%------------------------------------------------------------------------------
% File     : VBT00009^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem Hoare_Triple 00195_005707
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0025_Hoare_Triple_00195_005707 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 7875 (2346 unt; 987 typ;   0 def)
%            Number of atoms       : 21186 (7605 equ;   3 cnn)
%            Maximal formula atoms :   48 (   3 avg)
%            Number of connectives : 140514 (1664   ~; 193   |;1417   &;128103   @)
%                                         (   0 <=>;9137  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   38 (   7 avg)
%            Number of types       :   12 (  11 usr)
%            Number of type conns  : 7863 (7863   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  980 ( 976 usr;  15 con; 0-10 aty)
%            Number of variables   : 27671 (4895   ^21152   !; 495   ?;27671   :)
%                                         (1129  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 15:24:32.137
%------------------------------------------------------------------------------
% Could-be-implicit typings (24)
thf(ty_t_Heap__Time__Monad_OHeap,type,
    heap_Time_Heap: $tType > $tType ).

thf(ty_t_Code__Numeral_Onatural,type,
    code_natural: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Heap_Oheap_Oheap__ext,type,
    heap_ext: $tType > $tType ).

thf(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Old__Datatype_Onode,type,
    old_node: $tType > $tType > $tType ).

thf(ty_t_Multiset_Omultiset,type,
    multiset: $tType > $tType ).

thf(ty_t_Typerep_Otyperep,type,
    typerep: $tType ).

thf(ty_t_Assertions_Oassn,type,
    assn: $tType ).

thf(ty_t_Sum__Type_Osum,type,
    sum_sum: $tType > $tType > $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Heap_Oarray,type,
    array: $tType > $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Heap_Oref,type,
    ref: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

thf(ty_tf_a,type,
    a: $tType ).

% Explicit typings (963)
thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Heap_Oheap,type,
    heap: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Otimes,type,
    times: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Oinf,type,
    inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osup,type,
    sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Obot,type,
    bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Otop,type,
    top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable_Ocountable,type,
    countable: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__lattice,type,
    finite_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_OInf,type,
    complete_Inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_OSup,type,
    complete_Sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Partial__Order_Occpo,type,
    comple9053668089753744459l_ccpo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Onormalization__semidom,type,
    normal8620421768224518004emidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,
    bounded_lattice_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice__top,type,
    bounded_lattice_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide__unit__factor,type,
    semido2269285787275462019factor: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__boolean__algebra,type,
    comple489889107523837845lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Onormalization__semidom__multiplicative,type,
    normal6328177297339901930cative: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Array__Time_Oalloc,type,
    array_alloc: 
      !>[A: $tType] : ( ( list @ A ) > ( heap_ext @ product_unit ) > ( product_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) ) ) ).

thf(sy_c_Array__Time_Ofreeze,type,
    array_freeze: 
      !>[A: $tType] : ( ( array @ A ) > ( heap_Time_Heap @ ( list @ A ) ) ) ).

thf(sy_c_Array__Time_Oget,type,
    array_get: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( array @ A ) > ( list @ A ) ) ).

thf(sy_c_Array__Time_Olen,type,
    array_len: 
      !>[A: $tType] : ( ( array @ A ) > ( heap_Time_Heap @ nat ) ) ).

thf(sy_c_Array__Time_Olen_H,type,
    array_len2: 
      !>[B: $tType,A: $tType] : ( ( array @ B ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Array__Time_Olength,type,
    array_length: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( array @ A ) > nat ) ).

thf(sy_c_Array__Time_Omake,type,
    array_make: 
      !>[A: $tType] : ( nat > ( nat > A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Omap__entry,type,
    array_map_entry: 
      !>[A: $tType] : ( nat > ( A > A ) > ( array @ A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Onew,type,
    array_new: 
      !>[A: $tType] : ( nat > A > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Onth,type,
    array_nth: 
      !>[A: $tType] : ( ( array @ A ) > nat > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Array__Time_Oof__list,type,
    array_of_list: 
      !>[A: $tType] : ( ( list @ A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Oset,type,
    array_set: 
      !>[A: $tType] : ( ( array @ A ) > ( list @ A ) > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) ) ).

thf(sy_c_Array__Time_Oswap,type,
    array_swap: 
      !>[A: $tType] : ( nat > A > ( array @ A ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Array__Time_Oupd,type,
    array_upd: 
      !>[A: $tType] : ( nat > A > ( array @ A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Oupd_H,type,
    array_upd2: 
      !>[A: $tType] : ( ( array @ A ) > code_integer > A > ( heap_Time_Heap @ product_unit ) ) ).

thf(sy_c_Array__Time_Oupdate,type,
    array_update: 
      !>[A: $tType] : ( ( array @ A ) > nat > A > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) ) ).

thf(sy_c_Assertions_Oassn_OAbs__assn,type,
    abs_assn: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > assn ).

thf(sy_c_Assertions_Oassn_ORep__assn,type,
    rep_assn: assn > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oentails,type,
    entails: assn > assn > $o ).

thf(sy_c_Assertions_Oentailst,type,
    entailst: assn > assn > $o ).

thf(sy_c_Assertions_Oex__assn,type,
    ex_assn: 
      !>[A: $tType] : ( ( A > assn ) > assn ) ).

thf(sy_c_Assertions_Oin__range,type,
    in_range: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oin__range__rel,type,
    in_range_rel: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Ois__pure__assn,type,
    is_pure_assn: assn > $o ).

thf(sy_c_Assertions_Oone__assn__raw,type,
    one_assn_raw: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oone__assn__raw__rel,type,
    one_assn_raw_rel: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oprecise,type,
    precise: 
      !>[A: $tType,B: $tType] : ( ( A > B > assn ) > $o ) ).

thf(sy_c_Assertions_Oproper,type,
    proper: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > $o ).

thf(sy_c_Assertions_Opure__assn,type,
    pure_assn: $o > assn ).

thf(sy_c_Assertions_Opure__assn__raw,type,
    pure_assn_raw: 
      !>[A: $tType,B: $tType] : ( $o > ( product_prod @ A @ ( set @ B ) ) > $o ) ).

thf(sy_c_Assertions_Opure__assn__raw__rel,type,
    pure_assn_raw_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) > ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) > $o ) ).

thf(sy_c_Assertions_OrelH,type,
    relH: ( set @ nat ) > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) > $o ).

thf(sy_c_Assertions_Osnga__assn,type,
    snga_assn: 
      !>[A: $tType] : ( ( array @ A ) > ( list @ A ) > assn ) ).

thf(sy_c_Assertions_Osnga__assn__raw,type,
    snga_assn_raw: 
      !>[A: $tType] : ( ( array @ A ) > ( list @ A ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) ).

thf(sy_c_Assertions_Osnga__assn__raw__rel,type,
    snga_assn_raw_rel: 
      !>[A: $tType] : ( ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ) ).

thf(sy_c_Assertions_Osngr__assn,type,
    sngr_assn: 
      !>[A: $tType] : ( ( ref @ A ) > A > assn ) ).

thf(sy_c_Assertions_Osngr__assn__raw,type,
    sngr_assn_raw: 
      !>[A: $tType] : ( ( ref @ A ) > A > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) ).

thf(sy_c_Assertions_Osngr__assn__raw__rel,type,
    sngr_assn_raw_rel: 
      !>[A: $tType] : ( ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ) ).

thf(sy_c_Assertions_Otimes__assn__raw,type,
    times_assn_raw: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Otimes__assn__raw__rel,type,
    times_assn_raw_rel: ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ).

thf(sy_c_Assertions_Owand__assn,type,
    wand_assn: assn > assn > assn ).

thf(sy_c_Assertions_Owand__raw,type,
    wand_raw: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Owand__raw__rel,type,
    wand_raw_rel: ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ).

thf(sy_c_BNF__Cardinal__Arithmetic_OCsum,type,
    bNF_Cardinal_Csum: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Ocexp,type,
    bNF_Cardinal_cexp: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Ocinfinite,type,
    bNF_Ca4139267488887388095finite: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Ocone,type,
    bNF_Cardinal_cone: set @ ( product_prod @ product_unit @ product_unit ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Ocprod,type,
    bNF_Cardinal_cprod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Ocsum,type,
    bNF_Cardinal_csum: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Oczero,type,
    bNF_Cardinal_czero: 
      !>[A: $tType] : ( set @ ( product_prod @ A @ A ) ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OcardSuc,type,
    bNF_Ca8387033319878233205ardSuc: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_Ocard__of,type,
    bNF_Ca6860139660246222851ard_of: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_Ocard__order__on,type,
    bNF_Ca8970107618336181345der_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OisCardSuc,type,
    bNF_Ca6246979054910435723ardSuc: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) > $o ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OnatLeq,type,
    bNF_Ca8665028551170535155natLeq: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OnatLess,type,
    bNF_Ca8459412986667044542atLess: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OregularCard,type,
    bNF_Ca7133664381575040944arCard: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OrelChain,type,
    bNF_Ca3754400796208372196lChain: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( A > B ) > $o ) ).

thf(sy_c_BNF__Composition_Oid__bnf,type,
    bNF_id_bnf: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Def_OGrp,type,
    bNF_Grp: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > A > B > $o ) ).

thf(sy_c_BNF__Def_Ocollect,type,
    bNF_collect: 
      !>[B: $tType,A: $tType] : ( ( set @ ( B > ( set @ A ) ) ) > B > ( set @ A ) ) ).

thf(sy_c_BNF__Def_Oeq__onp,type,
    bNF_eq_onp: 
      !>[A: $tType] : ( ( A > $o ) > A > A > $o ) ).

thf(sy_c_BNF__Def_Opick__middlep,type,
    bNF_pick_middlep: 
      !>[B: $tType,A: $tType,C: $tType] : ( ( B > A > $o ) > ( A > C > $o ) > B > C > A ) ).

thf(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) ).

thf(sy_c_BNF__Def_Orel__set,type,
    bNF_rel_set: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_BNF__Def_Ovimage2p,type,
    bNF_vimage2p: 
      !>[A: $tType,D: $tType,B: $tType,E: $tType,C: $tType] : ( ( A > D ) > ( B > E ) > ( D > E > C ) > A > B > C ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OShift,type,
    bNF_Greatest_Shift: 
      !>[A: $tType] : ( ( set @ ( list @ A ) ) > A > ( set @ ( list @ A ) ) ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OSucc,type,
    bNF_Greatest_Succ: 
      !>[A: $tType] : ( ( set @ ( list @ A ) ) > ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OfromCard,type,
    bNF_Gr5436034075474128252omCard: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ B @ B ) ) > B > A ) ).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2p,type,
    bNF_Greatest_image2p: 
      !>[C: $tType,A: $tType,D: $tType,B: $tType] : ( ( C > A ) > ( D > B ) > ( C > D > $o ) > A > B > $o ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OrelImage,type,
    bNF_Gr4221423524335903396lImage: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ B ) ) > ( B > A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OrelInvImage,type,
    bNF_Gr7122648621184425601vImage: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OtoCard,type,
    bNF_Greatest_toCard: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ B @ B ) ) > A > B ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OtoCard__pred,type,
    bNF_Gr1419584066657907630d_pred: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > $o ) ).

thf(sy_c_BNF__Greatest__Fixpoint_Ouniv,type,
    bNF_Greatest_univ: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( A > B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set @ B ) > ( C > A ) > ( B > D ) > ( D > C ) > B > A ) ).

thf(sy_c_BNF__Wellorder__Constructions_Obsqr,type,
    bNF_Wellorder_bsqr: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_Ocurr,type,
    bNF_Wellorder_curr: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ A ) > ( ( product_prod @ A @ B ) > C ) > A > B > C ) ).

thf(sy_c_BNF__Wellorder__Constructions_Odir__image,type,
    bNF_We2720479622203943262_image: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( A > A2 ) > ( set @ ( product_prod @ A2 @ A2 ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OofilterIncl,type,
    bNF_We413866401316099525erIncl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OordIso,type,
    bNF_Wellorder_ordIso: 
      !>[A: $tType,A2: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OordLeq,type,
    bNF_Wellorder_ordLeq: 
      !>[A: $tType,A2: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OordLess,type,
    bNF_We4044943003108391690rdLess: 
      !>[A: $tType,A2: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_Oord__to__filter,type,
    bNF_We8469521843155493636filter: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) ) ).

thf(sy_c_BNF__Wellorder__Embedding_Ocompat,type,
    bNF_Wellorder_compat: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A2 @ A2 ) ) > ( A > A2 ) > $o ) ).

thf(sy_c_BNF__Wellorder__Embedding_Oembed,type,
    bNF_Wellorder_embed: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A2 @ A2 ) ) > ( A > A2 ) > $o ) ).

thf(sy_c_BNF__Wellorder__Embedding_OembedS,type,
    bNF_Wellorder_embedS: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A2 @ A2 ) ) > ( A > A2 ) > $o ) ).

thf(sy_c_BNF__Wellorder__Embedding_Oiso,type,
    bNF_Wellorder_iso: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A2 @ A2 ) ) > ( A > A2 ) > $o ) ).

thf(sy_c_BNF__Wellorder__Relation_Owo__rel,type,
    bNF_Wellorder_wo_rel: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_BNF__Wellorder__Relation_Owo__rel_OisMinim,type,
    bNF_We4791949203932849705sMinim: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > A > $o ) ).

thf(sy_c_BNF__Wellorder__Relation_Owo__rel_Omax2,type,
    bNF_We1388413361240627857o_max2: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > A > A ) ).

thf(sy_c_BNF__Wellorder__Relation_Owo__rel_Ominim,type,
    bNF_We6954850376910717587_minim: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > A ) ).

thf(sy_c_BNF__Wellorder__Relation_Owo__rel_Osuc,type,
    bNF_Wellorder_wo_suc: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > A ) ).

thf(sy_c_Basic__BNFs_Ofsts,type,
    basic_fsts: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > ( set @ A ) ) ).

thf(sy_c_Basic__BNFs_Ofstsp,type,
    basic_fstsp: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A > $o ) ).

thf(sy_c_Basic__BNFs_Opred__fun,type,
    basic_pred_fun: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( B > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Basic__BNFs_Opred__prod,type,
    basic_pred_prod: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( B > $o ) > ( product_prod @ A @ B ) > $o ) ).

thf(sy_c_Basic__BNFs_Orel__prod,type,
    basic_rel_prod: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( A > B > $o ) > ( C > D > $o ) > ( product_prod @ A @ C ) > ( product_prod @ B @ D ) > $o ) ).

thf(sy_c_Basic__BNFs_Osetl,type,
    basic_setl: 
      !>[A: $tType,B: $tType] : ( ( sum_sum @ A @ B ) > ( set @ A ) ) ).

thf(sy_c_Basic__BNFs_Osetlp,type,
    basic_setlp: 
      !>[A: $tType,B: $tType] : ( ( sum_sum @ A @ B ) > A > $o ) ).

thf(sy_c_Basic__BNFs_Osetr,type,
    basic_setr: 
      !>[A: $tType,B: $tType] : ( ( sum_sum @ A @ B ) > ( set @ B ) ) ).

thf(sy_c_Basic__BNFs_Osetrp,type,
    basic_setrp: 
      !>[A: $tType,B: $tType] : ( ( sum_sum @ A @ B ) > B > $o ) ).

thf(sy_c_Basic__BNFs_Osnds,type,
    basic_snds: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > ( set @ B ) ) ).

thf(sy_c_Basic__BNFs_Osndsp,type,
    basic_sndsp: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B > $o ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself @ A ) > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__axioms,type,
    boolea6902313364301356556axioms: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff__axioms,type,
    boolea5476839437570043046axioms: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Ocr__integer,type,
    code_cr_integer: int > code_integer > $o ).

thf(sy_c_Code__Numeral_Ocr__natural,type,
    code_cr_natural: nat > code_natural > $o ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odup,type,
    code_dup: code_integer > code_integer ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onatural_Ocase__natural,type,
    code_case_natural: 
      !>[T: $tType] : ( T > ( code_natural > T ) > code_natural > T ) ).

thf(sy_c_Code__Numeral_Onatural_Onat__of__natural,type,
    code_nat_of_natural: code_natural > nat ).

thf(sy_c_Code__Numeral_Onatural_Onatural__of__nat,type,
    code_natural_of_nat: nat > code_natural ).

thf(sy_c_Code__Numeral_Onatural_Orec__natural,type,
    code_rec_natural: 
      !>[T: $tType] : ( T > ( code_natural > T > T ) > code_natural > T ) ).

thf(sy_c_Code__Numeral_Onatural_Orec__set__natural,type,
    code_rec_set_natural: 
      !>[T: $tType] : ( T > ( code_natural > T > T ) > code_natural > T > $o ) ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Numeral_Opcr__integer,type,
    code_pcr_integer: int > code_integer > $o ).

thf(sy_c_Code__Numeral_Osub,type,
    code_sub: num > num > code_integer ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Partial__Order_Occpo_Oadmissible,type,
    comple1908693960933563346ssible: 
      !>[A: $tType] : ( ( ( set @ A ) > A ) > ( A > A > $o ) > ( A > $o ) > $o ) ).

thf(sy_c_Complete__Partial__Order_Occpo_Ofixp,type,
    comple187402453842119260l_fixp: 
      !>[A: $tType] : ( ( ( set @ A ) > A ) > ( A > A > $o ) > ( A > A ) > A ) ).

thf(sy_c_Complete__Partial__Order_Occpo__class_Ofixp,type,
    comple115746919287870866o_fixp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Complete__Partial__Order_Occpo__class_Oiterates,type,
    comple6359979572994053840erates: 
      !>[A: $tType] : ( ( A > A ) > ( set @ A ) ) ).

thf(sy_c_Complete__Partial__Order_Occpo__class_Oiteratesp,type,
    comple7512665784863727008ratesp: 
      !>[A: $tType] : ( ( A > A ) > A > $o ) ).

thf(sy_c_Complete__Partial__Order_Ochain,type,
    comple1602240252501008431_chain: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Complete__Partial__Order_Omonotone,type,
    comple7038119648293358887notone: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > B > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__above,type,
    condit8047198070973881523_above: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__below,type,
    condit8119078960628432327_below: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreordering__bdd,type,
    condit622319405099724424ng_bdd: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreordering__bdd_Obdd,type,
    condit16957441358409770ng_bdd: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Countable_Onat__to__rat__surj,type,
    nat_to_rat_surj: nat > rat ).

thf(sy_c_Countable_Oto__nat,type,
    to_nat: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Equiv__Relations_Ocongruent,type,
    equiv_congruent: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( A > B ) > $o ) ).

thf(sy_c_Equiv__Relations_Ocongruent2,type,
    equiv_congruent2: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( A > B > C ) > $o ) ).

thf(sy_c_Equiv__Relations_Oequiv,type,
    equiv_equiv: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Equiv__Relations_Oequivp,type,
    equiv_equivp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Equiv__Relations_Opart__equivp,type,
    equiv_part_equivp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Equiv__Relations_Oproj,type,
    equiv_proj: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ A ) ) > B > ( set @ A ) ) ).

thf(sy_c_Equiv__Relations_Oquotient,type,
    equiv_quotient: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Ocofinite,type,
    cofinite: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofilter_OAbs__filter,type,
    abs_filter: 
      !>[A: $tType] : ( ( ( A > $o ) > $o ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Ofilter_ORep__filter,type,
    rep_filter: 
      !>[A: $tType] : ( ( filter @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Ofinite__subsets__at__top,type,
    finite5375528669736107172at_top: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ ( set @ A ) ) ) ).

thf(sy_c_Filter_Ofrequently,type,
    frequently: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ois__filter,type,
    is_filter: 
      !>[A: $tType] : ( ( ( A > $o ) > $o ) > $o ) ).

thf(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( filter @ B ) > ( filter @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Filter_Orel__filter,type,
    rel_filter: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( filter @ A ) > ( filter @ B ) > $o ) ).

thf(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite2: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Finite__Set_Ofold__graph,type,
    finite_fold_graph: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B > $o ) ).

thf(sy_c_Finite__Set_Ofolding,type,
    finite_folding: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Ofcomp,type,
    fcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B ) > ( B > C ) > A > C ) ).

thf(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > B > A > B ) ).

thf(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ooverride__on,type,
    override_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( set @ A ) > A > B ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_Fun__Def_OTHE__default,type,
    fun_THE_default: 
      !>[A: $tType] : ( A > ( A > $o ) > A ) ).

thf(sy_c_Fun__Def_Orp__inv__image,type,
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_OGcd__class_OLcm,type,
    gcd_Lcm: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obounded__quasi__semilattice,type,
    bounde8507323023520639062attice: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( A > A ) > $o ) ).

thf(sy_c_GCD_Obounded__quasi__semilattice__set,type,
    bounde6485984586167503788ce_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( A > A ) > $o ) ).

thf(sy_c_GCD_Obounded__quasi__semilattice__set_OF,type,
    bounde2362111253966948842tice_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( set @ A ) > A ) ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__class_Olcm,type,
    gcd_lcm: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( ( itself @ A ) > nat ) ).

thf(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Osemiring__gcd__class_OLcm__fin,type,
    semiring_gcd_Lcm_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Groups_Oabel__semigroup,type,
    abel_semigroup: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Groups_Oabel__semigroup__axioms,type,
    abel_s757365448890700780axioms: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ocomm__monoid,type,
    comm_monoid: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Ocomm__monoid__axioms,type,
    comm_monoid_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Ogroup,type,
    group: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A ) > $o ) ).

thf(sy_c_Groups_Ogroup__axioms,type,
    group_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A ) > $o ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Omonoid,type,
    monoid: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Omonoid__axioms,type,
    monoid_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osemigroup,type,
    semigroup: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add_Osum,type,
    groups3894954378712506084id_sum: 
      !>[A: $tType,B: $tType] : ( ( A > A > A ) > A > ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__set,type,
    groups778175481326437816id_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__set_OF,type,
    groups_comm_monoid_F: 
      !>[A: $tType,B: $tType] : ( ( A > A > A ) > A > ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__set_OG,type,
    groups_comm_monoid_G: 
      !>[A: $tType,B: $tType] : ( ( A > A > A ) > A > ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__List_Ocomm__monoid__list,type,
    groups1828464146339083142d_list: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__List_Ocomm__monoid__list__set,type,
    groups4802862169904069756st_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_Groups__List_Omonoid__list,type,
    groups_monoid_list: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__List_Omonoid__list_OF,type,
    groups_monoid_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( list @ A ) > A ) ).

thf(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_OEx1,type,
    ex1: 
      !>[A: $tType] : ( ( A > $o ) > $o ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_HOL_OUniq,type,
    uniq: 
      !>[A: $tType] : ( ( A > $o ) > $o ) ).

thf(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

thf(sy_c_Heap_Oaddr__of__array,type,
    addr_of_array: 
      !>[A: $tType] : ( ( array @ A ) > nat ) ).

thf(sy_c_Heap_Oaddr__of__ref,type,
    addr_of_ref: 
      !>[A: $tType] : ( ( ref @ A ) > nat ) ).

thf(sy_c_Heap_Oarray_OArray,type,
    array2: 
      !>[A: $tType] : ( nat > ( array @ A ) ) ).

thf(sy_c_Heap_Oarray_Omap__array,type,
    map_array: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( array @ A ) > ( array @ Aa ) ) ).

thf(sy_c_Heap_Oarray_Opred__array,type,
    pred_array: 
      !>[A: $tType] : ( ( A > $o ) > ( array @ A ) > $o ) ).

thf(sy_c_Heap_Oarray_Orec__array,type,
    rec_array: 
      !>[C: $tType,A: $tType] : ( ( nat > C ) > ( array @ A ) > C ) ).

thf(sy_c_Heap_Oarray_Orel__array,type,
    rel_array: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( array @ A ) > ( array @ B ) > $o ) ).

thf(sy_c_Heap_Oarray_Oset__array,type,
    set_array: 
      !>[A: $tType] : ( ( array @ A ) > ( set @ A ) ) ).

thf(sy_c_Heap_Oempty,type,
    empty: heap_ext @ product_unit ).

thf(sy_c_Heap_Oheap_Oarrays,type,
    arrays: 
      !>[Z: $tType] : ( ( heap_ext @ Z ) > typerep > nat > ( list @ nat ) ) ).

thf(sy_c_Heap_Oheap_Oarrays__update,type,
    arrays_update: 
      !>[Z: $tType] : ( ( ( typerep > nat > ( list @ nat ) ) > typerep > nat > ( list @ nat ) ) > ( heap_ext @ Z ) > ( heap_ext @ Z ) ) ).

thf(sy_c_Heap_Oheap_Oheap__ext,type,
    heap_ext2: 
      !>[Z: $tType] : ( ( typerep > nat > ( list @ nat ) ) > ( typerep > nat > nat ) > nat > Z > ( heap_ext @ Z ) ) ).

thf(sy_c_Heap_Oheap_Olim,type,
    lim: 
      !>[Z: $tType] : ( ( heap_ext @ Z ) > nat ) ).

thf(sy_c_Heap_Oheap_Olim__update,type,
    lim_update: 
      !>[Z: $tType] : ( ( nat > nat ) > ( heap_ext @ Z ) > ( heap_ext @ Z ) ) ).

thf(sy_c_Heap_Oheap_Orefs,type,
    refs: 
      !>[Z: $tType] : ( ( heap_ext @ Z ) > typerep > nat > nat ) ).

thf(sy_c_Heap_Oheap_Orefs__update,type,
    refs_update: 
      !>[Z: $tType] : ( ( ( typerep > nat > nat ) > typerep > nat > nat ) > ( heap_ext @ Z ) > ( heap_ext @ Z ) ) ).

thf(sy_c_Heap_Oref_ORef,type,
    ref2: 
      !>[A: $tType] : ( nat > ( ref @ A ) ) ).

thf(sy_c_Heap_Oref_Omap__ref,type,
    map_ref: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( ref @ A ) > ( ref @ Aa ) ) ).

thf(sy_c_Heap_Oref_Opred__ref,type,
    pred_ref: 
      !>[A: $tType] : ( ( A > $o ) > ( ref @ A ) > $o ) ).

thf(sy_c_Heap_Oref_Orec__ref,type,
    rec_ref: 
      !>[C: $tType,A: $tType] : ( ( nat > C ) > ( ref @ A ) > C ) ).

thf(sy_c_Heap_Oref_Orel__ref,type,
    rel_ref: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( ref @ A ) > ( ref @ B ) > $o ) ).

thf(sy_c_Heap_Oref_Oset__ref,type,
    set_ref: 
      !>[A: $tType] : ( ( ref @ A ) > ( set @ A ) ) ).

thf(sy_c_Heap__Time__Monad_OHeap_OHeap,type,
    heap_Time_Heap2: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Omap__Heap,type,
    heap_Time_map_Heap: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( heap_Time_Heap @ A ) > ( heap_Time_Heap @ Aa ) ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Opred__Heap,type,
    heap_Time_pred_Heap: 
      !>[A: $tType] : ( ( A > $o ) > ( heap_Time_Heap @ A ) > $o ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Orec__Heap,type,
    heap_Time_rec_Heap: 
      !>[A: $tType,C: $tType] : ( ( ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > C ) > ( heap_Time_Heap @ A ) > C ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Orel__Heap,type,
    heap_Time_rel_Heap: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( heap_Time_Heap @ A ) > ( heap_Time_Heap @ B ) > $o ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Oset__Heap,type,
    heap_Time_set_Heap: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( set @ A ) ) ).

thf(sy_c_Heap__Time__Monad_OHeap__lub,type,
    heap_Time_Heap_lub: 
      !>[A: $tType] : ( ( set @ ( heap_Time_Heap @ A ) ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_OHeap__ord,type,
    heap_Time_Heap_ord: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( heap_Time_Heap @ A ) > $o ) ).

thf(sy_c_Heap__Time__Monad_Obind,type,
    heap_Time_bind: 
      !>[A: $tType,B: $tType] : ( ( heap_Time_Heap @ A ) > ( A > ( heap_Time_Heap @ B ) ) > ( heap_Time_Heap @ B ) ) ).

thf(sy_c_Heap__Time__Monad_Oeffect,type,
    heap_Time_effect: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) > A > nat > $o ) ).

thf(sy_c_Heap__Time__Monad_Oexecute,type,
    heap_Time_execute: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ).

thf(sy_c_Heap__Time__Monad_Oguard,type,
    heap_Time_guard: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > $o ) > ( ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Oheap,type,
    heap_Time_heap: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Olift,type,
    heap_Time_lift: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > ( heap_Time_Heap @ B ) ) ).

thf(sy_c_Heap__Time__Monad_Oraise,type,
    heap_Time_raise: 
      !>[A: $tType] : ( ( list @ char ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Oreturn,type,
    heap_Time_return: 
      !>[A: $tType] : ( A > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Osuccess,type,
    heap_Time_success: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( heap_ext @ product_unit ) > $o ) ).

thf(sy_c_Heap__Time__Monad_Otap,type,
    heap_Time_tap: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > A ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_OtimeFrame,type,
    heap_Time_timeFrame: 
      !>[A: $tType] : ( nat > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ).

thf(sy_c_Heap__Time__Monad_Oureturn,type,
    heap_Time_ureturn: 
      !>[A: $tType] : ( A > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Owait,type,
    heap_Time_wait: nat > ( heap_Time_Heap @ product_unit ) ).

thf(sy_c_Hilbert__Choice_Oinv__into,type,
    hilbert_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_Hoare__Triple_Ohoare__triple,type,
    hoare_hoare_triple: 
      !>[A: $tType] : ( assn > ( heap_Time_Heap @ A ) > ( A > assn ) > $o ) ).

thf(sy_c_Hoare__Triple_Onew__addrs,type,
    hoare_new_addrs: ( heap_ext @ product_unit ) > ( set @ nat ) > ( heap_ext @ product_unit ) > ( set @ nat ) ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Inductive_Ocomplete__lattice__class_Ogfp,type,
    complete_lattice_gfp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Inductive_Ocomplete__lattice__class_Olfp,type,
    complete_lattice_lfp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set @ A ) > nat > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Ocr__int,type,
    cr_int: ( product_prod @ nat @ nat ) > int > $o ).

thf(sy_c_Int_Oint_OAbs__int,type,
    abs_int: ( set @ ( product_prod @ nat @ nat ) ) > int ).

thf(sy_c_Int_Oint_ORep__int,type,
    rep_int: int > ( set @ ( product_prod @ nat @ nat ) ) ).

thf(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Ointrel,type,
    intrel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opcr__int,type,
    pcr_int: ( product_prod @ nat @ nat ) > int > $o ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice,type,
    semilattice: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__axioms,type,
    semilattice_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__neutr,type,
    semilattice_neutr: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__order,type,
    semilattice_order: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__order__axioms,type,
    semila6385135966242565138axioms: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMax,type,
    lattices_Max: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Oord_Oarg__max,type,
    lattices_arg_max: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( B > $o ) > B ) ).

thf(sy_c_Lattices__Big_Oord_Oarg__max__on,type,
    lattices_arg_max_on: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Oord_Oarg__min,type,
    lattices_arg_min: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( B > $o ) > B ) ).

thf(sy_c_Lattices__Big_Oord_Oarg__min__on,type,
    lattices_arg_min_on: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Oord_Ois__arg__max,type,
    lattices_is_arg_max: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( B > $o ) > B > $o ) ).

thf(sy_c_Lattices__Big_Oord_Ois__arg__min,type,
    lattices_is_arg_min: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( B > $o ) > B > $o ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min,type,
    lattices_ord_arg_min: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Ois__arg__min,type,
    lattic501386751177426532rg_min: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf_OInf__fin,type,
    lattic8678736583308907530nf_fin: 
      !>[A: $tType] : ( ( A > A > A ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__neutr__set,type,
    lattic5652469242046573047tr_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__neutr__set_OF,type,
    lattic5214292709420241887eutr_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__order__set,type,
    lattic4895041142388067077er_set: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__set,type,
    lattic149705377957585745ce_set: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__set_OF,type,
    lattic1715443433743089157tice_F: 
      !>[A: $tType] : ( ( A > A > A ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup_OSup__fin,type,
    lattic4630905495605216202up_fin: 
      !>[A: $tType] : ( ( A > A > A ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lifting_OQuotient,type,
    quotient: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > B ) > ( B > A ) > ( A > B > $o ) > $o ) ).

thf(sy_c_Lifting_Orel__pred__comp,type,
    rel_pred_comp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( B > $o ) > A > $o ) ).

thf(sy_c_List_OBleast,type,
    bleast: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > A ) ).

thf(sy_c_List_Oabort__Bleast,type,
    abort_Bleast: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > A ) ).

thf(sy_c_List_Oarg__min__list__rel,type,
    arg_min_list_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B ) @ ( list @ A ) ) > ( product_prod @ ( A > B ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) ).

thf(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldl,type,
    foldl: 
      !>[B: $tType,A: $tType] : ( ( B > A > B ) > B > ( list @ A ) > B ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Olast,type,
    last: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > nat > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__insert__key,type,
    linord329482645794927042rt_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osort__key,type,
    linorder_sort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olinorder__class_Ostable__sort__key,type,
    linord3483353639454293061rt_key: 
      !>[B: $tType,A: $tType] : ( ( ( B > A ) > ( list @ B ) > ( list @ B ) ) > $o ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Orec__list,type,
    rec_list: 
      !>[C: $tType,A: $tType] : ( C > ( A > ( list @ A ) > C > C ) > ( list @ A ) > C ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olists,type,
    lists: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( ( list @ ( set @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omap__project,type,
    map_project: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_List_Omeasures,type,
    measures: 
      !>[A: $tType] : ( ( list @ ( A > nat ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_List_Omin__list,type,
    min_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Omin__list__rel,type,
    min_list_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Oord_Olexordp,type,
    lexordp2: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oord__class_Olexordp,type,
    ord_lexordp: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Osuccessively,type,
    successively: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Othose,type,
    those: 
      !>[A: $tType] : ( ( list @ ( option @ A ) ) > ( option @ ( list @ A ) ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Odom,type,
    dom: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) ) ).

thf(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Omap__add,type,
    map_add: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( A > ( option @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Omap__comp,type,
    map_comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > ( option @ C ) ) > ( A > ( option @ B ) ) > A > ( option @ C ) ) ).

thf(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) > A > ( option @ B ) ) ).

thf(sy_c_Misc_OEps__Opt,type,
    eps_Opt: 
      !>[A: $tType] : ( ( A > $o ) > ( option @ A ) ) ).

thf(sy_c_Misc_Obijective,type,
    bijective: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > $o ) ).

thf(sy_c_Misc_Obrk__rel,type,
    brk_rel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) ) ) ) ).

thf(sy_c_Misc_Odflt__None__set,type,
    dflt_None_set: 
      !>[A: $tType] : ( ( set @ A ) > ( option @ ( set @ A ) ) ) ).

thf(sy_c_Misc_Ofun__of__rel,type,
    fun_of_rel: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ A ) ) > B > A ) ).

thf(sy_c_Misc_Oinv__on,type,
    inv_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > B > A ) ).

thf(sy_c_Misc_Olist__all__zip,type,
    list_all_zip: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_Misc_Olist__collect__set,type,
    list_collect_set: 
      !>[B: $tType,A: $tType] : ( ( B > ( set @ A ) ) > ( list @ B ) > ( set @ A ) ) ).

thf(sy_c_Misc_Omap__mmupd,type,
    map_mmupd: 
      !>[B: $tType,A: $tType] : ( ( B > ( option @ A ) ) > ( set @ B ) > A > B > ( option @ A ) ) ).

thf(sy_c_Misc_Omap__to__set,type,
    map_to_set: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Misc_Omerge__list,type,
    merge_list: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_Misc_Omergesort,type,
    mergesort: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Omergesort__by__rel,type,
    mergesort_by_rel: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Omergesort__by__rel__merge,type,
    merges9089515139780605204_merge: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Omergesort__by__rel__split,type,
    merges295452479951948502_split: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_Misc_Omergesort__remdups,type,
    mergesort_remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Opairself,type,
    pairself: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( product_prod @ A @ A ) > ( product_prod @ B @ B ) ) ).

thf(sy_c_Misc_Opartition__rev,type,
    partition_rev: 
      !>[A: $tType] : ( ( A > $o ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_Misc_Oquicksort__by__rel,type,
    quicksort_by_rel: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Oquicksort__by__rel__rel,type,
    quicksort_by_rel_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) > ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) > $o ) ).

thf(sy_c_Misc_Orel__of,type,
    rel_of: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( ( product_prod @ A @ B ) > $o ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Misc_Orel__restrict,type,
    rel_restrict: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Misc_Oremove__rev,type,
    remove_rev: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Oset__to__map,type,
    set_to_map: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ A ) ) > B > ( option @ A ) ) ).

thf(sy_c_Misc_Oslice,type,
    slice: 
      !>[A: $tType] : ( nat > nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Osu__rel__fun,type,
    su_rel_fun: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( A > B ) > $o ) ).

thf(sy_c_Misc_Othe__default,type,
    the_default: 
      !>[A: $tType] : ( A > ( option @ A ) > A ) ).

thf(sy_c_Misc_Ouncurry,type,
    uncurry: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Multiset_Oadd__mset,type,
    add_mset: 
      !>[A: $tType] : ( A > ( multiset @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Ocomm__monoid__add__class_Osum__mset,type,
    comm_m7189776963980413722m_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > A ) ).

thf(sy_c_Multiset_Ocomm__monoid__mset,type,
    comm_monoid_mset: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Multiset_Ocomm__monoid__mset_OF,type,
    comm_monoid_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( multiset @ A ) > A ) ).

thf(sy_c_Multiset_Ocomm__monoid__mult__class_Oprod__mset,type,
    comm_m9189036328036947845d_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > A ) ).

thf(sy_c_Multiset_Ocr__multiset,type,
    cr_multiset: 
      !>[A: $tType] : ( ( A > nat ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Ofilter__mset,type,
    filter_mset: 
      !>[A: $tType] : ( ( A > $o ) > ( multiset @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Ofold__mset,type,
    fold_mset: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( multiset @ A ) > B ) ).

thf(sy_c_Multiset_Oimage__mset,type,
    image_mset: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( multiset @ A ) > ( multiset @ B ) ) ).

thf(sy_c_Multiset_Ointer__mset,type,
    inter_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( multiset @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Olinorder__class_Opart,type,
    linorder_part: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > ( product_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) ) ) ).

thf(sy_c_Multiset_Olinorder__class_Osorted__list__of__multiset,type,
    linord6283353356039996273ltiset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( list @ A ) ) ).

thf(sy_c_Multiset_Omset,type,
    mset: 
      !>[A: $tType] : ( ( list @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Omset__set,type,
    mset_set: 
      !>[B: $tType] : ( ( set @ B ) > ( multiset @ B ) ) ).

thf(sy_c_Multiset_Omult,type,
    mult: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) ) ) ).

thf(sy_c_Multiset_Omult1,type,
    mult1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) ) ) ).

thf(sy_c_Multiset_Omulteqp__code,type,
    multeqp_code: 
      !>[A: $tType] : ( ( A > A > $o ) > ( multiset @ A ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Omultiset_OAbs__multiset,type,
    abs_multiset: 
      !>[A: $tType] : ( ( A > nat ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Omultiset_Ocount,type,
    count: 
      !>[A: $tType] : ( ( multiset @ A ) > A > nat ) ).

thf(sy_c_Multiset_Omultp,type,
    multp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( multiset @ A ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Omultp__code,type,
    multp_code: 
      !>[A: $tType] : ( ( A > A > $o ) > ( multiset @ A ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Opcr__multiset,type,
    pcr_multiset: 
      !>[C: $tType,B: $tType] : ( ( C > B > $o ) > ( C > nat ) > ( multiset @ B ) > $o ) ).

thf(sy_c_Multiset_Orel__mset,type,
    rel_mset: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( multiset @ A ) > ( multiset @ B ) > $o ) ).

thf(sy_c_Multiset_Orepeat__mset,type,
    repeat_mset: 
      !>[A: $tType] : ( nat > ( multiset @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Oreplicate__mset,type,
    replicate_mset: 
      !>[A: $tType] : ( nat > A > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Oset__mset,type,
    set_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( set @ A ) ) ).

thf(sy_c_Multiset_Osize__multiset,type,
    size_multiset: 
      !>[A: $tType] : ( ( A > nat ) > ( multiset @ A ) > nat ) ).

thf(sy_c_Multiset_Osubset__eq__mset__impl,type,
    subset_eq_mset_impl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( option @ $o ) ) ).

thf(sy_c_Multiset_Osubset__eq__mset__impl__rel,type,
    subset751672762298770561pl_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_Multiset_Osubset__mset,type,
    subset_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Osubseteq__mset,type,
    subseteq_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Ounion__mset,type,
    union_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( multiset @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Owcount,type,
    wcount: 
      !>[A: $tType] : ( ( A > nat ) > ( multiset @ A ) > A > nat ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Oint__decode,type,
    nat_int_decode: nat > int ).

thf(sy_c_Nat__Bijection_Olist__decode,type,
    nat_list_decode: nat > ( list @ nat ) ).

thf(sy_c_Nat__Bijection_Olist__decode__rel,type,
    nat_list_decode_rel: nat > nat > $o ).

thf(sy_c_Nat__Bijection_Oprod__decode,type,
    nat_prod_decode: nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: ( product_prod @ nat @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Osum__decode,type,
    nat_sum_decode: nat > ( sum_sum @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Osum__encode,type,
    nat_sum_encode: ( sum_sum @ nat @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Onat__of__num,type,
    nat_of_num: num > nat ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Ois__num,type,
    neg_numeral_is_num: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( A > ( num > A ) > ( num > A ) > num > A ) ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Old__Datatype_OAtom,type,
    old_Atom: 
      !>[A: $tType,B: $tType] : ( ( sum_sum @ A @ nat ) > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_OCase,type,
    old_Case: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( ( set @ ( old_node @ A @ B ) ) > C ) > ( ( set @ ( old_node @ A @ B ) ) > C ) > ( set @ ( old_node @ A @ B ) ) > C ) ).

thf(sy_c_Old__Datatype_OIn0,type,
    old_In0: 
      !>[A: $tType,B: $tType] : ( ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_OIn1,type,
    old_In1: 
      !>[A: $tType,B: $tType] : ( ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_OLim,type,
    old_Lim: 
      !>[B: $tType,A: $tType] : ( ( B > ( set @ ( old_node @ A @ B ) ) ) > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_ONode,type,
    old_Node: 
      !>[B: $tType,A: $tType] : ( set @ ( product_prod @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat ) ) ) ).

thf(sy_c_Old__Datatype_OPush,type,
    old_Push: 
      !>[B: $tType] : ( ( sum_sum @ B @ nat ) > ( nat > ( sum_sum @ B @ nat ) ) > nat > ( sum_sum @ B @ nat ) ) ).

thf(sy_c_Old__Datatype_OPush__Node,type,
    old_Push_Node: 
      !>[B: $tType,A: $tType] : ( ( sum_sum @ B @ nat ) > ( old_node @ A @ B ) > ( old_node @ A @ B ) ) ).

thf(sy_c_Old__Datatype_OScons,type,
    old_Scons: 
      !>[A: $tType,B: $tType] : ( ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_OSplit,type,
    old_Split: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) > C ) > ( set @ ( old_node @ A @ B ) ) > C ) ).

thf(sy_c_Old__Datatype_Odprod,type,
    old_dprod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) > ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) > ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) ) ).

thf(sy_c_Old__Datatype_Odsum,type,
    old_dsum: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) > ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) > ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) ) ).

thf(sy_c_Old__Datatype_Ondepth,type,
    old_ndepth: 
      !>[A: $tType,B: $tType] : ( ( old_node @ A @ B ) > nat ) ).

thf(sy_c_Old__Datatype_Onode_OAbs__Node,type,
    old_Abs_Node: 
      !>[B: $tType,A: $tType] : ( ( product_prod @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat ) ) > ( old_node @ A @ B ) ) ).

thf(sy_c_Old__Datatype_Onode_ORep__Node,type,
    old_Rep_Node: 
      !>[A: $tType,B: $tType] : ( ( old_node @ A @ B ) > ( product_prod @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat ) ) ) ).

thf(sy_c_Old__Datatype_Ontrunc,type,
    old_ntrunc: 
      !>[A: $tType,B: $tType] : ( nat > ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_Ouprod,type,
    old_uprod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( set @ ( old_node @ A @ B ) ) ) > ( set @ ( set @ ( old_node @ A @ B ) ) ) > ( set @ ( set @ ( old_node @ A @ B ) ) ) ) ).

thf(sy_c_Old__Datatype_Ousum,type,
    old_usum: 
      !>[A: $tType,B: $tType] : ( ( set @ ( set @ ( old_node @ A @ B ) ) ) > ( set @ ( set @ ( old_node @ A @ B ) ) ) > ( set @ ( set @ ( old_node @ A @ B ) ) ) ) ).

thf(sy_c_Option_Obind,type,
    bind2: 
      !>[A: $tType,B: $tType] : ( ( option @ A ) > ( A > ( option @ B ) ) > ( option @ B ) ) ).

thf(sy_c_Option_Ocombine__options,type,
    combine_options: 
      !>[A: $tType] : ( ( A > A > A ) > ( option @ A ) > ( option @ A ) > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) ).

thf(sy_c_Option_Ooption_Opred__option,type,
    pred_option: 
      !>[A: $tType] : ( ( A > $o ) > ( option @ A ) > $o ) ).

thf(sy_c_Option_Ooption_Orec__option,type,
    rec_option: 
      !>[C: $tType,A: $tType] : ( C > ( A > C ) > ( option @ A ) > C ) ).

thf(sy_c_Option_Ooption_Orel__option,type,
    rel_option: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( option @ A ) > ( option @ B ) > $o ) ).

thf(sy_c_Option_Ooption_Oset__option,type,
    set_option: 
      !>[A: $tType] : ( ( option @ A ) > ( set @ A ) ) ).

thf(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : ( ( option @ A ) > A ) ).

thf(sy_c_Option_Othese,type,
    these: 
      !>[A: $tType] : ( ( set @ ( option @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OAbove,type,
    order_Above: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OAboveS,type,
    order_AboveS: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OUnder,type,
    order_Under: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OUnderS,type,
    order_UnderS: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Order__Relation_Oabove,type,
    order_above: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OaboveS,type,
    order_aboveS: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_Olinear__order__on,type,
    order_679001287576687338der_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Order__Relation_Oofilter,type,
    order_ofilter: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > $o ) ).

thf(sy_c_Order__Relation_Opartial__order__on,type,
    order_7125193373082350890der_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Order__Relation_Opreorder__on,type,
    order_preorder_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Order__Relation_Orelation__of,type,
    order_relation_of: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Order__Relation_Ounder,type,
    order_under: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OunderS,type,
    order_underS: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_Owell__order__on,type,
    order_well_order_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord_Omax,type,
    max: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord_Omin,type,
    min: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder_OGreatest,type,
    greatest: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder_Omono,type,
    mono: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oordering,type,
    ordering: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Orderings_Oordering__axioms,type,
    ordering_axioms: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Orderings_Oordering__top,type,
    ordering_top: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > A > $o ) ).

thf(sy_c_Orderings_Oordering__top__axioms,type,
    ordering_top_axioms: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Orderings_Opartial__preordering,type,
    partial_preordering: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Orderings_Opreordering,type,
    preordering: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Orderings_Opreordering__axioms,type,
    preordering_axioms: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Partial__Function_Oflat__lub,type,
    partial_flat_lub: 
      !>[A: $tType] : ( A > ( set @ A ) > A ) ).

thf(sy_c_Partial__Function_Oflat__ord,type,
    partial_flat_ord: 
      !>[A: $tType] : ( A > A > A > $o ) ).

thf(sy_c_Partial__Function_Ofun__lub,type,
    partial_fun_lub: 
      !>[C: $tType,B: $tType,A: $tType] : ( ( ( set @ C ) > B ) > ( set @ ( A > C ) ) > A > B ) ).

thf(sy_c_Partial__Function_Ofun__ord,type,
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > $o ) > ( C > A ) > ( C > B ) > $o ) ).

thf(sy_c_Partial__Function_Oimg__ord,type,
    partial_img_ord: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( A > C ) > ( C > C > B ) > A > A > B ) ).

thf(sy_c_Partial__Function_Omk__less,type,
    partial_mk_less: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > $o ) ).

thf(sy_c_Partial__Function_Opartial__function__definitions,type,
    partia7178651479351089652itions: 
      !>[A: $tType] : ( ( A > A > $o ) > ( ( set @ A ) > A ) > $o ) ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_OUnity,type,
    product_Unity: product_unit ).

thf(sy_c_Product__Type_Oapfst,type,
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( A > C ) > ( product_prod @ A @ B ) > ( product_prod @ C @ B ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Ocurry,type,
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( ( product_prod @ A @ B ) > C ) > A > B > C ) ).

thf(sy_c_Product__Type_Omap__prod,type,
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) ).

thf(sy_c_Product__Type_Oold_Obool_Orec__bool,type,
    product_rec_bool: 
      !>[T: $tType] : ( T > T > $o > T ) ).

thf(sy_c_Product__Type_Oold_Obool_Orec__set__bool,type,
    product_rec_set_bool: 
      !>[T: $tType] : ( T > T > $o > T > $o ) ).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) ).

thf(sy_c_Product__Type_Oold_Oprod_Orec__set__prod,type,
    product_rec_set_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( A > B > T ) > ( product_prod @ A @ B ) > T > $o ) ).

thf(sy_c_Product__Type_Oold_Ounit_Orec__set__unit,type,
    product_rec_set_unit: 
      !>[T: $tType] : ( T > product_unit > T > $o ) ).

thf(sy_c_Product__Type_Oold_Ounit_Orec__unit,type,
    product_rec_unit: 
      !>[T: $tType] : ( T > product_unit > T ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Product__Type_Oprod_Oswap,type,
    product_swap: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > ( product_prod @ B @ A ) ) ).

thf(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_Oscomp,type,
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( A > ( product_prod @ B @ C ) ) > ( B > C > D ) > A > D ) ).

thf(sy_c_Product__Type_Ounit_OAbs__unit,type,
    product_Abs_unit: $o > product_unit ).

thf(sy_c_Product__Type_Ounit_ORep__unit,type,
    product_Rep_unit: product_unit > $o ).

thf(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : ( itself @ A ) ).

thf(sy_c_Quicksort_Olinorder__class_Oquicksort,type,
    linorder_quicksort: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Quicksort_Olinorder__class_Oquicksort__rel,type,
    linord6200660962353139674rt_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_Quotient_OQuotient3,type,
    quotient3: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > B ) > ( B > A ) > $o ) ).

thf(sy_c_Quotient_Oquot__type,type,
    quot_type: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( ( set @ A ) > B ) > ( B > ( set @ A ) ) > $o ) ).

thf(sy_c_Quotient_Oquot__type_Orep,type,
    quot_rep: 
      !>[B: $tType,A: $tType] : ( ( B > ( set @ A ) ) > B > A ) ).

thf(sy_c_Random_Oinc__shift,type,
    inc_shift: code_natural > code_natural > code_natural ).

thf(sy_c_Random_Oiterate,type,
    iterate: 
      !>[B: $tType,A: $tType] : ( code_natural > ( B > A > ( product_prod @ B @ A ) ) > B > A > ( product_prod @ B @ A ) ) ).

thf(sy_c_Random_Olog,type,
    log: code_natural > code_natural > code_natural ).

thf(sy_c_Random_Ominus__shift,type,
    minus_shift: code_natural > code_natural > code_natural > code_natural ).

thf(sy_c_Random_Onext,type,
    next: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Random_Opick,type,
    pick: 
      !>[A: $tType] : ( ( list @ ( product_prod @ code_natural @ A ) ) > code_natural > A ) ).

thf(sy_c_Random_Orange,type,
    range: code_natural > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Random_Oselect,type,
    select: 
      !>[A: $tType] : ( ( list @ A ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ A @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random_Oselect__weight,type,
    select_weight: 
      !>[A: $tType] : ( ( list @ ( product_prod @ code_natural @ A ) ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ A @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random_Osplit__seed,type,
    split_seed: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_ORep__Rat,type,
    rep_Rat: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Ocr__rat,type,
    cr_rat: ( product_prod @ int @ int ) > rat > $o ).

thf(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : ( rat > A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Opcr__rat,type,
    pcr_rat: ( product_prod @ int @ int ) > rat > $o ).

thf(sy_c_Rat_Opositive,type,
    positive: rat > $o ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Orat_OAbs__rat,type,
    abs_rat: ( set @ ( product_prod @ int @ int ) ) > rat ).

thf(sy_c_Rat_Orat_ORep__rat,type,
    rep_rat: rat > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Rat_Oratrel,type,
    ratrel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Ref__Time_Oalloc,type,
    ref_alloc: 
      !>[A: $tType] : ( A > ( heap_ext @ product_unit ) > ( product_prod @ ( ref @ A ) @ ( heap_ext @ product_unit ) ) ) ).

thf(sy_c_Ref__Time_Ochange,type,
    ref_change: 
      !>[A: $tType] : ( ( A > A ) > ( ref @ A ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Ref__Time_Oget,type,
    ref_get: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( ref @ A ) > A ) ).

thf(sy_c_Ref__Time_Olookup,type,
    ref_lookup: 
      !>[A: $tType] : ( ( ref @ A ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Ref__Time_Oref,type,
    ref_ref: 
      !>[A: $tType] : ( A > ( heap_Time_Heap @ ( ref @ A ) ) ) ).

thf(sy_c_Ref__Time_Oset,type,
    ref_set: 
      !>[A: $tType] : ( ( ref @ A ) > A > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) ) ).

thf(sy_c_Ref__Time_Oupdate,type,
    ref_update: 
      !>[A: $tType] : ( ( ref @ A ) > A > ( heap_Time_Heap @ product_unit ) ) ).

thf(sy_c_Relation_ODomain,type,
    domain: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ A ) ) ).

thf(sy_c_Relation_ODomainp,type,
    domainp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > A > $o ) ).

thf(sy_c_Relation_OField,type,
    field2: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Relation_OId,type,
    id2: 
      !>[A: $tType] : ( set @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_OImage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Relation_OPowp,type,
    powp: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Relation_ORange,type,
    range2: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Relation_ORangep,type,
    rangep: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > B > $o ) ).

thf(sy_c_Relation_Oantisym,type,
    antisym: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Oantisymp,type,
    antisymp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Relation_Oasym,type,
    asym: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Oasymp,type,
    asymp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Relation_Oconverse,type,
    converse: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ A ) ) ) ).

thf(sy_c_Relation_Oconversep,type,
    conversep: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > B > A > $o ) ).

thf(sy_c_Relation_Oinv__image,type,
    inv_image: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_Oinv__imagep,type,
    inv_imagep: 
      !>[B: $tType,A: $tType] : ( ( B > B > $o ) > ( A > B ) > A > A > $o ) ).

thf(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Oirreflp,type,
    irreflp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Relation_Orefl__on,type,
    refl_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Oreflp,type,
    reflp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) ).

thf(sy_c_Relation_Orelcompp,type,
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > $o ) > ( B > C > $o ) > A > C > $o ) ).

thf(sy_c_Relation_Osingle__valued,type,
    single_valued: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > $o ) ).

thf(sy_c_Relation_Osingle__valuedp,type,
    single_valuedp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Relation_Osym,type,
    sym: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Osymp,type,
    symp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Relation_Ototal__on,type,
    total_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Otrans,type,
    trans: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Onormalization__semidom__class_Onormalize,type,
    normal6383669964737779283malize: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Rings_Ounit__factor__class_Ounit__factor,type,
    unit_f5069060285200089521factor: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OBex,type,
    bex: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Obind,type,
    bind3: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Set_Odisjnt,type,
    disjnt: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ A ) > $o ) ).

thf(sy_c_Set_Ofilter,type,
    filter3: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Oimage,type,
    image2: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Ois__empty,type,
    is_empty: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Set_Ois__singleton,type,
    is_singleton: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Set_Opairwise,type,
    pairwise: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ B ) > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Oord_OatLeast,type,
    set_atLeast: 
      !>[A: $tType] : ( ( A > A > $o ) > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OatLeastAtMost,type,
    set_atLeastAtMost: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OatLeastLessThan,type,
    set_atLeastLessThan: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OatMost,type,
    set_atMost: 
      !>[A: $tType] : ( ( A > A > $o ) > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OgreaterThan,type,
    set_greaterThan: 
      !>[A: $tType] : ( ( A > A > $o ) > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OgreaterThanAtMost,type,
    set_gr3752724095348155675AtMost: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OgreaterThanLessThan,type,
    set_gr287244882034783167ssThan: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OlessThan,type,
    set_lessThan: 
      !>[A: $tType] : ( ( A > A > $o ) > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Sum__Type_OInl,type,
    sum_Inl: 
      !>[A: $tType,B: $tType] : ( A > ( sum_sum @ A @ B ) ) ).

thf(sy_c_Sum__Type_OInr,type,
    sum_Inr: 
      !>[B: $tType,A: $tType] : ( B > ( sum_sum @ A @ B ) ) ).

thf(sy_c_Sum__Type_OPlus,type,
    sum_Plus: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( sum_sum @ A @ B ) ) ) ).

thf(sy_c_Sum__Type_Oold_Osum_Orec__set__sum,type,
    sum_rec_set_sum: 
      !>[A: $tType,T: $tType,B: $tType] : ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T > $o ) ).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] : ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) ).

thf(sy_c_Sum__Type_Osum_Ocase__sum,type,
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( A > C ) > ( B > C ) > ( sum_sum @ A @ B ) > C ) ).

thf(sy_c_Sum__Type_Osum_Oisl,type,
    sum_isl: 
      !>[A: $tType,B: $tType] : ( ( sum_sum @ A @ B ) > $o ) ).

thf(sy_c_Sum__Type_Osum_Oprojl,type,
    sum_projl: 
      !>[A: $tType,B: $tType] : ( ( sum_sum @ A @ B ) > A ) ).

thf(sy_c_Sum__Type_Osum_Oprojr,type,
    sum_projr: 
      !>[A: $tType,B: $tType] : ( ( sum_sum @ A @ B ) > B ) ).

thf(sy_c_Syntax__Match_Oac__operator,type,
    syntax_ac_operator: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Syntax__Match_Osyntax__fo__nomatch,type,
    syntax7388354845996824322omatch: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_Syntax__Match_Osyntax__nomatch,type,
    syntax2379306206330768139omatch: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_Transfer_Obi__total,type,
    bi_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transfer_Obi__unique,type,
    bi_unique: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transfer_Oleft__total,type,
    left_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transfer_Oleft__unique,type,
    left_unique: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transfer_Oright__total,type,
    right_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transfer_Otransfer__bforall,type,
    transfer_bforall: 
      !>[A: $tType] : ( ( A > $o ) > ( A > $o ) > $o ) ).

thf(sy_c_Transitive__Closure_Oacyclic,type,
    transitive_acyclic: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortranclp,type,
    transitive_rtranclp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > $o ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otranclp,type,
    transitive_tranclp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > $o ) ).

thf(sy_c_Typedef_Otype__definition,type,
    type_definition: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Typerep_Otyperep__class_Otyperep,type,
    typerep_typerep: 
      !>[A: $tType] : ( ( itself @ A ) > typerep ) ).

thf(sy_c_Wellfounded_Oacc,type,
    acc: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ).

thf(sy_c_Wellfounded_Oless__than,type,
    less_than: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omax__extp,type,
    max_extp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > ( set @ A ) > $o ) ).

thf(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_Wellfounded_Owf,type,
    wf: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Wellfounded_OwfP,type,
    wfP: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Wfrec_Osame__fst,type,
    same_fst: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_Zorn_OChains,type,
    chains: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Zorn_Ochain__subset,type,
    chain_subset: 
      !>[A: $tType] : ( ( set @ ( set @ A ) ) > $o ) ).

thf(sy_c_Zorn_Ochains,type,
    chains2: 
      !>[A: $tType] : ( ( set @ ( set @ A ) ) > ( set @ ( set @ ( set @ A ) ) ) ) ).

thf(sy_c_Zorn_Oinit__seg__of,type,
    init_seg_of: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

thf(sy_c_Zorn_Opred__on_Ochain,type,
    pred_chain: 
      !>[A: $tType] : ( ( set @ A ) > ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Zorn_Opred__on_Omaxchain,type,
    pred_maxchain: 
      !>[A: $tType] : ( ( set @ A ) > ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Zorn_Opred__on_Osuc,type,
    pred_suc: 
      !>[A: $tType] : ( ( set @ A ) > ( A > A > $o ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Zorn_Opred__on_Osuc__Union__closed,type,
    pred_s596693808085603175closed: 
      !>[A: $tType] : ( ( set @ A ) > ( A > A > $o ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Zorn_Opred__on_Osuc__Union__closedp,type,
    pred_s7749564232668923593losedp: 
      !>[A: $tType] : ( ( set @ A ) > ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_P,type,
    p: assn ).

thf(sy_v_P_H,type,
    p2: assn ).

thf(sy_v_P_H__0_058ATP,type,
    p_0_ATP: assn ).

thf(sy_v_Q,type,
    q: a > assn ).

thf(sy_v_Q_H,type,
    q2: a > assn ).

thf(sy_v_c,type,
    c: heap_Time_Heap @ a ).

% Relevant facts (6168)
thf(fact_0_cons__rule,axiom,
    ! [A: $tType,P: assn,P2: assn,Q: A > assn,Q2: A > assn,C2: heap_Time_Heap @ A] :
      ( ( entails @ P @ P2 )
     => ( ! [X: A] : ( entails @ ( Q @ X ) @ ( Q2 @ X ) )
       => ( ( hoare_hoare_triple @ A @ P2 @ C2 @ Q )
         => ( hoare_hoare_triple @ A @ P @ C2 @ Q2 ) ) ) ) ).

% cons_rule
thf(fact_1_frame__rule,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn,R: assn] :
      ( ( hoare_hoare_triple @ A @ P @ C2 @ Q )
     => ( hoare_hoare_triple @ A @ ( times_times @ assn @ P @ R ) @ C2
        @ ^ [X2: A] : ( times_times @ assn @ ( Q @ X2 ) @ R ) ) ) ).

% frame_rule
thf(fact_2_cons__pre__rule,axiom,
    ! [A: $tType,P: assn,P2: assn,C2: heap_Time_Heap @ A,Q: A > assn] :
      ( ( entails @ P @ P2 )
     => ( ( hoare_hoare_triple @ A @ P2 @ C2 @ Q )
       => ( hoare_hoare_triple @ A @ P @ C2 @ Q ) ) ) ).

% cons_pre_rule
thf(fact_3_cons__post__rule,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn,Q2: A > assn] :
      ( ( hoare_hoare_triple @ A @ P @ C2 @ Q )
     => ( ! [X: A] : ( entails @ ( Q @ X ) @ ( Q2 @ X ) )
       => ( hoare_hoare_triple @ A @ P @ C2 @ Q2 ) ) ) ).

% cons_post_rule
thf(fact_4_merge__true__star,axiom,
    ( ( times_times @ assn @ ( top_top @ assn ) @ ( top_top @ assn ) )
    = ( top_top @ assn ) ) ).

% merge_true_star
thf(fact_5_top__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( top @ C )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X2: D] : ( top_top @ C ) ) ) ) ).

% top_apply
thf(fact_6_ent__true,axiom,
    ! [P: assn] : ( entails @ P @ ( top_top @ assn ) ) ).

% ent_true
thf(fact_7_ent__star__mono,axiom,
    ! [P: assn,P2: assn,Q: assn,Q2: assn] :
      ( ( entails @ P @ P2 )
     => ( ( entails @ Q @ Q2 )
       => ( entails @ ( times_times @ assn @ P @ Q ) @ ( times_times @ assn @ P2 @ Q2 ) ) ) ) ).

% ent_star_mono
thf(fact_8_ent__iffI,axiom,
    ! [A3: assn,B2: assn] :
      ( ( entails @ A3 @ B2 )
     => ( ( entails @ B2 @ A3 )
       => ( A3 = B2 ) ) ) ).

% ent_iffI
thf(fact_9_ent__refl,axiom,
    ! [P: assn] : ( entails @ P @ P ) ).

% ent_refl
thf(fact_10_ent__trans,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( ( entails @ P @ Q )
     => ( ( entails @ Q @ R )
       => ( entails @ P @ R ) ) ) ).

% ent_trans
thf(fact_11_assn__times__comm,axiom,
    ( ( times_times @ assn )
    = ( ^ [P3: assn,Q3: assn] : ( times_times @ assn @ Q3 @ P3 ) ) ) ).

% assn_times_comm
thf(fact_12_assn__times__assoc,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( ( times_times @ assn @ ( times_times @ assn @ P @ Q ) @ R )
      = ( times_times @ assn @ P @ ( times_times @ assn @ Q @ R ) ) ) ).

% assn_times_assoc
thf(fact_13_mult_Oright__assoc,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 )
          = ( times_times @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) ) ) ) ).

% mult.right_assoc
thf(fact_14_mult_Oright__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 )
          = ( times_times @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) ) ) ).

% mult.right_commute
thf(fact_15_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 )
          = ( times_times @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_16_ab__semigroup__mult__class_Omult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( times_times @ A @ B3 @ ( times_times @ A @ A4 @ C2 ) )
          = ( times_times @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult.left_commute
thf(fact_17_ab__semigroup__mult__class_Omult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ B4 @ A5 ) ) ) ) ).

% ab_semigroup_mult_class.mult.commute
thf(fact_18_ent__wandI,axiom,
    ! [Q: assn,P: assn,R: assn] :
      ( ( entails @ ( times_times @ assn @ Q @ P ) @ R )
     => ( entails @ P @ ( wand_assn @ Q @ R ) ) ) ).

% ent_wandI
thf(fact_19_ent__mp,axiom,
    ! [P: assn,Q: assn] : ( entails @ ( times_times @ assn @ P @ ( wand_assn @ P @ Q ) ) @ Q ) ).

% ent_mp
thf(fact_20_entt__def__true,axiom,
    ( entailst
    = ( ^ [P3: assn,Q3: assn] : ( entails @ ( times_times @ assn @ P3 @ ( top_top @ assn ) ) @ ( times_times @ assn @ Q3 @ ( top_top @ assn ) ) ) ) ) ).

% entt_def_true
thf(fact_21_entailst__def,axiom,
    ( entailst
    = ( ^ [A6: assn,B5: assn] : ( entails @ A6 @ ( times_times @ assn @ B5 @ ( top_top @ assn ) ) ) ) ) ).

% entailst_def
thf(fact_22_enttI__true,axiom,
    ! [P: assn,Q: assn] :
      ( ( entails @ ( times_times @ assn @ P @ ( top_top @ assn ) ) @ ( times_times @ assn @ Q @ ( top_top @ assn ) ) )
     => ( entailst @ P @ Q ) ) ).

% enttI_true
thf(fact_23_enttI,axiom,
    ! [A3: assn,B2: assn] :
      ( ( entails @ A3 @ ( times_times @ assn @ B2 @ ( top_top @ assn ) ) )
     => ( entailst @ A3 @ B2 ) ) ).

% enttI
thf(fact_24_enttD,axiom,
    ! [A3: assn,B2: assn] :
      ( ( entailst @ A3 @ B2 )
     => ( entails @ A3 @ ( times_times @ assn @ B2 @ ( top_top @ assn ) ) ) ) ).

% enttD
thf(fact_25_is__pure__assn__starI,axiom,
    ! [A4: assn,B3: assn] :
      ( ( is_pure_assn @ A4 )
     => ( ( is_pure_assn @ B3 )
       => ( is_pure_assn @ ( times_times @ assn @ A4 @ B3 ) ) ) ) ).

% is_pure_assn_starI
thf(fact_26_ent__pure__pre__iff,axiom,
    ! [P: assn,B3: $o,Q: assn] :
      ( ( entails @ ( times_times @ assn @ P @ ( pure_assn @ B3 ) ) @ Q )
      = ( B3
       => ( entails @ P @ Q ) ) ) ).

% ent_pure_pre_iff
thf(fact_27_entt__star__true__simp_I1_J,axiom,
    ! [A3: assn,B2: assn] :
      ( ( entailst @ A3 @ ( times_times @ assn @ B2 @ ( top_top @ assn ) ) )
      = ( entailst @ A3 @ B2 ) ) ).

% entt_star_true_simp(1)
thf(fact_28_entt__star__true__simp_I2_J,axiom,
    ! [A3: assn,B2: assn] :
      ( ( entailst @ ( times_times @ assn @ A3 @ ( top_top @ assn ) ) @ B2 )
      = ( entailst @ A3 @ B2 ) ) ).

% entt_star_true_simp(2)
thf(fact_29_mult_Osafe__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [X3: A,Y: A,A4: A,B3: A] :
          ( ( syntax7388354845996824322omatch @ A @ A @ ( times_times @ A @ X3 @ Y ) @ A4 )
         => ( ( times_times @ A @ A4 @ B3 )
            = ( times_times @ A @ B3 @ A4 ) ) ) ) ).

% mult.safe_commute
thf(fact_30_entt__refl,axiom,
    ! [A3: assn] : ( entailst @ A3 @ A3 ) ).

% entt_refl
thf(fact_31_pure__assn__eq__conv,axiom,
    ! [P: $o,Q: $o] :
      ( ( ( pure_assn @ P )
        = ( pure_assn @ Q ) )
      = ( P = Q ) ) ).

% pure_assn_eq_conv
thf(fact_32_merge__pure__star,axiom,
    ! [A4: $o,B3: $o] :
      ( ( times_times @ assn @ ( pure_assn @ A4 ) @ ( pure_assn @ B3 ) )
      = ( pure_assn
        @ ( A4
          & B3 ) ) ) ).

% merge_pure_star
thf(fact_33_entt__true,axiom,
    ! [A3: assn] : ( entailst @ A3 @ ( top_top @ assn ) ) ).

% entt_true
thf(fact_34_is__pure__assn__pure,axiom,
    ! [P: $o] : ( is_pure_assn @ ( pure_assn @ P ) ) ).

% is_pure_assn_pure
thf(fact_35_entt__trans,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( ( entailst @ A3 @ B2 )
     => ( ( entailst @ B2 @ C3 )
       => ( entailst @ A3 @ C3 ) ) ) ).

% entt_trans
thf(fact_36_is__pure__assnE,axiom,
    ! [A4: assn] :
      ( ( is_pure_assn @ A4 )
     => ~ ! [P4: $o] :
            ( A4
           != ( pure_assn @ P4 ) ) ) ).

% is_pure_assnE
thf(fact_37_is__pure__assn__def,axiom,
    ( is_pure_assn
    = ( ^ [A5: assn] :
        ? [P3: $o] :
          ( A5
          = ( pure_assn @ P3 ) ) ) ) ).

% is_pure_assn_def
thf(fact_38_syntax__fo__nomatch__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( syntax7388354845996824322omatch @ A @ B )
      = ( ^ [Pat: A,Obj: B] : $true ) ) ).

% syntax_fo_nomatch_def
thf(fact_39_entt__frame__fwd,axiom,
    ! [P: assn,Q: assn,A3: assn,F: assn,B2: assn] :
      ( ( entailst @ P @ Q )
     => ( ( entailst @ A3 @ ( times_times @ assn @ P @ F ) )
       => ( ( entailst @ ( times_times @ assn @ Q @ F ) @ B2 )
         => ( entailst @ A3 @ B2 ) ) ) ) ).

% entt_frame_fwd
thf(fact_40_entt__star__mono,axiom,
    ! [A3: assn,B2: assn,C3: assn,D2: assn] :
      ( ( entailst @ A3 @ B2 )
     => ( ( entailst @ C3 @ D2 )
       => ( entailst @ ( times_times @ assn @ A3 @ C3 ) @ ( times_times @ assn @ B2 @ D2 ) ) ) ) ).

% entt_star_mono
thf(fact_41_ent__imp__entt,axiom,
    ! [P: assn,Q: assn] :
      ( ( entails @ P @ Q )
     => ( entailst @ P @ Q ) ) ).

% ent_imp_entt
thf(fact_42_precise__extr__pure_I2_J,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn,P: $o] :
      ( ( precise @ A @ B
        @ ^ [X2: A,Y2: B] : ( times_times @ assn @ ( R @ X2 @ Y2 ) @ ( pure_assn @ P ) ) )
      = ( P
       => ( precise @ A @ B @ R ) ) ) ).

% precise_extr_pure(2)
thf(fact_43_precise__extr__pure_I1_J,axiom,
    ! [B: $tType,A: $tType,P: $o,R: A > B > assn] :
      ( ( precise @ A @ B
        @ ^ [X2: A,Y2: B] : ( times_times @ assn @ ( pure_assn @ P ) @ ( R @ X2 @ Y2 ) ) )
      = ( P
       => ( precise @ A @ B @ R ) ) ) ).

% precise_extr_pure(1)
thf(fact_44_ent__pure__post__iff,axiom,
    ! [P: assn,Q: assn,B3: $o] :
      ( ( entails @ P @ ( times_times @ assn @ Q @ ( pure_assn @ B3 ) ) )
      = ( ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( rep_assn @ P @ H )
           => B3 )
        & ( entails @ P @ Q ) ) ) ).

% ent_pure_post_iff
thf(fact_45_mem__Collect__eq,axiom,
    ! [A: $tType,A4: A,P: A > $o] :
      ( ( member @ A @ A4 @ ( collect @ A @ P ) )
      = ( P @ A4 ) ) ).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( collect @ A
        @ ^ [X2: A] : ( member @ A @ X2 @ A3 ) )
      = A3 ) ).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X: A] :
          ( ( P @ X )
          = ( Q @ X ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_48_ext,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G: A > B] :
      ( ! [X: A] :
          ( ( F2 @ X )
          = ( G @ X ) )
     => ( F2 = G ) ) ).

% ext
thf(fact_49_ent__pure__pre__iff__sng,axiom,
    ! [B3: $o,Q: assn] :
      ( ( entails @ ( pure_assn @ B3 ) @ Q )
      = ( B3
       => ( entails @ ( one_one @ assn ) @ Q ) ) ) ).

% ent_pure_pre_iff_sng
thf(fact_50_triv__exI,axiom,
    ! [A: $tType,Q: A > assn,X3: A] : ( entails @ ( Q @ X3 ) @ ( ex_assn @ A @ Q ) ) ).

% triv_exI
thf(fact_51_ac__operator_Osafe__commute,axiom,
    ! [A: $tType,F2: A > A > A,X3: A,Y: A,A4: A,B3: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( syntax7388354845996824322omatch @ A @ A @ ( F2 @ X3 @ Y ) @ A4 )
       => ( ( F2 @ A4 @ B3 )
          = ( F2 @ B3 @ A4 ) ) ) ) ).

% ac_operator.safe_commute
thf(fact_52_mod__pure__star__dist,axiom,
    ! [P: assn,B3: $o,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ P @ ( pure_assn @ B3 ) ) @ H2 )
      = ( ( rep_assn @ P @ H2 )
        & B3 ) ) ).

% mod_pure_star_dist
thf(fact_53_mod__star__trueE,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ P @ ( top_top @ assn ) ) @ H2 )
     => ~ ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ~ ( rep_assn @ P @ H3 ) ) ).

% mod_star_trueE
thf(fact_54_mod__star__trueI,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ P @ H2 )
     => ( rep_assn @ ( times_times @ assn @ P @ ( top_top @ assn ) ) @ H2 ) ) ).

% mod_star_trueI
thf(fact_55_ent__ex__preI,axiom,
    ! [A: $tType,P: A > assn,Q: assn] :
      ( ! [X: A] : ( entails @ ( P @ X ) @ Q )
     => ( entails @ ( ex_assn @ A @ P ) @ Q ) ) ).

% ent_ex_preI
thf(fact_56_ent__ex__postI,axiom,
    ! [A: $tType,P: assn,Q: A > assn,X3: A] :
      ( ( entails @ P @ ( Q @ X3 ) )
     => ( entails @ P @ ( ex_assn @ A @ Q ) ) ) ).

% ent_ex_postI
thf(fact_57_ex__distrib__star,axiom,
    ! [A: $tType,P: A > assn,Q: assn] :
      ( ( ex_assn @ A
        @ ^ [X2: A] : ( times_times @ assn @ ( P @ X2 ) @ Q ) )
      = ( times_times @ assn @ ( ex_assn @ A @ P ) @ Q ) ) ).

% ex_distrib_star
thf(fact_58_Rep__assn__inject,axiom,
    ! [X3: assn,Y: assn] :
      ( ( ( rep_assn @ X3 )
        = ( rep_assn @ Y ) )
      = ( X3 = Y ) ) ).

% Rep_assn_inject
thf(fact_59_ex__assn__const,axiom,
    ! [A: $tType,C2: assn] :
      ( ( ex_assn @ A
        @ ^ [X2: A] : C2 )
      = C2 ) ).

% ex_assn_const
thf(fact_60_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A4 )
          = A4 ) ) ).

% mult_1
thf(fact_61_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ A4 @ ( one_one @ A ) )
          = A4 ) ) ).

% mult.right_neutral
thf(fact_62_entt__emp,axiom,
    ! [A3: assn] : ( entailst @ A3 @ ( one_one @ assn ) ) ).

% entt_emp
thf(fact_63_pure__assn__eq__emp__iff,axiom,
    ! [P: $o] :
      ( ( ( pure_assn @ P )
        = ( one_one @ assn ) )
      = P ) ).

% pure_assn_eq_emp_iff
thf(fact_64_pure__true,axiom,
    ( ( pure_assn @ $true )
    = ( one_one @ assn ) ) ).

% pure_true
thf(fact_65_assn__basic__inequalities_I1_J,axiom,
    ( top_top @ assn )
 != ( one_one @ assn ) ).

% assn_basic_inequalities(1)
thf(fact_66_mod__ex__dist,axiom,
    ! [A: $tType,P: A > assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( ex_assn @ A @ P ) @ H2 )
      = ( ? [X2: A] : ( rep_assn @ ( P @ X2 ) @ H2 ) ) ) ).

% mod_ex_dist
thf(fact_67_ent__pure__post__iff__sng,axiom,
    ! [P: assn,B3: $o] :
      ( ( entails @ P @ ( pure_assn @ B3 ) )
      = ( ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( rep_assn @ P @ H )
           => B3 )
        & ( entails @ P @ ( one_one @ assn ) ) ) ) ).

% ent_pure_post_iff_sng
thf(fact_68_ex__one__point__gen,axiom,
    ! [A: $tType,P: A > assn,V: A] :
      ( ! [H4: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),X: A] :
          ( ( rep_assn @ ( P @ X ) @ H4 )
         => ( X = V ) )
     => ( ( ex_assn @ A @ P )
        = ( P @ V ) ) ) ).

% ex_one_point_gen
thf(fact_69_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X3: A] :
          ( ( ( one_one @ A )
            = X3 )
          = ( X3
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_70_mod__exI,axiom,
    ! [A: $tType,P: A > assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ? [X4: A] : ( rep_assn @ ( P @ X4 ) @ H2 )
     => ( rep_assn @ ( ex_assn @ A @ P ) @ H2 ) ) ).

% mod_exI
thf(fact_71_mod__exE,axiom,
    ! [A: $tType,P: A > assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( ex_assn @ A @ P ) @ H2 )
     => ~ ! [X: A] :
            ~ ( rep_assn @ ( P @ X ) @ H2 ) ) ).

% mod_exE
thf(fact_72_ac__operator_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ! [A7: A,B6: A,C4: A] :
          ( ( F2 @ ( F2 @ A7 @ B6 ) @ C4 )
          = ( F2 @ A7 @ ( F2 @ B6 @ C4 ) ) )
     => ( ! [A7: A,B6: A] :
            ( ( F2 @ A7 @ B6 )
            = ( F2 @ B6 @ A7 ) )
       => ( syntax_ac_operator @ A @ F2 ) ) ) ).

% ac_operator.intro
thf(fact_73_ac__operator_Ocommute,axiom,
    ! [A: $tType,F2: A > A > A,A4: A,B3: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( F2 @ A4 @ B3 )
        = ( F2 @ B3 @ A4 ) ) ) ).

% ac_operator.commute
thf(fact_74_ac__operator_Oleft__assoc,axiom,
    ! [A: $tType,F2: A > A > A,A4: A,B3: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( F2 @ A4 @ ( F2 @ B3 @ C2 ) )
        = ( F2 @ ( F2 @ A4 @ B3 ) @ C2 ) ) ) ).

% ac_operator.left_assoc
thf(fact_75_ac__operator_Oright__assoc,axiom,
    ! [A: $tType,F2: A > A > A,A4: A,B3: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( F2 @ ( F2 @ A4 @ B3 ) @ C2 )
        = ( F2 @ A4 @ ( F2 @ B3 @ C2 ) ) ) ) ).

% ac_operator.right_assoc
thf(fact_76_ac__operator_Oleft__commute,axiom,
    ! [A: $tType,F2: A > A > A,A4: A,B3: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( F2 @ A4 @ ( F2 @ B3 @ C2 ) )
        = ( F2 @ B3 @ ( F2 @ A4 @ C2 ) ) ) ) ).

% ac_operator.left_commute
thf(fact_77_ac__operator_Oright__commute,axiom,
    ! [A: $tType,F2: A > A > A,A4: A,B3: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( F2 @ ( F2 @ A4 @ B3 ) @ C2 )
        = ( F2 @ ( F2 @ A4 @ C2 ) @ B3 ) ) ) ).

% ac_operator.right_commute
thf(fact_78_ac__operator__def,axiom,
    ! [A: $tType] :
      ( ( syntax_ac_operator @ A )
      = ( ^ [F3: A > A > A] :
            ( ! [A5: A,B4: A,C5: A] :
                ( ( F3 @ ( F3 @ A5 @ B4 ) @ C5 )
                = ( F3 @ A5 @ ( F3 @ B4 @ C5 ) ) )
            & ! [A5: A,B4: A] :
                ( ( F3 @ A5 @ B4 )
                = ( F3 @ B4 @ A5 ) ) ) ) ) ).

% ac_operator_def
thf(fact_79_preciseD_H,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn,A4: A,P5: B,F: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),A8: A,F4: assn] :
      ( ( precise @ A @ B @ R )
     => ( ( rep_assn @ ( times_times @ assn @ ( R @ A4 @ P5 ) @ F ) @ H2 )
       => ( ( rep_assn @ ( times_times @ assn @ ( R @ A8 @ P5 ) @ F4 ) @ H2 )
         => ( A4 = A8 ) ) ) ) ).

% preciseD'
thf(fact_80_mod__starE,axiom,
    ! [A4: assn,B3: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ A4 @ B3 ) @ H2 )
     => ~ ( ? [X_1: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] : ( rep_assn @ A4 @ X_1 )
         => ! [H_2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ~ ( rep_assn @ B3 @ H_2 ) ) ) ).

% mod_starE
thf(fact_81_mod__starD,axiom,
    ! [A3: assn,B2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ A3 @ B2 ) @ H2 )
     => ? [H1: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),H22: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ A3 @ H1 )
          & ( rep_assn @ B2 @ H22 ) ) ) ).

% mod_starD
thf(fact_82_entails__def,axiom,
    ( entails
    = ( ^ [P3: assn,Q3: assn] :
        ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ P3 @ H )
         => ( rep_assn @ Q3 @ H ) ) ) ) ).

% entails_def
thf(fact_83_entailsI,axiom,
    ! [P: assn,Q: assn] :
      ( ! [H4: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ P @ H4 )
         => ( rep_assn @ Q @ H4 ) )
     => ( entails @ P @ Q ) ) ).

% entailsI
thf(fact_84_entailsD,axiom,
    ! [P: assn,Q: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( entails @ P @ Q )
     => ( ( rep_assn @ P @ H2 )
       => ( rep_assn @ Q @ H2 ) ) ) ).

% entailsD
thf(fact_85_ent__fwd,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Q: assn] :
      ( ( rep_assn @ P @ H2 )
     => ( ( entails @ P @ Q )
       => ( rep_assn @ Q @ H2 ) ) ) ).

% ent_fwd
thf(fact_86_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ A4 @ ( one_one @ A ) )
          = A4 ) ) ).

% mult.comm_neutral
thf(fact_87_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A4 )
          = A4 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_88_hoare__triple__preI,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn] :
      ( ! [H4: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ P @ H4 )
         => ( hoare_hoare_triple @ A @ P @ C2 @ Q ) )
     => ( hoare_hoare_triple @ A @ P @ C2 @ Q ) ) ).

% hoare_triple_preI
thf(fact_89_assn__one__left,axiom,
    ! [P: assn] :
      ( ( times_times @ assn @ ( one_one @ assn ) @ P )
      = P ) ).

% assn_one_left
thf(fact_90_is__pure__assn__basic__simps_I2_J,axiom,
    is_pure_assn @ ( one_one @ assn ) ).

% is_pure_assn_basic_simps(2)
thf(fact_91_mult_Oac__operator__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( syntax_ac_operator @ A @ ( times_times @ A ) ) ) ).

% mult.ac_operator_axioms
thf(fact_92_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X2: A] : X2 )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_93_precise__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( precise @ A @ B )
      = ( ^ [R2: A > B > assn] :
          ! [A5: A,A9: A,H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),P6: B,F5: assn,F6: assn] :
            ( ( rep_assn @ ( inf_inf @ assn @ ( times_times @ assn @ ( R2 @ A5 @ P6 ) @ F5 ) @ ( times_times @ assn @ ( R2 @ A9 @ P6 ) @ F6 ) ) @ H )
           => ( A5 = A9 ) ) ) ) ).

% precise_def
thf(fact_94_preciseI,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn] :
      ( ! [A7: A,A10: A,H4: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),P7: B,F7: assn,F8: assn] :
          ( ( rep_assn @ ( inf_inf @ assn @ ( times_times @ assn @ ( R @ A7 @ P7 ) @ F7 ) @ ( times_times @ assn @ ( R @ A10 @ P7 ) @ F8 ) ) @ H4 )
         => ( A7 = A10 ) )
     => ( precise @ A @ B @ R ) ) ).

% preciseI
thf(fact_95_preciseD,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn,A4: A,P5: B,F: assn,A8: A,F4: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( precise @ A @ B @ R )
     => ( ( rep_assn @ ( inf_inf @ assn @ ( times_times @ assn @ ( R @ A4 @ P5 ) @ F ) @ ( times_times @ assn @ ( R @ A8 @ P5 ) @ F4 ) ) @ H2 )
       => ( A4 = A8 ) ) ) ).

% preciseD
thf(fact_96_mod__true,axiom,
    ! [H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( top_top @ assn ) @ H2 )
      = ( in_range @ H2 ) ) ).

% mod_true
thf(fact_97_mult_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( monoid @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% mult.monoid_axioms
thf(fact_98_ent__false__iff,axiom,
    ! [P: assn] :
      ( ( entails @ P @ ( bot_bot @ assn ) )
      = ( ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ~ ( rep_assn @ P @ H ) ) ) ).

% ent_false_iff
thf(fact_99_mult_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( comm_monoid @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% mult.comm_monoid_axioms
thf(fact_100_Rep__assn__inverse,axiom,
    ! [X3: assn] :
      ( ( abs_assn @ ( rep_assn @ X3 ) )
      = X3 ) ).

% Rep_assn_inverse
thf(fact_101_wand__assn__def,axiom,
    ( wand_assn
    = ( ^ [P3: assn,Q3: assn] : ( abs_assn @ ( wand_raw @ ( rep_assn @ P3 ) @ ( rep_assn @ Q3 ) ) ) ) ) ).

% wand_assn_def
thf(fact_102_prod_Ocomm__monoid__list__set__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( groups4802862169904069756st_set @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod.comm_monoid_list_set_axioms
thf(fact_103_syntax__nomatch__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( syntax2379306206330768139omatch @ A @ B )
      = ( ^ [Pat: A,Obj: B] : $true ) ) ).

% syntax_nomatch_def
thf(fact_104_bot__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( bot @ C )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X2: D] : ( bot_bot @ C ) ) ) ) ).

% bot_apply
thf(fact_105_star__false__left,axiom,
    ! [P: assn] :
      ( ( times_times @ assn @ ( bot_bot @ assn ) @ P )
      = ( bot_bot @ assn ) ) ).

% star_false_left
thf(fact_106_star__false__right,axiom,
    ! [P: assn] :
      ( ( times_times @ assn @ P @ ( bot_bot @ assn ) )
      = ( bot_bot @ assn ) ) ).

% star_false_right
thf(fact_107_pure__false,axiom,
    ( ( pure_assn @ $false )
    = ( bot_bot @ assn ) ) ).

% pure_false
thf(fact_108_pure__assn__eq__false__iff,axiom,
    ! [P: $o] :
      ( ( ( pure_assn @ P )
        = ( bot_bot @ assn ) )
      = ( ~ P ) ) ).

% pure_assn_eq_false_iff
thf(fact_109_merge__pure__and,axiom,
    ! [A4: $o,B3: $o] :
      ( ( inf_inf @ assn @ ( pure_assn @ A4 ) @ ( pure_assn @ B3 ) )
      = ( pure_assn
        @ ( A4
          & B3 ) ) ) ).

% merge_pure_and
thf(fact_110_assn__basic__inequalities_I5_J,axiom,
    ( top_top @ assn )
 != ( bot_bot @ assn ) ).

% assn_basic_inequalities(5)
thf(fact_111_false__rule,axiom,
    ! [A: $tType,C2: heap_Time_Heap @ A,Q: A > assn] : ( hoare_hoare_triple @ A @ ( bot_bot @ assn ) @ C2 @ Q ) ).

% false_rule
thf(fact_112_assn__basic__inequalities_I3_J,axiom,
    ( bot_bot @ assn )
 != ( one_one @ assn ) ).

% assn_basic_inequalities(3)
thf(fact_113_monoid_Oleft__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,A4: A] :
      ( ( monoid @ A @ F2 @ Z2 )
     => ( ( F2 @ Z2 @ A4 )
        = A4 ) ) ).

% monoid.left_neutral
thf(fact_114_monoid_Oright__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,A4: A] :
      ( ( monoid @ A @ F2 @ Z2 )
     => ( ( F2 @ A4 @ Z2 )
        = A4 ) ) ).

% monoid.right_neutral
thf(fact_115_comm__monoid_Ocomm__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,A4: A] :
      ( ( comm_monoid @ A @ F2 @ Z2 )
     => ( ( F2 @ A4 @ Z2 )
        = A4 ) ) ).

% comm_monoid.comm_neutral
thf(fact_116_bot__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot @ B )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X2: A] : ( bot_bot @ B ) ) ) ) ).

% bot_fun_def
thf(fact_117_bot__assn__def,axiom,
    ( ( bot_bot @ assn )
    = ( abs_assn
      @ ^ [Uu: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] : $false ) ) ).

% bot_assn_def
thf(fact_118_top__assn__def,axiom,
    ( ( top_top @ assn )
    = ( abs_assn @ in_range ) ) ).

% top_assn_def
thf(fact_119_inf__assn__def,axiom,
    ( ( inf_inf @ assn )
    = ( ^ [P3: assn,Q3: assn] :
          ( abs_assn
          @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( rep_assn @ P3 @ H )
              & ( rep_assn @ Q3 @ H ) ) ) ) ) ).

% inf_assn_def
thf(fact_120_mod__and__dist,axiom,
    ! [P: assn,Q: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( inf_inf @ assn @ P @ Q ) @ H2 )
      = ( ( rep_assn @ P @ H2 )
        & ( rep_assn @ Q @ H2 ) ) ) ).

% mod_and_dist
thf(fact_121_mod__false,axiom,
    ! [H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ~ ( rep_assn @ ( bot_bot @ assn ) @ H2 ) ).

% mod_false
thf(fact_122_ent__conjI,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( ( entails @ A3 @ B2 )
     => ( ( entails @ A3 @ C3 )
       => ( entails @ A3 @ ( inf_inf @ assn @ B2 @ C3 ) ) ) ) ).

% ent_conjI
thf(fact_123_ent__conjE1,axiom,
    ! [A3: assn,C3: assn,B2: assn] :
      ( ( entails @ A3 @ C3 )
     => ( entails @ ( inf_inf @ assn @ A3 @ B2 ) @ C3 ) ) ).

% ent_conjE1
thf(fact_124_ent__conjE2,axiom,
    ! [B2: assn,C3: assn,A3: assn] :
      ( ( entails @ B2 @ C3 )
     => ( entails @ ( inf_inf @ assn @ A3 @ B2 ) @ C3 ) ) ).

% ent_conjE2
thf(fact_125_ent__false,axiom,
    ! [P: assn] : ( entails @ ( bot_bot @ assn ) @ P ) ).

% ent_false
thf(fact_126_models__in__range,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ P @ H2 )
     => ( in_range @ H2 ) ) ).

% models_in_range
thf(fact_127_is__pure__assn__basic__simps_I1_J,axiom,
    is_pure_assn @ ( bot_bot @ assn ) ).

% is_pure_assn_basic_simps(1)
thf(fact_128_Abs__assn__eqI_I2_J,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Pr: assn] :
      ( ! [H4: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( P @ H4 )
          = ( rep_assn @ Pr @ H4 ) )
     => ( Pr
        = ( abs_assn @ P ) ) ) ).

% Abs_assn_eqI(2)
thf(fact_129_Abs__assn__eqI_I1_J,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Pr: assn] :
      ( ! [H4: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( P @ H4 )
          = ( rep_assn @ Pr @ H4 ) )
     => ( ( abs_assn @ P )
        = Pr ) ) ).

% Abs_assn_eqI(1)
thf(fact_130_ex__distrib__and,axiom,
    ! [A: $tType,P: A > assn,Q: assn] :
      ( ( ex_assn @ A
        @ ^ [X2: A] : ( inf_inf @ assn @ ( P @ X2 ) @ Q ) )
      = ( inf_inf @ assn @ ( ex_assn @ A @ P ) @ Q ) ) ).

% ex_distrib_and
thf(fact_131_inf__top__left,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X3: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ X3 )
          = X3 ) ) ).

% inf_top_left
thf(fact_132_inf__top__right,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X3: A] :
          ( ( inf_inf @ A @ X3 @ ( top_top @ A ) )
          = X3 ) ) ).

% inf_top_right
thf(fact_133_inf__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X3: A,Y: A] :
          ( ( ( inf_inf @ A @ X3 @ Y )
            = ( top_top @ A ) )
          = ( ( X3
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% inf_eq_top_iff
thf(fact_134_top__eq__inf__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X3: A,Y: A] :
          ( ( ( top_top @ A )
            = ( inf_inf @ A @ X3 @ Y ) )
          = ( ( X3
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% top_eq_inf_iff
thf(fact_135_inf__top_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A4: A,B3: A] :
          ( ( ( inf_inf @ A @ A4 @ B3 )
            = ( top_top @ A ) )
          = ( ( A4
              = ( top_top @ A ) )
            & ( B3
              = ( top_top @ A ) ) ) ) ) ).

% inf_top.eq_neutr_iff
thf(fact_136_inf__top_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A4: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ A4 )
          = A4 ) ) ).

% inf_top.left_neutral
thf(fact_137_inf__top_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A4: A,B3: A] :
          ( ( ( top_top @ A )
            = ( inf_inf @ A @ A4 @ B3 ) )
          = ( ( A4
              = ( top_top @ A ) )
            & ( B3
              = ( top_top @ A ) ) ) ) ) ).

% inf_top.neutr_eq_iff
thf(fact_138_inf__top_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A4: A] :
          ( ( inf_inf @ A @ A4 @ ( top_top @ A ) )
          = A4 ) ) ).

% inf_top.right_neutral
thf(fact_139_boolean__algebra_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A] :
          ( ( inf_inf @ A @ X3 @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_zero_right
thf(fact_140_boolean__algebra_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X3 )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_zero_left
thf(fact_141_inf__bot__right,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A )
     => ! [X3: A] :
          ( ( inf_inf @ A @ X3 @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% inf_bot_right
thf(fact_142_inf__bot__left,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A )
     => ! [X3: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X3 )
          = ( bot_bot @ A ) ) ) ).

% inf_bot_left
thf(fact_143_inf_Oidem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A] :
          ( ( inf_inf @ A @ A4 @ A4 )
          = A4 ) ) ).

% inf.idem
thf(fact_144_inf__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A] :
          ( ( inf_inf @ A @ X3 @ X3 )
          = X3 ) ) ).

% inf_idem
thf(fact_145_inf_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A] :
          ( ( inf_inf @ A @ A4 @ ( inf_inf @ A @ A4 @ B3 ) )
          = ( inf_inf @ A @ A4 @ B3 ) ) ) ).

% inf.left_idem
thf(fact_146_inf__left__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y: A] :
          ( ( inf_inf @ A @ X3 @ ( inf_inf @ A @ X3 @ Y ) )
          = ( inf_inf @ A @ X3 @ Y ) ) ) ).

% inf_left_idem
thf(fact_147_inf_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A4 @ B3 ) @ B3 )
          = ( inf_inf @ A @ A4 @ B3 ) ) ) ).

% inf.right_idem
thf(fact_148_inf__right__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X3 @ Y ) @ Y )
          = ( inf_inf @ A @ X3 @ Y ) ) ) ).

% inf_right_idem
thf(fact_149_inf__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( inf_inf @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% inf_apply
thf(fact_150_inf__sup__aci_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A] :
          ( ( inf_inf @ A @ X3 @ ( inf_inf @ A @ X3 @ Y ) )
          = ( inf_inf @ A @ X3 @ Y ) ) ) ).

% inf_sup_aci(4)
thf(fact_151_inf__sup__aci_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X3 @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X3 @ Z2 ) ) ) ) ).

% inf_sup_aci(3)
thf(fact_152_inf__sup__aci_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X3 @ Y ) @ Z2 )
          = ( inf_inf @ A @ X3 @ ( inf_inf @ A @ Y @ Z2 ) ) ) ) ).

% inf_sup_aci(2)
thf(fact_153_inf__sup__aci_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ( ( inf_inf @ A )
        = ( ^ [X2: A,Y2: A] : ( inf_inf @ A @ Y2 @ X2 ) ) ) ) ).

% inf_sup_aci(1)
thf(fact_154_inf_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A4 @ B3 ) @ C2 )
          = ( inf_inf @ A @ A4 @ ( inf_inf @ A @ B3 @ C2 ) ) ) ) ).

% inf.assoc
thf(fact_155_inf__assoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X3 @ Y ) @ Z2 )
          = ( inf_inf @ A @ X3 @ ( inf_inf @ A @ Y @ Z2 ) ) ) ) ).

% inf_assoc
thf(fact_156_inf_Ocommute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( inf_inf @ A )
        = ( ^ [A5: A,B4: A] : ( inf_inf @ A @ B4 @ A5 ) ) ) ) ).

% inf.commute
thf(fact_157_inf__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( inf_inf @ A )
        = ( ^ [X2: A,Y2: A] : ( inf_inf @ A @ Y2 @ X2 ) ) ) ) ).

% inf_commute
thf(fact_158_boolean__algebra__cancel_Oinf1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,K: A,A4: A,B3: A] :
          ( ( A3
            = ( inf_inf @ A @ K @ A4 ) )
         => ( ( inf_inf @ A @ A3 @ B3 )
            = ( inf_inf @ A @ K @ ( inf_inf @ A @ A4 @ B3 ) ) ) ) ) ).

% boolean_algebra_cancel.inf1
thf(fact_159_boolean__algebra__cancel_Oinf2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,K: A,B3: A,A4: A] :
          ( ( B2
            = ( inf_inf @ A @ K @ B3 ) )
         => ( ( inf_inf @ A @ A4 @ B2 )
            = ( inf_inf @ A @ K @ ( inf_inf @ A @ A4 @ B3 ) ) ) ) ) ).

% boolean_algebra_cancel.inf2
thf(fact_160_inf_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( inf_inf @ A @ B3 @ ( inf_inf @ A @ A4 @ C2 ) )
          = ( inf_inf @ A @ A4 @ ( inf_inf @ A @ B3 @ C2 ) ) ) ) ).

% inf.left_commute
thf(fact_161_inf__left__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X3 @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X3 @ Z2 ) ) ) ) ).

% inf_left_commute
thf(fact_162_inf__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( inf_inf @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% inf_fun_def
thf(fact_163_boolean__algebra_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A] :
          ( ( inf_inf @ A @ X3 @ ( top_top @ A ) )
          = X3 ) ) ).

% boolean_algebra.conj_one_right
thf(fact_164_inf__top_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( comm_monoid @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.comm_monoid_axioms
thf(fact_165_inf__top_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( monoid @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.monoid_axioms
thf(fact_166_sngr__same__false,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P5: ref @ A,X3: A,Y: A] :
          ( ( times_times @ assn @ ( sngr_assn @ A @ P5 @ X3 ) @ ( sngr_assn @ A @ P5 @ Y ) )
          = ( bot_bot @ assn ) ) ) ).

% sngr_same_false
thf(fact_167_snga__same__false,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P5: array @ A,X3: list @ A,Y: list @ A] :
          ( ( times_times @ assn @ ( snga_assn @ A @ P5 @ X3 ) @ ( snga_assn @ A @ P5 @ Y ) )
          = ( bot_bot @ assn ) ) ) ).

% snga_same_false
thf(fact_168_times__assn__def,axiom,
    ( ( times_times @ assn )
    = ( ^ [P3: assn,Q3: assn] : ( abs_assn @ ( times_assn_raw @ ( rep_assn @ P3 ) @ ( rep_assn @ Q3 ) ) ) ) ) ).

% times_assn_def
thf(fact_169_one__assn__def,axiom,
    ( ( one_one @ assn )
    = ( abs_assn @ one_assn_raw ) ) ).

% one_assn_def
thf(fact_170_pure__assn__def,axiom,
    ( pure_assn
    = ( ^ [B4: $o] : ( abs_assn @ ( pure_assn_raw @ ( heap_ext @ product_unit ) @ nat @ B4 ) ) ) ) ).

% pure_assn_def
thf(fact_171_uminus__assn__def,axiom,
    ( ( uminus_uminus @ assn )
    = ( ^ [P3: assn] :
          ( abs_assn
          @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( in_range @ H )
              & ~ ( rep_assn @ P3 @ H ) ) ) ) ) ).

% uminus_assn_def
thf(fact_172_ex__assn__def,axiom,
    ! [A: $tType] :
      ( ( ex_assn @ A )
      = ( ^ [P3: A > assn] :
            ( abs_assn
            @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ? [X2: A] : ( rep_assn @ ( P3 @ X2 ) @ H ) ) ) ) ).

% ex_assn_def
thf(fact_173_prod__list_Ocomm__monoid__list__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( groups1828464146339083142d_list @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod_list.comm_monoid_list_axioms
thf(fact_174_mod__h__bot__iff_I8_J,axiom,
    ! [C: $tType,R: C > assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( ex_assn @ C @ R ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ? [X2: C] : ( rep_assn @ ( R @ X2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(8)
thf(fact_175_monoid_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( monoid @ A @ F2 @ Z2 )
     => ( monoid_axioms @ A @ F2 @ Z2 ) ) ).

% monoid.axioms(2)
thf(fact_176_prod__list_Omonoid__list__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( groups_monoid_list @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod_list.monoid_list_axioms
thf(fact_177_comm__monoid_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( comm_monoid @ A @ F2 @ Z2 )
     => ( comm_monoid_axioms @ A @ F2 @ Z2 ) ) ).

% comm_monoid.axioms(2)
thf(fact_178_boolean__algebra__class_Oboolean__algebra_Odouble__compl,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ X3 ) )
          = X3 ) ) ).

% boolean_algebra_class.boolean_algebra.double_compl
thf(fact_179_boolean__algebra__class_Oboolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( ( uminus_uminus @ A @ X3 )
            = ( uminus_uminus @ A @ Y ) )
          = ( X3 = Y ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_eq_compl_iff
thf(fact_180_uminus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A6: A > B,X2: A] : ( uminus_uminus @ B @ ( A6 @ X2 ) ) ) ) ) ).

% uminus_apply
thf(fact_181_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A4 ) )
          = A4 ) ) ).

% add.inverse_inverse
thf(fact_182_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ( uminus_uminus @ A @ A4 )
            = ( uminus_uminus @ A @ B3 ) )
          = ( A4 = B3 ) ) ) ).

% neg_equal_iff_equal
thf(fact_183_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A4: A,B3: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A4 ) @ B3 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A4 @ B3 ) ) ) ) ).

% mult_minus_left
thf(fact_184_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A4: A,B3: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A4 ) @ ( uminus_uminus @ A @ B3 ) )
          = ( times_times @ A @ A4 @ B3 ) ) ) ).

% minus_mult_minus
thf(fact_185_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A4: A,B3: A] :
          ( ( times_times @ A @ A4 @ ( uminus_uminus @ A @ B3 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A4 @ B3 ) ) ) ) ).

% mult_minus_right
thf(fact_186_boolean__algebra_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( ( uminus_uminus @ A @ ( top_top @ A ) )
        = ( bot_bot @ A ) ) ) ).

% boolean_algebra.compl_one
thf(fact_187_boolean__algebra_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( ( uminus_uminus @ A @ ( bot_bot @ A ) )
        = ( top_top @ A ) ) ) ).

% boolean_algebra.compl_zero
thf(fact_188_boolean__algebra_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A] :
          ( ( inf_inf @ A @ X3 @ ( uminus_uminus @ A @ X3 ) )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_cancel_right
thf(fact_189_boolean__algebra_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A] :
          ( ( inf_inf @ A @ ( uminus_uminus @ A @ X3 ) @ X3 )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_cancel_left
thf(fact_190_inf__compl__bot__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( inf_inf @ A @ X3 @ ( inf_inf @ A @ Y @ ( uminus_uminus @ A @ X3 ) ) )
          = ( bot_bot @ A ) ) ) ).

% inf_compl_bot_right
thf(fact_191_inf__compl__bot__left2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( inf_inf @ A @ X3 @ ( inf_inf @ A @ ( uminus_uminus @ A @ X3 ) @ Y ) )
          = ( bot_bot @ A ) ) ) ).

% inf_compl_bot_left2
thf(fact_192_inf__compl__bot__left1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( inf_inf @ A @ ( uminus_uminus @ A @ X3 ) @ ( inf_inf @ A @ X3 @ Y ) )
          = ( bot_bot @ A ) ) ) ).

% inf_compl_bot_left1
thf(fact_193_in__range__empty,axiom,
    ! [H2: heap_ext @ product_unit] : ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% in_range_empty
thf(fact_194_mod__not__dist,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( uminus_uminus @ assn @ P ) @ H2 )
      = ( ( in_range @ H2 )
        & ~ ( rep_assn @ P @ H2 ) ) ) ).

% mod_not_dist
thf(fact_195_mod__h__bot__iff_I5_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( times_times @ assn @ P @ Q ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        & ( rep_assn @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(5)
thf(fact_196_mod__h__bot__iff_I1_J,axiom,
    ! [B3: $o,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( pure_assn @ B3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = B3 ) ).

% mod_h_bot_iff(1)
thf(fact_197_mod__h__bot__iff_I6_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( inf_inf @ assn @ P @ Q ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        & ( rep_assn @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(6)
thf(fact_198_mod__h__bot__iff_I4_J,axiom,
    ! [B: $tType] :
      ( ( heap @ B )
     => ! [Q4: array @ B,Y: list @ B,H2: heap_ext @ product_unit] :
          ~ ( rep_assn @ ( snga_assn @ B @ Q4 @ Y ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% mod_h_bot_iff(4)
thf(fact_199_mod__h__bot__iff_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P5: ref @ A,X3: A,H2: heap_ext @ product_unit] :
          ~ ( rep_assn @ ( sngr_assn @ A @ P5 @ X3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% mod_h_bot_iff(3)
thf(fact_200_one__assn__raw_Oelims_I3_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( one_assn_raw @ X3 )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( X3
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ( As
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% one_assn_raw.elims(3)
thf(fact_201_one__assn__raw_Oelims_I2_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( one_assn_raw @ X3 )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( X3
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ( As
             != ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% one_assn_raw.elims(2)
thf(fact_202_one__assn__raw_Oelims_I1_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( one_assn_raw @ X3 )
        = Y )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( X3
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ( Y
              = ( ( As
                 != ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% one_assn_raw.elims(1)
thf(fact_203_pure__assn__raw_Oelims_I3_J,axiom,
    ! [B: $tType,A: $tType,X3: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ~ ( pure_assn_raw @ A @ B @ X3 @ Xa )
     => ~ ! [H4: A,As: set @ B] :
            ( ( Xa
              = ( product_Pair @ A @ ( set @ B ) @ H4 @ As ) )
           => ( ( As
                = ( bot_bot @ ( set @ B ) ) )
              & X3 ) ) ) ).

% pure_assn_raw.elims(3)
thf(fact_204_pure__assn__raw_Oelims_I2_J,axiom,
    ! [B: $tType,A: $tType,X3: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ( pure_assn_raw @ A @ B @ X3 @ Xa )
     => ~ ! [H4: A,As: set @ B] :
            ( ( Xa
              = ( product_Pair @ A @ ( set @ B ) @ H4 @ As ) )
           => ~ ( ( As
                  = ( bot_bot @ ( set @ B ) ) )
                & X3 ) ) ) ).

% pure_assn_raw.elims(2)
thf(fact_205_pure__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType,B: $tType,X3: $o,Xa: product_prod @ A @ ( set @ B ),Y: $o] :
      ( ( ( pure_assn_raw @ A @ B @ X3 @ Xa )
        = Y )
     => ~ ! [H4: A,As: set @ B] :
            ( ( Xa
              = ( product_Pair @ A @ ( set @ B ) @ H4 @ As ) )
           => ( Y
              = ( ~ ( ( As
                      = ( bot_bot @ ( set @ B ) ) )
                    & X3 ) ) ) ) ) ).

% pure_assn_raw.elims(1)
thf(fact_206_one__assn__raw_Osimps,axiom,
    ! [H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( one_assn_raw @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
      = ( As2
        = ( bot_bot @ ( set @ nat ) ) ) ) ).

% one_assn_raw.simps
thf(fact_207_pure__assn__raw_Osimps,axiom,
    ! [A: $tType,B: $tType,B3: $o,H2: A,As2: set @ B] :
      ( ( pure_assn_raw @ A @ B @ B3 @ ( product_Pair @ A @ ( set @ B ) @ H2 @ As2 ) )
      = ( ( As2
          = ( bot_bot @ ( set @ B ) ) )
        & B3 ) ) ).

% pure_assn_raw.simps
thf(fact_208_fun__Compl__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A6: A > B,X2: A] : ( uminus_uminus @ B @ ( A6 @ X2 ) ) ) ) ) ).

% fun_Compl_def
thf(fact_209_one__assn__raw_Ocases,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
          ( X3
         != ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ).

% one_assn_raw.cases
thf(fact_210_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
            = ( uminus_uminus @ A @ B3 ) )
          = ( B3
            = ( uminus_uminus @ A @ A4 ) ) ) ) ).

% equation_minus_iff
thf(fact_211_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ( uminus_uminus @ A @ A4 )
            = B3 )
          = ( ( uminus_uminus @ A @ B3 )
            = A4 ) ) ) ).

% minus_equation_iff
thf(fact_212_comm__monoid__list_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( groups1828464146339083142d_list @ A @ F2 @ Z2 )
     => ( groups_monoid_list @ A @ F2 @ Z2 ) ) ).

% comm_monoid_list.axioms(2)
thf(fact_213_comm__monoid__axioms__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_axioms @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
          ! [A5: A] :
            ( ( F3 @ A5 @ Z3 )
            = A5 ) ) ) ).

% comm_monoid_axioms_def
thf(fact_214_monoid__axioms__def,axiom,
    ! [A: $tType] :
      ( ( monoid_axioms @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
            ( ! [A5: A] :
                ( ( F3 @ Z3 @ A5 )
                = A5 )
            & ! [A5: A] :
                ( ( F3 @ A5 @ Z3 )
                = A5 ) ) ) ) ).

% monoid_axioms_def
thf(fact_215_comm__monoid__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ! [A7: A] :
          ( ( F2 @ A7 @ Z2 )
          = A7 )
     => ( comm_monoid_axioms @ A @ F2 @ Z2 ) ) ).

% comm_monoid_axioms.intro
thf(fact_216_monoid__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ! [A7: A] :
          ( ( F2 @ Z2 @ A7 )
          = A7 )
     => ( ! [A7: A] :
            ( ( F2 @ A7 @ Z2 )
            = A7 )
       => ( monoid_axioms @ A @ F2 @ Z2 ) ) ) ).

% monoid_axioms.intro
thf(fact_217_comm__monoid__list__def,axiom,
    ! [A: $tType] :
      ( ( groups1828464146339083142d_list @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
            ( ( comm_monoid @ A @ F3 @ Z3 )
            & ( groups_monoid_list @ A @ F3 @ Z3 ) ) ) ) ).

% comm_monoid_list_def
thf(fact_218_comm__monoid__list_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( comm_monoid @ A @ F2 @ Z2 )
     => ( ( groups_monoid_list @ A @ F2 @ Z2 )
       => ( groups1828464146339083142d_list @ A @ F2 @ Z2 ) ) ) ).

% comm_monoid_list.intro
thf(fact_219_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A4: A,B3: A] :
          ( ( ( times_times @ A @ A4 @ A4 )
            = ( times_times @ A @ B3 @ B3 ) )
          = ( ( A4 = B3 )
            | ( A4
              = ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% square_eq_iff
thf(fact_220_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A4: A,B3: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A4 ) @ B3 )
          = ( times_times @ A @ A4 @ ( uminus_uminus @ A @ B3 ) ) ) ) ).

% minus_mult_commute
thf(fact_221_mod__h__bot__indep,axiom,
    ! [P: assn,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% mod_h_bot_indep
thf(fact_222_sngr__prec,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( precise @ A @ ( ref @ A )
        @ ^ [X2: A,P6: ref @ A] : ( sngr_assn @ A @ P6 @ X2 ) ) ) ).

% sngr_prec
thf(fact_223_snga__prec,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( precise @ ( list @ A ) @ ( array @ A )
        @ ^ [X2: list @ A,P6: array @ A] : ( snga_assn @ A @ P6 @ X2 ) ) ) ).

% snga_prec
thf(fact_224_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X3: A] :
          ( ( ( times_times @ A @ X3 @ X3 )
            = ( one_one @ A ) )
          = ( ( X3
              = ( one_one @ A ) )
            | ( X3
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_225_inf__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,A4: A,B3: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ ( uminus_uminus @ A @ X3 ) @ A4 ) @ ( inf_inf @ A @ X3 @ B3 ) )
          = ( bot_bot @ A ) ) ) ).

% inf_cancel_left2
thf(fact_226_inf__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,A4: A,B3: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X3 @ A4 ) @ ( inf_inf @ A @ ( uminus_uminus @ A @ X3 ) @ B3 ) )
          = ( bot_bot @ A ) ) ) ).

% inf_cancel_left1
thf(fact_227_monoid__list__def,axiom,
    ! [A: $tType] :
      ( ( groups_monoid_list @ A )
      = ( monoid @ A ) ) ).

% monoid_list_def
thf(fact_228_monoid__list_Oaxioms,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( groups_monoid_list @ A @ F2 @ Z2 )
     => ( monoid @ A @ F2 @ Z2 ) ) ).

% monoid_list.axioms
thf(fact_229_monoid__list_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( monoid @ A @ F2 @ Z2 )
     => ( groups_monoid_list @ A @ F2 @ Z2 ) ) ).

% monoid_list.intro
thf(fact_230_comm__monoid__list_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( groups1828464146339083142d_list @ A @ F2 @ Z2 )
     => ( comm_monoid @ A @ F2 @ Z2 ) ) ).

% comm_monoid_list.axioms(1)
thf(fact_231_mod__h__bot__iff_I2_J,axiom,
    ! [H2: heap_ext @ product_unit] : ( rep_assn @ ( top_top @ assn ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% mod_h_bot_iff(2)
thf(fact_232_mod__emp__simp,axiom,
    ! [H2: heap_ext @ product_unit] : ( rep_assn @ ( one_one @ assn ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% mod_emp_simp
thf(fact_233_comm__monoid__list__set_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( groups4802862169904069756st_set @ A @ F2 @ Z2 )
     => ( groups1828464146339083142d_list @ A @ F2 @ Z2 ) ) ).

% comm_monoid_list_set.axioms(1)
thf(fact_234_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z2 )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1
thf(fact_235_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1_right
thf(fact_236_Collect__const,axiom,
    ! [A: $tType,P: $o] :
      ( ( P
       => ( ( collect @ A
            @ ^ [S: A] : P )
          = ( top_top @ ( set @ A ) ) ) )
      & ( ~ P
       => ( ( collect @ A
            @ ^ [S: A] : P )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Collect_const
thf(fact_237_empty__Collect__eq,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X2: A] :
            ~ ( P @ X2 ) ) ) ).

% empty_Collect_eq
thf(fact_238_Collect__empty__eq,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ~ ( P @ X2 ) ) ) ).

% Collect_empty_eq
thf(fact_239_all__not__in__conv,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ! [X2: A] :
            ~ ( member @ A @ X2 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% all_not_in_conv
thf(fact_240_empty__iff,axiom,
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) ).

% empty_iff
thf(fact_241_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_242_snga__assn__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( snga_assn @ A )
        = ( ^ [R3: array @ A,A5: list @ A] : ( abs_assn @ ( snga_assn_raw @ A @ R3 @ A5 ) ) ) ) ) ).

% snga_assn_def
thf(fact_243_sngr__assn__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( sngr_assn @ A )
        = ( ^ [R3: ref @ A,X2: A] : ( abs_assn @ ( sngr_assn_raw @ A @ R3 @ X2 ) ) ) ) ) ).

% sngr_assn_def
thf(fact_244_Set_Oempty__def,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X2: A] : $false ) ) ).

% Set.empty_def
thf(fact_245_Compl__disjoint,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Compl_disjoint
thf(fact_246_Compl__disjoint2,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Compl_disjoint2
thf(fact_247_Int__UNIV,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( top_top @ ( set @ A ) ) )
      = ( ( A3
          = ( top_top @ ( set @ A ) ) )
        & ( B2
          = ( top_top @ ( set @ A ) ) ) ) ) ).

% Int_UNIV
thf(fact_248_Int__UNIV__left,axiom,
    ! [A: $tType,B2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B2 )
      = B2 ) ).

% Int_UNIV_left
thf(fact_249_Int__UNIV__right,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) )
      = A3 ) ).

% Int_UNIV_right
thf(fact_250_Compl__empty__eq,axiom,
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) ).

% Compl_empty_eq
thf(fact_251_Compl__UNIV__eq,axiom,
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Compl_UNIV_eq
thf(fact_252_emptyE,axiom,
    ! [A: $tType,A4: A] :
      ~ ( member @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ).

% emptyE
thf(fact_253_equals0D,axiom,
    ! [A: $tType,A3: set @ A,A4: A] :
      ( ( A3
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A4 @ A3 ) ) ).

% equals0D
thf(fact_254_equals0I,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ! [Y3: A] :
          ~ ( member @ A @ Y3 @ A3 )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% equals0I
thf(fact_255_Int__emptyI,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ! [X: A] :
          ( ( member @ A @ X @ A3 )
         => ~ ( member @ A @ X @ B2 ) )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% Int_emptyI
thf(fact_256_ex__in__conv,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ? [X2: A] : ( member @ A @ X2 @ A3 ) )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% ex_in_conv
thf(fact_257_bot__set__def,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) ).

% bot_set_def
thf(fact_258_disjoint__iff,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ A3 )
           => ~ ( member @ A @ X2 @ B2 ) ) ) ) ).

% disjoint_iff
thf(fact_259_Int__empty__left,axiom,
    ! [A: $tType,B2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B2 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_empty_left
thf(fact_260_Int__empty__right,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_empty_right
thf(fact_261_disjoint__iff__not__equal,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ A3 )
           => ! [Y2: A] :
                ( ( member @ A @ Y2 @ B2 )
               => ( X2 != Y2 ) ) ) ) ) ).

% disjoint_iff_not_equal
thf(fact_262_empty__not__UNIV,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
     != ( top_top @ ( set @ A ) ) ) ).

% empty_not_UNIV
thf(fact_263_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_264_Set_Ois__empty__def,axiom,
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A6: set @ A] :
            ( A6
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Set.is_empty_def
thf(fact_265_pred__equals__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R ) )
        = ( ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ S2 ) ) )
      = ( R = S2 ) ) ).

% pred_equals_eq2
thf(fact_266_top__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( top_top @ ( A > B > $o ) )
      = ( ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% top_empty_eq2
thf(fact_267_inf__Int__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( inf_inf @ ( A > B > $o )
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R )
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ S2 ) )
      = ( ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ) ) ).

% inf_Int_eq2
thf(fact_268_bot__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot_bot @ ( A > B > $o ) )
      = ( ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% bot_empty_eq2
thf(fact_269_hoare__triple__success,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( hoare_hoare_triple @ A @ P @ C2 @ Q )
     => ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
       => ( heap_Time_success @ A @ C2 @ H2 ) ) ) ).

% hoare_triple_success
thf(fact_270_mod__star__conv,axiom,
    ! [A3: assn,B2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ A3 @ B2 ) @ H2 )
      = ( ? [Hr: heap_ext @ product_unit,As1: set @ nat,As22: set @ nat] :
            ( ( H2
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ Hr @ ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) ) )
            & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
              = ( bot_bot @ ( set @ nat ) ) )
            & ( rep_assn @ A3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ Hr @ As1 ) )
            & ( rep_assn @ B2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ Hr @ As22 ) ) ) ) ) ).

% mod_star_conv
thf(fact_271_star__assnI,axiom,
    ! [P: assn,H2: heap_ext @ product_unit,As2: set @ nat,Q: assn,As3: set @ nat] :
      ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
     => ( ( rep_assn @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As3 ) )
       => ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As3 )
            = ( bot_bot @ ( set @ nat ) ) )
         => ( rep_assn @ ( times_times @ assn @ P @ Q ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( sup_sup @ ( set @ nat ) @ As2 @ As3 ) ) ) ) ) ) ).

% star_assnI
thf(fact_272_mod__pure,axiom,
    ! [B3: $o,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( pure_assn @ B3 ) @ H2 )
      = ( ( ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 )
          = ( bot_bot @ ( set @ nat ) ) )
        & B3 ) ) ).

% mod_pure
thf(fact_273_mod__h__bot__iff_I7_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( sup_sup @ assn @ P @ Q ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        | ( rep_assn @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(7)
thf(fact_274_sup_Oidem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A] :
          ( ( sup_sup @ A @ A4 @ A4 )
          = A4 ) ) ).

% sup.idem
thf(fact_275_sup__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A] :
          ( ( sup_sup @ A @ X3 @ X3 )
          = X3 ) ) ).

% sup_idem
thf(fact_276_sup_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A,B3: A] :
          ( ( sup_sup @ A @ A4 @ ( sup_sup @ A @ A4 @ B3 ) )
          = ( sup_sup @ A @ A4 @ B3 ) ) ) ).

% sup.left_idem
thf(fact_277_sup__left__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,Y: A] :
          ( ( sup_sup @ A @ X3 @ ( sup_sup @ A @ X3 @ Y ) )
          = ( sup_sup @ A @ X3 @ Y ) ) ) ).

% sup_left_idem
thf(fact_278_sup_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A,B3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A4 @ B3 ) @ B3 )
          = ( sup_sup @ A @ A4 @ B3 ) ) ) ).

% sup.right_idem
thf(fact_279_sup__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( sup_sup @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% sup_apply
thf(fact_280_Int__iff,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B2: set @ A] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
      = ( ( member @ A @ C2 @ A3 )
        & ( member @ A @ C2 @ B2 ) ) ) ).

% Int_iff
thf(fact_281_IntI,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B2: set @ A] :
      ( ( member @ A @ C2 @ A3 )
     => ( ( member @ A @ C2 @ B2 )
       => ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% IntI
thf(fact_282_inf2I,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o,X3: A,Y: B,B2: A > B > $o] :
      ( ( A3 @ X3 @ Y )
     => ( ( B2 @ X3 @ Y )
       => ( inf_inf @ ( A > B > $o ) @ A3 @ B2 @ X3 @ Y ) ) ) ).

% inf2I
thf(fact_283_sup__bot_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A4: A] :
          ( ( sup_sup @ A @ A4 @ ( bot_bot @ A ) )
          = A4 ) ) ).

% sup_bot.right_neutral
thf(fact_284_sup__bot_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A4: A,B3: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ A4 @ B3 ) )
          = ( ( A4
              = ( bot_bot @ A ) )
            & ( B3
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_bot.neutr_eq_iff
thf(fact_285_sup__bot_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A4: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A4 )
          = A4 ) ) ).

% sup_bot.left_neutral
thf(fact_286_sup__bot_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A4: A,B3: A] :
          ( ( ( sup_sup @ A @ A4 @ B3 )
            = ( bot_bot @ A ) )
          = ( ( A4
              = ( bot_bot @ A ) )
            & ( B3
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_bot.eq_neutr_iff
thf(fact_287_sup__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X3: A,Y: A] :
          ( ( ( sup_sup @ A @ X3 @ Y )
            = ( bot_bot @ A ) )
          = ( ( X3
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_eq_bot_iff
thf(fact_288_bot__eq__sup__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X3: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X3 @ Y ) )
          = ( ( X3
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) ).

% bot_eq_sup_iff
thf(fact_289_sup__bot__right,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X3: A] :
          ( ( sup_sup @ A @ X3 @ ( bot_bot @ A ) )
          = X3 ) ) ).

% sup_bot_right
thf(fact_290_sup__bot__left,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X3: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ X3 )
          = X3 ) ) ).

% sup_bot_left
thf(fact_291_sup__top__left,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A )
     => ! [X3: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X3 )
          = ( top_top @ A ) ) ) ).

% sup_top_left
thf(fact_292_sup__top__right,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A )
     => ! [X3: A] :
          ( ( sup_sup @ A @ X3 @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% sup_top_right
thf(fact_293_boolean__algebra_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X3 )
          = ( top_top @ A ) ) ) ).

% boolean_algebra.disj_one_left
thf(fact_294_boolean__algebra_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A] :
          ( ( sup_sup @ A @ X3 @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% boolean_algebra.disj_one_right
thf(fact_295_sup__inf__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A] :
          ( ( sup_sup @ A @ X3 @ ( inf_inf @ A @ X3 @ Y ) )
          = X3 ) ) ).

% sup_inf_absorb
thf(fact_296_inf__sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A] :
          ( ( inf_inf @ A @ X3 @ ( sup_sup @ A @ X3 @ Y ) )
          = X3 ) ) ).

% inf_sup_absorb
thf(fact_297_Un__empty,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        & ( B2
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Un_empty
thf(fact_298_Un__Int__eq_I1_J,axiom,
    ! [A: $tType,S2: set @ A,T2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ S2 @ T2 ) @ S2 )
      = S2 ) ).

% Un_Int_eq(1)
thf(fact_299_Un__Int__eq_I2_J,axiom,
    ! [A: $tType,S2: set @ A,T2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ S2 @ T2 ) @ T2 )
      = T2 ) ).

% Un_Int_eq(2)
thf(fact_300_Un__Int__eq_I3_J,axiom,
    ! [A: $tType,S2: set @ A,T2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ S2 @ ( sup_sup @ ( set @ A ) @ S2 @ T2 ) )
      = S2 ) ).

% Un_Int_eq(3)
thf(fact_301_Un__Int__eq_I4_J,axiom,
    ! [A: $tType,T2: set @ A,S2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ T2 @ ( sup_sup @ ( set @ A ) @ S2 @ T2 ) )
      = T2 ) ).

% Un_Int_eq(4)
thf(fact_302_Int__Un__eq_I1_J,axiom,
    ! [A: $tType,S2: set @ A,T2: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ S2 @ T2 ) @ S2 )
      = S2 ) ).

% Int_Un_eq(1)
thf(fact_303_Int__Un__eq_I2_J,axiom,
    ! [A: $tType,S2: set @ A,T2: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ S2 @ T2 ) @ T2 )
      = T2 ) ).

% Int_Un_eq(2)
thf(fact_304_Int__Un__eq_I3_J,axiom,
    ! [A: $tType,S2: set @ A,T2: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ S2 @ ( inf_inf @ ( set @ A ) @ S2 @ T2 ) )
      = S2 ) ).

% Int_Un_eq(3)
thf(fact_305_Int__Un__eq_I4_J,axiom,
    ! [A: $tType,T2: set @ A,S2: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ T2 @ ( inf_inf @ ( set @ A ) @ S2 @ T2 ) )
      = T2 ) ).

% Int_Un_eq(4)
thf(fact_306_mod__or__dist,axiom,
    ! [P: assn,Q: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( sup_sup @ assn @ P @ Q ) @ H2 )
      = ( ( rep_assn @ P @ H2 )
        | ( rep_assn @ Q @ H2 ) ) ) ).

% mod_or_dist
thf(fact_307_merge__pure__or,axiom,
    ! [A4: $o,B3: $o] :
      ( ( sup_sup @ assn @ ( pure_assn @ A4 ) @ ( pure_assn @ B3 ) )
      = ( pure_assn
        @ ( A4
          | B3 ) ) ) ).

% merge_pure_or
thf(fact_308_sup__compl__top__left1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( sup_sup @ A @ ( uminus_uminus @ A @ X3 ) @ ( sup_sup @ A @ X3 @ Y ) )
          = ( top_top @ A ) ) ) ).

% sup_compl_top_left1
thf(fact_309_sup__compl__top__left2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( sup_sup @ A @ X3 @ ( sup_sup @ A @ ( uminus_uminus @ A @ X3 ) @ Y ) )
          = ( top_top @ A ) ) ) ).

% sup_compl_top_left2
thf(fact_310_boolean__algebra_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A] :
          ( ( sup_sup @ A @ ( uminus_uminus @ A @ X3 ) @ X3 )
          = ( top_top @ A ) ) ) ).

% boolean_algebra.disj_cancel_left
thf(fact_311_boolean__algebra_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A] :
          ( ( sup_sup @ A @ X3 @ ( uminus_uminus @ A @ X3 ) )
          = ( top_top @ A ) ) ) ).

% boolean_algebra.disj_cancel_right
thf(fact_312_boolean__algebra_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( uminus_uminus @ A @ ( inf_inf @ A @ X3 @ Y ) )
          = ( sup_sup @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% boolean_algebra.de_Morgan_conj
thf(fact_313_boolean__algebra_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( uminus_uminus @ A @ ( sup_sup @ A @ X3 @ Y ) )
          = ( inf_inf @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% boolean_algebra.de_Morgan_disj
thf(fact_314_in__range__dist__union,axiom,
    ! [H2: heap_ext @ product_unit,As2: set @ nat,As3: set @ nat] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( sup_sup @ ( set @ nat ) @ As2 @ As3 ) ) )
      = ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
        & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As3 ) ) ) ) ).

% in_range_dist_union
thf(fact_315_bot2E,axiom,
    ! [A: $tType,B: $tType,X3: A,Y: B] :
      ~ ( bot_bot @ ( A > B > $o ) @ X3 @ Y ) ).

% bot2E
thf(fact_316_Int__left__commute,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,C3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) )
      = ( inf_inf @ ( set @ A ) @ B2 @ ( inf_inf @ ( set @ A ) @ A3 @ C3 ) ) ) ).

% Int_left_commute
thf(fact_317_Un__Int__distrib2,axiom,
    ! [A: $tType,B2: set @ A,C3: set @ A,A3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) @ A3 )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B2 @ A3 ) @ ( sup_sup @ ( set @ A ) @ C3 @ A3 ) ) ) ).

% Un_Int_distrib2
thf(fact_318_Int__left__absorb,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ).

% Int_left_absorb
thf(fact_319_Int__Un__distrib2,axiom,
    ! [A: $tType,B2: set @ A,C3: set @ A,A3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) @ A3 )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B2 @ A3 ) @ ( inf_inf @ ( set @ A ) @ C3 @ A3 ) ) ) ).

% Int_Un_distrib2
thf(fact_320_Collect__conj__eq,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
            & ( Q @ X2 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) ).

% Collect_conj_eq
thf(fact_321_Un__Int__distrib,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,C3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) @ ( sup_sup @ ( set @ A ) @ A3 @ C3 ) ) ) ).

% Un_Int_distrib
thf(fact_322_Int__Un__distrib,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,C3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ ( inf_inf @ ( set @ A ) @ A3 @ C3 ) ) ) ).

% Int_Un_distrib
thf(fact_323_Un__Int__crazy,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,C3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) ) @ ( inf_inf @ ( set @ A ) @ C3 @ A3 ) )
      = ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) ) @ ( sup_sup @ ( set @ A ) @ C3 @ A3 ) ) ) ).

% Un_Int_crazy
thf(fact_324_inf__set__def,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A6: set @ A,B5: set @ A] :
            ( collect @ A
            @ ( inf_inf @ ( A > $o )
              @ ^ [X2: A] : ( member @ A @ X2 @ A6 )
              @ ^ [X2: A] : ( member @ A @ X2 @ B5 ) ) ) ) ) ).

% inf_set_def
thf(fact_325_Int__commute,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A6: set @ A,B5: set @ A] : ( inf_inf @ ( set @ A ) @ B5 @ A6 ) ) ) ).

% Int_commute
thf(fact_326_Int__Collect,axiom,
    ! [A: $tType,X3: A,A3: set @ A,P: A > $o] :
      ( ( member @ A @ X3 @ ( inf_inf @ ( set @ A ) @ A3 @ ( collect @ A @ P ) ) )
      = ( ( member @ A @ X3 @ A3 )
        & ( P @ X3 ) ) ) ).

% Int_Collect
thf(fact_327_Int__absorb,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ A3 )
      = A3 ) ).

% Int_absorb
thf(fact_328_Int__assoc,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,C3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ C3 )
      = ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) ) ) ).

% Int_assoc
thf(fact_329_Compl__Int,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
      = ( sup_sup @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( uminus_uminus @ ( set @ A ) @ B2 ) ) ) ).

% Compl_Int
thf(fact_330_Compl__Un,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( uminus_uminus @ ( set @ A ) @ B2 ) ) ) ).

% Compl_Un
thf(fact_331_Int__def,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A6: set @ A,B5: set @ A] :
            ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A6 )
                & ( member @ A @ X2 @ B5 ) ) ) ) ) ).

% Int_def
thf(fact_332_IntD2,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B2: set @ A] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
     => ( member @ A @ C2 @ B2 ) ) ).

% IntD2
thf(fact_333_IntD1,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B2: set @ A] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
     => ( member @ A @ C2 @ A3 ) ) ).

% IntD1
thf(fact_334_IntE,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B2: set @ A] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
     => ~ ( ( member @ A @ C2 @ A3 )
         => ~ ( member @ A @ C2 @ B2 ) ) ) ).

% IntE
thf(fact_335_uminus__set__def,axiom,
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( ^ [A6: set @ A] :
            ( collect @ A
            @ ( uminus_uminus @ ( A > $o )
              @ ^ [X2: A] : ( member @ A @ X2 @ A6 ) ) ) ) ) ).

% uminus_set_def
thf(fact_336_Collect__neg__eq,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ~ ( P @ X2 ) )
      = ( uminus_uminus @ ( set @ A ) @ ( collect @ A @ P ) ) ) ).

% Collect_neg_eq
thf(fact_337_Compl__eq,axiom,
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( ^ [A6: set @ A] :
            ( collect @ A
            @ ^ [X2: A] :
                ~ ( member @ A @ X2 @ A6 ) ) ) ) ).

% Compl_eq
thf(fact_338_inf__sup__aci_I8_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A] :
          ( ( sup_sup @ A @ X3 @ ( sup_sup @ A @ X3 @ Y ) )
          = ( sup_sup @ A @ X3 @ Y ) ) ) ).

% inf_sup_aci(8)
thf(fact_339_inf__sup__aci_I7_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X3 @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X3 @ Z2 ) ) ) ) ).

% inf_sup_aci(7)
thf(fact_340_inf__sup__aci_I6_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X3 @ Y ) @ Z2 )
          = ( sup_sup @ A @ X3 @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% inf_sup_aci(6)
thf(fact_341_inf__sup__aci_I5_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y2: A] : ( sup_sup @ A @ Y2 @ X2 ) ) ) ) ).

% inf_sup_aci(5)
thf(fact_342_sup_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A4 @ B3 ) @ C2 )
          = ( sup_sup @ A @ A4 @ ( sup_sup @ A @ B3 @ C2 ) ) ) ) ).

% sup.assoc
thf(fact_343_sup__assoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X3 @ Y ) @ Z2 )
          = ( sup_sup @ A @ X3 @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% sup_assoc
thf(fact_344_sup_Ocommute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( sup_sup @ A )
        = ( ^ [A5: A,B4: A] : ( sup_sup @ A @ B4 @ A5 ) ) ) ) ).

% sup.commute
thf(fact_345_sup__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y2: A] : ( sup_sup @ A @ Y2 @ X2 ) ) ) ) ).

% sup_commute
thf(fact_346_boolean__algebra__cancel_Osup1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,K: A,A4: A,B3: A] :
          ( ( A3
            = ( sup_sup @ A @ K @ A4 ) )
         => ( ( sup_sup @ A @ A3 @ B3 )
            = ( sup_sup @ A @ K @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ) ).

% boolean_algebra_cancel.sup1
thf(fact_347_boolean__algebra__cancel_Osup2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,K: A,B3: A,A4: A] :
          ( ( B2
            = ( sup_sup @ A @ K @ B3 ) )
         => ( ( sup_sup @ A @ A4 @ B2 )
            = ( sup_sup @ A @ K @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ) ).

% boolean_algebra_cancel.sup2
thf(fact_348_sup_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( sup_sup @ A @ B3 @ ( sup_sup @ A @ A4 @ C2 ) )
          = ( sup_sup @ A @ A4 @ ( sup_sup @ A @ B3 @ C2 ) ) ) ) ).

% sup.left_commute
thf(fact_349_sup__left__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X3 @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X3 @ Z2 ) ) ) ) ).

% sup_left_commute
thf(fact_350_sup__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( sup_sup @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% sup_fun_def
thf(fact_351_inf__Int__eq,axiom,
    ! [A: $tType,R: set @ A,S2: set @ A] :
      ( ( inf_inf @ ( A > $o )
        @ ^ [X2: A] : ( member @ A @ X2 @ R )
        @ ^ [X2: A] : ( member @ A @ X2 @ S2 ) )
      = ( ^ [X2: A] : ( member @ A @ X2 @ ( inf_inf @ ( set @ A ) @ R @ S2 ) ) ) ) ).

% inf_Int_eq
thf(fact_352_inf2E,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o,B2: A > B > $o,X3: A,Y: B] :
      ( ( inf_inf @ ( A > B > $o ) @ A3 @ B2 @ X3 @ Y )
     => ~ ( ( A3 @ X3 @ Y )
         => ~ ( B2 @ X3 @ Y ) ) ) ).

% inf2E
thf(fact_353_inf2D1,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o,B2: A > B > $o,X3: A,Y: B] :
      ( ( inf_inf @ ( A > B > $o ) @ A3 @ B2 @ X3 @ Y )
     => ( A3 @ X3 @ Y ) ) ).

% inf2D1
thf(fact_354_inf2D2,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o,B2: A > B > $o,X3: A,Y: B] :
      ( ( inf_inf @ ( A > B > $o ) @ A3 @ B2 @ X3 @ Y )
     => ( B2 @ X3 @ Y ) ) ).

% inf2D2
thf(fact_355_times__assn__raw_Ocases,axiom,
    ! [X3: product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) )] :
      ~ ! [P4: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q5: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H4: heap_ext @ product_unit,As: set @ nat] :
          ( X3
         != ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ P4 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Q5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ).

% times_assn_raw.cases
thf(fact_356_sngr__assn__raw_Ocases,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) )] :
          ~ ! [R4: ref @ A,X: A,H4: heap_ext @ product_unit,As: set @ nat] :
              ( X3
             != ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ R4 @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ) ).

% sngr_assn_raw.cases
thf(fact_357_snga__assn__raw_Ocases,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) )] :
          ~ ! [R4: array @ A,X: list @ A,H4: heap_ext @ product_unit,As: set @ nat] :
              ( X3
             != ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ R4 @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ) ).

% snga_assn_raw.cases
thf(fact_358_Collect__disj__eq,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
            | ( Q @ X2 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) ).

% Collect_disj_eq
thf(fact_359_Un__def,axiom,
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A6: set @ A,B5: set @ A] :
            ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A6 )
                | ( member @ A @ X2 @ B5 ) ) ) ) ) ).

% Un_def
thf(fact_360_Collect__imp__eq,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
           => ( Q @ X2 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ ( collect @ A @ P ) ) @ ( collect @ A @ Q ) ) ) ).

% Collect_imp_eq
thf(fact_361_boolean__algebra_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A] :
          ( ( sup_sup @ A @ X3 @ ( bot_bot @ A ) )
          = X3 ) ) ).

% boolean_algebra.disj_zero_right
thf(fact_362_boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,Z2: A,X3: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z2 ) @ X3 )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X3 ) @ ( sup_sup @ A @ Z2 @ X3 ) ) ) ) ).

% boolean_algebra.disj_conj_distrib2
thf(fact_363_boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,Z2: A,X3: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z2 ) @ X3 )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X3 ) @ ( inf_inf @ A @ Z2 @ X3 ) ) ) ) ).

% boolean_algebra.conj_disj_distrib2
thf(fact_364_boolean__algebra_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X3 @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X3 @ Y ) @ ( sup_sup @ A @ X3 @ Z2 ) ) ) ) ).

% boolean_algebra.disj_conj_distrib
thf(fact_365_boolean__algebra_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X3 @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X3 @ Y ) @ ( inf_inf @ A @ X3 @ Z2 ) ) ) ) ).

% boolean_algebra.conj_disj_distrib
thf(fact_366_sup__inf__distrib2,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [Y: A,Z2: A,X3: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z2 ) @ X3 )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X3 ) @ ( sup_sup @ A @ Z2 @ X3 ) ) ) ) ).

% sup_inf_distrib2
thf(fact_367_sup__inf__distrib1,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X3 @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X3 @ Y ) @ ( sup_sup @ A @ X3 @ Z2 ) ) ) ) ).

% sup_inf_distrib1
thf(fact_368_inf__sup__distrib2,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [Y: A,Z2: A,X3: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z2 ) @ X3 )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X3 ) @ ( inf_inf @ A @ Z2 @ X3 ) ) ) ) ).

% inf_sup_distrib2
thf(fact_369_inf__sup__distrib1,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X3 @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X3 @ Y ) @ ( inf_inf @ A @ X3 @ Z2 ) ) ) ) ).

% inf_sup_distrib1
thf(fact_370_distrib__imp2,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ! [X: A,Y3: A,Z4: A] :
              ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y3 @ Z4 ) )
              = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y3 ) @ ( sup_sup @ A @ X @ Z4 ) ) )
         => ( ( inf_inf @ A @ X3 @ ( sup_sup @ A @ Y @ Z2 ) )
            = ( sup_sup @ A @ ( inf_inf @ A @ X3 @ Y ) @ ( inf_inf @ A @ X3 @ Z2 ) ) ) ) ) ).

% distrib_imp2
thf(fact_371_distrib__imp1,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ! [X: A,Y3: A,Z4: A] :
              ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y3 @ Z4 ) )
              = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y3 ) @ ( inf_inf @ A @ X @ Z4 ) ) )
         => ( ( sup_sup @ A @ X3 @ ( inf_inf @ A @ Y @ Z2 ) )
            = ( inf_inf @ A @ ( sup_sup @ A @ X3 @ Y ) @ ( sup_sup @ A @ X3 @ Z2 ) ) ) ) ) ).

% distrib_imp1
thf(fact_372_Un__empty__right,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = A3 ) ).

% Un_empty_right
thf(fact_373_Un__empty__left,axiom,
    ! [A: $tType,B2: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B2 )
      = B2 ) ).

% Un_empty_left
thf(fact_374_pure__assn__raw_Ocases,axiom,
    ! [A: $tType,B: $tType,X3: product_prod @ $o @ ( product_prod @ A @ ( set @ B ) )] :
      ~ ! [B6: $o,H4: A,As: set @ B] :
          ( X3
         != ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ B6 @ ( product_Pair @ A @ ( set @ B ) @ H4 @ As ) ) ) ).

% pure_assn_raw.cases
thf(fact_375_star__or__dist1,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( ( times_times @ assn @ ( sup_sup @ assn @ A3 @ B2 ) @ C3 )
      = ( sup_sup @ assn @ ( times_times @ assn @ A3 @ C3 ) @ ( times_times @ assn @ B2 @ C3 ) ) ) ).

% star_or_dist1
thf(fact_376_star__or__dist2,axiom,
    ! [C3: assn,A3: assn,B2: assn] :
      ( ( times_times @ assn @ C3 @ ( sup_sup @ assn @ A3 @ B2 ) )
      = ( sup_sup @ assn @ ( times_times @ assn @ C3 @ A3 ) @ ( times_times @ assn @ C3 @ B2 ) ) ) ).

% star_or_dist2
thf(fact_377_ent__disjE,axiom,
    ! [A3: assn,C3: assn,B2: assn] :
      ( ( entails @ A3 @ C3 )
     => ( ( entails @ B2 @ C3 )
       => ( entails @ ( sup_sup @ assn @ A3 @ B2 ) @ C3 ) ) ) ).

% ent_disjE
thf(fact_378_ent__disjI1,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( ( entails @ ( sup_sup @ assn @ P @ Q ) @ R )
     => ( entails @ P @ R ) ) ).

% ent_disjI1
thf(fact_379_ent__disjI2,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( ( entails @ ( sup_sup @ assn @ P @ Q ) @ R )
     => ( entails @ Q @ R ) ) ).

% ent_disjI2
thf(fact_380_ent__disjI1_H,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( ( entails @ A3 @ B2 )
     => ( entails @ A3 @ ( sup_sup @ assn @ B2 @ C3 ) ) ) ).

% ent_disjI1'
thf(fact_381_ent__disjI2_H,axiom,
    ! [A3: assn,C3: assn,B2: assn] :
      ( ( entails @ A3 @ C3 )
     => ( entails @ A3 @ ( sup_sup @ assn @ B2 @ C3 ) ) ) ).

% ent_disjI2'
thf(fact_382_ent__disjI1__direct,axiom,
    ! [A3: assn,B2: assn] : ( entails @ A3 @ ( sup_sup @ assn @ A3 @ B2 ) ) ).

% ent_disjI1_direct
thf(fact_383_ent__disjI2__direct,axiom,
    ! [B2: assn,A3: assn] : ( entails @ B2 @ ( sup_sup @ assn @ A3 @ B2 ) ) ).

% ent_disjI2_direct
thf(fact_384_entt__disjE,axiom,
    ! [A3: assn,M: assn,B2: assn] :
      ( ( entailst @ A3 @ M )
     => ( ( entailst @ B2 @ M )
       => ( entailst @ ( sup_sup @ assn @ A3 @ B2 ) @ M ) ) ) ).

% entt_disjE
thf(fact_385_entt__disjD1,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( ( entailst @ ( sup_sup @ assn @ A3 @ B2 ) @ C3 )
     => ( entailst @ A3 @ C3 ) ) ).

% entt_disjD1
thf(fact_386_entt__disjD2,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( ( entailst @ ( sup_sup @ assn @ A3 @ B2 ) @ C3 )
     => ( entailst @ B2 @ C3 ) ) ).

% entt_disjD2
thf(fact_387_entt__disjI1_H,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( ( entailst @ A3 @ B2 )
     => ( entailst @ A3 @ ( sup_sup @ assn @ B2 @ C3 ) ) ) ).

% entt_disjI1'
thf(fact_388_entt__disjI2_H,axiom,
    ! [A3: assn,C3: assn,B2: assn] :
      ( ( entailst @ A3 @ C3 )
     => ( entailst @ A3 @ ( sup_sup @ assn @ B2 @ C3 ) ) ) ).

% entt_disjI2'
thf(fact_389_entt__disjI1__direct,axiom,
    ! [A3: assn,B2: assn] : ( entailst @ A3 @ ( sup_sup @ assn @ A3 @ B2 ) ) ).

% entt_disjI1_direct
thf(fact_390_entt__disjI2__direct,axiom,
    ! [B2: assn,A3: assn] : ( entailst @ B2 @ ( sup_sup @ assn @ A3 @ B2 ) ) ).

% entt_disjI2_direct
thf(fact_391_ex__join__or,axiom,
    ! [A: $tType,P: A > assn,Q: A > assn] :
      ( ( ex_assn @ A
        @ ^ [X2: A] : ( sup_sup @ assn @ ( P @ X2 ) @ ( ex_assn @ A @ Q ) ) )
      = ( ex_assn @ A
        @ ^ [X2: A] : ( sup_sup @ assn @ ( P @ X2 ) @ ( Q @ X2 ) ) ) ) ).

% ex_join_or
thf(fact_392_ex__distrib__or,axiom,
    ! [A: $tType,P: A > assn,Q: assn] :
      ( ( ex_assn @ A
        @ ^ [X2: A] : ( sup_sup @ assn @ ( P @ X2 ) @ Q ) )
      = ( sup_sup @ assn @ ( ex_assn @ A @ P ) @ Q ) ) ).

% ex_distrib_or
thf(fact_393_sup__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,A4: A,B3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X3 @ A4 ) @ ( sup_sup @ A @ ( uminus_uminus @ A @ X3 ) @ B3 ) )
          = ( top_top @ A ) ) ) ).

% sup_cancel_left1
thf(fact_394_sup__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,A4: A,B3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ ( uminus_uminus @ A @ X3 ) @ A4 ) @ ( sup_sup @ A @ X3 @ B3 ) )
          = ( top_top @ A ) ) ) ).

% sup_cancel_left2
thf(fact_395_sup__bot_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( comm_monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.comm_monoid_axioms
thf(fact_396_sup__bot_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.monoid_axioms
thf(fact_397_sup__assn__def,axiom,
    ( ( sup_sup @ assn )
    = ( ^ [P3: assn,Q3: assn] :
          ( abs_assn
          @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( rep_assn @ P3 @ H )
              | ( rep_assn @ Q3 @ H ) ) ) ) ) ).

% sup_assn_def
thf(fact_398_boolean__algebra_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [A4: A,X3: A,Y: A] :
          ( ( ( inf_inf @ A @ A4 @ X3 )
            = ( bot_bot @ A ) )
         => ( ( ( sup_sup @ A @ A4 @ X3 )
              = ( top_top @ A ) )
           => ( ( ( inf_inf @ A @ A4 @ Y )
                = ( bot_bot @ A ) )
             => ( ( ( sup_sup @ A @ A4 @ Y )
                  = ( top_top @ A ) )
               => ( X3 = Y ) ) ) ) ) ) ).

% boolean_algebra.complement_unique
thf(fact_399_bot__empty__eq,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X2: A] : ( member @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% bot_empty_eq
thf(fact_400_mod__emp,axiom,
    ! [H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( one_one @ assn ) @ H2 )
      = ( ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 )
        = ( bot_bot @ ( set @ nat ) ) ) ) ).

% mod_emp
thf(fact_401_times__assn__raw_Oelims_I3_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( times_assn_raw @ X3 @ Xa @ Xb )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ? [As12: set @ nat,As23: set @ nat] :
                ( ( As
                  = ( sup_sup @ ( set @ nat ) @ As12 @ As23 ) )
                & ( ( inf_inf @ ( set @ nat ) @ As12 @ As23 )
                  = ( bot_bot @ ( set @ nat ) ) )
                & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As12 ) )
                & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As23 ) ) ) ) ) ).

% times_assn_raw.elims(3)
thf(fact_402_times__assn__raw_Oelims_I2_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( times_assn_raw @ X3 @ Xa @ Xb )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ~ ? [As13: set @ nat,As24: set @ nat] :
                  ( ( As
                    = ( sup_sup @ ( set @ nat ) @ As13 @ As24 ) )
                  & ( ( inf_inf @ ( set @ nat ) @ As13 @ As24 )
                    = ( bot_bot @ ( set @ nat ) ) )
                  & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As13 ) )
                  & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As24 ) ) ) ) ) ).

% times_assn_raw.elims(2)
thf(fact_403_times__assn__raw_Oelims_I1_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( times_assn_raw @ X3 @ Xa @ Xb )
        = Y )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ( Y
              = ( ~ ? [As1: set @ nat,As22: set @ nat] :
                      ( ( As
                        = ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) )
                      & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
                        = ( bot_bot @ ( set @ nat ) ) )
                      & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As1 ) )
                      & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As22 ) ) ) ) ) ) ) ).

% times_assn_raw.elims(1)
thf(fact_404_times__assn__raw_Osimps,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( times_assn_raw @ P @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
      = ( ? [As1: set @ nat,As22: set @ nat] :
            ( ( As2
              = ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) )
            & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
              = ( bot_bot @ ( set @ nat ) ) )
            & ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As1 ) )
            & ( Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As22 ) ) ) ) ) ).

% times_assn_raw.simps
thf(fact_405_boolean__algebra__class_Oboolean__algebra_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( ( inf_inf @ A @ X3 @ Y )
            = ( bot_bot @ A ) )
         => ( ( ( sup_sup @ A @ X3 @ Y )
              = ( top_top @ A ) )
           => ( ( uminus_uminus @ A @ X3 )
              = Y ) ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_unique
thf(fact_406_wand__assnI,axiom,
    ! [H2: heap_ext @ product_unit,As2: set @ nat,Q: assn,R: assn] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
     => ( ! [H3: heap_ext @ product_unit,As4: set @ nat] :
            ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As4 )
              = ( bot_bot @ ( set @ nat ) ) )
           => ( ( relH @ As2 @ H2 @ H3 )
             => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As2 ) )
               => ( ( rep_assn @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As4 ) )
                 => ( rep_assn @ R @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ ( sup_sup @ ( set @ nat ) @ As2 @ As4 ) ) ) ) ) ) )
       => ( rep_assn @ ( wand_assn @ Q @ R ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) ) ) ) ).

% wand_assnI
thf(fact_407_wand__raw_Oelims_I3_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( wand_raw @ X3 @ Xa @ Xb )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
              & ! [H3: heap_ext @ product_unit,As4: set @ nat] :
                  ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As4 )
                      = ( bot_bot @ ( set @ nat ) ) )
                    & ( relH @ As @ H4 @ H3 )
                    & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                    & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As4 ) ) )
                 => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ ( sup_sup @ ( set @ nat ) @ As @ As4 ) ) ) ) ) ) ) ).

% wand_raw.elims(3)
thf(fact_408_wand__raw_Oelims_I2_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( wand_raw @ X3 @ Xa @ Xb )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ~ ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                & ! [H6: heap_ext @ product_unit,As5: set @ nat] :
                    ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As5 )
                        = ( bot_bot @ ( set @ nat ) ) )
                      & ( relH @ As @ H4 @ H6 )
                      & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ As ) )
                      & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ As5 ) ) )
                   => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ ( sup_sup @ ( set @ nat ) @ As @ As5 ) ) ) ) ) ) ) ).

% wand_raw.elims(2)
thf(fact_409_wand__raw_Oelims_I1_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( wand_raw @ X3 @ Xa @ Xb )
        = Y )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ( Y
              = ( ~ ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                    & ! [H7: heap_ext @ product_unit,As6: set @ nat] :
                        ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As6 )
                            = ( bot_bot @ ( set @ nat ) ) )
                          & ( relH @ As @ H4 @ H7 )
                          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As ) )
                          & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As6 ) ) )
                       => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ ( sup_sup @ ( set @ nat ) @ As @ As6 ) ) ) ) ) ) ) ) ) ).

% wand_raw.elims(1)
thf(fact_410_wand__raw_Osimps,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( wand_raw @ P @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
      = ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
        & ! [H7: heap_ext @ product_unit,As6: set @ nat] :
            ( ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As6 )
                = ( bot_bot @ ( set @ nat ) ) )
              & ( relH @ As2 @ H2 @ H7 )
              & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As2 ) )
              & ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As6 ) ) )
           => ( Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ ( sup_sup @ ( set @ nat ) @ As2 @ As6 ) ) ) ) ) ) ).

% wand_raw.simps
thf(fact_411_Collect__empty__eq__bot,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) ).

% Collect_empty_eq_bot
thf(fact_412_disjointI,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ! [X: A] :
          ( ( member @ A @ X @ A4 )
         => ~ ( member @ A @ X @ B3 ) )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% disjointI
thf(fact_413_boolean__algebra_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( inf_inf @ A ) @ ( sup_sup @ A ) @ ( uminus_uminus @ A ) @ ( bot_bot @ A ) @ ( top_top @ A ) ) ) ).

% boolean_algebra.abstract_boolean_algebra_axioms
thf(fact_414_success__LetI,axiom,
    ! [A: $tType,B: $tType,X3: A,T3: A,F2: A > ( heap_Time_Heap @ B ),H2: heap_ext @ product_unit] :
      ( ( X3 = T3 )
     => ( ( heap_Time_success @ B @ ( F2 @ X3 ) @ H2 )
       => ( heap_Time_success @ B @ ( F2 @ T3 ) @ H2 ) ) ) ).

% success_LetI
thf(fact_415_times__assn__raw_Opelims_I3_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( times_assn_raw @ X3 @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) )
               => ? [As12: set @ nat,As23: set @ nat] :
                    ( ( As
                      = ( sup_sup @ ( set @ nat ) @ As12 @ As23 ) )
                    & ( ( inf_inf @ ( set @ nat ) @ As12 @ As23 )
                      = ( bot_bot @ ( set @ nat ) ) )
                    & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As12 ) )
                    & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As23 ) ) ) ) ) ) ) ).

% times_assn_raw.pelims(3)
thf(fact_416_times__assn__raw_Opelims_I2_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( times_assn_raw @ X3 @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) )
               => ~ ? [As13: set @ nat,As24: set @ nat] :
                      ( ( As
                        = ( sup_sup @ ( set @ nat ) @ As13 @ As24 ) )
                      & ( ( inf_inf @ ( set @ nat ) @ As13 @ As24 )
                        = ( bot_bot @ ( set @ nat ) ) )
                      & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As13 ) )
                      & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As24 ) ) ) ) ) ) ) ).

% times_assn_raw.pelims(2)
thf(fact_417_inf1I,axiom,
    ! [A: $tType,A3: A > $o,X3: A,B2: A > $o] :
      ( ( A3 @ X3 )
     => ( ( B2 @ X3 )
       => ( inf_inf @ ( A > $o ) @ A3 @ B2 @ X3 ) ) ) ).

% inf1I
thf(fact_418_relH__dist__union,axiom,
    ! [As2: set @ nat,As3: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( relH @ ( sup_sup @ ( set @ nat ) @ As2 @ As3 ) @ H2 @ H5 )
      = ( ( relH @ As2 @ H2 @ H5 )
        & ( relH @ As3 @ H2 @ H5 ) ) ) ).

% relH_dist_union
thf(fact_419_inf1E,axiom,
    ! [A: $tType,A3: A > $o,B2: A > $o,X3: A] :
      ( ( inf_inf @ ( A > $o ) @ A3 @ B2 @ X3 )
     => ~ ( ( A3 @ X3 )
         => ~ ( B2 @ X3 ) ) ) ).

% inf1E
thf(fact_420_inf1D1,axiom,
    ! [A: $tType,A3: A > $o,B2: A > $o,X3: A] :
      ( ( inf_inf @ ( A > $o ) @ A3 @ B2 @ X3 )
     => ( A3 @ X3 ) ) ).

% inf1D1
thf(fact_421_inf1D2,axiom,
    ! [A: $tType,A3: A > $o,B2: A > $o,X3: A] :
      ( ( inf_inf @ ( A > $o ) @ A3 @ B2 @ X3 )
     => ( B2 @ X3 ) ) ).

% inf1D2
thf(fact_422_relH__trans,axiom,
    ! [As2: set @ nat,H12: heap_ext @ product_unit,H23: heap_ext @ product_unit,H32: heap_ext @ product_unit] :
      ( ( relH @ As2 @ H12 @ H23 )
     => ( ( relH @ As2 @ H23 @ H32 )
       => ( relH @ As2 @ H12 @ H32 ) ) ) ).

% relH_trans
thf(fact_423_relH__sym,axiom,
    ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( relH @ As2 @ H2 @ H5 )
     => ( relH @ As2 @ H5 @ H2 ) ) ).

% relH_sym
thf(fact_424_abstract__boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Y: A,Z2: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ ( Conj @ Y @ Z2 ) @ X3 )
        = ( Conj @ ( Disj @ Y @ X3 ) @ ( Disj @ Z2 @ X3 ) ) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib2
thf(fact_425_abstract__boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Y: A,Z2: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ ( Disj @ Y @ Z2 ) @ X3 )
        = ( Disj @ ( Conj @ Y @ X3 ) @ ( Conj @ Z2 @ X3 ) ) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib2
thf(fact_426_abstract__boolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A,Y: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( ( Compl @ X3 )
          = ( Compl @ Y ) )
        = ( X3 = Y ) ) ) ).

% abstract_boolean_algebra.compl_eq_compl_iff
thf(fact_427_abstract__boolean__algebra_Odisj__conj__distrib,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A,Y: A,Z2: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ X3 @ ( Conj @ Y @ Z2 ) )
        = ( Conj @ ( Disj @ X3 @ Y ) @ ( Disj @ X3 @ Z2 ) ) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib
thf(fact_428_abstract__boolean__algebra_Odisj__cancel__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ X3 @ ( Compl @ X3 ) )
        = One ) ) ).

% abstract_boolean_algebra.disj_cancel_right
thf(fact_429_abstract__boolean__algebra_Oconj__disj__distrib,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A,Y: A,Z2: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ X3 @ ( Disj @ Y @ Z2 ) )
        = ( Disj @ ( Conj @ X3 @ Y ) @ ( Conj @ X3 @ Z2 ) ) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib
thf(fact_430_abstract__boolean__algebra_Oconj__cancel__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ X3 @ ( Compl @ X3 ) )
        = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_right
thf(fact_431_abstract__boolean__algebra_Ocomplement__unique,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,A4: A,X3: A,Y: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( ( Conj @ A4 @ X3 )
          = Zero )
       => ( ( ( Disj @ A4 @ X3 )
            = One )
         => ( ( ( Conj @ A4 @ Y )
              = Zero )
           => ( ( ( Disj @ A4 @ Y )
                = One )
             => ( X3 = Y ) ) ) ) ) ) ).

% abstract_boolean_algebra.complement_unique
thf(fact_432_abstract__boolean__algebra_Odisj__cancel__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ ( Compl @ X3 ) @ X3 )
        = One ) ) ).

% abstract_boolean_algebra.disj_cancel_left
thf(fact_433_abstract__boolean__algebra_Oconj__cancel__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ ( Compl @ X3 ) @ X3 )
        = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_left
thf(fact_434_abstract__boolean__algebra_Odisj__zero__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ X3 @ Zero )
        = X3 ) ) ).

% abstract_boolean_algebra.disj_zero_right
thf(fact_435_abstract__boolean__algebra_Oconj__zero__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ X3 @ Zero )
        = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_right
thf(fact_436_abstract__boolean__algebra_Odisj__one__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ X3 @ One )
        = One ) ) ).

% abstract_boolean_algebra.disj_one_right
thf(fact_437_abstract__boolean__algebra_Ode__Morgan__disj,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A,Y: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Compl @ ( Disj @ X3 @ Y ) )
        = ( Conj @ ( Compl @ X3 ) @ ( Compl @ Y ) ) ) ) ).

% abstract_boolean_algebra.de_Morgan_disj
thf(fact_438_abstract__boolean__algebra_Ode__Morgan__conj,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A,Y: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Compl @ ( Conj @ X3 @ Y ) )
        = ( Disj @ ( Compl @ X3 ) @ ( Compl @ Y ) ) ) ) ).

% abstract_boolean_algebra.de_Morgan_conj
thf(fact_439_abstract__boolean__algebra_Oconj__zero__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ Zero @ X3 )
        = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_left
thf(fact_440_abstract__boolean__algebra_Oconj__one__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ X3 @ One )
        = X3 ) ) ).

% abstract_boolean_algebra.conj_one_right
thf(fact_441_abstract__boolean__algebra_Odisj__one__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ One @ X3 )
        = One ) ) ).

% abstract_boolean_algebra.disj_one_left
thf(fact_442_abstract__boolean__algebra_Odouble__compl,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Compl @ ( Compl @ X3 ) )
        = X3 ) ) ).

% abstract_boolean_algebra.double_compl
thf(fact_443_abstract__boolean__algebra_Ocompl__unique,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X3: A,Y: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( ( Conj @ X3 @ Y )
          = Zero )
       => ( ( ( Disj @ X3 @ Y )
            = One )
         => ( ( Compl @ X3 )
            = Y ) ) ) ) ).

% abstract_boolean_algebra.compl_unique
thf(fact_444_abstract__boolean__algebra_Ocompl__zero,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Compl @ Zero )
        = One ) ) ).

% abstract_boolean_algebra.compl_zero
thf(fact_445_abstract__boolean__algebra_Ocompl__one,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Compl @ One )
        = Zero ) ) ).

% abstract_boolean_algebra.compl_one
thf(fact_446_sup__Un__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( sup_sup @ ( A > B > $o )
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R )
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ S2 ) )
      = ( ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ) ) ).

% sup_Un_eq2
thf(fact_447_sup__Un__eq,axiom,
    ! [A: $tType,R: set @ A,S2: set @ A] :
      ( ( sup_sup @ ( A > $o )
        @ ^ [X2: A] : ( member @ A @ X2 @ R )
        @ ^ [X2: A] : ( member @ A @ X2 @ S2 ) )
      = ( ^ [X2: A] : ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ R @ S2 ) ) ) ) ).

% sup_Un_eq
thf(fact_448_sup__set__def,axiom,
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A6: set @ A,B5: set @ A] :
            ( collect @ A
            @ ( sup_sup @ ( A > $o )
              @ ^ [X2: A] : ( member @ A @ X2 @ A6 )
              @ ^ [X2: A] : ( member @ A @ X2 @ B5 ) ) ) ) ) ).

% sup_set_def
thf(fact_449_mod__relH,axiom,
    ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,P: assn] :
      ( ( relH @ As2 @ H2 @ H5 )
     => ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
        = ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) ) ) ) ).

% mod_relH
thf(fact_450_relH__refl,axiom,
    ! [H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
     => ( relH @ As2 @ H2 @ H2 ) ) ).

% relH_refl
thf(fact_451_relH__in__rangeI_I1_J,axiom,
    ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( relH @ As2 @ H2 @ H5 )
     => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) ) ) ).

% relH_in_rangeI(1)
thf(fact_452_relH__in__rangeI_I2_J,axiom,
    ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( relH @ As2 @ H2 @ H5 )
     => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) ) ) ).

% relH_in_rangeI(2)
thf(fact_453_set__notEmptyE,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ A ) ) )
     => ~ ! [X: A] :
            ~ ( member @ A @ X @ S2 ) ) ).

% set_notEmptyE
thf(fact_454_memb__imp__not__empty,axiom,
    ! [A: $tType,X3: A,S2: set @ A] :
      ( ( member @ A @ X3 @ S2 )
     => ( S2
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% memb_imp_not_empty
thf(fact_455_times__assn__raw_Opelims_I1_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( times_assn_raw @ X3 @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( Y
                  = ( ? [As1: set @ nat,As22: set @ nat] :
                        ( ( As
                          = ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) )
                        & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
                          = ( bot_bot @ ( set @ nat ) ) )
                        & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As1 ) )
                        & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As22 ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ) ) ) ) ).

% times_assn_raw.pelims(1)
thf(fact_456_wand__raw_Opelims_I1_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( wand_raw @ X3 @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( Y
                  = ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                    & ! [H7: heap_ext @ product_unit,As6: set @ nat] :
                        ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As6 )
                            = ( bot_bot @ ( set @ nat ) ) )
                          & ( relH @ As @ H4 @ H7 )
                          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As ) )
                          & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As6 ) ) )
                       => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ ( sup_sup @ ( set @ nat ) @ As @ As6 ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ) ) ) ) ).

% wand_raw.pelims(1)
thf(fact_457_wand__raw_Opelims_I2_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( wand_raw @ X3 @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) )
               => ~ ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                    & ! [H6: heap_ext @ product_unit,As5: set @ nat] :
                        ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As5 )
                            = ( bot_bot @ ( set @ nat ) ) )
                          & ( relH @ As @ H4 @ H6 )
                          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ As ) )
                          & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ As5 ) ) )
                       => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ ( sup_sup @ ( set @ nat ) @ As @ As5 ) ) ) ) ) ) ) ) ) ).

% wand_raw.pelims(2)
thf(fact_458_wand__raw_Opelims_I3_J,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( wand_raw @ X3 @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) )
               => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                  & ! [H3: heap_ext @ product_unit,As4: set @ nat] :
                      ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As4 )
                          = ( bot_bot @ ( set @ nat ) ) )
                        & ( relH @ As @ H4 @ H3 )
                        & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                        & ( X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As4 ) ) )
                     => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ ( sup_sup @ ( set @ nat ) @ As @ As4 ) ) ) ) ) ) ) ) ) ).

% wand_raw.pelims(3)
thf(fact_459_brk__rel__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( brk_rel @ A @ B )
      = ( ^ [R2: set @ ( product_prod @ A @ B )] :
            ( sup_sup @ ( set @ ( product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) ) )
            @ ( collect @ ( product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) )
              @ ^ [Uu: product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B )] :
                ? [X2: A,Y2: B] :
                  ( ( Uu
                    = ( product_Pair @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) @ ( product_Pair @ $o @ A @ $false @ X2 ) @ ( product_Pair @ $o @ B @ $false @ Y2 ) ) )
                  & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R2 ) ) )
            @ ( collect @ ( product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) )
              @ ^ [Uu: product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B )] :
                ? [X2: A,Y2: B] :
                  ( Uu
                  = ( product_Pair @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) @ ( product_Pair @ $o @ A @ $true @ X2 ) @ ( product_Pair @ $o @ B @ $false @ Y2 ) ) ) ) ) ) ) ).

% brk_rel_def
thf(fact_460_bijective__Empty,axiom,
    ! [B: $tType,A: $tType] : ( bijective @ A @ B @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% bijective_Empty
thf(fact_461_rel__restrict__compl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( rel_restrict @ A @ R @ A3 ) @ ( rel_restrict @ A @ R @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% rel_restrict_compl
thf(fact_462_properI,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ! [As: set @ nat,H4: heap_ext @ product_unit] :
          ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
         => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) )
     => ( ! [As: set @ nat,H4: heap_ext @ product_unit,H3: heap_ext @ product_unit] :
            ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ( ( relH @ As @ H4 @ H3 )
             => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
               => ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) ) )
       => ( proper @ P ) ) ) ).

% properI
thf(fact_463_properD2,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As2: set @ nat,H5: heap_ext @ product_unit] :
      ( ( proper @ P )
     => ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
       => ( ( relH @ As2 @ H2 @ H5 )
         => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) )
           => ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) ) ) ) ) ) ).

% properD2
thf(fact_464_proper__def,axiom,
    ( proper
    = ( ^ [P3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
        ! [H: heap_ext @ product_unit,H7: heap_ext @ product_unit,As7: set @ nat] :
          ( ( ( P3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As7 ) )
           => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As7 ) ) )
          & ( ( ( P3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As7 ) )
              & ( relH @ As7 @ H @ H7 )
              & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As7 ) ) )
           => ( P3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As7 ) ) ) ) ) ) ).

% proper_def
thf(fact_465_proper__iff,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( proper @ P )
     => ( ( relH @ As2 @ H2 @ H5 )
       => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) )
         => ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
            = ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) ) ) ) ) ) ).

% proper_iff
thf(fact_466_Id__on__empty,axiom,
    ! [A: $tType] :
      ( ( id_on @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% Id_on_empty
thf(fact_467_sup2CI,axiom,
    ! [A: $tType,B: $tType,B2: A > B > $o,X3: A,Y: B,A3: A > B > $o] :
      ( ( ~ ( B2 @ X3 @ Y )
       => ( A3 @ X3 @ Y ) )
     => ( sup_sup @ ( A > B > $o ) @ A3 @ B2 @ X3 @ Y ) ) ).

% sup2CI
thf(fact_468_sup1CI,axiom,
    ! [A: $tType,B2: A > $o,X3: A,A3: A > $o] :
      ( ( ~ ( B2 @ X3 )
       => ( A3 @ X3 ) )
     => ( sup_sup @ ( A > $o ) @ A3 @ B2 @ X3 ) ) ).

% sup1CI
thf(fact_469_bool__assn__proper_I2_J,axiom,
    ( proper
    @ ^ [Uu: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] : $false ) ).

% bool_assn_proper(2)
thf(fact_470_bool__assn__proper_I3_J,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P )
     => ( ( proper @ Q )
       => ( proper
          @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( P @ H )
              | ( Q @ H ) ) ) ) ) ).

% bool_assn_proper(3)
thf(fact_471_bool__assn__proper_I4_J,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P )
     => ( ( proper @ Q )
       => ( proper
          @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( P @ H )
              & ( Q @ H ) ) ) ) ) ).

% bool_assn_proper(4)
thf(fact_472_rel__restrict__empty,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( rel_restrict @ A @ R @ ( bot_bot @ ( set @ A ) ) )
      = R ) ).

% rel_restrict_empty
thf(fact_473_bool__assn__proper_I1_J,axiom,
    proper @ in_range ).

% bool_assn_proper(1)
thf(fact_474_ex__assn__proper,axiom,
    ! [A: $tType,P: A > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ! [X: A] : ( proper @ ( P @ X ) )
     => ( proper
        @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ? [X2: A] : ( P @ X2 @ H ) ) ) ).

% ex_assn_proper
thf(fact_475_one__assn__proper,axiom,
    proper @ one_assn_raw ).

% one_assn_proper
thf(fact_476_times__assn__proper,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P )
     => ( ( proper @ Q )
       => ( proper @ ( times_assn_raw @ P @ Q ) ) ) ) ).

% times_assn_proper
thf(fact_477_wand__proper,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] : ( proper @ ( wand_raw @ P @ Q ) ) ).

% wand_proper
thf(fact_478_snga__assn__proper,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R5: array @ A,X3: list @ A] : ( proper @ ( snga_assn_raw @ A @ R5 @ X3 ) ) ) ).

% snga_assn_proper
thf(fact_479_sngr__assn__proper,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R5: ref @ A,X3: A] : ( proper @ ( sngr_assn_raw @ A @ R5 @ X3 ) ) ) ).

% sngr_assn_proper
thf(fact_480_bool__assn__proper_I5_J,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P )
     => ( proper
        @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( in_range @ H )
            & ~ ( P @ H ) ) ) ) ).

% bool_assn_proper(5)
thf(fact_481_pure__assn__proper,axiom,
    ! [B3: $o] : ( proper @ ( pure_assn_raw @ ( heap_ext @ product_unit ) @ nat @ B3 ) ) ).

% pure_assn_proper
thf(fact_482_sup1E,axiom,
    ! [A: $tType,A3: A > $o,B2: A > $o,X3: A] :
      ( ( sup_sup @ ( A > $o ) @ A3 @ B2 @ X3 )
     => ( ~ ( A3 @ X3 )
       => ( B2 @ X3 ) ) ) ).

% sup1E
thf(fact_483_sup2E,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o,B2: A > B > $o,X3: A,Y: B] :
      ( ( sup_sup @ ( A > B > $o ) @ A3 @ B2 @ X3 @ Y )
     => ( ~ ( A3 @ X3 @ Y )
       => ( B2 @ X3 @ Y ) ) ) ).

% sup2E
thf(fact_484_sup1I1,axiom,
    ! [A: $tType,A3: A > $o,X3: A,B2: A > $o] :
      ( ( A3 @ X3 )
     => ( sup_sup @ ( A > $o ) @ A3 @ B2 @ X3 ) ) ).

% sup1I1
thf(fact_485_sup1I2,axiom,
    ! [A: $tType,B2: A > $o,X3: A,A3: A > $o] :
      ( ( B2 @ X3 )
     => ( sup_sup @ ( A > $o ) @ A3 @ B2 @ X3 ) ) ).

% sup1I2
thf(fact_486_sup2I1,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o,X3: A,Y: B,B2: A > B > $o] :
      ( ( A3 @ X3 @ Y )
     => ( sup_sup @ ( A > B > $o ) @ A3 @ B2 @ X3 @ Y ) ) ).

% sup2I1
thf(fact_487_sup2I2,axiom,
    ! [A: $tType,B: $tType,B2: A > B > $o,X3: A,Y: B,A3: A > B > $o] :
      ( ( B2 @ X3 @ Y )
     => ( sup_sup @ ( A > B > $o ) @ A3 @ B2 @ X3 @ Y ) ) ).

% sup2I2
thf(fact_488_Rep__assn,axiom,
    ! [X3: assn] : ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( rep_assn @ X3 ) @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) ) ).

% Rep_assn
thf(fact_489_Rep__assn__cases,axiom,
    ! [Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ~ ! [X: assn] :
            ( Y
           != ( rep_assn @ X ) ) ) ).

% Rep_assn_cases
thf(fact_490_Rep__assn__induct,axiom,
    ! [Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,P: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > $o] :
      ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ( ! [X: assn] : ( P @ ( rep_assn @ X ) )
       => ( P @ Y ) ) ) ).

% Rep_assn_induct
thf(fact_491_Abs__assn__cases,axiom,
    ! [X3: assn] :
      ~ ! [Y3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
          ( ( X3
            = ( abs_assn @ Y3 ) )
         => ~ ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y3 @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) ) ) ).

% Abs_assn_cases
thf(fact_492_Abs__assn__induct,axiom,
    ! [P: assn > $o,X3: assn] :
      ( ! [Y3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
          ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y3 @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
         => ( P @ ( abs_assn @ Y3 ) ) )
     => ( P @ X3 ) ) ).

% Abs_assn_induct
thf(fact_493_Abs__assn__inject,axiom,
    ! [X3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ X3 @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
       => ( ( ( abs_assn @ X3 )
            = ( abs_assn @ Y ) )
          = ( X3 = Y ) ) ) ) ).

% Abs_assn_inject
thf(fact_494_properD1,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( proper @ P )
     => ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
       => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) ) ) ) ).

% properD1
thf(fact_495_Abs__assn__inverse,axiom,
    ! [Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ( ( rep_assn @ ( abs_assn @ Y ) )
        = Y ) ) ).

% Abs_assn_inverse
thf(fact_496_monoid_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( semigroup @ A @ F2 )
     => ( ( monoid_axioms @ A @ F2 @ Z2 )
       => ( monoid @ A @ F2 @ Z2 ) ) ) ).

% monoid.intro
thf(fact_497_monoid__def,axiom,
    ! [A: $tType] :
      ( ( monoid @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
            ( ( semigroup @ A @ F3 )
            & ( monoid_axioms @ A @ F3 @ Z3 ) ) ) ) ).

% monoid_def
thf(fact_498_vimage__if,axiom,
    ! [B: $tType,A: $tType,C2: B,A3: set @ B,D3: B,B2: set @ A] :
      ( ( ( member @ B @ C2 @ A3 )
       => ( ( ( member @ B @ D3 @ A3 )
           => ( ( vimage @ A @ B
                @ ^ [X2: A] : ( if @ B @ ( member @ A @ X2 @ B2 ) @ C2 @ D3 )
                @ A3 )
              = ( top_top @ ( set @ A ) ) ) )
          & ( ~ ( member @ B @ D3 @ A3 )
           => ( ( vimage @ A @ B
                @ ^ [X2: A] : ( if @ B @ ( member @ A @ X2 @ B2 ) @ C2 @ D3 )
                @ A3 )
              = B2 ) ) ) )
      & ( ~ ( member @ B @ C2 @ A3 )
       => ( ( ( member @ B @ D3 @ A3 )
           => ( ( vimage @ A @ B
                @ ^ [X2: A] : ( if @ B @ ( member @ A @ X2 @ B2 ) @ C2 @ D3 )
                @ A3 )
              = ( uminus_uminus @ ( set @ A ) @ B2 ) ) )
          & ( ~ ( member @ B @ D3 @ A3 )
           => ( ( vimage @ A @ B
                @ ^ [X2: A] : ( if @ B @ ( member @ A @ X2 @ B2 ) @ C2 @ D3 )
                @ A3 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% vimage_if
thf(fact_499_type__definition__assn,axiom,
    type_definition @ assn @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ rep_assn @ abs_assn @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) ).

% type_definition_assn
thf(fact_500_pure__assn__raw_Opelims_I3_J,axiom,
    ! [B: $tType,A: $tType,X3: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ~ ( pure_assn_raw @ A @ B @ X3 @ Xa )
     => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X3 @ Xa ) )
       => ~ ! [H4: A,As: set @ B] :
              ( ( Xa
                = ( product_Pair @ A @ ( set @ B ) @ H4 @ As ) )
             => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X3 @ ( product_Pair @ A @ ( set @ B ) @ H4 @ As ) ) )
               => ( ( As
                    = ( bot_bot @ ( set @ B ) ) )
                  & X3 ) ) ) ) ) ).

% pure_assn_raw.pelims(3)
thf(fact_501_pure__assn__raw_Opelims_I2_J,axiom,
    ! [B: $tType,A: $tType,X3: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ( pure_assn_raw @ A @ B @ X3 @ Xa )
     => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X3 @ Xa ) )
       => ~ ! [H4: A,As: set @ B] :
              ( ( Xa
                = ( product_Pair @ A @ ( set @ B ) @ H4 @ As ) )
             => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X3 @ ( product_Pair @ A @ ( set @ B ) @ H4 @ As ) ) )
               => ~ ( ( As
                      = ( bot_bot @ ( set @ B ) ) )
                    & X3 ) ) ) ) ) ).

% pure_assn_raw.pelims(2)
thf(fact_502_pure__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType,B: $tType,X3: $o,Xa: product_prod @ A @ ( set @ B ),Y: $o] :
      ( ( ( pure_assn_raw @ A @ B @ X3 @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X3 @ Xa ) )
       => ~ ! [H4: A,As: set @ B] :
              ( ( Xa
                = ( product_Pair @ A @ ( set @ B ) @ H4 @ As ) )
             => ( ( Y
                  = ( ( As
                      = ( bot_bot @ ( set @ B ) ) )
                    & X3 ) )
               => ~ ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X3 @ ( product_Pair @ A @ ( set @ B ) @ H4 @ As ) ) ) ) ) ) ) ).

% pure_assn_raw.pelims(1)
thf(fact_503_rel__restrict__alt__def,axiom,
    ! [A: $tType] :
      ( ( rel_restrict @ A )
      = ( ^ [R2: set @ ( product_prod @ A @ A ),A6: set @ A] :
            ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R2
            @ ( product_Sigma @ A @ A @ ( uminus_uminus @ ( set @ A ) @ A6 )
              @ ^ [Uu: A] : ( uminus_uminus @ ( set @ A ) @ A6 ) ) ) ) ) ).

% rel_restrict_alt_def
thf(fact_504_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_505_image2__def,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( bNF_Greatest_image2 @ C @ A @ B )
      = ( ^ [A6: set @ C,F3: C > A,G2: C > B] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu: product_prod @ A @ B] :
              ? [A5: C] :
                ( ( Uu
                  = ( product_Pair @ A @ B @ ( F3 @ A5 ) @ ( G2 @ A5 ) ) )
                & ( member @ C @ A5 @ A6 ) ) ) ) ) ).

% image2_def
thf(fact_506_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_507_vimage__ident,axiom,
    ! [A: $tType,Y4: set @ A] :
      ( ( vimage @ A @ A
        @ ^ [X2: A] : X2
        @ Y4 )
      = Y4 ) ).

% vimage_ident
thf(fact_508_vimage__Collect__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,P: B > $o] :
      ( ( vimage @ A @ B @ F2 @ ( collect @ B @ P ) )
      = ( collect @ A
        @ ^ [Y2: A] : ( P @ ( F2 @ Y2 ) ) ) ) ).

% vimage_Collect_eq
thf(fact_509_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ( times_times @ A @ A4 @ C2 )
            = ( times_times @ A @ B3 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A4 = B3 ) ) ) ) ).

% mult_cancel_right
thf(fact_510_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ( times_times @ A @ C2 @ A4 )
            = ( times_times @ A @ C2 @ B3 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A4 = B3 ) ) ) ) ).

% mult_cancel_left
thf(fact_511_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A4: A,B3: A] :
          ( ( ( times_times @ A @ A4 @ B3 )
            = ( zero_zero @ A ) )
          = ( ( A4
              = ( zero_zero @ A ) )
            | ( B3
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_512_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ A4 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_513_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A4 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_514_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A4: A] :
          ( ( ( uminus_uminus @ A @ A4 )
            = A4 )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_515_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A4: A] :
          ( ( A4
            = ( uminus_uminus @ A @ A4 ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_516_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A] :
          ( ( ( uminus_uminus @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_517_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A4 ) )
          = ( ( zero_zero @ A )
            = A4 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_518_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_519_vimage__empty,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( vimage @ A @ B @ F2 @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% vimage_empty
thf(fact_520_vimage__Int,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ B,B2: set @ B] :
      ( ( vimage @ A @ B @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ A3 ) @ ( vimage @ A @ B @ F2 @ B2 ) ) ) ).

% vimage_Int
thf(fact_521_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A4: A,C2: A] :
          ( ( ( times_times @ A @ A4 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A4
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_522_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B3: A] :
          ( ( C2
            = ( times_times @ A @ B3 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B3
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_523_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A4: A] :
          ( ( ( times_times @ A @ C2 @ A4 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A4
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_524_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B3: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B3 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B3
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_525_vimage__const,axiom,
    ! [B: $tType,A: $tType,C2: B,A3: set @ B] :
      ( ( ( member @ B @ C2 @ A3 )
       => ( ( vimage @ A @ B
            @ ^ [X2: A] : C2
            @ A3 )
          = ( top_top @ ( set @ A ) ) ) )
      & ( ~ ( member @ B @ C2 @ A3 )
       => ( ( vimage @ A @ B
            @ ^ [X2: A] : C2
            @ A3 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% vimage_const
thf(fact_526_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_527_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X3: A] :
          ( ( ( zero_zero @ A )
            = X3 )
          = ( X3
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_528_semigroup__def,axiom,
    ! [A: $tType] :
      ( ( semigroup @ A )
      = ( ^ [F3: A > A > A] :
          ! [A5: A,B4: A,C5: A] :
            ( ( F3 @ ( F3 @ A5 @ B4 ) @ C5 )
            = ( F3 @ A5 @ ( F3 @ B4 @ C5 ) ) ) ) ) ).

% semigroup_def
thf(fact_529_semigroup_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ! [A7: A,B6: A,C4: A] :
          ( ( F2 @ ( F2 @ A7 @ B6 ) @ C4 )
          = ( F2 @ A7 @ ( F2 @ B6 @ C4 ) ) )
     => ( semigroup @ A @ F2 ) ) ).

% semigroup.intro
thf(fact_530_semigroup_Oassoc,axiom,
    ! [A: $tType,F2: A > A > A,A4: A,B3: A,C2: A] :
      ( ( semigroup @ A @ F2 )
     => ( ( F2 @ ( F2 @ A4 @ B3 ) @ C2 )
        = ( F2 @ A4 @ ( F2 @ B3 @ C2 ) ) ) ) ).

% semigroup.assoc
thf(fact_531_vimage__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( vimage @ A @ B )
      = ( ^ [F3: A > B,B5: set @ B] :
            ( collect @ A
            @ ^ [X2: A] : ( member @ B @ ( F3 @ X2 ) @ B5 ) ) ) ) ).

% vimage_def
thf(fact_532_vimage__inter__cong,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B,G: A > B,Y: set @ B] :
      ( ! [W: A] :
          ( ( member @ A @ W @ S2 )
         => ( ( F2 @ W )
            = ( G @ W ) ) )
     => ( ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ Y ) @ S2 )
        = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ G @ Y ) @ S2 ) ) ) ).

% vimage_inter_cong
thf(fact_533_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A4 @ C2 )
              = ( times_times @ A @ B3 @ C2 ) )
            = ( A4 = B3 ) ) ) ) ).

% mult_right_cancel
thf(fact_534_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A4 )
              = ( times_times @ A @ C2 @ B3 ) )
            = ( A4 = B3 ) ) ) ) ).

% mult_left_cancel
thf(fact_535_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( B3
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A4 @ B3 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_536_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A4: A,B3: A] :
          ( ( ( times_times @ A @ A4 @ B3 )
            = ( zero_zero @ A ) )
         => ( ( A4
              = ( zero_zero @ A ) )
            | ( B3
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_537_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A4: A,B3: A] :
          ( ( ( times_times @ A @ A4 @ B3 )
           != ( zero_zero @ A ) )
         => ( ( A4
             != ( zero_zero @ A ) )
            & ( B3
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_538_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_539_mult_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ( semigroup @ A @ ( times_times @ A ) ) ) ).

% mult.semigroup_axioms
thf(fact_540_inf_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( semigroup @ A @ ( inf_inf @ A ) ) ) ).

% inf.semigroup_axioms
thf(fact_541_sup_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( semigroup @ A @ ( sup_sup @ A ) ) ) ).

% sup.semigroup_axioms
thf(fact_542_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_543_monoid_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( monoid @ A @ F2 @ Z2 )
     => ( semigroup @ A @ F2 ) ) ).

% monoid.axioms(1)
thf(fact_544_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_545_UNIV__Times__UNIV,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_Sigma @ A @ B @ ( top_top @ ( set @ A ) )
        @ ^ [Uu: A] : ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% UNIV_Times_UNIV
thf(fact_546_Compl__Times__UNIV1,axiom,
    ! [B: $tType,A: $tType,A3: set @ B] :
      ( ( uminus_uminus @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ ( top_top @ ( set @ A ) )
          @ ^ [Uu: A] : A3 ) )
      = ( product_Sigma @ A @ B @ ( top_top @ ( set @ A ) )
        @ ^ [Uu: A] : ( uminus_uminus @ ( set @ B ) @ A3 ) ) ) ).

% Compl_Times_UNIV1
thf(fact_547_Compl__Times__UNIV2,axiom,
    ! [B: $tType,A: $tType,A3: set @ A] :
      ( ( uminus_uminus @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : ( top_top @ ( set @ B ) ) ) )
      = ( product_Sigma @ A @ B @ ( uminus_uminus @ ( set @ A ) @ A3 )
        @ ^ [Uu: A] : ( top_top @ ( set @ B ) ) ) ) ).

% Compl_Times_UNIV2
thf(fact_548_Times__empty,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B] :
      ( ( ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( B2
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% Times_empty
thf(fact_549_Sigma__empty2,axiom,
    ! [B: $tType,A: $tType,A3: set @ A] :
      ( ( product_Sigma @ A @ B @ A3
        @ ^ [Uu: A] : ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% Sigma_empty2
thf(fact_550_Sigma__empty1,axiom,
    ! [B: $tType,A: $tType,B2: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ ( bot_bot @ ( set @ A ) ) @ B2 )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% Sigma_empty1
thf(fact_551_Sigma__Un__distrib2,axiom,
    ! [B: $tType,A: $tType,I: set @ A,A3: A > ( set @ B ),B2: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ I
        @ ^ [I2: A] : ( sup_sup @ ( set @ B ) @ ( A3 @ I2 ) @ ( B2 @ I2 ) ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I @ A3 ) @ ( product_Sigma @ A @ B @ I @ B2 ) ) ) ).

% Sigma_Un_distrib2
thf(fact_552_Times__Un__distrib1,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ A,C3: set @ B] :
      ( ( product_Sigma @ A @ B @ ( sup_sup @ ( set @ A ) @ A3 @ B2 )
        @ ^ [Uu: A] : C3 )
      = ( sup_sup @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : C3 )
        @ ( product_Sigma @ A @ B @ B2
          @ ^ [Uu: A] : C3 ) ) ) ).

% Times_Un_distrib1
thf(fact_553_Times__Int__distrib1,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ A,C3: set @ B] :
      ( ( product_Sigma @ A @ B @ ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        @ ^ [Uu: A] : C3 )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : C3 )
        @ ( product_Sigma @ A @ B @ B2
          @ ^ [Uu: A] : C3 ) ) ) ).

% Times_Int_distrib1
thf(fact_554_Sigma__Int__distrib2,axiom,
    ! [B: $tType,A: $tType,I: set @ A,A3: A > ( set @ B ),B2: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ I
        @ ^ [I2: A] : ( inf_inf @ ( set @ B ) @ ( A3 @ I2 ) @ ( B2 @ I2 ) ) )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I @ A3 ) @ ( product_Sigma @ A @ B @ I @ B2 ) ) ) ).

% Sigma_Int_distrib2
thf(fact_555_Times__eq__cancel2,axiom,
    ! [A: $tType,B: $tType,X3: A,C3: set @ A,A3: set @ B,B2: set @ B] :
      ( ( member @ A @ X3 @ C3 )
     => ( ( ( product_Sigma @ B @ A @ A3
            @ ^ [Uu: B] : C3 )
          = ( product_Sigma @ B @ A @ B2
            @ ^ [Uu: B] : C3 ) )
        = ( A3 = B2 ) ) ) ).

% Times_eq_cancel2
thf(fact_556_Sigma__cong,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ A,C3: A > ( set @ B ),D2: A > ( set @ B )] :
      ( ( A3 = B2 )
     => ( ! [X: A] :
            ( ( member @ A @ X @ B2 )
           => ( ( C3 @ X )
              = ( D2 @ X ) ) )
       => ( ( product_Sigma @ A @ B @ A3 @ C3 )
          = ( product_Sigma @ A @ B @ B2 @ D2 ) ) ) ) ).

% Sigma_cong
thf(fact_557_times__eq__iff,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B,C3: set @ A,D2: set @ B] :
      ( ( ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 )
        = ( product_Sigma @ A @ B @ C3
          @ ^ [Uu: A] : D2 ) )
      = ( ( ( A3 = C3 )
          & ( B2 = D2 ) )
        | ( ( ( A3
              = ( bot_bot @ ( set @ A ) ) )
            | ( B2
              = ( bot_bot @ ( set @ B ) ) ) )
          & ( ( C3
              = ( bot_bot @ ( set @ A ) ) )
            | ( D2
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% times_eq_iff
thf(fact_558_Pair__vimage__Sigma,axiom,
    ! [B: $tType,A: $tType,X3: B,A3: set @ B,F2: B > ( set @ A )] :
      ( ( ( member @ B @ X3 @ A3 )
       => ( ( vimage @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X3 ) @ ( product_Sigma @ B @ A @ A3 @ F2 ) )
          = ( F2 @ X3 ) ) )
      & ( ~ ( member @ B @ X3 @ A3 )
       => ( ( vimage @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X3 ) @ ( product_Sigma @ B @ A @ A3 @ F2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Pair_vimage_Sigma
thf(fact_559_Sigma__Int__distrib1,axiom,
    ! [B: $tType,A: $tType,I: set @ A,J: set @ A,C3: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ ( inf_inf @ ( set @ A ) @ I @ J ) @ C3 )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I @ C3 ) @ ( product_Sigma @ A @ B @ J @ C3 ) ) ) ).

% Sigma_Int_distrib1
thf(fact_560_vimage__snd,axiom,
    ! [B: $tType,A: $tType,A3: set @ B] :
      ( ( vimage @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A3 )
      = ( product_Sigma @ A @ B @ ( top_top @ ( set @ A ) )
        @ ^ [Uu: A] : A3 ) ) ).

% vimage_snd
thf(fact_561_Sigma__empty__iff,axiom,
    ! [B: $tType,A: $tType,I: set @ A,X5: A > ( set @ B )] :
      ( ( ( product_Sigma @ A @ B @ I @ X5 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ I )
           => ( ( X5 @ X2 )
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ).

% Sigma_empty_iff
thf(fact_562_Times__Int__Times,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B,C3: set @ A,D2: set @ B] :
      ( ( inf_inf @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 )
        @ ( product_Sigma @ A @ B @ C3
          @ ^ [Uu: A] : D2 ) )
      = ( product_Sigma @ A @ B @ ( inf_inf @ ( set @ A ) @ A3 @ C3 )
        @ ^ [Uu: A] : ( inf_inf @ ( set @ B ) @ B2 @ D2 ) ) ) ).

% Times_Int_Times
thf(fact_563_relImage__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( bNF_Gr4221423524335903396lImage @ B @ A )
      = ( ^ [R2: set @ ( product_prod @ B @ B ),F3: B > A] :
            ( collect @ ( product_prod @ A @ A )
            @ ^ [Uu: product_prod @ A @ A] :
              ? [A1: B,A22: B] :
                ( ( Uu
                  = ( product_Pair @ A @ A @ ( F3 @ A1 ) @ ( F3 @ A22 ) ) )
                & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ A1 @ A22 ) @ R2 ) ) ) ) ) ).

% relImage_def
thf(fact_564_member__product,axiom,
    ! [B: $tType,A: $tType,X3: product_prod @ A @ B,A3: set @ A,B2: set @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ X3 @ ( product_product @ A @ B @ A3 @ B2 ) )
      = ( member @ ( product_prod @ A @ B ) @ X3
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 ) ) ) ).

% member_product
thf(fact_565_Product__Type_Oproduct__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_product @ A @ B )
      = ( ^ [A6: set @ A,B5: set @ B] :
            ( product_Sigma @ A @ B @ A6
            @ ^ [Uu: A] : B5 ) ) ) ).

% Product_Type.product_def
thf(fact_566_relInvImage__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Gr7122648621184425601vImage @ A @ B )
      = ( ^ [A6: set @ A,R2: set @ ( product_prod @ B @ B ),F3: A > B] :
            ( collect @ ( product_prod @ A @ A )
            @ ^ [Uu: product_prod @ A @ A] :
              ? [A1: A,A22: A] :
                ( ( Uu
                  = ( product_Pair @ A @ A @ A1 @ A22 ) )
                & ( member @ A @ A1 @ A6 )
                & ( member @ A @ A22 @ A6 )
                & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F3 @ A1 ) @ ( F3 @ A22 ) ) @ R2 ) ) ) ) ) ).

% relInvImage_def
thf(fact_567_fun__cong__unused__0,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( zero @ B )
     => ! [F2: ( A > B ) > C,G: C] :
          ( ( F2
            = ( ^ [X2: A > B] : G ) )
         => ( ( F2
              @ ^ [X2: A] : ( zero_zero @ B ) )
            = G ) ) ) ).

% fun_cong_unused_0
thf(fact_568_Sigma__UNIV__cancel,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,X5: set @ B] :
      ( ( minus_minus @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : X5 )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : ( top_top @ ( set @ B ) ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% Sigma_UNIV_cancel
thf(fact_569_snd__image__times,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,B2: set @ A] :
      ( ( ( A3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A )
            @ ( product_Sigma @ B @ A @ A3
              @ ^ [Uu: B] : B2 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A )
            @ ( product_Sigma @ B @ A @ A3
              @ ^ [Uu: B] : B2 ) )
          = B2 ) ) ) ).

% snd_image_times
thf(fact_570_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_571_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_572_image__vimage__eq,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ A] :
      ( ( image2 @ B @ A @ F2 @ ( vimage @ B @ A @ F2 @ A3 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ ( image2 @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) ).

% image_vimage_eq
thf(fact_573_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ( plus_plus @ A @ B3 @ A4 )
            = ( plus_plus @ A @ C2 @ A4 ) )
          = ( B3 = C2 ) ) ) ).

% add_right_cancel
thf(fact_574_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ( plus_plus @ A @ A4 @ B3 )
            = ( plus_plus @ A @ A4 @ C2 ) )
          = ( B3 = C2 ) ) ) ).

% add_left_cancel
thf(fact_575_minus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A6: A > B,B5: A > B,X2: A] : ( minus_minus @ B @ ( A6 @ X2 ) @ ( B5 @ X2 ) ) ) ) ) ).

% minus_apply
thf(fact_576_image__ident,axiom,
    ! [A: $tType,Y4: set @ A] :
      ( ( image2 @ A @ A
        @ ^ [X2: A] : X2
        @ Y4 )
      = Y4 ) ).

% image_ident
thf(fact_577_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A4: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A4 )
          = A4 ) ) ).

% add_0
thf(fact_578_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X3: A,Y: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X3 @ Y ) )
          = ( ( X3
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_579_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X3: A,Y: A] :
          ( ( ( plus_plus @ A @ X3 @ Y )
            = ( zero_zero @ A ) )
          = ( ( X3
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_580_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
            = ( plus_plus @ A @ A4 @ B3 ) )
          = ( B3
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_581_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
            = ( plus_plus @ A @ B3 @ A4 ) )
          = ( B3
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_582_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ( plus_plus @ A @ A4 @ B3 )
            = A4 )
          = ( B3
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_583_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B3: A,A4: A] :
          ( ( ( plus_plus @ A @ B3 @ A4 )
            = A4 )
          = ( B3
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_584_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A4: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A4 @ A4 ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_585_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A4: A] :
          ( ( plus_plus @ A @ A4 @ ( zero_zero @ A ) )
          = A4 ) ) ).

% add.right_neutral
thf(fact_586_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A4: A] :
          ( ( minus_minus @ A @ A4 @ A4 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_587_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A4: A] :
          ( ( minus_minus @ A @ A4 @ ( zero_zero @ A ) )
          = A4 ) ) ).

% diff_zero
thf(fact_588_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A4: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A4 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_589_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A] :
          ( ( minus_minus @ A @ A4 @ ( zero_zero @ A ) )
          = A4 ) ) ).

% diff_0_right
thf(fact_590_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A] :
          ( ( minus_minus @ A @ A4 @ A4 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_591_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A4: A,B3: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A4 @ B3 ) @ B3 )
          = A4 ) ) ).

% add_diff_cancel_right'
thf(fact_592_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A4 @ C2 ) @ ( plus_plus @ A @ B3 @ C2 ) )
          = ( minus_minus @ A @ A4 @ B3 ) ) ) ).

% add_diff_cancel_right
thf(fact_593_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A4: A,B3: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A4 @ B3 ) @ A4 )
          = B3 ) ) ).

% add_diff_cancel_left'
thf(fact_594_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A4 ) @ ( plus_plus @ A @ C2 @ B3 ) )
          = ( minus_minus @ A @ A4 @ B3 ) ) ) ).

% add_diff_cancel_left
thf(fact_595_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A4 @ B3 ) @ B3 )
          = A4 ) ) ).

% diff_add_cancel
thf(fact_596_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A4 @ B3 ) @ B3 )
          = A4 ) ) ).

% add_diff_cancel
thf(fact_597_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A4 @ B3 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A4 ) @ ( uminus_uminus @ A @ B3 ) ) ) ) ).

% minus_add_distrib
thf(fact_598_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A4 ) @ ( plus_plus @ A @ A4 @ B3 ) )
          = B3 ) ) ).

% minus_add_cancel
thf(fact_599_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( plus_plus @ A @ A4 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A4 ) @ B3 ) )
          = B3 ) ) ).

% add_minus_cancel
thf(fact_600_image__empty,axiom,
    ! [B: $tType,A: $tType,F2: B > A] :
      ( ( image2 @ B @ A @ F2 @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% image_empty
thf(fact_601_empty__is__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( image2 @ B @ A @ F2 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ B ) ) ) ) ).

% empty_is_image
thf(fact_602_image__is__empty,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( ( image2 @ B @ A @ F2 @ A3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( A3
        = ( bot_bot @ ( set @ B ) ) ) ) ).

% image_is_empty
thf(fact_603_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A4 @ B3 ) )
          = ( minus_minus @ A @ B3 @ A4 ) ) ) ).

% minus_diff_eq
thf(fact_604_Diff__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = A3 ) ).

% Diff_empty
thf(fact_605_empty__Diff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% empty_Diff
thf(fact_606_Diff__cancel,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_cancel
thf(fact_607_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A4: A,B3: A] :
          ( ( minus_minus @ A @ A4 @ ( plus_plus @ A @ A4 @ B3 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_608_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_609_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A4 ) @ A4 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_610_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A] :
          ( ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ A4 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_611_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A4 )
          = ( uminus_uminus @ A @ A4 ) ) ) ).

% diff_0
thf(fact_612_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A4 ) @ B3 )
          = ( minus_minus @ A @ B3 @ A4 ) ) ) ).

% uminus_add_conv_diff
thf(fact_613_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( minus_minus @ A @ A4 @ ( uminus_uminus @ A @ B3 ) )
          = ( plus_plus @ A @ A4 @ B3 ) ) ) ).

% diff_minus_eq_add
thf(fact_614_Diff__UNIV,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_UNIV
thf(fact_615_Diff__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B2 @ A3 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_disjoint
thf(fact_616_inter__compl__diff__conv,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ B2 ) )
      = ( minus_minus @ ( set @ A ) @ A3 @ B2 ) ) ).

% inter_compl_diff_conv
thf(fact_617_Diff__Compl,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ).

% Diff_Compl
thf(fact_618_if__image__distrib,axiom,
    ! [A: $tType,B: $tType,P: B > $o,F2: B > A,G: B > A,S2: set @ B] :
      ( ( image2 @ B @ A
        @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ S2 )
      = ( sup_sup @ ( set @ A ) @ ( image2 @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ S2 @ ( collect @ B @ P ) ) )
        @ ( image2 @ B @ A @ G
          @ ( inf_inf @ ( set @ B ) @ S2
            @ ( collect @ B
              @ ^ [X2: B] :
                  ~ ( P @ X2 ) ) ) ) ) ) ).

% if_image_distrib
thf(fact_619_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_620_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,K: A,B3: A,A4: A] :
          ( ( B2
            = ( plus_plus @ A @ K @ B3 ) )
         => ( ( minus_minus @ A @ A4 @ B2 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A4 @ B3 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_621_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ A5 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_622_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ A5 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_623_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A4 @ B3 ) @ C2 )
          = ( minus_minus @ A @ A4 @ ( plus_plus @ A @ B3 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_624_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A4 @ C2 ) @ B3 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% cancel_ab_semigroup_add_class.diff_right_commute
thf(fact_625_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ( plus_plus @ A @ C2 @ B3 )
            = A4 )
         => ( C2
            = ( minus_minus @ A @ A4 @ B3 ) ) ) ) ).

% add_implies_diff
thf(fact_626_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ( plus_plus @ A @ B3 @ A4 )
            = ( plus_plus @ A @ C2 @ A4 ) )
         => ( B3 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_627_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( minus_minus @ A @ A4 @ ( plus_plus @ A @ B3 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A4 @ C2 ) @ B3 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_628_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ( plus_plus @ A @ A4 @ B3 )
            = ( plus_plus @ A @ A4 @ C2 ) )
         => ( B3 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_629_ab__semigroup__add__class_Oadd_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( plus_plus @ A @ B3 @ ( plus_plus @ A @ A4 @ C2 ) )
          = ( plus_plus @ A @ A4 @ ( plus_plus @ A @ B3 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add.left_commute
thf(fact_630_ab__semigroup__add__class_Oadd_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ B4 @ A5 ) ) ) ) ).

% ab_semigroup_add_class.add.commute
thf(fact_631_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ( plus_plus @ A @ B3 @ A4 )
            = ( plus_plus @ A @ C2 @ A4 ) )
          = ( B3 = C2 ) ) ) ).

% add.right_cancel
thf(fact_632_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ( minus_minus @ A @ A4 @ B3 )
            = ( minus_minus @ A @ C2 @ D3 ) )
         => ( ( A4 = B3 )
            = ( C2 = D3 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_633_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ( plus_plus @ A @ A4 @ B3 )
            = ( plus_plus @ A @ A4 @ C2 ) )
          = ( B3 = C2 ) ) ) ).

% add.left_cancel
thf(fact_634_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A4 @ B3 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A4 @ C2 ) @ B3 ) ) ) ).

% diff_add_eq
thf(fact_635_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A4 @ B3 ) @ C2 )
          = ( plus_plus @ A @ A4 @ ( plus_plus @ A @ B3 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_636_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( minus_minus @ A @ A4 @ ( minus_minus @ A @ B3 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A4 @ C2 ) @ B3 ) ) ) ).

% diff_diff_eq2
thf(fact_637_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( plus_plus @ A @ A4 @ ( minus_minus @ A @ B3 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_638_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( A4
            = ( minus_minus @ A @ C2 @ B3 ) )
          = ( ( plus_plus @ A @ A4 @ B3 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_639_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ( minus_minus @ A @ A4 @ B3 )
            = C2 )
          = ( A4
            = ( plus_plus @ A @ C2 @ B3 ) ) ) ) ).

% diff_eq_eq
thf(fact_640_add_Oright__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A4 @ B3 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ A4 @ C2 ) @ B3 ) ) ) ).

% add.right_commute
thf(fact_641_add_Oright__assoc,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A4 @ B3 ) @ C2 )
          = ( plus_plus @ A @ A4 @ ( plus_plus @ A @ B3 @ C2 ) ) ) ) ).

% add.right_assoc
thf(fact_642_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A4: A,B3: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A4 ) )
         => ( ( minus_minus @ A @ A3 @ B3 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A4 @ B3 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_643_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B2: A,K: A,B3: A,A4: A] :
          ( ( B2
            = ( plus_plus @ A @ K @ B3 ) )
         => ( ( plus_plus @ A @ A4 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A4 @ B3 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_644_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A,K: A,A4: A,B3: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A4 ) )
         => ( ( plus_plus @ A @ A3 @ B3 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A4 @ B3 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_645_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( I3 = J2 )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I3 @ K )
            = ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_646_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A6: A > B,B5: A > B,X2: A] : ( minus_minus @ B @ ( A6 @ X2 ) @ ( B5 @ X2 ) ) ) ) ) ).

% fun_diff_def
thf(fact_647_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A4 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B3 @ E2 ) @ D3 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A4 @ B3 ) @ E2 ) @ C2 )
            = D3 ) ) ) ).

% eq_add_iff1
thf(fact_648_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A4 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B3 @ E2 ) @ D3 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B3 @ A4 ) @ E2 ) @ D3 ) ) ) ) ).

% eq_add_iff2
thf(fact_649_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X3: A,Y: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y @ Y ) )
          = ( times_times @ A @ ( plus_plus @ A @ X3 @ Y ) @ ( minus_minus @ A @ X3 @ Y ) ) ) ) ).

% square_diff_square_factored
thf(fact_650_imageE,axiom,
    ! [A: $tType,B: $tType,B3: A,F2: B > A,A3: set @ B] :
      ( ( member @ A @ B3 @ ( image2 @ B @ A @ F2 @ A3 ) )
     => ~ ! [X: B] :
            ( ( B3
              = ( F2 @ X ) )
           => ~ ( member @ B @ X @ A3 ) ) ) ).

% imageE
thf(fact_651_image__image,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,G: C > B,A3: set @ C] :
      ( ( image2 @ B @ A @ F2 @ ( image2 @ C @ B @ G @ A3 ) )
      = ( image2 @ C @ A
        @ ^ [X2: C] : ( F2 @ ( G @ X2 ) )
        @ A3 ) ) ).

% image_image
thf(fact_652_Compr__image__eq,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,P: A > $o] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ ( image2 @ B @ A @ F2 @ A3 ) )
            & ( P @ X2 ) ) )
      = ( image2 @ B @ A @ F2
        @ ( collect @ B
          @ ^ [X2: B] :
              ( ( member @ B @ X2 @ A3 )
              & ( P @ ( F2 @ X2 ) ) ) ) ) ) ).

% Compr_image_eq
thf(fact_653_set__diff__eq,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A6: set @ A,B5: set @ A] :
            ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A6 )
                & ~ ( member @ A @ X2 @ B5 ) ) ) ) ) ).

% set_diff_eq
thf(fact_654_Times__Diff__distrib1,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ A,C3: set @ B] :
      ( ( product_Sigma @ A @ B @ ( minus_minus @ ( set @ A ) @ A3 @ B2 )
        @ ^ [Uu: A] : C3 )
      = ( minus_minus @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : C3 )
        @ ( product_Sigma @ A @ B @ B2
          @ ^ [Uu: A] : C3 ) ) ) ).

% Times_Diff_distrib1
thf(fact_655_Sigma__Diff__distrib2,axiom,
    ! [B: $tType,A: $tType,I: set @ A,A3: A > ( set @ B ),B2: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ I
        @ ^ [I2: A] : ( minus_minus @ ( set @ B ) @ ( A3 @ I2 ) @ ( B2 @ I2 ) ) )
      = ( minus_minus @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I @ A3 ) @ ( product_Sigma @ A @ B @ I @ B2 ) ) ) ).

% Sigma_Diff_distrib2
thf(fact_656_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X3 @ ( one_one @ A ) ) @ ( minus_minus @ A @ X3 @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_657_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( minus_minus @ A @ A5 @ B4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_658_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ A4 @ ( minus_minus @ A @ B3 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A4 @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_659_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B3 @ C2 ) @ A4 )
          = ( minus_minus @ A @ ( times_times @ A @ B3 @ A4 ) @ ( times_times @ A @ C2 @ A4 ) ) ) ) ).

% left_diff_distrib'
thf(fact_660_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ A4 @ ( minus_minus @ A @ B3 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A4 @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_661_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A4 @ B3 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_662_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B3: A,A4: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B3 ) @ A4 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A4 ) @ B3 ) ) ) ).

% minus_diff_commute
thf(fact_663_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A4 )
          = A4 ) ) ).

% add.group_left_neutral
thf(fact_664_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: A] :
          ( ( plus_plus @ A @ A4 @ ( zero_zero @ A ) )
          = A4 ) ) ).

% add.comm_neutral
thf(fact_665_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A4 )
          = A4 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_666_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A4: A,E2: A,B3: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A4 @ E2 ) @ ( plus_plus @ A @ ( times_times @ A @ B3 @ E2 ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A4 @ B3 ) @ E2 ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_667_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A4 @ B3 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_668_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ A4 @ ( plus_plus @ A @ B3 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A4 @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_669_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A4 @ B3 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_670_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ A4 @ ( plus_plus @ A @ B3 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A4 @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_671_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A4 @ B3 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_672_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A4 @ B3 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B3 ) @ ( uminus_uminus @ A @ A4 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_673_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A4: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A4 ) )
         => ( ( uminus_uminus @ A @ A3 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A4 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_674_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X2: A] : ( minus_minus @ A @ ( plus_plus @ A @ X2 @ X2 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_675_Int__Diff,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,C3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ C3 )
      = ( inf_inf @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B2 @ C3 ) ) ) ).

% Int_Diff
thf(fact_676_Diff__Int2,axiom,
    ! [A: $tType,A3: set @ A,C3: set @ A,B2: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C3 ) @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C3 ) @ B2 ) ) ).

% Diff_Int2
thf(fact_677_Diff__Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ).

% Diff_Diff_Int
thf(fact_678_Diff__Int__distrib,axiom,
    ! [A: $tType,C3: set @ A,A3: set @ A,B2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ C3 @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ C3 @ A3 ) @ ( inf_inf @ ( set @ A ) @ C3 @ B2 ) ) ) ).

% Diff_Int_distrib
thf(fact_679_Diff__Int__distrib2,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,C3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) @ C3 )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C3 ) @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) ) ) ).

% Diff_Int_distrib2
thf(fact_680_add_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ( semigroup @ A @ ( plus_plus @ A ) ) ) ).

% add.semigroup_axioms
thf(fact_681_Setcompr__eq__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( collect @ A
        @ ^ [Uu: A] :
          ? [X2: B] :
            ( ( Uu
              = ( F2 @ X2 ) )
            & ( member @ B @ X2 @ A3 ) ) )
      = ( image2 @ B @ A @ F2 @ A3 ) ) ).

% Setcompr_eq_image
thf(fact_682_setcompr__eq__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,P: B > $o] :
      ( ( collect @ A
        @ ^ [Uu: A] :
          ? [X2: B] :
            ( ( Uu
              = ( F2 @ X2 ) )
            & ( P @ X2 ) ) )
      = ( image2 @ B @ A @ F2 @ ( collect @ B @ P ) ) ) ).

% setcompr_eq_image
thf(fact_683_range__composition,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: C > A,G: B > C] :
      ( ( image2 @ B @ A
        @ ^ [X2: B] : ( F2 @ ( G @ X2 ) )
        @ ( top_top @ ( set @ B ) ) )
      = ( image2 @ C @ A @ F2 @ ( image2 @ B @ C @ G @ ( top_top @ ( set @ B ) ) ) ) ) ).

% range_composition
thf(fact_684_rangeE,axiom,
    ! [A: $tType,B: $tType,B3: A,F2: B > A] :
      ( ( member @ A @ B3 @ ( image2 @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ~ ! [X: B] :
            ( B3
           != ( F2 @ X ) ) ) ).

% rangeE
thf(fact_685_add_Oac__operator__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( syntax_ac_operator @ A @ ( plus_plus @ A ) ) ) ).

% add.ac_operator_axioms
thf(fact_686_add_Osafe__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [X3: A,Y: A,A4: A,B3: A] :
          ( ( syntax7388354845996824322omatch @ A @ A @ ( plus_plus @ A @ X3 @ Y ) @ A4 )
         => ( ( plus_plus @ A @ A4 @ B3 )
            = ( plus_plus @ A @ B3 @ A4 ) ) ) ) ).

% add.safe_commute
thf(fact_687_diff__eq,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( ( minus_minus @ A )
        = ( ^ [X2: A,Y2: A] : ( inf_inf @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) ) ) ) ) ).

% diff_eq
thf(fact_688_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ( uminus_uminus @ A @ A4 )
            = B3 )
          = ( ( plus_plus @ A @ A4 @ B3 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_689_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
            = ( uminus_uminus @ A @ B3 ) )
          = ( ( plus_plus @ A @ A4 @ B3 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_690_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ( plus_plus @ A @ A4 @ B3 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A4 )
            = B3 ) ) ) ).

% add.inverse_unique
thf(fact_691_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A4 ) @ A4 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_692_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ( plus_plus @ A @ A4 @ B3 )
            = ( zero_zero @ A ) )
          = ( B3
            = ( uminus_uminus @ A @ A4 ) ) ) ) ).

% add_eq_0_iff
thf(fact_693_disjoint__alt__simp1,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A3 @ B2 )
        = A3 )
      = ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% disjoint_alt_simp1
thf(fact_694_disjoint__alt__simp2,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ B2 )
         != A3 ) )
      = ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjoint_alt_simp2
thf(fact_695_Diff__triv,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( minus_minus @ ( set @ A ) @ A3 @ B2 )
        = A3 ) ) ).

% Diff_triv
thf(fact_696_Int__Diff__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_Diff_disjoint
thf(fact_697_Diff__Un,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,C3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) )
      = ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) @ ( minus_minus @ ( set @ A ) @ A3 @ C3 ) ) ) ).

% Diff_Un
thf(fact_698_Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,C3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) @ ( minus_minus @ ( set @ A ) @ A3 @ C3 ) ) ) ).

% Diff_Int
thf(fact_699_Int__Diff__Un,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) )
      = A3 ) ).

% Int_Diff_Un
thf(fact_700_Un__Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
      = A3 ) ).

% Un_Diff_Int
thf(fact_701_add_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ( comm_monoid @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% add.comm_monoid_axioms
thf(fact_702_add_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( monoid @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% add.monoid_axioms
thf(fact_703_full__SetCompr__eq,axiom,
    ! [A: $tType,B: $tType,F2: B > A] :
      ( ( collect @ A
        @ ^ [U: A] :
          ? [X2: B] :
            ( U
            = ( F2 @ X2 ) ) )
      = ( image2 @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ).

% full_SetCompr_eq
thf(fact_704_sum__list_Omonoid__list__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( groups_monoid_list @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% sum_list.monoid_list_axioms
thf(fact_705_sum__list_Ocomm__monoid__list__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ( groups1828464146339083142d_list @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% sum_list.comm_monoid_list_axioms
thf(fact_706_sum_Ocomm__monoid__list__set__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ( groups4802862169904069756st_set @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% sum.comm_monoid_list_set_axioms
thf(fact_707_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X2: A] : ( plus_plus @ A @ ( plus_plus @ A @ X2 @ X2 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_708_surj__diff__right,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A] :
          ( ( image2 @ A @ A
            @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A4 )
            @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_diff_right
thf(fact_709_surj__vimage__empty,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ A] :
      ( ( ( image2 @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ( vimage @ B @ A @ F2 @ A3 )
          = ( bot_bot @ ( set @ B ) ) )
        = ( A3
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% surj_vimage_empty
thf(fact_710_translation__subtract__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,T3: set @ A] :
          ( ( image2 @ A @ A
            @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A4 )
            @ ( uminus_uminus @ ( set @ A ) @ T3 ) )
          = ( uminus_uminus @ ( set @ A )
            @ ( image2 @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A4 )
              @ T3 ) ) ) ) ).

% translation_subtract_Compl
thf(fact_711_translation__subtract__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,S3: set @ A,T3: set @ A] :
          ( ( image2 @ A @ A
            @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A4 )
            @ ( minus_minus @ ( set @ A ) @ S3 @ T3 ) )
          = ( minus_minus @ ( set @ A )
            @ ( image2 @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A4 )
              @ S3 )
            @ ( image2 @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A4 )
              @ T3 ) ) ) ) ).

% translation_subtract_diff
thf(fact_712_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,S3: set @ A,T3: set @ A] :
          ( ( image2 @ A @ A
            @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A4 )
            @ ( inf_inf @ ( set @ A ) @ S3 @ T3 ) )
          = ( inf_inf @ ( set @ A )
            @ ( image2 @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A4 )
              @ S3 )
            @ ( image2 @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A4 )
              @ T3 ) ) ) ) ).

% translation_subtract_Int
thf(fact_713_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,S3: set @ A,T3: set @ A] :
          ( ( image2 @ A @ A @ ( plus_plus @ A @ A4 ) @ ( inf_inf @ ( set @ A ) @ S3 @ T3 ) )
          = ( inf_inf @ ( set @ A ) @ ( image2 @ A @ A @ ( plus_plus @ A @ A4 ) @ S3 ) @ ( image2 @ A @ A @ ( plus_plus @ A @ A4 ) @ T3 ) ) ) ) ).

% translation_Int
thf(fact_714_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R5: A,A4: A,B3: A,C2: A,D3: A] :
          ( ( R5
           != ( zero_zero @ A ) )
         => ( ( ( A4 = B3 )
              & ( C2 != D3 ) )
           => ( ( plus_plus @ A @ A4 @ ( times_times @ A @ R5 @ C2 ) )
             != ( plus_plus @ A @ B3 @ ( times_times @ A @ R5 @ D3 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_715_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X3: A,Y: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y @ Y ) )
            = ( zero_zero @ A ) )
          = ( ( X3
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_716_pairself__image__cart,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ B,B2: set @ B] :
      ( ( image2 @ ( product_prod @ B @ B ) @ ( product_prod @ A @ A ) @ ( pairself @ B @ A @ F2 )
        @ ( product_Sigma @ B @ B @ A3
          @ ^ [Uu: B] : B2 ) )
      = ( product_Sigma @ A @ A @ ( image2 @ B @ A @ F2 @ A3 )
        @ ^ [Uu: A] : ( image2 @ B @ A @ F2 @ B2 ) ) ) ).

% pairself_image_cart
thf(fact_717_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D2: A,Q: A > $o] :
          ( ! [X: A,K2: A] :
              ( ( P @ X )
              = ( P @ ( minus_minus @ A @ X @ ( times_times @ A @ K2 @ D2 ) ) ) )
         => ( ! [X: A,K2: A] :
                ( ( Q @ X )
                = ( Q @ ( minus_minus @ A @ X @ ( times_times @ A @ K2 @ D2 ) ) ) )
           => ! [X4: A,K3: A] :
                ( ( ( P @ X4 )
                  & ( Q @ X4 ) )
                = ( ( P @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) )
                  & ( Q @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_718_minus__set__def,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A6: set @ A,B5: set @ A] :
            ( collect @ A
            @ ( minus_minus @ ( A > $o )
              @ ^ [X2: A] : ( member @ A @ X2 @ A6 )
              @ ^ [X2: A] : ( member @ A @ X2 @ B5 ) ) ) ) ) ).

% minus_set_def
thf(fact_719_minus__assn__def,axiom,
    ( ( minus_minus @ assn )
    = ( ^ [A5: assn,B4: assn] : ( inf_inf @ assn @ A5 @ ( uminus_uminus @ assn @ B4 ) ) ) ) ).

% minus_assn_def
thf(fact_720_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W2: A,Y: A,X3: A,Z2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W2 @ Y ) @ ( times_times @ A @ X3 @ Z2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ W2 @ Z2 ) @ ( times_times @ A @ X3 @ Y ) ) )
          = ( ( W2 = X3 )
            | ( Y = Z2 ) ) ) ) ).

% crossproduct_eq
thf(fact_721_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ( A4 != B3 )
            & ( C2 != D3 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ D3 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A4 @ D3 ) @ ( times_times @ A @ B3 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_722_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D2: A,Q: A > $o] :
          ( ! [X: A,K2: A] :
              ( ( P @ X )
              = ( P @ ( minus_minus @ A @ X @ ( times_times @ A @ K2 @ D2 ) ) ) )
         => ( ! [X: A,K2: A] :
                ( ( Q @ X )
                = ( Q @ ( minus_minus @ A @ X @ ( times_times @ A @ K2 @ D2 ) ) ) )
           => ! [X4: A,K3: A] :
                ( ( ( P @ X4 )
                  | ( Q @ X4 ) )
                = ( ( P @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) )
                  | ( Q @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_723_image__split__eq__Sigma,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: C > A,G: C > B,A3: set @ C] :
      ( ( image2 @ C @ ( product_prod @ A @ B )
        @ ^ [X2: C] : ( product_Pair @ A @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ A3 )
      = ( product_Sigma @ A @ B @ ( image2 @ C @ A @ F2 @ A3 )
        @ ^ [X2: A] : ( image2 @ C @ B @ G @ ( inf_inf @ ( set @ C ) @ ( vimage @ C @ A @ F2 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ A3 ) ) ) ) ).

% image_split_eq_Sigma
thf(fact_724_relImage__relInvImage,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ A ),F2: B > A,A3: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R
        @ ( product_Sigma @ A @ A @ ( image2 @ B @ A @ F2 @ A3 )
          @ ^ [Uu: A] : ( image2 @ B @ A @ F2 @ A3 ) ) )
     => ( ( bNF_Gr4221423524335903396lImage @ B @ A @ ( bNF_Gr7122648621184425601vImage @ B @ A @ A3 @ R @ F2 ) @ F2 )
        = R ) ) ).

% relImage_relInvImage
thf(fact_725_pairself__image__eq,axiom,
    ! [B: $tType,A: $tType,F2: B > A,P: B > B > $o] :
      ( ( image2 @ ( product_prod @ B @ B ) @ ( product_prod @ A @ A ) @ ( pairself @ B @ A @ F2 ) @ ( collect @ ( product_prod @ B @ B ) @ ( product_case_prod @ B @ B @ $o @ P ) ) )
      = ( collect @ ( product_prod @ A @ A )
        @ ^ [Uu: product_prod @ A @ A] :
          ? [A5: B,B4: B] :
            ( ( Uu
              = ( product_Pair @ A @ A @ ( F2 @ A5 ) @ ( F2 @ B4 ) ) )
            & ( P @ A5 @ B4 ) ) ) ) ).

% pairself_image_eq
thf(fact_726_rtrancl__restrictI,axiom,
    ! [A: $tType,U2: A,V: A,E3: set @ ( product_prod @ A @ A ),R: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U2 @ V )
        @ ( transitive_rtrancl @ A
          @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ E3
            @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
              @ ^ [Uu: A] : R ) ) ) )
     => ( ~ ( member @ A @ U2 @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U2 @ V ) @ ( transitive_rtrancl @ A @ ( rel_restrict @ A @ E3 @ R ) ) ) ) ) ).

% rtrancl_restrictI
thf(fact_727_the__elem__image__unique,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B,X3: A] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [Y3: A] :
            ( ( member @ A @ Y3 @ A3 )
           => ( ( F2 @ Y3 )
              = ( F2 @ X3 ) ) )
       => ( ( the_elem @ B @ ( image2 @ A @ B @ F2 @ A3 ) )
          = ( F2 @ X3 ) ) ) ) ).

% the_elem_image_unique
thf(fact_728_Sup_OSUP__identity__eq,axiom,
    ! [A: $tType,Sup: ( set @ A ) > A,A3: set @ A] :
      ( ( Sup
        @ ( image2 @ A @ A
          @ ^ [X2: A] : X2
          @ A3 ) )
      = ( Sup @ A3 ) ) ).

% Sup.SUP_identity_eq
thf(fact_729_Inf_OINF__identity__eq,axiom,
    ! [A: $tType,Inf: ( set @ A ) > A,A3: set @ A] :
      ( ( Inf
        @ ( image2 @ A @ A
          @ ^ [X2: A] : X2
          @ A3 ) )
      = ( Inf @ A3 ) ) ).

% Inf.INF_identity_eq
thf(fact_730_inj__on__Un,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B2: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
      = ( ( inj_on @ A @ B @ F2 @ A3 )
        & ( inj_on @ A @ B @ F2 @ B2 )
        & ( ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) ) @ ( image2 @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B2 @ A3 ) ) )
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% inj_on_Un
thf(fact_731_add_Ogroup__axioms,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( group @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A ) ) ) ).

% add.group_axioms
thf(fact_732_vimage__fst,axiom,
    ! [B: $tType,A: $tType,A3: set @ A] :
      ( ( vimage @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A3 )
      = ( product_Sigma @ A @ B @ A3
        @ ^ [Uu: A] : ( top_top @ ( set @ B ) ) ) ) ).

% vimage_fst
thf(fact_733_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A] : ( ord_less_eq @ A @ A4 @ A4 ) ) ).

% dual_order.refl
thf(fact_734_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ X3 @ X3 ) ) ).

% order_refl
thf(fact_735_split__part,axiom,
    ! [B: $tType,A: $tType,P: $o,Q: A > B > $o] :
      ( ( product_case_prod @ A @ B @ $o
        @ ^ [A5: A,B4: B] :
            ( P
            & ( Q @ A5 @ B4 ) ) )
      = ( ^ [Ab: product_prod @ A @ B] :
            ( P
            & ( product_case_prod @ A @ B @ $o @ Q @ Ab ) ) ) ) ).

% split_part
thf(fact_736_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_737_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ C2 ) @ ( plus_plus @ A @ B3 @ C2 ) )
          = ( ord_less_eq @ A @ A4 @ B3 ) ) ) ).

% add_le_cancel_right
thf(fact_738_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A4 ) @ ( plus_plus @ A @ C2 @ B3 ) )
          = ( ord_less_eq @ A @ A4 @ B3 ) ) ) ).

% add_le_cancel_left
thf(fact_739_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ ( uminus_uminus @ A @ A4 ) )
          = ( ord_less_eq @ A @ A4 @ B3 ) ) ) ).

% neg_le_iff_le
thf(fact_740_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X3 ) ) ) ).

% compl_le_compl_iff
thf(fact_741_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( ( ord_less_eq @ A @ X3 @ Y )
            & ( ord_less_eq @ A @ X3 @ Z2 ) ) ) ) ).

% le_inf_iff
thf(fact_742_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ ( inf_inf @ A @ B3 @ C2 ) )
          = ( ( ord_less_eq @ A @ A4 @ B3 )
            & ( ord_less_eq @ A @ A4 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_743_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B3 @ C2 ) @ A4 )
          = ( ( ord_less_eq @ A @ B3 @ A4 )
            & ( ord_less_eq @ A @ C2 @ A4 ) ) ) ) ).

% sup.bounded_iff
thf(fact_744_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X3 @ Y ) @ Z2 )
          = ( ( ord_less_eq @ A @ X3 @ Z2 )
            & ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% le_sup_iff
thf(fact_745_subset__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_empty
thf(fact_746_empty__subsetI,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 ) ).

% empty_subsetI
thf(fact_747_singletonI,axiom,
    ! [A: $tType,A4: A] : ( member @ A @ A4 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% singletonI
thf(fact_748_Int__subset__iff,axiom,
    ! [A: $tType,C3: set @ A,A3: set @ A,B2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C3 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C3 @ A3 )
        & ( ord_less_eq @ ( set @ A ) @ C3 @ B2 ) ) ) ).

% Int_subset_iff
thf(fact_749_Int__insert__left__if0,axiom,
    ! [A: $tType,A4: A,C3: set @ A,B2: set @ A] :
      ( ~ ( member @ A @ A4 @ C3 )
     => ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A4 @ B2 ) @ C3 )
        = ( inf_inf @ ( set @ A ) @ B2 @ C3 ) ) ) ).

% Int_insert_left_if0
thf(fact_750_Int__insert__left__if1,axiom,
    ! [A: $tType,A4: A,C3: set @ A,B2: set @ A] :
      ( ( member @ A @ A4 @ C3 )
     => ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A4 @ B2 ) @ C3 )
        = ( insert @ A @ A4 @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) ) ) ) ).

% Int_insert_left_if1
thf(fact_751_insert__inter__insert,axiom,
    ! [A: $tType,A4: A,A3: set @ A,B2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A4 @ A3 ) @ ( insert @ A @ A4 @ B2 ) )
      = ( insert @ A @ A4 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ).

% insert_inter_insert
thf(fact_752_Int__insert__right__if0,axiom,
    ! [A: $tType,A4: A,A3: set @ A,B2: set @ A] :
      ( ~ ( member @ A @ A4 @ A3 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ B2 ) )
        = ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ).

% Int_insert_right_if0
thf(fact_753_Int__insert__right__if1,axiom,
    ! [A: $tType,A4: A,A3: set @ A,B2: set @ A] :
      ( ( member @ A @ A4 @ A3 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ B2 ) )
        = ( insert @ A @ A4 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% Int_insert_right_if1
thf(fact_754_inj__on__empty,axiom,
    ! [B: $tType,A: $tType,F2: A > B] : ( inj_on @ A @ B @ F2 @ ( bot_bot @ ( set @ A ) ) ) ).

% inj_on_empty
thf(fact_755_singleton__conv,axiom,
    ! [A: $tType,A4: A] :
      ( ( collect @ A
        @ ^ [X2: A] : ( X2 = A4 ) )
      = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% singleton_conv
thf(fact_756_singleton__conv2,axiom,
    ! [A: $tType,A4: A] :
      ( ( collect @ A
        @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
          @ A4 ) )
      = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% singleton_conv2
thf(fact_757_case__prod__conv,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: B > C > A,A4: B,B3: C] :
      ( ( product_case_prod @ B @ C @ A @ F2 @ ( product_Pair @ B @ C @ A4 @ B3 ) )
      = ( F2 @ A4 @ B3 ) ) ).

% case_prod_conv
thf(fact_758_eq__or__mem__image__simp,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A4: B,B2: set @ B] :
      ( ( collect @ A
        @ ^ [Uu: A] :
          ? [L2: B] :
            ( ( Uu
              = ( F2 @ L2 ) )
            & ( ( L2 = A4 )
              | ( member @ B @ L2 @ B2 ) ) ) )
      = ( insert @ A @ ( F2 @ A4 )
        @ ( collect @ A
          @ ^ [Uu: A] :
            ? [L2: B] :
              ( ( Uu
                = ( F2 @ L2 ) )
              & ( member @ B @ L2 @ B2 ) ) ) ) ) ).

% eq_or_mem_image_simp
thf(fact_759_case__prodI,axiom,
    ! [A: $tType,B: $tType,F2: A > B > $o,A4: A,B3: B] :
      ( ( F2 @ A4 @ B3 )
     => ( product_case_prod @ A @ B @ $o @ F2 @ ( product_Pair @ A @ B @ A4 @ B3 ) ) ) ).

% case_prodI
thf(fact_760_case__prodI2,axiom,
    ! [B: $tType,A: $tType,P5: product_prod @ A @ B,C2: A > B > $o] :
      ( ! [A7: A,B6: B] :
          ( ( P5
            = ( product_Pair @ A @ B @ A7 @ B6 ) )
         => ( C2 @ A7 @ B6 ) )
     => ( product_case_prod @ A @ B @ $o @ C2 @ P5 ) ) ).

% case_prodI2
thf(fact_761_Collect__case__prod,axiom,
    ! [B: $tType,A: $tType,P: A > $o,Q: B > $o] :
      ( ( collect @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [A5: A,B4: B] :
              ( ( P @ A5 )
              & ( Q @ B4 ) ) ) )
      = ( product_Sigma @ A @ B @ ( collect @ A @ P )
        @ ^ [Uu: A] : ( collect @ B @ Q ) ) ) ).

% Collect_case_prod
thf(fact_762_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A4 @ A4 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_763_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ A4 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_764_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ ( plus_plus @ A @ B3 @ A4 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 ) ) ) ).

% le_add_same_cancel2
thf(fact_765_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ ( plus_plus @ A @ A4 @ B3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 ) ) ) ).

% le_add_same_cancel1
thf(fact_766_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ B3 ) @ B3 )
          = ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_767_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B3 @ A4 ) @ B3 )
          = ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_768_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A4 @ B3 ) )
          = ( ord_less_eq @ A @ B3 @ A4 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_769_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A4 ) @ A4 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_770_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ A4 @ ( uminus_uminus @ A @ A4 ) )
          = ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_771_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A4 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 ) ) ) ).

% neg_le_0_iff_le
thf(fact_772_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A4 ) )
          = ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_773_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A4 @ B3 ) @ B3 )
            = A4 ) ) ) ).

% le_add_diff_inverse2
thf(fact_774_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( plus_plus @ A @ B3 @ ( minus_minus @ A @ A4 @ B3 ) )
            = A4 ) ) ) ).

% le_add_diff_inverse
thf(fact_775_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A4: A,A3: set @ A,B3: A] :
      ( ( ( insert @ A @ A4 @ A3 )
        = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A4 = B3 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq'
thf(fact_776_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B3: A,A4: A,A3: set @ A] :
      ( ( ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A4 @ A3 ) )
      = ( ( A4 = B3 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq
thf(fact_777_disjoint__insert_I2_J,axiom,
    ! [A: $tType,A3: set @ A,B3: A,B2: set @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( inf_inf @ ( set @ A ) @ A3 @ ( insert @ A @ B3 @ B2 ) ) )
      = ( ~ ( member @ A @ B3 @ A3 )
        & ( ( bot_bot @ ( set @ A ) )
          = ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% disjoint_insert(2)
thf(fact_778_disjoint__insert_I1_J,axiom,
    ! [A: $tType,B2: set @ A,A4: A,A3: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ B2 @ ( insert @ A @ A4 @ A3 ) )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ~ ( member @ A @ A4 @ B2 )
        & ( ( inf_inf @ ( set @ A ) @ B2 @ A3 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjoint_insert(1)
thf(fact_779_insert__disjoint_I2_J,axiom,
    ! [A: $tType,A4: A,A3: set @ A,B2: set @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( inf_inf @ ( set @ A ) @ ( insert @ A @ A4 @ A3 ) @ B2 ) )
      = ( ~ ( member @ A @ A4 @ B2 )
        & ( ( bot_bot @ ( set @ A ) )
          = ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% insert_disjoint(2)
thf(fact_780_insert__disjoint_I1_J,axiom,
    ! [A: $tType,A4: A,A3: set @ A,B2: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A4 @ A3 ) @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ~ ( member @ A @ A4 @ B2 )
        & ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% insert_disjoint(1)
thf(fact_781_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B2 ) ) ).

% Diff_eq_empty_iff
thf(fact_782_insert__Diff__single,axiom,
    ! [A: $tType,A4: A,A3: set @ A] :
      ( ( insert @ A @ A4 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A4 @ A3 ) ) ).

% insert_Diff_single
thf(fact_783_pair__imageI,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: A,B3: B,A3: set @ ( product_prod @ A @ B ),F2: A > B > C] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 ) @ A3 )
     => ( member @ C @ ( F2 @ A4 @ B3 ) @ ( image2 @ ( product_prod @ A @ B ) @ C @ ( product_case_prod @ A @ B @ C @ F2 ) @ A3 ) ) ) ).

% pair_imageI
thf(fact_784_the__elem__eq,axiom,
    ! [A: $tType,X3: A] :
      ( ( the_elem @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
      = X3 ) ).

% the_elem_eq
thf(fact_785_Collect__const__case__prod,axiom,
    ! [B: $tType,A: $tType,P: $o] :
      ( ( P
       => ( ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A5: A,B4: B] : P ) )
          = ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) )
      & ( ~ P
       => ( ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A5: A,B4: B] : P ) )
          = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% Collect_const_case_prod
thf(fact_786_subset__Compl__singleton,axiom,
    ! [A: $tType,A3: set @ A,B3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B3 @ A3 ) ) ) ).

% subset_Compl_singleton
thf(fact_787_range__constant,axiom,
    ! [B: $tType,A: $tType,X3: A] :
      ( ( image2 @ B @ A
        @ ^ [Uu: B] : X3
        @ ( top_top @ ( set @ B ) ) )
      = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% range_constant
thf(fact_788_insert__Times__insert,axiom,
    ! [B: $tType,A: $tType,A4: A,A3: set @ A,B3: B,B2: set @ B] :
      ( ( product_Sigma @ A @ B @ ( insert @ A @ A4 @ A3 )
        @ ^ [Uu: A] : ( insert @ B @ B3 @ B2 ) )
      = ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 )
        @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) )
          @ ( product_Sigma @ A @ B @ A3
            @ ^ [Uu: A] : ( insert @ B @ B3 @ B2 ) )
          @ ( product_Sigma @ A @ B @ ( insert @ A @ A4 @ A3 )
            @ ^ [Uu: A] : B2 ) ) ) ) ).

% insert_Times_insert
thf(fact_789_fst__image__times,axiom,
    ! [B: $tType,A: $tType,B2: set @ B,A3: set @ A] :
      ( ( ( B2
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B )
            @ ( product_Sigma @ A @ B @ A3
              @ ^ [Uu: A] : B2 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( B2
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B )
            @ ( product_Sigma @ A @ B @ A3
              @ ^ [Uu: A] : B2 ) )
          = A3 ) ) ) ).

% fst_image_times
thf(fact_790_inj__on__insert,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A4: A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert @ A @ A4 @ A3 ) )
      = ( ( inj_on @ A @ B @ F2 @ A3 )
        & ~ ( member @ B @ ( F2 @ A4 ) @ ( image2 @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% inj_on_insert
thf(fact_791_inj__on__id2,axiom,
    ! [A: $tType,A3: set @ A] :
      ( inj_on @ A @ A
      @ ^ [X2: A] : X2
      @ A3 ) ).

% inj_on_id2
thf(fact_792_prod_Odisc__eq__case,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod @ A @ B] :
      ( product_case_prod @ A @ B @ $o
      @ ^ [Uu: A,Uv: B] : $true
      @ Prod ) ).

% prod.disc_eq_case
thf(fact_793_subset__singletonD,axiom,
    ! [A: $tType,A3: set @ A,X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( A3
          = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singletonD
thf(fact_794_subset__singleton__iff,axiom,
    ! [A: $tType,X5: set @ A,A4: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X5
          = ( bot_bot @ ( set @ A ) ) )
        | ( X5
          = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singleton_iff
thf(fact_795_fst__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( product_case_prod @ A @ B @ A
        @ ^ [X1: A,X22: B] : X1 ) ) ).

% fst_def
thf(fact_796_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X3: A] :
          ( ( ord_less_eq @ A @ Y @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ Y )
            = ( X3 = Y ) ) ) ) ).

% order_antisym_conv
thf(fact_797_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X3 @ Y )
         => ( ord_less_eq @ A @ Y @ X3 ) ) ) ).

% linorder_le_cases
thf(fact_798_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A4: A,B3: A,F2: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ( F2 @ B3 )
              = C2 )
           => ( ! [X: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X @ Y3 )
                 => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A4 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_799_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A4: A,F2: B > A,B3: B,C2: B] :
          ( ( A4
            = ( F2 @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C2 )
           => ( ! [X: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X @ Y3 )
                 => ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ A @ A4 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_800_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
          | ( ord_less_eq @ A @ Y @ X3 ) ) ) ).

% linorder_linear
thf(fact_801_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y: A] :
          ( ( X3 = Y )
         => ( ord_less_eq @ A @ X3 @ Y ) ) ) ).

% order_eq_refl
thf(fact_802_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A4: A,B3: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ C @ ( F2 @ B3 ) @ C2 )
           => ( ! [X: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X @ Y3 )
                 => ( ord_less_eq @ C @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A4 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_803_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A4: A,F2: B > A,B3: B,C2: B] :
          ( ( ord_less_eq @ A @ A4 @ ( F2 @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C2 )
           => ( ! [X: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X @ Y3 )
                 => ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less_eq @ A @ A4 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_804_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ( ord_less_eq @ A @ B4 @ A5 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_805_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B] :
            ! [X2: A] : ( ord_less_eq @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% le_fun_def
thf(fact_806_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B] :
          ( ! [X: A] : ( ord_less_eq @ B @ ( F2 @ X ) @ ( G @ X ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G ) ) ) ).

% le_funI
thf(fact_807_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) ) ) ).

% le_funE
thf(fact_808_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) ) ) ).

% le_funD
thf(fact_809_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ A4 )
           => ( A4 = B3 ) ) ) ) ).

% antisym
thf(fact_810_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( ord_less_eq @ A @ C2 @ B3 )
           => ( ord_less_eq @ A @ C2 @ A4 ) ) ) ) ).

% dual_order.trans
thf(fact_811_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( ord_less_eq @ A @ A4 @ B3 )
           => ( A4 = B3 ) ) ) ) ).

% dual_order.antisym
thf(fact_812_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ( ord_less_eq @ A @ A5 @ B4 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_813_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A4: A,B3: A] :
          ( ! [A7: A,B6: A] :
              ( ( ord_less_eq @ A @ A7 @ B6 )
             => ( P @ A7 @ B6 ) )
         => ( ! [A7: A,B6: A] :
                ( ( P @ B6 @ A7 )
               => ( P @ A7 @ B6 ) )
           => ( P @ A4 @ B3 ) ) ) ) ).

% linorder_wlog
thf(fact_814_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z2 )
           => ( ord_less_eq @ A @ X3 @ Z2 ) ) ) ) ).

% order_trans
thf(fact_815_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less_eq @ A @ A4 @ C2 ) ) ) ) ).

% order.trans
thf(fact_816_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( ord_less_eq @ A @ Y @ X3 )
           => ( X3 = Y ) ) ) ) ).

% order_antisym
thf(fact_817_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( B3 = C2 )
           => ( ord_less_eq @ A @ A4 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_818_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4 = B3 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less_eq @ A @ A4 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_819_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
        = ( ^ [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
              & ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_820_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X3 @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y @ X3 )
             => ~ ( ord_less_eq @ A @ X3 @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X3 @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X3 ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X3 ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X3 )
                     => ~ ( ord_less_eq @ A @ X3 @ Y ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_821_group_Oinverse__distrib__swap,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A4: A,B3: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( Inverse @ ( F2 @ A4 @ B3 ) )
        = ( F2 @ ( Inverse @ B3 ) @ ( Inverse @ A4 ) ) ) ) ).

% group.inverse_distrib_swap
thf(fact_822_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ~ ( ord_less_eq @ A @ A4 @ B3 ) )
          = ( ( ord_less_eq @ A @ B3 @ A4 )
            & ( B3 != A4 ) ) ) ) ).

% nle_le
thf(fact_823_group_Ogroup__left__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A4: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( F2 @ Z2 @ A4 )
        = A4 ) ) ).

% group.group_left_neutral
thf(fact_824_group_Oinverse__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( Inverse @ Z2 )
        = Z2 ) ) ).

% group.inverse_neutral
thf(fact_825_group_Oinverse__inverse,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A4: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( Inverse @ ( Inverse @ A4 ) )
        = A4 ) ) ).

% group.inverse_inverse
thf(fact_826_group_Oinverse__unique,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A4: A,B3: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( ( F2 @ A4 @ B3 )
          = Z2 )
       => ( ( Inverse @ A4 )
          = B3 ) ) ) ).

% group.inverse_unique
thf(fact_827_group_Oright__inverse,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A4: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( F2 @ A4 @ ( Inverse @ A4 ) )
        = Z2 ) ) ).

% group.right_inverse
thf(fact_828_group_Oright__cancel,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,B3: A,A4: A,C2: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( ( F2 @ B3 @ A4 )
          = ( F2 @ C2 @ A4 ) )
        = ( B3 = C2 ) ) ) ).

% group.right_cancel
thf(fact_829_group_Oleft__inverse,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A4: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( F2 @ ( Inverse @ A4 ) @ A4 )
        = Z2 ) ) ).

% group.left_inverse
thf(fact_830_group_Oleft__cancel,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A4: A,B3: A,C2: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( ( F2 @ A4 @ B3 )
          = ( F2 @ A4 @ C2 ) )
        = ( B3 = C2 ) ) ) ).

% group.left_cancel
thf(fact_831_nested__case__prod__simp,axiom,
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ ( D > A ) )
      = ( ^ [F3: B > C > D > A,X2: product_prod @ B @ C,Y2: D] :
            ( product_case_prod @ B @ C @ A
            @ ^ [A5: B,B4: C] : ( F3 @ A5 @ B4 @ Y2 )
            @ X2 ) ) ) ).

% nested_case_prod_simp
thf(fact_832_fn__fst__conv,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: A > C] :
      ( ( ^ [X2: product_prod @ A @ B] : ( F2 @ ( product_fst @ A @ B @ X2 ) ) )
      = ( product_case_prod @ A @ B @ C
        @ ^ [A5: A,Uu: B] : ( F2 @ A5 ) ) ) ).

% fn_fst_conv
thf(fact_833_case__prod__app,axiom,
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ ( D > A ) )
      = ( ^ [F3: B > C > D > A,X2: product_prod @ B @ C,Y2: D] :
            ( product_case_prod @ B @ C @ A
            @ ^ [L2: B,R3: C] : ( F3 @ L2 @ R3 @ Y2 )
            @ X2 ) ) ) ).

% case_prod_app
thf(fact_834_insert__compr,axiom,
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A5: A,B5: set @ A] :
            ( collect @ A
            @ ^ [X2: A] :
                ( ( X2 = A5 )
                | ( member @ A @ X2 @ B5 ) ) ) ) ) ).

% insert_compr
thf(fact_835_insert__Collect,axiom,
    ! [A: $tType,A4: A,P: A > $o] :
      ( ( insert @ A @ A4 @ ( collect @ A @ P ) )
      = ( collect @ A
        @ ^ [U: A] :
            ( ( U != A4 )
           => ( P @ U ) ) ) ) ).

% insert_Collect
thf(fact_836_prod_Ocase__distrib,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,H2: C > D,F2: A > B > C,Prod: product_prod @ A @ B] :
      ( ( H2 @ ( product_case_prod @ A @ B @ C @ F2 @ Prod ) )
      = ( product_case_prod @ A @ B @ D
        @ ^ [X1: A,X22: B] : ( H2 @ ( F2 @ X1 @ X22 ) )
        @ Prod ) ) ).

% prod.case_distrib
thf(fact_837_subset__CollectI,axiom,
    ! [A: $tType,B2: set @ A,A3: set @ A,Q: A > $o,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B2 @ A3 )
     => ( ! [X: A] :
            ( ( member @ A @ X @ B2 )
           => ( ( Q @ X )
             => ( P @ X ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ B2 )
                & ( Q @ X2 ) ) )
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A3 )
                & ( P @ X2 ) ) ) ) ) ) ).

% subset_CollectI
thf(fact_838_subset__Collect__iff,axiom,
    ! [A: $tType,B2: set @ A,A3: set @ A,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B2 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A3 )
                & ( P @ X2 ) ) ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ B2 )
             => ( P @ X2 ) ) ) ) ) ).

% subset_Collect_iff
thf(fact_839_Collect__subset,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ A3 )
            & ( P @ X2 ) ) )
      @ A3 ) ).

% Collect_subset
thf(fact_840_inj__fun,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ ( C > B )
        @ ^ [X2: A,Y2: C] : ( F2 @ X2 )
        @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fun
thf(fact_841_inj__singleton,axiom,
    ! [A: $tType,A3: set @ A] :
      ( inj_on @ A @ ( set @ A )
      @ ^ [X2: A] : ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) )
      @ A3 ) ).

% inj_singleton
thf(fact_842_case__prod__unfold,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [C5: A > B > C,P6: product_prod @ A @ B] : ( C5 @ ( product_fst @ A @ B @ P6 ) @ ( product_snd @ A @ B @ P6 ) ) ) ) ).

% case_prod_unfold
thf(fact_843_case__prod__beta_H,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [F3: A > B > C,X2: product_prod @ A @ B] : ( F3 @ ( product_fst @ A @ B @ X2 ) @ ( product_snd @ A @ B @ X2 ) ) ) ) ).

% case_prod_beta'
thf(fact_844_split__comp__eq,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,F2: A > B > C,G: D > A] :
      ( ( ^ [U: product_prod @ D @ B] : ( F2 @ ( G @ ( product_fst @ D @ B @ U ) ) @ ( product_snd @ D @ B @ U ) ) )
      = ( product_case_prod @ D @ B @ C
        @ ^ [X2: D] : ( F2 @ ( G @ X2 ) ) ) ) ).

% split_comp_eq
thf(fact_845_Times__subset__cancel2,axiom,
    ! [A: $tType,B: $tType,X3: A,C3: set @ A,A3: set @ B,B2: set @ B] :
      ( ( member @ A @ X3 @ C3 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) )
          @ ( product_Sigma @ B @ A @ A3
            @ ^ [Uu: B] : C3 )
          @ ( product_Sigma @ B @ A @ B2
            @ ^ [Uu: B] : C3 ) )
        = ( ord_less_eq @ ( set @ B ) @ A3 @ B2 ) ) ) ).

% Times_subset_cancel2
thf(fact_846_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C3: set @ A,A3: set @ A,B2: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ C3 )
       => ( ( ord_less_eq @ ( set @ A ) @ B2 @ C3 )
         => ( ( image2 @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
            = ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ A3 ) @ ( image2 @ A @ B @ F2 @ B2 ) ) ) ) ) ) ).

% inj_on_image_Int
thf(fact_847_Diff__single__insert,axiom,
    ! [A: $tType,A3: set @ A,X3: A,B2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B2 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ B2 ) ) ) ).

% Diff_single_insert
thf(fact_848_subset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X3: A,B2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ B2 ) )
      = ( ( ( member @ A @ X3 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B2 ) )
        & ( ~ ( member @ A @ X3 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% subset_insert_iff
thf(fact_849_inj__on__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B2: set @ A] :
      ( ( ( inj_on @ A @ B @ F2 @ A3 )
        | ( inj_on @ A @ B @ F2 @ B2 ) )
     => ( inj_on @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ).

% inj_on_Int
thf(fact_850_singletonD,axiom,
    ! [A: $tType,B3: A,A4: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B3 = A4 ) ) ).

% singletonD
thf(fact_851_singleton__iff,axiom,
    ! [A: $tType,B3: A,A4: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B3 = A4 ) ) ).

% singleton_iff
thf(fact_852_doubleton__eq__iff,axiom,
    ! [A: $tType,A4: A,B3: A,C2: A,D3: A] :
      ( ( ( insert @ A @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C2 @ ( insert @ A @ D3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A4 = C2 )
          & ( B3 = D3 ) )
        | ( ( A4 = D3 )
          & ( B3 = C2 ) ) ) ) ).

% doubleton_eq_iff
thf(fact_853_insert__not__empty,axiom,
    ! [A: $tType,A4: A,A3: set @ A] :
      ( ( insert @ A @ A4 @ A3 )
     != ( bot_bot @ ( set @ A ) ) ) ).

% insert_not_empty
thf(fact_854_singleton__inject,axiom,
    ! [A: $tType,A4: A,B3: A] :
      ( ( ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A4 = B3 ) ) ).

% singleton_inject
thf(fact_855_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) ) ).

% zero_le
thf(fact_856_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ C2 ) @ ( plus_plus @ A @ B3 @ C2 ) )
         => ( ord_less_eq @ A @ A4 @ B3 ) ) ) ).

% add_le_imp_le_right
thf(fact_857_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A4 ) @ ( plus_plus @ A @ C2 @ B3 ) )
         => ( ord_less_eq @ A @ A4 @ B3 ) ) ) ).

% add_le_imp_le_left
thf(fact_858_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
            ? [C5: A] :
              ( B4
              = ( plus_plus @ A @ A5 @ C5 ) ) ) ) ) ).

% le_iff_add
thf(fact_859_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ C2 ) @ ( plus_plus @ A @ B3 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_860_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ~ ! [C4: A] :
                ( B3
               != ( plus_plus @ A @ A4 @ C4 ) ) ) ) ).

% less_eqE
thf(fact_861_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A4 ) @ ( plus_plus @ A @ C2 @ B3 ) ) ) ) ).

% add_left_mono
thf(fact_862_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ C2 ) @ ( plus_plus @ A @ B3 @ D3 ) ) ) ) ) ).

% add_mono
thf(fact_863_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I3 @ J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_864_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( I3 = J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_865_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I3 @ J2 )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_866_Int__insert__left,axiom,
    ! [A: $tType,A4: A,C3: set @ A,B2: set @ A] :
      ( ( ( member @ A @ A4 @ C3 )
       => ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A4 @ B2 ) @ C3 )
          = ( insert @ A @ A4 @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) ) ) )
      & ( ~ ( member @ A @ A4 @ C3 )
       => ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A4 @ B2 ) @ C3 )
          = ( inf_inf @ ( set @ A ) @ B2 @ C3 ) ) ) ) ).

% Int_insert_left
thf(fact_867_Int__insert__right,axiom,
    ! [A: $tType,A4: A,A3: set @ A,B2: set @ A] :
      ( ( ( member @ A @ A4 @ A3 )
       => ( ( inf_inf @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ B2 ) )
          = ( insert @ A @ A4 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) )
      & ( ~ ( member @ A @ A4 @ A3 )
       => ( ( inf_inf @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ B2 ) )
          = ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% Int_insert_right
thf(fact_868_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_869_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ( minus_minus @ A @ A4 @ B3 )
            = ( minus_minus @ A @ C2 @ D3 ) )
         => ( ( ord_less_eq @ A @ A4 @ B3 )
            = ( ord_less_eq @ A @ C2 @ D3 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_870_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ C2 ) @ ( minus_minus @ A @ B3 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_871_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A4 ) @ ( minus_minus @ A @ C2 @ B3 ) ) ) ) ).

% diff_left_mono
thf(fact_872_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A,D3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ D3 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ C2 ) @ ( minus_minus @ A @ B3 @ D3 ) ) ) ) ) ).

% diff_mono
thf(fact_873_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ A4 @ ( bot_bot @ A ) )
         => ( A4
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_874_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ A4 @ ( bot_bot @ A ) )
          = ( A4
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_875_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A4: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A4 ) ) ).

% bot.extremum
thf(fact_876_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ ( uminus_uminus @ A @ A4 ) ) ) ) ).

% le_imp_neg_le
thf(fact_877_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A4 ) @ B3 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ A4 ) ) ) ).

% minus_le_iff
thf(fact_878_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ ( uminus_uminus @ A @ B3 ) )
          = ( ord_less_eq @ A @ B3 @ ( uminus_uminus @ A @ A4 ) ) ) ) ).

% le_minus_iff
thf(fact_879_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ X3 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X3 ) @ Y ) ) ) ).

% compl_le_swap2
thf(fact_880_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X3: A] :
          ( ( ord_less_eq @ A @ Y @ ( uminus_uminus @ A @ X3 ) )
         => ( ord_less_eq @ A @ X3 @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_le_swap1
thf(fact_881_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ ( uminus_uminus @ A @ X3 ) ) ) ) ).

% compl_mono
thf(fact_882_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A4 )
         => ( A4
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_883_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A4 )
          = ( A4
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_884_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A4: A] : ( ord_less_eq @ A @ A4 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_885_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ Y ) @ Y ) ) ).

% inf_sup_ord(2)
thf(fact_886_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ Y ) @ X3 ) ) ).

% inf_sup_ord(1)
thf(fact_887_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ Y ) @ X3 ) ) ).

% inf_le1
thf(fact_888_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ Y ) @ Y ) ) ).

% inf_le2
thf(fact_889_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ X3 @ ( inf_inf @ A @ A4 @ B3 ) )
         => ~ ( ( ord_less_eq @ A @ X3 @ A4 )
             => ~ ( ord_less_eq @ A @ X3 @ B3 ) ) ) ) ).

% le_infE
thf(fact_890_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ X3 @ A4 )
         => ( ( ord_less_eq @ A @ X3 @ B3 )
           => ( ord_less_eq @ A @ X3 @ ( inf_inf @ A @ A4 @ B3 ) ) ) ) ) ).

% le_infI
thf(fact_891_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( ( ord_less_eq @ A @ A4 @ C2 )
         => ( ( ord_less_eq @ A @ B3 @ D3 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A4 @ B3 ) @ ( inf_inf @ A @ C2 @ D3 ) ) ) ) ) ).

% inf_mono
thf(fact_892_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,X3: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ X3 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A4 @ B3 ) @ X3 ) ) ) ).

% le_infI1
thf(fact_893_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B3: A,X3: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ X3 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A4 @ B3 ) @ X3 ) ) ) ).

% le_infI2
thf(fact_894_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( A4
            = ( inf_inf @ A @ A4 @ B3 ) ) ) ) ).

% inf.orderE
thf(fact_895_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
            = ( inf_inf @ A @ A4 @ B3 ) )
         => ( ord_less_eq @ A @ A4 @ B3 ) ) ) ).

% inf.orderI
thf(fact_896_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F2: A > A > A,X3: A,Y: A] :
          ( ! [X: A,Y3: A] : ( ord_less_eq @ A @ ( F2 @ X @ Y3 ) @ X )
         => ( ! [X: A,Y3: A] : ( ord_less_eq @ A @ ( F2 @ X @ Y3 ) @ Y3 )
           => ( ! [X: A,Y3: A,Z4: A] :
                  ( ( ord_less_eq @ A @ X @ Y3 )
                 => ( ( ord_less_eq @ A @ X @ Z4 )
                   => ( ord_less_eq @ A @ X @ ( F2 @ Y3 @ Z4 ) ) ) )
             => ( ( inf_inf @ A @ X3 @ Y )
                = ( F2 @ X3 @ Y ) ) ) ) ) ) ).

% inf_unique
thf(fact_897_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y2: A] :
              ( ( inf_inf @ A @ X2 @ Y2 )
              = X2 ) ) ) ) ).

% le_iff_inf
thf(fact_898_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( inf_inf @ A @ A4 @ B3 )
            = A4 ) ) ) ).

% inf.absorb1
thf(fact_899_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( inf_inf @ A @ A4 @ B3 )
            = B3 ) ) ) ).

% inf.absorb2
thf(fact_900_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( inf_inf @ A @ X3 @ Y )
            = X3 ) ) ) ).

% inf_absorb1
thf(fact_901_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y: A,X3: A] :
          ( ( ord_less_eq @ A @ Y @ X3 )
         => ( ( inf_inf @ A @ X3 @ Y )
            = Y ) ) ) ).

% inf_absorb2
thf(fact_902_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ ( inf_inf @ A @ B3 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A4 @ B3 )
             => ~ ( ord_less_eq @ A @ A4 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_903_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ A4 @ C2 )
           => ( ord_less_eq @ A @ A4 @ ( inf_inf @ A @ B3 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_904_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( ord_less_eq @ A @ X3 @ Z2 )
           => ( ord_less_eq @ A @ X3 @ ( inf_inf @ A @ Y @ Z2 ) ) ) ) ) ).

% inf_greatest
thf(fact_905_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( A5
              = ( inf_inf @ A @ A5 @ B4 ) ) ) ) ) ).

% inf.order_iff
thf(fact_906_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A4 @ B3 ) @ A4 ) ) ).

% inf.cobounded1
thf(fact_907_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A4 @ B3 ) @ B3 ) ) ).

% inf.cobounded2
thf(fact_908_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( inf_inf @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_909_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( inf_inf @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_910_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_911_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_912_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less_eq @ A @ C2 @ B3 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ).

% sup.coboundedI2
thf(fact_913_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ C2 @ A4 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ).

% sup.coboundedI1
thf(fact_914_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( sup_sup @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_915_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( sup_sup @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_916_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B3: A,A4: A] : ( ord_less_eq @ A @ B3 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ).

% sup.cobounded2
thf(fact_917_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A,B3: A] : ( ord_less_eq @ A @ A4 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ).

% sup.cobounded1
thf(fact_918_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( A5
              = ( sup_sup @ A @ A5 @ B4 ) ) ) ) ) ).

% sup.order_iff
thf(fact_919_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( ord_less_eq @ A @ C2 @ A4 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B3 @ C2 ) @ A4 ) ) ) ) ).

% sup.boundedI
thf(fact_920_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B3 @ C2 ) @ A4 )
         => ~ ( ( ord_less_eq @ A @ B3 @ A4 )
             => ~ ( ord_less_eq @ A @ C2 @ A4 ) ) ) ) ).

% sup.boundedE
thf(fact_921_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( sup_sup @ A @ X3 @ Y )
            = Y ) ) ) ).

% sup_absorb2
thf(fact_922_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X3: A] :
          ( ( ord_less_eq @ A @ Y @ X3 )
         => ( ( sup_sup @ A @ X3 @ Y )
            = X3 ) ) ) ).

% sup_absorb1
thf(fact_923_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( sup_sup @ A @ A4 @ B3 )
            = B3 ) ) ) ).

% sup.absorb2
thf(fact_924_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( sup_sup @ A @ A4 @ B3 )
            = A4 ) ) ) ).

% sup.absorb1
thf(fact_925_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F2: A > A > A,X3: A,Y: A] :
          ( ! [X: A,Y3: A] : ( ord_less_eq @ A @ X @ ( F2 @ X @ Y3 ) )
         => ( ! [X: A,Y3: A] : ( ord_less_eq @ A @ Y3 @ ( F2 @ X @ Y3 ) )
           => ( ! [X: A,Y3: A,Z4: A] :
                  ( ( ord_less_eq @ A @ Y3 @ X )
                 => ( ( ord_less_eq @ A @ Z4 @ X )
                   => ( ord_less_eq @ A @ ( F2 @ Y3 @ Z4 ) @ X ) ) )
             => ( ( sup_sup @ A @ X3 @ Y )
                = ( F2 @ X3 @ Y ) ) ) ) ) ) ).

% sup_unique
thf(fact_926_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
            = ( sup_sup @ A @ A4 @ B3 ) )
         => ( ord_less_eq @ A @ B3 @ A4 ) ) ) ).

% sup.orderI
thf(fact_927_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( A4
            = ( sup_sup @ A @ A4 @ B3 ) ) ) ) ).

% sup.orderE
thf(fact_928_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y2: A] :
              ( ( sup_sup @ A @ X2 @ Y2 )
              = Y2 ) ) ) ) ).

% le_iff_sup
thf(fact_929_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X3: A,Z2: A] :
          ( ( ord_less_eq @ A @ Y @ X3 )
         => ( ( ord_less_eq @ A @ Z2 @ X3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y @ Z2 ) @ X3 ) ) ) ) ).

% sup_least
thf(fact_930_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( ( ord_less_eq @ A @ A4 @ C2 )
         => ( ( ord_less_eq @ A @ B3 @ D3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A4 @ B3 ) @ ( sup_sup @ A @ C2 @ D3 ) ) ) ) ) ).

% sup_mono
thf(fact_931_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A4: A,D3: A,B3: A] :
          ( ( ord_less_eq @ A @ C2 @ A4 )
         => ( ( ord_less_eq @ A @ D3 @ B3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D3 ) @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ) ).

% sup.mono
thf(fact_932_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,B3: A,A4: A] :
          ( ( ord_less_eq @ A @ X3 @ B3 )
         => ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ).

% le_supI2
thf(fact_933_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ X3 @ A4 )
         => ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ).

% le_supI1
thf(fact_934_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X3: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X3 @ Y ) ) ) ).

% sup_ge2
thf(fact_935_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,Y: A] : ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ X3 @ Y ) ) ) ).

% sup_ge1
thf(fact_936_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A,X3: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ X3 )
         => ( ( ord_less_eq @ A @ B3 @ X3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A4 @ B3 ) @ X3 ) ) ) ) ).

% le_supI
thf(fact_937_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A,B3: A,X3: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A4 @ B3 ) @ X3 )
         => ~ ( ( ord_less_eq @ A @ A4 @ X3 )
             => ~ ( ord_less_eq @ A @ B3 @ X3 ) ) ) ) ).

% le_supE
thf(fact_938_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A] : ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ X3 @ Y ) ) ) ).

% inf_sup_ord(3)
thf(fact_939_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y: A,X3: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X3 @ Y ) ) ) ).

% inf_sup_ord(4)
thf(fact_940_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,C3: set @ B,B2: set @ A,D2: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : C3 )
        @ ( product_Sigma @ A @ B @ B2
          @ ^ [Uu: A] : D2 ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( C3
          = ( bot_bot @ ( set @ B ) ) )
        | ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
          & ( ord_less_eq @ ( set @ B ) @ C3 @ D2 ) ) ) ) ).

% times_subset_iff
thf(fact_941_inter__eq__subsetI,axiom,
    ! [A: $tType,S2: set @ A,S4: set @ A,A3: set @ A,B2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ S4 )
     => ( ( ( inf_inf @ ( set @ A ) @ A3 @ S4 )
          = ( inf_inf @ ( set @ A ) @ B2 @ S4 ) )
       => ( ( inf_inf @ ( set @ A ) @ A3 @ S2 )
          = ( inf_inf @ ( set @ A ) @ B2 @ S2 ) ) ) ) ).

% inter_eq_subsetI
thf(fact_942_Int__mono,axiom,
    ! [A: $tType,A3: set @ A,C3: set @ A,B2: set @ A,D2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ D2 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ ( inf_inf @ ( set @ A ) @ C3 @ D2 ) ) ) ) ).

% Int_mono
thf(fact_943_Int__lower1,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ A3 ) ).

% Int_lower1
thf(fact_944_Int__lower2,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ B2 ) ).

% Int_lower2
thf(fact_945_Int__absorb1,axiom,
    ! [A: $tType,B2: set @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B2 @ A3 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = B2 ) ) ).

% Int_absorb1
thf(fact_946_Int__absorb2,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = A3 ) ) ).

% Int_absorb2
thf(fact_947_Int__greatest,axiom,
    ! [A: $tType,C3: set @ A,A3: set @ A,B2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C3 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ C3 @ B2 )
       => ( ord_less_eq @ ( set @ A ) @ C3 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% Int_greatest
thf(fact_948_Int__Collect__mono,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ! [X: A] :
            ( ( member @ A @ X @ A3 )
           => ( ( P @ X )
             => ( Q @ X ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B2 @ ( collect @ A @ Q ) ) ) ) ) ).

% Int_Collect_mono
thf(fact_949_case__prodD,axiom,
    ! [A: $tType,B: $tType,F2: A > B > $o,A4: A,B3: B] :
      ( ( product_case_prod @ A @ B @ $o @ F2 @ ( product_Pair @ A @ B @ A4 @ B3 ) )
     => ( F2 @ A4 @ B3 ) ) ).

% case_prodD
thf(fact_950_case__prodE,axiom,
    ! [A: $tType,B: $tType,C2: A > B > $o,P5: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ $o @ C2 @ P5 )
     => ~ ! [X: A,Y3: B] :
            ( ( P5
              = ( product_Pair @ A @ B @ X @ Y3 ) )
           => ~ ( C2 @ X @ Y3 ) ) ) ).

% case_prodE
thf(fact_951_inj__on__convol__ident,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X5: set @ A] :
      ( inj_on @ A @ ( product_prod @ A @ B )
      @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ ( F2 @ X2 ) )
      @ X5 ) ).

% inj_on_convol_ident
thf(fact_952_inj__Pair_I2_J,axiom,
    ! [B: $tType,A: $tType,C2: A > B,S2: set @ A] :
      ( inj_on @ A @ ( product_prod @ B @ A )
      @ ^ [X2: A] : ( product_Pair @ B @ A @ ( C2 @ X2 ) @ X2 )
      @ S2 ) ).

% inj_Pair(2)
thf(fact_953_inj__Pair_I1_J,axiom,
    ! [B: $tType,A: $tType,C2: A > B,S2: set @ A] :
      ( inj_on @ A @ ( product_prod @ A @ B )
      @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ ( C2 @ X2 ) )
      @ S2 ) ).

% inj_Pair(1)
thf(fact_954_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A4: A,A3: set @ A] :
          ( inj_on @ A @ A
          @ ^ [B4: A] : ( plus_plus @ A @ B4 @ A4 )
          @ A3 ) ) ).

% inj_on_add'
thf(fact_955_Collect__case__prod__Sigma,axiom,
    ! [B: $tType,A: $tType,P: A > $o,Q: A > B > $o] :
      ( ( collect @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X2: A,Y2: B] :
              ( ( P @ X2 )
              & ( Q @ X2 @ Y2 ) ) ) )
      = ( product_Sigma @ A @ B @ ( collect @ A @ P )
        @ ^ [X2: A] : ( collect @ B @ ( Q @ X2 ) ) ) ) ).

% Collect_case_prod_Sigma
thf(fact_956_case__prodE2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Q: A > $o,P: B > C > A,Z2: product_prod @ B @ C] :
      ( ( Q @ ( product_case_prod @ B @ C @ A @ P @ Z2 ) )
     => ~ ! [X: B,Y3: C] :
            ( ( Z2
              = ( product_Pair @ B @ C @ X @ Y3 ) )
           => ~ ( Q @ ( P @ X @ Y3 ) ) ) ) ).

% case_prodE2
thf(fact_957_case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: ( product_prod @ A @ B ) > C] :
      ( ( product_case_prod @ A @ B @ C
        @ ^ [X2: A,Y2: B] : ( F2 @ ( product_Pair @ A @ B @ X2 @ Y2 ) ) )
      = F2 ) ).

% case_prod_eta
thf(fact_958_cond__case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: A > B > C,G: ( product_prod @ A @ B ) > C] :
      ( ! [X: A,Y3: B] :
          ( ( F2 @ X @ Y3 )
          = ( G @ ( product_Pair @ A @ B @ X @ Y3 ) ) )
     => ( ( product_case_prod @ A @ B @ C @ F2 )
        = G ) ) ).

% cond_case_prod_eta
thf(fact_959_Collect__conv__if,axiom,
    ! [A: $tType,P: A > $o,A4: A] :
      ( ( ( P @ A4 )
       => ( ( collect @ A
            @ ^ [X2: A] :
                ( ( X2 = A4 )
                & ( P @ X2 ) ) )
          = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P @ A4 )
       => ( ( collect @ A
            @ ^ [X2: A] :
                ( ( X2 = A4 )
                & ( P @ X2 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Collect_conv_if
thf(fact_960_Collect__conv__if2,axiom,
    ! [A: $tType,P: A > $o,A4: A] :
      ( ( ( P @ A4 )
       => ( ( collect @ A
            @ ^ [X2: A] :
                ( ( A4 = X2 )
                & ( P @ X2 ) ) )
          = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P @ A4 )
       => ( ( collect @ A
            @ ^ [X2: A] :
                ( ( A4 = X2 )
                & ( P @ X2 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Collect_conv_if2
thf(fact_961_insert__def,axiom,
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A5: A] :
            ( sup_sup @ ( set @ A )
            @ ( collect @ A
              @ ^ [X2: A] : ( X2 = A5 ) ) ) ) ) ).

% insert_def
thf(fact_962_fn__snd__conv,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: B > C] :
      ( ( ^ [X2: product_prod @ A @ B] : ( F2 @ ( product_snd @ A @ B @ X2 ) ) )
      = ( product_case_prod @ A @ B @ C
        @ ^ [Uu: A] : F2 ) ) ).

% fn_snd_conv
thf(fact_963_snd__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_snd @ A @ B )
      = ( product_case_prod @ A @ B @ B
        @ ^ [X1: A,X22: B] : X22 ) ) ).

% snd_def
thf(fact_964_Id__on__def_H,axiom,
    ! [A: $tType,A3: A > $o] :
      ( ( id_on @ A @ ( collect @ A @ A3 ) )
      = ( collect @ ( product_prod @ A @ A )
        @ ( product_case_prod @ A @ A @ $o
          @ ^ [X2: A,Y2: A] :
              ( ( X2 = Y2 )
              & ( A3 @ X2 ) ) ) ) ) ).

% Id_on_def'
thf(fact_965_subset__fst__snd,axiom,
    ! [B: $tType,A: $tType,A3: set @ ( product_prod @ A @ B )] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A3
      @ ( product_Sigma @ A @ B @ ( image2 @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A3 )
        @ ^ [Uu: A] : ( image2 @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A3 ) ) ) ).

% subset_fst_snd
thf(fact_966_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A4: A,A3: set @ A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A4 ) @ A3 ) ) ) ).

% inj_on_mult
thf(fact_967_group_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( semigroup @ A @ F2 ) ) ).

% group.axioms(1)
thf(fact_968_singleton__Un__iff,axiom,
    ! [A: $tType,X3: A,A3: set @ A,B2: set @ A] :
      ( ( ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) )
        = ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
      = ( ( ( A3
            = ( bot_bot @ ( set @ A ) ) )
          & ( B2
            = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
        | ( ( A3
            = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B2
            = ( bot_bot @ ( set @ A ) ) ) )
        | ( ( A3
            = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B2
            = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% singleton_Un_iff
thf(fact_969_Un__singleton__iff,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,X3: A] :
      ( ( ( sup_sup @ ( set @ A ) @ A3 @ B2 )
        = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( ( A3
            = ( bot_bot @ ( set @ A ) ) )
          & ( B2
            = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
        | ( ( A3
            = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B2
            = ( bot_bot @ ( set @ A ) ) ) )
        | ( ( A3
            = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B2
            = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% Un_singleton_iff
thf(fact_970_insert__is__Un,axiom,
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A5: A] : ( sup_sup @ ( set @ A ) @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% insert_is_Un
thf(fact_971_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B3 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ C2 ) @ B3 ) ) ) ) ).

% add_decreasing
thf(fact_972_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less_eq @ A @ B3 @ ( plus_plus @ A @ A4 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_973_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A4 @ B3 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ C2 ) @ B3 ) ) ) ) ).

% add_decreasing2
thf(fact_974_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B3 @ A4 )
           => ( ord_less_eq @ A @ B3 @ ( plus_plus @ A @ A4 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_975_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A4 @ B3 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_976_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B3 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_977_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( plus_plus @ A @ X3 @ Y )
                = ( zero_zero @ A ) )
              = ( ( X3
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_978_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X3 @ Y )
                = ( zero_zero @ A ) )
              = ( ( X3
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_979_Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,A4: A,B2: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ B2 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Diff_insert
thf(fact_980_insert__Diff,axiom,
    ! [A: $tType,A4: A,A3: set @ A] :
      ( ( member @ A @ A4 @ A3 )
     => ( ( insert @ A @ A4 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A3 ) ) ).

% insert_Diff
thf(fact_981_Diff__insert2,axiom,
    ! [A: $tType,A3: set @ A,A4: A,B2: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ B2 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) @ B2 ) ) ).

% Diff_insert2
thf(fact_982_Diff__insert__absorb,axiom,
    ! [A: $tType,X3: A,A3: set @ A] :
      ( ~ ( member @ A @ X3 @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A3 ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
        = A3 ) ) ).

% Diff_insert_absorb
thf(fact_983_insert__minus__eq,axiom,
    ! [A: $tType,X3: A,Y: A,A3: set @ A] :
      ( ( X3 != Y )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A3 ) @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ X3 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% insert_minus_eq
thf(fact_984_set__minus__singleton__eq,axiom,
    ! [A: $tType,X3: A,X5: set @ A] :
      ( ~ ( member @ A @ X3 @ X5 )
     => ( ( minus_minus @ ( set @ A ) @ X5 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
        = X5 ) ) ).

% set_minus_singleton_eq
thf(fact_985_in__image__insert__iff,axiom,
    ! [A: $tType,B2: set @ ( set @ A ),X3: A,A3: set @ A] :
      ( ! [C6: set @ A] :
          ( ( member @ ( set @ A ) @ C6 @ B2 )
         => ~ ( member @ A @ X3 @ C6 ) )
     => ( ( member @ ( set @ A ) @ A3 @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( insert @ A @ X3 ) @ B2 ) )
        = ( ( member @ A @ X3 @ A3 )
          & ( member @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B2 ) ) ) ) ).

% in_image_insert_iff
thf(fact_986_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_987_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 ) )
            | ( ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B3 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_988_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ B3 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B3 @ A4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_989_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_990_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ B3 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_991_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_992_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A4: A,B3: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
              & ( ord_less_eq @ A @ B3 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_993_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A4 @ B3 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
              & ( ord_less_eq @ A @ B3 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_994_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_995_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_996_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) ) ) ) ) ).

% mult_left_mono
thf(fact_997_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B3 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_998_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_999_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A4: A,B3: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 ) )
            | ( ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B3 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) ) ) ) ).

% split_mult_pos_le
thf(fact_1000_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A4: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ A4 ) ) ) ).

% zero_le_square
thf(fact_1001_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ D3 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_1002_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ D3 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_1003_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_1004_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_1005_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_1006_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A5 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_1007_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I3: A,K: A,N: A,J2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ N )
         => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J2 @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ N )
             => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J2 @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N @ K ) @ J2 ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_1008_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I3: A,K: A,N: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ N )
         => ( ord_less_eq @ A @ I3 @ ( minus_minus @ A @ N @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_1009_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ A4 @ B3 )
           => ( ( ( minus_minus @ A @ B3 @ A4 )
                = C2 )
              = ( B3
                = ( plus_plus @ A @ C2 @ A4 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_1010_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( plus_plus @ A @ A4 @ ( minus_minus @ A @ B3 @ A4 ) )
            = B3 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_1011_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B3 @ A4 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A4 ) @ B3 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_1012_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B3 @ C2 ) @ A4 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B3 @ A4 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_1013_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B3 @ A4 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B3 @ C2 ) @ A4 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_1014_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B3 ) @ A4 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B3 @ A4 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_1015_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B3 @ A4 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B3 ) @ A4 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_1016_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B3 @ A4 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A4 ) @ B3 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_1017_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B3 @ C2 ) @ A4 ) ) ) ) ).

% le_add_diff
thf(fact_1018_ordered__cancel__comm__monoid__diff__class_Odiff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B3 @ A4 ) @ A4 )
            = B3 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add
thf(fact_1019_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ ( minus_minus @ A @ C2 @ B3 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_1020_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ B3 ) @ C2 )
          = ( ord_less_eq @ A @ A4 @ ( plus_plus @ A @ C2 @ B3 ) ) ) ) ).

% diff_le_eq
thf(fact_1021_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( ( minus_minus @ A @ X3 @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X3 @ Y ) ) ) ).

% diff_shunt_var
thf(fact_1022_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_1023_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_1024_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X3 @ ( inf_inf @ A @ Y @ Z2 ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X3 @ Y ) @ ( sup_sup @ A @ X3 @ Z2 ) ) ) ) ).

% distrib_sup_le
thf(fact_1025_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X3 @ Y ) @ ( inf_inf @ A @ X3 @ Z2 ) ) @ ( inf_inf @ A @ X3 @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% distrib_inf_le
thf(fact_1026_vimage__singleton__eq,axiom,
    ! [A: $tType,B: $tType,A4: A,F2: A > B,B3: B] :
      ( ( member @ A @ A4 @ ( vimage @ A @ B @ F2 @ ( insert @ B @ B3 @ ( bot_bot @ ( set @ B ) ) ) ) )
      = ( ( F2 @ A4 )
        = B3 ) ) ).

% vimage_singleton_eq
thf(fact_1027_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,B2: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image2 @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) @ ( inf_inf @ ( set @ A ) @ ( image2 @ B @ A @ F2 @ A3 ) @ ( image2 @ B @ A @ F2 @ B2 ) ) ) ).

% image_Int_subset
thf(fact_1028_disjoint__mono,axiom,
    ! [A: $tType,A4: set @ A,A8: set @ A,B3: set @ A,B7: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ A8 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ B7 )
       => ( ( ( inf_inf @ ( set @ A ) @ A8 @ B7 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% disjoint_mono
thf(fact_1029_subset__minus__empty,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( minus_minus @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_minus_empty
thf(fact_1030_inj__diff__right,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A] :
          ( inj_on @ A @ A
          @ ^ [B4: A] : ( minus_minus @ A @ B4 @ A4 )
          @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_diff_right
thf(fact_1031_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,C3: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ C3 )
        = ( inf_inf @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C3 @ A3 ) ) ).

% Un_Int_assoc_eq
thf(fact_1032_subset__Compl__self__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_Compl_self_eq
thf(fact_1033_rel__restrict__def,axiom,
    ! [A: $tType] :
      ( ( rel_restrict @ A )
      = ( ^ [R2: set @ ( product_prod @ A @ A ),A6: set @ A] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [V2: A,W3: A] :
                  ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V2 @ W3 ) @ R2 )
                  & ~ ( member @ A @ V2 @ A6 )
                  & ~ ( member @ A @ W3 @ A6 ) ) ) ) ) ) ).

% rel_restrict_def
thf(fact_1034_in__prod__fst__sndI,axiom,
    ! [B: $tType,A: $tType,X3: product_prod @ A @ B,A3: set @ A,B2: set @ B] :
      ( ( member @ A @ ( product_fst @ A @ B @ X3 ) @ A3 )
     => ( ( member @ B @ ( product_snd @ A @ B @ X3 ) @ B2 )
       => ( member @ ( product_prod @ A @ B ) @ X3
          @ ( product_Sigma @ A @ B @ A3
            @ ^ [Uu: A] : B2 ) ) ) ) ).

% in_prod_fst_sndI
thf(fact_1035_mem__Times__iff,axiom,
    ! [A: $tType,B: $tType,X3: product_prod @ A @ B,A3: set @ A,B2: set @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ X3
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 ) )
      = ( ( member @ A @ ( product_fst @ A @ B @ X3 ) @ A3 )
        & ( member @ B @ ( product_snd @ A @ B @ X3 ) @ B2 ) ) ) ).

% mem_Times_iff
thf(fact_1036_image__constant__conv,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,C2: A] :
      ( ( ( A3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ B @ A
            @ ^ [X2: B] : C2
            @ A3 )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ B @ A
            @ ^ [X2: B] : C2
            @ A3 )
          = ( insert @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_constant_conv
thf(fact_1037_image__constant,axiom,
    ! [A: $tType,B: $tType,X3: A,A3: set @ A,C2: B] :
      ( ( member @ A @ X3 @ A3 )
     => ( ( image2 @ A @ B
          @ ^ [X2: A] : C2
          @ A3 )
        = ( insert @ B @ C2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ).

% image_constant
thf(fact_1038_image__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B2: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( image2 @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
        = ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ A3 ) @ ( image2 @ A @ B @ F2 @ B2 ) ) ) ) ).

% image_Int
thf(fact_1039_Id__on__subset__Times,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( id_on @ A @ A3 )
      @ ( product_Sigma @ A @ A @ A3
        @ ^ [Uu: A] : A3 ) ) ).

% Id_on_subset_Times
thf(fact_1040_range__eq__singletonD,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A4: A,X3: B] :
      ( ( ( image2 @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( F2 @ X3 )
        = A4 ) ) ).

% range_eq_singletonD
thf(fact_1041_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X3: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y @ Y ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_1042_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) )
          = ( ( X3
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_1043_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A4: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ A4 ) ) ) ) ).

% mult_left_le
thf(fact_1044_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 )
           => ( ( ord_less_eq @ A @ B3 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ B3 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_1045_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X3 @ Y ) @ X3 ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_1046_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y @ X3 ) @ X3 ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_1047_rtrancl__last__visit__node,axiom,
    ! [A: $tType,S3: A,S5: A,R: set @ ( product_prod @ A @ A ),Sh: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ S3 @ S5 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( ( S3 != Sh )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ S3 @ S5 )
            @ ( transitive_rtrancl @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
                @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                  @ ^ [Uu: A] : ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ Sh @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) )
        | ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ S3 @ Sh ) @ ( transitive_rtrancl @ A @ R ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Sh @ S5 )
            @ ( transitive_rtrancl @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
                @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                  @ ^ [Uu: A] : ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ Sh @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% rtrancl_last_visit_node
thf(fact_1048_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_1049_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_1050_le__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A4 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B3 @ E2 ) @ D3 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A4 @ B3 ) @ E2 ) @ C2 ) @ D3 ) ) ) ).

% le_add_iff1
thf(fact_1051_le__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A4 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B3 @ E2 ) @ D3 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B3 @ A4 ) @ E2 ) @ D3 ) ) ) ) ).

% le_add_iff2
thf(fact_1052_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( ( inf_inf @ A @ X3 @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X3 @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% inf_shunt
thf(fact_1053_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( ( sup_sup @ A @ X3 @ Y )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X3 ) @ Y ) ) ) ).

% sup_shunt
thf(fact_1054_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ Y ) @ Z2 )
          = ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y ) @ Z2 ) ) ) ) ).

% shunt1
thf(fact_1055_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ ( uminus_uminus @ A @ Y ) ) @ Z2 )
          = ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% shunt2
thf(fact_1056_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P5: A,Q4: A,R5: A] :
          ( ( ord_less_eq @ A @ P5 @ ( sup_sup @ A @ Q4 @ R5 ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P5 @ ( uminus_uminus @ A @ Q4 ) ) @ R5 ) ) ) ).

% sup_neg_inf
thf(fact_1057_vimage__insert,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A4: B,B2: set @ B] :
      ( ( vimage @ A @ B @ F2 @ ( insert @ B @ A4 @ B2 ) )
      = ( sup_sup @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) @ ( vimage @ A @ B @ F2 @ B2 ) ) ) ).

% vimage_insert
thf(fact_1058_Compl__insert,axiom,
    ! [A: $tType,X3: A,A3: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X3 @ A3 ) )
      = ( minus_minus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Compl_insert
thf(fact_1059_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ B2 ) ) ) ).

% disjoint_eq_subset_Compl
thf(fact_1060_Restr__rtrancl__mono,axiom,
    ! [A: $tType,V: A,W2: A,E3: set @ ( product_prod @ A @ A ),U3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 )
        @ ( transitive_rtrancl @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ E3
            @ ( product_Sigma @ A @ A @ U3
              @ ^ [Uu: A] : U3 ) ) ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 ) @ ( transitive_rtrancl @ A @ E3 ) ) ) ).

% Restr_rtrancl_mono
thf(fact_1061_fst__image__Sigma,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: A > ( set @ B )] :
      ( ( image2 @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( product_Sigma @ A @ B @ A3 @ B2 ) )
      = ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ A3 )
            & ( ( B2 @ X2 )
             != ( bot_bot @ ( set @ B ) ) ) ) ) ) ).

% fst_image_Sigma
thf(fact_1062_fs__contract,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: A > B > C,S2: set @ C] :
      ( ( image2 @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B )
        @ ( collect @ ( product_prod @ A @ B )
          @ ^ [Uu: product_prod @ A @ B] :
            ? [P6: product_prod @ A @ B] :
              ( ( Uu = P6 )
              & ( member @ C @ ( F2 @ ( product_fst @ A @ B @ P6 ) @ ( product_snd @ A @ B @ P6 ) ) @ S2 ) ) ) )
      = ( collect @ A
        @ ^ [A5: A] :
          ? [B4: B] : ( member @ C @ ( F2 @ A5 @ B4 ) @ S2 ) ) ) ).

% fs_contract
thf(fact_1063_homo__rel__restrict__mono,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),B2: set @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R
        @ ( product_Sigma @ A @ A @ B2
          @ ^ [Uu: A] : B2 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( rel_restrict @ A @ R @ A3 )
        @ ( product_Sigma @ A @ A @ ( minus_minus @ ( set @ A ) @ B2 @ A3 )
          @ ^ [Uu: A] : ( minus_minus @ ( set @ A ) @ B2 @ A3 ) ) ) ) ).

% homo_rel_restrict_mono
thf(fact_1064_inj__on__disjoint__Un,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,G: A > B,B2: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( inj_on @ A @ B @ G @ B2 )
       => ( ( ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ A3 ) @ ( image2 @ A @ B @ G @ B2 ) )
            = ( bot_bot @ ( set @ B ) ) )
         => ( inj_on @ A @ B
            @ ^ [X2: A] : ( if @ B @ ( member @ A @ X2 @ A3 ) @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) ) ) ) ).

% inj_on_disjoint_Un
thf(fact_1065_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X3: A,A4: A,Y: A,U2: A,V: A] :
          ( ( ord_less_eq @ A @ X3 @ A4 )
         => ( ( ord_less_eq @ A @ Y @ A4 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U2 @ V )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U2 @ X3 ) @ ( times_times @ A @ V @ Y ) ) @ A4 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_1066_rtrancl__last__touch,axiom,
    ! [A: $tType,Q4: A,Q6: A,R: set @ ( product_prod @ A @ A ),S2: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Q6 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ A @ Q4 @ S2 )
       => ~ ! [Qt: A] :
              ( ( member @ A @ Qt @ S2 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Qt ) @ ( transitive_rtrancl @ A @ R ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Qt @ Q6 )
                    @ ( transitive_rtrancl @ A
                      @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R
                        @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                          @ ^ [Uu: A] : S2 ) ) ) ) ) ) ) ) ).

% rtrancl_last_touch
thf(fact_1067_rtrancl__last__visit_H,axiom,
    ! [A: $tType,Q4: A,Q6: A,R: set @ ( product_prod @ A @ A ),S2: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Q6 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Q6 )
            @ ( transitive_rtrancl @ A
              @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R
                @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                  @ ^ [Uu: A] : S2 ) ) ) )
       => ~ ! [Qt: A] :
              ( ( member @ A @ Qt @ S2 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Qt ) @ ( transitive_rtrancl @ A @ R ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Qt @ Q6 )
                    @ ( transitive_rtrancl @ A
                      @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R
                        @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                          @ ^ [Uu: A] : S2 ) ) ) ) ) ) ) ) ).

% rtrancl_last_visit'
thf(fact_1068_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A4: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A4 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A4
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_1069_rtrancl__insert,axiom,
    ! [A: $tType,A4: A,B3: A,R5: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtrancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R5 ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R5 )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X2: A,Y2: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ A4 ) @ ( transitive_rtrancl @ A @ R5 ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ Y2 ) @ ( transitive_rtrancl @ A @ R5 ) ) ) ) ) ) ) ).

% rtrancl_insert
thf(fact_1070_trancl__subset__Sigma__aux,axiom,
    ! [A: $tType,A4: A,B3: A,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ ( transitive_rtrancl @ A @ R5 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) )
       => ( ( A4 = B3 )
          | ( member @ A @ A4 @ A3 ) ) ) ) ).

% trancl_subset_Sigma_aux
thf(fact_1071_inj__on__iff__surj,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,A11: set @ B] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [F3: A > B] :
              ( ( inj_on @ A @ B @ F3 @ A3 )
              & ( ord_less_eq @ ( set @ B ) @ ( image2 @ A @ B @ F3 @ A3 ) @ A11 ) ) )
        = ( ? [G2: B > A] :
              ( ( image2 @ B @ A @ G2 @ A11 )
              = A3 ) ) ) ) ).

% inj_on_iff_surj
thf(fact_1072_Restr__subset,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,R5: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) )
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ B2
              @ ^ [Uu: A] : B2 ) )
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) )
        = ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) ) ) ).

% Restr_subset
thf(fact_1073_exE__realizer,axiom,
    ! [C: $tType,A: $tType,B: $tType,P: A > B > $o,P5: product_prod @ B @ A,Q: C > $o,F2: B > A > C] :
      ( ( P @ ( product_snd @ B @ A @ P5 ) @ ( product_fst @ B @ A @ P5 ) )
     => ( ! [X: B,Y3: A] :
            ( ( P @ Y3 @ X )
           => ( Q @ ( F2 @ X @ Y3 ) ) )
       => ( Q @ ( product_case_prod @ B @ A @ C @ F2 @ P5 ) ) ) ) ).

% exE_realizer
thf(fact_1074_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( inj_on @ A @ A
        @ ^ [X2: A] : X2
        @ ( top_top @ ( set @ A ) ) ) ) ).

% sorted_list_of_set.inj_on
thf(fact_1075_is__singleton__the__elem,axiom,
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A6: set @ A] :
            ( A6
            = ( insert @ A @ ( the_elem @ A @ A6 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% is_singleton_the_elem
thf(fact_1076_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: A > B,B2: set @ B] :
      ( ! [X: A] :
          ( ( P @ X )
         => ( member @ B @ ( F2 @ X ) @ B2 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ ( collect @ A @ P ) ) @ B2 ) ) ).

% image_Collect_subsetI
thf(fact_1077_less__by__empty,axiom,
    ! [A: $tType,A3: set @ ( product_prod @ A @ A ),B2: set @ ( product_prod @ A @ A )] :
      ( ( A3
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ A3 @ B2 ) ) ).

% less_by_empty
thf(fact_1078_mem__case__prodI2,axiom,
    ! [C: $tType,B: $tType,A: $tType,P5: product_prod @ A @ B,Z2: C,C2: A > B > ( set @ C )] :
      ( ! [A7: A,B6: B] :
          ( ( P5
            = ( product_Pair @ A @ B @ A7 @ B6 ) )
         => ( member @ C @ Z2 @ ( C2 @ A7 @ B6 ) ) )
     => ( member @ C @ Z2 @ ( product_case_prod @ A @ B @ ( set @ C ) @ C2 @ P5 ) ) ) ).

% mem_case_prodI2
thf(fact_1079_mem__case__prodI,axiom,
    ! [A: $tType,B: $tType,C: $tType,Z2: A,C2: B > C > ( set @ A ),A4: B,B3: C] :
      ( ( member @ A @ Z2 @ ( C2 @ A4 @ B3 ) )
     => ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ ( product_Pair @ B @ C @ A4 @ B3 ) ) ) ) ).

% mem_case_prodI
thf(fact_1080_case__prodI2_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P5: product_prod @ A @ B,C2: A > B > C > $o,X3: C] :
      ( ! [A7: A,B6: B] :
          ( ( ( product_Pair @ A @ B @ A7 @ B6 )
            = P5 )
         => ( C2 @ A7 @ B6 @ X3 ) )
     => ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P5 @ X3 ) ) ).

% case_prodI2'
thf(fact_1081_is__singletonI,axiom,
    ! [A: $tType,X3: A] : ( is_singleton @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% is_singletonI
thf(fact_1082_case__prod__Pair__iden,axiom,
    ! [B: $tType,A: $tType,P5: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ P5 )
      = P5 ) ).

% case_prod_Pair_iden
thf(fact_1083_swap__inj__on,axiom,
    ! [B: $tType,A: $tType,A3: set @ ( product_prod @ A @ B )] :
      ( inj_on @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A )
      @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
        @ ^ [I2: A,J3: B] : ( product_Pair @ B @ A @ J3 @ I2 ) )
      @ A3 ) ).

% swap_inj_on
thf(fact_1084_relH__subset,axiom,
    ! [Bs: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,As2: set @ nat] :
      ( ( relH @ Bs @ H2 @ H5 )
     => ( ( ord_less_eq @ ( set @ nat ) @ As2 @ Bs )
       => ( relH @ As2 @ H2 @ H5 ) ) ) ).

% relH_subset
thf(fact_1085_case__prodE_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: A > B > C > $o,P5: product_prod @ A @ B,Z2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P5 @ Z2 )
     => ~ ! [X: A,Y3: B] :
            ( ( P5
              = ( product_Pair @ A @ B @ X @ Y3 ) )
           => ~ ( C2 @ X @ Y3 @ Z2 ) ) ) ).

% case_prodE'
thf(fact_1086_case__prodD_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,R: A > B > C > $o,A4: A,B3: B,C2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ R @ ( product_Pair @ A @ B @ A4 @ B3 ) @ C2 )
     => ( R @ A4 @ B3 @ C2 ) ) ).

% case_prodD'
thf(fact_1087_less__eq__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: set @ A,B5: set @ A] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X2: A] : ( member @ A @ X2 @ A6 )
            @ ^ [X2: A] : ( member @ A @ X2 @ B5 ) ) ) ) ).

% less_eq_set_def
thf(fact_1088_pred__subset__eq,axiom,
    ! [A: $tType,R: set @ A,S2: set @ A] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X2: A] : ( member @ A @ X2 @ R )
        @ ^ [X2: A] : ( member @ A @ X2 @ S2 ) )
      = ( ord_less_eq @ ( set @ A ) @ R @ S2 ) ) ).

% pred_subset_eq
thf(fact_1089_less__eq__assn__def,axiom,
    ( ( ord_less_eq @ assn )
    = ( ^ [A5: assn,B4: assn] :
          ( A5
          = ( inf_inf @ assn @ A5 @ B4 ) ) ) ) ).

% less_eq_assn_def
thf(fact_1090_in__range__subset,axiom,
    ! [As2: set @ nat,As3: set @ nat,H2: heap_ext @ product_unit] :
      ( ( ord_less_eq @ ( set @ nat ) @ As2 @ As3 )
     => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As3 ) )
       => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) ) ) ) ).

% in_range_subset
thf(fact_1091_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( A > B > $o )
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R )
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ S2 ) )
      = ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ).

% pred_subset_eq2
thf(fact_1092_is__singletonI_H,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X: A,Y3: A] :
            ( ( member @ A @ X @ A3 )
           => ( ( member @ A @ Y3 @ A3 )
             => ( X = Y3 ) ) )
       => ( is_singleton @ A @ A3 ) ) ) ).

% is_singletonI'
thf(fact_1093_swap__product,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,B2: set @ A] :
      ( ( image2 @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [I2: B,J3: A] : ( product_Pair @ A @ B @ J3 @ I2 ) )
        @ ( product_Sigma @ B @ A @ A3
          @ ^ [Uu: B] : B2 ) )
      = ( product_Sigma @ A @ B @ B2
        @ ^ [Uu: A] : A3 ) ) ).

% swap_product
thf(fact_1094_image__paired__Times,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,F2: C > A,G: D > B,A3: set @ C,B2: set @ D] :
      ( ( image2 @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X2: C,Y2: D] : ( product_Pair @ A @ B @ ( F2 @ X2 ) @ ( G @ Y2 ) ) )
        @ ( product_Sigma @ C @ D @ A3
          @ ^ [Uu: C] : B2 ) )
      = ( product_Sigma @ A @ B @ ( image2 @ C @ A @ F2 @ A3 )
        @ ^ [Uu: A] : ( image2 @ D @ B @ G @ B2 ) ) ) ).

% image_paired_Times
thf(fact_1095_Collect__restrict,axiom,
    ! [A: $tType,X5: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ X5 )
            & ( P @ X2 ) ) )
      @ X5 ) ).

% Collect_restrict
thf(fact_1096_prop__restrict,axiom,
    ! [A: $tType,X3: A,Z6: set @ A,X5: set @ A,P: A > $o] :
      ( ( member @ A @ X3 @ Z6 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z6
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ X5 )
                & ( P @ X2 ) ) ) )
       => ( P @ X3 ) ) ) ).

% prop_restrict
thf(fact_1097_is__singletonE,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( is_singleton @ A @ A3 )
     => ~ ! [X: A] :
            ( A3
           != ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% is_singletonE
thf(fact_1098_is__singleton__def,axiom,
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A6: set @ A] :
          ? [X2: A] :
            ( A6
            = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% is_singleton_def
thf(fact_1099_mod__star__trueE_H,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ P @ ( top_top @ assn ) ) @ H2 )
     => ~ ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( ( product_fst @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 )
              = ( product_fst @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 ) )
           => ( ( ord_less_eq @ ( set @ nat ) @ ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 ) @ ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 ) )
             => ~ ( rep_assn @ P @ H3 ) ) ) ) ).

% mod_star_trueE'
thf(fact_1100_subset__emptyI,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ! [X: A] :
          ~ ( member @ A @ X @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_emptyI
thf(fact_1101_range__prod,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: C > ( product_prod @ A @ B )] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ C @ ( product_prod @ A @ B ) @ F2 @ ( top_top @ ( set @ C ) ) )
      @ ( product_Sigma @ A @ B @ ( image2 @ C @ A @ ( comp @ ( product_prod @ A @ B ) @ A @ C @ ( product_fst @ A @ B ) @ F2 ) @ ( top_top @ ( set @ C ) ) )
        @ ^ [Uu: A] : ( image2 @ C @ B @ ( comp @ ( product_prod @ A @ B ) @ B @ C @ ( product_snd @ A @ B ) @ F2 ) @ ( top_top @ ( set @ C ) ) ) ) ) ).

% range_prod
thf(fact_1102_Gr__incl,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F2: A > B,B2: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( bNF_Gr @ A @ B @ A3 @ F2 )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 ) )
      = ( ord_less_eq @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ A3 ) @ B2 ) ) ).

% Gr_incl
thf(fact_1103_inj__on__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,A4: B] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) @ A3 )
        @ ( insert @ A
          @ ( the @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A3 )
                & ( ( F2 @ X2 )
                  = A4 ) ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_on_vimage_singleton
thf(fact_1104_inj__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A4: B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) )
        @ ( insert @ A
          @ ( the @ A
            @ ^ [X2: A] :
                ( ( F2 @ X2 )
                = A4 ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_vimage_singleton
thf(fact_1105_vimage__Times,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > ( product_prod @ B @ C ),A3: set @ B,B2: set @ C] :
      ( ( vimage @ A @ ( product_prod @ B @ C ) @ F2
        @ ( product_Sigma @ B @ C @ A3
          @ ^ [Uu: B] : B2 ) )
      = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ F2 ) @ A3 ) @ ( vimage @ A @ C @ ( comp @ ( product_prod @ B @ C ) @ C @ A @ ( product_snd @ B @ C ) @ F2 ) @ B2 ) ) ) ).

% vimage_Times
thf(fact_1106_total__on__singleton,axiom,
    ! [A: $tType,X3: A] : ( total_on @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% total_on_singleton
thf(fact_1107_inj__graph,axiom,
    ! [B: $tType,A: $tType] :
      ( inj_on @ ( A > B ) @ ( set @ ( product_prod @ A @ B ) )
      @ ^ [F3: A > B] :
          ( collect @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ B @ $o
            @ ^ [X2: A,Y2: B] :
                ( Y2
                = ( F3 @ X2 ) ) ) )
      @ ( top_top @ ( set @ ( A > B ) ) ) ) ).

% inj_graph
thf(fact_1108_group_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A] :
      ( ( semigroup @ A @ F2 )
     => ( ( group_axioms @ A @ F2 @ Z2 @ Inverse )
       => ( group @ A @ F2 @ Z2 @ Inverse ) ) ) ).

% group.intro
thf(fact_1109_group__def,axiom,
    ! [A: $tType] :
      ( ( group @ A )
      = ( ^ [F3: A > A > A,Z3: A,Inverse2: A > A] :
            ( ( semigroup @ A @ F3 )
            & ( group_axioms @ A @ F3 @ Z3 @ Inverse2 ) ) ) ) ).

% group_def
thf(fact_1110_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Q: A > B > $o] :
      ( ! [X: A,Y3: B] :
          ( ( P @ X @ Y3 )
         => ( Q @ X @ Y3 ) )
     => ( ord_less_eq @ ( A > B > $o ) @ P @ Q ) ) ).

% predicate2I
thf(fact_1111_predicate1I,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X: A] :
          ( ( P @ X )
         => ( Q @ X ) )
     => ( ord_less_eq @ ( A > $o ) @ P @ Q ) ) ).

% predicate1I
thf(fact_1112_The__split__eq,axiom,
    ! [A: $tType,B: $tType,X3: A,Y: B] :
      ( ( the @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X6: A,Y6: B] :
              ( ( X3 = X6 )
              & ( Y = Y6 ) ) ) )
      = ( product_Pair @ A @ B @ X3 @ Y ) ) ).

% The_split_eq
thf(fact_1113_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X3: A,Y: B,Q: A > B > $o] :
      ( ( P @ X3 @ Y )
     => ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
       => ( Q @ X3 @ Y ) ) ) ).

% rev_predicate2D
thf(fact_1114_rev__predicate1D,axiom,
    ! [A: $tType,P: A > $o,X3: A,Q: A > $o] :
      ( ( P @ X3 )
     => ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
       => ( Q @ X3 ) ) ) ).

% rev_predicate1D
thf(fact_1115_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Q: A > B > $o,X3: A,Y: B] :
      ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
     => ( ( P @ X3 @ Y )
       => ( Q @ X3 @ Y ) ) ) ).

% predicate2D
thf(fact_1116_predicate1D,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,X3: A] :
      ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
     => ( ( P @ X3 )
       => ( Q @ X3 ) ) ) ).

% predicate1D
thf(fact_1117_eq__subset,axiom,
    ! [A: $tType,P: A > A > $o] :
      ( ord_less_eq @ ( A > A > $o )
      @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
      @ ^ [A5: A,B4: A] :
          ( ( P @ A5 @ B4 )
          | ( A5 = B4 ) ) ) ).

% eq_subset
thf(fact_1118_group__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A] :
      ( ! [A7: A] :
          ( ( F2 @ Z2 @ A7 )
          = A7 )
     => ( ! [A7: A] :
            ( ( F2 @ ( Inverse @ A7 ) @ A7 )
            = Z2 )
       => ( group_axioms @ A @ F2 @ Z2 @ Inverse ) ) ) ).

% group_axioms.intro
thf(fact_1119_group__axioms__def,axiom,
    ! [A: $tType] :
      ( ( group_axioms @ A )
      = ( ^ [F3: A > A > A,Z3: A,Inverse2: A > A] :
            ( ! [A5: A] :
                ( ( F3 @ Z3 @ A5 )
                = A5 )
            & ! [A5: A] :
                ( ( F3 @ ( Inverse2 @ A5 ) @ A5 )
                = Z3 ) ) ) ) ).

% group_axioms_def
thf(fact_1120_total__on__empty,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] : ( total_on @ A @ ( bot_bot @ ( set @ A ) ) @ R5 ) ).

% total_on_empty
thf(fact_1121_group_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( group_axioms @ A @ F2 @ Z2 @ Inverse ) ) ).

% group.axioms(2)
thf(fact_1122_The__case__prod,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o] :
      ( ( the @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) )
      = ( the @ ( product_prod @ A @ B )
        @ ^ [Xy: product_prod @ A @ B] : ( P @ ( product_fst @ A @ B @ Xy ) @ ( product_snd @ A @ B @ Xy ) ) ) ) ).

% The_case_prod
thf(fact_1123_the__elem__def,axiom,
    ! [A: $tType] :
      ( ( the_elem @ A )
      = ( ^ [X7: set @ A] :
            ( the @ A
            @ ^ [X2: A] :
                ( X7
                = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% the_elem_def
thf(fact_1124_fst__snd__flip,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ B @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ B @ A )
        @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
          @ ^ [X2: A,Y2: B] : ( product_Pair @ B @ A @ Y2 @ X2 ) ) ) ) ).

% fst_snd_flip
thf(fact_1125_snd__fst__flip,axiom,
    ! [A: $tType,B: $tType] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ A @ B ) @ A @ ( product_prod @ B @ A ) @ ( product_fst @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [X2: B,Y2: A] : ( product_Pair @ A @ B @ Y2 @ X2 ) ) ) ) ).

% snd_fst_flip
thf(fact_1126_the__equality,axiom,
    ! [A: $tType,P: A > $o,A4: A] :
      ( ( P @ A4 )
     => ( ! [X: A] :
            ( ( P @ X )
           => ( X = A4 ) )
       => ( ( the @ A @ P )
          = A4 ) ) ) ).

% the_equality
thf(fact_1127_the__eq__trivial,axiom,
    ! [A: $tType,A4: A] :
      ( ( the @ A
        @ ^ [X2: A] : ( X2 = A4 ) )
      = A4 ) ).

% the_eq_trivial
thf(fact_1128_the__sym__eq__trivial,axiom,
    ! [A: $tType,X3: A] :
      ( ( the @ A
        @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
          @ X3 ) )
      = X3 ) ).

% the_sym_eq_trivial
thf(fact_1129_Gr__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Gr @ A @ B )
      = ( ^ [A6: set @ A,F3: A > B] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu: product_prod @ A @ B] :
              ? [A5: A] :
                ( ( Uu
                  = ( product_Pair @ A @ B @ A5 @ ( F3 @ A5 ) ) )
                & ( member @ A @ A5 @ A6 ) ) ) ) ) ).

% Gr_def
thf(fact_1130_inj__on__apsnd,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: B > C,A3: set @ B] :
      ( ( inj_on @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) @ ( product_apsnd @ B @ C @ A @ F2 )
        @ ( product_Sigma @ A @ B @ ( top_top @ ( set @ A ) )
          @ ^ [Uu: A] : A3 ) )
      = ( inj_on @ B @ C @ F2 @ A3 ) ) ).

% inj_on_apsnd
thf(fact_1131_inj__on__apfst,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: A > C,A3: set @ A] :
      ( ( inj_on @ ( product_prod @ A @ B ) @ ( product_prod @ C @ B ) @ ( product_apfst @ A @ C @ B @ F2 )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : ( top_top @ ( set @ B ) ) ) )
      = ( inj_on @ A @ C @ F2 @ A3 ) ) ).

% inj_on_apfst
thf(fact_1132_Field__insert,axiom,
    ! [A: $tType,A4: A,B3: A,R5: set @ ( product_prod @ A @ A )] :
      ( ( field2 @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R5 ) )
      = ( sup_sup @ ( set @ A ) @ ( insert @ A @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( field2 @ A @ R5 ) ) ) ).

% Field_insert
thf(fact_1133_Field__square,axiom,
    ! [A: $tType,X3: set @ A] :
      ( ( field2 @ A
        @ ( product_Sigma @ A @ A @ X3
          @ ^ [Uu: A] : X3 ) )
      = X3 ) ).

% Field_square
thf(fact_1134_Field__empty,axiom,
    ! [A: $tType] :
      ( ( field2 @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Field_empty
thf(fact_1135_R__subset__Field,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R
      @ ( product_Sigma @ A @ A @ ( field2 @ A @ R )
        @ ^ [Uu: A] : ( field2 @ A @ R ) ) ) ).

% R_subset_Field
thf(fact_1136_Restr__Field,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
        @ ( product_Sigma @ A @ A @ ( field2 @ A @ R5 )
          @ ^ [Uu: A] : ( field2 @ A @ R5 ) ) )
      = R5 ) ).

% Restr_Field
thf(fact_1137_rel__restrict__Int__empty,axiom,
    ! [A: $tType,A3: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ ( field2 @ A @ R ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( rel_restrict @ A @ R @ A3 )
        = R ) ) ).

% rel_restrict_Int_empty
thf(fact_1138_Field__Restr__subset,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ord_less_eq @ ( set @ A )
      @ ( field2 @ A
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) )
      @ A3 ) ).

% Field_Restr_subset
thf(fact_1139_Total__Restr,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( total_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( total_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ A3
              @ ^ [Uu: A] : A3 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) ) ) ).

% Total_Restr
thf(fact_1140_total__on__imp__Total__Restr,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A )] :
      ( ( total_on @ A @ A3 @ R5 )
     => ( total_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ A3
              @ ^ [Uu: A] : A3 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) ) ) ).

% total_on_imp_Total_Restr
thf(fact_1141_the1__equality,axiom,
    ! [A: $tType,P: A > $o,A4: A] :
      ( ? [X4: A] :
          ( ( P @ X4 )
          & ! [Y3: A] :
              ( ( P @ Y3 )
             => ( Y3 = X4 ) ) )
     => ( ( P @ A4 )
       => ( ( the @ A @ P )
          = A4 ) ) ) ).

% the1_equality
thf(fact_1142_the1I2,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ? [X4: A] :
          ( ( P @ X4 )
          & ! [Y3: A] :
              ( ( P @ Y3 )
             => ( Y3 = X4 ) ) )
     => ( ! [X: A] :
            ( ( P @ X )
           => ( Q @ X ) )
       => ( Q @ ( the @ A @ P ) ) ) ) ).

% the1I2
thf(fact_1143_If__def,axiom,
    ! [A: $tType] :
      ( ( if @ A )
      = ( ^ [P3: $o,X2: A,Y2: A] :
            ( the @ A
            @ ^ [Z3: A] :
                ( ( P3
                 => ( Z3 = X2 ) )
                & ( ~ P3
                 => ( Z3 = Y2 ) ) ) ) ) ) ).

% If_def
thf(fact_1144_theI2,axiom,
    ! [A: $tType,P: A > $o,A4: A,Q: A > $o] :
      ( ( P @ A4 )
     => ( ! [X: A] :
            ( ( P @ X )
           => ( X = A4 ) )
       => ( ! [X: A] :
              ( ( P @ X )
             => ( Q @ X ) )
         => ( Q @ ( the @ A @ P ) ) ) ) ) ).

% theI2
thf(fact_1145_theI_H,axiom,
    ! [A: $tType,P: A > $o] :
      ( ? [X4: A] :
          ( ( P @ X4 )
          & ! [Y3: A] :
              ( ( P @ Y3 )
             => ( Y3 = X4 ) ) )
     => ( P @ ( the @ A @ P ) ) ) ).

% theI'
thf(fact_1146_theI,axiom,
    ! [A: $tType,P: A > $o,A4: A] :
      ( ( P @ A4 )
     => ( ! [X: A] :
            ( ( P @ X )
           => ( X = A4 ) )
       => ( P @ ( the @ A @ P ) ) ) ) ).

% theI
thf(fact_1147_Preorder__Restr,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( order_preorder_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( order_preorder_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ A3
              @ ^ [Uu: A] : A3 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) ) ) ).

% Preorder_Restr
thf(fact_1148_remove__def,axiom,
    ! [A: $tType] :
      ( ( remove @ A )
      = ( ^ [X2: A,A6: set @ A] : ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% remove_def
thf(fact_1149_Ex__inj__on__UNION__Sigma,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),I: set @ B] :
    ? [F9: A > ( product_prod @ B @ A )] :
      ( ( inj_on @ A @ ( product_prod @ B @ A ) @ F9 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) )
      & ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) ) @ ( image2 @ A @ ( product_prod @ B @ A ) @ F9 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) ) @ ( product_Sigma @ B @ A @ I @ A3 ) ) ) ).

% Ex_inj_on_UNION_Sigma
thf(fact_1150_trancl__multi__insert2,axiom,
    ! [A: $tType,A4: A,B3: A,R5: set @ ( product_prod @ A @ A ),M2: A,X5: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 )
        @ ( transitive_trancl @ A
          @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ ( insert @ A @ M2 @ ( bot_bot @ ( set @ A ) ) )
              @ ^ [Uu: A] : X5 ) ) ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ ( transitive_trancl @ A @ R5 ) )
       => ~ ! [X: A] :
              ( ( member @ A @ X @ X5 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ M2 ) @ ( transitive_rtrancl @ A @ R5 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ B3 ) @ ( transitive_rtrancl @ A @ R5 ) ) ) ) ) ) ).

% trancl_multi_insert2
thf(fact_1151_trancl__multi__insert,axiom,
    ! [A: $tType,A4: A,B3: A,R5: set @ ( product_prod @ A @ A ),X5: set @ A,M2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 )
        @ ( transitive_trancl @ A
          @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ X5
              @ ^ [Uu: A] : ( insert @ A @ M2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ ( transitive_trancl @ A @ R5 ) )
       => ~ ! [X: A] :
              ( ( member @ A @ X @ X5 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ X ) @ ( transitive_rtrancl @ A @ R5 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M2 @ B3 ) @ ( transitive_rtrancl @ A @ R5 ) ) ) ) ) ) ).

% trancl_multi_insert
thf(fact_1152_flat__lub__def,axiom,
    ! [A: $tType] :
      ( ( partial_flat_lub @ A )
      = ( ^ [B4: A,A6: set @ A] :
            ( if @ A @ ( ord_less_eq @ ( set @ A ) @ A6 @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) @ B4
            @ ( the @ A
              @ ^ [X2: A] : ( member @ A @ X2 @ ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% flat_lub_def
thf(fact_1153_refl__on__singleton,axiom,
    ! [A: $tType,X3: A] : ( refl_on @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% refl_on_singleton
thf(fact_1154_fun_Oin__rel,axiom,
    ! [B: $tType,A: $tType,D: $tType,R: A > B > $o,A4: D > A,B3: D > B] :
      ( ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y5: D,Z5: D] : ( Y5 = Z5 )
        @ R
        @ A4
        @ B3 )
      = ( ? [Z3: D > ( product_prod @ A @ B )] :
            ( ( member @ ( D > ( product_prod @ A @ B ) ) @ Z3
              @ ( collect @ ( D > ( product_prod @ A @ B ) )
                @ ^ [X2: D > ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ D @ ( product_prod @ A @ B ) @ X2 @ ( top_top @ ( set @ D ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) ) ) )
            & ( ( comp @ ( product_prod @ A @ B ) @ A @ D @ ( product_fst @ A @ B ) @ Z3 )
              = A4 )
            & ( ( comp @ ( product_prod @ A @ B ) @ B @ D @ ( product_snd @ A @ B ) @ Z3 )
              = B3 ) ) ) ) ).

% fun.in_rel
thf(fact_1155_trancl__insert,axiom,
    ! [A: $tType,Y: A,X3: A,R5: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ X3 ) @ R5 ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R5 )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [A5: A,B4: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ Y ) @ ( transitive_rtrancl @ A @ R5 ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ B4 ) @ ( transitive_rtrancl @ A @ R5 ) ) ) ) ) ) ) ).

% trancl_insert
thf(fact_1156_Sup__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Sup @ B )
     => ( ( complete_Sup_Sup @ ( A > B ) )
        = ( ^ [A6: set @ ( A > B ),X2: A] :
              ( complete_Sup_Sup @ B
              @ ( image2 @ ( A > B ) @ B
                @ ^ [F3: A > B] : ( F3 @ X2 )
                @ A6 ) ) ) ) ) ).

% Sup_apply
thf(fact_1157_Sup__bot__conv_I2_J,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( ( bot_bot @ A )
            = ( complete_Sup_Sup @ A @ A3 ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A3 )
               => ( X2
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% Sup_bot_conv(2)
thf(fact_1158_Sup__bot__conv_I1_J,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A3 )
            = ( bot_bot @ A ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A3 )
               => ( X2
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% Sup_bot_conv(1)
thf(fact_1159_trancl__empty,axiom,
    ! [A: $tType] :
      ( ( transitive_trancl @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% trancl_empty
thf(fact_1160_SUP__apply,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( complete_Sup @ A )
     => ! [F2: C > B > A,A3: set @ C,X3: B] :
          ( ( complete_Sup_Sup @ ( B > A ) @ ( image2 @ C @ ( B > A ) @ F2 @ A3 ) @ X3 )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ C @ A
              @ ^ [Y2: C] : ( F2 @ Y2 @ X3 )
              @ A3 ) ) ) ) ).

% SUP_apply
thf(fact_1161_SUP__identity__eq,axiom,
    ! [A: $tType] :
      ( ( complete_Sup @ A )
     => ! [A3: set @ A] :
          ( ( complete_Sup_Sup @ A
            @ ( image2 @ A @ A
              @ ^ [X2: A] : X2
              @ A3 ) )
          = ( complete_Sup_Sup @ A @ A3 ) ) ) ).

% SUP_identity_eq
thf(fact_1162_UN__I,axiom,
    ! [B: $tType,A: $tType,A4: A,A3: set @ A,B3: B,B2: A > ( set @ B )] :
      ( ( member @ A @ A4 @ A3 )
     => ( ( member @ B @ B3 @ ( B2 @ A4 ) )
       => ( member @ B @ B3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ B2 @ A3 ) ) ) ) ) ).

% UN_I
thf(fact_1163_UN__iff,axiom,
    ! [A: $tType,B: $tType,B3: A,B2: B > ( set @ A ),A3: set @ B] :
      ( ( member @ A @ B3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) )
      = ( ? [X2: B] :
            ( ( member @ B @ X2 @ A3 )
            & ( member @ A @ B3 @ ( B2 @ X2 ) ) ) ) ) ).

% UN_iff
thf(fact_1164_Sup__empty,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( bot_bot @ A ) ) ) ).

% Sup_empty
thf(fact_1165_Sup__UNIV,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ A ) ) ) ).

% Sup_UNIV
thf(fact_1166_SUP__bot__conv_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: B > A,A3: set @ B] :
          ( ( ( bot_bot @ A )
            = ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ B2 @ A3 ) ) )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( ( B2 @ X2 )
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% SUP_bot_conv(2)
thf(fact_1167_SUP__bot__conv_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: B > A,A3: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ B2 @ A3 ) )
            = ( bot_bot @ A ) )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( ( B2 @ X2 )
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% SUP_bot_conv(1)
thf(fact_1168_SUP__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B] :
          ( ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [X2: B] : ( bot_bot @ A )
              @ A3 ) )
          = ( bot_bot @ A ) ) ) ).

% SUP_bot
thf(fact_1169_SUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Sup_Sup @ A
              @ ( image2 @ B @ A
                @ ^ [I2: B] : F2
                @ A3 ) )
            = F2 ) ) ) ).

% SUP_const
thf(fact_1170_UN__constant,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,C2: set @ A] :
      ( ( ( A3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : C2
              @ A3 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : C2
              @ A3 ) )
          = C2 ) ) ) ).

% UN_constant
thf(fact_1171_UN__Un,axiom,
    ! [A: $tType,B: $tType,M: B > ( set @ A ),A3: set @ B,B2: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ A3 ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ B2 ) ) ) ) ).

% UN_Un
thf(fact_1172_trancl__single,axiom,
    ! [A: $tType,A4: A,B3: A] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) )
      = ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% trancl_single
thf(fact_1173_UN__singleton,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ A @ ( set @ A )
          @ ^ [X2: A] : ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) )
          @ A3 ) )
      = A3 ) ).

% UN_singleton
thf(fact_1174_UN__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set @ B,A4: A,B2: B > ( set @ A )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [X2: B] : ( insert @ A @ A4 @ ( B2 @ X2 ) )
              @ C3 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [X2: B] : ( insert @ A @ A4 @ ( B2 @ X2 ) )
              @ C3 ) )
          = ( insert @ A @ A4 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ C3 ) ) ) ) ) ) ).

% UN_simps(1)
thf(fact_1175_UN__simps_I3_J,axiom,
    ! [E: $tType,F10: $tType,C3: set @ F10,A3: set @ E,B2: F10 > ( set @ E )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ F10 ) ) )
       => ( ( complete_Sup_Sup @ ( set @ E )
            @ ( image2 @ F10 @ ( set @ E )
              @ ^ [X2: F10] : ( sup_sup @ ( set @ E ) @ A3 @ ( B2 @ X2 ) )
              @ C3 ) )
          = ( bot_bot @ ( set @ E ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ F10 ) ) )
       => ( ( complete_Sup_Sup @ ( set @ E )
            @ ( image2 @ F10 @ ( set @ E )
              @ ^ [X2: F10] : ( sup_sup @ ( set @ E ) @ A3 @ ( B2 @ X2 ) )
              @ C3 ) )
          = ( sup_sup @ ( set @ E ) @ A3 @ ( complete_Sup_Sup @ ( set @ E ) @ ( image2 @ F10 @ ( set @ E ) @ B2 @ C3 ) ) ) ) ) ) ).

% UN_simps(3)
thf(fact_1176_UN__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set @ C,A3: C > ( set @ D ),B2: set @ D] :
      ( ( ( C3
          = ( bot_bot @ ( set @ C ) ) )
       => ( ( complete_Sup_Sup @ ( set @ D )
            @ ( image2 @ C @ ( set @ D )
              @ ^ [X2: C] : ( sup_sup @ ( set @ D ) @ ( A3 @ X2 ) @ B2 )
              @ C3 ) )
          = ( bot_bot @ ( set @ D ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ C ) ) )
       => ( ( complete_Sup_Sup @ ( set @ D )
            @ ( image2 @ C @ ( set @ D )
              @ ^ [X2: C] : ( sup_sup @ ( set @ D ) @ ( A3 @ X2 ) @ B2 )
              @ C3 ) )
          = ( sup_sup @ ( set @ D ) @ ( complete_Sup_Sup @ ( set @ D ) @ ( image2 @ C @ ( set @ D ) @ A3 @ C3 ) ) @ B2 ) ) ) ) ).

% UN_simps(2)
thf(fact_1177_UN__insert,axiom,
    ! [A: $tType,B: $tType,B2: B > ( set @ A ),A4: B,A3: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ ( insert @ B @ A4 @ A3 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( B2 @ A4 ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) ) ) ).

% UN_insert
thf(fact_1178_Sup__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Sup @ B )
     => ( ( complete_Sup_Sup @ ( A > B ) )
        = ( ^ [A6: set @ ( A > B ),X2: A] :
              ( complete_Sup_Sup @ B
              @ ( image2 @ ( A > B ) @ B
                @ ^ [F3: A > B] : ( F3 @ X2 )
                @ A6 ) ) ) ) ) ).

% Sup_fun_def
thf(fact_1179_Sigma__Union,axiom,
    ! [B: $tType,A: $tType,X5: set @ ( set @ A ),B2: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ ( complete_Sup_Sup @ ( set @ A ) @ X5 ) @ B2 )
      = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
        @ ( image2 @ ( set @ A ) @ ( set @ ( product_prod @ A @ B ) )
          @ ^ [A6: set @ A] : ( product_Sigma @ A @ B @ A6 @ B2 )
          @ X5 ) ) ) ).

% Sigma_Union
thf(fact_1180_fun_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Sa: A > C > $o,X3: D > A,G: B > C,Y: D > B] :
      ( ( bNF_rel_fun @ D @ D @ A @ C
        @ ^ [Y5: D,Z5: D] : ( Y5 = Z5 )
        @ Sa
        @ X3
        @ ( comp @ B @ C @ D @ G @ Y ) )
      = ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y5: D,Z5: D] : ( Y5 = Z5 )
        @ ^ [X2: A,Y2: B] : ( Sa @ X2 @ ( G @ Y2 ) )
        @ X3
        @ Y ) ) ).

% fun.rel_map(2)
thf(fact_1181_fun_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Sb: C > B > $o,I3: A > C,X3: D > A,Y: D > B] :
      ( ( bNF_rel_fun @ D @ D @ C @ B
        @ ^ [Y5: D,Z5: D] : ( Y5 = Z5 )
        @ Sb
        @ ( comp @ A @ C @ D @ I3 @ X3 )
        @ Y )
      = ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y5: D,Z5: D] : ( Y5 = Z5 )
        @ ^ [X2: A] : ( Sb @ ( I3 @ X2 ) )
        @ X3
        @ Y ) ) ).

% fun.rel_map(1)
thf(fact_1182_SUP__UNION,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: C > ( set @ B ),A3: set @ C] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ C @ ( set @ B ) @ G @ A3 ) ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ C @ A
              @ ^ [Y2: C] : ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ ( G @ Y2 ) ) )
              @ A3 ) ) ) ) ).

% SUP_UNION
thf(fact_1183_Union__empty,axiom,
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Union_empty
thf(fact_1184_Union__empty__conv,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] :
      ( ( ( complete_Sup_Sup @ ( set @ A ) @ A3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: set @ A] :
            ( ( member @ ( set @ A ) @ X2 @ A3 )
           => ( X2
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Union_empty_conv
thf(fact_1185_empty__Union__conv,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ A3 ) )
      = ( ! [X2: set @ A] :
            ( ( member @ ( set @ A ) @ X2 @ A3 )
           => ( X2
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% empty_Union_conv
thf(fact_1186_UN__Times__distrib,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,E3: C > ( set @ A ),F: D > ( set @ B ),A3: set @ C,B2: set @ D] :
      ( ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
        @ ( image2 @ ( product_prod @ C @ D ) @ ( set @ ( product_prod @ A @ B ) )
          @ ( product_case_prod @ C @ D @ ( set @ ( product_prod @ A @ B ) )
            @ ^ [A5: C,B4: D] :
                ( product_Sigma @ A @ B @ ( E3 @ A5 )
                @ ^ [Uu: A] : ( F @ B4 ) ) )
          @ ( product_Sigma @ C @ D @ A3
            @ ^ [Uu: C] : B2 ) ) )
      = ( product_Sigma @ A @ B @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ C @ ( set @ A ) @ E3 @ A3 ) )
        @ ^ [Uu: A] : ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ D @ ( set @ B ) @ F @ B2 ) ) ) ) ).

% UN_Times_distrib
thf(fact_1187_SUP__commute,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > C > A,B2: set @ C,A3: set @ B] :
          ( ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [I2: B] : ( complete_Sup_Sup @ A @ ( image2 @ C @ A @ ( F2 @ I2 ) @ B2 ) )
              @ A3 ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ C @ A
              @ ^ [J3: C] :
                  ( complete_Sup_Sup @ A
                  @ ( image2 @ B @ A
                    @ ^ [I2: B] : ( F2 @ I2 @ J3 )
                    @ A3 ) )
              @ B2 ) ) ) ) ).

% SUP_commute
thf(fact_1188_SUP__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: $o > A] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ $o @ A @ A3 @ ( top_top @ ( set @ $o ) ) ) )
          = ( sup_sup @ A @ ( A3 @ $true ) @ ( A3 @ $false ) ) ) ) ).

% SUP_UNIV_bool_expand
thf(fact_1189_Union__SetCompr__eq,axiom,
    ! [B: $tType,A: $tType,F2: B > ( set @ A ),P: B > $o] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [Uu: set @ A] :
            ? [X2: B] :
              ( ( Uu
                = ( F2 @ X2 ) )
              & ( P @ X2 ) ) ) )
      = ( collect @ A
        @ ^ [A5: A] :
          ? [X2: B] :
            ( ( P @ X2 )
            & ( member @ A @ A5 @ ( F2 @ X2 ) ) ) ) ) ).

% Union_SetCompr_eq
thf(fact_1190_UN__bool__eq,axiom,
    ! [A: $tType,A3: $o > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ $o @ ( set @ A ) @ A3 @ ( top_top @ ( set @ $o ) ) ) )
      = ( sup_sup @ ( set @ A ) @ ( A3 @ $true ) @ ( A3 @ $false ) ) ) ).

% UN_bool_eq
thf(fact_1191_Un__eq__UN,axiom,
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A6: set @ A,B5: set @ A] :
            ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ $o @ ( set @ A )
              @ ^ [B4: $o] : ( if @ ( set @ A ) @ B4 @ A6 @ B5 )
              @ ( top_top @ ( set @ $o ) ) ) ) ) ) ).

% Un_eq_UN
thf(fact_1192_UN__extend__simps_I9_J,axiom,
    ! [S6: $tType,R6: $tType,Q7: $tType,C3: R6 > ( set @ S6 ),B2: Q7 > ( set @ R6 ),A3: set @ Q7] :
      ( ( complete_Sup_Sup @ ( set @ S6 )
        @ ( image2 @ Q7 @ ( set @ S6 )
          @ ^ [X2: Q7] : ( complete_Sup_Sup @ ( set @ S6 ) @ ( image2 @ R6 @ ( set @ S6 ) @ C3 @ ( B2 @ X2 ) ) )
          @ A3 ) )
      = ( complete_Sup_Sup @ ( set @ S6 ) @ ( image2 @ R6 @ ( set @ S6 ) @ C3 @ ( complete_Sup_Sup @ ( set @ R6 ) @ ( image2 @ Q7 @ ( set @ R6 ) @ B2 @ A3 ) ) ) ) ) ).

% UN_extend_simps(9)
thf(fact_1193_UN__E,axiom,
    ! [A: $tType,B: $tType,B3: A,B2: B > ( set @ A ),A3: set @ B] :
      ( ( member @ A @ B3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) )
     => ~ ! [X: B] :
            ( ( member @ B @ X @ A3 )
           => ~ ( member @ A @ B3 @ ( B2 @ X ) ) ) ) ).

% UN_E
thf(fact_1194_UN__UN__flatten,axiom,
    ! [A: $tType,B: $tType,C: $tType,C3: B > ( set @ A ),B2: C > ( set @ B ),A3: set @ C] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ C3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ C @ ( set @ B ) @ B2 @ A3 ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ C @ ( set @ A )
          @ ^ [Y2: C] : ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ C3 @ ( B2 @ Y2 ) ) )
          @ A3 ) ) ) ).

% UN_UN_flatten
thf(fact_1195_predicate2__transferD,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: A > B > $o,R22: C > D > $o,P: A > C > $o,Q: B > D > $o,A4: product_prod @ A @ B,A3: set @ ( product_prod @ A @ B ),B3: product_prod @ C @ D,B2: set @ ( product_prod @ C @ D )] :
      ( ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ R1
        @ ( bNF_rel_fun @ C @ D @ $o @ $o @ R22
          @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) )
        @ P
        @ Q )
     => ( ( member @ ( product_prod @ A @ B ) @ A4 @ A3 )
       => ( ( member @ ( product_prod @ C @ D ) @ B3 @ B2 )
         => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A3 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R1 ) ) )
           => ( ( ord_less_eq @ ( set @ ( product_prod @ C @ D ) ) @ B2 @ ( collect @ ( product_prod @ C @ D ) @ ( product_case_prod @ C @ D @ $o @ R22 ) ) )
             => ( ( P @ ( product_fst @ A @ B @ A4 ) @ ( product_fst @ C @ D @ B3 ) )
                = ( Q @ ( product_snd @ A @ B @ A4 ) @ ( product_snd @ C @ D @ B3 ) ) ) ) ) ) ) ) ).

% predicate2_transferD
thf(fact_1196_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U2: A] :
          ( ! [V3: A] :
              ( ( member @ A @ V3 @ A3 )
             => ( ord_less_eq @ A @ U2 @ V3 ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_1197_SUP__eq__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: set @ B,F2: B > A,X3: A] :
          ( ( I
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ I )
               => ( ( F2 @ I4 )
                  = X3 ) )
           => ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ I ) )
              = X3 ) ) ) ) ).

% SUP_eq_const
thf(fact_1198_Sup__inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B2: set @ A,A4: A] :
          ( ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ B2 ) @ A4 )
            = ( bot_bot @ A ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ B2 )
               => ( ( inf_inf @ A @ X2 @ A4 )
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% Sup_inf_eq_bot_iff
thf(fact_1199_inf__Sup,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A4: A,B2: set @ A] :
          ( ( inf_inf @ A @ A4 @ ( complete_Sup_Sup @ A @ B2 ) )
          = ( complete_Sup_Sup @ A @ ( image2 @ A @ A @ ( inf_inf @ A @ A4 ) @ B2 ) ) ) ) ).

% inf_Sup
thf(fact_1200_insert__partition,axiom,
    ! [A: $tType,X3: set @ A,F: set @ ( set @ A )] :
      ( ~ ( member @ ( set @ A ) @ X3 @ F )
     => ( ! [X: set @ A] :
            ( ( member @ ( set @ A ) @ X @ ( insert @ ( set @ A ) @ X3 @ F ) )
           => ! [Xa2: set @ A] :
                ( ( member @ ( set @ A ) @ Xa2 @ ( insert @ ( set @ A ) @ X3 @ F ) )
               => ( ( X != Xa2 )
                 => ( ( inf_inf @ ( set @ A ) @ X @ Xa2 )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ X3 @ ( complete_Sup_Sup @ ( set @ A ) @ F ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% insert_partition
thf(fact_1201_Union__disjoint,axiom,
    ! [A: $tType,C3: set @ ( set @ A ),A3: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ C3 ) @ A3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: set @ A] :
            ( ( member @ ( set @ A ) @ X2 @ C3 )
           => ( ( inf_inf @ ( set @ A ) @ X2 @ A3 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Union_disjoint
thf(fact_1202_Union__Int__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B2: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A3 @ B2 ) ) @ ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B2 ) ) ) ).

% Union_Int_subset
thf(fact_1203_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A,X3: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ X3 ) )
         => ( ! [Y3: A] :
                ( ! [I5: B] :
                    ( ( member @ B @ I5 @ A3 )
                   => ( ord_less_eq @ A @ ( F2 @ I5 ) @ Y3 ) )
               => ( ord_less_eq @ A @ X3 @ Y3 ) )
           => ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
              = X3 ) ) ) ) ).

% SUP_eqI
thf(fact_1204_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B2: set @ C,F2: B > A,G: C > A] :
          ( ! [N2: B] :
              ( ( member @ B @ N2 @ A3 )
             => ? [X4: C] :
                  ( ( member @ C @ X4 @ B2 )
                  & ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G @ X4 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ C @ A @ G @ B2 ) ) ) ) ) ).

% SUP_mono
thf(fact_1205_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A,U2: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ U2 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ U2 ) ) ) ).

% SUP_least
thf(fact_1206_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ! [X: B] : ( ord_less_eq @ A @ ( F2 @ X ) @ ( G @ X ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ G @ A3 ) ) ) ) ) ).

% SUP_mono'
thf(fact_1207_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,F2: B > A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% SUP_upper
thf(fact_1208_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,U2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ U2 )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ U2 ) ) ) ) ) ).

% SUP_le_iff
thf(fact_1209_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,U2: A,F2: B > A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ( ord_less_eq @ A @ U2 @ ( F2 @ I3 ) )
           => ( ord_less_eq @ A @ U2 @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_1210_SUP__inf__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F2: B > A,A3: set @ B,G: C > A,B2: set @ C] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ C @ A @ G @ B2 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [A5: B] :
                  ( complete_Sup_Sup @ A
                  @ ( image2 @ C @ A
                    @ ^ [B4: C] : ( inf_inf @ A @ ( F2 @ A5 ) @ ( G @ B4 ) )
                    @ B2 ) )
              @ A3 ) ) ) ) ).

% SUP_inf_distrib2
thf(fact_1211_inf__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A4: A,F2: B > A,B2: set @ B] :
          ( ( inf_inf @ A @ A4 @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ B2 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [B4: B] : ( inf_inf @ A @ A4 @ ( F2 @ B4 ) )
              @ B2 ) ) ) ) ).

% inf_SUP
thf(fact_1212_Sup__inf,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B2: set @ A,A4: A] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ B2 ) @ A4 )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ A @ A
              @ ^ [B4: A] : ( inf_inf @ A @ B4 @ A4 )
              @ B2 ) ) ) ) ).

% Sup_inf
thf(fact_1213_SUP__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F2: B > A,B2: set @ B,A4: A] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ B2 ) ) @ A4 )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [B4: B] : ( inf_inf @ A @ ( F2 @ B4 ) @ A4 )
              @ B2 ) ) ) ) ).

% SUP_inf
thf(fact_1214_complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,G: B > A] :
          ( ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ G @ A3 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [A5: B] : ( sup_sup @ A @ ( F2 @ A5 ) @ ( G @ A5 ) )
              @ A3 ) ) ) ) ).

% complete_lattice_class.SUP_sup_distrib
thf(fact_1215_SUP__absorb,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [K: B,I: set @ B,A3: B > A] :
          ( ( member @ B @ K @ I )
         => ( ( sup_sup @ A @ ( A3 @ K ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ A3 @ I ) ) )
            = ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ A3 @ I ) ) ) ) ) ).

% SUP_absorb
thf(fact_1216_refl__on__empty,axiom,
    ! [A: $tType] : ( refl_on @ A @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% refl_on_empty
thf(fact_1217_trancl__subset__Sigma,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5
        @ ( product_Sigma @ A @ A @ A3
          @ ^ [Uu: A] : A3 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R5 )
        @ ( product_Sigma @ A @ A @ A3
          @ ^ [Uu: A] : A3 ) ) ) ).

% trancl_subset_Sigma
thf(fact_1218_refl__on__Int,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),B2: set @ A,S3: set @ ( product_prod @ A @ A )] :
      ( ( refl_on @ A @ A3 @ R5 )
     => ( ( refl_on @ A @ B2 @ S3 )
       => ( refl_on @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ S3 ) ) ) ) ).

% refl_on_Int
thf(fact_1219_UN__extend__simps_I10_J,axiom,
    ! [V4: $tType,U4: $tType,T: $tType,B2: U4 > ( set @ V4 ),F2: T > U4,A3: set @ T] :
      ( ( complete_Sup_Sup @ ( set @ V4 )
        @ ( image2 @ T @ ( set @ V4 )
          @ ^ [A5: T] : ( B2 @ ( F2 @ A5 ) )
          @ A3 ) )
      = ( complete_Sup_Sup @ ( set @ V4 ) @ ( image2 @ U4 @ ( set @ V4 ) @ B2 @ ( image2 @ T @ U4 @ F2 @ A3 ) ) ) ) ).

% UN_extend_simps(10)
thf(fact_1220_image__UN,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,B2: C > ( set @ B ),A3: set @ C] :
      ( ( image2 @ B @ A @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ C @ ( set @ B ) @ B2 @ A3 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ C @ ( set @ A )
          @ ^ [X2: C] : ( image2 @ B @ A @ F2 @ ( B2 @ X2 ) )
          @ A3 ) ) ) ).

% image_UN
thf(fact_1221_UN__empty2,axiom,
    ! [B: $tType,A: $tType,A3: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X2: B] : ( bot_bot @ ( set @ A ) )
          @ A3 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% UN_empty2
thf(fact_1222_UN__empty,axiom,
    ! [B: $tType,A: $tType,B2: B > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ ( bot_bot @ ( set @ B ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% UN_empty
thf(fact_1223_UNION__empty__conv_I1_J,axiom,
    ! [A: $tType,B: $tType,B2: B > ( set @ A ),A3: set @ B] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ A3 )
           => ( ( B2 @ X2 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% UNION_empty_conv(1)
thf(fact_1224_UNION__empty__conv_I2_J,axiom,
    ! [A: $tType,B: $tType,B2: B > ( set @ A ),A3: set @ B] :
      ( ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ A3 )
           => ( ( B2 @ X2 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% UNION_empty_conv(2)
thf(fact_1225_UN__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ! [X: A] :
            ( ( member @ A @ X @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X ) @ ( G @ X ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ G @ B2 ) ) ) ) ) ).

% UN_mono
thf(fact_1226_UN__least,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: A > ( set @ B ),C3: set @ B] :
      ( ! [X: A] :
          ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ ( B2 @ X ) @ C3 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ B2 @ A3 ) ) @ C3 ) ) ).

% UN_least
thf(fact_1227_UN__upper,axiom,
    ! [B: $tType,A: $tType,A4: A,A3: set @ A,B2: A > ( set @ B )] :
      ( ( member @ A @ A4 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( B2 @ A4 ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ B2 @ A3 ) ) ) ) ).

% UN_upper
thf(fact_1228_UN__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),I: set @ B,B2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) @ B2 )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ I )
           => ( ord_less_eq @ ( set @ A ) @ ( A3 @ X2 ) @ B2 ) ) ) ) ).

% UN_subset_iff
thf(fact_1229_UN__insert__distrib,axiom,
    ! [B: $tType,A: $tType,U2: A,A3: set @ A,A4: B,B2: A > ( set @ B )] :
      ( ( member @ A @ U2 @ A3 )
     => ( ( complete_Sup_Sup @ ( set @ B )
          @ ( image2 @ A @ ( set @ B )
            @ ^ [X2: A] : ( insert @ B @ A4 @ ( B2 @ X2 ) )
            @ A3 ) )
        = ( insert @ B @ A4 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ B2 @ A3 ) ) ) ) ) ).

% UN_insert_distrib
thf(fact_1230_Int__UN__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType,A3: B > ( set @ A ),I: set @ B,B2: C > ( set @ A ),J: set @ C] :
      ( ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ C @ ( set @ A ) @ B2 @ J ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I2: B] :
              ( complete_Sup_Sup @ ( set @ A )
              @ ( image2 @ C @ ( set @ A )
                @ ^ [J3: C] : ( inf_inf @ ( set @ A ) @ ( A3 @ I2 ) @ ( B2 @ J3 ) )
                @ J ) )
          @ I ) ) ) ).

% Int_UN_distrib2
thf(fact_1231_Int__UN__distrib,axiom,
    ! [A: $tType,B: $tType,B2: set @ A,A3: B > ( set @ A ),I: set @ B] :
      ( ( inf_inf @ ( set @ A ) @ B2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I2: B] : ( inf_inf @ ( set @ A ) @ B2 @ ( A3 @ I2 ) )
          @ I ) ) ) ).

% Int_UN_distrib
thf(fact_1232_UN__extend__simps_I4_J,axiom,
    ! [H8: $tType,G3: $tType,A3: G3 > ( set @ H8 ),C3: set @ G3,B2: set @ H8] :
      ( ( inf_inf @ ( set @ H8 ) @ ( complete_Sup_Sup @ ( set @ H8 ) @ ( image2 @ G3 @ ( set @ H8 ) @ A3 @ C3 ) ) @ B2 )
      = ( complete_Sup_Sup @ ( set @ H8 )
        @ ( image2 @ G3 @ ( set @ H8 )
          @ ^ [X2: G3] : ( inf_inf @ ( set @ H8 ) @ ( A3 @ X2 ) @ B2 )
          @ C3 ) ) ) ).

% UN_extend_simps(4)
thf(fact_1233_UN__extend__simps_I5_J,axiom,
    ! [I6: $tType,J4: $tType,A3: set @ I6,B2: J4 > ( set @ I6 ),C3: set @ J4] :
      ( ( inf_inf @ ( set @ I6 ) @ A3 @ ( complete_Sup_Sup @ ( set @ I6 ) @ ( image2 @ J4 @ ( set @ I6 ) @ B2 @ C3 ) ) )
      = ( complete_Sup_Sup @ ( set @ I6 )
        @ ( image2 @ J4 @ ( set @ I6 )
          @ ^ [X2: J4] : ( inf_inf @ ( set @ I6 ) @ A3 @ ( B2 @ X2 ) )
          @ C3 ) ) ) ).

% UN_extend_simps(5)
thf(fact_1234_Un__Union__image,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),B2: B > ( set @ A ),C3: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X2: B] : ( sup_sup @ ( set @ A ) @ ( A3 @ X2 ) @ ( B2 @ X2 ) )
          @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ C3 ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ C3 ) ) ) ) ).

% Un_Union_image
thf(fact_1235_UN__Un__distrib,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),B2: B > ( set @ A ),I: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I2: B] : ( sup_sup @ ( set @ A ) @ ( A3 @ I2 ) @ ( B2 @ I2 ) )
          @ I ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ I ) ) ) ) ).

% UN_Un_distrib
thf(fact_1236_UN__absorb,axiom,
    ! [B: $tType,A: $tType,K: A,I: set @ A,A3: A > ( set @ B )] :
      ( ( member @ A @ K @ I )
     => ( ( sup_sup @ ( set @ B ) @ ( A3 @ K ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ I ) ) )
        = ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ I ) ) ) ) ).

% UN_absorb
thf(fact_1237_UN__extend__simps_I6_J,axiom,
    ! [L3: $tType,K4: $tType,A3: K4 > ( set @ L3 ),C3: set @ K4,B2: set @ L3] :
      ( ( minus_minus @ ( set @ L3 ) @ ( complete_Sup_Sup @ ( set @ L3 ) @ ( image2 @ K4 @ ( set @ L3 ) @ A3 @ C3 ) ) @ B2 )
      = ( complete_Sup_Sup @ ( set @ L3 )
        @ ( image2 @ K4 @ ( set @ L3 )
          @ ^ [X2: K4] : ( minus_minus @ ( set @ L3 ) @ ( A3 @ X2 ) @ B2 )
          @ C3 ) ) ) ).

% UN_extend_simps(6)
thf(fact_1238_vimage__UN,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > B,B2: C > ( set @ B ),A3: set @ C] :
      ( ( vimage @ A @ B @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ C @ ( set @ B ) @ B2 @ A3 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ C @ ( set @ A )
          @ ^ [X2: C] : ( vimage @ A @ B @ F2 @ ( B2 @ X2 ) )
          @ A3 ) ) ) ).

% vimage_UN
thf(fact_1239_image__Union,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ ( set @ B )] :
      ( ( image2 @ B @ A @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ S2 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( set @ B ) @ ( set @ A ) @ ( image2 @ B @ A @ F2 ) @ S2 ) ) ) ).

% image_Union
thf(fact_1240_Int__Union2,axiom,
    ! [A: $tType,B2: set @ ( set @ A ),A3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ B2 ) @ A3 )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ ( set @ A ) @ ( set @ A )
          @ ^ [C7: set @ A] : ( inf_inf @ ( set @ A ) @ C7 @ A3 )
          @ B2 ) ) ) ).

% Int_Union2
thf(fact_1241_Int__Union,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ B2 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 ) @ B2 ) ) ) ).

% Int_Union
thf(fact_1242_UN__extend__simps_I8_J,axiom,
    ! [P8: $tType,O: $tType,B2: O > ( set @ P8 ),A3: set @ ( set @ O )] :
      ( ( complete_Sup_Sup @ ( set @ P8 )
        @ ( image2 @ ( set @ O ) @ ( set @ P8 )
          @ ^ [Y2: set @ O] : ( complete_Sup_Sup @ ( set @ P8 ) @ ( image2 @ O @ ( set @ P8 ) @ B2 @ Y2 ) )
          @ A3 ) )
      = ( complete_Sup_Sup @ ( set @ P8 ) @ ( image2 @ O @ ( set @ P8 ) @ B2 @ ( complete_Sup_Sup @ ( set @ O ) @ A3 ) ) ) ) ).

% UN_extend_simps(8)
thf(fact_1243_vimage__Union,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ ( set @ B )] :
      ( ( vimage @ A @ B @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ A3 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( set @ B ) @ ( set @ A ) @ ( vimage @ A @ B @ F2 ) @ A3 ) ) ) ).

% vimage_Union
thf(fact_1244_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: set @ B,C2: A,F2: B > A] :
          ( ( I
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ I )
               => ( ord_less_eq @ A @ C2 @ ( F2 @ I4 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ I ) )
                = C2 )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ I )
                   => ( ( F2 @ X2 )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_1245_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B2: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B2 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_1246_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B2: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A3 @ B2 )
         => ( ! [X: B] :
                ( ( member @ B @ X @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X ) @ ( G @ X ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ G @ B2 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_1247_SUP__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ ( bot_bot @ ( set @ B ) ) ) )
          = ( bot_bot @ A ) ) ) ).

% SUP_empty
thf(fact_1248_SUP__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( ( A3
              = ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Sup_Sup @ A
                @ ( image2 @ B @ A
                  @ ^ [Y2: B] : C2
                  @ A3 ) )
              = ( bot_bot @ A ) ) )
          & ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Sup_Sup @ A
                @ ( image2 @ B @ A
                  @ ^ [Y2: B] : C2
                  @ A3 ) )
              = C2 ) ) ) ) ).

% SUP_constant
thf(fact_1249_trancl__subset__Field2,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R5 )
      @ ( product_Sigma @ A @ A @ ( field2 @ A @ R5 )
        @ ^ [Uu: A] : ( field2 @ A @ R5 ) ) ) ).

% trancl_subset_Field2
thf(fact_1250_SUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A4: B,A3: set @ B] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ ( insert @ B @ A4 @ A3 ) ) )
          = ( sup_sup @ A @ ( F2 @ A4 ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% SUP_insert
thf(fact_1251_Restr__trancl__mono,axiom,
    ! [A: $tType,V: A,W2: A,E3: set @ ( product_prod @ A @ A ),U3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 )
        @ ( transitive_trancl @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ E3
            @ ( product_Sigma @ A @ A @ U3
              @ ^ [Uu: A] : U3 ) ) ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 ) @ ( transitive_trancl @ A @ E3 ) ) ) ).

% Restr_trancl_mono
thf(fact_1252_SUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [M: B > A,A3: set @ B,B2: set @ B] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ M @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) ) )
          = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ M @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ M @ B2 ) ) ) ) ) ).

% SUP_union
thf(fact_1253_UN__extend__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set @ B,A4: A,B2: B > ( set @ A )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( insert @ A @ A4 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ C3 ) ) )
          = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( insert @ A @ A4 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ C3 ) ) )
          = ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [X2: B] : ( insert @ A @ A4 @ ( B2 @ X2 ) )
              @ C3 ) ) ) ) ) ).

% UN_extend_simps(1)
thf(fact_1254_Collect__ex__eq,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o] :
      ( ( collect @ A
        @ ^ [X2: A] :
          ? [X7: B] : ( P @ X2 @ X7 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [Y2: B] :
              ( collect @ A
              @ ^ [X2: A] : ( P @ X2 @ Y2 ) )
          @ ( top_top @ ( set @ B ) ) ) ) ) ).

% Collect_ex_eq
thf(fact_1255_UN__extend__simps_I3_J,axiom,
    ! [E: $tType,F10: $tType,C3: set @ F10,A3: set @ E,B2: F10 > ( set @ E )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ F10 ) ) )
       => ( ( sup_sup @ ( set @ E ) @ A3 @ ( complete_Sup_Sup @ ( set @ E ) @ ( image2 @ F10 @ ( set @ E ) @ B2 @ C3 ) ) )
          = A3 ) )
      & ( ( C3
         != ( bot_bot @ ( set @ F10 ) ) )
       => ( ( sup_sup @ ( set @ E ) @ A3 @ ( complete_Sup_Sup @ ( set @ E ) @ ( image2 @ F10 @ ( set @ E ) @ B2 @ C3 ) ) )
          = ( complete_Sup_Sup @ ( set @ E )
            @ ( image2 @ F10 @ ( set @ E )
              @ ^ [X2: F10] : ( sup_sup @ ( set @ E ) @ A3 @ ( B2 @ X2 ) )
              @ C3 ) ) ) ) ) ).

% UN_extend_simps(3)
thf(fact_1256_UN__extend__simps_I2_J,axiom,
    ! [D: $tType,C: $tType,C3: set @ C,A3: C > ( set @ D ),B2: set @ D] :
      ( ( ( C3
          = ( bot_bot @ ( set @ C ) ) )
       => ( ( sup_sup @ ( set @ D ) @ ( complete_Sup_Sup @ ( set @ D ) @ ( image2 @ C @ ( set @ D ) @ A3 @ C3 ) ) @ B2 )
          = B2 ) )
      & ( ( C3
         != ( bot_bot @ ( set @ C ) ) )
       => ( ( sup_sup @ ( set @ D ) @ ( complete_Sup_Sup @ ( set @ D ) @ ( image2 @ C @ ( set @ D ) @ A3 @ C3 ) ) @ B2 )
          = ( complete_Sup_Sup @ ( set @ D )
            @ ( image2 @ C @ ( set @ D )
              @ ^ [X2: C] : ( sup_sup @ ( set @ D ) @ ( A3 @ X2 ) @ B2 )
              @ C3 ) ) ) ) ) ).

% UN_extend_simps(2)
thf(fact_1257_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I: set @ A,A3: A > ( set @ B ),F2: B > C] :
      ( ! [I4: A,J5: A] :
          ( ( member @ A @ I4 @ I )
         => ( ( member @ A @ J5 @ I )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I4 ) @ ( A3 @ J5 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J5 ) @ ( A3 @ I4 ) ) ) ) )
     => ( ! [I4: A] :
            ( ( member @ A @ I4 @ I )
           => ( inj_on @ B @ C @ F2 @ ( A3 @ I4 ) ) )
       => ( inj_on @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ I ) ) ) ) ) ).

% inj_on_UNION_chain
thf(fact_1258_refl__on__def,axiom,
    ! [A: $tType] :
      ( ( refl_on @ A )
      = ( ^ [A6: set @ A,R3: set @ ( product_prod @ A @ A )] :
            ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R3
              @ ( product_Sigma @ A @ A @ A6
                @ ^ [Uu: A] : A6 ) )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ A6 )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R3 ) ) ) ) ) ).

% refl_on_def
thf(fact_1259_refl__onI,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5
        @ ( product_Sigma @ A @ A @ A3
          @ ^ [Uu: A] : A3 ) )
     => ( ! [X: A] :
            ( ( member @ A @ X @ A3 )
           => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ R5 ) )
       => ( refl_on @ A @ A3 @ R5 ) ) ) ).

% refl_onI
thf(fact_1260_Refl__Restr,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( refl_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( refl_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ A3
              @ ^ [Uu: A] : A3 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) ) ) ).

% Refl_Restr
thf(fact_1261_trancl__insert2,axiom,
    ! [A: $tType,A4: A,B3: A,R5: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R5 ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R5 )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X2: A,Y2: A] :
                ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ A4 ) @ ( transitive_trancl @ A @ R5 ) )
                  | ( X2 = A4 ) )
                & ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ Y2 ) @ ( transitive_trancl @ A @ R5 ) )
                  | ( Y2 = B3 ) ) ) ) ) ) ) ).

% trancl_insert2
thf(fact_1262_rel__restrict__Sigma__sub,axiom,
    ! [A: $tType,A3: set @ A,R: set @ A] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) )
      @ ( rel_restrict @ A
        @ ( transitive_trancl @ A
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) )
        @ R )
      @ ( transitive_trancl @ A
        @ ( product_Sigma @ A @ A @ ( minus_minus @ ( set @ A ) @ A3 @ R )
          @ ^ [Uu: A] : ( minus_minus @ ( set @ A ) @ A3 @ R ) ) ) ) ).

% rel_restrict_Sigma_sub
thf(fact_1263_UNION__singleton__eq__range,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X2: B] : ( insert @ A @ ( F2 @ X2 ) @ ( bot_bot @ ( set @ A ) ) )
          @ A3 ) )
      = ( image2 @ B @ A @ F2 @ A3 ) ) ).

% UNION_singleton_eq_range
thf(fact_1264_vimage__eq__UN,axiom,
    ! [B: $tType,A: $tType] :
      ( ( vimage @ A @ B )
      = ( ^ [F3: A > B,B5: set @ B] :
            ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : ( vimage @ A @ B @ F3 @ ( insert @ B @ Y2 @ ( bot_bot @ ( set @ B ) ) ) )
              @ B5 ) ) ) ) ).

% vimage_eq_UN
thf(fact_1265_snd__image__Sigma,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,B2: B > ( set @ A )] :
      ( ( image2 @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ ( product_Sigma @ B @ A @ A3 @ B2 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) ) ).

% snd_image_Sigma
thf(fact_1266_Sigma__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_Sigma @ A @ B )
      = ( ^ [A6: set @ A,B5: A > ( set @ B )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
            @ ( image2 @ A @ ( set @ ( product_prod @ A @ B ) )
              @ ^ [X2: A] :
                  ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
                  @ ( image2 @ B @ ( set @ ( product_prod @ A @ B ) )
                    @ ^ [Y2: B] : ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
                    @ ( B5 @ X2 ) ) )
              @ A6 ) ) ) ) ).

% Sigma_def
thf(fact_1267_fun_Omap__ident,axiom,
    ! [A: $tType,D: $tType,T3: D > A] :
      ( ( comp @ A @ A @ D
        @ ^ [X2: A] : X2
        @ T3 )
      = T3 ) ).

% fun.map_ident
thf(fact_1268_Id__on__def,axiom,
    ! [A: $tType] :
      ( ( id_on @ A )
      = ( ^ [A6: set @ A] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image2 @ A @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [X2: A] : ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
              @ A6 ) ) ) ) ).

% Id_on_def
thf(fact_1269_Refl__Field__Restr2,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( refl_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( field2 @ A @ R5 ) )
       => ( ( field2 @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
              @ ( product_Sigma @ A @ A @ A3
                @ ^ [Uu: A] : A3 ) ) )
          = A3 ) ) ) ).

% Refl_Field_Restr2
thf(fact_1270_Refl__Field__Restr,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( refl_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ A3
              @ ^ [Uu: A] : A3 ) ) )
        = ( inf_inf @ ( set @ A ) @ ( field2 @ A @ R5 ) @ A3 ) ) ) ).

% Refl_Field_Restr
thf(fact_1271_rtrancl__last__visit,axiom,
    ! [A: $tType,Q4: A,Q6: A,R: set @ ( product_prod @ A @ A ),S2: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Q6 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Q6 )
            @ ( transitive_rtrancl @ A
              @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R
                @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                  @ ^ [Uu: A] : S2 ) ) ) )
       => ~ ! [Qt: A] :
              ( ( member @ A @ Qt @ S2 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Qt ) @ ( transitive_trancl @ A @ R ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Qt @ Q6 )
                    @ ( transitive_rtrancl @ A
                      @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R
                        @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                          @ ^ [Uu: A] : S2 ) ) ) ) ) ) ) ) ).

% rtrancl_last_visit
thf(fact_1272_cSUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Sup_Sup @ A
              @ ( image2 @ B @ A
                @ ^ [X2: B] : C2
                @ A3 ) )
            = C2 ) ) ) ).

% cSUP_const
thf(fact_1273_cSup__singleton,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X3: A] :
          ( ( complete_Sup_Sup @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
          = X3 ) ) ).

% cSup_singleton
thf(fact_1274_ccpo__Sup__singleton,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [X3: A] :
          ( ( complete_Sup_Sup @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
          = X3 ) ) ).

% ccpo_Sup_singleton
thf(fact_1275_Union__image__empty,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: B > ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ F2 @ ( bot_bot @ ( set @ B ) ) ) ) )
      = A3 ) ).

% Union_image_empty
thf(fact_1276_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,M: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X: B] :
                ( ( member @ B @ X @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X ) @ M ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ M ) ) ) ) ).

% cSUP_least
thf(fact_1277_preorder__on__empty,axiom,
    ! [A: $tType] : ( order_preorder_on @ A @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% preorder_on_empty
thf(fact_1278_UN__image__subset,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: B > ( set @ A ),G: C > ( set @ B ),X3: C,X5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ F2 @ ( G @ X3 ) ) ) @ X5 )
      = ( ord_less_eq @ ( set @ B ) @ ( G @ X3 )
        @ ( collect @ B
          @ ^ [X2: B] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ X2 ) @ X5 ) ) ) ) ).

% UN_image_subset
thf(fact_1279_finite__inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A4: A,A3: set @ A] :
          ( ( inf_inf @ A @ A4 @ ( complete_Sup_Sup @ A @ A3 ) )
          = ( complete_Sup_Sup @ A
            @ ( collect @ A
              @ ^ [Uu: A] :
                ? [B4: A] :
                  ( ( Uu
                    = ( inf_inf @ A @ A4 @ B4 ) )
                  & ( member @ A @ B4 @ A3 ) ) ) ) ) ) ).

% finite_inf_Sup
thf(fact_1280_top__finite__def,axiom,
    ! [A: $tType] :
      ( ( finite_lattice @ A )
     => ( ( top_top @ A )
        = ( complete_Sup_Sup @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% top_finite_def
thf(fact_1281_Sup__nat__empty,axiom,
    ( ( complete_Sup_Sup @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% Sup_nat_empty
thf(fact_1282_in__Union__o__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,X3: A,Gset: B > ( set @ ( set @ A ) ),Gmap: C > B,A3: C] :
      ( ( member @ A @ X3 @ ( comp @ B @ ( set @ A ) @ C @ ( comp @ ( set @ ( set @ A ) ) @ ( set @ A ) @ B @ ( complete_Sup_Sup @ ( set @ A ) ) @ Gset ) @ Gmap @ A3 ) )
     => ( member @ A @ X3 @ ( comp @ ( set @ ( set @ A ) ) @ ( set @ A ) @ C @ ( complete_Sup_Sup @ ( set @ A ) ) @ ( comp @ B @ ( set @ ( set @ A ) ) @ C @ Gset @ Gmap ) @ A3 ) ) ) ).

% in_Union_o_assoc
thf(fact_1283_UNIV__bool,axiom,
    ( ( top_top @ ( set @ $o ) )
    = ( insert @ $o @ $false @ ( insert @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) ) ) ).

% UNIV_bool
thf(fact_1284_empty__natural,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F2: A > C,G: D > B] :
      ( ( comp @ C @ ( set @ B ) @ A
        @ ^ [Uu: C] : ( bot_bot @ ( set @ B ) )
        @ F2 )
      = ( comp @ ( set @ D ) @ ( set @ B ) @ A @ ( image2 @ D @ B @ G )
        @ ^ [Uu: A] : ( bot_bot @ ( set @ D ) ) ) ) ).

% empty_natural
thf(fact_1285_Union__natural,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( comp @ ( set @ ( set @ B ) ) @ ( set @ B ) @ ( set @ ( set @ A ) ) @ ( complete_Sup_Sup @ ( set @ B ) ) @ ( image2 @ ( set @ A ) @ ( set @ B ) @ ( image2 @ A @ B @ F2 ) ) )
      = ( comp @ ( set @ A ) @ ( set @ B ) @ ( set @ ( set @ A ) ) @ ( image2 @ A @ B @ F2 ) @ ( complete_Sup_Sup @ ( set @ A ) ) ) ) ).

% Union_natural
thf(fact_1286_SUP__UN__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R5: C > ( set @ ( product_prod @ A @ B ) ),S2: set @ C] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image2 @ C @ ( A > B > $o )
          @ ^ [I2: C,X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( R5 @ I2 ) )
          @ S2 ) )
      = ( ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ C @ ( set @ ( product_prod @ A @ B ) ) @ R5 @ S2 ) ) ) ) ) ).

% SUP_UN_eq2
thf(fact_1287_SUP__Sup__eq2,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image2 @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I2: set @ ( product_prod @ A @ B ),X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ I2 )
          @ S2 ) )
      = ( ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ S2 ) ) ) ) ).

% SUP_Sup_eq2
thf(fact_1288_SUP__Sup__eq,axiom,
    ! [A: $tType,S2: set @ ( set @ A )] :
      ( ( complete_Sup_Sup @ ( A > $o )
        @ ( image2 @ ( set @ A ) @ ( A > $o )
          @ ^ [I2: set @ A,X2: A] : ( member @ A @ X2 @ I2 )
          @ S2 ) )
      = ( ^ [X2: A] : ( member @ A @ X2 @ ( complete_Sup_Sup @ ( set @ A ) @ S2 ) ) ) ) ).

% SUP_Sup_eq
thf(fact_1289_Sup__set__def,axiom,
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( set @ A ) )
      = ( ^ [A6: set @ ( set @ A )] :
            ( collect @ A
            @ ^ [X2: A] : ( complete_Sup_Sup @ $o @ ( image2 @ ( set @ A ) @ $o @ ( member @ A @ X2 ) @ A6 ) ) ) ) ) ).

% Sup_set_def
thf(fact_1290_Sup__SUP__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Sup_Sup @ ( A > B > $o ) )
      = ( ^ [S7: set @ ( A > B > $o ),X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image2 @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S7 ) ) ) ) ) ) ).

% Sup_SUP_eq2
thf(fact_1291_SUP__UN__eq,axiom,
    ! [B: $tType,A: $tType,R5: B > ( set @ A ),S2: set @ B] :
      ( ( complete_Sup_Sup @ ( A > $o )
        @ ( image2 @ B @ ( A > $o )
          @ ^ [I2: B,X2: A] : ( member @ A @ X2 @ ( R5 @ I2 ) )
          @ S2 ) )
      = ( ^ [X2: A] : ( member @ A @ X2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ R5 @ S2 ) ) ) ) ) ).

% SUP_UN_eq
thf(fact_1292_case__prod__comp,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F2: D > C > A,G: B > D,X3: product_prod @ B @ C] :
      ( ( product_case_prod @ B @ C @ A @ ( comp @ D @ ( C > A ) @ B @ F2 @ G ) @ X3 )
      = ( F2 @ ( G @ ( product_fst @ B @ C @ X3 ) ) @ ( product_snd @ B @ C @ X3 ) ) ) ).

% case_prod_comp
thf(fact_1293_fst__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% fst_diag_fst
thf(fact_1294_snd__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X2: B] : ( product_Pair @ B @ B @ X2 @ X2 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% snd_diag_snd
thf(fact_1295_snd__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% snd_diag_fst
thf(fact_1296_fst__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_fst @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X2: B] : ( product_Pair @ B @ B @ X2 @ X2 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% fst_diag_snd
thf(fact_1297_conj__subset__def,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A3
        @ ( collect @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
              & ( Q @ X2 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ P ) )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ Q ) ) ) ) ).

% conj_subset_def
thf(fact_1298_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,Z2: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ X5 )
               => ( ord_less_eq @ A @ X @ Z2 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X5 ) @ Z2 ) ) ) ) ).

% cSup_least
thf(fact_1299_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A4: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ X5 )
               => ( ord_less_eq @ A @ X @ A4 ) )
           => ( ! [Y3: A] :
                  ( ! [X4: A] :
                      ( ( member @ A @ X4 @ X5 )
                     => ( ord_less_eq @ A @ X4 @ Y3 ) )
                 => ( ord_less_eq @ A @ A4 @ Y3 ) )
             => ( ( complete_Sup_Sup @ A @ X5 )
                = A4 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_1300_UN__UN__split__split__eq,axiom,
    ! [A: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A3: B > C > D > E > ( set @ A ),Y4: set @ ( product_prod @ D @ E ),X5: set @ ( product_prod @ B @ C )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ ( product_prod @ B @ C ) @ ( set @ A )
          @ ( product_case_prod @ B @ C @ ( set @ A )
            @ ^ [X1: B,X22: C] : ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( product_prod @ D @ E ) @ ( set @ A ) @ ( product_case_prod @ D @ E @ ( set @ A ) @ ( A3 @ X1 @ X22 ) ) @ Y4 ) ) )
          @ X5 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ ( product_prod @ B @ C ) @ ( set @ A )
          @ ^ [X2: product_prod @ B @ C] :
              ( complete_Sup_Sup @ ( set @ A )
              @ ( image2 @ ( product_prod @ D @ E ) @ ( set @ A )
                @ ^ [Y2: product_prod @ D @ E] :
                    ( product_case_prod @ B @ C @ ( set @ A )
                    @ ^ [X1: B,X22: C] : ( product_case_prod @ D @ E @ ( set @ A ) @ ( A3 @ X1 @ X22 ) @ Y2 )
                    @ X2 )
                @ Y4 ) )
          @ X5 ) ) ) ).

% UN_UN_split_split_eq
thf(fact_1301_subset__mset_OcSUP__const,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,C2: multiset @ A] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( complete_Sup_Sup @ ( multiset @ A )
          @ ( image2 @ B @ ( multiset @ A )
            @ ^ [X2: B] : C2
            @ A3 ) )
        = C2 ) ) ).

% subset_mset.cSUP_const
thf(fact_1302_typedef__rep__transfer,axiom,
    ! [A: $tType,B: $tType,Rep: B > A,Abs: A > B,A3: set @ A,T2: A > B > $o] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A3 )
     => ( ( T2
          = ( ^ [X2: A,Y2: B] :
                ( X2
                = ( Rep @ Y2 ) ) ) )
       => ( bNF_rel_fun @ A @ B @ A @ A @ T2
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
          @ ^ [X2: A] : X2
          @ Rep ) ) ) ).

% typedef_rep_transfer
thf(fact_1303_UN__constant__eq,axiom,
    ! [A: $tType,B: $tType,A4: A,A3: set @ A,F2: A > ( set @ B ),C2: set @ B] :
      ( ( member @ A @ A4 @ A3 )
     => ( ! [X: A] :
            ( ( member @ A @ X @ A3 )
           => ( ( F2 @ X )
              = C2 ) )
       => ( ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ F2 @ A3 ) )
          = C2 ) ) ) ).

% UN_constant_eq
thf(fact_1304_UNION__fun__upd,axiom,
    ! [B: $tType,A: $tType,A3: B > ( set @ A ),I3: B,B2: set @ A,J: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ ( fun_upd @ B @ ( set @ A ) @ A3 @ I3 @ B2 ) @ J ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ B ) @ J @ ( insert @ B @ I3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) @ ( if @ ( set @ A ) @ ( member @ B @ I3 @ J ) @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% UNION_fun_upd
thf(fact_1305_linear__order__on__singleton,axiom,
    ! [A: $tType,X3: A] : ( order_679001287576687338der_on @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% linear_order_on_singleton
thf(fact_1306_Total__subset__Id,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( total_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ ( id2 @ A ) )
       => ( ( R5
            = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
          | ? [A7: A] :
              ( R5
              = ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A7 @ A7 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ) ) ).

% Total_subset_Id
thf(fact_1307_INT__simps_I4_J,axiom,
    ! [G3: $tType,H8: $tType,C3: set @ H8,A3: set @ G3,B2: H8 > ( set @ G3 )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ H8 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G3 )
            @ ( image2 @ H8 @ ( set @ G3 )
              @ ^ [X2: H8] : ( minus_minus @ ( set @ G3 ) @ A3 @ ( B2 @ X2 ) )
              @ C3 ) )
          = ( top_top @ ( set @ G3 ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ H8 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G3 )
            @ ( image2 @ H8 @ ( set @ G3 )
              @ ^ [X2: H8] : ( minus_minus @ ( set @ G3 ) @ A3 @ ( B2 @ X2 ) )
              @ C3 ) )
          = ( minus_minus @ ( set @ G3 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G3 ) @ ( image2 @ H8 @ ( set @ G3 ) @ B2 @ C3 ) ) ) ) ) ) ).

% INT_simps(4)
thf(fact_1308_subset__mset_OcSup__singleton,axiom,
    ! [A: $tType,X3: multiset @ A] :
      ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
      = X3 ) ).

% subset_mset.cSup_singleton
thf(fact_1309_Inf__top__conv_I1_J,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A3 )
            = ( top_top @ A ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A3 )
               => ( X2
                  = ( top_top @ A ) ) ) ) ) ) ).

% Inf_top_conv(1)
thf(fact_1310_Inf__top__conv_I2_J,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( ( top_top @ A )
            = ( complete_Inf_Inf @ A @ A3 ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A3 )
               => ( X2
                  = ( top_top @ A ) ) ) ) ) ) ).

% Inf_top_conv(2)
thf(fact_1311_INF__identity__eq,axiom,
    ! [A: $tType] :
      ( ( complete_Inf @ A )
     => ! [A3: set @ A] :
          ( ( complete_Inf_Inf @ A
            @ ( image2 @ A @ A
              @ ^ [X2: A] : X2
              @ A3 ) )
          = ( complete_Inf_Inf @ A @ A3 ) ) ) ).

% INF_identity_eq
thf(fact_1312_INT__I,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: B,B2: A > ( set @ B )] :
      ( ! [X: A] :
          ( ( member @ A @ X @ A3 )
         => ( member @ B @ B3 @ ( B2 @ X ) ) )
     => ( member @ B @ B3 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ B2 @ A3 ) ) ) ) ).

% INT_I
thf(fact_1313_INT__iff,axiom,
    ! [A: $tType,B: $tType,B3: A,B2: B > ( set @ A ),A3: set @ B] :
      ( ( member @ A @ B3 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ A3 )
           => ( member @ A @ B3 @ ( B2 @ X2 ) ) ) ) ) ).

% INT_iff
thf(fact_1314_Inf__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Inf @ B )
     => ( ( complete_Inf_Inf @ ( A > B ) )
        = ( ^ [A6: set @ ( A > B ),X2: A] :
              ( complete_Inf_Inf @ B
              @ ( image2 @ ( A > B ) @ B
                @ ^ [F3: A > B] : ( F3 @ X2 )
                @ A6 ) ) ) ) ) ).

% Inf_apply
thf(fact_1315_Inf__empty,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( top_top @ A ) ) ) ).

% Inf_empty
thf(fact_1316_SUP2__I,axiom,
    ! [B: $tType,A: $tType,C: $tType,A4: A,A3: set @ A,B2: A > B > C > $o,B3: B,C2: C] :
      ( ( member @ A @ A4 @ A3 )
     => ( ( B2 @ A4 @ B3 @ C2 )
       => ( complete_Sup_Sup @ ( B > C > $o ) @ ( image2 @ A @ ( B > C > $o ) @ B2 @ A3 ) @ B3 @ C2 ) ) ) ).

% SUP2_I
thf(fact_1317_Inf__UNIV,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A @ ( top_top @ ( set @ A ) ) )
        = ( bot_bot @ A ) ) ) ).

% Inf_UNIV
thf(fact_1318_cInf__singleton,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X3: A] :
          ( ( complete_Inf_Inf @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
          = X3 ) ) ).

% cInf_singleton
thf(fact_1319_Inf__insert,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: A,A3: set @ A] :
          ( ( complete_Inf_Inf @ A @ ( insert @ A @ A4 @ A3 ) )
          = ( inf_inf @ A @ A4 @ ( complete_Inf_Inf @ A @ A3 ) ) ) ) ).

% Inf_insert
thf(fact_1320_SUP1__I,axiom,
    ! [A: $tType,B: $tType,A4: A,A3: set @ A,B2: A > B > $o,B3: B] :
      ( ( member @ A @ A4 @ A3 )
     => ( ( B2 @ A4 @ B3 )
       => ( complete_Sup_Sup @ ( B > $o ) @ ( image2 @ A @ ( B > $o ) @ B2 @ A3 ) @ B3 ) ) ) ).

% SUP1_I
thf(fact_1321_rtrancl__empty,axiom,
    ! [A: $tType] :
      ( ( transitive_rtrancl @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
      = ( id2 @ A ) ) ).

% rtrancl_empty
thf(fact_1322_INF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image2 @ B @ A
                @ ^ [I2: B] : F2
                @ A3 ) )
            = F2 ) ) ) ).

% INF_const
thf(fact_1323_cINF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image2 @ B @ A
                @ ^ [X2: B] : C2
                @ A3 ) )
            = C2 ) ) ) ).

% cINF_const
thf(fact_1324_INF__top__conv_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: B > A,A3: set @ B] :
          ( ( ( top_top @ A )
            = ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ B2 @ A3 ) ) )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( ( B2 @ X2 )
                  = ( top_top @ A ) ) ) ) ) ) ).

% INF_top_conv(2)
thf(fact_1325_INF__top__conv_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: B > A,A3: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ B2 @ A3 ) )
            = ( top_top @ A ) )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( ( B2 @ X2 )
                  = ( top_top @ A ) ) ) ) ) ) ).

% INF_top_conv(1)
thf(fact_1326_INF__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B] :
          ( ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [X2: B] : ( top_top @ A )
              @ A3 ) )
          = ( top_top @ A ) ) ) ).

% INF_top
thf(fact_1327_INF__apply,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( complete_Inf @ A )
     => ! [F2: C > B > A,A3: set @ C,X3: B] :
          ( ( complete_Inf_Inf @ ( B > A ) @ ( image2 @ C @ ( B > A ) @ F2 @ A3 ) @ X3 )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ C @ A
              @ ^ [Y2: C] : ( F2 @ Y2 @ X3 )
              @ A3 ) ) ) ) ).

% INF_apply
thf(fact_1328_INT__constant,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,C2: set @ A] :
      ( ( ( A3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Inf_Inf @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : C2
              @ A3 ) )
          = ( top_top @ ( set @ A ) ) ) )
      & ( ( A3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Inf_Inf @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : C2
              @ A3 ) )
          = C2 ) ) ) ).

% INT_constant
thf(fact_1329_INT__insert,axiom,
    ! [A: $tType,B: $tType,B2: B > ( set @ A ),A4: B,A3: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ ( insert @ B @ A4 @ A3 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( B2 @ A4 ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) ) ) ).

% INT_insert
thf(fact_1330_Compl__UN,axiom,
    ! [A: $tType,B: $tType,B2: B > ( set @ A ),A3: set @ B] :
      ( ( uminus_uminus @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) )
      = ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X2: B] : ( uminus_uminus @ ( set @ A ) @ ( B2 @ X2 ) )
          @ A3 ) ) ) ).

% Compl_UN
thf(fact_1331_Compl__INT,axiom,
    ! [A: $tType,B: $tType,B2: B > ( set @ A ),A3: set @ B] :
      ( ( uminus_uminus @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X2: B] : ( uminus_uminus @ ( set @ A ) @ ( B2 @ X2 ) )
          @ A3 ) ) ) ).

% Compl_INT
thf(fact_1332_INT__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set @ A,A3: A > ( set @ B ),B2: set @ B] :
      ( ( ( C3
          = ( bot_bot @ ( set @ A ) ) )
       => ( ( complete_Inf_Inf @ ( set @ B )
            @ ( image2 @ A @ ( set @ B )
              @ ^ [X2: A] : ( inf_inf @ ( set @ B ) @ ( A3 @ X2 ) @ B2 )
              @ C3 ) )
          = ( top_top @ ( set @ B ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ A ) ) )
       => ( ( complete_Inf_Inf @ ( set @ B )
            @ ( image2 @ A @ ( set @ B )
              @ ^ [X2: A] : ( inf_inf @ ( set @ B ) @ ( A3 @ X2 ) @ B2 )
              @ C3 ) )
          = ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ C3 ) ) @ B2 ) ) ) ) ).

% INT_simps(1)
thf(fact_1333_INT__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set @ D,A3: set @ C,B2: D > ( set @ C )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ D ) ) )
       => ( ( complete_Inf_Inf @ ( set @ C )
            @ ( image2 @ D @ ( set @ C )
              @ ^ [X2: D] : ( inf_inf @ ( set @ C ) @ A3 @ ( B2 @ X2 ) )
              @ C3 ) )
          = ( top_top @ ( set @ C ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ D ) ) )
       => ( ( complete_Inf_Inf @ ( set @ C )
            @ ( image2 @ D @ ( set @ C )
              @ ^ [X2: D] : ( inf_inf @ ( set @ C ) @ A3 @ ( B2 @ X2 ) )
              @ C3 ) )
          = ( inf_inf @ ( set @ C ) @ A3 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image2 @ D @ ( set @ C ) @ B2 @ C3 ) ) ) ) ) ) ).

% INT_simps(2)
thf(fact_1334_INT__simps_I3_J,axiom,
    ! [E: $tType,F10: $tType,C3: set @ E,A3: E > ( set @ F10 ),B2: set @ F10] :
      ( ( ( C3
          = ( bot_bot @ ( set @ E ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F10 )
            @ ( image2 @ E @ ( set @ F10 )
              @ ^ [X2: E] : ( minus_minus @ ( set @ F10 ) @ ( A3 @ X2 ) @ B2 )
              @ C3 ) )
          = ( top_top @ ( set @ F10 ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ E ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F10 )
            @ ( image2 @ E @ ( set @ F10 )
              @ ^ [X2: E] : ( minus_minus @ ( set @ F10 ) @ ( A3 @ X2 ) @ B2 )
              @ C3 ) )
          = ( minus_minus @ ( set @ F10 ) @ ( complete_Inf_Inf @ ( set @ F10 ) @ ( image2 @ E @ ( set @ F10 ) @ A3 @ C3 ) ) @ B2 ) ) ) ) ).

% INT_simps(3)
thf(fact_1335_Sup__multiset__empty,axiom,
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
      = ( zero_zero @ ( multiset @ A ) ) ) ).

% Sup_multiset_empty
thf(fact_1336_SUP2__E,axiom,
    ! [A: $tType,C: $tType,B: $tType,B2: C > A > B > $o,A3: set @ C,B3: A,C2: B] :
      ( ( complete_Sup_Sup @ ( A > B > $o ) @ ( image2 @ C @ ( A > B > $o ) @ B2 @ A3 ) @ B3 @ C2 )
     => ~ ! [X: C] :
            ( ( member @ C @ X @ A3 )
           => ~ ( B2 @ X @ B3 @ C2 ) ) ) ).

% SUP2_E
thf(fact_1337_SUP1__E,axiom,
    ! [B: $tType,A: $tType,B2: B > A > $o,A3: set @ B,B3: A] :
      ( ( complete_Sup_Sup @ ( A > $o ) @ ( image2 @ B @ ( A > $o ) @ B2 @ A3 ) @ B3 )
     => ~ ! [X: B] :
            ( ( member @ B @ X @ A3 )
           => ~ ( B2 @ X @ B3 ) ) ) ).

% SUP1_E
thf(fact_1338_Inf__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Inf @ B )
     => ( ( complete_Inf_Inf @ ( A > B ) )
        = ( ^ [A6: set @ ( A > B ),X2: A] :
              ( complete_Inf_Inf @ B
              @ ( image2 @ ( A > B ) @ B
                @ ^ [F3: A > B] : ( F3 @ X2 )
                @ A6 ) ) ) ) ) ).

% Inf_fun_def
thf(fact_1339_Inter__UNIV,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( top_top @ ( set @ ( set @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Inter_UNIV
thf(fact_1340_Inter__Un__distrib,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B2: set @ ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ A3 @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B2 ) ) ) ).

% Inter_Un_distrib
thf(fact_1341_INF__commute,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > C > A,B2: set @ C,A3: set @ B] :
          ( ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [I2: B] : ( complete_Inf_Inf @ A @ ( image2 @ C @ A @ ( F2 @ I2 ) @ B2 ) )
              @ A3 ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ C @ A
              @ ^ [J3: C] :
                  ( complete_Inf_Inf @ A
                  @ ( image2 @ B @ A
                    @ ^ [I2: B] : ( F2 @ I2 @ J3 )
                    @ A3 ) )
              @ B2 ) ) ) ) ).

% INF_commute
thf(fact_1342_INT__D,axiom,
    ! [A: $tType,B: $tType,B3: A,B2: B > ( set @ A ),A3: set @ B,A4: B] :
      ( ( member @ A @ B3 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) )
     => ( ( member @ B @ A4 @ A3 )
       => ( member @ A @ B3 @ ( B2 @ A4 ) ) ) ) ).

% INT_D
thf(fact_1343_INT__E,axiom,
    ! [A: $tType,B: $tType,B3: A,B2: B > ( set @ A ),A3: set @ B,A4: B] :
      ( ( member @ A @ B3 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) )
     => ( ~ ( member @ A @ B3 @ ( B2 @ A4 ) )
       => ~ ( member @ B @ A4 @ A3 ) ) ) ).

% INT_E
thf(fact_1344_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U2: A] :
          ( ! [V3: A] :
              ( ( member @ A @ V3 @ A3 )
             => ( ord_less_eq @ A @ V3 @ U2 ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ U2 ) ) ) ) ).

% Inf_less_eq
thf(fact_1345_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A4: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ X5 )
               => ( ord_less_eq @ A @ A4 @ X ) )
           => ( ! [Y3: A] :
                  ( ! [X4: A] :
                      ( ( member @ A @ X4 @ X5 )
                     => ( ord_less_eq @ A @ Y3 @ X4 ) )
                 => ( ord_less_eq @ A @ Y3 @ A4 ) )
             => ( ( complete_Inf_Inf @ A @ X5 )
                = A4 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_1346_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,Z2: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ X5 )
               => ( ord_less_eq @ A @ Z2 @ X ) )
           => ( ord_less_eq @ A @ Z2 @ ( complete_Inf_Inf @ A @ X5 ) ) ) ) ) ).

% cInf_greatest
thf(fact_1347_INF__eq__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: set @ B,F2: B > A,X3: A] :
          ( ( I
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ I )
               => ( ( F2 @ I4 )
                  = X3 ) )
           => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ I ) )
              = X3 ) ) ) ) ).

% INF_eq_const
thf(fact_1348_bot__finite__def,axiom,
    ! [A: $tType] :
      ( ( finite_lattice @ A )
     => ( ( bot_bot @ A )
        = ( complete_Inf_Inf @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% bot_finite_def
thf(fact_1349_Inf__sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B2: set @ A,A4: A] :
          ( ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ B2 ) @ A4 )
            = ( top_top @ A ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ B2 )
               => ( ( sup_sup @ A @ X2 @ A4 )
                  = ( top_top @ A ) ) ) ) ) ) ).

% Inf_sup_eq_top_iff
thf(fact_1350_Inf__finite__insert,axiom,
    ! [A: $tType] :
      ( ( finite_lattice @ A )
     => ! [A4: A,A3: set @ A] :
          ( ( complete_Inf_Inf @ A @ ( insert @ A @ A4 @ A3 ) )
          = ( inf_inf @ A @ A4 @ ( complete_Inf_Inf @ A @ A3 ) ) ) ) ).

% Inf_finite_insert
thf(fact_1351_Inf__union__distrib,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( complete_Inf_Inf @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
          = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B2 ) ) ) ) ).

% Inf_union_distrib
thf(fact_1352_Inter__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B2: set @ A] :
      ( ! [X8: set @ A] :
          ( ( member @ ( set @ A ) @ X8 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ X8 @ B2 ) )
     => ( ( A3
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ B2 ) ) ) ).

% Inter_subset
thf(fact_1353_Inter__empty,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) )
      = ( top_top @ ( set @ A ) ) ) ).

% Inter_empty
thf(fact_1354_inj__on__Inter,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( set @ A ),F2: A > B] :
      ( ( S2
       != ( bot_bot @ ( set @ ( set @ A ) ) ) )
     => ( ! [A12: set @ A] :
            ( ( member @ ( set @ A ) @ A12 @ S2 )
           => ( inj_on @ A @ B @ F2 @ A12 ) )
       => ( inj_on @ A @ B @ F2 @ ( complete_Inf_Inf @ ( set @ A ) @ S2 ) ) ) ) ).

% inj_on_Inter
thf(fact_1355_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,X3: A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ X3 @ ( F2 @ I4 ) ) )
         => ( ! [Y3: A] :
                ( ! [I5: B] :
                    ( ( member @ B @ I5 @ A3 )
                   => ( ord_less_eq @ A @ Y3 @ ( F2 @ I5 ) ) )
               => ( ord_less_eq @ A @ Y3 @ X3 ) )
           => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
              = X3 ) ) ) ) ).

% INF_eqI
thf(fact_1356_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: set @ B,A3: set @ C,F2: C > A,G: B > A] :
          ( ! [M3: B] :
              ( ( member @ B @ M3 @ B2 )
             => ? [X4: C] :
                  ( ( member @ C @ X4 @ A3 )
                  & ( ord_less_eq @ A @ ( F2 @ X4 ) @ ( G @ M3 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ C @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ B2 ) ) ) ) ) ).

% INF_mono
thf(fact_1357_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,F2: B > A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( F2 @ I3 ) ) ) ) ).

% INF_lower
thf(fact_1358_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ! [X: B] : ( ord_less_eq @ A @ ( F2 @ X ) @ ( G @ X ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ A3 ) ) ) ) ) ).

% INF_mono'
thf(fact_1359_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,F2: B > A,U2: A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ( ord_less_eq @ A @ ( F2 @ I3 ) @ U2 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ U2 ) ) ) ) ).

% INF_lower2
thf(fact_1360_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U2: A,F2: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ U2 @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( ord_less_eq @ A @ U2 @ ( F2 @ X2 ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_1361_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,U2: A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ U2 @ ( F2 @ I4 ) ) )
         => ( ord_less_eq @ A @ U2 @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% INF_greatest
thf(fact_1362_INF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,G: B > A] :
          ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ A3 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [A5: B] : ( inf_inf @ A @ ( F2 @ A5 ) @ ( G @ A5 ) )
              @ A3 ) ) ) ) ).

% INF_inf_distrib
thf(fact_1363_INF__absorb,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [K: B,I: set @ B,A3: B > A] :
          ( ( member @ B @ K @ I )
         => ( ( inf_inf @ A @ ( A3 @ K ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ A3 @ I ) ) )
            = ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ A3 @ I ) ) ) ) ) ).

% INF_absorb
thf(fact_1364_INF__sup__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F2: B > A,A3: set @ B,G: C > A,B2: set @ C] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ C @ A @ G @ B2 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [A5: B] :
                  ( complete_Inf_Inf @ A
                  @ ( image2 @ C @ A
                    @ ^ [B4: C] : ( sup_sup @ A @ ( F2 @ A5 ) @ ( G @ B4 ) )
                    @ B2 ) )
              @ A3 ) ) ) ) ).

% INF_sup_distrib2
thf(fact_1365_sup__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A4: A,F2: B > A,B2: set @ B] :
          ( ( sup_sup @ A @ A4 @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ B2 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [B4: B] : ( sup_sup @ A @ A4 @ ( F2 @ B4 ) )
              @ B2 ) ) ) ) ).

% sup_INF
thf(fact_1366_Inf__sup,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B2: set @ A,A4: A] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ B2 ) @ A4 )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ A @ A
              @ ^ [B4: A] : ( sup_sup @ A @ B4 @ A4 )
              @ B2 ) ) ) ) ).

% Inf_sup
thf(fact_1367_INF__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F2: B > A,B2: set @ B,A4: A] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ B2 ) ) @ A4 )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [B4: B] : ( sup_sup @ A @ ( F2 @ B4 ) @ A4 )
              @ B2 ) ) ) ) ).

% INF_sup
thf(fact_1368_Inter__insert,axiom,
    ! [A: $tType,A4: set @ A,B2: set @ ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( insert @ ( set @ A ) @ A4 @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ ( complete_Inf_Inf @ ( set @ A ) @ B2 ) ) ) ).

% Inter_insert
thf(fact_1369_INT__extend__simps_I10_J,axiom,
    ! [V4: $tType,U4: $tType,T: $tType,B2: U4 > ( set @ V4 ),F2: T > U4,A3: set @ T] :
      ( ( complete_Inf_Inf @ ( set @ V4 )
        @ ( image2 @ T @ ( set @ V4 )
          @ ^ [A5: T] : ( B2 @ ( F2 @ A5 ) )
          @ A3 ) )
      = ( complete_Inf_Inf @ ( set @ V4 ) @ ( image2 @ U4 @ ( set @ V4 ) @ B2 @ ( image2 @ T @ U4 @ F2 @ A3 ) ) ) ) ).

% INT_extend_simps(10)
thf(fact_1370_INT__lower,axiom,
    ! [B: $tType,A: $tType,A4: A,A3: set @ A,B2: A > ( set @ B )] :
      ( ( member @ A @ A4 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ B2 @ A3 ) ) @ ( B2 @ A4 ) ) ) ).

% INT_lower
thf(fact_1371_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,C3: set @ B,B2: A > ( set @ B )] :
      ( ! [X: A] :
          ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ C3 @ ( B2 @ X ) ) )
     => ( ord_less_eq @ ( set @ B ) @ C3 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ B2 @ A3 ) ) ) ) ).

% INT_greatest
thf(fact_1372_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ! [X: A] :
            ( ( member @ A @ X @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X ) @ ( G @ X ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ F2 @ B2 ) ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ G @ A3 ) ) ) ) ) ).

% INT_anti_mono
thf(fact_1373_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B2: set @ A,A3: B > ( set @ A ),I: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ I )
           => ( ord_less_eq @ ( set @ A ) @ B2 @ ( A3 @ X2 ) ) ) ) ) ).

% INT_subset_iff
thf(fact_1374_INT__extend__simps_I5_J,axiom,
    ! [I6: $tType,J4: $tType,A4: I6,B2: J4 > ( set @ I6 ),C3: set @ J4] :
      ( ( insert @ I6 @ A4 @ ( complete_Inf_Inf @ ( set @ I6 ) @ ( image2 @ J4 @ ( set @ I6 ) @ B2 @ C3 ) ) )
      = ( complete_Inf_Inf @ ( set @ I6 )
        @ ( image2 @ J4 @ ( set @ I6 )
          @ ^ [X2: J4] : ( insert @ I6 @ A4 @ ( B2 @ X2 ) )
          @ C3 ) ) ) ).

% INT_extend_simps(5)
thf(fact_1375_INT__insert__distrib,axiom,
    ! [B: $tType,A: $tType,U2: A,A3: set @ A,A4: B,B2: A > ( set @ B )] :
      ( ( member @ A @ U2 @ A3 )
     => ( ( complete_Inf_Inf @ ( set @ B )
          @ ( image2 @ A @ ( set @ B )
            @ ^ [X2: A] : ( insert @ B @ A4 @ ( B2 @ X2 ) )
            @ A3 ) )
        = ( insert @ B @ A4 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ B2 @ A3 ) ) ) ) ) ).

% INT_insert_distrib
thf(fact_1376_INTER__UNIV__conv_I1_J,axiom,
    ! [A: $tType,B: $tType,B2: B > ( set @ A ),A3: set @ B] :
      ( ( ( top_top @ ( set @ A ) )
        = ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ A3 )
           => ( ( B2 @ X2 )
              = ( top_top @ ( set @ A ) ) ) ) ) ) ).

% INTER_UNIV_conv(1)
thf(fact_1377_INTER__UNIV__conv_I2_J,axiom,
    ! [A: $tType,B: $tType,B2: B > ( set @ A ),A3: set @ B] :
      ( ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ A3 )
           => ( ( B2 @ X2 )
              = ( top_top @ ( set @ A ) ) ) ) ) ) ).

% INTER_UNIV_conv(2)
thf(fact_1378_Int__Inter__image,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),B2: B > ( set @ A ),C3: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X2: B] : ( inf_inf @ ( set @ A ) @ ( A3 @ X2 ) @ ( B2 @ X2 ) )
          @ C3 ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ C3 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ C3 ) ) ) ) ).

% Int_Inter_image
thf(fact_1379_INT__Int__distrib,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),B2: B > ( set @ A ),I: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I2: B] : ( inf_inf @ ( set @ A ) @ ( A3 @ I2 ) @ ( B2 @ I2 ) )
          @ I ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ I ) ) ) ) ).

% INT_Int_distrib
thf(fact_1380_INT__absorb,axiom,
    ! [B: $tType,A: $tType,K: A,I: set @ A,A3: A > ( set @ B )] :
      ( ( member @ A @ K @ I )
     => ( ( inf_inf @ ( set @ B ) @ ( A3 @ K ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ I ) ) )
        = ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ I ) ) ) ) ).

% INT_absorb
thf(fact_1381_Un__INT__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType,A3: B > ( set @ A ),I: set @ B,B2: C > ( set @ A ),J: set @ C] :
      ( ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ C @ ( set @ A ) @ B2 @ J ) ) )
      = ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I2: B] :
              ( complete_Inf_Inf @ ( set @ A )
              @ ( image2 @ C @ ( set @ A )
                @ ^ [J3: C] : ( sup_sup @ ( set @ A ) @ ( A3 @ I2 ) @ ( B2 @ J3 ) )
                @ J ) )
          @ I ) ) ) ).

% Un_INT_distrib2
thf(fact_1382_Un__INT__distrib,axiom,
    ! [A: $tType,B: $tType,B2: set @ A,A3: B > ( set @ A ),I: set @ B] :
      ( ( sup_sup @ ( set @ A ) @ B2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) )
      = ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I2: B] : ( sup_sup @ ( set @ A ) @ B2 @ ( A3 @ I2 ) )
          @ I ) ) ) ).

% Un_INT_distrib
thf(fact_1383_INT__extend__simps_I6_J,axiom,
    ! [L3: $tType,K4: $tType,A3: K4 > ( set @ L3 ),C3: set @ K4,B2: set @ L3] :
      ( ( sup_sup @ ( set @ L3 ) @ ( complete_Inf_Inf @ ( set @ L3 ) @ ( image2 @ K4 @ ( set @ L3 ) @ A3 @ C3 ) ) @ B2 )
      = ( complete_Inf_Inf @ ( set @ L3 )
        @ ( image2 @ K4 @ ( set @ L3 )
          @ ^ [X2: K4] : ( sup_sup @ ( set @ L3 ) @ ( A3 @ X2 ) @ B2 )
          @ C3 ) ) ) ).

% INT_extend_simps(6)
thf(fact_1384_INT__extend__simps_I7_J,axiom,
    ! [M4: $tType,N3: $tType,A3: set @ M4,B2: N3 > ( set @ M4 ),C3: set @ N3] :
      ( ( sup_sup @ ( set @ M4 ) @ A3 @ ( complete_Inf_Inf @ ( set @ M4 ) @ ( image2 @ N3 @ ( set @ M4 ) @ B2 @ C3 ) ) )
      = ( complete_Inf_Inf @ ( set @ M4 )
        @ ( image2 @ N3 @ ( set @ M4 )
          @ ^ [X2: N3] : ( sup_sup @ ( set @ M4 ) @ A3 @ ( B2 @ X2 ) )
          @ C3 ) ) ) ).

% INT_extend_simps(7)
thf(fact_1385_INT__extend__simps_I9_J,axiom,
    ! [S6: $tType,R6: $tType,Q7: $tType,C3: R6 > ( set @ S6 ),B2: Q7 > ( set @ R6 ),A3: set @ Q7] :
      ( ( complete_Inf_Inf @ ( set @ S6 )
        @ ( image2 @ Q7 @ ( set @ S6 )
          @ ^ [X2: Q7] : ( complete_Inf_Inf @ ( set @ S6 ) @ ( image2 @ R6 @ ( set @ S6 ) @ C3 @ ( B2 @ X2 ) ) )
          @ A3 ) )
      = ( complete_Inf_Inf @ ( set @ S6 ) @ ( image2 @ R6 @ ( set @ S6 ) @ C3 @ ( complete_Sup_Sup @ ( set @ R6 ) @ ( image2 @ Q7 @ ( set @ R6 ) @ B2 @ A3 ) ) ) ) ) ).

% INT_extend_simps(9)
thf(fact_1386_vimage__INT,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > B,B2: C > ( set @ B ),A3: set @ C] :
      ( ( vimage @ A @ B @ F2 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ C @ ( set @ B ) @ B2 @ A3 ) ) )
      = ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ C @ ( set @ A )
          @ ^ [X2: C] : ( vimage @ A @ B @ F2 @ ( B2 @ X2 ) )
          @ A3 ) ) ) ).

% vimage_INT
thf(fact_1387_Id__def,axiom,
    ! [A: $tType] :
      ( ( id2 @ A )
      = ( collect @ ( product_prod @ A @ A )
        @ ^ [P6: product_prod @ A @ A] :
          ? [X2: A] :
            ( P6
            = ( product_Pair @ A @ A @ X2 @ X2 ) ) ) ) ).

% Id_def
thf(fact_1388_Un__Inter,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( complete_Inf_Inf @ ( set @ A ) @ B2 ) )
      = ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 ) @ B2 ) ) ) ).

% Un_Inter
thf(fact_1389_Id__fstsnd__eq,axiom,
    ! [A: $tType] :
      ( ( id2 @ A )
      = ( collect @ ( product_prod @ A @ A )
        @ ^ [X2: product_prod @ A @ A] :
            ( ( product_fst @ A @ A @ X2 )
            = ( product_snd @ A @ A @ X2 ) ) ) ) ).

% Id_fstsnd_eq
thf(fact_1390_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: set @ B,F2: B > A,C2: A] :
          ( ( I
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ I )
               => ( ord_less_eq @ A @ ( F2 @ I4 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ I ) )
                = C2 )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ I )
                   => ( ( F2 @ X2 )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_1391_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,M2: A,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X: B] :
                ( ( member @ B @ X @ A3 )
               => ( ord_less_eq @ A @ M2 @ ( F2 @ X ) ) )
           => ( ord_less_eq @ A @ M2 @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_1392_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ).

% Inf_le_Sup
thf(fact_1393_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B2: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B2 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_1394_Inf__finite__empty,axiom,
    ! [A: $tType] :
      ( ( finite_lattice @ A )
     => ( ( complete_Inf_Inf @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( complete_Sup_Sup @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% Inf_finite_empty
thf(fact_1395_Sup__finite__empty,axiom,
    ! [A: $tType] :
      ( ( finite_lattice @ A )
     => ( ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( complete_Inf_Inf @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% Sup_finite_empty
thf(fact_1396_lnear__order__on__empty,axiom,
    ! [A: $tType] : ( order_679001287576687338der_on @ A @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% lnear_order_on_empty
thf(fact_1397_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: set @ B,A3: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B2 @ A3 )
         => ( ! [X: B] :
                ( ( member @ B @ X @ B2 )
               => ( ord_less_eq @ A @ ( F2 @ X ) @ ( G @ X ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ B2 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_1398_INF__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( ( A3
              = ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Inf_Inf @ A
                @ ( image2 @ B @ A
                  @ ^ [Y2: B] : C2
                  @ A3 ) )
              = ( top_top @ A ) ) )
          & ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Inf_Inf @ A
                @ ( image2 @ B @ A
                  @ ^ [Y2: B] : C2
                  @ A3 ) )
              = C2 ) ) ) ) ).

% INF_constant
thf(fact_1399_INF__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ ( bot_bot @ ( set @ B ) ) ) )
          = ( top_top @ A ) ) ) ).

% INF_empty
thf(fact_1400_INF__inf__const1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: set @ B,X3: A,F2: B > A] :
          ( ( I
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image2 @ B @ A
                @ ^ [I2: B] : ( inf_inf @ A @ X3 @ ( F2 @ I2 ) )
                @ I ) )
            = ( inf_inf @ A @ X3 @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ I ) ) ) ) ) ) ).

% INF_inf_const1
thf(fact_1401_INF__inf__const2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: set @ B,F2: B > A,X3: A] :
          ( ( I
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image2 @ B @ A
                @ ^ [I2: B] : ( inf_inf @ A @ ( F2 @ I2 ) @ X3 )
                @ I ) )
            = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ I ) ) @ X3 ) ) ) ) ).

% INF_inf_const2
thf(fact_1402_uminus__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple489889107523837845lgebra @ A )
     => ! [B2: B > A,A3: set @ B] :
          ( ( uminus_uminus @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ B2 @ A3 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [X2: B] : ( uminus_uminus @ A @ ( B2 @ X2 ) )
              @ A3 ) ) ) ) ).

% uminus_SUP
thf(fact_1403_uminus__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple489889107523837845lgebra @ A )
     => ! [B2: B > A,A3: set @ B] :
          ( ( uminus_uminus @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ B2 @ A3 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [X2: B] : ( uminus_uminus @ A @ ( B2 @ X2 ) )
              @ A3 ) ) ) ) ).

% uminus_INF
thf(fact_1404_INF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A4: B,A3: set @ B] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ ( insert @ B @ A4 @ A3 ) ) )
          = ( inf_inf @ A @ ( F2 @ A4 ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% INF_insert
thf(fact_1405_INF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [M: B > A,A3: set @ B,B2: set @ B] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ M @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) ) )
          = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ M @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ M @ B2 ) ) ) ) ) ).

% INF_union
thf(fact_1406_INT__empty,axiom,
    ! [B: $tType,A: $tType,B2: B > ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ ( bot_bot @ ( set @ B ) ) ) )
      = ( top_top @ ( set @ A ) ) ) ).

% INT_empty
thf(fact_1407_INT__extend__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set @ D,A3: set @ C,B2: D > ( set @ C )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ D ) ) )
       => ( ( inf_inf @ ( set @ C ) @ A3 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image2 @ D @ ( set @ C ) @ B2 @ C3 ) ) )
          = A3 ) )
      & ( ( C3
         != ( bot_bot @ ( set @ D ) ) )
       => ( ( inf_inf @ ( set @ C ) @ A3 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image2 @ D @ ( set @ C ) @ B2 @ C3 ) ) )
          = ( complete_Inf_Inf @ ( set @ C )
            @ ( image2 @ D @ ( set @ C )
              @ ^ [X2: D] : ( inf_inf @ ( set @ C ) @ A3 @ ( B2 @ X2 ) )
              @ C3 ) ) ) ) ) ).

% INT_extend_simps(2)
thf(fact_1408_INT__extend__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,C3: set @ A,A3: A > ( set @ B ),B2: set @ B] :
      ( ( ( C3
          = ( bot_bot @ ( set @ A ) ) )
       => ( ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ C3 ) ) @ B2 )
          = B2 ) )
      & ( ( C3
         != ( bot_bot @ ( set @ A ) ) )
       => ( ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ C3 ) ) @ B2 )
          = ( complete_Inf_Inf @ ( set @ B )
            @ ( image2 @ A @ ( set @ B )
              @ ^ [X2: A] : ( inf_inf @ ( set @ B ) @ ( A3 @ X2 ) @ B2 )
              @ C3 ) ) ) ) ) ).

% INT_extend_simps(1)
thf(fact_1409_inj__on__INTER,axiom,
    ! [C: $tType,B: $tType,A: $tType,I: set @ A,F2: B > C,A3: A > ( set @ B )] :
      ( ( I
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I4: A] :
            ( ( member @ A @ I4 @ I )
           => ( inj_on @ B @ C @ F2 @ ( A3 @ I4 ) ) )
       => ( inj_on @ B @ C @ F2 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ I ) ) ) ) ) ).

% inj_on_INTER
thf(fact_1410_INT__Un,axiom,
    ! [A: $tType,B: $tType,M: B > ( set @ A ),A3: set @ B,B2: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ A3 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ B2 ) ) ) ) ).

% INT_Un
thf(fact_1411_UN__extend__simps_I7_J,axiom,
    ! [M4: $tType,N3: $tType,A3: set @ M4,B2: N3 > ( set @ M4 ),C3: set @ N3] :
      ( ( minus_minus @ ( set @ M4 ) @ A3 @ ( complete_Inf_Inf @ ( set @ M4 ) @ ( image2 @ N3 @ ( set @ M4 ) @ B2 @ C3 ) ) )
      = ( complete_Sup_Sup @ ( set @ M4 )
        @ ( image2 @ N3 @ ( set @ M4 )
          @ ^ [X2: N3] : ( minus_minus @ ( set @ M4 ) @ A3 @ ( B2 @ X2 ) )
          @ C3 ) ) ) ).

% UN_extend_simps(7)
thf(fact_1412_Inter__Un__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B2: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B2 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A3 @ B2 ) ) ) ).

% Inter_Un_subset
thf(fact_1413_INT__extend__simps_I8_J,axiom,
    ! [P8: $tType,O: $tType,B2: O > ( set @ P8 ),A3: set @ ( set @ O )] :
      ( ( complete_Inf_Inf @ ( set @ P8 )
        @ ( image2 @ ( set @ O ) @ ( set @ P8 )
          @ ^ [Y2: set @ O] : ( complete_Inf_Inf @ ( set @ P8 ) @ ( image2 @ O @ ( set @ P8 ) @ B2 @ Y2 ) )
          @ A3 ) )
      = ( complete_Inf_Inf @ ( set @ P8 ) @ ( image2 @ O @ ( set @ P8 ) @ B2 @ ( complete_Sup_Sup @ ( set @ O ) @ A3 ) ) ) ) ).

% INT_extend_simps(8)
thf(fact_1414_Int__Inter__eq_I2_J,axiom,
    ! [A: $tType,B8: set @ ( set @ A ),A3: set @ A] :
      ( ( ( B8
          = ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ B8 ) @ A3 )
          = A3 ) )
      & ( ( B8
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ B8 ) @ A3 )
          = ( complete_Inf_Inf @ ( set @ A )
            @ ( image2 @ ( set @ A ) @ ( set @ A )
              @ ^ [B5: set @ A] : ( inf_inf @ ( set @ A ) @ B5 @ A3 )
              @ B8 ) ) ) ) ) ).

% Int_Inter_eq(2)
thf(fact_1415_Int__Inter__eq_I1_J,axiom,
    ! [A: $tType,B8: set @ ( set @ A ),A3: set @ A] :
      ( ( ( B8
          = ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ A3 @ ( complete_Inf_Inf @ ( set @ A ) @ B8 ) )
          = A3 ) )
      & ( ( B8
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ A3 @ ( complete_Inf_Inf @ ( set @ A ) @ B8 ) )
          = ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 ) @ B8 ) ) ) ) ) ).

% Int_Inter_eq(1)
thf(fact_1416_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_1417_reflcl__set__eq,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( sup_sup @ ( A > A > $o )
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 )
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
      = ( ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ ( id2 @ A ) ) ) ) ) ).

% reflcl_set_eq
thf(fact_1418_INF__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: $o > A] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ $o @ A @ A3 @ ( top_top @ ( set @ $o ) ) ) )
          = ( inf_inf @ A @ ( A3 @ $true ) @ ( A3 @ $false ) ) ) ) ).

% INF_UNIV_bool_expand
thf(fact_1419_image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > B,C3: set @ A,A3: set @ C,B2: C > ( set @ A ),J2: C] :
      ( ( inj_on @ A @ B @ F2 @ C3 )
     => ( ! [X: C] :
            ( ( member @ C @ X @ A3 )
           => ( ord_less_eq @ ( set @ A ) @ ( B2 @ X ) @ C3 ) )
       => ( ( member @ C @ J2 @ A3 )
         => ( ( image2 @ A @ B @ F2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ C @ ( set @ A ) @ B2 @ A3 ) ) )
            = ( complete_Inf_Inf @ ( set @ B )
              @ ( image2 @ C @ ( set @ B )
                @ ^ [X2: C] : ( image2 @ A @ B @ F2 @ ( B2 @ X2 ) )
                @ A3 ) ) ) ) ) ) ).

% image_INT
thf(fact_1420_INT__extend__simps_I3_J,axiom,
    ! [F10: $tType,E: $tType,C3: set @ E,A3: E > ( set @ F10 ),B2: set @ F10] :
      ( ( ( C3
          = ( bot_bot @ ( set @ E ) ) )
       => ( ( minus_minus @ ( set @ F10 ) @ ( complete_Inf_Inf @ ( set @ F10 ) @ ( image2 @ E @ ( set @ F10 ) @ A3 @ C3 ) ) @ B2 )
          = ( minus_minus @ ( set @ F10 ) @ ( top_top @ ( set @ F10 ) ) @ B2 ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ E ) ) )
       => ( ( minus_minus @ ( set @ F10 ) @ ( complete_Inf_Inf @ ( set @ F10 ) @ ( image2 @ E @ ( set @ F10 ) @ A3 @ C3 ) ) @ B2 )
          = ( complete_Inf_Inf @ ( set @ F10 )
            @ ( image2 @ E @ ( set @ F10 )
              @ ^ [X2: E] : ( minus_minus @ ( set @ F10 ) @ ( A3 @ X2 ) @ B2 )
              @ C3 ) ) ) ) ) ).

% INT_extend_simps(3)
thf(fact_1421_INT__extend__simps_I4_J,axiom,
    ! [G3: $tType,H8: $tType,C3: set @ H8,A3: set @ G3,B2: H8 > ( set @ G3 )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ H8 ) ) )
       => ( ( minus_minus @ ( set @ G3 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G3 ) @ ( image2 @ H8 @ ( set @ G3 ) @ B2 @ C3 ) ) )
          = A3 ) )
      & ( ( C3
         != ( bot_bot @ ( set @ H8 ) ) )
       => ( ( minus_minus @ ( set @ G3 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G3 ) @ ( image2 @ H8 @ ( set @ G3 ) @ B2 @ C3 ) ) )
          = ( complete_Inf_Inf @ ( set @ G3 )
            @ ( image2 @ H8 @ ( set @ G3 )
              @ ^ [X2: H8] : ( minus_minus @ ( set @ G3 ) @ A3 @ ( B2 @ X2 ) )
              @ C3 ) ) ) ) ) ).

% INT_extend_simps(4)
thf(fact_1422_INT__bool__eq,axiom,
    ! [A: $tType,A3: $o > ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ $o @ ( set @ A ) @ A3 @ ( top_top @ ( set @ $o ) ) ) )
      = ( inf_inf @ ( set @ A ) @ ( A3 @ $true ) @ ( A3 @ $false ) ) ) ).

% INT_bool_eq
thf(fact_1423_fun__upd__image,axiom,
    ! [A: $tType,B: $tType,X3: B,A3: set @ B,F2: B > A,Y: A] :
      ( ( ( member @ B @ X3 @ A3 )
       => ( ( image2 @ B @ A @ ( fun_upd @ B @ A @ F2 @ X3 @ Y ) @ A3 )
          = ( insert @ A @ Y @ ( image2 @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
      & ( ~ ( member @ B @ X3 @ A3 )
       => ( ( image2 @ B @ A @ ( fun_upd @ B @ A @ F2 @ X3 @ Y ) @ A3 )
          = ( image2 @ B @ A @ F2 @ A3 ) ) ) ) ).

% fun_upd_image
thf(fact_1424_Linear__order__Restr,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( order_679001287576687338der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( order_679001287576687338der_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ A3
              @ ^ [Uu: A] : A3 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) ) ) ).

% Linear_order_Restr
thf(fact_1425_SUP__INF,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [P: C > B > A] :
          ( ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [Y2: B] :
                  ( complete_Inf_Inf @ A
                  @ ( image2 @ C @ A
                    @ ^ [X2: C] : ( P @ X2 @ Y2 )
                    @ ( top_top @ ( set @ C ) ) ) )
              @ ( top_top @ ( set @ B ) ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ ( B > C ) @ A
              @ ^ [X2: B > C] :
                  ( complete_Sup_Sup @ A
                  @ ( image2 @ B @ A
                    @ ^ [Y2: B] : ( P @ ( X2 @ Y2 ) @ Y2 )
                    @ ( top_top @ ( set @ B ) ) ) )
              @ ( top_top @ ( set @ ( B > C ) ) ) ) ) ) ) ).

% SUP_INF
thf(fact_1426_INF__SUP,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [P: C > B > A] :
          ( ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [Y2: B] :
                  ( complete_Sup_Sup @ A
                  @ ( image2 @ C @ A
                    @ ^ [X2: C] : ( P @ X2 @ Y2 )
                    @ ( top_top @ ( set @ C ) ) ) )
              @ ( top_top @ ( set @ B ) ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ ( B > C ) @ A
              @ ^ [F3: B > C] :
                  ( complete_Inf_Inf @ A
                  @ ( image2 @ B @ A
                    @ ^ [X2: B] : ( P @ ( F3 @ X2 ) @ X2 )
                    @ ( top_top @ ( set @ B ) ) ) )
              @ ( top_top @ ( set @ ( B > C ) ) ) ) ) ) ) ).

% INF_SUP
thf(fact_1427_linear__order__on__Restr,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X3: A] :
      ( ( order_679001287576687338der_on @ A @ A3 @ R5 )
     => ( order_679001287576687338der_on @ A @ ( inf_inf @ ( set @ A ) @ A3 @ ( order_above @ A @ R5 @ X3 ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ ( order_above @ A @ R5 @ X3 )
            @ ^ [Uu: A] : ( order_above @ A @ R5 @ X3 ) ) ) ) ) ).

% linear_order_on_Restr
thf(fact_1428_rel__pred__comp__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_pred_comp @ A @ B )
      = ( ^ [R2: A > B > $o,P3: B > $o,X2: A] :
          ? [Y2: B] :
            ( ( R2 @ X2 @ Y2 )
            & ( P3 @ Y2 ) ) ) ) ).

% rel_pred_comp_def
thf(fact_1429_Linear__order__wf__diff__Id,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( order_679001287576687338der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( wf @ A @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ ( id2 @ A ) ) )
        = ( ! [A6: set @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ A6 @ ( field2 @ A @ R5 ) )
             => ( ( A6
                 != ( bot_bot @ ( set @ A ) ) )
               => ? [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                    & ! [Y2: A] :
                        ( ( member @ A @ Y2 @ A6 )
                       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) ) ) ) ) ) ) ) ).

% Linear_order_wf_diff_Id
thf(fact_1430_image__o__collect,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: C > B,F: set @ ( A > ( set @ C ) )] :
      ( ( bNF_collect @ A @ B @ ( image2 @ ( A > ( set @ C ) ) @ ( A > ( set @ B ) ) @ ( comp @ ( set @ C ) @ ( set @ B ) @ A @ ( image2 @ C @ B @ G ) ) @ F ) )
      = ( comp @ ( set @ C ) @ ( set @ B ) @ A @ ( image2 @ C @ B @ G ) @ ( bNF_collect @ A @ C @ F ) ) ) ).

% image_o_collect
thf(fact_1431_bsqr__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Wellorder_bsqr @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) )
            @ ( product_case_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) @ $o
              @ ( product_case_prod @ A @ A @ ( ( product_prod @ A @ A ) > $o )
                @ ^ [A1: A,A22: A] :
                    ( product_case_prod @ A @ A @ $o
                    @ ^ [B1: A,B22: A] :
                        ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A1 @ ( insert @ A @ A22 @ ( insert @ A @ B1 @ ( insert @ A @ B22 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) @ ( field2 @ A @ R3 ) )
                        & ( ( ( A1 = B1 )
                            & ( A22 = B22 ) )
                          | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( bNF_We1388413361240627857o_max2 @ A @ R3 @ A1 @ A22 ) @ ( bNF_We1388413361240627857o_max2 @ A @ R3 @ B1 @ B22 ) ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ ( id2 @ A ) ) )
                          | ( ( ( bNF_We1388413361240627857o_max2 @ A @ R3 @ A1 @ A22 )
                              = ( bNF_We1388413361240627857o_max2 @ A @ R3 @ B1 @ B22 ) )
                            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ B1 ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ ( id2 @ A ) ) ) )
                          | ( ( ( bNF_We1388413361240627857o_max2 @ A @ R3 @ A1 @ A22 )
                              = ( bNF_We1388413361240627857o_max2 @ A @ R3 @ B1 @ B22 ) )
                            & ( A1 = B1 )
                            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A22 @ B22 ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ ( id2 @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% bsqr_def
thf(fact_1432_same__fst__trancl,axiom,
    ! [B: $tType,A: $tType,P: A > $o,R: A > ( set @ ( product_prod @ B @ B ) )] :
      ( ( transitive_trancl @ ( product_prod @ A @ B ) @ ( same_fst @ A @ B @ P @ R ) )
      = ( same_fst @ A @ B @ P
        @ ^ [X2: A] : ( transitive_trancl @ B @ ( R @ X2 ) ) ) ) ).

% same_fst_trancl
thf(fact_1433_Inf__INT__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Inf_Inf @ ( A > B > $o ) )
      = ( ^ [S7: set @ ( A > B > $o ),X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image2 @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S7 ) ) ) ) ) ) ).

% Inf_INT_eq2
thf(fact_1434_relation__of__def,axiom,
    ! [A: $tType] :
      ( ( order_relation_of @ A )
      = ( ^ [P3: A > A > $o,A6: set @ A] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [A5: A,B4: A] :
                  ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 )
                    @ ( product_Sigma @ A @ A @ A6
                      @ ^ [Uu: A] : A6 ) )
                  & ( P3 @ A5 @ B4 ) ) ) ) ) ) ).

% relation_of_def
thf(fact_1435_INF1__I,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: A > B > $o,B3: B] :
      ( ! [X: A] :
          ( ( member @ A @ X @ A3 )
         => ( B2 @ X @ B3 ) )
     => ( complete_Inf_Inf @ ( B > $o ) @ ( image2 @ A @ ( B > $o ) @ B2 @ A3 ) @ B3 ) ) ).

% INF1_I
thf(fact_1436_subset__mset_OcInf__singleton,axiom,
    ! [A: $tType,X3: multiset @ A] :
      ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
      = X3 ) ).

% subset_mset.cInf_singleton
thf(fact_1437_subset__mset_OcINF__const,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,C2: multiset @ A] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( complete_Inf_Inf @ ( multiset @ A )
          @ ( image2 @ B @ ( multiset @ A )
            @ ^ [X2: B] : C2
            @ A3 ) )
        = C2 ) ) ).

% subset_mset.cINF_const
thf(fact_1438_INF2__I,axiom,
    ! [B: $tType,A: $tType,C: $tType,A3: set @ A,B2: A > B > C > $o,B3: B,C2: C] :
      ( ! [X: A] :
          ( ( member @ A @ X @ A3 )
         => ( B2 @ X @ B3 @ C2 ) )
     => ( complete_Inf_Inf @ ( B > C > $o ) @ ( image2 @ A @ ( B > C > $o ) @ B2 @ A3 ) @ B3 @ C2 ) ) ).

% INF2_I
thf(fact_1439_Inf__multiset__empty,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
      = ( zero_zero @ ( multiset @ A ) ) ) ).

% Inf_multiset_empty
thf(fact_1440_Inf__nat__def1,axiom,
    ! [K5: set @ nat] :
      ( ( K5
       != ( bot_bot @ ( set @ nat ) ) )
     => ( member @ nat @ ( complete_Inf_Inf @ nat @ K5 ) @ K5 ) ) ).

% Inf_nat_def1
thf(fact_1441_INF2__D,axiom,
    ! [A: $tType,C: $tType,B: $tType,B2: C > A > B > $o,A3: set @ C,B3: A,C2: B,A4: C] :
      ( ( complete_Inf_Inf @ ( A > B > $o ) @ ( image2 @ C @ ( A > B > $o ) @ B2 @ A3 ) @ B3 @ C2 )
     => ( ( member @ C @ A4 @ A3 )
       => ( B2 @ A4 @ B3 @ C2 ) ) ) ).

% INF2_D
thf(fact_1442_INF2__E,axiom,
    ! [B: $tType,A: $tType,C: $tType,B2: C > A > B > $o,A3: set @ C,B3: A,C2: B,A4: C] :
      ( ( complete_Inf_Inf @ ( A > B > $o ) @ ( image2 @ C @ ( A > B > $o ) @ B2 @ A3 ) @ B3 @ C2 )
     => ( ~ ( B2 @ A4 @ B3 @ C2 )
       => ~ ( member @ C @ A4 @ A3 ) ) ) ).

% INF2_E
thf(fact_1443_INF1__D,axiom,
    ! [B: $tType,A: $tType,B2: B > A > $o,A3: set @ B,B3: A,A4: B] :
      ( ( complete_Inf_Inf @ ( A > $o ) @ ( image2 @ B @ ( A > $o ) @ B2 @ A3 ) @ B3 )
     => ( ( member @ B @ A4 @ A3 )
       => ( B2 @ A4 @ B3 ) ) ) ).

% INF1_D
thf(fact_1444_INF1__E,axiom,
    ! [A: $tType,B: $tType,B2: B > A > $o,A3: set @ B,B3: A,A4: B] :
      ( ( complete_Inf_Inf @ ( A > $o ) @ ( image2 @ B @ ( A > $o ) @ B2 @ A3 ) @ B3 )
     => ( ~ ( B2 @ A4 @ B3 )
       => ~ ( member @ B @ A4 @ A3 ) ) ) ).

% INF1_E
thf(fact_1445_INF__Int__eq2,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image2 @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I2: set @ ( product_prod @ A @ B ),X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ I2 )
          @ S2 ) )
      = ( ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ S2 ) ) ) ) ).

% INF_Int_eq2
thf(fact_1446_INF__Int__eq,axiom,
    ! [A: $tType,S2: set @ ( set @ A )] :
      ( ( complete_Inf_Inf @ ( A > $o )
        @ ( image2 @ ( set @ A ) @ ( A > $o )
          @ ^ [I2: set @ A,X2: A] : ( member @ A @ X2 @ I2 )
          @ S2 ) )
      = ( ^ [X2: A] : ( member @ A @ X2 @ ( complete_Inf_Inf @ ( set @ A ) @ S2 ) ) ) ) ).

% INF_Int_eq
thf(fact_1447_INF__INT__eq,axiom,
    ! [B: $tType,A: $tType,R5: B > ( set @ A ),S2: set @ B] :
      ( ( complete_Inf_Inf @ ( A > $o )
        @ ( image2 @ B @ ( A > $o )
          @ ^ [I2: B,X2: A] : ( member @ A @ X2 @ ( R5 @ I2 ) )
          @ S2 ) )
      = ( ^ [X2: A] : ( member @ A @ X2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ R5 @ S2 ) ) ) ) ) ).

% INF_INT_eq
thf(fact_1448_INF__INT__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R5: C > ( set @ ( product_prod @ A @ B ) ),S2: set @ C] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image2 @ C @ ( A > B > $o )
          @ ^ [I2: C,X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( R5 @ I2 ) )
          @ S2 ) )
      = ( ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ C @ ( set @ ( product_prod @ A @ B ) ) @ R5 @ S2 ) ) ) ) ) ).

% INF_INT_eq2
thf(fact_1449_Inf__set__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( set @ A ) )
      = ( ^ [A6: set @ ( set @ A )] :
            ( collect @ A
            @ ^ [X2: A] : ( complete_Inf_Inf @ $o @ ( image2 @ ( set @ A ) @ $o @ ( member @ A @ X2 ) @ A6 ) ) ) ) ) ).

% Inf_set_def
thf(fact_1450_wf__eq__minimal2,axiom,
    ! [A: $tType] :
      ( ( wf @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
          ! [A6: set @ A] :
            ( ( ( ord_less_eq @ ( set @ A ) @ A6 @ ( field2 @ A @ R3 ) )
              & ( A6
               != ( bot_bot @ ( set @ A ) ) ) )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ A6 )
                & ! [Y2: A] :
                    ( ( member @ A @ Y2 @ A6 )
                   => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X2 ) @ R3 ) ) ) ) ) ) ).

% wf_eq_minimal2
thf(fact_1451_collect__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( bNF_collect @ B @ A )
      = ( ^ [F5: set @ ( B > ( set @ A ) ),X2: B] :
            ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ ( B > ( set @ A ) ) @ ( set @ A )
              @ ^ [F3: B > ( set @ A )] : ( F3 @ X2 )
              @ F5 ) ) ) ) ).

% collect_def
thf(fact_1452_Field__bsqr,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( field2 @ ( product_prod @ A @ A ) @ ( bNF_Wellorder_bsqr @ A @ R5 ) )
      = ( product_Sigma @ A @ A @ ( field2 @ A @ R5 )
        @ ^ [Uu: A] : ( field2 @ A @ R5 ) ) ) ).

% Field_bsqr
thf(fact_1453_collect__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: set @ ( C > ( set @ B ) ),G: A > C] :
      ( ( comp @ C @ ( set @ B ) @ A @ ( bNF_collect @ C @ B @ F ) @ G )
      = ( bNF_collect @ A @ B
        @ ( image2 @ ( C > ( set @ B ) ) @ ( A > ( set @ B ) )
          @ ^ [F3: C > ( set @ B )] : ( comp @ C @ ( set @ B ) @ A @ F3 @ G )
          @ F ) ) ) ).

% collect_comp
thf(fact_1454_above__def,axiom,
    ! [A: $tType] :
      ( ( order_above @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),A5: A] :
            ( collect @ A
            @ ^ [B4: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R3 ) ) ) ) ).

% above_def
thf(fact_1455_same__fst__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( same_fst @ A @ B )
      = ( ^ [P3: A > $o,R2: A > ( set @ ( product_prod @ B @ B ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [X6: A,Y6: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [X2: A,Y2: B] :
                        ( ( X6 = X2 )
                        & ( P3 @ X2 )
                        & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y6 @ Y2 ) @ ( R2 @ X2 ) ) ) ) ) ) ) ) ) ).

% same_fst_def
thf(fact_1456_wf__empty,axiom,
    ! [A: $tType] : ( wf @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% wf_empty
thf(fact_1457_wfI,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A,B2: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5
        @ ( product_Sigma @ A @ A @ A3
          @ ^ [Uu: A] : B2 ) )
     => ( ! [X: A,P4: A > $o] :
            ( ! [Xa3: A] :
                ( ! [Y3: A] :
                    ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Xa3 ) @ R5 )
                   => ( P4 @ Y3 ) )
               => ( P4 @ Xa3 ) )
           => ( ( member @ A @ X @ A3 )
             => ( ( member @ A @ X @ B2 )
               => ( P4 @ X ) ) ) )
       => ( wf @ A @ R5 ) ) ) ).

% wfI
thf(fact_1458_wfE__min_H,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Q: set @ A] :
      ( ( wf @ A @ R )
     => ( ( Q
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ! [Z4: A] :
              ( ( member @ A @ Z4 @ Q )
             => ~ ! [Y7: A] :
                    ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y7 @ Z4 ) @ R )
                   => ~ ( member @ A @ Y7 @ Q ) ) ) ) ) ).

% wfE_min'
thf(fact_1459_wf__Int1,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R5 )
     => ( wf @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ R7 ) ) ) ).

% wf_Int1
thf(fact_1460_wf__Int2,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R5 )
     => ( wf @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R7 @ R5 ) ) ) ).

% wf_Int2
thf(fact_1461_lex__prod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( lex_prod @ A @ B )
      = ( ^ [Ra: set @ ( product_prod @ A @ A ),Rb: set @ ( product_prod @ B @ B )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [A5: A,B4: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [A9: A,B9: B] :
                        ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ A9 ) @ Ra )
                        | ( ( A5 = A9 )
                          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B4 @ B9 ) @ Rb ) ) ) ) ) ) ) ) ) ).

% lex_prod_def
thf(fact_1462_subset__Image1__Image1__iff,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A4: A,B3: A] :
      ( ( order_preorder_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( member @ A @ A4 @ ( field2 @ A @ R5 ) )
       => ( ( member @ A @ B3 @ ( field2 @ A @ R5 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ R5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ R5 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ A4 ) @ R5 ) ) ) ) ) ).

% subset_Image1_Image1_iff
thf(fact_1463_Image__empty2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ B @ A )] :
      ( ( image @ B @ A @ R @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Image_empty2
thf(fact_1464_Image__empty1,axiom,
    ! [B: $tType,A: $tType,X5: set @ B] :
      ( ( image @ B @ A @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) @ X5 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Image_empty1
thf(fact_1465_Image__Id__on,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( image @ A @ A @ ( id_on @ A @ A3 ) @ B2 )
      = ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ).

% Image_Id_on
thf(fact_1466_Image__singleton__iff,axiom,
    ! [A: $tType,B: $tType,B3: A,R5: set @ ( product_prod @ B @ A ),A4: B] :
      ( ( member @ A @ B3 @ ( image @ B @ A @ R5 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) )
      = ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ A4 @ B3 ) @ R5 ) ) ).

% Image_singleton_iff
thf(fact_1467_pair__vimage__is__Image,axiom,
    ! [A: $tType,B: $tType,U2: B,E3: set @ ( product_prod @ B @ A )] :
      ( ( vimage @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ U2 ) @ E3 )
      = ( image @ B @ A @ E3 @ ( insert @ B @ U2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ).

% pair_vimage_is_Image
thf(fact_1468_Image__Int__subset,axiom,
    ! [A: $tType,B: $tType,R: set @ ( product_prod @ B @ A ),A3: set @ B,B2: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ R @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ R @ A3 ) @ ( image @ B @ A @ R @ B2 ) ) ) ).

% Image_Int_subset
thf(fact_1469_wfE__pf,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( wf @ A @ R )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( image @ A @ A @ R @ A3 ) )
       => ( A3
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% wfE_pf
thf(fact_1470_wfI__pf,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ! [A12: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A12 @ ( image @ A @ A @ R @ A12 ) )
         => ( A12
            = ( bot_bot @ ( set @ A ) ) ) )
     => ( wf @ A @ R ) ) ).

% wfI_pf
thf(fact_1471_Image__UN,axiom,
    ! [A: $tType,B: $tType,C: $tType,R5: set @ ( product_prod @ B @ A ),B2: C > ( set @ B ),A3: set @ C] :
      ( ( image @ B @ A @ R5 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ C @ ( set @ B ) @ B2 @ A3 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ C @ ( set @ A )
          @ ^ [X2: C] : ( image @ B @ A @ R5 @ ( B2 @ X2 ) )
          @ A3 ) ) ) ).

% Image_UN
thf(fact_1472_Image__empty__rtrancl__Image__id,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),V: A] :
      ( ( ( image @ A @ A @ R @ ( insert @ A @ V @ ( bot_bot @ ( set @ A ) ) ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( transitive_rtrancl @ A @ R ) @ ( insert @ A @ V @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ V @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Image_empty_rtrancl_Image_id
thf(fact_1473_Image__empty__trancl__Image__empty,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),V: A] :
      ( ( ( image @ A @ A @ R @ ( insert @ A @ V @ ( bot_bot @ ( set @ A ) ) ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( transitive_trancl @ A @ R ) @ ( insert @ A @ V @ ( bot_bot @ ( set @ A ) ) ) )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% Image_empty_trancl_Image_empty
thf(fact_1474_total__on__lex__prod,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),B2: set @ B,S3: set @ ( product_prod @ B @ B )] :
      ( ( total_on @ A @ A3 @ R5 )
     => ( ( total_on @ B @ B2 @ S3 )
       => ( total_on @ ( product_prod @ A @ B )
          @ ( product_Sigma @ A @ B @ A3
            @ ^ [Uu: A] : B2 )
          @ ( lex_prod @ A @ B @ R5 @ S3 ) ) ) ) ).

% total_on_lex_prod
thf(fact_1475_Image__singleton,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ B @ A ),A4: B] :
      ( ( image @ B @ A @ R5 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) )
      = ( collect @ A
        @ ^ [B4: A] : ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ A4 @ B4 ) @ R5 ) ) ) ).

% Image_singleton
thf(fact_1476_Image__subset,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ A @ B ),A3: set @ A,B2: set @ B,C3: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R5
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ R5 @ C3 ) @ B2 ) ) ).

% Image_subset
thf(fact_1477_Image__INT__subset,axiom,
    ! [A: $tType,B: $tType,C: $tType,R5: set @ ( product_prod @ B @ A ),B2: C > ( set @ B ),A3: set @ C] :
      ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ R5 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ C @ ( set @ B ) @ B2 @ A3 ) ) )
      @ ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ C @ ( set @ A )
          @ ^ [X2: C] : ( image @ B @ A @ R5 @ ( B2 @ X2 ) )
          @ A3 ) ) ) ).

% Image_INT_subset
thf(fact_1478_rtrancl__apply__insert,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X3: A,S2: set @ A] :
      ( ( image @ A @ A @ ( transitive_rtrancl @ A @ R ) @ ( insert @ A @ X3 @ S2 ) )
      = ( insert @ A @ X3 @ ( image @ A @ A @ ( transitive_rtrancl @ A @ R ) @ ( sup_sup @ ( set @ A ) @ S2 @ ( image @ A @ A @ R @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% rtrancl_apply_insert
thf(fact_1479_Image__eq__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( image @ B @ A )
      = ( ^ [R3: set @ ( product_prod @ B @ A ),B5: set @ B] :
            ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : ( image @ B @ A @ R3 @ ( insert @ B @ Y2 @ ( bot_bot @ ( set @ B ) ) ) )
              @ B5 ) ) ) ) ).

% Image_eq_UN
thf(fact_1480_Sigma__Image,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,B2: B > ( set @ A ),X5: set @ B] :
      ( ( image @ B @ A @ ( product_Sigma @ B @ A @ A3 @ B2 ) @ X5 )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ ( inf_inf @ ( set @ B ) @ X5 @ A3 ) ) ) ) ).

% Sigma_Image
thf(fact_1481_UN__Image,axiom,
    ! [A: $tType,B: $tType,C: $tType,X5: C > ( set @ ( product_prod @ B @ A ) ),I: set @ C,S2: set @ B] :
      ( ( image @ B @ A @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ A ) ) @ ( image2 @ C @ ( set @ ( product_prod @ B @ A ) ) @ X5 @ I ) ) @ S2 )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ C @ ( set @ A )
          @ ^ [I2: C] : ( image @ B @ A @ ( X5 @ I2 ) @ S2 )
          @ I ) ) ) ).

% UN_Image
thf(fact_1482_rtrancl__Image__advance__ss,axiom,
    ! [A: $tType,U2: A,V: A,E3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U2 @ V ) @ E3 )
     => ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ ( transitive_rtrancl @ A @ E3 ) @ ( insert @ A @ V @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ ( transitive_rtrancl @ A @ E3 ) @ ( insert @ A @ U2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% rtrancl_Image_advance_ss
thf(fact_1483_trancl__Image__advance__ss,axiom,
    ! [A: $tType,U2: A,V: A,E3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U2 @ V ) @ E3 )
     => ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ ( transitive_trancl @ A @ E3 ) @ ( insert @ A @ V @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ ( transitive_trancl @ A @ E3 ) @ ( insert @ A @ U2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% trancl_Image_advance_ss
thf(fact_1484_trancl__restrict__reachable,axiom,
    ! [A: $tType,U2: A,V: A,E3: set @ ( product_prod @ A @ A ),S2: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U2 @ V ) @ ( transitive_trancl @ A @ E3 ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ E3 @ S2 ) @ S2 )
       => ( ( member @ A @ U2 @ S2 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U2 @ V )
            @ ( transitive_trancl @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ E3
                @ ( product_Sigma @ A @ A @ S2
                  @ ^ [Uu: A] : S2 ) ) ) ) ) ) ) ).

% trancl_restrict_reachable
thf(fact_1485_Refl__antisym__eq__Image1__Image1__iff,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A4: A,B3: A] :
      ( ( refl_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( antisym @ A @ R5 )
       => ( ( member @ A @ A4 @ ( field2 @ A @ R5 ) )
         => ( ( member @ A @ B3 @ ( field2 @ A @ R5 ) )
           => ( ( ( image @ A @ A @ R5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( image @ A @ A @ R5 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
              = ( A4 = B3 ) ) ) ) ) ) ).

% Refl_antisym_eq_Image1_Image1_iff
thf(fact_1486_quotient__def,axiom,
    ! [A: $tType] :
      ( ( equiv_quotient @ A )
      = ( ^ [A6: set @ A,R3: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( set @ A ) )
            @ ( image2 @ A @ ( set @ ( set @ A ) )
              @ ^ [X2: A] : ( insert @ ( set @ A ) @ ( image @ A @ A @ R3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) )
              @ A6 ) ) ) ) ).

% quotient_def
thf(fact_1487_singleton__quotient,axiom,
    ! [A: $tType,X3: A,R5: set @ ( product_prod @ A @ A )] :
      ( ( equiv_quotient @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) @ R5 )
      = ( insert @ ( set @ A ) @ ( image @ A @ A @ R5 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% singleton_quotient
thf(fact_1488_chains__extend,axiom,
    ! [A: $tType,C2: set @ ( set @ A ),S2: set @ ( set @ A ),Z2: set @ A] :
      ( ( member @ ( set @ ( set @ A ) ) @ C2 @ ( chains2 @ A @ S2 ) )
     => ( ( member @ ( set @ A ) @ Z2 @ S2 )
       => ( ! [X: set @ A] :
              ( ( member @ ( set @ A ) @ X @ C2 )
             => ( ord_less_eq @ ( set @ A ) @ X @ Z2 ) )
         => ( member @ ( set @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( insert @ ( set @ A ) @ Z2 @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) @ C2 ) @ ( chains2 @ A @ S2 ) ) ) ) ) ).

% chains_extend
thf(fact_1489_Rep__unit,axiom,
    ! [X3: product_unit] : ( member @ $o @ ( product_Rep_unit @ X3 ) @ ( insert @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) ) ).

% Rep_unit
thf(fact_1490_Abs__unit__cases,axiom,
    ! [X3: product_unit] :
      ~ ! [Y3: $o] :
          ( ( X3
            = ( product_Abs_unit @ Y3 ) )
         => ~ ( member @ $o @ Y3 @ ( insert @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) ) ) ).

% Abs_unit_cases
thf(fact_1491_Rep__unit__cases,axiom,
    ! [Y: $o] :
      ( ( member @ $o @ Y @ ( insert @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
     => ~ ! [X: product_unit] :
            ( Y
            = ( ~ ( product_Rep_unit @ X ) ) ) ) ).

% Rep_unit_cases
thf(fact_1492_Abs__unit__induct,axiom,
    ! [P: product_unit > $o,X3: product_unit] :
      ( ! [Y3: $o] :
          ( ( member @ $o @ Y3 @ ( insert @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
         => ( P @ ( product_Abs_unit @ Y3 ) ) )
     => ( P @ X3 ) ) ).

% Abs_unit_induct
thf(fact_1493_quotient__is__empty2,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A )] :
      ( ( ( bot_bot @ ( set @ ( set @ A ) ) )
        = ( equiv_quotient @ A @ A3 @ R5 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% quotient_is_empty2
thf(fact_1494_quotient__is__empty,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A )] :
      ( ( ( equiv_quotient @ A @ A3 @ R5 )
        = ( bot_bot @ ( set @ ( set @ A ) ) ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% quotient_is_empty
thf(fact_1495_quotient__empty,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( equiv_quotient @ A @ ( bot_bot @ ( set @ A ) ) @ R5 )
      = ( bot_bot @ ( set @ ( set @ A ) ) ) ) ).

% quotient_empty
thf(fact_1496_antisym__empty,axiom,
    ! [A: $tType] : ( antisym @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% antisym_empty
thf(fact_1497_type__definition__unit,axiom,
    type_definition @ product_unit @ $o @ product_Rep_unit @ product_Abs_unit @ ( insert @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) ).

% type_definition_unit
thf(fact_1498_Abs__unit__inverse,axiom,
    ! [Y: $o] :
      ( ( member @ $o @ Y @ ( insert @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
     => ( ( product_Rep_unit @ ( product_Abs_unit @ Y ) )
        = Y ) ) ).

% Abs_unit_inverse
thf(fact_1499_antisym__singleton,axiom,
    ! [A: $tType,X3: product_prod @ A @ A] : ( antisym @ A @ ( insert @ ( product_prod @ A @ A ) @ X3 @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% antisym_singleton
thf(fact_1500_antisym__Restr,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( antisym @ A @ R5 )
     => ( antisym @ A
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) ) ) ).

% antisym_Restr
thf(fact_1501_quotientE,axiom,
    ! [A: $tType,X5: set @ A,A3: set @ A,R5: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A3 @ R5 ) )
     => ~ ! [X: A] :
            ( ( X5
              = ( image @ A @ A @ R5 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
           => ~ ( member @ A @ X @ A3 ) ) ) ).

% quotientE
thf(fact_1502_quotientI,axiom,
    ! [A: $tType,X3: A,A3: set @ A,R5: set @ ( product_prod @ A @ A )] :
      ( ( member @ A @ X3 @ A3 )
     => ( member @ ( set @ A ) @ ( image @ A @ A @ R5 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( equiv_quotient @ A @ A3 @ R5 ) ) ) ).

% quotientI
thf(fact_1503_quotient__diff1,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A,A4: A] :
      ( ( inj_on @ A @ ( set @ ( set @ A ) )
        @ ^ [A5: A] : ( equiv_quotient @ A @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) @ R5 )
        @ A3 )
     => ( ( member @ A @ A4 @ A3 )
       => ( ( equiv_quotient @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) @ R5 )
          = ( minus_minus @ ( set @ ( set @ A ) ) @ ( equiv_quotient @ A @ A3 @ R5 ) @ ( equiv_quotient @ A @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) @ R5 ) ) ) ) ) ).

% quotient_diff1
thf(fact_1504_Rep__unit__induct,axiom,
    ! [Y: $o,P: $o > $o] :
      ( ( member @ $o @ Y @ ( insert @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
     => ( ! [X: product_unit] : ( P @ ( product_Rep_unit @ X ) )
       => ( P @ Y ) ) ) ).

% Rep_unit_induct
thf(fact_1505_Abs__unit__inject,axiom,
    ! [X3: $o,Y: $o] :
      ( ( member @ $o @ X3 @ ( insert @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
     => ( ( member @ $o @ Y @ ( insert @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
       => ( ( ( product_Abs_unit @ X3 )
            = ( product_Abs_unit @ Y ) )
          = ( X3 = Y ) ) ) ) ).

% Abs_unit_inject
thf(fact_1506_Partial__order__eq__Image1__Image1__iff,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A4: A,B3: A] :
      ( ( order_7125193373082350890der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( member @ A @ A4 @ ( field2 @ A @ R5 ) )
       => ( ( member @ A @ B3 @ ( field2 @ A @ R5 ) )
         => ( ( ( image @ A @ A @ R5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( image @ A @ A @ R5 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( A4 = B3 ) ) ) ) ) ).

% Partial_order_eq_Image1_Image1_iff
thf(fact_1507_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B2: B > ( set @ A ),A3: set @ B] :
      ( ord_less_eq @ ( set @ ( set @ A ) )
      @ ( complete_Sup_Sup @ ( set @ ( set @ A ) )
        @ ( image2 @ B @ ( set @ ( set @ A ) )
          @ ^ [X2: B] : ( pow @ A @ ( B2 @ X2 ) )
          @ A3 ) )
      @ ( pow @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) ) ) ).

% UN_Pow_subset
thf(fact_1508_wo__rel_Ocases__Total3,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A4: A,B3: A,Phi: A > A > $o] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( field2 @ A @ R5 ) )
       => ( ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ ( id2 @ A ) ) )
              | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ A4 ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ ( id2 @ A ) ) ) )
           => ( Phi @ A4 @ B3 ) )
         => ( ( ( A4 = B3 )
             => ( Phi @ A4 @ B3 ) )
           => ( Phi @ A4 @ B3 ) ) ) ) ) ).

% wo_rel.cases_Total3
thf(fact_1509_chains__def,axiom,
    ! [A: $tType] :
      ( ( chains2 @ A )
      = ( ^ [A6: set @ ( set @ A )] :
            ( collect @ ( set @ ( set @ A ) )
            @ ^ [C7: set @ ( set @ A )] :
                ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C7 @ A6 )
                & ( chain_subset @ A @ C7 ) ) ) ) ) ).

% chains_def
thf(fact_1510_proj__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( equiv_proj @ B @ A )
      = ( ^ [R3: set @ ( product_prod @ B @ A ),X2: B] : ( image @ B @ A @ R3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ).

% proj_def
thf(fact_1511_cSUP__UNION,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [A3: set @ C,B2: C > ( set @ D ),F2: D > B] :
          ( ( A3
           != ( bot_bot @ ( set @ C ) ) )
         => ( ! [X: C] :
                ( ( member @ C @ X @ A3 )
               => ( ( B2 @ X )
                 != ( bot_bot @ ( set @ D ) ) ) )
           => ( ( condit941137186595557371_above @ B
                @ ( complete_Sup_Sup @ ( set @ B )
                  @ ( image2 @ C @ ( set @ B )
                    @ ^ [X2: C] : ( image2 @ D @ B @ F2 @ ( B2 @ X2 ) )
                    @ A3 ) ) )
             => ( ( complete_Sup_Sup @ B @ ( image2 @ D @ B @ F2 @ ( complete_Sup_Sup @ ( set @ D ) @ ( image2 @ C @ ( set @ D ) @ B2 @ A3 ) ) ) )
                = ( complete_Sup_Sup @ B
                  @ ( image2 @ C @ B
                    @ ^ [X2: C] : ( complete_Sup_Sup @ B @ ( image2 @ D @ B @ F2 @ ( B2 @ X2 ) ) )
                    @ A3 ) ) ) ) ) ) ) ).

% cSUP_UNION
thf(fact_1512_cINF__UNION,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [A3: set @ C,B2: C > ( set @ D ),F2: D > B] :
          ( ( A3
           != ( bot_bot @ ( set @ C ) ) )
         => ( ! [X: C] :
                ( ( member @ C @ X @ A3 )
               => ( ( B2 @ X )
                 != ( bot_bot @ ( set @ D ) ) ) )
           => ( ( condit1013018076250108175_below @ B
                @ ( complete_Sup_Sup @ ( set @ B )
                  @ ( image2 @ C @ ( set @ B )
                    @ ^ [X2: C] : ( image2 @ D @ B @ F2 @ ( B2 @ X2 ) )
                    @ A3 ) ) )
             => ( ( complete_Inf_Inf @ B @ ( image2 @ D @ B @ F2 @ ( complete_Sup_Sup @ ( set @ D ) @ ( image2 @ C @ ( set @ D ) @ B2 @ A3 ) ) ) )
                = ( complete_Inf_Inf @ B
                  @ ( image2 @ C @ B
                    @ ^ [X2: C] : ( complete_Inf_Inf @ B @ ( image2 @ D @ B @ F2 @ ( B2 @ X2 ) ) )
                    @ A3 ) ) ) ) ) ) ) ).

% cINF_UNION
thf(fact_1513_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: B > A,A13: set @ B,B12: set @ A,F22: C > D,B23: set @ C,A23: set @ D] :
      ( ( ( image2 @ B @ A @ F1 @ A13 )
        = B12 )
     => ( ( inj_on @ C @ D @ F22 @ B23 )
       => ( ( ord_less_eq @ ( set @ D ) @ ( image2 @ C @ D @ F22 @ B23 ) @ A23 )
         => ( ( ( B23
                = ( bot_bot @ ( set @ C ) ) )
             => ( A23
                = ( bot_bot @ ( set @ D ) ) ) )
           => ( ( bNF_Wellorder_Func @ C @ A @ B23 @ B12 )
              = ( image2 @ ( D > B ) @ ( C > A ) @ ( bNF_We4925052301507509544nc_map @ C @ B @ A @ D @ B23 @ F1 @ F22 ) @ ( bNF_Wellorder_Func @ D @ B @ A23 @ A13 ) ) ) ) ) ) ) ).

% Func_map_surj
thf(fact_1514_bdd__below__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( condit1013018076250108175_below @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% bdd_below_empty
thf(fact_1515_bdd__above__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( condit941137186595557371_above @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% bdd_above_empty
thf(fact_1516_bdd__below__image__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ( condit1013018076250108175_below @ A
            @ ( image2 @ B @ A
              @ ^ [X2: B] : ( inf_inf @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ A3 ) )
          = ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
            & ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ G @ A3 ) ) ) ) ) ).

% bdd_below_image_inf
thf(fact_1517_bdd__above__image__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ( condit941137186595557371_above @ A
            @ ( image2 @ B @ A
              @ ^ [X2: B] : ( sup_sup @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ A3 ) )
          = ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
            & ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ G @ A3 ) ) ) ) ) ).

% bdd_above_image_sup
thf(fact_1518_Pow__Int__eq,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( pow @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
      = ( inf_inf @ ( set @ ( set @ A ) ) @ ( pow @ A @ A3 ) @ ( pow @ A @ B2 ) ) ) ).

% Pow_Int_eq
thf(fact_1519_Pow__singleton__iff,axiom,
    ! [A: $tType,X5: set @ A,Y4: set @ A] :
      ( ( ( pow @ A @ X5 )
        = ( insert @ ( set @ A ) @ Y4 @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) )
      = ( ( X5
          = ( bot_bot @ ( set @ A ) ) )
        & ( Y4
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Pow_singleton_iff
thf(fact_1520_Pow__empty,axiom,
    ! [A: $tType] :
      ( ( pow @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( insert @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_empty
thf(fact_1521_bdd__below__Int1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A3 )
         => ( condit1013018076250108175_below @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% bdd_below_Int1
thf(fact_1522_bdd__below__Int2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: set @ A,A3: set @ A] :
          ( ( condit1013018076250108175_below @ A @ B2 )
         => ( condit1013018076250108175_below @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% bdd_below_Int2
thf(fact_1523_bdd__above__Int1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( condit941137186595557371_above @ A @ A3 )
         => ( condit941137186595557371_above @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% bdd_above_Int1
thf(fact_1524_bdd__above__Int2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: set @ A,A3: set @ A] :
          ( ( condit941137186595557371_above @ A @ B2 )
         => ( condit941137186595557371_above @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% bdd_above_Int2
thf(fact_1525_Pow__bottom,axiom,
    ! [A: $tType,B2: set @ A] : ( member @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( pow @ A @ B2 ) ) ).

% Pow_bottom
thf(fact_1526_Pow__not__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( pow @ A @ A3 )
     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ).

% Pow_not_empty
thf(fact_1527_Pow__def,axiom,
    ! [A: $tType] :
      ( ( pow @ A )
      = ( ^ [A6: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [B5: set @ A] : ( ord_less_eq @ ( set @ A ) @ B5 @ A6 ) ) ) ) ).

% Pow_def
thf(fact_1528_cSUP__eq__cINF__D,axiom,
    ! [B: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [F2: C > B,A3: set @ C,A4: C] :
          ( ( ( complete_Sup_Sup @ B @ ( image2 @ C @ B @ F2 @ A3 ) )
            = ( complete_Inf_Inf @ B @ ( image2 @ C @ B @ F2 @ A3 ) ) )
         => ( ( condit941137186595557371_above @ B @ ( image2 @ C @ B @ F2 @ A3 ) )
           => ( ( condit1013018076250108175_below @ B @ ( image2 @ C @ B @ F2 @ A3 ) )
             => ( ( member @ C @ A4 @ A3 )
               => ( ( F2 @ A4 )
                  = ( complete_Inf_Inf @ B @ ( image2 @ C @ B @ F2 @ A3 ) ) ) ) ) ) ) ) ).

% cSUP_eq_cINF_D
thf(fact_1529_Func__is__emp,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B] :
      ( ( ( bNF_Wellorder_Func @ A @ B @ A3 @ B2 )
        = ( bot_bot @ ( set @ ( A > B ) ) ) )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
        & ( B2
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% Func_is_emp
thf(fact_1530_Func__non__emp,axiom,
    ! [A: $tType,B: $tType,B2: set @ A,A3: set @ B] :
      ( ( B2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( bNF_Wellorder_Func @ B @ A @ A3 @ B2 )
       != ( bot_bot @ ( set @ ( B > A ) ) ) ) ) ).

% Func_non_emp
thf(fact_1531_Pow__Compl,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( pow @ A @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( collect @ ( set @ A )
        @ ^ [Uu: set @ A] :
          ? [B5: set @ A] :
            ( ( Uu
              = ( uminus_uminus @ ( set @ A ) @ B5 ) )
            & ( member @ ( set @ A ) @ A3 @ ( pow @ A @ B5 ) ) ) ) ) ).

% Pow_Compl
thf(fact_1532_cInf__le__cSup,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A3 )
           => ( ( condit1013018076250108175_below @ A @ A3 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ).

% cInf_le_cSup
thf(fact_1533_le__cInf__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A,A4: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S2 )
           => ( ( ord_less_eq @ A @ A4 @ ( complete_Inf_Inf @ A @ S2 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ S2 )
                   => ( ord_less_eq @ A @ A4 @ X2 ) ) ) ) ) ) ) ).

% le_cInf_iff
thf(fact_1534_cInf__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B2: set @ A,A3: set @ A] :
          ( ( B2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ A3 )
           => ( ! [B6: A] :
                  ( ( member @ A @ B6 @ B2 )
                 => ? [X4: A] :
                      ( ( member @ A @ X4 @ A3 )
                      & ( ord_less_eq @ A @ X4 @ B6 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B2 ) ) ) ) ) ) ).

% cInf_mono
thf(fact_1535_cSup__le__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A,A4: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S2 )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ S2 ) @ A4 )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ S2 )
                   => ( ord_less_eq @ A @ X2 @ A4 ) ) ) ) ) ) ) ).

% cSup_le_iff
thf(fact_1536_cSup__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B2: set @ A,A3: set @ A] :
          ( ( B2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A3 )
           => ( ! [B6: A] :
                  ( ( member @ A @ B6 @ B2 )
                 => ? [X4: A] :
                      ( ( member @ A @ X4 @ A3 )
                      & ( ord_less_eq @ A @ B6 @ X4 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ B2 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ).

% cSup_mono
thf(fact_1537_partial__order__on__empty,axiom,
    ! [A: $tType] : ( order_7125193373082350890der_on @ A @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% partial_order_on_empty
thf(fact_1538_wo__rel_Omax2__among,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A4: A,B3: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( member @ A @ A4 @ ( field2 @ A @ R5 ) )
       => ( ( member @ A @ B3 @ ( field2 @ A @ R5 ) )
         => ( member @ A @ ( bNF_We1388413361240627857o_max2 @ A @ R5 @ A4 @ B3 ) @ ( insert @ A @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% wo_rel.max2_among
thf(fact_1539_wo__rel_Ocases__Total,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A4: A,B3: A,Phi: A > A > $o] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( field2 @ A @ R5 ) )
       => ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R5 )
           => ( Phi @ A4 @ B3 ) )
         => ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ A4 ) @ R5 )
             => ( Phi @ A4 @ B3 ) )
           => ( Phi @ A4 @ B3 ) ) ) ) ) ).

% wo_rel.cases_Total
thf(fact_1540_le__cINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,U2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
           => ( ( ord_less_eq @ A @ U2 @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                   => ( ord_less_eq @ A @ U2 @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% le_cINF_iff
thf(fact_1541_cINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B2: set @ B,F2: C > A,A3: set @ C,G: B > A] :
          ( ( B2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ C @ A @ F2 @ A3 ) )
           => ( ! [M3: B] :
                  ( ( member @ B @ M3 @ B2 )
                 => ? [X4: C] :
                      ( ( member @ C @ X4 @ A3 )
                      & ( ord_less_eq @ A @ ( F2 @ X4 ) @ ( G @ M3 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ C @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ B2 ) ) ) ) ) ) ) ).

% cINF_mono
thf(fact_1542_cInf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ B2 )
           => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ B2 ) @ ( complete_Inf_Inf @ A @ A3 ) ) ) ) ) ) ).

% cInf_superset_mono
thf(fact_1543_cSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,U2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ U2 )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                   => ( ord_less_eq @ A @ ( F2 @ X2 ) @ U2 ) ) ) ) ) ) ) ).

% cSUP_le_iff
thf(fact_1544_cSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,G: C > A,B2: set @ C,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ C @ A @ G @ B2 ) )
           => ( ! [N2: B] :
                  ( ( member @ B @ N2 @ A3 )
                 => ? [X4: C] :
                      ( ( member @ C @ X4 @ B2 )
                      & ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G @ X4 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ C @ A @ G @ B2 ) ) ) ) ) ) ) ).

% cSUP_mono
thf(fact_1545_wo__rel_Omax2__greater__among,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A4: A,B3: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( member @ A @ A4 @ ( field2 @ A @ R5 ) )
       => ( ( member @ A @ B3 @ ( field2 @ A @ R5 ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ ( bNF_We1388413361240627857o_max2 @ A @ R5 @ A4 @ B3 ) ) @ R5 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ ( bNF_We1388413361240627857o_max2 @ A @ R5 @ A4 @ B3 ) ) @ R5 )
            & ( member @ A @ ( bNF_We1388413361240627857o_max2 @ A @ R5 @ A4 @ B3 ) @ ( insert @ A @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% wo_rel.max2_greater_among
thf(fact_1546_cSup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ B2 )
           => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B2 ) ) ) ) ) ) ).

% cSup_subset_mono
thf(fact_1547_cInf__insert,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A4: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ X5 )
           => ( ( complete_Inf_Inf @ A @ ( insert @ A @ A4 @ X5 ) )
              = ( inf_inf @ A @ A4 @ ( complete_Inf_Inf @ A @ X5 ) ) ) ) ) ) ).

% cInf_insert
thf(fact_1548_cInf__insert__If,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A4: A] :
          ( ( condit1013018076250108175_below @ A @ X5 )
         => ( ( ( X5
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert @ A @ A4 @ X5 ) )
                = A4 ) )
            & ( ( X5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert @ A @ A4 @ X5 ) )
                = ( inf_inf @ A @ A4 @ ( complete_Inf_Inf @ A @ X5 ) ) ) ) ) ) ) ).

% cInf_insert_If
thf(fact_1549_cSup__insert__If,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A4: A] :
          ( ( condit941137186595557371_above @ A @ X5 )
         => ( ( ( X5
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert @ A @ A4 @ X5 ) )
                = A4 ) )
            & ( ( X5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert @ A @ A4 @ X5 ) )
                = ( sup_sup @ A @ A4 @ ( complete_Sup_Sup @ A @ X5 ) ) ) ) ) ) ) ).

% cSup_insert_If
thf(fact_1550_cSup__insert,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A4: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ X5 )
           => ( ( complete_Sup_Sup @ A @ ( insert @ A @ A4 @ X5 ) )
              = ( sup_sup @ A @ A4 @ ( complete_Sup_Sup @ A @ X5 ) ) ) ) ) ) ).

% cSup_insert
thf(fact_1551_cInf__union__distrib,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ A3 )
           => ( ( B2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit1013018076250108175_below @ A @ B2 )
               => ( ( complete_Inf_Inf @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
                  = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B2 ) ) ) ) ) ) ) ) ).

% cInf_union_distrib
thf(fact_1552_cSup__union__distrib,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A3 )
           => ( ( B2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit941137186595557371_above @ A @ B2 )
               => ( ( complete_Sup_Sup @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
                  = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B2 ) ) ) ) ) ) ) ) ).

% cSup_union_distrib
thf(fact_1553_Pow__INT__eq,axiom,
    ! [A: $tType,B: $tType,B2: B > ( set @ A ),A3: set @ B] :
      ( ( pow @ A @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) ) )
      = ( complete_Inf_Inf @ ( set @ ( set @ A ) )
        @ ( image2 @ B @ ( set @ ( set @ A ) )
          @ ^ [X2: B] : ( pow @ A @ ( B2 @ X2 ) )
          @ A3 ) ) ) ).

% Pow_INT_eq
thf(fact_1554_cINF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
           => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ G @ A3 ) )
             => ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ A3 ) ) )
                = ( complete_Inf_Inf @ A
                  @ ( image2 @ B @ A
                    @ ^ [A5: B] : ( inf_inf @ A @ ( F2 @ A5 ) @ ( G @ A5 ) )
                    @ A3 ) ) ) ) ) ) ) ).

% cINF_inf_distrib
thf(fact_1555_conditionally__complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
           => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ G @ A3 ) )
             => ( ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ G @ A3 ) ) )
                = ( complete_Sup_Sup @ A
                  @ ( image2 @ B @ A
                    @ ^ [A5: B] : ( sup_sup @ A @ ( F2 @ A5 ) @ ( G @ A5 ) )
                    @ A3 ) ) ) ) ) ) ) ).

% conditionally_complete_lattice_class.SUP_sup_distrib
thf(fact_1556_cINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,G: B > A,B2: set @ B,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ G @ B2 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B2 )
             => ( ! [X: B] :
                    ( ( member @ B @ X @ B2 )
                   => ( ord_less_eq @ A @ ( G @ X ) @ ( F2 @ X ) ) )
               => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ B2 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) ) ) ) ) ) ) ).

% cINF_superset_mono
thf(fact_1557_cSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,G: B > A,B2: set @ B,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ G @ B2 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B2 )
             => ( ! [X: B] :
                    ( ( member @ B @ X @ A3 )
                   => ( ord_less_eq @ A @ ( F2 @ X ) @ ( G @ X ) ) )
               => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ G @ B2 ) ) ) ) ) ) ) ) ).

% cSUP_subset_mono
thf(fact_1558_less__eq__cInf__inter,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A3 )
         => ( ( condit1013018076250108175_below @ A @ B2 )
           => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B2 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ) ) ) ).

% less_eq_cInf_inter
thf(fact_1559_cINF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,A4: B] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
           => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ ( insert @ B @ A4 @ A3 ) ) )
              = ( inf_inf @ A @ ( F2 @ A4 ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) ) ) ) ) ) ).

% cINF_insert
thf(fact_1560_cSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( condit941137186595557371_above @ A @ A3 )
         => ( ( condit941137186595557371_above @ A @ B2 )
           => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) @ ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B2 ) ) ) ) ) ) ) ).

% cSup_inter_less_eq
thf(fact_1561_cSUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,A4: B] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
           => ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ ( insert @ B @ A4 @ A3 ) ) )
              = ( sup_sup @ A @ ( F2 @ A4 ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) ) ) ) ) ) ).

% cSUP_insert
thf(fact_1562_cINF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,B2: set @ B] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
           => ( ( B2
               != ( bot_bot @ ( set @ B ) ) )
             => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ B2 ) )
               => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) ) )
                  = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ B2 ) ) ) ) ) ) ) ) ) ).

% cINF_union
thf(fact_1563_Partial__order__Restr,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( order_7125193373082350890der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( order_7125193373082350890der_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ A3
              @ ^ [Uu: A] : A3 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) ) ) ).

% Partial_order_Restr
thf(fact_1564_cSUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,B2: set @ B] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
           => ( ( B2
               != ( bot_bot @ ( set @ B ) ) )
             => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F2 @ B2 ) )
               => ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) ) )
                  = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ B2 ) ) ) ) ) ) ) ) ) ).

% cSUP_union
thf(fact_1565_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: A > B,C3: set @ A,B2: set @ A,X3: A] :
      ( ( inj_on @ A @ B @ G @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ C3 @ ( sup_sup @ ( set @ A ) @ B2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( member @ ( B > A )
          @ ^ [I2: B] : ( if @ A @ ( member @ B @ I2 @ ( image2 @ A @ B @ G @ C3 ) ) @ ( the_inv_into @ A @ B @ C3 @ G @ I2 ) @ X3 )
          @ ( bNF_Wellorder_Func @ B @ A @ ( top_top @ ( set @ B ) ) @ ( sup_sup @ ( set @ A ) @ B2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% If_the_inv_into_in_Func
thf(fact_1566_wo__rel_OWell__order__isMinim__exists,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),B2: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ ( field2 @ A @ R5 ) )
       => ( ( B2
           != ( bot_bot @ ( set @ A ) ) )
         => ? [X_1: A] : ( bNF_We4791949203932849705sMinim @ A @ R5 @ B2 @ X_1 ) ) ) ) ).

% wo_rel.Well_order_isMinim_exists
thf(fact_1567_wo__rel_Ominim__in,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),B2: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ ( field2 @ A @ R5 ) )
       => ( ( B2
           != ( bot_bot @ ( set @ A ) ) )
         => ( member @ A @ ( bNF_We6954850376910717587_minim @ A @ R5 @ B2 ) @ B2 ) ) ) ) ).

% wo_rel.minim_in
thf(fact_1568_wo__rel_Ominim__inField,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),B2: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ ( field2 @ A @ R5 ) )
       => ( ( B2
           != ( bot_bot @ ( set @ A ) ) )
         => ( member @ A @ ( bNF_We6954850376910717587_minim @ A @ R5 @ B2 ) @ ( field2 @ A @ R5 ) ) ) ) ) ).

% wo_rel.minim_inField
thf(fact_1569_curr__surj,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: A > B > C,A3: set @ A,B2: set @ B,C3: set @ C] :
      ( ( member @ ( A > B > C ) @ G @ ( bNF_Wellorder_Func @ A @ ( B > C ) @ A3 @ ( bNF_Wellorder_Func @ B @ C @ B2 @ C3 ) ) )
     => ? [X: ( product_prod @ A @ B ) > C] :
          ( ( member @ ( ( product_prod @ A @ B ) > C ) @ X
            @ ( bNF_Wellorder_Func @ ( product_prod @ A @ B ) @ C
              @ ( product_Sigma @ A @ B @ A3
                @ ^ [Uu: A] : B2 )
              @ C3 ) )
          & ( ( bNF_Wellorder_curr @ A @ B @ C @ A3 @ X )
            = G ) ) ) ).

% curr_surj
thf(fact_1570_curr__in,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: ( product_prod @ A @ B ) > C,A3: set @ A,B2: set @ B,C3: set @ C] :
      ( ( member @ ( ( product_prod @ A @ B ) > C ) @ F2
        @ ( bNF_Wellorder_Func @ ( product_prod @ A @ B ) @ C
          @ ( product_Sigma @ A @ B @ A3
            @ ^ [Uu: A] : B2 )
          @ C3 ) )
     => ( member @ ( A > B > C ) @ ( bNF_Wellorder_curr @ A @ B @ C @ A3 @ F2 ) @ ( bNF_Wellorder_Func @ A @ ( B > C ) @ A3 @ ( bNF_Wellorder_Func @ B @ C @ B2 @ C3 ) ) ) ) ).

% curr_in
thf(fact_1571_proj__iff,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X3: A,Y: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X3 @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) @ A3 )
       => ( ( ( equiv_proj @ A @ A @ R5 @ X3 )
            = ( equiv_proj @ A @ A @ R5 @ Y ) )
          = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y ) @ R5 ) ) ) ) ).

% proj_iff
thf(fact_1572_subset__singleton__iff__Uniq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ? [A5: A] : ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( uniq @ A
        @ ^ [X2: A] : ( member @ A @ X2 @ A3 ) ) ) ).

% subset_singleton_iff_Uniq
thf(fact_1573_alt__ex1E_H,axiom,
    ! [A: $tType,P: A > $o] :
      ( ? [X4: A] :
          ( ( P @ X4 )
          & ! [Y3: A] :
              ( ( P @ Y3 )
             => ( Y3 = X4 ) ) )
     => ~ ( ? [X_1: A] : ( P @ X_1 )
         => ~ ( uniq @ A @ P ) ) ) ).

% alt_ex1E'
thf(fact_1574_ex1__iff__ex__Uniq,axiom,
    ! [A: $tType] :
      ( ( ex1 @ A )
      = ( ^ [P3: A > $o] :
            ( ? [X7: A] : ( P3 @ X7 )
            & ( uniq @ A @ P3 ) ) ) ) ).

% ex1_iff_ex_Uniq
thf(fact_1575_in__quotient__imp__non__empty,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X5: set @ A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A3 @ R5 ) )
       => ( X5
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% in_quotient_imp_non_empty
thf(fact_1576_the__inv__into__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( the_inv_into @ A @ B )
      = ( ^ [A6: set @ A,F3: A > B,X2: B] :
            ( the @ A
            @ ^ [Y2: A] :
                ( ( member @ A @ Y2 @ A6 )
                & ( ( F3 @ Y2 )
                  = X2 ) ) ) ) ) ).

% the_inv_into_def
thf(fact_1577_inj__on__iff__Uniq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( inj_on @ A @ B )
      = ( ^ [F3: A > B,A6: set @ A] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ A6 )
           => ( uniq @ A
              @ ^ [Y2: A] :
                  ( ( member @ A @ Y2 @ A6 )
                  & ( ( F3 @ X2 )
                    = ( F3 @ Y2 ) ) ) ) ) ) ) ).

% inj_on_iff_Uniq
thf(fact_1578_wo__rel_Ominim__def,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( bNF_We6954850376910717587_minim @ A @ R5 @ A3 )
        = ( the @ A @ ( bNF_We4791949203932849705sMinim @ A @ R5 @ A3 ) ) ) ) ).

% wo_rel.minim_def
thf(fact_1579_the1__equality_H,axiom,
    ! [A: $tType,P: A > $o,A4: A] :
      ( ( uniq @ A @ P )
     => ( ( P @ A4 )
       => ( ( the @ A @ P )
          = A4 ) ) ) ).

% the1_equality'
thf(fact_1580_equiv__type,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A )] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5
        @ ( product_Sigma @ A @ A @ A3
          @ ^ [Uu: A] : A3 ) ) ) ).

% equiv_type
thf(fact_1581_equiv__class__self,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),A4: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ A @ A4 @ A3 )
       => ( member @ A @ A4 @ ( image @ A @ A @ R5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% equiv_class_self
thf(fact_1582_quotient__disj,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X5: set @ A,Y4: set @ A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A3 @ R5 ) )
       => ( ( member @ ( set @ A ) @ Y4 @ ( equiv_quotient @ A @ A3 @ R5 ) )
         => ( ( X5 = Y4 )
            | ( ( inf_inf @ ( set @ A ) @ X5 @ Y4 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% quotient_disj
thf(fact_1583_curr__inj,axiom,
    ! [C: $tType,B: $tType,A: $tType,F1: ( product_prod @ A @ B ) > C,A3: set @ A,B2: set @ B,C3: set @ C,F22: ( product_prod @ A @ B ) > C] :
      ( ( member @ ( ( product_prod @ A @ B ) > C ) @ F1
        @ ( bNF_Wellorder_Func @ ( product_prod @ A @ B ) @ C
          @ ( product_Sigma @ A @ B @ A3
            @ ^ [Uu: A] : B2 )
          @ C3 ) )
     => ( ( member @ ( ( product_prod @ A @ B ) > C ) @ F22
          @ ( bNF_Wellorder_Func @ ( product_prod @ A @ B ) @ C
            @ ( product_Sigma @ A @ B @ A3
              @ ^ [Uu: A] : B2 )
            @ C3 ) )
       => ( ( ( bNF_Wellorder_curr @ A @ B @ C @ A3 @ F1 )
            = ( bNF_Wellorder_curr @ A @ B @ C @ A3 @ F22 ) )
          = ( F1 = F22 ) ) ) ) ).

% curr_inj
thf(fact_1584_wo__rel_Ominim__isMinim,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),B2: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ ( field2 @ A @ R5 ) )
       => ( ( B2
           != ( bot_bot @ ( set @ A ) ) )
         => ( bNF_We4791949203932849705sMinim @ A @ R5 @ B2 @ ( bNF_We6954850376910717587_minim @ A @ R5 @ B2 ) ) ) ) ) ).

% wo_rel.minim_isMinim
thf(fact_1585_eq__equiv__class,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A4: A,B3: A,A3: set @ A] :
      ( ( ( image @ A @ A @ R5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( image @ A @ A @ R5 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
     => ( ( equiv_equiv @ A @ A3 @ R5 )
       => ( ( member @ A @ B3 @ A3 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R5 ) ) ) ) ).

% eq_equiv_class
thf(fact_1586_equiv__class__eq,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),A4: A,B3: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R5 )
       => ( ( image @ A @ A @ R5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
          = ( image @ A @ A @ R5 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% equiv_class_eq
thf(fact_1587_eq__equiv__class__iff,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X3: A,Y: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ A @ X3 @ A3 )
       => ( ( member @ A @ Y @ A3 )
         => ( ( ( image @ A @ A @ R5 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( image @ A @ A @ R5 @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y ) @ R5 ) ) ) ) ) ).

% eq_equiv_class_iff
thf(fact_1588_equiv__class__eq__iff,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X3: A,Y: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y ) @ R5 )
        = ( ( ( image @ A @ A @ R5 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
            = ( image @ A @ A @ R5 @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( member @ A @ X3 @ A3 )
          & ( member @ A @ Y @ A3 ) ) ) ) ).

% equiv_class_eq_iff
thf(fact_1589_eq__equiv__class__iff2,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X3: A,Y: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ A @ X3 @ A3 )
       => ( ( member @ A @ Y @ A3 )
         => ( ( ( equiv_quotient @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) @ R5 )
              = ( equiv_quotient @ A @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) @ R5 ) )
            = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y ) @ R5 ) ) ) ) ) ).

% eq_equiv_class_iff2
thf(fact_1590_refines__equiv__class__eq,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A ),A3: set @ A,A4: A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S2 )
     => ( ( equiv_equiv @ A @ A3 @ R )
       => ( ( equiv_equiv @ A @ A3 @ S2 )
         => ( ( image @ A @ A @ R @ ( image @ A @ A @ S2 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( image @ A @ A @ S2 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% refines_equiv_class_eq
thf(fact_1591_refines__equiv__class__eq2,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A ),A3: set @ A,A4: A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S2 )
     => ( ( equiv_equiv @ A @ A3 @ R )
       => ( ( equiv_equiv @ A @ A3 @ S2 )
         => ( ( image @ A @ A @ S2 @ ( image @ A @ A @ R @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( image @ A @ A @ S2 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% refines_equiv_class_eq2
thf(fact_1592_refines__equiv__image__eq,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S2 )
     => ( ( equiv_equiv @ A @ A3 @ R )
       => ( ( equiv_equiv @ A @ A3 @ S2 )
         => ( ( image2 @ ( set @ A ) @ ( set @ A ) @ ( image @ A @ A @ S2 ) @ ( equiv_quotient @ A @ A3 @ R ) )
            = ( equiv_quotient @ A @ A3 @ S2 ) ) ) ) ) ).

% refines_equiv_image_eq
thf(fact_1593_equiv__class__subset,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),A4: A,B3: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R5 )
       => ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ R5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ R5 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% equiv_class_subset
thf(fact_1594_subset__equiv__class,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),B3: A,A4: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ R5 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ R5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( ( member @ A @ B3 @ A3 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R5 ) ) ) ) ).

% subset_equiv_class
thf(fact_1595_equiv__class__nondisjoint,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X3: A,A4: A,B3: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ A @ X3 @ ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ R5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ R5 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R5 ) ) ) ).

% equiv_class_nondisjoint
thf(fact_1596_in__quotient__imp__in__rel,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X5: set @ A,X3: A,Y: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A3 @ R5 ) )
       => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X3 @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) @ X5 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y ) @ R5 ) ) ) ) ).

% in_quotient_imp_in_rel
thf(fact_1597_UN__equiv__class2,axiom,
    ! [A: $tType,C: $tType,B: $tType,A13: set @ A,R12: set @ ( product_prod @ A @ A ),A23: set @ B,R23: set @ ( product_prod @ B @ B ),F2: A > B > ( set @ C ),A14: A,A24: B] :
      ( ( equiv_equiv @ A @ A13 @ R12 )
     => ( ( equiv_equiv @ B @ A23 @ R23 )
       => ( ( equiv_congruent2 @ A @ B @ ( set @ C ) @ R12 @ R23 @ F2 )
         => ( ( member @ A @ A14 @ A13 )
           => ( ( member @ B @ A24 @ A23 )
             => ( ( complete_Sup_Sup @ ( set @ C )
                  @ ( image2 @ A @ ( set @ C )
                    @ ^ [X1: A] : ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ ( F2 @ X1 ) @ ( image @ B @ B @ R23 @ ( insert @ B @ A24 @ ( bot_bot @ ( set @ B ) ) ) ) ) )
                    @ ( image @ A @ A @ R12 @ ( insert @ A @ A14 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                = ( F2 @ A14 @ A24 ) ) ) ) ) ) ) ).

% UN_equiv_class2
thf(fact_1598_UN__equiv__class,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),F2: A > ( set @ B ),A4: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( equiv_congruent @ A @ ( set @ B ) @ R5 @ F2 )
       => ( ( member @ A @ A4 @ A3 )
         => ( ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ F2 @ ( image @ A @ A @ R5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            = ( F2 @ A4 ) ) ) ) ) ).

% UN_equiv_class
thf(fact_1599_UN__equiv__class__inject,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),F2: A > ( set @ B ),X5: set @ A,Y4: set @ A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( equiv_congruent @ A @ ( set @ B ) @ R5 @ F2 )
       => ( ( ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ F2 @ X5 ) )
            = ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ F2 @ Y4 ) ) )
         => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A3 @ R5 ) )
           => ( ( member @ ( set @ A ) @ Y4 @ ( equiv_quotient @ A @ A3 @ R5 ) )
             => ( ! [X: A,Y3: A] :
                    ( ( member @ A @ X @ A3 )
                   => ( ( member @ A @ Y3 @ A3 )
                     => ( ( ( F2 @ X )
                          = ( F2 @ Y3 ) )
                       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R5 ) ) ) )
               => ( X5 = Y4 ) ) ) ) ) ) ) ).

% UN_equiv_class_inject
thf(fact_1600_UN__equiv__class__type2,axiom,
    ! [A: $tType,B: $tType,C: $tType,A13: set @ A,R12: set @ ( product_prod @ A @ A ),A23: set @ B,R23: set @ ( product_prod @ B @ B ),F2: A > B > ( set @ C ),X12: set @ A,X23: set @ B,B2: set @ ( set @ C )] :
      ( ( equiv_equiv @ A @ A13 @ R12 )
     => ( ( equiv_equiv @ B @ A23 @ R23 )
       => ( ( equiv_congruent2 @ A @ B @ ( set @ C ) @ R12 @ R23 @ F2 )
         => ( ( member @ ( set @ A ) @ X12 @ ( equiv_quotient @ A @ A13 @ R12 ) )
           => ( ( member @ ( set @ B ) @ X23 @ ( equiv_quotient @ B @ A23 @ R23 ) )
             => ( ! [X13: A,X24: B] :
                    ( ( member @ A @ X13 @ A13 )
                   => ( ( member @ B @ X24 @ A23 )
                     => ( member @ ( set @ C ) @ ( F2 @ X13 @ X24 ) @ B2 ) ) )
               => ( member @ ( set @ C )
                  @ ( complete_Sup_Sup @ ( set @ C )
                    @ ( image2 @ A @ ( set @ C )
                      @ ^ [X1: A] : ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ ( F2 @ X1 ) @ X23 ) )
                      @ X12 ) )
                  @ B2 ) ) ) ) ) ) ) ).

% UN_equiv_class_type2
thf(fact_1601_UN__equiv__class__type,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),F2: A > ( set @ B ),X5: set @ A,B2: set @ ( set @ B )] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( equiv_congruent @ A @ ( set @ B ) @ R5 @ F2 )
       => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A3 @ R5 ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ A3 )
               => ( member @ ( set @ B ) @ ( F2 @ X ) @ B2 ) )
           => ( member @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ F2 @ X5 ) ) @ B2 ) ) ) ) ) ).

% UN_equiv_class_type
thf(fact_1602_bij__betw__curr,axiom,
    ! [A: $tType,B: $tType,C: $tType,A3: set @ A,B2: set @ B,C3: set @ C] :
      ( bij_betw @ ( ( product_prod @ A @ B ) > C ) @ ( A > B > C ) @ ( bNF_Wellorder_curr @ A @ B @ C @ A3 )
      @ ( bNF_Wellorder_Func @ ( product_prod @ A @ B ) @ C
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 )
        @ C3 )
      @ ( bNF_Wellorder_Func @ A @ ( B > C ) @ A3 @ ( bNF_Wellorder_Func @ B @ C @ B2 @ C3 ) ) ) ).

% bij_betw_curr
thf(fact_1603_disjnt__equiv__class,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),A4: A,B3: A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( disjnt @ A @ ( image @ A @ A @ R5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ R5 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R5 ) ) ) ) ).

% disjnt_equiv_class
thf(fact_1604_congruent2__implies__congruent__UN,axiom,
    ! [B: $tType,C: $tType,A: $tType,A13: set @ A,R12: set @ ( product_prod @ A @ A ),A23: set @ B,R23: set @ ( product_prod @ B @ B ),F2: A > B > ( set @ C ),A4: B] :
      ( ( equiv_equiv @ A @ A13 @ R12 )
     => ( ( equiv_equiv @ B @ A23 @ R23 )
       => ( ( equiv_congruent2 @ A @ B @ ( set @ C ) @ R12 @ R23 @ F2 )
         => ( ( member @ B @ A4 @ A23 )
           => ( equiv_congruent @ A @ ( set @ C ) @ R12
              @ ^ [X1: A] : ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ ( F2 @ X1 ) @ ( image @ B @ B @ R23 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ) ).

% congruent2_implies_congruent_UN
thf(fact_1605_disjnt__self__iff__empty,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( disjnt @ A @ S2 @ S2 )
      = ( S2
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% disjnt_self_iff_empty
thf(fact_1606_disjnt__Times2__iff,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,C3: set @ B,B2: set @ A] :
      ( ( disjnt @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : C3 )
        @ ( product_Sigma @ A @ B @ B2
          @ ^ [Uu: A] : C3 ) )
      = ( ( C3
          = ( bot_bot @ ( set @ B ) ) )
        | ( disjnt @ A @ A3 @ B2 ) ) ) ).

% disjnt_Times2_iff
thf(fact_1607_disjnt__Times1__iff,axiom,
    ! [A: $tType,B: $tType,C3: set @ A,A3: set @ B,B2: set @ B] :
      ( ( disjnt @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ C3
          @ ^ [Uu: A] : A3 )
        @ ( product_Sigma @ A @ B @ C3
          @ ^ [Uu: A] : B2 ) )
      = ( ( C3
          = ( bot_bot @ ( set @ A ) ) )
        | ( disjnt @ B @ A3 @ B2 ) ) ) ).

% disjnt_Times1_iff
thf(fact_1608_bij__betw__empty1,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ ( bot_bot @ ( set @ A ) ) @ A3 )
     => ( A3
        = ( bot_bot @ ( set @ B ) ) ) ) ).

% bij_betw_empty1
thf(fact_1609_bij__betw__empty2,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A] :
      ( ( bij_betw @ A @ B @ F2 @ A3 @ ( bot_bot @ ( set @ B ) ) )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% bij_betw_empty2
thf(fact_1610_disjnt__empty1,axiom,
    ! [A: $tType,A3: set @ A] : ( disjnt @ A @ ( bot_bot @ ( set @ A ) ) @ A3 ) ).

% disjnt_empty1
thf(fact_1611_disjnt__empty2,axiom,
    ! [A: $tType,A3: set @ A] : ( disjnt @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ).

% disjnt_empty2
thf(fact_1612_disjnt__Sigma__iff,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,C3: A > ( set @ B ),B2: set @ A] :
      ( ( disjnt @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ A3 @ C3 ) @ ( product_Sigma @ A @ B @ B2 @ C3 ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
           => ( ( C3 @ X2 )
              = ( bot_bot @ ( set @ B ) ) ) )
        | ( disjnt @ A @ A3 @ B2 ) ) ) ).

% disjnt_Sigma_iff
thf(fact_1613_disjnt__def,axiom,
    ! [A: $tType] :
      ( ( disjnt @ A )
      = ( ^ [A6: set @ A,B5: set @ A] :
            ( ( inf_inf @ ( set @ A ) @ A6 @ B5 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjnt_def
thf(fact_1614_notIn__Un__bij__betw,axiom,
    ! [A: $tType,B: $tType,B3: A,A3: set @ A,F2: A > B,A11: set @ B] :
      ( ~ ( member @ A @ B3 @ A3 )
     => ( ~ ( member @ B @ ( F2 @ B3 ) @ A11 )
       => ( ( bij_betw @ A @ B @ F2 @ A3 @ A11 )
         => ( bij_betw @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( sup_sup @ ( set @ B ) @ A11 @ ( insert @ B @ ( F2 @ B3 ) @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ).

% notIn_Un_bij_betw
thf(fact_1615_notIn__Un__bij__betw3,axiom,
    ! [A: $tType,B: $tType,B3: A,A3: set @ A,F2: A > B,A11: set @ B] :
      ( ~ ( member @ A @ B3 @ A3 )
     => ( ~ ( member @ B @ ( F2 @ B3 ) @ A11 )
       => ( ( bij_betw @ A @ B @ F2 @ A3 @ A11 )
          = ( bij_betw @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( sup_sup @ ( set @ B ) @ A11 @ ( insert @ B @ ( F2 @ B3 ) @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ).

% notIn_Un_bij_betw3
thf(fact_1616_bij__betw__combine,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B2: set @ B,C3: set @ A,D2: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ A3 @ B2 )
     => ( ( bij_betw @ A @ B @ F2 @ C3 @ D2 )
       => ( ( ( inf_inf @ ( set @ B ) @ B2 @ D2 )
            = ( bot_bot @ ( set @ B ) ) )
         => ( bij_betw @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ C3 ) @ ( sup_sup @ ( set @ B ) @ B2 @ D2 ) ) ) ) ) ).

% bij_betw_combine
thf(fact_1617_bij__betw__partition,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,C3: set @ A,B2: set @ B,D2: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ C3 ) @ ( sup_sup @ ( set @ B ) @ B2 @ D2 ) )
     => ( ( bij_betw @ A @ B @ F2 @ C3 @ D2 )
       => ( ( ( inf_inf @ ( set @ A ) @ A3 @ C3 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( ( inf_inf @ ( set @ B ) @ B2 @ D2 )
              = ( bot_bot @ ( set @ B ) ) )
           => ( bij_betw @ A @ B @ F2 @ A3 @ B2 ) ) ) ) ) ).

% bij_betw_partition
thf(fact_1618_disjoint__UN__iff,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: B > ( set @ A ),I: set @ B] :
      ( ( disjnt @ A @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ I ) ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ I )
           => ( disjnt @ A @ A3 @ ( B2 @ X2 ) ) ) ) ) ).

% disjoint_UN_iff
thf(fact_1619_bij__betw__disjoint__Un,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,C3: set @ B,G: A > B,B2: set @ A,D2: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ A3 @ C3 )
     => ( ( bij_betw @ A @ B @ G @ B2 @ D2 )
       => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( ( inf_inf @ ( set @ B ) @ C3 @ D2 )
              = ( bot_bot @ ( set @ B ) ) )
           => ( bij_betw @ A @ B
              @ ^ [X2: A] : ( if @ B @ ( member @ A @ X2 @ A3 ) @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( sup_sup @ ( set @ A ) @ A3 @ B2 )
              @ ( sup_sup @ ( set @ B ) @ C3 @ D2 ) ) ) ) ) ) ).

% bij_betw_disjoint_Un
thf(fact_1620_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I: set @ A,A3: A > ( set @ B ),F2: B > C,A11: A > ( set @ C )] :
      ( ! [I4: A,J5: A] :
          ( ( member @ A @ I4 @ I )
         => ( ( member @ A @ J5 @ I )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I4 ) @ ( A3 @ J5 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J5 ) @ ( A3 @ I4 ) ) ) ) )
     => ( ! [I4: A] :
            ( ( member @ A @ I4 @ I )
           => ( bij_betw @ B @ C @ F2 @ ( A3 @ I4 ) @ ( A11 @ I4 ) ) )
       => ( bij_betw @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ I ) ) @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ A @ ( set @ C ) @ A11 @ I ) ) ) ) ) ).

% bij_betw_UNION_chain
thf(fact_1621_bij__image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > B,B2: C > ( set @ A ),A3: set @ C] :
      ( ( bij_betw @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
     => ( ( image2 @ A @ B @ F2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ C @ ( set @ A ) @ B2 @ A3 ) ) )
        = ( complete_Inf_Inf @ ( set @ B )
          @ ( image2 @ C @ ( set @ B )
            @ ^ [X2: C] : ( image2 @ A @ B @ F2 @ ( B2 @ X2 ) )
            @ A3 ) ) ) ) ).

% bij_image_INT
thf(fact_1622_comp__fun__commute__Pow__fold,axiom,
    ! [A: $tType] :
      ( finite6289374366891150609ommute @ A @ ( set @ ( set @ A ) )
      @ ^ [X2: A,A6: set @ ( set @ A )] : ( sup_sup @ ( set @ ( set @ A ) ) @ A6 @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( insert @ A @ X2 ) @ A6 ) ) ) ).

% comp_fun_commute_Pow_fold
thf(fact_1623_inf__img__fin__dom_H,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( finite_finite2 @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
     => ( ~ ( finite_finite2 @ B @ A3 )
       => ? [X: A] :
            ( ( member @ A @ X @ ( image2 @ B @ A @ F2 @ A3 ) )
            & ~ ( finite_finite2 @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ A3 ) ) ) ) ) ).

% inf_img_fin_dom'
thf(fact_1624_inf__img__fin__domE_H,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( finite_finite2 @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
     => ( ~ ( finite_finite2 @ B @ A3 )
       => ~ ! [Y3: A] :
              ( ( member @ A @ Y3 @ ( image2 @ B @ A @ F2 @ A3 ) )
             => ( finite_finite2 @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) @ A3 ) ) ) ) ) ).

% inf_img_fin_domE'
thf(fact_1625_finite__reachable__advance,axiom,
    ! [A: $tType,E3: set @ ( product_prod @ A @ A ),V0: A,V: A] :
      ( ( finite_finite2 @ A @ ( image @ A @ A @ ( transitive_rtrancl @ A @ E3 ) @ ( insert @ A @ V0 @ ( bot_bot @ ( set @ A ) ) ) ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V0 @ V ) @ ( transitive_rtrancl @ A @ E3 ) )
       => ( finite_finite2 @ A @ ( image @ A @ A @ ( transitive_rtrancl @ A @ E3 ) @ ( insert @ A @ V @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% finite_reachable_advance
thf(fact_1626_mono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit1013018076250108175_below @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image2 @ A @ B @ F2 @ A3 ) ) ) ) ) ) ) ).

% mono_cInf
thf(fact_1627_mono__cINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A3: C > A,I: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ C @ A @ A3 @ I ) )
           => ( ( I
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image2 @ C @ A @ A3 @ I ) ) )
                @ ( complete_Inf_Inf @ B
                  @ ( image2 @ C @ B
                    @ ^ [X2: C] : ( F2 @ ( A3 @ X2 ) )
                    @ I ) ) ) ) ) ) ) ).

% mono_cINF
thf(fact_1628_mono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image2 @ A @ B @ F2 @ A3 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ) ).

% mono_cSup
thf(fact_1629_mono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A3: C > A,I: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ C @ A @ A3 @ I ) )
           => ( ( I
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B
                @ ( complete_Sup_Sup @ B
                  @ ( image2 @ C @ B
                    @ ^ [X2: C] : ( F2 @ ( A3 @ X2 ) )
                    @ I ) )
                @ ( F2 @ ( complete_Sup_Sup @ A @ ( image2 @ C @ A @ A3 @ I ) ) ) ) ) ) ) ) ).

% mono_cSUP
thf(fact_1630_finite__Collect__disjI,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
              | ( Q @ X2 ) ) ) )
      = ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
        & ( finite_finite2 @ A @ ( collect @ A @ Q ) ) ) ) ).

% finite_Collect_disjI
thf(fact_1631_finite__Collect__conjI,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
        | ( finite_finite2 @ A @ ( collect @ A @ Q ) ) )
     => ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
              & ( Q @ X2 ) ) ) ) ) ).

% finite_Collect_conjI
thf(fact_1632_finite__Int,axiom,
    ! [A: $tType,F: set @ A,G4: set @ A] :
      ( ( ( finite_finite2 @ A @ F )
        | ( finite_finite2 @ A @ G4 ) )
     => ( finite_finite2 @ A @ ( inf_inf @ ( set @ A ) @ F @ G4 ) ) ) ).

% finite_Int
thf(fact_1633_finite__Collect__bounded__ex,axiom,
    ! [B: $tType,A: $tType,P: A > $o,Q: B > A > $o] :
      ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
     => ( ( finite_finite2 @ B
          @ ( collect @ B
            @ ^ [X2: B] :
              ? [Y2: A] :
                ( ( P @ Y2 )
                & ( Q @ X2 @ Y2 ) ) ) )
        = ( ! [Y2: A] :
              ( ( P @ Y2 )
             => ( finite_finite2 @ B
                @ ( collect @ B
                  @ ^ [X2: B] : ( Q @ X2 @ Y2 ) ) ) ) ) ) ) ).

% finite_Collect_bounded_ex
thf(fact_1634_finite__Collect__subsets,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( finite_finite2 @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B5: set @ A] : ( ord_less_eq @ ( set @ A ) @ B5 @ A3 ) ) ) ) ).

% finite_Collect_subsets
thf(fact_1635_finite__Collect__not,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
     => ( ( finite_finite2 @ A
          @ ( collect @ A
            @ ^ [X2: A] :
                ~ ( P @ X2 ) ) )
        = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_Collect_not
thf(fact_1636_finite__SigmaI,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: A > ( set @ B )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ! [A7: A] :
            ( ( member @ A @ A7 @ A3 )
           => ( finite_finite2 @ B @ ( B2 @ A7 ) ) )
       => ( finite_finite2 @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ A3 @ B2 ) ) ) ) ).

% finite_SigmaI
thf(fact_1637_finite__UN__I,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: A > ( set @ B )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ! [A7: A] :
            ( ( member @ A @ A7 @ A3 )
           => ( finite_finite2 @ B @ ( B2 @ A7 ) ) )
       => ( finite_finite2 @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ B2 @ A3 ) ) ) ) ) ).

% finite_UN_I
thf(fact_1638_finite__INT,axiom,
    ! [B: $tType,A: $tType,I: set @ A,A3: A > ( set @ B )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ I )
          & ( finite_finite2 @ B @ ( A3 @ X4 ) ) )
     => ( finite_finite2 @ B @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ I ) ) ) ) ).

% finite_INT
thf(fact_1639_bdd__above__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [I: set @ B,A3: B > ( set @ A )] :
          ( ( finite_finite2 @ B @ I )
         => ( ( condit941137186595557371_above @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) )
            = ( ! [X2: B] :
                  ( ( member @ B @ X2 @ I )
                 => ( condit941137186595557371_above @ A @ ( A3 @ X2 ) ) ) ) ) ) ) ).

% bdd_above_UN
thf(fact_1640_bdd__below__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [I: set @ B,A3: B > ( set @ A )] :
          ( ( finite_finite2 @ B @ I )
         => ( ( condit1013018076250108175_below @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) )
            = ( ! [X2: B] :
                  ( ( member @ B @ X2 @ I )
                 => ( condit1013018076250108175_below @ A @ ( A3 @ X2 ) ) ) ) ) ) ) ).

% bdd_below_UN
thf(fact_1641_finite__if__eq__beyond__finite,axiom,
    ! [A: $tType,S2: set @ A,S5: set @ A] :
      ( ( finite_finite2 @ A @ S2 )
     => ( finite_finite2 @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [S: set @ A] :
              ( ( minus_minus @ ( set @ A ) @ S @ S2 )
              = ( minus_minus @ ( set @ A ) @ S5 @ S2 ) ) ) ) ) ).

% finite_if_eq_beyond_finite
thf(fact_1642_not__finite__existsD,axiom,
    ! [A: $tType,P: A > $o] :
      ( ~ ( finite_finite2 @ A @ ( collect @ A @ P ) )
     => ? [X_1: A] : ( P @ X_1 ) ) ).

% not_finite_existsD
thf(fact_1643_pigeonhole__infinite__rel,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B,R: A > B > $o] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ B @ B2 )
       => ( ! [X: A] :
              ( ( member @ A @ X @ A3 )
             => ? [Xa3: B] :
                  ( ( member @ B @ Xa3 @ B2 )
                  & ( R @ X @ Xa3 ) ) )
         => ? [X: B] :
              ( ( member @ B @ X @ B2 )
              & ~ ( finite_finite2 @ A
                  @ ( collect @ A
                    @ ^ [A5: A] :
                        ( ( member @ A @ A5 @ A3 )
                        & ( R @ A5 @ X ) ) ) ) ) ) ) ) ).

% pigeonhole_infinite_rel
thf(fact_1644_finite__cartesian__product,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ B @ B2 )
       => ( finite_finite2 @ ( product_prod @ A @ B )
          @ ( product_Sigma @ A @ B @ A3
            @ ^ [Uu: A] : B2 ) ) ) ) ).

% finite_cartesian_product
thf(fact_1645_comp__fun__commute__const,axiom,
    ! [B: $tType,A: $tType,F2: B > B] :
      ( finite6289374366891150609ommute @ A @ B
      @ ^ [Uu: A] : F2 ) ).

% comp_fun_commute_const
thf(fact_1646_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X3 @ Y )
           => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) ) ) ) ).

% monoD
thf(fact_1647_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X3 @ Y )
           => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) ) ) ) ) ).

% monoE
thf(fact_1648_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X: A,Y3: A] :
              ( ( ord_less_eq @ A @ X @ Y3 )
             => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% monoI
thf(fact_1649_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
             => ( ord_less_eq @ B @ ( F3 @ X2 ) @ ( F3 @ Y2 ) ) ) ) ) ) ).

% mono_def
thf(fact_1650_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A4: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A4 ) ) ) ).

% mono_add
thf(fact_1651_finite_OemptyI,axiom,
    ! [A: $tType] : ( finite_finite2 @ A @ ( bot_bot @ ( set @ A ) ) ) ).

% finite.emptyI
thf(fact_1652_infinite__imp__nonempty,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ~ ( finite_finite2 @ A @ S2 )
     => ( S2
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% infinite_imp_nonempty
thf(fact_1653_finite__SigmaI2,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: A > ( set @ B )] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] :
              ( ( member @ A @ X2 @ A3 )
              & ( ( B2 @ X2 )
               != ( bot_bot @ ( set @ B ) ) ) ) ) )
     => ( ! [A7: A] :
            ( ( member @ A @ A7 @ A3 )
           => ( finite_finite2 @ B @ ( B2 @ A7 ) ) )
       => ( finite_finite2 @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ A3 @ B2 ) ) ) ) ).

% finite_SigmaI2
thf(fact_1654_finite__cartesian__productD1,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B] :
      ( ( finite_finite2 @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 ) )
     => ( ( B2
         != ( bot_bot @ ( set @ B ) ) )
       => ( finite_finite2 @ A @ A3 ) ) ) ).

% finite_cartesian_productD1
thf(fact_1655_finite__cartesian__productD2,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B] :
      ( ( finite_finite2 @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 ) )
     => ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
       => ( finite_finite2 @ B @ B2 ) ) ) ).

% finite_cartesian_productD2
thf(fact_1656_finite__cartesian__product__iff,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B] :
      ( ( finite_finite2 @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( B2
          = ( bot_bot @ ( set @ B ) ) )
        | ( ( finite_finite2 @ A @ A3 )
          & ( finite_finite2 @ B @ B2 ) ) ) ) ).

% finite_cartesian_product_iff
thf(fact_1657_pigeonhole__infinite,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ B @ ( image2 @ A @ B @ F2 @ A3 ) )
       => ? [X: A] :
            ( ( member @ A @ X @ A3 )
            & ~ ( finite_finite2 @ A
                @ ( collect @ A
                  @ ^ [A5: A] :
                      ( ( member @ A @ A5 @ A3 )
                      & ( ( F2 @ A5 )
                        = ( F2 @ X ) ) ) ) ) ) ) ) ).

% pigeonhole_infinite
thf(fact_1658_finite__image__set2,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: A > $o,Q: B > $o,F2: A > B > C] :
      ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
     => ( ( finite_finite2 @ B @ ( collect @ B @ Q ) )
       => ( finite_finite2 @ C
          @ ( collect @ C
            @ ^ [Uu: C] :
              ? [X2: A,Y2: B] :
                ( ( Uu
                  = ( F2 @ X2 @ Y2 ) )
                & ( P @ X2 )
                & ( Q @ Y2 ) ) ) ) ) ) ).

% finite_image_set2
thf(fact_1659_finite__image__set,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: A > B] :
      ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
     => ( finite_finite2 @ B
        @ ( collect @ B
          @ ^ [Uu: B] :
            ? [X2: A] :
              ( ( Uu
                = ( F2 @ X2 ) )
              & ( P @ X2 ) ) ) ) ) ).

% finite_image_set
thf(fact_1660_INF__filter__not__bot,axiom,
    ! [I6: $tType,A: $tType,B2: set @ I6,F: I6 > ( filter @ A )] :
      ( ! [X8: set @ I6] :
          ( ( ord_less_eq @ ( set @ I6 ) @ X8 @ B2 )
         => ( ( finite_finite2 @ I6 @ X8 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image2 @ I6 @ ( filter @ A ) @ F @ X8 ) )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image2 @ I6 @ ( filter @ A ) @ F @ B2 ) )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% INF_filter_not_bot
thf(fact_1661_finite__inverse__image__gen,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F2: B > A,D2: set @ B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( inj_on @ B @ A @ F2 @ D2 )
       => ( finite_finite2 @ B
          @ ( collect @ B
            @ ^ [J3: B] :
                ( ( member @ B @ J3 @ D2 )
                & ( member @ A @ ( F2 @ J3 ) @ A3 ) ) ) ) ) ) ).

% finite_inverse_image_gen
thf(fact_1662_rtranclp_Omono,axiom,
    ! [A: $tType,R5: A > A > $o] :
      ( order_mono @ ( A > A > $o ) @ ( A > A > $o )
      @ ^ [P6: A > A > $o,X1: A,X22: A] :
          ( ? [A5: A] :
              ( ( X1 = A5 )
              & ( X22 = A5 ) )
          | ? [A5: A,B4: A,C5: A] :
              ( ( X1 = A5 )
              & ( X22 = C5 )
              & ( P6 @ A5 @ B4 )
              & ( R5 @ B4 @ C5 ) ) ) ) ).

% rtranclp.mono
thf(fact_1663_tranclp_Omono,axiom,
    ! [A: $tType,R5: A > A > $o] :
      ( order_mono @ ( A > A > $o ) @ ( A > A > $o )
      @ ^ [P6: A > A > $o,X1: A,X22: A] :
          ( ? [A5: A,B4: A] :
              ( ( X1 = A5 )
              & ( X22 = B4 )
              & ( R5 @ A5 @ B4 ) )
          | ? [A5: A,B4: A,C5: A] :
              ( ( X1 = A5 )
              & ( X22 = C5 )
              & ( P6 @ A5 @ B4 )
              & ( R5 @ B4 @ C5 ) ) ) ) ).

% tranclp.mono
thf(fact_1664_finite__update__induct,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C2: B,P: ( A > B ) > $o] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [A5: A] :
              ( ( F2 @ A5 )
             != C2 ) ) )
     => ( ( P
          @ ^ [A5: A] : C2 )
       => ( ! [A7: A,B6: B,F9: A > B] :
              ( ( finite_finite2 @ A
                @ ( collect @ A
                  @ ^ [C5: A] :
                      ( ( F9 @ C5 )
                     != C2 ) ) )
             => ( ( ( F9 @ A7 )
                  = C2 )
               => ( ( B6 != C2 )
                 => ( ( P @ F9 )
                   => ( P @ ( fun_upd @ A @ B @ F9 @ A7 @ B6 ) ) ) ) ) )
         => ( P @ F2 ) ) ) ) ).

% finite_update_induct
thf(fact_1665_finite__quotient,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) )
       => ( finite_finite2 @ ( set @ A ) @ ( equiv_quotient @ A @ A3 @ R5 ) ) ) ) ).

% finite_quotient
thf(fact_1666_mono__Int,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A3: set @ A,B2: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) @ ( inf_inf @ ( set @ B ) @ ( F2 @ A3 ) @ ( F2 @ B2 ) ) ) ) ).

% mono_Int
thf(fact_1667_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F2: A > B,A3: A,B2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inf_inf @ A @ A3 @ B2 ) ) @ ( inf_inf @ B @ ( F2 @ A3 ) @ ( F2 @ B2 ) ) ) ) ) ).

% mono_inf
thf(fact_1668_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F2: A > B,A3: A,B2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F2 @ A3 ) @ ( F2 @ B2 ) ) @ ( F2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ) ).

% mono_sup
thf(fact_1669_comp__fun__commute__filter__fold,axiom,
    ! [A: $tType,P: A > $o] :
      ( finite6289374366891150609ommute @ A @ ( set @ A )
      @ ^ [X2: A,A15: set @ A] : ( if @ ( set @ A ) @ ( P @ X2 ) @ ( insert @ A @ X2 @ A15 ) @ A15 ) ) ).

% comp_fun_commute_filter_fold
thf(fact_1670_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X: A] :
                ( ( member @ A @ X @ A3 )
                & ! [Xa3: A] :
                    ( ( member @ A @ Xa3 @ A3 )
                   => ( ( ord_less_eq @ A @ X @ Xa3 )
                     => ( X = Xa3 ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_1671_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X: A] :
                ( ( member @ A @ X @ A3 )
                & ! [Xa3: A] :
                    ( ( member @ A @ Xa3 @ A3 )
                   => ( ( ord_less_eq @ A @ Xa3 @ X )
                     => ( X = Xa3 ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_1672_finite_Ocases,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite2 @ A @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ! [A12: set @ A] :
              ( ? [A7: A] :
                  ( A4
                  = ( insert @ A @ A7 @ A12 ) )
             => ~ ( finite_finite2 @ A @ A12 ) ) ) ) ).

% finite.cases
thf(fact_1673_finite_Osimps,axiom,
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( ^ [A5: set @ A] :
            ( ( A5
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A6: set @ A,B4: A] :
                ( ( A5
                  = ( insert @ A @ B4 @ A6 ) )
                & ( finite_finite2 @ A @ A6 ) ) ) ) ) ).

% finite.simps
thf(fact_1674_finite__induct,axiom,
    ! [A: $tType,F: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite2 @ A @ F )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X: A,F7: set @ A] :
              ( ( finite_finite2 @ A @ F7 )
             => ( ~ ( member @ A @ X @ F7 )
               => ( ( P @ F7 )
                 => ( P @ ( insert @ A @ X @ F7 ) ) ) ) )
         => ( P @ F ) ) ) ) ).

% finite_induct
thf(fact_1675_finite__ne__induct,axiom,
    ! [A: $tType,F: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite2 @ A @ F )
     => ( ( F
         != ( bot_bot @ ( set @ A ) ) )
       => ( ! [X: A] : ( P @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ! [X: A,F7: set @ A] :
                ( ( finite_finite2 @ A @ F7 )
               => ( ( F7
                   != ( bot_bot @ ( set @ A ) ) )
                 => ( ~ ( member @ A @ X @ F7 )
                   => ( ( P @ F7 )
                     => ( P @ ( insert @ A @ X @ F7 ) ) ) ) ) )
           => ( P @ F ) ) ) ) ) ).

% finite_ne_induct
thf(fact_1676_infinite__finite__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,A3: set @ A] :
      ( ! [A12: set @ A] :
          ( ~ ( finite_finite2 @ A @ A12 )
         => ( P @ A12 ) )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X: A,F7: set @ A] :
              ( ( finite_finite2 @ A @ F7 )
             => ( ~ ( member @ A @ X @ F7 )
               => ( ( P @ F7 )
                 => ( P @ ( insert @ A @ X @ F7 ) ) ) ) )
         => ( P @ A3 ) ) ) ) ).

% infinite_finite_induct
thf(fact_1677_finite__range__imageI,axiom,
    ! [C: $tType,A: $tType,B: $tType,G: B > A,F2: A > C] :
      ( ( finite_finite2 @ A @ ( image2 @ B @ A @ G @ ( top_top @ ( set @ B ) ) ) )
     => ( finite_finite2 @ C
        @ ( image2 @ B @ C
          @ ^ [X2: B] : ( F2 @ ( G @ X2 ) )
          @ ( top_top @ ( set @ B ) ) ) ) ) ).

% finite_range_imageI
thf(fact_1678_finite__Collect,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: B > A] :
      ( ( finite_finite2 @ A @ S2 )
     => ( ( inj_on @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ B
          @ ( collect @ B
            @ ^ [A5: B] : ( member @ A @ ( F2 @ A5 ) @ S2 ) ) ) ) ) ).

% finite_Collect
thf(fact_1679_finite__inverse__image,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F2: B > A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( inj_on @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ B
          @ ( collect @ B
            @ ^ [J3: B] : ( member @ A @ ( F2 @ J3 ) @ A3 ) ) ) ) ) ).

% finite_inverse_image
thf(fact_1680_Rings_Omono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A4 ) ) ) ) ).

% Rings.mono_mult
thf(fact_1681_finite__subset__induct,axiom,
    ! [A: $tType,F: set @ A,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite2 @ A @ F )
     => ( ( ord_less_eq @ ( set @ A ) @ F @ A3 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A7: A,F7: set @ A] :
                ( ( finite_finite2 @ A @ F7 )
               => ( ( member @ A @ A7 @ A3 )
                 => ( ~ ( member @ A @ A7 @ F7 )
                   => ( ( P @ F7 )
                     => ( P @ ( insert @ A @ A7 @ F7 ) ) ) ) ) )
           => ( P @ F ) ) ) ) ) ).

% finite_subset_induct
thf(fact_1682_finite__subset__induct_H,axiom,
    ! [A: $tType,F: set @ A,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite2 @ A @ F )
     => ( ( ord_less_eq @ ( set @ A ) @ F @ A3 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A7: A,F7: set @ A] :
                ( ( finite_finite2 @ A @ F7 )
               => ( ( member @ A @ A7 @ A3 )
                 => ( ( ord_less_eq @ ( set @ A ) @ F7 @ A3 )
                   => ( ~ ( member @ A @ A7 @ F7 )
                     => ( ( P @ F7 )
                       => ( P @ ( insert @ A @ A7 @ F7 ) ) ) ) ) ) )
           => ( P @ F ) ) ) ) ) ).

% finite_subset_induct'
thf(fact_1683_finite__Sup__in,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X: A,Y3: A] :
                  ( ( member @ A @ X @ A3 )
                 => ( ( member @ A @ Y3 @ A3 )
                   => ( member @ A @ ( sup_sup @ A @ X @ Y3 ) @ A3 ) ) )
             => ( member @ A @ ( complete_Sup_Sup @ A @ A3 ) @ A3 ) ) ) ) ) ).

% finite_Sup_in
thf(fact_1684_finite__Inf__in,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X: A,Y3: A] :
                  ( ( member @ A @ X @ A3 )
                 => ( ( member @ A @ Y3 @ A3 )
                   => ( member @ A @ ( inf_inf @ A @ X @ Y3 ) @ A3 ) ) )
             => ( member @ A @ ( complete_Inf_Inf @ A @ A3 ) @ A3 ) ) ) ) ) ).

% finite_Inf_in
thf(fact_1685_infinite__remove,axiom,
    ! [A: $tType,S2: set @ A,A4: A] :
      ( ~ ( finite_finite2 @ A @ S2 )
     => ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_remove
thf(fact_1686_infinite__coinduct,axiom,
    ! [A: $tType,X5: ( set @ A ) > $o,A3: set @ A] :
      ( ( X5 @ A3 )
     => ( ! [A12: set @ A] :
            ( ( X5 @ A12 )
           => ? [X4: A] :
                ( ( member @ A @ X4 @ A12 )
                & ( ( X5 @ ( minus_minus @ ( set @ A ) @ A12 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  | ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A12 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
       => ~ ( finite_finite2 @ A @ A3 ) ) ) ).

% infinite_coinduct
thf(fact_1687_finite__empty__induct,axiom,
    ! [A: $tType,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( P @ A3 )
       => ( ! [A7: A,A12: set @ A] :
              ( ( finite_finite2 @ A @ A12 )
             => ( ( member @ A @ A7 @ A12 )
               => ( ( P @ A12 )
                 => ( P @ ( minus_minus @ ( set @ A ) @ A12 @ ( insert @ A @ A7 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
         => ( P @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% finite_empty_induct
thf(fact_1688_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image2 @ A @ B @ F2 @ A3 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% mono_Sup
thf(fact_1689_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: C > A,I: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image2 @ C @ B
                @ ^ [X2: C] : ( F2 @ ( A3 @ X2 ) )
                @ I ) )
            @ ( F2 @ ( complete_Sup_Sup @ A @ ( image2 @ C @ A @ A3 @ I ) ) ) ) ) ) ).

% mono_SUP
thf(fact_1690_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image2 @ A @ B @ F2 @ A3 ) ) ) ) ) ).

% mono_Inf
thf(fact_1691_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: C > A,I: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image2 @ C @ A @ A3 @ I ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image2 @ C @ B
                @ ^ [X2: C] : ( F2 @ ( A3 @ X2 ) )
                @ I ) ) ) ) ) ).

% mono_INF
thf(fact_1692_finite__vimage__IntI,axiom,
    ! [A: $tType,B: $tType,F: set @ A,H2: B > A,A3: set @ B] :
      ( ( finite_finite2 @ A @ F )
     => ( ( inj_on @ B @ A @ H2 @ A3 )
       => ( finite_finite2 @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ H2 @ F ) @ A3 ) ) ) ) ).

% finite_vimage_IntI
thf(fact_1693_finite__equiv__class,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X5: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) )
       => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A3 @ R5 ) )
         => ( finite_finite2 @ A @ X5 ) ) ) ) ).

% finite_equiv_class
thf(fact_1694_remove__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,B2: set @ A] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite2 @ A @ B2 )
         => ( P @ B2 ) )
       => ( ! [A12: set @ A] :
              ( ( finite_finite2 @ A @ A12 )
             => ( ( A12
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A12 @ B2 )
                 => ( ! [X4: A] :
                        ( ( member @ A @ X4 @ A12 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A12 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A12 ) ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% remove_induct
thf(fact_1695_finite__remove__induct,axiom,
    ! [A: $tType,B2: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite2 @ A @ B2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A12: set @ A] :
              ( ( finite_finite2 @ A @ A12 )
             => ( ( A12
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A12 @ B2 )
                 => ( ! [X4: A] :
                        ( ( member @ A @ X4 @ A12 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A12 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A12 ) ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% finite_remove_induct
thf(fact_1696_inf__img__fin__domE,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ B] :
      ( ( finite_finite2 @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
     => ( ~ ( finite_finite2 @ B @ A3 )
       => ~ ! [Y3: A] :
              ( ( member @ A @ Y3 @ ( image2 @ B @ A @ F2 @ A3 ) )
             => ( finite_finite2 @ B @ ( vimage @ B @ A @ F2 @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% inf_img_fin_domE
thf(fact_1697_inf__img__fin__dom,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ B] :
      ( ( finite_finite2 @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
     => ( ~ ( finite_finite2 @ B @ A3 )
       => ? [X: A] :
            ( ( member @ A @ X @ ( image2 @ B @ A @ F2 @ A3 ) )
            & ~ ( finite_finite2 @ B @ ( vimage @ B @ A @ F2 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% inf_img_fin_dom
thf(fact_1698_infinite__imp__bij__betw2,axiom,
    ! [A: $tType,A3: set @ A,A4: A] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ? [H4: A > A] : ( bij_betw @ A @ A @ H4 @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_imp_bij_betw2
thf(fact_1699_infinite__imp__bij__betw,axiom,
    ! [A: $tType,A3: set @ A,A4: A] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ? [H4: A > A] : ( bij_betw @ A @ A @ H4 @ A3 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_imp_bij_betw
thf(fact_1700_finite__finite__vimage__IntI,axiom,
    ! [A: $tType,B: $tType,F: set @ A,H2: B > A,A3: set @ B] :
      ( ( finite_finite2 @ A @ F )
     => ( ! [Y3: A] :
            ( ( member @ A @ Y3 @ F )
           => ( finite_finite2 @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ H2 @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) @ A3 ) ) )
       => ( finite_finite2 @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ H2 @ F ) @ A3 ) ) ) ) ).

% finite_finite_vimage_IntI
thf(fact_1701_finite_Omono,axiom,
    ! [A: $tType] :
      ( order_mono @ ( ( set @ A ) > $o ) @ ( ( set @ A ) > $o )
      @ ^ [P6: ( set @ A ) > $o,X2: set @ A] :
          ( ( X2
            = ( bot_bot @ ( set @ A ) ) )
          | ? [A6: set @ A,A5: A] :
              ( ( X2
                = ( insert @ A @ A5 @ A6 ) )
              & ( P6 @ A6 ) ) ) ) ).

% finite.mono
thf(fact_1702_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S2: set @ B,P: ( set @ B ) > $o,F2: B > A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X: B,S8: set @ B] :
                  ( ( finite_finite2 @ B @ S8 )
                 => ( ! [Y7: B] :
                        ( ( member @ B @ Y7 @ S8 )
                       => ( ord_less_eq @ A @ ( F2 @ Y7 ) @ ( F2 @ X ) ) )
                   => ( ( P @ S8 )
                     => ( P @ ( insert @ B @ X @ S8 ) ) ) ) )
             => ( P @ S2 ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_1703_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I: set @ B,X3: B > A,Y: B > A] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [I2: B] :
                  ( ( member @ B @ I2 @ I )
                  & ( ( X3 @ I2 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [I2: B] :
                    ( ( member @ B @ I2 @ I )
                    & ( ( Y @ I2 )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [I2: B] :
                    ( ( member @ B @ I2 @ I )
                    & ( ( times_times @ A @ ( X3 @ I2 ) @ ( Y @ I2 ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_1704_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I: set @ B,X3: B > A,Y: B > A] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [I2: B] :
                  ( ( member @ B @ I2 @ I )
                  & ( ( X3 @ I2 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [I2: B] :
                    ( ( member @ B @ I2 @ I )
                    & ( ( Y @ I2 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [I2: B] :
                    ( ( member @ B @ I2 @ I )
                    & ( ( plus_plus @ A @ ( X3 @ I2 ) @ ( Y @ I2 ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_1705_Pow__fold,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( pow @ A @ A3 )
        = ( finite_fold @ A @ ( set @ ( set @ A ) )
          @ ^ [X2: A,A6: set @ ( set @ A )] : ( sup_sup @ ( set @ ( set @ A ) ) @ A6 @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( insert @ A @ X2 ) @ A6 ) )
          @ ( insert @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) )
          @ A3 ) ) ) ).

% Pow_fold
thf(fact_1706_infinite__cartesian__product,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ~ ( finite_finite2 @ B @ B2 )
       => ~ ( finite_finite2 @ ( product_prod @ A @ B )
            @ ( product_Sigma @ A @ B @ A3
              @ ^ [Uu: A] : B2 ) ) ) ) ).

% infinite_cartesian_product
thf(fact_1707_fold__union__pair,axiom,
    ! [B: $tType,A: $tType,B2: set @ A,X3: B,A3: set @ ( product_prod @ B @ A )] :
      ( ( finite_finite2 @ A @ B2 )
     => ( ( sup_sup @ ( set @ ( product_prod @ B @ A ) )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ A ) )
            @ ( image2 @ A @ ( set @ ( product_prod @ B @ A ) )
              @ ^ [Y2: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X3 @ Y2 ) @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) )
              @ B2 ) )
          @ A3 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
          @ ^ [Y2: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X3 @ Y2 ) )
          @ A3
          @ B2 ) ) ) ).

% fold_union_pair
thf(fact_1708_Fpow__Pow__finite,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A6: set @ A] : ( inf_inf @ ( set @ ( set @ A ) ) @ ( pow @ A @ A6 ) @ ( collect @ ( set @ A ) @ ( finite_finite2 @ A ) ) ) ) ) ).

% Fpow_Pow_finite
thf(fact_1709_finite__transitivity__chain,axiom,
    ! [A: $tType,A3: set @ A,R: A > A > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ! [X: A] :
            ~ ( R @ X @ X )
       => ( ! [X: A,Y3: A,Z4: A] :
              ( ( R @ X @ Y3 )
             => ( ( R @ Y3 @ Z4 )
               => ( R @ X @ Z4 ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ A3 )
               => ? [Y7: A] :
                    ( ( member @ A @ Y7 @ A3 )
                    & ( R @ X @ Y7 ) ) )
           => ( A3
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% finite_transitivity_chain
thf(fact_1710_fold__empty,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,Z2: A] :
      ( ( finite_fold @ B @ A @ F2 @ Z2 @ ( bot_bot @ ( set @ B ) ) )
      = Z2 ) ).

% fold_empty
thf(fact_1711_mono__compose,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ C ) )
     => ! [Q: A > B > C,F2: D > B] :
          ( ( order_mono @ A @ ( B > C ) @ Q )
         => ( order_mono @ A @ ( D > C )
            @ ^ [I2: A,X2: D] : ( Q @ I2 @ ( F2 @ X2 ) ) ) ) ) ).

% mono_compose
thf(fact_1712_Inf__filter__not__bot,axiom,
    ! [A: $tType,B2: set @ ( filter @ A )] :
      ( ! [X8: set @ ( filter @ A )] :
          ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X8 @ B2 )
         => ( ( finite_finite2 @ ( filter @ A ) @ X8 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ X8 )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ B2 )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% Inf_filter_not_bot
thf(fact_1713_INF__filter__bot__base,axiom,
    ! [B: $tType,A: $tType,I: set @ A,F: A > ( filter @ B )] :
      ( ! [I4: A] :
          ( ( member @ A @ I4 @ I )
         => ! [J5: A] :
              ( ( member @ A @ J5 @ I )
             => ? [X4: A] :
                  ( ( member @ A @ X4 @ I )
                  & ( ord_less_eq @ ( filter @ B ) @ ( F @ X4 ) @ ( inf_inf @ ( filter @ B ) @ ( F @ I4 ) @ ( F @ J5 ) ) ) ) ) )
     => ( ( ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ A @ ( filter @ B ) @ F @ I ) )
          = ( bot_bot @ ( filter @ B ) ) )
        = ( ? [X2: A] :
              ( ( member @ A @ X2 @ I )
              & ( ( F @ X2 )
                = ( bot_bot @ ( filter @ B ) ) ) ) ) ) ) ).

% INF_filter_bot_base
thf(fact_1714_comp__fun__commute__relcomp__fold,axiom,
    ! [A: $tType,B: $tType,C: $tType,S2: set @ ( product_prod @ A @ B )] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ S2 )
     => ( finite6289374366891150609ommute @ ( product_prod @ C @ A ) @ ( set @ ( product_prod @ C @ B ) )
        @ ( product_case_prod @ C @ A @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
          @ ^ [X2: C,Y2: A,A6: set @ ( product_prod @ C @ B )] :
              ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
              @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
                @ ^ [W3: A,Z3: B,A15: set @ ( product_prod @ C @ B )] : ( if @ ( set @ ( product_prod @ C @ B ) ) @ ( Y2 = W3 ) @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ X2 @ Z3 ) @ A15 ) @ A15 ) )
              @ A6
              @ S2 ) ) ) ) ).

% comp_fun_commute_relcomp_fold
thf(fact_1715_comp__fun__commute__product__fold,axiom,
    ! [A: $tType,B: $tType,B2: set @ A] :
      ( ( finite_finite2 @ A @ B2 )
     => ( finite6289374366891150609ommute @ B @ ( set @ ( product_prod @ B @ A ) )
        @ ^ [X2: B,Z3: set @ ( product_prod @ B @ A )] :
            ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
            @ ^ [Y2: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y2 ) )
            @ Z3
            @ B2 ) ) ) ).

% comp_fun_commute_product_fold
thf(fact_1716_comp__fun__commute__Image__fold,axiom,
    ! [B: $tType,A: $tType,S2: set @ A] :
      ( finite6289374366891150609ommute @ ( product_prod @ A @ B ) @ ( set @ B )
      @ ( product_case_prod @ A @ B @ ( ( set @ B ) > ( set @ B ) )
        @ ^ [X2: A,Y2: B,A6: set @ B] : ( if @ ( set @ B ) @ ( member @ A @ X2 @ S2 ) @ ( insert @ B @ Y2 @ A6 ) @ A6 ) ) ) ).

% comp_fun_commute_Image_fold
thf(fact_1717_empty__in__Fpow,axiom,
    ! [A: $tType,A3: set @ A] : ( member @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( finite_Fpow @ A @ A3 ) ) ).

% empty_in_Fpow
thf(fact_1718_Fpow__not__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_Fpow @ A @ A3 )
     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ).

% Fpow_not_empty
thf(fact_1719_inf__Inf__fold__inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B2: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A3 ) @ B2 )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ B2 @ A3 ) ) ) ) ).

% inf_Inf_fold_inf
thf(fact_1720_Sup__fold__sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( complete_Sup_Sup @ A @ A3 )
            = ( finite_fold @ A @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) @ A3 ) ) ) ) ).

% Sup_fold_sup
thf(fact_1721_Inf__fold__inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( complete_Inf_Inf @ A @ A3 )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ A3 ) ) ) ) ).

% Inf_fold_inf
thf(fact_1722_image__fold__insert,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( image2 @ A @ B @ F2 @ A3 )
        = ( finite_fold @ A @ ( set @ B )
          @ ^ [K6: A] : ( insert @ B @ ( F2 @ K6 ) )
          @ ( bot_bot @ ( set @ B ) )
          @ A3 ) ) ) ).

% image_fold_insert
thf(fact_1723_Fpow__def,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A6: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [X7: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ X7 @ A6 )
                & ( finite_finite2 @ A @ X7 ) ) ) ) ) ).

% Fpow_def
thf(fact_1724_inf__INF__fold__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B2: A,F2: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( inf_inf @ A @ B2 @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) )
            = ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( inf_inf @ A ) @ F2 ) @ B2 @ A3 ) ) ) ) ).

% inf_INF_fold_inf
thf(fact_1725_product__fold,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ B @ B2 )
       => ( ( product_Sigma @ A @ B @ A3
            @ ^ [Uu: A] : B2 )
          = ( finite_fold @ A @ ( set @ ( product_prod @ A @ B ) )
            @ ^ [X2: A,Z3: set @ ( product_prod @ A @ B )] :
                ( finite_fold @ B @ ( set @ ( product_prod @ A @ B ) )
                @ ^ [Y2: B] : ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) )
                @ Z3
                @ B2 )
            @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) )
            @ A3 ) ) ) ) ).

% product_fold
thf(fact_1726_Id__on__fold,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( id_on @ A @ A3 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ A @ A ) )
          @ ^ [X2: A] : ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) )
          @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) )
          @ A3 ) ) ) ).

% Id_on_fold
thf(fact_1727_SUP__fold__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
            = ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( sup_sup @ A ) @ F2 ) @ ( bot_bot @ A ) @ A3 ) ) ) ) ).

% SUP_fold_sup
thf(fact_1728_INF__fold__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
            = ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( inf_inf @ A ) @ F2 ) @ ( top_top @ A ) @ A3 ) ) ) ) ).

% INF_fold_inf
thf(fact_1729_coinduct3__mono__lemma,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [F2: A > ( set @ B ),X5: set @ B,B2: set @ B] :
          ( ( order_mono @ A @ ( set @ B ) @ F2 )
         => ( order_mono @ A @ ( set @ B )
            @ ^ [X2: A] : ( sup_sup @ ( set @ B ) @ ( sup_sup @ ( set @ B ) @ ( F2 @ X2 ) @ X5 ) @ B2 ) ) ) ) ).

% coinduct3_mono_lemma
thf(fact_1730_Set__filter__fold,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( filter3 @ A @ P @ A3 )
        = ( finite_fold @ A @ ( set @ A )
          @ ^ [X2: A,A15: set @ A] : ( if @ ( set @ A ) @ ( P @ X2 ) @ ( insert @ A @ X2 @ A15 ) @ A15 )
          @ ( bot_bot @ ( set @ A ) )
          @ A3 ) ) ) ).

% Set_filter_fold
thf(fact_1731_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F: set @ A,I: set @ A,F2: A > B,I3: A] :
          ( ( finite_finite2 @ A @ F )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I2: A] :
                    ( ( member @ A @ I2 @ I )
                    & ( ( F2 @ I2 )
                     != ( zero_zero @ B ) ) ) )
              @ F )
           => ( ( ( member @ A @ I3 @ I )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I ) @ ( F2 @ I3 ) ) ) )
              & ( ~ ( member @ A @ I3 @ I )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_1732_insert__relcomp__union__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S2: set @ ( product_prod @ A @ B ),X3: product_prod @ C @ A,X5: set @ ( product_prod @ C @ B )] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ S2 )
     => ( ( sup_sup @ ( set @ ( product_prod @ C @ B ) ) @ ( relcomp @ C @ A @ B @ ( insert @ ( product_prod @ C @ A ) @ X3 @ ( bot_bot @ ( set @ ( product_prod @ C @ A ) ) ) ) @ S2 ) @ X5 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z3: B,A15: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X3 )
                  = W3 )
                @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X3 ) @ Z3 ) @ A15 )
                @ A15 ) )
          @ X5
          @ S2 ) ) ) ).

% insert_relcomp_union_fold
thf(fact_1733_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [I: set @ A,F2: A > B,I3: A] :
          ( ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [I2: A] :
                  ( ( member @ A @ I2 @ I )
                  & ( ( F2 @ I2 )
                   != ( zero_zero @ B ) ) ) ) )
         => ( ( ( member @ A @ I3 @ I )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I ) @ ( F2 @ I3 ) ) ) )
            & ( ~ ( member @ A @ I3 @ I )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I ) ) ) ) ) ) ).

% sum_diff1'
thf(fact_1734_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,A3: set @ A,B2: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( ord_less_eq @ ( set @ A ) @ B2 @ S2 )
         => ( ( finite_finite2 @ A @ A3 )
           => ( ( finite_finite2 @ A @ B2 )
             => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
                  = ( finite_fold @ A @ B @ F2 @ ( finite_fold @ A @ B @ F2 @ Z2 @ A3 ) @ B2 ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
thf(fact_1735_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X3: A,A3: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X3 @ A3 ) @ S2 )
       => ( ( finite_finite2 @ A @ A3 )
         => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert @ A @ X3 @ A3 ) )
            = ( F2 @ X3 @ ( finite_fold @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
thf(fact_1736_relcomp__empty2,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set @ ( product_prod @ A @ C )] :
      ( ( relcomp @ A @ C @ B @ R @ ( bot_bot @ ( set @ ( product_prod @ C @ B ) ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% relcomp_empty2
thf(fact_1737_relcomp__empty1,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( bot_bot @ ( set @ ( product_prod @ A @ C ) ) ) @ R )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% relcomp_empty1
thf(fact_1738_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P5: B > A] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ P5 @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty'
thf(fact_1739_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I: set @ B,P5: B > A,I3: B] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I )
                  & ( ( P5 @ X2 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member @ B @ I3 @ I )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P5 @ ( insert @ B @ I3 @ I ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P5 @ I ) ) )
            & ( ~ ( member @ B @ I3 @ I )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P5 @ ( insert @ B @ I3 @ I ) )
                = ( plus_plus @ A @ ( P5 @ I3 ) @ ( groups1027152243600224163dd_sum @ B @ A @ P5 @ I ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_1740_Set_Ofilter__def,axiom,
    ! [A: $tType] :
      ( ( filter3 @ A )
      = ( ^ [P3: A > $o,A6: set @ A] :
            ( collect @ A
            @ ^ [A5: A] :
                ( ( member @ A @ A5 @ A6 )
                & ( P3 @ A5 ) ) ) ) ) ).

% Set.filter_def
thf(fact_1741_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,I: set @ B] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ G
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I )
                  & ( ( G @ X2 )
                   != ( zero_zero @ A ) ) ) ) )
          = ( groups1027152243600224163dd_sum @ B @ A @ G @ I ) ) ) ).

% sum.non_neutral'
thf(fact_1742_wf__no__loop,axiom,
    ! [B: $tType,R: set @ ( product_prod @ B @ B )] :
      ( ( ( relcomp @ B @ B @ B @ R @ R )
        = ( bot_bot @ ( set @ ( product_prod @ B @ B ) ) ) )
     => ( wf @ B @ R ) ) ).

% wf_no_loop
thf(fact_1743_union__comp__emptyL,axiom,
    ! [A: $tType,A3: set @ ( product_prod @ A @ A ),C3: set @ ( product_prod @ A @ A ),B2: set @ ( product_prod @ A @ A )] :
      ( ( ( relcomp @ A @ A @ A @ A3 @ C3 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ( ( relcomp @ A @ A @ A @ B2 @ C3 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ( ( relcomp @ A @ A @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ A3 @ B2 ) @ C3 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ).

% union_comp_emptyL
thf(fact_1744_union__comp__emptyR,axiom,
    ! [A: $tType,A3: set @ ( product_prod @ A @ A ),B2: set @ ( product_prod @ A @ A ),C3: set @ ( product_prod @ A @ A )] :
      ( ( ( relcomp @ A @ A @ A @ A3 @ B2 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ( ( relcomp @ A @ A @ A @ A3 @ C3 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ( ( relcomp @ A @ A @ A @ A3 @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ B2 @ C3 ) )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ).

% union_comp_emptyR
thf(fact_1745_relcomp__subset__Sigma,axiom,
    ! [B: $tType,C: $tType,A: $tType,R5: set @ ( product_prod @ A @ B ),A3: set @ A,B2: set @ B,S3: set @ ( product_prod @ B @ C ),C3: set @ C] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R5
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ C ) ) @ S3
          @ ( product_Sigma @ B @ C @ B2
            @ ^ [Uu: B] : C3 ) )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( relcomp @ A @ B @ C @ R5 @ S3 )
          @ ( product_Sigma @ A @ C @ A3
            @ ^ [Uu: A] : C3 ) ) ) ) ).

% relcomp_subset_Sigma
thf(fact_1746_relcomp__UNION__distrib,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,S3: set @ ( product_prod @ A @ C ),R5: D > ( set @ ( product_prod @ C @ B ) ),I: set @ D] :
      ( ( relcomp @ A @ C @ B @ S3 @ ( complete_Sup_Sup @ ( set @ ( product_prod @ C @ B ) ) @ ( image2 @ D @ ( set @ ( product_prod @ C @ B ) ) @ R5 @ I ) ) )
      = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
        @ ( image2 @ D @ ( set @ ( product_prod @ A @ B ) )
          @ ^ [I2: D] : ( relcomp @ A @ C @ B @ S3 @ ( R5 @ I2 ) )
          @ I ) ) ) ).

% relcomp_UNION_distrib
thf(fact_1747_relcomp__UNION__distrib2,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,R5: D > ( set @ ( product_prod @ A @ C ) ),I: set @ D,S3: set @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ C ) ) @ ( image2 @ D @ ( set @ ( product_prod @ A @ C ) ) @ R5 @ I ) ) @ S3 )
      = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
        @ ( image2 @ D @ ( set @ ( product_prod @ A @ B ) )
          @ ^ [I2: D] : ( relcomp @ A @ C @ B @ ( R5 @ I2 ) @ S3 )
          @ I ) ) ) ).

% relcomp_UNION_distrib2
thf(fact_1748_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite2 @ B @ I )
         => ( ( groups1027152243600224163dd_sum @ B @ A
              @ ^ [I2: B] : ( plus_plus @ A @ ( G @ I2 ) @ ( H2 @ I2 ) )
              @ I )
            = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I ) ) ) ) ) ).

% sum.distrib_triv'
thf(fact_1749_trancl__Int__subset,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ S3 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R5 ) @ S3 ) @ R5 ) @ S3 )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R5 ) @ S3 ) ) ) ).

% trancl_Int_subset
thf(fact_1750_relcomp__unfold,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( relcomp @ A @ C @ B )
      = ( ^ [R3: set @ ( product_prod @ A @ C ),S: set @ ( product_prod @ C @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [X2: A,Z3: B] :
                ? [Y2: C] :
                  ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X2 @ Y2 ) @ R3 )
                  & ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y2 @ Z3 ) @ S ) ) ) ) ) ) ).

% relcomp_unfold
thf(fact_1751_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I )
                  & ( ( G @ X2 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ I )
                    & ( ( H2 @ X2 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I2: B] : ( plus_plus @ A @ ( G @ I2 ) @ ( H2 @ I2 ) )
                @ I )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_1752_rtrancl__Int__subset,axiom,
    ! [A: $tType,S3: set @ ( product_prod @ A @ A ),R5: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( id2 @ A ) @ S3 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R5 ) @ S3 ) @ R5 ) @ S3 )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R5 ) @ S3 ) ) ) ).

% rtrancl_Int_subset
thf(fact_1753_relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ B @ C )] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ R )
     => ( ( finite_finite2 @ ( product_prod @ B @ C ) @ S2 )
       => ( ( relcomp @ A @ B @ C @ R @ S2 )
          = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ A @ C ) )
            @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
              @ ^ [X2: A,Y2: B,A6: set @ ( product_prod @ A @ C )] :
                  ( finite_fold @ ( product_prod @ B @ C ) @ ( set @ ( product_prod @ A @ C ) )
                  @ ( product_case_prod @ B @ C @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
                    @ ^ [W3: B,Z3: C,A15: set @ ( product_prod @ A @ C )] : ( if @ ( set @ ( product_prod @ A @ C ) ) @ ( Y2 = W3 ) @ ( insert @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X2 @ Z3 ) @ A15 ) @ A15 ) )
                  @ A6
                  @ S2 ) )
            @ ( bot_bot @ ( set @ ( product_prod @ A @ C ) ) )
            @ R ) ) ) ) ).

% relcomp_fold
thf(fact_1754_Image__fold,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ A] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ R )
     => ( ( image @ A @ B @ R @ S2 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ B )
          @ ( product_case_prod @ A @ B @ ( ( set @ B ) > ( set @ B ) )
            @ ^ [X2: A,Y2: B,A6: set @ B] : ( if @ ( set @ B ) @ ( member @ A @ X2 @ S2 ) @ ( insert @ B @ Y2 @ A6 ) @ A6 ) )
          @ ( bot_bot @ ( set @ B ) )
          @ R ) ) ) ).

% Image_fold
thf(fact_1755_inter__Set__filter,axiom,
    ! [A: $tType,B2: set @ A,A3: set @ A] :
      ( ( finite_finite2 @ A @ B2 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( filter3 @ A
          @ ^ [X2: A] : ( member @ A @ X2 @ A3 )
          @ B2 ) ) ) ).

% inter_Set_filter
thf(fact_1756_insert__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S2: set @ ( product_prod @ A @ B ),X3: product_prod @ C @ A,R: set @ ( product_prod @ C @ A )] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ S2 )
     => ( ( relcomp @ C @ A @ B @ ( insert @ ( product_prod @ C @ A ) @ X3 @ R ) @ S2 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z3: B,A15: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X3 )
                  = W3 )
                @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X3 ) @ Z3 ) @ A15 )
                @ A15 ) )
          @ ( relcomp @ C @ A @ B @ R @ S2 )
          @ S2 ) ) ) ).

% insert_relcomp_fold
thf(fact_1757_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,A3: set @ A,X3: A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( finite_finite2 @ A @ A3 )
         => ( ( member @ A @ X3 @ A3 )
           => ( ( finite_fold @ A @ B @ F2 @ Z2 @ A3 )
              = ( F2 @ X3 @ ( finite_fold @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
thf(fact_1758_min__ext__compat,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R @ S2 ) @ R )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( min_ext @ A @ R ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( min_ext @ A @ S2 ) @ ( insert @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( min_ext @ A @ R ) ) ) ).

% min_ext_compat
thf(fact_1759_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S2: set @ A,Y: A,F2: A > B] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member @ A @ Y @ S2 )
             => ( ord_less_eq @ B @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) @ ( F2 @ Y ) ) ) ) ) ) ).

% arg_min_least
thf(fact_1760_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I: set @ B,P5: B > A,I3: B] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I )
                  & ( ( P5 @ X2 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member @ B @ I3 @ I )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P5 @ ( insert @ B @ I3 @ I ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P5 @ I ) ) )
            & ( ~ ( member @ B @ I3 @ I )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P5 @ ( insert @ B @ I3 @ I ) )
                = ( times_times @ A @ ( P5 @ I3 ) @ ( groups1962203154675924110t_prod @ B @ A @ P5 @ I ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_1761_finite__def,axiom,
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( complete_lattice_lfp @ ( ( set @ A ) > $o )
        @ ^ [P6: ( set @ A ) > $o,X2: set @ A] :
            ( ( X2
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A6: set @ A,A5: A] :
                ( ( X2
                  = ( insert @ A @ A5 @ A6 ) )
                & ( P6 @ A6 ) ) ) ) ) ).

% finite_def
thf(fact_1762_INF__principal__finite,axiom,
    ! [B: $tType,A: $tType,X5: set @ A,F2: A > ( set @ B )] :
      ( ( finite_finite2 @ A @ X5 )
     => ( ( complete_Inf_Inf @ ( filter @ B )
          @ ( image2 @ A @ ( filter @ B )
            @ ^ [X2: A] : ( principal @ B @ ( F2 @ X2 ) )
            @ X5 ) )
        = ( principal @ B @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ F2 @ X5 ) ) ) ) ) ).

% INF_principal_finite
thf(fact_1763_comp__fun__commute__on_Ofold__graph__insertE__aux,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: A > B > B,A3: set @ A,Z2: B,Y: B,A4: A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( finite_fold_graph @ A @ B @ F2 @ Z2 @ A3 @ Y )
         => ( ( member @ A @ A4 @ A3 )
           => ? [Y8: B] :
                ( ( Y
                  = ( F2 @ A4 @ Y8 ) )
                & ( finite_fold_graph @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) @ Y8 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE_aux
thf(fact_1764_relImage__Gr,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ A ),A3: set @ A,F2: A > B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R
        @ ( product_Sigma @ A @ A @ A3
          @ ^ [Uu: A] : A3 ) )
     => ( ( bNF_Gr4221423524335903396lImage @ A @ B @ R @ F2 )
        = ( relcomp @ B @ A @ B @ ( converse @ A @ B @ ( bNF_Gr @ A @ B @ A3 @ F2 ) ) @ ( relcomp @ A @ A @ B @ R @ ( bNF_Gr @ A @ B @ A3 @ F2 ) ) ) ) ) ).

% relImage_Gr
thf(fact_1765_converse__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( converse @ B @ A @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% converse_empty
thf(fact_1766_pair__set__inverse,axiom,
    ! [B: $tType,A: $tType,P: B > A > $o] :
      ( ( converse @ B @ A @ ( collect @ ( product_prod @ B @ A ) @ ( product_case_prod @ B @ A @ $o @ P ) ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [B4: A,A5: B] : ( P @ A5 @ B4 ) ) ) ) ).

% pair_set_inverse
thf(fact_1767_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P5: B > A] :
          ( ( groups1962203154675924110t_prod @ B @ A @ P5 @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty'
thf(fact_1768_inf__principal,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( inf_inf @ ( filter @ A ) @ ( principal @ A @ A3 ) @ ( principal @ A @ B2 ) )
      = ( principal @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ).

% inf_principal
thf(fact_1769_SUP__principal,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),I: set @ B] :
      ( ( complete_Sup_Sup @ ( filter @ A )
        @ ( image2 @ B @ ( filter @ A )
          @ ^ [I2: B] : ( principal @ A @ ( A3 @ I2 ) )
          @ I ) )
      = ( principal @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) ) ) ).

% SUP_principal
thf(fact_1770_lfp__const,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [T3: A] :
          ( ( complete_lattice_lfp @ A
            @ ^ [X2: A] : T3 )
          = T3 ) ) ).

% lfp_const
thf(fact_1771_converse__Int,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ B @ A ),S3: set @ ( product_prod @ B @ A )] :
      ( ( converse @ B @ A @ ( inf_inf @ ( set @ ( product_prod @ B @ A ) ) @ R5 @ S3 ) )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( converse @ B @ A @ R5 ) @ ( converse @ B @ A @ S3 ) ) ) ).

% converse_Int
thf(fact_1772_fold__graph_OemptyI,axiom,
    ! [A: $tType,B: $tType,F2: A > B > B,Z2: B] : ( finite_fold_graph @ A @ B @ F2 @ Z2 @ ( bot_bot @ ( set @ A ) ) @ Z2 ) ).

% fold_graph.emptyI
thf(fact_1773_empty__fold__graphE,axiom,
    ! [A: $tType,B: $tType,F2: A > B > B,Z2: B,X3: B] :
      ( ( finite_fold_graph @ A @ B @ F2 @ Z2 @ ( bot_bot @ ( set @ A ) ) @ X3 )
     => ( X3 = Z2 ) ) ).

% empty_fold_graphE
thf(fact_1774_converse__Times,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,B2: set @ A] :
      ( ( converse @ B @ A
        @ ( product_Sigma @ B @ A @ A3
          @ ^ [Uu: B] : B2 ) )
      = ( product_Sigma @ A @ B @ B2
        @ ^ [Uu: A] : A3 ) ) ).

% converse_Times
thf(fact_1775_lfp__lfp,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A > A] :
          ( ! [X: A,Y3: A,W: A,Z4: A] :
              ( ( ord_less_eq @ A @ X @ Y3 )
             => ( ( ord_less_eq @ A @ W @ Z4 )
               => ( ord_less_eq @ A @ ( F2 @ X @ W ) @ ( F2 @ Y3 @ Z4 ) ) ) )
         => ( ( complete_lattice_lfp @ A
              @ ^ [X2: A] : ( complete_lattice_lfp @ A @ ( F2 @ X2 ) ) )
            = ( complete_lattice_lfp @ A
              @ ^ [X2: A] : ( F2 @ X2 @ X2 ) ) ) ) ) ).

% lfp_lfp
thf(fact_1776_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,I: set @ B] :
          ( ( groups1962203154675924110t_prod @ B @ A @ G
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I )
                  & ( ( G @ X2 )
                   != ( one_one @ A ) ) ) ) )
          = ( groups1962203154675924110t_prod @ B @ A @ G @ I ) ) ) ).

% prod.non_neutral'
thf(fact_1777_lfp__rolling,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comple6319245703460814977attice @ B )
        & ( comple6319245703460814977attice @ A ) )
     => ! [G: A > B,F2: B > A] :
          ( ( order_mono @ A @ B @ G )
         => ( ( order_mono @ B @ A @ F2 )
           => ( ( G
                @ ( complete_lattice_lfp @ A
                  @ ^ [X2: A] : ( F2 @ ( G @ X2 ) ) ) )
              = ( complete_lattice_lfp @ B
                @ ^ [X2: B] : ( G @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% lfp_rolling
thf(fact_1778_converse__unfold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( converse @ B @ A )
      = ( ^ [R3: set @ ( product_prod @ B @ A )] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [Y2: A,X2: B] : ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y2 ) @ R3 ) ) ) ) ) ).

% converse_unfold
thf(fact_1779_fold__graph_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_fold_graph @ A @ B )
      = ( ^ [F3: A > B > B,Z3: B,A1: set @ A,A22: B] :
            ( ( ( A1
                = ( bot_bot @ ( set @ A ) ) )
              & ( A22 = Z3 ) )
            | ? [X2: A,A6: set @ A,Y2: B] :
                ( ( A1
                  = ( insert @ A @ X2 @ A6 ) )
                & ( A22
                  = ( F3 @ X2 @ Y2 ) )
                & ~ ( member @ A @ X2 @ A6 )
                & ( finite_fold_graph @ A @ B @ F3 @ Z3 @ A6 @ Y2 ) ) ) ) ) ).

% fold_graph.simps
thf(fact_1780_fold__graph_Ocases,axiom,
    ! [A: $tType,B: $tType,F2: A > B > B,Z2: B,A14: set @ A,A24: B] :
      ( ( finite_fold_graph @ A @ B @ F2 @ Z2 @ A14 @ A24 )
     => ( ( ( A14
            = ( bot_bot @ ( set @ A ) ) )
         => ( A24 != Z2 ) )
       => ~ ! [X: A,A12: set @ A] :
              ( ( A14
                = ( insert @ A @ X @ A12 ) )
             => ! [Y3: B] :
                  ( ( A24
                    = ( F2 @ X @ Y3 ) )
                 => ( ~ ( member @ A @ X @ A12 )
                   => ~ ( finite_fold_graph @ A @ B @ F2 @ Z2 @ A12 @ Y3 ) ) ) ) ) ) ).

% fold_graph.cases
thf(fact_1781_principal__eq__bot__iff,axiom,
    ! [A: $tType,X5: set @ A] :
      ( ( ( principal @ A @ X5 )
        = ( bot_bot @ ( filter @ A ) ) )
      = ( X5
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% principal_eq_bot_iff
thf(fact_1782_bot__eq__principal__empty,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( filter @ A ) )
      = ( principal @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% bot_eq_principal_empty
thf(fact_1783_converse__UNION,axiom,
    ! [B: $tType,A: $tType,C: $tType,R5: C > ( set @ ( product_prod @ B @ A ) ),S2: set @ C] :
      ( ( converse @ B @ A @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ A ) ) @ ( image2 @ C @ ( set @ ( product_prod @ B @ A ) ) @ R5 @ S2 ) ) )
      = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
        @ ( image2 @ C @ ( set @ ( product_prod @ A @ B ) )
          @ ^ [X2: C] : ( converse @ B @ A @ ( R5 @ X2 ) )
          @ S2 ) ) ) ).

% converse_UNION
thf(fact_1784_converse__INTER,axiom,
    ! [B: $tType,A: $tType,C: $tType,R5: C > ( set @ ( product_prod @ B @ A ) ),S2: set @ C] :
      ( ( converse @ B @ A @ ( complete_Inf_Inf @ ( set @ ( product_prod @ B @ A ) ) @ ( image2 @ C @ ( set @ ( product_prod @ B @ A ) ) @ R5 @ S2 ) ) )
      = ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) )
        @ ( image2 @ C @ ( set @ ( product_prod @ A @ B ) )
          @ ^ [X2: C] : ( converse @ B @ A @ ( R5 @ X2 ) )
          @ S2 ) ) ) ).

% converse_INTER
thf(fact_1785_lfp__def,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_lattice_lfp @ A )
        = ( ^ [F3: A > A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [U: A] : ( ord_less_eq @ A @ ( F3 @ U ) @ U ) ) ) ) ) ) ).

% lfp_def
thf(fact_1786_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite2 @ B @ I )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I2: B] : ( times_times @ A @ ( G @ I2 ) @ ( H2 @ I2 ) )
              @ I )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_1787_def__lfp__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: A,F2: A > A,P: A] :
          ( ( A3
            = ( complete_lattice_lfp @ A @ F2 ) )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ( ord_less_eq @ A @ ( F2 @ ( inf_inf @ A @ A3 @ P ) ) @ P )
             => ( ord_less_eq @ A @ A3 @ P ) ) ) ) ) ).

% def_lfp_induct
thf(fact_1788_lfp__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,P: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ ( inf_inf @ A @ ( complete_lattice_lfp @ A @ F2 ) @ P ) ) @ P )
           => ( ord_less_eq @ A @ ( complete_lattice_lfp @ A @ F2 ) @ P ) ) ) ) ).

% lfp_induct
thf(fact_1789_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T2: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T2 )
         => ( ! [X: B] :
                ( ( member @ B @ X @ ( minus_minus @ ( set @ B ) @ T2 @ S2 ) )
               => ( ( G @ X )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ T2 ) ) ) ) ) ).

% prod.mono_neutral_left'
thf(fact_1790_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T2: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T2 )
         => ( ! [X: B] :
                ( ( member @ B @ X @ ( minus_minus @ ( set @ B ) @ T2 @ S2 ) )
               => ( ( G @ X )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T2 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ S2 ) ) ) ) ) ).

% prod.mono_neutral_right'
thf(fact_1791_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T2: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T2 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ T2 @ S2 ) )
               => ( ( H2 @ I4 )
                  = ( one_one @ A ) ) )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ S2 )
                 => ( ( G @ X )
                    = ( H2 @ X ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ T2 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
thf(fact_1792_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T2: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T2 )
         => ( ! [X: B] :
                ( ( member @ B @ X @ ( minus_minus @ ( set @ B ) @ T2 @ S2 ) )
               => ( ( G @ X )
                  = ( one_one @ A ) ) )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ S2 )
                 => ( ( G @ X )
                    = ( H2 @ X ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T2 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
thf(fact_1793_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I )
                  & ( ( G @ X2 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ I )
                    & ( ( H2 @ X2 )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I2: B] : ( times_times @ A @ ( G @ I2 ) @ ( H2 @ I2 ) )
                @ I )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_1794_Finite__Set_Ofold__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_fold @ A @ B )
      = ( ^ [F3: A > B > B,Z3: B,A6: set @ A] : ( if @ B @ ( finite_finite2 @ A @ A6 ) @ ( the @ B @ ( finite_fold_graph @ A @ B @ F3 @ Z3 @ A6 ) ) @ Z3 ) ) ) ).

% Finite_Set.fold_def
thf(fact_1795_arg__min__if__finite_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) @ S2 ) ) ) ) ).

% arg_min_if_finite(1)
thf(fact_1796_irrefl__tranclI,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),X3: A] :
      ( ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( converse @ A @ A @ R5 ) @ ( transitive_rtrancl @ A @ R5 ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ ( transitive_trancl @ A @ R5 ) ) ) ).

% irrefl_tranclI
thf(fact_1797_relInvImage__Gr,axiom,
    ! [A: $tType,B: $tType,R: set @ ( product_prod @ A @ A ),B2: set @ A,A3: set @ B,F2: B > A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R
        @ ( product_Sigma @ A @ A @ B2
          @ ^ [Uu: A] : B2 ) )
     => ( ( bNF_Gr7122648621184425601vImage @ B @ A @ A3 @ R @ F2 )
        = ( relcomp @ B @ A @ B @ ( bNF_Gr @ B @ A @ A3 @ F2 ) @ ( relcomp @ A @ A @ B @ R @ ( converse @ B @ A @ ( bNF_Gr @ B @ A @ A3 @ F2 ) ) ) ) ) ) ).

% relInvImage_Gr
thf(fact_1798_max__ext__compat,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R @ S2 ) @ R )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( max_ext @ A @ R ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( max_ext @ A @ S2 ) @ ( insert @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( max_ext @ A @ R ) ) ) ).

% max_ext_compat
thf(fact_1799_trans__wf__iff,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( trans @ A @ R5 )
     => ( ( wf @ A @ R5 )
        = ( ! [A5: A] :
              ( wf @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                @ ( product_Sigma @ A @ A @ ( image @ A @ A @ ( converse @ A @ A @ R5 ) @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) )
                  @ ^ [Uu: A] : ( image @ A @ A @ ( converse @ A @ A @ R5 ) @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% trans_wf_iff
thf(fact_1800_Image__INT__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,R5: set @ ( product_prod @ B @ A ),A3: set @ C,B2: C > ( set @ B )] :
      ( ( single_valued @ A @ B @ ( converse @ B @ A @ R5 ) )
     => ( ( A3
         != ( bot_bot @ ( set @ C ) ) )
       => ( ( image @ B @ A @ R5 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ C @ ( set @ B ) @ B2 @ A3 ) ) )
          = ( complete_Inf_Inf @ ( set @ A )
            @ ( image2 @ C @ ( set @ A )
              @ ^ [X2: C] : ( image @ B @ A @ R5 @ ( B2 @ X2 ) )
              @ A3 ) ) ) ) ) ).

% Image_INT_eq
thf(fact_1801_finite__subsets__at__top__finite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite5375528669736107172at_top @ A @ A3 )
        = ( principal @ ( set @ A ) @ ( insert @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ).

% finite_subsets_at_top_finite
thf(fact_1802_max__ext_Ocases,axiom,
    ! [A: $tType,A14: set @ A,A24: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A14 @ A24 ) @ ( max_ext @ A @ R ) )
     => ~ ( ( finite_finite2 @ A @ A14 )
         => ( ( finite_finite2 @ A @ A24 )
           => ( ( A24
               != ( bot_bot @ ( set @ A ) ) )
             => ~ ! [X4: A] :
                    ( ( member @ A @ X4 @ A14 )
                   => ? [Xa2: A] :
                        ( ( member @ A @ Xa2 @ A24 )
                        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ Xa2 ) @ R ) ) ) ) ) ) ) ).

% max_ext.cases
thf(fact_1803_max__ext_Osimps,axiom,
    ! [A: $tType,A14: set @ A,A24: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A14 @ A24 ) @ ( max_ext @ A @ R ) )
      = ( ( finite_finite2 @ A @ A14 )
        & ( finite_finite2 @ A @ A24 )
        & ( A24
         != ( bot_bot @ ( set @ A ) ) )
        & ! [X2: A] :
            ( ( member @ A @ X2 @ A14 )
           => ? [Y2: A] :
                ( ( member @ A @ Y2 @ A24 )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R ) ) ) ) ) ).

% max_ext.simps
thf(fact_1804_finite__subsets__at__top__neq__bot,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite5375528669736107172at_top @ A @ A3 )
     != ( bot_bot @ ( filter @ ( set @ A ) ) ) ) ).

% finite_subsets_at_top_neq_bot
thf(fact_1805_trans__empty,axiom,
    ! [A: $tType] : ( trans @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% trans_empty
thf(fact_1806_trans__Int,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( trans @ A @ R5 )
     => ( ( trans @ A @ S3 )
       => ( trans @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ S3 ) ) ) ) ).

% trans_Int
thf(fact_1807_single__valued__empty,axiom,
    ! [B: $tType,A: $tType] : ( single_valued @ A @ B @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% single_valued_empty
thf(fact_1808_single__valued__inter1,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( single_valued @ A @ B @ R )
     => ( single_valued @ A @ B @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ) ).

% single_valued_inter1
thf(fact_1809_single__valued__inter2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( single_valued @ A @ B @ R )
     => ( single_valued @ A @ B @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ S2 @ R ) ) ) ).

% single_valued_inter2
thf(fact_1810_trans__Restr,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( trans @ A @ R5 )
     => ( trans @ A
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) ) ) ).

% trans_Restr
thf(fact_1811_lfp__induct__set,axiom,
    ! [A: $tType,A4: A,F2: ( set @ A ) > ( set @ A ),P: A > $o] :
      ( ( member @ A @ A4 @ ( complete_lattice_lfp @ ( set @ A ) @ F2 ) )
     => ( ( order_mono @ ( set @ A ) @ ( set @ A ) @ F2 )
       => ( ! [X: A] :
              ( ( member @ A @ X @ ( F2 @ ( inf_inf @ ( set @ A ) @ ( complete_lattice_lfp @ ( set @ A ) @ F2 ) @ ( collect @ A @ P ) ) ) )
             => ( P @ X ) )
         => ( P @ A4 ) ) ) ) ).

% lfp_induct_set
thf(fact_1812_def__lfp__induct__set,axiom,
    ! [A: $tType,A3: set @ A,F2: ( set @ A ) > ( set @ A ),A4: A,P: A > $o] :
      ( ( A3
        = ( complete_lattice_lfp @ ( set @ A ) @ F2 ) )
     => ( ( order_mono @ ( set @ A ) @ ( set @ A ) @ F2 )
       => ( ( member @ A @ A4 @ A3 )
         => ( ! [X: A] :
                ( ( member @ A @ X @ ( F2 @ ( inf_inf @ ( set @ A ) @ A3 @ ( collect @ A @ P ) ) ) )
               => ( P @ X ) )
           => ( P @ A4 ) ) ) ) ) ).

% def_lfp_induct_set
thf(fact_1813_trans__singleton,axiom,
    ! [A: $tType,A4: A] : ( trans @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ A4 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% trans_singleton
thf(fact_1814_lfp__induct2,axiom,
    ! [A: $tType,B: $tType,A4: A,B3: B,F2: ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 ) @ ( complete_lattice_lfp @ ( set @ ( product_prod @ A @ B ) ) @ F2 ) )
     => ( ( order_mono @ ( set @ ( product_prod @ A @ B ) ) @ ( set @ ( product_prod @ A @ B ) ) @ F2 )
       => ( ! [A7: A,B6: B] :
              ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A7 @ B6 ) @ ( F2 @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( complete_lattice_lfp @ ( set @ ( product_prod @ A @ B ) ) @ F2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) ) ) ) )
             => ( P @ A7 @ B6 ) )
         => ( P @ A4 @ B3 ) ) ) ) ).

% lfp_induct2
thf(fact_1815_Image__Int__eq,axiom,
    ! [A: $tType,B: $tType,R: set @ ( product_prod @ B @ A ),A3: set @ B,B2: set @ B] :
      ( ( single_valued @ A @ B @ ( converse @ B @ A @ R ) )
     => ( ( image @ B @ A @ R @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) )
        = ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ R @ A3 ) @ ( image @ B @ A @ R @ B2 ) ) ) ) ).

% Image_Int_eq
thf(fact_1816_finite__subsets__at__top__def,axiom,
    ! [A: $tType] :
      ( ( finite5375528669736107172at_top @ A )
      = ( ^ [A6: set @ A] :
            ( complete_Inf_Inf @ ( filter @ ( set @ A ) )
            @ ( image2 @ ( set @ A ) @ ( filter @ ( set @ A ) )
              @ ^ [X7: set @ A] :
                  ( principal @ ( set @ A )
                  @ ( collect @ ( set @ A )
                    @ ^ [Y9: set @ A] :
                        ( ( finite_finite2 @ A @ Y9 )
                        & ( ord_less_eq @ ( set @ A ) @ X7 @ Y9 )
                        & ( ord_less_eq @ ( set @ A ) @ Y9 @ A6 ) ) ) )
              @ ( collect @ ( set @ A )
                @ ^ [X7: set @ A] :
                    ( ( finite_finite2 @ A @ X7 )
                    & ( ord_less_eq @ ( set @ A ) @ X7 @ A6 ) ) ) ) ) ) ) ).

% finite_subsets_at_top_def
thf(fact_1817_max__ext_Omax__extI,axiom,
    ! [A: $tType,X5: set @ A,Y4: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite2 @ A @ X5 )
     => ( ( finite_finite2 @ A @ Y4 )
       => ( ( Y4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ X5 )
               => ? [Xa3: A] :
                    ( ( member @ A @ Xa3 @ Y4 )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Xa3 ) @ R ) ) )
           => ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X5 @ Y4 ) @ ( max_ext @ A @ R ) ) ) ) ) ) ).

% max_ext.max_extI
thf(fact_1818_max__extp__eq,axiom,
    ! [A: $tType] :
      ( ( max_extp @ A )
      = ( ^ [R3: A > A > $o,X2: set @ A,Y2: set @ A] : ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X2 @ Y2 ) @ ( max_ext @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R3 ) ) ) ) ) ) ).

% max_extp_eq
thf(fact_1819_max__extp__max__ext__eq,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( max_extp @ A
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R ) )
      = ( ^ [X2: set @ A,Y2: set @ A] : ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X2 @ Y2 ) @ ( max_ext @ A @ R ) ) ) ) ).

% max_extp_max_ext_eq
thf(fact_1820_wf__finite__segments,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R5 )
     => ( ( trans @ A @ R5 )
       => ( ! [X: A] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X ) @ R5 ) ) )
         => ( wf @ A @ R5 ) ) ) ) ).

% wf_finite_segments
thf(fact_1821_filterlim__base__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,I: set @ A,F: A > ( set @ B ),F2: B > C,G4: D > ( set @ C ),J: set @ D] :
      ( ( I
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I4: A] :
            ( ( member @ A @ I4 @ I )
           => ! [J5: A] :
                ( ( member @ A @ J5 @ I )
               => ( ( ord_less_eq @ ( set @ B ) @ ( F @ I4 ) @ ( F @ J5 ) )
                  | ( ord_less_eq @ ( set @ B ) @ ( F @ J5 ) @ ( F @ I4 ) ) ) ) )
       => ( ( filterlim @ B @ C @ F2
            @ ( complete_Inf_Inf @ ( filter @ C )
              @ ( image2 @ D @ ( filter @ C )
                @ ^ [J3: D] : ( principal @ C @ ( G4 @ J3 ) )
                @ J ) )
            @ ( complete_Inf_Inf @ ( filter @ B )
              @ ( image2 @ A @ ( filter @ B )
                @ ^ [I2: A] : ( principal @ B @ ( F @ I2 ) )
                @ I ) ) )
          = ( ! [X2: D] :
                ( ( member @ D @ X2 @ J )
               => ? [Y2: A] :
                    ( ( member @ A @ Y2 @ I )
                    & ! [Z3: B] :
                        ( ( member @ B @ Z3 @ ( F @ Y2 ) )
                       => ( member @ C @ ( F2 @ Z3 ) @ ( G4 @ X2 ) ) ) ) ) ) ) ) ) ).

% filterlim_base_iff
thf(fact_1822_arg__min__inj__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [F2: A > B,P: A > $o,A4: A] :
          ( ( inj_on @ A @ B @ F2 @ ( collect @ A @ P ) )
         => ( ( P @ A4 )
           => ( ! [Y3: A] :
                  ( ( P @ Y3 )
                 => ( ord_less_eq @ B @ ( F2 @ A4 ) @ ( F2 @ Y3 ) ) )
             => ( ( lattices_ord_arg_min @ A @ B @ F2 @ P )
                = A4 ) ) ) ) ) ).

% arg_min_inj_eq
thf(fact_1823_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( member @ A @ X3 @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A3 )
                  = X3 ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A3 )
                  = ( sup_sup @ A @ X3 @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.remove
thf(fact_1824_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X3 @ A3 ) )
                = X3 ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X3 @ A3 ) )
                = ( sup_sup @ A @ X3 @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.insert_remove
thf(fact_1825_Sup__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A] :
          ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
          = X3 ) ) ).

% Sup_fin.singleton
thf(fact_1826_inf__Sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A3: set @ A,A4: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( member @ A @ A4 @ A3 )
           => ( ( inf_inf @ A @ A4 @ ( lattic5882676163264333800up_fin @ A @ A3 ) )
              = A4 ) ) ) ) ).

% inf_Sup_absorb
thf(fact_1827_Sup__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X3 @ A3 ) )
              = ( sup_sup @ A @ X3 @ ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ) ).

% Sup_fin.insert
thf(fact_1828_filterlim__ident,axiom,
    ! [A: $tType,F: filter @ A] :
      ( filterlim @ A @ A
      @ ^ [X2: A] : X2
      @ F
      @ F ) ).

% filterlim_ident
thf(fact_1829_filterlim__compose,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: A > B,F32: filter @ B,F23: filter @ A,F2: C > A,F12: filter @ C] :
      ( ( filterlim @ A @ B @ G @ F32 @ F23 )
     => ( ( filterlim @ C @ A @ F2 @ F23 @ F12 )
       => ( filterlim @ C @ B
          @ ^ [X2: C] : ( G @ ( F2 @ X2 ) )
          @ F32
          @ F12 ) ) ) ).

% filterlim_compose
thf(fact_1830_filterlim__inf,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F23: filter @ B,F32: filter @ B,F12: filter @ A] :
      ( ( filterlim @ A @ B @ F2 @ ( inf_inf @ ( filter @ B ) @ F23 @ F32 ) @ F12 )
      = ( ( filterlim @ A @ B @ F2 @ F23 @ F12 )
        & ( filterlim @ A @ B @ F2 @ F32 @ F12 ) ) ) ).

% filterlim_inf
thf(fact_1831_filterlim__INF,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > B,G4: C > ( filter @ B ),B2: set @ C,F: filter @ A] :
      ( ( filterlim @ A @ B @ F2 @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ C @ ( filter @ B ) @ G4 @ B2 ) ) @ F )
      = ( ! [X2: C] :
            ( ( member @ C @ X2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( G4 @ X2 ) @ F ) ) ) ) ).

% filterlim_INF
thf(fact_1832_filterlim__INF_H,axiom,
    ! [C: $tType,B: $tType,A: $tType,X3: A,A3: set @ A,F2: B > C,F: filter @ C,G4: A > ( filter @ B )] :
      ( ( member @ A @ X3 @ A3 )
     => ( ( filterlim @ B @ C @ F2 @ F @ ( G4 @ X3 ) )
       => ( filterlim @ B @ C @ F2 @ F @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ A @ ( filter @ B ) @ G4 @ A3 ) ) ) ) ) ).

% filterlim_INF'
thf(fact_1833_filterlim__If,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G4: filter @ B,F: filter @ A,P: A > $o,G: A > B] :
      ( ( filterlim @ A @ B @ F2 @ G4 @ ( inf_inf @ ( filter @ A ) @ F @ ( principal @ A @ ( collect @ A @ P ) ) ) )
     => ( ( filterlim @ A @ B @ G @ G4
          @ ( inf_inf @ ( filter @ A ) @ F
            @ ( principal @ A
              @ ( collect @ A
                @ ^ [X2: A] :
                    ~ ( P @ X2 ) ) ) ) )
       => ( filterlim @ A @ B
          @ ^ [X2: A] : ( if @ B @ ( P @ X2 ) @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ G4
          @ F ) ) ) ).

% filterlim_If
thf(fact_1834_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X3 )
             => ! [A16: A] :
                  ( ( member @ A @ A16 @ A3 )
                 => ( ord_less_eq @ A @ A16 @ X3 ) ) ) ) ) ) ).

% Sup_fin.boundedE
thf(fact_1835_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A7: A] :
                  ( ( member @ A @ A7 @ A3 )
                 => ( ord_less_eq @ A @ A7 @ X3 ) )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X3 ) ) ) ) ) ).

% Sup_fin.boundedI
thf(fact_1836_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X3 )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X2 @ X3 ) ) ) ) ) ) ) ).

% Sup_fin.bounded_iff
thf(fact_1837_Sup__fin__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ A3 )
              = ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% Sup_fin_Sup
thf(fact_1838_cSup__eq__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A] :
          ( ( finite_finite2 @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Sup_Sup @ A @ X5 )
              = ( lattic5882676163264333800up_fin @ A @ X5 ) ) ) ) ) ).

% cSup_eq_Sup_fin
thf(fact_1839_filterlim__base,axiom,
    ! [B: $tType,A: $tType,E: $tType,D: $tType,C: $tType,J: set @ A,I3: A > C,I: set @ C,F: C > ( set @ D ),F2: D > E,G4: A > ( set @ E )] :
      ( ! [M3: A,X: B] :
          ( ( member @ A @ M3 @ J )
         => ( member @ C @ ( I3 @ M3 ) @ I ) )
     => ( ! [M3: A,X: D] :
            ( ( member @ A @ M3 @ J )
           => ( ( member @ D @ X @ ( F @ ( I3 @ M3 ) ) )
             => ( member @ E @ ( F2 @ X ) @ ( G4 @ M3 ) ) ) )
       => ( filterlim @ D @ E @ F2
          @ ( complete_Inf_Inf @ ( filter @ E )
            @ ( image2 @ A @ ( filter @ E )
              @ ^ [J3: A] : ( principal @ E @ ( G4 @ J3 ) )
              @ J ) )
          @ ( complete_Inf_Inf @ ( filter @ D )
            @ ( image2 @ C @ ( filter @ D )
              @ ^ [I2: C] : ( principal @ D @ ( F @ I2 ) )
              @ I ) ) ) ) ) ).

% filterlim_base
thf(fact_1840_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ B2 )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ B2 ) ) ) ) ) ) ).

% Sup_fin.subset_imp
thf(fact_1841_Sup__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X: A,Y3: A] :
              ( ( H2 @ ( sup_sup @ A @ X @ Y3 ) )
              = ( sup_sup @ A @ ( H2 @ X ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite2 @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic5882676163264333800up_fin @ A @ N4 ) )
                = ( lattic5882676163264333800up_fin @ A @ ( image2 @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% Sup_fin.hom_commute
thf(fact_1842_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( B2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A3 )
             => ( ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ B2 ) @ ( lattic5882676163264333800up_fin @ A @ A3 ) )
                = ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ) ).

% Sup_fin.subset
thf(fact_1843_Sup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ~ ( member @ A @ X3 @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X3 @ A3 ) )
                = ( sup_sup @ A @ X3 @ ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ) ) ).

% Sup_fin.insert_not_elem
thf(fact_1844_Sup__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X: A,Y3: A] : ( member @ A @ ( sup_sup @ A @ X @ Y3 ) @ ( insert @ A @ X @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ A3 ) ) ) ) ) ).

% Sup_fin.closed
thf(fact_1845_Sup__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ B2 )
             => ( ( B2
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
                  = ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ B2 ) ) ) ) ) ) ) ) ).

% Sup_fin.union
thf(fact_1846_inf__Sup1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( inf_inf @ A @ X3 @ ( lattic5882676163264333800up_fin @ A @ A3 ) )
              = ( lattic5882676163264333800up_fin @ A
                @ ( collect @ A
                  @ ^ [Uu: A] :
                    ? [A5: A] :
                      ( ( Uu
                        = ( inf_inf @ A @ X3 @ A5 ) )
                      & ( member @ A @ A5 @ A3 ) ) ) ) ) ) ) ) ).

% inf_Sup1_distrib
thf(fact_1847_inf__Sup2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ B2 )
             => ( ( B2
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( inf_inf @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ B2 ) )
                  = ( lattic5882676163264333800up_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu: A] :
                        ? [A5: A,B4: A] :
                          ( ( Uu
                            = ( inf_inf @ A @ A5 @ B4 ) )
                          & ( member @ A @ A5 @ A3 )
                          & ( member @ A @ B4 @ B2 ) ) ) ) ) ) ) ) ) ) ).

% inf_Sup2_distrib
thf(fact_1848_arg__min__on__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattic7623131987881927897min_on @ B @ A )
        = ( ^ [F3: B > A,S7: set @ B] :
              ( lattices_ord_arg_min @ B @ A @ F3
              @ ^ [X2: B] : ( member @ B @ X2 @ S7 ) ) ) ) ) ).

% arg_min_on_def
thf(fact_1849_max__ext__def,axiom,
    ! [A: $tType] :
      ( ( max_ext @ A )
      = ( ^ [R2: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
            @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
              @ ( max_extp @ A
                @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R2 ) ) ) ) ) ) ).

% max_ext_def
thf(fact_1850_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( member @ A @ X3 @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A3 )
                  = X3 ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A3 )
                  = ( inf_inf @ A @ X3 @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.remove
thf(fact_1851_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X3 @ A3 ) )
                = X3 ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X3 @ A3 ) )
                = ( inf_inf @ A @ X3 @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.insert_remove
thf(fact_1852_Inf__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X3 @ A3 ) )
              = ( inf_inf @ A @ X3 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.insert
thf(fact_1853_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B2: set @ A,F: A > ( filter @ B ),P: B > $o] :
      ( ( B2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [A7: A] :
            ( ( member @ A @ A7 @ B2 )
           => ! [B6: A] :
                ( ( member @ A @ B6 @ B2 )
               => ? [X4: A] :
                    ( ( member @ A @ X4 @ B2 )
                    & ( ord_less_eq @ ( filter @ B ) @ ( F @ X4 ) @ ( inf_inf @ ( filter @ B ) @ ( F @ A7 ) @ ( F @ B6 ) ) ) ) ) )
       => ( ( eventually @ B @ P @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ A @ ( filter @ B ) @ F @ B2 ) ) )
          = ( ? [X2: A] :
                ( ( member @ A @ X2 @ B2 )
                & ( eventually @ B @ P @ ( F @ X2 ) ) ) ) ) ) ) ).

% eventually_INF_base
thf(fact_1854_coinduct3__lemma,axiom,
    ! [A: $tType,X5: set @ A,F2: ( set @ A ) > ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ X5
        @ ( F2
          @ ( complete_lattice_lfp @ ( set @ A )
            @ ^ [X2: set @ A] : ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( F2 @ X2 ) @ X5 ) @ ( complete_lattice_gfp @ ( set @ A ) @ F2 ) ) ) ) )
     => ( ( order_mono @ ( set @ A ) @ ( set @ A ) @ F2 )
       => ( ord_less_eq @ ( set @ A )
          @ ( complete_lattice_lfp @ ( set @ A )
            @ ^ [X2: set @ A] : ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( F2 @ X2 ) @ X5 ) @ ( complete_lattice_gfp @ ( set @ A ) @ F2 ) ) )
          @ ( F2
            @ ( complete_lattice_lfp @ ( set @ A )
              @ ^ [X2: set @ A] : ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( F2 @ X2 ) @ X5 ) @ ( complete_lattice_gfp @ ( set @ A ) @ F2 ) ) ) ) ) ) ) ).

% coinduct3_lemma
thf(fact_1855_def__coinduct3,axiom,
    ! [A: $tType,A3: set @ A,F2: ( set @ A ) > ( set @ A ),A4: A,X5: set @ A] :
      ( ( A3
        = ( complete_lattice_gfp @ ( set @ A ) @ F2 ) )
     => ( ( order_mono @ ( set @ A ) @ ( set @ A ) @ F2 )
       => ( ( member @ A @ A4 @ X5 )
         => ( ( ord_less_eq @ ( set @ A ) @ X5
              @ ( F2
                @ ( complete_lattice_lfp @ ( set @ A )
                  @ ^ [X2: set @ A] : ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( F2 @ X2 ) @ X5 ) @ A3 ) ) ) )
           => ( member @ A @ A4 @ A3 ) ) ) ) ) ).

% def_coinduct3
thf(fact_1856_coinduct3,axiom,
    ! [A: $tType,F2: ( set @ A ) > ( set @ A ),A4: A,X5: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ A ) @ F2 )
     => ( ( member @ A @ A4 @ X5 )
       => ( ( ord_less_eq @ ( set @ A ) @ X5
            @ ( F2
              @ ( complete_lattice_lfp @ ( set @ A )
                @ ^ [X2: set @ A] : ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( F2 @ X2 ) @ X5 ) @ ( complete_lattice_gfp @ ( set @ A ) @ F2 ) ) ) ) )
         => ( member @ A @ A4 @ ( complete_lattice_gfp @ ( set @ A ) @ F2 ) ) ) ) ) ).

% coinduct3
thf(fact_1857_eventually__const,axiom,
    ! [A: $tType,F: filter @ A,P: $o] :
      ( ( F
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ A
          @ ^ [X2: A] : P
          @ F )
        = P ) ) ).

% eventually_const
thf(fact_1858_Inf__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
          = X3 ) ) ).

% Inf_fin.singleton
thf(fact_1859_not__eventually__impI,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A,Q: A > $o] :
      ( ( eventually @ A @ P @ F )
     => ( ~ ( eventually @ A @ Q @ F )
       => ~ ( eventually @ A
            @ ^ [X2: A] :
                ( ( P @ X2 )
               => ( Q @ X2 ) )
            @ F ) ) ) ).

% not_eventually_impI
thf(fact_1860_eventually__conj__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,F: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
            & ( Q @ X2 ) )
        @ F )
      = ( ( eventually @ A @ P @ F )
        & ( eventually @ A @ Q @ F ) ) ) ).

% eventually_conj_iff
thf(fact_1861_eventually__rev__mp,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A,Q: A > $o] :
      ( ( eventually @ A @ P @ F )
     => ( ( eventually @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
             => ( Q @ X2 ) )
          @ F )
       => ( eventually @ A @ Q @ F ) ) ) ).

% eventually_rev_mp
thf(fact_1862_eventually__subst,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,F: filter @ A] :
      ( ( eventually @ A
        @ ^ [N5: A] :
            ( ( P @ N5 )
            = ( Q @ N5 ) )
        @ F )
     => ( ( eventually @ A @ P @ F )
        = ( eventually @ A @ Q @ F ) ) ) ).

% eventually_subst
thf(fact_1863_eventually__elim2,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A,Q: A > $o,R: A > $o] :
      ( ( eventually @ A @ P @ F )
     => ( ( eventually @ A @ Q @ F )
       => ( ! [I4: A] :
              ( ( P @ I4 )
             => ( ( Q @ I4 )
               => ( R @ I4 ) ) )
         => ( eventually @ A @ R @ F ) ) ) ) ).

% eventually_elim2
thf(fact_1864_eventually__conj,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A,Q: A > $o] :
      ( ( eventually @ A @ P @ F )
     => ( ( eventually @ A @ Q @ F )
       => ( eventually @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
              & ( Q @ X2 ) )
          @ F ) ) ) ).

% eventually_conj
thf(fact_1865_eventually__True,axiom,
    ! [A: $tType,F: filter @ A] :
      ( eventually @ A
      @ ^ [X2: A] : $true
      @ F ) ).

% eventually_True
thf(fact_1866_eventually__mp,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,F: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
           => ( Q @ X2 ) )
        @ F )
     => ( ( eventually @ A @ P @ F )
       => ( eventually @ A @ Q @ F ) ) ) ).

% eventually_mp
thf(fact_1867_eventually__frequently__const__simps_I3_J,axiom,
    ! [A: $tType,P: A > $o,C3: $o,F: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
            | C3 )
        @ F )
      = ( ( eventually @ A @ P @ F )
        | C3 ) ) ).

% eventually_frequently_const_simps(3)
thf(fact_1868_eventually__frequently__const__simps_I4_J,axiom,
    ! [A: $tType,C3: $o,P: A > $o,F: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] :
            ( C3
            | ( P @ X2 ) )
        @ F )
      = ( C3
        | ( eventually @ A @ P @ F ) ) ) ).

% eventually_frequently_const_simps(4)
thf(fact_1869_eventually__frequently__const__simps_I6_J,axiom,
    ! [A: $tType,C3: $o,P: A > $o,F: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] :
            ( C3
           => ( P @ X2 ) )
        @ F )
      = ( C3
       => ( eventually @ A @ P @ F ) ) ) ).

% eventually_frequently_const_simps(6)
thf(fact_1870_gfp__const,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [T3: A] :
          ( ( complete_lattice_gfp @ A
            @ ^ [X2: A] : T3 )
          = T3 ) ) ).

% gfp_const
thf(fact_1871_eventually__happens_H,axiom,
    ! [A: $tType,F: filter @ A,P: A > $o] :
      ( ( F
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ A @ P @ F )
       => ? [X_1: A] : ( P @ X_1 ) ) ) ).

% eventually_happens'
thf(fact_1872_eventually__happens,axiom,
    ! [A: $tType,P: A > $o,Net: filter @ A] :
      ( ( eventually @ A @ P @ Net )
     => ( ( Net
          = ( bot_bot @ ( filter @ A ) ) )
        | ? [X_1: A] : ( P @ X_1 ) ) ) ).

% eventually_happens
thf(fact_1873_eventually__bot,axiom,
    ! [A: $tType,P: A > $o] : ( eventually @ A @ P @ ( bot_bot @ ( filter @ A ) ) ) ).

% eventually_bot
thf(fact_1874_eventually__inf,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A,F4: filter @ A] :
      ( ( eventually @ A @ P @ ( inf_inf @ ( filter @ A ) @ F @ F4 ) )
      = ( ? [Q3: A > $o,R2: A > $o] :
            ( ( eventually @ A @ Q3 @ F )
            & ( eventually @ A @ R2 @ F4 )
            & ! [X2: A] :
                ( ( ( Q3 @ X2 )
                  & ( R2 @ X2 ) )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_inf
thf(fact_1875_eventually__ex,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,F: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] :
          ? [X7: B] : ( P @ X2 @ X7 )
        @ F )
      = ( ? [Y9: A > B] :
            ( eventually @ A
            @ ^ [X2: A] : ( P @ X2 @ ( Y9 @ X2 ) )
            @ F ) ) ) ).

% eventually_ex
thf(fact_1876_eventually__compose__filterlim,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F: filter @ A,F2: B > A,G4: filter @ B] :
      ( ( eventually @ A @ P @ F )
     => ( ( filterlim @ B @ A @ F2 @ F @ G4 )
       => ( eventually @ B
          @ ^ [X2: B] : ( P @ ( F2 @ X2 ) )
          @ G4 ) ) ) ).

% eventually_compose_filterlim
thf(fact_1877_filterlim__cong,axiom,
    ! [A: $tType,B: $tType,F12: filter @ A,F13: filter @ A,F23: filter @ B,F24: filter @ B,F2: B > A,G: B > A] :
      ( ( F12 = F13 )
     => ( ( F23 = F24 )
       => ( ( eventually @ B
            @ ^ [X2: B] :
                ( ( F2 @ X2 )
                = ( G @ X2 ) )
            @ F23 )
         => ( ( filterlim @ B @ A @ F2 @ F12 @ F23 )
            = ( filterlim @ B @ A @ G @ F13 @ F24 ) ) ) ) ) ).

% filterlim_cong
thf(fact_1878_filterlim__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( filterlim @ A @ B )
      = ( ^ [F3: A > B,F25: filter @ B,F14: filter @ A] :
          ! [P3: B > $o] :
            ( ( eventually @ B @ P3 @ F25 )
           => ( eventually @ A
              @ ^ [X2: A] : ( P3 @ ( F3 @ X2 ) )
              @ F14 ) ) ) ) ).

% filterlim_iff
thf(fact_1879_trivial__limit__def,axiom,
    ! [A: $tType,F: filter @ A] :
      ( ( F
        = ( bot_bot @ ( filter @ A ) ) )
      = ( eventually @ A
        @ ^ [X2: A] : $false
        @ F ) ) ).

% trivial_limit_def
thf(fact_1880_eventually__const__iff,axiom,
    ! [A: $tType,P: $o,F: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] : P
        @ F )
      = ( P
        | ( F
          = ( bot_bot @ ( filter @ A ) ) ) ) ) ).

% eventually_const_iff
thf(fact_1881_False__imp__not__eventually,axiom,
    ! [A: $tType,P: A > $o,Net: filter @ A] :
      ( ! [X: A] :
          ~ ( P @ X )
     => ( ( Net
         != ( bot_bot @ ( filter @ A ) ) )
       => ~ ( eventually @ A @ P @ Net ) ) ) ).

% False_imp_not_eventually
thf(fact_1882_gfp__gfp,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A > A] :
          ( ! [X: A,Y3: A,W: A,Z4: A] :
              ( ( ord_less_eq @ A @ X @ Y3 )
             => ( ( ord_less_eq @ A @ W @ Z4 )
               => ( ord_less_eq @ A @ ( F2 @ X @ W ) @ ( F2 @ Y3 @ Z4 ) ) ) )
         => ( ( complete_lattice_gfp @ A
              @ ^ [X2: A] : ( complete_lattice_gfp @ A @ ( F2 @ X2 ) ) )
            = ( complete_lattice_gfp @ A
              @ ^ [X2: A] : ( F2 @ X2 @ X2 ) ) ) ) ) ).

% gfp_gfp
thf(fact_1883_gfp__rolling,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comple6319245703460814977attice @ B )
        & ( comple6319245703460814977attice @ A ) )
     => ! [G: A > B,F2: B > A] :
          ( ( order_mono @ A @ B @ G )
         => ( ( order_mono @ B @ A @ F2 )
           => ( ( G
                @ ( complete_lattice_gfp @ A
                  @ ^ [X2: A] : ( F2 @ ( G @ X2 ) ) ) )
              = ( complete_lattice_gfp @ B
                @ ^ [X2: B] : ( G @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% gfp_rolling
thf(fact_1884_Inf__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( member @ A @ X3 @ A3 )
           => ( ( inf_inf @ A @ X3 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
              = ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ).

% Inf_fin.in_idem
thf(fact_1885_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F: filter @ B,G4: filter @ A,F4: filter @ B,G5: filter @ A,F11: A > B] :
      ( ( filterlim @ A @ B @ F2 @ F @ G4 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F @ F4 )
       => ( ( ord_less_eq @ ( filter @ A ) @ G5 @ G4 )
         => ( ( eventually @ A
              @ ^ [X2: A] :
                  ( ( F2 @ X2 )
                  = ( F11 @ X2 ) )
              @ G5 )
           => ( filterlim @ A @ B @ F11 @ F4 @ G5 ) ) ) ) ) ).

% filterlim_mono_eventually
thf(fact_1886_filterlim__principal,axiom,
    ! [B: $tType,A: $tType,F2: A > B,S2: set @ B,F: filter @ A] :
      ( ( filterlim @ A @ B @ F2 @ ( principal @ B @ S2 ) @ F )
      = ( eventually @ A
        @ ^ [X2: A] : ( member @ B @ ( F2 @ X2 ) @ S2 )
        @ F ) ) ).

% filterlim_principal
thf(fact_1887_le__principal,axiom,
    ! [A: $tType,F: filter @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ F @ ( principal @ A @ A3 ) )
      = ( eventually @ A
        @ ^ [X2: A] : ( member @ A @ X2 @ A3 )
        @ F ) ) ).

% le_principal
thf(fact_1888_eventually__INF1,axiom,
    ! [B: $tType,A: $tType,I3: A,I: set @ A,P: B > $o,F: A > ( filter @ B )] :
      ( ( member @ A @ I3 @ I )
     => ( ( eventually @ B @ P @ ( F @ I3 ) )
       => ( eventually @ B @ P @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ A @ ( filter @ B ) @ F @ I ) ) ) ) ) ).

% eventually_INF1
thf(fact_1889_eventually__inf__principal,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A,S3: set @ A] :
      ( ( eventually @ A @ P @ ( inf_inf @ ( filter @ A ) @ F @ ( principal @ A @ S3 ) ) )
      = ( eventually @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ S3 )
           => ( P @ X2 ) )
        @ F ) ) ).

% eventually_inf_principal
thf(fact_1890_gfp__def,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_lattice_gfp @ A )
        = ( ^ [F3: A > A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [U: A] : ( ord_less_eq @ A @ U @ ( F3 @ U ) ) ) ) ) ) ) ).

% gfp_def
thf(fact_1891_def__Collect__coinduct,axiom,
    ! [A: $tType,A3: set @ A,P: ( set @ A ) > A > $o,A4: A,X5: set @ A] :
      ( ( A3
        = ( complete_lattice_gfp @ ( set @ A )
          @ ^ [W3: set @ A] : ( collect @ A @ ( P @ W3 ) ) ) )
     => ( ( order_mono @ ( set @ A ) @ ( set @ A )
          @ ^ [W3: set @ A] : ( collect @ A @ ( P @ W3 ) ) )
       => ( ( member @ A @ A4 @ X5 )
         => ( ! [Z4: A] :
                ( ( member @ A @ Z4 @ X5 )
               => ( P @ ( sup_sup @ ( set @ A ) @ X5 @ A3 ) @ Z4 ) )
           => ( member @ A @ A4 @ A3 ) ) ) ) ) ).

% def_Collect_coinduct
thf(fact_1892_eventually__Inf__base,axiom,
    ! [A: $tType,B2: set @ ( filter @ A ),P: A > $o] :
      ( ( B2
       != ( bot_bot @ ( set @ ( filter @ A ) ) ) )
     => ( ! [F7: filter @ A] :
            ( ( member @ ( filter @ A ) @ F7 @ B2 )
           => ! [G6: filter @ A] :
                ( ( member @ ( filter @ A ) @ G6 @ B2 )
               => ? [X4: filter @ A] :
                    ( ( member @ ( filter @ A ) @ X4 @ B2 )
                    & ( ord_less_eq @ ( filter @ A ) @ X4 @ ( inf_inf @ ( filter @ A ) @ F7 @ G6 ) ) ) ) )
       => ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B2 ) )
          = ( ? [X2: filter @ A] :
                ( ( member @ ( filter @ A ) @ X2 @ B2 )
                & ( eventually @ A @ P @ X2 ) ) ) ) ) ) ).

% eventually_Inf_base
thf(fact_1893_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X3 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X3 @ X2 ) ) ) ) ) ) ) ).

% Inf_fin.bounded_iff
thf(fact_1894_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A7: A] :
                  ( ( member @ A @ A7 @ A3 )
                 => ( ord_less_eq @ A @ X3 @ A7 ) )
             => ( ord_less_eq @ A @ X3 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.boundedI
thf(fact_1895_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X3 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
             => ! [A16: A] :
                  ( ( member @ A @ A16 @ A3 )
                 => ( ord_less_eq @ A @ X3 @ A16 ) ) ) ) ) ) ).

% Inf_fin.boundedE
thf(fact_1896_eventually__INF__finite,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,P: B > $o,F: A > ( filter @ B )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( eventually @ B @ P @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ A @ ( filter @ B ) @ F @ A3 ) ) )
        = ( ? [Q3: A > B > $o] :
              ( ! [X2: A] :
                  ( ( member @ A @ X2 @ A3 )
                 => ( eventually @ B @ ( Q3 @ X2 ) @ ( F @ X2 ) ) )
              & ! [Y2: B] :
                  ( ! [X2: A] :
                      ( ( member @ A @ X2 @ A3 )
                     => ( Q3 @ X2 @ Y2 ) )
                 => ( P @ Y2 ) ) ) ) ) ) ).

% eventually_INF_finite
thf(fact_1897_filterlim__finite__subsets__at__top,axiom,
    ! [A: $tType,B: $tType,F2: A > ( set @ B ),A3: set @ B,F: filter @ A] :
      ( ( filterlim @ A @ ( set @ B ) @ F2 @ ( finite5375528669736107172at_top @ B @ A3 ) @ F )
      = ( ! [X7: set @ B] :
            ( ( ( finite_finite2 @ B @ X7 )
              & ( ord_less_eq @ ( set @ B ) @ X7 @ A3 ) )
           => ( eventually @ A
              @ ^ [Y2: A] :
                  ( ( finite_finite2 @ B @ ( F2 @ Y2 ) )
                  & ( ord_less_eq @ ( set @ B ) @ X7 @ ( F2 @ Y2 ) )
                  & ( ord_less_eq @ ( set @ B ) @ ( F2 @ Y2 ) @ A3 ) )
              @ F ) ) ) ) ).

% filterlim_finite_subsets_at_top
thf(fact_1898_cInf__eq__Inf__fin,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A] :
          ( ( finite_finite2 @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Inf_Inf @ A @ X5 )
              = ( lattic7752659483105999362nf_fin @ A @ X5 ) ) ) ) ) ).

% cInf_eq_Inf_fin
thf(fact_1899_Inf__fin__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ A3 )
              = ( complete_Inf_Inf @ A @ A3 ) ) ) ) ) ).

% Inf_fin_Inf
thf(fact_1900_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F: B > ( filter @ A ),B2: set @ B] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image2 @ B @ ( filter @ A ) @ F @ B2 ) ) )
      = ( ? [X7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ X7 @ B2 )
            & ( finite_finite2 @ B @ X7 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image2 @ B @ ( filter @ A ) @ F @ X7 ) ) ) ) ) ) ).

% eventually_INF
thf(fact_1901_Inf__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ B2 )
             => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ B2 ) @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.subset_imp
thf(fact_1902_Inf__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X: A,Y3: A] :
              ( ( H2 @ ( inf_inf @ A @ X @ Y3 ) )
              = ( inf_inf @ A @ ( H2 @ X ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite2 @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic7752659483105999362nf_fin @ A @ N4 ) )
                = ( lattic7752659483105999362nf_fin @ A @ ( image2 @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% Inf_fin.hom_commute
thf(fact_1903_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( B2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A3 )
             => ( ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ B2 ) @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
                = ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.subset
thf(fact_1904_Inf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ~ ( member @ A @ X3 @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X3 @ A3 ) )
                = ( inf_inf @ A @ X3 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ) ).

% Inf_fin.insert_not_elem
thf(fact_1905_Inf__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X: A,Y3: A] : ( member @ A @ ( inf_inf @ A @ X @ Y3 ) @ ( insert @ A @ X @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ A3 ) ) ) ) ) ).

% Inf_fin.closed
thf(fact_1906_Inf__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ B2 )
             => ( ( B2
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
                  = ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ ( lattic7752659483105999362nf_fin @ A @ B2 ) ) ) ) ) ) ) ) ).

% Inf_fin.union
thf(fact_1907_Inf__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X3 @ A3 ) )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ X3 @ A3 ) ) ) ) ).

% Inf_fin.eq_fold
thf(fact_1908_Inf__fin__le__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ).

% Inf_fin_le_Sup_fin
thf(fact_1909_sup__Inf2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ B2 )
             => ( ( B2
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ ( lattic7752659483105999362nf_fin @ A @ B2 ) )
                  = ( lattic7752659483105999362nf_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu: A] :
                        ? [A5: A,B4: A] :
                          ( ( Uu
                            = ( sup_sup @ A @ A5 @ B4 ) )
                          & ( member @ A @ A5 @ A3 )
                          & ( member @ A @ B4 @ B2 ) ) ) ) ) ) ) ) ) ) ).

% sup_Inf2_distrib
thf(fact_1910_sup__Inf1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( sup_sup @ A @ X3 @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
              = ( lattic7752659483105999362nf_fin @ A
                @ ( collect @ A
                  @ ^ [Uu: A] :
                    ? [A5: A] :
                      ( ( Uu
                        = ( sup_sup @ A @ X3 @ A5 ) )
                      & ( member @ A @ A5 @ A3 ) ) ) ) ) ) ) ) ).

% sup_Inf1_distrib
thf(fact_1911_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: B > A,Y4: set @ B,X5: set @ A,F: filter @ B,F2: A > C] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image2 @ B @ A @ G @ Y4 ) @ X5 )
     => ( ( eventually @ B
          @ ^ [X2: B] : ( member @ B @ X2 @ Y4 )
          @ F )
       => ( ( map_filter_on @ A @ C @ X5 @ F2 @ ( map_filter_on @ B @ A @ Y4 @ G @ F ) )
          = ( map_filter_on @ B @ C @ Y4 @ ( comp @ A @ C @ B @ F2 @ G ) @ F ) ) ) ) ).

% map_filter_on_comp
thf(fact_1912_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F )
          = ( ! [Z7: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z7 )
                @ F ) ) ) ) ).

% filterlim_at_bot
thf(fact_1913_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F )
          = ( ! [Z7: B] :
                ( ( ord_less_eq @ B @ Z7 @ C2 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z7 )
                  @ F ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_1914_filterlim__INF__INF,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,J: set @ A,I: set @ B,F2: D > C,F: B > ( filter @ D ),G4: A > ( filter @ C )] :
      ( ! [M3: A] :
          ( ( member @ A @ M3 @ J )
         => ? [X4: B] :
              ( ( member @ B @ X4 @ I )
              & ( ord_less_eq @ ( filter @ C ) @ ( filtermap @ D @ C @ F2 @ ( F @ X4 ) ) @ ( G4 @ M3 ) ) ) )
     => ( filterlim @ D @ C @ F2 @ ( complete_Inf_Inf @ ( filter @ C ) @ ( image2 @ A @ ( filter @ C ) @ G4 @ J ) ) @ ( complete_Inf_Inf @ ( filter @ D ) @ ( image2 @ B @ ( filter @ D ) @ F @ I ) ) ) ) ).

% filterlim_INF_INF
thf(fact_1915_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I3: C,A3: set @ C,F2: C > B] :
          ( ( member @ C @ I3 @ A3 )
         => ( ! [X: C] :
                ( ( member @ C @ X @ ( minus_minus @ ( set @ C ) @ A3 @ ( insert @ C @ I3 @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X ) ) )
           => ( ( finite_finite2 @ C @ A3 )
             => ( ord_less_eq @ B @ ( F2 @ I3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ F2 @ A3 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_1916_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B2: set @ A,A3: set @ A,F2: A > B] :
          ( ( finite_finite2 @ A @ B2 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
           => ( ! [B6: A] :
                  ( ( member @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B2 @ A3 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ B6 ) ) )
             => ( ! [A7: A] :
                    ( ( member @ A @ A7 @ A3 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ A7 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ B2 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_1917_ex__is__arg__min__if__finite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X_1: A] :
                ( lattic501386751177426532rg_min @ A @ B @ F2
                @ ^ [X2: A] : ( member @ A @ X2 @ S2 )
                @ X_1 ) ) ) ) ).

% ex_is_arg_min_if_finite
thf(fact_1918_filtermap__id_H,axiom,
    ! [A: $tType] :
      ( ( filtermap @ A @ A
        @ ^ [X2: A] : X2 )
      = ( ^ [F5: filter @ A] : F5 ) ) ).

% filtermap_id'
thf(fact_1919_filtermap__bot,axiom,
    ! [B: $tType,A: $tType,F2: B > A] :
      ( ( filtermap @ B @ A @ F2 @ ( bot_bot @ ( filter @ B ) ) )
      = ( bot_bot @ ( filter @ A ) ) ) ).

% filtermap_bot
thf(fact_1920_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [Uu: B] : ( zero_zero @ A )
            @ A3 )
          = ( zero_zero @ A ) ) ) ).

% sum.neutral_const
thf(fact_1921_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [Uu: B] : ( one_one @ A )
            @ A3 )
          = ( one_one @ A ) ) ) ).

% prod.neutral_const
thf(fact_1922_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty
thf(fact_1923_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A] :
          ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty
thf(fact_1924_prod_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ~ ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( one_one @ A ) ) ) ) ).

% prod.infinite
thf(fact_1925_sum_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A4: B,B3: B > A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( ( member @ B @ A4 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( B3 @ A4 ) ) )
            & ( ~ ( member @ B @ A4 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta
thf(fact_1926_sum_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A4: B,B3: B > A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( ( member @ B @ A4 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( A4 = K6 ) @ ( B3 @ K6 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( B3 @ A4 ) ) )
            & ( ~ ( member @ B @ A4 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( A4 = K6 ) @ ( B3 @ K6 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta'
thf(fact_1927_prod_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A4: B,B3: B > A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( ( member @ B @ A4 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( B3 @ A4 ) ) )
            & ( ~ ( member @ B @ A4 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta
thf(fact_1928_prod_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A4: B,B3: B > A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( ( member @ B @ A4 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( A4 = K6 ) @ ( B3 @ K6 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( B3 @ A4 ) ) )
            & ( ~ ( member @ B @ A4 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( A4 = K6 ) @ ( B3 @ K6 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta'
thf(fact_1929_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X3: B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ~ ( member @ B @ X3 @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X3 @ A3 ) )
              = ( times_times @ A @ ( G @ X3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod.insert
thf(fact_1930_filtermap__filtermap,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,G: C > B,F: filter @ C] :
      ( ( filtermap @ B @ A @ F2 @ ( filtermap @ C @ B @ G @ F ) )
      = ( filtermap @ C @ A
        @ ^ [X2: C] : ( F2 @ ( G @ X2 ) )
        @ F ) ) ).

% filtermap_filtermap
thf(fact_1931_filtermap__ident,axiom,
    ! [A: $tType,F: filter @ A] :
      ( ( filtermap @ A @ A
        @ ^ [X2: A] : X2
        @ F )
      = F ) ).

% filtermap_ident
thf(fact_1932_sum_Oswap,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > C > A,B2: set @ C,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [I2: B] : ( groups7311177749621191930dd_sum @ C @ A @ ( G @ I2 ) @ B2 )
            @ A3 )
          = ( groups7311177749621191930dd_sum @ C @ A
            @ ^ [J3: C] :
                ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [I2: B] : ( G @ I2 @ J3 )
                @ A3 )
            @ B2 ) ) ) ).

% sum.swap
thf(fact_1933_prod_Oswap,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > C > A,B2: set @ C,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [I2: B] : ( groups7121269368397514597t_prod @ C @ A @ ( G @ I2 ) @ B2 )
            @ A3 )
          = ( groups7121269368397514597t_prod @ C @ A
            @ ^ [J3: C] :
                ( groups7121269368397514597t_prod @ B @ A
                @ ^ [I2: B] : ( G @ I2 @ J3 )
                @ A3 )
            @ B2 ) ) ) ).

% prod.swap
thf(fact_1934_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
           != ( one_one @ A ) )
         => ~ ! [A7: B] :
                ( ( member @ B @ A7 @ A3 )
               => ( ( G @ A7 )
                  = ( one_one @ A ) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
thf(fact_1935_prod_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ! [X: B] :
              ( ( member @ B @ X @ A3 )
             => ( ( G @ X )
                = ( one_one @ A ) ) )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( one_one @ A ) ) ) ) ).

% prod.neutral
thf(fact_1936_prod_Ocartesian__product,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > C > A,B2: set @ C,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( groups7121269368397514597t_prod @ C @ A @ ( G @ X2 ) @ B2 )
            @ A3 )
          = ( groups7121269368397514597t_prod @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ G )
            @ ( product_Sigma @ B @ C @ A3
              @ ^ [Uu: B] : B2 ) ) ) ) ).

% prod.cartesian_product
thf(fact_1937_sum_Ocartesian__product,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > C > A,B2: set @ C,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : ( groups7311177749621191930dd_sum @ C @ A @ ( G @ X2 ) @ B2 )
            @ A3 )
          = ( groups7311177749621191930dd_sum @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ G )
            @ ( product_Sigma @ B @ C @ A3
              @ ^ [Uu: B] : B2 ) ) ) ) ).

% sum.cartesian_product
thf(fact_1938_prod_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B2: set @ ( set @ B ),G: B > A] :
          ( ! [X: set @ B] :
              ( ( member @ ( set @ B ) @ X @ B2 )
             => ( finite_finite2 @ B @ X ) )
         => ( ! [A17: set @ B] :
                ( ( member @ ( set @ B ) @ A17 @ B2 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B2 )
                   => ( ( A17 != A25 )
                     => ! [X: B] :
                          ( ( member @ B @ X @ A17 )
                         => ( ( member @ B @ X @ A25 )
                           => ( ( G @ X )
                              = ( one_one @ A ) ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B2 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7121269368397514597t_prod @ ( set @ B ) @ A ) @ ( groups7121269368397514597t_prod @ B @ A ) @ G @ B2 ) ) ) ) ) ).

% prod.Union_comp
thf(fact_1939_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K5: set @ B,F2: B > A,G: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ K5 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( G @ I4 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ K5 ) ) ) ) ).

% sum_mono
thf(fact_1940_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H2: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( times_times @ A @ ( G @ X2 ) @ ( H2 @ X2 ) )
            @ A3 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ A3 ) ) ) ) ).

% prod.distrib
thf(fact_1941_prod_Oswap__restrict,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B2: set @ C,G: B > C > A,R: B > C > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ C @ B2 )
           => ( ( groups7121269368397514597t_prod @ B @ A
                @ ^ [X2: B] :
                    ( groups7121269368397514597t_prod @ C @ A @ ( G @ X2 )
                    @ ( collect @ C
                      @ ^ [Y2: C] :
                          ( ( member @ C @ Y2 @ B2 )
                          & ( R @ X2 @ Y2 ) ) ) )
                @ A3 )
              = ( groups7121269368397514597t_prod @ C @ A
                @ ^ [Y2: C] :
                    ( groups7121269368397514597t_prod @ B @ A
                    @ ^ [X2: B] : ( G @ X2 @ Y2 )
                    @ ( collect @ B
                      @ ^ [X2: B] :
                          ( ( member @ B @ X2 @ A3 )
                          & ( R @ X2 @ Y2 ) ) ) )
                @ B2 ) ) ) ) ) ).

% prod.swap_restrict
thf(fact_1942_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,H2: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : ( plus_plus @ A @ ( G @ X2 ) @ ( H2 @ X2 ) )
            @ A3 )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ A3 ) ) ) ) ).

% sum.distrib
thf(fact_1943_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,A3: set @ A,G: C > B,B2: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B2 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I2: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J3: C] : ( times_times @ B @ ( F2 @ I2 ) @ ( G @ J3 ) )
                @ B2 )
            @ A3 ) ) ) ).

% sum_product
thf(fact_1944_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,A3: set @ B,R5: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ R5 )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N5: B] : ( times_times @ A @ ( F2 @ N5 ) @ R5 )
            @ A3 ) ) ) ).

% sum_distrib_right
thf(fact_1945_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R5: A,F2: B > A,A3: set @ B] :
          ( ( times_times @ A @ R5 @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N5: B] : ( times_times @ A @ R5 @ ( F2 @ N5 ) )
            @ A3 ) ) ) ).

% sum_distrib_left
thf(fact_1946_sum__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ A3 )
          = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum_subtractf
thf(fact_1947_sum_Oswap__restrict,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B2: set @ C,G: B > C > A,R: B > C > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ C @ B2 )
           => ( ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [X2: B] :
                    ( groups7311177749621191930dd_sum @ C @ A @ ( G @ X2 )
                    @ ( collect @ C
                      @ ^ [Y2: C] :
                          ( ( member @ C @ Y2 @ B2 )
                          & ( R @ X2 @ Y2 ) ) ) )
                @ A3 )
              = ( groups7311177749621191930dd_sum @ C @ A
                @ ^ [Y2: C] :
                    ( groups7311177749621191930dd_sum @ B @ A
                    @ ^ [X2: B] : ( G @ X2 @ Y2 )
                    @ ( collect @ B
                      @ ^ [X2: B] :
                          ( ( member @ B @ X2 @ A3 )
                          & ( R @ X2 @ Y2 ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum.swap_restrict
thf(fact_1948_sum__negf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : ( uminus_uminus @ A @ ( F2 @ X2 ) )
            @ A3 )
          = ( uminus_uminus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ).

% sum_negf
thf(fact_1949_filtermap__bot__iff,axiom,
    ! [A: $tType,B: $tType,F2: B > A,F: filter @ B] :
      ( ( ( filtermap @ B @ A @ F2 @ F )
        = ( bot_bot @ ( filter @ A ) ) )
      = ( F
        = ( bot_bot @ ( filter @ B ) ) ) ) ).

% filtermap_bot_iff
thf(fact_1950_prod_Oreindex__bij__betw,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [H2: B > C,S2: set @ B,T2: set @ C,G: C > A] :
          ( ( bij_betw @ B @ C @ H2 @ S2 @ T2 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( G @ ( H2 @ X2 ) )
              @ S2 )
            = ( groups7121269368397514597t_prod @ C @ A @ G @ T2 ) ) ) ) ).

% prod.reindex_bij_betw
thf(fact_1951_sum_Oreindex__bij__betw,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [H2: B > C,S2: set @ B,T2: set @ C,G: C > A] :
          ( ( bij_betw @ B @ C @ H2 @ S2 @ T2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( G @ ( H2 @ X2 ) )
              @ S2 )
            = ( groups7311177749621191930dd_sum @ C @ A @ G @ T2 ) ) ) ) ).

% sum.reindex_bij_betw
thf(fact_1952_prod_OSigma,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B2: B > ( set @ C ),G: B > C > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ! [X: B] :
                ( ( member @ B @ X @ A3 )
               => ( finite_finite2 @ C @ ( B2 @ X ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A
                @ ^ [X2: B] : ( groups7121269368397514597t_prod @ C @ A @ ( G @ X2 ) @ ( B2 @ X2 ) )
                @ A3 )
              = ( groups7121269368397514597t_prod @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ G ) @ ( product_Sigma @ B @ C @ A3 @ B2 ) ) ) ) ) ) ).

% prod.Sigma
thf(fact_1953_sum_OSigma,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B2: B > ( set @ C ),G: B > C > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ! [X: B] :
                ( ( member @ B @ X @ A3 )
               => ( finite_finite2 @ C @ ( B2 @ X ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [X2: B] : ( groups7311177749621191930dd_sum @ C @ A @ ( G @ X2 ) @ ( B2 @ X2 ) )
                @ A3 )
              = ( groups7311177749621191930dd_sum @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ G ) @ ( product_Sigma @ B @ C @ A3 @ B2 ) ) ) ) ) ) ).

% sum.Sigma
thf(fact_1954_eventually__filtermap,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,F: filter @ B] :
      ( ( eventually @ A @ P @ ( filtermap @ B @ A @ F2 @ F ) )
      = ( eventually @ B
        @ ^ [X2: B] : ( P @ ( F2 @ X2 ) )
        @ F ) ) ).

% eventually_filtermap
thf(fact_1955_prod_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C3: set @ ( set @ B ),G: B > A] :
          ( ! [X: set @ B] :
              ( ( member @ ( set @ B ) @ X @ C3 )
             => ( finite_finite2 @ B @ X ) )
         => ( ! [X: set @ B] :
                ( ( member @ ( set @ B ) @ X @ C3 )
               => ! [Xa2: set @ B] :
                    ( ( member @ ( set @ B ) @ Xa2 @ C3 )
                   => ( ( X != Xa2 )
                     => ( ( inf_inf @ ( set @ B ) @ X @ Xa2 )
                        = ( bot_bot @ ( set @ B ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ C3 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7121269368397514597t_prod @ ( set @ B ) @ A ) @ ( groups7121269368397514597t_prod @ B @ A ) @ G @ C3 ) ) ) ) ) ).

% prod.Union_disjoint
thf(fact_1956_sum_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C3: set @ ( set @ B ),G: B > A] :
          ( ! [X: set @ B] :
              ( ( member @ ( set @ B ) @ X @ C3 )
             => ( finite_finite2 @ B @ X ) )
         => ( ! [X: set @ B] :
                ( ( member @ ( set @ B ) @ X @ C3 )
               => ! [Xa2: set @ B] :
                    ( ( member @ ( set @ B ) @ Xa2 @ C3 )
                   => ( ( X != Xa2 )
                     => ( ( inf_inf @ ( set @ B ) @ X @ Xa2 )
                        = ( bot_bot @ ( set @ B ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ C3 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G @ C3 ) ) ) ) ) ).

% sum.Union_disjoint
thf(fact_1957_filterlim__filtermap,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > B,F12: filter @ B,G: C > A,F23: filter @ C] :
      ( ( filterlim @ A @ B @ F2 @ F12 @ ( filtermap @ C @ A @ G @ F23 ) )
      = ( filterlim @ C @ B
        @ ^ [X2: C] : ( F2 @ ( G @ X2 ) )
        @ F12
        @ F23 ) ) ).

% filterlim_filtermap
thf(fact_1958_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X: B] :
              ( ( member @ B @ X @ A3 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F2 @ X ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_ge_1
thf(fact_1959_prod_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                    & ( P @ X2 ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( G @ X2 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_filter
thf(fact_1960_prod_Oimage__gen,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,H2: B > A,G: B > C] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 )
            = ( groups7121269368397514597t_prod @ C @ A
              @ ^ [Y2: C] :
                  ( groups7121269368397514597t_prod @ B @ A @ H2
                  @ ( collect @ B
                    @ ^ [X2: B] :
                        ( ( member @ B @ X2 @ S2 )
                        & ( ( G @ X2 )
                          = Y2 ) ) ) )
              @ ( image2 @ B @ C @ G @ S2 ) ) ) ) ) ).

% prod.image_gen
thf(fact_1961_sum_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                    & ( P @ X2 ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( G @ X2 ) @ ( zero_zero @ A ) )
              @ A3 ) ) ) ) ).

% sum.inter_filter
thf(fact_1962_sum_Oimage__gen,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,H2: B > A,G: B > C] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S2 )
            = ( groups7311177749621191930dd_sum @ C @ A
              @ ^ [Y2: C] :
                  ( groups7311177749621191930dd_sum @ B @ A @ H2
                  @ ( collect @ B
                    @ ^ [X2: B] :
                        ( ( member @ B @ X2 @ S2 )
                        & ( ( G @ X2 )
                          = Y2 ) ) ) )
              @ ( image2 @ B @ C @ G @ S2 ) ) ) ) ) ).

% sum.image_gen
thf(fact_1963_prod_Oimage__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( inj_on @ B @ A @ G @ A3 )
         => ( ( groups7121269368397514597t_prod @ A @ A
              @ ^ [X2: A] : X2
              @ ( image2 @ B @ A @ G @ A3 ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod.image_eq
thf(fact_1964_sum_Oimage__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( inj_on @ B @ A @ G @ A3 )
         => ( ( groups7311177749621191930dd_sum @ A @ A
              @ ^ [X2: A] : X2
              @ ( image2 @ B @ A @ G @ A3 ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum.image_eq
thf(fact_1965_trivial__limit__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( at_bot @ A )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% trivial_limit_at_bot_linorder
thf(fact_1966_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X: B] :
              ( ( member @ B @ X @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X ) )
                & ( ord_less_eq @ A @ ( F2 @ X ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_1967_eventually__at__bot__not__equal,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X2: A] : ( X2 != C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_at_bot_not_equal
thf(fact_1968_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R: A > A > $o,S2: set @ B,H2: B > A,G: B > A] :
          ( ( R @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X13: A,Y1: A,X24: A,Y22: A] :
                ( ( ( R @ X13 @ X24 )
                  & ( R @ Y1 @ Y22 ) )
               => ( R @ ( times_times @ A @ X13 @ Y1 ) @ ( times_times @ A @ X24 @ Y22 ) ) )
           => ( ( finite_finite2 @ B @ S2 )
             => ( ! [X: B] :
                    ( ( member @ B @ X @ S2 )
                   => ( R @ ( H2 @ X ) @ ( G @ X ) ) )
               => ( R @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ) ).

% prod.related
thf(fact_1969_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X3: B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( ( member @ B @ X3 @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X3 @ A3 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X3 @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X3 @ A3 ) )
                = ( times_times @ A @ ( G @ X3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_1970_filtermap__inf,axiom,
    ! [A: $tType,B: $tType,F2: B > A,F12: filter @ B,F23: filter @ B] : ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ B @ A @ F2 @ ( inf_inf @ ( filter @ B ) @ F12 @ F23 ) ) @ ( inf_inf @ ( filter @ A ) @ ( filtermap @ B @ A @ F2 @ F12 ) @ ( filtermap @ B @ A @ F2 @ F23 ) ) ) ).

% filtermap_inf
thf(fact_1971_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S4: set @ B,T4: set @ C,S2: set @ B,I3: C > B,J2: B > C,T2: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite2 @ B @ S4 )
         => ( ( finite_finite2 @ C @ T4 )
           => ( ! [A7: B] :
                  ( ( member @ B @ A7 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) )
                 => ( ( I3 @ ( J2 @ A7 ) )
                    = A7 ) )
             => ( ! [A7: B] :
                    ( ( member @ B @ A7 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) )
                   => ( member @ C @ ( J2 @ A7 ) @ ( minus_minus @ ( set @ C ) @ T2 @ T4 ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T2 @ T4 ) )
                     => ( ( J2 @ ( I3 @ B6 ) )
                        = B6 ) )
                 => ( ! [B6: C] :
                        ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T2 @ T4 ) )
                       => ( member @ B @ ( I3 @ B6 ) @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) ) )
                   => ( ! [A7: B] :
                          ( ( member @ B @ A7 @ S4 )
                         => ( ( G @ A7 )
                            = ( one_one @ A ) ) )
                     => ( ! [B6: C] :
                            ( ( member @ C @ B6 @ T4 )
                           => ( ( H2 @ B6 )
                              = ( one_one @ A ) ) )
                       => ( ! [A7: B] :
                              ( ( member @ B @ A7 @ S2 )
                             => ( ( H2 @ ( J2 @ A7 ) )
                                = ( G @ A7 ) ) )
                         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                            = ( groups7121269368397514597t_prod @ C @ A @ H2 @ T2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
thf(fact_1972_sum__diff1__nat,axiom,
    ! [A: $tType,A4: A,A3: set @ A,F2: A > nat] :
      ( ( ( member @ A @ A4 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( F2 @ A4 ) ) ) )
      & ( ~ ( member @ A @ A4 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) ) ) ) ).

% sum_diff1_nat
thf(fact_1973_filtermap__fun__inverse,axiom,
    ! [B: $tType,A: $tType,G: A > B,F: filter @ B,G4: filter @ A,F2: B > A] :
      ( ( filterlim @ A @ B @ G @ F @ G4 )
     => ( ( filterlim @ B @ A @ F2 @ G4 @ F )
       => ( ( eventually @ A
            @ ^ [X2: A] :
                ( ( F2 @ ( G @ X2 ) )
                = X2 )
            @ G4 )
         => ( ( filtermap @ B @ A @ F2 @ F )
            = G4 ) ) ) ) ).

% filtermap_fun_inverse
thf(fact_1974_sum__Un__nat,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A,F2: A > nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ A @ B2 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B2 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_1975_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S3: set @ B,F2: B > A,B2: A,I3: B] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ S3 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S3 )
                = B2 )
             => ( ( member @ B @ I3 @ S3 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ B2 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_1976_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S3: set @ B,F2: B > A,I3: B] :
          ( ( finite_finite2 @ B @ S3 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ S3 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S3 )
                = ( zero_zero @ A ) )
             => ( ( member @ B @ I3 @ S3 )
               => ( ( F2 @ I3 )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_1977_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T2: set @ C,G: B > C,H2: B > A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( finite_finite2 @ C @ T2 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image2 @ B @ C @ G @ S2 ) @ T2 )
             => ( ( groups7121269368397514597t_prod @ C @ A
                  @ ^ [Y2: C] :
                      ( groups7121269368397514597t_prod @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X2: B] :
                            ( ( member @ B @ X2 @ S2 )
                            & ( ( G @ X2 )
                              = Y2 ) ) ) )
                  @ T2 )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% prod.group
thf(fact_1978_prod_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B2: set @ B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( member @ B @ X2 @ B2 ) @ ( G @ X2 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_restrict
thf(fact_1979_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( G @ X2 )
                      = ( one_one @ A ) ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod.setdiff_irrelevant
thf(fact_1980_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T2: set @ C,G: B > C,H2: B > A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( finite_finite2 @ C @ T2 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image2 @ B @ C @ G @ S2 ) @ T2 )
             => ( ( groups7311177749621191930dd_sum @ C @ A
                  @ ^ [Y2: C] :
                      ( groups7311177749621191930dd_sum @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X2: B] :
                            ( ( member @ B @ X2 @ S2 )
                            & ( ( G @ X2 )
                              = Y2 ) ) ) )
                  @ T2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% sum.group
thf(fact_1981_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B2: set @ B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( member @ B @ X2 @ B2 ) @ ( G @ X2 ) @ ( zero_zero @ A ) )
              @ A3 ) ) ) ) ).

% sum.inter_restrict
thf(fact_1982_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( G @ X2 )
                      = ( zero_zero @ A ) ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum.setdiff_irrelevant
thf(fact_1983_filtermap__SUP,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,F: C > ( filter @ B ),B2: set @ C] :
      ( ( filtermap @ B @ A @ F2 @ ( complete_Sup_Sup @ ( filter @ B ) @ ( image2 @ C @ ( filter @ B ) @ F @ B2 ) ) )
      = ( complete_Sup_Sup @ ( filter @ A )
        @ ( image2 @ C @ ( filter @ A )
          @ ^ [B4: C] : ( filtermap @ B @ A @ F2 @ ( F @ B4 ) )
          @ B2 ) ) ) ).

% filtermap_SUP
thf(fact_1984_sum_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups1027152243600224163dd_sum @ B @ A )
        = ( ^ [P6: B > A,I7: set @ B] :
              ( if @ A
              @ ( finite_finite2 @ B
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member @ B @ X2 @ I7 )
                      & ( ( P6 @ X2 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( groups7311177749621191930dd_sum @ B @ A @ P6
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member @ B @ X2 @ I7 )
                      & ( ( P6 @ X2 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( zero_zero @ A ) ) ) ) ) ).

% sum.G_def
thf(fact_1985_prod_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ B @ A )
        = ( ^ [P6: B > A,I7: set @ B] :
              ( if @ A
              @ ( finite_finite2 @ B
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member @ B @ X2 @ I7 )
                      & ( ( P6 @ X2 )
                       != ( one_one @ A ) ) ) ) )
              @ ( groups7121269368397514597t_prod @ B @ A @ P6
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member @ B @ X2 @ I7 )
                      & ( ( P6 @ X2 )
                       != ( one_one @ A ) ) ) ) )
              @ ( one_one @ A ) ) ) ) ) ).

% prod.G_def
thf(fact_1986_eventually__map__filter__on,axiom,
    ! [B: $tType,A: $tType,X5: set @ A,F: filter @ A,P: B > $o,F2: A > B] :
      ( ( eventually @ A
        @ ^ [X2: A] : ( member @ A @ X2 @ X5 )
        @ F )
     => ( ( eventually @ B @ P @ ( map_filter_on @ A @ B @ X5 @ F2 @ F ) )
        = ( eventually @ A
          @ ^ [X2: A] :
              ( ( P @ ( F2 @ X2 ) )
              & ( member @ A @ X2 @ X5 ) )
          @ F ) ) ) ).

% eventually_map_filter_on
thf(fact_1987_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,H2: B > C,G: C > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ! [X: B,Y3: B] :
                ( ( member @ B @ X @ A3 )
               => ( ( member @ B @ Y3 @ A3 )
                 => ( ( X != Y3 )
                   => ( ( ( H2 @ X )
                        = ( H2 @ Y3 ) )
                     => ( ( G @ ( H2 @ X ) )
                        = ( one_one @ A ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( image2 @ B @ C @ H2 @ A3 ) )
              = ( groups7121269368397514597t_prod @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A3 ) ) ) ) ) ).

% prod.reindex_nontrivial
thf(fact_1988_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B2: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B2 @ A3 )
         => ( ( finite_finite2 @ B @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B2 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_1989_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C3: set @ B,A3: set @ B,B2: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite2 @ B @ C3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C3 )
           => ( ( ord_less_eq @ ( set @ B ) @ B2 @ C3 )
             => ( ! [A7: B] :
                    ( ( member @ B @ A7 @ ( minus_minus @ ( set @ B ) @ C3 @ A3 ) )
                   => ( ( G @ A7 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C3 @ B2 ) )
                     => ( ( H2 @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B2 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G @ C3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C3 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_1990_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C3: set @ B,A3: set @ B,B2: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite2 @ B @ C3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C3 )
           => ( ( ord_less_eq @ ( set @ B ) @ B2 @ C3 )
             => ( ! [A7: B] :
                    ( ( member @ B @ A7 @ ( minus_minus @ ( set @ B ) @ C3 @ A3 ) )
                   => ( ( G @ A7 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C3 @ B2 ) )
                     => ( ( H2 @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ C3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C3 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B2 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_1991_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T2: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ T2 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T2 )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ ( minus_minus @ ( set @ B ) @ T2 @ S2 ) )
                 => ( ( G @ X )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ T2 ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_1992_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T2: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ T2 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T2 )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ ( minus_minus @ ( set @ B ) @ T2 @ S2 ) )
                 => ( ( G @ X )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T2 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_1993_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T2: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ T2 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T2 )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ ( minus_minus @ ( set @ B ) @ T2 @ S2 ) )
                 => ( ( H2 @ X )
                    = ( one_one @ A ) ) )
             => ( ! [X: B] :
                    ( ( member @ B @ X @ S2 )
                   => ( ( G @ X )
                      = ( H2 @ X ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T2 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_1994_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T2: set @ B,S2: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite2 @ B @ T2 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T2 )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ ( minus_minus @ ( set @ B ) @ T2 @ S2 ) )
                 => ( ( G @ X )
                    = ( one_one @ A ) ) )
             => ( ! [X: B] :
                    ( ( member @ B @ X @ S2 )
                   => ( ( G @ X )
                      = ( H2 @ X ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T2 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_1995_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B2: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B2 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B2 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_1996_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B2: set @ B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B2 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_1997_prod_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T2: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ T2 )
         => ( ( finite_finite2 @ B @ S2 )
           => ( ! [I4: B] :
                  ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ T2 @ S2 ) )
                 => ( ( H2 @ I4 )
                    = ( one_one @ A ) ) )
             => ( ! [I4: B] :
                    ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ S2 @ T2 ) )
                   => ( ( G @ I4 )
                      = ( one_one @ A ) ) )
               => ( ! [X: B] :
                      ( ( member @ B @ X @ ( inf_inf @ ( set @ B ) @ S2 @ T2 ) )
                     => ( ( G @ X )
                        = ( H2 @ X ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                    = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T2 ) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
thf(fact_1998_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T2: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ T2 )
         => ( ( finite_finite2 @ B @ S2 )
           => ( ! [I4: B] :
                  ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ T2 @ S2 ) )
                 => ( ( H2 @ I4 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I4: B] :
                    ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ S2 @ T2 ) )
                   => ( ( G @ I4 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X: B] :
                      ( ( member @ B @ X @ ( inf_inf @ ( set @ B ) @ S2 @ T2 ) )
                     => ( ( G @ X )
                        = ( H2 @ X ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T2 ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_1999_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B2: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B2 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B2 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_2000_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B2: set @ B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B2 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_2001_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( ^ [G2: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( times_times @ A ) @ G2 ) @ ( one_one @ A ) ) ) ) ) ).

% prod.eq_fold
thf(fact_2002_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S4: set @ B,T4: set @ C,H2: B > C,S2: set @ B,T2: set @ C,G: C > A] :
          ( ( finite_finite2 @ B @ S4 )
         => ( ( finite_finite2 @ C @ T4 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) @ ( minus_minus @ ( set @ C ) @ T2 @ T4 ) )
             => ( ! [A7: B] :
                    ( ( member @ B @ A7 @ S4 )
                   => ( ( G @ ( H2 @ A7 ) )
                      = ( one_one @ A ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ T4 )
                     => ( ( G @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A
                      @ ^ [X2: B] : ( G @ ( H2 @ X2 ) )
                      @ S2 )
                    = ( groups7121269368397514597t_prod @ C @ A @ G @ T2 ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
thf(fact_2003_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S4: set @ B,T4: set @ C,H2: B > C,S2: set @ B,T2: set @ C,G: C > A] :
          ( ( finite_finite2 @ B @ S4 )
         => ( ( finite_finite2 @ C @ T4 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) @ ( minus_minus @ ( set @ C ) @ T2 @ T4 ) )
             => ( ! [A7: B] :
                    ( ( member @ B @ A7 @ S4 )
                   => ( ( G @ ( H2 @ A7 ) )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ T4 )
                     => ( ( G @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A
                      @ ^ [X2: B] : ( G @ ( H2 @ X2 ) )
                      @ S2 )
                    = ( groups7311177749621191930dd_sum @ C @ A @ G @ T2 ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
thf(fact_2004_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( H2 @ X2 ) @ ( G @ X2 ) )
              @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_2005_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( H2 @ X2 ) @ ( G @ X2 ) )
              @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_2006_filtermap__INF,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,F: C > ( filter @ B ),B2: set @ C] :
      ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ B @ A @ F2 @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ C @ ( filter @ B ) @ F @ B2 ) ) )
      @ ( complete_Inf_Inf @ ( filter @ A )
        @ ( image2 @ C @ ( filter @ A )
          @ ^ [B4: C] : ( filtermap @ B @ A @ F2 @ ( F @ B4 ) )
          @ B2 ) ) ) ).

% filtermap_INF
thf(fact_2007_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X2: A] : ( ord_less_eq @ A @ X2 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_2008_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X3: B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( member @ B @ X3 @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( G @ X3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_2009_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,X3: B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X3 @ A3 ) )
            = ( times_times @ A @ ( G @ X3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_2010_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B2: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B2 )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) )
                 => ( ( G @ X )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B2 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_2011_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B2: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B2 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B2 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B2 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_2012_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B2: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B2 )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) )
                 => ( ( G @ X )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B2 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_2013_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,X3: B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X3 @ A3 ) )
            = ( plus_plus @ A @ ( G @ X3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% sum.insert_remove
thf(fact_2014_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X3: B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( member @ B @ X3 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( G @ X3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.remove
thf(fact_2015_sum__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,A4: B,F2: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( ( member @ B @ A4 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) )
                = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( F2 @ A4 ) ) ) )
            & ( ~ ( member @ B @ A4 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% sum_diff1
thf(fact_2016_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B2: set @ B,F2: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B2 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_2017_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B2: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B2 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B2 @ A3 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_2018_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B2: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B2 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B2 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B2 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_2019_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B2: set @ B,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B2 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B2 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_2020_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A3: set @ A,B2: set @ A,F2: A > B] :
          ( ( finite_finite2 @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B2 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_2021_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A4: B,B3: B > A,C2: B > A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( ( member @ B @ A4 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ ( C2 @ K6 ) )
                  @ S2 )
                = ( times_times @ A @ ( B3 @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A4 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ ( C2 @ K6 ) )
                  @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_2022_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A4: B,B3: B > A,C2: B > A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( ( member @ B @ A4 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ ( C2 @ K6 ) )
                  @ S2 )
                = ( plus_plus @ A @ ( B3 @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A4 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ ( C2 @ K6 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.delta_remove
thf(fact_2023_prod_OUNION__disjoint,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I: set @ B,A3: B > ( set @ C ),G: C > A] :
          ( ( finite_finite2 @ B @ I )
         => ( ! [X: B] :
                ( ( member @ B @ X @ I )
               => ( finite_finite2 @ C @ ( A3 @ X ) ) )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ I )
                 => ! [Xa2: B] :
                      ( ( member @ B @ Xa2 @ I )
                     => ( ( X != Xa2 )
                       => ( ( inf_inf @ ( set @ C ) @ ( A3 @ X ) @ ( A3 @ Xa2 ) )
                          = ( bot_bot @ ( set @ C ) ) ) ) ) )
             => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A3 @ I ) ) )
                = ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [X2: B] : ( groups7121269368397514597t_prod @ C @ A @ G @ ( A3 @ X2 ) )
                  @ I ) ) ) ) ) ) ).

% prod.UNION_disjoint
thf(fact_2024_sum_OUNION__disjoint,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I: set @ B,A3: B > ( set @ C ),G: C > A] :
          ( ( finite_finite2 @ B @ I )
         => ( ! [X: B] :
                ( ( member @ B @ X @ I )
               => ( finite_finite2 @ C @ ( A3 @ X ) ) )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ I )
                 => ! [Xa2: B] :
                      ( ( member @ B @ Xa2 @ I )
                     => ( ( X != Xa2 )
                       => ( ( inf_inf @ ( set @ C ) @ ( A3 @ X ) @ ( A3 @ Xa2 ) )
                          = ( bot_bot @ ( set @ C ) ) ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A3 @ I ) ) )
                = ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [X2: B] : ( groups7311177749621191930dd_sum @ C @ A @ G @ ( A3 @ X2 ) )
                  @ I ) ) ) ) ) ) ).

% sum.UNION_disjoint
thf(fact_2025_at__bot__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( at_bot @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image2 @ A @ ( filter @ A )
            @ ^ [K6: A] : ( principal @ A @ ( set_ord_atMost @ A @ K6 ) )
            @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% at_bot_def
thf(fact_2026_sum__mult__sum__if__inj,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,G: C > B,A3: set @ A,B2: set @ C] :
          ( ( inj_on @ ( product_prod @ A @ C ) @ B
            @ ( product_case_prod @ A @ C @ B
              @ ^ [A5: A,B4: C] : ( times_times @ B @ ( F2 @ A5 ) @ ( G @ B4 ) ) )
            @ ( product_Sigma @ A @ C @ A3
              @ ^ [Uu: A] : B2 ) )
         => ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B2 ) )
            = ( groups7311177749621191930dd_sum @ B @ B @ ( id @ B )
              @ ( collect @ B
                @ ^ [Uu: B] :
                  ? [A5: A,B4: C] :
                    ( ( Uu
                      = ( times_times @ B @ ( F2 @ A5 ) @ ( G @ B4 ) ) )
                    & ( member @ A @ A5 @ A3 )
                    & ( member @ C @ B4 @ B2 ) ) ) ) ) ) ) ).

% sum_mult_sum_if_inj
thf(fact_2027_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A3: set @ B,B2: set @ B,F2: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ B2 )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) )
                 => ( ( F2 @ X )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_2028_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: set @ B,F2: B > A,A4: B] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( ( F2 @ A4 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A4 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( F2 @ A4 ) ) ) )
              & ( ~ ( member @ B @ A4 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_2029_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I: set @ A,X3: A > B,A4: A > B,B3: B,Delta: B] :
          ( ! [I4: A] :
              ( ( member @ A @ I4 @ I )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X3 @ I4 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X3 @ I )
              = ( one_one @ B ) )
           => ( ! [I4: A] :
                  ( ( member @ A @ I4 @ I )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A4 @ I4 ) @ B3 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I2: A] : ( times_times @ B @ ( A4 @ I2 ) @ ( X3 @ I2 ) )
                      @ I )
                    @ B3 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_2030_at__bot__sub,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( ( at_bot @ A )
          = ( complete_Inf_Inf @ ( filter @ A )
            @ ( image2 @ A @ ( filter @ A )
              @ ^ [K6: A] : ( principal @ A @ ( set_ord_atMost @ A @ K6 ) )
              @ ( set_ord_atMost @ A @ C2 ) ) ) ) ) ).

% at_bot_sub
thf(fact_2031_prod__filter__principal__singleton2,axiom,
    ! [B: $tType,A: $tType,F: filter @ A,X3: B] :
      ( ( prod_filter @ A @ B @ F @ ( principal @ B @ ( insert @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) )
      = ( filtermap @ A @ ( product_prod @ A @ B )
        @ ^ [A5: A] : ( product_Pair @ A @ B @ A5 @ X3 )
        @ F ) ) ).

% prod_filter_principal_singleton2
thf(fact_2032_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A4 ) )
          = ( abs_abs @ A @ A4 ) ) ) ).

% abs_idempotent
thf(fact_2033_abs__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A4 ) )
          = ( abs_abs @ A @ A4 ) ) ) ).

% abs_abs
thf(fact_2034_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A4: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A4 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_2035_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A4: A] :
          ( ( divide_divide @ A @ A4 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_2036_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B3 @ C2 ) @ A4 )
          = ( divide_divide @ A @ ( times_times @ A @ B3 @ A4 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_2037_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A4 @ B3 ) @ C2 )
          = ( divide_divide @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_2038_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( divide_divide @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) ) ) ).

% divide_divide_eq_right
thf(fact_2039_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_2040_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A4: A] :
          ( ( divide_divide @ A @ A4 @ ( one_one @ A ) )
          = A4 ) ) ).

% div_by_1
thf(fact_2041_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A4 ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_2042_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ( ( ( abs_abs @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_2043_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_2044_abs__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_0
thf(fact_2045_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ B3 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ B3 ) ) ) ) ).

% abs_add_abs
thf(fact_2046_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ A4 ) )
          = ( times_times @ A @ A4 @ A4 ) ) ) ).

% abs_mult_self_eq
thf(fact_2047_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_2048_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A4 ) )
          = ( abs_abs @ A @ A4 ) ) ) ).

% abs_minus_cancel
thf(fact_2049_abs__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A4 ) )
          = ( abs_abs @ A @ A4 ) ) ) ).

% abs_minus
thf(fact_2050_abs__sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A3: set @ A] :
          ( ( abs_abs @ B
            @ ( groups7311177749621191930dd_sum @ A @ B
              @ ^ [A5: A] : ( abs_abs @ B @ ( F2 @ A5 ) )
              @ A3 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [A5: A] : ( abs_abs @ B @ ( F2 @ A5 ) )
            @ A3 ) ) ) ).

% abs_sum_abs
thf(fact_2051_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
              = ( divide_divide @ A @ A4 @ B3 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_2052_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
            = ( divide_divide @ A @ A4 @ B3 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_2053_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ B3 @ C2 ) )
            = ( divide_divide @ A @ A4 @ B3 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_2054_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
            = ( divide_divide @ A @ A4 @ B3 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_2055_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ C2 @ B3 ) )
            = ( divide_divide @ A @ A4 @ B3 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_2056_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A4 @ B3 ) @ A4 )
            = B3 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_2057_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B3: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A4 @ B3 ) @ B3 )
            = A4 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_2058_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A4 ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_2059_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A4 )
            = ( zero_zero @ A ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_2060_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,A4: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B3 @ A4 ) )
          = ( ( A4
             != ( zero_zero @ A ) )
            & ( A4 = B3 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_2061_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,A4: A] :
          ( ( ( divide_divide @ A @ B3 @ A4 )
            = ( one_one @ A ) )
          = ( ( A4
             != ( zero_zero @ A ) )
            & ( A4 = B3 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_2062_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A] :
          ( ( ( A4
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A4 @ A4 )
              = ( zero_zero @ A ) ) )
          & ( ( A4
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A4 @ A4 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_2063_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A4 @ A4 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_2064_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: A,B3: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A4 @ B3 ) )
          = ( ( B3
             != ( zero_zero @ A ) )
            & ( A4 = B3 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_2065_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: A,B3: A] :
          ( ( ( divide_divide @ A @ A4 @ B3 )
            = ( one_one @ A ) )
          = ( ( B3
             != ( zero_zero @ A ) )
            & ( A4 = B3 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_2066_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A4: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A4 @ A4 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_2067_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A4 ) @ ( zero_zero @ A ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_2068_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A4 ) @ A4 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 ) ) ) ).

% abs_le_self_iff
thf(fact_2069_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( abs_abs @ A @ A4 )
            = A4 ) ) ) ).

% abs_of_nonneg
thf(fact_2070_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A] :
          ( ( divide_divide @ A @ X3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X3 ) ) ) ).

% divide_minus1
thf(fact_2071_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_2072_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I2: A] : ( abs_abs @ B @ ( F2 @ I2 ) )
            @ A3 ) ) ) ).

% sum_abs
thf(fact_2073_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A4 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_2074_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A4 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_2075_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A4 @ ( times_times @ A @ A4 @ B3 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B3 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_2076_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B3: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B3 @ ( times_times @ A @ A4 @ B3 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A4 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_2077_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A4 )
            = ( uminus_uminus @ A @ A4 ) ) ) ) ).

% abs_of_nonpos
thf(fact_2078_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I2: A] : ( abs_abs @ B @ ( F2 @ I2 ) )
            @ A3 ) ) ) ).

% sum_abs_ge_zero
thf(fact_2079_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: A] :
          ( ( inj_on @ A @ A
            @ ^ [B4: A] : ( divide_divide @ A @ B4 @ A4 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A4
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_2080_sum__subtractf__nat,axiom,
    ! [A: $tType,A3: set @ A,G: A > nat,F2: A > nat] :
      ( ! [X: A] :
          ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ nat @ ( G @ X ) @ ( F2 @ X ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X2: A] : ( minus_minus @ nat @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ A3 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G @ A3 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_2081_prod__filter__assoc,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: filter @ A,G4: filter @ B,H9: filter @ C] :
      ( ( prod_filter @ ( product_prod @ A @ B ) @ C @ ( prod_filter @ A @ B @ F @ G4 ) @ H9 )
      = ( filtermap @ ( product_prod @ A @ ( product_prod @ B @ C ) ) @ ( product_prod @ ( product_prod @ A @ B ) @ C )
        @ ( product_case_prod @ A @ ( product_prod @ B @ C ) @ ( product_prod @ ( product_prod @ A @ B ) @ C )
          @ ^ [X2: A] :
              ( product_case_prod @ B @ C @ ( product_prod @ ( product_prod @ A @ B ) @ C )
              @ ^ [Y2: B] : ( product_Pair @ ( product_prod @ A @ B ) @ C @ ( product_Pair @ A @ B @ X2 @ Y2 ) ) ) )
        @ ( prod_filter @ A @ ( product_prod @ B @ C ) @ F @ ( prod_filter @ B @ C @ G4 @ H9 ) ) ) ) ).

% prod_filter_assoc
thf(fact_2082_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A4 ) @ B3 )
         => ( ord_less_eq @ A @ A4 @ B3 ) ) ) ).

% abs_le_D1
thf(fact_2083_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] : ( ord_less_eq @ A @ A4 @ ( abs_abs @ A @ A4 ) ) ) ).

% abs_ge_self
thf(fact_2084_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A] :
          ( ( ( abs_abs @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0_iff
thf(fact_2085_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A,B3: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ B3 ) ) ) ) ).

% abs_mult
thf(fact_2086_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_2087_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A4 @ B3 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B3 @ A4 ) ) ) ) ).

% abs_minus_commute
thf(fact_2088_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X3: A,Y: A] :
          ( ( ( abs_abs @ A @ X3 )
            = ( abs_abs @ A @ Y ) )
          = ( ( X3 = Y )
            | ( X3
              = ( uminus_uminus @ A @ Y ) ) ) ) ) ).

% abs_eq_iff
thf(fact_2089_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,Y: A,Z2: A,W2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X3 @ Y ) @ ( divide_divide @ A @ Z2 @ W2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ Y @ W2 ) ) ) ) ).

% times_divide_times_eq
thf(fact_2090_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,Y: A,Z2: A,W2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X3 @ Y ) @ ( divide_divide @ A @ Z2 @ W2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ X3 @ W2 ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ).

% divide_divide_times_eq
thf(fact_2091_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A4 @ B3 ) @ C2 )
          = ( divide_divide @ A @ A4 @ ( times_times @ A @ C2 @ B3 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_2092_abs__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_field @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( abs_abs @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( abs_abs @ A @ ( F2 @ X2 ) )
            @ A3 ) ) ) ).

% abs_prod
thf(fact_2093_set_Oidentity,axiom,
    ! [A: $tType] :
      ( ( vimage @ A @ A
        @ ^ [X2: A] : X2 )
      = ( id @ ( set @ A ) ) ) ).

% set.identity
thf(fact_2094_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,A3: set @ B,R5: A] :
          ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ R5 )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N5: B] : ( divide_divide @ A @ ( F2 @ N5 ) @ R5 )
            @ A3 ) ) ) ).

% sum_divide_distrib
thf(fact_2095_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ A3 )
          = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_dividef
thf(fact_2096_prod__filter__eq__bot,axiom,
    ! [A: $tType,B: $tType,A3: filter @ A,B2: filter @ B] :
      ( ( ( prod_filter @ A @ B @ A3 @ B2 )
        = ( bot_bot @ ( filter @ ( product_prod @ A @ B ) ) ) )
      = ( ( A3
          = ( bot_bot @ ( filter @ A ) ) )
        | ( B2
          = ( bot_bot @ ( filter @ B ) ) ) ) ) ).

% prod_filter_eq_bot
thf(fact_2097_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A4 ) ) ) ).

% abs_ge_zero
thf(fact_2098_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A4 @ B3 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ B3 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_2099_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ B3 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A4 @ B3 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_2100_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ B3 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A4 @ B3 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_2101_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ B3 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B3 @ A4 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_2102_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A4 ) @ B3 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A4 ) @ B3 ) ) ) ) ).

% abs_leI
thf(fact_2103_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A4 ) @ B3 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A4 ) @ B3 ) ) ) ).

% abs_le_D2
thf(fact_2104_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A4 ) @ B3 )
          = ( ( ord_less_eq @ A @ A4 @ B3 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A4 ) @ B3 ) ) ) ) ).

% abs_le_iff
thf(fact_2105_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A4 ) @ ( abs_abs @ A @ A4 ) ) ) ).

% abs_ge_minus_self
thf(fact_2106_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X3: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X3 @ Y )
                = ( divide_divide @ A @ W2 @ Z2 ) )
              = ( ( times_times @ A @ X3 @ Z2 )
                = ( times_times @ A @ W2 @ Y ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_2107_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ( divide_divide @ A @ B3 @ C2 )
            = A4 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B3
                = ( times_times @ A @ A4 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_2108_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4
            = ( divide_divide @ A @ B3 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A4 @ C2 )
                = B3 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_2109_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B3
              = ( times_times @ A @ A4 @ C2 ) )
           => ( ( divide_divide @ A @ B3 @ C2 )
              = A4 ) ) ) ) ).

% divide_eq_imp
thf(fact_2110_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A4 @ C2 )
              = B3 )
           => ( A4
              = ( divide_divide @ A @ B3 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_2111_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B3 @ C2 )
              = A4 )
            = ( B3
              = ( times_times @ A @ A4 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_2112_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A4
              = ( divide_divide @ A @ B3 @ C2 ) )
            = ( ( times_times @ A @ A4 @ C2 )
              = B3 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_2113_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B3: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A4 @ B3 )
              = ( one_one @ A ) )
            = ( A4 = B3 ) ) ) ) ).

% right_inverse_eq
thf(fact_2114_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A4: A,B3: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
              | ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 )
              | ( ord_less_eq @ A @ B3 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A4 @ B3 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ B3 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_2115_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y ) @ X3 )
            = ( abs_abs @ A @ ( times_times @ A @ Y @ X3 ) ) ) ) ) ).

% abs_mult_pos
thf(fact_2116_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A4 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_2117_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A4: A,B3: A] :
          ( ( ( abs_abs @ A @ A4 )
            = B3 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 )
            & ( ( A4 = B3 )
              | ( A4
                = ( uminus_uminus @ A @ B3 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_2118_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
            = ( abs_abs @ A @ B3 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
            & ( ( B3 = A4 )
              | ( B3
                = ( uminus_uminus @ A @ A4 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_2119_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A4 @ B3 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ B3 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_2120_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A4 @ B3 ) @ ( plus_plus @ A @ C2 @ D3 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A4 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B3 @ D3 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_2121_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,A4: A,R5: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ A4 ) ) @ R5 )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ R5 ) @ X3 )
            & ( ord_less_eq @ A @ X3 @ ( plus_plus @ A @ A4 @ R5 ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_2122_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A4: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ A4 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S2 ) ) @ A4 ) ) ) ) ).

% cSup_abs_le
thf(fact_2123_prod__filter__mono__iff,axiom,
    ! [A: $tType,B: $tType,A3: filter @ A,B2: filter @ B,C3: filter @ A,D2: filter @ B] :
      ( ( A3
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( B2
         != ( bot_bot @ ( filter @ B ) ) )
       => ( ( ord_less_eq @ ( filter @ ( product_prod @ A @ B ) ) @ ( prod_filter @ A @ B @ A3 @ B2 ) @ ( prod_filter @ A @ B @ C3 @ D2 ) )
          = ( ( ord_less_eq @ ( filter @ A ) @ A3 @ C3 )
            & ( ord_less_eq @ ( filter @ B ) @ B2 @ D2 ) ) ) ) ) ).

% prod_filter_mono_iff
thf(fact_2124_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A4 @ Z2 ) @ B3 )
              = B3 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A4 @ Z2 ) @ B3 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A4 @ ( times_times @ A @ B3 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_2125_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A4 @ ( divide_divide @ A @ B3 @ Z2 ) )
              = A4 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A4 @ ( divide_divide @ A @ B3 @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A4 @ Z2 ) @ B3 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_2126_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X3: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X3 @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_2127_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,X3: A,Z2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X3 @ Y ) @ Z2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X3 @ ( times_times @ A @ Z2 @ Y ) ) @ Y ) ) ) ) ).

% add_frac_num
thf(fact_2128_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X3: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ X3 @ Y ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X3 @ ( times_times @ A @ Z2 @ Y ) ) @ Y ) ) ) ) ).

% add_num_frac
thf(fact_2129_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X3 @ ( divide_divide @ A @ Y @ Z2 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X3 @ Z2 ) @ Y ) @ Z2 ) ) ) ) ).

% add_divide_eq_iff
thf(fact_2130_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X3 @ Z2 ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ X3 @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_add_eq_iff
thf(fact_2131_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A4 @ ( divide_divide @ A @ B3 @ Z2 ) )
              = A4 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A4 @ ( divide_divide @ A @ B3 @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A4 @ Z2 ) @ B3 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_2132_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X3: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X3 @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_2133_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X3 @ ( divide_divide @ A @ Y @ Z2 ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X3 @ Z2 ) @ Y ) @ Z2 ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_2134_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X3 @ Z2 ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ X3 @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_2135_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A4 @ C2 )
                = ( uminus_uminus @ A @ B3 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_2136_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) )
            = A4 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B3 )
                = ( times_times @ A @ A4 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_2137_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A4 @ B3 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A4 )
              = ( times_times @ A @ C2 @ B3 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_2138_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A4 @ B3 ) ) )
            = ( ( times_times @ A @ C2 @ B3 )
              = ( uminus_uminus @ A @ A4 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_2139_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: A,B3: A] :
          ( ( ( divide_divide @ A @ A4 @ B3 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B3
             != ( zero_zero @ A ) )
            & ( A4
              = ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_2140_filterlim__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: A > B,G4: filter @ B,F: filter @ A,G: A > C,H9: filter @ C] :
      ( ( filterlim @ A @ B @ F2 @ G4 @ F )
     => ( ( filterlim @ A @ C @ G @ H9 @ F )
       => ( filterlim @ A @ ( product_prod @ B @ C )
          @ ^ [X2: A] : ( product_Pair @ B @ C @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ ( prod_filter @ B @ C @ G4 @ H9 )
          @ F ) ) ) ).

% filterlim_Pair
thf(fact_2141_filtermap__Pair,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: C > A,G: C > B,F: filter @ C] :
      ( ord_less_eq @ ( filter @ ( product_prod @ A @ B ) )
      @ ( filtermap @ C @ ( product_prod @ A @ B )
        @ ^ [X2: C] : ( product_Pair @ A @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ F )
      @ ( prod_filter @ A @ B @ ( filtermap @ C @ A @ F2 @ F ) @ ( filtermap @ C @ B @ G @ F ) ) ) ).

% filtermap_Pair
thf(fact_2142_principal__prod__principal,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B] :
      ( ( prod_filter @ A @ B @ ( principal @ A @ A3 ) @ ( principal @ B @ B2 ) )
      = ( principal @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 ) ) ) ).

% principal_prod_principal
thf(fact_2143_fst__diag__id,axiom,
    ! [A: $tType,Z2: A] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ A @ ( product_fst @ A @ A )
        @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
        @ Z2 )
      = ( id @ A @ Z2 ) ) ).

% fst_diag_id
thf(fact_2144_snd__diag__id,axiom,
    ! [A: $tType,Z2: A] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ A @ ( product_snd @ A @ A )
        @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
        @ Z2 )
      = ( id @ A @ Z2 ) ) ).

% snd_diag_id
thf(fact_2145_prod__filter__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( prod_filter @ A @ B )
      = ( ^ [F5: filter @ A,G7: filter @ B] :
            ( complete_Inf_Inf @ ( filter @ ( product_prod @ A @ B ) )
            @ ( image2 @ ( product_prod @ ( A > $o ) @ ( B > $o ) ) @ ( filter @ ( product_prod @ A @ B ) )
              @ ( product_case_prod @ ( A > $o ) @ ( B > $o ) @ ( filter @ ( product_prod @ A @ B ) )
                @ ^ [P3: A > $o,Q3: B > $o] :
                    ( principal @ ( product_prod @ A @ B )
                    @ ( collect @ ( product_prod @ A @ B )
                      @ ( product_case_prod @ A @ B @ $o
                        @ ^ [X2: A,Y2: B] :
                            ( ( P3 @ X2 )
                            & ( Q3 @ Y2 ) ) ) ) ) )
              @ ( collect @ ( product_prod @ ( A > $o ) @ ( B > $o ) )
                @ ( product_case_prod @ ( A > $o ) @ ( B > $o ) @ $o
                  @ ^ [P3: A > $o,Q3: B > $o] :
                      ( ( eventually @ A @ P3 @ F5 )
                      & ( eventually @ B @ Q3 @ G7 ) ) ) ) ) ) ) ) ).

% prod_filter_def
thf(fact_2146_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X3: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X3 @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_2147_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X3 @ Z2 ) ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X3 ) @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_2148_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A4 @ Z2 ) ) @ B3 )
              = B3 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A4 @ Z2 ) ) @ B3 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A4 ) @ ( times_times @ A @ B3 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_2149_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A4 @ Z2 ) ) @ B3 )
              = ( uminus_uminus @ A @ B3 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A4 @ Z2 ) ) @ B3 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A4 ) @ ( times_times @ A @ B3 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_2150_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A4 @ Z2 ) @ B3 )
              = ( uminus_uminus @ A @ B3 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A4 @ Z2 ) @ B3 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A4 @ ( times_times @ A @ B3 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_2151_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X3 @ Z2 ) ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X3 ) @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_2152_eventually__prodI,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F: filter @ A,Q: B > $o,G4: filter @ B] :
      ( ( eventually @ A @ P @ F )
     => ( ( eventually @ B @ Q @ G4 )
       => ( eventually @ ( product_prod @ A @ B )
          @ ^ [X2: product_prod @ A @ B] :
              ( ( P @ ( product_fst @ A @ B @ X2 ) )
              & ( Q @ ( product_snd @ A @ B @ X2 ) ) )
          @ ( prod_filter @ A @ B @ F @ G4 ) ) ) ) ).

% eventually_prodI
thf(fact_2153_If__the__inv__into__f__f,axiom,
    ! [B: $tType,A: $tType,I3: A,C3: set @ A,G: A > B,X3: A] :
      ( ( member @ A @ I3 @ C3 )
     => ( ( inj_on @ A @ B @ G @ C3 )
       => ( ( comp @ B @ A @ A
            @ ^ [I2: B] : ( if @ A @ ( member @ B @ I2 @ ( image2 @ A @ B @ G @ C3 ) ) @ ( the_inv_into @ A @ B @ C3 @ G @ I2 ) @ X3 )
            @ G
            @ I3 )
          = ( id @ A @ I3 ) ) ) ) ).

% If_the_inv_into_f_f
thf(fact_2154_eventually__prod1,axiom,
    ! [A: $tType,B: $tType,B2: filter @ A,P: B > $o,A3: filter @ B] :
      ( ( B2
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ ( product_prod @ B @ A )
          @ ( product_case_prod @ B @ A @ $o
            @ ^ [X2: B,Y2: A] : ( P @ X2 ) )
          @ ( prod_filter @ B @ A @ A3 @ B2 ) )
        = ( eventually @ B @ P @ A3 ) ) ) ).

% eventually_prod1
thf(fact_2155_eventually__prod2,axiom,
    ! [A: $tType,B: $tType,A3: filter @ A,P: B > $o,B2: filter @ B] :
      ( ( A3
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ B @ $o
            @ ^ [X2: A] : P )
          @ ( prod_filter @ A @ B @ A3 @ B2 ) )
        = ( eventually @ B @ P @ B2 ) ) ) ).

% eventually_prod2
thf(fact_2156_prod__filter__INF2,axiom,
    ! [B: $tType,C: $tType,A: $tType,J: set @ A,A3: filter @ B,B2: A > ( filter @ C )] :
      ( ( J
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( prod_filter @ B @ C @ A3 @ ( complete_Inf_Inf @ ( filter @ C ) @ ( image2 @ A @ ( filter @ C ) @ B2 @ J ) ) )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ B @ C ) )
          @ ( image2 @ A @ ( filter @ ( product_prod @ B @ C ) )
            @ ^ [I2: A] : ( prod_filter @ B @ C @ A3 @ ( B2 @ I2 ) )
            @ J ) ) ) ) ).

% prod_filter_INF2
thf(fact_2157_prod__filter__INF1,axiom,
    ! [B: $tType,C: $tType,A: $tType,I: set @ A,A3: A > ( filter @ B ),B2: filter @ C] :
      ( ( I
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( prod_filter @ B @ C @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ A @ ( filter @ B ) @ A3 @ I ) ) @ B2 )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ B @ C ) )
          @ ( image2 @ A @ ( filter @ ( product_prod @ B @ C ) )
            @ ^ [I2: A] : ( prod_filter @ B @ C @ ( A3 @ I2 ) @ B2 )
            @ I ) ) ) ) ).

% prod_filter_INF1
thf(fact_2158_prod__filter__INF,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,I: set @ A,J: set @ B,A3: A > ( filter @ C ),B2: B > ( filter @ D )] :
      ( ( I
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( J
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( prod_filter @ C @ D @ ( complete_Inf_Inf @ ( filter @ C ) @ ( image2 @ A @ ( filter @ C ) @ A3 @ I ) ) @ ( complete_Inf_Inf @ ( filter @ D ) @ ( image2 @ B @ ( filter @ D ) @ B2 @ J ) ) )
          = ( complete_Inf_Inf @ ( filter @ ( product_prod @ C @ D ) )
            @ ( image2 @ A @ ( filter @ ( product_prod @ C @ D ) )
              @ ^ [I2: A] :
                  ( complete_Inf_Inf @ ( filter @ ( product_prod @ C @ D ) )
                  @ ( image2 @ B @ ( filter @ ( product_prod @ C @ D ) )
                    @ ^ [J3: B] : ( prod_filter @ C @ D @ ( A3 @ I2 ) @ ( B2 @ J3 ) )
                    @ J ) )
              @ I ) ) ) ) ) ).

% prod_filter_INF
thf(fact_2159_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U2: A,V: A,R5: A,S3: A] :
          ( ( ord_less_eq @ A @ U2 @ V )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R5 )
           => ( ( ord_less_eq @ A @ R5 @ S3 )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U2 @ ( divide_divide @ A @ ( times_times @ A @ R5 @ ( minus_minus @ A @ V @ U2 ) ) @ S3 ) ) @ V ) ) ) ) ) ).

% scaling_mono
thf(fact_2160_prod__filter__principal__singleton,axiom,
    ! [A: $tType,B: $tType,X3: A,F: filter @ B] :
      ( ( prod_filter @ A @ B @ ( principal @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ F )
      = ( filtermap @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 ) @ F ) ) ).

% prod_filter_principal_singleton
thf(fact_2161_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A4 @ ( times_times @ A @ C2 @ B3 ) ) @ B3 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A4 @ B3 ) ) ) ) ) ).

% div_mult_self1
thf(fact_2162_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) ) @ B3 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A4 @ B3 ) ) ) ) ) ).

% div_mult_self2
thf(fact_2163_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B3 ) @ A4 ) @ B3 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A4 @ B3 ) ) ) ) ) ).

% div_mult_self3
thf(fact_2164_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B3 @ C2 ) @ A4 ) @ B3 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A4 @ B3 ) ) ) ) ) ).

% div_mult_self4
thf(fact_2165_Inf__atMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A] :
          ( ( complete_Inf_Inf @ A @ ( set_ord_atMost @ A @ X3 ) )
          = ( bot_bot @ A ) ) ) ).

% Inf_atMost
thf(fact_2166_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A4: A] :
          ( ( divide_divide @ A @ A4 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A4 ) ) ) ).

% div_minus1_right
thf(fact_2167_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
            = ( divide_divide @ A @ A4 @ B3 ) ) ) ) ).

% div_mult_mult1
thf(fact_2168_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite2 @ nat
      @ ( collect @ nat
        @ ^ [N5: nat] : ( ord_less_eq @ nat @ N5 @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_2169_atMost__0,axiom,
    ( ( set_ord_atMost @ nat @ ( zero_zero @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atMost_0
thf(fact_2170_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
              = ( divide_divide @ A @ A4 @ B3 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_2171_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
            = ( divide_divide @ A @ A4 @ B3 ) ) ) ) ).

% div_mult_mult2
thf(fact_2172_finite__less__ub,axiom,
    ! [F2: nat > nat,U2: nat] :
      ( ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( F2 @ N2 ) )
     => ( finite_finite2 @ nat
        @ ( collect @ nat
          @ ^ [N5: nat] : ( ord_less_eq @ nat @ ( F2 @ N5 ) @ U2 ) ) ) ) ).

% finite_less_ub
thf(fact_2173_not__empty__eq__Iic__eq__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [H2: A] :
          ( ( bot_bot @ ( set @ A ) )
         != ( set_ord_atMost @ A @ H2 ) ) ) ).

% not_empty_eq_Iic_eq_empty
thf(fact_2174_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I2: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ J3 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( G @ I2 @ ( minus_minus @ nat @ K6 @ I2 ) )
                @ ( set_ord_atMost @ nat @ K6 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_2175_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I2: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ J3 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K6: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( G @ I2 @ ( minus_minus @ nat @ K6 @ I2 ) )
                @ ( set_ord_atMost @ nat @ K6 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_2176_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U: A] :
              ( collect @ A
              @ ^ [X2: A] : ( ord_less_eq @ A @ X2 @ U ) ) ) ) ) ).

% atMost_def
thf(fact_2177_atMost__eq__UNIV__iff,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X3: A] :
          ( ( ( set_ord_atMost @ A @ X3 )
            = ( top_top @ ( set @ A ) ) )
          = ( X3
            = ( top_top @ A ) ) ) ) ).

% atMost_eq_UNIV_iff
thf(fact_2178_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B3: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B3 @ A4 ) @ B3 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A4 @ B3 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_2179_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B3: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A4 @ B3 ) @ B3 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A4 @ B3 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_2180_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S2 ) @ L ) ) @ E2 ) ) ) ) ).

% cInf_asclose
thf(fact_2181_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S2 ) @ L ) ) @ E2 ) ) ) ) ).

% cSup_asclose
thf(fact_2182_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A4: A] :
          ( ( divide_divide @ A @ A4 @ ( one_one @ A ) )
          = A4 ) ) ).

% bits_div_by_1
thf(fact_2183_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A4: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ A4 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S2 ) ) @ A4 ) ) ) ) ).

% cInf_abs_ge
thf(fact_2184_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A4 @ B3 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_2185_inj__on__diff__nat,axiom,
    ! [N4: set @ nat,K: nat] :
      ( ! [N2: nat] :
          ( ( member @ nat @ N2 @ N4 )
         => ( ord_less_eq @ nat @ K @ N2 ) )
     => ( inj_on @ nat @ nat
        @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ K )
        @ N4 ) ) ).

% inj_on_diff_nat
thf(fact_2186_card__UN__disjoint,axiom,
    ! [B: $tType,A: $tType,I: set @ A,A3: A > ( set @ B )] :
      ( ( finite_finite2 @ A @ I )
     => ( ! [X: A] :
            ( ( member @ A @ X @ I )
           => ( finite_finite2 @ B @ ( A3 @ X ) ) )
       => ( ! [X: A] :
              ( ( member @ A @ X @ I )
             => ! [Xa2: A] :
                  ( ( member @ A @ Xa2 @ I )
                 => ( ( X != Xa2 )
                   => ( ( inf_inf @ ( set @ B ) @ ( A3 @ X ) @ ( A3 @ Xa2 ) )
                      = ( bot_bot @ ( set @ B ) ) ) ) ) )
         => ( ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ I ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I2: A] : ( finite_card @ B @ ( A3 @ I2 ) )
              @ I ) ) ) ) ) ).

% card_UN_disjoint
thf(fact_2187_card_Oempty,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ nat ) ) ).

% card.empty
thf(fact_2188_card__0__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ( finite_card @ A @ A3 )
          = ( zero_zero @ nat ) )
        = ( A3
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_0_eq
thf(fact_2189_card__SigmaI,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: A > ( set @ B )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ! [X: A] :
            ( ( member @ A @ X @ A3 )
           => ( finite_finite2 @ B @ ( B2 @ X ) ) )
       => ( ( finite_card @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ A3 @ B2 ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [A5: A] : ( finite_card @ B @ ( B2 @ A5 ) )
            @ A3 ) ) ) ) ).

% card_SigmaI
thf(fact_2190_UN__atMost__UNIV,axiom,
    ( ( complete_Sup_Sup @ ( set @ nat ) @ ( image2 @ nat @ ( set @ nat ) @ ( set_ord_atMost @ nat ) @ ( top_top @ ( set @ nat ) ) ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% UN_atMost_UNIV
thf(fact_2191_card__cartesian__product,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B] :
      ( ( finite_card @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B2 ) )
      = ( times_times @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B2 ) ) ) ).

% card_cartesian_product
thf(fact_2192_card__cartesian__product__singleton,axiom,
    ! [A: $tType,B: $tType,X3: A,A3: set @ B] :
      ( ( finite_card @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) )
          @ ^ [Uu: A] : A3 ) )
      = ( finite_card @ B @ A3 ) ) ).

% card_cartesian_product_singleton
thf(fact_2193_card__eq__sum,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X2: A] : ( one_one @ nat ) ) ) ).

% card_eq_sum
thf(fact_2194_card__1__singletonE,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( one_one @ nat ) )
     => ~ ! [X: A] :
            ( A3
           != ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_1_singletonE
thf(fact_2195_card__partition,axiom,
    ! [A: $tType,C3: set @ ( set @ A ),K: nat] :
      ( ( finite_finite2 @ ( set @ A ) @ C3 )
     => ( ( finite_finite2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C3 ) )
       => ( ! [C4: set @ A] :
              ( ( member @ ( set @ A ) @ C4 @ C3 )
             => ( ( finite_card @ A @ C4 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member @ ( set @ A ) @ C1 @ C3 )
               => ( ( member @ ( set @ A ) @ C22 @ C3 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C3 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C3 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_2196_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,T2: set @ B,R: A > B > $o,K: nat] :
      ( ( finite_finite2 @ A @ S2 )
     => ( ( finite_finite2 @ B @ T2 )
       => ( ! [X: B] :
              ( ( member @ B @ X @ T2 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I2: A] :
                        ( ( member @ A @ I2 @ S2 )
                        & ( R @ I2 @ X ) ) ) )
                = K ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I2: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J3: B] :
                        ( ( member @ B @ J3 @ T2 )
                        & ( R @ I2 @ J3 ) ) ) )
              @ S2 )
            = ( times_times @ nat @ K @ ( finite_card @ B @ T2 ) ) ) ) ) ) ).

% sum_multicount
thf(fact_2197_sum__multicount__gen,axiom,
    ! [A: $tType,B: $tType,S3: set @ A,T3: set @ B,R: A > B > $o,K: B > nat] :
      ( ( finite_finite2 @ A @ S3 )
     => ( ( finite_finite2 @ B @ T3 )
       => ( ! [X: B] :
              ( ( member @ B @ X @ T3 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I2: A] :
                        ( ( member @ A @ I2 @ S3 )
                        & ( R @ I2 @ X ) ) ) )
                = ( K @ X ) ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I2: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J3: B] :
                        ( ( member @ B @ J3 @ T3 )
                        & ( R @ I2 @ J3 ) ) ) )
              @ S3 )
            = ( groups7311177749621191930dd_sum @ B @ nat @ K @ T3 ) ) ) ) ) ).

% sum_multicount_gen
thf(fact_2198_card__eq__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( zero_zero @ nat ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite2 @ A @ A3 ) ) ) ).

% card_eq_0_iff
thf(fact_2199_card__1__singletonI,axiom,
    ! [A: $tType,S2: set @ A,X3: A] :
      ( ( finite_finite2 @ A @ S2 )
     => ( ( ( finite_card @ A @ S2 )
          = ( one_one @ nat ) )
       => ( ( member @ A @ X3 @ S2 )
         => ( S2
            = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_1_singletonI
thf(fact_2200_card__quotient__disjoint,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( inj_on @ A @ ( set @ ( set @ A ) )
          @ ^ [X2: A] : ( equiv_quotient @ A @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) @ R5 )
          @ A3 )
       => ( ( finite_card @ ( set @ A ) @ ( equiv_quotient @ A @ A3 @ R5 ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_quotient_disjoint
thf(fact_2201_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_2202_card__Diff1__le,axiom,
    ! [A: $tType,A3: set @ A,X3: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ).

% card_Diff1_le
thf(fact_2203_card__Diff__singleton,axiom,
    ! [A: $tType,X3: A,A3: set @ A] :
      ( ( member @ A @ X3 @ A3 )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) ) ).

% card_Diff_singleton
thf(fact_2204_card__Diff__singleton__if,axiom,
    ! [A: $tType,X3: A,A3: set @ A] :
      ( ( ( member @ A @ X3 @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X3 @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff_singleton_if
thf(fact_2205_card__Un__Int,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ A @ B2 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B2 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_2206_card__Diff__subset__Int,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( finite_finite2 @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ) ).

% card_Diff_subset_Int
thf(fact_2207_card__Un__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ A @ B2 )
       => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B2 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_2208_card__vimage__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,D2: set @ A,A3: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ D2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ A3 ) @ D2 ) ) @ ( finite_card @ B @ A3 ) ) ) ) ).

% card_vimage_inj_on_le
thf(fact_2209_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I: set @ A,A3: A > ( set @ B )] :
      ( ( finite_finite2 @ A @ I )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A3 @ I ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I2: A] : ( finite_card @ B @ ( A3 @ I2 ) )
          @ I ) ) ) ).

% card_UN_le
thf(fact_2210_sum__card__image,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > ( set @ B )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( pairwise @ A
          @ ^ [S: A,T5: A] : ( disjnt @ B @ ( F2 @ S ) @ ( F2 @ T5 ) )
          @ A3 )
       => ( ( groups7311177749621191930dd_sum @ ( set @ B ) @ nat @ ( finite_card @ B ) @ ( image2 @ A @ ( set @ B ) @ F2 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [A5: A] : ( finite_card @ B @ ( F2 @ A5 ) )
            @ A3 ) ) ) ) ).

% sum_card_image
thf(fact_2211_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: set @ nat,C2: nat > A,D3: nat > A] :
          ( ( ( ( finite_finite2 @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) ) @ ( D3 @ I2 ) )
                @ A3 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D3 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite2 @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) ) @ ( D3 @ I2 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_2212_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite2 @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) )
                @ A3 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite2 @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_2213_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S2: set @ A,R: set @ B,G: A > B,F2: B > C] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( finite_finite2 @ B @ R )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image2 @ A @ B @ G @ S2 ) @ R )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X2: A] : ( F2 @ ( G @ X2 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y2: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X2: A] :
                                ( ( member @ A @ X2 @ S2 )
                                & ( ( G @ X2 )
                                  = Y2 ) ) ) ) )
                      @ ( F2 @ Y2 ) )
                  @ R ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_2214_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,N: A,K: nat] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) )
                & ( ord_less_eq @ A @ ( F2 @ I4 ) @ N ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( power_power @ A @ N @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_2215_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ ( divide_divide @ A @ K5 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) ) ) )
         => ( ( finite_finite2 @ B @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_2216_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,M2: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image2 @ A @ A
                @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A4 @ M2 ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B3 @ M2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B3 @ M2 ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A4 @ M2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_2217_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_2218_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
          = ( ~ ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_2219_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_2220_atLeastAtMost__singleton__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
            = ( insert @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )
          = ( ( A4 = B3 )
            & ( B3 = C2 ) ) ) ) ).

% atLeastAtMost_singleton_iff
thf(fact_2221_atLeastAtMost__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: A] :
          ( ( set_or1337092689740270186AtMost @ A @ A4 @ A4 )
          = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastAtMost_singleton
thf(fact_2222_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M2: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M2 @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mult
thf(fact_2223_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( one_one @ A ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_2224_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_2225_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_2226_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I3: A,J2: A] :
          ( ( image2 @ A @ A
            @ ^ [N5: A] : ( plus_plus @ A @ N5 @ K )
            @ ( set_or1337092689740270186AtMost @ A @ I3 @ J2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ K ) ) ) ) ).

% image_add_atLeastAtMost'
thf(fact_2227_image__minus__const__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [D3: A,A4: A,B3: A] :
          ( ( image2 @ A @ A
            @ ^ [T5: A] : ( minus_minus @ A @ T5 @ D3 )
            @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ A4 @ D3 ) @ ( minus_minus @ A @ B3 @ D3 ) ) ) ) ).

% image_minus_const_atLeastAtMost'
thf(fact_2228_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y: A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : Y
            @ A3 )
          = ( power_power @ A @ Y @ ( finite_card @ B @ A3 ) ) ) ) ).

% prod_constant
thf(fact_2229_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat,A4: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ A4 ) )
          = A4 ) ) ).

% left_minus_one_mult_self
thf(fact_2230_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_2231_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : Y
            @ A3 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ Y ) ) ) ).

% sum_constant
thf(fact_2232_prod__int__plus__eq,axiom,
    ! [I3: nat,J2: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I3 @ ( plus_plus @ nat @ I3 @ J2 ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X2: int] : X2
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I3 ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I3 @ J2 ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_2233_pairwise__trivial,axiom,
    ! [A: $tType,I: set @ A] :
      ( pairwise @ A
      @ ^ [I2: A,J3: A] : ( J3 != I2 )
      @ I ) ).

% pairwise_trivial
thf(fact_2234_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X3: nat,Y: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X3 ) @ Y )
          = ( times_times @ A @ Y @ ( semiring_1_of_nat @ A @ X3 ) ) ) ) ).

% mult_of_nat_commute
thf(fact_2235_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X3: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X3 @ Y )
            = ( times_times @ A @ Y @ X3 ) )
         => ( ( times_times @ A @ ( power_power @ A @ X3 @ N ) @ Y )
            = ( times_times @ A @ Y @ ( power_power @ A @ X3 @ N ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_2236_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A,B3: A,N: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A4 @ B3 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ A4 @ N ) @ ( power_power @ A @ B3 @ N ) ) ) ) ).

% power_mult_distrib
thf(fact_2237_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A4: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A4 @ N ) @ A4 )
          = ( times_times @ A @ A4 @ ( power_power @ A @ A4 @ N ) ) ) ) ).

% power_commutes
thf(fact_2238_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ B )
     => ! [F2: A > B,A3: set @ A,N: nat] :
          ( ( power_power @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A3 ) @ N )
          = ( groups7121269368397514597t_prod @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
            @ A3 ) ) ) ).

% prod_power_distrib
thf(fact_2239_pairwise__empty,axiom,
    ! [A: $tType,P: A > A > $o] : ( pairwise @ A @ P @ ( bot_bot @ ( set @ A ) ) ) ).

% pairwise_empty
thf(fact_2240_atLeastAtMost__singleton_H,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: A,B3: A] :
          ( ( A4 = B3 )
         => ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
            = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% atLeastAtMost_singleton'
thf(fact_2241_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A4: A,M2: nat,N: nat] :
          ( ( divide_divide @ A @ A4 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A4 @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% div_mult2_eq'
thf(fact_2242_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A4 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A4 @ N ) ) ) ) ).

% one_le_power
thf(fact_2243_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X3: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X3 @ Y )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X3 @ N ) @ ( power_power @ A @ Y @ N ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_2244_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A4: A] :
          ( ( power_power @ A @ A4 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_2245_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A4 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A4 @ N ) ) ) ) ).

% power_one_over
thf(fact_2246_pairwise__image,axiom,
    ! [A: $tType,B: $tType,R5: A > A > $o,F2: B > A,S3: set @ B] :
      ( ( pairwise @ A @ R5 @ ( image2 @ B @ A @ F2 @ S3 ) )
      = ( pairwise @ B
        @ ^ [X2: B,Y2: B] :
            ( ( ( F2 @ X2 )
             != ( F2 @ Y2 ) )
           => ( R5 @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
        @ S3 ) ) ).

% pairwise_image
thf(fact_2247_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A4: A,M2: nat,N: nat] :
          ( ( power_power @ A @ A4 @ ( plus_plus @ nat @ M2 @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A4 @ M2 ) @ ( power_power @ A @ A4 @ N ) ) ) ) ).

% power_add
thf(fact_2248_pairwise__disjnt__iff,axiom,
    ! [A: $tType,A18: set @ ( set @ A )] :
      ( ( pairwise @ ( set @ A ) @ ( disjnt @ A ) @ A18 )
      = ( ! [X2: A] :
            ( uniq @ ( set @ A )
            @ ^ [X7: set @ A] :
                ( ( member @ ( set @ A ) @ X7 @ A18 )
                & ( member @ A @ X2 @ X7 ) ) ) ) ) ).

% pairwise_disjnt_iff
thf(fact_2249_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M2: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( plus_plus @ nat @ I2 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% sum.shift_bounds_cl_nat_ivl
thf(fact_2250_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M2: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( plus_plus @ nat @ I2 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% prod.shift_bounds_cl_nat_ivl
thf(fact_2251_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,F2: B > nat,A3: set @ B] :
          ( ( power_power @ A @ C2 @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A5: B] : ( power_power @ A @ C2 @ ( F2 @ A5 ) )
            @ A3 ) ) ) ).

% power_sum
thf(fact_2252_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M2: nat,N: nat,X3: A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
            = ( times_times @ A @ ( power_power @ A @ X3 @ M2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_2253_atLeastAtMost__eq__UNIV__iff,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice @ A )
     => ! [X3: A,Y: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ X3 @ Y )
            = ( top_top @ ( set @ A ) ) )
          = ( ( X3
              = ( bot_bot @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% atLeastAtMost_eq_UNIV_iff
thf(fact_2254_pairwise__singleton,axiom,
    ! [A: $tType,P: A > A > $o,A3: A] : ( pairwise @ A @ P @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% pairwise_singleton
thf(fact_2255_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ A4 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A4 @ N ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_2256_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_2257_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A4: A] :
          ( ( ord_less_eq @ nat @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A4 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A4 @ N ) @ ( power_power @ A @ A4 @ N4 ) ) ) ) ) ).

% power_increasing
thf(fact_2258_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A4: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A4 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ A4 @ N ) ) ) ) ).

% power_minus
thf(fact_2259_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M2 ) ) ) ) ).

% sum.atLeastAtMost_rev
thf(fact_2260_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M2 ) ) ) ) ).

% prod.atLeastAtMost_rev
thf(fact_2261_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,M2: nat,I: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( power_power @ A @ X3 @ ( plus_plus @ nat @ M2 @ I2 ) )
            @ I )
          = ( times_times @ A @ ( power_power @ A @ X3 @ M2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ I ) ) ) ) ).

% sum_power_add
thf(fact_2262_UN__le__add__shift,axiom,
    ! [A: $tType,M: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ nat @ ( set @ A )
          @ ^ [I2: nat] : ( M @ ( plus_plus @ nat @ I2 @ K ) )
          @ ( set_ord_atMost @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ M @ ( set_or1337092689740270186AtMost @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift
thf(fact_2263_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A4: A] :
          ( ( ord_less_eq @ nat @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
           => ( ( ord_less_eq @ A @ A4 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A4 @ N4 ) @ ( power_power @ A @ A4 @ N ) ) ) ) ) ) ).

% power_decreasing
thf(fact_2264_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I4 ) @ K5 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ).

% sum_bounded_above
thf(fact_2265_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,K5: A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less_eq @ A @ K5 @ ( F2 @ I4 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ).

% sum_bounded_below
thf(fact_2266_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P6: A,M5: nat] :
              ( if @ A
              @ ( M5
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P6 @ ( power_power @ A @ P6 @ ( minus_minus @ nat @ M5 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_2267_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( power @ B )
        & ( power @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ A @ B @ ( nat > A ) @ ( nat > B ) @ R
              @ ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 )
                @ R )
              @ ( power_power @ A )
              @ ( power_power @ B ) ) ) ) ) ).

% power_transfer
thf(fact_2268_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A,P5: nat] :
          ( ( ord_less_eq @ nat @ M2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ N @ P5 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P5 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_2269_pairwise__alt,axiom,
    ! [A: $tType] :
      ( ( pairwise @ A )
      = ( ^ [R2: A > A > $o,S7: set @ A] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ S7 )
           => ! [Y2: A] :
                ( ( member @ A @ Y2 @ ( minus_minus @ ( set @ A ) @ S7 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
               => ( R2 @ X2 @ Y2 ) ) ) ) ) ).

% pairwise_alt
thf(fact_2270_UN__le__eq__Un0,axiom,
    ! [A: $tType,M: nat > ( set @ A ),N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ M @ ( set_ord_atMost @ nat @ N ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ M @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) @ ( M @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_2271_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A4: A,N: nat,M2: nat] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N @ M2 )
             => ( ( divide_divide @ A @ ( power_power @ A @ A4 @ M2 ) @ ( power_power @ A @ A4 @ N ) )
                = ( power_power @ A @ A4 @ ( minus_minus @ nat @ M2 @ N ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N @ M2 )
             => ( ( divide_divide @ A @ ( power_power @ A @ A4 @ M2 ) @ ( power_power @ A @ A4 @ N ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A4 @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_2272_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M2: nat,N: nat,F2: nat > A] :
          ( ( ( ord_less_eq @ nat @ M2 @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K6: nat] : ( minus_minus @ A @ ( F2 @ K6 ) @ ( F2 @ ( plus_plus @ nat @ K6 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
              = ( minus_minus @ A @ ( F2 @ M2 ) @ ( F2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M2 @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K6: nat] : ( minus_minus @ A @ ( F2 @ K6 ) @ ( F2 @ ( plus_plus @ nat @ K6 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_2273_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A4: B,B3: B > A,C2: A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( ( member @ B @ A4 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ C2 )
                  @ S2 )
                = ( times_times @ A @ ( B3 @ A4 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S2 ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A4 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ C2 )
                  @ S2 )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S2 ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_2274_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,M2: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image2 @ A @ A
                @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M2 @ A4 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M2 @ B3 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M2 @ B3 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M2 @ A4 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_2275_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,M2: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image2 @ A @ A
                @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M2 @ A4 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M2 @ B3 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M2 @ B3 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M2 @ A4 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_2276_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,M2: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image2 @ A @ A
                @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A4 @ M2 ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B3 @ M2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B3 @ M2 ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A4 @ M2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_2277_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [F2: B > nat,A3: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : ( semiring_1_of_nat @ A @ ( F2 @ X2 ) )
            @ A3 ) ) ) ).

% of_nat_sum
thf(fact_2278_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > nat,A3: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( semiring_1_of_nat @ A @ ( F2 @ X2 ) )
            @ A3 ) ) ) ).

% of_nat_prod
thf(fact_2279_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_2280_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( semiring_1 @ B )
        & ( semiring_1 @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 )
                @ R
                @ ( semiring_1_of_nat @ A )
                @ ( semiring_1_of_nat @ B ) ) ) ) ) ) ).

% transfer_rule_of_nat
thf(fact_2281_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N5: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I2: A] : ( plus_plus @ A @ I2 @ ( one_one @ A ) )
              @ N5
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_2282_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( ( X3
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_atMost @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) )
          & ( ( X3
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_atMost @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) ) ) ) ) ) ).

% sum_gp0
thf(fact_2283_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,M2: nat,N: nat] :
          ( ( ( X3
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ M2 @ N ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) )
          & ( ( X3
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ M2 @ N ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X3 @ M2 ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ ( suc @ N ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_2284_card__Collect__le__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I2: nat] : ( ord_less_eq @ nat @ I2 @ N ) ) )
      = ( suc @ N ) ) ).

% card_Collect_le_nat
thf(fact_2285_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M2: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M2 ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M2 ) ) ) ) ).

% of_nat_Suc
thf(fact_2286_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_2287_prod__int__eq,axiom,
    ! [I3: nat,J2: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I3 @ J2 ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X2: int] : X2
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I3 ) @ ( semiring_1_of_nat @ int @ J2 ) ) ) ) ).

% prod_int_eq
thf(fact_2288_int__prod,axiom,
    ! [B: $tType,F2: B > nat,A3: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A3 ) )
      = ( groups7121269368397514597t_prod @ B @ int
        @ ^ [X2: B] : ( semiring_1_of_nat @ int @ ( F2 @ X2 ) )
        @ A3 ) ) ).

% int_prod
thf(fact_2289_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M2: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
thf(fact_2290_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M2: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
thf(fact_2291_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A4: A,N: nat] :
          ( ( power_power @ A @ A4 @ ( suc @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A4 @ N ) @ A4 ) ) ) ).

% power_Suc2
thf(fact_2292_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A4: A,N: nat] :
          ( ( power_power @ A @ A4 @ ( suc @ N ) )
          = ( times_times @ A @ A4 @ ( power_power @ A @ A4 @ N ) ) ) ) ).

% power_Suc
thf(fact_2293_card_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( finite_fold @ A @ nat
        @ ^ [Uu: A] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card.eq_fold
thf(fact_2294_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_2295_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_2296_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ ( suc @ N ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_2297_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
            = ( times_times @ A @ ( G @ M2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_2298_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ M2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_2299_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M2: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I2 ) ) @ ( F2 @ I2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
            = ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ M2 ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_2300_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ M2 )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_2301_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M2: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_2302_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M2: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_2303_sum__Suc,axiom,
    ! [A: $tType,F2: A > nat,A3: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X2: A] : ( suc @ ( F2 @ X2 ) )
        @ A3 )
      = ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( finite_card @ A @ A3 ) ) ) ).

% sum_Suc
thf(fact_2304_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ A4 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A4 @ ( suc @ N ) ) @ A4 ) ) ) ) ).

% power_Suc_le_self
thf(fact_2305_card__1__singleton__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ? [X2: A] :
            ( A3
            = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_1_singleton_iff
thf(fact_2306_card__eq__SucD,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
     => ? [B6: A,B10: set @ A] :
          ( ( A3
            = ( insert @ A @ B6 @ B10 ) )
          & ~ ( member @ A @ B6 @ B10 )
          & ( ( finite_card @ A @ B10 )
            = K )
          & ( ( K
              = ( zero_zero @ nat ) )
           => ( B10
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_eq_SucD
thf(fact_2307_card__Suc__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
      = ( ? [B4: A,B5: set @ A] :
            ( ( A3
              = ( insert @ A @ B4 @ B5 ) )
            & ~ ( member @ A @ B4 @ B5 )
            & ( ( finite_card @ A @ B5 )
              = K )
            & ( ( K
                = ( zero_zero @ nat ) )
             => ( B5
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_Suc_eq
thf(fact_2308_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_2309_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_2310_sum__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,I3: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( minus_minus @ A @ ( F2 @ I2 ) @ ( F2 @ ( suc @ I2 ) ) )
            @ ( set_ord_atMost @ nat @ I3 ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ ( suc @ I3 ) ) ) ) ) ).

% sum_telescope
thf(fact_2311_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_2312_card_Oremove,axiom,
    ! [A: $tType,A3: set @ A,X3: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( member @ A @ X3 @ A3 )
       => ( ( finite_card @ A @ A3 )
          = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% card.remove
thf(fact_2313_card_Oinsert__remove,axiom,
    ! [A: $tType,A3: set @ A,X3: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_card @ A @ ( insert @ A @ X3 @ A3 ) )
        = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% card.insert_remove
thf(fact_2314_card__Suc__Diff1,axiom,
    ! [A: $tType,A3: set @ A,X3: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( member @ A @ X3 @ A3 )
       => ( ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Suc_Diff1
thf(fact_2315_int__sum,axiom,
    ! [B: $tType,F2: B > nat,A3: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A3 ) )
      = ( groups7311177749621191930dd_sum @ B @ int
        @ ^ [X2: B] : ( semiring_1_of_nat @ int @ ( F2 @ X2 ) )
        @ A3 ) ) ).

% int_sum
thf(fact_2316_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M2: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K6: nat] : ( minus_minus @ A @ ( F2 @ K6 ) @ ( F2 @ ( minus_minus @ nat @ K6 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M2 ) ) ) ) ) ).

% sum_telescope''
thf(fact_2317_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M2: nat,N: nat,X3: A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X3 @ M2 ) @ ( power_power @ A @ X3 @ ( suc @ N ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_2318_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_atMost @ nat @ N ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ ( suc @ N ) ) ) ) ) ).

% sum_gp_basic
thf(fact_2319_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N: nat,M2: nat,X3: A] :
          ( ( ( ord_less @ nat @ N @ M2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M2 )
           => ( ( ( X3
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M2 ) ) ) )
              & ( ( X3
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X3 @ M2 ) @ ( power_power @ A @ X3 @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_2320_card__UNION,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] :
      ( ( finite_finite2 @ ( set @ A ) @ A3 )
     => ( ! [X: set @ A] :
            ( ( member @ ( set @ A ) @ X @ A3 )
           => ( finite_finite2 @ A @ X ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I7: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I7 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I7 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I7: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I7 @ A3 )
                    & ( I7
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_2321_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P5: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P5 )
         => ( ( ord_less_eq @ nat @ K @ P5 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( one_one @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P5 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P5 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_2322_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P5: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P5 )
         => ( ( ord_less_eq @ nat @ K @ P5 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( zero_zero @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P5 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P5 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_2323_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_leq_as_int
thf(fact_2324_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F2: nat > A,A4: nat,B3: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A4 @ B3 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A5: nat] : ( times_times @ A @ ( F2 @ A5 ) )
            @ A4
            @ B3
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_2325_finite__interval__int1,axiom,
    ! [A4: int,B3: int] :
      ( finite_finite2 @ int
      @ ( collect @ int
        @ ^ [I2: int] :
            ( ( ord_less_eq @ int @ A4 @ I2 )
            & ( ord_less_eq @ int @ I2 @ B3 ) ) ) ) ).

% finite_interval_int1
thf(fact_2326_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_2327_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A4 @ C2 ) @ ( plus_plus @ A @ B3 @ C2 ) )
          = ( ord_less @ A @ A4 @ B3 ) ) ) ).

% add_less_cancel_right
thf(fact_2328_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A4 ) @ ( plus_plus @ A @ C2 @ B3 ) )
          = ( ord_less @ A @ A4 @ B3 ) ) ) ).

% add_less_cancel_left
thf(fact_2329_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B3 ) @ ( uminus_uminus @ A @ A4 ) )
          = ( ord_less @ A @ A4 @ B3 ) ) ) ).

% neg_less_iff_less
thf(fact_2330_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less @ A @ Y @ X3 ) ) ) ).

% compl_less_compl_iff
thf(fact_2331_finite__Collect__less__nat,axiom,
    ! [K: nat] :
      ( finite_finite2 @ nat
      @ ( collect @ nat
        @ ^ [N5: nat] : ( ord_less @ nat @ N5 @ K ) ) ) ).

% finite_Collect_less_nat
thf(fact_2332_card__Collect__less__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N ) ) )
      = N ) ).

% card_Collect_less_nat
thf(fact_2333_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A4 @ A4 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A4 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_2334_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A4 @ A4 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_2335_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( plus_plus @ A @ B3 @ A4 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B3 ) ) ) ).

% less_add_same_cancel2
thf(fact_2336_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( plus_plus @ A @ A4 @ B3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B3 ) ) ) ).

% less_add_same_cancel1
thf(fact_2337_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A4 @ B3 ) @ B3 )
          = ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_2338_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B3 @ A4 ) @ B3 )
          = ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_2339_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A4 @ B3 ) )
          = ( ord_less @ A @ B3 @ A4 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_2340_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A4 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A4 ) ) ) ).

% neg_less_0_iff_less
thf(fact_2341_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A4 ) )
          = ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_2342_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A4 ) @ A4 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A4 ) ) ) ).

% neg_less_pos
thf(fact_2343_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ A4 @ ( uminus_uminus @ A @ A4 ) )
          = ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_2344_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,M2: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A4 )
         => ( ( ( power_power @ A @ A4 @ M2 )
              = ( power_power @ A @ A4 @ N ) )
            = ( M2 = N ) ) ) ) ).

% power_inject_exp
thf(fact_2345_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A4 ) )
          = ( ( A4
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_2346_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A3 )
            = ( bot_bot @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X2 )
               => ? [Y2: A] :
                    ( ( member @ A @ Y2 @ A3 )
                    & ( ord_less @ A @ Y2 @ X2 ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_2347_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A3 )
            = ( top_top @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ X2 @ ( top_top @ A ) )
               => ? [Y2: A] :
                    ( ( member @ A @ Y2 @ A3 )
                    & ( ord_less @ A @ X2 @ Y2 ) ) ) ) ) ) ).

% Sup_eq_top_iff
thf(fact_2348_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ( set_or1337092689740270186AtMost @ A @ A4 @ B3 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_2349_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A4 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_2350_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B3 @ A4 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A4 @ B3 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_2351_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B3 @ A4 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B3 @ A4 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_2352_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B3 @ A4 ) )
            = ( ord_less @ A @ B3 @ A4 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_2353_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B3 @ A4 ) )
            = ( ord_less @ A @ A4 @ B3 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_2354_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A4 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A4 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_2355_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B3: A,X3: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B3 )
         => ( ( ord_less @ A @ ( power_power @ A @ B3 @ X3 ) @ ( power_power @ A @ B3 @ Y ) )
            = ( ord_less @ nat @ X3 @ Y ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_2356_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
            = ( bot_bot @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X2 )
               => ? [Y2: B] :
                    ( ( member @ B @ Y2 @ A3 )
                    & ( ord_less @ A @ ( F2 @ Y2 ) @ X2 ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_2357_SUP__eq__top__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
            = ( top_top @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ X2 @ ( top_top @ A ) )
               => ? [Y2: B] :
                    ( ( member @ B @ Y2 @ A3 )
                    & ( ord_less @ A @ X2 @ ( F2 @ Y2 ) ) ) ) ) ) ) ).

% SUP_eq_top_iff
thf(fact_2358_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B3 @ A4 ) )
            = ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_2359_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B3 @ A4 ) )
            = ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_2360_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B3 @ A4 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_2361_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B3 @ A4 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_2362_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B3: A,M2: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B3 )
         => ( ( ord_less @ A @ B3 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B3 @ M2 ) @ ( power_power @ A @ B3 @ N ) )
              = ( ord_less @ nat @ N @ M2 ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_2363_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D3: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D3 )
         => ( ( image2 @ A @ A @ ( times_times @ A @ D3 ) @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D3 @ A4 ) @ ( times_times @ A @ D3 @ B3 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_2364_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B3: A,X3: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B3 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B3 @ X3 ) @ ( power_power @ A @ B3 @ Y ) )
            = ( ord_less_eq @ nat @ X3 @ Y ) ) ) ) ).

% power_increasing_iff
thf(fact_2365_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D3: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D3 )
         => ( ( image2 @ A @ A
              @ ^ [C5: A] : ( divide_divide @ A @ C5 @ D3 )
              @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A4 @ D3 ) @ ( divide_divide @ A @ B3 @ D3 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_2366_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B3: A,M2: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B3 )
         => ( ( ord_less @ A @ B3 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B3 @ M2 ) @ ( power_power @ A @ B3 @ N ) )
              = ( ord_less_eq @ nat @ N @ M2 ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_2367_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M2: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_2368_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_2369_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y: A] :
          ( ( X3 != Y )
         => ( ~ ( ord_less @ A @ X3 @ Y )
           => ( ord_less @ A @ Y @ X3 ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_2370_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ X3 @ Y )
         => ~ ( ord_less @ A @ Y @ X3 ) ) ) ).

% order_less_imp_not_less
thf(fact_2371_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ X3 @ Y )
         => ( Y != X3 ) ) ) ).

% order_less_imp_not_eq2
thf(fact_2372_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ X3 @ Y )
         => ( X3 != Y ) ) ) ).

% order_less_imp_not_eq
thf(fact_2373_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ X3 @ Y )
          | ( X3 = Y )
          | ( ord_less @ A @ Y @ X3 ) ) ) ).

% linorder_less_linear
thf(fact_2374_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y: A,P: $o] :
          ( ( ord_less @ A @ X3 @ Y )
         => ( ( ord_less @ A @ Y @ X3 )
           => P ) ) ) ).

% order_less_imp_triv
thf(fact_2375_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ X3 @ Y )
         => ~ ( ord_less @ A @ Y @ X3 ) ) ) ).

% order_less_not_sym
thf(fact_2376_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A4: A,B3: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ C @ ( F2 @ B3 ) @ C2 )
           => ( ! [X: A,Y3: A] :
                  ( ( ord_less @ A @ X @ Y3 )
                 => ( ord_less @ C @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ C @ ( F2 @ A4 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_2377_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A4: A,F2: B > A,B3: B,C2: B] :
          ( ( ord_less @ A @ A4 @ ( F2 @ B3 ) )
         => ( ( ord_less @ B @ B3 @ C2 )
           => ( ! [X: B,Y3: B] :
                  ( ( ord_less @ B @ X @ Y3 )
                 => ( ord_less @ A @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A4 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_2378_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A] :
          ~ ( ord_less @ A @ X3 @ X3 ) ) ).

% order_less_irrefl
thf(fact_2379_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A4: A,B3: A,F2: A > B,C2: B] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ( F2 @ B3 )
              = C2 )
           => ( ! [X: A,Y3: A] :
                  ( ( ord_less @ A @ X @ Y3 )
                 => ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ B @ ( F2 @ A4 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_2380_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A4: A,F2: B > A,B3: B,C2: B] :
          ( ( A4
            = ( F2 @ B3 ) )
         => ( ( ord_less @ B @ B3 @ C2 )
           => ( ! [X: B,Y3: B] :
                  ( ( ord_less @ B @ X @ Y3 )
                 => ( ord_less @ A @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A4 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_2381_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X3 @ Y )
         => ( ( ord_less @ A @ Y @ Z2 )
           => ( ord_less @ A @ X3 @ Z2 ) ) ) ) ).

% order_less_trans
thf(fact_2382_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ~ ( ord_less @ A @ B3 @ A4 ) ) ) ).

% order_less_asym'
thf(fact_2383_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ( X3 != Y ) )
          = ( ( ord_less @ A @ X3 @ Y )
            | ( ord_less @ A @ Y @ X3 ) ) ) ) ).

% linorder_neq_iff
thf(fact_2384_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ X3 @ Y )
         => ~ ( ord_less @ A @ Y @ X3 ) ) ) ).

% order_less_asym
thf(fact_2385_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ( X3 != Y )
         => ( ~ ( ord_less @ A @ X3 @ Y )
           => ( ord_less @ A @ Y @ X3 ) ) ) ) ).

% linorder_neqE
thf(fact_2386_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( A4 != B3 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_2387_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( A4 != B3 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_2388_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ( ord_less @ A @ C2 @ B3 )
           => ( ord_less @ A @ C2 @ A4 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_2389_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X3 @ Y ) )
          = ( ( ord_less @ A @ Y @ X3 )
            | ( X3 = Y ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_2390_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ B3 @ C2 )
           => ( ord_less @ A @ A4 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_2391_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A4: A,B3: A] :
          ( ! [A7: A,B6: A] :
              ( ( ord_less @ A @ A7 @ B6 )
             => ( P @ A7 @ B6 ) )
         => ( ! [A7: A] : ( P @ A7 @ A7 )
           => ( ! [A7: A,B6: A] :
                  ( ( P @ B6 @ A7 )
                 => ( P @ A7 @ B6 ) )
             => ( P @ A4 @ B3 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_2392_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P9: A > $o] :
            ? [X9: A] : ( P9 @ X9 ) )
        = ( ^ [P3: A > $o] :
            ? [N5: A] :
              ( ( P3 @ N5 )
              & ! [M5: A] :
                  ( ( ord_less @ A @ M5 @ N5 )
                 => ~ ( P3 @ M5 ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_2393_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A] :
          ~ ( ord_less @ A @ A4 @ A4 ) ) ).

% dual_order.irrefl
thf(fact_2394_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ~ ( ord_less @ A @ A4 @ B3 ) ) ) ).

% dual_order.asym
thf(fact_2395_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ~ ( ord_less @ A @ X3 @ Y )
         => ( ( X3 != Y )
           => ( ord_less @ A @ Y @ X3 ) ) ) ) ).

% linorder_cases
thf(fact_2396_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X3: A] :
          ( ~ ( ord_less @ A @ Y @ X3 )
         => ( ( ~ ( ord_less @ A @ X3 @ Y ) )
            = ( X3 = Y ) ) ) ) ).

% antisym_conv3
thf(fact_2397_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A4: A] :
          ( ! [X: A] :
              ( ! [Y7: A] :
                  ( ( ord_less @ A @ Y7 @ X )
                 => ( P @ Y7 ) )
             => ( P @ X ) )
         => ( P @ A4 ) ) ) ).

% less_induct
thf(fact_2398_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( B3 = C2 )
           => ( ord_less @ A @ A4 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_2399_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4 = B3 )
         => ( ( ord_less @ A @ B3 @ C2 )
           => ( ord_less @ A @ A4 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_2400_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ~ ( ord_less @ A @ B3 @ A4 ) ) ) ).

% order.asym
thf(fact_2401_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ X3 @ Y )
         => ( X3 != Y ) ) ) ).

% less_imp_neq
thf(fact_2402_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ X3 @ Y )
         => ? [Z4: A] :
              ( ( ord_less @ A @ X3 @ Z4 )
              & ( ord_less @ A @ Z4 @ Y ) ) ) ) ).

% dense
thf(fact_2403_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X3: A] :
        ? [X_1: A] : ( ord_less @ A @ X3 @ X_1 ) ) ).

% gt_ex
thf(fact_2404_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X3: A] :
        ? [Y3: A] : ( ord_less @ A @ Y3 @ X3 ) ) ).

% lt_ex
thf(fact_2405_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A4: A] :
          ( ( ord_less @ nat @ N @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A4 )
           => ( ord_less @ A @ ( power_power @ A @ A4 @ N ) @ ( power_power @ A @ A4 @ N4 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_2406_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,M2: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A4 )
         => ( ( ord_less @ A @ ( power_power @ A @ A4 @ M2 ) @ ( power_power @ A @ A4 @ N ) )
           => ( ord_less @ nat @ M2 @ N ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_2407_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( ord_less @ A @ X3 @ Y )
            | ( X3 = Y ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_2408_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
          | ( ord_less @ A @ Y @ X3 ) ) ) ).

% linorder_le_less_linear
thf(fact_2409_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A4: A,B3: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ C @ ( F2 @ B3 ) @ C2 )
           => ( ! [X: A,Y3: A] :
                  ( ( ord_less @ A @ X @ Y3 )
                 => ( ord_less @ C @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ C @ ( F2 @ A4 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_2410_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A4: A,F2: B > A,B3: B,C2: B] :
          ( ( ord_less @ A @ A4 @ ( F2 @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C2 )
           => ( ! [X: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X @ Y3 )
                 => ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A4 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_2411_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A4: A,B3: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less @ C @ ( F2 @ B3 ) @ C2 )
           => ( ! [X: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X @ Y3 )
                 => ( ord_less_eq @ C @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ C @ ( F2 @ A4 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_2412_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A4: A,F2: B > A,B3: B,C2: B] :
          ( ( ord_less_eq @ A @ A4 @ ( F2 @ B3 ) )
         => ( ( ord_less @ B @ B3 @ C2 )
           => ( ! [X: B,Y3: B] :
                  ( ( ord_less @ B @ X @ Y3 )
                 => ( ord_less @ A @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
             => ( ord_less @ A @ A4 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_2413_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X3 @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z2 )
           => ( ord_less @ A @ X3 @ Z2 ) ) ) ) ).

% order_less_le_trans
thf(fact_2414_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( ord_less @ A @ Y @ Z2 )
           => ( ord_less @ A @ X3 @ Z2 ) ) ) ) ).

% order_le_less_trans
thf(fact_2415_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: A,B3: A] :
          ( ( A4 != B3 )
         => ( ( ord_less_eq @ A @ A4 @ B3 )
           => ( ord_less @ A @ A4 @ B3 ) ) ) ) ).

% order_neq_le_trans
thf(fact_2416_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( A4 != B3 )
           => ( ord_less @ A @ A4 @ B3 ) ) ) ) ).

% order_le_neq_trans
thf(fact_2417_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ X3 @ Y )
         => ( ord_less_eq @ A @ X3 @ Y ) ) ) ).

% order_less_imp_le
thf(fact_2418_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X3 @ Y ) )
          = ( ord_less_eq @ A @ Y @ X3 ) ) ) ).

% linorder_not_less
thf(fact_2419_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ~ ( ord_less_eq @ A @ X3 @ Y ) )
          = ( ord_less @ A @ Y @ X3 ) ) ) ).

% linorder_not_le
thf(fact_2420_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
              & ( X2 != Y2 ) ) ) ) ) ).

% order_less_le
thf(fact_2421_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y2: A] :
              ( ( ord_less @ A @ X2 @ Y2 )
              | ( X2 = Y2 ) ) ) ) ) ).

% order_le_less
thf(fact_2422_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ord_less_eq @ A @ B3 @ A4 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_2423_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ord_less_eq @ A @ A4 @ B3 ) ) ) ).

% order.strict_implies_order
thf(fact_2424_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ~ ( ord_less_eq @ A @ A5 @ B4 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_2425_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ( ord_less_eq @ A @ C2 @ B3 )
           => ( ord_less @ A @ C2 @ A4 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_2426_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( ord_less @ A @ C2 @ B3 )
           => ( ord_less @ A @ C2 @ A4 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_2427_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ( A5 != B4 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_2428_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less @ A @ B4 @ A5 )
              | ( A5 = B4 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_2429_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X3 @ Y )
         => ( ! [W: A] :
                ( ( ord_less @ A @ X3 @ W )
               => ( ( ord_less @ A @ W @ Y )
                 => ( ord_less_eq @ A @ W @ Z2 ) ) )
           => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% dense_le_bounded
thf(fact_2430_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ X3 )
         => ( ! [W: A] :
                ( ( ord_less @ A @ Z2 @ W )
               => ( ( ord_less @ A @ W @ X3 )
                 => ( ord_less_eq @ A @ Y @ W ) ) )
           => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% dense_ge_bounded
thf(fact_2431_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ~ ( ord_less_eq @ A @ B4 @ A5 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_2432_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less @ A @ A4 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_2433_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ B3 @ C2 )
           => ( ord_less @ A @ A4 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_2434_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ( A5 != B4 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_2435_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less @ A @ A5 @ B4 )
              | ( A5 = B4 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_2436_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X3: A] :
          ( ~ ( ord_less_eq @ A @ Y @ X3 )
         => ( ord_less @ A @ X3 @ Y ) ) ) ).

% not_le_imp_less
thf(fact_2437_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
              & ~ ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ) ) ).

% less_le_not_le
thf(fact_2438_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y: A,Z2: A] :
          ( ! [X: A] :
              ( ( ord_less @ A @ X @ Y )
             => ( ord_less_eq @ A @ X @ Z2 ) )
         => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ).

% dense_le
thf(fact_2439_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,Y: A] :
          ( ! [X: A] :
              ( ( ord_less @ A @ Z2 @ X )
             => ( ord_less_eq @ A @ Y @ X ) )
         => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ).

% dense_ge
thf(fact_2440_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( ~ ( ord_less @ A @ X3 @ Y ) )
            = ( X3 = Y ) ) ) ) ).

% antisym_conv2
thf(fact_2441_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y: A] :
          ( ~ ( ord_less @ A @ X3 @ Y )
         => ( ( ord_less_eq @ A @ X3 @ Y )
            = ( X3 = Y ) ) ) ) ).

% antisym_conv1
thf(fact_2442_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: A,B3: A] :
          ( ( ~ ( ord_less @ A @ A4 @ B3 ) )
          = ( ~ ( ord_less_eq @ A @ A4 @ B3 )
            | ( A4 = B3 ) ) ) ) ).

% nless_le
thf(fact_2443_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ~ ( ord_less @ A @ X3 @ Y )
         => ( ord_less_eq @ A @ Y @ X3 ) ) ) ).

% leI
thf(fact_2444_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X3: A] :
          ( ( ord_less_eq @ A @ Y @ X3 )
         => ~ ( ord_less @ A @ X3 @ Y ) ) ) ).

% leD
thf(fact_2445_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N )
          = ( ( N
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_2446_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M2: A,N: A] :
          ( ( ord_less @ A @ M2 @ N )
         => ( N
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_2447_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ~ ( ord_less @ A @ N @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_2448_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( N
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N ) ) ) ).

% gr_zeroI
thf(fact_2449_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A4 @ C2 ) @ ( plus_plus @ A @ B3 @ C2 ) )
         => ( ord_less @ A @ A4 @ B3 ) ) ) ).

% add_less_imp_less_right
thf(fact_2450_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A4 ) @ ( plus_plus @ A @ C2 @ B3 ) )
         => ( ord_less @ A @ A4 @ B3 ) ) ) ).

% add_less_imp_less_left
thf(fact_2451_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ord_less @ A @ ( plus_plus @ A @ A4 @ C2 ) @ ( plus_plus @ A @ B3 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_2452_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A4 ) @ ( plus_plus @ A @ C2 @ B3 ) ) ) ) ).

% add_strict_left_mono
thf(fact_2453_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ord_less @ A @ ( plus_plus @ A @ A4 @ C2 ) @ ( plus_plus @ A @ B3 @ D3 ) ) ) ) ) ).

% add_strict_mono
thf(fact_2454_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I3 @ J2 )
            & ( K = L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_2455_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( I3 = J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_2456_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I3 @ J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_2457_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_2458_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ord_less @ A @ ( minus_minus @ A @ A4 @ C2 ) @ ( minus_minus @ A @ B3 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_2459_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A4 ) @ ( minus_minus @ A @ C2 @ B3 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_2460_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ( minus_minus @ A @ A4 @ B3 )
            = ( minus_minus @ A @ C2 @ D3 ) )
         => ( ( ord_less @ A @ A4 @ B3 )
            = ( ord_less @ A @ C2 @ D3 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_2461_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A,D3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ D3 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A4 @ C2 ) @ ( minus_minus @ A @ B3 @ D3 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_2462_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A4: A] :
          ( ( ( A4
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A4 ) ) ) ).

% bot.not_eq_extremum
thf(fact_2463_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A4: A] :
          ~ ( ord_less @ A @ A4 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_2464_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A4 ) @ B3 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B3 ) @ A4 ) ) ) ).

% minus_less_iff
thf(fact_2465_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( uminus_uminus @ A @ B3 ) )
          = ( ord_less @ A @ B3 @ ( uminus_uminus @ A @ A4 ) ) ) ) ).

% less_minus_iff
thf(fact_2466_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y ) @ X3 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X3 ) @ Y ) ) ) ).

% compl_less_swap2
thf(fact_2467_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X3: A] :
          ( ( ord_less @ A @ Y @ ( uminus_uminus @ A @ X3 ) )
         => ( ord_less @ A @ X3 @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_less_swap1
thf(fact_2468_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A4: A] :
          ( ( ( A4
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A4 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_2469_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A4: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A4 ) ) ).

% top.extremum_strict
thf(fact_2470_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,X3: A,B3: A] :
          ( ( ord_less @ A @ A4 @ X3 )
         => ( ord_less @ A @ ( inf_inf @ A @ A4 @ B3 ) @ X3 ) ) ) ).

% less_infI1
thf(fact_2471_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B3: A,X3: A,A4: A] :
          ( ( ord_less @ A @ B3 @ X3 )
         => ( ord_less @ A @ ( inf_inf @ A @ A4 @ B3 ) @ X3 ) ) ) ).

% less_infI2
thf(fact_2472_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( inf_inf @ A @ A4 @ B3 )
            = A4 ) ) ) ).

% inf.absorb3
thf(fact_2473_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ( inf_inf @ A @ A4 @ B3 )
            = B3 ) ) ) ).

% inf.absorb4
thf(fact_2474_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ ( inf_inf @ A @ B3 @ C2 ) )
         => ~ ( ( ord_less @ A @ A4 @ B3 )
             => ~ ( ord_less @ A @ A4 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_2475_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( inf_inf @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_2476_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less @ A @ A4 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_2477_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less @ A @ B3 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_2478_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less @ A @ C2 @ B3 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_2479_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ C2 @ A4 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_2480_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( A5
                = ( sup_sup @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_2481_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B3 @ C2 ) @ A4 )
         => ~ ( ( ord_less @ A @ B3 @ A4 )
             => ~ ( ord_less @ A @ C2 @ A4 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_2482_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( sup_sup @ A @ A4 @ B3 )
            = B3 ) ) ) ).

% sup.absorb4
thf(fact_2483_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ( sup_sup @ A @ A4 @ B3 )
            = A4 ) ) ) ).

% sup.absorb3
thf(fact_2484_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,B3: A,A4: A] :
          ( ( ord_less @ A @ X3 @ B3 )
         => ( ord_less @ A @ X3 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ).

% less_supI2
thf(fact_2485_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,A4: A,B3: A] :
          ( ( ord_less @ A @ X3 @ A4 )
         => ( ord_less @ A @ X3 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ).

% less_supI1
thf(fact_2486_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) )
           => ( ord_less @ A @ X3 @ Y ) ) ) ) ).

% mono_strict_invE
thf(fact_2487_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A4: A] :
          ( ( ord_less @ nat @ N @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
           => ( ( ord_less @ A @ A4 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A4 @ N4 ) @ ( power_power @ A @ A4 @ N ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_2488_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A4 @ N ) ) ) ) ) ).

% one_less_power
thf(fact_2489_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_2490_nat__minus__as__int,axiom,
    ( ( minus_minus @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_minus_as_int
thf(fact_2491_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_2492_finite__M__bounded__by__nat,axiom,
    ! [P: nat > $o,I3: nat] :
      ( finite_finite2 @ nat
      @ ( collect @ nat
        @ ^ [K6: nat] :
            ( ( P @ K6 )
            & ( ord_less @ nat @ K6 @ I3 ) ) ) ) ).

% finite_M_bounded_by_nat
thf(fact_2493_wf__less,axiom,
    wf @ nat @ ( collect @ ( product_prod @ nat @ nat ) @ ( product_case_prod @ nat @ nat @ $o @ ( ord_less @ nat ) ) ) ).

% wf_less
thf(fact_2494_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I3 @ J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_2495_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I3 @ J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_2496_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ord_less @ A @ ( plus_plus @ A @ A4 @ C2 ) @ ( plus_plus @ A @ B3 @ D3 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_2497_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ord_less @ A @ ( plus_plus @ A @ A4 @ C2 ) @ ( plus_plus @ A @ B3 @ D3 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_2498_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B3 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_2499_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A4 @ B3 ) ) ) ) ) ).

% add_pos_pos
thf(fact_2500_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ~ ! [C4: A] :
                ( ( B3
                  = ( plus_plus @ A @ A4 @ C4 ) )
               => ( C4
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_2501_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ B3 @ C2 )
           => ( ord_less @ A @ B3 @ ( plus_plus @ A @ A4 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_2502_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X3 @ Y ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X3 @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_2503_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_2504_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A4 @ B3 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B3 @ A4 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_2505_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_2506_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_2507_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A4 @ B3 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B3 @ A4 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_2508_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_2509_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_2510_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
            = ( ord_less @ A @ A4 @ B3 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_2511_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
            = ( ord_less @ A @ B3 @ A4 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_2512_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B3 @ A4 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B3 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_2513_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B3 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_2514_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B3 ) )
            | ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B3 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_2515_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ B3 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B3 @ A4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_2516_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_2517_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ B3 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_2518_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B3 )
           => ( ord_less @ A @ ( times_times @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_2519_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A4 @ B3 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
              & ( ord_less @ A @ B3 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B3 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_2520_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A4: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A4 @ A4 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_2521_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B3 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_2522_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_2523_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_2524_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_2525_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] : ( ord_less @ A @ ( minus_minus @ A @ A5 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_2526_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ord_less @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B3 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_2527_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A] : ( ord_less @ A @ A4 @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_2528_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ~ ( ord_less @ A @ A4 @ B3 )
         => ( ( plus_plus @ A @ B3 @ ( minus_minus @ A @ A4 @ B3 ) )
            = A4 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_2529_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( minus_minus @ A @ C2 @ B3 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_2530_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A4 @ B3 ) @ C2 )
          = ( ord_less @ A @ A4 @ ( plus_plus @ A @ C2 @ B3 ) ) ) ) ).

% diff_less_eq
thf(fact_2531_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M2: A,N: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M2 @ N ) ) ) ) ) ).

% less_1_mult
thf(fact_2532_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_2533_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_2534_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X: A] :
                ( ( member @ A @ X @ S2 )
                & ~ ? [Xa3: A] :
                      ( ( member @ A @ Xa3 @ S2 )
                      & ( ord_less @ A @ Xa3 @ X ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_2535_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X5: set @ A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ X5 )
               => ? [Xa3: A] :
                    ( ( member @ A @ Xa3 @ X5 )
                    & ( ord_less @ A @ X @ Xa3 ) ) )
           => ~ ( finite_finite2 @ A @ X5 ) ) ) ) ).

% infinite_growing
thf(fact_2536_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y: A,X5: set @ A] :
          ( ( ord_less @ A @ Y @ ( complete_Sup_Sup @ A @ X5 ) )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X: A] :
                  ( ( member @ A @ X @ X5 )
                 => ~ ( ord_less @ A @ Y @ X ) ) ) ) ) ).

% less_cSupE
thf(fact_2537_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,Z2: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z2 @ ( complete_Sup_Sup @ A @ X5 ) )
           => ? [X: A] :
                ( ( member @ A @ X @ X5 )
                & ( ord_less @ A @ Z2 @ X ) ) ) ) ) ).

% less_cSupD
thf(fact_2538_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( abs_abs @ A @ A4 )
            = A4 ) ) ) ).

% abs_of_pos
thf(fact_2539_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A4 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_2540_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,Z2: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X5 ) @ Z2 )
           => ? [X: A] :
                ( ( member @ A @ X @ X5 )
                & ( ord_less @ A @ X @ Z2 ) ) ) ) ) ).

% cInf_lessD
thf(fact_2541_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A4 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B3 ) @ D3 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ B3 ) ) @ ( times_times @ A @ C2 @ D3 ) ) ) ) ) ).

% abs_mult_less
thf(fact_2542_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A4 ) @ B3 )
          = ( ( ord_less @ A @ A4 @ B3 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A4 ) @ B3 ) ) ) ) ).

% abs_less_iff
thf(fact_2543_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) )
           => ( ord_less_eq @ A @ X3 @ Y ) ) ) ) ).

% mono_invE
thf(fact_2544_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( ord_less @ A @ ( F2 @ I4 ) @ K5 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A3 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_2545_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,Y: A,I3: B] :
          ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ Y )
         => ( ( member @ B @ I3 @ A3 )
           => ( ord_less @ A @ ( F2 @ I3 ) @ Y ) ) ) ) ).

% SUP_lessD
thf(fact_2546_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: A,F2: B > A,A3: set @ B] :
          ( ( ord_less @ A @ A4 @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) )
          = ( ? [X2: B] :
                ( ( member @ B @ X2 @ A3 )
                & ( ord_less @ A @ A4 @ ( F2 @ X2 ) ) ) ) ) ) ).

% less_SUP_iff
thf(fact_2547_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Y: A,F2: B > A,A3: set @ B,I3: B] :
          ( ( ord_less @ A @ Y @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) )
         => ( ( member @ B @ I3 @ A3 )
           => ( ord_less @ A @ Y @ ( F2 @ I3 ) ) ) ) ) ).

% less_INF_D
thf(fact_2548_INF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B,A4: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ A4 )
          = ( ? [X2: B] :
                ( ( member @ B @ X2 @ A3 )
                & ( ord_less @ A @ ( F2 @ X2 ) @ A4 ) ) ) ) ) ).

% INF_less_iff
thf(fact_2549_filter__preserves__multiset,axiom,
    ! [A: $tType,M: A > nat,P: A > $o] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( M @ X2 ) ) ) )
     => ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( if @ nat @ ( P @ X2 ) @ ( M @ X2 ) @ ( zero_zero @ nat ) ) ) ) ) ) ).

% filter_preserves_multiset
thf(fact_2550_card__less__Suc2,axiom,
    ! [M: set @ nat,I3: nat] :
      ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K6: nat] :
                ( ( member @ nat @ ( suc @ K6 ) @ M )
                & ( ord_less @ nat @ K6 @ I3 ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K6: nat] :
                ( ( member @ nat @ K6 @ M )
                & ( ord_less @ nat @ K6 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_2551_card__less__Suc,axiom,
    ! [M: set @ nat,I3: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K6: nat] :
                  ( ( member @ nat @ ( suc @ K6 ) @ M )
                  & ( ord_less @ nat @ K6 @ I3 ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K6: nat] :
                ( ( member @ nat @ K6 @ M )
                & ( ord_less @ nat @ K6 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_2552_card__less,axiom,
    ! [M: set @ nat,I3: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K6: nat] :
                ( ( member @ nat @ K6 @ M )
                & ( ord_less @ nat @ K6 @ ( suc @ I3 ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_2553_wf,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( wf @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ ( ord_less @ A ) ) ) ) ) ).

% wf
thf(fact_2554_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A3: set @ A,F2: nat > A,N: nat] :
      ( ( A3
        = ( image2 @ nat @ A @ F2
          @ ( collect @ nat
            @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N ) ) ) )
     => ( finite_finite2 @ A @ A3 ) ) ).

% nat_seg_image_imp_finite
thf(fact_2555_finite__conv__nat__seg__image,axiom,
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( ^ [A6: set @ A] :
          ? [N5: nat,F3: nat > A] :
            ( A6
            = ( image2 @ nat @ A @ F3
              @ ( collect @ nat
                @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N5 ) ) ) ) ) ) ).

% finite_conv_nat_seg_image
thf(fact_2556_wf__if__measure,axiom,
    ! [A: $tType,P: A > $o,F2: A > nat,G: A > A] :
      ( ! [X: A] :
          ( ( P @ X )
         => ( ord_less @ nat @ ( F2 @ ( G @ X ) ) @ ( F2 @ X ) ) )
     => ( wf @ A
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [Y2: A,X2: A] :
                ( ( P @ X2 )
                & ( Y2
                  = ( G @ X2 ) ) ) ) ) ) ) ).

% wf_if_measure
thf(fact_2557_Field__natLeq__on,axiom,
    ! [N: nat] :
      ( ( field2 @ nat
        @ ( collect @ ( product_prod @ nat @ nat )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [X2: nat,Y2: nat] :
                ( ( ord_less @ nat @ X2 @ N )
                & ( ord_less @ nat @ Y2 @ N )
                & ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) )
      = ( collect @ nat
        @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) ) ) ).

% Field_natLeq_on
thf(fact_2558_natLeq__on__wo__rel,axiom,
    ! [N: nat] :
      ( bNF_Wellorder_wo_rel @ nat
      @ ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y2: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y2 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) ) ).

% natLeq_on_wo_rel
thf(fact_2559_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ? [F9: A > nat,N2: nat] :
          ( ( ( image2 @ A @ nat @ F9 @ A3 )
            = ( collect @ nat
              @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N2 ) ) )
          & ( inj_on @ A @ nat @ F9 @ A3 ) ) ) ).

% finite_imp_inj_to_nat_seg
thf(fact_2560_finite__imp__inj__to__nat__seg_H,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ~ ! [F9: A > nat] :
            ( ? [N2: nat] :
                ( ( image2 @ A @ nat @ F9 @ A3 )
                = ( collect @ nat
                  @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N2 ) ) )
           => ~ ( inj_on @ A @ nat @ F9 @ A3 ) ) ) ).

% finite_imp_inj_to_nat_seg'
thf(fact_2561_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( ( unboun7993243217541854897norder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ A @ X2 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_gt_at_bot
thf(fact_2562_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B3 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_2563_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A4 @ B3 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_2564_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B3 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_2565_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A4 @ B3 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_2566_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less @ A @ B3 @ ( plus_plus @ A @ A4 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_2567_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ B3 @ C2 )
           => ( ord_less @ A @ B3 @ ( plus_plus @ A @ A4 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_2568_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A4 @ B3 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_2569_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A4 @ B3 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_2570_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A4 @ B3 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_2571_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ D3 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_2572_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A4 @ B3 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B3 @ A4 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_2573_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A4 @ B3 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_2574_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ D3 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_2575_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A4 @ B3 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B3 @ A4 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_2576_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
            = ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_2577_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
            = ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_2578_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_2579_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_2580_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ D3 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_2581_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ D3 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_2582_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X3: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_2583_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y @ Y ) ) )
          = ( ( X3
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_2584_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_2585_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_2586_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_2587_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_2588_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A4 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B3 @ E2 ) @ D3 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A4 @ B3 ) @ E2 ) @ C2 ) @ D3 ) ) ) ).

% less_add_iff1
thf(fact_2589_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A4 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B3 @ E2 ) @ D3 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B3 @ A4 ) @ E2 ) @ D3 ) ) ) ) ).

% less_add_iff2
thf(fact_2590_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A4 ) @ ( divide_divide @ A @ C2 @ B3 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_2591_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A4 ) @ ( divide_divide @ A @ C2 @ B3 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_2592_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ ( times_times @ A @ Z2 @ Y ) @ X3 )
           => ( ord_less @ A @ Z2 @ ( divide_divide @ A @ X3 @ Y ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_2593_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X3: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ X3 @ ( times_times @ A @ Z2 @ Y ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X3 @ Y ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_2594_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_2595_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B3 @ C2 ) @ A4 )
            = ( ord_less @ A @ B3 @ ( times_times @ A @ A4 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_2596_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
            = ( ord_less @ A @ B3 @ ( times_times @ A @ A4 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_2597_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B3 @ C2 ) @ A4 )
            = ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_2598_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B3 @ ( times_times @ A @ A4 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_2599_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B3 @ C2 ) @ A4 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B3 @ ( times_times @ A @ A4 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A4 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_2600_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B3 @ A4 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
              & ( ord_less @ A @ B3 @ A4 ) )
            | ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A4 @ B3 ) )
            | ( A4
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_2601_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B3 @ A4 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
              & ( ord_less @ A @ A4 @ B3 ) )
            | ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B3 @ A4 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_2602_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
         => ? [N2: nat] : ( ord_less @ A @ Y @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ X3 ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_2603_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A4 @ B3 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B3 ) ) ) ).

% gt_half_sum
thf(fact_2604_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ord_less @ A @ A4 @ ( divide_divide @ A @ ( plus_plus @ A @ A4 @ B3 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_2605_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X3: A] :
          ( ! [E4: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E4 )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ E4 ) )
         => ( X3
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_2606_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A4 )
         => ( ord_less @ A @ ( power_power @ A @ A4 @ N ) @ ( times_times @ A @ A4 @ ( power_power @ A @ A4 @ N ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_2607_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A4 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A4 @ ( power_power @ A @ A4 @ N ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_2608_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A12: set @ A] :
                  ( ( finite_finite2 @ A @ A12 )
                 => ( ! [X4: A] :
                        ( ( member @ A @ X4 @ A12 )
                       => ( ord_less @ A @ B6 @ X4 ) )
                   => ( ( P @ A12 )
                     => ( P @ ( insert @ A @ B6 @ A12 ) ) ) ) )
             => ( P @ A3 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_2609_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A12: set @ A] :
                  ( ( finite_finite2 @ A @ A12 )
                 => ( ! [X4: A] :
                        ( ( member @ A @ X4 @ A12 )
                       => ( ord_less @ A @ X4 @ B6 ) )
                   => ( ( P @ A12 )
                     => ( P @ ( insert @ A @ B6 @ A12 ) ) ) ) )
             => ( P @ A3 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_2610_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,A4: A] :
          ( ( finite_finite2 @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X5 ) @ A4 )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ X5 )
                   => ( ord_less @ A @ X2 @ A4 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_2611_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A4 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A4 @ ( suc @ N ) ) ) ) ) ).

% power_gt1
thf(fact_2612_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A5: A] : ( if @ A @ ( ord_less @ A @ A5 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A5 ) @ A5 ) ) ) ) ).

% abs_if
thf(fact_2613_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A4 )
            = ( uminus_uminus @ A @ A4 ) ) ) ) ).

% abs_of_neg
thf(fact_2614_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,A4: A,R5: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ A4 ) ) @ R5 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A4 @ R5 ) @ X3 )
            & ( ord_less @ A @ X3 @ ( plus_plus @ A @ A4 @ R5 ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_2615_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,A4: A] :
          ( ( finite_finite2 @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A4 @ ( complete_Inf_Inf @ A @ X5 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ X5 )
                   => ( ord_less @ A @ A4 @ X2 ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_2616_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X: B] :
                  ( ( member @ B @ X @ A3 )
                 => ( ord_less @ A @ ( F2 @ X ) @ ( G @ X ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_2617_less__cSup__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,Y: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ X5 )
           => ( ( ord_less @ A @ Y @ ( complete_Sup_Sup @ A @ X5 ) )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ X5 )
                    & ( ord_less @ A @ Y @ X2 ) ) ) ) ) ) ) ).

% less_cSup_iff
thf(fact_2618_cInf__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,Y: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ X5 )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X5 ) @ Y )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ X5 )
                    & ( ord_less @ A @ X2 @ Y ) ) ) ) ) ) ) ).

% cInf_less_iff
thf(fact_2619_Un__interval,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [B13: A,B24: A,B32: A,F2: A > B] :
          ( ( ord_less_eq @ A @ B13 @ B24 )
         => ( ( ord_less_eq @ A @ B24 @ B32 )
           => ( ( sup_sup @ ( set @ B )
                @ ( collect @ B
                  @ ^ [Uu: B] :
                    ? [I2: A] :
                      ( ( Uu
                        = ( F2 @ I2 ) )
                      & ( ord_less_eq @ A @ B13 @ I2 )
                      & ( ord_less @ A @ I2 @ B24 ) ) )
                @ ( collect @ B
                  @ ^ [Uu: B] :
                    ? [I2: A] :
                      ( ( Uu
                        = ( F2 @ I2 ) )
                      & ( ord_less_eq @ A @ B24 @ I2 )
                      & ( ord_less @ A @ I2 @ B32 ) ) ) )
              = ( collect @ B
                @ ^ [Uu: B] :
                  ? [I2: A] :
                    ( ( Uu
                      = ( F2 @ I2 ) )
                    & ( ord_less_eq @ A @ B13 @ I2 )
                    & ( ord_less @ A @ I2 @ B32 ) ) ) ) ) ) ) ).

% Un_interval
thf(fact_2620_add__mset__in__multiset,axiom,
    ! [A: $tType,M: A > nat,A4: A] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( M @ X2 ) ) ) )
     => ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( if @ nat @ ( X2 = A4 ) @ ( suc @ ( M @ X2 ) ) @ ( M @ X2 ) ) ) ) ) ) ).

% add_mset_in_multiset
thf(fact_2621_diff__preserves__multiset,axiom,
    ! [A: $tType,M: A > nat,N4: A > nat] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( M @ X2 ) ) ) )
     => ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ ( M @ X2 ) @ ( N4 @ X2 ) ) ) ) ) ) ).

% diff_preserves_multiset
thf(fact_2622_cSUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A3: set @ B,Y: A,I3: B] :
          ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
         => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ Y )
           => ( ( member @ B @ I3 @ A3 )
             => ( ord_less @ A @ ( F2 @ I3 ) @ Y ) ) ) ) ) ).

% cSUP_lessD
thf(fact_2623_less__cINF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A3: set @ B,Y: A,I3: B] :
          ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
         => ( ( ord_less @ A @ Y @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) )
           => ( ( member @ B @ I3 @ A3 )
             => ( ord_less @ A @ Y @ ( F2 @ I3 ) ) ) ) ) ) ).

% less_cINF_D
thf(fact_2624_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X4: A] :
                  ( ( member @ A @ X4 @ S2 )
                  & ( ord_less @ B @ ( F2 @ X4 ) @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_2625_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ? [N2: nat,F9: nat > A] :
          ( ( A3
            = ( image2 @ nat @ A @ F9
              @ ( collect @ nat
                @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N2 ) ) ) )
          & ( inj_on @ nat @ A @ F9
            @ ( collect @ nat
              @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N2 ) ) ) ) ) ).

% finite_imp_nat_seg_image_inj_on
thf(fact_2626_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A4 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A4 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_2627_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B3: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B3 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B3 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B3 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_2628_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A4: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A4 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A4 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A4 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_2629_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B3: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B3 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B3 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B3 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_2630_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A4 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A4 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_2631_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B3: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B3 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B3 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B3 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_2632_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A4: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A4 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A4 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A4 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_2633_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B3: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B3 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B3 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_2634_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y: A] :
          ( ! [Z4: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z4 )
             => ( ( ord_less @ A @ Z4 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z4 @ X3 ) @ Y ) ) )
         => ( ord_less_eq @ A @ X3 @ Y ) ) ) ).

% field_le_mult_one_interval
thf(fact_2635_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B3 @ C2 ) @ A4 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B3 @ ( times_times @ A @ A4 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_2636_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B3 @ ( times_times @ A @ A4 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_2637_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A4 ) @ ( divide_divide @ A @ C2 @ B3 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_2638_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B3 @ C2 ) @ A4 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_2639_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
            = ( ord_less_eq @ A @ B3 @ ( times_times @ A @ A4 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_2640_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B3 @ C2 ) @ A4 )
            = ( ord_less_eq @ A @ B3 @ ( times_times @ A @ A4 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_2641_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_2642_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X3: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X3 @ ( times_times @ A @ Z2 @ Y ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X3 @ Y ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_2643_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ Y ) @ X3 )
           => ( ord_less_eq @ A @ Z2 @ ( divide_divide @ A @ X3 @ Y ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_2644_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A4 ) @ ( divide_divide @ A @ C2 @ B3 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_2645_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B3 @ A4 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
              & ( ord_less_eq @ A @ A4 @ B3 ) )
            | ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_2646_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B3 @ A4 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
              & ( ord_less_eq @ A @ B3 @ A4 ) )
            | ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A4 @ B3 ) )
            | ( A4
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_2647_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X3: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X3 @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_2648_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ A4 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A4 @ ( power_power @ A @ A4 @ N ) ) @ ( power_power @ A @ A4 @ N ) ) ) ) ) ).

% power_Suc_less
thf(fact_2649_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( uminus_uminus @ A @ B3 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_2650_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) @ A4 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( uminus_uminus @ A @ B3 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A4 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_2651_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A4 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_2652_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) @ A4 )
            = ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_2653_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A4 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A4 @ C2 ) @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_2654_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) @ A4 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_2655_filterlim__at__bot__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( dense_linorder @ B )
        & ( no_bot @ B ) )
     => ! [F2: A > B,F: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F )
          = ( ! [Z7: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ Z7 )
                @ F ) ) ) ) ).

% filterlim_at_bot_dense
thf(fact_2656_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ A4 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A4 @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_2657_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X3 ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_2658_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I: set @ B,F2: B > A] :
          ( ( finite_finite2 @ B @ I )
         => ( ( I
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I4: B] :
                  ( ( member @ B @ I4 @ I )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I ) ) ) ) ) ) ).

% sum_pos
thf(fact_2659_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,M2: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A4 @ M2 ) @ ( power_power @ A @ A4 @ N ) )
           => ( ord_less_eq @ nat @ M2 @ N ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_2660_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I: set @ A,I3: A,F2: A > B] :
          ( ( finite_finite2 @ A @ I )
         => ( ( member @ A @ I3 @ I )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I3 ) )
             => ( ! [I4: A] :
                    ( ( member @ A @ I4 @ I )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ I4 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_2661_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I: set @ A,F2: A > B] :
          ( ( finite_finite2 @ A @ I )
         => ( ( I
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I4: A] :
                  ( ( member @ A @ I4 @ I )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I4 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I ) ) ) ) ) ) ).

% less_1_prod
thf(fact_2662_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less_eq @ A @ A4 @ ( power_power @ A @ A4 @ N ) ) ) ) ) ).

% self_le_power
thf(fact_2663_card__gt__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite2 @ A @ A3 ) ) ) ).

% card_gt_0_iff
thf(fact_2664_less__cSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A3: set @ B,F2: B > A,A4: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
           => ( ( ord_less @ A @ A4 @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) )
              = ( ? [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                    & ( ord_less @ A @ A4 @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% less_cSUP_iff
thf(fact_2665_cINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A3: set @ B,F2: B > A,A4: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ A3 ) )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ A4 )
              = ( ? [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                    & ( ord_less @ A @ ( F2 @ X2 ) @ A4 ) ) ) ) ) ) ) ).

% cINF_less_iff
thf(fact_2666_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X3: A,A4: A,Y: A,U2: A,V: A] :
          ( ( ord_less @ A @ X3 @ A4 )
         => ( ( ord_less @ A @ Y @ A4 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U2 @ V )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U2 @ X3 ) @ ( times_times @ A @ V @ Y ) ) @ A4 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_2667_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) @ A4 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_2668_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A4 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_2669_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) @ A4 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_2670_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A4 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_2671_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) @ A4 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ ( uminus_uminus @ A @ B3 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_2672_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B3 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A4 @ C2 ) @ ( uminus_uminus @ A @ B3 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A4 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_2673_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F )
          = ( ! [Z7: B] :
                ( ( ord_less @ B @ Z7 @ C2 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z7 )
                  @ F ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_2674_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ A3 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) )
                  & ( ord_less @ A @ ( F2 @ I4 ) @ ( G @ I4 ) ) ) )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_2675_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
         => ~ ! [N2: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) ) @ E2 ) ) ) ).

% nat_approx_posE
thf(fact_2676_card__Diff1__less__iff,axiom,
    ! [A: $tType,A3: set @ A,X3: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) )
      = ( ( finite_finite2 @ A @ A3 )
        & ( member @ A @ X3 @ A3 ) ) ) ).

% card_Diff1_less_iff
thf(fact_2677_card__Diff2__less,axiom,
    ! [A: $tType,A3: set @ A,X3: A,Y: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( member @ A @ X3 @ A3 )
       => ( ( member @ A @ Y @ A3 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_2678_card__Diff1__less,axiom,
    ! [A: $tType,A3: set @ A,X3: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( member @ A @ X3 @ A3 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff1_less
thf(fact_2679_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat,A4: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( power_power @ A @ A4 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ A4 )
            = ( power_power @ A @ A4 @ N ) ) ) ) ).

% power_minus_mult
thf(fact_2680_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X3: A,Y: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X3 ) @ ( times_times @ A @ C2 @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X3 @ Y )
               => ( ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y ) @ ( times_times @ A @ C2 @ X3 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X3 @ Y )
               => ( ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_2681_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X3 @ Y )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X3 @ C2 ) @ ( times_times @ A @ Y @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y @ C2 ) @ ( times_times @ A @ X3 @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X3 @ Y )
           => ( ( image2 @ A @ A
                @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_2682_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,A4: nat,B3: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A4 @ B3 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A5: nat] : ( plus_plus @ A @ ( F2 @ A5 ) )
            @ A4
            @ B3
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_2683_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ X3 ) @ ( times_times @ A @ Z2 @ Y ) )
            = ( ord_less_eq @ A @ X3 @ Y ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_2684_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ Y @ Z2 ) )
            = ( ord_less_eq @ A @ X3 @ Y ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_2685_natLess__def,axiom,
    ( bNF_Ca8459412986667044542atLess
    = ( collect @ ( product_prod @ nat @ nat ) @ ( product_case_prod @ nat @ nat @ $o @ ( ord_less @ nat ) ) ) ) ).

% natLess_def
thf(fact_2686_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M5: nat,N5: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N5
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M5 @ N5 ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M5 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q8: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q8 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M5 @ N5 ) @ N5 ) ) ) ) ) ).

% divmod_nat_if
thf(fact_2687_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ Y @ Z2 ) )
            = ( ord_less @ A @ X3 @ Y ) ) ) ) ).

% mult_less_iff1
thf(fact_2688_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I2 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_2689_finite__interval__int4,axiom,
    ! [A4: int,B3: int] :
      ( finite_finite2 @ int
      @ ( collect @ int
        @ ^ [I2: int] :
            ( ( ord_less @ int @ A4 @ I2 )
            & ( ord_less @ int @ I2 @ B3 ) ) ) ) ).

% finite_interval_int4
thf(fact_2690_finite__interval__int2,axiom,
    ! [A4: int,B3: int] :
      ( finite_finite2 @ int
      @ ( collect @ int
        @ ^ [I2: int] :
            ( ( ord_less_eq @ int @ A4 @ I2 )
            & ( ord_less @ int @ I2 @ B3 ) ) ) ) ).

% finite_interval_int2
thf(fact_2691_finite__interval__int3,axiom,
    ! [A4: int,B3: int] :
      ( finite_finite2 @ int
      @ ( collect @ int
        @ ^ [I2: int] :
            ( ( ord_less @ int @ A4 @ I2 )
            & ( ord_less_eq @ int @ I2 @ B3 ) ) ) ) ).

% finite_interval_int3
thf(fact_2692_not__psubset__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ~ ( ord_less @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ).

% not_psubset_empty
thf(fact_2693_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F3 @ G2 )
              & ~ ( ord_less_eq @ ( A > B ) @ G2 @ F3 ) ) ) ) ) ).

% less_fun_def
thf(fact_2694_less__assn__def,axiom,
    ( ( ord_less @ assn )
    = ( ^ [A5: assn,B4: assn] :
          ( ( ord_less_eq @ assn @ A5 @ B4 )
          & ( A5 != B4 ) ) ) ) ).

% less_assn_def
thf(fact_2695_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I2: int,J3: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J3 @ I2 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert @ int @ I2 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J3 ) ) ) ) ) ).

% simp_from_to
thf(fact_2696_sum__choose__upper,axiom,
    ! [M2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K6: nat] : ( binomial @ K6 @ M2 )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( suc @ N ) @ ( suc @ M2 ) ) ) ).

% sum_choose_upper
thf(fact_2697_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_less_as_int
thf(fact_2698_remove__subset,axiom,
    ! [A: $tType,X3: A,S2: set @ A] :
      ( ( member @ A @ X3 @ S2 )
     => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ S2 ) ) ).

% remove_subset
thf(fact_2699_disjoint__alt__simp3,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) @ A3 )
      = ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjoint_alt_simp3
thf(fact_2700_sum__choose__lower,axiom,
    ! [R5: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K6: nat] : ( binomial @ ( plus_plus @ nat @ R5 @ K6 ) @ K6 )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( suc @ ( plus_plus @ nat @ R5 @ N ) ) @ N ) ) ).

% sum_choose_lower
thf(fact_2701_choose__rising__sum_I1_J,axiom,
    ! [N: nat,M2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N @ J3 ) @ N )
        @ ( set_ord_atMost @ nat @ M2 ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M2 ) @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% choose_rising_sum(1)
thf(fact_2702_choose__rising__sum_I2_J,axiom,
    ! [N: nat,M2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N @ J3 ) @ N )
        @ ( set_ord_atMost @ nat @ M2 ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M2 ) @ ( one_one @ nat ) ) @ M2 ) ) ).

% choose_rising_sum(2)
thf(fact_2703_diff__nat__eq__if,axiom,
    ! [Z8: int,Z2: int] :
      ( ( ( ord_less @ int @ Z8 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z8 ) )
          = ( nat2 @ Z2 ) ) )
      & ( ~ ( ord_less @ int @ Z8 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z8 ) )
          = ( if @ nat @ ( ord_less @ int @ ( minus_minus @ int @ Z2 @ Z8 ) @ ( zero_zero @ int ) ) @ ( zero_zero @ nat ) @ ( nat2 @ ( minus_minus @ int @ Z2 @ Z8 ) ) ) ) ) ) ).

% diff_nat_eq_if
thf(fact_2704_wf__bounded__supset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( finite_finite2 @ A @ S2 )
     => ( wf @ ( set @ A )
        @ ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
          @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
            @ ^ [Q9: set @ A,Q3: set @ A] :
                ( ( ord_less @ ( set @ A ) @ Q3 @ Q9 )
                & ( ord_less_eq @ ( set @ A ) @ Q9 @ S2 ) ) ) ) ) ) ).

% wf_bounded_supset
thf(fact_2705_finite__subset__wf,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( wf @ ( set @ A )
        @ ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
          @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
            @ ^ [X7: set @ A,Y9: set @ A] :
                ( ( ord_less @ ( set @ A ) @ X7 @ Y9 )
                & ( ord_less_eq @ ( set @ A ) @ Y9 @ A3 ) ) ) ) ) ) ).

% finite_subset_wf
thf(fact_2706_finite__induct__select,axiom,
    ! [A: $tType,S2: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite2 @ A @ S2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T6: set @ A] :
              ( ( ord_less @ ( set @ A ) @ T6 @ S2 )
             => ( ( P @ T6 )
               => ? [X4: A] :
                    ( ( member @ A @ X4 @ ( minus_minus @ ( set @ A ) @ S2 @ T6 ) )
                    & ( P @ ( insert @ A @ X4 @ T6 ) ) ) ) )
         => ( P @ S2 ) ) ) ) ).

% finite_induct_select
thf(fact_2707_psubset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X3: A,B2: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ B2 ) )
      = ( ( ( member @ A @ X3 @ B2 )
         => ( ord_less @ ( set @ A ) @ A3 @ B2 ) )
        & ( ~ ( member @ A @ X3 @ B2 )
         => ( ( ( member @ A @ X3 @ A3 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B2 ) )
            & ( ~ ( member @ A @ X3 @ A3 )
             => ( ord_less_eq @ ( set @ A ) @ A3 @ B2 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_2708_sum__choose__diagonal,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K6: nat] : ( binomial @ ( minus_minus @ nat @ N @ K6 ) @ ( minus_minus @ nat @ M2 @ K6 ) )
          @ ( set_ord_atMost @ nat @ M2 ) )
        = ( binomial @ ( suc @ N ) @ M2 ) ) ) ).

% sum_choose_diagonal
thf(fact_2709_vandermonde,axiom,
    ! [M2: nat,N: nat,R5: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K6: nat] : ( times_times @ nat @ ( binomial @ M2 @ K6 ) @ ( binomial @ N @ ( minus_minus @ nat @ R5 @ K6 ) ) )
        @ ( set_ord_atMost @ nat @ R5 ) )
      = ( binomial @ ( plus_plus @ nat @ M2 @ N ) @ R5 ) ) ).

% vandermonde
thf(fact_2710_binomial,axiom,
    ! [A4: nat,B3: nat,N: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A4 @ B3 ) @ N )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K6: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N @ K6 ) ) @ ( power_power @ nat @ A4 @ K6 ) ) @ ( power_power @ nat @ B3 @ ( minus_minus @ nat @ N @ K6 ) ) )
        @ ( set_ord_atMost @ nat @ N ) ) ) ).

% binomial
thf(fact_2711_n__subsets,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_card @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [B5: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B5 @ A3 )
                & ( ( finite_card @ A @ B5 )
                  = K ) ) ) )
        = ( binomial @ ( finite_card @ A @ A3 ) @ K ) ) ) ).

% n_subsets
thf(fact_2712_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: A,B3: A,N: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A4 @ B3 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K6 ) ) @ ( power_power @ A @ A4 @ K6 ) ) @ ( power_power @ A @ B3 @ ( minus_minus @ nat @ N @ K6 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% binomial_ring
thf(fact_2713_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( N
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I2 ) @ ( semiring_1_of_nat @ A @ I2 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_2714_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: nat > ( set @ A ),S2: set @ A] :
      ( ! [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ I4 ) @ S2 )
     => ( ( finite_finite2 @ A @ S2 )
       => ( ? [N6: nat] :
              ( ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N2 @ N6 )
                 => ! [M3: nat] :
                      ( ( ord_less_eq @ nat @ M3 @ N6 )
                     => ( ( ord_less @ nat @ M3 @ N2 )
                       => ( ord_less @ ( set @ A ) @ ( F2 @ M3 ) @ ( F2 @ N2 ) ) ) ) )
              & ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N2 )
                 => ( ( F2 @ N6 )
                    = ( F2 @ N2 ) ) ) )
         => ( ( F2 @ ( finite_card @ A @ S2 ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ F2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_2715_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F3: A > nat,R2: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X2: A,Y2: A] :
                  ( ( ord_less @ nat @ ( F3 @ X2 ) @ ( F3 @ Y2 ) )
                  | ( ( ord_less_eq @ nat @ ( F3 @ X2 ) @ ( F3 @ Y2 ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R2 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_2716_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat,A4: A,X3: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ A4 ) @ K6 ) @ ( power_power @ A @ X3 @ K6 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M2 @ K6 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K6 ) @ A4 ) @ ( one_one @ A ) ) @ K6 ) @ ( power_power @ A @ X3 @ K6 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X3 @ Y ) @ ( minus_minus @ nat @ M2 @ K6 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_2717_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I2: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J3 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K6: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( G @ I2 @ ( minus_minus @ nat @ K6 @ I2 ) )
                @ ( set_ord_atMost @ nat @ K6 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.triangle_reindex
thf(fact_2718_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I2: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J3 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( G @ I2 @ ( minus_minus @ nat @ K6 @ I2 ) )
                @ ( set_ord_atMost @ nat @ K6 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.triangle_reindex
thf(fact_2719_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N5: nat] :
              ( if @ A
              @ ( N5
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O2: nat] : ( times_times @ A @ ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ O2 ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N5 @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_2720_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite2 @ ( product_prod @ A @ A ) @ R )
     => ( ( transitive_trancl @ A @ R )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image2 @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N5: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N5 @ R )
            @ ( collect @ nat
              @ ^ [N5: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N5 )
                  & ( ord_less_eq @ nat @ N5 @ ( finite_card @ ( product_prod @ A @ A ) @ R ) ) ) ) ) ) ) ) ).

% trancl_finite_eq_relpow
thf(fact_2721_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A4: A] :
          ( ( gbinomial @ A @ A4 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_2722_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A4 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_2723_lessThan__0,axiom,
    ( ( set_ord_lessThan @ nat @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% lessThan_0
thf(fact_2724_single__Diff__lessThan,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A] :
          ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ K @ ( bot_bot @ ( set @ A ) ) ) @ ( set_ord_lessThan @ A @ K ) )
          = ( insert @ A @ K @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% single_Diff_lessThan
thf(fact_2725_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_2726_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X3 )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X3 ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_2727_less__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A6: set @ A,B5: set @ A] :
            ( ord_less @ ( A > $o )
            @ ^ [X2: A] : ( member @ A @ X2 @ A6 )
            @ ^ [X2: A] : ( member @ A @ X2 @ B5 ) ) ) ) ).

% less_set_def
thf(fact_2728_lessThan__non__empty,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X3: A] :
          ( ( set_ord_lessThan @ A @ X3 )
         != ( bot_bot @ ( set @ A ) ) ) ) ).

% lessThan_non_empty
thf(fact_2729_lessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_lessThan @ A )
        = ( ^ [U: A] :
              ( collect @ A
              @ ^ [X2: A] : ( ord_less @ A @ X2 @ U ) ) ) ) ) ).

% lessThan_def
thf(fact_2730_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( ( set_ord_lessThan @ nat @ N )
        = ( bot_bot @ ( set @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% lessThan_empty_iff
thf(fact_2731_Iio__eq__empty__iff,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( order_bot @ A ) )
     => ! [N: A] :
          ( ( ( set_ord_lessThan @ A @ N )
            = ( bot_bot @ ( set @ A ) ) )
          = ( N
            = ( bot_bot @ A ) ) ) ) ).

% Iio_eq_empty_iff
thf(fact_2732_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A4 @ K ) @ ( gbinomial @ A @ A4 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_2733_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_2734_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ N @ ( suc @ I2 ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.nat_diff_reindex
thf(fact_2735_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ N @ ( suc @ I2 ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.nat_diff_reindex
thf(fact_2736_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% relpow_empty
thf(fact_2737_ivl__disj__int__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(4)
thf(fact_2738_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,K: nat] :
          ( ( gbinomial @ A @ A4 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_2739_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A4 @ K ) )
          = ( times_times @ A @ A4 @ ( gbinomial @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_2740_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A4 @ K ) @ A4 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A4 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A4 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_2741_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,K: nat] :
          ( ( times_times @ A @ A4 @ ( gbinomial @ A @ A4 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A4 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A4 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_2742_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P: A > nat,N: A] :
          ( ! [X: A] : ( ord_less_eq @ nat @ ( Q @ X ) @ ( P @ X ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P @ ( set_ord_lessThan @ A @ N ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X2: A] : ( minus_minus @ nat @ ( P @ X2 ) @ ( Q @ X2 ) )
              @ ( set_ord_lessThan @ A @ N ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_2743_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_2744_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N5: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N5 ) ) @ ( F2 @ N5 ) )
            @ ( set_ord_lessThan @ nat @ M2 ) )
          = ( minus_minus @ A @ ( F2 @ M2 ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ).

% sum_lessThan_telescope
thf(fact_2745_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N5: nat] : ( minus_minus @ A @ ( F2 @ N5 ) @ ( F2 @ ( suc @ N5 ) ) )
            @ ( set_ord_lessThan @ nat @ M2 ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ M2 ) ) ) ) ).

% sum_lessThan_telescope'
thf(fact_2746_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_2747_rtrancl__is__UN__relpow,axiom,
    ! [A: $tType] :
      ( ( transitive_rtrancl @ A )
      = ( ^ [R2: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image2 @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N5: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N5 @ R2 )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% rtrancl_is_UN_relpow
thf(fact_2748_rtrancl__imp__UN__relpow,axiom,
    ! [A: $tType,P5: product_prod @ A @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P5 @ ( transitive_rtrancl @ A @ R ) )
     => ( member @ ( product_prod @ A @ A ) @ P5
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image2 @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N5: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N5 @ R )
            @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% rtrancl_imp_UN_relpow
thf(fact_2749_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( G @ ( suc @ K6 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.atLeast1_atMost_eq
thf(fact_2750_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K6: nat] : ( G @ ( suc @ K6 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.atLeast1_atMost_eq
thf(fact_2751_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A4 @ ( suc @ N ) )
          = ( times_times @ A @ A4 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% pochhammer_rec
thf(fact_2752_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,Mm: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( F2 @ ( suc @ K6 ) )
            @ ( set_ord_lessThan @ nat @ Mm ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ Mm ) ) ) ) ).

% sum_bounds_lt_plus1
thf(fact_2753_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) ) ) ).

% pochhammer_rec'
thf(fact_2754_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A4 @ ( suc @ N ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A4 @ N ) @ ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_2755_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat,M2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( plus_plus @ nat @ N @ M2 ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ M2 ) ) ) ) ).

% pochhammer_product'
thf(fact_2756_sum_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A4 @ I2 ) @ ( set_ord_lessThan @ nat @ I2 ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( A4 @ I2 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.nested_swap'
thf(fact_2757_prod_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A4 @ I2 ) @ ( set_ord_lessThan @ nat @ I2 ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( A4 @ I2 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.nested_swap'
thf(fact_2758_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,K: A] :
          ( ( ( ord_less @ A @ X3 @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X3 @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_2759_ivl__disj__un__singleton_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [U2: A] :
          ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ U2 ) @ ( insert @ A @ U2 @ ( bot_bot @ ( set @ A ) ) ) )
          = ( set_ord_atMost @ A @ U2 ) ) ) ).

% ivl_disj_un_singleton(2)
thf(fact_2760_UN__lessThan__UNIV,axiom,
    ( ( complete_Sup_Sup @ ( set @ nat ) @ ( image2 @ nat @ ( set @ nat ) @ ( set_ord_lessThan @ nat ) @ ( top_top @ ( set @ nat ) ) ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% UN_lessThan_UNIV
thf(fact_2761_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A4: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A4 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_2762_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A4: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A4 @ ( suc @ K ) ) )
          = ( times_times @ A @ A4 @ ( gbinomial @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_2763_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M2: nat,A4: A] :
          ( ( ord_less_eq @ nat @ K @ M2 )
         => ( ( times_times @ A @ ( gbinomial @ A @ A4 @ M2 ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M2 ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A4 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M2 @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_2764_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X3 @ N ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X3 @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_2765_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_2766_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,N: nat] :
          ( ( X3
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_lessThan @ nat @ N ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X3 @ N ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X3 @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_2767_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_2768_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_2769_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M2: nat,N: nat,Z2: A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ Z2 @ N )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ M2 ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_2770_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ K6 ) ) @ K6 )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ N ) ) ) ).

% gbinomial_parallel_sum
thf(fact_2771_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A4 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_2772_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A4 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_2773_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K6: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K6 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K6 ) @ A5 ) @ ( one_one @ A ) ) @ K6 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_2774_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N ) ) ) ) ).

% gbinomial_index_swap
thf(fact_2775_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( ( X3
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) )
          & ( ( X3
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ N ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_2776_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X3 @ N ) @ ( power_power @ A @ Y @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ X3 @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ ( suc @ I2 ) ) ) @ ( power_power @ A @ X3 @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_2777_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X3 @ ( suc @ N ) ) @ ( power_power @ A @ Y @ ( suc @ N ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X3 @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ X3 @ P6 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ P6 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_2778_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R5: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R5 @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R5 ) @ K ) )
          = ( times_times @ A @ R5 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R5 ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_2779_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite2 @ ( product_prod @ A @ A ) @ R )
     => ( ( transitive_rtrancl @ A @ R )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image2 @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N5: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N5 @ R )
            @ ( collect @ nat
              @ ^ [N5: nat] : ( ord_less_eq @ nat @ N5 @ ( finite_card @ ( product_prod @ A @ A ) @ R ) ) ) ) ) ) ) ).

% rtrancl_finite_eq_relpow
thf(fact_2780_relpow__finite__bounded,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite2 @ ( product_prod @ A @ A ) @ R )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R )
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image2 @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N5: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N5 @ R )
            @ ( collect @ nat
              @ ^ [N5: nat] : ( ord_less_eq @ nat @ N5 @ ( finite_card @ ( product_prod @ A @ A ) @ R ) ) ) ) ) ) ) ).

% relpow_finite_bounded
thf(fact_2781_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A4 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_2782_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X3 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( power_power @ A @ X3 @ ( minus_minus @ nat @ N @ ( suc @ I2 ) ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_2783_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A4: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A4 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_2784_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A4 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_2785_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N5: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N5 @ I2 ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N5 ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_2786_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B3: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B3 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_2787_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B3: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B3 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_2788_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( times_times @ A @ ( gbinomial @ A @ A4 @ K6 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K6 ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ ( gbinomial @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) @ M2 ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_2789_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A4 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I2 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_2790_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A4: A,B3: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A4 @ B3 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K6 ) ) @ ( comm_s3205402744901411588hammer @ A @ A4 @ K6 ) ) @ ( comm_s3205402744901411588hammer @ A @ B3 @ ( minus_minus @ nat @ N @ K6 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_2791_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J3 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_2792_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat,A4: A,X3: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ A4 ) @ K6 ) @ ( power_power @ A @ X3 @ K6 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M2 @ K6 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A4 ) @ K6 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X3 ) @ K6 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X3 @ Y ) @ ( minus_minus @ nat @ M2 @ K6 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_2793_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A4: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A4 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A4 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_2794_relpow__finite__bounded1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite2 @ ( product_prod @ A @ A ) @ R )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image2 @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N5: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N5 @ R )
              @ ( collect @ nat
                @ ^ [N5: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N5 )
                    & ( ord_less_eq @ nat @ N5 @ ( finite_card @ ( product_prod @ A @ A ) @ R ) ) ) ) ) ) ) ) ) ).

% relpow_finite_bounded1
thf(fact_2795_ntrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_ntrancl @ A )
      = ( ^ [N5: nat,R2: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image2 @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [I2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ I2 @ R2 )
              @ ( collect @ nat
                @ ^ [I2: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I2 )
                    & ( ord_less_eq @ nat @ I2 @ ( suc @ N5 ) ) ) ) ) ) ) ) ).

% ntrancl_def
thf(fact_2796_finite__psubset__def,axiom,
    ! [A: $tType] :
      ( ( finite_psubset @ A )
      = ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
        @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
          @ ^ [A6: set @ A,B5: set @ A] :
              ( ( ord_less @ ( set @ A ) @ A6 @ B5 )
              & ( finite_finite2 @ A @ B5 ) ) ) ) ) ).

% finite_psubset_def
thf(fact_2797_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K6: nat] :
              ( if @ A
              @ ( K6
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L2: nat] : ( times_times @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ L2 ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K6 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K6 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_2798_int__ge__less__than__def,axiom,
    ( int_ge_less_than
    = ( ^ [D4: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z9: int,Z3: int] :
                ( ( ord_less_eq @ int @ D4 @ Z9 )
                & ( ord_less @ int @ Z9 @ Z3 ) ) ) ) ) ) ).

% int_ge_less_than_def
thf(fact_2799_int__ge__less__than2__def,axiom,
    ( int_ge_less_than2
    = ( ^ [D4: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z9: int,Z3: int] :
                ( ( ord_less_eq @ int @ D4 @ Z3 )
                & ( ord_less @ int @ Z9 @ Z3 ) ) ) ) ) ) ).

% int_ge_less_than2_def
thf(fact_2800_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A4: A,K: nat] :
          ( ( gbinomial @ A @ A4 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_2801_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_2802_fact__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_1
thf(fact_2803_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_2804_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_Suc
thf(fact_2805_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_1
thf(fact_2806_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_semiring_1 @ A ) )
     => ( ( semiring_char_0_fact @ A )
        = ( comm_s3205402744901411588hammer @ A @ ( one_one @ A ) ) ) ) ).

% pochhammer_fact
thf(fact_2807_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N5: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X2: nat] : X2
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N5 ) ) ) ) ) ) ).

% fact_prod
thf(fact_2808_fact__eq__fact__times,axiom,
    ! [N: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ N @ M2 )
     => ( ( semiring_char_0_fact @ nat @ M2 )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X2: nat] : X2
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M2 ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_2809_fact__div__fact,axiom,
    ! [N: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ N @ M2 )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M2 ) @ ( semiring_char_0_fact @ nat @ N ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M2 ) ) ) ) ).

% fact_div_fact
thf(fact_2810_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M5: nat] :
              ( if @ A
              @ ( M5
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M5 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M5 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_2811_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_2812_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% pochhammer_same
thf(fact_2813_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_2814_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_2815_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K6: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ K6 ) ) @ ( one_one @ A ) ) @ K6 ) @ ( semiring_char_0_fact @ A @ K6 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_2816_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K6: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K6 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A5 ) @ K6 ) ) @ ( semiring_char_0_fact @ A @ K6 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_2817_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K6: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ I2 ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K6 ) )
              @ ( semiring_char_0_fact @ A @ K6 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_2818_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A4 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_2819_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A4: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A4 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_2820_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I2 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_2821_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K6: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ I2 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K6 @ I2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K6 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_2822_times__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U ) @ ( times_times @ nat @ Y2 @ V2 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V2 ) @ ( times_times @ nat @ Y2 @ U ) ) ) ) )
    @ ( times_times @ int ) ) ).

% times_int.transfer
thf(fact_2823_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( set_or7035219750837199246ssThan @ A @ A4 @ B3 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_2824_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A4 @ B3 ) )
          = ( ~ ( ord_less @ A @ A4 @ B3 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_2825_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A4 @ B3 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A4 @ B3 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_2826_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I3: A,J2: A] :
          ( ( image2 @ A @ A
            @ ^ [N5: A] : ( plus_plus @ A @ N5 @ K )
            @ ( set_or7035219750837199246ssThan @ A @ I3 @ J2 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J2 @ K ) ) ) ) ).

% image_add_atLeastLessThan'
thf(fact_2827_atLeastLessThan__singleton,axiom,
    ! [M2: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ M2 ) )
      = ( insert @ nat @ M2 @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atLeastLessThan_singleton
thf(fact_2828_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M2: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_2829_ivl__disj__int__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M2 ) @ ( set_or7035219750837199246ssThan @ A @ M2 @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(3)
thf(fact_2830_atLeastLessThan0,axiom,
    ! [M2: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M2 @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% atLeastLessThan0
thf(fact_2831_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M2: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ).

% sum.shift_bounds_Suc_ivl
thf(fact_2832_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M2: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( plus_plus @ nat @ I2 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ).

% sum.shift_bounds_nat_ivl
thf(fact_2833_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M2: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ).

% prod.shift_bounds_Suc_ivl
thf(fact_2834_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M2: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( plus_plus @ nat @ I2 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ).

% prod.shift_bounds_nat_ivl
thf(fact_2835_ivl__disj__int__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M2 ) @ ( set_or1337092689740270186AtMost @ A @ M2 @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(7)
thf(fact_2836_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,P5: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( ord_less_eq @ nat @ N @ P5 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P5 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ P5 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_2837_ivl__disj__int__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or7035219750837199246ssThan @ A @ L @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(2)
thf(fact_2838_nat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ nat @ nat @ pcr_int
    @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ nat2 ) ).

% nat.transfer
thf(fact_2839_binomial__def,axiom,
    ( binomial
    = ( ^ [N5: nat,K6: nat] :
          ( finite_card @ ( set @ nat )
          @ ( collect @ ( set @ nat )
            @ ^ [K7: set @ nat] :
                ( ( member @ ( set @ nat ) @ K7 @ ( pow @ nat @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N5 ) ) )
                & ( ( finite_card @ nat @ K7 )
                  = K6 ) ) ) ) ) ) ).

% binomial_def
thf(fact_2840_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_2841_atLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( set_or7035219750837199246ssThan @ A )
        = ( ^ [A5: A,B4: A] : ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A5 @ B4 ) @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% atLeastLessThan_eq_atLeastAtMost_diff
thf(fact_2842_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M2 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) )
            = ( times_times @ A @ ( G @ M2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M2 ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_2843_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: nat,B3: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A4 @ B3 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A4 @ ( suc @ B3 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A4 @ B3 ) ) @ ( G @ B3 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_2844_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
            = ( times_times @ A @ ( G @ N ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_2845_atLeastLessThanSuc,axiom,
    ! [M2: nat,N: nat] :
      ( ( ( ord_less_eq @ nat @ M2 @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N ) )
          = ( insert @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M2 @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_2846_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M2: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I2 ) ) @ ( F2 @ I2 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M2 ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_2847_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N ) @ ( suc @ I2 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M2 ) ) ) ) ).

% sum.atLeastLessThan_rev
thf(fact_2848_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A4 @ I2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( A4 @ I2 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sum.nested_swap
thf(fact_2849_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N ) @ ( suc @ I2 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M2 ) ) ) ) ).

% prod.atLeastLessThan_rev
thf(fact_2850_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A4 @ I2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( A4 @ I2 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% prod.nested_swap
thf(fact_2851_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N5: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ ( minus_minus @ nat @ N5 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N5 ) ) ) ) ) ) ).

% fact_prod_rev
thf(fact_2852_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [M5: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M5 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M5 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% sum.nat_group
thf(fact_2853_int__transfer,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( product_prod @ nat @ nat ) @ int
    @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 )
    @ pcr_int
    @ ^ [N5: nat] : ( product_Pair @ nat @ nat @ N5 @ ( zero_zero @ nat ) )
    @ ( semiring_1_of_nat @ int ) ) ).

% int_transfer
thf(fact_2854_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [M5: nat] : ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M5 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M5 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% prod.nat_group
thf(fact_2855_UN__UN__finite__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ nat @ ( set @ A )
          @ ^ [N5: nat] : ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N5 ) ) )
          @ ( top_top @ ( set @ nat ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UN_UN_finite_eq
thf(fact_2856_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ nat @ ( set @ A )
          @ ^ [I2: nat] : ( M @ ( plus_plus @ nat @ I2 @ K ) )
          @ ( set_ord_lessThan @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ M @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift_strict
thf(fact_2857_card__sum__le__nat__sum,axiom,
    ! [S2: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S2 ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ S2 ) ) ).

% card_sum_le_nat_sum
thf(fact_2858_uminus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X2: nat,Y2: nat] : ( product_Pair @ nat @ nat @ Y2 @ X2 ) )
    @ ( uminus_uminus @ int ) ) ).

% uminus_int.transfer
thf(fact_2859_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U2: A] :
          ( ( ord_less_eq @ A @ L @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U2 ) @ ( insert @ A @ U2 @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U2 ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_2860_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M2: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.head_if
thf(fact_2861_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_2862_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M2 ) ) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_2863_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M2 ) ) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_2864_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N5: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ I2 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N5 ) ) ) ) ) ).

% pochhammer_prod
thf(fact_2865_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M2: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_2866_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M2: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_2867_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y: nat,X3: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y )
       => ( ( image2 @ nat @ nat
            @ ^ [I2: nat] : ( minus_minus @ nat @ I2 @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X3 @ Y ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X3 @ C2 ) @ ( minus_minus @ nat @ Y @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y )
       => ( ( ( ord_less @ nat @ X3 @ Y )
           => ( ( image2 @ nat @ nat
                @ ^ [I2: nat] : ( minus_minus @ nat @ I2 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X3 @ Y ) )
              = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X3 @ Y )
           => ( ( image2 @ nat @ nat
                @ ^ [I2: nat] : ( minus_minus @ nat @ I2 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X3 @ Y ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_2868_UN__finite__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),C3: set @ A] :
      ( ! [N2: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) @ C3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ C3 ) ) ).

% UN_finite_subset
thf(fact_2869_UN__finite2__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B2: nat > ( set @ A ),K: nat] :
      ( ! [N2: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N2 @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ B2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_2870_less__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U: nat,V2: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ U @ Y2 ) ) ) )
    @ ( ord_less @ int ) ) ).

% less_int.transfer
thf(fact_2871_less__eq__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U: nat,V2: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ U @ Y2 ) ) ) )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_int.transfer
thf(fact_2872_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N @ K ) @ N ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_2873_plus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U ) @ ( plus_plus @ nat @ Y2 @ V2 ) ) ) )
    @ ( plus_plus @ int ) ) ).

% plus_int.transfer
thf(fact_2874_minus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ Y2 @ U ) ) ) )
    @ ( minus_minus @ int ) ) ).

% minus_int.transfer
thf(fact_2875_UN__finite2__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B2: nat > ( set @ A ),K: nat] :
      ( ! [N2: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N2 @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ B2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_2876_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_2877_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X3: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X3 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y2: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U ) @ ( times_times @ nat @ Y2 @ V2 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V2 ) @ ( times_times @ nat @ Y2 @ U ) ) ) )
          @ Xa
          @ X3 ) ) ) ).

% times_int.abs_eq
thf(fact_2878_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X3: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X3 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y2: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ Y2 @ U ) ) )
          @ Xa
          @ X3 ) ) ) ).

% minus_int.abs_eq
thf(fact_2879_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X3: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X3 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y2: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U ) @ ( plus_plus @ nat @ Y2 @ V2 ) ) )
          @ Xa
          @ X3 ) ) ) ).

% plus_int.abs_eq
thf(fact_2880_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_2881_pred__nat__def,axiom,
    ( pred_nat
    = ( collect @ ( product_prod @ nat @ nat )
      @ ( product_case_prod @ nat @ nat @ $o
        @ ^ [M5: nat,N5: nat] :
            ( N5
            = ( suc @ M5 ) ) ) ) ) ).

% pred_nat_def
thf(fact_2882_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: A,N: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X3 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X3 ) @ N )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ X3 @ N ) ) ) ) ) ).

% power_minus'
thf(fact_2883_semilattice__neutr__order_Oeq__neutr__iff,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z2 @ Less_eq @ Less )
     => ( ( ( F2 @ A4 @ B3 )
          = Z2 )
        = ( ( A4 = Z2 )
          & ( B3 = Z2 ) ) ) ) ).

% semilattice_neutr_order.eq_neutr_iff
thf(fact_2884_semilattice__neutr__order_Oneutr__eq__iff,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z2 @ Less_eq @ Less )
     => ( ( Z2
          = ( F2 @ A4 @ B3 ) )
        = ( ( A4 = Z2 )
          & ( B3 = Z2 ) ) ) ) ).

% semilattice_neutr_order.neutr_eq_iff
thf(fact_2885_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U2: int] :
      ( ( image2 @ int @ int
        @ ^ [X2: int] : ( plus_plus @ int @ X2 @ L )
        @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ ( minus_minus @ int @ U2 @ L ) ) )
      = ( set_or7035219750837199246ssThan @ int @ L @ U2 ) ) ).

% image_add_int_atLeastLessThan
thf(fact_2886_uminus__int_Oabs__eq,axiom,
    ! [X3: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X3 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X2: nat,Y2: nat] : ( product_Pair @ nat @ nat @ Y2 @ X2 )
          @ X3 ) ) ) ).

% uminus_int.abs_eq
thf(fact_2887_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X3: B,Y: B,C2: A,A4: A,B3: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X3 @ Y ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A4 @ B3 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_2888_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X3: B,Y: B,A4: A,B3: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X3 @ Y ) @ A4 )
         => ( ( times_times @ A @ A4 @ ( plus_plus @ A @ B3 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A4 @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_2889_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X3: B,Y: B,A4: A,B3: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X3 @ Y ) @ A4 )
         => ( ( times_times @ A @ A4 @ ( minus_minus @ A @ B3 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A4 @ B3 ) @ ( times_times @ A @ A4 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_2890_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X3: B,Y: B,C2: A,A4: A,B3: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X3 @ Y ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A4 @ B3 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_2891_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X3: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X3 ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y2: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U: nat,V2: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ U @ Y2 ) ) )
        @ Xa
        @ X3 ) ) ).

% less_int.abs_eq
thf(fact_2892_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X3: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X3 ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y2: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U: nat,V2: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ U @ Y2 ) ) )
        @ Xa
        @ X3 ) ) ).

% less_eq_int.abs_eq
thf(fact_2893_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_2894_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X3: B,B3: A,A4: A] :
          ( ( nO_MATCH @ B @ A @ X3 @ B3 )
         => ( ( B3
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A4 @ B3 ) @ B3 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A4 @ B3 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_2895_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X3: B,B3: A,A4: A] :
          ( ( nO_MATCH @ B @ A @ X3 @ B3 )
         => ( ( B3
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B3 @ A4 ) @ B3 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A4 @ B3 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_2896_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X2: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y2: nat,Z3: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U: nat,V2: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y2 @ V2 ) @ ( plus_plus @ nat @ U @ Z3 ) ) )
          @ ( rep_Integ @ X2 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_2897_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X2: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y2: nat,Z3: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U: nat,V2: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y2 @ V2 ) @ ( plus_plus @ nat @ U @ Z3 ) ) )
          @ ( rep_Integ @ X2 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_2898_times__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U ) @ ( times_times @ nat @ Y2 @ V2 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V2 ) @ ( times_times @ nat @ Y2 @ U ) ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U ) @ ( times_times @ nat @ Y2 @ V2 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V2 ) @ ( times_times @ nat @ Y2 @ U ) ) ) ) ) ) ).

% times_int.rsp
thf(fact_2899_uminus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X2: nat,Y2: nat] : ( product_Pair @ nat @ nat @ Y2 @ X2 ) )
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X2: nat,Y2: nat] : ( product_Pair @ nat @ nat @ Y2 @ X2 ) ) ) ).

% uminus_int.rsp
thf(fact_2900_nat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ nat @ nat @ intrel
    @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ).

% nat.rsp
thf(fact_2901_of__int_Orsp,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ A @ A @ intrel
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I2: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J3 ) ) )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I2: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J3 ) ) ) ) ) ).

% of_int.rsp
thf(fact_2902_intrel__def,axiom,
    ( intrel
    = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U: nat,V2: nat] :
              ( ( plus_plus @ nat @ X2 @ V2 )
              = ( plus_plus @ nat @ U @ Y2 ) ) ) ) ) ).

% intrel_def
thf(fact_2903_less__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U: nat,V2: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ U @ Y2 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U: nat,V2: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ U @ Y2 ) ) ) ) ) ).

% less_int.rsp
thf(fact_2904_less__eq__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U: nat,V2: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ U @ Y2 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U: nat,V2: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ U @ Y2 ) ) ) ) ) ).

% less_eq_int.rsp
thf(fact_2905_minus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ Y2 @ U ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ Y2 @ U ) ) ) ) ) ).

% minus_int.rsp
thf(fact_2906_plus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U ) @ ( plus_plus @ nat @ Y2 @ V2 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U ) @ ( plus_plus @ nat @ Y2 @ V2 ) ) ) ) ) ).

% plus_int.rsp
thf(fact_2907_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X2: nat,Y2: nat] : ( product_Pair @ nat @ nat @ Y2 @ X2 ) ) ) ) ).

% uminus_int_def
thf(fact_2908_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F )
          = ( ! [Z7: B] :
                ( ( ord_less @ B @ C2 @ Z7 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ Z7 @ ( F2 @ X2 ) )
                  @ F ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_2909_sum__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,P: B > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ B @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [X2: B] : ( zero_neq_one_of_bool @ A @ ( P @ X2 ) )
                @ A3 )
              = ( semiring_1_of_nat @ A @ ( finite_card @ B @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum_of_bool_eq
thf(fact_2910_finite__enumerate__initial__segment,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat,S3: A] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( ord_less @ nat @ N @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ S2 @ ( set_ord_lessThan @ A @ S3 ) ) ) )
           => ( ( infini527867602293511546merate @ A @ ( inf_inf @ ( set @ A ) @ S2 @ ( set_ord_lessThan @ A @ S3 ) ) @ N )
              = ( infini527867602293511546merate @ A @ S2 @ N ) ) ) ) ) ).

% finite_enumerate_initial_segment
thf(fact_2911_nat__def,axiom,
    ( nat2
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ nat @ nat @ rep_Integ @ ( id @ nat ) @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ) ).

% nat_def
thf(fact_2912_eventually__sequentially__Suc,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat
        @ ^ [I2: nat] : ( P @ ( suc @ I2 ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_Suc
thf(fact_2913_eventually__sequentially__seg,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat
        @ ^ [N5: nat] : ( P @ ( plus_plus @ nat @ N5 @ K ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_seg
thf(fact_2914_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_2915_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) ).

% of_bool_eq(1)
thf(fact_2916_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( zero_zero @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_eq_0_iff
thf(fact_2917_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_2918_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( one_one @ A ) )
          = P ) ) ).

% of_bool_eq_1_iff
thf(fact_2919_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_2920_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: $o] :
          ( ( abs_abs @ A @ ( zero_neq_one_of_bool @ A @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% abs_bool_eq
thf(fact_2921_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) )
          = P ) ) ).

% zero_less_of_bool_iff
thf(fact_2922_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_2923_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ) ).

% of_bool_not_iff
thf(fact_2924_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,F2: B > A,P: B > $o] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ ( zero_neq_one_of_bool @ A @ ( P @ X2 ) ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_2925_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,P: B > $o,F2: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P @ X2 ) ) @ ( F2 @ X2 ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_2926_map__fun_Oidentity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_fun @ A @ A @ B @ B
        @ ^ [X2: A] : X2
        @ ^ [X2: B] : X2 )
      = ( id @ ( A > B ) ) ) ).

% map_fun.identity
thf(fact_2927_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P5: $o,Q4: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P5 )
            = ( zero_neq_one_of_bool @ A @ Q4 ) )
          = ( P5 = Q4 ) ) ) ).

% of_bool_eq_iff
thf(fact_2928_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              & Q ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_conj
thf(fact_2929_filtermap__sequentually__ne__bot,axiom,
    ! [A: $tType,F2: nat > A] :
      ( ( filtermap @ nat @ A @ F2 @ ( at_top @ nat ) )
     != ( bot_bot @ ( filter @ A ) ) ) ).

% filtermap_sequentually_ne_bot
thf(fact_2930_filterlim__sequentially__Suc,axiom,
    ! [A: $tType,F2: nat > A,F: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X2: nat] : ( F2 @ ( suc @ X2 ) )
        @ F
        @ ( at_top @ nat ) )
      = ( filterlim @ nat @ A @ F2 @ F @ ( at_top @ nat ) ) ) ).

% filterlim_sequentially_Suc
thf(fact_2931_le__sequentially,axiom,
    ! [F: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F @ ( at_top @ nat ) )
      = ( ! [N7: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N7 ) @ F ) ) ) ).

% le_sequentially
thf(fact_2932_trivial__limit__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( at_top @ A )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% trivial_limit_at_top_linorder
thf(fact_2933_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% zero_less_eq_of_bool
thf(fact_2934_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_2935_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P6: $o] : ( if @ A @ P6 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_2936_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P5: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P5 ) )
          = ( ( P5
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P5
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_2937_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P5: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P5 ) )
          = ( ~ ( ( P5
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P5
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_2938_eventually__at__top__not__equal,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X2: A] : ( X2 != C2 )
          @ ( at_top @ A ) ) ) ).

% eventually_at_top_not_equal
thf(fact_2939_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( zero_neq_one @ B )
        & ( zero_neq_one @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( bNF_rel_fun @ $o @ $o @ A @ B
              @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
              @ R
              @ ( zero_neq_one_of_bool @ A )
              @ ( zero_neq_one_of_bool @ B ) ) ) ) ) ).

% transfer_rule_of_bool
thf(fact_2940_filterlim__atMost__at__top,axiom,
    filterlim @ nat @ ( set @ nat ) @ ( set_ord_atMost @ nat ) @ ( finite5375528669736107172at_top @ nat @ ( top_top @ ( set @ nat ) ) ) @ ( at_top @ nat ) ).

% filterlim_atMost_at_top
thf(fact_2941_filterlim__lessThan__at__top,axiom,
    filterlim @ nat @ ( set @ nat ) @ ( set_ord_lessThan @ nat ) @ ( finite5375528669736107172at_top @ nat @ ( top_top @ ( set @ nat ) ) ) @ ( at_top @ nat ) ).

% filterlim_lessThan_at_top
thf(fact_2942_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_2943_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] : ( eventually @ A @ ( ord_less @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_gt_at_top
thf(fact_2944_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F )
          = ( ! [Z7: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ B @ Z7 @ ( F2 @ X2 ) )
                @ F ) ) ) ) ).

% filterlim_at_top
thf(fact_2945_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F )
          = ( ! [Z7: B] :
                ( ( ord_less_eq @ B @ C2 @ Z7 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ Z7 @ ( F2 @ X2 ) )
                  @ F ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_2946_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,F: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( at_top @ A ) @ F )
         => ( ( eventually @ B
              @ ^ [X2: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ F )
           => ( filterlim @ B @ A @ G @ ( at_top @ A ) @ F ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_2947_filterlim__at__top__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F )
          = ( ! [Z7: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less @ B @ Z7 @ ( F2 @ X2 ) )
                @ F ) ) ) ) ).

% filterlim_at_top_dense
thf(fact_2948_enumerate__Suc_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
          = ( infini527867602293511546merate @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ ( infini527867602293511546merate @ A @ S2 @ ( zero_zero @ nat ) ) @ ( bot_bot @ ( set @ A ) ) ) ) @ N ) ) ) ).

% enumerate_Suc'
thf(fact_2949_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y2: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U ) @ ( times_times @ nat @ Y2 @ V2 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V2 ) @ ( times_times @ nat @ Y2 @ U ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_2950_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y2: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ Y2 @ U ) ) ) ) ) ) ).

% minus_int_def
thf(fact_2951_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y2: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U: nat,V2: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U ) @ ( plus_plus @ nat @ Y2 @ V2 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_2952_finite__enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( ord_less @ nat @ ( suc @ N ) @ ( finite_card @ A @ S2 ) )
           => ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
              = ( ord_Least @ A
                @ ^ [S: A] :
                    ( ( member @ A @ S @ S2 )
                    & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ S ) ) ) ) ) ) ) ).

% finite_enumerate_Suc''
thf(fact_2953_enumerate__Suc,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
          = ( infini527867602293511546merate @ A
            @ ( minus_minus @ ( set @ A ) @ S2
              @ ( insert @ A
                @ ( ord_Least @ A
                  @ ^ [N5: A] : ( member @ A @ N5 @ S2 ) )
                @ ( bot_bot @ ( set @ A ) ) ) )
            @ N ) ) ) ).

% enumerate_Suc
thf(fact_2954_trivial__limit__sequentially,axiom,
    ( at_top @ nat )
 != ( bot_bot @ ( filter @ nat ) ) ).

% trivial_limit_sequentially
thf(fact_2955_eventually__False__sequentially,axiom,
    ~ ( eventually @ nat
      @ ^ [N5: nat] : $false
      @ ( at_top @ nat ) ) ).

% eventually_False_sequentially
thf(fact_2956_LeastI,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI
thf(fact_2957_LeastI2__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( ! [X: A] :
                ( ( P @ X )
               => ( Q @ X ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_ex
thf(fact_2958_LeastI__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI_ex
thf(fact_2959_LeastI2,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A4: A,Q: A > $o] :
          ( ( P @ A4 )
         => ( ! [X: A] :
                ( ( P @ X )
               => ( Q @ X ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2
thf(fact_2960_LeastI2__wellorder__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( ! [A7: A] :
                ( ( P @ A7 )
               => ( ! [B11: A] :
                      ( ( P @ B11 )
                     => ( ord_less_eq @ A @ A7 @ B11 ) )
                 => ( Q @ A7 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder_ex
thf(fact_2961_LeastI2__wellorder,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A4: A,Q: A > $o] :
          ( ( P @ A4 )
         => ( ! [A7: A] :
                ( ( P @ A7 )
               => ( ! [B11: A] :
                      ( ( P @ B11 )
                     => ( ord_less_eq @ A @ A7 @ B11 ) )
                 => ( Q @ A7 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder
thf(fact_2962_Least__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X3: A] :
          ( ( P @ X3 )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ X3 @ Y3 ) )
           => ( ( ord_Least @ A @ P )
              = X3 ) ) ) ) ).

% Least_equality
thf(fact_2963_LeastI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X3: A,Q: A > $o] :
          ( ( P @ X3 )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ X3 @ Y3 ) )
           => ( ! [X: A] :
                  ( ( P @ X )
                 => ( ! [Y7: A] :
                        ( ( P @ Y7 )
                       => ( ord_less_eq @ A @ X @ Y7 ) )
                   => ( Q @ X ) ) )
             => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ) ).

% LeastI2_order
thf(fact_2964_Least1__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,Z2: A] :
          ( ? [X4: A] :
              ( ( P @ X4 )
              & ! [Y3: A] :
                  ( ( P @ Y3 )
                 => ( ord_less_eq @ A @ X4 @ Y3 ) )
              & ! [Y3: A] :
                  ( ( ( P @ Y3 )
                    & ! [Ya: A] :
                        ( ( P @ Ya )
                       => ( ord_less_eq @ A @ Y3 @ Ya ) ) )
                 => ( Y3 = X4 ) ) )
         => ( ( P @ Z2 )
           => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ Z2 ) ) ) ) ).

% Least1_le
thf(fact_2965_Least1I,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o] :
          ( ? [X4: A] :
              ( ( P @ X4 )
              & ! [Y3: A] :
                  ( ( P @ Y3 )
                 => ( ord_less_eq @ A @ X4 @ Y3 ) )
              & ! [Y3: A] :
                  ( ( ( P @ Y3 )
                    & ! [Ya: A] :
                        ( ( P @ Ya )
                       => ( ord_less_eq @ A @ Y3 @ Ya ) ) )
                 => ( Y3 = X4 ) ) )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% Least1I
thf(fact_2966_Least__le,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ K ) ) ) ).

% Least_le
thf(fact_2967_not__less__Least,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [K: A,P: A > $o] :
          ( ( ord_less @ A @ K @ ( ord_Least @ A @ P ) )
         => ~ ( P @ K ) ) ) ).

% not_less_Least
thf(fact_2968_Inf__nat__def,axiom,
    ( ( complete_Inf_Inf @ nat )
    = ( ^ [X7: set @ nat] :
          ( ord_Least @ nat
          @ ^ [N5: nat] : ( member @ nat @ N5 @ X7 ) ) ) ) ).

% Inf_nat_def
thf(fact_2969_Least__Suc,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ( ( ord_Least @ nat @ P )
          = ( suc
            @ ( ord_Least @ nat
              @ ^ [M5: nat] : ( P @ ( suc @ M5 ) ) ) ) ) ) ) ).

% Least_Suc
thf(fact_2970_enumerate__0,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( zero_zero @ nat ) )
          = ( ord_Least @ A
            @ ^ [N5: A] : ( member @ A @ N5 @ S2 ) ) ) ) ).

% enumerate_0
thf(fact_2971_less__int__def,axiom,
    ( ( ord_less @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y2: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U: nat,V2: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ U @ Y2 ) ) ) ) ) ) ).

% less_int_def
thf(fact_2972_less__eq__int__def,axiom,
    ( ( ord_less_eq @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y2: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U: nat,V2: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V2 ) @ ( plus_plus @ nat @ U @ Y2 ) ) ) ) ) ) ).

% less_eq_int_def
thf(fact_2973_Least__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,S2: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ? [X4: A] :
                ( ( member @ A @ X4 @ S2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ S2 )
                   => ( ord_less_eq @ A @ X4 @ Xa2 ) ) )
           => ( ( ord_Least @ B
                @ ^ [Y2: B] : ( member @ B @ Y2 @ ( image2 @ A @ B @ F2 @ S2 ) ) )
              = ( F2
                @ ( ord_Least @ A
                  @ ^ [X2: A] : ( member @ A @ X2 @ S2 ) ) ) ) ) ) ) ).

% Least_mono
thf(fact_2974_enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ~ ( finite_finite2 @ A @ S2 )
         => ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
            = ( ord_Least @ A
              @ ^ [S: A] :
                  ( ( member @ A @ S @ S2 )
                  & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ S ) ) ) ) ) ) ).

% enumerate_Suc''
thf(fact_2975_Bleast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( bleast @ A )
        = ( ^ [S7: set @ A,P3: A > $o] :
              ( ord_Least @ A
              @ ^ [X2: A] :
                  ( ( member @ A @ X2 @ S7 )
                  & ( P3 @ X2 ) ) ) ) ) ) ).

% Bleast_def
thf(fact_2976_abort__Bleast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( abort_Bleast @ A )
        = ( ^ [S7: set @ A,P3: A > $o] :
              ( ord_Least @ A
              @ ^ [X2: A] :
                  ( ( member @ A @ X2 @ S7 )
                  & ( P3 @ X2 ) ) ) ) ) ) ).

% abort_Bleast_def
thf(fact_2977_ring__1__class_Oof__int__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ A @ A @ rep_Integ @ ( id @ A )
          @ ( product_case_prod @ nat @ nat @ A
            @ ^ [I2: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J3 ) ) ) ) ) ) ).

% ring_1_class.of_int_def
thf(fact_2978_at__top__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( at_top @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image2 @ A @ ( filter @ A )
            @ ^ [K6: A] : ( principal @ A @ ( set_ord_atLeast @ A @ K6 ) )
            @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% at_top_def
thf(fact_2979_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( divide_divide @ A @ B3 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B3 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B3 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_2980_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M2: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N ) ) ) ) ).

% numeral_times_numeral
thf(fact_2981_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V: num,W2: num,Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ Z2 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W2 ) ) @ Z2 ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_2982_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A4: A,M2: num,N: num,B3: A] :
          ( ( times_times @ A @ ( power_power @ A @ A4 @ ( numeral_numeral @ nat @ M2 ) ) @ ( times_times @ A @ ( power_power @ A @ A4 @ ( numeral_numeral @ nat @ N ) ) @ B3 ) )
          = ( times_times @ A @ ( power_power @ A @ A4 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M2 @ N ) ) ) @ B3 ) ) ) ).

% power_add_numeral2
thf(fact_2983_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A4: A,M2: num,N: num] :
          ( ( times_times @ A @ ( power_power @ A @ A4 @ ( numeral_numeral @ nat @ M2 ) ) @ ( power_power @ A @ A4 @ ( numeral_numeral @ nat @ N ) ) )
          = ( power_power @ A @ A4 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M2 @ N ) ) ) ) ) ).

% power_add_numeral
thf(fact_2984_atLeast__empty__triv,axiom,
    ! [A: $tType] :
      ( ( set_ord_atLeast @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) )
      = ( top_top @ ( set @ ( set @ A ) ) ) ) ).

% atLeast_empty_triv
thf(fact_2985_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V: num,B3: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B3 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B3 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_2986_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A4: A,B3: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A4 @ B3 ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A4 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B3 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_2987_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A4: A,B3: A,V: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A4 @ B3 ) @ ( numeral_numeral @ A @ V ) )
          = ( minus_minus @ A @ ( times_times @ A @ A4 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B3 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_2988_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V: num,B3: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( minus_minus @ A @ B3 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B3 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_2989_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_2990_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_2991_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_2992_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( one_one @ A ) )
          = ( Z2
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_2993_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_2994_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W2: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W2 @ Z2 ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W2 ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_mult
thf(fact_2995_Sup__atLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A] :
          ( ( complete_Sup_Sup @ A @ ( set_ord_atLeast @ A @ X3 ) )
          = ( top_top @ A ) ) ) ).

% Sup_atLeast
thf(fact_2996_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,W2: num] :
          ( ( ord_less_eq @ A @ A4 @ ( divide_divide @ A @ B3 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A4 @ ( numeral_numeral @ A @ W2 ) ) @ B3 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_2997_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,W2: num,A4: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B3 @ ( numeral_numeral @ A @ W2 ) ) @ A4 )
          = ( ord_less_eq @ A @ B3 @ ( times_times @ A @ A4 @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_2998_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A,B3: A,W2: num] :
          ( ( A4
            = ( divide_divide @ A @ B3 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ( numeral_numeral @ A @ W2 )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A4 @ ( numeral_numeral @ A @ W2 ) )
                = B3 ) )
            & ( ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) )
             => ( A4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_2999_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B3: A,W2: num,A4: A] :
          ( ( ( divide_divide @ A @ B3 @ ( numeral_numeral @ A @ W2 ) )
            = A4 )
          = ( ( ( ( numeral_numeral @ A @ W2 )
               != ( zero_zero @ A ) )
             => ( B3
                = ( times_times @ A @ A4 @ ( numeral_numeral @ A @ W2 ) ) ) )
            & ( ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) )
             => ( A4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_3000_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,W2: num] :
          ( ( ord_less @ A @ A4 @ ( divide_divide @ A @ B3 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A4 @ ( numeral_numeral @ A @ W2 ) ) @ B3 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_3001_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,W2: num,A4: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B3 @ ( numeral_numeral @ A @ W2 ) ) @ A4 )
          = ( ord_less @ A @ B3 @ ( times_times @ A @ A4 @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_3002_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [F2: B > int,A3: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7121269368397514597t_prod @ B @ int @ F2 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( ring_1_of_int @ A @ ( F2 @ X2 ) )
            @ A3 ) ) ) ).

% of_int_prod
thf(fact_3003_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: B > int,A3: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7311177749621191930dd_sum @ B @ int @ F2 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : ( ring_1_of_int @ A @ ( F2 @ X2 ) )
            @ A3 ) ) ) ).

% of_int_sum
thf(fact_3004_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,W2: num,A4: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ A4 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A4 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ B3 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_3005_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,W2: num] :
          ( ( ord_less_eq @ A @ A4 @ ( divide_divide @ A @ B3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ord_less_eq @ A @ B3 @ ( times_times @ A @ A4 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_3006_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B3: A,W2: num,A4: A] :
          ( ( ( divide_divide @ A @ B3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
            = A4 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
               != ( zero_zero @ A ) )
             => ( B3
                = ( times_times @ A @ A4 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) )
             => ( A4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_3007_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A,B3: A,W2: num] :
          ( ( A4
            = ( divide_divide @ A @ B3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A4 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
                = B3 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) )
             => ( A4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_3008_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A,W2: num] :
          ( ( ord_less @ A @ A4 @ ( divide_divide @ A @ B3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ord_less @ A @ B3 @ ( times_times @ A @ A4 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_3009_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,W2: num,A4: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ A4 )
          = ( ord_less @ A @ ( times_times @ A @ A4 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ B3 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_3010_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_3011_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_le_iff
thf(fact_3012_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_3013_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_less_iff
thf(fact_3014_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: int,Y: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X3 ) @ Y )
          = ( times_times @ A @ Y @ ( ring_1_of_int @ A @ X3 ) ) ) ) ).

% mult_of_int_commute
thf(fact_3015_not__empty__eq__Ici__eq__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A] :
          ( ( bot_bot @ ( set @ A ) )
         != ( set_ord_atLeast @ A @ L ) ) ) ).

% not_empty_eq_Ici_eq_empty
thf(fact_3016_atLeast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atLeast @ A )
        = ( ^ [L2: A] : ( collect @ A @ ( ord_less_eq @ A @ L2 ) ) ) ) ) ).

% atLeast_def
thf(fact_3017_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% one_le_numeral
thf(fact_3018_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_3019_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X3: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X3 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X3 ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_3020_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_3021_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ N )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_3022_atLeast__eq__UNIV__iff,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X3: A] :
          ( ( ( set_ord_atLeast @ A @ X3 )
            = ( top_top @ ( set @ A ) ) )
          = ( X3
            = ( bot_bot @ A ) ) ) ) ).

% atLeast_eq_UNIV_iff
thf(fact_3023_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_3024_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_3025_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_3026_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M2 ) ) ) ).

% neg_one_le_numeral
thf(fact_3027_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_3028_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num,B3: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W2 )
            = ( divide_divide @ A @ B3 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 )
                = B3 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_3029_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B3: A,C2: A,W2: num] :
          ( ( ( divide_divide @ A @ B3 @ C2 )
            = ( numeral_numeral @ A @ W2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B3
                = ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_3030_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_3031_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_3032_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_3033_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M2 ) ) ) ).

% neg_one_less_numeral
thf(fact_3034_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_3035_ivl__disj__int__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U2 ) @ ( set_ord_atLeast @ A @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(8)
thf(fact_3036_atLeastAtMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or1337092689740270186AtMost @ A )
        = ( ^ [L2: A,U: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_atLeast @ A @ L2 ) @ ( set_ord_atMost @ A @ U ) ) ) ) ) ).

% atLeastAtMost_def
thf(fact_3037_atLeastLessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or7035219750837199246ssThan @ A )
        = ( ^ [L2: A,U: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_atLeast @ A @ L2 ) @ ( set_ord_lessThan @ A @ U ) ) ) ) ) ).

% atLeastLessThan_def
thf(fact_3038_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X3 )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X3 ) ) ) ) ).

% of_int_leD
thf(fact_3039_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X3: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X3 )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X3 ) ) ) ) ).

% of_int_lessD
thf(fact_3040_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,C2: A,W2: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B3 @ C2 ) @ ( numeral_numeral @ A @ W2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B3 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B3 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_3041_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B3: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W2 ) @ ( divide_divide @ A @ B3 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B3 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B3 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W2 ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_3042_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B3: A,C2: A,W2: num] :
          ( ( ( divide_divide @ A @ B3 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B3
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_3043_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num,B3: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
            = ( divide_divide @ A @ B3 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 )
                = B3 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_3044_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: product_prod @ nat @ nat] :
          ( ( ring_1_of_int @ A @ ( abs_Integ @ X3 ) )
          = ( product_case_prod @ nat @ nat @ A
            @ ^ [I2: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J3 ) )
            @ X3 ) ) ) ).

% of_int.abs_eq
thf(fact_3045_atMost__Int__atLeast,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [N: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ N ) @ ( set_ord_atLeast @ A @ N ) )
          = ( insert @ A @ N @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atMost_Int_atLeast
thf(fact_3046_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [X2: int] :
              ( product_case_prod @ nat @ nat @ A
              @ ^ [I2: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J3 ) )
              @ ( rep_Integ @ X2 ) ) ) ) ) ).

% of_int.rep_eq
thf(fact_3047_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,C2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B3 @ C2 ) @ ( numeral_numeral @ A @ W2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B3 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B3 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_3048_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W2 ) @ ( divide_divide @ A @ B3 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B3 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B3 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W2 ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_3049_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,C2: A,W2: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B3 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B3 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B3 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_3050_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B3: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( divide_divide @ A @ B3 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B3 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B3 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_3051_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( semiring_numeral @ B )
        & ( monoid_add @ A )
        & ( semiring_numeral @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ num @ num @ A @ B
                @ ^ [Y5: num,Z5: num] : ( Y5 = Z5 )
                @ R
                @ ( numeral_numeral @ A )
                @ ( numeral_numeral @ B ) ) ) ) ) ) ).

% transfer_rule_numeral
thf(fact_3052_atLeast__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atLeast @ nat @ K ) @ ( insert @ nat @ K @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast_Suc
thf(fact_3053_UN__atLeast__UNIV,axiom,
    ( ( complete_Sup_Sup @ ( set @ nat ) @ ( image2 @ nat @ ( set @ nat ) @ ( set_ord_atLeast @ nat ) @ ( top_top @ ( set @ nat ) ) ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% UN_atLeast_UNIV
thf(fact_3054_at__top__sub,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( ( at_top @ A )
          = ( complete_Inf_Inf @ ( filter @ A )
            @ ( image2 @ A @ ( filter @ A )
              @ ^ [K6: A] : ( principal @ A @ ( set_ord_atLeast @ A @ K6 ) )
              @ ( set_ord_atLeast @ A @ C2 ) ) ) ) ) ).

% at_top_sub
thf(fact_3055_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ring_1 @ B )
        & ( ring_1 @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( ( bNF_rel_fun @ A @ B @ A @ B @ R @ R @ ( uminus_uminus @ A ) @ ( uminus_uminus @ B ) )
               => ( bNF_rel_fun @ int @ int @ A @ B
                  @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
                  @ R
                  @ ( ring_1_of_int @ A )
                  @ ( ring_1_of_int @ B ) ) ) ) ) ) ) ).

% transfer_rule_of_int
thf(fact_3056_of__int_Otransfer,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ A @ A @ pcr_int
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I2: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J3 ) ) )
        @ ( ring_1_of_int @ A ) ) ) ).

% of_int.transfer
thf(fact_3057_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B3: A,C2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B3 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B3 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B3 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_3058_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W2: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ Y ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W2 ) ) @ Y ) ) ) ).

% semiring_norm(172)
thf(fact_3059_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W2: num,Y: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W2 ) ) ) @ Y ) ) ) ).

% semiring_norm(171)
thf(fact_3060_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W2: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W2 ) ) ) @ Y ) ) ) ).

% semiring_norm(170)
thf(fact_3061_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W2: num,X3: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ ( uminus_uminus @ A @ X3 ) )
          = ( times_times @ A @ X3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_3062_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_3063_ceiling__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% ceiling_one
thf(fact_3064_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X3 @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_3065_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X3 ) ) ) ).

% one_less_ceiling
thf(fact_3066_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X3 @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_3067_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X3 @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( one_one @ int ) ) ) ) ).

% ceiling_diff_one
thf(fact_3068_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_3069_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X3 ) ) ) ).

% zero_le_ceiling
thf(fact_3070_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X3 @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_3071_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% numeral_le_ceiling
thf(fact_3072_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X3 @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_3073_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T3: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T3 ) )
          = ( ! [I2: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I2 ) @ ( one_one @ A ) ) @ T3 )
                  & ( ord_less_eq @ A @ T3 @ ( ring_1_of_int @ A @ I2 ) ) )
               => ( P @ I2 ) ) ) ) ) ).

% ceiling_split
thf(fact_3074_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,A4: int] :
          ( ( ( archimedean_ceiling @ A @ X3 )
            = A4 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A4 ) @ ( one_one @ A ) ) @ X3 )
            & ( ord_less_eq @ A @ X3 @ ( ring_1_of_int @ A @ A4 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_3075_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X3: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ ( ring_1_of_int @ A @ Z2 ) )
           => ( ( archimedean_ceiling @ A @ X3 )
              = Z2 ) ) ) ) ).

% ceiling_unique
thf(fact_3076_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X3 ) ) @ ( one_one @ A ) ) @ X3 )
          & ( ord_less_eq @ A @ X3 @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X3 ) ) ) ) ) ).

% ceiling_correct
thf(fact_3077_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A4 @ B3 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A4 ) @ ( archimedean_ceiling @ A @ B3 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_3078_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Z2: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X3 ) @ Z2 )
          = ( ord_less_eq @ A @ X3 @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_3079_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X3: A] :
          ( ( ord_less_eq @ int @ Z2 @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% le_ceiling_iff
thf(fact_3080_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less_eq @ A @ P5 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P5 @ Q4 ) ) ) @ Q4 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_3081_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P5 @ Q4 ) ) ) @ ( one_one @ A ) ) @ Q4 ) @ P5 ) ) ) ).

% ceiling_divide_lower
thf(fact_3082_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X3 @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_3083_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% neg_numeral_less_floor
thf(fact_3084_sub_Orsp,axiom,
    ( bNF_rel_fun @ num @ num @ ( num > int ) @ ( num > int )
    @ ^ [Y5: num,Z5: num] : ( Y5 = Z5 )
    @ ( bNF_rel_fun @ num @ num @ int @ int
      @ ^ [Y5: num,Z5: num] : ( Y5 = Z5 )
      @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 ) )
    @ ^ [M5: num,N5: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M5 ) @ ( numeral_numeral @ int @ N5 ) )
    @ ^ [M5: num,N5: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M5 ) @ ( numeral_numeral @ int @ N5 ) ) ) ).

% sub.rsp
thf(fact_3085_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K6: nat] : ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K6 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_3086_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A4: B,B3: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A4 )
         => ( ( member @ B @ A4 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A4 @ B3 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A4 ) @ ( archimedean_ceiling @ B @ B3 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_3087_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_3088_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) ).

% one_eq_numeral_iff
thf(fact_3089_floor__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% floor_one
thf(fact_3090_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_3091_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ one2 @ N ) ) ) ).

% one_less_numeral_iff
thf(fact_3092_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_3093_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_3094_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) )
          = ( ( M2 != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_3095_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_3096_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M2 != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_3097_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_3098_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% one_plus_numeral
thf(fact_3099_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X3 ) ) ) ).

% zero_less_floor
thf(fact_3100_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X3 @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_3101_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X3 ) ) ) ).

% one_le_floor
thf(fact_3102_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X3 @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_3103_floor__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X3 @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( one_one @ int ) ) ) ) ).

% floor_diff_one
thf(fact_3104_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_3105_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_3106_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_3107_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_3108_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_3109_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_3110_card__doubleton__eq__2__iff,axiom,
    ! [A: $tType,A4: A,B3: A] :
      ( ( ( finite_card @ A @ ( insert @ A @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( A4 != B3 ) ) ) ).

% card_doubleton_eq_2_iff
thf(fact_3111_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_3112_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M2 @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_3113_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_3114_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% numeral_less_floor
thf(fact_3115_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X3 @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_3116_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_3117_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_3118_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A4: A,B3: A] :
          ( ( member @ A @ A4 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B3 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A4 @ B3 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_3119_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_3120_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2
thf(fact_3121_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2_right
thf(fact_3122_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A4: A,B3: A] :
          ( ( plus_plus @ A @ A4 @ ( plus_plus @ A @ A4 @ B3 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) @ B3 ) ) ) ).

% left_add_twice
thf(fact_3123_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A4: A] :
          ( ( power_power @ A @ A4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A4 @ A4 ) ) ) ).

% power2_eq_square
thf(fact_3124_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X3: A] :
          ( ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X3 @ X3 ) @ X3 ) @ X3 ) ) ) ).

% power4_eq_xxxx
thf(fact_3125_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_3126_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A4: A] :
          ( ( ( power_power @ A @ A4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A4
              = ( one_one @ A ) )
            | ( A4
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_3127_card__2__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X2: A,Y2: A] :
            ( ( S2
              = ( insert @ A @ X2 @ ( insert @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) )
            & ( X2 != Y2 ) ) ) ) ).

% card_2_iff
thf(fact_3128_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X3 )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_3129_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ A4 @ ( numeral_numeral @ A @ one2 ) )
          = A4 ) ) ).

% mult_numeral_1_right
thf(fact_3130_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A4 )
          = A4 ) ) ).

% mult_numeral_1
thf(fact_3131_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_3132_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M5: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M5 ) @ M5 ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_3133_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X2: rat] :
          ( the @ int
          @ ^ [Z3: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z3 ) @ X2 )
              & ( ord_less @ rat @ X2 @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z3 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_3134_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A4: B,B3: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A4 )
         => ( ( member @ B @ A4 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A4 ) @ ( archim6421214686448440834_floor @ B @ B3 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A4 @ B3 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_3135_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_code(2)
thf(fact_3136_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X3: A,Y: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X3 @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) @ Y ) ) ) ) ).

% power2_sum
thf(fact_3137_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_3138_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_3139_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X3 ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_3140_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P: A > $o,A4: A] :
          ( ! [A7: A] :
              ( ( ( divide_divide @ A @ A7 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A7 )
             => ( P @ A7 ) )
         => ( ! [A7: A,B6: $o] :
                ( ( P @ A7 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A7 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A7 )
                 => ( P @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A7 ) ) ) ) )
           => ( P @ A4 ) ) ) ) ).

% bits_induct
thf(fact_3141_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A4: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A4 ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ A4 ) @ N ) )
          = ( power_power @ A @ A4 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% minus_power_mult_self
thf(fact_3142_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A4: A,N: nat] :
          ( ( power_power @ A @ A4 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( times_times @ A @ A4 @ ( power_power @ A @ ( power_power @ A @ A4 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_3143_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A4: A,B3: A] :
          ( finite_finite2 @ A
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A4 @ X2 )
                & ( ord_less_eq @ A @ X2 @ B3 ) ) ) ) ) ).

% finite_int_segment
thf(fact_3144_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X3: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X3 @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) @ Y ) ) ) ) ).

% power2_diff
thf(fact_3145_choose__row__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ N ) @ ( set_ord_atMost @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% choose_row_sum
thf(fact_3146_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_3147_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q8: nat] : ( ord_less @ nat @ Q8 @ N ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_3148_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B3: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B3 )
          = ( uminus_uminus @ A @ B3 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_3149_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B3: A] :
          ( ( times_times @ A @ B3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B3 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_3150_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_3151_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M2: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% sum.in_pairs
thf(fact_3152_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M2: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% prod.in_pairs
thf(fact_3153_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A4: A] :
          ( ( member @ A @ A4 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A4 ) @ A4 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_3154_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.in_pairs_0
thf(fact_3155_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.in_pairs_0
thf(fact_3156_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W2: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit0 @ W2 ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) ) ) ) ).

% power_numeral_even
thf(fact_3157_choose__square__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K6: nat] : ( power_power @ nat @ ( binomial @ N @ K6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% choose_square_sum
thf(fact_3158_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A4: A] :
          ( finite_finite2 @ A
          @ ( collect @ A
            @ ^ [K6: A] :
                ( ( member @ A @ K6 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K6 ) @ A4 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_3159_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_3160_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q8: nat] : ( ord_less @ nat @ Q8 @ N ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_3161_gauss__sum__nat,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( suc @ N ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_3162_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_3163_Sum__Ico__nat,axiom,
    ! [M2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M2 @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_3164_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N @ M2 ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M2 @ N ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_3165_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_3166_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: A,D3: A,N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( plus_plus @ A @ A4 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I2 ) @ D3 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D3 ) ) ) ) ) ).

% double_arith_series
thf(fact_3167_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( member @ A @ A4 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A4 ) @ A4 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_3168_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M2 @ K6 ) ) @ K6 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K6 ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_3169_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( member @ A @ X3 @ ( ring_1_Ints @ A ) )
         => ( ( X3
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X3 ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_3170_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( member @ A @ X3 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X3 ) @ ( one_one @ A ) )
           => ( X3
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_3171_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y: A] :
          ( ( member @ A @ X3 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y @ ( ring_1_Ints @ A ) )
           => ( ( X3 = Y )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_3172_arith__series__nat,axiom,
    ! [A4: nat,D3: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I2: nat] : ( plus_plus @ nat @ A4 @ ( times_times @ nat @ I2 @ D3 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A4 ) @ ( times_times @ nat @ N @ D3 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_3173_Sum__Icc__int,axiom,
    ! [M2: int,N: int] :
      ( ( ord_less_eq @ int @ M2 @ N )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X2: int] : X2
          @ ( set_or1337092689740270186AtMost @ int @ M2 @ N ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N @ ( plus_plus @ int @ N @ ( one_one @ int ) ) ) @ ( times_times @ int @ M2 @ ( minus_minus @ int @ M2 @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_3174_Sum__Icc__nat,axiom,
    ! [M2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M2 @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_3175_binomial__r__part__sum,axiom,
    ! [M2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) ) ) ).

% binomial_r_part_sum
thf(fact_3176_choose__linear__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I2: nat] : ( times_times @ nat @ I2 @ ( binomial @ N @ I2 ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( times_times @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_3177_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T3: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T3 ) )
          = ( ! [I2: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I2 ) @ T3 )
                  & ( ord_less @ A @ T3 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I2 ) @ ( one_one @ A ) ) ) )
               => ( P @ I2 ) ) ) ) ) ).

% floor_split
thf(fact_3178_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,A4: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X3 )
            = A4 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A4 ) @ X3 )
            & ( ord_less @ A @ X3 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_3179_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X3: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X3 )
         => ( ( ord_less @ A @ X3 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X3 )
              = Z2 ) ) ) ) ).

% floor_unique
thf(fact_3180_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B3 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A4 ) @ ( archim6421214686448440834_floor @ A @ B3 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A4 @ B3 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_3181_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_double
thf(fact_3182_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X3: A] :
          ( ( ord_less @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% less_floor_iff
thf(fact_3183_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Z2: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ Z2 )
          = ( ord_less @ A @ X3 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_3184_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_3185_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A4: A,D3: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( plus_plus @ A @ A4 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I2 ) @ D3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D3 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_3186_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_3187_dup_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ int @ int
    @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
    @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
    @ ^ [K6: int] : ( plus_plus @ int @ K6 @ K6 )
    @ ^ [K6: int] : ( plus_plus @ int @ K6 @ K6 ) ) ).

% dup.rsp
thf(fact_3188_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N ) ) ) ) ).

% pochhammer_double
thf(fact_3189_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_3190_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R5: A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( times_times @ A @ ( gbinomial @ A @ R5 @ K6 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K6 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R5 @ ( suc @ M2 ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_3191_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P5 @ Q4 ) ) ) @ Q4 ) @ P5 ) ) ) ).

% floor_divide_lower
thf(fact_3192_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M2 ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_3193_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K6: nat] : ( times_times @ A @ ( gbinomial @ A @ A4 @ K6 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K6 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A4 @ ( plus_plus @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_3194_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less @ A @ P5 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P5 @ Q4 ) ) ) @ ( one_one @ A ) ) @ Q4 ) ) ) ) ).

% floor_divide_upper
thf(fact_3195_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L: num,R5: A,Q4: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R5 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q4 @ R5 ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R5 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q4 @ R5 ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_eq
thf(fact_3196_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L2: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q8: A,R3: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L2 ) @ R3 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q8 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R3 @ ( numeral_numeral @ A @ L2 ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q8 ) @ R3 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_3197_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L2: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q8: nat,R3: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L2 ) @ R3 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q8 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R3 @ ( numeral_numeral @ nat @ L2 ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q8 ) @ R3 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_3198_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A4 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_3199_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L2: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q8: int,R3: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L2 ) @ R3 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q8 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R3 @ ( numeral_numeral @ int @ L2 ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q8 ) @ R3 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_3200_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L2: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q8: code_integer,R3: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L2 ) @ R3 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q8 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R3 @ ( numeral_numeral @ code_integer @ L2 ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q8 ) @ R3 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_3201_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A4 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_3202_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y ) @ ( plus_plus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X3 )
              = Y ) ) ) ) ).

% round_unique
thf(fact_3203_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_odd_sum
thf(fact_3204_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_even_sum
thf(fact_3205_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_3206_dvd__0__right,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: A] : ( dvd_dvd @ A @ A4 @ ( zero_zero @ A ) ) ) ).

% dvd_0_right
thf(fact_3207_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A4 )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left_iff
thf(fact_3208_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( plus_plus @ A @ A4 @ B3 ) )
          = ( dvd_dvd @ A @ A4 @ B3 ) ) ) ).

% dvd_add_triv_left_iff
thf(fact_3209_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( plus_plus @ A @ B3 @ A4 ) )
          = ( dvd_dvd @ A @ A4 @ B3 ) ) ) ).

% dvd_add_triv_right_iff
thf(fact_3210_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X3: A,Y: A] :
          ( ( dvd_dvd @ A @ X3 @ ( uminus_uminus @ A @ Y ) )
          = ( dvd_dvd @ A @ X3 @ Y ) ) ) ).

% dvd_minus_iff
thf(fact_3211_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X3: A,Y: A] :
          ( ( dvd_dvd @ A @ ( uminus_uminus @ A @ X3 ) @ Y )
          = ( dvd_dvd @ A @ X3 @ Y ) ) ) ).

% minus_dvd_iff
thf(fact_3212_div__dvd__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( ( dvd_dvd @ A @ A4 @ C2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ B3 @ A4 ) @ ( divide_divide @ A @ C2 @ A4 ) )
              = ( dvd_dvd @ A @ B3 @ C2 ) ) ) ) ) ).

% div_dvd_div
thf(fact_3213_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: A,K: A] :
          ( ( dvd_dvd @ A @ ( abs_abs @ A @ M2 ) @ K )
          = ( dvd_dvd @ A @ M2 @ K ) ) ) ).

% abs_dvd_iff
thf(fact_3214_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: A,K: A] :
          ( ( dvd_dvd @ A @ M2 @ ( abs_abs @ A @ K ) )
          = ( dvd_dvd @ A @ M2 @ K ) ) ) ).

% dvd_abs_iff
thf(fact_3215_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A4 @ B3 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_3216_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A4 @ B3 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_3217_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A4 @ B3 ) @ ( times_times @ A @ A4 @ C2 ) )
            = ( dvd_dvd @ A @ B3 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_3218_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B3 @ A4 ) @ ( times_times @ A @ C2 @ A4 ) )
            = ( dvd_dvd @ A @ B3 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_3219_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A4 ) @ B3 ) )
          = ( dvd_dvd @ A @ A4 @ B3 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_3220_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( plus_plus @ A @ B3 @ ( times_times @ A @ C2 @ A4 ) ) )
          = ( dvd_dvd @ A @ A4 @ B3 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_3221_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A4 @ B3 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_3222_div__add,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( dvd_dvd @ A @ C2 @ A4 )
         => ( ( dvd_dvd @ A @ C2 @ B3 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A4 @ B3 ) @ C2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A4 @ C2 ) @ ( divide_divide @ A @ B3 @ C2 ) ) ) ) ) ) ).

% div_add
thf(fact_3223_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( ( times_times @ A @ A4 @ ( divide_divide @ A @ B3 @ A4 ) )
            = B3 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_3224_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B3 @ A4 ) @ A4 )
            = B3 ) ) ) ).

% dvd_div_mult_self
thf(fact_3225_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A4 ) )
            = A4 ) ) ) ).

% unit_div_1_div_1
thf(fact_3226_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A4 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_3227_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A4 @ B3 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_3228_div__diff,axiom,
    ! [A: $tType] :
      ( ( idom_modulo @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( dvd_dvd @ A @ C2 @ A4 )
         => ( ( dvd_dvd @ A @ C2 @ B3 )
           => ( ( divide_divide @ A @ ( minus_minus @ A @ A4 @ B3 ) @ C2 )
              = ( minus_minus @ A @ ( divide_divide @ A @ A4 @ C2 ) @ ( divide_divide @ A @ B3 @ C2 ) ) ) ) ) ) ).

% div_diff
thf(fact_3229_round__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% round_1
thf(fact_3230_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B3 @ ( divide_divide @ A @ ( one_one @ A ) @ A4 ) )
            = ( divide_divide @ A @ B3 @ A4 ) ) ) ) ).

% unit_mult_div_div
thf(fact_3231_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B3 @ A4 ) @ A4 )
            = B3 ) ) ) ).

% unit_div_mult_self
thf(fact_3232_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A4 @ B3 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) ) ) ) ).

% even_mult_iff
thf(fact_3233_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_3234_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) ) ) ).

% even_plus_one_iff
thf(fact_3235_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A4 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_3236_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_3237_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A4: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_3238_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_3239_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_3240_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A4: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A4 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_3241_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_3242_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A4: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A4 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( divide_divide @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_3243_div__div__div__same,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [D3: A,B3: A,A4: A] :
          ( ( dvd_dvd @ A @ D3 @ B3 )
         => ( ( dvd_dvd @ A @ B3 @ A4 )
           => ( ( divide_divide @ A @ ( divide_divide @ A @ A4 @ D3 ) @ ( divide_divide @ A @ B3 @ D3 ) )
              = ( divide_divide @ A @ A4 @ B3 ) ) ) ) ) ).

% div_div_div_same
thf(fact_3244_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ( divide_divide @ A @ A4 @ C2 )
            = ( divide_divide @ A @ B3 @ C2 ) )
         => ( ( dvd_dvd @ A @ C2 @ A4 )
           => ( ( dvd_dvd @ A @ C2 @ B3 )
             => ( A4 = B3 ) ) ) ) ) ).

% dvd_div_eq_cancel
thf(fact_3245_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( dvd_dvd @ A @ C2 @ A4 )
         => ( ( dvd_dvd @ A @ C2 @ B3 )
           => ( ( ( divide_divide @ A @ A4 @ C2 )
                = ( divide_divide @ A @ B3 @ C2 ) )
              = ( A4 = B3 ) ) ) ) ) ).

% dvd_div_eq_iff
thf(fact_3246_image__add__integer__atLeastLessThan,axiom,
    ! [L: code_integer,U2: code_integer] :
      ( ( image2 @ code_integer @ code_integer
        @ ^ [X2: code_integer] : ( plus_plus @ code_integer @ X2 @ L )
        @ ( set_or7035219750837199246ssThan @ code_integer @ ( zero_zero @ code_integer ) @ ( minus_minus @ code_integer @ U2 @ L ) ) )
      = ( set_or7035219750837199246ssThan @ code_integer @ L @ U2 ) ) ).

% image_add_integer_atLeastLessThan
thf(fact_3247_dvd__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A4 )
         => ( A4
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left
thf(fact_3248_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( ( dvd_dvd @ A @ A4 @ ( plus_plus @ A @ B3 @ C2 ) )
            = ( dvd_dvd @ A @ A4 @ C2 ) ) ) ) ).

% dvd_add_right_iff
thf(fact_3249_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ C2 )
         => ( ( dvd_dvd @ A @ A4 @ ( plus_plus @ A @ B3 @ C2 ) )
            = ( dvd_dvd @ A @ A4 @ B3 ) ) ) ) ).

% dvd_add_left_iff
thf(fact_3250_dvd__add,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( ( dvd_dvd @ A @ A4 @ C2 )
           => ( dvd_dvd @ A @ A4 @ ( plus_plus @ A @ B3 @ C2 ) ) ) ) ) ).

% dvd_add
thf(fact_3251_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A,B3: A] : ( dvd_dvd @ A @ A4 @ ( times_times @ A @ B3 @ A4 ) ) ) ).

% dvd_triv_right
thf(fact_3252_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 )
         => ( dvd_dvd @ A @ B3 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_3253_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( ( dvd_dvd @ A @ C2 @ D3 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ D3 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_3254_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A,B3: A] : ( dvd_dvd @ A @ A4 @ ( times_times @ A @ A4 @ B3 ) ) ) ).

% dvd_triv_left
thf(fact_3255_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 )
         => ( dvd_dvd @ A @ A4 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_3256_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( dvd_dvd @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_3257_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ C2 )
         => ( dvd_dvd @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_3258_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B4: A,A5: A] :
            ? [K6: A] :
              ( A5
              = ( times_times @ A @ B4 @ K6 ) ) ) ) ) ).

% dvd_def
thf(fact_3259_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A4: A,B3: A,K: A] :
          ( ( A4
            = ( times_times @ A @ B3 @ K ) )
         => ( dvd_dvd @ A @ B3 @ A4 ) ) ) ).

% dvdI
thf(fact_3260_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B3: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ A4 )
         => ~ ! [K2: A] :
                ( A4
               != ( times_times @ A @ B3 @ K2 ) ) ) ) ).

% dvdE
thf(fact_3261_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A4 ) ) ).

% one_dvd
thf(fact_3262_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B3 @ A4 ) ) ) ).

% unit_imp_dvd
thf(fact_3263_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A4 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_3264_dvd__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( dvd_dvd @ A @ X3 @ Y )
         => ( ( dvd_dvd @ A @ X3 @ Z2 )
           => ( dvd_dvd @ A @ X3 @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ) ).

% dvd_diff
thf(fact_3265_dvd__refl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A] : ( dvd_dvd @ A @ A4 @ A4 ) ) ).

% dvd_refl
thf(fact_3266_dvd__trans,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( ( dvd_dvd @ A @ B3 @ C2 )
           => ( dvd_dvd @ A @ A4 @ C2 ) ) ) ) ).

% dvd_trans
thf(fact_3267_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [L: A,K: A] :
          ( ( ( abs_abs @ A @ L )
            = ( abs_abs @ A @ K ) )
         => ( dvd_dvd @ A @ L @ K ) ) ) ).

% dvd_if_abs_eq
thf(fact_3268_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ ( set @ A )
            @ ( collect @ A
              @ ^ [C5: A] : ( dvd_dvd @ A @ C5 @ A4 ) )
            @ ( collect @ A
              @ ^ [C5: A] : ( dvd_dvd @ A @ C5 @ B3 ) ) )
          = ( dvd_dvd @ A @ A4 @ B3 ) ) ) ).

% subset_divisors_dvd
thf(fact_3269_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ ( set @ A )
            @ ( collect @ A
              @ ^ [C5: A] : ( dvd_dvd @ A @ C5 @ A4 ) )
            @ ( collect @ A
              @ ^ [C5: A] : ( dvd_dvd @ A @ C5 @ B3 ) ) )
          = ( ( dvd_dvd @ A @ A4 @ B3 )
            & ~ ( dvd_dvd @ A @ B3 @ A4 ) ) ) ) ).

% strict_subset_divisors_dvd
thf(fact_3270_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_3271_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A4 @ B3 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B3 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_3272_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A4 @ ( times_times @ A @ C2 @ B3 ) )
            = ( dvd_dvd @ A @ A4 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_3273_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 )
            = ( dvd_dvd @ A @ A4 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_3274_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) )
            = ( dvd_dvd @ A @ A4 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_3275_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 )
            = ( dvd_dvd @ A @ B3 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_3276_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A4 @ B3 )
              = ( times_times @ A @ A4 @ C2 ) )
            = ( B3 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_3277_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B3 @ A4 )
              = ( times_times @ A @ C2 @ A4 ) )
            = ( B3 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_3278_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B3: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ A4 )
         => ( ( ( divide_divide @ A @ A4 @ B3 )
              = ( zero_zero @ A ) )
            = ( A4
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_3279_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A,D3: A,C2: A] :
          ( ( dvd_dvd @ A @ B3 @ A4 )
         => ( ( dvd_dvd @ A @ D3 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A4 @ B3 ) @ ( divide_divide @ A @ C2 @ D3 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ D3 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_3280_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 )
         => ( dvd_dvd @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_3281_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B3 @ C2 ) @ A4 )
         => ( ( divide_divide @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A4 @ B3 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_3282_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( dvd_dvd @ A @ C2 @ B3 )
         => ( ( dvd_dvd @ A @ B3 @ A4 )
           => ( ( divide_divide @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A4 @ B3 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_3283_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( dvd_dvd @ A @ C2 @ B3 )
         => ( ( times_times @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_3284_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( dvd_dvd @ A @ C2 @ B3 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B3 @ C2 ) @ A4 )
            = ( divide_divide @ A @ ( times_times @ A @ B3 @ A4 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_3285_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A4 @ ( divide_divide @ A @ C2 @ B3 ) )
            = ( dvd_dvd @ A @ A4 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_3286_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A4 @ B3 ) @ C2 )
            = ( dvd_dvd @ A @ A4 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_3287_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B3 @ A4 )
              = ( divide_divide @ A @ C2 @ A4 ) )
            = ( B3 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_3288_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B3: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ A4 )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A4 ) @ B3 )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A4 @ B3 ) ) ) ) ) ).

% dvd_neg_div
thf(fact_3289_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B3: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ A4 )
         => ( ( divide_divide @ A @ A4 @ ( uminus_uminus @ A @ B3 ) )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A4 @ B3 ) ) ) ) ) ).

% dvd_div_neg
thf(fact_3290_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L: A] :
          ( ( ? [X2: A] : ( P @ ( times_times @ A @ L @ X2 ) ) )
          = ( ? [X2: A] :
                ( ( dvd_dvd @ A @ L @ ( plus_plus @ A @ X2 @ ( zero_zero @ A ) ) )
                & ( P @ X2 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_3291_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ~ ( ( A4
               != ( zero_zero @ A ) )
             => ! [C4: A] :
                  ( B3
                 != ( times_times @ A @ A4 @ C4 ) ) ) ) ) ).

% unit_dvdE
thf(fact_3292_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D3: A,D2: A,T3: A] :
          ( ( dvd_dvd @ A @ D3 @ D2 )
         => ! [X4: A,K3: A] :
              ( ( ~ ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ X4 @ T3 ) ) )
              = ( ~ ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) @ T3 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_3293_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D3: A,D2: A,T3: A] :
          ( ( dvd_dvd @ A @ D3 @ D2 )
         => ! [X4: A,K3: A] :
              ( ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ X4 @ T3 ) )
              = ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) @ T3 ) ) ) ) ) ).

% inf_period(3)
thf(fact_3294_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A4 @ B3 )
             => ( ( dvd_dvd @ A @ C2 @ D3 )
               => ( ( ( divide_divide @ A @ B3 @ A4 )
                    = ( divide_divide @ A @ D3 @ C2 ) )
                  = ( ( times_times @ A @ B3 @ C2 )
                    = ( times_times @ A @ A4 @ D3 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_3295_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B3 )
           => ( ( dvd_dvd @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_3296_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B3 @ A4 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A4 @ B3 ) @ C2 )
              = ( dvd_dvd @ A @ A4 @ ( times_times @ A @ C2 @ B3 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_3297_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A4 @ B3 )
           => ( ( ( divide_divide @ A @ B3 @ A4 )
                = C2 )
              = ( B3
                = ( times_times @ A @ C2 @ A4 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_3298_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A4 @ B3 )
              = ( zero_zero @ A ) )
            = ( A4
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_3299_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A4 @ B3 )
              = C2 )
            = ( A4
              = ( times_times @ A @ C2 @ B3 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_3300_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( A4
              = ( divide_divide @ A @ C2 @ B3 ) )
            = ( ( times_times @ A @ A4 @ B3 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_3301_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B3 @ A4 )
           => ( ( divide_divide @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A4 @ B3 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_3302_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A4 @ B3 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 ) ) ) ) ).

% unit_div_commute
thf(fact_3303_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_3304_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A4 @ B3 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_3305_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,N: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A4 @ N ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_3306_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_3307_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
            = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
              @ ( finite_card @ B
                @ ( collect @ B
                  @ ^ [A5: B] :
                      ( ( member @ B @ A5 @ A3 )
                      & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ A5 ) ) ) ) ) ) ) ) ) ).

% even_sum_iff
thf(fact_3308_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ~ ( ( A4
               != ( zero_zero @ A ) )
             => ! [B6: A] :
                  ( ( B6
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B6 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A4 )
                        = B6 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B6 )
                          = A4 )
                       => ( ( ( times_times @ A @ A4 @ B6 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A4 )
                           != ( times_times @ A @ C2 @ B6 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_3309_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A4 @ ( times_times @ A @ A4 @ B3 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B3 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_3310_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A4 @ ( times_times @ A @ B3 @ A4 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B3 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_3311_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
         => ~ ! [B6: A] :
                ( A4
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) ) ) ) ).

% evenE
thf(fact_3312_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_3313_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X3: A,M2: nat,N: nat] :
          ( ( X3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X3 @ M2 ) @ ( power_power @ A @ X3 @ N ) )
            = ( ( dvd_dvd @ A @ X3 @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M2 @ N ) ) ) ) ) ).

% dvd_power_iff
thf(fact_3314_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat,X3: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            | ( X3
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X3 @ ( power_power @ A @ X3 @ N ) ) ) ) ).

% dvd_power
thf(fact_3315_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% choose_dvd
thf(fact_3316_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A4 ) ) ) ).

% even_two_times_div_two
thf(fact_3317_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) )
     => ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% odd_card_imp_not_empty
thf(fact_3318_dvd__partition,axiom,
    ! [A: $tType,C3: set @ ( set @ A ),K: nat] :
      ( ( finite_finite2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C3 ) )
     => ( ! [X: set @ A] :
            ( ( member @ ( set @ A ) @ X @ C3 )
           => ( dvd_dvd @ nat @ K @ ( finite_card @ A @ X ) ) )
       => ( ! [X: set @ A] :
              ( ( member @ ( set @ A ) @ X @ C3 )
             => ! [Xa2: set @ A] :
                  ( ( member @ ( set @ A ) @ Xa2 @ C3 )
                 => ( ( X != Xa2 )
                   => ( ( inf_inf @ ( set @ A ) @ X @ Xa2 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( dvd_dvd @ nat @ K @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C3 ) ) ) ) ) ) ).

% dvd_partition
thf(fact_3319_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: set @ B,F2: B > A,B3: A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ B3 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A5: B] : ( divide_divide @ A @ ( F2 @ A5 ) @ B3 )
                @ ( inf_inf @ ( set @ B ) @ A3
                  @ ( collect @ B
                    @ ^ [A5: B] : ( dvd_dvd @ A @ B3 @ ( F2 @ A5 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F2
                  @ ( inf_inf @ ( set @ B ) @ A3
                    @ ( collect @ B
                      @ ^ [A5: B] :
                          ~ ( dvd_dvd @ A @ B3 @ ( F2 @ A5 ) ) ) ) )
                @ B3 ) ) ) ) ) ).

% sum_div_partition
thf(fact_3320_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
         => ~ ! [B6: A] :
                ( A4
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_3321_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_3322_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M2: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ord_less_eq @ nat @ M2 @ N ) ) ) ).

% even_mask_div_iff'
thf(fact_3323_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M2 @ N ) ) ) ) ).

% even_mask_div_iff
thf(fact_3324_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A4: A,M2: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ord_less @ nat @ N @ M2 )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M2 @ N )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_3325_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X2: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_3326_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X3 ) ) @ ( plus_plus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_3327_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X3 ) ) ) ) ).

% of_int_round_ge
thf(fact_3328_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less @ A @ ( minus_minus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X3 ) ) ) ) ).

% of_int_round_gt
thf(fact_3329_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X3 ) ) @ X3 ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_3330_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,N: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ ( ring_1_of_int @ A @ N ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X3 )
            = N ) ) ) ).

% round_unique'
thf(fact_3331_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A4 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_3332_finite__divisors__nat,axiom,
    ! [M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( finite_finite2 @ nat
        @ ( collect @ nat
          @ ^ [D4: nat] : ( dvd_dvd @ nat @ D4 @ M2 ) ) ) ) ).

% finite_divisors_nat
thf(fact_3333_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X2: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X2 ) ) @ ( archimedean_ceiling @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ X2 ) ) ) ) ) ).

% round_altdef
thf(fact_3334_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M2 ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q8: A,R3: A] : ( product_Pair @ A @ A @ Q8 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R3 ) )
            @ ( unique8689654367752047608divmod @ A @ M2 @ N ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_3335_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A4: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A4 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_3336_mod__self,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A4: A] :
          ( ( modulo_modulo @ A @ A4 @ A4 )
          = ( zero_zero @ A ) ) ) ).

% mod_self
thf(fact_3337_mod__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A4: A] :
          ( ( modulo_modulo @ A @ A4 @ ( zero_zero @ A ) )
          = A4 ) ) ).

% mod_by_0
thf(fact_3338_mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A4: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A4 )
          = ( zero_zero @ A ) ) ) ).

% mod_0
thf(fact_3339_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A4: A,B3: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A4 @ B3 ) @ B3 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_3340_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B3: A,A4: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B3 @ A4 ) @ B3 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_3341_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A4: A] :
          ( ( modulo_modulo @ A @ A4 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_3342_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A4: A] :
          ( ( modulo_modulo @ A @ A4 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_3343_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B3 @ C2 ) @ A4 ) @ B3 )
          = ( modulo_modulo @ A @ A4 @ B3 ) ) ) ).

% mod_mult_self4
thf(fact_3344_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B3 ) @ A4 ) @ B3 )
          = ( modulo_modulo @ A @ A4 @ B3 ) ) ) ).

% mod_mult_self3
thf(fact_3345_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) ) @ B3 )
          = ( modulo_modulo @ A @ A4 @ B3 ) ) ) ).

% mod_mult_self2
thf(fact_3346_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A4 @ ( times_times @ A @ C2 @ B3 ) ) @ B3 )
          = ( modulo_modulo @ A @ A4 @ B3 ) ) ) ).

% mod_mult_self1
thf(fact_3347_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( ( modulo_modulo @ A @ B3 @ A4 )
            = ( zero_zero @ A ) ) ) ) ).

% dvd_imp_mod_0
thf(fact_3348_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A4: A] :
          ( ( modulo_modulo @ A @ A4 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_3349_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_3350_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_3351_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: A] :
          ( ( ( ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_3352_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: A] :
          ( ( ( ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_3353_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_3354_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_3355_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_div_numeral
thf(fact_3356_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_mod_numeral
thf(fact_3357_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_3358_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A4 @ ( modulo_modulo @ A @ B3 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_3359_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A4 @ C2 ) @ B3 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_3360_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A4 @ B3 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) ) ) ) ).

% mult_mod_right
thf(fact_3361_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_3362_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A4: A,C2: A,A8: A,B3: A,B7: A] :
          ( ( ( modulo_modulo @ A @ A4 @ C2 )
            = ( modulo_modulo @ A @ A8 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B3 @ C2 )
              = ( modulo_modulo @ A @ B7 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A8 @ B7 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_3363_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A4 @ C2 ) @ ( modulo_modulo @ A @ B3 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_3364_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( dvd_dvd @ A @ C2 @ B3 )
         => ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A4 @ B3 ) )
            = ( dvd_dvd @ A @ C2 @ A4 ) ) ) ) ).

% dvd_mod_iff
thf(fact_3365_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A4 @ B3 ) )
         => ( ( dvd_dvd @ A @ C2 @ B3 )
           => ( dvd_dvd @ A @ C2 @ A4 ) ) ) ) ).

% dvd_mod_imp_dvd
thf(fact_3366_nat__mod__as__int,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_mod_as_int
thf(fact_3367_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A4: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [I2: B] : ( modulo_modulo @ A @ ( F2 @ I2 ) @ A4 )
              @ A3 )
            @ A4 )
          = ( modulo_modulo @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ A4 ) ) ) ).

% mod_sum_eq
thf(fact_3368_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A4: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7121269368397514597t_prod @ B @ A
              @ ^ [I2: B] : ( modulo_modulo @ A @ ( F2 @ I2 ) @ A4 )
              @ A3 )
            @ A4 )
          = ( modulo_modulo @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ A4 ) ) ) ).

% mod_prod_eq
thf(fact_3369_finite__divisors__int,axiom,
    ! [I3: int] :
      ( ( I3
       != ( zero_zero @ int ) )
     => ( finite_finite2 @ int
        @ ( collect @ int
          @ ^ [D4: int] : ( dvd_dvd @ int @ D4 @ I3 ) ) ) ) ).

% finite_divisors_int
thf(fact_3370_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ( modulo_modulo @ A @ A4 @ C2 )
            = ( modulo_modulo @ A @ B3 @ C2 ) )
         => ~ ! [D5: A] :
                ( B3
               != ( plus_plus @ A @ A4 @ ( times_times @ A @ C2 @ D5 ) ) ) ) ) ).

% mod_eqE
thf(fact_3371_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A4: A,B3: A] :
          ( ( ( modulo_modulo @ A @ A4 @ B3 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ B3 @ A4 ) ) ) ).

% mod_eq_0_iff_dvd
thf(fact_3372_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( modulo_modulo @ A @ B4 @ A5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_eq_mod_eq_0
thf(fact_3373_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A4: A,B3: A] :
          ( ( ( modulo_modulo @ A @ A4 @ B3 )
            = ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ B3 @ A4 ) ) ) ).

% mod_0_imp_dvd
thf(fact_3374_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B3: A,A4: A] : ( dvd_dvd @ A @ B3 @ ( minus_minus @ A @ A4 @ ( modulo_modulo @ A @ A4 @ B3 ) ) ) ) ).

% dvd_minus_mod
thf(fact_3375_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X3 ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_3376_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X3 @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X3 ) ) ) ).

% frac_1_eq
thf(fact_3377_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B3: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A4 @ B3 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_3378_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A4 @ ( divide_divide @ A @ B3 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A4 @ ( modulo_modulo @ A @ B3 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_3379_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B3 @ ( divide_divide @ A @ A4 @ B3 ) ) @ ( modulo_modulo @ A @ A4 @ B3 ) ) @ C2 )
          = ( plus_plus @ A @ A4 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_3380_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A4 @ B3 ) @ B3 ) @ ( modulo_modulo @ A @ A4 @ B3 ) ) @ C2 )
          = ( plus_plus @ A @ A4 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_3381_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A4: A,B3: A] :
          ( A4
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A4 @ B3 ) @ B3 ) @ ( modulo_modulo @ A @ A4 @ B3 ) ) ) ) ).

% mod_div_decomp
thf(fact_3382_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A4: A,B3: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A4 @ B3 ) @ B3 ) @ ( modulo_modulo @ A @ A4 @ B3 ) )
          = A4 ) ) ).

% div_mult_mod_eq
thf(fact_3383_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A4: A,B3: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ B3 ) @ ( times_times @ A @ ( divide_divide @ A @ A4 @ B3 ) @ B3 ) )
          = A4 ) ) ).

% mod_div_mult_eq
thf(fact_3384_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A4: A,B3: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ B3 ) @ ( times_times @ A @ B3 @ ( divide_divide @ A @ A4 @ B3 ) ) )
          = A4 ) ) ).

% mod_mult_div_eq
thf(fact_3385_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B3: A,A4: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B3 @ ( divide_divide @ A @ A4 @ B3 ) ) @ ( modulo_modulo @ A @ A4 @ B3 ) )
          = A4 ) ) ).

% mult_div_mod_eq
thf(fact_3386_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A4: A,B3: A] :
          ( ( minus_minus @ A @ A4 @ ( times_times @ A @ ( divide_divide @ A @ A4 @ B3 ) @ B3 ) )
          = ( modulo_modulo @ A @ A4 @ B3 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_3387_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A4: A,B3: A] :
          ( ( minus_minus @ A @ A4 @ ( modulo_modulo @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A4 @ B3 ) @ B3 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_3388_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A4: A,B3: A] :
          ( ( minus_minus @ A @ A4 @ ( modulo_modulo @ A @ A4 @ B3 ) )
          = ( times_times @ A @ B3 @ ( divide_divide @ A @ A4 @ B3 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_3389_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A4: A,B3: A] :
          ( ( minus_minus @ A @ A4 @ ( times_times @ A @ B3 @ ( divide_divide @ A @ A4 @ B3 ) ) )
          = ( modulo_modulo @ A @ A4 @ B3 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_3390_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A4: A,M2: nat,N: nat] :
          ( ( modulo_modulo @ A @ A4 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A4 @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) @ ( modulo_modulo @ A @ A4 @ ( semiring_1_of_nat @ A @ M2 ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_3391_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A4: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N ) @ A4 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_3392_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B3 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A4 @ B3 ) @ C2 ) ) @ ( modulo_modulo @ A @ A4 @ B3 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_3393_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) )
          = ( ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_3394_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ( archimedean_frac @ A @ X3 )
            = X3 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
            & ( ord_less @ A @ X3 @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_3395_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X3 @ Y ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X3 @ Y ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_3396_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B3 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) ) @ B3 )
           => ( ( modulo_modulo @ A @ A4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) )
              = ( modulo_modulo @ A @ A4 @ B3 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_3397_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
           => ( ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
             => ( ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_3398_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
           => ( ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
           => ( ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_3399_range__mod,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( image2 @ nat @ nat
          @ ^ [M5: nat] : ( modulo_modulo @ nat @ M5 @ N )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% range_mod
thf(fact_3400_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B3 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) ) @ B3 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) ) )
              = ( divide_divide @ A @ A4 @ B3 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_3401_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ( member @ A @ X3 @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X3 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X3 @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X3 ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X3 ) ) ) ) ) ) ).

% frac_neg
thf(fact_3402_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N: nat,A4: A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M2 ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_3403_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M2: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M2 @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) ) ) ).

% exp_mod_exp
thf(fact_3404_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) )
         => ? [B14: A,C8: A] :
              ( ( A4
                = ( times_times @ A @ B14 @ C8 ) )
              & ( dvd_dvd @ A @ B14 @ B3 )
              & ( dvd_dvd @ A @ C8 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_3405_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P5: A,A4: A,B3: A] :
          ( ( dvd_dvd @ A @ P5 @ ( times_times @ A @ A4 @ B3 ) )
         => ~ ! [X: A,Y3: A] :
                ( ( P5
                  = ( times_times @ A @ X @ Y3 ) )
               => ( ( dvd_dvd @ A @ X @ A4 )
                 => ~ ( dvd_dvd @ A @ Y3 @ B3 ) ) ) ) ) ).

% dvd_productE
thf(fact_3406_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: A,X3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
           => ( ( ( modulo_modulo @ A @ X3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) )
                = ( modulo_modulo @ A @ X3 @ M2 ) )
              | ( ( modulo_modulo @ A @ X3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X3 @ M2 ) @ M2 ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_3407_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B3 )
           => ( ( ord_less_eq @ A @ B3 @ ( modulo_modulo @ A @ A4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) ) @ B3 )
                = ( modulo_modulo @ A @ A4 @ B3 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_3408_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,A4: A] :
          ( ( ( archimedean_frac @ A @ X3 )
            = A4 )
          = ( ( member @ A @ ( minus_minus @ A @ X3 @ A4 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
            & ( ord_less @ A @ A4 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_3409_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A4: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N ) @ A4 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_3410_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A4: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N ) @ A4 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_3411_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ Y ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ Y ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_3412_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B3 )
           => ( ( ord_less_eq @ A @ B3 @ ( modulo_modulo @ A @ A4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A4 @ B3 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_3413_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N5: nat,A5: A] :
              ( if @ A
              @ ( N5
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N5 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_3414_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K6: int] :
          ( if @ code_integer @ ( ord_less @ int @ K6 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K6 ) ) )
          @ ( if @ code_integer
            @ ( K6
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K6 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K6 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K6 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_3415_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M2 ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q8: A,R3: A] : ( product_Pair @ A @ A @ Q8 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R3 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M2 @ N ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_3416_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K6: int,L2: int] :
          ( if @ int
          @ ( ( member @ int @ K6 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K6 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K6 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K6 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_3417_and__int_Oelims,axiom,
    ! [X3: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X3 @ Xa )
        = Y )
     => ( ( ( ( member @ int @ X3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X3 )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X3 )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_3418_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X3 ) ) ).

% bit.conj_one_right
thf(fact_3419_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A4: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A4 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A4 ) ) ).

% and.right_neutral
thf(fact_3420_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A4: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A4 )
          = A4 ) ) ).

% and.left_neutral
thf(fact_3421_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_3422_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_3423_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_3424_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_3425_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_3426_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_3427_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_3428_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(3)
thf(fact_3429_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_3430_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(4)
thf(fact_3431_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(6)
thf(fact_3432_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_3433_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_3434_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A4: A,B3: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A4 @ B3 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A4
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B3
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_3435_and_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( comm_monoid @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.comm_monoid_axioms
thf(fact_3436_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_3437_and_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( monoid @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.monoid_axioms
thf(fact_3438_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_3439_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W2: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit1 @ W2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z2 @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) ) ) ) ).

% power_numeral_odd
thf(fact_3440_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A4: A] :
          ( ( power_power @ A @ A4 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A4 @ A4 ) @ A4 ) ) ) ).

% power3_eq_cube
thf(fact_3441_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A4 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_3442_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A4 )
          = ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_3443_card__3__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
      = ( ? [X2: A,Y2: A,Z3: A] :
            ( ( S2
              = ( insert @ A @ X2 @ ( insert @ A @ Y2 @ ( insert @ A @ Z3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            & ( X2 != Y2 )
            & ( Y2 != Z3 )
            & ( X2 != Z3 ) ) ) ) ).

% card_3_iff
thf(fact_3444_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A4: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ A4 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_3445_and__int_Opelims,axiom,
    ! [X3: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X3 @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X3 @ Xa ) )
       => ~ ( ( ( ( ( member @ int @ X3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X3 )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X3 )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X3 @ Xa ) ) ) ) ) ).

% and_int.pelims
thf(fact_3446_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L ) )
     => ( ( ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_3447_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N5: nat,A5: A] :
              ( if @ A
              @ ( N5
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N5 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_3448_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_3449_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K6: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K6 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L2: code_integer,J3: code_integer] :
                ( if @ num
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L2 ) @ ( code_num_of_integer @ L2 ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L2 ) @ ( code_num_of_integer @ L2 ) ) @ one2 ) )
            @ ( code_divmod_integer @ K6 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_3450_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_3451_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_3452_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_3453_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% take_bit_of_1
thf(fact_3454_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A4: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ A4 )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_3455_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_of_1
thf(fact_3456_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N @ M2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_of_exp
thf(fact_3457_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_3458_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A4: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A4 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_3459_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_3460_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( times_times @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N5 ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_3461_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_3462_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_3463_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A4: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A4 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_3464_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_3465_and__int_Opinduct,axiom,
    ! [A0: int,A14: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A14 ) )
     => ( ! [K2: int,L4: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K2 @ L4 ) )
           => ( ( ~ ( ( member @ int @ K2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L4 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K2 @ L4 ) ) )
       => ( P @ A0 @ A14 ) ) ) ).

% and_int.pinduct
thf(fact_3466_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A,N: nat] :
          ( ( ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A4 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A4 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A4 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_3467_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K6: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K6 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L2: code_integer,J3: code_integer] :
                ( if @ nat
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L2 ) @ ( code_nat_of_integer @ L2 ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L2 ) @ ( code_nat_of_integer @ L2 ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K6 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_3468_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K6: code_integer,L2: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K6
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L2 )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K6 ) @ ( code_divmod_abs @ K6 @ L2 )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R3: code_integer,S: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L2 @ S ) ) )
                @ ( code_divmod_abs @ K6 @ L2 ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L2
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K6 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K6 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K6 @ L2 )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R3: code_integer,S: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L2 ) @ S ) ) )
                    @ ( code_divmod_abs @ K6 @ L2 ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_3469_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K6: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K6 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K6 ) ) )
          @ ( if @ int
            @ ( K6
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L2: code_integer,J3: code_integer] :
                  ( if @ int
                  @ ( J3
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L2 ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L2 ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K6 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_3470_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_3471_Divides_Oadjust__div__def,axiom,
    ( adjust_div
    = ( product_case_prod @ int @ int @ int
      @ ^ [Q8: int,R3: int] :
          ( plus_plus @ int @ Q8
          @ ( zero_neq_one_of_bool @ int
            @ ( R3
             != ( zero_zero @ int ) ) ) ) ) ) ).

% Divides.adjust_div_def
thf(fact_3472_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_3473_atLeastLessThan__nat__numeral,axiom,
    ! [M2: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M2 @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M2 @ ( numeral_numeral @ nat @ K ) )
          = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M2 @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M2 @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M2 @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_3474_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_3475_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K6: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K6
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R3: code_integer,S: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K6 ) @ R3 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ S ) )
                @ ( S
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K6 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_3476_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K6: code_integer,L2: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K6
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L2
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K6 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L2
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K6 )
                  = ( sgn_sgn @ code_integer @ L2 ) )
                @ ( code_divmod_abs @ K6 @ L2 )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R3: code_integer,S: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L2 ) @ S ) ) )
                  @ ( code_divmod_abs @ K6 @ L2 ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_3477_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N ) ) ) ) ) ) ).

% mask_numeral
thf(fact_3478_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_3479_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_3480_sgn__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A] :
          ( ( sgn_sgn @ A @ ( sgn_sgn @ A @ A4 ) )
          = ( sgn_sgn @ A @ A4 ) ) ) ).

% sgn_sgn
thf(fact_3481_sgn__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_0
thf(fact_3482_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_3483_sgn__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A] :
          ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ A4 ) )
          = ( uminus_uminus @ A @ ( sgn_sgn @ A @ A4 ) ) ) ) ).

% sgn_minus
thf(fact_3484_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A4 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_3485_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A4 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A4 ) ) ) ).

% sgn_greater
thf(fact_3486_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( divide_divide @ A @ A4 @ ( sgn_sgn @ A @ B3 ) )
          = ( times_times @ A @ A4 @ ( sgn_sgn @ A @ B3 ) ) ) ) ).

% divide_sgn
thf(fact_3487_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( sgn_sgn @ A @ A4 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_3488_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A4 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_3489_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_3490_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A4 ) @ ( sgn_sgn @ A @ A4 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A4
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_3491_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_3492_sgn__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A] :
          ( ( abs_abs @ A @ ( sgn_sgn @ A @ A4 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A4
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_abs
thf(fact_3493_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A] :
          ( ( sgn_sgn @ A @ ( abs_abs @ A @ A4 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A4
             != ( zero_zero @ A ) ) ) ) ) ).

% idom_abs_sgn_class.abs_sgn
thf(fact_3494_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ A4 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A4 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_3495_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_3496_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% xor_numerals(1)
thf(fact_3497_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y ) ) ) ) ).

% xor_numerals(2)
thf(fact_3498_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X3 ) ) ) ) ).

% xor_numerals(5)
thf(fact_3499_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X3 ) ) ) ) ).

% xor_numerals(8)
thf(fact_3500_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_3501_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A,B3: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A4 ) @ ( sgn_sgn @ A @ B3 ) ) ) ) ).

% sgn_mult
thf(fact_3502_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B3: A,A4: A] :
          ( ( ( sgn_sgn @ A @ B3 )
            = ( sgn_sgn @ A @ A4 ) )
         => ( ( sgn_sgn @ A @ ( plus_plus @ A @ A4 @ B3 ) )
            = ( sgn_sgn @ A @ A4 ) ) ) ) ).

% same_sgn_sgn_add
thf(fact_3503_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A] :
          ( ( ( sgn_sgn @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% sgn_eq_0_iff
thf(fact_3504_sgn__0__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( ( sgn_sgn @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% sgn_0_0
thf(fact_3505_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B3: A,A4: A] :
          ( ( ( sgn_sgn @ A @ B3 )
           != ( sgn_sgn @ A @ A4 ) )
         => ( ( ( sgn_sgn @ A @ A4 )
             != ( zero_zero @ A ) )
           => ( ( ( sgn_sgn @ A @ B3 )
               != ( zero_zero @ A ) )
             => ( ( sgn_sgn @ A @ A4 )
                = ( uminus_uminus @ A @ ( sgn_sgn @ A @ B3 ) ) ) ) ) ) ) ).

% sgn_not_eq_imp
thf(fact_3506_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_3507_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B3: A,A4: A] :
          ( ( ( sgn_sgn @ A @ B3 )
            = ( sgn_sgn @ A @ A4 ) )
         => ( ( abs_abs @ A @ ( plus_plus @ A @ A4 @ B3 ) )
            = ( plus_plus @ A @ ( abs_abs @ A @ A4 ) @ ( abs_abs @ A @ B3 ) ) ) ) ) ).

% same_sgn_abs_add
thf(fact_3508_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K6: A] : ( times_times @ A @ K6 @ ( sgn_sgn @ A @ K6 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_3509_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A4 ) @ ( sgn_sgn @ A @ A4 ) )
          = A4 ) ) ).

% abs_mult_sgn
thf(fact_3510_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A4 ) @ ( abs_abs @ A @ A4 ) )
          = A4 ) ) ).

% sgn_mult_abs
thf(fact_3511_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X3 ) @ ( abs_abs @ A @ X3 ) )
          = X3 ) ) ).

% mult_sgn_abs
thf(fact_3512_xor_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( comm_monoid @ A @ ( bit_se5824344971392196577ns_xor @ A ) @ ( zero_zero @ A ) ) ) ).

% xor.comm_monoid_axioms
thf(fact_3513_xor_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( monoid @ A @ ( bit_se5824344971392196577ns_xor @ A ) @ ( zero_zero @ A ) ) ) ).

% xor.monoid_axioms
thf(fact_3514_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( ( sgn_sgn @ A @ A4 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A4 ) ) ) ).

% sgn_1_pos
thf(fact_3515_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( ( A4
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A4 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A4
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A4 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_3516_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( bit_se5824344971392196577ns_xor @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N5 @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_3517_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X2: A] :
              ( if @ A
              @ ( X2
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X2 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_3518_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A4: A] :
          ( ( ( sgn_sgn @ A @ A4 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_3519_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N5: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N5 ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_3520_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A4 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A4 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) ) ) ) ).

% one_xor_eq
thf(fact_3521_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A4 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A4 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) ) ) ) ).

% xor_one_eq
thf(fact_3522_integer__of__num_I3_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit1 @ N ) )
      = ( plus_plus @ code_integer @ ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) @ ( one_one @ code_integer ) ) ) ).

% integer_of_num(3)
thf(fact_3523_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A4: A,F2: nat > A > A,V: num,N: nat] :
      ( ( rec_nat @ A @ A4 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) @ ( rec_nat @ A @ A4 @ F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_3524_case__nat__add__eq__if,axiom,
    ! [A: $tType,A4: A,F2: nat > A,V: num,N: nat] :
      ( ( case_nat @ A @ A4 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ).

% case_nat_add_eq_if
thf(fact_3525_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_3526_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_3527_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_3528_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X3 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_3529_case__nat__numeral,axiom,
    ! [A: $tType,A4: A,F2: nat > A,V: num] :
      ( ( case_nat @ A @ A4 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) ) ) ).

% case_nat_numeral
thf(fact_3530_rec__nat__numeral,axiom,
    ! [A: $tType,A4: A,F2: nat > A > A,V: num] :
      ( ( rec_nat @ A @ A4 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) @ ( rec_nat @ A @ A4 @ F2 @ ( pred_numeral @ V ) ) ) ) ).

% rec_nat_numeral
thf(fact_3531_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(2)
thf(fact_3532_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X3 ) ) ) ) ).

% or_numerals(8)
thf(fact_3533_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% or_numerals(3)
thf(fact_3534_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X3 ) ) ) ) ).

% or_numerals(5)
thf(fact_3535_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(1)
thf(fact_3536_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_3537_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: nat > A,Nat: nat] :
      ( ( H2 @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( case_nat @ B @ ( H2 @ F1 )
        @ ^ [X2: nat] : ( H2 @ ( F22 @ X2 ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_3538_or_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( comm_monoid @ A @ ( bit_se1065995026697491101ons_or @ A ) @ ( zero_zero @ A ) ) ) ).

% or.comm_monoid_axioms
thf(fact_3539_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_3540_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_3541_or_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( monoid @ A @ ( bit_se1065995026697491101ons_or @ A ) @ ( zero_zero @ A ) ) ) ).

% or.monoid_axioms
thf(fact_3542_rec__nat__0__imp,axiom,
    ! [A: $tType,F2: nat > A,F1: A,F22: nat > A > A] :
      ( ( F2
        = ( rec_nat @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( zero_zero @ nat ) )
        = F1 ) ) ).

% rec_nat_0_imp
thf(fact_3543_rec__nat__Suc__imp,axiom,
    ! [A: $tType,F2: nat > A,F1: A,F22: nat > A > A,N: nat] :
      ( ( F2
        = ( rec_nat @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( suc @ N ) )
        = ( F22 @ N @ ( F2 @ N ) ) ) ) ).

% rec_nat_Suc_imp
thf(fact_3544_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( bit_se1065995026697491101ons_or @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N5 @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_3545_less__eq__nat_Osimps_I2_J,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M2 ) @ N ) ) ).

% less_eq_nat.simps(2)
thf(fact_3546_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A4: A,X3: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A4 @ X3 )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A4 @ X3 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A4 @ Y )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A4 @ Y )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X3 = Y ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_3547_diff__Suc,axiom,
    ! [M2: nat,N: nat] :
      ( ( minus_minus @ nat @ M2 @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K6: nat] : K6
        @ ( minus_minus @ nat @ M2 @ N ) ) ) ).

% diff_Suc
thf(fact_3548_integer__of__num_I2_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit0 @ N ) )
      = ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) ) ).

% integer_of_num(2)
thf(fact_3549_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A4 )
          = ( plus_plus @ A @ A4 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) ) ) ) ).

% one_or_eq
thf(fact_3550_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A4 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A4 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) ) ) ) ).

% or_one_eq
thf(fact_3551_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% mask_Suc_double
thf(fact_3552_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F15: T,F26: nat > T > T,X2: nat] : ( the @ T @ ( rec_set_nat @ T @ F15 @ F26 @ X2 ) ) ) ) ).

% old.rec_nat_def
thf(fact_3553_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A,B3: A,N: nat] :
          ( ! [J5: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A4 @ ( suc @ J5 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) ) @ N )
            = ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) @ N ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_3554_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N5 ) @ A5 ) @ N5 ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N5 ) @ A5 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N5 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N5 ) @ A5 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_3555_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M2 @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_3556_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_3557_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_3558_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ one2 @ N ) ) ) ).

% diff_numeral_special(1)
thf(fact_3559_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M2 ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M2 @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_3560_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_3561_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M2 @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_3562_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M2 ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_3563_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M2 ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_3564_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M2 ) ) ) ).

% diff_numeral_special(8)
thf(fact_3565_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_3566_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N ) ) ) ).

% not_bit_1_Suc
thf(fact_3567_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% bit_numeral_simps(1)
thf(fact_3568_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W2: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W2 ) ) @ N )
          = ( case_nat @ $o @ $false @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W2 ) ) @ N ) ) ) ).

% bit_numeral_rec(1)
thf(fact_3569_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W2: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W2 ) ) @ N )
          = ( case_nat @ $o @ $true @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W2 ) ) @ N ) ) ) ).

% bit_numeral_rec(2)
thf(fact_3570_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N5: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N5 @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_3571_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N5: nat,A5: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K6: nat] : ( bit_se4730199178511100633sh_bit @ A @ K6 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ K6 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N5 ) ) ) ) ) ).

% take_bit_sum
thf(fact_3572_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A4: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A4 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A4 @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_3573_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A4: A,N: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A4 @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_3574_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X22: nat] : X22 ) ) ).

% pred_def
thf(fact_3575_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N5 @ A5 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ N5 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N5 ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_3576_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_3577_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X3 ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X3 @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_3578_Gcd__remove0__nat,axiom,
    ! [M: set @ nat] :
      ( ( finite_finite2 @ nat @ M )
     => ( ( gcd_Gcd @ nat @ M )
        = ( gcd_Gcd @ nat @ ( minus_minus @ ( set @ nat ) @ M @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% Gcd_remove0_nat
thf(fact_3579_Gcd__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_empty
thf(fact_3580_Gcd__UNIV,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( top_top @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Gcd_UNIV
thf(fact_3581_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_3582_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_3583_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X3 @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_3584_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) @ X3 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_3585_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X3 @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_3586_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) @ X3 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_3587_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X3 ) ) ) ).

% bit.xor_one_right
thf(fact_3588_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X3 )
          = ( bit_ri4277139882892585799ns_not @ A @ X3 ) ) ) ).

% bit.xor_one_left
thf(fact_3589_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( gcd_Gcd @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_3590_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_3591_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_3592_Gcd__1,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( member @ A @ ( one_one @ A ) @ A3 )
         => ( ( gcd_Gcd @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_1
thf(fact_3593_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_3594_Gcd__eq__1__I,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: A,A3: set @ A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( member @ A @ A4 @ A3 )
           => ( ( gcd_Gcd @ A @ A3 )
              = ( one_one @ A ) ) ) ) ) ).

% Gcd_eq_1_I
thf(fact_3595_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_3596_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A5: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A5 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_3597_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A5: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_3598_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A5: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A5 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_3599_Gcd__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ! [X: B] :
              ( ( member @ B @ X @ A3 )
             => ( dvd_dvd @ A @ ( F2 @ X ) @ ( G @ X ) ) )
         => ( dvd_dvd @ A @ ( gcd_Gcd @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( gcd_Gcd @ A @ ( image2 @ B @ A @ G @ A3 ) ) ) ) ) ).

% Gcd_mono
thf(fact_3600_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N5 @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_3601_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X3 @ Y )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X3 @ Y )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X3 )
              = Y ) ) ) ) ).

% bit.compl_unique
thf(fact_3602_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_3603_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: num] :
          ( ( ( numeral_numeral @ A @ X3 )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X3 @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_3604_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_3605_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_3606_Gcd__eq__Max,axiom,
    ! [M: set @ nat] :
      ( ( finite_finite2 @ nat @ M )
     => ( ( M
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( gcd_Gcd @ nat @ M )
            = ( lattic643756798349783984er_Max @ nat
              @ ( complete_Inf_Inf @ ( set @ nat )
                @ ( image2 @ nat @ ( set @ nat )
                  @ ^ [M5: nat] :
                      ( collect @ nat
                      @ ^ [D4: nat] : ( dvd_dvd @ nat @ D4 @ M5 ) )
                  @ M ) ) ) ) ) ) ) ).

% Gcd_eq_Max
thf(fact_3607_semiring__char__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiri4206861660011772517g_char @ A )
        = ( ^ [Uu2: itself @ A] :
              ( gcd_Gcd @ nat
              @ ( collect @ nat
                @ ^ [N5: nat] :
                    ( ( semiring_1_of_nat @ A @ N5 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% semiring_char_def
thf(fact_3608_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X2: nat] :
          ( collect @ nat
          @ ^ [N5: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N5 ) ) ) ) ) ) ).

% set_decode_def
thf(fact_3609_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_3610_Gcd__abs__eq,axiom,
    ! [K5: set @ int] :
      ( ( gcd_Gcd @ int @ ( image2 @ int @ int @ ( abs_abs @ int ) @ K5 ) )
      = ( gcd_Gcd @ int @ K5 ) ) ).

% Gcd_abs_eq
thf(fact_3611_Gcd__int__eq,axiom,
    ! [N4: set @ nat] :
      ( ( gcd_Gcd @ int @ ( image2 @ nat @ int @ ( semiring_1_of_nat @ int ) @ N4 ) )
      = ( semiring_1_of_nat @ int @ ( gcd_Gcd @ nat @ N4 ) ) ) ).

% Gcd_int_eq
thf(fact_3612_Gcd__nat__abs__eq,axiom,
    ! [K5: set @ int] :
      ( ( gcd_Gcd @ nat
        @ ( image2 @ int @ nat
          @ ^ [K6: int] : ( nat2 @ ( abs_abs @ int @ K6 ) )
          @ K5 ) )
      = ( nat2 @ ( gcd_Gcd @ int @ K5 ) ) ) ).

% Gcd_nat_abs_eq
thf(fact_3613_Max__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A] :
          ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
          = X3 ) ) ).

% Max_singleton
thf(fact_3614_set__decode__zero,axiom,
    ( ( nat_set_decode @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% set_decode_zero
thf(fact_3615_Max__divisors__self__nat,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D4: nat] : ( dvd_dvd @ nat @ D4 @ N ) ) )
        = N ) ) ).

% Max_divisors_self_nat
thf(fact_3616_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X3 )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X2 @ X3 ) ) ) ) ) ) ) ).

% Max.bounded_iff
thf(fact_3617_Max__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X3 )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less @ A @ X2 @ X3 ) ) ) ) ) ) ) ).

% Max_less_iff
thf(fact_3618_Max__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image2 @ B @ A
                  @ ^ [Uu: B] : C2
                  @ A3 ) )
              = C2 ) ) ) ) ).

% Max_const
thf(fact_3619_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M2 ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_3620_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_3621_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M2 ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_3622_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib2,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,Y: A,Z2: A,X3: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Conj @ ( Xor @ Y @ Z2 ) @ X3 )
        = ( Xor @ ( Conj @ Y @ X3 ) @ ( Conj @ Z2 @ X3 ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib2
thf(fact_3623_abstract__boolean__algebra__sym__diff_Oxor__cancel__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X3: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X3 @ ( Compl @ X3 ) )
        = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_right
thf(fact_3624_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X3: A,Y: A,Z2: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Conj @ X3 @ ( Xor @ Y @ Z2 ) )
        = ( Xor @ ( Conj @ X3 @ Y ) @ ( Conj @ X3 @ Z2 ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib
thf(fact_3625_abstract__boolean__algebra__sym__diff_Oxor__compl__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X3: A,Y: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X3 @ ( Compl @ Y ) )
        = ( Compl @ ( Xor @ X3 @ Y ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_right
thf(fact_3626_abstract__boolean__algebra__sym__diff_Oxor__cancel__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X3: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ ( Compl @ X3 ) @ X3 )
        = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_left
thf(fact_3627_abstract__boolean__algebra__sym__diff_Oxor__compl__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X3: A,Y: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ ( Compl @ X3 ) @ Y )
        = ( Compl @ ( Xor @ X3 @ Y ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_left
thf(fact_3628_abstract__boolean__algebra__sym__diff_Oxor__one__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X3: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X3 @ One )
        = ( Compl @ X3 ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_right
thf(fact_3629_abstract__boolean__algebra__sym__diff_Oxor__left__self,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X3: A,Y: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X3 @ ( Xor @ X3 @ Y ) )
        = Y ) ) ).

% abstract_boolean_algebra_sym_diff.xor_left_self
thf(fact_3630_abstract__boolean__algebra__sym__diff_Oxor__one__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X3: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ One @ X3 )
        = ( Compl @ X3 ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_left
thf(fact_3631_abstract__boolean__algebra__sym__diff_Oxor__self,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X3: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X3 @ X3 )
        = Zero ) ) ).

% abstract_boolean_algebra_sym_diff.xor_self
thf(fact_3632_abstract__boolean__algebra__sym__diff_Oxor__def2,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X3: A,Y: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X3 @ Y )
        = ( Conj @ ( Disj @ X3 @ Y ) @ ( Disj @ ( Compl @ X3 ) @ ( Compl @ Y ) ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def2
thf(fact_3633_abstract__boolean__algebra__sym__diff_Oxor__def,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X3: A,Y: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X3 @ Y )
        = ( Disj @ ( Conj @ X3 @ ( Compl @ Y ) ) @ ( Conj @ ( Compl @ X3 ) @ Y ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def
thf(fact_3634_abstract__boolean__algebra__sym__diff_Oaxioms_I1_J,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One ) ) ).

% abstract_boolean_algebra_sym_diff.axioms(1)
thf(fact_3635_Max__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ A3 ) ) ) ) ).

% Max_in
thf(fact_3636_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M2: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798349783984er_Max @ A @ A3 )
                = M2 )
              = ( ( member @ A @ M2 @ A3 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X2 @ M2 ) ) ) ) ) ) ) ).

% Max_eq_iff
thf(fact_3637_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X3 @ ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                    & ( ord_less_eq @ A @ X3 @ X2 ) ) ) ) ) ) ) ).

% Max_ge_iff
thf(fact_3638_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M2: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M2
                = ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ( member @ A @ M2 @ A3 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X2 @ M2 ) ) ) ) ) ) ) ).

% eq_Max_iff
thf(fact_3639_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X3 )
             => ! [A16: A] :
                  ( ( member @ A @ A16 @ A3 )
                 => ( ord_less_eq @ A @ A16 @ X3 ) ) ) ) ) ) ).

% Max.boundedE
thf(fact_3640_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A7: A] :
                  ( ( member @ A @ A7 @ A3 )
                 => ( ord_less_eq @ A @ A7 @ X3 ) )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X3 ) ) ) ) ) ).

% Max.boundedI
thf(fact_3641_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X3 @ ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                    & ( ord_less @ A @ X3 @ X2 ) ) ) ) ) ) ) ).

% Max_gr_iff
thf(fact_3642_Max__Sup,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ A3 )
              = ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% Max_Sup
thf(fact_3643_cSup__eq__Max,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A] :
          ( ( finite_finite2 @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Sup_Sup @ A @ X5 )
              = ( lattic643756798349783984er_Max @ A @ X5 ) ) ) ) ) ).

% cSup_eq_Max
thf(fact_3644_Sup__nat__def,axiom,
    ( ( complete_Sup_Sup @ nat )
    = ( ^ [X7: set @ nat] :
          ( if @ nat
          @ ( X7
            = ( bot_bot @ ( set @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat @ X7 ) ) ) ) ).

% Sup_nat_def
thf(fact_3645_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X3: num] :
          ( ( numeral_numeral @ A @ ( inc @ X3 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X3 ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_3646_Max_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ B2 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ ( lattic643756798349783984er_Max @ A @ B2 ) ) ) ) ) ) ).

% Max.subset_imp
thf(fact_3647_Max__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: set @ A,N4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M @ N4 )
         => ( ( M
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ N4 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ M ) @ ( lattic643756798349783984er_Max @ A @ N4 ) ) ) ) ) ) ).

% Max_mono
thf(fact_3648_mono__Max__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite2 @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798349783984er_Max @ A @ A3 ) )
                = ( lattic643756798349783984er_Max @ B @ ( image2 @ A @ B @ F2 @ A3 ) ) ) ) ) ) ) ).

% mono_Max_commute
thf(fact_3649_Gcd__int__def,axiom,
    ( ( gcd_Gcd @ int )
    = ( ^ [K7: set @ int] : ( semiring_1_of_nat @ int @ ( gcd_Gcd @ nat @ ( image2 @ int @ nat @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) @ K7 ) ) ) ) ) ).

% Gcd_int_def
thf(fact_3650_Max__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F2: B > A,K: A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image2 @ B @ A
                  @ ^ [X2: B] : ( plus_plus @ A @ ( F2 @ X2 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798349783984er_Max @ A @ ( image2 @ B @ A @ F2 @ S2 ) ) @ K ) ) ) ) ) ).

% Max_add_commute
thf(fact_3651_divide__nat__def,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M5: nat,N5: nat] :
          ( if @ nat
          @ ( N5
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat
            @ ( collect @ nat
              @ ^ [K6: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ K6 @ N5 ) @ M5 ) ) ) ) ) ) ).

% divide_nat_def
thf(fact_3652_dual__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Min @ A
          @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 ) )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% dual_Min
thf(fact_3653_INT__greaterThan__UNIV,axiom,
    ( ( complete_Inf_Inf @ ( set @ nat ) @ ( image2 @ nat @ ( set @ nat ) @ ( set_ord_greaterThan @ nat ) @ ( top_top @ ( set @ nat ) ) ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% INT_greaterThan_UNIV
thf(fact_3654_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat,M2: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M2 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_3655_Code__Numeral_Odup__def,axiom,
    ( code_dup
    = ( map_fun @ code_integer @ int @ int @ code_integer @ code_int_of_integer @ code_integer_of_int
      @ ^ [K6: int] : ( plus_plus @ int @ K6 @ K6 ) ) ) ).

% Code_Numeral.dup_def
thf(fact_3656_min_Oidem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A] :
          ( ( ord_min @ A @ A4 @ A4 )
          = A4 ) ) ).

% min.idem
thf(fact_3657_min_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_min @ A @ A4 @ ( ord_min @ A @ A4 @ B3 ) )
          = ( ord_min @ A @ A4 @ B3 ) ) ) ).

% min.left_idem
thf(fact_3658_min_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_min @ A @ ( ord_min @ A @ A4 @ B3 ) @ B3 )
          = ( ord_min @ A @ A4 @ B3 ) ) ) ).

% min.right_idem
thf(fact_3659_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ ( ord_min @ A @ B3 @ C2 ) )
          = ( ( ord_less_eq @ A @ A4 @ B3 )
            & ( ord_less_eq @ A @ A4 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_3660_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( ord_min @ A @ A4 @ B3 )
            = B3 ) ) ) ).

% min.absorb2
thf(fact_3661_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_min @ A @ A4 @ B3 )
            = A4 ) ) ) ).

% min.absorb1
thf(fact_3662_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_min @ A @ X3 @ Y ) )
          = ( ( ord_less @ A @ Z2 @ X3 )
            & ( ord_less @ A @ Z2 @ Y ) ) ) ) ).

% min_less_iff_conj
thf(fact_3663_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ( ord_min @ A @ A4 @ B3 )
            = B3 ) ) ) ).

% min.absorb4
thf(fact_3664_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_min @ A @ A4 @ B3 )
            = A4 ) ) ) ).

% min.absorb3
thf(fact_3665_min__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X3: A] :
          ( ( ord_min @ A @ ( bot_bot @ A ) @ X3 )
          = ( bot_bot @ A ) ) ) ).

% min_bot
thf(fact_3666_min__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X3: A] :
          ( ( ord_min @ A @ X3 @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% min_bot2
thf(fact_3667_min__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X3: A] :
          ( ( ord_min @ A @ X3 @ ( top_top @ A ) )
          = X3 ) ) ).

% min_top2
thf(fact_3668_min__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X3: A] :
          ( ( ord_min @ A @ ( top_top @ A ) @ X3 )
          = X3 ) ) ).

% min_top
thf(fact_3669_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_3670_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_3671_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X3 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_3672_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X3 ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_3673_Int__atMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ A4 ) @ ( set_ord_atMost @ A @ B3 ) )
          = ( set_ord_atMost @ A @ ( ord_min @ A @ A4 @ B3 ) ) ) ) ).

% Int_atMost
thf(fact_3674_Max__divisors__self__int,axiom,
    ! [N: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D4: int] : ( dvd_dvd @ int @ D4 @ N ) ) )
        = ( abs_abs @ int @ N ) ) ) ).

% Max_divisors_self_int
thf(fact_3675_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ X3 @ ( top_top @ A ) )
         => ( ( complete_Sup_Sup @ A @ ( set_ord_greaterThan @ A @ X3 ) )
            = ( top_top @ A ) ) ) ) ).

% Sup_greaterThanAtLeast
thf(fact_3676_Int__atLeastAtMostR1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ B3 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D3 ) )
          = ( set_or1337092689740270186AtMost @ A @ C2 @ ( ord_min @ A @ B3 @ D3 ) ) ) ) ).

% Int_atLeastAtMostR1
thf(fact_3677_Int__atLeastAtMostL1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) @ ( set_ord_atMost @ A @ D3 ) )
          = ( set_or1337092689740270186AtMost @ A @ A4 @ ( ord_min @ A @ B3 @ D3 ) ) ) ) ).

% Int_atLeastAtMostL1
thf(fact_3678_min__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,M2: A,N: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_min @ B @ ( F2 @ M2 ) @ ( F2 @ N ) )
            = ( F2 @ ( ord_min @ A @ M2 @ N ) ) ) ) ) ).

% min_of_mono
thf(fact_3679_min_Oassoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_min @ A @ ( ord_min @ A @ A4 @ B3 ) @ C2 )
          = ( ord_min @ A @ A4 @ ( ord_min @ A @ B3 @ C2 ) ) ) ) ).

% min.assoc
thf(fact_3680_min_Ocommute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_min @ A )
        = ( ^ [A5: A,B4: A] : ( ord_min @ A @ B4 @ A5 ) ) ) ) ).

% min.commute
thf(fact_3681_min_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_min @ A @ B3 @ ( ord_min @ A @ A4 @ C2 ) )
          = ( ord_min @ A @ A4 @ ( ord_min @ A @ B3 @ C2 ) ) ) ) ).

% min.left_commute
thf(fact_3682_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_3683_complete__linorder__inf__min,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ( ( inf_inf @ A )
        = ( ord_min @ A ) ) ) ).

% complete_linorder_inf_min
thf(fact_3684_inf__min,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( linorder @ A ) )
     => ( ( inf_inf @ A )
        = ( ord_min @ A ) ) ) ).

% inf_min
thf(fact_3685_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X3 @ Y ) @ Z2 )
          = ( ord_min @ A @ ( minus_minus @ A @ X3 @ Z2 ) @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ).

% min_diff_distrib_left
thf(fact_3686_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ X3 @ ( ord_min @ A @ Y @ Z2 ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X3 @ Y ) @ ( plus_plus @ A @ X3 @ Z2 ) ) ) ) ).

% min_add_distrib_right
thf(fact_3687_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X3 @ Y ) @ Z2 )
          = ( ord_min @ A @ ( plus_plus @ A @ X3 @ Z2 ) @ ( plus_plus @ A @ Y @ Z2 ) ) ) ) ).

% min_add_distrib_left
thf(fact_3688_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( ( ord_less_eq @ A @ A4 @ C2 )
         => ( ( ord_less_eq @ A @ B3 @ D3 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A4 @ B3 ) @ ( ord_min @ A @ C2 @ D3 ) ) ) ) ) ).

% min.mono
thf(fact_3689_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( A4
            = ( ord_min @ A @ A4 @ B3 ) ) ) ) ).

% min.orderE
thf(fact_3690_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
            = ( ord_min @ A @ A4 @ B3 ) )
         => ( ord_less_eq @ A @ A4 @ B3 ) ) ) ).

% min.orderI
thf(fact_3691_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ ( ord_min @ A @ B3 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A4 @ B3 )
             => ~ ( ord_less_eq @ A @ A4 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_3692_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_less_eq @ A @ A4 @ C2 )
           => ( ord_less_eq @ A @ A4 @ ( ord_min @ A @ B3 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_3693_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( A5
              = ( ord_min @ A @ A5 @ B4 ) ) ) ) ) ).

% min.order_iff
thf(fact_3694_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A4 @ B3 ) @ A4 ) ) ).

% min.cobounded1
thf(fact_3695_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A4 @ B3 ) @ B3 ) ) ).

% min.cobounded2
thf(fact_3696_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_min @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% min.absorb_iff1
thf(fact_3697_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_min @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% min.absorb_iff2
thf(fact_3698_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_3699_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_3700_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X3 @ Y ) @ Z2 )
          = ( ( ord_less_eq @ A @ X3 @ Z2 )
            | ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% min_le_iff_disj
thf(fact_3701_min__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ A5 @ B4 ) ) ) ) ).

% min_def
thf(fact_3702_min__absorb1,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( ord_min @ A @ X3 @ Y )
            = X3 ) ) ) ).

% min_absorb1
thf(fact_3703_min__absorb2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X3: A] :
          ( ( ord_less_eq @ A @ Y @ X3 )
         => ( ( ord_min @ A @ X3 @ Y )
            = Y ) ) ) ).

% min_absorb2
thf(fact_3704_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less @ A @ B3 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_3705_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( ord_less @ A @ A4 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A4 @ B3 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_3706_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( ord_min @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_3707_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ ( ord_min @ A @ B3 @ C2 ) )
         => ~ ( ( ord_less @ A @ A4 @ B3 )
             => ~ ( ord_less @ A @ A4 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_3708_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X3 @ Y ) @ Z2 )
          = ( ( ord_less @ A @ X3 @ Z2 )
            | ( ord_less @ A @ Y @ Z2 ) ) ) ) ).

% min_less_iff_disj
thf(fact_3709_min_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semigroup @ A @ ( ord_min @ A ) ) ) ).

% min.semigroup_axioms
thf(fact_3710_min__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ A5 @ B4 ) ) ) ) ).

% min_def_raw
thf(fact_3711_greaterThan__non__empty,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X3: A] :
          ( ( set_ord_greaterThan @ A @ X3 )
         != ( bot_bot @ ( set @ A ) ) ) ) ).

% greaterThan_non_empty
thf(fact_3712_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_greaterThan @ A )
        = ( ^ [L2: A] : ( collect @ A @ ( ord_less @ A @ L2 ) ) ) ) ) ).

% greaterThan_def
thf(fact_3713_greaterThan__Int__greaterThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A4 ) @ ( set_ord_lessThan @ A @ B3 ) )
          = ( set_ord_lessThan @ A @ ( ord_min @ A @ A4 @ B3 ) ) ) ) ).

% greaterThan_Int_greaterThan
thf(fact_3714_Inf__insert__finite,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert @ A @ X3 @ S2 ) )
                = X3 ) )
            & ( ( S2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert @ A @ X3 @ S2 ) )
                = ( ord_min @ A @ X3 @ ( complete_Inf_Inf @ A @ S2 ) ) ) ) ) ) ) ).

% Inf_insert_finite
thf(fact_3715_min__Suc1,axiom,
    ! [N: nat,M2: nat] :
      ( ( ord_min @ nat @ ( suc @ N ) @ M2 )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M6: nat] : ( suc @ ( ord_min @ nat @ N @ M6 ) )
        @ M2 ) ) ).

% min_Suc1
thf(fact_3716_min__Suc2,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_min @ nat @ M2 @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M6: nat] : ( suc @ ( ord_min @ nat @ M6 @ N ) )
        @ M2 ) ) ).

% min_Suc2
thf(fact_3717_ivl__disj__int__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ U2 ) @ ( set_ord_greaterThan @ A @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(7)
thf(fact_3718_ivl__disj__un__singleton_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A] :
          ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_ord_greaterThan @ A @ L ) )
          = ( set_ord_atLeast @ A @ L ) ) ) ).

% ivl_disj_un_singleton(1)
thf(fact_3719_greaterThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_greaterThan @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_greaterThan @ nat @ K ) @ ( insert @ nat @ ( suc @ K ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% greaterThan_Suc
thf(fact_3720_dual__max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( max @ A
          @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 ) )
        = ( ord_min @ A ) ) ) ).

% dual_max
thf(fact_3721_minus__Max__eq__Min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798349783984er_Max @ A @ S2 ) )
              = ( lattic643756798350308766er_Min @ A @ ( image2 @ A @ A @ ( uminus_uminus @ A ) @ S2 ) ) ) ) ) ) ).

% minus_Max_eq_Min
thf(fact_3722_minus__Min__eq__Max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798350308766er_Min @ A @ S2 ) )
              = ( lattic643756798349783984er_Max @ A @ ( image2 @ A @ A @ ( uminus_uminus @ A ) @ S2 ) ) ) ) ) ) ).

% minus_Min_eq_Max
thf(fact_3723_take__bit__numeral__minus__numeral__int,axiom,
    ! [M2: num,N: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q8: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M2 ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M2 ) ) @ ( numeral_numeral @ int @ Q8 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M2 ) @ N ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_3724_Min__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A] :
          ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
          = X3 ) ) ).

% Min_singleton
thf(fact_3725_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X3 @ ( lattic643756798350308766er_Min @ A @ A3 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ X3 @ X2 ) ) ) ) ) ) ) ).

% Min.bounded_iff
thf(fact_3726_Min__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X3 @ ( lattic643756798350308766er_Min @ A @ A3 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less @ A @ X3 @ X2 ) ) ) ) ) ) ) ).

% Min_gr_iff
thf(fact_3727_Min__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ B,C2: A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image2 @ B @ A
                  @ ^ [Uu: B] : C2
                  @ A3 ) )
              = C2 ) ) ) ) ).

% Min_const
thf(fact_3728_Min__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X3 @ A3 ) )
              = ( ord_min @ A @ X3 @ ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ).

% Min_insert
thf(fact_3729_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: num,N: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M2 ) @ N ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_3730_disjE__realizer2,axiom,
    ! [B: $tType,A: $tType,P: $o,Q: A > $o,X3: option @ A,R: B > $o,F2: B,G: A > B] :
      ( ( case_option @ $o @ A @ P @ Q @ X3 )
     => ( ( P
         => ( R @ F2 ) )
       => ( ! [Q10: A] :
              ( ( Q @ Q10 )
             => ( R @ ( G @ Q10 ) ) )
         => ( R @ ( case_option @ B @ A @ F2 @ G @ X3 ) ) ) ) ) ).

% disjE_realizer2
thf(fact_3731_ord_Omax_Ocong,axiom,
    ! [A: $tType] :
      ( ( max @ A )
      = ( max @ A ) ) ).

% ord.max.cong
thf(fact_3732_ord_Omax__def,axiom,
    ! [A: $tType] :
      ( ( max @ A )
      = ( ^ [Less_eq2: A > A > $o,A5: A,B4: A] : ( if @ A @ ( Less_eq2 @ A5 @ B4 ) @ B4 @ A5 ) ) ) ).

% ord.max_def
thf(fact_3733_Min__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ A3 ) ) ) ) ).

% Min_in
thf(fact_3734_Least__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
         => ( ? [X_12: A] : ( P @ X_12 )
           => ( ( ord_Least @ A @ P )
              = ( lattic643756798350308766er_Min @ A @ ( collect @ A @ P ) ) ) ) ) ) ).

% Least_Min
thf(fact_3735_Min__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M2: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798350308766er_Min @ A @ A3 )
                = M2 )
              = ( ( member @ A @ M2 @ A3 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ M2 @ X2 ) ) ) ) ) ) ) ).

% Min_eq_iff
thf(fact_3736_Min__le__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ X3 )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                    & ( ord_less_eq @ A @ X2 @ X3 ) ) ) ) ) ) ) ).

% Min_le_iff
thf(fact_3737_eq__Min__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M2: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M2
                = ( lattic643756798350308766er_Min @ A @ A3 ) )
              = ( ( member @ A @ M2 @ A3 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                   => ( ord_less_eq @ A @ M2 @ X2 ) ) ) ) ) ) ) ).

% eq_Min_iff
thf(fact_3738_Min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X3 @ ( lattic643756798350308766er_Min @ A @ A3 ) )
             => ! [A16: A] :
                  ( ( member @ A @ A16 @ A3 )
                 => ( ord_less_eq @ A @ X3 @ A16 ) ) ) ) ) ) ).

% Min.boundedE
thf(fact_3739_Min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A7: A] :
                  ( ( member @ A @ A7 @ A3 )
                 => ( ord_less_eq @ A @ X3 @ A7 ) )
             => ( ord_less_eq @ A @ X3 @ ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ).

% Min.boundedI
thf(fact_3740_Min__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ X3 )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                    & ( ord_less @ A @ X2 @ X3 ) ) ) ) ) ) ) ).

% Min_less_iff
thf(fact_3741_Min__Inf,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ A3 )
              = ( complete_Inf_Inf @ A @ A3 ) ) ) ) ) ).

% Min_Inf
thf(fact_3742_cInf__eq__Min,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A] :
          ( ( finite_finite2 @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Inf_Inf @ A @ X5 )
              = ( lattic643756798350308766er_Min @ A @ X5 ) ) ) ) ) ).

% cInf_eq_Min
thf(fact_3743_Min_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ B2 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ B2 ) @ ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ).

% Min.subset_imp
thf(fact_3744_Min__antimono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: set @ A,N4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M @ N4 )
         => ( ( M
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ N4 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ N4 ) @ ( lattic643756798350308766er_Min @ A @ M ) ) ) ) ) ) ).

% Min_antimono
thf(fact_3745_hom__Min__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X: A,Y3: A] :
              ( ( H2 @ ( ord_min @ A @ X @ Y3 ) )
              = ( ord_min @ A @ ( H2 @ X ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite2 @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798350308766er_Min @ A @ N4 ) )
                = ( lattic643756798350308766er_Min @ A @ ( image2 @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% hom_Min_commute
thf(fact_3746_Min_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( B2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A3 )
             => ( ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ B2 ) @ ( lattic643756798350308766er_Min @ A @ A3 ) )
                = ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ).

% Min.subset
thf(fact_3747_Min_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ~ ( member @ A @ X3 @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X3 @ A3 ) )
                = ( ord_min @ A @ X3 @ ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ) ).

% Min.insert_not_elem
thf(fact_3748_Min_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X: A,Y3: A] : ( member @ A @ ( ord_min @ A @ X @ Y3 ) @ ( insert @ A @ X @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ A3 ) ) ) ) ) ).

% Min.closed
thf(fact_3749_mono__Min__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite2 @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798350308766er_Min @ A @ A3 ) )
                = ( lattic643756798350308766er_Min @ B @ ( image2 @ A @ B @ F2 @ A3 ) ) ) ) ) ) ) ).

% mono_Min_commute
thf(fact_3750_Min_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ B2 )
             => ( ( B2
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
                  = ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ ( lattic643756798350308766er_Min @ A @ B2 ) ) ) ) ) ) ) ) ).

% Min.union
thf(fact_3751_Min__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F2: B > A,K: A] :
          ( ( finite_finite2 @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image2 @ B @ A
                  @ ^ [X2: B] : ( plus_plus @ A @ ( F2 @ X2 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798350308766er_Min @ A @ ( image2 @ B @ A @ F2 @ S2 ) ) @ K ) ) ) ) ) ).

% Min_add_commute
thf(fact_3752_Min_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( member @ A @ X3 @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A3 )
                  = X3 ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A3 )
                  = ( ord_min @ A @ X3 @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Min.remove
thf(fact_3753_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X3 @ A3 ) )
                = X3 ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X3 @ A3 ) )
                = ( ord_min @ A @ X3 @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Min.insert_remove
thf(fact_3754_and__minus__numerals_I4_J,axiom,
    ! [M2: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M2 @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(4)
thf(fact_3755_and__minus__numerals_I8_J,axiom,
    ! [N: num,M2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M2 ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M2 @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(8)
thf(fact_3756_dual__Max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Max @ A
          @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 ) )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% dual_Max
thf(fact_3757_int__numeral__and__not__num,axiom,
    ! [M2: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M2 @ N ) ) ) ).

% int_numeral_and_not_num
thf(fact_3758_int__numeral__not__and__num,axiom,
    ! [M2: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ N @ M2 ) ) ) ).

% int_numeral_not_and_num
thf(fact_3759_and__minus__numerals_I7_J,axiom,
    ! [N: num,M2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M2 ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M2 @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(7)
thf(fact_3760_and__minus__numerals_I3_J,axiom,
    ! [M2: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M2 @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(3)
thf(fact_3761_less__option__def,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ ( option @ A ) )
        = ( ^ [X2: option @ A] :
              ( case_option @ $o @ A @ $false
              @ ^ [Y2: A] :
                  ( case_option @ $o @ A @ $true
                  @ ^ [Z3: A] : ( ord_less @ A @ Z3 @ Y2 )
                  @ X2 ) ) ) ) ) ).

% less_option_def
thf(fact_3762_less__eq__option__def,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less_eq @ ( option @ A ) )
        = ( ^ [X2: option @ A,Y2: option @ A] :
              ( case_option @ $o @ A @ $true
              @ ^ [Z3: A] : ( case_option @ $o @ A @ $false @ ( ord_less_eq @ A @ Z3 ) @ Y2 )
              @ X2 ) ) ) ) ).

% less_eq_option_def
thf(fact_3763_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_3764_take__bit__num__simps_I7_J,axiom,
    ! [R5: num,M2: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R5 ) @ ( bit1 @ M2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ ( pred_numeral @ R5 ) @ M2 ) ) ) ) ).

% take_bit_num_simps(7)
thf(fact_3765_abstract__boolean__algebra__sym__diff_Ointro,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( boolea5476839437570043046axioms @ A @ Conj @ Disj @ Compl @ Xor )
       => ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor ) ) ) ).

% abstract_boolean_algebra_sym_diff.intro
thf(fact_3766_abstract__boolean__algebra__sym__diff__def,axiom,
    ! [A: $tType] :
      ( ( boolea3799213064322606851m_diff @ A )
      = ( ^ [Conj2: A > A > A,Disj2: A > A > A,Compl2: A > A,Zero2: A,One2: A,Xor2: A > A > A] :
            ( ( boolea2506097494486148201lgebra @ A @ Conj2 @ Disj2 @ Compl2 @ Zero2 @ One2 )
            & ( boolea5476839437570043046axioms @ A @ Conj2 @ Disj2 @ Compl2 @ Xor2 ) ) ) ) ).

% abstract_boolean_algebra_sym_diff_def
thf(fact_3767_rat__floor__code,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [P6: rat] : ( product_case_prod @ int @ int @ int @ ( divide_divide @ int ) @ ( quotient_of @ P6 ) ) ) ) ).

% rat_floor_code
thf(fact_3768_inf__Some,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ! [X3: A,Y: A] :
          ( ( inf_inf @ ( option @ A ) @ ( some @ A @ X3 ) @ ( some @ A @ Y ) )
          = ( some @ A @ ( inf_inf @ A @ X3 @ Y ) ) ) ) ).

% inf_Some
thf(fact_3769_take__bit__num__simps_I4_J,axiom,
    ! [N: nat,M2: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit1 @ M2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N @ M2 ) ) ) ) ).

% take_bit_num_simps(4)
thf(fact_3770_top__option__def,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ( ( top_top @ ( option @ A ) )
        = ( some @ A @ ( top_top @ A ) ) ) ) ).

% top_option_def
thf(fact_3771_abstract__boolean__algebra__sym__diff__axioms_Ointro,axiom,
    ! [A: $tType,Xor: A > A > A,Disj: A > A > A,Conj: A > A > A,Compl: A > A] :
      ( ! [X: A,Y3: A] :
          ( ( Xor @ X @ Y3 )
          = ( Disj @ ( Conj @ X @ ( Compl @ Y3 ) ) @ ( Conj @ ( Compl @ X ) @ Y3 ) ) )
     => ( boolea5476839437570043046axioms @ A @ Conj @ Disj @ Compl @ Xor ) ) ).

% abstract_boolean_algebra_sym_diff_axioms.intro
thf(fact_3772_abstract__boolean__algebra__sym__diff__axioms__def,axiom,
    ! [A: $tType] :
      ( ( boolea5476839437570043046axioms @ A )
      = ( ^ [Conj2: A > A > A,Disj2: A > A > A,Compl2: A > A,Xor2: A > A > A] :
          ! [X2: A,Y2: A] :
            ( ( Xor2 @ X2 @ Y2 )
            = ( Disj2 @ ( Conj2 @ X2 @ ( Compl2 @ Y2 ) ) @ ( Conj2 @ ( Compl2 @ X2 ) @ Y2 ) ) ) ) ) ).

% abstract_boolean_algebra_sym_diff_axioms_def
thf(fact_3773_sup__option__def,axiom,
    ! [A: $tType] :
      ( ( sup @ A )
     => ( ( sup_sup @ ( option @ A ) )
        = ( ^ [X2: option @ A,Y2: option @ A] :
              ( case_option @ ( option @ A ) @ A @ Y2
              @ ^ [X6: A] :
                  ( case_option @ ( option @ A ) @ A @ X2
                  @ ^ [Z3: A] : ( some @ A @ ( sup_sup @ A @ X6 @ Z3 ) )
                  @ Y2 )
              @ X2 ) ) ) ) ).

% sup_option_def
thf(fact_3774_Some__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( some @ A @ ( complete_Sup_Sup @ A @ A3 ) )
            = ( complete_Sup_Sup @ ( option @ A ) @ ( image2 @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) ) ) ) ) ).

% Some_Sup
thf(fact_3775_Some__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( some @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) )
          = ( complete_Inf_Inf @ ( option @ A )
            @ ( image2 @ B @ ( option @ A )
              @ ^ [X2: B] : ( some @ A @ ( F2 @ X2 ) )
              @ A3 ) ) ) ) ).

% Some_INF
thf(fact_3776_Some__SUP,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ B )
     => ! [A3: set @ A,F2: A > B] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( some @ B @ ( complete_Sup_Sup @ B @ ( image2 @ A @ B @ F2 @ A3 ) ) )
            = ( complete_Sup_Sup @ ( option @ B )
              @ ( image2 @ A @ ( option @ B )
                @ ^ [X2: A] : ( some @ B @ ( F2 @ X2 ) )
                @ A3 ) ) ) ) ) ).

% Some_SUP
thf(fact_3777_abstract__boolean__algebra__sym__diff_Oaxioms_I2_J,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( boolea5476839437570043046axioms @ A @ Conj @ Disj @ Compl @ Xor ) ) ).

% abstract_boolean_algebra_sym_diff.axioms(2)
thf(fact_3778_rat__uminus__code,axiom,
    ! [P5: rat] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ P5 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ A5 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_uminus_code
thf(fact_3779_and__not__num_Osimps_I8_J,axiom,
    ! [M2: num,N: num] :
      ( ( bit_and_not_num @ ( bit1 @ M2 ) @ ( bit0 @ N ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N8: num] : ( some @ num @ ( bit1 @ N8 ) )
        @ ( bit_and_not_num @ M2 @ N ) ) ) ).

% and_not_num.simps(8)
thf(fact_3780_rat__abs__code,axiom,
    ! [P5: rat] :
      ( ( quotient_of @ ( abs_abs @ rat @ P5 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int] : ( product_Pair @ int @ int @ ( abs_abs @ int @ A5 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_abs_code
thf(fact_3781_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P6: rat,Q8: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A5: int,C5: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B4: int,D4: int] : ( ord_less @ int @ ( times_times @ int @ A5 @ D4 ) @ ( times_times @ int @ C5 @ B4 ) )
              @ ( quotient_of @ Q8 ) )
          @ ( quotient_of @ P6 ) ) ) ) ).

% rat_less_code
thf(fact_3782_rat__less__eq__code,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [P6: rat,Q8: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A5: int,C5: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B4: int,D4: int] : ( ord_less_eq @ int @ ( times_times @ int @ A5 @ D4 ) @ ( times_times @ int @ C5 @ B4 ) )
              @ ( quotient_of @ Q8 ) )
          @ ( quotient_of @ P6 ) ) ) ) ).

% rat_less_eq_code
thf(fact_3783_rel__of__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_of @ A @ B )
      = ( ^ [M5: A > ( option @ B ),P3: ( product_prod @ A @ B ) > $o] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [K6: A,V2: B] :
                  ( ( ( M5 @ K6 )
                    = ( some @ B @ V2 ) )
                  & ( P3 @ ( product_Pair @ A @ B @ K6 @ V2 ) ) ) ) ) ) ) ).

% rel_of_def
thf(fact_3784_map__to__set__upd,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),K: A,V: B] :
      ( ( map_to_set @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M2 @ K @ ( some @ B @ V ) ) )
      = ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V )
        @ ( minus_minus @ ( set @ ( product_prod @ A @ B ) ) @ ( map_to_set @ A @ B @ M2 )
          @ ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu: product_prod @ A @ B] :
              ? [V5: B] :
                ( Uu
                = ( product_Pair @ A @ B @ K @ V5 ) ) ) ) ) ) ).

% map_to_set_upd
thf(fact_3785_rat__minus__code,axiom,
    ! [P5: rat,Q4: rat] :
      ( ( quotient_of @ ( minus_minus @ rat @ P5 @ Q4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C5: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D4: int] : ( normalize @ ( product_Pair @ int @ int @ ( minus_minus @ int @ ( times_times @ int @ A5 @ D4 ) @ ( times_times @ int @ B4 @ C5 ) ) @ ( times_times @ int @ C5 @ D4 ) ) )
            @ ( quotient_of @ Q4 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_minus_code
thf(fact_3786_rat__plus__code,axiom,
    ! [P5: rat,Q4: rat] :
      ( ( quotient_of @ ( plus_plus @ rat @ P5 @ Q4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C5: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D4: int] : ( normalize @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ A5 @ D4 ) @ ( times_times @ int @ B4 @ C5 ) ) @ ( times_times @ int @ C5 @ D4 ) ) )
            @ ( quotient_of @ Q4 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_plus_code
thf(fact_3787_map__to__set__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_to_set @ A @ B )
      = ( ^ [M5: A > ( option @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [K6: A,V2: B] :
                  ( ( M5 @ K6 )
                  = ( some @ B @ V2 ) ) ) ) ) ) ).

% map_to_set_def
thf(fact_3788_rat__divide__code,axiom,
    ! [P5: rat,Q4: rat] :
      ( ( quotient_of @ ( divide_divide @ rat @ P5 @ Q4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C5: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D4: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A5 @ D4 ) @ ( times_times @ int @ C5 @ B4 ) ) )
            @ ( quotient_of @ Q4 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_divide_code
thf(fact_3789_rat__times__code,axiom,
    ! [P5: rat,Q4: rat] :
      ( ( quotient_of @ ( times_times @ rat @ P5 @ Q4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C5: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D4: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A5 @ B4 ) @ ( times_times @ int @ C5 @ D4 ) ) )
            @ ( quotient_of @ Q4 ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_times_code
thf(fact_3790_take__bit__num__simps_I6_J,axiom,
    ! [R5: num,M2: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R5 ) @ ( bit0 @ M2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q8: num] : ( some @ num @ ( bit0 @ Q8 ) )
        @ ( bit_take_bit_num @ ( pred_numeral @ R5 ) @ M2 ) ) ) ).

% take_bit_num_simps(6)
thf(fact_3791_take__bit__num__simps_I3_J,axiom,
    ! [N: nat,M2: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit0 @ M2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q8: num] : ( some @ num @ ( bit0 @ Q8 ) )
        @ ( bit_take_bit_num @ N @ M2 ) ) ) ).

% take_bit_num_simps(3)
thf(fact_3792_rat__inverse__code,axiom,
    ! [P5: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P5 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,B4: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A5
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A5 ) @ B4 ) @ ( abs_abs @ int @ A5 ) ) )
        @ ( quotient_of @ P5 ) ) ) ).

% rat_inverse_code
thf(fact_3793_normalize__def,axiom,
    ( normalize
    = ( ^ [P6: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P6 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P6 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_3794_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A] :
          ( ( gcd_gcd @ A @ ( one_one @ A ) @ A4 )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_left_bottom
thf(fact_3795_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A] :
          ( ( gcd_gcd @ A @ A4 @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_right_bottom
thf(fact_3796_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: A,B3: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A4 ) @ ( inverse_inverse @ A @ B3 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_3797_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A] :
          ( ( ( inverse_inverse @ A @ X3 )
            = ( one_one @ A ) )
          = ( X3
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_3798_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_3799_singleton__None__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ ( option @ A ) @ ( insert @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) )
        = ( none @ A ) ) ) ).

% singleton_None_Sup
thf(fact_3800_empty__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ ( option @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) )
        = ( none @ A ) ) ) ).

% empty_Sup
thf(fact_3801_inf__None__1,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ! [Y: option @ A] :
          ( ( inf_inf @ ( option @ A ) @ ( none @ A ) @ Y )
          = ( none @ A ) ) ) ).

% inf_None_1
thf(fact_3802_inf__None__2,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ! [X3: option @ A] :
          ( ( inf_inf @ ( option @ A ) @ X3 @ ( none @ A ) )
          = ( none @ A ) ) ) ).

% inf_None_2
thf(fact_3803_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A4 @ B3 ) @ ( one_one @ A ) )
          = ( ( gcd_gcd @ A @ A4 @ B3 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_gcd_iff
thf(fact_3804_map__to__set__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_to_set @ A @ B
        @ ^ [X2: A] : ( none @ B ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% map_to_set_empty
thf(fact_3805_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A4 ) @ A4 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_3806_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A4 @ ( inverse_inverse @ A @ A4 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_3807_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_3808_Gcd__2,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( gcd_Gcd @ A @ ( insert @ A @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( gcd_gcd @ A @ A4 @ B3 ) ) ) ).

% Gcd_2
thf(fact_3809_rel__of__empty,axiom,
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ) > $o] :
      ( ( rel_of @ A @ B
        @ ^ [X2: A] : ( none @ B )
        @ P )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% rel_of_empty
thf(fact_3810_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_3811_bot__option__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( bot_bot @ ( option @ A ) )
        = ( none @ A ) ) ) ).

% bot_option_def
thf(fact_3812_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y: A,X3: A] :
          ( ( ( times_times @ A @ Y @ X3 )
            = ( times_times @ A @ X3 @ Y ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y ) @ X3 )
            = ( times_times @ A @ X3 @ ( inverse_inverse @ A @ Y ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_3813_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( B3
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A4 @ B3 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B3 ) @ ( inverse_inverse @ A @ A4 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_3814_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A,B3: A] :
          ( ( ( times_times @ A @ A4 @ B3 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A4 )
            = B3 ) ) ) ).

% inverse_unique
thf(fact_3815_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M2: A,K: A,N: A] :
          ( ( gcd_gcd @ A @ M2 @ ( plus_plus @ A @ ( times_times @ A @ K @ M2 ) @ N ) )
          = ( gcd_gcd @ A @ M2 @ N ) ) ) ).

% gcd_add_mult
thf(fact_3816_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ ( inverse_inverse @ A @ B4 ) @ A5 ) ) ) ) ).

% divide_inverse_commute
thf(fact_3817_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ A5 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% divide_inverse
thf(fact_3818_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ A5 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_3819_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_3820_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A4 @ B3 ) @ ( times_times @ A @ K @ B3 ) ) ) ).

% gcd_dvd_prod
thf(fact_3821_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X3 @ M2 ) @ ( inverse_inverse @ A @ X3 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X3 ) @ ( power_power @ A @ X3 @ M2 ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_3822_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M2: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X3 @ M2 ) @ ( power_power @ A @ ( inverse_inverse @ A @ X3 ) @ N ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X3 ) @ N ) @ ( power_power @ A @ X3 @ M2 ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_3823_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: nat,X3: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) @ X3 )
          = ( times_times @ A @ X3 @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_3824_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: int,X3: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) @ X3 )
          = ( times_times @ A @ X3 @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_3825_map__to__set__empty__iff_I1_J,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B )] :
      ( ( ( map_to_set @ A @ B @ M2 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( M2
        = ( ^ [X2: A] : ( none @ B ) ) ) ) ).

% map_to_set_empty_iff(1)
thf(fact_3826_map__to__set__empty__iff_I2_J,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B )] :
      ( ( ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) )
        = ( map_to_set @ A @ B @ M2 ) )
      = ( M2
        = ( ^ [X2: A] : ( none @ B ) ) ) ) ).

% map_to_set_empty_iff(2)
thf(fact_3827_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X3 ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X3 ) ) ) ) ).

% inverse_le_1_iff
thf(fact_3828_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X3 ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
            & ( ord_less @ A @ X3 @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_3829_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less @ A @ A4 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A4 ) ) ) ) ) ).

% one_less_inverse
thf(fact_3830_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( B3
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A4 ) @ ( inverse_inverse @ A @ B3 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A4 @ B3 ) @ ( inverse_inverse @ A @ A4 ) ) @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ) ).

% inverse_add
thf(fact_3831_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( B3
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A4 ) @ ( inverse_inverse @ A @ B3 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A4 ) @ ( plus_plus @ A @ A4 @ B3 ) ) @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_3832_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A4 ) @ A4 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_3833_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( B3
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A4 ) @ ( inverse_inverse @ A @ B3 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A4 ) @ ( minus_minus @ A @ B3 @ A4 ) ) @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_3834_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A4 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A4 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_3835_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B3 @ A4 ) @ C2 )
            = ( gcd_gcd @ A @ B3 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_3836_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B3 @ ( times_times @ A @ C2 @ A4 ) )
            = ( gcd_gcd @ A @ B3 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_3837_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B3 @ ( divide_divide @ A @ C2 @ A4 ) )
            = ( gcd_gcd @ A @ B3 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_3838_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B3 @ A4 ) @ C2 )
            = ( gcd_gcd @ A @ B3 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_3839_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A4 ) @ ( inverse_inverse @ A @ B3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) )
             => ( ord_less @ A @ B3 @ A4 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A4 @ B3 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A4 @ B3 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_3840_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A4 ) @ ( inverse_inverse @ A @ B3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A4 @ B3 ) )
             => ( ord_less_eq @ A @ B3 @ A4 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A4 @ B3 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_3841_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( ord_less_eq @ A @ A4 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A4 ) ) ) ) ) ).

% one_le_inverse
thf(fact_3842_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X3 ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X3 ) ) ) ) ).

% inverse_less_1_iff
thf(fact_3843_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X3 ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
            & ( ord_less_eq @ A @ X3 @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_3844_gcd__is__Max__divisors__int,axiom,
    ! [N: int,M2: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( gcd_gcd @ int @ M2 @ N )
        = ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D4: int] :
                ( ( dvd_dvd @ int @ D4 @ M2 )
                & ( dvd_dvd @ int @ D4 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_int
thf(fact_3845_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M2: nat,N: nat] :
          ( ( X3
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M2 @ N )
           => ( ( power_power @ A @ X3 @ ( minus_minus @ nat @ N @ M2 ) )
              = ( times_times @ A @ ( power_power @ A @ X3 @ N ) @ ( power_power @ A @ ( inverse_inverse @ A @ X3 ) @ M2 ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_3846_inf__option__def,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ( ( inf_inf @ ( option @ A ) )
        = ( ^ [X2: option @ A,Y2: option @ A] :
              ( case_option @ ( option @ A ) @ A @ ( none @ A )
              @ ^ [Z3: A] :
                  ( case_option @ ( option @ A ) @ A @ ( none @ A )
                  @ ^ [Aa2: A] : ( some @ A @ ( inf_inf @ A @ Z3 @ Aa2 ) )
                  @ Y2 )
              @ X2 ) ) ) ) ).

% inf_option_def
thf(fact_3847_empty__upd__none,axiom,
    ! [B: $tType,A: $tType,X3: A] :
      ( ( fun_upd @ A @ ( option @ B )
        @ ^ [X2: A] : ( none @ B )
        @ X3
        @ ( none @ B ) )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% empty_upd_none
thf(fact_3848_take__bit__num__code,axiom,
    ( bit_take_bit_num
    = ( ^ [N5: nat,M5: num] :
          ( product_case_prod @ nat @ num @ ( option @ num )
          @ ^ [A5: nat,X2: num] :
              ( case_nat @ ( option @ num ) @ ( none @ num )
              @ ^ [O2: nat] :
                  ( case_num @ ( option @ num ) @ ( some @ num @ one2 )
                  @ ^ [P6: num] :
                      ( case_option @ ( option @ num ) @ num @ ( none @ num )
                      @ ^ [Q8: num] : ( some @ num @ ( bit0 @ Q8 ) )
                      @ ( bit_take_bit_num @ O2 @ P6 ) )
                  @ ^ [P6: num] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ O2 @ P6 ) ) )
                  @ X2 )
              @ A5 )
          @ ( product_Pair @ nat @ num @ N5 @ M5 ) ) ) ) ).

% take_bit_num_code
thf(fact_3849_case__optionE,axiom,
    ! [A: $tType,P: $o,Q: A > $o,X3: option @ A] :
      ( ( case_option @ $o @ A @ P @ Q @ X3 )
     => ( ( ( X3
            = ( none @ A ) )
         => ~ P )
       => ~ ! [Y3: A] :
              ( ( X3
                = ( some @ A @ Y3 ) )
             => ~ ( Q @ Y3 ) ) ) ) ).

% case_optionE
thf(fact_3850_option_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( ( Option
         != ( none @ A ) ) )
      = ( case_option @ $o @ A @ $false
        @ ^ [Uu: A] : $true
        @ Option ) ) ).

% option.disc_eq_case(2)
thf(fact_3851_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: num > A,F33: num > A,Num: num] :
      ( ( H2 @ ( case_num @ A @ F1 @ F22 @ F33 @ Num ) )
      = ( case_num @ B @ ( H2 @ F1 )
        @ ^ [X2: num] : ( H2 @ ( F22 @ X2 ) )
        @ ^ [X2: num] : ( H2 @ ( F33 @ X2 ) )
        @ Num ) ) ).

% num.case_distrib
thf(fact_3852_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) @ ( dvd_dvd @ nat )
    @ ^ [M5: nat,N5: nat] :
        ( ( dvd_dvd @ nat @ M5 @ N5 )
        & ( M5 != N5 ) ) ) ).

% gcd_nat.semilattice_neutr_order_axioms
thf(fact_3853_Gcd__in,axiom,
    ! [A3: set @ nat] :
      ( ! [A7: nat,B6: nat] :
          ( ( member @ nat @ A7 @ A3 )
         => ( ( member @ nat @ B6 @ A3 )
           => ( member @ nat @ ( gcd_gcd @ nat @ A7 @ B6 ) @ A3 ) ) )
     => ( ( A3
         != ( bot_bot @ ( set @ nat ) ) )
       => ( member @ nat @ ( gcd_Gcd @ nat @ A3 ) @ A3 ) ) ) ).

% Gcd_in
thf(fact_3854_gcd__is__Max__divisors__nat,axiom,
    ! [N: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( gcd_gcd @ nat @ M2 @ N )
        = ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D4: nat] :
                ( ( dvd_dvd @ nat @ D4 @ M2 )
                & ( dvd_dvd @ nat @ D4 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_nat
thf(fact_3855_option_Ocase__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,H2: B > C,F1: B,F22: A > B,Option: option @ A] :
      ( ( H2 @ ( case_option @ B @ A @ F1 @ F22 @ Option ) )
      = ( case_option @ C @ A @ ( H2 @ F1 )
        @ ^ [X2: A] : ( H2 @ ( F22 @ X2 ) )
        @ Option ) ) ).

% option.case_distrib
thf(fact_3856_option_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
        = ( none @ A ) )
      = ( case_option @ $o @ A @ $true
        @ ^ [Uu: A] : $false
        @ Option ) ) ).

% option.disc_eq_case(1)
thf(fact_3857_Sup__option__def,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ ( option @ A ) )
        = ( ^ [A6: set @ ( option @ A )] :
              ( if @ ( option @ A )
              @ ( ( A6
                  = ( bot_bot @ ( set @ ( option @ A ) ) ) )
                | ( A6
                  = ( insert @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) )
              @ ( none @ A )
              @ ( some @ A @ ( complete_Sup_Sup @ A @ ( these @ A @ A6 ) ) ) ) ) ) ) ).

% Sup_option_def
thf(fact_3858_plus__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X2: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y2 ) @ ( product_snd @ int @ int @ X2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) )
    @ ( plus_plus @ rat ) ) ).

% plus_rat.transfer
thf(fact_3859_inverse__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat
    @ ^ [X2: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X2 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) )
    @ ( inverse_inverse @ rat ) ) ).

% inverse_rat.transfer
thf(fact_3860_these__not__empty__eq,axiom,
    ! [A: $tType,B2: set @ ( option @ A )] :
      ( ( ( ( these @ A @ B2 )
         != ( bot_bot @ ( set @ A ) ) ) )
      = ( ( B2
         != ( bot_bot @ ( set @ ( option @ A ) ) ) )
        & ( B2
         != ( insert @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) ) ) ).

% these_not_empty_eq
thf(fact_3861_these__empty,axiom,
    ! [A: $tType] :
      ( ( these @ A @ ( bot_bot @ ( set @ ( option @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% these_empty
thf(fact_3862_Some__image__these__eq,axiom,
    ! [A: $tType,A3: set @ ( option @ A )] :
      ( ( image2 @ A @ ( option @ A ) @ ( some @ A ) @ ( these @ A @ A3 ) )
      = ( collect @ ( option @ A )
        @ ^ [X2: option @ A] :
            ( ( member @ ( option @ A ) @ X2 @ A3 )
            & ( X2
             != ( none @ A ) ) ) ) ) ).

% Some_image_these_eq
thf(fact_3863_uminus__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat
    @ ^ [X2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( product_fst @ int @ int @ X2 ) ) @ ( product_snd @ int @ int @ X2 ) )
    @ ( uminus_uminus @ rat ) ) ).

% uminus_rat.transfer
thf(fact_3864_times__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X2: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_fst @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) )
    @ ( times_times @ rat ) ) ).

% times_rat.transfer
thf(fact_3865_these__empty__eq,axiom,
    ! [A: $tType,B2: set @ ( option @ A )] :
      ( ( ( these @ A @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( B2
          = ( bot_bot @ ( set @ ( option @ A ) ) ) )
        | ( B2
          = ( insert @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) ) ) ).

% these_empty_eq
thf(fact_3866_positive_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ $o @ $o @ pcr_rat
    @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
    @ ^ [X2: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ X2 ) ) )
    @ positive ) ).

% positive.transfer
thf(fact_3867_and__not__num_Oelims,axiom,
    ! [X3: num,Xa: num,Y: option @ num] :
      ( ( ( bit_and_not_num @ X3 @ Xa )
        = Y )
     => ( ( ( X3 = one2 )
         => ( ( Xa = one2 )
           => ( Y
             != ( none @ num ) ) ) )
       => ( ( ( X3 = one2 )
           => ( ? [N2: num] :
                  ( Xa
                  = ( bit0 @ N2 ) )
             => ( Y
               != ( some @ num @ one2 ) ) ) )
         => ( ( ( X3 = one2 )
             => ( ? [N2: num] :
                    ( Xa
                    = ( bit1 @ N2 ) )
               => ( Y
                 != ( none @ num ) ) ) )
           => ( ! [M3: num] :
                  ( ( X3
                    = ( bit0 @ M3 ) )
                 => ( ( Xa = one2 )
                   => ( Y
                     != ( some @ num @ ( bit0 @ M3 ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X3
                      = ( bit0 @ M3 ) )
                   => ! [N2: num] :
                        ( ( Xa
                          = ( bit0 @ N2 ) )
                       => ( Y
                         != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N2 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X3
                        = ( bit0 @ M3 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit1 @ N2 ) )
                         => ( Y
                           != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N2 ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X3
                          = ( bit1 @ M3 ) )
                       => ( ( Xa = one2 )
                         => ( Y
                           != ( some @ num @ ( bit0 @ M3 ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X3
                            = ( bit1 @ M3 ) )
                         => ! [N2: num] :
                              ( ( Xa
                                = ( bit0 @ N2 ) )
                             => ( Y
                               != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                  @ ^ [N8: num] : ( some @ num @ ( bit1 @ N8 ) )
                                  @ ( bit_and_not_num @ M3 @ N2 ) ) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X3
                              = ( bit1 @ M3 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit1 @ N2 ) )
                               => ( Y
                                 != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
thf(fact_3868_of__rat_Otransfer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ A @ A @ pcr_rat
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
        @ ^ [X2: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X2 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X2 ) ) )
        @ ( field_char_0_of_rat @ A ) ) ) ).

% of_rat.transfer
thf(fact_3869_restrict__upd__same,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),X3: A,Y: B] :
      ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M2 @ X3 @ ( some @ B @ Y ) ) @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( restrict_map @ A @ B @ M2 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% restrict_upd_same
thf(fact_3870_of__rat__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( one_one @ rat ) )
        = ( one_one @ A ) ) ) ).

% of_rat_1
thf(fact_3871_of__rat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: rat] :
          ( ( ( field_char_0_of_rat @ A @ A4 )
            = ( one_one @ A ) )
          = ( A4
            = ( one_one @ rat ) ) ) ) ).

% of_rat_eq_1_iff
thf(fact_3872_one__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: rat] :
          ( ( ( one_one @ A )
            = ( field_char_0_of_rat @ A @ A4 ) )
          = ( ( one_one @ rat )
            = A4 ) ) ) ).

% one_eq_of_rat_iff
thf(fact_3873_restrict__restrict,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),A3: set @ A,B2: set @ A] :
      ( ( restrict_map @ A @ B @ ( restrict_map @ A @ B @ M2 @ A3 ) @ B2 )
      = ( restrict_map @ A @ B @ M2 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ).

% restrict_restrict
thf(fact_3874_map__option__o__empty,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: C > B] :
      ( ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 )
        @ ^ [X2: A] : ( none @ C ) )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% map_option_o_empty
thf(fact_3875_restrict__map__empty,axiom,
    ! [B: $tType,A: $tType,D2: set @ A] :
      ( ( restrict_map @ A @ B
        @ ^ [X2: A] : ( none @ B )
        @ D2 )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% restrict_map_empty
thf(fact_3876_restrict__map__to__empty,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B )] :
      ( ( restrict_map @ A @ B @ M2 @ ( bot_bot @ ( set @ A ) ) )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% restrict_map_to_empty
thf(fact_3877_of__rat__neg__one,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% of_rat_neg_one
thf(fact_3878_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R5: rat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R5 ) )
          = ( ord_less @ rat @ ( one_one @ rat ) @ R5 ) ) ) ).

% one_less_of_rat_iff
thf(fact_3879_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R5: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R5 ) @ ( one_one @ A ) )
          = ( ord_less @ rat @ R5 @ ( one_one @ rat ) ) ) ) ).

% of_rat_less_1_iff
thf(fact_3880_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R5: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R5 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ rat @ R5 @ ( one_one @ rat ) ) ) ) ).

% of_rat_le_1_iff
thf(fact_3881_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R5: rat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R5 ) )
          = ( ord_less_eq @ rat @ ( one_one @ rat ) @ R5 ) ) ) ).

% one_le_of_rat_iff
thf(fact_3882_fun__upd__restrict__conv,axiom,
    ! [A: $tType,B: $tType,X3: A,D2: set @ A,M2: A > ( option @ B ),Y: option @ B] :
      ( ( member @ A @ X3 @ D2 )
     => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M2 @ D2 ) @ X3 @ Y )
        = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M2 @ ( minus_minus @ ( set @ A ) @ D2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X3 @ Y ) ) ) ).

% fun_upd_restrict_conv
thf(fact_3883_restrict__fun__upd,axiom,
    ! [B: $tType,A: $tType,X3: A,D2: set @ A,M2: A > ( option @ B ),Y: option @ B] :
      ( ( ( member @ A @ X3 @ D2 )
       => ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M2 @ X3 @ Y ) @ D2 )
          = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M2 @ ( minus_minus @ ( set @ A ) @ D2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X3 @ Y ) ) )
      & ( ~ ( member @ A @ X3 @ D2 )
       => ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M2 @ X3 @ Y ) @ D2 )
          = ( restrict_map @ A @ B @ M2 @ D2 ) ) ) ) ).

% restrict_fun_upd
thf(fact_3884_fun__upd__None__restrict,axiom,
    ! [B: $tType,A: $tType,X3: A,D2: set @ A,M2: A > ( option @ B )] :
      ( ( ( member @ A @ X3 @ D2 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M2 @ D2 ) @ X3 @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M2 @ ( minus_minus @ ( set @ A ) @ D2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )
      & ( ~ ( member @ A @ X3 @ D2 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M2 @ D2 ) @ X3 @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M2 @ D2 ) ) ) ) ).

% fun_upd_None_restrict
thf(fact_3885_option_Omap__ident,axiom,
    ! [A: $tType,T3: option @ A] :
      ( ( map_option @ A @ A
        @ ^ [X2: A] : X2
        @ T3 )
      = T3 ) ).

% option.map_ident
thf(fact_3886_map__option_Oidentity,axiom,
    ! [A: $tType] :
      ( ( map_option @ A @ A
        @ ^ [X2: A] : X2 )
      = ( id @ ( option @ A ) ) ) ).

% map_option.identity
thf(fact_3887_of__rat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field_char_0 @ A )
     => ! [F2: B > rat,A3: set @ B] :
          ( ( field_char_0_of_rat @ A @ ( groups7311177749621191930dd_sum @ B @ rat @ F2 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [A5: B] : ( field_char_0_of_rat @ A @ ( F2 @ A5 ) )
            @ A3 ) ) ) ).

% of_rat_sum
thf(fact_3888_of__rat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field_char_0 @ A )
     => ! [F2: B > rat,A3: set @ B] :
          ( ( field_char_0_of_rat @ A @ ( groups7121269368397514597t_prod @ B @ rat @ F2 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A5: B] : ( field_char_0_of_rat @ A @ ( F2 @ A5 ) )
            @ A3 ) ) ) ).

% of_rat_prod
thf(fact_3889_of__rat__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A4: rat,B3: rat] :
          ( ( field_char_0_of_rat @ A @ ( times_times @ rat @ A4 @ B3 ) )
          = ( times_times @ A @ ( field_char_0_of_rat @ A @ A4 ) @ ( field_char_0_of_rat @ A @ B3 ) ) ) ) ).

% of_rat_mult
thf(fact_3890_map__option__case,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map_option @ B @ A )
      = ( ^ [F3: B > A] :
            ( case_option @ ( option @ A ) @ B @ ( none @ A )
            @ ^ [X2: B] : ( some @ A @ ( F3 @ X2 ) ) ) ) ) ).

% map_option_case
thf(fact_3891_fun__upd__restrict,axiom,
    ! [A: $tType,B: $tType,M2: A > ( option @ B ),D2: set @ A,X3: A,Y: option @ B] :
      ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M2 @ D2 ) @ X3 @ Y )
      = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M2 @ ( minus_minus @ ( set @ A ) @ D2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X3 @ Y ) ) ).

% fun_upd_restrict
thf(fact_3892_restrict__complement__singleton__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > ( option @ B ),X3: A] :
      ( ( restrict_map @ A @ B @ F2 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( fun_upd @ A @ ( option @ B ) @ F2 @ X3 @ ( none @ B ) ) ) ).

% restrict_complement_singleton_eq
thf(fact_3893_map__upd__eq__restrict,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),X3: A] :
      ( ( fun_upd @ A @ ( option @ B ) @ M2 @ X3 @ ( none @ B ) )
      = ( restrict_map @ A @ B @ M2 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% map_upd_eq_restrict
thf(fact_3894_positive__def,axiom,
    ( positive
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ $o @ $o @ rep_Rat @ ( id @ $o )
      @ ^ [X2: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ X2 ) ) ) ) ) ).

% positive_def
thf(fact_3895_and__num_Oelims,axiom,
    ! [X3: num,Xa: num,Y: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X3 @ Xa )
        = Y )
     => ( ( ( X3 = one2 )
         => ( ( Xa = one2 )
           => ( Y
             != ( some @ num @ one2 ) ) ) )
       => ( ( ( X3 = one2 )
           => ( ? [N2: num] :
                  ( Xa
                  = ( bit0 @ N2 ) )
             => ( Y
               != ( none @ num ) ) ) )
         => ( ( ( X3 = one2 )
             => ( ? [N2: num] :
                    ( Xa
                    = ( bit1 @ N2 ) )
               => ( Y
                 != ( some @ num @ one2 ) ) ) )
           => ( ( ? [M3: num] :
                    ( X3
                    = ( bit0 @ M3 ) )
               => ( ( Xa = one2 )
                 => ( Y
                   != ( none @ num ) ) ) )
             => ( ! [M3: num] :
                    ( ( X3
                      = ( bit0 @ M3 ) )
                   => ! [N2: num] :
                        ( ( Xa
                          = ( bit0 @ N2 ) )
                       => ( Y
                         != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N2 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X3
                        = ( bit0 @ M3 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit1 @ N2 ) )
                         => ( Y
                           != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N2 ) ) ) ) )
                 => ( ( ? [M3: num] :
                          ( X3
                          = ( bit1 @ M3 ) )
                     => ( ( Xa = one2 )
                       => ( Y
                         != ( some @ num @ one2 ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X3
                            = ( bit1 @ M3 ) )
                         => ! [N2: num] :
                              ( ( Xa
                                = ( bit0 @ N2 ) )
                             => ( Y
                               != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N2 ) ) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X3
                              = ( bit1 @ M3 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit1 @ N2 ) )
                               => ( Y
                                 != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                    @ ^ [N8: num] : ( some @ num @ ( bit1 @ N8 ) )
                                    @ ( bit_un7362597486090784418nd_num @ M3 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
thf(fact_3896_of__rat__def,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A )
        = ( map_fun @ rat @ ( product_prod @ int @ int ) @ A @ A @ rep_Rat @ ( id @ A )
          @ ^ [X2: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X2 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X2 ) ) ) ) ) ) ).

% of_rat_def
thf(fact_3897_Min_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798350308766er_Min @ A )
        = ( ^ [A6: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y2: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( ord_min @ A @ X2 ) @ Y2 ) )
                @ ( none @ A )
                @ A6 ) ) ) ) ) ).

% Min.eq_fold'
thf(fact_3898_Option_Othese__def,axiom,
    ! [A: $tType] :
      ( ( these @ A )
      = ( ^ [A6: set @ ( option @ A )] :
            ( image2 @ ( option @ A ) @ A @ ( the2 @ A )
            @ ( collect @ ( option @ A )
              @ ^ [X2: option @ A] :
                  ( ( member @ ( option @ A ) @ X2 @ A6 )
                  & ( X2
                   != ( none @ A ) ) ) ) ) ) ) ).

% Option.these_def
thf(fact_3899_numeral__and__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: num,N: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un7362597486090784418nd_num @ M2 @ N ) ) ) ) ).

% numeral_and_num
thf(fact_3900_and__num_Osimps_I9_J,axiom,
    ! [M2: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M2 ) @ ( bit1 @ N ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N8: num] : ( some @ num @ ( bit1 @ N8 ) )
        @ ( bit_un7362597486090784418nd_num @ M2 @ N ) ) ) ).

% and_num.simps(9)
thf(fact_3901_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( ^ [A6: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y2: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( inf_inf @ A @ X2 ) @ Y2 ) )
                @ ( none @ A )
                @ A6 ) ) ) ) ) ).

% Inf_fin.eq_fold'
thf(fact_3902_Sup__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( ^ [A6: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y2: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( sup_sup @ A @ X2 ) @ Y2 ) )
                @ ( none @ A )
                @ A6 ) ) ) ) ) ).

% Sup_fin.eq_fold'
thf(fact_3903_plus__rat__def,axiom,
    ( ( plus_plus @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X2: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y2 ) @ ( product_snd @ int @ int @ X2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) ) ) ) ).

% plus_rat_def
thf(fact_3904_inverse__rat__def,axiom,
    ( ( inverse_inverse @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat
      @ ^ [X2: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int )
          @ ( ( product_fst @ int @ int @ X2 )
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) ) ) ) ).

% inverse_rat_def
thf(fact_3905_times__rat__def,axiom,
    ( ( times_times @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X2: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_fst @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) ) ) ) ).

% times_rat_def
thf(fact_3906_uminus__rat__def,axiom,
    ( ( uminus_uminus @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat
      @ ^ [X2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( product_fst @ int @ int @ X2 ) ) @ ( product_snd @ int @ int @ X2 ) ) ) ) ).

% uminus_rat_def
thf(fact_3907_Max_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798349783984er_Max @ A )
        = ( ^ [A6: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y2: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( ord_max @ A @ X2 ) @ Y2 ) )
                @ ( none @ A )
                @ A6 ) ) ) ) ) ).

% Max.eq_fold'
thf(fact_3908_Gcd__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( ^ [A6: set @ A] : ( if @ A @ ( finite_finite2 @ A @ A6 ) @ ( finite_fold @ A @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ A6 ) @ ( one_one @ A ) ) ) ) ) ).

% Gcd_fin.eq_fold
thf(fact_3909_plus__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X2: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y2 ) @ ( product_snd @ int @ int @ X2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) )
    @ ^ [X2: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y2 ) @ ( product_snd @ int @ int @ X2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) ) ) ).

% plus_rat.rsp
thf(fact_3910_inverse__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel
    @ ^ [X2: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X2 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) )
    @ ^ [X2: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X2 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) ) ) ).

% inverse_rat.rsp
thf(fact_3911_max_Oidem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A] :
          ( ( ord_max @ A @ A4 @ A4 )
          = A4 ) ) ).

% max.idem
thf(fact_3912_max_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_max @ A @ A4 @ ( ord_max @ A @ A4 @ B3 ) )
          = ( ord_max @ A @ A4 @ B3 ) ) ) ).

% max.left_idem
thf(fact_3913_max_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_max @ A @ ( ord_max @ A @ A4 @ B3 ) @ B3 )
          = ( ord_max @ A @ A4 @ B3 ) ) ) ).

% max.right_idem
thf(fact_3914_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( ord_max @ A @ A4 @ B3 )
            = A4 ) ) ) ).

% max.absorb1
thf(fact_3915_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less_eq @ A @ A4 @ B3 )
         => ( ( ord_max @ A @ A4 @ B3 )
            = B3 ) ) ) ).

% max.absorb2
thf(fact_3916_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B3 @ C2 ) @ A4 )
          = ( ( ord_less_eq @ A @ B3 @ A4 )
            & ( ord_less_eq @ A @ C2 @ A4 ) ) ) ) ).

% max.bounded_iff
thf(fact_3917_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X3 @ Y ) @ Z2 )
          = ( ( ord_less @ A @ X3 @ Z2 )
            & ( ord_less @ A @ Y @ Z2 ) ) ) ) ).

% max_less_iff_conj
thf(fact_3918_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_max @ A @ A4 @ B3 )
            = B3 ) ) ) ).

% max.absorb4
thf(fact_3919_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ( ord_max @ A @ A4 @ B3 )
            = A4 ) ) ) ).

% max.absorb3
thf(fact_3920_max__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X3: A] :
          ( ( ord_max @ A @ X3 @ ( bot_bot @ A ) )
          = X3 ) ) ).

% max_bot2
thf(fact_3921_max__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X3: A] :
          ( ( ord_max @ A @ ( bot_bot @ A ) @ X3 )
          = X3 ) ) ).

% max_bot
thf(fact_3922_max__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X3: A] :
          ( ( ord_max @ A @ ( top_top @ A ) @ X3 )
          = ( top_top @ A ) ) ) ).

% max_top
thf(fact_3923_max__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X3: A] :
          ( ( ord_max @ A @ X3 @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% max_top2
thf(fact_3924_max__min__same_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_max @ A @ X3 @ ( ord_min @ A @ X3 @ Y ) )
          = X3 ) ) ).

% max_min_same(1)
thf(fact_3925_max__min__same_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X3 @ Y ) @ X3 )
          = X3 ) ) ).

% max_min_same(2)
thf(fact_3926_max__min__same_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X3 @ Y ) @ Y )
          = Y ) ) ).

% max_min_same(3)
thf(fact_3927_max__min__same_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X3: A] :
          ( ( ord_max @ A @ Y @ ( ord_min @ A @ X3 @ Y ) )
          = Y ) ) ).

% max_min_same(4)
thf(fact_3928_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              | Q ) )
          = ( ord_max @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_or_iff
thf(fact_3929_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_3930_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_3931_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X3 ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X3 ) ) ) ).

% max_0_1(6)
thf(fact_3932_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X3 ) )
          = ( numeral_numeral @ A @ X3 ) ) ) ).

% max_0_1(5)
thf(fact_3933_Gcd__fin_Oempty,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_fin.empty
thf(fact_3934_Gcd__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite2 @ A @ A3 )
         => ( ( semiring_gcd_Gcd_fin @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_fin.infinite
thf(fact_3935_is__unit__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A] :
          ( ( dvd_dvd @ A @ ( semiring_gcd_Gcd_fin @ A @ A3 ) @ ( one_one @ A ) )
          = ( ( semiring_gcd_Gcd_fin @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_Gcd_fin_iff
thf(fact_3936_Int__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D3 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A4 @ C2 ) @ ( ord_min @ A @ B3 @ D3 ) ) ) ) ).

% Int_atLeastAtMost
thf(fact_3937_Int__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A4 @ B3 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D3 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( ord_max @ A @ A4 @ C2 ) @ ( ord_min @ A @ B3 @ D3 ) ) ) ) ).

% Int_atLeastLessThan
thf(fact_3938_Int__atLeastAtMostR2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atLeast @ A @ A4 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D3 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A4 @ C2 ) @ D3 ) ) ) ).

% Int_atLeastAtMostR2
thf(fact_3939_Int__atLeastAtMostL2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) @ ( set_ord_atLeast @ A @ C2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A4 @ C2 ) @ B3 ) ) ) ).

% Int_atLeastAtMostL2
thf(fact_3940_Max__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X3 @ A3 ) )
              = ( ord_max @ A @ X3 @ ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ) ).

% Max_insert
thf(fact_3941_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X3 @ Y ) @ Z2 )
          = ( ord_max @ A @ ( plus_plus @ A @ X3 @ Z2 ) @ ( plus_plus @ A @ Y @ Z2 ) ) ) ) ).

% max_add_distrib_left
thf(fact_3942_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ X3 @ ( ord_max @ A @ Y @ Z2 ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X3 @ Y ) @ ( plus_plus @ A @ X3 @ Z2 ) ) ) ) ).

% max_add_distrib_right
thf(fact_3943_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X3 @ Y ) @ Z2 )
          = ( ord_max @ A @ ( minus_minus @ A @ X3 @ Z2 ) @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ).

% max_diff_distrib_left
thf(fact_3944_sup__max,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( linorder @ A ) )
     => ( ( sup_sup @ A )
        = ( ord_max @ A ) ) ) ).

% sup_max
thf(fact_3945_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ B4 @ A5 ) ) ) ) ).

% max_def_raw
thf(fact_3946_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_max @ A @ X3 @ Y ) )
          = ( ( ord_less @ A @ Z2 @ X3 )
            | ( ord_less @ A @ Z2 @ Y ) ) ) ) ).

% less_max_iff_disj
thf(fact_3947_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B3 @ C2 ) @ A4 )
         => ~ ( ( ord_less @ A @ B3 @ A4 )
             => ~ ( ord_less @ A @ C2 @ A4 ) ) ) ) ).

% max.strict_boundedE
thf(fact_3948_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( A5
                = ( ord_max @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_3949_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ C2 @ A4 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A4 @ B3 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_3950_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less @ A @ C2 @ B3 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A4 @ B3 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_3951_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( ord_max @ A @ X3 @ Y )
            = Y ) ) ) ).

% max_absorb2
thf(fact_3952_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X3: A] :
          ( ( ord_less_eq @ A @ Y @ X3 )
         => ( ( ord_max @ A @ X3 @ Y )
            = X3 ) ) ) ).

% max_absorb1
thf(fact_3953_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ B4 @ A5 ) ) ) ) ).

% max_def
thf(fact_3954_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less_eq @ A @ C2 @ B3 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A4 @ B3 ) ) ) ) ).

% max.coboundedI2
thf(fact_3955_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less_eq @ A @ C2 @ A4 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A4 @ B3 ) ) ) ) ).

% max.coboundedI1
thf(fact_3956_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_max @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% max.absorb_iff2
thf(fact_3957_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_max @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% max.absorb_iff1
thf(fact_3958_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X3: A,Y: A] :
          ( ( ord_less_eq @ A @ Z2 @ ( ord_max @ A @ X3 @ Y ) )
          = ( ( ord_less_eq @ A @ Z2 @ X3 )
            | ( ord_less_eq @ A @ Z2 @ Y ) ) ) ) ).

% le_max_iff_disj
thf(fact_3959_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,A4: A] : ( ord_less_eq @ A @ B3 @ ( ord_max @ A @ A4 @ B3 ) ) ) ).

% max.cobounded2
thf(fact_3960_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] : ( ord_less_eq @ A @ A4 @ ( ord_max @ A @ A4 @ B3 ) ) ) ).

% max.cobounded1
thf(fact_3961_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( A5
              = ( ord_max @ A @ A5 @ B4 ) ) ) ) ) ).

% max.order_iff
thf(fact_3962_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( ( ord_less_eq @ A @ C2 @ A4 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B3 @ C2 ) @ A4 ) ) ) ) ).

% max.boundedI
thf(fact_3963_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B3 @ C2 ) @ A4 )
         => ~ ( ( ord_less_eq @ A @ B3 @ A4 )
             => ~ ( ord_less_eq @ A @ C2 @ A4 ) ) ) ) ).

% max.boundedE
thf(fact_3964_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
            = ( ord_max @ A @ A4 @ B3 ) )
         => ( ord_less_eq @ A @ B3 @ A4 ) ) ) ).

% max.orderI
thf(fact_3965_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,A4: A] :
          ( ( ord_less_eq @ A @ B3 @ A4 )
         => ( A4
            = ( ord_max @ A @ A4 @ B3 ) ) ) ) ).

% max.orderE
thf(fact_3966_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A4: A,D3: A,B3: A] :
          ( ( ord_less_eq @ A @ C2 @ A4 )
         => ( ( ord_less_eq @ A @ D3 @ B3 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D3 ) @ ( ord_max @ A @ A4 @ B3 ) ) ) ) ) ).

% max.mono
thf(fact_3967_max__min__distrib1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ B3 @ C2 ) @ A4 )
          = ( ord_min @ A @ ( ord_max @ A @ B3 @ A4 ) @ ( ord_max @ A @ C2 @ A4 ) ) ) ) ).

% max_min_distrib1
thf(fact_3968_max__min__distrib2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_max @ A @ A4 @ ( ord_min @ A @ B3 @ C2 ) )
          = ( ord_min @ A @ ( ord_max @ A @ A4 @ B3 ) @ ( ord_max @ A @ A4 @ C2 ) ) ) ) ).

% max_min_distrib2
thf(fact_3969_min__max__distrib1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_min @ A @ ( ord_max @ A @ B3 @ C2 ) @ A4 )
          = ( ord_max @ A @ ( ord_min @ A @ B3 @ A4 ) @ ( ord_min @ A @ C2 @ A4 ) ) ) ) ).

% min_max_distrib1
thf(fact_3970_min__max__distrib2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_min @ A @ A4 @ ( ord_max @ A @ B3 @ C2 ) )
          = ( ord_max @ A @ ( ord_min @ A @ A4 @ B3 ) @ ( ord_min @ A @ A4 @ C2 ) ) ) ) ).

% min_max_distrib2
thf(fact_3971_max__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,M2: A,N: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_max @ B @ ( F2 @ M2 ) @ ( F2 @ N ) )
            = ( F2 @ ( ord_max @ A @ M2 @ N ) ) ) ) ) ).

% max_of_mono
thf(fact_3972_max_Oassoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_max @ A @ ( ord_max @ A @ A4 @ B3 ) @ C2 )
          = ( ord_max @ A @ A4 @ ( ord_max @ A @ B3 @ C2 ) ) ) ) ).

% max.assoc
thf(fact_3973_max_Ocommute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_max @ A )
        = ( ^ [A5: A,B4: A] : ( ord_max @ A @ B4 @ A5 ) ) ) ) ).

% max.commute
thf(fact_3974_max_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_max @ A @ B3 @ ( ord_max @ A @ A4 @ C2 ) )
          = ( ord_max @ A @ A4 @ ( ord_max @ A @ B3 @ C2 ) ) ) ) ).

% max.left_commute
thf(fact_3975_max_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semigroup @ A @ ( ord_max @ A ) ) ) ).

% max.semigroup_axioms
thf(fact_3976_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X3: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X3 @ Y ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_max_eq_min
thf(fact_3977_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X3: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X3 @ Y ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_min_eq_max
thf(fact_3978_lessThan__Int__lessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A4 ) @ ( set_ord_greaterThan @ A @ B3 ) )
          = ( set_ord_greaterThan @ A @ ( ord_max @ A @ A4 @ B3 ) ) ) ) ).

% lessThan_Int_lessThan
thf(fact_3979_max__Suc1,axiom,
    ! [N: nat,M2: nat] :
      ( ( ord_max @ nat @ ( suc @ N ) @ M2 )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M6: nat] : ( suc @ ( ord_max @ nat @ N @ M6 ) )
        @ M2 ) ) ).

% max_Suc1
thf(fact_3980_max__Suc2,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_max @ nat @ M2 @ ( suc @ N ) )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M6: nat] : ( suc @ ( ord_max @ nat @ M6 @ N ) )
        @ M2 ) ) ).

% max_Suc2
thf(fact_3981_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P5: A,X3: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ P5 @ ( ord_max @ A @ X3 @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P5 @ X3 ) @ ( times_times @ A @ P5 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ P5 @ ( ord_max @ A @ X3 @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P5 @ X3 ) @ ( times_times @ A @ P5 @ Y ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_3982_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P5: A,X3: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ P5 @ ( ord_min @ A @ X3 @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P5 @ X3 ) @ ( times_times @ A @ P5 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ P5 @ ( ord_min @ A @ X3 @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P5 @ X3 ) @ ( times_times @ A @ P5 @ Y ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_3983_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P5: A,X3: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ ( ord_max @ A @ X3 @ Y ) @ P5 )
              = ( ord_max @ A @ ( times_times @ A @ X3 @ P5 ) @ ( times_times @ A @ Y @ P5 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ ( ord_max @ A @ X3 @ Y ) @ P5 )
              = ( ord_min @ A @ ( times_times @ A @ X3 @ P5 ) @ ( times_times @ A @ Y @ P5 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_3984_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P5: A,X3: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ ( ord_min @ A @ X3 @ Y ) @ P5 )
              = ( ord_min @ A @ ( times_times @ A @ X3 @ P5 ) @ ( times_times @ A @ Y @ P5 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P5 )
           => ( ( times_times @ A @ ( ord_min @ A @ X3 @ Y ) @ P5 )
              = ( ord_max @ A @ ( times_times @ A @ X3 @ P5 ) @ ( times_times @ A @ Y @ P5 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_3985_Fract_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > ( product_prod @ int @ int ) )
    @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int )
      @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
      @ ratrel )
    @ ^ [A5: int,B4: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B4
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A5 @ B4 ) )
    @ ^ [A5: int,B4: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B4
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A5 @ B4 ) ) ) ).

% Fract.rsp
thf(fact_3986_Sup__insert__finite,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert @ A @ X3 @ S2 ) )
                = X3 ) )
            & ( ( S2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert @ A @ X3 @ S2 ) )
                = ( ord_max @ A @ X3 @ ( complete_Sup_Sup @ A @ S2 ) ) ) ) ) ) ) ).

% Sup_insert_finite
thf(fact_3987_hom__Max__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X: A,Y3: A] :
              ( ( H2 @ ( ord_max @ A @ X @ Y3 ) )
              = ( ord_max @ A @ ( H2 @ X ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite2 @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798349783984er_Max @ A @ N4 ) )
                = ( lattic643756798349783984er_Max @ A @ ( image2 @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% hom_Max_commute
thf(fact_3988_Max_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( B2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A3 )
             => ( ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ B2 ) @ ( lattic643756798349783984er_Max @ A @ A3 ) )
                = ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ) ).

% Max.subset
thf(fact_3989_Max_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X: A,Y3: A] : ( member @ A @ ( ord_max @ A @ X @ Y3 ) @ ( insert @ A @ X @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ A3 ) ) ) ) ) ).

% Max.closed
thf(fact_3990_Max_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ~ ( member @ A @ X3 @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X3 @ A3 ) )
                = ( ord_max @ A @ X3 @ ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ) ) ).

% Max.insert_not_elem
thf(fact_3991_Max_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B2: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ B2 )
             => ( ( B2
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
                  = ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ ( lattic643756798349783984er_Max @ A @ B2 ) ) ) ) ) ) ) ) ).

% Max.union
thf(fact_3992_Max_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( member @ A @ X3 @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A3 )
                  = X3 ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A3 )
                  = ( ord_max @ A @ X3 @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Max.remove
thf(fact_3993_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X3 @ A3 ) )
                = X3 ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X3 @ A3 ) )
                = ( ord_max @ A @ X3 @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Max.insert_remove
thf(fact_3994_Gcd__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,A3: set @ A] :
          ( ( member @ A @ A4 @ A3 )
         => ( ( semiring_gcd_Gcd_fin @ A @ A3 )
            = ( gcd_gcd @ A @ A4 @ ( semiring_gcd_Gcd_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% Gcd_fin.remove
thf(fact_3995_Gcd__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,A3: set @ A] :
          ( ( semiring_gcd_Gcd_fin @ A @ ( insert @ A @ A4 @ A3 ) )
          = ( gcd_gcd @ A @ A4 @ ( semiring_gcd_Gcd_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% Gcd_fin.insert_remove
thf(fact_3996_of__rat_Orsp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ A @ A @ ratrel
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
        @ ^ [X2: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X2 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X2 ) ) )
        @ ^ [X2: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X2 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X2 ) ) ) ) ) ).

% of_rat.rsp
thf(fact_3997_ratrel__def,axiom,
    ( ratrel
    = ( ^ [X2: product_prod @ int @ int,Y2: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X2 )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y2 )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y2 ) @ ( product_snd @ int @ int @ X2 ) ) ) ) ) ) ).

% ratrel_def
thf(fact_3998_times__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X2: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_fst @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) )
    @ ^ [X2: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_fst @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y2 ) ) ) ) ).

% times_rat.rsp
thf(fact_3999_uminus__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel
    @ ^ [X2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( product_fst @ int @ int @ X2 ) ) @ ( product_snd @ int @ int @ X2 ) )
    @ ^ [X2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( product_fst @ int @ int @ X2 ) ) @ ( product_snd @ int @ int @ X2 ) ) ) ).

% uminus_rat.rsp
thf(fact_4000_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X2: nat,Y2: nat] : ( ord_less_eq @ nat @ Y2 @ X2 )
    @ ^ [X2: nat,Y2: nat] : ( ord_less @ nat @ Y2 @ X2 ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_4001_Gcd__fin__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( semiring_gcd_Gcd_fin @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) )
            & ( finite_finite2 @ A @ A3 ) ) ) ) ).

% Gcd_fin_0_iff
thf(fact_4002_positive_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ $o @ $o @ ratrel
    @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
    @ ^ [X2: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ X2 ) ) )
    @ ^ [X2: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ X2 ) ) ) ) ).

% positive.rsp
thf(fact_4003_cr__rat__def,axiom,
    ( cr_rat
    = ( ^ [X2: product_prod @ int @ int,Y2: rat] :
          ( ( ratrel @ X2 @ X2 )
          & ( ( abs_Rat @ X2 )
            = Y2 ) ) ) ) ).

% cr_rat_def
thf(fact_4004_dual__min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( min @ A
          @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 ) )
        = ( ord_max @ A ) ) ) ).

% dual_min
thf(fact_4005_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: num,N: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un2480387367778600638or_num @ M2 @ N ) ) ) ) ).

% numeral_xor_num
thf(fact_4006_the__dflt__None__nonempty,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( dflt_None_set @ A @ S2 )
        = ( some @ ( set @ A ) @ S2 ) ) ) ).

% the_dflt_None_nonempty
thf(fact_4007_the__dflt__None__empty,axiom,
    ! [A: $tType] :
      ( ( dflt_None_set @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( none @ ( set @ A ) ) ) ).

% the_dflt_None_empty
thf(fact_4008_ord_Omin_Ocong,axiom,
    ! [A: $tType] :
      ( ( min @ A )
      = ( min @ A ) ) ).

% ord.min.cong
thf(fact_4009_ord_Omin__def,axiom,
    ! [A: $tType] :
      ( ( min @ A )
      = ( ^ [Less_eq2: A > A > $o,A5: A,B4: A] : ( if @ A @ ( Less_eq2 @ A5 @ B4 ) @ A5 @ B4 ) ) ) ).

% ord.min_def
thf(fact_4010_dflt__None__set__def,axiom,
    ! [A: $tType] :
      ( ( dflt_None_set @ A )
      = ( ^ [S7: set @ A] :
            ( if @ ( option @ ( set @ A ) )
            @ ( S7
              = ( bot_bot @ ( set @ A ) ) )
            @ ( none @ ( set @ A ) )
            @ ( some @ ( set @ A ) @ S7 ) ) ) ) ).

% dflt_None_set_def
thf(fact_4011_the__dflt__None__set,axiom,
    ! [A: $tType,X3: set @ A] :
      ( ( the_default @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( dflt_None_set @ A @ X3 ) )
      = X3 ) ).

% the_dflt_None_set
thf(fact_4012_and__not__num_Opelims,axiom,
    ! [X3: num,Xa: num,Y: option @ num] :
      ( ( ( bit_and_not_num @ X3 @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ X3 @ Xa ) )
       => ( ( ( X3 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X3 = one2 )
             => ! [N2: num] :
                  ( ( Xa
                    = ( bit0 @ N2 ) )
                 => ( ( Y
                      = ( some @ num @ one2 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N2 ) ) ) ) ) )
           => ( ( ( X3 = one2 )
               => ! [N2: num] :
                    ( ( Xa
                      = ( bit1 @ N2 ) )
                   => ( ( Y
                        = ( none @ num ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N2 ) ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X3
                      = ( bit0 @ M3 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( some @ num @ ( bit0 @ M3 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ one2 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X3
                        = ( bit0 @ M3 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit0 @ N2 ) )
                         => ( ( Y
                              = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N2 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit0 @ N2 ) ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X3
                          = ( bit0 @ M3 ) )
                       => ! [N2: num] :
                            ( ( Xa
                              = ( bit1 @ N2 ) )
                           => ( ( Y
                                = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N2 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit1 @ N2 ) ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X3
                            = ( bit1 @ M3 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y
                                = ( some @ num @ ( bit0 @ M3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ one2 ) ) ) ) )
                     => ( ! [M3: num] :
                            ( ( X3
                              = ( bit1 @ M3 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit0 @ N2 ) )
                               => ( ( Y
                                    = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                      @ ^ [N8: num] : ( some @ num @ ( bit1 @ N8 ) )
                                      @ ( bit_and_not_num @ M3 @ N2 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit0 @ N2 ) ) ) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X3
                                = ( bit1 @ M3 ) )
                             => ! [N2: num] :
                                  ( ( Xa
                                    = ( bit1 @ N2 ) )
                                 => ( ( Y
                                      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N2 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
thf(fact_4013_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U2: A] :
          ( ( ord_less @ A @ L @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L @ U2 ) )
            = ( set_or7035219750837199246ssThan @ A @ L @ U2 ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_4014_and__num_Opelims,axiom,
    ! [X3: num,Xa: num,Y: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X3 @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ X3 @ Xa ) )
       => ( ( ( X3 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y
                  = ( some @ num @ one2 ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X3 = one2 )
             => ! [N2: num] :
                  ( ( Xa
                    = ( bit0 @ N2 ) )
                 => ( ( Y
                      = ( none @ num ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N2 ) ) ) ) ) )
           => ( ( ( X3 = one2 )
               => ! [N2: num] :
                    ( ( Xa
                      = ( bit1 @ N2 ) )
                   => ( ( Y
                        = ( some @ num @ one2 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N2 ) ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X3
                      = ( bit0 @ M3 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( none @ num ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ one2 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X3
                        = ( bit0 @ M3 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit0 @ N2 ) )
                         => ( ( Y
                              = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N2 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit0 @ N2 ) ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X3
                          = ( bit0 @ M3 ) )
                       => ! [N2: num] :
                            ( ( Xa
                              = ( bit1 @ N2 ) )
                           => ( ( Y
                                = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N2 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit1 @ N2 ) ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X3
                            = ( bit1 @ M3 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y
                                = ( some @ num @ one2 ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ one2 ) ) ) ) )
                     => ( ! [M3: num] :
                            ( ( X3
                              = ( bit1 @ M3 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit0 @ N2 ) )
                               => ( ( Y
                                    = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N2 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit0 @ N2 ) ) ) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X3
                                = ( bit1 @ M3 ) )
                             => ! [N2: num] :
                                  ( ( Xa
                                    = ( bit1 @ N2 ) )
                                 => ( ( Y
                                      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                        @ ^ [N8: num] : ( some @ num @ ( bit1 @ N8 ) )
                                        @ ( bit_un7362597486090784418nd_num @ M3 @ N2 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
thf(fact_4015_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_4016_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A4 @ B3 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B3 @ A4 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_4017_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A4 @ B3 ) )
          = ( ord_less_eq @ A @ B3 @ A4 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_4018_Int__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A4 @ B3 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D3 ) )
          = ( set_or5935395276787703475ssThan @ A @ ( ord_max @ A @ A4 @ C2 ) @ ( ord_min @ A @ B3 @ D3 ) ) ) ) ).

% Int_greaterThanLessThan
thf(fact_4019_ivl__disj__int__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M2 ) @ ( set_or1337092689740270186AtMost @ A @ M2 @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(5)
thf(fact_4020_ivl__disj__int__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M2 ) @ ( set_or5935395276787703475ssThan @ A @ M2 @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(4)
thf(fact_4021_ivl__disj__int__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M2 ) @ ( set_or7035219750837199246ssThan @ A @ M2 @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(1)
thf(fact_4022_ivl__disj__int__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or5935395276787703475ssThan @ A @ L @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(1)
thf(fact_4023_ivl__disj__int__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U2 ) @ ( set_ord_atLeast @ A @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(6)
thf(fact_4024_greaterThanLessThan__eq,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or5935395276787703475ssThan @ A )
        = ( ^ [A5: A,B4: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A5 ) @ ( set_ord_lessThan @ A @ B4 ) ) ) ) ) ).

% greaterThanLessThan_eq
thf(fact_4025_greaterThanLessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or5935395276787703475ssThan @ A )
        = ( ^ [L2: A,U: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ L2 ) @ ( set_ord_lessThan @ A @ U ) ) ) ) ) ).

% greaterThanLessThan_def
thf(fact_4026_atLeastAtMost__diff__ends,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A] :
          ( ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) @ ( insert @ A @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( set_or5935395276787703475ssThan @ A @ A4 @ B3 ) ) ) ).

% atLeastAtMost_diff_ends
thf(fact_4027_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A] :
          ( ! [A7: A,B6: A,X: A] :
              ( ( member @ A @ A7 @ S2 )
             => ( ( member @ A @ B6 @ S2 )
               => ( ( ord_less_eq @ A @ A7 @ X )
                 => ( ( ord_less_eq @ A @ X @ B6 )
                   => ( member @ A @ X @ S2 ) ) ) ) )
         => ? [A7: A,B6: A] :
              ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
              | ( S2
                = ( top_top @ ( set @ A ) ) )
              | ( S2
                = ( set_ord_lessThan @ A @ B6 ) )
              | ( S2
                = ( set_ord_atMost @ A @ B6 ) )
              | ( S2
                = ( set_ord_greaterThan @ A @ A7 ) )
              | ( S2
                = ( set_ord_atLeast @ A @ A7 ) )
              | ( S2
                = ( set_or5935395276787703475ssThan @ A @ A7 @ B6 ) )
              | ( S2
                = ( set_or3652927894154168847AtMost @ A @ A7 @ B6 ) )
              | ( S2
                = ( set_or7035219750837199246ssThan @ A @ A7 @ B6 ) )
              | ( S2
                = ( set_or1337092689740270186AtMost @ A @ A7 @ B6 ) ) ) ) ) ).

% interval_cases
thf(fact_4028_set__to__map__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( set_to_map @ A @ B @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% set_to_map_empty
thf(fact_4029_bot_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ( ordering_top @ A
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 )
        @ ( bot_bot @ A ) ) ) ).

% bot.ordering_top_axioms
thf(fact_4030_euclidean__size__times__nonunit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( B3
             != ( zero_zero @ A ) )
           => ( ~ ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
             => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ B3 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A4 @ B3 ) ) ) ) ) ) ) ).

% euclidean_size_times_nonunit
thf(fact_4031_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_4032_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_4033_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_4034_euclidean__size__1,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) )
        = ( one_one @ nat ) ) ) ).

% euclidean_size_1
thf(fact_4035_Int__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A4 @ B3 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D3 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( ord_max @ A @ A4 @ C2 ) @ ( ord_min @ A @ B3 @ D3 ) ) ) ) ).

% Int_greaterThanAtMost
thf(fact_4036_ordering__top_Oextremum__uniqueI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A4: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ( Less_eq @ Top @ A4 )
       => ( A4 = Top ) ) ) ).

% ordering_top.extremum_uniqueI
thf(fact_4037_ordering__top_Onot__eq__extremum,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A4: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ( ( A4 != Top ) )
        = ( Less @ A4 @ Top ) ) ) ).

% ordering_top.not_eq_extremum
thf(fact_4038_ordering__top_Oextremum__unique,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A4: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ( Less_eq @ Top @ A4 )
        = ( A4 = Top ) ) ) ).

% ordering_top.extremum_unique
thf(fact_4039_ordering__top_Oextremum__strict,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A4: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ~ ( Less @ Top @ A4 ) ) ).

% ordering_top.extremum_strict
thf(fact_4040_ordering__top_Oextremum,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A4: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( Less_eq @ A4 @ Top ) ) ).

% ordering_top.extremum
thf(fact_4041_ivl__disj__int__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M2 ) @ ( set_or3652927894154168847AtMost @ A @ M2 @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(6)
thf(fact_4042_euclidean__size__unit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( euclid6346220572633701492n_size @ A @ A4 )
            = ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) ) ) ) ) ).

% euclidean_size_unit
thf(fact_4043_euclidean__size__mult,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A4: A,B3: A] :
          ( ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A4 @ B3 ) )
          = ( times_times @ nat @ ( euclid6346220572633701492n_size @ A @ A4 ) @ ( euclid6346220572633701492n_size @ A @ B3 ) ) ) ) ).

% euclidean_size_mult
thf(fact_4044_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A4 @ B3 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D3 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B3 @ A4 )
            | ( ord_less_eq @ A @ D3 @ C2 )
            | ( ord_less_eq @ A @ B3 @ C2 )
            | ( ord_less_eq @ A @ D3 @ A4 ) ) ) ) ).

% Ioc_disjoint
thf(fact_4045_ivl__disj__int__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M2 ) @ ( set_or3652927894154168847AtMost @ A @ M2 @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(8)
thf(fact_4046_ivl__disj__int__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or3652927894154168847AtMost @ A @ L @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(3)
thf(fact_4047_unit__iff__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
          = ( ( ( euclid6346220572633701492n_size @ A @ A4 )
              = ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) ) )
            & ( A4
             != ( zero_zero @ A ) ) ) ) ) ).

% unit_iff_euclidean_size
thf(fact_4048_size__mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B3: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A4 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ B3 @ A4 ) ) ) ) ) ).

% size_mult_mono'
thf(fact_4049_size__mult__mono,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B3: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A4 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A4 @ B3 ) ) ) ) ) ).

% size_mult_mono
thf(fact_4050_euclidean__size__times__unit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A4 @ B3 ) )
            = ( euclid6346220572633701492n_size @ A @ B3 ) ) ) ) ).

% euclidean_size_times_unit
thf(fact_4051_ivl__disj__int__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M2 ) @ ( set_or5935395276787703475ssThan @ A @ M2 @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(2)
thf(fact_4052_ivl__disj__int__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ U2 ) @ ( set_ord_greaterThan @ A @ U2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(5)
thf(fact_4053_greaterThanAtMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or3652927894154168847AtMost @ A )
        = ( ^ [L2: A,U: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ L2 ) @ ( set_ord_atMost @ A @ U ) ) ) ) ) ).

% greaterThanAtMost_def
thf(fact_4054_gcd__nat_Oordering__top__axioms,axiom,
    ( ordering_top @ nat @ ( dvd_dvd @ nat )
    @ ^ [M5: nat,N5: nat] :
        ( ( dvd_dvd @ nat @ M5 @ N5 )
        & ( M5 != N5 ) )
    @ ( zero_zero @ nat ) ) ).

% gcd_nat.ordering_top_axioms
thf(fact_4055_set__to__map__empty__iff_I1_J,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( product_prod @ A @ B )] :
      ( ( ( set_to_map @ A @ B @ S2 )
        = ( ^ [X2: A] : ( none @ B ) ) )
      = ( S2
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ).

% set_to_map_empty_iff(1)
thf(fact_4056_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
            = ( times_times @ A @ ( G @ M2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M2 @ N ) ) ) ) ) ) ).

% prod.head
thf(fact_4057_greaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( set_or3652927894154168847AtMost @ A )
        = ( ^ [A5: A,B4: A] : ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A5 @ B4 ) @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% greaterThanAtMost_eq_atLeastAtMost_diff
thf(fact_4058_set__to__map__empty__iff_I2_J,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X2: A] : ( none @ B ) )
        = ( set_to_map @ A @ B @ S2 ) )
      = ( S2
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ).

% set_to_map_empty_iff(2)
thf(fact_4059_top_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ( ordering_top @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ A ) ) ) ).

% top.ordering_top_axioms
thf(fact_4060_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U2: A] :
          ( ( ord_less_eq @ A @ L @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L @ U2 ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U2 ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_4061_bot__nat__0_Oordering__top__axioms,axiom,
    ( ordering_top @ nat
    @ ^ [X2: nat,Y2: nat] : ( ord_less_eq @ nat @ Y2 @ X2 )
    @ ^ [X2: nat,Y2: nat] : ( ord_less @ nat @ Y2 @ X2 )
    @ ( zero_zero @ nat ) ) ).

% bot_nat_0.ordering_top_axioms
thf(fact_4062_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U2: A] :
          ( ( ord_less @ A @ L @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U2 ) @ ( insert @ A @ U2 @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L @ U2 ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_4063_divmod__cases,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B3: A,A4: A] :
          ( ( ( B3
             != ( zero_zero @ A ) )
           => ( ( ( modulo_modulo @ A @ A4 @ B3 )
                = ( zero_zero @ A ) )
             => ( A4
               != ( times_times @ A @ ( divide_divide @ A @ A4 @ B3 ) @ B3 ) ) ) )
         => ( ( ( B3
               != ( zero_zero @ A ) )
             => ! [Q10: A,R4: A] :
                  ( ( ( euclid7384307370059645450egment @ A @ R4 )
                    = ( euclid7384307370059645450egment @ A @ B3 ) )
                 => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R4 ) @ ( euclid6346220572633701492n_size @ A @ B3 ) )
                   => ( ( R4
                       != ( zero_zero @ A ) )
                     => ( ( ( divide_divide @ A @ A4 @ B3 )
                          = Q10 )
                       => ( ( ( modulo_modulo @ A @ A4 @ B3 )
                            = R4 )
                         => ( A4
                           != ( plus_plus @ A @ ( times_times @ A @ Q10 @ B3 ) @ R4 ) ) ) ) ) ) ) )
           => ( B3
              = ( zero_zero @ A ) ) ) ) ) ).

% divmod_cases
thf(fact_4064_mod__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B3: A,R5: A,Q4: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R5 )
              = ( euclid7384307370059645450egment @ A @ B3 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R5 ) @ ( euclid6346220572633701492n_size @ A @ B3 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q4 @ B3 ) @ R5 )
                  = A4 )
               => ( ( modulo_modulo @ A @ A4 @ B3 )
                  = R5 ) ) ) ) ) ) ).

% mod_eqI
thf(fact_4065_div__bounded,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B3: A,R5: A,Q4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R5 )
              = ( euclid7384307370059645450egment @ A @ B3 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R5 ) @ ( euclid6346220572633701492n_size @ A @ B3 ) )
             => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ Q4 @ B3 ) @ R5 ) @ B3 )
                = Q4 ) ) ) ) ) ).

% div_bounded
thf(fact_4066_div__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B3: A,R5: A,Q4: A,A4: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R5 )
              = ( euclid7384307370059645450egment @ A @ B3 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R5 ) @ ( euclid6346220572633701492n_size @ A @ B3 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q4 @ B3 ) @ R5 )
                  = A4 )
               => ( ( divide_divide @ A @ A4 @ B3 )
                  = Q4 ) ) ) ) ) ) ).

% div_eqI
thf(fact_4067_division__segment__1,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( euclid7384307370059645450egment @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% division_segment_1
thf(fact_4068_division__segment__numeral,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [K: num] :
          ( ( euclid7384307370059645450egment @ A @ ( numeral_numeral @ A @ K ) )
          = ( one_one @ A ) ) ) ).

% division_segment_numeral
thf(fact_4069_division__segment__of__nat,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( euclid7384307370059645450egment @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( one_one @ A ) ) ) ).

% division_segment_of_nat
thf(fact_4070_division__segment__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A4 ) @ ( semiring_1_of_nat @ A @ ( euclid6346220572633701492n_size @ A @ A4 ) ) )
          = A4 ) ) ).

% division_segment_euclidean_size
thf(fact_4071_division__segment__mult,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( B3
             != ( zero_zero @ A ) )
           => ( ( euclid7384307370059645450egment @ A @ ( times_times @ A @ A4 @ B3 ) )
              = ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A4 ) @ ( euclid7384307370059645450egment @ A @ B3 ) ) ) ) ) ) ).

% division_segment_mult
thf(fact_4072_is__unit__division__segment,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A4: A] : ( dvd_dvd @ A @ ( euclid7384307370059645450egment @ A @ A4 ) @ ( one_one @ A ) ) ) ).

% is_unit_division_segment
thf(fact_4073_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_4074_Max_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( lattic4895041142388067077er_set @ A @ ( ord_max @ A )
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% Max.semilattice_order_set_axioms
thf(fact_4075_set__to__map__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( set_to_map @ B @ A )
      = ( ^ [S7: set @ ( product_prod @ B @ A ),K6: B] :
            ( eps_Opt @ A
            @ ^ [V2: A] : ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K6 @ V2 ) @ S7 ) ) ) ) ).

% set_to_map_def
thf(fact_4076_Gcd__fin__def,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( bounde2362111253966948842tice_F @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ) ).

% Gcd_fin_def
thf(fact_4077_some__opt__eq__trivial,axiom,
    ! [A: $tType,X3: A] :
      ( ( eps_Opt @ A
        @ ^ [Y2: A] : ( Y2 = X3 ) )
      = ( some @ A @ X3 ) ) ).

% some_opt_eq_trivial
thf(fact_4078_some__opt__false__trivial,axiom,
    ! [A: $tType] :
      ( ( eps_Opt @ A
        @ ^ [Uu: A] : $false )
      = ( none @ A ) ) ).

% some_opt_false_trivial
thf(fact_4079_Inf__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( lattic4895041142388067077er_set @ A @ ( inf_inf @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% Inf_fin.semilattice_order_set_axioms
thf(fact_4080_Sup__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( lattic4895041142388067077er_set @ A @ ( sup_sup @ A )
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% Sup_fin.semilattice_order_set_axioms
thf(fact_4081_bounded__quasi__semilattice__set_Oremove,axiom,
    ! [A: $tType,F2: A > A > A,Top: A,Bot: A,Normalize: A > A,A4: A,A3: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F2 @ Top @ Bot @ Normalize )
     => ( ( member @ A @ A4 @ A3 )
       => ( ( bounde2362111253966948842tice_F @ A @ F2 @ Top @ Bot @ A3 )
          = ( F2 @ A4 @ ( bounde2362111253966948842tice_F @ A @ F2 @ Top @ Bot @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% bounded_quasi_semilattice_set.remove
thf(fact_4082_bounded__quasi__semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F2: A > A > A,Top: A,Bot: A,Normalize: A > A,A4: A,A3: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F2 @ Top @ Bot @ Normalize )
     => ( ( bounde2362111253966948842tice_F @ A @ F2 @ Top @ Bot @ ( insert @ A @ A4 @ A3 ) )
        = ( F2 @ A4 @ ( bounde2362111253966948842tice_F @ A @ F2 @ Top @ Bot @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% bounded_quasi_semilattice_set.insert_remove
thf(fact_4083_dom__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y: option @ B,F2: A > ( option @ B ),X3: A] :
      ( ( ( Y
          = ( none @ B ) )
       => ( ( dom @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F2 @ X3 @ Y ) )
          = ( minus_minus @ ( set @ A ) @ ( dom @ A @ B @ F2 ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
      & ( ( Y
         != ( none @ B ) )
       => ( ( dom @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F2 @ X3 @ Y ) )
          = ( insert @ A @ X3 @ ( dom @ A @ B @ F2 ) ) ) ) ) ).

% dom_fun_upd
thf(fact_4084_card__def,axiom,
    ! [B: $tType] :
      ( ( finite_card @ B )
      = ( finite_folding_F @ B @ nat
        @ ^ [Uu: B] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card_def
thf(fact_4085_dom__eq__empty__conv,axiom,
    ! [B: $tType,A: $tType,F2: A > ( option @ B )] :
      ( ( ( dom @ A @ B @ F2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( F2
        = ( ^ [X2: A] : ( none @ B ) ) ) ) ).

% dom_eq_empty_conv
thf(fact_4086_dom__restrict,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),A3: set @ A] :
      ( ( dom @ A @ B @ ( restrict_map @ A @ B @ M2 @ A3 ) )
      = ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M2 ) @ A3 ) ) ).

% dom_restrict
thf(fact_4087_dom__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( dom @ A @ B
        @ ^ [X2: A] : ( none @ B ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% dom_empty
thf(fact_4088_map__update__eta__repair_I1_J,axiom,
    ! [B: $tType,A: $tType,K: A,V: B,M2: A > ( option @ B )] :
      ( ( dom @ A @ B
        @ ^ [X2: A] : ( if @ ( option @ B ) @ ( X2 = K ) @ ( some @ B @ V ) @ ( M2 @ X2 ) ) )
      = ( insert @ A @ K @ ( dom @ A @ B @ M2 ) ) ) ).

% map_update_eta_repair(1)
thf(fact_4089_dom__const_H,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( dom @ A @ B
        @ ^ [X2: A] : ( some @ B @ ( F2 @ X2 ) ) )
      = ( top_top @ ( set @ A ) ) ) ).

% dom_const'
thf(fact_4090_dom__map__option,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: A > C > B,M2: A > ( option @ C )] :
      ( ( dom @ A @ B
        @ ^ [K6: A] : ( map_option @ C @ B @ ( F2 @ K6 ) @ ( M2 @ K6 ) ) )
      = ( dom @ A @ C @ M2 ) ) ).

% dom_map_option
thf(fact_4091_dom__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( dom @ A @ B )
      = ( ^ [M5: A > ( option @ B )] :
            ( collect @ A
            @ ^ [A5: A] :
                ( ( M5 @ A5 )
               != ( none @ B ) ) ) ) ) ).

% dom_def
thf(fact_4092_dom__if,axiom,
    ! [B: $tType,A: $tType,P: A > $o,F2: A > ( option @ B ),G: A > ( option @ B )] :
      ( ( dom @ A @ B
        @ ^ [X2: A] : ( if @ ( option @ B ) @ ( P @ X2 ) @ ( F2 @ X2 ) @ ( G @ X2 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ F2 ) @ ( collect @ A @ P ) )
        @ ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ G )
          @ ( collect @ A
            @ ^ [X2: A] :
                ~ ( P @ X2 ) ) ) ) ) ).

% dom_if
thf(fact_4093_restrict__map__eq_I1_J,axiom,
    ! [A: $tType,B: $tType,M2: B > ( option @ A ),A3: set @ B,K: B] :
      ( ( ( restrict_map @ B @ A @ M2 @ A3 @ K )
        = ( none @ A ) )
      = ( ~ ( member @ B @ K @ ( inf_inf @ ( set @ B ) @ ( dom @ B @ A @ M2 ) @ A3 ) ) ) ) ).

% restrict_map_eq(1)
thf(fact_4094_bounded__quasi__semilattice__set_Oempty,axiom,
    ! [A: $tType,F2: A > A > A,Top: A,Bot: A,Normalize: A > A] :
      ( ( bounde6485984586167503788ce_set @ A @ F2 @ Top @ Bot @ Normalize )
     => ( ( bounde2362111253966948842tice_F @ A @ F2 @ Top @ Bot @ ( bot_bot @ ( set @ A ) ) )
        = Top ) ) ).

% bounded_quasi_semilattice_set.empty
thf(fact_4095_finite__Map__induct,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),P: ( A > ( option @ B ) ) > $o] :
      ( ( finite_finite2 @ A @ ( dom @ A @ B @ M2 ) )
     => ( ( P
          @ ^ [X2: A] : ( none @ B ) )
       => ( ! [K2: A,V3: B,M3: A > ( option @ B )] :
              ( ( finite_finite2 @ A @ ( dom @ A @ B @ M3 ) )
             => ( ~ ( member @ A @ K2 @ ( dom @ A @ B @ M3 ) )
               => ( ( P @ M3 )
                 => ( P @ ( fun_upd @ A @ ( option @ B ) @ M3 @ K2 @ ( some @ B @ V3 ) ) ) ) ) )
         => ( P @ M2 ) ) ) ) ).

% finite_Map_induct
thf(fact_4096_dom__eq__singleton__conv,axiom,
    ! [A: $tType,B: $tType,F2: A > ( option @ B ),X3: A] :
      ( ( ( dom @ A @ B @ F2 )
        = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ? [V2: B] :
            ( F2
            = ( fun_upd @ A @ ( option @ B )
              @ ^ [X2: A] : ( none @ B )
              @ X3
              @ ( some @ B @ V2 ) ) ) ) ) ).

% dom_eq_singleton_conv
thf(fact_4097_dom__override__on,axiom,
    ! [B: $tType,A: $tType,F2: A > ( option @ B ),G: A > ( option @ B ),A3: set @ A] :
      ( ( dom @ A @ B @ ( override_on @ A @ ( option @ B ) @ F2 @ G @ A3 ) )
      = ( sup_sup @ ( set @ A )
        @ ( minus_minus @ ( set @ A ) @ ( dom @ A @ B @ F2 )
          @ ( collect @ A
            @ ^ [A5: A] : ( member @ A @ A5 @ ( minus_minus @ ( set @ A ) @ A3 @ ( dom @ A @ B @ G ) ) ) ) )
        @ ( collect @ A
          @ ^ [A5: A] : ( member @ A @ A5 @ ( inf_inf @ ( set @ A ) @ A3 @ ( dom @ A @ B @ G ) ) ) ) ) ) ).

% dom_override_on
thf(fact_4098_folding__on_Oremove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,A3: set @ A,X3: A,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( finite_finite2 @ A @ A3 )
         => ( ( member @ A @ X3 @ A3 )
           => ( ( finite_folding_F @ A @ B @ F2 @ Z2 @ A3 )
              = ( F2 @ X3 @ ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% folding_on.remove
thf(fact_4099_folding__on_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X3: A,A3: set @ A,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X3 @ A3 ) @ S2 )
       => ( ( finite_finite2 @ A @ A3 )
         => ( ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( insert @ A @ X3 @ A3 ) )
            = ( F2 @ X3 @ ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% folding_on.insert_remove
thf(fact_4100_ran__map__upd__Some,axiom,
    ! [B: $tType,A: $tType,M2: B > ( option @ A ),X3: B,Y: A,Z2: A] :
      ( ( ( M2 @ X3 )
        = ( some @ A @ Y ) )
     => ( ( inj_on @ B @ ( option @ A ) @ M2 @ ( dom @ B @ A @ M2 ) )
       => ( ~ ( member @ A @ Z2 @ ( ran @ B @ A @ M2 ) )
         => ( ( ran @ B @ A @ ( fun_upd @ B @ ( option @ A ) @ M2 @ X3 @ ( some @ A @ Z2 ) ) )
            = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( ran @ B @ A @ M2 ) @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Z2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% ran_map_upd_Some
thf(fact_4101_override__on__emptyset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G: A > B] :
      ( ( override_on @ A @ B @ F2 @ G @ ( bot_bot @ ( set @ A ) ) )
      = F2 ) ).

% override_on_emptyset
thf(fact_4102_ran__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ran @ B @ A
        @ ^ [X2: B] : ( none @ A ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% ran_empty
thf(fact_4103_map__update__eta__repair_I2_J,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),K: A,V: B] :
      ( ( ( M2 @ K )
        = ( none @ B ) )
     => ( ( ran @ A @ B
          @ ^ [X2: A] : ( if @ ( option @ B ) @ ( X2 = K ) @ ( some @ B @ V ) @ ( M2 @ X2 ) ) )
        = ( insert @ B @ V @ ( ran @ A @ B @ M2 ) ) ) ) ).

% map_update_eta_repair(2)
thf(fact_4104_ran__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ran @ A @ B )
      = ( ^ [M5: A > ( option @ B )] :
            ( collect @ B
            @ ^ [B4: B] :
              ? [A5: A] :
                ( ( M5 @ A5 )
                = ( some @ B @ B4 ) ) ) ) ) ).

% ran_def
thf(fact_4105_ran__map__option,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: C > A,M2: B > ( option @ C )] :
      ( ( ran @ B @ A
        @ ^ [X2: B] : ( map_option @ C @ A @ F2 @ ( M2 @ X2 ) ) )
      = ( image2 @ C @ A @ F2 @ ( ran @ B @ C @ M2 ) ) ) ).

% ran_map_option
thf(fact_4106_folding__on_Oempty,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: A > B > B,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F2 )
     => ( ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( bot_bot @ ( set @ A ) ) )
        = Z2 ) ) ).

% folding_on.empty
thf(fact_4107_card_Ofolding__on__axioms,axiom,
    ! [A: $tType] :
      ( finite_folding_on @ A @ nat @ ( top_top @ ( set @ A ) )
      @ ^ [Uu: A] : suc ) ).

% card.folding_on_axioms
thf(fact_4108_finite__set__of__finite__maps,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ B @ B2 )
       => ( finite_finite2 @ ( A > ( option @ B ) )
          @ ( collect @ ( A > ( option @ B ) )
            @ ^ [M5: A > ( option @ B )] :
                ( ( ( dom @ A @ B @ M5 )
                  = A3 )
                & ( ord_less_eq @ ( set @ B ) @ ( ran @ A @ B @ M5 ) @ B2 ) ) ) ) ) ) ).

% finite_set_of_finite_maps
thf(fact_4109_ran__add,axiom,
    ! [B: $tType,A: $tType,F2: A > ( option @ B ),G: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ F2 ) @ ( dom @ A @ B @ G ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( ran @ A @ B @ ( map_add @ A @ B @ F2 @ G ) )
        = ( sup_sup @ ( set @ B ) @ ( ran @ A @ B @ F2 ) @ ( ran @ A @ B @ G ) ) ) ) ).

% ran_add
thf(fact_4110_ran__map__add,axiom,
    ! [B: $tType,A: $tType,M1: A > ( option @ B ),M22: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M1 ) @ ( dom @ A @ B @ M22 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( ran @ A @ B @ ( map_add @ A @ B @ M1 @ M22 ) )
        = ( sup_sup @ ( set @ B ) @ ( ran @ A @ B @ M1 ) @ ( ran @ A @ B @ M22 ) ) ) ) ).

% ran_map_add
thf(fact_4111_graph__eq__to__snd__dom,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B )
      = ( ^ [M5: A > ( option @ B )] :
            ( image2 @ A @ ( product_prod @ A @ B )
            @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ ( the2 @ B @ ( M5 @ X2 ) ) )
            @ ( dom @ A @ B @ M5 ) ) ) ) ).

% graph_eq_to_snd_dom
thf(fact_4112_empty__eq__map__add__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > ( option @ B ),G: A > ( option @ B )] :
      ( ( ( ^ [X2: A] : ( none @ B ) )
        = ( map_add @ A @ B @ F2 @ G ) )
      = ( ( F2
          = ( ^ [X2: A] : ( none @ B ) ) )
        & ( G
          = ( ^ [X2: A] : ( none @ B ) ) ) ) ) ).

% empty_eq_map_add_iff
thf(fact_4113_map__add__empty,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B )] :
      ( ( map_add @ A @ B @ M2
        @ ^ [X2: A] : ( none @ B ) )
      = M2 ) ).

% map_add_empty
thf(fact_4114_empty__map__add,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B )] :
      ( ( map_add @ A @ B
        @ ^ [X2: A] : ( none @ B )
        @ M2 )
      = M2 ) ).

% empty_map_add
thf(fact_4115_graph__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B
        @ ^ [X2: A] : ( none @ B ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% graph_empty
thf(fact_4116_bot__filter__parametric,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o] : ( rel_filter @ A @ B @ A3 @ ( bot_bot @ ( filter @ A ) ) @ ( bot_bot @ ( filter @ B ) ) ) ).

% bot_filter_parametric
thf(fact_4117_graph__map__add,axiom,
    ! [B: $tType,A: $tType,M1: A > ( option @ B ),M22: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M1 ) @ ( dom @ A @ B @ M22 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( graph @ A @ B @ ( map_add @ A @ B @ M1 @ M22 ) )
        = ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ ( graph @ A @ B @ M1 ) @ ( graph @ A @ B @ M22 ) ) ) ) ).

% graph_map_add
thf(fact_4118_map__add__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_add @ A @ B )
      = ( ^ [M12: A > ( option @ B ),M23: A > ( option @ B ),X2: A] : ( case_option @ ( option @ B ) @ B @ ( M12 @ X2 ) @ ( some @ B ) @ ( M23 @ X2 ) ) ) ) ).

% map_add_def
thf(fact_4119_map__add__distinct__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( preorder @ B )
     => ! [M2: A > ( option @ B ),M7: A > ( option @ B ),N: A > ( option @ B ),N9: A > ( option @ B )] :
          ( ( ord_less_eq @ ( A > ( option @ B ) ) @ M2 @ M7 )
         => ( ( ord_less_eq @ ( A > ( option @ B ) ) @ N @ N9 )
           => ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M7 ) @ ( dom @ A @ B @ N9 ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ ( A > ( option @ B ) ) @ ( map_add @ A @ B @ M2 @ N ) @ ( map_add @ A @ B @ M7 @ N9 ) ) ) ) ) ) ).

% map_add_distinct_le
thf(fact_4120_map__add__comm,axiom,
    ! [B: $tType,A: $tType,M1: A > ( option @ B ),M22: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M1 ) @ ( dom @ A @ B @ M22 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( map_add @ A @ B @ M1 @ M22 )
        = ( map_add @ A @ B @ M22 @ M1 ) ) ) ).

% map_add_comm
thf(fact_4121_map__add__left__comm,axiom,
    ! [B: $tType,A: $tType,A3: A > ( option @ B ),B2: A > ( option @ B ),C3: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ A3 ) @ ( dom @ A @ B @ B2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( map_add @ A @ B @ A3 @ ( map_add @ A @ B @ B2 @ C3 ) )
        = ( map_add @ A @ B @ B2 @ ( map_add @ A @ B @ A3 @ C3 ) ) ) ) ).

% map_add_left_comm
thf(fact_4122_graph__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B )
      = ( ^ [M5: A > ( option @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu: product_prod @ A @ B] :
              ? [A5: A,B4: B] :
                ( ( Uu
                  = ( product_Pair @ A @ B @ A5 @ B4 ) )
                & ( ( M5 @ A5 )
                  = ( some @ B @ B4 ) ) ) ) ) ) ).

% graph_def
thf(fact_4123_graph__fun__upd__None,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),K: A] :
      ( ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M2 @ K @ ( none @ B ) ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [E5: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ E5 @ ( graph @ A @ B @ M2 ) )
            & ( ( product_fst @ A @ B @ E5 )
             != K ) ) ) ) ).

% graph_fun_upd_None
thf(fact_4124_rel__filter_Ocases,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,F: filter @ A,G4: filter @ B] :
      ( ( rel_filter @ A @ B @ R @ F @ G4 )
     => ~ ! [Z10: filter @ ( product_prod @ A @ B )] :
            ( ( eventually @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) @ Z10 )
           => ( ( ( map_filter_on @ ( product_prod @ A @ B ) @ A @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) @ ( product_fst @ A @ B ) @ Z10 )
                = F )
             => ( ( map_filter_on @ ( product_prod @ A @ B ) @ B @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) @ ( product_snd @ A @ B ) @ Z10 )
               != G4 ) ) ) ) ).

% rel_filter.cases
thf(fact_4125_rel__filter_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_filter @ A @ B )
      = ( ^ [R2: A > B > $o,F5: filter @ A,G7: filter @ B] :
          ? [Z7: filter @ ( product_prod @ A @ B )] :
            ( ( eventually @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) @ Z7 )
            & ( ( map_filter_on @ ( product_prod @ A @ B ) @ A @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) @ ( product_fst @ A @ B ) @ Z7 )
              = F5 )
            & ( ( map_filter_on @ ( product_prod @ A @ B ) @ B @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) @ ( product_snd @ A @ B ) @ Z7 )
              = G7 ) ) ) ) ).

% rel_filter.simps
thf(fact_4126_rel__filter_Ointros,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,Z6: filter @ ( product_prod @ A @ B ),F: filter @ A,G4: filter @ B] :
      ( ( eventually @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) @ Z6 )
     => ( ( ( map_filter_on @ ( product_prod @ A @ B ) @ A @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) @ ( product_fst @ A @ B ) @ Z6 )
          = F )
       => ( ( ( map_filter_on @ ( product_prod @ A @ B ) @ B @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) @ ( product_snd @ A @ B ) @ Z6 )
            = G4 )
         => ( rel_filter @ A @ B @ R @ F @ G4 ) ) ) ) ).

% rel_filter.intros
thf(fact_4127_arg__min__SOME__Min,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite2 @ A @ S2 )
         => ( ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 )
            = ( fChoice @ A
              @ ^ [Y2: A] :
                  ( ( member @ A @ Y2 @ S2 )
                  & ( ( F2 @ Y2 )
                    = ( lattic643756798350308766er_Min @ B @ ( image2 @ A @ B @ F2 @ S2 ) ) ) ) ) ) ) ) ).

% arg_min_SOME_Min
thf(fact_4128_map__comp__def,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( map_comp @ B @ C @ A )
      = ( ^ [F3: B > ( option @ C ),G2: A > ( option @ B ),K6: A] : ( case_option @ ( option @ C ) @ B @ ( none @ C ) @ F3 @ ( G2 @ K6 ) ) ) ) ).

% map_comp_def
thf(fact_4129_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [Uu: A] :
            ? [N5: int] :
              ( ( Uu
                = ( ring_1_of_int @ A @ N5 ) )
              & ( ord_less_eq @ int @ ( zero_zero @ int ) @ N5 ) ) ) ) ) ).

% Nats_altdef1
thf(fact_4130_cSup__cInf,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S2 )
           => ( ( complete_Sup_Sup @ A @ S2 )
              = ( complete_Inf_Inf @ A
                @ ( collect @ A
                  @ ^ [X2: A] :
                    ! [Y2: A] :
                      ( ( member @ A @ Y2 @ S2 )
                     => ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ) ) ) ) ) ).

% cSup_cInf
thf(fact_4131_some__sym__eq__trivial,axiom,
    ! [A: $tType,X3: A] :
      ( ( fChoice @ A
        @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
          @ X3 ) )
      = X3 ) ).

% some_sym_eq_trivial
thf(fact_4132_some__eq__trivial,axiom,
    ! [A: $tType,X3: A] :
      ( ( fChoice @ A
        @ ^ [Y2: A] : ( Y2 = X3 ) )
      = X3 ) ).

% some_eq_trivial
thf(fact_4133_some__equality,axiom,
    ! [A: $tType,P: A > $o,A4: A] :
      ( ( P @ A4 )
     => ( ! [X: A] :
            ( ( P @ X )
           => ( X = A4 ) )
       => ( ( fChoice @ A @ P )
          = A4 ) ) ) ).

% some_equality
thf(fact_4134_ball__empty,axiom,
    ! [A: $tType,P: A > $o,X4: A] :
      ( ( member @ A @ X4 @ ( bot_bot @ ( set @ A ) ) )
     => ( P @ X4 ) ) ).

% ball_empty
thf(fact_4135_Eps__case__prod__eq,axiom,
    ! [A: $tType,B: $tType,X3: A,Y: B] :
      ( ( fChoice @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X6: A,Y6: B] :
              ( ( X3 = X6 )
              & ( Y = Y6 ) ) ) )
      = ( product_Pair @ A @ B @ X3 @ Y ) ) ).

% Eps_case_prod_eq
thf(fact_4136_map__comp__empty_I1_J,axiom,
    ! [C: $tType,B: $tType,A: $tType,M2: C > ( option @ B )] :
      ( ( map_comp @ C @ B @ A @ M2
        @ ^ [X2: A] : ( none @ C ) )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% map_comp_empty(1)
thf(fact_4137_map__comp__empty_I2_J,axiom,
    ! [B: $tType,D: $tType,C: $tType,M2: C > ( option @ B )] :
      ( ( map_comp @ B @ D @ C
        @ ^ [X2: B] : ( none @ D )
        @ M2 )
      = ( ^ [X2: C] : ( none @ D ) ) ) ).

% map_comp_empty(2)
thf(fact_4138_some__insert__self,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( insert @ A
          @ ( fChoice @ A
            @ ^ [X2: A] : ( member @ A @ X2 @ S2 ) )
          @ S2 )
        = S2 ) ) ).

% some_insert_self
thf(fact_4139_INF__bool__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [A6: set @ A,F3: A > $o] : ( complete_Inf_Inf @ $o @ ( image2 @ A @ $o @ F3 @ A6 ) ) )
      = ( ball @ A ) ) ).

% INF_bool_eq
thf(fact_4140_Ball__fold,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ! [X2: A] :
              ( ( member @ A @ X2 @ A3 )
             => ( P @ X2 ) ) )
        = ( finite_fold @ A @ $o
          @ ^ [K6: A,S: $o] :
              ( S
              & ( P @ K6 ) )
          @ $true
          @ A3 ) ) ) ).

% Ball_fold
thf(fact_4141_someI2,axiom,
    ! [A: $tType,P: A > $o,A4: A,Q: A > $o] :
      ( ( P @ A4 )
     => ( ! [X: A] :
            ( ( P @ X )
           => ( Q @ X ) )
       => ( Q @ ( fChoice @ A @ P ) ) ) ) ).

% someI2
thf(fact_4142_someI__ex,axiom,
    ! [A: $tType,P: A > $o] :
      ( ? [X_12: A] : ( P @ X_12 )
     => ( P @ ( fChoice @ A @ P ) ) ) ).

% someI_ex
thf(fact_4143_someI2__ex,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ? [X_12: A] : ( P @ X_12 )
     => ( ! [X: A] :
            ( ( P @ X )
           => ( Q @ X ) )
       => ( Q @ ( fChoice @ A @ P ) ) ) ) ).

% someI2_ex
thf(fact_4144_someI2__bex,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o,Q: A > $o] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ A3 )
          & ( P @ X4 ) )
     => ( ! [X: A] :
            ( ( ( member @ A @ X @ A3 )
              & ( P @ X ) )
           => ( Q @ X ) )
       => ( Q
          @ ( fChoice @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A3 )
                & ( P @ X2 ) ) ) ) ) ) ).

% someI2_bex
thf(fact_4145_some__eq__ex,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X7: A] : ( P @ X7 ) ) ) ).

% some_eq_ex
thf(fact_4146_some1__equality,axiom,
    ! [A: $tType,P: A > $o,A4: A] :
      ( ? [X4: A] :
          ( ( P @ X4 )
          & ! [Y3: A] :
              ( ( P @ Y3 )
             => ( Y3 = X4 ) ) )
     => ( ( P @ A4 )
       => ( ( fChoice @ A @ P )
          = A4 ) ) ) ).

% some1_equality
thf(fact_4147_verit__sko__ex_H,axiom,
    ! [A: $tType,P: A > $o,A3: $o] :
      ( ( ( P @ ( fChoice @ A @ P ) )
        = A3 )
     => ( ( ? [X7: A] : ( P @ X7 ) )
        = A3 ) ) ).

% verit_sko_ex'
thf(fact_4148_verit__sko__forall,axiom,
    ! [A: $tType] :
      ( ( ^ [P9: A > $o] :
          ! [X9: A] : ( P9 @ X9 ) )
      = ( ^ [P3: A > $o] :
            ( P3
            @ ( fChoice @ A
              @ ^ [X2: A] :
                  ~ ( P3 @ X2 ) ) ) ) ) ).

% verit_sko_forall
thf(fact_4149_verit__sko__forall_H,axiom,
    ! [A: $tType,P: A > $o,A3: $o] :
      ( ( ( P
          @ ( fChoice @ A
            @ ^ [X2: A] :
                ~ ( P @ X2 ) ) )
        = A3 )
     => ( ( ! [X7: A] : ( P @ X7 ) )
        = A3 ) ) ).

% verit_sko_forall'
thf(fact_4150_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B2: A,A3: A,P: A > $o] :
      ( ( B2 = A3 )
     => ( ( ( fChoice @ A @ P )
          = A3 )
        = ( ( fChoice @ A @ P )
          = B2 ) ) ) ).

% verit_sko_forall''
thf(fact_4151_verit__sko__ex__indirect,axiom,
    ! [A: $tType,X3: A,P: A > $o] :
      ( ( X3
        = ( fChoice @ A @ P ) )
     => ( ( ? [X7: A] : ( P @ X7 ) )
        = ( P @ X3 ) ) ) ).

% verit_sko_ex_indirect
thf(fact_4152_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,X3: A,P: A > $o,P2: A > $o] :
      ( ( X3
        = ( fChoice @ A @ P ) )
     => ( ! [X: A] :
            ( ( P @ X )
            = ( P2 @ X ) )
       => ( ( ? [X7: A] : ( P2 @ X7 ) )
          = ( P @ X3 ) ) ) ) ).

% verit_sko_ex_indirect2
thf(fact_4153_verit__sko__forall__indirect,axiom,
    ! [A: $tType,X3: A,P: A > $o] :
      ( ( X3
        = ( fChoice @ A
          @ ^ [X2: A] :
              ~ ( P @ X2 ) ) )
     => ( ( ! [X7: A] : ( P @ X7 ) )
        = ( P @ X3 ) ) ) ).

% verit_sko_forall_indirect
thf(fact_4154_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,X3: A,P: A > $o,P2: A > $o] :
      ( ( X3
        = ( fChoice @ A
          @ ^ [X2: A] :
              ~ ( P @ X2 ) ) )
     => ( ! [X: A] :
            ( ( P @ X )
            = ( P2 @ X ) )
       => ( ( ! [X7: A] : ( P2 @ X7 ) )
          = ( P @ X3 ) ) ) ) ).

% verit_sko_forall_indirect2
thf(fact_4155_Inter__eq,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( set @ A ) )
      = ( ^ [A6: set @ ( set @ A )] :
            ( collect @ A
            @ ^ [X2: A] :
              ! [Y2: set @ A] :
                ( ( member @ ( set @ A ) @ Y2 @ A6 )
               => ( member @ A @ X2 @ Y2 ) ) ) ) ) ).

% Inter_eq
thf(fact_4156_some__elem,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ A ) ) )
     => ( member @ A
        @ ( fChoice @ A
          @ ^ [X2: A] : ( member @ A @ X2 @ S2 ) )
        @ S2 ) ) ).

% some_elem
thf(fact_4157_some__in__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( member @ A
        @ ( fChoice @ A
          @ ^ [X2: A] : ( member @ A @ X2 @ A3 ) )
        @ A3 )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% some_in_eq
thf(fact_4158_Ball__comp__iff,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: B > ( set @ C ),F2: C > $o,G: A > B] :
      ( ( comp @ B @ $o @ A
        @ ^ [X2: B] :
          ! [Y2: C] :
            ( ( member @ C @ Y2 @ ( A3 @ X2 ) )
           => ( F2 @ Y2 ) )
        @ G )
      = ( ^ [X2: A] :
          ! [Y2: C] :
            ( ( member @ C @ Y2 @ ( comp @ B @ ( set @ C ) @ A @ A3 @ G @ X2 ) )
           => ( F2 @ Y2 ) ) ) ) ).

% Ball_comp_iff
thf(fact_4159_Nats__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A4: A,B3: A] :
          ( ( member @ A @ A4 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B3 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( times_times @ A @ A4 @ B3 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_mult
thf(fact_4160_Nats__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_1
thf(fact_4161_eventually__ball__finite__distrib,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,P: B > A > $o,Net: filter @ B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( eventually @ B
          @ ^ [X2: B] :
            ! [Y2: A] :
              ( ( member @ A @ Y2 @ A3 )
             => ( P @ X2 @ Y2 ) )
          @ Net )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ A3 )
             => ( eventually @ B
                @ ^ [Y2: B] : ( P @ Y2 @ X2 )
                @ Net ) ) ) ) ) ).

% eventually_ball_finite_distrib
thf(fact_4162_eventually__ball__finite,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,P: B > A > $o,Net: filter @ B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ! [X: A] :
            ( ( member @ A @ X @ A3 )
           => ( eventually @ B
              @ ^ [Y2: B] : ( P @ Y2 @ X )
              @ Net ) )
       => ( eventually @ B
          @ ^ [X2: B] :
            ! [Y2: A] :
              ( ( member @ A @ Y2 @ A3 )
             => ( P @ X2 @ Y2 ) )
          @ Net ) ) ) ).

% eventually_ball_finite
thf(fact_4163_Field__not__elem,axiom,
    ! [A: $tType,V: A,R: set @ ( product_prod @ A @ A )] :
      ( ~ ( member @ A @ V @ ( field2 @ A @ R ) )
     => ! [X4: product_prod @ A @ A] :
          ( ( member @ ( product_prod @ A @ A ) @ X4 @ R )
         => ( product_case_prod @ A @ A @ $o
            @ ^ [Y2: A,Z3: A] :
                ( ( Y2 != V )
                & ( Z3 != V ) )
            @ X4 ) ) ) ).

% Field_not_elem
thf(fact_4164_Collect__ball__eq,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,P: A > B > $o] :
      ( ( collect @ A
        @ ^ [X2: A] :
          ! [Y2: B] :
            ( ( member @ B @ Y2 @ A3 )
           => ( P @ X2 @ Y2 ) ) )
      = ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [Y2: B] :
              ( collect @ A
              @ ^ [X2: A] : ( P @ X2 @ Y2 ) )
          @ A3 ) ) ) ).

% Collect_ball_eq
thf(fact_4165_INTER__eq,axiom,
    ! [B: $tType,A: $tType,B2: B > ( set @ A ),A3: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) )
      = ( collect @ A
        @ ^ [Y2: A] :
          ! [X2: B] :
            ( ( member @ B @ X2 @ A3 )
           => ( member @ A @ Y2 @ ( B2 @ X2 ) ) ) ) ) ).

% INTER_eq
thf(fact_4166_split__paired__Eps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( fChoice @ ( product_prod @ A @ B ) )
      = ( ^ [P3: ( product_prod @ A @ B ) > $o] :
            ( fChoice @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A5: A,B4: B] : ( P3 @ ( product_Pair @ A @ B @ A5 @ B4 ) ) ) ) ) ) ).

% split_paired_Eps
thf(fact_4167_irrefl__distinct,axiom,
    ! [A: $tType] :
      ( ( irrefl @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
          ! [X2: product_prod @ A @ A] :
            ( ( member @ ( product_prod @ A @ A ) @ X2 @ R3 )
           => ( product_case_prod @ A @ A @ $o
              @ ^ [A5: A,B4: A] : ( A5 != B4 )
              @ X2 ) ) ) ) ).

% irrefl_distinct
thf(fact_4168_some__theI,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o] :
      ( ? [A16: A,X_12: B] : ( P @ A16 @ X_12 )
     => ( ! [B15: B,B25: B] :
            ( ? [A7: A] : ( P @ A7 @ B15 )
           => ( ? [A7: A] : ( P @ A7 @ B25 )
             => ( B15 = B25 ) ) )
       => ( P
          @ ( fChoice @ A
            @ ^ [A5: A] :
              ? [X7: B] : ( P @ A5 @ X7 ) )
          @ ( the @ B
            @ ^ [B4: B] :
              ? [A5: A] : ( P @ A5 @ B4 ) ) ) ) ) ).

% some_theI
thf(fact_4169_congruent__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( equiv_congruent @ A @ B )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),F3: A > B] :
          ! [X2: product_prod @ A @ A] :
            ( ( member @ ( product_prod @ A @ A ) @ X2 @ R3 )
           => ( product_case_prod @ A @ A @ $o
              @ ^ [Y2: A,Z3: A] :
                  ( ( F3 @ Y2 )
                  = ( F3 @ Z3 ) )
              @ X2 ) ) ) ) ).

% congruent_def
thf(fact_4170_congruent2__def,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( equiv_congruent2 @ A @ B @ C )
      = ( ^ [R13: set @ ( product_prod @ A @ A ),R24: set @ ( product_prod @ B @ B ),F3: A > B > C] :
          ! [X2: product_prod @ A @ A] :
            ( ( member @ ( product_prod @ A @ A ) @ X2 @ R13 )
           => ( product_case_prod @ A @ A @ $o
              @ ^ [Y12: A,Z1: A] :
                ! [Y2: product_prod @ B @ B] :
                  ( ( member @ ( product_prod @ B @ B ) @ Y2 @ R24 )
                 => ( product_case_prod @ B @ B @ $o
                    @ ^ [Y23: B,Z22: B] :
                        ( ( F3 @ Y12 @ Y23 )
                        = ( F3 @ Z1 @ Z22 ) )
                    @ Y2 ) )
              @ X2 ) ) ) ) ).

% congruent2_def
thf(fact_4171_equiv__Eps__in,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X5: set @ A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A3 @ R5 ) )
       => ( member @ A
          @ ( fChoice @ A
            @ ^ [X2: A] : ( member @ A @ X2 @ X5 ) )
          @ X5 ) ) ) ).

% equiv_Eps_in
thf(fact_4172_equiv__Eps__preserves,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X5: set @ A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A3 @ R5 ) )
       => ( member @ A
          @ ( fChoice @ A
            @ ^ [X2: A] : ( member @ A @ X2 @ X5 ) )
          @ A3 ) ) ) ).

% equiv_Eps_preserves
thf(fact_4173_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A6: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                   => ( ord_less_eq @ A @ X2 @ B4 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_4174_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A6: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                   => ( ord_less_eq @ A @ B4 @ X2 ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_4175_trans__join,axiom,
    ! [A: $tType] :
      ( ( trans @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
          ! [X2: product_prod @ A @ A] :
            ( ( member @ ( product_prod @ A @ A ) @ X2 @ R3 )
           => ( product_case_prod @ A @ A @ $o
              @ ^ [Y2: A,Y12: A] :
                ! [Z3: product_prod @ A @ A] :
                  ( ( member @ ( product_prod @ A @ A ) @ Z3 @ R3 )
                 => ( product_case_prod @ A @ A @ $o
                    @ ^ [Y23: A,Aa2: A] :
                        ( ( Y12 = Y23 )
                       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Aa2 ) @ R3 ) )
                    @ Z3 ) )
              @ X2 ) ) ) ) ).

% trans_join
thf(fact_4176_refl__on__def_H,axiom,
    ! [A: $tType] :
      ( ( refl_on @ A )
      = ( ^ [A6: set @ A,R3: set @ ( product_prod @ A @ A )] :
            ( ! [X2: product_prod @ A @ A] :
                ( ( member @ ( product_prod @ A @ A ) @ X2 @ R3 )
               => ( product_case_prod @ A @ A @ $o
                  @ ^ [Y2: A,Z3: A] :
                      ( ( member @ A @ Y2 @ A6 )
                      & ( member @ A @ Z3 @ A6 ) )
                  @ X2 ) )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ A6 )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R3 ) ) ) ) ) ).

% refl_on_def'
thf(fact_4177_Sup__int__def,axiom,
    ( ( complete_Sup_Sup @ int )
    = ( ^ [X7: set @ int] :
          ( the @ int
          @ ^ [X2: int] :
              ( ( member @ int @ X2 @ X7 )
              & ! [Y2: int] :
                  ( ( member @ int @ Y2 @ X7 )
                 => ( ord_less_eq @ int @ Y2 @ X2 ) ) ) ) ) ) ).

% Sup_int_def
thf(fact_4178_arg__min__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattices_ord_arg_min @ B @ A )
        = ( ^ [F3: B > A,P3: B > $o] : ( fChoice @ B @ ( lattic501386751177426532rg_min @ B @ A @ F3 @ P3 ) ) ) ) ) ).

% arg_min_def
thf(fact_4179_Eps__case__prod,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o] :
      ( ( fChoice @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) )
      = ( fChoice @ ( product_prod @ A @ B )
        @ ^ [Xy: product_prod @ A @ B] : ( P @ ( product_fst @ A @ B @ Xy ) @ ( product_snd @ A @ B @ Xy ) ) ) ) ).

% Eps_case_prod
thf(fact_4180_Union__maximal__sets,axiom,
    ! [A: $tType,F16: set @ ( set @ A )] :
      ( ( finite_finite2 @ ( set @ A ) @ F16 )
     => ( ( complete_Sup_Sup @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [T7: set @ A] :
                ( ( member @ ( set @ A ) @ T7 @ F16 )
                & ! [X2: set @ A] :
                    ( ( member @ ( set @ A ) @ X2 @ F16 )
                   => ~ ( ord_less @ ( set @ A ) @ T7 @ X2 ) ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ F16 ) ) ) ).

% Union_maximal_sets
thf(fact_4181_Sup__Inf,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A ) @ A3 ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu
                      = ( image2 @ ( set @ A ) @ A @ F3 @ A3 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A3 )
                       => ( member @ A @ ( F3 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% Sup_Inf
thf(fact_4182_Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu
                      = ( image2 @ ( set @ A ) @ A @ F3 @ A3 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A3 )
                       => ( member @ A @ ( F3 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% Inf_Sup
thf(fact_4183_Inf__filter__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( filter @ A ) )
      = ( ^ [S7: set @ ( filter @ A )] :
            ( complete_Sup_Sup @ ( filter @ A )
            @ ( collect @ ( filter @ A )
              @ ^ [F5: filter @ A] :
                ! [X2: filter @ A] :
                  ( ( member @ ( filter @ A ) @ X2 @ S7 )
                 => ( ord_less_eq @ ( filter @ A ) @ F5 @ X2 ) ) ) ) ) ) ).

% Inf_filter_def
thf(fact_4184_proj__Eps,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A ),X5: set @ A] :
      ( ( equiv_equiv @ A @ A3 @ R5 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A3 @ R5 ) )
       => ( ( equiv_proj @ A @ A @ R5
            @ ( fChoice @ A
              @ ^ [X2: A] : ( member @ A @ X2 @ X5 ) ) )
          = X5 ) ) ) ).

% proj_Eps
thf(fact_4185_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image2 @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu
                      = ( image2 @ ( set @ A ) @ A @ F3 @ A3 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A3 )
                       => ( member @ A @ ( F3 @ X2 ) @ X2 ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image2 @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) ) ) ) ).

% Sup_Inf_le
thf(fact_4186_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image2 @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu
                      = ( image2 @ ( set @ A ) @ A @ F3 @ A3 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A3 )
                       => ( member @ A @ ( F3 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_4187_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image2 @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu
                      = ( image2 @ ( set @ A ) @ A @ F3 @ A3 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A3 )
                       => ( member @ A @ ( F3 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_4188_INF__SUP__set,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [G: B > A,A3: set @ ( set @ B )] :
          ( ( complete_Inf_Inf @ A
            @ ( image2 @ ( set @ B ) @ A
              @ ^ [B5: set @ B] : ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ G @ B5 ) )
              @ A3 ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ ( set @ B ) @ A
              @ ^ [B5: set @ B] : ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ B5 ) )
              @ ( collect @ ( set @ B )
                @ ^ [Uu: set @ B] :
                  ? [F3: ( set @ B ) > B] :
                    ( ( Uu
                      = ( image2 @ ( set @ B ) @ B @ F3 @ A3 ) )
                    & ! [X2: set @ B] :
                        ( ( member @ ( set @ B ) @ X2 @ A3 )
                       => ( member @ B @ ( F3 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% INF_SUP_set
thf(fact_4189_SUP__INF__set,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [G: B > A,A3: set @ ( set @ B )] :
          ( ( complete_Sup_Sup @ A
            @ ( image2 @ ( set @ B ) @ A
              @ ^ [X2: set @ B] : ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ X2 ) )
              @ A3 ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ ( set @ B ) @ A
              @ ^ [X2: set @ B] : ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ G @ X2 ) )
              @ ( collect @ ( set @ B )
                @ ^ [Uu: set @ B] :
                  ? [F3: ( set @ B ) > B] :
                    ( ( Uu
                      = ( image2 @ ( set @ B ) @ B @ F3 @ A3 ) )
                    & ! [X2: set @ B] :
                        ( ( member @ ( set @ B ) @ X2 @ A3 )
                       => ( member @ B @ ( F3 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% SUP_INF_set
thf(fact_4190_option__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ ( option @ A ) )] :
          ( ord_less_eq @ ( option @ A ) @ ( complete_Inf_Inf @ ( option @ A ) @ ( image2 @ ( set @ ( option @ A ) ) @ ( option @ A ) @ ( complete_Sup_Sup @ ( option @ A ) ) @ A3 ) )
          @ ( complete_Sup_Sup @ ( option @ A )
            @ ( image2 @ ( set @ ( option @ A ) ) @ ( option @ A ) @ ( complete_Inf_Inf @ ( option @ A ) )
              @ ( collect @ ( set @ ( option @ A ) )
                @ ^ [Uu: set @ ( option @ A )] :
                  ? [F3: ( set @ ( option @ A ) ) > ( option @ A )] :
                    ( ( Uu
                      = ( image2 @ ( set @ ( option @ A ) ) @ ( option @ A ) @ F3 @ A3 ) )
                    & ! [X2: set @ ( option @ A )] :
                        ( ( member @ ( set @ ( option @ A ) ) @ X2 @ A3 )
                       => ( member @ ( option @ A ) @ ( F3 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% option_Inf_Sup
thf(fact_4191_Eps__Opt__def,axiom,
    ! [A: $tType] :
      ( ( eps_Opt @ A )
      = ( ^ [P3: A > $o] :
            ( if @ ( option @ A )
            @ ? [X7: A] : ( P3 @ X7 )
            @ ( some @ A @ ( fChoice @ A @ P3 ) )
            @ ( none @ A ) ) ) ) ).

% Eps_Opt_def
thf(fact_4192_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [N5: A] :
              ( ( member @ A @ N5 @ ( ring_1_Ints @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ N5 ) ) ) ) ) ).

% Nats_altdef2
thf(fact_4193_cInf__cSup,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S2 )
           => ( ( complete_Inf_Inf @ A @ S2 )
              = ( complete_Sup_Sup @ A
                @ ( collect @ A
                  @ ^ [X2: A] :
                    ! [Y2: A] :
                      ( ( member @ A @ Y2 @ S2 )
                     => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ) ) ) ) ).

% cInf_cSup
thf(fact_4194_Under__def,axiom,
    ! [A: $tType] :
      ( ( order_Under @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),A6: set @ A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( member @ A @ B4 @ ( field2 @ A @ R3 ) )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                   => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ X2 ) @ R3 ) ) ) ) ) ) ).

% Under_def
thf(fact_4195_UnderS__def,axiom,
    ! [A: $tType] :
      ( ( order_UnderS @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),A6: set @ A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( member @ A @ B4 @ ( field2 @ A @ R3 ) )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                   => ( ( B4 != X2 )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ X2 ) @ R3 ) ) ) ) ) ) ) ).

% UnderS_def
thf(fact_4196_Above__def,axiom,
    ! [A: $tType] :
      ( ( order_Above @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),A6: set @ A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( member @ A @ B4 @ ( field2 @ A @ R3 ) )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                   => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ B4 ) @ R3 ) ) ) ) ) ) ).

% Above_def
thf(fact_4197_fun__of__rel__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( fun_of_rel @ B @ A )
      = ( ^ [R2: set @ ( product_prod @ B @ A ),X2: B] :
            ( fChoice @ A
            @ ^ [Y2: A] : ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y2 ) @ R2 ) ) ) ) ).

% fun_of_rel_def
thf(fact_4198_conj__comp__iff,axiom,
    ! [B: $tType,A: $tType,P: B > $o,Q: B > $o,G: A > B] :
      ( ( comp @ B @ $o @ A
        @ ^ [X2: B] :
            ( ( P @ X2 )
            & ( Q @ X2 ) )
        @ G )
      = ( ^ [X2: A] :
            ( ( comp @ B @ $o @ A @ P @ G @ X2 )
            & ( comp @ B @ $o @ A @ Q @ G @ X2 ) ) ) ) ).

% conj_comp_iff
thf(fact_4199_iteratesp_Omono,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [F2: A > A] :
          ( order_mono @ ( A > $o ) @ ( A > $o )
          @ ^ [P6: A > $o,X2: A] :
              ( ? [Y2: A] :
                  ( ( X2
                    = ( F2 @ Y2 ) )
                  & ( P6 @ Y2 ) )
              | ? [M8: set @ A] :
                  ( ( X2
                    = ( complete_Sup_Sup @ A @ M8 ) )
                  & ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ M8 )
                  & ! [Y2: A] :
                      ( ( member @ A @ Y2 @ M8 )
                     => ( P6 @ Y2 ) ) ) ) ) ) ).

% iteratesp.mono
thf(fact_4200_Sup__filter__def,axiom,
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( filter @ A ) )
      = ( ^ [S7: set @ ( filter @ A )] :
            ( abs_filter @ A
            @ ^ [P3: A > $o] :
              ! [X2: filter @ A] :
                ( ( member @ ( filter @ A ) @ X2 @ S7 )
               => ( eventually @ A @ P3 @ X2 ) ) ) ) ) ).

% Sup_filter_def
thf(fact_4201_min__ext__def,axiom,
    ! [A: $tType] :
      ( ( min_ext @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
            @ ^ [Uu: product_prod @ ( set @ A ) @ ( set @ A )] :
              ? [X7: set @ A,Y9: set @ A] :
                ( ( Uu
                  = ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X7 @ Y9 ) )
                & ( X7
                 != ( bot_bot @ ( set @ A ) ) )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ Y9 )
                   => ? [Y2: A] :
                        ( ( member @ A @ Y2 @ X7 )
                        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X2 ) @ R3 ) ) ) ) ) ) ) ).

% min_ext_def
thf(fact_4202_AboveS__def,axiom,
    ! [A: $tType] :
      ( ( order_AboveS @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),A6: set @ A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( member @ A @ B4 @ ( field2 @ A @ R3 ) )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                   => ( ( B4 != X2 )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ B4 ) @ R3 ) ) ) ) ) ) ) ).

% AboveS_def
thf(fact_4203_bex__empty,axiom,
    ! [A: $tType,P: A > $o] :
      ~ ? [X4: A] :
          ( ( member @ A @ X4 @ ( bot_bot @ ( set @ A ) ) )
          & ( P @ X4 ) ) ).

% bex_empty
thf(fact_4204_finite__Collect__bex,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,Q: B > A > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ B
          @ ( collect @ B
            @ ^ [X2: B] :
              ? [Y2: A] :
                ( ( member @ A @ Y2 @ A3 )
                & ( Q @ X2 @ Y2 ) ) ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ A3 )
             => ( finite_finite2 @ B
                @ ( collect @ B
                  @ ^ [Y2: B] : ( Q @ Y2 @ X2 ) ) ) ) ) ) ) ).

% finite_Collect_bex
thf(fact_4205_Image__Collect__case__prod,axiom,
    ! [B: $tType,A: $tType,P: B > A > $o,A3: set @ B] :
      ( ( image @ B @ A @ ( collect @ ( product_prod @ B @ A ) @ ( product_case_prod @ B @ A @ $o @ P ) ) @ A3 )
      = ( collect @ A
        @ ^ [Y2: A] :
          ? [X2: B] :
            ( ( member @ B @ X2 @ A3 )
            & ( P @ X2 @ Y2 ) ) ) ) ).

% Image_Collect_case_prod
thf(fact_4206_SUP__bool__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [A6: set @ A,F3: A > $o] : ( complete_Sup_Sup @ $o @ ( image2 @ A @ $o @ F3 @ A6 ) ) )
      = ( bex @ A ) ) ).

% SUP_bool_eq
thf(fact_4207_image__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( image2 @ A @ B )
      = ( ^ [F3: A > B,A6: set @ A] :
            ( collect @ B
            @ ^ [Y2: B] :
              ? [X2: A] :
                ( ( member @ A @ X2 @ A6 )
                & ( Y2
                  = ( F3 @ X2 ) ) ) ) ) ) ).

% image_def
thf(fact_4208_Union__eq,axiom,
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( set @ A ) )
      = ( ^ [A6: set @ ( set @ A )] :
            ( collect @ A
            @ ^ [X2: A] :
              ? [Y2: set @ A] :
                ( ( member @ ( set @ A ) @ Y2 @ A6 )
                & ( member @ A @ X2 @ Y2 ) ) ) ) ) ).

% Union_eq
thf(fact_4209_chain__compr,axiom,
    ! [A: $tType,Ord: A > A > $o,A3: set @ A,P: A > $o] :
      ( ( comple1602240252501008431_chain @ A @ Ord @ A3 )
     => ( comple1602240252501008431_chain @ A @ Ord
        @ ( collect @ A
          @ ^ [X2: A] :
              ( ( member @ A @ X2 @ A3 )
              & ( P @ X2 ) ) ) ) ) ).

% chain_compr
thf(fact_4210_chain__empty,axiom,
    ! [A: $tType,Ord: A > A > $o] : ( comple1602240252501008431_chain @ A @ Ord @ ( bot_bot @ ( set @ A ) ) ) ).

% chain_empty
thf(fact_4211_Bex__def__raw,axiom,
    ! [A: $tType] :
      ( ( bex @ A )
      = ( ^ [A6: set @ A,P3: A > $o] :
          ? [X2: A] :
            ( ( member @ A @ X2 @ A6 )
            & ( P3 @ X2 ) ) ) ) ).

% Bex_def_raw
thf(fact_4212_sup__filter__def,axiom,
    ! [A: $tType] :
      ( ( sup_sup @ ( filter @ A ) )
      = ( ^ [F5: filter @ A,F6: filter @ A] :
            ( abs_filter @ A
            @ ^ [P3: A > $o] :
                ( ( eventually @ A @ P3 @ F5 )
                & ( eventually @ A @ P3 @ F6 ) ) ) ) ) ).

% sup_filter_def
thf(fact_4213_bot__filter__def,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( filter @ A ) )
      = ( abs_filter @ A
        @ ^ [P3: A > $o] : $true ) ) ).

% bot_filter_def
thf(fact_4214_Image__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( image @ A @ B )
      = ( ^ [R3: set @ ( product_prod @ A @ B ),S: set @ A] :
            ( collect @ B
            @ ^ [Y2: B] :
              ? [X2: A] :
                ( ( member @ A @ X2 @ S )
                & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R3 ) ) ) ) ) ).

% Image_def
thf(fact_4215_Collect__bex__eq,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,P: A > B > $o] :
      ( ( collect @ A
        @ ^ [X2: A] :
          ? [Y2: B] :
            ( ( member @ B @ Y2 @ A3 )
            & ( P @ X2 @ Y2 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [Y2: B] :
              ( collect @ A
              @ ^ [X2: A] : ( P @ X2 @ Y2 ) )
          @ A3 ) ) ) ).

% Collect_bex_eq
thf(fact_4216_UNION__eq,axiom,
    ! [B: $tType,A: $tType,B2: B > ( set @ A ),A3: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B2 @ A3 ) )
      = ( collect @ A
        @ ^ [Y2: A] :
          ? [X2: B] :
            ( ( member @ B @ X2 @ A3 )
            & ( member @ A @ Y2 @ ( B2 @ X2 ) ) ) ) ) ).

% UNION_eq
thf(fact_4217_vimage__image__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A] :
      ( ( vimage @ A @ B @ F2 @ ( image2 @ A @ B @ F2 @ A3 ) )
      = ( collect @ A
        @ ^ [Y2: A] :
          ? [X2: A] :
            ( ( member @ A @ X2 @ A3 )
            & ( ( F2 @ X2 )
              = ( F2 @ Y2 ) ) ) ) ) ).

% vimage_image_eq
thf(fact_4218_chain__singleton,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [X3: A] : ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% chain_singleton
thf(fact_4219_Bex__fold,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ? [X2: A] :
              ( ( member @ A @ X2 @ A3 )
              & ( P @ X2 ) ) )
        = ( finite_fold @ A @ $o
          @ ^ [K6: A,S: $o] :
              ( S
              | ( P @ K6 ) )
          @ $false
          @ A3 ) ) ) ).

% Bex_fold
thf(fact_4220_AboveS__disjoint,axiom,
    ! [A: $tType,A3: set @ A,R5: set @ ( product_prod @ A @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( order_AboveS @ A @ R5 @ A3 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% AboveS_disjoint
thf(fact_4221_max__extp_Omax__extI,axiom,
    ! [A: $tType,X5: set @ A,Y4: set @ A,R: A > A > $o] :
      ( ( finite_finite2 @ A @ X5 )
     => ( ( finite_finite2 @ A @ Y4 )
       => ( ( Y4
           != ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ X5 )
               => ? [Xa3: A] :
                    ( ( member @ A @ Xa3 @ Y4 )
                    & ( R @ X @ Xa3 ) ) )
           => ( max_extp @ A @ R @ X5 @ Y4 ) ) ) ) ) ).

% max_extp.max_extI
thf(fact_4222_max__extp_Osimps,axiom,
    ! [A: $tType] :
      ( ( max_extp @ A )
      = ( ^ [R2: A > A > $o,A1: set @ A,A22: set @ A] :
            ( ( finite_finite2 @ A @ A1 )
            & ( finite_finite2 @ A @ A22 )
            & ( A22
             != ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ A1 )
               => ? [Y2: A] :
                    ( ( member @ A @ Y2 @ A22 )
                    & ( R2 @ X2 @ Y2 ) ) ) ) ) ) ).

% max_extp.simps
thf(fact_4223_max__extp_Ocases,axiom,
    ! [A: $tType,R: A > A > $o,A14: set @ A,A24: set @ A] :
      ( ( max_extp @ A @ R @ A14 @ A24 )
     => ~ ( ( finite_finite2 @ A @ A14 )
         => ( ( finite_finite2 @ A @ A24 )
           => ( ( A24
               != ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) )
             => ~ ! [X4: A] :
                    ( ( member @ A @ X4 @ A14 )
                   => ? [Xa2: A] :
                        ( ( member @ A @ Xa2 @ A24 )
                        & ( R @ X4 @ Xa2 ) ) ) ) ) ) ) ).

% max_extp.cases
thf(fact_4224_principal__def,axiom,
    ! [A: $tType] :
      ( ( principal @ A )
      = ( ^ [S7: set @ A] : ( abs_filter @ A @ ( ball @ A @ S7 ) ) ) ) ).

% principal_def
thf(fact_4225_filtermap__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( filtermap @ A @ B )
      = ( ^ [F3: A > B,F5: filter @ A] :
            ( abs_filter @ B
            @ ^ [P3: B > $o] :
                ( eventually @ A
                @ ^ [X2: A] : ( P3 @ ( F3 @ X2 ) )
                @ F5 ) ) ) ) ).

% filtermap_def
thf(fact_4226_map__filter__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_filter_on @ A @ B )
      = ( ^ [X7: set @ A,F3: A > B,F5: filter @ A] :
            ( abs_filter @ B
            @ ^ [P3: B > $o] :
                ( eventually @ A
                @ ^ [X2: A] :
                    ( ( P3 @ ( F3 @ X2 ) )
                    & ( member @ A @ X2 @ X7 ) )
                @ F5 ) ) ) ) ).

% map_filter_on_def
thf(fact_4227_in__chain__finite,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [A3: set @ A] :
          ( ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ A3 )
         => ( ( finite_finite2 @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( member @ A @ ( complete_Sup_Sup @ A @ A3 ) @ A3 ) ) ) ) ) ).

% in_chain_finite
thf(fact_4228_map__project__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_project @ A @ B )
      = ( ^ [F3: A > ( option @ B ),A6: set @ A] :
            ( collect @ B
            @ ^ [B4: B] :
              ? [X2: A] :
                ( ( member @ A @ X2 @ A6 )
                & ( ( F3 @ X2 )
                  = ( some @ B @ B4 ) ) ) ) ) ) ).

% map_project_def
thf(fact_4229_iteratesp__def,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ( ( comple7512665784863727008ratesp @ A )
        = ( ^ [F3: A > A] :
              ( complete_lattice_lfp @ ( A > $o )
              @ ^ [P6: A > $o,X2: A] :
                  ( ? [Y2: A] :
                      ( ( X2
                        = ( F3 @ Y2 ) )
                      & ( P6 @ Y2 ) )
                  | ? [M8: set @ A] :
                      ( ( X2
                        = ( complete_Sup_Sup @ A @ M8 ) )
                      & ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ M8 )
                      & ! [Y2: A] :
                          ( ( member @ A @ Y2 @ M8 )
                         => ( P6 @ Y2 ) ) ) ) ) ) ) ) ).

% iteratesp_def
thf(fact_4230_wo__rel_Osuc__greater,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),B2: set @ A,B3: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ ( field2 @ A @ R5 ) )
       => ( ( ( order_AboveS @ A @ R5 @ B2 )
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ A @ B3 @ B2 )
           => ( ( ( bNF_Wellorder_wo_suc @ A @ R5 @ B2 )
               != B3 )
              & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ ( bNF_Wellorder_wo_suc @ A @ R5 @ B2 ) ) @ R5 ) ) ) ) ) ) ).

% wo_rel.suc_greater
thf(fact_4231_wo__rel_Osuc__AboveS,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),B2: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ ( field2 @ A @ R5 ) )
       => ( ( ( order_AboveS @ A @ R5 @ B2 )
           != ( bot_bot @ ( set @ A ) ) )
         => ( member @ A @ ( bNF_Wellorder_wo_suc @ A @ R5 @ B2 ) @ ( order_AboveS @ A @ R5 @ B2 ) ) ) ) ) ).

% wo_rel.suc_AboveS
thf(fact_4232_wo__rel_Osuc__inField,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),B2: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ ( field2 @ A @ R5 ) )
       => ( ( ( order_AboveS @ A @ R5 @ B2 )
           != ( bot_bot @ ( set @ A ) ) )
         => ( member @ A @ ( bNF_Wellorder_wo_suc @ A @ R5 @ B2 ) @ ( field2 @ A @ R5 ) ) ) ) ) ).

% wo_rel.suc_inField
thf(fact_4233_max__ext__eq,axiom,
    ! [A: $tType] :
      ( ( max_ext @ A )
      = ( ^ [R2: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
            @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
              @ ^ [X7: set @ A,Y9: set @ A] :
                  ( ( finite_finite2 @ A @ X7 )
                  & ( finite_finite2 @ A @ Y9 )
                  & ( Y9
                   != ( bot_bot @ ( set @ A ) ) )
                  & ! [X2: A] :
                      ( ( member @ A @ X2 @ X7 )
                     => ? [Y2: A] :
                          ( ( member @ A @ Y2 @ Y9 )
                          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R2 ) ) ) ) ) ) ) ) ).

% max_ext_eq
thf(fact_4234_wo__rel_Osuc__ofilter__in,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A,B3: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( ( ( order_AboveS @ A @ R5 @ A3 )
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ ( bNF_Wellorder_wo_suc @ A @ R5 @ A3 ) ) @ R5 )
           => ( ( B3
               != ( bNF_Wellorder_wo_suc @ A @ R5 @ A3 ) )
             => ( member @ A @ B3 @ A3 ) ) ) ) ) ) ).

% wo_rel.suc_ofilter_in
thf(fact_4235_univ__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( bNF_Greatest_univ @ B @ A )
      = ( ^ [F3: B > A,X7: set @ B] :
            ( F3
            @ ( fChoice @ B
              @ ^ [X2: B] : ( member @ B @ X2 @ X7 ) ) ) ) ) ).

% univ_def
thf(fact_4236_flip__pred,axiom,
    ! [A: $tType,B: $tType,A3: set @ ( product_prod @ A @ B ),R: B > A > $o] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A3 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( conversep @ B @ A @ R ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) )
        @ ( image2 @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A )
          @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
            @ ^ [X2: A,Y2: B] : ( product_Pair @ B @ A @ Y2 @ X2 ) )
          @ A3 )
        @ ( collect @ ( product_prod @ B @ A ) @ ( product_case_prod @ B @ A @ $o @ R ) ) ) ) ).

% flip_pred
thf(fact_4237_conversep__noteq,axiom,
    ! [A: $tType] :
      ( ( conversep @ A @ A
        @ ^ [X2: A,Y2: A] : ( X2 != Y2 ) )
      = ( ^ [X2: A,Y2: A] : ( X2 != Y2 ) ) ) ).

% conversep_noteq
thf(fact_4238_eventually__all__finite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_finite @ B )
     => ! [P: A > B > $o,Net: filter @ A] :
          ( ! [Y3: B] :
              ( eventually @ A
              @ ^ [X2: A] : ( P @ X2 @ Y3 )
              @ Net )
         => ( eventually @ A
            @ ^ [X2: A] :
              ! [X7: B] : ( P @ X2 @ X7 )
            @ Net ) ) ) ).

% eventually_all_finite
thf(fact_4239_converse__meet,axiom,
    ! [A: $tType,B: $tType,R5: B > A > $o,S3: B > A > $o] :
      ( ( conversep @ B @ A @ ( inf_inf @ ( B > A > $o ) @ R5 @ S3 ) )
      = ( inf_inf @ ( A > B > $o ) @ ( conversep @ B @ A @ R5 ) @ ( conversep @ B @ A @ S3 ) ) ) ).

% converse_meet
thf(fact_4240_rel__fun__def,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType] :
      ( ( bNF_rel_fun @ A @ C @ B @ D )
      = ( ^ [A6: A > C > $o,B5: B > D > $o,F3: A > B,G2: C > D] :
          ! [X2: A,Y2: C] :
            ( ( A6 @ X2 @ Y2 )
           => ( B5 @ ( F3 @ X2 ) @ ( G2 @ Y2 ) ) ) ) ) ).

% rel_fun_def
thf(fact_4241_rel__fun__eq__rel,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: B > C > $o] :
      ( ( bNF_rel_fun @ A @ A @ B @ C
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
        @ R )
      = ( ^ [F3: A > B,G2: A > C] :
          ! [X2: A] : ( R @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ).

% rel_fun_eq_rel
thf(fact_4242_Ball__def__raw,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A6: set @ A,P3: A > $o] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ A6 )
           => ( P3 @ X2 ) ) ) ) ).

% Ball_def_raw
thf(fact_4243_top__filter__def,axiom,
    ! [A: $tType] :
      ( ( top_top @ ( filter @ A ) )
      = ( abs_filter @ A
        @ ^ [P9: A > $o] :
          ! [X9: A] : ( P9 @ X9 ) ) ) ).

% top_filter_def
thf(fact_4244_conversep__converse__eq,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ A @ B )] :
      ( ( conversep @ A @ B
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R5 ) )
      = ( ^ [X2: B,Y2: A] : ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y2 ) @ ( converse @ A @ B @ R5 ) ) ) ) ).

% conversep_converse_eq
thf(fact_4245_converse__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( converse @ A @ B )
      = ( ^ [R3: set @ ( product_prod @ A @ B )] :
            ( collect @ ( product_prod @ B @ A )
            @ ( product_case_prod @ B @ A @ $o
              @ ( conversep @ A @ B
                @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R3 ) ) ) ) ) ) ).

% converse_def
thf(fact_4246_finite__set__of__finite__funs,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B,D3: B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ B @ B2 )
       => ( finite_finite2 @ ( A > B )
          @ ( collect @ ( A > B )
            @ ^ [F3: A > B] :
              ! [X2: A] :
                ( ( ( member @ A @ X2 @ A3 )
                 => ( member @ B @ ( F3 @ X2 ) @ B2 ) )
                & ( ~ ( member @ A @ X2 @ A3 )
                 => ( ( F3 @ X2 )
                    = D3 ) ) ) ) ) ) ) ).

% finite_set_of_finite_funs
thf(fact_4247_Collect__all__eq,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o] :
      ( ( collect @ A
        @ ^ [X2: A] :
          ! [X7: B] : ( P @ X2 @ X7 ) )
      = ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [Y2: B] :
              ( collect @ A
              @ ^ [X2: A] : ( P @ X2 @ Y2 ) )
          @ ( top_top @ ( set @ B ) ) ) ) ) ).

% Collect_all_eq
thf(fact_4248_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X2: A] :
              ! [Y2: A] :
                ( ( ord_less_eq @ A @ X2 @ Y2 )
               => ( P @ Y2 ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_4249_Least__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_Least @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X2: A] :
                  ( ( P3 @ X2 )
                  & ! [Y2: A] :
                      ( ( P3 @ Y2 )
                     => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ) ) ) ).

% Least_def
thf(fact_4250_wo__rel_Oofilter__UNION,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ A @ A ),I: set @ B,A3: B > ( set @ A )] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ! [I4: B] :
            ( ( member @ B @ I4 @ I )
           => ( order_ofilter @ A @ R5 @ ( A3 @ I4 ) ) )
       => ( order_ofilter @ A @ R5 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) ) ) ) ).

% wo_rel.ofilter_UNION
thf(fact_4251_inf__filter__def,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( filter @ A ) )
      = ( ^ [F5: filter @ A,F6: filter @ A] :
            ( abs_filter @ A
            @ ^ [P3: A > $o] :
              ? [Q3: A > $o,R2: A > $o] :
                ( ( eventually @ A @ Q3 @ F5 )
                & ( eventually @ A @ R2 @ F6 )
                & ! [X2: A] :
                    ( ( ( Q3 @ X2 )
                      & ( R2 @ X2 ) )
                   => ( P3 @ X2 ) ) ) ) ) ) ).

% inf_filter_def
thf(fact_4252_ofilterIncl__def,axiom,
    ! [A: $tType] :
      ( ( bNF_We413866401316099525erIncl @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
            @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
              @ ^ [A6: set @ A,B5: set @ A] :
                  ( ( order_ofilter @ A @ R3 @ A6 )
                  & ( A6
                   != ( field2 @ A @ R3 ) )
                  & ( order_ofilter @ A @ R3 @ B5 )
                  & ( B5
                   != ( field2 @ A @ R3 ) )
                  & ( ord_less @ ( set @ A ) @ A6 @ B5 ) ) ) ) ) ) ).

% ofilterIncl_def
thf(fact_4253_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X2: A] :
                  ( ( P3 @ X2 )
                  & ! [Y2: A] :
                      ( ( P3 @ Y2 )
                     => ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_4254_ord_OLeast__def,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( ^ [Less_eq2: A > A > $o,P3: A > $o] :
            ( the @ A
            @ ^ [X2: A] :
                ( ( P3 @ X2 )
                & ! [Y2: A] :
                    ( ( P3 @ Y2 )
                   => ( Less_eq2 @ X2 @ Y2 ) ) ) ) ) ) ).

% ord.Least_def
thf(fact_4255_transfer__bforall__def,axiom,
    ! [A: $tType] :
      ( ( transfer_bforall @ A )
      = ( ^ [P3: A > $o,Q3: A > $o] :
          ! [X2: A] :
            ( ( P3 @ X2 )
           => ( Q3 @ X2 ) ) ) ) ).

% transfer_bforall_def
thf(fact_4256_ord_OLeast_Ocong,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( least @ A ) ) ).

% ord.Least.cong
thf(fact_4257_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X3: A,Q: A > $o] :
          ( ( P @ X3 )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ Y3 @ X3 ) )
           => ( ! [X: A] :
                  ( ( P @ X )
                 => ( ! [Y7: A] :
                        ( ( P @ Y7 )
                       => ( ord_less_eq @ A @ Y7 @ X ) )
                   => ( Q @ X ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_4258_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X3: A] :
          ( ( P @ X3 )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ Y3 @ X3 ) )
           => ( ( order_Greatest @ A @ P )
              = X3 ) ) ) ) ).

% Greatest_equality
thf(fact_4259_filtercomap__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( filtercomap @ A @ B )
      = ( ^ [F3: A > B,F5: filter @ B] :
            ( abs_filter @ A
            @ ^ [P3: A > $o] :
              ? [Q3: B > $o] :
                ( ( eventually @ B @ Q3 @ F5 )
                & ! [X2: A] :
                    ( ( Q3 @ ( F3 @ X2 ) )
                   => ( P3 @ X2 ) ) ) ) ) ) ).

% filtercomap_def
thf(fact_4260_init__seg__of__def,axiom,
    ! [A: $tType] :
      ( ( init_seg_of @ A )
      = ( collect @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
        @ ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ $o
          @ ^ [R3: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
              ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ S )
              & ! [A5: A,B4: A,C5: A] :
                  ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ S )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ C5 ) @ R3 ) )
                 => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R3 ) ) ) ) ) ) ).

% init_seg_of_def
thf(fact_4261_wo__rel_Oofilter__under__UNION,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( A3
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ A @ ( set @ A ) @ ( order_under @ A @ R5 ) @ A3 ) ) ) ) ) ).

% wo_rel.ofilter_under_UNION
thf(fact_4262_ofilter__Restr__Int,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A,B2: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( order_ofilter @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ B2
              @ ^ [Uu: A] : B2 ) )
          @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% ofilter_Restr_Int
thf(fact_4263_filtercomap__bot,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( filtercomap @ A @ B @ F2 @ ( bot_bot @ ( filter @ B ) ) )
      = ( bot_bot @ ( filter @ A ) ) ) ).

% filtercomap_bot
thf(fact_4264_eventually__filtercomapI,axiom,
    ! [B: $tType,A: $tType,P: A > $o,F: filter @ A,F2: B > A] :
      ( ( eventually @ A @ P @ F )
     => ( eventually @ B
        @ ^ [X2: B] : ( P @ ( F2 @ X2 ) )
        @ ( filtercomap @ B @ A @ F2 @ F ) ) ) ).

% eventually_filtercomapI
thf(fact_4265_filtercomap__filtercomap,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > B,G: B > C,F: filter @ C] :
      ( ( filtercomap @ A @ B @ F2 @ ( filtercomap @ B @ C @ G @ F ) )
      = ( filtercomap @ A @ C
        @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
        @ F ) ) ).

% filtercomap_filtercomap
thf(fact_4266_filtercomap__ident,axiom,
    ! [A: $tType,F: filter @ A] :
      ( ( filtercomap @ A @ A
        @ ^ [X2: A] : X2
        @ F )
      = F ) ).

% filtercomap_ident
thf(fact_4267_filtercomap__inf,axiom,
    ! [A: $tType,B: $tType,F2: A > B,F12: filter @ B,F23: filter @ B] :
      ( ( filtercomap @ A @ B @ F2 @ ( inf_inf @ ( filter @ B ) @ F12 @ F23 ) )
      = ( inf_inf @ ( filter @ A ) @ ( filtercomap @ A @ B @ F2 @ F12 ) @ ( filtercomap @ A @ B @ F2 @ F23 ) ) ) ).

% filtercomap_inf
thf(fact_4268_under__def,axiom,
    ! [A: $tType] :
      ( ( order_under @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),A5: A] :
            ( collect @ A
            @ ^ [B4: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ A5 ) @ R3 ) ) ) ) ).

% under_def
thf(fact_4269_well__order__on__empty,axiom,
    ! [A: $tType] : ( order_well_order_on @ A @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% well_order_on_empty
thf(fact_4270_ofilter__Restr__under,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A,A4: A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( ( member @ A @ A4 @ A3 )
         => ( ( order_under @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                @ ( product_Sigma @ A @ A @ A3
                  @ ^ [Uu: A] : A3 ) )
              @ A4 )
            = ( order_under @ A @ R5 @ A4 ) ) ) ) ) ).

% ofilter_Restr_under
thf(fact_4271_filtercomap__neq__bot,axiom,
    ! [A: $tType,B: $tType,F: filter @ A,F2: B > A] :
      ( ! [P4: A > $o] :
          ( ( eventually @ A @ P4 @ F )
         => ? [X4: B] : ( P4 @ ( F2 @ X4 ) ) )
     => ( ( filtercomap @ B @ A @ F2 @ F )
       != ( bot_bot @ ( filter @ B ) ) ) ) ).

% filtercomap_neq_bot
thf(fact_4272_filtercomap__INF,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > B,F: C > ( filter @ B ),B2: set @ C] :
      ( ( filtercomap @ A @ B @ F2 @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ C @ ( filter @ B ) @ F @ B2 ) ) )
      = ( complete_Inf_Inf @ ( filter @ A )
        @ ( image2 @ C @ ( filter @ A )
          @ ^ [B4: C] : ( filtercomap @ A @ B @ F2 @ ( F @ B4 ) )
          @ B2 ) ) ) ).

% filtercomap_INF
thf(fact_4273_Well__order__Restr,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( order_well_order_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ A3
              @ ^ [Uu: A] : A3 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) ) ) ).

% Well_order_Restr
thf(fact_4274_natLeq__on__well__order__on,axiom,
    ! [N: nat] :
      ( order_well_order_on @ nat
      @ ( collect @ nat
        @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) )
      @ ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y2: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y2 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) ) ).

% natLeq_on_well_order_on
thf(fact_4275_bsqr__ofilter,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),D2: set @ ( product_prod @ A @ A )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ ( product_prod @ A @ A ) @ ( bNF_Wellorder_bsqr @ A @ R5 ) @ D2 )
       => ( ( ord_less @ ( set @ ( product_prod @ A @ A ) ) @ D2
            @ ( product_Sigma @ A @ A @ ( field2 @ A @ R5 )
              @ ^ [Uu: A] : ( field2 @ A @ R5 ) ) )
         => ( ~ ? [A7: A] :
                  ( ( field2 @ A @ R5 )
                  = ( order_under @ A @ R5 @ A7 ) )
           => ? [A12: set @ A] :
                ( ( order_ofilter @ A @ R5 @ A12 )
                & ( ord_less @ ( set @ A ) @ A12 @ ( field2 @ A @ R5 ) )
                & ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ D2
                  @ ( product_Sigma @ A @ A @ A12
                    @ ^ [Uu: A] : A12 ) ) ) ) ) ) ) ).

% bsqr_ofilter
thf(fact_4276_filtercomap__neq__bot__surj,axiom,
    ! [A: $tType,B: $tType,F: filter @ A,F2: B > A] :
      ( ( F
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( ( image2 @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
          = ( top_top @ ( set @ A ) ) )
       => ( ( filtercomap @ B @ A @ F2 @ F )
         != ( bot_bot @ ( filter @ B ) ) ) ) ) ).

% filtercomap_neq_bot_surj
thf(fact_4277_well__order__on__Restr,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( field2 @ A @ R5 ) )
       => ( order_well_order_on @ A @ A3
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
            @ ( product_Sigma @ A @ A @ A3
              @ ^ [Uu: A] : A3 ) ) ) ) ) ).

% well_order_on_Restr
thf(fact_4278_Field__Restr__ofilter,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( ( field2 @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
              @ ( product_Sigma @ A @ A @ A3
                @ ^ [Uu: A] : A3 ) ) )
          = A3 ) ) ) ).

% Field_Restr_ofilter
thf(fact_4279_natLeq__on__Well__order,axiom,
    ! [N: nat] :
      ( order_well_order_on @ nat
      @ ( field2 @ nat
        @ ( collect @ ( product_prod @ nat @ nat )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [X2: nat,Y2: nat] :
                ( ( ord_less @ nat @ X2 @ N )
                & ( ord_less @ nat @ Y2 @ N )
                & ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) )
      @ ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y2: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y2 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) ) ).

% natLeq_on_Well_order
thf(fact_4280_filtercomap__SUP,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: A > C,F: B > ( filter @ C ),B2: set @ B] :
      ( ord_less_eq @ ( filter @ A )
      @ ( complete_Sup_Sup @ ( filter @ A )
        @ ( image2 @ B @ ( filter @ A )
          @ ^ [B4: B] : ( filtercomap @ A @ C @ F2 @ ( F @ B4 ) )
          @ B2 ) )
      @ ( filtercomap @ A @ C @ F2 @ ( complete_Sup_Sup @ ( filter @ C ) @ ( image2 @ B @ ( filter @ C ) @ F @ B2 ) ) ) ) ).

% filtercomap_SUP
thf(fact_4281_Linear__order__Well__order__iff,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( order_679001287576687338der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
        = ( ! [A6: set @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ A6 @ ( field2 @ A @ R5 ) )
             => ( ( A6
                 != ( bot_bot @ ( set @ A ) ) )
               => ? [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                    & ! [Y2: A] :
                        ( ( member @ A @ Y2 @ A6 )
                       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) ) ) ) ) ) ) ) ).

% Linear_order_Well_order_iff
thf(fact_4282_ofilter__Restr__subset,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A,B2: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
         => ( order_ofilter @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
              @ ( product_Sigma @ A @ A @ B2
                @ ^ [Uu: A] : B2 ) )
            @ A3 ) ) ) ) ).

% ofilter_Restr_subset
thf(fact_4283_UNION__inj__on__ofilter,axiom,
    ! [C: $tType,A: $tType,B: $tType,R5: set @ ( product_prod @ A @ A ),I: set @ B,A3: B > ( set @ A ),F2: A > C] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ! [I4: B] :
            ( ( member @ B @ I4 @ I )
           => ( order_ofilter @ A @ R5 @ ( A3 @ I4 ) ) )
       => ( ! [I4: B] :
              ( ( member @ B @ I4 @ I )
             => ( inj_on @ A @ C @ F2 @ ( A3 @ I4 ) ) )
         => ( inj_on @ A @ C @ F2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) ) ) ) ) ).

% UNION_inj_on_ofilter
thf(fact_4284_ofilter__subset__embedS,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A,B2: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( ( order_ofilter @ A @ R5 @ B2 )
         => ( ( ord_less @ ( set @ A ) @ A3 @ B2 )
            = ( bNF_Wellorder_embedS @ A @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                @ ( product_Sigma @ A @ A @ A3
                  @ ^ [Uu: A] : A3 ) )
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                @ ( product_Sigma @ A @ A @ B2
                  @ ^ [Uu: A] : B2 ) )
              @ ( id @ A ) ) ) ) ) ) ).

% ofilter_subset_embedS
thf(fact_4285_ofilter__subset__embed,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A,B2: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( ( order_ofilter @ A @ R5 @ B2 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
            = ( bNF_Wellorder_embed @ A @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                @ ( product_Sigma @ A @ A @ A3
                  @ ^ [Uu: A] : A3 ) )
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                @ ( product_Sigma @ A @ A @ B2
                  @ ^ [Uu: A] : B2 ) )
              @ ( id @ A ) ) ) ) ) ) ).

% ofilter_subset_embed
thf(fact_4286_ofilter__embed,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
        = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( field2 @ A @ R5 ) )
          & ( bNF_Wellorder_embed @ A @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
              @ ( product_Sigma @ A @ A @ A3
                @ ^ [Uu: A] : A3 ) )
            @ R5
            @ ( id @ A ) ) ) ) ) ).

% ofilter_embed
thf(fact_4287_embedS__defs_I2_J,axiom,
    ! [A2: $tType,A: $tType] :
      ( ( bNF_Wellorder_embedS @ A @ A2 )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),R8: set @ ( product_prod @ A2 @ A2 ),F3: A > A2] :
            ( ( bNF_Wellorder_embed @ A @ A2 @ R3 @ R8 @ F3 )
            & ~ ( bij_betw @ A @ A2 @ F3 @ ( field2 @ A @ R3 ) @ ( field2 @ A2 @ R8 ) ) ) ) ) ).

% embedS_defs(2)
thf(fact_4288_embed__defs_I2_J,axiom,
    ! [A2: $tType,A: $tType] :
      ( ( bNF_Wellorder_embed @ A @ A2 )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),R8: set @ ( product_prod @ A2 @ A2 ),F3: A > A2] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ ( field2 @ A @ R3 ) )
           => ( bij_betw @ A @ A2 @ F3 @ ( order_under @ A @ R3 @ X2 ) @ ( order_under @ A2 @ R8 @ ( F3 @ X2 ) ) ) ) ) ) ).

% embed_defs(2)
thf(fact_4289_ord__to__filter__def,axiom,
    ! [A: $tType] :
      ( ( bNF_We8469521843155493636filter @ A )
      = ( ^ [R0: set @ ( product_prod @ A @ A ),R3: set @ ( product_prod @ A @ A )] : ( image2 @ A @ A @ ( fChoice @ ( A > A ) @ ( bNF_Wellorder_embed @ A @ A @ R3 @ R0 ) ) @ ( field2 @ A @ R3 ) ) ) ) ).

% ord_to_filter_def
thf(fact_4290_ofilter__subset__embedS__iso,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A,B2: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( ( order_ofilter @ A @ R5 @ B2 )
         => ( ( ( ord_less @ ( set @ A ) @ A3 @ B2 )
              = ( bNF_Wellorder_embedS @ A @ A
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                  @ ( product_Sigma @ A @ A @ A3
                    @ ^ [Uu: A] : A3 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                  @ ( product_Sigma @ A @ A @ B2
                    @ ^ [Uu: A] : B2 ) )
                @ ( id @ A ) ) )
            & ( ( A3 = B2 )
              = ( bNF_Wellorder_iso @ A @ A
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                  @ ( product_Sigma @ A @ A @ A3
                    @ ^ [Uu: A] : A3 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                  @ ( product_Sigma @ A @ A @ B2
                    @ ^ [Uu: A] : B2 ) )
                @ ( id @ A ) ) ) ) ) ) ) ).

% ofilter_subset_embedS_iso
thf(fact_4291_embed__implies__iso__Restr,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ B @ B ),F2: B > A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R7 ) @ R7 )
       => ( ( bNF_Wellorder_embed @ B @ A @ R7 @ R5 @ F2 )
         => ( bNF_Wellorder_iso @ B @ A @ R7
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
              @ ( product_Sigma @ A @ A @ ( image2 @ B @ A @ F2 @ ( field2 @ B @ R7 ) )
                @ ^ [Uu: A] : ( image2 @ B @ A @ F2 @ ( field2 @ B @ R7 ) ) ) )
            @ F2 ) ) ) ) ).

% embed_implies_iso_Restr
thf(fact_4292_ordLess__def,axiom,
    ! [A2: $tType,A: $tType] :
      ( ( bNF_We4044943003108391690rdLess @ A @ A2 )
      = ( collect @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) )
        @ ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) @ $o
          @ ^ [R3: set @ ( product_prod @ A @ A ),R8: set @ ( product_prod @ A2 @ A2 )] :
              ( ( order_well_order_on @ A @ ( field2 @ A @ R3 ) @ R3 )
              & ( order_well_order_on @ A2 @ ( field2 @ A2 @ R8 ) @ R8 )
              & ? [X7: A > A2] : ( bNF_Wellorder_embedS @ A @ A2 @ R3 @ R8 @ X7 ) ) ) ) ) ).

% ordLess_def
thf(fact_4293_iso__defs_I2_J,axiom,
    ! [A2: $tType,A: $tType] :
      ( ( bNF_Wellorder_iso @ A @ A2 )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),R8: set @ ( product_prod @ A2 @ A2 ),F3: A > A2] :
            ( ( bNF_Wellorder_embed @ A @ A2 @ R3 @ R8 @ F3 )
            & ( bij_betw @ A @ A2 @ F3 @ ( field2 @ A @ R3 ) @ ( field2 @ A2 @ R8 ) ) ) ) ) ).

% iso_defs(2)
thf(fact_4294_ofilter__ordLess,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( ( ord_less @ ( set @ A ) @ A3 @ ( field2 @ A @ R5 ) )
          = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
            @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                @ ( product_Sigma @ A @ A @ A3
                  @ ^ [Uu: A] : A3 ) )
              @ R5 )
            @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ) ).

% ofilter_ordLess
thf(fact_4295_ofilter__subset__ordLess,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A,B2: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( ( order_ofilter @ A @ R5 @ B2 )
         => ( ( ord_less @ ( set @ A ) @ A3 @ B2 )
            = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                  @ ( product_Sigma @ A @ A @ A3
                    @ ^ [Uu: A] : A3 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                  @ ( product_Sigma @ A @ A @ B2
                    @ ^ [Uu: A] : B2 ) ) )
              @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ) ) ).

% ofilter_subset_ordLess
thf(fact_4296_ord__to__filter__compat,axiom,
    ! [A: $tType,R02: set @ ( product_prod @ A @ A )] :
      ( bNF_Wellorder_compat @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ A )
      @ ( inf_inf @ ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) ) @ ( bNF_We4044943003108391690rdLess @ A @ A )
        @ ( product_Sigma @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( image @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( converse @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) @ ( insert @ ( set @ ( product_prod @ A @ A ) ) @ R02 @ ( bot_bot @ ( set @ ( set @ ( product_prod @ A @ A ) ) ) ) ) )
          @ ^ [Uu: set @ ( product_prod @ A @ A )] : ( image @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( converse @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) @ ( insert @ ( set @ ( product_prod @ A @ A ) ) @ R02 @ ( bot_bot @ ( set @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ) )
      @ ( bNF_We413866401316099525erIncl @ A @ R02 )
      @ ( bNF_We8469521843155493636filter @ A @ R02 ) ) ).

% ord_to_filter_compat
thf(fact_4297_underS__Restr__ordLess,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A4: A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( ( field2 @ A @ R5 )
         != ( bot_bot @ ( set @ A ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
              @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R5 @ A4 )
                @ ^ [Uu: A] : ( order_underS @ A @ R5 @ A4 ) ) )
            @ R5 )
          @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ).

% underS_Restr_ordLess
thf(fact_4298_Refl__under__underS,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A4: A] :
      ( ( refl_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( member @ A @ A4 @ ( field2 @ A @ R5 ) )
       => ( ( order_under @ A @ R5 @ A4 )
          = ( sup_sup @ ( set @ A ) @ ( order_underS @ A @ R5 @ A4 ) @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% Refl_under_underS
thf(fact_4299_ordIso__def,axiom,
    ! [A2: $tType,A: $tType] :
      ( ( bNF_Wellorder_ordIso @ A @ A2 )
      = ( collect @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) )
        @ ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) @ $o
          @ ^ [R3: set @ ( product_prod @ A @ A ),R8: set @ ( product_prod @ A2 @ A2 )] :
              ( ( order_well_order_on @ A @ ( field2 @ A @ R3 ) @ R3 )
              & ( order_well_order_on @ A2 @ ( field2 @ A2 @ R8 ) @ R8 )
              & ? [X7: A > A2] : ( bNF_Wellorder_iso @ A @ A2 @ R3 @ R8 @ X7 ) ) ) ) ) ).

% ordIso_def
thf(fact_4300_underS__def,axiom,
    ! [A: $tType] :
      ( ( order_underS @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),A5: A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( B4 != A5 )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ A5 ) @ R3 ) ) ) ) ) ).

% underS_def
thf(fact_4301_underS__empty,axiom,
    ! [A: $tType,A4: A,R5: set @ ( product_prod @ A @ A )] :
      ( ~ ( member @ A @ A4 @ ( field2 @ A @ R5 ) )
     => ( ( order_underS @ A @ R5 @ A4 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% underS_empty
thf(fact_4302_ordLess__iff__ordIso__Restr,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ B @ B )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R7 ) @ R7 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R7 @ R5 ) @ ( bNF_We4044943003108391690rdLess @ B @ A ) )
          = ( ? [X2: A] :
                ( ( member @ A @ X2 @ ( field2 @ A @ R5 ) )
                & ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) )
                  @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R7
                    @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                      @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R5 @ X2 )
                        @ ^ [Uu: A] : ( order_underS @ A @ R5 @ X2 ) ) ) )
                  @ ( bNF_Wellorder_ordIso @ B @ A ) ) ) ) ) ) ) ).

% ordLess_iff_ordIso_Restr
thf(fact_4303_underS__Field3,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A4: A] :
      ( ( ( field2 @ A @ R5 )
       != ( bot_bot @ ( set @ A ) ) )
     => ( ord_less @ ( set @ A ) @ ( order_underS @ A @ R5 @ A4 ) @ ( field2 @ A @ R5 ) ) ) ).

% underS_Field3
thf(fact_4304_ordLeq__iff__ordLess__Restr,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ B @ B )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R7 ) @ R7 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R5 @ R7 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( field2 @ A @ R5 ) )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) )
                  @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) )
                    @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                      @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R5 @ X2 )
                        @ ^ [Uu: A] : ( order_underS @ A @ R5 @ X2 ) ) )
                    @ R7 )
                  @ ( bNF_We4044943003108391690rdLess @ A @ B ) ) ) ) ) ) ) ).

% ordLeq_iff_ordLess_Restr
thf(fact_4305_ofilter__subset__ordLeq,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A,B2: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( order_ofilter @ A @ R5 @ A3 )
       => ( ( order_ofilter @ A @ R5 @ B2 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
            = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                  @ ( product_Sigma @ A @ A @ A3
                    @ ^ [Uu: A] : A3 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                  @ ( product_Sigma @ A @ A @ B2
                    @ ^ [Uu: A] : B2 ) ) )
              @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ) ) ) ).

% ofilter_subset_ordLeq
thf(fact_4306_ordLeq__def,axiom,
    ! [A2: $tType,A: $tType] :
      ( ( bNF_Wellorder_ordLeq @ A @ A2 )
      = ( collect @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) )
        @ ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) @ $o
          @ ^ [R3: set @ ( product_prod @ A @ A ),R8: set @ ( product_prod @ A2 @ A2 )] :
              ( ( order_well_order_on @ A @ ( field2 @ A @ R3 ) @ R3 )
              & ( order_well_order_on @ A2 @ ( field2 @ A2 @ R8 ) @ R8 )
              & ? [X7: A > A2] : ( bNF_Wellorder_embed @ A @ A2 @ R3 @ R8 @ X7 ) ) ) ) ) ).

% ordLeq_def
thf(fact_4307_finite__subset__Union__chain,axiom,
    ! [A: $tType,A3: set @ A,B8: set @ ( set @ A ),A18: set @ ( set @ A )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ B8 ) )
       => ( ( B8
           != ( bot_bot @ ( set @ ( set @ A ) ) ) )
         => ( ( pred_chain @ ( set @ A ) @ A18 @ ( ord_less @ ( set @ A ) ) @ B8 )
           => ~ ! [B10: set @ A] :
                  ( ( member @ ( set @ A ) @ B10 @ B8 )
                 => ~ ( ord_less_eq @ ( set @ A ) @ A3 @ B10 ) ) ) ) ) ) ).

% finite_subset_Union_chain
thf(fact_4308_pred__on_Ochain__empty,axiom,
    ! [A: $tType,A3: set @ A,P: A > A > $o] : ( pred_chain @ A @ A3 @ P @ ( bot_bot @ ( set @ A ) ) ) ).

% pred_on.chain_empty
thf(fact_4309_subset_Ochain__empty,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] : ( pred_chain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ).

% subset.chain_empty
thf(fact_4310_chains__alt__def,axiom,
    ! [A: $tType] :
      ( ( chains2 @ A )
      = ( ^ [A6: set @ ( set @ A )] : ( collect @ ( set @ ( set @ A ) ) @ ( pred_chain @ ( set @ A ) @ A6 @ ( ord_less @ ( set @ A ) ) ) ) ) ) ).

% chains_alt_def
thf(fact_4311_subset__Zorn__nonempty,axiom,
    ! [A: $tType,A18: set @ ( set @ A )] :
      ( ( A18
       != ( bot_bot @ ( set @ ( set @ A ) ) ) )
     => ( ! [C9: set @ ( set @ A )] :
            ( ( C9
             != ( bot_bot @ ( set @ ( set @ A ) ) ) )
           => ( ( pred_chain @ ( set @ A ) @ A18 @ ( ord_less @ ( set @ A ) ) @ C9 )
             => ( member @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ C9 ) @ A18 ) ) )
       => ? [X: set @ A] :
            ( ( member @ ( set @ A ) @ X @ A18 )
            & ! [Xa3: set @ A] :
                ( ( member @ ( set @ A ) @ Xa3 @ A18 )
               => ( ( ord_less_eq @ ( set @ A ) @ X @ Xa3 )
                 => ( Xa3 = X ) ) ) ) ) ) ).

% subset_Zorn_nonempty
thf(fact_4312_Union__in__chain,axiom,
    ! [A: $tType,B8: set @ ( set @ A ),A18: set @ ( set @ A )] :
      ( ( finite_finite2 @ ( set @ A ) @ B8 )
     => ( ( B8
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( pred_chain @ ( set @ A ) @ A18 @ ( ord_less @ ( set @ A ) ) @ B8 )
         => ( member @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ B8 ) @ B8 ) ) ) ) ).

% Union_in_chain
thf(fact_4313_Inter__in__chain,axiom,
    ! [A: $tType,B8: set @ ( set @ A ),A18: set @ ( set @ A )] :
      ( ( finite_finite2 @ ( set @ A ) @ B8 )
     => ( ( B8
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( pred_chain @ ( set @ A ) @ A18 @ ( ord_less @ ( set @ A ) ) @ B8 )
         => ( member @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ B8 ) @ B8 ) ) ) ) ).

% Inter_in_chain
thf(fact_4314_exists__minim__Well__order,axiom,
    ! [A: $tType,R: set @ ( set @ ( product_prod @ A @ A ) )] :
      ( ( R
       != ( bot_bot @ ( set @ ( set @ ( product_prod @ A @ A ) ) ) ) )
     => ( ! [X: set @ ( product_prod @ A @ A )] :
            ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X @ R )
           => ( order_well_order_on @ A @ ( field2 @ A @ X ) @ X ) )
       => ? [X: set @ ( product_prod @ A @ A )] :
            ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X @ R )
            & ! [Xa3: set @ ( product_prod @ A @ A )] :
                ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ Xa3 @ R )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ X @ Xa3 ) @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ) ) ) ).

% exists_minim_Well_order
thf(fact_4315_subset_Ochain__extend,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),C3: set @ ( set @ A ),Z2: set @ A] :
      ( ( pred_chain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ C3 )
     => ( ( member @ ( set @ A ) @ Z2 @ A3 )
       => ( ! [X: set @ A] :
              ( ( member @ ( set @ A ) @ X @ C3 )
             => ( sup_sup @ ( ( set @ A ) > ( set @ A ) > $o ) @ ( ord_less @ ( set @ A ) )
                @ ^ [Y5: set @ A,Z5: set @ A] : ( Y5 = Z5 )
                @ X
                @ Z2 ) )
         => ( pred_chain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( insert @ ( set @ A ) @ Z2 @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) @ C3 ) ) ) ) ) ).

% subset.chain_extend
thf(fact_4316_pred__on_Ochain__extend,axiom,
    ! [A: $tType,A3: set @ A,P: A > A > $o,C3: set @ A,Z2: A] :
      ( ( pred_chain @ A @ A3 @ P @ C3 )
     => ( ( member @ A @ Z2 @ A3 )
       => ( ! [X: A] :
              ( ( member @ A @ X @ C3 )
             => ( sup_sup @ ( A > A > $o ) @ P
                @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
                @ X
                @ Z2 ) )
         => ( pred_chain @ A @ A3 @ P @ ( sup_sup @ ( set @ A ) @ ( insert @ A @ Z2 @ ( bot_bot @ ( set @ A ) ) ) @ C3 ) ) ) ) ) ).

% pred_on.chain_extend
thf(fact_4317_Chains__subset_H,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( refl_on @ A @ ( top_top @ ( set @ A ) ) @ R5 )
     => ( ord_less_eq @ ( set @ ( set @ A ) )
        @ ( collect @ ( set @ A )
          @ ( pred_chain @ A @ ( top_top @ ( set @ A ) )
            @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) ) )
        @ ( chains @ A @ R5 ) ) ) ).

% Chains_subset'
thf(fact_4318_Chains__subset,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( chains @ A @ R5 )
      @ ( collect @ ( set @ A )
        @ ( pred_chain @ A @ ( top_top @ ( set @ A ) )
          @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) ) ) ) ).

% Chains_subset
thf(fact_4319_Chains__alt__def,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( refl_on @ A @ ( top_top @ ( set @ A ) ) @ R5 )
     => ( ( chains @ A @ R5 )
        = ( collect @ ( set @ A )
          @ ( pred_chain @ A @ ( top_top @ ( set @ A ) )
            @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) ) ) ) ) ).

% Chains_alt_def
thf(fact_4320_comp__set__bd__Union__o__collect,axiom,
    ! [C: $tType,B: $tType,A: $tType,X3: C,X5: set @ ( C > ( set @ ( set @ A ) ) ),Hbd: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) )
          @ ( bNF_Ca6860139660246222851ard_of @ A
            @ ( complete_Sup_Sup @ ( set @ A )
              @ ( complete_Sup_Sup @ ( set @ ( set @ A ) )
                @ ( image2 @ ( C > ( set @ ( set @ A ) ) ) @ ( set @ ( set @ A ) )
                  @ ^ [F3: C > ( set @ ( set @ A ) )] : ( F3 @ X3 )
                  @ X5 ) ) ) )
          @ Hbd )
        @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( comp @ ( set @ ( set @ A ) ) @ ( set @ A ) @ C @ ( complete_Sup_Sup @ ( set @ A ) ) @ ( bNF_collect @ C @ ( set @ A ) @ X5 ) @ X3 ) ) @ Hbd ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ).

% comp_set_bd_Union_o_collect
thf(fact_4321_card__of__Times3,axiom,
    ! [A: $tType,A3: set @ A] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ A )
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu: A] : A3 ) ) )
      @ ( bNF_Wellorder_ordLeq @ A @ ( product_prod @ A @ A ) ) ) ).

% card_of_Times3
thf(fact_4322_card__of__Times2,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
            @ ( product_Sigma @ A @ B @ A3
              @ ^ [Uu: A] : B2 ) ) )
        @ ( bNF_Wellorder_ordLeq @ B @ ( product_prod @ A @ B ) ) ) ) ).

% card_of_Times2
thf(fact_4323_card__of__Times1,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
            @ ( product_Sigma @ B @ A @ B2
              @ ^ [Uu: B] : A3 ) ) )
        @ ( bNF_Wellorder_ordLeq @ B @ ( product_prod @ B @ A ) ) ) ) ).

% card_of_Times1
thf(fact_4324_card__of__bool,axiom,
    ! [A: $tType,A14: A,A24: A] :
      ( ( A14 != A24 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ $o @ ( top_top @ ( set @ $o ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( insert @ A @ A14 @ ( insert @ A @ A24 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) @ ( bNF_Wellorder_ordIso @ $o @ A ) ) ) ).

% card_of_bool
thf(fact_4325_card__of__Times__same__infinite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ A )
            @ ( product_Sigma @ A @ A @ A3
              @ ^ [Uu: A] : A3 ) )
          @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) )
        @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ A ) @ A ) ) ) ).

% card_of_Times_same_infinite
thf(fact_4326_card__of__Times__commute,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
          @ ( product_Sigma @ A @ B @ A3
            @ ^ [Uu: A] : B2 ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
          @ ( product_Sigma @ B @ A @ B2
            @ ^ [Uu: B] : A3 ) ) )
      @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A ) ) ) ).

% card_of_Times_commute
thf(fact_4327_Func__Times__Range,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: set @ A,B2: set @ B,C3: set @ C] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( A > ( product_prod @ B @ C ) ) @ ( A > ( product_prod @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( product_prod @ ( A > B ) @ ( A > C ) ) @ ( product_prod @ ( A > B ) @ ( A > C ) ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( A > ( product_prod @ B @ C ) ) @ ( A > ( product_prod @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( product_prod @ ( A > B ) @ ( A > C ) ) @ ( product_prod @ ( A > B ) @ ( A > C ) ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( A > ( product_prod @ B @ C ) )
          @ ( bNF_Wellorder_Func @ A @ ( product_prod @ B @ C ) @ A3
            @ ( product_Sigma @ B @ C @ B2
              @ ^ [Uu: B] : C3 ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ ( A > B ) @ ( A > C ) )
          @ ( product_Sigma @ ( A > B ) @ ( A > C ) @ ( bNF_Wellorder_Func @ A @ B @ A3 @ B2 )
            @ ^ [Uu: A > B] : ( bNF_Wellorder_Func @ A @ C @ A3 @ C3 ) ) ) )
      @ ( bNF_Wellorder_ordIso @ ( A > ( product_prod @ B @ C ) ) @ ( product_prod @ ( A > B ) @ ( A > C ) ) ) ) ).

% Func_Times_Range
thf(fact_4328_card__of__UNION__Sigma,axiom,
    ! [B: $tType,A: $tType,A3: B > ( set @ A ),I: set @ B] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A3 @ I ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A ) @ ( product_Sigma @ B @ A @ I @ A3 ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ ( product_prod @ B @ A ) ) ) ).

% card_of_UNION_Sigma
thf(fact_4329_card__of__Sigma__mono1,axiom,
    ! [C: $tType,B: $tType,A: $tType,I: set @ A,A3: A > ( set @ B ),B2: A > ( set @ C )] :
      ( ! [X: A] :
          ( ( member @ A @ X @ I )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( A3 @ X ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( B2 @ X ) ) ) @ ( bNF_Wellorder_ordLeq @ B @ C ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ I @ A3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ C ) @ ( product_Sigma @ A @ C @ I @ B2 ) ) ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) ) ).

% card_of_Sigma_mono1
thf(fact_4330_card__of__Times__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,A3: set @ A,B2: set @ B,C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ C )
            @ ( product_Sigma @ A @ C @ A3
              @ ^ [Uu: A] : C3 ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ C )
            @ ( product_Sigma @ B @ C @ B2
              @ ^ [Uu: B] : C3 ) ) )
        @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C ) ) ) ) ).

% card_of_Times_mono1
thf(fact_4331_card__of__Times__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,A3: set @ A,B2: set @ B,C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ C @ A )
            @ ( product_Sigma @ C @ A @ C3
              @ ^ [Uu: C] : A3 ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ C @ B )
            @ ( product_Sigma @ C @ B @ C3
              @ ^ [Uu: C] : B2 ) ) )
        @ ( bNF_Wellorder_ordLeq @ ( product_prod @ C @ A ) @ ( product_prod @ C @ B ) ) ) ) ).

% card_of_Times_mono2
thf(fact_4332_card__of__Sigma__ordLeq__infinite,axiom,
    ! [A: $tType,C: $tType,B: $tType,B2: set @ A,I: set @ B,A3: B > ( set @ C )] :
      ( ~ ( finite_finite2 @ A @ B2 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ I ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B2 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( ! [X: B] :
              ( ( member @ B @ X @ I )
             => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A3 @ X ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B2 ) ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ C ) @ ( product_Sigma @ B @ C @ I @ A3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B2 ) ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ B @ C ) @ A ) ) ) ) ) ).

% card_of_Sigma_ordLeq_infinite
thf(fact_4333_card__of__Times__infinite,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( B2
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
                  @ ( product_Sigma @ A @ B @ A3
                    @ ^ [Uu: A] : B2 ) )
                @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) )
              @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ B ) @ A ) )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
                  @ ( product_Sigma @ B @ A @ B2
                    @ ^ [Uu: B] : A3 ) )
                @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) )
              @ ( bNF_Wellorder_ordIso @ ( product_prod @ B @ A ) @ A ) ) ) ) ) ) ).

% card_of_Times_infinite
thf(fact_4334_card__of__Times__infinite__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( B2
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
            @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) )
              @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
                @ ( product_Sigma @ A @ B @ A3
                  @ ^ [Uu: A] : B2 ) )
              @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) )
            @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ B ) @ A ) ) ) ) ) ).

% card_of_Times_infinite_simps(1)
thf(fact_4335_card__of__Times__infinite__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( B2
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) )
            @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 )
              @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
                @ ( product_Sigma @ A @ B @ A3
                  @ ^ [Uu: A] : B2 ) ) )
            @ ( bNF_Wellorder_ordIso @ A @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% card_of_Times_infinite_simps(2)
thf(fact_4336_card__of__Times__infinite__simps_I3_J,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( B2
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
            @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) )
              @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
                @ ( product_Sigma @ B @ A @ B2
                  @ ^ [Uu: B] : A3 ) )
              @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) )
            @ ( bNF_Wellorder_ordIso @ ( product_prod @ B @ A ) @ A ) ) ) ) ) ).

% card_of_Times_infinite_simps(3)
thf(fact_4337_card__of__Times__infinite__simps_I4_J,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( B2
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) )
            @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 )
              @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
                @ ( product_Sigma @ B @ A @ B2
                  @ ^ [Uu: B] : A3 ) ) )
            @ ( bNF_Wellorder_ordIso @ A @ ( product_prod @ B @ A ) ) ) ) ) ) ).

% card_of_Times_infinite_simps(4)
thf(fact_4338_card__of__Func__Times,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: set @ A,B2: set @ B,C3: set @ C] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( ( product_prod @ A @ B ) > C ) @ ( ( product_prod @ A @ B ) > C ) ) ) @ ( set @ ( product_prod @ ( A > B > C ) @ ( A > B > C ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( ( product_prod @ A @ B ) > C ) @ ( ( product_prod @ A @ B ) > C ) ) ) @ ( set @ ( product_prod @ ( A > B > C ) @ ( A > B > C ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( ( product_prod @ A @ B ) > C )
          @ ( bNF_Wellorder_Func @ ( product_prod @ A @ B ) @ C
            @ ( product_Sigma @ A @ B @ A3
              @ ^ [Uu: A] : B2 )
            @ C3 ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( A > B > C ) @ ( bNF_Wellorder_Func @ A @ ( B > C ) @ A3 @ ( bNF_Wellorder_Func @ B @ C @ B2 @ C3 ) ) ) )
      @ ( bNF_Wellorder_ordIso @ ( ( product_prod @ A @ B ) > C ) @ ( A > B > C ) ) ) ).

% card_of_Func_Times
thf(fact_4339_card__of__empty,axiom,
    ! [B: $tType,A: $tType,A3: set @ B] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( bot_bot @ ( set @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ).

% card_of_empty
thf(fact_4340_card__of__empty3,axiom,
    ! [B: $tType,A: $tType,A3: set @ A] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( bot_bot @ ( set @ B ) ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% card_of_empty3
thf(fact_4341_card__of__empty__ordIso,axiom,
    ! [B: $tType,A: $tType] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( bot_bot @ ( set @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( bot_bot @ ( set @ B ) ) ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ).

% card_of_empty_ordIso
thf(fact_4342_card__of__empty2,axiom,
    ! [B: $tType,A: $tType,A3: set @ A] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( bot_bot @ ( set @ B ) ) ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% card_of_empty2
thf(fact_4343_card__of__ordLeq2,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B2: set @ B] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [G2: B > A] :
              ( ( image2 @ B @ A @ G2 @ B2 )
              = A3 ) )
        = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ) ).

% card_of_ordLeq2
thf(fact_4344_card__of__singl__ordLeq,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B3: B] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( insert @ B @ B3 @ ( bot_bot @ ( set @ B ) ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ).

% card_of_singl_ordLeq
thf(fact_4345_card__of__ordLess2,axiom,
    ! [A: $tType,B: $tType,B2: set @ A,A3: set @ B] :
      ( ( B2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ? [F3: B > A] :
                ( ( image2 @ B @ A @ F3 @ A3 )
                = B2 ) )
        = ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A3 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B2 ) ) @ ( bNF_We4044943003108391690rdLess @ B @ A ) ) ) ) ).

% card_of_ordLess2
thf(fact_4346_card__of__Func__UNIV,axiom,
    ! [B: $tType,A: $tType,B2: set @ B] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) @ ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) @ ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( A > B ) @ ( bNF_Wellorder_Func @ A @ B @ ( top_top @ ( set @ A ) ) @ B2 ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( A > B )
          @ ( collect @ ( A > B )
            @ ^ [F3: A > B] : ( ord_less_eq @ ( set @ B ) @ ( image2 @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) ) @ B2 ) ) ) )
      @ ( bNF_Wellorder_ordIso @ ( A > B ) @ ( A > B ) ) ) ).

% card_of_Func_UNIV
thf(fact_4347_ordLeq__Times__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,R5: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ B @ B ),C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R5 @ R7 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ C )
            @ ( product_Sigma @ A @ C @ ( field2 @ A @ R5 )
              @ ^ [Uu: A] : C3 ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ C )
            @ ( product_Sigma @ B @ C @ ( field2 @ B @ R7 )
              @ ^ [Uu: B] : C3 ) ) )
        @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C ) ) ) ) ).

% ordLeq_Times_mono1
thf(fact_4348_ordLeq__Times__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,R5: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ B @ B ),A3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R5 @ R7 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ C @ A )
            @ ( product_Sigma @ C @ A @ A3
              @ ^ [Uu: C] : ( field2 @ A @ R5 ) ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ C @ B )
            @ ( product_Sigma @ C @ B @ A3
              @ ^ [Uu: C] : ( field2 @ B @ R7 ) ) ) )
        @ ( bNF_Wellorder_ordLeq @ ( product_prod @ C @ A ) @ ( product_prod @ C @ B ) ) ) ) ).

% ordLeq_Times_mono2
thf(fact_4349_Chains__def,axiom,
    ! [A: $tType] :
      ( ( chains @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( set @ A )
            @ ^ [C7: set @ A] :
              ! [X2: A] :
                ( ( member @ A @ X2 @ C7 )
               => ! [Y2: A] :
                    ( ( member @ A @ Y2 @ C7 )
                   => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 )
                      | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X2 ) @ R3 ) ) ) ) ) ) ) ).

% Chains_def
thf(fact_4350_Chains__inits__DiffI,axiom,
    ! [A: $tType,R: set @ ( set @ ( product_prod @ A @ A ) ),S3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( set @ ( set @ ( product_prod @ A @ A ) ) ) @ R @ ( chains @ ( set @ ( product_prod @ A @ A ) ) @ ( init_seg_of @ A ) ) )
     => ( member @ ( set @ ( set @ ( product_prod @ A @ A ) ) )
        @ ( collect @ ( set @ ( product_prod @ A @ A ) )
          @ ^ [Uu: set @ ( product_prod @ A @ A )] :
            ? [R3: set @ ( product_prod @ A @ A )] :
              ( ( Uu
                = ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ S3 ) )
              & ( member @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ R ) ) )
        @ ( chains @ ( set @ ( product_prod @ A @ A ) ) @ ( init_seg_of @ A ) ) ) ) ).

% Chains_inits_DiffI
thf(fact_4351_card__of__UNION__ordLeq__infinite,axiom,
    ! [B: $tType,A: $tType,C: $tType,B2: set @ A,I: set @ B,A3: B > ( set @ C )] :
      ( ~ ( finite_finite2 @ A @ B2 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ I ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B2 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( ! [X: B] :
              ( ( member @ B @ X @ I )
             => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A3 @ X ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B2 ) ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A3 @ I ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B2 ) ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) ) ) ) ).

% card_of_UNION_ordLeq_infinite
thf(fact_4352_Card__order__iff__Restr__underS,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( field2 @ A @ R5 ) )
             => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
                @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
                  @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5
                    @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R5 @ X2 )
                      @ ^ [Uu: A] : ( order_underS @ A @ R5 @ X2 ) ) )
                  @ ( bNF_Ca6860139660246222851ard_of @ A @ ( field2 @ A @ R5 ) ) )
                @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ) ) ).

% Card_order_iff_Restr_underS
thf(fact_4353_card__of__Plus__Times__aux,axiom,
    ! [B: $tType,A: $tType,A14: A,A24: A,A3: set @ A,B2: set @ B] :
      ( ( ( A14 != A24 )
        & ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A14 @ ( insert @ A @ A24 @ ( bot_bot @ ( set @ A ) ) ) ) @ A3 ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A3 @ B2 ) )
            @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
              @ ( product_Sigma @ A @ B @ A3
                @ ^ [Uu: A] : B2 ) ) )
          @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ) ).

% card_of_Plus_Times_aux
thf(fact_4354_card__of__UNION__ordLeq__infinite__Field,axiom,
    ! [B: $tType,A: $tType,C: $tType,R5: set @ ( product_prod @ A @ A ),I: set @ B,A3: B > ( set @ C )] :
      ( ~ ( finite_finite2 @ A @ ( field2 @ A @ R5 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ I ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( ! [X: B] :
                ( ( member @ B @ X @ I )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A3 @ X ) ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A3 @ I ) ) ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) ) ) ) ) ).

% card_of_UNION_ordLeq_infinite_Field
thf(fact_4355_card__of__Times__ordLeq__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ B,B2: set @ C] :
      ( ~ ( finite_finite2 @ A @ ( field2 @ A @ R5 ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A3 ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ B2 ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ C @ A ) )
         => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ C )
                  @ ( product_Sigma @ B @ C @ A3
                    @ ^ [Uu: B] : B2 ) )
                @ R5 )
              @ ( bNF_Wellorder_ordLeq @ ( product_prod @ B @ C ) @ A ) ) ) ) ) ) ).

% card_of_Times_ordLeq_infinite_Field
thf(fact_4356_card__of__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Ca6860139660246222851ard_of @ A )
      = ( ^ [A6: set @ A] : ( fChoice @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca8970107618336181345der_on @ A @ A6 ) ) ) ) ).

% card_of_def
thf(fact_4357_card__of__Times__Plus__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: set @ A,B2: set @ B,C3: set @ C] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ ( sum_sum @ B @ C ) )
          @ ( product_Sigma @ A @ ( sum_sum @ B @ C ) @ A3
            @ ^ [Uu: A] : ( sum_Plus @ B @ C @ B2 @ C3 ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) )
          @ ( sum_Plus @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C )
            @ ( product_Sigma @ A @ B @ A3
              @ ^ [Uu: A] : B2 )
            @ ( product_Sigma @ A @ C @ A3
              @ ^ [Uu: A] : C3 ) ) ) )
      @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) ) ).

% card_of_Times_Plus_distrib
thf(fact_4358_card__of__Plus__Times__bool,axiom,
    ! [A: $tType,A3: set @ A] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ A ) @ ( sum_sum @ A @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ $o ) @ ( product_prod @ A @ $o ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ A ) @ ( sum_sum @ A @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ $o ) @ ( product_prod @ A @ $o ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ A ) @ ( sum_Plus @ A @ A @ A3 @ A3 ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ $o )
          @ ( product_Sigma @ A @ $o @ A3
            @ ^ [Uu: A] : ( top_top @ ( set @ $o ) ) ) ) )
      @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ A ) @ ( product_prod @ A @ $o ) ) ) ).

% card_of_Plus_Times_bool
thf(fact_4359_card__of__Plus__empty2,axiom,
    ! [B: $tType,A: $tType,A3: set @ A] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ A ) @ ( sum_Plus @ B @ A @ ( bot_bot @ ( set @ B ) ) @ A3 ) ) ) @ ( bNF_Wellorder_ordIso @ A @ ( sum_sum @ B @ A ) ) ) ).

% card_of_Plus_empty2
thf(fact_4360_card__of__Plus__empty1,axiom,
    ! [B: $tType,A: $tType,A3: set @ A] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) @ ( bNF_Wellorder_ordIso @ A @ ( sum_sum @ A @ B ) ) ) ).

% card_of_Plus_empty1
thf(fact_4361_Card__order__Times2,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( A3
         != ( bot_bot @ ( set @ B ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ R5
            @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
              @ ( product_Sigma @ B @ A @ A3
                @ ^ [Uu: B] : ( field2 @ A @ R5 ) ) ) )
          @ ( bNF_Wellorder_ordLeq @ A @ ( product_prod @ B @ A ) ) ) ) ) ).

% Card_order_Times2
thf(fact_4362_Card__order__Times1,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ A ),B2: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( B2
         != ( bot_bot @ ( set @ B ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ R5
            @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
              @ ( product_Sigma @ A @ B @ ( field2 @ A @ R5 )
                @ ^ [Uu: A] : B2 ) ) )
          @ ( bNF_Wellorder_ordLeq @ A @ ( product_prod @ A @ B ) ) ) ) ) ).

% Card_order_Times1
thf(fact_4363_Card__order__Times__same__infinite,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ~ ( finite_finite2 @ A @ ( field2 @ A @ R5 ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) )
            @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ A )
              @ ( product_Sigma @ A @ A @ ( field2 @ A @ R5 )
                @ ^ [Uu: A] : ( field2 @ A @ R5 ) ) )
            @ R5 )
          @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ A ) @ A ) ) ) ) ).

% Card_order_Times_same_infinite
thf(fact_4364_card__of__Plus__Times,axiom,
    ! [B: $tType,A: $tType,A14: A,A24: A,A3: set @ A,B13: B,B24: B,B2: set @ B] :
      ( ( ( A14 != A24 )
        & ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A14 @ ( insert @ A @ A24 @ ( bot_bot @ ( set @ A ) ) ) ) @ A3 ) )
     => ( ( ( B13 != B24 )
          & ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ B13 @ ( insert @ B @ B24 @ ( bot_bot @ ( set @ B ) ) ) ) @ B2 ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A3 @ B2 ) )
            @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
              @ ( product_Sigma @ A @ B @ A3
                @ ^ [Uu: A] : B2 ) ) )
          @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ) ).

% card_of_Plus_Times
thf(fact_4365_exists__minim__Card__order,axiom,
    ! [A: $tType,R: set @ ( set @ ( product_prod @ A @ A ) )] :
      ( ( R
       != ( bot_bot @ ( set @ ( set @ ( product_prod @ A @ A ) ) ) ) )
     => ( ! [X: set @ ( product_prod @ A @ A )] :
            ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X @ R )
           => ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ X ) @ X ) )
       => ? [X: set @ ( product_prod @ A @ A )] :
            ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X @ R )
            & ! [Xa3: set @ ( product_prod @ A @ A )] :
                ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ Xa3 @ R )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ X @ Xa3 ) @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ) ) ) ).

% exists_minim_Card_order
thf(fact_4366_Card__order__empty,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( bot_bot @ ( set @ B ) ) ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ).

% Card_order_empty
thf(fact_4367_Card__order__singl__ordLeq,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ A @ A ),B3: B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( ( field2 @ A @ R5 )
         != ( bot_bot @ ( set @ A ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( insert @ B @ B3 @ ( bot_bot @ ( set @ B ) ) ) ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ) ).

% Card_order_singl_ordLeq
thf(fact_4368_card__of__empty1,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( ( order_well_order_on @ A @ ( field2 @ A @ R5 ) @ R5 )
        | ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( bot_bot @ ( set @ B ) ) ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ).

% card_of_empty1
thf(fact_4369_Card__order__Times__infinite,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ A @ A ),P5: set @ ( product_prod @ B @ B )] :
      ( ~ ( finite_finite2 @ A @ ( field2 @ A @ R5 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
       => ( ( ( field2 @ B @ P5 )
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P5 @ R5 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
           => ( ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
                @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) )
                  @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
                    @ ( product_Sigma @ A @ B @ ( field2 @ A @ R5 )
                      @ ^ [Uu: A] : ( field2 @ B @ P5 ) ) )
                  @ R5 )
                @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ B ) @ A ) )
              & ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
                @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) )
                  @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
                    @ ( product_Sigma @ B @ A @ ( field2 @ B @ P5 )
                      @ ^ [Uu: B] : ( field2 @ A @ R5 ) ) )
                  @ R5 )
                @ ( bNF_Wellorder_ordIso @ ( product_prod @ B @ A ) @ A ) ) ) ) ) ) ) ).

% Card_order_Times_infinite
thf(fact_4370_card__of__Sigma__ordLeq__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R5: set @ ( product_prod @ A @ A ),I: set @ B,A3: B > ( set @ C )] :
      ( ~ ( finite_finite2 @ A @ ( field2 @ A @ R5 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ I ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( ! [X: B] :
                ( ( member @ B @ X @ I )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A3 @ X ) ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ C ) @ ( product_Sigma @ B @ C @ I @ A3 ) ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ B @ C ) @ A ) ) ) ) ) ) ).

% card_of_Sigma_ordLeq_infinite_Field
thf(fact_4371_Plus__eq__empty__conv,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B] :
      ( ( ( sum_Plus @ A @ B @ A3 @ B2 )
        = ( bot_bot @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        & ( B2
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% Plus_eq_empty_conv
thf(fact_4372_regularCard__UNION,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ A ),As8: A > ( set @ B ),B2: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( bNF_Ca7133664381575040944arCard @ A @ R5 )
       => ( ( bNF_Ca3754400796208372196lChain @ A @ ( set @ B ) @ R5 @ As8 )
         => ( ( ord_less_eq @ ( set @ B ) @ B2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ As8 @ ( field2 @ A @ R5 ) ) ) )
           => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) @ R5 ) @ ( bNF_We4044943003108391690rdLess @ B @ A ) )
             => ? [X: A] :
                  ( ( member @ A @ X @ ( field2 @ A @ R5 ) )
                  & ( ord_less_eq @ ( set @ B ) @ B2 @ ( As8 @ X ) ) ) ) ) ) ) ) ).

% regularCard_UNION
thf(fact_4373_cardSuc__UNION,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ A ),As8: ( set @ A ) > ( set @ B ),B2: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ~ ( finite_finite2 @ A @ ( field2 @ A @ R5 ) )
       => ( ( bNF_Ca3754400796208372196lChain @ ( set @ A ) @ ( set @ B ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R5 ) @ As8 )
         => ( ( ord_less_eq @ ( set @ B ) @ B2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ ( set @ A ) @ ( set @ B ) @ As8 @ ( field2 @ ( set @ A ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R5 ) ) ) ) )
           => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
             => ? [X: set @ A] :
                  ( ( member @ ( set @ A ) @ X @ ( field2 @ ( set @ A ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R5 ) ) )
                  & ( ord_less_eq @ ( set @ B ) @ B2 @ ( As8 @ X ) ) ) ) ) ) ) ) ).

% cardSuc_UNION
thf(fact_4374_UNION__Cinfinite__bound,axiom,
    ! [A: $tType,B: $tType,C: $tType,I: set @ A,R5: set @ ( product_prod @ B @ B ),A3: A > ( set @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ I ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ! [X: A] :
            ( ( member @ A @ X @ I )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A3 @ X ) ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ C @ B ) ) )
       => ( ( ( bNF_Ca4139267488887388095finite @ B @ R5 )
            & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R5 ) @ R5 ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ A @ ( set @ C ) @ A3 @ I ) ) ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ C @ B ) ) ) ) ) ).

% UNION_Cinfinite_bound
thf(fact_4375_cardSuc__UNION__Cinfinite,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ A ),As8: ( set @ A ) > ( set @ B ),B2: set @ B] :
      ( ( ( bNF_Ca4139267488887388095finite @ A @ R5 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 ) )
     => ( ( bNF_Ca3754400796208372196lChain @ ( set @ A ) @ ( set @ B ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R5 ) @ As8 )
       => ( ( ord_less_eq @ ( set @ B ) @ B2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ ( set @ A ) @ ( set @ B ) @ As8 @ ( field2 @ ( set @ A ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R5 ) ) ) ) )
         => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B2 ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
           => ? [X: set @ A] :
                ( ( member @ ( set @ A ) @ X @ ( field2 @ ( set @ A ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R5 ) ) )
                & ( ord_less_eq @ ( set @ B ) @ B2 @ ( As8 @ X ) ) ) ) ) ) ) ).

% cardSuc_UNION_Cinfinite
thf(fact_4376_SIGMA__CSUM,axiom,
    ! [B: $tType,A: $tType,I: set @ A,As8: A > ( set @ B )] :
      ( ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ I @ As8 ) )
      = ( bNF_Cardinal_Csum @ A @ B @ ( bNF_Ca6860139660246222851ard_of @ A @ I )
        @ ^ [I2: A] : ( bNF_Ca6860139660246222851ard_of @ B @ ( As8 @ I2 ) ) ) ) ).

% SIGMA_CSUM
thf(fact_4377_Csum__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Cardinal_Csum @ A @ B )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),Rs: A > ( set @ ( product_prod @ B @ B ) )] :
            ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
            @ ( product_Sigma @ A @ B @ ( field2 @ A @ R3 )
              @ ^ [I2: A] : ( field2 @ B @ ( Rs @ I2 ) ) ) ) ) ) ).

% Csum_def
thf(fact_4378_cexp__mono2_H,axiom,
    ! [B: $tType,C: $tType,A: $tType,P22: set @ ( product_prod @ A @ A ),R23: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P22 @ R23 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ Q4 ) @ Q4 )
       => ( ( ( ( field2 @ A @ P22 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( field2 @ B @ R23 )
              = ( bot_bot @ ( set @ B ) ) ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( A > C ) @ ( A > C ) ) ) @ ( set @ ( product_prod @ ( B > C ) @ ( B > C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( A > C ) @ ( A > C ) ) ) @ ( set @ ( product_prod @ ( B > C ) @ ( B > C ) ) ) @ ( bNF_Cardinal_cexp @ C @ A @ Q4 @ P22 ) @ ( bNF_Cardinal_cexp @ C @ B @ Q4 @ R23 ) ) @ ( bNF_Wellorder_ordLeq @ ( A > C ) @ ( B > C ) ) ) ) ) ) ).

% cexp_mono2'
thf(fact_4379_pred__on_Onot__maxchain__Some,axiom,
    ! [A: $tType,A3: set @ A,P: A > A > $o,C3: set @ A] :
      ( ( pred_chain @ A @ A3 @ P @ C3 )
     => ( ~ ( pred_maxchain @ A @ A3 @ P @ C3 )
       => ( ( pred_chain @ A @ A3 @ P
            @ ( fChoice @ ( set @ A )
              @ ^ [D6: set @ A] :
                  ( ( pred_chain @ A @ A3 @ P @ D6 )
                  & ( ord_less @ ( set @ A ) @ C3 @ D6 ) ) ) )
          & ( ord_less @ ( set @ A ) @ C3
            @ ( fChoice @ ( set @ A )
              @ ^ [D6: set @ A] :
                  ( ( pred_chain @ A @ A3 @ P @ D6 )
                  & ( ord_less @ ( set @ A ) @ C3 @ D6 ) ) ) ) ) ) ) ).

% pred_on.not_maxchain_Some
thf(fact_4380_subset_Onot__maxchain__Some,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),C3: set @ ( set @ A )] :
      ( ( pred_chain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ C3 )
     => ( ~ ( pred_maxchain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ C3 )
       => ( ( pred_chain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) )
            @ ( fChoice @ ( set @ ( set @ A ) )
              @ ^ [D6: set @ ( set @ A )] :
                  ( ( pred_chain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ D6 )
                  & ( ord_less @ ( set @ ( set @ A ) ) @ C3 @ D6 ) ) ) )
          & ( ord_less @ ( set @ ( set @ A ) ) @ C3
            @ ( fChoice @ ( set @ ( set @ A ) )
              @ ^ [D6: set @ ( set @ A )] :
                  ( ( pred_chain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ D6 )
                  & ( ord_less @ ( set @ ( set @ A ) ) @ C3 @ D6 ) ) ) ) ) ) ) ).

% subset.not_maxchain_Some
thf(fact_4381_cexp__mono_H,axiom,
    ! [B: $tType,D: $tType,A: $tType,C: $tType,P1: set @ ( product_prod @ A @ A ),R12: set @ ( product_prod @ B @ B ),P22: set @ ( product_prod @ C @ C ),R23: set @ ( product_prod @ D @ D )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R12 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ P22 @ R23 ) @ ( bNF_Wellorder_ordLeq @ C @ D ) )
       => ( ( ( ( field2 @ C @ P22 )
              = ( bot_bot @ ( set @ C ) ) )
           => ( ( field2 @ D @ R23 )
              = ( bot_bot @ ( set @ D ) ) ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( D > B ) @ ( D > B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( D > B ) @ ( D > B ) ) ) @ ( bNF_Cardinal_cexp @ A @ C @ P1 @ P22 ) @ ( bNF_Cardinal_cexp @ B @ D @ R12 @ R23 ) ) @ ( bNF_Wellorder_ordLeq @ ( C > A ) @ ( D > B ) ) ) ) ) ) ).

% cexp_mono'
thf(fact_4382_card__of__Csum__Times_H,axiom,
    ! [A: $tType,C: $tType,B: $tType,R5: set @ ( product_prod @ A @ A ),I: set @ B,A3: B > ( set @ C )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ! [X: B] :
            ( ( member @ B @ X @ I )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A3 @ X ) ) @ R5 ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) )
            @ ( bNF_Cardinal_Csum @ B @ C @ ( bNF_Ca6860139660246222851ard_of @ B @ I )
              @ ^ [I2: B] : ( bNF_Ca6860139660246222851ard_of @ C @ ( A3 @ I2 ) ) )
            @ ( bNF_Cardinal_cprod @ B @ A @ ( bNF_Ca6860139660246222851ard_of @ B @ I ) @ R5 ) )
          @ ( bNF_Wellorder_ordLeq @ ( product_prod @ B @ C ) @ ( product_prod @ B @ A ) ) ) ) ) ).

% card_of_Csum_Times'
thf(fact_4383_card__of__Csum__Times,axiom,
    ! [C: $tType,B: $tType,A: $tType,I: set @ A,A3: A > ( set @ B ),B2: set @ C] :
      ( ! [X: A] :
          ( ( member @ A @ X @ I )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( A3 @ X ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ B2 ) ) @ ( bNF_Wellorder_ordLeq @ B @ C ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) )
          @ ( bNF_Cardinal_Csum @ A @ B @ ( bNF_Ca6860139660246222851ard_of @ A @ I )
            @ ^ [I2: A] : ( bNF_Ca6860139660246222851ard_of @ B @ ( A3 @ I2 ) ) )
          @ ( bNF_Cardinal_cprod @ A @ C @ ( bNF_Ca6860139660246222851ard_of @ A @ I ) @ ( bNF_Ca6860139660246222851ard_of @ C @ B2 ) ) )
        @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) ) ).

% card_of_Csum_Times
thf(fact_4384_czeroI,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 )
     => ( ( ( field2 @ A @ R5 )
          = ( bot_bot @ ( set @ A ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R5 @ ( bNF_Cardinal_czero @ B ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ) ) ).

% czeroI
thf(fact_4385_Cnotzero__imp__not__empty,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R5 ) @ R5 ) )
     => ( ( field2 @ A @ R5 )
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% Cnotzero_imp_not_empty
thf(fact_4386_czero__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Cardinal_czero @ A )
      = ( bNF_Ca6860139660246222851ard_of @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% czero_def
thf(fact_4387_cprod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Cardinal_cprod @ A @ B )
      = ( ^ [R13: set @ ( product_prod @ A @ A ),R24: set @ ( product_prod @ B @ B )] :
            ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
            @ ( product_Sigma @ A @ B @ ( field2 @ A @ R13 )
              @ ^ [Uu: A] : ( field2 @ B @ R24 ) ) ) ) ) ).

% cprod_def
thf(fact_4388_czeroE,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R5 @ ( bNF_Cardinal_czero @ B ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( field2 @ A @ R5 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% czeroE
thf(fact_4389_card__of__ordIso__czero__iff__empty,axiom,
    ! [B: $tType,A: $tType,A3: set @ A] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A3 ) @ ( bNF_Cardinal_czero @ B ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% card_of_ordIso_czero_iff_empty
thf(fact_4390_subset_Osuc__def,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),C3: set @ ( set @ A )] :
      ( ( ( ~ ( pred_chain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ C3 )
          | ( pred_maxchain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ C3 ) )
       => ( ( pred_suc @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ C3 )
          = C3 ) )
      & ( ~ ( ~ ( pred_chain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ C3 )
            | ( pred_maxchain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ C3 ) )
       => ( ( pred_suc @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ C3 )
          = ( fChoice @ ( set @ ( set @ A ) )
            @ ^ [D6: set @ ( set @ A )] :
                ( ( pred_chain @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) @ D6 )
                & ( ord_less @ ( set @ ( set @ A ) ) @ C3 @ D6 ) ) ) ) ) ) ).

% subset.suc_def
thf(fact_4391_pred__on_Osuc__def,axiom,
    ! [A: $tType] :
      ( ( pred_suc @ A )
      = ( ^ [A6: set @ A,P3: A > A > $o,C7: set @ A] :
            ( if @ ( set @ A )
            @ ( ~ ( pred_chain @ A @ A6 @ P3 @ C7 )
              | ( pred_maxchain @ A @ A6 @ P3 @ C7 ) )
            @ C7
            @ ( fChoice @ ( set @ A )
              @ ^ [D6: set @ A] :
                  ( ( pred_chain @ A @ A6 @ P3 @ D6 )
                  & ( ord_less @ ( set @ A ) @ C7 @ D6 ) ) ) ) ) ) ).

% pred_on.suc_def
thf(fact_4392_prod__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,X3: A,Y: B] :
      ( ( basic_fsts @ A @ B @ ( product_Pair @ A @ B @ X3 @ Y ) )
      = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% prod_set_simps(1)
thf(fact_4393_prod__set__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X3: A,Y: B] :
      ( ( basic_snds @ A @ B @ ( product_Pair @ A @ B @ X3 @ Y ) )
      = ( insert @ B @ Y @ ( bot_bot @ ( set @ B ) ) ) ) ).

% prod_set_simps(2)
thf(fact_4394_prod__set__defs_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_fsts @ A @ B )
      = ( ^ [P6: product_prod @ A @ B] : ( insert @ A @ ( product_fst @ A @ B @ P6 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% prod_set_defs(1)
thf(fact_4395_prod__set__defs_I2_J,axiom,
    ! [D: $tType,C: $tType] :
      ( ( basic_snds @ C @ D )
      = ( ^ [P6: product_prod @ C @ D] : ( insert @ D @ ( product_snd @ C @ D @ P6 ) @ ( bot_bot @ ( set @ D ) ) ) ) ) ).

% prod_set_defs(2)
thf(fact_4396_funpow__inj__finite,axiom,
    ! [A: $tType,P5: A > A,X3: A] :
      ( ( inj_on @ A @ A @ P5 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ A
          @ ( collect @ A
            @ ^ [Y2: A] :
              ? [N5: nat] :
                ( Y2
                = ( compow @ ( A > A ) @ N5 @ P5 @ X3 ) ) ) )
       => ~ ! [N2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( compow @ ( A > A ) @ N2 @ P5 @ X3 )
               != X3 ) ) ) ) ).

% funpow_inj_finite
thf(fact_4397_single__valuedp__single__valued__eq,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ B )] :
      ( ( single_valuedp @ A @ B
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R5 ) )
      = ( single_valued @ A @ B @ R5 ) ) ).

% single_valuedp_single_valued_eq
thf(fact_4398_Code__Numeral_Osub__def,axiom,
    ( code_sub
    = ( map_fun @ num @ num @ ( num > int ) @ ( num > code_integer ) @ ( id @ num ) @ ( map_fun @ num @ num @ int @ code_integer @ ( id @ num ) @ code_integer_of_int )
      @ ^ [M5: num,N5: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M5 ) @ ( numeral_numeral @ int @ N5 ) ) ) ) ).

% Code_Numeral.sub_def
thf(fact_4399_set__encode__empty,axiom,
    ( ( nat_set_encode @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% set_encode_empty
thf(fact_4400_comp__fun__commute_Ocomp__fun__commute__funpow,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,G: A > nat] :
      ( ( finite6289374366891150609ommute @ A @ B @ F2 )
     => ( finite6289374366891150609ommute @ A @ B
        @ ^ [X2: A] : ( compow @ ( B > B ) @ ( G @ X2 ) @ ( F2 @ X2 ) ) ) ) ).

% comp_fun_commute.comp_fun_commute_funpow
thf(fact_4401_comp__fun__commute__on_Ocomp__fun__commute__on__funpow,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,G: A > nat] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( finite4664212375090638736ute_on @ A @ B @ S2
        @ ^ [X2: A] : ( compow @ ( B > B ) @ ( G @ X2 ) @ ( F2 @ X2 ) ) ) ) ).

% comp_fun_commute_on.comp_fun_commute_on_funpow
thf(fact_4402_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F2: A > nat,X3: A] :
          ( ( compow @ ( A > A ) @ ( F2 @ X3 ) @ ( times_times @ A @ X3 ) )
          = ( times_times @ A @ ( power_power @ A @ X3 @ ( F2 @ X3 ) ) ) ) ) ).

% funpow_times_power
thf(fact_4403_relpowp__relpow__eq,axiom,
    ! [A: $tType,N: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( A > A > $o ) @ N
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R ) )
      = ( ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) ) ) ) ).

% relpowp_relpow_eq
thf(fact_4404_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F2: A > A,P5: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ P5 ) @ P5 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) @ P5 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_4405_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F2: A > A,P5: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ P5 @ ( F2 @ P5 ) )
           => ( ord_less_eq @ A @ P5 @ ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_4406_single__valuedp__bot,axiom,
    ! [B: $tType,A: $tType] : ( single_valuedp @ A @ B @ ( bot_bot @ ( A > B > $o ) ) ) ).

% single_valuedp_bot
thf(fact_4407_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( A > A > $o ) @ N @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_4408_single__valuedp__iff__Uniq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( single_valuedp @ A @ B )
      = ( ^ [R3: A > B > $o] :
          ! [X2: A] : ( uniq @ B @ ( R3 @ X2 ) ) ) ) ).

% single_valuedp_iff_Uniq
thf(fact_4409_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N5: nat] : ( compow @ ( A > A ) @ N5 @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_4410_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A4: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A4 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A4 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_4411_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I2: nat] : ( compow @ ( A > A ) @ I2 @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_4412_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M2: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M2 @ F2 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_4413_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M2: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F2 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M2 @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_4414_lfp__Kleene__iter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ( compow @ ( A > A ) @ ( suc @ K ) @ F2 @ ( bot_bot @ A ) )
              = ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) )
           => ( ( complete_lattice_lfp @ A @ F2 )
              = ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% lfp_Kleene_iter
thf(fact_4415_gfp__Kleene__iter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ( compow @ ( A > A ) @ ( suc @ K ) @ F2 @ ( top_top @ A ) )
              = ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) )
           => ( ( complete_lattice_gfp @ A @ F2 )
              = ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% gfp_Kleene_iter
thf(fact_4416_inj__on__funpow__least,axiom,
    ! [A: $tType,N: nat,F2: A > A,S3: A] :
      ( ( ( compow @ ( A > A ) @ N @ F2 @ S3 )
        = S3 )
     => ( ! [M3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M3 )
           => ( ( ord_less @ nat @ M3 @ N )
             => ( ( compow @ ( A > A ) @ M3 @ F2 @ S3 )
               != S3 ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K6: nat] : ( compow @ ( A > A ) @ K6 @ F2 @ S3 )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% inj_on_funpow_least
thf(fact_4417_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K6: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K6 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_4418_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_antimono @ nat @ A
            @ ^ [I2: nat] : ( compow @ ( A > A ) @ I2 @ Q @ ( top_top @ A ) ) ) ) ) ).

% antimono_funpow
thf(fact_4419_su__rel__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( su_rel_fun @ A @ B )
      = ( ^ [F5: set @ ( product_prod @ A @ B ),F3: A > B] :
            ( ! [A6: A,B5: B,B16: B] :
                ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B5 ) @ F5 )
               => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B16 ) @ F5 )
                 => ( B5 = B16 ) ) )
            & ! [A6: A,P3: $o] :
                ( ! [B5: B] :
                    ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B5 ) @ F5 )
                   => P3 )
               => P3 )
            & ! [A6: A] :
                ( ( F3 @ A6 )
                = ( the @ B
                  @ ^ [B5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B5 ) @ F5 ) ) ) ) ) ) ).

% su_rel_fun_def
thf(fact_4420_su__rel__fun_Ointro,axiom,
    ! [B: $tType,A: $tType,F: set @ ( product_prod @ A @ B ),F2: A > B] :
      ( ! [A12: A,B10: B,B17: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A12 @ B10 ) @ F )
         => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A12 @ B17 ) @ F )
           => ( B10 = B17 ) ) )
     => ( ! [A12: A,P4: $o] :
            ( ! [B18: B] :
                ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A12 @ B18 ) @ F )
               => P4 )
           => P4 )
       => ( ! [A12: A] :
              ( ( F2 @ A12 )
              = ( the @ B
                @ ^ [B5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A12 @ B5 ) @ F ) ) )
         => ( su_rel_fun @ A @ B @ F @ F2 ) ) ) ) ).

% su_rel_fun.intro
thf(fact_4421_su__rel__fun_Of__def,axiom,
    ! [A: $tType,B: $tType,F: set @ ( product_prod @ A @ B ),F2: A > B,A3: A] :
      ( ( su_rel_fun @ A @ B @ F @ F2 )
     => ( ( F2 @ A3 )
        = ( the @ B
          @ ^ [B5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B5 ) @ F ) ) ) ) ).

% su_rel_fun.f_def
thf(fact_4422_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
             => ( ord_less_eq @ B @ ( F3 @ Y2 ) @ ( F3 @ X2 ) ) ) ) ) ) ).

% antimono_def
thf(fact_4423_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X: A,Y3: A] :
              ( ( ord_less_eq @ A @ X @ Y3 )
             => ( ord_less_eq @ B @ ( F2 @ Y3 ) @ ( F2 @ X ) ) )
         => ( order_antimono @ A @ B @ F2 ) ) ) ).

% antimonoI
thf(fact_4424_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X3 @ Y )
           => ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X3 ) ) ) ) ) ).

% antimonoE
thf(fact_4425_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X3 @ Y )
           => ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X3 ) ) ) ) ) ).

% antimonoD
thf(fact_4426_min__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,X3: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_min @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) )
            = ( F2 @ ( ord_max @ A @ X3 @ Y ) ) ) ) ) ).

% min_of_antimono
thf(fact_4427_max__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,X3: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_max @ B @ ( F2 @ X3 ) @ ( F2 @ Y ) )
            = ( F2 @ ( ord_min @ A @ X3 @ Y ) ) ) ) ) ).

% max_of_antimono
thf(fact_4428_aboveS__def,axiom,
    ! [A: $tType] :
      ( ( order_aboveS @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),A5: A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( B4 != A5 )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R3 ) ) ) ) ) ).

% aboveS_def
thf(fact_4429_cardSuc__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Ca8387033319878233205ardSuc @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] : ( fChoice @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( bNF_Ca6246979054910435723ardSuc @ A @ R3 ) ) ) ) ).

% cardSuc_def
thf(fact_4430_scomp__unfold,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( product_scomp @ A @ B @ C @ D )
      = ( ^ [F3: A > ( product_prod @ B @ C ),G2: B > C > D,X2: A] : ( G2 @ ( product_fst @ B @ C @ ( F3 @ X2 ) ) @ ( product_snd @ B @ C @ ( F3 @ X2 ) ) ) ) ) ).

% scomp_unfold
thf(fact_4431_semilattice__order__set_Osubset__imp,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: set @ A,B2: set @ A] :
      ( ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
       => ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_finite2 @ A @ B2 )
           => ( Less_eq @ ( lattic1715443433743089157tice_F @ A @ F2 @ B2 ) @ ( lattic1715443433743089157tice_F @ A @ F2 @ A3 ) ) ) ) ) ) ).

% semilattice_order_set.subset_imp
thf(fact_4432_scomp__scomp,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F10: $tType,E: $tType,F2: A > ( product_prod @ E @ F10 ),G: E > F10 > ( product_prod @ C @ D ),H2: C > D > B] :
      ( ( product_scomp @ A @ C @ D @ B @ ( product_scomp @ A @ E @ F10 @ ( product_prod @ C @ D ) @ F2 @ G ) @ H2 )
      = ( product_scomp @ A @ E @ F10 @ B @ F2
        @ ^ [X2: E] : ( product_scomp @ F10 @ C @ D @ B @ ( G @ X2 ) @ H2 ) ) ) ).

% scomp_scomp
thf(fact_4433_Inf__fin__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( lattic1715443433743089157tice_F @ A @ ( inf_inf @ A ) ) ) ) ).

% Inf_fin_def
thf(fact_4434_semilattice__order__set_Obounded__iff,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: set @ A,X3: A] :
      ( ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( Less_eq @ X3 @ ( lattic1715443433743089157tice_F @ A @ F2 @ A3 ) )
            = ( ! [X2: A] :
                  ( ( member @ A @ X2 @ A3 )
                 => ( Less_eq @ X3 @ X2 ) ) ) ) ) ) ) ).

% semilattice_order_set.bounded_iff
thf(fact_4435_semilattice__order__set_OboundedI,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: set @ A,X3: A] :
      ( ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [A7: A] :
                ( ( member @ A @ A7 @ A3 )
               => ( Less_eq @ X3 @ A7 ) )
           => ( Less_eq @ X3 @ ( lattic1715443433743089157tice_F @ A @ F2 @ A3 ) ) ) ) ) ) ).

% semilattice_order_set.boundedI
thf(fact_4436_semilattice__order__set_OboundedE,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: set @ A,X3: A] :
      ( ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( Less_eq @ X3 @ ( lattic1715443433743089157tice_F @ A @ F2 @ A3 ) )
           => ! [A16: A] :
                ( ( member @ A @ A16 @ A3 )
               => ( Less_eq @ X3 @ A16 ) ) ) ) ) ) ).

% semilattice_order_set.boundedE
thf(fact_4437_semilattice__set_Oeq__fold_H,axiom,
    ! [A: $tType,F2: A > A > A,A3: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( lattic1715443433743089157tice_F @ A @ F2 @ A3 )
        = ( the2 @ A
          @ ( finite_fold @ A @ ( option @ A )
            @ ^ [X2: A,Y2: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( F2 @ X2 ) @ Y2 ) )
            @ ( none @ A )
            @ A3 ) ) ) ) ).

% semilattice_set.eq_fold'
thf(fact_4438_semilattice__set_Oremove,axiom,
    ! [A: $tType,F2: A > A > A,A3: set @ A,X3: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( member @ A @ X3 @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic1715443433743089157tice_F @ A @ F2 @ A3 )
                = X3 ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic1715443433743089157tice_F @ A @ F2 @ A3 )
                = ( F2 @ X3 @ ( lattic1715443433743089157tice_F @ A @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% semilattice_set.remove
thf(fact_4439_semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F2: A > A > A,A3: set @ A,X3: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( insert @ A @ X3 @ A3 ) )
              = X3 ) )
          & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( insert @ A @ X3 @ A3 ) )
              = ( F2 @ X3 @ ( lattic1715443433743089157tice_F @ A @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% semilattice_set.insert_remove
thf(fact_4440_semilattice__set_Ounion,axiom,
    ! [A: $tType,F2: A > A > A,A3: set @ A,B2: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_finite2 @ A @ B2 )
           => ( ( B2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
                = ( F2 @ ( lattic1715443433743089157tice_F @ A @ F2 @ A3 ) @ ( lattic1715443433743089157tice_F @ A @ F2 @ B2 ) ) ) ) ) ) ) ) ).

% semilattice_set.union
thf(fact_4441_Inf__fin_Osemilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( lattic149705377957585745ce_set @ A @ ( inf_inf @ A ) ) ) ).

% Inf_fin.semilattice_set_axioms
thf(fact_4442_semilattice__set_Osingleton,axiom,
    ! [A: $tType,F2: A > A > A,X3: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
        = X3 ) ) ).

% semilattice_set.singleton
thf(fact_4443_semilattice__set_Ohom__commute,axiom,
    ! [A: $tType,F2: A > A > A,H2: A > A,N4: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ! [X: A,Y3: A] :
            ( ( H2 @ ( F2 @ X @ Y3 ) )
            = ( F2 @ ( H2 @ X ) @ ( H2 @ Y3 ) ) )
       => ( ( finite_finite2 @ A @ N4 )
         => ( ( N4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( H2 @ ( lattic1715443433743089157tice_F @ A @ F2 @ N4 ) )
              = ( lattic1715443433743089157tice_F @ A @ F2 @ ( image2 @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% semilattice_set.hom_commute
thf(fact_4444_semilattice__set_Osubset,axiom,
    ! [A: $tType,F2: A > A > A,A3: set @ A,B2: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( B2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A3 )
           => ( ( F2 @ ( lattic1715443433743089157tice_F @ A @ F2 @ B2 ) @ ( lattic1715443433743089157tice_F @ A @ F2 @ A3 ) )
              = ( lattic1715443433743089157tice_F @ A @ F2 @ A3 ) ) ) ) ) ) ).

% semilattice_set.subset
thf(fact_4445_semilattice__set_Oinsert__not__elem,axiom,
    ! [A: $tType,F2: A > A > A,A3: set @ A,X3: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ~ ( member @ A @ X3 @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( insert @ A @ X3 @ A3 ) )
              = ( F2 @ X3 @ ( lattic1715443433743089157tice_F @ A @ F2 @ A3 ) ) ) ) ) ) ) ).

% semilattice_set.insert_not_elem
thf(fact_4446_semilattice__set_Oinsert,axiom,
    ! [A: $tType,F2: A > A > A,A3: set @ A,X3: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( insert @ A @ X3 @ A3 ) )
            = ( F2 @ X3 @ ( lattic1715443433743089157tice_F @ A @ F2 @ A3 ) ) ) ) ) ) ).

% semilattice_set.insert
thf(fact_4447_semilattice__set_Oclosed,axiom,
    ! [A: $tType,F2: A > A > A,A3: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A,Y3: A] : ( member @ A @ ( F2 @ X @ Y3 ) @ ( insert @ A @ X @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
           => ( member @ A @ ( lattic1715443433743089157tice_F @ A @ F2 @ A3 ) @ A3 ) ) ) ) ) ).

% semilattice_set.closed
thf(fact_4448_cr__int__def,axiom,
    ( cr_int
    = ( ^ [X2: product_prod @ nat @ nat] :
          ( ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
          @ ( abs_Integ @ X2 ) ) ) ) ).

% cr_int_def
thf(fact_4449_antisymp__antisym__eq,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( antisymp @ A
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) )
      = ( antisym @ A @ R5 ) ) ).

% antisymp_antisym_eq
thf(fact_4450_mult__inj__if__coprime__nat,axiom,
    ! [B: $tType,A: $tType,F2: A > nat,A3: set @ A,G: B > nat,B2: set @ B] :
      ( ( inj_on @ A @ nat @ F2 @ A3 )
     => ( ( inj_on @ B @ nat @ G @ B2 )
       => ( ! [A7: A,B6: B] :
              ( ( member @ A @ A7 @ A3 )
             => ( ( member @ B @ B6 @ B2 )
               => ( algebr8660921524188924756oprime @ nat @ ( F2 @ A7 ) @ ( G @ B6 ) ) ) )
         => ( inj_on @ ( product_prod @ A @ B ) @ nat
            @ ( product_case_prod @ A @ B @ nat
              @ ^ [A5: A,B4: B] : ( times_times @ nat @ ( F2 @ A5 ) @ ( G @ B4 ) ) )
            @ ( product_Sigma @ A @ B @ A3
              @ ^ [Uu: A] : B2 ) ) ) ) ) ).

% mult_inj_if_coprime_nat
thf(fact_4451_K__record__comp,axiom,
    ! [C: $tType,B: $tType,A: $tType,C2: B,F2: A > C] :
      ( ( comp @ C @ B @ A
        @ ^ [X2: C] : C2
        @ F2 )
      = ( ^ [X2: A] : C2 ) ) ).

% K_record_comp
thf(fact_4452_coprime__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ ( times_times @ A @ A4 @ B3 ) )
          = ( ( algebr8660921524188924756oprime @ A @ C2 @ A4 )
            & ( algebr8660921524188924756oprime @ A @ C2 @ B3 ) ) ) ) ).

% coprime_mult_right_iff
thf(fact_4453_coprime__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 )
          = ( ( algebr8660921524188924756oprime @ A @ A4 @ C2 )
            & ( algebr8660921524188924756oprime @ A @ B3 @ C2 ) ) ) ) ).

% coprime_mult_left_iff
thf(fact_4454_coprime__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A] :
          ( ( algebr8660921524188924756oprime @ A @ A4 @ A4 )
          = ( dvd_dvd @ A @ A4 @ ( one_one @ A ) ) ) ) ).

% coprime_self
thf(fact_4455_coprime__imp__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ A4 @ B3 )
         => ( ( gcd_gcd @ A @ A4 @ B3 )
            = ( one_one @ A ) ) ) ) ).

% coprime_imp_gcd_eq_1
thf(fact_4456_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A] :
          ( ( algebr8660921524188924756oprime @ A @ A4 @ ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ A4 @ ( one_one @ A ) ) ) ) ).

% coprime_0_right_iff
thf(fact_4457_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( zero_zero @ A ) @ A4 )
          = ( dvd_dvd @ A @ A4 @ ( one_one @ A ) ) ) ) ).

% coprime_0_left_iff
thf(fact_4458_coprime__mult__self__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ) ).

% coprime_mult_self_left_iff
thf(fact_4459_coprime__mult__self__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ) ).

% coprime_mult_self_right_iff
thf(fact_4460_is__unit__gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A4 @ B3 ) @ ( one_one @ A ) )
          = ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ).

% is_unit_gcd
thf(fact_4461_prod__coprime__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ B,F2: B > A,A4: A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( algebr8660921524188924756oprime @ A @ ( F2 @ I4 ) @ A4 ) )
         => ( algebr8660921524188924756oprime @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ A4 ) ) ) ).

% prod_coprime_left
thf(fact_4462_prod__coprime__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ B,A4: A,F2: B > A] :
          ( ! [I4: B] :
              ( ( member @ B @ I4 @ A3 )
             => ( algebr8660921524188924756oprime @ A @ A4 @ ( F2 @ I4 ) ) )
         => ( algebr8660921524188924756oprime @ A @ A4 @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_coprime_right
thf(fact_4463_coprime__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [B4: A,A5: A] : ( algebr8660921524188924756oprime @ A @ A5 @ B4 ) ) ) ) ).

% coprime_commute
thf(fact_4464_coprime__divisors,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( ( dvd_dvd @ A @ A4 @ C2 )
         => ( ( dvd_dvd @ A @ B3 @ D3 )
           => ( ( algebr8660921524188924756oprime @ A @ C2 @ D3 )
             => ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ) ) ).

% coprime_divisors
thf(fact_4465_coprime__1__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A] : ( algebr8660921524188924756oprime @ A @ ( one_one @ A ) @ A4 ) ) ).

% coprime_1_left
thf(fact_4466_coprime__1__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A] : ( algebr8660921524188924756oprime @ A @ A4 @ ( one_one @ A ) ) ) ).

% coprime_1_right
thf(fact_4467_coprime__add__one__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A] : ( algebr8660921524188924756oprime @ A @ A4 @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) ) ) ).

% coprime_add_one_right
thf(fact_4468_coprime__add__one__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A] : ( algebr8660921524188924756oprime @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) @ A4 ) ) ).

% coprime_add_one_left
thf(fact_4469_coprime__doff__one__right,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A4: A] : ( algebr8660921524188924756oprime @ A @ A4 @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) ) ) ).

% coprime_doff_one_right
thf(fact_4470_coprime__diff__one__left,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A4: A] : ( algebr8660921524188924756oprime @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) @ A4 ) ) ).

% coprime_diff_one_left
thf(fact_4471_coprime__dvd__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ A4 @ C2 )
         => ( ( dvd_dvd @ A @ A4 @ ( times_times @ A @ C2 @ B3 ) )
            = ( dvd_dvd @ A @ A4 @ B3 ) ) ) ) ).

% coprime_dvd_mult_right_iff
thf(fact_4472_coprime__dvd__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ A4 @ C2 )
         => ( ( dvd_dvd @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) )
            = ( dvd_dvd @ A @ A4 @ B3 ) ) ) ) ).

% coprime_dvd_mult_left_iff
thf(fact_4473_divides__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ C2 )
         => ( ( dvd_dvd @ A @ B3 @ C2 )
           => ( ( algebr8660921524188924756oprime @ A @ A4 @ B3 )
             => ( dvd_dvd @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 ) ) ) ) ) ).

% divides_mult
thf(fact_4474_is__unit__right__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B3: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ).

% is_unit_right_imp_coprime
thf(fact_4475_is__unit__left__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ).

% is_unit_left_imp_coprime
thf(fact_4476_coprime__common__divisor,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A4 @ B3 )
         => ( ( dvd_dvd @ A @ C2 @ A4 )
           => ( ( dvd_dvd @ A @ C2 @ B3 )
             => ( dvd_dvd @ A @ C2 @ ( one_one @ A ) ) ) ) ) ) ).

% coprime_common_divisor
thf(fact_4477_coprime__absorb__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [Y: A,X3: A] :
          ( ( dvd_dvd @ A @ Y @ X3 )
         => ( ( algebr8660921524188924756oprime @ A @ X3 @ Y )
            = ( dvd_dvd @ A @ Y @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_right
thf(fact_4478_coprime__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,D3: A,A4: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ D3 )
         => ( ! [E4: A] :
                ( ~ ( dvd_dvd @ A @ E4 @ ( one_one @ A ) )
               => ( ( dvd_dvd @ A @ E4 @ A4 )
                 => ( ( dvd_dvd @ A @ E4 @ B3 )
                   => ( dvd_dvd @ A @ E4 @ C2 ) ) ) )
           => ( ! [E4: A] :
                  ( ~ ( dvd_dvd @ A @ E4 @ ( one_one @ A ) )
                 => ( ( dvd_dvd @ A @ E4 @ A4 )
                   => ( ( dvd_dvd @ A @ E4 @ B3 )
                     => ( dvd_dvd @ A @ E4 @ D3 ) ) ) )
             => ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ) ) ).

% coprime_imp_coprime
thf(fact_4479_coprime__absorb__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X3: A,Y: A] :
          ( ( dvd_dvd @ A @ X3 @ Y )
         => ( ( algebr8660921524188924756oprime @ A @ X3 @ Y )
            = ( dvd_dvd @ A @ X3 @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_left
thf(fact_4480_not__coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( dvd_dvd @ A @ C2 @ A4 )
         => ( ( dvd_dvd @ A @ C2 @ B3 )
           => ( ~ ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
             => ~ ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ) ) ).

% not_coprimeI
thf(fact_4481_not__coprimeE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ~ ( algebr8660921524188924756oprime @ A @ A4 @ B3 )
         => ~ ! [C4: A] :
                ( ( dvd_dvd @ A @ C4 @ A4 )
               => ( ( dvd_dvd @ A @ C4 @ B3 )
                 => ( dvd_dvd @ A @ C4 @ ( one_one @ A ) ) ) ) ) ) ).

% not_coprimeE
thf(fact_4482_coprime__def,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [A5: A,B4: A] :
            ! [C5: A] :
              ( ( dvd_dvd @ A @ C5 @ A5 )
             => ( ( dvd_dvd @ A @ C5 @ B4 )
               => ( dvd_dvd @ A @ C5 @ ( one_one @ A ) ) ) ) ) ) ) ).

% coprime_def
thf(fact_4483_coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: A,B3: A] :
          ( ! [C4: A] :
              ( ( dvd_dvd @ A @ C4 @ A4 )
             => ( ( dvd_dvd @ A @ C4 @ B3 )
               => ( dvd_dvd @ A @ C4 @ ( one_one @ A ) ) ) )
         => ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ).

% coprimeI
thf(fact_4484_mult__mod__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [N: A,A4: A,M2: A,B3: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ N @ A4 ) @ M2 )
            = ( modulo_modulo @ A @ ( times_times @ A @ N @ B3 ) @ M2 ) )
         => ( ( algebr8660921524188924756oprime @ A @ M2 @ N )
           => ( ( modulo_modulo @ A @ A4 @ M2 )
              = ( modulo_modulo @ A @ B3 @ M2 ) ) ) ) ) ).

% mult_mod_cancel_left
thf(fact_4485_mult__mod__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [A4: A,N: A,M2: A,B3: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A4 @ N ) @ M2 )
            = ( modulo_modulo @ A @ ( times_times @ A @ B3 @ N ) @ M2 ) )
         => ( ( algebr8660921524188924756oprime @ A @ M2 @ N )
           => ( ( modulo_modulo @ A @ A4 @ M2 )
              = ( modulo_modulo @ A @ B3 @ M2 ) ) ) ) ) ).

% mult_mod_cancel_right
thf(fact_4486_gcd__mult__right__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ A4 @ C2 )
         => ( ( gcd_gcd @ A @ A4 @ ( times_times @ A @ B3 @ C2 ) )
            = ( gcd_gcd @ A @ A4 @ B3 ) ) ) ) ).

% gcd_mult_right_right_cancel
thf(fact_4487_gcd__mult__right__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ A4 @ C2 )
         => ( ( gcd_gcd @ A @ A4 @ ( times_times @ A @ C2 @ B3 ) )
            = ( gcd_gcd @ A @ A4 @ B3 ) ) ) ) ).

% gcd_mult_right_left_cancel
thf(fact_4488_gcd__mult__left__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( algebr8660921524188924756oprime @ A @ B3 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ A4 @ C2 ) @ B3 )
            = ( gcd_gcd @ A @ A4 @ B3 ) ) ) ) ).

% gcd_mult_left_right_cancel
thf(fact_4489_gcd__mult__left__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B3: A,C2: A,A4: A] :
          ( ( algebr8660921524188924756oprime @ A @ B3 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A4 ) @ B3 )
            = ( gcd_gcd @ A @ A4 @ B3 ) ) ) ) ).

% gcd_mult_left_left_cancel
thf(fact_4490_gcd__eq__1__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( ( gcd_gcd @ A @ A4 @ B3 )
            = ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ).

% gcd_eq_1_imp_coprime
thf(fact_4491_coprime__iff__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( gcd_gcd @ A @ A5 @ B4 )
              = ( one_one @ A ) ) ) ) ) ).

% coprime_iff_gcd_eq_1
thf(fact_4492_antisym__bot,axiom,
    ! [A: $tType] : ( antisymp @ A @ ( bot_bot @ ( A > A > $o ) ) ) ).

% antisym_bot
thf(fact_4493_invertible__coprime,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A4 @ B3 ) @ C2 )
            = ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A4 @ C2 ) ) ) ).

% invertible_coprime
thf(fact_4494_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( ( gcd_gcd @ A @ A4 @ B3 )
           != ( zero_zero @ A ) )
         => ? [A10: A,B14: A] :
              ( ( A4
                = ( times_times @ A @ A10 @ ( gcd_gcd @ A @ A4 @ B3 ) ) )
              & ( B3
                = ( times_times @ A @ B14 @ ( gcd_gcd @ A @ A4 @ B3 ) ) )
              & ( algebr8660921524188924756oprime @ A @ A10 @ B14 ) ) ) ) ).

% gcd_coprime_exists
thf(fact_4495_gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,A8: A,B7: A] :
          ( ( ( gcd_gcd @ A @ A4 @ B3 )
           != ( zero_zero @ A ) )
         => ( ( A4
              = ( times_times @ A @ A8 @ ( gcd_gcd @ A @ A4 @ B3 ) ) )
           => ( ( B3
                = ( times_times @ A @ B7 @ ( gcd_gcd @ A @ A4 @ B3 ) ) )
             => ( algebr8660921524188924756oprime @ A @ A8 @ B7 ) ) ) ) ) ).

% gcd_coprime
thf(fact_4496_bind__singleton__conv__image,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,F2: B > A] :
      ( ( bind3 @ B @ A @ A3
        @ ^ [X2: B] : ( insert @ A @ ( F2 @ X2 ) @ ( bot_bot @ ( set @ A ) ) ) )
      = ( image2 @ B @ A @ F2 @ A3 ) ) ).

% bind_singleton_conv_image
thf(fact_4497_and_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( semilattice_neutr @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.semilattice_neutr_axioms
thf(fact_4498_Func__empty,axiom,
    ! [B: $tType,A: $tType,B2: set @ B] :
      ( ( bNF_Wellorder_Func @ A @ B @ ( bot_bot @ ( set @ A ) ) @ B2 )
      = ( insert @ ( A > B )
        @ ^ [X2: A] : ( undefined @ B )
        @ ( bot_bot @ ( set @ ( A > B ) ) ) ) ) ).

% Func_empty
thf(fact_4499_Restr__natLeq2,axiom,
    ! [N: nat] :
      ( ( inf_inf @ ( set @ ( product_prod @ nat @ nat ) ) @ bNF_Ca8665028551170535155natLeq
        @ ( product_Sigma @ nat @ nat @ ( order_underS @ nat @ bNF_Ca8665028551170535155natLeq @ N )
          @ ^ [Uu: nat] : ( order_underS @ nat @ bNF_Ca8665028551170535155natLeq @ N ) ) )
      = ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y2: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y2 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) ) ).

% Restr_natLeq2
thf(fact_4500_empty__bind,axiom,
    ! [B: $tType,A: $tType,F2: B > ( set @ A )] :
      ( ( bind3 @ B @ A @ ( bot_bot @ ( set @ B ) ) @ F2 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% empty_bind
thf(fact_4501_mod__h__bot__normalize,axiom,
    ! [A: $tType,H2: heap_ext @ product_unit,P: assn] :
      ( ( syntax7388354845996824322omatch @ A @ ( heap_ext @ product_unit ) @ ( undefined @ A ) @ H2 )
     => ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        = ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ ( undefined @ ( heap_ext @ product_unit ) ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_normalize
thf(fact_4502_Set_Obind__bind,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: set @ A,B2: A > ( set @ C ),C3: C > ( set @ B )] :
      ( ( bind3 @ C @ B @ ( bind3 @ A @ C @ A3 @ B2 ) @ C3 )
      = ( bind3 @ A @ B @ A3
        @ ^ [X2: A] : ( bind3 @ C @ B @ ( B2 @ X2 ) @ C3 ) ) ) ).

% Set.bind_bind
thf(fact_4503_natLeq__underS__less,axiom,
    ! [N: nat] :
      ( ( order_underS @ nat @ bNF_Ca8665028551170535155natLeq @ N )
      = ( collect @ nat
        @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) ) ) ).

% natLeq_underS_less
thf(fact_4504_semilattice__neutr_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( semilattice_neutr @ A @ F2 @ Z2 )
     => ( comm_monoid @ A @ F2 @ Z2 ) ) ).

% semilattice_neutr.axioms(2)
thf(fact_4505_bind__const,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,B2: set @ A] :
      ( ( ( A3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( bind3 @ B @ A @ A3
            @ ^ [Uu: B] : B2 )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( bind3 @ B @ A @ A3
            @ ^ [Uu: B] : B2 )
          = B2 ) ) ) ).

% bind_const
thf(fact_4506_nonempty__bind__const,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B2: set @ B] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( bind3 @ A @ B @ A3
          @ ^ [Uu: A] : B2 )
        = B2 ) ) ).

% nonempty_bind_const
thf(fact_4507_semilattice__neutr__order_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z2 @ Less_eq @ Less )
     => ( semilattice_neutr @ A @ F2 @ Z2 ) ) ).

% semilattice_neutr_order.axioms(1)
thf(fact_4508_option_Othe__def,axiom,
    ! [A: $tType] :
      ( ( the2 @ A )
      = ( case_option @ A @ A @ ( undefined @ A )
        @ ^ [X22: A] : X22 ) ) ).

% option.the_def
thf(fact_4509_sup__bot_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semilattice_neutr @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.semilattice_neutr_axioms
thf(fact_4510_inf__top_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semilattice_neutr @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.semilattice_neutr_axioms
thf(fact_4511_curr__def,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( bNF_Wellorder_curr @ A @ B @ C )
      = ( ^ [A6: set @ A,F3: ( product_prod @ A @ B ) > C,A5: A] :
            ( if @ ( B > C ) @ ( member @ A @ A5 @ A6 )
            @ ^ [B4: B] : ( F3 @ ( product_Pair @ A @ B @ A5 @ B4 ) )
            @ ( undefined @ ( B > C ) ) ) ) ) ).

% curr_def
thf(fact_4512_natLeq__def,axiom,
    ( bNF_Ca8665028551170535155natLeq
    = ( collect @ ( product_prod @ nat @ nat ) @ ( product_case_prod @ nat @ nat @ $o @ ( ord_less_eq @ nat ) ) ) ) ).

% natLeq_def
thf(fact_4513_Set_Obind__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bind3 @ A @ B )
      = ( ^ [A6: set @ A,F3: A > ( set @ B )] :
            ( collect @ B
            @ ^ [X2: B] :
              ? [Y2: set @ B] :
                ( ( member @ ( set @ B ) @ Y2 @ ( image2 @ A @ ( set @ B ) @ F3 @ A6 ) )
                & ( member @ B @ X2 @ Y2 ) ) ) ) ) ).

% Set.bind_def
thf(fact_4514_Func__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Wellorder_Func @ A @ B )
      = ( ^ [A6: set @ A,B5: set @ B] :
            ( collect @ ( A > B )
            @ ^ [F3: A > B] :
                ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                   => ( member @ B @ ( F3 @ X2 ) @ B5 ) )
                & ! [A5: A] :
                    ( ~ ( member @ A @ A5 @ A6 )
                   => ( ( F3 @ A5 )
                      = ( undefined @ B ) ) ) ) ) ) ) ).

% Func_def
thf(fact_4515_Restr__natLeq,axiom,
    ! [N: nat] :
      ( ( inf_inf @ ( set @ ( product_prod @ nat @ nat ) ) @ bNF_Ca8665028551170535155natLeq
        @ ( product_Sigma @ nat @ nat
          @ ( collect @ nat
            @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) )
          @ ^ [Uu: nat] :
              ( collect @ nat
              @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) ) ) )
      = ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y2: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y2 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) ) ).

% Restr_natLeq
thf(fact_4516_quotient__of__def,axiom,
    ( quotient_of
    = ( ^ [X2: rat] :
          ( the @ ( product_prod @ int @ int )
          @ ^ [Pair: product_prod @ int @ int] :
              ( ( X2
                = ( fract @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) )
              & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ Pair ) )
              & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) ) ) ) ) ).

% quotient_of_def
thf(fact_4517_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M2: int] :
          ( ( ( X3
             != ( zero_zero @ A ) )
            | ( M2
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X3 @ ( plus_plus @ int @ M2 @ ( one_one @ int ) ) )
            = ( times_times @ A @ X3 @ ( power_int @ A @ X3 @ M2 ) ) ) ) ) ).

% power_int_add_1'
thf(fact_4518_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M2: int] :
          ( ( ( X3
             != ( zero_zero @ A ) )
            | ( M2
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X3 @ ( plus_plus @ int @ M2 @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X3 @ M2 ) @ X3 ) ) ) ) ).

% power_int_add_1
thf(fact_4519_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,N: int] :
          ( ( ( X3
             != ( zero_zero @ A ) )
            | ( N
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X3 @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) @ X3 )
            = ( power_int @ A @ X3 @ N ) ) ) ) ).

% power_int_minus_mult
thf(fact_4520_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_4521_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,W2: num,M2: int] :
          ( ( power_int @ A @ ( times_times @ A @ X3 @ ( numeral_numeral @ A @ W2 ) ) @ M2 )
          = ( times_times @ A @ ( power_int @ A @ X3 @ M2 ) @ ( power_int @ A @ ( numeral_numeral @ A @ W2 ) @ M2 ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_4522_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W2: num,Y: A,M2: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ Y ) @ M2 )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W2 ) @ M2 ) @ ( power_int @ A @ Y @ M2 ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_4523_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X3: B] :
          ( ( power_int @ B @ X3 @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_4524_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M2: int] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) )
          = ( one_one @ A ) ) ) ).

% power_int_minus_one_mult_self
thf(fact_4525_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M2: int,B3: A] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ B3 ) )
          = B3 ) ) ).

% power_int_minus_one_mult_self'
thf(fact_4526_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M2: num,N: num] :
          ( ( times_times @ A @ ( power_int @ A @ X3 @ ( numeral_numeral @ int @ M2 ) ) @ ( power_int @ A @ X3 @ ( numeral_numeral @ int @ N ) ) )
          = ( power_int @ A @ X3 @ ( numeral_numeral @ int @ ( plus_plus @ num @ M2 @ N ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_4527_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M2: num,N: num,B3: A] :
          ( ( times_times @ A @ ( power_int @ A @ X3 @ ( numeral_numeral @ int @ M2 ) ) @ ( times_times @ A @ ( power_int @ A @ X3 @ ( numeral_numeral @ int @ N ) ) @ B3 ) )
          = ( times_times @ A @ ( power_int @ A @ X3 @ ( numeral_numeral @ int @ ( plus_plus @ num @ M2 @ N ) ) ) @ B3 ) ) ) ).

% power_int_add_numeral2
thf(fact_4528_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,N: int] :
          ( ( times_times @ A @ ( power_int @ A @ X3 @ N ) @ X3 )
          = ( times_times @ A @ X3 @ ( power_int @ A @ X3 @ N ) ) ) ) ).

% power_int_commutes
thf(fact_4529_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,Y: A,M2: int] :
          ( ( power_int @ A @ ( times_times @ A @ X3 @ Y ) @ M2 )
          = ( times_times @ A @ ( power_int @ A @ X3 @ M2 ) @ ( power_int @ A @ Y @ M2 ) ) ) ) ).

% power_int_mult_distrib
thf(fact_4530_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,N: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X3 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X3 @ N ) ) ) ) ).

% power_int_one_over
thf(fact_4531_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M2: int] :
          ( ( ( M2
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M2 )
              = ( one_one @ A ) ) )
          & ( ( M2
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_4532_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A4: A] :
          ( ( ord_less_eq @ int @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A4 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A4 @ N ) @ ( power_int @ A @ A4 @ N4 ) ) ) ) ) ).

% power_int_increasing
thf(fact_4533_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A4: A] :
          ( ( ord_less @ int @ N @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A4 )
           => ( ord_less @ A @ ( power_int @ A @ A4 @ N ) @ ( power_int @ A @ A4 @ N4 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_4534_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ int @ N ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) ) ) ).

% power_int_minus_one_minus
thf(fact_4535_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: int,B3: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ A4 @ B3 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ B3 @ A4 ) ) ) ) ).

% power_int_minus_one_diff_commute
thf(fact_4536_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A4: A] :
          ( ( ord_less @ int @ N @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A4 )
           => ( ( ord_less @ A @ A4 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A4 @ N4 ) @ ( power_int @ A @ A4 @ N ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_4537_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,N: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X3 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X3 @ N ) ) ) ) ) ).

% one_le_power_int
thf(fact_4538_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: A,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A4 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A4 @ N ) ) ) ) ) ).

% one_less_power_int
thf(fact_4539_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M2: int,N: int] :
          ( ( ( X3
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M2 @ N )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X3 @ ( plus_plus @ int @ M2 @ N ) )
            = ( times_times @ A @ ( power_int @ A @ X3 @ M2 ) @ ( power_int @ A @ X3 @ N ) ) ) ) ) ).

% power_int_add
thf(fact_4540_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( division_ring @ A )
        & ( one @ B )
        & ( uminus @ B ) )
     => ! [X3: C,A4: A,N: int] :
          ( ( nO_MATCH @ B @ C @ ( uminus_uminus @ B @ ( one_one @ B ) ) @ X3 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A4 ) @ N )
            = ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_int @ A @ A4 @ N ) ) ) ) ) ).

% power_int_minus_left_distrib
thf(fact_4541_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ X3 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X3 @ N ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_4542_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A4: A] :
          ( ( ord_less_eq @ int @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A4 )
           => ( ( ord_less_eq @ A @ A4 @ ( one_one @ A ) )
             => ( ( ( A4
                   != ( zero_zero @ A ) )
                  | ( N4
                   != ( zero_zero @ int ) )
                  | ( N
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A4 @ N4 ) @ ( power_int @ A @ A4 @ N ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_4543_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,M2: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X3 @ M2 ) @ ( power_int @ A @ X3 @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less_eq @ int @ M2 @ N ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_4544_Fract_Otransfer,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat )
    @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ rat
      @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
      @ pcr_rat )
    @ ^ [A5: int,B4: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B4
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A5 @ B4 ) )
    @ fract ) ).

% Fract.transfer
thf(fact_4545_Fract__def,axiom,
    ( fract
    = ( map_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat ) @ ( id @ int ) @ ( map_fun @ int @ int @ ( product_prod @ int @ int ) @ rat @ ( id @ int ) @ abs_Rat )
      @ ^ [A5: int,B4: int] :
          ( if @ ( product_prod @ int @ int )
          @ ( B4
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ A5 @ B4 ) ) ) ) ).

% Fract_def
thf(fact_4546_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,M2: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X3 )
         => ( ( ord_less @ A @ ( power_int @ A @ X3 @ M2 ) @ ( power_int @ A @ X3 @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ int @ M2 @ N ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_4547_fun_Opred__set,axiom,
    ! [A: $tType,D: $tType,P: A > $o] :
      ( ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true
        @ P )
      = ( ^ [X2: D > A] :
          ! [Y2: A] :
            ( ( member @ A @ Y2 @ ( image2 @ D @ A @ X2 @ ( top_top @ ( set @ D ) ) ) )
           => ( P @ Y2 ) ) ) ) ).

% fun.pred_set
thf(fact_4548_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X2: A] : X2 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_4549_mset__set__Union,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ A @ B2 )
       => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( mset_set @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
            = ( plus_plus @ ( multiset @ A ) @ ( mset_set @ A @ A3 ) @ ( mset_set @ A @ B2 ) ) ) ) ) ) ).

% mset_set_Union
thf(fact_4550_MOST__const,axiom,
    ! [A: $tType,P: $o] :
      ( ( eventually @ A
        @ ^ [X2: A] : P
        @ ( cofinite @ A ) )
      = ( P
        | ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% MOST_const
thf(fact_4551_mset__set_Oempty,axiom,
    ! [A: $tType] :
      ( ( mset_set @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ ( multiset @ A ) ) ) ).

% mset_set.empty
thf(fact_4552_cofinite__bot,axiom,
    ! [A: $tType] :
      ( ( ( cofinite @ A )
        = ( bot_bot @ ( filter @ A ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ).

% cofinite_bot
thf(fact_4553_MOST__eq_I2_J,axiom,
    ! [A: $tType,A4: A] :
      ( ( eventually @ A
        @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
          @ A4 )
        @ ( cofinite @ A ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ).

% MOST_eq(2)
thf(fact_4554_MOST__eq_I1_J,axiom,
    ! [A: $tType,A4: A] :
      ( ( eventually @ A
        @ ^ [X2: A] : ( X2 = A4 )
        @ ( cofinite @ A ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ).

% MOST_eq(1)
thf(fact_4555_fun_Opred__True,axiom,
    ! [A: $tType,D: $tType] :
      ( ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true
        @ ^ [Uu: A] : $true )
      = ( ^ [Uu: D > A] : $true ) ) ).

% fun.pred_True
thf(fact_4556_MOST__neq_I2_J,axiom,
    ! [A: $tType,A4: A] :
      ( eventually @ A
      @ ^ [X2: A] : ( A4 != X2 )
      @ ( cofinite @ A ) ) ).

% MOST_neq(2)
thf(fact_4557_MOST__neq_I1_J,axiom,
    ! [A: $tType,A4: A] :
      ( eventually @ A
      @ ^ [X2: A] : ( X2 != A4 )
      @ ( cofinite @ A ) ) ).

% MOST_neq(1)
thf(fact_4558_MOST__eq__imp_I2_J,axiom,
    ! [A: $tType,A4: A,P: A > $o] :
      ( eventually @ A
      @ ^ [X2: A] :
          ( ( A4 = X2 )
         => ( P @ X2 ) )
      @ ( cofinite @ A ) ) ).

% MOST_eq_imp(2)
thf(fact_4559_MOST__eq__imp_I1_J,axiom,
    ! [A: $tType,A4: A,P: A > $o] :
      ( eventually @ A
      @ ^ [X2: A] :
          ( ( X2 = A4 )
         => ( P @ X2 ) )
      @ ( cofinite @ A ) ) ).

% MOST_eq_imp(1)
thf(fact_4560_MOST__I,axiom,
    ! [A: $tType,P: A > $o] :
      ( ! [X_1: A] : ( P @ X_1 )
     => ( eventually @ A @ P @ ( cofinite @ A ) ) ) ).

% MOST_I
thf(fact_4561_ALL__MOST,axiom,
    ! [A: $tType,P: A > $o] :
      ( ! [X_1: A] : ( P @ X_1 )
     => ( eventually @ A @ P @ ( cofinite @ A ) ) ) ).

% ALL_MOST
thf(fact_4562_MOST__mono,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( eventually @ A @ P @ ( cofinite @ A ) )
     => ( ! [X: A] :
            ( ( P @ X )
           => ( Q @ X ) )
       => ( eventually @ A @ Q @ ( cofinite @ A ) ) ) ) ).

% MOST_mono
thf(fact_4563_MOST__conjI,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( eventually @ A @ P @ ( cofinite @ A ) )
     => ( ( eventually @ A @ Q @ ( cofinite @ A ) )
       => ( eventually @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
              & ( Q @ X2 ) )
          @ ( cofinite @ A ) ) ) ) ).

% MOST_conjI
thf(fact_4564_MOST__rev__mp,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( eventually @ A @ P @ ( cofinite @ A ) )
     => ( ( eventually @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
             => ( Q @ X2 ) )
          @ ( cofinite @ A ) )
       => ( eventually @ A @ Q @ ( cofinite @ A ) ) ) ) ).

% MOST_rev_mp
thf(fact_4565_MOST__imp__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( eventually @ A @ P @ ( cofinite @ A ) )
     => ( ( eventually @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
             => ( Q @ X2 ) )
          @ ( cofinite @ A ) )
        = ( eventually @ A @ Q @ ( cofinite @ A ) ) ) ) ).

% MOST_imp_iff
thf(fact_4566_MOST__conj__distrib,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( eventually @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
            & ( Q @ X2 ) )
        @ ( cofinite @ A ) )
      = ( ( eventually @ A @ P @ ( cofinite @ A ) )
        & ( eventually @ A @ Q @ ( cofinite @ A ) ) ) ) ).

% MOST_conj_distrib
thf(fact_4567_pred__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_pred_fun @ A @ B )
      = ( ^ [A6: A > $o,B5: B > $o,F3: A > B] :
          ! [X2: A] :
            ( ( A6 @ X2 )
           => ( B5 @ ( F3 @ X2 ) ) ) ) ) ).

% pred_fun_def
thf(fact_4568_fun_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,D: $tType,X3: D > A,Ya2: D > A,F2: A > B,G: A > B] :
      ( ( X3 = Ya2 )
     => ( ( basic_pred_fun @ D @ A
          @ ^ [Uu: D] : $true
          @ ^ [Z3: A] :
              ( ( F2 @ Z3 )
              = ( G @ Z3 ) )
          @ Ya2 )
       => ( ( comp @ A @ B @ D @ F2 @ X3 )
          = ( comp @ A @ B @ D @ G @ Ya2 ) ) ) ) ).

% fun.map_cong_pred
thf(fact_4569_fun_Opred__mono,axiom,
    ! [D: $tType,A: $tType,P: A > $o,Pa: A > $o] :
      ( ( ord_less_eq @ ( A > $o ) @ P @ Pa )
     => ( ord_less_eq @ ( ( D > A ) > $o )
        @ ( basic_pred_fun @ D @ A
          @ ^ [Uu: D] : $true
          @ P )
        @ ( basic_pred_fun @ D @ A
          @ ^ [Uu: D] : $true
          @ Pa ) ) ) ).

% fun.pred_mono
thf(fact_4570_pred__fun__True__id,axiom,
    ! [A: $tType,B: $tType,C: $tType,P5: B > $o,F2: C > B] :
      ( ( nO_MATCH @ ( A > A ) @ ( B > $o ) @ ( id @ A ) @ P5 )
     => ( ( basic_pred_fun @ C @ B
          @ ^ [X2: C] : $true
          @ P5
          @ F2 )
        = ( basic_pred_fun @ C @ $o
          @ ^ [X2: C] : $true
          @ ( id @ $o )
          @ ( comp @ B @ $o @ C @ P5 @ F2 ) ) ) ) ).

% pred_fun_True_id
thf(fact_4571_MOST__iff__finiteNeg,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( eventually @ A @ P @ ( cofinite @ A ) )
      = ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] :
              ~ ( P @ X2 ) ) ) ) ).

% MOST_iff_finiteNeg
thf(fact_4572_eventually__cofinite,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( eventually @ A @ P @ ( cofinite @ A ) )
      = ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] :
              ~ ( P @ X2 ) ) ) ) ).

% eventually_cofinite
thf(fact_4573_MOST__SucD,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat
        @ ^ [N5: nat] : ( P @ ( suc @ N5 ) )
        @ ( cofinite @ nat ) )
     => ( eventually @ nat @ P @ ( cofinite @ nat ) ) ) ).

% MOST_SucD
thf(fact_4574_MOST__SucI,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( cofinite @ nat ) )
     => ( eventually @ nat
        @ ^ [N5: nat] : ( P @ ( suc @ N5 ) )
        @ ( cofinite @ nat ) ) ) ).

% MOST_SucI
thf(fact_4575_MOST__Suc__iff,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat
        @ ^ [N5: nat] : ( P @ ( suc @ N5 ) )
        @ ( cofinite @ nat ) )
      = ( eventually @ nat @ P @ ( cofinite @ nat ) ) ) ).

% MOST_Suc_iff
thf(fact_4576_MOST__nat,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( cofinite @ nat ) )
      = ( ? [M5: nat] :
          ! [N5: nat] :
            ( ( ord_less @ nat @ M5 @ N5 )
           => ( P @ N5 ) ) ) ) ).

% MOST_nat
thf(fact_4577_MOST__ge__nat,axiom,
    ! [M2: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ M2 ) @ ( cofinite @ nat ) ) ).

% MOST_ge_nat
thf(fact_4578_MOST__nat__le,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( cofinite @ nat ) )
      = ( ? [M5: nat] :
          ! [N5: nat] :
            ( ( ord_less_eq @ nat @ M5 @ N5 )
           => ( P @ N5 ) ) ) ) ).

% MOST_nat_le
thf(fact_4579_fun_Opred__cong,axiom,
    ! [A: $tType,D: $tType,X3: D > A,Ya2: D > A,P: A > $o,Pa: A > $o] :
      ( ( X3 = Ya2 )
     => ( ! [Z4: A] :
            ( ( member @ A @ Z4 @ ( image2 @ D @ A @ Ya2 @ ( top_top @ ( set @ D ) ) ) )
           => ( ( P @ Z4 )
              = ( Pa @ Z4 ) ) )
       => ( ( basic_pred_fun @ D @ A
            @ ^ [Uu: D] : $true
            @ P
            @ X3 )
          = ( basic_pred_fun @ D @ A
            @ ^ [Uu: D] : $true
            @ Pa
            @ Ya2 ) ) ) ) ).

% fun.pred_cong
thf(fact_4580_fun_Opred__mono__strong,axiom,
    ! [A: $tType,D: $tType,P: A > $o,X3: D > A,Pa: A > $o] :
      ( ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true
        @ P
        @ X3 )
     => ( ! [Z4: A] :
            ( ( member @ A @ Z4 @ ( image2 @ D @ A @ X3 @ ( top_top @ ( set @ D ) ) ) )
           => ( ( P @ Z4 )
             => ( Pa @ Z4 ) ) )
       => ( basic_pred_fun @ D @ A
          @ ^ [Uu: D] : $true
          @ Pa
          @ X3 ) ) ) ).

% fun.pred_mono_strong
thf(fact_4581_cofinite__def,axiom,
    ! [A: $tType] :
      ( ( cofinite @ A )
      = ( abs_filter @ A
        @ ^ [P3: A > $o] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] :
                  ~ ( P3 @ X2 ) ) ) ) ) ).

% cofinite_def
thf(fact_4582_fun_Opred__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,R: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( D > A ) > $o ) @ ( ( D > B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
        @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) )
      @ ( bNF_rel_fun @ ( D > A ) @ ( D > B ) @ $o @ $o
        @ ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y5: D,Z5: D] : ( Y5 = Z5 )
          @ R )
        @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) )
      @ ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true )
      @ ( basic_pred_fun @ D @ B
        @ ^ [Uu: D] : $true ) ) ).

% fun.pred_transfer
thf(fact_4583_mset__set__empty__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( mset_set @ A @ A3 )
        = ( zero_zero @ ( multiset @ A ) ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite2 @ A @ A3 ) ) ) ).

% mset_set_empty_iff
thf(fact_4584_fun_Opred__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,Q: B > $o,F2: A > B,X3: D > A] :
      ( ( basic_pred_fun @ D @ B
        @ ^ [Uu: D] : $true
        @ Q
        @ ( comp @ A @ B @ D @ F2 @ X3 ) )
      = ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true
        @ ( comp @ B @ $o @ A @ Q @ F2 )
        @ X3 ) ) ).

% fun.pred_map
thf(fact_4585_MOST__finite__Ball__distrib,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,P: A > B > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( eventually @ B
          @ ^ [Y2: B] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ A3 )
             => ( P @ X2 @ Y2 ) )
          @ ( cofinite @ B ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ A3 )
             => ( eventually @ B @ ( P @ X2 ) @ ( cofinite @ B ) ) ) ) ) ) ).

% MOST_finite_Ball_distrib
thf(fact_4586_MOST__inj,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A] :
      ( ( eventually @ A @ P @ ( cofinite @ A ) )
     => ( ( inj_on @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
       => ( eventually @ B
          @ ^ [X2: B] : ( P @ ( F2 @ X2 ) )
          @ ( cofinite @ B ) ) ) ) ).

% MOST_inj
thf(fact_4587_mset__set_Oinsert__remove,axiom,
    ! [A: $tType,A3: set @ A,X3: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( mset_set @ A @ ( insert @ A @ X3 @ A3 ) )
        = ( add_mset @ A @ X3 @ ( mset_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% mset_set.insert_remove
thf(fact_4588_mset__set_Oremove,axiom,
    ! [A: $tType,A3: set @ A,X3: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( member @ A @ X3 @ A3 )
       => ( ( mset_set @ A @ A3 )
          = ( add_mset @ A @ X3 @ ( mset_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% mset_set.remove
thf(fact_4589_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X3: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X3 @ A3 ) @ S2 )
       => ( ( finite_finite2 @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert @ B @ X3 @ A3 ) )
            = ( insort_key @ A @ B @ Less_eq @ F2 @ X3 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_4590_cr__integer__def,axiom,
    ( code_cr_integer
    = ( ^ [X2: int,Y2: code_integer] :
          ( X2
          = ( code_int_of_integer @ Y2 ) ) ) ) ).

% cr_integer_def
thf(fact_4591_sum__multiset__singleton,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ ( multiset @ A )
        @ ^ [N5: A] : ( add_mset @ A @ N5 @ ( zero_zero @ ( multiset @ A ) ) )
        @ A3 )
      = ( mset_set @ A @ A3 ) ) ).

% sum_multiset_singleton
thf(fact_4592_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X3: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X3 @ A3 ) @ S2 )
       => ( ( finite_finite2 @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X3 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_4593_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( finite_finite2 @ B @ A3 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 )
              = ( nil @ B ) )
            = ( A3
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_4594_at__most__one__mset__mset__diff,axiom,
    ! [A: $tType,A4: A,M: multiset @ A] :
      ( ~ ( member @ A @ A4 @ ( set_mset @ A @ ( minus_minus @ ( multiset @ A ) @ M @ ( add_mset @ A @ A4 @ ( zero_zero @ ( multiset @ A ) ) ) ) ) )
     => ( ( set_mset @ A @ ( minus_minus @ ( multiset @ A ) @ M @ ( add_mset @ A @ A4 @ ( zero_zero @ ( multiset @ A ) ) ) ) )
        = ( minus_minus @ ( set @ A ) @ ( set_mset @ A @ M ) @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% at_most_one_mset_mset_diff
thf(fact_4595_set__mset__empty,axiom,
    ! [A: $tType] :
      ( ( set_mset @ A @ ( zero_zero @ ( multiset @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% set_mset_empty
thf(fact_4596_set__mset__eq__empty__iff,axiom,
    ! [A: $tType,M: multiset @ A] :
      ( ( ( set_mset @ A @ M )
        = ( bot_bot @ ( set @ A ) ) )
      = ( M
        = ( zero_zero @ ( multiset @ A ) ) ) ) ).

% set_mset_eq_empty_iff
thf(fact_4597_in__Inf__multiset__iff,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: A] :
      ( ( A3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( member @ A @ X3 @ ( set_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A3 ) ) )
        = ( ! [X2: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ X2 @ A3 )
             => ( member @ A @ X3 @ ( set_mset @ A @ X2 ) ) ) ) ) ) ).

% in_Inf_multiset_iff
thf(fact_4598_infinite__set__mset__mset__set,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( set_mset @ A @ ( mset_set @ A @ A3 ) )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% infinite_set_mset_mset_set
thf(fact_4599_set__mset__Inf,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( set_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A3 ) )
        = ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ ( multiset @ A ) @ ( set @ A ) @ ( set_mset @ A ) @ A3 ) ) ) ) ).

% set_mset_Inf
thf(fact_4600_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( bot_bot @ ( set @ B ) ) )
        = ( nil @ B ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
thf(fact_4601_set__mset__single,axiom,
    ! [A: $tType,B3: A] :
      ( ( set_mset @ A @ ( add_mset @ A @ B3 @ ( zero_zero @ ( multiset @ A ) ) ) )
      = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_mset_single
thf(fact_4602_mult1__def,axiom,
    ! [A: $tType] :
      ( ( mult1 @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) )
            @ ( product_case_prod @ ( multiset @ A ) @ ( multiset @ A ) @ $o
              @ ^ [N7: multiset @ A,M8: multiset @ A] :
                ? [A5: A,M0: multiset @ A,K7: multiset @ A] :
                  ( ( M8
                    = ( add_mset @ A @ A5 @ M0 ) )
                  & ( N7
                    = ( plus_plus @ ( multiset @ A ) @ M0 @ K7 ) )
                  & ! [B4: A] :
                      ( ( member @ A @ B4 @ ( set_mset @ A @ K7 ) )
                     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ A5 ) @ R3 ) ) ) ) ) ) ) ).

% mult1_def
thf(fact_4603_sum__wcount__Int,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat,N4: multiset @ A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( wcount @ A @ F2 @ N4 ) @ ( inf_inf @ ( set @ A ) @ A3 @ ( set_mset @ A @ N4 ) ) )
        = ( groups7311177749621191930dd_sum @ A @ nat @ ( wcount @ A @ F2 @ N4 ) @ A3 ) ) ) ).

% sum_wcount_Int
thf(fact_4604_set__mset__replicate__mset__subset,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set_mset @ A @ ( replicate_mset @ A @ N @ X3 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set_mset @ A @ ( replicate_mset @ A @ N @ X3 ) )
          = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_mset_replicate_mset_subset
thf(fact_4605_mult1__lessE,axiom,
    ! [A: $tType,N4: multiset @ A,M: multiset @ A,R5: A > A > $o] :
      ( ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ N4 @ M ) @ ( mult1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) )
     => ( ( asymp @ A @ R5 )
       => ~ ! [A7: A,M02: multiset @ A] :
              ( ( M
                = ( add_mset @ A @ A7 @ M02 ) )
             => ! [K8: multiset @ A] :
                  ( ( N4
                    = ( plus_plus @ ( multiset @ A ) @ M02 @ K8 ) )
                 => ( ~ ( member @ A @ A7 @ ( set_mset @ A @ K8 ) )
                   => ~ ! [B11: A] :
                          ( ( member @ A @ B11 @ ( set_mset @ A @ K8 ) )
                         => ( R5 @ B11 @ A7 ) ) ) ) ) ) ) ).

% mult1_lessE
thf(fact_4606_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X3 @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_4607_Pow__set_I1_J,axiom,
    ! [A: $tType] :
      ( ( pow @ A @ ( set2 @ A @ ( nil @ A ) ) )
      = ( insert @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_set(1)
thf(fact_4608_set__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( set2 @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty
thf(fact_4609_set__empty2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty2
thf(fact_4610_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
thf(fact_4611_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( nil @ A ) )
            = ( A3
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
thf(fact_4612_empty__set,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) ).

% empty_set
thf(fact_4613_asymp__greater,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( asymp @ A
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% asymp_greater
thf(fact_4614_card__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A3 ) ) @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% card_lists_length_le
thf(fact_4615_set__removeAll,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X3 @ Xs ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_4616_set__list__bind,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( set2 @ A @ ( bind @ B @ A @ Xs @ F2 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X2: B] : ( set2 @ A @ ( F2 @ X2 ) )
          @ ( set2 @ B @ Xs ) ) ) ) ).

% set_list_bind
thf(fact_4617_finite__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( finite_finite2 @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs2: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
              & ( ( size_size @ ( list @ A ) @ Xs2 )
                = N ) ) ) ) ) ).

% finite_lists_length_eq
thf(fact_4618_finite__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( finite_finite2 @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs2: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_4619_card__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs2 )
                  = N ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A3 ) @ N ) ) ) ).

% card_lists_length_eq
thf(fact_4620_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A3 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs2: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = K )
                  & ( distinct @ A @ Xs2 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X2: nat] : X2
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_4621_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A3: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A3 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs2 )
                  = K )
                & ( distinct @ A @ Xs2 )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_4622_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_4623_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( ( set2 @ A @ ( remove1 @ A @ X3 @ Xs ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_4624_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ A3 )
     => ( finite_finite2 @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs2: list @ A] :
              ( ( ( size_size @ ( list @ A ) @ Xs2 )
                = N )
              & ( distinct @ A @ Xs2 )
              & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 ) ) ) ) ) ).

% finite_lists_distinct_length_eq
thf(fact_4625_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( shuffles @ A @ Xs @ ( nil @ A ) )
      = ( insert @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(2)
thf(fact_4626_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( shuffles @ A @ ( nil @ A ) @ Ys )
      = ( insert @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(1)
thf(fact_4627_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ A @ Ys )
       => ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
           => ( distinct @ A @ Zs ) ) ) ) ) ).

% distinct_disjoint_shuffles
thf(fact_4628_distinct__finite__set,axiom,
    ! [A: $tType,X3: set @ A] :
      ( finite_finite2 @ ( list @ A )
      @ ( collect @ ( list @ A )
        @ ^ [Ys2: list @ A] :
            ( ( ( set2 @ A @ Ys2 )
              = X3 )
            & ( distinct @ A @ Ys2 ) ) ) ) ).

% distinct_finite_set
thf(fact_4629_distinct__finite__subset,axiom,
    ! [A: $tType,X3: set @ A] :
      ( ( finite_finite2 @ A @ X3 )
     => ( finite_finite2 @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Ys2: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys2 ) @ X3 )
              & ( distinct @ A @ Ys2 ) ) ) ) ) ).

% distinct_finite_subset
thf(fact_4630_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X3 @ A3 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X3
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_4631_set__map__filter,axiom,
    ! [B: $tType,A: $tType,G: B > ( option @ A ),Xs: list @ B] :
      ( ( set2 @ A @ ( map_filter @ B @ A @ G @ Xs ) )
      = ( collect @ A
        @ ^ [Y2: A] :
          ? [X2: B] :
            ( ( member @ B @ X2 @ ( set2 @ B @ Xs ) )
            & ( ( G @ X2 )
              = ( some @ A @ Y2 ) ) ) ) ) ).

% set_map_filter
thf(fact_4632_distinct__foldl__invar,axiom,
    ! [B: $tType,A: $tType,S2: list @ A,I: ( set @ A ) > B > $o,Sigma_0: B,F2: B > A > B] :
      ( ( distinct @ A @ S2 )
     => ( ( I @ ( set2 @ A @ S2 ) @ Sigma_0 )
       => ( ! [X: A,It: set @ A,Sigma: B] :
              ( ( member @ A @ X @ It )
             => ( ( ord_less_eq @ ( set @ A ) @ It @ ( set2 @ A @ S2 ) )
               => ( ( I @ It @ Sigma )
                 => ( I @ ( minus_minus @ ( set @ A ) @ It @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( F2 @ Sigma @ X ) ) ) ) )
         => ( I @ ( bot_bot @ ( set @ A ) ) @ ( foldl @ B @ A @ F2 @ Sigma_0 @ S2 ) ) ) ) ) ).

% distinct_foldl_invar
thf(fact_4633_foldl__length,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( foldl @ nat @ A
        @ ^ [I2: nat,X2: A] : ( suc @ I2 )
        @ ( zero_zero @ nat )
        @ L )
      = ( size_size @ ( list @ A ) @ L ) ) ).

% foldl_length
thf(fact_4634_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ~ ( member @ A @ X3 @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X3 @ A3 ) )
              = ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ X3
                @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
thf(fact_4635_insort__left__comm,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y: A,Xs: list @ A] :
          ( ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2
            @ X3
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y
              @ Xs ) )
          = ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2
            @ Y
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X3
              @ Xs ) ) ) ) ).

% insort_left_comm
thf(fact_4636_comp__fun__commute__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( finite6289374366891150609ommute @ A @ ( list @ A )
        @ ( linorder_insort_key @ A @ A
          @ ^ [X2: A] : X2 ) ) ) ).

% comp_fun_commute_insort
thf(fact_4637_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X3: A] :
          ( ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X3 ) )
          = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X3 )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
thf(fact_4638_sorted__list__of__set_Ofold__insort__key_Ofolding__on__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( finite_folding_on @ A @ ( list @ A ) @ ( top_top @ ( set @ A ) )
        @ ( linorder_insort_key @ A @ A
          @ ^ [X2: A] : X2 ) ) ) ).

% sorted_list_of_set.fold_insort_key.folding_on_axioms
thf(fact_4639_comp__fun__commute_Ofoldl__f__commute,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,A4: A,B3: B,Xs: list @ A] :
      ( ( finite6289374366891150609ommute @ A @ B @ F2 )
     => ( ( F2 @ A4
          @ ( foldl @ B @ A
            @ ^ [A5: B,B4: A] : ( F2 @ B4 @ A5 )
            @ B3
            @ Xs ) )
        = ( foldl @ B @ A
          @ ^ [A5: B,B4: A] : ( F2 @ B4 @ A5 )
          @ ( F2 @ A4 @ B3 )
          @ Xs ) ) ) ).

% comp_fun_commute.foldl_f_commute
thf(fact_4640_fst__foldl,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > C > A,G: A > B > C > B,A4: A,B3: B,Xs: list @ C] :
      ( ( product_fst @ A @ B
        @ ( foldl @ ( product_prod @ A @ B ) @ C
          @ ( product_case_prod @ A @ B @ ( C > ( product_prod @ A @ B ) )
            @ ^ [A5: A,B4: B,X2: C] : ( product_Pair @ A @ B @ ( F2 @ A5 @ X2 ) @ ( G @ A5 @ B4 @ X2 ) ) )
          @ ( product_Pair @ A @ B @ A4 @ B3 )
          @ Xs ) )
      = ( foldl @ A @ C @ F2 @ A4 @ Xs ) ) ).

% fst_foldl
thf(fact_4641_foldl__absorb1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X3: A,Zs: list @ A] :
          ( ( times_times @ A @ X3 @ ( foldl @ A @ A @ ( times_times @ A ) @ ( one_one @ A ) @ Zs ) )
          = ( foldl @ A @ A @ ( times_times @ A ) @ X3 @ Zs ) ) ) ).

% foldl_absorb1
thf(fact_4642_foldl__un__empty__eq,axiom,
    ! [A: $tType,I3: set @ A,Ww: list @ ( set @ A )] :
      ( ( foldl @ ( set @ A ) @ ( set @ A ) @ ( sup_sup @ ( set @ A ) ) @ I3 @ Ww )
      = ( sup_sup @ ( set @ A ) @ I3 @ ( foldl @ ( set @ A ) @ ( set @ A ) @ ( sup_sup @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) @ Ww ) ) ) ).

% foldl_un_empty_eq
thf(fact_4643_sorted__list__of__set_Ofold__insort__key_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( finite_fold @ A @ ( list @ A )
          @ ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2 )
          @ ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.eq_fold
thf(fact_4644_foldl__set,axiom,
    ! [A: $tType,L: list @ ( set @ A )] :
      ( ( foldl @ ( set @ A ) @ ( set @ A ) @ ( sup_sup @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) @ L )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [X2: set @ A] : ( member @ ( set @ A ) @ X2 @ ( set2 @ ( set @ A ) @ L ) ) ) ) ) ).

% foldl_set
thf(fact_4645_foldl__length__aux,axiom,
    ! [A: $tType,A4: nat,L: list @ A] :
      ( ( foldl @ nat @ A
        @ ^ [I2: nat,X2: A] : ( suc @ I2 )
        @ A4
        @ L )
      = ( plus_plus @ nat @ A4 @ ( size_size @ ( list @ A ) @ L ) ) ) ).

% foldl_length_aux
thf(fact_4646_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( member @ A @ X3 @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ X3
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_4647_listset_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( listset @ A @ ( nil @ ( set @ A ) ) )
      = ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listset.simps(1)
thf(fact_4648_sorted__list__of__multiset__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,M: multiset @ A] :
          ( ( linord6283353356039996273ltiset @ A @ ( add_mset @ A @ X3 @ M ) )
          = ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2
            @ X3
            @ ( linord6283353356039996273ltiset @ A @ M ) ) ) ) ).

% sorted_list_of_multiset_insert
thf(fact_4649_set__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) )
      = ( collect @ ( list @ A )
        @ ^ [Ys2: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Ys2 )
              = N )
            & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys2 ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% set_n_lists
thf(fact_4650_distinct__n__lists,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) ) ) ).

% distinct_n_lists
thf(fact_4651_length__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( n_lists @ A @ N @ Xs ) )
      = ( power_power @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_n_lists
thf(fact_4652_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( linord144544945434240204of_set @ A @ A
          @ ^ [X2: A] : X2 ) ) ) ).

% sorted_list_of_set_def
thf(fact_4653_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ A @ ( concat @ A @ Xs ) )
      = ( ( distinct @ ( list @ A ) @ ( removeAll @ ( list @ A ) @ ( nil @ A ) @ Xs ) )
        & ! [Ys2: list @ A] :
            ( ( member @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys2 ) )
        & ! [Ys2: list @ A,Zs2: list @ A] :
            ( ( ( member @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( member @ ( list @ A ) @ Zs2 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( Ys2 != Zs2 ) )
           => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys2 ) @ ( set2 @ A @ Zs2 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% distinct_concat_iff
thf(fact_4654_set__product,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) )
      = ( product_Sigma @ A @ B @ ( set2 @ A @ Xs )
        @ ^ [Uu: A] : ( set2 @ B @ Ys ) ) ) ).

% set_product
thf(fact_4655_set__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( set2 @ A @ ( concat @ A @ Xs ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xs ) ) ) ) ).

% set_concat
thf(fact_4656_distinct__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A ) @ Xs )
     => ( ! [Ys3: list @ A] :
            ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys3 ) )
       => ( ! [Ys3: list @ A,Zs3: list @ A] :
              ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member @ ( list @ A ) @ Zs3 @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys3 != Zs3 )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Zs3 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat
thf(fact_4657_distinct__concat_H,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys2: list @ A] :
              ( Ys2
             != ( nil @ A ) )
          @ Xs ) )
     => ( ! [Ys3: list @ A] :
            ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys3 ) )
       => ( ! [Ys3: list @ A,Zs3: list @ A] :
              ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member @ ( list @ A ) @ Zs3 @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys3 != Zs3 )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Zs3 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat'
thf(fact_4658_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ ( concat @ A @ Xss ) ) )
      = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xss ) ) ) ) ) ).

% length_remdups_concat
thf(fact_4659_sorted__list__of__set__nonempty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( cons @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set_nonempty
thf(fact_4660_filter__filter,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,Xs: list @ A] :
      ( ( filter2 @ A @ P @ ( filter2 @ A @ Q @ Xs ) )
      = ( filter2 @ A
        @ ^ [X2: A] :
            ( ( Q @ X2 )
            & ( P @ X2 ) )
        @ Xs ) ) ).

% filter_filter
thf(fact_4661_set__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( set2 @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( P @ X2 ) ) ) ) ).

% set_filter
thf(fact_4662_removeAll__filter__not__eq,axiom,
    ! [A: $tType] :
      ( ( removeAll @ A )
      = ( ^ [X2: A] :
            ( filter2 @ A
            @ ^ [Y2: A] : ( X2 != Y2 ) ) ) ) ).

% removeAll_filter_not_eq
thf(fact_4663_partition__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( member @ ( list @ A ) @ Xs
      @ ( shuffles @ A @ ( filter2 @ A @ P @ Xs )
        @ ( filter2 @ A
          @ ^ [X2: A] :
              ~ ( P @ X2 )
          @ Xs ) ) ) ).

% partition_in_shuffles
thf(fact_4664_inj__split__Cons,axiom,
    ! [A: $tType,X5: set @ ( product_prod @ ( list @ A ) @ A )] :
      ( inj_on @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
      @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
        @ ^ [Xs2: list @ A,N5: A] : ( cons @ A @ N5 @ Xs2 ) )
      @ X5 ) ).

% inj_split_Cons
thf(fact_4665_map__filter__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X3: B,Xs: list @ B] :
      ( ( map_filter @ B @ A @ F2 @ ( cons @ B @ X3 @ Xs ) )
      = ( case_option @ ( list @ A ) @ A @ ( map_filter @ B @ A @ F2 @ Xs )
        @ ^ [Y2: A] : ( cons @ A @ Y2 @ ( map_filter @ B @ A @ F2 @ Xs ) )
        @ ( F2 @ X3 ) ) ) ).

% map_filter_simps(1)
thf(fact_4666_sum__length__filter__compl,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ^ [X2: A] :
                ~ ( P @ X2 )
            @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% sum_length_filter_compl
thf(fact_4667_inter__set__filter,axiom,
    ! [A: $tType,A3: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( set2 @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X2: A] : ( member @ A @ X2 @ A3 )
          @ Xs ) ) ) ).

% inter_set_filter
thf(fact_4668_concat__filter__neq__Nil,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( concat @ A
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys2: list @ A] :
              ( Ys2
             != ( nil @ A ) )
          @ Xs ) )
      = ( concat @ A @ Xs ) ) ).

% concat_filter_neq_Nil
thf(fact_4669_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: A > A > $o] :
      ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
      @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X1: list @ A,X22: list @ A] :
          ( ? [Y2: A,Ys2: list @ A] :
              ( ( X1
                = ( nil @ A ) )
              & ( X22
                = ( cons @ A @ Y2 @ Ys2 ) ) )
          | ? [X2: A,Y2: A,Xs2: list @ A,Ys2: list @ A] :
              ( ( X1
                = ( cons @ A @ X2 @ Xs2 ) )
              & ( X22
                = ( cons @ A @ Y2 @ Ys2 ) )
              & ( Less @ X2 @ Y2 ) )
          | ? [X2: A,Y2: A,Xs2: list @ A,Ys2: list @ A] :
              ( ( X1
                = ( cons @ A @ X2 @ Xs2 ) )
              & ( X22
                = ( cons @ A @ Y2 @ Ys2 ) )
              & ~ ( Less @ X2 @ Y2 )
              & ~ ( Less @ Y2 @ X2 )
              & ( P6 @ Xs2 @ Ys2 ) ) ) ) ).

% ord.lexordp.mono
thf(fact_4670_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Y: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert @ A @ Y @ ( set2 @ A @ Xs ) ) )
     => ( ( filter2 @ A
          @ ^ [X2: A] :
              ( ( F2 @ Y )
              = ( F2 @ X2 ) )
          @ Xs )
        = ( filter2 @ A
          @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
            @ Y )
          @ Xs ) ) ) ).

% inj_on_filter_key_eq
thf(fact_4671_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X1: list @ A,X22: list @ A] :
            ( ? [Y2: A,Ys2: list @ A] :
                ( ( X1
                  = ( nil @ A ) )
                & ( X22
                  = ( cons @ A @ Y2 @ Ys2 ) ) )
            | ? [X2: A,Y2: A,Xs2: list @ A,Ys2: list @ A] :
                ( ( X1
                  = ( cons @ A @ X2 @ Xs2 ) )
                & ( X22
                  = ( cons @ A @ Y2 @ Ys2 ) )
                & ( ord_less @ A @ X2 @ Y2 ) )
            | ? [X2: A,Y2: A,Xs2: list @ A,Ys2: list @ A] :
                ( ( X1
                  = ( cons @ A @ X2 @ Xs2 ) )
                & ( X22
                  = ( cons @ A @ Y2 @ Ys2 ) )
                & ~ ( ord_less @ A @ X2 @ Y2 )
                & ~ ( ord_less @ A @ Y2 @ X2 )
                & ( P6 @ Xs2 @ Ys2 ) ) ) ) ) ).

% lexordp.mono
thf(fact_4672_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list @ A,Y: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X2: A] : ( X2 != Y )
          @ Xs ) ) ) ).

% set_minus_filter_out
thf(fact_4673_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] :
                ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
thf(fact_4674_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] : ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
thf(fact_4675_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] :
                ~ ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
thf(fact_4676_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] : ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
thf(fact_4677_lists__length__Suc__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( collect @ ( list @ A )
        @ ^ [Xs2: list @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
            & ( ( size_size @ ( list @ A ) @ Xs2 )
              = ( suc @ N ) ) ) )
      = ( image2 @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
        @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
          @ ^ [Xs2: list @ A,N5: A] : ( cons @ A @ N5 @ Xs2 ) )
        @ ( product_Sigma @ ( list @ A ) @ A
          @ ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs2 )
                  = N ) ) )
          @ ^ [Uu: list @ A] : A3 ) ) ) ).

% lists_length_Suc_eq
thf(fact_4678_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        = ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_length_filter
thf(fact_4679_shuffles_Oelims,axiom,
    ! [A: $tType,X3: list @ A,Xa: list @ A,Y: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X3 @ Xa )
        = Y )
     => ( ( ( X3
            = ( nil @ A ) )
         => ( Y
           != ( insert @ ( list @ A ) @ Xa @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y
             != ( insert @ ( list @ A ) @ X3 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
         => ~ ! [X: A,Xs3: list @ A] :
                ( ( X3
                  = ( cons @ A @ X @ Xs3 ) )
               => ! [Y3: A,Ys3: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ Y3 @ Ys3 ) )
                   => ( Y
                     != ( sup_sup @ ( set @ ( list @ A ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs3 @ ( cons @ A @ Y3 @ Ys3 ) ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y3 ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs3 ) @ Ys3 ) ) ) ) ) ) ) ) ) ).

% shuffles.elims
thf(fact_4680_Pow__set_I2_J,axiom,
    ! [B: $tType,X3: B,Xs: list @ B] :
      ( ( pow @ B @ ( set2 @ B @ ( cons @ B @ X3 @ Xs ) ) )
      = ( sup_sup @ ( set @ ( set @ B ) ) @ ( pow @ B @ ( set2 @ B @ Xs ) ) @ ( image2 @ ( set @ B ) @ ( set @ B ) @ ( insert @ B @ X3 ) @ ( pow @ B @ ( set2 @ B @ Xs ) ) ) ) ) ).

% Pow_set(2)
thf(fact_4681_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( set_Cons @ A @ A3 @ ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
      = ( image2 @ A @ ( list @ A )
        @ ^ [X2: A] : ( cons @ A @ X2 @ ( nil @ A ) )
        @ A3 ) ) ).

% set_Cons_sing_Nil
thf(fact_4682_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs2: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs2 ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X2: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X2 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys2: list @ B] :
                  ( Ys2
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_4683_foldr__length,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( foldr @ A @ nat
        @ ^ [X2: A] : suc
        @ L
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ A ) @ L ) ) ).

% foldr_length
thf(fact_4684_foldr__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,P: B > $o,Xs: list @ B] :
      ( ( foldr @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( foldr @ B @ A
        @ ^ [X2: B] : ( if @ ( A > A ) @ ( P @ X2 ) @ ( F2 @ X2 ) @ ( id @ A ) )
        @ Xs ) ) ).

% foldr_filter
thf(fact_4685_comp__fun__commute_Ofoldr__conv__foldl,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,Xs: list @ A,A4: B] :
      ( ( finite6289374366891150609ommute @ A @ B @ F2 )
     => ( ( foldr @ A @ B @ F2 @ Xs @ A4 )
        = ( foldl @ B @ A
          @ ^ [A5: B,B4: A] : ( F2 @ B4 @ A5 )
          @ A4
          @ Xs ) ) ) ).

% comp_fun_commute.foldr_conv_foldl
thf(fact_4686_foldr__length__aux,axiom,
    ! [A: $tType,L: list @ A,A4: nat] :
      ( ( foldr @ A @ nat
        @ ^ [X2: A] : suc
        @ L
        @ A4 )
      = ( plus_plus @ nat @ A4 @ ( size_size @ ( list @ A ) @ L ) ) ) ).

% foldr_length_aux
thf(fact_4687_set__Cons__def,axiom,
    ! [A: $tType] :
      ( ( set_Cons @ A )
      = ( ^ [A6: set @ A,XS: set @ ( list @ A )] :
            ( collect @ ( list @ A )
            @ ^ [Z3: list @ A] :
              ? [X2: A,Xs2: list @ A] :
                ( ( Z3
                  = ( cons @ A @ X2 @ Xs2 ) )
                & ( member @ A @ X2 @ A6 )
                & ( member @ ( list @ A ) @ Xs2 @ XS ) ) ) ) ) ).

% set_Cons_def
thf(fact_4688_transpose__max__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs2: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) )
        @ ( transpose @ A @ Xs )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X2: list @ A] :
              ( X2
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_max_length
thf(fact_4689_listrel__Cons,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ B @ A ),X3: B,Xs: list @ B] :
      ( ( image @ ( list @ B ) @ ( list @ A ) @ ( listrel @ B @ A @ R5 ) @ ( insert @ ( list @ B ) @ ( cons @ B @ X3 @ Xs ) @ ( bot_bot @ ( set @ ( list @ B ) ) ) ) )
      = ( set_Cons @ A @ ( image @ B @ A @ R5 @ ( insert @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) @ ( image @ ( list @ B ) @ ( list @ A ) @ ( listrel @ B @ A @ R5 ) @ ( insert @ ( list @ B ) @ Xs @ ( bot_bot @ ( set @ ( list @ B ) ) ) ) ) ) ) ).

% listrel_Cons
thf(fact_4690_arg__min__list_Oelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X3: A > B,Xa: list @ A,Y: A] :
          ( ( ( arg_min_list @ A @ B @ X3 @ Xa )
            = Y )
         => ( ! [X: A] :
                ( ( Xa
                  = ( cons @ A @ X @ ( nil @ A ) ) )
               => ( Y != X ) )
           => ( ! [X: A,Y3: A,Zs3: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ X @ ( cons @ A @ Y3 @ Zs3 ) ) )
                 => ( Y
                   != ( if @ A @ ( ord_less_eq @ B @ ( X3 @ X ) @ ( X3 @ ( arg_min_list @ A @ B @ X3 @ ( cons @ A @ Y3 @ Zs3 ) ) ) ) @ X @ ( arg_min_list @ A @ B @ X3 @ ( cons @ A @ Y3 @ Zs3 ) ) ) ) )
             => ~ ( ( Xa
                    = ( nil @ A ) )
                 => ( Y
                   != ( undefined @ A ) ) ) ) ) ) ) ).

% arg_min_list.elims
thf(fact_4691_listrel__Nil,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ B @ A )] :
      ( ( image @ ( list @ B ) @ ( list @ A ) @ ( listrel @ B @ A @ R5 ) @ ( insert @ ( list @ B ) @ ( nil @ B ) @ ( bot_bot @ ( set @ ( list @ B ) ) ) ) )
      = ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listrel_Nil
thf(fact_4692_filter__conv__foldr,axiom,
    ! [A: $tType] :
      ( ( filter2 @ A )
      = ( ^ [P3: A > $o,Xs2: list @ A] :
            ( foldr @ A @ ( list @ A )
            @ ^ [X2: A,Xt: list @ A] : ( if @ ( list @ A ) @ ( P3 @ X2 ) @ ( cons @ A @ X2 @ Xt ) @ Xt )
            @ Xs2
            @ ( nil @ A ) ) ) ) ).

% filter_conv_foldr
thf(fact_4693_arg__min__list_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X3: A,Y: A,Zs: list @ A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X3 @ ( cons @ A @ Y @ Zs ) ) )
          = ( if @ A @ ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs ) ) ) ) @ X3 @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% arg_min_list.simps(2)
thf(fact_4694_length__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs2: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) )
        @ Xs
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_4695_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A5: A,Xs2: list @ B] :
              ( foldr @ B @ A
              @ ^ [X2: B,B4: A] : ( plus_plus @ A @ ( F3 @ X2 ) @ ( times_times @ A @ A5 @ B4 ) )
              @ Xs2
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_4696_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A4: A,X3: B,Xs: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A4 @ ( cons @ B @ X3 @ Xs ) )
          = ( plus_plus @ A @ ( F2 @ X3 ) @ ( times_times @ A @ A4 @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A4 @ Xs ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_4697_ord__class_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_lexordp @ A )
        = ( complete_lattice_lfp @ ( ( list @ A ) > ( list @ A ) > $o )
          @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X1: list @ A,X22: list @ A] :
              ( ? [Y2: A,Ys2: list @ A] :
                  ( ( X1
                    = ( nil @ A ) )
                  & ( X22
                    = ( cons @ A @ Y2 @ Ys2 ) ) )
              | ? [X2: A,Y2: A,Xs2: list @ A,Ys2: list @ A] :
                  ( ( X1
                    = ( cons @ A @ X2 @ Xs2 ) )
                  & ( X22
                    = ( cons @ A @ Y2 @ Ys2 ) )
                  & ( ord_less @ A @ X2 @ Y2 ) )
              | ? [X2: A,Y2: A,Xs2: list @ A,Ys2: list @ A] :
                  ( ( X1
                    = ( cons @ A @ X2 @ Xs2 ) )
                  & ( X22
                    = ( cons @ A @ Y2 @ Ys2 ) )
                  & ~ ( ord_less @ A @ X2 @ Y2 )
                  & ~ ( ord_less @ A @ Y2 @ X2 )
                  & ( P6 @ Xs2 @ Ys2 ) ) ) ) ) ) ).

% ord_class.lexordp_def
thf(fact_4698_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A4: A] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A4 @ ( nil @ B ) )
          = ( zero_zero @ A ) ) ) ).

% horner_sum_simps(1)
thf(fact_4699_ord_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp2 @ A )
      = ( ^ [Less2: A > A > $o] :
            ( complete_lattice_lfp @ ( ( list @ A ) > ( list @ A ) > $o )
            @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X1: list @ A,X22: list @ A] :
                ( ? [Y2: A,Ys2: list @ A] :
                    ( ( X1
                      = ( nil @ A ) )
                    & ( X22
                      = ( cons @ A @ Y2 @ Ys2 ) ) )
                | ? [X2: A,Y2: A,Xs2: list @ A,Ys2: list @ A] :
                    ( ( X1
                      = ( cons @ A @ X2 @ Xs2 ) )
                    & ( X22
                      = ( cons @ A @ Y2 @ Ys2 ) )
                    & ( Less2 @ X2 @ Y2 ) )
                | ? [X2: A,Y2: A,Xs2: list @ A,Ys2: list @ A] :
                    ( ( X1
                      = ( cons @ A @ X2 @ Xs2 ) )
                    & ( X22
                      = ( cons @ A @ Y2 @ Ys2 ) )
                    & ~ ( Less2 @ X2 @ Y2 )
                    & ~ ( Less2 @ Y2 @ X2 )
                    & ( P6 @ Xs2 @ Ys2 ) ) ) ) ) ) ).

% ord.lexordp_def
thf(fact_4700_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A5: A,Xs2: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N5: nat] : ( compow @ ( A > A ) @ N5 @ ( times_times @ A @ A5 ) @ ( F3 @ ( nth @ B @ Xs2 @ N5 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_4701_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A5: A,Xs2: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N5: nat] : ( times_times @ A @ ( F3 @ ( nth @ B @ Xs2 @ N5 ) ) @ ( power_power @ A @ A5 @ N5 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_4702_ran__nth__set__encoding__conv,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( ran @ nat @ A
        @ ^ [I2: nat] : ( if @ ( option @ A ) @ ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ L ) ) @ ( some @ A @ ( nth @ A @ L @ I2 ) ) @ ( none @ A ) ) )
      = ( set2 @ A @ L ) ) ).

% ran_nth_set_encoding_conv
thf(fact_4703_nth__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X3 @ Xs ) @ N )
      = ( case_nat @ A @ X3 @ ( nth @ A @ Xs ) @ N ) ) ).

% nth_Cons
thf(fact_4704_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs2: list @ A] :
            ( collect @ A
            @ ^ [Uu: A] :
              ? [I2: nat] :
                ( ( Uu
                  = ( nth @ A @ Xs2 @ I2 ) )
                & ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_4705_length__filter__conv__card,axiom,
    ! [A: $tType,P5: A > $o,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P5 @ Xs ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I2: nat] :
              ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( P5 @ ( nth @ A @ Xs @ I2 ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_4706_list__collect__set__alt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( list_collect_set @ B @ A )
      = ( ^ [F3: B > ( set @ A ),L2: list @ B] :
            ( complete_Sup_Sup @ ( set @ A )
            @ ( collect @ ( set @ A )
              @ ^ [Uu: set @ A] :
                ? [I2: nat] :
                  ( ( Uu
                    = ( F3 @ ( nth @ B @ L2 @ I2 ) ) )
                  & ( ord_less @ nat @ I2 @ ( size_size @ ( list @ B ) @ L2 ) ) ) ) ) ) ) ).

% list_collect_set_alt
thf(fact_4707_set__update__distinct,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs @ N @ X3 ) )
          = ( insert @ A @ X3 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ ( nth @ A @ Xs @ N ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_4708_set__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [Uu: product_prod @ A @ B] :
          ? [I2: nat] :
            ( ( Uu
              = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I2 ) @ ( nth @ B @ Ys @ I2 ) ) )
            & ( ord_less @ nat @ I2 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% set_zip
thf(fact_4709_list__collect__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( set @ A )] :
      ( ( list_collect_set @ B @ A @ F2 @ ( nil @ B ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% list_collect_set_simps(1)
thf(fact_4710_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,I3: nat,V: A] :
      ( ( list_update @ A @ ( cons @ A @ X3 @ Xs ) @ I3 @ V )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ V @ Xs )
        @ ^ [J3: nat] : ( cons @ A @ X3 @ ( list_update @ A @ Xs @ J3 @ V ) )
        @ I3 ) ) ).

% list_update.simps(2)
thf(fact_4711_set__zip__cart,axiom,
    ! [B: $tType,A: $tType,X3: product_prod @ A @ B,L: list @ A,L5: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ X3 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ L @ L5 ) ) )
     => ( member @ ( product_prod @ A @ B ) @ X3
        @ ( product_Sigma @ A @ B @ ( set2 @ A @ L )
          @ ^ [Uu: A] : ( set2 @ B @ L5 ) ) ) ) ).

% set_zip_cart
thf(fact_4712_concat__injective,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xs )
        = ( concat @ A @ Ys ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ! [X: product_prod @ ( list @ A ) @ ( list @ A )] :
              ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) ) )
             => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
                @ ^ [Y2: list @ A,Z3: list @ A] :
                    ( ( size_size @ ( list @ A ) @ Y2 )
                    = ( size_size @ ( list @ A ) @ Z3 ) )
                @ X ) )
         => ( Xs = Ys ) ) ) ) ).

% concat_injective
thf(fact_4713_concat__eq__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ! [X: product_prod @ ( list @ A ) @ ( list @ A )] :
          ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) ) )
         => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
            @ ^ [Y2: list @ A,Z3: list @ A] :
                ( ( size_size @ ( list @ A ) @ Y2 )
                = ( size_size @ ( list @ A ) @ Z3 ) )
            @ X ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ( ( concat @ A @ Xs )
            = ( concat @ A @ Ys ) )
          = ( Xs = Ys ) ) ) ) ).

% concat_eq_concat_iff
thf(fact_4714_foldl__snd__zip,axiom,
    ! [B: $tType,C: $tType,A: $tType,Ys: list @ A,Xs: list @ B,F2: C > A > C,B3: C] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ys ) @ ( size_size @ ( list @ B ) @ Xs ) )
     => ( ( foldl @ C @ ( product_prod @ B @ A )
          @ ^ [B4: C] :
              ( product_case_prod @ B @ A @ C
              @ ^ [X2: B] : ( F2 @ B4 ) )
          @ B3
          @ ( zip @ B @ A @ Xs @ Ys ) )
        = ( foldl @ C @ A @ F2 @ B3 @ Ys ) ) ) ).

% foldl_snd_zip
thf(fact_4715_foldr__snd__zip,axiom,
    ! [B: $tType,A: $tType,C: $tType,Ys: list @ A,Xs: list @ B,F2: A > C > C,B3: C] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ys ) @ ( size_size @ ( list @ B ) @ Xs ) )
     => ( ( foldr @ ( product_prod @ B @ A ) @ C
          @ ( product_case_prod @ B @ A @ ( C > C )
            @ ^ [X2: B] : F2 )
          @ ( zip @ B @ A @ Xs @ Ys )
          @ B3 )
        = ( foldr @ A @ C @ F2 @ Ys @ B3 ) ) ) ).

% foldr_snd_zip
thf(fact_4716_list__eq__iff__zip__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y5: list @ A,Z5: list @ A] : ( Y5 = Z5 ) )
      = ( ^ [Xs2: list @ A,Ys2: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs2 )
              = ( size_size @ ( list @ A ) @ Ys2 ) )
            & ! [X2: product_prod @ A @ A] :
                ( ( member @ ( product_prod @ A @ A ) @ X2 @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs2 @ Ys2 ) ) )
               => ( product_case_prod @ A @ A @ $o
                  @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
                  @ X2 ) ) ) ) ) ).

% list_eq_iff_zip_eq
thf(fact_4717_list__collect__set__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( list_collect_set @ B @ A )
      = ( ^ [F3: B > ( set @ A ),L2: list @ B] :
            ( complete_Sup_Sup @ ( set @ A )
            @ ( collect @ ( set @ A )
              @ ^ [Uu: set @ A] :
                ? [A5: B] :
                  ( ( Uu
                    = ( F3 @ A5 ) )
                  & ( member @ B @ A5 @ ( set2 @ B @ L2 ) ) ) ) ) ) ) ).

% list_collect_set_def
thf(fact_4718_distinct__list__update,axiom,
    ! [A: $tType,Xs: list @ A,A4: A,I3: nat] :
      ( ( distinct @ A @ Xs )
     => ( ~ ( member @ A @ A4 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ ( nth @ A @ Xs @ I3 ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs @ I3 @ A4 ) ) ) ) ).

% distinct_list_update
thf(fact_4719_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,R5: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R5 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [X2: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ X2 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
           => ( product_case_prod @ A @ B @ $o
              @ ^ [Y2: A,Z3: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y2 @ Z3 ) @ R5 )
              @ X2 ) ) ) ) ).

% listrel_iff_zip
thf(fact_4720_set__nths,axiom,
    ! [A: $tType,Xs: list @ A,I: set @ nat] :
      ( ( set2 @ A @ ( nths @ A @ Xs @ I ) )
      = ( collect @ A
        @ ^ [Uu: A] :
          ? [I2: nat] :
            ( ( Uu
              = ( nth @ A @ Xs @ I2 ) )
            & ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( member @ nat @ I2 @ I ) ) ) ) ).

% set_nths
thf(fact_4721_nth__transpose,axiom,
    ! [A: $tType,I3: nat,Xs: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I3 )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs2: list @ A] : ( nth @ A @ Xs2 @ I3 )
          @ ( filter2 @ ( list @ A )
            @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys2 ) )
            @ Xs ) ) ) ) ).

% nth_transpose
thf(fact_4722_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs: list @ A,X3: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs @ K @ X3 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ X3 ) @ ( nth @ A @ Xs @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_4723_map__ident,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X2: A] : X2 )
      = ( ^ [Xs2: list @ A] : Xs2 ) ) ).

% map_ident
thf(fact_4724_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A @ ( nil @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sum_list.Nil
thf(fact_4725_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( cons @ A @ X3 @ Xs ) )
          = ( plus_plus @ A @ X3 @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% sum_list.Cons
thf(fact_4726_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Ns ) )
               => ( X2
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_4727_nths__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( nths @ A @ Xs @ ( bot_bot @ ( set @ nat ) ) )
      = ( nil @ A ) ) ).

% nths_empty
thf(fact_4728_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( zero_zero @ A )
              @ Xs ) )
          = ( zero_zero @ A ) ) ) ).

% sum_list_0
thf(fact_4729_list__collect__set__map__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: B > ( set @ A ),X3: C > B] :
      ( ( list_collect_set @ B @ A @ F2 @ ( map @ C @ B @ X3 @ ( nil @ C ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% list_collect_set_map_simps(1)
thf(fact_4730_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( concat @ A
        @ ( map @ B @ ( list @ A )
          @ ^ [X2: B] : ( cons @ A @ ( F2 @ X2 ) @ ( nil @ A ) )
          @ Xs ) )
      = ( map @ B @ A @ F2 @ Xs ) ) ).

% concat_map_singleton
thf(fact_4731_map__zip__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: ( product_prod @ B @ C ) > A,G: D > B,Xs: list @ D,Ys: list @ C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ ( map @ D @ B @ G @ Xs ) @ Ys ) )
      = ( map @ ( product_prod @ D @ C ) @ A
        @ ( product_case_prod @ D @ C @ A
          @ ^ [X2: D,Y2: C] : ( F2 @ ( product_Pair @ B @ C @ ( G @ X2 ) @ Y2 ) ) )
        @ ( zip @ D @ C @ Xs @ Ys ) ) ) ).

% map_zip_map
thf(fact_4732_map__zip__map2,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: ( product_prod @ B @ C ) > A,Xs: list @ B,G: D > C,Ys: list @ D] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ Xs @ ( map @ D @ C @ G @ Ys ) ) )
      = ( map @ ( product_prod @ B @ D ) @ A
        @ ( product_case_prod @ B @ D @ A
          @ ^ [X2: B,Y2: D] : ( F2 @ ( product_Pair @ B @ C @ X2 @ ( G @ Y2 ) ) ) )
        @ ( zip @ B @ D @ Xs @ Ys ) ) ) ).

% map_zip_map2
thf(fact_4733_zip__map1,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: C > A,Xs: list @ C,Ys: list @ B] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ Ys )
      = ( map @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ B @ ( product_prod @ A @ B )
          @ ^ [X2: C] : ( product_Pair @ A @ B @ ( F2 @ X2 ) ) )
        @ ( zip @ C @ B @ Xs @ Ys ) ) ) ).

% zip_map1
thf(fact_4734_zip__map2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,F2: C > B,Ys: list @ C] :
      ( ( zip @ A @ B @ Xs @ ( map @ C @ B @ F2 @ Ys ) )
      = ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
          @ ^ [X2: A,Y2: C] : ( product_Pair @ A @ B @ X2 @ ( F2 @ Y2 ) ) )
        @ ( zip @ A @ C @ Xs @ Ys ) ) ) ).

% zip_map2
thf(fact_4735_map__prod__fun__zip,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: C > A,G: D > B,Xs: list @ C,Ys: list @ D] :
      ( ( map @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X2: C,Y2: D] : ( product_Pair @ A @ B @ ( F2 @ X2 ) @ ( G @ Y2 ) ) )
        @ ( zip @ C @ D @ Xs @ Ys ) )
      = ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ ( map @ D @ B @ G @ Ys ) ) ) ).

% map_prod_fun_zip
thf(fact_4736_map2__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,H2: B > C > A,F2: D > B,Xs: list @ D,G: D > C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ H2 ) @ ( zip @ B @ C @ ( map @ D @ B @ F2 @ Xs ) @ ( map @ D @ C @ G @ Xs ) ) )
      = ( map @ D @ A
        @ ^ [X2: D] : ( H2 @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ Xs ) ) ).

% map2_map_map
thf(fact_4737_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B,P: B > $o,F2: B > A] :
          ( ! [X: B] :
              ( ( member @ B @ X @ ( set2 @ B @ Xs ) )
             => ( ~ ( P @ X )
               => ( ( F2 @ X )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_4738_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [F2: B > A,P: B > $o,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
          = ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( F2 @ X2 ) @ ( zero_zero @ A ) )
              @ Xs ) ) ) ) ).

% sum_list_map_filter'
thf(fact_4739_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
               => ( ord_less @ B @ ( F2 @ X ) @ ( G @ X ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_4740_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [X3: B,Xs: list @ B,F2: B > A] :
          ( ( member @ B @ X3 @ ( set2 @ B @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) )
            = ( plus_plus @ A @ ( F2 @ X3 ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X3 @ Xs ) ) ) ) ) ) ) ).

% sum_list_map_remove1
thf(fact_4741_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G: A > B] :
          ( ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G @ X ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ).

% sum_list_mono
thf(fact_4742_sum__list__distinct__conv__sum__set,axiom,
    ! [C: $tType,B: $tType] :
      ( ( comm_monoid_add @ C )
     => ! [Xs: list @ B,F2: B > C] :
          ( ( distinct @ B @ Xs )
         => ( ( groups8242544230860333062m_list @ C @ ( map @ B @ C @ F2 @ Xs ) )
            = ( groups7311177749621191930dd_sum @ B @ C @ F2 @ ( set2 @ B @ Xs ) ) ) ) ) ).

% sum_list_distinct_conv_sum_set
thf(fact_4743_sum_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ B,G: B > A] :
          ( ( distinct @ B @ Xs )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum.distinct_set_conv_list
thf(fact_4744_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R5: B,Xs: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X2: C] : R5
              @ Xs ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs ) ) @ R5 ) ) ) ).

% sum_list_triv
thf(fact_4745_length__concat,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ B ) @ ( concat @ B @ Xss ) )
      = ( groups8242544230860333062m_list @ nat @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) ) ) ).

% length_concat
thf(fact_4746_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs ) ) ) ) ).

% sum_list_abs
thf(fact_4747_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F2: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ Xs ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_4748_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,C2: A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
              @ Xs ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_4749_list_Omap__ident,axiom,
    ! [A: $tType,T3: list @ A] :
      ( ( map @ A @ A
        @ ^ [X2: A] : X2
        @ T3 )
      = T3 ) ).

% list.map_ident
thf(fact_4750_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: B > A,G: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( plus_plus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ Xs ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum_list_addf
thf(fact_4751_List_Omap_Oidentity,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X2: A] : X2 )
      = ( id @ ( list @ A ) ) ) ).

% List.map.identity
thf(fact_4752_sum__list__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: B > A,G: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ Xs ) )
          = ( minus_minus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum_list_subtractf
thf(fact_4753_uminus__sum__list__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( uminus_uminus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ ( comp @ A @ A @ B @ ( uminus_uminus @ A ) @ F2 ) @ Xs ) ) ) ) ).

% uminus_sum_list_map
thf(fact_4754_foldl__map,axiom,
    ! [A: $tType,B: $tType,C: $tType,G: A > B > A,A4: A,F2: C > B,Xs: list @ C] :
      ( ( foldl @ A @ B @ G @ A4 @ ( map @ C @ B @ F2 @ Xs ) )
      = ( foldl @ A @ C
        @ ^ [A5: A,X2: C] : ( G @ A5 @ ( F2 @ X2 ) )
        @ A4
        @ Xs ) ) ).

% foldl_map
thf(fact_4755_sum__code,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,Xs: list @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ ( remdups @ B @ Xs ) ) ) ) ) ).

% sum_code
thf(fact_4756_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ A @ X3 @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% member_le_sum_list
thf(fact_4757_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_4758_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs )
              = ( zero_zero @ A ) )
            = ( ! [X2: A] :
                  ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
                 => ( X2
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_4759_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_4760_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs2: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs2 @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_4761_nths__nths,axiom,
    ! [A: $tType,Xs: list @ A,A3: set @ nat,B2: set @ nat] :
      ( ( nths @ A @ ( nths @ A @ Xs @ A3 ) @ B2 )
      = ( nths @ A @ Xs
        @ ( collect @ nat
          @ ^ [I2: nat] :
              ( ( member @ nat @ I2 @ A3 )
              & ( member @ nat
                @ ( finite_card @ nat
                  @ ( collect @ nat
                    @ ^ [I8: nat] :
                        ( ( member @ nat @ I8 @ A3 )
                        & ( ord_less @ nat @ I8 @ I2 ) ) ) )
                @ B2 ) ) ) ) ) ).

% nths_nths
thf(fact_4762_distinct__sum__list__conv__Sum,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( ( groups8242544230860333062m_list @ A @ Xs )
            = ( groups7311177749621191930dd_sum @ A @ A
              @ ^ [X2: A] : X2
              @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_sum_list_conv_Sum
thf(fact_4763_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_4764_filter__in__nths,axiom,
    ! [A: $tType,Xs: list @ A,S3: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ( filter2 @ A
          @ ^ [X2: A] : ( member @ A @ X2 @ ( set2 @ A @ ( nths @ A @ Xs @ S3 ) ) )
          @ Xs )
        = ( nths @ A @ Xs @ S3 ) ) ) ).

% filter_in_nths
thf(fact_4765_card__length__sum__list__rec,axiom,
    ! [M2: nat,N4: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M2 )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L2: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L2 )
                  = M2 )
                & ( ( groups8242544230860333062m_list @ nat @ L2 )
                  = N4 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L2: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L2 )
                    = ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L2 )
                    = N4 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L2: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L2 )
                    = M2 )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L2 ) @ ( one_one @ nat ) )
                    = N4 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_4766_card__length__sum__list,axiom,
    ! [M2: nat,N4: nat] :
      ( ( finite_card @ ( list @ nat )
        @ ( collect @ ( list @ nat )
          @ ^ [L2: list @ nat] :
              ( ( ( size_size @ ( list @ nat ) @ L2 )
                = M2 )
              & ( ( groups8242544230860333062m_list @ nat @ L2 )
                = N4 ) ) ) )
      = ( binomial @ ( minus_minus @ nat @ ( plus_plus @ nat @ N4 @ M2 ) @ ( one_one @ nat ) ) @ N4 ) ) ).

% card_length_sum_list
thf(fact_4767_length__nths,axiom,
    ! [A: $tType,Xs: list @ A,I: set @ nat] :
      ( ( size_size @ ( list @ A ) @ ( nths @ A @ Xs @ I ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I2: nat] :
              ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( member @ nat @ I2 @ I ) ) ) ) ) ).

% length_nths
thf(fact_4768_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,P: B > $o,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( map_filter @ B @ A
        @ ^ [X2: B] : ( if @ ( option @ A ) @ ( P @ X2 ) @ ( some @ A @ ( F2 @ X2 ) ) @ ( none @ A ) )
        @ Xs ) ) ).

% map_filter_map_filter
thf(fact_4769_filter__eq__nths,axiom,
    ! [A: $tType] :
      ( ( filter2 @ A )
      = ( ^ [P3: A > $o,Xs2: list @ A] :
            ( nths @ A @ Xs2
            @ ( collect @ nat
              @ ^ [I2: nat] :
                  ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                  & ( P3 @ ( nth @ A @ Xs2 @ I2 ) ) ) ) ) ) ) ).

% filter_eq_nths
thf(fact_4770_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs2: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_4771_map__filter__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_filter @ A @ B )
      = ( ^ [F3: A > ( option @ B ),Xs2: list @ A] :
            ( map @ A @ B @ ( comp @ ( option @ B ) @ B @ A @ ( the2 @ B ) @ F3 )
            @ ( filter2 @ A
              @ ^ [X2: A] :
                  ( ( F3 @ X2 )
                 != ( none @ B ) )
              @ Xs2 ) ) ) ) ).

% map_filter_def
thf(fact_4772_length__product__lists,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_4773_part__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_part @ B @ A )
        = ( ^ [F3: B > A,Pivot: A,Xs2: list @ B] :
              ( product_Pair @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) )
              @ ( filter2 @ B
                @ ^ [X2: B] : ( ord_less @ A @ ( F3 @ X2 ) @ Pivot )
                @ Xs2 )
              @ ( product_Pair @ ( list @ B ) @ ( list @ B )
                @ ( filter2 @ B
                  @ ^ [X2: B] :
                      ( ( F3 @ X2 )
                      = Pivot )
                  @ Xs2 )
                @ ( filter2 @ B
                  @ ^ [X2: B] : ( ord_less @ A @ Pivot @ ( F3 @ X2 ) )
                  @ Xs2 ) ) ) ) ) ) ).

% part_def
thf(fact_4774_part__code_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Pivot2: A,X3: B,Xs: list @ B] :
          ( ( linorder_part @ B @ A @ F2 @ Pivot2 @ ( cons @ B @ X3 @ Xs ) )
          = ( product_case_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ ( product_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) )
            @ ^ [Lts: list @ B] :
                ( product_case_prod @ ( list @ B ) @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) )
                @ ^ [Eqs: list @ B,Gts: list @ B] : ( if @ ( product_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) ) @ ( ord_less @ A @ ( F2 @ X3 ) @ Pivot2 ) @ ( product_Pair @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ ( cons @ B @ X3 @ Lts ) @ ( product_Pair @ ( list @ B ) @ ( list @ B ) @ Eqs @ Gts ) ) @ ( if @ ( product_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) ) @ ( ord_less @ A @ Pivot2 @ ( F2 @ X3 ) ) @ ( product_Pair @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ Lts @ ( product_Pair @ ( list @ B ) @ ( list @ B ) @ Eqs @ ( cons @ B @ X3 @ Gts ) ) ) @ ( product_Pair @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ Lts @ ( product_Pair @ ( list @ B ) @ ( list @ B ) @ ( cons @ B @ X3 @ Eqs ) @ Gts ) ) ) ) )
            @ ( linorder_part @ B @ A @ F2 @ Pivot2 @ Xs ) ) ) ) ).

% part_code(2)
thf(fact_4775_map__fst__mk__snd,axiom,
    ! [B: $tType,A: $tType,K: B,L: list @ A] :
      ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B )
        @ ( map @ A @ ( product_prod @ A @ B )
          @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ K )
          @ L ) )
      = L ) ).

% map_fst_mk_snd
thf(fact_4776_map__snd__mk__fst,axiom,
    ! [B: $tType,A: $tType,K: B,L: list @ A] :
      ( ( map @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ ( map @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K ) @ L ) )
      = L ) ).

% map_snd_mk_fst
thf(fact_4777_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: nat > $o,Xs: list @ A,Is: list @ nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( P @ ( suc @ ( product_snd @ A @ nat @ P6 ) ) )
          @ ( zip @ A @ nat @ Xs @ Is ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( P @ ( product_snd @ A @ nat @ P6 ) )
          @ ( zip @ A @ nat @ Xs @ ( map @ nat @ nat @ suc @ Is ) ) ) ) ) ).

% nths_shift_lemma_Suc
thf(fact_4778_product__concat__map,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product @ A @ B )
      = ( ^ [Xs2: list @ A,Ys2: list @ B] :
            ( concat @ ( product_prod @ A @ B )
            @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
              @ ^ [X2: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 ) @ Ys2 )
              @ Xs2 ) ) ) ) ).

% product_concat_map
thf(fact_4779_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( product_lists @ A @ ( cons @ ( list @ A ) @ Xs @ Xss ) )
      = ( concat @ ( list @ A )
        @ ( map @ A @ ( list @ ( list @ A ) )
          @ ^ [X2: A] : ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( product_lists @ A @ Xss ) )
          @ Xs ) ) ) ).

% product_lists.simps(2)
thf(fact_4780_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: A > nat,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) ) ).

% sum_list_filter_le_nat
thf(fact_4781_zip__same__conv__map,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( zip @ A @ A @ Xs @ Xs )
      = ( map @ A @ ( product_prod @ A @ A )
        @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
        @ Xs ) ) ).

% zip_same_conv_map
thf(fact_4782_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( product_product @ A @ B @ ( set2 @ A @ Xs ) @ ( set2 @ B @ Ys ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [X2: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 ) @ Ys )
            @ Xs ) ) ) ) ).

% product_code
thf(fact_4783_sum__list__Suc,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat
        @ ( map @ A @ nat
          @ ^ [X2: A] : ( suc @ ( F2 @ X2 ) )
          @ Xs ) )
      = ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% sum_list_Suc
thf(fact_4784_zip__left__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys @ Zs ) )
      = ( map @ ( product_prod @ B @ ( product_prod @ A @ C ) ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ B @ ( product_prod @ A @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ^ [Y2: B] :
              ( product_case_prod @ A @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
              @ ^ [X2: A,Z3: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X2 @ ( product_Pair @ B @ C @ Y2 @ Z3 ) ) ) )
        @ ( zip @ B @ ( product_prod @ A @ C ) @ Ys @ ( zip @ A @ C @ Xs @ Zs ) ) ) ) ).

% zip_left_commute
thf(fact_4785_zip__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys @ Zs ) )
      = ( map @ ( product_prod @ ( product_prod @ A @ B ) @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ ( product_prod @ A @ B ) @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ( product_case_prod @ A @ B @ ( C > ( product_prod @ A @ ( product_prod @ B @ C ) ) )
            @ ^ [X2: A,Y2: B,Z3: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X2 @ ( product_Pair @ B @ C @ Y2 @ Z3 ) ) ) )
        @ ( zip @ ( product_prod @ A @ B ) @ C @ ( zip @ A @ B @ Xs @ Ys ) @ Zs ) ) ) ).

% zip_assoc
thf(fact_4786_zip__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( zip @ A @ B )
      = ( ^ [Xs2: list @ A,Ys2: list @ B] :
            ( map @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
            @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
              @ ^ [X2: B,Y2: A] : ( product_Pair @ A @ B @ Y2 @ X2 ) )
            @ ( zip @ B @ A @ Ys2 @ Xs2 ) ) ) ) ).

% zip_commute
thf(fact_4787_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( n_lists @ A @ ( suc @ N ) @ Xs )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys2: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y2: A] : ( cons @ A @ Y2 @ Ys2 )
              @ Xs )
          @ ( n_lists @ A @ N @ Xs ) ) ) ) ).

% n_lists.simps(2)
thf(fact_4788_Id__on__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( id_on @ A @ ( set2 @ A @ Xs ) )
      = ( set2 @ ( product_prod @ A @ A )
        @ ( map @ A @ ( product_prod @ A @ A )
          @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
          @ Xs ) ) ) ).

% Id_on_set
thf(fact_4789_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys: list @ ( product_prod @ A @ C ),Yzs: list @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( set2 @ ( product_prod @ A @ C ) @ Xys ) @ ( set2 @ ( product_prod @ C @ B ) @ Yzs ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ ( product_prod @ A @ C ) @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [Xy: product_prod @ A @ C] :
                ( concat @ ( product_prod @ A @ B )
                @ ( map @ ( product_prod @ C @ B ) @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [Yz: product_prod @ C @ B] :
                      ( if @ ( list @ ( product_prod @ A @ B ) )
                      @ ( ( product_snd @ A @ C @ Xy )
                        = ( product_fst @ C @ B @ Yz ) )
                      @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Xy ) @ ( product_snd @ C @ B @ Yz ) ) @ ( nil @ ( product_prod @ A @ B ) ) )
                      @ ( nil @ ( product_prod @ A @ B ) ) )
                  @ Yzs ) )
            @ Xys ) ) ) ) ).

% set_relcomp
thf(fact_4790_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs: list @ A,X5: set @ A,F2: A > nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X5 )
     => ( ( finite_finite2 @ A @ X5 )
       => ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X2: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X2 ) @ ( F2 @ X2 ) )
            @ X5 ) ) ) ) ).

% sum_list_map_eq_sum_count2
thf(fact_4791_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X2: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X2 ) @ ( F2 @ X2 ) )
        @ ( set2 @ A @ Xs ) ) ) ).

% sum_list_map_eq_sum_count
thf(fact_4792_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F2: nat > B,Ns: list @ nat] :
          ( ! [X: nat,Y3: nat] :
              ( ( ord_less_eq @ nat @ X @ Y3 )
             => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F2 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_4793_sorted__wrt__map__linord,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ ( product_prod @ A @ B )] :
          ( ( sorted_wrt @ ( product_prod @ A @ B )
            @ ^ [X2: product_prod @ A @ B,Y2: product_prod @ A @ B] : ( ord_less_eq @ A @ ( product_fst @ A @ B @ X2 ) @ ( product_fst @ A @ B @ Y2 ) )
            @ L )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ L ) ) ) ) ).

% sorted_wrt_map_linord
thf(fact_4794_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R: A > A > $o,F2: B > A,Xs: list @ B] :
      ( ( sorted_wrt @ A @ R @ ( map @ B @ A @ F2 @ Xs ) )
      = ( sorted_wrt @ B
        @ ^ [X2: B,Y2: B] : ( R @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
        @ Xs ) ) ).

% sorted_wrt_map
thf(fact_4795_sorted__wrt__true,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( sorted_wrt @ A
      @ ^ [Uu: A,Uv: A] : $true
      @ Xs ) ).

% sorted_wrt_true
thf(fact_4796_strict__sorted__equal__Uniq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( uniq @ ( list @ A )
          @ ^ [Xs2: list @ A] :
              ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs2 )
              & ( ( set2 @ A @ Xs2 )
                = A3 ) ) ) ) ).

% strict_sorted_equal_Uniq
thf(fact_4797_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
          = ( sorted_wrt @ B
            @ ^ [X2: B,Y2: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
            @ Xs ) ) ) ).

% sorted_map
thf(fact_4798_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G: ( list @ A ) > A,Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X2: A] :
                ( X2
                = ( G @ Xs ) )
            @ Xs ) ) ) ).

% sorted_same
thf(fact_4799_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X3
              @ Xs ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted_insort
thf(fact_4800_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,G: ( list @ B ) > A,Xs: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F2
            @ ( filter2 @ B
              @ ^ [X2: B] :
                  ( ( F2 @ X2 )
                  = ( G @ Xs ) )
              @ Xs ) ) ) ) ).

% sorted_map_same
thf(fact_4801_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: A,Xs: list @ A] :
          ( ( member @ A @ A4 @ ( set2 @ A @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ A4
                @ ( remove1 @ A @ A4 @ Xs ) )
              = Xs ) ) ) ) ).

% insort_remove1
thf(fact_4802_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I3: nat,J2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
       => ( ( ord_less @ nat @ J2
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys2 ) )
                @ Xs ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I3 ) @ J2 )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J2 ) @ I3 ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_4803_transpose__column,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I3: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys2: list @ A] : ( nth @ A @ Ys2 @ I3 )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys2 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( nth @ ( list @ A ) @ Xs @ I3 ) ) ) ) ).

% transpose_column
thf(fact_4804_transpose__column__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I3: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys2 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I3 ) ) ) ) ) ).

% transpose_column_length
thf(fact_4805_sum__list__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( rev @ A @ Xs ) )
          = ( groups8242544230860333062m_list @ A @ Xs ) ) ) ).

% sum_list_rev
thf(fact_4806_sorted__wrt__rev__linord,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ A] :
          ( ( sorted_wrt @ A
            @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
            @ L )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ L ) ) ) ) ).

% sorted_wrt_rev_linord
thf(fact_4807_sorted__wrt__map__rev__linord,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ ( product_prod @ A @ B )] :
          ( ( sorted_wrt @ ( product_prod @ A @ B )
            @ ^ [X2: product_prod @ A @ B,Y2: product_prod @ A @ B] : ( ord_less_eq @ A @ ( product_fst @ A @ B @ Y2 ) @ ( product_fst @ A @ B @ X2 ) )
            @ L )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ L ) ) ) ) ) ).

% sorted_wrt_map_rev_linord
thf(fact_4808_sorted__wrt__rev,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( rev @ A @ Xs ) )
      = ( sorted_wrt @ A
        @ ^ [X2: A,Y2: A] : ( P @ Y2 @ X2 )
        @ Xs ) ) ).

% sorted_wrt_rev
thf(fact_4809_foldr__conv__foldl,axiom,
    ! [A: $tType,B: $tType] :
      ( ( foldr @ B @ A )
      = ( ^ [F3: B > A > A,Xs2: list @ B,A5: A] :
            ( foldl @ A @ B
            @ ^ [X2: A,Y2: B] : ( F3 @ Y2 @ X2 )
            @ A5
            @ ( rev @ B @ Xs2 ) ) ) ) ).

% foldr_conv_foldl
thf(fact_4810_foldl__conv__foldr,axiom,
    ! [B: $tType,A: $tType] :
      ( ( foldl @ A @ B )
      = ( ^ [F3: A > B > A,A5: A,Xs2: list @ B] :
            ( foldr @ B @ A
            @ ^ [X2: B,Y2: A] : ( F3 @ Y2 @ X2 )
            @ ( rev @ B @ Xs2 )
            @ A5 ) ) ) ).

% foldl_conv_foldr
thf(fact_4811_remove__rev__alt__def,axiom,
    ! [A: $tType] :
      ( ( remove_rev @ A )
      = ( ^ [X2: A,Xs2: list @ A] :
            ( filter2 @ A
            @ ^ [Y2: A] : ( Y2 != X2 )
            @ ( rev @ A @ Xs2 ) ) ) ) ).

% remove_rev_alt_def
thf(fact_4812_nths__def,axiom,
    ! [A: $tType] :
      ( ( nths @ A )
      = ( ^ [Xs2: list @ A,A6: set @ nat] :
            ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
            @ ( filter2 @ ( product_prod @ A @ nat )
              @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P6 ) @ A6 )
              @ ( zip @ A @ nat @ Xs2 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ) ).

% nths_def
thf(fact_4813_nths__shift__lemma,axiom,
    ! [A: $tType,A3: set @ nat,Xs: list @ A,I3: nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P6 ) @ A3 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ I3 @ ( plus_plus @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( plus_plus @ nat @ ( product_snd @ A @ nat @ P6 ) @ I3 ) @ A3 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nths_shift_lemma
thf(fact_4814_sum__list__upt,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M2 @ N ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ).

% sum_list_upt
thf(fact_4815_map__add__upt_H,axiom,
    ! [Ofs: nat,A4: nat,B3: nat] :
      ( ( map @ nat @ nat
        @ ^ [I2: nat] : ( plus_plus @ nat @ I2 @ Ofs )
        @ ( upt @ A4 @ B3 ) )
      = ( upt @ ( plus_plus @ nat @ A4 @ Ofs ) @ ( plus_plus @ nat @ B3 @ Ofs ) ) ) ).

% map_add_upt'
thf(fact_4816_upt__filter__extend,axiom,
    ! [U2: nat,U5: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ U2 @ U5 )
     => ( ! [I4: nat] :
            ( ( ( ord_less_eq @ nat @ U2 @ I4 )
              & ( ord_less @ nat @ I4 @ U5 ) )
           => ~ ( P @ I4 ) )
       => ( ( filter2 @ nat @ P @ ( upt @ ( zero_zero @ nat ) @ U2 ) )
          = ( filter2 @ nat @ P @ ( upt @ ( zero_zero @ nat ) @ U5 ) ) ) ) ) ).

% upt_filter_extend
thf(fact_4817_interv__sum__list__conv__sum__set__nat,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [F2: nat > B,M2: nat,N: nat] :
          ( ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F2 @ ( upt @ M2 @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ B @ F2 @ ( set2 @ nat @ ( upt @ M2 @ N ) ) ) ) ) ).

% interv_sum_list_conv_sum_set_nat
thf(fact_4818_sum__set__upt__conv__sum__list__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,M2: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set2 @ nat @ ( upt @ M2 @ N ) ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ nat @ A @ F2 @ ( upt @ M2 @ N ) ) ) ) ) ).

% sum_set_upt_conv_sum_list_nat
thf(fact_4819_map__add__upt,axiom,
    ! [N: nat,M2: nat] :
      ( ( map @ nat @ nat
        @ ^ [I2: nat] : ( plus_plus @ nat @ I2 @ N )
        @ ( upt @ ( zero_zero @ nat ) @ M2 ) )
      = ( upt @ N @ ( plus_plus @ nat @ M2 @ N ) ) ) ).

% map_add_upt
thf(fact_4820_map__upt__Suc,axiom,
    ! [A: $tType,F2: nat > A,N: nat] :
      ( ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
      = ( cons @ A @ ( F2 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I2: nat] : ( F2 @ ( suc @ I2 ) )
          @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% map_upt_Suc
thf(fact_4821_map__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
      = Xs ) ).

% map_nth
thf(fact_4822_map__decr__upt,axiom,
    ! [M2: nat,N: nat] :
      ( ( map @ nat @ nat
        @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M2 ) @ ( suc @ N ) ) )
      = ( upt @ M2 @ N ) ) ).

% map_decr_upt
thf(fact_4823_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N: nat] :
      ( ( ( Xs
          = ( nil @ ( list @ A ) ) )
       => ( N
          = ( zero_zero @ nat ) ) )
     => ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I4 ) )
              = N ) )
       => ( ( transpose @ A @ Xs )
          = ( map @ nat @ ( list @ A )
            @ ^ [I2: nat] :
                ( map @ nat @ A
                @ ^ [J3: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J3 ) @ I2 )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% transpose_rectangle
thf(fact_4824_transpose__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X2: list @ A] :
              ( X2
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_transpose
thf(fact_4825_sorted__find__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ? [X4: A] :
                ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
                & ( P @ X4 ) )
           => ( ( find @ A @ P @ Xs )
              = ( some @ A
                @ ( lattic643756798350308766er_Min @ A
                  @ ( collect @ A
                    @ ^ [X2: A] :
                        ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
                        & ( P @ X2 ) ) ) ) ) ) ) ) ) ).

% sorted_find_Min
thf(fact_4826_extract__Cons__code,axiom,
    ! [A: $tType,P: A > $o,X3: A,Xs: list @ A] :
      ( ( ( P @ X3 )
       => ( ( extract @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( nil @ A ) @ ( product_Pair @ A @ ( list @ A ) @ X3 @ Xs ) ) ) ) )
      & ( ~ ( P @ X3 )
       => ( ( extract @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( case_option @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
              @ ^ [Ys2: list @ A] :
                  ( product_case_prod @ A @ ( list @ A ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
                  @ ^ [Y2: A,Zs2: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( cons @ A @ X3 @ Ys2 ) @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Zs2 ) ) ) ) )
            @ ( extract @ A @ P @ Xs ) ) ) ) ) ).

% extract_Cons_code
thf(fact_4827_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,T3: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) ) )
         => ( ( filter2 @ B
              @ ^ [X2: B] : ( ord_less @ A @ T3 @ ( F2 @ X2 ) )
              @ Xs )
            = ( takeWhile @ B
              @ ^ [X2: B] : ( ord_less @ A @ T3 @ ( F2 @ X2 ) )
              @ Xs ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_4828_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A4: B,Xs: list @ B,F2: B > A] :
          ( ( member @ B @ A4 @ ( set2 @ B @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X2: B] :
                        ( ( F2 @ A4 )
                        = ( F2 @ X2 ) )
                    @ Xs ) )
                = A4 )
             => ( ( linorder_insort_key @ B @ A @ F2 @ A4 @ ( remove1 @ B @ A4 @ Xs ) )
                = Xs ) ) ) ) ) ).

% insort_key_remove1
thf(fact_4829_map__of__distinct__upd,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list @ ( product_prod @ A @ B ),Y: B] :
      ( ~ ( member @ A @ X3 @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) ) )
     => ( ( map_add @ A @ B
          @ ( fun_upd @ A @ ( option @ B )
            @ ^ [X2: A] : ( none @ B )
            @ X3
            @ ( some @ B @ Y ) )
          @ ( map_of @ A @ B @ Xs ) )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ Xs ) @ X3 @ ( some @ B @ Y ) ) ) ) ).

% map_of_distinct_upd
thf(fact_4830_empty__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X2: A] : ( none @ B ) )
        = ( map_of @ A @ B @ Xys ) )
      = ( Xys
        = ( nil @ ( product_prod @ A @ B ) ) ) ) ).

% empty_eq_map_of_iff
thf(fact_4831_hd__def,axiom,
    ! [A: $tType] :
      ( ( hd @ A )
      = ( case_list @ A @ A @ ( undefined @ A )
        @ ^ [X21: A,X222: list @ A] : X21 ) ) ).

% hd_def
thf(fact_4832_list_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H2: B > C,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( H2 @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( case_list @ C @ A @ ( H2 @ F1 )
        @ ^ [X1: A,X22: list @ A] : ( H2 @ ( F22 @ X1 @ X22 ) )
        @ List ) ) ).

% list.case_distrib
thf(fact_4833_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ A
        @ ( map @ ( list @ A ) @ ( list @ A )
          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
            @ ^ [H: A,T5: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ A @ ( hd @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys2: list @ A] :
              ( Ys2
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_head
thf(fact_4834_map__add__map__of__foldr,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),Ps: list @ ( product_prod @ A @ B )] :
      ( ( map_add @ A @ B @ M2 @ ( map_of @ A @ B @ Ps ) )
      = ( foldr @ ( product_prod @ A @ B ) @ ( A > ( option @ B ) )
        @ ( product_case_prod @ A @ B @ ( ( A > ( option @ B ) ) > A > ( option @ B ) )
          @ ^ [K6: A,V2: B,M5: A > ( option @ B )] : ( fun_upd @ A @ ( option @ B ) @ M5 @ K6 @ ( some @ B @ V2 ) ) )
        @ Ps
        @ M2 ) ) ).

% map_add_map_of_foldr
thf(fact_4835_map__of__concat,axiom,
    ! [B: $tType,A: $tType,Xss: list @ ( list @ ( product_prod @ A @ B ) )] :
      ( ( map_of @ A @ B @ ( concat @ ( product_prod @ A @ B ) @ Xss ) )
      = ( foldr @ ( list @ ( product_prod @ A @ B ) ) @ ( A > ( option @ B ) )
        @ ^ [Xs2: list @ ( product_prod @ A @ B ),F3: A > ( option @ B )] : ( map_add @ A @ B @ F3 @ ( map_of @ A @ B @ Xs2 ) )
        @ Xss
        @ ^ [X2: A] : ( none @ B ) ) ) ).

% map_of_concat
thf(fact_4836_map__of__map__keys,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,M2: A > ( option @ B )] :
      ( ( ( set2 @ A @ Xs )
        = ( dom @ A @ B @ M2 ) )
     => ( ( map_of @ A @ B
          @ ( map @ A @ ( product_prod @ A @ B )
            @ ^ [K6: A] : ( product_Pair @ A @ B @ K6 @ ( the2 @ B @ ( M2 @ K6 ) ) )
            @ Xs ) )
        = M2 ) ) ).

% map_of_map_keys
thf(fact_4837_map__of__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: C > B,Xs: list @ ( product_prod @ A @ C )] :
      ( ( map_of @ A @ B
        @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
            @ ^ [K6: A,V2: C] : ( product_Pair @ A @ B @ K6 @ ( F2 @ V2 ) ) )
          @ Xs ) )
      = ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 ) @ ( map_of @ A @ C @ Xs ) ) ) ).

% map_of_map
thf(fact_4838_transpose_Oelims,axiom,
    ! [A: $tType,X3: list @ ( list @ A ),Y: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X3 )
        = Y )
     => ( ( ( X3
            = ( nil @ ( list @ A ) ) )
         => ( Y
           != ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( X3
                = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( Y
               != ( transpose @ A @ Xss2 ) ) )
         => ~ ! [X: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                ( ( X3
                  = ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs3 ) @ Xss2 ) )
               => ( Y
                 != ( cons @ ( list @ A )
                    @ ( cons @ A @ X
                      @ ( concat @ A
                        @ ( map @ ( list @ A ) @ ( list @ A )
                          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                            @ ^ [H: A,T5: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                          @ Xss2 ) ) )
                    @ ( transpose @ A
                      @ ( cons @ ( list @ A ) @ Xs3
                        @ ( concat @ ( list @ A )
                          @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                            @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                              @ ^ [H: A,T5: list @ A] : ( cons @ ( list @ A ) @ T5 @ ( nil @ ( list @ A ) ) ) )
                            @ Xss2 ) ) ) ) ) ) ) ) ) ) ).

% transpose.elims
thf(fact_4839_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ Xss ) )
      = ( cons @ ( list @ A )
        @ ( cons @ A @ X3
          @ ( concat @ A
            @ ( map @ ( list @ A ) @ ( list @ A )
              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                @ ^ [H: A,T5: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
              @ Xss ) ) )
        @ ( transpose @ A
          @ ( cons @ ( list @ A ) @ Xs
            @ ( concat @ ( list @ A )
              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                  @ ^ [H: A,T5: list @ A] : ( cons @ ( list @ A ) @ T5 @ ( nil @ ( list @ A ) ) ) )
                @ Xss ) ) ) ) ) ) ).

% transpose.simps(3)
thf(fact_4840_set__map__of__compr,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B )] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
     => ( ( set2 @ ( product_prod @ A @ B ) @ Xs )
        = ( collect @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ B @ $o
            @ ^ [K6: A,V2: B] :
                ( ( map_of @ A @ B @ Xs @ K6 )
                = ( some @ B @ V2 ) ) ) ) ) ) ).

% set_map_of_compr
thf(fact_4841_map__of__mapk__SomeI,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > B,T3: list @ ( product_prod @ A @ C ),K: A,X3: C] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map_of @ A @ C @ T3 @ K )
          = ( some @ C @ X3 ) )
       => ( ( map_of @ B @ C
            @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C )
              @ ( product_case_prod @ A @ C @ ( product_prod @ B @ C )
                @ ^ [K6: A] : ( product_Pair @ B @ C @ ( F2 @ K6 ) ) )
              @ T3 )
            @ ( F2 @ K ) )
          = ( some @ C @ X3 ) ) ) ) ).

% map_of_mapk_SomeI
thf(fact_4842_map__of__map__restrict,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Ks: list @ A] :
      ( ( map_of @ A @ B
        @ ( map @ A @ ( product_prod @ A @ B )
          @ ^ [K6: A] : ( product_Pair @ A @ B @ K6 @ ( F2 @ K6 ) )
          @ Ks ) )
      = ( restrict_map @ A @ B @ ( comp @ B @ ( option @ B ) @ A @ ( some @ B ) @ F2 ) @ ( set2 @ A @ Ks ) ) ) ).

% map_of_map_restrict
thf(fact_4843_min__list_Oelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X3: list @ A,Y: A] :
          ( ( ( min_list @ A @ X3 )
            = Y )
         => ( ! [X: A,Xs3: list @ A] :
                ( ( X3
                  = ( cons @ A @ X @ Xs3 ) )
               => ( Y
                 != ( case_list @ A @ A @ X
                    @ ^ [A5: A,List2: list @ A] : ( ord_min @ A @ X @ ( min_list @ A @ Xs3 ) )
                    @ Xs3 ) ) )
           => ~ ( ( X3
                  = ( nil @ A ) )
               => ( Y
                 != ( undefined @ A ) ) ) ) ) ) ).

% min_list.elims
thf(fact_4844_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
            @ ^ [H: A,T5: list @ A] : ( cons @ ( list @ A ) @ T5 @ ( nil @ ( list @ A ) ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ ( list @ A ) @ ( tl @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys2: list @ A] :
              ( Ys2
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_tail
thf(fact_4845_transpose_Opelims,axiom,
    ! [A: $tType,X3: list @ ( list @ A ),Y: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X3 )
        = Y )
     => ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ X3 )
       => ( ( ( X3
              = ( nil @ ( list @ A ) ) )
           => ( ( Y
                = ( nil @ ( list @ A ) ) )
             => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) ) ) )
         => ( ! [Xss2: list @ ( list @ A )] :
                ( ( X3
                  = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
               => ( ( Y
                    = ( transpose @ A @ Xss2 ) )
                 => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
           => ~ ! [X: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                  ( ( X3
                    = ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs3 ) @ Xss2 ) )
                 => ( ( Y
                      = ( cons @ ( list @ A )
                        @ ( cons @ A @ X
                          @ ( concat @ A
                            @ ( map @ ( list @ A ) @ ( list @ A )
                              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                                @ ^ [H: A,T5: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                              @ Xss2 ) ) )
                        @ ( transpose @ A
                          @ ( cons @ ( list @ A ) @ Xs3
                            @ ( concat @ ( list @ A )
                              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                                  @ ^ [H: A,T5: list @ A] : ( cons @ ( list @ A ) @ T5 @ ( nil @ ( list @ A ) ) ) )
                                @ Xss2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs3 ) @ Xss2 ) ) ) ) ) ) ) ) ).

% transpose.pelims
thf(fact_4846_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
        = ( nil @ A ) )
      = ( case_list @ $o @ A @ $true
        @ ^ [Uu: A,Uv: list @ A] : $false
        @ List ) ) ).

% list.disc_eq_case(1)
thf(fact_4847_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( ( List
         != ( nil @ A ) ) )
      = ( case_list @ $o @ A @ $false
        @ ^ [Uu: A,Uv: list @ A] : $true
        @ List ) ) ).

% list.disc_eq_case(2)
thf(fact_4848_tl__def,axiom,
    ! [A: $tType] :
      ( ( tl @ A )
      = ( case_list @ ( list @ A ) @ A @ ( nil @ A )
        @ ^ [X21: A,X222: list @ A] : X222 ) ) ).

% tl_def
thf(fact_4849_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list @ ( list @ A ),P: ( list @ ( list @ A ) ) > $o] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ A0 )
     => ( ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
         => ( P @ ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( ( P @ Xss2 )
               => ( P @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
         => ( ! [X: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs3 ) @ Xss2 ) )
               => ( ( P
                    @ ( cons @ ( list @ A ) @ Xs3
                      @ ( concat @ ( list @ A )
                        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                            @ ^ [H: A,T5: list @ A] : ( cons @ ( list @ A ) @ T5 @ ( nil @ ( list @ A ) ) ) )
                          @ Xss2 ) ) ) )
                 => ( P @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs3 ) @ Xss2 ) ) ) )
           => ( P @ A0 ) ) ) ) ) ).

% transpose.pinduct
thf(fact_4850_zip__Cons1,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list @ A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X3 @ Xs ) @ Ys )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ B @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Y2: B,Ys2: list @ B] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
        @ Ys ) ) ).

% zip_Cons1
thf(fact_4851_zip__Cons,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( cons @ B @ Y @ Ys ) )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ A @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Z3: A,Zs2: list @ A] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Z3 @ Y ) @ ( zip @ A @ B @ Zs2 @ Ys ) )
        @ Xs ) ) ).

% zip_Cons
thf(fact_4852_min__list_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( min_list @ A @ ( cons @ A @ X3 @ Xs ) )
          = ( case_list @ A @ A @ X3
            @ ^ [A5: A,List2: list @ A] : ( ord_min @ A @ X3 @ ( min_list @ A @ Xs ) )
            @ Xs ) ) ) ).

% min_list.simps
thf(fact_4853_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ Xss ) )
        = ( cons @ ( list @ A )
          @ ( cons @ A @ X3
            @ ( concat @ A
              @ ( map @ ( list @ A ) @ ( list @ A )
                @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                  @ ^ [H: A,T5: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                @ Xss ) ) )
          @ ( transpose @ A
            @ ( cons @ ( list @ A ) @ Xs
              @ ( concat @ ( list @ A )
                @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                  @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                    @ ^ [H: A,T5: list @ A] : ( cons @ ( list @ A ) @ T5 @ ( nil @ ( list @ A ) ) ) )
                  @ Xss ) ) ) ) ) ) ) ).

% transpose.psimps(3)
thf(fact_4854_min__list_Opelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X3: list @ A,Y: A] :
          ( ( ( min_list @ A @ X3 )
            = Y )
         => ( ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ X3 )
           => ( ! [X: A,Xs3: list @ A] :
                  ( ( X3
                    = ( cons @ A @ X @ Xs3 ) )
                 => ( ( Y
                      = ( case_list @ A @ A @ X
                        @ ^ [A5: A,List2: list @ A] : ( ord_min @ A @ X @ ( min_list @ A @ Xs3 ) )
                        @ Xs3 ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( cons @ A @ X @ Xs3 ) ) ) )
             => ~ ( ( X3
                    = ( nil @ A ) )
                 => ( ( Y
                      = ( undefined @ A ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( nil @ A ) ) ) ) ) ) ) ) ).

% min_list.pelims
thf(fact_4855_extract__def,axiom,
    ! [A: $tType] :
      ( ( extract @ A )
      = ( ^ [P3: A > $o,Xs2: list @ A] :
            ( case_list @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ A @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ^ [Y2: A,Ys2: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( takeWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs2 ) @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Ys2 ) ) )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs2 ) ) ) ) ).

% extract_def
thf(fact_4856_Bleast__code,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( bleast @ A @ ( set2 @ A @ Xs ) @ P )
          = ( case_list @ A @ A @ ( abort_Bleast @ A @ ( set2 @ A @ Xs ) @ P )
            @ ^ [X2: A,Xs2: list @ A] : X2
            @ ( filter2 @ A @ P
              @ ( linorder_sort_key @ A @ A
                @ ^ [X2: A] : X2
                @ Xs ) ) ) ) ) ).

% Bleast_code
thf(fact_4857_sort__upt,axiom,
    ! [M2: nat,N: nat] :
      ( ( linorder_sort_key @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( upt @ M2 @ N ) )
      = ( upt @ M2 @ N ) ) ).

% sort_upt
thf(fact_4858_sort__key__stable,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,K: B,Xs: list @ A] :
          ( ( filter2 @ A
            @ ^ [Y2: A] :
                ( ( F2 @ Y2 )
                = K )
            @ ( linorder_sort_key @ A @ B @ F2 @ Xs ) )
          = ( filter2 @ A
            @ ^ [Y2: A] :
                ( ( F2 @ Y2 )
                = K )
            @ Xs ) ) ) ).

% sort_key_stable
thf(fact_4859_sort__key__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [C2: B,Xs: list @ A] :
          ( ( linorder_sort_key @ A @ B
            @ ^ [X2: A] : C2
            @ Xs )
          = Xs ) ) ).

% sort_key_const
thf(fact_4860_sorted__sort__id,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( linorder_sort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Xs )
            = Xs ) ) ) ).

% sorted_sort_id
thf(fact_4861_sorted__sort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( linorder_sort_key @ A @ A
            @ ^ [X2: A] : X2
            @ Xs ) ) ) ).

% sorted_sort
thf(fact_4862_find__dropWhile,axiom,
    ! [A: $tType] :
      ( ( find @ A )
      = ( ^ [P3: A > $o,Xs2: list @ A] :
            ( case_list @ ( option @ A ) @ A @ ( none @ A )
            @ ^ [X2: A,Xa4: list @ A] : ( some @ A @ X2 )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs2 ) ) ) ) ).

% find_dropWhile
thf(fact_4863_sorted__list__of__set__sort__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
          = ( linorder_sort_key @ A @ A
            @ ^ [X2: A] : X2
            @ ( remdups @ A @ Xs ) ) ) ) ).

% sorted_list_of_set_sort_remdups
thf(fact_4864_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ( ( dropWhile @ A
            @ ^ [Y2: A] : ( Y2 != X3 )
            @ ( rev @ A @ Xs ) )
          = ( cons @ A @ X3
            @ ( rev @ A
              @ ( takeWhile @ A
                @ ^ [Y2: A] : ( Y2 != X3 )
                @ Xs ) ) ) ) ) ) ).

% dropWhile_neq_rev
thf(fact_4865_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ( ( takeWhile @ A
            @ ^ [Y2: A] : ( Y2 != X3 )
            @ ( rev @ A @ Xs ) )
          = ( rev @ A
            @ ( tl @ A
              @ ( dropWhile @ A
                @ ^ [Y2: A] : ( Y2 != X3 )
                @ Xs ) ) ) ) ) ) ).

% takeWhile_neq_rev
thf(fact_4866_sort__key__by__quicksort__code,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_sort_key @ B @ A )
        = ( ^ [F3: B > A,Xs2: list @ B] :
              ( case_list @ ( list @ B ) @ B @ ( nil @ B )
              @ ^ [X2: B] :
                  ( case_list @ ( list @ B ) @ B @ Xs2
                  @ ^ [Y2: B] :
                      ( case_list @ ( list @ B ) @ B @ ( if @ ( list @ B ) @ ( ord_less_eq @ A @ ( F3 @ X2 ) @ ( F3 @ Y2 ) ) @ Xs2 @ ( cons @ B @ Y2 @ ( cons @ B @ X2 @ ( nil @ B ) ) ) )
                      @ ^ [Ab: B,List2: list @ B] :
                          ( product_case_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ ( list @ B )
                          @ ^ [Lts: list @ B] :
                              ( product_case_prod @ ( list @ B ) @ ( list @ B ) @ ( list @ B )
                              @ ^ [Eqs: list @ B,Gts: list @ B] : ( append @ B @ ( linorder_sort_key @ B @ A @ F3 @ Lts ) @ ( append @ B @ Eqs @ ( linorder_sort_key @ B @ A @ F3 @ Gts ) ) ) )
                          @ ( linorder_part @ B @ A @ F3 @ ( F3 @ ( nth @ B @ Xs2 @ ( divide_divide @ nat @ ( size_size @ ( list @ B ) @ Xs2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Xs2 ) ) ) )
              @ Xs2 ) ) ) ) ).

% sort_key_by_quicksort_code
thf(fact_4867_remdup__sort__mergesort__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A ) @ ( remdups @ A )
          @ ( linorder_sort_key @ A @ A
            @ ^ [X2: A] : X2 ) )
        = ( mergesort_remdups @ A ) ) ) ).

% remdup_sort_mergesort_remdups
thf(fact_4868_sort__key__by__quicksort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_sort_key @ B @ A )
        = ( ^ [F3: B > A,Xs2: list @ B] :
              ( append @ B
              @ ( linorder_sort_key @ B @ A @ F3
                @ ( filter2 @ B
                  @ ^ [X2: B] : ( ord_less @ A @ ( F3 @ X2 ) @ ( F3 @ ( nth @ B @ Xs2 @ ( divide_divide @ nat @ ( size_size @ ( list @ B ) @ Xs2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  @ Xs2 ) )
              @ ( append @ B
                @ ( filter2 @ B
                  @ ^ [X2: B] :
                      ( ( F3 @ X2 )
                      = ( F3 @ ( nth @ B @ Xs2 @ ( divide_divide @ nat @ ( size_size @ ( list @ B ) @ Xs2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  @ Xs2 )
                @ ( linorder_sort_key @ B @ A @ F3
                  @ ( filter2 @ B
                    @ ^ [X2: B] : ( ord_less @ A @ ( F3 @ ( nth @ B @ Xs2 @ ( divide_divide @ nat @ ( size_size @ ( list @ B ) @ Xs2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( F3 @ X2 ) )
                    @ Xs2 ) ) ) ) ) ) ) ).

% sort_key_by_quicksort
thf(fact_4869_sum__list__append,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( append @ A @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( groups8242544230860333062m_list @ A @ Ys ) ) ) ) ).

% sum_list_append
thf(fact_4870_distinct__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( append @ A @ Xs @ Ys ) )
      = ( ( distinct @ A @ Xs )
        & ( distinct @ A @ Ys )
        & ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% distinct_append
thf(fact_4871_tl__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
      = ( case_list @ ( list @ A ) @ A @ ( tl @ A @ Ys )
        @ ^ [Z3: A,Zs2: list @ A] : ( append @ A @ Zs2 @ Ys )
        @ Xs ) ) ).

% tl_append
thf(fact_4872_map__by__foldl,axiom,
    ! [B: $tType,A: $tType,F2: A > B,L: list @ A] :
      ( ( foldl @ ( list @ B ) @ A
        @ ^ [L2: list @ B,X2: A] : ( append @ B @ L2 @ ( cons @ B @ ( F2 @ X2 ) @ ( nil @ B ) ) )
        @ ( nil @ B )
        @ L )
      = ( map @ A @ B @ F2 @ L ) ) ).

% map_by_foldl
thf(fact_4873_takeWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ! [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
           => ( P @ X ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( takeWhile @ A @ P @ Ys ) ) ) )
      & ( ~ ! [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
             => ( P @ X4 ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% takeWhile_append
thf(fact_4874_dropWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ! [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
           => ( P @ X ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( dropWhile @ A @ P @ Ys ) ) )
      & ( ~ ! [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
             => ( P @ X4 ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ Ys ) ) ) ) ).

% dropWhile_append
thf(fact_4875_nths__append,axiom,
    ! [A: $tType,L: list @ A,L5: list @ A,A3: set @ nat] :
      ( ( nths @ A @ ( append @ A @ L @ L5 ) @ A3 )
      = ( append @ A @ ( nths @ A @ L @ A3 )
        @ ( nths @ A @ L5
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( plus_plus @ nat @ J3 @ ( size_size @ ( list @ A ) @ L ) ) @ A3 ) ) ) ) ) ).

% nths_append
thf(fact_4876_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > A,A4: A,Xs: list @ B,Ys: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A4 @ ( append @ B @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A4 @ Xs ) @ ( times_times @ A @ ( power_power @ A @ A4 @ ( size_size @ ( list @ B ) @ Xs ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A4 @ Ys ) ) ) ) ) ).

% horner_sum_append
thf(fact_4877_nths__Cons,axiom,
    ! [A: $tType,X3: A,L: list @ A,A3: set @ nat] :
      ( ( nths @ A @ ( cons @ A @ X3 @ L ) @ A3 )
      = ( append @ A @ ( if @ ( list @ A ) @ ( member @ nat @ ( zero_zero @ nat ) @ A3 ) @ ( cons @ A @ X3 @ ( nil @ A ) ) @ ( nil @ A ) )
        @ ( nths @ A @ L
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( suc @ J3 ) @ A3 ) ) ) ) ) ).

% nths_Cons
thf(fact_4878_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A4: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ! [X: A] :
                ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X @ A4 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ A4
                @ Xs )
              = ( append @ A @ Xs @ ( cons @ A @ A4 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_4879_filter__upt__last,axiom,
    ! [A: $tType,P: A > $o,L: list @ A,Js: list @ nat,J2: nat,I3: nat] :
      ( ( ( filter2 @ nat
          @ ^ [K6: nat] : ( P @ ( nth @ A @ L @ K6 ) )
          @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ L ) ) )
        = ( append @ nat @ Js @ ( cons @ nat @ J2 @ ( nil @ nat ) ) ) )
     => ( ( ord_less @ nat @ J2 @ I3 )
       => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ L ) )
         => ~ ( P @ ( nth @ A @ L @ I3 ) ) ) ) ) ).

% filter_upt_last
thf(fact_4880_sort__by__quicksort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( linorder_sort_key @ A @ A
            @ ^ [X2: A] : X2
            @ Xs )
          = ( append @ A
            @ ( linorder_sort_key @ A @ A
              @ ^ [X2: A] : X2
              @ ( filter2 @ A
                @ ^ [X2: A] : ( ord_less @ A @ X2 @ ( nth @ A @ Xs @ ( divide_divide @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                @ Xs ) )
            @ ( append @ A
              @ ( filter2 @ A
                @ ^ [X2: A] :
                    ( X2
                    = ( nth @ A @ Xs @ ( divide_divide @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                @ Xs )
              @ ( linorder_sort_key @ A @ A
                @ ^ [X2: A] : X2
                @ ( filter2 @ A @ ( ord_less @ A @ ( nth @ A @ Xs @ ( divide_divide @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Xs ) ) ) ) ) ) ).

% sort_by_quicksort
thf(fact_4881_lexn__conv,axiom,
    ! [A: $tType] :
      ( ( lexn @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),N5: nat] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys2: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = N5 )
                  & ( ( size_size @ ( list @ A ) @ Ys2 )
                    = N5 )
                  & ? [Xys2: list @ A,X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                      ( ( Xs2
                        = ( append @ A @ Xys2 @ ( cons @ A @ X2 @ Xs4 ) ) )
                      & ( Ys2
                        = ( append @ A @ Xys2 @ ( cons @ A @ Y2 @ Ys4 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 ) ) ) ) ) ) ) ).

% lexn_conv
thf(fact_4882_lex__conv,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys2: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = ( size_size @ ( list @ A ) @ Ys2 ) )
                  & ? [Xys2: list @ A,X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                      ( ( Xs2
                        = ( append @ A @ Xys2 @ ( cons @ A @ X2 @ Xs4 ) ) )
                      & ( Ys2
                        = ( append @ A @ Xys2 @ ( cons @ A @ Y2 @ Ys4 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 ) ) ) ) ) ) ) ).

% lex_conv
thf(fact_4883_subset__eq__mset__impl_Oelims,axiom,
    ! [A: $tType,X3: list @ A,Xa: list @ A,Y: option @ $o] :
      ( ( ( subset_eq_mset_impl @ A @ X3 @ Xa )
        = Y )
     => ( ( ( X3
            = ( nil @ A ) )
         => ( Y
           != ( some @ $o
              @ ( Xa
               != ( nil @ A ) ) ) ) )
       => ~ ! [X: A,Xs3: list @ A] :
              ( ( X3
                = ( cons @ A @ X @ Xs3 ) )
             => ( Y
               != ( case_option @ ( option @ $o ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ $o )
                  @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ $o )
                    @ ^ [Ys1: list @ A] :
                        ( product_case_prod @ A @ ( list @ A ) @ ( option @ $o )
                        @ ^ [Y2: A,Ys22: list @ A] : ( subset_eq_mset_impl @ A @ Xs3 @ ( append @ A @ Ys1 @ Ys22 ) ) ) )
                  @ ( extract @ A
                    @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
                      @ X )
                    @ Xa ) ) ) ) ) ) ).

% subset_eq_mset_impl.elims
thf(fact_4884_lex__def,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] : ( complete_Sup_Sup @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image2 @ nat @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( lexn @ A @ R3 ) @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% lex_def
thf(fact_4885_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( lexn @ A @ R5 @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) ).

% lexn.simps(1)
thf(fact_4886_subset__eq__mset__impl_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Ys: list @ A] :
      ( ( subset_eq_mset_impl @ A @ ( cons @ A @ X3 @ Xs ) @ Ys )
      = ( case_option @ ( option @ $o ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ $o )
        @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ $o )
          @ ^ [Ys1: list @ A] :
              ( product_case_prod @ A @ ( list @ A ) @ ( option @ $o )
              @ ^ [X2: A,Ys22: list @ A] : ( subset_eq_mset_impl @ A @ Xs @ ( append @ A @ Ys1 @ Ys22 ) ) ) )
        @ ( extract @ A
          @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
            @ X3 )
          @ Ys ) ) ) ).

% subset_eq_mset_impl.simps(2)
thf(fact_4887_subset__eq__mset__impl_Opelims,axiom,
    ! [A: $tType,X3: list @ A,Xa: list @ A,Y: option @ $o] :
      ( ( ( subset_eq_mset_impl @ A @ X3 @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( subset751672762298770561pl_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ Xa ) )
       => ( ( ( X3
              = ( nil @ A ) )
           => ( ( Y
                = ( some @ $o
                  @ ( Xa
                   != ( nil @ A ) ) ) )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( subset751672762298770561pl_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ~ ! [X: A,Xs3: list @ A] :
                ( ( X3
                  = ( cons @ A @ X @ Xs3 ) )
               => ( ( Y
                    = ( case_option @ ( option @ $o ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ $o )
                      @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ $o )
                        @ ^ [Ys1: list @ A] :
                            ( product_case_prod @ A @ ( list @ A ) @ ( option @ $o )
                            @ ^ [Y2: A,Ys22: list @ A] : ( subset_eq_mset_impl @ A @ Xs3 @ ( append @ A @ Ys1 @ Ys22 ) ) ) )
                      @ ( extract @ A
                        @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
                          @ X )
                        @ Xa ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( subset751672762298770561pl_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs3 ) @ Xa ) ) ) ) ) ) ) ).

% subset_eq_mset_impl.pelims
thf(fact_4888_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys2: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys2 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs2 )
                      = ( size_size @ ( list @ A ) @ Ys2 ) )
                    & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys2 ) @ ( lex @ A @ R3 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_4889_quicksort_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( linorder_quicksort @ A @ ( cons @ A @ X3 @ Xs ) )
          = ( append @ A
            @ ( linorder_quicksort @ A
              @ ( filter2 @ A
                @ ^ [Y2: A] :
                    ~ ( ord_less_eq @ A @ X3 @ Y2 )
                @ Xs ) )
            @ ( append @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) @ ( linorder_quicksort @ A @ ( filter2 @ A @ ( ord_less_eq @ A @ X3 ) @ Xs ) ) ) ) ) ) ).

% quicksort.simps(2)
thf(fact_4890_sort__quicksort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_sort_key @ A @ A
          @ ^ [X2: A] : X2 )
        = ( linorder_quicksort @ A ) ) ) ).

% sort_quicksort
thf(fact_4891_quicksort_Oelims,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: list @ A,Y: list @ A] :
          ( ( ( linorder_quicksort @ A @ X3 )
            = Y )
         => ( ( ( X3
                = ( nil @ A ) )
             => ( Y
               != ( nil @ A ) ) )
           => ~ ! [X: A,Xs3: list @ A] :
                  ( ( X3
                    = ( cons @ A @ X @ Xs3 ) )
                 => ( Y
                   != ( append @ A
                      @ ( linorder_quicksort @ A
                        @ ( filter2 @ A
                          @ ^ [Y2: A] :
                              ~ ( ord_less_eq @ A @ X @ Y2 )
                          @ Xs3 ) )
                      @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ ( linorder_quicksort @ A @ ( filter2 @ A @ ( ord_less_eq @ A @ X ) @ Xs3 ) ) ) ) ) ) ) ) ) ).

% quicksort.elims
thf(fact_4892_quicksort_Opelims,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: list @ A,Y: list @ A] :
          ( ( ( linorder_quicksort @ A @ X3 )
            = Y )
         => ( ( accp @ ( list @ A ) @ ( linord6200660962353139674rt_rel @ A ) @ X3 )
           => ( ( ( X3
                  = ( nil @ A ) )
               => ( ( Y
                    = ( nil @ A ) )
                 => ~ ( accp @ ( list @ A ) @ ( linord6200660962353139674rt_rel @ A ) @ ( nil @ A ) ) ) )
             => ~ ! [X: A,Xs3: list @ A] :
                    ( ( X3
                      = ( cons @ A @ X @ Xs3 ) )
                   => ( ( Y
                        = ( append @ A
                          @ ( linorder_quicksort @ A
                            @ ( filter2 @ A
                              @ ^ [Y2: A] :
                                  ~ ( ord_less_eq @ A @ X @ Y2 )
                              @ Xs3 ) )
                          @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ ( linorder_quicksort @ A @ ( filter2 @ A @ ( ord_less_eq @ A @ X ) @ Xs3 ) ) ) ) )
                     => ~ ( accp @ ( list @ A ) @ ( linord6200660962353139674rt_rel @ A ) @ ( cons @ A @ X @ Xs3 ) ) ) ) ) ) ) ) ).

% quicksort.pelims
thf(fact_4893_shuffles_Opelims,axiom,
    ! [A: $tType,X3: list @ A,Xa: list @ A,Y: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X3 @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ Xa ) )
       => ( ( ( X3
              = ( nil @ A ) )
           => ( ( Y
                = ( insert @ ( list @ A ) @ Xa @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ( ( ( Xa
                = ( nil @ A ) )
             => ( ( Y
                  = ( insert @ ( list @ A ) @ X3 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ ( nil @ A ) ) ) ) )
           => ~ ! [X: A,Xs3: list @ A] :
                  ( ( X3
                    = ( cons @ A @ X @ Xs3 ) )
                 => ! [Y3: A,Ys3: list @ A] :
                      ( ( Xa
                        = ( cons @ A @ Y3 @ Ys3 ) )
                     => ( ( Y
                          = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs3 @ ( cons @ A @ Y3 @ Ys3 ) ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y3 ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs3 ) @ Ys3 ) ) ) )
                       => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs3 ) @ ( cons @ A @ Y3 @ Ys3 ) ) ) ) ) ) ) ) ) ) ).

% shuffles.pelims
thf(fact_4894_shuffles_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) )
     => ( ( shuffles @ A @ ( nil @ A ) @ Ys )
        = ( insert @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(1)
thf(fact_4895_shuffles_Opsimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) )
     => ( ( shuffles @ A @ Xs @ ( nil @ A ) )
        = ( insert @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(2)
thf(fact_4896_inv__image__partition,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ( P @ X ) )
     => ( ! [Y3: A] :
            ( ( member @ A @ Y3 @ ( set2 @ A @ Ys ) )
           => ~ ( P @ Y3 ) )
       => ( ( vimage @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( partition @ A @ P ) @ ( insert @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) )
          = ( shuffles @ A @ Xs @ Ys ) ) ) ) ).

% inv_image_partition
thf(fact_4897_mergesort__remdups__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( mergesort_remdups @ A )
        = ( ^ [Xs2: list @ A] :
              ( merge_list @ A @ ( nil @ ( list @ A ) )
              @ ( map @ A @ ( list @ A )
                @ ^ [X2: A] : ( cons @ A @ X2 @ ( nil @ A ) )
                @ Xs2 ) ) ) ) ) ).

% mergesort_remdups_def
thf(fact_4898_lexord__def,axiom,
    ! [A: $tType] :
      ( ( lexord @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [X2: list @ A,Y2: list @ A] :
                ? [A5: A,V2: list @ A] :
                  ( ( Y2
                    = ( append @ A @ X2 @ ( cons @ A @ A5 @ V2 ) ) )
                  | ? [U: list @ A,B4: A,C5: A,W3: list @ A,Z3: list @ A] :
                      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ C5 ) @ R3 )
                      & ( X2
                        = ( append @ A @ U @ ( cons @ A @ B4 @ W3 ) ) )
                      & ( Y2
                        = ( append @ A @ U @ ( cons @ A @ C5 @ Z3 ) ) ) ) ) ) ) ) ) ).

% lexord_def
thf(fact_4899_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X3: A,Xs: list @ A] :
      ( ( partition @ A @ P @ ( cons @ A @ X3 @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
        @ ^ [Yes: list @ A,No: list @ A] : ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( P @ X3 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Yes ) @ No ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ ( cons @ A @ X3 @ No ) ) )
        @ ( partition @ A @ P @ Xs ) ) ) ).

% partition.simps(2)
thf(fact_4900_lexordp__conv__lexord,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs2: list @ A,Ys2: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys2 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ ( ord_less @ A ) ) ) ) ) ) ) ) ).

% lexordp_conv_lexord
thf(fact_4901_List_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [R3: A > A > $o,Xs2: list @ A,Ys2: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys2 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R3 ) ) ) ) ) ) ).

% List.lexordp_def
thf(fact_4902_Succ__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Greatest_Succ @ A )
      = ( ^ [Kl: set @ ( list @ A ),Kl2: list @ A] :
            ( collect @ A
            @ ^ [K6: A] : ( member @ ( list @ A ) @ ( append @ A @ Kl2 @ ( cons @ A @ K6 @ ( nil @ A ) ) ) @ Kl ) ) ) ) ).

% Succ_def
thf(fact_4903_listrel1__def,axiom,
    ! [A: $tType] :
      ( ( listrel1 @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys2: list @ A] :
                ? [Us: list @ A,Z3: A,Z9: A,Vs: list @ A] :
                  ( ( Xs2
                    = ( append @ A @ Us @ ( cons @ A @ Z3 @ Vs ) ) )
                  & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ Z9 ) @ R3 )
                  & ( Ys2
                    = ( append @ A @ Us @ ( cons @ A @ Z9 @ Vs ) ) ) ) ) ) ) ) ).

% listrel1_def
thf(fact_4904_listrel1p__def,axiom,
    ! [A: $tType] :
      ( ( listrel1p @ A )
      = ( ^ [R3: A > A > $o,Xs2: list @ A,Ys2: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys2 ) @ ( listrel1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R3 ) ) ) ) ) ) ).

% listrel1p_def
thf(fact_4905_slice__prepend,axiom,
    ! [A: $tType,I3: nat,K: nat,Xs: list @ A,Ys: list @ A] :
      ( ( ord_less_eq @ nat @ I3 @ K )
     => ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( slice @ A @ I3 @ K @ Xs )
          = ( slice @ A @ ( plus_plus @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( plus_plus @ nat @ K @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( append @ A @ Ys @ Xs ) ) ) ) ) ).

% slice_prepend
thf(fact_4906_lexn_Osimps_I2_J,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( lexn @ A @ R5 @ ( suc @ N ) )
      = ( inf_inf @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image2 @ ( product_prod @ ( product_prod @ A @ ( list @ A ) ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_map_prod @ ( product_prod @ A @ ( list @ A ) ) @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( list @ A ) @ ( product_case_prod @ A @ ( list @ A ) @ ( list @ A ) @ ( cons @ A ) ) @ ( product_case_prod @ A @ ( list @ A ) @ ( list @ A ) @ ( cons @ A ) ) ) @ ( lex_prod @ A @ ( list @ A ) @ R5 @ ( lexn @ A @ R5 @ N ) ) )
        @ ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
          @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
            @ ^ [Xs2: list @ A,Ys2: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs2 )
                  = ( suc @ N ) )
                & ( ( size_size @ ( list @ A ) @ Ys2 )
                  = ( suc @ N ) ) ) ) ) ) ) ).

% lexn.simps(2)
thf(fact_4907_map__prod__ident,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_map_prod @ A @ A @ B @ B
        @ ^ [X2: A] : X2
        @ ^ [Y2: B] : Y2 )
      = ( ^ [Z3: product_prod @ A @ B] : Z3 ) ) ).

% map_prod_ident
thf(fact_4908_case__prod__map__prod,axiom,
    ! [C: $tType,A: $tType,B: $tType,E: $tType,D: $tType,H2: B > C > A,F2: D > B,G: E > C,X3: product_prod @ D @ E] :
      ( ( product_case_prod @ B @ C @ A @ H2 @ ( product_map_prod @ D @ B @ E @ C @ F2 @ G @ X3 ) )
      = ( product_case_prod @ D @ E @ A
        @ ^ [L2: D,R3: E] : ( H2 @ ( F2 @ L2 ) @ ( G @ R3 ) )
        @ X3 ) ) ).

% case_prod_map_prod
thf(fact_4909_prod_Omap__ident,axiom,
    ! [B: $tType,A: $tType,T3: product_prod @ A @ B] :
      ( ( product_map_prod @ A @ A @ B @ B
        @ ^ [X2: A] : X2
        @ ^ [X2: B] : X2
        @ T3 )
      = T3 ) ).

% prod.map_ident
thf(fact_4910_map__prod_Oidentity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_map_prod @ A @ A @ B @ B
        @ ^ [X2: A] : X2
        @ ^ [X2: B] : X2 )
      = ( id @ ( product_prod @ A @ B ) ) ) ).

% map_prod.identity
thf(fact_4911_map__prod__def,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType] :
      ( ( product_map_prod @ A @ C @ B @ D )
      = ( ^ [F3: A > C,G2: B > D] :
            ( product_case_prod @ A @ B @ ( product_prod @ C @ D )
            @ ^ [X2: A,Y2: B] : ( product_Pair @ C @ D @ ( F3 @ X2 ) @ ( G2 @ Y2 ) ) ) ) ) ).

% map_prod_def
thf(fact_4912_case__prod__o__map__prod,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType,A: $tType,F2: D > E > C,G1: A > D,G22: B > E] :
      ( ( comp @ ( product_prod @ D @ E ) @ C @ ( product_prod @ A @ B ) @ ( product_case_prod @ D @ E @ C @ F2 ) @ ( product_map_prod @ A @ D @ B @ E @ G1 @ G22 ) )
      = ( product_case_prod @ A @ B @ C
        @ ^ [L2: A,R3: B] : ( F2 @ ( G1 @ L2 ) @ ( G22 @ R3 ) ) ) ) ).

% case_prod_o_map_prod
thf(fact_4913_map__prod__surj__on,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F2: B > A,A3: set @ B,A11: set @ A,G: D > C,B2: set @ D,B19: set @ C] :
      ( ( ( image2 @ B @ A @ F2 @ A3 )
        = A11 )
     => ( ( ( image2 @ D @ C @ G @ B2 )
          = B19 )
       => ( ( image2 @ ( product_prod @ B @ D ) @ ( product_prod @ A @ C ) @ ( product_map_prod @ B @ A @ D @ C @ F2 @ G )
            @ ( product_Sigma @ B @ D @ A3
              @ ^ [Uu: B] : B2 ) )
          = ( product_Sigma @ A @ C @ A11
            @ ^ [Uu: A] : B19 ) ) ) ) ).

% map_prod_surj_on
thf(fact_4914_map__prod__inj__on,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,F2: A > B,A3: set @ A,G: C > D,B2: set @ C] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( inj_on @ C @ D @ G @ B2 )
       => ( inj_on @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ ( product_map_prod @ A @ B @ C @ D @ F2 @ G )
          @ ( product_Sigma @ A @ C @ A3
            @ ^ [Uu: A] : B2 ) ) ) ) ).

% map_prod_inj_on
thf(fact_4915_sort__mergesort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_sort_key @ A @ A
          @ ^ [X2: A] : X2 )
        = ( mergesort @ A ) ) ) ).

% sort_mergesort
thf(fact_4916_listrel__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrel @ A @ B )
      = ( ^ [R3: set @ ( product_prod @ A @ B )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ B ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ B ) @ $o
              @ ( listrelp @ A @ B
                @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R3 ) ) ) ) ) ) ).

% listrel_def
thf(fact_4917_size__list__conv__sum__list,axiom,
    ! [B: $tType] :
      ( ( size_list @ B )
      = ( ^ [F3: B > nat,Xs2: list @ B] : ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ B @ nat @ F3 @ Xs2 ) ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ).

% size_list_conv_sum_list
thf(fact_4918_listrelp__listrel__eq,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ B )] :
      ( ( listrelp @ A @ B
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R5 ) )
      = ( ^ [X2: list @ A,Y2: list @ B] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ X2 @ Y2 ) @ ( listrel @ A @ B @ R5 ) ) ) ) ).

% listrelp_listrel_eq
thf(fact_4919_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X3: A > nat,X212: A,X223: list @ A] :
      ( ( size_list @ A @ X3 @ ( cons @ A @ X212 @ X223 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X3 @ X212 ) @ ( size_list @ A @ X3 @ X223 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_4920_map__snd__mk__snd,axiom,
    ! [B: $tType,A: $tType,K: A,L: list @ B] :
      ( ( map @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A )
        @ ( map @ B @ ( product_prod @ B @ A )
          @ ^ [X2: B] : ( product_Pair @ B @ A @ X2 @ K )
          @ L ) )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ L ) @ K ) ) ).

% map_snd_mk_snd
thf(fact_4921_map__fst__mk__fst,axiom,
    ! [B: $tType,A: $tType,K: A,L: list @ B] :
      ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K ) @ L ) )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ L ) @ K ) ) ).

% map_fst_mk_fst
thf(fact_4922_lists__empty,axiom,
    ! [A: $tType] :
      ( ( lists @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% lists_empty
thf(fact_4923_lists__Int__eq,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ( lists @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
      = ( inf_inf @ ( set @ ( list @ A ) ) @ ( lists @ A @ A3 ) @ ( lists @ A @ B2 ) ) ) ).

% lists_Int_eq
thf(fact_4924_set__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N @ X3 ) )
        = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_4925_lists__IntI,axiom,
    ! [A: $tType,L: list @ A,A3: set @ A,B2: set @ A] :
      ( ( member @ ( list @ A ) @ L @ ( lists @ A @ A3 ) )
     => ( ( member @ ( list @ A ) @ L @ ( lists @ A @ B2 ) )
       => ( member @ ( list @ A ) @ L @ ( lists @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ) ).

% lists_IntI
thf(fact_4926_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list @ B] :
      ( ( map @ B @ A
        @ ^ [X2: B] : K
        @ Lst )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ Lst ) @ K ) ) ).

% map_replicate_const
thf(fact_4927_replicate__length__filter,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( replicate @ A
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
              @ X3 )
            @ Xs ) )
        @ X3 )
      = ( filter2 @ A
        @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
          @ X3 )
        @ Xs ) ) ).

% replicate_length_filter
thf(fact_4928_lists__eq__set,axiom,
    ! [A: $tType] :
      ( ( lists @ A )
      = ( ^ [A6: set @ A] :
            ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A6 ) ) ) ) ).

% lists_eq_set
thf(fact_4929_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_4930_map__replicate__trivial,axiom,
    ! [A: $tType,X3: A,I3: nat] :
      ( ( map @ nat @ A
        @ ^ [I2: nat] : X3
        @ ( upt @ ( zero_zero @ nat ) @ I3 ) )
      = ( replicate @ A @ I3 @ X3 ) ) ).

% map_replicate_trivial
thf(fact_4931_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X3 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X3 ) )
          = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_4932_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N ) @ X3 ) )
      = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_4933_listrel__subset,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5
        @ ( product_Sigma @ A @ A @ A3
          @ ^ [Uu: A] : A3 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel @ A @ A @ R5 )
        @ ( product_Sigma @ ( list @ A ) @ ( list @ A ) @ ( lists @ A @ A3 )
          @ ^ [Uu: list @ A] : ( lists @ A @ A3 ) ) ) ) ).

% listrel_subset
thf(fact_4934_lists__of__len__fin2,axiom,
    ! [A: $tType,P: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ P )
     => ( finite_finite2 @ ( list @ A )
        @ ( inf_inf @ ( set @ ( list @ A ) ) @ ( lists @ A @ P )
          @ ( collect @ ( list @ A )
            @ ^ [L2: list @ A] :
                ( N
                = ( size_size @ ( list @ A ) @ L2 ) ) ) ) ) ) ).

% lists_of_len_fin2
thf(fact_4935_lists__of__len__fin1,axiom,
    ! [A: $tType,P: set @ A,N: nat] :
      ( ( finite_finite2 @ A @ P )
     => ( finite_finite2 @ ( list @ A )
        @ ( inf_inf @ ( set @ ( list @ A ) ) @ ( lists @ A @ P )
          @ ( collect @ ( list @ A )
            @ ^ [L2: list @ A] :
                ( ( size_size @ ( list @ A ) @ L2 )
                = N ) ) ) ) ) ).

% lists_of_len_fin1
thf(fact_4936_map__zip2,axiom,
    ! [A: $tType,B: $tType,K: A,L: list @ B] :
      ( ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K ) @ L )
      = ( zip @ A @ B @ ( replicate @ A @ ( size_size @ ( list @ B ) @ L ) @ K ) @ L ) ) ).

% map_zip2
thf(fact_4937_map__zip1,axiom,
    ! [A: $tType,B: $tType,K: B,L: list @ A] :
      ( ( map @ A @ ( product_prod @ A @ B )
        @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ K )
        @ L )
      = ( zip @ A @ B @ L @ ( replicate @ B @ ( size_size @ ( list @ A ) @ L ) @ K ) ) ) ).

% map_zip1
thf(fact_4938_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M2: nat,A4: A] :
      ( ( enumerate @ A @ N @ ( replicate @ A @ M2 @ A4 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q8: nat] : ( product_Pair @ nat @ A @ Q8 @ A4 )
        @ ( upt @ N @ ( plus_plus @ nat @ N @ M2 ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_4939_prod_Oset__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,Xs: list @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set2 @ B @ Xs ) )
          = ( groups5270119922927024881d_list @ A @ ( map @ B @ A @ G @ ( remdups @ B @ Xs ) ) ) ) ) ).

% prod.set_conv_list
thf(fact_4940_INF__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
          = ( fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( inf_inf @ A ) @ F2 ) @ Xs @ ( top_top @ A ) ) ) ) ).

% INF_set_fold
thf(fact_4941_prod__list_Orev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Xs: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( rev @ A @ Xs ) )
          = ( groups5270119922927024881d_list @ A @ Xs ) ) ) ).

% prod_list.rev
thf(fact_4942_prod__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( cons @ A @ X3 @ Xs ) )
          = ( times_times @ A @ X3 @ ( groups5270119922927024881d_list @ A @ Xs ) ) ) ) ).

% prod_list.Cons
thf(fact_4943_prod__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A @ ( nil @ A ) )
        = ( one_one @ A ) ) ) ).

% prod_list.Nil
thf(fact_4944_prod__list_Oappend,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( append @ A @ Xs @ Ys ) )
          = ( times_times @ A @ ( groups5270119922927024881d_list @ A @ Xs ) @ ( groups5270119922927024881d_list @ A @ Ys ) ) ) ) ).

% prod_list.append
thf(fact_4945_foldl__conv__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( foldl @ A @ B )
      = ( ^ [F3: A > B > A,S: A,Xs2: list @ B] :
            ( fold @ B @ A
            @ ^ [X2: B,T5: A] : ( F3 @ T5 @ X2 )
            @ Xs2
            @ S ) ) ) ).

% foldl_conv_fold
thf(fact_4946_fold__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,P: B > $o,Xs: list @ B] :
      ( ( fold @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( fold @ B @ A
        @ ^ [X2: B] : ( if @ ( A > A ) @ ( P @ X2 ) @ ( F2 @ X2 ) @ ( id @ A ) )
        @ Xs ) ) ).

% fold_filter
thf(fact_4947_prod__list__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( semiring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [Xs: list @ A] :
          ( ( ( groups5270119922927024881d_list @ A @ Xs )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( zero_zero @ A ) @ ( set2 @ A @ Xs ) ) ) ) ).

% prod_list_zero_iff
thf(fact_4948_fold__plus__sum__list__rev,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ A] :
          ( ( fold @ A @ A @ ( plus_plus @ A ) @ Xs )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( rev @ A @ Xs ) ) ) ) ) ).

% fold_plus_sum_list_rev
thf(fact_4949_sort__conv__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( linorder_sort_key @ A @ A
            @ ^ [X2: A] : X2
            @ Xs )
          = ( fold @ A @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2 )
            @ Xs
            @ ( nil @ A ) ) ) ) ).

% sort_conv_fold
thf(fact_4950_Sup__set__fold,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Xs: list @ A] :
          ( ( complete_Sup_Sup @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( sup_sup @ A ) @ Xs @ ( bot_bot @ A ) ) ) ) ).

% Sup_set_fold
thf(fact_4951_Inf__set__fold,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Xs: list @ A] :
          ( ( complete_Inf_Inf @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( inf_inf @ A ) @ Xs @ ( top_top @ A ) ) ) ) ).

% Inf_set_fold
thf(fact_4952_Inf__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( set2 @ A @ ( cons @ A @ X3 @ Xs ) ) )
          = ( fold @ A @ A @ ( inf_inf @ A ) @ Xs @ X3 ) ) ) ).

% Inf_fin.set_eq_fold
thf(fact_4953_prod__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A )
        = ( ^ [Xs2: list @ A] : ( foldr @ A @ A @ ( times_times @ A ) @ Xs2 @ ( one_one @ A ) ) ) ) ) ).

% prod_list.eq_foldr
thf(fact_4954_enumerate__map__upt,axiom,
    ! [A: $tType,N: nat,F2: nat > A,M2: nat] :
      ( ( enumerate @ A @ N @ ( map @ nat @ A @ F2 @ ( upt @ N @ M2 ) ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [K6: nat] : ( product_Pair @ nat @ A @ K6 @ ( F2 @ K6 ) )
        @ ( upt @ N @ M2 ) ) ) ).

% enumerate_map_upt
thf(fact_4955_prod_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Xs: list @ B,G: B > A] :
          ( ( distinct @ B @ Xs )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set2 @ B @ Xs ) )
            = ( groups5270119922927024881d_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% prod.distinct_set_conv_list
thf(fact_4956_SUP__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
          = ( fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( sup_sup @ A ) @ F2 ) @ Xs @ ( bot_bot @ A ) ) ) ) ).

% SUP_set_fold
thf(fact_4957_list_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [R2: A > B > $o,A5: list @ A,B4: list @ B] :
          ? [Z3: list @ ( product_prod @ A @ B )] :
            ( ( member @ ( list @ ( product_prod @ A @ B ) ) @ Z3
              @ ( collect @ ( list @ ( product_prod @ A @ B ) )
                @ ^ [X2: list @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set2 @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) ) )
            & ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z3 )
              = A5 )
            & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z3 )
              = B4 ) ) ) ) ).

% list.in_rel
thf(fact_4958_properties__for__sort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Ys: list @ B,Xs: list @ B,F2: B > A] :
          ( ( ( mset @ B @ Ys )
            = ( mset @ B @ Xs ) )
         => ( ! [K2: B] :
                ( ( member @ B @ K2 @ ( set2 @ B @ Ys ) )
               => ( ( filter2 @ B
                    @ ^ [X2: B] :
                        ( ( F2 @ K2 )
                        = ( F2 @ X2 ) )
                    @ Ys )
                  = ( filter2 @ B
                    @ ^ [X2: B] :
                        ( ( F2 @ K2 )
                        = ( F2 @ X2 ) )
                    @ Xs ) ) )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Ys ) )
             => ( ( linorder_sort_key @ B @ A @ F2 @ Xs )
                = Ys ) ) ) ) ) ).

% properties_for_sort_key
thf(fact_4959_set__drop__conv,axiom,
    ! [A: $tType,N: nat,L: list @ A] :
      ( ( set2 @ A @ ( drop @ A @ N @ L ) )
      = ( collect @ A
        @ ^ [Uu: A] :
          ? [I2: nat] :
            ( ( Uu
              = ( nth @ A @ L @ I2 ) )
            & ( ord_less_eq @ nat @ N @ I2 )
            & ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ L ) ) ) ) ) ).

% set_drop_conv
thf(fact_4960_Multiset_Omset__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( mset @ A
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X3
              @ Xs ) )
          = ( add_mset @ A @ X3 @ ( mset @ A @ Xs ) ) ) ) ).

% Multiset.mset_insort
thf(fact_4961_sorted__list__of__multiset__mset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( linord6283353356039996273ltiset @ A @ ( mset @ A @ Xs ) )
          = ( linorder_sort_key @ A @ A
            @ ^ [X2: A] : X2
            @ Xs ) ) ) ).

% sorted_list_of_multiset_mset
thf(fact_4962_list_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: A > C > $o,X3: list @ A,G: B > C,Y: list @ B] :
      ( ( list_all2 @ A @ C @ Sa @ X3 @ ( map @ B @ C @ G @ Y ) )
      = ( list_all2 @ A @ B
        @ ^ [X2: A,Y2: B] : ( Sa @ X2 @ ( G @ Y2 ) )
        @ X3
        @ Y ) ) ).

% list.rel_map(2)
thf(fact_4963_list_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: C > B > $o,I3: A > C,X3: list @ A,Y: list @ B] :
      ( ( list_all2 @ C @ B @ Sb @ ( map @ A @ C @ I3 @ X3 ) @ Y )
      = ( list_all2 @ A @ B
        @ ^ [X2: A] : ( Sb @ ( I3 @ X2 ) )
        @ X3
        @ Y ) ) ).

% list.rel_map(1)
thf(fact_4964_list__all2__map1,axiom,
    ! [C: $tType,A: $tType,B: $tType,P: A > B > $o,F2: C > A,As2: list @ C,Bs: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( map @ C @ A @ F2 @ As2 ) @ Bs )
      = ( list_all2 @ C @ B
        @ ^ [X2: C] : ( P @ ( F2 @ X2 ) )
        @ As2
        @ Bs ) ) ).

% list_all2_map1
thf(fact_4965_list__all2__map2,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: A > B > $o,As2: list @ A,F2: C > B,Bs: list @ C] :
      ( ( list_all2 @ A @ B @ P @ As2 @ ( map @ C @ B @ F2 @ Bs ) )
      = ( list_all2 @ A @ C
        @ ^ [X2: A,Y2: C] : ( P @ X2 @ ( F2 @ Y2 ) )
        @ As2
        @ Bs ) ) ).

% list_all2_map2
thf(fact_4966_list_Odisc__transfer_I1_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ R )
      @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
      @ ^ [List2: list @ A] :
          ( List2
          = ( nil @ A ) )
      @ ^ [List2: list @ B] :
          ( List2
          = ( nil @ B ) ) ) ).

% list.disc_transfer(1)
thf(fact_4967_list_Odisc__transfer_I2_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ R )
      @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
      @ ^ [List2: list @ A] :
          ( List2
         != ( nil @ A ) )
      @ ^ [List2: list @ B] :
          ( List2
         != ( nil @ B ) ) ) ).

% list.disc_transfer(2)
thf(fact_4968_mset__eq__finite,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( finite_finite2 @ ( list @ A )
      @ ( collect @ ( list @ A )
        @ ^ [Ys2: list @ A] :
            ( ( mset @ A @ Ys2 )
            = ( mset @ A @ Xs ) ) ) ) ).

% mset_eq_finite
thf(fact_4969_mset__eq__length__filter,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Z2: A] :
      ( ( ( mset @ A @ Xs )
        = ( mset @ A @ Ys ) )
     => ( ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
              @ Z2 )
            @ Xs ) )
        = ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
              @ Z2 )
            @ Ys ) ) ) ) ).

% mset_eq_length_filter
thf(fact_4970_drop__eq__nths,axiom,
    ! [A: $tType] :
      ( ( drop @ A )
      = ( ^ [N5: nat,Xs2: list @ A] : ( nths @ A @ Xs2 @ ( collect @ nat @ ( ord_less_eq @ nat @ N5 ) ) ) ) ) ).

% drop_eq_nths
thf(fact_4971_drop__Cons,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list @ A] :
      ( ( drop @ A @ N @ ( cons @ A @ X3 @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ X3 @ Xs )
        @ ^ [M5: nat] : ( drop @ A @ M5 @ Xs )
        @ N ) ) ).

% drop_Cons
thf(fact_4972_properties__for__sort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Ys: list @ A,Xs: list @ A] :
          ( ( ( mset @ A @ Ys )
            = ( mset @ A @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
           => ( ( linorder_sort_key @ A @ A
                @ ^ [X2: A] : X2
                @ Xs )
              = Ys ) ) ) ) ).

% properties_for_sort
thf(fact_4973_product__lists__set,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss ) )
      = ( collect @ ( list @ A )
        @ ^ [Xs2: list @ A] :
            ( list_all2 @ A @ ( list @ A )
            @ ^ [X2: A,Ys2: list @ A] : ( member @ A @ X2 @ ( set2 @ A @ Ys2 ) )
            @ Xs2
            @ Xss ) ) ) ).

% product_lists_set
thf(fact_4974_sum__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( monoid_add @ A ) )
     => ! [A3: A > B > $o] :
          ( ( A3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A3 @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A3 ) @ A3 @ ( groups8242544230860333062m_list @ A ) @ ( groups8242544230860333062m_list @ B ) ) ) ) ) ).

% sum_list_transfer
thf(fact_4975_prod__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_mult @ B )
        & ( monoid_mult @ A ) )
     => ! [A3: A > B > $o] :
          ( ( A3 @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A3 @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A3 ) @ A3 @ ( groups5270119922927024881d_list @ A ) @ ( groups5270119922927024881d_list @ B ) ) ) ) ) ).

% prod_list_transfer
thf(fact_4976_list__all2__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [P3: A > B > $o,Xs2: list @ A,Ys2: list @ B] :
            ( ( ( size_size @ ( list @ A ) @ Xs2 )
              = ( size_size @ ( list @ B ) @ Ys2 ) )
            & ! [X2: product_prod @ A @ B] :
                ( ( member @ ( product_prod @ A @ B ) @ X2 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys2 ) ) )
               => ( product_case_prod @ A @ B @ $o @ P3 @ X2 ) ) ) ) ) ).

% list_all2_iff
thf(fact_4977_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( ( comm_semiring_0 @ B )
        & ( comm_semiring_0 @ A ) )
     => ! [A3: A > B > $o,B2: C > D > $o] :
          ( ( A3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A3 @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A3 @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) @ ( times_times @ A ) @ ( times_times @ B ) )
             => ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( A > ( list @ C ) > A ) @ ( B > ( list @ D ) > B ) @ ( bNF_rel_fun @ C @ D @ A @ B @ B2 @ A3 ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ C ) > A ) @ ( ( list @ D ) > B ) @ A3 @ ( bNF_rel_fun @ ( list @ C ) @ ( list @ D ) @ A @ B @ ( list_all2 @ C @ D @ B2 ) @ A3 ) ) @ ( groups4207007520872428315er_sum @ C @ A ) @ ( groups4207007520872428315er_sum @ D @ B ) ) ) ) ) ) ).

% horner_sum_transfer
thf(fact_4978_image__mset__map__of,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B )] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
     => ( ( image_mset @ A @ B
          @ ^ [I2: A] : ( the2 @ B @ ( map_of @ A @ B @ Xs @ I2 ) )
          @ ( mset @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) ) )
        = ( mset @ B @ ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Xs ) ) ) ) ).

% image_mset_map_of
thf(fact_4979_stable__sort__key__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord3483353639454293061rt_key @ B @ A )
        = ( ^ [Sk: ( B > A ) > ( list @ B ) > ( list @ B )] :
            ! [F3: B > A,Xs2: list @ B,K6: A] :
              ( ( filter2 @ B
                @ ^ [Y2: B] :
                    ( ( F3 @ Y2 )
                    = K6 )
                @ ( Sk @ F3 @ Xs2 ) )
              = ( filter2 @ B
                @ ^ [Y2: B] :
                    ( ( F3 @ Y2 )
                    = K6 )
                @ Xs2 ) ) ) ) ) ).

% stable_sort_key_def
thf(fact_4980_map__rec,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map @ B @ A )
      = ( ^ [F3: B > A] :
            ( rec_list @ ( list @ A ) @ B @ ( nil @ A )
            @ ^ [X2: B,Uu: list @ B] : ( cons @ A @ ( F3 @ X2 ) ) ) ) ) ).

% map_rec
thf(fact_4981_image__mset_Oidentity,axiom,
    ! [A: $tType] :
      ( ( image_mset @ A @ A
        @ ^ [X2: A] : X2 )
      = ( id @ ( multiset @ A ) ) ) ).

% image_mset.identity
thf(fact_4982_multiset_Omap__ident,axiom,
    ! [A: $tType,T3: multiset @ A] :
      ( ( image_mset @ A @ A
        @ ^ [X2: A] : X2
        @ T3 )
      = T3 ) ).

% multiset.map_ident
thf(fact_4983_image__mset__cong,axiom,
    ! [B: $tType,A: $tType,M: multiset @ A,F2: A > B,G: A > B] :
      ( ! [X: A] :
          ( ( member @ A @ X @ ( set_mset @ A @ M ) )
         => ( ( F2 @ X )
            = ( G @ X ) ) )
     => ( ( image_mset @ A @ B @ F2 @ M )
        = ( image_mset @ A @ B @ G @ M ) ) ) ).

% image_mset_cong
thf(fact_4984_image__mset__cong__pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,M: multiset @ ( product_prod @ A @ B ),F2: A > B > C,G: A > B > C] :
      ( ! [X: A,Y3: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y3 ) @ ( set_mset @ ( product_prod @ A @ B ) @ M ) )
         => ( ( F2 @ X @ Y3 )
            = ( G @ X @ Y3 ) ) )
     => ( ( image_mset @ ( product_prod @ A @ B ) @ C @ ( product_case_prod @ A @ B @ C @ F2 ) @ M )
        = ( image_mset @ ( product_prod @ A @ B ) @ C @ ( product_case_prod @ A @ B @ C @ G ) @ M ) ) ) ).

% image_mset_cong_pair
thf(fact_4985_in__image__mset,axiom,
    ! [A: $tType,B: $tType,Y: A,F2: B > A,M: multiset @ B] :
      ( ( member @ A @ Y @ ( set_mset @ A @ ( image_mset @ B @ A @ F2 @ M ) ) )
      = ( member @ A @ Y @ ( image2 @ B @ A @ F2 @ ( set_mset @ B @ M ) ) ) ) ).

% in_image_mset
thf(fact_4986_rec__list__Cons__imp,axiom,
    ! [B: $tType,A: $tType,F2: ( list @ A ) > B,F1: B,F22: A > ( list @ A ) > B > B,X3: A,Xs: list @ A] :
      ( ( F2
        = ( rec_list @ B @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( cons @ A @ X3 @ Xs ) )
        = ( F22 @ X3 @ Xs @ ( F2 @ Xs ) ) ) ) ).

% rec_list_Cons_imp
thf(fact_4987_rec__list__Nil__imp,axiom,
    ! [A: $tType,B: $tType,F2: ( list @ A ) > B,F1: B,F22: A > ( list @ A ) > B > B] :
      ( ( F2
        = ( rec_list @ B @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( nil @ A ) )
        = F1 ) ) ).

% rec_list_Nil_imp
thf(fact_4988_list_Orec__o__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: C,Ga: B > ( list @ B ) > C > C,F2: A > B] :
      ( ( comp @ ( list @ B ) @ C @ ( list @ A ) @ ( rec_list @ C @ B @ G @ Ga ) @ ( map @ A @ B @ F2 ) )
      = ( rec_list @ C @ A @ G
        @ ^ [X2: A,Xa4: list @ A] : ( Ga @ ( F2 @ X2 ) @ ( map @ A @ B @ F2 @ Xa4 ) ) ) ) ).

% list.rec_o_map
thf(fact_4989_count__image__mset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: multiset @ B,X3: A] :
      ( ( count @ A @ ( image_mset @ B @ A @ F2 @ A3 ) @ X3 )
      = ( groups7311177749621191930dd_sum @ B @ nat @ ( count @ B @ A3 ) @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( set_mset @ B @ A3 ) ) ) ) ).

% count_image_mset
thf(fact_4990_set__rec,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( rec_list @ ( set @ A ) @ A @ ( bot_bot @ ( set @ A ) )
        @ ^ [X2: A,Uu: list @ A] : ( insert @ A @ X2 ) ) ) ).

% set_rec
thf(fact_4991_prod_Oin__rel,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType] :
      ( ( basic_rel_prod @ A @ C @ B @ D )
      = ( ^ [R14: A > C > $o,R25: B > D > $o,A5: product_prod @ A @ B,B4: product_prod @ C @ D] :
          ? [Z3: product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D )] :
            ( ( member @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) ) @ Z3
              @ ( collect @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) )
                @ ^ [X2: product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D )] :
                    ( ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( basic_fsts @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ X2 ) @ ( collect @ ( product_prod @ A @ C ) @ ( product_case_prod @ A @ C @ $o @ R14 ) ) )
                    & ( ord_less_eq @ ( set @ ( product_prod @ B @ D ) ) @ ( basic_snds @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ X2 ) @ ( collect @ ( product_prod @ B @ D ) @ ( product_case_prod @ B @ D @ $o @ R25 ) ) ) ) ) )
            & ( ( product_map_prod @ ( product_prod @ A @ C ) @ A @ ( product_prod @ B @ D ) @ B @ ( product_fst @ A @ C ) @ ( product_fst @ B @ D ) @ Z3 )
              = A5 )
            & ( ( product_map_prod @ ( product_prod @ A @ C ) @ C @ ( product_prod @ B @ D ) @ D @ ( product_snd @ A @ C ) @ ( product_snd @ B @ D ) @ Z3 )
              = B4 ) ) ) ) ).

% prod.in_rel
thf(fact_4992_prod_Orel__map_I1_J,axiom,
    ! [A: $tType,B: $tType,E: $tType,F10: $tType,D: $tType,C: $tType,S1b: E > C > $o,S2b: F10 > D > $o,I1: A > E,I22: B > F10,X3: product_prod @ A @ B,Y: product_prod @ C @ D] :
      ( ( basic_rel_prod @ E @ C @ F10 @ D @ S1b @ S2b @ ( product_map_prod @ A @ E @ B @ F10 @ I1 @ I22 @ X3 ) @ Y )
      = ( basic_rel_prod @ A @ C @ B @ D
        @ ^ [X2: A] : ( S1b @ ( I1 @ X2 ) )
        @ ^ [X2: B] : ( S2b @ ( I22 @ X2 ) )
        @ X3
        @ Y ) ) ).

% prod.rel_map(1)
thf(fact_4993_prod_Orel__map_I2_J,axiom,
    ! [A: $tType,B: $tType,E: $tType,F10: $tType,D: $tType,C: $tType,S1a: A > E > $o,S2a: B > F10 > $o,X3: product_prod @ A @ B,G1: C > E,G22: D > F10,Y: product_prod @ C @ D] :
      ( ( basic_rel_prod @ A @ E @ B @ F10 @ S1a @ S2a @ X3 @ ( product_map_prod @ C @ E @ D @ F10 @ G1 @ G22 @ Y ) )
      = ( basic_rel_prod @ A @ C @ B @ D
        @ ^ [X2: A,Y2: C] : ( S1a @ X2 @ ( G1 @ Y2 ) )
        @ ^ [X2: B,Y2: D] : ( S2a @ X2 @ ( G22 @ Y2 ) )
        @ X3
        @ Y ) ) ).

% prod.rel_map(2)
thf(fact_4994_rel__prod__conv,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType] :
      ( ( basic_rel_prod @ A @ C @ B @ D )
      = ( ^ [R14: A > C > $o,R25: B > D > $o] :
            ( product_case_prod @ A @ B @ ( ( product_prod @ C @ D ) > $o )
            @ ^ [A5: A,B4: B] :
                ( product_case_prod @ C @ D @ $o
                @ ^ [C5: C,D4: D] :
                    ( ( R14 @ A5 @ C5 )
                    & ( R25 @ B4 @ D4 ) ) ) ) ) ) ).

% rel_prod_conv
thf(fact_4995_int_Oid__abs__transfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int
    @ ( basic_rel_prod @ nat @ nat @ nat @ nat
      @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 )
      @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 ) )
    @ pcr_int
    @ ^ [X2: product_prod @ nat @ nat] : X2
    @ abs_Integ ) ).

% int.id_abs_transfer
thf(fact_4996_count__sum,axiom,
    ! [A: $tType,B: $tType,F2: B > ( multiset @ A ),A3: set @ B,X3: A] :
      ( ( count @ A @ ( groups7311177749621191930dd_sum @ B @ ( multiset @ A ) @ F2 @ A3 ) @ X3 )
      = ( groups7311177749621191930dd_sum @ B @ nat
        @ ^ [A5: B] : ( count @ A @ ( F2 @ A5 ) @ X3 )
        @ A3 ) ) ).

% count_sum
thf(fact_4997_set__mset__def,axiom,
    ! [A: $tType] :
      ( ( set_mset @ A )
      = ( ^ [M8: multiset @ A] :
            ( collect @ A
            @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( count @ A @ M8 @ X2 ) ) ) ) ) ).

% set_mset_def
thf(fact_4998_set__mset__diff,axiom,
    ! [A: $tType,M: multiset @ A,N4: multiset @ A] :
      ( ( set_mset @ A @ ( minus_minus @ ( multiset @ A ) @ M @ N4 ) )
      = ( collect @ A
        @ ^ [A5: A] : ( ord_less @ nat @ ( count @ A @ N4 @ A5 ) @ ( count @ A @ M @ A5 ) ) ) ) ).

% set_mset_diff
thf(fact_4999_count__mset,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( count @ A @ ( mset @ A @ Xs ) @ X3 )
      = ( size_size @ ( list @ A )
        @ ( filter2 @ A
          @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
            @ X3 )
          @ Xs ) ) ) ).

% count_mset
thf(fact_5000_count__image__mset_H,axiom,
    ! [A: $tType,B: $tType,F2: B > A,X5: multiset @ B,Y: A] :
      ( ( count @ A @ ( image_mset @ B @ A @ F2 @ X5 ) @ Y )
      = ( groups7311177749621191930dd_sum @ B @ nat @ ( count @ B @ X5 )
        @ ( collect @ B
          @ ^ [X2: B] :
              ( ( member @ B @ X2 @ ( set_mset @ B @ X5 ) )
              & ( Y
                = ( F2 @ X2 ) ) ) ) ) ) ).

% count_image_mset'
thf(fact_5001_count__induct,axiom,
    ! [A: $tType,Y: A > nat,P: ( A > nat ) > $o] :
      ( ( member @ ( A > nat ) @ Y
        @ ( collect @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
     => ( ! [X: multiset @ A] : ( P @ ( count @ A @ X ) )
       => ( P @ Y ) ) ) ).

% count_induct
thf(fact_5002_count__cases,axiom,
    ! [A: $tType,Y: A > nat] :
      ( ( member @ ( A > nat ) @ Y
        @ ( collect @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
     => ~ ! [X: multiset @ A] :
            ( Y
           != ( count @ A @ X ) ) ) ).

% count_cases
thf(fact_5003_count,axiom,
    ! [A: $tType,X3: multiset @ A] :
      ( member @ ( A > nat ) @ ( count @ A @ X3 )
      @ ( collect @ ( A > nat )
        @ ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) ) ).

% count
thf(fact_5004_Inf__multiset_Orep__eq,axiom,
    ! [A: $tType,X3: set @ ( multiset @ A )] :
      ( ( count @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ X3 ) )
      = ( ^ [I2: A] :
            ( if @ nat
            @ ( ( image2 @ ( multiset @ A ) @ ( A > nat ) @ ( count @ A ) @ X3 )
              = ( bot_bot @ ( set @ ( A > nat ) ) ) )
            @ ( zero_zero @ nat )
            @ ( complete_Inf_Inf @ nat
              @ ( image2 @ ( A > nat ) @ nat
                @ ^ [F3: A > nat] : ( F3 @ I2 )
                @ ( image2 @ ( multiset @ A ) @ ( A > nat ) @ ( count @ A ) @ X3 ) ) ) ) ) ) ).

% Inf_multiset.rep_eq
thf(fact_5005_count__Inf__multiset__nonempty,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: A] :
      ( ( A3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( count @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A3 ) @ X3 )
        = ( complete_Inf_Inf @ nat
          @ ( image2 @ ( multiset @ A ) @ nat
            @ ^ [X7: multiset @ A] : ( count @ A @ X7 @ X3 )
            @ A3 ) ) ) ) ).

% count_Inf_multiset_nonempty
thf(fact_5006_size__multiset__eq,axiom,
    ! [A: $tType] :
      ( ( size_multiset @ A )
      = ( ^ [F3: A > nat,M8: multiset @ A] :
            ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X2: A] : ( times_times @ nat @ ( count @ A @ M8 @ X2 ) @ ( suc @ ( F3 @ X2 ) ) )
            @ ( set_mset @ A @ M8 ) ) ) ) ).

% size_multiset_eq
thf(fact_5007_multiset_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_mset @ A @ B )
      = ( ^ [R2: A > B > $o,A5: multiset @ A,B4: multiset @ B] :
          ? [Z3: multiset @ ( product_prod @ A @ B )] :
            ( ( member @ ( multiset @ ( product_prod @ A @ B ) ) @ Z3
              @ ( collect @ ( multiset @ ( product_prod @ A @ B ) )
                @ ^ [X2: multiset @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_mset @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) ) )
            & ( ( image_mset @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z3 )
              = A5 )
            & ( ( image_mset @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z3 )
              = B4 ) ) ) ) ).

% multiset.in_rel
thf(fact_5008_fold__mset__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( fold_mset @ A @ B )
      = ( ^ [F3: A > B > B,S: B,M8: multiset @ A] :
            ( finite_fold @ A @ B
            @ ^ [X2: A] : ( compow @ ( B > B ) @ ( count @ A @ M8 @ X2 ) @ ( F3 @ X2 ) )
            @ S
            @ ( set_mset @ A @ M8 ) ) ) ) ).

% fold_mset_def
thf(fact_5009_multiset_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: A > C > $o,X3: multiset @ A,G: B > C,Y: multiset @ B] :
      ( ( rel_mset @ A @ C @ Sa @ X3 @ ( image_mset @ B @ C @ G @ Y ) )
      = ( rel_mset @ A @ B
        @ ^ [X2: A,Y2: B] : ( Sa @ X2 @ ( G @ Y2 ) )
        @ X3
        @ Y ) ) ).

% multiset.rel_map(2)
thf(fact_5010_multiset_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: C > B > $o,I3: A > C,X3: multiset @ A,Y: multiset @ B] :
      ( ( rel_mset @ C @ B @ Sb @ ( image_mset @ A @ C @ I3 @ X3 ) @ Y )
      = ( rel_mset @ A @ B
        @ ^ [X2: A] : ( Sb @ ( I3 @ X2 ) )
        @ X3
        @ Y ) ) ).

% multiset.rel_map(1)
thf(fact_5011_sorted__list__of__multiset__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord6283353356039996273ltiset @ A )
        = ( fold_mset @ A @ ( list @ A )
          @ ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2 )
          @ ( nil @ A ) ) ) ) ).

% sorted_list_of_multiset_def
thf(fact_5012_Inf__multiset__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( multiset @ A ) )
      = ( map_fun @ ( set @ ( multiset @ A ) ) @ ( set @ ( A > nat ) ) @ ( A > nat ) @ ( multiset @ A ) @ ( image2 @ ( multiset @ A ) @ ( A > nat ) @ ( count @ A ) ) @ ( abs_multiset @ A )
        @ ^ [A6: set @ ( A > nat ),I2: A] :
            ( if @ nat
            @ ( A6
              = ( bot_bot @ ( set @ ( A > nat ) ) ) )
            @ ( zero_zero @ nat )
            @ ( complete_Inf_Inf @ nat
              @ ( image2 @ ( A > nat ) @ nat
                @ ^ [F3: A > nat] : ( F3 @ I2 )
                @ A6 ) ) ) ) ) ).

% Inf_multiset_def
thf(fact_5013_count__Abs__multiset,axiom,
    ! [A: $tType,F2: A > nat] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X2 ) ) ) )
     => ( ( count @ A @ ( abs_multiset @ A @ F2 ) )
        = F2 ) ) ).

% count_Abs_multiset
thf(fact_5014_sum__mset__delta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: B,C2: A,A3: multiset @ B] :
          ( ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( Y = X2 ) @ C2 @ ( zero_zero @ A ) )
              @ A3 ) )
          = ( times_times @ A @ C2 @ ( semiring_1_of_nat @ A @ ( count @ B @ A3 @ Y ) ) ) ) ) ).

% sum_mset_delta'
thf(fact_5015_Union__image__single__mset,axiom,
    ! [A: $tType,M2: multiset @ A] :
      ( ( comm_m7189776963980413722m_mset @ ( multiset @ A )
        @ ( image_mset @ A @ ( multiset @ A )
          @ ^ [X2: A] : ( add_mset @ A @ X2 @ ( zero_zero @ ( multiset @ A ) ) )
          @ M2 ) )
      = M2 ) ).

% Union_image_single_mset
thf(fact_5016_sum__mset_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: multiset @ B] :
          ( ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [Uu: B] : ( zero_zero @ A )
              @ A3 ) )
          = ( zero_zero @ A ) ) ) ).

% sum_mset.neutral_const
thf(fact_5017_set__mset__Union__mset,axiom,
    ! [A: $tType,MM: multiset @ ( multiset @ A )] :
      ( ( set_mset @ A @ ( comm_m7189776963980413722m_mset @ ( multiset @ A ) @ MM ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( multiset @ A ) @ ( set @ A ) @ ( set_mset @ A ) @ ( set_mset @ ( multiset @ A ) @ MM ) ) ) ) ).

% set_mset_Union_mset
thf(fact_5018_sum__mset__replicate__mset,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,A4: A] :
          ( ( comm_m7189776963980413722m_mset @ A @ ( replicate_mset @ A @ N @ A4 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ A4 ) ) ) ).

% sum_mset_replicate_mset
thf(fact_5019_sum__mset_Oswap,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > C > A,B2: multiset @ C,A3: multiset @ B] :
          ( ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [I2: B] : ( comm_m7189776963980413722m_mset @ A @ ( image_mset @ C @ A @ ( G @ I2 ) @ B2 ) )
              @ A3 ) )
          = ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ C @ A
              @ ^ [J3: C] :
                  ( comm_m7189776963980413722m_mset @ A
                  @ ( image_mset @ B @ A
                    @ ^ [I2: B] : ( G @ I2 @ J3 )
                    @ A3 ) )
              @ B2 ) ) ) ) ).

% sum_mset.swap
thf(fact_5020_sum__mset_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,H2: B > A,A3: multiset @ B] :
          ( ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( plus_plus @ A @ ( G @ X2 ) @ ( H2 @ X2 ) )
              @ A3 ) )
          = ( plus_plus @ A @ ( comm_m7189776963980413722m_mset @ A @ ( image_mset @ B @ A @ G @ A3 ) ) @ ( comm_m7189776963980413722m_mset @ A @ ( image_mset @ B @ A @ H2 @ A3 ) ) ) ) ) ).

% sum_mset.distrib
thf(fact_5021_sum__mset__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F2: B > A,M: multiset @ B] :
          ( ( times_times @ A @ C2 @ ( comm_m7189776963980413722m_mset @ A @ ( image_mset @ B @ A @ F2 @ M ) ) )
          = ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ M ) ) ) ) ).

% sum_mset_distrib_left
thf(fact_5022_sum__mset__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,M: multiset @ B,C2: A] :
          ( ( times_times @ A @ ( comm_m7189776963980413722m_mset @ A @ ( image_mset @ B @ A @ F2 @ M ) ) @ C2 )
          = ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
              @ M ) ) ) ) ).

% sum_mset_distrib_right
thf(fact_5023_sum__mset__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( times @ A )
        & ( semiring_0 @ B ) )
     => ! [F2: A > B,A3: multiset @ A,G: C > B,B2: multiset @ C] :
          ( ( times_times @ B @ ( comm_m7189776963980413722m_mset @ B @ ( image_mset @ A @ B @ F2 @ A3 ) ) @ ( comm_m7189776963980413722m_mset @ B @ ( image_mset @ C @ B @ G @ B2 ) ) )
          = ( comm_m7189776963980413722m_mset @ B
            @ ( image_mset @ A @ B
              @ ^ [I2: A] :
                  ( comm_m7189776963980413722m_mset @ B
                  @ ( image_mset @ C @ B
                    @ ^ [J3: C] : ( times_times @ B @ ( F2 @ I2 ) @ ( G @ J3 ) )
                    @ B2 ) )
              @ A3 ) ) ) ) ).

% sum_mset_product
thf(fact_5024_zero__multiset__def,axiom,
    ! [A: $tType] :
      ( ( zero_zero @ ( multiset @ A ) )
      = ( abs_multiset @ A
        @ ^ [A5: A] : ( zero_zero @ nat ) ) ) ).

% zero_multiset_def
thf(fact_5025_Abs__multiset__inject,axiom,
    ! [A: $tType,X3: A > nat,Y: A > nat] :
      ( ( member @ ( A > nat ) @ X3
        @ ( collect @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
     => ( ( member @ ( A > nat ) @ Y
          @ ( collect @ ( A > nat )
            @ ^ [F3: A > nat] :
                ( finite_finite2 @ A
                @ ( collect @ A
                  @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
       => ( ( ( abs_multiset @ A @ X3 )
            = ( abs_multiset @ A @ Y ) )
          = ( X3 = Y ) ) ) ) ).

% Abs_multiset_inject
thf(fact_5026_Abs__multiset__induct,axiom,
    ! [A: $tType,P: ( multiset @ A ) > $o,X3: multiset @ A] :
      ( ! [Y3: A > nat] :
          ( ( member @ ( A > nat ) @ Y3
            @ ( collect @ ( A > nat )
              @ ^ [F3: A > nat] :
                  ( finite_finite2 @ A
                  @ ( collect @ A
                    @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
         => ( P @ ( abs_multiset @ A @ Y3 ) ) )
     => ( P @ X3 ) ) ).

% Abs_multiset_induct
thf(fact_5027_Abs__multiset__cases,axiom,
    ! [A: $tType,X3: multiset @ A] :
      ~ ! [Y3: A > nat] :
          ( ( X3
            = ( abs_multiset @ A @ Y3 ) )
         => ~ ( member @ ( A > nat ) @ Y3
              @ ( collect @ ( A > nat )
                @ ^ [F3: A > nat] :
                    ( finite_finite2 @ A
                    @ ( collect @ A
                      @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) ) ) ).

% Abs_multiset_cases
thf(fact_5028_plus__multiset__def,axiom,
    ! [A: $tType] :
      ( ( plus_plus @ ( multiset @ A ) )
      = ( map_fun @ ( multiset @ A ) @ ( A > nat ) @ ( ( A > nat ) > A > nat ) @ ( ( multiset @ A ) > ( multiset @ A ) ) @ ( count @ A ) @ ( map_fun @ ( multiset @ A ) @ ( A > nat ) @ ( A > nat ) @ ( multiset @ A ) @ ( count @ A ) @ ( abs_multiset @ A ) )
        @ ^ [M8: A > nat,N7: A > nat,A5: A] : ( plus_plus @ nat @ ( M8 @ A5 ) @ ( N7 @ A5 ) ) ) ) ).

% plus_multiset_def
thf(fact_5029_minus__multiset__def,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( multiset @ A ) )
      = ( map_fun @ ( multiset @ A ) @ ( A > nat ) @ ( ( A > nat ) > A > nat ) @ ( ( multiset @ A ) > ( multiset @ A ) ) @ ( count @ A ) @ ( map_fun @ ( multiset @ A ) @ ( A > nat ) @ ( A > nat ) @ ( multiset @ A ) @ ( count @ A ) @ ( abs_multiset @ A ) )
        @ ^ [M8: A > nat,N7: A > nat,A5: A] : ( minus_minus @ nat @ ( M8 @ A5 ) @ ( N7 @ A5 ) ) ) ) ).

% minus_multiset_def
thf(fact_5030_type__definition__multiset,axiom,
    ! [A: $tType] :
      ( type_definition @ ( multiset @ A ) @ ( A > nat ) @ ( count @ A ) @ ( abs_multiset @ A )
      @ ( collect @ ( A > nat )
        @ ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) ) ).

% type_definition_multiset
thf(fact_5031_Abs__multiset__inverse,axiom,
    ! [A: $tType,Y: A > nat] :
      ( ( member @ ( A > nat ) @ Y
        @ ( collect @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
     => ( ( count @ A @ ( abs_multiset @ A @ Y ) )
        = Y ) ) ).

% Abs_multiset_inverse
thf(fact_5032_add__mset__def,axiom,
    ! [A: $tType] :
      ( ( add_mset @ A )
      = ( map_fun @ A @ A @ ( ( A > nat ) > A > nat ) @ ( ( multiset @ A ) > ( multiset @ A ) ) @ ( id @ A ) @ ( map_fun @ ( multiset @ A ) @ ( A > nat ) @ ( A > nat ) @ ( multiset @ A ) @ ( count @ A ) @ ( abs_multiset @ A ) )
        @ ^ [A5: A,M8: A > nat,B4: A] : ( if @ nat @ ( B4 = A5 ) @ ( suc @ ( M8 @ B4 ) ) @ ( M8 @ B4 ) ) ) ) ).

% add_mset_def
thf(fact_5033_sum__mset__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: B,C2: A,A3: multiset @ B] :
          ( ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( X2 = Y ) @ C2 @ ( zero_zero @ A ) )
              @ A3 ) )
          = ( times_times @ A @ C2 @ ( semiring_1_of_nat @ A @ ( count @ B @ A3 @ Y ) ) ) ) ) ).

% sum_mset_delta
thf(fact_5034_minus__multiset_Oabs__eq,axiom,
    ! [A: $tType,Xa: A > nat,X3: A > nat] :
      ( ( bNF_eq_onp @ ( A > nat )
        @ ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) )
        @ Xa
        @ Xa )
     => ( ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) )
          @ X3
          @ X3 )
       => ( ( minus_minus @ ( multiset @ A ) @ ( abs_multiset @ A @ Xa ) @ ( abs_multiset @ A @ X3 ) )
          = ( abs_multiset @ A
            @ ^ [A5: A] : ( minus_minus @ nat @ ( Xa @ A5 ) @ ( X3 @ A5 ) ) ) ) ) ) ).

% minus_multiset.abs_eq
thf(fact_5035_plus__multiset_Oabs__eq,axiom,
    ! [A: $tType,Xa: A > nat,X3: A > nat] :
      ( ( bNF_eq_onp @ ( A > nat )
        @ ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) )
        @ Xa
        @ Xa )
     => ( ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) )
          @ X3
          @ X3 )
       => ( ( plus_plus @ ( multiset @ A ) @ ( abs_multiset @ A @ Xa ) @ ( abs_multiset @ A @ X3 ) )
          = ( abs_multiset @ A
            @ ^ [A5: A] : ( plus_plus @ nat @ ( Xa @ A5 ) @ ( X3 @ A5 ) ) ) ) ) ) ).

% plus_multiset.abs_eq
thf(fact_5036_add__mset_Oabs__eq,axiom,
    ! [A: $tType,X3: A > nat,Xa: A] :
      ( ( bNF_eq_onp @ ( A > nat )
        @ ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) )
        @ X3
        @ X3 )
     => ( ( add_mset @ A @ Xa @ ( abs_multiset @ A @ X3 ) )
        = ( abs_multiset @ A
          @ ^ [B4: A] : ( if @ nat @ ( B4 = Xa ) @ ( suc @ ( X3 @ B4 ) ) @ ( X3 @ B4 ) ) ) ) ) ).

% add_mset.abs_eq
thf(fact_5037_eq__onp__def,axiom,
    ! [A: $tType] :
      ( ( bNF_eq_onp @ A )
      = ( ^ [R2: A > $o,X2: A,Y2: A] :
            ( ( R2 @ X2 )
            & ( X2 = Y2 ) ) ) ) ).

% eq_onp_def
thf(fact_5038_eq__onp__True,axiom,
    ! [A: $tType] :
      ( ( bNF_eq_onp @ A
        @ ^ [Uu: A] : $true )
      = ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) ) ) ).

% eq_onp_True
thf(fact_5039_fun_Orel__eq__onp,axiom,
    ! [D: $tType,A: $tType,P: A > $o] :
      ( ( bNF_rel_fun @ D @ D @ A @ A
        @ ^ [Y5: D,Z5: D] : ( Y5 = Z5 )
        @ ( bNF_eq_onp @ A @ P ) )
      = ( bNF_eq_onp @ ( D > A )
        @ ( basic_pred_fun @ D @ A
          @ ^ [Uu: D] : $true
          @ P ) ) ) ).

% fun.rel_eq_onp
thf(fact_5040_rel__fun__eq__eq__onp,axiom,
    ! [B: $tType,A: $tType,P: B > $o] :
      ( ( bNF_rel_fun @ A @ A @ B @ B
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
        @ ( bNF_eq_onp @ B @ P ) )
      = ( bNF_eq_onp @ ( A > B )
        @ ^ [F3: A > B] :
          ! [X2: A] : ( P @ ( F3 @ X2 ) ) ) ) ).

% rel_fun_eq_eq_onp
thf(fact_5041_fun_Opred__rel,axiom,
    ! [A: $tType,D: $tType,P: A > $o,X3: D > A] :
      ( ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true
        @ P
        @ X3 )
      = ( bNF_rel_fun @ D @ D @ A @ A
        @ ^ [Y5: D,Z5: D] : ( Y5 = Z5 )
        @ ( bNF_eq_onp @ A @ P )
        @ X3
        @ X3 ) ) ).

% fun.pred_rel
thf(fact_5042_rel__fun__eq__onp__rel,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: A > $o,S2: B > C > $o] :
      ( ( bNF_rel_fun @ A @ A @ B @ C @ ( bNF_eq_onp @ A @ R ) @ S2 )
      = ( ^ [F3: A > B,G2: A > C] :
          ! [X2: A] :
            ( ( R @ X2 )
           => ( S2 @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% rel_fun_eq_onp_rel
thf(fact_5043_filter__mset_Orsp,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ ( A > $o ) @ ( A > $o ) @ ( ( A > nat ) > A > nat ) @ ( ( A > nat ) > A > nat )
      @ ^ [Y5: A > $o,Z5: A > $o] : ( Y5 = Z5 )
      @ ( bNF_rel_fun @ ( A > nat ) @ ( A > nat ) @ ( A > nat ) @ ( A > nat )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
      @ ^ [P3: A > $o,M8: A > nat,X2: A] : ( if @ nat @ ( P3 @ X2 ) @ ( M8 @ X2 ) @ ( zero_zero @ nat ) )
      @ ^ [P3: A > $o,M8: A > nat,X2: A] : ( if @ nat @ ( P3 @ X2 ) @ ( M8 @ X2 ) @ ( zero_zero @ nat ) ) ) ).

% filter_mset.rsp
thf(fact_5044_zero__multiset_Orsp,axiom,
    ! [A: $tType] :
      ( bNF_eq_onp @ ( A > nat )
      @ ^ [F3: A > nat] :
          ( finite_finite2 @ A
          @ ( collect @ A
            @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) )
      @ ^ [A5: A] : ( zero_zero @ nat )
      @ ^ [A5: A] : ( zero_zero @ nat ) ) ).

% zero_multiset.rsp
thf(fact_5045_add__mset_Orsp,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ A @ A @ ( ( A > nat ) > A > nat ) @ ( ( A > nat ) > A > nat )
      @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
      @ ( bNF_rel_fun @ ( A > nat ) @ ( A > nat ) @ ( A > nat ) @ ( A > nat )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
      @ ^ [A5: A,M8: A > nat,B4: A] : ( if @ nat @ ( B4 = A5 ) @ ( suc @ ( M8 @ B4 ) ) @ ( M8 @ B4 ) )
      @ ^ [A5: A,M8: A > nat,B4: A] : ( if @ nat @ ( B4 = A5 ) @ ( suc @ ( M8 @ B4 ) ) @ ( M8 @ B4 ) ) ) ).

% add_mset.rsp
thf(fact_5046_plus__multiset_Orsp,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ ( A > nat ) @ ( A > nat ) @ ( ( A > nat ) > A > nat ) @ ( ( A > nat ) > A > nat )
      @ ( bNF_eq_onp @ ( A > nat )
        @ ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
      @ ( bNF_rel_fun @ ( A > nat ) @ ( A > nat ) @ ( A > nat ) @ ( A > nat )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
      @ ^ [M8: A > nat,N7: A > nat,A5: A] : ( plus_plus @ nat @ ( M8 @ A5 ) @ ( N7 @ A5 ) )
      @ ^ [M8: A > nat,N7: A > nat,A5: A] : ( plus_plus @ nat @ ( M8 @ A5 ) @ ( N7 @ A5 ) ) ) ).

% plus_multiset.rsp
thf(fact_5047_minus__multiset_Orsp,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ ( A > nat ) @ ( A > nat ) @ ( ( A > nat ) > A > nat ) @ ( ( A > nat ) > A > nat )
      @ ( bNF_eq_onp @ ( A > nat )
        @ ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
      @ ( bNF_rel_fun @ ( A > nat ) @ ( A > nat ) @ ( A > nat ) @ ( A > nat )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
      @ ^ [M8: A > nat,N7: A > nat,A5: A] : ( minus_minus @ nat @ ( M8 @ A5 ) @ ( N7 @ A5 ) )
      @ ^ [M8: A > nat,N7: A > nat,A5: A] : ( minus_minus @ nat @ ( M8 @ A5 ) @ ( N7 @ A5 ) ) ) ).

% minus_multiset.rsp
thf(fact_5048_repeat__mset_Orsp,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ nat @ nat @ ( ( A > nat ) > A > nat ) @ ( ( A > nat ) > A > nat )
      @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 )
      @ ( bNF_rel_fun @ ( A > nat ) @ ( A > nat ) @ ( A > nat ) @ ( A > nat )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
      @ ^ [N5: nat,M8: A > nat,A5: A] : ( times_times @ nat @ N5 @ ( M8 @ A5 ) )
      @ ^ [N5: nat,M8: A > nat,A5: A] : ( times_times @ nat @ N5 @ ( M8 @ A5 ) ) ) ).

% repeat_mset.rsp
thf(fact_5049_Inf__multiset_Oabs__eq,axiom,
    ! [A: $tType,X3: set @ ( A > nat )] :
      ( ( bNF_rel_set @ ( A > nat ) @ ( A > nat )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
        @ X3
        @ X3 )
     => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ ( A > nat ) @ ( multiset @ A ) @ ( abs_multiset @ A ) @ X3 ) )
        = ( abs_multiset @ A
          @ ^ [I2: A] :
              ( if @ nat
              @ ( X3
                = ( bot_bot @ ( set @ ( A > nat ) ) ) )
              @ ( zero_zero @ nat )
              @ ( complete_Inf_Inf @ nat
                @ ( image2 @ ( A > nat ) @ nat
                  @ ^ [F3: A > nat] : ( F3 @ I2 )
                  @ X3 ) ) ) ) ) ) ).

% Inf_multiset.abs_eq
thf(fact_5050_repeat__mset_Oabs__eq,axiom,
    ! [A: $tType,X3: A > nat,Xa: nat] :
      ( ( bNF_eq_onp @ ( A > nat )
        @ ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) )
        @ X3
        @ X3 )
     => ( ( repeat_mset @ A @ Xa @ ( abs_multiset @ A @ X3 ) )
        = ( abs_multiset @ A
          @ ^ [A5: A] : ( times_times @ nat @ Xa @ ( X3 @ A5 ) ) ) ) ) ).

% repeat_mset.abs_eq
thf(fact_5051_Inf__multiset_Orsp,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ ( set @ ( A > nat ) ) @ ( set @ ( A > nat ) ) @ ( A > nat ) @ ( A > nat )
      @ ( bNF_rel_set @ ( A > nat ) @ ( A > nat )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F3: A > nat] :
              ( finite_finite2 @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) )
      @ ( bNF_eq_onp @ ( A > nat )
        @ ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
      @ ^ [A6: set @ ( A > nat ),I2: A] :
          ( if @ nat
          @ ( A6
            = ( bot_bot @ ( set @ ( A > nat ) ) ) )
          @ ( zero_zero @ nat )
          @ ( complete_Inf_Inf @ nat
            @ ( image2 @ ( A > nat ) @ nat
              @ ^ [F3: A > nat] : ( F3 @ I2 )
              @ A6 ) ) )
      @ ^ [A6: set @ ( A > nat ),I2: A] :
          ( if @ nat
          @ ( A6
            = ( bot_bot @ ( set @ ( A > nat ) ) ) )
          @ ( zero_zero @ nat )
          @ ( complete_Inf_Inf @ nat
            @ ( image2 @ ( A > nat ) @ nat
              @ ^ [F3: A > nat] : ( F3 @ I2 )
              @ A6 ) ) ) ) ).

% Inf_multiset.rsp
thf(fact_5052_rel__set__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_rel_set @ A @ B )
      = ( ^ [R2: A > B > $o,A6: set @ A,B5: set @ B] :
            ( ! [X2: A] :
                ( ( member @ A @ X2 @ A6 )
               => ? [Y2: B] :
                    ( ( member @ B @ Y2 @ B5 )
                    & ( R2 @ X2 @ Y2 ) ) )
            & ! [X2: B] :
                ( ( member @ B @ X2 @ B5 )
               => ? [Y2: A] :
                    ( ( member @ A @ Y2 @ A6 )
                    & ( R2 @ Y2 @ X2 ) ) ) ) ) ) ).

% rel_set_def
thf(fact_5053_fun_Oset__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,R: A > B > $o] :
      ( bNF_rel_fun @ ( D > A ) @ ( D > B ) @ ( set @ A ) @ ( set @ B )
      @ ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y5: D,Z5: D] : ( Y5 = Z5 )
        @ R )
      @ ( bNF_rel_set @ A @ B @ R )
      @ ^ [F3: D > A] : ( image2 @ D @ A @ F3 @ ( top_top @ ( set @ D ) ) )
      @ ^ [F3: D > B] : ( image2 @ D @ B @ F3 @ ( top_top @ ( set @ D ) ) ) ) ).

% fun.set_transfer
thf(fact_5054_repeat__mset__def,axiom,
    ! [A: $tType] :
      ( ( repeat_mset @ A )
      = ( map_fun @ nat @ nat @ ( ( A > nat ) > A > nat ) @ ( ( multiset @ A ) > ( multiset @ A ) ) @ ( id @ nat ) @ ( map_fun @ ( multiset @ A ) @ ( A > nat ) @ ( A > nat ) @ ( multiset @ A ) @ ( count @ A ) @ ( abs_multiset @ A ) )
        @ ^ [N5: nat,M8: A > nat,A5: A] : ( times_times @ nat @ N5 @ ( M8 @ A5 ) ) ) ) ).

% repeat_mset_def
thf(fact_5055_INF__parametric,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( complete_Inf @ C )
     => ! [A3: A > B > $o] :
          ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( ( A > C ) > C ) @ ( ( B > C ) > C ) @ ( bNF_rel_set @ A @ B @ A3 )
          @ ( bNF_rel_fun @ ( A > C ) @ ( B > C ) @ C @ C
            @ ( bNF_rel_fun @ A @ B @ C @ C @ A3
              @ ^ [Y5: C,Z5: C] : ( Y5 = Z5 ) )
            @ ^ [Y5: C,Z5: C] : ( Y5 = Z5 ) )
          @ ^ [A6: set @ A,F3: A > C] : ( complete_Inf_Inf @ C @ ( image2 @ A @ C @ F3 @ A6 ) )
          @ ^ [A6: set @ B,F3: B > C] : ( complete_Inf_Inf @ C @ ( image2 @ B @ C @ F3 @ A6 ) ) ) ) ).

% INF_parametric
thf(fact_5056_SUP__parametric,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( complete_Sup @ C )
     => ! [R: A > B > $o] :
          ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( ( A > C ) > C ) @ ( ( B > C ) > C ) @ ( bNF_rel_set @ A @ B @ R )
          @ ( bNF_rel_fun @ ( A > C ) @ ( B > C ) @ C @ C
            @ ( bNF_rel_fun @ A @ B @ C @ C @ R
              @ ^ [Y5: C,Z5: C] : ( Y5 = Z5 ) )
            @ ^ [Y5: C,Z5: C] : ( Y5 = Z5 ) )
          @ ^ [A6: set @ A,F3: A > C] : ( complete_Sup_Sup @ C @ ( image2 @ A @ C @ F3 @ A6 ) )
          @ ^ [A6: set @ B,F3: B > C] : ( complete_Sup_Sup @ C @ ( image2 @ B @ C @ F3 @ A6 ) ) ) ) ).

% SUP_parametric
thf(fact_5057_UNION__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A3: A > B > $o,B2: C > D > $o] :
      ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( ( A > ( set @ C ) ) > ( set @ C ) ) @ ( ( B > ( set @ D ) ) > ( set @ D ) ) @ ( bNF_rel_set @ A @ B @ A3 ) @ ( bNF_rel_fun @ ( A > ( set @ C ) ) @ ( B > ( set @ D ) ) @ ( set @ C ) @ ( set @ D ) @ ( bNF_rel_fun @ A @ B @ ( set @ C ) @ ( set @ D ) @ A3 @ ( bNF_rel_set @ C @ D @ B2 ) ) @ ( bNF_rel_set @ C @ D @ B2 ) )
      @ ^ [A6: set @ A,F3: A > ( set @ C )] : ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ A @ ( set @ C ) @ F3 @ A6 ) )
      @ ^ [A6: set @ B,F3: B > ( set @ D )] : ( complete_Sup_Sup @ ( set @ D ) @ ( image2 @ B @ ( set @ D ) @ F3 @ A6 ) ) ) ).

% UNION_transfer
thf(fact_5058_empty__transfer,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o] : ( bNF_rel_set @ A @ B @ A3 @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ B ) ) ) ).

% empty_transfer
thf(fact_5059_Union__transfer,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o] : ( bNF_rel_fun @ ( set @ ( set @ A ) ) @ ( set @ ( set @ B ) ) @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A3 ) ) @ ( bNF_rel_set @ A @ B @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) ) @ ( complete_Sup_Sup @ ( set @ B ) ) ) ).

% Union_transfer
thf(fact_5060_set__relator__eq__onp,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( bNF_rel_set @ A @ A @ ( bNF_eq_onp @ A @ P ) )
      = ( bNF_eq_onp @ ( set @ A )
        @ ^ [A6: set @ A] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ A6 )
           => ( P @ X2 ) ) ) ) ).

% set_relator_eq_onp
thf(fact_5061_Inf__multiset_Otransfer,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ ( set @ ( A > nat ) ) @ ( set @ ( multiset @ A ) ) @ ( A > nat ) @ ( multiset @ A )
      @ ( bNF_rel_set @ ( A > nat ) @ ( multiset @ A )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) ) )
      @ ( pcr_multiset @ A @ A
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
      @ ^ [A6: set @ ( A > nat ),I2: A] :
          ( if @ nat
          @ ( A6
            = ( bot_bot @ ( set @ ( A > nat ) ) ) )
          @ ( zero_zero @ nat )
          @ ( complete_Inf_Inf @ nat
            @ ( image2 @ ( A > nat ) @ nat
              @ ^ [F3: A > nat] : ( F3 @ I2 )
              @ A6 ) ) )
      @ ( complete_Inf_Inf @ ( multiset @ A ) ) ) ).

% Inf_multiset.transfer
thf(fact_5062_filter__mset_Oabs__eq,axiom,
    ! [A: $tType,X3: A > nat,Xa: A > $o] :
      ( ( bNF_eq_onp @ ( A > nat )
        @ ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) )
        @ X3
        @ X3 )
     => ( ( filter_mset @ A @ Xa @ ( abs_multiset @ A @ X3 ) )
        = ( abs_multiset @ A
          @ ^ [X2: A] : ( if @ nat @ ( Xa @ X2 ) @ ( X3 @ X2 ) @ ( zero_zero @ nat ) ) ) ) ) ).

% filter_mset.abs_eq
thf(fact_5063_filter__mset__def,axiom,
    ! [A: $tType] :
      ( ( filter_mset @ A )
      = ( map_fun @ ( A > $o ) @ ( A > $o ) @ ( ( A > nat ) > A > nat ) @ ( ( multiset @ A ) > ( multiset @ A ) ) @ ( id @ ( A > $o ) ) @ ( map_fun @ ( multiset @ A ) @ ( A > nat ) @ ( A > nat ) @ ( multiset @ A ) @ ( count @ A ) @ ( abs_multiset @ A ) )
        @ ^ [P3: A > $o,M8: A > nat,X2: A] : ( if @ nat @ ( P3 @ X2 ) @ ( M8 @ X2 ) @ ( zero_zero @ nat ) ) ) ) ).

% filter_mset_def
thf(fact_5064_filter__mset__True,axiom,
    ! [A: $tType,M: multiset @ A] :
      ( ( filter_mset @ A
        @ ^ [Y2: A] : $true
        @ M )
      = M ) ).

% filter_mset_True
thf(fact_5065_filter__mset__False,axiom,
    ! [A: $tType,M: multiset @ A] :
      ( ( filter_mset @ A
        @ ^ [Y2: A] : $false
        @ M )
      = ( zero_zero @ ( multiset @ A ) ) ) ).

% filter_mset_False
thf(fact_5066_set__mset__filter,axiom,
    ! [A: $tType,P: A > $o,M: multiset @ A] :
      ( ( set_mset @ A @ ( filter_mset @ A @ P @ M ) )
      = ( collect @ A
        @ ^ [A5: A] :
            ( ( member @ A @ A5 @ ( set_mset @ A @ M ) )
            & ( P @ A5 ) ) ) ) ).

% set_mset_filter
thf(fact_5067_filter__mset__mset__set,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( filter_mset @ A @ P @ ( mset_set @ A @ A3 ) )
        = ( mset_set @ A
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A3 )
                & ( P @ X2 ) ) ) ) ) ) ).

% filter_mset_mset_set
thf(fact_5068_mset__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( mset @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( filter_mset @ A @ P @ ( mset @ A @ Xs ) ) ) ).

% mset_filter
thf(fact_5069_filter__mset_Otransfer,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ ( A > $o ) @ ( A > $o ) @ ( ( A > nat ) > A > nat ) @ ( ( multiset @ A ) > ( multiset @ A ) )
      @ ^ [Y5: A > $o,Z5: A > $o] : ( Y5 = Z5 )
      @ ( bNF_rel_fun @ ( A > nat ) @ ( multiset @ A ) @ ( A > nat ) @ ( multiset @ A )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) ) )
      @ ^ [P3: A > $o,M8: A > nat,X2: A] : ( if @ nat @ ( P3 @ X2 ) @ ( M8 @ X2 ) @ ( zero_zero @ nat ) )
      @ ( filter_mset @ A ) ) ).

% filter_mset.transfer
thf(fact_5070_filter__filter__mset,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,M: multiset @ A] :
      ( ( filter_mset @ A @ P @ ( filter_mset @ A @ Q @ M ) )
      = ( filter_mset @ A
        @ ^ [X2: A] :
            ( ( Q @ X2 )
            & ( P @ X2 ) )
        @ M ) ) ).

% filter_filter_mset
thf(fact_5071_multiset__partition,axiom,
    ! [A: $tType,M: multiset @ A,P: A > $o] :
      ( M
      = ( plus_plus @ ( multiset @ A ) @ ( filter_mset @ A @ P @ M )
        @ ( filter_mset @ A
          @ ^ [X2: A] :
              ~ ( P @ X2 )
          @ M ) ) ) ).

% multiset_partition
thf(fact_5072_image__mset__If,axiom,
    ! [A: $tType,B: $tType,P: B > $o,F2: B > A,G: B > A,A3: multiset @ B] :
      ( ( image_mset @ B @ A
        @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ A3 )
      = ( plus_plus @ ( multiset @ A ) @ ( image_mset @ B @ A @ F2 @ ( filter_mset @ B @ P @ A3 ) )
        @ ( image_mset @ B @ A @ G
          @ ( filter_mset @ B
            @ ^ [X2: B] :
                ~ ( P @ X2 )
            @ A3 ) ) ) ) ).

% image_mset_If
thf(fact_5073_filter__eq__replicate__mset,axiom,
    ! [A: $tType,X3: A,D2: multiset @ A] :
      ( ( filter_mset @ A
        @ ^ [Y2: A] : ( Y2 = X3 )
        @ D2 )
      = ( replicate_mset @ A @ ( count @ A @ D2 @ X3 ) @ X3 ) ) ).

% filter_eq_replicate_mset
thf(fact_5074_zero__multiset_Otransfer,axiom,
    ! [A: $tType] :
      ( pcr_multiset @ A @ A
      @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
      @ ^ [A5: A] : ( zero_zero @ nat )
      @ ( zero_zero @ ( multiset @ A ) ) ) ).

% zero_multiset.transfer
thf(fact_5075_multiset_Orep__transfer,axiom,
    ! [D: $tType,E: $tType,T2: D > E > $o] :
      ( bNF_rel_fun @ ( D > nat ) @ ( multiset @ E ) @ ( D > nat ) @ ( E > nat ) @ ( pcr_multiset @ D @ E @ T2 )
      @ ( bNF_rel_fun @ D @ E @ nat @ nat @ T2
        @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 ) )
      @ ^ [X2: D > nat] : X2
      @ ( count @ E ) ) ).

% multiset.rep_transfer
thf(fact_5076_add__mset_Otransfer,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ A @ A @ ( ( A > nat ) > A > nat ) @ ( ( multiset @ A ) > ( multiset @ A ) )
      @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
      @ ( bNF_rel_fun @ ( A > nat ) @ ( multiset @ A ) @ ( A > nat ) @ ( multiset @ A )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) ) )
      @ ^ [A5: A,M8: A > nat,B4: A] : ( if @ nat @ ( B4 = A5 ) @ ( suc @ ( M8 @ B4 ) ) @ ( M8 @ B4 ) )
      @ ( add_mset @ A ) ) ).

% add_mset.transfer
thf(fact_5077_plus__multiset_Otransfer,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ ( A > nat ) @ ( multiset @ A ) @ ( ( A > nat ) > A > nat ) @ ( ( multiset @ A ) > ( multiset @ A ) )
      @ ( pcr_multiset @ A @ A
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
      @ ( bNF_rel_fun @ ( A > nat ) @ ( multiset @ A ) @ ( A > nat ) @ ( multiset @ A )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) ) )
      @ ^ [M8: A > nat,N7: A > nat,A5: A] : ( plus_plus @ nat @ ( M8 @ A5 ) @ ( N7 @ A5 ) )
      @ ( plus_plus @ ( multiset @ A ) ) ) ).

% plus_multiset.transfer
thf(fact_5078_minus__multiset_Otransfer,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ ( A > nat ) @ ( multiset @ A ) @ ( ( A > nat ) > A > nat ) @ ( ( multiset @ A ) > ( multiset @ A ) )
      @ ( pcr_multiset @ A @ A
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
      @ ( bNF_rel_fun @ ( A > nat ) @ ( multiset @ A ) @ ( A > nat ) @ ( multiset @ A )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) ) )
      @ ^ [M8: A > nat,N7: A > nat,A5: A] : ( minus_minus @ nat @ ( M8 @ A5 ) @ ( N7 @ A5 ) )
      @ ( minus_minus @ ( multiset @ A ) ) ) ).

% minus_multiset.transfer
thf(fact_5079_repeat__mset_Otransfer,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ nat @ nat @ ( ( A > nat ) > A > nat ) @ ( ( multiset @ A ) > ( multiset @ A ) )
      @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 )
      @ ( bNF_rel_fun @ ( A > nat ) @ ( multiset @ A ) @ ( A > nat ) @ ( multiset @ A )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) ) )
      @ ^ [N5: nat,M8: A > nat,A5: A] : ( times_times @ nat @ N5 @ ( M8 @ A5 ) )
      @ ( repeat_mset @ A ) ) ).

% repeat_mset.transfer
thf(fact_5080_minus__coset__filter,axiom,
    ! [A: $tType,A3: set @ A,Xs: list @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( coset @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X2: A] : ( member @ A @ X2 @ A3 )
          @ Xs ) ) ) ).

% minus_coset_filter
thf(fact_5081_multiset_Odomain,axiom,
    ! [B: $tType,C: $tType,T2: C > B > $o] :
      ( ( domainp @ ( C > nat ) @ ( multiset @ B ) @ ( pcr_multiset @ C @ B @ T2 ) )
      = ( ^ [X2: C > nat] :
          ? [Y2: B > nat] :
            ( ( bNF_rel_fun @ C @ B @ nat @ nat @ T2
              @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 )
              @ X2
              @ Y2 )
            & ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [Z3: B] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( Y2 @ Z3 ) ) ) ) ) ) ) ).

% multiset.domain
thf(fact_5082_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs2: list @ A,I3: nat,J2: nat] :
      ( ( distinct @ A @ Vs2 )
     => ( ( ord_less_eq @ nat @ I3 @ J2 )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I3 @ Vs2 ) ) @ ( set2 @ A @ ( drop @ A @ J2 @ Vs2 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_5083_fun_ODomainp__rel,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: A > B > $o] :
      ( ( domainp @ ( C > A ) @ ( C > B )
        @ ( bNF_rel_fun @ C @ C @ A @ B
          @ ^ [Y5: C,Z5: C] : ( Y5 = Z5 )
          @ R ) )
      = ( basic_pred_fun @ C @ A
        @ ^ [Uu: C] : $true
        @ ( domainp @ A @ B @ R ) ) ) ).

% fun.Domainp_rel
thf(fact_5084_filter__upt__take__conv,axiom,
    ! [A: $tType,P: A > $o,M2: nat,L: list @ A,N: nat] :
      ( ( filter2 @ nat
        @ ^ [I2: nat] : ( P @ ( nth @ A @ ( take @ A @ M2 @ L ) @ I2 ) )
        @ ( upt @ N @ M2 ) )
      = ( filter2 @ nat
        @ ^ [I2: nat] : ( P @ ( nth @ A @ L @ I2 ) )
        @ ( upt @ N @ M2 ) ) ) ).

% filter_upt_take_conv
thf(fact_5085_take__Cons,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list @ A] :
      ( ( take @ A @ N @ ( cons @ A @ X3 @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( nil @ A )
        @ ^ [M5: nat] : ( cons @ A @ X3 @ ( take @ A @ M5 @ Xs ) )
        @ N ) ) ).

% take_Cons
thf(fact_5086_union__coset__filter,axiom,
    ! [A: $tType,Xs: list @ A,A3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( coset @ A @ Xs ) @ A3 )
      = ( coset @ A
        @ ( filter2 @ A
          @ ^ [X2: A] :
              ~ ( member @ A @ X2 @ A3 )
          @ Xs ) ) ) ).

% union_coset_filter
thf(fact_5087_inter__coset__fold,axiom,
    ! [A: $tType,A3: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( coset @ A @ Xs ) )
      = ( fold @ A @ ( set @ A ) @ ( remove @ A ) @ Xs @ A3 ) ) ).

% inter_coset_fold
thf(fact_5088_multiset_Odomain__eq,axiom,
    ! [A: $tType] :
      ( ( domainp @ ( A > nat ) @ ( multiset @ A )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) ) )
      = ( ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) ) ) ).

% multiset.domain_eq
thf(fact_5089_zip__replicate2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,N: nat,Y: B] :
      ( ( zip @ A @ B @ Xs @ ( replicate @ B @ N @ Y ) )
      = ( map @ A @ ( product_prod @ A @ B )
        @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ Y )
        @ ( take @ A @ N @ Xs ) ) ) ).

% zip_replicate2
thf(fact_5090_multiset_Odomain__par,axiom,
    ! [B: $tType,C: $tType,T2: C > B > $o,DT: C > $o,DS: nat > $o,P23: ( C > nat ) > $o] :
      ( ( ( domainp @ C @ B @ T2 )
        = DT )
     => ( ( ( domainp @ nat @ nat
            @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 ) )
          = DS )
       => ( ( left_unique @ C @ B @ T2 )
         => ( ( bNF_rel_fun @ ( C > nat ) @ ( B > nat ) @ $o @ $o
              @ ( bNF_rel_fun @ C @ B @ nat @ nat @ T2
                @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 ) )
              @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
              @ P23
              @ ^ [F3: B > nat] :
                  ( finite_finite2 @ B
                  @ ( collect @ B
                    @ ^ [X2: B] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
           => ( ( domainp @ ( C > nat ) @ ( multiset @ B ) @ ( pcr_multiset @ C @ B @ T2 ) )
              = ( inf_inf @ ( ( C > nat ) > $o ) @ ( basic_pred_fun @ C @ nat @ DT @ DS ) @ P23 ) ) ) ) ) ) ).

% multiset.domain_par
thf(fact_5091_multiset_Odomain__par__left__total,axiom,
    ! [B: $tType,C: $tType,T2: C > B > $o,P2: ( C > nat ) > $o] :
      ( ( left_total @ ( C > nat ) @ ( B > nat )
        @ ( bNF_rel_fun @ C @ B @ nat @ nat @ T2
          @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 ) ) )
     => ( ( bNF_rel_fun @ ( C > nat ) @ ( B > nat ) @ $o @ $o
          @ ( bNF_rel_fun @ C @ B @ nat @ nat @ T2
            @ ^ [Y5: nat,Z5: nat] : ( Y5 = Z5 ) )
          @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
          @ P2
          @ ^ [F3: B > nat] :
              ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [X2: B] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
       => ( ( domainp @ ( C > nat ) @ ( multiset @ B ) @ ( pcr_multiset @ C @ B @ T2 ) )
          = P2 ) ) ) ).

% multiset.domain_par_left_total
thf(fact_5092_prod__mset_Oremove,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [X3: A,A3: multiset @ A] :
          ( ( member @ A @ X3 @ ( set_mset @ A @ A3 ) )
         => ( ( comm_m9189036328036947845d_mset @ A @ A3 )
            = ( times_times @ A @ X3 @ ( comm_m9189036328036947845d_mset @ A @ ( minus_minus @ ( multiset @ A ) @ A3 @ ( add_mset @ A @ X3 @ ( zero_zero @ ( multiset @ A ) ) ) ) ) ) ) ) ) ).

% prod_mset.remove
thf(fact_5093_prod__mset__empty,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( comm_m9189036328036947845d_mset @ A @ ( zero_zero @ ( multiset @ A ) ) )
        = ( one_one @ A ) ) ) ).

% prod_mset_empty
thf(fact_5094_prod__mset_Oadd__mset,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [X3: A,N4: multiset @ A] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( add_mset @ A @ X3 @ N4 ) )
          = ( times_times @ A @ X3 @ ( comm_m9189036328036947845d_mset @ A @ N4 ) ) ) ) ).

% prod_mset.add_mset
thf(fact_5095_prod__mset_Ounion,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: multiset @ A,N4: multiset @ A] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( plus_plus @ ( multiset @ A ) @ M @ N4 ) )
          = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ M ) @ ( comm_m9189036328036947845d_mset @ A @ N4 ) ) ) ) ).

% prod_mset.union
thf(fact_5096_prod__mset__Un,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: multiset @ A,B2: multiset @ A] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( plus_plus @ ( multiset @ A ) @ A3 @ B2 ) )
          = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ A3 ) @ ( comm_m9189036328036947845d_mset @ A @ B2 ) ) ) ) ).

% prod_mset_Un
thf(fact_5097_prod__mset_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [Uu: B] : ( one_one @ A )
              @ A3 ) )
          = ( one_one @ A ) ) ) ).

% prod_mset.neutral_const
thf(fact_5098_prod__mset_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,X3: B,A3: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ ( add_mset @ B @ X3 @ A3 ) ) )
          = ( times_times @ A @ ( G @ X3 ) @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ A3 ) ) ) ) ) ).

% prod_mset.insert
thf(fact_5099_prod__mset_Oswap,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > C > A,B2: multiset @ C,A3: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [I2: B] : ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ C @ A @ ( G @ I2 ) @ B2 ) )
              @ A3 ) )
          = ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ C @ A
              @ ^ [J3: C] :
                  ( comm_m9189036328036947845d_mset @ A
                  @ ( image_mset @ B @ A
                    @ ^ [I2: B] : ( G @ I2 @ J3 )
                    @ A3 ) )
              @ B2 ) ) ) ) ).

% prod_mset.swap
thf(fact_5100_typedef__left__unique,axiom,
    ! [B: $tType,A: $tType,Rep: B > A,Abs: A > B,A3: set @ A,T2: A > B > $o] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A3 )
     => ( ( T2
          = ( ^ [X2: A,Y2: B] :
                ( X2
                = ( Rep @ Y2 ) ) ) )
       => ( left_unique @ A @ B @ T2 ) ) ) ).

% typedef_left_unique
thf(fact_5101_left__unique__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( left_unique @ A @ B )
      = ( ^ [R2: A > B > $o] :
          ! [Z3: B] :
            ( uniq @ A
            @ ^ [X2: A] : ( R2 @ X2 @ Z3 ) ) ) ) ).

% left_unique_iff
thf(fact_5102_prod__mset_Oneutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: multiset @ A] :
          ( ! [X: A] :
              ( ( member @ A @ X @ ( set_mset @ A @ A3 ) )
             => ( X
                = ( one_one @ A ) ) )
         => ( ( comm_m9189036328036947845d_mset @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% prod_mset.neutral
thf(fact_5103_prod__mset_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H2: B > A,A3: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( G @ X2 ) @ ( H2 @ X2 ) )
              @ A3 ) )
          = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ A3 ) ) @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ H2 @ A3 ) ) ) ) ) ).

% prod_mset.distrib
thf(fact_5104_rat_Odomain,axiom,
    ( ( domainp @ ( product_prod @ int @ int ) @ rat @ pcr_rat )
    = ( ^ [X2: product_prod @ int @ int] :
        ? [Y2: product_prod @ int @ int] :
          ( ( basic_rel_prod @ int @ int @ int @ int
            @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
            @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
            @ X2
            @ Y2 )
          & ( ratrel @ Y2 @ Y2 ) ) ) ) ).

% rat.domain
thf(fact_5105_is__unit__prod__mset__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: multiset @ A] :
          ( ( dvd_dvd @ A @ ( comm_m9189036328036947845d_mset @ A @ A3 ) @ ( one_one @ A ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set_mset @ A @ A3 ) )
               => ( dvd_dvd @ A @ X2 @ ( one_one @ A ) ) ) ) ) ) ).

% is_unit_prod_mset_iff
thf(fact_5106_prod__mset_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( comm_m9189036328036947845d_mset @ A )
        = ( fold_mset @ A @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod_mset.eq_fold
thf(fact_5107_prod__mset__delta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y: B,C2: A,A3: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( Y = X2 ) @ C2 @ ( one_one @ A ) )
              @ A3 ) )
          = ( power_power @ A @ C2 @ ( count @ B @ A3 @ Y ) ) ) ) ).

% prod_mset_delta'
thf(fact_5108_prod__mset__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y: B,C2: A,A3: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( X2 = Y ) @ C2 @ ( one_one @ A ) )
              @ A3 ) )
          = ( power_power @ A @ C2 @ ( count @ B @ A3 @ Y ) ) ) ) ).

% prod_mset_delta
thf(fact_5109_prod__mset__multiplicity,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( comm_m9189036328036947845d_mset @ A )
        = ( ^ [M8: multiset @ A] :
              ( groups7121269368397514597t_prod @ A @ A
              @ ^ [X2: A] : ( power_power @ A @ X2 @ ( count @ A @ M8 @ X2 ) )
              @ ( set_mset @ A @ M8 ) ) ) ) ) ).

% prod_mset_multiplicity
thf(fact_5110_composed__equiv__rel__eq__onp,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o,P: A > $o,P2: B > $o,P10: A > $o] :
      ( ( left_unique @ A @ B @ R )
     => ( ( bNF_rel_fun @ A @ B @ $o @ $o @ R
          @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
          @ P
          @ P2 )
       => ( ( ( domainp @ A @ B @ R )
            = P10 )
         => ( ( relcompp @ A @ B @ A @ R @ ( relcompp @ B @ B @ A @ ( bNF_eq_onp @ B @ P2 ) @ ( conversep @ A @ B @ R ) ) )
            = ( bNF_eq_onp @ A @ ( inf_inf @ ( A > $o ) @ P10 @ P ) ) ) ) ) ) ).

% composed_equiv_rel_eq_onp
thf(fact_5111_rat_Odomain__par,axiom,
    ! [DR1: int > $o,DR2: int > $o,P23: ( product_prod @ int @ int ) > $o] :
      ( ( ( domainp @ int @ int
          @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 ) )
        = DR1 )
     => ( ( ( domainp @ int @ int
            @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 ) )
          = DR2 )
       => ( ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ $o @ $o
            @ ( basic_rel_prod @ int @ int @ int @ int
              @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
              @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 ) )
            @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
            @ P23
            @ ^ [X2: product_prod @ int @ int] : ( ratrel @ X2 @ X2 ) )
         => ( ( domainp @ ( product_prod @ int @ int ) @ rat @ pcr_rat )
            = ( inf_inf @ ( ( product_prod @ int @ int ) > $o ) @ ( basic_pred_prod @ int @ int @ DR1 @ DR2 ) @ P23 ) ) ) ) ) ).

% rat.domain_par
thf(fact_5112_wfP__SUP,axiom,
    ! [B: $tType,A: $tType,R5: A > B > B > $o] :
      ( ! [I4: A] : ( wfP @ B @ ( R5 @ I4 ) )
     => ( ! [I4: A,J5: A] :
            ( ( ( R5 @ I4 )
             != ( R5 @ J5 ) )
           => ( ( inf_inf @ ( B > $o ) @ ( domainp @ B @ B @ ( R5 @ I4 ) ) @ ( rangep @ B @ B @ ( R5 @ J5 ) ) )
              = ( bot_bot @ ( B > $o ) ) ) )
       => ( wfP @ B @ ( complete_Sup_Sup @ ( B > B > $o ) @ ( image2 @ A @ ( B > B > $o ) @ R5 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% wfP_SUP
thf(fact_5113_wfP__empty,axiom,
    ! [A: $tType] :
      ( wfP @ A
      @ ^ [X2: A,Y2: A] : $false ) ).

% wfP_empty
thf(fact_5114_relcompp__bot1,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: C > B > $o] :
      ( ( relcompp @ A @ C @ B @ ( bot_bot @ ( A > C > $o ) ) @ R )
      = ( bot_bot @ ( A > B > $o ) ) ) ).

% relcompp_bot1
thf(fact_5115_relcompp__bot2,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: A > C > $o] :
      ( ( relcompp @ A @ C @ B @ R @ ( bot_bot @ ( C > B > $o ) ) )
      = ( bot_bot @ ( A > B > $o ) ) ) ).

% relcompp_bot2
thf(fact_5116_prod_Opred__True,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_pred_prod @ A @ B
        @ ^ [Uu: A] : $true
        @ ^ [Uu: B] : $true )
      = ( ^ [Uu: product_prod @ A @ B] : $true ) ) ).

% prod.pred_True
thf(fact_5117_OO__def,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( relcompp @ A @ C @ B )
      = ( ^ [R2: A > C > $o,S7: C > B > $o,X2: A,Z3: B] :
          ? [Y2: C] :
            ( ( R2 @ X2 @ Y2 )
            & ( S7 @ Y2 @ Z3 ) ) ) ) ).

% OO_def
thf(fact_5118_prod_Omap__cong__pred,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,X3: product_prod @ A @ B,Ya2: product_prod @ A @ B,F1: A > C,G1: A > C,F22: B > D,G22: B > D] :
      ( ( X3 = Ya2 )
     => ( ( basic_pred_prod @ A @ B
          @ ^ [Z1: A] :
              ( ( F1 @ Z1 )
              = ( G1 @ Z1 ) )
          @ ^ [Z22: B] :
              ( ( F22 @ Z22 )
              = ( G22 @ Z22 ) )
          @ Ya2 )
       => ( ( product_map_prod @ A @ C @ B @ D @ F1 @ F22 @ X3 )
          = ( product_map_prod @ A @ C @ B @ D @ G1 @ G22 @ Ya2 ) ) ) ) ).

% prod.map_cong_pred
thf(fact_5119_relcompp__relcomp__eq,axiom,
    ! [C: $tType,B: $tType,A: $tType,R5: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ B @ C )] :
      ( ( relcompp @ A @ B @ C
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R5 )
        @ ^ [X2: B,Y2: C] : ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ X2 @ Y2 ) @ S3 ) )
      = ( ^ [X2: A,Y2: C] : ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X2 @ Y2 ) @ ( relcomp @ A @ B @ C @ R5 @ S3 ) ) ) ) ).

% relcompp_relcomp_eq
thf(fact_5120_pcr__Domainp,axiom,
    ! [B: $tType,A: $tType,C: $tType,B2: A > B > $o,P: A > $o,A3: C > A > $o] :
      ( ( ( domainp @ A @ B @ B2 )
        = P )
     => ( ( domainp @ C @ B @ ( relcompp @ C @ A @ B @ A3 @ B2 ) )
        = ( ^ [X2: C] :
            ? [Y2: A] :
              ( ( A3 @ X2 @ Y2 )
              & ( P @ Y2 ) ) ) ) ) ).

% pcr_Domainp
thf(fact_5121_relcompp__SUP__distrib,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,S3: A > C > $o,R5: D > C > B > $o,I: set @ D] :
      ( ( relcompp @ A @ C @ B @ S3 @ ( complete_Sup_Sup @ ( C > B > $o ) @ ( image2 @ D @ ( C > B > $o ) @ R5 @ I ) ) )
      = ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image2 @ D @ ( A > B > $o )
          @ ^ [I2: D] : ( relcompp @ A @ C @ B @ S3 @ ( R5 @ I2 ) )
          @ I ) ) ) ).

% relcompp_SUP_distrib
thf(fact_5122_relcompp__SUP__distrib2,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,R5: D > A > C > $o,I: set @ D,S3: C > B > $o] :
      ( ( relcompp @ A @ C @ B @ ( complete_Sup_Sup @ ( A > C > $o ) @ ( image2 @ D @ ( A > C > $o ) @ R5 @ I ) ) @ S3 )
      = ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image2 @ D @ ( A > B > $o )
          @ ^ [I2: D] : ( relcompp @ A @ C @ B @ ( R5 @ I2 ) @ S3 )
          @ I ) ) ) ).

% relcompp_SUP_distrib2
thf(fact_5123_pcr__Domainp__par,axiom,
    ! [A: $tType,B: $tType,C: $tType,B2: A > B > $o,P24: A > $o,A3: C > A > $o,P12: C > $o,P23: C > $o] :
      ( ( ( domainp @ A @ B @ B2 )
        = P24 )
     => ( ( ( domainp @ C @ A @ A3 )
          = P12 )
       => ( ( bNF_rel_fun @ C @ A @ $o @ $o @ A3
            @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
            @ P23
            @ P24 )
         => ( ( domainp @ C @ B @ ( relcompp @ C @ A @ B @ A3 @ B2 ) )
            = ( inf_inf @ ( C > $o ) @ P12 @ P23 ) ) ) ) ) ).

% pcr_Domainp_par
thf(fact_5124_relcomp__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( relcomp @ A @ B @ C )
      = ( ^ [R3: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ B @ C )] :
            ( collect @ ( product_prod @ A @ C )
            @ ( product_case_prod @ A @ C @ $o
              @ ( relcompp @ A @ B @ C
                @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R3 )
                @ ^ [X2: B,Y2: C] : ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ X2 @ Y2 ) @ S ) ) ) ) ) ) ).

% relcomp_def
thf(fact_5125_wfP__wf__eq,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( wfP @ A
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) )
      = ( wf @ A @ R5 ) ) ).

% wfP_wf_eq
thf(fact_5126_wfP__def,axiom,
    ! [A: $tType] :
      ( ( wfP @ A )
      = ( ^ [R3: A > A > $o] : ( wf @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R3 ) ) ) ) ) ).

% wfP_def
thf(fact_5127_prod_Orel__compp__Grp,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType] :
      ( ( basic_rel_prod @ A @ C @ B @ D )
      = ( ^ [R14: A > C > $o,R25: B > D > $o] :
            ( relcompp @ ( product_prod @ A @ B ) @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) ) @ ( product_prod @ C @ D )
            @ ( conversep @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) ) @ ( product_prod @ A @ B )
              @ ( bNF_Grp @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) ) @ ( product_prod @ A @ B )
                @ ( collect @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) )
                  @ ^ [X2: product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D )] :
                      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( basic_fsts @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ X2 ) @ ( collect @ ( product_prod @ A @ C ) @ ( product_case_prod @ A @ C @ $o @ R14 ) ) )
                      & ( ord_less_eq @ ( set @ ( product_prod @ B @ D ) ) @ ( basic_snds @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ X2 ) @ ( collect @ ( product_prod @ B @ D ) @ ( product_case_prod @ B @ D @ $o @ R25 ) ) ) ) )
                @ ( product_map_prod @ ( product_prod @ A @ C ) @ A @ ( product_prod @ B @ D ) @ B @ ( product_fst @ A @ C ) @ ( product_fst @ B @ D ) ) ) )
            @ ( bNF_Grp @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) ) @ ( product_prod @ C @ D )
              @ ( collect @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) )
                @ ^ [X2: product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D )] :
                    ( ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( basic_fsts @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ X2 ) @ ( collect @ ( product_prod @ A @ C ) @ ( product_case_prod @ A @ C @ $o @ R14 ) ) )
                    & ( ord_less_eq @ ( set @ ( product_prod @ B @ D ) ) @ ( basic_snds @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ X2 ) @ ( collect @ ( product_prod @ B @ D ) @ ( product_case_prod @ B @ D @ $o @ R25 ) ) ) ) )
              @ ( product_map_prod @ ( product_prod @ A @ C ) @ C @ ( product_prod @ B @ D ) @ D @ ( product_snd @ A @ C ) @ ( product_snd @ B @ D ) ) ) ) ) ) ).

% prod.rel_compp_Grp
thf(fact_5128_multiset_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_mset @ A @ B )
      = ( ^ [R2: A > B > $o] :
            ( relcompp @ ( multiset @ A ) @ ( multiset @ ( product_prod @ A @ B ) ) @ ( multiset @ B )
            @ ( conversep @ ( multiset @ ( product_prod @ A @ B ) ) @ ( multiset @ A )
              @ ( bNF_Grp @ ( multiset @ ( product_prod @ A @ B ) ) @ ( multiset @ A )
                @ ( collect @ ( multiset @ ( product_prod @ A @ B ) )
                  @ ^ [X2: multiset @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_mset @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
                @ ( image_mset @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) ) ) )
            @ ( bNF_Grp @ ( multiset @ ( product_prod @ A @ B ) ) @ ( multiset @ B )
              @ ( collect @ ( multiset @ ( product_prod @ A @ B ) )
                @ ^ [X2: multiset @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_mset @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
              @ ( image_mset @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) ) ) ) ) ) ).

% multiset.rel_compp_Grp
thf(fact_5129_fun_Orel__compp__Grp,axiom,
    ! [D: $tType,B: $tType,A: $tType,R: A > B > $o] :
      ( ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y5: D,Z5: D] : ( Y5 = Z5 )
        @ R )
      = ( relcompp @ ( D > A ) @ ( D > ( product_prod @ A @ B ) ) @ ( D > B )
        @ ( conversep @ ( D > ( product_prod @ A @ B ) ) @ ( D > A )
          @ ( bNF_Grp @ ( D > ( product_prod @ A @ B ) ) @ ( D > A )
            @ ( collect @ ( D > ( product_prod @ A @ B ) )
              @ ^ [X2: D > ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ D @ ( product_prod @ A @ B ) @ X2 @ ( top_top @ ( set @ D ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) ) )
            @ ( comp @ ( product_prod @ A @ B ) @ A @ D @ ( product_fst @ A @ B ) ) ) )
        @ ( bNF_Grp @ ( D > ( product_prod @ A @ B ) ) @ ( D > B )
          @ ( collect @ ( D > ( product_prod @ A @ B ) )
            @ ^ [X2: D > ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ D @ ( product_prod @ A @ B ) @ X2 @ ( top_top @ ( set @ D ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) ) )
          @ ( comp @ ( product_prod @ A @ B ) @ B @ D @ ( product_snd @ A @ B ) ) ) ) ) ).

% fun.rel_compp_Grp
thf(fact_5130_Grp__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Grp @ A @ B )
      = ( ^ [A6: set @ A,F3: A > B,A5: A,B4: B] :
            ( ( B4
              = ( F3 @ A5 ) )
            & ( member @ A @ A5 @ A6 ) ) ) ) ).

% Grp_def
thf(fact_5131_list_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( list_all2 @ A @ B @ ( bNF_Grp @ A @ B @ A3 @ F2 ) )
      = ( bNF_Grp @ ( list @ A ) @ ( list @ B )
        @ ( collect @ ( list @ A )
          @ ^ [X2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ X2 ) @ A3 ) )
        @ ( map @ A @ B @ F2 ) ) ) ).

% list.rel_Grp
thf(fact_5132_multiset_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( rel_mset @ A @ B @ ( bNF_Grp @ A @ B @ A3 @ F2 ) )
      = ( bNF_Grp @ ( multiset @ A ) @ ( multiset @ B )
        @ ( collect @ ( multiset @ A )
          @ ^ [X2: multiset @ A] : ( ord_less_eq @ ( set @ A ) @ ( set_mset @ A @ X2 ) @ A3 ) )
        @ ( image_mset @ A @ B @ F2 ) ) ) ).

% multiset.rel_Grp
thf(fact_5133_fun_Orel__Grp,axiom,
    ! [D: $tType,B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y5: D,Z5: D] : ( Y5 = Z5 )
        @ ( bNF_Grp @ A @ B @ A3 @ F2 ) )
      = ( bNF_Grp @ ( D > A ) @ ( D > B )
        @ ( collect @ ( D > A )
          @ ^ [X2: D > A] : ( ord_less_eq @ ( set @ A ) @ ( image2 @ D @ A @ X2 @ ( top_top @ ( set @ D ) ) ) @ A3 ) )
        @ ( comp @ A @ B @ D @ F2 ) ) ) ).

% fun.rel_Grp
thf(fact_5134_prod_Orel__Grp,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A13: set @ A,F1: A > C,A23: set @ B,F22: B > D] :
      ( ( basic_rel_prod @ A @ C @ B @ D @ ( bNF_Grp @ A @ C @ A13 @ F1 ) @ ( bNF_Grp @ B @ D @ A23 @ F22 ) )
      = ( bNF_Grp @ ( product_prod @ A @ B ) @ ( product_prod @ C @ D )
        @ ( collect @ ( product_prod @ A @ B )
          @ ^ [X2: product_prod @ A @ B] :
              ( ( ord_less_eq @ ( set @ A ) @ ( basic_fsts @ A @ B @ X2 ) @ A13 )
              & ( ord_less_eq @ ( set @ B ) @ ( basic_snds @ A @ B @ X2 ) @ A23 ) ) )
        @ ( product_map_prod @ A @ C @ B @ D @ F1 @ F22 ) ) ) ).

% prod.rel_Grp
thf(fact_5135_OO__Grp__alt,axiom,
    ! [B: $tType,C: $tType,A: $tType,A3: set @ C,F2: C > A,G: C > B] :
      ( ( relcompp @ A @ C @ B @ ( conversep @ C @ A @ ( bNF_Grp @ C @ A @ A3 @ F2 ) ) @ ( bNF_Grp @ C @ B @ A3 @ G ) )
      = ( ^ [X2: A,Y2: B] :
          ? [Z3: C] :
            ( ( member @ C @ Z3 @ A3 )
            & ( ( F2 @ Z3 )
              = X2 )
            & ( ( G @ Z3 )
              = Y2 ) ) ) ) ).

% OO_Grp_alt
thf(fact_5136_rat_Odomain__par__left__total,axiom,
    ! [P2: ( product_prod @ int @ int ) > $o] :
      ( ( left_total @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int )
        @ ( basic_rel_prod @ int @ int @ int @ int
          @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
          @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 ) ) )
     => ( ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ $o @ $o
          @ ( basic_rel_prod @ int @ int @ int @ int
            @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
            @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 ) )
          @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
          @ P2
          @ ^ [X2: product_prod @ int @ int] : ( ratrel @ X2 @ X2 ) )
       => ( ( domainp @ ( product_prod @ int @ int ) @ rat @ pcr_rat )
          = P2 ) ) ) ).

% rat.domain_par_left_total
thf(fact_5137_list_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [R2: A > B > $o] :
            ( relcompp @ ( list @ A ) @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ B )
            @ ( conversep @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ A )
              @ ( bNF_Grp @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ A )
                @ ( collect @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [X2: list @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set2 @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
                @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) ) ) )
            @ ( bNF_Grp @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ B )
              @ ( collect @ ( list @ ( product_prod @ A @ B ) )
                @ ^ [X2: list @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set2 @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
              @ ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) ) ) ) ) ) ).

% list.rel_compp_Grp
thf(fact_5138_right__total__relcompp__transfer,axiom,
    ! [C: $tType,A: $tType,E: $tType,F10: $tType,B: $tType,D: $tType,B2: A > B > $o,A3: C > D > $o,C3: E > F10 > $o] :
      ( ( right_total @ A @ B @ B2 )
     => ( bNF_rel_fun @ ( C > A > $o ) @ ( D > B > $o ) @ ( ( A > E > $o ) > C > E > $o ) @ ( ( B > F10 > $o ) > D > F10 > $o )
        @ ( bNF_rel_fun @ C @ D @ ( A > $o ) @ ( B > $o ) @ A3
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ B2
            @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) ) )
        @ ( bNF_rel_fun @ ( A > E > $o ) @ ( B > F10 > $o ) @ ( C > E > $o ) @ ( D > F10 > $o )
          @ ( bNF_rel_fun @ A @ B @ ( E > $o ) @ ( F10 > $o ) @ B2
            @ ( bNF_rel_fun @ E @ F10 @ $o @ $o @ C3
              @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) ) )
          @ ( bNF_rel_fun @ C @ D @ ( E > $o ) @ ( F10 > $o ) @ A3
            @ ( bNF_rel_fun @ E @ F10 @ $o @ $o @ C3
              @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) ) ) )
        @ ^ [R2: C > A > $o,S7: A > E > $o,X2: C,Z3: E] :
          ? [Y2: A] :
            ( ( member @ A @ Y2 @ ( collect @ A @ ( domainp @ A @ B @ B2 ) ) )
            & ( R2 @ X2 @ Y2 )
            & ( S7 @ Y2 @ Z3 ) )
        @ ( relcompp @ D @ B @ F10 ) ) ) ).

% right_total_relcompp_transfer
thf(fact_5139_typedef__right__total,axiom,
    ! [B: $tType,A: $tType,Rep: B > A,Abs: A > B,A3: set @ A,T2: A > B > $o] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A3 )
     => ( ( T2
          = ( ^ [X2: A,Y2: B] :
                ( X2
                = ( Rep @ Y2 ) ) ) )
       => ( right_total @ A @ B @ T2 ) ) ) ).

% typedef_right_total
thf(fact_5140_right__total__Collect__transfer,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o] :
      ( ( right_total @ A @ B @ A3 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( set @ A ) @ ( set @ B )
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A3
          @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) )
        @ ( bNF_rel_set @ A @ B @ A3 )
        @ ^ [P3: A > $o] :
            ( collect @ A
            @ ^ [X2: A] :
                ( ( P3 @ X2 )
                & ( domainp @ A @ B @ A3 @ X2 ) ) )
        @ ( collect @ B ) ) ) ).

% right_total_Collect_transfer
thf(fact_5141_right__total__Domainp__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,B2: A > B > $o,A3: C > D > $o] :
      ( ( right_total @ A @ B @ B2 )
     => ( bNF_rel_fun @ ( C > A > $o ) @ ( D > B > $o ) @ ( C > $o ) @ ( D > $o )
        @ ( bNF_rel_fun @ C @ D @ ( A > $o ) @ ( B > $o ) @ A3
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ B2
            @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) ) )
        @ ( bNF_rel_fun @ C @ D @ $o @ $o @ A3
          @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) )
        @ ^ [T7: C > A > $o,X2: C] :
          ? [Y2: A] :
            ( ( member @ A @ Y2 @ ( collect @ A @ ( domainp @ A @ B @ B2 ) ) )
            & ( T7 @ X2 @ Y2 ) )
        @ ( domainp @ D @ B ) ) ) ).

% right_total_Domainp_transfer
thf(fact_5142_right__total__Inter__transfer,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o] :
      ( ( bi_unique @ A @ B @ A3 )
     => ( ( right_total @ A @ B @ A3 )
       => ( bNF_rel_fun @ ( set @ ( set @ A ) ) @ ( set @ ( set @ B ) ) @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A3 ) ) @ ( bNF_rel_set @ A @ B @ A3 )
          @ ^ [S7: set @ ( set @ A )] : ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ S7 ) @ ( collect @ A @ ( domainp @ A @ B @ A3 ) ) )
          @ ( complete_Inf_Inf @ ( set @ B ) ) ) ) ) ).

% right_total_Inter_transfer
thf(fact_5143_vimage__right__total__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,B2: A > B > $o,A3: C > D > $o] :
      ( ( bi_unique @ A @ B @ B2 )
     => ( ( right_total @ C @ D @ A3 )
       => ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( ( set @ A ) > ( set @ C ) ) @ ( ( set @ B ) > ( set @ D ) ) @ ( bNF_rel_fun @ C @ D @ A @ B @ A3 @ B2 ) @ ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( set @ C ) @ ( set @ D ) @ ( bNF_rel_set @ A @ B @ B2 ) @ ( bNF_rel_set @ C @ D @ A3 ) )
          @ ^ [F3: C > A,X7: set @ A] : ( inf_inf @ ( set @ C ) @ ( vimage @ C @ A @ F3 @ X7 ) @ ( collect @ C @ ( domainp @ C @ D @ A3 ) ) )
          @ ( vimage @ D @ B ) ) ) ) ).

% vimage_right_total_transfer
thf(fact_5144_right__total__fun__eq__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A3: A > B > $o,B2: C > D > $o] :
      ( ( right_total @ A @ B @ A3 )
     => ( ( bi_unique @ C @ D @ B2 )
       => ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ ( ( A > C ) > $o ) @ ( ( B > D ) > $o ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B2 )
          @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B2 )
            @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 ) )
          @ ^ [F3: A > C,G2: A > C] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ ( collect @ A @ ( domainp @ A @ B @ A3 ) ) )
             => ( ( F3 @ X2 )
                = ( G2 @ X2 ) ) )
          @ ^ [Y5: B > D,Z5: B > D] : ( Y5 = Z5 ) ) ) ) ).

% right_total_fun_eq_transfer
thf(fact_5145_typedef__bi__unique,axiom,
    ! [B: $tType,A: $tType,Rep: B > A,Abs: A > B,A3: set @ A,T2: A > B > $o] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A3 )
     => ( ( T2
          = ( ^ [X2: A,Y2: B] :
                ( X2
                = ( Rep @ Y2 ) ) ) )
       => ( bi_unique @ A @ B @ T2 ) ) ) ).

% typedef_bi_unique
thf(fact_5146_bi__unique__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bi_unique @ A @ B )
      = ( ^ [R2: A > B > $o] :
            ( ! [Z3: B] :
                ( uniq @ A
                @ ^ [X2: A] : ( R2 @ X2 @ Z3 ) )
            & ! [Z3: A] : ( uniq @ B @ ( R2 @ Z3 ) ) ) ) ) ).

% bi_unique_iff
thf(fact_5147_inter__transfer,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o] :
      ( ( bi_unique @ A @ B @ A3 )
     => ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( ( set @ A ) > ( set @ A ) ) @ ( ( set @ B ) > ( set @ B ) ) @ ( bNF_rel_set @ A @ B @ A3 ) @ ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A3 ) @ ( bNF_rel_set @ A @ B @ A3 ) ) @ ( inf_inf @ ( set @ A ) ) @ ( inf_inf @ ( set @ B ) ) ) ) ).

% inter_transfer
thf(fact_5148_right__total__Compl__transfer,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o] :
      ( ( bi_unique @ A @ B @ A3 )
     => ( ( right_total @ A @ B @ A3 )
       => ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A3 ) @ ( bNF_rel_set @ A @ B @ A3 )
          @ ^ [S7: set @ A] : ( inf_inf @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ S7 ) @ ( collect @ A @ ( domainp @ A @ B @ A3 ) ) )
          @ ( uminus_uminus @ ( set @ B ) ) ) ) ) ).

% right_total_Compl_transfer
thf(fact_5149_Inter__transfer,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o] :
      ( ( bi_unique @ A @ B @ A3 )
     => ( ( bi_total @ A @ B @ A3 )
       => ( bNF_rel_fun @ ( set @ ( set @ A ) ) @ ( set @ ( set @ B ) ) @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A3 ) ) @ ( bNF_rel_set @ A @ B @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) ) @ ( complete_Inf_Inf @ ( set @ B ) ) ) ) ) ).

% Inter_transfer
thf(fact_5150_Abs__rat__cases,axiom,
    ! [X3: rat] :
      ~ ! [Y3: set @ ( product_prod @ int @ int )] :
          ( ( X3
            = ( abs_rat @ Y3 ) )
         => ~ ( member @ ( set @ ( product_prod @ int @ int ) ) @ Y3
              @ ( collect @ ( set @ ( product_prod @ int @ int ) )
                @ ^ [C5: set @ ( product_prod @ int @ int )] :
                  ? [X2: product_prod @ int @ int] :
                    ( ( ratrel @ X2 @ X2 )
                    & ( C5
                      = ( collect @ ( product_prod @ int @ int ) @ ( ratrel @ X2 ) ) ) ) ) ) ) ).

% Abs_rat_cases
thf(fact_5151_Abs__rat__induct,axiom,
    ! [P: rat > $o,X3: rat] :
      ( ! [Y3: set @ ( product_prod @ int @ int )] :
          ( ( member @ ( set @ ( product_prod @ int @ int ) ) @ Y3
            @ ( collect @ ( set @ ( product_prod @ int @ int ) )
              @ ^ [C5: set @ ( product_prod @ int @ int )] :
                ? [X2: product_prod @ int @ int] :
                  ( ( ratrel @ X2 @ X2 )
                  & ( C5
                    = ( collect @ ( product_prod @ int @ int ) @ ( ratrel @ X2 ) ) ) ) ) )
         => ( P @ ( abs_rat @ Y3 ) ) )
     => ( P @ X3 ) ) ).

% Abs_rat_induct
thf(fact_5152_inf__filter__parametric,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o] :
      ( ( bi_unique @ A @ B @ A3 )
     => ( ( bi_total @ A @ B @ A3 )
       => ( bNF_rel_fun @ ( filter @ A ) @ ( filter @ B ) @ ( ( filter @ A ) > ( filter @ A ) ) @ ( ( filter @ B ) > ( filter @ B ) ) @ ( rel_filter @ A @ B @ A3 ) @ ( bNF_rel_fun @ ( filter @ A ) @ ( filter @ B ) @ ( filter @ A ) @ ( filter @ B ) @ ( rel_filter @ A @ B @ A3 ) @ ( rel_filter @ A @ B @ A3 ) ) @ ( inf_inf @ ( filter @ A ) ) @ ( inf_inf @ ( filter @ B ) ) ) ) ) ).

% inf_filter_parametric
thf(fact_5153_Abs__rat__inject,axiom,
    ! [X3: set @ ( product_prod @ int @ int ),Y: set @ ( product_prod @ int @ int )] :
      ( ( member @ ( set @ ( product_prod @ int @ int ) ) @ X3
        @ ( collect @ ( set @ ( product_prod @ int @ int ) )
          @ ^ [C5: set @ ( product_prod @ int @ int )] :
            ? [X2: product_prod @ int @ int] :
              ( ( ratrel @ X2 @ X2 )
              & ( C5
                = ( collect @ ( product_prod @ int @ int ) @ ( ratrel @ X2 ) ) ) ) ) )
     => ( ( member @ ( set @ ( product_prod @ int @ int ) ) @ Y
          @ ( collect @ ( set @ ( product_prod @ int @ int ) )
            @ ^ [C5: set @ ( product_prod @ int @ int )] :
              ? [X2: product_prod @ int @ int] :
                ( ( ratrel @ X2 @ X2 )
                & ( C5
                  = ( collect @ ( product_prod @ int @ int ) @ ( ratrel @ X2 ) ) ) ) ) )
       => ( ( ( abs_rat @ X3 )
            = ( abs_rat @ Y ) )
          = ( X3 = Y ) ) ) ) ).

% Abs_rat_inject
thf(fact_5154_type__definition__rat,axiom,
    ( type_definition @ rat @ ( set @ ( product_prod @ int @ int ) ) @ rep_rat @ abs_rat
    @ ( collect @ ( set @ ( product_prod @ int @ int ) )
      @ ^ [C5: set @ ( product_prod @ int @ int )] :
        ? [X2: product_prod @ int @ int] :
          ( ( ratrel @ X2 @ X2 )
          & ( C5
            = ( collect @ ( product_prod @ int @ int ) @ ( ratrel @ X2 ) ) ) ) ) ) ).

% type_definition_rat
thf(fact_5155_Abs__rat__inverse,axiom,
    ! [Y: set @ ( product_prod @ int @ int )] :
      ( ( member @ ( set @ ( product_prod @ int @ int ) ) @ Y
        @ ( collect @ ( set @ ( product_prod @ int @ int ) )
          @ ^ [C5: set @ ( product_prod @ int @ int )] :
            ? [X2: product_prod @ int @ int] :
              ( ( ratrel @ X2 @ X2 )
              & ( C5
                = ( collect @ ( product_prod @ int @ int ) @ ( ratrel @ X2 ) ) ) ) ) )
     => ( ( rep_rat @ ( abs_rat @ Y ) )
        = Y ) ) ).

% Abs_rat_inverse
thf(fact_5156_Rep__rat__induct,axiom,
    ! [Y: set @ ( product_prod @ int @ int ),P: ( set @ ( product_prod @ int @ int ) ) > $o] :
      ( ( member @ ( set @ ( product_prod @ int @ int ) ) @ Y
        @ ( collect @ ( set @ ( product_prod @ int @ int ) )
          @ ^ [C5: set @ ( product_prod @ int @ int )] :
            ? [X2: product_prod @ int @ int] :
              ( ( ratrel @ X2 @ X2 )
              & ( C5
                = ( collect @ ( product_prod @ int @ int ) @ ( ratrel @ X2 ) ) ) ) ) )
     => ( ! [X: rat] : ( P @ ( rep_rat @ X ) )
       => ( P @ Y ) ) ) ).

% Rep_rat_induct
thf(fact_5157_Rep__rat,axiom,
    ! [X3: rat] :
      ( member @ ( set @ ( product_prod @ int @ int ) ) @ ( rep_rat @ X3 )
      @ ( collect @ ( set @ ( product_prod @ int @ int ) )
        @ ^ [C5: set @ ( product_prod @ int @ int )] :
          ? [X2: product_prod @ int @ int] :
            ( ( ratrel @ X2 @ X2 )
            & ( C5
              = ( collect @ ( product_prod @ int @ int ) @ ( ratrel @ X2 ) ) ) ) ) ) ).

% Rep_rat
thf(fact_5158_Rep__rat__cases,axiom,
    ! [Y: set @ ( product_prod @ int @ int )] :
      ( ( member @ ( set @ ( product_prod @ int @ int ) ) @ Y
        @ ( collect @ ( set @ ( product_prod @ int @ int ) )
          @ ^ [C5: set @ ( product_prod @ int @ int )] :
            ? [X2: product_prod @ int @ int] :
              ( ( ratrel @ X2 @ X2 )
              & ( C5
                = ( collect @ ( product_prod @ int @ int ) @ ( ratrel @ X2 ) ) ) ) ) )
     => ~ ! [X: rat] :
            ( Y
           != ( rep_rat @ X ) ) ) ).

% Rep_rat_cases
thf(fact_5159_type__copy__vimage2p__Grp__Abs,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Rep: A > B,Abs: B > A,G: D > C,P: C > $o,H2: C > A] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( bNF_vimage2p @ D @ C @ B @ A @ $o @ G @ Abs @ ( bNF_Grp @ C @ A @ ( collect @ C @ P ) @ H2 ) )
        = ( bNF_Grp @ D @ B
          @ ( collect @ D
            @ ^ [X2: D] : ( P @ ( G @ X2 ) ) )
          @ ( comp @ C @ B @ D @ ( comp @ A @ B @ C @ Rep @ H2 ) @ G ) ) ) ) ).

% type_copy_vimage2p_Grp_Abs
thf(fact_5160_type__copy__vimage2p__Grp__Rep,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,Rep: A > B,Abs: B > A,F2: C > D,P: D > $o,H2: D > B] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( bNF_vimage2p @ C @ D @ A @ B @ $o @ F2 @ Rep @ ( bNF_Grp @ D @ B @ ( collect @ D @ P ) @ H2 ) )
        = ( bNF_Grp @ C @ A
          @ ( collect @ C
            @ ^ [X2: C] : ( P @ ( F2 @ X2 ) ) )
          @ ( comp @ D @ A @ C @ ( comp @ B @ A @ D @ Abs @ H2 ) @ F2 ) ) ) ) ).

% type_copy_vimage2p_Grp_Rep
thf(fact_5161_sum__mset__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [Y: B,A3: multiset @ A] :
          ( ( comm_m7189776963980413722m_mset @ B
            @ ( image_mset @ A @ B
              @ ^ [X2: A] : Y
              @ A3 ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( multiset @ A ) @ A3 ) ) @ Y ) ) ) ).

% sum_mset_constant
thf(fact_5162_prod__mset__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,A3: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [Uu: B] : C2
              @ A3 ) )
          = ( power_power @ A @ C2 @ ( size_size @ ( multiset @ B ) @ A3 ) ) ) ) ).

% prod_mset_constant
thf(fact_5163_vimage2p__def,axiom,
    ! [B: $tType,E: $tType,C: $tType,D: $tType,A: $tType] :
      ( ( bNF_vimage2p @ A @ D @ B @ E @ C )
      = ( ^ [F3: A > D,G2: B > E,R2: D > E > C,X2: A,Y2: B] : ( R2 @ ( F3 @ X2 ) @ ( G2 @ Y2 ) ) ) ) ).

% vimage2p_def
thf(fact_5164_size__eq__sum__mset,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( multiset @ A ) )
      = ( ^ [M8: multiset @ A] :
            ( comm_m7189776963980413722m_mset @ nat
            @ ( image_mset @ A @ nat
              @ ^ [A5: A] : ( one_one @ nat )
              @ M8 ) ) ) ) ).

% size_eq_sum_mset
thf(fact_5165_image__mset__const__eq,axiom,
    ! [B: $tType,A: $tType,C2: A,M: multiset @ B] :
      ( ( image_mset @ B @ A
        @ ^ [A5: B] : C2
        @ M )
      = ( replicate_mset @ A @ ( size_size @ ( multiset @ B ) @ M ) @ C2 ) ) ).

% image_mset_const_eq
thf(fact_5166_size__multiset__overloaded__def,axiom,
    ! [B: $tType] :
      ( ( size_size @ ( multiset @ B ) )
      = ( size_multiset @ B
        @ ^ [Uu: B] : ( zero_zero @ nat ) ) ) ).

% size_multiset_overloaded_def
thf(fact_5167_size__multiset__overloaded__eq,axiom,
    ! [B: $tType] :
      ( ( size_size @ ( multiset @ B ) )
      = ( ^ [X2: multiset @ B] : ( groups7311177749621191930dd_sum @ B @ nat @ ( count @ B @ X2 ) @ ( set_mset @ B @ X2 ) ) ) ) ).

% size_multiset_overloaded_eq
thf(fact_5168_tl__remdups__adj,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( tl @ A @ ( remdups_adj @ A @ Ys ) )
        = ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X2: A] :
                ( X2
                = ( hd @ A @ Ys ) )
            @ ( tl @ A @ Ys ) ) ) ) ) ).

% tl_remdups_adj
thf(fact_5169_map__upds__fold__map__upd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_upds @ A @ B )
      = ( ^ [M5: A > ( option @ B ),Ks2: list @ A,Vs: list @ B] :
            ( foldl @ ( A > ( option @ B ) ) @ ( product_prod @ A @ B )
            @ ^ [N5: A > ( option @ B )] :
                ( product_case_prod @ A @ B @ ( A > ( option @ B ) )
                @ ^ [K6: A,V2: B] : ( fun_upd @ A @ ( option @ B ) @ N5 @ K6 @ ( some @ B @ V2 ) ) )
            @ M5
            @ ( zip @ A @ B @ Ks2 @ Vs ) ) ) ) ).

% map_upds_fold_map_upd
thf(fact_5170_prod__list__def,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A )
        = ( groups_monoid_F @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod_list_def
thf(fact_5171_monoid__list_OF_Ocong,axiom,
    ! [A: $tType] :
      ( ( groups_monoid_F @ A )
      = ( groups_monoid_F @ A ) ) ).

% monoid_list.F.cong
thf(fact_5172_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs ) )
      = ( cons @ A @ X3
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [Y2: A] : ( Y2 = X3 )
            @ Xs ) ) ) ) ).

% remdups_adj_Cons'
thf(fact_5173_monoid__list_OCons,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,X3: A,Xs: list @ A] :
      ( ( groups_monoid_list @ A @ F2 @ Z2 )
     => ( ( groups_monoid_F @ A @ F2 @ Z2 @ ( cons @ A @ X3 @ Xs ) )
        = ( F2 @ X3 @ ( groups_monoid_F @ A @ F2 @ Z2 @ Xs ) ) ) ) ).

% monoid_list.Cons
thf(fact_5174_monoid__list_ONil,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( groups_monoid_list @ A @ F2 @ Z2 )
     => ( ( groups_monoid_F @ A @ F2 @ Z2 @ ( nil @ A ) )
        = Z2 ) ) ).

% monoid_list.Nil
thf(fact_5175_monoid__list_Oappend,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Xs: list @ A,Ys: list @ A] :
      ( ( groups_monoid_list @ A @ F2 @ Z2 )
     => ( ( groups_monoid_F @ A @ F2 @ Z2 @ ( append @ A @ Xs @ Ys ) )
        = ( F2 @ ( groups_monoid_F @ A @ F2 @ Z2 @ Xs ) @ ( groups_monoid_F @ A @ F2 @ Z2 @ Ys ) ) ) ) ).

% monoid_list.append
thf(fact_5176_remdups__adj__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs ) )
      = ( case_list @ ( list @ A ) @ A @ ( cons @ A @ X3 @ ( nil @ A ) )
        @ ^ [Y2: A,Xs2: list @ A] : ( if @ ( list @ A ) @ ( X3 = Y2 ) @ ( cons @ A @ Y2 @ Xs2 ) @ ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Xs2 ) ) )
        @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_Cons
thf(fact_5177_comm__monoid__list_Orev,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Xs: list @ A] :
      ( ( groups1828464146339083142d_list @ A @ F2 @ Z2 )
     => ( ( groups_monoid_F @ A @ F2 @ Z2 @ ( rev @ A @ Xs ) )
        = ( groups_monoid_F @ A @ F2 @ Z2 @ Xs ) ) ) ).

% comm_monoid_list.rev
thf(fact_5178_monoid__list_Oeq__foldr,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Xs: list @ A] :
      ( ( groups_monoid_list @ A @ F2 @ Z2 )
     => ( ( groups_monoid_F @ A @ F2 @ Z2 @ Xs )
        = ( foldr @ A @ A @ F2 @ Xs @ Z2 ) ) ) ).

% monoid_list.eq_foldr
thf(fact_5179_sum__list__def,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( groups_monoid_F @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_def
thf(fact_5180_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X2: A] : ( X2 = Y )
            @ Ys ) ) ) ) ).

% remdups_adj_append_dropWhile
thf(fact_5181_comm__monoid__list__set_Oset__conv__list,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,G: B > A,Xs: list @ B] :
      ( ( groups4802862169904069756st_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( set2 @ B @ Xs ) )
        = ( groups_monoid_F @ A @ F2 @ Z2 @ ( map @ B @ A @ G @ ( remdups @ B @ Xs ) ) ) ) ) ).

% comm_monoid_list_set.set_conv_list
thf(fact_5182_comm__monoid__list__set_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,Xs: list @ B,G: B > A] :
      ( ( groups4802862169904069756st_set @ A @ F2 @ Z2 )
     => ( ( distinct @ B @ Xs )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( set2 @ B @ Xs ) )
          = ( groups_monoid_F @ A @ F2 @ Z2 @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% comm_monoid_list_set.distinct_set_conv_list
thf(fact_5183_remdups__adj__append_H_H,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( remdups_adj @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( remdups_adj @ A @ Xs )
          @ ( remdups_adj @ A
            @ ( dropWhile @ A
              @ ^ [Y2: A] :
                  ( Y2
                  = ( last @ A @ Xs ) )
              @ Ys ) ) ) ) ) ).

% remdups_adj_append''
thf(fact_5184_comm__monoid__mult__class_Oprod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( groups_comm_monoid_F @ A @ B @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% comm_monoid_mult_class.prod_def
thf(fact_5185_comm__monoid__set_Otriangle__reindex,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ ( product_prod @ nat @ nat ) @ F2 @ Z2 @ ( product_case_prod @ nat @ nat @ A @ G )
          @ ( collect @ ( product_prod @ nat @ nat )
            @ ( product_case_prod @ nat @ nat @ $o
              @ ^ [I2: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J3 ) @ N ) ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [K6: nat] :
              ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
              @ ^ [I2: nat] : ( G @ I2 @ ( minus_minus @ nat @ K6 @ I2 ) )
              @ ( set_ord_atMost @ nat @ K6 ) )
          @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% comm_monoid_set.triangle_reindex
thf(fact_5186_comm__monoid__set_Ozero__middle,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,P5: nat,K: nat,G: nat > A,H2: nat > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P5 )
       => ( ( ord_less_eq @ nat @ K @ P5 )
         => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
              @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ Z2 @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
              @ ( set_ord_atMost @ nat @ P5 ) )
            = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
              @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H2 @ J3 ) )
              @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P5 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% comm_monoid_set.zero_middle
thf(fact_5187_comm__monoid__set_Otriangle__reindex__eq,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ ( product_prod @ nat @ nat ) @ F2 @ Z2 @ ( product_case_prod @ nat @ nat @ A @ G )
          @ ( collect @ ( product_prod @ nat @ nat )
            @ ( product_case_prod @ nat @ nat @ $o
              @ ^ [I2: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ J3 ) @ N ) ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [K6: nat] :
              ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
              @ ^ [I2: nat] : ( G @ I2 @ ( minus_minus @ nat @ K6 @ I2 ) )
              @ ( set_ord_atMost @ nat @ K6 ) )
          @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% comm_monoid_set.triangle_reindex_eq
thf(fact_5188_comm__monoid__set_Oswap,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > A > A,Z2: A,G: B > C > A,B2: set @ C,A3: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
          @ ^ [I2: B] : ( groups_comm_monoid_F @ A @ C @ F2 @ Z2 @ ( G @ I2 ) @ B2 )
          @ A3 )
        = ( groups_comm_monoid_F @ A @ C @ F2 @ Z2
          @ ^ [J3: C] :
              ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
              @ ^ [I2: B] : ( G @ I2 @ J3 )
              @ A3 )
          @ B2 ) ) ) ).

% comm_monoid_set.swap
thf(fact_5189_comm__monoid__set_Odistrib,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,G: B > A,H2: B > A,A3: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
          @ ^ [X2: B] : ( F2 @ ( G @ X2 ) @ ( H2 @ X2 ) )
          @ A3 )
        = ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A3 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ H2 @ A3 ) ) ) ) ).

% comm_monoid_set.distrib
thf(fact_5190_comm__monoid__set_Oneutral__const,axiom,
    ! [B: $tType,A: $tType,F2: A > A > A,Z2: A,A3: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
          @ ^ [Uu: B] : Z2
          @ A3 )
        = Z2 ) ) ).

% comm_monoid_set.neutral_const
thf(fact_5191_comm__monoid__set_Oempty,axiom,
    ! [B: $tType,A: $tType,F2: A > A > A,Z2: A,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( bot_bot @ ( set @ B ) ) )
        = Z2 ) ) ).

% comm_monoid_set.empty
thf(fact_5192_comm__monoid__set_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,I: set @ B,X3: B > A,Y: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B
          @ ( collect @ B
            @ ^ [I2: B] :
                ( ( member @ B @ I2 @ I )
                & ( ( X3 @ I2 )
                 != Z2 ) ) ) )
       => ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [I2: B] :
                  ( ( member @ B @ I2 @ I )
                  & ( ( Y @ I2 )
                   != Z2 ) ) ) )
         => ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [I2: B] :
                  ( ( member @ B @ I2 @ I )
                  & ( ( F2 @ ( X3 @ I2 ) @ ( Y @ I2 ) )
                   != Z2 ) ) ) ) ) ) ) ).

% comm_monoid_set.finite_Collect_op
thf(fact_5193_comm__monoid__set__def,axiom,
    ! [A: $tType] :
      ( ( groups778175481326437816id_set @ A )
      = ( comm_monoid @ A ) ) ).

% comm_monoid_set_def
thf(fact_5194_comm__monoid__set_Oaxioms,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( comm_monoid @ A @ F2 @ Z2 ) ) ).

% comm_monoid_set.axioms
thf(fact_5195_comm__monoid__set_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( comm_monoid @ A @ F2 @ Z2 )
     => ( groups778175481326437816id_set @ A @ F2 @ Z2 ) ) ).

% comm_monoid_set.intro
thf(fact_5196_comm__monoid__list__set_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( groups4802862169904069756st_set @ A @ F2 @ Z2 )
     => ( groups778175481326437816id_set @ A @ F2 @ Z2 ) ) ).

% comm_monoid_list_set.axioms(2)
thf(fact_5197_prod_Ocomm__monoid__set__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( groups778175481326437816id_set @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod.comm_monoid_set_axioms
thf(fact_5198_comm__monoid__set_Odelta,axiom,
    ! [B: $tType,A: $tType,F2: A > A > A,Z2: A,S2: set @ B,A4: B,B3: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ S2 )
       => ( ( ( member @ B @ A4 @ S2 )
           => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
                @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ Z2 )
                @ S2 )
              = ( B3 @ A4 ) ) )
          & ( ~ ( member @ B @ A4 @ S2 )
           => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
                @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ Z2 )
                @ S2 )
              = Z2 ) ) ) ) ) ).

% comm_monoid_set.delta
thf(fact_5199_comm__monoid__set_Odelta_H,axiom,
    ! [B: $tType,A: $tType,F2: A > A > A,Z2: A,S2: set @ B,A4: B,B3: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ S2 )
       => ( ( ( member @ B @ A4 @ S2 )
           => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
                @ ^ [K6: B] : ( if @ A @ ( A4 = K6 ) @ ( B3 @ K6 ) @ Z2 )
                @ S2 )
              = ( B3 @ A4 ) ) )
          & ( ~ ( member @ B @ A4 @ S2 )
           => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
                @ ^ [K6: B] : ( if @ A @ ( A4 = K6 ) @ ( B3 @ K6 ) @ Z2 )
                @ S2 )
              = Z2 ) ) ) ) ) ).

% comm_monoid_set.delta'
thf(fact_5200_comm__monoid__set_Ointer__filter,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,G: B > A,P: B > $o] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ A3 )
                  & ( P @ X2 ) ) ) )
          = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
            @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( G @ X2 ) @ Z2 )
            @ A3 ) ) ) ) ).

% comm_monoid_set.inter_filter
thf(fact_5201_comm__monoid__set_Oswap__restrict,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > A > A,Z2: A,A3: set @ B,B2: set @ C,G: B > C > A,R: B > C > $o] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( finite_finite2 @ C @ B2 )
         => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
              @ ^ [X2: B] :
                  ( groups_comm_monoid_F @ A @ C @ F2 @ Z2 @ ( G @ X2 )
                  @ ( collect @ C
                    @ ^ [Y2: C] :
                        ( ( member @ C @ Y2 @ B2 )
                        & ( R @ X2 @ Y2 ) ) ) )
              @ A3 )
            = ( groups_comm_monoid_F @ A @ C @ F2 @ Z2
              @ ^ [Y2: C] :
                  ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
                  @ ^ [X2: B] : ( G @ X2 @ Y2 )
                  @ ( collect @ B
                    @ ^ [X2: B] :
                        ( ( member @ B @ X2 @ A3 )
                        & ( R @ X2 @ Y2 ) ) ) )
              @ B2 ) ) ) ) ) ).

% comm_monoid_set.swap_restrict
thf(fact_5202_comm__monoid__set_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,M2: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
          @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% comm_monoid_set.shift_bounds_cl_Suc_ivl
thf(fact_5203_comm__monoid__set_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,M2: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
          @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ).

% comm_monoid_set.shift_bounds_Suc_ivl
thf(fact_5204_comm__monoid__set_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,M2: nat,K: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( G @ ( plus_plus @ nat @ I2 @ K ) )
          @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% comm_monoid_set.shift_bounds_cl_nat_ivl
thf(fact_5205_comm__monoid__set_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,M2: nat,K: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( G @ ( plus_plus @ nat @ I2 @ K ) )
          @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ).

% comm_monoid_set.shift_bounds_nat_ivl
thf(fact_5206_comm__monoid__set_Oreindex__bij__betw,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > A > A,Z2: A,H2: B > C,S2: set @ B,T2: set @ C,G: C > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( bij_betw @ B @ C @ H2 @ S2 @ T2 )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
            @ ^ [X2: B] : ( G @ ( H2 @ X2 ) )
            @ S2 )
          = ( groups_comm_monoid_F @ A @ C @ F2 @ Z2 @ G @ T2 ) ) ) ) ).

% comm_monoid_set.reindex_bij_betw
thf(fact_5207_comm__monoid__list__set__def,axiom,
    ! [A: $tType] :
      ( ( groups4802862169904069756st_set @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
            ( ( groups1828464146339083142d_list @ A @ F3 @ Z3 )
            & ( groups778175481326437816id_set @ A @ F3 @ Z3 ) ) ) ) ).

% comm_monoid_list_set_def
thf(fact_5208_comm__monoid__list__set_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( groups1828464146339083142d_list @ A @ F2 @ Z2 )
     => ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
       => ( groups4802862169904069756st_set @ A @ F2 @ Z2 ) ) ) ).

% comm_monoid_list_set.intro
thf(fact_5209_comm__monoid__set_Oimage__gen,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: A > A > A,Z2: A,S2: set @ B,H2: B > A,G: B > C] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ S2 )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ H2 @ S2 )
          = ( groups_comm_monoid_F @ A @ C @ F2 @ Z2
            @ ^ [Y2: C] :
                ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ H2
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member @ B @ X2 @ S2 )
                      & ( ( G @ X2 )
                        = Y2 ) ) ) )
            @ ( image2 @ B @ C @ G @ S2 ) ) ) ) ) ).

% comm_monoid_set.image_gen
thf(fact_5210_comm__monoid__set_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,G: B > A,B2: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) )
          = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
            @ ^ [X2: B] : ( if @ A @ ( member @ B @ X2 @ B2 ) @ ( G @ X2 ) @ Z2 )
            @ A3 ) ) ) ) ).

% comm_monoid_set.inter_restrict
thf(fact_5211_comm__monoid__set_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G
            @ ( minus_minus @ ( set @ B ) @ A3
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( G @ X2 )
                    = Z2 ) ) ) )
          = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A3 ) ) ) ) ).

% comm_monoid_set.setdiff_irrelevant
thf(fact_5212_comm__monoid__set_OSuc__reindex__ivl,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,M2: nat,N: nat,G: nat > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( ord_less_eq @ nat @ M2 @ N )
       => ( ( F2 @ ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) @ ( G @ ( suc @ N ) ) )
          = ( F2 @ ( G @ M2 )
            @ ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ) ) ).

% comm_monoid_set.Suc_reindex_ivl
thf(fact_5213_comm__monoid__set_Oimage__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,G: B > A,A3: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( inj_on @ B @ A @ G @ A3 )
       => ( ( groups_comm_monoid_F @ A @ A @ F2 @ Z2
            @ ^ [X2: A] : X2
            @ ( image2 @ B @ A @ G @ A3 ) )
          = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A3 ) ) ) ) ).

% comm_monoid_set.image_eq
thf(fact_5214_comm__monoid__set_OatMost__Suc__shift,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
        = ( F2 @ ( G @ ( zero_zero @ nat ) )
          @ ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
            @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% comm_monoid_set.atMost_Suc_shift
thf(fact_5215_comm__monoid__set_OatLeastAtMost__rev,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,N: nat,M2: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M2 ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N ) @ I2 ) )
          @ ( set_or1337092689740270186AtMost @ nat @ N @ M2 ) ) ) ) ).

% comm_monoid_set.atLeastAtMost_rev
thf(fact_5216_comm__monoid__set_OlessThan__Suc__shift,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
        = ( F2 @ ( G @ ( zero_zero @ nat ) )
          @ ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
            @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% comm_monoid_set.lessThan_Suc_shift
thf(fact_5217_comm__monoid__set_Ocartesian__product,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: A > A > A,Z2: A,G: B > C > A,B2: set @ C,A3: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
          @ ^ [X2: B] : ( groups_comm_monoid_F @ A @ C @ F2 @ Z2 @ ( G @ X2 ) @ B2 )
          @ A3 )
        = ( groups_comm_monoid_F @ A @ ( product_prod @ B @ C ) @ F2 @ Z2 @ ( product_case_prod @ B @ C @ A @ G )
          @ ( product_Sigma @ B @ C @ A3
            @ ^ [Uu: B] : B2 ) ) ) ) ).

% comm_monoid_set.cartesian_product
thf(fact_5218_comm__monoid__set_Onat__diff__reindex,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ N @ ( suc @ I2 ) ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% comm_monoid_set.nat_diff_reindex
thf(fact_5219_comm__monoid__set_Ounion__inter,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,B2: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( finite_finite2 @ B @ B2 )
         => ( ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) )
            = ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A3 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ B2 ) ) ) ) ) ) ).

% comm_monoid_set.union_inter
thf(fact_5220_comm__monoid__set_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,B2: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( finite_finite2 @ B @ B2 )
         => ( ! [X: B] :
                ( ( member @ B @ X @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) )
               => ( ( G @ X )
                  = Z2 ) )
           => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) )
              = ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A3 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ B2 ) ) ) ) ) ) ) ).

% comm_monoid_set.union_inter_neutral
thf(fact_5221_comm__monoid__set_OInt__Diff,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,G: B > A,B2: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A3 )
          = ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B2 ) ) ) ) ) ) ).

% comm_monoid_set.Int_Diff
thf(fact_5222_comm__monoid__set_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,T2: set @ B,S2: set @ B,H2: B > A,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ T2 )
       => ( ( finite_finite2 @ B @ S2 )
         => ( ! [I4: B] :
                ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ T2 @ S2 ) )
               => ( ( H2 @ I4 )
                  = Z2 ) )
           => ( ! [I4: B] :
                  ( ( member @ B @ I4 @ ( minus_minus @ ( set @ B ) @ S2 @ T2 ) )
                 => ( ( G @ I4 )
                    = Z2 ) )
             => ( ! [X: B] :
                    ( ( member @ B @ X @ ( inf_inf @ ( set @ B ) @ S2 @ T2 ) )
                   => ( ( G @ X )
                      = ( H2 @ X ) ) )
               => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ S2 )
                  = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ H2 @ T2 ) ) ) ) ) ) ) ) ).

% comm_monoid_set.mono_neutral_cong
thf(fact_5223_comm__monoid__set_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: A > A > A,Z2: A,S2: set @ B,T2: set @ C,G: B > C,H2: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ S2 )
       => ( ( finite_finite2 @ C @ T2 )
         => ( ( ord_less_eq @ ( set @ C ) @ ( image2 @ B @ C @ G @ S2 ) @ T2 )
           => ( ( groups_comm_monoid_F @ A @ C @ F2 @ Z2
                @ ^ [Y2: C] :
                    ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ H2
                    @ ( collect @ B
                      @ ^ [X2: B] :
                          ( ( member @ B @ X2 @ S2 )
                          & ( ( G @ X2 )
                            = Y2 ) ) ) )
                @ T2 )
              = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ H2 @ S2 ) ) ) ) ) ) ).

% comm_monoid_set.group
thf(fact_5224_comm__monoid__set_OatLeastLessThan__rev,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,N: nat,M2: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M2 ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N ) @ ( suc @ I2 ) ) )
          @ ( set_or7035219750837199246ssThan @ nat @ N @ M2 ) ) ) ) ).

% comm_monoid_set.atLeastLessThan_rev
thf(fact_5225_comm__monoid__set_OSigma,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,B2: B > ( set @ C ),G: B > C > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ! [X: B] :
              ( ( member @ B @ X @ A3 )
             => ( finite_finite2 @ C @ ( B2 @ X ) ) )
         => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
              @ ^ [X2: B] : ( groups_comm_monoid_F @ A @ C @ F2 @ Z2 @ ( G @ X2 ) @ ( B2 @ X2 ) )
              @ A3 )
            = ( groups_comm_monoid_F @ A @ ( product_prod @ B @ C ) @ F2 @ Z2 @ ( product_case_prod @ B @ C @ A @ G ) @ ( product_Sigma @ B @ C @ A3 @ B2 ) ) ) ) ) ) ).

% comm_monoid_set.Sigma
thf(fact_5226_comm__monoid__set_Onested__swap,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,A4: nat > nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ ( A4 @ I2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I2 ) )
          @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [J3: nat] :
              ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
              @ ^ [I2: nat] : ( A4 @ I2 @ J3 )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% comm_monoid_set.nested_swap
thf(fact_5227_comm__monoid__set_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > A > A,Z2: A,S4: set @ B,T4: set @ C,H2: B > C,S2: set @ B,T2: set @ C,G: C > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ S4 )
       => ( ( finite_finite2 @ C @ T4 )
         => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) @ ( minus_minus @ ( set @ C ) @ T2 @ T4 ) )
           => ( ! [A7: B] :
                  ( ( member @ B @ A7 @ S4 )
                 => ( ( G @ ( H2 @ A7 ) )
                    = Z2 ) )
             => ( ! [B6: C] :
                    ( ( member @ C @ B6 @ T4 )
                   => ( ( G @ B6 )
                      = Z2 ) )
               => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
                    @ ^ [X2: B] : ( G @ ( H2 @ X2 ) )
                    @ S2 )
                  = ( groups_comm_monoid_F @ A @ C @ F2 @ Z2 @ G @ T2 ) ) ) ) ) ) ) ) ).

% comm_monoid_set.reindex_bij_betw_not_neutral
thf(fact_5228_comm__monoid__set_OIf__cases,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,P: B > $o,H2: B > A,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
            @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( H2 @ X2 ) @ ( G @ X2 ) )
            @ A3 )
          = ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ H2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% comm_monoid_set.If_cases
thf(fact_5229_comm__monoid__set_OatLeast1__atMost__eq,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [K6: nat] : ( G @ ( suc @ K6 ) )
          @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% comm_monoid_set.atLeast1_atMost_eq
thf(fact_5230_comm__monoid__set_OatMost__shift,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_ord_atMost @ nat @ N ) )
        = ( F2 @ ( G @ ( zero_zero @ nat ) )
          @ ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
            @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% comm_monoid_set.atMost_shift
thf(fact_5231_comm__monoid__set_Onat__group,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,K: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [M5: nat] : ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M5 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M5 @ K ) @ K ) ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% comm_monoid_set.nat_group
thf(fact_5232_comm__monoid__set_Onested__swap_H,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,A4: nat > nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ ( A4 @ I2 ) @ ( set_ord_lessThan @ nat @ I2 ) )
          @ ( set_ord_atMost @ nat @ N ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [J3: nat] :
              ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
              @ ^ [I2: nat] : ( A4 @ I2 @ J3 )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
          @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% comm_monoid_set.nested_swap'
thf(fact_5233_comm__monoid__set_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,G: B > A,X3: B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( insert @ B @ X3 @ A3 ) )
          = ( F2 @ ( G @ X3 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% comm_monoid_set.insert_remove
thf(fact_5234_comm__monoid__set_Oremove,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,X3: B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( member @ B @ X3 @ A3 )
         => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A3 )
            = ( F2 @ ( G @ X3 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% comm_monoid_set.remove
thf(fact_5235_comm__monoid__set_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,B2: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( finite_finite2 @ B @ B2 )
         => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B2 )
              = ( bot_bot @ ( set @ B ) ) )
           => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) )
              = ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A3 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ B2 ) ) ) ) ) ) ) ).

% comm_monoid_set.union_disjoint
thf(fact_5236_comm__monoid__set_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A3: set @ B,B2: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ A3 )
       => ( ( finite_finite2 @ B @ B2 )
         => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) )
            = ( F2 @ ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B2 ) ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ B2 @ A3 ) ) ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B2 ) ) ) ) ) ) ) ).

% comm_monoid_set.union_diff2
thf(fact_5237_comm__monoid__set_Odelta__remove,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,S2: set @ B,A4: B,B3: B > A,C2: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ S2 )
       => ( ( ( member @ B @ A4 @ S2 )
           => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
                @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ ( C2 @ K6 ) )
                @ S2 )
              = ( F2 @ ( B3 @ A4 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
          & ( ~ ( member @ B @ A4 @ S2 )
           => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
                @ ^ [K6: B] : ( if @ A @ ( K6 = A4 ) @ ( B3 @ K6 ) @ ( C2 @ K6 ) )
                @ S2 )
              = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% comm_monoid_set.delta_remove
thf(fact_5238_comm__monoid__set_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,N: nat,M2: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M2 ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N ) @ I2 ) )
          @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M2 ) ) ) ) ).

% comm_monoid_set.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_5239_comm__monoid__set_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,M2: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ( comp @ nat @ A @ nat @ G
            @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
          @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% comm_monoid_set.atLeast_atMost_pred_shift
thf(fact_5240_comm__monoid__set_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,M2: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ( comp @ nat @ A @ nat @ G
            @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
          @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M2 ) @ ( suc @ N ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ).

% comm_monoid_set.atLeast_lessThan_pred_shift
thf(fact_5241_comm__monoid__set_Oin__pairs,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,M2: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( F2 @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
          @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% comm_monoid_set.in_pairs
thf(fact_5242_comm__monoid__set_OUNION__disjoint,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: A > A > A,Z2: A,I: set @ B,A3: B > ( set @ C ),G: C > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ I )
       => ( ! [X: B] :
              ( ( member @ B @ X @ I )
             => ( finite_finite2 @ C @ ( A3 @ X ) ) )
         => ( ! [X: B] :
                ( ( member @ B @ X @ I )
               => ! [Xa2: B] :
                    ( ( member @ B @ Xa2 @ I )
                   => ( ( X != Xa2 )
                     => ( ( inf_inf @ ( set @ C ) @ ( A3 @ X ) @ ( A3 @ Xa2 ) )
                        = ( bot_bot @ ( set @ C ) ) ) ) ) )
           => ( ( groups_comm_monoid_F @ A @ C @ F2 @ Z2 @ G @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A3 @ I ) ) )
              = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
                @ ^ [X2: B] : ( groups_comm_monoid_F @ A @ C @ F2 @ Z2 @ G @ ( A3 @ X2 ) )
                @ I ) ) ) ) ) ) ).

% comm_monoid_set.UNION_disjoint
thf(fact_5243_comm__monoid__set_Oin__pairs__0,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,G: nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
          @ ^ [I2: nat] : ( F2 @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
          @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% comm_monoid_set.in_pairs_0
thf(fact_5244_comm__monoid__set_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,C3: set @ ( set @ B ),G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ! [X: set @ B] :
            ( ( member @ ( set @ B ) @ X @ C3 )
           => ( finite_finite2 @ B @ X ) )
       => ( ! [X: set @ B] :
              ( ( member @ ( set @ B ) @ X @ C3 )
             => ! [Xa2: set @ B] :
                  ( ( member @ ( set @ B ) @ Xa2 @ C3 )
                 => ( ( X != Xa2 )
                   => ( ( inf_inf @ ( set @ B ) @ X @ Xa2 )
                      = ( bot_bot @ ( set @ B ) ) ) ) ) )
         => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( complete_Sup_Sup @ ( set @ B ) @ C3 ) )
            = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups_comm_monoid_F @ A @ ( set @ B ) @ F2 @ Z2 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 ) @ G @ C3 ) ) ) ) ) ).

% comm_monoid_set.Union_disjoint
thf(fact_5245_insort__insert__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ~ ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( linord329482645794927042rt_key @ A @ A
              @ ^ [X2: A] : X2
              @ X3
              @ Xs )
            = ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X3
              @ Xs ) ) ) ) ).

% insort_insert_insort
thf(fact_5246_Quotient__multiset,axiom,
    ! [A: $tType] :
      ( quotient @ ( A > nat ) @ ( multiset @ A )
      @ ( bNF_eq_onp @ ( A > nat )
        @ ^ [F3: A > nat] :
            ( finite_finite2 @ A
            @ ( collect @ A
              @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
      @ ( abs_multiset @ A )
      @ ( count @ A )
      @ ( cr_multiset @ A ) ) ).

% Quotient_multiset
thf(fact_5247_sorted__insort__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,X3: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linord329482645794927042rt_key @ A @ A
              @ ^ [X2: A] : X2
              @ X3
              @ Xs ) ) ) ) ).

% sorted_insort_insert
thf(fact_5248_QuotientI,axiom,
    ! [A: $tType,B: $tType,Abs: B > A,Rep: A > B,R: B > B > $o,T2: B > A > $o] :
      ( ! [A7: A] :
          ( ( Abs @ ( Rep @ A7 ) )
          = A7 )
     => ( ! [A7: A] : ( R @ ( Rep @ A7 ) @ ( Rep @ A7 ) )
       => ( ! [R4: B,S9: B] :
              ( ( R @ R4 @ S9 )
              = ( ( R @ R4 @ R4 )
                & ( R @ S9 @ S9 )
                & ( ( Abs @ R4 )
                  = ( Abs @ S9 ) ) ) )
         => ( ( T2
              = ( ^ [X2: B,Y2: A] :
                    ( ( R @ X2 @ X2 )
                    & ( ( Abs @ X2 )
                      = Y2 ) ) ) )
           => ( quotient @ B @ A @ R @ Abs @ Rep @ T2 ) ) ) ) ) ).

% QuotientI
thf(fact_5249_Quotient__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( quotient @ A @ B )
      = ( ^ [R2: A > A > $o,Abs2: A > B,Rep2: B > A,T7: A > B > $o] :
            ( ! [A5: B] :
                ( ( Abs2 @ ( Rep2 @ A5 ) )
                = A5 )
            & ! [A5: B] : ( R2 @ ( Rep2 @ A5 ) @ ( Rep2 @ A5 ) )
            & ! [R3: A,S: A] :
                ( ( R2 @ R3 @ S )
                = ( ( R2 @ R3 @ R3 )
                  & ( R2 @ S @ S )
                  & ( ( Abs2 @ R3 )
                    = ( Abs2 @ S ) ) ) )
            & ( T7
              = ( ^ [X2: A,Y2: B] :
                    ( ( R2 @ X2 @ X2 )
                    & ( ( Abs2 @ X2 )
                      = Y2 ) ) ) ) ) ) ) ).

% Quotient_def
thf(fact_5250_Quotient__cr__rel,axiom,
    ! [B: $tType,A: $tType,R: A > A > $o,Abs: A > B,Rep: B > A,T2: A > B > $o] :
      ( ( quotient @ A @ B @ R @ Abs @ Rep @ T2 )
     => ( T2
        = ( ^ [X2: A,Y2: B] :
              ( ( R @ X2 @ X2 )
              & ( ( Abs @ X2 )
                = Y2 ) ) ) ) ) ).

% Quotient_cr_rel
thf(fact_5251_UNIV__typedef__to__Quotient,axiom,
    ! [A: $tType,B: $tType,Rep: A > B,Abs: B > A,T2: B > A > $o] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( T2
          = ( ^ [X2: B,Y2: A] :
                ( X2
                = ( Rep @ Y2 ) ) ) )
       => ( quotient @ B @ A
          @ ^ [Y5: B,Z5: B] : ( Y5 = Z5 )
          @ Abs
          @ Rep
          @ T2 ) ) ) ).

% UNIV_typedef_to_Quotient
thf(fact_5252_open__typedef__to__Quotient,axiom,
    ! [A: $tType,B: $tType,Rep: A > B,Abs: B > A,P: B > $o,T2: B > A > $o] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( collect @ B @ P ) )
     => ( ( T2
          = ( ^ [X2: B,Y2: A] :
                ( X2
                = ( Rep @ Y2 ) ) ) )
       => ( quotient @ B @ A @ ( bNF_eq_onp @ B @ P ) @ Abs @ Rep @ T2 ) ) ) ).

% open_typedef_to_Quotient
thf(fact_5253_typedef__to__Quotient,axiom,
    ! [A: $tType,B: $tType,Rep: A > B,Abs: B > A,S2: set @ B,T2: B > A > $o] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ S2 )
     => ( ( T2
          = ( ^ [X2: B,Y2: A] :
                ( X2
                = ( Rep @ Y2 ) ) ) )
       => ( quotient @ B @ A
          @ ( bNF_eq_onp @ B
            @ ^ [X2: B] : ( member @ B @ X2 @ S2 ) )
          @ Abs
          @ Rep
          @ T2 ) ) ) ).

% typedef_to_Quotient
thf(fact_5254_insort__insert__triv,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( linord329482645794927042rt_key @ A @ A
              @ ^ [X2: A] : X2
              @ X3
              @ Xs )
            = Xs ) ) ) ).

% insort_insert_triv
thf(fact_5255_cr__multiset__def,axiom,
    ! [A: $tType] :
      ( ( cr_multiset @ A )
      = ( ^ [X2: A > nat,Y2: multiset @ A] :
            ( X2
            = ( count @ A @ Y2 ) ) ) ) ).

% cr_multiset_def
thf(fact_5256_set__insort__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( set2 @ A
            @ ( linord329482645794927042rt_key @ A @ A
              @ ^ [X2: A] : X2
              @ X3
              @ Xs ) )
          = ( insert @ A @ X3 @ ( set2 @ A @ Xs ) ) ) ) ).

% set_insort_insert
thf(fact_5257_Quotient__eq__onp__typedef,axiom,
    ! [B: $tType,A: $tType,P: A > $o,Abs: A > B,Rep: B > A,Cr: A > B > $o] :
      ( ( quotient @ A @ B @ ( bNF_eq_onp @ A @ P ) @ Abs @ Rep @ Cr )
     => ( type_definition @ B @ A @ Rep @ Abs @ ( collect @ A @ P ) ) ) ).

% Quotient_eq_onp_typedef
thf(fact_5258_Quotient__crel__typedef,axiom,
    ! [B: $tType,A: $tType,P: A > $o,Abs: A > B,Rep: B > A,T2: A > B > $o] :
      ( ( quotient @ A @ B @ ( bNF_eq_onp @ A @ P ) @ Abs @ Rep @ T2 )
     => ( T2
        = ( ^ [X2: A,Y2: B] :
              ( X2
              = ( Rep @ Y2 ) ) ) ) ) ).

% Quotient_crel_typedef
thf(fact_5259_Quotient__crel__typecopy,axiom,
    ! [B: $tType,A: $tType,Abs: A > B,Rep: B > A,T2: A > B > $o] :
      ( ( quotient @ A @ B
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
        @ Abs
        @ Rep
        @ T2 )
     => ( T2
        = ( ^ [X2: A,Y2: B] :
              ( X2
              = ( Rep @ Y2 ) ) ) ) ) ).

% Quotient_crel_typecopy
thf(fact_5260_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( subseqs @ A @ ( cons @ A @ X3 @ Xs ) )
      = ( append @ ( list @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( subseqs @ A @ Xs ) ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs.simps(2)
thf(fact_5261_sort__quicksort__by__rel,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_sort_key @ A @ A
          @ ^ [X2: A] : X2 )
        = ( quicksort_by_rel @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ) ).

% sort_quicksort_by_rel
thf(fact_5262_Powp__Pow__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( powp @ A
        @ ^ [X2: A] : ( member @ A @ X2 @ A3 ) )
      = ( ^ [X2: set @ A] : ( member @ ( set @ A ) @ X2 @ ( pow @ A @ A3 ) ) ) ) ).

% Powp_Pow_eq
thf(fact_5263_Powp__def,axiom,
    ! [A: $tType] :
      ( ( powp @ A )
      = ( ^ [A6: A > $o,B5: set @ A] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ B5 )
           => ( A6 @ X2 ) ) ) ) ).

% Powp_def
thf(fact_5264_quicksort__by__rel_Oelims,axiom,
    ! [A: $tType,X3: A > A > $o,Xa: list @ A,Xb: list @ A,Y: list @ A] :
      ( ( ( quicksort_by_rel @ A @ X3 @ Xa @ Xb )
        = Y )
     => ( ( ( Xb
            = ( nil @ A ) )
         => ( Y != Xa ) )
       => ~ ! [X: A,Xs3: list @ A] :
              ( ( Xb
                = ( cons @ A @ X @ Xs3 ) )
             => ( Y
               != ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
                  @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ X3 @ ( cons @ A @ X @ ( quicksort_by_rel @ A @ X3 @ Xa @ Xs_b ) ) @ Xs_s )
                  @ ( partition_rev @ A
                    @ ^ [Y2: A] : ( X3 @ Y2 @ X )
                    @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                    @ Xs3 ) ) ) ) ) ) ).

% quicksort_by_rel.elims
thf(fact_5265_quicksort__by__rel_Osimps_I2_J,axiom,
    ! [A: $tType,R: A > A > $o,Sl: list @ A,X3: A,Xs: list @ A] :
      ( ( quicksort_by_rel @ A @ R @ Sl @ ( cons @ A @ X3 @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
        @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ R @ ( cons @ A @ X3 @ ( quicksort_by_rel @ A @ R @ Sl @ Xs_b ) ) @ Xs_s )
        @ ( partition_rev @ A
          @ ^ [Y2: A] : ( R @ Y2 @ X3 )
          @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
          @ Xs ) ) ) ).

% quicksort_by_rel.simps(2)
thf(fact_5266_quicksort__by__rel_Opsimps_I2_J,axiom,
    ! [A: $tType,R: A > A > $o,Sl: list @ A,X3: A,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl @ ( cons @ A @ X3 @ Xs ) ) ) )
     => ( ( quicksort_by_rel @ A @ R @ Sl @ ( cons @ A @ X3 @ Xs ) )
        = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
          @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ R @ ( cons @ A @ X3 @ ( quicksort_by_rel @ A @ R @ Sl @ Xs_b ) ) @ Xs_s )
          @ ( partition_rev @ A
            @ ^ [Y2: A] : ( R @ Y2 @ X3 )
            @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
            @ Xs ) ) ) ) ).

% quicksort_by_rel.psimps(2)
thf(fact_5267_quicksort__by__rel_Opelims,axiom,
    ! [A: $tType,X3: A > A > $o,Xa: list @ A,Xb: list @ A,Y: list @ A] :
      ( ( ( quicksort_by_rel @ A @ X3 @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X3 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ Xb ) ) )
       => ( ( ( Xb
              = ( nil @ A ) )
           => ( ( Y = Xa )
             => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X3 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ ( nil @ A ) ) ) ) ) )
         => ~ ! [X: A,Xs3: list @ A] :
                ( ( Xb
                  = ( cons @ A @ X @ Xs3 ) )
               => ( ( Y
                    = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
                      @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ X3 @ ( cons @ A @ X @ ( quicksort_by_rel @ A @ X3 @ Xa @ Xs_b ) ) @ Xs_s )
                      @ ( partition_rev @ A
                        @ ^ [Y2: A] : ( X3 @ Y2 @ X )
                        @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                        @ Xs3 ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X3 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ ( cons @ A @ X @ Xs3 ) ) ) ) ) ) ) ) ) ).

% quicksort_by_rel.pelims
thf(fact_5268_quicksort__by__rel_Opinduct,axiom,
    ! [A: $tType,A0: A > A > $o,A14: list @ A,A24: list @ A,P: ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ A0 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A14 @ A24 ) ) )
     => ( ! [R9: A > A > $o,Sl2: list @ A] :
            ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R9 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl2 @ ( nil @ A ) ) ) )
           => ( P @ R9 @ Sl2 @ ( nil @ A ) ) )
       => ( ! [R9: A > A > $o,Sl2: list @ A,X: A,Xs3: list @ A] :
              ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R9 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl2 @ ( cons @ A @ X @ Xs3 ) ) ) )
             => ( ! [Xa3: product_prod @ ( list @ A ) @ ( list @ A ),Xb2: list @ A,Y7: list @ A] :
                    ( ( Xa3
                      = ( partition_rev @ A
                        @ ^ [Z3: A] : ( R9 @ Z3 @ X )
                        @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                        @ Xs3 ) )
                   => ( ( ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xb2 @ Y7 )
                        = Xa3 )
                     => ( P @ R9 @ Sl2 @ Y7 ) ) )
               => ( ! [Xa3: product_prod @ ( list @ A ) @ ( list @ A ),Xb2: list @ A,Y7: list @ A] :
                      ( ( Xa3
                        = ( partition_rev @ A
                          @ ^ [Z3: A] : ( R9 @ Z3 @ X )
                          @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                          @ Xs3 ) )
                     => ( ( ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xb2 @ Y7 )
                          = Xa3 )
                       => ( P @ R9 @ ( cons @ A @ X @ ( quicksort_by_rel @ A @ R9 @ Sl2 @ Y7 ) ) @ Xb2 ) ) )
                 => ( P @ R9 @ Sl2 @ ( cons @ A @ X @ Xs3 ) ) ) ) )
         => ( P @ A0 @ A14 @ A24 ) ) ) ) ).

% quicksort_by_rel.pinduct
thf(fact_5269_arg__min__list_Opelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X3: A > B,Xa: list @ A,Y: A] :
          ( ( ( arg_min_list @ A @ B @ X3 @ Xa )
            = Y )
         => ( ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X3 @ Xa ) )
           => ( ! [X: A] :
                  ( ( Xa
                    = ( cons @ A @ X @ ( nil @ A ) ) )
                 => ( ( Y = X )
                   => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X3 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ) )
             => ( ! [X: A,Y3: A,Zs3: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ X @ ( cons @ A @ Y3 @ Zs3 ) ) )
                   => ( ( Y
                        = ( if @ A @ ( ord_less_eq @ B @ ( X3 @ X ) @ ( X3 @ ( arg_min_list @ A @ B @ X3 @ ( cons @ A @ Y3 @ Zs3 ) ) ) ) @ X @ ( arg_min_list @ A @ B @ X3 @ ( cons @ A @ Y3 @ Zs3 ) ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X3 @ ( cons @ A @ X @ ( cons @ A @ Y3 @ Zs3 ) ) ) ) ) )
               => ~ ( ( Xa
                      = ( nil @ A ) )
                   => ( ( Y
                        = ( undefined @ A ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X3 @ ( nil @ A ) ) ) ) ) ) ) ) ) ) ).

% arg_min_list.pelims
thf(fact_5270_product__swap,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,B2: set @ A] :
      ( ( image2 @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A )
        @ ( product_Sigma @ B @ A @ A3
          @ ^ [Uu: B] : B2 ) )
      = ( product_Sigma @ A @ B @ B2
        @ ^ [Uu: A] : A3 ) ) ).

% product_swap
thf(fact_5271_MOST__INFM,axiom,
    ! [A: $tType,P: A > $o] :
      ( ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( eventually @ A @ P @ ( cofinite @ A ) )
       => ( frequently @ A @ P @ ( cofinite @ A ) ) ) ) ).

% MOST_INFM
thf(fact_5272_frequently__const,axiom,
    ! [A: $tType,F: filter @ A,P: $o] :
      ( ( F
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( frequently @ A
          @ ^ [X2: A] : P
          @ F )
        = P ) ) ).

% frequently_const
thf(fact_5273_case__swap,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: C > B > A,P5: product_prod @ C @ B] :
      ( ( product_case_prod @ B @ C @ A
        @ ^ [Y2: B,X2: C] : ( F2 @ X2 @ Y2 )
        @ ( product_swap @ C @ B @ P5 ) )
      = ( product_case_prod @ C @ B @ A @ F2 @ P5 ) ) ).

% case_swap
thf(fact_5274_not__INFM,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( ~ ( frequently @ A @ P @ ( cofinite @ A ) ) )
      = ( eventually @ A
        @ ^ [X2: A] :
            ~ ( P @ X2 )
        @ ( cofinite @ A ) ) ) ).

% not_INFM
thf(fact_5275_not__MOST,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( ~ ( eventually @ A @ P @ ( cofinite @ A ) ) )
      = ( frequently @ A
        @ ^ [X2: A] :
            ~ ( P @ X2 )
        @ ( cofinite @ A ) ) ) ).

% not_MOST
thf(fact_5276_INFM__const,axiom,
    ! [A: $tType,P: $o] :
      ( ( frequently @ A
        @ ^ [X2: A] : P
        @ ( cofinite @ A ) )
      = ( P
        & ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% INFM_const
thf(fact_5277_INFM__neq_I1_J,axiom,
    ! [A: $tType,A4: A] :
      ( ( frequently @ A
        @ ^ [X2: A] : ( X2 != A4 )
        @ ( cofinite @ A ) )
      = ( ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% INFM_neq(1)
thf(fact_5278_INFM__neq_I2_J,axiom,
    ! [A: $tType,A4: A] :
      ( ( frequently @ A
        @ ^ [X2: A] : ( A4 != X2 )
        @ ( cofinite @ A ) )
      = ( ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% INFM_neq(2)
thf(fact_5279_frequently__const__iff,axiom,
    ! [A: $tType,P: $o,F: filter @ A] :
      ( ( frequently @ A
        @ ^ [X2: A] : P
        @ F )
      = ( P
        & ( F
         != ( bot_bot @ ( filter @ A ) ) ) ) ) ).

% frequently_const_iff
thf(fact_5280_frequently__all,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,F: filter @ A] :
      ( ( frequently @ A
        @ ^ [X2: A] :
          ! [X7: B] : ( P @ X2 @ X7 )
        @ F )
      = ( ! [Y9: A > B] :
            ( frequently @ A
            @ ^ [X2: A] : ( P @ X2 @ ( Y9 @ X2 ) )
            @ F ) ) ) ).

% frequently_all
thf(fact_5281_not__frequently__False,axiom,
    ! [A: $tType,F: filter @ A] :
      ~ ( frequently @ A
        @ ^ [X2: A] : $false
        @ F ) ).

% not_frequently_False
thf(fact_5282_frequently__disj__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,F: filter @ A] :
      ( ( frequently @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
            | ( Q @ X2 ) )
        @ F )
      = ( ( frequently @ A @ P @ F )
        | ( frequently @ A @ Q @ F ) ) ) ).

% frequently_disj_iff
thf(fact_5283_frequently__elim1,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A,Q: A > $o] :
      ( ( frequently @ A @ P @ F )
     => ( ! [I4: A] :
            ( ( P @ I4 )
           => ( Q @ I4 ) )
       => ( frequently @ A @ Q @ F ) ) ) ).

% frequently_elim1
thf(fact_5284_frequently__disj,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A,Q: A > $o] :
      ( ( frequently @ A @ P @ F )
     => ( ( frequently @ A @ Q @ F )
       => ( frequently @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
              | ( Q @ X2 ) )
          @ F ) ) ) ).

% frequently_disj
thf(fact_5285_frequently__ex,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A] :
      ( ( frequently @ A @ P @ F )
     => ? [X_1: A] : ( P @ X_1 ) ) ).

% frequently_ex
thf(fact_5286_eventually__frequently__const__simps_I1_J,axiom,
    ! [A: $tType,P: A > $o,C3: $o,F: filter @ A] :
      ( ( frequently @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
            & C3 )
        @ F )
      = ( ( frequently @ A @ P @ F )
        & C3 ) ) ).

% eventually_frequently_const_simps(1)
thf(fact_5287_eventually__frequently__const__simps_I2_J,axiom,
    ! [A: $tType,C3: $o,P: A > $o,F: filter @ A] :
      ( ( frequently @ A
        @ ^ [X2: A] :
            ( C3
            & ( P @ X2 ) )
        @ F )
      = ( C3
        & ( frequently @ A @ P @ F ) ) ) ).

% eventually_frequently_const_simps(2)
thf(fact_5288_eventually__frequently__const__simps_I5_J,axiom,
    ! [A: $tType,P: A > $o,C3: $o,F: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
           => C3 )
        @ F )
      = ( ( frequently @ A @ P @ F )
       => C3 ) ) ).

% eventually_frequently_const_simps(5)
thf(fact_5289_frequently__mp,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,F: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
           => ( Q @ X2 ) )
        @ F )
     => ( ( frequently @ A @ P @ F )
       => ( frequently @ A @ Q @ F ) ) ) ).

% frequently_mp
thf(fact_5290_frequently__def,axiom,
    ! [A: $tType] :
      ( ( frequently @ A )
      = ( ^ [P3: A > $o,F5: filter @ A] :
            ~ ( eventually @ A
              @ ^ [X2: A] :
                  ~ ( P3 @ X2 )
              @ F5 ) ) ) ).

% frequently_def
thf(fact_5291_not__eventually,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A] :
      ( ( ~ ( eventually @ A @ P @ F ) )
      = ( frequently @ A
        @ ^ [X2: A] :
            ~ ( P @ X2 )
        @ F ) ) ).

% not_eventually
thf(fact_5292_not__frequently,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A] :
      ( ( ~ ( frequently @ A @ P @ F ) )
      = ( eventually @ A
        @ ^ [X2: A] :
            ~ ( P @ X2 )
        @ F ) ) ).

% not_frequently
thf(fact_5293_frequently__rev__mp,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A,Q: A > $o] :
      ( ( frequently @ A @ P @ F )
     => ( ( eventually @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
             => ( Q @ X2 ) )
          @ F )
       => ( frequently @ A @ Q @ F ) ) ) ).

% frequently_rev_mp
thf(fact_5294_frequently__imp__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,F: filter @ A] :
      ( ( frequently @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
           => ( Q @ X2 ) )
        @ F )
      = ( ( eventually @ A @ P @ F )
       => ( frequently @ A @ Q @ F ) ) ) ).

% frequently_imp_iff
thf(fact_5295_INFM__disj__distrib,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( frequently @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
            | ( Q @ X2 ) )
        @ ( cofinite @ A ) )
      = ( ( frequently @ A @ P @ ( cofinite @ A ) )
        | ( frequently @ A @ Q @ ( cofinite @ A ) ) ) ) ).

% INFM_disj_distrib
thf(fact_5296_INFM__mono,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( frequently @ A @ P @ ( cofinite @ A ) )
     => ( ! [X: A] :
            ( ( P @ X )
           => ( Q @ X ) )
       => ( frequently @ A @ Q @ ( cofinite @ A ) ) ) ) ).

% INFM_mono
thf(fact_5297_INFM__EX,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( frequently @ A @ P @ ( cofinite @ A ) )
     => ? [X_1: A] : ( P @ X_1 ) ) ).

% INFM_EX
thf(fact_5298_INFM__E,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( frequently @ A @ P @ ( cofinite @ A ) )
     => ~ ! [X: A] :
            ~ ( P @ X ) ) ).

% INFM_E
thf(fact_5299_not__INFM__eq_I1_J,axiom,
    ! [A: $tType,A4: A] :
      ~ ( frequently @ A
        @ ^ [X2: A] : ( X2 = A4 )
        @ ( cofinite @ A ) ) ).

% not_INFM_eq(1)
thf(fact_5300_not__INFM__eq_I2_J,axiom,
    ! [A: $tType,A4: A] :
      ~ ( frequently @ A
        @ ( ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
          @ A4 )
        @ ( cofinite @ A ) ) ).

% not_INFM_eq(2)
thf(fact_5301_eventually__frequently,axiom,
    ! [A: $tType,F: filter @ A,P: A > $o] :
      ( ( F
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ A @ P @ F )
       => ( frequently @ A @ P @ F ) ) ) ).

% eventually_frequently
thf(fact_5302_frequently__bex__finite__distrib,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,P: B > A > $o,F: filter @ B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( frequently @ B
          @ ^ [X2: B] :
            ? [Y2: A] :
              ( ( member @ A @ Y2 @ A3 )
              & ( P @ X2 @ Y2 ) )
          @ F )
        = ( ? [X2: A] :
              ( ( member @ A @ X2 @ A3 )
              & ( frequently @ B
                @ ^ [Y2: B] : ( P @ Y2 @ X2 )
                @ F ) ) ) ) ) ).

% frequently_bex_finite_distrib
thf(fact_5303_frequently__bex__finite,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,P: B > A > $o,F: filter @ B] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( frequently @ B
          @ ^ [X2: B] :
            ? [Y2: A] :
              ( ( member @ A @ Y2 @ A3 )
              & ( P @ X2 @ Y2 ) )
          @ F )
       => ? [X: A] :
            ( ( member @ A @ X @ A3 )
            & ( frequently @ B
              @ ^ [Y2: B] : ( P @ Y2 @ X )
              @ F ) ) ) ) ).

% frequently_bex_finite
thf(fact_5304_frequently__cofinite,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( frequently @ A @ P @ ( cofinite @ A ) )
      = ( ~ ( finite_finite2 @ A @ ( collect @ A @ P ) ) ) ) ).

% frequently_cofinite
thf(fact_5305_INFM__iff__infinite,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( frequently @ A @ P @ ( cofinite @ A ) )
      = ( ~ ( finite_finite2 @ A @ ( collect @ A @ P ) ) ) ) ).

% INFM_iff_infinite
thf(fact_5306_INFM__conjI,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( frequently @ A @ P @ ( cofinite @ A ) )
     => ( ( eventually @ A @ Q @ ( cofinite @ A ) )
       => ( frequently @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
              & ( Q @ X2 ) )
          @ ( cofinite @ A ) ) ) ) ).

% INFM_conjI
thf(fact_5307_Alm__all__def,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( eventually @ A @ P @ ( cofinite @ A ) )
      = ( ~ ( frequently @ A
            @ ^ [X2: A] :
                ~ ( P @ X2 )
            @ ( cofinite @ A ) ) ) ) ).

% Alm_all_def
thf(fact_5308_INFM__imp__distrib,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( frequently @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
           => ( Q @ X2 ) )
        @ ( cofinite @ A ) )
      = ( ( eventually @ A @ P @ ( cofinite @ A ) )
       => ( frequently @ A @ Q @ ( cofinite @ A ) ) ) ) ).

% INFM_imp_distrib
thf(fact_5309_eventually__frequentlyE,axiom,
    ! [A: $tType,P: A > $o,F: filter @ A,Q: A > $o] :
      ( ( eventually @ A @ P @ F )
     => ( ( eventually @ A
          @ ^ [X2: A] :
              ( ~ ( P @ X2 )
              | ( Q @ X2 ) )
          @ F )
       => ( ( F
           != ( bot_bot @ ( filter @ A ) ) )
         => ( frequently @ A @ Q @ F ) ) ) ) ).

% eventually_frequentlyE
thf(fact_5310_INFM__nat,axiom,
    ! [P: nat > $o] :
      ( ( frequently @ nat @ P @ ( cofinite @ nat ) )
      = ( ! [M5: nat] :
          ? [N5: nat] :
            ( ( ord_less @ nat @ M5 @ N5 )
            & ( P @ N5 ) ) ) ) ).

% INFM_nat
thf(fact_5311_INFM__nat__le,axiom,
    ! [P: nat > $o] :
      ( ( frequently @ nat @ P @ ( cofinite @ nat ) )
      = ( ! [M5: nat] :
          ? [N5: nat] :
            ( ( ord_less_eq @ nat @ M5 @ N5 )
            & ( P @ N5 ) ) ) ) ).

% INFM_nat_le
thf(fact_5312_INFM__inj,axiom,
    ! [A: $tType,B: $tType,P: B > $o,F2: A > B] :
      ( ( frequently @ A
        @ ^ [X2: A] : ( P @ ( F2 @ X2 ) )
        @ ( cofinite @ A ) )
     => ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
       => ( frequently @ B @ P @ ( cofinite @ B ) ) ) ) ).

% INFM_inj
thf(fact_5313_INFM__finite__Bex__distrib,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,P: A > B > $o] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( frequently @ B
          @ ^ [Y2: B] :
            ? [X2: A] :
              ( ( member @ A @ X2 @ A3 )
              & ( P @ X2 @ Y2 ) )
          @ ( cofinite @ B ) )
        = ( ? [X2: A] :
              ( ( member @ A @ X2 @ A3 )
              & ( frequently @ B @ ( P @ X2 ) @ ( cofinite @ B ) ) ) ) ) ) ).

% INFM_finite_Bex_distrib
thf(fact_5314_INFM__nat__inductI,axiom,
    ! [P: nat > $o,Q: nat > $o] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [I4: nat] :
            ( ( P @ I4 )
           => ? [J6: nat] :
                ( ( ord_less @ nat @ I4 @ J6 )
                & ( P @ J6 )
                & ( Q @ J6 ) ) )
       => ( frequently @ nat @ Q @ ( cofinite @ nat ) ) ) ) ).

% INFM_nat_inductI
thf(fact_5315_Sup__multiset__def,axiom,
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( multiset @ A ) )
      = ( ^ [A6: set @ ( multiset @ A )] :
            ( if @ ( multiset @ A )
            @ ( ( A6
               != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
              & ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A6 ) )
            @ ( abs_multiset @ A
              @ ^ [I2: A] :
                  ( complete_Sup_Sup @ nat
                  @ ( image2 @ ( multiset @ A ) @ nat
                    @ ^ [X7: multiset @ A] : ( count @ A @ X7 @ I2 )
                    @ A6 ) ) )
            @ ( zero_zero @ ( multiset @ A ) ) ) ) ) ).

% Sup_multiset_def
thf(fact_5316_irreflp__irrefl__eq,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( irreflp @ A
        @ ^ [A5: A,B4: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R ) )
      = ( irrefl @ A @ R ) ) ).

% irreflp_irrefl_eq
thf(fact_5317_comm__monoid__set_OG__def,axiom,
    ! [B: $tType,A: $tType,F2: A > A > A,Z2: A,I: set @ B,P5: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I )
                  & ( ( P5 @ X2 )
                   != Z2 ) ) ) )
         => ( ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ P5 @ I )
            = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ P5
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ I )
                    & ( ( P5 @ X2 )
                     != Z2 ) ) ) ) ) )
        & ( ~ ( finite_finite2 @ B
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ I )
                    & ( ( P5 @ X2 )
                     != Z2 ) ) ) )
         => ( ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ P5 @ I )
            = Z2 ) ) ) ) ).

% comm_monoid_set.G_def
thf(fact_5318_subset__mset_Obdd__above__empty,axiom,
    ! [A: $tType] : ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ).

% subset_mset.bdd_above_empty
thf(fact_5319_subset__mset_Obdd__above__UN,axiom,
    ! [A: $tType,B: $tType,I: set @ B,A3: B > ( set @ ( multiset @ A ) )] :
      ( ( finite_finite2 @ B @ I )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( complete_Sup_Sup @ ( set @ ( multiset @ A ) ) @ ( image2 @ B @ ( set @ ( multiset @ A ) ) @ A3 @ I ) ) )
        = ( ! [X2: B] :
              ( ( member @ B @ X2 @ I )
             => ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( A3 @ X2 ) ) ) ) ) ) ).

% subset_mset.bdd_above_UN
thf(fact_5320_bdd__above__multiset__imp__bdd__above__count,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: A] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
     => ( condit941137186595557371_above @ nat
        @ ( image2 @ ( multiset @ A ) @ nat
          @ ^ [X7: multiset @ A] : ( count @ A @ X7 @ X3 )
          @ A3 ) ) ) ).

% bdd_above_multiset_imp_bdd_above_count
thf(fact_5321_subset__mset_OcSUP__le__iff,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,F2: B > ( multiset @ A ),U2: multiset @ A] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
       => ( ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) @ U2 )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( subseteq_mset @ A @ ( F2 @ X2 ) @ U2 ) ) ) ) ) ) ).

% subset_mset.cSUP_le_iff
thf(fact_5322_subset__mset_OcSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType,A3: set @ B,G: C > ( multiset @ A ),B2: set @ C,F2: B > ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ G @ B2 ) )
       => ( ! [N2: B] :
              ( ( member @ B @ N2 @ A3 )
             => ? [X4: C] :
                  ( ( member @ C @ X4 @ B2 )
                  & ( subseteq_mset @ A @ ( F2 @ N2 ) @ ( G @ X4 ) ) ) )
         => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ G @ B2 ) ) ) ) ) ) ).

% subset_mset.cSUP_mono
thf(fact_5323_subset__mset_OLeast__def,axiom,
    ! [A: $tType,P: ( multiset @ A ) > $o] :
      ( ( least @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ P )
      = ( the @ ( multiset @ A )
        @ ^ [X2: multiset @ A] :
            ( ( P @ X2 )
            & ! [Y2: multiset @ A] :
                ( ( P @ Y2 )
               => ( subseteq_mset @ A @ X2 @ Y2 ) ) ) ) ) ).

% subset_mset.Least_def
thf(fact_5324_subset__mset_OcSup__subset__mono,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B2 )
       => ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ A3 @ B2 )
         => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ B2 ) ) ) ) ) ).

% subset_mset.cSup_subset_mono
thf(fact_5325_subset__mset_Ofinite__has__maximal,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ? [X: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X @ A3 )
            & ! [Xa3: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ Xa3 @ A3 )
               => ( ( subseteq_mset @ A @ X @ Xa3 )
                 => ( X = Xa3 ) ) ) ) ) ) ).

% subset_mset.finite_has_maximal
thf(fact_5326_subset__mset_Ofinite__has__minimal,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ? [X: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X @ A3 )
            & ! [Xa3: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ Xa3 @ A3 )
               => ( ( subseteq_mset @ A @ Xa3 @ X )
                 => ( X = Xa3 ) ) ) ) ) ) ).

% subset_mset.finite_has_minimal
thf(fact_5327_subset__mset_OcSup__le__iff,axiom,
    ! [A: $tType,S2: set @ ( multiset @ A ),A4: multiset @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ S2 )
       => ( ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ S2 ) @ A4 )
          = ( ! [X2: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ X2 @ S2 )
               => ( subseteq_mset @ A @ X2 @ A4 ) ) ) ) ) ) ).

% subset_mset.cSup_le_iff
thf(fact_5328_subset__mset_OcSup__mono,axiom,
    ! [A: $tType,B2: set @ ( multiset @ A ),A3: set @ ( multiset @ A )] :
      ( ( B2
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
       => ( ! [B6: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ B6 @ B2 )
             => ? [X4: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ X4 @ A3 )
                  & ( subseteq_mset @ A @ B6 @ X4 ) ) )
         => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ B2 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ A3 ) ) ) ) ) ).

% subset_mset.cSup_mono
thf(fact_5329_subset__mset_OcSup__cInf,axiom,
    ! [A: $tType,S2: set @ ( multiset @ A )] :
      ( ( S2
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ S2 )
       => ( ( complete_Sup_Sup @ ( multiset @ A ) @ S2 )
          = ( complete_Inf_Inf @ ( multiset @ A )
            @ ( collect @ ( multiset @ A )
              @ ^ [X2: multiset @ A] :
                ! [Y2: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ Y2 @ S2 )
                 => ( subseteq_mset @ A @ Y2 @ X2 ) ) ) ) ) ) ) ).

% subset_mset.cSup_cInf
thf(fact_5330_subset__mset_Obdd__above__Int1,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
     => ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A3 @ B2 ) ) ) ).

% subset_mset.bdd_above_Int1
thf(fact_5331_subset__mset_Obdd__above__Int2,axiom,
    ! [A: $tType,B2: set @ ( multiset @ A ),A3: set @ ( multiset @ A )] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B2 )
     => ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A3 @ B2 ) ) ) ).

% subset_mset.bdd_above_Int2
thf(fact_5332_comm__monoid__set_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,G: B > A,I: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ G
          @ ( collect @ B
            @ ^ [X2: B] :
                ( ( member @ B @ X2 @ I )
                & ( ( G @ X2 )
                 != Z2 ) ) ) )
        = ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ G @ I ) ) ) ).

% comm_monoid_set.non_neutral'
thf(fact_5333_subset__mset_OcSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,G: B > ( multiset @ A ),B2: set @ B,F2: B > ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ B2 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B2 )
         => ( ! [X: B] :
                ( ( member @ B @ X @ A3 )
               => ( subseteq_mset @ A @ ( F2 @ X ) @ ( G @ X ) ) )
           => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ B2 ) ) ) ) ) ) ) ).

% subset_mset.cSUP_subset_mono
thf(fact_5334_subset__mset_OcInf__eq__non__empty,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A4: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ! [X: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X @ X5 )
           => ( subseteq_mset @ A @ A4 @ X ) )
       => ( ! [Y3: multiset @ A] :
              ( ! [X4: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ X4 @ X5 )
                 => ( subseteq_mset @ A @ Y3 @ X4 ) )
             => ( subseteq_mset @ A @ Y3 @ A4 ) )
         => ( ( complete_Inf_Inf @ ( multiset @ A ) @ X5 )
            = A4 ) ) ) ) ).

% subset_mset.cInf_eq_non_empty
thf(fact_5335_subset__mset_OcInf__greatest,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),Z2: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ! [X: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X @ X5 )
           => ( subseteq_mset @ A @ Z2 @ X ) )
       => ( subseteq_mset @ A @ Z2 @ ( complete_Inf_Inf @ ( multiset @ A ) @ X5 ) ) ) ) ).

% subset_mset.cInf_greatest
thf(fact_5336_subset__mset_OcSup__eq__non__empty,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A4: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ! [X: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X @ X5 )
           => ( subseteq_mset @ A @ X @ A4 ) )
       => ( ! [Y3: multiset @ A] :
              ( ! [X4: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ X4 @ X5 )
                 => ( subseteq_mset @ A @ X4 @ Y3 ) )
             => ( subseteq_mset @ A @ A4 @ Y3 ) )
         => ( ( complete_Sup_Sup @ ( multiset @ A ) @ X5 )
            = A4 ) ) ) ) ).

% subset_mset.cSup_eq_non_empty
thf(fact_5337_subset__mset_OcSup__least,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),Z2: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ! [X: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X @ X5 )
           => ( subseteq_mset @ A @ X @ Z2 ) )
       => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ X5 ) @ Z2 ) ) ) ).

% subset_mset.cSup_least
thf(fact_5338_irreflp__greater,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( irreflp @ A
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% irreflp_greater
thf(fact_5339_set__mset__Sup,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
     => ( ( set_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ A3 ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( multiset @ A ) @ ( set @ A ) @ ( set_mset @ A ) @ A3 ) ) ) ) ).

% set_mset_Sup
thf(fact_5340_comm__monoid__set_Oempty_H,axiom,
    ! [B: $tType,A: $tType,F2: A > A > A,Z2: A,P5: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ P5 @ ( bot_bot @ ( set @ B ) ) )
        = Z2 ) ) ).

% comm_monoid_set.empty'
thf(fact_5341_comm__monoid__set_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,I: set @ B,G: B > A,H2: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B @ I )
       => ( ( groups_comm_monoid_G @ A @ B @ F2 @ Z2
            @ ^ [I2: B] : ( F2 @ ( G @ I2 ) @ ( H2 @ I2 ) )
            @ I )
          = ( F2 @ ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ G @ I ) @ ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ H2 @ I ) ) ) ) ) ).

% comm_monoid_set.distrib_triv'
thf(fact_5342_comm__monoid__set_Odistrib_H,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,I: set @ B,G: B > A,H2: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B
          @ ( collect @ B
            @ ^ [X2: B] :
                ( ( member @ B @ X2 @ I )
                & ( ( G @ X2 )
                 != Z2 ) ) ) )
       => ( ( finite_finite2 @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I )
                  & ( ( H2 @ X2 )
                   != Z2 ) ) ) )
         => ( ( groups_comm_monoid_G @ A @ B @ F2 @ Z2
              @ ^ [I2: B] : ( F2 @ ( G @ I2 ) @ ( H2 @ I2 ) )
              @ I )
            = ( F2 @ ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ G @ I ) @ ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ H2 @ I ) ) ) ) ) ) ).

% comm_monoid_set.distrib'
thf(fact_5343_count__Sup__multiset__nonempty,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: A] :
      ( ( A3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
       => ( ( count @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ A3 ) @ X3 )
          = ( complete_Sup_Sup @ nat
            @ ( image2 @ ( multiset @ A ) @ nat
              @ ^ [X7: multiset @ A] : ( count @ A @ X7 @ X3 )
              @ A3 ) ) ) ) ) ).

% count_Sup_multiset_nonempty
thf(fact_5344_subset__mset_OcINF__greatest,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,M2: multiset @ A,F2: B > ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ! [X: B] :
            ( ( member @ B @ X @ A3 )
           => ( subseteq_mset @ A @ M2 @ ( F2 @ X ) ) )
       => ( subseteq_mset @ A @ M2 @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) ) ) ) ).

% subset_mset.cINF_greatest
thf(fact_5345_subset__mset_OcSUP__least,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,F2: B > ( multiset @ A ),M: multiset @ A] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ! [X: B] :
            ( ( member @ B @ X @ A3 )
           => ( subseteq_mset @ A @ ( F2 @ X ) @ M ) )
       => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) @ M ) ) ) ).

% subset_mset.cSUP_least
thf(fact_5346_prod_H__def,axiom,
    ! [C: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ C @ A )
        = ( groups_comm_monoid_G @ A @ C @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod'_def
thf(fact_5347_bdd__above__multiset__imp__finite__support,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
       => ( finite_finite2 @ A
          @ ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ ( multiset @ A ) @ ( set @ A )
              @ ^ [X7: multiset @ A] :
                  ( collect @ A
                  @ ^ [X2: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( count @ A @ X7 @ X2 ) ) )
              @ A3 ) ) ) ) ) ).

% bdd_above_multiset_imp_finite_support
thf(fact_5348_Sup__multiset__in__multiset,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
       => ( finite_finite2 @ A
          @ ( collect @ A
            @ ^ [I2: A] :
                ( ord_less @ nat @ ( zero_zero @ nat )
                @ ( complete_Sup_Sup @ nat
                  @ ( image2 @ ( multiset @ A ) @ nat
                    @ ^ [M8: multiset @ A] : ( count @ A @ M8 @ I2 )
                    @ A3 ) ) ) ) ) ) ) ).

% Sup_multiset_in_multiset
thf(fact_5349_comm__monoid__set_Oinsert_H,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,I: set @ B,P5: B > A,I3: B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ B
          @ ( collect @ B
            @ ^ [X2: B] :
                ( ( member @ B @ X2 @ I )
                & ( ( P5 @ X2 )
                 != Z2 ) ) ) )
       => ( ( ( member @ B @ I3 @ I )
           => ( ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ P5 @ ( insert @ B @ I3 @ I ) )
              = ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ P5 @ I ) ) )
          & ( ~ ( member @ B @ I3 @ I )
           => ( ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ P5 @ ( insert @ B @ I3 @ I ) )
              = ( F2 @ ( P5 @ I3 ) @ ( groups_comm_monoid_G @ A @ B @ F2 @ Z2 @ P5 @ I ) ) ) ) ) ) ) ).

% comm_monoid_set.insert'
thf(fact_5350_subset__mset_Omono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [F2: ( multiset @ A ) > B,A3: C > ( multiset @ A ),I: set @ C] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F2 )
         => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ A3 @ I ) )
           => ( ( I
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B
                @ ( complete_Sup_Sup @ B
                  @ ( image2 @ C @ B
                    @ ^ [X2: C] : ( F2 @ ( A3 @ X2 ) )
                    @ I ) )
                @ ( F2 @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ A3 @ I ) ) ) ) ) ) ) ) ).

% subset_mset.mono_cSUP
thf(fact_5351_subset__mset_Omono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [F2: ( multiset @ A ) > B,A3: set @ ( multiset @ A )] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F2 )
         => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
             => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image2 @ ( multiset @ A ) @ B @ F2 @ A3 ) ) @ ( F2 @ ( complete_Sup_Sup @ ( multiset @ A ) @ A3 ) ) ) ) ) ) ) ).

% subset_mset.mono_cSup
thf(fact_5352_subset__mset_Osum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType,S3: set @ B,F2: B > ( multiset @ A ),B2: multiset @ A,I3: B] :
      ( ( finite_finite2 @ B @ S3 )
     => ( ! [I4: B] :
            ( ( member @ B @ I4 @ S3 )
           => ( subseteq_mset @ A @ ( zero_zero @ ( multiset @ A ) ) @ ( F2 @ I4 ) ) )
       => ( ( ( groups3894954378712506084id_sum @ ( multiset @ A ) @ B @ ( plus_plus @ ( multiset @ A ) ) @ ( zero_zero @ ( multiset @ A ) ) @ F2 @ S3 )
            = B2 )
         => ( ( member @ B @ I3 @ S3 )
           => ( subseteq_mset @ A @ ( F2 @ I3 ) @ B2 ) ) ) ) ) ).

% subset_mset.sum_nonneg_leq_bound
thf(fact_5353_order_Omono_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ( ( mono @ A @ B )
        = ( mono @ A @ B ) ) ) ).

% order.mono.cong
thf(fact_5354_subset__mset_Osum__mono,axiom,
    ! [A: $tType,B: $tType,K5: set @ B,F2: B > ( multiset @ A ),G: B > ( multiset @ A )] :
      ( ! [I4: B] :
          ( ( member @ B @ I4 @ K5 )
         => ( subseteq_mset @ A @ ( F2 @ I4 ) @ ( G @ I4 ) ) )
     => ( subseteq_mset @ A @ ( groups3894954378712506084id_sum @ ( multiset @ A ) @ B @ ( plus_plus @ ( multiset @ A ) ) @ ( zero_zero @ ( multiset @ A ) ) @ F2 @ K5 ) @ ( groups3894954378712506084id_sum @ ( multiset @ A ) @ B @ ( plus_plus @ ( multiset @ A ) ) @ ( zero_zero @ ( multiset @ A ) ) @ G @ K5 ) ) ) ).

% subset_mset.sum_mono
thf(fact_5355_subset__mset_Osum__nonneg__0,axiom,
    ! [B: $tType,A: $tType,S3: set @ B,F2: B > ( multiset @ A ),I3: B] :
      ( ( finite_finite2 @ B @ S3 )
     => ( ! [I4: B] :
            ( ( member @ B @ I4 @ S3 )
           => ( subseteq_mset @ A @ ( zero_zero @ ( multiset @ A ) ) @ ( F2 @ I4 ) ) )
       => ( ( ( groups3894954378712506084id_sum @ ( multiset @ A ) @ B @ ( plus_plus @ ( multiset @ A ) ) @ ( zero_zero @ ( multiset @ A ) ) @ F2 @ S3 )
            = ( zero_zero @ ( multiset @ A ) ) )
         => ( ( member @ B @ I3 @ S3 )
           => ( ( F2 @ I3 )
              = ( zero_zero @ ( multiset @ A ) ) ) ) ) ) ) ).

% subset_mset.sum_nonneg_0
thf(fact_5356_subset__mset_OGreatest__def,axiom,
    ! [A: $tType,P: ( multiset @ A ) > $o] :
      ( ( greatest @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ P )
      = ( the @ ( multiset @ A )
        @ ^ [X2: multiset @ A] :
            ( ( P @ X2 )
            & ! [Y2: multiset @ A] :
                ( ( P @ Y2 )
               => ( subseteq_mset @ A @ Y2 @ X2 ) ) ) ) ) ).

% subset_mset.Greatest_def
thf(fact_5357_subset__mset_Omono__cINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [F2: ( multiset @ A ) > B,A3: C > ( multiset @ A ),I: set @ C] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F2 )
         => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ A3 @ I ) )
           => ( ( I
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ A3 @ I ) ) )
                @ ( complete_Inf_Inf @ B
                  @ ( image2 @ C @ B
                    @ ^ [X2: C] : ( F2 @ ( A3 @ X2 ) )
                    @ I ) ) ) ) ) ) ) ).

% subset_mset.mono_cINF
thf(fact_5358_subset__mset_Omono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [F2: ( multiset @ A ) > B,A3: set @ ( multiset @ A )] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F2 )
         => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
             => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ ( multiset @ A ) @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image2 @ ( multiset @ A ) @ B @ F2 @ A3 ) ) ) ) ) ) ) ).

% subset_mset.mono_cInf
thf(fact_5359_subset__mset_Obdd__below__empty,axiom,
    ! [A: $tType] : ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ).

% subset_mset.bdd_below_empty
thf(fact_5360_subset__mset_Obdd__below__UN,axiom,
    ! [A: $tType,B: $tType,I: set @ B,A3: B > ( set @ ( multiset @ A ) )] :
      ( ( finite_finite2 @ B @ I )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( complete_Sup_Sup @ ( set @ ( multiset @ A ) ) @ ( image2 @ B @ ( set @ ( multiset @ A ) ) @ A3 @ I ) ) )
        = ( ! [X2: B] :
              ( ( member @ B @ X2 @ I )
             => ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( A3 @ X2 ) ) ) ) ) ) ).

% subset_mset.bdd_below_UN
thf(fact_5361_order_OGreatest_Ocong,axiom,
    ! [A: $tType] :
      ( ( greatest @ A )
      = ( greatest @ A ) ) ).

% order.Greatest.cong
thf(fact_5362_subset__mset_Obdd__below__Int2,axiom,
    ! [A: $tType,B2: set @ ( multiset @ A ),A3: set @ ( multiset @ A )] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B2 )
     => ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A3 @ B2 ) ) ) ).

% subset_mset.bdd_below_Int2
thf(fact_5363_subset__mset_Obdd__below__Int1,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
     => ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A3 @ B2 ) ) ) ).

% subset_mset.bdd_below_Int1
thf(fact_5364_subset__mset_Ole__cInf__iff,axiom,
    ! [A: $tType,S2: set @ ( multiset @ A ),A4: multiset @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ S2 )
       => ( ( subseteq_mset @ A @ A4 @ ( complete_Inf_Inf @ ( multiset @ A ) @ S2 ) )
          = ( ! [X2: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ X2 @ S2 )
               => ( subseteq_mset @ A @ A4 @ X2 ) ) ) ) ) ) ).

% subset_mset.le_cInf_iff
thf(fact_5365_subset__mset_OcInf__mono,axiom,
    ! [A: $tType,B2: set @ ( multiset @ A ),A3: set @ ( multiset @ A )] :
      ( ( B2
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
       => ( ! [B6: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ B6 @ B2 )
             => ? [X4: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ X4 @ A3 )
                  & ( subseteq_mset @ A @ X4 @ B6 ) ) )
         => ( subseteq_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ B2 ) ) ) ) ) ).

% subset_mset.cInf_mono
thf(fact_5366_subset__mset_OcINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType,B2: set @ B,F2: C > ( multiset @ A ),A3: set @ C,G: B > ( multiset @ A )] :
      ( ( B2
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ F2 @ A3 ) )
       => ( ! [M3: B] :
              ( ( member @ B @ M3 @ B2 )
             => ? [X4: C] :
                  ( ( member @ C @ X4 @ A3 )
                  & ( subseteq_mset @ A @ ( F2 @ X4 ) @ ( G @ M3 ) ) ) )
         => ( subseteq_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ B2 ) ) ) ) ) ) ).

% subset_mset.cINF_mono
thf(fact_5367_subset__mset_Ole__cINF__iff,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,F2: B > ( multiset @ A ),U2: multiset @ A] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
       => ( ( subseteq_mset @ A @ U2 @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( subseteq_mset @ A @ U2 @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% subset_mset.le_cINF_iff
thf(fact_5368_subset__mset_OcInf__superset__mono,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B2 )
       => ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ A3 @ B2 )
         => ( subseteq_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ B2 ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ A3 ) ) ) ) ) ).

% subset_mset.cInf_superset_mono
thf(fact_5369_subset__mset_OcINF__superset__mono,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,G: B > ( multiset @ A ),B2: set @ B,F2: B > ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ B2 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B2 )
         => ( ! [X: B] :
                ( ( member @ B @ X @ B2 )
               => ( subseteq_mset @ A @ ( G @ X ) @ ( F2 @ X ) ) )
           => ( subseteq_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ B2 ) ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) ) ) ) ) ) ).

% subset_mset.cINF_superset_mono
thf(fact_5370_subset__mset_OcInf__le__cSup,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
       => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
         => ( subseteq_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ A3 ) ) ) ) ) ).

% subset_mset.cInf_le_cSup
thf(fact_5371_subset__mset_OcInf__cSup,axiom,
    ! [A: $tType,S2: set @ ( multiset @ A )] :
      ( ( S2
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ S2 )
       => ( ( complete_Inf_Inf @ ( multiset @ A ) @ S2 )
          = ( complete_Sup_Sup @ ( multiset @ A )
            @ ( collect @ ( multiset @ A )
              @ ^ [X2: multiset @ A] :
                ! [Y2: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ Y2 @ S2 )
                 => ( subseteq_mset @ A @ X2 @ Y2 ) ) ) ) ) ) ) ).

% subset_mset.cInf_cSup
thf(fact_5372_subset__mset_OcINF__union,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,F2: B > ( multiset @ A ),B2: set @ B] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
       => ( ( B2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ B2 ) )
           => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) ) )
              = ( inter_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ B2 ) ) ) ) ) ) ) ) ).

% subset_mset.cINF_union
thf(fact_5373_subset__mset_OcINF__insert,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,F2: B > ( multiset @ A ),A4: B] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
       => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ ( insert @ B @ A4 @ A3 ) ) )
          = ( inter_mset @ A @ ( F2 @ A4 ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) ) ) ) ) ).

% subset_mset.cINF_insert
thf(fact_5374_subset__mset_OcSUP__union,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,F2: B > ( multiset @ A ),B2: set @ B] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
       => ( ( B2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ B2 ) )
           => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B2 ) ) )
              = ( union_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ B2 ) ) ) ) ) ) ) ) ).

% subset_mset.cSUP_union
thf(fact_5375_set__mset__inter,axiom,
    ! [A: $tType,A3: multiset @ A,B2: multiset @ A] :
      ( ( set_mset @ A @ ( inter_mset @ A @ A3 @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ ( set_mset @ A @ A3 ) @ ( set_mset @ A @ B2 ) ) ) ).

% set_mset_inter
thf(fact_5376_subset__mset_Obdd__above__image__sup,axiom,
    ! [A: $tType,B: $tType,F2: B > ( multiset @ A ),G: B > ( multiset @ A ),A3: set @ B] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A )
        @ ( image2 @ B @ ( multiset @ A )
          @ ^ [X2: B] : ( union_mset @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ A3 ) )
      = ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
        & ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ A3 ) ) ) ) ).

% subset_mset.bdd_above_image_sup
thf(fact_5377_subset__mset_Obdd__below__image__inf,axiom,
    ! [A: $tType,B: $tType,F2: B > ( multiset @ A ),G: B > ( multiset @ A ),A3: set @ B] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A )
        @ ( image2 @ B @ ( multiset @ A )
          @ ^ [X2: B] : ( inter_mset @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ A3 ) )
      = ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
        & ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ A3 ) ) ) ) ).

% subset_mset.bdd_below_image_inf
thf(fact_5378_prod__mset_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: multiset @ B,B2: multiset @ B,G: B > A] :
          ( ( ( inter_mset @ B @ A3 @ B2 )
            = ( zero_zero @ ( multiset @ B ) ) )
         => ( ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ ( union_mset @ B @ A3 @ B2 ) ) )
            = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ A3 ) ) @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ B2 ) ) ) ) ) ) ).

% prod_mset.union_disjoint
thf(fact_5379_subset__mset_Omono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ! [F2: ( multiset @ A ) > B,A3: multiset @ A,B2: multiset @ A] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inter_mset @ A @ A3 @ B2 ) ) @ ( inf_inf @ B @ ( F2 @ A3 ) @ ( F2 @ B2 ) ) ) ) ) ).

% subset_mset.mono_inf
thf(fact_5380_subset__mset_OcSup__union__distrib,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
       => ( ( B2
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B2 )
           => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( sup_sup @ ( set @ ( multiset @ A ) ) @ A3 @ B2 ) )
              = ( union_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ B2 ) ) ) ) ) ) ) ).

% subset_mset.cSup_union_distrib
thf(fact_5381_subset__mset_OcInf__union__distrib,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
       => ( ( B2
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B2 )
           => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( sup_sup @ ( set @ ( multiset @ A ) ) @ A3 @ B2 ) )
              = ( inter_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ B2 ) ) ) ) ) ) ) ).

% subset_mset.cInf_union_distrib
thf(fact_5382_subset__mset_OcSup__insert__If,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A4: multiset @ A] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ X5 )
     => ( ( ( X5
            = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( insert @ ( multiset @ A ) @ A4 @ X5 ) )
            = A4 ) )
        & ( ( X5
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( insert @ ( multiset @ A ) @ A4 @ X5 ) )
            = ( union_mset @ A @ A4 @ ( complete_Sup_Sup @ ( multiset @ A ) @ X5 ) ) ) ) ) ) ).

% subset_mset.cSup_insert_If
thf(fact_5383_subset__mset_OcSup__insert,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A4: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ X5 )
       => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( insert @ ( multiset @ A ) @ A4 @ X5 ) )
          = ( union_mset @ A @ A4 @ ( complete_Sup_Sup @ ( multiset @ A ) @ X5 ) ) ) ) ) ).

% subset_mset.cSup_insert
thf(fact_5384_subset__mset_OcInf__insert,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A4: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ X5 )
       => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( insert @ ( multiset @ A ) @ A4 @ X5 ) )
          = ( inter_mset @ A @ A4 @ ( complete_Inf_Inf @ ( multiset @ A ) @ X5 ) ) ) ) ) ).

% subset_mset.cInf_insert
thf(fact_5385_subset__mset_OcInf__insert__If,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A4: multiset @ A] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ X5 )
     => ( ( ( X5
            = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( insert @ ( multiset @ A ) @ A4 @ X5 ) )
            = A4 ) )
        & ( ( X5
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( insert @ ( multiset @ A ) @ A4 @ X5 ) )
            = ( inter_mset @ A @ A4 @ ( complete_Inf_Inf @ ( multiset @ A ) @ X5 ) ) ) ) ) ) ).

% subset_mset.cInf_insert_If
thf(fact_5386_subset__mset_OcSup__inter__less__eq,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B2 )
       => ( ( ( inf_inf @ ( set @ ( multiset @ A ) ) @ A3 @ B2 )
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A3 @ B2 ) ) @ ( union_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ B2 ) ) ) ) ) ) ).

% subset_mset.cSup_inter_less_eq
thf(fact_5387_subset__mset_Oless__eq__cInf__inter,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B2 )
       => ( ( ( inf_inf @ ( set @ ( multiset @ A ) ) @ A3 @ B2 )
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( subseteq_mset @ A @ ( inter_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ B2 ) ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A3 @ B2 ) ) ) ) ) ) ).

% subset_mset.less_eq_cInf_inter
thf(fact_5388_subset__mset_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,F2: B > ( multiset @ A ),G: B > ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
       => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ A3 ) )
         => ( ( union_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ A3 ) ) )
            = ( complete_Sup_Sup @ ( multiset @ A )
              @ ( image2 @ B @ ( multiset @ A )
                @ ^ [A5: B] : ( union_mset @ A @ ( F2 @ A5 ) @ ( G @ A5 ) )
                @ A3 ) ) ) ) ) ) ).

% subset_mset.SUP_sup_distrib
thf(fact_5389_subset__mset_OcINF__inf__distrib,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,F2: B > ( multiset @ A ),G: B > ( multiset @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
       => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ A3 ) )
         => ( ( inter_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ A3 ) ) )
            = ( complete_Inf_Inf @ ( multiset @ A )
              @ ( image2 @ B @ ( multiset @ A )
                @ ^ [A5: B] : ( inter_mset @ A @ ( F2 @ A5 ) @ ( G @ A5 ) )
                @ A3 ) ) ) ) ) ) ).

% subset_mset.cINF_inf_distrib
thf(fact_5390_subset__mset_OcSUP__insert,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,F2: B > ( multiset @ A ),A4: B] :
      ( ( A3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
       => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ ( insert @ B @ A4 @ A3 ) ) )
          = ( union_mset @ A @ ( F2 @ A4 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) ) ) ) ) ).

% subset_mset.cSUP_insert
thf(fact_5391_multp__code__def,axiom,
    ! [A: $tType] :
      ( ( multp_code @ A )
      = ( ^ [P3: A > A > $o,N7: multiset @ A,M8: multiset @ A] :
            ( ( ( minus_minus @ ( multiset @ A ) @ M8 @ ( inter_mset @ A @ M8 @ N7 ) )
             != ( zero_zero @ ( multiset @ A ) ) )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set_mset @ A @ ( minus_minus @ ( multiset @ A ) @ N7 @ ( inter_mset @ A @ M8 @ N7 ) ) ) )
               => ? [Y2: A] :
                    ( ( member @ A @ Y2 @ ( set_mset @ A @ ( minus_minus @ ( multiset @ A ) @ M8 @ ( inter_mset @ A @ M8 @ N7 ) ) ) )
                    & ( P3 @ X2 @ Y2 ) ) ) ) ) ) ).

% multp_code_def
thf(fact_5392_multeqp__code__def,axiom,
    ! [A: $tType] :
      ( ( multeqp_code @ A )
      = ( ^ [P3: A > A > $o,N7: multiset @ A,M8: multiset @ A] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ ( set_mset @ A @ ( minus_minus @ ( multiset @ A ) @ N7 @ ( inter_mset @ A @ M8 @ N7 ) ) ) )
           => ? [Y2: A] :
                ( ( member @ A @ Y2 @ ( set_mset @ A @ ( minus_minus @ ( multiset @ A ) @ M8 @ ( inter_mset @ A @ M8 @ N7 ) ) ) )
                & ( P3 @ X2 @ Y2 ) ) ) ) ) ).

% multeqp_code_def
thf(fact_5393_subset__mset_Oinf__Sup1__distrib,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( inter_mset @ A @ X3 @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) )
          = ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A )
            @ ( collect @ ( multiset @ A )
              @ ^ [Uu: multiset @ A] :
                ? [A5: multiset @ A] :
                  ( ( Uu
                    = ( inter_mset @ A @ X3 @ A5 ) )
                  & ( member @ ( multiset @ A ) @ A5 @ A3 ) ) ) ) ) ) ) ).

% subset_mset.inf_Sup1_distrib
thf(fact_5394_subset__mset_OSup__fin_Osingleton,axiom,
    ! [A: $tType,X3: multiset @ A] :
      ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
      = X3 ) ).

% subset_mset.Sup_fin.singleton
thf(fact_5395_subset__mset_OSup__fin_Oinsert,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ A3 ) )
          = ( union_mset @ A @ X3 @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) ) ) ) ) ).

% subset_mset.Sup_fin.insert
thf(fact_5396_subset__mset_OSup__fin_Oeq__fold_H,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 )
      = ( the2 @ ( multiset @ A )
        @ ( finite_fold @ ( multiset @ A ) @ ( option @ ( multiset @ A ) )
          @ ^ [X2: multiset @ A,Y2: option @ ( multiset @ A )] : ( some @ ( multiset @ A ) @ ( case_option @ ( multiset @ A ) @ ( multiset @ A ) @ X2 @ ( union_mset @ A @ X2 ) @ Y2 ) )
          @ ( none @ ( multiset @ A ) )
          @ A3 ) ) ) ).

% subset_mset.Sup_fin.eq_fold'
thf(fact_5397_subset__mset_OSup__fin_Ounion,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite2 @ ( multiset @ A ) @ B2 )
         => ( ( B2
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( sup_sup @ ( set @ ( multiset @ A ) ) @ A3 @ B2 ) )
              = ( union_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ B2 ) ) ) ) ) ) ) ).

% subset_mset.Sup_fin.union
thf(fact_5398_subset__mset_OSup__fin_Ohom__commute,axiom,
    ! [A: $tType,H2: ( multiset @ A ) > ( multiset @ A ),N4: set @ ( multiset @ A )] :
      ( ! [X: multiset @ A,Y3: multiset @ A] :
          ( ( H2 @ ( union_mset @ A @ X @ Y3 ) )
          = ( union_mset @ A @ ( H2 @ X ) @ ( H2 @ Y3 ) ) )
     => ( ( finite_finite2 @ ( multiset @ A ) @ N4 )
       => ( ( N4
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( H2 @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ N4 ) )
            = ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( image2 @ ( multiset @ A ) @ ( multiset @ A ) @ H2 @ N4 ) ) ) ) ) ) ).

% subset_mset.Sup_fin.hom_commute
thf(fact_5399_subset__mset_OSup__fin_Obounded__iff,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( subseteq_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) @ X3 )
          = ( ! [X2: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ X2 @ A3 )
               => ( subseteq_mset @ A @ X2 @ X3 ) ) ) ) ) ) ).

% subset_mset.Sup_fin.bounded_iff
thf(fact_5400_subset__mset_OSup__fin_OboundedI,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ! [A7: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ A7 @ A3 )
             => ( subseteq_mset @ A @ A7 @ X3 ) )
         => ( subseteq_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) @ X3 ) ) ) ) ).

% subset_mset.Sup_fin.boundedI
thf(fact_5401_subset__mset_OSup__fin_OboundedE,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( subseteq_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) @ X3 )
         => ! [A16: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ A16 @ A3 )
             => ( subseteq_mset @ A @ A16 @ X3 ) ) ) ) ) ).

% subset_mset.Sup_fin.boundedE
thf(fact_5402_subset__mset_OcSup__eq__Sup__fin,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ X5 )
     => ( ( X5
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( complete_Sup_Sup @ ( multiset @ A ) @ X5 )
          = ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ X5 ) ) ) ) ).

% subset_mset.cSup_eq_Sup_fin
thf(fact_5403_subset__mset_OSup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ~ ( member @ ( multiset @ A ) @ X3 @ A3 )
       => ( ( A3
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ A3 ) )
            = ( union_mset @ A @ X3 @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) ) ) ) ) ) ).

% subset_mset.Sup_fin.insert_not_elem
thf(fact_5404_subset__mset_OSup__fin_Oclosed,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ! [X: multiset @ A,Y3: multiset @ A] : ( member @ ( multiset @ A ) @ ( union_mset @ A @ X @ Y3 ) @ ( insert @ ( multiset @ A ) @ X @ ( insert @ ( multiset @ A ) @ Y3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) )
         => ( member @ ( multiset @ A ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) @ A3 ) ) ) ) ).

% subset_mset.Sup_fin.closed
thf(fact_5405_subset__mset_OSup__fin_Oinsert__remove,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
            = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ A3 ) )
            = X3 ) )
        & ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ A3 ) )
            = ( union_mset @ A @ X3 @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ) ) ) ) ) ).

% subset_mset.Sup_fin.insert_remove
thf(fact_5406_subset__mset_OSup__fin_Oremove,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( member @ ( multiset @ A ) @ X3 @ A3 )
       => ( ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
              = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 )
              = X3 ) )
          & ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 )
              = ( union_mset @ A @ X3 @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% subset_mset.Sup_fin.remove
thf(fact_5407_subset__mset_OSup__fin_Osubset,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( B2
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ B2 @ A3 )
         => ( ( union_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ B2 ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) )
            = ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) ) ) ) ) ).

% subset_mset.Sup_fin.subset
thf(fact_5408_subset__mset_OSup__fin_Osubset__imp,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ A3 @ B2 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite2 @ ( multiset @ A ) @ B2 )
         => ( subseteq_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ B2 ) ) ) ) ) ).

% subset_mset.Sup_fin.subset_imp
thf(fact_5409_subset__mset_Oinf__Sup2__distrib,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite2 @ ( multiset @ A ) @ B2 )
         => ( ( B2
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( inter_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ B2 ) )
              = ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A )
                @ ( collect @ ( multiset @ A )
                  @ ^ [Uu: multiset @ A] :
                    ? [A5: multiset @ A,B4: multiset @ A] :
                      ( ( Uu
                        = ( inter_mset @ A @ A5 @ B4 ) )
                      & ( member @ ( multiset @ A ) @ A5 @ A3 )
                      & ( member @ ( multiset @ A ) @ B4 @ B2 ) ) ) ) ) ) ) ) ) ).

% subset_mset.inf_Sup2_distrib
thf(fact_5410_subset__mset_OInf__fin__le__Sup__fin,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( subseteq_mset @ A @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A3 ) ) ) ) ).

% subset_mset.Inf_fin_le_Sup_fin
thf(fact_5411_subset__mset_Osup__Inf2__distrib,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite2 @ ( multiset @ A ) @ B2 )
         => ( ( B2
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( union_mset @ A @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ B2 ) )
              = ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A )
                @ ( collect @ ( multiset @ A )
                  @ ^ [Uu: multiset @ A] :
                    ? [A5: multiset @ A,B4: multiset @ A] :
                      ( ( Uu
                        = ( union_mset @ A @ A5 @ B4 ) )
                      & ( member @ ( multiset @ A ) @ A5 @ A3 )
                      & ( member @ ( multiset @ A ) @ B4 @ B2 ) ) ) ) ) ) ) ) ) ).

% subset_mset.sup_Inf2_distrib
thf(fact_5412_subset__mset_Osup__Inf1__distrib,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( union_mset @ A @ X3 @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) )
          = ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A )
            @ ( collect @ ( multiset @ A )
              @ ^ [Uu: multiset @ A] :
                ? [A5: multiset @ A] :
                  ( ( Uu
                    = ( union_mset @ A @ X3 @ A5 ) )
                  & ( member @ ( multiset @ A ) @ A5 @ A3 ) ) ) ) ) ) ) ).

% subset_mset.sup_Inf1_distrib
thf(fact_5413_subset__mset_OInf__fin_Osingleton,axiom,
    ! [A: $tType,X3: multiset @ A] :
      ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
      = X3 ) ).

% subset_mset.Inf_fin.singleton
thf(fact_5414_subset__mset_OInf__fin_Oinsert,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ A3 ) )
          = ( inter_mset @ A @ X3 @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) ) ) ) ) ).

% subset_mset.Inf_fin.insert
thf(fact_5415_subset__mset_OInf__fin_Oeq__fold_H,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 )
      = ( the2 @ ( multiset @ A )
        @ ( finite_fold @ ( multiset @ A ) @ ( option @ ( multiset @ A ) )
          @ ^ [X2: multiset @ A,Y2: option @ ( multiset @ A )] : ( some @ ( multiset @ A ) @ ( case_option @ ( multiset @ A ) @ ( multiset @ A ) @ X2 @ ( inter_mset @ A @ X2 ) @ Y2 ) )
          @ ( none @ ( multiset @ A ) )
          @ A3 ) ) ) ).

% subset_mset.Inf_fin.eq_fold'
thf(fact_5416_subset__mset_OInf__fin_Ohom__commute,axiom,
    ! [A: $tType,H2: ( multiset @ A ) > ( multiset @ A ),N4: set @ ( multiset @ A )] :
      ( ! [X: multiset @ A,Y3: multiset @ A] :
          ( ( H2 @ ( inter_mset @ A @ X @ Y3 ) )
          = ( inter_mset @ A @ ( H2 @ X ) @ ( H2 @ Y3 ) ) )
     => ( ( finite_finite2 @ ( multiset @ A ) @ N4 )
       => ( ( N4
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( H2 @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ N4 ) )
            = ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( image2 @ ( multiset @ A ) @ ( multiset @ A ) @ H2 @ N4 ) ) ) ) ) ) ).

% subset_mset.Inf_fin.hom_commute
thf(fact_5417_subset__mset_OInf__fin_OboundedE,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( subseteq_mset @ A @ X3 @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) )
         => ! [A16: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ A16 @ A3 )
             => ( subseteq_mset @ A @ X3 @ A16 ) ) ) ) ) ).

% subset_mset.Inf_fin.boundedE
thf(fact_5418_subset__mset_OInf__fin_OboundedI,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ! [A7: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ A7 @ A3 )
             => ( subseteq_mset @ A @ X3 @ A7 ) )
         => ( subseteq_mset @ A @ X3 @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) ) ) ) ) ).

% subset_mset.Inf_fin.boundedI
thf(fact_5419_subset__mset_OInf__fin_Obounded__iff,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( subseteq_mset @ A @ X3 @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) )
          = ( ! [X2: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ X2 @ A3 )
               => ( subseteq_mset @ A @ X3 @ X2 ) ) ) ) ) ) ).

% subset_mset.Inf_fin.bounded_iff
thf(fact_5420_subset__mset_OcInf__eq__Inf__fin,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ X5 )
     => ( ( X5
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( complete_Inf_Inf @ ( multiset @ A ) @ X5 )
          = ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ X5 ) ) ) ) ).

% subset_mset.cInf_eq_Inf_fin
thf(fact_5421_subset__mset_OInf__fin_Oremove,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( member @ ( multiset @ A ) @ X3 @ A3 )
       => ( ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
              = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 )
              = X3 ) )
          & ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 )
              = ( inter_mset @ A @ X3 @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% subset_mset.Inf_fin.remove
thf(fact_5422_subset__mset_OInf__fin_Oinsert__remove,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
            = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ A3 ) )
            = X3 ) )
        & ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ A3 ) )
            = ( inter_mset @ A @ X3 @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( minus_minus @ ( set @ ( multiset @ A ) ) @ A3 @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ) ) ) ) ) ).

% subset_mset.Inf_fin.insert_remove
thf(fact_5423_subset__mset_OInf__fin_Oclosed,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ! [X: multiset @ A,Y3: multiset @ A] : ( member @ ( multiset @ A ) @ ( inter_mset @ A @ X @ Y3 ) @ ( insert @ ( multiset @ A ) @ X @ ( insert @ ( multiset @ A ) @ Y3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) )
         => ( member @ ( multiset @ A ) @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) @ A3 ) ) ) ) ).

% subset_mset.Inf_fin.closed
thf(fact_5424_subset__mset_OInf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),X3: multiset @ A] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ~ ( member @ ( multiset @ A ) @ X3 @ A3 )
       => ( ( A3
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( insert @ ( multiset @ A ) @ X3 @ A3 ) )
            = ( inter_mset @ A @ X3 @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) ) ) ) ) ) ).

% subset_mset.Inf_fin.insert_not_elem
thf(fact_5425_subset__mset_OInf__fin_Osubset,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( B2
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ B2 @ A3 )
         => ( ( inter_mset @ A @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ B2 ) @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) )
            = ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) ) ) ) ) ).

% subset_mset.Inf_fin.subset
thf(fact_5426_subset__mset_OInf__fin_Ounion,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( finite_finite2 @ ( multiset @ A ) @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite2 @ ( multiset @ A ) @ B2 )
         => ( ( B2
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( sup_sup @ ( set @ ( multiset @ A ) ) @ A3 @ B2 ) )
              = ( inter_mset @ A @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ B2 ) ) ) ) ) ) ) ).

% subset_mset.Inf_fin.union
thf(fact_5427_subset__mset_OInf__fin_Osubset__imp,axiom,
    ! [A: $tType,A3: set @ ( multiset @ A ),B2: set @ ( multiset @ A )] :
      ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ A3 @ B2 )
     => ( ( A3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite2 @ ( multiset @ A ) @ B2 )
         => ( subseteq_mset @ A @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ B2 ) @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A3 ) ) ) ) ) ).

% subset_mset.Inf_fin.subset_imp
thf(fact_5428_subset__mset_Osum__pos,axiom,
    ! [A: $tType,B: $tType,I: set @ B,F2: B > ( multiset @ A )] :
      ( ( finite_finite2 @ B @ I )
     => ( ( I
         != ( bot_bot @ ( set @ B ) ) )
       => ( ! [I4: B] :
              ( ( member @ B @ I4 @ I )
             => ( subset_mset @ A @ ( zero_zero @ ( multiset @ A ) ) @ ( F2 @ I4 ) ) )
         => ( subset_mset @ A @ ( zero_zero @ ( multiset @ A ) ) @ ( groups3894954378712506084id_sum @ ( multiset @ A ) @ B @ ( plus_plus @ ( multiset @ A ) ) @ ( zero_zero @ ( multiset @ A ) ) @ F2 @ I ) ) ) ) ) ).

% subset_mset.sum_pos
thf(fact_5429_subset__mset_Osum__strict__mono,axiom,
    ! [A: $tType,B: $tType,A3: set @ B,F2: B > ( multiset @ A ),G: B > ( multiset @ A )] :
      ( ( finite_finite2 @ B @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ! [X: B] :
              ( ( member @ B @ X @ A3 )
             => ( subset_mset @ A @ ( F2 @ X ) @ ( G @ X ) ) )
         => ( subset_mset @ A @ ( groups3894954378712506084id_sum @ ( multiset @ A ) @ B @ ( plus_plus @ ( multiset @ A ) ) @ ( zero_zero @ ( multiset @ A ) ) @ F2 @ A3 ) @ ( groups3894954378712506084id_sum @ ( multiset @ A ) @ B @ ( plus_plus @ ( multiset @ A ) ) @ ( zero_zero @ ( multiset @ A ) ) @ G @ A3 ) ) ) ) ) ).

% subset_mset.sum_strict_mono
thf(fact_5430_subset__mset_OatLeastAtMost__singleton,axiom,
    ! [A: $tType,A4: multiset @ A] :
      ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 @ A4 )
      = ( insert @ ( multiset @ A ) @ A4 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ).

% subset_mset.atLeastAtMost_singleton
thf(fact_5431_subset__mset_OatLeastatMost__empty__iff,axiom,
    ! [A: $tType,A4: multiset @ A,B3: multiset @ A] :
      ( ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
      = ( ~ ( subseteq_mset @ A @ A4 @ B3 ) ) ) ).

% subset_mset.atLeastatMost_empty_iff
thf(fact_5432_subset__mset_OatLeastatMost__empty__iff2,axiom,
    ! [A: $tType,A4: multiset @ A,B3: multiset @ A] :
      ( ( ( bot_bot @ ( set @ ( multiset @ A ) ) )
        = ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 @ B3 ) )
      = ( ~ ( subseteq_mset @ A @ A4 @ B3 ) ) ) ).

% subset_mset.atLeastatMost_empty_iff2
thf(fact_5433_subset__mset_OatLeastatMost__empty,axiom,
    ! [A: $tType,B3: multiset @ A,A4: multiset @ A] :
      ( ( subset_mset @ A @ B3 @ A4 )
     => ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ).

% subset_mset.atLeastatMost_empty
thf(fact_5434_subset__mset_OatLeastAtMost__singleton__iff,axiom,
    ! [A: $tType,A4: multiset @ A,B3: multiset @ A,C2: multiset @ A] :
      ( ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 @ B3 )
        = ( insert @ ( multiset @ A ) @ C2 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
      = ( ( A4 = B3 )
        & ( B3 = C2 ) ) ) ).

% subset_mset.atLeastAtMost_singleton_iff
thf(fact_5435_subset__mset_Oasymp__greater,axiom,
    ! [A: $tType] :
      ( asymp @ ( multiset @ A )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subset_mset @ A @ Y2 @ X2 ) ) ).

% subset_mset.asymp_greater
thf(fact_5436_subset__mset_Oirreflp__greater,axiom,
    ! [A: $tType] :
      ( irreflp @ ( multiset @ A )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subset_mset @ A @ Y2 @ X2 ) ) ).

% subset_mset.irreflp_greater
thf(fact_5437_subset__mset_Olexordp_Omono,axiom,
    ! [A: $tType] :
      ( order_mono @ ( ( list @ ( multiset @ A ) ) > ( list @ ( multiset @ A ) ) > $o ) @ ( ( list @ ( multiset @ A ) ) > ( list @ ( multiset @ A ) ) > $o )
      @ ^ [P6: ( list @ ( multiset @ A ) ) > ( list @ ( multiset @ A ) ) > $o,X1: list @ ( multiset @ A ),X22: list @ ( multiset @ A )] :
          ( ? [Y2: multiset @ A,Ys2: list @ ( multiset @ A )] :
              ( ( X1
                = ( nil @ ( multiset @ A ) ) )
              & ( X22
                = ( cons @ ( multiset @ A ) @ Y2 @ Ys2 ) ) )
          | ? [X2: multiset @ A,Y2: multiset @ A,Xs2: list @ ( multiset @ A ),Ys2: list @ ( multiset @ A )] :
              ( ( X1
                = ( cons @ ( multiset @ A ) @ X2 @ Xs2 ) )
              & ( X22
                = ( cons @ ( multiset @ A ) @ Y2 @ Ys2 ) )
              & ( subset_mset @ A @ X2 @ Y2 ) )
          | ? [X2: multiset @ A,Y2: multiset @ A,Xs2: list @ ( multiset @ A ),Ys2: list @ ( multiset @ A )] :
              ( ( X1
                = ( cons @ ( multiset @ A ) @ X2 @ Xs2 ) )
              & ( X22
                = ( cons @ ( multiset @ A ) @ Y2 @ Ys2 ) )
              & ~ ( subset_mset @ A @ X2 @ Y2 )
              & ~ ( subset_mset @ A @ Y2 @ X2 )
              & ( P6 @ Xs2 @ Ys2 ) ) ) ) ).

% subset_mset.lexordp.mono
thf(fact_5438_subset__mset_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp2 @ ( multiset @ A ) @ ( subset_mset @ A ) )
      = ( complete_lattice_lfp @ ( ( list @ ( multiset @ A ) ) > ( list @ ( multiset @ A ) ) > $o )
        @ ^ [P6: ( list @ ( multiset @ A ) ) > ( list @ ( multiset @ A ) ) > $o,X1: list @ ( multiset @ A ),X22: list @ ( multiset @ A )] :
            ( ? [Y2: multiset @ A,Ys2: list @ ( multiset @ A )] :
                ( ( X1
                  = ( nil @ ( multiset @ A ) ) )
                & ( X22
                  = ( cons @ ( multiset @ A ) @ Y2 @ Ys2 ) ) )
            | ? [X2: multiset @ A,Y2: multiset @ A,Xs2: list @ ( multiset @ A ),Ys2: list @ ( multiset @ A )] :
                ( ( X1
                  = ( cons @ ( multiset @ A ) @ X2 @ Xs2 ) )
                & ( X22
                  = ( cons @ ( multiset @ A ) @ Y2 @ Ys2 ) )
                & ( subset_mset @ A @ X2 @ Y2 ) )
            | ? [X2: multiset @ A,Y2: multiset @ A,Xs2: list @ ( multiset @ A ),Ys2: list @ ( multiset @ A )] :
                ( ( X1
                  = ( cons @ ( multiset @ A ) @ X2 @ Xs2 ) )
                & ( X22
                  = ( cons @ ( multiset @ A ) @ Y2 @ Ys2 ) )
                & ~ ( subset_mset @ A @ X2 @ Y2 )
                & ~ ( subset_mset @ A @ Y2 @ X2 )
                & ( P6 @ Xs2 @ Ys2 ) ) ) ) ) ).

% subset_mset.lexordp_def
thf(fact_5439_subset__mset_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( ordering_top @ ( multiset @ A )
      @ ^ [A6: multiset @ A,B5: multiset @ A] : ( subseteq_mset @ A @ B5 @ A6 )
      @ ^ [A6: multiset @ A,B5: multiset @ A] : ( subset_mset @ A @ B5 @ A6 )
      @ ( zero_zero @ ( multiset @ A ) ) ) ).

% subset_mset.ordering_top_axioms
thf(fact_5440_subset__mset_OSup__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( lattic4895041142388067077er_set @ ( multiset @ A ) @ ( union_mset @ A )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subseteq_mset @ A @ Y2 @ X2 )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subset_mset @ A @ Y2 @ X2 ) ) ).

% subset_mset.Sup_fin.semilattice_order_set_axioms
thf(fact_5441_wf__subset__mset__rel,axiom,
    ! [A: $tType] : ( wf @ ( multiset @ A ) @ ( collect @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_case_prod @ ( multiset @ A ) @ ( multiset @ A ) @ $o @ ( subset_mset @ A ) ) ) ) ).

% wf_subset_mset_rel
thf(fact_5442_subset__mset_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( semila1105856199041335345_order @ ( multiset @ A ) @ ( union_mset @ A ) @ ( zero_zero @ ( multiset @ A ) )
      @ ^ [A6: multiset @ A,B5: multiset @ A] : ( subseteq_mset @ A @ B5 @ A6 )
      @ ^ [A6: multiset @ A,B5: multiset @ A] : ( subset_mset @ A @ B5 @ A6 ) ) ).

% subset_mset.semilattice_neutr_order_axioms
thf(fact_5443_subset__mset_OatLeastAtMost__singleton_H,axiom,
    ! [A: $tType,A4: multiset @ A,B3: multiset @ A] :
      ( ( A4 = B3 )
     => ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 @ B3 )
        = ( insert @ ( multiset @ A ) @ A4 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ).

% subset_mset.atLeastAtMost_singleton'
thf(fact_5444_subset__mset_OcSUP__lessD,axiom,
    ! [B: $tType,A: $tType,F2: B > ( multiset @ A ),A3: set @ B,Y: multiset @ A,I3: B] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
     => ( ( subset_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) @ Y )
       => ( ( member @ B @ I3 @ A3 )
         => ( subset_mset @ A @ ( F2 @ I3 ) @ Y ) ) ) ) ).

% subset_mset.cSUP_lessD
thf(fact_5445_subset__mset_Oless__cINF__D,axiom,
    ! [A: $tType,B: $tType,F2: B > ( multiset @ A ),A3: set @ B,Y: multiset @ A,I3: B] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) )
     => ( ( subset_mset @ A @ Y @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F2 @ A3 ) ) )
       => ( ( member @ B @ I3 @ A3 )
         => ( subset_mset @ A @ Y @ ( F2 @ I3 ) ) ) ) ) ).

% subset_mset.less_cINF_D
thf(fact_5446_subset__mset_OgreaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType,A4: multiset @ A,B3: multiset @ A] :
      ( ( set_gr3752724095348155675AtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ A4 @ B3 )
      = ( minus_minus @ ( set @ ( multiset @ A ) ) @ ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 @ B3 ) @ ( insert @ ( multiset @ A ) @ A4 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ).

% subset_mset.greaterThanAtMost_eq_atLeastAtMost_diff
thf(fact_5447_subset__mset_OatLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType,A4: multiset @ A,B3: multiset @ A] :
      ( ( set_atLeastLessThan @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ A4 @ B3 )
      = ( minus_minus @ ( set @ ( multiset @ A ) ) @ ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 @ B3 ) @ ( insert @ ( multiset @ A ) @ B3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ).

% subset_mset.atLeastLessThan_eq_atLeastAtMost_diff
thf(fact_5448_subset__mset_OgreaterThanLessThan__empty,axiom,
    ! [A: $tType,L: multiset @ A,K: multiset @ A] :
      ( ( subseteq_mset @ A @ L @ K )
     => ( ( set_gr287244882034783167ssThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ K @ L )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ).

% subset_mset.greaterThanLessThan_empty
thf(fact_5449_subset__mset_OatLeastLessThan__empty,axiom,
    ! [A: $tType,B3: multiset @ A,A4: multiset @ A] :
      ( ( subseteq_mset @ A @ B3 @ A4 )
     => ( ( set_atLeastLessThan @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ).

% subset_mset.atLeastLessThan_empty
thf(fact_5450_subset__mset_OatLeastLessThan__empty__iff,axiom,
    ! [A: $tType,A4: multiset @ A,B3: multiset @ A] :
      ( ( ( set_atLeastLessThan @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
      = ( ~ ( subset_mset @ A @ A4 @ B3 ) ) ) ).

% subset_mset.atLeastLessThan_empty_iff
thf(fact_5451_subset__mset_OatLeastLessThan__empty__iff2,axiom,
    ! [A: $tType,A4: multiset @ A,B3: multiset @ A] :
      ( ( ( bot_bot @ ( set @ ( multiset @ A ) ) )
        = ( set_atLeastLessThan @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ A4 @ B3 ) )
      = ( ~ ( subset_mset @ A @ A4 @ B3 ) ) ) ).

% subset_mset.atLeastLessThan_empty_iff2
thf(fact_5452_subset__mset_OgreaterThanAtMost__empty,axiom,
    ! [A: $tType,L: multiset @ A,K: multiset @ A] :
      ( ( subseteq_mset @ A @ L @ K )
     => ( ( set_gr3752724095348155675AtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ K @ L )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ).

% subset_mset.greaterThanAtMost_empty
thf(fact_5453_subset__mset_OgreaterThanAtMost__empty__iff,axiom,
    ! [A: $tType,K: multiset @ A,L: multiset @ A] :
      ( ( ( set_gr3752724095348155675AtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ K @ L )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
      = ( ~ ( subset_mset @ A @ K @ L ) ) ) ).

% subset_mset.greaterThanAtMost_empty_iff
thf(fact_5454_subset__mset_OgreaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType,K: multiset @ A,L: multiset @ A] :
      ( ( ( bot_bot @ ( set @ ( multiset @ A ) ) )
        = ( set_gr3752724095348155675AtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ K @ L ) )
      = ( ~ ( subset_mset @ A @ K @ L ) ) ) ).

% subset_mset.greaterThanAtMost_empty_iff2
thf(fact_5455_subset__mset_OIio__Int__singleton,axiom,
    ! [A: $tType,X3: multiset @ A,K: multiset @ A] :
      ( ( ( subset_mset @ A @ X3 @ K )
       => ( ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_lessThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ K ) @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
          = ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) )
      & ( ~ ( subset_mset @ A @ X3 @ K )
       => ( ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_lessThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ K ) @ ( insert @ ( multiset @ A ) @ X3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
          = ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ).

% subset_mset.Iio_Int_singleton
thf(fact_5456_equivp__equiv,axiom,
    ! [A: $tType,A3: set @ ( product_prod @ A @ A )] :
      ( ( equiv_equiv @ A @ ( top_top @ ( set @ A ) ) @ A3 )
      = ( equiv_equivp @ A
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ A3 ) ) ) ).

% equivp_equiv
thf(fact_5457_asymp__asym__eq,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( asymp @ A
        @ ^ [A5: A,B4: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R ) )
      = ( asym @ A @ R ) ) ).

% asymp_asym_eq
thf(fact_5458_ord_OlessThan__def,axiom,
    ! [A: $tType] :
      ( ( set_lessThan @ A )
      = ( ^ [Less2: A > A > $o,U: A] :
            ( collect @ A
            @ ^ [X2: A] : ( Less2 @ X2 @ U ) ) ) ) ).

% ord.lessThan_def
thf(fact_5459_Quotient__crel__quotient,axiom,
    ! [B: $tType,A: $tType,R: A > A > $o,Abs: A > B,Rep: B > A,T2: A > B > $o] :
      ( ( quotient @ A @ B @ R @ Abs @ Rep @ T2 )
     => ( ( equiv_equivp @ A @ R )
       => ( T2
          = ( ^ [X2: A] :
                ( ^ [Y5: B,Z5: B] : ( Y5 = Z5 )
                @ ( Abs @ X2 ) ) ) ) ) ) ).

% Quotient_crel_quotient
thf(fact_5460_subset__mset_OlessThan__def,axiom,
    ! [A: $tType,U2: multiset @ A] :
      ( ( set_lessThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ U2 )
      = ( collect @ ( multiset @ A )
        @ ^ [X2: multiset @ A] : ( subset_mset @ A @ X2 @ U2 ) ) ) ).

% subset_mset.lessThan_def
thf(fact_5461_subset__mset_OatLeastLessThan__def,axiom,
    ! [A: $tType,L: multiset @ A,U2: multiset @ A] :
      ( ( set_atLeastLessThan @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ L @ U2 )
      = ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_atLeast @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ L ) @ ( set_lessThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ U2 ) ) ) ).

% subset_mset.atLeastLessThan_def
thf(fact_5462_subset__mset_OgreaterThanLessThan__eq,axiom,
    ! [A: $tType,A4: multiset @ A,B3: multiset @ A] :
      ( ( set_gr287244882034783167ssThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ A4 @ B3 )
      = ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_greaterThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ A4 ) @ ( set_lessThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ B3 ) ) ) ).

% subset_mset.greaterThanLessThan_eq
thf(fact_5463_subset__mset_OgreaterThanLessThan__def,axiom,
    ! [A: $tType,L: multiset @ A,U2: multiset @ A] :
      ( ( set_gr287244882034783167ssThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ L @ U2 )
      = ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_greaterThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ L ) @ ( set_lessThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ U2 ) ) ) ).

% subset_mset.greaterThanLessThan_def
thf(fact_5464_ord_OgreaterThan__def,axiom,
    ! [A: $tType] :
      ( ( set_greaterThan @ A )
      = ( ^ [Less2: A > A > $o,L2: A] : ( collect @ A @ ( Less2 @ L2 ) ) ) ) ).

% ord.greaterThan_def
thf(fact_5465_ord_OatLeast__def,axiom,
    ! [A: $tType] :
      ( ( set_atLeast @ A )
      = ( ^ [Less_eq2: A > A > $o,L2: A] : ( collect @ A @ ( Less_eq2 @ L2 ) ) ) ) ).

% ord.atLeast_def
thf(fact_5466_subset__mset_OatLeast__def,axiom,
    ! [A: $tType,L: multiset @ A] :
      ( ( set_atLeast @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ L )
      = ( collect @ ( multiset @ A ) @ ( subseteq_mset @ A @ L ) ) ) ).

% subset_mset.atLeast_def
thf(fact_5467_subset__mset_OgreaterThan__def,axiom,
    ! [A: $tType,L: multiset @ A] :
      ( ( set_greaterThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ L )
      = ( collect @ ( multiset @ A ) @ ( subset_mset @ A @ L ) ) ) ).

% subset_mset.greaterThan_def
thf(fact_5468_subset__mset_Onot__empty__eq__Ici__eq__empty,axiom,
    ! [A: $tType,L: multiset @ A] :
      ( ( bot_bot @ ( set @ ( multiset @ A ) ) )
     != ( set_atLeast @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ L ) ) ).

% subset_mset.not_empty_eq_Ici_eq_empty
thf(fact_5469_ord_OgreaterThanLessThan__eq,axiom,
    ! [A: $tType] :
      ( ( set_gr287244882034783167ssThan @ A )
      = ( ^ [Less2: A > A > $o,A5: A,B4: A] : ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less2 @ A5 ) @ ( set_lessThan @ A @ Less2 @ B4 ) ) ) ) ).

% ord.greaterThanLessThan_eq
thf(fact_5470_ord_OgreaterThanLessThan__def,axiom,
    ! [A: $tType] :
      ( ( set_gr287244882034783167ssThan @ A )
      = ( ^ [Less2: A > A > $o,L2: A,U: A] : ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less2 @ L2 ) @ ( set_lessThan @ A @ Less2 @ U ) ) ) ) ).

% ord.greaterThanLessThan_def
thf(fact_5471_ord_OatLeastLessThan__def,axiom,
    ! [A: $tType] :
      ( ( set_atLeastLessThan @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o,L2: A,U: A] : ( inf_inf @ ( set @ A ) @ ( set_atLeast @ A @ Less_eq2 @ L2 ) @ ( set_lessThan @ A @ Less2 @ U ) ) ) ) ).

% ord.atLeastLessThan_def
thf(fact_5472_subset__mset_OgreaterThanAtMost__def,axiom,
    ! [A: $tType,L: multiset @ A,U2: multiset @ A] :
      ( ( set_gr3752724095348155675AtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ L @ U2 )
      = ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_greaterThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ L ) @ ( set_atMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ U2 ) ) ) ).

% subset_mset.greaterThanAtMost_def
thf(fact_5473_ord_OgreaterThanAtMost__def,axiom,
    ! [A: $tType] :
      ( ( set_gr3752724095348155675AtMost @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o,L2: A,U: A] : ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less2 @ L2 ) @ ( set_atMost @ A @ Less_eq2 @ U ) ) ) ) ).

% ord.greaterThanAtMost_def
thf(fact_5474_ord_OatLeastAtMost__def,axiom,
    ! [A: $tType] :
      ( ( set_atLeastAtMost @ A )
      = ( ^ [Less_eq2: A > A > $o,L2: A,U: A] : ( inf_inf @ ( set @ A ) @ ( set_atLeast @ A @ Less_eq2 @ L2 ) @ ( set_atMost @ A @ Less_eq2 @ U ) ) ) ) ).

% ord.atLeastAtMost_def
thf(fact_5475_ord_OatMost__def,axiom,
    ! [A: $tType] :
      ( ( set_atMost @ A )
      = ( ^ [Less_eq2: A > A > $o,U: A] :
            ( collect @ A
            @ ^ [X2: A] : ( Less_eq2 @ X2 @ U ) ) ) ) ).

% ord.atMost_def
thf(fact_5476_subset__mset_OatMost__def,axiom,
    ! [A: $tType,U2: multiset @ A] :
      ( ( set_atMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ U2 )
      = ( collect @ ( multiset @ A )
        @ ^ [X2: multiset @ A] : ( subseteq_mset @ A @ X2 @ U2 ) ) ) ).

% subset_mset.atMost_def
thf(fact_5477_subset__mset_Onot__empty__eq__Iic__eq__empty,axiom,
    ! [A: $tType,H2: multiset @ A] :
      ( ( bot_bot @ ( set @ ( multiset @ A ) ) )
     != ( set_atMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ H2 ) ) ).

% subset_mset.not_empty_eq_Iic_eq_empty
thf(fact_5478_subset__mset_OatLeastAtMost__def,axiom,
    ! [A: $tType,L: multiset @ A,U2: multiset @ A] :
      ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ L @ U2 )
      = ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_atLeast @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ L ) @ ( set_atMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ U2 ) ) ) ).

% subset_mset.atLeastAtMost_def
thf(fact_5479_Shift__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Greatest_Shift @ A )
      = ( ^ [Kl: set @ ( list @ A ),K6: A] :
            ( collect @ ( list @ A )
            @ ^ [Kl2: list @ A] : ( member @ ( list @ A ) @ ( cons @ A @ K6 @ Kl2 ) @ Kl ) ) ) ) ).

% Shift_def
thf(fact_5480_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_5481_bit__double__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A4: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A4 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            & ( N
             != ( zero_zero @ nat ) )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% bit_double_iff
thf(fact_5482_bit__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
          = ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ).

% bit_minus_1_iff
thf(fact_5483_bit__minus__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A4: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ A4 ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% bit_minus_iff
thf(fact_5484_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ M2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ord_less_eq @ nat @ M2 @ N )
                & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) ).

% drop_bit_exp_eq
thf(fact_5485_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A4: A,N: nat] :
          ( ( divide_divide @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ A4 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_5486_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N5: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N5 @ A5 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_5487_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ A ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ N @ M2 ) ) ) ) ).

% bit_mask_sub_iff
thf(fact_5488_old_Orec__unit__def,axiom,
    ! [T: $tType] :
      ( ( product_rec_unit @ T )
      = ( ^ [F15: T,X2: product_unit] : ( the @ T @ ( product_rec_set_unit @ T @ F15 @ X2 ) ) ) ) ).

% old.rec_unit_def
thf(fact_5489_Gcd__Lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A )
        = ( ^ [A6: set @ A] :
              ( gcd_Lcm @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                   => ( dvd_dvd @ A @ B4 @ X2 ) ) ) ) ) ) ) ).

% Gcd_Lcm
thf(fact_5490_Lcm__Gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Lcm @ A )
        = ( ^ [A6: set @ A] :
              ( gcd_Gcd @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                   => ( dvd_dvd @ A @ X2 @ B4 ) ) ) ) ) ) ) ).

% Lcm_Gcd
thf(fact_5491_Lcm__abs__eq,axiom,
    ! [K5: set @ int] :
      ( ( gcd_Lcm @ int @ ( image2 @ int @ int @ ( abs_abs @ int ) @ K5 ) )
      = ( gcd_Lcm @ int @ K5 ) ) ).

% Lcm_abs_eq
thf(fact_5492_Lcm__int__eq,axiom,
    ! [N4: set @ nat] :
      ( ( gcd_Lcm @ int @ ( image2 @ nat @ int @ ( semiring_1_of_nat @ int ) @ N4 ) )
      = ( semiring_1_of_nat @ int @ ( gcd_Lcm @ nat @ N4 ) ) ) ).

% Lcm_int_eq
thf(fact_5493_Lcm__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Lcm @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Lcm_empty
thf(fact_5494_Lcm__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( gcd_Lcm @ A @ A3 )
            = ( one_one @ A ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A3 )
               => ( dvd_dvd @ A @ X2 @ ( one_one @ A ) ) ) ) ) ) ).

% Lcm_1_iff
thf(fact_5495_Lcm__nat__abs__eq,axiom,
    ! [K5: set @ int] :
      ( ( gcd_Lcm @ nat
        @ ( image2 @ int @ nat
          @ ^ [K6: int] : ( nat2 @ ( abs_abs @ int @ K6 ) )
          @ K5 ) )
      = ( nat2 @ ( gcd_Lcm @ int @ K5 ) ) ) ).

% Lcm_nat_abs_eq
thf(fact_5496_Lcm__nat__empty,axiom,
    ( ( gcd_Lcm @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( one_one @ nat ) ) ).

% Lcm_nat_empty
thf(fact_5497_Lcm__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ! [X: B] :
              ( ( member @ B @ X @ A3 )
             => ( dvd_dvd @ A @ ( F2 @ X ) @ ( G @ X ) ) )
         => ( dvd_dvd @ A @ ( gcd_Lcm @ A @ ( image2 @ B @ A @ F2 @ A3 ) ) @ ( gcd_Lcm @ A @ ( image2 @ B @ A @ G @ A3 ) ) ) ) ) ).

% Lcm_mono
thf(fact_5498_Gcd__nat__def,axiom,
    ( ( gcd_Gcd @ nat )
    = ( ^ [M8: set @ nat] :
          ( gcd_Lcm @ nat
          @ ( collect @ nat
            @ ^ [D4: nat] :
              ! [X2: nat] :
                ( ( member @ nat @ X2 @ M8 )
               => ( dvd_dvd @ nat @ D4 @ X2 ) ) ) ) ) ) ).

% Gcd_nat_def
thf(fact_5499_Lcm__int__def,axiom,
    ( ( gcd_Lcm @ int )
    = ( ^ [K7: set @ int] : ( semiring_1_of_nat @ int @ ( gcd_Lcm @ nat @ ( image2 @ int @ nat @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) @ K7 ) ) ) ) ) ).

% Lcm_int_def
thf(fact_5500_Lcm__no__units,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Lcm @ A )
        = ( ^ [A6: set @ A] :
              ( gcd_Lcm @ A
              @ ( minus_minus @ ( set @ A ) @ A6
                @ ( collect @ A
                  @ ^ [A5: A] : ( dvd_dvd @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% Lcm_no_units
thf(fact_5501_Lcm__coprime_H,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( finite_card @ A @ A3 )
           != ( zero_zero @ nat ) )
         => ( ! [A7: A,B6: A] :
                ( ( member @ A @ A7 @ A3 )
               => ( ( member @ A @ B6 @ A3 )
                 => ( ( A7 != B6 )
                   => ( algebr8660921524188924756oprime @ A @ A7 @ B6 ) ) ) )
           => ( ( gcd_Lcm @ A @ A3 )
              = ( normal6383669964737779283malize @ A
                @ ( groups7121269368397514597t_prod @ A @ A
                  @ ^ [X2: A] : X2
                  @ A3 ) ) ) ) ) ) ).

% Lcm_coprime'
thf(fact_5502_Lcm__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A7: A,B6: A] :
                  ( ( member @ A @ A7 @ A3 )
                 => ( ( member @ A @ B6 @ A3 )
                   => ( ( A7 != B6 )
                     => ( algebr8660921524188924756oprime @ A @ A7 @ B6 ) ) ) )
             => ( ( gcd_Lcm @ A @ A3 )
                = ( normal6383669964737779283malize @ A
                  @ ( groups7121269368397514597t_prod @ A @ A
                    @ ^ [X2: A] : X2
                    @ A3 ) ) ) ) ) ) ) ).

% Lcm_coprime
thf(fact_5503_Lcm__eq__Max__nat,axiom,
    ! [M: set @ nat] :
      ( ( finite_finite2 @ nat @ M )
     => ( ( M
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M )
         => ( ! [M3: nat,N2: nat] :
                ( ( member @ nat @ M3 @ M )
               => ( ( member @ nat @ N2 @ M )
                 => ( member @ nat @ ( gcd_lcm @ nat @ M3 @ N2 ) @ M ) ) )
           => ( ( gcd_Lcm @ nat @ M )
              = ( lattic643756798349783984er_Max @ nat @ M ) ) ) ) ) ) ).

% Lcm_eq_Max_nat
thf(fact_5504_normalize__idem,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( normal6383669964737779283malize @ A @ ( normal6383669964737779283malize @ A @ A4 ) )
          = ( normal6383669964737779283malize @ A @ A4 ) ) ) ).

% normalize_idem
thf(fact_5505_normalize__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( ( normal6383669964737779283malize @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% normalize_eq_0_iff
thf(fact_5506_normalize__0,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ( ( normal6383669964737779283malize @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% normalize_0
thf(fact_5507_normalize__mult__normalize__left,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ ( normal6383669964737779283malize @ A @ A4 ) @ B3 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A4 @ B3 ) ) ) ) ).

% normalize_mult_normalize_left
thf(fact_5508_normalize__mult__normalize__right,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A4 @ ( normal6383669964737779283malize @ A @ B3 ) ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A4 @ B3 ) ) ) ) ).

% normalize_mult_normalize_right
thf(fact_5509_normalize__1,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ( ( normal6383669964737779283malize @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% normalize_1
thf(fact_5510_gcd_Onormalize__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( normal6383669964737779283malize @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% gcd.normalize_bottom
thf(fact_5511_normalize__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ ( normal6383669964737779283malize @ A @ A4 ) @ B3 )
          = ( dvd_dvd @ A @ A4 @ B3 ) ) ) ).

% normalize_dvd_iff
thf(fact_5512_dvd__normalize__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( normal6383669964737779283malize @ A @ B3 ) )
          = ( dvd_dvd @ A @ A4 @ B3 ) ) ) ).

% dvd_normalize_iff
thf(fact_5513_coprime__normalize__right__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ A4 @ ( normal6383669964737779283malize @ A @ B3 ) )
          = ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ).

% coprime_normalize_right_iff
thf(fact_5514_coprime__normalize__left__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( normal6383669964737779283malize @ A @ A4 ) @ B3 )
          = ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ).

% coprime_normalize_left_iff
thf(fact_5515_lcm__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( ( gcd_lcm @ A @ A4 @ B3 )
            = ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B3 @ ( one_one @ A ) ) ) ) ) ).

% lcm_eq_1_iff
thf(fact_5516_lcm_Otop__left__normalize,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A] :
          ( ( gcd_lcm @ A @ ( one_one @ A ) @ A4 )
          = ( normal6383669964737779283malize @ A @ A4 ) ) ) ).

% lcm.top_left_normalize
thf(fact_5517_lcm_Otop__right__normalize,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A] :
          ( ( gcd_lcm @ A @ A4 @ ( one_one @ A ) )
          = ( normal6383669964737779283malize @ A @ A4 ) ) ) ).

% lcm.top_right_normalize
thf(fact_5518_normalize__mult__unit__left,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A4 @ B3 ) )
            = ( normal6383669964737779283malize @ A @ B3 ) ) ) ) ).

% normalize_mult_unit_left
thf(fact_5519_normalize__mult__unit__right,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [B3: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ ( one_one @ A ) )
         => ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A4 @ B3 ) )
            = ( normal6383669964737779283malize @ A @ A4 ) ) ) ) ).

% normalize_mult_unit_right
thf(fact_5520_gcd__mult__lcm,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A4: A,B3: A] :
          ( ( times_times @ A @ ( gcd_gcd @ A @ A4 @ B3 ) @ ( gcd_lcm @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( normal6383669964737779283malize @ A @ A4 ) @ ( normal6383669964737779283malize @ A @ B3 ) ) ) ) ).

% gcd_mult_lcm
thf(fact_5521_lcm__mult__gcd,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A4: A,B3: A] :
          ( ( times_times @ A @ ( gcd_lcm @ A @ A4 @ B3 ) @ ( gcd_gcd @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( normal6383669964737779283malize @ A @ A4 ) @ ( normal6383669964737779283malize @ A @ B3 ) ) ) ) ).

% lcm_mult_gcd
thf(fact_5522_Lcm__2,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( gcd_Lcm @ A @ ( insert @ A @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( gcd_lcm @ A @ A4 @ B3 ) ) ) ).

% Lcm_2
thf(fact_5523_Lcm__singleton,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: A] :
          ( ( gcd_Lcm @ A @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
          = ( normal6383669964737779283malize @ A @ A4 ) ) ) ).

% Lcm_singleton
thf(fact_5524_Gcd__singleton,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: A] :
          ( ( gcd_Gcd @ A @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
          = ( normal6383669964737779283malize @ A @ A4 ) ) ) ).

% Gcd_singleton
thf(fact_5525_coprime__crossproduct,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,D3: A,B3: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A4 @ D3 )
         => ( ( algebr8660921524188924756oprime @ A @ B3 @ C2 )
           => ( ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ A4 ) @ ( normal6383669964737779283malize @ A @ C2 ) )
                = ( times_times @ A @ ( normal6383669964737779283malize @ A @ B3 ) @ ( normal6383669964737779283malize @ A @ D3 ) ) )
              = ( ( ( normal6383669964737779283malize @ A @ A4 )
                  = ( normal6383669964737779283malize @ A @ B3 ) )
                & ( ( normal6383669964737779283malize @ A @ C2 )
                  = ( normal6383669964737779283malize @ A @ D3 ) ) ) ) ) ) ) ).

% coprime_crossproduct
thf(fact_5526_dvd__normalize__div,axiom,
    ! [A: $tType] :
      ( ( normal6328177297339901930cative @ A )
     => ! [B3: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ A4 )
         => ( ( normal6383669964737779283malize @ A @ ( divide_divide @ A @ A4 @ B3 ) )
            = ( divide_divide @ A @ ( normal6383669964737779283malize @ A @ A4 ) @ ( normal6383669964737779283malize @ A @ B3 ) ) ) ) ) ).

% dvd_normalize_div
thf(fact_5527_associated__unit,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( ( normal6383669964737779283malize @ A @ A4 )
            = ( normal6383669964737779283malize @ A @ B3 ) )
         => ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ B3 @ ( one_one @ A ) ) ) ) ) ).

% associated_unit
thf(fact_5528_normalize__1__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( ( normal6383669964737779283malize @ A @ A4 )
            = ( one_one @ A ) )
          = ( dvd_dvd @ A @ A4 @ ( one_one @ A ) ) ) ) ).

% normalize_1_iff
thf(fact_5529_is__unit__normalize,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( normal6383669964737779283malize @ A @ A4 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_normalize
thf(fact_5530_normalize__idem__imp__is__unit__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( ( normal6383669964737779283malize @ A @ A4 )
            = A4 )
         => ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
            = ( A4
              = ( one_one @ A ) ) ) ) ) ).

% normalize_idem_imp_is_unit_iff
thf(fact_5531_gcd__lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( B3
             != ( zero_zero @ A ) )
           => ( ( gcd_gcd @ A @ A4 @ B3 )
              = ( normal6383669964737779283malize @ A @ ( divide_divide @ A @ ( times_times @ A @ A4 @ B3 ) @ ( gcd_lcm @ A @ A4 @ B3 ) ) ) ) ) ) ) ).

% gcd_lcm
thf(fact_5532_associated__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( ( normal6383669964737779283malize @ A @ A4 )
            = ( normal6383669964737779283malize @ A @ B3 ) )
          = ( ( dvd_dvd @ A @ A4 @ B3 )
            & ( dvd_dvd @ A @ B3 @ A4 ) ) ) ) ).

% associated_iff_dvd
thf(fact_5533_associated__eqI,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( ( dvd_dvd @ A @ B3 @ A4 )
           => ( ( ( normal6383669964737779283malize @ A @ A4 )
                = A4 )
             => ( ( ( normal6383669964737779283malize @ A @ B3 )
                  = B3 )
               => ( A4 = B3 ) ) ) ) ) ) ).

% associated_eqI
thf(fact_5534_associatedD2,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( ( normal6383669964737779283malize @ A @ A4 )
            = ( normal6383669964737779283malize @ A @ B3 ) )
         => ( dvd_dvd @ A @ B3 @ A4 ) ) ) ).

% associatedD2
thf(fact_5535_associatedD1,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( ( normal6383669964737779283malize @ A @ A4 )
            = ( normal6383669964737779283malize @ A @ B3 ) )
         => ( dvd_dvd @ A @ A4 @ B3 ) ) ) ).

% associatedD1
thf(fact_5536_associatedI,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ B3 )
         => ( ( dvd_dvd @ A @ B3 @ A4 )
           => ( ( normal6383669964737779283malize @ A @ A4 )
              = ( normal6383669964737779283malize @ A @ B3 ) ) ) ) ) ).

% associatedI
thf(fact_5537_normalize__mult,axiom,
    ! [A: $tType] :
      ( ( normal6328177297339901930cative @ A )
     => ! [A4: A,B3: A] :
          ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( normal6383669964737779283malize @ A @ A4 ) @ ( normal6383669964737779283malize @ A @ B3 ) ) ) ) ).

% normalize_mult
thf(fact_5538_lcm__mult__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( gcd_lcm @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_lcm @ A @ A4 @ B3 ) ) ) ) ) ).

% lcm_mult_left
thf(fact_5539_lcm__mult__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( gcd_lcm @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ ( gcd_lcm @ A @ B3 @ A4 ) @ C2 ) ) ) ) ).

% lcm_mult_right
thf(fact_5540_lcm__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ C2 ) @ ( gcd_lcm @ A @ A4 @ B3 ) )
          = ( gcd_lcm @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) ) ) ) ).

% lcm_mult_distrib'
thf(fact_5541_lcm__gcd__prod,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A4: A,B3: A] :
          ( ( times_times @ A @ ( gcd_lcm @ A @ A4 @ B3 ) @ ( gcd_gcd @ A @ A4 @ B3 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A4 @ B3 ) ) ) ) ).

% lcm_gcd_prod
thf(fact_5542_lcm__gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( gcd_lcm @ A )
        = ( ^ [A5: A,B4: A] : ( normal6383669964737779283malize @ A @ ( divide_divide @ A @ ( times_times @ A @ A5 @ B4 ) @ ( gcd_gcd @ A @ A5 @ B4 ) ) ) ) ) ) ).

% lcm_gcd
thf(fact_5543_Lcm__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde6485984586167503788ce_set @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% Lcm_fin.bounded_quasi_semilattice_set_axioms
thf(fact_5544_lcm__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( algebr8660921524188924756oprime @ A @ A4 @ B3 )
         => ( ( gcd_lcm @ A @ A4 @ B3 )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A4 @ B3 ) ) ) ) ) ).

% lcm_coprime
thf(fact_5545_gcd__mult__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_gcd @ A @ A4 @ B3 ) ) ) ) ) ).

% gcd_mult_left
thf(fact_5546_gcd__mult__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,C2: A,B3: A] :
          ( ( gcd_gcd @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ ( gcd_gcd @ A @ B3 @ A4 ) @ C2 ) ) ) ) ).

% gcd_mult_right
thf(fact_5547_gcd__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ C2 ) @ ( gcd_gcd @ A @ A4 @ B3 ) )
          = ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) ) ) ) ).

% gcd_mult_distrib'
thf(fact_5548_Lcm__in__lcm__closed__set__nat,axiom,
    ! [M: set @ nat] :
      ( ( finite_finite2 @ nat @ M )
     => ( ( M
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ! [M3: nat,N2: nat] :
              ( ( member @ nat @ M3 @ M )
             => ( ( member @ nat @ N2 @ M )
               => ( member @ nat @ ( gcd_lcm @ nat @ M3 @ N2 ) @ M ) ) )
         => ( member @ nat @ ( gcd_Lcm @ nat @ M ) @ M ) ) ) ) ).

% Lcm_in_lcm_closed_set_nat
thf(fact_5549_lcm__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ ( times_times @ A @ B3 @ A4 ) @ C2 )
            = ( gcd_lcm @ A @ B3 @ C2 ) ) ) ) ).

% lcm_mult_unit1
thf(fact_5550_lcm__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ B3 @ ( times_times @ A @ C2 @ A4 ) )
            = ( gcd_lcm @ A @ B3 @ C2 ) ) ) ) ).

% lcm_mult_unit2
thf(fact_5551_lcm__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ B3 @ ( divide_divide @ A @ C2 @ A4 ) )
            = ( gcd_lcm @ A @ B3 @ C2 ) ) ) ) ).

% lcm_div_unit2
thf(fact_5552_lcm__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ ( divide_divide @ A @ B3 @ A4 ) @ C2 )
            = ( gcd_lcm @ A @ B3 @ C2 ) ) ) ) ).

% lcm_div_unit1
thf(fact_5553_Gcd__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [C2: A,A3: set @ A] :
          ( ( gcd_Gcd @ A @ ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ A3 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_Gcd @ A @ A3 ) ) ) ) ) ).

% Gcd_mult
thf(fact_5554_Lcm__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A,C2: A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( gcd_Lcm @ A @ ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ A3 ) )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_Lcm @ A @ A3 ) ) ) ) ) ) ).

% Lcm_mult
thf(fact_5555_Gcd__fin__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A,B3: A] :
          ( ( finite_finite2 @ A @ A3 )
         => ( ( semiring_gcd_Gcd_fin @ A @ ( image2 @ A @ A @ ( times_times @ A @ B3 ) @ A3 ) )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ B3 @ ( semiring_gcd_Gcd_fin @ A @ A3 ) ) ) ) ) ) ).

% Gcd_fin_mult
thf(fact_5556_Lcm__set__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [Xs: list @ A] :
          ( ( gcd_Lcm @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_lcm @ A ) @ Xs @ ( one_one @ A ) ) ) ) ).

% Lcm_set_eq_fold
thf(fact_5557_Gcd__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde6485984586167503788ce_set @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% Gcd_fin.bounded_quasi_semilattice_set_axioms
thf(fact_5558_Lcm__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Lcm_fin @ A )
        = ( ^ [A6: set @ A] : ( if @ A @ ( finite_finite2 @ A @ A6 ) @ ( finite_fold @ A @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ A6 ) @ ( zero_zero @ A ) ) ) ) ) ).

% Lcm_fin.eq_fold
thf(fact_5559_lcm_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde8507323023520639062attice @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% lcm.bounded_quasi_semilattice_axioms
thf(fact_5560_gcd_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde8507323023520639062attice @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% gcd.bounded_quasi_semilattice_axioms
thf(fact_5561_Lcm__fin_Oempty,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Lcm_fin @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Lcm_fin.empty
thf(fact_5562_is__unit__Lcm__fin__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A] :
          ( ( dvd_dvd @ A @ ( semiring_gcd_Lcm_fin @ A @ A3 ) @ ( one_one @ A ) )
          = ( ( semiring_gcd_Lcm_fin @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_Lcm_fin_iff
thf(fact_5563_Lcm__fin__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( semiring_gcd_Lcm_fin @ A @ A3 )
            = ( one_one @ A ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A3 )
               => ( dvd_dvd @ A @ X2 @ ( one_one @ A ) ) )
            & ( finite_finite2 @ A @ A3 ) ) ) ) ).

% Lcm_fin_1_iff
thf(fact_5564_Lcm__fin__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A,B3: A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( semiring_gcd_Lcm_fin @ A @ ( image2 @ A @ A @ ( times_times @ A @ B3 ) @ A3 ) )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ B3 @ ( semiring_gcd_Lcm_fin @ A @ A3 ) ) ) ) ) ) ).

% Lcm_fin_mult
thf(fact_5565_Lcm__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,A3: set @ A] :
          ( ( semiring_gcd_Lcm_fin @ A @ ( insert @ A @ A4 @ A3 ) )
          = ( gcd_lcm @ A @ A4 @ ( semiring_gcd_Lcm_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% Lcm_fin.insert_remove
thf(fact_5566_Lcm__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,A3: set @ A] :
          ( ( member @ A @ A4 @ A3 )
         => ( ( semiring_gcd_Lcm_fin @ A @ A3 )
            = ( gcd_lcm @ A @ A4 @ ( semiring_gcd_Lcm_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% Lcm_fin.remove
thf(fact_5567_Lcm__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Xs: list @ A] :
          ( ( semiring_gcd_Lcm_fin @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_lcm @ A ) @ Xs @ ( one_one @ A ) ) ) ) ).

% Lcm_fin.set_eq_fold
thf(fact_5568_Lcm__fin__def,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Lcm_fin @ A )
        = ( bounde2362111253966948842tice_F @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ).

% Lcm_fin_def
thf(fact_5569_combine__options__def,axiom,
    ! [A: $tType] :
      ( ( combine_options @ A )
      = ( ^ [F3: A > A > A,X2: option @ A,Y2: option @ A] :
            ( case_option @ ( option @ A ) @ A @ Y2
            @ ^ [Z3: A] :
                ( case_option @ ( option @ A ) @ A @ ( some @ A @ Z3 )
                @ ^ [Aa2: A] : ( some @ A @ ( F3 @ Z3 @ Aa2 ) )
                @ Y2 )
            @ X2 ) ) ) ).

% combine_options_def
thf(fact_5570_inv__image__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( inv_image @ B @ A )
      = ( ^ [R3: set @ ( product_prod @ B @ B ),F3: A > B] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F3 @ X2 ) @ ( F3 @ Y2 ) ) @ R3 ) ) ) ) ) ).

% inv_image_def
thf(fact_5571_normalize__div,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( divide_divide @ A @ ( normal6383669964737779283malize @ A @ A4 ) @ A4 )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( unit_f5069060285200089521factor @ A @ A4 ) ) ) ) ).

% normalize_div
thf(fact_5572_unit__factor__idem,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( unit_f5069060285200089521factor @ A @ ( unit_f5069060285200089521factor @ A @ A4 ) )
          = ( unit_f5069060285200089521factor @ A @ A4 ) ) ) ).

% unit_factor_idem
thf(fact_5573_unit__factor__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( ( unit_f5069060285200089521factor @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% unit_factor_eq_0_iff
thf(fact_5574_unit__factor__0,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ( ( unit_f5069060285200089521factor @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% unit_factor_0
thf(fact_5575_unit__factor__1,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ( ( unit_f5069060285200089521factor @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% unit_factor_1
thf(fact_5576_normalize__mult__unit__factor,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ A4 ) @ ( unit_f5069060285200089521factor @ A @ A4 ) )
          = A4 ) ) ).

% normalize_mult_unit_factor
thf(fact_5577_unit__factor__mult__normalize,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ A4 ) @ ( normal6383669964737779283malize @ A @ A4 ) )
          = A4 ) ) ).

% unit_factor_mult_normalize
thf(fact_5578_div__unit__factor,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( divide_divide @ A @ A4 @ ( unit_f5069060285200089521factor @ A @ A4 ) )
          = ( normal6383669964737779283malize @ A @ A4 ) ) ) ).

% div_unit_factor
thf(fact_5579_div__normalize,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( divide_divide @ A @ A4 @ ( normal6383669964737779283malize @ A @ A4 ) )
          = ( unit_f5069060285200089521factor @ A @ A4 ) ) ) ).

% div_normalize
thf(fact_5580_inv__unit__factor__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ ( unit_f5069060285200089521factor @ A @ A4 ) )
            = ( zero_zero @ A ) )
          = ( A4
            = ( zero_zero @ A ) ) ) ) ).

% inv_unit_factor_eq_0_iff
thf(fact_5581_unit__factor__mult__unit__left,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ ( times_times @ A @ A4 @ B3 ) )
            = ( times_times @ A @ A4 @ ( unit_f5069060285200089521factor @ A @ B3 ) ) ) ) ) ).

% unit_factor_mult_unit_left
thf(fact_5582_unit__factor__mult__unit__right,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A4: A,B3: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ ( times_times @ A @ B3 @ A4 ) )
            = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ B3 ) @ A4 ) ) ) ) ).

% unit_factor_mult_unit_right
thf(fact_5583_mult__one__div__unit__factor,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( times_times @ A @ A4 @ ( divide_divide @ A @ ( one_one @ A ) @ ( unit_f5069060285200089521factor @ A @ B3 ) ) )
          = ( divide_divide @ A @ A4 @ ( unit_f5069060285200089521factor @ A @ B3 ) ) ) ) ).

% mult_one_div_unit_factor
thf(fact_5584_unit__factor__lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( ( ( A4
                = ( zero_zero @ A ) )
              | ( B3
                = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_lcm @ A @ A4 @ B3 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ( A4
                  = ( zero_zero @ A ) )
                | ( B3
                  = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_lcm @ A @ A4 @ B3 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_lcm
thf(fact_5585_unit__factor__normalize,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ ( normal6383669964737779283malize @ A @ A4 ) )
            = ( one_one @ A ) ) ) ) ).

% unit_factor_normalize
thf(fact_5586_normalize__unit__factor,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( ( normal6383669964737779283malize @ A @ ( unit_f5069060285200089521factor @ A @ A4 ) )
            = ( one_one @ A ) ) ) ) ).

% normalize_unit_factor
thf(fact_5587_unit__factor__self,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] : ( dvd_dvd @ A @ ( unit_f5069060285200089521factor @ A @ A4 ) @ A4 ) ) ).

% unit_factor_self
thf(fact_5588_unit__factor__mult,axiom,
    ! [A: $tType] :
      ( ( normal6328177297339901930cative @ A )
     => ! [A4: A,B3: A] :
          ( ( unit_f5069060285200089521factor @ A @ ( times_times @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ A4 ) @ ( unit_f5069060285200089521factor @ A @ B3 ) ) ) ) ).

% unit_factor_mult
thf(fact_5589_normalize__unit__factor__eqI,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( ( normal6383669964737779283malize @ A @ A4 )
            = ( normal6383669964737779283malize @ A @ B3 ) )
         => ( ( ( unit_f5069060285200089521factor @ A @ A4 )
              = ( unit_f5069060285200089521factor @ A @ B3 ) )
           => ( A4 = B3 ) ) ) ) ).

% normalize_unit_factor_eqI
thf(fact_5590_unit__factor__dvd,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A,B3: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ ( unit_f5069060285200089521factor @ A @ A4 ) @ B3 ) ) ) ).

% unit_factor_dvd
thf(fact_5591_is__unit__unit__factor,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A4: A] :
          ( ( dvd_dvd @ A @ A4 @ ( one_one @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ A4 )
            = A4 ) ) ) ).

% is_unit_unit_factor
thf(fact_5592_dvd__unit__factor__div,axiom,
    ! [A: $tType] :
      ( ( normal6328177297339901930cative @ A )
     => ! [B3: A,A4: A] :
          ( ( dvd_dvd @ A @ B3 @ A4 )
         => ( ( unit_f5069060285200089521factor @ A @ ( divide_divide @ A @ A4 @ B3 ) )
            = ( divide_divide @ A @ ( unit_f5069060285200089521factor @ A @ A4 ) @ ( unit_f5069060285200089521factor @ A @ B3 ) ) ) ) ) ).

% dvd_unit_factor_div
thf(fact_5593_gcd__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [K: A,A4: A,B3: A] :
          ( ( times_times @ A @ K @ ( gcd_gcd @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( gcd_gcd @ A @ ( times_times @ A @ K @ A4 ) @ ( times_times @ A @ K @ B3 ) ) @ ( unit_f5069060285200089521factor @ A @ K ) ) ) ) ).

% gcd_mult_distrib
thf(fact_5594_mult__gcd__right,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ ( gcd_gcd @ A @ A4 @ B3 ) @ C2 )
          = ( times_times @ A @ ( gcd_gcd @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) @ ( unit_f5069060285200089521factor @ A @ C2 ) ) ) ) ).

% mult_gcd_right
thf(fact_5595_mult__gcd__left,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( times_times @ A @ C2 @ ( gcd_gcd @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ C2 ) @ ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) ) ) ) ) ).

% mult_gcd_left
thf(fact_5596_mult__lcm__left,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A4: A,B3: A] :
          ( ( times_times @ A @ C2 @ ( gcd_lcm @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ C2 ) @ ( gcd_lcm @ A @ ( times_times @ A @ C2 @ A4 ) @ ( times_times @ A @ C2 @ B3 ) ) ) ) ) ).

% mult_lcm_left
thf(fact_5597_mult__lcm__right,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A4: A,B3: A,C2: A] :
          ( ( times_times @ A @ ( gcd_lcm @ A @ A4 @ B3 ) @ C2 )
          = ( times_times @ A @ ( gcd_lcm @ A @ ( times_times @ A @ A4 @ C2 ) @ ( times_times @ A @ B3 @ C2 ) ) @ ( unit_f5069060285200089521factor @ A @ C2 ) ) ) ) ).

% mult_lcm_right
thf(fact_5598_lcm__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [K: A,A4: A,B3: A] :
          ( ( times_times @ A @ K @ ( gcd_lcm @ A @ A4 @ B3 ) )
          = ( times_times @ A @ ( gcd_lcm @ A @ ( times_times @ A @ K @ A4 ) @ ( times_times @ A @ K @ B3 ) ) @ ( unit_f5069060285200089521factor @ A @ K ) ) ) ) ).

% lcm_mult_distrib
thf(fact_5599_unit__factor__is__unit,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A4: A] :
          ( ( A4
           != ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ ( unit_f5069060285200089521factor @ A @ A4 ) @ ( one_one @ A ) ) ) ) ).

% unit_factor_is_unit
thf(fact_5600_unit__factor__gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: A,B3: A] :
          ( ( ( ( A4
                = ( zero_zero @ A ) )
              & ( B3
                = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_gcd @ A @ A4 @ B3 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ( A4
                  = ( zero_zero @ A ) )
                & ( B3
                  = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_gcd @ A @ A4 @ B3 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_gcd
thf(fact_5601_coprime__crossproduct_H,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [B3: A,D3: A,A4: A,C2: A] :
          ( ( B3
           != ( zero_zero @ A ) )
         => ( ( ( unit_f5069060285200089521factor @ A @ B3 )
              = ( unit_f5069060285200089521factor @ A @ D3 ) )
           => ( ( algebr8660921524188924756oprime @ A @ A4 @ B3 )
             => ( ( algebr8660921524188924756oprime @ A @ C2 @ D3 )
               => ( ( ( times_times @ A @ A4 @ D3 )
                    = ( times_times @ A @ B3 @ C2 ) )
                  = ( ( A4 = C2 )
                    & ( B3 = D3 ) ) ) ) ) ) ) ) ).

% coprime_crossproduct'
thf(fact_5602_unit__factor__Lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( ( gcd_Lcm @ A @ A3 )
              = ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Lcm @ A @ A3 ) )
              = ( zero_zero @ A ) ) )
          & ( ( ( gcd_Lcm @ A @ A3 )
             != ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Lcm @ A @ A3 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_Lcm
thf(fact_5603_unit__factor__Gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( ( gcd_Gcd @ A @ A3 )
              = ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Gcd @ A @ A3 ) )
              = ( zero_zero @ A ) ) )
          & ( ( ( gcd_Gcd @ A @ A3 )
             != ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Gcd @ A @ A3 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_Gcd
thf(fact_5604_normalize__idem__imp__unit__factor__eq,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A4: A] :
          ( ( ( normal6383669964737779283malize @ A @ A4 )
            = A4 )
         => ( ( unit_f5069060285200089521factor @ A @ A4 )
            = ( zero_neq_one_of_bool @ A
              @ ( A4
               != ( zero_zero @ A ) ) ) ) ) ) ).

% normalize_idem_imp_unit_factor_eq
thf(fact_5605_rp__inv__image__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( fun_rp_inv_image @ A @ B )
      = ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) )
        @ ^ [R2: set @ ( product_prod @ A @ A ),S7: set @ ( product_prod @ A @ A ),F3: B > A] : ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( inv_image @ A @ B @ R2 @ F3 ) @ ( inv_image @ A @ B @ S7 @ F3 ) ) ) ) ).

% rp_inv_image_def
thf(fact_5606_lenlex__def,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( inv_image @ ( product_prod @ nat @ ( list @ A ) ) @ ( list @ A ) @ ( lex_prod @ nat @ ( list @ A ) @ less_than @ ( lex @ A @ R3 ) )
            @ ^ [Xs2: list @ A] : ( product_Pair @ nat @ ( list @ A ) @ ( size_size @ ( list @ A ) @ Xs2 ) @ Xs2 ) ) ) ) ).

% lenlex_def
thf(fact_5607_mlex__prod__def,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F3: A > nat,R2: set @ ( product_prod @ A @ A )] :
            ( inv_image @ ( product_prod @ nat @ A ) @ A @ ( lex_prod @ nat @ A @ less_than @ R2 )
            @ ^ [X2: A] : ( product_Pair @ nat @ A @ ( F3 @ X2 ) @ X2 ) ) ) ) ).

% mlex_prod_def
thf(fact_5608_measures__def,axiom,
    ! [A: $tType] :
      ( ( measures @ A )
      = ( ^ [Fs: list @ ( A > nat )] :
            ( inv_image @ ( list @ nat ) @ A @ ( lex @ nat @ less_than )
            @ ^ [A5: A] :
                ( map @ ( A > nat ) @ nat
                @ ^ [F3: A > nat] : ( F3 @ A5 )
                @ Fs ) ) ) ) ).

% measures_def
thf(fact_5609_old_Orec__sum__def,axiom,
    ! [B: $tType,T: $tType,A: $tType] :
      ( ( sum_rec_sum @ A @ T @ B )
      = ( ^ [F15: A > T,F26: B > T,X2: sum_sum @ A @ B] : ( the @ T @ ( sum_rec_set_sum @ A @ T @ B @ F15 @ F26 @ X2 ) ) ) ) ).

% old.rec_sum_def
thf(fact_5610_takeWhile__not__last,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( takeWhile @ A
          @ ^ [Y2: A] :
              ( Y2
             != ( last @ A @ Xs ) )
          @ Xs )
        = ( butlast @ A @ Xs ) ) ) ).

% takeWhile_not_last
thf(fact_5611_uncurry__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( uncurry @ A @ B @ C )
      = ( product_case_prod @ A @ B @ C ) ) ).

% uncurry_def
thf(fact_5612_img__ord__def,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( partial_img_ord @ A @ C @ B )
      = ( ^ [F3: A > C,Ord2: C > C > B,X2: A,Y2: A] : ( Ord2 @ ( F3 @ X2 ) @ ( F3 @ Y2 ) ) ) ) ).

% img_ord_def
thf(fact_5613_mk__less__def,axiom,
    ! [A: $tType] :
      ( ( partial_mk_less @ A )
      = ( ^ [R2: A > A > $o,X2: A,Y2: A] :
            ( ( R2 @ X2 @ Y2 )
            & ~ ( R2 @ Y2 @ X2 ) ) ) ) ).

% mk_less_def
thf(fact_5614_ID_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_id_bnf @ ( A > B > $o ) )
      = ( ^ [R2: A > B > $o,A5: A,B4: B] :
          ? [Z3: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ Z3
              @ ( collect @ ( product_prod @ A @ B )
                @ ^ [X2: product_prod @ A @ B] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( insert @ ( product_prod @ A @ B ) @ X2 @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) ) )
            & ( ( bNF_id_bnf @ ( ( product_prod @ A @ B ) > A ) @ ( product_fst @ A @ B ) @ Z3 )
              = A5 )
            & ( ( bNF_id_bnf @ ( ( product_prod @ A @ B ) > B ) @ ( product_snd @ A @ B ) @ Z3 )
              = B4 ) ) ) ) ).

% ID.in_rel
thf(fact_5615_is__num_Ocases,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A4: A] :
          ( ( neg_numeral_is_num @ A @ A4 )
         => ( ( A4
             != ( one_one @ A ) )
           => ( ! [X: A] :
                  ( ( A4
                    = ( uminus_uminus @ A @ X ) )
                 => ~ ( neg_numeral_is_num @ A @ X ) )
             => ~ ! [X: A,Y3: A] :
                    ( ( A4
                      = ( plus_plus @ A @ X @ Y3 ) )
                   => ( ( neg_numeral_is_num @ A @ X )
                     => ~ ( neg_numeral_is_num @ A @ Y3 ) ) ) ) ) ) ) ).

% is_num.cases
thf(fact_5616_pred__on_Osuc__Union__closed__empty,axiom,
    ! [A: $tType,A3: set @ A,P: A > A > $o] : ( member @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( pred_s596693808085603175closed @ A @ A3 @ P ) ) ).

% pred_on.suc_Union_closed_empty
thf(fact_5617_ID_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X3: A,Ya2: A,F2: A > B,G: A > B] :
      ( ( X3 = Ya2 )
     => ( ( bNF_id_bnf @ ( A > $o )
          @ ^ [Z3: A] :
              ( ( F2 @ Z3 )
              = ( G @ Z3 ) )
          @ Ya2 )
       => ( ( bNF_id_bnf @ ( A > B ) @ F2 @ X3 )
          = ( bNF_id_bnf @ ( A > B ) @ G @ Ya2 ) ) ) ) ).

% ID.map_cong_pred
thf(fact_5618_is__num__normalize_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( neg_numeral_is_num @ A @ ( one_one @ A ) ) ) ).

% is_num_normalize(4)
thf(fact_5619_pred__on_Osuc__Union__closed__def,axiom,
    ! [A: $tType] :
      ( ( pred_s596693808085603175closed @ A )
      = ( ^ [A6: set @ A,P3: A > A > $o] : ( collect @ ( set @ A ) @ ( pred_s7749564232668923593losedp @ A @ A6 @ P3 ) ) ) ) ).

% pred_on.suc_Union_closed_def
thf(fact_5620_subset_Osuc__Union__closed__empty,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] : ( member @ ( set @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) @ ( pred_s596693808085603175closed @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) ) ) ).

% subset.suc_Union_closed_empty
thf(fact_5621_ID_Orel__cong,axiom,
    ! [A: $tType,B: $tType,X3: A,Ya2: A,Y: B,Xa: B,R: A > B > $o,Ra2: A > B > $o] :
      ( ( X3 = Ya2 )
     => ( ( Y = Xa )
       => ( ! [Z4: A,Yb: B] :
              ( ( member @ A @ Z4 @ ( insert @ A @ Ya2 @ ( bot_bot @ ( set @ A ) ) ) )
             => ( ( member @ B @ Yb @ ( insert @ B @ Xa @ ( bot_bot @ ( set @ B ) ) ) )
               => ( ( R @ Z4 @ Yb )
                  = ( Ra2 @ Z4 @ Yb ) ) ) )
         => ( ( bNF_id_bnf @ ( A > B > $o ) @ R @ X3 @ Y )
            = ( bNF_id_bnf @ ( A > B > $o ) @ Ra2 @ Ya2 @ Xa ) ) ) ) ) ).

% ID.rel_cong
thf(fact_5622_ID_Orel__mono__strong,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X3: A,Y: B,Ra2: A > B > $o] :
      ( ( bNF_id_bnf @ ( A > B > $o ) @ R @ X3 @ Y )
     => ( ! [Z4: A,Yb: B] :
            ( ( member @ A @ Z4 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
           => ( ( member @ B @ Yb @ ( insert @ B @ Y @ ( bot_bot @ ( set @ B ) ) ) )
             => ( ( R @ Z4 @ Yb )
               => ( Ra2 @ Z4 @ Yb ) ) ) )
       => ( bNF_id_bnf @ ( A > B > $o ) @ Ra2 @ X3 @ Y ) ) ) ).

% ID.rel_mono_strong
thf(fact_5623_ID_Orel__refl__strong,axiom,
    ! [A: $tType,X3: A,Ra2: A > A > $o] :
      ( ! [Z4: A] :
          ( ( member @ A @ Z4 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( Ra2 @ Z4 @ Z4 ) )
     => ( bNF_id_bnf @ ( A > A > $o ) @ Ra2 @ X3 @ X3 ) ) ).

% ID.rel_refl_strong
thf(fact_5624_subset_Osuc__Union__closed__def,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] :
      ( ( pred_s596693808085603175closed @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) )
      = ( collect @ ( set @ ( set @ A ) ) @ ( pred_s7749564232668923593losedp @ ( set @ A ) @ A3 @ ( ord_less @ ( set @ A ) ) ) ) ) ).

% subset.suc_Union_closed_def
thf(fact_5625_is__num_Osimps,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_is_num @ A )
        = ( ^ [A5: A] :
              ( ( A5
                = ( one_one @ A ) )
              | ? [X2: A] :
                  ( ( A5
                    = ( uminus_uminus @ A @ X2 ) )
                  & ( neg_numeral_is_num @ A @ X2 ) )
              | ? [X2: A,Y2: A] :
                  ( ( A5
                    = ( plus_plus @ A @ X2 @ Y2 ) )
                  & ( neg_numeral_is_num @ A @ X2 )
                  & ( neg_numeral_is_num @ A @ Y2 ) ) ) ) ) ) ).

% is_num.simps
thf(fact_5626_acyclicP__converse,axiom,
    ! [A: $tType,R5: A > A > $o] :
      ( ( transitive_acyclic @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ ( conversep @ A @ A @ R5 ) ) ) )
      = ( transitive_acyclic @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ).

% acyclicP_converse
thf(fact_5627_typedef__to__part__equivp,axiom,
    ! [A: $tType,B: $tType,Rep: A > B,Abs: B > A,S2: set @ B] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ S2 )
     => ( equiv_part_equivp @ B
        @ ( bNF_eq_onp @ B
          @ ^ [X2: B] : ( member @ B @ X2 @ S2 ) ) ) ) ).

% typedef_to_part_equivp
thf(fact_5628_open__typedef__to__part__equivp,axiom,
    ! [A: $tType,B: $tType,Rep: A > B,Abs: B > A,P: B > $o] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( collect @ B @ P ) )
     => ( equiv_part_equivp @ B @ ( bNF_eq_onp @ B @ P ) ) ) ).

% open_typedef_to_part_equivp
thf(fact_5629_acyclic__empty,axiom,
    ! [A: $tType] : ( transitive_acyclic @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% acyclic_empty
thf(fact_5630_ID_Opred__True,axiom,
    ! [A: $tType] :
      ( ( bNF_id_bnf @ ( A > $o )
        @ ^ [Uu: A] : $true )
      = ( ^ [Uu: A] : $true ) ) ).

% ID.pred_True
thf(fact_5631_part__equivp__typedef,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( ( equiv_part_equivp @ A @ R )
     => ? [D5: set @ A] :
          ( member @ ( set @ A ) @ D5
          @ ( collect @ ( set @ A )
            @ ^ [C5: set @ A] :
              ? [X2: A] :
                ( ( R @ X2 @ X2 )
                & ( C5
                  = ( collect @ A @ ( R @ X2 ) ) ) ) ) ) ) ).

% part_equivp_typedef
thf(fact_5632_ID_Opred__mono__strong,axiom,
    ! [A: $tType,P: A > $o,X3: A,Pa: A > $o] :
      ( ( bNF_id_bnf @ ( A > $o ) @ P @ X3 )
     => ( ! [Z4: A] :
            ( ( member @ A @ Z4 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
           => ( ( P @ Z4 )
             => ( Pa @ Z4 ) ) )
       => ( bNF_id_bnf @ ( A > $o ) @ Pa @ X3 ) ) ) ).

% ID.pred_mono_strong
thf(fact_5633_ID_Opred__cong,axiom,
    ! [A: $tType,X3: A,Ya2: A,P: A > $o,Pa: A > $o] :
      ( ( X3 = Ya2 )
     => ( ! [Z4: A] :
            ( ( member @ A @ Z4 @ ( insert @ A @ Ya2 @ ( bot_bot @ ( set @ A ) ) ) )
           => ( ( P @ Z4 )
              = ( Pa @ Z4 ) ) )
       => ( ( bNF_id_bnf @ ( A > $o ) @ P @ X3 )
          = ( bNF_id_bnf @ ( A > $o ) @ Pa @ Ya2 ) ) ) ) ).

% ID.pred_cong
thf(fact_5634_wfP__acyclicP,axiom,
    ! [A: $tType,R5: A > A > $o] :
      ( ( wfP @ A @ R5 )
     => ( transitive_acyclic @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ).

% wfP_acyclicP
thf(fact_5635_ID_Opred__set,axiom,
    ! [A: $tType] :
      ( ( bNF_id_bnf @ ( A > $o ) )
      = ( ^ [P3: A > $o,X2: A] :
          ! [Y2: A] :
            ( ( member @ A @ Y2 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
           => ( P3 @ Y2 ) ) ) ) ).

% ID.pred_set
thf(fact_5636_old_Orec__prod__def,axiom,
    ! [T: $tType,B: $tType,A: $tType] :
      ( ( product_rec_prod @ A @ B @ T )
      = ( ^ [F15: A > B > T,X2: product_prod @ A @ B] : ( the @ T @ ( product_rec_set_prod @ A @ B @ T @ F15 @ X2 ) ) ) ) ).

% old.rec_prod_def
thf(fact_5637_snds__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_snds @ A @ B )
      = ( ^ [P6: product_prod @ A @ B] : ( collect @ B @ ( basic_sndsp @ A @ B @ P6 ) ) ) ) ).

% snds_def
thf(fact_5638_nat__of__num__code_I3_J,axiom,
    ! [N: num] :
      ( ( nat_of_num @ ( bit1 @ N ) )
      = ( suc @ ( plus_plus @ nat @ ( nat_of_num @ N ) @ ( nat_of_num @ N ) ) ) ) ).

% nat_of_num_code(3)
thf(fact_5639_nat__of__num__code_I2_J,axiom,
    ! [N: num] :
      ( ( nat_of_num @ ( bit0 @ N ) )
      = ( plus_plus @ nat @ ( nat_of_num @ N ) @ ( nat_of_num @ N ) ) ) ).

% nat_of_num_code(2)
thf(fact_5640_fsts__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_fsts @ A @ B )
      = ( ^ [P6: product_prod @ A @ B] : ( collect @ A @ ( basic_fstsp @ A @ B @ P6 ) ) ) ) ).

% fsts_def
thf(fact_5641_inv__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( inv_on @ A @ B )
      = ( ^ [F3: A > B,A6: set @ A,X2: B] :
            ( fChoice @ A
            @ ^ [Y2: A] :
                ( ( member @ A @ Y2 @ A6 )
                & ( ( F3 @ Y2 )
                  = X2 ) ) ) ) ) ).

% inv_on_def
thf(fact_5642_pick__middlep__def,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( bNF_pick_middlep @ B @ A @ C )
      = ( ^ [P3: B > A > $o,Q3: A > C > $o,A5: B,C5: C] :
            ( fChoice @ A
            @ ^ [B4: A] :
                ( ( P3 @ A5 @ B4 )
                & ( Q3 @ B4 @ C5 ) ) ) ) ) ).

% pick_middlep_def
thf(fact_5643_subset__mset_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_order @ ( multiset @ A ) @ ( union_mset @ A )
      @ ^ [A6: multiset @ A,B5: multiset @ A] : ( subseteq_mset @ A @ B5 @ A6 )
      @ ^ [A6: multiset @ A,B5: multiset @ A] : ( subset_mset @ A @ B5 @ A6 ) ) ).

% subset_mset.semilattice_order_axioms
thf(fact_5644_max_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice_order @ A @ ( ord_max @ A )
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% max.semilattice_order_axioms
thf(fact_5645_prod__mset__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( comm_m9189036328036947845d_mset @ A )
        = ( comm_monoid_F @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod_mset_def
thf(fact_5646_semilattice__order_Omono,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,C2: A,B3: A,D3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ C2 )
       => ( ( Less_eq @ B3 @ D3 )
         => ( Less_eq @ ( F2 @ A4 @ B3 ) @ ( F2 @ C2 @ D3 ) ) ) ) ) ).

% semilattice_order.mono
thf(fact_5647_semilattice__order_OorderE,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ B3 )
       => ( A4
          = ( F2 @ A4 @ B3 ) ) ) ) ).

% semilattice_order.orderE
thf(fact_5648_semilattice__order_OorderI,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( A4
          = ( F2 @ A4 @ B3 ) )
       => ( Less_eq @ A4 @ B3 ) ) ) ).

% semilattice_order.orderI
thf(fact_5649_semilattice__order_Oabsorb1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ B3 )
       => ( ( F2 @ A4 @ B3 )
          = A4 ) ) ) ).

% semilattice_order.absorb1
thf(fact_5650_semilattice__order_Oabsorb2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B3: A,A4: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ B3 @ A4 )
       => ( ( F2 @ A4 @ B3 )
          = B3 ) ) ) ).

% semilattice_order.absorb2
thf(fact_5651_semilattice__order_Oabsorb3,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A4 @ B3 )
       => ( ( F2 @ A4 @ B3 )
          = A4 ) ) ) ).

% semilattice_order.absorb3
thf(fact_5652_semilattice__order_Oabsorb4,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B3: A,A4: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ B3 @ A4 )
       => ( ( F2 @ A4 @ B3 )
          = B3 ) ) ) ).

% semilattice_order.absorb4
thf(fact_5653_semilattice__order_OboundedE,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ ( F2 @ B3 @ C2 ) )
       => ~ ( ( Less_eq @ A4 @ B3 )
           => ~ ( Less_eq @ A4 @ C2 ) ) ) ) ).

% semilattice_order.boundedE
thf(fact_5654_semilattice__order_OboundedI,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ B3 )
       => ( ( Less_eq @ A4 @ C2 )
         => ( Less_eq @ A4 @ ( F2 @ B3 @ C2 ) ) ) ) ) ).

% semilattice_order.boundedI
thf(fact_5655_semilattice__order_Oorder__iff,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ B3 )
        = ( A4
          = ( F2 @ A4 @ B3 ) ) ) ) ).

% semilattice_order.order_iff
thf(fact_5656_semilattice__order_Ocobounded1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( Less_eq @ ( F2 @ A4 @ B3 ) @ A4 ) ) ).

% semilattice_order.cobounded1
thf(fact_5657_semilattice__order_Ocobounded2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( Less_eq @ ( F2 @ A4 @ B3 ) @ B3 ) ) ).

% semilattice_order.cobounded2
thf(fact_5658_semilattice__order_Oabsorb__iff1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ B3 )
        = ( ( F2 @ A4 @ B3 )
          = A4 ) ) ) ).

% semilattice_order.absorb_iff1
thf(fact_5659_semilattice__order_Oabsorb__iff2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B3: A,A4: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ B3 @ A4 )
        = ( ( F2 @ A4 @ B3 )
          = B3 ) ) ) ).

% semilattice_order.absorb_iff2
thf(fact_5660_semilattice__order_Obounded__iff,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ ( F2 @ B3 @ C2 ) )
        = ( ( Less_eq @ A4 @ B3 )
          & ( Less_eq @ A4 @ C2 ) ) ) ) ).

% semilattice_order.bounded_iff
thf(fact_5661_semilattice__order_OcoboundedI1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,C2: A,B3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ C2 )
       => ( Less_eq @ ( F2 @ A4 @ B3 ) @ C2 ) ) ) ).

% semilattice_order.coboundedI1
thf(fact_5662_semilattice__order_OcoboundedI2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B3: A,C2: A,A4: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ B3 @ C2 )
       => ( Less_eq @ ( F2 @ A4 @ B3 ) @ C2 ) ) ) ).

% semilattice_order.coboundedI2
thf(fact_5663_semilattice__order_Ostrict__boundedE,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A4 @ ( F2 @ B3 @ C2 ) )
       => ~ ( ( Less @ A4 @ B3 )
           => ~ ( Less @ A4 @ C2 ) ) ) ) ).

% semilattice_order.strict_boundedE
thf(fact_5664_semilattice__order_Ostrict__order__iff,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A4 @ B3 )
        = ( ( A4
            = ( F2 @ A4 @ B3 ) )
          & ( A4 != B3 ) ) ) ) ).

% semilattice_order.strict_order_iff
thf(fact_5665_semilattice__order_Ostrict__coboundedI1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: A,C2: A,B3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A4 @ C2 )
       => ( Less @ ( F2 @ A4 @ B3 ) @ C2 ) ) ) ).

% semilattice_order.strict_coboundedI1
thf(fact_5666_semilattice__order_Ostrict__coboundedI2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B3: A,C2: A,A4: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ B3 @ C2 )
       => ( Less @ ( F2 @ A4 @ B3 ) @ C2 ) ) ) ).

% semilattice_order.strict_coboundedI2
thf(fact_5667_semilattice__neutr__order_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z2 @ Less_eq @ Less )
     => ( semilattice_order @ A @ F2 @ Less_eq @ Less ) ) ).

% semilattice_neutr_order.axioms(2)
thf(fact_5668_gcd__nat_Osemilattice__order__axioms,axiom,
    ( semilattice_order @ nat @ ( gcd_gcd @ nat ) @ ( dvd_dvd @ nat )
    @ ^ [M5: nat,N5: nat] :
        ( ( dvd_dvd @ nat @ M5 @ N5 )
        & ( M5 != N5 ) ) ) ).

% gcd_nat.semilattice_order_axioms
thf(fact_5669_semilattice__neutr__order_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice_neutr @ A @ F2 @ Z2 )
     => ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
       => ( semila1105856199041335345_order @ A @ F2 @ Z2 @ Less_eq @ Less ) ) ) ).

% semilattice_neutr_order.intro
thf(fact_5670_semilattice__neutr__order__def,axiom,
    ! [A: $tType] :
      ( ( semila1105856199041335345_order @ A )
      = ( ^ [F3: A > A > A,Z3: A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( semilattice_neutr @ A @ F3 @ Z3 )
            & ( semilattice_order @ A @ F3 @ Less_eq2 @ Less2 ) ) ) ) ).

% semilattice_neutr_order_def
thf(fact_5671_inf_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( semilattice_order @ A @ ( inf_inf @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf.semilattice_order_axioms
thf(fact_5672_min_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice_order @ A @ ( ord_min @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% min.semilattice_order_axioms
thf(fact_5673_sup_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( semilattice_order @ A @ ( sup_sup @ A )
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% sup.semilattice_order_axioms
thf(fact_5674_comm__monoid__mset_Oneutral__const,axiom,
    ! [B: $tType,A: $tType,F2: A > A > A,Z2: A,A3: multiset @ B] :
      ( ( comm_monoid_mset @ A @ F2 @ Z2 )
     => ( ( comm_monoid_F @ A @ F2 @ Z2
          @ ( image_mset @ B @ A
            @ ^ [Uu: B] : Z2
            @ A3 ) )
        = Z2 ) ) ).

% comm_monoid_mset.neutral_const
thf(fact_5675_comm__monoid__mset_Odistrib,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,G: B > A,H2: B > A,A3: multiset @ B] :
      ( ( comm_monoid_mset @ A @ F2 @ Z2 )
     => ( ( comm_monoid_F @ A @ F2 @ Z2
          @ ( image_mset @ B @ A
            @ ^ [X2: B] : ( F2 @ ( G @ X2 ) @ ( H2 @ X2 ) )
            @ A3 ) )
        = ( F2 @ ( comm_monoid_F @ A @ F2 @ Z2 @ ( image_mset @ B @ A @ G @ A3 ) ) @ ( comm_monoid_F @ A @ F2 @ Z2 @ ( image_mset @ B @ A @ H2 @ A3 ) ) ) ) ) ).

% comm_monoid_mset.distrib
thf(fact_5676_comm__monoid__mset_Oswap,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > A > A,Z2: A,G: B > C > A,B2: multiset @ C,A3: multiset @ B] :
      ( ( comm_monoid_mset @ A @ F2 @ Z2 )
     => ( ( comm_monoid_F @ A @ F2 @ Z2
          @ ( image_mset @ B @ A
            @ ^ [I2: B] : ( comm_monoid_F @ A @ F2 @ Z2 @ ( image_mset @ C @ A @ ( G @ I2 ) @ B2 ) )
            @ A3 ) )
        = ( comm_monoid_F @ A @ F2 @ Z2
          @ ( image_mset @ C @ A
            @ ^ [J3: C] :
                ( comm_monoid_F @ A @ F2 @ Z2
                @ ( image_mset @ B @ A
                  @ ^ [I2: B] : ( G @ I2 @ J3 )
                  @ A3 ) )
            @ B2 ) ) ) ) ).

% comm_monoid_mset.swap
thf(fact_5677_comm__monoid__mset__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mset @ A )
      = ( comm_monoid @ A ) ) ).

% comm_monoid_mset_def
thf(fact_5678_comm__monoid__mset_Oaxioms,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( comm_monoid_mset @ A @ F2 @ Z2 )
     => ( comm_monoid @ A @ F2 @ Z2 ) ) ).

% comm_monoid_mset.axioms
thf(fact_5679_comm__monoid__mset_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( comm_monoid @ A @ F2 @ Z2 )
     => ( comm_monoid_mset @ A @ F2 @ Z2 ) ) ).

% comm_monoid_mset.intro
thf(fact_5680_prod__mset_Ocomm__monoid__mset__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( comm_monoid_mset @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod_mset.comm_monoid_mset_axioms
thf(fact_5681_bdd__below__primitive__def,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( condit1013018076250108175_below @ A )
        = ( condit16957441358409770ng_bdd @ A
          @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ) ).

% bdd_below_primitive_def
thf(fact_5682_option_Osimps_I15_J,axiom,
    ! [A: $tType,X25: A] :
      ( ( set_option @ A @ ( some @ A @ X25 ) )
      = ( insert @ A @ X25 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% option.simps(15)
thf(fact_5683_those_Osimps_I2_J,axiom,
    ! [A: $tType,X3: option @ A,Xs: list @ ( option @ A )] :
      ( ( those @ A @ ( cons @ ( option @ A ) @ X3 @ Xs ) )
      = ( case_option @ ( option @ ( list @ A ) ) @ A @ ( none @ ( list @ A ) )
        @ ^ [Y2: A] : ( map_option @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( those @ A @ Xs ) )
        @ X3 ) ) ).

% those.simps(2)
thf(fact_5684_set__empty__eq,axiom,
    ! [A: $tType,Xo: option @ A] :
      ( ( ( set_option @ A @ Xo )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xo
        = ( none @ A ) ) ) ).

% set_empty_eq
thf(fact_5685_option_Osimps_I14_J,axiom,
    ! [A: $tType] :
      ( ( set_option @ A @ ( none @ A ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% option.simps(14)
thf(fact_5686_subset__mset_Obdd__below__primitive__def,axiom,
    ! [A: $tType] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) )
      = ( condit16957441358409770ng_bdd @ ( multiset @ A )
        @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subseteq_mset @ A @ Y2 @ X2 ) ) ) ).

% subset_mset.bdd_below_primitive_def
thf(fact_5687_option_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( rel_option @ A @ B @ ( bNF_Grp @ A @ B @ A3 @ F2 ) )
      = ( bNF_Grp @ ( option @ A ) @ ( option @ B )
        @ ( collect @ ( option @ A )
          @ ^ [X2: option @ A] : ( ord_less_eq @ ( set @ A ) @ ( set_option @ A @ X2 ) @ A3 ) )
        @ ( map_option @ A @ B @ F2 ) ) ) ).

% option.rel_Grp
thf(fact_5688_option_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_option @ A @ B )
      = ( ^ [R2: A > B > $o,A5: option @ A,B4: option @ B] :
          ? [Z3: option @ ( product_prod @ A @ B )] :
            ( ( member @ ( option @ ( product_prod @ A @ B ) ) @ Z3
              @ ( collect @ ( option @ ( product_prod @ A @ B ) )
                @ ^ [X2: option @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_option @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) ) )
            & ( ( map_option @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z3 )
              = A5 )
            & ( ( map_option @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z3 )
              = B4 ) ) ) ) ).

% option.in_rel
thf(fact_5689_option_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_option @ A @ B )
      = ( ^ [R2: A > B > $o] :
            ( relcompp @ ( option @ A ) @ ( option @ ( product_prod @ A @ B ) ) @ ( option @ B )
            @ ( conversep @ ( option @ ( product_prod @ A @ B ) ) @ ( option @ A )
              @ ( bNF_Grp @ ( option @ ( product_prod @ A @ B ) ) @ ( option @ A )
                @ ( collect @ ( option @ ( product_prod @ A @ B ) )
                  @ ^ [X2: option @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_option @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
                @ ( map_option @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) ) ) )
            @ ( bNF_Grp @ ( option @ ( product_prod @ A @ B ) ) @ ( option @ B )
              @ ( collect @ ( option @ ( product_prod @ A @ B ) )
                @ ^ [X2: option @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_option @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
              @ ( map_option @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) ) ) ) ) ) ).

% option.rel_compp_Grp
thf(fact_5690_rel__option__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_option @ A @ B )
      = ( ^ [R2: A > B > $o,X2: option @ A,Y2: option @ B] :
            ( product_case_prod @ ( option @ A ) @ ( option @ B ) @ $o
            @ ^ [A5: option @ A,B4: option @ B] :
                ( case_option @ $o @ A
                @ ( case_option @ $o @ B @ $true
                  @ ^ [C5: B] : $false
                  @ B4 )
                @ ^ [Z3: A] : ( case_option @ $o @ B @ $false @ ( R2 @ Z3 ) @ B4 )
                @ A5 )
            @ ( product_Pair @ ( option @ A ) @ ( option @ B ) @ X2 @ Y2 ) ) ) ) ).

% rel_option_iff
thf(fact_5691_option_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: A > C > $o,X3: option @ A,G: B > C,Y: option @ B] :
      ( ( rel_option @ A @ C @ Sa @ X3 @ ( map_option @ B @ C @ G @ Y ) )
      = ( rel_option @ A @ B
        @ ^ [X2: A,Y2: B] : ( Sa @ X2 @ ( G @ Y2 ) )
        @ X3
        @ Y ) ) ).

% option.rel_map(2)
thf(fact_5692_option_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: C > B > $o,I3: A > C,X3: option @ A,Y: option @ B] :
      ( ( rel_option @ C @ B @ Sb @ ( map_option @ A @ C @ I3 @ X3 ) @ Y )
      = ( rel_option @ A @ B
        @ ^ [X2: A] : ( Sb @ ( I3 @ X2 ) )
        @ X3
        @ Y ) ) ).

% option.rel_map(1)
thf(fact_5693_option_Odisc__transfer_I2_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] :
      ( bNF_rel_fun @ ( option @ A ) @ ( option @ B ) @ $o @ $o @ ( rel_option @ A @ B @ R )
      @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
      @ ^ [Option2: option @ A] :
          ( Option2
         != ( none @ A ) )
      @ ^ [Option2: option @ B] :
          ( Option2
         != ( none @ B ) ) ) ).

% option.disc_transfer(2)
thf(fact_5694_option_Odisc__transfer_I1_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] :
      ( bNF_rel_fun @ ( option @ A ) @ ( option @ B ) @ $o @ $o @ ( rel_option @ A @ B @ R )
      @ ^ [Y5: $o,Z5: $o] : ( Y5 = Z5 )
      @ ^ [Option2: option @ A] :
          ( Option2
          = ( none @ A ) )
      @ ^ [Option2: option @ B] :
          ( Option2
          = ( none @ B ) ) ) ).

% option.disc_transfer(1)
thf(fact_5695_rel__option__inf,axiom,
    ! [B: $tType,A: $tType,A3: A > B > $o,B2: A > B > $o] :
      ( ( inf_inf @ ( ( option @ A ) > ( option @ B ) > $o ) @ ( rel_option @ A @ B @ A3 ) @ ( rel_option @ A @ B @ B2 ) )
      = ( rel_option @ A @ B @ ( inf_inf @ ( A > B > $o ) @ A3 @ B2 ) ) ) ).

% rel_option_inf
thf(fact_5696_preordering__bdd_OInt1,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: set @ A,B2: set @ A] :
      ( ( condit622319405099724424ng_bdd @ A @ Less_eq @ Less )
     => ( ( condit16957441358409770ng_bdd @ A @ Less_eq @ A3 )
       => ( condit16957441358409770ng_bdd @ A @ Less_eq @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% preordering_bdd.Int1
thf(fact_5697_preordering__bdd_OInt2,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,B2: set @ A,A3: set @ A] :
      ( ( condit622319405099724424ng_bdd @ A @ Less_eq @ Less )
     => ( ( condit16957441358409770ng_bdd @ A @ Less_eq @ B2 )
       => ( condit16957441358409770ng_bdd @ A @ Less_eq @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) ).

% preordering_bdd.Int2
thf(fact_5698_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_5699_subset__mset_Obdd__below_Opreordering__bdd__axioms,axiom,
    ! [A: $tType] :
      ( condit622319405099724424ng_bdd @ ( multiset @ A )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subseteq_mset @ A @ Y2 @ X2 )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subset_mset @ A @ Y2 @ X2 ) ) ).

% subset_mset.bdd_below.preordering_bdd_axioms
thf(fact_5700_preordering__bdd_Oempty,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( condit622319405099724424ng_bdd @ A @ Less_eq @ Less )
     => ( condit16957441358409770ng_bdd @ A @ Less_eq @ ( bot_bot @ ( set @ A ) ) ) ) ).

% preordering_bdd.empty
thf(fact_5701_bdd__below_Opreordering__bdd__axioms,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( condit622319405099724424ng_bdd @ A
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% bdd_below.preordering_bdd_axioms
thf(fact_5702_in__range_Osimps,axiom,
    ! [H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
      = ( ! [X2: nat] :
            ( ( member @ nat @ X2 @ As2 )
           => ( ord_less @ nat @ X2 @ ( lim @ product_unit @ H2 ) ) ) ) ) ).

% in_range.simps
thf(fact_5703_in__range_Oelims_I1_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( in_range @ X3 )
        = Y )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( X3
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ( Y
              = ( ~ ! [X2: nat] :
                      ( ( member @ nat @ X2 @ As )
                     => ( ord_less @ nat @ X2 @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ) ).

% in_range.elims(1)
thf(fact_5704_in__range_Oelims_I2_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( in_range @ X3 )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( X3
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ~ ! [X4: nat] :
                  ( ( member @ nat @ X4 @ As )
                 => ( ord_less @ nat @ X4 @ ( lim @ product_unit @ H4 ) ) ) ) ) ).

% in_range.elims(2)
thf(fact_5705_in__range_Oelims_I3_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( in_range @ X3 )
     => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
            ( ( X3
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ! [X: nat] :
                ( ( member @ nat @ X @ As )
               => ( ord_less @ nat @ X @ ( lim @ product_unit @ H4 ) ) ) ) ) ).

% in_range.elims(3)
thf(fact_5706_new__addrs__def,axiom,
    ( hoare_new_addrs
    = ( ^ [H: heap_ext @ product_unit,As7: set @ nat,H7: heap_ext @ product_unit] :
          ( sup_sup @ ( set @ nat ) @ As7
          @ ( collect @ nat
            @ ^ [A5: nat] :
                ( ( ord_less_eq @ nat @ ( lim @ product_unit @ H ) @ A5 )
                & ( ord_less @ nat @ A5 @ ( lim @ product_unit @ H7 ) ) ) ) ) ) ) ).

% new_addrs_def
thf(fact_5707_hoare__tripleE,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( hoare_hoare_triple @ A @ P @ C2 @ Q )
     => ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
       => ~ ! [R4: A,H3: heap_ext @ product_unit] :
              ( ? [T8: nat] :
                  ( ( heap_Time_execute @ A @ C2 @ H2 )
                  = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R4 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H3 @ T8 ) ) ) )
             => ( ( rep_assn @ ( Q @ R4 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ ( hoare_new_addrs @ H2 @ As2 @ H3 ) ) )
               => ( ( relH
                    @ ( collect @ nat
                      @ ^ [A5: nat] :
                          ( ( ord_less @ nat @ A5 @ ( lim @ product_unit @ H2 ) )
                          & ~ ( member @ nat @ A5 @ As2 ) ) )
                    @ H2
                    @ H3 )
                 => ~ ( ord_less_eq @ nat @ ( lim @ product_unit @ H2 ) @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ) ).

% hoare_tripleE
thf(fact_5708_hoare__tripleI,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn] :
      ( ! [H4: heap_ext @ product_unit,As: set @ nat] :
          ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
         => ? [R10: A,H6: heap_ext @ product_unit,T9: nat] :
              ( ( ( heap_Time_execute @ A @ C2 @ H4 )
                = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R10 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H6 @ T9 ) ) ) )
              & ( rep_assn @ ( Q @ R10 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ ( hoare_new_addrs @ H4 @ As @ H6 ) ) )
              & ( relH
                @ ( collect @ nat
                  @ ^ [A5: nat] :
                      ( ( ord_less @ nat @ A5 @ ( lim @ product_unit @ H4 ) )
                      & ~ ( member @ nat @ A5 @ As ) ) )
                @ H4
                @ H6 )
              & ( ord_less_eq @ nat @ ( lim @ product_unit @ H4 ) @ ( lim @ product_unit @ H6 ) ) ) )
     => ( hoare_hoare_triple @ A @ P @ C2 @ Q ) ) ).

% hoare_tripleI
thf(fact_5709_new__addr__refl,axiom,
    ! [H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( hoare_new_addrs @ H2 @ As2 @ H2 )
      = As2 ) ).

% new_addr_refl
thf(fact_5710_hoare__triple__def,axiom,
    ! [A: $tType] :
      ( ( hoare_hoare_triple @ A )
      = ( ^ [P3: assn,C5: heap_Time_Heap @ A,Q3: A > assn] :
          ! [H: heap_ext @ product_unit,As7: set @ nat] :
            ( ( rep_assn @ P3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As7 ) )
           => ? [R3: A,H7: heap_ext @ product_unit] :
                ( ? [T5: nat] :
                    ( ( heap_Time_execute @ A @ C5 @ H )
                    = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ T5 ) ) ) )
                & ( rep_assn @ ( Q3 @ R3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ ( hoare_new_addrs @ H @ As7 @ H7 ) ) )
                & ( relH
                  @ ( collect @ nat
                    @ ^ [A5: nat] :
                        ( ( ord_less @ nat @ A5 @ ( lim @ product_unit @ H ) )
                        & ~ ( member @ nat @ A5 @ As7 ) ) )
                  @ H
                  @ H7 )
                & ( ord_less_eq @ nat @ ( lim @ product_unit @ H ) @ ( lim @ product_unit @ H7 ) ) ) ) ) ) ).

% hoare_triple_def
thf(fact_5711_execute__ureturn,axiom,
    ! [A: $tType,X3: A] :
      ( ( heap_Time_execute @ A @ ( heap_Time_ureturn @ A @ X3 ) )
      = ( comp @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( zero_zero @ nat ) ) ) ) ) ).

% execute_ureturn
thf(fact_5712_execute__return,axiom,
    ! [A: $tType,X3: A] :
      ( ( heap_Time_execute @ A @ ( heap_Time_return @ A @ X3 ) )
      = ( comp @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( one_one @ nat ) ) ) ) ) ).

% execute_return
thf(fact_5713_hoare__triple__effect,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( hoare_hoare_triple @ A @ P @ C2 @ Q )
     => ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
       => ? [H3: heap_ext @ product_unit,R4: A,T8: nat] :
            ( ( heap_Time_effect @ A @ C2 @ H2 @ H3 @ R4 @ T8 )
            & ( rep_assn @ ( Q @ R4 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ ( hoare_new_addrs @ H2 @ As2 @ H3 ) ) ) ) ) ) ).

% hoare_triple_effect
thf(fact_5714_effect__LetI,axiom,
    ! [B: $tType,A: $tType,X3: A,T3: A,F2: A > ( heap_Time_Heap @ B ),H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R5: B,N: nat] :
      ( ( X3 = T3 )
     => ( ( heap_Time_effect @ B @ ( F2 @ X3 ) @ H2 @ H5 @ R5 @ N )
       => ( heap_Time_effect @ B @ ( F2 @ T3 ) @ H2 @ H5 @ R5 @ N ) ) ) ).

% effect_LetI
thf(fact_5715_ureturn__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_ureturn @ A )
      = ( ^ [X2: A] :
            ( heap_Time_heap @ A
            @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( zero_zero @ nat ) ) ) ) ) ) ).

% ureturn_def
thf(fact_5716_return__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_return @ A )
      = ( ^ [X2: A] :
            ( heap_Time_heap @ A
            @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( one_one @ nat ) ) ) ) ) ) ).

% return_def
thf(fact_5717_sngr__assn__raw_Oelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( sngr_assn_raw @ A @ X3 @ Xa @ Xb )
         => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
               => ( ( ( ref_get @ A @ H4 @ X3 )
                    = Xa )
                  & ( As
                    = ( insert @ nat @ ( addr_of_ref @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                  & ( ord_less @ nat @ ( addr_of_ref @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ).

% sngr_assn_raw.elims(3)
thf(fact_5718_relH__ref,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R5: ref @ A] :
          ( ( relH @ As2 @ H2 @ H5 )
         => ( ( member @ nat @ ( addr_of_ref @ A @ R5 ) @ As2 )
           => ( ( ref_get @ A @ H2 @ R5 )
              = ( ref_get @ A @ H5 @ R5 ) ) ) ) ) ).

% relH_ref
thf(fact_5719_sngr__assn__raw_Osimps,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R5: ref @ A,X3: A,H2: heap_ext @ product_unit,As2: set @ nat] :
          ( ( sngr_assn_raw @ A @ R5 @ X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
          = ( ( ( ref_get @ A @ H2 @ R5 )
              = X3 )
            & ( As2
              = ( insert @ nat @ ( addr_of_ref @ A @ R5 ) @ ( bot_bot @ ( set @ nat ) ) ) )
            & ( ord_less @ nat @ ( addr_of_ref @ A @ R5 ) @ ( lim @ product_unit @ H2 ) ) ) ) ) ).

% sngr_assn_raw.simps
thf(fact_5720_sngr__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( sngr_assn_raw @ A @ X3 @ Xa @ Xb )
            = Y )
         => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
               => ( Y
                  = ( ~ ( ( ( ref_get @ A @ H4 @ X3 )
                          = Xa )
                        & ( As
                          = ( insert @ nat @ ( addr_of_ref @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_ref @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.elims(1)
thf(fact_5721_sngr__assn__raw_Oelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( sngr_assn_raw @ A @ X3 @ Xa @ Xb )
         => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
               => ~ ( ( ( ref_get @ A @ H4 @ X3 )
                      = Xa )
                    & ( As
                      = ( insert @ nat @ ( addr_of_ref @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                    & ( ord_less @ nat @ ( addr_of_ref @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ).

% sngr_assn_raw.elims(2)
thf(fact_5722_sngr__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( sngr_assn_raw @ A @ X3 @ Xa @ Xb )
            = Y )
         => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                 => ( ( Y
                      = ( ( ( ref_get @ A @ H4 @ X3 )
                          = Xa )
                        & ( As
                          = ( insert @ nat @ ( addr_of_ref @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_ref @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) )
                   => ~ ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(1)
thf(fact_5723_sngr__assn__raw_Opelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( sngr_assn_raw @ A @ X3 @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                 => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) )
                   => ~ ( ( ( ref_get @ A @ H4 @ X3 )
                          = Xa )
                        & ( As
                          = ( insert @ nat @ ( addr_of_ref @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_ref @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(2)
thf(fact_5724_sngr__assn__raw_Opelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( sngr_assn_raw @ A @ X3 @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                 => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) )
                   => ( ( ( ref_get @ A @ H4 @ X3 )
                        = Xa )
                      & ( As
                        = ( insert @ nat @ ( addr_of_ref @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                      & ( ord_less @ nat @ ( addr_of_ref @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(3)
thf(fact_5725_relH__set__ref,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R5: ref @ A,As2: set @ nat,H2: heap_ext @ product_unit,X3: A] :
          ( ~ ( member @ nat @ ( addr_of_ref @ A @ R5 ) @ As2 )
         => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
           => ( relH @ As2 @ H2 @ ( ref_set @ A @ R5 @ X3 @ H2 ) ) ) ) ) ).

% relH_set_ref
thf(fact_5726_snga__assn__raw_Oelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( snga_assn_raw @ A @ X3 @ Xa @ Xb )
         => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
               => ( ( ( array_get @ A @ H4 @ X3 )
                    = Xa )
                  & ( As
                    = ( insert @ nat @ ( addr_of_array @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                  & ( ord_less @ nat @ ( addr_of_array @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ).

% snga_assn_raw.elims(3)
thf(fact_5727_snga__assn__raw_Oelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( snga_assn_raw @ A @ X3 @ Xa @ Xb )
         => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
               => ~ ( ( ( array_get @ A @ H4 @ X3 )
                      = Xa )
                    & ( As
                      = ( insert @ nat @ ( addr_of_array @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                    & ( ord_less @ nat @ ( addr_of_array @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ).

% snga_assn_raw.elims(2)
thf(fact_5728_relH__array,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R5: array @ A] :
          ( ( relH @ As2 @ H2 @ H5 )
         => ( ( member @ nat @ ( addr_of_array @ A @ R5 ) @ As2 )
           => ( ( array_get @ A @ H2 @ R5 )
              = ( array_get @ A @ H5 @ R5 ) ) ) ) ) ).

% relH_array
thf(fact_5729_snga__assn__raw_Osimps,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R5: array @ A,X3: list @ A,H2: heap_ext @ product_unit,As2: set @ nat] :
          ( ( snga_assn_raw @ A @ R5 @ X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
          = ( ( ( array_get @ A @ H2 @ R5 )
              = X3 )
            & ( As2
              = ( insert @ nat @ ( addr_of_array @ A @ R5 ) @ ( bot_bot @ ( set @ nat ) ) ) )
            & ( ord_less @ nat @ ( addr_of_array @ A @ R5 ) @ ( lim @ product_unit @ H2 ) ) ) ) ) ).

% snga_assn_raw.simps
thf(fact_5730_snga__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( snga_assn_raw @ A @ X3 @ Xa @ Xb )
            = Y )
         => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
               => ( Y
                  = ( ~ ( ( ( array_get @ A @ H4 @ X3 )
                          = Xa )
                        & ( As
                          = ( insert @ nat @ ( addr_of_array @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_array @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ) ) ).

% snga_assn_raw.elims(1)
thf(fact_5731_snga__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( snga_assn_raw @ A @ X3 @ Xa @ Xb )
            = Y )
         => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                 => ( ( Y
                      = ( ( ( array_get @ A @ H4 @ X3 )
                          = Xa )
                        & ( As
                          = ( insert @ nat @ ( addr_of_array @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_array @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) )
                   => ~ ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(1)
thf(fact_5732_snga__assn__raw_Opelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( snga_assn_raw @ A @ X3 @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                 => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) )
                   => ~ ( ( ( array_get @ A @ H4 @ X3 )
                          = Xa )
                        & ( As
                          = ( insert @ nat @ ( addr_of_array @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_array @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(2)
thf(fact_5733_snga__assn__raw_Opelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X3: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( snga_assn_raw @ A @ X3 @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                 => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X3 @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) )
                   => ( ( ( array_get @ A @ H4 @ X3 )
                        = Xa )
                      & ( As
                        = ( insert @ nat @ ( addr_of_array @ A @ X3 ) @ ( bot_bot @ ( set @ nat ) ) ) )
                      & ( ord_less @ nat @ ( addr_of_array @ A @ X3 ) @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(3)
thf(fact_5734_relH__set__array,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R5: array @ A,As2: set @ nat,H2: heap_ext @ product_unit,X3: list @ A] :
          ( ~ ( member @ nat @ ( addr_of_array @ A @ R5 ) @ As2 )
         => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
           => ( relH @ As2 @ H2 @ ( array_set @ A @ R5 @ X3 @ H2 ) ) ) ) ) ).

% relH_set_array
thf(fact_5735_execute__make,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,F2: nat > A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( array @ A ) @ ( array_make @ A @ N @ F2 ) @ H2 )
          = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
              @ ( array_alloc @ A @ ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ N ) ) @ H2 ) ) ) ) ) ).

% execute_make
thf(fact_5736_Array__Time_Omake__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_make @ A )
        = ( ^ [N5: nat,F3: nat > A] :
              ( heap_Time_heap @ ( array @ A )
              @ ^ [H: heap_ext @ product_unit] :
                  ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ N5 @ ( one_one @ nat ) ) ) )
                  @ ( array_alloc @ A @ ( map @ nat @ A @ F3 @ ( upt @ ( zero_zero @ nat ) @ N5 ) ) @ H ) ) ) ) ) ) ).

% Array_Time.make_def
thf(fact_5737_execute__of__list,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [Xs: list @ A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( array @ A ) @ ( array_of_list @ A @ Xs ) @ H2 )
          = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) )
              @ ( array_alloc @ A @ Xs @ H2 ) ) ) ) ) ).

% execute_of_list
thf(fact_5738_execute__new,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,X3: A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( array @ A ) @ ( array_new @ A @ N @ X3 ) @ H2 )
          = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
              @ ( array_alloc @ A @ ( replicate @ A @ N @ X3 ) @ H2 ) ) ) ) ) ).

% execute_new
thf(fact_5739_of__list__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_of_list @ A )
        = ( ^ [Xs2: list @ A] :
              ( heap_Time_heap @ ( array @ A )
              @ ^ [H: heap_ext @ product_unit] :
                  ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) )
                  @ ( array_alloc @ A @ Xs2 @ H ) ) ) ) ) ) ).

% of_list_def
thf(fact_5740_array__make,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_new @ A )
        = ( ^ [N5: nat,X2: A] :
              ( array_make @ A @ N5
              @ ^ [Uu: nat] : X2 ) ) ) ) ).

% array_make
thf(fact_5741_array__of__list__make,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_of_list @ A )
        = ( ^ [Xs2: list @ A] : ( array_make @ A @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( nth @ A @ Xs2 ) ) ) ) ) ).

% array_of_list_make
thf(fact_5742_new__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_new @ A )
        = ( ^ [N5: nat,X2: A] :
              ( heap_Time_heap @ ( array @ A )
              @ ^ [H: heap_ext @ product_unit] :
                  ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ N5 @ ( one_one @ nat ) ) ) )
                  @ ( array_alloc @ A @ ( replicate @ A @ N5 @ X2 ) @ H ) ) ) ) ) ) ).

% new_def
thf(fact_5743_Array__Time_Oalloc__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_alloc @ A )
        = ( ^ [Xs2: list @ A,H: heap_ext @ product_unit] :
              ( product_Pair @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( array2 @ A @ ( lim @ product_unit @ H ) )
              @ ( array_set @ A @ ( array2 @ A @ ( lim @ product_unit @ H ) ) @ Xs2
                @ ( lim_update @ product_unit
                  @ ^ [Uu: nat] : ( plus_plus @ nat @ ( lim @ product_unit @ H ) @ ( one_one @ nat ) )
                  @ H ) ) ) ) ) ) ).

% Array_Time.alloc_def
thf(fact_5744_freeze__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_freeze @ A )
        = ( ^ [A5: array @ A] :
              ( heap_Time_heap @ ( list @ A )
              @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( array_get @ A @ H @ A5 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( array_length @ A @ H @ A5 ) ) ) ) ) ) ) ) ).

% freeze_def
thf(fact_5745_trancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_trancl @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ( transitive_tranclp @ A
                @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 ) ) ) ) ) ) ).

% trancl_def
thf(fact_5746_less__nat__rel,axiom,
    ( ( ord_less @ nat )
    = ( transitive_tranclp @ nat
      @ ^ [M5: nat,N5: nat] :
          ( N5
          = ( suc @ M5 ) ) ) ) ).

% less_nat_rel
thf(fact_5747_tranclp__trancl__eq,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( transitive_tranclp @ A
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) )
      = ( ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_trancl @ A @ R5 ) ) ) ) ).

% tranclp_trancl_eq
thf(fact_5748_tranclp__def,axiom,
    ! [A: $tType] :
      ( ( transitive_tranclp @ A )
      = ( ^ [R3: A > A > $o] :
            ( complete_lattice_lfp @ ( A > A > $o )
            @ ^ [P6: A > A > $o,X1: A,X22: A] :
                ( ? [A5: A,B4: A] :
                    ( ( X1 = A5 )
                    & ( X22 = B4 )
                    & ( R3 @ A5 @ B4 ) )
                | ? [A5: A,B4: A,C5: A] :
                    ( ( X1 = A5 )
                    & ( X22 = C5 )
                    & ( P6 @ A5 @ B4 )
                    & ( R3 @ B4 @ C5 ) ) ) ) ) ) ).

% tranclp_def
thf(fact_5749_Nitpick_Otranclp__unfold,axiom,
    ! [A: $tType] :
      ( ( transitive_tranclp @ A )
      = ( ^ [R3: A > A > $o,A5: A,B4: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ ( transitive_trancl @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R3 ) ) ) ) ) ) ).

% Nitpick.tranclp_unfold
thf(fact_5750_Array__Time_Onth__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_nth @ A )
        = ( ^ [A5: array @ A,I2: nat] :
              ( heap_Time_guard @ A
              @ ^ [H: heap_ext @ product_unit] : ( ord_less @ nat @ I2 @ ( array_length @ A @ H @ A5 ) )
              @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( nth @ A @ ( array_get @ A @ H @ A5 ) @ I2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( one_one @ nat ) ) ) ) ) ) ) ).

% Array_Time.nth_def
thf(fact_5751_swap__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_swap @ A )
        = ( ^ [I2: nat,X2: A,A5: array @ A] :
              ( heap_Time_guard @ A
              @ ^ [H: heap_ext @ product_unit] : ( ord_less @ nat @ I2 @ ( array_length @ A @ H @ A5 ) )
              @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( nth @ A @ ( array_get @ A @ H @ A5 ) @ I2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( array_update @ A @ A5 @ I2 @ X2 @ H ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% swap_def
thf(fact_5752_map__entry__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_map_entry @ A )
        = ( ^ [I2: nat,F3: A > A,A5: array @ A] :
              ( heap_Time_guard @ ( array @ A )
              @ ^ [H: heap_ext @ product_unit] : ( ord_less @ nat @ I2 @ ( array_length @ A @ H @ A5 ) )
              @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ A5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( array_update @ A @ A5 @ I2 @ ( F3 @ ( nth @ A @ ( array_get @ A @ H @ A5 ) @ I2 ) ) @ H ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% map_entry_def
thf(fact_5753_upd__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_upd @ A )
        = ( ^ [I2: nat,X2: A,A5: array @ A] :
              ( heap_Time_guard @ ( array @ A )
              @ ^ [H: heap_ext @ product_unit] : ( ord_less @ nat @ I2 @ ( array_length @ A @ H @ A5 ) )
              @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ A5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( array_update @ A @ A5 @ I2 @ X2 @ H ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% upd_def
thf(fact_5754_reflp__refl__eq,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( reflp @ A
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) )
      = ( refl_on @ A @ ( top_top @ ( set @ A ) ) @ R5 ) ) ).

% reflp_refl_eq
thf(fact_5755_reflp__inf,axiom,
    ! [A: $tType,R5: A > A > $o,S3: A > A > $o] :
      ( ( reflp @ A @ R5 )
     => ( ( reflp @ A @ S3 )
       => ( reflp @ A @ ( inf_inf @ ( A > A > $o ) @ R5 @ S3 ) ) ) ) ).

% reflp_inf
thf(fact_5756_Quotient__id__abs__transfer,axiom,
    ! [B: $tType,A: $tType,R: A > A > $o,Abs: A > B,Rep: B > A,T2: A > B > $o] :
      ( ( quotient @ A @ B @ R @ Abs @ Rep @ T2 )
     => ( ( reflp @ A @ R )
       => ( bNF_rel_fun @ A @ A @ A @ B
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
          @ T2
          @ ^ [X2: A] : X2
          @ Abs ) ) ) ).

% Quotient_id_abs_transfer
thf(fact_5757_sub_Otransfer,axiom,
    ( bNF_rel_fun @ num @ num @ ( num > int ) @ ( num > code_integer )
    @ ^ [Y5: num,Z5: num] : ( Y5 = Z5 )
    @ ( bNF_rel_fun @ num @ num @ int @ code_integer
      @ ^ [Y5: num,Z5: num] : ( Y5 = Z5 )
      @ code_pcr_integer )
    @ ^ [M5: num,N5: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M5 ) @ ( numeral_numeral @ int @ N5 ) )
    @ code_sub ) ).

% sub.transfer
thf(fact_5758_image2p__def,axiom,
    ! [D: $tType,B: $tType,A: $tType,C: $tType] :
      ( ( bNF_Greatest_image2p @ C @ A @ D @ B )
      = ( ^ [F3: C > A,G2: D > B,R2: C > D > $o,X2: A,Y2: B] :
          ? [X6: C,Y6: D] :
            ( ( R2 @ X6 @ Y6 )
            & ( ( F3 @ X6 )
              = X2 )
            & ( ( G2 @ Y6 )
              = Y2 ) ) ) ) ).

% image2p_def
thf(fact_5759_rtranclp__imp__Sup__relpowp,axiom,
    ! [A: $tType,P: A > A > $o,X3: A,Y: A] :
      ( ( transitive_rtranclp @ A @ P @ X3 @ Y )
     => ( complete_Sup_Sup @ ( A > A > $o )
        @ ( image2 @ nat @ ( A > A > $o )
          @ ^ [N5: nat] : ( compow @ ( A > A > $o ) @ N5 @ P )
          @ ( top_top @ ( set @ nat ) ) )
        @ X3
        @ Y ) ) ).

% rtranclp_imp_Sup_relpowp
thf(fact_5760_rtranclp__r__diff__Id,axiom,
    ! [A: $tType,R5: A > A > $o] :
      ( ( transitive_rtranclp @ A
        @ ( inf_inf @ ( A > A > $o ) @ R5
          @ ^ [X2: A,Y2: A] : ( X2 != Y2 ) ) )
      = ( transitive_rtranclp @ A @ R5 ) ) ).

% rtranclp_r_diff_Id
thf(fact_5761_integer_Oid__abs__transfer,axiom,
    ( bNF_rel_fun @ int @ int @ int @ code_integer
    @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
    @ code_pcr_integer
    @ ^ [X2: int] : X2
    @ code_integer_of_int ) ).

% integer.id_abs_transfer
thf(fact_5762_integer_Orep__transfer,axiom,
    ( bNF_rel_fun @ int @ code_integer @ int @ int @ code_pcr_integer
    @ ^ [Y5: int,Z5: int] : ( Y5 = Z5 )
    @ ^ [X2: int] : X2
    @ code_int_of_integer ) ).

% integer.rep_transfer
thf(fact_5763_Transitive__Closure_Ortranclp__rtrancl__eq,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtranclp @ A
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) )
      = ( ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_rtrancl @ A @ R5 ) ) ) ) ).

% Transitive_Closure.rtranclp_rtrancl_eq
thf(fact_5764_dup_Otransfer,axiom,
    ( bNF_rel_fun @ int @ code_integer @ int @ code_integer @ code_pcr_integer @ code_pcr_integer
    @ ^ [K6: int] : ( plus_plus @ int @ K6 @ K6 )
    @ code_dup ) ).

% dup.transfer
thf(fact_5765_rtranclp__def,axiom,
    ! [A: $tType] :
      ( ( transitive_rtranclp @ A )
      = ( ^ [R3: A > A > $o] :
            ( complete_lattice_lfp @ ( A > A > $o )
            @ ^ [P6: A > A > $o,X1: A,X22: A] :
                ( ? [A5: A] :
                    ( ( X1 = A5 )
                    & ( X22 = A5 ) )
                | ? [A5: A,B4: A,C5: A] :
                    ( ( X1 = A5 )
                    & ( X22 = C5 )
                    & ( P6 @ A5 @ B4 )
                    & ( R3 @ B4 @ C5 ) ) ) ) ) ) ).

% rtranclp_def
thf(fact_5766_rtrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_rtrancl @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ( transitive_rtranclp @ A
                @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 ) ) ) ) ) ) ).

% rtrancl_def
thf(fact_5767_Enum_Ortranclp__rtrancl__eq,axiom,
    ! [A: $tType] :
      ( ( transitive_rtranclp @ A )
      = ( ^ [R3: A > A > $o,X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_rtrancl @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R3 ) ) ) ) ) ) ).

% Enum.rtranclp_rtrancl_eq
thf(fact_5768_rtranclp__is__Sup__relpowp,axiom,
    ! [A: $tType] :
      ( ( transitive_rtranclp @ A )
      = ( ^ [P3: A > A > $o] :
            ( complete_Sup_Sup @ ( A > A > $o )
            @ ( image2 @ nat @ ( A > A > $o )
              @ ^ [N5: nat] : ( compow @ ( A > A > $o ) @ N5 @ P3 )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% rtranclp_is_Sup_relpowp
thf(fact_5769_old_Orec__bool__def,axiom,
    ! [T: $tType] :
      ( ( product_rec_bool @ T )
      = ( ^ [F15: T,F26: T,X2: $o] : ( the @ T @ ( product_rec_set_bool @ T @ F15 @ F26 @ X2 ) ) ) ) ).

% old.rec_bool_def
thf(fact_5770_Ref__Time_Oalloc__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_alloc @ A )
        = ( ^ [X2: A,H: heap_ext @ product_unit] :
              ( product_Pair @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ ( ref2 @ A @ ( lim @ product_unit @ H ) )
              @ ( ref_set @ A @ ( ref2 @ A @ ( lim @ product_unit @ H ) ) @ X2
                @ ( lim_update @ product_unit
                  @ ^ [Uu: nat] : ( plus_plus @ nat @ ( lim @ product_unit @ H ) @ ( one_one @ nat ) )
                  @ H ) ) ) ) ) ) ).

% Ref_Time.alloc_def
thf(fact_5771_sum__encode__def,axiom,
    ( nat_sum_encode
    = ( sum_case_sum @ nat @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      @ ^ [B4: nat] : ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B4 ) ) ) ) ).

% sum_encode_def
thf(fact_5772_case__sum__KK,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: C] :
      ( ( sum_case_sum @ A @ C @ B
        @ ^ [X2: A] : A4
        @ ^ [X2: B] : A4 )
      = ( ^ [X2: sum_sum @ A @ B] : A4 ) ) ).

% case_sum_KK
thf(fact_5773_disjE__realizer,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: A > $o,Q: B > $o,X3: sum_sum @ A @ B,R: C > $o,F2: A > C,G: B > C] :
      ( ( sum_case_sum @ A @ $o @ B @ P @ Q @ X3 )
     => ( ! [P7: A] :
            ( ( P @ P7 )
           => ( R @ ( F2 @ P7 ) ) )
       => ( ! [Q10: B] :
              ( ( Q @ Q10 )
             => ( R @ ( G @ Q10 ) ) )
         => ( R @ ( sum_case_sum @ A @ C @ B @ F2 @ G @ X3 ) ) ) ) ) ).

% disjE_realizer
thf(fact_5774_sum_Ocase__distrib,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,H2: C > D,F1: A > C,F22: B > C,Sum: sum_sum @ A @ B] :
      ( ( H2 @ ( sum_case_sum @ A @ C @ B @ F1 @ F22 @ Sum ) )
      = ( sum_case_sum @ A @ D @ B
        @ ^ [X2: A] : ( H2 @ ( F1 @ X2 ) )
        @ ^ [X2: B] : ( H2 @ ( F22 @ X2 ) )
        @ Sum ) ) ).

% sum.case_distrib
thf(fact_5775_execute__ref,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [V: A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( ref @ A ) @ ( ref_ref @ A @ V ) @ H2 )
          = ( some @ ( product_prod @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R3: ref @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( one_one @ nat ) ) )
              @ ( ref_alloc @ A @ V @ H2 ) ) ) ) ) ).

% execute_ref
thf(fact_5776_ref__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_ref @ A )
        = ( ^ [V2: A] :
              ( heap_Time_heap @ ( ref @ A )
              @ ^ [H: heap_ext @ product_unit] :
                  ( product_case_prod @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R3: ref @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( one_one @ nat ) ) )
                  @ ( ref_alloc @ A @ V2 @ H ) ) ) ) ) ) ).

% ref_def
thf(fact_5777_projr__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( sum_projr @ A @ B )
      = ( sum_case_sum @ A @ B @ B
        @ ^ [Uu2: A] : ( undefined @ B )
        @ ^ [X22: B] : X22 ) ) ).

% projr_def
thf(fact_5778_projl__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( sum_projl @ A @ B )
      = ( sum_case_sum @ A @ A @ B
        @ ^ [X1: A] : X1
        @ ^ [Uu2: B] : ( undefined @ A ) ) ) ).

% projl_def
thf(fact_5779_laz__weak__Pb,axiom,
    ! [A: $tType,B: $tType,P: B > $o,A3: list @ A,B2: list @ B] :
      ( ( list_all_zip @ A @ B
        @ ^ [A5: A] : P
        @ A3
        @ B2 )
      = ( ( ( size_size @ ( list @ A ) @ A3 )
          = ( size_size @ ( list @ B ) @ B2 ) )
        & ! [X2: B] :
            ( ( member @ B @ X2 @ ( set2 @ B @ B2 ) )
           => ( P @ X2 ) ) ) ) ).

% laz_weak_Pb
thf(fact_5780_laz__weak__Pa,axiom,
    ! [B: $tType,A: $tType,P: A > $o,A3: list @ A,B2: list @ B] :
      ( ( list_all_zip @ A @ B
        @ ^ [A5: A,B4: B] : ( P @ A5 )
        @ A3
        @ B2 )
      = ( ( ( size_size @ ( list @ A ) @ A3 )
          = ( size_size @ ( list @ B ) @ B2 ) )
        & ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ A3 ) )
           => ( P @ X2 ) ) ) ) ).

% laz_weak_Pa
thf(fact_5781_laz__conj,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Q: A > B > $o,A4: list @ A,B3: list @ B] :
      ( ( list_all_zip @ A @ B
        @ ^ [X2: A,Y2: B] :
            ( ( P @ X2 @ Y2 )
            & ( Q @ X2 @ Y2 ) )
        @ A4
        @ B3 )
      = ( ( list_all_zip @ A @ B @ P @ A4 @ B3 )
        & ( list_all_zip @ A @ B @ Q @ A4 @ B3 ) ) ) ).

% laz_conj
thf(fact_5782_laz__swap__ex,axiom,
    ! [B: $tType,A: $tType,C: $tType,P: A > B > C > $o,A3: list @ A,B2: list @ B] :
      ( ( list_all_zip @ A @ B
        @ ^ [A5: A,B4: B] :
          ? [X7: C] : ( P @ A5 @ B4 @ X7 )
        @ A3
        @ B2 )
     => ~ ! [C6: list @ C] :
            ( ( list_all_zip @ A @ C
              @ ^ [A5: A,C5: C] :
                ? [B4: B] : ( P @ A5 @ B4 @ C5 )
              @ A3
              @ C6 )
           => ~ ( list_all_zip @ B @ C
                @ ^ [B4: B,C5: C] :
                  ? [A5: A] : ( P @ A5 @ B4 @ C5 )
                @ B2
                @ C6 ) ) ) ).

% laz_swap_ex
thf(fact_5783_list__all__zip__map1,axiom,
    ! [C: $tType,A: $tType,B: $tType,P: A > B > $o,F2: C > A,As2: list @ C,Bs: list @ B] :
      ( ( list_all_zip @ A @ B @ P @ ( map @ C @ A @ F2 @ As2 ) @ Bs )
      = ( list_all_zip @ C @ B
        @ ^ [A5: C] : ( P @ ( F2 @ A5 ) )
        @ As2
        @ Bs ) ) ).

% list_all_zip_map1
thf(fact_5784_list__all__zip__map2,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: A > B > $o,As2: list @ A,F2: C > B,Bs: list @ C] :
      ( ( list_all_zip @ A @ B @ P @ As2 @ ( map @ C @ B @ F2 @ Bs ) )
      = ( list_all_zip @ A @ C
        @ ^ [A5: A,B4: C] : ( P @ A5 @ ( F2 @ B4 ) )
        @ As2
        @ Bs ) ) ).

% list_all_zip_map2
thf(fact_5785_option_Orec__o__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: C,Ga: B > C,F2: A > B] :
      ( ( comp @ ( option @ B ) @ C @ ( option @ A ) @ ( rec_option @ C @ B @ G @ Ga ) @ ( map_option @ A @ B @ F2 ) )
      = ( rec_option @ C @ A @ G
        @ ^ [X2: A] : ( Ga @ ( F2 @ X2 ) ) ) ) ).

% option.rec_o_map
thf(fact_5786_tap__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_tap @ A )
      = ( ^ [F3: ( heap_ext @ product_unit ) > A] :
            ( heap_Time_Heap2 @ A
            @ ^ [H: heap_ext @ product_unit] : ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F3 @ H ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( one_one @ nat ) ) ) ) ) ) ) ).

% tap_def
thf(fact_5787_ordering__top_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ordering_top_axioms @ A @ Less_eq @ Top ) ) ).

% ordering_top.axioms(2)
thf(fact_5788_ordering__top__axioms__def,axiom,
    ! [A: $tType] :
      ( ( ordering_top_axioms @ A )
      = ( ^ [Less_eq2: A > A > $o,Top2: A] :
          ! [A5: A] : ( Less_eq2 @ A5 @ Top2 ) ) ) ).

% ordering_top_axioms_def
thf(fact_5789_ordering__top__axioms_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Top: A] :
      ( ! [A7: A] : ( Less_eq @ A7 @ Top )
     => ( ordering_top_axioms @ A @ Less_eq @ Top ) ) ).

% ordering_top_axioms.intro
thf(fact_5790_guard__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_guard @ A )
      = ( ^ [P3: ( heap_ext @ product_unit ) > $o,F3: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] :
            ( heap_Time_Heap2 @ A
            @ ^ [H: heap_ext @ product_unit] : ( if @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( P3 @ H ) @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( F3 @ H ) ) @ ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ) ) ).

% guard_def
thf(fact_5791_lookup__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_lookup @ A )
        = ( ^ [R3: ref @ A] :
              ( heap_Time_tap @ A
              @ ^ [H: heap_ext @ product_unit] : ( ref_get @ A @ H @ R3 ) ) ) ) ) ).

% lookup_def
thf(fact_5792_ordering__top_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( ordering_top_axioms @ A @ Less_eq @ Top )
       => ( ordering_top @ A @ Less_eq @ Less @ Top ) ) ) ).

% ordering_top.intro
thf(fact_5793_ordering__top__def,axiom,
    ! [A: $tType] :
      ( ( ordering_top @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o,Top2: A] :
            ( ( ordering @ A @ Less_eq2 @ Less2 )
            & ( ordering_top_axioms @ A @ Less_eq2 @ Top2 ) ) ) ) ).

% ordering_top_def
thf(fact_5794_ordering__top_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ordering @ A @ Less_eq @ Less ) ) ).

% ordering_top.axioms(1)
thf(fact_5795_ordering_Oeq__iff,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( A4 = B3 )
        = ( ( Less_eq @ A4 @ B3 )
          & ( Less_eq @ B3 @ A4 ) ) ) ) ).

% ordering.eq_iff
thf(fact_5796_ordering_Oantisym,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ B3 )
       => ( ( Less_eq @ B3 @ A4 )
         => ( A4 = B3 ) ) ) ) ).

% ordering.antisym
thf(fact_5797_ordering_Oorder__iff__strict,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ B3 )
        = ( ( Less @ A4 @ B3 )
          | ( A4 = B3 ) ) ) ) ).

% ordering.order_iff_strict
thf(fact_5798_ordering_Ostrict__iff__order,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less @ A4 @ B3 )
        = ( ( Less_eq @ A4 @ B3 )
          & ( A4 != B3 ) ) ) ) ).

% ordering.strict_iff_order
thf(fact_5799_ordering_Ostrict__implies__not__eq,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less @ A4 @ B3 )
       => ( A4 != B3 ) ) ) ).

% ordering.strict_implies_not_eq
thf(fact_5800_ordering_Onot__eq__order__implies__strict,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( A4 != B3 )
       => ( ( Less_eq @ A4 @ B3 )
         => ( Less @ A4 @ B3 ) ) ) ) ).

% ordering.not_eq_order_implies_strict
thf(fact_5801_ordering__strictI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ! [A7: A,B6: A] :
          ( ( Less_eq @ A7 @ B6 )
          = ( ( Less @ A7 @ B6 )
            | ( A7 = B6 ) ) )
     => ( ! [A7: A,B6: A] :
            ( ( Less @ A7 @ B6 )
           => ~ ( Less @ B6 @ A7 ) )
       => ( ! [A7: A] :
              ~ ( Less @ A7 @ A7 )
         => ( ! [A7: A,B6: A,C4: A] :
                ( ( Less @ A7 @ B6 )
               => ( ( Less @ B6 @ C4 )
                 => ( Less @ A7 @ C4 ) ) )
           => ( ordering @ A @ Less_eq @ Less ) ) ) ) ) ).

% ordering_strictI
thf(fact_5802_ordering__dualI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( ordering @ A
        @ ^ [A5: A,B4: A] : ( Less_eq @ B4 @ A5 )
        @ ^ [A5: A,B4: A] : ( Less @ B4 @ A5 ) )
     => ( ordering @ A @ Less_eq @ Less ) ) ).

% ordering_dualI
thf(fact_5803_gcd__nat_Oordering__axioms,axiom,
    ( ordering @ nat @ ( dvd_dvd @ nat )
    @ ^ [M5: nat,N5: nat] :
        ( ( dvd_dvd @ nat @ M5 @ N5 )
        & ( M5 != N5 ) ) ) ).

% gcd_nat.ordering_axioms
thf(fact_5804_order_Oordering__axioms,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ordering @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% order.ordering_axioms
thf(fact_5805_dual__order_Oordering__axioms,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ordering @ A
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% dual_order.ordering_axioms
thf(fact_5806_subset__mset_Odual__order_Oordering__axioms,axiom,
    ! [A: $tType] :
      ( ordering @ ( multiset @ A )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subseteq_mset @ A @ Y2 @ X2 )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subset_mset @ A @ Y2 @ X2 ) ) ).

% subset_mset.dual_order.ordering_axioms
thf(fact_5807_raise__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_raise @ A )
      = ( ^ [S: list @ char] :
            ( heap_Time_Heap2 @ A
            @ ^ [Uu: heap_ext @ product_unit] : ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ) ).

% raise_def
thf(fact_5808_Heap__lub__empty,axiom,
    ! [A: $tType] :
      ( ( heap_Time_Heap_lub @ A @ ( bot_bot @ ( set @ ( heap_Time_Heap @ A ) ) ) )
      = ( heap_Time_Heap2 @ A
        @ ^ [X2: heap_ext @ product_unit] : ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ).

% Heap_lub_empty
thf(fact_5809_len__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_len @ A )
        = ( ^ [A5: array @ A] :
              ( heap_Time_tap @ nat
              @ ^ [H: heap_ext @ product_unit] : ( array_length @ A @ H @ A5 ) ) ) ) ) ).

% len_def
thf(fact_5810_len_H__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( heap @ B )
        & ( semiring_1 @ A ) )
     => ( ( array_len2 @ B @ A )
        = ( ^ [A5: array @ B] :
              ( heap_Time_bind @ nat @ A @ ( array_len @ B @ A5 )
              @ ^ [N5: nat] : ( heap_Time_ureturn @ A @ ( semiring_1_of_nat @ A @ N5 ) ) ) ) ) ) ).

% len'_def
thf(fact_5811_Heap_Oset,axiom,
    ! [A: $tType,X3: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( heap_Time_set_Heap @ A @ ( heap_Time_Heap2 @ A @ X3 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( set @ A )
          @ ^ [Uu2: option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] : ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( set @ A ) @ ( basic_fsts @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( set_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ Uu2 ) ) )
          @ ( image2 @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ X3 @ ( top_top @ ( set @ ( heap_ext @ product_unit ) ) ) ) ) ) ) ).

% Heap.set
thf(fact_5812_Range__Int__subset,axiom,
    ! [A: $tType,B: $tType,A3: set @ ( product_prod @ B @ A ),B2: set @ ( product_prod @ B @ A )] : ( ord_less_eq @ ( set @ A ) @ ( range2 @ B @ A @ ( inf_inf @ ( set @ ( product_prod @ B @ A ) ) @ A3 @ B2 ) ) @ ( inf_inf @ ( set @ A ) @ ( range2 @ B @ A @ A3 ) @ ( range2 @ B @ A @ B2 ) ) ) ).

% Range_Int_subset
thf(fact_5813_Heap__Time__Monad_Obind__bind,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: heap_Time_Heap @ A,G: A > ( heap_Time_Heap @ C ),K: C > ( heap_Time_Heap @ B )] :
      ( ( heap_Time_bind @ C @ B @ ( heap_Time_bind @ A @ C @ F2 @ G ) @ K )
      = ( heap_Time_bind @ A @ B @ F2
        @ ^ [X2: A] : ( heap_Time_bind @ C @ B @ ( G @ X2 ) @ K ) ) ) ).

% Heap_Time_Monad.bind_bind
thf(fact_5814_Range__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( range2 @ B @ A @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Range_empty
thf(fact_5815_Range__Collect__case__prod,axiom,
    ! [B: $tType,A: $tType,P: B > A > $o] :
      ( ( range2 @ B @ A @ ( collect @ ( product_prod @ B @ A ) @ ( product_case_prod @ B @ A @ $o @ P ) ) )
      = ( collect @ A
        @ ^ [Y2: A] :
          ? [X2: B] : ( P @ X2 @ Y2 ) ) ) ).

% Range_Collect_case_prod
thf(fact_5816_distrib__if__bind,axiom,
    ! [A: $tType,B: $tType,B3: $o,C2: heap_Time_Heap @ B,D3: heap_Time_Heap @ B,F2: B > ( heap_Time_Heap @ A )] :
      ( ( B3
       => ( ( heap_Time_bind @ B @ A @ ( if @ ( heap_Time_Heap @ B ) @ B3 @ C2 @ D3 ) @ F2 )
          = ( heap_Time_bind @ B @ A @ C2 @ F2 ) ) )
      & ( ~ B3
       => ( ( heap_Time_bind @ B @ A @ ( if @ ( heap_Time_Heap @ B ) @ B3 @ C2 @ D3 ) @ F2 )
          = ( heap_Time_bind @ B @ A @ D3 @ F2 ) ) ) ) ).

% distrib_if_bind
thf(fact_5817_Range__empty__iff,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ B @ A )] :
      ( ( ( range2 @ B @ A @ R5 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( R5
        = ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) ) ) ).

% Range_empty_iff
thf(fact_5818_Range__Union,axiom,
    ! [A: $tType,B: $tType,S2: set @ ( set @ ( product_prod @ B @ A ) )] :
      ( ( range2 @ B @ A @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ A ) ) @ S2 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( set @ ( product_prod @ B @ A ) ) @ ( set @ A ) @ ( range2 @ B @ A ) @ S2 ) ) ) ).

% Range_Union
thf(fact_5819_Range__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( range2 @ A @ B )
      = ( ^ [R3: set @ ( product_prod @ A @ B )] :
            ( collect @ B
            @ ( rangep @ A @ B
              @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R3 ) ) ) ) ) ).

% Range_def
thf(fact_5820_Rangep__Range__eq,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ A @ B )] :
      ( ( rangep @ A @ B
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R5 ) )
      = ( ^ [X2: B] : ( member @ B @ X2 @ ( range2 @ A @ B @ R5 ) ) ) ) ).

% Rangep_Range_eq
thf(fact_5821_lookup__chain,axiom,
    ! [B: $tType,A: $tType] :
      ( ( heap @ B )
     => ! [R5: ref @ B,F2: heap_Time_Heap @ A] :
          ( ( heap_Time_bind @ B @ A @ ( ref_lookup @ B @ R5 )
            @ ^ [Uu: B] : F2 )
          = ( heap_Time_bind @ product_unit @ A @ ( heap_Time_wait @ ( one_one @ nat ) )
            @ ^ [Uu: product_unit] : F2 ) ) ) ).

% lookup_chain
thf(fact_5822_bind__return,axiom,
    ! [A: $tType,F2: heap_Time_Heap @ A] :
      ( ( heap_Time_bind @ A @ A @ F2 @ ( heap_Time_return @ A ) )
      = ( heap_Time_bind @ product_unit @ A @ ( heap_Time_wait @ ( one_one @ nat ) )
        @ ^ [Uu: product_unit] : F2 ) ) ).

% bind_return
thf(fact_5823_return__bind,axiom,
    ! [B: $tType,A: $tType,X3: B,F2: B > ( heap_Time_Heap @ A )] :
      ( ( heap_Time_bind @ B @ A @ ( heap_Time_return @ B @ X3 ) @ F2 )
      = ( heap_Time_bind @ product_unit @ A @ ( heap_Time_wait @ ( one_one @ nat ) )
        @ ^ [Uu: product_unit] : ( F2 @ X3 ) ) ) ).

% return_bind
thf(fact_5824_upd__ureturn,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I3: nat,X3: A,A4: array @ A] :
          ( ( heap_Time_bind @ ( array @ A ) @ ( array @ A ) @ ( array_upd @ A @ I3 @ X3 @ A4 )
            @ ^ [Uu: array @ A] : ( heap_Time_ureturn @ ( array @ A ) @ A4 ) )
          = ( array_upd @ A @ I3 @ X3 @ A4 ) ) ) ).

% upd_ureturn
thf(fact_5825_bind__lift,axiom,
    ! [A: $tType,B: $tType,F2: heap_Time_Heap @ B,G: B > A] :
      ( ( heap_Time_bind @ B @ A @ F2 @ ( heap_Time_lift @ B @ A @ G ) )
      = ( heap_Time_bind @ B @ A @ F2
        @ ^ [X2: B] : ( heap_Time_return @ A @ ( G @ X2 ) ) ) ) ).

% bind_lift
thf(fact_5826_Heap__Time__Monad_Obind__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( heap_Time_bind @ A @ B )
      = ( ^ [F3: heap_Time_Heap @ A,G2: A > ( heap_Time_Heap @ B )] :
            ( heap_Time_Heap2 @ B
            @ ^ [H: heap_ext @ product_unit] :
                ( case_option @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( none @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
                @ ( product_case_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
                  @ ^ [R3: A] :
                      ( product_case_prod @ ( heap_ext @ product_unit ) @ nat @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
                      @ ^ [H7: heap_ext @ product_unit,N5: nat] : ( heap_Time_timeFrame @ B @ N5 @ ( heap_Time_execute @ B @ ( G2 @ R3 ) @ H7 ) ) ) )
                @ ( heap_Time_execute @ A @ F3 @ H ) ) ) ) ) ).

% Heap_Time_Monad.bind_def
thf(fact_5827_wf__UN,axiom,
    ! [B: $tType,A: $tType,I: set @ A,R5: A > ( set @ ( product_prod @ B @ B ) )] :
      ( ! [I4: A] :
          ( ( member @ A @ I4 @ I )
         => ( wf @ B @ ( R5 @ I4 ) ) )
     => ( ! [I4: A,J5: A] :
            ( ( member @ A @ I4 @ I )
           => ( ( member @ A @ J5 @ I )
             => ( ( ( R5 @ I4 )
                 != ( R5 @ J5 ) )
               => ( ( inf_inf @ ( set @ B ) @ ( domain @ B @ B @ ( R5 @ I4 ) ) @ ( range2 @ B @ B @ ( R5 @ J5 ) ) )
                  = ( bot_bot @ ( set @ B ) ) ) ) ) )
       => ( wf @ B @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ B ) ) @ ( image2 @ A @ ( set @ ( product_prod @ B @ B ) ) @ R5 @ I ) ) ) ) ) ).

% wf_UN
thf(fact_5828_Domain__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( domain @ A @ B @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Domain_empty
thf(fact_5829_Domain__Collect__case__prod,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o] :
      ( ( domain @ A @ B @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) ) )
      = ( collect @ A
        @ ^ [X2: A] :
          ? [X7: B] : ( P @ X2 @ X7 ) ) ) ).

% Domain_Collect_case_prod
thf(fact_5830_dom__ran__disj__comp,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ R ) @ ( range2 @ A @ A @ R ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( relcomp @ A @ A @ A @ R @ R )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% dom_ran_disj_comp
thf(fact_5831_Domain__empty__iff,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ B )] :
      ( ( ( domain @ A @ B @ R5 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( R5
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ).

% Domain_empty_iff
thf(fact_5832_Domain__unfold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( domain @ A @ B )
      = ( ^ [R3: set @ ( product_prod @ A @ B )] :
            ( collect @ A
            @ ^ [X2: A] :
              ? [Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R3 ) ) ) ) ).

% Domain_unfold
thf(fact_5833_Domainp__Domain__eq,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ A @ B )] :
      ( ( domainp @ A @ B
        @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R5 ) )
      = ( ^ [X2: A] : ( member @ A @ X2 @ ( domain @ A @ B @ R5 ) ) ) ) ).

% Domainp_Domain_eq
thf(fact_5834_Domain__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( domain @ A @ B )
      = ( ^ [R3: set @ ( product_prod @ A @ B )] :
            ( collect @ A
            @ ( domainp @ A @ B
              @ ^ [X2: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R3 ) ) ) ) ) ).

% Domain_def
thf(fact_5835_Domain__Int__subset,axiom,
    ! [B: $tType,A: $tType,A3: set @ ( product_prod @ A @ B ),B2: set @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ A ) @ ( domain @ A @ B @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ A3 @ B2 ) ) @ ( inf_inf @ ( set @ A ) @ ( domain @ A @ B @ A3 ) @ ( domain @ A @ B @ B2 ) ) ) ).

% Domain_Int_subset
thf(fact_5836_wf__no__path,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ R ) @ ( range2 @ A @ A @ R ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( wf @ A @ R ) ) ).

% wf_no_path
thf(fact_5837_wf__min,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R )
     => ( ( R
         != ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ~ ! [M3: A] :
              ~ ( member @ A @ M3 @ ( minus_minus @ ( set @ A ) @ ( domain @ A @ A @ R ) @ ( range2 @ A @ A @ R ) ) ) ) ) ).

% wf_min
thf(fact_5838_Domain__Union,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( domain @ A @ B @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ S2 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( set @ ( product_prod @ A @ B ) ) @ ( set @ A ) @ ( domain @ A @ B ) @ S2 ) ) ) ).

% Domain_Union
thf(fact_5839_wf__Un,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R5 )
     => ( ( wf @ A @ S3 )
       => ( ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ R5 ) @ ( range2 @ A @ A @ S3 ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( wf @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ S3 ) ) ) ) ) ).

% wf_Un
thf(fact_5840_wf__Union,axiom,
    ! [A: $tType,R: set @ ( set @ ( product_prod @ A @ A ) )] :
      ( ! [X: set @ ( product_prod @ A @ A )] :
          ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X @ R )
         => ( wf @ A @ X ) )
     => ( ! [X: set @ ( product_prod @ A @ A )] :
            ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X @ R )
           => ! [Xa2: set @ ( product_prod @ A @ A )] :
                ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ Xa2 @ R )
               => ( ( X != Xa2 )
                 => ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ X ) @ ( range2 @ A @ A @ Xa2 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
       => ( wf @ A @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) ) @ R ) ) ) ) ).

% wf_Union
thf(fact_5841_wf__max,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ ( converse @ A @ A @ R ) )
     => ( ( R
         != ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ~ ! [M3: A] :
              ~ ( member @ A @ M3 @ ( minus_minus @ ( set @ A ) @ ( range2 @ A @ A @ R ) @ ( domain @ A @ A @ R ) ) ) ) ) ).

% wf_max
thf(fact_5842_execute__bind__case,axiom,
    ! [A: $tType,B: $tType,F2: heap_Time_Heap @ B,G: B > ( heap_Time_Heap @ A ),H2: heap_ext @ product_unit] :
      ( ( heap_Time_execute @ A @ ( heap_Time_bind @ B @ A @ F2 @ G ) @ H2 )
      = ( case_option @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ( product_case_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
          @ ^ [X2: B] :
              ( product_case_prod @ ( heap_ext @ product_unit ) @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
              @ ^ [H7: heap_ext @ product_unit,N5: nat] : ( heap_Time_timeFrame @ A @ N5 @ ( heap_Time_execute @ A @ ( G @ X2 ) @ H7 ) ) ) )
        @ ( heap_Time_execute @ B @ F2 @ H2 ) ) ) ).

% execute_bind_case
thf(fact_5843_change__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_change @ A )
        = ( ^ [F3: A > A,R3: ref @ A] :
              ( heap_Time_bind @ A @ A @ ( ref_lookup @ A @ R3 )
              @ ^ [X2: A] :
                  ( heap_Time_bind @ product_unit @ A @ ( ref_update @ A @ R3 @ ( F3 @ X2 ) )
                  @ ^ [Uu: product_unit] : ( heap_Time_return @ A @ ( F3 @ X2 ) ) ) ) ) ) ) ).

% change_def
thf(fact_5844_wait__def,axiom,
    ( heap_Time_wait
    = ( ^ [N5: nat] :
          ( heap_Time_Heap2 @ product_unit
          @ ^ [H: heap_ext @ product_unit] : ( some @ ( product_prod @ product_unit @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ product_unit @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ product_Unity @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ N5 ) ) ) ) ) ) ).

% wait_def
thf(fact_5845_rec__natural__def,axiom,
    ! [T: $tType] :
      ( ( code_rec_natural @ T )
      = ( ^ [F15: T,F26: code_natural > T > T,X2: code_natural] : ( the @ T @ ( code_rec_set_natural @ T @ F15 @ F26 @ X2 ) ) ) ) ).

% rec_natural_def
thf(fact_5846_unit__abs__eta__conv,axiom,
    ! [A: $tType,F2: product_unit > A] :
      ( ( ^ [U: product_unit] : ( F2 @ product_Unity ) )
      = F2 ) ).

% unit_abs_eta_conv
thf(fact_5847_UNIV__unit,axiom,
    ( ( top_top @ ( set @ product_unit ) )
    = ( insert @ product_unit @ product_Unity @ ( bot_bot @ ( set @ product_unit ) ) ) ) ).

% UNIV_unit
thf(fact_5848_inf__unit__def,axiom,
    ( ( inf_inf @ product_unit )
    = ( ^ [Uu2: product_unit,Uv2: product_unit] : product_Unity ) ) ).

% inf_unit_def
thf(fact_5849_bot__unit__def,axiom,
    ( ( bot_bot @ product_unit )
    = product_Unity ) ).

% bot_unit_def
thf(fact_5850_Ref__Time_Oupdate__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_update @ A )
        = ( ^ [R3: ref @ A,V2: A] :
              ( heap_Time_heap @ product_unit
              @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ product_unit @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ product_Unity @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( ref_set @ A @ R3 @ V2 @ H ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% Ref_Time.update_def
thf(fact_5851_upd_H__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_upd2 @ A )
        = ( ^ [A5: array @ A,I2: code_integer,X2: A] :
              ( heap_Time_bind @ ( array @ A ) @ product_unit @ ( array_upd @ A @ ( code_nat_of_integer @ I2 ) @ X2 @ A5 )
              @ ^ [Uu: array @ A] : ( heap_Time_ureturn @ product_unit @ product_Unity ) ) ) ) ) ).

% upd'_def
thf(fact_5852_case__natural__def,axiom,
    ! [T: $tType] :
      ( ( code_case_natural @ T )
      = ( ^ [F15: T,F26: code_natural > T] :
            ( code_rec_natural @ T @ F15
            @ ^ [X1: code_natural,X22: T] : ( F26 @ X1 ) ) ) ) ).

% case_natural_def
thf(fact_5853_cone__def,axiom,
    ( bNF_Cardinal_cone
    = ( bNF_Ca6860139660246222851ard_of @ product_unit @ ( insert @ product_unit @ product_Unity @ ( bot_bot @ ( set @ product_unit ) ) ) ) ) ).

% cone_def
thf(fact_5854_next_Osimps,axiom,
    ! [V: code_natural,W2: code_natural] :
      ( ( next @ ( product_Pair @ code_natural @ code_natural @ V @ W2 ) )
      = ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( plus_plus @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( plus_plus @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ W2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ W2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( one_one @ code_natural ) ) ) @ ( one_one @ code_natural ) ) @ ( product_Pair @ code_natural @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ W2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ W2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% next.simps
thf(fact_5855_Abs__int__cases,axiom,
    ! [X3: int] :
      ~ ! [Y3: set @ ( product_prod @ nat @ nat )] :
          ( ( X3
            = ( abs_int @ Y3 ) )
         => ~ ( member @ ( set @ ( product_prod @ nat @ nat ) ) @ Y3
              @ ( collect @ ( set @ ( product_prod @ nat @ nat ) )
                @ ^ [C5: set @ ( product_prod @ nat @ nat )] :
                  ? [X2: product_prod @ nat @ nat] :
                    ( ( intrel @ X2 @ X2 )
                    & ( C5
                      = ( collect @ ( product_prod @ nat @ nat ) @ ( intrel @ X2 ) ) ) ) ) ) ) ).

% Abs_int_cases
thf(fact_5856_Abs__int__inject,axiom,
    ! [X3: set @ ( product_prod @ nat @ nat ),Y: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( set @ ( product_prod @ nat @ nat ) ) @ X3
        @ ( collect @ ( set @ ( product_prod @ nat @ nat ) )
          @ ^ [C5: set @ ( product_prod @ nat @ nat )] :
            ? [X2: product_prod @ nat @ nat] :
              ( ( intrel @ X2 @ X2 )
              & ( C5
                = ( collect @ ( product_prod @ nat @ nat ) @ ( intrel @ X2 ) ) ) ) ) )
     => ( ( member @ ( set @ ( product_prod @ nat @ nat ) ) @ Y
          @ ( collect @ ( set @ ( product_prod @ nat @ nat ) )
            @ ^ [C5: set @ ( product_prod @ nat @ nat )] :
              ? [X2: product_prod @ nat @ nat] :
                ( ( intrel @ X2 @ X2 )
                & ( C5
                  = ( collect @ ( product_prod @ nat @ nat ) @ ( intrel @ X2 ) ) ) ) ) )
       => ( ( ( abs_int @ X3 )
            = ( abs_int @ Y ) )
          = ( X3 = Y ) ) ) ) ).

% Abs_int_inject
thf(fact_5857_Abs__int__induct,axiom,
    ! [P: int > $o,X3: int] :
      ( ! [Y3: set @ ( product_prod @ nat @ nat )] :
          ( ( member @ ( set @ ( product_prod @ nat @ nat ) ) @ Y3
            @ ( collect @ ( set @ ( product_prod @ nat @ nat ) )
              @ ^ [C5: set @ ( product_prod @ nat @ nat )] :
                ? [X2: product_prod @ nat @ nat] :
                  ( ( intrel @ X2 @ X2 )
                  & ( C5
                    = ( collect @ ( product_prod @ nat @ nat ) @ ( intrel @ X2 ) ) ) ) ) )
         => ( P @ ( abs_int @ Y3 ) ) )
     => ( P @ X3 ) ) ).

% Abs_int_induct
thf(fact_5858_split__seed__def,axiom,
    ( split_seed
    = ( ^ [S: product_prod @ code_natural @ code_natural] :
          ( product_case_prod @ code_natural @ code_natural @ ( product_prod @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) )
          @ ^ [V2: code_natural,W3: code_natural] :
              ( product_case_prod @ code_natural @ code_natural @ ( product_prod @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) )
              @ ^ [V5: code_natural,W4: code_natural] : ( product_Pair @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) @ ( product_Pair @ code_natural @ code_natural @ ( inc_shift @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ V2 ) @ W4 ) @ ( product_Pair @ code_natural @ code_natural @ V5 @ ( inc_shift @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ W3 ) ) )
              @ ( product_snd @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( next @ S ) ) )
          @ S ) ) ) ).

% split_seed_def
thf(fact_5859_Random_Orange__def,axiom,
    ( range
    = ( ^ [K6: code_natural] :
          ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) )
          @ ( iterate @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( log @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ K6 )
            @ ^ [L2: code_natural] :
                ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) @ next
                @ ^ [V2: code_natural] : ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( plus_plus @ code_natural @ V2 @ ( times_times @ code_natural @ L2 @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
            @ ( one_one @ code_natural ) )
          @ ^ [V2: code_natural] : ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( modulo_modulo @ code_natural @ V2 @ K6 ) ) ) ) ) ).

% Random.range_def
thf(fact_5860_Abs__int__inverse,axiom,
    ! [Y: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( set @ ( product_prod @ nat @ nat ) ) @ Y
        @ ( collect @ ( set @ ( product_prod @ nat @ nat ) )
          @ ^ [C5: set @ ( product_prod @ nat @ nat )] :
            ? [X2: product_prod @ nat @ nat] :
              ( ( intrel @ X2 @ X2 )
              & ( C5
                = ( collect @ ( product_prod @ nat @ nat ) @ ( intrel @ X2 ) ) ) ) ) )
     => ( ( rep_int @ ( abs_int @ Y ) )
        = Y ) ) ).

% Abs_int_inverse
thf(fact_5861_Rep__int,axiom,
    ! [X3: int] :
      ( member @ ( set @ ( product_prod @ nat @ nat ) ) @ ( rep_int @ X3 )
      @ ( collect @ ( set @ ( product_prod @ nat @ nat ) )
        @ ^ [C5: set @ ( product_prod @ nat @ nat )] :
          ? [X2: product_prod @ nat @ nat] :
            ( ( intrel @ X2 @ X2 )
            & ( C5
              = ( collect @ ( product_prod @ nat @ nat ) @ ( intrel @ X2 ) ) ) ) ) ) ).

% Rep_int
thf(fact_5862_Rep__int__cases,axiom,
    ! [Y: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( set @ ( product_prod @ nat @ nat ) ) @ Y
        @ ( collect @ ( set @ ( product_prod @ nat @ nat ) )
          @ ^ [C5: set @ ( product_prod @ nat @ nat )] :
            ? [X2: product_prod @ nat @ nat] :
              ( ( intrel @ X2 @ X2 )
              & ( C5
                = ( collect @ ( product_prod @ nat @ nat ) @ ( intrel @ X2 ) ) ) ) ) )
     => ~ ! [X: int] :
            ( Y
           != ( rep_int @ X ) ) ) ).

% Rep_int_cases
thf(fact_5863_Rep__int__induct,axiom,
    ! [Y: set @ ( product_prod @ nat @ nat ),P: ( set @ ( product_prod @ nat @ nat ) ) > $o] :
      ( ( member @ ( set @ ( product_prod @ nat @ nat ) ) @ Y
        @ ( collect @ ( set @ ( product_prod @ nat @ nat ) )
          @ ^ [C5: set @ ( product_prod @ nat @ nat )] :
            ? [X2: product_prod @ nat @ nat] :
              ( ( intrel @ X2 @ X2 )
              & ( C5
                = ( collect @ ( product_prod @ nat @ nat ) @ ( intrel @ X2 ) ) ) ) ) )
     => ( ! [X: int] : ( P @ ( rep_int @ X ) )
       => ( P @ Y ) ) ) ).

% Rep_int_induct
thf(fact_5864_type__definition__int,axiom,
    ( type_definition @ int @ ( set @ ( product_prod @ nat @ nat ) ) @ rep_int @ abs_int
    @ ( collect @ ( set @ ( product_prod @ nat @ nat ) )
      @ ^ [C5: set @ ( product_prod @ nat @ nat )] :
        ? [X2: product_prod @ nat @ nat] :
          ( ( intrel @ X2 @ X2 )
          & ( C5
            = ( collect @ ( product_prod @ nat @ nat ) @ ( intrel @ X2 ) ) ) ) ) ) ).

% type_definition_int
thf(fact_5865_select__weight__def,axiom,
    ! [A: $tType] :
      ( ( select_weight @ A )
      = ( ^ [Xs2: list @ ( product_prod @ code_natural @ A )] :
            ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ A @ ( product_prod @ code_natural @ code_natural ) ) @ ( range @ ( groups8242544230860333062m_list @ code_natural @ ( map @ ( product_prod @ code_natural @ A ) @ code_natural @ ( product_fst @ code_natural @ A ) @ Xs2 ) ) )
            @ ^ [K6: code_natural] : ( product_Pair @ A @ ( product_prod @ code_natural @ code_natural ) @ ( pick @ A @ Xs2 @ K6 ) ) ) ) ) ).

% select_weight_def
thf(fact_5866_pick__drop__zero,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ code_natural @ A )] :
      ( ( pick @ A
        @ ( filter2 @ ( product_prod @ code_natural @ A )
          @ ( product_case_prod @ code_natural @ A @ $o
            @ ^ [K6: code_natural,Uu: A] : ( ord_less @ code_natural @ ( zero_zero @ code_natural ) @ K6 ) )
          @ Xs ) )
      = ( pick @ A @ Xs ) ) ).

% pick_drop_zero
thf(fact_5867_select__weight__drop__zero,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ code_natural @ A )] :
      ( ( select_weight @ A
        @ ( filter2 @ ( product_prod @ code_natural @ A )
          @ ( product_case_prod @ code_natural @ A @ $o
            @ ^ [K6: code_natural,Uu: A] : ( ord_less @ code_natural @ ( zero_zero @ code_natural ) @ K6 ) )
          @ Xs ) )
      = ( select_weight @ A @ Xs ) ) ).

% select_weight_drop_zero
thf(fact_5868_comm__monoid__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
            ( ( abel_semigroup @ A @ F3 )
            & ( comm_monoid_axioms @ A @ F3 @ Z3 ) ) ) ) ).

% comm_monoid_def
thf(fact_5869_comm__monoid_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( ( comm_monoid_axioms @ A @ F2 @ Z2 )
       => ( comm_monoid @ A @ F2 @ Z2 ) ) ) ).

% comm_monoid.intro
thf(fact_5870_ordering_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ordering_axioms @ A @ Less_eq @ Less ) ) ).

% ordering.axioms(2)
thf(fact_5871_mult_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( abel_semigroup @ A @ ( times_times @ A ) ) ) ).

% mult.abel_semigroup_axioms
thf(fact_5872_add_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( abel_semigroup @ A @ ( plus_plus @ A ) ) ) ).

% add.abel_semigroup_axioms
thf(fact_5873_sup_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( abel_semigroup @ A @ ( sup_sup @ A ) ) ) ).

% sup.abel_semigroup_axioms
thf(fact_5874_comm__monoid_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( comm_monoid @ A @ F2 @ Z2 )
     => ( abel_semigroup @ A @ F2 ) ) ).

% comm_monoid.axioms(1)
thf(fact_5875_min_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( abel_semigroup @ A @ ( ord_min @ A ) ) ) ).

% min.abel_semigroup_axioms
thf(fact_5876_max_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( abel_semigroup @ A @ ( ord_max @ A ) ) ) ).

% max.abel_semigroup_axioms
thf(fact_5877_ordering__axioms_Ointro,axiom,
    ! [A: $tType,Less: A > A > $o,Less_eq: A > A > $o] :
      ( ! [A7: A,B6: A] :
          ( ( Less @ A7 @ B6 )
          = ( ( Less_eq @ A7 @ B6 )
            & ( A7 != B6 ) ) )
     => ( ! [A7: A,B6: A] :
            ( ( Less_eq @ A7 @ B6 )
           => ( ( Less_eq @ B6 @ A7 )
             => ( A7 = B6 ) ) )
       => ( ordering_axioms @ A @ Less_eq @ Less ) ) ) ).

% ordering_axioms.intro
thf(fact_5878_ordering__axioms__def,axiom,
    ! [A: $tType] :
      ( ( ordering_axioms @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ! [A5: A,B4: A] :
                ( ( Less2 @ A5 @ B4 )
                = ( ( Less_eq2 @ A5 @ B4 )
                  & ( A5 != B4 ) ) )
            & ! [A5: A,B4: A] :
                ( ( Less_eq2 @ A5 @ B4 )
               => ( ( Less_eq2 @ B4 @ A5 )
                 => ( A5 = B4 ) ) ) ) ) ) ).

% ordering_axioms_def
thf(fact_5879_abel__semigroup_Ocommute,axiom,
    ! [A: $tType,F2: A > A > A,A4: A,B3: A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( ( F2 @ A4 @ B3 )
        = ( F2 @ B3 @ A4 ) ) ) ).

% abel_semigroup.commute
thf(fact_5880_abel__semigroup_Oleft__commute,axiom,
    ! [A: $tType,F2: A > A > A,B3: A,A4: A,C2: A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( ( F2 @ B3 @ ( F2 @ A4 @ C2 ) )
        = ( F2 @ A4 @ ( F2 @ B3 @ C2 ) ) ) ) ).

% abel_semigroup.left_commute
thf(fact_5881_abstract__boolean__algebra_Oaxioms_I1_J,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( abel_semigroup @ A @ Conj ) ) ).

% abstract_boolean_algebra.axioms(1)
thf(fact_5882_abstract__boolean__algebra_Oaxioms_I2_J,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( abel_semigroup @ A @ Disj ) ) ).

% abstract_boolean_algebra.axioms(2)
thf(fact_5883_abel__semigroup_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( semigroup @ A @ F2 ) ) ).

% abel_semigroup.axioms(1)
thf(fact_5884_inf_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( abel_semigroup @ A @ ( inf_inf @ A ) ) ) ).

% inf.abel_semigroup_axioms
thf(fact_5885_abel__semigroup__def,axiom,
    ! [A: $tType] :
      ( ( abel_semigroup @ A )
      = ( ^ [F3: A > A > A] :
            ( ( semigroup @ A @ F3 )
            & ( abel_s757365448890700780axioms @ A @ F3 ) ) ) ) ).

% abel_semigroup_def
thf(fact_5886_abel__semigroup_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( semigroup @ A @ F2 )
     => ( ( abel_s757365448890700780axioms @ A @ F2 )
       => ( abel_semigroup @ A @ F2 ) ) ) ).

% abel_semigroup.intro
thf(fact_5887_abstract__boolean__algebra__def,axiom,
    ! [A: $tType] :
      ( ( boolea2506097494486148201lgebra @ A )
      = ( ^ [Conj2: A > A > A,Disj2: A > A > A,Compl2: A > A,Zero2: A,One2: A] :
            ( ( abel_semigroup @ A @ Conj2 )
            & ( abel_semigroup @ A @ Disj2 )
            & ( boolea6902313364301356556axioms @ A @ Conj2 @ Disj2 @ Compl2 @ Zero2 @ One2 ) ) ) ) ).

% abstract_boolean_algebra_def
thf(fact_5888_abel__semigroup__axioms__def,axiom,
    ! [A: $tType] :
      ( ( abel_s757365448890700780axioms @ A )
      = ( ^ [F3: A > A > A] :
          ! [A5: A,B4: A] :
            ( ( F3 @ A5 @ B4 )
            = ( F3 @ B4 @ A5 ) ) ) ) ).

% abel_semigroup_axioms_def
thf(fact_5889_abel__semigroup__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ! [A7: A,B6: A] :
          ( ( F2 @ A7 @ B6 )
          = ( F2 @ B6 @ A7 ) )
     => ( abel_s757365448890700780axioms @ A @ F2 ) ) ).

% abel_semigroup_axioms.intro
thf(fact_5890_abstract__boolean__algebra__axioms__def,axiom,
    ! [A: $tType] :
      ( ( boolea6902313364301356556axioms @ A )
      = ( ^ [Conj2: A > A > A,Disj2: A > A > A,Compl2: A > A,Zero2: A,One2: A] :
            ( ! [X2: A,Y2: A,Z3: A] :
                ( ( Conj2 @ X2 @ ( Disj2 @ Y2 @ Z3 ) )
                = ( Disj2 @ ( Conj2 @ X2 @ Y2 ) @ ( Conj2 @ X2 @ Z3 ) ) )
            & ! [X2: A,Y2: A,Z3: A] :
                ( ( Disj2 @ X2 @ ( Conj2 @ Y2 @ Z3 ) )
                = ( Conj2 @ ( Disj2 @ X2 @ Y2 ) @ ( Disj2 @ X2 @ Z3 ) ) )
            & ! [X2: A] :
                ( ( Conj2 @ X2 @ One2 )
                = X2 )
            & ! [X2: A] :
                ( ( Disj2 @ X2 @ Zero2 )
                = X2 )
            & ! [X2: A] :
                ( ( Conj2 @ X2 @ ( Compl2 @ X2 ) )
                = Zero2 )
            & ! [X2: A] :
                ( ( Disj2 @ X2 @ ( Compl2 @ X2 ) )
                = One2 ) ) ) ) ).

% abstract_boolean_algebra_axioms_def
thf(fact_5891_abstract__boolean__algebra__axioms_Ointro,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,One: A,Zero: A,Compl: A > A] :
      ( ! [X: A,Y3: A,Z4: A] :
          ( ( Conj @ X @ ( Disj @ Y3 @ Z4 ) )
          = ( Disj @ ( Conj @ X @ Y3 ) @ ( Conj @ X @ Z4 ) ) )
     => ( ! [X: A,Y3: A,Z4: A] :
            ( ( Disj @ X @ ( Conj @ Y3 @ Z4 ) )
            = ( Conj @ ( Disj @ X @ Y3 ) @ ( Disj @ X @ Z4 ) ) )
       => ( ! [X: A] :
              ( ( Conj @ X @ One )
              = X )
         => ( ! [X: A] :
                ( ( Disj @ X @ Zero )
                = X )
           => ( ! [X: A] :
                  ( ( Conj @ X @ ( Compl @ X ) )
                  = Zero )
             => ( ! [X: A] :
                    ( ( Disj @ X @ ( Compl @ X ) )
                    = One )
               => ( boolea6902313364301356556axioms @ A @ Conj @ Disj @ Compl @ Zero @ One ) ) ) ) ) ) ) ).

% abstract_boolean_algebra_axioms.intro
thf(fact_5892_abel__semigroup_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( abel_s757365448890700780axioms @ A @ F2 ) ) ).

% abel_semigroup.axioms(2)
thf(fact_5893_abstract__boolean__algebra_Oaxioms_I3_J,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( boolea6902313364301356556axioms @ A @ Conj @ Disj @ Compl @ Zero @ One ) ) ).

% abstract_boolean_algebra.axioms(3)
thf(fact_5894_abstract__boolean__algebra_Ointro,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( abel_semigroup @ A @ Conj )
     => ( ( abel_semigroup @ A @ Disj )
       => ( ( boolea6902313364301356556axioms @ A @ Conj @ Disj @ Compl @ Zero @ One )
         => ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One ) ) ) ) ).

% abstract_boolean_algebra.intro
thf(fact_5895_ordering__def,axiom,
    ! [A: $tType] :
      ( ( ordering @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( partial_preordering @ A @ Less_eq2 )
            & ( ordering_axioms @ A @ Less_eq2 @ Less2 ) ) ) ) ).

% ordering_def
thf(fact_5896_ordering_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( partial_preordering @ A @ Less_eq )
     => ( ( ordering_axioms @ A @ Less_eq @ Less )
       => ( ordering @ A @ Less_eq @ Less ) ) ) ).

% ordering.intro
thf(fact_5897_sort__mergesort__by__rel,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_sort_key @ A @ A
          @ ^ [X2: A] : X2 )
        = ( mergesort_by_rel @ A @ ( ord_less_eq @ A ) ) ) ) ).

% sort_mergesort_by_rel
thf(fact_5898_partial__preordering_Orefl,axiom,
    ! [A: $tType,Less_eq: A > A > $o,A4: A] :
      ( ( partial_preordering @ A @ Less_eq )
     => ( Less_eq @ A4 @ A4 ) ) ).

% partial_preordering.refl
thf(fact_5899_partial__preordering_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o] :
      ( ! [A7: A] : ( Less_eq @ A7 @ A7 )
     => ( ! [A7: A,B6: A,C4: A] :
            ( ( Less_eq @ A7 @ B6 )
           => ( ( Less_eq @ B6 @ C4 )
             => ( Less_eq @ A7 @ C4 ) ) )
       => ( partial_preordering @ A @ Less_eq ) ) ) ).

% partial_preordering.intro
thf(fact_5900_partial__preordering_Otrans,axiom,
    ! [A: $tType,Less_eq: A > A > $o,A4: A,B3: A,C2: A] :
      ( ( partial_preordering @ A @ Less_eq )
     => ( ( Less_eq @ A4 @ B3 )
       => ( ( Less_eq @ B3 @ C2 )
         => ( Less_eq @ A4 @ C2 ) ) ) ) ).

% partial_preordering.trans
thf(fact_5901_partial__preordering__def,axiom,
    ! [A: $tType] :
      ( ( partial_preordering @ A )
      = ( ^ [Less_eq2: A > A > $o] :
            ( ! [A5: A] : ( Less_eq2 @ A5 @ A5 )
            & ! [A5: A,B4: A,C5: A] :
                ( ( Less_eq2 @ A5 @ B4 )
               => ( ( Less_eq2 @ B4 @ C5 )
                 => ( Less_eq2 @ A5 @ C5 ) ) ) ) ) ) ).

% partial_preordering_def
thf(fact_5902_order_Opartial__preordering__axioms,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( partial_preordering @ A @ ( ord_less_eq @ A ) ) ) ).

% order.partial_preordering_axioms
thf(fact_5903_ordering_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( partial_preordering @ A @ Less_eq ) ) ).

% ordering.axioms(1)
thf(fact_5904_subset__mset_Odual__order_Opartial__preordering__axioms,axiom,
    ! [A: $tType] :
      ( partial_preordering @ ( multiset @ A )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subseteq_mset @ A @ Y2 @ X2 ) ) ).

% subset_mset.dual_order.partial_preordering_axioms
thf(fact_5905_dual__order_Opartial__preordering__axioms,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( partial_preordering @ A
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% dual_order.partial_preordering_axioms
thf(fact_5906_mergesort__by__rel__simps_I3_J,axiom,
    ! [A: $tType,R: A > A > $o,X14: A,X25: A,Xs: list @ A] :
      ( ( mergesort_by_rel @ A @ R @ ( cons @ A @ X14 @ ( cons @ A @ X25 @ Xs ) ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
        @ ^ [Xs1: list @ A,Xs22: list @ A] : ( merges9089515139780605204_merge @ A @ R @ ( mergesort_by_rel @ A @ R @ Xs1 ) @ ( mergesort_by_rel @ A @ R @ Xs22 ) )
        @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X14 @ ( nil @ A ) ) @ ( cons @ A @ X25 @ ( nil @ A ) ) ) @ Xs ) ) ) ).

% mergesort_by_rel_simps(3)
thf(fact_5907_semilattice__neutr_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( semilattice @ A @ F2 )
     => ( ( comm_monoid @ A @ F2 @ Z2 )
       => ( semilattice_neutr @ A @ F2 @ Z2 ) ) ) ).

% semilattice_neutr.intro
thf(fact_5908_semilattice__neutr__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_neutr @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
            ( ( semilattice @ A @ F3 )
            & ( comm_monoid @ A @ F3 @ Z3 ) ) ) ) ).

% semilattice_neutr_def
thf(fact_5909_semilattice__map2,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( semilattice @ A @ F2 )
     => ( semilattice @ ( list @ A )
        @ ^ [Xs2: list @ A,Ys2: list @ A] : ( map @ ( product_prod @ A @ A ) @ A @ ( product_case_prod @ A @ A @ A @ F2 ) @ ( zip @ A @ A @ Xs2 @ Ys2 ) ) ) ) ).

% semilattice_map2
thf(fact_5910_semilattice_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( semilattice @ A @ F2 )
     => ( abel_semigroup @ A @ F2 ) ) ).

% semilattice.axioms(1)
thf(fact_5911_inf_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( semilattice @ A @ ( inf_inf @ A ) ) ) ).

% inf.semilattice_axioms
thf(fact_5912_semilattice__neutr_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( semilattice_neutr @ A @ F2 @ Z2 )
     => ( semilattice @ A @ F2 ) ) ).

% semilattice_neutr.axioms(1)
thf(fact_5913_max_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice @ A @ ( ord_max @ A ) ) ) ).

% max.semilattice_axioms
thf(fact_5914_min_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice @ A @ ( ord_min @ A ) ) ) ).

% min.semilattice_axioms
thf(fact_5915_semilattice_Oright__idem,axiom,
    ! [A: $tType,F2: A > A > A,A4: A,B3: A] :
      ( ( semilattice @ A @ F2 )
     => ( ( F2 @ ( F2 @ A4 @ B3 ) @ B3 )
        = ( F2 @ A4 @ B3 ) ) ) ).

% semilattice.right_idem
thf(fact_5916_semilattice_Oleft__idem,axiom,
    ! [A: $tType,F2: A > A > A,A4: A,B3: A] :
      ( ( semilattice @ A @ F2 )
     => ( ( F2 @ A4 @ ( F2 @ A4 @ B3 ) )
        = ( F2 @ A4 @ B3 ) ) ) ).

% semilattice.left_idem
thf(fact_5917_semilattice_Oidem,axiom,
    ! [A: $tType,F2: A > A > A,A4: A] :
      ( ( semilattice @ A @ F2 )
     => ( ( F2 @ A4 @ A4 )
        = A4 ) ) ).

% semilattice.idem
thf(fact_5918_sup_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( semilattice @ A @ ( sup_sup @ A ) ) ) ).

% sup.semilattice_axioms
thf(fact_5919_semilattice__order_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( semilattice @ A @ F2 ) ) ).

% semilattice_order.axioms(1)
thf(fact_5920_semilattice_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( ( semilattice_axioms @ A @ F2 )
       => ( semilattice @ A @ F2 ) ) ) ).

% semilattice.intro
thf(fact_5921_semilattice__def,axiom,
    ! [A: $tType] :
      ( ( semilattice @ A )
      = ( ^ [F3: A > A > A] :
            ( ( abel_semigroup @ A @ F3 )
            & ( semilattice_axioms @ A @ F3 ) ) ) ) ).

% semilattice_def
thf(fact_5922_semilattice__order__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_order @ A )
      = ( ^ [F3: A > A > A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( semilattice @ A @ F3 )
            & ( semila6385135966242565138axioms @ A @ F3 @ Less_eq2 @ Less2 ) ) ) ) ).

% semilattice_order_def
thf(fact_5923_semilattice__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ! [A7: A] :
          ( ( F2 @ A7 @ A7 )
          = A7 )
     => ( semilattice_axioms @ A @ F2 ) ) ).

% semilattice_axioms.intro
thf(fact_5924_semilattice__order__axioms_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,F2: A > A > A,Less: A > A > $o] :
      ( ! [A7: A,B6: A] :
          ( ( Less_eq @ A7 @ B6 )
          = ( A7
            = ( F2 @ A7 @ B6 ) ) )
     => ( ! [A7: A,B6: A] :
            ( ( Less @ A7 @ B6 )
            = ( ( A7
                = ( F2 @ A7 @ B6 ) )
              & ( A7 != B6 ) ) )
       => ( semila6385135966242565138axioms @ A @ F2 @ Less_eq @ Less ) ) ) ).

% semilattice_order_axioms.intro
thf(fact_5925_semilattice__axioms__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_axioms @ A )
      = ( ^ [F3: A > A > A] :
          ! [A5: A] :
            ( ( F3 @ A5 @ A5 )
            = A5 ) ) ) ).

% semilattice_axioms_def
thf(fact_5926_semilattice__order__axioms__def,axiom,
    ! [A: $tType] :
      ( ( semila6385135966242565138axioms @ A )
      = ( ^ [F3: A > A > A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ! [A5: A,B4: A] :
                ( ( Less_eq2 @ A5 @ B4 )
                = ( A5
                  = ( F3 @ A5 @ B4 ) ) )
            & ! [A5: A,B4: A] :
                ( ( Less2 @ A5 @ B4 )
                = ( ( A5
                    = ( F3 @ A5 @ B4 ) )
                  & ( A5 != B4 ) ) ) ) ) ) ).

% semilattice_order_axioms_def
thf(fact_5927_semilattice__order_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( semila6385135966242565138axioms @ A @ F2 @ Less_eq @ Less ) ) ).

% semilattice_order.axioms(2)
thf(fact_5928_semilattice_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( semilattice @ A @ F2 )
     => ( semilattice_axioms @ A @ F2 ) ) ).

% semilattice.axioms(2)
thf(fact_5929_semilattice__order_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice @ A @ F2 )
     => ( ( semila6385135966242565138axioms @ A @ F2 @ Less_eq @ Less )
       => ( semilattice_order @ A @ F2 @ Less_eq @ Less ) ) ) ).

% semilattice_order.intro
thf(fact_5930_subset__mset_Odual__order_Opreordering__axioms,axiom,
    ! [A: $tType] :
      ( preordering @ ( multiset @ A )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subseteq_mset @ A @ Y2 @ X2 )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subset_mset @ A @ Y2 @ X2 ) ) ).

% subset_mset.dual_order.preordering_axioms
thf(fact_5931_list__decode_Oelims,axiom,
    ! [X3: nat,Y: list @ nat] :
      ( ( ( nat_list_decode @ X3 )
        = Y )
     => ( ( ( X3
            = ( zero_zero @ nat ) )
         => ( Y
           != ( nil @ nat ) ) )
       => ~ ! [N2: nat] :
              ( ( X3
                = ( suc @ N2 ) )
             => ( Y
               != ( product_case_prod @ nat @ nat @ ( list @ nat )
                  @ ^ [X2: nat,Y2: nat] : ( cons @ nat @ X2 @ ( nat_list_decode @ Y2 ) )
                  @ ( nat_prod_decode @ N2 ) ) ) ) ) ) ).

% list_decode.elims
thf(fact_5932_dual__order_Opreordering__axioms,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( preordering @ A
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% dual_order.preordering_axioms
thf(fact_5933_preordering__dualI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( preordering @ A
        @ ^ [A5: A,B4: A] : ( Less_eq @ B4 @ A5 )
        @ ^ [A5: A,B4: A] : ( Less @ B4 @ A5 ) )
     => ( preordering @ A @ Less_eq @ Less ) ) ).

% preordering_dualI
thf(fact_5934_preordering__strictI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ! [A7: A,B6: A] :
          ( ( Less_eq @ A7 @ B6 )
          = ( ( Less @ A7 @ B6 )
            | ( A7 = B6 ) ) )
     => ( ! [A7: A,B6: A] :
            ( ( Less @ A7 @ B6 )
           => ~ ( Less @ B6 @ A7 ) )
       => ( ! [A7: A] :
              ~ ( Less @ A7 @ A7 )
         => ( ! [A7: A,B6: A,C4: A] :
                ( ( Less @ A7 @ B6 )
               => ( ( Less @ B6 @ C4 )
                 => ( Less @ A7 @ C4 ) ) )
           => ( preordering @ A @ Less_eq @ Less ) ) ) ) ) ).

% preordering_strictI
thf(fact_5935_preordering_Ostrict__implies__order,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less @ A4 @ B3 )
       => ( Less_eq @ A4 @ B3 ) ) ) ).

% preordering.strict_implies_order
thf(fact_5936_preordering_Ostrict__iff__not,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less @ A4 @ B3 )
        = ( ( Less_eq @ A4 @ B3 )
          & ~ ( Less_eq @ B3 @ A4 ) ) ) ) ).

% preordering.strict_iff_not
thf(fact_5937_preordering_Ostrict__trans2,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A,C2: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less @ A4 @ B3 )
       => ( ( Less_eq @ B3 @ C2 )
         => ( Less @ A4 @ C2 ) ) ) ) ).

% preordering.strict_trans2
thf(fact_5938_preordering_Ostrict__trans1,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A,C2: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less_eq @ A4 @ B3 )
       => ( ( Less @ B3 @ C2 )
         => ( Less @ A4 @ C2 ) ) ) ) ).

% preordering.strict_trans1
thf(fact_5939_preordering_Ostrict__trans,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A,C2: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less @ A4 @ B3 )
       => ( ( Less @ B3 @ C2 )
         => ( Less @ A4 @ C2 ) ) ) ) ).

% preordering.strict_trans
thf(fact_5940_preordering_Oirrefl,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ~ ( Less @ A4 @ A4 ) ) ).

% preordering.irrefl
thf(fact_5941_preordering_Oasym,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: A,B3: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less @ A4 @ B3 )
       => ~ ( Less @ B3 @ A4 ) ) ) ).

% preordering.asym
thf(fact_5942_gcd__nat_Opreordering__axioms,axiom,
    ( preordering @ nat @ ( dvd_dvd @ nat )
    @ ^ [M5: nat,N5: nat] :
        ( ( dvd_dvd @ nat @ M5 @ N5 )
        & ( M5 != N5 ) ) ) ).

% gcd_nat.preordering_axioms
thf(fact_5943_list__decode_Osimps_I2_J,axiom,
    ! [N: nat] :
      ( ( nat_list_decode @ ( suc @ N ) )
      = ( product_case_prod @ nat @ nat @ ( list @ nat )
        @ ^ [X2: nat,Y2: nat] : ( cons @ nat @ X2 @ ( nat_list_decode @ Y2 ) )
        @ ( nat_prod_decode @ N ) ) ) ).

% list_decode.simps(2)
thf(fact_5944_preordering_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( partial_preordering @ A @ Less_eq ) ) ).

% preordering.axioms(1)
thf(fact_5945_order_Opreordering__axioms,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( preordering @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% order.preordering_axioms
thf(fact_5946_preordering__def,axiom,
    ! [A: $tType] :
      ( ( preordering @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( partial_preordering @ A @ Less_eq2 )
            & ( preordering_axioms @ A @ Less_eq2 @ Less2 ) ) ) ) ).

% preordering_def
thf(fact_5947_preordering_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( partial_preordering @ A @ Less_eq )
     => ( ( preordering_axioms @ A @ Less_eq @ Less )
       => ( preordering @ A @ Less_eq @ Less ) ) ) ).

% preordering.intro
thf(fact_5948_list__decode_Opelims,axiom,
    ! [X3: nat,Y: list @ nat] :
      ( ( ( nat_list_decode @ X3 )
        = Y )
     => ( ( accp @ nat @ nat_list_decode_rel @ X3 )
       => ( ( ( X3
              = ( zero_zero @ nat ) )
           => ( ( Y
                = ( nil @ nat ) )
             => ~ ( accp @ nat @ nat_list_decode_rel @ ( zero_zero @ nat ) ) ) )
         => ~ ! [N2: nat] :
                ( ( X3
                  = ( suc @ N2 ) )
               => ( ( Y
                    = ( product_case_prod @ nat @ nat @ ( list @ nat )
                      @ ^ [X2: nat,Y2: nat] : ( cons @ nat @ X2 @ ( nat_list_decode @ Y2 ) )
                      @ ( nat_prod_decode @ N2 ) ) )
                 => ~ ( accp @ nat @ nat_list_decode_rel @ ( suc @ N2 ) ) ) ) ) ) ) ).

% list_decode.pelims
thf(fact_5949_preordering__axioms_Ointro,axiom,
    ! [A: $tType,Less: A > A > $o,Less_eq: A > A > $o] :
      ( ! [A7: A,B6: A] :
          ( ( Less @ A7 @ B6 )
          = ( ( Less_eq @ A7 @ B6 )
            & ~ ( Less_eq @ B6 @ A7 ) ) )
     => ( preordering_axioms @ A @ Less_eq @ Less ) ) ).

% preordering_axioms.intro
thf(fact_5950_preordering__axioms__def,axiom,
    ! [A: $tType] :
      ( ( preordering_axioms @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o] :
          ! [A5: A,B4: A] :
            ( ( Less2 @ A5 @ B4 )
            = ( ( Less_eq2 @ A5 @ B4 )
              & ~ ( Less_eq2 @ B4 @ A5 ) ) ) ) ) ).

% preordering_axioms_def
thf(fact_5951_preordering_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( preordering_axioms @ A @ Less_eq @ Less ) ) ).

% preordering.axioms(2)
thf(fact_5952_list__decode_Opsimps_I2_J,axiom,
    ! [N: nat] :
      ( ( accp @ nat @ nat_list_decode_rel @ ( suc @ N ) )
     => ( ( nat_list_decode @ ( suc @ N ) )
        = ( product_case_prod @ nat @ nat @ ( list @ nat )
          @ ^ [X2: nat,Y2: nat] : ( cons @ nat @ X2 @ ( nat_list_decode @ Y2 ) )
          @ ( nat_prod_decode @ N ) ) ) ) ).

% list_decode.psimps(2)
thf(fact_5953_admissible__disj,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ( comple1908693960933563346ssible @ A @ ( complete_Sup_Sup @ A ) @ ( ord_less_eq @ A ) @ P )
         => ( ( comple1908693960933563346ssible @ A @ ( complete_Sup_Sup @ A ) @ ( ord_less_eq @ A ) @ Q )
           => ( comple1908693960933563346ssible @ A @ ( complete_Sup_Sup @ A ) @ ( ord_less_eq @ A )
              @ ^ [X2: A] :
                  ( ( P @ X2 )
                  | ( Q @ X2 ) ) ) ) ) ) ).

% admissible_disj
thf(fact_5954_ndepth__Push__Node__aux,axiom,
    ! [A: $tType,I3: nat,F2: nat > ( sum_sum @ A @ nat ),K: nat] :
      ( ( ( case_nat @ ( sum_sum @ A @ nat ) @ ( sum_Inr @ nat @ A @ ( suc @ I3 ) ) @ F2 @ K )
        = ( sum_Inr @ nat @ A @ ( zero_zero @ nat ) ) )
     => ( ord_less_eq @ nat
        @ ( suc
          @ ( ord_Least @ nat
            @ ^ [X2: nat] :
                ( ( F2 @ X2 )
                = ( sum_Inr @ nat @ A @ ( zero_zero @ nat ) ) ) ) )
        @ K ) ) ).

% ndepth_Push_Node_aux
thf(fact_5955_bij__image__Collect__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > B,P: A > $o] :
      ( ( bij_betw @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
     => ( ( image2 @ A @ B @ F2 @ ( collect @ A @ P ) )
        = ( collect @ B
          @ ^ [Y2: B] : ( P @ ( hilbert_inv_into @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 @ Y2 ) ) ) ) ) ).

% bij_image_Collect_eq
thf(fact_5956_inv__identity,axiom,
    ! [A: $tType] :
      ( ( hilbert_inv_into @ A @ A @ ( top_top @ ( set @ A ) )
        @ ^ [A5: A] : A5 )
      = ( ^ [A5: A] : A5 ) ) ).

% inv_identity
thf(fact_5957_inv__into__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( hilbert_inv_into @ A @ B )
      = ( ^ [A6: set @ A,F3: A > B,X2: B] :
            ( fChoice @ A
            @ ^ [Y2: A] :
                ( ( member @ A @ Y2 @ A6 )
                & ( ( F3 @ Y2 )
                  = X2 ) ) ) ) ) ).

% inv_into_def
thf(fact_5958_inv__into__def2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( hilbert_inv_into @ A @ B )
      = ( ^ [A6: set @ A,F3: A > B,X2: B] :
            ( fChoice @ A
            @ ^ [Y2: A] :
                ( ( member @ A @ Y2 @ A6 )
                & ( ( F3 @ Y2 )
                  = X2 ) ) ) ) ) ).

% inv_into_def2
thf(fact_5959_admissible__True,axiom,
    ! [A: $tType,Lub: ( set @ A ) > A,Ord: A > A > $o] :
      ( comple1908693960933563346ssible @ A @ Lub @ Ord
      @ ^ [X2: A] : $true ) ).

% admissible_True
thf(fact_5960_admissible__conj,axiom,
    ! [A: $tType,Lub: ( set @ A ) > A,Ord: A > A > $o,P: A > $o,Q: A > $o] :
      ( ( comple1908693960933563346ssible @ A @ Lub @ Ord @ P )
     => ( ( comple1908693960933563346ssible @ A @ Lub @ Ord @ Q )
       => ( comple1908693960933563346ssible @ A @ Lub @ Ord
          @ ^ [X2: A] :
              ( ( P @ X2 )
              & ( Q @ X2 ) ) ) ) ) ).

% admissible_conj
thf(fact_5961_admissible__const,axiom,
    ! [A: $tType,Lub: ( set @ A ) > A,Ord: A > A > $o,T3: $o] :
      ( comple1908693960933563346ssible @ A @ Lub @ Ord
      @ ^ [X2: A] : T3 ) ).

% admissible_const
thf(fact_5962_admissible__ball,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,Lub: ( set @ B ) > B,Ord: B > B > $o,P: B > A > $o] :
      ( ! [Y3: A] :
          ( ( member @ A @ Y3 @ A3 )
         => ( comple1908693960933563346ssible @ B @ Lub @ Ord
            @ ^ [X2: B] : ( P @ X2 @ Y3 ) ) )
     => ( comple1908693960933563346ssible @ B @ Lub @ Ord
        @ ^ [X2: B] :
          ! [Y2: A] :
            ( ( member @ A @ Y2 @ A3 )
           => ( P @ X2 @ Y2 ) ) ) ) ).

% admissible_ball
thf(fact_5963_admissible__all,axiom,
    ! [A: $tType,B: $tType,Lub: ( set @ B ) > B,Ord: B > B > $o,P: B > A > $o] :
      ( ! [Y3: A] :
          ( comple1908693960933563346ssible @ B @ Lub @ Ord
          @ ^ [X2: B] : ( P @ X2 @ Y3 ) )
     => ( comple1908693960933563346ssible @ B @ Lub @ Ord
        @ ^ [X2: B] :
          ! [X7: A] : ( P @ X2 @ X7 ) ) ) ).

% admissible_all
thf(fact_5964_inv__def,axiom,
    ! [B: $tType,A: $tType,F2: B > A] :
      ( ( hilbert_inv_into @ B @ A @ ( top_top @ ( set @ B ) ) @ F2 )
      = ( ^ [Y2: A] :
            ( fChoice @ B
            @ ^ [X2: B] :
                ( ( F2 @ X2 )
                = Y2 ) ) ) ) ).

% inv_def
thf(fact_5965_ccpo_Oadmissible__def,axiom,
    ! [A: $tType] :
      ( ( comple1908693960933563346ssible @ A )
      = ( ^ [Lub2: ( set @ A ) > A,Ord2: A > A > $o,P3: A > $o] :
          ! [A6: set @ A] :
            ( ( comple1602240252501008431_chain @ A @ Ord2 @ A6 )
           => ( ( A6
               != ( bot_bot @ ( set @ A ) ) )
             => ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A6 )
                   => ( P3 @ X2 ) )
               => ( P3 @ ( Lub2 @ A6 ) ) ) ) ) ) ) ).

% ccpo.admissible_def
thf(fact_5966_ccpo_OadmissibleI,axiom,
    ! [A: $tType,Ord: A > A > $o,P: A > $o,Lub: ( set @ A ) > A] :
      ( ! [A12: set @ A] :
          ( ( comple1602240252501008431_chain @ A @ Ord @ A12 )
         => ( ( A12
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X4: A] :
                  ( ( member @ A @ X4 @ A12 )
                 => ( P @ X4 ) )
             => ( P @ ( Lub @ A12 ) ) ) ) )
     => ( comple1908693960933563346ssible @ A @ Lub @ Ord @ P ) ) ).

% ccpo.admissibleI
thf(fact_5967_ccpo_OadmissibleD,axiom,
    ! [A: $tType,Lub: ( set @ A ) > A,Ord: A > A > $o,P: A > $o,A3: set @ A] :
      ( ( comple1908693960933563346ssible @ A @ Lub @ Ord @ P )
     => ( ( comple1602240252501008431_chain @ A @ Ord @ A3 )
       => ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A] :
                ( ( member @ A @ X @ A3 )
               => ( P @ X ) )
           => ( P @ ( Lub @ A3 ) ) ) ) ) ) ).

% ccpo.admissibleD
thf(fact_5968_Node__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( old_Node @ B @ A )
      = ( collect @ ( product_prod @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat ) )
        @ ^ [P6: product_prod @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat )] :
          ? [F3: nat > ( sum_sum @ B @ nat ),X2: sum_sum @ A @ nat,K6: nat] :
            ( ( P6
              = ( product_Pair @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat ) @ F3 @ X2 ) )
            & ( ( F3 @ K6 )
              = ( sum_Inr @ nat @ B @ ( zero_zero @ nat ) ) ) ) ) ) ).

% Node_def
thf(fact_5969_Union__plus,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: ( sum_sum @ B @ C ) > ( set @ A ),A3: set @ B,B2: set @ C] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( sum_sum @ B @ C ) @ ( set @ A ) @ F2 @ ( sum_Plus @ B @ C @ A3 @ B2 ) ) )
      = ( sup_sup @ ( set @ A )
        @ ( complete_Sup_Sup @ ( set @ A )
          @ ( image2 @ B @ ( set @ A )
            @ ^ [A5: B] : ( F2 @ ( sum_Inl @ B @ C @ A5 ) )
            @ A3 ) )
        @ ( complete_Sup_Sup @ ( set @ A )
          @ ( image2 @ C @ ( set @ A )
            @ ^ [B4: C] : ( F2 @ ( sum_Inr @ C @ B @ B4 ) )
            @ B2 ) ) ) ) ).

% Union_plus
thf(fact_5970_Union__sum,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: ( sum_sum @ A @ B ) > ( set @ C )] :
      ( ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ ( sum_sum @ A @ B ) @ ( set @ C ) @ F2 @ ( top_top @ ( set @ ( sum_sum @ A @ B ) ) ) ) )
      = ( sup_sup @ ( set @ C )
        @ ( complete_Sup_Sup @ ( set @ C )
          @ ( image2 @ A @ ( set @ C )
            @ ^ [L2: A] : ( F2 @ ( sum_Inl @ A @ B @ L2 ) )
            @ ( top_top @ ( set @ A ) ) ) )
        @ ( complete_Sup_Sup @ ( set @ C )
          @ ( image2 @ B @ ( set @ C )
            @ ^ [R3: B] : ( F2 @ ( sum_Inr @ B @ A @ R3 ) )
            @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% Union_sum
thf(fact_5971_surjective__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: ( sum_sum @ A @ B ) > C] :
      ( ( sum_case_sum @ A @ C @ B
        @ ^ [X2: A] : ( F2 @ ( sum_Inl @ A @ B @ X2 ) )
        @ ^ [Y2: B] : ( F2 @ ( sum_Inr @ B @ A @ Y2 ) ) )
      = F2 ) ).

% surjective_sum
thf(fact_5972_Node__K0__I,axiom,
    ! [B: $tType,A: $tType,A4: sum_sum @ B @ nat] :
      ( member @ ( product_prod @ ( nat > ( sum_sum @ A @ nat ) ) @ ( sum_sum @ B @ nat ) )
      @ ( product_Pair @ ( nat > ( sum_sum @ A @ nat ) ) @ ( sum_sum @ B @ nat )
        @ ^ [K6: nat] : ( sum_Inr @ nat @ A @ ( zero_zero @ nat ) )
        @ A4 )
      @ ( old_Node @ A @ B ) ) ).

% Node_K0_I
thf(fact_5973_prod_OPlus,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B2: set @ C,G: ( sum_sum @ B @ C ) > A] :
          ( ( finite_finite2 @ B @ A3 )
         => ( ( finite_finite2 @ C @ B2 )
           => ( ( groups7121269368397514597t_prod @ ( sum_sum @ B @ C ) @ A @ G @ ( sum_Plus @ B @ C @ A3 @ B2 ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ ( comp @ ( sum_sum @ B @ C ) @ A @ B @ G @ ( sum_Inl @ B @ C ) ) @ A3 ) @ ( groups7121269368397514597t_prod @ C @ A @ ( comp @ ( sum_sum @ B @ C ) @ A @ C @ G @ ( sum_Inr @ C @ B ) ) @ B2 ) ) ) ) ) ) ).

% prod.Plus
thf(fact_5974_card__order__csum__cone__cexp__def,axiom,
    ! [A: $tType,B: $tType,R5: set @ ( product_prod @ A @ A ),A13: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( top_top @ ( set @ A ) ) @ R5 )
     => ( ( bNF_Cardinal_cexp @ ( sum_sum @ B @ product_unit ) @ A @ ( bNF_Cardinal_csum @ B @ product_unit @ ( bNF_Ca6860139660246222851ard_of @ B @ A13 ) @ bNF_Cardinal_cone ) @ R5 )
        = ( bNF_Ca6860139660246222851ard_of @ ( A > ( sum_sum @ B @ product_unit ) ) @ ( bNF_Wellorder_Func @ A @ ( sum_sum @ B @ product_unit ) @ ( top_top @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( sum_sum @ B @ product_unit ) ) @ ( image2 @ B @ ( sum_sum @ B @ product_unit ) @ ( sum_Inl @ B @ product_unit ) @ A13 ) @ ( insert @ ( sum_sum @ B @ product_unit ) @ ( sum_Inr @ product_unit @ B @ product_Unity ) @ ( bot_bot @ ( set @ ( sum_sum @ B @ product_unit ) ) ) ) ) ) ) ) ) ).

% card_order_csum_cone_cexp_def
thf(fact_5975_sum__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,X3: A] :
      ( ( basic_setl @ A @ B @ ( sum_Inl @ A @ B @ X3 ) )
      = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% sum_set_simps(1)
thf(fact_5976_sum__set__simps_I2_J,axiom,
    ! [A: $tType,C: $tType,X3: A] :
      ( ( basic_setl @ C @ A @ ( sum_Inr @ A @ C @ X3 ) )
      = ( bot_bot @ ( set @ C ) ) ) ).

% sum_set_simps(2)
thf(fact_5977_sum__set__defs_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( basic_setl @ A @ B )
      = ( sum_case_sum @ A @ ( set @ A ) @ B
        @ ^ [Z3: A] : ( insert @ A @ Z3 @ ( bot_bot @ ( set @ A ) ) )
        @ ^ [B4: B] : ( bot_bot @ ( set @ A ) ) ) ) ).

% sum_set_defs(1)
thf(fact_5978_sum__set__simps_I4_J,axiom,
    ! [E: $tType,A: $tType,X3: A] :
      ( ( basic_setr @ E @ A @ ( sum_Inr @ A @ E @ X3 ) )
      = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% sum_set_simps(4)
thf(fact_5979_Push__def,axiom,
    ! [B: $tType] :
      ( ( old_Push @ B )
      = ( case_nat @ ( sum_sum @ B @ nat ) ) ) ).

% Push_def
thf(fact_5980_sum__set__simps_I3_J,axiom,
    ! [A: $tType,D: $tType,X3: A] :
      ( ( basic_setr @ A @ D @ ( sum_Inl @ A @ D @ X3 ) )
      = ( bot_bot @ ( set @ D ) ) ) ).

% sum_set_simps(3)
thf(fact_5981_sum__set__defs_I2_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( basic_setr @ C @ D )
      = ( sum_case_sum @ C @ ( set @ D ) @ D
        @ ^ [A5: C] : ( bot_bot @ ( set @ D ) )
        @ ^ [Z3: D] : ( insert @ D @ Z3 @ ( bot_bot @ ( set @ D ) ) ) ) ) ).

% sum_set_defs(2)
thf(fact_5982_ndepth__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( old_ndepth @ A @ B )
      = ( ^ [N5: old_node @ A @ B] :
            ( product_case_prod @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat ) @ nat
            @ ^ [F3: nat > ( sum_sum @ B @ nat ),X2: sum_sum @ A @ nat] :
                ( ord_Least @ nat
                @ ^ [K6: nat] :
                    ( ( F3 @ K6 )
                    = ( sum_Inr @ nat @ B @ ( zero_zero @ nat ) ) ) )
            @ ( old_Rep_Node @ A @ B @ N5 ) ) ) ) ).

% ndepth_def
thf(fact_5983_ndepth__K0,axiom,
    ! [A: $tType,B: $tType,X3: sum_sum @ A @ nat] :
      ( ( old_ndepth @ A @ B
        @ ( old_Abs_Node @ B @ A
          @ ( product_Pair @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat )
            @ ^ [K6: nat] : ( sum_Inr @ nat @ B @ ( zero_zero @ nat ) )
            @ X3 ) ) )
      = ( zero_zero @ nat ) ) ).

% ndepth_K0
thf(fact_5984_Atom__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( old_Atom @ A @ B )
      = ( ^ [X2: sum_sum @ A @ nat] :
            ( insert @ ( old_node @ A @ B )
            @ ( old_Abs_Node @ B @ A
              @ ( product_Pair @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat )
                @ ^ [K6: nat] : ( sum_Inr @ nat @ B @ ( zero_zero @ nat ) )
                @ X2 ) )
            @ ( bot_bot @ ( set @ ( old_node @ A @ B ) ) ) ) ) ) ).

% Atom_def
thf(fact_5985_Push__Node__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( old_Push_Node @ B @ A )
      = ( ^ [N5: sum_sum @ B @ nat,X2: old_node @ A @ B] : ( old_Abs_Node @ B @ A @ ( product_apfst @ ( nat > ( sum_sum @ B @ nat ) ) @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat ) @ ( old_Push @ B @ N5 ) @ ( old_Rep_Node @ A @ B @ X2 ) ) ) ) ) ).

% Push_Node_def
thf(fact_5986_Lim__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( old_Lim @ B @ A )
      = ( ^ [F3: B > ( set @ ( old_node @ A @ B ) )] :
            ( complete_Sup_Sup @ ( set @ ( old_node @ A @ B ) )
            @ ( collect @ ( set @ ( old_node @ A @ B ) )
              @ ^ [Z3: set @ ( old_node @ A @ B )] :
                ? [X2: B] :
                  ( Z3
                  = ( image2 @ ( old_node @ A @ B ) @ ( old_node @ A @ B ) @ ( old_Push_Node @ B @ A @ ( sum_Inl @ B @ nat @ X2 ) ) @ ( F3 @ X2 ) ) ) ) ) ) ) ).

% Lim_def
thf(fact_5987_ntrunc__0,axiom,
    ! [B: $tType,A: $tType,M: set @ ( old_node @ A @ B )] :
      ( ( old_ntrunc @ A @ B @ ( zero_zero @ nat ) @ M )
      = ( bot_bot @ ( set @ ( old_node @ A @ B ) ) ) ) ).

% ntrunc_0
thf(fact_5988_ntrunc__UN1,axiom,
    ! [A: $tType,B: $tType,C: $tType,K: nat,F2: C > ( set @ ( old_node @ A @ B ) )] :
      ( ( old_ntrunc @ A @ B @ K @ ( complete_Sup_Sup @ ( set @ ( old_node @ A @ B ) ) @ ( image2 @ C @ ( set @ ( old_node @ A @ B ) ) @ F2 @ ( top_top @ ( set @ C ) ) ) ) )
      = ( complete_Sup_Sup @ ( set @ ( old_node @ A @ B ) )
        @ ( image2 @ C @ ( set @ ( old_node @ A @ B ) )
          @ ^ [X2: C] : ( old_ntrunc @ A @ B @ K @ ( F2 @ X2 ) )
          @ ( top_top @ ( set @ C ) ) ) ) ) ).

% ntrunc_UN1
thf(fact_5989_ntrunc__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( old_ntrunc @ A @ B )
      = ( ^ [K6: nat,N7: set @ ( old_node @ A @ B )] :
            ( collect @ ( old_node @ A @ B )
            @ ^ [N5: old_node @ A @ B] :
                ( ( member @ ( old_node @ A @ B ) @ N5 @ N7 )
                & ( ord_less @ nat @ ( old_ndepth @ A @ B @ N5 ) @ K6 ) ) ) ) ) ).

% ntrunc_def
thf(fact_5990_ntrunc__one__In1,axiom,
    ! [B: $tType,A: $tType,M: set @ ( old_node @ A @ B )] :
      ( ( old_ntrunc @ A @ B @ ( suc @ ( zero_zero @ nat ) ) @ ( old_In1 @ A @ B @ M ) )
      = ( bot_bot @ ( set @ ( old_node @ A @ B ) ) ) ) ).

% ntrunc_one_In1
thf(fact_5991_ntrunc__one__In0,axiom,
    ! [B: $tType,A: $tType,M: set @ ( old_node @ A @ B )] :
      ( ( old_ntrunc @ A @ B @ ( suc @ ( zero_zero @ nat ) ) @ ( old_In0 @ A @ B @ M ) )
      = ( bot_bot @ ( set @ ( old_node @ A @ B ) ) ) ) ).

% ntrunc_one_In0
thf(fact_5992_In1__UN1,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: C > ( set @ ( old_node @ A @ B ) )] :
      ( ( old_In1 @ A @ B @ ( complete_Sup_Sup @ ( set @ ( old_node @ A @ B ) ) @ ( image2 @ C @ ( set @ ( old_node @ A @ B ) ) @ F2 @ ( top_top @ ( set @ C ) ) ) ) )
      = ( complete_Sup_Sup @ ( set @ ( old_node @ A @ B ) )
        @ ( image2 @ C @ ( set @ ( old_node @ A @ B ) )
          @ ^ [X2: C] : ( old_In1 @ A @ B @ ( F2 @ X2 ) )
          @ ( top_top @ ( set @ C ) ) ) ) ) ).

% In1_UN1
thf(fact_5993_In0__UN1,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: C > ( set @ ( old_node @ A @ B ) )] :
      ( ( old_In0 @ A @ B @ ( complete_Sup_Sup @ ( set @ ( old_node @ A @ B ) ) @ ( image2 @ C @ ( set @ ( old_node @ A @ B ) ) @ F2 @ ( top_top @ ( set @ C ) ) ) ) )
      = ( complete_Sup_Sup @ ( set @ ( old_node @ A @ B ) )
        @ ( image2 @ C @ ( set @ ( old_node @ A @ B ) )
          @ ^ [X2: C] : ( old_In0 @ A @ B @ ( F2 @ X2 ) )
          @ ( top_top @ ( set @ C ) ) ) ) ) ).

% In0_UN1
thf(fact_5994_Case__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( old_Case @ A @ B @ C )
      = ( ^ [C5: ( set @ ( old_node @ A @ B ) ) > C,D4: ( set @ ( old_node @ A @ B ) ) > C,M8: set @ ( old_node @ A @ B )] :
            ( the @ C
            @ ^ [U: C] :
                ( ? [X2: set @ ( old_node @ A @ B )] :
                    ( ( M8
                      = ( old_In0 @ A @ B @ X2 ) )
                    & ( U
                      = ( C5 @ X2 ) ) )
                | ? [Y2: set @ ( old_node @ A @ B )] :
                    ( ( M8
                      = ( old_In1 @ A @ B @ Y2 ) )
                    & ( U
                      = ( D4 @ Y2 ) ) ) ) ) ) ) ).

% Case_def
thf(fact_5995_dsum__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( old_dsum @ A @ B )
      = ( ^ [R3: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),S: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) )] :
            ( sup_sup @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
            @ ( complete_Sup_Sup @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
              @ ( image2 @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                @ ( product_case_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                  @ ^ [X2: set @ ( old_node @ A @ B ),X6: set @ ( old_node @ A @ B )] : ( insert @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_In0 @ A @ B @ X2 ) @ ( old_In0 @ A @ B @ X6 ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) ) ) )
                @ R3 ) )
            @ ( complete_Sup_Sup @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
              @ ( image2 @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                @ ( product_case_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                  @ ^ [Y2: set @ ( old_node @ A @ B ),Y6: set @ ( old_node @ A @ B )] : ( insert @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_In1 @ A @ B @ Y2 ) @ ( old_In1 @ A @ B @ Y6 ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) ) ) )
                @ S ) ) ) ) ) ).

% dsum_def
thf(fact_5996_dprod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( old_dprod @ A @ B )
      = ( ^ [R3: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),S: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
            @ ( image2 @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
              @ ( product_case_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                @ ^ [X2: set @ ( old_node @ A @ B ),X6: set @ ( old_node @ A @ B )] :
                    ( complete_Sup_Sup @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                    @ ( image2 @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                      @ ( product_case_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                        @ ^ [Y2: set @ ( old_node @ A @ B ),Y6: set @ ( old_node @ A @ B )] : ( insert @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_Scons @ A @ B @ X2 @ Y2 ) @ ( old_Scons @ A @ B @ X6 @ Y6 ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) ) ) )
                      @ S ) ) )
              @ R3 ) ) ) ) ).

% dprod_def
thf(fact_5997_Scons__UN1__y,axiom,
    ! [A: $tType,B: $tType,C: $tType,M: set @ ( old_node @ A @ B ),F2: C > ( set @ ( old_node @ A @ B ) )] :
      ( ( old_Scons @ A @ B @ M @ ( complete_Sup_Sup @ ( set @ ( old_node @ A @ B ) ) @ ( image2 @ C @ ( set @ ( old_node @ A @ B ) ) @ F2 @ ( top_top @ ( set @ C ) ) ) ) )
      = ( complete_Sup_Sup @ ( set @ ( old_node @ A @ B ) )
        @ ( image2 @ C @ ( set @ ( old_node @ A @ B ) )
          @ ^ [X2: C] : ( old_Scons @ A @ B @ M @ ( F2 @ X2 ) )
          @ ( top_top @ ( set @ C ) ) ) ) ) ).

% Scons_UN1_y
thf(fact_5998_Scons__UN1__x,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: C > ( set @ ( old_node @ A @ B ) ),M: set @ ( old_node @ A @ B )] :
      ( ( old_Scons @ A @ B @ ( complete_Sup_Sup @ ( set @ ( old_node @ A @ B ) ) @ ( image2 @ C @ ( set @ ( old_node @ A @ B ) ) @ F2 @ ( top_top @ ( set @ C ) ) ) ) @ M )
      = ( complete_Sup_Sup @ ( set @ ( old_node @ A @ B ) )
        @ ( image2 @ C @ ( set @ ( old_node @ A @ B ) )
          @ ^ [X2: C] : ( old_Scons @ A @ B @ ( F2 @ X2 ) @ M )
          @ ( top_top @ ( set @ C ) ) ) ) ) ).

% Scons_UN1_x
thf(fact_5999_Split__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( old_Split @ A @ B @ C )
      = ( ^ [C5: ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) > C,M8: set @ ( old_node @ A @ B )] :
            ( the @ C
            @ ^ [U: C] :
              ? [X2: set @ ( old_node @ A @ B ),Y2: set @ ( old_node @ A @ B )] :
                ( ( M8
                  = ( old_Scons @ A @ B @ X2 @ Y2 ) )
                & ( U
                  = ( C5 @ X2 @ Y2 ) ) ) ) ) ) ).

% Split_def
thf(fact_6000_setr__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_setr @ A @ B )
      = ( ^ [S: sum_sum @ A @ B] : ( collect @ B @ ( basic_setrp @ A @ B @ S ) ) ) ) ).

% setr_def
thf(fact_6001_setl__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_setl @ A @ B )
      = ( ^ [S: sum_sum @ A @ B] : ( collect @ A @ ( basic_setlp @ A @ B @ S ) ) ) ) ).

% setl_def
thf(fact_6002_dsum__subset__Sigma,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),A3: set @ ( set @ ( old_node @ A @ B ) ),B2: set @ ( set @ ( old_node @ A @ B ) ),S3: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),C3: set @ ( set @ ( old_node @ A @ B ) ),D2: set @ ( set @ ( old_node @ A @ B ) )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) @ R5
        @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ A3
          @ ^ [Uu: set @ ( old_node @ A @ B )] : B2 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) @ S3
          @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ C3
            @ ^ [Uu: set @ ( old_node @ A @ B )] : D2 ) )
       => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) @ ( old_dsum @ A @ B @ R5 @ S3 )
          @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_usum @ A @ B @ A3 @ C3 )
            @ ^ [Uu: set @ ( old_node @ A @ B )] : ( old_usum @ A @ B @ B2 @ D2 ) ) ) ) ) ).

% dsum_subset_Sigma
thf(fact_6003_dsum__Sigma,axiom,
    ! [B: $tType,A: $tType,A3: set @ ( set @ ( old_node @ A @ B ) ),B2: set @ ( set @ ( old_node @ A @ B ) ),C3: set @ ( set @ ( old_node @ A @ B ) ),D2: set @ ( set @ ( old_node @ A @ B ) )] :
      ( ord_less_eq @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
      @ ( old_dsum @ A @ B
        @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ A3
          @ ^ [Uu: set @ ( old_node @ A @ B )] : B2 )
        @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ C3
          @ ^ [Uu: set @ ( old_node @ A @ B )] : D2 ) )
      @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_usum @ A @ B @ A3 @ C3 )
        @ ^ [Uu: set @ ( old_node @ A @ B )] : ( old_usum @ A @ B @ B2 @ D2 ) ) ) ).

% dsum_Sigma
thf(fact_6004_dprod__Sigma,axiom,
    ! [B: $tType,A: $tType,A3: set @ ( set @ ( old_node @ A @ B ) ),B2: set @ ( set @ ( old_node @ A @ B ) ),C3: set @ ( set @ ( old_node @ A @ B ) ),D2: set @ ( set @ ( old_node @ A @ B ) )] :
      ( ord_less_eq @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
      @ ( old_dprod @ A @ B
        @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ A3
          @ ^ [Uu: set @ ( old_node @ A @ B )] : B2 )
        @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ C3
          @ ^ [Uu: set @ ( old_node @ A @ B )] : D2 ) )
      @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_uprod @ A @ B @ A3 @ C3 )
        @ ^ [Uu: set @ ( old_node @ A @ B )] : ( old_uprod @ A @ B @ B2 @ D2 ) ) ) ).

% dprod_Sigma
thf(fact_6005_dprod__subset__Sigma,axiom,
    ! [B: $tType,A: $tType,R5: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),A3: set @ ( set @ ( old_node @ A @ B ) ),B2: set @ ( set @ ( old_node @ A @ B ) ),S3: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),C3: set @ ( set @ ( old_node @ A @ B ) ),D2: set @ ( set @ ( old_node @ A @ B ) )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) @ R5
        @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ A3
          @ ^ [Uu: set @ ( old_node @ A @ B )] : B2 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) @ S3
          @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ C3
            @ ^ [Uu: set @ ( old_node @ A @ B )] : D2 ) )
       => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) @ ( old_dprod @ A @ B @ R5 @ S3 )
          @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_uprod @ A @ B @ A3 @ C3 )
            @ ^ [Uu: set @ ( old_node @ A @ B )] : ( old_uprod @ A @ B @ B2 @ D2 ) ) ) ) ) ).

% dprod_subset_Sigma
thf(fact_6006_uprod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( old_uprod @ A @ B )
      = ( ^ [A6: set @ ( set @ ( old_node @ A @ B ) ),B5: set @ ( set @ ( old_node @ A @ B ) )] :
            ( complete_Sup_Sup @ ( set @ ( set @ ( old_node @ A @ B ) ) )
            @ ( image2 @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( set @ ( old_node @ A @ B ) ) )
              @ ^ [X2: set @ ( old_node @ A @ B )] :
                  ( complete_Sup_Sup @ ( set @ ( set @ ( old_node @ A @ B ) ) )
                  @ ( image2 @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( set @ ( old_node @ A @ B ) ) )
                    @ ^ [Y2: set @ ( old_node @ A @ B )] : ( insert @ ( set @ ( old_node @ A @ B ) ) @ ( old_Scons @ A @ B @ X2 @ Y2 ) @ ( bot_bot @ ( set @ ( set @ ( old_node @ A @ B ) ) ) ) )
                    @ B5 ) )
              @ A6 ) ) ) ) ).

% uprod_def
thf(fact_6007_dprod__subset__Sigma2,axiom,
    ! [B: $tType,A: $tType,A3: set @ ( set @ ( old_node @ A @ B ) ),B2: ( set @ ( old_node @ A @ B ) ) > ( set @ ( set @ ( old_node @ A @ B ) ) ),C3: set @ ( set @ ( old_node @ A @ B ) ),D2: ( set @ ( old_node @ A @ B ) ) > ( set @ ( set @ ( old_node @ A @ B ) ) )] :
      ( ord_less_eq @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) @ ( old_dprod @ A @ B @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ A3 @ B2 ) @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ C3 @ D2 ) )
      @ ( product_Sigma @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_uprod @ A @ B @ A3 @ C3 )
        @ ( old_Split @ A @ B @ ( set @ ( set @ ( old_node @ A @ B ) ) )
          @ ^ [X2: set @ ( old_node @ A @ B ),Y2: set @ ( old_node @ A @ B )] : ( old_uprod @ A @ B @ ( B2 @ X2 ) @ ( D2 @ Y2 ) ) ) ) ) ).

% dprod_subset_Sigma2
thf(fact_6008_relH__def,axiom,
    ( relH
    = ( ^ [As7: set @ nat,H: heap_ext @ product_unit,H7: heap_ext @ product_unit] :
          ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As7 ) )
          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As7 ) )
          & ! [T5: typerep,X2: nat] :
              ( ( member @ nat @ X2 @ As7 )
             => ( ( ( refs @ product_unit @ H @ T5 @ X2 )
                  = ( refs @ product_unit @ H7 @ T5 @ X2 ) )
                & ( ( arrays @ product_unit @ H @ T5 @ X2 )
                  = ( arrays @ product_unit @ H7 @ T5 @ X2 ) ) ) ) ) ) ) ).

% relH_def
thf(fact_6009_int__decode__def,axiom,
    ( nat_int_decode
    = ( ^ [N5: nat] :
          ( sum_case_sum @ nat @ int @ nat @ ( semiring_1_of_nat @ int )
          @ ^ [B4: nat] : ( minus_minus @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ B4 ) ) @ ( one_one @ int ) )
          @ ( nat_sum_decode @ N5 ) ) ) ) ).

% int_decode_def
thf(fact_6010_nat__to__rat__surj__def,axiom,
    ( nat_to_rat_surj
    = ( ^ [N5: nat] :
          ( product_case_prod @ nat @ nat @ rat
          @ ^ [A5: nat,B4: nat] : ( fract @ ( nat_int_decode @ A5 ) @ ( nat_int_decode @ B4 ) )
          @ ( nat_prod_decode @ N5 ) ) ) ) ).

% nat_to_rat_surj_def
thf(fact_6011_accp__eq__acc,axiom,
    ! [A: $tType] :
      ( ( accp @ A )
      = ( ^ [R3: A > A > $o,X2: A] : ( member @ A @ X2 @ ( acc @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R3 ) ) ) ) ) ) ).

% accp_eq_acc
thf(fact_6012_acc__def,axiom,
    ! [A: $tType] :
      ( ( acc @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ A
            @ ( accp @ A
              @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 ) ) ) ) ) ).

% acc_def
thf(fact_6013_accp__acc__eq,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( accp @ A
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) )
      = ( ^ [X2: A] : ( member @ A @ X2 @ ( acc @ A @ R5 ) ) ) ) ).

% accp_acc_eq
thf(fact_6014_in__range_Opelims_I1_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( in_range @ X3 )
        = Y )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ X3 )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( X3
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( Y
                  = ( ! [X2: nat] :
                        ( ( member @ nat @ X2 @ As )
                       => ( ord_less @ nat @ X2 @ ( lim @ product_unit @ H4 ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ) ) ).

% in_range.pelims(1)
thf(fact_6015_in__range_Opelims_I2_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( in_range @ X3 )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ X3 )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( X3
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
               => ~ ! [X4: nat] :
                      ( ( member @ nat @ X4 @ As )
                     => ( ord_less @ nat @ X4 @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ) ).

% in_range.pelims(2)
thf(fact_6016_in__range_Opelims_I3_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( in_range @ X3 )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ X3 )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( X3
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
               => ! [X: nat] :
                    ( ( member @ nat @ X @ As )
                   => ( ord_less @ nat @ X @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ) ).

% in_range.pelims(3)
thf(fact_6017_one__assn__raw_Opelims_I3_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( one_assn_raw @ X3 )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ X3 )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( X3
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
               => ( As
                  = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% one_assn_raw.pelims(3)
thf(fact_6018_one__assn__raw_Opelims_I2_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( one_assn_raw @ X3 )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ X3 )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( X3
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
               => ( As
                 != ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% one_assn_raw.pelims(2)
thf(fact_6019_one__assn__raw_Opelims_I1_J,axiom,
    ! [X3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( one_assn_raw @ X3 )
        = Y )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ X3 )
       => ~ ! [H4: heap_ext @ product_unit,As: set @ nat] :
              ( ( X3
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
             => ( ( Y
                  = ( As
                    = ( bot_bot @ ( set @ nat ) ) ) )
               => ~ ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ) ) ).

% one_assn_raw.pelims(1)
thf(fact_6020_to__nat__def,axiom,
    ! [A: $tType] :
      ( ( countable @ A )
     => ( ( to_nat @ A )
        = ( fChoice @ ( A > nat )
          @ ^ [F3: A > nat] : ( inj_on @ A @ nat @ F3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% to_nat_def
thf(fact_6021_fixp__induct,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [P: A > $o,F2: A > A] :
          ( ( comple1908693960933563346ssible @ A @ ( complete_Sup_Sup @ A ) @ ( ord_less_eq @ A ) @ P )
         => ( ( comple7038119648293358887notone @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less_eq @ A ) @ F2 )
           => ( ( P @ ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) ) )
             => ( ! [X: A] :
                    ( ( P @ X )
                   => ( P @ ( F2 @ X ) ) )
               => ( P @ ( comple115746919287870866o_fixp @ A @ F2 ) ) ) ) ) ) ) ).

% fixp_induct
thf(fact_6022_let__mono,axiom,
    ! [A: $tType,C: $tType,B: $tType,Orda: B > B > $o,Ordb: C > C > $o,B3: B > A > C,T3: A] :
      ( ! [X: A] :
          ( comple7038119648293358887notone @ B @ C @ Orda @ Ordb
          @ ^ [F3: B] : ( B3 @ F3 @ X ) )
     => ( comple7038119648293358887notone @ B @ C @ Orda @ Ordb
        @ ^ [F3: B] : ( B3 @ F3 @ T3 ) ) ) ).

% let_mono
thf(fact_6023_if__mono,axiom,
    ! [B: $tType,A: $tType,Orda: A > A > $o,Ordb: B > B > $o,F: A > B,G4: A > B,C2: $o] :
      ( ( comple7038119648293358887notone @ A @ B @ Orda @ Ordb @ F )
     => ( ( comple7038119648293358887notone @ A @ B @ Orda @ Ordb @ G4 )
       => ( comple7038119648293358887notone @ A @ B @ Orda @ Ordb
          @ ^ [F3: A] : ( if @ B @ C2 @ ( F @ F3 ) @ ( G4 @ F3 ) ) ) ) ) ).

% if_mono
thf(fact_6024_Array__Time_Oset__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_set @ A )
        = ( ^ [A5: array @ A,X2: list @ A] :
              ( arrays_update @ product_unit
              @ ^ [H: typerep > nat > ( list @ nat )] : ( fun_upd @ typerep @ ( nat > ( list @ nat ) ) @ H @ ( typerep_typerep @ A @ ( type2 @ A ) ) @ ( fun_upd @ nat @ ( list @ nat ) @ ( H @ ( typerep_typerep @ A @ ( type2 @ A ) ) ) @ ( addr_of_array @ A @ A5 ) @ ( map @ A @ nat @ ( to_nat @ A ) @ X2 ) ) ) ) ) ) ) ).

% Array_Time.set_def
thf(fact_6025_Ref__Time_Oset__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_set @ A )
        = ( ^ [R3: ref @ A,X2: A] :
              ( refs_update @ product_unit
              @ ^ [H: typerep > nat > nat] : ( fun_upd @ typerep @ ( nat > nat ) @ H @ ( typerep_typerep @ A @ ( type2 @ A ) ) @ ( fun_upd @ nat @ nat @ ( H @ ( typerep_typerep @ A @ ( type2 @ A ) ) ) @ ( addr_of_ref @ A @ R3 ) @ ( to_nat @ A @ X2 ) ) ) ) ) ) ) ).

% Ref_Time.set_def
thf(fact_6026_tailrec_Oconst__mono,axiom,
    ! [A: $tType,B: $tType,Ord: B > B > $o,C2: A] :
      ( comple7038119648293358887notone @ B @ A @ Ord @ ( partial_flat_ord @ A @ ( undefined @ A ) )
      @ ^ [F3: B] : C2 ) ).

% tailrec.const_mono
thf(fact_6027_dir__image__def,axiom,
    ! [A2: $tType,A: $tType] :
      ( ( bNF_We2720479622203943262_image @ A @ A2 )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),F3: A > A2] :
            ( collect @ ( product_prod @ A2 @ A2 )
            @ ^ [Uu: product_prod @ A2 @ A2] :
              ? [A5: A,B4: A] :
                ( ( Uu
                  = ( product_Pair @ A2 @ A2 @ ( F3 @ A5 ) @ ( F3 @ B4 ) ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R3 ) ) ) ) ) ).

% dir_image_def
thf(fact_6028_option_Oconst__mono,axiom,
    ! [A: $tType,B: $tType,Ord: B > B > $o,C2: option @ A] :
      ( comple7038119648293358887notone @ B @ ( option @ A ) @ Ord @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) )
      @ ^ [F3: B] : C2 ) ).

% option.const_mono
thf(fact_6029_heap__step__admissible,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: E > A > C > B > D > $o,X3: E] :
      ( comple1908693960933563346ssible @ ( A > ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) ) @ ( partial_fun_lub @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ A @ ( partial_flat_lub @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ ( none @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) ) ) @ ( partial_fun_ord @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ A @ ( partial_flat_ord @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ ( none @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) ) )
      @ ^ [F3: A > ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
        ! [H: A,H7: C,R3: B,N5: D] :
          ( ( ( F3 @ H )
            = ( some @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ R3 @ ( product_Pair @ C @ D @ H7 @ N5 ) ) ) )
         => ( P @ X3 @ H @ H7 @ R3 @ N5 ) ) ) ).

% heap_step_admissible
thf(fact_6030_map__mmupd__empty,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),V: B] :
      ( ( map_mmupd @ A @ B @ M2 @ ( bot_bot @ ( set @ A ) ) @ V )
      = M2 ) ).

% map_mmupd_empty
thf(fact_6031_option__admissible,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o] :
      ( comple1908693960933563346ssible @ ( A > ( option @ B ) ) @ ( partial_fun_lub @ ( option @ B ) @ ( option @ B ) @ A @ ( partial_flat_lub @ ( option @ B ) @ ( none @ B ) ) ) @ ( partial_fun_ord @ ( option @ B ) @ ( option @ B ) @ A @ ( partial_flat_ord @ ( option @ B ) @ ( none @ B ) ) )
      @ ^ [F3: A > ( option @ B )] :
        ! [X2: A,Y2: B] :
          ( ( ( F3 @ X2 )
            = ( some @ B @ Y2 ) )
         => ( P @ X2 @ Y2 ) ) ) ).

% option_admissible
thf(fact_6032_call__mono,axiom,
    ! [B: $tType,A: $tType,Ord: B > B > $o,T3: A] :
      ( comple7038119648293358887notone @ ( A > B ) @ B @ ( partial_fun_ord @ B @ B @ A @ Ord ) @ Ord
      @ ^ [F3: A > B] : ( F3 @ T3 ) ) ).

% call_mono
thf(fact_6033_fun__lub__def,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( partial_fun_lub @ C @ B @ A )
      = ( ^ [L6: ( set @ C ) > B,A6: set @ ( A > C ),X2: A] :
            ( L6
            @ ( collect @ C
              @ ^ [Y2: C] :
                ? [Z3: A > C] :
                  ( ( member @ ( A > C ) @ Z3 @ A6 )
                  & ( Y2
                    = ( Z3 @ X2 ) ) ) ) ) ) ) ).

% fun_lub_def
thf(fact_6034_chain__fun,axiom,
    ! [A: $tType,B: $tType,Ord: B > B > $o,A3: set @ ( A > B ),A4: A] :
      ( ( comple1602240252501008431_chain @ ( A > B ) @ ( partial_fun_ord @ B @ B @ A @ Ord ) @ A3 )
     => ( comple1602240252501008431_chain @ B @ Ord
        @ ( collect @ B
          @ ^ [Y2: B] :
            ? [X2: A > B] :
              ( ( member @ ( A > B ) @ X2 @ A3 )
              & ( Y2
                = ( X2 @ A4 ) ) ) ) ) ) ).

% chain_fun
thf(fact_6035_tailrec__admissible,axiom,
    ! [B: $tType,A: $tType,C2: B,P: A > B > $o] :
      ( comple1908693960933563346ssible @ ( A > B ) @ ( partial_fun_lub @ B @ B @ A @ ( partial_flat_lub @ B @ C2 ) ) @ ( partial_fun_ord @ B @ B @ A @ ( partial_flat_ord @ B @ C2 ) )
      @ ^ [A5: A > B] :
        ! [X2: A] :
          ( ( ( A5 @ X2 )
           != C2 )
         => ( P @ X2 @ ( A5 @ X2 ) ) ) ) ).

% tailrec_admissible
thf(fact_6036_tailrec_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U3: C > B > A,F: C > C,C3: ( B > A ) > C,F2: C,P: ( B > A ) > $o] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > A ) @ A @ ( partial_fun_ord @ A @ A @ B @ ( partial_flat_ord @ A @ ( undefined @ A ) ) ) @ ( partial_flat_ord @ A @ ( undefined @ A ) )
          @ ^ [F3: B > A] : ( U3 @ ( F @ ( C3 @ F3 ) ) @ X ) )
     => ( ( F2
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ ( partial_flat_lub @ A @ ( undefined @ A ) ) ) @ ( partial_fun_ord @ A @ A @ B @ ( partial_flat_ord @ A @ ( undefined @ A ) ) )
              @ ^ [F3: B > A] : ( U3 @ ( F @ ( C3 @ F3 ) ) ) ) ) )
       => ( ! [F9: B > A] :
              ( ( U3 @ ( C3 @ F9 ) )
              = F9 )
         => ( ( comple1908693960933563346ssible @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ ( partial_flat_lub @ A @ ( undefined @ A ) ) ) @ ( partial_fun_ord @ A @ A @ B @ ( partial_flat_ord @ A @ ( undefined @ A ) ) ) @ P )
           => ( ( P
                @ ^ [Uu: B] : ( undefined @ A ) )
             => ( ! [F9: C] :
                    ( ( P @ ( U3 @ F9 ) )
                   => ( P @ ( U3 @ ( F @ F9 ) ) ) )
               => ( P @ ( U3 @ F2 ) ) ) ) ) ) ) ) ).

% tailrec.fixp_induct_uc
thf(fact_6037_option_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U3: C > B > ( option @ A ),F: C > C,C3: ( B > ( option @ A ) ) > C,F2: C,P: ( B > ( option @ A ) ) > $o] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > ( option @ A ) ) @ ( option @ A ) @ ( partial_fun_ord @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) ) ) @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) )
          @ ^ [F3: B > ( option @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) @ X ) )
     => ( ( F2
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > ( option @ A ) ) @ ( partial_fun_lub @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_lub @ ( option @ A ) @ ( none @ A ) ) ) @ ( partial_fun_ord @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) ) )
              @ ^ [F3: B > ( option @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) ) ) ) )
       => ( ! [F9: B > ( option @ A )] :
              ( ( U3 @ ( C3 @ F9 ) )
              = F9 )
         => ( ( comple1908693960933563346ssible @ ( B > ( option @ A ) ) @ ( partial_fun_lub @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_lub @ ( option @ A ) @ ( none @ A ) ) ) @ ( partial_fun_ord @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) ) ) @ P )
           => ( ( P
                @ ^ [Uu: B] : ( none @ A ) )
             => ( ! [F9: C] :
                    ( ( P @ ( U3 @ F9 ) )
                   => ( P @ ( U3 @ ( F @ F9 ) ) ) )
               => ( P @ ( U3 @ F2 ) ) ) ) ) ) ) ) ).

% option.fixp_induct_uc
thf(fact_6038_fixp__induct__tailrec,axiom,
    ! [C: $tType,B: $tType,A: $tType,C2: A,U3: C > B > A,F: C > C,C3: ( B > A ) > C,F2: C,P: B > A > $o,X3: B,Y: A] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > A ) @ A @ ( partial_fun_ord @ A @ A @ B @ ( partial_flat_ord @ A @ C2 ) ) @ ( partial_flat_ord @ A @ C2 )
          @ ^ [F3: B > A] : ( U3 @ ( F @ ( C3 @ F3 ) ) @ X ) )
     => ( ( F2
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ ( partial_flat_lub @ A @ C2 ) ) @ ( partial_fun_ord @ A @ A @ B @ ( partial_flat_ord @ A @ C2 ) )
              @ ^ [F3: B > A] : ( U3 @ ( F @ ( C3 @ F3 ) ) ) ) ) )
       => ( ! [F9: B > A] :
              ( ( U3 @ ( C3 @ F9 ) )
              = F9 )
         => ( ! [F9: C,X: B,Y3: A] :
                ( ! [Xa3: B,Ya: A] :
                    ( ( ( U3 @ F9 @ Xa3 )
                      = Ya )
                   => ( ( Ya != C2 )
                     => ( P @ Xa3 @ Ya ) ) )
               => ( ( ( U3 @ ( F @ F9 ) @ X )
                    = Y3 )
                 => ( ( Y3 != C2 )
                   => ( P @ X @ Y3 ) ) ) )
           => ( ( ( U3 @ F2 @ X3 )
                = Y )
             => ( ( Y != C2 )
               => ( P @ X3 @ Y ) ) ) ) ) ) ) ).

% fixp_induct_tailrec
thf(fact_6039_option_Omono__body__fixp,axiom,
    ! [A: $tType,B: $tType,F: ( B > ( option @ A ) ) > B > ( option @ A )] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > ( option @ A ) ) @ ( option @ A ) @ ( partial_fun_ord @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) ) ) @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) )
          @ ^ [F3: B > ( option @ A )] : ( F @ F3 @ X ) )
     => ( ( comple187402453842119260l_fixp @ ( B > ( option @ A ) ) @ ( partial_fun_lub @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_lub @ ( option @ A ) @ ( none @ A ) ) ) @ ( partial_fun_ord @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) ) ) @ F )
        = ( F @ ( comple187402453842119260l_fixp @ ( B > ( option @ A ) ) @ ( partial_fun_lub @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_lub @ ( option @ A ) @ ( none @ A ) ) ) @ ( partial_fun_ord @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) ) ) @ F ) ) ) ) ).

% option.mono_body_fixp
thf(fact_6040_option_Ofixp__rule__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U3: C > B > ( option @ A ),F: C > C,C3: ( B > ( option @ A ) ) > C,F2: C] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > ( option @ A ) ) @ ( option @ A ) @ ( partial_fun_ord @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) ) ) @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) )
          @ ^ [F3: B > ( option @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) @ X ) )
     => ( ( F2
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > ( option @ A ) ) @ ( partial_fun_lub @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_lub @ ( option @ A ) @ ( none @ A ) ) ) @ ( partial_fun_ord @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) ) )
              @ ^ [F3: B > ( option @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) ) ) ) )
       => ( ! [F9: C] :
              ( ( C3 @ ( U3 @ F9 ) )
              = F9 )
         => ( F2
            = ( F @ F2 ) ) ) ) ) ).

% option.fixp_rule_uc
thf(fact_6041_tailrec_Omono__body__fixp,axiom,
    ! [A: $tType,B: $tType,F: ( B > A ) > B > A] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > A ) @ A @ ( partial_fun_ord @ A @ A @ B @ ( partial_flat_ord @ A @ ( undefined @ A ) ) ) @ ( partial_flat_ord @ A @ ( undefined @ A ) )
          @ ^ [F3: B > A] : ( F @ F3 @ X ) )
     => ( ( comple187402453842119260l_fixp @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ ( partial_flat_lub @ A @ ( undefined @ A ) ) ) @ ( partial_fun_ord @ A @ A @ B @ ( partial_flat_ord @ A @ ( undefined @ A ) ) ) @ F )
        = ( F @ ( comple187402453842119260l_fixp @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ ( partial_flat_lub @ A @ ( undefined @ A ) ) ) @ ( partial_fun_ord @ A @ A @ B @ ( partial_flat_ord @ A @ ( undefined @ A ) ) ) @ F ) ) ) ) ).

% tailrec.mono_body_fixp
thf(fact_6042_tailrec_Ofixp__rule__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U3: C > B > A,F: C > C,C3: ( B > A ) > C,F2: C] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > A ) @ A @ ( partial_fun_ord @ A @ A @ B @ ( partial_flat_ord @ A @ ( undefined @ A ) ) ) @ ( partial_flat_ord @ A @ ( undefined @ A ) )
          @ ^ [F3: B > A] : ( U3 @ ( F @ ( C3 @ F3 ) ) @ X ) )
     => ( ( F2
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ ( partial_flat_lub @ A @ ( undefined @ A ) ) ) @ ( partial_fun_ord @ A @ A @ B @ ( partial_flat_ord @ A @ ( undefined @ A ) ) )
              @ ^ [F3: B > A] : ( U3 @ ( F @ ( C3 @ F3 ) ) ) ) ) )
       => ( ! [F9: C] :
              ( ( C3 @ ( U3 @ F9 ) )
              = F9 )
         => ( F2
            = ( F @ F2 ) ) ) ) ) ).

% tailrec.fixp_rule_uc
thf(fact_6043_fixp__induct__option,axiom,
    ! [C: $tType,B: $tType,A: $tType,U3: C > B > ( option @ A ),F: C > C,C3: ( B > ( option @ A ) ) > C,F2: C,P: B > A > $o,X3: B,Y: A] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > ( option @ A ) ) @ ( option @ A ) @ ( partial_fun_ord @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) ) ) @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) )
          @ ^ [F3: B > ( option @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) @ X ) )
     => ( ( F2
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > ( option @ A ) ) @ ( partial_fun_lub @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_lub @ ( option @ A ) @ ( none @ A ) ) ) @ ( partial_fun_ord @ ( option @ A ) @ ( option @ A ) @ B @ ( partial_flat_ord @ ( option @ A ) @ ( none @ A ) ) )
              @ ^ [F3: B > ( option @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) ) ) ) )
       => ( ! [F9: B > ( option @ A )] :
              ( ( U3 @ ( C3 @ F9 ) )
              = F9 )
         => ( ! [F9: C,X: B,Y3: A] :
                ( ! [Xa3: B,Ya: A] :
                    ( ( ( U3 @ F9 @ Xa3 )
                      = ( some @ A @ Ya ) )
                   => ( P @ Xa3 @ Ya ) )
               => ( ( ( U3 @ ( F @ F9 ) @ X )
                    = ( some @ A @ Y3 ) )
                 => ( P @ X @ Y3 ) ) )
           => ( ( ( U3 @ F2 @ X3 )
                = ( some @ A @ Y ) )
             => ( P @ X3 @ Y ) ) ) ) ) ) ).

% fixp_induct_option
thf(fact_6044_partial__function__definitions_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Leq: A > A > $o,Lub: ( set @ A ) > A,U3: C > B > A,F: C > C,C3: ( B > A ) > C,F2: C,P: ( B > A ) > $o] :
      ( ( partia7178651479351089652itions @ A @ Leq @ Lub )
     => ( ! [X: B] :
            ( comple7038119648293358887notone @ ( B > A ) @ A @ ( partial_fun_ord @ A @ A @ B @ Leq ) @ Leq
            @ ^ [F3: B > A] : ( U3 @ ( F @ ( C3 @ F3 ) ) @ X ) )
       => ( ( F2
            = ( C3
              @ ( comple187402453842119260l_fixp @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ Lub ) @ ( partial_fun_ord @ A @ A @ B @ Leq )
                @ ^ [F3: B > A] : ( U3 @ ( F @ ( C3 @ F3 ) ) ) ) ) )
         => ( ! [F9: B > A] :
                ( ( U3 @ ( C3 @ F9 ) )
                = F9 )
           => ( ( comple1908693960933563346ssible @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ Lub ) @ ( partial_fun_ord @ A @ A @ B @ Leq ) @ P )
             => ( ( P
                  @ ^ [Uu: B] : ( Lub @ ( bot_bot @ ( set @ A ) ) ) )
               => ( ! [F9: C] :
                      ( ( P @ ( U3 @ F9 ) )
                     => ( P @ ( U3 @ ( F @ F9 ) ) ) )
                 => ( P @ ( U3 @ F2 ) ) ) ) ) ) ) ) ) ).

% partial_function_definitions.fixp_induct_uc
thf(fact_6045_admissible__fun,axiom,
    ! [A: $tType,B: $tType,Le: A > A > $o,Lub: ( set @ A ) > A,Q: B > A > $o] :
      ( ( partia7178651479351089652itions @ A @ Le @ Lub )
     => ( ! [X: B] : ( comple1908693960933563346ssible @ A @ Lub @ Le @ ( Q @ X ) )
       => ( comple1908693960933563346ssible @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ Lub ) @ ( partial_fun_ord @ A @ A @ B @ Le )
          @ ^ [F3: B > A] :
            ! [X2: B] : ( Q @ X2 @ ( F3 @ X2 ) ) ) ) ) ).

% admissible_fun
thf(fact_6046_partial__function__definitions_Oconst__mono,axiom,
    ! [A: $tType,B: $tType,Leq: A > A > $o,Lub: ( set @ A ) > A,Ord: B > B > $o,C2: A] :
      ( ( partia7178651479351089652itions @ A @ Leq @ Lub )
     => ( comple7038119648293358887notone @ B @ A @ Ord @ Leq
        @ ^ [F3: B] : C2 ) ) ).

% partial_function_definitions.const_mono
thf(fact_6047_partial__function__definitions_Ofixp__rule__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Leq: A > A > $o,Lub: ( set @ A ) > A,U3: C > B > A,F: C > C,C3: ( B > A ) > C,F2: C] :
      ( ( partia7178651479351089652itions @ A @ Leq @ Lub )
     => ( ! [X: B] :
            ( comple7038119648293358887notone @ ( B > A ) @ A @ ( partial_fun_ord @ A @ A @ B @ Leq ) @ Leq
            @ ^ [F3: B > A] : ( U3 @ ( F @ ( C3 @ F3 ) ) @ X ) )
       => ( ( F2
            = ( C3
              @ ( comple187402453842119260l_fixp @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ Lub ) @ ( partial_fun_ord @ A @ A @ B @ Leq )
                @ ^ [F3: B > A] : ( U3 @ ( F @ ( C3 @ F3 ) ) ) ) ) )
         => ( ! [F9: C] :
                ( ( C3 @ ( U3 @ F9 ) )
                = F9 )
           => ( F2
              = ( F @ F2 ) ) ) ) ) ) ).

% partial_function_definitions.fixp_rule_uc
thf(fact_6048_partial__function__definitions_Omono__body__fixp,axiom,
    ! [A: $tType,B: $tType,Leq: A > A > $o,Lub: ( set @ A ) > A,F: ( B > A ) > B > A] :
      ( ( partia7178651479351089652itions @ A @ Leq @ Lub )
     => ( ! [X: B] :
            ( comple7038119648293358887notone @ ( B > A ) @ A @ ( partial_fun_ord @ A @ A @ B @ Leq ) @ Leq
            @ ^ [F3: B > A] : ( F @ F3 @ X ) )
       => ( ( comple187402453842119260l_fixp @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ Lub ) @ ( partial_fun_ord @ A @ A @ B @ Leq ) @ F )
          = ( F @ ( comple187402453842119260l_fixp @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ Lub ) @ ( partial_fun_ord @ A @ A @ B @ Leq ) @ F ) ) ) ) ) ).

% partial_function_definitions.mono_body_fixp
thf(fact_6049_Partial__Function_Obind__mono,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,B2: ( A > ( option @ B ) ) > ( option @ C ),C3: C > ( A > ( option @ B ) ) > ( option @ D )] :
      ( ( comple7038119648293358887notone @ ( A > ( option @ B ) ) @ ( option @ C ) @ ( partial_fun_ord @ ( option @ B ) @ ( option @ B ) @ A @ ( partial_flat_ord @ ( option @ B ) @ ( none @ B ) ) ) @ ( partial_flat_ord @ ( option @ C ) @ ( none @ C ) ) @ B2 )
     => ( ! [Y3: C] : ( comple7038119648293358887notone @ ( A > ( option @ B ) ) @ ( option @ D ) @ ( partial_fun_ord @ ( option @ B ) @ ( option @ B ) @ A @ ( partial_flat_ord @ ( option @ B ) @ ( none @ B ) ) ) @ ( partial_flat_ord @ ( option @ D ) @ ( none @ D ) ) @ ( C3 @ Y3 ) )
       => ( comple7038119648293358887notone @ ( A > ( option @ B ) ) @ ( option @ D ) @ ( partial_fun_ord @ ( option @ B ) @ ( option @ B ) @ A @ ( partial_flat_ord @ ( option @ B ) @ ( none @ B ) ) ) @ ( partial_flat_ord @ ( option @ D ) @ ( none @ D ) )
          @ ^ [F3: A > ( option @ B )] :
              ( bind2 @ C @ D @ ( B2 @ F3 )
              @ ^ [Y2: C] : ( C3 @ Y2 @ F3 ) ) ) ) ) ).

% Partial_Function.bind_mono
thf(fact_6050_heap_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U3: C > B > ( heap_Time_Heap @ A ),F: C > C,C3: ( B > ( heap_Time_Heap @ A ) ) > C,F2: C,P: ( B > ( heap_Time_Heap @ A ) ) > $o] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > ( heap_Time_Heap @ A ) ) @ ( heap_Time_Heap @ A ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ ( heap_Time_Heap_ord @ A )
          @ ^ [F3: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) @ X ) )
     => ( ( F2
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) )
              @ ^ [F3: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) ) ) ) )
       => ( ! [F9: B > ( heap_Time_Heap @ A )] :
              ( ( U3 @ ( C3 @ F9 ) )
              = F9 )
         => ( ( comple1908693960933563346ssible @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ P )
           => ( ( P
                @ ^ [Uu: B] :
                    ( heap_Time_Heap2 @ A
                    @ ^ [X2: heap_ext @ product_unit] : ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) )
             => ( ! [F9: C] :
                    ( ( P @ ( U3 @ F9 ) )
                   => ( P @ ( U3 @ ( F @ F9 ) ) ) )
               => ( P @ ( U3 @ F2 ) ) ) ) ) ) ) ) ).

% heap.fixp_induct_uc
thf(fact_6051_bind__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,X3: option @ C,F2: C > ( option @ B ),G: B > ( option @ A )] :
      ( ( bind2 @ B @ A @ ( bind2 @ C @ B @ X3 @ F2 ) @ G )
      = ( bind2 @ C @ A @ X3
        @ ^ [Y2: C] : ( bind2 @ B @ A @ ( F2 @ Y2 ) @ G ) ) ) ).

% bind_assoc
thf(fact_6052_bind__rzero,axiom,
    ! [B: $tType,A: $tType,X3: option @ B] :
      ( ( bind2 @ B @ A @ X3
        @ ^ [X2: B] : ( none @ A ) )
      = ( none @ A ) ) ).

% bind_rzero
thf(fact_6053_heap_Oconst__mono,axiom,
    ! [A: $tType,B: $tType,Ord: B > B > $o,C2: heap_Time_Heap @ A] :
      ( comple7038119648293358887notone @ B @ ( heap_Time_Heap @ A ) @ Ord @ ( heap_Time_Heap_ord @ A )
      @ ^ [F3: B] : C2 ) ).

% heap.const_mono
thf(fact_6054_heap_Omono__body__fixp,axiom,
    ! [A: $tType,B: $tType,F: ( B > ( heap_Time_Heap @ A ) ) > B > ( heap_Time_Heap @ A )] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > ( heap_Time_Heap @ A ) ) @ ( heap_Time_Heap @ A ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ ( heap_Time_Heap_ord @ A )
          @ ^ [F3: B > ( heap_Time_Heap @ A )] : ( F @ F3 @ X ) )
     => ( ( comple187402453842119260l_fixp @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ F )
        = ( F @ ( comple187402453842119260l_fixp @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ F ) ) ) ) ).

% heap.mono_body_fixp
thf(fact_6055_heap_Ofixp__rule__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U3: C > B > ( heap_Time_Heap @ A ),F: C > C,C3: ( B > ( heap_Time_Heap @ A ) ) > C,F2: C] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > ( heap_Time_Heap @ A ) ) @ ( heap_Time_Heap @ A ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ ( heap_Time_Heap_ord @ A )
          @ ^ [F3: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) @ X ) )
     => ( ( F2
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) )
              @ ^ [F3: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) ) ) ) )
       => ( ! [F9: C] :
              ( ( C3 @ ( U3 @ F9 ) )
              = F9 )
         => ( F2
            = ( F @ F2 ) ) ) ) ) ).

% heap.fixp_rule_uc
thf(fact_6056_Heap__Time__Monad_Obind__mono,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,B2: ( A > ( heap_Time_Heap @ B ) ) > ( heap_Time_Heap @ C ),C3: C > ( A > ( heap_Time_Heap @ B ) ) > ( heap_Time_Heap @ D )] :
      ( ( comple7038119648293358887notone @ ( A > ( heap_Time_Heap @ B ) ) @ ( heap_Time_Heap @ C ) @ ( partial_fun_ord @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ B ) @ A @ ( heap_Time_Heap_ord @ B ) ) @ ( heap_Time_Heap_ord @ C ) @ B2 )
     => ( ! [Y3: C] : ( comple7038119648293358887notone @ ( A > ( heap_Time_Heap @ B ) ) @ ( heap_Time_Heap @ D ) @ ( partial_fun_ord @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ B ) @ A @ ( heap_Time_Heap_ord @ B ) ) @ ( heap_Time_Heap_ord @ D ) @ ( C3 @ Y3 ) )
       => ( comple7038119648293358887notone @ ( A > ( heap_Time_Heap @ B ) ) @ ( heap_Time_Heap @ D ) @ ( partial_fun_ord @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ B ) @ A @ ( heap_Time_Heap_ord @ B ) ) @ ( heap_Time_Heap_ord @ D )
          @ ^ [F3: A > ( heap_Time_Heap @ B )] :
              ( heap_Time_bind @ C @ D @ ( B2 @ F3 )
              @ ^ [Y2: C] : ( C3 @ Y2 @ F3 ) ) ) ) ) ).

% Heap_Time_Monad.bind_mono
thf(fact_6057_fixp__induct__heap,axiom,
    ! [C: $tType,A: $tType,B: $tType,U3: C > B > ( heap_Time_Heap @ A ),F: C > C,C3: ( B > ( heap_Time_Heap @ A ) ) > C,F2: C,P: B > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) > A > nat > $o,X3: B,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R5: A,N: nat] :
      ( ! [X: B] :
          ( comple7038119648293358887notone @ ( B > ( heap_Time_Heap @ A ) ) @ ( heap_Time_Heap @ A ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ ( heap_Time_Heap_ord @ A )
          @ ^ [F3: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) @ X ) )
     => ( ( F2
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) )
              @ ^ [F3: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F @ ( C3 @ F3 ) ) ) ) ) )
       => ( ! [F9: B > ( heap_Time_Heap @ A )] :
              ( ( U3 @ ( C3 @ F9 ) )
              = F9 )
         => ( ! [F9: C,X: B,H4: heap_ext @ product_unit,H3: heap_ext @ product_unit,R4: A,N2: nat] :
                ( ! [Xa3: B,Ha: heap_ext @ product_unit,H_a: heap_ext @ product_unit,Ra3: A,Na: nat] :
                    ( ( heap_Time_effect @ A @ ( U3 @ F9 @ Xa3 ) @ Ha @ H_a @ Ra3 @ Na )
                   => ( P @ Xa3 @ Ha @ H_a @ Ra3 @ Na ) )
               => ( ( heap_Time_effect @ A @ ( U3 @ ( F @ F9 ) @ X ) @ H4 @ H3 @ R4 @ N2 )
                 => ( P @ X @ H4 @ H3 @ R4 @ N2 ) ) )
           => ( ( heap_Time_effect @ A @ ( U3 @ F2 @ X3 ) @ H2 @ H5 @ R5 @ N )
             => ( P @ X3 @ H2 @ H5 @ R5 @ N ) ) ) ) ) ) ).

% fixp_induct_heap
thf(fact_6058_admissible__heap,axiom,
    ! [B: $tType,A: $tType,P: A > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) > B > nat > $o] :
      ( comple1908693960933563346ssible @ ( A > ( heap_Time_Heap @ B ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ B ) @ A @ ( heap_Time_Heap_lub @ B ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ B ) @ A @ ( heap_Time_Heap_ord @ B ) )
      @ ^ [F3: A > ( heap_Time_Heap @ B )] :
        ! [X2: A,H: heap_ext @ product_unit,H7: heap_ext @ product_unit,R3: B,N5: nat] :
          ( ( heap_Time_effect @ B @ ( F3 @ X2 ) @ H @ H7 @ R3 @ N5 )
         => ( P @ X2 @ H @ H7 @ R3 @ N5 ) ) ) ).

% admissible_heap
thf(fact_6059_sum__set__upto__conv__sum__list__int,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: int > A,I3: int,J2: int] :
          ( ( groups7311177749621191930dd_sum @ int @ A @ F2 @ ( set2 @ int @ ( upto @ I3 @ J2 ) ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ int @ A @ F2 @ ( upto @ I3 @ J2 ) ) ) ) ) ).

% sum_set_upto_conv_sum_list_int
thf(fact_6060_interv__sum__list__conv__sum__set__int,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [F2: int > B,K: int,L: int] :
          ( ( groups8242544230860333062m_list @ B @ ( map @ int @ B @ F2 @ ( upto @ K @ L ) ) )
          = ( groups7311177749621191930dd_sum @ int @ B @ F2 @ ( set2 @ int @ ( upto @ K @ L ) ) ) ) ) ).

% interv_sum_list_conv_sum_set_int
thf(fact_6061_sort__upto,axiom,
    ! [I3: int,J2: int] :
      ( ( linorder_sort_key @ int @ int
        @ ^ [X2: int] : X2
        @ ( upto @ I3 @ J2 ) )
      = ( upto @ I3 @ J2 ) ) ).

% sort_upto
thf(fact_6062_card_Ofolding__axioms,axiom,
    ! [A: $tType] :
      ( finite_folding @ A @ nat
      @ ^ [Uu: A] : suc ) ).

% card.folding_axioms
thf(fact_6063_sum_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( sum_isl @ A @ B )
      = ( sum_case_sum @ A @ $o @ B
        @ ^ [Uu: A] : $true
        @ ^ [Uu: B] : $false ) ) ).

% sum.disc_eq_case(1)
thf(fact_6064_sum_Odisc__eq__case_I2_J,axiom,
    ! [B: $tType,A: $tType,Sum: sum_sum @ A @ B] :
      ( ( ~ ( sum_isl @ A @ B @ Sum ) )
      = ( sum_case_sum @ A @ $o @ B
        @ ^ [Uu: A] : $false
        @ ^ [Uu: B] : $true
        @ Sum ) ) ).

% sum.disc_eq_case(2)
thf(fact_6065_scomp__fcomp,axiom,
    ! [A: $tType,C: $tType,B: $tType,E: $tType,D: $tType,F2: A > ( product_prod @ D @ E ),G: D > E > C,H2: C > B] :
      ( ( fcomp @ A @ C @ B @ ( product_scomp @ A @ D @ E @ C @ F2 @ G ) @ H2 )
      = ( product_scomp @ A @ D @ E @ B @ F2
        @ ^ [X2: D] : ( fcomp @ E @ C @ B @ ( G @ X2 ) @ H2 ) ) ) ).

% scomp_fcomp
thf(fact_6066_bot__in__iterates,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [F2: A > A] : ( member @ A @ ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) ) @ ( comple6359979572994053840erates @ A @ F2 ) ) ) ).

% bot_in_iterates
thf(fact_6067_iterates__def,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ( ( comple6359979572994053840erates @ A )
        = ( ^ [F3: A > A] : ( collect @ A @ ( comple7512665784863727008ratesp @ A @ F3 ) ) ) ) ) ).

% iterates_def
thf(fact_6068_sym__Int__converse,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] : ( sym @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ ( converse @ A @ A @ R5 ) ) ) ).

% sym_Int_converse
thf(fact_6069_Heap_Oempty__def,axiom,
    ( empty
    = ( heap_ext2 @ product_unit
      @ ^ [Uu: typerep,Uv: nat] : ( nil @ nat )
      @ ^ [Uu: typerep,Uv: nat] : ( zero_zero @ nat )
      @ ( zero_zero @ nat )
      @ product_Unity ) ) ).

% Heap.empty_def
thf(fact_6070_sym__Int,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( sym @ A @ R5 )
     => ( ( sym @ A @ S3 )
       => ( sym @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ S3 ) ) ) ) ).

% sym_Int
thf(fact_6071_array_Oset,axiom,
    ! [A: $tType,X3: nat] :
      ( ( set_array @ A @ ( array2 @ A @ X3 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% array.set
thf(fact_6072_ref_Oset,axiom,
    ! [A: $tType,X3: nat] :
      ( ( set_ref @ A @ ( ref2 @ A @ X3 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% ref.set
thf(fact_6073_Quotient3__to__Quotient__equivp,axiom,
    ! [B: $tType,A: $tType,R: A > A > $o,Abs: A > B,Rep: B > A,T2: A > B > $o] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( T2
          = ( ^ [X2: A] :
                ( ^ [Y5: B,Z5: B] : ( Y5 = Z5 )
                @ ( Abs @ X2 ) ) ) )
       => ( ( equiv_equivp @ A @ R )
         => ( quotient @ A @ B @ R @ Abs @ Rep @ T2 ) ) ) ) ).

% Quotient3_to_Quotient_equivp
thf(fact_6074_quot__type_Osome__collect,axiom,
    ! [B: $tType,A: $tType,R: A > A > $o,Abs: ( set @ A ) > B,Rep: B > ( set @ A ),R5: A] :
      ( ( quot_type @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R5 @ R5 )
       => ( ( R
            @ ( fChoice @ A
              @ ^ [X2: A] : ( member @ A @ X2 @ ( collect @ A @ ( R @ R5 ) ) ) ) )
          = ( R @ R5 ) ) ) ) ).

% quot_type.some_collect
thf(fact_6075_lambda__prs1,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: A > A > $o,Abs1: A > B,Rep1: B > A,R22: C > C > $o,Abs22: C > D,Rep22: D > C,F2: B > D] :
      ( ( quotient3 @ A @ B @ R1 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ C @ D @ R22 @ Abs22 @ Rep22 )
       => ( ( map_fun @ B @ A @ C @ D @ Rep1 @ Abs22 @ ( map_fun @ A @ B @ D @ C @ Abs1 @ Rep22 @ F2 ) )
          = F2 ) ) ) ).

% lambda_prs1
thf(fact_6076_lambda__prs,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: A > A > $o,Abs1: A > B,Rep1: B > A,R22: C > C > $o,Abs22: C > D,Rep22: D > C,F2: B > D] :
      ( ( quotient3 @ A @ B @ R1 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ C @ D @ R22 @ Abs22 @ Rep22 )
       => ( ( map_fun @ B @ A @ C @ D @ Rep1 @ Abs22
            @ ^ [X2: A] : ( Rep22 @ ( F2 @ ( Abs1 @ X2 ) ) ) )
          = F2 ) ) ) ).

% lambda_prs
thf(fact_6077_Quotient3__to__Quotient,axiom,
    ! [B: $tType,A: $tType,R: A > A > $o,Abs: A > B,Rep: B > A,T2: A > B > $o] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( T2
          = ( ^ [X2: A,Y2: B] :
                ( ( R @ X2 @ X2 )
                & ( ( Abs @ X2 )
                  = Y2 ) ) ) )
       => ( quotient @ A @ B @ R @ Abs @ Rep @ T2 ) ) ) ).

% Quotient3_to_Quotient
thf(fact_6078_quot__type_Orep__def,axiom,
    ! [B: $tType,A: $tType,R: A > A > $o,Abs: ( set @ A ) > B,Rep: B > ( set @ A ),A4: B] :
      ( ( quot_type @ A @ B @ R @ Abs @ Rep )
     => ( ( quot_rep @ B @ A @ Rep @ A4 )
        = ( fChoice @ A
          @ ^ [X2: A] : ( member @ A @ X2 @ ( Rep @ A4 ) ) ) ) ) ).

% quot_type.rep_def
thf(fact_6079_toCard__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Greatest_toCard @ A @ B )
      = ( ^ [A6: set @ A,R3: set @ ( product_prod @ B @ B )] : ( fChoice @ ( A > B ) @ ( bNF_Gr1419584066657907630d_pred @ A @ B @ A6 @ R3 ) ) ) ) ).

% toCard_def
thf(fact_6080_fromCard__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Gr5436034075474128252omCard @ A @ B )
      = ( ^ [A6: set @ A,R3: set @ ( product_prod @ B @ B ),K6: B] :
            ( fChoice @ A
            @ ^ [B4: A] :
                ( ( member @ A @ B4 @ A6 )
                & ( ( bNF_Greatest_toCard @ A @ B @ A6 @ R3 @ B4 )
                  = K6 ) ) ) ) ) ).

% fromCard_def
thf(fact_6081_symp__sym__eq,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( symp @ A
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) )
      = ( sym @ A @ R5 ) ) ).

% symp_sym_eq
thf(fact_6082_symp__inf,axiom,
    ! [A: $tType,R5: A > A > $o,S3: A > A > $o] :
      ( ( symp @ A @ R5 )
     => ( ( symp @ A @ S3 )
       => ( symp @ A @ ( inf_inf @ ( A > A > $o ) @ R5 @ S3 ) ) ) ) ).

% symp_inf
thf(fact_6083_select__def,axiom,
    ! [A: $tType] :
      ( ( select @ A )
      = ( ^ [Xs2: list @ A] :
            ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ A @ ( product_prod @ code_natural @ code_natural ) ) @ ( range @ ( code_natural_of_nat @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
            @ ^ [K6: code_natural] : ( product_Pair @ A @ ( product_prod @ code_natural @ code_natural ) @ ( nth @ A @ Xs2 @ ( code_nat_of_natural @ K6 ) ) ) ) ) ) ).

% select_def
thf(fact_6084_subset__mset_Oarg__max__def,axiom,
    ! [A: $tType,B: $tType,F2: B > ( multiset @ A ),P: B > $o] :
      ( ( lattices_arg_max @ ( multiset @ A ) @ B @ ( subset_mset @ A ) @ F2 @ P )
      = ( fChoice @ B @ ( lattices_is_arg_max @ ( multiset @ A ) @ B @ ( subset_mset @ A ) @ F2 @ P ) ) ) ).

% subset_mset.arg_max_def
thf(fact_6085_ord_Oarg__max__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( lattices_arg_max @ A @ B )
      = ( ^ [Less2: A > A > $o,F3: B > A,P3: B > $o] : ( fChoice @ B @ ( lattices_is_arg_max @ A @ B @ Less2 @ F3 @ P3 ) ) ) ) ).

% ord.arg_max_def
thf(fact_6086_subset__mset_Oarg__max__on__def,axiom,
    ! [A: $tType,B: $tType,F2: B > ( multiset @ A ),S2: set @ B] :
      ( ( lattices_arg_max_on @ ( multiset @ A ) @ B @ ( subset_mset @ A ) @ F2 @ S2 )
      = ( lattices_arg_max @ ( multiset @ A ) @ B @ ( subset_mset @ A ) @ F2
        @ ^ [X2: B] : ( member @ B @ X2 @ S2 ) ) ) ).

% subset_mset.arg_max_on_def
thf(fact_6087_ord_Oarg__max__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( lattices_arg_max_on @ A @ B )
      = ( ^ [Less2: A > A > $o,F3: B > A,S7: set @ B] :
            ( lattices_arg_max @ A @ B @ Less2 @ F3
            @ ^ [X2: B] : ( member @ B @ X2 @ S7 ) ) ) ) ).

% ord.arg_max_on_def
thf(fact_6088_cr__natural__def,axiom,
    ( code_cr_natural
    = ( ^ [X2: nat,Y2: code_natural] :
          ( X2
          = ( code_nat_of_natural @ Y2 ) ) ) ) ).

% cr_natural_def
thf(fact_6089_subset__mset_Oarg__min__def,axiom,
    ! [A: $tType,B: $tType,F2: B > ( multiset @ A ),P: B > $o] :
      ( ( lattices_arg_min @ ( multiset @ A ) @ B @ ( subset_mset @ A ) @ F2 @ P )
      = ( fChoice @ B @ ( lattices_is_arg_min @ ( multiset @ A ) @ B @ ( subset_mset @ A ) @ F2 @ P ) ) ) ).

% subset_mset.arg_min_def
thf(fact_6090_ord_Oarg__min__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( lattices_arg_min @ A @ B )
      = ( ^ [Less2: A > A > $o,F3: B > A,P3: B > $o] : ( fChoice @ B @ ( lattices_is_arg_min @ A @ B @ Less2 @ F3 @ P3 ) ) ) ) ).

% ord.arg_min_def
thf(fact_6091_subset__mset_Oarg__min__on__def,axiom,
    ! [A: $tType,B: $tType,F2: B > ( multiset @ A ),S2: set @ B] :
      ( ( lattices_arg_min_on @ ( multiset @ A ) @ B @ ( subset_mset @ A ) @ F2 @ S2 )
      = ( lattices_arg_min @ ( multiset @ A ) @ B @ ( subset_mset @ A ) @ F2
        @ ^ [X2: B] : ( member @ B @ X2 @ S2 ) ) ) ).

% subset_mset.arg_min_on_def
thf(fact_6092_ord_Oarg__min__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( lattices_arg_min_on @ A @ B )
      = ( ^ [Less2: A > A > $o,F3: B > A,S7: set @ B] :
            ( lattices_arg_min @ A @ B @ Less2 @ F3
            @ ^ [X2: B] : ( member @ B @ X2 @ S7 ) ) ) ) ).

% ord.arg_min_on_def
thf(fact_6093_Nitpick_OEx1__unfold,axiom,
    ! [A: $tType] :
      ( ( ex1 @ A )
      = ( ^ [P3: A > $o] :
          ? [X2: A] :
            ( ( collect @ A @ P3 )
            = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Nitpick.Ex1_unfold
thf(fact_6094_transp__trans,axiom,
    ! [A: $tType] :
      ( ( transp @ A )
      = ( ^ [R3: A > A > $o] : ( trans @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R3 ) ) ) ) ) ).

% transp_trans
thf(fact_6095_transp__ge,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% transp_ge
thf(fact_6096_transp__inf,axiom,
    ! [A: $tType,R5: A > A > $o,S3: A > A > $o] :
      ( ( transp @ A @ R5 )
     => ( ( transp @ A @ S3 )
       => ( transp @ A @ ( inf_inf @ ( A > A > $o ) @ R5 @ S3 ) ) ) ) ).

% transp_inf
thf(fact_6097_transp__empty,axiom,
    ! [A: $tType] :
      ( transp @ A
      @ ^ [X2: A,Y2: A] : $false ) ).

% transp_empty
thf(fact_6098_transp__singleton,axiom,
    ! [A: $tType,A4: A] :
      ( transp @ A
      @ ^ [X2: A,Y2: A] :
          ( ( X2 = A4 )
          & ( Y2 = A4 ) ) ) ).

% transp_singleton
thf(fact_6099_subset__mset_Otransp__ge,axiom,
    ! [A: $tType] :
      ( transp @ ( multiset @ A )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subseteq_mset @ A @ Y2 @ X2 ) ) ).

% subset_mset.transp_ge
thf(fact_6100_subset__mset_Otransp__gr,axiom,
    ! [A: $tType] :
      ( transp @ ( multiset @ A )
      @ ^ [X2: multiset @ A,Y2: multiset @ A] : ( subset_mset @ A @ Y2 @ X2 ) ) ).

% subset_mset.transp_gr
thf(fact_6101_transp__gr,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% transp_gr
thf(fact_6102_transp__trans__eq,axiom,
    ! [A: $tType,R5: set @ ( product_prod @ A @ A )] :
      ( ( transp @ A
        @ ^ [X2: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R5 ) )
      = ( trans @ A @ R5 ) ) ).

% transp_trans_eq
thf(fact_6103_irreflp__multp,axiom,
    ! [A: $tType,R5: A > A > $o] :
      ( ( transp @ A @ R5 )
     => ( ( irreflp @ A @ R5 )
       => ( irreflp @ ( multiset @ A ) @ ( multp @ A @ R5 ) ) ) ) ).

% irreflp_multp
thf(fact_6104_multp__cancel__max,axiom,
    ! [A: $tType,R5: A > A > $o,X5: multiset @ A,Y4: multiset @ A] :
      ( ( transp @ A @ R5 )
     => ( ( irreflp @ A @ R5 )
       => ( ( multp @ A @ R5 @ X5 @ Y4 )
          = ( multp @ A @ R5 @ ( minus_minus @ ( multiset @ A ) @ X5 @ Y4 ) @ ( minus_minus @ ( multiset @ A ) @ Y4 @ X5 ) ) ) ) ) ).

% multp_cancel_max
thf(fact_6105_multp__cancel__add__mset,axiom,
    ! [A: $tType,R5: A > A > $o,Uu3: A,X5: multiset @ A,Y4: multiset @ A] :
      ( ( transp @ A @ R5 )
     => ( ( irreflp @ A @ R5 )
       => ( ( multp @ A @ R5 @ ( add_mset @ A @ Uu3 @ X5 ) @ ( add_mset @ A @ Uu3 @ Y4 ) )
          = ( multp @ A @ R5 @ X5 @ Y4 ) ) ) ) ).

% multp_cancel_add_mset
thf(fact_6106_multp__cancel,axiom,
    ! [A: $tType,R5: A > A > $o,X5: multiset @ A,Z6: multiset @ A,Y4: multiset @ A] :
      ( ( transp @ A @ R5 )
     => ( ( irreflp @ A @ R5 )
       => ( ( multp @ A @ R5 @ ( plus_plus @ ( multiset @ A ) @ X5 @ Z6 ) @ ( plus_plus @ ( multiset @ A ) @ Y4 @ Z6 ) )
          = ( multp @ A @ R5 @ X5 @ Y4 ) ) ) ) ).

% multp_cancel
thf(fact_6107_multp__def,axiom,
    ! [A: $tType] :
      ( ( multp @ A )
      = ( ^ [R3: A > A > $o,M8: multiset @ A,N7: multiset @ A] : ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ M8 @ N7 ) @ ( mult @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R3 ) ) ) ) ) ) ).

% multp_def
thf(fact_6108_THE__default__def,axiom,
    ! [A: $tType] :
      ( ( fun_THE_default @ A )
      = ( ^ [D4: A,P3: A > $o] :
            ( if @ A
            @ ? [X2: A] :
                ( ( P3 @ X2 )
                & ! [Y2: A] :
                    ( ( P3 @ Y2 )
                   => ( Y2 = X2 ) ) )
            @ ( the @ A @ P3 )
            @ D4 ) ) ) ).

% THE_default_def
thf(fact_6109_fundef__ex1__uniqueness,axiom,
    ! [B: $tType,A: $tType,F2: A > B,D3: A > B,G4: A > B > $o,X3: A,H2: A > B] :
      ( ( F2
        = ( ^ [X2: A] : ( fun_THE_default @ B @ ( D3 @ X2 ) @ ( G4 @ X2 ) ) ) )
     => ( ? [X4: B] :
            ( ( G4 @ X3 @ X4 )
            & ! [Y3: B] :
                ( ( G4 @ X3 @ Y3 )
               => ( Y3 = X4 ) ) )
       => ( ( G4 @ X3 @ ( H2 @ X3 ) )
         => ( ( H2 @ X3 )
            = ( F2 @ X3 ) ) ) ) ) ).

% fundef_ex1_uniqueness
thf(fact_6110_fundef__ex1__existence,axiom,
    ! [B: $tType,A: $tType,F2: A > B,D3: A > B,G4: A > B > $o,X3: A] :
      ( ( F2
        = ( ^ [X2: A] : ( fun_THE_default @ B @ ( D3 @ X2 ) @ ( G4 @ X2 ) ) ) )
     => ( ? [X4: B] :
            ( ( G4 @ X3 @ X4 )
            & ! [Y3: B] :
                ( ( G4 @ X3 @ Y3 )
               => ( Y3 = X4 ) ) )
       => ( G4 @ X3 @ ( F2 @ X3 ) ) ) ) ).

% fundef_ex1_existence
thf(fact_6111_fundef__default__value,axiom,
    ! [B: $tType,A: $tType,F2: A > B,D3: A > B,G4: A > B > $o,D2: A > $o,X3: A] :
      ( ( F2
        = ( ^ [X2: A] : ( fun_THE_default @ B @ ( D3 @ X2 ) @ ( G4 @ X2 ) ) ) )
     => ( ! [X: A,Y3: B] :
            ( ( G4 @ X @ Y3 )
           => ( D2 @ X ) )
       => ( ~ ( D2 @ X3 )
         => ( ( F2 @ X3 )
            = ( D3 @ X3 ) ) ) ) ) ).

% fundef_default_value
thf(fact_6112_fundef__ex1__iff,axiom,
    ! [A: $tType,B: $tType,F2: A > B,D3: A > B,G4: A > B > $o,X3: A,Y: B] :
      ( ( F2
        = ( ^ [X2: A] : ( fun_THE_default @ B @ ( D3 @ X2 ) @ ( G4 @ X2 ) ) ) )
     => ( ? [X4: B] :
            ( ( G4 @ X3 @ X4 )
            & ! [Y3: B] :
                ( ( G4 @ X3 @ Y3 )
               => ( Y3 = X4 ) ) )
       => ( ( G4 @ X3 @ Y )
          = ( ( F2 @ X3 )
            = Y ) ) ) ) ).

% fundef_ex1_iff
thf(fact_6113_curry__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_curry @ A @ B @ C )
      = ( ^ [C5: ( product_prod @ A @ B ) > C,X2: A,Y2: B] : ( C5 @ ( product_Pair @ A @ B @ X2 @ Y2 ) ) ) ) ).

% curry_def
thf(fact_6114_prod__encode__def,axiom,
    ( nat_prod_encode
    = ( product_case_prod @ nat @ nat @ nat
      @ ^ [M5: nat,N5: nat] : ( plus_plus @ nat @ ( nat_triangle @ ( plus_plus @ nat @ M5 @ N5 ) ) @ M5 ) ) ) ).

% prod_encode_def
thf(fact_6115_curry__K,axiom,
    ! [B: $tType,C: $tType,A: $tType,C2: C] :
      ( ( product_curry @ A @ B @ C
        @ ^ [X2: product_prod @ A @ B] : C2 )
      = ( ^ [X2: A,Y2: B] : C2 ) ) ).

% curry_K
thf(fact_6116_successively__altdef,axiom,
    ! [A: $tType] :
      ( ( successively @ A )
      = ( ^ [P3: A > A > $o] :
            ( rec_list @ $o @ A @ $true
            @ ^ [X2: A,Xs2: list @ A,B4: $o] :
                ( case_list @ $o @ A @ $true
                @ ^ [Y2: A,Xa4: list @ A] :
                    ( ( P3 @ X2 @ Y2 )
                    & B4 )
                @ Xs2 ) ) ) ) ).

% successively_altdef
thf(fact_6117_semilattice__neutr__set_Oremove,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,A3: set @ A,X3: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( member @ A @ X3 @ A3 )
         => ( ( lattic5214292709420241887eutr_F @ A @ F2 @ Z2 @ A3 )
            = ( F2 @ X3 @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% semilattice_neutr_set.remove
thf(fact_6118_successively__rev,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ( successively @ A @ P @ ( rev @ A @ Xs ) )
      = ( successively @ A
        @ ^ [X2: A,Y2: A] : ( P @ Y2 @ X2 )
        @ Xs ) ) ).

% successively_rev
thf(fact_6119_semilattice__neutr__set_Oclosed,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,A3: set @ A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X: A,Y3: A] : ( member @ A @ ( F2 @ X @ Y3 ) @ ( insert @ A @ X @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
           => ( member @ A @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z2 @ A3 ) @ A3 ) ) ) ) ) ).

% semilattice_neutr_set.closed
thf(fact_6120_semilattice__neutr__set_Oempty,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z2 )
     => ( ( lattic5214292709420241887eutr_F @ A @ F2 @ Z2 @ ( bot_bot @ ( set @ A ) ) )
        = Z2 ) ) ).

% semilattice_neutr_set.empty
thf(fact_6121_successively__map,axiom,
    ! [A: $tType,B: $tType,P: A > A > $o,F2: B > A,Xs: list @ B] :
      ( ( successively @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( successively @ B
        @ ^ [X2: B,Y2: B] : ( P @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
        @ Xs ) ) ).

% successively_map
thf(fact_6122_semilattice__neutr__set_Oinsert__remove,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,A3: set @ A,X3: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z2 )
     => ( ( finite_finite2 @ A @ A3 )
       => ( ( lattic5214292709420241887eutr_F @ A @ F2 @ Z2 @ ( insert @ A @ X3 @ A3 ) )
          = ( F2 @ X3 @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% semilattice_neutr_set.insert_remove
thf(fact_6123_inv__imagep__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( inv_imagep @ B @ A )
      = ( ^ [R3: B > B > $o,F3: A > B,X2: A,Y2: A] : ( R3 @ ( F3 @ X2 ) @ ( F3 @ Y2 ) ) ) ) ).

% inv_imagep_def
thf(fact_6124_is__filter__map__filter__on,axiom,
    ! [A: $tType,B: $tType,F2: B > A,X5: set @ B,F: filter @ B] :
      ( ( is_filter @ A
        @ ^ [P3: A > $o] :
            ( eventually @ B
            @ ^ [X2: B] :
                ( ( P3 @ ( F2 @ X2 ) )
                & ( member @ B @ X2 @ X5 ) )
            @ F ) )
      = ( eventually @ B
        @ ^ [X2: B] : ( member @ B @ X2 @ X5 )
        @ F ) ) ).

% is_filter_map_filter_on
thf(fact_6125_is__filter_OTrue,axiom,
    ! [A: $tType,F: ( A > $o ) > $o] :
      ( ( is_filter @ A @ F )
     => ( F
        @ ^ [X2: A] : $true ) ) ).

% is_filter.True
thf(fact_6126_is__filter_Oconj,axiom,
    ! [A: $tType,F: ( A > $o ) > $o,P: A > $o,Q: A > $o] :
      ( ( is_filter @ A @ F )
     => ( ( F @ P )
       => ( ( F @ Q )
         => ( F
            @ ^ [X2: A] :
                ( ( P @ X2 )
                & ( Q @ X2 ) ) ) ) ) ) ).

% is_filter.conj
thf(fact_6127_is__filter_Omono,axiom,
    ! [A: $tType,F: ( A > $o ) > $o,P: A > $o,Q: A > $o] :
      ( ( is_filter @ A @ F )
     => ( ! [X: A] :
            ( ( P @ X )
           => ( Q @ X ) )
       => ( ( F @ P )
         => ( F @ Q ) ) ) ) ).

% is_filter.mono
thf(fact_6128_is__filter_Ointro,axiom,
    ! [A: $tType,F: ( A > $o ) > $o] :
      ( ( F
        @ ^ [X2: A] : $true )
     => ( ! [P4: A > $o] :
            ( ( F @ P4 )
           => ! [Q5: A > $o] :
                ( ( F @ Q5 )
               => ( F
                  @ ^ [X2: A] :
                      ( ( P4 @ X2 )
                      & ( Q5 @ X2 ) ) ) ) )
       => ( ! [P4: A > $o,Q5: A > $o] :
              ( ! [X4: A] :
                  ( ( P4 @ X4 )
                 => ( Q5 @ X4 ) )
             => ( ( F @ P4 )
               => ( F @ Q5 ) ) )
         => ( is_filter @ A @ F ) ) ) ) ).

% is_filter.intro
thf(fact_6129_is__filter__def,axiom,
    ! [A: $tType] :
      ( ( is_filter @ A )
      = ( ^ [F5: ( A > $o ) > $o] :
            ( ( F5
              @ ^ [X2: A] : $true )
            & ! [P3: A > $o] :
                ( ( F5 @ P3 )
               => ! [Q3: A > $o] :
                    ( ( F5 @ Q3 )
                   => ( F5
                      @ ^ [X2: A] :
                          ( ( P3 @ X2 )
                          & ( Q3 @ X2 ) ) ) ) )
            & ! [P3: A > $o,Q3: A > $o] :
                ( ! [X2: A] :
                    ( ( P3 @ X2 )
                   => ( Q3 @ X2 ) )
               => ( ( F5 @ P3 )
                 => ( F5 @ Q3 ) ) ) ) ) ) ).

% is_filter_def
thf(fact_6130_Abs__filter__cases,axiom,
    ! [A: $tType,X3: filter @ A] :
      ~ ! [Y3: ( A > $o ) > $o] :
          ( ( X3
            = ( abs_filter @ A @ Y3 ) )
         => ~ ( member @ ( ( A > $o ) > $o ) @ Y3 @ ( collect @ ( ( A > $o ) > $o ) @ ( is_filter @ A ) ) ) ) ).

% Abs_filter_cases
thf(fact_6131_Abs__filter__induct,axiom,
    ! [A: $tType,P: ( filter @ A ) > $o,X3: filter @ A] :
      ( ! [Y3: ( A > $o ) > $o] :
          ( ( member @ ( ( A > $o ) > $o ) @ Y3 @ ( collect @ ( ( A > $o ) > $o ) @ ( is_filter @ A ) ) )
         => ( P @ ( abs_filter @ A @ Y3 ) ) )
     => ( P @ X3 ) ) ).

% Abs_filter_induct
thf(fact_6132_Abs__filter__inject,axiom,
    ! [A: $tType,X3: ( A > $o ) > $o,Y: ( A > $o ) > $o] :
      ( ( member @ ( ( A > $o ) > $o ) @ X3 @ ( collect @ ( ( A > $o ) > $o ) @ ( is_filter @ A ) ) )
     => ( ( member @ ( ( A > $o ) > $o ) @ Y @ ( collect @ ( ( A > $o ) > $o ) @ ( is_filter @ A ) ) )
       => ( ( ( abs_filter @ A @ X3 )
            = ( abs_filter @ A @ Y ) )
          = ( X3 = Y ) ) ) ) ).

% Abs_filter_inject
thf(fact_6133_type__definition__filter,axiom,
    ! [A: $tType] : ( type_definition @ ( filter @ A ) @ ( ( A > $o ) > $o ) @ ( rep_filter @ A ) @ ( abs_filter @ A ) @ ( collect @ ( ( A > $o ) > $o ) @ ( is_filter @ A ) ) ) ).

% type_definition_filter
thf(fact_6134_Abs__filter__inverse,axiom,
    ! [A: $tType,Y: ( A > $o ) > $o] :
      ( ( member @ ( ( A > $o ) > $o ) @ Y @ ( collect @ ( ( A > $o ) > $o ) @ ( is_filter @ A ) ) )
     => ( ( rep_filter @ A @ ( abs_filter @ A @ Y ) )
        = Y ) ) ).

% Abs_filter_inverse
thf(fact_6135_Rep__filter,axiom,
    ! [A: $tType,X3: filter @ A] : ( member @ ( ( A > $o ) > $o ) @ ( rep_filter @ A @ X3 ) @ ( collect @ ( ( A > $o ) > $o ) @ ( is_filter @ A ) ) ) ).

% Rep_filter
thf(fact_6136_Rep__filter__cases,axiom,
    ! [A: $tType,Y: ( A > $o ) > $o] :
      ( ( member @ ( ( A > $o ) > $o ) @ Y @ ( collect @ ( ( A > $o ) > $o ) @ ( is_filter @ A ) ) )
     => ~ ! [X: filter @ A] :
            ( Y
           != ( rep_filter @ A @ X ) ) ) ).

% Rep_filter_cases
thf(fact_6137_Rep__filter__induct,axiom,
    ! [A: $tType,Y: ( A > $o ) > $o,P: ( ( A > $o ) > $o ) > $o] :
      ( ( member @ ( ( A > $o ) > $o ) @ Y @ ( collect @ ( ( A > $o ) > $o ) @ ( is_filter @ A ) ) )
     => ( ! [X: filter @ A] : ( P @ ( rep_filter @ A @ X ) )
       => ( P @ Y ) ) ) ).

% Rep_filter_induct
thf(fact_6138_ref_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_ref @ A @ B )
      = ( ^ [R2: A > B > $o] :
            ( relcompp @ ( ref @ A ) @ ( ref @ ( product_prod @ A @ B ) ) @ ( ref @ B )
            @ ( conversep @ ( ref @ ( product_prod @ A @ B ) ) @ ( ref @ A )
              @ ( bNF_Grp @ ( ref @ ( product_prod @ A @ B ) ) @ ( ref @ A )
                @ ( collect @ ( ref @ ( product_prod @ A @ B ) )
                  @ ^ [X2: ref @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_ref @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
                @ ( map_ref @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) ) ) )
            @ ( bNF_Grp @ ( ref @ ( product_prod @ A @ B ) ) @ ( ref @ B )
              @ ( collect @ ( ref @ ( product_prod @ A @ B ) )
                @ ^ [X2: ref @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_ref @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
              @ ( map_ref @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) ) ) ) ) ) ).

% ref.rel_compp_Grp
thf(fact_6139_array_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_array @ A @ B )
      = ( ^ [R2: A > B > $o] :
            ( relcompp @ ( array @ A ) @ ( array @ ( product_prod @ A @ B ) ) @ ( array @ B )
            @ ( conversep @ ( array @ ( product_prod @ A @ B ) ) @ ( array @ A )
              @ ( bNF_Grp @ ( array @ ( product_prod @ A @ B ) ) @ ( array @ A )
                @ ( collect @ ( array @ ( product_prod @ A @ B ) )
                  @ ^ [X2: array @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_array @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
                @ ( map_array @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) ) ) )
            @ ( bNF_Grp @ ( array @ ( product_prod @ A @ B ) ) @ ( array @ B )
              @ ( collect @ ( array @ ( product_prod @ A @ B ) )
                @ ^ [X2: array @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_array @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
              @ ( map_array @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) ) ) ) ) ) ).

% array.rel_compp_Grp
thf(fact_6140_ref_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: A > C > $o,X3: ref @ A,G: B > C,Y: ref @ B] :
      ( ( rel_ref @ A @ C @ Sa @ X3 @ ( map_ref @ B @ C @ G @ Y ) )
      = ( rel_ref @ A @ B
        @ ^ [X2: A,Y2: B] : ( Sa @ X2 @ ( G @ Y2 ) )
        @ X3
        @ Y ) ) ).

% ref.rel_map(2)
thf(fact_6141_ref_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: C > B > $o,I3: A > C,X3: ref @ A,Y: ref @ B] :
      ( ( rel_ref @ C @ B @ Sb @ ( map_ref @ A @ C @ I3 @ X3 ) @ Y )
      = ( rel_ref @ A @ B
        @ ^ [X2: A] : ( Sb @ ( I3 @ X2 ) )
        @ X3
        @ Y ) ) ).

% ref.rel_map(1)
thf(fact_6142_array_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: A > C > $o,X3: array @ A,G: B > C,Y: array @ B] :
      ( ( rel_array @ A @ C @ Sa @ X3 @ ( map_array @ B @ C @ G @ Y ) )
      = ( rel_array @ A @ B
        @ ^ [X2: A,Y2: B] : ( Sa @ X2 @ ( G @ Y2 ) )
        @ X3
        @ Y ) ) ).

% array.rel_map(2)
thf(fact_6143_array_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: C > B > $o,I3: A > C,X3: array @ A,Y: array @ B] :
      ( ( rel_array @ C @ B @ Sb @ ( map_array @ A @ C @ I3 @ X3 ) @ Y )
      = ( rel_array @ A @ B
        @ ^ [X2: A] : ( Sb @ ( I3 @ X2 ) )
        @ X3
        @ Y ) ) ).

% array.rel_map(1)
thf(fact_6144_ref_Omap__ident,axiom,
    ! [A: $tType,T3: ref @ A] :
      ( ( map_ref @ A @ A
        @ ^ [X2: A] : X2
        @ T3 )
      = T3 ) ).

% ref.map_ident
thf(fact_6145_array_Omap__ident,axiom,
    ! [A: $tType,T3: array @ A] :
      ( ( map_array @ A @ A
        @ ^ [X2: A] : X2
        @ T3 )
      = T3 ) ).

% array.map_ident
thf(fact_6146_ref_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( rel_ref @ A @ B @ ( bNF_Grp @ A @ B @ A3 @ F2 ) )
      = ( bNF_Grp @ ( ref @ A ) @ ( ref @ B )
        @ ( collect @ ( ref @ A )
          @ ^ [X2: ref @ A] : ( ord_less_eq @ ( set @ A ) @ ( set_ref @ A @ X2 ) @ A3 ) )
        @ ( map_ref @ A @ B @ F2 ) ) ) ).

% ref.rel_Grp
thf(fact_6147_array_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( rel_array @ A @ B @ ( bNF_Grp @ A @ B @ A3 @ F2 ) )
      = ( bNF_Grp @ ( array @ A ) @ ( array @ B )
        @ ( collect @ ( array @ A )
          @ ^ [X2: array @ A] : ( ord_less_eq @ ( set @ A ) @ ( set_array @ A @ X2 ) @ A3 ) )
        @ ( map_array @ A @ B @ F2 ) ) ) ).

% array.rel_Grp
thf(fact_6148_ref_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_ref @ A @ B )
      = ( ^ [R2: A > B > $o,A5: ref @ A,B4: ref @ B] :
          ? [Z3: ref @ ( product_prod @ A @ B )] :
            ( ( member @ ( ref @ ( product_prod @ A @ B ) ) @ Z3
              @ ( collect @ ( ref @ ( product_prod @ A @ B ) )
                @ ^ [X2: ref @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_ref @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) ) )
            & ( ( map_ref @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z3 )
              = A5 )
            & ( ( map_ref @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z3 )
              = B4 ) ) ) ) ).

% ref.in_rel
thf(fact_6149_array_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_array @ A @ B )
      = ( ^ [R2: A > B > $o,A5: array @ A,B4: array @ B] :
          ? [Z3: array @ ( product_prod @ A @ B )] :
            ( ( member @ ( array @ ( product_prod @ A @ B ) ) @ Z3
              @ ( collect @ ( array @ ( product_prod @ A @ B ) )
                @ ^ [X2: array @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set_array @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) ) )
            & ( ( map_array @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z3 )
              = A5 )
            & ( ( map_array @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z3 )
              = B4 ) ) ) ) ).

% array.in_rel
thf(fact_6150_array_Orec__o__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: nat > C,F2: A > B] :
      ( ( comp @ ( array @ B ) @ C @ ( array @ A ) @ ( rec_array @ C @ B @ G ) @ ( map_array @ A @ B @ F2 ) )
      = ( rec_array @ C @ A @ G ) ) ).

% array.rec_o_map
thf(fact_6151_ref_Orec__o__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: nat > C,F2: A > B] :
      ( ( comp @ ( ref @ B ) @ C @ ( ref @ A ) @ ( rec_ref @ C @ B @ G ) @ ( map_ref @ A @ B @ F2 ) )
      = ( rec_ref @ C @ A @ G ) ) ).

% ref.rec_o_map
thf(fact_6152_array_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X3: array @ A,Ya2: array @ A,F2: A > B,G: A > B] :
      ( ( X3 = Ya2 )
     => ( ( pred_array @ A
          @ ^ [Z3: A] :
              ( ( F2 @ Z3 )
              = ( G @ Z3 ) )
          @ Ya2 )
       => ( ( map_array @ A @ B @ F2 @ X3 )
          = ( map_array @ A @ B @ G @ Ya2 ) ) ) ) ).

% array.map_cong_pred
thf(fact_6153_ref_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X3: ref @ A,Ya2: ref @ A,F2: A > B,G: A > B] :
      ( ( X3 = Ya2 )
     => ( ( pred_ref @ A
          @ ^ [Z3: A] :
              ( ( F2 @ Z3 )
              = ( G @ Z3 ) )
          @ Ya2 )
       => ( ( map_ref @ A @ B @ F2 @ X3 )
          = ( map_ref @ A @ B @ G @ Ya2 ) ) ) ) ).

% ref.map_cong_pred
thf(fact_6154_ref_Opred__True,axiom,
    ! [A: $tType] :
      ( ( pred_ref @ A
        @ ^ [Uu: A] : $true )
      = ( ^ [Uu: ref @ A] : $true ) ) ).

% ref.pred_True
thf(fact_6155_array_Opred__True,axiom,
    ! [A: $tType] :
      ( ( pred_array @ A
        @ ^ [Uu: A] : $true )
      = ( ^ [Uu: array @ A] : $true ) ) ).

% array.pred_True
thf(fact_6156_Heap_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( heap_Time_rel_Heap @ A @ B )
      = ( ^ [R2: A > B > $o,A5: heap_Time_Heap @ A,B4: heap_Time_Heap @ B] :
          ? [Z3: heap_Time_Heap @ ( product_prod @ A @ B )] :
            ( ( member @ ( heap_Time_Heap @ ( product_prod @ A @ B ) ) @ Z3
              @ ( collect @ ( heap_Time_Heap @ ( product_prod @ A @ B ) )
                @ ^ [X2: heap_Time_Heap @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( heap_Time_set_Heap @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) ) )
            & ( ( heap_Time_map_Heap @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z3 )
              = A5 )
            & ( ( heap_Time_map_Heap @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z3 )
              = B4 ) ) ) ) ).

% Heap.in_rel
thf(fact_6157_Heap_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( heap_Time_rel_Heap @ A @ B )
      = ( ^ [R2: A > B > $o] :
            ( relcompp @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ ( product_prod @ A @ B ) ) @ ( heap_Time_Heap @ B )
            @ ( conversep @ ( heap_Time_Heap @ ( product_prod @ A @ B ) ) @ ( heap_Time_Heap @ A )
              @ ( bNF_Grp @ ( heap_Time_Heap @ ( product_prod @ A @ B ) ) @ ( heap_Time_Heap @ A )
                @ ( collect @ ( heap_Time_Heap @ ( product_prod @ A @ B ) )
                  @ ^ [X2: heap_Time_Heap @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( heap_Time_set_Heap @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
                @ ( heap_Time_map_Heap @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) ) ) )
            @ ( bNF_Grp @ ( heap_Time_Heap @ ( product_prod @ A @ B ) ) @ ( heap_Time_Heap @ B )
              @ ( collect @ ( heap_Time_Heap @ ( product_prod @ A @ B ) )
                @ ^ [X2: heap_Time_Heap @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( heap_Time_set_Heap @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
              @ ( heap_Time_map_Heap @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) ) ) ) ) ) ).

% Heap.rel_compp_Grp
thf(fact_6158_Heap_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: C > B > $o,I3: A > C,X3: heap_Time_Heap @ A,Y: heap_Time_Heap @ B] :
      ( ( heap_Time_rel_Heap @ C @ B @ Sb @ ( heap_Time_map_Heap @ A @ C @ I3 @ X3 ) @ Y )
      = ( heap_Time_rel_Heap @ A @ B
        @ ^ [X2: A] : ( Sb @ ( I3 @ X2 ) )
        @ X3
        @ Y ) ) ).

% Heap.rel_map(1)
thf(fact_6159_Heap_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: A > C > $o,X3: heap_Time_Heap @ A,G: B > C,Y: heap_Time_Heap @ B] :
      ( ( heap_Time_rel_Heap @ A @ C @ Sa @ X3 @ ( heap_Time_map_Heap @ B @ C @ G @ Y ) )
      = ( heap_Time_rel_Heap @ A @ B
        @ ^ [X2: A,Y2: B] : ( Sa @ X2 @ ( G @ Y2 ) )
        @ X3
        @ Y ) ) ).

% Heap.rel_map(2)
thf(fact_6160_Heap_Omap__ident,axiom,
    ! [A: $tType,T3: heap_Time_Heap @ A] :
      ( ( heap_Time_map_Heap @ A @ A
        @ ^ [X2: A] : X2
        @ T3 )
      = T3 ) ).

% Heap.map_ident
thf(fact_6161_Heap_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( heap_Time_rel_Heap @ A @ B @ ( bNF_Grp @ A @ B @ A3 @ F2 ) )
      = ( bNF_Grp @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B )
        @ ( collect @ ( heap_Time_Heap @ A )
          @ ^ [X2: heap_Time_Heap @ A] : ( ord_less_eq @ ( set @ A ) @ ( heap_Time_set_Heap @ A @ X2 ) @ A3 ) )
        @ ( heap_Time_map_Heap @ A @ B @ F2 ) ) ) ).

% Heap.rel_Grp
thf(fact_6162_Heap_Orec__o__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > C,F2: A > B] :
      ( ( comp @ ( heap_Time_Heap @ B ) @ C @ ( heap_Time_Heap @ A ) @ ( heap_Time_rec_Heap @ B @ C @ G ) @ ( heap_Time_map_Heap @ A @ B @ F2 ) )
      = ( heap_Time_rec_Heap @ A @ C
        @ ^ [X2: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] : ( G @ ( comp @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( map_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_map_prod @ A @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ F2 @ ( id @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ X2 ) ) ) ) ).

% Heap.rec_o_map
thf(fact_6163_Heap_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X3: heap_Time_Heap @ A,Ya2: heap_Time_Heap @ A,F2: A > B,G: A > B] :
      ( ( X3 = Ya2 )
     => ( ( heap_Time_pred_Heap @ A
          @ ^ [Z3: A] :
              ( ( F2 @ Z3 )
              = ( G @ Z3 ) )
          @ Ya2 )
       => ( ( heap_Time_map_Heap @ A @ B @ F2 @ X3 )
          = ( heap_Time_map_Heap @ A @ B @ G @ Ya2 ) ) ) ) ).

% Heap.map_cong_pred
thf(fact_6164_Heap_Opred__True,axiom,
    ! [A: $tType] :
      ( ( heap_Time_pred_Heap @ A
        @ ^ [Uu: A] : $true )
      = ( ^ [Uu: heap_Time_Heap @ A] : $true ) ) ).

% Heap.pred_True
thf(fact_6165_Heap_Opred__inject,axiom,
    ! [A: $tType,P: A > $o,A4: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( heap_Time_pred_Heap @ A @ P @ ( heap_Time_Heap2 @ A @ A4 ) )
      = ( basic_pred_fun @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ^ [Uu: heap_ext @ product_unit] : $true
        @ ( pred_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( basic_pred_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ P @ ( top_top @ ( ( product_prod @ ( heap_ext @ product_unit ) @ nat ) > $o ) ) ) )
        @ A4 ) ) ).

% Heap.pred_inject
thf(fact_6166_option_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X3: option @ A,Ya2: option @ A,F2: A > B,G: A > B] :
      ( ( X3 = Ya2 )
     => ( ( pred_option @ A
          @ ^ [Z3: A] :
              ( ( F2 @ Z3 )
              = ( G @ Z3 ) )
          @ Ya2 )
       => ( ( map_option @ A @ B @ F2 @ X3 )
          = ( map_option @ A @ B @ G @ Ya2 ) ) ) ) ).

% option.map_cong_pred
thf(fact_6167_option_Opred__True,axiom,
    ! [A: $tType] :
      ( ( pred_option @ A
        @ ^ [Uu: A] : $true )
      = ( ^ [Uu: option @ A] : $true ) ) ).

% option.pred_True

% Type constructors (712)
thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( condit1219197933456340205attice @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( comple592849572758109894attice @ A20 )
     => ( comple592849572758109894attice @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__boolean__algebra,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( comple489889107523837845lgebra @ A20 )
     => ( comple489889107523837845lgebra @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( bounded_lattice @ A20 )
     => ( bounde4967611905675639751up_bot @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( bounded_lattice @ A20 )
     => ( bounde4346867609351753570nf_top @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( comple6319245703460814977attice @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( boolea8198339166811842893lgebra @ A20 )
     => ( boolea8198339166811842893lgebra @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( bounded_lattice @ A20 )
     => ( bounded_lattice_top @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( bounded_lattice @ A20 )
     => ( bounded_lattice_bot @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Complete__Partial__Order_Occpo,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( comple9053668089753744459l_ccpo @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( semilattice_sup @ A20 )
     => ( semilattice_sup @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( semilattice_inf @ A20 )
     => ( semilattice_inf @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( distrib_lattice @ A20 )
     => ( distrib_lattice @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( bounded_lattice @ A20 )
     => ( bounded_lattice @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Complete__Lattices_OSup,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( complete_Sup @ A20 )
     => ( complete_Sup @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Complete__Lattices_OInf,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( complete_Inf @ A20 )
     => ( complete_Inf @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( order_top @ A20 )
     => ( order_top @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( order_bot @ A20 )
     => ( order_bot @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Countable_Ocountable,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( ( finite_finite @ A19 )
        & ( countable @ A20 ) )
     => ( countable @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( preorder @ A20 )
     => ( preorder @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Finite__Set_Ofinite,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( ( finite_finite @ A19 )
        & ( finite_finite @ A20 ) )
     => ( finite_finite @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( lattice @ A20 )
     => ( lattice @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( order @ A20 )
     => ( order @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Otop,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( top @ A20 )
     => ( top @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( ord @ A20 )
     => ( ord @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Orderings_Obot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( bot @ A20 )
     => ( bot @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( uminus @ A20 )
     => ( uminus @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Osup,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( semilattice_sup @ A20 )
     => ( sup @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Lattices_Oinf,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( semilattice_inf @ A20 )
     => ( inf @ ( A19 > A20 ) ) ) ).

thf(tcon_fun___Groups_Ominus,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( minus @ A20 )
     => ( minus @ ( A19 > A20 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_1,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Rings_Onormalization__semidom__multiplicative,axiom,
    normal6328177297339901930cative @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide__unit__factor,axiom,
    semido2269285787275462019factor @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Onormalization__semidom,axiom,
    normal8620421768224518004emidom @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_2,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_3,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Lattices_Odistrib__lattice_4,axiom,
    distrib_lattice @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Complete__Lattices_OSup_5,axiom,
    complete_Sup @ int ).

thf(tcon_Int_Oint___Complete__Lattices_OInf_6,axiom,
    complete_Inf @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Countable_Ocountable_7,axiom,
    countable @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_8,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_9,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_10,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Orderings_Oord_11,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_12,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___Lattices_Osup_13,axiom,
    sup @ int ).

thf(tcon_Int_Oint___Lattices_Oinf_14,axiom,
    inf @ int ).

thf(tcon_Int_Oint___Groups_Otimes,axiom,
    times @ int ).

thf(tcon_Int_Oint___Groups_Ominus_15,axiom,
    minus @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Int_Oint___Heap_Oheap,axiom,
    heap @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_16,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_17,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_18,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_19,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_20,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_21,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_22,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_23,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Onormalization__semidom__multiplicative_24,axiom,
    normal6328177297339901930cative @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_25,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_26,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_27,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_28,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_29,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_30,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_31,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_32,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_33,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_34,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_35,axiom,
    linord4140545234300271783up_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_36,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide__unit__factor_37,axiom,
    semido2269285787275462019factor @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_38,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_39,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_40,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_41,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_42,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_43,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_44,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_45,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_46,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_47,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Rings_Onormalization__semidom_48,axiom,
    normal8620421768224518004emidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_49,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_50,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_51,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_52,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_53,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_54,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Lattices_Odistrib__lattice_55,axiom,
    distrib_lattice @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_56,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_57,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_58,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_59,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_60,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_61,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_62,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_63,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_64,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_65,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_66,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Complete__Lattices_OSup_67,axiom,
    complete_Sup @ nat ).

thf(tcon_Nat_Onat___Complete__Lattices_OInf_68,axiom,
    complete_Inf @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_69,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_70,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_71,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_72,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_73,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_74,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_75,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_76,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Countable_Ocountable_77,axiom,
    countable @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_78,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_79,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_80,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_81,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_82,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_83,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_84,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_85,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_86,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_87,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_88,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_89,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_90,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_91,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_92,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Orderings_Obot_93,axiom,
    bot @ nat ).

thf(tcon_Nat_Onat___Lattices_Osup_94,axiom,
    sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Oinf_95,axiom,
    inf @ nat ).

thf(tcon_Nat_Onat___Groups_Otimes_96,axiom,
    times @ nat ).

thf(tcon_Nat_Onat___Groups_Ominus_97,axiom,
    minus @ nat ).

thf(tcon_Nat_Onat___Power_Opower_98,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_99,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_100,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_101,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_102,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Heap_Oheap_103,axiom,
    heap @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_104,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_105,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_106,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_107,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Otimes_108,axiom,
    times @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_109,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_110,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_111,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_112,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_113,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_114,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_115,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_116,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_117,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_118,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_119,axiom,
    linord4140545234300271783up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_120,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_121,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_122,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_123,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_124,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_125,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_126,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_127,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_128,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_129,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_130,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_131,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_132,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_133,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_134,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_135,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_136,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_137,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_138,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_139,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_140,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Lattices_Odistrib__lattice_141,axiom,
    distrib_lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_142,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_143,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_144,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_145,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_146,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_147,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_148,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_149,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_150,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_151,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_152,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_153,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_154,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_155,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_156,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_157,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_158,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_159,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Countable_Ocountable_160,axiom,
    countable @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_161,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_162,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_163,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_164,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_165,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_166,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_167,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_168,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_169,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_170,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_171,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_172,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_173,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_174,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_175,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_176,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_177,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_178,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_179,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_180,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_181,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_182,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_183,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_184,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_185,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Lattices_Osup_186,axiom,
    sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Oinf_187,axiom,
    inf @ rat ).

thf(tcon_Rat_Orat___Groups_Otimes_188,axiom,
    times @ rat ).

thf(tcon_Rat_Orat___Groups_Ominus_189,axiom,
    minus @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_190,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_191,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_192,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_193,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_194,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_195,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_196,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_197,axiom,
    ! [A19: $tType] : ( condit1219197933456340205attice @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_198,axiom,
    ! [A19: $tType] : ( comple592849572758109894attice @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__boolean__algebra_199,axiom,
    ! [A19: $tType] : ( comple489889107523837845lgebra @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_200,axiom,
    ! [A19: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_201,axiom,
    ! [A19: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_202,axiom,
    ! [A19: $tType] : ( comple6319245703460814977attice @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_203,axiom,
    ! [A19: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_204,axiom,
    ! [A19: $tType] : ( bounded_lattice_top @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_205,axiom,
    ! [A19: $tType] : ( bounded_lattice_bot @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Complete__Partial__Order_Occpo_206,axiom,
    ! [A19: $tType] : ( comple9053668089753744459l_ccpo @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_207,axiom,
    ! [A19: $tType] : ( semilattice_sup @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_208,axiom,
    ! [A19: $tType] : ( semilattice_inf @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_209,axiom,
    ! [A19: $tType] : ( distrib_lattice @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_210,axiom,
    ! [A19: $tType] : ( bounded_lattice @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_OSup_211,axiom,
    ! [A19: $tType] : ( complete_Sup @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_OInf_212,axiom,
    ! [A19: $tType] : ( complete_Inf @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_213,axiom,
    ! [A19: $tType] : ( order_top @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_214,axiom,
    ! [A19: $tType] : ( order_bot @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Countable_Ocountable_215,axiom,
    ! [A19: $tType] :
      ( ( finite_finite @ A19 )
     => ( countable @ ( set @ A19 ) ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_216,axiom,
    ! [A19: $tType] : ( preorder @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Finite__Set_Ofinite_217,axiom,
    ! [A19: $tType] :
      ( ( finite_finite @ A19 )
     => ( finite_finite @ ( set @ A19 ) ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_218,axiom,
    ! [A19: $tType] : ( lattice @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_219,axiom,
    ! [A19: $tType] : ( order @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Orderings_Otop_220,axiom,
    ! [A19: $tType] : ( top @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_221,axiom,
    ! [A19: $tType] : ( ord @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Orderings_Obot_222,axiom,
    ! [A19: $tType] : ( bot @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_223,axiom,
    ! [A19: $tType] : ( uminus @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Lattices_Osup_224,axiom,
    ! [A19: $tType] : ( sup @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Lattices_Oinf_225,axiom,
    ! [A19: $tType] : ( inf @ ( set @ A19 ) ) ).

thf(tcon_Set_Oset___Groups_Ominus_226,axiom,
    ! [A19: $tType] : ( minus @ ( set @ A19 ) ) ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_227,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_228,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__boolean__algebra_229,axiom,
    comple489889107523837845lgebra @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_230,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_231,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_232,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_233,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_234,axiom,
    bounded_lattice_top @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_235,axiom,
    bounded_lattice_bot @ $o ).

thf(tcon_HOL_Obool___Complete__Partial__Order_Occpo_236,axiom,
    comple9053668089753744459l_ccpo @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_237,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_238,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_239,axiom,
    distrib_lattice @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_240,axiom,
    bounded_lattice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_OSup_241,axiom,
    complete_Sup @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_OInf_242,axiom,
    complete_Inf @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_243,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_244,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Countable_Ocountable_245,axiom,
    countable @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_246,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_247,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_248,axiom,
    finite_finite @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_249,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_250,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Otop_251,axiom,
    top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_252,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Orderings_Obot_253,axiom,
    bot @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_254,axiom,
    uminus @ $o ).

thf(tcon_HOL_Obool___Lattices_Osup_255,axiom,
    sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Oinf_256,axiom,
    inf @ $o ).

thf(tcon_HOL_Obool___Groups_Ominus_257,axiom,
    minus @ $o ).

thf(tcon_HOL_Obool___Heap_Oheap_258,axiom,
    heap @ $o ).

thf(tcon_Heap_Oref___Countable_Ocountable_259,axiom,
    ! [A19: $tType] : ( countable @ ( ref @ A19 ) ) ).

thf(tcon_Heap_Oref___Heap_Oheap_260,axiom,
    ! [A19: $tType] : ( heap @ ( ref @ A19 ) ) ).

thf(tcon_List_Olist___Countable_Ocountable_261,axiom,
    ! [A19: $tType] :
      ( ( countable @ A19 )
     => ( countable @ ( list @ A19 ) ) ) ).

thf(tcon_List_Olist___Heap_Oheap_262,axiom,
    ! [A19: $tType] :
      ( ( heap @ A19 )
     => ( heap @ ( list @ A19 ) ) ) ).

thf(tcon_Heap_Oarray___Countable_Ocountable_263,axiom,
    ! [A19: $tType] : ( countable @ ( array @ A19 ) ) ).

thf(tcon_Heap_Oarray___Heap_Oheap_264,axiom,
    ! [A19: $tType] : ( heap @ ( array @ A19 ) ) ).

thf(tcon_Sum__Type_Osum___Countable_Ocountable_265,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( ( countable @ A19 )
        & ( countable @ A20 ) )
     => ( countable @ ( sum_sum @ A19 @ A20 ) ) ) ).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_266,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( ( finite_finite @ A19 )
        & ( finite_finite @ A20 ) )
     => ( finite_finite @ ( sum_sum @ A19 @ A20 ) ) ) ).

thf(tcon_Sum__Type_Osum___Heap_Oheap_267,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( ( heap @ A19 )
        & ( heap @ A20 ) )
     => ( heap @ ( sum_sum @ A19 @ A20 ) ) ) ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_268,axiom,
    ! [A19: $tType] : ( condit1219197933456340205attice @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_269,axiom,
    ! [A19: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_270,axiom,
    ! [A19: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_271,axiom,
    ! [A19: $tType] : ( comple6319245703460814977attice @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice__top_272,axiom,
    ! [A19: $tType] : ( bounded_lattice_top @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice__bot_273,axiom,
    ! [A19: $tType] : ( bounded_lattice_bot @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Partial__Order_Occpo_274,axiom,
    ! [A19: $tType] : ( comple9053668089753744459l_ccpo @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_275,axiom,
    ! [A19: $tType] : ( semilattice_sup @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_276,axiom,
    ! [A19: $tType] : ( semilattice_inf @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Odistrib__lattice_277,axiom,
    ! [A19: $tType] : ( distrib_lattice @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_278,axiom,
    ! [A19: $tType] : ( bounded_lattice @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_OSup_279,axiom,
    ! [A19: $tType] : ( complete_Sup @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_OInf_280,axiom,
    ! [A19: $tType] : ( complete_Inf @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_281,axiom,
    ! [A19: $tType] : ( order_top @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_282,axiom,
    ! [A19: $tType] : ( order_bot @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_283,axiom,
    ! [A19: $tType] : ( preorder @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_284,axiom,
    ! [A19: $tType] : ( lattice @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_285,axiom,
    ! [A19: $tType] : ( order @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Otop_286,axiom,
    ! [A19: $tType] : ( top @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_287,axiom,
    ! [A19: $tType] : ( ord @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Obot_288,axiom,
    ! [A19: $tType] : ( bot @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osup_289,axiom,
    ! [A19: $tType] : ( sup @ ( filter @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Oinf_290,axiom,
    ! [A19: $tType] : ( inf @ ( filter @ A19 ) ) ).

thf(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_291,axiom,
    ! [A19: $tType] :
      ( ( comple5582772986160207858norder @ A19 )
     => ( condit6923001295902523014norder @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_292,axiom,
    ! [A19: $tType] :
      ( ( comple6319245703460814977attice @ A19 )
     => ( condit1219197933456340205attice @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_Ocomplete__distrib__lattice_293,axiom,
    ! [A19: $tType] :
      ( ( comple592849572758109894attice @ A19 )
     => ( comple592849572758109894attice @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__semilattice__sup__bot_294,axiom,
    ! [A19: $tType] :
      ( ( lattice @ A19 )
     => ( bounde4967611905675639751up_bot @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__semilattice__inf__top_295,axiom,
    ! [A19: $tType] :
      ( ( bounded_lattice_top @ A19 )
     => ( bounde4346867609351753570nf_top @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_Ocomplete__linorder,axiom,
    ! [A19: $tType] :
      ( ( comple5582772986160207858norder @ A19 )
     => ( comple5582772986160207858norder @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_Ocomplete__lattice_296,axiom,
    ! [A19: $tType] :
      ( ( comple6319245703460814977attice @ A19 )
     => ( comple6319245703460814977attice @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__lattice__top_297,axiom,
    ! [A19: $tType] :
      ( ( bounded_lattice_top @ A19 )
     => ( bounded_lattice_top @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__lattice__bot_298,axiom,
    ! [A19: $tType] :
      ( ( lattice @ A19 )
     => ( bounded_lattice_bot @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Partial__Order_Occpo_299,axiom,
    ! [A19: $tType] :
      ( ( comple6319245703460814977attice @ A19 )
     => ( comple9053668089753744459l_ccpo @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Osemilattice__sup_300,axiom,
    ! [A19: $tType] :
      ( ( semilattice_sup @ A19 )
     => ( semilattice_sup @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Osemilattice__inf_301,axiom,
    ! [A19: $tType] :
      ( ( semilattice_inf @ A19 )
     => ( semilattice_inf @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Odistrib__lattice_302,axiom,
    ! [A19: $tType] :
      ( ( distrib_lattice @ A19 )
     => ( distrib_lattice @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__lattice_303,axiom,
    ! [A19: $tType] :
      ( ( bounded_lattice_top @ A19 )
     => ( bounded_lattice @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_OSup_304,axiom,
    ! [A19: $tType] :
      ( ( comple6319245703460814977attice @ A19 )
     => ( complete_Sup @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_OInf_305,axiom,
    ! [A19: $tType] :
      ( ( comple6319245703460814977attice @ A19 )
     => ( complete_Inf @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Owellorder_306,axiom,
    ! [A19: $tType] :
      ( ( wellorder @ A19 )
     => ( wellorder @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Oorder__top_307,axiom,
    ! [A19: $tType] :
      ( ( order_top @ A19 )
     => ( order_top @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Oorder__bot_308,axiom,
    ! [A19: $tType] :
      ( ( order @ A19 )
     => ( order_bot @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Countable_Ocountable_309,axiom,
    ! [A19: $tType] :
      ( ( countable @ A19 )
     => ( countable @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Opreorder_310,axiom,
    ! [A19: $tType] :
      ( ( preorder @ A19 )
     => ( preorder @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Olinorder_311,axiom,
    ! [A19: $tType] :
      ( ( linorder @ A19 )
     => ( linorder @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Finite__Set_Ofinite_312,axiom,
    ! [A19: $tType] :
      ( ( finite_finite @ A19 )
     => ( finite_finite @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Olattice_313,axiom,
    ! [A19: $tType] :
      ( ( lattice @ A19 )
     => ( lattice @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Oorder_314,axiom,
    ! [A19: $tType] :
      ( ( order @ A19 )
     => ( order @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Otop_315,axiom,
    ! [A19: $tType] :
      ( ( order_top @ A19 )
     => ( top @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Oord_316,axiom,
    ! [A19: $tType] :
      ( ( preorder @ A19 )
     => ( ord @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Obot_317,axiom,
    ! [A19: $tType] :
      ( ( order @ A19 )
     => ( bot @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Osup_318,axiom,
    ! [A19: $tType] :
      ( ( sup @ A19 )
     => ( sup @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Oinf_319,axiom,
    ! [A19: $tType] :
      ( ( inf @ A19 )
     => ( inf @ ( option @ A19 ) ) ) ).

thf(tcon_Option_Ooption___Heap_Oheap_320,axiom,
    ! [A19: $tType] :
      ( ( heap @ A19 )
     => ( heap @ ( option @ A19 ) ) ) ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__sup__bot_321,axiom,
    bounde4967611905675639751up_bot @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__inf__top_322,axiom,
    bounde4346867609351753570nf_top @ assn ).

thf(tcon_Assertions_Oassn___Boolean__Algebras_Oboolean__algebra_323,axiom,
    boolea8198339166811842893lgebra @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__lattice__top_324,axiom,
    bounded_lattice_top @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__lattice__bot_325,axiom,
    bounded_lattice_bot @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Osemilattice__sup_326,axiom,
    semilattice_sup @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Osemilattice__inf_327,axiom,
    semilattice_inf @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Odistrib__lattice_328,axiom,
    distrib_lattice @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__lattice_329,axiom,
    bounded_lattice @ assn ).

thf(tcon_Assertions_Oassn___Groups_Oab__semigroup__mult_330,axiom,
    ab_semigroup_mult @ assn ).

thf(tcon_Assertions_Oassn___Groups_Ocomm__monoid__mult_331,axiom,
    comm_monoid_mult @ assn ).

thf(tcon_Assertions_Oassn___Groups_Osemigroup__mult_332,axiom,
    semigroup_mult @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Oorder__top_333,axiom,
    order_top @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Oorder__bot_334,axiom,
    order_bot @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Opreorder_335,axiom,
    preorder @ assn ).

thf(tcon_Assertions_Oassn___Groups_Omonoid__mult_336,axiom,
    monoid_mult @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Olattice_337,axiom,
    lattice @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Oorder_338,axiom,
    order @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Otop_339,axiom,
    top @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Oord_340,axiom,
    ord @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Obot_341,axiom,
    bot @ assn ).

thf(tcon_Assertions_Oassn___Groups_Ouminus_342,axiom,
    uminus @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Osup_343,axiom,
    sup @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Oinf_344,axiom,
    inf @ assn ).

thf(tcon_Assertions_Oassn___Groups_Otimes_345,axiom,
    times @ assn ).

thf(tcon_Assertions_Oassn___Groups_Ominus_346,axiom,
    minus @ assn ).

thf(tcon_Assertions_Oassn___Power_Opower_347,axiom,
    power @ assn ).

thf(tcon_Assertions_Oassn___Groups_Oone_348,axiom,
    one @ assn ).

thf(tcon_Assertions_Oassn___Rings_Odvd_349,axiom,
    dvd @ assn ).

thf(tcon_Typerep_Otyperep___Countable_Ocountable_350,axiom,
    countable @ typerep ).

thf(tcon_Typerep_Otyperep___Heap_Oheap_351,axiom,
    heap @ typerep ).

thf(tcon_Multiset_Omultiset___Groups_Oordered__ab__semigroup__add_352,axiom,
    ! [A19: $tType] :
      ( ( preorder @ A19 )
     => ( ordere6658533253407199908up_add @ ( multiset @ A19 ) ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocancel__ab__semigroup__add_353,axiom,
    ! [A19: $tType] : ( cancel2418104881723323429up_add @ ( multiset @ A19 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocancel__comm__monoid__add_354,axiom,
    ! [A19: $tType] : ( cancel1802427076303600483id_add @ ( multiset @ A19 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocancel__semigroup__add_355,axiom,
    ! [A19: $tType] : ( cancel_semigroup_add @ ( multiset @ A19 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__diff_356,axiom,
    ! [A19: $tType] : ( comm_monoid_diff @ ( multiset @ A19 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Oab__semigroup__add_357,axiom,
    ! [A19: $tType] : ( ab_semigroup_add @ ( multiset @ A19 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__add_358,axiom,
    ! [A19: $tType] : ( comm_monoid_add @ ( multiset @ A19 ) ) ).

thf(tcon_Multiset_Omultiset___Complete__Lattices_OSup_359,axiom,
    ! [A19: $tType] : ( complete_Sup @ ( multiset @ A19 ) ) ).

thf(tcon_Multiset_Omultiset___Complete__Lattices_OInf_360,axiom,
    ! [A19: $tType] : ( complete_Inf @ ( multiset @ A19 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Osemigroup__add_361,axiom,
    ! [A19: $tType] : ( semigroup_add @ ( multiset @ A19 ) ) ).

thf(tcon_Multiset_Omultiset___Orderings_Opreorder_362,axiom,
    ! [A19: $tType] :
      ( ( preorder @ A19 )
     => ( preorder @ ( multiset @ A19 ) ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Omonoid__add_363,axiom,
    ! [A19: $tType] : ( monoid_add @ ( multiset @ A19 ) ) ).

thf(tcon_Multiset_Omultiset___Orderings_Oorder_364,axiom,
    ! [A19: $tType] :
      ( ( preorder @ A19 )
     => ( order @ ( multiset @ A19 ) ) ) ).

thf(tcon_Multiset_Omultiset___Orderings_Oord_365,axiom,
    ! [A19: $tType] :
      ( ( preorder @ A19 )
     => ( ord @ ( multiset @ A19 ) ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ominus_366,axiom,
    ! [A19: $tType] : ( minus @ ( multiset @ A19 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ozero_367,axiom,
    ! [A19: $tType] : ( zero @ ( multiset @ A19 ) ) ).

thf(tcon_Product__Type_Oprod___Countable_Ocountable_368,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( ( countable @ A19 )
        & ( countable @ A20 ) )
     => ( countable @ ( product_prod @ A19 @ A20 ) ) ) ).

thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite_369,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( ( finite_finite @ A19 )
        & ( finite_finite @ A20 ) )
     => ( finite_finite @ ( product_prod @ A19 @ A20 ) ) ) ).

thf(tcon_Product__Type_Oprod___Heap_Oheap_370,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( ( heap @ A19 )
        & ( heap @ A20 ) )
     => ( heap @ ( product_prod @ A19 @ A20 ) ) ) ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_371,axiom,
    condit6923001295902523014norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_372,axiom,
    condit1219197933456340205attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_373,axiom,
    comple592849572758109894attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__boolean__algebra_374,axiom,
    comple489889107523837845lgebra @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_375,axiom,
    bounde4967611905675639751up_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_376,axiom,
    bounde4346867609351753570nf_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_377,axiom,
    comple5582772986160207858norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_378,axiom,
    comple6319245703460814977attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_379,axiom,
    boolea8198339166811842893lgebra @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__top_380,axiom,
    bounded_lattice_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__bot_381,axiom,
    bounded_lattice_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Partial__Order_Occpo_382,axiom,
    comple9053668089753744459l_ccpo @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_383,axiom,
    semilattice_sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_384,axiom,
    semilattice_inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Odistrib__lattice_385,axiom,
    distrib_lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice_386,axiom,
    bounded_lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_OSup_387,axiom,
    complete_Sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_OInf_388,axiom,
    complete_Inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Owellorder_389,axiom,
    wellorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__top_390,axiom,
    order_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__bot_391,axiom,
    order_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Countable_Ocountable_392,axiom,
    countable @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Opreorder_393,axiom,
    preorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Olinorder_394,axiom,
    linorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Finite__Set_Ofinite_395,axiom,
    finite_finite @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Olattice_396,axiom,
    lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder_397,axiom,
    order @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Otop_398,axiom,
    top @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oord_399,axiom,
    ord @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Obot_400,axiom,
    bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ouminus_401,axiom,
    uminus @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osup_402,axiom,
    sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Oinf_403,axiom,
    inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ominus_404,axiom,
    minus @ product_unit ).

thf(tcon_Product__Type_Ounit___Heap_Oheap_405,axiom,
    heap @ product_unit ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_406,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_407,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_408,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_409,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_410,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_411,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_412,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_413,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_414,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_415,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_416,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_417,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_418,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_419,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_420,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_421,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_422,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_423,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_424,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_425,axiom,
    linord4140545234300271783up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_426,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_427,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_428,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_429,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_430,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_431,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_432,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_433,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_434,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_435,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_436,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_437,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_438,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_439,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_440,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_441,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_442,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_443,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_444,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_445,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_446,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_447,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_448,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_449,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_450,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_451,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_452,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_453,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_454,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_455,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_456,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_457,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_458,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_459,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_460,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_461,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_462,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_463,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_464,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_465,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_466,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_467,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_468,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_469,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_470,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_471,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_472,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_473,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_474,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_475,axiom,
    idom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_476,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_477,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_478,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_479,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_480,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_481,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_482,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_483,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_484,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_485,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_486,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_487,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_488,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_489,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_490,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_491,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Otimes_492,axiom,
    times @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ominus_493,axiom,
    minus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_494,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_495,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_496,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_497,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_498,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_499,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_500,axiom,
    dvd @ code_integer ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_501,axiom,
    bit_un5681908812861735899ations @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring__with__nat_502,axiom,
    euclid5411537665997757685th_nat @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__monoid__add__imp__le_503,axiom,
    ordere1937475149494474687imp_le @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring_504,axiom,
    euclid3128863361964157862miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring__cancel_505,axiom,
    euclid4440199948858584721cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors__cancel_506,axiom,
    semiri6575147826004484403cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__ab__semigroup__add_507,axiom,
    strict9044650504122735259up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__ab__semigroup__add_508,axiom,
    ordere580206878836729694up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add__imp__le_509,axiom,
    ordere2412721322843649153imp_le @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bit__operations_510,axiom,
    bit_se359711467146920520ations @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__comm__semiring__strict_511,axiom,
    linord2810124833399127020strict @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__comm__monoid__add_512,axiom,
    strict7427464778891057005id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__comm__monoid__add_513,axiom,
    ordere8940638589300402666id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring_514,axiom,
    euclid3725896446679973847miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Olinordered__ab__semigroup__add_515,axiom,
    linord4140545234300271783up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__nonzero__semiring_516,axiom,
    linord181362715937106298miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring__strict_517,axiom,
    linord8928482502909563296strict @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors_518,axiom,
    semiri3467727345109120633visors @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_519,axiom,
    ordere6658533253407199908up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__comm__monoid__add_520,axiom,
    ordere6911136660526730532id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__ab__semigroup__add_521,axiom,
    cancel2418104881723323429up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_522,axiom,
    cancel1802427076303600483id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1__cancel_523,axiom,
    comm_s4317794764714335236cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bits_524,axiom,
    bit_semiring_bits @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__comm__semiring_525,axiom,
    ordere2520102378445227354miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_526,axiom,
    cancel_semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring_527,axiom,
    linordered_semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring__0_528,axiom,
    ordered_semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semidom_529,axiom,
    linordered_semidom @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__mult_530,axiom,
    ab_semigroup_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oalgebraic__semidom_531,axiom,
    algebraic_semidom @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__mult_532,axiom,
    comm_monoid_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__diff_533,axiom,
    comm_monoid_diff @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_534,axiom,
    ab_semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring_535,axiom,
    ordered_semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Parity_Osemiring__parity_536,axiom,
    semiring_parity @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_537,axiom,
    comm_monoid_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__modulo_538,axiom,
    semiring_modulo @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_539,axiom,
    comm_semiring_1 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__0_540,axiom,
    comm_semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__mult_541,axiom,
    semigroup_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemidom__modulo_542,axiom,
    semidom_modulo @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemidom__divide_543,axiom,
    semidom_divide @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Num_Osemiring__numeral_544,axiom,
    semiring_numeral @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_545,axiom,
    semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ozero__less__one_546,axiom,
    zero_less_one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring_547,axiom,
    comm_semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Nat_Osemiring__char__0_548,axiom,
    semiring_char_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ozero__neq__one_549,axiom,
    zero_neq_one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Opreorder_550,axiom,
    preorder @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Olinorder_551,axiom,
    linorder @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__mult_552,axiom,
    monoid_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_553,axiom,
    monoid_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__1_554,axiom,
    semiring_1 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__0_555,axiom,
    semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Omult__zero_556,axiom,
    mult_zero @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Oorder_557,axiom,
    order @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring_558,axiom,
    semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Oord_559,axiom,
    ord @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Otimes_560,axiom,
    times @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ominus_561,axiom,
    minus @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Power_Opower_562,axiom,
    power @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Num_Onumeral_563,axiom,
    numeral @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ozero_564,axiom,
    zero @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oone_565,axiom,
    one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Odvd_566,axiom,
    dvd @ code_natural ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X3: A,Y: A] :
      ( ( if @ A @ $false @ X3 @ Y )
      = Y ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X3: A,Y: A] :
      ( ( if @ A @ $true @ X3 @ Y )
      = X3 ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X7: A] : ( P @ X7 ) ) ) ).

% Conjectures (4)
thf(conj_0,hypothesis,
    entails @ p @ ( times_times @ assn @ p2 @ ( top_top @ assn ) ) ).

thf(conj_1,hypothesis,
    ! [X4: a] : ( entails @ ( q @ X4 ) @ ( times_times @ assn @ ( q2 @ X4 ) @ ( top_top @ assn ) ) ) ).

thf(conj_2,hypothesis,
    ( hoare_hoare_triple @ a @ p2 @ c
    @ ^ [R3: a] : ( times_times @ assn @ ( q @ R3 ) @ ( top_top @ assn ) ) ) ).

thf(conj_3,conjecture,
    entails @ p @ p_0_ATP ).

%------------------------------------------------------------------------------
