%------------------------------------------------------------------------------
% File     : VBT00009_2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem Hoare_Triple 00195_005707
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0025_Hoare_Triple_00195_005707 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 10695 (2532 unt;2397 typ;   0 def)
%            Number of atoms       : 21171 (6979 equ)
%            Maximal formula atoms :   38 (   2 avg)
%            Number of connectives : 14494 (1621   ~; 193   |;1318   &)
%                                         (1743 <=>;9619  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   31 (   6 avg)
%            Maximal term depth    :   40 (   2 avg)
%            Number of types       :   13 (  12 usr)
%            Number of type conns  : 2294 (1809   >; 485   *;   0   +;   0  <<)
%            Number of predicates  :  296 ( 293 usr;   2 prp; 0-9 aty)
%            Number of functors    : 2092 (2092 usr;  55 con; 0-8 aty)
%            Number of variables   : 32777 (28419   !; 427   ?;32777   :)
%                                         (3931  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TF1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 15:24:28.114
%------------------------------------------------------------------------------
% Could-be-implicit typings (26)
tff(ty_t_Heap__Time__Monad_OHeap,type,
    heap_Time_Heap: $tType > $tType ).

tff(ty_t_Code__Numeral_Onatural,type,
    code_natural: $tType ).

tff(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

tff(ty_t_Heap_Oheap_Oheap__ext,type,
    heap_ext: $tType > $tType ).

tff(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

tff(ty_t_Product__Type_Oprod,type,
    product_prod: ( $tType * $tType ) > $tType ).

tff(ty_t_Old__Datatype_Onode,type,
    old_node: ( $tType * $tType ) > $tType ).

tff(ty_t_Multiset_Omultiset,type,
    multiset: $tType > $tType ).

tff(ty_t_Typerep_Otyperep,type,
    typerep: $tType ).

tff(ty_t_Assertions_Oassn,type,
    assn: $tType ).

tff(ty_t_Sum__Type_Osum,type,
    sum_sum: ( $tType * $tType ) > $tType ).

tff(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

tff(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

tff(ty_t_String_Ochar,type,
    char: $tType ).

tff(ty_t_Heap_Oarray,type,
    array: $tType > $tType ).

tff(ty_t_List_Olist,type,
    list: $tType > $tType ).

tff(ty_t_Heap_Oref,type,
    ref: $tType > $tType ).

tff(ty_t_HOL_Obool,type,
    bool: $tType ).

tff(ty_t_Set_Oset,type,
    set: $tType > $tType ).

tff(ty_t_Rat_Orat,type,
    rat: $tType ).

tff(ty_t_Num_Onum,type,
    num: $tType ).

tff(ty_t_Nat_Onat,type,
    nat: $tType ).

tff(ty_t_Int_Oint,type,
    int: $tType ).

tff(ty_t_itself,type,
    itself: $tType > $tType ).

tff(ty_t_fun,type,
    fun: ( $tType * $tType ) > $tType ).

tff(ty_tf_a,type,
    a: $tType ).

% Explicit typings (2371)
tff(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

tff(sy_cl_Heap_Oheap,type,
    heap: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Otimes,type,
    times: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Oinf,type,
    inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osup,type,
    sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Obot,type,
    bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Otop,type,
    top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Countable_Ocountable,type,
    countable: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Ofinite__lattice,type,
    finite_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_OInf,type,
    complete_Inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_OSup,type,
    complete_Sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Partial__Order_Occpo,type,
    comple9053668089753744459l_ccpo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Onormalization__semidom,type,
    normal8620421768224518004emidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice__bot,type,
    bounded_lattice_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice__top,type,
    bounded_lattice_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide__unit__factor,type,
    semido2269285787275462019factor: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__boolean__algebra,type,
    comple489889107523837845lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Onormalization__semidom__multiplicative,type,
    normal6328177297339901930cative: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

tff(sy_c_ATP_058Lamp__a____,type,
    aTP_Lamp_a: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aa____,type,
    aTP_Lamp_aa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaa____,type,
    aTP_Lamp_aaa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aab____,type,
    aTP_Lamp_aab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aac____,type,
    aTP_Lamp_aac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aad____,type,
    aTP_Lamp_aad: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aae____,type,
    aTP_Lamp_aae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaf____,type,
    aTP_Lamp_aaf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aag____,type,
    aTP_Lamp_aag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aah____,type,
    aTP_Lamp_aah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aai____,type,
    aTP_Lamp_aai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaj____,type,
    aTP_Lamp_aaj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aak____,type,
    aTP_Lamp_aak: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aal____,type,
    aTP_Lamp_aal: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aam____,type,
    aTP_Lamp_aam: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aan____,type,
    aTP_Lamp_aan: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aao____,type,
    aTP_Lamp_aao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aap____,type,
    aTP_Lamp_aap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaq____,type,
    aTP_Lamp_aaq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aar____,type,
    aTP_Lamp_aar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aas____,type,
    aTP_Lamp_aas: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aat____,type,
    aTP_Lamp_aat: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aau____,type,
    aTP_Lamp_aau: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aav____,type,
    aTP_Lamp_aav: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaw____,type,
    aTP_Lamp_aaw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aax____,type,
    aTP_Lamp_aax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aay____,type,
    aTP_Lamp_aay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaz____,type,
    aTP_Lamp_aaz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ab____,type,
    aTP_Lamp_ab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aba____,type,
    aTP_Lamp_aba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abb____,type,
    aTP_Lamp_abb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abc____,type,
    aTP_Lamp_abc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abd____,type,
    aTP_Lamp_abd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abe____,type,
    aTP_Lamp_abe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abf____,type,
    aTP_Lamp_abf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abg____,type,
    aTP_Lamp_abg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abh____,type,
    aTP_Lamp_abh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abi____,type,
    aTP_Lamp_abi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abj____,type,
    aTP_Lamp_abj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abk____,type,
    aTP_Lamp_abk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abl____,type,
    aTP_Lamp_abl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abm____,type,
    aTP_Lamp_abm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abn____,type,
    aTP_Lamp_abn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abo____,type,
    aTP_Lamp_abo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abp____,type,
    aTP_Lamp_abp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abq____,type,
    aTP_Lamp_abq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abr____,type,
    aTP_Lamp_abr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abs____,type,
    aTP_Lamp_abs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abt____,type,
    aTP_Lamp_abt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abu____,type,
    aTP_Lamp_abu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abv____,type,
    aTP_Lamp_abv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abw____,type,
    aTP_Lamp_abw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abx____,type,
    aTP_Lamp_abx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aby____,type,
    aTP_Lamp_aby: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abz____,type,
    aTP_Lamp_abz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ac____,type,
    aTP_Lamp_ac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aca____,type,
    aTP_Lamp_aca: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acb____,type,
    aTP_Lamp_acb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acc____,type,
    aTP_Lamp_acc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acd____,type,
    aTP_Lamp_acd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ace____,type,
    aTP_Lamp_ace: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acf____,type,
    aTP_Lamp_acf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acg____,type,
    aTP_Lamp_acg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ach____,type,
    aTP_Lamp_ach: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aci____,type,
    aTP_Lamp_aci: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acj____,type,
    aTP_Lamp_acj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ack____,type,
    aTP_Lamp_ack: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acl____,type,
    aTP_Lamp_acl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acm____,type,
    aTP_Lamp_acm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acn____,type,
    aTP_Lamp_acn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aco____,type,
    aTP_Lamp_aco: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acp____,type,
    aTP_Lamp_acp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acq____,type,
    aTP_Lamp_acq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acr____,type,
    aTP_Lamp_acr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acs____,type,
    aTP_Lamp_acs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__act____,type,
    aTP_Lamp_act: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acu____,type,
    aTP_Lamp_acu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acv____,type,
    aTP_Lamp_acv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acw____,type,
    aTP_Lamp_acw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acx____,type,
    aTP_Lamp_acx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acy____,type,
    aTP_Lamp_acy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acz____,type,
    aTP_Lamp_acz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ad____,type,
    aTP_Lamp_ad: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ada____,type,
    aTP_Lamp_ada: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adb____,type,
    aTP_Lamp_adb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adc____,type,
    aTP_Lamp_adc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__add____,type,
    aTP_Lamp_add: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ade____,type,
    aTP_Lamp_ade: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adf____,type,
    aTP_Lamp_adf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adg____,type,
    aTP_Lamp_adg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adh____,type,
    aTP_Lamp_adh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adi____,type,
    aTP_Lamp_adi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adj____,type,
    aTP_Lamp_adj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adk____,type,
    aTP_Lamp_adk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adl____,type,
    aTP_Lamp_adl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adm____,type,
    aTP_Lamp_adm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adn____,type,
    aTP_Lamp_adn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ado____,type,
    aTP_Lamp_ado: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adp____,type,
    aTP_Lamp_adp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adq____,type,
    aTP_Lamp_adq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adr____,type,
    aTP_Lamp_adr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ads____,type,
    aTP_Lamp_ads: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adt____,type,
    aTP_Lamp_adt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adu____,type,
    aTP_Lamp_adu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adv____,type,
    aTP_Lamp_adv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adw____,type,
    aTP_Lamp_adw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adx____,type,
    aTP_Lamp_adx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ady____,type,
    aTP_Lamp_ady: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adz____,type,
    aTP_Lamp_adz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ae____,type,
    aTP_Lamp_ae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aea____,type,
    aTP_Lamp_aea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeb____,type,
    aTP_Lamp_aeb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aec____,type,
    aTP_Lamp_aec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aed____,type,
    aTP_Lamp_aed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aee____,type,
    aTP_Lamp_aee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aef____,type,
    aTP_Lamp_aef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeg____,type,
    aTP_Lamp_aeg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeh____,type,
    aTP_Lamp_aeh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aei____,type,
    aTP_Lamp_aei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aej____,type,
    aTP_Lamp_aej: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aek____,type,
    aTP_Lamp_aek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ael____,type,
    aTP_Lamp_ael: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aem____,type,
    aTP_Lamp_aem: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aen____,type,
    aTP_Lamp_aen: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeo____,type,
    aTP_Lamp_aeo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aep____,type,
    aTP_Lamp_aep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeq____,type,
    aTP_Lamp_aeq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aer____,type,
    aTP_Lamp_aer: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aes____,type,
    aTP_Lamp_aes: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aet____,type,
    aTP_Lamp_aet: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeu____,type,
    aTP_Lamp_aeu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aev____,type,
    aTP_Lamp_aev: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aew____,type,
    aTP_Lamp_aew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aex____,type,
    aTP_Lamp_aex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aey____,type,
    aTP_Lamp_aey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aez____,type,
    aTP_Lamp_aez: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__af____,type,
    aTP_Lamp_af: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afa____,type,
    aTP_Lamp_afa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afb____,type,
    aTP_Lamp_afb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afc____,type,
    aTP_Lamp_afc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afd____,type,
    aTP_Lamp_afd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afe____,type,
    aTP_Lamp_afe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aff____,type,
    aTP_Lamp_aff: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afg____,type,
    aTP_Lamp_afg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afh____,type,
    aTP_Lamp_afh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afi____,type,
    aTP_Lamp_afi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afj____,type,
    aTP_Lamp_afj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afk____,type,
    aTP_Lamp_afk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afl____,type,
    aTP_Lamp_afl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afm____,type,
    aTP_Lamp_afm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afn____,type,
    aTP_Lamp_afn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afo____,type,
    aTP_Lamp_afo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afp____,type,
    aTP_Lamp_afp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afq____,type,
    aTP_Lamp_afq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afr____,type,
    aTP_Lamp_afr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afs____,type,
    aTP_Lamp_afs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aft____,type,
    aTP_Lamp_aft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afu____,type,
    aTP_Lamp_afu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afv____,type,
    aTP_Lamp_afv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afw____,type,
    aTP_Lamp_afw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afx____,type,
    aTP_Lamp_afx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afy____,type,
    aTP_Lamp_afy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afz____,type,
    aTP_Lamp_afz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ag____,type,
    aTP_Lamp_ag: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aga____,type,
    aTP_Lamp_aga: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agb____,type,
    aTP_Lamp_agb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agc____,type,
    aTP_Lamp_agc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agd____,type,
    aTP_Lamp_agd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__age____,type,
    aTP_Lamp_age: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agf____,type,
    aTP_Lamp_agf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agg____,type,
    aTP_Lamp_agg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agh____,type,
    aTP_Lamp_agh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agi____,type,
    aTP_Lamp_agi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agj____,type,
    aTP_Lamp_agj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agk____,type,
    aTP_Lamp_agk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agl____,type,
    aTP_Lamp_agl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agm____,type,
    aTP_Lamp_agm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agn____,type,
    aTP_Lamp_agn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ago____,type,
    aTP_Lamp_ago: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agp____,type,
    aTP_Lamp_agp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agq____,type,
    aTP_Lamp_agq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agr____,type,
    aTP_Lamp_agr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ags____,type,
    aTP_Lamp_ags: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agt____,type,
    aTP_Lamp_agt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agu____,type,
    aTP_Lamp_agu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agv____,type,
    aTP_Lamp_agv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agw____,type,
    aTP_Lamp_agw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agx____,type,
    aTP_Lamp_agx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agy____,type,
    aTP_Lamp_agy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agz____,type,
    aTP_Lamp_agz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ah____,type,
    aTP_Lamp_ah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aha____,type,
    aTP_Lamp_aha: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahb____,type,
    aTP_Lamp_ahb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahc____,type,
    aTP_Lamp_ahc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahd____,type,
    aTP_Lamp_ahd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahe____,type,
    aTP_Lamp_ahe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahf____,type,
    aTP_Lamp_ahf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahg____,type,
    aTP_Lamp_ahg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahh____,type,
    aTP_Lamp_ahh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahi____,type,
    aTP_Lamp_ahi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahj____,type,
    aTP_Lamp_ahj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahk____,type,
    aTP_Lamp_ahk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahl____,type,
    aTP_Lamp_ahl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahm____,type,
    aTP_Lamp_ahm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahn____,type,
    aTP_Lamp_ahn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aho____,type,
    aTP_Lamp_aho: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahp____,type,
    aTP_Lamp_ahp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahq____,type,
    aTP_Lamp_ahq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahr____,type,
    aTP_Lamp_ahr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahs____,type,
    aTP_Lamp_ahs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aht____,type,
    aTP_Lamp_aht: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahu____,type,
    aTP_Lamp_ahu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahv____,type,
    aTP_Lamp_ahv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahw____,type,
    aTP_Lamp_ahw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahx____,type,
    aTP_Lamp_ahx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahy____,type,
    aTP_Lamp_ahy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahz____,type,
    aTP_Lamp_ahz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ai____,type,
    aTP_Lamp_ai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aia____,type,
    aTP_Lamp_aia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aib____,type,
    aTP_Lamp_aib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aic____,type,
    aTP_Lamp_aic: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aid____,type,
    aTP_Lamp_aid: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aie____,type,
    aTP_Lamp_aie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aif____,type,
    aTP_Lamp_aif: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aig____,type,
    aTP_Lamp_aig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aih____,type,
    aTP_Lamp_aih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aii____,type,
    aTP_Lamp_aii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aij____,type,
    aTP_Lamp_aij: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aik____,type,
    aTP_Lamp_aik: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ail____,type,
    aTP_Lamp_ail: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aim____,type,
    aTP_Lamp_aim: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ain____,type,
    aTP_Lamp_ain: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aio____,type,
    aTP_Lamp_aio: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aip____,type,
    aTP_Lamp_aip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiq____,type,
    aTP_Lamp_aiq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__air____,type,
    aTP_Lamp_air: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ais____,type,
    aTP_Lamp_ais: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ait____,type,
    aTP_Lamp_ait: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiu____,type,
    aTP_Lamp_aiu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiv____,type,
    aTP_Lamp_aiv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiw____,type,
    aTP_Lamp_aiw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aix____,type,
    aTP_Lamp_aix: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aiy____,type,
    aTP_Lamp_aiy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aiz____,type,
    aTP_Lamp_aiz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aj____,type,
    aTP_Lamp_aj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aja____,type,
    aTP_Lamp_aja: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajb____,type,
    aTP_Lamp_ajb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajc____,type,
    aTP_Lamp_ajc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajd____,type,
    aTP_Lamp_ajd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aje____,type,
    aTP_Lamp_aje: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajf____,type,
    aTP_Lamp_ajf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajg____,type,
    aTP_Lamp_ajg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajh____,type,
    aTP_Lamp_ajh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aji____,type,
    aTP_Lamp_aji: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajj____,type,
    aTP_Lamp_ajj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajk____,type,
    aTP_Lamp_ajk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajl____,type,
    aTP_Lamp_ajl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajm____,type,
    aTP_Lamp_ajm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajn____,type,
    aTP_Lamp_ajn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajo____,type,
    aTP_Lamp_ajo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajp____,type,
    aTP_Lamp_ajp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajq____,type,
    aTP_Lamp_ajq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajr____,type,
    aTP_Lamp_ajr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajs____,type,
    aTP_Lamp_ajs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajt____,type,
    aTP_Lamp_ajt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aju____,type,
    aTP_Lamp_aju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajv____,type,
    aTP_Lamp_ajv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajw____,type,
    aTP_Lamp_ajw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajx____,type,
    aTP_Lamp_ajx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajy____,type,
    aTP_Lamp_ajy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajz____,type,
    aTP_Lamp_ajz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ak____,type,
    aTP_Lamp_ak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aka____,type,
    aTP_Lamp_aka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akb____,type,
    aTP_Lamp_akb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akc____,type,
    aTP_Lamp_akc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akd____,type,
    aTP_Lamp_akd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ake____,type,
    aTP_Lamp_ake: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akf____,type,
    aTP_Lamp_akf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akg____,type,
    aTP_Lamp_akg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akh____,type,
    aTP_Lamp_akh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aki____,type,
    aTP_Lamp_aki: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akj____,type,
    aTP_Lamp_akj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akk____,type,
    aTP_Lamp_akk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akl____,type,
    aTP_Lamp_akl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akm____,type,
    aTP_Lamp_akm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akn____,type,
    aTP_Lamp_akn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ako____,type,
    aTP_Lamp_ako: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akp____,type,
    aTP_Lamp_akp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akq____,type,
    aTP_Lamp_akq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akr____,type,
    aTP_Lamp_akr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aks____,type,
    aTP_Lamp_aks: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akt____,type,
    aTP_Lamp_akt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aku____,type,
    aTP_Lamp_aku: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akv____,type,
    aTP_Lamp_akv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akw____,type,
    aTP_Lamp_akw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akx____,type,
    aTP_Lamp_akx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aky____,type,
    aTP_Lamp_aky: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__akz____,type,
    aTP_Lamp_akz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__al____,type,
    aTP_Lamp_al: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ala____,type,
    aTP_Lamp_ala: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alb____,type,
    aTP_Lamp_alb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alc____,type,
    aTP_Lamp_alc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ald____,type,
    aTP_Lamp_ald: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ale____,type,
    aTP_Lamp_ale: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__alf____,type,
    aTP_Lamp_alf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alg____,type,
    aTP_Lamp_alg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__alh____,type,
    aTP_Lamp_alh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ali____,type,
    aTP_Lamp_ali: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alj____,type,
    aTP_Lamp_alj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alk____,type,
    aTP_Lamp_alk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__all____,type,
    aTP_Lamp_all: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__alm____,type,
    aTP_Lamp_alm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aln____,type,
    aTP_Lamp_aln: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alo____,type,
    aTP_Lamp_alo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alp____,type,
    aTP_Lamp_alp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alq____,type,
    aTP_Lamp_alq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alr____,type,
    aTP_Lamp_alr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__als____,type,
    aTP_Lamp_als: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alt____,type,
    aTP_Lamp_alt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alu____,type,
    aTP_Lamp_alu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alv____,type,
    aTP_Lamp_alv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alw____,type,
    aTP_Lamp_alw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alx____,type,
    aTP_Lamp_alx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aly____,type,
    aTP_Lamp_aly: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__alz____,type,
    aTP_Lamp_alz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__am____,type,
    aTP_Lamp_am: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ama____,type,
    aTP_Lamp_ama: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amb____,type,
    aTP_Lamp_amb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amc____,type,
    aTP_Lamp_amc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amd____,type,
    aTP_Lamp_amd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ame____,type,
    aTP_Lamp_ame: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amf____,type,
    aTP_Lamp_amf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amg____,type,
    aTP_Lamp_amg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amh____,type,
    aTP_Lamp_amh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ami____,type,
    aTP_Lamp_ami: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amj____,type,
    aTP_Lamp_amj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amk____,type,
    aTP_Lamp_amk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aml____,type,
    aTP_Lamp_aml: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amm____,type,
    aTP_Lamp_amm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amn____,type,
    aTP_Lamp_amn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amo____,type,
    aTP_Lamp_amo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amp____,type,
    aTP_Lamp_amp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amq____,type,
    aTP_Lamp_amq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amr____,type,
    aTP_Lamp_amr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ams____,type,
    aTP_Lamp_ams: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amt____,type,
    aTP_Lamp_amt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amu____,type,
    aTP_Lamp_amu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amv____,type,
    aTP_Lamp_amv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amw____,type,
    aTP_Lamp_amw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amx____,type,
    aTP_Lamp_amx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amy____,type,
    aTP_Lamp_amy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amz____,type,
    aTP_Lamp_amz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__an____,type,
    aTP_Lamp_an: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ana____,type,
    aTP_Lamp_ana: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anb____,type,
    aTP_Lamp_anb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anc____,type,
    aTP_Lamp_anc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__and____,type,
    aTP_Lamp_and: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ane____,type,
    aTP_Lamp_ane: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anf____,type,
    aTP_Lamp_anf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ang____,type,
    aTP_Lamp_ang: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anh____,type,
    aTP_Lamp_anh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ani____,type,
    aTP_Lamp_ani: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anj____,type,
    aTP_Lamp_anj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ank____,type,
    aTP_Lamp_ank: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anl____,type,
    aTP_Lamp_anl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anm____,type,
    aTP_Lamp_anm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ann____,type,
    aTP_Lamp_ann: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ano____,type,
    aTP_Lamp_ano: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anp____,type,
    aTP_Lamp_anp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anq____,type,
    aTP_Lamp_anq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anr____,type,
    aTP_Lamp_anr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ans____,type,
    aTP_Lamp_ans: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ant____,type,
    aTP_Lamp_ant: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anu____,type,
    aTP_Lamp_anu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anv____,type,
    aTP_Lamp_anv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anw____,type,
    aTP_Lamp_anw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anx____,type,
    aTP_Lamp_anx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__any____,type,
    aTP_Lamp_any: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anz____,type,
    aTP_Lamp_anz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ao____,type,
    aTP_Lamp_ao: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aoa____,type,
    aTP_Lamp_aoa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aob____,type,
    aTP_Lamp_aob: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoc____,type,
    aTP_Lamp_aoc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aod____,type,
    aTP_Lamp_aod: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoe____,type,
    aTP_Lamp_aoe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aof____,type,
    aTP_Lamp_aof: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aog____,type,
    aTP_Lamp_aog: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoh____,type,
    aTP_Lamp_aoh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoi____,type,
    aTP_Lamp_aoi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aoj____,type,
    aTP_Lamp_aoj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aok____,type,
    aTP_Lamp_aok: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aol____,type,
    aTP_Lamp_aol: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aom____,type,
    aTP_Lamp_aom: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aon____,type,
    aTP_Lamp_aon: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoo____,type,
    aTP_Lamp_aoo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aop____,type,
    aTP_Lamp_aop: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoq____,type,
    aTP_Lamp_aoq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aor____,type,
    aTP_Lamp_aor: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aos____,type,
    aTP_Lamp_aos: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aot____,type,
    aTP_Lamp_aot: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aou____,type,
    aTP_Lamp_aou: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aov____,type,
    aTP_Lamp_aov: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aow____,type,
    aTP_Lamp_aow: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aox____,type,
    aTP_Lamp_aox: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoy____,type,
    aTP_Lamp_aoy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoz____,type,
    aTP_Lamp_aoz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ap____,type,
    aTP_Lamp_ap: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apa____,type,
    aTP_Lamp_apa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apb____,type,
    aTP_Lamp_apb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apc____,type,
    aTP_Lamp_apc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apd____,type,
    aTP_Lamp_apd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ape____,type,
    aTP_Lamp_ape: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apf____,type,
    aTP_Lamp_apf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apg____,type,
    aTP_Lamp_apg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aph____,type,
    aTP_Lamp_aph: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__api____,type,
    aTP_Lamp_api: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apj____,type,
    aTP_Lamp_apj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apk____,type,
    aTP_Lamp_apk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apl____,type,
    aTP_Lamp_apl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apm____,type,
    aTP_Lamp_apm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apn____,type,
    aTP_Lamp_apn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apo____,type,
    aTP_Lamp_apo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__app____,type,
    aTP_Lamp_app: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apq____,type,
    aTP_Lamp_apq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apr____,type,
    aTP_Lamp_apr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aps____,type,
    aTP_Lamp_aps: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apt____,type,
    aTP_Lamp_apt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apu____,type,
    aTP_Lamp_apu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apv____,type,
    aTP_Lamp_apv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apw____,type,
    aTP_Lamp_apw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apx____,type,
    aTP_Lamp_apx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apy____,type,
    aTP_Lamp_apy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apz____,type,
    aTP_Lamp_apz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aq____,type,
    aTP_Lamp_aq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqa____,type,
    aTP_Lamp_aqa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqb____,type,
    aTP_Lamp_aqb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqc____,type,
    aTP_Lamp_aqc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqd____,type,
    aTP_Lamp_aqd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqe____,type,
    aTP_Lamp_aqe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqf____,type,
    aTP_Lamp_aqf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqg____,type,
    aTP_Lamp_aqg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqh____,type,
    aTP_Lamp_aqh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqi____,type,
    aTP_Lamp_aqi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqj____,type,
    aTP_Lamp_aqj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqk____,type,
    aTP_Lamp_aqk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aql____,type,
    aTP_Lamp_aql: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqm____,type,
    aTP_Lamp_aqm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqn____,type,
    aTP_Lamp_aqn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqo____,type,
    aTP_Lamp_aqo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqp____,type,
    aTP_Lamp_aqp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqq____,type,
    aTP_Lamp_aqq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqr____,type,
    aTP_Lamp_aqr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqs____,type,
    aTP_Lamp_aqs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqt____,type,
    aTP_Lamp_aqt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqu____,type,
    aTP_Lamp_aqu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqv____,type,
    aTP_Lamp_aqv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqw____,type,
    aTP_Lamp_aqw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqx____,type,
    aTP_Lamp_aqx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqy____,type,
    aTP_Lamp_aqy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqz____,type,
    aTP_Lamp_aqz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ar____,type,
    aTP_Lamp_ar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ara____,type,
    aTP_Lamp_ara: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arb____,type,
    aTP_Lamp_arb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arc____,type,
    aTP_Lamp_arc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ard____,type,
    aTP_Lamp_ard: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__are____,type,
    aTP_Lamp_are: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arf____,type,
    aTP_Lamp_arf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arg____,type,
    aTP_Lamp_arg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arh____,type,
    aTP_Lamp_arh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ari____,type,
    aTP_Lamp_ari: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arj____,type,
    aTP_Lamp_arj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ark____,type,
    aTP_Lamp_ark: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arl____,type,
    aTP_Lamp_arl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arm____,type,
    aTP_Lamp_arm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arn____,type,
    aTP_Lamp_arn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aro____,type,
    aTP_Lamp_aro: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__arp____,type,
    aTP_Lamp_arp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arq____,type,
    aTP_Lamp_arq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arr____,type,
    aTP_Lamp_arr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ars____,type,
    aTP_Lamp_ars: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__art____,type,
    aTP_Lamp_art: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aru____,type,
    aTP_Lamp_aru: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arv____,type,
    aTP_Lamp_arv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__arw____,type,
    aTP_Lamp_arw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arx____,type,
    aTP_Lamp_arx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ary____,type,
    aTP_Lamp_ary: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arz____,type,
    aTP_Lamp_arz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__as____,type,
    aTP_Lamp_as: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asa____,type,
    aTP_Lamp_asa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asb____,type,
    aTP_Lamp_asb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asc____,type,
    aTP_Lamp_asc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asd____,type,
    aTP_Lamp_asd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ase____,type,
    aTP_Lamp_ase: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asf____,type,
    aTP_Lamp_asf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asg____,type,
    aTP_Lamp_asg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ash____,type,
    aTP_Lamp_ash: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asi____,type,
    aTP_Lamp_asi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asj____,type,
    aTP_Lamp_asj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ask____,type,
    aTP_Lamp_ask: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asl____,type,
    aTP_Lamp_asl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asm____,type,
    aTP_Lamp_asm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asn____,type,
    aTP_Lamp_asn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aso____,type,
    aTP_Lamp_aso: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asp____,type,
    aTP_Lamp_asp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asq____,type,
    aTP_Lamp_asq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asr____,type,
    aTP_Lamp_asr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ass____,type,
    aTP_Lamp_ass: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ast____,type,
    aTP_Lamp_ast: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asu____,type,
    aTP_Lamp_asu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asv____,type,
    aTP_Lamp_asv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asw____,type,
    aTP_Lamp_asw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asx____,type,
    aTP_Lamp_asx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asy____,type,
    aTP_Lamp_asy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asz____,type,
    aTP_Lamp_asz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__at____,type,
    aTP_Lamp_at: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ata____,type,
    aTP_Lamp_ata: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atb____,type,
    aTP_Lamp_atb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atc____,type,
    aTP_Lamp_atc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atd____,type,
    aTP_Lamp_atd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ate____,type,
    aTP_Lamp_ate: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atf____,type,
    aTP_Lamp_atf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atg____,type,
    aTP_Lamp_atg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ath____,type,
    aTP_Lamp_ath: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ati____,type,
    aTP_Lamp_ati: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atj____,type,
    aTP_Lamp_atj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atk____,type,
    aTP_Lamp_atk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atl____,type,
    aTP_Lamp_atl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atm____,type,
    aTP_Lamp_atm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atn____,type,
    aTP_Lamp_atn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ato____,type,
    aTP_Lamp_ato: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atp____,type,
    aTP_Lamp_atp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atq____,type,
    aTP_Lamp_atq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atr____,type,
    aTP_Lamp_atr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ats____,type,
    aTP_Lamp_ats: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__att____,type,
    aTP_Lamp_att: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atu____,type,
    aTP_Lamp_atu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atv____,type,
    aTP_Lamp_atv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atw____,type,
    aTP_Lamp_atw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atx____,type,
    aTP_Lamp_atx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aty____,type,
    aTP_Lamp_aty: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atz____,type,
    aTP_Lamp_atz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__au____,type,
    aTP_Lamp_au: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aua____,type,
    aTP_Lamp_aua: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aub____,type,
    aTP_Lamp_aub: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auc____,type,
    aTP_Lamp_auc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aud____,type,
    aTP_Lamp_aud: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aue____,type,
    aTP_Lamp_aue: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__auf____,type,
    aTP_Lamp_auf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aug____,type,
    aTP_Lamp_aug: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__auh____,type,
    aTP_Lamp_auh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aui____,type,
    aTP_Lamp_aui: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auj____,type,
    aTP_Lamp_auj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auk____,type,
    aTP_Lamp_auk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aul____,type,
    aTP_Lamp_aul: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aum____,type,
    aTP_Lamp_aum: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aun____,type,
    aTP_Lamp_aun: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auo____,type,
    aTP_Lamp_auo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aup____,type,
    aTP_Lamp_aup: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auq____,type,
    aTP_Lamp_auq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aur____,type,
    aTP_Lamp_aur: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aus____,type,
    aTP_Lamp_aus: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aut____,type,
    aTP_Lamp_aut: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auu____,type,
    aTP_Lamp_auu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auv____,type,
    aTP_Lamp_auv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auw____,type,
    aTP_Lamp_auw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aux____,type,
    aTP_Lamp_aux: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auy____,type,
    aTP_Lamp_auy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auz____,type,
    aTP_Lamp_auz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__av____,type,
    aTP_Lamp_av: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ava____,type,
    aTP_Lamp_ava: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avb____,type,
    aTP_Lamp_avb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avc____,type,
    aTP_Lamp_avc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avd____,type,
    aTP_Lamp_avd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ave____,type,
    aTP_Lamp_ave: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avf____,type,
    aTP_Lamp_avf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avg____,type,
    aTP_Lamp_avg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avh____,type,
    aTP_Lamp_avh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avi____,type,
    aTP_Lamp_avi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avj____,type,
    aTP_Lamp_avj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avk____,type,
    aTP_Lamp_avk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avl____,type,
    aTP_Lamp_avl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avm____,type,
    aTP_Lamp_avm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avn____,type,
    aTP_Lamp_avn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avo____,type,
    aTP_Lamp_avo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avp____,type,
    aTP_Lamp_avp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avq____,type,
    aTP_Lamp_avq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avr____,type,
    aTP_Lamp_avr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avs____,type,
    aTP_Lamp_avs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avt____,type,
    aTP_Lamp_avt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avu____,type,
    aTP_Lamp_avu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avv____,type,
    aTP_Lamp_avv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avw____,type,
    aTP_Lamp_avw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avx____,type,
    aTP_Lamp_avx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avy____,type,
    aTP_Lamp_avy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avz____,type,
    aTP_Lamp_avz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aw____,type,
    aTP_Lamp_aw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awa____,type,
    aTP_Lamp_awa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awb____,type,
    aTP_Lamp_awb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awc____,type,
    aTP_Lamp_awc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awd____,type,
    aTP_Lamp_awd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awe____,type,
    aTP_Lamp_awe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awf____,type,
    aTP_Lamp_awf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awg____,type,
    aTP_Lamp_awg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awh____,type,
    aTP_Lamp_awh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awi____,type,
    aTP_Lamp_awi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awj____,type,
    aTP_Lamp_awj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awk____,type,
    aTP_Lamp_awk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awl____,type,
    aTP_Lamp_awl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awm____,type,
    aTP_Lamp_awm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awn____,type,
    aTP_Lamp_awn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awo____,type,
    aTP_Lamp_awo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awp____,type,
    aTP_Lamp_awp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awq____,type,
    aTP_Lamp_awq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awr____,type,
    aTP_Lamp_awr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aws____,type,
    aTP_Lamp_aws: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awt____,type,
    aTP_Lamp_awt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awu____,type,
    aTP_Lamp_awu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awv____,type,
    aTP_Lamp_awv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aww____,type,
    aTP_Lamp_aww: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awx____,type,
    aTP_Lamp_awx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awy____,type,
    aTP_Lamp_awy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awz____,type,
    aTP_Lamp_awz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ax____,type,
    aTP_Lamp_ax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axa____,type,
    aTP_Lamp_axa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axb____,type,
    aTP_Lamp_axb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axc____,type,
    aTP_Lamp_axc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axd____,type,
    aTP_Lamp_axd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axe____,type,
    aTP_Lamp_axe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axf____,type,
    aTP_Lamp_axf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axg____,type,
    aTP_Lamp_axg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axh____,type,
    aTP_Lamp_axh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axi____,type,
    aTP_Lamp_axi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axj____,type,
    aTP_Lamp_axj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axk____,type,
    aTP_Lamp_axk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axl____,type,
    aTP_Lamp_axl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axm____,type,
    aTP_Lamp_axm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axn____,type,
    aTP_Lamp_axn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axo____,type,
    aTP_Lamp_axo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axp____,type,
    aTP_Lamp_axp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axq____,type,
    aTP_Lamp_axq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axr____,type,
    aTP_Lamp_axr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axs____,type,
    aTP_Lamp_axs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__axt____,type,
    aTP_Lamp_axt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axu____,type,
    aTP_Lamp_axu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__axv____,type,
    aTP_Lamp_axv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axw____,type,
    aTP_Lamp_axw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axx____,type,
    aTP_Lamp_axx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axy____,type,
    aTP_Lamp_axy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__axz____,type,
    aTP_Lamp_axz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ay____,type,
    aTP_Lamp_ay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aya____,type,
    aTP_Lamp_aya: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayb____,type,
    aTP_Lamp_ayb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayc____,type,
    aTP_Lamp_ayc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayd____,type,
    aTP_Lamp_ayd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aye____,type,
    aTP_Lamp_aye: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayf____,type,
    aTP_Lamp_ayf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayg____,type,
    aTP_Lamp_ayg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayh____,type,
    aTP_Lamp_ayh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayi____,type,
    aTP_Lamp_ayi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayj____,type,
    aTP_Lamp_ayj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayk____,type,
    aTP_Lamp_ayk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayl____,type,
    aTP_Lamp_ayl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aym____,type,
    aTP_Lamp_aym: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayn____,type,
    aTP_Lamp_ayn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayo____,type,
    aTP_Lamp_ayo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayp____,type,
    aTP_Lamp_ayp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayq____,type,
    aTP_Lamp_ayq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayr____,type,
    aTP_Lamp_ayr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ays____,type,
    aTP_Lamp_ays: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayt____,type,
    aTP_Lamp_ayt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayu____,type,
    aTP_Lamp_ayu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayv____,type,
    aTP_Lamp_ayv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayw____,type,
    aTP_Lamp_ayw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayx____,type,
    aTP_Lamp_ayx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayy____,type,
    aTP_Lamp_ayy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayz____,type,
    aTP_Lamp_ayz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__az____,type,
    aTP_Lamp_az: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aza____,type,
    aTP_Lamp_aza: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azb____,type,
    aTP_Lamp_azb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azc____,type,
    aTP_Lamp_azc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azd____,type,
    aTP_Lamp_azd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aze____,type,
    aTP_Lamp_aze: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__azf____,type,
    aTP_Lamp_azf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azg____,type,
    aTP_Lamp_azg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azh____,type,
    aTP_Lamp_azh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azi____,type,
    aTP_Lamp_azi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azj____,type,
    aTP_Lamp_azj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azk____,type,
    aTP_Lamp_azk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azl____,type,
    aTP_Lamp_azl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azm____,type,
    aTP_Lamp_azm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azn____,type,
    aTP_Lamp_azn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azo____,type,
    aTP_Lamp_azo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azp____,type,
    aTP_Lamp_azp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azq____,type,
    aTP_Lamp_azq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__azr____,type,
    aTP_Lamp_azr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__azs____,type,
    aTP_Lamp_azs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__azt____,type,
    aTP_Lamp_azt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azu____,type,
    aTP_Lamp_azu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azv____,type,
    aTP_Lamp_azv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azw____,type,
    aTP_Lamp_azw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azx____,type,
    aTP_Lamp_azx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azy____,type,
    aTP_Lamp_azy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azz____,type,
    aTP_Lamp_azz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ba____,type,
    aTP_Lamp_ba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baa____,type,
    aTP_Lamp_baa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bab____,type,
    aTP_Lamp_bab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bac____,type,
    aTP_Lamp_bac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bad____,type,
    aTP_Lamp_bad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bae____,type,
    aTP_Lamp_bae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baf____,type,
    aTP_Lamp_baf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bag____,type,
    aTP_Lamp_bag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bah____,type,
    aTP_Lamp_bah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bai____,type,
    aTP_Lamp_bai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baj____,type,
    aTP_Lamp_baj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bak____,type,
    aTP_Lamp_bak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bal____,type,
    aTP_Lamp_bal: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bam____,type,
    aTP_Lamp_bam: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ban____,type,
    aTP_Lamp_ban: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bao____,type,
    aTP_Lamp_bao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bap____,type,
    aTP_Lamp_bap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baq____,type,
    aTP_Lamp_baq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bar____,type,
    aTP_Lamp_bar: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bas____,type,
    aTP_Lamp_bas: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bat____,type,
    aTP_Lamp_bat: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bau____,type,
    aTP_Lamp_bau: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bav____,type,
    aTP_Lamp_bav: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baw____,type,
    aTP_Lamp_baw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bax____,type,
    aTP_Lamp_bax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bay____,type,
    aTP_Lamp_bay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baz____,type,
    aTP_Lamp_baz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bb____,type,
    aTP_Lamp_bb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bba____,type,
    aTP_Lamp_bba: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bbb____,type,
    aTP_Lamp_bbb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbc____,type,
    aTP_Lamp_bbc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbd____,type,
    aTP_Lamp_bbd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbe____,type,
    aTP_Lamp_bbe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbf____,type,
    aTP_Lamp_bbf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbg____,type,
    aTP_Lamp_bbg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bbh____,type,
    aTP_Lamp_bbh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbi____,type,
    aTP_Lamp_bbi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbj____,type,
    aTP_Lamp_bbj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbk____,type,
    aTP_Lamp_bbk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbl____,type,
    aTP_Lamp_bbl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbm____,type,
    aTP_Lamp_bbm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbn____,type,
    aTP_Lamp_bbn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbo____,type,
    aTP_Lamp_bbo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbp____,type,
    aTP_Lamp_bbp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbq____,type,
    aTP_Lamp_bbq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbr____,type,
    aTP_Lamp_bbr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbs____,type,
    aTP_Lamp_bbs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbt____,type,
    aTP_Lamp_bbt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bc____,type,
    aTP_Lamp_bc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bd____,type,
    aTP_Lamp_bd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__be____,type,
    aTP_Lamp_be: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bf____,type,
    aTP_Lamp_bf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bg____,type,
    aTP_Lamp_bg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bh____,type,
    aTP_Lamp_bh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bi____,type,
    aTP_Lamp_bi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bj____,type,
    aTP_Lamp_bj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bk____,type,
    aTP_Lamp_bk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bl____,type,
    aTP_Lamp_bl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bm____,type,
    aTP_Lamp_bm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bn____,type,
    aTP_Lamp_bn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bo____,type,
    aTP_Lamp_bo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bp____,type,
    aTP_Lamp_bp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bq____,type,
    aTP_Lamp_bq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__br____,type,
    aTP_Lamp_br: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bs____,type,
    aTP_Lamp_bs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bt____,type,
    aTP_Lamp_bt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bu____,type,
    aTP_Lamp_bu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bv____,type,
    aTP_Lamp_bv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bw____,type,
    aTP_Lamp_bw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bx____,type,
    aTP_Lamp_bx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__by____,type,
    aTP_Lamp_by: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bz____,type,
    aTP_Lamp_bz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ca____,type,
    aTP_Lamp_ca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cb____,type,
    aTP_Lamp_cb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cc____,type,
    aTP_Lamp_cc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cd____,type,
    aTP_Lamp_cd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ce____,type,
    aTP_Lamp_ce: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cf____,type,
    aTP_Lamp_cf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cg____,type,
    aTP_Lamp_cg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ch____,type,
    aTP_Lamp_ch: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ci____,type,
    aTP_Lamp_ci: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cj____,type,
    aTP_Lamp_cj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ck____,type,
    aTP_Lamp_ck: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cl____,type,
    aTP_Lamp_cl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cm____,type,
    aTP_Lamp_cm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cn____,type,
    aTP_Lamp_cn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__co____,type,
    aTP_Lamp_co: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cp____,type,
    aTP_Lamp_cp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cq____,type,
    aTP_Lamp_cq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cr____,type,
    aTP_Lamp_cr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cs____,type,
    aTP_Lamp_cs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ct____,type,
    aTP_Lamp_ct: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cu____,type,
    aTP_Lamp_cu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cv____,type,
    aTP_Lamp_cv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cw____,type,
    aTP_Lamp_cw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cx____,type,
    aTP_Lamp_cx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cy____,type,
    aTP_Lamp_cy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cz____,type,
    aTP_Lamp_cz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__da____,type,
    aTP_Lamp_da: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__db____,type,
    aTP_Lamp_db: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dc____,type,
    aTP_Lamp_dc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dd____,type,
    aTP_Lamp_dd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__de____,type,
    aTP_Lamp_de: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__df____,type,
    aTP_Lamp_df: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dg____,type,
    aTP_Lamp_dg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dh____,type,
    aTP_Lamp_dh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__di____,type,
    aTP_Lamp_di: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dj____,type,
    aTP_Lamp_dj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__dk____,type,
    aTP_Lamp_dk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dl____,type,
    aTP_Lamp_dl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dm____,type,
    aTP_Lamp_dm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dn____,type,
    aTP_Lamp_dn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__do____,type,
    aTP_Lamp_do: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dp____,type,
    aTP_Lamp_dp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dq____,type,
    aTP_Lamp_dq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dr____,type,
    aTP_Lamp_dr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ds____,type,
    aTP_Lamp_ds: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dt____,type,
    aTP_Lamp_dt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__du____,type,
    aTP_Lamp_du: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dv____,type,
    aTP_Lamp_dv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dw____,type,
    aTP_Lamp_dw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__dx____,type,
    aTP_Lamp_dx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dy____,type,
    aTP_Lamp_dy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dz____,type,
    aTP_Lamp_dz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ea____,type,
    aTP_Lamp_ea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eb____,type,
    aTP_Lamp_eb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ec____,type,
    aTP_Lamp_ec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ed____,type,
    aTP_Lamp_ed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ee____,type,
    aTP_Lamp_ee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ef____,type,
    aTP_Lamp_ef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eg____,type,
    aTP_Lamp_eg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eh____,type,
    aTP_Lamp_eh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ei____,type,
    aTP_Lamp_ei: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ej____,type,
    aTP_Lamp_ej: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ek____,type,
    aTP_Lamp_ek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__el____,type,
    aTP_Lamp_el: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__em____,type,
    aTP_Lamp_em: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__en____,type,
    aTP_Lamp_en: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eo____,type,
    aTP_Lamp_eo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ep____,type,
    aTP_Lamp_ep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eq____,type,
    aTP_Lamp_eq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__er____,type,
    aTP_Lamp_er: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__es____,type,
    aTP_Lamp_es: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__et____,type,
    aTP_Lamp_et: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eu____,type,
    aTP_Lamp_eu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ev____,type,
    aTP_Lamp_ev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ew____,type,
    aTP_Lamp_ew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ex____,type,
    aTP_Lamp_ex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ey____,type,
    aTP_Lamp_ey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ez____,type,
    aTP_Lamp_ez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fa____,type,
    aTP_Lamp_fa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fb____,type,
    aTP_Lamp_fb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fc____,type,
    aTP_Lamp_fc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fd____,type,
    aTP_Lamp_fd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fe____,type,
    aTP_Lamp_fe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ff____,type,
    aTP_Lamp_ff: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fg____,type,
    aTP_Lamp_fg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fh____,type,
    aTP_Lamp_fh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fi____,type,
    aTP_Lamp_fi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fj____,type,
    aTP_Lamp_fj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fk____,type,
    aTP_Lamp_fk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fl____,type,
    aTP_Lamp_fl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fm____,type,
    aTP_Lamp_fm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fn____,type,
    aTP_Lamp_fn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fo____,type,
    aTP_Lamp_fo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fp____,type,
    aTP_Lamp_fp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fq____,type,
    aTP_Lamp_fq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fr____,type,
    aTP_Lamp_fr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fs____,type,
    aTP_Lamp_fs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ft____,type,
    aTP_Lamp_ft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fu____,type,
    aTP_Lamp_fu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fv____,type,
    aTP_Lamp_fv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fw____,type,
    aTP_Lamp_fw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fx____,type,
    aTP_Lamp_fx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fy____,type,
    aTP_Lamp_fy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fz____,type,
    aTP_Lamp_fz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ga____,type,
    aTP_Lamp_ga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gb____,type,
    aTP_Lamp_gb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gc____,type,
    aTP_Lamp_gc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gd____,type,
    aTP_Lamp_gd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ge____,type,
    aTP_Lamp_ge: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gf____,type,
    aTP_Lamp_gf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gg____,type,
    aTP_Lamp_gg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gh____,type,
    aTP_Lamp_gh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gi____,type,
    aTP_Lamp_gi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gj____,type,
    aTP_Lamp_gj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gk____,type,
    aTP_Lamp_gk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gl____,type,
    aTP_Lamp_gl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gm____,type,
    aTP_Lamp_gm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gn____,type,
    aTP_Lamp_gn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__go____,type,
    aTP_Lamp_go: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gp____,type,
    aTP_Lamp_gp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gq____,type,
    aTP_Lamp_gq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gr____,type,
    aTP_Lamp_gr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gs____,type,
    aTP_Lamp_gs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gt____,type,
    aTP_Lamp_gt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gu____,type,
    aTP_Lamp_gu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gv____,type,
    aTP_Lamp_gv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gw____,type,
    aTP_Lamp_gw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gx____,type,
    aTP_Lamp_gx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gy____,type,
    aTP_Lamp_gy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gz____,type,
    aTP_Lamp_gz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ha____,type,
    aTP_Lamp_ha: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hb____,type,
    aTP_Lamp_hb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hc____,type,
    aTP_Lamp_hc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hd____,type,
    aTP_Lamp_hd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__he____,type,
    aTP_Lamp_he: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hf____,type,
    aTP_Lamp_hf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hg____,type,
    aTP_Lamp_hg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hh____,type,
    aTP_Lamp_hh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hi____,type,
    aTP_Lamp_hi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hj____,type,
    aTP_Lamp_hj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hk____,type,
    aTP_Lamp_hk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hl____,type,
    aTP_Lamp_hl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hm____,type,
    aTP_Lamp_hm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hn____,type,
    aTP_Lamp_hn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ho____,type,
    aTP_Lamp_ho: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hp____,type,
    aTP_Lamp_hp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hq____,type,
    aTP_Lamp_hq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hr____,type,
    aTP_Lamp_hr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hs____,type,
    aTP_Lamp_hs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ht____,type,
    aTP_Lamp_ht: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hu____,type,
    aTP_Lamp_hu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hv____,type,
    aTP_Lamp_hv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hw____,type,
    aTP_Lamp_hw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hx____,type,
    aTP_Lamp_hx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hy____,type,
    aTP_Lamp_hy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hz____,type,
    aTP_Lamp_hz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ia____,type,
    aTP_Lamp_ia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ib____,type,
    aTP_Lamp_ib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ic____,type,
    aTP_Lamp_ic: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__id____,type,
    aTP_Lamp_id: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ie____,type,
    aTP_Lamp_ie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__if____,type,
    aTP_Lamp_if: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ig____,type,
    aTP_Lamp_ig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ih____,type,
    aTP_Lamp_ih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ii____,type,
    aTP_Lamp_ii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ij____,type,
    aTP_Lamp_ij: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ik____,type,
    aTP_Lamp_ik: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__il____,type,
    aTP_Lamp_il: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__im____,type,
    aTP_Lamp_im: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__in____,type,
    aTP_Lamp_in: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__io____,type,
    aTP_Lamp_io: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ip____,type,
    aTP_Lamp_ip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iq____,type,
    aTP_Lamp_iq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ir____,type,
    aTP_Lamp_ir: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__is____,type,
    aTP_Lamp_is: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__it____,type,
    aTP_Lamp_it: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iu____,type,
    aTP_Lamp_iu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iv____,type,
    aTP_Lamp_iv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iw____,type,
    aTP_Lamp_iw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ix____,type,
    aTP_Lamp_ix: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iy____,type,
    aTP_Lamp_iy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iz____,type,
    aTP_Lamp_iz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ja____,type,
    aTP_Lamp_ja: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jb____,type,
    aTP_Lamp_jb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jc____,type,
    aTP_Lamp_jc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jd____,type,
    aTP_Lamp_jd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__je____,type,
    aTP_Lamp_je: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jf____,type,
    aTP_Lamp_jf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jg____,type,
    aTP_Lamp_jg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jh____,type,
    aTP_Lamp_jh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ji____,type,
    aTP_Lamp_ji: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jj____,type,
    aTP_Lamp_jj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jk____,type,
    aTP_Lamp_jk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jl____,type,
    aTP_Lamp_jl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jm____,type,
    aTP_Lamp_jm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jn____,type,
    aTP_Lamp_jn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jo____,type,
    aTP_Lamp_jo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jp____,type,
    aTP_Lamp_jp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jq____,type,
    aTP_Lamp_jq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jr____,type,
    aTP_Lamp_jr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__js____,type,
    aTP_Lamp_js: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jt____,type,
    aTP_Lamp_jt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ju____,type,
    aTP_Lamp_ju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jv____,type,
    aTP_Lamp_jv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jw____,type,
    aTP_Lamp_jw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jx____,type,
    aTP_Lamp_jx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jy____,type,
    aTP_Lamp_jy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jz____,type,
    aTP_Lamp_jz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ka____,type,
    aTP_Lamp_ka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kb____,type,
    aTP_Lamp_kb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kc____,type,
    aTP_Lamp_kc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kd____,type,
    aTP_Lamp_kd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ke____,type,
    aTP_Lamp_ke: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kf____,type,
    aTP_Lamp_kf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kg____,type,
    aTP_Lamp_kg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kh____,type,
    aTP_Lamp_kh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ki____,type,
    aTP_Lamp_ki: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kj____,type,
    aTP_Lamp_kj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kk____,type,
    aTP_Lamp_kk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kl____,type,
    aTP_Lamp_kl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__km____,type,
    aTP_Lamp_km: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kn____,type,
    aTP_Lamp_kn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ko____,type,
    aTP_Lamp_ko: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__kp____,type,
    aTP_Lamp_kp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kq____,type,
    aTP_Lamp_kq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kr____,type,
    aTP_Lamp_kr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ks____,type,
    aTP_Lamp_ks: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kt____,type,
    aTP_Lamp_kt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ku____,type,
    aTP_Lamp_ku: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kv____,type,
    aTP_Lamp_kv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kw____,type,
    aTP_Lamp_kw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kx____,type,
    aTP_Lamp_kx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ky____,type,
    aTP_Lamp_ky: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kz____,type,
    aTP_Lamp_kz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__la____,type,
    aTP_Lamp_la: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lb____,type,
    aTP_Lamp_lb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lc____,type,
    aTP_Lamp_lc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ld____,type,
    aTP_Lamp_ld: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__le____,type,
    aTP_Lamp_le: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lf____,type,
    aTP_Lamp_lf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lg____,type,
    aTP_Lamp_lg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lh____,type,
    aTP_Lamp_lh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__li____,type,
    aTP_Lamp_li: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lj____,type,
    aTP_Lamp_lj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lk____,type,
    aTP_Lamp_lk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ll____,type,
    aTP_Lamp_ll: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lm____,type,
    aTP_Lamp_lm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ln____,type,
    aTP_Lamp_ln: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lo____,type,
    aTP_Lamp_lo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lp____,type,
    aTP_Lamp_lp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lq____,type,
    aTP_Lamp_lq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lr____,type,
    aTP_Lamp_lr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ls____,type,
    aTP_Lamp_ls: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lt____,type,
    aTP_Lamp_lt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lu____,type,
    aTP_Lamp_lu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lv____,type,
    aTP_Lamp_lv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lw____,type,
    aTP_Lamp_lw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lx____,type,
    aTP_Lamp_lx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ly____,type,
    aTP_Lamp_ly: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lz____,type,
    aTP_Lamp_lz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ma____,type,
    aTP_Lamp_ma: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mb____,type,
    aTP_Lamp_mb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mc____,type,
    aTP_Lamp_mc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__md____,type,
    aTP_Lamp_md: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__me____,type,
    aTP_Lamp_me: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mf____,type,
    aTP_Lamp_mf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mg____,type,
    aTP_Lamp_mg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mh____,type,
    aTP_Lamp_mh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mi____,type,
    aTP_Lamp_mi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mj____,type,
    aTP_Lamp_mj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mk____,type,
    aTP_Lamp_mk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ml____,type,
    aTP_Lamp_ml: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mm____,type,
    aTP_Lamp_mm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mn____,type,
    aTP_Lamp_mn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mo____,type,
    aTP_Lamp_mo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mp____,type,
    aTP_Lamp_mp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mq____,type,
    aTP_Lamp_mq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mr____,type,
    aTP_Lamp_mr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ms____,type,
    aTP_Lamp_ms: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mt____,type,
    aTP_Lamp_mt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mu____,type,
    aTP_Lamp_mu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mv____,type,
    aTP_Lamp_mv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mw____,type,
    aTP_Lamp_mw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mx____,type,
    aTP_Lamp_mx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__my____,type,
    aTP_Lamp_my: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mz____,type,
    aTP_Lamp_mz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__na____,type,
    aTP_Lamp_na: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nb____,type,
    aTP_Lamp_nb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nc____,type,
    aTP_Lamp_nc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nd____,type,
    aTP_Lamp_nd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ne____,type,
    aTP_Lamp_ne: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nf____,type,
    aTP_Lamp_nf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ng____,type,
    aTP_Lamp_ng: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nh____,type,
    aTP_Lamp_nh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ni____,type,
    aTP_Lamp_ni: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nj____,type,
    aTP_Lamp_nj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nk____,type,
    aTP_Lamp_nk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nl____,type,
    aTP_Lamp_nl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nm____,type,
    aTP_Lamp_nm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nn____,type,
    aTP_Lamp_nn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__no____,type,
    aTP_Lamp_no: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__np____,type,
    aTP_Lamp_np: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nq____,type,
    aTP_Lamp_nq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nr____,type,
    aTP_Lamp_nr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ns____,type,
    aTP_Lamp_ns: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nt____,type,
    aTP_Lamp_nt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nu____,type,
    aTP_Lamp_nu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nv____,type,
    aTP_Lamp_nv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nw____,type,
    aTP_Lamp_nw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nx____,type,
    aTP_Lamp_nx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ny____,type,
    aTP_Lamp_ny: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nz____,type,
    aTP_Lamp_nz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oa____,type,
    aTP_Lamp_oa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ob____,type,
    aTP_Lamp_ob: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oc____,type,
    aTP_Lamp_oc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__od____,type,
    aTP_Lamp_od: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__oe____,type,
    aTP_Lamp_oe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__of____,type,
    aTP_Lamp_of: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__og____,type,
    aTP_Lamp_og: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oh____,type,
    aTP_Lamp_oh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oi____,type,
    aTP_Lamp_oi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oj____,type,
    aTP_Lamp_oj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ok____,type,
    aTP_Lamp_ok: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ol____,type,
    aTP_Lamp_ol: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__om____,type,
    aTP_Lamp_om: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__on____,type,
    aTP_Lamp_on: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oo____,type,
    aTP_Lamp_oo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__op____,type,
    aTP_Lamp_op: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oq____,type,
    aTP_Lamp_oq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__or____,type,
    aTP_Lamp_or: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__os____,type,
    aTP_Lamp_os: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ot____,type,
    aTP_Lamp_ot: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ou____,type,
    aTP_Lamp_ou: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ov____,type,
    aTP_Lamp_ov: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ow____,type,
    aTP_Lamp_ow: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ox____,type,
    aTP_Lamp_ox: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oy____,type,
    aTP_Lamp_oy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oz____,type,
    aTP_Lamp_oz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pa____,type,
    aTP_Lamp_pa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pb____,type,
    aTP_Lamp_pb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pc____,type,
    aTP_Lamp_pc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pd____,type,
    aTP_Lamp_pd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pe____,type,
    aTP_Lamp_pe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pf____,type,
    aTP_Lamp_pf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pg____,type,
    aTP_Lamp_pg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ph____,type,
    aTP_Lamp_ph: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pi____,type,
    aTP_Lamp_pi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pj____,type,
    aTP_Lamp_pj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pk____,type,
    aTP_Lamp_pk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pl____,type,
    aTP_Lamp_pl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pm____,type,
    aTP_Lamp_pm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pn____,type,
    aTP_Lamp_pn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__po____,type,
    aTP_Lamp_po: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pp____,type,
    aTP_Lamp_pp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pq____,type,
    aTP_Lamp_pq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pr____,type,
    aTP_Lamp_pr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ps____,type,
    aTP_Lamp_ps: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pt____,type,
    aTP_Lamp_pt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pu____,type,
    aTP_Lamp_pu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pv____,type,
    aTP_Lamp_pv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pw____,type,
    aTP_Lamp_pw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__px____,type,
    aTP_Lamp_px: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__py____,type,
    aTP_Lamp_py: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pz____,type,
    aTP_Lamp_pz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qa____,type,
    aTP_Lamp_qa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qb____,type,
    aTP_Lamp_qb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qc____,type,
    aTP_Lamp_qc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qd____,type,
    aTP_Lamp_qd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qe____,type,
    aTP_Lamp_qe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qf____,type,
    aTP_Lamp_qf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qg____,type,
    aTP_Lamp_qg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qh____,type,
    aTP_Lamp_qh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qi____,type,
    aTP_Lamp_qi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qj____,type,
    aTP_Lamp_qj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qk____,type,
    aTP_Lamp_qk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ql____,type,
    aTP_Lamp_ql: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qm____,type,
    aTP_Lamp_qm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qn____,type,
    aTP_Lamp_qn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qo____,type,
    aTP_Lamp_qo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qp____,type,
    aTP_Lamp_qp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qq____,type,
    aTP_Lamp_qq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qr____,type,
    aTP_Lamp_qr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qs____,type,
    aTP_Lamp_qs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qt____,type,
    aTP_Lamp_qt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qu____,type,
    aTP_Lamp_qu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qv____,type,
    aTP_Lamp_qv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qw____,type,
    aTP_Lamp_qw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qx____,type,
    aTP_Lamp_qx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qy____,type,
    aTP_Lamp_qy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qz____,type,
    aTP_Lamp_qz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ra____,type,
    aTP_Lamp_ra: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rb____,type,
    aTP_Lamp_rb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rc____,type,
    aTP_Lamp_rc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rd____,type,
    aTP_Lamp_rd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__re____,type,
    aTP_Lamp_re: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rf____,type,
    aTP_Lamp_rf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rg____,type,
    aTP_Lamp_rg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rh____,type,
    aTP_Lamp_rh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ri____,type,
    aTP_Lamp_ri: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rj____,type,
    aTP_Lamp_rj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rk____,type,
    aTP_Lamp_rk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rl____,type,
    aTP_Lamp_rl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rm____,type,
    aTP_Lamp_rm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rn____,type,
    aTP_Lamp_rn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ro____,type,
    aTP_Lamp_ro: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rp____,type,
    aTP_Lamp_rp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rq____,type,
    aTP_Lamp_rq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rr____,type,
    aTP_Lamp_rr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rs____,type,
    aTP_Lamp_rs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rt____,type,
    aTP_Lamp_rt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ru____,type,
    aTP_Lamp_ru: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rv____,type,
    aTP_Lamp_rv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rw____,type,
    aTP_Lamp_rw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rx____,type,
    aTP_Lamp_rx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ry____,type,
    aTP_Lamp_ry: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rz____,type,
    aTP_Lamp_rz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sa____,type,
    aTP_Lamp_sa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sb____,type,
    aTP_Lamp_sb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sc____,type,
    aTP_Lamp_sc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sd____,type,
    aTP_Lamp_sd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__se____,type,
    aTP_Lamp_se: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sf____,type,
    aTP_Lamp_sf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sg____,type,
    aTP_Lamp_sg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sh____,type,
    aTP_Lamp_sh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__si____,type,
    aTP_Lamp_si: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sj____,type,
    aTP_Lamp_sj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sk____,type,
    aTP_Lamp_sk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sl____,type,
    aTP_Lamp_sl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sm____,type,
    aTP_Lamp_sm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sn____,type,
    aTP_Lamp_sn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__so____,type,
    aTP_Lamp_so: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sp____,type,
    aTP_Lamp_sp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sq____,type,
    aTP_Lamp_sq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sr____,type,
    aTP_Lamp_sr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ss____,type,
    aTP_Lamp_ss: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__st____,type,
    aTP_Lamp_st: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__su____,type,
    aTP_Lamp_su: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sv____,type,
    aTP_Lamp_sv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sw____,type,
    aTP_Lamp_sw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sx____,type,
    aTP_Lamp_sx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sy____,type,
    aTP_Lamp_sy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sz____,type,
    aTP_Lamp_sz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ta____,type,
    aTP_Lamp_ta: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tb____,type,
    aTP_Lamp_tb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__tc____,type,
    aTP_Lamp_tc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__td____,type,
    aTP_Lamp_td: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__te____,type,
    aTP_Lamp_te: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tf____,type,
    aTP_Lamp_tf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tg____,type,
    aTP_Lamp_tg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__th____,type,
    aTP_Lamp_th: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ti____,type,
    aTP_Lamp_ti: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tj____,type,
    aTP_Lamp_tj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__tk____,type,
    aTP_Lamp_tk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tl____,type,
    aTP_Lamp_tl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tm____,type,
    aTP_Lamp_tm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tn____,type,
    aTP_Lamp_tn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__to____,type,
    aTP_Lamp_to: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tp____,type,
    aTP_Lamp_tp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tq____,type,
    aTP_Lamp_tq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tr____,type,
    aTP_Lamp_tr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ts____,type,
    aTP_Lamp_ts: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tt____,type,
    aTP_Lamp_tt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tu____,type,
    aTP_Lamp_tu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tv____,type,
    aTP_Lamp_tv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tw____,type,
    aTP_Lamp_tw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tx____,type,
    aTP_Lamp_tx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ty____,type,
    aTP_Lamp_ty: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tz____,type,
    aTP_Lamp_tz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ua____,type,
    aTP_Lamp_ua: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ub____,type,
    aTP_Lamp_ub: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uc____,type,
    aTP_Lamp_uc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ud____,type,
    aTP_Lamp_ud: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ue____,type,
    aTP_Lamp_ue: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uf____,type,
    aTP_Lamp_uf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ug____,type,
    aTP_Lamp_ug: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uh____,type,
    aTP_Lamp_uh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ui____,type,
    aTP_Lamp_ui: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uj____,type,
    aTP_Lamp_uj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uk____,type,
    aTP_Lamp_uk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ul____,type,
    aTP_Lamp_ul: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__um____,type,
    aTP_Lamp_um: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__un____,type,
    aTP_Lamp_un: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uo____,type,
    aTP_Lamp_uo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__up____,type,
    aTP_Lamp_up: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uq____,type,
    aTP_Lamp_uq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ur____,type,
    aTP_Lamp_ur: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__us____,type,
    aTP_Lamp_us: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ut____,type,
    aTP_Lamp_ut: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uu____,type,
    aTP_Lamp_uu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uv____,type,
    aTP_Lamp_uv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uw____,type,
    aTP_Lamp_uw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ux____,type,
    aTP_Lamp_ux: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uy____,type,
    aTP_Lamp_uy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uz____,type,
    aTP_Lamp_uz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__va____,type,
    aTP_Lamp_va: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vb____,type,
    aTP_Lamp_vb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vc____,type,
    aTP_Lamp_vc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vd____,type,
    aTP_Lamp_vd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ve____,type,
    aTP_Lamp_ve: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vf____,type,
    aTP_Lamp_vf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vg____,type,
    aTP_Lamp_vg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vh____,type,
    aTP_Lamp_vh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vi____,type,
    aTP_Lamp_vi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vj____,type,
    aTP_Lamp_vj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vk____,type,
    aTP_Lamp_vk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vl____,type,
    aTP_Lamp_vl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vm____,type,
    aTP_Lamp_vm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vn____,type,
    aTP_Lamp_vn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vo____,type,
    aTP_Lamp_vo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vp____,type,
    aTP_Lamp_vp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vq____,type,
    aTP_Lamp_vq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vr____,type,
    aTP_Lamp_vr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vs____,type,
    aTP_Lamp_vs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vt____,type,
    aTP_Lamp_vt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vu____,type,
    aTP_Lamp_vu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vv____,type,
    aTP_Lamp_vv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vw____,type,
    aTP_Lamp_vw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vx____,type,
    aTP_Lamp_vx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vy____,type,
    aTP_Lamp_vy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vz____,type,
    aTP_Lamp_vz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wa____,type,
    aTP_Lamp_wa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wb____,type,
    aTP_Lamp_wb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wc____,type,
    aTP_Lamp_wc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wd____,type,
    aTP_Lamp_wd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__we____,type,
    aTP_Lamp_we: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wf____,type,
    aTP_Lamp_wf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wg____,type,
    aTP_Lamp_wg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wh____,type,
    aTP_Lamp_wh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wi____,type,
    aTP_Lamp_wi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wj____,type,
    aTP_Lamp_wj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wk____,type,
    aTP_Lamp_wk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wl____,type,
    aTP_Lamp_wl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wm____,type,
    aTP_Lamp_wm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wn____,type,
    aTP_Lamp_wn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wo____,type,
    aTP_Lamp_wo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wp____,type,
    aTP_Lamp_wp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wq____,type,
    aTP_Lamp_wq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wr____,type,
    aTP_Lamp_wr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ws____,type,
    aTP_Lamp_ws: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wt____,type,
    aTP_Lamp_wt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wu____,type,
    aTP_Lamp_wu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wv____,type,
    aTP_Lamp_wv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ww____,type,
    aTP_Lamp_ww: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wx____,type,
    aTP_Lamp_wx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wy____,type,
    aTP_Lamp_wy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wz____,type,
    aTP_Lamp_wz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xa____,type,
    aTP_Lamp_xa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xb____,type,
    aTP_Lamp_xb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xc____,type,
    aTP_Lamp_xc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xd____,type,
    aTP_Lamp_xd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xe____,type,
    aTP_Lamp_xe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xf____,type,
    aTP_Lamp_xf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xg____,type,
    aTP_Lamp_xg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xh____,type,
    aTP_Lamp_xh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xi____,type,
    aTP_Lamp_xi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xj____,type,
    aTP_Lamp_xj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xk____,type,
    aTP_Lamp_xk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xl____,type,
    aTP_Lamp_xl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xm____,type,
    aTP_Lamp_xm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xn____,type,
    aTP_Lamp_xn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xo____,type,
    aTP_Lamp_xo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xp____,type,
    aTP_Lamp_xp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xq____,type,
    aTP_Lamp_xq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xr____,type,
    aTP_Lamp_xr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xs____,type,
    aTP_Lamp_xs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xt____,type,
    aTP_Lamp_xt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xu____,type,
    aTP_Lamp_xu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xv____,type,
    aTP_Lamp_xv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xw____,type,
    aTP_Lamp_xw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xx____,type,
    aTP_Lamp_xx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xy____,type,
    aTP_Lamp_xy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xz____,type,
    aTP_Lamp_xz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ya____,type,
    aTP_Lamp_ya: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yb____,type,
    aTP_Lamp_yb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yc____,type,
    aTP_Lamp_yc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yd____,type,
    aTP_Lamp_yd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ye____,type,
    aTP_Lamp_ye: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yf____,type,
    aTP_Lamp_yf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yg____,type,
    aTP_Lamp_yg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yh____,type,
    aTP_Lamp_yh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yi____,type,
    aTP_Lamp_yi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yj____,type,
    aTP_Lamp_yj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yk____,type,
    aTP_Lamp_yk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yl____,type,
    aTP_Lamp_yl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ym____,type,
    aTP_Lamp_ym: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yn____,type,
    aTP_Lamp_yn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yo____,type,
    aTP_Lamp_yo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yp____,type,
    aTP_Lamp_yp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yq____,type,
    aTP_Lamp_yq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yr____,type,
    aTP_Lamp_yr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ys____,type,
    aTP_Lamp_ys: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yt____,type,
    aTP_Lamp_yt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yu____,type,
    aTP_Lamp_yu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yv____,type,
    aTP_Lamp_yv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yw____,type,
    aTP_Lamp_yw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yx____,type,
    aTP_Lamp_yx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yy____,type,
    aTP_Lamp_yy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yz____,type,
    aTP_Lamp_yz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__za____,type,
    aTP_Lamp_za: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zb____,type,
    aTP_Lamp_zb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zc____,type,
    aTP_Lamp_zc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zd____,type,
    aTP_Lamp_zd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ze____,type,
    aTP_Lamp_ze: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zf____,type,
    aTP_Lamp_zf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zg____,type,
    aTP_Lamp_zg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zh____,type,
    aTP_Lamp_zh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zi____,type,
    aTP_Lamp_zi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zj____,type,
    aTP_Lamp_zj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zk____,type,
    aTP_Lamp_zk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zl____,type,
    aTP_Lamp_zl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zm____,type,
    aTP_Lamp_zm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zn____,type,
    aTP_Lamp_zn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zo____,type,
    aTP_Lamp_zo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zp____,type,
    aTP_Lamp_zp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zq____,type,
    aTP_Lamp_zq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zr____,type,
    aTP_Lamp_zr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zs____,type,
    aTP_Lamp_zs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zt____,type,
    aTP_Lamp_zt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zu____,type,
    aTP_Lamp_zu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zv____,type,
    aTP_Lamp_zv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zw____,type,
    aTP_Lamp_zw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zx____,type,
    aTP_Lamp_zx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zy____,type,
    aTP_Lamp_zy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zz____,type,
    aTP_Lamp_zz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Array__Time_Oalloc,type,
    array_alloc: 
      !>[A: $tType] : ( ( list(A) * heap_ext(product_unit) ) > product_prod(array(A),heap_ext(product_unit)) ) ).

tff(sy_c_Array__Time_Ofreeze,type,
    array_freeze: 
      !>[A: $tType] : ( array(A) > heap_Time_Heap(list(A)) ) ).

tff(sy_c_Array__Time_Oget,type,
    array_get: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * array(A) ) > list(A) ) ).

tff(sy_c_Array__Time_Olen,type,
    array_len: 
      !>[A: $tType] : ( array(A) > heap_Time_Heap(nat) ) ).

tff(sy_c_Array__Time_Olen_H,type,
    array_len2: 
      !>[B: $tType,A: $tType] : ( array(B) > heap_Time_Heap(A) ) ).

tff(sy_c_Array__Time_Olength,type,
    array_length: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * array(A) ) > nat ) ).

tff(sy_c_Array__Time_Omake,type,
    array_make: 
      !>[A: $tType] : ( ( nat * fun(nat,A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Omap__entry,type,
    array_map_entry: 
      !>[A: $tType] : ( ( nat * fun(A,A) * array(A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Onew,type,
    array_new: 
      !>[A: $tType] : ( ( nat * A ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Onth,type,
    array_nth: 
      !>[A: $tType] : ( ( array(A) * nat ) > heap_Time_Heap(A) ) ).

tff(sy_c_Array__Time_Oof__list,type,
    array_of_list: 
      !>[A: $tType] : ( list(A) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Oset,type,
    array_set: 
      !>[A: $tType] : ( ( array(A) * list(A) ) > fun(heap_ext(product_unit),heap_ext(product_unit)) ) ).

tff(sy_c_Array__Time_Oswap,type,
    array_swap: 
      !>[A: $tType] : ( ( nat * A * array(A) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Array__Time_Oupd,type,
    array_upd: 
      !>[A: $tType] : ( ( nat * A * array(A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Oupd_H,type,
    array_upd2: 
      !>[A: $tType] : ( ( array(A) * code_integer * A ) > heap_Time_Heap(product_unit) ) ).

tff(sy_c_Array__Time_Oupdate,type,
    array_update: 
      !>[A: $tType] : ( ( array(A) * nat * A * heap_ext(product_unit) ) > heap_ext(product_unit) ) ).

tff(sy_c_Assertions_Oassn_OAbs__assn,type,
    abs_assn: fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn) ).

tff(sy_c_Assertions_Oassn_ORep__assn,type,
    rep_assn: fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool)) ).

tff(sy_c_Assertions_Oentails,type,
    entails: ( assn * assn ) > $o ).

tff(sy_c_Assertions_Oentailst,type,
    entailst: ( assn * assn ) > $o ).

tff(sy_c_Assertions_Oex__assn,type,
    ex_assn: 
      !>[A: $tType] : ( fun(A,assn) > assn ) ).

tff(sy_c_Assertions_Oin__range,type,
    in_range: fun(product_prod(heap_ext(product_unit),set(nat)),bool) ).

tff(sy_c_Assertions_Oin__range__rel,type,
    in_range_rel: fun(product_prod(heap_ext(product_unit),set(nat)),fun(product_prod(heap_ext(product_unit),set(nat)),bool)) ).

tff(sy_c_Assertions_Ois__pure__assn,type,
    is_pure_assn: assn > $o ).

tff(sy_c_Assertions_Oone__assn__raw,type,
    one_assn_raw: fun(product_prod(heap_ext(product_unit),set(nat)),bool) ).

tff(sy_c_Assertions_Oone__assn__raw__rel,type,
    one_assn_raw_rel: fun(product_prod(heap_ext(product_unit),set(nat)),fun(product_prod(heap_ext(product_unit),set(nat)),bool)) ).

tff(sy_c_Assertions_Oprecise,type,
    precise: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,assn)) > $o ) ).

tff(sy_c_Assertions_Oproper,type,
    proper: fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool) ).

tff(sy_c_Assertions_Opure__assn,type,
    pure_assn: bool > assn ).

tff(sy_c_Assertions_Opure__assn__raw,type,
    pure_assn_raw: 
      !>[A: $tType,B: $tType] : ( bool > fun(product_prod(A,set(B)),bool) ) ).

tff(sy_c_Assertions_Opure__assn__raw__rel,type,
    pure_assn_raw_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(bool,product_prod(A,set(B))),fun(product_prod(bool,product_prod(A,set(B))),bool)) ).

tff(sy_c_Assertions_OrelH,type,
    relH: ( set(nat) * heap_ext(product_unit) * heap_ext(product_unit) ) > $o ).

tff(sy_c_Assertions_Osnga__assn,type,
    snga_assn: 
      !>[A: $tType] : ( ( array(A) * list(A) ) > assn ) ).

tff(sy_c_Assertions_Osnga__assn__raw,type,
    snga_assn_raw: 
      !>[A: $tType] : ( ( array(A) * list(A) ) > fun(product_prod(heap_ext(product_unit),set(nat)),bool) ) ).

tff(sy_c_Assertions_Osnga__assn__raw__rel,type,
    snga_assn_raw_rel: 
      !>[A: $tType] : fun(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool)) ).

tff(sy_c_Assertions_Osngr__assn,type,
    sngr_assn: 
      !>[A: $tType] : ( ( ref(A) * A ) > assn ) ).

tff(sy_c_Assertions_Osngr__assn__raw,type,
    sngr_assn_raw: 
      !>[A: $tType] : ( ( ref(A) * A ) > fun(product_prod(heap_ext(product_unit),set(nat)),bool) ) ).

tff(sy_c_Assertions_Osngr__assn__raw__rel,type,
    sngr_assn_raw_rel: 
      !>[A: $tType] : fun(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool)) ).

tff(sy_c_Assertions_Otimes__assn__raw,type,
    times_assn_raw: ( fun(product_prod(heap_ext(product_unit),set(nat)),bool) * fun(product_prod(heap_ext(product_unit),set(nat)),bool) ) > fun(product_prod(heap_ext(product_unit),set(nat)),bool) ).

tff(sy_c_Assertions_Otimes__assn__raw__rel,type,
    times_assn_raw_rel: fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool)) ).

tff(sy_c_Assertions_Owand__assn,type,
    wand_assn: ( assn * assn ) > assn ).

tff(sy_c_Assertions_Owand__raw,type,
    wand_raw: ( fun(product_prod(heap_ext(product_unit),set(nat)),bool) * fun(product_prod(heap_ext(product_unit),set(nat)),bool) ) > fun(product_prod(heap_ext(product_unit),set(nat)),bool) ).

tff(sy_c_Assertions_Owand__raw__rel,type,
    wand_raw_rel: fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool)) ).

tff(sy_c_BNF__Cardinal__Arithmetic_OCsum,type,
    bNF_Cardinal_Csum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,set(product_prod(B,B))) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocexp,type,
    bNF_Cardinal_cexp: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * set(product_prod(A,A)) ) > set(product_prod(fun(A,B),fun(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocinfinite,type,
    bNF_Ca4139267488887388095finite: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocone,type,
    bNF_Cardinal_cone: set(product_prod(product_unit,product_unit)) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocprod,type,
    bNF_Cardinal_cprod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocsum,type,
    bNF_Cardinal_csum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(sum_sum(A,B),sum_sum(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Oczero,type,
    bNF_Cardinal_czero: 
      !>[A: $tType] : set(product_prod(A,A)) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OcardSuc,type,
    bNF_Ca8387033319878233205ardSuc: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_Ocard__of,type,
    bNF_Ca6860139660246222851ard_of: 
      !>[A: $tType] : ( set(A) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_Ocard__order__on,type,
    bNF_Ca8970107618336181345der_on: 
      !>[A: $tType] : ( set(A) > fun(set(product_prod(A,A)),bool) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OisCardSuc,type,
    bNF_Ca6246979054910435723ardSuc: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(set(product_prod(set(A),set(A))),bool) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OnatLeq,type,
    bNF_Ca8665028551170535155natLeq: set(product_prod(nat,nat)) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OnatLess,type,
    bNF_Ca8459412986667044542atLess: set(product_prod(nat,nat)) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OregularCard,type,
    bNF_Ca7133664381575040944arCard: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OrelChain,type,
    bNF_Ca3754400796208372196lChain: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,B) ) > $o ) ).

tff(sy_c_BNF__Composition_Oid__bnf,type,
    bNF_id_bnf: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_BNF__Def_OGrp,type,
    bNF_Grp: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > fun(A,fun(B,bool)) ) ).

tff(sy_c_BNF__Def_Ocollect,type,
    bNF_collect: 
      !>[B: $tType,A: $tType] : ( set(fun(B,set(A))) > fun(B,set(A)) ) ).

tff(sy_c_BNF__Def_Oeq__onp,type,
    bNF_eq_onp: 
      !>[A: $tType] : ( fun(A,bool) > fun(A,fun(A,bool)) ) ).

tff(sy_c_BNF__Def_Opick__middlep,type,
    bNF_pick_middlep: 
      !>[B: $tType,A: $tType,C: $tType] : ( ( fun(B,fun(A,bool)) * fun(A,fun(C,bool)) * B * C ) > A ) ).

tff(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,fun(C,bool)) * fun(B,fun(D,bool)) ) > fun(fun(A,B),fun(fun(C,D),bool)) ) ).

tff(sy_c_BNF__Def_Orel__set,type,
    bNF_rel_set: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(set(A),fun(set(B),bool)) ) ).

tff(sy_c_BNF__Def_Ovimage2p,type,
    bNF_vimage2p: 
      !>[A: $tType,D: $tType,B: $tType,E: $tType,C: $tType] : ( ( fun(A,D) * fun(B,E) * fun(D,fun(E,C)) ) > fun(A,fun(B,C)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OShift,type,
    bNF_Greatest_Shift: 
      !>[A: $tType] : ( ( set(list(A)) * A ) > set(list(A)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OSucc,type,
    bNF_Greatest_Succ: 
      !>[A: $tType] : ( ( set(list(A)) * list(A) ) > set(A) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OfromCard,type,
    bNF_Gr5436034075474128252omCard: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) * B ) > A ) ).

tff(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( set(C) * fun(C,A) * fun(C,B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_Oimage2p,type,
    bNF_Greatest_image2p: 
      !>[C: $tType,A: $tType,D: $tType,B: $tType] : ( ( fun(C,A) * fun(D,B) * fun(C,fun(D,bool)) * A * B ) > $o ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OrelImage,type,
    bNF_Gr4221423524335903396lImage: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * fun(B,A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OrelInvImage,type,
    bNF_Gr7122648621184425601vImage: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) * fun(A,B) ) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OtoCard,type,
    bNF_Greatest_toCard: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) ) > fun(A,B) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OtoCard__pred,type,
    bNF_Gr1419584066657907630d_pred: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) ) > fun(fun(A,B),bool) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_Ouniv,type,
    bNF_Greatest_univ: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > A ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(fun(A,B)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set(B) * fun(C,A) * fun(B,D) ) > fun(fun(D,C),fun(B,A)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Obsqr,type,
    bNF_Wellorder_bsqr: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(product_prod(A,A),product_prod(A,A))) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Ocurr,type,
    bNF_Wellorder_curr: 
      !>[A: $tType,B: $tType,C: $tType] : ( set(A) > fun(fun(product_prod(A,B),C),fun(A,fun(B,C))) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Odir__image,type,
    bNF_We2720479622203943262_image: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * fun(A,A2) ) > set(product_prod(A2,A2)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OofilterIncl,type,
    bNF_We413866401316099525erIncl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OordIso,type,
    bNF_Wellorder_ordIso: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_OordLeq,type,
    bNF_Wellorder_ordLeq: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_OordLess,type,
    bNF_We4044943003108391690rdLess: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_Oord__to__filter,type,
    bNF_We8469521843155493636filter: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(set(product_prod(A,A)),set(A)) ) ).

tff(sy_c_BNF__Wellorder__Embedding_Ocompat,type,
    bNF_Wellorder_compat: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Embedding_Oembed,type,
    bNF_Wellorder_embed: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) ) > fun(fun(A,A2),bool) ) ).

tff(sy_c_BNF__Wellorder__Embedding_OembedS,type,
    bNF_Wellorder_embedS: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Embedding_Oiso,type,
    bNF_Wellorder_iso: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel,type,
    bNF_Wellorder_wo_rel: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_OisMinim,type,
    bNF_We4791949203932849705sMinim: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > fun(A,bool) ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Omax2,type,
    bNF_We1388413361240627857o_max2: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A * A ) > A ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Ominim,type,
    bNF_We6954850376910717587_minim: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > A ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Osuc,type,
    bNF_Wellorder_wo_suc: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > A ) ).

tff(sy_c_Basic__BNFs_Ofsts,type,
    basic_fsts: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),set(A)) ).

tff(sy_c_Basic__BNFs_Ofstsp,type,
    basic_fstsp: 
      !>[A: $tType,B: $tType] : ( product_prod(A,B) > fun(A,bool) ) ).

tff(sy_c_Basic__BNFs_Opred__fun,type,
    basic_pred_fun: 
      !>[A: $tType,B: $tType] : ( fun(A,bool) > fun(fun(B,bool),fun(fun(A,B),bool)) ) ).

tff(sy_c_Basic__BNFs_Opred__prod,type,
    basic_pred_prod: 
      !>[A: $tType,B: $tType] : ( ( fun(A,bool) * fun(B,bool) ) > fun(product_prod(A,B),bool) ) ).

tff(sy_c_Basic__BNFs_Orel__prod,type,
    basic_rel_prod: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( fun(A,fun(B,bool)) * fun(C,fun(D,bool)) ) > fun(product_prod(A,C),fun(product_prod(B,D),bool)) ) ).

tff(sy_c_Basic__BNFs_Osetl,type,
    basic_setl: 
      !>[A: $tType,B: $tType] : fun(sum_sum(A,B),set(A)) ).

tff(sy_c_Basic__BNFs_Osetlp,type,
    basic_setlp: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,B) > fun(A,bool) ) ).

tff(sy_c_Basic__BNFs_Osetr,type,
    basic_setr: 
      !>[A: $tType,B: $tType] : fun(sum_sum(A,B),set(B)) ).

tff(sy_c_Basic__BNFs_Osetrp,type,
    basic_setrp: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,B) > fun(B,bool) ) ).

tff(sy_c_Basic__BNFs_Osnds,type,
    basic_snds: 
      !>[A: $tType,B: $tType] : ( product_prod(A,B) > set(B) ) ).

tff(sy_c_Basic__BNFs_Osndsp,type,
    basic_sndsp: 
      !>[A: $tType,B: $tType] : ( product_prod(A,B) > fun(B,bool) ) ).

tff(sy_c_Binomial_Obinomial,type,
    binomial: nat > fun(nat,nat) ).

tff(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > fun(nat,A) ) ).

tff(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: fun(product_prod(int,int),fun(product_prod(int,int),bool)) ).

tff(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: fun(product_prod(num,num),fun(product_prod(num,num),bool)) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > fun(nat,bool) ) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself(A) * nat ) > bool ) ).

tff(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: ( nat * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: fun(product_prod(num,num),fun(product_prod(num,num),bool)) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: ( num * num ) > option(num) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__axioms,type,
    boolea6902313364301356556axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff__axioms,type,
    boolea5476839437570043046axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > product_prod(code_integer,bool) ).

tff(sy_c_Code__Numeral_Ocr__integer,type,
    code_cr_integer: ( int * code_integer ) > $o ).

tff(sy_c_Code__Numeral_Ocr__natural,type,
    code_cr_natural: ( nat * code_natural ) > $o ).

tff(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Odup,type,
    code_dup: fun(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: fun(code_integer,int) ).

tff(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: fun(int,code_integer) ).

tff(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

tff(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

tff(sy_c_Code__Numeral_Onatural_Ocase__natural,type,
    code_case_natural: 
      !>[T: $tType] : ( ( T * fun(code_natural,T) ) > fun(code_natural,T) ) ).

tff(sy_c_Code__Numeral_Onatural_Onat__of__natural,type,
    code_nat_of_natural: code_natural > nat ).

tff(sy_c_Code__Numeral_Onatural_Onatural__of__nat,type,
    code_natural_of_nat: nat > code_natural ).

tff(sy_c_Code__Numeral_Onatural_Orec__natural,type,
    code_rec_natural: 
      !>[T: $tType] : ( ( T * fun(code_natural,fun(T,T)) ) > fun(code_natural,T) ) ).

tff(sy_c_Code__Numeral_Onatural_Orec__set__natural,type,
    code_rec_set_natural: 
      !>[T: $tType] : ( ( T * fun(code_natural,fun(T,T)) * code_natural ) > fun(T,bool) ) ).

tff(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

tff(sy_c_Code__Numeral_Opcr__integer,type,
    code_pcr_integer: fun(int,fun(code_integer,bool)) ).

tff(sy_c_Code__Numeral_Osub,type,
    code_sub: fun(num,fun(num,code_integer)) ).

tff(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complete__Partial__Order_Occpo_Oadmissible,type,
    comple1908693960933563346ssible: 
      !>[A: $tType] : ( ( fun(set(A),A) * fun(A,fun(A,bool)) * fun(A,bool) ) > $o ) ).

tff(sy_c_Complete__Partial__Order_Occpo_Ofixp,type,
    comple187402453842119260l_fixp: 
      !>[A: $tType] : ( ( fun(set(A),A) * fun(A,fun(A,bool)) * fun(A,A) ) > A ) ).

tff(sy_c_Complete__Partial__Order_Occpo__class_Ofixp,type,
    comple115746919287870866o_fixp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Complete__Partial__Order_Occpo__class_Oiterates,type,
    comple6359979572994053840erates: 
      !>[A: $tType] : ( fun(A,A) > set(A) ) ).

tff(sy_c_Complete__Partial__Order_Occpo__class_Oiteratesp,type,
    comple7512665784863727008ratesp: 
      !>[A: $tType] : ( fun(A,A) > fun(A,bool) ) ).

tff(sy_c_Complete__Partial__Order_Ochain,type,
    comple1602240252501008431_chain: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * set(A) ) > $o ) ).

tff(sy_c_Complete__Partial__Order_Omonotone,type,
    comple7038119648293358887notone: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,fun(B,bool)) * fun(A,B) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__above,type,
    condit8047198070973881523_above: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * set(A) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__below,type,
    condit8119078960628432327_below: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(set(A),bool) ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : fun(set(A),bool) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreordering__bdd,type,
    condit622319405099724424ng_bdd: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreordering__bdd_Obdd,type,
    condit16957441358409770ng_bdd: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(set(A),bool) ) ).

tff(sy_c_Countable_Onat__to__rat__surj,type,
    nat_to_rat_surj: nat > rat ).

tff(sy_c_Countable_Oto__nat,type,
    to_nat: 
      !>[A: $tType] : fun(A,nat) ).

tff(sy_c_Divides_Oadjust__div,type,
    adjust_div: product_prod(int,int) > int ).

tff(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( ( num * num ) > product_prod(A,A) ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( ( num * product_prod(A,A) ) > product_prod(A,A) ) ).

tff(sy_c_Equiv__Relations_Ocongruent,type,
    equiv_congruent: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,B) ) > $o ) ).

tff(sy_c_Equiv__Relations_Ocongruent2,type,
    equiv_congruent2: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) * fun(A,fun(B,C)) ) > $o ) ).

tff(sy_c_Equiv__Relations_Oequiv,type,
    equiv_equiv: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Equiv__Relations_Oequivp,type,
    equiv_equivp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Equiv__Relations_Opart__equivp,type,
    equiv_part_equivp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Equiv__Relations_Oproj,type,
    equiv_proj: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,A)) * B ) > set(A) ) ).

tff(sy_c_Equiv__Relations_Oquotient,type,
    equiv_quotient: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > set(set(A)) ) ).

tff(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : ( A > nat ) ).

tff(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( ( A * nat ) > A ) ).

tff(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Ocofinite,type,
    cofinite: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( fun(A,bool) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofilter_OAbs__filter,type,
    abs_filter: 
      !>[A: $tType] : fun(fun(fun(A,bool),bool),filter(A)) ).

tff(sy_c_Filter_Ofilter_ORep__filter,type,
    rep_filter: 
      !>[A: $tType] : fun(filter(A),fun(fun(A,bool),bool)) ).

tff(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) ) > filter(A) ) ).

tff(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Ofinite__subsets__at__top,type,
    finite5375528669736107172at_top: 
      !>[A: $tType] : ( set(A) > filter(set(A)) ) ).

tff(sy_c_Filter_Ofrequently,type,
    frequently: 
      !>[A: $tType] : ( ( fun(A,bool) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ois__filter,type,
    is_filter: 
      !>[A: $tType] : fun(fun(fun(A,bool),bool),bool) ).

tff(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( set(A) > filter(A) ) ).

tff(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter(A) * filter(B) ) > filter(product_prod(A,B)) ) ).

tff(sy_c_Filter_Orel__filter,type,
    rel_filter: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(filter(A),fun(filter(B),bool)) ) ).

tff(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : fun(set(B),nat) ).

tff(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofinite,type,
    finite_finite2: 
      !>[A: $tType] : fun(set(A),bool) ).

tff(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > B ) ).

tff(sy_c_Finite__Set_Ofold__graph,type,
    finite_fold_graph: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > fun(B,bool) ) ).

tff(sy_c_Finite__Set_Ofolding,type,
    finite_folding: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B ) > fun(set(A),B) ) ).

tff(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) * set(B) ) > $o ) ).

tff(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( fun(B,C) > fun(fun(A,B),fun(A,C)) ) ).

tff(sy_c_Fun_Ofcomp,type,
    fcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,B) * fun(B,C) ) > fun(A,C) ) ).

tff(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A * B ) > fun(A,B) ) ).

tff(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( fun(C,A) * fun(B,D) ) > fun(fun(A,B),fun(C,D)) ) ).

tff(sy_c_Fun_Ooverride__on,type,
    override_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * fun(A,B) * set(A) ) > fun(A,B) ) ).

tff(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * B ) > A ) ).

tff(sy_c_Fun__Def_OTHE__default,type,
    fun_THE_default: 
      !>[A: $tType] : ( ( A * fun(A,bool) ) > A ) ).

tff(sy_c_Fun__Def_Orp__inv__image,type,
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] : fun(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))) ).

tff(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_OGcd__class_OLcm,type,
    gcd_Lcm: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice,type,
    bounde8507323023520639062attice: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A * fun(A,A) ) > $o ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set,type,
    bounde6485984586167503788ce_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A * fun(A,A) ) > $o ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set_OF,type,
    bounde2362111253966948842tice_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A ) > fun(set(A),A) ) ).

tff(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Ogcd__class_Olcm,type,
    gcd_lcm: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( itself(A) > nat ) ).

tff(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_GCD_Osemiring__gcd__class_OLcm__fin,type,
    semiring_gcd_Lcm_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Groups_Oabel__semigroup,type,
    abel_semigroup: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Oabel__semigroup__axioms,type,
    abel_s757365448890700780axioms: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ocomm__monoid,type,
    comm_monoid: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Ocomm__monoid__axioms,type,
    comm_monoid_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Ogroup,type,
    group: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,A) ) > $o ) ).

tff(sy_c_Groups_Ogroup__axioms,type,
    group_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,A) ) > $o ) ).

tff(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Omonoid,type,
    monoid: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Omonoid__axioms,type,
    monoid_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

tff(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Osemigroup,type,
    semigroup: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

tff(sy_c_Groups__Big_Ocomm__monoid__add_Osum,type,
    groups3894954378712506084id_sum: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A * fun(B,A) * set(B) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : fun(fun(C,A),fun(set(C),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set,type,
    groups778175481326437816id_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set_OF,type,
    groups_comm_monoid_F: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(fun(B,A),fun(set(B),A)) ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set_OG,type,
    groups_comm_monoid_G: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(fun(B,A),fun(set(B),A)) ) ).

tff(sy_c_Groups__List_Ocomm__monoid__list,type,
    groups1828464146339083142d_list: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Ocomm__monoid__list__set,type,
    groups4802862169904069756st_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(A,fun(list(B),A))) ).

tff(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_Groups__List_Omonoid__list,type,
    groups_monoid_list: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Omonoid__list_OF,type,
    groups_monoid_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(list(A),A) ) ).

tff(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( fun(A,bool) > A ) ).

tff(sy_c_HOL_OUniq,type,
    uniq: 
      !>[A: $tType] : ( fun(A,bool) > $o ) ).

tff(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

tff(sy_c_Heap_Oaddr__of__array,type,
    addr_of_array: 
      !>[A: $tType] : ( array(A) > nat ) ).

tff(sy_c_Heap_Oaddr__of__ref,type,
    addr_of_ref: 
      !>[A: $tType] : ( ref(A) > nat ) ).

tff(sy_c_Heap_Oarray_OArray,type,
    array2: 
      !>[A: $tType] : ( nat > array(A) ) ).

tff(sy_c_Heap_Oarray_Omap__array,type,
    map_array: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(array(A),array(Aa)) ) ).

tff(sy_c_Heap_Oarray_Opred__array,type,
    pred_array: 
      !>[A: $tType] : ( ( fun(A,bool) * array(A) ) > $o ) ).

tff(sy_c_Heap_Oarray_Orec__array,type,
    rec_array: 
      !>[C: $tType,A: $tType] : ( fun(nat,C) > fun(array(A),C) ) ).

tff(sy_c_Heap_Oarray_Orel__array,type,
    rel_array: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(array(A),fun(array(B),bool)) ) ).

tff(sy_c_Heap_Oarray_Oset__array,type,
    set_array: 
      !>[A: $tType] : ( array(A) > set(A) ) ).

tff(sy_c_Heap_Oempty,type,
    empty: heap_ext(product_unit) ).

tff(sy_c_Heap_Oheap_Oarrays,type,
    arrays: 
      !>[Z: $tType] : ( ( heap_ext(Z) * typerep * nat ) > list(nat) ) ).

tff(sy_c_Heap_Oheap_Oarrays__update,type,
    arrays_update: 
      !>[Z: $tType] : ( fun(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat)))) > fun(heap_ext(Z),heap_ext(Z)) ) ).

tff(sy_c_Heap_Oheap_Oheap__ext,type,
    heap_ext2: 
      !>[Z: $tType] : ( ( fun(typerep,fun(nat,list(nat))) * fun(typerep,fun(nat,nat)) * nat * Z ) > heap_ext(Z) ) ).

tff(sy_c_Heap_Oheap_Olim,type,
    lim: 
      !>[Z: $tType] : ( heap_ext(Z) > nat ) ).

tff(sy_c_Heap_Oheap_Olim__update,type,
    lim_update: 
      !>[Z: $tType] : ( ( fun(nat,nat) * heap_ext(Z) ) > heap_ext(Z) ) ).

tff(sy_c_Heap_Oheap_Orefs,type,
    refs: 
      !>[Z: $tType] : ( ( heap_ext(Z) * typerep * nat ) > nat ) ).

tff(sy_c_Heap_Oheap_Orefs__update,type,
    refs_update: 
      !>[Z: $tType] : ( fun(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat))) > fun(heap_ext(Z),heap_ext(Z)) ) ).

tff(sy_c_Heap_Oref_ORef,type,
    ref2: 
      !>[A: $tType] : ( nat > ref(A) ) ).

tff(sy_c_Heap_Oref_Omap__ref,type,
    map_ref: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(ref(A),ref(Aa)) ) ).

tff(sy_c_Heap_Oref_Opred__ref,type,
    pred_ref: 
      !>[A: $tType] : ( ( fun(A,bool) * ref(A) ) > $o ) ).

tff(sy_c_Heap_Oref_Orec__ref,type,
    rec_ref: 
      !>[C: $tType,A: $tType] : ( fun(nat,C) > fun(ref(A),C) ) ).

tff(sy_c_Heap_Oref_Orel__ref,type,
    rel_ref: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(ref(A),fun(ref(B),bool)) ) ).

tff(sy_c_Heap_Oref_Oset__ref,type,
    set_ref: 
      !>[A: $tType] : ( ref(A) > set(A) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_OHeap,type,
    heap_Time_Heap2: 
      !>[A: $tType] : ( fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_Omap__Heap,type,
    heap_Time_map_Heap: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(heap_Time_Heap(A),heap_Time_Heap(Aa)) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_Opred__Heap,type,
    heap_Time_pred_Heap: 
      !>[A: $tType] : ( ( fun(A,bool) * heap_Time_Heap(A) ) > $o ) ).

tff(sy_c_Heap__Time__Monad_OHeap_Orec__Heap,type,
    heap_Time_rec_Heap: 
      !>[A: $tType,C: $tType] : ( fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C) > fun(heap_Time_Heap(A),C) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_Orel__Heap,type,
    heap_Time_rel_Heap: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_Oset__Heap,type,
    heap_Time_set_Heap: 
      !>[A: $tType] : ( heap_Time_Heap(A) > set(A) ) ).

tff(sy_c_Heap__Time__Monad_OHeap__lub,type,
    heap_Time_Heap_lub: 
      !>[A: $tType] : fun(set(heap_Time_Heap(A)),heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_OHeap__ord,type,
    heap_Time_Heap_ord: 
      !>[A: $tType] : fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool)) ).

tff(sy_c_Heap__Time__Monad_Obind,type,
    heap_Time_bind: 
      !>[A: $tType,B: $tType] : ( ( heap_Time_Heap(A) * fun(A,heap_Time_Heap(B)) ) > heap_Time_Heap(B) ) ).

tff(sy_c_Heap__Time__Monad_Oeffect,type,
    heap_Time_effect: 
      !>[A: $tType] : ( ( heap_Time_Heap(A) * heap_ext(product_unit) * heap_ext(product_unit) * A * nat ) > $o ) ).

tff(sy_c_Heap__Time__Monad_Oexecute,type,
    heap_Time_execute: 
      !>[A: $tType] : ( heap_Time_Heap(A) > fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))) ) ).

tff(sy_c_Heap__Time__Monad_Oguard,type,
    heap_Time_guard: 
      !>[A: $tType] : ( ( fun(heap_ext(product_unit),bool) * fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Oheap,type,
    heap_Time_heap: 
      !>[A: $tType] : ( fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Olift,type,
    heap_Time_lift: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(A,heap_Time_Heap(B)) ) ).

tff(sy_c_Heap__Time__Monad_Oraise,type,
    heap_Time_raise: 
      !>[A: $tType] : ( list(char) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Oreturn,type,
    heap_Time_return: 
      !>[A: $tType] : fun(A,heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_Osuccess,type,
    heap_Time_success: 
      !>[A: $tType] : ( ( heap_Time_Heap(A) * heap_ext(product_unit) ) > $o ) ).

tff(sy_c_Heap__Time__Monad_Otap,type,
    heap_Time_tap: 
      !>[A: $tType] : ( fun(heap_ext(product_unit),A) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_OtimeFrame,type,
    heap_Time_timeFrame: 
      !>[A: $tType] : ( ( nat * option(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) > option(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ).

tff(sy_c_Heap__Time__Monad_Oureturn,type,
    heap_Time_ureturn: 
      !>[A: $tType] : ( A > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Owait,type,
    heap_Time_wait: nat > heap_Time_Heap(product_unit) ).

tff(sy_c_Hilbert__Choice_Oinv__into,type,
    hilbert_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * B ) > A ) ).

tff(sy_c_Hoare__Triple_Ohoare__triple,type,
    hoare_hoare_triple: 
      !>[A: $tType] : ( ( assn * heap_Time_Heap(A) * fun(A,assn) ) > $o ) ).

tff(sy_c_Hoare__Triple_Onew__addrs,type,
    hoare_new_addrs: ( heap_ext(product_unit) * set(nat) * heap_ext(product_unit) ) > set(nat) ).

tff(sy_c_If,type,
    if: 
      !>[A: $tType] : ( ( bool * A * A ) > A ) ).

tff(sy_c_Inductive_Ocomplete__lattice__class_Ogfp,type,
    complete_lattice_gfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Inductive_Ocomplete__lattice__class_Olfp,type,
    complete_lattice_lfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set(A) * nat ) > A ) ).

tff(sy_c_Int_OAbs__Integ,type,
    abs_Integ: fun(product_prod(nat,nat),int) ).

tff(sy_c_Int_ORep__Integ,type,
    rep_Integ: fun(int,product_prod(nat,nat)) ).

tff(sy_c_Int_Ocr__int,type,
    cr_int: product_prod(nat,nat) > fun(int,bool) ).

tff(sy_c_Int_Oint_OAbs__int,type,
    abs_int: fun(set(product_prod(nat,nat)),int) ).

tff(sy_c_Int_Oint_ORep__int,type,
    rep_int: fun(int,set(product_prod(nat,nat))) ).

tff(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Ointrel,type,
    intrel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)) ).

tff(sy_c_Int_Onat,type,
    nat2: fun(int,nat) ).

tff(sy_c_Int_Opcr__int,type,
    pcr_int: fun(product_prod(nat,nat),fun(int,bool)) ).

tff(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( ( A * int ) > A ) ).

tff(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : fun(int,A) ).

tff(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices_Osemilattice,type,
    semilattice: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices_Osemilattice__axioms,type,
    semilattice_axioms: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices_Osemilattice__neutr,type,
    semilattice_neutr: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__order,type,
    semilattice_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__order__axioms,type,
    semila6385135966242565138axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices__Big_Olinorder_OMax,type,
    lattices_Max: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(set(A),A) ) ).

tff(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(set(A),A) ) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lattices__Big_Oord_Oarg__max,type,
    lattices_arg_max: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,A) * fun(B,bool) ) > B ) ).

tff(sy_c_Lattices__Big_Oord_Oarg__max__on,type,
    lattices_arg_max_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Lattices__Big_Oord_Oarg__min,type,
    lattices_arg_min: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,A) * fun(B,bool) ) > B ) ).

tff(sy_c_Lattices__Big_Oord_Oarg__min__on,type,
    lattices_arg_min_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Lattices__Big_Oord_Ois__arg__max,type,
    lattices_is_arg_max: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,A) * fun(B,bool) ) > fun(B,bool) ) ).

tff(sy_c_Lattices__Big_Oord_Ois__arg__min,type,
    lattices_is_arg_min: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,A) * fun(B,bool) ) > fun(B,bool) ) ).

tff(sy_c_Lattices__Big_Oord__class_Oarg__min,type,
    lattices_ord_arg_min: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * fun(B,bool) ) > B ) ).

tff(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Lattices__Big_Oord__class_Ois__arg__min,type,
    lattic501386751177426532rg_min: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * fun(B,bool) ) > fun(B,bool) ) ).

tff(sy_c_Lattices__Big_Osemilattice__inf_OInf__fin,type,
    lattic8678736583308907530nf_fin: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lattices__Big_Osemilattice__neutr__set,type,
    lattic5652469242046573047tr_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__neutr__set_OF,type,
    lattic5214292709420241887eutr_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__order__set,type,
    lattic4895041142388067077er_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__set,type,
    lattic149705377957585745ce_set: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__set_OF,type,
    lattic1715443433743089157tice_F: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > fun(set(A),A) ) ).

tff(sy_c_Lattices__Big_Osemilattice__sup_OSup__fin,type,
    lattic4630905495605216202up_fin: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lifting_OQuotient,type,
    quotient: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,B) * fun(B,A) * fun(A,fun(B,bool)) ) > $o ) ).

tff(sy_c_Lifting_Orel__pred__comp,type,
    rel_pred_comp: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,bool)) * fun(B,bool) * A ) > $o ) ).

tff(sy_c_List_OBleast,type,
    bleast: 
      !>[A: $tType] : ( ( set(A) * fun(A,bool) ) > A ) ).

tff(sy_c_List_Oabort__Bleast,type,
    abort_Bleast: 
      !>[A: $tType] : ( ( set(A) * fun(A,bool) ) > A ) ).

tff(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * list(A) ) > A ) ).

tff(sy_c_List_Oarg__min__list__rel,type,
    arg_min_list_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(fun(A,B),list(A)),fun(product_prod(fun(A,B),list(A)),bool)) ).

tff(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list(A) * fun(A,list(B)) ) > list(B) ) ).

tff(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( list(list(A)) > list(A) ) ).

tff(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( list(A) > set(A) ) ).

tff(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list(A) * A ) > nat ) ).

tff(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( list(A) > $o ) ).

tff(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(product_prod(nat,A)) ) ).

tff(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > option(product_prod(list(A),product_prod(A,list(A)))) ) ).

tff(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( fun(A,bool) > fun(list(A),list(A)) ) ).

tff(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > option(A) ) ).

tff(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) * set(B) * fun(B,A) ) > $o ) ).

tff(sy_c_List_Ofoldl,type,
    foldl: 
      !>[B: $tType,A: $tType] : ( ( fun(B,fun(A,B)) * B * list(A) ) > B ) ).

tff(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Olast,type,
    last: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(nat,set(product_prod(list(A),list(A)))) ) ).

tff(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,A) * B * list(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,A) * set(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder__class_Oinsort__insert__key,type,
    linord329482645794927042rt_key: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * B * list(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( fun(B,A) > fun(B,fun(list(B),list(B))) ) ).

tff(sy_c_List_Olinorder__class_Osort__key,type,
    linorder_sort_key: 
      !>[B: $tType,A: $tType] : ( fun(B,A) > fun(list(B),list(B)) ) ).

tff(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( fun(B,A) > fun(set(B),list(B)) ) ).

tff(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : fun(set(A),list(A)) ).

tff(sy_c_List_Olinorder__class_Ostable__sort__key,type,
    linord3483353639454293061rt_key: 
      !>[B: $tType,A: $tType] : ( fun(fun(B,A),fun(list(B),list(B))) > $o ) ).

tff(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : fun(A,fun(list(A),list(A))) ).

tff(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : list(A) ).

tff(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,fun(list(A),B)) ) > fun(list(A),B) ) ).

tff(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(list(A),fun(list(B),bool)) ) ).

tff(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(list(A),list(Aa)) ) ).

tff(sy_c_List_Olist_Orec__list,type,
    rec_list: 
      !>[C: $tType,A: $tType] : ( ( C * fun(A,fun(list(A),fun(C,C))) ) > fun(list(A),C) ) ).

tff(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : fun(list(A),set(A)) ).

tff(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( fun(A,nat) * list(A) ) > nat ) ).

tff(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list(A) * nat * A ) > list(A) ) ).

tff(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(list(A),list(B))) ) ).

tff(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(list(A),fun(list(B),bool)) ) ).

tff(sy_c_List_Olists,type,
    lists: 
      !>[A: $tType] : ( set(A) > set(list(A)) ) ).

tff(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( list(set(A)) > set(list(A)) ) ).

tff(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * list(A) ) > list(B) ) ).

tff(sy_c_List_Omap__project,type,
    map_project: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * set(A) ) > set(B) ) ).

tff(sy_c_List_Omeasures,type,
    measures: 
      !>[A: $tType] : ( list(fun(A,nat)) > set(product_prod(A,A)) ) ).

tff(sy_c_List_Omin__list,type,
    min_list: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_List_Omin__list__rel,type,
    min_list_rel: 
      !>[A: $tType] : fun(list(A),fun(list(A),bool)) ).

tff(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(list(A)) ) ).

tff(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( list(A) > fun(nat,A) ) ).

tff(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list(A) * set(nat) ) > list(A) ) ).

tff(sy_c_List_Oord_Olexordp,type,
    lexordp2: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(list(A),fun(list(A),bool)) ) ).

tff(sy_c_List_Oord__class_Olexordp,type,
    ord_lexordp: 
      !>[A: $tType] : fun(list(A),fun(list(A),bool)) ).

tff(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( fun(A,bool) > fun(list(A),product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > fun(list(A),list(A)) ) ).

tff(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( ( nat * A ) > list(A) ) ).

tff(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set(A) * set(list(A)) ) > set(list(A)) ) ).

tff(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > set(list(A)) ) ).

tff(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),bool)) ).

tff(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) ) > $o ) ).

tff(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( list(A) > list(list(A)) ) ).

tff(sy_c_List_Osuccessively,type,
    successively: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(list(A),bool) ) ).

tff(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > list(A) ) ).

tff(sy_c_List_Othose,type,
    those: 
      !>[A: $tType] : ( list(option(A)) > option(list(A)) ) ).

tff(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : fun(list(list(A)),fun(list(list(A)),bool)) ).

tff(sy_c_List_Oupt,type,
    upt: ( nat * nat ) > list(nat) ).

tff(sy_c_List_Oupto,type,
    upto: ( int * int ) > list(int) ).

tff(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_Map_Odom,type,
    dom: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(A) ) ).

tff(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(product_prod(A,B)) ) ).

tff(sy_c_Map_Omap__add,type,
    map_add: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * fun(A,option(B)) ) > fun(A,option(B)) ) ).

tff(sy_c_Map_Omap__comp,type,
    map_comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( fun(B,option(C)) * fun(A,option(B)) * A ) > option(C) ) ).

tff(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( list(product_prod(A,B)) > fun(A,option(B)) ) ).

tff(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * list(A) * list(B) ) > fun(A,option(B)) ) ).

tff(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(B) ) ).

tff(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * set(A) ) > fun(A,option(B)) ) ).

tff(sy_c_Misc_OEps__Opt,type,
    eps_Opt: 
      !>[A: $tType] : ( fun(A,bool) > option(A) ) ).

tff(sy_c_Misc_Obijective,type,
    bijective: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > $o ) ).

tff(sy_c_Misc_Obrk__rel,type,
    brk_rel: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(product_prod(bool,A),product_prod(bool,B))) ) ).

tff(sy_c_Misc_Odflt__None__set,type,
    dflt_None_set: 
      !>[A: $tType] : ( set(A) > option(set(A)) ) ).

tff(sy_c_Misc_Ofun__of__rel,type,
    fun_of_rel: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,A)) * B ) > A ) ).

tff(sy_c_Misc_Oinv__on,type,
    inv_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) * B ) > A ) ).

tff(sy_c_Misc_Olist__all__zip,type,
    list_all_zip: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,bool)) * list(A) * list(B) ) > $o ) ).

tff(sy_c_Misc_Olist__collect__set,type,
    list_collect_set: 
      !>[B: $tType,A: $tType] : ( ( fun(B,set(A)) * list(B) ) > set(A) ) ).

tff(sy_c_Misc_Omap__mmupd,type,
    map_mmupd: 
      !>[B: $tType,A: $tType] : ( ( fun(B,option(A)) * set(B) * A ) > fun(B,option(A)) ) ).

tff(sy_c_Misc_Omap__to__set,type,
    map_to_set: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(product_prod(A,B)) ) ).

tff(sy_c_Misc_Omerge__list,type,
    merge_list: 
      !>[A: $tType] : ( ( list(list(A)) * list(list(A)) ) > list(A) ) ).

tff(sy_c_Misc_Omergesort,type,
    mergesort: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_Misc_Omergesort__by__rel,type,
    mergesort_by_rel: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(list(A),list(A)) ) ).

tff(sy_c_Misc_Omergesort__by__rel__merge,type,
    merges9089515139780605204_merge: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Omergesort__by__rel__split,type,
    merges295452479951948502_split: 
      !>[A: $tType] : ( ( product_prod(list(A),list(A)) * list(A) ) > product_prod(list(A),list(A)) ) ).

tff(sy_c_Misc_Omergesort__remdups,type,
    mergesort_remdups: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_Misc_Opairself,type,
    pairself: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(product_prod(A,A),product_prod(B,B)) ) ).

tff(sy_c_Misc_Opartition__rev,type,
    partition_rev: 
      !>[A: $tType] : ( ( fun(A,bool) * product_prod(list(A),list(A)) * list(A) ) > product_prod(list(A),list(A)) ) ).

tff(sy_c_Misc_Oquicksort__by__rel,type,
    quicksort_by_rel: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) ) > fun(list(A),list(A)) ) ).

tff(sy_c_Misc_Oquicksort__by__rel__rel,type,
    quicksort_by_rel_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),fun(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool)) ).

tff(sy_c_Misc_Orel__of,type,
    rel_of: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * fun(product_prod(A,B),bool) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Misc_Orel__restrict,type,
    rel_restrict: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Misc_Oremove__rev,type,
    remove_rev: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Oset__to__map,type,
    set_to_map: 
      !>[B: $tType,A: $tType] : ( set(product_prod(B,A)) > fun(B,option(A)) ) ).

tff(sy_c_Misc_Oslice,type,
    slice: 
      !>[A: $tType] : ( ( nat * nat * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Osu__rel__fun,type,
    su_rel_fun: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,B)) * fun(A,B) ) > $o ) ).

tff(sy_c_Misc_Othe__default,type,
    the_default: 
      !>[A: $tType] : ( ( A * option(A) ) > A ) ).

tff(sy_c_Misc_Ouncurry,type,
    uncurry: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(A,fun(B,C)) > fun(product_prod(A,B),C) ) ).

tff(sy_c_Multiset_Oadd__mset,type,
    add_mset: 
      !>[A: $tType] : fun(A,fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Ocomm__monoid__add__class_Osum__mset,type,
    comm_m7189776963980413722m_mset: 
      !>[A: $tType] : ( multiset(A) > A ) ).

tff(sy_c_Multiset_Ocomm__monoid__mset,type,
    comm_monoid_mset: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Multiset_Ocomm__monoid__mset_OF,type,
    comm_monoid_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(multiset(A),A) ) ).

tff(sy_c_Multiset_Ocomm__monoid__mult__class_Oprod__mset,type,
    comm_m9189036328036947845d_mset: 
      !>[A: $tType] : fun(multiset(A),A) ).

tff(sy_c_Multiset_Ocr__multiset,type,
    cr_multiset: 
      !>[A: $tType] : fun(fun(A,nat),fun(multiset(A),bool)) ).

tff(sy_c_Multiset_Ofilter__mset,type,
    filter_mset: 
      !>[A: $tType] : fun(fun(A,bool),fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Ofold__mset,type,
    fold_mset: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * multiset(A) ) > B ) ).

tff(sy_c_Multiset_Oimage__mset,type,
    image_mset: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(multiset(A),multiset(B)) ) ).

tff(sy_c_Multiset_Ointer__mset,type,
    inter_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Olinorder__class_Opart,type,
    linorder_part: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * A * list(B) ) > product_prod(list(B),product_prod(list(B),list(B))) ) ).

tff(sy_c_Multiset_Olinorder__class_Osorted__list__of__multiset,type,
    linord6283353356039996273ltiset: 
      !>[A: $tType] : ( multiset(A) > list(A) ) ).

tff(sy_c_Multiset_Omset,type,
    mset: 
      !>[A: $tType] : ( list(A) > multiset(A) ) ).

tff(sy_c_Multiset_Omset__set,type,
    mset_set: 
      !>[B: $tType] : ( set(B) > multiset(B) ) ).

tff(sy_c_Multiset_Omult,type,
    mult: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(multiset(A),multiset(A))) ) ).

tff(sy_c_Multiset_Omult1,type,
    mult1: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(multiset(A),multiset(A))) ) ).

tff(sy_c_Multiset_Omulteqp__code,type,
    multeqp_code: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * multiset(A) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Omultiset_OAbs__multiset,type,
    abs_multiset: 
      !>[A: $tType] : fun(fun(A,nat),multiset(A)) ).

tff(sy_c_Multiset_Omultiset_Ocount,type,
    count: 
      !>[A: $tType] : fun(multiset(A),fun(A,nat)) ).

tff(sy_c_Multiset_Omultp,type,
    multp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(multiset(A),fun(multiset(A),bool)) ) ).

tff(sy_c_Multiset_Omultp__code,type,
    multp_code: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * multiset(A) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Opcr__multiset,type,
    pcr_multiset: 
      !>[C: $tType,B: $tType] : ( fun(C,fun(B,bool)) > fun(fun(C,nat),fun(multiset(B),bool)) ) ).

tff(sy_c_Multiset_Orel__mset,type,
    rel_mset: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(multiset(A),fun(multiset(B),bool)) ) ).

tff(sy_c_Multiset_Orepeat__mset,type,
    repeat_mset: 
      !>[A: $tType] : fun(nat,fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Oreplicate__mset,type,
    replicate_mset: 
      !>[A: $tType] : ( ( nat * A ) > multiset(A) ) ).

tff(sy_c_Multiset_Oset__mset,type,
    set_mset: 
      !>[A: $tType] : fun(multiset(A),set(A)) ).

tff(sy_c_Multiset_Osize__multiset,type,
    size_multiset: 
      !>[A: $tType] : ( fun(A,nat) > fun(multiset(A),nat) ) ).

tff(sy_c_Multiset_Osubset__eq__mset__impl,type,
    subset_eq_mset_impl: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > option(bool) ) ).

tff(sy_c_Multiset_Osubset__eq__mset__impl__rel,type,
    subset751672762298770561pl_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),bool)) ).

tff(sy_c_Multiset_Osubset__mset,type,
    subset_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),bool)) ).

tff(sy_c_Multiset_Osubseteq__mset,type,
    subseteq_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),bool)) ).

tff(sy_c_Multiset_Ounion__mset,type,
    union_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Owcount,type,
    wcount: 
      !>[A: $tType] : ( ( fun(A,nat) * multiset(A) ) > fun(A,nat) ) ).

tff(sy_c_Nat_OSuc,type,
    suc: fun(nat,nat) ).

tff(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : fun(A,fun(fun(nat,A),fun(nat,A))) ).

tff(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

tff(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( ( T * fun(nat,fun(T,T)) ) > fun(nat,T) ) ).

tff(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( ( T * fun(nat,fun(T,T)) * nat ) > fun(T,bool) ) ).

tff(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : fun(nat,A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( fun(A,A) * nat * A ) > A ) ).

tff(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : fun(A,nat) ).

tff(sy_c_Nat__Bijection_Oint__decode,type,
    nat_int_decode: nat > int ).

tff(sy_c_Nat__Bijection_Olist__decode,type,
    nat_list_decode: nat > list(nat) ).

tff(sy_c_Nat__Bijection_Olist__decode__rel,type,
    nat_list_decode_rel: fun(nat,fun(nat,bool)) ).

tff(sy_c_Nat__Bijection_Oprod__decode,type,
    nat_prod_decode: nat > product_prod(nat,nat) ).

tff(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: fun(product_prod(nat,nat),nat) ).

tff(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > set(nat) ).

tff(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: set(nat) > nat ).

tff(sy_c_Nat__Bijection_Osum__decode,type,
    nat_sum_decode: nat > sum_sum(nat,nat) ).

tff(sy_c_Nat__Bijection_Osum__encode,type,
    nat_sum_encode: sum_sum(nat,nat) > nat ).

tff(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

tff(sy_c_Num_OBitM,type,
    bitM: num > num ).

tff(sy_c_Num_Oinc,type,
    inc: num > num ).

tff(sy_c_Num_Onat__of__num,type,
    nat_of_num: num > nat ).

tff(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Ois__num,type,
    neg_numeral_is_num: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( ( num * num ) > A ) ).

tff(sy_c_Num_Onum_OBit0,type,
    bit0: fun(num,num) ).

tff(sy_c_Num_Onum_OBit1,type,
    bit1: fun(num,num) ).

tff(sy_c_Num_Onum_OOne,type,
    one2: num ).

tff(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( ( A * fun(num,A) * fun(num,A) * num ) > A ) ).

tff(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

tff(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : fun(num,A) ).

tff(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

tff(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Osqr,type,
    sqr: num > num ).

tff(sy_c_Old__Datatype_OAtom,type,
    old_Atom: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,nat) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OCase,type,
    old_Case: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(set(old_node(A,B)),C) * fun(set(old_node(A,B)),C) * set(old_node(A,B)) ) > C ) ).

tff(sy_c_Old__Datatype_OIn0,type,
    old_In0: 
      !>[A: $tType,B: $tType] : ( set(old_node(A,B)) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OIn1,type,
    old_In1: 
      !>[A: $tType,B: $tType] : ( set(old_node(A,B)) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OLim,type,
    old_Lim: 
      !>[B: $tType,A: $tType] : ( fun(B,set(old_node(A,B))) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_ONode,type,
    old_Node: 
      !>[B: $tType,A: $tType] : set(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))) ).

tff(sy_c_Old__Datatype_OPush,type,
    old_Push: 
      !>[B: $tType] : fun(sum_sum(B,nat),fun(fun(nat,sum_sum(B,nat)),fun(nat,sum_sum(B,nat)))) ).

tff(sy_c_Old__Datatype_OPush__Node,type,
    old_Push_Node: 
      !>[B: $tType,A: $tType] : ( sum_sum(B,nat) > fun(old_node(A,B),old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OScons,type,
    old_Scons: 
      !>[A: $tType,B: $tType] : ( ( set(old_node(A,B)) * set(old_node(A,B)) ) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OSplit,type,
    old_Split: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(set(old_node(A,B)),fun(set(old_node(A,B)),C)) > fun(set(old_node(A,B)),C) ) ).

tff(sy_c_Old__Datatype_Odprod,type,
    old_dprod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) * set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) > set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) ).

tff(sy_c_Old__Datatype_Odsum,type,
    old_dsum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) * set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) > set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) ).

tff(sy_c_Old__Datatype_Ondepth,type,
    old_ndepth: 
      !>[A: $tType,B: $tType] : ( old_node(A,B) > nat ) ).

tff(sy_c_Old__Datatype_Onode_OAbs__Node,type,
    old_Abs_Node: 
      !>[B: $tType,A: $tType] : ( product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)) > old_node(A,B) ) ).

tff(sy_c_Old__Datatype_Onode_ORep__Node,type,
    old_Rep_Node: 
      !>[A: $tType,B: $tType] : ( old_node(A,B) > product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)) ) ).

tff(sy_c_Old__Datatype_Ontrunc,type,
    old_ntrunc: 
      !>[A: $tType,B: $tType] : ( ( nat * set(old_node(A,B)) ) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_Ouprod,type,
    old_uprod: 
      !>[A: $tType,B: $tType] : ( ( set(set(old_node(A,B))) * set(set(old_node(A,B))) ) > set(set(old_node(A,B))) ) ).

tff(sy_c_Old__Datatype_Ousum,type,
    old_usum: 
      !>[A: $tType,B: $tType] : ( ( set(set(old_node(A,B))) * set(set(old_node(A,B))) ) > set(set(old_node(A,B))) ) ).

tff(sy_c_Option_Obind,type,
    bind2: 
      !>[A: $tType,B: $tType] : ( ( option(A) * fun(A,option(B)) ) > option(B) ) ).

tff(sy_c_Option_Ocombine__options,type,
    combine_options: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * option(A) * option(A) ) > option(A) ) ).

tff(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : option(A) ).

tff(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : fun(A,option(A)) ).

tff(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,B) * option(A) ) > B ) ).

tff(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(option(A),option(Aa)) ) ).

tff(sy_c_Option_Ooption_Opred__option,type,
    pred_option: 
      !>[A: $tType] : ( fun(A,bool) > fun(option(A),bool) ) ).

tff(sy_c_Option_Ooption_Orec__option,type,
    rec_option: 
      !>[C: $tType,A: $tType] : ( ( C * fun(A,C) ) > fun(option(A),C) ) ).

tff(sy_c_Option_Ooption_Orel__option,type,
    rel_option: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(option(A),fun(option(B),bool)) ) ).

tff(sy_c_Option_Ooption_Oset__option,type,
    set_option: 
      !>[A: $tType] : ( option(A) > set(A) ) ).

tff(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : fun(option(A),A) ).

tff(sy_c_Option_Othese,type,
    these: 
      !>[A: $tType] : ( set(option(A)) > set(A) ) ).

tff(sy_c_Order__Relation_OAbove,type,
    order_Above: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OAboveS,type,
    order_AboveS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OUnder,type,
    order_Under: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OUnderS,type,
    order_UnderS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_Oabove,type,
    order_above: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_OaboveS,type,
    order_aboveS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_Olinear__order__on,type,
    order_679001287576687338der_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Oofilter,type,
    order_ofilter: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > $o ) ).

tff(sy_c_Order__Relation_Opartial__order__on,type,
    order_7125193373082350890der_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Opreorder__on,type,
    order_preorder_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Orelation__of,type,
    order_relation_of: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * set(A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Order__Relation_Ounder,type,
    order_under: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(A,set(A)) ) ).

tff(sy_c_Order__Relation_OunderS,type,
    order_underS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_Owell__order__on,type,
    order_well_order_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

tff(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(fun(A,bool),A) ) ).

tff(sy_c_Orderings_Oord_Omax,type,
    max: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(A,fun(A,A)) ) ).

tff(sy_c_Orderings_Oord_Omin,type,
    min: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(A,fun(A,A)) ) ).

tff(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( fun(A,bool) > A ) ).

tff(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : fun(A,fun(A,bool)) ).

tff(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : fun(A,fun(A,bool)) ).

tff(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oorder_OGreatest,type,
    greatest: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(fun(A,bool),A) ) ).

tff(sy_c_Orderings_Oorder_Omono,type,
    mono: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(A,bool)) > fun(fun(A,B),bool) ) ).

tff(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( fun(A,bool) > A ) ).

tff(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oordering,type,
    ordering: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Orderings_Oordering__axioms,type,
    ordering_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Orderings_Oordering__top,type,
    ordering_top: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) * A ) > $o ) ).

tff(sy_c_Orderings_Oordering__top__axioms,type,
    ordering_top_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A ) > $o ) ).

tff(sy_c_Orderings_Opartial__preordering,type,
    partial_preordering: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Orderings_Opreordering,type,
    preordering: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Orderings_Opreordering__axioms,type,
    preordering_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

tff(sy_c_Partial__Function_Oflat__lub,type,
    partial_flat_lub: 
      !>[A: $tType] : ( A > fun(set(A),A) ) ).

tff(sy_c_Partial__Function_Oflat__ord,type,
    partial_flat_ord: 
      !>[A: $tType] : ( A > fun(A,fun(A,bool)) ) ).

tff(sy_c_Partial__Function_Ofun__lub,type,
    partial_fun_lub: 
      !>[C: $tType,B: $tType,A: $tType] : ( fun(set(C),B) > fun(set(fun(A,C)),fun(A,B)) ) ).

tff(sy_c_Partial__Function_Ofun__ord,type,
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(A,fun(B,bool)) > fun(fun(C,A),fun(fun(C,B),bool)) ) ).

tff(sy_c_Partial__Function_Oimg__ord,type,
    partial_img_ord: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( fun(A,C) * fun(C,fun(C,B)) * A * A ) > B ) ).

tff(sy_c_Partial__Function_Omk__less,type,
    partial_mk_less: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A * A ) > $o ) ).

tff(sy_c_Partial__Function_Opartial__function__definitions,type,
    partia7178651479351089652itions: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(set(A),A) ) > $o ) ).

tff(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : fun(A,fun(nat,A)) ).

tff(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : fun(A,fun(B,product_prod(A,B))) ).

tff(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,set(B)) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Product__Type_OUnity,type,
    product_Unity: product_unit ).

tff(sy_c_Product__Type_Oapfst,type,
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] : ( fun(A,C) > fun(product_prod(A,B),product_prod(C,B)) ) ).

tff(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : fun(fun(B,C),fun(product_prod(A,B),product_prod(A,C))) ).

tff(sy_c_Product__Type_Ocurry,type,
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(product_prod(A,B),C) * A * B ) > C ) ).

tff(sy_c_Product__Type_Omap__prod,type,
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,C) * fun(B,D) ) > fun(product_prod(A,B),product_prod(C,D)) ) ).

tff(sy_c_Product__Type_Oold_Obool_Orec__bool,type,
    product_rec_bool: 
      !>[T: $tType] : ( ( T * T * bool ) > T ) ).

tff(sy_c_Product__Type_Oold_Obool_Orec__set__bool,type,
    product_rec_set_bool: 
      !>[T: $tType] : ( ( T * T * bool ) > fun(T,bool) ) ).

tff(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( fun(A,fun(B,T)) * product_prod(A,B) ) > T ) ).

tff(sy_c_Product__Type_Oold_Oprod_Orec__set__prod,type,
    product_rec_set_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( fun(A,fun(B,T)) * product_prod(A,B) ) > fun(T,bool) ) ).

tff(sy_c_Product__Type_Oold_Ounit_Orec__set__unit,type,
    product_rec_set_unit: 
      !>[T: $tType] : ( ( T * product_unit ) > fun(T,bool) ) ).

tff(sy_c_Product__Type_Oold_Ounit_Orec__unit,type,
    product_rec_unit: 
      !>[T: $tType] : ( ( T * product_unit ) > T ) ).

tff(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : fun(fun(A,fun(B,C)),fun(product_prod(A,B),C)) ).

tff(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),A) ).

tff(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),B) ).

tff(sy_c_Product__Type_Oprod_Oswap,type,
    product_swap: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),product_prod(B,A)) ).

tff(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Product__Type_Oscomp,type,
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( fun(A,product_prod(B,C)) * fun(B,fun(C,D)) ) > fun(A,D) ) ).

tff(sy_c_Product__Type_Ounit_OAbs__unit,type,
    product_Abs_unit: fun(bool,product_unit) ).

tff(sy_c_Product__Type_Ounit_ORep__unit,type,
    product_Rep_unit: fun(product_unit,bool) ).

tff(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : itself(A) ).

tff(sy_c_Quicksort_Olinorder__class_Oquicksort,type,
    linorder_quicksort: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_Quicksort_Olinorder__class_Oquicksort__rel,type,
    linord6200660962353139674rt_rel: 
      !>[A: $tType] : fun(list(A),fun(list(A),bool)) ).

tff(sy_c_Quotient_OQuotient3,type,
    quotient3: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,B) * fun(B,A) ) > $o ) ).

tff(sy_c_Quotient_Oquot__type,type,
    quot_type: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(set(A),B) * fun(B,set(A)) ) > $o ) ).

tff(sy_c_Quotient_Oquot__type_Orep,type,
    quot_rep: 
      !>[B: $tType,A: $tType] : ( ( fun(B,set(A)) * B ) > A ) ).

tff(sy_c_Random_Oinc__shift,type,
    inc_shift: ( code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Oiterate,type,
    iterate: 
      !>[B: $tType,A: $tType] : ( ( code_natural * fun(B,fun(A,product_prod(B,A))) * B ) > fun(A,product_prod(B,A)) ) ).

tff(sy_c_Random_Olog,type,
    log: ( code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Ominus__shift,type,
    minus_shift: ( code_natural * code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Onext,type,
    next: fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))) ).

tff(sy_c_Random_Opick,type,
    pick: 
      !>[A: $tType] : ( list(product_prod(code_natural,A)) > fun(code_natural,A) ) ).

tff(sy_c_Random_Orange,type,
    range: code_natural > fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))) ).

tff(sy_c_Random_Oselect,type,
    select: 
      !>[A: $tType] : ( list(A) > fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random_Oselect__weight,type,
    select_weight: 
      !>[A: $tType] : ( list(product_prod(code_natural,A)) > fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random_Osplit__seed,type,
    split_seed: product_prod(code_natural,code_natural) > product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)) ).

tff(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: fun(product_prod(int,int),rat) ).

tff(sy_c_Rat_OFract,type,
    fract: fun(int,fun(int,rat)) ).

tff(sy_c_Rat_ORep__Rat,type,
    rep_Rat: fun(rat,product_prod(int,int)) ).

tff(sy_c_Rat_Ocr__rat,type,
    cr_rat: ( product_prod(int,int) * rat ) > $o ).

tff(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : fun(rat,A) ).

tff(sy_c_Rat_Onormalize,type,
    normalize: product_prod(int,int) > product_prod(int,int) ).

tff(sy_c_Rat_Opcr__rat,type,
    pcr_rat: fun(product_prod(int,int),fun(rat,bool)) ).

tff(sy_c_Rat_Opositive,type,
    positive: fun(rat,bool) ).

tff(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > product_prod(int,int) ).

tff(sy_c_Rat_Orat_OAbs__rat,type,
    abs_rat: fun(set(product_prod(int,int)),rat) ).

tff(sy_c_Rat_Orat_ORep__rat,type,
    rep_rat: fun(rat,set(product_prod(int,int))) ).

tff(sy_c_Rat_Oratrel,type,
    ratrel: fun(product_prod(int,int),fun(product_prod(int,int),bool)) ).

tff(sy_c_Ref__Time_Oalloc,type,
    ref_alloc: 
      !>[A: $tType] : ( ( A * heap_ext(product_unit) ) > product_prod(ref(A),heap_ext(product_unit)) ) ).

tff(sy_c_Ref__Time_Ochange,type,
    ref_change: 
      !>[A: $tType] : ( ( fun(A,A) * ref(A) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Ref__Time_Oget,type,
    ref_get: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * ref(A) ) > A ) ).

tff(sy_c_Ref__Time_Olookup,type,
    ref_lookup: 
      !>[A: $tType] : ( ref(A) > heap_Time_Heap(A) ) ).

tff(sy_c_Ref__Time_Oref,type,
    ref_ref: 
      !>[A: $tType] : ( A > heap_Time_Heap(ref(A)) ) ).

tff(sy_c_Ref__Time_Oset,type,
    ref_set: 
      !>[A: $tType] : ( ( ref(A) * A ) > fun(heap_ext(product_unit),heap_ext(product_unit)) ) ).

tff(sy_c_Ref__Time_Oupdate,type,
    ref_update: 
      !>[A: $tType] : ( ( ref(A) * A ) > heap_Time_Heap(product_unit) ) ).

tff(sy_c_Relation_ODomain,type,
    domain: 
      !>[A: $tType,B: $tType] : fun(set(product_prod(A,B)),set(A)) ).

tff(sy_c_Relation_ODomainp,type,
    domainp: 
      !>[A: $tType,B: $tType] : fun(fun(A,fun(B,bool)),fun(A,bool)) ).

tff(sy_c_Relation_OField,type,
    field2: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(A) ) ).

tff(sy_c_Relation_OId,type,
    id2: 
      !>[A: $tType] : set(product_prod(A,A)) ).

tff(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( set(A) > set(product_prod(A,A)) ) ).

tff(sy_c_Relation_OImage,type,
    image: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > fun(set(A),set(B)) ) ).

tff(sy_c_Relation_OPowp,type,
    powp: 
      !>[A: $tType] : ( ( fun(A,bool) * set(A) ) > $o ) ).

tff(sy_c_Relation_ORange,type,
    range2: 
      !>[A: $tType,B: $tType] : fun(set(product_prod(A,B)),set(B)) ).

tff(sy_c_Relation_ORangep,type,
    rangep: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(B,bool) ) ).

tff(sy_c_Relation_Oantisym,type,
    antisym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oantisymp,type,
    antisymp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Relation_Oasym,type,
    asym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oasymp,type,
    asymp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Relation_Oconverse,type,
    converse: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(B,A)) ) ).

tff(sy_c_Relation_Oconversep,type,
    conversep: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(B,fun(A,bool)) ) ).

tff(sy_c_Relation_Oinv__image,type,
    inv_image: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * fun(A,B) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Relation_Oinv__imagep,type,
    inv_imagep: 
      !>[B: $tType,A: $tType] : ( ( fun(B,fun(B,bool)) * fun(A,B) * A * A ) > $o ) ).

tff(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oirreflp,type,
    irreflp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Relation_Orefl__on,type,
    refl_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Relation_Oreflp,type,
    reflp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(product_prod(A,B)) * set(product_prod(B,C)) ) > set(product_prod(A,C)) ) ).

tff(sy_c_Relation_Orelcompp,type,
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] : fun(fun(A,fun(B,bool)),fun(fun(B,fun(C,bool)),fun(A,fun(C,bool)))) ).

tff(sy_c_Relation_Osingle__valued,type,
    single_valued: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > $o ) ).

tff(sy_c_Relation_Osingle__valuedp,type,
    single_valuedp: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > $o ) ).

tff(sy_c_Relation_Osym,type,
    sym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Osymp,type,
    symp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Relation_Ototal__on,type,
    total_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Relation_Otrans,type,
    trans: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( ( A * A ) > $o ) ).

tff(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : fun(A,fun(A,bool)) ).

tff(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Rings_Onormalization__semidom__class_Onormalize,type,
    normal6383669964737779283malize: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Rings_Ounit__factor__class_Ounit__factor,type,
    unit_f5069060285200089521factor: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : fun(bool,A) ).

tff(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : fun(set(A),fun(fun(A,bool),bool)) ).

tff(sy_c_Set_OBex,type,
    bex: 
      !>[A: $tType] : fun(set(A),fun(fun(A,bool),bool)) ).

tff(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : fun(fun(A,bool),set(A)) ).

tff(sy_c_Set_OPow,type,
    pow: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Set_Obind,type,
    bind3: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,set(B)) ) > set(B) ) ).

tff(sy_c_Set_Odisjnt,type,
    disjnt: 
      !>[A: $tType] : fun(set(A),fun(set(A),bool)) ).

tff(sy_c_Set_Ofilter,type,
    filter3: 
      !>[A: $tType] : ( ( fun(A,bool) * set(A) ) > set(A) ) ).

tff(sy_c_Set_Oimage,type,
    image2: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(set(A),set(B)) ) ).

tff(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > fun(set(A),set(A)) ) ).

tff(sy_c_Set_Ois__empty,type,
    is_empty: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Set_Ois__singleton,type,
    is_singleton: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Set_Opairwise,type,
    pairwise: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * set(A) ) > $o ) ).

tff(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : fun(A,fun(set(A),set(A))) ).

tff(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : fun(fun(A,B),fun(set(B),set(A))) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( fun(nat,fun(A,A)) * nat * nat * A ) > A ) ).

tff(sy_c_Set__Interval_Oord_OatLeast,type,
    set_atLeast: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatLeastAtMost,type,
    set_atLeastAtMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatLeastLessThan,type,
    set_atLeastLessThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatMost,type,
    set_atMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThan,type,
    set_greaterThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThanAtMost,type,
    set_gr3752724095348155675AtMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThanLessThan,type,
    set_gr287244882034783167ssThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OlessThan,type,
    set_lessThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Sum__Type_OInl,type,
    sum_Inl: 
      !>[A: $tType,B: $tType] : fun(A,sum_sum(A,B)) ).

tff(sy_c_Sum__Type_OInr,type,
    sum_Inr: 
      !>[B: $tType,A: $tType] : fun(B,sum_sum(A,B)) ).

tff(sy_c_Sum__Type_OPlus,type,
    sum_Plus: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(sum_sum(A,B)) ) ).

tff(sy_c_Sum__Type_Oold_Osum_Orec__set__sum,type,
    sum_rec_set_sum: 
      !>[A: $tType,T: $tType,B: $tType] : ( ( fun(A,T) * fun(B,T) * sum_sum(A,B) ) > fun(T,bool) ) ).

tff(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] : ( ( fun(A,T) * fun(B,T) * sum_sum(A,B) ) > T ) ).

tff(sy_c_Sum__Type_Osum_Ocase__sum,type,
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( fun(A,C) * fun(B,C) ) > fun(sum_sum(A,B),C) ) ).

tff(sy_c_Sum__Type_Osum_Oisl,type,
    sum_isl: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,B) > $o ) ).

tff(sy_c_Sum__Type_Osum_Oprojl,type,
    sum_projl: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,B) > A ) ).

tff(sy_c_Sum__Type_Osum_Oprojr,type,
    sum_projr: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,B) > B ) ).

tff(sy_c_Syntax__Match_Oac__operator,type,
    syntax_ac_operator: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Syntax__Match_Osyntax__fo__nomatch,type,
    syntax7388354845996824322omatch: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_Syntax__Match_Osyntax__nomatch,type,
    syntax2379306206330768139omatch: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_Transfer_Obi__total,type,
    bi_total: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > $o ) ).

tff(sy_c_Transfer_Obi__unique,type,
    bi_unique: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > $o ) ).

tff(sy_c_Transfer_Oleft__total,type,
    left_total: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > $o ) ).

tff(sy_c_Transfer_Oleft__unique,type,
    left_unique: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > $o ) ).

tff(sy_c_Transfer_Oright__total,type,
    right_total: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > $o ) ).

tff(sy_c_Transfer_Otransfer__bforall,type,
    transfer_bforall: 
      !>[A: $tType] : ( ( fun(A,bool) * fun(A,bool) ) > $o ) ).

tff(sy_c_Transitive__Closure_Oacyclic,type,
    transitive_acyclic: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( ( nat * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Ortranclp,type,
    transitive_rtranclp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(A,fun(A,bool)) ) ).

tff(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Otranclp,type,
    transitive_tranclp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(A,fun(A,bool)) ) ).

tff(sy_c_Typedef_Otype__definition,type,
    type_definition: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Typerep_Otyperep__class_Otyperep,type,
    typerep_typerep: 
      !>[A: $tType] : ( itself(A) > typerep ) ).

tff(sy_c_Wellfounded_Oacc,type,
    acc: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(A) ) ).

tff(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(A,bool) ) ).

tff(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : set(product_prod(set(A),set(A))) ).

tff(sy_c_Wellfounded_Oless__than,type,
    less_than: set(product_prod(nat,nat)) ).

tff(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_Wellfounded_Omax__extp,type,
    max_extp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(set(A),fun(set(A),bool)) ) ).

tff(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( fun(A,nat) * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set(product_prod(nat,nat)) ).

tff(sy_c_Wellfounded_Owf,type,
    wf: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Wellfounded_OwfP,type,
    wfP: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Wfrec_Osame__fst,type,
    same_fst: 
      !>[A: $tType,B: $tType] : ( ( fun(A,bool) * fun(A,set(product_prod(B,B))) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_Zorn_OChains,type,
    chains: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(set(A)) ) ).

tff(sy_c_Zorn_Ochain__subset,type,
    chain_subset: 
      !>[A: $tType] : ( set(set(A)) > $o ) ).

tff(sy_c_Zorn_Ochains,type,
    chains2: 
      !>[A: $tType] : ( set(set(A)) > set(set(set(A))) ) ).

tff(sy_c_Zorn_Oinit__seg__of,type,
    init_seg_of: 
      !>[A: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))) ).

tff(sy_c_Zorn_Opred__on_Ochain,type,
    pred_chain: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,bool)) ) > fun(set(A),bool) ) ).

tff(sy_c_Zorn_Opred__on_Omaxchain,type,
    pred_maxchain: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,bool)) * set(A) ) > $o ) ).

tff(sy_c_Zorn_Opred__on_Osuc,type,
    pred_suc: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,bool)) * set(A) ) > set(A) ) ).

tff(sy_c_Zorn_Opred__on_Osuc__Union__closed,type,
    pred_s596693808085603175closed: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,bool)) ) > set(set(A)) ) ).

tff(sy_c_Zorn_Opred__on_Osuc__Union__closedp,type,
    pred_s7749564232668923593losedp: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,bool)) ) > fun(set(A),bool) ) ).

tff(sy_c_aa,type,
    aa: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A ) > B ) ).

tff(sy_c_fAll,type,
    fAll: 
      !>[A: $tType] : fun(fun(A,bool),bool) ).

tff(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( fun(A,bool) > A ) ).

tff(sy_c_fEx,type,
    fEx: 
      !>[A: $tType] : fun(fun(A,bool),bool) ).

tff(sy_c_fFalse,type,
    fFalse: bool ).

tff(sy_c_fNot,type,
    fNot: fun(bool,bool) ).

tff(sy_c_fTrue,type,
    fTrue: bool ).

tff(sy_c_fconj,type,
    fconj: ( bool * bool ) > bool ).

tff(sy_c_fdisj,type,
    fdisj: ( bool * bool ) > bool ).

tff(sy_c_fequal,type,
    fequal: 
      !>[A: $tType] : fun(A,fun(A,bool)) ).

tff(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > fun(set(A),bool) ) ).

tff(sy_c_pp,type,
    pp: bool > $o ).

tff(sy_v_P,type,
    p: assn ).

tff(sy_v_P_H,type,
    p2: assn ).

tff(sy_v_P_H__0_058ATP,type,
    p_0_ATP: assn ).

tff(sy_v_Q,type,
    q: a > assn ).

tff(sy_v_Q_H,type,
    q2: a > assn ).

tff(sy_v_c,type,
    c: heap_Time_Heap(a) ).

% Relevant facts (7565)
tff(fact_0_cons__rule,axiom,
    ! [A: $tType,P: assn,P2: assn,Q: fun(A,assn),Q2: fun(A,assn),C2: heap_Time_Heap(A)] :
      ( entails(P,P2)
     => ( ! [X: A] : entails(aa(A,assn,Q,X),aa(A,assn,Q2,X))
       => ( hoare_hoare_triple(A,P2,C2,Q)
         => hoare_hoare_triple(A,P,C2,Q2) ) ) ) ).

% cons_rule
tff(fact_1_frame__rule,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn),R: assn] :
      ( hoare_hoare_triple(A,P,C2,Q)
     => hoare_hoare_triple(A,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),R),C2,aa(assn,fun(A,assn),aTP_Lamp_aa(fun(A,assn),fun(assn,fun(A,assn)),Q),R)) ) ).

% frame_rule
tff(fact_2_cons__pre__rule,axiom,
    ! [A: $tType,P: assn,P2: assn,C2: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( entails(P,P2)
     => ( hoare_hoare_triple(A,P2,C2,Q)
       => hoare_hoare_triple(A,P,C2,Q) ) ) ).

% cons_pre_rule
tff(fact_3_cons__post__rule,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn),Q2: fun(A,assn)] :
      ( hoare_hoare_triple(A,P,C2,Q)
     => ( ! [X: A] : entails(aa(A,assn,Q,X),aa(A,assn,Q2,X))
       => hoare_hoare_triple(A,P,C2,Q2) ) ) ).

% cons_post_rule
tff(fact_4_merge__true__star,axiom,
    aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),top_top(assn)),top_top(assn)) = top_top(assn) ).

% merge_true_star
tff(fact_5_top__apply,axiom,
    ! [D: $tType,C: $tType] :
      ( top(C)
     => ! [X2: D] : ( aa(D,C,top_top(fun(D,C)),X2) = top_top(C) ) ) ).

% top_apply
tff(fact_6_ent__true,axiom,
    ! [P: assn] : entails(P,top_top(assn)) ).

% ent_true
tff(fact_7_ent__star__mono,axiom,
    ! [P: assn,P2: assn,Q: assn,Q2: assn] :
      ( entails(P,P2)
     => ( entails(Q,Q2)
       => entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P2),Q2)) ) ) ).

% ent_star_mono
tff(fact_8_ent__iffI,axiom,
    ! [A3: assn,B2: assn] :
      ( entails(A3,B2)
     => ( entails(B2,A3)
       => ( A3 = B2 ) ) ) ).

% ent_iffI
tff(fact_9_ent__refl,axiom,
    ! [P: assn] : entails(P,P) ).

% ent_refl
tff(fact_10_ent__trans,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( entails(P,Q)
     => ( entails(Q,R)
       => entails(P,R) ) ) ).

% ent_trans
tff(fact_11_assn__times__comm,axiom,
    ! [P: assn,Q: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),P) ) ).

% assn_times_comm
tff(fact_12_assn__times__assoc,axiom,
    ! [P: assn,Q: assn,R: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q)),R) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),R)) ) ).

% assn_times_assoc
tff(fact_13_mult_Oright__assoc,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) ) ) ).

% mult.right_assoc
tff(fact_14_mult_Oright__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3) ) ) ).

% mult.right_commute
tff(fact_15_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_mult(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) ) ) ).

% mult.assoc
tff(fact_16_ab__semigroup__mult__class_Omult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [B3: A,A4: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) ) ) ).

% ab_semigroup_mult_class.mult.left_commute
tff(fact_17_ab__semigroup__mult__class_Omult_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3) = aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4) ) ) ).

% ab_semigroup_mult_class.mult.commute
tff(fact_18_ent__wandI,axiom,
    ! [Q: assn,P: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),P),R)
     => entails(P,wand_assn(Q,R)) ) ).

% ent_wandI
tff(fact_19_ent__mp,axiom,
    ! [P: assn,Q: assn] : entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),wand_assn(P,Q)),Q) ).

% ent_mp
tff(fact_20_entt__def__true,axiom,
    ! [P: assn,Q: assn] :
      ( entailst(P,Q)
    <=> entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),top_top(assn)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),top_top(assn))) ) ).

% entt_def_true
tff(fact_21_entailst__def,axiom,
    ! [A3: assn,B2: assn] :
      ( entailst(A3,B2)
    <=> entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn))) ) ).

% entailst_def
tff(fact_22_enttI__true,axiom,
    ! [P: assn,Q: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),top_top(assn)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),top_top(assn)))
     => entailst(P,Q) ) ).

% enttI_true
tff(fact_23_enttI,axiom,
    ! [A3: assn,B2: assn] :
      ( entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn)))
     => entailst(A3,B2) ) ).

% enttI
tff(fact_24_enttD,axiom,
    ! [A3: assn,B2: assn] :
      ( entailst(A3,B2)
     => entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn))) ) ).

% enttD
tff(fact_25_is__pure__assn__starI,axiom,
    ! [A4: assn,B3: assn] :
      ( is_pure_assn(A4)
     => ( is_pure_assn(B3)
       => is_pure_assn(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),B3)) ) ) ).

% is_pure_assn_starI
tff(fact_26_ent__pure__pre__iff,axiom,
    ! [P: assn,B3: bool,Q: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),pure_assn(B3)),Q)
    <=> ( pp(B3)
       => entails(P,Q) ) ) ).

% ent_pure_pre_iff
tff(fact_27_entt__star__true__simp_I1_J,axiom,
    ! [A3: assn,B2: assn] :
      ( entailst(A3,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn)))
    <=> entailst(A3,B2) ) ).

% entt_star_true_simp(1)
tff(fact_28_entt__star__true__simp_I2_J,axiom,
    ! [A3: assn,B2: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),top_top(assn)),B2)
    <=> entailst(A3,B2) ) ).

% entt_star_true_simp(2)
tff(fact_29_mult_Osafe__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [X2: A,Y: A,A4: A,B3: A] :
          ( syntax7388354845996824322omatch(A,A,aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y),A4)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3) = aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4) ) ) ) ).

% mult.safe_commute
tff(fact_30_entt__refl,axiom,
    ! [A3: assn] : entailst(A3,A3) ).

% entt_refl
tff(fact_31_pure__assn__eq__conv,axiom,
    ! [P: bool,Q: bool] :
      ( ( pure_assn(P) = pure_assn(Q) )
    <=> ( pp(P)
      <=> pp(Q) ) ) ).

% pure_assn_eq_conv
tff(fact_32_merge__pure__star,axiom,
    ! [A4: bool,B3: bool] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),pure_assn(A4)),pure_assn(B3)) = pure_assn(fconj(A4,B3)) ) ).

% merge_pure_star
tff(fact_33_entt__true,axiom,
    ! [A3: assn] : entailst(A3,top_top(assn)) ).

% entt_true
tff(fact_34_is__pure__assn__pure,axiom,
    ! [P: bool] : is_pure_assn(pure_assn(P)) ).

% is_pure_assn_pure
tff(fact_35_entt__trans,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( entailst(A3,B2)
     => ( entailst(B2,C3)
       => entailst(A3,C3) ) ) ).

% entt_trans
tff(fact_36_is__pure__assnE,axiom,
    ! [A4: assn] :
      ( is_pure_assn(A4)
     => ~ ! [P3: bool] : ( A4 != pure_assn(P3) ) ) ).

% is_pure_assnE
tff(fact_37_is__pure__assn__def,axiom,
    ! [A4: assn] :
      ( is_pure_assn(A4)
    <=> ? [P4: bool] : ( A4 = pure_assn(P4) ) ) ).

% is_pure_assn_def
tff(fact_38_syntax__fo__nomatch__def,axiom,
    ! [A: $tType,B: $tType,Pat: A,Obj: B] : syntax7388354845996824322omatch(A,B,Pat,Obj) ).

% syntax_fo_nomatch_def
tff(fact_39_entt__frame__fwd,axiom,
    ! [P: assn,Q: assn,A3: assn,F: assn,B2: assn] :
      ( entailst(P,Q)
     => ( entailst(A3,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),F))
       => ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),F),B2)
         => entailst(A3,B2) ) ) ) ).

% entt_frame_fwd
tff(fact_40_entt__star__mono,axiom,
    ! [A3: assn,B2: assn,C3: assn,D2: assn] :
      ( entailst(A3,B2)
     => ( entailst(C3,D2)
       => entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),C3),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),D2)) ) ) ).

% entt_star_mono
tff(fact_41_ent__imp__entt,axiom,
    ! [P: assn,Q: assn] :
      ( entails(P,Q)
     => entailst(P,Q) ) ).

% ent_imp_entt
tff(fact_42_precise__extr__pure_I2_J,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,assn)),P: bool] :
      ( precise(A,B,aa(bool,fun(A,fun(B,assn)),aTP_Lamp_ab(fun(A,fun(B,assn)),fun(bool,fun(A,fun(B,assn))),R),P))
    <=> ( pp(P)
       => precise(A,B,R) ) ) ).

% precise_extr_pure(2)
tff(fact_43_precise__extr__pure_I1_J,axiom,
    ! [B: $tType,A: $tType,P: bool,R: fun(A,fun(B,assn))] :
      ( precise(A,B,aa(fun(A,fun(B,assn)),fun(A,fun(B,assn)),aTP_Lamp_ac(bool,fun(fun(A,fun(B,assn)),fun(A,fun(B,assn))),P),R))
    <=> ( pp(P)
       => precise(A,B,R) ) ) ).

% precise_extr_pure(1)
tff(fact_44_ent__pure__post__iff,axiom,
    ! [P: assn,Q: assn,B3: bool] :
      ( entails(P,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),pure_assn(B3)))
    <=> ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
            ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H))
           => pp(B3) )
        & entails(P,Q) ) ) ).

% ent_pure_post_iff
tff(fact_45_mem__Collect__eq,axiom,
    ! [A: $tType,A4: A,P: fun(A,bool)] :
      ( pp(aa(set(A),bool,member(A,A4),aa(fun(A,bool),set(A),collect(A),P)))
    <=> pp(aa(A,bool,P,A4)) ) ).

% mem_Collect_eq
tff(fact_46_Collect__mem__eq,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3)) = A3 ) ).

% Collect_mem_eq
tff(fact_47_Collect__cong,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( ! [X: A] :
          ( pp(aa(A,bool,P,X))
        <=> pp(aa(A,bool,Q,X)) )
     => ( aa(fun(A,bool),set(A),collect(A),P) = aa(fun(A,bool),set(A),collect(A),Q) ) ) ).

% Collect_cong
tff(fact_48_ext,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),G: fun(A,B)] :
      ( ! [X: A] : ( aa(A,B,F2,X) = aa(A,B,G,X) )
     => ( F2 = G ) ) ).

% ext
tff(fact_49_ent__pure__pre__iff__sng,axiom,
    ! [B3: bool,Q: assn] :
      ( entails(pure_assn(B3),Q)
    <=> ( pp(B3)
       => entails(one_one(assn),Q) ) ) ).

% ent_pure_pre_iff_sng
tff(fact_50_triv__exI,axiom,
    ! [A: $tType,Q: fun(A,assn),X2: A] : entails(aa(A,assn,Q,X2),ex_assn(A,Q)) ).

% triv_exI
tff(fact_51_ac__operator_Osafe__commute,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),X2: A,Y: A,A4: A,B3: A] :
      ( syntax_ac_operator(A,F2)
     => ( syntax7388354845996824322omatch(A,A,aa(A,A,aa(A,fun(A,A),F2,X2),Y),A4)
       => ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = aa(A,A,aa(A,fun(A,A),F2,B3),A4) ) ) ) ).

% ac_operator.safe_commute
tff(fact_52_mod__pure__star__dist,axiom,
    ! [P: assn,B3: bool,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),pure_assn(B3))),H2))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
        & pp(B3) ) ) ).

% mod_pure_star_dist
tff(fact_53_mod__star__trueE,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),top_top(assn))),H2))
     => ~ ! [H3: product_prod(heap_ext(product_unit),set(nat))] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H3)) ) ).

% mod_star_trueE
tff(fact_54_mod__star__trueI,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),top_top(assn))),H2)) ) ).

% mod_star_trueI
tff(fact_55_ent__ex__preI,axiom,
    ! [A: $tType,P: fun(A,assn),Q: assn] :
      ( ! [X: A] : entails(aa(A,assn,P,X),Q)
     => entails(ex_assn(A,P),Q) ) ).

% ent_ex_preI
tff(fact_56_ent__ex__postI,axiom,
    ! [A: $tType,P: assn,Q: fun(A,assn),X2: A] :
      ( entails(P,aa(A,assn,Q,X2))
     => entails(P,ex_assn(A,Q)) ) ).

% ent_ex_postI
tff(fact_57_ex__distrib__star,axiom,
    ! [A: $tType,P: fun(A,assn),Q: assn] : ( ex_assn(A,aa(assn,fun(A,assn),aTP_Lamp_aa(fun(A,assn),fun(assn,fun(A,assn)),P),Q)) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),ex_assn(A,P)),Q) ) ).

% ex_distrib_star
tff(fact_58_Rep__assn__inject,axiom,
    ! [X2: assn,Y: assn] :
      ( ( aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,X2) = aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Y) )
    <=> ( X2 = Y ) ) ).

% Rep_assn_inject
tff(fact_59_ex__assn__const,axiom,
    ! [A: $tType,C2: assn] : ( ex_assn(A,aTP_Lamp_ae(assn,fun(A,assn),C2)) = C2 ) ).

% ex_assn_const
tff(fact_60_mult__1,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A4) = A4 ) ) ).

% mult_1
tff(fact_61_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),one_one(A)) = A4 ) ) ).

% mult.right_neutral
tff(fact_62_entt__emp,axiom,
    ! [A3: assn] : entailst(A3,one_one(assn)) ).

% entt_emp
tff(fact_63_pure__assn__eq__emp__iff,axiom,
    ! [P: bool] :
      ( ( pure_assn(P) = one_one(assn) )
    <=> pp(P) ) ).

% pure_assn_eq_emp_iff
tff(fact_64_pure__true,axiom,
    pure_assn(fTrue) = one_one(assn) ).

% pure_true
tff(fact_65_assn__basic__inequalities_I1_J,axiom,
    top_top(assn) != one_one(assn) ).

% assn_basic_inequalities(1)
tff(fact_66_mod__ex__dist,axiom,
    ! [A: $tType,P: fun(A,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,ex_assn(A,P)),H2))
    <=> ? [X3: A] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,P,X3)),H2)) ) ).

% mod_ex_dist
tff(fact_67_ent__pure__post__iff__sng,axiom,
    ! [P: assn,B3: bool] :
      ( entails(P,pure_assn(B3))
    <=> ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
            ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H))
           => pp(B3) )
        & entails(P,one_one(assn)) ) ) ).

% ent_pure_post_iff_sng
tff(fact_68_ex__one__point__gen,axiom,
    ! [A: $tType,P: fun(A,assn),V: A] :
      ( ! [H4: product_prod(heap_ext(product_unit),set(nat)),X: A] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,P,X)),H4))
         => ( X = V ) )
     => ( ex_assn(A,P) = aa(A,assn,P,V) ) ) ).

% ex_one_point_gen
tff(fact_69_one__reorient,axiom,
    ! [A: $tType] :
      ( one(A)
     => ! [X2: A] :
          ( ( one_one(A) = X2 )
        <=> ( X2 = one_one(A) ) ) ) ).

% one_reorient
tff(fact_70_mod__exI,axiom,
    ! [A: $tType,P: fun(A,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ? [X4: A] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,P,X4)),H2))
     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,ex_assn(A,P)),H2)) ) ).

% mod_exI
tff(fact_71_mod__exE,axiom,
    ! [A: $tType,P: fun(A,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,ex_assn(A,P)),H2))
     => ~ ! [X: A] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,P,X)),H2)) ) ).

% mod_exE
tff(fact_72_ac__operator_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( ! [A5: A,B4: A,C4: A] : ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,A5),B4)),C4) = aa(A,A,aa(A,fun(A,A),F2,A5),aa(A,A,aa(A,fun(A,A),F2,B4),C4)) )
     => ( ! [A5: A,B4: A] : ( aa(A,A,aa(A,fun(A,A),F2,A5),B4) = aa(A,A,aa(A,fun(A,A),F2,B4),A5) )
       => syntax_ac_operator(A,F2) ) ) ).

% ac_operator.intro
tff(fact_73_ac__operator_Ocommute,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A4: A,B3: A] :
      ( syntax_ac_operator(A,F2)
     => ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = aa(A,A,aa(A,fun(A,A),F2,B3),A4) ) ) ).

% ac_operator.commute
tff(fact_74_ac__operator_Oleft__assoc,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A4: A,B3: A,C2: A] :
      ( syntax_ac_operator(A,F2)
     => ( aa(A,A,aa(A,fun(A,A),F2,A4),aa(A,A,aa(A,fun(A,A),F2,B3),C2)) = aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),C2) ) ) ).

% ac_operator.left_assoc
tff(fact_75_ac__operator_Oright__assoc,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A4: A,B3: A,C2: A] :
      ( syntax_ac_operator(A,F2)
     => ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),F2,A4),aa(A,A,aa(A,fun(A,A),F2,B3),C2)) ) ) ).

% ac_operator.right_assoc
tff(fact_76_ac__operator_Oleft__commute,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A4: A,B3: A,C2: A] :
      ( syntax_ac_operator(A,F2)
     => ( aa(A,A,aa(A,fun(A,A),F2,A4),aa(A,A,aa(A,fun(A,A),F2,B3),C2)) = aa(A,A,aa(A,fun(A,A),F2,B3),aa(A,A,aa(A,fun(A,A),F2,A4),C2)) ) ) ).

% ac_operator.left_commute
tff(fact_77_ac__operator_Oright__commute,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A4: A,B3: A,C2: A] :
      ( syntax_ac_operator(A,F2)
     => ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,A4),C2)),B3) ) ) ).

% ac_operator.right_commute
tff(fact_78_ac__operator__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( syntax_ac_operator(A,F2)
    <=> ( ! [A6: A,B5: A,C5: A] : ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,A6),B5)),C5) = aa(A,A,aa(A,fun(A,A),F2,A6),aa(A,A,aa(A,fun(A,A),F2,B5),C5)) )
        & ! [A6: A,B5: A] : ( aa(A,A,aa(A,fun(A,A),F2,A6),B5) = aa(A,A,aa(A,fun(A,A),F2,B5),A6) ) ) ) ).

% ac_operator_def
tff(fact_79_preciseD_H,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,assn)),A4: A,P5: B,F: assn,H2: product_prod(heap_ext(product_unit),set(nat)),A7: A,F3: assn] :
      ( precise(A,B,R)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A4),P5)),F)),H2))
       => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A7),P5)),F3)),H2))
         => ( A4 = A7 ) ) ) ) ).

% preciseD'
tff(fact_80_mod__starE,axiom,
    ! [A4: assn,B3: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),B3)),H2))
     => ~ ( ? [X_1: product_prod(heap_ext(product_unit),set(nat))] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,A4),X_1))
         => ! [H_2: product_prod(heap_ext(product_unit),set(nat))] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,B3),H_2)) ) ) ).

% mod_starE
tff(fact_81_mod__starD,axiom,
    ! [A3: assn,B2: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),B2)),H2))
     => ? [H1: product_prod(heap_ext(product_unit),set(nat)),H22: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,A3),H1))
          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,B2),H22)) ) ) ).

% mod_starD
tff(fact_82_entails__def,axiom,
    ! [P: assn,Q: assn] :
      ( entails(P,Q)
    <=> ! [H: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H))
         => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H)) ) ) ).

% entails_def
tff(fact_83_entailsI,axiom,
    ! [P: assn,Q: assn] :
      ( ! [H4: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H4))
         => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H4)) )
     => entails(P,Q) ) ).

% entailsI
tff(fact_84_entailsD,axiom,
    ! [P: assn,Q: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( entails(P,Q)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H2)) ) ) ).

% entailsD
tff(fact_85_ent__fwd,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat)),Q: assn] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
     => ( entails(P,Q)
       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H2)) ) ) ).

% ent_fwd
tff(fact_86_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),one_one(A)) = A4 ) ) ).

% mult.comm_neutral
tff(fact_87_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A4) = A4 ) ) ).

% comm_monoid_mult_class.mult_1
tff(fact_88_hoare__triple__preI,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( ! [H4: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H4))
         => hoare_hoare_triple(A,P,C2,Q) )
     => hoare_hoare_triple(A,P,C2,Q) ) ).

% hoare_triple_preI
tff(fact_89_assn__one__left,axiom,
    ! [P: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),one_one(assn)),P) = P ) ).

% assn_one_left
tff(fact_90_is__pure__assn__basic__simps_I2_J,axiom,
    is_pure_assn(one_one(assn)) ).

% is_pure_assn_basic_simps(2)
tff(fact_91_mult_Oac__operator__axioms,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => syntax_ac_operator(A,times_times(A)) ) ).

% mult.ac_operator_axioms
tff(fact_92_lambda__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( aTP_Lamp_af(A,A) = aa(A,fun(A,A),times_times(A),one_one(A)) ) ) ).

% lambda_one
tff(fact_93_precise__def,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,assn))] :
      ( precise(A,B,R)
    <=> ! [A6: A,A8: A,H: product_prod(heap_ext(product_unit),set(nat)),P6: B,F4: assn,F5: assn] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A6),P6)),F4)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A8),P6)),F5))),H))
         => ( A6 = A8 ) ) ) ).

% precise_def
tff(fact_94_preciseI,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,assn))] :
      ( ! [A5: A,A9: A,H4: product_prod(heap_ext(product_unit),set(nat)),P7: B,F6: assn,F7: assn] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A5),P7)),F6)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A9),P7)),F7))),H4))
         => ( A5 = A9 ) )
     => precise(A,B,R) ) ).

% preciseI
tff(fact_95_preciseD,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,assn)),A4: A,P5: B,F: assn,A7: A,F3: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( precise(A,B,R)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A4),P5)),F)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A7),P5)),F3))),H2))
       => ( A4 = A7 ) ) ) ).

% preciseD
tff(fact_96_mod__true,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,top_top(assn)),H2))
    <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,H2)) ) ).

% mod_true
tff(fact_97_mult_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => monoid(A,times_times(A),one_one(A)) ) ).

% mult.monoid_axioms
tff(fact_98_ent__false__iff,axiom,
    ! [P: assn] :
      ( entails(P,bot_bot(assn))
    <=> ! [H: product_prod(heap_ext(product_unit),set(nat))] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H)) ) ).

% ent_false_iff
tff(fact_99_mult_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => comm_monoid(A,times_times(A),one_one(A)) ) ).

% mult.comm_monoid_axioms
tff(fact_100_Rep__assn__inverse,axiom,
    ! [X2: assn] : ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,X2)) = X2 ) ).

% Rep_assn_inverse
tff(fact_101_wand__assn__def,axiom,
    ! [P: assn,Q: assn] : ( wand_assn(P,Q) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,wand_raw(aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q))) ) ).

% wand_assn_def
tff(fact_102_prod_Ocomm__monoid__list__set__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => groups4802862169904069756st_set(A,times_times(A),one_one(A)) ) ).

% prod.comm_monoid_list_set_axioms
tff(fact_103_syntax__nomatch__def,axiom,
    ! [A: $tType,B: $tType,Pat: A,Obj: B] : syntax2379306206330768139omatch(A,B,Pat,Obj) ).

% syntax_nomatch_def
tff(fact_104_bot__apply,axiom,
    ! [D: $tType,C: $tType] :
      ( bot(C)
     => ! [X2: D] : ( aa(D,C,bot_bot(fun(D,C)),X2) = bot_bot(C) ) ) ).

% bot_apply
tff(fact_105_star__false__left,axiom,
    ! [P: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),bot_bot(assn)),P) = bot_bot(assn) ) ).

% star_false_left
tff(fact_106_star__false__right,axiom,
    ! [P: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),bot_bot(assn)) = bot_bot(assn) ) ).

% star_false_right
tff(fact_107_pure__false,axiom,
    pure_assn(fFalse) = bot_bot(assn) ).

% pure_false
tff(fact_108_pure__assn__eq__false__iff,axiom,
    ! [P: bool] :
      ( ( pure_assn(P) = bot_bot(assn) )
    <=> ~ pp(P) ) ).

% pure_assn_eq_false_iff
tff(fact_109_merge__pure__and,axiom,
    ! [A4: bool,B3: bool] : ( aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),pure_assn(A4)),pure_assn(B3)) = pure_assn(fconj(A4,B3)) ) ).

% merge_pure_and
tff(fact_110_assn__basic__inequalities_I5_J,axiom,
    top_top(assn) != bot_bot(assn) ).

% assn_basic_inequalities(5)
tff(fact_111_false__rule,axiom,
    ! [A: $tType,C2: heap_Time_Heap(A),Q: fun(A,assn)] : hoare_hoare_triple(A,bot_bot(assn),C2,Q) ).

% false_rule
tff(fact_112_assn__basic__inequalities_I3_J,axiom,
    bot_bot(assn) != one_one(assn) ).

% assn_basic_inequalities(3)
tff(fact_113_monoid_Oleft__neutral,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,A4: A] :
      ( monoid(A,F2,Z2)
     => ( aa(A,A,aa(A,fun(A,A),F2,Z2),A4) = A4 ) ) ).

% monoid.left_neutral
tff(fact_114_monoid_Oright__neutral,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,A4: A] :
      ( monoid(A,F2,Z2)
     => ( aa(A,A,aa(A,fun(A,A),F2,A4),Z2) = A4 ) ) ).

% monoid.right_neutral
tff(fact_115_comm__monoid_Ocomm__neutral,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,A4: A] :
      ( comm_monoid(A,F2,Z2)
     => ( aa(A,A,aa(A,fun(A,A),F2,A4),Z2) = A4 ) ) ).

% comm_monoid.comm_neutral
tff(fact_116_bot__fun__def,axiom,
    ! [A: $tType,B: $tType] :
      ( bot(B)
     => ! [X4: A] : ( aa(A,B,bot_bot(fun(A,B)),X4) = bot_bot(B) ) ) ).

% bot_fun_def
tff(fact_117_bot__assn__def,axiom,
    bot_bot(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aTP_Lamp_ag(product_prod(heap_ext(product_unit),set(nat)),bool)) ).

% bot_assn_def
tff(fact_118_top__assn__def,axiom,
    top_top(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,in_range) ).

% top_assn_def
tff(fact_119_inf__assn__def,axiom,
    ! [P: assn,Q: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),P),Q) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_ah(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),P),Q)) ) ).

% inf_assn_def
tff(fact_120_mod__and__dist,axiom,
    ! [P: assn,Q: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),P),Q)),H2))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H2)) ) ) ).

% mod_and_dist
tff(fact_121_mod__false,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,bot_bot(assn)),H2)) ).

% mod_false
tff(fact_122_ent__conjI,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( entails(A3,B2)
     => ( entails(A3,C3)
       => entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),B2),C3)) ) ) ).

% ent_conjI
tff(fact_123_ent__conjE1,axiom,
    ! [A3: assn,C3: assn,B2: assn] :
      ( entails(A3,C3)
     => entails(aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A3),B2),C3) ) ).

% ent_conjE1
tff(fact_124_ent__conjE2,axiom,
    ! [B2: assn,C3: assn,A3: assn] :
      ( entails(B2,C3)
     => entails(aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A3),B2),C3) ) ).

% ent_conjE2
tff(fact_125_ent__false,axiom,
    ! [P: assn] : entails(bot_bot(assn),P) ).

% ent_false
tff(fact_126_models__in__range,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,H2)) ) ).

% models_in_range
tff(fact_127_is__pure__assn__basic__simps_I1_J,axiom,
    is_pure_assn(bot_bot(assn)) ).

% is_pure_assn_basic_simps(1)
tff(fact_128_Abs__assn__eqI_I2_J,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Pr: assn] :
      ( ! [H4: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,H4))
        <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Pr),H4)) )
     => ( Pr = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,P) ) ) ).

% Abs_assn_eqI(2)
tff(fact_129_Abs__assn__eqI_I1_J,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Pr: assn] :
      ( ! [H4: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,H4))
        <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Pr),H4)) )
     => ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,P) = Pr ) ) ).

% Abs_assn_eqI(1)
tff(fact_130_ex__distrib__and,axiom,
    ! [A: $tType,P: fun(A,assn),Q: assn] : ( ex_assn(A,aa(assn,fun(A,assn),aTP_Lamp_ai(fun(A,assn),fun(assn,fun(A,assn)),P),Q)) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),ex_assn(A,P)),Q) ) ).

% ex_distrib_and
tff(fact_131_inf__top__left,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),top_top(A)),X2) = X2 ) ) ).

% inf_top_left
tff(fact_132_inf__top__right,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),top_top(A)) = X2 ) ) ).

% inf_top_right
tff(fact_133_inf__eq__top__iff,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [X2: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) = top_top(A) )
        <=> ( ( X2 = top_top(A) )
            & ( Y = top_top(A) ) ) ) ) ).

% inf_eq_top_iff
tff(fact_134_top__eq__inf__iff,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [X2: A,Y: A] :
          ( ( top_top(A) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) )
        <=> ( ( X2 = top_top(A) )
            & ( Y = top_top(A) ) ) ) ) ).

% top_eq_inf_iff
tff(fact_135_inf__top_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) = top_top(A) )
        <=> ( ( A4 = top_top(A) )
            & ( B3 = top_top(A) ) ) ) ) ).

% inf_top.eq_neutr_iff
tff(fact_136_inf__top_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),top_top(A)),A4) = A4 ) ) ).

% inf_top.left_neutral
tff(fact_137_inf__top_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [A4: A,B3: A] :
          ( ( top_top(A) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) )
        <=> ( ( A4 = top_top(A) )
            & ( B3 = top_top(A) ) ) ) ) ).

% inf_top.neutr_eq_iff
tff(fact_138_inf__top_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),top_top(A)) = A4 ) ) ).

% inf_top.right_neutral
tff(fact_139_boolean__algebra_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),bot_bot(A)) = bot_bot(A) ) ) ).

% boolean_algebra.conj_zero_right
tff(fact_140_boolean__algebra_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),bot_bot(A)),X2) = bot_bot(A) ) ) ).

% boolean_algebra.conj_zero_left
tff(fact_141_inf__bot__right,axiom,
    ! [A: $tType] :
      ( bounded_lattice_bot(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),bot_bot(A)) = bot_bot(A) ) ) ).

% inf_bot_right
tff(fact_142_inf__bot__left,axiom,
    ! [A: $tType] :
      ( bounded_lattice_bot(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),bot_bot(A)),X2) = bot_bot(A) ) ) ).

% inf_bot_left
tff(fact_143_inf_Oidem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),A4) = A4 ) ) ).

% inf.idem
tff(fact_144_inf__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),X2) = X2 ) ) ).

% inf_idem
tff(fact_145_inf_Oleft__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) ) ) ).

% inf.left_idem
tff(fact_146_inf__left__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) ) ) ).

% inf_left_idem
tff(fact_147_inf_Oright__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),B3) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) ) ) ).

% inf.right_idem
tff(fact_148_inf__right__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),Y) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) ) ) ).

% inf_right_idem
tff(fact_149_inf__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( semilattice_inf(B)
     => ! [F2: fun(A,B),G: fun(A,B),X2: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),inf_inf(fun(A,B)),F2),G),X2) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(A,B,F2,X2)),aa(A,B,G,X2)) ) ) ).

% inf_apply
tff(fact_150_inf__sup__aci_I4_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) ) ) ).

% inf_sup_aci(4)
tff(fact_151_inf__sup__aci_I3_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Z2)) ) ) ).

% inf_sup_aci(3)
tff(fact_152_inf__sup__aci_I2_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),Z2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) ) ) ).

% inf_sup_aci(2)
tff(fact_153_inf__sup__aci_I1_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),X2) ) ) ).

% inf_sup_aci(1)
tff(fact_154_inf_Oassoc,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),aa(A,A,aa(A,fun(A,A),inf_inf(A),B3),C2)) ) ) ).

% inf.assoc
tff(fact_155_inf__assoc,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),Z2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) ) ) ).

% inf_assoc
tff(fact_156_inf_Ocommute,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) = aa(A,A,aa(A,fun(A,A),inf_inf(A),B3),A4) ) ) ).

% inf.commute
tff(fact_157_inf__commute,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),X2) ) ) ).

% inf_commute
tff(fact_158_boolean__algebra__cancel_Oinf1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,K: A,A4: A,B3: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),inf_inf(A),K),A4) )
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B3) = aa(A,A,aa(A,fun(A,A),inf_inf(A),K),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)) ) ) ) ).

% boolean_algebra_cancel.inf1
tff(fact_159_boolean__algebra__cancel_Oinf2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,K: A,B3: A,A4: A] :
          ( ( B2 = aa(A,A,aa(A,fun(A,A),inf_inf(A),K),B3) )
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),K),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)) ) ) ) ).

% boolean_algebra_cancel.inf2
tff(fact_160_inf_Oleft__commute,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B3: A,A4: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),B3),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),C2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),aa(A,A,aa(A,fun(A,A),inf_inf(A),B3),C2)) ) ) ).

% inf.left_commute
tff(fact_161_inf__left__commute,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Z2)) ) ) ).

% inf_left_commute
tff(fact_162_inf__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( semilattice_inf(B)
     => ! [F2: fun(A,B),G: fun(A,B),X4: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),inf_inf(fun(A,B)),F2),G),X4) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(A,B,F2,X4)),aa(A,B,G,X4)) ) ) ).

% inf_fun_def
tff(fact_163_boolean__algebra_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),top_top(A)) = X2 ) ) ).

% boolean_algebra.conj_one_right
tff(fact_164_inf__top_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => comm_monoid(A,inf_inf(A),top_top(A)) ) ).

% inf_top.comm_monoid_axioms
tff(fact_165_inf__top_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => monoid(A,inf_inf(A),top_top(A)) ) ).

% inf_top.monoid_axioms
tff(fact_166_sngr__same__false,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [P5: ref(A),X2: A,Y: A] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),sngr_assn(A,P5,X2)),sngr_assn(A,P5,Y)) = bot_bot(assn) ) ) ).

% sngr_same_false
tff(fact_167_snga__same__false,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [P5: array(A),X2: list(A),Y: list(A)] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(A,P5,X2)),snga_assn(A,P5,Y)) = bot_bot(assn) ) ) ).

% snga_same_false
tff(fact_168_times__assn__def,axiom,
    ! [P: assn,Q: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,times_assn_raw(aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q))) ) ).

% times_assn_def
tff(fact_169_one__assn__def,axiom,
    one_one(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,one_assn_raw) ).

% one_assn_def
tff(fact_170_pure__assn__def,axiom,
    ! [B3: bool] : ( pure_assn(B3) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,pure_assn_raw(heap_ext(product_unit),nat,B3)) ) ).

% pure_assn_def
tff(fact_171_uminus__assn__def,axiom,
    ! [P: assn] : ( aa(assn,assn,uminus_uminus(assn),P) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aTP_Lamp_aj(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),P)) ) ).

% uminus_assn_def
tff(fact_172_ex__assn__def,axiom,
    ! [A: $tType,P: fun(A,assn)] : ( ex_assn(A,P) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aTP_Lamp_ak(fun(A,assn),fun(product_prod(heap_ext(product_unit),set(nat)),bool),P)) ) ).

% ex_assn_def
tff(fact_173_prod__list_Ocomm__monoid__list__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => groups1828464146339083142d_list(A,times_times(A),one_one(A)) ) ).

% prod_list.comm_monoid_list_axioms
tff(fact_174_mod__h__bot__iff_I8_J,axiom,
    ! [C: $tType,R: fun(C,assn),H2: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,ex_assn(C,R)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> ? [X3: C] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(C,assn,R,X3)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ).

% mod_h_bot_iff(8)
tff(fact_175_monoid_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( monoid(A,F2,Z2)
     => monoid_axioms(A,F2,Z2) ) ).

% monoid.axioms(2)
tff(fact_176_prod__list_Omonoid__list__axioms,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => groups_monoid_list(A,times_times(A),one_one(A)) ) ).

% prod_list.monoid_list_axioms
tff(fact_177_comm__monoid_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid(A,F2,Z2)
     => comm_monoid_axioms(A,F2,Z2) ) ).

% comm_monoid.axioms(2)
tff(fact_178_boolean__algebra__class_Oboolean__algebra_Odouble__compl,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,uminus_uminus(A),X2)) = X2 ) ) ).

% boolean_algebra_class.boolean_algebra.double_compl
tff(fact_179_boolean__algebra__class_Oboolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] :
          ( ( aa(A,A,uminus_uminus(A),X2) = aa(A,A,uminus_uminus(A),Y) )
        <=> ( X2 = Y ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_eq_compl_iff
tff(fact_180_uminus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( uminus(B)
     => ! [A3: fun(A,B),X2: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),uminus_uminus(fun(A,B)),A3),X2) = aa(B,B,uminus_uminus(B),aa(A,B,A3,X2)) ) ) ).

% uminus_apply
tff(fact_181_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,uminus_uminus(A),A4)) = A4 ) ) ).

% add.inverse_inverse
tff(fact_182_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,uminus_uminus(A),A4) = aa(A,A,uminus_uminus(A),B3) )
        <=> ( A4 = B3 ) ) ) ).

% neg_equal_iff_equal
tff(fact_183_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A4)),B3) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) ) ) ).

% mult_minus_left
tff(fact_184_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A4)),aa(A,A,uminus_uminus(A),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3) ) ) ).

% minus_mult_minus
tff(fact_185_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,uminus_uminus(A),B3)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) ) ) ).

% mult_minus_right
tff(fact_186_boolean__algebra_Ocompl__one,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ( aa(A,A,uminus_uminus(A),top_top(A)) = bot_bot(A) ) ) ).

% boolean_algebra.compl_one
tff(fact_187_boolean__algebra_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ( aa(A,A,uminus_uminus(A),bot_bot(A)) = top_top(A) ) ) ).

% boolean_algebra.compl_zero
tff(fact_188_boolean__algebra_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,uminus_uminus(A),X2)) = bot_bot(A) ) ) ).

% boolean_algebra.conj_cancel_right
tff(fact_189_boolean__algebra_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X2)),X2) = bot_bot(A) ) ) ).

% boolean_algebra.conj_cancel_left
tff(fact_190_inf__compl__bot__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),aa(A,A,uminus_uminus(A),X2))) = bot_bot(A) ) ) ).

% inf_compl_bot_right
tff(fact_191_inf__compl__bot__left2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X2)),Y)) = bot_bot(A) ) ) ).

% inf_compl_bot_left2
tff(fact_192_inf__compl__bot__left1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)) = bot_bot(A) ) ) ).

% inf_compl_bot_left1
tff(fact_193_in__range__empty,axiom,
    ! [H2: heap_ext(product_unit)] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ).

% in_range_empty
tff(fact_194_mod__not__dist,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,uminus_uminus(assn),P)),H2))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,H2))
        & ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2)) ) ) ).

% mod_not_dist
tff(fact_195_mod__h__bot__iff_I5_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ) ).

% mod_h_bot_iff(5)
tff(fact_196_mod__h__bot__iff_I1_J,axiom,
    ! [B3: bool,H2: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,pure_assn(B3)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> pp(B3) ) ).

% mod_h_bot_iff(1)
tff(fact_197_mod__h__bot__iff_I6_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),P),Q)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ) ).

% mod_h_bot_iff(6)
tff(fact_198_mod__h__bot__iff_I4_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Q3: array(B),Y: list(B),H2: heap_ext(product_unit)] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,snga_assn(B,Q3,Y)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ).

% mod_h_bot_iff(4)
tff(fact_199_mod__h__bot__iff_I3_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [P5: ref(A),X2: A,H2: heap_ext(product_unit)] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,sngr_assn(A,P5,X2)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ).

% mod_h_bot_iff(3)
tff(fact_200_one__assn__raw_Oelims_I3_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X2))
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( As = bot_bot(set(nat)) ) ) ) ).

% one_assn_raw.elims(3)
tff(fact_201_one__assn__raw_Oelims_I2_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X2))
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( As != bot_bot(set(nat)) ) ) ) ).

% one_assn_raw.elims(2)
tff(fact_202_one__assn__raw_Oelims_I1_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X2))
      <=> pp(Y) )
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( pp(Y)
            <=> ( As != bot_bot(set(nat)) ) ) ) ) ).

% one_assn_raw.elims(1)
tff(fact_203_pure__assn__raw_Oelims_I3_J,axiom,
    ! [B: $tType,A: $tType,X2: bool,Xa: product_prod(A,set(B))] :
      ( ~ pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X2),Xa))
     => ~ ! [H4: A,As: set(B)] :
            ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H4),As) )
           => ( ( As = bot_bot(set(B)) )
              & pp(X2) ) ) ) ).

% pure_assn_raw.elims(3)
tff(fact_204_pure__assn__raw_Oelims_I2_J,axiom,
    ! [B: $tType,A: $tType,X2: bool,Xa: product_prod(A,set(B))] :
      ( pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X2),Xa))
     => ~ ! [H4: A,As: set(B)] :
            ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H4),As) )
           => ~ ( ( As = bot_bot(set(B)) )
                & pp(X2) ) ) ) ).

% pure_assn_raw.elims(2)
tff(fact_205_pure__assn__raw_Oelims_I1_J,axiom,
    ! [B: $tType,A: $tType,X2: bool,Xa: product_prod(A,set(B)),Y: bool] :
      ( ( pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X2),Xa))
      <=> pp(Y) )
     => ~ ! [H4: A,As: set(B)] :
            ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H4),As) )
           => ( pp(Y)
            <=> ~ ( ( As = bot_bot(set(B)) )
                  & pp(X2) ) ) ) ) ).

% pure_assn_raw.elims(1)
tff(fact_206_one__assn__raw_Osimps,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
    <=> ( As2 = bot_bot(set(nat)) ) ) ).

% one_assn_raw.simps
tff(fact_207_pure__assn__raw_Osimps,axiom,
    ! [B: $tType,A: $tType,B3: bool,H2: A,As2: set(B)] :
      ( pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,B3),aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H2),As2)))
    <=> ( ( As2 = bot_bot(set(B)) )
        & pp(B3) ) ) ).

% pure_assn_raw.simps
tff(fact_208_fun__Compl__def,axiom,
    ! [B: $tType,A: $tType] :
      ( uminus(B)
     => ! [A3: fun(A,B),X4: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),uminus_uminus(fun(A,B)),A3),X4) = aa(B,B,uminus_uminus(B),aa(A,B,A3,X4)) ) ) ).

% fun_Compl_def
tff(fact_209_one__assn__raw_Ocases,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ~ ! [H4: heap_ext(product_unit),As: set(nat)] : ( X2 != aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) ) ).

% one_assn_raw.cases
tff(fact_210_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = aa(A,A,uminus_uminus(A),B3) )
        <=> ( B3 = aa(A,A,uminus_uminus(A),A4) ) ) ) ).

% equation_minus_iff
tff(fact_211_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,uminus_uminus(A),A4) = B3 )
        <=> ( aa(A,A,uminus_uminus(A),B3) = A4 ) ) ) ).

% minus_equation_iff
tff(fact_212_comm__monoid__list_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups1828464146339083142d_list(A,F2,Z2)
     => groups_monoid_list(A,F2,Z2) ) ).

% comm_monoid_list.axioms(2)
tff(fact_213_comm__monoid__axioms__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid_axioms(A,F2,Z2)
    <=> ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F2,A6),Z2) = A6 ) ) ).

% comm_monoid_axioms_def
tff(fact_214_monoid__axioms__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( monoid_axioms(A,F2,Z2)
    <=> ( ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F2,Z2),A6) = A6 )
        & ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F2,A6),Z2) = A6 ) ) ) ).

% monoid_axioms_def
tff(fact_215_comm__monoid__axioms_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( ! [A5: A] : ( aa(A,A,aa(A,fun(A,A),F2,A5),Z2) = A5 )
     => comm_monoid_axioms(A,F2,Z2) ) ).

% comm_monoid_axioms.intro
tff(fact_216_monoid__axioms_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( ! [A5: A] : ( aa(A,A,aa(A,fun(A,A),F2,Z2),A5) = A5 )
     => ( ! [A5: A] : ( aa(A,A,aa(A,fun(A,A),F2,A5),Z2) = A5 )
       => monoid_axioms(A,F2,Z2) ) ) ).

% monoid_axioms.intro
tff(fact_217_comm__monoid__list__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups1828464146339083142d_list(A,F2,Z2)
    <=> ( comm_monoid(A,F2,Z2)
        & groups_monoid_list(A,F2,Z2) ) ) ).

% comm_monoid_list_def
tff(fact_218_comm__monoid__list_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid(A,F2,Z2)
     => ( groups_monoid_list(A,F2,Z2)
       => groups1828464146339083142d_list(A,F2,Z2) ) ) ).

% comm_monoid_list.intro
tff(fact_219_square__eq__iff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),B3),B3) )
        <=> ( ( A4 = B3 )
            | ( A4 = aa(A,A,uminus_uminus(A),B3) ) ) ) ) ).

% square_eq_iff
tff(fact_220_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A4)),B3) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,uminus_uminus(A),B3)) ) ) ).

% minus_mult_commute
tff(fact_221_mod__h__bot__indep,axiom,
    ! [P: assn,H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),bot_bot(set(nat))))) ) ).

% mod_h_bot_indep
tff(fact_222_sngr__prec,axiom,
    ! [A: $tType] :
      ( heap(A)
     => precise(A,ref(A),aTP_Lamp_al(A,fun(ref(A),assn))) ) ).

% sngr_prec
tff(fact_223_snga__prec,axiom,
    ! [A: $tType] :
      ( heap(A)
     => precise(list(A),array(A),aTP_Lamp_am(list(A),fun(array(A),assn))) ) ).

% snga_prec
tff(fact_224_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [X2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2) = one_one(A) )
        <=> ( ( X2 = one_one(A) )
            | ( X2 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% square_eq_1_iff
tff(fact_225_inf__cancel__left2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X2)),A4)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),B3)) = bot_bot(A) ) ) ).

% inf_cancel_left2
tff(fact_226_inf__cancel__left1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),A4)),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X2)),B3)) = bot_bot(A) ) ) ).

% inf_cancel_left1
tff(fact_227_monoid__list__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups_monoid_list(A,F2,Z2)
    <=> monoid(A,F2,Z2) ) ).

% monoid_list_def
tff(fact_228_monoid__list_Oaxioms,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups_monoid_list(A,F2,Z2)
     => monoid(A,F2,Z2) ) ).

% monoid_list.axioms
tff(fact_229_monoid__list_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( monoid(A,F2,Z2)
     => groups_monoid_list(A,F2,Z2) ) ).

% monoid_list.intro
tff(fact_230_comm__monoid__list_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups1828464146339083142d_list(A,F2,Z2)
     => comm_monoid(A,F2,Z2) ) ).

% comm_monoid_list.axioms(1)
tff(fact_231_mod__h__bot__iff_I2_J,axiom,
    ! [H2: heap_ext(product_unit)] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,top_top(assn)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ).

% mod_h_bot_iff(2)
tff(fact_232_mod__emp__simp,axiom,
    ! [H2: heap_ext(product_unit)] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,one_one(assn)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ).

% mod_emp_simp
tff(fact_233_comm__monoid__list__set_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups4802862169904069756st_set(A,F2,Z2)
     => groups1828464146339083142d_list(A,F2,Z2) ) ).

% comm_monoid_list_set.axioms(1)
tff(fact_234_mult__minus1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),one_one(A))),Z2) = aa(A,A,uminus_uminus(A),Z2) ) ) ).

% mult_minus1
tff(fact_235_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z2),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),Z2) ) ) ).

% mult_minus1_right
tff(fact_236_Collect__const,axiom,
    ! [A: $tType,P: bool] :
      ( ( pp(P)
       => ( aa(fun(A,bool),set(A),collect(A),aTP_Lamp_an(bool,fun(A,bool),P)) = top_top(set(A)) ) )
      & ( ~ pp(P)
       => ( aa(fun(A,bool),set(A),collect(A),aTP_Lamp_an(bool,fun(A,bool),P)) = bot_bot(set(A)) ) ) ) ).

% Collect_const
tff(fact_237_empty__Collect__eq,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ( bot_bot(set(A)) = aa(fun(A,bool),set(A),collect(A),P) )
    <=> ! [X3: A] : ~ pp(aa(A,bool,P,X3)) ) ).

% empty_Collect_eq
tff(fact_238_Collect__empty__eq,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ( aa(fun(A,bool),set(A),collect(A),P) = bot_bot(set(A)) )
    <=> ! [X3: A] : ~ pp(aa(A,bool,P,X3)) ) ).

% Collect_empty_eq
tff(fact_239_all__not__in__conv,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ! [X3: A] : ~ pp(aa(set(A),bool,member(A,X3),A3))
    <=> ( A3 = bot_bot(set(A)) ) ) ).

% all_not_in_conv
tff(fact_240_empty__iff,axiom,
    ! [A: $tType,C2: A] : ~ pp(aa(set(A),bool,member(A,C2),bot_bot(set(A)))) ).

% empty_iff
tff(fact_241_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( one_one(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% one_neq_neg_one
tff(fact_242_snga__assn__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R2: array(A),A4: list(A)] : ( snga_assn(A,R2,A4) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,snga_assn_raw(A,R2,A4)) ) ) ).

% snga_assn_def
tff(fact_243_sngr__assn__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R2: ref(A),X2: A] : ( sngr_assn(A,R2,X2) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,sngr_assn_raw(A,R2,X2)) ) ) ).

% sngr_assn_def
tff(fact_244_Set_Oempty__def,axiom,
    ! [A: $tType] : ( bot_bot(set(A)) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_ao(A,bool)) ) ).

% Set.empty_def
tff(fact_245_Compl__disjoint,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),A3)) = bot_bot(set(A)) ) ).

% Compl_disjoint
tff(fact_246_Compl__disjoint2,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A3)),A3) = bot_bot(set(A)) ) ).

% Compl_disjoint2
tff(fact_247_Int__UNIV,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = top_top(set(A)) )
    <=> ( ( A3 = top_top(set(A)) )
        & ( B2 = top_top(set(A)) ) ) ) ).

% Int_UNIV
tff(fact_248_Int__UNIV__left,axiom,
    ! [A: $tType,B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),top_top(set(A))),B2) = B2 ) ).

% Int_UNIV_left
tff(fact_249_Int__UNIV__right,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),top_top(set(A))) = A3 ) ).

% Int_UNIV_right
tff(fact_250_Compl__empty__eq,axiom,
    ! [A: $tType] : ( aa(set(A),set(A),uminus_uminus(set(A)),bot_bot(set(A))) = top_top(set(A)) ) ).

% Compl_empty_eq
tff(fact_251_Compl__UNIV__eq,axiom,
    ! [A: $tType] : ( aa(set(A),set(A),uminus_uminus(set(A)),top_top(set(A))) = bot_bot(set(A)) ) ).

% Compl_UNIV_eq
tff(fact_252_emptyE,axiom,
    ! [A: $tType,A4: A] : ~ pp(aa(set(A),bool,member(A,A4),bot_bot(set(A)))) ).

% emptyE
tff(fact_253_equals0D,axiom,
    ! [A: $tType,A3: set(A),A4: A] :
      ( ( A3 = bot_bot(set(A)) )
     => ~ pp(aa(set(A),bool,member(A,A4),A3)) ) ).

% equals0D
tff(fact_254_equals0I,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ! [Y2: A] : ~ pp(aa(set(A),bool,member(A,Y2),A3))
     => ( A3 = bot_bot(set(A)) ) ) ).

% equals0I
tff(fact_255_Int__emptyI,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),A3))
         => ~ pp(aa(set(A),bool,member(A,X),B2)) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) ) ) ).

% Int_emptyI
tff(fact_256_ex__in__conv,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ? [X3: A] : pp(aa(set(A),bool,member(A,X3),A3))
    <=> ( A3 != bot_bot(set(A)) ) ) ).

% ex_in_conv
tff(fact_257_bot__set__def,axiom,
    ! [A: $tType] : ( bot_bot(set(A)) = aa(fun(A,bool),set(A),collect(A),bot_bot(fun(A,bool))) ) ).

% bot_set_def
tff(fact_258_disjoint__iff,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) )
    <=> ! [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),A3))
         => ~ pp(aa(set(A),bool,member(A,X3),B2)) ) ) ).

% disjoint_iff
tff(fact_259_Int__empty__left,axiom,
    ! [A: $tType,B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),bot_bot(set(A))),B2) = bot_bot(set(A)) ) ).

% Int_empty_left
tff(fact_260_Int__empty__right,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),bot_bot(set(A))) = bot_bot(set(A)) ) ).

% Int_empty_right
tff(fact_261_disjoint__iff__not__equal,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) )
    <=> ! [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),A3))
         => ! [Xa2: A] :
              ( pp(aa(set(A),bool,member(A,Xa2),B2))
             => ( X3 != Xa2 ) ) ) ) ).

% disjoint_iff_not_equal
tff(fact_262_empty__not__UNIV,axiom,
    ! [A: $tType] : ( bot_bot(set(A)) != top_top(set(A)) ) ).

% empty_not_UNIV
tff(fact_263_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_inc_simps(4)
tff(fact_264_Set_Ois__empty__def,axiom,
    ! [A: $tType,A3: set(A)] :
      ( is_empty(A,A3)
    <=> ( A3 = bot_bot(set(A)) ) ) ).

% Set.is_empty_def
tff(fact_265_pred__equals__eq2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S: set(product_prod(A,B))] :
      ( ! [X3: A,Xa2: B] :
          ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa2)),R))
        <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa2)),S)) )
    <=> ( R = S ) ) ).

% pred_equals_eq2
tff(fact_266_top__empty__eq2,axiom,
    ! [B: $tType,A: $tType,X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),top_top(fun(A,fun(B,bool))),X4),Xa3))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa3)),top_top(set(product_prod(A,B))))) ) ).

% top_empty_eq2
tff(fact_267_inf__Int__eq2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S: set(product_prod(A,B)),X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),R)),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),S)),X4),Xa3))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa3)),aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),R),S))) ) ).

% inf_Int_eq2
tff(fact_268_bot__empty__eq2,axiom,
    ! [B: $tType,A: $tType,X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),bot_bot(fun(A,fun(B,bool))),X4),Xa3))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa3)),bot_bot(set(product_prod(A,B))))) ) ).

% bot_empty_eq2
tff(fact_269_hoare__triple__success,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn),H2: heap_ext(product_unit),As2: set(nat)] :
      ( hoare_hoare_triple(A,P,C2,Q)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
       => heap_Time_success(A,C2,H2) ) ) ).

% hoare_triple_success
tff(fact_270_mod__star__conv,axiom,
    ! [A3: assn,B2: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),B2)),H2))
    <=> ? [Hr: heap_ext(product_unit),As1: set(nat),As22: set(nat)] :
          ( ( H2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22)) )
          & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,A3),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),As1)))
          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,B2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),As22))) ) ) ).

% mod_star_conv
tff(fact_271_star__assnI,axiom,
    ! [P: assn,H2: heap_ext(product_unit),As2: set(nat),Q: assn,As3: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3)))
       => ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As3) = bot_bot(set(nat)) )
         => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As3)))) ) ) ) ).

% star_assnI
tff(fact_272_mod__pure,axiom,
    ! [B3: bool,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,pure_assn(B3)),H2))
    <=> ( ( aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2) = bot_bot(set(nat)) )
        & pp(B3) ) ) ).

% mod_pure
tff(fact_273_mod__h__bot__iff_I7_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),P),Q)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
        | pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ) ).

% mod_h_bot_iff(7)
tff(fact_274_sup_Oidem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),A4) = A4 ) ) ).

% sup.idem
tff(fact_275_sup__idem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),X2) = X2 ) ) ).

% sup_idem
tff(fact_276_sup_Oleft__idem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) ) ) ).

% sup.left_idem
tff(fact_277_sup__left__idem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) ) ) ).

% sup_left_idem
tff(fact_278_sup_Oright__idem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3)),B3) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) ) ) ).

% sup.right_idem
tff(fact_279_sup__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( semilattice_sup(B)
     => ! [F2: fun(A,B),G: fun(A,B),X2: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),sup_sup(fun(A,B)),F2),G),X2) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(A,B,F2,X2)),aa(A,B,G,X2)) ) ) ).

% sup_apply
tff(fact_280_Int__iff,axiom,
    ! [A: $tType,C2: A,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,member(A,C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)))
    <=> ( pp(aa(set(A),bool,member(A,C2),A3))
        & pp(aa(set(A),bool,member(A,C2),B2)) ) ) ).

% Int_iff
tff(fact_281_IntI,axiom,
    ! [A: $tType,C2: A,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,member(A,C2),A3))
     => ( pp(aa(set(A),bool,member(A,C2),B2))
       => pp(aa(set(A),bool,member(A,C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))) ) ) ).

% IntI
tff(fact_282_inf2I,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool)),X2: A,Y: B,B2: fun(A,fun(B,bool))] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),A3,X2),Y))
     => ( pp(aa(B,bool,aa(A,fun(B,bool),B2,X2),Y))
       => pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),A3),B2),X2),Y)) ) ) ).

% inf2I
tff(fact_283_sup__bot_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),bot_bot(A)) = A4 ) ) ).

% sup_bot.right_neutral
tff(fact_284_sup__bot_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [A4: A,B3: A] :
          ( ( bot_bot(A) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) )
        <=> ( ( A4 = bot_bot(A) )
            & ( B3 = bot_bot(A) ) ) ) ) ).

% sup_bot.neutr_eq_iff
tff(fact_285_sup__bot_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),bot_bot(A)),A4) = A4 ) ) ).

% sup_bot.left_neutral
tff(fact_286_sup__bot_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) = bot_bot(A) )
        <=> ( ( A4 = bot_bot(A) )
            & ( B3 = bot_bot(A) ) ) ) ) ).

% sup_bot.eq_neutr_iff
tff(fact_287_sup__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [X2: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) = bot_bot(A) )
        <=> ( ( X2 = bot_bot(A) )
            & ( Y = bot_bot(A) ) ) ) ) ).

% sup_eq_bot_iff
tff(fact_288_bot__eq__sup__iff,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [X2: A,Y: A] :
          ( ( bot_bot(A) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) )
        <=> ( ( X2 = bot_bot(A) )
            & ( Y = bot_bot(A) ) ) ) ) ).

% bot_eq_sup_iff
tff(fact_289_sup__bot__right,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),bot_bot(A)) = X2 ) ) ).

% sup_bot_right
tff(fact_290_sup__bot__left,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),bot_bot(A)),X2) = X2 ) ) ).

% sup_bot_left
tff(fact_291_sup__top__left,axiom,
    ! [A: $tType] :
      ( bounded_lattice_top(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),top_top(A)),X2) = top_top(A) ) ) ).

% sup_top_left
tff(fact_292_sup__top__right,axiom,
    ! [A: $tType] :
      ( bounded_lattice_top(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),top_top(A)) = top_top(A) ) ) ).

% sup_top_right
tff(fact_293_boolean__algebra_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),top_top(A)),X2) = top_top(A) ) ) ).

% boolean_algebra.disj_one_left
tff(fact_294_boolean__algebra_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),top_top(A)) = top_top(A) ) ) ).

% boolean_algebra.disj_one_right
tff(fact_295_sup__inf__absorb,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)) = X2 ) ) ).

% sup_inf_absorb
tff(fact_296_inf__sup__absorb,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)) = X2 ) ) ).

% inf_sup_absorb
tff(fact_297_Un__empty,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2) = bot_bot(set(A)) )
    <=> ( ( A3 = bot_bot(set(A)) )
        & ( B2 = bot_bot(set(A)) ) ) ) ).

% Un_empty
tff(fact_298_Un__Int__eq_I1_J,axiom,
    ! [A: $tType,S: set(A),T2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S),T2)),S) = S ) ).

% Un_Int_eq(1)
tff(fact_299_Un__Int__eq_I2_J,axiom,
    ! [A: $tType,S: set(A),T2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S),T2)),T2) = T2 ) ).

% Un_Int_eq(2)
tff(fact_300_Un__Int__eq_I3_J,axiom,
    ! [A: $tType,S: set(A),T2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S),T2)) = S ) ).

% Un_Int_eq(3)
tff(fact_301_Un__Int__eq_I4_J,axiom,
    ! [A: $tType,T2: set(A),S: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),T2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S),T2)) = T2 ) ).

% Un_Int_eq(4)
tff(fact_302_Int__Un__eq_I1_J,axiom,
    ! [A: $tType,S: set(A),T2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T2)),S) = S ) ).

% Int_Un_eq(1)
tff(fact_303_Int__Un__eq_I2_J,axiom,
    ! [A: $tType,S: set(A),T2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T2)),T2) = T2 ) ).

% Int_Un_eq(2)
tff(fact_304_Int__Un__eq_I3_J,axiom,
    ! [A: $tType,S: set(A),T2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T2)) = S ) ).

% Int_Un_eq(3)
tff(fact_305_Int__Un__eq_I4_J,axiom,
    ! [A: $tType,T2: set(A),S: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),T2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T2)) = T2 ) ).

% Int_Un_eq(4)
tff(fact_306_mod__or__dist,axiom,
    ! [P: assn,Q: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),P),Q)),H2))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
        | pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H2)) ) ) ).

% mod_or_dist
tff(fact_307_merge__pure__or,axiom,
    ! [A4: bool,B3: bool] : ( aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),pure_assn(A4)),pure_assn(B3)) = pure_assn(fdisj(A4,B3)) ) ).

% merge_pure_or
tff(fact_308_sup__compl__top__left1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)) = top_top(A) ) ) ).

% sup_compl_top_left1
tff(fact_309_sup__compl__top__left2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X2)),Y)) = top_top(A) ) ) ).

% sup_compl_top_left2
tff(fact_310_boolean__algebra_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X2)),X2) = top_top(A) ) ) ).

% boolean_algebra.disj_cancel_left
tff(fact_311_boolean__algebra_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,uminus_uminus(A),X2)) = top_top(A) ) ) ).

% boolean_algebra.disj_cancel_right
tff(fact_312_boolean__algebra_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% boolean_algebra.de_Morgan_conj
tff(fact_313_boolean__algebra_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% boolean_algebra.de_Morgan_disj
tff(fact_314_in__range__dist__union,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat),As3: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As3))))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3))) ) ) ).

% in_range_dist_union
tff(fact_315_bot2E,axiom,
    ! [A: $tType,B: $tType,X2: A,Y: B] : ~ pp(aa(B,bool,aa(A,fun(B,bool),bot_bot(fun(A,fun(B,bool))),X2),Y)) ).

% bot2E
tff(fact_316_Int__left__commute,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C3)) ) ).

% Int_left_commute
tff(fact_317_Un__Int__distrib2,axiom,
    ! [A: $tType,B2: set(A),C3: set(A),A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3)),A3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B2),A3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),C3),A3)) ) ).

% Un_Int_distrib2
tff(fact_318_Int__left__absorb,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) ) ).

% Int_left_absorb
tff(fact_319_Int__Un__distrib2,axiom,
    ! [A: $tType,B2: set(A),C3: set(A),A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B2),C3)),A3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),A3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),A3)) ) ).

% Int_Un_distrib2
tff(fact_320_Collect__conj__eq,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] : ( aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(fun(A,bool),set(A),collect(A),P)),aa(fun(A,bool),set(A),collect(A),Q)) ) ).

% Collect_conj_eq
tff(fact_321_Un__Int__distrib,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),C3)) ) ).

% Un_Int_distrib
tff(fact_322_Int__Un__distrib,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B2),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C3)) ) ).

% Int_Un_distrib
tff(fact_323_Un__Int__crazy,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),A3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B2),C3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),C3),A3)) ) ).

% Un_Int_crazy
tff(fact_324_inf__set__def,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),B2))) ) ).

% inf_set_def
tff(fact_325_Int__commute,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),A3) ) ).

% Int_commute
tff(fact_326_Int__Collect,axiom,
    ! [A: $tType,X2: A,A3: set(A),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,member(A,X2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,bool),set(A),collect(A),P))))
    <=> ( pp(aa(set(A),bool,member(A,X2),A3))
        & pp(aa(A,bool,P,X2)) ) ) ).

% Int_Collect
tff(fact_327_Int__absorb,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),A3) = A3 ) ).

% Int_absorb
tff(fact_328_Int__assoc,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3)) ) ).

% Int_assoc
tff(fact_329_Compl__Int,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A3)),aa(set(A),set(A),uminus_uminus(set(A)),B2)) ) ).

% Compl_Int
tff(fact_330_Compl__Un,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A3)),aa(set(A),set(A),uminus_uminus(set(A)),B2)) ) ).

% Compl_Un
tff(fact_331_Int__def,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_ar(set(A),fun(set(A),fun(A,bool)),A3),B2)) ) ).

% Int_def
tff(fact_332_IntD2,axiom,
    ! [A: $tType,C2: A,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,member(A,C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)))
     => pp(aa(set(A),bool,member(A,C2),B2)) ) ).

% IntD2
tff(fact_333_IntD1,axiom,
    ! [A: $tType,C2: A,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,member(A,C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)))
     => pp(aa(set(A),bool,member(A,C2),A3)) ) ).

% IntD1
tff(fact_334_IntE,axiom,
    ! [A: $tType,C2: A,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,member(A,C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)))
     => ~ ( pp(aa(set(A),bool,member(A,C2),A3))
         => ~ pp(aa(set(A),bool,member(A,C2),B2)) ) ) ).

% IntE
tff(fact_335_uminus__set__def,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),A3) = aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),uminus_uminus(fun(A,bool)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3))) ) ).

% uminus_set_def
tff(fact_336_Collect__neg__eq,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( aa(fun(A,bool),set(A),collect(A),aTP_Lamp_as(fun(A,bool),fun(A,bool),P)) = aa(set(A),set(A),uminus_uminus(set(A)),aa(fun(A,bool),set(A),collect(A),P)) ) ).

% Collect_neg_eq
tff(fact_337_Compl__eq,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),A3) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_at(set(A),fun(A,bool),A3)) ) ).

% Compl_eq
tff(fact_338_inf__sup__aci_I8_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) ) ) ).

% inf_sup_aci(8)
tff(fact_339_inf__sup__aci_I7_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Z2)) ) ) ).

% inf_sup_aci(7)
tff(fact_340_inf__sup__aci_I6_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)),Z2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) ) ) ).

% inf_sup_aci(6)
tff(fact_341_inf__sup__aci_I5_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),X2) ) ) ).

% inf_sup_aci(5)
tff(fact_342_sup_Oassoc,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),aa(A,A,aa(A,fun(A,A),sup_sup(A),B3),C2)) ) ) ).

% sup.assoc
tff(fact_343_sup__assoc,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)),Z2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) ) ) ).

% sup_assoc
tff(fact_344_sup_Ocommute,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) = aa(A,A,aa(A,fun(A,A),sup_sup(A),B3),A4) ) ) ).

% sup.commute
tff(fact_345_sup__commute,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),X2) ) ) ).

% sup_commute
tff(fact_346_boolean__algebra__cancel_Osup1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,K: A,A4: A,B3: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),sup_sup(A),K),A4) )
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B3) = aa(A,A,aa(A,fun(A,A),sup_sup(A),K),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3)) ) ) ) ).

% boolean_algebra_cancel.sup1
tff(fact_347_boolean__algebra__cancel_Osup2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,K: A,B3: A,A4: A] :
          ( ( B2 = aa(A,A,aa(A,fun(A,A),sup_sup(A),K),B3) )
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),K),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3)) ) ) ) ).

% boolean_algebra_cancel.sup2
tff(fact_348_sup_Oleft__commute,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,A4: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),B3),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),C2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),aa(A,A,aa(A,fun(A,A),sup_sup(A),B3),C2)) ) ) ).

% sup.left_commute
tff(fact_349_sup__left__commute,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Z2)) ) ) ).

% sup_left_commute
tff(fact_350_sup__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( semilattice_sup(B)
     => ! [F2: fun(A,B),G: fun(A,B),X4: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),sup_sup(fun(A,B)),F2),G),X4) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(A,B,F2,X4)),aa(A,B,G,X4)) ) ) ).

% sup_fun_def
tff(fact_351_inf__Int__eq,axiom,
    ! [A: $tType,R: set(A),S: set(A),X4: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),R)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),S)),X4))
    <=> pp(aa(set(A),bool,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),R),S))) ) ).

% inf_Int_eq
tff(fact_352_inf2E,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool)),B2: fun(A,fun(B,bool)),X2: A,Y: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),A3),B2),X2),Y))
     => ~ ( pp(aa(B,bool,aa(A,fun(B,bool),A3,X2),Y))
         => ~ pp(aa(B,bool,aa(A,fun(B,bool),B2,X2),Y)) ) ) ).

% inf2E
tff(fact_353_inf2D1,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool)),B2: fun(A,fun(B,bool)),X2: A,Y: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),A3),B2),X2),Y))
     => pp(aa(B,bool,aa(A,fun(B,bool),A3,X2),Y)) ) ).

% inf2D1
tff(fact_354_inf2D2,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool)),B2: fun(A,fun(B,bool)),X2: A,Y: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),A3),B2),X2),Y))
     => pp(aa(B,bool,aa(A,fun(B,bool),B2,X2),Y)) ) ).

% inf2D2
tff(fact_355_times__assn__raw_Ocases,axiom,
    ! [X2: product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))] :
      ~ ! [P3: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q4: fun(product_prod(heap_ext(product_unit),set(nat)),bool),H4: heap_ext(product_unit),As: set(nat)] : ( X2 != aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),P3),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Q4),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ).

% times_assn_raw.cases
tff(fact_356_sngr__assn__raw_Ocases,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))] :
          ~ ! [R3: ref(A),X: A,H4: heap_ext(product_unit),As: set(nat)] : ( X2 != aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),R3),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),X),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ) ).

% sngr_assn_raw.cases
tff(fact_357_snga__assn__raw_Ocases,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))] :
          ~ ! [R3: array(A),X: list(A),H4: heap_ext(product_unit),As: set(nat)] : ( X2 != aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),R3),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),X),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ) ).

% snga_assn_raw.cases
tff(fact_358_Collect__disj__eq,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] : ( aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_au(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(fun(A,bool),set(A),collect(A),P)),aa(fun(A,bool),set(A),collect(A),Q)) ) ).

% Collect_disj_eq
tff(fact_359_Un__def,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_av(set(A),fun(set(A),fun(A,bool)),A3),B2)) ) ).

% Un_def
tff(fact_360_Collect__imp__eq,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] : ( aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_aw(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),aa(fun(A,bool),set(A),collect(A),P))),aa(fun(A,bool),set(A),collect(A),Q)) ) ).

% Collect_imp_eq
tff(fact_361_boolean__algebra_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),bot_bot(A)) = X2 ) ) ).

% boolean_algebra.disj_zero_right
tff(fact_362_boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,Z2: A,X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)),X2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),X2)),aa(A,A,aa(A,fun(A,A),sup_sup(A),Z2),X2)) ) ) ).

% boolean_algebra.disj_conj_distrib2
tff(fact_363_boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,Z2: A,X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)),X2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),X2)),aa(A,A,aa(A,fun(A,A),inf_inf(A),Z2),X2)) ) ) ).

% boolean_algebra.conj_disj_distrib2
tff(fact_364_boolean__algebra_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Z2)) ) ) ).

% boolean_algebra.disj_conj_distrib
tff(fact_365_boolean__algebra_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Z2)) ) ) ).

% boolean_algebra.conj_disj_distrib
tff(fact_366_sup__inf__distrib2,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Y: A,Z2: A,X2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)),X2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),X2)),aa(A,A,aa(A,fun(A,A),sup_sup(A),Z2),X2)) ) ) ).

% sup_inf_distrib2
tff(fact_367_sup__inf__distrib1,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Z2)) ) ) ).

% sup_inf_distrib1
tff(fact_368_inf__sup__distrib2,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Y: A,Z2: A,X2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)),X2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),X2)),aa(A,A,aa(A,fun(A,A),inf_inf(A),Z2),X2)) ) ) ).

% inf_sup_distrib2
tff(fact_369_inf__sup__distrib1,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Z2)) ) ) ).

% inf_sup_distrib1
tff(fact_370_distrib__imp2,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( ! [X: A,Y2: A,Z3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y2),Z3)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y2)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Z3)) )
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Z2)) ) ) ) ).

% distrib_imp2
tff(fact_371_distrib__imp1,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( ! [X: A,Y2: A,Z3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y2),Z3)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y2)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Z3)) )
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Z2)) ) ) ) ).

% distrib_imp1
tff(fact_372_Un__empty__right,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),bot_bot(set(A))) = A3 ) ).

% Un_empty_right
tff(fact_373_Un__empty__left,axiom,
    ! [A: $tType,B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),bot_bot(set(A))),B2) = B2 ) ).

% Un_empty_left
tff(fact_374_pure__assn__raw_Ocases,axiom,
    ! [A: $tType,B: $tType,X2: product_prod(bool,product_prod(A,set(B)))] :
      ~ ! [B4: bool,H4: A,As: set(B)] : ( X2 != aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),B4),aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H4),As)) ) ).

% pure_assn_raw.cases
tff(fact_375_star__or__dist1,axiom,
    ! [A3: assn,B2: assn,C3: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)),C3) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),C3)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),C3)) ) ).

% star_or_dist1
tff(fact_376_star__or__dist2,axiom,
    ! [C3: assn,A3: assn,B2: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C3),aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C3),A3)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C3),B2)) ) ).

% star_or_dist2
tff(fact_377_ent__disjE,axiom,
    ! [A3: assn,C3: assn,B2: assn] :
      ( entails(A3,C3)
     => ( entails(B2,C3)
       => entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2),C3) ) ) ).

% ent_disjE
tff(fact_378_ent__disjI1,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),P),Q),R)
     => entails(P,R) ) ).

% ent_disjI1
tff(fact_379_ent__disjI2,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),P),Q),R)
     => entails(Q,R) ) ).

% ent_disjI2
tff(fact_380_ent__disjI1_H,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( entails(A3,B2)
     => entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C3)) ) ).

% ent_disjI1'
tff(fact_381_ent__disjI2_H,axiom,
    ! [A3: assn,C3: assn,B2: assn] :
      ( entails(A3,C3)
     => entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C3)) ) ).

% ent_disjI2'
tff(fact_382_ent__disjI1__direct,axiom,
    ! [A3: assn,B2: assn] : entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)) ).

% ent_disjI1_direct
tff(fact_383_ent__disjI2__direct,axiom,
    ! [B2: assn,A3: assn] : entails(B2,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)) ).

% ent_disjI2_direct
tff(fact_384_entt__disjE,axiom,
    ! [A3: assn,M: assn,B2: assn] :
      ( entailst(A3,M)
     => ( entailst(B2,M)
       => entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2),M) ) ) ).

% entt_disjE
tff(fact_385_entt__disjD1,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2),C3)
     => entailst(A3,C3) ) ).

% entt_disjD1
tff(fact_386_entt__disjD2,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2),C3)
     => entailst(B2,C3) ) ).

% entt_disjD2
tff(fact_387_entt__disjI1_H,axiom,
    ! [A3: assn,B2: assn,C3: assn] :
      ( entailst(A3,B2)
     => entailst(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C3)) ) ).

% entt_disjI1'
tff(fact_388_entt__disjI2_H,axiom,
    ! [A3: assn,C3: assn,B2: assn] :
      ( entailst(A3,C3)
     => entailst(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C3)) ) ).

% entt_disjI2'
tff(fact_389_entt__disjI1__direct,axiom,
    ! [A3: assn,B2: assn] : entailst(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)) ).

% entt_disjI1_direct
tff(fact_390_entt__disjI2__direct,axiom,
    ! [B2: assn,A3: assn] : entailst(B2,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)) ).

% entt_disjI2_direct
tff(fact_391_ex__join__or,axiom,
    ! [A: $tType,P: fun(A,assn),Q: fun(A,assn)] : ( ex_assn(A,aa(fun(A,assn),fun(A,assn),aTP_Lamp_ax(fun(A,assn),fun(fun(A,assn),fun(A,assn)),P),Q)) = ex_assn(A,aa(fun(A,assn),fun(A,assn),aTP_Lamp_ay(fun(A,assn),fun(fun(A,assn),fun(A,assn)),P),Q)) ) ).

% ex_join_or
tff(fact_392_ex__distrib__or,axiom,
    ! [A: $tType,P: fun(A,assn),Q: assn] : ( ex_assn(A,aa(assn,fun(A,assn),aTP_Lamp_az(fun(A,assn),fun(assn,fun(A,assn)),P),Q)) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),ex_assn(A,P)),Q) ) ).

% ex_distrib_or
tff(fact_393_sup__cancel__left1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),A4)),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X2)),B3)) = top_top(A) ) ) ).

% sup_cancel_left1
tff(fact_394_sup__cancel__left2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X2)),A4)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),B3)) = top_top(A) ) ) ).

% sup_cancel_left2
tff(fact_395_sup__bot_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => comm_monoid(A,sup_sup(A),bot_bot(A)) ) ).

% sup_bot.comm_monoid_axioms
tff(fact_396_sup__bot_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => monoid(A,sup_sup(A),bot_bot(A)) ) ).

% sup_bot.monoid_axioms
tff(fact_397_sup__assn__def,axiom,
    ! [P: assn,Q: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),P),Q) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_ba(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),P),Q)) ) ).

% sup_assn_def
tff(fact_398_boolean__algebra_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [A4: A,X2: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),X2) = bot_bot(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),X2) = top_top(A) )
           => ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),Y) = bot_bot(A) )
             => ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),Y) = top_top(A) )
               => ( X2 = Y ) ) ) ) ) ) ).

% boolean_algebra.complement_unique
tff(fact_399_bot__empty__eq,axiom,
    ! [A: $tType,X4: A] :
      ( pp(aa(A,bool,bot_bot(fun(A,bool)),X4))
    <=> pp(aa(set(A),bool,member(A,X4),bot_bot(set(A)))) ) ).

% bot_empty_eq
tff(fact_400_mod__emp,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,one_one(assn)),H2))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2) = bot_bot(set(nat)) ) ) ).

% mod_emp
tff(fact_401_times__assn__raw_Oelims_I3_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X2,Xa),Xb))
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ? [As12: set(nat),As23: set(nat)] :
                ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As12),As23) )
                & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As12),As23) = bot_bot(set(nat)) )
                & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As12)))
                & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As23))) ) ) ) ).

% times_assn_raw.elims(3)
tff(fact_402_times__assn__raw_Oelims_I2_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X2,Xa),Xb))
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ~ ? [As13: set(nat),As24: set(nat)] :
                  ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As13),As24) )
                  & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As13),As24) = bot_bot(set(nat)) )
                  & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As13)))
                  & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As24))) ) ) ) ).

% times_assn_raw.elims(2)
tff(fact_403_times__assn__raw_Oelims_I1_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X2,Xa),Xb))
      <=> pp(Y) )
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( pp(Y)
            <=> ~ ? [As1: set(nat),As22: set(nat)] :
                    ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
                    & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As1)))
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As22))) ) ) ) ) ).

% times_assn_raw.elims(1)
tff(fact_404_times__assn__raw_Osimps,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool),H2: heap_ext(product_unit),As2: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(P,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
    <=> ? [As1: set(nat),As22: set(nat)] :
          ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
          & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As1)))
          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Q,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As22))) ) ) ).

% times_assn_raw.simps
tff(fact_405_boolean__algebra__class_Oboolean__algebra_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) = bot_bot(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) = top_top(A) )
           => ( aa(A,A,uminus_uminus(A),X2) = Y ) ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_unique
tff(fact_406_wand__assnI,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat),Q: assn,R: assn] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
     => ( ! [H3: heap_ext(product_unit),As4: set(nat)] :
            ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As4) = bot_bot(set(nat)) )
           => ( relH(As2,H2,H3)
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As2)))
               => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As4)))
                 => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,R),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As4)))) ) ) ) )
       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,wand_assn(Q,R)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))) ) ) ).

% wand_assnI
tff(fact_407_wand__raw_Oelims_I3_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X2,Xa),Xb))
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
              & ! [H3: heap_ext(product_unit),As4: set(nat)] :
                  ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As4) = bot_bot(set(nat)) )
                    & relH(As,H4,H3)
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As)))
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As4))) )
                 => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As4)))) ) ) ) ) ).

% wand_raw.elims(3)
tff(fact_408_wand__raw_Oelims_I2_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X2,Xa),Xb))
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ~ ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
                & ! [H6: heap_ext(product_unit),As5: set(nat)] :
                    ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As5) = bot_bot(set(nat)) )
                      & relH(As,H4,H6)
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),As)))
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),As5))) )
                   => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As5)))) ) ) ) ) ).

% wand_raw.elims(2)
tff(fact_409_wand__raw_Oelims_I1_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X2,Xa),Xb))
      <=> pp(Y) )
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( pp(Y)
            <=> ~ ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
                  & ! [H7: heap_ext(product_unit),As6: set(nat)] :
                      ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As6) = bot_bot(set(nat)) )
                        & relH(As,H4,H7)
                        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As)))
                        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As6))) )
                     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As6)))) ) ) ) ) ) ).

% wand_raw.elims(1)
tff(fact_410_wand__raw_Osimps,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool),H2: heap_ext(product_unit),As2: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(P,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
        & ! [H7: heap_ext(product_unit),As6: set(nat)] :
            ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As6) = bot_bot(set(nat)) )
              & relH(As2,H2,H7)
              & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As2)))
              & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As6))) )
           => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Q,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As6)))) ) ) ) ).

% wand_raw.simps
tff(fact_411_Collect__empty__eq__bot,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ( aa(fun(A,bool),set(A),collect(A),P) = bot_bot(set(A)) )
    <=> ( P = bot_bot(fun(A,bool)) ) ) ).

% Collect_empty_eq_bot
tff(fact_412_disjointI,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),A4))
         => ~ pp(aa(set(A),bool,member(A,X),B3)) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) ) ) ).

% disjointI
tff(fact_413_boolean__algebra_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => boolea2506097494486148201lgebra(A,inf_inf(A),sup_sup(A),uminus_uminus(A),bot_bot(A),top_top(A)) ) ).

% boolean_algebra.abstract_boolean_algebra_axioms
tff(fact_414_success__LetI,axiom,
    ! [A: $tType,B: $tType,X2: A,T3: A,F2: fun(A,heap_Time_Heap(B)),H2: heap_ext(product_unit)] :
      ( ( X2 = T3 )
     => ( heap_Time_success(B,aa(A,heap_Time_Heap(B),F2,X2),H2)
       => heap_Time_success(B,aa(A,heap_Time_Heap(B),F2,T3),H2) ) ) ).

% success_LetI
tff(fact_415_times__assn__raw_Opelims_I3_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X2,Xa),Xb))
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))))
               => ? [As12: set(nat),As23: set(nat)] :
                    ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As12),As23) )
                    & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As12),As23) = bot_bot(set(nat)) )
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As12)))
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As23))) ) ) ) ) ) ).

% times_assn_raw.pelims(3)
tff(fact_416_times__assn__raw_Opelims_I2_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X2,Xa),Xb))
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))))
               => ~ ? [As13: set(nat),As24: set(nat)] :
                      ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As13),As24) )
                      & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As13),As24) = bot_bot(set(nat)) )
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As13)))
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As24))) ) ) ) ) ) ).

% times_assn_raw.pelims(2)
tff(fact_417_inf1I,axiom,
    ! [A: $tType,A3: fun(A,bool),X2: A,B2: fun(A,bool)] :
      ( pp(aa(A,bool,A3,X2))
     => ( pp(aa(A,bool,B2,X2))
       => pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),A3),B2),X2)) ) ) ).

% inf1I
tff(fact_418_relH__dist__union,axiom,
    ! [As2: set(nat),As3: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( relH(aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As3),H2,H5)
    <=> ( relH(As2,H2,H5)
        & relH(As3,H2,H5) ) ) ).

% relH_dist_union
tff(fact_419_inf1E,axiom,
    ! [A: $tType,A3: fun(A,bool),B2: fun(A,bool),X2: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),A3),B2),X2))
     => ~ ( pp(aa(A,bool,A3,X2))
         => ~ pp(aa(A,bool,B2,X2)) ) ) ).

% inf1E
tff(fact_420_inf1D1,axiom,
    ! [A: $tType,A3: fun(A,bool),B2: fun(A,bool),X2: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),A3),B2),X2))
     => pp(aa(A,bool,A3,X2)) ) ).

% inf1D1
tff(fact_421_inf1D2,axiom,
    ! [A: $tType,A3: fun(A,bool),B2: fun(A,bool),X2: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),A3),B2),X2))
     => pp(aa(A,bool,B2,X2)) ) ).

% inf1D2
tff(fact_422_relH__trans,axiom,
    ! [As2: set(nat),H12: heap_ext(product_unit),H23: heap_ext(product_unit),H32: heap_ext(product_unit)] :
      ( relH(As2,H12,H23)
     => ( relH(As2,H23,H32)
       => relH(As2,H12,H32) ) ) ).

% relH_trans
tff(fact_423_relH__sym,axiom,
    ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( relH(As2,H2,H5)
     => relH(As2,H5,H2) ) ).

% relH_sym
tff(fact_424_abstract__boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Y: A,Z2: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,Y),Z2)),X2) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,Y),X2)),aa(A,A,aa(A,fun(A,A),Disj,Z2),X2)) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib2
tff(fact_425_abstract__boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Y: A,Z2: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,Y),Z2)),X2) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,Y),X2)),aa(A,A,aa(A,fun(A,A),Conj,Z2),X2)) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib2
tff(fact_426_abstract__boolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A,Y: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( ( aa(A,A,Compl,X2) = aa(A,A,Compl,Y) )
      <=> ( X2 = Y ) ) ) ).

% abstract_boolean_algebra.compl_eq_compl_iff
tff(fact_427_abstract__boolean__algebra_Odisj__conj__distrib,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A,Y: A,Z2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,X2),aa(A,A,aa(A,fun(A,A),Conj,Y),Z2)) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,X2),Y)),aa(A,A,aa(A,fun(A,A),Disj,X2),Z2)) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib
tff(fact_428_abstract__boolean__algebra_Odisj__cancel__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,X2),aa(A,A,Compl,X2)) = One ) ) ).

% abstract_boolean_algebra.disj_cancel_right
tff(fact_429_abstract__boolean__algebra_Oconj__disj__distrib,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A,Y: A,Z2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,X2),aa(A,A,aa(A,fun(A,A),Disj,Y),Z2)) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X2),Y)),aa(A,A,aa(A,fun(A,A),Conj,X2),Z2)) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib
tff(fact_430_abstract__boolean__algebra_Oconj__cancel__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,X2),aa(A,A,Compl,X2)) = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_right
tff(fact_431_abstract__boolean__algebra_Ocomplement__unique,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,A4: A,X2: A,Y: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( ( aa(A,A,aa(A,fun(A,A),Conj,A4),X2) = Zero )
       => ( ( aa(A,A,aa(A,fun(A,A),Disj,A4),X2) = One )
         => ( ( aa(A,A,aa(A,fun(A,A),Conj,A4),Y) = Zero )
           => ( ( aa(A,A,aa(A,fun(A,A),Disj,A4),Y) = One )
             => ( X2 = Y ) ) ) ) ) ) ).

% abstract_boolean_algebra.complement_unique
tff(fact_432_abstract__boolean__algebra_Odisj__cancel__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,Compl,X2)),X2) = One ) ) ).

% abstract_boolean_algebra.disj_cancel_left
tff(fact_433_abstract__boolean__algebra_Oconj__cancel__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,Compl,X2)),X2) = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_left
tff(fact_434_abstract__boolean__algebra_Odisj__zero__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,X2),Zero) = X2 ) ) ).

% abstract_boolean_algebra.disj_zero_right
tff(fact_435_abstract__boolean__algebra_Oconj__zero__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,X2),Zero) = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_right
tff(fact_436_abstract__boolean__algebra_Odisj__one__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,X2),One) = One ) ) ).

% abstract_boolean_algebra.disj_one_right
tff(fact_437_abstract__boolean__algebra_Ode__Morgan__disj,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A,Y: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,Compl,aa(A,A,aa(A,fun(A,A),Disj,X2),Y)) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,Compl,X2)),aa(A,A,Compl,Y)) ) ) ).

% abstract_boolean_algebra.de_Morgan_disj
tff(fact_438_abstract__boolean__algebra_Ode__Morgan__conj,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A,Y: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,Compl,aa(A,A,aa(A,fun(A,A),Conj,X2),Y)) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,Compl,X2)),aa(A,A,Compl,Y)) ) ) ).

% abstract_boolean_algebra.de_Morgan_conj
tff(fact_439_abstract__boolean__algebra_Oconj__zero__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,Zero),X2) = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_left
tff(fact_440_abstract__boolean__algebra_Oconj__one__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,X2),One) = X2 ) ) ).

% abstract_boolean_algebra.conj_one_right
tff(fact_441_abstract__boolean__algebra_Odisj__one__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,One),X2) = One ) ) ).

% abstract_boolean_algebra.disj_one_left
tff(fact_442_abstract__boolean__algebra_Odouble__compl,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,Compl,aa(A,A,Compl,X2)) = X2 ) ) ).

% abstract_boolean_algebra.double_compl
tff(fact_443_abstract__boolean__algebra_Ocompl__unique,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X2: A,Y: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( ( aa(A,A,aa(A,fun(A,A),Conj,X2),Y) = Zero )
       => ( ( aa(A,A,aa(A,fun(A,A),Disj,X2),Y) = One )
         => ( aa(A,A,Compl,X2) = Y ) ) ) ) ).

% abstract_boolean_algebra.compl_unique
tff(fact_444_abstract__boolean__algebra_Ocompl__zero,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,Compl,Zero) = One ) ) ).

% abstract_boolean_algebra.compl_zero
tff(fact_445_abstract__boolean__algebra_Ocompl__one,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,Compl,One) = Zero ) ) ).

% abstract_boolean_algebra.compl_one
tff(fact_446_sup__Un__eq2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S: set(product_prod(A,B)),X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),sup_sup(fun(A,fun(B,bool))),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),R)),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),S)),X4),Xa3))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa3)),aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),sup_sup(set(product_prod(A,B))),R),S))) ) ).

% sup_Un_eq2
tff(fact_447_sup__Un__eq,axiom,
    ! [A: $tType,R: set(A),S: set(A),X4: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),sup_sup(fun(A,bool)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),R)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),S)),X4))
    <=> pp(aa(set(A),bool,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),R),S))) ) ).

% sup_Un_eq
tff(fact_448_sup__set__def,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2) = aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),sup_sup(fun(A,bool)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),B2))) ) ).

% sup_set_def
tff(fact_449_mod__relH,axiom,
    ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit),P: assn] :
      ( relH(As2,H2,H5)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
      <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2))) ) ) ).

% mod_relH
tff(fact_450_relH__refl,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
     => relH(As2,H2,H2) ) ).

% relH_refl
tff(fact_451_relH__in__rangeI_I1_J,axiom,
    ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( relH(As2,H2,H5)
     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))) ) ).

% relH_in_rangeI(1)
tff(fact_452_relH__in__rangeI_I2_J,axiom,
    ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( relH(As2,H2,H5)
     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2))) ) ).

% relH_in_rangeI(2)
tff(fact_453_set__notEmptyE,axiom,
    ! [A: $tType,S: set(A)] :
      ( ( S != bot_bot(set(A)) )
     => ~ ! [X: A] : ~ pp(aa(set(A),bool,member(A,X),S)) ) ).

% set_notEmptyE
tff(fact_454_memb__imp__not__empty,axiom,
    ! [A: $tType,X2: A,S: set(A)] :
      ( pp(aa(set(A),bool,member(A,X2),S))
     => ( S != bot_bot(set(A)) ) ) ).

% memb_imp_not_empty
tff(fact_455_times__assn__raw_Opelims_I1_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X2,Xa),Xb))
      <=> pp(Y) )
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( ( pp(Y)
                <=> ? [As1: set(nat),As22: set(nat)] :
                      ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
                      & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As1)))
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As22))) ) )
               => ~ pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))) ) ) ) ) ).

% times_assn_raw.pelims(1)
tff(fact_456_wand__raw_Opelims_I1_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X2,Xa),Xb))
      <=> pp(Y) )
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( ( pp(Y)
                <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
                    & ! [H7: heap_ext(product_unit),As6: set(nat)] :
                        ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As6) = bot_bot(set(nat)) )
                          & relH(As,H4,H7)
                          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As)))
                          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As6))) )
                       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As6)))) ) ) )
               => ~ pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))) ) ) ) ) ).

% wand_raw.pelims(1)
tff(fact_457_wand__raw_Opelims_I2_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X2,Xa),Xb))
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))))
               => ~ ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
                    & ! [H6: heap_ext(product_unit),As5: set(nat)] :
                        ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As5) = bot_bot(set(nat)) )
                          & relH(As,H4,H6)
                          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),As)))
                          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),As5))) )
                       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As5)))) ) ) ) ) ) ) ).

% wand_raw.pelims(2)
tff(fact_458_wand__raw_Opelims_I3_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X2,Xa),Xb))
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))))
               => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
                  & ! [H3: heap_ext(product_unit),As4: set(nat)] :
                      ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As4) = bot_bot(set(nat)) )
                        & relH(As,H4,H3)
                        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As)))
                        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As4))) )
                     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As4)))) ) ) ) ) ) ) ).

% wand_raw.pelims(3)
tff(fact_459_brk__rel__def,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B))] : ( brk_rel(A,B,R) = aa(set(product_prod(product_prod(bool,A),product_prod(bool,B))),set(product_prod(product_prod(bool,A),product_prod(bool,B))),aa(set(product_prod(product_prod(bool,A),product_prod(bool,B))),fun(set(product_prod(product_prod(bool,A),product_prod(bool,B))),set(product_prod(product_prod(bool,A),product_prod(bool,B)))),sup_sup(set(product_prod(product_prod(bool,A),product_prod(bool,B)))),aa(fun(product_prod(product_prod(bool,A),product_prod(bool,B)),bool),set(product_prod(product_prod(bool,A),product_prod(bool,B))),collect(product_prod(product_prod(bool,A),product_prod(bool,B))),aTP_Lamp_bb(set(product_prod(A,B)),fun(product_prod(product_prod(bool,A),product_prod(bool,B)),bool),R))),aa(fun(product_prod(product_prod(bool,A),product_prod(bool,B)),bool),set(product_prod(product_prod(bool,A),product_prod(bool,B))),collect(product_prod(product_prod(bool,A),product_prod(bool,B))),aTP_Lamp_bc(product_prod(product_prod(bool,A),product_prod(bool,B)),bool))) ) ).

% brk_rel_def
tff(fact_460_bijective__Empty,axiom,
    ! [B: $tType,A: $tType] : bijective(A,B,bot_bot(set(product_prod(A,B)))) ).

% bijective_Empty
tff(fact_461_rel__restrict__compl,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),A3: set(A)] : ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),rel_restrict(A,R,A3)),rel_restrict(A,R,aa(set(A),set(A),uminus_uminus(set(A)),A3))) = bot_bot(set(product_prod(A,A))) ) ).

% rel_restrict_compl
tff(fact_462_properI,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( ! [As: set(nat),H4: heap_ext(product_unit)] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
         => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) )
     => ( ! [As: set(nat),H4: heap_ext(product_unit),H3: heap_ext(product_unit)] :
            ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
           => ( relH(As,H4,H3)
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As)))
               => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As))) ) ) )
       => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P)) ) ) ).

% properI
tff(fact_463_properD2,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),H2: heap_ext(product_unit),As2: set(nat),H5: heap_ext(product_unit)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
       => ( relH(As2,H2,H5)
         => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2)))
           => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2))) ) ) ) ) ).

% properD2
tff(fact_464_proper__def,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
    <=> ! [H: heap_ext(product_unit),H7: heap_ext(product_unit),As7: set(nat)] :
          ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As7)))
           => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As7))) )
          & ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As7)))
              & relH(As7,H,H7)
              & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As7))) )
           => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As7))) ) ) ) ).

% proper_def
tff(fact_465_proper__iff,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( relH(As2,H2,H5)
       => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2)))
         => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
          <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2))) ) ) ) ) ).

% proper_iff
tff(fact_466_Id__on__empty,axiom,
    ! [A: $tType] : ( id_on(A,bot_bot(set(A))) = bot_bot(set(product_prod(A,A))) ) ).

% Id_on_empty
tff(fact_467_sup2CI,axiom,
    ! [A: $tType,B: $tType,B2: fun(A,fun(B,bool)),X2: A,Y: B,A3: fun(A,fun(B,bool))] :
      ( ( ~ pp(aa(B,bool,aa(A,fun(B,bool),B2,X2),Y))
       => pp(aa(B,bool,aa(A,fun(B,bool),A3,X2),Y)) )
     => pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),sup_sup(fun(A,fun(B,bool))),A3),B2),X2),Y)) ) ).

% sup2CI
tff(fact_468_sup1CI,axiom,
    ! [A: $tType,B2: fun(A,bool),X2: A,A3: fun(A,bool)] :
      ( ( ~ pp(aa(A,bool,B2,X2))
       => pp(aa(A,bool,A3,X2)) )
     => pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),sup_sup(fun(A,bool)),A3),B2),X2)) ) ).

% sup1CI
tff(fact_469_bool__assn__proper_I2_J,axiom,
    pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aTP_Lamp_ag(product_prod(heap_ext(product_unit),set(nat)),bool))) ).

% bool_assn_proper(2)
tff(fact_470_bool__assn__proper_I3_J,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,Q))
       => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_bd(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool)),P),Q))) ) ) ).

% bool_assn_proper(3)
tff(fact_471_bool__assn__proper_I4_J,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,Q))
       => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_be(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool)),P),Q))) ) ) ).

% bool_assn_proper(4)
tff(fact_472_rel__restrict__empty,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( rel_restrict(A,R,bot_bot(set(A))) = R ) ).

% rel_restrict_empty
tff(fact_473_bool__assn__proper_I1_J,axiom,
    pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,in_range)) ).

% bool_assn_proper(1)
tff(fact_474_ex__assn__proper,axiom,
    ! [A: $tType,P: fun(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool))] :
      ( ! [X: A] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool),P,X)))
     => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aTP_Lamp_bf(fun(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),fun(product_prod(heap_ext(product_unit),set(nat)),bool),P))) ) ).

% ex_assn_proper
tff(fact_475_one__assn__proper,axiom,
    pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,one_assn_raw)) ).

% one_assn_proper
tff(fact_476_times__assn__proper,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,Q))
       => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,times_assn_raw(P,Q))) ) ) ).

% times_assn_proper
tff(fact_477_wand__proper,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,wand_raw(P,Q))) ).

% wand_proper
tff(fact_478_snga__assn__proper,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R2: array(A),X2: list(A)] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,snga_assn_raw(A,R2,X2))) ) ).

% snga_assn_proper
tff(fact_479_sngr__assn__proper,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R2: ref(A),X2: A] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,sngr_assn_raw(A,R2,X2))) ) ).

% sngr_assn_proper
tff(fact_480_bool__assn__proper_I5_J,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aTP_Lamp_bg(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),P))) ) ).

% bool_assn_proper(5)
tff(fact_481_pure__assn__proper,axiom,
    ! [B3: bool] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,pure_assn_raw(heap_ext(product_unit),nat,B3))) ).

% pure_assn_proper
tff(fact_482_sup1E,axiom,
    ! [A: $tType,A3: fun(A,bool),B2: fun(A,bool),X2: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),sup_sup(fun(A,bool)),A3),B2),X2))
     => ( ~ pp(aa(A,bool,A3,X2))
       => pp(aa(A,bool,B2,X2)) ) ) ).

% sup1E
tff(fact_483_sup2E,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool)),B2: fun(A,fun(B,bool)),X2: A,Y: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),sup_sup(fun(A,fun(B,bool))),A3),B2),X2),Y))
     => ( ~ pp(aa(B,bool,aa(A,fun(B,bool),A3,X2),Y))
       => pp(aa(B,bool,aa(A,fun(B,bool),B2,X2),Y)) ) ) ).

% sup2E
tff(fact_484_sup1I1,axiom,
    ! [A: $tType,A3: fun(A,bool),X2: A,B2: fun(A,bool)] :
      ( pp(aa(A,bool,A3,X2))
     => pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),sup_sup(fun(A,bool)),A3),B2),X2)) ) ).

% sup1I1
tff(fact_485_sup1I2,axiom,
    ! [A: $tType,B2: fun(A,bool),X2: A,A3: fun(A,bool)] :
      ( pp(aa(A,bool,B2,X2))
     => pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),sup_sup(fun(A,bool)),A3),B2),X2)) ) ).

% sup1I2
tff(fact_486_sup2I1,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool)),X2: A,Y: B,B2: fun(A,fun(B,bool))] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),A3,X2),Y))
     => pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),sup_sup(fun(A,fun(B,bool))),A3),B2),X2),Y)) ) ).

% sup2I1
tff(fact_487_sup2I2,axiom,
    ! [A: $tType,B: $tType,B2: fun(A,fun(B,bool)),X2: A,Y: B,A3: fun(A,fun(B,bool))] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),B2,X2),Y))
     => pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),sup_sup(fun(A,fun(B,bool))),A3),B2),X2),Y)) ) ).

% sup2I2
tff(fact_488_Rep__assn,axiom,
    ! [X2: assn] : pp(aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),bool,member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,X2)),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper))) ).

% Rep_assn
tff(fact_489_Rep__assn__cases,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),bool,member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
     => ~ ! [X: assn] : ( Y != aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,X) ) ) ).

% Rep_assn_cases
tff(fact_490_Rep__assn__induct,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),bool),P: fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool)] :
      ( pp(aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),bool,member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
     => ( ! [X: assn] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,P,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,X)))
       => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,P,Y)) ) ) ).

% Rep_assn_induct
tff(fact_491_Abs__assn__cases,axiom,
    ! [X2: assn] :
      ~ ! [Y2: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
          ( ( X2 = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,Y2) )
         => ~ pp(aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),bool,member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y2),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper))) ) ).

% Abs_assn_cases
tff(fact_492_Abs__assn__induct,axiom,
    ! [P: fun(assn,bool),X2: assn] :
      ( ! [Y2: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
          ( pp(aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),bool,member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y2),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
         => pp(aa(assn,bool,P,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,Y2))) )
     => pp(aa(assn,bool,P,X2)) ) ).

% Abs_assn_induct
tff(fact_493_Abs__assn__inject,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),bool,member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),X2),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
     => ( pp(aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),bool,member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
       => ( ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,X2) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,Y) )
        <=> ( X2 = Y ) ) ) ) ).

% Abs_assn_inject
tff(fact_494_properD1,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),H2: heap_ext(product_unit),As2: set(nat)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))) ) ) ).

% properD1
tff(fact_495_Abs__assn__inverse,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),bool,member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
     => ( aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,Y)) = Y ) ) ).

% Abs_assn_inverse
tff(fact_496_monoid_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( semigroup(A,F2)
     => ( monoid_axioms(A,F2,Z2)
       => monoid(A,F2,Z2) ) ) ).

% monoid.intro
tff(fact_497_monoid__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( monoid(A,F2,Z2)
    <=> ( semigroup(A,F2)
        & monoid_axioms(A,F2,Z2) ) ) ).

% monoid_def
tff(fact_498_vimage__if,axiom,
    ! [B: $tType,A: $tType,C2: B,A3: set(B),D3: B,B2: set(A)] :
      ( ( pp(aa(set(B),bool,member(B,C2),A3))
       => ( ( pp(aa(set(B),bool,member(B,D3),A3))
           => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aa(set(A),fun(A,B),aa(B,fun(set(A),fun(A,B)),aTP_Lamp_bh(B,fun(B,fun(set(A),fun(A,B))),C2),D3),B2)),A3) = top_top(set(A)) ) )
          & ( ~ pp(aa(set(B),bool,member(B,D3),A3))
           => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aa(set(A),fun(A,B),aa(B,fun(set(A),fun(A,B)),aTP_Lamp_bh(B,fun(B,fun(set(A),fun(A,B))),C2),D3),B2)),A3) = B2 ) ) ) )
      & ( ~ pp(aa(set(B),bool,member(B,C2),A3))
       => ( ( pp(aa(set(B),bool,member(B,D3),A3))
           => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aa(set(A),fun(A,B),aa(B,fun(set(A),fun(A,B)),aTP_Lamp_bh(B,fun(B,fun(set(A),fun(A,B))),C2),D3),B2)),A3) = aa(set(A),set(A),uminus_uminus(set(A)),B2) ) )
          & ( ~ pp(aa(set(B),bool,member(B,D3),A3))
           => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aa(set(A),fun(A,B),aa(B,fun(set(A),fun(A,B)),aTP_Lamp_bh(B,fun(B,fun(set(A),fun(A,B))),C2),D3),B2)),A3) = bot_bot(set(A)) ) ) ) ) ) ).

% vimage_if
tff(fact_499_type__definition__assn,axiom,
    type_definition(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,abs_assn,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)) ).

% type_definition_assn
tff(fact_500_pure__assn__raw_Opelims_I3_J,axiom,
    ! [B: $tType,A: $tType,X2: bool,Xa: product_prod(A,set(B))] :
      ( ~ pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X2),Xa))
     => ( pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X2),Xa)))
       => ~ ! [H4: A,As: set(B)] :
              ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H4),As) )
             => ( pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X2),aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H4),As))))
               => ( ( As = bot_bot(set(B)) )
                  & pp(X2) ) ) ) ) ) ).

% pure_assn_raw.pelims(3)
tff(fact_501_pure__assn__raw_Opelims_I2_J,axiom,
    ! [B: $tType,A: $tType,X2: bool,Xa: product_prod(A,set(B))] :
      ( pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X2),Xa))
     => ( pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X2),Xa)))
       => ~ ! [H4: A,As: set(B)] :
              ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H4),As) )
             => ( pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X2),aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H4),As))))
               => ~ ( ( As = bot_bot(set(B)) )
                    & pp(X2) ) ) ) ) ) ).

% pure_assn_raw.pelims(2)
tff(fact_502_pure__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType,B: $tType,X2: bool,Xa: product_prod(A,set(B)),Y: bool] :
      ( ( pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X2),Xa))
      <=> pp(Y) )
     => ( pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X2),Xa)))
       => ~ ! [H4: A,As: set(B)] :
              ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H4),As) )
             => ( ( pp(Y)
                <=> ( ( As = bot_bot(set(B)) )
                    & pp(X2) ) )
               => ~ pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X2),aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H4),As)))) ) ) ) ) ).

% pure_assn_raw.pelims(1)
tff(fact_503_rel__restrict__alt__def,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),A3: set(A)] : ( rel_restrict(A,R,A3) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R),product_Sigma(A,A,aa(set(A),set(A),uminus_uminus(set(A)),A3),aTP_Lamp_bi(set(A),fun(A,set(A)),A3))) ) ).

% rel_restrict_alt_def
tff(fact_504_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,one_one(A)) = one_one(A) ) ) ).

% dbl_dec_simps(3)
tff(fact_505_image2__def,axiom,
    ! [A: $tType,B: $tType,C: $tType,A3: set(C),F2: fun(C,A),G: fun(C,B)] : ( bNF_Greatest_image2(C,A,B,A3,F2,G) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(C,B),fun(product_prod(A,B),bool),aa(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),bool)),aTP_Lamp_bj(set(C),fun(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),bool))),A3),F2),G)) ) ).

% image2_def
tff(fact_506_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,zero_zero(A)) = one_one(A) ) ) ).

% dbl_inc_simps(2)
tff(fact_507_vimage__ident,axiom,
    ! [A: $tType,Y3: set(A)] : ( aa(set(A),set(A),aa(fun(A,A),fun(set(A),set(A)),vimage(A,A),aTP_Lamp_bk(A,A)),Y3) = Y3 ) ).

% vimage_ident
tff(fact_508_vimage__Collect__eq,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),P: fun(B,bool)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),aa(fun(B,bool),set(B),collect(B),P)) = aa(fun(A,bool),set(A),collect(A),aa(fun(B,bool),fun(A,bool),aTP_Lamp_bl(fun(A,B),fun(fun(B,bool),fun(A,bool)),F2),P)) ) ).

% vimage_Collect_eq
tff(fact_509_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [A4: A,C2: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A4 = B3 ) ) ) ) ).

% mult_cancel_right
tff(fact_510_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A4 = B3 ) ) ) ) ).

% mult_cancel_left
tff(fact_511_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3) = zero_zero(A) )
        <=> ( ( A4 = zero_zero(A) )
            | ( B3 = zero_zero(A) ) ) ) ) ).

% mult_eq_0_iff
tff(fact_512_mult__zero__right,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),zero_zero(A)) = zero_zero(A) ) ) ).

% mult_zero_right
tff(fact_513_mult__zero__left,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),zero_zero(A)),A4) = zero_zero(A) ) ) ).

% mult_zero_left
tff(fact_514_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A4: A] :
          ( ( aa(A,A,uminus_uminus(A),A4) = A4 )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% neg_equal_zero
tff(fact_515_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A4: A] :
          ( ( A4 = aa(A,A,uminus_uminus(A),A4) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% equal_neg_zero
tff(fact_516_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A] :
          ( ( aa(A,A,uminus_uminus(A),A4) = zero_zero(A) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% neg_equal_0_iff_equal
tff(fact_517_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A] :
          ( ( zero_zero(A) = aa(A,A,uminus_uminus(A),A4) )
        <=> ( zero_zero(A) = A4 ) ) ) ).

% neg_0_equal_iff_equal
tff(fact_518_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ( aa(A,A,uminus_uminus(A),zero_zero(A)) = zero_zero(A) ) ) ).

% add.inverse_neutral
tff(fact_519_vimage__empty,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),bot_bot(set(B))) = bot_bot(set(A)) ) ).

% vimage_empty
tff(fact_520_vimage__Int,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A3: set(B),B2: set(B)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),A3)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),B2)) ) ).

% vimage_Int
tff(fact_521_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A4: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A4 = one_one(A) ) ) ) ) ).

% mult_cancel_right2
tff(fact_522_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B3: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B3 = one_one(A) ) ) ) ) ).

% mult_cancel_right1
tff(fact_523_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,A4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A4 = one_one(A) ) ) ) ) ).

% mult_cancel_left2
tff(fact_524_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B3: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B3 = one_one(A) ) ) ) ) ).

% mult_cancel_left1
tff(fact_525_vimage__const,axiom,
    ! [B: $tType,A: $tType,C2: B,A3: set(B)] :
      ( ( pp(aa(set(B),bool,member(B,C2),A3))
       => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aTP_Lamp_bm(B,fun(A,B),C2)),A3) = top_top(set(A)) ) )
      & ( ~ pp(aa(set(B),bool,member(B,C2),A3))
       => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aTP_Lamp_bm(B,fun(A,B),C2)),A3) = bot_bot(set(A)) ) ) ) ).

% vimage_const
tff(fact_526_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_dec_simps(2)
tff(fact_527_zero__reorient,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [X2: A] :
          ( ( zero_zero(A) = X2 )
        <=> ( X2 = zero_zero(A) ) ) ) ).

% zero_reorient
tff(fact_528_semigroup__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( semigroup(A,F2)
    <=> ! [A6: A,B5: A,C5: A] : ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,A6),B5)),C5) = aa(A,A,aa(A,fun(A,A),F2,A6),aa(A,A,aa(A,fun(A,A),F2,B5),C5)) ) ) ).

% semigroup_def
tff(fact_529_semigroup_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( ! [A5: A,B4: A,C4: A] : ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,A5),B4)),C4) = aa(A,A,aa(A,fun(A,A),F2,A5),aa(A,A,aa(A,fun(A,A),F2,B4),C4)) )
     => semigroup(A,F2) ) ).

% semigroup.intro
tff(fact_530_semigroup_Oassoc,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A4: A,B3: A,C2: A] :
      ( semigroup(A,F2)
     => ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),F2,A4),aa(A,A,aa(A,fun(A,A),F2,B3),C2)) ) ) ).

% semigroup.assoc
tff(fact_531_vimage__def,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),B2: set(B)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),B2) = aa(fun(A,bool),set(A),collect(A),aa(set(B),fun(A,bool),aTP_Lamp_bn(fun(A,B),fun(set(B),fun(A,bool)),F2),B2)) ) ).

% vimage_def
tff(fact_532_vimage__inter__cong,axiom,
    ! [B: $tType,A: $tType,S: set(A),F2: fun(A,B),G: fun(A,B),Y: set(B)] :
      ( ! [W: A] :
          ( pp(aa(set(A),bool,member(A,W),S))
         => ( aa(A,B,F2,W) = aa(A,B,G,W) ) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),Y)),S) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),G),Y)),S) ) ) ).

% vimage_inter_cong
tff(fact_533_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2) )
          <=> ( A4 = B3 ) ) ) ) ).

% mult_right_cancel
tff(fact_534_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3) )
          <=> ( A4 = B3 ) ) ) ) ).

% mult_left_cancel
tff(fact_535_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( ( B3 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3) != zero_zero(A) ) ) ) ) ).

% no_zero_divisors
tff(fact_536_divisors__zero,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3) = zero_zero(A) )
         => ( ( A4 = zero_zero(A) )
            | ( B3 = zero_zero(A) ) ) ) ) ).

% divisors_zero
tff(fact_537_mult__not__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3) != zero_zero(A) )
         => ( ( A4 != zero_zero(A) )
            & ( B3 != zero_zero(A) ) ) ) ) ).

% mult_not_zero
tff(fact_538_zero__neq__one,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( zero_zero(A) != one_one(A) ) ) ).

% zero_neq_one
tff(fact_539_mult_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( semigroup_mult(A)
     => semigroup(A,times_times(A)) ) ).

% mult.semigroup_axioms
tff(fact_540_inf_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => semigroup(A,inf_inf(A)) ) ).

% inf.semigroup_axioms
tff(fact_541_sup_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => semigroup(A,sup_sup(A)) ) ).

% sup.semigroup_axioms
tff(fact_542_lambda__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ( aTP_Lamp_bo(A,A) = aa(A,fun(A,A),times_times(A),zero_zero(A)) ) ) ).

% lambda_zero
tff(fact_543_monoid_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( monoid(A,F2,Z2)
     => semigroup(A,F2) ) ).

% monoid.axioms(1)
tff(fact_544_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( zero_zero(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% zero_neq_neg_one
tff(fact_545_UNIV__Times__UNIV,axiom,
    ! [B: $tType,A: $tType] : ( product_Sigma(A,B,top_top(set(A)),aTP_Lamp_bp(A,set(B))) = top_top(set(product_prod(A,B))) ) ).

% UNIV_Times_UNIV
tff(fact_546_Compl__Times__UNIV1,axiom,
    ! [A: $tType,B: $tType,A3: set(B)] : ( aa(set(product_prod(A,B)),set(product_prod(A,B)),uminus_uminus(set(product_prod(A,B))),product_Sigma(A,B,top_top(set(A)),aTP_Lamp_bq(set(B),fun(A,set(B)),A3))) = product_Sigma(A,B,top_top(set(A)),aTP_Lamp_br(set(B),fun(A,set(B)),A3)) ) ).

% Compl_Times_UNIV1
tff(fact_547_Compl__Times__UNIV2,axiom,
    ! [B: $tType,A: $tType,A3: set(A)] : ( aa(set(product_prod(A,B)),set(product_prod(A,B)),uminus_uminus(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_bp(A,set(B)))) = product_Sigma(A,B,aa(set(A),set(A),uminus_uminus(set(A)),A3),aTP_Lamp_bp(A,set(B))) ) ).

% Compl_Times_UNIV2
tff(fact_548_Times__empty,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( ( product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)) = bot_bot(set(product_prod(A,B))) )
    <=> ( ( A3 = bot_bot(set(A)) )
        | ( B2 = bot_bot(set(B)) ) ) ) ).

% Times_empty
tff(fact_549_Sigma__empty2,axiom,
    ! [B: $tType,A: $tType,A3: set(A)] : ( product_Sigma(A,B,A3,aTP_Lamp_bs(A,set(B))) = bot_bot(set(product_prod(A,B))) ) ).

% Sigma_empty2
tff(fact_550_Sigma__empty1,axiom,
    ! [B: $tType,A: $tType,B2: fun(A,set(B))] : ( product_Sigma(A,B,bot_bot(set(A)),B2) = bot_bot(set(product_prod(A,B))) ) ).

% Sigma_empty1
tff(fact_551_Sigma__Un__distrib2,axiom,
    ! [B: $tType,A: $tType,I: set(A),A3: fun(A,set(B)),B2: fun(A,set(B))] : ( product_Sigma(A,B,I,aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_bt(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),A3),B2)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),sup_sup(set(product_prod(A,B))),product_Sigma(A,B,I,A3)),product_Sigma(A,B,I,B2)) ) ).

% Sigma_Un_distrib2
tff(fact_552_Times__Un__distrib1,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(A),C3: set(B)] : ( product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2),aTP_Lamp_bq(set(B),fun(A,set(B)),C3)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),sup_sup(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),C3))),product_Sigma(A,B,B2,aTP_Lamp_bq(set(B),fun(A,set(B)),C3))) ) ).

% Times_Un_distrib1
tff(fact_553_Times__Int__distrib1,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(A),C3: set(B)] : ( product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2),aTP_Lamp_bq(set(B),fun(A,set(B)),C3)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),C3))),product_Sigma(A,B,B2,aTP_Lamp_bq(set(B),fun(A,set(B)),C3))) ) ).

% Times_Int_distrib1
tff(fact_554_Sigma__Int__distrib2,axiom,
    ! [B: $tType,A: $tType,I: set(A),A3: fun(A,set(B)),B2: fun(A,set(B))] : ( product_Sigma(A,B,I,aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_bu(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),A3),B2)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),product_Sigma(A,B,I,A3)),product_Sigma(A,B,I,B2)) ) ).

% Sigma_Int_distrib2
tff(fact_555_Times__eq__cancel2,axiom,
    ! [A: $tType,B: $tType,X2: A,C3: set(A),A3: set(B),B2: set(B)] :
      ( pp(aa(set(A),bool,member(A,X2),C3))
     => ( ( product_Sigma(B,A,A3,aTP_Lamp_bv(set(A),fun(B,set(A)),C3)) = product_Sigma(B,A,B2,aTP_Lamp_bv(set(A),fun(B,set(A)),C3)) )
      <=> ( A3 = B2 ) ) ) ).

% Times_eq_cancel2
tff(fact_556_Sigma__cong,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: set(A),C3: fun(A,set(B)),D2: fun(A,set(B))] :
      ( ( A3 = B2 )
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),B2))
           => ( aa(A,set(B),C3,X) = aa(A,set(B),D2,X) ) )
       => ( product_Sigma(A,B,A3,C3) = product_Sigma(A,B,B2,D2) ) ) ) ).

% Sigma_cong
tff(fact_557_times__eq__iff,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B),C3: set(A),D2: set(B)] :
      ( ( product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)) = product_Sigma(A,B,C3,aTP_Lamp_bq(set(B),fun(A,set(B)),D2)) )
    <=> ( ( ( A3 = C3 )
          & ( B2 = D2 ) )
        | ( ( ( A3 = bot_bot(set(A)) )
            | ( B2 = bot_bot(set(B)) ) )
          & ( ( C3 = bot_bot(set(A)) )
            | ( D2 = bot_bot(set(B)) ) ) ) ) ) ).

% times_eq_iff
tff(fact_558_Pair__vimage__Sigma,axiom,
    ! [B: $tType,A: $tType,X2: B,A3: set(B),F2: fun(B,set(A))] :
      ( ( pp(aa(set(B),bool,member(B,X2),A3))
       => ( aa(set(product_prod(B,A)),set(A),aa(fun(A,product_prod(B,A)),fun(set(product_prod(B,A)),set(A)),vimage(A,product_prod(B,A)),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X2)),product_Sigma(B,A,A3,F2)) = aa(B,set(A),F2,X2) ) )
      & ( ~ pp(aa(set(B),bool,member(B,X2),A3))
       => ( aa(set(product_prod(B,A)),set(A),aa(fun(A,product_prod(B,A)),fun(set(product_prod(B,A)),set(A)),vimage(A,product_prod(B,A)),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X2)),product_Sigma(B,A,A3,F2)) = bot_bot(set(A)) ) ) ) ).

% Pair_vimage_Sigma
tff(fact_559_Sigma__Int__distrib1,axiom,
    ! [B: $tType,A: $tType,I: set(A),J: set(A),C3: fun(A,set(B))] : ( product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),I),J),C3) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),product_Sigma(A,B,I,C3)),product_Sigma(A,B,J,C3)) ) ).

% Sigma_Int_distrib1
tff(fact_560_vimage__snd,axiom,
    ! [A: $tType,B: $tType,A3: set(B)] : ( aa(set(B),set(product_prod(A,B)),aa(fun(product_prod(A,B),B),fun(set(B),set(product_prod(A,B))),vimage(product_prod(A,B),B),product_snd(A,B)),A3) = product_Sigma(A,B,top_top(set(A)),aTP_Lamp_bq(set(B),fun(A,set(B)),A3)) ) ).

% vimage_snd
tff(fact_561_Sigma__empty__iff,axiom,
    ! [A: $tType,B: $tType,I: set(A),X5: fun(A,set(B))] :
      ( ( product_Sigma(A,B,I,X5) = bot_bot(set(product_prod(A,B))) )
    <=> ! [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),I))
         => ( aa(A,set(B),X5,X3) = bot_bot(set(B)) ) ) ) ).

% Sigma_empty_iff
tff(fact_562_Times__Int__Times,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B),C3: set(A),D2: set(B)] : ( aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))),product_Sigma(A,B,C3,aTP_Lamp_bq(set(B),fun(A,set(B)),D2))) = product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C3),aa(set(B),fun(A,set(B)),aTP_Lamp_bw(set(B),fun(set(B),fun(A,set(B))),B2),D2)) ) ).

% Times_Int_Times
tff(fact_563_relImage__def,axiom,
    ! [A: $tType,B: $tType,R: set(product_prod(B,B)),F2: fun(B,A)] : ( bNF_Gr4221423524335903396lImage(B,A,R,F2) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(B,A),fun(product_prod(A,A),bool),aTP_Lamp_bx(set(product_prod(B,B)),fun(fun(B,A),fun(product_prod(A,A),bool)),R),F2)) ) ).

% relImage_def
tff(fact_564_member__product,axiom,
    ! [A: $tType,B: $tType,X2: product_prod(A,B),A3: set(A),B2: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),X2),product_product(A,B,A3,B2)))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),X2),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)))) ) ).

% member_product
tff(fact_565_Product__Type_Oproduct__def,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] : ( product_product(A,B,A3,B2) = product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)) ) ).

% Product_Type.product_def
tff(fact_566_relInvImage__def,axiom,
    ! [B: $tType,A: $tType,A3: set(A),R: set(product_prod(B,B)),F2: fun(A,B)] : ( bNF_Gr7122648621184425601vImage(A,B,A3,R,F2) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,B),fun(product_prod(A,A),bool),aa(set(product_prod(B,B)),fun(fun(A,B),fun(product_prod(A,A),bool)),aTP_Lamp_by(set(A),fun(set(product_prod(B,B)),fun(fun(A,B),fun(product_prod(A,A),bool))),A3),R),F2)) ) ).

% relInvImage_def
tff(fact_567_fun__cong__unused__0,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( zero(B)
     => ! [F2: fun(fun(A,B),C),G: C] :
          ( ! [X: fun(A,B)] : ( aa(fun(A,B),C,F2,X) = G )
         => ( aa(fun(A,B),C,F2,aTP_Lamp_bz(A,B)) = G ) ) ) ).

% fun_cong_unused_0
tff(fact_568_Sigma__UNIV__cancel,axiom,
    ! [B: $tType,A: $tType,A3: set(A),X5: set(B)] : ( aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),X5))),product_Sigma(A,B,A3,aTP_Lamp_bp(A,set(B)))) = bot_bot(set(product_prod(A,B))) ) ).

% Sigma_UNIV_cancel
tff(fact_569_snd__image__times,axiom,
    ! [B: $tType,A: $tType,A3: set(B),B2: set(A)] :
      ( ( ( A3 = bot_bot(set(B)) )
       => ( aa(set(product_prod(B,A)),set(A),image2(product_prod(B,A),A,product_snd(B,A)),product_Sigma(B,A,A3,aTP_Lamp_bv(set(A),fun(B,set(A)),B2))) = bot_bot(set(A)) ) )
      & ( ( A3 != bot_bot(set(B)) )
       => ( aa(set(product_prod(B,A)),set(A),image2(product_prod(B,A),A,product_snd(B,A)),product_Sigma(B,A,A3,aTP_Lamp_bv(set(A),fun(B,set(A)),B2))) = B2 ) ) ) ).

% snd_image_times
tff(fact_570_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% add_neg_numeral_special(7)
tff(fact_571_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = zero_zero(A) ) ) ).

% add_neg_numeral_special(8)
tff(fact_572_image__vimage__eq,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: set(A)] : ( aa(set(B),set(A),image2(B,A,F2),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F2),A3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(B),set(A),image2(B,A,F2),top_top(set(B)))) ) ).

% image_vimage_eq
tff(fact_573_add__right__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B3: A,A4: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4) )
        <=> ( B3 = C2 ) ) ) ).

% add_right_cancel
tff(fact_574_add__left__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2) )
        <=> ( B3 = C2 ) ) ) ).

% add_left_cancel
tff(fact_575_minus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( minus(B)
     => ! [A3: fun(A,B),B2: fun(A,B),X2: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),minus_minus(fun(A,B)),A3),B2),X2) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A3,X2)),aa(A,B,B2,X2)) ) ) ).

% minus_apply
tff(fact_576_image__ident,axiom,
    ! [A: $tType,Y3: set(A)] : ( aa(set(A),set(A),image2(A,A,aTP_Lamp_bk(A,A)),Y3) = Y3 ) ).

% image_ident
tff(fact_577_add__0,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A4) = A4 ) ) ).

% add_0
tff(fact_578_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X2: A,Y: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y) )
        <=> ( ( X2 = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
tff(fact_579_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X2: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y) = zero_zero(A) )
        <=> ( ( X2 = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
tff(fact_580_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) )
        <=> ( B3 = zero_zero(A) ) ) ) ).

% add_cancel_right_right
tff(fact_581_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4) )
        <=> ( B3 = zero_zero(A) ) ) ) ).

% add_cancel_right_left
tff(fact_582_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) = A4 )
        <=> ( B3 = zero_zero(A) ) ) ) ).

% add_cancel_left_right
tff(fact_583_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [B3: A,A4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4) = A4 )
        <=> ( B3 = zero_zero(A) ) ) ) ).

% add_cancel_left_left
tff(fact_584_double__zero__sym,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A4: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),A4) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% double_zero_sym
tff(fact_585_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),zero_zero(A)) = A4 ) ) ).

% add.right_neutral
tff(fact_586_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),A4) = zero_zero(A) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
tff(fact_587_diff__zero,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),zero_zero(A)) = A4 ) ) ).

% diff_zero
tff(fact_588_zero__diff,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A4) = zero_zero(A) ) ) ).

% zero_diff
tff(fact_589_diff__0__right,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),zero_zero(A)) = A4 ) ) ).

% diff_0_right
tff(fact_590_diff__self,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),A4) = zero_zero(A) ) ) ).

% diff_self
tff(fact_591_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),B3) = A4 ) ) ).

% add_diff_cancel_right'
tff(fact_592_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A4: A,C2: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3) ) ) ).

% add_diff_cancel_right
tff(fact_593_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),A4) = B3 ) ) ).

% add_diff_cancel_left'
tff(fact_594_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [C2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3) ) ) ).

% add_diff_cancel_left
tff(fact_595_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),B3) = A4 ) ) ).

% diff_add_cancel
tff(fact_596_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),B3) = A4 ) ) ).

% add_diff_cancel
tff(fact_597_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A4)),aa(A,A,uminus_uminus(A),B3)) ) ) ).

% minus_add_distrib
tff(fact_598_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)) = B3 ) ) ).

% minus_add_cancel
tff(fact_599_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A4)),B3)) = B3 ) ) ).

% add_minus_cancel
tff(fact_600_image__empty,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A)] : ( aa(set(B),set(A),image2(B,A,F2),bot_bot(set(B))) = bot_bot(set(A)) ) ).

% image_empty
tff(fact_601_empty__is__image,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: set(B)] :
      ( ( bot_bot(set(A)) = aa(set(B),set(A),image2(B,A,F2),A3) )
    <=> ( A3 = bot_bot(set(B)) ) ) ).

% empty_is_image
tff(fact_602_image__is__empty,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: set(B)] :
      ( ( aa(set(B),set(A),image2(B,A,F2),A3) = bot_bot(set(A)) )
    <=> ( A3 = bot_bot(set(B)) ) ) ).

% image_is_empty
tff(fact_603_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4) ) ) ).

% minus_diff_eq
tff(fact_604_Diff__empty,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),bot_bot(set(A))) = A3 ) ).

% Diff_empty
tff(fact_605_empty__Diff,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),bot_bot(set(A))),A3) = bot_bot(set(A)) ) ).

% empty_Diff
tff(fact_606_Diff__cancel,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),A3) = bot_bot(set(A)) ) ).

% Diff_cancel
tff(fact_607_diff__add__zero,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)) = zero_zero(A) ) ) ).

% diff_add_zero
tff(fact_608_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),one_one(A)) = zero_zero(A) ) ) ).

% diff_numeral_special(9)
tff(fact_609_ab__left__minus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A4)),A4) = zero_zero(A) ) ) ).

% ab_left_minus
tff(fact_610_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,uminus_uminus(A),A4)) = zero_zero(A) ) ) ).

% add.right_inverse
tff(fact_611_diff__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A4) = aa(A,A,uminus_uminus(A),A4) ) ) ).

% diff_0
tff(fact_612_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A4)),B3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4) ) ) ).

% uminus_add_conv_diff
tff(fact_613_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(A,A,uminus_uminus(A),B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) ) ) ).

% diff_minus_eq_add
tff(fact_614_Diff__UNIV,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),top_top(set(A))) = bot_bot(set(A)) ) ).

% Diff_UNIV
tff(fact_615_Diff__disjoint,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B2),A3)) = bot_bot(set(A)) ) ).

% Diff_disjoint
tff(fact_616_inter__compl__diff__conv,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2) ) ).

% inter_compl_diff_conv
tff(fact_617_Diff__Compl,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) ) ).

% Diff_Compl
tff(fact_618_if__image__distrib,axiom,
    ! [A: $tType,B: $tType,P: fun(B,bool),F2: fun(B,A),G: fun(B,A),S: set(B)] : ( aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_ca(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),F2),G)),S) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(B),set(A),image2(B,A,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),aa(fun(B,bool),set(B),collect(B),P)))),aa(set(B),set(A),image2(B,A,G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),aa(fun(B,bool),set(B),collect(B),aTP_Lamp_cb(fun(B,bool),fun(B,bool),P))))) ) ).

% if_image_distrib
tff(fact_619_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% diff_numeral_special(12)
tff(fact_620_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B2: A,K: A,B3: A,A4: A] :
          ( ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B3) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)) ) ) ) ).

% group_cancel.sub2
tff(fact_621_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,uminus_uminus(A),B3)) ) ) ).

% diff_conv_add_uminus
tff(fact_622_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,uminus_uminus(A),B3)) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
tff(fact_623_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)) ) ) ).

% diff_diff_eq
tff(fact_624_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A4: A,C2: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),C2)),B3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),C2) ) ) ).

% cancel_ab_semigroup_add_class.diff_right_commute
tff(fact_625_add__implies__diff,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [C2: A,B3: A,A4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3) = A4 )
         => ( C2 = aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3) ) ) ) ).

% add_implies_diff
tff(fact_626_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B3: A,A4: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4) )
         => ( B3 = C2 ) ) ) ).

% add_right_imp_eq
tff(fact_627_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),C2)),B3) ) ) ).

% diff_add_eq_diff_diff_swap
tff(fact_628_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2) )
         => ( B3 = C2 ) ) ) ).

% add_left_imp_eq
tff(fact_629_ab__semigroup__add__class_Oadd_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [B3: A,A4: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)) ) ) ).

% ab_semigroup_add_class.add.left_commute
tff(fact_630_ab__semigroup__add__class_Oadd_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4) ) ) ).

% ab_semigroup_add_class.add.commute
tff(fact_631_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B3: A,A4: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4) )
        <=> ( B3 = C2 ) ) ) ).

% add.right_cancel
tff(fact_632_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D3) )
         => ( ( A4 = B3 )
          <=> ( C2 = D3 ) ) ) ) ).

% diff_eq_diff_eq
tff(fact_633_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2) )
        <=> ( B3 = C2 ) ) ) ).

% add.left_cancel
tff(fact_634_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),B3) ) ) ).

% diff_add_eq
tff(fact_635_add_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_add(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)) ) ) ).

% add.assoc
tff(fact_636_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),B3) ) ) ).

% diff_diff_eq2
tff(fact_637_add__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),C2) ) ) ).

% add_diff_eq
tff(fact_638_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,C2: A,B3: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B3) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) = C2 ) ) ) ).

% eq_diff_eq
tff(fact_639_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3) = C2 )
        <=> ( A4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3) ) ) ) ).

% diff_eq_eq
tff(fact_640_add_Oright__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),B3) ) ) ).

% add.right_commute
tff(fact_641_add_Oright__assoc,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)) ) ) ).

% add.right_assoc
tff(fact_642_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,K: A,A4: A,B3: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A4) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)) ) ) ) ).

% group_cancel.sub1
tff(fact_643_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [B2: A,K: A,B3: A,A4: A] :
          ( ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B3) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)) ) ) ) ).

% group_cancel.add2
tff(fact_644_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: A,K: A,A4: A,B3: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A4) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)) ) ) ) ).

% group_cancel.add1
tff(fact_645_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( I2 = J2 )
            & ( K = L ) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
tff(fact_646_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( minus(B)
     => ! [A3: fun(A,B),B2: fun(A,B),X4: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),minus_minus(fun(A,B)),A3),B2),X4) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A3,X4)),aa(A,B,B2,X4)) ) ) ).

% fun_diff_def
tff(fact_647_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),E2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),E2)),D3) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),E2)),C2) = D3 ) ) ) ).

% eq_add_iff1
tff(fact_648_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),E2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),E2)),D3) )
        <=> ( C2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)),E2)),D3) ) ) ) ).

% eq_add_iff2
tff(fact_649_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( comm_ring(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y)),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y)) ) ) ).

% square_diff_square_factored
tff(fact_650_imageE,axiom,
    ! [A: $tType,B: $tType,B3: A,F2: fun(B,A),A3: set(B)] :
      ( pp(aa(set(A),bool,member(A,B3),aa(set(B),set(A),image2(B,A,F2),A3)))
     => ~ ! [X: B] :
            ( ( B3 = aa(B,A,F2,X) )
           => ~ pp(aa(set(B),bool,member(B,X),A3)) ) ) ).

% imageE
tff(fact_651_image__image,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(B,A),G: fun(C,B),A3: set(C)] : ( aa(set(B),set(A),image2(B,A,F2),aa(set(C),set(B),image2(C,B,G),A3)) = aa(set(C),set(A),image2(C,A,aa(fun(C,B),fun(C,A),aTP_Lamp_cc(fun(B,A),fun(fun(C,B),fun(C,A)),F2),G)),A3) ) ).

% image_image
tff(fact_652_Compr__image__eq,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),A3: set(B),P: fun(A,bool)] : ( aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aa(set(B),fun(fun(A,bool),fun(A,bool)),aTP_Lamp_cd(fun(B,A),fun(set(B),fun(fun(A,bool),fun(A,bool))),F2),A3),P)) = aa(set(B),set(A),image2(B,A,F2),aa(fun(B,bool),set(B),collect(B),aa(fun(A,bool),fun(B,bool),aa(set(B),fun(fun(A,bool),fun(B,bool)),aTP_Lamp_ce(fun(B,A),fun(set(B),fun(fun(A,bool),fun(B,bool))),F2),A3),P))) ) ).

% Compr_image_eq
tff(fact_653_set__diff__eq,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_cf(set(A),fun(set(A),fun(A,bool)),A3),B2)) ) ).

% set_diff_eq
tff(fact_654_Times__Diff__distrib1,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(A),C3: set(B)] : ( product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2),aTP_Lamp_bq(set(B),fun(A,set(B)),C3)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),C3))),product_Sigma(A,B,B2,aTP_Lamp_bq(set(B),fun(A,set(B)),C3))) ) ).

% Times_Diff_distrib1
tff(fact_655_Sigma__Diff__distrib2,axiom,
    ! [B: $tType,A: $tType,I: set(A),A3: fun(A,set(B)),B2: fun(A,set(B))] : ( product_Sigma(A,B,I,aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_cg(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),A3),B2)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),product_Sigma(A,B,I,A3)),product_Sigma(A,B,I,B2)) ) ).

% Sigma_Diff_distrib2
tff(fact_656_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),one_one(A))) ) ) ).

% square_diff_one_factored
tff(fact_657_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = B3 )
        <=> ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3) = zero_zero(A) ) ) ) ).

% eq_iff_diff_eq_0
tff(fact_658_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)) ) ) ).

% right_diff_distrib'
tff(fact_659_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [B3: A,C2: A,A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),C2)),A4) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)) ) ) ).

% left_diff_distrib'
tff(fact_660_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)) ) ) ).

% right_diff_distrib
tff(fact_661_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) ) ) ).

% left_diff_distrib
tff(fact_662_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B3: A,A4: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),B3)),A4) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A4)),B3) ) ) ).

% minus_diff_commute
tff(fact_663_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A4) = A4 ) ) ).

% add.group_left_neutral
tff(fact_664_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),zero_zero(A)) = A4 ) ) ).

% add.comm_neutral
tff(fact_665_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A4) = A4 ) ) ).

% comm_monoid_add_class.add_0
tff(fact_666_combine__common__factor,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A4: A,E2: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),E2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),E2)),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),E2)),C2) ) ) ).

% combine_common_factor
tff(fact_667_distrib__right,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) ) ) ).

% distrib_right
tff(fact_668_distrib__left,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)) ) ) ).

% distrib_left
tff(fact_669_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( comm_semiring(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) ) ) ).

% comm_semiring_class.distrib
tff(fact_670_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)) ) ) ).

% ring_class.ring_distribs(1)
tff(fact_671_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) ) ) ).

% ring_class.ring_distribs(2)
tff(fact_672_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,uminus_uminus(A),A4)) ) ) ).

% add.inverse_distrib_swap
tff(fact_673_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,K: A,A4: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A4) )
         => ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,uminus_uminus(A),A4)) ) ) ) ).

% group_cancel.neg1
tff(fact_674_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X2: A] : ( neg_numeral_dbl_dec(A,X2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),X2)),one_one(A)) ) ) ).

% dbl_dec_def
tff(fact_675_Int__Diff,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B2),C3)) ) ).

% Int_Diff
tff(fact_676_Diff__Int2,axiom,
    ! [A: $tType,A3: set(A),C3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C3)),B2) ) ).

% Diff_Int2
tff(fact_677_Diff__Diff__Int,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) ) ).

% Diff_Diff_Int
tff(fact_678_Diff__Int__distrib,axiom,
    ! [A: $tType,C3: set(A),A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),A3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),B2)) ) ).

% Diff_Int_distrib
tff(fact_679_Diff__Int__distrib2,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3)) ) ).

% Diff_Int_distrib2
tff(fact_680_add_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( semigroup_add(A)
     => semigroup(A,plus_plus(A)) ) ).

% add.semigroup_axioms
tff(fact_681_Setcompr__eq__image,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: set(B)] : ( aa(fun(A,bool),set(A),collect(A),aa(set(B),fun(A,bool),aTP_Lamp_ch(fun(B,A),fun(set(B),fun(A,bool)),F2),A3)) = aa(set(B),set(A),image2(B,A,F2),A3) ) ).

% Setcompr_eq_image
tff(fact_682_setcompr__eq__image,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),P: fun(B,bool)] : ( aa(fun(A,bool),set(A),collect(A),aa(fun(B,bool),fun(A,bool),aTP_Lamp_ci(fun(B,A),fun(fun(B,bool),fun(A,bool)),F2),P)) = aa(set(B),set(A),image2(B,A,F2),aa(fun(B,bool),set(B),collect(B),P)) ) ).

% setcompr_eq_image
tff(fact_683_range__composition,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: fun(C,A),G: fun(B,C)] : ( aa(set(B),set(A),image2(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_cj(fun(C,A),fun(fun(B,C),fun(B,A)),F2),G)),top_top(set(B))) = aa(set(C),set(A),image2(C,A,F2),aa(set(B),set(C),image2(B,C,G),top_top(set(B)))) ) ).

% range_composition
tff(fact_684_rangeE,axiom,
    ! [A: $tType,B: $tType,B3: A,F2: fun(B,A)] :
      ( pp(aa(set(A),bool,member(A,B3),aa(set(B),set(A),image2(B,A,F2),top_top(set(B)))))
     => ~ ! [X: B] : ( B3 != aa(B,A,F2,X) ) ) ).

% rangeE
tff(fact_685_add_Oac__operator__axioms,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => syntax_ac_operator(A,plus_plus(A)) ) ).

% add.ac_operator_axioms
tff(fact_686_add_Osafe__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [X2: A,Y: A,A4: A,B3: A] :
          ( syntax7388354845996824322omatch(A,A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y),A4)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4) ) ) ) ).

% add.safe_commute
tff(fact_687_diff__eq,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% diff_eq
tff(fact_688_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,uminus_uminus(A),A4) = B3 )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) = zero_zero(A) ) ) ) ).

% neg_eq_iff_add_eq_0
tff(fact_689_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = aa(A,A,uminus_uminus(A),B3) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) = zero_zero(A) ) ) ) ).

% eq_neg_iff_add_eq_0
tff(fact_690_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) = zero_zero(A) )
         => ( aa(A,A,uminus_uminus(A),A4) = B3 ) ) ) ).

% add.inverse_unique
tff(fact_691_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A4)),A4) = zero_zero(A) ) ) ).

% ab_group_add_class.ab_left_minus
tff(fact_692_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3) = zero_zero(A) )
        <=> ( B3 = aa(A,A,uminus_uminus(A),A4) ) ) ) ).

% add_eq_0_iff
tff(fact_693_disjoint__alt__simp1,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2) = A3 )
    <=> ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) ) ) ).

% disjoint_alt_simp1
tff(fact_694_disjoint__alt__simp2,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2) != A3 )
    <=> ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) != bot_bot(set(A)) ) ) ).

% disjoint_alt_simp2
tff(fact_695_Diff__triv,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2) = A3 ) ) ).

% Diff_triv
tff(fact_696_Int__Diff__disjoint,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2)) = bot_bot(set(A)) ) ).

% Int_Diff_disjoint
tff(fact_697_Diff__Un,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B2),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),C3)) ) ).

% Diff_Un
tff(fact_698_Diff__Int,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),C3)) ) ).

% Diff_Int
tff(fact_699_Int__Diff__Un,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2)) = A3 ) ).

% Int_Diff_Un
tff(fact_700_Un__Diff__Int,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) = A3 ) ).

% Un_Diff_Int
tff(fact_701_add_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => comm_monoid(A,plus_plus(A),zero_zero(A)) ) ).

% add.comm_monoid_axioms
tff(fact_702_add_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => monoid(A,plus_plus(A),zero_zero(A)) ) ).

% add.monoid_axioms
tff(fact_703_full__SetCompr__eq,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A)] : ( aa(fun(A,bool),set(A),collect(A),aTP_Lamp_ck(fun(B,A),fun(A,bool),F2)) = aa(set(B),set(A),image2(B,A,F2),top_top(set(B))) ) ).

% full_SetCompr_eq
tff(fact_704_sum__list_Omonoid__list__axioms,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => groups_monoid_list(A,plus_plus(A),zero_zero(A)) ) ).

% sum_list.monoid_list_axioms
tff(fact_705_sum__list_Ocomm__monoid__list__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => groups1828464146339083142d_list(A,plus_plus(A),zero_zero(A)) ) ).

% sum_list.comm_monoid_list_axioms
tff(fact_706_sum_Ocomm__monoid__list__set__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => groups4802862169904069756st_set(A,plus_plus(A),zero_zero(A)) ) ).

% sum.comm_monoid_list_set_axioms
tff(fact_707_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X2: A] : ( neg_numeral_dbl_inc(A,X2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),X2)),one_one(A)) ) ) ).

% dbl_inc_def
tff(fact_708_surj__diff__right,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A] : ( aa(set(A),set(A),image2(A,A,aTP_Lamp_cl(A,fun(A,A),A4)),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_diff_right
tff(fact_709_surj__vimage__empty,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),A3: set(A)] :
      ( ( aa(set(B),set(A),image2(B,A,F2),top_top(set(B))) = top_top(set(A)) )
     => ( ( aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F2),A3) = bot_bot(set(B)) )
      <=> ( A3 = bot_bot(set(A)) ) ) ) ).

% surj_vimage_empty
tff(fact_710_translation__subtract__Compl,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A,T3: set(A)] : ( aa(set(A),set(A),image2(A,A,aTP_Lamp_cl(A,fun(A,A),A4)),aa(set(A),set(A),uminus_uminus(set(A)),T3)) = aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),image2(A,A,aTP_Lamp_cl(A,fun(A,A),A4)),T3)) ) ) ).

% translation_subtract_Compl
tff(fact_711_translation__subtract__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A,S2: set(A),T3: set(A)] : ( aa(set(A),set(A),image2(A,A,aTP_Lamp_cl(A,fun(A,A),A4)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),T3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),image2(A,A,aTP_Lamp_cl(A,fun(A,A),A4)),S2)),aa(set(A),set(A),image2(A,A,aTP_Lamp_cl(A,fun(A,A),A4)),T3)) ) ) ).

% translation_subtract_diff
tff(fact_712_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A,S2: set(A),T3: set(A)] : ( aa(set(A),set(A),image2(A,A,aTP_Lamp_cl(A,fun(A,A),A4)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),T3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),image2(A,A,aTP_Lamp_cl(A,fun(A,A),A4)),S2)),aa(set(A),set(A),image2(A,A,aTP_Lamp_cl(A,fun(A,A),A4)),T3)) ) ) ).

% translation_subtract_Int
tff(fact_713_translation__Int,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A,S2: set(A),T3: set(A)] : ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),plus_plus(A),A4)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),T3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),plus_plus(A),A4)),S2)),aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),plus_plus(A),A4)),T3)) ) ) ).

% translation_Int
tff(fact_714_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [R2: A,A4: A,B3: A,C2: A,D3: A] :
          ( ( R2 != zero_zero(A) )
         => ( ( ( A4 = B3 )
              & ( C2 != D3 ) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),R2),C2)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),R2),D3)) ) ) ) ) ).

% add_scale_eq_noteq
tff(fact_715_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X2: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)) = zero_zero(A) )
        <=> ( ( X2 = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_squares_eq_zero_iff
tff(fact_716_pairself__image__cart,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: set(B),B2: set(B)] : ( aa(set(product_prod(B,B)),set(product_prod(A,A)),image2(product_prod(B,B),product_prod(A,A),pairself(B,A,F2)),product_Sigma(B,B,A3,aTP_Lamp_cm(set(B),fun(B,set(B)),B2))) = product_Sigma(A,A,aa(set(B),set(A),image2(B,A,F2),A3),aa(set(B),fun(A,set(A)),aTP_Lamp_cn(fun(B,A),fun(set(B),fun(A,set(A))),F2),B2)) ) ).

% pairself_image_cart
tff(fact_717_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,bool),D2: A,Q: fun(A,bool)] :
          ( ! [X: A,K2: A] :
              ( pp(aa(A,bool,P,X))
            <=> pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D2)))) )
         => ( ! [X: A,K2: A] :
                ( pp(aa(A,bool,Q,X))
              <=> pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D2)))) )
           => ! [X4: A,K3: A] :
                ( ( pp(aa(A,bool,P,X4))
                  & pp(aa(A,bool,Q,X4)) )
              <=> ( pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D2))))
                  & pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D2)))) ) ) ) ) ) ).

% inf_period(1)
tff(fact_718_minus__set__def,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2) = aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),minus_minus(fun(A,bool)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),B2))) ) ).

% minus_set_def
tff(fact_719_minus__assn__def,axiom,
    ! [A4: assn,B3: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),minus_minus(assn),A4),B3) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A4),aa(assn,assn,uminus_uminus(assn),B3)) ) ).

% minus_assn_def
tff(fact_720_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [W2: A,Y: A,X2: A,Z2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y)) )
        <=> ( ( W2 = X2 )
            | ( Y = Z2 ) ) ) ) ).

% crossproduct_eq
tff(fact_721_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( ( A4 != B3 )
            & ( C2 != D3 ) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),D3)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),D3)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) ) ) ) ).

% crossproduct_noteq
tff(fact_722_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,bool),D2: A,Q: fun(A,bool)] :
          ( ! [X: A,K2: A] :
              ( pp(aa(A,bool,P,X))
            <=> pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D2)))) )
         => ( ! [X: A,K2: A] :
                ( pp(aa(A,bool,Q,X))
              <=> pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D2)))) )
           => ! [X4: A,K3: A] :
                ( ( pp(aa(A,bool,P,X4))
                  | pp(aa(A,bool,Q,X4)) )
              <=> ( pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D2))))
                  | pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D2)))) ) ) ) ) ) ).

% inf_period(2)
tff(fact_723_image__split__eq__Sigma,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(C,A),G: fun(C,B),A3: set(C)] : ( aa(set(C),set(product_prod(A,B)),image2(C,product_prod(A,B),aa(fun(C,B),fun(C,product_prod(A,B)),aTP_Lamp_co(fun(C,A),fun(fun(C,B),fun(C,product_prod(A,B))),F2),G)),A3) = product_Sigma(A,B,aa(set(C),set(A),image2(C,A,F2),A3),aa(set(C),fun(A,set(B)),aa(fun(C,B),fun(set(C),fun(A,set(B))),aTP_Lamp_cp(fun(C,A),fun(fun(C,B),fun(set(C),fun(A,set(B)))),F2),G),A3)) ) ).

% image_split_eq_Sigma
tff(fact_724_relImage__relInvImage,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,A)),F2: fun(B,A),A3: set(B)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R),product_Sigma(A,A,aa(set(B),set(A),image2(B,A,F2),A3),aa(set(B),fun(A,set(A)),aTP_Lamp_cn(fun(B,A),fun(set(B),fun(A,set(A))),F2),A3))))
     => ( bNF_Gr4221423524335903396lImage(B,A,bNF_Gr7122648621184425601vImage(B,A,A3,R,F2),F2) = R ) ) ).

% relImage_relInvImage
tff(fact_725_pairself__image__eq,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),P: fun(B,fun(B,bool))] : ( aa(set(product_prod(B,B)),set(product_prod(A,A)),image2(product_prod(B,B),product_prod(A,A),pairself(B,A,F2)),aa(fun(product_prod(B,B),bool),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,bool)),fun(product_prod(B,B),bool),product_case_prod(B,B,bool),P))) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(B,fun(B,bool)),fun(product_prod(A,A),bool),aTP_Lamp_cq(fun(B,A),fun(fun(B,fun(B,bool)),fun(product_prod(A,A),bool)),F2),P)) ) ).

% pairself_image_eq
tff(fact_726_rtrancl__restrictI,axiom,
    ! [A: $tType,U: A,V: A,E3: set(product_prod(A,A)),R: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V)),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),E3),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_cr(set(A),fun(A,set(A)),R))))))
     => ( ~ pp(aa(set(A),bool,member(A,U),R))
       => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V)),transitive_rtrancl(A,rel_restrict(A,E3,R)))) ) ) ).

% rtrancl_restrictI
tff(fact_727_the__elem__image__unique,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,B),X2: A] :
      ( ( A3 != bot_bot(set(A)) )
     => ( ! [Y2: A] :
            ( pp(aa(set(A),bool,member(A,Y2),A3))
           => ( aa(A,B,F2,Y2) = aa(A,B,F2,X2) ) )
       => ( the_elem(B,aa(set(A),set(B),image2(A,B,F2),A3)) = aa(A,B,F2,X2) ) ) ) ).

% the_elem_image_unique
tff(fact_728_Sup_OSUP__identity__eq,axiom,
    ! [A: $tType,Sup: fun(set(A),A),A3: set(A)] : ( aa(set(A),A,Sup,aa(set(A),set(A),image2(A,A,aTP_Lamp_bk(A,A)),A3)) = aa(set(A),A,Sup,A3) ) ).

% Sup.SUP_identity_eq
tff(fact_729_Inf_OINF__identity__eq,axiom,
    ! [A: $tType,Inf: fun(set(A),A),A3: set(A)] : ( aa(set(A),A,Inf,aa(set(A),set(A),image2(A,A,aTP_Lamp_bk(A,A)),A3)) = aa(set(A),A,Inf,A3) ) ).

% Inf.INF_identity_eq
tff(fact_730_inj__on__Un,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A3: set(A),B2: set(A)] :
      ( inj_on(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2))
    <=> ( inj_on(A,B,F2,A3)
        & inj_on(A,B,F2,B2)
        & ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image2(A,B,F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2))),aa(set(A),set(B),image2(A,B,F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B2),A3))) = bot_bot(set(B)) ) ) ) ).

% inj_on_Un
tff(fact_731_add_Ogroup__axioms,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => group(A,plus_plus(A),zero_zero(A),uminus_uminus(A)) ) ).

% add.group_axioms
tff(fact_732_vimage__fst,axiom,
    ! [B: $tType,A: $tType,A3: set(A)] : ( aa(set(A),set(product_prod(A,B)),aa(fun(product_prod(A,B),A),fun(set(A),set(product_prod(A,B))),vimage(product_prod(A,B),A),product_fst(A,B)),A3) = product_Sigma(A,B,A3,aTP_Lamp_bp(A,set(B))) ) ).

% vimage_fst
tff(fact_733_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),A4)) ) ).

% dual_order.refl
tff(fact_734_order__refl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),X2)) ) ).

% order_refl
tff(fact_735_split__part,axiom,
    ! [B: $tType,A: $tType,P: bool,Q: fun(A,fun(B,bool)),X4: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aTP_Lamp_cs(bool,fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),P),Q)),X4))
    <=> ( pp(P)
        & pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Q),X4)) ) ) ).

% split_part
tff(fact_736_le__zero__eq,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),N),zero_zero(A)))
        <=> ( N = zero_zero(A) ) ) ) ).

% le_zero_eq
tff(fact_737_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ).

% add_le_cancel_right
tff(fact_738_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ).

% add_le_cancel_left
tff(fact_739_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,uminus_uminus(A),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ).

% neg_le_iff_le
tff(fact_740_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,uminus_uminus(A),Y)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2)) ) ) ).

% compl_le_compl_iff
tff(fact_741_le__inf__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z2)) ) ) ) ).

% le_inf_iff
tff(fact_742_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),inf_inf(A),B3),C2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2)) ) ) ) ).

% inf.bounded_iff
tff(fact_743_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B3),C2)),A4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A4)) ) ) ) ).

% sup.bounded_iff
tff(fact_744_le__sup__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)),Z2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ) ).

% le_sup_iff
tff(fact_745_subset__empty,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),bot_bot(set(A))))
    <=> ( A3 = bot_bot(set(A)) ) ) ).

% subset_empty
tff(fact_746_empty__subsetI,axiom,
    ! [A: $tType,A3: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),bot_bot(set(A))),A3)) ).

% empty_subsetI
tff(fact_747_singletonI,axiom,
    ! [A: $tType,A4: A] : pp(aa(set(A),bool,member(A,A4),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))) ).

% singletonI
tff(fact_748_Int__subset__iff,axiom,
    ! [A: $tType,C3: set(A),A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),A3))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),B2)) ) ) ).

% Int_subset_iff
tff(fact_749_Int__insert__left__if0,axiom,
    ! [A: $tType,A4: A,C3: set(A),B2: set(A)] :
      ( ~ pp(aa(set(A),bool,member(A,A4),C3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert(A,A4),B2)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3) ) ) ).

% Int_insert_left_if0
tff(fact_750_Int__insert__left__if1,axiom,
    ! [A: $tType,A4: A,C3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,member(A,A4),C3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert(A,A4),B2)),C3) = aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3)) ) ) ).

% Int_insert_left_if1
tff(fact_751_insert__inter__insert,axiom,
    ! [A: $tType,A4: A,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert(A,A4),A3)),aa(set(A),set(A),insert(A,A4),B2)) = aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) ) ).

% insert_inter_insert
tff(fact_752_Int__insert__right__if0,axiom,
    ! [A: $tType,A4: A,A3: set(A),B2: set(A)] :
      ( ~ pp(aa(set(A),bool,member(A,A4),A3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),insert(A,A4),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) ) ) ).

% Int_insert_right_if0
tff(fact_753_Int__insert__right__if1,axiom,
    ! [A: $tType,A4: A,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,member(A,A4),A3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),insert(A,A4),B2)) = aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) ) ) ).

% Int_insert_right_if1
tff(fact_754_inj__on__empty,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B)] : inj_on(A,B,F2,bot_bot(set(A))) ).

% inj_on_empty
tff(fact_755_singleton__conv,axiom,
    ! [A: $tType,A4: A] : ( aa(fun(A,bool),set(A),collect(A),aTP_Lamp_ct(A,fun(A,bool),A4)) = aa(set(A),set(A),insert(A,A4),bot_bot(set(A))) ) ).

% singleton_conv
tff(fact_756_singleton__conv2,axiom,
    ! [A: $tType,A4: A] : ( aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),fequal(A),A4)) = aa(set(A),set(A),insert(A,A4),bot_bot(set(A))) ) ).

% singleton_conv2
tff(fact_757_case__prod__conv,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(B,fun(C,A)),A4: B,B3: C] : ( aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),F2),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B3)) = aa(C,A,aa(B,fun(C,A),F2,A4),B3) ) ).

% case_prod_conv
tff(fact_758_eq__or__mem__image__simp,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A4: B,B2: set(B)] : ( aa(fun(A,bool),set(A),collect(A),aa(set(B),fun(A,bool),aa(B,fun(set(B),fun(A,bool)),aTP_Lamp_cu(fun(B,A),fun(B,fun(set(B),fun(A,bool))),F2),A4),B2)) = aa(set(A),set(A),insert(A,aa(B,A,F2,A4)),aa(fun(A,bool),set(A),collect(A),aa(set(B),fun(A,bool),aTP_Lamp_ch(fun(B,A),fun(set(B),fun(A,bool)),F2),B2))) ) ).

% eq_or_mem_image_simp
tff(fact_759_case__prodI,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(B,bool)),A4: A,B3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),F2,A4),B3))
     => pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),F2),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3))) ) ).

% case_prodI
tff(fact_760_case__prodI2,axiom,
    ! [B: $tType,A: $tType,P5: product_prod(A,B),C2: fun(A,fun(B,bool))] :
      ( ! [A5: A,B4: B] :
          ( ( P5 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A5),B4) )
         => pp(aa(B,bool,aa(A,fun(B,bool),C2,A5),B4)) )
     => pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),C2),P5)) ) ).

% case_prodI2
tff(fact_761_Collect__case__prod,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),Q: fun(B,bool)] : ( aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(fun(B,bool),fun(A,fun(B,bool)),aTP_Lamp_cv(fun(A,bool),fun(fun(B,bool),fun(A,fun(B,bool))),P),Q))) = product_Sigma(A,B,aa(fun(A,bool),set(A),collect(A),P),aTP_Lamp_cw(fun(B,bool),fun(A,set(B)),Q)) ) ).

% Collect_case_prod
tff(fact_762_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4)) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
tff(fact_763_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),A4)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A))) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
tff(fact_764_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3)) ) ) ).

% le_add_same_cancel2
tff(fact_765_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3)) ) ) ).

% le_add_same_cancel1
tff(fact_766_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),B3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A))) ) ) ).

% add_le_same_cancel2
tff(fact_767_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4)),B3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A))) ) ) ).

% add_le_same_cancel1
tff(fact_768_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ).

% diff_ge_0_iff_ge
tff(fact_769_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A4)),A4))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4)) ) ) ).

% neg_less_eq_nonneg
tff(fact_770_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,uminus_uminus(A),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A))) ) ) ).

% less_eq_neg_nonpos
tff(fact_771_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A4)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4)) ) ) ).

% neg_le_0_iff_le
tff(fact_772_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A))) ) ) ).

% neg_0_le_iff_le
tff(fact_773_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),B3) = A4 ) ) ) ).

% le_add_diff_inverse2
tff(fact_774_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)) = A4 ) ) ) ).

% le_add_diff_inverse
tff(fact_775_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A4: A,A3: set(A),B3: A] :
      ( ( aa(set(A),set(A),insert(A,A4),A3) = aa(set(A),set(A),insert(A,B3),bot_bot(set(A))) )
    <=> ( ( A4 = B3 )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))) ) ) ).

% singleton_insert_inj_eq'
tff(fact_776_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B3: A,A4: A,A3: set(A)] :
      ( ( aa(set(A),set(A),insert(A,B3),bot_bot(set(A))) = aa(set(A),set(A),insert(A,A4),A3) )
    <=> ( ( A4 = B3 )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))) ) ) ).

% singleton_insert_inj_eq
tff(fact_777_disjoint__insert_I2_J,axiom,
    ! [A: $tType,A3: set(A),B3: A,B2: set(A)] :
      ( ( bot_bot(set(A)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),insert(A,B3),B2)) )
    <=> ( ~ pp(aa(set(A),bool,member(A,B3),A3))
        & ( bot_bot(set(A)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) ) ) ) ).

% disjoint_insert(2)
tff(fact_778_disjoint__insert_I1_J,axiom,
    ! [A: $tType,B2: set(A),A4: A,A3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),aa(set(A),set(A),insert(A,A4),A3)) = bot_bot(set(A)) )
    <=> ( ~ pp(aa(set(A),bool,member(A,A4),B2))
        & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),A3) = bot_bot(set(A)) ) ) ) ).

% disjoint_insert(1)
tff(fact_779_insert__disjoint_I2_J,axiom,
    ! [A: $tType,A4: A,A3: set(A),B2: set(A)] :
      ( ( bot_bot(set(A)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert(A,A4),A3)),B2) )
    <=> ( ~ pp(aa(set(A),bool,member(A,A4),B2))
        & ( bot_bot(set(A)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) ) ) ) ).

% insert_disjoint(2)
tff(fact_780_insert__disjoint_I1_J,axiom,
    ! [A: $tType,A4: A,A3: set(A),B2: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert(A,A4),A3)),B2) = bot_bot(set(A)) )
    <=> ( ~ pp(aa(set(A),bool,member(A,A4),B2))
        & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) ) ) ) ).

% insert_disjoint(1)
tff(fact_781_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2) = bot_bot(set(A)) )
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2)) ) ).

% Diff_eq_empty_iff
tff(fact_782_insert__Diff__single,axiom,
    ! [A: $tType,A4: A,A3: set(A)] : ( aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))) = aa(set(A),set(A),insert(A,A4),A3) ) ).

% insert_Diff_single
tff(fact_783_pair__imageI,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: A,B3: B,A3: set(product_prod(A,B)),F2: fun(A,fun(B,C))] :
      ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3)),A3))
     => pp(aa(set(C),bool,member(C,aa(B,C,aa(A,fun(B,C),F2,A4),B3)),aa(set(product_prod(A,B)),set(C),image2(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F2)),A3))) ) ).

% pair_imageI
tff(fact_784_the__elem__eq,axiom,
    ! [A: $tType,X2: A] : ( the_elem(A,aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = X2 ) ).

% the_elem_eq
tff(fact_785_Collect__const__case__prod,axiom,
    ! [B: $tType,A: $tType,P: bool] :
      ( ( pp(P)
       => ( aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_cx(bool,fun(A,fun(B,bool)),P))) = top_top(set(product_prod(A,B))) ) )
      & ( ~ pp(P)
       => ( aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_cx(bool,fun(A,fun(B,bool)),P))) = bot_bot(set(product_prod(A,B))) ) ) ) ).

% Collect_const_case_prod
tff(fact_786_subset__Compl__singleton,axiom,
    ! [A: $tType,A3: set(A),B3: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))))
    <=> ~ pp(aa(set(A),bool,member(A,B3),A3)) ) ).

% subset_Compl_singleton
tff(fact_787_range__constant,axiom,
    ! [B: $tType,A: $tType,X2: A] : ( aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_cy(A,fun(B,A)),X2)),top_top(set(B))) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ).

% range_constant
tff(fact_788_insert__Times__insert,axiom,
    ! [A: $tType,B: $tType,A4: A,A3: set(A),B3: B,B2: set(B)] : ( product_Sigma(A,B,aa(set(A),set(A),insert(A,A4),A3),aa(set(B),fun(A,set(B)),aTP_Lamp_cz(B,fun(set(B),fun(A,set(B))),B3),B2)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),insert(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3)),aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),sup_sup(set(product_prod(A,B))),product_Sigma(A,B,A3,aa(set(B),fun(A,set(B)),aTP_Lamp_cz(B,fun(set(B),fun(A,set(B))),B3),B2))),product_Sigma(A,B,aa(set(A),set(A),insert(A,A4),A3),aTP_Lamp_bq(set(B),fun(A,set(B)),B2)))) ) ).

% insert_Times_insert
tff(fact_789_fst__image__times,axiom,
    ! [B: $tType,A: $tType,B2: set(B),A3: set(A)] :
      ( ( ( B2 = bot_bot(set(B)) )
       => ( aa(set(product_prod(A,B)),set(A),image2(product_prod(A,B),A,product_fst(A,B)),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))) = bot_bot(set(A)) ) )
      & ( ( B2 != bot_bot(set(B)) )
       => ( aa(set(product_prod(A,B)),set(A),image2(product_prod(A,B),A,product_fst(A,B)),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))) = A3 ) ) ) ).

% fst_image_times
tff(fact_790_inj__on__insert,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A4: A,A3: set(A)] :
      ( inj_on(A,B,F2,aa(set(A),set(A),insert(A,A4),A3))
    <=> ( inj_on(A,B,F2,A3)
        & ~ pp(aa(set(B),bool,member(B,aa(A,B,F2,A4)),aa(set(A),set(B),image2(A,B,F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))))) ) ) ).

% inj_on_insert
tff(fact_791_inj__on__id2,axiom,
    ! [A: $tType,A3: set(A)] : inj_on(A,A,aTP_Lamp_bk(A,A),A3) ).

% inj_on_id2
tff(fact_792_prod_Odisc__eq__case,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod(A,B)] : pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_da(A,fun(B,bool))),Prod)) ).

% prod.disc_eq_case
tff(fact_793_subset__singletonD,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))
     => ( ( A3 = bot_bot(set(A)) )
        | ( A3 = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ) ) ).

% subset_singletonD
tff(fact_794_subset__singleton__iff,axiom,
    ! [A: $tType,X5: set(A),A4: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X5),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))
    <=> ( ( X5 = bot_bot(set(A)) )
        | ( X5 = aa(set(A),set(A),insert(A,A4),bot_bot(set(A))) ) ) ) ).

% subset_singleton_iff
tff(fact_795_fst__def,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod(A,B)] : ( aa(product_prod(A,B),A,product_fst(A,B),Prod) = aa(product_prod(A,B),A,aa(fun(A,fun(B,A)),fun(product_prod(A,B),A),product_case_prod(A,B,A),aTP_Lamp_cy(A,fun(B,A))),Prod) ) ).

% fst_def
tff(fact_796_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
          <=> ( X2 = Y ) ) ) ) ).

% order_antisym_conv
tff(fact_797_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2)) ) ) ).

% linorder_le_cases
tff(fact_798_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A4: A,B3: A,F2: fun(A,B),C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( ( aa(A,B,F2,B3) = C2 )
           => ( ! [X: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X)),aa(A,B,F2,Y2))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,A4)),C2)) ) ) ) ) ).

% ord_le_eq_subst
tff(fact_799_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A4: A,F2: fun(B,A),B3: B,C2: B] :
          ( ( A4 = aa(B,A,F2,B3) )
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),B3),C2))
           => ( ! [X: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),X),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(B,A,F2,C2))) ) ) ) ) ).

% ord_eq_le_subst
tff(fact_800_linorder__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
          | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2)) ) ) ).

% linorder_linear
tff(fact_801_order__eq__refl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y: A] :
          ( ( X2 = Y )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y)) ) ) ).

% order_eq_refl
tff(fact_802_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A4: A,B3: A,F2: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F2,B3)),C2))
           => ( ! [X: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F2,X)),aa(A,C,F2,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F2,A4)),C2)) ) ) ) ) ).

% order_subst2
tff(fact_803_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A4: A,F2: fun(B,A),B3: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(B,A,F2,B3)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),B3),C2))
           => ( ! [X: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),X),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(B,A,F2,C2))) ) ) ) ) ).

% order_subst1
tff(fact_804_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = B3 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ) ).

% Orderings.order_eq_iff
tff(fact_805_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F2),G))
        <=> ! [X3: A] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,G,X3))) ) ) ).

% le_fun_def
tff(fact_806_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( ! [X: A] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X)),aa(A,B,G,X)))
         => pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F2),G)) ) ) ).

% le_funI
tff(fact_807_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F2: fun(A,B),G: fun(A,B),X2: A] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F2),G))
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,G,X2))) ) ) ).

% le_funE
tff(fact_808_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F2: fun(A,B),G: fun(A,B),X2: A] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F2),G))
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,G,X2))) ) ) ).

% le_funD
tff(fact_809_antisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
           => ( A4 = B3 ) ) ) ) ).

% antisym
tff(fact_810_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A4)) ) ) ) ).

% dual_order.trans
tff(fact_811_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
           => ( A4 = B3 ) ) ) ) ).

% dual_order.antisym
tff(fact_812_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = B3 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ) ).

% dual_order.eq_iff
tff(fact_813_linorder__wlog,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,fun(A,bool)),A4: A,B3: A] :
          ( ! [A5: A,B4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A5),B4))
             => pp(aa(A,bool,aa(A,fun(A,bool),P,A5),B4)) )
         => ( ! [A5: A,B4: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),P,B4),A5))
               => pp(aa(A,bool,aa(A,fun(A,bool),P,A5),B4)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),P,A4),B3)) ) ) ) ).

% linorder_wlog
tff(fact_814_order__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z2)) ) ) ) ).

% order_trans
tff(fact_815_order_Otrans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2)) ) ) ) ).

% order.trans
tff(fact_816_order__antisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2))
           => ( X2 = Y ) ) ) ) ).

% order_antisym
tff(fact_817_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( ( B3 = C2 )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2)) ) ) ) ).

% ord_le_eq_trans
tff(fact_818_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4 = B3 )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2)) ) ) ) ).

% ord_eq_le_trans
tff(fact_819_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y: A] :
          ( ( X2 = Y )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2)) ) ) ) ).

% order_class.order_eq_iff
tff(fact_820_le__cases3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
           => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) )
         => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z2)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z2))
               => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),Y)) )
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),Y))
                 => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2)) )
               => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2))
                   => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),X2)) )
                 => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),X2))
                     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y)) ) ) ) ) ) ) ) ).

% le_cases3
tff(fact_821_group_Oinverse__distrib__swap,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A4: A,B3: A] :
      ( group(A,F2,Z2,Inverse)
     => ( aa(A,A,Inverse,aa(A,A,aa(A,fun(A,A),F2,A4),B3)) = aa(A,A,aa(A,fun(A,A),F2,aa(A,A,Inverse,B3)),aa(A,A,Inverse,A4)) ) ) ).

% group.inverse_distrib_swap
tff(fact_822_nle__le,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
            & ( B3 != A4 ) ) ) ) ).

% nle_le
tff(fact_823_group_Ogroup__left__neutral,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A4: A] :
      ( group(A,F2,Z2,Inverse)
     => ( aa(A,A,aa(A,fun(A,A),F2,Z2),A4) = A4 ) ) ).

% group.group_left_neutral
tff(fact_824_group_Oinverse__neutral,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( group(A,F2,Z2,Inverse)
     => ( aa(A,A,Inverse,Z2) = Z2 ) ) ).

% group.inverse_neutral
tff(fact_825_group_Oinverse__inverse,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A4: A] :
      ( group(A,F2,Z2,Inverse)
     => ( aa(A,A,Inverse,aa(A,A,Inverse,A4)) = A4 ) ) ).

% group.inverse_inverse
tff(fact_826_group_Oinverse__unique,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A4: A,B3: A] :
      ( group(A,F2,Z2,Inverse)
     => ( ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = Z2 )
       => ( aa(A,A,Inverse,A4) = B3 ) ) ) ).

% group.inverse_unique
tff(fact_827_group_Oright__inverse,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A4: A] :
      ( group(A,F2,Z2,Inverse)
     => ( aa(A,A,aa(A,fun(A,A),F2,A4),aa(A,A,Inverse,A4)) = Z2 ) ) ).

% group.right_inverse
tff(fact_828_group_Oright__cancel,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),B3: A,A4: A,C2: A] :
      ( group(A,F2,Z2,Inverse)
     => ( ( aa(A,A,aa(A,fun(A,A),F2,B3),A4) = aa(A,A,aa(A,fun(A,A),F2,C2),A4) )
      <=> ( B3 = C2 ) ) ) ).

% group.right_cancel
tff(fact_829_group_Oleft__inverse,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A4: A] :
      ( group(A,F2,Z2,Inverse)
     => ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,Inverse,A4)),A4) = Z2 ) ) ).

% group.left_inverse
tff(fact_830_group_Oleft__cancel,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A4: A,B3: A,C2: A] :
      ( group(A,F2,Z2,Inverse)
     => ( ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = aa(A,A,aa(A,fun(A,A),F2,A4),C2) )
      <=> ( B3 = C2 ) ) ) ).

% group.left_cancel
tff(fact_831_nested__case__prod__simp,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F2: fun(B,fun(C,fun(D,A))),X2: product_prod(B,C),Y: D] : ( aa(D,A,aa(product_prod(B,C),fun(D,A),aa(fun(B,fun(C,fun(D,A))),fun(product_prod(B,C),fun(D,A)),product_case_prod(B,C,fun(D,A)),F2),X2),Y) = aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),aa(D,fun(B,fun(C,A)),aTP_Lamp_db(fun(B,fun(C,fun(D,A))),fun(D,fun(B,fun(C,A))),F2),Y)),X2) ) ).

% nested_case_prod_simp
tff(fact_832_fn__fst__conv,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: fun(A,C)] : ( aTP_Lamp_dc(fun(A,C),fun(product_prod(A,B),C),F2) = aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),aTP_Lamp_dd(fun(A,C),fun(A,fun(B,C)),F2)) ) ).

% fn_fst_conv
tff(fact_833_case__prod__app,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F2: fun(B,fun(C,fun(D,A))),X2: product_prod(B,C),Y: D] : ( aa(D,A,aa(product_prod(B,C),fun(D,A),aa(fun(B,fun(C,fun(D,A))),fun(product_prod(B,C),fun(D,A)),product_case_prod(B,C,fun(D,A)),F2),X2),Y) = aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),aa(D,fun(B,fun(C,A)),aTP_Lamp_db(fun(B,fun(C,fun(D,A))),fun(D,fun(B,fun(C,A))),F2),Y)),X2) ) ).

% case_prod_app
tff(fact_834_insert__compr,axiom,
    ! [A: $tType,A4: A,B2: set(A)] : ( aa(set(A),set(A),insert(A,A4),B2) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_de(A,fun(set(A),fun(A,bool)),A4),B2)) ) ).

% insert_compr
tff(fact_835_insert__Collect,axiom,
    ! [A: $tType,A4: A,P: fun(A,bool)] : ( aa(set(A),set(A),insert(A,A4),aa(fun(A,bool),set(A),collect(A),P)) = aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_df(A,fun(fun(A,bool),fun(A,bool)),A4),P)) ) ).

% insert_Collect
tff(fact_836_prod_Ocase__distrib,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,H2: fun(C,D),F2: fun(A,fun(B,C)),Prod: product_prod(A,B)] : ( aa(C,D,H2,aa(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F2),Prod)) = aa(product_prod(A,B),D,aa(fun(A,fun(B,D)),fun(product_prod(A,B),D),product_case_prod(A,B,D),aa(fun(A,fun(B,C)),fun(A,fun(B,D)),aTP_Lamp_dg(fun(C,D),fun(fun(A,fun(B,C)),fun(A,fun(B,D))),H2),F2)),Prod) ) ).

% prod.case_distrib
tff(fact_837_subset__CollectI,axiom,
    ! [A: $tType,B2: set(A),A3: set(A),Q: fun(A,bool),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),A3))
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),B2))
           => ( pp(aa(A,bool,Q,X))
             => pp(aa(A,bool,P,X)) ) )
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_dh(set(A),fun(fun(A,bool),fun(A,bool)),B2),Q))),aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_dh(set(A),fun(fun(A,bool),fun(A,bool)),A3),P)))) ) ) ).

% subset_CollectI
tff(fact_838_subset__Collect__iff,axiom,
    ! [A: $tType,B2: set(A),A3: set(A),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),A3))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_dh(set(A),fun(fun(A,bool),fun(A,bool)),A3),P))))
      <=> ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),B2))
           => pp(aa(A,bool,P,X3)) ) ) ) ).

% subset_Collect_iff
tff(fact_839_Collect__subset,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,bool)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_dh(set(A),fun(fun(A,bool),fun(A,bool)),A3),P))),A3)) ).

% Collect_subset
tff(fact_840_inj__fun,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: fun(A,B)] :
      ( inj_on(A,B,F2,top_top(set(A)))
     => inj_on(A,fun(C,B),aTP_Lamp_di(fun(A,B),fun(A,fun(C,B)),F2),top_top(set(A))) ) ).

% inj_fun
tff(fact_841_inj__singleton,axiom,
    ! [A: $tType,A3: set(A)] : inj_on(A,set(A),aTP_Lamp_dj(A,set(A)),A3) ).

% inj_singleton
tff(fact_842_case__prod__unfold,axiom,
    ! [C: $tType,B: $tType,A: $tType,X4: fun(A,fun(B,C)),Xa3: product_prod(A,B)] : ( aa(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),X4),Xa3) = aa(B,C,aa(A,fun(B,C),X4,aa(product_prod(A,B),A,product_fst(A,B),Xa3)),aa(product_prod(A,B),B,product_snd(A,B),Xa3)) ) ).

% case_prod_unfold
tff(fact_843_case__prod__beta_H,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(A,fun(B,C)),X4: product_prod(A,B)] : ( aa(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F2),X4) = aa(B,C,aa(A,fun(B,C),F2,aa(product_prod(A,B),A,product_fst(A,B),X4)),aa(product_prod(A,B),B,product_snd(A,B),X4)) ) ).

% case_prod_beta'
tff(fact_844_split__comp__eq,axiom,
    ! [B: $tType,C: $tType,A: $tType,D: $tType,F2: fun(A,fun(B,C)),G: fun(D,A)] : ( aa(fun(D,A),fun(product_prod(D,B),C),aTP_Lamp_dk(fun(A,fun(B,C)),fun(fun(D,A),fun(product_prod(D,B),C)),F2),G) = aa(fun(D,fun(B,C)),fun(product_prod(D,B),C),product_case_prod(D,B,C),aa(fun(D,A),fun(D,fun(B,C)),aTP_Lamp_dl(fun(A,fun(B,C)),fun(fun(D,A),fun(D,fun(B,C))),F2),G)) ) ).

% split_comp_eq
tff(fact_845_Times__subset__cancel2,axiom,
    ! [A: $tType,B: $tType,X2: A,C3: set(A),A3: set(B),B2: set(B)] :
      ( pp(aa(set(A),bool,member(A,X2),C3))
     => ( pp(aa(set(product_prod(B,A)),bool,aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),bool),ord_less_eq(set(product_prod(B,A))),product_Sigma(B,A,A3,aTP_Lamp_bv(set(A),fun(B,set(A)),C3))),product_Sigma(B,A,B2,aTP_Lamp_bv(set(A),fun(B,set(A)),C3))))
      <=> pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A3),B2)) ) ) ).

% Times_subset_cancel2
tff(fact_846_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),C3: set(A),A3: set(A),B2: set(A)] :
      ( inj_on(A,B,F2,C3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),C3))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),C3))
         => ( aa(set(A),set(B),image2(A,B,F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image2(A,B,F2),A3)),aa(set(A),set(B),image2(A,B,F2),B2)) ) ) ) ) ).

% inj_on_image_Int
tff(fact_847_Diff__single__insert,axiom,
    ! [A: $tType,A3: set(A),X2: A,B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),B2))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,X2),B2))) ) ).

% Diff_single_insert
tff(fact_848_subset__insert__iff,axiom,
    ! [A: $tType,A3: set(A),X2: A,B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,X2),B2)))
    <=> ( ( pp(aa(set(A),bool,member(A,X2),A3))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),B2)) )
        & ( ~ pp(aa(set(A),bool,member(A,X2),A3))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2)) ) ) ) ).

% subset_insert_iff
tff(fact_849_inj__on__Int,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A3: set(A),B2: set(A)] :
      ( ( inj_on(A,B,F2,A3)
        | inj_on(A,B,F2,B2) )
     => inj_on(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) ) ).

% inj_on_Int
tff(fact_850_singletonD,axiom,
    ! [A: $tType,B3: A,A4: A] :
      ( pp(aa(set(A),bool,member(A,B3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))
     => ( B3 = A4 ) ) ).

% singletonD
tff(fact_851_singleton__iff,axiom,
    ! [A: $tType,B3: A,A4: A] :
      ( pp(aa(set(A),bool,member(A,B3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))
    <=> ( B3 = A4 ) ) ).

% singleton_iff
tff(fact_852_doubleton__eq__iff,axiom,
    ! [A: $tType,A4: A,B3: A,C2: A,D3: A] :
      ( ( aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))) = aa(set(A),set(A),insert(A,C2),aa(set(A),set(A),insert(A,D3),bot_bot(set(A)))) )
    <=> ( ( ( A4 = C2 )
          & ( B3 = D3 ) )
        | ( ( A4 = D3 )
          & ( B3 = C2 ) ) ) ) ).

% doubleton_eq_iff
tff(fact_853_insert__not__empty,axiom,
    ! [A: $tType,A4: A,A3: set(A)] : ( aa(set(A),set(A),insert(A,A4),A3) != bot_bot(set(A)) ) ).

% insert_not_empty
tff(fact_854_singleton__inject,axiom,
    ! [A: $tType,A4: A,B3: A] :
      ( ( aa(set(A),set(A),insert(A,A4),bot_bot(set(A))) = aa(set(A),set(A),insert(A,B3),bot_bot(set(A))) )
     => ( A4 = B3 ) ) ).

% singleton_inject
tff(fact_855_zero__le,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X2)) ) ).

% zero_le
tff(fact_856_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ).

% add_le_imp_le_right
tff(fact_857_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ).

% add_le_imp_le_left
tff(fact_858_le__iff__add,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
        <=> ? [C5: A] : ( B3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C5) ) ) ) ).

% le_iff_add
tff(fact_859_add__right__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2))) ) ) ).

% add_right_mono
tff(fact_860_less__eqE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ~ ! [C4: A] : ( B3 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C4) ) ) ) ).

% less_eqE
tff(fact_861_add__left__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3))) ) ) ).

% add_left_mono
tff(fact_862_add__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),D3))) ) ) ) ).

% add_mono
tff(fact_863_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I2),J2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_semiring(1)
tff(fact_864_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( I2 = J2 )
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_semiring(2)
tff(fact_865_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I2),J2))
            & ( K = L ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_semiring(3)
tff(fact_866_Int__insert__left,axiom,
    ! [A: $tType,A4: A,C3: set(A),B2: set(A)] :
      ( ( pp(aa(set(A),bool,member(A,A4),C3))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert(A,A4),B2)),C3) = aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3)) ) )
      & ( ~ pp(aa(set(A),bool,member(A,A4),C3))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert(A,A4),B2)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),C3) ) ) ) ).

% Int_insert_left
tff(fact_867_Int__insert__right,axiom,
    ! [A: $tType,A4: A,A3: set(A),B2: set(A)] :
      ( ( pp(aa(set(A),bool,member(A,A4),A3))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),insert(A,A4),B2)) = aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) ) )
      & ( ~ pp(aa(set(A),bool,member(A,A4),A3))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),insert(A,A4),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) ) ) ) ).

% Int_insert_right
tff(fact_868_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),one_one(A))) ) ).

% le_numeral_extra(4)
tff(fact_869_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D3) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D3)) ) ) ) ).

% diff_eq_diff_less_eq
tff(fact_870_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),C2))) ) ) ).

% diff_right_mono
tff(fact_871_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A4)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B3))) ) ) ).

% diff_left_mono
tff(fact_872_diff__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A,D3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),D3))) ) ) ) ).

% diff_mono
tff(fact_873_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),bot_bot(A)))
         => ( A4 = bot_bot(A) ) ) ) ).

% bot.extremum_uniqueI
tff(fact_874_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),bot_bot(A)))
        <=> ( A4 = bot_bot(A) ) ) ) ).

% bot.extremum_unique
tff(fact_875_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),bot_bot(A)),A4)) ) ).

% bot.extremum
tff(fact_876_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,uminus_uminus(A),A4))) ) ) ).

% le_imp_neg_le
tff(fact_877_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A4)),B3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B3)),A4)) ) ) ).

% minus_le_iff
tff(fact_878_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,uminus_uminus(A),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,uminus_uminus(A),A4))) ) ) ).

% le_minus_iff
tff(fact_879_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),Y)),X2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),X2)),Y)) ) ) ).

% compl_le_swap2
tff(fact_880_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),aa(A,A,uminus_uminus(A),X2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,uminus_uminus(A),Y))) ) ) ).

% compl_le_swap1
tff(fact_881_compl__mono,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),Y)),aa(A,A,uminus_uminus(A),X2))) ) ) ).

% compl_mono
tff(fact_882_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),top_top(A)),A4))
         => ( A4 = top_top(A) ) ) ) ).

% top.extremum_uniqueI
tff(fact_883_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),top_top(A)),A4))
        <=> ( A4 = top_top(A) ) ) ) ).

% top.extremum_unique
tff(fact_884_top__greatest,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),top_top(A))) ) ).

% top_greatest
tff(fact_885_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),Y)) ) ).

% inf_sup_ord(2)
tff(fact_886_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),X2)) ) ).

% inf_sup_ord(1)
tff(fact_887_inf__le1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),X2)) ) ).

% inf_le1
tff(fact_888_inf__le2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),Y)) ) ).

% inf_le2
tff(fact_889_le__infE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A4))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B3)) ) ) ) ).

% le_infE
tff(fact_890_le__infI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3))) ) ) ) ).

% le_infI
tff(fact_891_inf__mono,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),D3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),aa(A,A,aa(A,fun(A,A),inf_inf(A),C2),D3))) ) ) ) ).

% inf_mono
tff(fact_892_le__infI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,X2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),X2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),X2)) ) ) ).

% le_infI1
tff(fact_893_le__infI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B3: A,X2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),X2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),X2)) ) ) ).

% le_infI2
tff(fact_894_inf_OorderE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( A4 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) ) ) ) ).

% inf.orderE
tff(fact_895_inf_OorderI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ).

% inf.orderI
tff(fact_896_inf__unique,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [F2: fun(A,fun(A,A)),X2: A,Y: A] :
          ( ! [X: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F2,X),Y2)),X))
         => ( ! [X: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F2,X),Y2)),Y2))
           => ( ! [X: A,Y2: A,Z3: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Z3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),F2,Y2),Z3))) ) )
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) = aa(A,A,aa(A,fun(A,A),F2,X2),Y) ) ) ) ) ) ).

% inf_unique
tff(fact_897_le__iff__inf,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) = X2 ) ) ) ).

% le_iff_inf
tff(fact_898_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) = A4 ) ) ) ).

% inf.absorb1
tff(fact_899_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) = B3 ) ) ) ).

% inf.absorb2
tff(fact_900_inf__absorb1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) = X2 ) ) ) ).

% inf_absorb1
tff(fact_901_inf__absorb2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Y: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) = Y ) ) ) ).

% inf_absorb2
tff(fact_902_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),inf_inf(A),B3),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2)) ) ) ) ).

% inf.boundedE
tff(fact_903_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),inf_inf(A),B3),C2))) ) ) ) ).

% inf.boundedI
tff(fact_904_inf__greatest,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2))) ) ) ) ).

% inf_greatest
tff(fact_905_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
        <=> ( A4 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) ) ) ) ).

% inf.order_iff
tff(fact_906_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),A4)) ) ).

% inf.cobounded1
tff(fact_907_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),B3)) ) ).

% inf.cobounded2
tff(fact_908_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) = A4 ) ) ) ).

% inf.absorb_iff1
tff(fact_909_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) = B3 ) ) ) ).

% inf.absorb_iff2
tff(fact_910_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),C2)) ) ) ).

% inf.coboundedI1
tff(fact_911_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),C2)) ) ) ).

% inf.coboundedI2
tff(fact_912_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3))) ) ) ).

% sup.coboundedI2
tff(fact_913_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3))) ) ) ).

% sup.coboundedI1
tff(fact_914_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) = B3 ) ) ) ).

% sup.absorb_iff2
tff(fact_915_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) = A4 ) ) ) ).

% sup.absorb_iff1
tff(fact_916_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3))) ) ).

% sup.cobounded2
tff(fact_917_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3))) ) ).

% sup.cobounded1
tff(fact_918_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
        <=> ( A4 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) ) ) ) ).

% sup.order_iff
tff(fact_919_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B3),C2)),A4)) ) ) ) ).

% sup.boundedI
tff(fact_920_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B3),C2)),A4))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A4)) ) ) ) ).

% sup.boundedE
tff(fact_921_sup__absorb2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) = Y ) ) ) ).

% sup_absorb2
tff(fact_922_sup__absorb1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) = X2 ) ) ) ).

% sup_absorb1
tff(fact_923_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) = B3 ) ) ) ).

% sup.absorb2
tff(fact_924_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) = A4 ) ) ) ).

% sup.absorb1
tff(fact_925_sup__unique,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [F2: fun(A,fun(A,A)),X2: A,Y: A] :
          ( ! [X: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),F2,X),Y2)))
         => ( ! [X: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),aa(A,A,aa(A,fun(A,A),F2,X),Y2)))
           => ( ! [X: A,Y2: A,Z3: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z3),X))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F2,Y2),Z3)),X)) ) )
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) = aa(A,A,aa(A,fun(A,A),F2,X2),Y) ) ) ) ) ) ).

% sup_unique
tff(fact_926_sup_OorderI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ).

% sup.orderI
tff(fact_927_sup_OorderE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( A4 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) ) ) ) ).

% sup.orderE
tff(fact_928_le__iff__sup,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) = Y ) ) ) ).

% le_iff_sup
tff(fact_929_sup__least,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y: A,X2: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),X2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)),X2)) ) ) ) ).

% sup_least
tff(fact_930_sup__mono,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),D3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3)),aa(A,A,aa(A,fun(A,A),sup_sup(A),C2),D3))) ) ) ) ).

% sup_mono
tff(fact_931_sup_Omono,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A4: A,D3: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D3),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),C2),D3)),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3))) ) ) ) ).

% sup.mono
tff(fact_932_le__supI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3))) ) ) ).

% le_supI2
tff(fact_933_le__supI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3))) ) ) ).

% le_supI1
tff(fact_934_sup__ge2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y: A,X2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y))) ) ).

% sup_ge2
tff(fact_935_sup__ge1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y))) ) ).

% sup_ge1
tff(fact_936_le__supI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,X2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),X2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),X2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3)),X2)) ) ) ) ).

% le_supI
tff(fact_937_le__supE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,B3: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3)),X2))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),X2))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),X2)) ) ) ) ).

% le_supE
tff(fact_938_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y))) ) ).

% inf_sup_ord(3)
tff(fact_939_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [Y: A,X2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y))) ) ).

% inf_sup_ord(4)
tff(fact_940_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: set(A),C3: set(B),B2: set(A),D2: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),C3))),product_Sigma(A,B,B2,aTP_Lamp_bq(set(B),fun(A,set(B)),D2))))
    <=> ( ( A3 = bot_bot(set(A)) )
        | ( C3 = bot_bot(set(B)) )
        | ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
          & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),C3),D2)) ) ) ) ).

% times_subset_iff
tff(fact_941_inter__eq__subsetI,axiom,
    ! [A: $tType,S: set(A),S3: set(A),A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S),S3))
     => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),S3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),S3) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),S) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),S) ) ) ) ).

% inter_eq_subsetI
tff(fact_942_Int__mono,axiom,
    ! [A: $tType,A3: set(A),C3: set(A),B2: set(A),D2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),C3))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),D2))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),D2))) ) ) ).

% Int_mono
tff(fact_943_Int__lower1,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)),A3)) ).

% Int_lower1
tff(fact_944_Int__lower2,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)),B2)) ).

% Int_lower2
tff(fact_945_Int__absorb1,axiom,
    ! [A: $tType,B2: set(A),A3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),A3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = B2 ) ) ).

% Int_absorb1
tff(fact_946_Int__absorb2,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = A3 ) ) ).

% Int_absorb2
tff(fact_947_Int__greatest,axiom,
    ! [A: $tType,C3: set(A),A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),A3))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),B2))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))) ) ) ).

% Int_greatest
tff(fact_948_Int__Collect__mono,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),P: fun(A,bool),Q: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),A3))
           => ( pp(aa(A,bool,P,X))
             => pp(aa(A,bool,Q,X)) ) )
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,bool),set(A),collect(A),P))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),aa(fun(A,bool),set(A),collect(A),Q)))) ) ) ).

% Int_Collect_mono
tff(fact_949_case__prodD,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(B,bool)),A4: A,B3: B] :
      ( pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),F2),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3)))
     => pp(aa(B,bool,aa(A,fun(B,bool),F2,A4),B3)) ) ).

% case_prodD
tff(fact_950_case__prodE,axiom,
    ! [A: $tType,B: $tType,C2: fun(A,fun(B,bool)),P5: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),C2),P5))
     => ~ ! [X: A,Y2: B] :
            ( ( P5 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y2) )
           => ~ pp(aa(B,bool,aa(A,fun(B,bool),C2,X),Y2)) ) ) ).

% case_prodE
tff(fact_951_inj__on__convol__ident,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),X5: set(A)] : inj_on(A,product_prod(A,B),aTP_Lamp_dm(fun(A,B),fun(A,product_prod(A,B)),F2),X5) ).

% inj_on_convol_ident
tff(fact_952_inj__Pair_I2_J,axiom,
    ! [B: $tType,A: $tType,C2: fun(A,B),S: set(A)] : inj_on(A,product_prod(B,A),aTP_Lamp_dn(fun(A,B),fun(A,product_prod(B,A)),C2),S) ).

% inj_Pair(2)
tff(fact_953_inj__Pair_I1_J,axiom,
    ! [B: $tType,A: $tType,C2: fun(A,B),S: set(A)] : inj_on(A,product_prod(A,B),aTP_Lamp_dm(fun(A,B),fun(A,product_prod(A,B)),C2),S) ).

% inj_Pair(1)
tff(fact_954_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A4: A,A3: set(A)] : inj_on(A,A,aTP_Lamp_do(A,fun(A,A),A4),A3) ) ).

% inj_on_add'
tff(fact_955_Collect__case__prod__Sigma,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),Q: fun(A,fun(B,bool))] : ( aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aTP_Lamp_dp(fun(A,bool),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),P),Q))) = product_Sigma(A,B,aa(fun(A,bool),set(A),collect(A),P),aTP_Lamp_dq(fun(A,fun(B,bool)),fun(A,set(B)),Q)) ) ).

% Collect_case_prod_Sigma
tff(fact_956_case__prodE2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Q: fun(A,bool),P: fun(B,fun(C,A)),Z2: product_prod(B,C)] :
      ( pp(aa(A,bool,Q,aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),P),Z2)))
     => ~ ! [X: B,Y2: C] :
            ( ( Z2 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y2) )
           => ~ pp(aa(A,bool,Q,aa(C,A,aa(B,fun(C,A),P,X),Y2))) ) ) ).

% case_prodE2
tff(fact_957_case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(product_prod(A,B),C)] : ( aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),aTP_Lamp_dr(fun(product_prod(A,B),C),fun(A,fun(B,C)),F2)) = F2 ) ).

% case_prod_eta
tff(fact_958_cond__case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(A,fun(B,C)),G: fun(product_prod(A,B),C)] :
      ( ! [X: A,Y2: B] : ( aa(B,C,aa(A,fun(B,C),F2,X),Y2) = aa(product_prod(A,B),C,G,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y2)) )
     => ( aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F2) = G ) ) ).

% cond_case_prod_eta
tff(fact_959_Collect__conv__if,axiom,
    ! [A: $tType,P: fun(A,bool),A4: A] :
      ( ( pp(aa(A,bool,P,A4))
       => ( aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_ds(fun(A,bool),fun(A,fun(A,bool)),P),A4)) = aa(set(A),set(A),insert(A,A4),bot_bot(set(A))) ) )
      & ( ~ pp(aa(A,bool,P,A4))
       => ( aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_ds(fun(A,bool),fun(A,fun(A,bool)),P),A4)) = bot_bot(set(A)) ) ) ) ).

% Collect_conv_if
tff(fact_960_Collect__conv__if2,axiom,
    ! [A: $tType,P: fun(A,bool),A4: A] :
      ( ( pp(aa(A,bool,P,A4))
       => ( aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_dt(fun(A,bool),fun(A,fun(A,bool)),P),A4)) = aa(set(A),set(A),insert(A,A4),bot_bot(set(A))) ) )
      & ( ~ pp(aa(A,bool,P,A4))
       => ( aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_dt(fun(A,bool),fun(A,fun(A,bool)),P),A4)) = bot_bot(set(A)) ) ) ) ).

% Collect_conv_if2
tff(fact_961_insert__def,axiom,
    ! [A: $tType,A4: A,B2: set(A)] : ( aa(set(A),set(A),insert(A,A4),B2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_ct(A,fun(A,bool),A4))),B2) ) ).

% insert_def
tff(fact_962_fn__snd__conv,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: fun(B,C)] : ( aTP_Lamp_du(fun(B,C),fun(product_prod(A,B),C),F2) = aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),aTP_Lamp_dv(fun(B,C),fun(A,fun(B,C)),F2)) ) ).

% fn_snd_conv
tff(fact_963_snd__def,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod(A,B)] : ( aa(product_prod(A,B),B,product_snd(A,B),Prod) = aa(product_prod(A,B),B,aa(fun(A,fun(B,B)),fun(product_prod(A,B),B),product_case_prod(A,B,B),aTP_Lamp_dw(A,fun(B,B))),Prod) ) ).

% snd_def
tff(fact_964_Id__on__def_H,axiom,
    ! [A: $tType,A3: fun(A,bool)] : ( id_on(A,aa(fun(A,bool),set(A),collect(A),A3)) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aTP_Lamp_dx(fun(A,bool),fun(A,fun(A,bool)),A3))) ) ).

% Id_on_def'
tff(fact_965_subset__fst__snd,axiom,
    ! [B: $tType,A: $tType,A3: set(product_prod(A,B))] : pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),A3),product_Sigma(A,B,aa(set(product_prod(A,B)),set(A),image2(product_prod(A,B),A,product_fst(A,B)),A3),aTP_Lamp_dy(set(product_prod(A,B)),fun(A,set(B)),A3)))) ).

% subset_fst_snd
tff(fact_966_inj__on__mult,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A4: A,A3: set(A)] :
          ( ( A4 != zero_zero(A) )
         => inj_on(A,A,aa(A,fun(A,A),times_times(A),A4),A3) ) ) ).

% inj_on_mult
tff(fact_967_group_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( group(A,F2,Z2,Inverse)
     => semigroup(A,F2) ) ).

% group.axioms(1)
tff(fact_968_singleton__Un__iff,axiom,
    ! [A: $tType,X2: A,A3: set(A),B2: set(A)] :
      ( ( aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2) )
    <=> ( ( ( A3 = bot_bot(set(A)) )
          & ( B2 = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) )
        | ( ( A3 = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) )
          & ( B2 = bot_bot(set(A)) ) )
        | ( ( A3 = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) )
          & ( B2 = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ) ) ) ).

% singleton_Un_iff
tff(fact_969_Un__singleton__iff,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),X2: A] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) )
    <=> ( ( ( A3 = bot_bot(set(A)) )
          & ( B2 = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) )
        | ( ( A3 = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) )
          & ( B2 = bot_bot(set(A)) ) )
        | ( ( A3 = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) )
          & ( B2 = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ) ) ) ).

% Un_singleton_iff
tff(fact_970_insert__is__Un,axiom,
    ! [A: $tType,A4: A,A3: set(A)] : ( aa(set(A),set(A),insert(A,A4),A3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))),A3) ) ).

% insert_is_Un
tff(fact_971_add__decreasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),B3)) ) ) ) ).

% add_decreasing
tff(fact_972_add__increasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2))) ) ) ) ).

% add_increasing
tff(fact_973_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),B3)) ) ) ) ).

% add_decreasing2
tff(fact_974_add__increasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2))) ) ) ) ).

% add_increasing2
tff(fact_975_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3))) ) ) ) ).

% add_nonneg_nonneg
tff(fact_976_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),zero_zero(A))) ) ) ) ).

% add_nonpos_nonpos
tff(fact_977_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y))
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y) = zero_zero(A) )
            <=> ( ( X2 = zero_zero(A) )
                & ( Y = zero_zero(A) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
tff(fact_978_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),zero_zero(A)))
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y) = zero_zero(A) )
            <=> ( ( X2 = zero_zero(A) )
                & ( Y = zero_zero(A) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
tff(fact_979_Diff__insert,axiom,
    ! [A: $tType,A3: set(A),A4: A,B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2)),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) ) ).

% Diff_insert
tff(fact_980_insert__Diff,axiom,
    ! [A: $tType,A4: A,A3: set(A)] :
      ( pp(aa(set(A),bool,member(A,A4),A3))
     => ( aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))) = A3 ) ) ).

% insert_Diff
tff(fact_981_Diff__insert2,axiom,
    ! [A: $tType,A3: set(A),A4: A,B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))),B2) ) ).

% Diff_insert2
tff(fact_982_Diff__insert__absorb,axiom,
    ! [A: $tType,X2: A,A3: set(A)] :
      ( ~ pp(aa(set(A),bool,member(A,X2),A3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert(A,X2),A3)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = A3 ) ) ).

% Diff_insert_absorb
tff(fact_983_insert__minus__eq,axiom,
    ! [A: $tType,X2: A,Y: A,A3: set(A)] :
      ( ( X2 != Y )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert(A,X2),A3)),aa(set(A),set(A),insert(A,Y),bot_bot(set(A)))) = aa(set(A),set(A),insert(A,X2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Y),bot_bot(set(A))))) ) ) ).

% insert_minus_eq
tff(fact_984_set__minus__singleton__eq,axiom,
    ! [A: $tType,X2: A,X5: set(A)] :
      ( ~ pp(aa(set(A),bool,member(A,X2),X5))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),X5),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = X5 ) ) ).

% set_minus_singleton_eq
tff(fact_985_in__image__insert__iff,axiom,
    ! [A: $tType,B2: set(set(A)),X2: A,A3: set(A)] :
      ( ! [C6: set(A)] :
          ( pp(aa(set(set(A)),bool,member(set(A),C6),B2))
         => ~ pp(aa(set(A),bool,member(A,X2),C6)) )
     => ( pp(aa(set(set(A)),bool,member(set(A),A3),aa(set(set(A)),set(set(A)),image2(set(A),set(A),insert(A,X2)),B2)))
      <=> ( pp(aa(set(A),bool,member(A,X2),A3))
          & pp(aa(set(set(A)),bool,member(set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),B2)) ) ) ) ).

% in_image_insert_iff
tff(fact_986_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordere2520102378445227354miring(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3))) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
tff(fact_987_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),zero_zero(A))) ) ) ) ) ).

% zero_le_mult_iff
tff(fact_988_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)),zero_zero(A))) ) ) ) ).

% mult_nonneg_nonpos2
tff(fact_989_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),zero_zero(A))) ) ) ) ).

% mult_nonpos_nonneg
tff(fact_990_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),zero_zero(A))) ) ) ) ).

% mult_nonneg_nonpos
tff(fact_991_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3))) ) ) ) ).

% mult_nonneg_nonneg
tff(fact_992_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A4: A,B3: A] :
          ( ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),zero_zero(A))) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3)) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),zero_zero(A))) ) ) ).

% split_mult_neg_le
tff(fact_993_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),zero_zero(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),zero_zero(A))) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3)) ) ) ) ) ).

% mult_le_0_iff
tff(fact_994_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2))) ) ) ) ).

% mult_right_mono
tff(fact_995_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2))) ) ) ) ).

% mult_right_mono_neg
tff(fact_996_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3))) ) ) ) ).

% mult_left_mono
tff(fact_997_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3))) ) ) ) ).

% mult_nonpos_nonpos
tff(fact_998_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3))) ) ) ) ).

% mult_left_mono_neg
tff(fact_999_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A4: A,B3: A] :
          ( ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),zero_zero(A))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3))) ) ) ).

% split_mult_pos_le
tff(fact_1000_zero__le__square,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),A4))) ) ).

% zero_le_square
tff(fact_1001_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),D3))) ) ) ) ) ) ).

% mult_mono'
tff(fact_1002_mult__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),D3))) ) ) ) ) ) ).

% mult_mono
tff(fact_1003_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),zero_zero(A))) ) ).

% not_one_le_zero
tff(fact_1004_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),one_one(A))) ) ).

% linordered_nonzero_semiring_class.zero_le_one
tff(fact_1005_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),one_one(A))) ) ).

% zero_less_one_class.zero_le_one
tff(fact_1006_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),zero_zero(A))) ) ) ).

% le_iff_diff_le_0
tff(fact_1007_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I2: A,K: A,N: A,J2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),N))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),N),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),N))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),N),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),N),K)),J2)) ) ) ) ) ) ).

% add_le_add_imp_diff_le
tff(fact_1008_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I2: A,K: A,N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),N))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I2),aa(A,A,aa(A,fun(A,A),minus_minus(A),N),K))) ) ) ).

% add_le_imp_le_diff
tff(fact_1009_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
           => ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4) = C2 )
            <=> ( B3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
tff(fact_1010_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)) = B3 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
tff(fact_1011_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4)),B3) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
tff(fact_1012_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)),C2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
tff(fact_1013_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)),A4) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
tff(fact_1014_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3)),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
tff(fact_1015_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3)),A4) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
tff(fact_1016_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4)),B3)) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
tff(fact_1017_le__add__diff,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)),A4))) ) ) ).

% le_add_diff
tff(fact_1018_ordered__cancel__comm__monoid__diff__class_Odiff__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)),A4) = B3 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add
tff(fact_1019_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),C2)) ) ) ).

% le_diff_eq
tff(fact_1020_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),C2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3))) ) ) ).

% diff_le_eq
tff(fact_1021_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y) = bot_bot(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y)) ) ) ).

% diff_shunt_var
tff(fact_1022_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% le_minus_one_simps(4)
tff(fact_1023_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A))) ) ).

% le_minus_one_simps(2)
tff(fact_1024_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A,Z2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2))),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Z2)))) ) ).

% distrib_sup_le
tff(fact_1025_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X2: A,Y: A,Z2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Z2))),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)))) ) ).

% distrib_inf_le
tff(fact_1026_vimage__singleton__eq,axiom,
    ! [A: $tType,B: $tType,A4: A,F2: fun(A,B),B3: B] :
      ( pp(aa(set(A),bool,member(A,A4),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))))
    <=> ( aa(A,B,F2,A4) = B3 ) ) ).

% vimage_singleton_eq
tff(fact_1027_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: set(B),B2: set(B)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image2(B,A,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),image2(B,A,F2),A3)),aa(set(B),set(A),image2(B,A,F2),B2)))) ).

% image_Int_subset
tff(fact_1028_disjoint__mono,axiom,
    ! [A: $tType,A4: set(A),A7: set(A),B3: set(A),B6: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),A7))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),B6))
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A7),B6) = bot_bot(set(A)) )
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) ) ) ) ) ).

% disjoint_mono
tff(fact_1029_subset__minus__empty,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2) = bot_bot(set(A)) ) ) ).

% subset_minus_empty
tff(fact_1030_inj__diff__right,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A] : inj_on(A,A,aTP_Lamp_cl(A,fun(A,A),A4),top_top(set(A))) ) ).

% inj_diff_right
tff(fact_1031_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),C3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B2),C3)) )
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),A3)) ) ).

% Un_Int_assoc_eq
tff(fact_1032_subset__Compl__self__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),A3)))
    <=> ( A3 = bot_bot(set(A)) ) ) ).

% subset_Compl_self_eq
tff(fact_1033_rel__restrict__def,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),A3: set(A)] : ( rel_restrict(A,R,A3) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(A),fun(A,fun(A,bool)),aTP_Lamp_dz(set(product_prod(A,A)),fun(set(A),fun(A,fun(A,bool))),R),A3))) ) ).

% rel_restrict_def
tff(fact_1034_in__prod__fst__sndI,axiom,
    ! [A: $tType,B: $tType,X2: product_prod(A,B),A3: set(A),B2: set(B)] :
      ( pp(aa(set(A),bool,member(A,aa(product_prod(A,B),A,product_fst(A,B),X2)),A3))
     => ( pp(aa(set(B),bool,member(B,aa(product_prod(A,B),B,product_snd(A,B),X2)),B2))
       => pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),X2),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)))) ) ) ).

% in_prod_fst_sndI
tff(fact_1035_mem__Times__iff,axiom,
    ! [A: $tType,B: $tType,X2: product_prod(A,B),A3: set(A),B2: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),X2),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))
    <=> ( pp(aa(set(A),bool,member(A,aa(product_prod(A,B),A,product_fst(A,B),X2)),A3))
        & pp(aa(set(B),bool,member(B,aa(product_prod(A,B),B,product_snd(A,B),X2)),B2)) ) ) ).

% mem_Times_iff
tff(fact_1036_image__constant__conv,axiom,
    ! [B: $tType,A: $tType,A3: set(B),C2: A] :
      ( ( ( A3 = bot_bot(set(B)) )
       => ( aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_cy(A,fun(B,A)),C2)),A3) = bot_bot(set(A)) ) )
      & ( ( A3 != bot_bot(set(B)) )
       => ( aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_cy(A,fun(B,A)),C2)),A3) = aa(set(A),set(A),insert(A,C2),bot_bot(set(A))) ) ) ) ).

% image_constant_conv
tff(fact_1037_image__constant,axiom,
    ! [A: $tType,B: $tType,X2: A,A3: set(A),C2: B] :
      ( pp(aa(set(A),bool,member(A,X2),A3))
     => ( aa(set(A),set(B),image2(A,B,aTP_Lamp_bm(B,fun(A,B),C2)),A3) = aa(set(B),set(B),insert(B,C2),bot_bot(set(B))) ) ) ).

% image_constant
tff(fact_1038_image__Int,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A3: set(A),B2: set(A)] :
      ( inj_on(A,B,F2,top_top(set(A)))
     => ( aa(set(A),set(B),image2(A,B,F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image2(A,B,F2),A3)),aa(set(A),set(B),image2(A,B,F2),B2)) ) ) ).

% image_Int
tff(fact_1039_Id__on__subset__Times,axiom,
    ! [A: $tType,A3: set(A)] : pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),id_on(A,A3)),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ).

% Id_on_subset_Times
tff(fact_1040_range__eq__singletonD,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),A4: A,X2: B] :
      ( ( aa(set(B),set(A),image2(B,A,F2),top_top(set(B))) = aa(set(A),set(A),insert(A,A4),bot_bot(set(A))) )
     => ( aa(B,A,F2,X2) = A4 ) ) ).

% range_eq_singletonD
tff(fact_1041_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X2: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)))) ) ).

% sum_squares_ge_zero
tff(fact_1042_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))),zero_zero(A)))
        <=> ( ( X2 = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_squares_le_zero_iff
tff(fact_1043_mult__left__le,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),A4)) ) ) ) ).

% mult_left_le
tff(fact_1044_mult__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),one_one(A))) ) ) ) ) ).

% mult_le_one
tff(fact_1045_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y)),X2)) ) ) ) ) ).

% mult_right_le_one_le
tff(fact_1046_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y),X2)),X2)) ) ) ) ) ).

% mult_left_le_one_le
tff(fact_1047_rtrancl__last__visit__node,axiom,
    ! [A: $tType,S2: A,S4: A,R: set(product_prod(A,A)),Sh: A] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),S2),S4)),transitive_rtrancl(A,R)))
     => ( ( ( S2 != Sh )
          & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),S2),S4)),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_ea(A,fun(A,set(A)),Sh)))))) )
        | ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),S2),Sh)),transitive_rtrancl(A,R)))
          & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Sh),S4)),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_ea(A,fun(A,set(A)),Sh)))))) ) ) ) ).

% rtrancl_last_visit_node
tff(fact_1048_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% le_minus_one_simps(3)
tff(fact_1049_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A))) ) ).

% le_minus_one_simps(1)
tff(fact_1050_le__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),E2)),D3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),E2)),C2)),D3)) ) ) ).

% le_add_iff1
tff(fact_1051_le__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),E2)),D3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)),E2)),D3))) ) ) ).

% le_add_iff2
tff(fact_1052_inf__shunt,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y) = bot_bot(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,uminus_uminus(A),Y))) ) ) ).

% inf_shunt
tff(fact_1053_sup__shunt,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y) = top_top(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),X2)),Y)) ) ) ).

% sup_shunt
tff(fact_1054_shunt1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)),Z2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),Y)),Z2))) ) ) ).

% shunt1
tff(fact_1055_shunt2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,uminus_uminus(A),Y))),Z2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2))) ) ) ).

% shunt2
tff(fact_1056_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [P5: A,Q3: A,R2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),P5),aa(A,A,aa(A,fun(A,A),sup_sup(A),Q3),R2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),P5),aa(A,A,uminus_uminus(A),Q3))),R2)) ) ) ).

% sup_neg_inf
tff(fact_1057_vimage__insert,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A4: B,B2: set(B)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),aa(set(B),set(B),insert(B,A4),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),B2)) ) ).

% vimage_insert
tff(fact_1058_Compl__insert,axiom,
    ! [A: $tType,X2: A,A3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert(A,X2),A3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A3)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) ) ).

% Compl_insert
tff(fact_1059_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) )
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),B2))) ) ).

% disjoint_eq_subset_Compl
tff(fact_1060_Restr__rtrancl__mono,axiom,
    ! [A: $tType,V: A,W2: A,E3: set(product_prod(A,A)),U2: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2)),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),E3),product_Sigma(A,A,U2,aTP_Lamp_cr(set(A),fun(A,set(A)),U2))))))
     => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2)),transitive_rtrancl(A,E3))) ) ).

% Restr_rtrancl_mono
tff(fact_1061_fst__image__Sigma,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: fun(A,set(B))] : ( aa(set(product_prod(A,B)),set(A),image2(product_prod(A,B),A,product_fst(A,B)),product_Sigma(A,B,A3,B2)) = aa(fun(A,bool),set(A),collect(A),aa(fun(A,set(B)),fun(A,bool),aTP_Lamp_eb(set(A),fun(fun(A,set(B)),fun(A,bool)),A3),B2)) ) ).

% fst_image_Sigma
tff(fact_1062_fs__contract,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(A,fun(B,C)),S: set(C)] : ( aa(set(product_prod(A,B)),set(A),image2(product_prod(A,B),A,product_fst(A,B)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(set(C),fun(product_prod(A,B),bool),aTP_Lamp_ec(fun(A,fun(B,C)),fun(set(C),fun(product_prod(A,B),bool)),F2),S))) = aa(fun(A,bool),set(A),collect(A),aa(set(C),fun(A,bool),aTP_Lamp_ed(fun(A,fun(B,C)),fun(set(C),fun(A,bool)),F2),S)) ) ).

% fs_contract
tff(fact_1063_homo__rel__restrict__mono,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),B2: set(A),A3: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R),product_Sigma(A,A,B2,aTP_Lamp_cr(set(A),fun(A,set(A)),B2))))
     => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),rel_restrict(A,R,A3)),product_Sigma(A,A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B2),A3),aa(set(A),fun(A,set(A)),aTP_Lamp_ee(set(A),fun(set(A),fun(A,set(A))),B2),A3)))) ) ).

% homo_rel_restrict_mono
tff(fact_1064_inj__on__disjoint__Un,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A3: set(A),G: fun(A,B),B2: set(A)] :
      ( inj_on(A,B,F2,A3)
     => ( inj_on(A,B,G,B2)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image2(A,B,F2),A3)),aa(set(A),set(B),image2(A,B,G),B2)) = bot_bot(set(B)) )
         => inj_on(A,B,aa(fun(A,B),fun(A,B),aa(set(A),fun(fun(A,B),fun(A,B)),aTP_Lamp_ef(fun(A,B),fun(set(A),fun(fun(A,B),fun(A,B))),F2),A3),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) ) ) ) ).

% inj_on_disjoint_Un
tff(fact_1065_convex__bound__le,axiom,
    ! [A: $tType] :
      ( linord6961819062388156250ring_1(A)
     => ! [X2: A,A4: A,Y: A,U: A,V: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),U))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),V))
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y))),A4)) ) ) ) ) ) ) ).

% convex_bound_le
tff(fact_1066_rtrancl__last__touch,axiom,
    ! [A: $tType,Q3: A,Q5: A,R: set(product_prod(A,A)),S: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Q5)),transitive_rtrancl(A,R)))
     => ( pp(aa(set(A),bool,member(A,Q3),S))
       => ~ ! [Qt: A] :
              ( pp(aa(set(A),bool,member(A,Qt),S))
             => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Qt)),transitive_rtrancl(A,R)))
               => ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Qt),Q5)),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_cr(set(A),fun(A,set(A)),S)))))) ) ) ) ) ).

% rtrancl_last_touch
tff(fact_1067_rtrancl__last__visit_H,axiom,
    ! [A: $tType,Q3: A,Q5: A,R: set(product_prod(A,A)),S: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Q5)),transitive_rtrancl(A,R)))
     => ( ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Q5)),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_cr(set(A),fun(A,set(A)),S))))))
       => ~ ! [Qt: A] :
              ( pp(aa(set(A),bool,member(A,Qt),S))
             => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Qt)),transitive_rtrancl(A,R)))
               => ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Qt),Q5)),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_cr(set(A),fun(A,set(A)),S)))))) ) ) ) ) ).

% rtrancl_last_visit'
tff(fact_1068_inj__mult__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A4: A] :
          ( inj_on(A,A,aa(A,fun(A,A),times_times(A),A4),top_top(set(A)))
        <=> ( A4 != zero_zero(A) ) ) ) ).

% inj_mult_left
tff(fact_1069_rtrancl__insert,axiom,
    ! [A: $tType,A4: A,B3: A,R2: set(product_prod(A,A))] : ( transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),R2)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_rtrancl(A,R2)),aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool))),aTP_Lamp_eg(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool)))),A4),B3),R2)))) ) ).

% rtrancl_insert
tff(fact_1070_trancl__subset__Sigma__aux,axiom,
    ! [A: $tType,A4: A,B3: A,R2: set(product_prod(A,A)),A3: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),transitive_rtrancl(A,R2)))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))))
       => ( ( A4 = B3 )
          | pp(aa(set(A),bool,member(A,A4),A3)) ) ) ) ).

% trancl_subset_Sigma_aux
tff(fact_1071_inj__on__iff__surj,axiom,
    ! [B: $tType,A: $tType,A3: set(A),A10: set(B)] :
      ( ( A3 != bot_bot(set(A)) )
     => ( ? [F8: fun(A,B)] :
            ( inj_on(A,B,F8,A3)
            & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image2(A,B,F8),A3)),A10)) )
      <=> ? [G2: fun(B,A)] : ( aa(set(B),set(A),image2(B,A,G2),A10) = A3 ) ) ) ).

% inj_on_iff_surj
tff(fact_1072_Restr__subset,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
     => ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,B2,aTP_Lamp_cr(set(A),fun(A,set(A)),B2)))),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))) ) ) ).

% Restr_subset
tff(fact_1073_exE__realizer,axiom,
    ! [C: $tType,A: $tType,B: $tType,P: fun(A,fun(B,bool)),P5: product_prod(B,A),Q: fun(C,bool),F2: fun(B,fun(A,C))] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),P,aa(product_prod(B,A),A,product_snd(B,A),P5)),aa(product_prod(B,A),B,product_fst(B,A),P5)))
     => ( ! [X: B,Y2: A] :
            ( pp(aa(B,bool,aa(A,fun(B,bool),P,Y2),X))
           => pp(aa(C,bool,Q,aa(A,C,aa(B,fun(A,C),F2,X),Y2))) )
       => pp(aa(C,bool,Q,aa(product_prod(B,A),C,aa(fun(B,fun(A,C)),fun(product_prod(B,A),C),product_case_prod(B,A,C),F2),P5))) ) ) ).

% exE_realizer
tff(fact_1074_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => inj_on(A,A,aTP_Lamp_eh(A,A),top_top(set(A))) ) ).

% sorted_list_of_set.inj_on
tff(fact_1075_is__singleton__the__elem,axiom,
    ! [A: $tType,A3: set(A)] :
      ( is_singleton(A,A3)
    <=> ( A3 = aa(set(A),set(A),insert(A,the_elem(A,A3)),bot_bot(set(A))) ) ) ).

% is_singleton_the_elem
tff(fact_1076_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F2: fun(A,B),B2: set(B)] :
      ( ! [X: A] :
          ( pp(aa(A,bool,P,X))
         => pp(aa(set(B),bool,member(B,aa(A,B,F2,X)),B2)) )
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image2(A,B,F2),aa(fun(A,bool),set(A),collect(A),P))),B2)) ) ).

% image_Collect_subsetI
tff(fact_1077_less__by__empty,axiom,
    ! [A: $tType,A3: set(product_prod(A,A)),B2: set(product_prod(A,A))] :
      ( ( A3 = bot_bot(set(product_prod(A,A))) )
     => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),A3),B2)) ) ).

% less_by_empty
tff(fact_1078_mem__case__prodI2,axiom,
    ! [C: $tType,B: $tType,A: $tType,P5: product_prod(A,B),Z2: C,C2: fun(A,fun(B,set(C)))] :
      ( ! [A5: A,B4: B] :
          ( ( P5 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A5),B4) )
         => pp(aa(set(C),bool,member(C,Z2),aa(B,set(C),aa(A,fun(B,set(C)),C2,A5),B4))) )
     => pp(aa(set(C),bool,member(C,Z2),aa(product_prod(A,B),set(C),aa(fun(A,fun(B,set(C))),fun(product_prod(A,B),set(C)),product_case_prod(A,B,set(C)),C2),P5))) ) ).

% mem_case_prodI2
tff(fact_1079_mem__case__prodI,axiom,
    ! [A: $tType,B: $tType,C: $tType,Z2: A,C2: fun(B,fun(C,set(A))),A4: B,B3: C] :
      ( pp(aa(set(A),bool,member(A,Z2),aa(C,set(A),aa(B,fun(C,set(A)),C2,A4),B3)))
     => pp(aa(set(A),bool,member(A,Z2),aa(product_prod(B,C),set(A),aa(fun(B,fun(C,set(A))),fun(product_prod(B,C),set(A)),product_case_prod(B,C,set(A)),C2),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B3)))) ) ).

% mem_case_prodI
tff(fact_1080_case__prodI2_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P5: product_prod(A,B),C2: fun(A,fun(B,fun(C,bool))),X2: C] :
      ( ! [A5: A,B4: B] :
          ( ( aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A5),B4) = P5 )
         => pp(aa(C,bool,aa(B,fun(C,bool),aa(A,fun(B,fun(C,bool)),C2,A5),B4),X2)) )
     => pp(aa(C,bool,aa(product_prod(A,B),fun(C,bool),aa(fun(A,fun(B,fun(C,bool))),fun(product_prod(A,B),fun(C,bool)),product_case_prod(A,B,fun(C,bool)),C2),P5),X2)) ) ).

% case_prodI2'
tff(fact_1081_is__singletonI,axiom,
    ! [A: $tType,X2: A] : is_singleton(A,aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) ).

% is_singletonI
tff(fact_1082_case__prod__Pair__iden,axiom,
    ! [B: $tType,A: $tType,P5: product_prod(A,B)] : ( aa(product_prod(A,B),product_prod(A,B),aa(fun(A,fun(B,product_prod(A,B))),fun(product_prod(A,B),product_prod(A,B)),product_case_prod(A,B,product_prod(A,B)),product_Pair(A,B)),P5) = P5 ) ).

% case_prod_Pair_iden
tff(fact_1083_swap__inj__on,axiom,
    ! [B: $tType,A: $tType,A3: set(product_prod(A,B))] : inj_on(product_prod(A,B),product_prod(B,A),aa(fun(A,fun(B,product_prod(B,A))),fun(product_prod(A,B),product_prod(B,A)),product_case_prod(A,B,product_prod(B,A)),aTP_Lamp_ei(A,fun(B,product_prod(B,A)))),A3) ).

% swap_inj_on
tff(fact_1084_relH__subset,axiom,
    ! [Bs: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit),As2: set(nat)] :
      ( relH(Bs,H2,H5)
     => ( pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),As2),Bs))
       => relH(As2,H2,H5) ) ) ).

% relH_subset
tff(fact_1085_case__prodE_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: fun(A,fun(B,fun(C,bool))),P5: product_prod(A,B),Z2: C] :
      ( pp(aa(C,bool,aa(product_prod(A,B),fun(C,bool),aa(fun(A,fun(B,fun(C,bool))),fun(product_prod(A,B),fun(C,bool)),product_case_prod(A,B,fun(C,bool)),C2),P5),Z2))
     => ~ ! [X: A,Y2: B] :
            ( ( P5 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y2) )
           => ~ pp(aa(C,bool,aa(B,fun(C,bool),aa(A,fun(B,fun(C,bool)),C2,X),Y2),Z2)) ) ) ).

% case_prodE'
tff(fact_1086_case__prodD_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,R: fun(A,fun(B,fun(C,bool))),A4: A,B3: B,C2: C] :
      ( pp(aa(C,bool,aa(product_prod(A,B),fun(C,bool),aa(fun(A,fun(B,fun(C,bool))),fun(product_prod(A,B),fun(C,bool)),product_case_prod(A,B,fun(C,bool)),R),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3)),C2))
     => pp(aa(C,bool,aa(B,fun(C,bool),aa(A,fun(B,fun(C,bool)),R,A4),B3),C2)) ) ).

% case_prodD'
tff(fact_1087_less__eq__set__def,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
    <=> pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),B2))) ) ).

% less_eq_set_def
tff(fact_1088_pred__subset__eq,axiom,
    ! [A: $tType,R: set(A),S: set(A)] :
      ( pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),R)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),S)))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),R),S)) ) ).

% pred_subset_eq
tff(fact_1089_less__eq__assn__def,axiom,
    ! [A4: assn,B3: assn] :
      ( pp(aa(assn,bool,aa(assn,fun(assn,bool),ord_less_eq(assn),A4),B3))
    <=> ( A4 = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A4),B3) ) ) ).

% less_eq_assn_def
tff(fact_1090_in__range__subset,axiom,
    ! [As2: set(nat),As3: set(nat),H2: heap_ext(product_unit)] :
      ( pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),As2),As3))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3)))
       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))) ) ) ).

% in_range_subset
tff(fact_1091_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S: set(product_prod(A,B))] :
      ( pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),R)),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),S)))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),R),S)) ) ).

% pred_subset_eq2
tff(fact_1092_is__singletonI_H,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( A3 != bot_bot(set(A)) )
     => ( ! [X: A,Y2: A] :
            ( pp(aa(set(A),bool,member(A,X),A3))
           => ( pp(aa(set(A),bool,member(A,Y2),A3))
             => ( X = Y2 ) ) )
       => is_singleton(A,A3) ) ) ).

% is_singletonI'
tff(fact_1093_swap__product,axiom,
    ! [A: $tType,B: $tType,A3: set(B),B2: set(A)] : ( aa(set(product_prod(B,A)),set(product_prod(A,B)),image2(product_prod(B,A),product_prod(A,B),aa(fun(B,fun(A,product_prod(A,B))),fun(product_prod(B,A),product_prod(A,B)),product_case_prod(B,A,product_prod(A,B)),aTP_Lamp_ej(B,fun(A,product_prod(A,B))))),product_Sigma(B,A,A3,aTP_Lamp_bv(set(A),fun(B,set(A)),B2))) = product_Sigma(A,B,B2,aTP_Lamp_bq(set(B),fun(A,set(B)),A3)) ) ).

% swap_product
tff(fact_1094_image__paired__Times,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F2: fun(C,A),G: fun(D,B),A3: set(C),B2: set(D)] : ( aa(set(product_prod(C,D)),set(product_prod(A,B)),image2(product_prod(C,D),product_prod(A,B),aa(fun(C,fun(D,product_prod(A,B))),fun(product_prod(C,D),product_prod(A,B)),product_case_prod(C,D,product_prod(A,B)),aa(fun(D,B),fun(C,fun(D,product_prod(A,B))),aTP_Lamp_ek(fun(C,A),fun(fun(D,B),fun(C,fun(D,product_prod(A,B)))),F2),G))),product_Sigma(C,D,A3,aTP_Lamp_el(set(D),fun(C,set(D)),B2))) = product_Sigma(A,B,aa(set(C),set(A),image2(C,A,F2),A3),aa(set(D),fun(A,set(B)),aTP_Lamp_em(fun(D,B),fun(set(D),fun(A,set(B))),G),B2)) ) ).

% image_paired_Times
tff(fact_1095_Collect__restrict,axiom,
    ! [A: $tType,X5: set(A),P: fun(A,bool)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_dh(set(A),fun(fun(A,bool),fun(A,bool)),X5),P))),X5)) ).

% Collect_restrict
tff(fact_1096_prop__restrict,axiom,
    ! [A: $tType,X2: A,Z4: set(A),X5: set(A),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,member(A,X2),Z4))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Z4),aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_dh(set(A),fun(fun(A,bool),fun(A,bool)),X5),P))))
       => pp(aa(A,bool,P,X2)) ) ) ).

% prop_restrict
tff(fact_1097_is__singletonE,axiom,
    ! [A: $tType,A3: set(A)] :
      ( is_singleton(A,A3)
     => ~ ! [X: A] : ( A3 != aa(set(A),set(A),insert(A,X),bot_bot(set(A))) ) ) ).

% is_singletonE
tff(fact_1098_is__singleton__def,axiom,
    ! [A: $tType,A3: set(A)] :
      ( is_singleton(A,A3)
    <=> ? [X3: A] : ( A3 = aa(set(A),set(A),insert(A,X3),bot_bot(set(A))) ) ) ).

% is_singleton_def
tff(fact_1099_mod__star__trueE_H,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),top_top(assn))),H2))
     => ~ ! [H3: product_prod(heap_ext(product_unit),set(nat))] :
            ( ( aa(product_prod(heap_ext(product_unit),set(nat)),heap_ext(product_unit),product_fst(heap_ext(product_unit),set(nat)),H3) = aa(product_prod(heap_ext(product_unit),set(nat)),heap_ext(product_unit),product_fst(heap_ext(product_unit),set(nat)),H2) )
           => ( pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H3)),aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2)))
             => ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H3)) ) ) ) ).

% mod_star_trueE'
tff(fact_1100_subset__emptyI,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ! [X: A] : ~ pp(aa(set(A),bool,member(A,X),A3))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),bot_bot(set(A)))) ) ).

% subset_emptyI
tff(fact_1101_range__prod,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(C,product_prod(A,B))] : pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),aa(set(C),set(product_prod(A,B)),image2(C,product_prod(A,B),F2),top_top(set(C)))),product_Sigma(A,B,aa(set(C),set(A),image2(C,A,aa(fun(C,product_prod(A,B)),fun(C,A),comp(product_prod(A,B),A,C,product_fst(A,B)),F2)),top_top(set(C))),aTP_Lamp_en(fun(C,product_prod(A,B)),fun(A,set(B)),F2)))) ).

% range_prod
tff(fact_1102_Gr__incl,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F2: fun(A,B),B2: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),bNF_Gr(A,B,A3,F2)),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))
    <=> pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image2(A,B,F2),A3)),B2)) ) ).

% Gr_incl
tff(fact_1103_inj__on__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A3: set(A),A4: B] :
      ( inj_on(A,B,F2,A3)
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))),A3)),aa(set(A),set(A),insert(A,the(A,aa(B,fun(A,bool),aa(set(A),fun(B,fun(A,bool)),aTP_Lamp_eo(fun(A,B),fun(set(A),fun(B,fun(A,bool))),F2),A3),A4))),bot_bot(set(A))))) ) ).

% inj_on_vimage_singleton
tff(fact_1104_inj__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A4: B] :
      ( inj_on(A,B,F2,top_top(set(A)))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))),aa(set(A),set(A),insert(A,the(A,aa(B,fun(A,bool),aTP_Lamp_ep(fun(A,B),fun(B,fun(A,bool)),F2),A4))),bot_bot(set(A))))) ) ).

% inj_vimage_singleton
tff(fact_1105_vimage__Times,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(A,product_prod(B,C)),A3: set(B),B2: set(C)] : ( aa(set(product_prod(B,C)),set(A),aa(fun(A,product_prod(B,C)),fun(set(product_prod(B,C)),set(A)),vimage(A,product_prod(B,C)),F2),product_Sigma(B,C,A3,aTP_Lamp_eq(set(C),fun(B,set(C)),B2))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aa(fun(A,product_prod(B,C)),fun(A,B),comp(product_prod(B,C),B,A,product_fst(B,C)),F2)),A3)),aa(set(C),set(A),aa(fun(A,C),fun(set(C),set(A)),vimage(A,C),aa(fun(A,product_prod(B,C)),fun(A,C),comp(product_prod(B,C),C,A,product_snd(B,C)),F2)),B2)) ) ).

% vimage_Times
tff(fact_1106_total__on__singleton,axiom,
    ! [A: $tType,X2: A] : total_on(A,aa(set(A),set(A),insert(A,X2),bot_bot(set(A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2)),bot_bot(set(product_prod(A,A))))) ).

% total_on_singleton
tff(fact_1107_inj__graph,axiom,
    ! [B: $tType,A: $tType] : inj_on(fun(A,B),set(product_prod(A,B)),aTP_Lamp_es(fun(A,B),set(product_prod(A,B))),top_top(set(fun(A,B)))) ).

% inj_graph
tff(fact_1108_group_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( semigroup(A,F2)
     => ( group_axioms(A,F2,Z2,Inverse)
       => group(A,F2,Z2,Inverse) ) ) ).

% group.intro
tff(fact_1109_group__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( group(A,F2,Z2,Inverse)
    <=> ( semigroup(A,F2)
        & group_axioms(A,F2,Z2,Inverse) ) ) ).

% group_def
tff(fact_1110_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool)),Q: fun(A,fun(B,bool))] :
      ( ! [X: A,Y2: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),P,X),Y2))
         => pp(aa(B,bool,aa(A,fun(B,bool),Q,X),Y2)) )
     => pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),P),Q)) ) ).

% predicate2I
tff(fact_1111_predicate1I,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( ! [X: A] :
          ( pp(aa(A,bool,P,X))
         => pp(aa(A,bool,Q,X)) )
     => pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),P),Q)) ) ).

% predicate1I
tff(fact_1112_The__split__eq,axiom,
    ! [A: $tType,B: $tType,X2: A,Y: B] : ( the(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(B,fun(A,fun(B,bool)),aTP_Lamp_et(A,fun(B,fun(A,fun(B,bool))),X2),Y))) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y) ) ).

% The_split_eq
tff(fact_1113_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,bool)),X2: A,Y: B,Q: fun(A,fun(B,bool))] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),P,X2),Y))
     => ( pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),P),Q))
       => pp(aa(B,bool,aa(A,fun(B,bool),Q,X2),Y)) ) ) ).

% rev_predicate2D
tff(fact_1114_rev__predicate1D,axiom,
    ! [A: $tType,P: fun(A,bool),X2: A,Q: fun(A,bool)] :
      ( pp(aa(A,bool,P,X2))
     => ( pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),P),Q))
       => pp(aa(A,bool,Q,X2)) ) ) ).

% rev_predicate1D
tff(fact_1115_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,bool)),Q: fun(A,fun(B,bool)),X2: A,Y: B] :
      ( pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),P),Q))
     => ( pp(aa(B,bool,aa(A,fun(B,bool),P,X2),Y))
       => pp(aa(B,bool,aa(A,fun(B,bool),Q,X2),Y)) ) ) ).

% predicate2D
tff(fact_1116_predicate1D,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),X2: A] :
      ( pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),P),Q))
     => ( pp(aa(A,bool,P,X2))
       => pp(aa(A,bool,Q,X2)) ) ) ).

% predicate1D
tff(fact_1117_eq__subset,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool))] : pp(aa(fun(A,fun(A,bool)),bool,aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),bool),ord_less_eq(fun(A,fun(A,bool))),fequal(A)),aTP_Lamp_eu(fun(A,fun(A,bool)),fun(A,fun(A,bool)),P))) ).

% eq_subset
tff(fact_1118_group__axioms_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( ! [A5: A] : ( aa(A,A,aa(A,fun(A,A),F2,Z2),A5) = A5 )
     => ( ! [A5: A] : ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,Inverse,A5)),A5) = Z2 )
       => group_axioms(A,F2,Z2,Inverse) ) ) ).

% group_axioms.intro
tff(fact_1119_group__axioms__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( group_axioms(A,F2,Z2,Inverse)
    <=> ( ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F2,Z2),A6) = A6 )
        & ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,Inverse,A6)),A6) = Z2 ) ) ) ).

% group_axioms_def
tff(fact_1120_total__on__empty,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : total_on(A,bot_bot(set(A)),R2) ).

% total_on_empty
tff(fact_1121_group_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( group(A,F2,Z2,Inverse)
     => group_axioms(A,F2,Z2,Inverse) ) ).

% group.axioms(2)
tff(fact_1122_The__case__prod,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool))] : ( the(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),P)) = the(product_prod(A,B),aTP_Lamp_ev(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),P)) ) ).

% The_case_prod
tff(fact_1123_the__elem__def,axiom,
    ! [A: $tType,X5: set(A)] : ( the_elem(A,X5) = the(A,aTP_Lamp_ew(set(A),fun(A,bool),X5)) ) ).

% the_elem_def
tff(fact_1124_fst__snd__flip,axiom,
    ! [B: $tType,A: $tType,Xy: product_prod(A,B)] : ( aa(product_prod(A,B),A,product_fst(A,B),Xy) = aa(product_prod(A,B),A,aa(fun(product_prod(A,B),product_prod(B,A)),fun(product_prod(A,B),A),comp(product_prod(B,A),A,product_prod(A,B),product_snd(B,A)),aa(fun(A,fun(B,product_prod(B,A))),fun(product_prod(A,B),product_prod(B,A)),product_case_prod(A,B,product_prod(B,A)),aTP_Lamp_ei(A,fun(B,product_prod(B,A))))),Xy) ) ).

% fst_snd_flip
tff(fact_1125_snd__fst__flip,axiom,
    ! [A: $tType,B: $tType,Xy: product_prod(B,A)] : ( aa(product_prod(B,A),A,product_snd(B,A),Xy) = aa(product_prod(B,A),A,aa(fun(product_prod(B,A),product_prod(A,B)),fun(product_prod(B,A),A),comp(product_prod(A,B),A,product_prod(B,A),product_fst(A,B)),aa(fun(B,fun(A,product_prod(A,B))),fun(product_prod(B,A),product_prod(A,B)),product_case_prod(B,A,product_prod(A,B)),aTP_Lamp_ej(B,fun(A,product_prod(A,B))))),Xy) ) ).

% snd_fst_flip
tff(fact_1126_the__equality,axiom,
    ! [A: $tType,P: fun(A,bool),A4: A] :
      ( pp(aa(A,bool,P,A4))
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
           => ( X = A4 ) )
       => ( the(A,P) = A4 ) ) ) ).

% the_equality
tff(fact_1127_the__eq__trivial,axiom,
    ! [A: $tType,A4: A] : ( the(A,aTP_Lamp_ct(A,fun(A,bool),A4)) = A4 ) ).

% the_eq_trivial
tff(fact_1128_the__sym__eq__trivial,axiom,
    ! [A: $tType,X2: A] : ( the(A,aa(A,fun(A,bool),fequal(A),X2)) = X2 ) ).

% the_sym_eq_trivial
tff(fact_1129_Gr__def,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,B)] : ( bNF_Gr(A,B,A3,F2) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,B),fun(product_prod(A,B),bool),aTP_Lamp_ex(set(A),fun(fun(A,B),fun(product_prod(A,B),bool)),A3),F2)) ) ).

% Gr_def
tff(fact_1130_inj__on__apsnd,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: fun(B,C),A3: set(B)] :
      ( inj_on(product_prod(A,B),product_prod(A,C),aa(fun(B,C),fun(product_prod(A,B),product_prod(A,C)),product_apsnd(B,C,A),F2),product_Sigma(A,B,top_top(set(A)),aTP_Lamp_bq(set(B),fun(A,set(B)),A3)))
    <=> inj_on(B,C,F2,A3) ) ).

% inj_on_apsnd
tff(fact_1131_inj__on__apfst,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: fun(A,C),A3: set(A)] :
      ( inj_on(product_prod(A,B),product_prod(C,B),product_apfst(A,C,B,F2),product_Sigma(A,B,A3,aTP_Lamp_bp(A,set(B))))
    <=> inj_on(A,C,F2,A3) ) ).

% inj_on_apfst
tff(fact_1132_Field__insert,axiom,
    ! [A: $tType,A4: A,B3: A,R2: set(product_prod(A,A))] : ( field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),R2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))),field2(A,R2)) ) ).

% Field_insert
tff(fact_1133_Field__square,axiom,
    ! [A: $tType,X2: set(A)] : ( field2(A,product_Sigma(A,A,X2,aTP_Lamp_cr(set(A),fun(A,set(A)),X2))) = X2 ) ).

% Field_square
tff(fact_1134_Field__empty,axiom,
    ! [A: $tType] : ( field2(A,bot_bot(set(product_prod(A,A)))) = bot_bot(set(A)) ) ).

% Field_empty
tff(fact_1135_R__subset__Field,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R),product_Sigma(A,A,field2(A,R),aTP_Lamp_ey(set(product_prod(A,A)),fun(A,set(A)),R)))) ).

% R_subset_Field
tff(fact_1136_Restr__Field,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,field2(A,R2),aTP_Lamp_ey(set(product_prod(A,A)),fun(A,set(A)),R2))) = R2 ) ).

% Restr_Field
tff(fact_1137_rel__restrict__Int__empty,axiom,
    ! [A: $tType,A3: set(A),R: set(product_prod(A,A))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),field2(A,R)) = bot_bot(set(A)) )
     => ( rel_restrict(A,R,A3) = R ) ) ).

% rel_restrict_Int_empty
tff(fact_1138_Field__Restr__subset,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))))),A3)) ).

% Field_Restr_subset
tff(fact_1139_Total__Restr,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( total_on(A,field2(A,R2),R2)
     => total_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ).

% Total_Restr
tff(fact_1140_total__on__imp__Total__Restr,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A))] :
      ( total_on(A,A3,R2)
     => total_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ).

% total_on_imp_Total_Restr
tff(fact_1141_the1__equality,axiom,
    ! [A: $tType,P: fun(A,bool),A4: A] :
      ( ? [X4: A] :
          ( pp(aa(A,bool,P,X4))
          & ! [Y2: A] :
              ( pp(aa(A,bool,P,Y2))
             => ( Y2 = X4 ) ) )
     => ( pp(aa(A,bool,P,A4))
       => ( the(A,P) = A4 ) ) ) ).

% the1_equality
tff(fact_1142_the1I2,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( ? [X4: A] :
          ( pp(aa(A,bool,P,X4))
          & ! [Y2: A] :
              ( pp(aa(A,bool,P,Y2))
             => ( Y2 = X4 ) ) )
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
           => pp(aa(A,bool,Q,X)) )
       => pp(aa(A,bool,Q,the(A,P))) ) ) ).

% the1I2
tff(fact_1143_If__def,axiom,
    ! [A: $tType,P: bool,X2: A,Y: A] :
      ( ( pp(P)
       => ( X2 = the(A,aa(A,fun(A,bool),aa(A,fun(A,fun(A,bool)),aTP_Lamp_ez(bool,fun(A,fun(A,fun(A,bool))),P),X2),Y)) ) )
      & ( ~ pp(P)
       => ( Y = the(A,aa(A,fun(A,bool),aa(A,fun(A,fun(A,bool)),aTP_Lamp_ez(bool,fun(A,fun(A,fun(A,bool))),P),X2),Y)) ) ) ) ).

% If_def
tff(fact_1144_theI2,axiom,
    ! [A: $tType,P: fun(A,bool),A4: A,Q: fun(A,bool)] :
      ( pp(aa(A,bool,P,A4))
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
           => ( X = A4 ) )
       => ( ! [X: A] :
              ( pp(aa(A,bool,P,X))
             => pp(aa(A,bool,Q,X)) )
         => pp(aa(A,bool,Q,the(A,P))) ) ) ) ).

% theI2
tff(fact_1145_theI_H,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ? [X4: A] :
          ( pp(aa(A,bool,P,X4))
          & ! [Y2: A] :
              ( pp(aa(A,bool,P,Y2))
             => ( Y2 = X4 ) ) )
     => pp(aa(A,bool,P,the(A,P))) ) ).

% theI'
tff(fact_1146_theI,axiom,
    ! [A: $tType,P: fun(A,bool),A4: A] :
      ( pp(aa(A,bool,P,A4))
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
           => ( X = A4 ) )
       => pp(aa(A,bool,P,the(A,P))) ) ) ).

% theI
tff(fact_1147_Preorder__Restr,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( order_preorder_on(A,field2(A,R2),R2)
     => order_preorder_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ).

% Preorder_Restr
tff(fact_1148_remove__def,axiom,
    ! [A: $tType,X2: A,A3: set(A)] : ( aa(set(A),set(A),aa(A,fun(set(A),set(A)),remove(A),X2),A3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) ) ).

% remove_def
tff(fact_1149_Ex__inj__on__UNION__Sigma,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),I: set(B)] :
    ? [F9: fun(A,product_prod(B,A))] :
      ( inj_on(A,product_prod(B,A),F9,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I)))
      & pp(aa(set(product_prod(B,A)),bool,aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),bool),ord_less_eq(set(product_prod(B,A))),aa(set(A),set(product_prod(B,A)),image2(A,product_prod(B,A),F9),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I)))),product_Sigma(B,A,I,A3))) ) ).

% Ex_inj_on_UNION_Sigma
tff(fact_1150_trancl__multi__insert2,axiom,
    ! [A: $tType,A4: A,B3: A,R2: set(product_prod(A,A)),M2: A,X5: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R2),product_Sigma(A,A,aa(set(A),set(A),insert(A,M2),bot_bot(set(A))),aTP_Lamp_cr(set(A),fun(A,set(A)),X5))))))
     => ( ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),transitive_trancl(A,R2)))
       => ~ ! [X: A] :
              ( pp(aa(set(A),bool,member(A,X),X5))
             => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),M2)),transitive_rtrancl(A,R2)))
               => ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),B3)),transitive_rtrancl(A,R2))) ) ) ) ) ).

% trancl_multi_insert2
tff(fact_1151_trancl__multi__insert,axiom,
    ! [A: $tType,A4: A,B3: A,R2: set(product_prod(A,A)),X5: set(A),M2: A] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R2),product_Sigma(A,A,X5,aTP_Lamp_fa(A,fun(A,set(A)),M2))))))
     => ( ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),transitive_trancl(A,R2)))
       => ~ ! [X: A] :
              ( pp(aa(set(A),bool,member(A,X),X5))
             => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),X)),transitive_rtrancl(A,R2)))
               => ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),M2),B3)),transitive_rtrancl(A,R2))) ) ) ) ) ).

% trancl_multi_insert
tff(fact_1152_flat__lub__def,axiom,
    ! [A: $tType,A3: set(A),B3: A] :
      ( ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))))
       => ( aa(set(A),A,partial_flat_lub(A,B3),A3) = B3 ) )
      & ( ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))))
       => ( aa(set(A),A,partial_flat_lub(A,B3),A3) = the(A,aa(A,fun(A,bool),aTP_Lamp_fb(set(A),fun(A,fun(A,bool)),A3),B3)) ) ) ) ).

% flat_lub_def
tff(fact_1153_refl__on__singleton,axiom,
    ! [A: $tType,X2: A] : refl_on(A,aa(set(A),set(A),insert(A,X2),bot_bot(set(A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2)),bot_bot(set(product_prod(A,A))))) ).

% refl_on_singleton
tff(fact_1154_fun_Oin__rel,axiom,
    ! [A: $tType,B: $tType,D: $tType,R: fun(A,fun(B,bool)),A4: fun(D,A),B3: fun(D,B)] :
      ( pp(aa(fun(D,B),bool,aa(fun(D,A),fun(fun(D,B),bool),bNF_rel_fun(D,D,A,B,fequal(D),R),A4),B3))
    <=> ? [Z5: fun(D,product_prod(A,B))] :
          ( pp(aa(set(fun(D,product_prod(A,B))),bool,member(fun(D,product_prod(A,B)),Z5),aa(fun(fun(D,product_prod(A,B)),bool),set(fun(D,product_prod(A,B))),collect(fun(D,product_prod(A,B))),aTP_Lamp_fc(fun(A,fun(B,bool)),fun(fun(D,product_prod(A,B)),bool),R))))
          & ( aa(fun(D,product_prod(A,B)),fun(D,A),comp(product_prod(A,B),A,D,product_fst(A,B)),Z5) = A4 )
          & ( aa(fun(D,product_prod(A,B)),fun(D,B),comp(product_prod(A,B),B,D,product_snd(A,B)),Z5) = B3 ) ) ) ).

% fun.in_rel
tff(fact_1155_trancl__insert,axiom,
    ! [A: $tType,Y: A,X2: A,R2: set(product_prod(A,A))] : ( transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),X2)),R2)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_trancl(A,R2)),aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool))),aTP_Lamp_eg(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool)))),Y),X2),R2)))) ) ).

% trancl_insert
tff(fact_1156_Sup__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( complete_Sup(B)
     => ! [A3: set(fun(A,B)),X2: A] : ( aa(A,B,aa(set(fun(A,B)),fun(A,B),complete_Sup_Sup(fun(A,B)),A3),X2) = aa(set(B),B,complete_Sup_Sup(B),aa(set(fun(A,B)),set(B),image2(fun(A,B),B,aTP_Lamp_fd(A,fun(fun(A,B),B),X2)),A3)) ) ) ).

% Sup_apply
tff(fact_1157_Sup__bot__conv_I2_J,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( ( bot_bot(A) = aa(set(A),A,complete_Sup_Sup(A),A3) )
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),A3))
             => ( X3 = bot_bot(A) ) ) ) ) ).

% Sup_bot_conv(2)
tff(fact_1158_Sup__bot__conv_I1_J,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),A3) = bot_bot(A) )
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),A3))
             => ( X3 = bot_bot(A) ) ) ) ) ).

% Sup_bot_conv(1)
tff(fact_1159_trancl__empty,axiom,
    ! [A: $tType] : ( transitive_trancl(A,bot_bot(set(product_prod(A,A)))) = bot_bot(set(product_prod(A,A))) ) ).

% trancl_empty
tff(fact_1160_SUP__apply,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( complete_Sup(A)
     => ! [F2: fun(C,fun(B,A)),A3: set(C),X2: B] : ( aa(B,A,aa(set(fun(B,A)),fun(B,A),complete_Sup_Sup(fun(B,A)),aa(set(C),set(fun(B,A)),image2(C,fun(B,A),F2),A3)),X2) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,aa(B,fun(C,A),aTP_Lamp_fe(fun(C,fun(B,A)),fun(B,fun(C,A)),F2),X2)),A3)) ) ) ).

% SUP_apply
tff(fact_1161_SUP__identity__eq,axiom,
    ! [A: $tType] :
      ( complete_Sup(A)
     => ! [A3: set(A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),image2(A,A,aTP_Lamp_ff(A,A)),A3)) = aa(set(A),A,complete_Sup_Sup(A),A3) ) ) ).

% SUP_identity_eq
tff(fact_1162_UN__I,axiom,
    ! [B: $tType,A: $tType,A4: A,A3: set(A),B3: B,B2: fun(A,set(B))] :
      ( pp(aa(set(A),bool,member(A,A4),A3))
     => ( pp(aa(set(B),bool,member(B,B3),aa(A,set(B),B2,A4)))
       => pp(aa(set(B),bool,member(B,B3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),B2),A3)))) ) ) ).

% UN_I
tff(fact_1163_UN__iff,axiom,
    ! [A: $tType,B: $tType,B3: A,B2: fun(B,set(A)),A3: set(B)] :
      ( pp(aa(set(A),bool,member(A,B3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3))))
    <=> ? [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),A3))
          & pp(aa(set(A),bool,member(A,B3),aa(B,set(A),B2,X3))) ) ) ).

% UN_iff
tff(fact_1164_Sup__empty,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ( aa(set(A),A,complete_Sup_Sup(A),bot_bot(set(A))) = bot_bot(A) ) ) ).

% Sup_empty
tff(fact_1165_Sup__UNIV,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ( aa(set(A),A,complete_Sup_Sup(A),top_top(set(A))) = top_top(A) ) ) ).

% Sup_UNIV
tff(fact_1166_SUP__bot__conv_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B2: fun(B,A),A3: set(B)] :
          ( ( bot_bot(A) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,B2),A3)) )
        <=> ! [X3: B] :
              ( pp(aa(set(B),bool,member(B,X3),A3))
             => ( aa(B,A,B2,X3) = bot_bot(A) ) ) ) ) ).

% SUP_bot_conv(2)
tff(fact_1167_SUP__bot__conv_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B2: fun(B,A),A3: set(B)] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,B2),A3)) = bot_bot(A) )
        <=> ! [X3: B] :
              ( pp(aa(set(B),bool,member(B,X3),A3))
             => ( aa(B,A,B2,X3) = bot_bot(A) ) ) ) ) ).

% SUP_bot_conv(1)
tff(fact_1168_SUP__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_fg(B,A)),A3)) = bot_bot(A) ) ) ).

% SUP_bot
tff(fact_1169_SUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),F2: A] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_fh(A,fun(B,A),F2)),A3)) = F2 ) ) ) ).

% SUP_const
tff(fact_1170_UN__constant,axiom,
    ! [B: $tType,A: $tType,A3: set(B),C2: set(A)] :
      ( ( ( A3 = bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_bv(set(A),fun(B,set(A)),C2)),A3)) = bot_bot(set(A)) ) )
      & ( ( A3 != bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_bv(set(A),fun(B,set(A)),C2)),A3)) = C2 ) ) ) ).

% UN_constant
tff(fact_1171_UN__Un,axiom,
    ! [A: $tType,B: $tType,M: fun(B,set(A)),A3: set(B),B2: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),M),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),M),A3))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),M),B2))) ) ).

% UN_Un
tff(fact_1172_trancl__single,axiom,
    ! [A: $tType,A4: A,B3: A] : ( transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),bot_bot(set(product_prod(A,A))))) = aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),bot_bot(set(product_prod(A,A)))) ) ).

% trancl_single
tff(fact_1173_UN__singleton,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(A),set(set(A)),image2(A,set(A),aTP_Lamp_dj(A,set(A))),A3)) = A3 ) ).

% UN_singleton
tff(fact_1174_UN__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set(B),A4: A,B2: fun(B,set(A))] :
      ( ( ( C3 = bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_fi(A,fun(fun(B,set(A)),fun(B,set(A))),A4),B2)),C3)) = bot_bot(set(A)) ) )
      & ( ( C3 != bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_fi(A,fun(fun(B,set(A)),fun(B,set(A))),A4),B2)),C3)) = aa(set(A),set(A),insert(A,A4),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),C3))) ) ) ) ).

% UN_simps(1)
tff(fact_1175_UN__simps_I3_J,axiom,
    ! [E: $tType,F10: $tType,C3: set(F10),A3: set(E),B2: fun(F10,set(E))] :
      ( ( ( C3 = bot_bot(set(F10)) )
       => ( aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F10),set(set(E)),image2(F10,set(E),aa(fun(F10,set(E)),fun(F10,set(E)),aTP_Lamp_fj(set(E),fun(fun(F10,set(E)),fun(F10,set(E))),A3),B2)),C3)) = bot_bot(set(E)) ) )
      & ( ( C3 != bot_bot(set(F10)) )
       => ( aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F10),set(set(E)),image2(F10,set(E),aa(fun(F10,set(E)),fun(F10,set(E)),aTP_Lamp_fj(set(E),fun(fun(F10,set(E)),fun(F10,set(E))),A3),B2)),C3)) = aa(set(E),set(E),aa(set(E),fun(set(E),set(E)),sup_sup(set(E)),A3),aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F10),set(set(E)),image2(F10,set(E),B2),C3))) ) ) ) ).

% UN_simps(3)
tff(fact_1176_UN__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set(C),A3: fun(C,set(D)),B2: set(D)] :
      ( ( ( C3 = bot_bot(set(C)) )
       => ( aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),aa(set(D),fun(C,set(D)),aTP_Lamp_fk(fun(C,set(D)),fun(set(D),fun(C,set(D))),A3),B2)),C3)) = bot_bot(set(D)) ) )
      & ( ( C3 != bot_bot(set(C)) )
       => ( aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),aa(set(D),fun(C,set(D)),aTP_Lamp_fk(fun(C,set(D)),fun(set(D),fun(C,set(D))),A3),B2)),C3)) = aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),sup_sup(set(D)),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A3),C3))),B2) ) ) ) ).

% UN_simps(2)
tff(fact_1177_UN__insert,axiom,
    ! [A: $tType,B: $tType,B2: fun(B,set(A)),A4: B,A3: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),aa(set(B),set(B),insert(B,A4),A3))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(B,set(A),B2,A4)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3))) ) ).

% UN_insert
tff(fact_1178_Sup__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( complete_Sup(B)
     => ! [A3: set(fun(A,B)),X4: A] : ( aa(A,B,aa(set(fun(A,B)),fun(A,B),complete_Sup_Sup(fun(A,B)),A3),X4) = aa(set(B),B,complete_Sup_Sup(B),aa(set(fun(A,B)),set(B),image2(fun(A,B),B,aTP_Lamp_fd(A,fun(fun(A,B),B),X4)),A3)) ) ) ).

% Sup_fun_def
tff(fact_1179_Sigma__Union,axiom,
    ! [B: $tType,A: $tType,X5: set(set(A)),B2: fun(A,set(B))] : ( product_Sigma(A,B,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),X5),B2) = aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(set(A)),set(set(product_prod(A,B))),image2(set(A),set(product_prod(A,B)),aTP_Lamp_fl(fun(A,set(B)),fun(set(A),set(product_prod(A,B))),B2)),X5)) ) ).

% Sigma_Union
tff(fact_1180_fun_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Sa: fun(A,fun(C,bool)),X2: fun(D,A),G: fun(B,C),Y: fun(D,B)] :
      ( pp(aa(fun(D,C),bool,aa(fun(D,A),fun(fun(D,C),bool),bNF_rel_fun(D,D,A,C,fequal(D),Sa),X2),aa(fun(D,B),fun(D,C),comp(B,C,D,G),Y)))
    <=> pp(aa(fun(D,B),bool,aa(fun(D,A),fun(fun(D,B),bool),bNF_rel_fun(D,D,A,B,fequal(D),aa(fun(B,C),fun(A,fun(B,bool)),aTP_Lamp_fm(fun(A,fun(C,bool)),fun(fun(B,C),fun(A,fun(B,bool))),Sa),G)),X2),Y)) ) ).

% fun.rel_map(2)
tff(fact_1181_fun_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Sb: fun(C,fun(B,bool)),I2: fun(A,C),X2: fun(D,A),Y: fun(D,B)] :
      ( pp(aa(fun(D,B),bool,aa(fun(D,C),fun(fun(D,B),bool),bNF_rel_fun(D,D,C,B,fequal(D),Sb),aa(fun(D,A),fun(D,C),comp(A,C,D,I2),X2)),Y))
    <=> pp(aa(fun(D,B),bool,aa(fun(D,A),fun(fun(D,B),bool),bNF_rel_fun(D,D,A,B,fequal(D),aa(fun(A,C),fun(A,fun(B,bool)),aTP_Lamp_fn(fun(C,fun(B,bool)),fun(fun(A,C),fun(A,fun(B,bool))),Sb),I2)),X2),Y)) ) ).

% fun.rel_map(1)
tff(fact_1182_SUP__UNION,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),G: fun(C,set(B)),A3: set(C)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),G),A3)))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,aa(fun(C,set(B)),fun(C,A),aTP_Lamp_fo(fun(B,A),fun(fun(C,set(B)),fun(C,A)),F2),G)),A3)) ) ) ).

% SUP_UNION
tff(fact_1183_Union__empty,axiom,
    ! [A: $tType] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),bot_bot(set(set(A)))) = bot_bot(set(A)) ) ).

% Union_empty
tff(fact_1184_Union__empty__conv,axiom,
    ! [A: $tType,A3: set(set(A))] :
      ( ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3) = bot_bot(set(A)) )
    <=> ! [X3: set(A)] :
          ( pp(aa(set(set(A)),bool,member(set(A),X3),A3))
         => ( X3 = bot_bot(set(A)) ) ) ) ).

% Union_empty_conv
tff(fact_1185_empty__Union__conv,axiom,
    ! [A: $tType,A3: set(set(A))] :
      ( ( bot_bot(set(A)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3) )
    <=> ! [X3: set(A)] :
          ( pp(aa(set(set(A)),bool,member(set(A),X3),A3))
         => ( X3 = bot_bot(set(A)) ) ) ) ).

% empty_Union_conv
tff(fact_1186_UN__Times__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,E3: fun(C,set(A)),F: fun(D,set(B)),A3: set(C),B2: set(D)] : ( aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(product_prod(C,D)),set(set(product_prod(A,B))),image2(product_prod(C,D),set(product_prod(A,B)),aa(fun(C,fun(D,set(product_prod(A,B)))),fun(product_prod(C,D),set(product_prod(A,B))),product_case_prod(C,D,set(product_prod(A,B))),aa(fun(D,set(B)),fun(C,fun(D,set(product_prod(A,B)))),aTP_Lamp_fq(fun(C,set(A)),fun(fun(D,set(B)),fun(C,fun(D,set(product_prod(A,B))))),E3),F))),product_Sigma(C,D,A3,aTP_Lamp_el(set(D),fun(C,set(D)),B2)))) = product_Sigma(A,B,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image2(C,set(A),E3),A3)),aa(set(D),fun(A,set(B)),aTP_Lamp_fr(fun(D,set(B)),fun(set(D),fun(A,set(B))),F),B2)) ) ).

% UN_Times_distrib
tff(fact_1187_SUP__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,fun(C,A)),B2: set(C),A3: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(set(C),fun(B,A),aTP_Lamp_fs(fun(B,fun(C,A)),fun(set(C),fun(B,A)),F2),B2)),A3)) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,aa(set(B),fun(C,A),aTP_Lamp_fu(fun(B,fun(C,A)),fun(set(B),fun(C,A)),F2),A3)),B2)) ) ) ).

% SUP_commute
tff(fact_1188_SUP__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: fun(bool,A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(bool),set(A),image2(bool,A,A3),top_top(set(bool)))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(bool,A,A3,fTrue)),aa(bool,A,A3,fFalse)) ) ) ).

% SUP_UNIV_bool_expand
tff(fact_1189_Union__SetCompr__eq,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,set(A)),P: fun(B,bool)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aa(fun(B,bool),fun(set(A),bool),aTP_Lamp_fv(fun(B,set(A)),fun(fun(B,bool),fun(set(A),bool)),F2),P))) = aa(fun(A,bool),set(A),collect(A),aa(fun(B,bool),fun(A,bool),aTP_Lamp_fw(fun(B,set(A)),fun(fun(B,bool),fun(A,bool)),F2),P)) ) ).

% Union_SetCompr_eq
tff(fact_1190_UN__bool__eq,axiom,
    ! [A: $tType,A3: fun(bool,set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(bool),set(set(A)),image2(bool,set(A),A3),top_top(set(bool)))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(bool,set(A),A3,fTrue)),aa(bool,set(A),A3,fFalse)) ) ).

% UN_bool_eq
tff(fact_1191_Un__eq__UN,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(bool),set(set(A)),image2(bool,set(A),aa(set(A),fun(bool,set(A)),aTP_Lamp_fx(set(A),fun(set(A),fun(bool,set(A))),A3),B2)),top_top(set(bool)))) ) ).

% Un_eq_UN
tff(fact_1192_UN__extend__simps_I9_J,axiom,
    ! [S5: $tType,R4: $tType,Q6: $tType,C3: fun(R4,set(S5)),B2: fun(Q6,set(R4)),A3: set(Q6)] : ( aa(set(set(S5)),set(S5),complete_Sup_Sup(set(S5)),aa(set(Q6),set(set(S5)),image2(Q6,set(S5),aa(fun(Q6,set(R4)),fun(Q6,set(S5)),aTP_Lamp_fy(fun(R4,set(S5)),fun(fun(Q6,set(R4)),fun(Q6,set(S5))),C3),B2)),A3)) = aa(set(set(S5)),set(S5),complete_Sup_Sup(set(S5)),aa(set(R4),set(set(S5)),image2(R4,set(S5),C3),aa(set(set(R4)),set(R4),complete_Sup_Sup(set(R4)),aa(set(Q6),set(set(R4)),image2(Q6,set(R4),B2),A3)))) ) ).

% UN_extend_simps(9)
tff(fact_1193_UN__E,axiom,
    ! [A: $tType,B: $tType,B3: A,B2: fun(B,set(A)),A3: set(B)] :
      ( pp(aa(set(A),bool,member(A,B3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3))))
     => ~ ! [X: B] :
            ( pp(aa(set(B),bool,member(B,X),A3))
           => ~ pp(aa(set(A),bool,member(A,B3),aa(B,set(A),B2,X))) ) ) ).

% UN_E
tff(fact_1194_UN__UN__flatten,axiom,
    ! [B: $tType,A: $tType,C: $tType,C3: fun(B,set(A)),B2: fun(C,set(B)),A3: set(C)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),C3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_fz(fun(B,set(A)),fun(fun(C,set(B)),fun(C,set(A))),C3),B2)),A3)) ) ).

% UN_UN_flatten
tff(fact_1195_predicate2__transferD,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: fun(A,fun(B,bool)),R22: fun(C,fun(D,bool)),P: fun(A,fun(C,bool)),Q: fun(B,fun(D,bool)),A4: product_prod(A,B),A3: set(product_prod(A,B)),B3: product_prod(C,D),B2: set(product_prod(C,D))] :
      ( pp(aa(fun(B,fun(D,bool)),bool,aa(fun(A,fun(C,bool)),fun(fun(B,fun(D,bool)),bool),bNF_rel_fun(A,B,fun(C,bool),fun(D,bool),R1,bNF_rel_fun(C,D,bool,bool,R22,fequal(bool))),P),Q))
     => ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),A4),A3))
       => ( pp(aa(set(product_prod(C,D)),bool,member(product_prod(C,D),B3),B2))
         => ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),A3),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),R1))))
           => ( pp(aa(set(product_prod(C,D)),bool,aa(set(product_prod(C,D)),fun(set(product_prod(C,D)),bool),ord_less_eq(set(product_prod(C,D))),B2),aa(fun(product_prod(C,D),bool),set(product_prod(C,D)),collect(product_prod(C,D)),aa(fun(C,fun(D,bool)),fun(product_prod(C,D),bool),product_case_prod(C,D,bool),R22))))
             => ( pp(aa(C,bool,aa(A,fun(C,bool),P,aa(product_prod(A,B),A,product_fst(A,B),A4)),aa(product_prod(C,D),C,product_fst(C,D),B3)))
              <=> pp(aa(D,bool,aa(B,fun(D,bool),Q,aa(product_prod(A,B),B,product_snd(A,B),A4)),aa(product_prod(C,D),D,product_snd(C,D),B3))) ) ) ) ) ) ) ).

% predicate2_transferD
tff(fact_1196_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),U: A] :
          ( ! [V2: A] :
              ( pp(aa(set(A),bool,member(A,V2),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),V2)) )
         => ( ( A3 != bot_bot(set(A)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(set(A),A,complete_Sup_Sup(A),A3))) ) ) ) ).

% less_eq_Sup
tff(fact_1197_SUP__eq__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I: set(B),F2: fun(B,A),X2: A] :
          ( ( I != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,member(B,I3),I))
               => ( aa(B,A,F2,I3) = X2 ) )
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),I)) = X2 ) ) ) ) ).

% SUP_eq_const
tff(fact_1198_Sup__inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B2: set(A),A4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),B2)),A4) = bot_bot(A) )
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),B2))
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X3),A4) = bot_bot(A) ) ) ) ) ).

% Sup_inf_eq_bot_iff
tff(fact_1199_inf__Sup,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A4: A,B2: set(A)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),aa(set(A),A,complete_Sup_Sup(A),B2)) = aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),inf_inf(A),A4)),B2)) ) ) ).

% inf_Sup
tff(fact_1200_insert__partition,axiom,
    ! [A: $tType,X2: set(A),F: set(set(A))] :
      ( ~ pp(aa(set(set(A)),bool,member(set(A),X2),F))
     => ( ! [X: set(A)] :
            ( pp(aa(set(set(A)),bool,member(set(A),X),aa(set(set(A)),set(set(A)),insert(set(A),X2),F)))
           => ! [Xa4: set(A)] :
                ( pp(aa(set(set(A)),bool,member(set(A),Xa4),aa(set(set(A)),set(set(A)),insert(set(A),X2),F)))
               => ( ( X != Xa4 )
                 => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),X),Xa4) = bot_bot(set(A)) ) ) ) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),X2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),F)) = bot_bot(set(A)) ) ) ) ).

% insert_partition
tff(fact_1201_Union__disjoint,axiom,
    ! [A: $tType,C3: set(set(A)),A3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C3)),A3) = bot_bot(set(A)) )
    <=> ! [X3: set(A)] :
          ( pp(aa(set(set(A)),bool,member(set(A),X3),C3))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),X3),A3) = bot_bot(set(A)) ) ) ) ).

% Union_disjoint
tff(fact_1202_Union__Int__subset,axiom,
    ! [A: $tType,A3: set(set(A)),B2: set(set(A))] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),A3),B2))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B2)))) ).

% Union_Int_subset
tff(fact_1203_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),F2: fun(B,A),X2: A] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),X2)) )
         => ( ! [Y2: A] :
                ( ! [I4: B] :
                    ( pp(aa(set(B),bool,member(B,I4),A3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I4)),Y2)) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3)) = X2 ) ) ) ) ).

% SUP_eqI
tff(fact_1204_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),B2: set(C),F2: fun(B,A),G: fun(C,A)] :
          ( ! [N2: B] :
              ( pp(aa(set(B),bool,member(B,N2),A3))
             => ? [X4: C] :
                  ( pp(aa(set(C),bool,member(C,X4),B2))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,N2)),aa(C,A,G,X4))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,G),B2)))) ) ) ).

% SUP_mono
tff(fact_1205_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),F2: fun(B,A),U: A] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),U)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),U)) ) ) ).

% SUP_least
tff(fact_1206_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),G: fun(B,A),A3: set(B)] :
          ( ! [X: B] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X)),aa(B,A,G,X)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,G),A3)))) ) ) ).

% SUP_mono'
tff(fact_1207_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I2: B,A3: set(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,member(B,I2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I2)),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3)))) ) ) ).

% SUP_upper
tff(fact_1208_SUP__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),A3: set(B),U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),U))
        <=> ! [X3: B] :
              ( pp(aa(set(B),bool,member(B,X3),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X3)),U)) ) ) ) ).

% SUP_le_iff
tff(fact_1209_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I2: B,A3: set(B),U: A,F2: fun(B,A)] :
          ( pp(aa(set(B),bool,member(B,I2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(B,A,F2,I2)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3)))) ) ) ) ).

% SUP_upper2
tff(fact_1210_SUP__inf__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F2: fun(B,A),A3: set(B),G: fun(C,A),B2: set(C)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,G),B2))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_gb(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),F2),G),B2)),A3)) ) ) ).

% SUP_inf_distrib2
tff(fact_1211_inf__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A4: A,F2: fun(B,A),B2: set(B)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),B2))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_gc(A,fun(fun(B,A),fun(B,A)),A4),F2)),B2)) ) ) ).

% inf_SUP
tff(fact_1212_Sup__inf,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B2: set(A),A4: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),B2)),A4) = aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),image2(A,A,aTP_Lamp_gd(A,fun(A,A),A4)),B2)) ) ) ).

% Sup_inf
tff(fact_1213_SUP__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F2: fun(B,A),B2: set(B),A4: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),B2))),A4) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_ge(fun(B,A),fun(A,fun(B,A)),F2),A4)),B2)) ) ) ).

% SUP_inf
tff(fact_1214_complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),A3: set(B),G: fun(B,A)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,G),A3))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_gf(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),A3)) ) ) ).

% complete_lattice_class.SUP_sup_distrib
tff(fact_1215_SUP__absorb,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [K: B,I: set(B),A3: fun(B,A)] :
          ( pp(aa(set(B),bool,member(B,K),I))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,A3,K)),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,A3),I))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,A3),I)) ) ) ) ).

% SUP_absorb
tff(fact_1216_refl__on__empty,axiom,
    ! [A: $tType] : refl_on(A,bot_bot(set(A)),bot_bot(set(product_prod(A,A)))) ).

% refl_on_empty
tff(fact_1217_trancl__subset__Sigma,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))))
     => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),transitive_trancl(A,R2)),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ).

% trancl_subset_Sigma
tff(fact_1218_refl__on__Int,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),B2: set(A),S2: set(product_prod(A,A))] :
      ( refl_on(A,A3,R2)
     => ( refl_on(A,B2,S2)
       => refl_on(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),S2)) ) ) ).

% refl_on_Int
tff(fact_1219_UN__extend__simps_I10_J,axiom,
    ! [V3: $tType,U3: $tType,T: $tType,B2: fun(U3,set(V3)),F2: fun(T,U3),A3: set(T)] : ( aa(set(set(V3)),set(V3),complete_Sup_Sup(set(V3)),aa(set(T),set(set(V3)),image2(T,set(V3),aa(fun(T,U3),fun(T,set(V3)),aTP_Lamp_gg(fun(U3,set(V3)),fun(fun(T,U3),fun(T,set(V3))),B2),F2)),A3)) = aa(set(set(V3)),set(V3),complete_Sup_Sup(set(V3)),aa(set(U3),set(set(V3)),image2(U3,set(V3),B2),aa(set(T),set(U3),image2(T,U3,F2),A3))) ) ).

% UN_extend_simps(10)
tff(fact_1220_image__UN,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(B,A),B2: fun(C,set(B)),A3: set(C)] : ( aa(set(B),set(A),image2(B,A,F2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_gh(fun(B,A),fun(fun(C,set(B)),fun(C,set(A))),F2),B2)),A3)) ) ).

% image_UN
tff(fact_1221_UN__empty2,axiom,
    ! [B: $tType,A: $tType,A3: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_gi(B,set(A))),A3)) = bot_bot(set(A)) ) ).

% UN_empty2
tff(fact_1222_UN__empty,axiom,
    ! [B: $tType,A: $tType,B2: fun(B,set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),bot_bot(set(B)))) = bot_bot(set(A)) ) ).

% UN_empty
tff(fact_1223_UNION__empty__conv_I1_J,axiom,
    ! [B: $tType,A: $tType,B2: fun(B,set(A)),A3: set(B)] :
      ( ( bot_bot(set(A)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3)) )
    <=> ! [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),A3))
         => ( aa(B,set(A),B2,X3) = bot_bot(set(A)) ) ) ) ).

% UNION_empty_conv(1)
tff(fact_1224_UNION__empty__conv_I2_J,axiom,
    ! [B: $tType,A: $tType,B2: fun(B,set(A)),A3: set(B)] :
      ( ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3)) = bot_bot(set(A)) )
    <=> ! [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),A3))
         => ( aa(B,set(A),B2,X3) = bot_bot(set(A)) ) ) ) ).

% UNION_empty_conv(2)
tff(fact_1225_UN__mono,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: set(A),F2: fun(A,set(B)),G: fun(A,set(B))] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),A3))
           => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),F2,X)),aa(A,set(B),G,X))) )
       => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),F2),A3))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),G),B2)))) ) ) ).

% UN_mono
tff(fact_1226_UN__least,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: fun(A,set(B)),C3: set(B)] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),A3))
         => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),B2,X)),C3)) )
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),B2),A3))),C3)) ) ).

% UN_least
tff(fact_1227_UN__upper,axiom,
    ! [B: $tType,A: $tType,A4: A,A3: set(A),B2: fun(A,set(B))] :
      ( pp(aa(set(A),bool,member(A,A4),A3))
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),B2,A4)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),B2),A3)))) ) ).

% UN_upper
tff(fact_1228_UN__subset__iff,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),I: set(B),B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))),B2))
    <=> ! [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),I))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(B,set(A),A3,X3)),B2)) ) ) ).

% UN_subset_iff
tff(fact_1229_UN__insert__distrib,axiom,
    ! [B: $tType,A: $tType,U: A,A3: set(A),A4: B,B2: fun(A,set(B))] :
      ( pp(aa(set(A),bool,member(A,U),A3))
     => ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_gj(B,fun(fun(A,set(B)),fun(A,set(B))),A4),B2)),A3)) = aa(set(B),set(B),insert(B,A4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),B2),A3))) ) ) ).

% UN_insert_distrib
tff(fact_1230_Int__UN__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType,A3: fun(B,set(A)),I: set(B),B2: fun(C,set(A)),J: set(C)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image2(C,set(A),B2),J))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(set(C),fun(B,set(A)),aa(fun(C,set(A)),fun(set(C),fun(B,set(A))),aTP_Lamp_gl(fun(B,set(A)),fun(fun(C,set(A)),fun(set(C),fun(B,set(A)))),A3),B2),J)),I)) ) ).

% Int_UN_distrib2
tff(fact_1231_Int__UN__distrib,axiom,
    ! [A: $tType,B: $tType,B2: set(A),A3: fun(B,set(A)),I: set(B)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_gm(set(A),fun(fun(B,set(A)),fun(B,set(A))),B2),A3)),I)) ) ).

% Int_UN_distrib
tff(fact_1232_UN__extend__simps_I4_J,axiom,
    ! [H8: $tType,G3: $tType,A3: fun(G3,set(H8)),C3: set(G3),B2: set(H8)] : ( aa(set(H8),set(H8),aa(set(H8),fun(set(H8),set(H8)),inf_inf(set(H8)),aa(set(set(H8)),set(H8),complete_Sup_Sup(set(H8)),aa(set(G3),set(set(H8)),image2(G3,set(H8),A3),C3))),B2) = aa(set(set(H8)),set(H8),complete_Sup_Sup(set(H8)),aa(set(G3),set(set(H8)),image2(G3,set(H8),aa(set(H8),fun(G3,set(H8)),aTP_Lamp_gn(fun(G3,set(H8)),fun(set(H8),fun(G3,set(H8))),A3),B2)),C3)) ) ).

% UN_extend_simps(4)
tff(fact_1233_UN__extend__simps_I5_J,axiom,
    ! [I5: $tType,J3: $tType,A3: set(I5),B2: fun(J3,set(I5)),C3: set(J3)] : ( aa(set(I5),set(I5),aa(set(I5),fun(set(I5),set(I5)),inf_inf(set(I5)),A3),aa(set(set(I5)),set(I5),complete_Sup_Sup(set(I5)),aa(set(J3),set(set(I5)),image2(J3,set(I5),B2),C3))) = aa(set(set(I5)),set(I5),complete_Sup_Sup(set(I5)),aa(set(J3),set(set(I5)),image2(J3,set(I5),aa(fun(J3,set(I5)),fun(J3,set(I5)),aTP_Lamp_go(set(I5),fun(fun(J3,set(I5)),fun(J3,set(I5))),A3),B2)),C3)) ) ).

% UN_extend_simps(5)
tff(fact_1234_Un__Union__image,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),B2: fun(B,set(A)),C3: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_gp(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),A3),B2)),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),C3))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),C3))) ) ).

% Un_Union_image
tff(fact_1235_UN__Un__distrib,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),B2: fun(B,set(A)),I: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_gp(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),A3),B2)),I)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),I))) ) ).

% UN_Un_distrib
tff(fact_1236_UN__absorb,axiom,
    ! [B: $tType,A: $tType,K: A,I: set(A),A3: fun(A,set(B))] :
      ( pp(aa(set(A),bool,member(A,K),I))
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(A,set(B),A3,K)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),I))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),I)) ) ) ).

% UN_absorb
tff(fact_1237_UN__extend__simps_I6_J,axiom,
    ! [L2: $tType,K4: $tType,A3: fun(K4,set(L2)),C3: set(K4),B2: set(L2)] : ( aa(set(L2),set(L2),aa(set(L2),fun(set(L2),set(L2)),minus_minus(set(L2)),aa(set(set(L2)),set(L2),complete_Sup_Sup(set(L2)),aa(set(K4),set(set(L2)),image2(K4,set(L2),A3),C3))),B2) = aa(set(set(L2)),set(L2),complete_Sup_Sup(set(L2)),aa(set(K4),set(set(L2)),image2(K4,set(L2),aa(set(L2),fun(K4,set(L2)),aTP_Lamp_gq(fun(K4,set(L2)),fun(set(L2),fun(K4,set(L2))),A3),B2)),C3)) ) ).

% UN_extend_simps(6)
tff(fact_1238_vimage__UN,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(A,B),B2: fun(C,set(B)),A3: set(C)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_gr(fun(A,B),fun(fun(C,set(B)),fun(C,set(A))),F2),B2)),A3)) ) ).

% vimage_UN
tff(fact_1239_image__Union,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),S: set(set(B))] : ( aa(set(B),set(A),image2(B,A,F2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),S)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(B)),set(set(A)),image2(set(B),set(A),image2(B,A,F2)),S)) ) ).

% image_Union
tff(fact_1240_Int__Union2,axiom,
    ! [A: $tType,B2: set(set(A)),A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B2)),A3) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(A)),set(set(A)),image2(set(A),set(A),aTP_Lamp_gs(set(A),fun(set(A),set(A)),A3)),B2)) ) ).

% Int_Union2
tff(fact_1241_Int__Union,axiom,
    ! [A: $tType,A3: set(A),B2: set(set(A))] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B2)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(A)),set(set(A)),image2(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3)),B2)) ) ).

% Int_Union
tff(fact_1242_UN__extend__simps_I8_J,axiom,
    ! [P8: $tType,O: $tType,B2: fun(O,set(P8)),A3: set(set(O))] : ( aa(set(set(P8)),set(P8),complete_Sup_Sup(set(P8)),aa(set(set(O)),set(set(P8)),image2(set(O),set(P8),aTP_Lamp_gt(fun(O,set(P8)),fun(set(O),set(P8)),B2)),A3)) = aa(set(set(P8)),set(P8),complete_Sup_Sup(set(P8)),aa(set(O),set(set(P8)),image2(O,set(P8),B2),aa(set(set(O)),set(O),complete_Sup_Sup(set(O)),A3))) ) ).

% UN_extend_simps(8)
tff(fact_1243_vimage__Union,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A3: set(set(B))] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A3)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(B)),set(set(A)),image2(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2)),A3)) ) ).

% vimage_Union
tff(fact_1244_SUP__eq__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I: set(B),C2: A,F2: fun(B,A)] :
          ( ( I != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,member(B,I3),I))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(B,A,F2,I3))) )
           => ( ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),I)) = C2 )
            <=> ! [X3: B] :
                  ( pp(aa(set(B),bool,member(B,X3),I))
                 => ( aa(B,A,F2,X3) = C2 ) ) ) ) ) ) ).

% SUP_eq_iff
tff(fact_1245_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),B2: set(A)] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B2)))) ) ).

% Sup_inter_less_eq
tff(fact_1246_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),B2: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A3),B2))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),A3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X)),aa(B,A,G,X))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,G),B2)))) ) ) ) ).

% SUP_subset_mono
tff(fact_1247_SUP__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),bot_bot(set(B)))) = bot_bot(A) ) ) ).

% SUP_empty
tff(fact_1248_SUP__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),C2: A] :
          ( ( ( A3 = bot_bot(set(B)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_fh(A,fun(B,A),C2)),A3)) = bot_bot(A) ) )
          & ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_fh(A,fun(B,A),C2)),A3)) = C2 ) ) ) ) ).

% SUP_constant
tff(fact_1249_trancl__subset__Field2,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),transitive_trancl(A,R2)),product_Sigma(A,A,field2(A,R2),aTP_Lamp_ey(set(product_prod(A,A)),fun(A,set(A)),R2)))) ).

% trancl_subset_Field2
tff(fact_1250_SUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),A4: B,A3: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),aa(set(B),set(B),insert(B,A4),A3))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,F2,A4)),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))) ) ) ).

% SUP_insert
tff(fact_1251_Restr__trancl__mono,axiom,
    ! [A: $tType,V: A,W2: A,E3: set(product_prod(A,A)),U2: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2)),transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),E3),product_Sigma(A,A,U2,aTP_Lamp_cr(set(A),fun(A,set(A)),U2))))))
     => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2)),transitive_trancl(A,E3))) ) ).

% Restr_trancl_mono
tff(fact_1252_SUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [M: fun(B,A),A3: set(B),B2: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,M),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,M),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,M),B2))) ) ) ).

% SUP_union
tff(fact_1253_UN__extend__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set(B),A4: A,B2: fun(B,set(A))] :
      ( ( ( C3 = bot_bot(set(B)) )
       => ( aa(set(A),set(A),insert(A,A4),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),C3))) = aa(set(A),set(A),insert(A,A4),bot_bot(set(A))) ) )
      & ( ( C3 != bot_bot(set(B)) )
       => ( aa(set(A),set(A),insert(A,A4),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),C3))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_fi(A,fun(fun(B,set(A)),fun(B,set(A))),A4),B2)),C3)) ) ) ) ).

% UN_extend_simps(1)
tff(fact_1254_Collect__ex__eq,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,bool))] : ( aa(fun(A,bool),set(A),collect(A),aTP_Lamp_gu(fun(A,fun(B,bool)),fun(A,bool),P)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_gw(fun(A,fun(B,bool)),fun(B,set(A)),P)),top_top(set(B)))) ) ).

% Collect_ex_eq
tff(fact_1255_UN__extend__simps_I3_J,axiom,
    ! [E: $tType,F10: $tType,C3: set(F10),A3: set(E),B2: fun(F10,set(E))] :
      ( ( ( C3 = bot_bot(set(F10)) )
       => ( aa(set(E),set(E),aa(set(E),fun(set(E),set(E)),sup_sup(set(E)),A3),aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F10),set(set(E)),image2(F10,set(E),B2),C3))) = A3 ) )
      & ( ( C3 != bot_bot(set(F10)) )
       => ( aa(set(E),set(E),aa(set(E),fun(set(E),set(E)),sup_sup(set(E)),A3),aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F10),set(set(E)),image2(F10,set(E),B2),C3))) = aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F10),set(set(E)),image2(F10,set(E),aa(fun(F10,set(E)),fun(F10,set(E)),aTP_Lamp_fj(set(E),fun(fun(F10,set(E)),fun(F10,set(E))),A3),B2)),C3)) ) ) ) ).

% UN_extend_simps(3)
tff(fact_1256_UN__extend__simps_I2_J,axiom,
    ! [D: $tType,C: $tType,C3: set(C),A3: fun(C,set(D)),B2: set(D)] :
      ( ( ( C3 = bot_bot(set(C)) )
       => ( aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),sup_sup(set(D)),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A3),C3))),B2) = B2 ) )
      & ( ( C3 != bot_bot(set(C)) )
       => ( aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),sup_sup(set(D)),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A3),C3))),B2) = aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),aa(set(D),fun(C,set(D)),aTP_Lamp_fk(fun(C,set(D)),fun(set(D),fun(C,set(D))),A3),B2)),C3)) ) ) ) ).

% UN_extend_simps(2)
tff(fact_1257_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I: set(A),A3: fun(A,set(B)),F2: fun(B,C)] :
      ( ! [I3: A,J4: A] :
          ( pp(aa(set(A),bool,member(A,I3),I))
         => ( pp(aa(set(A),bool,member(A,J4),I))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),A3,I3)),aa(A,set(B),A3,J4)))
              | pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),A3,J4)),aa(A,set(B),A3,I3))) ) ) )
     => ( ! [I3: A] :
            ( pp(aa(set(A),bool,member(A,I3),I))
           => inj_on(B,C,F2,aa(A,set(B),A3,I3)) )
       => inj_on(B,C,F2,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),I))) ) ) ).

% inj_on_UNION_chain
tff(fact_1258_refl__on__def,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A))] :
      ( refl_on(A,A3,R2)
    <=> ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))))
        & ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),A3))
           => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),X3)),R2)) ) ) ) ).

% refl_on_def
tff(fact_1259_refl__onI,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))))
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),A3))
           => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),X)),R2)) )
       => refl_on(A,A3,R2) ) ) ).

% refl_onI
tff(fact_1260_Refl__Restr,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( refl_on(A,field2(A,R2),R2)
     => refl_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ).

% Refl_Restr
tff(fact_1261_trancl__insert2,axiom,
    ! [A: $tType,A4: A,B3: A,R2: set(product_prod(A,A))] : ( transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),R2)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_trancl(A,R2)),aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool))),aTP_Lamp_gx(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool)))),A4),B3),R2)))) ) ).

% trancl_insert2
tff(fact_1262_rel__restrict__Sigma__sub,axiom,
    ! [A: $tType,A3: set(A),R: set(A)] : pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),rel_restrict(A,transitive_trancl(A,product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))),R)),transitive_trancl(A,product_Sigma(A,A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),R),aa(set(A),fun(A,set(A)),aTP_Lamp_ee(set(A),fun(set(A),fun(A,set(A))),A3),R))))) ).

% rel_restrict_Sigma_sub
tff(fact_1263_UNION__singleton__eq__range,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_gy(fun(B,A),fun(B,set(A)),F2)),A3)) = aa(set(B),set(A),image2(B,A,F2),A3) ) ).

% UNION_singleton_eq_range
tff(fact_1264_vimage__eq__UN,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),B2: set(B)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),B2) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_gz(fun(A,B),fun(B,set(A)),F2)),B2)) ) ).

% vimage_eq_UN
tff(fact_1265_snd__image__Sigma,axiom,
    ! [A: $tType,B: $tType,A3: set(B),B2: fun(B,set(A))] : ( aa(set(product_prod(B,A)),set(A),image2(product_prod(B,A),A,product_snd(B,A)),product_Sigma(B,A,A3,B2)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3)) ) ).

% snd_image_Sigma
tff(fact_1266_Sigma__def,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: fun(A,set(B))] : ( product_Sigma(A,B,A3,B2) = aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(A),set(set(product_prod(A,B))),image2(A,set(product_prod(A,B)),aTP_Lamp_hb(fun(A,set(B)),fun(A,set(product_prod(A,B))),B2)),A3)) ) ).

% Sigma_def
tff(fact_1267_fun_Omap__ident,axiom,
    ! [A: $tType,D: $tType,T3: fun(D,A)] : ( aa(fun(D,A),fun(D,A),comp(A,A,D,aTP_Lamp_bk(A,A)),T3) = T3 ) ).

% fun.map_ident
tff(fact_1268_Id__on__def,axiom,
    ! [A: $tType,A3: set(A)] : ( id_on(A,A3) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(A),set(set(product_prod(A,A))),image2(A,set(product_prod(A,A)),aTP_Lamp_hc(A,set(product_prod(A,A)))),A3)) ) ).

% Id_on_def
tff(fact_1269_Refl__Field__Restr2,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( refl_on(A,field2(A,R2),R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),field2(A,R2)))
       => ( field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) = A3 ) ) ) ).

% Refl_Field_Restr2
tff(fact_1270_Refl__Field__Restr,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( refl_on(A,field2(A,R2),R2)
     => ( field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),field2(A,R2)),A3) ) ) ).

% Refl_Field_Restr
tff(fact_1271_rtrancl__last__visit,axiom,
    ! [A: $tType,Q3: A,Q5: A,R: set(product_prod(A,A)),S: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Q5)),transitive_rtrancl(A,R)))
     => ( ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Q5)),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_cr(set(A),fun(A,set(A)),S))))))
       => ~ ! [Qt: A] :
              ( pp(aa(set(A),bool,member(A,Qt),S))
             => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Qt)),transitive_trancl(A,R)))
               => ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Qt),Q5)),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_cr(set(A),fun(A,set(A)),S)))))) ) ) ) ) ).

% rtrancl_last_visit
tff(fact_1272_cSUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),C2: A] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hd(A,fun(B,A),C2)),A3)) = C2 ) ) ) ).

% cSUP_const
tff(fact_1273_cSup__singleton,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X2: A] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = X2 ) ) ).

% cSup_singleton
tff(fact_1274_ccpo__Sup__singleton,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [X2: A] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = X2 ) ) ).

% ccpo_Sup_singleton
tff(fact_1275_Union__image__empty,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(B,set(A))] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),F2),bot_bot(set(B))))) = A3 ) ).

% Union_image_empty
tff(fact_1276_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),F2: fun(B,A),M: A] :
          ( ( A3 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),A3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X)),M)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),M)) ) ) ) ).

% cSUP_least
tff(fact_1277_preorder__on__empty,axiom,
    ! [A: $tType] : order_preorder_on(A,bot_bot(set(A)),bot_bot(set(product_prod(A,A)))) ).

% preorder_on_empty
tff(fact_1278_UN__image__subset,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(B,set(A)),G: fun(C,set(B)),X2: C,X5: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),F2),aa(C,set(B),G,X2)))),X5))
    <=> pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(C,set(B),G,X2)),aa(fun(B,bool),set(B),collect(B),aa(set(A),fun(B,bool),aTP_Lamp_he(fun(B,set(A)),fun(set(A),fun(B,bool)),F2),X5)))) ) ).

% UN_image_subset
tff(fact_1279_finite__inf__Sup,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [A4: A,A3: set(A)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),aa(set(A),A,complete_Sup_Sup(A),A3)) = aa(set(A),A,complete_Sup_Sup(A),aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_hf(A,fun(set(A),fun(A,bool)),A4),A3))) ) ) ).

% finite_inf_Sup
tff(fact_1280_top__finite__def,axiom,
    ! [A: $tType] :
      ( finite_lattice(A)
     => ( top_top(A) = aa(set(A),A,complete_Sup_Sup(A),top_top(set(A))) ) ) ).

% top_finite_def
tff(fact_1281_Sup__nat__empty,axiom,
    aa(set(nat),nat,complete_Sup_Sup(nat),bot_bot(set(nat))) = zero_zero(nat) ).

% Sup_nat_empty
tff(fact_1282_in__Union__o__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,X2: A,Gset: fun(B,set(set(A))),Gmap: fun(C,B),A3: C] :
      ( pp(aa(set(A),bool,member(A,X2),aa(C,set(A),aa(fun(C,B),fun(C,set(A)),comp(B,set(A),C,aa(fun(B,set(set(A))),fun(B,set(A)),comp(set(set(A)),set(A),B,complete_Sup_Sup(set(A))),Gset)),Gmap),A3)))
     => pp(aa(set(A),bool,member(A,X2),aa(C,set(A),aa(fun(C,set(set(A))),fun(C,set(A)),comp(set(set(A)),set(A),C,complete_Sup_Sup(set(A))),aa(fun(C,B),fun(C,set(set(A))),comp(B,set(set(A)),C,Gset),Gmap)),A3))) ) ).

% in_Union_o_assoc
tff(fact_1283_UNIV__bool,axiom,
    top_top(set(bool)) = aa(set(bool),set(bool),insert(bool,fFalse),aa(set(bool),set(bool),insert(bool,fTrue),bot_bot(set(bool)))) ).

% UNIV_bool
tff(fact_1284_empty__natural,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F2: fun(A,C),G: fun(D,B)] : ( aa(fun(A,C),fun(A,set(B)),comp(C,set(B),A,aTP_Lamp_hg(C,set(B))),F2) = aa(fun(A,set(D)),fun(A,set(B)),comp(set(D),set(B),A,image2(D,B,G)),aTP_Lamp_hh(A,set(D))) ) ).

% empty_natural
tff(fact_1285_Union__natural,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B)] : ( aa(fun(set(set(A)),set(set(B))),fun(set(set(A)),set(B)),comp(set(set(B)),set(B),set(set(A)),complete_Sup_Sup(set(B))),image2(set(A),set(B),image2(A,B,F2))) = aa(fun(set(set(A)),set(A)),fun(set(set(A)),set(B)),comp(set(A),set(B),set(set(A)),image2(A,B,F2)),complete_Sup_Sup(set(A))) ) ).

% Union_natural
tff(fact_1286_SUP__UN__eq2,axiom,
    ! [A: $tType,B: $tType,C: $tType,R2: fun(C,set(product_prod(A,B))),S: set(C),X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Sup_Sup(fun(A,fun(B,bool))),aa(set(C),set(fun(A,fun(B,bool))),image2(C,fun(A,fun(B,bool)),aTP_Lamp_hi(fun(C,set(product_prod(A,B))),fun(C,fun(A,fun(B,bool))),R2)),S)),X4),Xa3))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(C),set(set(product_prod(A,B))),image2(C,set(product_prod(A,B)),R2),S)))) ) ).

% SUP_UN_eq2
tff(fact_1287_SUP__Sup__eq2,axiom,
    ! [B: $tType,A: $tType,S: set(set(product_prod(A,B))),X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Sup_Sup(fun(A,fun(B,bool))),aa(set(set(product_prod(A,B))),set(fun(A,fun(B,bool))),image2(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool)))),S)),X4),Xa3))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),S))) ) ).

% SUP_Sup_eq2
tff(fact_1288_SUP__Sup__eq,axiom,
    ! [A: $tType,S: set(set(A)),X4: A] :
      ( pp(aa(A,bool,aa(set(fun(A,bool)),fun(A,bool),complete_Sup_Sup(fun(A,bool)),aa(set(set(A)),set(fun(A,bool)),image2(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool))),S)),X4))
    <=> pp(aa(set(A),bool,member(A,X4),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),S))) ) ).

% SUP_Sup_eq
tff(fact_1289_Sup__set__def,axiom,
    ! [A: $tType,A3: set(set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_hj(set(set(A)),fun(A,bool),A3)) ) ).

% Sup_set_def
tff(fact_1290_Sup__SUP__eq2,axiom,
    ! [B: $tType,A: $tType,S: set(fun(A,fun(B,bool))),X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Sup_Sup(fun(A,fun(B,bool))),S),X4),Xa3))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(fun(product_prod(A,B),bool)),set(set(product_prod(A,B))),image2(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B))),aa(set(fun(A,fun(B,bool))),set(fun(product_prod(A,B),bool)),image2(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool)),S))))) ) ).

% Sup_SUP_eq2
tff(fact_1291_SUP__UN__eq,axiom,
    ! [A: $tType,B: $tType,R2: fun(B,set(A)),S: set(B),X4: A] :
      ( pp(aa(A,bool,aa(set(fun(A,bool)),fun(A,bool),complete_Sup_Sup(fun(A,bool)),aa(set(B),set(fun(A,bool)),image2(B,fun(A,bool),aTP_Lamp_hk(fun(B,set(A)),fun(B,fun(A,bool)),R2)),S)),X4))
    <=> pp(aa(set(A),bool,member(A,X4),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),R2),S)))) ) ).

% SUP_UN_eq
tff(fact_1292_case__prod__comp,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F2: fun(D,fun(C,A)),G: fun(B,D),X2: product_prod(B,C)] : ( aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),aa(fun(B,D),fun(B,fun(C,A)),comp(D,fun(C,A),B,F2),G)),X2) = aa(C,A,aa(D,fun(C,A),F2,aa(B,D,G,aa(product_prod(B,C),B,product_fst(B,C),X2))),aa(product_prod(B,C),C,product_snd(B,C),X2)) ) ).

% case_prod_comp
tff(fact_1293_fst__diag__fst,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(A,A)),fun(product_prod(A,B),A),comp(product_prod(A,A),A,product_prod(A,B),product_fst(A,A)),aa(fun(product_prod(A,B),A),fun(product_prod(A,B),product_prod(A,A)),comp(A,product_prod(A,A),product_prod(A,B),aTP_Lamp_hl(A,product_prod(A,A))),product_fst(A,B))) = product_fst(A,B) ) ).

% fst_diag_fst
tff(fact_1294_snd__diag__snd,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(B,B)),fun(product_prod(A,B),B),comp(product_prod(B,B),B,product_prod(A,B),product_snd(B,B)),aa(fun(product_prod(A,B),B),fun(product_prod(A,B),product_prod(B,B)),comp(B,product_prod(B,B),product_prod(A,B),aTP_Lamp_hm(B,product_prod(B,B))),product_snd(A,B))) = product_snd(A,B) ) ).

% snd_diag_snd
tff(fact_1295_snd__diag__fst,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(A,A)),fun(product_prod(A,B),A),comp(product_prod(A,A),A,product_prod(A,B),product_snd(A,A)),aa(fun(product_prod(A,B),A),fun(product_prod(A,B),product_prod(A,A)),comp(A,product_prod(A,A),product_prod(A,B),aTP_Lamp_hl(A,product_prod(A,A))),product_fst(A,B))) = product_fst(A,B) ) ).

% snd_diag_fst
tff(fact_1296_fst__diag__snd,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(B,B)),fun(product_prod(A,B),B),comp(product_prod(B,B),B,product_prod(A,B),product_fst(B,B)),aa(fun(product_prod(A,B),B),fun(product_prod(A,B),product_prod(B,B)),comp(B,product_prod(B,B),product_prod(A,B),aTP_Lamp_hm(B,product_prod(B,B))),product_snd(A,B))) = product_snd(A,B) ) ).

% fst_diag_snd
tff(fact_1297_conj__subset__def,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,bool),Q: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q))))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(fun(A,bool),set(A),collect(A),P)))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(fun(A,bool),set(A),collect(A),Q))) ) ) ).

% conj_subset_def
tff(fact_1298_cSup__least,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X5: set(A),Z2: A] :
          ( ( X5 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),X5))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Z2)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),X5)),Z2)) ) ) ) ).

% cSup_least
tff(fact_1299_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X5: set(A),A4: A] :
          ( ( X5 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),X5))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),A4)) )
           => ( ! [Y2: A] :
                  ( ! [X4: A] :
                      ( pp(aa(set(A),bool,member(A,X4),X5))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Y2)) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),Y2)) )
             => ( aa(set(A),A,complete_Sup_Sup(A),X5) = A4 ) ) ) ) ) ).

% cSup_eq_non_empty
tff(fact_1300_UN__UN__split__split__eq,axiom,
    ! [D: $tType,E: $tType,A: $tType,C: $tType,B: $tType,A3: fun(B,fun(C,fun(D,fun(E,set(A))))),Y3: set(product_prod(D,E)),X5: set(product_prod(B,C))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(product_prod(B,C)),set(set(A)),image2(product_prod(B,C),set(A),aa(fun(B,fun(C,set(A))),fun(product_prod(B,C),set(A)),product_case_prod(B,C,set(A)),aa(set(product_prod(D,E)),fun(B,fun(C,set(A))),aTP_Lamp_hn(fun(B,fun(C,fun(D,fun(E,set(A))))),fun(set(product_prod(D,E)),fun(B,fun(C,set(A)))),A3),Y3))),X5)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(product_prod(B,C)),set(set(A)),image2(product_prod(B,C),set(A),aa(set(product_prod(D,E)),fun(product_prod(B,C),set(A)),aTP_Lamp_hq(fun(B,fun(C,fun(D,fun(E,set(A))))),fun(set(product_prod(D,E)),fun(product_prod(B,C),set(A))),A3),Y3)),X5)) ) ).

% UN_UN_split_split_eq
tff(fact_1301_subset__mset_OcSUP__const,axiom,
    ! [B: $tType,A: $tType,A3: set(B),C2: multiset(A)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),aTP_Lamp_hr(multiset(A),fun(B,multiset(A)),C2)),A3)) = C2 ) ) ).

% subset_mset.cSUP_const
tff(fact_1302_typedef__rep__transfer,axiom,
    ! [A: $tType,B: $tType,Rep: fun(B,A),Abs: fun(A,B),A3: set(A),T2: fun(A,fun(B,bool))] :
      ( type_definition(B,A,Rep,Abs,A3)
     => ( ! [X: A,Xa4: B] :
            ( pp(aa(B,bool,aa(A,fun(B,bool),T2,X),Xa4))
          <=> ( X = aa(B,A,Rep,Xa4) ) )
       => pp(aa(fun(B,A),bool,aa(fun(A,A),fun(fun(B,A),bool),bNF_rel_fun(A,B,A,A,T2,fequal(A)),aTP_Lamp_bk(A,A)),Rep)) ) ) ).

% typedef_rep_transfer
tff(fact_1303_UN__constant__eq,axiom,
    ! [A: $tType,B: $tType,A4: A,A3: set(A),F2: fun(A,set(B)),C2: set(B)] :
      ( pp(aa(set(A),bool,member(A,A4),A3))
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),A3))
           => ( aa(A,set(B),F2,X) = C2 ) )
       => ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),F2),A3)) = C2 ) ) ) ).

% UN_constant_eq
tff(fact_1304_UNION__fun__upd,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),I2: B,B2: set(A),J: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),fun_upd(B,set(A),A3,I2,B2)),J)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),J),aa(set(B),set(B),insert(B,I2),bot_bot(set(B))))))),if(set(A),aa(set(B),bool,member(B,I2),J),B2,bot_bot(set(A)))) ) ).

% UNION_fun_upd
tff(fact_1305_linear__order__on__singleton,axiom,
    ! [A: $tType,X2: A] : order_679001287576687338der_on(A,aa(set(A),set(A),insert(A,X2),bot_bot(set(A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2)),bot_bot(set(product_prod(A,A))))) ).

% linear_order_on_singleton
tff(fact_1306_Total__subset__Id,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( total_on(A,field2(A,R2),R2)
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),id2(A)))
       => ( ( R2 = bot_bot(set(product_prod(A,A))) )
          | ? [A5: A] : ( R2 = aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A5),A5)),bot_bot(set(product_prod(A,A)))) ) ) ) ) ).

% Total_subset_Id
tff(fact_1307_INT__simps_I4_J,axiom,
    ! [G3: $tType,H8: $tType,C3: set(H8),A3: set(G3),B2: fun(H8,set(G3))] :
      ( ( ( C3 = bot_bot(set(H8)) )
       => ( aa(set(set(G3)),set(G3),complete_Inf_Inf(set(G3)),aa(set(H8),set(set(G3)),image2(H8,set(G3),aa(fun(H8,set(G3)),fun(H8,set(G3)),aTP_Lamp_hs(set(G3),fun(fun(H8,set(G3)),fun(H8,set(G3))),A3),B2)),C3)) = top_top(set(G3)) ) )
      & ( ( C3 != bot_bot(set(H8)) )
       => ( aa(set(set(G3)),set(G3),complete_Inf_Inf(set(G3)),aa(set(H8),set(set(G3)),image2(H8,set(G3),aa(fun(H8,set(G3)),fun(H8,set(G3)),aTP_Lamp_hs(set(G3),fun(fun(H8,set(G3)),fun(H8,set(G3))),A3),B2)),C3)) = aa(set(G3),set(G3),aa(set(G3),fun(set(G3),set(G3)),minus_minus(set(G3)),A3),aa(set(set(G3)),set(G3),complete_Sup_Sup(set(G3)),aa(set(H8),set(set(G3)),image2(H8,set(G3),B2),C3))) ) ) ) ).

% INT_simps(4)
tff(fact_1308_subset__mset_OcSup__singleton,axiom,
    ! [A: $tType,X2: multiset(A)] : ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) = X2 ) ).

% subset_mset.cSup_singleton
tff(fact_1309_Inf__top__conv_I1_J,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),A,complete_Inf_Inf(A),A3) = top_top(A) )
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),A3))
             => ( X3 = top_top(A) ) ) ) ) ).

% Inf_top_conv(1)
tff(fact_1310_Inf__top__conv_I2_J,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( ( top_top(A) = aa(set(A),A,complete_Inf_Inf(A),A3) )
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),A3))
             => ( X3 = top_top(A) ) ) ) ) ).

% Inf_top_conv(2)
tff(fact_1311_INF__identity__eq,axiom,
    ! [A: $tType] :
      ( complete_Inf(A)
     => ! [A3: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),image2(A,A,aTP_Lamp_ht(A,A)),A3)) = aa(set(A),A,complete_Inf_Inf(A),A3) ) ) ).

% INF_identity_eq
tff(fact_1312_INT__I,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B3: B,B2: fun(A,set(B))] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),A3))
         => pp(aa(set(B),bool,member(B,B3),aa(A,set(B),B2,X))) )
     => pp(aa(set(B),bool,member(B,B3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),B2),A3)))) ) ).

% INT_I
tff(fact_1313_INT__iff,axiom,
    ! [A: $tType,B: $tType,B3: A,B2: fun(B,set(A)),A3: set(B)] :
      ( pp(aa(set(A),bool,member(A,B3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3))))
    <=> ! [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),A3))
         => pp(aa(set(A),bool,member(A,B3),aa(B,set(A),B2,X3))) ) ) ).

% INT_iff
tff(fact_1314_Inf__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( complete_Inf(B)
     => ! [A3: set(fun(A,B)),X2: A] : ( aa(A,B,aa(set(fun(A,B)),fun(A,B),complete_Inf_Inf(fun(A,B)),A3),X2) = aa(set(B),B,complete_Inf_Inf(B),aa(set(fun(A,B)),set(B),image2(fun(A,B),B,aTP_Lamp_hu(A,fun(fun(A,B),B),X2)),A3)) ) ) ).

% Inf_apply
tff(fact_1315_Inf__empty,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ( aa(set(A),A,complete_Inf_Inf(A),bot_bot(set(A))) = top_top(A) ) ) ).

% Inf_empty
tff(fact_1316_SUP2__I,axiom,
    ! [B: $tType,A: $tType,C: $tType,A4: A,A3: set(A),B2: fun(A,fun(B,fun(C,bool))),B3: B,C2: C] :
      ( pp(aa(set(A),bool,member(A,A4),A3))
     => ( pp(aa(C,bool,aa(B,fun(C,bool),aa(A,fun(B,fun(C,bool)),B2,A4),B3),C2))
       => pp(aa(C,bool,aa(B,fun(C,bool),aa(set(fun(B,fun(C,bool))),fun(B,fun(C,bool)),complete_Sup_Sup(fun(B,fun(C,bool))),aa(set(A),set(fun(B,fun(C,bool))),image2(A,fun(B,fun(C,bool)),B2),A3)),B3),C2)) ) ) ).

% SUP2_I
tff(fact_1317_Inf__UNIV,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ( aa(set(A),A,complete_Inf_Inf(A),top_top(set(A))) = bot_bot(A) ) ) ).

% Inf_UNIV
tff(fact_1318_cInf__singleton,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X2: A] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = X2 ) ) ).

% cInf_singleton
tff(fact_1319_Inf__insert,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: A,A3: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert(A,A4),A3)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),aa(set(A),A,complete_Inf_Inf(A),A3)) ) ) ).

% Inf_insert
tff(fact_1320_SUP1__I,axiom,
    ! [A: $tType,B: $tType,A4: A,A3: set(A),B2: fun(A,fun(B,bool)),B3: B] :
      ( pp(aa(set(A),bool,member(A,A4),A3))
     => ( pp(aa(B,bool,aa(A,fun(B,bool),B2,A4),B3))
       => pp(aa(B,bool,aa(set(fun(B,bool)),fun(B,bool),complete_Sup_Sup(fun(B,bool)),aa(set(A),set(fun(B,bool)),image2(A,fun(B,bool),B2),A3)),B3)) ) ) ).

% SUP1_I
tff(fact_1321_rtrancl__empty,axiom,
    ! [A: $tType] : ( transitive_rtrancl(A,bot_bot(set(product_prod(A,A)))) = id2(A) ) ).

% rtrancl_empty
tff(fact_1322_INF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),F2: A] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_fh(A,fun(B,A),F2)),A3)) = F2 ) ) ) ).

% INF_const
tff(fact_1323_cINF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),C2: A] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hd(A,fun(B,A),C2)),A3)) = C2 ) ) ) ).

% cINF_const
tff(fact_1324_INF__top__conv_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B2: fun(B,A),A3: set(B)] :
          ( ( top_top(A) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,B2),A3)) )
        <=> ! [X3: B] :
              ( pp(aa(set(B),bool,member(B,X3),A3))
             => ( aa(B,A,B2,X3) = top_top(A) ) ) ) ) ).

% INF_top_conv(2)
tff(fact_1325_INF__top__conv_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B2: fun(B,A),A3: set(B)] :
          ( ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,B2),A3)) = top_top(A) )
        <=> ! [X3: B] :
              ( pp(aa(set(B),bool,member(B,X3),A3))
             => ( aa(B,A,B2,X3) = top_top(A) ) ) ) ) ).

% INF_top_conv(1)
tff(fact_1326_INF__top,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hv(B,A)),A3)) = top_top(A) ) ) ).

% INF_top
tff(fact_1327_INF__apply,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( complete_Inf(A)
     => ! [F2: fun(C,fun(B,A)),A3: set(C),X2: B] : ( aa(B,A,aa(set(fun(B,A)),fun(B,A),complete_Inf_Inf(fun(B,A)),aa(set(C),set(fun(B,A)),image2(C,fun(B,A),F2),A3)),X2) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,aa(B,fun(C,A),aTP_Lamp_hw(fun(C,fun(B,A)),fun(B,fun(C,A)),F2),X2)),A3)) ) ) ).

% INF_apply
tff(fact_1328_INT__constant,axiom,
    ! [B: $tType,A: $tType,A3: set(B),C2: set(A)] :
      ( ( ( A3 = bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_bv(set(A),fun(B,set(A)),C2)),A3)) = top_top(set(A)) ) )
      & ( ( A3 != bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_bv(set(A),fun(B,set(A)),C2)),A3)) = C2 ) ) ) ).

% INT_constant
tff(fact_1329_INT__insert,axiom,
    ! [A: $tType,B: $tType,B2: fun(B,set(A)),A4: B,A3: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),aa(set(B),set(B),insert(B,A4),A3))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(B,set(A),B2,A4)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3))) ) ).

% INT_insert
tff(fact_1330_Compl__UN,axiom,
    ! [A: $tType,B: $tType,B2: fun(B,set(A)),A3: set(B)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3))) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_hx(fun(B,set(A)),fun(B,set(A)),B2)),A3)) ) ).

% Compl_UN
tff(fact_1331_Compl__INT,axiom,
    ! [A: $tType,B: $tType,B2: fun(B,set(A)),A3: set(B)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_hx(fun(B,set(A)),fun(B,set(A)),B2)),A3)) ) ).

% Compl_INT
tff(fact_1332_INT__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set(A),A3: fun(A,set(B)),B2: set(B)] :
      ( ( ( C3 = bot_bot(set(A)) )
       => ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_hy(fun(A,set(B)),fun(set(B),fun(A,set(B))),A3),B2)),C3)) = top_top(set(B)) ) )
      & ( ( C3 != bot_bot(set(A)) )
       => ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_hy(fun(A,set(B)),fun(set(B),fun(A,set(B))),A3),B2)),C3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),C3))),B2) ) ) ) ).

% INT_simps(1)
tff(fact_1333_INT__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set(D),A3: set(C),B2: fun(D,set(C))] :
      ( ( ( C3 = bot_bot(set(D)) )
       => ( aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),aa(fun(D,set(C)),fun(D,set(C)),aTP_Lamp_hz(set(C),fun(fun(D,set(C)),fun(D,set(C))),A3),B2)),C3)) = top_top(set(C)) ) )
      & ( ( C3 != bot_bot(set(D)) )
       => ( aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),aa(fun(D,set(C)),fun(D,set(C)),aTP_Lamp_hz(set(C),fun(fun(D,set(C)),fun(D,set(C))),A3),B2)),C3)) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B2),C3))) ) ) ) ).

% INT_simps(2)
tff(fact_1334_INT__simps_I3_J,axiom,
    ! [E: $tType,F10: $tType,C3: set(E),A3: fun(E,set(F10)),B2: set(F10)] :
      ( ( ( C3 = bot_bot(set(E)) )
       => ( aa(set(set(F10)),set(F10),complete_Inf_Inf(set(F10)),aa(set(E),set(set(F10)),image2(E,set(F10),aa(set(F10),fun(E,set(F10)),aTP_Lamp_ia(fun(E,set(F10)),fun(set(F10),fun(E,set(F10))),A3),B2)),C3)) = top_top(set(F10)) ) )
      & ( ( C3 != bot_bot(set(E)) )
       => ( aa(set(set(F10)),set(F10),complete_Inf_Inf(set(F10)),aa(set(E),set(set(F10)),image2(E,set(F10),aa(set(F10),fun(E,set(F10)),aTP_Lamp_ia(fun(E,set(F10)),fun(set(F10),fun(E,set(F10))),A3),B2)),C3)) = aa(set(F10),set(F10),aa(set(F10),fun(set(F10),set(F10)),minus_minus(set(F10)),aa(set(set(F10)),set(F10),complete_Inf_Inf(set(F10)),aa(set(E),set(set(F10)),image2(E,set(F10),A3),C3))),B2) ) ) ) ).

% INT_simps(3)
tff(fact_1335_Sup__multiset__empty,axiom,
    ! [A: $tType] : ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),bot_bot(set(multiset(A)))) = zero_zero(multiset(A)) ) ).

% Sup_multiset_empty
tff(fact_1336_SUP2__E,axiom,
    ! [A: $tType,C: $tType,B: $tType,B2: fun(C,fun(A,fun(B,bool))),A3: set(C),B3: A,C2: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Sup_Sup(fun(A,fun(B,bool))),aa(set(C),set(fun(A,fun(B,bool))),image2(C,fun(A,fun(B,bool)),B2),A3)),B3),C2))
     => ~ ! [X: C] :
            ( pp(aa(set(C),bool,member(C,X),A3))
           => ~ pp(aa(B,bool,aa(A,fun(B,bool),aa(C,fun(A,fun(B,bool)),B2,X),B3),C2)) ) ) ).

% SUP2_E
tff(fact_1337_SUP1__E,axiom,
    ! [B: $tType,A: $tType,B2: fun(B,fun(A,bool)),A3: set(B),B3: A] :
      ( pp(aa(A,bool,aa(set(fun(A,bool)),fun(A,bool),complete_Sup_Sup(fun(A,bool)),aa(set(B),set(fun(A,bool)),image2(B,fun(A,bool),B2),A3)),B3))
     => ~ ! [X: B] :
            ( pp(aa(set(B),bool,member(B,X),A3))
           => ~ pp(aa(A,bool,aa(B,fun(A,bool),B2,X),B3)) ) ) ).

% SUP1_E
tff(fact_1338_Inf__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( complete_Inf(B)
     => ! [A3: set(fun(A,B)),X4: A] : ( aa(A,B,aa(set(fun(A,B)),fun(A,B),complete_Inf_Inf(fun(A,B)),A3),X4) = aa(set(B),B,complete_Inf_Inf(B),aa(set(fun(A,B)),set(B),image2(fun(A,B),B,aTP_Lamp_hu(A,fun(fun(A,B),B),X4)),A3)) ) ) ).

% Inf_fun_def
tff(fact_1339_Inter__UNIV,axiom,
    ! [A: $tType] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),top_top(set(set(A)))) = bot_bot(set(A)) ) ).

% Inter_UNIV
tff(fact_1340_Inter__Un__distrib,axiom,
    ! [A: $tType,A3: set(set(A)),B2: set(set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),A3),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B2)) ) ).

% Inter_Un_distrib
tff(fact_1341_INF__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,fun(C,A)),B2: set(C),A3: set(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(set(C),fun(B,A),aTP_Lamp_ib(fun(B,fun(C,A)),fun(set(C),fun(B,A)),F2),B2)),A3)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,aa(set(B),fun(C,A),aTP_Lamp_ic(fun(B,fun(C,A)),fun(set(B),fun(C,A)),F2),A3)),B2)) ) ) ).

% INF_commute
tff(fact_1342_INT__D,axiom,
    ! [A: $tType,B: $tType,B3: A,B2: fun(B,set(A)),A3: set(B),A4: B] :
      ( pp(aa(set(A),bool,member(A,B3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3))))
     => ( pp(aa(set(B),bool,member(B,A4),A3))
       => pp(aa(set(A),bool,member(A,B3),aa(B,set(A),B2,A4))) ) ) ).

% INT_D
tff(fact_1343_INT__E,axiom,
    ! [A: $tType,B: $tType,B3: A,B2: fun(B,set(A)),A3: set(B),A4: B] :
      ( pp(aa(set(A),bool,member(A,B3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3))))
     => ( ~ pp(aa(set(A),bool,member(A,B3),aa(B,set(A),B2,A4)))
       => ~ pp(aa(set(B),bool,member(B,A4),A3)) ) ) ).

% INT_E
tff(fact_1344_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),U: A] :
          ( ! [V2: A] :
              ( pp(aa(set(A),bool,member(A,V2),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),V2),U)) )
         => ( ( A3 != bot_bot(set(A)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),U)) ) ) ) ).

% Inf_less_eq
tff(fact_1345_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X5: set(A),A4: A] :
          ( ( X5 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),X5))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),X)) )
           => ( ! [Y2: A] :
                  ( ! [X4: A] :
                      ( pp(aa(set(A),bool,member(A,X4),X5))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X4)) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),A4)) )
             => ( aa(set(A),A,complete_Inf_Inf(A),X5) = A4 ) ) ) ) ) ).

% cInf_eq_non_empty
tff(fact_1346_cInf__greatest,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X5: set(A),Z2: A] :
          ( ( X5 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),X5))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),X)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),aa(set(A),A,complete_Inf_Inf(A),X5))) ) ) ) ).

% cInf_greatest
tff(fact_1347_INF__eq__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I: set(B),F2: fun(B,A),X2: A] :
          ( ( I != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,member(B,I3),I))
               => ( aa(B,A,F2,I3) = X2 ) )
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),I)) = X2 ) ) ) ) ).

% INF_eq_const
tff(fact_1348_bot__finite__def,axiom,
    ! [A: $tType] :
      ( finite_lattice(A)
     => ( bot_bot(A) = aa(set(A),A,complete_Inf_Inf(A),top_top(set(A))) ) ) ).

% bot_finite_def
tff(fact_1349_Inf__sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B2: set(A),A4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),B2)),A4) = top_top(A) )
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),B2))
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X3),A4) = top_top(A) ) ) ) ) ).

% Inf_sup_eq_top_iff
tff(fact_1350_Inf__finite__insert,axiom,
    ! [A: $tType] :
      ( finite_lattice(A)
     => ! [A4: A,A3: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert(A,A4),A3)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),aa(set(A),A,complete_Inf_Inf(A),A3)) ) ) ).

% Inf_finite_insert
tff(fact_1351_Inf__union__distrib,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),B2: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B2)) ) ) ).

% Inf_union_distrib
tff(fact_1352_Inter__subset,axiom,
    ! [A: $tType,A3: set(set(A)),B2: set(A)] :
      ( ! [X6: set(A)] :
          ( pp(aa(set(set(A)),bool,member(set(A),X6),A3))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X6),B2)) )
     => ( ( A3 != bot_bot(set(set(A))) )
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3)),B2)) ) ) ).

% Inter_subset
tff(fact_1353_Inter__empty,axiom,
    ! [A: $tType] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),bot_bot(set(set(A)))) = top_top(set(A)) ) ).

% Inter_empty
tff(fact_1354_inj__on__Inter,axiom,
    ! [B: $tType,A: $tType,S: set(set(A)),F2: fun(A,B)] :
      ( ( S != bot_bot(set(set(A))) )
     => ( ! [A11: set(A)] :
            ( pp(aa(set(set(A)),bool,member(set(A),A11),S))
           => inj_on(A,B,F2,A11) )
       => inj_on(A,B,F2,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),S)) ) ) ).

% inj_on_Inter
tff(fact_1355_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),X2: A,F2: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(B,A,F2,I3))) )
         => ( ! [Y2: A] :
                ( ! [I4: B] :
                    ( pp(aa(set(B),bool,member(B,I4),A3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),aa(B,A,F2,I4))) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X2)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3)) = X2 ) ) ) ) ).

% INF_eqI
tff(fact_1356_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B2: set(B),A3: set(C),F2: fun(C,A),G: fun(B,A)] :
          ( ! [M3: B] :
              ( pp(aa(set(B),bool,member(B,M3),B2))
             => ? [X4: C] :
                  ( pp(aa(set(C),bool,member(C,X4),A3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(C,A,F2,X4)),aa(B,A,G,M3))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,F2),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),B2)))) ) ) ).

% INF_mono
tff(fact_1357_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I2: B,A3: set(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,member(B,I2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(B,A,F2,I2))) ) ) ).

% INF_lower
tff(fact_1358_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),G: fun(B,A),A3: set(B)] :
          ( ! [X: B] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X)),aa(B,A,G,X)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),A3)))) ) ) ).

% INF_mono'
tff(fact_1359_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I2: B,A3: set(B),F2: fun(B,A),U: A] :
          ( pp(aa(set(B),bool,member(B,I2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I2)),U))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))),U)) ) ) ) ).

% INF_lower2
tff(fact_1360_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [U: A,F2: fun(B,A),A3: set(B)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))))
        <=> ! [X3: B] :
              ( pp(aa(set(B),bool,member(B,X3),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(B,A,F2,X3))) ) ) ) ).

% le_INF_iff
tff(fact_1361_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),U: A,F2: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(B,A,F2,I3))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3)))) ) ) ).

% INF_greatest
tff(fact_1362_INF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),A3: set(B),G: fun(B,A)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),A3))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_id(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),A3)) ) ) ).

% INF_inf_distrib
tff(fact_1363_INF__absorb,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [K: B,I: set(B),A3: fun(B,A)] :
          ( pp(aa(set(B),bool,member(B,K),I))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,A3,K)),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,A3),I))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,A3),I)) ) ) ) ).

% INF_absorb
tff(fact_1364_INF__sup__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F2: fun(B,A),A3: set(B),G: fun(C,A),B2: set(C)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,G),B2))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_if(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),F2),G),B2)),A3)) ) ) ).

% INF_sup_distrib2
tff(fact_1365_sup__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A4: A,F2: fun(B,A),B2: set(B)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),B2))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ig(A,fun(fun(B,A),fun(B,A)),A4),F2)),B2)) ) ) ).

% sup_INF
tff(fact_1366_Inf__sup,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B2: set(A),A4: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),B2)),A4) = aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),image2(A,A,aTP_Lamp_ih(A,fun(A,A),A4)),B2)) ) ) ).

% Inf_sup
tff(fact_1367_INF__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F2: fun(B,A),B2: set(B),A4: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),B2))),A4) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_ii(fun(B,A),fun(A,fun(B,A)),F2),A4)),B2)) ) ) ).

% INF_sup
tff(fact_1368_Inter__insert,axiom,
    ! [A: $tType,A4: set(A),B2: set(set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),insert(set(A),A4),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B2)) ) ).

% Inter_insert
tff(fact_1369_INT__extend__simps_I10_J,axiom,
    ! [V3: $tType,U3: $tType,T: $tType,B2: fun(U3,set(V3)),F2: fun(T,U3),A3: set(T)] : ( aa(set(set(V3)),set(V3),complete_Inf_Inf(set(V3)),aa(set(T),set(set(V3)),image2(T,set(V3),aa(fun(T,U3),fun(T,set(V3)),aTP_Lamp_gg(fun(U3,set(V3)),fun(fun(T,U3),fun(T,set(V3))),B2),F2)),A3)) = aa(set(set(V3)),set(V3),complete_Inf_Inf(set(V3)),aa(set(U3),set(set(V3)),image2(U3,set(V3),B2),aa(set(T),set(U3),image2(T,U3,F2),A3))) ) ).

% INT_extend_simps(10)
tff(fact_1370_INT__lower,axiom,
    ! [B: $tType,A: $tType,A4: A,A3: set(A),B2: fun(A,set(B))] :
      ( pp(aa(set(A),bool,member(A,A4),A3))
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),B2),A3))),aa(A,set(B),B2,A4))) ) ).

% INT_lower
tff(fact_1371_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A3: set(A),C3: set(B),B2: fun(A,set(B))] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),A3))
         => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),C3),aa(A,set(B),B2,X))) )
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),C3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),B2),A3)))) ) ).

% INT_greatest
tff(fact_1372_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: set(A),F2: fun(A,set(B)),G: fun(A,set(B))] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),A3))
           => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),F2,X)),aa(A,set(B),G,X))) )
       => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),F2),B2))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),G),A3)))) ) ) ).

% INT_anti_mono
tff(fact_1373_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B2: set(A),A3: fun(B,set(A)),I: set(B)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))))
    <=> ! [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),I))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),aa(B,set(A),A3,X3))) ) ) ).

% INT_subset_iff
tff(fact_1374_INT__extend__simps_I5_J,axiom,
    ! [I5: $tType,J3: $tType,A4: I5,B2: fun(J3,set(I5)),C3: set(J3)] : ( aa(set(I5),set(I5),insert(I5,A4),aa(set(set(I5)),set(I5),complete_Inf_Inf(set(I5)),aa(set(J3),set(set(I5)),image2(J3,set(I5),B2),C3))) = aa(set(set(I5)),set(I5),complete_Inf_Inf(set(I5)),aa(set(J3),set(set(I5)),image2(J3,set(I5),aa(fun(J3,set(I5)),fun(J3,set(I5)),aTP_Lamp_ij(I5,fun(fun(J3,set(I5)),fun(J3,set(I5))),A4),B2)),C3)) ) ).

% INT_extend_simps(5)
tff(fact_1375_INT__insert__distrib,axiom,
    ! [B: $tType,A: $tType,U: A,A3: set(A),A4: B,B2: fun(A,set(B))] :
      ( pp(aa(set(A),bool,member(A,U),A3))
     => ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_gj(B,fun(fun(A,set(B)),fun(A,set(B))),A4),B2)),A3)) = aa(set(B),set(B),insert(B,A4),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),B2),A3))) ) ) ).

% INT_insert_distrib
tff(fact_1376_INTER__UNIV__conv_I1_J,axiom,
    ! [B: $tType,A: $tType,B2: fun(B,set(A)),A3: set(B)] :
      ( ( top_top(set(A)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3)) )
    <=> ! [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),A3))
         => ( aa(B,set(A),B2,X3) = top_top(set(A)) ) ) ) ).

% INTER_UNIV_conv(1)
tff(fact_1377_INTER__UNIV__conv_I2_J,axiom,
    ! [B: $tType,A: $tType,B2: fun(B,set(A)),A3: set(B)] :
      ( ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3)) = top_top(set(A)) )
    <=> ! [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),A3))
         => ( aa(B,set(A),B2,X3) = top_top(set(A)) ) ) ) ).

% INTER_UNIV_conv(2)
tff(fact_1378_Int__Inter__image,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),B2: fun(B,set(A)),C3: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_ik(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),A3),B2)),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),C3))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),C3))) ) ).

% Int_Inter_image
tff(fact_1379_INT__Int__distrib,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),B2: fun(B,set(A)),I: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_ik(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),A3),B2)),I)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),I))) ) ).

% INT_Int_distrib
tff(fact_1380_INT__absorb,axiom,
    ! [B: $tType,A: $tType,K: A,I: set(A),A3: fun(A,set(B))] :
      ( pp(aa(set(A),bool,member(A,K),I))
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),A3,K)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),I))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),I)) ) ) ).

% INT_absorb
tff(fact_1381_Un__INT__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType,A3: fun(B,set(A)),I: set(B),B2: fun(C,set(A)),J: set(C)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image2(C,set(A),B2),J))) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(set(C),fun(B,set(A)),aa(fun(C,set(A)),fun(set(C),fun(B,set(A))),aTP_Lamp_im(fun(B,set(A)),fun(fun(C,set(A)),fun(set(C),fun(B,set(A)))),A3),B2),J)),I)) ) ).

% Un_INT_distrib2
tff(fact_1382_Un__INT__distrib,axiom,
    ! [A: $tType,B: $tType,B2: set(A),A3: fun(B,set(A)),I: set(B)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_in(set(A),fun(fun(B,set(A)),fun(B,set(A))),B2),A3)),I)) ) ).

% Un_INT_distrib
tff(fact_1383_INT__extend__simps_I6_J,axiom,
    ! [L2: $tType,K4: $tType,A3: fun(K4,set(L2)),C3: set(K4),B2: set(L2)] : ( aa(set(L2),set(L2),aa(set(L2),fun(set(L2),set(L2)),sup_sup(set(L2)),aa(set(set(L2)),set(L2),complete_Inf_Inf(set(L2)),aa(set(K4),set(set(L2)),image2(K4,set(L2),A3),C3))),B2) = aa(set(set(L2)),set(L2),complete_Inf_Inf(set(L2)),aa(set(K4),set(set(L2)),image2(K4,set(L2),aa(set(L2),fun(K4,set(L2)),aTP_Lamp_io(fun(K4,set(L2)),fun(set(L2),fun(K4,set(L2))),A3),B2)),C3)) ) ).

% INT_extend_simps(6)
tff(fact_1384_INT__extend__simps_I7_J,axiom,
    ! [M4: $tType,N3: $tType,A3: set(M4),B2: fun(N3,set(M4)),C3: set(N3)] : ( aa(set(M4),set(M4),aa(set(M4),fun(set(M4),set(M4)),sup_sup(set(M4)),A3),aa(set(set(M4)),set(M4),complete_Inf_Inf(set(M4)),aa(set(N3),set(set(M4)),image2(N3,set(M4),B2),C3))) = aa(set(set(M4)),set(M4),complete_Inf_Inf(set(M4)),aa(set(N3),set(set(M4)),image2(N3,set(M4),aa(fun(N3,set(M4)),fun(N3,set(M4)),aTP_Lamp_ip(set(M4),fun(fun(N3,set(M4)),fun(N3,set(M4))),A3),B2)),C3)) ) ).

% INT_extend_simps(7)
tff(fact_1385_INT__extend__simps_I9_J,axiom,
    ! [S5: $tType,R4: $tType,Q6: $tType,C3: fun(R4,set(S5)),B2: fun(Q6,set(R4)),A3: set(Q6)] : ( aa(set(set(S5)),set(S5),complete_Inf_Inf(set(S5)),aa(set(Q6),set(set(S5)),image2(Q6,set(S5),aa(fun(Q6,set(R4)),fun(Q6,set(S5)),aTP_Lamp_iq(fun(R4,set(S5)),fun(fun(Q6,set(R4)),fun(Q6,set(S5))),C3),B2)),A3)) = aa(set(set(S5)),set(S5),complete_Inf_Inf(set(S5)),aa(set(R4),set(set(S5)),image2(R4,set(S5),C3),aa(set(set(R4)),set(R4),complete_Sup_Sup(set(R4)),aa(set(Q6),set(set(R4)),image2(Q6,set(R4),B2),A3)))) ) ).

% INT_extend_simps(9)
tff(fact_1386_vimage__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(A,B),B2: fun(C,set(B)),A3: set(C)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3))) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_gr(fun(A,B),fun(fun(C,set(B)),fun(C,set(A))),F2),B2)),A3)) ) ).

% vimage_INT
tff(fact_1387_Id__def,axiom,
    ! [A: $tType] : ( id2(A) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aTP_Lamp_ir(product_prod(A,A),bool)) ) ).

% Id_def
tff(fact_1388_Un__Inter,axiom,
    ! [A: $tType,A3: set(A),B2: set(set(A))] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B2)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),image2(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3)),B2)) ) ).

% Un_Inter
tff(fact_1389_Id__fstsnd__eq,axiom,
    ! [A: $tType] : ( id2(A) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aTP_Lamp_is(product_prod(A,A),bool)) ) ).

% Id_fstsnd_eq
tff(fact_1390_INF__eq__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I: set(B),F2: fun(B,A),C2: A] :
          ( ( I != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,member(B,I3),I))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),C2)) )
           => ( ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),I)) = C2 )
            <=> ! [X3: B] :
                  ( pp(aa(set(B),bool,member(B,X3),I))
                 => ( aa(B,A,F2,X3) = C2 ) ) ) ) ) ) ).

% INF_eq_iff
tff(fact_1391_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),M2: A,F2: fun(B,A)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),A3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M2),aa(B,A,F2,X))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M2),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3)))) ) ) ) ).

% cINF_greatest
tff(fact_1392_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( ( A3 != bot_bot(set(A)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Sup_Sup(A),A3))) ) ) ).

% Inf_le_Sup
tff(fact_1393_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),B2: set(A)] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B2))),aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)))) ) ).

% less_eq_Inf_inter
tff(fact_1394_Inf__finite__empty,axiom,
    ! [A: $tType] :
      ( finite_lattice(A)
     => ( aa(set(A),A,complete_Inf_Inf(A),bot_bot(set(A))) = aa(set(A),A,complete_Sup_Sup(A),top_top(set(A))) ) ) ).

% Inf_finite_empty
tff(fact_1395_Sup__finite__empty,axiom,
    ! [A: $tType] :
      ( finite_lattice(A)
     => ( aa(set(A),A,complete_Sup_Sup(A),bot_bot(set(A))) = aa(set(A),A,complete_Inf_Inf(A),top_top(set(A))) ) ) ).

% Sup_finite_empty
tff(fact_1396_lnear__order__on__empty,axiom,
    ! [A: $tType] : order_679001287576687338der_on(A,bot_bot(set(A)),bot_bot(set(product_prod(A,A)))) ).

% lnear_order_on_empty
tff(fact_1397_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B2: set(B),A3: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B2),A3))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),B2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X)),aa(B,A,G,X))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),B2)))) ) ) ) ).

% INF_superset_mono
tff(fact_1398_INF__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),C2: A] :
          ( ( ( A3 = bot_bot(set(B)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_fh(A,fun(B,A),C2)),A3)) = top_top(A) ) )
          & ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_fh(A,fun(B,A),C2)),A3)) = C2 ) ) ) ) ).

% INF_constant
tff(fact_1399_INF__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),bot_bot(set(B)))) = top_top(A) ) ) ).

% INF_empty
tff(fact_1400_INF__inf__const1,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I: set(B),X2: A,F2: fun(B,A)] :
          ( ( I != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_it(A,fun(fun(B,A),fun(B,A)),X2),F2)),I)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),I))) ) ) ) ).

% INF_inf_const1
tff(fact_1401_INF__inf__const2,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I: set(B),F2: fun(B,A),X2: A] :
          ( ( I != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_iu(fun(B,A),fun(A,fun(B,A)),F2),X2)),I)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),I))),X2) ) ) ) ).

% INF_inf_const2
tff(fact_1402_uminus__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( comple489889107523837845lgebra(A)
     => ! [B2: fun(B,A),A3: set(B)] : ( aa(A,A,uminus_uminus(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,B2),A3))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_iv(fun(B,A),fun(B,A),B2)),A3)) ) ) ).

% uminus_SUP
tff(fact_1403_uminus__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( comple489889107523837845lgebra(A)
     => ! [B2: fun(B,A),A3: set(B)] : ( aa(A,A,uminus_uminus(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,B2),A3))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_iv(fun(B,A),fun(B,A),B2)),A3)) ) ) ).

% uminus_INF
tff(fact_1404_INF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),A4: B,A3: set(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),aa(set(B),set(B),insert(B,A4),A3))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,F2,A4)),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))) ) ) ).

% INF_insert
tff(fact_1405_INF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [M: fun(B,A),A3: set(B),B2: set(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,M),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,M),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,M),B2))) ) ) ).

% INF_union
tff(fact_1406_INT__empty,axiom,
    ! [B: $tType,A: $tType,B2: fun(B,set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),bot_bot(set(B)))) = top_top(set(A)) ) ).

% INT_empty
tff(fact_1407_INT__extend__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set(D),A3: set(C),B2: fun(D,set(C))] :
      ( ( ( C3 = bot_bot(set(D)) )
       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B2),C3))) = A3 ) )
      & ( ( C3 != bot_bot(set(D)) )
       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B2),C3))) = aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),aa(fun(D,set(C)),fun(D,set(C)),aTP_Lamp_hz(set(C),fun(fun(D,set(C)),fun(D,set(C))),A3),B2)),C3)) ) ) ) ).

% INT_extend_simps(2)
tff(fact_1408_INT__extend__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,C3: set(A),A3: fun(A,set(B)),B2: set(B)] :
      ( ( ( C3 = bot_bot(set(A)) )
       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),C3))),B2) = B2 ) )
      & ( ( C3 != bot_bot(set(A)) )
       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),C3))),B2) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_hy(fun(A,set(B)),fun(set(B),fun(A,set(B))),A3),B2)),C3)) ) ) ) ).

% INT_extend_simps(1)
tff(fact_1409_inj__on__INTER,axiom,
    ! [C: $tType,B: $tType,A: $tType,I: set(A),F2: fun(B,C),A3: fun(A,set(B))] :
      ( ( I != bot_bot(set(A)) )
     => ( ! [I3: A] :
            ( pp(aa(set(A),bool,member(A,I3),I))
           => inj_on(B,C,F2,aa(A,set(B),A3,I3)) )
       => inj_on(B,C,F2,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),I))) ) ) ).

% inj_on_INTER
tff(fact_1410_INT__Un,axiom,
    ! [A: $tType,B: $tType,M: fun(B,set(A)),A3: set(B),B2: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),M),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),M),A3))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),M),B2))) ) ).

% INT_Un
tff(fact_1411_UN__extend__simps_I7_J,axiom,
    ! [M4: $tType,N3: $tType,A3: set(M4),B2: fun(N3,set(M4)),C3: set(N3)] : ( aa(set(M4),set(M4),aa(set(M4),fun(set(M4),set(M4)),minus_minus(set(M4)),A3),aa(set(set(M4)),set(M4),complete_Inf_Inf(set(M4)),aa(set(N3),set(set(M4)),image2(N3,set(M4),B2),C3))) = aa(set(set(M4)),set(M4),complete_Sup_Sup(set(M4)),aa(set(N3),set(set(M4)),image2(N3,set(M4),aa(fun(N3,set(M4)),fun(N3,set(M4)),aTP_Lamp_iw(set(M4),fun(fun(N3,set(M4)),fun(N3,set(M4))),A3),B2)),C3)) ) ).

% UN_extend_simps(7)
tff(fact_1412_Inter__Un__subset,axiom,
    ! [A: $tType,A3: set(set(A)),B2: set(set(A))] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B2))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),A3),B2)))) ).

% Inter_Un_subset
tff(fact_1413_INT__extend__simps_I8_J,axiom,
    ! [P8: $tType,O: $tType,B2: fun(O,set(P8)),A3: set(set(O))] : ( aa(set(set(P8)),set(P8),complete_Inf_Inf(set(P8)),aa(set(set(O)),set(set(P8)),image2(set(O),set(P8),aTP_Lamp_ix(fun(O,set(P8)),fun(set(O),set(P8)),B2)),A3)) = aa(set(set(P8)),set(P8),complete_Inf_Inf(set(P8)),aa(set(O),set(set(P8)),image2(O,set(P8),B2),aa(set(set(O)),set(O),complete_Sup_Sup(set(O)),A3))) ) ).

% INT_extend_simps(8)
tff(fact_1414_Int__Inter__eq_I2_J,axiom,
    ! [A: $tType,B7: set(set(A)),A3: set(A)] :
      ( ( ( B7 = bot_bot(set(set(A))) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B7)),A3) = A3 ) )
      & ( ( B7 != bot_bot(set(set(A))) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B7)),A3) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),image2(set(A),set(A),aTP_Lamp_gs(set(A),fun(set(A),set(A)),A3)),B7)) ) ) ) ).

% Int_Inter_eq(2)
tff(fact_1415_Int__Inter__eq_I1_J,axiom,
    ! [A: $tType,B7: set(set(A)),A3: set(A)] :
      ( ( ( B7 = bot_bot(set(set(A))) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B7)) = A3 ) )
      & ( ( B7 != bot_bot(set(set(A))) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B7)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),image2(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3)),B7)) ) ) ) ).

% Int_Inter_eq(1)
tff(fact_1416_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),F2: fun(B,A)] :
          ( ( A3 != bot_bot(set(B)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3)))) ) ) ).

% INF_le_SUP
tff(fact_1417_reflcl__set__eq,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),X4: A,Xa3: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),sup_sup(fun(A,fun(A,bool))),aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2)),fequal(A)),X4),Xa3))
    <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa3)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R2),id2(A)))) ) ).

% reflcl_set_eq
tff(fact_1418_INF__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: fun(bool,A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(bool),set(A),image2(bool,A,A3),top_top(set(bool)))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(bool,A,A3,fTrue)),aa(bool,A,A3,fFalse)) ) ) ).

% INF_UNIV_bool_expand
tff(fact_1419_image__INT,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(A,B),C3: set(A),A3: set(C),B2: fun(C,set(A)),J2: C] :
      ( inj_on(A,B,F2,C3)
     => ( ! [X: C] :
            ( pp(aa(set(C),bool,member(C,X),A3))
           => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(C,set(A),B2,X)),C3)) )
       => ( pp(aa(set(C),bool,member(C,J2),A3))
         => ( aa(set(A),set(B),image2(A,B,F2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image2(C,set(A),B2),A3))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(A)),fun(C,set(B)),aTP_Lamp_iz(fun(A,B),fun(fun(C,set(A)),fun(C,set(B))),F2),B2)),A3)) ) ) ) ) ).

% image_INT
tff(fact_1420_INT__extend__simps_I3_J,axiom,
    ! [F10: $tType,E: $tType,C3: set(E),A3: fun(E,set(F10)),B2: set(F10)] :
      ( ( ( C3 = bot_bot(set(E)) )
       => ( aa(set(F10),set(F10),aa(set(F10),fun(set(F10),set(F10)),minus_minus(set(F10)),aa(set(set(F10)),set(F10),complete_Inf_Inf(set(F10)),aa(set(E),set(set(F10)),image2(E,set(F10),A3),C3))),B2) = aa(set(F10),set(F10),aa(set(F10),fun(set(F10),set(F10)),minus_minus(set(F10)),top_top(set(F10))),B2) ) )
      & ( ( C3 != bot_bot(set(E)) )
       => ( aa(set(F10),set(F10),aa(set(F10),fun(set(F10),set(F10)),minus_minus(set(F10)),aa(set(set(F10)),set(F10),complete_Inf_Inf(set(F10)),aa(set(E),set(set(F10)),image2(E,set(F10),A3),C3))),B2) = aa(set(set(F10)),set(F10),complete_Inf_Inf(set(F10)),aa(set(E),set(set(F10)),image2(E,set(F10),aa(set(F10),fun(E,set(F10)),aTP_Lamp_ia(fun(E,set(F10)),fun(set(F10),fun(E,set(F10))),A3),B2)),C3)) ) ) ) ).

% INT_extend_simps(3)
tff(fact_1421_INT__extend__simps_I4_J,axiom,
    ! [G3: $tType,H8: $tType,C3: set(H8),A3: set(G3),B2: fun(H8,set(G3))] :
      ( ( ( C3 = bot_bot(set(H8)) )
       => ( aa(set(G3),set(G3),aa(set(G3),fun(set(G3),set(G3)),minus_minus(set(G3)),A3),aa(set(set(G3)),set(G3),complete_Sup_Sup(set(G3)),aa(set(H8),set(set(G3)),image2(H8,set(G3),B2),C3))) = A3 ) )
      & ( ( C3 != bot_bot(set(H8)) )
       => ( aa(set(G3),set(G3),aa(set(G3),fun(set(G3),set(G3)),minus_minus(set(G3)),A3),aa(set(set(G3)),set(G3),complete_Sup_Sup(set(G3)),aa(set(H8),set(set(G3)),image2(H8,set(G3),B2),C3))) = aa(set(set(G3)),set(G3),complete_Inf_Inf(set(G3)),aa(set(H8),set(set(G3)),image2(H8,set(G3),aa(fun(H8,set(G3)),fun(H8,set(G3)),aTP_Lamp_hs(set(G3),fun(fun(H8,set(G3)),fun(H8,set(G3))),A3),B2)),C3)) ) ) ) ).

% INT_extend_simps(4)
tff(fact_1422_INT__bool__eq,axiom,
    ! [A: $tType,A3: fun(bool,set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(bool),set(set(A)),image2(bool,set(A),A3),top_top(set(bool)))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(bool,set(A),A3,fTrue)),aa(bool,set(A),A3,fFalse)) ) ).

% INT_bool_eq
tff(fact_1423_fun__upd__image,axiom,
    ! [A: $tType,B: $tType,X2: B,A3: set(B),F2: fun(B,A),Y: A] :
      ( ( pp(aa(set(B),bool,member(B,X2),A3))
       => ( aa(set(B),set(A),image2(B,A,fun_upd(B,A,F2,X2,Y)),A3) = aa(set(A),set(A),insert(A,Y),aa(set(B),set(A),image2(B,A,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) )
      & ( ~ pp(aa(set(B),bool,member(B,X2),A3))
       => ( aa(set(B),set(A),image2(B,A,fun_upd(B,A,F2,X2,Y)),A3) = aa(set(B),set(A),image2(B,A,F2),A3) ) ) ) ).

% fun_upd_image
tff(fact_1424_Linear__order__Restr,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( order_679001287576687338der_on(A,field2(A,R2),R2)
     => order_679001287576687338der_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ).

% Linear_order_Restr
tff(fact_1425_SUP__INF,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [P: fun(C,fun(B,A))] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_jb(fun(C,fun(B,A)),fun(B,A),P)),top_top(set(B)))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(fun(B,C)),set(A),image2(fun(B,C),A,aTP_Lamp_jd(fun(C,fun(B,A)),fun(fun(B,C),A),P)),top_top(set(fun(B,C))))) ) ) ).

% SUP_INF
tff(fact_1426_INF__SUP,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [P: fun(C,fun(B,A))] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_je(fun(C,fun(B,A)),fun(B,A),P)),top_top(set(B)))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(fun(B,C)),set(A),image2(fun(B,C),A,aTP_Lamp_jf(fun(C,fun(B,A)),fun(fun(B,C),A),P)),top_top(set(fun(B,C))))) ) ) ).

% INF_SUP
tff(fact_1427_linear__order__on__Restr,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X2: A] :
      ( order_679001287576687338der_on(A,A3,R2)
     => order_679001287576687338der_on(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),order_above(A,R2,X2)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,order_above(A,R2,X2),aa(A,fun(A,set(A)),aTP_Lamp_jg(set(product_prod(A,A)),fun(A,fun(A,set(A))),R2),X2)))) ) ).

% linear_order_on_Restr
tff(fact_1428_rel__pred__comp__def,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),P: fun(B,bool),X4: A] :
      ( rel_pred_comp(A,B,R,P,X4)
    <=> ? [Y4: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),R,X4),Y4))
          & pp(aa(B,bool,P,Y4)) ) ) ).

% rel_pred_comp_def
tff(fact_1429_Linear__order__wf__diff__Id,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( order_679001287576687338der_on(A,field2(A,R2),R2)
     => ( wf(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R2),id2(A)))
      <=> ! [A12: set(A)] :
            ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A12),field2(A,R2)))
           => ( ( A12 != bot_bot(set(A)) )
             => ? [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A12))
                  & ! [Xa2: A] :
                      ( pp(aa(set(A),bool,member(A,Xa2),A12))
                     => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa2)),R2)) ) ) ) ) ) ) ).

% Linear_order_wf_diff_Id
tff(fact_1430_image__o__collect,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: fun(C,B),F: set(fun(A,set(C)))] : ( bNF_collect(A,B,aa(set(fun(A,set(C))),set(fun(A,set(B))),image2(fun(A,set(C)),fun(A,set(B)),comp(set(C),set(B),A,image2(C,B,G))),F)) = aa(fun(A,set(C)),fun(A,set(B)),comp(set(C),set(B),A,image2(C,B,G)),bNF_collect(A,C,F)) ) ).

% image_o_collect
tff(fact_1431_bsqr__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( bNF_Wellorder_bsqr(A,R2) = aa(fun(product_prod(product_prod(A,A),product_prod(A,A)),bool),set(product_prod(product_prod(A,A),product_prod(A,A))),collect(product_prod(product_prod(A,A),product_prod(A,A))),aa(fun(product_prod(A,A),fun(product_prod(A,A),bool)),fun(product_prod(product_prod(A,A),product_prod(A,A)),bool),product_case_prod(product_prod(A,A),product_prod(A,A),bool),aa(fun(A,fun(A,fun(product_prod(A,A),bool))),fun(product_prod(A,A),fun(product_prod(A,A),bool)),product_case_prod(A,A,fun(product_prod(A,A),bool)),aTP_Lamp_ji(set(product_prod(A,A)),fun(A,fun(A,fun(product_prod(A,A),bool))),R2)))) ) ).

% bsqr_def
tff(fact_1432_same__fst__trancl,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),R: fun(A,set(product_prod(B,B)))] : ( transitive_trancl(product_prod(A,B),same_fst(A,B,P,R)) = same_fst(A,B,P,aTP_Lamp_jj(fun(A,set(product_prod(B,B))),fun(A,set(product_prod(B,B))),R)) ) ).

% same_fst_trancl
tff(fact_1433_Inf__INT__eq2,axiom,
    ! [B: $tType,A: $tType,S: set(fun(A,fun(B,bool))),X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Inf_Inf(fun(A,fun(B,bool))),S),X4),Xa3))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Inf_Inf(set(product_prod(A,B))),aa(set(fun(product_prod(A,B),bool)),set(set(product_prod(A,B))),image2(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B))),aa(set(fun(A,fun(B,bool))),set(fun(product_prod(A,B),bool)),image2(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool)),S))))) ) ).

% Inf_INT_eq2
tff(fact_1434_relation__of__def,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),A3: set(A)] : ( order_relation_of(A,P,A3) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(A),fun(A,fun(A,bool)),aTP_Lamp_jk(fun(A,fun(A,bool)),fun(set(A),fun(A,fun(A,bool))),P),A3))) ) ).

% relation_of_def
tff(fact_1435_INF1__I,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: fun(A,fun(B,bool)),B3: B] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),A3))
         => pp(aa(B,bool,aa(A,fun(B,bool),B2,X),B3)) )
     => pp(aa(B,bool,aa(set(fun(B,bool)),fun(B,bool),complete_Inf_Inf(fun(B,bool)),aa(set(A),set(fun(B,bool)),image2(A,fun(B,bool),B2),A3)),B3)) ) ).

% INF1_I
tff(fact_1436_subset__mset_OcInf__singleton,axiom,
    ! [A: $tType,X2: multiset(A)] : ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) = X2 ) ).

% subset_mset.cInf_singleton
tff(fact_1437_subset__mset_OcINF__const,axiom,
    ! [B: $tType,A: $tType,A3: set(B),C2: multiset(A)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),aTP_Lamp_hr(multiset(A),fun(B,multiset(A)),C2)),A3)) = C2 ) ) ).

% subset_mset.cINF_const
tff(fact_1438_INF2__I,axiom,
    ! [B: $tType,A: $tType,C: $tType,A3: set(A),B2: fun(A,fun(B,fun(C,bool))),B3: B,C2: C] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),A3))
         => pp(aa(C,bool,aa(B,fun(C,bool),aa(A,fun(B,fun(C,bool)),B2,X),B3),C2)) )
     => pp(aa(C,bool,aa(B,fun(C,bool),aa(set(fun(B,fun(C,bool))),fun(B,fun(C,bool)),complete_Inf_Inf(fun(B,fun(C,bool))),aa(set(A),set(fun(B,fun(C,bool))),image2(A,fun(B,fun(C,bool)),B2),A3)),B3),C2)) ) ).

% INF2_I
tff(fact_1439_Inf__multiset__empty,axiom,
    ! [A: $tType] : ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),bot_bot(set(multiset(A)))) = zero_zero(multiset(A)) ) ).

% Inf_multiset_empty
tff(fact_1440_Inf__nat__def1,axiom,
    ! [K5: set(nat)] :
      ( ( K5 != bot_bot(set(nat)) )
     => pp(aa(set(nat),bool,member(nat,aa(set(nat),nat,complete_Inf_Inf(nat),K5)),K5)) ) ).

% Inf_nat_def1
tff(fact_1441_INF2__D,axiom,
    ! [A: $tType,C: $tType,B: $tType,B2: fun(C,fun(A,fun(B,bool))),A3: set(C),B3: A,C2: B,A4: C] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Inf_Inf(fun(A,fun(B,bool))),aa(set(C),set(fun(A,fun(B,bool))),image2(C,fun(A,fun(B,bool)),B2),A3)),B3),C2))
     => ( pp(aa(set(C),bool,member(C,A4),A3))
       => pp(aa(B,bool,aa(A,fun(B,bool),aa(C,fun(A,fun(B,bool)),B2,A4),B3),C2)) ) ) ).

% INF2_D
tff(fact_1442_INF2__E,axiom,
    ! [B: $tType,A: $tType,C: $tType,B2: fun(C,fun(A,fun(B,bool))),A3: set(C),B3: A,C2: B,A4: C] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Inf_Inf(fun(A,fun(B,bool))),aa(set(C),set(fun(A,fun(B,bool))),image2(C,fun(A,fun(B,bool)),B2),A3)),B3),C2))
     => ( ~ pp(aa(B,bool,aa(A,fun(B,bool),aa(C,fun(A,fun(B,bool)),B2,A4),B3),C2))
       => ~ pp(aa(set(C),bool,member(C,A4),A3)) ) ) ).

% INF2_E
tff(fact_1443_INF1__D,axiom,
    ! [B: $tType,A: $tType,B2: fun(B,fun(A,bool)),A3: set(B),B3: A,A4: B] :
      ( pp(aa(A,bool,aa(set(fun(A,bool)),fun(A,bool),complete_Inf_Inf(fun(A,bool)),aa(set(B),set(fun(A,bool)),image2(B,fun(A,bool),B2),A3)),B3))
     => ( pp(aa(set(B),bool,member(B,A4),A3))
       => pp(aa(A,bool,aa(B,fun(A,bool),B2,A4),B3)) ) ) ).

% INF1_D
tff(fact_1444_INF1__E,axiom,
    ! [A: $tType,B: $tType,B2: fun(B,fun(A,bool)),A3: set(B),B3: A,A4: B] :
      ( pp(aa(A,bool,aa(set(fun(A,bool)),fun(A,bool),complete_Inf_Inf(fun(A,bool)),aa(set(B),set(fun(A,bool)),image2(B,fun(A,bool),B2),A3)),B3))
     => ( ~ pp(aa(A,bool,aa(B,fun(A,bool),B2,A4),B3))
       => ~ pp(aa(set(B),bool,member(B,A4),A3)) ) ) ).

% INF1_E
tff(fact_1445_INF__Int__eq2,axiom,
    ! [B: $tType,A: $tType,S: set(set(product_prod(A,B))),X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Inf_Inf(fun(A,fun(B,bool))),aa(set(set(product_prod(A,B))),set(fun(A,fun(B,bool))),image2(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool)))),S)),X4),Xa3))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Inf_Inf(set(product_prod(A,B))),S))) ) ).

% INF_Int_eq2
tff(fact_1446_INF__Int__eq,axiom,
    ! [A: $tType,S: set(set(A)),X4: A] :
      ( pp(aa(A,bool,aa(set(fun(A,bool)),fun(A,bool),complete_Inf_Inf(fun(A,bool)),aa(set(set(A)),set(fun(A,bool)),image2(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool))),S)),X4))
    <=> pp(aa(set(A),bool,member(A,X4),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),S))) ) ).

% INF_Int_eq
tff(fact_1447_INF__INT__eq,axiom,
    ! [A: $tType,B: $tType,R2: fun(B,set(A)),S: set(B),X4: A] :
      ( pp(aa(A,bool,aa(set(fun(A,bool)),fun(A,bool),complete_Inf_Inf(fun(A,bool)),aa(set(B),set(fun(A,bool)),image2(B,fun(A,bool),aTP_Lamp_hk(fun(B,set(A)),fun(B,fun(A,bool)),R2)),S)),X4))
    <=> pp(aa(set(A),bool,member(A,X4),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),R2),S)))) ) ).

% INF_INT_eq
tff(fact_1448_INF__INT__eq2,axiom,
    ! [A: $tType,B: $tType,C: $tType,R2: fun(C,set(product_prod(A,B))),S: set(C),X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Inf_Inf(fun(A,fun(B,bool))),aa(set(C),set(fun(A,fun(B,bool))),image2(C,fun(A,fun(B,bool)),aTP_Lamp_hi(fun(C,set(product_prod(A,B))),fun(C,fun(A,fun(B,bool))),R2)),S)),X4),Xa3))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Inf_Inf(set(product_prod(A,B))),aa(set(C),set(set(product_prod(A,B))),image2(C,set(product_prod(A,B)),R2),S)))) ) ).

% INF_INT_eq2
tff(fact_1449_Inf__set__def,axiom,
    ! [A: $tType,A3: set(set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_jl(set(set(A)),fun(A,bool),A3)) ) ).

% Inf_set_def
tff(fact_1450_wf__eq__minimal2,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( wf(A,R2)
    <=> ! [A12: set(A)] :
          ( ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A12),field2(A,R2)))
            & ( A12 != bot_bot(set(A)) ) )
         => ? [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),A12))
              & ! [Xa2: A] :
                  ( pp(aa(set(A),bool,member(A,Xa2),A12))
                 => ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa2),X3)),R2)) ) ) ) ) ).

% wf_eq_minimal2
tff(fact_1451_collect__def,axiom,
    ! [A: $tType,B: $tType,F: set(fun(B,set(A))),X2: B] : ( aa(B,set(A),bNF_collect(B,A,F),X2) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(fun(B,set(A))),set(set(A)),image2(fun(B,set(A)),set(A),aTP_Lamp_jm(B,fun(fun(B,set(A)),set(A)),X2)),F)) ) ).

% collect_def
tff(fact_1452_Field__bsqr,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( field2(product_prod(A,A),bNF_Wellorder_bsqr(A,R2)) = product_Sigma(A,A,field2(A,R2),aTP_Lamp_ey(set(product_prod(A,A)),fun(A,set(A)),R2)) ) ).

% Field_bsqr
tff(fact_1453_collect__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: set(fun(C,set(B))),G: fun(A,C)] : ( aa(fun(A,C),fun(A,set(B)),comp(C,set(B),A,bNF_collect(C,B,F)),G) = bNF_collect(A,B,aa(set(fun(C,set(B))),set(fun(A,set(B))),image2(fun(C,set(B)),fun(A,set(B)),aTP_Lamp_jn(fun(A,C),fun(fun(C,set(B)),fun(A,set(B))),G)),F)) ) ).

% collect_comp
tff(fact_1454_above__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A] : ( order_above(A,R2,A4) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2),A4)) ) ).

% above_def
tff(fact_1455_same__fst__def,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),R: fun(A,set(product_prod(B,B)))] : ( same_fst(A,B,P,R) = aa(fun(product_prod(product_prod(A,B),product_prod(A,B)),bool),set(product_prod(product_prod(A,B),product_prod(A,B))),collect(product_prod(product_prod(A,B),product_prod(A,B))),aa(fun(product_prod(A,B),fun(product_prod(A,B),bool)),fun(product_prod(product_prod(A,B),product_prod(A,B)),bool),product_case_prod(product_prod(A,B),product_prod(A,B),bool),aa(fun(A,fun(B,fun(product_prod(A,B),bool))),fun(product_prod(A,B),fun(product_prod(A,B),bool)),product_case_prod(A,B,fun(product_prod(A,B),bool)),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),bool))),aTP_Lamp_jp(fun(A,bool),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),bool)))),P),R)))) ) ).

% same_fst_def
tff(fact_1456_wf__empty,axiom,
    ! [A: $tType] : wf(A,bot_bot(set(product_prod(A,A)))) ).

% wf_empty
tff(fact_1457_wfI,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A),B2: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),B2))))
     => ( ! [X: A,P3: fun(A,bool)] :
            ( ! [Xa3: A] :
                ( ! [Y2: A] :
                    ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Xa3)),R2))
                   => pp(aa(A,bool,P3,Y2)) )
               => pp(aa(A,bool,P3,Xa3)) )
           => ( pp(aa(set(A),bool,member(A,X),A3))
             => ( pp(aa(set(A),bool,member(A,X),B2))
               => pp(aa(A,bool,P3,X)) ) ) )
       => wf(A,R2) ) ) ).

% wfI
tff(fact_1458_wfE__min_H,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),Q: set(A)] :
      ( wf(A,R)
     => ( ( Q != bot_bot(set(A)) )
       => ~ ! [Z3: A] :
              ( pp(aa(set(A),bool,member(A,Z3),Q))
             => ~ ! [Y5: A] :
                    ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y5),Z3)),R))
                   => ~ pp(aa(set(A),bool,member(A,Y5),Q)) ) ) ) ) ).

% wfE_min'
tff(fact_1459_wf__Int1,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),R5: set(product_prod(A,A))] :
      ( wf(A,R2)
     => wf(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),R5)) ) ).

% wf_Int1
tff(fact_1460_wf__Int2,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),R5: set(product_prod(A,A))] :
      ( wf(A,R2)
     => wf(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R5),R2)) ) ).

% wf_Int2
tff(fact_1461_lex__prod__def,axiom,
    ! [A: $tType,B: $tType,Ra: set(product_prod(A,A)),Rb: set(product_prod(B,B))] : ( lex_prod(A,B,Ra,Rb) = aa(fun(product_prod(product_prod(A,B),product_prod(A,B)),bool),set(product_prod(product_prod(A,B),product_prod(A,B))),collect(product_prod(product_prod(A,B),product_prod(A,B))),aa(fun(product_prod(A,B),fun(product_prod(A,B),bool)),fun(product_prod(product_prod(A,B),product_prod(A,B)),bool),product_case_prod(product_prod(A,B),product_prod(A,B),bool),aa(fun(A,fun(B,fun(product_prod(A,B),bool))),fun(product_prod(A,B),fun(product_prod(A,B),bool)),product_case_prod(A,B,fun(product_prod(A,B),bool)),aa(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),bool))),aTP_Lamp_jr(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),bool)))),Ra),Rb)))) ) ).

% lex_prod_def
tff(fact_1462_subset__Image1__Image1__iff,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A,B3: A] :
      ( order_preorder_on(A,field2(A,R2),R2)
     => ( pp(aa(set(A),bool,member(A,A4),field2(A,R2)))
       => ( pp(aa(set(A),bool,member(A,B3),field2(A,R2)))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))))
          <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B3),A4)),R2)) ) ) ) ) ).

% subset_Image1_Image1_iff
tff(fact_1463_Image__empty2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(B,A))] : ( aa(set(B),set(A),image(B,A,R),bot_bot(set(B))) = bot_bot(set(A)) ) ).

% Image_empty2
tff(fact_1464_Image__empty1,axiom,
    ! [B: $tType,A: $tType,X5: set(B)] : ( aa(set(B),set(A),image(B,A,bot_bot(set(product_prod(B,A)))),X5) = bot_bot(set(A)) ) ).

% Image_empty1
tff(fact_1465_Image__Id__on,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(set(A),set(A),image(A,A,id_on(A,A3)),B2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) ) ).

% Image_Id_on
tff(fact_1466_Image__singleton__iff,axiom,
    ! [A: $tType,B: $tType,B3: A,R2: set(product_prod(B,A)),A4: B] :
      ( pp(aa(set(A),bool,member(A,B3),aa(set(B),set(A),image(B,A,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))))
    <=> pp(aa(set(product_prod(B,A)),bool,member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),A4),B3)),R2)) ) ).

% Image_singleton_iff
tff(fact_1467_pair__vimage__is__Image,axiom,
    ! [A: $tType,B: $tType,U: B,E3: set(product_prod(B,A))] : ( aa(set(product_prod(B,A)),set(A),aa(fun(A,product_prod(B,A)),fun(set(product_prod(B,A)),set(A)),vimage(A,product_prod(B,A)),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),U)),E3) = aa(set(B),set(A),image(B,A,E3),aa(set(B),set(B),insert(B,U),bot_bot(set(B)))) ) ).

% pair_vimage_is_Image
tff(fact_1468_Image__Int__subset,axiom,
    ! [A: $tType,B: $tType,R: set(product_prod(B,A)),A3: set(B),B2: set(B)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,R),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),image(B,A,R),A3)),aa(set(B),set(A),image(B,A,R),B2)))) ).

% Image_Int_subset
tff(fact_1469_wfE__pf,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),A3: set(A)] :
      ( wf(A,R)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),image(A,A,R),A3)))
       => ( A3 = bot_bot(set(A)) ) ) ) ).

% wfE_pf
tff(fact_1470_wfI__pf,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( ! [A11: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A11),aa(set(A),set(A),image(A,A,R),A11)))
         => ( A11 = bot_bot(set(A)) ) )
     => wf(A,R) ) ).

% wfI_pf
tff(fact_1471_Image__UN,axiom,
    ! [B: $tType,A: $tType,C: $tType,R2: set(product_prod(B,A)),B2: fun(C,set(B)),A3: set(C)] : ( aa(set(B),set(A),image(B,A,R2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_js(set(product_prod(B,A)),fun(fun(C,set(B)),fun(C,set(A))),R2),B2)),A3)) ) ).

% Image_UN
tff(fact_1472_Image__empty__rtrancl__Image__id,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),V: A] :
      ( ( aa(set(A),set(A),image(A,A,R),aa(set(A),set(A),insert(A,V),bot_bot(set(A)))) = bot_bot(set(A)) )
     => ( aa(set(A),set(A),image(A,A,transitive_rtrancl(A,R)),aa(set(A),set(A),insert(A,V),bot_bot(set(A)))) = aa(set(A),set(A),insert(A,V),bot_bot(set(A))) ) ) ).

% Image_empty_rtrancl_Image_id
tff(fact_1473_Image__empty__trancl__Image__empty,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),V: A] :
      ( ( aa(set(A),set(A),image(A,A,R),aa(set(A),set(A),insert(A,V),bot_bot(set(A)))) = bot_bot(set(A)) )
     => ( aa(set(A),set(A),image(A,A,transitive_trancl(A,R)),aa(set(A),set(A),insert(A,V),bot_bot(set(A)))) = bot_bot(set(A)) ) ) ).

% Image_empty_trancl_Image_empty
tff(fact_1474_total__on__lex__prod,axiom,
    ! [A: $tType,B: $tType,A3: set(A),R2: set(product_prod(A,A)),B2: set(B),S2: set(product_prod(B,B))] :
      ( total_on(A,A3,R2)
     => ( total_on(B,B2,S2)
       => total_on(product_prod(A,B),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)),lex_prod(A,B,R2,S2)) ) ) ).

% total_on_lex_prod
tff(fact_1475_Image__singleton,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(B,A)),A4: B] : ( aa(set(B),set(A),image(B,A,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) = aa(fun(A,bool),set(A),collect(A),aa(B,fun(A,bool),aTP_Lamp_jt(set(product_prod(B,A)),fun(B,fun(A,bool)),R2),A4)) ) ).

% Image_singleton
tff(fact_1476_Image__subset,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(A,B)),A3: set(A),B2: set(B),C3: set(A)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),R2),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,R2),C3)),B2)) ) ).

% Image_subset
tff(fact_1477_Image__INT__subset,axiom,
    ! [B: $tType,A: $tType,C: $tType,R2: set(product_prod(B,A)),B2: fun(C,set(B)),A3: set(C)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,R2),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_js(set(product_prod(B,A)),fun(fun(C,set(B)),fun(C,set(A))),R2),B2)),A3)))) ).

% Image_INT_subset
tff(fact_1478_rtrancl__apply__insert,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),X2: A,S: set(A)] : ( aa(set(A),set(A),image(A,A,transitive_rtrancl(A,R)),aa(set(A),set(A),insert(A,X2),S)) = aa(set(A),set(A),insert(A,X2),aa(set(A),set(A),image(A,A,transitive_rtrancl(A,R)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S),aa(set(A),set(A),image(A,A,R),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))))) ) ).

% rtrancl_apply_insert
tff(fact_1479_Image__eq__UN,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(B,A)),B2: set(B)] : ( aa(set(B),set(A),image(B,A,R2),B2) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_ju(set(product_prod(B,A)),fun(B,set(A)),R2)),B2)) ) ).

% Image_eq_UN
tff(fact_1480_Sigma__Image,axiom,
    ! [A: $tType,B: $tType,A3: set(B),B2: fun(B,set(A)),X5: set(B)] : ( aa(set(B),set(A),image(B,A,product_Sigma(B,A,A3,B2)),X5) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X5),A3))) ) ).

% Sigma_Image
tff(fact_1481_UN__Image,axiom,
    ! [B: $tType,A: $tType,C: $tType,X5: fun(C,set(product_prod(B,A))),I: set(C),S: set(B)] : ( aa(set(B),set(A),image(B,A,aa(set(set(product_prod(B,A))),set(product_prod(B,A)),complete_Sup_Sup(set(product_prod(B,A))),aa(set(C),set(set(product_prod(B,A))),image2(C,set(product_prod(B,A)),X5),I))),S) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(set(B),fun(C,set(A)),aTP_Lamp_jv(fun(C,set(product_prod(B,A))),fun(set(B),fun(C,set(A))),X5),S)),I)) ) ).

% UN_Image
tff(fact_1482_rtrancl__Image__advance__ss,axiom,
    ! [A: $tType,U: A,V: A,E3: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V)),E3))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),image(A,A,transitive_rtrancl(A,E3)),aa(set(A),set(A),insert(A,V),bot_bot(set(A))))),aa(set(A),set(A),image(A,A,transitive_rtrancl(A,E3)),aa(set(A),set(A),insert(A,U),bot_bot(set(A)))))) ) ).

% rtrancl_Image_advance_ss
tff(fact_1483_trancl__Image__advance__ss,axiom,
    ! [A: $tType,U: A,V: A,E3: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V)),E3))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),image(A,A,transitive_trancl(A,E3)),aa(set(A),set(A),insert(A,V),bot_bot(set(A))))),aa(set(A),set(A),image(A,A,transitive_trancl(A,E3)),aa(set(A),set(A),insert(A,U),bot_bot(set(A)))))) ) ).

% trancl_Image_advance_ss
tff(fact_1484_trancl__restrict__reachable,axiom,
    ! [A: $tType,U: A,V: A,E3: set(product_prod(A,A)),S: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V)),transitive_trancl(A,E3)))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),image(A,A,E3),S)),S))
       => ( pp(aa(set(A),bool,member(A,U),S))
         => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V)),transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),E3),product_Sigma(A,A,S,aTP_Lamp_cr(set(A),fun(A,set(A)),S)))))) ) ) ) ).

% trancl_restrict_reachable
tff(fact_1485_Refl__antisym__eq__Image1__Image1__iff,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A,B3: A] :
      ( refl_on(A,field2(A,R2),R2)
     => ( antisym(A,R2)
       => ( pp(aa(set(A),bool,member(A,A4),field2(A,R2)))
         => ( pp(aa(set(A),bool,member(A,B3),field2(A,R2)))
           => ( ( aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) = aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))) )
            <=> ( A4 = B3 ) ) ) ) ) ) ).

% Refl_antisym_eq_Image1_Image1_iff
tff(fact_1486_quotient__def,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A))] : ( equiv_quotient(A,A3,R2) = aa(set(set(set(A))),set(set(A)),complete_Sup_Sup(set(set(A))),aa(set(A),set(set(set(A))),image2(A,set(set(A)),aTP_Lamp_jw(set(product_prod(A,A)),fun(A,set(set(A))),R2)),A3)) ) ).

% quotient_def
tff(fact_1487_singleton__quotient,axiom,
    ! [A: $tType,X2: A,R2: set(product_prod(A,A))] : ( equiv_quotient(A,aa(set(A),set(A),insert(A,X2),bot_bot(set(A))),R2) = aa(set(set(A)),set(set(A)),insert(set(A),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),bot_bot(set(set(A)))) ) ).

% singleton_quotient
tff(fact_1488_chains__extend,axiom,
    ! [A: $tType,C2: set(set(A)),S: set(set(A)),Z2: set(A)] :
      ( pp(aa(set(set(set(A))),bool,member(set(set(A)),C2),chains2(A,S)))
     => ( pp(aa(set(set(A)),bool,member(set(A),Z2),S))
       => ( ! [X: set(A)] :
              ( pp(aa(set(set(A)),bool,member(set(A),X),C2))
             => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X),Z2)) )
         => pp(aa(set(set(set(A))),bool,member(set(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),aa(set(set(A)),set(set(A)),insert(set(A),Z2),bot_bot(set(set(A))))),C2)),chains2(A,S))) ) ) ) ).

% chains_extend
tff(fact_1489_Rep__unit,axiom,
    ! [X2: product_unit] : pp(aa(set(bool),bool,member(bool,aa(product_unit,bool,product_Rep_unit,X2)),aa(set(bool),set(bool),insert(bool,fTrue),bot_bot(set(bool))))) ).

% Rep_unit
tff(fact_1490_Abs__unit__cases,axiom,
    ! [X2: product_unit] :
      ~ ! [Y2: bool] :
          ( ( X2 = aa(bool,product_unit,product_Abs_unit,Y2) )
         => ~ pp(aa(set(bool),bool,member(bool,Y2),aa(set(bool),set(bool),insert(bool,fTrue),bot_bot(set(bool))))) ) ).

% Abs_unit_cases
tff(fact_1491_Rep__unit__cases,axiom,
    ! [Y: bool] :
      ( pp(aa(set(bool),bool,member(bool,Y),aa(set(bool),set(bool),insert(bool,fTrue),bot_bot(set(bool)))))
     => ~ ! [X: product_unit] :
            ( pp(Y)
          <=> ~ pp(aa(product_unit,bool,product_Rep_unit,X)) ) ) ).

% Rep_unit_cases
tff(fact_1492_Abs__unit__induct,axiom,
    ! [P: fun(product_unit,bool),X2: product_unit] :
      ( ! [Y2: bool] :
          ( pp(aa(set(bool),bool,member(bool,Y2),aa(set(bool),set(bool),insert(bool,fTrue),bot_bot(set(bool)))))
         => pp(aa(product_unit,bool,P,aa(bool,product_unit,product_Abs_unit,Y2))) )
     => pp(aa(product_unit,bool,P,X2)) ) ).

% Abs_unit_induct
tff(fact_1493_quotient__is__empty2,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A))] :
      ( ( bot_bot(set(set(A))) = equiv_quotient(A,A3,R2) )
    <=> ( A3 = bot_bot(set(A)) ) ) ).

% quotient_is_empty2
tff(fact_1494_quotient__is__empty,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A))] :
      ( ( equiv_quotient(A,A3,R2) = bot_bot(set(set(A))) )
    <=> ( A3 = bot_bot(set(A)) ) ) ).

% quotient_is_empty
tff(fact_1495_quotient__empty,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( equiv_quotient(A,bot_bot(set(A)),R2) = bot_bot(set(set(A))) ) ).

% quotient_empty
tff(fact_1496_antisym__empty,axiom,
    ! [A: $tType] : antisym(A,bot_bot(set(product_prod(A,A)))) ).

% antisym_empty
tff(fact_1497_type__definition__unit,axiom,
    type_definition(product_unit,bool,product_Rep_unit,product_Abs_unit,aa(set(bool),set(bool),insert(bool,fTrue),bot_bot(set(bool)))) ).

% type_definition_unit
tff(fact_1498_Abs__unit__inverse,axiom,
    ! [Y: bool] :
      ( pp(aa(set(bool),bool,member(bool,Y),aa(set(bool),set(bool),insert(bool,fTrue),bot_bot(set(bool)))))
     => ( pp(aa(product_unit,bool,product_Rep_unit,aa(bool,product_unit,product_Abs_unit,Y)))
      <=> pp(Y) ) ) ).

% Abs_unit_inverse
tff(fact_1499_antisym__singleton,axiom,
    ! [A: $tType,X2: product_prod(A,A)] : antisym(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),X2),bot_bot(set(product_prod(A,A))))) ).

% antisym_singleton
tff(fact_1500_antisym__Restr,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( antisym(A,R2)
     => antisym(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ).

% antisym_Restr
tff(fact_1501_quotientE,axiom,
    ! [A: $tType,X5: set(A),A3: set(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(set(A)),bool,member(set(A),X5),equiv_quotient(A,A3,R2)))
     => ~ ! [X: A] :
            ( ( X5 = aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) )
           => ~ pp(aa(set(A),bool,member(A,X),A3)) ) ) ).

% quotientE
tff(fact_1502_quotientI,axiom,
    ! [A: $tType,X2: A,A3: set(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(A),bool,member(A,X2),A3))
     => pp(aa(set(set(A)),bool,member(set(A),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),equiv_quotient(A,A3,R2))) ) ).

% quotientI
tff(fact_1503_quotient__diff1,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A),A4: A] :
      ( inj_on(A,set(set(A)),aTP_Lamp_jx(set(product_prod(A,A)),fun(A,set(set(A))),R2),A3)
     => ( pp(aa(set(A),bool,member(A,A4),A3))
       => ( equiv_quotient(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))),R2) = aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),minus_minus(set(set(A))),equiv_quotient(A,A3,R2)),equiv_quotient(A,aa(set(A),set(A),insert(A,A4),bot_bot(set(A))),R2)) ) ) ) ).

% quotient_diff1
tff(fact_1504_Rep__unit__induct,axiom,
    ! [Y: bool,P: fun(bool,bool)] :
      ( pp(aa(set(bool),bool,member(bool,Y),aa(set(bool),set(bool),insert(bool,fTrue),bot_bot(set(bool)))))
     => ( ! [X: product_unit] : pp(aa(bool,bool,P,aa(product_unit,bool,product_Rep_unit,X)))
       => pp(aa(bool,bool,P,Y)) ) ) ).

% Rep_unit_induct
tff(fact_1505_Abs__unit__inject,axiom,
    ! [X2: bool,Y: bool] :
      ( pp(aa(set(bool),bool,member(bool,X2),aa(set(bool),set(bool),insert(bool,fTrue),bot_bot(set(bool)))))
     => ( pp(aa(set(bool),bool,member(bool,Y),aa(set(bool),set(bool),insert(bool,fTrue),bot_bot(set(bool)))))
       => ( ( aa(bool,product_unit,product_Abs_unit,X2) = aa(bool,product_unit,product_Abs_unit,Y) )
        <=> ( pp(X2)
          <=> pp(Y) ) ) ) ) ).

% Abs_unit_inject
tff(fact_1506_Partial__order__eq__Image1__Image1__iff,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A,B3: A] :
      ( order_7125193373082350890der_on(A,field2(A,R2),R2)
     => ( pp(aa(set(A),bool,member(A,A4),field2(A,R2)))
       => ( pp(aa(set(A),bool,member(A,B3),field2(A,R2)))
         => ( ( aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) = aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))) )
          <=> ( A4 = B3 ) ) ) ) ) ).

% Partial_order_eq_Image1_Image1_iff
tff(fact_1507_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B2: fun(B,set(A)),A3: set(B)] : pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),aa(set(set(set(A))),set(set(A)),complete_Sup_Sup(set(set(A))),aa(set(B),set(set(set(A))),image2(B,set(set(A)),aTP_Lamp_jy(fun(B,set(A)),fun(B,set(set(A))),B2)),A3))),pow(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3))))) ).

% UN_Pow_subset
tff(fact_1508_wo__rel_Ocases__Total3,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A,B3: A,Phi: fun(A,fun(A,bool))] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))),field2(A,R2)))
       => ( ( ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R2),id2(A))))
              | pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B3),A4)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R2),id2(A)))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A4),B3)) )
         => ( ( ( A4 = B3 )
             => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A4),B3)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A4),B3)) ) ) ) ) ).

% wo_rel.cases_Total3
tff(fact_1509_chains__def,axiom,
    ! [A: $tType,A3: set(set(A))] : ( chains2(A,A3) = aa(fun(set(set(A)),bool),set(set(set(A))),collect(set(set(A))),aTP_Lamp_jz(set(set(A)),fun(set(set(A)),bool),A3)) ) ).

% chains_def
tff(fact_1510_proj__def,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(B,A)),X2: B] : ( equiv_proj(B,A,R2,X2) = aa(set(B),set(A),image(B,A,R2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) ) ).

% proj_def
tff(fact_1511_cSUP__UNION,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(C),B2: fun(C,set(D)),F2: fun(D,B)] :
          ( ( A3 != bot_bot(set(C)) )
         => ( ! [X: C] :
                ( pp(aa(set(C),bool,member(C,X),A3))
               => ( aa(C,set(D),B2,X) != bot_bot(set(D)) ) )
           => ( condit941137186595557371_above(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(D,B),fun(C,set(B)),aTP_Lamp_ka(fun(C,set(D)),fun(fun(D,B),fun(C,set(B))),B2),F2)),A3)))
             => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,F2),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),B2),A3)))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(D,B),fun(C,B),aTP_Lamp_kb(fun(C,set(D)),fun(fun(D,B),fun(C,B)),B2),F2)),A3)) ) ) ) ) ) ).

% cSUP_UNION
tff(fact_1512_cINF__UNION,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(C),B2: fun(C,set(D)),F2: fun(D,B)] :
          ( ( A3 != bot_bot(set(C)) )
         => ( ! [X: C] :
                ( pp(aa(set(C),bool,member(C,X),A3))
               => ( aa(C,set(D),B2,X) != bot_bot(set(D)) ) )
           => ( pp(aa(set(B),bool,condit1013018076250108175_below(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(D,B),fun(C,set(B)),aTP_Lamp_ka(fun(C,set(D)),fun(fun(D,B),fun(C,set(B))),B2),F2)),A3))))
             => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,F2),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),B2),A3)))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(D,B),fun(C,B),aTP_Lamp_kc(fun(C,set(D)),fun(fun(D,B),fun(C,B)),B2),F2)),A3)) ) ) ) ) ) ).

% cINF_UNION
tff(fact_1513_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: fun(B,A),A1: set(B),B1: set(A),F22: fun(C,D),B22: set(C),A22: set(D)] :
      ( ( aa(set(B),set(A),image2(B,A,F1),A1) = B1 )
     => ( inj_on(C,D,F22,B22)
       => ( pp(aa(set(D),bool,aa(set(D),fun(set(D),bool),ord_less_eq(set(D)),aa(set(C),set(D),image2(C,D,F22),B22)),A22))
         => ( ( ( B22 = bot_bot(set(C)) )
             => ( A22 = bot_bot(set(D)) ) )
           => ( bNF_Wellorder_Func(C,A,B22,B1) = aa(set(fun(D,B)),set(fun(C,A)),image2(fun(D,B),fun(C,A),bNF_We4925052301507509544nc_map(C,B,A,D,B22,F1,F22)),bNF_Wellorder_Func(D,B,A22,A1)) ) ) ) ) ) ).

% Func_map_surj
tff(fact_1514_bdd__below__empty,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => pp(aa(set(A),bool,condit1013018076250108175_below(A),bot_bot(set(A)))) ) ).

% bdd_below_empty
tff(fact_1515_bdd__above__empty,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => condit941137186595557371_above(A,bot_bot(set(A))) ) ).

% bdd_above_empty
tff(fact_1516_bdd__below__image__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [F2: fun(B,A),G: fun(B,A),A3: set(B)] :
          ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_kd(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),A3)))
        <=> ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,F2),A3)))
            & pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,G),A3))) ) ) ) ).

% bdd_below_image_inf
tff(fact_1517_bdd__above__image__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [F2: fun(B,A),G: fun(B,A),A3: set(B)] :
          ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ke(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),A3))
        <=> ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F2),A3))
            & condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,G),A3)) ) ) ) ).

% bdd_above_image_sup
tff(fact_1518_Pow__Int__eq,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( pow(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) = aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),pow(A,A3)),pow(A,B2)) ) ).

% Pow_Int_eq
tff(fact_1519_Pow__singleton__iff,axiom,
    ! [A: $tType,X5: set(A),Y3: set(A)] :
      ( ( pow(A,X5) = aa(set(set(A)),set(set(A)),insert(set(A),Y3),bot_bot(set(set(A)))) )
    <=> ( ( X5 = bot_bot(set(A)) )
        & ( Y3 = bot_bot(set(A)) ) ) ) ).

% Pow_singleton_iff
tff(fact_1520_Pow__empty,axiom,
    ! [A: $tType] : ( pow(A,bot_bot(set(A))) = aa(set(set(A)),set(set(A)),insert(set(A),bot_bot(set(A))),bot_bot(set(set(A)))) ) ).

% Pow_empty
tff(fact_1521_bdd__below__Int1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,condit1013018076250108175_below(A),A3))
         => pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))) ) ) ).

% bdd_below_Int1
tff(fact_1522_bdd__below__Int2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: set(A),A3: set(A)] :
          ( pp(aa(set(A),bool,condit1013018076250108175_below(A),B2))
         => pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))) ) ) ).

% bdd_below_Int2
tff(fact_1523_bdd__above__Int1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: set(A),B2: set(A)] :
          ( condit941137186595557371_above(A,A3)
         => condit941137186595557371_above(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) ) ) ).

% bdd_above_Int1
tff(fact_1524_bdd__above__Int2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: set(A),A3: set(A)] :
          ( condit941137186595557371_above(A,B2)
         => condit941137186595557371_above(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) ) ) ).

% bdd_above_Int2
tff(fact_1525_Pow__bottom,axiom,
    ! [A: $tType,B2: set(A)] : pp(aa(set(set(A)),bool,member(set(A),bot_bot(set(A))),pow(A,B2))) ).

% Pow_bottom
tff(fact_1526_Pow__not__empty,axiom,
    ! [A: $tType,A3: set(A)] : ( pow(A,A3) != bot_bot(set(set(A))) ) ).

% Pow_not_empty
tff(fact_1527_Pow__def,axiom,
    ! [A: $tType,A3: set(A)] : ( pow(A,A3) = aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_kf(set(A),fun(set(A),bool),A3)) ) ).

% Pow_def
tff(fact_1528_cSUP__eq__cINF__D,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F2: fun(C,B),A3: set(C),A4: C] :
          ( ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),A3)) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3)) )
         => ( condit941137186595557371_above(B,aa(set(C),set(B),image2(C,B,F2),A3))
           => ( pp(aa(set(B),bool,condit1013018076250108175_below(B),aa(set(C),set(B),image2(C,B,F2),A3)))
             => ( pp(aa(set(C),bool,member(C,A4),A3))
               => ( aa(C,B,F2,A4) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3)) ) ) ) ) ) ) ).

% cSUP_eq_cINF_D
tff(fact_1529_Func__is__emp,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( ( bNF_Wellorder_Func(A,B,A3,B2) = bot_bot(set(fun(A,B))) )
    <=> ( ( A3 != bot_bot(set(A)) )
        & ( B2 = bot_bot(set(B)) ) ) ) ).

% Func_is_emp
tff(fact_1530_Func__non__emp,axiom,
    ! [A: $tType,B: $tType,B2: set(A),A3: set(B)] :
      ( ( B2 != bot_bot(set(A)) )
     => ( bNF_Wellorder_Func(B,A,A3,B2) != bot_bot(set(fun(B,A))) ) ) ).

% Func_non_emp
tff(fact_1531_Pow__Compl,axiom,
    ! [A: $tType,A3: set(A)] : ( pow(A,aa(set(A),set(A),uminus_uminus(set(A)),A3)) = aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_kg(set(A),fun(set(A),bool),A3)) ) ).

% Pow_Compl
tff(fact_1532_cInf__le__cSup,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,A3)
           => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Sup_Sup(A),A3))) ) ) ) ) ).

% cInf_le_cSup
tff(fact_1533_le__cInf__iff,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S: set(A),A4: A] :
          ( ( S != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),S))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(set(A),A,complete_Inf_Inf(A),S)))
            <=> ! [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),S))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),X3)) ) ) ) ) ) ).

% le_cInf_iff
tff(fact_1534_cInf__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [B2: set(A),A3: set(A)] :
          ( ( B2 != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),A3))
           => ( ! [B4: A] :
                  ( pp(aa(set(A),bool,member(A,B4),B2))
                 => ? [X4: A] :
                      ( pp(aa(set(A),bool,member(A,X4),A3))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),B4)) ) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B2))) ) ) ) ) ).

% cInf_mono
tff(fact_1535_cSup__le__iff,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S: set(A),A4: A] :
          ( ( S != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,S)
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),S)),A4))
            <=> ! [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),S))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),A4)) ) ) ) ) ) ).

% cSup_le_iff
tff(fact_1536_cSup__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [B2: set(A),A3: set(A)] :
          ( ( B2 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,A3)
           => ( ! [B4: A] :
                  ( pp(aa(set(A),bool,member(A,B4),B2))
                 => ? [X4: A] :
                      ( pp(aa(set(A),bool,member(A,X4),A3))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B4),X4)) ) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),B2)),aa(set(A),A,complete_Sup_Sup(A),A3))) ) ) ) ) ).

% cSup_mono
tff(fact_1537_partial__order__on__empty,axiom,
    ! [A: $tType] : order_7125193373082350890der_on(A,bot_bot(set(A)),bot_bot(set(product_prod(A,A)))) ).

% partial_order_on_empty
tff(fact_1538_wo__rel_Omax2__among,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A,B3: A] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( pp(aa(set(A),bool,member(A,A4),field2(A,R2)))
       => ( pp(aa(set(A),bool,member(A,B3),field2(A,R2)))
         => pp(aa(set(A),bool,member(A,bNF_We1388413361240627857o_max2(A,R2,A4,B3)),aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))))) ) ) ) ).

% wo_rel.max2_among
tff(fact_1539_wo__rel_Ocases__Total,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A,B3: A,Phi: fun(A,fun(A,bool))] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))),field2(A,R2)))
       => ( ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),R2))
           => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A4),B3)) )
         => ( ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B3),A4)),R2))
             => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A4),B3)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A4),B3)) ) ) ) ) ).

% wo_rel.cases_Total
tff(fact_1540_le__cINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),F2: fun(B,A),U: A] :
          ( ( A3 != bot_bot(set(B)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,F2),A3)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))))
            <=> ! [X3: B] :
                  ( pp(aa(set(B),bool,member(B,X3),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(B,A,F2,X3))) ) ) ) ) ) ).

% le_cINF_iff
tff(fact_1541_cINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [B2: set(B),F2: fun(C,A),A3: set(C),G: fun(B,A)] :
          ( ( B2 != bot_bot(set(B)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(C),set(A),image2(C,A,F2),A3)))
           => ( ! [M3: B] :
                  ( pp(aa(set(B),bool,member(B,M3),B2))
                 => ? [X4: C] :
                      ( pp(aa(set(C),bool,member(C,X4),A3))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(C,A,F2,X4)),aa(B,A,G,M3))) ) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,F2),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),B2)))) ) ) ) ) ).

% cINF_mono
tff(fact_1542_cInf__superset__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A),B2: set(A)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),B2))
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),B2)),aa(set(A),A,complete_Inf_Inf(A),A3))) ) ) ) ) ).

% cInf_superset_mono
tff(fact_1543_cSUP__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),F2: fun(B,A),U: A] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F2),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),U))
            <=> ! [X3: B] :
                  ( pp(aa(set(B),bool,member(B,X3),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X3)),U)) ) ) ) ) ) ).

% cSUP_le_iff
tff(fact_1544_cSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),G: fun(C,A),B2: set(C),F2: fun(B,A)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(C),set(A),image2(C,A,G),B2))
           => ( ! [N2: B] :
                  ( pp(aa(set(B),bool,member(B,N2),A3))
                 => ? [X4: C] :
                      ( pp(aa(set(C),bool,member(C,X4),B2))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,N2)),aa(C,A,G,X4))) ) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,G),B2)))) ) ) ) ) ).

% cSUP_mono
tff(fact_1545_wo__rel_Omax2__greater__among,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A,B3: A] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( pp(aa(set(A),bool,member(A,A4),field2(A,R2)))
       => ( pp(aa(set(A),bool,member(A,B3),field2(A,R2)))
         => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),bNF_We1388413361240627857o_max2(A,R2,A4,B3))),R2))
            & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B3),bNF_We1388413361240627857o_max2(A,R2,A4,B3))),R2))
            & pp(aa(set(A),bool,member(A,bNF_We1388413361240627857o_max2(A,R2,A4,B3)),aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))))) ) ) ) ) ).

% wo_rel.max2_greater_among
tff(fact_1546_cSup__subset__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A),B2: set(A)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,B2)
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B2))) ) ) ) ) ).

% cSup_subset_mono
tff(fact_1547_cInf__insert,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X5: set(A),A4: A] :
          ( ( X5 != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),X5))
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert(A,A4),X5)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),aa(set(A),A,complete_Inf_Inf(A),X5)) ) ) ) ) ).

% cInf_insert
tff(fact_1548_cInf__insert__If,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X5: set(A),A4: A] :
          ( pp(aa(set(A),bool,condit1013018076250108175_below(A),X5))
         => ( ( ( X5 = bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert(A,A4),X5)) = A4 ) )
            & ( ( X5 != bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert(A,A4),X5)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),aa(set(A),A,complete_Inf_Inf(A),X5)) ) ) ) ) ) ).

% cInf_insert_If
tff(fact_1549_cSup__insert__If,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X5: set(A),A4: A] :
          ( condit941137186595557371_above(A,X5)
         => ( ( ( X5 = bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert(A,A4),X5)) = A4 ) )
            & ( ( X5 != bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert(A,A4),X5)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),aa(set(A),A,complete_Sup_Sup(A),X5)) ) ) ) ) ) ).

% cSup_insert_If
tff(fact_1550_cSup__insert,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X5: set(A),A4: A] :
          ( ( X5 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,X5)
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert(A,A4),X5)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),aa(set(A),A,complete_Sup_Sup(A),X5)) ) ) ) ) ).

% cSup_insert
tff(fact_1551_cInf__union__distrib,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A),B2: set(A)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),A3))
           => ( ( B2 != bot_bot(set(A)) )
             => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),B2))
               => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B2)) ) ) ) ) ) ) ).

% cInf_union_distrib
tff(fact_1552_cSup__union__distrib,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A),B2: set(A)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,A3)
           => ( ( B2 != bot_bot(set(A)) )
             => ( condit941137186595557371_above(A,B2)
               => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B2)) ) ) ) ) ) ) ).

% cSup_union_distrib
tff(fact_1553_Pow__INT__eq,axiom,
    ! [A: $tType,B: $tType,B2: fun(B,set(A)),A3: set(B)] : ( pow(A,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3))) = aa(set(set(set(A))),set(set(A)),complete_Inf_Inf(set(set(A))),aa(set(B),set(set(set(A))),image2(B,set(set(A)),aTP_Lamp_jy(fun(B,set(A)),fun(B,set(set(A))),B2)),A3)) ) ).

% Pow_INT_eq
tff(fact_1554_cINF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,F2),A3)))
           => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,G),A3)))
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),A3))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_kh(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),A3)) ) ) ) ) ) ).

% cINF_inf_distrib
tff(fact_1555_conditionally__complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F2),A3))
           => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,G),A3))
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,G),A3))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ki(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),A3)) ) ) ) ) ) ).

% conditionally_complete_lattice_class.SUP_sup_distrib
tff(fact_1556_cINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),G: fun(B,A),B2: set(B),F2: fun(B,A)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,G),B2)))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A3),B2))
             => ( ! [X: B] :
                    ( pp(aa(set(B),bool,member(B,X),B2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,G,X)),aa(B,A,F2,X))) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),B2))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3)))) ) ) ) ) ) ).

% cINF_superset_mono
tff(fact_1557_cSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),G: fun(B,A),B2: set(B),F2: fun(B,A)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,G),B2))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A3),B2))
             => ( ! [X: B] :
                    ( pp(aa(set(B),bool,member(B,X),A3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X)),aa(B,A,G,X))) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,G),B2)))) ) ) ) ) ) ).

% cSUP_subset_mono
tff(fact_1558_less__eq__cInf__inter,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,condit1013018076250108175_below(A),A3))
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),B2))
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) != bot_bot(set(A)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B2))),aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)))) ) ) ) ) ).

% less_eq_cInf_inter
tff(fact_1559_cINF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),F2: fun(B,A),A4: B] :
          ( ( A3 != bot_bot(set(B)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,F2),A3)))
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),aa(set(B),set(B),insert(B,A4),A3))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,F2,A4)),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))) ) ) ) ) ).

% cINF_insert
tff(fact_1560_cSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A),B2: set(A)] :
          ( condit941137186595557371_above(A,A3)
         => ( condit941137186595557371_above(A,B2)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) != bot_bot(set(A)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B2)))) ) ) ) ) ).

% cSup_inter_less_eq
tff(fact_1561_cSUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),F2: fun(B,A),A4: B] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F2),A3))
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),aa(set(B),set(B),insert(B,A4),A3))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,F2,A4)),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))) ) ) ) ) ).

% cSUP_insert
tff(fact_1562_cINF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),F2: fun(B,A),B2: set(B)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,F2),A3)))
           => ( ( B2 != bot_bot(set(B)) )
             => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,F2),B2)))
               => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),B2))) ) ) ) ) ) ) ).

% cINF_union
tff(fact_1563_Partial__order__Restr,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( order_7125193373082350890der_on(A,field2(A,R2),R2)
     => order_7125193373082350890der_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ).

% Partial_order_Restr
tff(fact_1564_cSUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(B),F2: fun(B,A),B2: set(B)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F2),A3))
           => ( ( B2 != bot_bot(set(B)) )
             => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F2),B2))
               => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),B2))) ) ) ) ) ) ) ).

% cSUP_union
tff(fact_1565_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: fun(A,B),C3: set(A),B2: set(A),X2: A] :
      ( inj_on(A,B,G,C3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))))
       => pp(aa(set(fun(B,A)),bool,member(fun(B,A),aa(A,fun(B,A),aa(set(A),fun(A,fun(B,A)),aTP_Lamp_kj(fun(A,B),fun(set(A),fun(A,fun(B,A))),G),C3),X2)),bNF_Wellorder_Func(B,A,top_top(set(B)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))))) ) ) ).

% If_the_inv_into_in_Func
tff(fact_1566_wo__rel_OWell__order__isMinim__exists,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),B2: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),field2(A,R2)))
       => ( ( B2 != bot_bot(set(A)) )
         => ? [X_1: A] : pp(aa(A,bool,bNF_We4791949203932849705sMinim(A,R2,B2),X_1)) ) ) ) ).

% wo_rel.Well_order_isMinim_exists
tff(fact_1567_wo__rel_Ominim__in,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),B2: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),field2(A,R2)))
       => ( ( B2 != bot_bot(set(A)) )
         => pp(aa(set(A),bool,member(A,bNF_We6954850376910717587_minim(A,R2,B2)),B2)) ) ) ) ).

% wo_rel.minim_in
tff(fact_1568_wo__rel_Ominim__inField,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),B2: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),field2(A,R2)))
       => ( ( B2 != bot_bot(set(A)) )
         => pp(aa(set(A),bool,member(A,bNF_We6954850376910717587_minim(A,R2,B2)),field2(A,R2))) ) ) ) ).

% wo_rel.minim_inField
tff(fact_1569_curr__surj,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: fun(A,fun(B,C)),A3: set(A),B2: set(B),C3: set(C)] :
      ( pp(aa(set(fun(A,fun(B,C))),bool,member(fun(A,fun(B,C)),G),bNF_Wellorder_Func(A,fun(B,C),A3,bNF_Wellorder_Func(B,C,B2,C3))))
     => ? [X: fun(product_prod(A,B),C)] :
          ( pp(aa(set(fun(product_prod(A,B),C)),bool,member(fun(product_prod(A,B),C),X),bNF_Wellorder_Func(product_prod(A,B),C,product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)),C3)))
          & ( aa(fun(product_prod(A,B),C),fun(A,fun(B,C)),bNF_Wellorder_curr(A,B,C,A3),X) = G ) ) ) ).

% curr_surj
tff(fact_1570_curr__in,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(product_prod(A,B),C),A3: set(A),B2: set(B),C3: set(C)] :
      ( pp(aa(set(fun(product_prod(A,B),C)),bool,member(fun(product_prod(A,B),C),F2),bNF_Wellorder_Func(product_prod(A,B),C,product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)),C3)))
     => pp(aa(set(fun(A,fun(B,C))),bool,member(fun(A,fun(B,C)),aa(fun(product_prod(A,B),C),fun(A,fun(B,C)),bNF_Wellorder_curr(A,B,C,A3),F2)),bNF_Wellorder_Func(A,fun(B,C),A3,bNF_Wellorder_Func(B,C,B2,C3)))) ) ).

% curr_in
tff(fact_1571_proj__iff,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X2: A,Y: A] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,X2),aa(set(A),set(A),insert(A,Y),bot_bot(set(A))))),A3))
       => ( ( equiv_proj(A,A,R2,X2) = equiv_proj(A,A,R2,Y) )
        <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y)),R2)) ) ) ) ).

% proj_iff
tff(fact_1572_subset__singleton__iff__Uniq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ? [A6: A] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,A6),bot_bot(set(A)))))
    <=> uniq(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3)) ) ).

% subset_singleton_iff_Uniq
tff(fact_1573_alt__ex1E_H,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ? [X4: A] :
          ( pp(aa(A,bool,P,X4))
          & ! [Y2: A] :
              ( pp(aa(A,bool,P,Y2))
             => ( Y2 = X4 ) ) )
     => ~ ( ? [X_1: A] : pp(aa(A,bool,P,X_1))
         => ~ uniq(A,P) ) ) ).

% alt_ex1E'
tff(fact_1574_ex1__iff__ex__Uniq,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ? [X3: A] :
          ( pp(aa(A,bool,P,X3))
          & ! [Y4: A] :
              ( pp(aa(A,bool,P,Y4))
             => ( Y4 = X3 ) ) )
    <=> ( ? [X_12: A] : pp(aa(A,bool,P,X_12))
        & uniq(A,P) ) ) ).

% ex1_iff_ex_Uniq
tff(fact_1575_in__quotient__imp__non__empty,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X5: set(A)] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(set(A)),bool,member(set(A),X5),equiv_quotient(A,A3,R2)))
       => ( X5 != bot_bot(set(A)) ) ) ) ).

% in_quotient_imp_non_empty
tff(fact_1576_the__inv__into__def,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F2: fun(A,B),X4: B] : ( the_inv_into(A,B,A3,F2,X4) = the(A,aa(B,fun(A,bool),aa(fun(A,B),fun(B,fun(A,bool)),aTP_Lamp_kk(set(A),fun(fun(A,B),fun(B,fun(A,bool))),A3),F2),X4)) ) ).

% the_inv_into_def
tff(fact_1577_inj__on__iff__Uniq,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A3: set(A)] :
      ( inj_on(A,B,F2,A3)
    <=> ! [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),A3))
         => uniq(A,aa(A,fun(A,bool),aa(set(A),fun(A,fun(A,bool)),aTP_Lamp_kl(fun(A,B),fun(set(A),fun(A,fun(A,bool))),F2),A3),X3)) ) ) ).

% inj_on_iff_Uniq
tff(fact_1578_wo__rel_Ominim__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( bNF_We6954850376910717587_minim(A,R2,A3) = the(A,bNF_We4791949203932849705sMinim(A,R2,A3)) ) ) ).

% wo_rel.minim_def
tff(fact_1579_the1__equality_H,axiom,
    ! [A: $tType,P: fun(A,bool),A4: A] :
      ( uniq(A,P)
     => ( pp(aa(A,bool,P,A4))
       => ( the(A,P) = A4 ) ) ) ).

% the1_equality'
tff(fact_1580_equiv__type,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A))] :
      ( equiv_equiv(A,A3,R2)
     => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ).

% equiv_type
tff(fact_1581_equiv__class__self,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),A4: A] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(A),bool,member(A,A4),A3))
       => pp(aa(set(A),bool,member(A,A4),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))) ) ) ).

% equiv_class_self
tff(fact_1582_quotient__disj,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X5: set(A),Y3: set(A)] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(set(A)),bool,member(set(A),X5),equiv_quotient(A,A3,R2)))
       => ( pp(aa(set(set(A)),bool,member(set(A),Y3),equiv_quotient(A,A3,R2)))
         => ( ( X5 = Y3 )
            | ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),X5),Y3) = bot_bot(set(A)) ) ) ) ) ) ).

% quotient_disj
tff(fact_1583_curr__inj,axiom,
    ! [C: $tType,B: $tType,A: $tType,F1: fun(product_prod(A,B),C),A3: set(A),B2: set(B),C3: set(C),F22: fun(product_prod(A,B),C)] :
      ( pp(aa(set(fun(product_prod(A,B),C)),bool,member(fun(product_prod(A,B),C),F1),bNF_Wellorder_Func(product_prod(A,B),C,product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)),C3)))
     => ( pp(aa(set(fun(product_prod(A,B),C)),bool,member(fun(product_prod(A,B),C),F22),bNF_Wellorder_Func(product_prod(A,B),C,product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)),C3)))
       => ( ( aa(fun(product_prod(A,B),C),fun(A,fun(B,C)),bNF_Wellorder_curr(A,B,C,A3),F1) = aa(fun(product_prod(A,B),C),fun(A,fun(B,C)),bNF_Wellorder_curr(A,B,C,A3),F22) )
        <=> ( F1 = F22 ) ) ) ) ).

% curr_inj
tff(fact_1584_wo__rel_Ominim__isMinim,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),B2: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),field2(A,R2)))
       => ( ( B2 != bot_bot(set(A)) )
         => pp(aa(A,bool,bNF_We4791949203932849705sMinim(A,R2,B2),bNF_We6954850376910717587_minim(A,R2,B2))) ) ) ) ).

% wo_rel.minim_isMinim
tff(fact_1585_eq__equiv__class,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A,B3: A,A3: set(A)] :
      ( ( aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) = aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))) )
     => ( equiv_equiv(A,A3,R2)
       => ( pp(aa(set(A),bool,member(A,B3),A3))
         => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),R2)) ) ) ) ).

% eq_equiv_class
tff(fact_1586_equiv__class__eq,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),A4: A,B3: A] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),R2))
       => ( aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) = aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))) ) ) ) ).

% equiv_class_eq
tff(fact_1587_eq__equiv__class__iff,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X2: A,Y: A] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(A),bool,member(A,X2),A3))
       => ( pp(aa(set(A),bool,member(A,Y),A3))
         => ( ( aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,Y),bot_bot(set(A)))) )
          <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y)),R2)) ) ) ) ) ).

% eq_equiv_class_iff
tff(fact_1588_equiv__class__eq__iff,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X2: A,Y: A] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y)),R2))
      <=> ( ( aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,Y),bot_bot(set(A)))) )
          & pp(aa(set(A),bool,member(A,X2),A3))
          & pp(aa(set(A),bool,member(A,Y),A3)) ) ) ) ).

% equiv_class_eq_iff
tff(fact_1589_eq__equiv__class__iff2,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X2: A,Y: A] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(A),bool,member(A,X2),A3))
       => ( pp(aa(set(A),bool,member(A,Y),A3))
         => ( ( equiv_quotient(A,aa(set(A),set(A),insert(A,X2),bot_bot(set(A))),R2) = equiv_quotient(A,aa(set(A),set(A),insert(A,Y),bot_bot(set(A))),R2) )
          <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y)),R2)) ) ) ) ) ).

% eq_equiv_class_iff2
tff(fact_1590_refines__equiv__class__eq,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S: set(product_prod(A,A)),A3: set(A),A4: A] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R),S))
     => ( equiv_equiv(A,A3,R)
       => ( equiv_equiv(A,A3,S)
         => ( aa(set(A),set(A),image(A,A,R),aa(set(A),set(A),image(A,A,S),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))) = aa(set(A),set(A),image(A,A,S),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) ) ) ) ) ).

% refines_equiv_class_eq
tff(fact_1591_refines__equiv__class__eq2,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S: set(product_prod(A,A)),A3: set(A),A4: A] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R),S))
     => ( equiv_equiv(A,A3,R)
       => ( equiv_equiv(A,A3,S)
         => ( aa(set(A),set(A),image(A,A,S),aa(set(A),set(A),image(A,A,R),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))) = aa(set(A),set(A),image(A,A,S),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) ) ) ) ) ).

% refines_equiv_class_eq2
tff(fact_1592_refines__equiv__image__eq,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S: set(product_prod(A,A)),A3: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R),S))
     => ( equiv_equiv(A,A3,R)
       => ( equiv_equiv(A,A3,S)
         => ( aa(set(set(A)),set(set(A)),image2(set(A),set(A),image(A,A,S)),equiv_quotient(A,A3,R)) = equiv_quotient(A,A3,S) ) ) ) ) ).

% refines_equiv_image_eq
tff(fact_1593_equiv__class__subset,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),A4: A,B3: A] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),R2))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))))) ) ) ).

% equiv_class_subset
tff(fact_1594_subset__equiv__class,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),B3: A,A4: A] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))))
       => ( pp(aa(set(A),bool,member(A,B3),A3))
         => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),R2)) ) ) ) ).

% subset_equiv_class
tff(fact_1595_equiv__class__nondisjoint,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X2: A,A4: A,B3: A] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(A),bool,member(A,X2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))))))
       => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),R2)) ) ) ).

% equiv_class_nondisjoint
tff(fact_1596_in__quotient__imp__in__rel,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X5: set(A),X2: A,Y: A] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(set(A)),bool,member(set(A),X5),equiv_quotient(A,A3,R2)))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,X2),aa(set(A),set(A),insert(A,Y),bot_bot(set(A))))),X5))
         => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y)),R2)) ) ) ) ).

% in_quotient_imp_in_rel
tff(fact_1597_UN__equiv__class2,axiom,
    ! [A: $tType,C: $tType,B: $tType,A1: set(A),R12: set(product_prod(A,A)),A22: set(B),R23: set(product_prod(B,B)),F2: fun(A,fun(B,set(C))),A13: A,A23: B] :
      ( equiv_equiv(A,A1,R12)
     => ( equiv_equiv(B,A22,R23)
       => ( equiv_congruent2(A,B,set(C),R12,R23,F2)
         => ( pp(aa(set(A),bool,member(A,A13),A1))
           => ( pp(aa(set(B),bool,member(B,A23),A22))
             => ( aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image2(A,set(C),aa(B,fun(A,set(C)),aa(fun(A,fun(B,set(C))),fun(B,fun(A,set(C))),aTP_Lamp_km(set(product_prod(B,B)),fun(fun(A,fun(B,set(C))),fun(B,fun(A,set(C)))),R23),F2),A23)),aa(set(A),set(A),image(A,A,R12),aa(set(A),set(A),insert(A,A13),bot_bot(set(A)))))) = aa(B,set(C),aa(A,fun(B,set(C)),F2,A13),A23) ) ) ) ) ) ) ).

% UN_equiv_class2
tff(fact_1598_UN__equiv__class,axiom,
    ! [B: $tType,A: $tType,A3: set(A),R2: set(product_prod(A,A)),F2: fun(A,set(B)),A4: A] :
      ( equiv_equiv(A,A3,R2)
     => ( equiv_congruent(A,set(B),R2,F2)
       => ( pp(aa(set(A),bool,member(A,A4),A3))
         => ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),F2),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))) = aa(A,set(B),F2,A4) ) ) ) ) ).

% UN_equiv_class
tff(fact_1599_UN__equiv__class__inject,axiom,
    ! [B: $tType,A: $tType,A3: set(A),R2: set(product_prod(A,A)),F2: fun(A,set(B)),X5: set(A),Y3: set(A)] :
      ( equiv_equiv(A,A3,R2)
     => ( equiv_congruent(A,set(B),R2,F2)
       => ( ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),F2),X5)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),F2),Y3)) )
         => ( pp(aa(set(set(A)),bool,member(set(A),X5),equiv_quotient(A,A3,R2)))
           => ( pp(aa(set(set(A)),bool,member(set(A),Y3),equiv_quotient(A,A3,R2)))
             => ( ! [X: A,Y2: A] :
                    ( pp(aa(set(A),bool,member(A,X),A3))
                   => ( pp(aa(set(A),bool,member(A,Y2),A3))
                     => ( ( aa(A,set(B),F2,X) = aa(A,set(B),F2,Y2) )
                       => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y2)),R2)) ) ) )
               => ( X5 = Y3 ) ) ) ) ) ) ) ).

% UN_equiv_class_inject
tff(fact_1600_UN__equiv__class__type2,axiom,
    ! [A: $tType,B: $tType,C: $tType,A1: set(A),R12: set(product_prod(A,A)),A22: set(B),R23: set(product_prod(B,B)),F2: fun(A,fun(B,set(C))),X1: set(A),X22: set(B),B2: set(set(C))] :
      ( equiv_equiv(A,A1,R12)
     => ( equiv_equiv(B,A22,R23)
       => ( equiv_congruent2(A,B,set(C),R12,R23,F2)
         => ( pp(aa(set(set(A)),bool,member(set(A),X1),equiv_quotient(A,A1,R12)))
           => ( pp(aa(set(set(B)),bool,member(set(B),X22),equiv_quotient(B,A22,R23)))
             => ( ! [X12: A,X23: B] :
                    ( pp(aa(set(A),bool,member(A,X12),A1))
                   => ( pp(aa(set(B),bool,member(B,X23),A22))
                     => pp(aa(set(set(C)),bool,member(set(C),aa(B,set(C),aa(A,fun(B,set(C)),F2,X12),X23)),B2)) ) )
               => pp(aa(set(set(C)),bool,member(set(C),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image2(A,set(C),aa(set(B),fun(A,set(C)),aTP_Lamp_kn(fun(A,fun(B,set(C))),fun(set(B),fun(A,set(C))),F2),X22)),X1))),B2)) ) ) ) ) ) ) ).

% UN_equiv_class_type2
tff(fact_1601_UN__equiv__class__type,axiom,
    ! [A: $tType,B: $tType,A3: set(A),R2: set(product_prod(A,A)),F2: fun(A,set(B)),X5: set(A),B2: set(set(B))] :
      ( equiv_equiv(A,A3,R2)
     => ( equiv_congruent(A,set(B),R2,F2)
       => ( pp(aa(set(set(A)),bool,member(set(A),X5),equiv_quotient(A,A3,R2)))
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),A3))
               => pp(aa(set(set(B)),bool,member(set(B),aa(A,set(B),F2,X)),B2)) )
           => pp(aa(set(set(B)),bool,member(set(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),F2),X5))),B2)) ) ) ) ) ).

% UN_equiv_class_type
tff(fact_1602_bij__betw__curr,axiom,
    ! [A: $tType,B: $tType,C: $tType,A3: set(A),B2: set(B),C3: set(C)] : bij_betw(fun(product_prod(A,B),C),fun(A,fun(B,C)),bNF_Wellorder_curr(A,B,C,A3),bNF_Wellorder_Func(product_prod(A,B),C,product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)),C3),bNF_Wellorder_Func(A,fun(B,C),A3,bNF_Wellorder_Func(B,C,B2,C3))) ).

% bij_betw_curr
tff(fact_1603_disjnt__equiv__class,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),A4: A,B3: A] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),disjnt(A),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))),aa(set(A),set(A),image(A,A,R2),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))))
      <=> ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),R2)) ) ) ).

% disjnt_equiv_class
tff(fact_1604_congruent2__implies__congruent__UN,axiom,
    ! [A: $tType,C: $tType,B: $tType,A1: set(A),R12: set(product_prod(A,A)),A22: set(B),R23: set(product_prod(B,B)),F2: fun(A,fun(B,set(C))),A4: B] :
      ( equiv_equiv(A,A1,R12)
     => ( equiv_equiv(B,A22,R23)
       => ( equiv_congruent2(A,B,set(C),R12,R23,F2)
         => ( pp(aa(set(B),bool,member(B,A4),A22))
           => equiv_congruent(A,set(C),R12,aa(B,fun(A,set(C)),aa(fun(A,fun(B,set(C))),fun(B,fun(A,set(C))),aTP_Lamp_km(set(product_prod(B,B)),fun(fun(A,fun(B,set(C))),fun(B,fun(A,set(C)))),R23),F2),A4)) ) ) ) ) ).

% congruent2_implies_congruent_UN
tff(fact_1605_disjnt__self__iff__empty,axiom,
    ! [A: $tType,S: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),disjnt(A),S),S))
    <=> ( S = bot_bot(set(A)) ) ) ).

% disjnt_self_iff_empty
tff(fact_1606_disjnt__Times2__iff,axiom,
    ! [B: $tType,A: $tType,A3: set(A),C3: set(B),B2: set(A)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),disjnt(product_prod(A,B)),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),C3))),product_Sigma(A,B,B2,aTP_Lamp_bq(set(B),fun(A,set(B)),C3))))
    <=> ( ( C3 = bot_bot(set(B)) )
        | pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),disjnt(A),A3),B2)) ) ) ).

% disjnt_Times2_iff
tff(fact_1607_disjnt__Times1__iff,axiom,
    ! [A: $tType,B: $tType,C3: set(A),A3: set(B),B2: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),disjnt(product_prod(A,B)),product_Sigma(A,B,C3,aTP_Lamp_bq(set(B),fun(A,set(B)),A3))),product_Sigma(A,B,C3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))
    <=> ( ( C3 = bot_bot(set(A)) )
        | pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),disjnt(B),A3),B2)) ) ) ).

% disjnt_Times1_iff
tff(fact_1608_bij__betw__empty1,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A3: set(B)] :
      ( bij_betw(A,B,F2,bot_bot(set(A)),A3)
     => ( A3 = bot_bot(set(B)) ) ) ).

% bij_betw_empty1
tff(fact_1609_bij__betw__empty2,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A3: set(A)] :
      ( bij_betw(A,B,F2,A3,bot_bot(set(B)))
     => ( A3 = bot_bot(set(A)) ) ) ).

% bij_betw_empty2
tff(fact_1610_disjnt__empty1,axiom,
    ! [A: $tType,A3: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),disjnt(A),bot_bot(set(A))),A3)) ).

% disjnt_empty1
tff(fact_1611_disjnt__empty2,axiom,
    ! [A: $tType,A3: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),disjnt(A),A3),bot_bot(set(A)))) ).

% disjnt_empty2
tff(fact_1612_disjnt__Sigma__iff,axiom,
    ! [B: $tType,A: $tType,A3: set(A),C3: fun(A,set(B)),B2: set(A)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),disjnt(product_prod(A,B)),product_Sigma(A,B,A3,C3)),product_Sigma(A,B,B2,C3)))
    <=> ( ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)))
           => ( aa(A,set(B),C3,X3) = bot_bot(set(B)) ) )
        | pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),disjnt(A),A3),B2)) ) ) ).

% disjnt_Sigma_iff
tff(fact_1613_disjnt__def,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),disjnt(A),A3),B2))
    <=> ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) ) ) ).

% disjnt_def
tff(fact_1614_notIn__Un__bij__betw,axiom,
    ! [A: $tType,B: $tType,B3: A,A3: set(A),F2: fun(A,B),A10: set(B)] :
      ( ~ pp(aa(set(A),bool,member(A,B3),A3))
     => ( ~ pp(aa(set(B),bool,member(B,aa(A,B,F2,B3)),A10))
       => ( bij_betw(A,B,F2,A3,A10)
         => bij_betw(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A10),aa(set(B),set(B),insert(B,aa(A,B,F2,B3)),bot_bot(set(B))))) ) ) ) ).

% notIn_Un_bij_betw
tff(fact_1615_notIn__Un__bij__betw3,axiom,
    ! [A: $tType,B: $tType,B3: A,A3: set(A),F2: fun(A,B),A10: set(B)] :
      ( ~ pp(aa(set(A),bool,member(A,B3),A3))
     => ( ~ pp(aa(set(B),bool,member(B,aa(A,B,F2,B3)),A10))
       => ( bij_betw(A,B,F2,A3,A10)
        <=> bij_betw(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A10),aa(set(B),set(B),insert(B,aa(A,B,F2,B3)),bot_bot(set(B))))) ) ) ) ).

% notIn_Un_bij_betw3
tff(fact_1616_bij__betw__combine,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A3: set(A),B2: set(B),C3: set(A),D2: set(B)] :
      ( bij_betw(A,B,F2,A3,B2)
     => ( bij_betw(A,B,F2,C3,D2)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),D2) = bot_bot(set(B)) )
         => bij_betw(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),C3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),D2)) ) ) ) ).

% bij_betw_combine
tff(fact_1617_bij__betw__partition,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A3: set(A),C3: set(A),B2: set(B),D2: set(B)] :
      ( bij_betw(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),C3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),D2))
     => ( bij_betw(A,B,F2,C3,D2)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C3) = bot_bot(set(A)) )
         => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),D2) = bot_bot(set(B)) )
           => bij_betw(A,B,F2,A3,B2) ) ) ) ) ).

% bij_betw_partition
tff(fact_1618_disjoint__UN__iff,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: fun(B,set(A)),I: set(B)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),disjnt(A),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),I))))
    <=> ! [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),I))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),disjnt(A),A3),aa(B,set(A),B2,X3))) ) ) ).

% disjoint_UN_iff
tff(fact_1619_bij__betw__disjoint__Un,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A3: set(A),C3: set(B),G: fun(A,B),B2: set(A),D2: set(B)] :
      ( bij_betw(A,B,F2,A3,C3)
     => ( bij_betw(A,B,G,B2,D2)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) )
         => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C3),D2) = bot_bot(set(B)) )
           => bij_betw(A,B,aa(fun(A,B),fun(A,B),aa(set(A),fun(fun(A,B),fun(A,B)),aTP_Lamp_ef(fun(A,B),fun(set(A),fun(fun(A,B),fun(A,B))),F2),A3),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),C3),D2)) ) ) ) ) ).

% bij_betw_disjoint_Un
tff(fact_1620_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I: set(A),A3: fun(A,set(B)),F2: fun(B,C),A10: fun(A,set(C))] :
      ( ! [I3: A,J4: A] :
          ( pp(aa(set(A),bool,member(A,I3),I))
         => ( pp(aa(set(A),bool,member(A,J4),I))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),A3,I3)),aa(A,set(B),A3,J4)))
              | pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),A3,J4)),aa(A,set(B),A3,I3))) ) ) )
     => ( ! [I3: A] :
            ( pp(aa(set(A),bool,member(A,I3),I))
           => bij_betw(B,C,F2,aa(A,set(B),A3,I3),aa(A,set(C),A10,I3)) )
       => bij_betw(B,C,F2,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),I)),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image2(A,set(C),A10),I))) ) ) ).

% bij_betw_UNION_chain
tff(fact_1621_bij__image__INT,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(A,B),B2: fun(C,set(A)),A3: set(C)] :
      ( bij_betw(A,B,F2,top_top(set(A)),top_top(set(B)))
     => ( aa(set(A),set(B),image2(A,B,F2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image2(C,set(A),B2),A3))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(A)),fun(C,set(B)),aTP_Lamp_iz(fun(A,B),fun(fun(C,set(A)),fun(C,set(B))),F2),B2)),A3)) ) ) ).

% bij_image_INT
tff(fact_1622_comp__fun__commute__Pow__fold,axiom,
    ! [A: $tType] : finite6289374366891150609ommute(A,set(set(A)),aTP_Lamp_ko(A,fun(set(set(A)),set(set(A))))) ).

% comp_fun_commute_Pow_fold
tff(fact_1623_inf__img__fin__dom_H,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: set(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(set(B),set(A),image2(B,A,F2),A3)))
     => ( ~ pp(aa(set(B),bool,finite_finite2(B),A3))
       => ? [X: A] :
            ( pp(aa(set(A),bool,member(A,X),aa(set(B),set(A),image2(B,A,F2),A3)))
            & ~ pp(aa(set(B),bool,finite_finite2(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F2),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))),A3))) ) ) ) ).

% inf_img_fin_dom'
tff(fact_1624_inf__img__fin__domE_H,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: set(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(set(B),set(A),image2(B,A,F2),A3)))
     => ( ~ pp(aa(set(B),bool,finite_finite2(B),A3))
       => ~ ! [Y2: A] :
              ( pp(aa(set(A),bool,member(A,Y2),aa(set(B),set(A),image2(B,A,F2),A3)))
             => pp(aa(set(B),bool,finite_finite2(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F2),aa(set(A),set(A),insert(A,Y2),bot_bot(set(A))))),A3))) ) ) ) ).

% inf_img_fin_domE'
tff(fact_1625_finite__reachable__advance,axiom,
    ! [A: $tType,E3: set(product_prod(A,A)),V0: A,V: A] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(set(A),set(A),image(A,A,transitive_rtrancl(A,E3)),aa(set(A),set(A),insert(A,V0),bot_bot(set(A))))))
     => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V0),V)),transitive_rtrancl(A,E3)))
       => pp(aa(set(A),bool,finite_finite2(A),aa(set(A),set(A),image(A,A,transitive_rtrancl(A,E3)),aa(set(A),set(A),insert(A,V),bot_bot(set(A)))))) ) ) ).

% finite_reachable_advance
tff(fact_1626_mono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F2: fun(A,B),A3: set(A)] :
          ( order_mono(A,B,F2)
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),A3))
           => ( ( A3 != bot_bot(set(A)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,aa(set(A),A,complete_Inf_Inf(A),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image2(A,B,F2),A3)))) ) ) ) ) ).

% mono_cInf
tff(fact_1627_mono__cINF,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(A) )
     => ! [F2: fun(A,B),A3: fun(C,A),I: set(C)] :
          ( order_mono(A,B,F2)
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(C),set(A),image2(C,A,A3),I)))
           => ( ( I != bot_bot(set(C)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,A3),I)))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_kp(fun(A,B),fun(fun(C,A),fun(C,B)),F2),A3)),I)))) ) ) ) ) ).

% mono_cINF
tff(fact_1628_mono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F2: fun(A,B),A3: set(A)] :
          ( order_mono(A,B,F2)
         => ( condit941137186595557371_above(A,A3)
           => ( ( A3 != bot_bot(set(A)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image2(A,B,F2),A3))),aa(A,B,F2,aa(set(A),A,complete_Sup_Sup(A),A3)))) ) ) ) ) ).

% mono_cSup
tff(fact_1629_mono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F2: fun(A,B),A3: fun(C,A),I: set(C)] :
          ( order_mono(A,B,F2)
         => ( condit941137186595557371_above(A,aa(set(C),set(A),image2(C,A,A3),I))
           => ( ( I != bot_bot(set(C)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_kp(fun(A,B),fun(fun(C,A),fun(C,B)),F2),A3)),I))),aa(A,B,F2,aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,A3),I))))) ) ) ) ) ).

% mono_cSUP
tff(fact_1630_finite__Collect__disjI,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_au(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q))))
    <=> ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),P)))
        & pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),Q))) ) ) ).

% finite_Collect_disjI
tff(fact_1631_finite__Collect__conjI,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),P)))
        | pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),Q))) )
     => pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q)))) ) ).

% finite_Collect_conjI
tff(fact_1632_finite__Int,axiom,
    ! [A: $tType,F: set(A),G4: set(A)] :
      ( ( pp(aa(set(A),bool,finite_finite2(A),F))
        | pp(aa(set(A),bool,finite_finite2(A),G4)) )
     => pp(aa(set(A),bool,finite_finite2(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),F),G4))) ) ).

% finite_Int
tff(fact_1633_finite__Collect__bounded__ex,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),Q: fun(B,fun(A,bool))] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),P)))
     => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,fun(A,bool)),fun(B,bool),aTP_Lamp_kq(fun(A,bool),fun(fun(B,fun(A,bool)),fun(B,bool)),P),Q))))
      <=> ! [Y4: A] :
            ( pp(aa(A,bool,P,Y4))
           => pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(A,fun(B,bool),aTP_Lamp_kr(fun(B,fun(A,bool)),fun(A,fun(B,bool)),Q),Y4)))) ) ) ) ).

% finite_Collect_bounded_ex
tff(fact_1634_finite__Collect__subsets,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => pp(aa(set(set(A)),bool,finite_finite2(set(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_kf(set(A),fun(set(A),bool),A3)))) ) ).

% finite_Collect_subsets
tff(fact_1635_finite__Collect__not,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),P)))
     => ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_as(fun(A,bool),fun(A,bool),P))))
      <=> pp(aa(set(A),bool,finite_finite2(A),top_top(set(A)))) ) ) ).

% finite_Collect_not
tff(fact_1636_finite__SigmaI,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: fun(A,set(B))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ! [A5: A] :
            ( pp(aa(set(A),bool,member(A,A5),A3))
           => pp(aa(set(B),bool,finite_finite2(B),aa(A,set(B),B2,A5))) )
       => pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),product_Sigma(A,B,A3,B2))) ) ) ).

% finite_SigmaI
tff(fact_1637_finite__UN__I,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: fun(A,set(B))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ! [A5: A] :
            ( pp(aa(set(A),bool,member(A,A5),A3))
           => pp(aa(set(B),bool,finite_finite2(B),aa(A,set(B),B2,A5))) )
       => pp(aa(set(B),bool,finite_finite2(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),B2),A3)))) ) ) ).

% finite_UN_I
tff(fact_1638_finite__INT,axiom,
    ! [B: $tType,A: $tType,I: set(A),A3: fun(A,set(B))] :
      ( ? [X4: A] :
          ( pp(aa(set(A),bool,member(A,X4),I))
          & pp(aa(set(B),bool,finite_finite2(B),aa(A,set(B),A3,X4))) )
     => pp(aa(set(B),bool,finite_finite2(B),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),I)))) ) ).

% finite_INT
tff(fact_1639_bdd__above__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [I: set(B),A3: fun(B,set(A))] :
          ( pp(aa(set(B),bool,finite_finite2(B),I))
         => ( condit941137186595557371_above(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I)))
          <=> ! [X3: B] :
                ( pp(aa(set(B),bool,member(B,X3),I))
               => condit941137186595557371_above(A,aa(B,set(A),A3,X3)) ) ) ) ) ).

% bdd_above_UN
tff(fact_1640_bdd__below__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [I: set(B),A3: fun(B,set(A))] :
          ( pp(aa(set(B),bool,finite_finite2(B),I))
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))))
          <=> ! [X3: B] :
                ( pp(aa(set(B),bool,member(B,X3),I))
               => pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(B,set(A),A3,X3))) ) ) ) ) ).

% bdd_below_UN
tff(fact_1641_finite__if__eq__beyond__finite,axiom,
    ! [A: $tType,S: set(A),S4: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),S))
     => pp(aa(set(set(A)),bool,finite_finite2(set(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aa(set(A),fun(set(A),bool),aTP_Lamp_ks(set(A),fun(set(A),fun(set(A),bool)),S),S4)))) ) ).

% finite_if_eq_beyond_finite
tff(fact_1642_not__finite__existsD,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),P)))
     => ? [X_1: A] : pp(aa(A,bool,P,X_1)) ) ).

% not_finite_existsD
tff(fact_1643_pigeonhole__infinite__rel,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B),R: fun(A,fun(B,bool))] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(B),bool,finite_finite2(B),B2))
       => ( ! [X: A] :
              ( pp(aa(set(A),bool,member(A,X),A3))
             => ? [Xa3: B] :
                  ( pp(aa(set(B),bool,member(B,Xa3),B2))
                  & pp(aa(B,bool,aa(A,fun(B,bool),R,X),Xa3)) ) )
         => ? [X: B] :
              ( pp(aa(set(B),bool,member(B,X),B2))
              & ~ pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(B,fun(A,bool),aa(fun(A,fun(B,bool)),fun(B,fun(A,bool)),aTP_Lamp_kt(set(A),fun(fun(A,fun(B,bool)),fun(B,fun(A,bool))),A3),R),X)))) ) ) ) ) ).

% pigeonhole_infinite_rel
tff(fact_1644_finite__cartesian__product,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(B),bool,finite_finite2(B),B2))
       => pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)))) ) ) ).

% finite_cartesian_product
tff(fact_1645_comp__fun__commute__const,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,B)] : finite6289374366891150609ommute(A,B,aTP_Lamp_ku(fun(B,B),fun(A,fun(B,B)),F2)) ).

% comp_fun_commute_const
tff(fact_1646_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B),X2: A,Y: A] :
          ( order_mono(A,B,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,F2,Y))) ) ) ) ).

% monoD
tff(fact_1647_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B),X2: A,Y: A] :
          ( order_mono(A,B,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,F2,Y))) ) ) ) ).

% monoE
tff(fact_1648_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( ! [X: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X)),aa(A,B,F2,Y2))) )
         => order_mono(A,B,F2) ) ) ).

% monoI
tff(fact_1649_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( order_mono(A,B,F2)
        <=> ! [X3: A,Y4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4))) ) ) ) ).

% mono_def
tff(fact_1650_mono__add,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A4: A] : order_mono(A,A,aa(A,fun(A,A),plus_plus(A),A4)) ) ).

% mono_add
tff(fact_1651_finite_OemptyI,axiom,
    ! [A: $tType] : pp(aa(set(A),bool,finite_finite2(A),bot_bot(set(A)))) ).

% finite.emptyI
tff(fact_1652_infinite__imp__nonempty,axiom,
    ! [A: $tType,S: set(A)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),S))
     => ( S != bot_bot(set(A)) ) ) ).

% infinite_imp_nonempty
tff(fact_1653_finite__SigmaI2,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: fun(A,set(B))] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(fun(A,set(B)),fun(A,bool),aTP_Lamp_eb(set(A),fun(fun(A,set(B)),fun(A,bool)),A3),B2))))
     => ( ! [A5: A] :
            ( pp(aa(set(A),bool,member(A,A5),A3))
           => pp(aa(set(B),bool,finite_finite2(B),aa(A,set(B),B2,A5))) )
       => pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),product_Sigma(A,B,A3,B2))) ) ) ).

% finite_SigmaI2
tff(fact_1654_finite__cartesian__productD1,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))
     => ( ( B2 != bot_bot(set(B)) )
       => pp(aa(set(A),bool,finite_finite2(A),A3)) ) ) ).

% finite_cartesian_productD1
tff(fact_1655_finite__cartesian__productD2,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))
     => ( ( A3 != bot_bot(set(A)) )
       => pp(aa(set(B),bool,finite_finite2(B),B2)) ) ) ).

% finite_cartesian_productD2
tff(fact_1656_finite__cartesian__product__iff,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))
    <=> ( ( A3 = bot_bot(set(A)) )
        | ( B2 = bot_bot(set(B)) )
        | ( pp(aa(set(A),bool,finite_finite2(A),A3))
          & pp(aa(set(B),bool,finite_finite2(B),B2)) ) ) ) ).

% finite_cartesian_product_iff
tff(fact_1657_pigeonhole__infinite,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,B)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(B),bool,finite_finite2(B),aa(set(A),set(B),image2(A,B,F2),A3)))
       => ? [X: A] :
            ( pp(aa(set(A),bool,member(A,X),A3))
            & ~ pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aa(fun(A,B),fun(A,fun(A,bool)),aTP_Lamp_kv(set(A),fun(fun(A,B),fun(A,fun(A,bool))),A3),F2),X)))) ) ) ) ).

% pigeonhole_infinite
tff(fact_1658_finite__image__set2,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: fun(A,bool),Q: fun(B,bool),F2: fun(A,fun(B,C))] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),P)))
     => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),Q)))
       => pp(aa(set(C),bool,finite_finite2(C),aa(fun(C,bool),set(C),collect(C),aa(fun(A,fun(B,C)),fun(C,bool),aa(fun(B,bool),fun(fun(A,fun(B,C)),fun(C,bool)),aTP_Lamp_kw(fun(A,bool),fun(fun(B,bool),fun(fun(A,fun(B,C)),fun(C,bool))),P),Q),F2)))) ) ) ).

% finite_image_set2
tff(fact_1659_finite__image__set,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),F2: fun(A,B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),P)))
     => pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(A,B),fun(B,bool),aTP_Lamp_kx(fun(A,bool),fun(fun(A,B),fun(B,bool)),P),F2)))) ) ).

% finite_image_set
tff(fact_1660_INF__filter__not__bot,axiom,
    ! [I5: $tType,A: $tType,B2: set(I5),F: fun(I5,filter(A))] :
      ( ! [X6: set(I5)] :
          ( pp(aa(set(I5),bool,aa(set(I5),fun(set(I5),bool),ord_less_eq(set(I5)),X6),B2))
         => ( pp(aa(set(I5),bool,finite_finite2(I5),X6))
           => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(I5),set(filter(A)),image2(I5,filter(A),F),X6)) != bot_bot(filter(A)) ) ) )
     => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(I5),set(filter(A)),image2(I5,filter(A),F),B2)) != bot_bot(filter(A)) ) ) ).

% INF_filter_not_bot
tff(fact_1661_finite__inverse__image__gen,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F2: fun(B,A),D2: set(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( inj_on(B,A,F2,D2)
       => pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(set(B),fun(B,bool),aa(fun(B,A),fun(set(B),fun(B,bool)),aTP_Lamp_ky(set(A),fun(fun(B,A),fun(set(B),fun(B,bool))),A3),F2),D2)))) ) ) ).

% finite_inverse_image_gen
tff(fact_1662_rtranclp_Omono,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool))] : order_mono(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aTP_Lamp_kz(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),R2)) ).

% rtranclp.mono
tff(fact_1663_tranclp_Omono,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool))] : order_mono(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aTP_Lamp_la(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),R2)) ).

% tranclp.mono
tff(fact_1664_finite__update__induct,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),C2: B,P: fun(fun(A,B),bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(B,fun(A,bool),aTP_Lamp_lb(fun(A,B),fun(B,fun(A,bool)),F2),C2))))
     => ( pp(aa(fun(A,B),bool,P,aTP_Lamp_bm(B,fun(A,B),C2)))
       => ( ! [A5: A,B4: B,F9: fun(A,B)] :
              ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(fun(A,B),fun(A,bool),aTP_Lamp_lc(B,fun(fun(A,B),fun(A,bool)),C2),F9))))
             => ( ( aa(A,B,F9,A5) = C2 )
               => ( ( B4 != C2 )
                 => ( pp(aa(fun(A,B),bool,P,F9))
                   => pp(aa(fun(A,B),bool,P,fun_upd(A,B,F9,A5,B4))) ) ) ) )
         => pp(aa(fun(A,B),bool,P,F2)) ) ) ) ).

% finite_update_induct
tff(fact_1665_finite__quotient,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))))
       => pp(aa(set(set(A)),bool,finite_finite2(set(A)),equiv_quotient(A,A3,R2))) ) ) ).

% finite_quotient
tff(fact_1666_mono__Int,axiom,
    ! [B: $tType,A: $tType,F2: fun(set(A),set(B)),A3: set(A),B2: set(A)] :
      ( order_mono(set(A),set(B),F2)
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),F2,A3)),aa(set(A),set(B),F2,B2)))) ) ).

% mono_Int
tff(fact_1667_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf(A)
        & semilattice_inf(B) )
     => ! [F2: fun(A,B),A3: A,B2: A] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2))),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(A,B,F2,A3)),aa(A,B,F2,B2)))) ) ) ).

% mono_inf
tff(fact_1668_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup(A)
        & semilattice_sup(B) )
     => ! [F2: fun(A,B),A3: A,B2: A] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(A,B,F2,A3)),aa(A,B,F2,B2))),aa(A,B,F2,aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)))) ) ) ).

% mono_sup
tff(fact_1669_comp__fun__commute__filter__fold,axiom,
    ! [A: $tType,P: fun(A,bool)] : finite6289374366891150609ommute(A,set(A),aTP_Lamp_ld(fun(A,bool),fun(A,fun(set(A),set(A))),P)) ).

% comp_fun_commute_filter_fold
tff(fact_1670_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ? [X: A] :
                ( pp(aa(set(A),bool,member(A,X),A3))
                & ! [Xa3: A] :
                    ( pp(aa(set(A),bool,member(A,Xa3),A3))
                   => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Xa3))
                     => ( X = Xa3 ) ) ) ) ) ) ) ).

% finite_has_maximal
tff(fact_1671_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ? [X: A] :
                ( pp(aa(set(A),bool,member(A,X),A3))
                & ! [Xa3: A] :
                    ( pp(aa(set(A),bool,member(A,Xa3),A3))
                   => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Xa3),X))
                     => ( X = Xa3 ) ) ) ) ) ) ) ).

% finite_has_minimal
tff(fact_1672_finite_Ocases,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A4))
     => ( ( A4 != bot_bot(set(A)) )
       => ~ ! [A11: set(A)] :
              ( ? [A5: A] : ( A4 = aa(set(A),set(A),insert(A,A5),A11) )
             => ~ pp(aa(set(A),bool,finite_finite2(A),A11)) ) ) ) ).

% finite.cases
tff(fact_1673_finite_Osimps,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A4))
    <=> ( ( A4 = bot_bot(set(A)) )
        | ? [A12: set(A),A6: A] :
            ( ( A4 = aa(set(A),set(A),insert(A,A6),A12) )
            & pp(aa(set(A),bool,finite_finite2(A),A12)) ) ) ) ).

% finite.simps
tff(fact_1674_finite__induct,axiom,
    ! [A: $tType,F: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),F))
     => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
       => ( ! [X: A,F6: set(A)] :
              ( pp(aa(set(A),bool,finite_finite2(A),F6))
             => ( ~ pp(aa(set(A),bool,member(A,X),F6))
               => ( pp(aa(set(A),bool,P,F6))
                 => pp(aa(set(A),bool,P,aa(set(A),set(A),insert(A,X),F6))) ) ) )
         => pp(aa(set(A),bool,P,F)) ) ) ) ).

% finite_induct
tff(fact_1675_finite__ne__induct,axiom,
    ! [A: $tType,F: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),F))
     => ( ( F != bot_bot(set(A)) )
       => ( ! [X: A] : pp(aa(set(A),bool,P,aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))
         => ( ! [X: A,F6: set(A)] :
                ( pp(aa(set(A),bool,finite_finite2(A),F6))
               => ( ( F6 != bot_bot(set(A)) )
                 => ( ~ pp(aa(set(A),bool,member(A,X),F6))
                   => ( pp(aa(set(A),bool,P,F6))
                     => pp(aa(set(A),bool,P,aa(set(A),set(A),insert(A,X),F6))) ) ) ) )
           => pp(aa(set(A),bool,P,F)) ) ) ) ) ).

% finite_ne_induct
tff(fact_1676_infinite__finite__induct,axiom,
    ! [A: $tType,P: fun(set(A),bool),A3: set(A)] :
      ( ! [A11: set(A)] :
          ( ~ pp(aa(set(A),bool,finite_finite2(A),A11))
         => pp(aa(set(A),bool,P,A11)) )
     => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
       => ( ! [X: A,F6: set(A)] :
              ( pp(aa(set(A),bool,finite_finite2(A),F6))
             => ( ~ pp(aa(set(A),bool,member(A,X),F6))
               => ( pp(aa(set(A),bool,P,F6))
                 => pp(aa(set(A),bool,P,aa(set(A),set(A),insert(A,X),F6))) ) ) )
         => pp(aa(set(A),bool,P,A3)) ) ) ) ).

% infinite_finite_induct
tff(fact_1677_finite__range__imageI,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: fun(B,A),F2: fun(A,C)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(set(B),set(A),image2(B,A,G),top_top(set(B)))))
     => pp(aa(set(C),bool,finite_finite2(C),aa(set(B),set(C),image2(B,C,aa(fun(A,C),fun(B,C),aTP_Lamp_le(fun(B,A),fun(fun(A,C),fun(B,C)),G),F2)),top_top(set(B))))) ) ).

% finite_range_imageI
tff(fact_1678_finite__Collect,axiom,
    ! [A: $tType,B: $tType,S: set(A),F2: fun(B,A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),S))
     => ( inj_on(B,A,F2,top_top(set(B)))
       => pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_lf(set(A),fun(fun(B,A),fun(B,bool)),S),F2)))) ) ) ).

% finite_Collect
tff(fact_1679_finite__inverse__image,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F2: fun(B,A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( inj_on(B,A,F2,top_top(set(B)))
       => pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_lf(set(A),fun(fun(B,A),fun(B,bool)),A3),F2)))) ) ) ).

% finite_inverse_image
tff(fact_1680_Rings_Omono__mult,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => order_mono(A,A,aa(A,fun(A,A),times_times(A),A4)) ) ) ).

% Rings.mono_mult
tff(fact_1681_finite__subset__induct,axiom,
    ! [A: $tType,F: set(A),A3: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),F))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),F),A3))
       => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
         => ( ! [A5: A,F6: set(A)] :
                ( pp(aa(set(A),bool,finite_finite2(A),F6))
               => ( pp(aa(set(A),bool,member(A,A5),A3))
                 => ( ~ pp(aa(set(A),bool,member(A,A5),F6))
                   => ( pp(aa(set(A),bool,P,F6))
                     => pp(aa(set(A),bool,P,aa(set(A),set(A),insert(A,A5),F6))) ) ) ) )
           => pp(aa(set(A),bool,P,F)) ) ) ) ) ).

% finite_subset_induct
tff(fact_1682_finite__subset__induct_H,axiom,
    ! [A: $tType,F: set(A),A3: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),F))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),F),A3))
       => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
         => ( ! [A5: A,F6: set(A)] :
                ( pp(aa(set(A),bool,finite_finite2(A),F6))
               => ( pp(aa(set(A),bool,member(A,A5),A3))
                 => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),F6),A3))
                   => ( ~ pp(aa(set(A),bool,member(A,A5),F6))
                     => ( pp(aa(set(A),bool,P,F6))
                       => pp(aa(set(A),bool,P,aa(set(A),set(A),insert(A,A5),F6))) ) ) ) ) )
           => pp(aa(set(A),bool,P,F)) ) ) ) ) ).

% finite_subset_induct'
tff(fact_1683_finite__Sup__in,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [X: A,Y2: A] :
                  ( pp(aa(set(A),bool,member(A,X),A3))
                 => ( pp(aa(set(A),bool,member(A,Y2),A3))
                   => pp(aa(set(A),bool,member(A,aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y2)),A3)) ) )
             => pp(aa(set(A),bool,member(A,aa(set(A),A,complete_Sup_Sup(A),A3)),A3)) ) ) ) ) ).

% finite_Sup_in
tff(fact_1684_finite__Inf__in,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [X: A,Y2: A] :
                  ( pp(aa(set(A),bool,member(A,X),A3))
                 => ( pp(aa(set(A),bool,member(A,Y2),A3))
                   => pp(aa(set(A),bool,member(A,aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y2)),A3)) ) )
             => pp(aa(set(A),bool,member(A,aa(set(A),A,complete_Inf_Inf(A),A3)),A3)) ) ) ) ) ).

% finite_Inf_in
tff(fact_1685_infinite__remove,axiom,
    ! [A: $tType,S: set(A),A4: A] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),S))
     => ~ pp(aa(set(A),bool,finite_finite2(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))) ) ).

% infinite_remove
tff(fact_1686_infinite__coinduct,axiom,
    ! [A: $tType,X5: fun(set(A),bool),A3: set(A)] :
      ( pp(aa(set(A),bool,X5,A3))
     => ( ! [A11: set(A)] :
            ( pp(aa(set(A),bool,X5,A11))
           => ? [X4: A] :
                ( pp(aa(set(A),bool,member(A,X4),A11))
                & ( pp(aa(set(A),bool,X5,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A11),aa(set(A),set(A),insert(A,X4),bot_bot(set(A))))))
                  | ~ pp(aa(set(A),bool,finite_finite2(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A11),aa(set(A),set(A),insert(A,X4),bot_bot(set(A)))))) ) ) )
       => ~ pp(aa(set(A),bool,finite_finite2(A),A3)) ) ) ).

% infinite_coinduct
tff(fact_1687_finite__empty__induct,axiom,
    ! [A: $tType,A3: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(A),bool,P,A3))
       => ( ! [A5: A,A11: set(A)] :
              ( pp(aa(set(A),bool,finite_finite2(A),A11))
             => ( pp(aa(set(A),bool,member(A,A5),A11))
               => ( pp(aa(set(A),bool,P,A11))
                 => pp(aa(set(A),bool,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A11),aa(set(A),set(A),insert(A,A5),bot_bot(set(A)))))) ) ) )
         => pp(aa(set(A),bool,P,bot_bot(set(A)))) ) ) ) ).

% finite_empty_induct
tff(fact_1688_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F2: fun(A,B),A3: set(A)] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image2(A,B,F2),A3))),aa(A,B,F2,aa(set(A),A,complete_Sup_Sup(A),A3)))) ) ) ).

% mono_Sup
tff(fact_1689_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F2: fun(A,B),A3: fun(C,A),I: set(C)] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_lg(fun(A,B),fun(fun(C,A),fun(C,B)),F2),A3)),I))),aa(A,B,F2,aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,A3),I))))) ) ) ).

% mono_SUP
tff(fact_1690_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F2: fun(A,B),A3: set(A)] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,aa(set(A),A,complete_Inf_Inf(A),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image2(A,B,F2),A3)))) ) ) ).

% mono_Inf
tff(fact_1691_mono__INF,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(A) )
     => ! [F2: fun(A,B),A3: fun(C,A),I: set(C)] :
          ( order_mono(A,B,F2)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,A3),I)))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_lg(fun(A,B),fun(fun(C,A),fun(C,B)),F2),A3)),I)))) ) ) ).

% mono_INF
tff(fact_1692_finite__vimage__IntI,axiom,
    ! [A: $tType,B: $tType,F: set(A),H2: fun(B,A),A3: set(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),F))
     => ( inj_on(B,A,H2,A3)
       => pp(aa(set(B),bool,finite_finite2(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),H2),F)),A3))) ) ) ).

% finite_vimage_IntI
tff(fact_1693_finite__equiv__class,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X5: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))))
       => ( pp(aa(set(set(A)),bool,member(set(A),X5),equiv_quotient(A,A3,R2)))
         => pp(aa(set(A),bool,finite_finite2(A),X5)) ) ) ) ).

% finite_equiv_class
tff(fact_1694_remove__induct,axiom,
    ! [A: $tType,P: fun(set(A),bool),B2: set(A)] :
      ( pp(aa(set(A),bool,P,bot_bot(set(A))))
     => ( ( ~ pp(aa(set(A),bool,finite_finite2(A),B2))
         => pp(aa(set(A),bool,P,B2)) )
       => ( ! [A11: set(A)] :
              ( pp(aa(set(A),bool,finite_finite2(A),A11))
             => ( ( A11 != bot_bot(set(A)) )
               => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A11),B2))
                 => ( ! [X4: A] :
                        ( pp(aa(set(A),bool,member(A,X4),A11))
                       => pp(aa(set(A),bool,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A11),aa(set(A),set(A),insert(A,X4),bot_bot(set(A)))))) )
                   => pp(aa(set(A),bool,P,A11)) ) ) ) )
         => pp(aa(set(A),bool,P,B2)) ) ) ) ).

% remove_induct
tff(fact_1695_finite__remove__induct,axiom,
    ! [A: $tType,B2: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),B2))
     => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
       => ( ! [A11: set(A)] :
              ( pp(aa(set(A),bool,finite_finite2(A),A11))
             => ( ( A11 != bot_bot(set(A)) )
               => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A11),B2))
                 => ( ! [X4: A] :
                        ( pp(aa(set(A),bool,member(A,X4),A11))
                       => pp(aa(set(A),bool,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A11),aa(set(A),set(A),insert(A,X4),bot_bot(set(A)))))) )
                   => pp(aa(set(A),bool,P,A11)) ) ) ) )
         => pp(aa(set(A),bool,P,B2)) ) ) ) ).

% finite_remove_induct
tff(fact_1696_inf__img__fin__domE,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),A3: set(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(set(B),set(A),image2(B,A,F2),A3)))
     => ( ~ pp(aa(set(B),bool,finite_finite2(B),A3))
       => ~ ! [Y2: A] :
              ( pp(aa(set(A),bool,member(A,Y2),aa(set(B),set(A),image2(B,A,F2),A3)))
             => pp(aa(set(B),bool,finite_finite2(B),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F2),aa(set(A),set(A),insert(A,Y2),bot_bot(set(A)))))) ) ) ) ).

% inf_img_fin_domE
tff(fact_1697_inf__img__fin__dom,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),A3: set(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(set(B),set(A),image2(B,A,F2),A3)))
     => ( ~ pp(aa(set(B),bool,finite_finite2(B),A3))
       => ? [X: A] :
            ( pp(aa(set(A),bool,member(A,X),aa(set(B),set(A),image2(B,A,F2),A3)))
            & ~ pp(aa(set(B),bool,finite_finite2(B),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F2),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ).

% inf_img_fin_dom
tff(fact_1698_infinite__imp__bij__betw2,axiom,
    ! [A: $tType,A3: set(A),A4: A] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => ? [H4: fun(A,A)] : bij_betw(A,A,H4,A3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))) ) ).

% infinite_imp_bij_betw2
tff(fact_1699_infinite__imp__bij__betw,axiom,
    ! [A: $tType,A3: set(A),A4: A] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => ? [H4: fun(A,A)] : bij_betw(A,A,H4,A3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))) ) ).

% infinite_imp_bij_betw
tff(fact_1700_finite__finite__vimage__IntI,axiom,
    ! [A: $tType,B: $tType,F: set(A),H2: fun(B,A),A3: set(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),F))
     => ( ! [Y2: A] :
            ( pp(aa(set(A),bool,member(A,Y2),F))
           => pp(aa(set(B),bool,finite_finite2(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),H2),aa(set(A),set(A),insert(A,Y2),bot_bot(set(A))))),A3))) )
       => pp(aa(set(B),bool,finite_finite2(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),H2),F)),A3))) ) ) ).

% finite_finite_vimage_IntI
tff(fact_1701_finite_Omono,axiom,
    ! [A: $tType] : order_mono(fun(set(A),bool),fun(set(A),bool),aTP_Lamp_lh(fun(set(A),bool),fun(set(A),bool))) ).

% finite.mono
tff(fact_1702_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [S: set(B),P: fun(set(B),bool),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( pp(aa(set(B),bool,P,bot_bot(set(B))))
           => ( ! [X: B,S6: set(B)] :
                  ( pp(aa(set(B),bool,finite_finite2(B),S6))
                 => ( ! [Y5: B] :
                        ( pp(aa(set(B),bool,member(B,Y5),S6))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,Y5)),aa(B,A,F2,X))) )
                   => ( pp(aa(set(B),bool,P,S6))
                     => pp(aa(set(B),bool,P,aa(set(B),set(B),insert(B,X),S6))) ) ) )
             => pp(aa(set(B),bool,P,S)) ) ) ) ) ).

% finite_ranking_induct
tff(fact_1703_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I: set(B),X2: fun(B,A),Y: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_li(set(B),fun(fun(B,A),fun(B,bool)),I),X2))))
         => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_li(set(B),fun(fun(B,A),fun(B,bool)),I),Y))))
           => pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aTP_Lamp_lj(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),I),X2),Y)))) ) ) ) ).

% prod.finite_Collect_op
tff(fact_1704_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [I: set(B),X2: fun(B,A),Y: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_lk(set(B),fun(fun(B,A),fun(B,bool)),I),X2))))
         => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_lk(set(B),fun(fun(B,A),fun(B,bool)),I),Y))))
           => pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aTP_Lamp_ll(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),I),X2),Y)))) ) ) ) ).

% sum.finite_Collect_op
tff(fact_1705_Pow__fold,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pow(A,A3) = finite_fold(A,set(set(A)),aTP_Lamp_ko(A,fun(set(set(A)),set(set(A)))),aa(set(set(A)),set(set(A)),insert(set(A),bot_bot(set(A))),bot_bot(set(set(A)))),A3) ) ) ).

% Pow_fold
tff(fact_1706_infinite__cartesian__product,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ~ pp(aa(set(B),bool,finite_finite2(B),B2))
       => ~ pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)))) ) ) ).

% infinite_cartesian_product
tff(fact_1707_fold__union__pair,axiom,
    ! [B: $tType,A: $tType,B2: set(A),X2: B,A3: set(product_prod(B,A))] :
      ( pp(aa(set(A),bool,finite_finite2(A),B2))
     => ( aa(set(product_prod(B,A)),set(product_prod(B,A)),aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),set(product_prod(B,A))),sup_sup(set(product_prod(B,A))),aa(set(set(product_prod(B,A))),set(product_prod(B,A)),complete_Sup_Sup(set(product_prod(B,A))),aa(set(A),set(set(product_prod(B,A))),image2(A,set(product_prod(B,A)),aTP_Lamp_lm(B,fun(A,set(product_prod(B,A))),X2)),B2))),A3) = finite_fold(A,set(product_prod(B,A)),aTP_Lamp_ln(B,fun(A,fun(set(product_prod(B,A)),set(product_prod(B,A)))),X2),A3,B2) ) ) ).

% fold_union_pair
tff(fact_1708_Fpow__Pow__finite,axiom,
    ! [A: $tType,A3: set(A)] : ( finite_Fpow(A,A3) = aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),pow(A,A3)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),finite_finite2(A))) ) ).

% Fpow_Pow_finite
tff(fact_1709_finite__transitivity__chain,axiom,
    ! [A: $tType,A3: set(A),R: fun(A,fun(A,bool))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ! [X: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),R,X),X))
       => ( ! [X: A,Y2: A,Z3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),R,X),Y2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),R,Y2),Z3))
               => pp(aa(A,bool,aa(A,fun(A,bool),R,X),Z3)) ) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),A3))
               => ? [Y5: A] :
                    ( pp(aa(set(A),bool,member(A,Y5),A3))
                    & pp(aa(A,bool,aa(A,fun(A,bool),R,X),Y5)) ) )
           => ( A3 = bot_bot(set(A)) ) ) ) ) ) ).

% finite_transitivity_chain
tff(fact_1710_fold__empty,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,fun(A,A)),Z2: A] : ( finite_fold(B,A,F2,Z2,bot_bot(set(B))) = Z2 ) ).

% fold_empty
tff(fact_1711_mono__compose,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [Q: fun(A,fun(B,C)),F2: fun(D,B)] :
          ( order_mono(A,fun(B,C),Q)
         => order_mono(A,fun(D,C),aa(fun(D,B),fun(A,fun(D,C)),aTP_Lamp_lo(fun(A,fun(B,C)),fun(fun(D,B),fun(A,fun(D,C))),Q),F2)) ) ) ).

% mono_compose
tff(fact_1712_Inf__filter__not__bot,axiom,
    ! [A: $tType,B2: set(filter(A))] :
      ( ! [X6: set(filter(A))] :
          ( pp(aa(set(filter(A)),bool,aa(set(filter(A)),fun(set(filter(A)),bool),ord_less_eq(set(filter(A))),X6),B2))
         => ( pp(aa(set(filter(A)),bool,finite_finite2(filter(A)),X6))
           => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),X6) != bot_bot(filter(A)) ) ) )
     => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),B2) != bot_bot(filter(A)) ) ) ).

% Inf_filter_not_bot
tff(fact_1713_INF__filter__bot__base,axiom,
    ! [A: $tType,B: $tType,I: set(A),F: fun(A,filter(B))] :
      ( ! [I3: A] :
          ( pp(aa(set(A),bool,member(A,I3),I))
         => ! [J4: A] :
              ( pp(aa(set(A),bool,member(A,J4),I))
             => ? [X4: A] :
                  ( pp(aa(set(A),bool,member(A,X4),I))
                  & pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),aa(A,filter(B),F,X4)),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),aa(A,filter(B),F,I3)),aa(A,filter(B),F,J4)))) ) ) )
     => ( ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),F),I)) = bot_bot(filter(B)) )
      <=> ? [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),I))
            & ( aa(A,filter(B),F,X3) = bot_bot(filter(B)) ) ) ) ) ).

% INF_filter_bot_base
tff(fact_1714_comp__fun__commute__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),S))
     => finite6289374366891150609ommute(product_prod(C,A),set(product_prod(C,B)),aa(fun(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(C,A),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(C,A,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_lq(set(product_prod(A,B)),fun(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B))))),S))) ) ).

% comp_fun_commute_relcomp_fold
tff(fact_1715_comp__fun__commute__product__fold,axiom,
    ! [B: $tType,A: $tType,B2: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),B2))
     => finite6289374366891150609ommute(B,set(product_prod(B,A)),aTP_Lamp_lr(set(A),fun(B,fun(set(product_prod(B,A)),set(product_prod(B,A)))),B2)) ) ).

% comp_fun_commute_product_fold
tff(fact_1716_comp__fun__commute__Image__fold,axiom,
    ! [B: $tType,A: $tType,S: set(A)] : finite6289374366891150609ommute(product_prod(A,B),set(B),aa(fun(A,fun(B,fun(set(B),set(B)))),fun(product_prod(A,B),fun(set(B),set(B))),product_case_prod(A,B,fun(set(B),set(B))),aTP_Lamp_ls(set(A),fun(A,fun(B,fun(set(B),set(B)))),S))) ).

% comp_fun_commute_Image_fold
tff(fact_1717_empty__in__Fpow,axiom,
    ! [A: $tType,A3: set(A)] : pp(aa(set(set(A)),bool,member(set(A),bot_bot(set(A))),finite_Fpow(A,A3))) ).

% empty_in_Fpow
tff(fact_1718_Fpow__not__empty,axiom,
    ! [A: $tType,A3: set(A)] : ( finite_Fpow(A,A3) != bot_bot(set(set(A))) ) ).

% Fpow_not_empty
tff(fact_1719_inf__Inf__fold__inf,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),B2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),A3)),B2) = finite_fold(A,A,inf_inf(A),B2,A3) ) ) ) ).

% inf_Inf_fold_inf
tff(fact_1720_Sup__fold__sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( aa(set(A),A,complete_Sup_Sup(A),A3) = finite_fold(A,A,sup_sup(A),bot_bot(A),A3) ) ) ) ).

% Sup_fold_sup
tff(fact_1721_Inf__fold__inf,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( aa(set(A),A,complete_Inf_Inf(A),A3) = finite_fold(A,A,inf_inf(A),top_top(A),A3) ) ) ) ).

% Inf_fold_inf
tff(fact_1722_image__fold__insert,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( aa(set(A),set(B),image2(A,B,F2),A3) = finite_fold(A,set(B),aTP_Lamp_lt(fun(A,B),fun(A,fun(set(B),set(B))),F2),bot_bot(set(B)),A3) ) ) ).

% image_fold_insert
tff(fact_1723_Fpow__def,axiom,
    ! [A: $tType,A3: set(A)] : ( finite_Fpow(A,A3) = aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_lu(set(A),fun(set(A),bool),A3)) ) ).

% Fpow_def
tff(fact_1724_inf__INF__fold__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),B2: A,F2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,inf_inf(A)),F2),B2,A3) ) ) ) ).

% inf_INF_fold_inf
tff(fact_1725_product__fold,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: set(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(B),bool,finite_finite2(B),B2))
       => ( product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)) = finite_fold(A,set(product_prod(A,B)),aTP_Lamp_lw(set(B),fun(A,fun(set(product_prod(A,B)),set(product_prod(A,B)))),B2),bot_bot(set(product_prod(A,B))),A3) ) ) ) ).

% product_fold
tff(fact_1726_Id__on__fold,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( id_on(A,A3) = finite_fold(A,set(product_prod(A,A)),aTP_Lamp_lx(A,fun(set(product_prod(A,A)),set(product_prod(A,A)))),bot_bot(set(product_prod(A,A))),A3) ) ) ).

% Id_on_fold
tff(fact_1727_SUP__fold__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3)) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,sup_sup(A)),F2),bot_bot(A),A3) ) ) ) ).

% SUP_fold_sup
tff(fact_1728_INF__fold__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3)) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,inf_inf(A)),F2),top_top(A),A3) ) ) ) ).

% INF_fold_inf
tff(fact_1729_coinduct3__mono__lemma,axiom,
    ! [A: $tType,B: $tType] :
      ( order(A)
     => ! [F2: fun(A,set(B)),X5: set(B),B2: set(B)] :
          ( order_mono(A,set(B),F2)
         => order_mono(A,set(B),aa(set(B),fun(A,set(B)),aa(set(B),fun(set(B),fun(A,set(B))),aTP_Lamp_ly(fun(A,set(B)),fun(set(B),fun(set(B),fun(A,set(B)))),F2),X5),B2)) ) ) ).

% coinduct3_mono_lemma
tff(fact_1730_Set__filter__fold,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( filter3(A,P,A3) = finite_fold(A,set(A),aTP_Lamp_ld(fun(A,bool),fun(A,fun(set(A),set(A))),P),bot_bot(set(A)),A3) ) ) ).

% Set_filter_fold
tff(fact_1731_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [F: set(A),I: set(A),F2: fun(A,B),I2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),F))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(fun(A,bool),set(A),collect(A),aa(fun(A,B),fun(A,bool),aTP_Lamp_lz(set(A),fun(fun(A,B),fun(A,bool)),I),F2))),F))
           => ( ( pp(aa(set(A),bool,member(A,I2),I))
               => ( groups1027152243600224163dd_sum(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I),aa(set(A),set(A),insert(A,I2),bot_bot(set(A))))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F2,I)),aa(A,B,F2,I2)) ) )
              & ( ~ pp(aa(set(A),bool,member(A,I2),I))
               => ( groups1027152243600224163dd_sum(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I),aa(set(A),set(A),insert(A,I2),bot_bot(set(A))))) = groups1027152243600224163dd_sum(A,B,F2,I) ) ) ) ) ) ) ).

% sum_diff1'_aux
tff(fact_1732_insert__relcomp__union__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S: set(product_prod(A,B)),X2: product_prod(C,A),X5: set(product_prod(C,B))] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),S))
     => ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),set(product_prod(C,B))),sup_sup(set(product_prod(C,B))),relcomp(C,A,B,aa(set(product_prod(C,A)),set(product_prod(C,A)),insert(product_prod(C,A),X2),bot_bot(set(product_prod(C,A)))),S)),X5) = finite_fold(product_prod(A,B),set(product_prod(C,B)),aa(fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(A,B),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(A,B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_ma(product_prod(C,A),fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),X2)),X5,S) ) ) ).

% insert_relcomp_union_fold
tff(fact_1733_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [I: set(A),F2: fun(A,B),I2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(fun(A,B),fun(A,bool),aTP_Lamp_lz(set(A),fun(fun(A,B),fun(A,bool)),I),F2))))
         => ( ( pp(aa(set(A),bool,member(A,I2),I))
             => ( groups1027152243600224163dd_sum(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I),aa(set(A),set(A),insert(A,I2),bot_bot(set(A))))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F2,I)),aa(A,B,F2,I2)) ) )
            & ( ~ pp(aa(set(A),bool,member(A,I2),I))
             => ( groups1027152243600224163dd_sum(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I),aa(set(A),set(A),insert(A,I2),bot_bot(set(A))))) = groups1027152243600224163dd_sum(A,B,F2,I) ) ) ) ) ) ).

% sum_diff1'
tff(fact_1734_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S: set(A),F2: fun(A,fun(B,B)),A3: set(A),B2: set(A),Z2: B] :
      ( finite4664212375090638736ute_on(A,B,S,F2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),S))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),S))
         => ( pp(aa(set(A),bool,finite_finite2(A),A3))
           => ( pp(aa(set(A),bool,finite_finite2(A),B2))
             => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) )
               => ( finite_fold(A,B,F2,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = finite_fold(A,B,F2,finite_fold(A,B,F2,Z2,A3),B2) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
tff(fact_1735_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S: set(A),F2: fun(A,fun(B,B)),X2: A,A3: set(A),Z2: B] :
      ( finite4664212375090638736ute_on(A,B,S,F2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,X2),A3)),S))
       => ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( finite_fold(A,B,F2,Z2,aa(set(A),set(A),insert(A,X2),A3)) = aa(B,B,aa(A,fun(B,B),F2,X2),finite_fold(A,B,F2,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
tff(fact_1736_relcomp__empty2,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set(product_prod(A,C))] : ( relcomp(A,C,B,R,bot_bot(set(product_prod(C,B)))) = bot_bot(set(product_prod(A,B))) ) ).

% relcomp_empty2
tff(fact_1737_relcomp__empty1,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set(product_prod(C,B))] : ( relcomp(A,C,B,bot_bot(set(product_prod(A,C))),R) = bot_bot(set(product_prod(A,B))) ) ).

% relcomp_empty1
tff(fact_1738_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [P5: fun(B,A)] : ( groups1027152243600224163dd_sum(B,A,P5,bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty'
tff(fact_1739_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [I: set(B),P5: fun(B,A),I2: B] :
          ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_lk(set(B),fun(fun(B,A),fun(B,bool)),I),P5))))
         => ( ( pp(aa(set(B),bool,member(B,I2),I))
             => ( groups1027152243600224163dd_sum(B,A,P5,aa(set(B),set(B),insert(B,I2),I)) = groups1027152243600224163dd_sum(B,A,P5,I) ) )
            & ( ~ pp(aa(set(B),bool,member(B,I2),I))
             => ( groups1027152243600224163dd_sum(B,A,P5,aa(set(B),set(B),insert(B,I2),I)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,P5,I2)),groups1027152243600224163dd_sum(B,A,P5,I)) ) ) ) ) ) ).

% sum.insert'
tff(fact_1740_Set_Ofilter__def,axiom,
    ! [A: $tType,P: fun(A,bool),A3: set(A)] : ( filter3(A,P,A3) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_mb(fun(A,bool),fun(set(A),fun(A,bool)),P),A3)) ) ).

% Set.filter_def
tff(fact_1741_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),I: set(B)] : ( groups1027152243600224163dd_sum(B,A,G,aa(fun(B,bool),set(B),collect(B),aa(set(B),fun(B,bool),aTP_Lamp_mc(fun(B,A),fun(set(B),fun(B,bool)),G),I))) = groups1027152243600224163dd_sum(B,A,G,I) ) ) ).

% sum.non_neutral'
tff(fact_1742_wf__no__loop,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ( relcomp(B,B,B,R,R) = bot_bot(set(product_prod(B,B))) )
     => wf(B,R) ) ).

% wf_no_loop
tff(fact_1743_union__comp__emptyL,axiom,
    ! [A: $tType,A3: set(product_prod(A,A)),C3: set(product_prod(A,A)),B2: set(product_prod(A,A))] :
      ( ( relcomp(A,A,A,A3,C3) = bot_bot(set(product_prod(A,A))) )
     => ( ( relcomp(A,A,A,B2,C3) = bot_bot(set(product_prod(A,A))) )
       => ( relcomp(A,A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),A3),B2),C3) = bot_bot(set(product_prod(A,A))) ) ) ) ).

% union_comp_emptyL
tff(fact_1744_union__comp__emptyR,axiom,
    ! [A: $tType,A3: set(product_prod(A,A)),B2: set(product_prod(A,A)),C3: set(product_prod(A,A))] :
      ( ( relcomp(A,A,A,A3,B2) = bot_bot(set(product_prod(A,A))) )
     => ( ( relcomp(A,A,A,A3,C3) = bot_bot(set(product_prod(A,A))) )
       => ( relcomp(A,A,A,A3,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),B2),C3)) = bot_bot(set(product_prod(A,A))) ) ) ) ).

% union_comp_emptyR
tff(fact_1745_relcomp__subset__Sigma,axiom,
    ! [B: $tType,A: $tType,C: $tType,R2: set(product_prod(A,B)),A3: set(A),B2: set(B),S2: set(product_prod(B,C)),C3: set(C)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),R2),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))
     => ( pp(aa(set(product_prod(B,C)),bool,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),bool),ord_less_eq(set(product_prod(B,C))),S2),product_Sigma(B,C,B2,aTP_Lamp_eq(set(C),fun(B,set(C)),C3))))
       => pp(aa(set(product_prod(A,C)),bool,aa(set(product_prod(A,C)),fun(set(product_prod(A,C)),bool),ord_less_eq(set(product_prod(A,C))),relcomp(A,B,C,R2,S2)),product_Sigma(A,C,A3,aTP_Lamp_md(set(C),fun(A,set(C)),C3)))) ) ) ).

% relcomp_subset_Sigma
tff(fact_1746_relcomp__UNION__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,S2: set(product_prod(A,C)),R2: fun(D,set(product_prod(C,B))),I: set(D)] : ( relcomp(A,C,B,S2,aa(set(set(product_prod(C,B))),set(product_prod(C,B)),complete_Sup_Sup(set(product_prod(C,B))),aa(set(D),set(set(product_prod(C,B))),image2(D,set(product_prod(C,B)),R2),I))) = aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(D),set(set(product_prod(A,B))),image2(D,set(product_prod(A,B)),aa(fun(D,set(product_prod(C,B))),fun(D,set(product_prod(A,B))),aTP_Lamp_me(set(product_prod(A,C)),fun(fun(D,set(product_prod(C,B))),fun(D,set(product_prod(A,B)))),S2),R2)),I)) ) ).

% relcomp_UNION_distrib
tff(fact_1747_relcomp__UNION__distrib2,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,R2: fun(D,set(product_prod(A,C))),I: set(D),S2: set(product_prod(C,B))] : ( relcomp(A,C,B,aa(set(set(product_prod(A,C))),set(product_prod(A,C)),complete_Sup_Sup(set(product_prod(A,C))),aa(set(D),set(set(product_prod(A,C))),image2(D,set(product_prod(A,C)),R2),I)),S2) = aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(D),set(set(product_prod(A,B))),image2(D,set(product_prod(A,B)),aa(set(product_prod(C,B)),fun(D,set(product_prod(A,B))),aTP_Lamp_mf(fun(D,set(product_prod(A,C))),fun(set(product_prod(C,B)),fun(D,set(product_prod(A,B)))),R2),S2)),I)) ) ).

% relcomp_UNION_distrib2
tff(fact_1748_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [I: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),I))
         => ( groups1027152243600224163dd_sum(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_mg(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2),I) = aa(A,A,aa(A,fun(A,A),plus_plus(A),groups1027152243600224163dd_sum(B,A,G,I)),groups1027152243600224163dd_sum(B,A,H2,I)) ) ) ) ).

% sum.distrib_triv'
tff(fact_1749_trancl__Int__subset,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),S2))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),transitive_trancl(A,R2)),S2),R2)),S2))
       => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),transitive_trancl(A,R2)),S2)) ) ) ).

% trancl_Int_subset
tff(fact_1750_relcomp__unfold,axiom,
    ! [A: $tType,B: $tType,C: $tType,R2: set(product_prod(A,C)),S2: set(product_prod(C,B))] : ( relcomp(A,C,B,R2,S2) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(set(product_prod(C,B)),fun(A,fun(B,bool)),aTP_Lamp_mh(set(product_prod(A,C)),fun(set(product_prod(C,B)),fun(A,fun(B,bool))),R2),S2))) ) ).

% relcomp_unfold
tff(fact_1751_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [I: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_lk(set(B),fun(fun(B,A),fun(B,bool)),I),G))))
         => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_lk(set(B),fun(fun(B,A),fun(B,bool)),I),H2))))
           => ( groups1027152243600224163dd_sum(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_mg(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2),I) = aa(A,A,aa(A,fun(A,A),plus_plus(A),groups1027152243600224163dd_sum(B,A,G,I)),groups1027152243600224163dd_sum(B,A,H2,I)) ) ) ) ) ).

% sum.distrib'
tff(fact_1752_rtrancl__Int__subset,axiom,
    ! [A: $tType,S2: set(product_prod(A,A)),R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),id2(A)),S2))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),transitive_rtrancl(A,R2)),S2),R2)),S2))
       => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),transitive_rtrancl(A,R2)),S2)) ) ) ).

% rtrancl_Int_subset
tff(fact_1753_relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set(product_prod(A,B)),S: set(product_prod(B,C))] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),R))
     => ( pp(aa(set(product_prod(B,C)),bool,finite_finite2(product_prod(B,C)),S))
       => ( relcomp(A,B,C,R,S) = finite_fold(product_prod(A,B),set(product_prod(A,C)),aa(fun(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C))))),fun(product_prod(A,B),fun(set(product_prod(A,C)),set(product_prod(A,C)))),product_case_prod(A,B,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aTP_Lamp_mj(set(product_prod(B,C)),fun(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C))))),S)),bot_bot(set(product_prod(A,C))),R) ) ) ) ).

% relcomp_fold
tff(fact_1754_Image__fold,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S: set(A)] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),R))
     => ( aa(set(A),set(B),image(A,B,R),S) = finite_fold(product_prod(A,B),set(B),aa(fun(A,fun(B,fun(set(B),set(B)))),fun(product_prod(A,B),fun(set(B),set(B))),product_case_prod(A,B,fun(set(B),set(B))),aTP_Lamp_ls(set(A),fun(A,fun(B,fun(set(B),set(B)))),S)),bot_bot(set(B)),R) ) ) ).

% Image_fold
tff(fact_1755_inter__Set__filter,axiom,
    ! [A: $tType,B2: set(A),A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),B2))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = filter3(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3),B2) ) ) ).

% inter_Set_filter
tff(fact_1756_insert__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S: set(product_prod(A,B)),X2: product_prod(C,A),R: set(product_prod(C,A))] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite2(product_prod(A,B)),S))
     => ( relcomp(C,A,B,aa(set(product_prod(C,A)),set(product_prod(C,A)),insert(product_prod(C,A),X2),R),S) = finite_fold(product_prod(A,B),set(product_prod(C,B)),aa(fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(A,B),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(A,B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_ma(product_prod(C,A),fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),X2)),relcomp(C,A,B,R,S),S) ) ) ).

% insert_relcomp_fold
tff(fact_1757_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S: set(A),F2: fun(A,fun(B,B)),A3: set(A),X2: A,Z2: B] :
      ( finite4664212375090638736ute_on(A,B,S,F2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),S))
       => ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( pp(aa(set(A),bool,member(A,X2),A3))
           => ( finite_fold(A,B,F2,Z2,A3) = aa(B,B,aa(A,fun(B,B),F2,X2),finite_fold(A,B,F2,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
tff(fact_1758_min__ext__compat,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,R,S)),R))
     => pp(aa(set(product_prod(set(A),set(A))),bool,aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),bool),ord_less_eq(set(product_prod(set(A),set(A)))),relcomp(set(A),set(A),set(A),min_ext(A,R),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),sup_sup(set(product_prod(set(A),set(A)))),min_ext(A,S)),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),insert(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),bot_bot(set(A))),bot_bot(set(A)))),bot_bot(set(product_prod(set(A),set(A)))))))),min_ext(A,R))) ) ).

% min_ext_compat
tff(fact_1759_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [S: set(A),Y: A,F2: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( ( S != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,member(A,Y),S))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,lattic7623131987881927897min_on(A,B,F2,S))),aa(A,B,F2,Y))) ) ) ) ) ).

% arg_min_least
tff(fact_1760_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I: set(B),P5: fun(B,A),I2: B] :
          ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_li(set(B),fun(fun(B,A),fun(B,bool)),I),P5))))
         => ( ( pp(aa(set(B),bool,member(B,I2),I))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P5),aa(set(B),set(B),insert(B,I2),I)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P5),I) ) )
            & ( ~ pp(aa(set(B),bool,member(B,I2),I))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P5),aa(set(B),set(B),insert(B,I2),I)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,P5,I2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P5),I)) ) ) ) ) ) ).

% prod.insert'
tff(fact_1761_finite__def,axiom,
    ! [A: $tType] : ( finite_finite2(A) = complete_lattice_lfp(fun(set(A),bool),aTP_Lamp_lh(fun(set(A),bool),fun(set(A),bool))) ) ).

% finite_def
tff(fact_1762_INF__principal__finite,axiom,
    ! [B: $tType,A: $tType,X5: set(A),F2: fun(A,set(B))] :
      ( pp(aa(set(A),bool,finite_finite2(A),X5))
     => ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),aTP_Lamp_mk(fun(A,set(B)),fun(A,filter(B)),F2)),X5)) = principal(B,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),F2),X5))) ) ) ).

% INF_principal_finite
tff(fact_1763_comp__fun__commute__on_Ofold__graph__insertE__aux,axiom,
    ! [A: $tType,B: $tType,S: set(A),F2: fun(A,fun(B,B)),A3: set(A),Z2: B,Y: B,A4: A] :
      ( finite4664212375090638736ute_on(A,B,S,F2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),S))
       => ( pp(aa(B,bool,finite_fold_graph(A,B,F2,Z2,A3),Y))
         => ( pp(aa(set(A),bool,member(A,A4),A3))
           => ? [Y6: B] :
                ( ( Y = aa(B,B,aa(A,fun(B,B),F2,A4),Y6) )
                & pp(aa(B,bool,finite_fold_graph(A,B,F2,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))),Y6)) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE_aux
tff(fact_1764_relImage__Gr,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,A)),A3: set(A),F2: fun(A,B)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))))
     => ( bNF_Gr4221423524335903396lImage(A,B,R,F2) = relcomp(B,A,B,converse(A,B,bNF_Gr(A,B,A3,F2)),relcomp(A,A,B,R,bNF_Gr(A,B,A3,F2))) ) ) ).

% relImage_Gr
tff(fact_1765_converse__empty,axiom,
    ! [B: $tType,A: $tType] : ( converse(B,A,bot_bot(set(product_prod(B,A)))) = bot_bot(set(product_prod(A,B))) ) ).

% converse_empty
tff(fact_1766_pair__set__inverse,axiom,
    ! [A: $tType,B: $tType,P: fun(B,fun(A,bool))] : ( converse(B,A,aa(fun(product_prod(B,A),bool),set(product_prod(B,A)),collect(product_prod(B,A)),aa(fun(B,fun(A,bool)),fun(product_prod(B,A),bool),product_case_prod(B,A,bool),P))) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_kr(fun(B,fun(A,bool)),fun(A,fun(B,bool)),P))) ) ).

% pair_set_inverse
tff(fact_1767_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P5: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P5),bot_bot(set(B))) = one_one(A) ) ) ).

% prod.empty'
tff(fact_1768_inf__principal,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),principal(A,A3)),principal(A,B2)) = principal(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) ) ).

% inf_principal
tff(fact_1769_SUP__principal,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),I: set(B)] : ( aa(set(filter(A)),filter(A),complete_Sup_Sup(filter(A)),aa(set(B),set(filter(A)),image2(B,filter(A),aTP_Lamp_ml(fun(B,set(A)),fun(B,filter(A)),A3)),I)) = principal(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))) ) ).

% SUP_principal
tff(fact_1770_lfp__const,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [T3: A] : ( complete_lattice_lfp(A,aTP_Lamp_mm(A,fun(A,A),T3)) = T3 ) ) ).

% lfp_const
tff(fact_1771_converse__Int,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(B,A)),S2: set(product_prod(B,A))] : ( converse(B,A,aa(set(product_prod(B,A)),set(product_prod(B,A)),aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),set(product_prod(B,A))),inf_inf(set(product_prod(B,A))),R2),S2)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),converse(B,A,R2)),converse(B,A,S2)) ) ).

% converse_Int
tff(fact_1772_fold__graph_OemptyI,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(B,B)),Z2: B] : pp(aa(B,bool,finite_fold_graph(A,B,F2,Z2,bot_bot(set(A))),Z2)) ).

% fold_graph.emptyI
tff(fact_1773_empty__fold__graphE,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(B,B)),Z2: B,X2: B] :
      ( pp(aa(B,bool,finite_fold_graph(A,B,F2,Z2,bot_bot(set(A))),X2))
     => ( X2 = Z2 ) ) ).

% empty_fold_graphE
tff(fact_1774_converse__Times,axiom,
    ! [A: $tType,B: $tType,A3: set(B),B2: set(A)] : ( converse(B,A,product_Sigma(B,A,A3,aTP_Lamp_bv(set(A),fun(B,set(A)),B2))) = product_Sigma(A,B,B2,aTP_Lamp_bq(set(B),fun(A,set(B)),A3)) ) ).

% converse_Times
tff(fact_1775_lfp__lfp,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,fun(A,A))] :
          ( ! [X: A,Y2: A,W: A,Z3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),W),Z3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F2,X),W)),aa(A,A,aa(A,fun(A,A),F2,Y2),Z3))) ) )
         => ( complete_lattice_lfp(A,aTP_Lamp_mn(fun(A,fun(A,A)),fun(A,A),F2)) = complete_lattice_lfp(A,aTP_Lamp_mo(fun(A,fun(A,A)),fun(A,A),F2)) ) ) ) ).

% lfp_lfp
tff(fact_1776_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),I: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),aa(fun(B,bool),set(B),collect(B),aa(set(B),fun(B,bool),aTP_Lamp_mp(fun(B,A),fun(set(B),fun(B,bool)),G),I))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),I) ) ) ).

% prod.non_neutral'
tff(fact_1777_lfp__rolling,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(A) )
     => ! [G: fun(A,B),F2: fun(B,A)] :
          ( order_mono(A,B,G)
         => ( order_mono(B,A,F2)
           => ( aa(A,B,G,complete_lattice_lfp(A,aa(fun(B,A),fun(A,A),aTP_Lamp_mq(fun(A,B),fun(fun(B,A),fun(A,A)),G),F2))) = complete_lattice_lfp(B,aa(fun(B,A),fun(B,B),aTP_Lamp_mr(fun(A,B),fun(fun(B,A),fun(B,B)),G),F2)) ) ) ) ) ).

% lfp_rolling
tff(fact_1778_converse__unfold,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(B,A))] : ( converse(B,A,R2) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_ms(set(product_prod(B,A)),fun(A,fun(B,bool)),R2))) ) ).

% converse_unfold
tff(fact_1779_fold__graph_Osimps,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(B,B)),Z2: B,A13: set(A),A23: B] :
      ( pp(aa(B,bool,finite_fold_graph(A,B,F2,Z2,A13),A23))
    <=> ( ( ( A13 = bot_bot(set(A)) )
          & ( A23 = Z2 ) )
        | ? [X3: A,A12: set(A),Y4: B] :
            ( ( A13 = aa(set(A),set(A),insert(A,X3),A12) )
            & ( A23 = aa(B,B,aa(A,fun(B,B),F2,X3),Y4) )
            & ~ pp(aa(set(A),bool,member(A,X3),A12))
            & pp(aa(B,bool,finite_fold_graph(A,B,F2,Z2,A12),Y4)) ) ) ) ).

% fold_graph.simps
tff(fact_1780_fold__graph_Ocases,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(B,B)),Z2: B,A13: set(A),A23: B] :
      ( pp(aa(B,bool,finite_fold_graph(A,B,F2,Z2,A13),A23))
     => ( ( ( A13 = bot_bot(set(A)) )
         => ( A23 != Z2 ) )
       => ~ ! [X: A,A11: set(A)] :
              ( ( A13 = aa(set(A),set(A),insert(A,X),A11) )
             => ! [Y2: B] :
                  ( ( A23 = aa(B,B,aa(A,fun(B,B),F2,X),Y2) )
                 => ( ~ pp(aa(set(A),bool,member(A,X),A11))
                   => ~ pp(aa(B,bool,finite_fold_graph(A,B,F2,Z2,A11),Y2)) ) ) ) ) ) ).

% fold_graph.cases
tff(fact_1781_principal__eq__bot__iff,axiom,
    ! [A: $tType,X5: set(A)] :
      ( ( principal(A,X5) = bot_bot(filter(A)) )
    <=> ( X5 = bot_bot(set(A)) ) ) ).

% principal_eq_bot_iff
tff(fact_1782_bot__eq__principal__empty,axiom,
    ! [A: $tType] : ( bot_bot(filter(A)) = principal(A,bot_bot(set(A))) ) ).

% bot_eq_principal_empty
tff(fact_1783_converse__UNION,axiom,
    ! [B: $tType,A: $tType,C: $tType,R2: fun(C,set(product_prod(B,A))),S: set(C)] : ( converse(B,A,aa(set(set(product_prod(B,A))),set(product_prod(B,A)),complete_Sup_Sup(set(product_prod(B,A))),aa(set(C),set(set(product_prod(B,A))),image2(C,set(product_prod(B,A)),R2),S))) = aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(C),set(set(product_prod(A,B))),image2(C,set(product_prod(A,B)),aTP_Lamp_mt(fun(C,set(product_prod(B,A))),fun(C,set(product_prod(A,B))),R2)),S)) ) ).

% converse_UNION
tff(fact_1784_converse__INTER,axiom,
    ! [B: $tType,A: $tType,C: $tType,R2: fun(C,set(product_prod(B,A))),S: set(C)] : ( converse(B,A,aa(set(set(product_prod(B,A))),set(product_prod(B,A)),complete_Inf_Inf(set(product_prod(B,A))),aa(set(C),set(set(product_prod(B,A))),image2(C,set(product_prod(B,A)),R2),S))) = aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Inf_Inf(set(product_prod(A,B))),aa(set(C),set(set(product_prod(A,B))),image2(C,set(product_prod(A,B)),aTP_Lamp_mt(fun(C,set(product_prod(B,A))),fun(C,set(product_prod(A,B))),R2)),S)) ) ).

% converse_INTER
tff(fact_1785_lfp__def,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,A)] : ( complete_lattice_lfp(A,F2) = aa(set(A),A,complete_Inf_Inf(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_mu(fun(A,A),fun(A,bool),F2))) ) ) ).

% lfp_def
tff(fact_1786_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),I))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_mv(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2)),I) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),I)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),H2),I)) ) ) ) ).

% prod.distrib_triv'
tff(fact_1787_def__lfp__induct,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: A,F2: fun(A,A),P: A] :
          ( ( A3 = complete_lattice_lfp(A,F2) )
         => ( order_mono(A,A,F2)
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,F2,aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),P))),P))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),P)) ) ) ) ) ).

% def_lfp_induct
tff(fact_1788_lfp__induct,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,A),P: A] :
          ( order_mono(A,A,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,F2,aa(A,A,aa(A,fun(A,A),inf_inf(A),complete_lattice_lfp(A,F2)),P))),P))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),complete_lattice_lfp(A,F2)),P)) ) ) ) ).

% lfp_induct
tff(fact_1789_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S: set(B),T2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S),T2))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S)))
               => ( aa(B,A,G,X) = one_one(A) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),S) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),T2) ) ) ) ) ).

% prod.mono_neutral_left'
tff(fact_1790_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S: set(B),T2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S),T2))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S)))
               => ( aa(B,A,G,X) = one_one(A) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),T2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),S) ) ) ) ) ).

% prod.mono_neutral_right'
tff(fact_1791_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S: set(B),T2: set(B),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S),T2))
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S)))
               => ( aa(B,A,H2,I3) = one_one(A) ) )
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),S))
                 => ( aa(B,A,G,X) = aa(B,A,H2,X) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),S) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),H2),T2) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
tff(fact_1792_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S: set(B),T2: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S),T2))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S)))
               => ( aa(B,A,G,X) = one_one(A) ) )
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),S))
                 => ( aa(B,A,G,X) = aa(B,A,H2,X) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),T2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),H2),S) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
tff(fact_1793_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_li(set(B),fun(fun(B,A),fun(B,bool)),I),G))))
         => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_li(set(B),fun(fun(B,A),fun(B,bool)),I),H2))))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_mv(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2)),I) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),I)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),H2),I)) ) ) ) ) ).

% prod.distrib'
tff(fact_1794_Finite__Set_Ofold__def,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F2: fun(A,fun(B,B)),Z2: B] :
      ( ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( finite_fold(A,B,F2,Z2,A3) = the(B,finite_fold_graph(A,B,F2,Z2,A3)) ) )
      & ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( finite_fold(A,B,F2,Z2,A3) = Z2 ) ) ) ).

% Finite_Set.fold_def
tff(fact_1795_arg__min__if__finite_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [S: set(A),F2: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( ( S != bot_bot(set(A)) )
           => pp(aa(set(A),bool,member(A,lattic7623131987881927897min_on(A,B,F2,S)),S)) ) ) ) ).

% arg_min_if_finite(1)
tff(fact_1796_irrefl__tranclI,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),X2: A] :
      ( ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),converse(A,A,R2)),transitive_rtrancl(A,R2)) = bot_bot(set(product_prod(A,A))) )
     => ~ pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2)),transitive_trancl(A,R2))) ) ).

% irrefl_tranclI
tff(fact_1797_relInvImage__Gr,axiom,
    ! [A: $tType,B: $tType,R: set(product_prod(A,A)),B2: set(A),A3: set(B),F2: fun(B,A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R),product_Sigma(A,A,B2,aTP_Lamp_cr(set(A),fun(A,set(A)),B2))))
     => ( bNF_Gr7122648621184425601vImage(B,A,A3,R,F2) = relcomp(B,A,B,bNF_Gr(B,A,A3,F2),relcomp(A,A,B,R,converse(B,A,bNF_Gr(B,A,A3,F2)))) ) ) ).

% relInvImage_Gr
tff(fact_1798_max__ext__compat,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,R,S)),R))
     => pp(aa(set(product_prod(set(A),set(A))),bool,aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),bool),ord_less_eq(set(product_prod(set(A),set(A)))),relcomp(set(A),set(A),set(A),max_ext(A,R),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),sup_sup(set(product_prod(set(A),set(A)))),max_ext(A,S)),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),insert(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),bot_bot(set(A))),bot_bot(set(A)))),bot_bot(set(product_prod(set(A),set(A)))))))),max_ext(A,R))) ) ).

% max_ext_compat
tff(fact_1799_trans__wf__iff,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( trans(A,R2)
     => ( wf(A,R2)
      <=> ! [A6: A] : wf(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,aa(set(A),set(A),image(A,A,converse(A,A,R2)),aa(set(A),set(A),insert(A,A6),bot_bot(set(A)))),aa(A,fun(A,set(A)),aTP_Lamp_mw(set(product_prod(A,A)),fun(A,fun(A,set(A))),R2),A6)))) ) ) ).

% trans_wf_iff
tff(fact_1800_Image__INT__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType,R2: set(product_prod(B,A)),A3: set(C),B2: fun(C,set(B))] :
      ( single_valued(A,B,converse(B,A,R2))
     => ( ( A3 != bot_bot(set(C)) )
       => ( aa(set(B),set(A),image(B,A,R2),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3))) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_js(set(product_prod(B,A)),fun(fun(C,set(B)),fun(C,set(A))),R2),B2)),A3)) ) ) ) ).

% Image_INT_eq
tff(fact_1801_finite__subsets__at__top__finite,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( finite5375528669736107172at_top(A,A3) = principal(set(A),aa(set(set(A)),set(set(A)),insert(set(A),A3),bot_bot(set(set(A))))) ) ) ).

% finite_subsets_at_top_finite
tff(fact_1802_max__ext_Ocases,axiom,
    ! [A: $tType,A13: set(A),A23: set(A),R: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(set(A),set(A))),bool,member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),A13),A23)),max_ext(A,R)))
     => ~ ( pp(aa(set(A),bool,finite_finite2(A),A13))
         => ( pp(aa(set(A),bool,finite_finite2(A),A23))
           => ( ( A23 != bot_bot(set(A)) )
             => ~ ! [X4: A] :
                    ( pp(aa(set(A),bool,member(A,X4),A13))
                   => ? [Xa4: A] :
                        ( pp(aa(set(A),bool,member(A,Xa4),A23))
                        & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa4)),R)) ) ) ) ) ) ) ).

% max_ext.cases
tff(fact_1803_max__ext_Osimps,axiom,
    ! [A: $tType,A13: set(A),A23: set(A),R: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(set(A),set(A))),bool,member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),A13),A23)),max_ext(A,R)))
    <=> ( pp(aa(set(A),bool,finite_finite2(A),A13))
        & pp(aa(set(A),bool,finite_finite2(A),A23))
        & ( A23 != bot_bot(set(A)) )
        & ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),A13))
           => ? [Xa2: A] :
                ( pp(aa(set(A),bool,member(A,Xa2),A23))
                & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa2)),R)) ) ) ) ) ).

% max_ext.simps
tff(fact_1804_finite__subsets__at__top__neq__bot,axiom,
    ! [A: $tType,A3: set(A)] : ( finite5375528669736107172at_top(A,A3) != bot_bot(filter(set(A))) ) ).

% finite_subsets_at_top_neq_bot
tff(fact_1805_trans__empty,axiom,
    ! [A: $tType] : trans(A,bot_bot(set(product_prod(A,A)))) ).

% trans_empty
tff(fact_1806_trans__Int,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( trans(A,R2)
     => ( trans(A,S2)
       => trans(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),S2)) ) ) ).

% trans_Int
tff(fact_1807_single__valued__empty,axiom,
    ! [B: $tType,A: $tType] : single_valued(A,B,bot_bot(set(product_prod(A,B)))) ).

% single_valued_empty
tff(fact_1808_single__valued__inter1,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S: set(product_prod(A,B))] :
      ( single_valued(A,B,R)
     => single_valued(A,B,aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),R),S)) ) ).

% single_valued_inter1
tff(fact_1809_single__valued__inter2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S: set(product_prod(A,B))] :
      ( single_valued(A,B,R)
     => single_valued(A,B,aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),S),R)) ) ).

% single_valued_inter2
tff(fact_1810_trans__Restr,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( trans(A,R2)
     => trans(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ).

% trans_Restr
tff(fact_1811_lfp__induct__set,axiom,
    ! [A: $tType,A4: A,F2: fun(set(A),set(A)),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,member(A,A4),complete_lattice_lfp(set(A),F2)))
     => ( order_mono(set(A),set(A),F2)
       => ( ! [X: A] :
              ( pp(aa(set(A),bool,member(A,X),aa(set(A),set(A),F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),complete_lattice_lfp(set(A),F2)),aa(fun(A,bool),set(A),collect(A),P)))))
             => pp(aa(A,bool,P,X)) )
         => pp(aa(A,bool,P,A4)) ) ) ) ).

% lfp_induct_set
tff(fact_1812_def__lfp__induct__set,axiom,
    ! [A: $tType,A3: set(A),F2: fun(set(A),set(A)),A4: A,P: fun(A,bool)] :
      ( ( A3 = complete_lattice_lfp(set(A),F2) )
     => ( order_mono(set(A),set(A),F2)
       => ( pp(aa(set(A),bool,member(A,A4),A3))
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),aa(set(A),set(A),F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,bool),set(A),collect(A),P)))))
               => pp(aa(A,bool,P,X)) )
           => pp(aa(A,bool,P,A4)) ) ) ) ) ).

% def_lfp_induct_set
tff(fact_1813_trans__singleton,axiom,
    ! [A: $tType,A4: A] : trans(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),A4)),bot_bot(set(product_prod(A,A))))) ).

% trans_singleton
tff(fact_1814_lfp__induct2,axiom,
    ! [A: $tType,B: $tType,A4: A,B3: B,F2: fun(set(product_prod(A,B)),set(product_prod(A,B))),P: fun(A,fun(B,bool))] :
      ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3)),complete_lattice_lfp(set(product_prod(A,B)),F2)))
     => ( order_mono(set(product_prod(A,B)),set(product_prod(A,B)),F2)
       => ( ! [A5: A,B4: B] :
              ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A5),B4)),aa(set(product_prod(A,B)),set(product_prod(A,B)),F2,aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),complete_lattice_lfp(set(product_prod(A,B)),F2)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),P))))))
             => pp(aa(B,bool,aa(A,fun(B,bool),P,A5),B4)) )
         => pp(aa(B,bool,aa(A,fun(B,bool),P,A4),B3)) ) ) ) ).

% lfp_induct2
tff(fact_1815_Image__Int__eq,axiom,
    ! [A: $tType,B: $tType,R: set(product_prod(B,A)),A3: set(B),B2: set(B)] :
      ( single_valued(A,B,converse(B,A,R))
     => ( aa(set(B),set(A),image(B,A,R),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),image(B,A,R),A3)),aa(set(B),set(A),image(B,A,R),B2)) ) ) ).

% Image_Int_eq
tff(fact_1816_finite__subsets__at__top__def,axiom,
    ! [A: $tType,A3: set(A)] : ( finite5375528669736107172at_top(A,A3) = aa(set(filter(set(A))),filter(set(A)),complete_Inf_Inf(filter(set(A))),aa(set(set(A)),set(filter(set(A))),image2(set(A),filter(set(A)),aTP_Lamp_my(set(A),fun(set(A),filter(set(A))),A3)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_mz(set(A),fun(set(A),bool),A3)))) ) ).

% finite_subsets_at_top_def
tff(fact_1817_max__ext_Omax__extI,axiom,
    ! [A: $tType,X5: set(A),Y3: set(A),R: set(product_prod(A,A))] :
      ( pp(aa(set(A),bool,finite_finite2(A),X5))
     => ( pp(aa(set(A),bool,finite_finite2(A),Y3))
       => ( ( Y3 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),X5))
               => ? [Xa3: A] :
                    ( pp(aa(set(A),bool,member(A,Xa3),Y3))
                    & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Xa3)),R)) ) )
           => pp(aa(set(product_prod(set(A),set(A))),bool,member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),X5),Y3)),max_ext(A,R))) ) ) ) ) ).

% max_ext.max_extI
tff(fact_1818_max__extp__eq,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),X2: set(A),Y: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),max_extp(A,R2),X2),Y))
    <=> pp(aa(set(product_prod(set(A),set(A))),bool,member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),X2),Y)),max_ext(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2))))) ) ).

% max_extp_eq
tff(fact_1819_max__extp__max__ext__eq,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),X4: set(A),Xa3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),max_extp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R)),X4),Xa3))
    <=> pp(aa(set(product_prod(set(A),set(A))),bool,member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),X4),Xa3)),max_ext(A,R))) ) ).

% max_extp_max_ext_eq
tff(fact_1820_wf__finite__segments,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( irrefl(A,R2)
     => ( trans(A,R2)
       => ( ! [X: A] : pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_na(set(product_prod(A,A)),fun(A,fun(A,bool)),R2),X))))
         => wf(A,R2) ) ) ) ).

% wf_finite_segments
tff(fact_1821_filterlim__base__iff,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,I: set(A),F: fun(A,set(B)),F2: fun(B,C),G4: fun(D,set(C)),J: set(D)] :
      ( ( I != bot_bot(set(A)) )
     => ( ! [I3: A] :
            ( pp(aa(set(A),bool,member(A,I3),I))
           => ! [J4: A] :
                ( pp(aa(set(A),bool,member(A,J4),I))
               => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),F,I3)),aa(A,set(B),F,J4)))
                  | pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),F,J4)),aa(A,set(B),F,I3))) ) ) )
       => ( filterlim(B,C,F2,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(D),set(filter(C)),image2(D,filter(C),aTP_Lamp_nb(fun(D,set(C)),fun(D,filter(C)),G4)),J)),aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),aTP_Lamp_mk(fun(A,set(B)),fun(A,filter(B)),F)),I)))
        <=> ! [X3: D] :
              ( pp(aa(set(D),bool,member(D,X3),J))
             => ? [Xa2: A] :
                  ( pp(aa(set(A),bool,member(A,Xa2),I))
                  & ! [Xb2: B] :
                      ( pp(aa(set(B),bool,member(B,Xb2),aa(A,set(B),F,Xa2)))
                     => pp(aa(set(C),bool,member(C,aa(B,C,F2,Xb2)),aa(D,set(C),G4,X3))) ) ) ) ) ) ) ).

% filterlim_base_iff
tff(fact_1822_arg__min__inj__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [F2: fun(A,B),P: fun(A,bool),A4: A] :
          ( inj_on(A,B,F2,aa(fun(A,bool),set(A),collect(A),P))
         => ( pp(aa(A,bool,P,A4))
           => ( ! [Y2: A] :
                  ( pp(aa(A,bool,P,Y2))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,A4)),aa(A,B,F2,Y2))) )
             => ( lattices_ord_arg_min(A,B,F2,P) = A4 ) ) ) ) ) ).

% arg_min_inj_eq
tff(fact_1823_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( pp(aa(set(A),bool,member(A,X2),A3))
           => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = bot_bot(set(A)) )
               => ( lattic5882676163264333800up_fin(A,A3) = X2 ) )
              & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) != bot_bot(set(A)) )
               => ( lattic5882676163264333800up_fin(A,A3) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),lattic5882676163264333800up_fin(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ) ).

% Sup_fin.remove
tff(fact_1824_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = bot_bot(set(A)) )
             => ( lattic5882676163264333800up_fin(A,aa(set(A),set(A),insert(A,X2),A3)) = X2 ) )
            & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) != bot_bot(set(A)) )
             => ( lattic5882676163264333800up_fin(A,aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),lattic5882676163264333800up_fin(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ).

% Sup_fin.insert_remove
tff(fact_1825_Sup__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A] : ( lattic5882676163264333800up_fin(A,aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = X2 ) ) ).

% Sup_fin.singleton
tff(fact_1826_inf__Sup__absorb,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [A3: set(A),A4: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( pp(aa(set(A),bool,member(A,A4),A3))
           => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),lattic5882676163264333800up_fin(A,A3)) = A4 ) ) ) ) ).

% inf_Sup_absorb
tff(fact_1827_Sup__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( lattic5882676163264333800up_fin(A,aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),lattic5882676163264333800up_fin(A,A3)) ) ) ) ) ).

% Sup_fin.insert
tff(fact_1828_filterlim__ident,axiom,
    ! [A: $tType,F: filter(A)] : filterlim(A,A,aTP_Lamp_bk(A,A),F,F) ).

% filterlim_ident
tff(fact_1829_filterlim__compose,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: fun(A,B),F32: filter(B),F23: filter(A),F2: fun(C,A),F12: filter(C)] :
      ( filterlim(A,B,G,F32,F23)
     => ( filterlim(C,A,F2,F23,F12)
       => filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_nc(fun(A,B),fun(fun(C,A),fun(C,B)),G),F2),F32,F12) ) ) ).

% filterlim_compose
tff(fact_1830_filterlim__inf,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),F23: filter(B),F32: filter(B),F12: filter(A)] :
      ( filterlim(A,B,F2,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F23),F32),F12)
    <=> ( filterlim(A,B,F2,F23,F12)
        & filterlim(A,B,F2,F32,F12) ) ) ).

% filterlim_inf
tff(fact_1831_filterlim__INF,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(A,B),G4: fun(C,filter(B)),B2: set(C),F: filter(A)] :
      ( filterlim(A,B,F2,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(C),set(filter(B)),image2(C,filter(B),G4),B2)),F)
    <=> ! [X3: C] :
          ( pp(aa(set(C),bool,member(C,X3),B2))
         => filterlim(A,B,F2,aa(C,filter(B),G4,X3),F) ) ) ).

% filterlim_INF
tff(fact_1832_filterlim__INF_H,axiom,
    ! [C: $tType,B: $tType,A: $tType,X2: A,A3: set(A),F2: fun(B,C),F: filter(C),G4: fun(A,filter(B))] :
      ( pp(aa(set(A),bool,member(A,X2),A3))
     => ( filterlim(B,C,F2,F,aa(A,filter(B),G4,X2))
       => filterlim(B,C,F2,F,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),G4),A3))) ) ) ).

% filterlim_INF'
tff(fact_1833_filterlim__If,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),G4: filter(B),F: filter(A),P: fun(A,bool),G: fun(A,B)] :
      ( filterlim(A,B,F2,G4,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F),principal(A,aa(fun(A,bool),set(A),collect(A),P))))
     => ( filterlim(A,B,G,G4,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F),principal(A,aa(fun(A,bool),set(A),collect(A),aTP_Lamp_as(fun(A,bool),fun(A,bool),P)))))
       => filterlim(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,bool),fun(fun(A,B),fun(A,B)),aTP_Lamp_nd(fun(A,B),fun(fun(A,bool),fun(fun(A,B),fun(A,B))),F2),P),G),G4,F) ) ) ).

% filterlim_If
tff(fact_1834_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic5882676163264333800up_fin(A,A3)),X2))
             => ! [A14: A] :
                  ( pp(aa(set(A),bool,member(A,A14),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A14),X2)) ) ) ) ) ) ).

% Sup_fin.boundedE
tff(fact_1835_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [A5: A] :
                  ( pp(aa(set(A),bool,member(A,A5),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A5),X2)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic5882676163264333800up_fin(A,A3)),X2)) ) ) ) ) ).

% Sup_fin.boundedI
tff(fact_1836_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic5882676163264333800up_fin(A,A3)),X2))
            <=> ! [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),X2)) ) ) ) ) ) ).

% Sup_fin.bounded_iff
tff(fact_1837_Sup__fin__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( lattic5882676163264333800up_fin(A,A3) = aa(set(A),A,complete_Sup_Sup(A),A3) ) ) ) ) ).

% Sup_fin_Sup
tff(fact_1838_cSup__eq__Sup__fin,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X5: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),X5))
         => ( ( X5 != bot_bot(set(A)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),X5) = lattic5882676163264333800up_fin(A,X5) ) ) ) ) ).

% cSup_eq_Sup_fin
tff(fact_1839_filterlim__base,axiom,
    ! [B: $tType,A: $tType,E: $tType,D: $tType,C: $tType,J: set(A),I2: fun(A,C),I: set(C),F: fun(C,set(D)),F2: fun(D,E),G4: fun(A,set(E))] :
      ( ! [M3: A,X: B] :
          ( pp(aa(set(A),bool,member(A,M3),J))
         => pp(aa(set(C),bool,member(C,aa(A,C,I2,M3)),I)) )
     => ( ! [M3: A,X: D] :
            ( pp(aa(set(A),bool,member(A,M3),J))
           => ( pp(aa(set(D),bool,member(D,X),aa(C,set(D),F,aa(A,C,I2,M3))))
             => pp(aa(set(E),bool,member(E,aa(D,E,F2,X)),aa(A,set(E),G4,M3))) ) )
       => filterlim(D,E,F2,aa(set(filter(E)),filter(E),complete_Inf_Inf(filter(E)),aa(set(A),set(filter(E)),image2(A,filter(E),aTP_Lamp_ne(fun(A,set(E)),fun(A,filter(E)),G4)),J)),aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(C),set(filter(D)),image2(C,filter(D),aTP_Lamp_nf(fun(C,set(D)),fun(C,filter(D)),F)),I))) ) ) ).

% filterlim_base
tff(fact_1840_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),B2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic5882676163264333800up_fin(A,A3)),lattic5882676163264333800up_fin(A,B2))) ) ) ) ) ).

% Sup_fin.subset_imp
tff(fact_1841_Sup__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [H2: fun(A,A),N4: set(A)] :
          ( ! [X: A,Y2: A] : ( aa(A,A,H2,aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,H2,X)),aa(A,A,H2,Y2)) )
         => ( pp(aa(set(A),bool,finite_finite2(A),N4))
           => ( ( N4 != bot_bot(set(A)) )
             => ( aa(A,A,H2,lattic5882676163264333800up_fin(A,N4)) = lattic5882676163264333800up_fin(A,aa(set(A),set(A),image2(A,A,H2),N4)) ) ) ) ) ) ).

% Sup_fin.hom_commute
tff(fact_1842_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( B2 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),A3))
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),lattic5882676163264333800up_fin(A,B2)),lattic5882676163264333800up_fin(A,A3)) = lattic5882676163264333800up_fin(A,A3) ) ) ) ) ) ).

% Sup_fin.subset
tff(fact_1843_Sup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ~ pp(aa(set(A),bool,member(A,X2),A3))
           => ( ( A3 != bot_bot(set(A)) )
             => ( lattic5882676163264333800up_fin(A,aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),lattic5882676163264333800up_fin(A,A3)) ) ) ) ) ) ).

% Sup_fin.insert_not_elem
tff(fact_1844_Sup__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [X: A,Y2: A] : pp(aa(set(A),bool,member(A,aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y2)),aa(set(A),set(A),insert(A,X),aa(set(A),set(A),insert(A,Y2),bot_bot(set(A))))))
             => pp(aa(set(A),bool,member(A,lattic5882676163264333800up_fin(A,A3)),A3)) ) ) ) ) ).

% Sup_fin.closed
tff(fact_1845_Sup__fin_Ounion,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),B2))
             => ( ( B2 != bot_bot(set(A)) )
               => ( lattic5882676163264333800up_fin(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),lattic5882676163264333800up_fin(A,A3)),lattic5882676163264333800up_fin(A,B2)) ) ) ) ) ) ) ).

% Sup_fin.union
tff(fact_1846_inf__Sup1__distrib,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),lattic5882676163264333800up_fin(A,A3)) = lattic5882676163264333800up_fin(A,aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_ng(set(A),fun(A,fun(A,bool)),A3),X2))) ) ) ) ) ).

% inf_Sup1_distrib
tff(fact_1847_inf__Sup2__distrib,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),B2))
             => ( ( B2 != bot_bot(set(A)) )
               => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),lattic5882676163264333800up_fin(A,A3)),lattic5882676163264333800up_fin(A,B2)) = lattic5882676163264333800up_fin(A,aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_nh(set(A),fun(set(A),fun(A,bool)),A3),B2))) ) ) ) ) ) ) ).

% inf_Sup2_distrib
tff(fact_1848_arg__min__on__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ord(A)
     => ! [F2: fun(B,A),S: set(B)] : ( lattic7623131987881927897min_on(B,A,F2,S) = lattices_ord_arg_min(B,A,F2,aTP_Lamp_ni(set(B),fun(B,bool),S)) ) ) ).

% arg_min_on_def
tff(fact_1849_max__ext__def,axiom,
    ! [A: $tType,X4: set(product_prod(A,A))] : ( max_ext(A,X4) = aa(fun(product_prod(set(A),set(A)),bool),set(product_prod(set(A),set(A))),collect(product_prod(set(A),set(A))),aa(fun(set(A),fun(set(A),bool)),fun(product_prod(set(A),set(A)),bool),product_case_prod(set(A),set(A),bool),max_extp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),X4)))) ) ).

% max_ext_def
tff(fact_1850_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( pp(aa(set(A),bool,member(A,X2),A3))
           => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = bot_bot(set(A)) )
               => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),A3) = X2 ) )
              & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) != bot_bot(set(A)) )
               => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),A3) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ) ).

% Inf_fin.remove
tff(fact_1851_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = bot_bot(set(A)) )
             => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert(A,X2),A3)) = X2 ) )
            & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ).

% Inf_fin.insert_remove
tff(fact_1852_Inf__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3)) ) ) ) ) ).

% Inf_fin.insert
tff(fact_1853_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B2: set(A),F: fun(A,filter(B)),P: fun(B,bool)] :
      ( ( B2 != bot_bot(set(A)) )
     => ( ! [A5: A] :
            ( pp(aa(set(A),bool,member(A,A5),B2))
           => ! [B4: A] :
                ( pp(aa(set(A),bool,member(A,B4),B2))
               => ? [X4: A] :
                    ( pp(aa(set(A),bool,member(A,X4),B2))
                    & pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),aa(A,filter(B),F,X4)),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),aa(A,filter(B),F,A5)),aa(A,filter(B),F,B4)))) ) ) )
       => ( eventually(B,P,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),F),B2)))
        <=> ? [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),B2))
              & eventually(B,P,aa(A,filter(B),F,X3)) ) ) ) ) ).

% eventually_INF_base
tff(fact_1854_coinduct3__lemma,axiom,
    ! [A: $tType,X5: set(A),F2: fun(set(A),set(A))] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X5),aa(set(A),set(A),F2,complete_lattice_lfp(set(A),aa(fun(set(A),set(A)),fun(set(A),set(A)),aTP_Lamp_nj(set(A),fun(fun(set(A),set(A)),fun(set(A),set(A))),X5),F2)))))
     => ( order_mono(set(A),set(A),F2)
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),complete_lattice_lfp(set(A),aa(fun(set(A),set(A)),fun(set(A),set(A)),aTP_Lamp_nj(set(A),fun(fun(set(A),set(A)),fun(set(A),set(A))),X5),F2))),aa(set(A),set(A),F2,complete_lattice_lfp(set(A),aa(fun(set(A),set(A)),fun(set(A),set(A)),aTP_Lamp_nj(set(A),fun(fun(set(A),set(A)),fun(set(A),set(A))),X5),F2))))) ) ) ).

% coinduct3_lemma
tff(fact_1855_def__coinduct3,axiom,
    ! [A: $tType,A3: set(A),F2: fun(set(A),set(A)),A4: A,X5: set(A)] :
      ( ( A3 = complete_lattice_gfp(set(A),F2) )
     => ( order_mono(set(A),set(A),F2)
       => ( pp(aa(set(A),bool,member(A,A4),X5))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X5),aa(set(A),set(A),F2,complete_lattice_lfp(set(A),aa(set(A),fun(set(A),set(A)),aa(fun(set(A),set(A)),fun(set(A),fun(set(A),set(A))),aTP_Lamp_nk(set(A),fun(fun(set(A),set(A)),fun(set(A),fun(set(A),set(A)))),A3),F2),X5)))))
           => pp(aa(set(A),bool,member(A,A4),A3)) ) ) ) ) ).

% def_coinduct3
tff(fact_1856_coinduct3,axiom,
    ! [A: $tType,F2: fun(set(A),set(A)),A4: A,X5: set(A)] :
      ( order_mono(set(A),set(A),F2)
     => ( pp(aa(set(A),bool,member(A,A4),X5))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X5),aa(set(A),set(A),F2,complete_lattice_lfp(set(A),aa(set(A),fun(set(A),set(A)),aTP_Lamp_nl(fun(set(A),set(A)),fun(set(A),fun(set(A),set(A))),F2),X5)))))
         => pp(aa(set(A),bool,member(A,A4),complete_lattice_gfp(set(A),F2))) ) ) ) ).

% coinduct3
tff(fact_1857_eventually__const,axiom,
    ! [A: $tType,F: filter(A),P: bool] :
      ( ( F != bot_bot(filter(A)) )
     => ( eventually(A,aTP_Lamp_an(bool,fun(A,bool),P),F)
      <=> pp(P) ) ) ).

% eventually_const
tff(fact_1858_Inf__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A] : ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = X2 ) ) ).

% Inf_fin.singleton
tff(fact_1859_not__eventually__impI,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A),Q: fun(A,bool)] :
      ( eventually(A,P,F)
     => ( ~ eventually(A,Q,F)
       => ~ eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aw(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F) ) ) ).

% not_eventually_impI
tff(fact_1860_eventually__conj__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),F: filter(A)] :
      ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F)
    <=> ( eventually(A,P,F)
        & eventually(A,Q,F) ) ) ).

% eventually_conj_iff
tff(fact_1861_eventually__rev__mp,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A),Q: fun(A,bool)] :
      ( eventually(A,P,F)
     => ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aw(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F)
       => eventually(A,Q,F) ) ) ).

% eventually_rev_mp
tff(fact_1862_eventually__subst,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),F: filter(A)] :
      ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_nm(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F)
     => ( eventually(A,P,F)
      <=> eventually(A,Q,F) ) ) ).

% eventually_subst
tff(fact_1863_eventually__elim2,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A),Q: fun(A,bool),R: fun(A,bool)] :
      ( eventually(A,P,F)
     => ( eventually(A,Q,F)
       => ( ! [I3: A] :
              ( pp(aa(A,bool,P,I3))
             => ( pp(aa(A,bool,Q,I3))
               => pp(aa(A,bool,R,I3)) ) )
         => eventually(A,R,F) ) ) ) ).

% eventually_elim2
tff(fact_1864_eventually__conj,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A),Q: fun(A,bool)] :
      ( eventually(A,P,F)
     => ( eventually(A,Q,F)
       => eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F) ) ) ).

% eventually_conj
tff(fact_1865_eventually__True,axiom,
    ! [A: $tType,F: filter(A)] : eventually(A,aTP_Lamp_nn(A,bool),F) ).

% eventually_True
tff(fact_1866_eventually__mp,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),F: filter(A)] :
      ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aw(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F)
     => ( eventually(A,P,F)
       => eventually(A,Q,F) ) ) ).

% eventually_mp
tff(fact_1867_eventually__frequently__const__simps_I3_J,axiom,
    ! [A: $tType,P: fun(A,bool),C3: bool,F: filter(A)] :
      ( eventually(A,aa(bool,fun(A,bool),aTP_Lamp_no(fun(A,bool),fun(bool,fun(A,bool)),P),C3),F)
    <=> ( eventually(A,P,F)
        | pp(C3) ) ) ).

% eventually_frequently_const_simps(3)
tff(fact_1868_eventually__frequently__const__simps_I4_J,axiom,
    ! [A: $tType,C3: bool,P: fun(A,bool),F: filter(A)] :
      ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_np(bool,fun(fun(A,bool),fun(A,bool)),C3),P),F)
    <=> ( pp(C3)
        | eventually(A,P,F) ) ) ).

% eventually_frequently_const_simps(4)
tff(fact_1869_eventually__frequently__const__simps_I6_J,axiom,
    ! [A: $tType,C3: bool,P: fun(A,bool),F: filter(A)] :
      ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_nq(bool,fun(fun(A,bool),fun(A,bool)),C3),P),F)
    <=> ( pp(C3)
       => eventually(A,P,F) ) ) ).

% eventually_frequently_const_simps(6)
tff(fact_1870_gfp__const,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [T3: A] : ( complete_lattice_gfp(A,aTP_Lamp_mm(A,fun(A,A),T3)) = T3 ) ) ).

% gfp_const
tff(fact_1871_eventually__happens_H,axiom,
    ! [A: $tType,F: filter(A),P: fun(A,bool)] :
      ( ( F != bot_bot(filter(A)) )
     => ( eventually(A,P,F)
       => ? [X_1: A] : pp(aa(A,bool,P,X_1)) ) ) ).

% eventually_happens'
tff(fact_1872_eventually__happens,axiom,
    ! [A: $tType,P: fun(A,bool),Net: filter(A)] :
      ( eventually(A,P,Net)
     => ( ( Net = bot_bot(filter(A)) )
        | ? [X_1: A] : pp(aa(A,bool,P,X_1)) ) ) ).

% eventually_happens
tff(fact_1873_eventually__bot,axiom,
    ! [A: $tType,P: fun(A,bool)] : eventually(A,P,bot_bot(filter(A))) ).

% eventually_bot
tff(fact_1874_eventually__inf,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A),F3: filter(A)] :
      ( eventually(A,P,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F),F3))
    <=> ? [Q7: fun(A,bool),R6: fun(A,bool)] :
          ( eventually(A,Q7,F)
          & eventually(A,R6,F3)
          & ! [X3: A] :
              ( ( pp(aa(A,bool,Q7,X3))
                & pp(aa(A,bool,R6,X3)) )
             => pp(aa(A,bool,P,X3)) ) ) ) ).

% eventually_inf
tff(fact_1875_eventually__ex,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool)),F: filter(A)] :
      ( eventually(A,aTP_Lamp_gu(fun(A,fun(B,bool)),fun(A,bool),P),F)
    <=> ? [Y7: fun(A,B)] : eventually(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_nr(fun(A,fun(B,bool)),fun(fun(A,B),fun(A,bool)),P),Y7),F) ) ).

% eventually_ex
tff(fact_1876_eventually__compose__filterlim,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F: filter(A),F2: fun(B,A),G4: filter(B)] :
      ( eventually(A,P,F)
     => ( filterlim(B,A,F2,F,G4)
       => eventually(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_ns(fun(A,bool),fun(fun(B,A),fun(B,bool)),P),F2),G4) ) ) ).

% eventually_compose_filterlim
tff(fact_1877_filterlim__cong,axiom,
    ! [A: $tType,B: $tType,F12: filter(A),F13: filter(A),F23: filter(B),F24: filter(B),F2: fun(B,A),G: fun(B,A)] :
      ( ( F12 = F13 )
     => ( ( F23 = F24 )
       => ( eventually(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_nt(fun(B,A),fun(fun(B,A),fun(B,bool)),F2),G),F23)
         => ( filterlim(B,A,F2,F12,F23)
          <=> filterlim(B,A,G,F13,F24) ) ) ) ) ).

% filterlim_cong
tff(fact_1878_filterlim__iff,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),F23: filter(B),F12: filter(A)] :
      ( filterlim(A,B,F2,F23,F12)
    <=> ! [P4: fun(B,bool)] :
          ( eventually(B,P4,F23)
         => eventually(A,aa(fun(B,bool),fun(A,bool),aTP_Lamp_bl(fun(A,B),fun(fun(B,bool),fun(A,bool)),F2),P4),F12) ) ) ).

% filterlim_iff
tff(fact_1879_trivial__limit__def,axiom,
    ! [A: $tType,F: filter(A)] :
      ( ( F = bot_bot(filter(A)) )
    <=> eventually(A,aTP_Lamp_ao(A,bool),F) ) ).

% trivial_limit_def
tff(fact_1880_eventually__const__iff,axiom,
    ! [A: $tType,P: bool,F: filter(A)] :
      ( eventually(A,aTP_Lamp_an(bool,fun(A,bool),P),F)
    <=> ( pp(P)
        | ( F = bot_bot(filter(A)) ) ) ) ).

% eventually_const_iff
tff(fact_1881_False__imp__not__eventually,axiom,
    ! [A: $tType,P: fun(A,bool),Net: filter(A)] :
      ( ! [X: A] : ~ pp(aa(A,bool,P,X))
     => ( ( Net != bot_bot(filter(A)) )
       => ~ eventually(A,P,Net) ) ) ).

% False_imp_not_eventually
tff(fact_1882_gfp__gfp,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,fun(A,A))] :
          ( ! [X: A,Y2: A,W: A,Z3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),W),Z3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F2,X),W)),aa(A,A,aa(A,fun(A,A),F2,Y2),Z3))) ) )
         => ( complete_lattice_gfp(A,aTP_Lamp_nu(fun(A,fun(A,A)),fun(A,A),F2)) = complete_lattice_gfp(A,aTP_Lamp_mo(fun(A,fun(A,A)),fun(A,A),F2)) ) ) ) ).

% gfp_gfp
tff(fact_1883_gfp__rolling,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(A) )
     => ! [G: fun(A,B),F2: fun(B,A)] :
          ( order_mono(A,B,G)
         => ( order_mono(B,A,F2)
           => ( aa(A,B,G,complete_lattice_gfp(A,aa(fun(B,A),fun(A,A),aTP_Lamp_mq(fun(A,B),fun(fun(B,A),fun(A,A)),G),F2))) = complete_lattice_gfp(B,aa(fun(B,A),fun(B,B),aTP_Lamp_mr(fun(A,B),fun(fun(B,A),fun(B,B)),G),F2)) ) ) ) ) ).

% gfp_rolling
tff(fact_1884_Inf__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( pp(aa(set(A),bool,member(A,X2),A3))
           => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3)) = aa(set(A),A,lattic7752659483105999362nf_fin(A),A3) ) ) ) ) ).

% Inf_fin.in_idem
tff(fact_1885_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),F: filter(B),G4: filter(A),F3: filter(B),G5: filter(A),F11: fun(A,B)] :
      ( filterlim(A,B,F2,F,G4)
     => ( pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),F),F3))
       => ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),G5),G4))
         => ( eventually(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_nv(fun(A,B),fun(fun(A,B),fun(A,bool)),F2),F11),G5)
           => filterlim(A,B,F11,F3,G5) ) ) ) ) ).

% filterlim_mono_eventually
tff(fact_1886_filterlim__principal,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),S: set(B),F: filter(A)] :
      ( filterlim(A,B,F2,principal(B,S),F)
    <=> eventually(A,aa(set(B),fun(A,bool),aTP_Lamp_bn(fun(A,B),fun(set(B),fun(A,bool)),F2),S),F) ) ).

% filterlim_principal
tff(fact_1887_le__principal,axiom,
    ! [A: $tType,F: filter(A),A3: set(A)] :
      ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),F),principal(A,A3)))
    <=> eventually(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3),F) ) ).

% le_principal
tff(fact_1888_eventually__INF1,axiom,
    ! [B: $tType,A: $tType,I2: A,I: set(A),P: fun(B,bool),F: fun(A,filter(B))] :
      ( pp(aa(set(A),bool,member(A,I2),I))
     => ( eventually(B,P,aa(A,filter(B),F,I2))
       => eventually(B,P,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),F),I))) ) ) ).

% eventually_INF1
tff(fact_1889_eventually__inf__principal,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A),S2: set(A)] :
      ( eventually(A,P,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F),principal(A,S2)))
    <=> eventually(A,aa(set(A),fun(A,bool),aTP_Lamp_nw(fun(A,bool),fun(set(A),fun(A,bool)),P),S2),F) ) ).

% eventually_inf_principal
tff(fact_1890_gfp__def,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,A)] : ( complete_lattice_gfp(A,F2) = aa(set(A),A,complete_Sup_Sup(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_nx(fun(A,A),fun(A,bool),F2))) ) ) ).

% gfp_def
tff(fact_1891_def__Collect__coinduct,axiom,
    ! [A: $tType,A3: set(A),P: fun(set(A),fun(A,bool)),A4: A,X5: set(A)] :
      ( ( A3 = complete_lattice_gfp(set(A),aTP_Lamp_ny(fun(set(A),fun(A,bool)),fun(set(A),set(A)),P)) )
     => ( order_mono(set(A),set(A),aTP_Lamp_ny(fun(set(A),fun(A,bool)),fun(set(A),set(A)),P))
       => ( pp(aa(set(A),bool,member(A,A4),X5))
         => ( ! [Z3: A] :
                ( pp(aa(set(A),bool,member(A,Z3),X5))
               => pp(aa(A,bool,aa(set(A),fun(A,bool),P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),X5),A3)),Z3)) )
           => pp(aa(set(A),bool,member(A,A4),A3)) ) ) ) ) ).

% def_Collect_coinduct
tff(fact_1892_eventually__Inf__base,axiom,
    ! [A: $tType,B2: set(filter(A)),P: fun(A,bool)] :
      ( ( B2 != bot_bot(set(filter(A))) )
     => ( ! [F6: filter(A)] :
            ( pp(aa(set(filter(A)),bool,member(filter(A),F6),B2))
           => ! [G6: filter(A)] :
                ( pp(aa(set(filter(A)),bool,member(filter(A),G6),B2))
               => ? [X4: filter(A)] :
                    ( pp(aa(set(filter(A)),bool,member(filter(A),X4),B2))
                    & pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),X4),aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F6),G6))) ) ) )
       => ( eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),B2))
        <=> ? [X3: filter(A)] :
              ( pp(aa(set(filter(A)),bool,member(filter(A),X3),B2))
              & eventually(A,P,X3) ) ) ) ) ).

% eventually_Inf_base
tff(fact_1893_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3)))
            <=> ! [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),X3)) ) ) ) ) ) ).

% Inf_fin.bounded_iff
tff(fact_1894_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [A5: A] :
                  ( pp(aa(set(A),bool,member(A,A5),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A5)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3))) ) ) ) ) ).

% Inf_fin.boundedI
tff(fact_1895_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3)))
             => ! [A14: A] :
                  ( pp(aa(set(A),bool,member(A,A14),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A14)) ) ) ) ) ) ).

% Inf_fin.boundedE
tff(fact_1896_eventually__INF__finite,axiom,
    ! [A: $tType,B: $tType,A3: set(A),P: fun(B,bool),F: fun(A,filter(B))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( eventually(B,P,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),F),A3)))
      <=> ? [Q7: fun(A,fun(B,bool))] :
            ( ! [X3: A] :
                ( pp(aa(set(A),bool,member(A,X3),A3))
               => eventually(B,aa(A,fun(B,bool),Q7,X3),aa(A,filter(B),F,X3)) )
            & ! [Y4: B] :
                ( ! [X3: A] :
                    ( pp(aa(set(A),bool,member(A,X3),A3))
                   => pp(aa(B,bool,aa(A,fun(B,bool),Q7,X3),Y4)) )
               => pp(aa(B,bool,P,Y4)) ) ) ) ) ).

% eventually_INF_finite
tff(fact_1897_filterlim__finite__subsets__at__top,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,set(B)),A3: set(B),F: filter(A)] :
      ( filterlim(A,set(B),F2,finite5375528669736107172at_top(B,A3),F)
    <=> ! [X7: set(B)] :
          ( ( pp(aa(set(B),bool,finite_finite2(B),X7))
            & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),X7),A3)) )
         => eventually(A,aa(set(B),fun(A,bool),aa(set(B),fun(set(B),fun(A,bool)),aTP_Lamp_nz(fun(A,set(B)),fun(set(B),fun(set(B),fun(A,bool))),F2),A3),X7),F) ) ) ).

% filterlim_finite_subsets_at_top
tff(fact_1898_cInf__eq__Inf__fin,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X5: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),X5))
         => ( ( X5 != bot_bot(set(A)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),X5) = aa(set(A),A,lattic7752659483105999362nf_fin(A),X5) ) ) ) ) ).

% cInf_eq_Inf_fin
tff(fact_1899_Inf__fin__Inf,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),A3) = aa(set(A),A,complete_Inf_Inf(A),A3) ) ) ) ) ).

% Inf_fin_Inf
tff(fact_1900_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F: fun(B,filter(A)),B2: set(B)] :
      ( eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(B),set(filter(A)),image2(B,filter(A),F),B2)))
    <=> ? [X7: set(B)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),X7),B2))
          & pp(aa(set(B),bool,finite_finite2(B),X7))
          & eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(B),set(filter(A)),image2(B,filter(A),F),X7))) ) ) ).

% eventually_INF
tff(fact_1901_Inf__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),B2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic7752659483105999362nf_fin(A),B2)),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3))) ) ) ) ) ).

% Inf_fin.subset_imp
tff(fact_1902_Inf__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [H2: fun(A,A),N4: set(A)] :
          ( ! [X: A,Y2: A] : ( aa(A,A,H2,aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,H2,X)),aa(A,A,H2,Y2)) )
         => ( pp(aa(set(A),bool,finite_finite2(A),N4))
           => ( ( N4 != bot_bot(set(A)) )
             => ( aa(A,A,H2,aa(set(A),A,lattic7752659483105999362nf_fin(A),N4)) = aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),image2(A,A,H2),N4)) ) ) ) ) ) ).

% Inf_fin.hom_commute
tff(fact_1903_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( B2 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),A3))
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,lattic7752659483105999362nf_fin(A),B2)),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3)) = aa(set(A),A,lattic7752659483105999362nf_fin(A),A3) ) ) ) ) ) ).

% Inf_fin.subset
tff(fact_1904_Inf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ~ pp(aa(set(A),bool,member(A,X2),A3))
           => ( ( A3 != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3)) ) ) ) ) ) ).

% Inf_fin.insert_not_elem
tff(fact_1905_Inf__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [X: A,Y2: A] : pp(aa(set(A),bool,member(A,aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y2)),aa(set(A),set(A),insert(A,X),aa(set(A),set(A),insert(A,Y2),bot_bot(set(A))))))
             => pp(aa(set(A),bool,member(A,aa(set(A),A,lattic7752659483105999362nf_fin(A),A3)),A3)) ) ) ) ) ).

% Inf_fin.closed
tff(fact_1906_Inf__fin_Ounion,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),B2))
             => ( ( B2 != bot_bot(set(A)) )
               => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3)),aa(set(A),A,lattic7752659483105999362nf_fin(A),B2)) ) ) ) ) ) ) ).

% Inf_fin.union
tff(fact_1907_Inf__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert(A,X2),A3)) = finite_fold(A,A,inf_inf(A),X2,A3) ) ) ) ).

% Inf_fin.eq_fold
tff(fact_1908_Inf__fin__le__Sup__fin,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3)),lattic5882676163264333800up_fin(A,A3))) ) ) ) ).

% Inf_fin_le_Sup_fin
tff(fact_1909_sup__Inf2__distrib,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),B2))
             => ( ( B2 != bot_bot(set(A)) )
               => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3)),aa(set(A),A,lattic7752659483105999362nf_fin(A),B2)) = aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_oa(set(A),fun(set(A),fun(A,bool)),A3),B2))) ) ) ) ) ) ) ).

% sup_Inf2_distrib
tff(fact_1910_sup__Inf1__distrib,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(set(A),A,lattic7752659483105999362nf_fin(A),A3)) = aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_ob(set(A),fun(A,fun(A,bool)),A3),X2))) ) ) ) ) ).

% sup_Inf1_distrib
tff(fact_1911_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: fun(B,A),Y3: set(B),X5: set(A),F: filter(B),F2: fun(A,C)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image2(B,A,G),Y3)),X5))
     => ( eventually(B,aTP_Lamp_ni(set(B),fun(B,bool),Y3),F)
       => ( map_filter_on(A,C,X5,F2,map_filter_on(B,A,Y3,G,F)) = map_filter_on(B,C,Y3,aa(fun(B,A),fun(B,C),comp(A,C,B,F2),G),F) ) ) ) ).

% map_filter_on_comp
tff(fact_1912_filterlim__at__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),F: filter(A)] :
          ( filterlim(A,B,F2,at_bot(B),F)
        <=> ! [Z6: B] : eventually(A,aa(B,fun(A,bool),aTP_Lamp_oc(fun(A,B),fun(B,fun(A,bool)),F2),Z6),F) ) ) ).

% filterlim_at_bot
tff(fact_1913_filterlim__at__bot__le,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),F: filter(A),C2: B] :
          ( filterlim(A,B,F2,at_bot(B),F)
        <=> ! [Z6: B] :
              ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),Z6),C2))
             => eventually(A,aa(B,fun(A,bool),aTP_Lamp_oc(fun(A,B),fun(B,fun(A,bool)),F2),Z6),F) ) ) ) ).

% filterlim_at_bot_le
tff(fact_1914_filterlim__INF__INF,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,J: set(A),I: set(B),F2: fun(D,C),F: fun(B,filter(D)),G4: fun(A,filter(C))] :
      ( ! [M3: A] :
          ( pp(aa(set(A),bool,member(A,M3),J))
         => ? [X4: B] :
              ( pp(aa(set(B),bool,member(B,X4),I))
              & pp(aa(filter(C),bool,aa(filter(C),fun(filter(C),bool),ord_less_eq(filter(C)),filtermap(D,C,F2,aa(B,filter(D),F,X4))),aa(A,filter(C),G4,M3))) ) )
     => filterlim(D,C,F2,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(A),set(filter(C)),image2(A,filter(C),G4),J)),aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(B),set(filter(D)),image2(B,filter(D),F),I))) ) ).

% filterlim_INF_INF
tff(fact_1915_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add(B)
        & semiring_1(B) )
     => ! [I2: C,A3: set(C),F2: fun(C,B)] :
          ( pp(aa(set(C),bool,member(C,I2),A3))
         => ( ! [X: C] :
                ( pp(aa(set(C),bool,member(C,X),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A3),aa(set(C),set(C),insert(C,I2),bot_bot(set(C))))))
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(C,B,F2,X))) )
           => ( pp(aa(set(C),bool,finite_finite2(C),A3))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(C,B,F2,I2)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),F2),A3))) ) ) ) ) ).

% member_le_sum
tff(fact_1916_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [B2: set(A),A3: set(A),F2: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite2(A),B2))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
           => ( ! [B4: A] :
                  ( pp(aa(set(A),bool,member(A,B4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B2),A3)))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),one_one(B)),aa(A,B,F2,B4))) )
             => ( ! [A5: A] :
                    ( pp(aa(set(A),bool,member(A,A5),A3))
                   => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,A5))) )
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),B2))) ) ) ) ) ) ).

% prod_mono2
tff(fact_1917_ex__is__arg__min__if__finite,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [S: set(A),F2: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( ( S != bot_bot(set(A)) )
           => ? [X_1: A] : pp(aa(A,bool,lattic501386751177426532rg_min(A,B,F2,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),S)),X_1)) ) ) ) ).

% ex_is_arg_min_if_finite
tff(fact_1918_filtermap__id_H,axiom,
    ! [A: $tType,X4: filter(A)] : ( filtermap(A,A,aTP_Lamp_bk(A,A),X4) = X4 ) ).

% filtermap_id'
tff(fact_1919_filtermap__bot,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A)] : ( filtermap(B,A,F2,bot_bot(filter(B))) = bot_bot(filter(A)) ) ).

% filtermap_bot
tff(fact_1920_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_od(B,A)),A3) = zero_zero(A) ) ) ).

% sum.neutral_const
tff(fact_1921_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_oe(B,A)),A3) = one_one(A) ) ) ).

% prod.neutral_const
tff(fact_1922_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty
tff(fact_1923_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),bot_bot(set(B))) = one_one(A) ) ) ).

% prod.empty
tff(fact_1924_prod_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),G: fun(B,A)] :
          ( ~ pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) = one_one(A) ) ) ) ).

% prod.infinite
tff(fact_1925_sum_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [S: set(B),A4: B,B3: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( ( pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_of(B,fun(fun(B,A),fun(B,A)),A4),B3)),S) = aa(B,A,B3,A4) ) )
            & ( ~ pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_of(B,fun(fun(B,A),fun(B,A)),A4),B3)),S) = zero_zero(A) ) ) ) ) ) ).

% sum.delta
tff(fact_1926_sum_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [S: set(B),A4: B,B3: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( ( pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_og(B,fun(fun(B,A),fun(B,A)),A4),B3)),S) = aa(B,A,B3,A4) ) )
            & ( ~ pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_og(B,fun(fun(B,A),fun(B,A)),A4),B3)),S) = zero_zero(A) ) ) ) ) ) ).

% sum.delta'
tff(fact_1927_prod_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [S: set(B),A4: B,B3: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( ( pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_oh(B,fun(fun(B,A),fun(B,A)),A4),B3)),S) = aa(B,A,B3,A4) ) )
            & ( ~ pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_oh(B,fun(fun(B,A),fun(B,A)),A4),B3)),S) = one_one(A) ) ) ) ) ) ).

% prod.delta
tff(fact_1928_prod_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [S: set(B),A4: B,B3: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( ( pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_oi(B,fun(fun(B,A),fun(B,A)),A4),B3)),S) = aa(B,A,B3,A4) ) )
            & ( ~ pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_oi(B,fun(fun(B,A),fun(B,A)),A4),B3)),S) = one_one(A) ) ) ) ) ) ).

% prod.delta'
tff(fact_1929_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),X2: B,G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ~ pp(aa(set(B),bool,member(B,X2),A3))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),insert(B,X2),A3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3)) ) ) ) ) ).

% prod.insert
tff(fact_1930_filtermap__filtermap,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(B,A),G: fun(C,B),F: filter(C)] : ( filtermap(B,A,F2,filtermap(C,B,G,F)) = filtermap(C,A,aa(fun(C,B),fun(C,A),aTP_Lamp_cc(fun(B,A),fun(fun(C,B),fun(C,A)),F2),G),F) ) ).

% filtermap_filtermap
tff(fact_1931_filtermap__ident,axiom,
    ! [A: $tType,F: filter(A)] : ( filtermap(A,A,aTP_Lamp_bk(A,A),F) = F ) ).

% filtermap_ident
tff(fact_1932_sum_Oswap,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,fun(C,A)),B2: set(C),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(set(C),fun(B,A),aTP_Lamp_oj(fun(B,fun(C,A)),fun(set(C),fun(B,A)),G),B2)),A3) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(set(B),fun(C,A),aTP_Lamp_ol(fun(B,fun(C,A)),fun(set(B),fun(C,A)),G),A3)),B2) ) ) ).

% sum.swap
tff(fact_1933_prod_Oswap,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,fun(C,A)),B2: set(C),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(set(C),fun(B,A),aTP_Lamp_om(fun(B,fun(C,A)),fun(set(C),fun(B,A)),G),B2)),A3) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),aa(set(B),fun(C,A),aTP_Lamp_oo(fun(B,fun(C,A)),fun(set(B),fun(C,A)),G),A3)),B2) ) ) ).

% prod.swap
tff(fact_1934_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),A3: set(B)] :
          ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) != one_one(A) )
         => ~ ! [A5: B] :
                ( pp(aa(set(B),bool,member(B,A5),A3))
               => ( aa(B,A,G,A5) = one_one(A) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
tff(fact_1935_prod_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),G: fun(B,A)] :
          ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),A3))
             => ( aa(B,A,G,X) = one_one(A) ) )
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) = one_one(A) ) ) ) ).

% prod.neutral
tff(fact_1936_prod_Ocartesian__product,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,fun(C,A)),B2: set(C),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(set(C),fun(B,A),aTP_Lamp_om(fun(B,fun(C,A)),fun(set(C),fun(B,A)),G),B2)),A3) = aa(set(product_prod(B,C)),A,aa(fun(product_prod(B,C),A),fun(set(product_prod(B,C)),A),groups7121269368397514597t_prod(product_prod(B,C),A),aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),G)),product_Sigma(B,C,A3,aTP_Lamp_eq(set(C),fun(B,set(C)),B2))) ) ) ).

% prod.cartesian_product
tff(fact_1937_sum_Ocartesian__product,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,fun(C,A)),B2: set(C),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(set(C),fun(B,A),aTP_Lamp_oj(fun(B,fun(C,A)),fun(set(C),fun(B,A)),G),B2)),A3) = aa(set(product_prod(B,C)),A,aa(fun(product_prod(B,C),A),fun(set(product_prod(B,C)),A),groups7311177749621191930dd_sum(product_prod(B,C),A),aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),G)),product_Sigma(B,C,A3,aTP_Lamp_eq(set(C),fun(B,set(C)),B2))) ) ) ).

% sum.cartesian_product
tff(fact_1938_prod_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [B2: set(set(B)),G: fun(B,A)] :
          ( ! [X: set(B)] :
              ( pp(aa(set(set(B)),bool,member(set(B),X),B2))
             => pp(aa(set(B),bool,finite_finite2(B),X)) )
         => ( ! [A15: set(B)] :
                ( pp(aa(set(set(B)),bool,member(set(B),A15),B2))
               => ! [A24: set(B)] :
                    ( pp(aa(set(set(B)),bool,member(set(B),A24),B2))
                   => ( ( A15 != A24 )
                     => ! [X: B] :
                          ( pp(aa(set(B),bool,member(B,X),A15))
                         => ( pp(aa(set(B),bool,member(B,X),A24))
                           => ( aa(B,A,G,X) = one_one(A) ) ) ) ) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B2)) = aa(set(set(B)),A,aa(fun(B,A),fun(set(set(B)),A),aa(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A)),comp(fun(set(B),A),fun(set(set(B)),A),fun(B,A),groups7121269368397514597t_prod(set(B),A)),groups7121269368397514597t_prod(B,A)),G),B2) ) ) ) ) ).

% prod.Union_comp
tff(fact_1939_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [K5: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),K5))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),aa(B,A,G,I3))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),K5)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),K5))) ) ) ).

% sum_mono
tff(fact_1940_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),H2: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_mv(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2)),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),A3)) ) ) ).

% prod.distrib
tff(fact_1941_prod_Oswap__restrict,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),B2: set(C),G: fun(B,fun(C,A)),R: fun(B,fun(C,bool))] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(C),bool,finite_finite2(C),B2))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,fun(C,bool)),fun(B,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A)),aTP_Lamp_oq(set(C),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A))),B2),G),R)),A3) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),aa(fun(B,fun(C,bool)),fun(C,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A)),aTP_Lamp_os(set(B),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A))),A3),G),R)),B2) ) ) ) ) ).

% prod.swap_restrict
tff(fact_1942_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),H2: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_mg(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H2),A3)) ) ) ).

% sum.distrib
tff(fact_1943_sum__product,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( semiring_0(B)
     => ! [F2: fun(A,B),A3: set(A),G: fun(C,B),B2: set(C)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),B2)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(set(C),fun(A,B),aa(fun(C,B),fun(set(C),fun(A,B)),aTP_Lamp_ou(fun(A,B),fun(fun(C,B),fun(set(C),fun(A,B))),F2),G),B2)),A3) ) ) ).

% sum_product
tff(fact_1944_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [F2: fun(B,A),A3: set(B),R2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),R2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_ov(fun(B,A),fun(A,fun(B,A)),F2),R2)),A3) ) ) ).

% sum_distrib_right
tff(fact_1945_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [R2: A,F2: fun(B,A),A3: set(B)] : ( aa(A,A,aa(A,fun(A,A),times_times(A),R2),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_ow(A,fun(fun(B,A),fun(B,A)),R2),F2)),A3) ) ) ).

% sum_distrib_left
tff(fact_1946_sum__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(B,A),G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_ox(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)) ) ) ).

% sum_subtractf
tff(fact_1947_sum_Oswap__restrict,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),B2: set(C),G: fun(B,fun(C,A)),R: fun(B,fun(C,bool))] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(C),bool,finite_finite2(C),B2))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,fun(C,bool)),fun(B,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A)),aTP_Lamp_oy(set(C),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A))),B2),G),R)),A3) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(fun(B,fun(C,bool)),fun(C,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A)),aTP_Lamp_oz(set(B),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A))),A3),G),R)),B2) ) ) ) ) ).

% sum.swap_restrict
tff(fact_1948_sum__negf,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_pa(fun(B,A),fun(B,A),F2)),A3) = aa(A,A,uminus_uminus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)) ) ) ).

% sum_negf
tff(fact_1949_filtermap__bot__iff,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),F: filter(B)] :
      ( ( filtermap(B,A,F2,F) = bot_bot(filter(A)) )
    <=> ( F = bot_bot(filter(B)) ) ) ).

% filtermap_bot_iff
tff(fact_1950_prod_Oreindex__bij__betw,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [H2: fun(B,C),S: set(B),T2: set(C),G: fun(C,A)] :
          ( bij_betw(B,C,H2,S,T2)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(C,A),fun(B,A),aTP_Lamp_pb(fun(B,C),fun(fun(C,A),fun(B,A)),H2),G)),S) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),G),T2) ) ) ) ).

% prod.reindex_bij_betw
tff(fact_1951_sum_Oreindex__bij__betw,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [H2: fun(B,C),S: set(B),T2: set(C),G: fun(C,A)] :
          ( bij_betw(B,C,H2,S,T2)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(C,A),fun(B,A),aTP_Lamp_pc(fun(B,C),fun(fun(C,A),fun(B,A)),H2),G)),S) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),G),T2) ) ) ) ).

% sum.reindex_bij_betw
tff(fact_1952_prod_OSigma,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),B2: fun(B,set(C)),G: fun(B,fun(C,A))] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),A3))
               => pp(aa(set(C),bool,finite_finite2(C),aa(B,set(C),B2,X))) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,fun(C,A)),fun(B,A),aTP_Lamp_pd(fun(B,set(C)),fun(fun(B,fun(C,A)),fun(B,A)),B2),G)),A3) = aa(set(product_prod(B,C)),A,aa(fun(product_prod(B,C),A),fun(set(product_prod(B,C)),A),groups7121269368397514597t_prod(product_prod(B,C),A),aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),G)),product_Sigma(B,C,A3,B2)) ) ) ) ) ).

% prod.Sigma
tff(fact_1953_sum_OSigma,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),B2: fun(B,set(C)),G: fun(B,fun(C,A))] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),A3))
               => pp(aa(set(C),bool,finite_finite2(C),aa(B,set(C),B2,X))) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,fun(C,A)),fun(B,A),aTP_Lamp_pe(fun(B,set(C)),fun(fun(B,fun(C,A)),fun(B,A)),B2),G)),A3) = aa(set(product_prod(B,C)),A,aa(fun(product_prod(B,C),A),fun(set(product_prod(B,C)),A),groups7311177749621191930dd_sum(product_prod(B,C),A),aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),G)),product_Sigma(B,C,A3,B2)) ) ) ) ) ).

% sum.Sigma
tff(fact_1954_eventually__filtermap,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F2: fun(B,A),F: filter(B)] :
      ( eventually(A,P,filtermap(B,A,F2,F))
    <=> eventually(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_ns(fun(A,bool),fun(fun(B,A),fun(B,bool)),P),F2),F) ) ).

% eventually_filtermap
tff(fact_1955_prod_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C3: set(set(B)),G: fun(B,A)] :
          ( ! [X: set(B)] :
              ( pp(aa(set(set(B)),bool,member(set(B),X),C3))
             => pp(aa(set(B),bool,finite_finite2(B),X)) )
         => ( ! [X: set(B)] :
                ( pp(aa(set(set(B)),bool,member(set(B),X),C3))
               => ! [Xa4: set(B)] :
                    ( pp(aa(set(set(B)),bool,member(set(B),Xa4),C3))
                   => ( ( X != Xa4 )
                     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X),Xa4) = bot_bot(set(B)) ) ) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3)) = aa(set(set(B)),A,aa(fun(B,A),fun(set(set(B)),A),aa(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A)),comp(fun(set(B),A),fun(set(set(B)),A),fun(B,A),groups7121269368397514597t_prod(set(B),A)),groups7121269368397514597t_prod(B,A)),G),C3) ) ) ) ) ).

% prod.Union_disjoint
tff(fact_1956_sum_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [C3: set(set(B)),G: fun(B,A)] :
          ( ! [X: set(B)] :
              ( pp(aa(set(set(B)),bool,member(set(B),X),C3))
             => pp(aa(set(B),bool,finite_finite2(B),X)) )
         => ( ! [X: set(B)] :
                ( pp(aa(set(set(B)),bool,member(set(B),X),C3))
               => ! [Xa4: set(B)] :
                    ( pp(aa(set(set(B)),bool,member(set(B),Xa4),C3))
                   => ( ( X != Xa4 )
                     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X),Xa4) = bot_bot(set(B)) ) ) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3)) = aa(set(set(B)),A,aa(fun(B,A),fun(set(set(B)),A),aa(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A)),comp(fun(set(B),A),fun(set(set(B)),A),fun(B,A),groups7311177749621191930dd_sum(set(B),A)),groups7311177749621191930dd_sum(B,A)),G),C3) ) ) ) ) ).

% sum.Union_disjoint
tff(fact_1957_filterlim__filtermap,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(A,B),F12: filter(B),G: fun(C,A),F23: filter(C)] :
      ( filterlim(A,B,F2,F12,filtermap(C,A,G,F23))
    <=> filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_nc(fun(A,B),fun(fun(C,A),fun(C,B)),F2),G),F12,F23) ) ).

% filterlim_filtermap
tff(fact_1958_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A3: set(B),F2: fun(B,A)] :
          ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(B,A,F2,X))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3))) ) ) ).

% prod_ge_1
tff(fact_1959_prod_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),G: fun(B,A),P: fun(B,bool)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(fun(B,bool),set(B),collect(B),aa(fun(B,bool),fun(B,bool),aTP_Lamp_pf(set(B),fun(fun(B,bool),fun(B,bool)),A3),P))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,bool),fun(B,A),aTP_Lamp_pg(fun(B,A),fun(fun(B,bool),fun(B,A)),G),P)),A3) ) ) ) ).

% prod.inter_filter
tff(fact_1960_prod_Oimage__gen,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S: set(B),H2: fun(B,A),G: fun(B,C)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),S) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),aa(fun(B,C),fun(C,A),aa(fun(B,A),fun(fun(B,C),fun(C,A)),aTP_Lamp_pi(set(B),fun(fun(B,A),fun(fun(B,C),fun(C,A))),S),H2),G)),aa(set(B),set(C),image2(B,C,G),S)) ) ) ) ).

% prod.image_gen
tff(fact_1961_sum_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),G: fun(B,A),P: fun(B,bool)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(fun(B,bool),set(B),collect(B),aa(fun(B,bool),fun(B,bool),aTP_Lamp_pf(set(B),fun(fun(B,bool),fun(B,bool)),A3),P))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,bool),fun(B,A),aTP_Lamp_pj(fun(B,A),fun(fun(B,bool),fun(B,A)),G),P)),A3) ) ) ) ).

% sum.inter_filter
tff(fact_1962_sum_Oimage__gen,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [S: set(B),H2: fun(B,A),G: fun(B,C)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H2),S) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(fun(B,C),fun(C,A),aa(fun(B,A),fun(fun(B,C),fun(C,A)),aTP_Lamp_pk(set(B),fun(fun(B,A),fun(fun(B,C),fun(C,A))),S),H2),G)),aa(set(B),set(C),image2(B,C,G),S)) ) ) ) ).

% sum.image_gen
tff(fact_1963_prod_Oimage__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),A3: set(B)] :
          ( inj_on(B,A,G,A3)
         => ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7121269368397514597t_prod(A,A),aTP_Lamp_pl(A,A)),aa(set(B),set(A),image2(B,A,G),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) ) ) ) ).

% prod.image_eq
tff(fact_1964_sum_Oimage__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),A3: set(B)] :
          ( inj_on(B,A,G,A3)
         => ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_pm(A,A)),aa(set(B),set(A),image2(B,A,G),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3) ) ) ) ).

% sum.image_eq
tff(fact_1965_trivial__limit__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( at_bot(A) != bot_bot(filter(A)) ) ) ).

% trivial_limit_at_bot_linorder
tff(fact_1966_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A3: set(B),F2: fun(B,A)] :
          ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),A3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,X)))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X)),one_one(A))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3)),one_one(A))) ) ) ).

% prod_le_1
tff(fact_1967_eventually__at__bot__not__equal,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_bot(A) )
     => ! [C2: A] : eventually(A,aTP_Lamp_pn(A,fun(A,bool),C2),at_bot(A)) ) ).

% eventually_at_bot_not_equal
tff(fact_1968_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [R: fun(A,fun(A,bool)),S: set(B),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),R,one_one(A)),one_one(A)))
         => ( ! [X12: A,Y1: A,X23: A,Y22: A] :
                ( ( pp(aa(A,bool,aa(A,fun(A,bool),R,X12),X23))
                  & pp(aa(A,bool,aa(A,fun(A,bool),R,Y1),Y22)) )
               => pp(aa(A,bool,aa(A,fun(A,bool),R,aa(A,A,aa(A,fun(A,A),times_times(A),X12),Y1)),aa(A,A,aa(A,fun(A,A),times_times(A),X23),Y22))) )
           => ( pp(aa(set(B),bool,finite_finite2(B),S))
             => ( ! [X: B] :
                    ( pp(aa(set(B),bool,member(B,X),S))
                   => pp(aa(A,bool,aa(A,fun(A,bool),R,aa(B,A,H2,X)),aa(B,A,G,X))) )
               => pp(aa(A,bool,aa(A,fun(A,bool),R,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),S)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S))) ) ) ) ) ) ).

% prod.related
tff(fact_1969_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),X2: B,G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ( pp(aa(set(B),bool,member(B,X2),A3))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),insert(B,X2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) ) )
            & ( ~ pp(aa(set(B),bool,member(B,X2),A3))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),insert(B,X2),A3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3)) ) ) ) ) ) ).

% prod.insert_if
tff(fact_1970_filtermap__inf,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),F12: filter(B),F23: filter(B)] : pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),filtermap(B,A,F2,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F12),F23))),aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),filtermap(B,A,F2,F12)),filtermap(B,A,F2,F23)))) ).

% filtermap_inf
tff(fact_1971_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [S3: set(B),T4: set(C),S: set(B),I2: fun(C,B),J2: fun(B,C),T2: set(C),G: fun(B,A),H2: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S3))
         => ( pp(aa(set(C),bool,finite_finite2(C),T4))
           => ( ! [A5: B] :
                  ( pp(aa(set(B),bool,member(B,A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),S3)))
                 => ( aa(C,B,I2,aa(B,C,J2,A5)) = A5 ) )
             => ( ! [A5: B] :
                    ( pp(aa(set(B),bool,member(B,A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),S3)))
                   => pp(aa(set(C),bool,member(C,aa(B,C,J2,A5)),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),T4))) )
               => ( ! [B4: C] :
                      ( pp(aa(set(C),bool,member(C,B4),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),T4)))
                     => ( aa(B,C,J2,aa(C,B,I2,B4)) = B4 ) )
                 => ( ! [B4: C] :
                        ( pp(aa(set(C),bool,member(C,B4),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),T4)))
                       => pp(aa(set(B),bool,member(B,aa(C,B,I2,B4)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),S3))) )
                   => ( ! [A5: B] :
                          ( pp(aa(set(B),bool,member(B,A5),S3))
                         => ( aa(B,A,G,A5) = one_one(A) ) )
                     => ( ! [B4: C] :
                            ( pp(aa(set(C),bool,member(C,B4),T4))
                           => ( aa(C,A,H2,B4) = one_one(A) ) )
                       => ( ! [A5: B] :
                              ( pp(aa(set(B),bool,member(B,A5),S))
                             => ( aa(C,A,H2,aa(B,C,J2,A5)) = aa(B,A,G,A5) ) )
                         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),H2),T2) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
tff(fact_1972_sum__diff1__nat,axiom,
    ! [A: $tType,A4: A,A3: set(A),F2: fun(A,nat)] :
      ( ( pp(aa(set(A),bool,member(A,A4),A3))
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3)),aa(A,nat,F2,A4)) ) )
      & ( ~ pp(aa(set(A),bool,member(A,A4),A3))
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3) ) ) ) ).

% sum_diff1_nat
tff(fact_1973_filtermap__fun__inverse,axiom,
    ! [B: $tType,A: $tType,G: fun(A,B),F: filter(B),G4: filter(A),F2: fun(B,A)] :
      ( filterlim(A,B,G,F,G4)
     => ( filterlim(B,A,F2,G4,F)
       => ( eventually(A,aa(fun(B,A),fun(A,bool),aTP_Lamp_po(fun(A,B),fun(fun(B,A),fun(A,bool)),G),F2),G4)
         => ( filtermap(B,A,F2,F) = G4 ) ) ) ) ).

% filtermap_fun_inverse
tff(fact_1974_sum__Un__nat,axiom,
    ! [A: $tType,A3: set(A),B2: set(A),F2: fun(A,nat)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(A),bool,finite_finite2(A),B2))
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),B2))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))) ) ) ) ).

% sum_Un_nat
tff(fact_1975_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [S2: set(B),F2: fun(B,A),B2: A,I2: B] :
          ( pp(aa(set(B),bool,finite_finite2(B),S2))
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,member(B,I3),S2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,I3))) )
           => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),S2) = B2 )
             => ( pp(aa(set(B),bool,member(B,I2),S2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I2)),B2)) ) ) ) ) ) ).

% sum_nonneg_leq_bound
tff(fact_1976_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [S2: set(B),F2: fun(B,A),I2: B] :
          ( pp(aa(set(B),bool,finite_finite2(B),S2))
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,member(B,I3),S2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,I3))) )
           => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),S2) = zero_zero(A) )
             => ( pp(aa(set(B),bool,member(B,I2),S2))
               => ( aa(B,A,F2,I2) = zero_zero(A) ) ) ) ) ) ) ).

% sum_nonneg_0
tff(fact_1977_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S: set(B),T2: set(C),G: fun(B,C),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( pp(aa(set(C),bool,finite_finite2(C),T2))
           => ( pp(aa(set(C),bool,aa(set(C),fun(set(C),bool),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,G),S)),T2))
             => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),aa(fun(B,A),fun(C,A),aa(fun(B,C),fun(fun(B,A),fun(C,A)),aTP_Lamp_pp(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))),S),G),H2)),T2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),S) ) ) ) ) ) ).

% prod.group
tff(fact_1978_prod_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),G: fun(B,A),B2: set(B)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(set(B),fun(B,A),aTP_Lamp_pq(fun(B,A),fun(set(B),fun(B,A)),G),B2)),A3) ) ) ) ).

% prod.inter_restrict
tff(fact_1979_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(fun(B,bool),set(B),collect(B),aTP_Lamp_pr(fun(B,A),fun(B,bool),G)))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) ) ) ) ).

% prod.setdiff_irrelevant
tff(fact_1980_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [S: set(B),T2: set(C),G: fun(B,C),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( pp(aa(set(C),bool,finite_finite2(C),T2))
           => ( pp(aa(set(C),bool,aa(set(C),fun(set(C),bool),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,G),S)),T2))
             => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(fun(B,A),fun(C,A),aa(fun(B,C),fun(fun(B,A),fun(C,A)),aTP_Lamp_ps(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))),S),G),H2)),T2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H2),S) ) ) ) ) ) ).

% sum.group
tff(fact_1981_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),G: fun(B,A),B2: set(B)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(set(B),fun(B,A),aTP_Lamp_pt(fun(B,A),fun(set(B),fun(B,A)),G),B2)),A3) ) ) ) ).

% sum.inter_restrict
tff(fact_1982_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(fun(B,bool),set(B),collect(B),aTP_Lamp_pu(fun(B,A),fun(B,bool),G)))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3) ) ) ) ).

% sum.setdiff_irrelevant
tff(fact_1983_filtermap__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(B,A),F: fun(C,filter(B)),B2: set(C)] : ( filtermap(B,A,F2,aa(set(filter(B)),filter(B),complete_Sup_Sup(filter(B)),aa(set(C),set(filter(B)),image2(C,filter(B),F),B2))) = aa(set(filter(A)),filter(A),complete_Sup_Sup(filter(A)),aa(set(C),set(filter(A)),image2(C,filter(A),aa(fun(C,filter(B)),fun(C,filter(A)),aTP_Lamp_pv(fun(B,A),fun(fun(C,filter(B)),fun(C,filter(A))),F2),F)),B2)) ) ).

% filtermap_SUP
tff(fact_1984_sum_OG__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [I: set(B),P5: fun(B,A)] :
          ( ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_lk(set(B),fun(fun(B,A),fun(B,bool)),I),P5))))
           => ( groups1027152243600224163dd_sum(B,A,P5,I) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),P5),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_lk(set(B),fun(fun(B,A),fun(B,bool)),I),P5))) ) )
          & ( ~ pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_lk(set(B),fun(fun(B,A),fun(B,bool)),I),P5))))
           => ( groups1027152243600224163dd_sum(B,A,P5,I) = zero_zero(A) ) ) ) ) ).

% sum.G_def
tff(fact_1985_prod_OG__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [I: set(B),P5: fun(B,A)] :
          ( ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_li(set(B),fun(fun(B,A),fun(B,bool)),I),P5))))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P5),I) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),P5),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_li(set(B),fun(fun(B,A),fun(B,bool)),I),P5))) ) )
          & ( ~ pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_li(set(B),fun(fun(B,A),fun(B,bool)),I),P5))))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P5),I) = one_one(A) ) ) ) ) ).

% prod.G_def
tff(fact_1986_eventually__map__filter__on,axiom,
    ! [B: $tType,A: $tType,X5: set(A),F: filter(A),P: fun(B,bool),F2: fun(A,B)] :
      ( eventually(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),X5),F)
     => ( eventually(B,P,map_filter_on(A,B,X5,F2,F))
      <=> eventually(A,aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),aTP_Lamp_pw(set(A),fun(fun(B,bool),fun(fun(A,B),fun(A,bool))),X5),P),F2),F) ) ) ).

% eventually_map_filter_on
tff(fact_1987_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),H2: fun(B,C),G: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ! [X: B,Y2: B] :
                ( pp(aa(set(B),bool,member(B,X),A3))
               => ( pp(aa(set(B),bool,member(B,Y2),A3))
                 => ( ( X != Y2 )
                   => ( ( aa(B,C,H2,X) = aa(B,C,H2,Y2) )
                     => ( aa(C,A,G,aa(B,C,H2,X)) = one_one(A) ) ) ) ) )
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),G),aa(set(B),set(C),image2(B,C,H2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,C),fun(B,A),comp(C,A,B,G),H2)),A3) ) ) ) ) ).

% prod.reindex_nontrivial
tff(fact_1988_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [B2: set(B),A3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B2),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),A3))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),B2)) ) ) ) ) ).

% prod.subset_diff
tff(fact_1989_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C3: set(B),A3: set(B),B2: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),C3))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A3),C3))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B2),C3))
             => ( ! [A5: B] :
                    ( pp(aa(set(B),bool,member(B,A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),A3)))
                   => ( aa(B,A,G,A5) = one_one(A) ) )
               => ( ! [B4: B] :
                      ( pp(aa(set(B),bool,member(B,B4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),B2)))
                     => ( aa(B,A,H2,B4) = one_one(A) ) )
                 => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),B2) )
                  <=> ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),C3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),C3) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
tff(fact_1990_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C3: set(B),A3: set(B),B2: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),C3))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A3),C3))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B2),C3))
             => ( ! [A5: B] :
                    ( pp(aa(set(B),bool,member(B,A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),A3)))
                   => ( aa(B,A,G,A5) = one_one(A) ) )
               => ( ! [B4: B] :
                      ( pp(aa(set(B),bool,member(B,B4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),B2)))
                     => ( aa(B,A,H2,B4) = one_one(A) ) )
                 => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),C3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),C3) )
                   => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),B2) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
tff(fact_1991_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T2: set(B),S: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),T2))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S),T2))
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S)))
                 => ( aa(B,A,G,X) = one_one(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),T2) ) ) ) ) ) ).

% prod.mono_neutral_left
tff(fact_1992_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T2: set(B),S: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),T2))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S),T2))
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S)))
                 => ( aa(B,A,G,X) = one_one(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),T2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S) ) ) ) ) ) ).

% prod.mono_neutral_right
tff(fact_1993_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T2: set(B),S: set(B),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),T2))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S),T2))
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S)))
                 => ( aa(B,A,H2,X) = one_one(A) ) )
             => ( ! [X: B] :
                    ( pp(aa(set(B),bool,member(B,X),S))
                   => ( aa(B,A,G,X) = aa(B,A,H2,X) ) )
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),T2) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
tff(fact_1994_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T2: set(B),S: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),T2))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S),T2))
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S)))
                 => ( aa(B,A,G,X) = one_one(A) ) )
             => ( ! [X: B] :
                    ( pp(aa(set(B),bool,member(B,X),S))
                   => ( aa(B,A,G,X) = aa(B,A,H2,X) ) )
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),T2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),S) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
tff(fact_1995_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),B2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),B2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),B2)) ) ) ) ) ).

% prod.union_inter
tff(fact_1996_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),G: fun(B,A),B2: set(B)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))) ) ) ) ).

% prod.Int_Diff
tff(fact_1997_prod_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T2: set(B),S: set(B),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),T2))
         => ( pp(aa(set(B),bool,finite_finite2(B),S))
           => ( ! [I3: B] :
                  ( pp(aa(set(B),bool,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S)))
                 => ( aa(B,A,H2,I3) = one_one(A) ) )
             => ( ! [I3: B] :
                    ( pp(aa(set(B),bool,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),T2)))
                   => ( aa(B,A,G,I3) = one_one(A) ) )
               => ( ! [X: B] :
                      ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),T2)))
                     => ( aa(B,A,G,X) = aa(B,A,H2,X) ) )
                 => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),T2) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
tff(fact_1998_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [T2: set(B),S: set(B),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),T2))
         => ( pp(aa(set(B),bool,finite_finite2(B),S))
           => ( ! [I3: B] :
                  ( pp(aa(set(B),bool,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S)))
                 => ( aa(B,A,H2,I3) = zero_zero(A) ) )
             => ( ! [I3: B] :
                    ( pp(aa(set(B),bool,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),T2)))
                   => ( aa(B,A,G,I3) = zero_zero(A) ) )
               => ( ! [X: B] :
                      ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),T2)))
                     => ( aa(B,A,G,X) = aa(B,A,H2,X) ) )
                 => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),S) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H2),T2) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
tff(fact_1999_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),B2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),B2))
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),B2)) ) ) ) ) ).

% sum.union_inter
tff(fact_2000_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),G: fun(B,A),B2: set(B)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))) ) ) ) ).

% sum.Int_Diff
tff(fact_2001_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,times_times(A)),G),one_one(A),A3) ) ) ).

% prod.eq_fold
tff(fact_2002_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [S3: set(B),T4: set(C),H2: fun(B,C),S: set(B),T2: set(C),G: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S3))
         => ( pp(aa(set(C),bool,finite_finite2(C),T4))
           => ( bij_betw(B,C,H2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),S3),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),T4))
             => ( ! [A5: B] :
                    ( pp(aa(set(B),bool,member(B,A5),S3))
                   => ( aa(C,A,G,aa(B,C,H2,A5)) = one_one(A) ) )
               => ( ! [B4: C] :
                      ( pp(aa(set(C),bool,member(C,B4),T4))
                     => ( aa(C,A,G,B4) = one_one(A) ) )
                 => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(C,A),fun(B,A),aTP_Lamp_pb(fun(B,C),fun(fun(C,A),fun(B,A)),H2),G)),S) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),G),T2) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
tff(fact_2003_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [S3: set(B),T4: set(C),H2: fun(B,C),S: set(B),T2: set(C),G: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S3))
         => ( pp(aa(set(C),bool,finite_finite2(C),T4))
           => ( bij_betw(B,C,H2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),S3),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),T4))
             => ( ! [A5: B] :
                    ( pp(aa(set(B),bool,member(B,A5),S3))
                   => ( aa(C,A,G,aa(B,C,H2,A5)) = zero_zero(A) ) )
               => ( ! [B4: C] :
                      ( pp(aa(set(C),bool,member(C,B4),T4))
                     => ( aa(C,A,G,B4) = zero_zero(A) ) )
                 => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(C,A),fun(B,A),aTP_Lamp_pc(fun(B,C),fun(fun(C,A),fun(B,A)),H2),G)),S) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),G),T2) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
tff(fact_2004_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),P: fun(B,bool),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_px(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),H2),G)),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,bool),set(B),collect(B),P)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,bool),set(B),collect(B),P))))) ) ) ) ).

% prod.If_cases
tff(fact_2005_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),P: fun(B,bool),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_py(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),H2),G)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,bool),set(B),collect(B),P)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,bool),set(B),collect(B),P))))) ) ) ) ).

% sum.If_cases
tff(fact_2006_filtermap__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(B,A),F: fun(C,filter(B)),B2: set(C)] : pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),filtermap(B,A,F2,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(C),set(filter(B)),image2(C,filter(B),F),B2)))),aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(C),set(filter(A)),image2(C,filter(A),aa(fun(C,filter(B)),fun(C,filter(A)),aTP_Lamp_pv(fun(B,A),fun(fun(C,filter(B)),fun(C,filter(A))),F2),F)),B2)))) ).

% filtermap_INF
tff(fact_2007_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A] : eventually(A,aa(A,fun(A,bool),aTP_Lamp_pz(A,fun(A,bool)),C2),at_bot(A)) ) ).

% eventually_le_at_bot
tff(fact_2008_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),X2: B,G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,member(B,X2),A3))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ).

% prod.remove
tff(fact_2009_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),G: fun(B,A),X2: B] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),insert(B,X2),A3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ).

% prod.insert_remove
tff(fact_2010_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),B2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),B2))
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)))
                 => ( aa(B,A,G,X) = one_one(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),B2)) ) ) ) ) ) ).

% prod.union_inter_neutral
tff(fact_2011_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),B2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),B2))
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),B2)) ) ) ) ) ) ).

% prod.union_disjoint
tff(fact_2012_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),B2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),B2))
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)))
                 => ( aa(B,A,G,X) = zero_zero(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),B2)) ) ) ) ) ) ).

% sum.union_inter_neutral
tff(fact_2013_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),G: fun(B,A),X2: B] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),insert(B,X2),A3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,G,X2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ).

% sum.insert_remove
tff(fact_2014_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),X2: B,G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,member(B,X2),A3))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,G,X2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ).

% sum.remove
tff(fact_2015_sum__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [A3: set(B),A4: B,F2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ( pp(aa(set(B),bool,member(B,A4),A3))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),aa(B,A,F2,A4)) ) )
            & ( ~ pp(aa(set(B),bool,member(B,A4),A3))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3) ) ) ) ) ) ).

% sum_diff1
tff(fact_2016_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [A3: set(B),B2: set(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),B2))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ) ).

% sum_Un
tff(fact_2017_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),B2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),B2))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A3)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ) ).

% prod.union_diff2
tff(fact_2018_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),B2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),B2))
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),B2)) ) ) ) ) ) ).

% sum.union_disjoint
tff(fact_2019_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B),B2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),B2))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A3)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ) ).

% sum.union_diff2
tff(fact_2020_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B2: set(A),F2: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite2(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)))
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B2),A3)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))) ) ) ) ).

% sum_Un2
tff(fact_2021_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S: set(B),A4: B,B3: fun(B,A),C2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( ( pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_qa(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A4),B3),C2)),S) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,B3,A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) )
            & ( ~ pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_qa(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A4),B3),C2)),S) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) ) ) ) ) ) ).

% prod.delta_remove
tff(fact_2022_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [S: set(B),A4: B,B3: fun(B,A),C2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( ( pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_qb(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A4),B3),C2)),S) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,B3,A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) )
            & ( ~ pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_qb(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A4),B3),C2)),S) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) ) ) ) ) ) ).

% sum.delta_remove
tff(fact_2023_prod_OUNION__disjoint,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I: set(B),A3: fun(B,set(C)),G: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),I))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),I))
               => pp(aa(set(C),bool,finite_finite2(C),aa(B,set(C),A3,X))) )
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),I))
                 => ! [Xa4: B] :
                      ( pp(aa(set(B),bool,member(B,Xa4),I))
                     => ( ( X != Xa4 )
                       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A3,X)),aa(B,set(C),A3,Xa4)) = bot_bot(set(C)) ) ) ) )
             => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),G),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(C,A),fun(B,A),aTP_Lamp_qc(fun(B,set(C)),fun(fun(C,A),fun(B,A)),A3),G)),I) ) ) ) ) ) ).

% prod.UNION_disjoint
tff(fact_2024_sum_OUNION__disjoint,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [I: set(B),A3: fun(B,set(C)),G: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),I))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),I))
               => pp(aa(set(C),bool,finite_finite2(C),aa(B,set(C),A3,X))) )
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),I))
                 => ! [Xa4: B] :
                      ( pp(aa(set(B),bool,member(B,Xa4),I))
                     => ( ( X != Xa4 )
                       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A3,X)),aa(B,set(C),A3,Xa4)) = bot_bot(set(C)) ) ) ) )
             => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),G),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(C,A),fun(B,A),aTP_Lamp_qd(fun(B,set(C)),fun(fun(C,A),fun(B,A)),A3),G)),I) ) ) ) ) ) ).

% sum.UNION_disjoint
tff(fact_2025_at__bot__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ( at_bot(A) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image2(A,filter(A),aTP_Lamp_qe(A,filter(A))),top_top(set(A)))) ) ) ).

% at_bot_def
tff(fact_2026_sum__mult__sum__if__inj,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [F2: fun(A,B),G: fun(C,B),A3: set(A),B2: set(C)] :
          ( inj_on(product_prod(A,C),B,aa(fun(A,fun(C,B)),fun(product_prod(A,C),B),product_case_prod(A,C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_ot(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),F2),G)),product_Sigma(A,C,A3,aTP_Lamp_md(set(C),fun(A,set(C)),B2)))
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),B2)) = aa(set(B),B,aa(fun(B,B),fun(set(B),B),groups7311177749621191930dd_sum(B,B),id(B)),aa(fun(B,bool),set(B),collect(B),aa(set(C),fun(B,bool),aa(set(A),fun(set(C),fun(B,bool)),aa(fun(C,B),fun(set(A),fun(set(C),fun(B,bool))),aTP_Lamp_qf(fun(A,B),fun(fun(C,B),fun(set(A),fun(set(C),fun(B,bool)))),F2),G),A3),B2))) ) ) ) ).

% sum_mult_sum_if_inj
tff(fact_2027_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [A3: set(B),B2: set(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),B2))
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)))
                 => ( aa(B,A,F2,X) != zero_zero(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ) ) ).

% prod_Un
tff(fact_2028_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( semidom_divide(A)
     => ! [A3: set(B),F2: fun(B,A),A4: B] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ( aa(B,A,F2,A4) != zero_zero(A) )
           => ( ( pp(aa(set(B),bool,member(B,A4),A3))
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3)),aa(B,A,F2,A4)) ) )
              & ( ~ pp(aa(set(B),bool,member(B,A4),A3))
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3) ) ) ) ) ) ) ).

% prod_diff1
tff(fact_2029_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_idom(B)
     => ! [I: set(A),X2: fun(A,B),A4: fun(A,B),B3: B,Delta: B] :
          ( ! [I3: A] :
              ( pp(aa(set(A),bool,member(A,I3),I))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(A,B,X2,I3))) )
         => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),X2),I) = one_one(B) )
           => ( ! [I3: A] :
                  ( pp(aa(set(A),bool,member(A,I3),I))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A4,I3)),B3))),Delta)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_qg(fun(A,B),fun(fun(A,B),fun(A,B)),X2),A4)),I)),B3))),Delta)) ) ) ) ) ).

% convex_sum_bound_le
tff(fact_2030_at__bot__sub,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A] : ( at_bot(A) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image2(A,filter(A),aTP_Lamp_qh(A,filter(A))),aa(A,set(A),set_ord_atMost(A),C2))) ) ) ).

% at_bot_sub
tff(fact_2031_prod__filter__principal__singleton2,axiom,
    ! [B: $tType,A: $tType,F: filter(A),X2: B] : ( prod_filter(A,B,F,principal(B,aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))) = filtermap(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_ej(B,fun(A,product_prod(A,B))),X2),F) ) ).

% prod_filter_principal_singleton2
tff(fact_2032_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] : ( aa(A,A,abs_abs(A),aa(A,A,abs_abs(A),A4)) = aa(A,A,abs_abs(A),A4) ) ) ).

% abs_idempotent
tff(fact_2033_abs__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A] : ( aa(A,A,abs_abs(A),aa(A,A,abs_abs(A),A4)) = aa(A,A,abs_abs(A),A4) ) ) ).

% abs_abs
tff(fact_2034_div__0,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),zero_zero(A)),A4) = zero_zero(A) ) ) ).

% div_0
tff(fact_2035_div__by__0,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),zero_zero(A)) = zero_zero(A) ) ) ).

% div_by_0
tff(fact_2036_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B3: A,C2: A,A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),A4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)),C2) ) ) ).

% times_divide_eq_left
tff(fact_2037_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) ) ) ).

% divide_divide_eq_left
tff(fact_2038_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3) ) ) ).

% divide_divide_eq_right
tff(fact_2039_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2) ) ) ).

% times_divide_eq_right
tff(fact_2040_div__by__1,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),one_one(A)) = A4 ) ) ).

% div_by_1
tff(fact_2041_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] :
          ( ( zero_zero(A) = aa(A,A,abs_abs(A),A4) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% abs_0_eq
tff(fact_2042_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] :
          ( ( aa(A,A,abs_abs(A),A4) = zero_zero(A) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% abs_eq_0
tff(fact_2043_abs__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ( aa(A,A,abs_abs(A),zero_zero(A)) = zero_zero(A) ) ) ).

% abs_zero
tff(fact_2044_abs__0,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,abs_abs(A),zero_zero(A)) = zero_zero(A) ) ) ).

% abs_0
tff(fact_2045_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),B3))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),B3)) ) ) ).

% abs_add_abs
tff(fact_2046_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),A4)) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),A4) ) ) ).

% abs_mult_self_eq
tff(fact_2047_abs__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_1
tff(fact_2048_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),A4)) = aa(A,A,abs_abs(A),A4) ) ) ).

% abs_minus_cancel
tff(fact_2049_abs__minus,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),A4)) = aa(A,A,abs_abs(A),A4) ) ) ).

% abs_minus
tff(fact_2050_abs__sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [F2: fun(A,B),A3: set(A)] : ( aa(B,B,abs_abs(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aTP_Lamp_qi(fun(A,B),fun(A,B),F2)),A3)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aTP_Lamp_qi(fun(A,B),fun(A,B),F2)),A3) ) ) ).

% abs_sum_abs
tff(fact_2051_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( ( C2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) = zero_zero(A) ) )
          & ( ( C2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
tff(fact_2052_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
tff(fact_2053_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
tff(fact_2054_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
tff(fact_2055_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
tff(fact_2056_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),A4) = B3 ) ) ) ).

% nonzero_mult_div_cancel_left
tff(fact_2057_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [B3: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),B3) = A4 ) ) ) ).

% nonzero_mult_div_cancel_right
tff(fact_2058_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% zero_eq_1_divide_iff
tff(fact_2059_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4) = zero_zero(A) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% one_divide_eq_0_iff
tff(fact_2060_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,A4: A] :
          ( ( one_one(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4) )
        <=> ( ( A4 != zero_zero(A) )
            & ( A4 = B3 ) ) ) ) ).

% eq_divide_eq_1
tff(fact_2061_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,A4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4) = one_one(A) )
        <=> ( ( A4 != zero_zero(A) )
            & ( A4 = B3 ) ) ) ) ).

% divide_eq_eq_1
tff(fact_2062_divide__self__if,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A] :
          ( ( ( A4 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),A4) = zero_zero(A) ) )
          & ( ( A4 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),A4) = one_one(A) ) ) ) ) ).

% divide_self_if
tff(fact_2063_divide__self,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A] :
          ( ( A4 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),A4) = one_one(A) ) ) ) ).

% divide_self
tff(fact_2064_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A,B3: A] :
          ( ( one_one(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) )
        <=> ( ( B3 != zero_zero(A) )
            & ( A4 = B3 ) ) ) ) ).

% one_eq_divide_iff
tff(fact_2065_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) = one_one(A) )
        <=> ( ( B3 != zero_zero(A) )
            & ( A4 = B3 ) ) ) ) ).

% divide_eq_1_iff
tff(fact_2066_div__self,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A4: A] :
          ( ( A4 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),A4) = one_one(A) ) ) ) ).

% div_self
tff(fact_2067_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A4)),zero_zero(A)))
        <=> ( A4 = zero_zero(A) ) ) ) ).

% abs_le_zero_iff
tff(fact_2068_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A4)),A4))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4)) ) ) ).

% abs_le_self_iff
tff(fact_2069_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( aa(A,A,abs_abs(A),A4) = A4 ) ) ) ).

% abs_of_nonneg
tff(fact_2070_divide__minus1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),X2) ) ) ).

% divide_minus1
tff(fact_2071_abs__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),one_one(A))) = one_one(A) ) ) ).

% abs_neg_one
tff(fact_2072_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [F2: fun(A,B),A3: set(A)] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,abs_abs(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aTP_Lamp_qi(fun(A,B),fun(A,B),F2)),A3))) ) ).

% sum_abs
tff(fact_2073_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4)) ) ) ).

% zero_le_divide_1_iff
tff(fact_2074_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A))) ) ) ).

% divide_le_0_1_iff
tff(fact_2075_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B3) ) ) ) ).

% nonzero_divide_mult_cancel_left
tff(fact_2076_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B3: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4) ) ) ) ).

% nonzero_divide_mult_cancel_right
tff(fact_2077_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A)))
         => ( aa(A,A,abs_abs(A),A4) = aa(A,A,uminus_uminus(A),A4) ) ) ) ).

% abs_of_nonpos
tff(fact_2078_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [F2: fun(A,B),A3: set(A)] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aTP_Lamp_qi(fun(A,B),fun(A,B),F2)),A3))) ) ).

% sum_abs_ge_zero
tff(fact_2079_inj__divide__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A] :
          ( inj_on(A,A,aTP_Lamp_qj(A,fun(A,A),A4),top_top(set(A)))
        <=> ( A4 != zero_zero(A) ) ) ) ).

% inj_divide_right
tff(fact_2080_sum__subtractf__nat,axiom,
    ! [A: $tType,A3: set(A),G: fun(A,nat),F2: fun(A,nat)] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),A3))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,G,X)),aa(A,nat,F2,X))) )
     => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_qk(fun(A,nat),fun(fun(A,nat),fun(A,nat)),G),F2)),A3) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),G),A3)) ) ) ).

% sum_subtractf_nat
tff(fact_2081_prod__filter__assoc,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: filter(A),G4: filter(B),H9: filter(C)] : ( prod_filter(product_prod(A,B),C,prod_filter(A,B,F,G4),H9) = filtermap(product_prod(A,product_prod(B,C)),product_prod(product_prod(A,B),C),aa(fun(A,fun(product_prod(B,C),product_prod(product_prod(A,B),C))),fun(product_prod(A,product_prod(B,C)),product_prod(product_prod(A,B),C)),product_case_prod(A,product_prod(B,C),product_prod(product_prod(A,B),C)),aTP_Lamp_qm(A,fun(product_prod(B,C),product_prod(product_prod(A,B),C)))),prod_filter(A,product_prod(B,C),F,prod_filter(B,C,G4,H9))) ) ).

% prod_filter_assoc
tff(fact_2082_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A4)),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ).

% abs_le_D1
tff(fact_2083_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,abs_abs(A),A4))) ) ).

% abs_ge_self
tff(fact_2084_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A] :
          ( ( aa(A,A,abs_abs(A),A4) = zero_zero(A) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% abs_eq_0_iff
tff(fact_2085_abs__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A,B3: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),B3)) ) ) ).

% abs_mult
tff(fact_2086_abs__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_one
tff(fact_2087_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)) ) ) ).

% abs_minus_commute
tff(fact_2088_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X2: A,Y: A] :
          ( ( aa(A,A,abs_abs(A),X2) = aa(A,A,abs_abs(A),Y) )
        <=> ( ( X2 = Y )
            | ( X2 = aa(A,A,uminus_uminus(A),Y) ) ) ) ) ).

% abs_eq_iff
tff(fact_2089_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A,Y: A,Z2: A,W2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Z2),W2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),W2)) ) ) ).

% times_divide_times_eq
tff(fact_2090_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A,Y: A,Z2: A,W2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Z2),W2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),W2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)) ) ) ).

% divide_divide_times_eq
tff(fact_2091_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) ) ) ).

% divide_divide_eq_left'
tff(fact_2092_abs__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_field(A)
     => ! [F2: fun(B,A),A3: set(B)] : ( aa(A,A,abs_abs(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_qn(fun(B,A),fun(B,A),F2)),A3) ) ) ).

% abs_prod
tff(fact_2093_set_Oidentity,axiom,
    ! [A: $tType] : ( aa(fun(A,A),fun(set(A),set(A)),vimage(A,A),aTP_Lamp_bk(A,A)) = id(set(A)) ) ).

% set.identity
tff(fact_2094_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [F2: fun(B,A),A3: set(B),R2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),R2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_qo(fun(B,A),fun(A,fun(B,A)),F2),R2)),A3) ) ) ).

% sum_divide_distrib
tff(fact_2095_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [F2: fun(B,A),G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_qp(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3)) ) ) ).

% prod_dividef
tff(fact_2096_prod__filter__eq__bot,axiom,
    ! [A: $tType,B: $tType,A3: filter(A),B2: filter(B)] :
      ( ( prod_filter(A,B,A3,B2) = bot_bot(filter(product_prod(A,B))) )
    <=> ( ( A3 = bot_bot(filter(A)) )
        | ( B2 = bot_bot(filter(B)) ) ) ) ).

% prod_filter_eq_bot
tff(fact_2097_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,abs_abs(A),A4))) ) ).

% abs_ge_zero
tff(fact_2098_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),B3)))) ) ).

% abs_triangle_ineq
tff(fact_2099_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),B3))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)))) ) ).

% abs_triangle_ineq2
tff(fact_2100_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),B3)))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)))) ) ).

% abs_triangle_ineq3
tff(fact_2101_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),B3))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)))) ) ).

% abs_triangle_ineq2_sym
tff(fact_2102_abs__leI,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A4)),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A4)),B3)) ) ) ) ).

% abs_leI
tff(fact_2103_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A4)),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A4)),B3)) ) ) ).

% abs_le_D2
tff(fact_2104_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A4)),B3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A4)),B3)) ) ) ) ).

% abs_le_iff
tff(fact_2105_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A4)),aa(A,A,abs_abs(A),A4))) ) ).

% abs_ge_minus_self
tff(fact_2106_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z2: A,X2: A,W2: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z2 != zero_zero(A) )
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y) = aa(A,A,aa(A,fun(A,A),divide_divide(A),W2),Z2) )
            <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z2) = aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y) ) ) ) ) ) ).

% frac_eq_eq
tff(fact_2107_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B3: A,C2: A,A4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) = A4 )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( B3 = aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( A4 = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq
tff(fact_2108_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) = B3 ) )
            & ( ( C2 = zero_zero(A) )
             => ( A4 = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq
tff(fact_2109_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B3: A,A4: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( B3 = aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) = A4 ) ) ) ) ).

% divide_eq_imp
tff(fact_2110_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) = B3 )
           => ( A4 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) ) ) ) ) ).

% eq_divide_imp
tff(fact_2111_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B3: A,A4: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) = A4 )
          <=> ( B3 = aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) ) ) ) ) ).

% nonzero_divide_eq_eq
tff(fact_2112_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( A4 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) = B3 ) ) ) ) ).

% nonzero_eq_divide_eq
tff(fact_2113_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B3: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) = one_one(A) )
          <=> ( A4 = B3 ) ) ) ) ).

% right_inverse_eq
tff(fact_2114_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ordered_ring_abs(A)
     => ! [A4: A,B3: A] :
          ( ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
              | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3))
              | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),zero_zero(A))) ) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),B3)) ) ) ) ).

% abs_eq_mult
tff(fact_2115_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X2))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),Y)),X2) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y),X2)) ) ) ) ).

% abs_mult_pos
tff(fact_2116_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,abs_abs(A),A4))),zero_zero(A))) ) ).

% abs_minus_le_zero
tff(fact_2117_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,abs_abs(A),A4) = B3 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3))
            & ( ( A4 = B3 )
              | ( A4 = aa(A,A,uminus_uminus(A),B3) ) ) ) ) ) ).

% abs_eq_iff'
tff(fact_2118_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = aa(A,A,abs_abs(A),B3) )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
            & ( ( B3 = A4 )
              | ( B3 = aa(A,A,uminus_uminus(A),A4) ) ) ) ) ) ).

% eq_abs_iff'
tff(fact_2119_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),B3)))) ) ).

% abs_triangle_ineq4
tff(fact_2120_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A,B3: A,C2: A,D3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),D3)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),C2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),D3))))) ) ).

% abs_diff_triangle_ineq
tff(fact_2121_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,A4: A,R2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),A4))),R2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),R2)),X2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),R2))) ) ) ) ).

% abs_diff_le_iff
tff(fact_2122_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S: set(A),A4: A] :
          ( ( S != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),S))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X)),A4)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(set(A),A,complete_Sup_Sup(A),S))),A4)) ) ) ) ).

% cSup_abs_le
tff(fact_2123_prod__filter__mono__iff,axiom,
    ! [A: $tType,B: $tType,A3: filter(A),B2: filter(B),C3: filter(A),D2: filter(B)] :
      ( ( A3 != bot_bot(filter(A)) )
     => ( ( B2 != bot_bot(filter(B)) )
       => ( pp(aa(filter(product_prod(A,B)),bool,aa(filter(product_prod(A,B)),fun(filter(product_prod(A,B)),bool),ord_less_eq(filter(product_prod(A,B))),prod_filter(A,B,A3,B2)),prod_filter(A,B,C3,D2)))
        <=> ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),A3),C3))
            & pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),B2),D2)) ) ) ) ) ).

% prod_filter_mono_iff
tff(fact_2124_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),Z2)),B3) = B3 ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),Z2)),B3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),Z2))),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(2)
tff(fact_2125_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),Z2)) = A4 ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),Z2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),Z2)),B3)),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(1)
tff(fact_2126_add__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z2: A,X2: A,W2: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W2),Z2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)) ) ) ) ) ).

% add_frac_eq
tff(fact_2127_add__frac__num,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,X2: A,Z2: A] :
          ( ( Y != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y)),Z2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y))),Y) ) ) ) ).

% add_frac_num
tff(fact_2128_add__num__frac,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z2: A,X2: A] :
          ( ( Y != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y))),Y) ) ) ) ).

% add_num_frac
tff(fact_2129_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z2)),Y)),Z2) ) ) ) ).

% add_divide_eq_iff
tff(fact_2130_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Z2)),Y) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2))),Z2) ) ) ) ).

% divide_add_eq_iff
tff(fact_2131_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),Z2)) = A4 ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),Z2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),Z2)),B3)),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(4)
tff(fact_2132_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z2: A,X2: A,W2: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W2),Z2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)) ) ) ) ) ).

% diff_frac_eq
tff(fact_2133_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z2)),Y)),Z2) ) ) ) ).

% diff_divide_eq_iff
tff(fact_2134_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Z2)),Y) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2))),Z2) ) ) ) ).

% divide_diff_eq_iff
tff(fact_2135_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4 = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) = aa(A,A,uminus_uminus(A),B3) ) )
            & ( ( C2 = zero_zero(A) )
             => ( A4 = zero_zero(A) ) ) ) ) ) ).

% eq_minus_divide_eq
tff(fact_2136_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B3: A,C2: A,A4: A] :
          ( ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)) = A4 )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,uminus_uminus(A),B3) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( A4 = zero_zero(A) ) ) ) ) ) ).

% minus_divide_eq_eq
tff(fact_2137_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B3: A,A4: A,C2: A] :
          ( ( B3 != zero_zero(A) )
         => ( ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)) = C2 )
          <=> ( aa(A,A,uminus_uminus(A),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
tff(fact_2138_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B3: A,C2: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => ( ( C2 = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3) = aa(A,A,uminus_uminus(A),A4) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
tff(fact_2139_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( B3 != zero_zero(A) )
            & ( A4 = aa(A,A,uminus_uminus(A),B3) ) ) ) ) ).

% divide_eq_minus_1_iff
tff(fact_2140_filterlim__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(A,B),G4: filter(B),F: filter(A),G: fun(A,C),H9: filter(C)] :
      ( filterlim(A,B,F2,G4,F)
     => ( filterlim(A,C,G,H9,F)
       => filterlim(A,product_prod(B,C),aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_qq(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),F2),G),prod_filter(B,C,G4,H9),F) ) ) ).

% filterlim_Pair
tff(fact_2141_filtermap__Pair,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(C,A),G: fun(C,B),F: filter(C)] : pp(aa(filter(product_prod(A,B)),bool,aa(filter(product_prod(A,B)),fun(filter(product_prod(A,B)),bool),ord_less_eq(filter(product_prod(A,B))),filtermap(C,product_prod(A,B),aa(fun(C,B),fun(C,product_prod(A,B)),aTP_Lamp_co(fun(C,A),fun(fun(C,B),fun(C,product_prod(A,B))),F2),G),F)),prod_filter(A,B,filtermap(C,A,F2,F),filtermap(C,B,G,F)))) ).

% filtermap_Pair
tff(fact_2142_principal__prod__principal,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] : ( prod_filter(A,B,principal(A,A3),principal(B,B2)) = principal(product_prod(A,B),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))) ) ).

% principal_prod_principal
tff(fact_2143_fst__diag__id,axiom,
    ! [A: $tType,Z2: A] : ( aa(A,A,aa(fun(A,product_prod(A,A)),fun(A,A),comp(product_prod(A,A),A,A,product_fst(A,A)),aTP_Lamp_hl(A,product_prod(A,A))),Z2) = aa(A,A,id(A),Z2) ) ).

% fst_diag_id
tff(fact_2144_snd__diag__id,axiom,
    ! [A: $tType,Z2: A] : ( aa(A,A,aa(fun(A,product_prod(A,A)),fun(A,A),comp(product_prod(A,A),A,A,product_snd(A,A)),aTP_Lamp_hl(A,product_prod(A,A))),Z2) = aa(A,A,id(A),Z2) ) ).

% snd_diag_id
tff(fact_2145_prod__filter__def,axiom,
    ! [A: $tType,B: $tType,F: filter(A),G4: filter(B)] : ( prod_filter(A,B,F,G4) = aa(set(filter(product_prod(A,B))),filter(product_prod(A,B)),complete_Inf_Inf(filter(product_prod(A,B))),aa(set(product_prod(fun(A,bool),fun(B,bool))),set(filter(product_prod(A,B))),image2(product_prod(fun(A,bool),fun(B,bool)),filter(product_prod(A,B)),aa(fun(fun(A,bool),fun(fun(B,bool),filter(product_prod(A,B)))),fun(product_prod(fun(A,bool),fun(B,bool)),filter(product_prod(A,B))),product_case_prod(fun(A,bool),fun(B,bool),filter(product_prod(A,B))),aTP_Lamp_qr(fun(A,bool),fun(fun(B,bool),filter(product_prod(A,B)))))),aa(fun(product_prod(fun(A,bool),fun(B,bool)),bool),set(product_prod(fun(A,bool),fun(B,bool))),collect(product_prod(fun(A,bool),fun(B,bool))),aa(fun(fun(A,bool),fun(fun(B,bool),bool)),fun(product_prod(fun(A,bool),fun(B,bool)),bool),product_case_prod(fun(A,bool),fun(B,bool),bool),aa(filter(B),fun(fun(A,bool),fun(fun(B,bool),bool)),aTP_Lamp_qs(filter(A),fun(filter(B),fun(fun(A,bool),fun(fun(B,bool),bool))),F),G4))))) ) ).

% prod_filter_def
tff(fact_2146_frac__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z2: A,X2: A,W2: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z2 != zero_zero(A) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W2),Z2)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2))),zero_zero(A))) ) ) ) ) ).

% frac_le_eq
tff(fact_2147_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Z2))),Y) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2))),Z2) ) ) ) ).

% minus_divide_add_eq_iff
tff(fact_2148_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),Z2))),B3) = B3 ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),Z2))),B3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),Z2))),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(3)
tff(fact_2149_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),Z2))),B3) = aa(A,A,uminus_uminus(A),B3) ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),Z2))),B3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),Z2))),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(6)
tff(fact_2150_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A4: A,B3: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),Z2)),B3) = aa(A,A,uminus_uminus(A),B3) ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),Z2)),B3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),Z2))),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(5)
tff(fact_2151_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Z2))),Y) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2))),Z2) ) ) ) ).

% minus_divide_diff_eq_iff
tff(fact_2152_eventually__prodI,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F: filter(A),Q: fun(B,bool),G4: filter(B)] :
      ( eventually(A,P,F)
     => ( eventually(B,Q,G4)
       => eventually(product_prod(A,B),aa(fun(B,bool),fun(product_prod(A,B),bool),aTP_Lamp_qt(fun(A,bool),fun(fun(B,bool),fun(product_prod(A,B),bool)),P),Q),prod_filter(A,B,F,G4)) ) ) ).

% eventually_prodI
tff(fact_2153_If__the__inv__into__f__f,axiom,
    ! [B: $tType,A: $tType,I2: A,C3: set(A),G: fun(A,B),X2: A] :
      ( pp(aa(set(A),bool,member(A,I2),C3))
     => ( inj_on(A,B,G,C3)
       => ( aa(A,A,aa(fun(A,B),fun(A,A),comp(B,A,A,aa(A,fun(B,A),aa(fun(A,B),fun(A,fun(B,A)),aTP_Lamp_qu(set(A),fun(fun(A,B),fun(A,fun(B,A))),C3),G),X2)),G),I2) = aa(A,A,id(A),I2) ) ) ) ).

% If_the_inv_into_f_f
tff(fact_2154_eventually__prod1,axiom,
    ! [A: $tType,B: $tType,B2: filter(A),P: fun(B,bool),A3: filter(B)] :
      ( ( B2 != bot_bot(filter(A)) )
     => ( eventually(product_prod(B,A),aa(fun(B,fun(A,bool)),fun(product_prod(B,A),bool),product_case_prod(B,A,bool),aTP_Lamp_qv(fun(B,bool),fun(B,fun(A,bool)),P)),prod_filter(B,A,A3,B2))
      <=> eventually(B,P,A3) ) ) ).

% eventually_prod1
tff(fact_2155_eventually__prod2,axiom,
    ! [A: $tType,B: $tType,A3: filter(A),P: fun(B,bool),B2: filter(B)] :
      ( ( A3 != bot_bot(filter(A)) )
     => ( eventually(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_qw(fun(B,bool),fun(A,fun(B,bool)),P)),prod_filter(A,B,A3,B2))
      <=> eventually(B,P,B2) ) ) ).

% eventually_prod2
tff(fact_2156_prod__filter__INF2,axiom,
    ! [C: $tType,B: $tType,A: $tType,J: set(A),A3: filter(B),B2: fun(A,filter(C))] :
      ( ( J != bot_bot(set(A)) )
     => ( prod_filter(B,C,A3,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(A),set(filter(C)),image2(A,filter(C),B2),J))) = aa(set(filter(product_prod(B,C))),filter(product_prod(B,C)),complete_Inf_Inf(filter(product_prod(B,C))),aa(set(A),set(filter(product_prod(B,C))),image2(A,filter(product_prod(B,C)),aa(fun(A,filter(C)),fun(A,filter(product_prod(B,C))),aTP_Lamp_qx(filter(B),fun(fun(A,filter(C)),fun(A,filter(product_prod(B,C)))),A3),B2)),J)) ) ) ).

% prod_filter_INF2
tff(fact_2157_prod__filter__INF1,axiom,
    ! [C: $tType,B: $tType,A: $tType,I: set(A),A3: fun(A,filter(B)),B2: filter(C)] :
      ( ( I != bot_bot(set(A)) )
     => ( prod_filter(B,C,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),A3),I)),B2) = aa(set(filter(product_prod(B,C))),filter(product_prod(B,C)),complete_Inf_Inf(filter(product_prod(B,C))),aa(set(A),set(filter(product_prod(B,C))),image2(A,filter(product_prod(B,C)),aa(filter(C),fun(A,filter(product_prod(B,C))),aTP_Lamp_qy(fun(A,filter(B)),fun(filter(C),fun(A,filter(product_prod(B,C)))),A3),B2)),I)) ) ) ).

% prod_filter_INF1
tff(fact_2158_prod__filter__INF,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType,I: set(A),J: set(B),A3: fun(A,filter(C)),B2: fun(B,filter(D))] :
      ( ( I != bot_bot(set(A)) )
     => ( ( J != bot_bot(set(B)) )
       => ( prod_filter(C,D,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(A),set(filter(C)),image2(A,filter(C),A3),I)),aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(B),set(filter(D)),image2(B,filter(D),B2),J))) = aa(set(filter(product_prod(C,D))),filter(product_prod(C,D)),complete_Inf_Inf(filter(product_prod(C,D))),aa(set(A),set(filter(product_prod(C,D))),image2(A,filter(product_prod(C,D)),aa(fun(B,filter(D)),fun(A,filter(product_prod(C,D))),aa(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D)))),aTP_Lamp_ra(set(B),fun(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D))))),J),A3),B2)),I)) ) ) ) ).

% prod_filter_INF
tff(fact_2159_scaling__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [U: A,V: A,R2: A,S2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),V))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),R2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),R2),S2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),U),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),R2),aa(A,A,aa(A,fun(A,A),minus_minus(A),V),U))),S2))),V)) ) ) ) ) ).

% scaling_mono
tff(fact_2160_prod__filter__principal__singleton,axiom,
    ! [A: $tType,B: $tType,X2: A,F: filter(B)] : ( prod_filter(A,B,principal(A,aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))),F) = filtermap(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),F) ) ).

% prod_filter_principal_singleton
tff(fact_2161_div__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B3: A,A4: A,C2: A] :
          ( ( B3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3))),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)) ) ) ) ).

% div_mult_self1
tff(fact_2162_div__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B3: A,A4: A,C2: A] :
          ( ( B3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2))),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)) ) ) ) ).

% div_mult_self2
tff(fact_2163_div__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B3: A,C2: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)),A4)),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)) ) ) ) ).

% div_mult_self3
tff(fact_2164_div__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B3: A,C2: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)),A4)),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)) ) ) ) ).

% div_mult_self4
tff(fact_2165_Inf__atMost,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X2: A] : ( aa(set(A),A,complete_Inf_Inf(A),aa(A,set(A),set_ord_atMost(A),X2)) = bot_bot(A) ) ) ).

% Inf_atMost
tff(fact_2166_div__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),A4) ) ) ).

% div_minus1_right
tff(fact_2167_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) ) ) ) ).

% div_mult_mult1
tff(fact_2168_finite__Collect__le__nat,axiom,
    ! [K: nat] : pp(aa(set(nat),bool,finite_finite2(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_rb(nat,fun(nat,bool)),K)))) ).

% finite_Collect_le_nat
tff(fact_2169_atMost__0,axiom,
    aa(nat,set(nat),set_ord_atMost(nat),zero_zero(nat)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))) ).

% atMost_0
tff(fact_2170_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( ( C2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) = zero_zero(A) ) )
          & ( ( C2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) ) ) ) ) ).

% div_mult_mult1_if
tff(fact_2171_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A4: A,B3: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) ) ) ) ).

% div_mult_mult2
tff(fact_2172_finite__less__ub,axiom,
    ! [F2: fun(nat,nat),U: nat] :
      ( ! [N2: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N2),aa(nat,nat,F2,N2)))
     => pp(aa(set(nat),bool,finite_finite2(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_rc(fun(nat,nat),fun(nat,fun(nat,bool)),F2),U)))) ) ).

% finite_less_ub
tff(fact_2173_not__empty__eq__Iic__eq__empty,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [H2: A] : ( bot_bot(set(A)) != aa(A,set(A),set_ord_atMost(A),H2) ) ) ).

% not_empty_eq_Iic_eq_empty
tff(fact_2174_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7311177749621191930dd_sum(product_prod(nat,nat),A),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),G)),aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_rd(nat,fun(nat,fun(nat,bool)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_rf(fun(nat,fun(nat,A)),fun(nat,A),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% sum.triangle_reindex_eq
tff(fact_2175_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7121269368397514597t_prod(product_prod(nat,nat),A),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),G)),aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_rd(nat,fun(nat,fun(nat,bool)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_rh(fun(nat,fun(nat,A)),fun(nat,A),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% prod.triangle_reindex_eq
tff(fact_2176_atMost__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [U: A] : ( aa(A,set(A),set_ord_atMost(A),U) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_ri(A,fun(A,bool),U)) ) ) ).

% atMost_def
tff(fact_2177_atMost__eq__UNIV__iff,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [X2: A] :
          ( ( aa(A,set(A),set_ord_atMost(A),X2) = top_top(set(A)) )
        <=> ( X2 = top_top(A) ) ) ) ).

% atMost_eq_UNIV_iff
tff(fact_2178_div__add__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B3: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4)),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),one_one(A)) ) ) ) ).

% div_add_self1
tff(fact_2179_div__add__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B3: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),one_one(A)) ) ) ) ).

% div_add_self2
tff(fact_2180_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S: set(A),L: A,E2: A] :
          ( ( S != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),S))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),L))),E2)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(A),A,complete_Inf_Inf(A),S)),L))),E2)) ) ) ) ).

% cInf_asclose
tff(fact_2181_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S: set(A),L: A,E2: A] :
          ( ( S != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),S))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),L))),E2)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(A),A,complete_Sup_Sup(A),S)),L))),E2)) ) ) ) ).

% cSup_asclose
tff(fact_2182_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),one_one(A)) = A4 ) ) ).

% bits_div_by_1
tff(fact_2183_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S: set(A),A4: A] :
          ( ( S != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),S))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X)),A4)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(set(A),A,complete_Inf_Inf(A),S))),A4)) ) ) ) ).

% cInf_abs_ge
tff(fact_2184_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),C2) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
tff(fact_2185_inj__on__diff__nat,axiom,
    ! [N4: set(nat),K: nat] :
      ( ! [N2: nat] :
          ( pp(aa(set(nat),bool,member(nat,N2),N4))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N2)) )
     => inj_on(nat,nat,aTP_Lamp_rj(nat,fun(nat,nat),K),N4) ) ).

% inj_on_diff_nat
tff(fact_2186_card__UN__disjoint,axiom,
    ! [B: $tType,A: $tType,I: set(A),A3: fun(A,set(B))] :
      ( pp(aa(set(A),bool,finite_finite2(A),I))
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),I))
           => pp(aa(set(B),bool,finite_finite2(B),aa(A,set(B),A3,X))) )
       => ( ! [X: A] :
              ( pp(aa(set(A),bool,member(A,X),I))
             => ! [Xa4: A] :
                  ( pp(aa(set(A),bool,member(A,Xa4),I))
                 => ( ( X != Xa4 )
                   => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),A3,X)),aa(A,set(B),A3,Xa4)) = bot_bot(set(B)) ) ) ) )
         => ( aa(set(B),nat,finite_card(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),I))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_rk(fun(A,set(B)),fun(A,nat),A3)),I) ) ) ) ) ).

% card_UN_disjoint
tff(fact_2187_card_Oempty,axiom,
    ! [A: $tType] : ( aa(set(A),nat,finite_card(A),bot_bot(set(A))) = zero_zero(nat) ) ).

% card.empty
tff(fact_2188_card__0__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ( aa(set(A),nat,finite_card(A),A3) = zero_zero(nat) )
      <=> ( A3 = bot_bot(set(A)) ) ) ) ).

% card_0_eq
tff(fact_2189_card__SigmaI,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: fun(A,set(B))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),A3))
           => pp(aa(set(B),bool,finite_finite2(B),aa(A,set(B),B2,X))) )
       => ( aa(set(product_prod(A,B)),nat,finite_card(product_prod(A,B)),product_Sigma(A,B,A3,B2)) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_rk(fun(A,set(B)),fun(A,nat),B2)),A3) ) ) ) ).

% card_SigmaI
tff(fact_2190_UN__atMost__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Sup_Sup(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),set_ord_atMost(nat)),top_top(set(nat)))) = top_top(set(nat)) ).

% UN_atMost_UNIV
tff(fact_2191_card__cartesian__product,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] : ( aa(set(product_prod(A,B)),nat,finite_card(product_prod(A,B)),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(B),nat,finite_card(B),B2)) ) ).

% card_cartesian_product
tff(fact_2192_card__cartesian__product__singleton,axiom,
    ! [A: $tType,B: $tType,X2: A,A3: set(B)] : ( aa(set(product_prod(A,B)),nat,finite_card(product_prod(A,B)),product_Sigma(A,B,aa(set(A),set(A),insert(A,X2),bot_bot(set(A))),aTP_Lamp_bq(set(B),fun(A,set(B)),A3))) = aa(set(B),nat,finite_card(B),A3) ) ).

% card_cartesian_product_singleton
tff(fact_2193_card__eq__sum,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),nat,finite_card(A),A3) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_rl(A,nat)),A3) ) ).

% card_eq_sum
tff(fact_2194_card__1__singletonE,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),A3) = one_one(nat) )
     => ~ ! [X: A] : ( A3 != aa(set(A),set(A),insert(A,X),bot_bot(set(A))) ) ) ).

% card_1_singletonE
tff(fact_2195_card__partition,axiom,
    ! [A: $tType,C3: set(set(A)),K: nat] :
      ( pp(aa(set(set(A)),bool,finite_finite2(set(A)),C3))
     => ( pp(aa(set(A),bool,finite_finite2(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C3)))
       => ( ! [C4: set(A)] :
              ( pp(aa(set(set(A)),bool,member(set(A),C4),C3))
             => ( aa(set(A),nat,finite_card(A),C4) = K ) )
         => ( ! [C1: set(A),C22: set(A)] :
                ( pp(aa(set(set(A)),bool,member(set(A),C1),C3))
               => ( pp(aa(set(set(A)),bool,member(set(A),C22),C3))
                 => ( ( C1 != C22 )
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C1),C22) = bot_bot(set(A)) ) ) ) )
           => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(set(set(A)),nat,finite_card(set(A)),C3)) = aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C3)) ) ) ) ) ) ).

% card_partition
tff(fact_2196_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S: set(A),T2: set(B),R: fun(A,fun(B,bool)),K: nat] :
      ( pp(aa(set(A),bool,finite_finite2(A),S))
     => ( pp(aa(set(B),bool,finite_finite2(B),T2))
       => ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),T2))
             => ( aa(set(A),nat,finite_card(A),aa(fun(A,bool),set(A),collect(A),aa(B,fun(A,bool),aa(fun(A,fun(B,bool)),fun(B,fun(A,bool)),aTP_Lamp_kt(set(A),fun(fun(A,fun(B,bool)),fun(B,fun(A,bool))),S),R),X))) = K ) )
         => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,fun(B,bool)),fun(A,nat),aTP_Lamp_rn(set(B),fun(fun(A,fun(B,bool)),fun(A,nat)),T2),R)),S) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(set(B),nat,finite_card(B),T2)) ) ) ) ) ).

% sum_multicount
tff(fact_2197_sum__multicount__gen,axiom,
    ! [A: $tType,B: $tType,S2: set(A),T3: set(B),R: fun(A,fun(B,bool)),K: fun(B,nat)] :
      ( pp(aa(set(A),bool,finite_finite2(A),S2))
     => ( pp(aa(set(B),bool,finite_finite2(B),T3))
       => ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),T3))
             => ( aa(set(A),nat,finite_card(A),aa(fun(A,bool),set(A),collect(A),aa(B,fun(A,bool),aa(fun(A,fun(B,bool)),fun(B,fun(A,bool)),aTP_Lamp_kt(set(A),fun(fun(A,fun(B,bool)),fun(B,fun(A,bool))),S2),R),X))) = aa(B,nat,K,X) ) )
         => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,fun(B,bool)),fun(A,nat),aTP_Lamp_rn(set(B),fun(fun(A,fun(B,bool)),fun(A,nat)),T3),R)),S2) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),K),T3) ) ) ) ) ).

% sum_multicount_gen
tff(fact_2198_card__eq__0__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),A3) = zero_zero(nat) )
    <=> ( ( A3 = bot_bot(set(A)) )
        | ~ pp(aa(set(A),bool,finite_finite2(A),A3)) ) ) ).

% card_eq_0_iff
tff(fact_2199_card__1__singletonI,axiom,
    ! [A: $tType,S: set(A),X2: A] :
      ( pp(aa(set(A),bool,finite_finite2(A),S))
     => ( ( aa(set(A),nat,finite_card(A),S) = one_one(nat) )
       => ( pp(aa(set(A),bool,member(A,X2),S))
         => ( S = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ) ) ) ).

% card_1_singletonI
tff(fact_2200_card__quotient__disjoint,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( inj_on(A,set(set(A)),aTP_Lamp_jx(set(product_prod(A,A)),fun(A,set(set(A))),R2),A3)
       => ( aa(set(set(A)),nat,finite_card(set(A)),equiv_quotient(A,A3,R2)) = aa(set(A),nat,finite_card(A),A3) ) ) ) ).

% card_quotient_disjoint
tff(fact_2201_bot__nat__def,axiom,
    bot_bot(nat) = zero_zero(nat) ).

% bot_nat_def
tff(fact_2202_card__Diff1__le,axiom,
    ! [A: $tType,A3: set(A),X2: A] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3))) ).

% card_Diff1_le
tff(fact_2203_card__Diff__singleton,axiom,
    ! [A: $tType,X2: A,A3: set(A)] :
      ( pp(aa(set(A),bool,member(A,X2),A3))
     => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),one_one(nat)) ) ) ).

% card_Diff_singleton
tff(fact_2204_card__Diff__singleton__if,axiom,
    ! [A: $tType,X2: A,A3: set(A)] :
      ( ( pp(aa(set(A),bool,member(A,X2),A3))
       => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),one_one(nat)) ) )
      & ( ~ pp(aa(set(A),bool,member(A,X2),A3))
       => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))) = aa(set(A),nat,finite_card(A),A3) ) ) ) ).

% card_Diff_singleton_if
tff(fact_2205_card__Un__Int,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(A),bool,finite_finite2(A),B2))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))) ) ) ) ).

% card_Un_Int
tff(fact_2206_card__Diff__subset__Int,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)))
     => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))) ) ) ).

% card_Diff_subset_Int
tff(fact_2207_card__Un__disjoint,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(A),bool,finite_finite2(A),B2))
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) )
         => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B2)) ) ) ) ) ).

% card_Un_disjoint
tff(fact_2208_card__vimage__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),D2: set(A),A3: set(B)] :
      ( inj_on(A,B,F2,D2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),A3)),D2))),aa(set(B),nat,finite_card(B),A3))) ) ) ).

% card_vimage_inj_on_le
tff(fact_2209_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I: set(A),A3: fun(A,set(B))] :
      ( pp(aa(set(A),bool,finite_finite2(A),I))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(B),nat,finite_card(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A3),I)))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_rk(fun(A,set(B)),fun(A,nat),A3)),I))) ) ).

% card_UN_le
tff(fact_2210_sum__card__image,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,set(B))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pairwise(A,aTP_Lamp_ro(fun(A,set(B)),fun(A,fun(A,bool)),F2),A3)
       => ( aa(set(set(B)),nat,aa(fun(set(B),nat),fun(set(set(B)),nat),groups7311177749621191930dd_sum(set(B),nat),finite_card(B)),aa(set(A),set(set(B)),image2(A,set(B),F2),A3)) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_rk(fun(A,set(B)),fun(A,nat),F2)),A3) ) ) ) ).

% sum_card_image
tff(fact_2211_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: set(nat),C2: fun(nat,A),D3: fun(nat,A)] :
          ( ( ( pp(aa(set(nat),bool,finite_finite2(nat),A3))
              & pp(aa(set(nat),bool,member(nat,zero_zero(nat)),A3)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_rp(fun(nat,A),fun(fun(nat,A),fun(nat,A)),C2),D3)),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,C2,zero_zero(nat))),aa(nat,A,D3,zero_zero(nat))) ) )
          & ( ~ ( pp(aa(set(nat),bool,finite_finite2(nat),A3))
                & pp(aa(set(nat),bool,member(nat,zero_zero(nat)),A3)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_rp(fun(nat,A),fun(fun(nat,A),fun(nat,A)),C2),D3)),A3) = zero_zero(A) ) ) ) ) ).

% sum_zero_power'
tff(fact_2212_sum__zero__power,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: set(nat),C2: fun(nat,A)] :
          ( ( ( pp(aa(set(nat),bool,finite_finite2(nat),A3))
              & pp(aa(set(nat),bool,member(nat,zero_zero(nat)),A3)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_rq(fun(nat,A),fun(nat,A),C2)),A3) = aa(nat,A,C2,zero_zero(nat)) ) )
          & ( ~ ( pp(aa(set(nat),bool,finite_finite2(nat),A3))
                & pp(aa(set(nat),bool,member(nat,zero_zero(nat)),A3)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_rq(fun(nat,A),fun(nat,A),C2)),A3) = zero_zero(A) ) ) ) ) ).

% sum_zero_power
tff(fact_2213_sum__fun__comp,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [S: set(A),R: set(B),G: fun(A,B),F2: fun(B,C)] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( pp(aa(set(B),bool,finite_finite2(B),R))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image2(A,B,G),S)),R))
             => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_rr(fun(A,B),fun(fun(B,C),fun(A,C)),G),F2)),S) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aa(fun(A,B),fun(fun(B,C),fun(B,C)),aTP_Lamp_rs(set(A),fun(fun(A,B),fun(fun(B,C),fun(B,C))),S),G),F2)),R) ) ) ) ) ) ).

% sum_fun_comp
tff(fact_2214_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: set(B),F2: fun(B,A),N: A,K: nat] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),A3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,I3)))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),N)) ) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(B),nat,finite_card(B),A3)),K))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),N))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3)),aa(nat,A,aa(A,fun(nat,A),power_power(A),N),K))) ) ) ) ) ).

% prod_le_power
tff(fact_2215_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_field(A)
     => ! [A3: set(B),F2: fun(B,A),K5: A] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),K5),aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),A3))))) )
         => ( pp(aa(set(B),bool,finite_finite2(B),A3))
           => ( ( A3 != bot_bot(set(B)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),K5)) ) ) ) ) ).

% sum_bounded_above_divide
tff(fact_2216_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,M2: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A4,B3) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_rt(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A4,B3) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M2))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_rt(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),M2)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),M2)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M2))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_rt(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),M2)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),M2)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
tff(fact_2217_power__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),one_one(A)),N) = one_one(A) ) ) ).

% power_one
tff(fact_2218_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A] :
          ( ( bot_bot(set(A)) = set_or1337092689740270186AtMost(A,A4,B3) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ).

% atLeastatMost_empty_iff2
tff(fact_2219_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A] :
          ( ( set_or1337092689740270186AtMost(A,A4,B3) = bot_bot(set(A)) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ).

% atLeastatMost_empty_iff
tff(fact_2220_atLeastAtMost__singleton__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( set_or1337092689740270186AtMost(A,A4,B3) = aa(set(A),set(A),insert(A,C2),bot_bot(set(A))) )
        <=> ( ( A4 = B3 )
            & ( B3 = C2 ) ) ) ) ).

% atLeastAtMost_singleton_iff
tff(fact_2221_atLeastAtMost__singleton,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A] : ( set_or1337092689740270186AtMost(A,A4,A4) = aa(set(A),set(A),insert(A,A4),bot_bot(set(A))) ) ) ).

% atLeastAtMost_singleton
tff(fact_2222_of__nat__mult,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M2: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M2),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M2)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_mult
tff(fact_2223_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),N) = one_one(A) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_eq_1_iff
tff(fact_2224_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( ( one_one(A) = aa(nat,A,semiring_1_of_nat(A),N) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_1_eq_iff
tff(fact_2225_of__nat__1,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),one_one(nat)) = one_one(A) ) ) ).

% of_nat_1
tff(fact_2226_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I2: A,J2: A] : ( aa(set(A),set(A),image2(A,A,aTP_Lamp_ru(A,fun(A,A),K)),set_or1337092689740270186AtMost(A,I2,J2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)) ) ) ).

% image_add_atLeastAtMost'
tff(fact_2227_image__minus__const__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [D3: A,A4: A,B3: A] : ( aa(set(A),set(A),image2(A,A,aTP_Lamp_rv(A,fun(A,A),D3)),set_or1337092689740270186AtMost(A,A4,B3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),D3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),D3)) ) ) ).

% image_minus_const_atLeastAtMost'
tff(fact_2228_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Y: A,A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_rw(A,fun(B,A),Y)),A3) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(set(B),nat,finite_card(B),A3)) ) ) ).

% prod_constant
tff(fact_2229_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat,A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),A4)) = A4 ) ) ).

% left_minus_one_mult_self
tff(fact_2230_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)) = one_one(A) ) ) ).

% minus_one_mult_self
tff(fact_2231_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Y: A,A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_rx(A,fun(B,A),Y)),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),A3))),Y) ) ) ).

% sum_constant
tff(fact_2232_prod__int__plus__eq,axiom,
    ! [I2: nat,J2: nat] : ( aa(set(nat),int,aa(fun(nat,int),fun(set(nat),int),groups7121269368397514597t_prod(nat,int),semiring_1_of_nat(int)),set_or1337092689740270186AtMost(nat,I2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2))) = aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7121269368397514597t_prod(int,int),aTP_Lamp_ry(int,int)),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),I2),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2)))) ) ).

% prod_int_plus_eq
tff(fact_2233_pairwise__trivial,axiom,
    ! [A: $tType,I: set(A)] : pairwise(A,aTP_Lamp_rz(A,fun(A,bool)),I) ).

% pairwise_trivial
tff(fact_2234_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [X2: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),X2)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(nat,A,semiring_1_of_nat(A),X2)) ) ) ).

% mult_of_nat_commute
tff(fact_2235_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X2: A,Y: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),X2) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N)) ) ) ) ).

% power_commuting_commutes
tff(fact_2236_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A,B3: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B3),N)) ) ) ).

% power_mult_distrib
tff(fact_2237_power__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A4: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)) ) ) ).

% power_commutes
tff(fact_2238_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(B)
     => ! [F2: fun(A,B),A3: set(A),N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),N) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(nat,fun(A,B),aTP_Lamp_sa(fun(A,B),fun(nat,fun(A,B)),F2),N)),A3) ) ) ).

% prod_power_distrib
tff(fact_2239_pairwise__empty,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool))] : pairwise(A,P,bot_bot(set(A))) ).

% pairwise_empty
tff(fact_2240_atLeastAtMost__singleton_H,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = B3 )
         => ( set_or1337092689740270186AtMost(A,A4,B3) = aa(set(A),set(A),insert(A,A4),bot_bot(set(A))) ) ) ) ).

% atLeastAtMost_singleton'
tff(fact_2241_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A4: A,M2: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M2)),aa(nat,A,semiring_1_of_nat(A),N))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(nat,A,semiring_1_of_nat(A),M2))),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% div_mult2_eq'
tff(fact_2242_one__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N))) ) ) ).

% one_le_power
tff(fact_2243_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X2: A,Y: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y) = one_one(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),N)) = one_one(A) ) ) ) ).

% left_right_inverse_power
tff(fact_2244_power__0,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A4: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),zero_zero(nat)) = one_one(A) ) ) ).

% power_0
tff(fact_2245_power__one__over,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4)),N) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)) ) ) ).

% power_one_over
tff(fact_2246_pairwise__image,axiom,
    ! [A: $tType,B: $tType,R2: fun(A,fun(A,bool)),F2: fun(B,A),S2: set(B)] :
      ( pairwise(A,R2,aa(set(B),set(A),image2(B,A,F2),S2))
    <=> pairwise(B,aa(fun(B,A),fun(B,fun(B,bool)),aTP_Lamp_sb(fun(A,fun(A,bool)),fun(fun(B,A),fun(B,fun(B,bool))),R2),F2),S2) ) ).

% pairwise_image
tff(fact_2247_power__add,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A4: A,M2: nat,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)) ) ) ).

% power_add
tff(fact_2248_pairwise__disjnt__iff,axiom,
    ! [A: $tType,A16: set(set(A))] :
      ( pairwise(set(A),disjnt(A),A16)
    <=> ! [X3: A] : uniq(set(A),aa(A,fun(set(A),bool),aTP_Lamp_sc(set(set(A)),fun(A,fun(set(A),bool)),A16),X3)) ) ).

% pairwise_disjnt_iff
tff(fact_2249_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M2: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_sd(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% sum.shift_bounds_cl_nat_ivl
tff(fact_2250_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M2: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_se(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% prod.shift_bounds_cl_nat_ivl
tff(fact_2251_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C2: A,F2: fun(B,nat),A3: set(B)] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),C2),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,nat),fun(B,A),aTP_Lamp_sf(A,fun(fun(B,nat),fun(B,A)),C2),F2)),A3) ) ) ).

% power_sum
tff(fact_2252_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [M2: nat,N: nat,X2: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),set_or1337092689740270186AtMost(nat,M2,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),M2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2)))) ) ) ) ).

% sum_power_shift
tff(fact_2253_atLeastAtMost__eq__UNIV__iff,axiom,
    ! [A: $tType] :
      ( bounded_lattice(A)
     => ! [X2: A,Y: A] :
          ( ( set_or1337092689740270186AtMost(A,X2,Y) = top_top(set(A)) )
        <=> ( ( X2 = bot_bot(A) )
            & ( Y = top_top(A) ) ) ) ) ).

% atLeastAtMost_eq_UNIV_iff
tff(fact_2254_pairwise__singleton,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),A3: A] : pairwise(A,P,aa(set(A),set(A),insert(A,A3),bot_bot(set(A)))) ).

% pairwise_singleton
tff(fact_2255_power__le__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)),one_one(A))) ) ) ) ).

% power_le_one
tff(fact_2256_power__0__left,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( ( ( N = zero_zero(nat) )
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),N) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),N) = zero_zero(A) ) ) ) ) ).

% power_0_left
tff(fact_2257_power__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N4: nat,A4: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N4))) ) ) ) ).

% power_increasing
tff(fact_2258_power__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A4: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A4)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)) ) ) ).

% power_minus
tff(fact_2259_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat,M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,N,M2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_sg(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M2)),set_or1337092689740270186AtMost(nat,N,M2)) ) ) ).

% sum.atLeastAtMost_rev
tff(fact_2260_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat,M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,N,M2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_sh(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M2)),set_or1337092689740270186AtMost(nat,N,M2)) ) ) ).

% prod.atLeastAtMost_rev
tff(fact_2261_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,M2: nat,I: set(nat)] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_si(A,fun(nat,fun(nat,A)),X2),M2)),I) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),M2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),I)) ) ) ).

% sum_power_add
tff(fact_2262_UN__le__add__shift,axiom,
    ! [A: $tType,M: fun(nat,set(A)),K: nat,N: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_sj(fun(nat,set(A)),fun(nat,fun(nat,set(A))),M),K)),aa(nat,set(nat),set_ord_atMost(nat),N))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),M),set_or1337092689740270186AtMost(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))) ) ).

% UN_le_add_shift
tff(fact_2263_power__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N4: nat,A4: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N))) ) ) ) ) ).

% power_decreasing
tff(fact_2264_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & semiring_1(A) )
     => ! [A3: set(B),F2: fun(B,A),K5: A] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,I3)),K5)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),A3))),K5))) ) ) ).

% sum_bounded_above
tff(fact_2265_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & semiring_1(A) )
     => ! [A3: set(B),K5: A,F2: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K5),aa(B,A,F2,I3))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),A3))),K5)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3))) ) ) ).

% sum_bounded_below
tff(fact_2266_power__eq__if,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [M2: nat,P5: A] :
          ( ( ( M2 = zero_zero(nat) )
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),P5),M2) = one_one(A) ) )
          & ( ( M2 != zero_zero(nat) )
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),P5),M2) = aa(A,A,aa(A,fun(A,A),times_times(A),P5),aa(nat,A,aa(A,fun(nat,A),power_power(A),P5),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),one_one(nat)))) ) ) ) ) ).

% power_eq_if
tff(fact_2267_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & power(A) )
     => ! [R: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),R,one_one(A)),one_one(B)))
         => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R,bNF_rel_fun(A,B,A,B,R,R)),times_times(A)),times_times(B)))
           => pp(aa(fun(B,fun(nat,B)),bool,aa(fun(A,fun(nat,A)),fun(fun(B,fun(nat,B)),bool),bNF_rel_fun(A,B,fun(nat,A),fun(nat,B),R,bNF_rel_fun(nat,nat,A,B,fequal(nat),R)),power_power(A)),power_power(B))) ) ) ) ).

% power_transfer
tff(fact_2268_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M2: nat,N: nat,G: fun(nat,A),P5: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P5))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P5)))) ) ) ) ).

% prod.ub_add_nat
tff(fact_2269_pairwise__alt,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),S: set(A)] :
      ( pairwise(A,R,S)
    <=> ! [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),S))
         => ! [Xa2: A] :
              ( pp(aa(set(A),bool,member(A,Xa2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),aa(set(A),set(A),insert(A,X3),bot_bot(set(A))))))
             => pp(aa(A,bool,aa(A,fun(A,bool),R,X3),Xa2)) ) ) ) ).

% pairwise_alt
tff(fact_2270_UN__le__eq__Un0,axiom,
    ! [A: $tType,M: fun(nat,set(A)),N: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),M),aa(nat,set(nat),set_ord_atMost(nat),N))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),M),set_or1337092689740270186AtMost(nat,one_one(nat),N)))),aa(nat,set(A),M,zero_zero(nat))) ) ).

% UN_le_eq_Un0
tff(fact_2271_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A4: A,N: nat,M2: nat] :
          ( ( A4 != zero_zero(A) )
         => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M2))
             => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),N)) ) )
            & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M2))
             => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2))) ) ) ) ) ) ).

% power_diff_power_eq
tff(fact_2272_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M2: nat,N: nat,F2: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_sk(fun(nat,A),fun(nat,A),F2)),set_or1337092689740270186AtMost(nat,M2,N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,M2)),aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_sk(fun(nat,A),fun(nat,A),F2)),set_or1337092689740270186AtMost(nat,M2,N)) = zero_zero(A) ) ) ) ) ).

% sum_natinterval_diff
tff(fact_2273_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S: set(B),A4: B,B3: fun(B,A),C2: A] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( ( pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(A,fun(B,A),aa(fun(B,A),fun(A,fun(B,A)),aTP_Lamp_sl(B,fun(fun(B,A),fun(A,fun(B,A))),A4),B3),C2)),S) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,B3,A4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,finite_card(B),S)),one_one(nat)))) ) )
            & ( ~ pp(aa(set(B),bool,member(B,A4),S))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(A,fun(B,A),aa(fun(B,A),fun(A,fun(B,A)),aTP_Lamp_sl(B,fun(fun(B,A),fun(A,fun(B,A))),A4),B3),C2)),S) = aa(nat,A,aa(A,fun(nat,A),power_power(A),C2),aa(set(B),nat,finite_card(B),S)) ) ) ) ) ) ).

% prod_gen_delta
tff(fact_2274_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,M2: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A4,B3) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_sm(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A4,B3) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M2))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_sm(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M2),A4)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M2),B3)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M2))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_sm(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M2),B3)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M2),A4)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
tff(fact_2275_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,M2: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A4,B3) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_sn(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A4,B3) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M2))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_sn(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M2),A4)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M2),B3)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M2))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_sn(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M2),B3)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M2),A4)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
tff(fact_2276_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,M2: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A4,B3) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_so(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A4,B3) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M2))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_so(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),M2)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),M2)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M2))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_so(A,fun(A,fun(A,A)),M2),C2)),set_or1337092689740270186AtMost(A,A4,B3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),M2)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),M2)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
tff(fact_2277_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [F2: fun(B,nat),A3: set(B)] : ( aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_sp(fun(B,nat),fun(B,A),F2)),A3) ) ) ).

% of_nat_sum
tff(fact_2278_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F2: fun(B,nat),A3: set(B)] : ( aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7121269368397514597t_prod(B,nat),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_sq(fun(B,nat),fun(B,A),F2)),A3) ) ) ).

% of_nat_prod
tff(fact_2279_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
tff(fact_2280_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1(B)
        & semiring_1(A) )
     => ! [R: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),R,zero_zero(A)),zero_zero(B)))
         => ( pp(aa(B,bool,aa(A,fun(B,bool),R,one_one(A)),one_one(B)))
           => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R,bNF_rel_fun(A,B,A,B,R,R)),plus_plus(A)),plus_plus(B)))
             => pp(aa(fun(nat,B),bool,aa(fun(nat,A),fun(fun(nat,B),bool),bNF_rel_fun(nat,nat,A,B,fequal(nat),R),semiring_1_of_nat(A)),semiring_1_of_nat(B))) ) ) ) ) ).

% transfer_rule_of_nat
tff(fact_2281_of__nat__code,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),N) = semiri8178284476397505188at_aux(A,aTP_Lamp_sr(A,A),N,zero_zero(A)) ) ) ).

% of_nat_code
tff(fact_2282_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X2: A,N: nat] :
          ( ( ( X2 = one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))) ) )
          & ( ( X2 != one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(nat,nat,suc,N)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)) ) ) ) ) ).

% sum_gp0
tff(fact_2283_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X2: A,M2: nat,N: nat] :
          ( ( ( X2 = one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),set_or1337092689740270186AtMost(nat,M2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A)) ) )
          & ( ( X2 != one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),set_or1337092689740270186AtMost(nat,M2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),N))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),M2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(nat,nat,suc,N))))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)) ) ) ) ) ).

% sum_gp_offset
tff(fact_2284_card__Collect__le__nat,axiom,
    ! [N: nat] : ( aa(set(nat),nat,finite_card(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_rb(nat,fun(nat,bool)),N))) = aa(nat,nat,suc,N) ) ).

% card_Collect_le_nat
tff(fact_2285_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M2: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,M2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),M2)) ) ) ).

% of_nat_Suc
tff(fact_2286_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% prod.atMost_Suc
tff(fact_2287_prod__int__eq,axiom,
    ! [I2: nat,J2: nat] : ( aa(set(nat),int,aa(fun(nat,int),fun(set(nat),int),groups7121269368397514597t_prod(nat,int),semiring_1_of_nat(int)),set_or1337092689740270186AtMost(nat,I2,J2)) = aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7121269368397514597t_prod(int,int),aTP_Lamp_ry(int,int)),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),I2),aa(nat,int,semiring_1_of_nat(int),J2))) ) ).

% prod_int_eq
tff(fact_2288_int__prod,axiom,
    ! [B: $tType,F2: fun(B,nat),A3: set(B)] : ( aa(nat,int,semiring_1_of_nat(int),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7121269368397514597t_prod(B,nat),F2),A3)) = aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7121269368397514597t_prod(B,int),aTP_Lamp_ss(fun(B,nat),fun(B,int),F2)),A3) ) ).

% int_prod
tff(fact_2289_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M2: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_st(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
tff(fact_2290_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M2: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_su(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
tff(fact_2291_power__Suc2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A4: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)),A4) ) ) ).

% power_Suc2
tff(fact_2292_power__Suc,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A4: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)) ) ) ).

% power_Suc
tff(fact_2293_card_Oeq__fold,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),nat,finite_card(A),A3) = finite_fold(A,nat,aTP_Lamp_sv(A,fun(nat,nat)),zero_zero(nat),A3) ) ).

% card.eq_fold
tff(fact_2294_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% prod.atLeast0_atMost_Suc
tff(fact_2295_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_atMost_Suc_shift
tff(fact_2296_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M2: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),aa(nat,nat,suc,N)))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,aa(nat,nat,suc,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N))) ) ) ) ).

% prod.nat_ivl_Suc'
tff(fact_2297_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M2: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),N))) ) ) ) ).

% prod.atLeast_Suc_atMost
tff(fact_2298_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M2: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N))),aa(nat,A,G,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_st(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M2,N))) ) ) ) ).

% sum.Suc_reindex_ivl
tff(fact_2299_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M2: nat,N: nat,F2: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),aa(nat,nat,suc,N)))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_sw(fun(nat,A),fun(nat,A),F2)),set_or1337092689740270186AtMost(nat,M2,N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,aa(nat,nat,suc,N))),aa(nat,A,F2,M2)) ) ) ) ).

% sum_Suc_diff
tff(fact_2300_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M2: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N))),aa(nat,A,G,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_su(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M2,N))) ) ) ) ).

% prod.Suc_reindex_ivl
tff(fact_2301_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M2: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_sx(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% sum.atLeast_atMost_pred_shift
tff(fact_2302_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M2: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_sx(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% prod.atLeast_atMost_pred_shift
tff(fact_2303_sum__Suc,axiom,
    ! [A: $tType,F2: fun(A,nat),A3: set(A)] : ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_sy(fun(A,nat),fun(A,nat),F2)),A3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3)),aa(set(A),nat,finite_card(A),A3)) ) ).

% sum_Suc
tff(fact_2304_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(nat,nat,suc,N))),A4)) ) ) ) ).

% power_Suc_le_self
tff(fact_2305_card__1__singleton__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ? [X3: A] : ( A3 = aa(set(A),set(A),insert(A,X3),bot_bot(set(A))) ) ) ).

% card_1_singleton_iff
tff(fact_2306_card__eq__SucD,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,K) )
     => ? [B4: A,B8: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,B4),B8) )
          & ~ pp(aa(set(A),bool,member(A,B4),B8))
          & ( aa(set(A),nat,finite_card(A),B8) = K )
          & ( ( K = zero_zero(nat) )
           => ( B8 = bot_bot(set(A)) ) ) ) ) ).

% card_eq_SucD
tff(fact_2307_card__Suc__eq,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,K) )
    <=> ? [B5: A,B9: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,B5),B9) )
          & ~ pp(aa(set(A),bool,member(A,B5),B9))
          & ( aa(set(A),nat,finite_card(A),B9) = K )
          & ( ( K = zero_zero(nat) )
           => ( B9 = bot_bot(set(A)) ) ) ) ) ).

% card_Suc_eq
tff(fact_2308_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] : ( set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_atMost(nat),N)),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_atMost_eq_remove0
tff(fact_2309_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_st(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_atMost(nat),N))) ) ) ).

% sum.atMost_Suc_shift
tff(fact_2310_sum__telescope,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(nat,A),I2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_sz(fun(nat,A),fun(nat,A),F2)),aa(nat,set(nat),set_ord_atMost(nat),I2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,zero_zero(nat))),aa(nat,A,F2,aa(nat,nat,suc,I2))) ) ) ).

% sum_telescope
tff(fact_2311_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_su(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_atMost(nat),N))) ) ) ).

% prod.atMost_Suc_shift
tff(fact_2312_card_Oremove,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(A),bool,member(A,X2),A3))
       => ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ).

% card.remove
tff(fact_2313_card_Oinsert__remove,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(nat,nat,suc,aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ).

% card.insert_remove
tff(fact_2314_card__Suc__Diff1,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(A),bool,member(A,X2),A3))
       => ( aa(nat,nat,suc,aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) = aa(set(A),nat,finite_card(A),A3) ) ) ) ).

% card_Suc_Diff1
tff(fact_2315_int__sum,axiom,
    ! [B: $tType,F2: fun(B,nat),A3: set(B)] : ( aa(nat,int,semiring_1_of_nat(int),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A3)) = aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7311177749621191930dd_sum(B,int),aTP_Lamp_ss(fun(B,nat),fun(B,int),F2)),A3) ) ).

% int_sum
tff(fact_2316_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M2: nat,N: nat,F2: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ta(fun(nat,A),fun(nat,A),F2)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,N)),aa(nat,A,F2,M2)) ) ) ) ).

% sum_telescope''
tff(fact_2317_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [M2: nat,N: nat,X2: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),set_or1337092689740270186AtMost(nat,M2,N))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(nat,nat,suc,N))) ) ) ) ).

% sum_gp_multiplied
tff(fact_2318_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),aa(nat,set(nat),set_ord_atMost(nat),N))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(nat,nat,suc,N))) ) ) ).

% sum_gp_basic
tff(fact_2319_sum__gp,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [N: nat,M2: nat,X2: A] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M2))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),set_or1337092689740270186AtMost(nat,M2,N)) = zero_zero(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M2))
           => ( ( ( X2 = one_one(A) )
               => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),set_or1337092689740270186AtMost(nat,M2,N)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))),M2)) ) )
              & ( ( X2 != one_one(A) )
               => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),set_or1337092689740270186AtMost(nat,M2,N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(nat,nat,suc,N)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)) ) ) ) ) ) ) ).

% sum_gp
tff(fact_2320_card__UNION,axiom,
    ! [A: $tType,A3: set(set(A))] :
      ( pp(aa(set(set(A)),bool,finite_finite2(set(A)),A3))
     => ( ! [X: set(A)] :
            ( pp(aa(set(set(A)),bool,member(set(A),X),A3))
           => pp(aa(set(A),bool,finite_finite2(A),X)) )
       => ( aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3)) = aa(int,nat,nat2,aa(set(set(set(A))),int,aa(fun(set(set(A)),int),fun(set(set(set(A))),int),groups7311177749621191930dd_sum(set(set(A)),int),aTP_Lamp_tb(set(set(A)),int)),aa(fun(set(set(A)),bool),set(set(set(A))),collect(set(set(A))),aTP_Lamp_tc(set(set(A)),fun(set(set(A)),bool),A3)))) ) ) ) ).

% card_UNION
tff(fact_2321_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P5: nat,K: nat,G: fun(nat,A),H2: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),P5))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),P5))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_td(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),P5)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_te(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P5),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% prod.zero_middle
tff(fact_2322_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [P5: nat,K: nat,G: fun(nat,A),H2: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),P5))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),P5))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_tf(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),P5)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_tg(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P5),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% sum.zero_middle
tff(fact_2323_nat__leq__as__int,axiom,
    ! [X4: nat,Xa3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X4),Xa3))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_leq_as_int
tff(fact_2324_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [F2: fun(nat,A),A4: nat,B3: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),F2),set_or1337092689740270186AtMost(nat,A4,B3)) = set_fo6178422350223883121st_nat(A,aTP_Lamp_th(fun(nat,A),fun(nat,fun(A,A)),F2),A4,B3,one_one(A)) ) ) ).

% prod_atLeastAtMost_code
tff(fact_2325_finite__interval__int1,axiom,
    ! [A4: int,B3: int] : pp(aa(set(int),bool,finite_finite2(int),aa(fun(int,bool),set(int),collect(int),aa(int,fun(int,bool),aTP_Lamp_ti(int,fun(int,fun(int,bool)),A4),B3)))) ).

% finite_interval_int1
tff(fact_2326_not__gr__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),N))
        <=> ( N = zero_zero(A) ) ) ) ).

% not_gr_zero
tff(fact_2327_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ).

% add_less_cancel_right
tff(fact_2328_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ).

% add_less_cancel_left
tff(fact_2329_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,uminus_uminus(A),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ).

% neg_less_iff_less
tff(fact_2330_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,uminus_uminus(A),Y)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ).

% compl_less_compl_iff
tff(fact_2331_finite__Collect__less__nat,axiom,
    ! [K: nat] : pp(aa(set(nat),bool,finite_finite2(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),K)))) ).

% finite_Collect_less_nat
tff(fact_2332_card__Collect__less__nat,axiom,
    ! [N: nat] : ( aa(set(nat),nat,finite_card(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N))) = N ) ).

% card_Collect_less_nat
tff(fact_2333_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4)) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
tff(fact_2334_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),A4)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A))) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
tff(fact_2335_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3)) ) ) ).

% less_add_same_cancel2
tff(fact_2336_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3)) ) ) ).

% less_add_same_cancel1
tff(fact_2337_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),B3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A))) ) ) ).

% add_less_same_cancel2
tff(fact_2338_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4)),B3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A))) ) ) ).

% add_less_same_cancel1
tff(fact_2339_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) ) ) ).

% diff_gt_0_iff_gt
tff(fact_2340_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),A4)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4)) ) ) ).

% neg_less_0_iff_less
tff(fact_2341_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A))) ) ) ).

% neg_0_less_iff_less
tff(fact_2342_neg__less__pos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),A4)),A4))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4)) ) ) ).

% neg_less_pos
tff(fact_2343_less__neg__neg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,uminus_uminus(A),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A))) ) ) ).

% less_neg_neg
tff(fact_2344_power__inject__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,M2: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4))
         => ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),M2) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N) )
          <=> ( M2 = N ) ) ) ) ).

% power_inject_exp
tff(fact_2345_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,abs_abs(A),A4)))
        <=> ( A4 != zero_zero(A) ) ) ) ).

% zero_less_abs_iff
tff(fact_2346_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),A,complete_Inf_Inf(A),A3) = bot_bot(A) )
        <=> ! [X3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),bot_bot(A)),X3))
             => ? [Xa2: A] :
                  ( pp(aa(set(A),bool,member(A,Xa2),A3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Xa2),X3)) ) ) ) ) ).

% Inf_eq_bot_iff
tff(fact_2347_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),A3) = top_top(A) )
        <=> ! [X3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),top_top(A)))
             => ? [Xa2: A] :
                  ( pp(aa(set(A),bool,member(A,Xa2),A3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Xa2)) ) ) ) ) ).

% Sup_eq_top_iff
tff(fact_2348_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ( set_or1337092689740270186AtMost(A,A4,B3) = bot_bot(set(A)) ) ) ) ).

% atLeastatMost_empty
tff(fact_2349_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A))) ) ) ).

% divide_less_0_1_iff
tff(fact_2350_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ) ).

% divide_less_eq_1_neg
tff(fact_2351_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) ) ) ) ).

% divide_less_eq_1_pos
tff(fact_2352_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) ) ) ) ).

% less_divide_eq_1_neg
tff(fact_2353_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ) ).

% less_divide_eq_1_pos
tff(fact_2354_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4)) ) ) ).

% zero_less_divide_1_iff
tff(fact_2355_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B3: A,X2: nat,Y: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B3),X2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B3),Y)))
          <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X2),Y)) ) ) ) ).

% power_strict_increasing_iff
tff(fact_2356_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F2: fun(B,A),A3: set(B)] :
          ( ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3)) = bot_bot(A) )
        <=> ! [X3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),bot_bot(A)),X3))
             => ? [Xa2: B] :
                  ( pp(aa(set(B),bool,member(B,Xa2),A3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,Xa2)),X3)) ) ) ) ) ).

% INF_eq_bot_iff
tff(fact_2357_SUP__eq__top__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F2: fun(B,A),A3: set(B)] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3)) = top_top(A) )
        <=> ! [X3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),top_top(A)))
             => ? [Xa2: B] :
                  ( pp(aa(set(B),bool,member(B,Xa2),A3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),aa(B,A,F2,Xa2))) ) ) ) ) ).

% SUP_eq_top_iff
tff(fact_2358_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ) ).

% le_divide_eq_1_pos
tff(fact_2359_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ) ).

% le_divide_eq_1_neg
tff(fact_2360_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ) ).

% divide_le_eq_1_pos
tff(fact_2361_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ) ).

% divide_le_eq_1_neg
tff(fact_2362_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B3: A,M2: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),one_one(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B3),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B3),N)))
            <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M2)) ) ) ) ) ).

% power_strict_decreasing_iff
tff(fact_2363_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D3: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),D3))
         => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),D3)),set_or1337092689740270186AtMost(A,A4,B3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),D3),A4),aa(A,A,aa(A,fun(A,A),times_times(A),D3),B3)) ) ) ) ).

% image_mult_atLeastAtMost
tff(fact_2364_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B3: A,X2: nat,Y: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B3),X2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B3),Y)))
          <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X2),Y)) ) ) ) ).

% power_increasing_iff
tff(fact_2365_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D3: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),D3))
         => ( aa(set(A),set(A),image2(A,A,aTP_Lamp_tk(A,fun(A,A),D3)),set_or1337092689740270186AtMost(A,A4,B3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),D3),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),D3)) ) ) ) ).

% image_divide_atLeastAtMost
tff(fact_2366_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B3: A,M2: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),one_one(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B3),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B3),N)))
            <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M2)) ) ) ) ) ).

% power_decreasing_iff
tff(fact_2367_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [N: nat,M2: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,N)),M2))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,aa(nat,nat,suc,N))) = one_one(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,N)),M2))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ) ) ).

% prod.cl_ivl_Suc
tff(fact_2368_nat__div__as__int,axiom,
    ! [X4: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X4),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_div_as_int
tff(fact_2369_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y: A] :
          ( ( X2 != Y )
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ) ).

% linorder_neqE_linordered_idom
tff(fact_2370_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ).

% order_less_imp_not_less
tff(fact_2371_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ( Y != X2 ) ) ) ).

% order_less_imp_not_eq2
tff(fact_2372_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ( X2 != Y ) ) ) ).

% order_less_imp_not_eq
tff(fact_2373_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
          | ( X2 = Y )
          | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ).

% linorder_less_linear
tff(fact_2374_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y: A,P: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2))
           => pp(P) ) ) ) ).

% order_less_imp_triv
tff(fact_2375_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ).

% order_less_not_sym
tff(fact_2376_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A4: A,B3: A,F2: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,B3)),C2))
           => ( ! [X: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,X)),aa(A,C,F2,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,A4)),C2)) ) ) ) ) ).

% order_less_subst2
tff(fact_2377_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A4: A,F2: fun(B,A),B3: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(B,A,F2,B3)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),B3),C2))
           => ( ! [X: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(B,A,F2,C2))) ) ) ) ) ).

% order_less_subst1
tff(fact_2378_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),X2)) ) ).

% order_less_irrefl
tff(fact_2379_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A4: A,B3: A,F2: fun(A,B),C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( ( aa(A,B,F2,B3) = C2 )
           => ( ! [X: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y2))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X)),aa(A,B,F2,Y2))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,A4)),C2)) ) ) ) ) ).

% ord_less_eq_subst
tff(fact_2380_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A4: A,F2: fun(B,A),B3: B,C2: B] :
          ( ( A4 = aa(B,A,F2,B3) )
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),B3),C2))
           => ( ! [X: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(B,A,F2,C2))) ) ) ) ) ).

% ord_eq_less_subst
tff(fact_2381_order__less__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z2)) ) ) ) ).

% order_less_trans
tff(fact_2382_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) ) ) ).

% order_less_asym'
tff(fact_2383_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] :
          ( ( X2 != Y )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ) ).

% linorder_neq_iff
tff(fact_2384_order__less__asym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ).

% order_less_asym
tff(fact_2385_linorder__neqE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] :
          ( ( X2 != Y )
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ) ).

% linorder_neqE
tff(fact_2386_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ( A4 != B3 ) ) ) ).

% dual_order.strict_implies_not_eq
tff(fact_2387_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( A4 != B3 ) ) ) ).

% order.strict_implies_not_eq
tff(fact_2388_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A4)) ) ) ) ).

% dual_order.strict_trans
tff(fact_2389_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2))
            | ( X2 = Y ) ) ) ) ).

% not_less_iff_gr_or_eq
tff(fact_2390_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),C2)) ) ) ) ).

% order.strict_trans
tff(fact_2391_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,fun(A,bool)),A4: A,B3: A] :
          ( ! [A5: A,B4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A5),B4))
             => pp(aa(A,bool,aa(A,fun(A,bool),P,A5),B4)) )
         => ( ! [A5: A] : pp(aa(A,bool,aa(A,fun(A,bool),P,A5),A5))
           => ( ! [A5: A,B4: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),P,B4),A5))
                 => pp(aa(A,bool,aa(A,fun(A,bool),P,A5),B4)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),P,A4),B3)) ) ) ) ) ).

% linorder_less_wlog
tff(fact_2392_exists__least__iff,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool)] :
          ( ? [X_12: A] : pp(aa(A,bool,P,X_12))
        <=> ? [N5: A] :
              ( pp(aa(A,bool,P,N5))
              & ! [M5: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M5),N5))
                 => ~ pp(aa(A,bool,P,M5)) ) ) ) ) ).

% exists_least_iff
tff(fact_2393_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),A4)) ) ).

% dual_order.irrefl
tff(fact_2394_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ).

% dual_order.asym
tff(fact_2395_linorder__cases,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ( ( X2 != Y )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ) ).

% linorder_cases
tff(fact_2396_antisym__conv3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y: A,X2: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2))
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
          <=> ( X2 = Y ) ) ) ) ).

% antisym_conv3
tff(fact_2397_less__induct,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),A4: A] :
          ( ! [X: A] :
              ( ! [Y5: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y5),X))
                 => pp(aa(A,bool,P,Y5)) )
             => pp(aa(A,bool,P,X)) )
         => pp(aa(A,bool,P,A4)) ) ) ).

% less_induct
tff(fact_2398_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( ( B3 = C2 )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),C2)) ) ) ) ).

% ord_less_eq_trans
tff(fact_2399_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4 = B3 )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),C2)) ) ) ) ).

% ord_eq_less_trans
tff(fact_2400_order_Oasym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) ) ) ).

% order.asym
tff(fact_2401_less__imp__neq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ( X2 != Y ) ) ) ).

% less_imp_neq
tff(fact_2402_dense,axiom,
    ! [A: $tType] :
      ( dense_order(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ? [Z3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z3),Y)) ) ) ) ).

% dense
tff(fact_2403_gt__ex,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [X2: A] :
        ? [X_1: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),X_1)) ) ).

% gt_ex
tff(fact_2404_lt__ex,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [X2: A] :
        ? [Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y2),X2)) ) ).

% lt_ex
tff(fact_2405_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N4: nat,A4: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N4))) ) ) ) ).

% power_strict_increasing
tff(fact_2406_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,M2: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M2),N)) ) ) ) ).

% power_less_imp_less_exp
tff(fact_2407_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
            | ( X2 = Y ) ) ) ) ).

% order_le_imp_less_or_eq
tff(fact_2408_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
          | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ).

% linorder_le_less_linear
tff(fact_2409_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A4: A,B3: A,F2: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F2,B3)),C2))
           => ( ! [X: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,X)),aa(A,C,F2,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,A4)),C2)) ) ) ) ) ).

% order_less_le_subst2
tff(fact_2410_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A4: A,F2: fun(B,A),B3: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(B,A,F2,B3)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),B3),C2))
           => ( ! [X: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),X),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F2,X)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(B,A,F2,C2))) ) ) ) ) ).

% order_less_le_subst1
tff(fact_2411_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A4: A,B3: A,F2: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,B3)),C2))
           => ( ! [X: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F2,X)),aa(A,C,F2,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F2,A4)),C2)) ) ) ) ) ).

% order_le_less_subst2
tff(fact_2412_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A4: A,F2: fun(B,A),B3: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(B,A,F2,B3)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),B3),C2))
           => ( ! [X: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X)),aa(B,A,F2,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(B,A,F2,C2))) ) ) ) ) ).

% order_le_less_subst1
tff(fact_2413_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z2)) ) ) ) ).

% order_less_le_trans
tff(fact_2414_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z2)) ) ) ) ).

% order_le_less_trans
tff(fact_2415_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != B3 )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ) ).

% order_neq_le_trans
tff(fact_2416_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( ( A4 != B3 )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ) ).

% order_le_neq_trans
tff(fact_2417_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y)) ) ) ).

% order_less_imp_le
tff(fact_2418_linorder__not__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2)) ) ) ).

% linorder_not_less
tff(fact_2419_linorder__not__le,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ).

% linorder_not_le
tff(fact_2420_order__less__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
            & ( X2 != Y ) ) ) ) ).

% order_less_le
tff(fact_2421_order__le__less,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
            | ( X2 = Y ) ) ) ) ).

% order_le_less
tff(fact_2422_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ).

% dual_order.strict_implies_order
tff(fact_2423_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ).

% order.strict_implies_order
tff(fact_2424_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ) ).

% dual_order.strict_iff_not
tff(fact_2425_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A4)) ) ) ) ).

% dual_order.strict_trans2
tff(fact_2426_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A4)) ) ) ) ).

% dual_order.strict_trans1
tff(fact_2427_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
            & ( A4 != B3 ) ) ) ) ).

% dual_order.strict_iff_order
tff(fact_2428_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
            | ( A4 = B3 ) ) ) ) ).

% dual_order.order_iff_strict
tff(fact_2429_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ( ! [W: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),W))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),W),Y))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),W),Z2)) ) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ) ).

% dense_le_bounded
tff(fact_2430_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),X2))
         => ( ! [W: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),W))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),W),X2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),W)) ) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ) ).

% dense_ge_bounded
tff(fact_2431_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ) ).

% order.strict_iff_not
tff(fact_2432_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),C2)) ) ) ) ).

% order.strict_trans2
tff(fact_2433_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),C2)) ) ) ) ).

% order.strict_trans1
tff(fact_2434_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
            & ( A4 != B3 ) ) ) ) ).

% order.strict_iff_order
tff(fact_2435_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
            | ( A4 = B3 ) ) ) ) ).

% order.order_iff_strict
tff(fact_2436_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y: A,X2: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y)) ) ) ).

% not_le_imp_less
tff(fact_2437_less__le__not__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2)) ) ) ) ).

% less_le_not_le
tff(fact_2438_dense__le,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Y: A,Z2: A] :
          ( ! [X: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Z2)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ).

% dense_le
tff(fact_2439_dense__ge,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z2: A,Y: A] :
          ( ! [X: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),X))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ).

% dense_ge
tff(fact_2440_antisym__conv2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
          <=> ( X2 = Y ) ) ) ) ).

% antisym_conv2
tff(fact_2441_antisym__conv1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
          <=> ( X2 = Y ) ) ) ) ).

% antisym_conv1
tff(fact_2442_nless__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
        <=> ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
            | ( A4 = B3 ) ) ) ) ).

% nless_le
tff(fact_2443_leI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2)) ) ) ).

% leI
tff(fact_2444_leD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y)) ) ) ).

% leD
tff(fact_2445_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),N))
        <=> ( N != zero_zero(A) ) ) ) ).

% zero_less_iff_neq_zero
tff(fact_2446_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [M2: A,N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M2),N))
         => ( N != zero_zero(A) ) ) ) ).

% gr_implies_not_zero
tff(fact_2447_not__less__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),N),zero_zero(A))) ) ).

% not_less_zero
tff(fact_2448_gr__zeroI,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( ( N != zero_zero(A) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),N)) ) ) ).

% gr_zeroI
tff(fact_2449_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ).

% add_less_imp_less_right
tff(fact_2450_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ).

% add_less_imp_less_left
tff(fact_2451_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2))) ) ) ).

% add_strict_right_mono
tff(fact_2452_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3))) ) ) ).

% add_strict_left_mono
tff(fact_2453_add__strict__mono,axiom,
    ! [A: $tType] :
      ( strict9044650504122735259up_add(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),D3))) ) ) ) ).

% add_strict_mono
tff(fact_2454_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I2),J2))
            & ( K = L ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_field(1)
tff(fact_2455_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( I2 = J2 )
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_field(2)
tff(fact_2456_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I2),J2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_field(5)
tff(fact_2457_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),one_one(A))) ) ).

% less_numeral_extra(4)
tff(fact_2458_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),C2))) ) ) ).

% diff_strict_right_mono
tff(fact_2459_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A4)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B3))) ) ) ).

% diff_strict_left_mono
tff(fact_2460_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D3) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D3)) ) ) ) ).

% diff_eq_diff_less
tff(fact_2461_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A,D3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),D3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),D3))) ) ) ) ).

% diff_strict_mono
tff(fact_2462_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A4: A] :
          ( ( A4 != bot_bot(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),bot_bot(A)),A4)) ) ) ).

% bot.not_eq_extremum
tff(fact_2463_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A4: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),bot_bot(A))) ) ).

% bot.extremum_strict
tff(fact_2464_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),A4)),B3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B3)),A4)) ) ) ).

% minus_less_iff
tff(fact_2465_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,uminus_uminus(A),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,uminus_uminus(A),A4))) ) ) ).

% less_minus_iff
tff(fact_2466_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),Y)),X2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),X2)),Y)) ) ) ).

% compl_less_swap2
tff(fact_2467_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(A,A,uminus_uminus(A),X2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(A,A,uminus_uminus(A),Y))) ) ) ).

% compl_less_swap1
tff(fact_2468_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A4: A] :
          ( ( A4 != top_top(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),top_top(A))) ) ) ).

% top.not_eq_extremum
tff(fact_2469_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A4: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),top_top(A)),A4)) ) ).

% top.extremum_strict
tff(fact_2470_less__infI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,X2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),X2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),X2)) ) ) ).

% less_infI1
tff(fact_2471_less__infI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B3: A,X2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),X2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),X2)) ) ) ).

% less_infI2
tff(fact_2472_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) = A4 ) ) ) ).

% inf.absorb3
tff(fact_2473_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) = B3 ) ) ) ).

% inf.absorb4
tff(fact_2474_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),inf_inf(A),B3),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),C2)) ) ) ) ).

% inf.strict_boundedE
tff(fact_2475_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
        <=> ( ( A4 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3) )
            & ( A4 != B3 ) ) ) ) ).

% inf.strict_order_iff
tff(fact_2476_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),C2)) ) ) ).

% inf.strict_coboundedI1
tff(fact_2477_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3)),C2)) ) ) ).

% inf.strict_coboundedI2
tff(fact_2478_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3))) ) ) ).

% sup.strict_coboundedI2
tff(fact_2479_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3))) ) ) ).

% sup.strict_coboundedI1
tff(fact_2480_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
        <=> ( ( A4 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) )
            & ( A4 != B3 ) ) ) ) ).

% sup.strict_order_iff
tff(fact_2481_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B3),C2)),A4))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A4)) ) ) ) ).

% sup.strict_boundedE
tff(fact_2482_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) = B3 ) ) ) ).

% sup.absorb4
tff(fact_2483_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3) = A4 ) ) ) ).

% sup.absorb3
tff(fact_2484_less__supI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3))) ) ) ).

% less_supI2
tff(fact_2485_less__supI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3))) ) ) ).

% less_supI1
tff(fact_2486_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F2: fun(A,B),X2: A,Y: A] :
          ( order_mono(A,B,F2)
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X2)),aa(A,B,F2,Y)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y)) ) ) ) ).

% mono_strict_invE
tff(fact_2487_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N4: nat,A4: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N))) ) ) ) ) ).

% power_strict_decreasing
tff(fact_2488_one__less__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N))) ) ) ) ).

% one_less_power
tff(fact_2489_nat__plus__as__int,axiom,
    ! [X4: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X4),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_plus_as_int
tff(fact_2490_nat__minus__as__int,axiom,
    ! [X4: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X4),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_minus_as_int
tff(fact_2491_nat__times__as__int,axiom,
    ! [X4: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),X4),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_times_as_int
tff(fact_2492_finite__M__bounded__by__nat,axiom,
    ! [P: fun(nat,bool),I2: nat] : pp(aa(set(nat),bool,finite_finite2(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tl(fun(nat,bool),fun(nat,fun(nat,bool)),P),I2)))) ).

% finite_M_bounded_by_nat
tff(fact_2493_wf__less,axiom,
    wf(nat,aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),ord_less(nat)))) ).

% wf_less
tff(fact_2494_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I2),J2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_field(4)
tff(fact_2495_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I2),J2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_field(3)
tff(fact_2496_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),D3))) ) ) ) ).

% add_le_less_mono
tff(fact_2497_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),D3))) ) ) ) ).

% add_less_le_mono
tff(fact_2498_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),zero_zero(A))) ) ) ) ).

% add_neg_neg
tff(fact_2499_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3))) ) ) ) ).

% add_pos_pos
tff(fact_2500_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ~ ! [C4: A] :
                ( ( B3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C4) )
               => ( C4 = zero_zero(A) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
tff(fact_2501_pos__add__strict,axiom,
    ! [A: $tType] :
      ( strict7427464778891057005id_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2))) ) ) ) ).

% pos_add_strict
tff(fact_2502_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y)),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),zero_zero(A)))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),zero_zero(A))) ) ) ) ).

% add_less_zeroD
tff(fact_2503_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord2810124833399127020strict(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3))) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
tff(fact_2504_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) ) ) ) ) ).

% mult_less_cancel_right_disj
tff(fact_2505_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2))) ) ) ) ).

% mult_strict_right_mono
tff(fact_2506_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2))) ) ) ) ).

% mult_strict_right_mono_neg
tff(fact_2507_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) ) ) ) ) ).

% mult_less_cancel_left_disj
tff(fact_2508_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3))) ) ) ) ).

% mult_strict_left_mono
tff(fact_2509_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3))) ) ) ) ).

% mult_strict_left_mono_neg
tff(fact_2510_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ) ).

% mult_less_cancel_left_pos
tff(fact_2511_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) ) ) ) ).

% mult_less_cancel_left_neg
tff(fact_2512_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3)) ) ) ) ).

% zero_less_mult_pos2
tff(fact_2513_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3)) ) ) ) ).

% zero_less_mult_pos
tff(fact_2514_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),zero_zero(A))) ) ) ) ) ).

% zero_less_mult_iff
tff(fact_2515_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)),zero_zero(A))) ) ) ) ).

% mult_pos_neg2
tff(fact_2516_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3))) ) ) ) ).

% mult_pos_pos
tff(fact_2517_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),zero_zero(A))) ) ) ) ).

% mult_pos_neg
tff(fact_2518_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),zero_zero(A))) ) ) ) ).

% mult_neg_pos
tff(fact_2519_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),zero_zero(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),zero_zero(A))) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3)) ) ) ) ) ).

% mult_less_0_iff
tff(fact_2520_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A4: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),A4)),zero_zero(A))) ) ).

% not_square_less_zero
tff(fact_2521_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3))) ) ) ) ).

% mult_neg_neg
tff(fact_2522_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),one_one(A))) ) ).

% less_numeral_extra(1)
tff(fact_2523_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),zero_zero(A))) ) ).

% not_one_less_zero
tff(fact_2524_zero__less__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),one_one(A))) ) ).

% zero_less_one
tff(fact_2525_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),zero_zero(A))) ) ) ).

% less_iff_diff_less_0
tff(fact_2526_add__mono1,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),one_one(A)))) ) ) ).

% add_mono1
tff(fact_2527_less__add__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A)))) ) ).

% less_add_one
tff(fact_2528_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,B3: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)) = A4 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
tff(fact_2529_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),C2)) ) ) ).

% less_diff_eq
tff(fact_2530_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),C2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B3))) ) ) ).

% diff_less_eq
tff(fact_2531_less__1__mult,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [M2: A,N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),M2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),M2),N))) ) ) ) ).

% less_1_mult
tff(fact_2532_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% less_minus_one_simps(4)
tff(fact_2533_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A))) ) ).

% less_minus_one_simps(2)
tff(fact_2534_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [S: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( ( S != bot_bot(set(A)) )
           => ? [X: A] :
                ( pp(aa(set(A),bool,member(A,X),S))
                & ~ ? [Xa3: A] :
                      ( pp(aa(set(A),bool,member(A,Xa3),S))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Xa3),X)) ) ) ) ) ) ).

% ex_min_if_finite
tff(fact_2535_infinite__growing,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X5: set(A)] :
          ( ( X5 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),X5))
               => ? [Xa3: A] :
                    ( pp(aa(set(A),bool,member(A,Xa3),X5))
                    & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Xa3)) ) )
           => ~ pp(aa(set(A),bool,finite_finite2(A),X5)) ) ) ) ).

% infinite_growing
tff(fact_2536_less__cSupE,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [Y: A,X5: set(A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(set(A),A,complete_Sup_Sup(A),X5)))
         => ( ( X5 != bot_bot(set(A)) )
           => ~ ! [X: A] :
                  ( pp(aa(set(A),bool,member(A,X),X5))
                 => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X)) ) ) ) ) ).

% less_cSupE
tff(fact_2537_less__cSupD,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X5: set(A),Z2: A] :
          ( ( X5 != bot_bot(set(A)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),aa(set(A),A,complete_Sup_Sup(A),X5)))
           => ? [X: A] :
                ( pp(aa(set(A),bool,member(A,X),X5))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),X)) ) ) ) ) ).

% less_cSupD
tff(fact_2538_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( aa(A,A,abs_abs(A),A4) = A4 ) ) ) ).

% abs_of_pos
tff(fact_2539_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),A4)),zero_zero(A))) ) ).

% abs_not_less_zero
tff(fact_2540_cInf__lessD,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X5: set(A),Z2: A] :
          ( ( X5 != bot_bot(set(A)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),X5)),Z2))
           => ? [X: A] :
                ( pp(aa(set(A),bool,member(A,X),X5))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z2)) ) ) ) ) ).

% cInf_lessD
tff(fact_2541_abs__mult__less,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),A4)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),B3)),D3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),B3))),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D3))) ) ) ) ).

% abs_mult_less
tff(fact_2542_abs__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),A4)),B3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),A4)),B3)) ) ) ) ).

% abs_less_iff
tff(fact_2543_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F2: fun(A,B),X2: A,Y: A] :
          ( order_mono(A,B,F2)
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X2)),aa(A,B,F2,Y)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y)) ) ) ) ).

% mono_invE
tff(fact_2544_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add(A)
        & semiring_1(A) )
     => ! [A3: set(B),F2: fun(B,A),K5: A] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,I3)),K5)) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(set(B),nat,finite_card(B),A3)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),A3))),K5))) ) ) ) ).

% sum_bounded_above_strict
tff(fact_2545_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),A3: set(B),Y: A,I2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),Y))
         => ( pp(aa(set(B),bool,member(B,I2),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,I2)),Y)) ) ) ) ).

% SUP_lessD
tff(fact_2546_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A4: A,F2: fun(B,A),A3: set(B)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))))
        <=> ? [X3: B] :
              ( pp(aa(set(B),bool,member(B,X3),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(B,A,F2,X3))) ) ) ) ).

% less_SUP_iff
tff(fact_2547_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Y: A,F2: fun(B,A),A3: set(B),I2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))))
         => ( pp(aa(set(B),bool,member(B,I2),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(B,A,F2,I2))) ) ) ) ).

% less_INF_D
tff(fact_2548_INF__less__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F2: fun(B,A),A3: set(B),A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))),A4))
        <=> ? [X3: B] :
              ( pp(aa(set(B),bool,member(B,X3),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X3)),A4)) ) ) ) ).

% INF_less_iff
tff(fact_2549_filter__preserves__multiset,axiom,
    ! [A: $tType,M: fun(A,nat),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_tm(fun(A,nat),fun(A,bool),M))))
     => pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_tn(fun(A,nat),fun(fun(A,bool),fun(A,bool)),M),P)))) ) ).

% filter_preserves_multiset
tff(fact_2550_card__less__Suc2,axiom,
    ! [M: set(nat),I2: nat] :
      ( ~ pp(aa(set(nat),bool,member(nat,zero_zero(nat)),M))
     => ( aa(set(nat),nat,finite_card(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_to(set(nat),fun(nat,fun(nat,bool)),M),I2))) = aa(set(nat),nat,finite_card(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tp(set(nat),fun(nat,fun(nat,bool)),M),I2))) ) ) ).

% card_less_Suc2
tff(fact_2551_card__less__Suc,axiom,
    ! [M: set(nat),I2: nat] :
      ( pp(aa(set(nat),bool,member(nat,zero_zero(nat)),M))
     => ( aa(nat,nat,suc,aa(set(nat),nat,finite_card(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_to(set(nat),fun(nat,fun(nat,bool)),M),I2)))) = aa(set(nat),nat,finite_card(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tp(set(nat),fun(nat,fun(nat,bool)),M),I2))) ) ) ).

% card_less_Suc
tff(fact_2552_card__less,axiom,
    ! [M: set(nat),I2: nat] :
      ( pp(aa(set(nat),bool,member(nat,zero_zero(nat)),M))
     => ( aa(set(nat),nat,finite_card(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tp(set(nat),fun(nat,fun(nat,bool)),M),I2))) != zero_zero(nat) ) ) ).

% card_less
tff(fact_2553_wf,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => wf(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),ord_less(A)))) ) ).

% wf
tff(fact_2554_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A3: set(A),F2: fun(nat,A),N: nat] :
      ( ( A3 = aa(set(nat),set(A),image2(nat,A,F2),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N))) )
     => pp(aa(set(A),bool,finite_finite2(A),A3)) ) ).

% nat_seg_image_imp_finite
tff(fact_2555_finite__conv__nat__seg__image,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
    <=> ? [N5: nat,F8: fun(nat,A)] : ( A3 = aa(set(nat),set(A),image2(nat,A,F8),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N5))) ) ) ).

% finite_conv_nat_seg_image
tff(fact_2556_wf__if__measure,axiom,
    ! [A: $tType,P: fun(A,bool),F2: fun(A,nat),G: fun(A,A)] :
      ( ! [X: A] :
          ( pp(aa(A,bool,P,X))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F2,aa(A,A,G,X))),aa(A,nat,F2,X))) )
     => wf(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(fun(A,A),fun(A,fun(A,bool)),aTP_Lamp_tq(fun(A,bool),fun(fun(A,A),fun(A,fun(A,bool))),P),G)))) ) ).

% wf_if_measure
tff(fact_2557_Field__natLeq__on,axiom,
    ! [N: nat] : ( field2(nat,aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_tr(nat,fun(nat,fun(nat,bool)),N)))) = aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N)) ) ).

% Field_natLeq_on
tff(fact_2558_natLeq__on__wo__rel,axiom,
    ! [N: nat] : bNF_Wellorder_wo_rel(nat,aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_tr(nat,fun(nat,fun(nat,bool)),N)))) ).

% natLeq_on_wo_rel
tff(fact_2559_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ? [F9: fun(A,nat),N2: nat] :
          ( ( aa(set(A),set(nat),image2(A,nat,F9),A3) = aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N2)) )
          & inj_on(A,nat,F9,A3) ) ) ).

% finite_imp_inj_to_nat_seg
tff(fact_2560_finite__imp__inj__to__nat__seg_H,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ~ ! [F9: fun(A,nat)] :
            ( ? [N2: nat] : ( aa(set(A),set(nat),image2(A,nat,F9),A3) = aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N2)) )
           => ~ inj_on(A,nat,F9,A3) ) ) ).

% finite_imp_inj_to_nat_seg'
tff(fact_2561_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( unboun7993243217541854897norder(A)
     => ! [C2: A] : eventually(A,aTP_Lamp_ts(A,fun(A,bool),C2),at_bot(A)) ) ).

% eventually_gt_at_bot
tff(fact_2562_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),zero_zero(A))) ) ) ) ).

% add_neg_nonpos
tff(fact_2563_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3))) ) ) ) ).

% add_nonneg_pos
tff(fact_2564_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),zero_zero(A))) ) ) ) ).

% add_nonpos_neg
tff(fact_2565_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3))) ) ) ) ).

% add_pos_nonneg
tff(fact_2566_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2))) ) ) ) ).

% add_strict_increasing
tff(fact_2567_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2))) ) ) ) ).

% add_strict_increasing2
tff(fact_2568_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ) ) ).

% mult_le_cancel_left
tff(fact_2569_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ) ) ).

% mult_le_cancel_right
tff(fact_2570_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ) ).

% mult_left_less_imp_less
tff(fact_2571_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),D3))) ) ) ) ) ) ).

% mult_strict_mono
tff(fact_2572_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) ) ) ) ) ).

% mult_less_cancel_left
tff(fact_2573_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ) ).

% mult_right_less_imp_less
tff(fact_2574_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),D3))) ) ) ) ) ) ).

% mult_strict_mono'
tff(fact_2575_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) ) ) ) ) ).

% mult_less_cancel_right
tff(fact_2576_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ) ).

% mult_le_cancel_left_neg
tff(fact_2577_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ) ).

% mult_le_cancel_left_pos
tff(fact_2578_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ) ).

% mult_left_le_imp_le
tff(fact_2579_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ) ).

% mult_right_le_imp_le
tff(fact_2580_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),D3))) ) ) ) ) ) ).

% mult_le_less_imp_less
tff(fact_2581_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),D3))) ) ) ) ) ) ).

% mult_less_le_imp_less
tff(fact_2582_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X2: A,Y: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))),zero_zero(A))) ) ).

% not_sum_squares_lt_zero
tff(fact_2583_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))))
        <=> ( ( X2 != zero_zero(A) )
            | ( Y != zero_zero(A) ) ) ) ) ).

% sum_squares_gt_zero_iff
tff(fact_2584_discrete,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))),B3)) ) ) ).

% discrete
tff(fact_2585_zero__less__two,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))) ) ).

% zero_less_two
tff(fact_2586_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% less_minus_one_simps(3)
tff(fact_2587_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A))) ) ).

% less_minus_one_simps(1)
tff(fact_2588_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),E2)),D3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),E2)),C2)),D3)) ) ) ).

% less_add_iff1
tff(fact_2589_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A4: A,E2: A,C2: A,B3: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),E2)),D3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4)),E2)),D3))) ) ) ).

% less_add_iff2
tff(fact_2590_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A4)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B3))) ) ) ) ) ).

% divide_strict_left_mono_neg
tff(fact_2591_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A4)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B3))) ) ) ) ) ).

% divide_strict_left_mono
tff(fact_2592_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z2: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)),X2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y))) ) ) ) ).

% mult_imp_less_div_pos
tff(fact_2593_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,X2: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y)),Z2)) ) ) ) ).

% mult_imp_div_pos_less
tff(fact_2594_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3)) ) ) ) ).

% pos_less_divide_eq
tff(fact_2595_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),A4))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) ) ) ) ).

% pos_divide_less_eq
tff(fact_2596_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) ) ) ) ).

% neg_less_divide_eq
tff(fact_2597_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),A4))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3)) ) ) ) ).

% neg_divide_less_eq
tff(fact_2598_less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A))) ) ) ) ) ) ) ).

% less_divide_eq
tff(fact_2599_divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),A4))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4)) ) ) ) ) ) ) ).

% divide_less_eq
tff(fact_2600_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)),one_one(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) )
            | ( A4 = zero_zero(A) ) ) ) ) ).

% divide_less_eq_1
tff(fact_2601_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) ) ) ) ) ).

% less_divide_eq_1
tff(fact_2602_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X2))
         => ? [N2: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N2)),X2))) ) ) ).

% ex_less_of_nat_mult
tff(fact_2603_gt__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))),B3)) ) ) ).

% gt_half_sum
tff(fact_2604_less__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A))))) ) ) ).

% less_half_sum
tff(fact_2605_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs(A)
        & dense_linorder(A) )
     => ! [X2: A] :
          ( ! [E4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),E4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X2)),E4)) )
         => ( X2 = zero_zero(A) ) ) ) ).

% dense_eq0_I
tff(fact_2606_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)))) ) ) ).

% power_less_power_Suc
tff(fact_2607_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)))) ) ) ).

% power_gt1_lemma
tff(fact_2608_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),P: fun(set(A),bool)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
           => ( ! [B4: A,A11: set(A)] :
                  ( pp(aa(set(A),bool,finite_finite2(A),A11))
                 => ( ! [X4: A] :
                        ( pp(aa(set(A),bool,member(A,X4),A11))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B4),X4)) )
                   => ( pp(aa(set(A),bool,P,A11))
                     => pp(aa(set(A),bool,P,aa(set(A),set(A),insert(A,B4),A11))) ) ) )
             => pp(aa(set(A),bool,P,A3)) ) ) ) ) ).

% finite_linorder_min_induct
tff(fact_2609_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),P: fun(set(A),bool)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
           => ( ! [B4: A,A11: set(A)] :
                  ( pp(aa(set(A),bool,finite_finite2(A),A11))
                 => ( ! [X4: A] :
                        ( pp(aa(set(A),bool,member(A,X4),A11))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),B4)) )
                   => ( pp(aa(set(A),bool,P,A11))
                     => pp(aa(set(A),bool,P,aa(set(A),set(A),insert(A,B4),A11))) ) ) )
             => pp(aa(set(A),bool,P,A3)) ) ) ) ) ).

% finite_linorder_max_induct
tff(fact_2610_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X5: set(A),A4: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),X5))
         => ( ( X5 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Sup_Sup(A),X5)),A4))
            <=> ! [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),X5))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),A4)) ) ) ) ) ) ).

% finite_Sup_less_iff
tff(fact_2611_power__gt1,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(nat,nat,suc,N)))) ) ) ).

% power_gt1
tff(fact_2612_abs__if,axiom,
    ! [A: $tType] :
      ( abs_if(A)
     => ! [A4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
           => ( aa(A,A,abs_abs(A),A4) = aa(A,A,uminus_uminus(A),A4) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
           => ( aa(A,A,abs_abs(A),A4) = A4 ) ) ) ) ).

% abs_if
tff(fact_2613_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
         => ( aa(A,A,abs_abs(A),A4) = aa(A,A,uminus_uminus(A),A4) ) ) ) ).

% abs_of_neg
tff(fact_2614_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,A4: A,R2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),A4))),R2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),R2)),X2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),R2))) ) ) ) ).

% abs_diff_less_iff
tff(fact_2615_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X5: set(A),A4: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),X5))
         => ( ( X5 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(set(A),A,complete_Inf_Inf(A),X5)))
            <=> ! [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),X5))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),X3)) ) ) ) ) ) ).

% finite_less_Inf_iff
tff(fact_2616_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( strict7427464778891057005id_add(A)
     => ! [A3: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [X: B] :
                  ( pp(aa(set(B),bool,member(B,X),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X)),aa(B,A,G,X))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3))) ) ) ) ) ).

% sum_strict_mono
tff(fact_2617_less__cSup__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X5: set(A),Y: A] :
          ( ( X5 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,X5)
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(set(A),A,complete_Sup_Sup(A),X5)))
            <=> ? [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),X5))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X3)) ) ) ) ) ) ).

% less_cSup_iff
tff(fact_2618_cInf__less__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X5: set(A),Y: A] :
          ( ( X5 != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),X5))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),X5)),Y))
            <=> ? [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),X5))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y)) ) ) ) ) ) ).

% cInf_less_iff
tff(fact_2619_Un__interval,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [B12: A,B23: A,B32: A,F2: fun(A,B)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B12),B23))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B23),B32))
           => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(fun(B,bool),set(B),collect(B),aa(fun(A,B),fun(B,bool),aa(A,fun(fun(A,B),fun(B,bool)),aTP_Lamp_tt(A,fun(A,fun(fun(A,B),fun(B,bool))),B12),B23),F2))),aa(fun(B,bool),set(B),collect(B),aa(fun(A,B),fun(B,bool),aa(A,fun(fun(A,B),fun(B,bool)),aTP_Lamp_tt(A,fun(A,fun(fun(A,B),fun(B,bool))),B23),B32),F2))) = aa(fun(B,bool),set(B),collect(B),aa(fun(A,B),fun(B,bool),aa(A,fun(fun(A,B),fun(B,bool)),aTP_Lamp_tt(A,fun(A,fun(fun(A,B),fun(B,bool))),B12),B32),F2)) ) ) ) ) ).

% Un_interval
tff(fact_2620_add__mset__in__multiset,axiom,
    ! [A: $tType,M: fun(A,nat),A4: A] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_tm(fun(A,nat),fun(A,bool),M))))
     => pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_tu(fun(A,nat),fun(A,fun(A,bool)),M),A4)))) ) ).

% add_mset_in_multiset
tff(fact_2621_diff__preserves__multiset,axiom,
    ! [A: $tType,M: fun(A,nat),N4: fun(A,nat)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_tm(fun(A,nat),fun(A,bool),M))))
     => pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(fun(A,nat),fun(A,bool),aTP_Lamp_tv(fun(A,nat),fun(fun(A,nat),fun(A,bool)),M),N4)))) ) ).

% diff_preserves_multiset
tff(fact_2622_cSUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [F2: fun(B,A),A3: set(B),Y: A,I2: B] :
          ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))),Y))
           => ( pp(aa(set(B),bool,member(B,I2),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,I2)),Y)) ) ) ) ) ).

% cSUP_lessD
tff(fact_2623_less__cINF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [F2: fun(B,A),A3: set(B),Y: A,I2: B] :
          ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,F2),A3)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))))
           => ( pp(aa(set(B),bool,member(B,I2),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(B,A,F2,I2))) ) ) ) ) ).

% less_cINF_D
tff(fact_2624_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [S: set(A),F2: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( ( S != bot_bot(set(A)) )
           => ~ ? [X4: A] :
                  ( pp(aa(set(A),bool,member(A,X4),S))
                  & pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X4)),aa(A,B,F2,lattic7623131987881927897min_on(A,B,F2,S)))) ) ) ) ) ).

% arg_min_if_finite(2)
tff(fact_2625_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ? [N2: nat,F9: fun(nat,A)] :
          ( ( A3 = aa(set(nat),set(A),image2(nat,A,F9),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N2))) )
          & inj_on(nat,A,F9,aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N2))) ) ) ).

% finite_imp_nat_seg_image_inj_on
tff(fact_2626_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4)) ) ) ) ) ).

% mult_less_cancel_right2
tff(fact_2627_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),one_one(A))) ) ) ) ) ).

% mult_less_cancel_right1
tff(fact_2628_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4)) ) ) ) ) ).

% mult_less_cancel_left2
tff(fact_2629_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),one_one(A))) ) ) ) ) ).

% mult_less_cancel_left1
tff(fact_2630_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A4)) ) ) ) ) ).

% mult_le_cancel_right2
tff(fact_2631_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),B3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),one_one(A))) ) ) ) ) ).

% mult_le_cancel_right1
tff(fact_2632_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A4)) ) ) ) ) ).

% mult_le_cancel_left2
tff(fact_2633_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),B3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),one_one(A))) ) ) ) ) ).

% mult_le_cancel_left1
tff(fact_2634_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y: A] :
          ( ! [Z3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z3),one_one(A)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z3),X2)),Y)) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y)) ) ) ).

% field_le_mult_one_interval
tff(fact_2635_divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),A4))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4)) ) ) ) ) ) ) ).

% divide_le_eq
tff(fact_2636_le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A))) ) ) ) ) ) ) ).

% le_divide_eq
tff(fact_2637_divide__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A4)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B3))) ) ) ) ) ).

% divide_left_mono
tff(fact_2638_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),A4))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3)) ) ) ) ).

% neg_divide_le_eq
tff(fact_2639_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) ) ) ) ).

% neg_le_divide_eq
tff(fact_2640_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),A4))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) ) ) ) ).

% pos_divide_le_eq
tff(fact_2641_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3)) ) ) ) ).

% pos_le_divide_eq
tff(fact_2642_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,X2: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y)),Z2)) ) ) ) ).

% mult_imp_div_pos_le
tff(fact_2643_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z2: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)),X2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y))) ) ) ) ).

% mult_imp_le_div_pos
tff(fact_2644_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A4)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B3))) ) ) ) ) ).

% divide_left_mono_neg
tff(fact_2645_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ) ) ).

% le_divide_eq_1
tff(fact_2646_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)),one_one(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) )
            | ( A4 = zero_zero(A) ) ) ) ) ).

% divide_le_eq_1
tff(fact_2647_frac__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z2: A,X2: A,W2: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z2 != zero_zero(A) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W2),Z2)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2))),zero_zero(A))) ) ) ) ) ).

% frac_less_eq
tff(fact_2648_power__Suc__less,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N))),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N))) ) ) ) ).

% power_Suc_less
tff(fact_2649_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,uminus_uminus(A),B3))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A))) ) ) ) ) ) ) ).

% less_minus_divide_eq
tff(fact_2650_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))),A4))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,uminus_uminus(A),B3))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4)) ) ) ) ) ) ) ).

% minus_divide_less_eq
tff(fact_2651_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) ) ) ) ).

% neg_less_minus_divide_eq
tff(fact_2652_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))),A4))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,uminus_uminus(A),B3))) ) ) ) ).

% neg_minus_divide_less_eq
tff(fact_2653_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,uminus_uminus(A),B3))) ) ) ) ).

% pos_less_minus_divide_eq
tff(fact_2654_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))),A4))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) ) ) ) ).

% pos_minus_divide_less_eq
tff(fact_2655_filterlim__at__bot__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( dense_linorder(B)
        & no_bot(B) )
     => ! [F2: fun(A,B),F: filter(A)] :
          ( filterlim(A,B,F2,at_bot(B),F)
        <=> ! [Z6: B] : eventually(A,aa(B,fun(A,bool),aTP_Lamp_tw(fun(A,B),fun(B,fun(A,bool)),F2),Z6),F) ) ) ).

% filterlim_at_bot_dense
tff(fact_2656_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(nat,nat,suc,N))),one_one(A))) ) ) ) ).

% power_Suc_less_one
tff(fact_2657_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,abs_abs(A),X2)))) ) ).

% abs_add_one_gt_zero
tff(fact_2658_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [I: set(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),I))
         => ( ( I != bot_bot(set(B)) )
           => ( ! [I3: B] :
                  ( pp(aa(set(B),bool,member(B,I3),I))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(B,A,F2,I3))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),I))) ) ) ) ) ).

% sum_pos
tff(fact_2659_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,M2: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N)) ) ) ) ).

% power_le_imp_le_exp
tff(fact_2660_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I: set(A),I2: A,F2: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite2(A),I))
         => ( pp(aa(set(A),bool,member(A,I2),I))
           => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),aa(A,B,F2,I2)))
             => ( ! [I3: A] :
                    ( pp(aa(set(A),bool,member(A,I3),I))
                   => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),one_one(B)),aa(A,B,F2,I3))) )
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),I))) ) ) ) ) ) ).

% less_1_prod2
tff(fact_2661_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I: set(A),F2: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite2(A),I))
         => ( ( I != bot_bot(set(A)) )
           => ( ! [I3: A] :
                  ( pp(aa(set(A),bool,member(A,I3),I))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),aa(A,B,F2,I3))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),I))) ) ) ) ) ).

% less_1_prod
tff(fact_2662_self__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A4))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N))) ) ) ) ).

% self_le_power
tff(fact_2663_card__gt__0__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),A3)))
    <=> ( ( A3 != bot_bot(set(A)) )
        & pp(aa(set(A),bool,finite_finite2(A),A3)) ) ) ).

% card_gt_0_iff
tff(fact_2664_less__cSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [A3: set(B),F2: fun(B,A),A4: A] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F2),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),A3))))
            <=> ? [X3: B] :
                  ( pp(aa(set(B),bool,member(B,X3),A3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(B,A,F2,X3))) ) ) ) ) ) ).

% less_cSUP_iff
tff(fact_2665_cINF__less__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [A3: set(B),F2: fun(B,A),A4: A] :
          ( ( A3 != bot_bot(set(B)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),aa(set(B),set(A),image2(B,A,F2),A3)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))),A4))
            <=> ? [X3: B] :
                  ( pp(aa(set(B),bool,member(B,X3),A3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,X3)),A4)) ) ) ) ) ) ).

% cINF_less_iff
tff(fact_2666_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( linord715952674999750819strict(A)
     => ! [X2: A,A4: A,Y: A,U: A,V: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),U))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),V))
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y))),A4)) ) ) ) ) ) ) ).

% convex_bound_lt
tff(fact_2667_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))),A4))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) ) ) ) ).

% pos_minus_divide_le_eq
tff(fact_2668_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,uminus_uminus(A),B3))) ) ) ) ).

% pos_le_minus_divide_eq
tff(fact_2669_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))),A4))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,uminus_uminus(A),B3))) ) ) ) ).

% neg_minus_divide_le_eq
tff(fact_2670_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) ) ) ) ).

% neg_le_minus_divide_eq
tff(fact_2671_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))),A4))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,uminus_uminus(A),B3))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4)) ) ) ) ) ) ) ).

% minus_divide_le_eq
tff(fact_2672_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,uminus_uminus(A),B3))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),zero_zero(A))) ) ) ) ) ) ) ).

% le_minus_divide_eq
tff(fact_2673_filterlim__at__bot__lt,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F2: fun(A,B),F: filter(A),C2: B] :
          ( filterlim(A,B,F2,at_bot(B),F)
        <=> ! [Z6: B] :
              ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),Z6),C2))
             => eventually(A,aa(B,fun(A,bool),aTP_Lamp_tx(fun(A,B),fun(B,fun(A,bool)),F2),Z6),F) ) ) ) ).

% filterlim_at_bot_lt
tff(fact_2674_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_semidom(A)
     => ! [A3: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,member(B,I3),A3))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F2,I3)))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F2,I3)),aa(B,A,G,I3))) ) )
           => ( ( A3 != bot_bot(set(B)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3))) ) ) ) ) ).

% prod_mono_strict
tff(fact_2675_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [E2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),E2))
         => ~ ! [N2: nat] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N2)))),E2)) ) ) ).

% nat_approx_posE
tff(fact_2676_card__Diff1__less__iff,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3)))
    <=> ( pp(aa(set(A),bool,finite_finite2(A),A3))
        & pp(aa(set(A),bool,member(A,X2),A3)) ) ) ).

% card_Diff1_less_iff
tff(fact_2677_card__Diff2__less,axiom,
    ! [A: $tType,A3: set(A),X2: A,Y: A] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(A),bool,member(A,X2),A3))
       => ( pp(aa(set(A),bool,member(A,Y),A3))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),aa(set(A),set(A),insert(A,Y),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3))) ) ) ) ).

% card_Diff2_less
tff(fact_2678_card__Diff1__less,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(A),bool,member(A,X2),A3))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3))) ) ) ).

% card_Diff1_less
tff(fact_2679_power__minus__mult,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [N: nat,A4: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))),A4) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N) ) ) ) ).

% power_minus_mult
tff(fact_2680_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,X2: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),C2)),set_or1337092689740270186AtMost(A,X2,Y)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),X2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),C2)),set_or1337092689740270186AtMost(A,X2,Y)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y),aa(A,A,aa(A,fun(A,A),times_times(A),C2),X2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),C2)),set_or1337092689740270186AtMost(A,X2,Y)) = bot_bot(set(A)) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
tff(fact_2681_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y: A,C2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
               => ( aa(set(A),set(A),image2(A,A,aTP_Lamp_ty(A,fun(A,A),C2)),set_or1337092689740270186AtMost(A,X2,Y)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),X2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),Y),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
               => ( aa(set(A),set(A),image2(A,A,aTP_Lamp_ty(A,fun(A,A),C2)),set_or1337092689740270186AtMost(A,X2,Y)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),Y),C2),aa(A,A,aa(A,fun(A,A),times_times(A),X2),C2)) ) ) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
           => ( aa(set(A),set(A),image2(A,A,aTP_Lamp_ty(A,fun(A,A),C2)),set_or1337092689740270186AtMost(A,X2,Y)) = bot_bot(set(A)) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
tff(fact_2682_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),A4: nat,B3: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,A4,B3)) = set_fo6178422350223883121st_nat(A,aTP_Lamp_tz(fun(nat,A),fun(nat,fun(A,A)),F2),A4,B3,zero_zero(A)) ) ) ).

% sum_atLeastAtMost_code
tff(fact_2683_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y)) ) ) ) ).

% mult_le_cancel_iff2
tff(fact_2684_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y)) ) ) ) ).

% mult_le_cancel_iff1
tff(fact_2685_natLess__def,axiom,
    bNF_Ca8459412986667044542atLess = aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),ord_less(nat))) ).

% natLess_def
tff(fact_2686_divmod__nat__if,axiom,
    ! [N: nat,M2: nat] :
      ( ( ( ( N = zero_zero(nat) )
          | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M2),N)) )
       => ( divmod_nat(M2,N) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),M2) ) )
      & ( ~ ( ( N = zero_zero(nat) )
            | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M2),N)) )
       => ( divmod_nat(M2,N) = aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_ua(nat,fun(nat,product_prod(nat,nat)))),divmod_nat(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),N),N)) ) ) ) ).

% divmod_nat_if
tff(fact_2687_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y)) ) ) ) ).

% mult_less_iff1
tff(fact_2688_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ub(nat,fun(nat,A),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) = zero_zero(A) ) ) ) ).

% choose_alternating_sum
tff(fact_2689_finite__interval__int4,axiom,
    ! [A4: int,B3: int] : pp(aa(set(int),bool,finite_finite2(int),aa(fun(int,bool),set(int),collect(int),aa(int,fun(int,bool),aTP_Lamp_uc(int,fun(int,fun(int,bool)),A4),B3)))) ).

% finite_interval_int4
tff(fact_2690_finite__interval__int2,axiom,
    ! [A4: int,B3: int] : pp(aa(set(int),bool,finite_finite2(int),aa(fun(int,bool),set(int),collect(int),aa(int,fun(int,bool),aTP_Lamp_ud(int,fun(int,fun(int,bool)),A4),B3)))) ).

% finite_interval_int2
tff(fact_2691_finite__interval__int3,axiom,
    ! [A4: int,B3: int] : pp(aa(set(int),bool,finite_finite2(int),aa(fun(int,bool),set(int),collect(int),aa(int,fun(int,bool),aTP_Lamp_ue(int,fun(int,fun(int,bool)),A4),B3)))) ).

% finite_interval_int3
tff(fact_2692_not__psubset__empty,axiom,
    ! [A: $tType,A3: set(A)] : ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A3),bot_bot(set(A)))) ).

% not_psubset_empty
tff(fact_2693_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less(fun(A,B)),F2),G))
        <=> ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F2),G))
            & ~ pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),G),F2)) ) ) ) ).

% less_fun_def
tff(fact_2694_less__assn__def,axiom,
    ! [A4: assn,B3: assn] :
      ( pp(aa(assn,bool,aa(assn,fun(assn,bool),ord_less(assn),A4),B3))
    <=> ( pp(aa(assn,bool,aa(assn,fun(assn,bool),ord_less_eq(assn),A4),B3))
        & ( A4 != B3 ) ) ) ).

% less_assn_def
tff(fact_2695_simp__from__to,axiom,
    ! [J2: int,I2: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J2),I2))
       => ( set_or1337092689740270186AtMost(int,I2,J2) = bot_bot(set(int)) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J2),I2))
       => ( set_or1337092689740270186AtMost(int,I2,J2) = aa(set(int),set(int),insert(int,I2),set_or1337092689740270186AtMost(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int)),J2)) ) ) ) ).

% simp_from_to
tff(fact_2696_sum__choose__upper,axiom,
    ! [M2: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_uf(nat,fun(nat,nat),M2)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,nat,binomial(aa(nat,nat,suc,N)),aa(nat,nat,suc,M2)) ) ).

% sum_choose_upper
tff(fact_2697_nat__less__as__int,axiom,
    ! [X4: nat,Xa3: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X4),Xa3))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_less_as_int
tff(fact_2698_remove__subset,axiom,
    ! [A: $tType,X2: A,S: set(A)] :
      ( pp(aa(set(A),bool,member(A,X2),S))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),S)) ) ).

% remove_subset
tff(fact_2699_disjoint__alt__simp3,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B2)),A3))
    <=> ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) != bot_bot(set(A)) ) ) ).

% disjoint_alt_simp3
tff(fact_2700_sum__choose__lower,axiom,
    ! [R2: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_ug(nat,fun(nat,nat),R2)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),R2),N))),N) ) ).

% sum_choose_lower
tff(fact_2701_choose__rising__sum_I1_J,axiom,
    ! [N: nat,M2: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_uh(nat,fun(nat,nat),N)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M2)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))) ) ).

% choose_rising_sum(1)
tff(fact_2702_choose__rising__sum_I2_J,axiom,
    ! [N: nat,M2: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_uh(nat,fun(nat,nat),N)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M2)),one_one(nat))),M2) ) ).

% choose_rising_sum(2)
tff(fact_2703_diff__nat__eq__if,axiom,
    ! [Z7: int,Z2: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z7),zero_zero(int)))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z2)),aa(int,nat,nat2,Z7)) = aa(int,nat,nat2,Z2) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z7),zero_zero(int)))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z2)),aa(int,nat,nat2,Z7)) = if(nat,aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z2),Z7)),zero_zero(int)),zero_zero(nat),aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),Z2),Z7))) ) ) ) ).

% diff_nat_eq_if
tff(fact_2704_wf__bounded__supset,axiom,
    ! [A: $tType,S: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),S))
     => wf(set(A),aa(fun(product_prod(set(A),set(A)),bool),set(product_prod(set(A),set(A))),collect(product_prod(set(A),set(A))),aa(fun(set(A),fun(set(A),bool)),fun(product_prod(set(A),set(A)),bool),product_case_prod(set(A),set(A),bool),aTP_Lamp_ui(set(A),fun(set(A),fun(set(A),bool)),S)))) ) ).

% wf_bounded_supset
tff(fact_2705_finite__subset__wf,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => wf(set(A),aa(fun(product_prod(set(A),set(A)),bool),set(product_prod(set(A),set(A))),collect(product_prod(set(A),set(A))),aa(fun(set(A),fun(set(A),bool)),fun(product_prod(set(A),set(A)),bool),product_case_prod(set(A),set(A),bool),aTP_Lamp_uj(set(A),fun(set(A),fun(set(A),bool)),A3)))) ) ).

% finite_subset_wf
tff(fact_2706_finite__induct__select,axiom,
    ! [A: $tType,S: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),S))
     => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
       => ( ! [T5: set(A)] :
              ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),T5),S))
             => ( pp(aa(set(A),bool,P,T5))
               => ? [X4: A] :
                    ( pp(aa(set(A),bool,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),T5)))
                    & pp(aa(set(A),bool,P,aa(set(A),set(A),insert(A,X4),T5))) ) ) )
         => pp(aa(set(A),bool,P,S)) ) ) ) ).

% finite_induct_select
tff(fact_2707_psubset__insert__iff,axiom,
    ! [A: $tType,A3: set(A),X2: A,B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A3),aa(set(A),set(A),insert(A,X2),B2)))
    <=> ( ( pp(aa(set(A),bool,member(A,X2),B2))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A3),B2)) )
        & ( ~ pp(aa(set(A),bool,member(A,X2),B2))
         => ( ( pp(aa(set(A),bool,member(A,X2),A3))
             => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),B2)) )
            & ( ~ pp(aa(set(A),bool,member(A,X2),A3))
             => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2)) ) ) ) ) ) ).

% psubset_insert_iff
tff(fact_2708_sum__choose__diagonal,axiom,
    ! [M2: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
     => ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_uk(nat,fun(nat,fun(nat,nat)),M2),N)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,nat,binomial(aa(nat,nat,suc,N)),M2) ) ) ).

% sum_choose_diagonal
tff(fact_2709_vandermonde,axiom,
    ! [M2: nat,N: nat,R2: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_ul(nat,fun(nat,fun(nat,fun(nat,nat))),M2),N),R2)),aa(nat,set(nat),set_ord_atMost(nat),R2)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),N)),R2) ) ).

% vandermonde
tff(fact_2710_binomial,axiom,
    ! [A4: nat,B3: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),B3)),N) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_um(nat,fun(nat,fun(nat,fun(nat,nat))),A4),B3),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ).

% binomial
tff(fact_2711_n__subsets,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( aa(set(set(A)),nat,finite_card(set(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aa(nat,fun(set(A),bool),aTP_Lamp_un(set(A),fun(nat,fun(set(A),bool)),A3),K))) = aa(nat,nat,binomial(aa(set(A),nat,finite_card(A),A3)),K) ) ) ).

% n_subsets
tff(fact_2712_binomial__ring,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A,B3: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_uo(A,fun(A,fun(nat,fun(nat,A))),A4),B3),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% binomial_ring
tff(fact_2713_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( ( N != one_one(nat) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_up(nat,fun(nat,A),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) = zero_zero(A) ) ) ) ).

% choose_alternating_linear_sum
tff(fact_2714_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: fun(nat,set(A)),S: set(A)] :
      ( ! [I3: nat] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(nat,set(A),F2,I3)),S))
     => ( pp(aa(set(A),bool,finite_finite2(A),S))
       => ( ? [N6: nat] :
              ( ! [N2: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N2),N6))
                 => ! [M3: nat] :
                      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M3),N6))
                     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N2))
                       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),aa(nat,set(A),F2,M3)),aa(nat,set(A),F2,N2))) ) ) )
              & ! [N2: nat] :
                  ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N6),N2))
                 => ( aa(nat,set(A),F2,N6) = aa(nat,set(A),F2,N2) ) ) )
         => ( aa(nat,set(A),F2,aa(set(A),nat,finite_card(A),S)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),F2),top_top(set(nat)))) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
tff(fact_2715_mlex__eq,axiom,
    ! [A: $tType,F2: fun(A,nat),R: set(product_prod(A,A))] : ( mlex_prod(A,F2,R) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aTP_Lamp_uq(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,bool))),F2),R))) ) ).

% mlex_eq
tff(fact_2716_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M2: nat,A4: A,X2: A,Y: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ur(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M2),A4),X2),Y)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_us(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M2),A4),X2),Y)),aa(nat,set(nat),set_ord_atMost(nat),M2)) ) ) ).

% gbinomial_partial_sum_poly_xpos
tff(fact_2717_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7121269368397514597t_prod(product_prod(nat,nat),A),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),G)),aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_ut(nat,fun(nat,fun(nat,bool)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_rh(fun(nat,fun(nat,A)),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% prod.triangle_reindex
tff(fact_2718_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7311177749621191930dd_sum(product_prod(nat,nat),A),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),G)),aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_ut(nat,fun(nat,fun(nat,bool)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_rf(fun(nat,fun(nat,A)),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% sum.triangle_reindex
tff(fact_2719_pochhammer__code,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat,A4: A] :
          ( ( ( N = zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,A4,N) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,A4,N) = set_fo6178422350223883121st_nat(A,aTP_Lamp_uu(A,fun(nat,fun(A,A)),A4),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),one_one(A)) ) ) ) ) ).

% pochhammer_code
tff(fact_2720_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,finite_finite2(product_prod(A,A)),R))
     => ( transitive_trancl(A,R) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image2(nat,set(product_prod(A,A)),aTP_Lamp_uv(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R)),aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_uw(set(product_prod(A,A)),fun(nat,bool),R)))) ) ) ).

% trancl_finite_eq_relpow
tff(fact_2721_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A4: A] : ( aa(nat,A,gbinomial(A,A4),zero_zero(nat)) = one_one(A) ) ) ).

% gbinomial_0(1)
tff(fact_2722_pochhammer__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A] : ( comm_s3205402744901411588hammer(A,A4,zero_zero(nat)) = one_one(A) ) ) ).

% pochhammer_0
tff(fact_2723_lessThan__0,axiom,
    aa(nat,set(nat),set_ord_lessThan(nat),zero_zero(nat)) = bot_bot(set(nat)) ).

% lessThan_0
tff(fact_2724_single__Diff__lessThan,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert(A,K),bot_bot(set(A)))),aa(A,set(A),set_ord_lessThan(A),K)) = aa(set(A),set(A),insert(A,K),bot_bot(set(A))) ) ) ).

% single_Diff_lessThan
tff(fact_2725_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),N))),aa(nat,A,G,N)) ) ) ).

% prod.lessThan_Suc
tff(fact_2726_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),top_top(A)),X2))
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(A,set(A),set_ord_lessThan(A),X2)) = bot_bot(A) ) ) ) ).

% Inf_atMostLessThan
tff(fact_2727_less__set__def,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A3),B2))
    <=> pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less(fun(A,bool)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3)),aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),B2))) ) ).

% less_set_def
tff(fact_2728_lessThan__non__empty,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [X2: A] : ( aa(A,set(A),set_ord_lessThan(A),X2) != bot_bot(set(A)) ) ) ).

% lessThan_non_empty
tff(fact_2729_lessThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [U: A] : ( aa(A,set(A),set_ord_lessThan(A),U) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_ux(A,fun(A,bool),U)) ) ) ).

% lessThan_def
tff(fact_2730_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( aa(nat,set(nat),set_ord_lessThan(nat),N) = bot_bot(set(nat)) )
    <=> ( N = zero_zero(nat) ) ) ).

% lessThan_empty_iff
tff(fact_2731_Iio__eq__empty__iff,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & order_bot(A) )
     => ! [N: A] :
          ( ( aa(A,set(A),set_ord_lessThan(A),N) = bot_bot(set(A)) )
        <=> ( N = bot_bot(A) ) ) ) ).

% Iio_eq_empty_iff
tff(fact_2732_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,A4),K)),aa(nat,A,gbinomial(A,A4),aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc_Suc
tff(fact_2733_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] :
          ( ( ( N = zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,zero_zero(A),N) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,zero_zero(A),N) = zero_zero(A) ) ) ) ) ).

% pochhammer_0_left
tff(fact_2734_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_uy(fun(nat,A),fun(nat,fun(nat,A)),G),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% sum.nat_diff_reindex
tff(fact_2735_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_uz(fun(nat,A),fun(nat,fun(nat,A)),G),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% prod.nat_diff_reindex
tff(fact_2736_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( compow(set(product_prod(A,A)),N,bot_bot(set(product_prod(A,A)))) = bot_bot(set(product_prod(A,A))) ) ) ).

% relpow_empty
tff(fact_2737_ivl__disj__int__one_I4_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_lessThan(A),L)),set_or1337092689740270186AtMost(A,L,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(4)
tff(fact_2738_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(nat,A,gbinomial(A,A4),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))),K)) ) ) ).

% gbinomial_addition_formula
tff(fact_2739_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,A4),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))),K)) ) ) ).

% gbinomial_absorb_comp
tff(fact_2740_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A4),K)),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A4),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A4),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1'
tff(fact_2741_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,gbinomial(A,A4),K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A4),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A4),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1
tff(fact_2742_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Q: fun(A,nat),P: fun(A,nat),N: A] :
          ( ! [X: A] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,Q,X)),aa(A,nat,P,X)))
         => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),P),aa(A,set(A),set_ord_lessThan(A),N))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),Q),aa(A,set(A),set_ord_lessThan(A),N))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_va(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Q),P)),aa(A,set(A),set_ord_lessThan(A),N)) ) ) ) ).

% sum_diff_distrib
tff(fact_2743_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_st(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% sum.lessThan_Suc_shift
tff(fact_2744_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(nat,A),M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_sw(fun(nat,A),fun(nat,A),F2)),aa(nat,set(nat),set_ord_lessThan(nat),M2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,M2)),aa(nat,A,F2,zero_zero(nat))) ) ) ).

% sum_lessThan_telescope
tff(fact_2745_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(nat,A),M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_sz(fun(nat,A),fun(nat,A),F2)),aa(nat,set(nat),set_ord_lessThan(nat),M2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,zero_zero(nat))),aa(nat,A,F2,M2)) ) ) ).

% sum_lessThan_telescope'
tff(fact_2746_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_su(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% prod.lessThan_Suc_shift
tff(fact_2747_rtrancl__is__UN__relpow,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( transitive_rtrancl(A,R) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image2(nat,set(product_prod(A,A)),aTP_Lamp_uv(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R)),top_top(set(nat)))) ) ).

% rtrancl_is_UN_relpow
tff(fact_2748_rtrancl__imp__UN__relpow,axiom,
    ! [A: $tType,P5: product_prod(A,A),R: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),P5),transitive_rtrancl(A,R)))
     => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),P5),aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image2(nat,set(product_prod(A,A)),aTP_Lamp_uv(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R)),top_top(set(nat)))))) ) ).

% rtrancl_imp_UN_relpow
tff(fact_2749_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_st(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% sum.atLeast1_atMost_eq
tff(fact_2750_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_su(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% prod.atLeast1_atMost_eq
tff(fact_2751_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A,N: nat] : ( comm_s3205402744901411588hammer(A,A4,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A)),N)) ) ) ).

% pochhammer_rec
tff(fact_2752_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),Mm: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_st(fun(nat,A),fun(nat,A),F2)),aa(nat,set(nat),set_ord_lessThan(nat),Mm)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,one_one(nat),Mm)) ) ) ).

% sum_bounds_lt_plus1
tff(fact_2753_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z2: A,N: nat] : ( comm_s3205402744901411588hammer(A,Z2,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),aa(nat,A,semiring_1_of_nat(A),N))),comm_s3205402744901411588hammer(A,Z2,N)) ) ) ).

% pochhammer_rec'
tff(fact_2754_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A,N: nat] : ( comm_s3205402744901411588hammer(A,A4,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,A4,N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(nat,A,semiring_1_of_nat(A),N))) ) ) ).

% pochhammer_Suc
tff(fact_2755_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z2: A,N: nat,M2: nat] : ( comm_s3205402744901411588hammer(A,Z2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M2)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z2,N)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),aa(nat,A,semiring_1_of_nat(A),N)),M2)) ) ) ).

% pochhammer_product'
tff(fact_2756_sum_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: fun(nat,fun(nat,A)),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_vb(fun(nat,fun(nat,A)),fun(nat,A),A4)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_vd(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A4),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% sum.nested_swap'
tff(fact_2757_prod_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: fun(nat,fun(nat,A)),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_ve(fun(nat,fun(nat,A)),fun(nat,A),A4)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_vg(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A4),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% prod.nested_swap'
tff(fact_2758_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,K: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),K))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_lessThan(A),K)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),K))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_lessThan(A),K)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = bot_bot(set(A)) ) ) ) ) ).

% Iio_Int_singleton
tff(fact_2759_ivl__disj__un__singleton_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(A,set(A),set_ord_lessThan(A),U)),aa(set(A),set(A),insert(A,U),bot_bot(set(A)))) = aa(A,set(A),set_ord_atMost(A),U) ) ) ).

% ivl_disj_un_singleton(2)
tff(fact_2760_UN__lessThan__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Sup_Sup(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),set_ord_lessThan(nat)),top_top(set(nat)))) = top_top(set(nat)) ).

% UN_lessThan_UNIV
tff(fact_2761_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))),aa(nat,A,gbinomial(A,A4),K)) ) ) ).

% Suc_times_gbinomial
tff(fact_2762_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A4),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))),K)) ) ) ).

% gbinomial_absorption
tff(fact_2763_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,M2: nat,A4: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),M2))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A4),M2)),aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),M2)),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A4),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),K))) ) ) ) ).

% gbinomial_trinomial_revision
tff(fact_2764_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),one_one(A))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% power_diff_1_eq
tff(fact_2765_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% one_diff_power_eq
tff(fact_2766_geometric__sum,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A,N: nat] :
          ( ( X2 != one_one(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),one_one(A))) ) ) ) ).

% geometric_sum
tff(fact_2767_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_st(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% sum.atMost_shift
tff(fact_2768_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_su(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% prod.atMost_shift
tff(fact_2769_pochhammer__product,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [M2: nat,N: nat,Z2: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( comm_s3205402744901411588hammer(A,Z2,N) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z2,M2)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),aa(nat,A,semiring_1_of_nat(A),M2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2))) ) ) ) ).

% pochhammer_product
tff(fact_2770_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_vh(A,fun(nat,A),A4)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(nat,A,semiring_1_of_nat(A),N))),one_one(A))),N) ) ) ).

% gbinomial_parallel_sum
tff(fact_2771_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A4),K)),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_rec
tff(fact_2772_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))),aa(nat,A,gbinomial(A,A4),K)) ) ) ).

% gbinomial_factors
tff(fact_2773_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(nat,A,gbinomial(A,A4),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),K)),A4)),one_one(A))),K)) ) ) ).

% gbinomial_negated_upper
tff(fact_2774_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N))),one_one(A))),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),N)) ) ) ).

% gbinomial_index_swap
tff(fact_2775_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X2: A,N: nat] :
          ( ( ( X2 = one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(nat,A,semiring_1_of_nat(A),N) ) )
          & ( ( X2 != one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X2)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)) ) ) ) ) ).

% sum_gp_strict
tff(fact_2776_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,N: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_vi(A,fun(nat,fun(A,fun(nat,A))),X2),N),Y)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% power_diff_sumr2
tff(fact_2777_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,N: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(nat,nat,suc,N))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_vj(A,fun(nat,fun(A,fun(nat,A))),X2),N),Y)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,N)))) ) ) ).

% diff_power_eq_sum
tff(fact_2778_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [R2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),R2),aa(nat,A,semiring_1_of_nat(A),K))),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),R2),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),R2),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),R2)),one_one(A)),K)) ) ) ).

% pochhammer_absorb_comp
tff(fact_2779_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,finite_finite2(product_prod(A,A)),R))
     => ( transitive_rtrancl(A,R) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image2(nat,set(product_prod(A,A)),aTP_Lamp_uv(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R)),aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_vk(set(product_prod(A,A)),fun(nat,bool),R)))) ) ) ).

% rtrancl_finite_eq_relpow
tff(fact_2780_relpow__finite__bounded,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),K: nat] :
      ( pp(aa(set(product_prod(A,A)),bool,finite_finite2(product_prod(A,A)),R))
     => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),compow(set(product_prod(A,A)),K,R)),aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image2(nat,set(product_prod(A,A)),aTP_Lamp_uv(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R)),aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_vk(set(product_prod(A,A)),fun(nat,bool),R)))))) ) ).

% relpow_finite_bounded
tff(fact_2781_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),A4)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),K)) ) ) ).

% gbinomial_minus
tff(fact_2782_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_vl(A,fun(nat,fun(nat,A)),X2),N)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% one_diff_power_eq'
tff(fact_2783_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A4: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
         => ( aa(nat,A,gbinomial(A,A4),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))),K)) ) ) ) ).

% gbinomial_reduce_nat
tff(fact_2784_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A,N: nat] : ( comm_s3205402744901411588hammer(A,A4,aa(nat,nat,suc,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_vm(A,fun(nat,A),A4)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_Suc_prod
tff(fact_2785_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A,N: nat] : ( comm_s3205402744901411588hammer(A,A4,N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_vn(A,fun(nat,fun(nat,A)),A4),N)),set_or1337092689740270186AtMost(nat,one_one(nat),N)) ) ) ).

% pochhammer_prod_rev
tff(fact_2786_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B3: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B3),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K)) ) ) ).

% pochhammer_minus
tff(fact_2787_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B3: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B3),K)) ) ) ).

% pochhammer_minus'
tff(fact_2788_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_vo(A,fun(nat,A),A4)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),M2)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))),M2)) ) ) ).

% gbinomial_sum_lower_neg
tff(fact_2789_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A,N: nat] : ( comm_s3205402744901411588hammer(A,A4,aa(nat,nat,suc,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_vn(A,fun(nat,fun(nat,A)),A4),N)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_Suc_prod_rev
tff(fact_2790_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A4: A,B3: A,N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3),N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_vp(A,fun(A,fun(nat,fun(nat,A))),A4),B3),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% pochhammer_binomial_sum
tff(fact_2791_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_vq(nat,fun(nat,A),K)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat))) ) ) ).

% gbinomial_sum_up_index
tff(fact_2792_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M2: nat,A4: A,X2: A,Y: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ur(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M2),A4),X2),Y)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_vr(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M2),A4),X2),Y)),aa(nat,set(nat),set_ord_atMost(nat),M2)) ) ) ).

% gbinomial_partial_sum_poly
tff(fact_2793_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A4: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
         => ( aa(nat,A,gbinomial(A,A4),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ) ).

% gbinomial_absorption'
tff(fact_2794_relpow__finite__bounded1,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),K: nat] :
      ( pp(aa(set(product_prod(A,A)),bool,finite_finite2(product_prod(A,A)),R))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
       => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),compow(set(product_prod(A,A)),K,R)),aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image2(nat,set(product_prod(A,A)),aTP_Lamp_uv(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R)),aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_uw(set(product_prod(A,A)),fun(nat,bool),R)))))) ) ) ).

% relpow_finite_bounded1
tff(fact_2795_ntrancl__def,axiom,
    ! [A: $tType,N: nat,R: set(product_prod(A,A))] : ( transitive_ntrancl(A,N,R) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image2(nat,set(product_prod(A,A)),aTP_Lamp_uv(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R)),aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_vs(nat,fun(nat,bool),N)))) ) ).

% ntrancl_def
tff(fact_2796_finite__psubset__def,axiom,
    ! [A: $tType] : ( finite_psubset(A) = aa(fun(product_prod(set(A),set(A)),bool),set(product_prod(set(A),set(A))),collect(product_prod(set(A),set(A))),aa(fun(set(A),fun(set(A),bool)),fun(product_prod(set(A),set(A)),bool),product_case_prod(set(A),set(A),bool),aTP_Lamp_vt(set(A),fun(set(A),bool)))) ) ).

% finite_psubset_def
tff(fact_2797_gbinomial__code,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A4: A] :
          ( ( ( K = zero_zero(nat) )
           => ( aa(nat,A,gbinomial(A,A4),K) = one_one(A) ) )
          & ( ( K != zero_zero(nat) )
           => ( aa(nat,A,gbinomial(A,A4),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),set_fo6178422350223883121st_nat(A,aTP_Lamp_vu(A,fun(nat,fun(A,A)),A4),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)),one_one(A))),semiring_char_0_fact(A,K)) ) ) ) ) ).

% gbinomial_code
tff(fact_2798_int__ge__less__than__def,axiom,
    ! [D3: int] : ( int_ge_less_than(D3) = aa(fun(product_prod(int,int),bool),set(product_prod(int,int)),collect(product_prod(int,int)),aa(fun(int,fun(int,bool)),fun(product_prod(int,int),bool),product_case_prod(int,int,bool),aTP_Lamp_vv(int,fun(int,fun(int,bool)),D3))) ) ).

% int_ge_less_than_def
tff(fact_2799_int__ge__less__than2__def,axiom,
    ! [D3: int] : ( int_ge_less_than2(D3) = aa(fun(product_prod(int,int),bool),set(product_prod(int,int)),collect(product_prod(int,int)),aa(fun(int,fun(int,bool)),fun(product_prod(int,int),bool),product_case_prod(int,int,bool),aTP_Lamp_vw(int,fun(int,fun(int,bool)),D3))) ) ).

% int_ge_less_than2_def
tff(fact_2800_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A4: A,K: nat] : ( aa(nat,A,gbinomial(A,A4),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_vx(A,fun(nat,A),A4)),set_or1337092689740270186AtMost(nat,zero_zero(nat),K))),semiring_char_0_fact(A,aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc
tff(fact_2801_fact__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,zero_zero(nat)) = one_one(A) ) ) ).

% fact_0
tff(fact_2802_fact__1,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,one_one(nat)) = one_one(A) ) ) ).

% fact_1
tff(fact_2803_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% fact_Suc_0
tff(fact_2804_fact__Suc,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N))),semiring_char_0_fact(A,N)) ) ) ).

% fact_Suc
tff(fact_2805_fact__ge__1,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),semiring_char_0_fact(A,N))) ) ).

% fact_ge_1
tff(fact_2806_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & comm_semiring_1(A) )
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = comm_s3205402744901411588hammer(A,one_one(A),N) ) ) ).

% pochhammer_fact
tff(fact_2807_fact__prod,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_vy(nat,nat)),set_or1337092689740270186AtMost(nat,one_one(nat),N))) ) ) ).

% fact_prod
tff(fact_2808_fact__eq__fact__times,axiom,
    ! [N: nat,M2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M2))
     => ( semiring_char_0_fact(nat,M2) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,N)),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_vy(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M2))) ) ) ).

% fact_eq_fact_times
tff(fact_2809_fact__div__fact,axiom,
    ! [N: nat,M2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M2))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),semiring_char_0_fact(nat,M2)),semiring_char_0_fact(nat,N)) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_vy(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),M2)) ) ) ).

% fact_div_fact
tff(fact_2810_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M2: nat] :
          ( ( ( M2 = zero_zero(nat) )
           => ( semiring_char_0_fact(A,M2) = one_one(A) ) )
          & ( ( M2 != zero_zero(nat) )
           => ( semiring_char_0_fact(A,M2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M2)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),one_one(nat)))) ) ) ) ) ).

% fact_num_eq_if
tff(fact_2811_fact__reduce,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( semiring_char_0_fact(A,N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ) ) ).

% fact_reduce
tff(fact_2812_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & comm_ring_1(A)
        & semiri3467727345109120633visors(A) )
     => ! [N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),semiring_char_0_fact(A,N)) ) ) ).

% pochhammer_same
tff(fact_2813_fact__binomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),semiring_char_0_fact(A,N)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_binomial
tff(fact_2814_binomial__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),semiring_char_0_fact(A,N)),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))) ) ) ) ).

% binomial_fact
tff(fact_2815_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(nat,A,gbinomial(A,A4),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K)),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer'
tff(fact_2816_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(nat,A,gbinomial(A,A4),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),A4),K))),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer
tff(fact_2817_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A4: A,K: nat] : ( aa(nat,A,gbinomial(A,A4),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_vx(A,fun(nat,A),A4)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K))),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_prod_rev
tff(fact_2818_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A4),K)),semiring_char_0_fact(A,K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_vz(A,fun(nat,A),A4)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact'
tff(fact_2819_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,gbinomial(A,A4),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_vz(A,fun(nat,A),A4)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact
tff(fact_2820_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_wa(nat,fun(nat,fun(nat,A)),K),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ) ).

% binomial_altdef_of_nat
tff(fact_2821_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,K: nat] : ( aa(nat,A,gbinomial(A,A4),K) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_wb(A,fun(nat,fun(nat,A)),A4),K)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_altdef_of_nat
tff(fact_2822_times__int_Otransfer,axiom,
    pp(aa(fun(int,fun(int,int)),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),bool),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wd(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),times_times(int))) ).

% times_int.transfer
tff(fact_2823_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( set_or7035219750837199246ssThan(A,A4,B3) = bot_bot(set(A)) ) ) ) ).

% atLeastLessThan_empty
tff(fact_2824_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A] :
          ( ( bot_bot(set(A)) = set_or7035219750837199246ssThan(A,A4,B3) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ).

% atLeastLessThan_empty_iff2
tff(fact_2825_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: A,B3: A] :
          ( ( set_or7035219750837199246ssThan(A,A4,B3) = bot_bot(set(A)) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ).

% atLeastLessThan_empty_iff
tff(fact_2826_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I2: A,J2: A] : ( aa(set(A),set(A),image2(A,A,aTP_Lamp_ru(A,fun(A,A),K)),set_or7035219750837199246ssThan(A,I2,J2)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)) ) ) ).

% image_add_atLeastLessThan'
tff(fact_2827_atLeastLessThan__singleton,axiom,
    ! [M2: nat] : ( set_or7035219750837199246ssThan(nat,M2,aa(nat,nat,suc,M2)) = aa(set(nat),set(nat),insert(nat,M2),bot_bot(set(nat))) ) ).

% atLeastLessThan_singleton
tff(fact_2828_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [N: nat,M2: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M2))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M2,aa(nat,nat,suc,N))) = one_one(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M2))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M2,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M2,N))),aa(nat,A,G,N)) ) ) ) ) ).

% prod.op_ivl_Suc
tff(fact_2829_ivl__disj__int__two_I3_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M2: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or7035219750837199246ssThan(A,L,M2)),set_or7035219750837199246ssThan(A,M2,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(3)
tff(fact_2830_atLeastLessThan0,axiom,
    ! [M2: nat] : ( set_or7035219750837199246ssThan(nat,M2,zero_zero(nat)) = bot_bot(set(nat)) ) ).

% atLeastLessThan0
tff(fact_2831_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M2: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_st(fun(nat,A),fun(nat,A),G)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% sum.shift_bounds_Suc_ivl
tff(fact_2832_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M2: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_sd(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% sum.shift_bounds_nat_ivl
tff(fact_2833_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M2: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_su(fun(nat,A),fun(nat,A),G)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% prod.shift_bounds_Suc_ivl
tff(fact_2834_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M2: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_se(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% prod.shift_bounds_nat_ivl
tff(fact_2835_ivl__disj__int__two_I7_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M2: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or7035219750837199246ssThan(A,L,M2)),set_or1337092689740270186AtMost(A,M2,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(7)
tff(fact_2836_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M2: nat,N: nat,P5: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),P5))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M2,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,N,P5))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M2,P5)) ) ) ) ) ).

% prod.atLeastLessThan_concat
tff(fact_2837_ivl__disj__int__one_I2_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_lessThan(A),L)),set_or7035219750837199246ssThan(A,L,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(2)
tff(fact_2838_nat_Otransfer,axiom,
    pp(aa(fun(int,nat),bool,aa(fun(product_prod(nat,nat),nat),fun(fun(int,nat),bool),bNF_rel_fun(product_prod(nat,nat),int,nat,nat,pcr_int,fequal(nat)),aa(fun(nat,fun(nat,nat)),fun(product_prod(nat,nat),nat),product_case_prod(nat,nat,nat),minus_minus(nat))),nat2)) ).

% nat.transfer
tff(fact_2839_binomial__def,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,binomial(N),K) = aa(set(set(nat)),nat,finite_card(set(nat)),aa(fun(set(nat),bool),set(set(nat)),collect(set(nat)),aa(nat,fun(set(nat),bool),aTP_Lamp_we(nat,fun(nat,fun(set(nat),bool)),N),K))) ) ).

% binomial_def
tff(fact_2840_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(nat,A,G,N)) ) ) ).

% prod.atLeast0_lessThan_Suc
tff(fact_2841_atLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] : ( set_or7035219750837199246ssThan(A,A4,B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A4,B3)),aa(set(A),set(A),insert(A,B3),bot_bot(set(A)))) ) ) ).

% atLeastLessThan_eq_atLeastAtMost_diff
tff(fact_2842_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M2: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M2),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M2,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),N))) ) ) ) ).

% prod.atLeast_Suc_lessThan
tff(fact_2843_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: nat,B3: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A4),B3))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,A4,aa(nat,nat,suc,B3))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,A4,B3))),aa(nat,A,G,B3)) ) ) ) ).

% prod.atLeastLessThan_Suc
tff(fact_2844_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M2: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,N)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M2,N))) ) ) ) ).

% prod.last_plus
tff(fact_2845_atLeastLessThanSuc,axiom,
    ! [M2: nat,N: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
       => ( set_or7035219750837199246ssThan(nat,M2,aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert(nat,N),set_or7035219750837199246ssThan(nat,M2,N)) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
       => ( set_or7035219750837199246ssThan(nat,M2,aa(nat,nat,suc,N)) = bot_bot(set(nat)) ) ) ) ).

% atLeastLessThanSuc
tff(fact_2846_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M2: nat,N: nat,F2: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_sw(fun(nat,A),fun(nat,A),F2)),set_or7035219750837199246ssThan(nat,M2,N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,N)),aa(nat,A,F2,M2)) ) ) ) ).

% sum_Suc_diff'
tff(fact_2847_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat,M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_wf(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M2)),set_or7035219750837199246ssThan(nat,N,M2)) ) ) ).

% sum.atLeastLessThan_rev
tff(fact_2848_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: fun(nat,fun(nat,A)),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_wg(fun(nat,fun(nat,A)),fun(nat,A),A4)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_vd(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A4),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% sum.nested_swap
tff(fact_2849_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat,M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_wh(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M2)),set_or7035219750837199246ssThan(nat,N,M2)) ) ) ).

% prod.atLeastLessThan_rev
tff(fact_2850_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: fun(nat,fun(nat,A)),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_wi(fun(nat,fun(nat,A)),fun(nat,A),A4)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_vg(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A4),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% prod.nested_swap
tff(fact_2851_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aa(nat,fun(nat,nat),minus_minus(nat),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% fact_prod_rev
tff(fact_2852_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_wj(fun(nat,A),fun(nat,fun(nat,A)),G),K)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))) ) ) ).

% sum.nat_group
tff(fact_2853_int__transfer,axiom,
    pp(aa(fun(nat,int),bool,aa(fun(nat,product_prod(nat,nat)),fun(fun(nat,int),bool),bNF_rel_fun(nat,nat,product_prod(nat,nat),int,fequal(nat),pcr_int),aTP_Lamp_wk(nat,product_prod(nat,nat))),semiring_1_of_nat(int))) ).

% int_transfer
tff(fact_2854_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_wl(fun(nat,A),fun(nat,fun(nat,A)),G),K)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))) ) ) ).

% prod.nat_group
tff(fact_2855_UN__UN__finite__eq,axiom,
    ! [A: $tType,A3: fun(nat,set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),aTP_Lamp_wm(fun(nat,set(A)),fun(nat,set(A)),A3)),top_top(set(nat)))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),A3),top_top(set(nat)))) ) ).

% UN_UN_finite_eq
tff(fact_2856_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M: fun(nat,set(A)),K: nat,N: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_sj(fun(nat,set(A)),fun(nat,fun(nat,set(A))),M),K)),aa(nat,set(nat),set_ord_lessThan(nat),N))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),M),set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))) ) ).

% UN_le_add_shift_strict
tff(fact_2857_card__sum__le__nat__sum,axiom,
    ! [S: set(nat)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vy(nat,nat)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(set(nat),nat,finite_card(nat),S)))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vy(nat,nat)),S))) ).

% card_sum_le_nat_sum
tff(fact_2858_uminus__int_Otransfer,axiom,
    pp(aa(fun(int,int),bool,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(int,int),bool),bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_wn(nat,fun(nat,product_prod(nat,nat))))),uminus_uminus(int))) ).

% uminus_int.transfer
tff(fact_2859_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or7035219750837199246ssThan(A,L,U)),aa(set(A),set(A),insert(A,U),bot_bot(set(A)))) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(6)
tff(fact_2860_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [N: nat,M2: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M2))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N)) = one_one(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M2))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M2,N))),aa(nat,A,G,N)) ) ) ) ) ).

% prod.head_if
tff(fact_2861_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
tff(fact_2862_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat,M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_sg(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M2)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M2)) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_2863_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat,M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_sh(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M2)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M2)) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_2864_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A,N: nat] : ( comm_s3205402744901411588hammer(A,A4,N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_vm(A,fun(nat,A),A4)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_prod
tff(fact_2865_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M2: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_sx(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% sum.atLeast_lessThan_pred_shift
tff(fact_2866_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M2: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_sx(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% prod.atLeast_lessThan_pred_shift
tff(fact_2867_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y: nat,X2: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),C2),Y))
       => ( aa(set(nat),set(nat),image2(nat,nat,aTP_Lamp_rj(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,X2,Y)) = set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X2),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Y),C2)) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),C2),Y))
       => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X2),Y))
           => ( aa(set(nat),set(nat),image2(nat,nat,aTP_Lamp_rj(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,X2,Y)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X2),Y))
           => ( aa(set(nat),set(nat),image2(nat,nat,aTP_Lamp_rj(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,X2,Y)) = bot_bot(set(nat)) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
tff(fact_2868_UN__finite__subset,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),C3: set(A)] :
      ( ! [N2: nat] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2)))),C3))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),A3),top_top(set(nat))))),C3)) ) ).

% UN_finite_subset
tff(fact_2869_UN__finite2__eq,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),B2: fun(nat,set(A)),K: nat] :
      ( ! [N2: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),K)))) )
     => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),A3),top_top(set(nat)))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),B2),top_top(set(nat)))) ) ) ).

% UN_finite2_eq
tff(fact_2870_less__int_Otransfer,axiom,
    pp(aa(fun(int,fun(int,bool)),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),fun(fun(int,fun(int,bool)),bool),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),bool),fun(int,bool),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,bool,bool,pcr_int,fequal(bool))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),bool))))),ord_less(int))) ).

% less_int.transfer
tff(fact_2871_less__eq__int_Otransfer,axiom,
    pp(aa(fun(int,fun(int,bool)),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),fun(fun(int,fun(int,bool)),bool),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),bool),fun(int,bool),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,bool,bool,pcr_int,fequal(bool))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),bool))))),ord_less_eq(int))) ).

% less_eq_int.transfer
tff(fact_2872_fact__split,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( semiring_char_0_fact(A,N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K),N)))),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_split
tff(fact_2873_plus__int_Otransfer,axiom,
    pp(aa(fun(int,fun(int,int)),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),bool),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),plus_plus(int))) ).

% plus_int.transfer
tff(fact_2874_minus__int_Otransfer,axiom,
    pp(aa(fun(int,fun(int,int)),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),bool),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wv(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),minus_minus(int))) ).

% minus_int.transfer
tff(fact_2875_UN__finite2__subset,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),B2: fun(nat,set(A)),K: nat] :
      ( ! [N2: nat] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2)))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),K))))))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),A3),top_top(set(nat))))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),B2),top_top(set(nat)))))) ) ).

% UN_finite2_subset
tff(fact_2876_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] : ( set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_lessThan(nat),N)),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_lessThan_eq_remove0
tff(fact_2877_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X2: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wd(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X2)) ) ).

% times_int.abs_eq
tff(fact_2878_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X2: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wv(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X2)) ) ).

% minus_int.abs_eq
tff(fact_2879_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X2: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X2)) ) ).

% plus_int.abs_eq
tff(fact_2880_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => semila1105856199041335345_order(A,sup_sup(A),bot_bot(A),aTP_Lamp_ww(A,fun(A,bool)),aTP_Lamp_wx(A,fun(A,bool))) ) ).

% sup_bot.semilattice_neutr_order_axioms
tff(fact_2881_pred__nat__def,axiom,
    pred_nat = aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_wy(nat,fun(nat,bool)))) ).

% pred_nat_def
tff(fact_2882_power__minus_H,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: A,N: nat] :
          ( nO_MATCH(A,A,one_one(A),X2)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),X2)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N)) ) ) ) ).

% power_minus'
tff(fact_2883_semilattice__neutr__order_Oeq__neutr__iff,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( semila1105856199041335345_order(A,F2,Z2,Less_eq,Less)
     => ( ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = Z2 )
      <=> ( ( A4 = Z2 )
          & ( B3 = Z2 ) ) ) ) ).

% semilattice_neutr_order.eq_neutr_iff
tff(fact_2884_semilattice__neutr__order_Oneutr__eq__iff,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( semila1105856199041335345_order(A,F2,Z2,Less_eq,Less)
     => ( ( Z2 = aa(A,A,aa(A,fun(A,A),F2,A4),B3) )
      <=> ( ( A4 = Z2 )
          & ( B3 = Z2 ) ) ) ) ).

% semilattice_neutr_order.neutr_eq_iff
tff(fact_2885_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] : ( aa(set(int),set(int),image2(int,int,aTP_Lamp_wz(int,fun(int,int),L)),set_or7035219750837199246ssThan(int,zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L))) = set_or7035219750837199246ssThan(int,L,U) ) ).

% image_add_int_atLeastLessThan
tff(fact_2886_uminus__int_Oabs__eq,axiom,
    ! [X2: product_prod(nat,nat)] : ( aa(int,int,uminus_uminus(int),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_wn(nat,fun(nat,product_prod(nat,nat)))),X2)) ) ).

% uminus_int.abs_eq
tff(fact_2887_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring(A)
     => ! [X2: B,Y: B,C2: A,A4: A,B3: A] :
          ( nO_MATCH(B,A,aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y),C2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) ) ) ) ).

% distrib_right_NO_MATCH
tff(fact_2888_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring(A)
     => ! [X2: B,Y: B,A4: A,B3: A,C2: A] :
          ( nO_MATCH(B,A,aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y),A4)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)) ) ) ) ).

% distrib_left_NO_MATCH
tff(fact_2889_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ring(A)
     => ! [X2: B,Y: B,A4: A,B3: A,C2: A] :
          ( nO_MATCH(B,A,aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y),A4)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)) ) ) ) ).

% right_diff_distrib_NO_MATCH
tff(fact_2890_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ring(A)
     => ! [X2: B,Y: B,C2: A,A4: A,B3: A] :
          ( nO_MATCH(B,A,aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y),C2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) ) ) ) ).

% left_diff_distrib_NO_MATCH
tff(fact_2891_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X2: product_prod(nat,nat)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X2)))
    <=> pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),bool)))),Xa),X2)) ) ).

% less_int.abs_eq
tff(fact_2892_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X2: product_prod(nat,nat)] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X2)))
    <=> pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),bool)))),Xa),X2)) ) ).

% less_eq_int.abs_eq
tff(fact_2893_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => semila1105856199041335345_order(A,inf_inf(A),top_top(A),ord_less_eq(A),ord_less(A)) ) ).

% inf_top.semilattice_neutr_order_axioms
tff(fact_2894_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel(A)
        & field(B) )
     => ! [X2: B,B3: A,A4: A] :
          ( nO_MATCH(B,A,X2,B3)
         => ( ( B3 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),one_one(A)) ) ) ) ) ).

% div_add_self2_no_field
tff(fact_2895_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel(A)
        & field(B) )
     => ! [X2: B,B3: A,A4: A] :
          ( nO_MATCH(B,A,X2,B3)
         => ( ( B3 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4)),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),one_one(A)) ) ) ) ) ).

% div_add_self1_no_field
tff(fact_2896_less__eq__int_Orep__eq,axiom,
    ! [X2: int,Xa: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X2),Xa))
    <=> pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),bool)))),aa(int,product_prod(nat,nat),rep_Integ,X2)),aa(int,product_prod(nat,nat),rep_Integ,Xa))) ) ).

% less_eq_int.rep_eq
tff(fact_2897_less__int_Orep__eq,axiom,
    ! [X2: int,Xa: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),X2),Xa))
    <=> pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),bool)))),aa(int,product_prod(nat,nat),rep_Integ,X2)),aa(int,product_prod(nat,nat),rep_Integ,Xa))) ) ).

% less_int.rep_eq
tff(fact_2898_times__int_Orsp,axiom,
    pp(aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wd(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wd(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))))) ).

% times_int.rsp
tff(fact_2899_uminus__int_Orsp,axiom,
    pp(aa(fun(product_prod(nat,nat),product_prod(nat,nat)),bool,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(product_prod(nat,nat),product_prod(nat,nat)),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_wn(nat,fun(nat,product_prod(nat,nat))))),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_wn(nat,fun(nat,product_prod(nat,nat)))))) ).

% uminus_int.rsp
tff(fact_2900_nat_Orsp,axiom,
    pp(aa(fun(product_prod(nat,nat),nat),bool,aa(fun(product_prod(nat,nat),nat),fun(fun(product_prod(nat,nat),nat),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),nat,nat,intrel,fequal(nat)),aa(fun(nat,fun(nat,nat)),fun(product_prod(nat,nat),nat),product_case_prod(nat,nat,nat),minus_minus(nat))),aa(fun(nat,fun(nat,nat)),fun(product_prod(nat,nat),nat),product_case_prod(nat,nat,nat),minus_minus(nat)))) ).

% nat.rsp
tff(fact_2901_of__int_Orsp,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => pp(aa(fun(product_prod(nat,nat),A),bool,aa(fun(product_prod(nat,nat),A),fun(fun(product_prod(nat,nat),A),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),A,A,intrel,fequal(A)),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),aTP_Lamp_xa(nat,fun(nat,A)))),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),aTP_Lamp_xa(nat,fun(nat,A))))) ) ).

% of_int.rsp
tff(fact_2902_intrel__def,axiom,
    intrel = aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_xc(nat,fun(nat,fun(product_prod(nat,nat),bool)))) ).

% intrel_def
tff(fact_2903_less__int_Orsp,axiom,
    pp(aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),bool),fun(product_prod(nat,nat),bool),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),bool,bool,intrel,fequal(bool))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),bool))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),bool)))))) ).

% less_int.rsp
tff(fact_2904_less__eq__int_Orsp,axiom,
    pp(aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),bool),fun(product_prod(nat,nat),bool),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),bool,bool,intrel,fequal(bool))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),bool))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),bool)))))) ).

% less_eq_int.rsp
tff(fact_2905_minus__int_Orsp,axiom,
    pp(aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wv(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wv(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))))) ).

% minus_int.rsp
tff(fact_2906_plus__int_Orsp,axiom,
    pp(aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))))) ).

% plus_int.rsp
tff(fact_2907_uminus__int__def,axiom,
    uminus_uminus(int) = aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_wn(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int_def
tff(fact_2908_filterlim__at__top__gt,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F2: fun(A,B),F: filter(A),C2: B] :
          ( filterlim(A,B,F2,at_top(B),F)
        <=> ! [Z6: B] :
              ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),C2),Z6))
             => eventually(A,aa(B,fun(A,bool),aTP_Lamp_xd(fun(A,B),fun(B,fun(A,bool)),F2),Z6),F) ) ) ) ).

% filterlim_at_top_gt
tff(fact_2909_sum__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [A3: set(B),P: fun(B,bool)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(B),bool,finite_finite2(B),A3))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_xe(fun(B,bool),fun(B,A),P)),A3) = aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,bool),set(B),collect(B),P)))) ) ) ) ) ).

% sum_of_bool_eq
tff(fact_2910_finite__enumerate__initial__segment,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S: set(A),N: nat,S2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),aa(A,set(A),set_ord_lessThan(A),S2)))))
           => ( infini527867602293511546merate(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),aa(A,set(A),set_ord_lessThan(A),S2)),N) = infini527867602293511546merate(A,S,N) ) ) ) ) ).

% finite_enumerate_initial_segment
tff(fact_2911_nat__def,axiom,
    nat2 = aa(fun(product_prod(nat,nat),nat),fun(int,nat),map_fun(int,product_prod(nat,nat),nat,nat,rep_Integ,id(nat)),aa(fun(nat,fun(nat,nat)),fun(product_prod(nat,nat),nat),product_case_prod(nat,nat,nat),minus_minus(nat))) ).

% nat_def
tff(fact_2912_eventually__sequentially__Suc,axiom,
    ! [P: fun(nat,bool)] :
      ( eventually(nat,aTP_Lamp_xf(fun(nat,bool),fun(nat,bool),P),at_top(nat))
    <=> eventually(nat,P,at_top(nat)) ) ).

% eventually_sequentially_Suc
tff(fact_2913_eventually__sequentially__seg,axiom,
    ! [P: fun(nat,bool),K: nat] :
      ( eventually(nat,aa(nat,fun(nat,bool),aTP_Lamp_xg(fun(nat,bool),fun(nat,fun(nat,bool)),P),K),at_top(nat))
    <=> eventually(nat,P,at_top(nat)) ) ).

% eventually_sequentially_seg
tff(fact_2914_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [P: bool,Q: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(bool,A,zero_neq_one_of_bool(A),P)),aa(bool,A,zero_neq_one_of_bool(A),Q)))
        <=> ( pp(P)
           => pp(Q) ) ) ) ).

% of_bool_less_eq_iff
tff(fact_2915_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( aa(bool,A,zero_neq_one_of_bool(A),fFalse) = zero_zero(A) ) ) ).

% of_bool_eq(1)
tff(fact_2916_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: bool] :
          ( ( aa(bool,A,zero_neq_one_of_bool(A),P) = zero_zero(A) )
        <=> ~ pp(P) ) ) ).

% of_bool_eq_0_iff
tff(fact_2917_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [P: bool,Q: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(bool,A,zero_neq_one_of_bool(A),P)),aa(bool,A,zero_neq_one_of_bool(A),Q)))
        <=> ( ~ pp(P)
            & pp(Q) ) ) ) ).

% of_bool_less_iff
tff(fact_2918_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: bool] :
          ( ( aa(bool,A,zero_neq_one_of_bool(A),P) = one_one(A) )
        <=> pp(P) ) ) ).

% of_bool_eq_1_iff
tff(fact_2919_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( aa(bool,A,zero_neq_one_of_bool(A),fTrue) = one_one(A) ) ) ).

% of_bool_eq(2)
tff(fact_2920_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P: bool] : ( aa(A,A,abs_abs(A),aa(bool,A,zero_neq_one_of_bool(A),P)) = aa(bool,A,zero_neq_one_of_bool(A),P) ) ) ).

% abs_bool_eq
tff(fact_2921_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(bool,A,zero_neq_one_of_bool(A),P)))
        <=> pp(P) ) ) ).

% zero_less_of_bool_iff
tff(fact_2922_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(bool,A,zero_neq_one_of_bool(A),P)),one_one(A)))
        <=> ~ pp(P) ) ) ).

% of_bool_less_one_iff
tff(fact_2923_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [P: bool] : ( aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,P)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(bool,A,zero_neq_one_of_bool(A),P)) ) ) ).

% of_bool_not_iff
tff(fact_2924_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [A3: set(B),F2: fun(B,A),P: fun(B,bool)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,bool),fun(B,A),aTP_Lamp_xh(fun(B,A),fun(fun(B,bool),fun(B,A)),F2),P)),A3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,bool),set(B),collect(B),P))) ) ) ) ).

% sum_mult_of_bool_eq
tff(fact_2925_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [A3: set(B),P: fun(B,bool),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_xi(fun(B,bool),fun(fun(B,A),fun(B,A)),P),F2)),A3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,bool),set(B),collect(B),P))) ) ) ) ).

% sum_of_bool_mult_eq
tff(fact_2926_map__fun_Oidentity,axiom,
    ! [B: $tType,A: $tType] : ( map_fun(A,A,B,B,aTP_Lamp_bk(A,A),aTP_Lamp_xj(B,B)) = id(fun(A,B)) ) ).

% map_fun.identity
tff(fact_2927_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P5: bool,Q3: bool] :
          ( ( aa(bool,A,zero_neq_one_of_bool(A),P5) = aa(bool,A,zero_neq_one_of_bool(A),Q3) )
        <=> ( pp(P5)
          <=> pp(Q3) ) ) ) ).

% of_bool_eq_iff
tff(fact_2928_of__bool__conj,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [P: bool,Q: bool] : ( aa(bool,A,zero_neq_one_of_bool(A),fconj(P,Q)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),P)),aa(bool,A,zero_neq_one_of_bool(A),Q)) ) ) ).

% of_bool_conj
tff(fact_2929_filtermap__sequentually__ne__bot,axiom,
    ! [A: $tType,F2: fun(nat,A)] : ( filtermap(nat,A,F2,at_top(nat)) != bot_bot(filter(A)) ) ).

% filtermap_sequentually_ne_bot
tff(fact_2930_filterlim__sequentially__Suc,axiom,
    ! [A: $tType,F2: fun(nat,A),F: filter(A)] :
      ( filterlim(nat,A,aTP_Lamp_xk(fun(nat,A),fun(nat,A),F2),F,at_top(nat))
    <=> filterlim(nat,A,F2,F,at_top(nat)) ) ).

% filterlim_sequentially_Suc
tff(fact_2931_le__sequentially,axiom,
    ! [F: filter(nat)] :
      ( pp(aa(filter(nat),bool,aa(filter(nat),fun(filter(nat),bool),ord_less_eq(filter(nat)),F),at_top(nat)))
    <=> ! [N7: nat] : eventually(nat,aa(nat,fun(nat,bool),ord_less_eq(nat),N7),F) ) ).

% le_sequentially
tff(fact_2932_trivial__limit__at__top__linorder,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( at_top(A) != bot_bot(filter(A)) ) ) ).

% trivial_limit_at_top_linorder
tff(fact_2933_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(bool,A,zero_neq_one_of_bool(A),P))) ) ).

% zero_less_eq_of_bool
tff(fact_2934_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(bool,A,zero_neq_one_of_bool(A),P)),one_one(A))) ) ).

% of_bool_less_eq_one
tff(fact_2935_of__bool__def,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P5: bool] :
          ( ( pp(P5)
           => ( aa(bool,A,zero_neq_one_of_bool(A),P5) = one_one(A) ) )
          & ( ~ pp(P5)
           => ( aa(bool,A,zero_neq_one_of_bool(A),P5) = zero_zero(A) ) ) ) ) ).

% of_bool_def
tff(fact_2936_split__of__bool,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,bool),P5: bool] :
          ( pp(aa(A,bool,P,aa(bool,A,zero_neq_one_of_bool(A),P5)))
        <=> ( ( pp(P5)
             => pp(aa(A,bool,P,one_one(A))) )
            & ( ~ pp(P5)
             => pp(aa(A,bool,P,zero_zero(A))) ) ) ) ) ).

% split_of_bool
tff(fact_2937_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,bool),P5: bool] :
          ( pp(aa(A,bool,P,aa(bool,A,zero_neq_one_of_bool(A),P5)))
        <=> ~ ( ( pp(P5)
                & ~ pp(aa(A,bool,P,one_one(A))) )
              | ( ~ pp(P5)
                & ~ pp(aa(A,bool,P,zero_zero(A))) ) ) ) ) ).

% split_of_bool_asm
tff(fact_2938_eventually__at__top__not__equal,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_top(A) )
     => ! [C2: A] : eventually(A,aTP_Lamp_xl(A,fun(A,bool),C2),at_top(A)) ) ).

% eventually_at_top_not_equal
tff(fact_2939_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( zero_neq_one(B)
        & zero_neq_one(A) )
     => ! [R: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),R,zero_zero(A)),zero_zero(B)))
         => ( pp(aa(B,bool,aa(A,fun(B,bool),R,one_one(A)),one_one(B)))
           => pp(aa(fun(bool,B),bool,aa(fun(bool,A),fun(fun(bool,B),bool),bNF_rel_fun(bool,bool,A,B,fequal(bool),R),zero_neq_one_of_bool(A)),zero_neq_one_of_bool(B))) ) ) ) ).

% transfer_rule_of_bool
tff(fact_2940_filterlim__atMost__at__top,axiom,
    filterlim(nat,set(nat),set_ord_atMost(nat),finite5375528669736107172at_top(nat,top_top(set(nat))),at_top(nat)) ).

% filterlim_atMost_at_top
tff(fact_2941_filterlim__lessThan__at__top,axiom,
    filterlim(nat,set(nat),set_ord_lessThan(nat),finite5375528669736107172at_top(nat,top_top(set(nat))),at_top(nat)) ).

% filterlim_lessThan_at_top
tff(fact_2942_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A] : eventually(A,aa(A,fun(A,bool),ord_less_eq(A),C2),at_top(A)) ) ).

% eventually_ge_at_top
tff(fact_2943_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_top(A) )
     => ! [C2: A] : eventually(A,aa(A,fun(A,bool),ord_less(A),C2),at_top(A)) ) ).

% eventually_gt_at_top
tff(fact_2944_filterlim__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),F: filter(A)] :
          ( filterlim(A,B,F2,at_top(B),F)
        <=> ! [Z6: B] : eventually(A,aa(B,fun(A,bool),aTP_Lamp_xm(fun(A,B),fun(B,fun(A,bool)),F2),Z6),F) ) ) ).

% filterlim_at_top
tff(fact_2945_filterlim__at__top__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),F: filter(A),C2: B] :
          ( filterlim(A,B,F2,at_top(B),F)
        <=> ! [Z6: B] :
              ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),C2),Z6))
             => eventually(A,aa(B,fun(A,bool),aTP_Lamp_xm(fun(A,B),fun(B,fun(A,bool)),F2),Z6),F) ) ) ) ).

% filterlim_at_top_ge
tff(fact_2946_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),F: filter(B),G: fun(B,A)] :
          ( filterlim(B,A,F2,at_top(A),F)
         => ( eventually(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_xn(fun(B,A),fun(fun(B,A),fun(B,bool)),F2),G),F)
           => filterlim(B,A,G,at_top(A),F) ) ) ) ).

% filterlim_at_top_mono
tff(fact_2947_filterlim__at__top__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F2: fun(A,B),F: filter(A)] :
          ( filterlim(A,B,F2,at_top(B),F)
        <=> ! [Z6: B] : eventually(A,aa(B,fun(A,bool),aTP_Lamp_xo(fun(A,B),fun(B,fun(A,bool)),F2),Z6),F) ) ) ).

% filterlim_at_top_dense
tff(fact_2948_enumerate__Suc_H,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S: set(A),N: nat] : ( infini527867602293511546merate(A,S,aa(nat,nat,suc,N)) = infini527867602293511546merate(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),aa(set(A),set(A),insert(A,infini527867602293511546merate(A,S,zero_zero(nat))),bot_bot(set(A)))),N) ) ) ).

% enumerate_Suc'
tff(fact_2949_times__int__def,axiom,
    times_times(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wd(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int_def
tff(fact_2950_minus__int__def,axiom,
    minus_minus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wv(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int_def
tff(fact_2951_plus__int__def,axiom,
    plus_plus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int_def
tff(fact_2952_finite__enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S: set(A),N: nat] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,N)),aa(set(A),nat,finite_card(A),S)))
           => ( infini527867602293511546merate(A,S,aa(nat,nat,suc,N)) = ord_Least(A,aa(nat,fun(A,bool),aTP_Lamp_xp(set(A),fun(nat,fun(A,bool)),S),N)) ) ) ) ) ).

% finite_enumerate_Suc''
tff(fact_2953_enumerate__Suc,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S: set(A),N: nat] : ( infini527867602293511546merate(A,S,aa(nat,nat,suc,N)) = infini527867602293511546merate(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),aa(set(A),set(A),insert(A,ord_Least(A,aTP_Lamp_xq(set(A),fun(A,bool),S))),bot_bot(set(A)))),N) ) ) ).

% enumerate_Suc
tff(fact_2954_trivial__limit__sequentially,axiom,
    at_top(nat) != bot_bot(filter(nat)) ).

% trivial_limit_sequentially
tff(fact_2955_eventually__False__sequentially,axiom,
    ~ eventually(nat,aTP_Lamp_xr(nat,bool),at_top(nat)) ).

% eventually_False_sequentially
tff(fact_2956_LeastI,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),K: A] :
          ( pp(aa(A,bool,P,K))
         => pp(aa(A,bool,P,ord_Least(A,P))) ) ) ).

% LeastI
tff(fact_2957_LeastI2__ex,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),Q: fun(A,bool)] :
          ( ? [X_13: A] : pp(aa(A,bool,P,X_13))
         => ( ! [X: A] :
                ( pp(aa(A,bool,P,X))
               => pp(aa(A,bool,Q,X)) )
           => pp(aa(A,bool,Q,ord_Least(A,P))) ) ) ) ).

% LeastI2_ex
tff(fact_2958_LeastI__ex,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool)] :
          ( ? [X_13: A] : pp(aa(A,bool,P,X_13))
         => pp(aa(A,bool,P,ord_Least(A,P))) ) ) ).

% LeastI_ex
tff(fact_2959_LeastI2,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),A4: A,Q: fun(A,bool)] :
          ( pp(aa(A,bool,P,A4))
         => ( ! [X: A] :
                ( pp(aa(A,bool,P,X))
               => pp(aa(A,bool,Q,X)) )
           => pp(aa(A,bool,Q,ord_Least(A,P))) ) ) ) ).

% LeastI2
tff(fact_2960_LeastI2__wellorder__ex,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),Q: fun(A,bool)] :
          ( ? [X_13: A] : pp(aa(A,bool,P,X_13))
         => ( ! [A5: A] :
                ( pp(aa(A,bool,P,A5))
               => ( ! [B10: A] :
                      ( pp(aa(A,bool,P,B10))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A5),B10)) )
                 => pp(aa(A,bool,Q,A5)) ) )
           => pp(aa(A,bool,Q,ord_Least(A,P))) ) ) ) ).

% LeastI2_wellorder_ex
tff(fact_2961_LeastI2__wellorder,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),A4: A,Q: fun(A,bool)] :
          ( pp(aa(A,bool,P,A4))
         => ( ! [A5: A] :
                ( pp(aa(A,bool,P,A5))
               => ( ! [B10: A] :
                      ( pp(aa(A,bool,P,B10))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A5),B10)) )
                 => pp(aa(A,bool,Q,A5)) ) )
           => pp(aa(A,bool,Q,ord_Least(A,P))) ) ) ) ).

% LeastI2_wellorder
tff(fact_2962_Least__equality,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),X2: A] :
          ( pp(aa(A,bool,P,X2))
         => ( ! [Y2: A] :
                ( pp(aa(A,bool,P,Y2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2)) )
           => ( ord_Least(A,P) = X2 ) ) ) ) ).

% Least_equality
tff(fact_2963_LeastI2__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),X2: A,Q: fun(A,bool)] :
          ( pp(aa(A,bool,P,X2))
         => ( ! [Y2: A] :
                ( pp(aa(A,bool,P,Y2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2)) )
           => ( ! [X: A] :
                  ( pp(aa(A,bool,P,X))
                 => ( ! [Y5: A] :
                        ( pp(aa(A,bool,P,Y5))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y5)) )
                   => pp(aa(A,bool,Q,X)) ) )
             => pp(aa(A,bool,Q,ord_Least(A,P))) ) ) ) ) ).

% LeastI2_order
tff(fact_2964_Least1__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),Z2: A] :
          ( ? [X4: A] :
              ( pp(aa(A,bool,P,X4))
              & ! [Y2: A] :
                  ( pp(aa(A,bool,P,Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Y2)) )
              & ! [Y2: A] :
                  ( ( pp(aa(A,bool,P,Y2))
                    & ! [Ya: A] :
                        ( pp(aa(A,bool,P,Ya))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),Ya)) ) )
                 => ( Y2 = X4 ) ) )
         => ( pp(aa(A,bool,P,Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),ord_Least(A,P)),Z2)) ) ) ) ).

% Least1_le
tff(fact_2965_Least1I,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool)] :
          ( ? [X4: A] :
              ( pp(aa(A,bool,P,X4))
              & ! [Y2: A] :
                  ( pp(aa(A,bool,P,Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Y2)) )
              & ! [Y2: A] :
                  ( ( pp(aa(A,bool,P,Y2))
                    & ! [Ya: A] :
                        ( pp(aa(A,bool,P,Ya))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),Ya)) ) )
                 => ( Y2 = X4 ) ) )
         => pp(aa(A,bool,P,ord_Least(A,P))) ) ) ).

% Least1I
tff(fact_2966_Least__le,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),K: A] :
          ( pp(aa(A,bool,P,K))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),ord_Least(A,P)),K)) ) ) ).

% Least_le
tff(fact_2967_not__less__Least,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [K: A,P: fun(A,bool)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),ord_Least(A,P)))
         => ~ pp(aa(A,bool,P,K)) ) ) ).

% not_less_Least
tff(fact_2968_Inf__nat__def,axiom,
    ! [X5: set(nat)] : ( aa(set(nat),nat,complete_Inf_Inf(nat),X5) = ord_Least(nat,aTP_Lamp_xs(set(nat),fun(nat,bool),X5)) ) ).

% Inf_nat_def
tff(fact_2969_Least__Suc,axiom,
    ! [P: fun(nat,bool),N: nat] :
      ( pp(aa(nat,bool,P,N))
     => ( ~ pp(aa(nat,bool,P,zero_zero(nat)))
       => ( ord_Least(nat,P) = aa(nat,nat,suc,ord_Least(nat,aTP_Lamp_xf(fun(nat,bool),fun(nat,bool),P))) ) ) ) ).

% Least_Suc
tff(fact_2970_enumerate__0,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S: set(A)] : ( infini527867602293511546merate(A,S,zero_zero(nat)) = ord_Least(A,aTP_Lamp_xq(set(A),fun(A,bool),S)) ) ) ).

% enumerate_0
tff(fact_2971_less__int__def,axiom,
    ord_less(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),fun(int,fun(int,bool)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),bool),fun(int,bool),rep_Integ,map_fun(int,product_prod(nat,nat),bool,bool,rep_Integ,id(bool))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),bool))))) ).

% less_int_def
tff(fact_2972_less__eq__int__def,axiom,
    ord_less_eq(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),fun(int,fun(int,bool)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),bool),fun(int,bool),rep_Integ,map_fun(int,product_prod(nat,nat),bool,bool,rep_Integ,id(bool))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),bool))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)),product_case_prod(nat,nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),bool))))) ).

% less_eq_int_def
tff(fact_2973_Least__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B),S: set(A)] :
          ( order_mono(A,B,F2)
         => ( ? [X4: A] :
                ( pp(aa(set(A),bool,member(A,X4),S))
                & ! [Xa4: A] :
                    ( pp(aa(set(A),bool,member(A,Xa4),S))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Xa4)) ) )
           => ( ord_Least(B,aa(set(A),fun(B,bool),aTP_Lamp_xt(fun(A,B),fun(set(A),fun(B,bool)),F2),S)) = aa(A,B,F2,ord_Least(A,aTP_Lamp_xu(set(A),fun(A,bool),S))) ) ) ) ) ).

% Least_mono
tff(fact_2974_enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S: set(A),N: nat] :
          ( ~ pp(aa(set(A),bool,finite_finite2(A),S))
         => ( infini527867602293511546merate(A,S,aa(nat,nat,suc,N)) = ord_Least(A,aa(nat,fun(A,bool),aTP_Lamp_xp(set(A),fun(nat,fun(A,bool)),S),N)) ) ) ) ).

% enumerate_Suc''
tff(fact_2975_Bleast__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [S: set(A),P: fun(A,bool)] : ( bleast(A,S,P) = ord_Least(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_xv(set(A),fun(fun(A,bool),fun(A,bool)),S),P)) ) ) ).

% Bleast_def
tff(fact_2976_abort__Bleast__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [S: set(A),P: fun(A,bool)] : ( abort_Bleast(A,S,P) = ord_Least(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_xv(set(A),fun(fun(A,bool),fun(A,bool)),S),P)) ) ) ).

% abort_Bleast_def
tff(fact_2977_ring__1__class_Oof__int__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( ring_1_of_int(A) = aa(fun(product_prod(nat,nat),A),fun(int,A),map_fun(int,product_prod(nat,nat),A,A,rep_Integ,id(A)),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),aTP_Lamp_xa(nat,fun(nat,A)))) ) ) ).

% ring_1_class.of_int_def
tff(fact_2978_at__top__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ( at_top(A) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image2(A,filter(A),aTP_Lamp_xw(A,filter(A))),top_top(set(A)))) ) ) ).

% at_top_def
tff(fact_2979_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W2: num,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2)),B3)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),zero_zero(A))) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
tff(fact_2980_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [M2: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),M2)),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M2),N)) ) ) ).

% numeral_times_numeral
tff(fact_2981_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [V: num,W2: num,Z2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),Z2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2))),Z2) ) ) ).

% mult_numeral_left_semiring_numeral
tff(fact_2982_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A4: A,M2: num,N: num,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(num,nat,numeral_numeral(nat),M2))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(num,nat,numeral_numeral(nat),N))),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M2),N)))),B3) ) ) ).

% power_add_numeral2
tff(fact_2983_power__add__numeral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A4: A,M2: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(num,nat,numeral_numeral(nat),M2))),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(num,nat,numeral_numeral(nat),N))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M2),N))) ) ) ).

% power_add_numeral
tff(fact_2984_atLeast__empty__triv,axiom,
    ! [A: $tType] : ( aa(set(A),set(set(A)),set_ord_atLeast(set(A)),bot_bot(set(A))) = top_top(set(set(A))) ) ).

% atLeast_empty_triv
tff(fact_2985_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [V: num,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% distrib_left_numeral
tff(fact_2986_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [A4: A,B3: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(num,A,numeral_numeral(A),V))) ) ) ).

% distrib_right_numeral
tff(fact_2987_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [A4: A,B3: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(num,A,numeral_numeral(A),V))) ) ) ).

% left_diff_distrib_numeral
tff(fact_2988_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [V: num,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% right_diff_distrib_numeral
tff(fact_2989_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M2: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),M2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M2),N))) ) ) ).

% mult_neg_numeral_simps(3)
tff(fact_2990_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M2: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M2),N))) ) ) ).

% mult_neg_numeral_simps(2)
tff(fact_2991_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M2: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M2),N)) ) ) ).

% mult_neg_numeral_simps(1)
tff(fact_2992_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z2: int] :
          ( ( aa(int,A,ring_1_of_int(A),Z2) = one_one(A) )
        <=> ( Z2 = one_one(int) ) ) ) ).

% of_int_eq_1_iff
tff(fact_2993_of__int__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( aa(int,A,ring_1_of_int(A),one_one(int)) = one_one(A) ) ) ).

% of_int_1
tff(fact_2994_of__int__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W2: int,Z2: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),times_times(int),W2),Z2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),W2)),aa(int,A,ring_1_of_int(A),Z2)) ) ) ).

% of_int_mult
tff(fact_2995_Sup__atLeast,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X2: A] : ( aa(set(A),A,complete_Sup_Sup(A),aa(A,set(A),set_ord_atLeast(A),X2)) = top_top(A) ) ) ).

% Sup_atLeast
tff(fact_2996_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(num,A,numeral_numeral(A),W2))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(num,A,numeral_numeral(A),W2))),B3)) ) ) ).

% le_divide_eq_numeral1(1)
tff(fact_2997_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,W2: num,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(num,A,numeral_numeral(A),W2))),A4))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(num,A,numeral_numeral(A),W2)))) ) ) ).

% divide_le_eq_numeral1(1)
tff(fact_2998_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,B3: A,W2: num] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(num,A,numeral_numeral(A),W2)) )
        <=> ( ( ( aa(num,A,numeral_numeral(A),W2) != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(num,A,numeral_numeral(A),W2)) = B3 ) )
            & ( ( aa(num,A,numeral_numeral(A),W2) = zero_zero(A) )
             => ( A4 = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
tff(fact_2999_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B3: A,W2: num,A4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(num,A,numeral_numeral(A),W2)) = A4 )
        <=> ( ( ( aa(num,A,numeral_numeral(A),W2) != zero_zero(A) )
             => ( B3 = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(num,A,numeral_numeral(A),W2)) ) )
            & ( ( aa(num,A,numeral_numeral(A),W2) = zero_zero(A) )
             => ( A4 = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
tff(fact_3000_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(num,A,numeral_numeral(A),W2))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(num,A,numeral_numeral(A),W2))),B3)) ) ) ).

% less_divide_eq_numeral1(1)
tff(fact_3001_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,W2: num,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(num,A,numeral_numeral(A),W2))),A4))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(num,A,numeral_numeral(A),W2)))) ) ) ).

% divide_less_eq_numeral1(1)
tff(fact_3002_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_ring_1(A)
     => ! [F2: fun(B,int),A3: set(B)] : ( aa(int,A,ring_1_of_int(A),aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7121269368397514597t_prod(B,int),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_xx(fun(B,int),fun(B,A),F2)),A3) ) ) ).

% of_int_prod
tff(fact_3003_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(A)
     => ! [F2: fun(B,int),A3: set(B)] : ( aa(int,A,ring_1_of_int(A),aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7311177749621191930dd_sum(B,int),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_xy(fun(B,int),fun(B,A),F2)),A3) ) ) ).

% of_int_sum
tff(fact_3004_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,W2: num,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))),A4))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))),B3)) ) ) ).

% divide_le_eq_numeral1(2)
tff(fact_3005_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))))) ) ) ).

% le_divide_eq_numeral1(2)
tff(fact_3006_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B3: A,W2: num,A4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) = A4 )
        <=> ( ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) != zero_zero(A) )
             => ( B3 = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) ) )
            & ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) = zero_zero(A) )
             => ( A4 = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
tff(fact_3007_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,B3: A,W2: num] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) )
        <=> ( ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) = B3 ) )
            & ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) = zero_zero(A) )
             => ( A4 = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
tff(fact_3008_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))))) ) ) ).

% less_divide_eq_numeral1(2)
tff(fact_3009_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,W2: num,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))),A4))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))),B3)) ) ) ).

% divide_less_eq_numeral1(2)
tff(fact_3010_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z2),one_one(int))) ) ) ).

% of_int_le_1_iff
tff(fact_3011_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(int,A,ring_1_of_int(A),Z2)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),one_one(int)),Z2)) ) ) ).

% of_int_1_le_iff
tff(fact_3012_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z2),one_one(int))) ) ) ).

% of_int_less_1_iff
tff(fact_3013_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(int,A,ring_1_of_int(A),Z2)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),one_one(int)),Z2)) ) ) ).

% of_int_1_less_iff
tff(fact_3014_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: int,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),X2)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(int,A,ring_1_of_int(A),X2)) ) ) ).

% mult_of_int_commute
tff(fact_3015_not__empty__eq__Ici__eq__empty,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [L: A] : ( bot_bot(set(A)) != aa(A,set(A),set_ord_atLeast(A),L) ) ) ).

% not_empty_eq_Ici_eq_empty
tff(fact_3016_atLeast__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A] : ( aa(A,set(A),set_ord_atLeast(A),L) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),ord_less_eq(A),L)) ) ) ).

% atLeast_def
tff(fact_3017_one__le__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(num,A,numeral_numeral(A),N))) ) ).

% one_le_numeral
tff(fact_3018_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),N)),one_one(A))) ) ).

% not_numeral_less_one
tff(fact_3019_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),X2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),X2)),one_one(A)) ) ) ).

% one_plus_numeral_commute
tff(fact_3020_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] : ( one_one(A) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) ) ) ).

% one_neq_neg_numeral
tff(fact_3021_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),N) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% numeral_neq_neg_one
tff(fact_3022_atLeast__eq__UNIV__iff,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [X2: A] :
          ( ( aa(A,set(A),set_ord_atLeast(A),X2) = top_top(set(A)) )
        <=> ( X2 = bot_bot(A) ) ) ) ).

% atLeast_eq_UNIV_iff
tff(fact_3023_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2)))) ) ).

% not_one_le_neg_numeral
tff(fact_3024_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),M2)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% not_numeral_le_neg_one
tff(fact_3025_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% neg_numeral_le_neg_one
tff(fact_3026_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),M2))) ) ).

% neg_one_le_numeral
tff(fact_3027_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))),one_one(A))) ) ).

% neg_numeral_le_one
tff(fact_3028_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W2: num,B3: A,C2: A] :
          ( ( aa(num,A,numeral_numeral(A),W2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2) = B3 ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(num,A,numeral_numeral(A),W2) = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
tff(fact_3029_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B3: A,C2: A,W2: num] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) = aa(num,A,numeral_numeral(A),W2) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( B3 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(num,A,numeral_numeral(A),W2) = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
tff(fact_3030_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2)))) ) ).

% not_neg_one_less_neg_numeral
tff(fact_3031_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2)))) ) ).

% not_one_less_neg_numeral
tff(fact_3032_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),M2)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% not_numeral_less_neg_one
tff(fact_3033_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),M2))) ) ).

% neg_one_less_numeral
tff(fact_3034_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))),one_one(A))) ) ).

% neg_numeral_less_one
tff(fact_3035_ivl__disj__int__one_I8_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or7035219750837199246ssThan(A,L,U)),aa(A,set(A),set_ord_atLeast(A),U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(8)
tff(fact_3036_atLeastAtMost__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A,U: A] : ( set_or1337092689740270186AtMost(A,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_atLeast(A),L)),aa(A,set(A),set_ord_atMost(A),U)) ) ) ).

% atLeastAtMost_def
tff(fact_3037_atLeastLessThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A,U: A] : ( set_or7035219750837199246ssThan(A,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_atLeast(A),L)),aa(A,set(A),set_ord_lessThan(A),U)) ) ) ).

% atLeastLessThan_def
tff(fact_3038_of__int__leD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: int,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),N))),X2))
         => ( ( N = zero_zero(int) )
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X2)) ) ) ) ).

% of_int_leD
tff(fact_3039_of__int__lessD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: int,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),N))),X2))
         => ( ( N = zero_zero(int) )
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X2)) ) ) ) ).

% of_int_lessD
tff(fact_3040_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,C2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),aa(num,A,numeral_numeral(A),W2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2)),B3)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W2))) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
tff(fact_3041_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W2: num,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),W2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2)),B3)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),W2)),zero_zero(A))) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
tff(fact_3042_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B3: A,C2: A,W2: num] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( B3 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
tff(fact_3043_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W2: num,B3: A,C2: A] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2) = B3 ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
tff(fact_3044_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: product_prod(nat,nat)] : ( aa(int,A,ring_1_of_int(A),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),A,aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),aTP_Lamp_xa(nat,fun(nat,A))),X2) ) ) ).

% of_int.abs_eq
tff(fact_3045_atMost__Int__atLeast,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [N: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_atMost(A),N)),aa(A,set(A),set_ord_atLeast(A),N)) = aa(set(A),set(A),insert(A,N),bot_bot(set(A))) ) ) ).

% atMost_Int_atLeast
tff(fact_3046_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: int] : ( aa(int,A,ring_1_of_int(A),X2) = aa(product_prod(nat,nat),A,aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),aTP_Lamp_xa(nat,fun(nat,A))),aa(int,product_prod(nat,nat),rep_Integ,X2)) ) ) ).

% of_int.rep_eq
tff(fact_3047_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,C2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),aa(num,A,numeral_numeral(A),W2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2)),B3)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W2))) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
tff(fact_3048_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W2: num,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),W2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2)),B3)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),W2)),zero_zero(A))) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
tff(fact_3049_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,C2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2)),B3)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
tff(fact_3050_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W2: num,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2)),B3)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),zero_zero(A))) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
tff(fact_3051_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add(B)
        & semiring_numeral(B)
        & monoid_add(A)
        & semiring_numeral(A) )
     => ! [R: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),R,zero_zero(A)),zero_zero(B)))
         => ( pp(aa(B,bool,aa(A,fun(B,bool),R,one_one(A)),one_one(B)))
           => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R,bNF_rel_fun(A,B,A,B,R,R)),plus_plus(A)),plus_plus(B)))
             => pp(aa(fun(num,B),bool,aa(fun(num,A),fun(fun(num,B),bool),bNF_rel_fun(num,num,A,B,fequal(num),R),numeral_numeral(A)),numeral_numeral(B))) ) ) ) ) ).

% transfer_rule_numeral
tff(fact_3052_atLeast__Suc,axiom,
    ! [K: nat] : ( aa(nat,set(nat),set_ord_atLeast(nat),aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_atLeast(nat),K)),aa(set(nat),set(nat),insert(nat,K),bot_bot(set(nat)))) ) ).

% atLeast_Suc
tff(fact_3053_UN__atLeast__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Sup_Sup(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),set_ord_atLeast(nat)),top_top(set(nat)))) = top_top(set(nat)) ).

% UN_atLeast_UNIV
tff(fact_3054_at__top__sub,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A] : ( at_top(A) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image2(A,filter(A),aTP_Lamp_xz(A,filter(A))),aa(A,set(A),set_ord_atLeast(A),C2))) ) ) ).

% at_top_sub
tff(fact_3055_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1(B)
        & ring_1(A) )
     => ! [R: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),R,zero_zero(A)),zero_zero(B)))
         => ( pp(aa(B,bool,aa(A,fun(B,bool),R,one_one(A)),one_one(B)))
           => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R,bNF_rel_fun(A,B,A,B,R,R)),plus_plus(A)),plus_plus(B)))
             => ( pp(aa(fun(B,B),bool,aa(fun(A,A),fun(fun(B,B),bool),bNF_rel_fun(A,B,A,B,R,R),uminus_uminus(A)),uminus_uminus(B)))
               => pp(aa(fun(int,B),bool,aa(fun(int,A),fun(fun(int,B),bool),bNF_rel_fun(int,int,A,B,fequal(int),R),ring_1_of_int(A)),ring_1_of_int(B))) ) ) ) ) ) ).

% transfer_rule_of_int
tff(fact_3056_of__int_Otransfer,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => pp(aa(fun(int,A),bool,aa(fun(product_prod(nat,nat),A),fun(fun(int,A),bool),bNF_rel_fun(product_prod(nat,nat),int,A,A,pcr_int,fequal(A)),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),aTP_Lamp_xa(nat,fun(nat,A)))),ring_1_of_int(A))) ) ).

% of_int.transfer
tff(fact_3057_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B3: A,C2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2)),B3)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
tff(fact_3058_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W2: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2))),Y) ) ) ).

% semiring_norm(172)
tff(fact_3059_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W2: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2)))),Y) ) ) ).

% semiring_norm(171)
tff(fact_3060_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W2: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2)))),Y) ) ) ).

% semiring_norm(170)
tff(fact_3061_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [W2: num,X2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),aa(A,A,uminus_uminus(A),X2)) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) ) ) ).

% numeral_times_minus_swap
tff(fact_3062_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(A,X2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),X2)) ) ) ).

% neg_numeral_le_ceiling
tff(fact_3063_ceiling__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_ceiling(A,one_one(A)) = one_one(int) ) ) ).

% ceiling_one
tff(fact_3064_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,X2)),one_one(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),one_one(A))) ) ) ).

% ceiling_le_one
tff(fact_3065_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),one_one(int)),archimedean_ceiling(A,X2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X2)) ) ) ).

% one_less_ceiling
tff(fact_3066_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),one_one(A))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X2)),one_one(int)) ) ) ).

% ceiling_add_one
tff(fact_3067_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),one_one(A))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,X2)),one_one(int)) ) ) ).

% ceiling_diff_one
tff(fact_3068_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X2)),zero_zero(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,uminus_uminus(A),one_one(A)))) ) ) ).

% ceiling_less_zero
tff(fact_3069_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),archimedean_ceiling(A,X2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),X2)) ) ) ).

% zero_le_ceiling
tff(fact_3070_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X2)),aa(num,int,numeral_numeral(int),V)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A)))) ) ) ).

% ceiling_less_numeral
tff(fact_3071_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(A,X2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),X2)) ) ) ).

% numeral_le_ceiling
tff(fact_3072_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A)))) ) ) ).

% ceiling_less_neg_numeral
tff(fact_3073_ceiling__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,bool),T3: A] :
          ( pp(aa(int,bool,P,archimedean_ceiling(A,T3)))
        <=> ! [I6: int] :
              ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),I6)),one_one(A))),T3))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),T3),aa(int,A,ring_1_of_int(A),I6))) )
             => pp(aa(int,bool,P,I6)) ) ) ) ).

% ceiling_split
tff(fact_3074_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,A4: int] :
          ( ( archimedean_ceiling(A,X2) = A4 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),A4)),one_one(A))),X2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(int,A,ring_1_of_int(A),A4))) ) ) ) ).

% ceiling_eq_iff
tff(fact_3075_ceiling__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z2: int,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A))),X2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(int,A,ring_1_of_int(A),Z2)))
           => ( archimedean_ceiling(A,X2) = Z2 ) ) ) ) ).

% ceiling_unique
tff(fact_3076_ceiling__correct,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,X2))),one_one(A))),X2))
          & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,X2)))) ) ) ).

% ceiling_correct
tff(fact_3077_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3))),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(A,A4)),archimedean_ceiling(A,B3)))) ) ) ) ).

% mult_ceiling_le
tff(fact_3078_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Z2: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X2)),Z2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A)))) ) ) ).

% ceiling_less_iff
tff(fact_3079_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z2: int,X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z2),archimedean_ceiling(A,X2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A))),X2)) ) ) ).

% le_ceiling_iff
tff(fact_3080_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q3: A,P5: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),P5),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P5),Q3)))),Q3))) ) ) ).

% ceiling_divide_upper
tff(fact_3081_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q3: A,P5: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P5),Q3)))),one_one(A))),Q3)),P5)) ) ) ).

% ceiling_divide_lower
tff(fact_3082_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A)))) ) ) ).

% floor_le_neg_numeral
tff(fact_3083_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(A,X2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),X2)) ) ) ).

% neg_numeral_less_floor
tff(fact_3084_sub_Orsp,axiom,
    pp(aa(fun(num,fun(num,int)),bool,aa(fun(num,fun(num,int)),fun(fun(num,fun(num,int)),bool),bNF_rel_fun(num,num,fun(num,int),fun(num,int),fequal(num),bNF_rel_fun(num,num,int,int,fequal(num),fequal(int))),aTP_Lamp_ya(num,fun(num,int))),aTP_Lamp_ya(num,fun(num,int)))) ).

% sub.rsp
tff(fact_3085_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z2: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z2,aa(nat,nat,suc,N))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_yb(A,fun(nat,A),Z2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)),one_one(nat)))) ) ) ).

% pochhammer_times_pochhammer_half
tff(fact_3086_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & linordered_idom(A) )
     => ! [A4: B,B3: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),A4))
         => ( pp(aa(set(B),bool,member(B,A4),ring_1_Ints(B)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)))),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(B,A4)),archimedean_ceiling(B,B3))))) ) ) ) ).

% mult_ceiling_le_Ints
tff(fact_3087_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: num] :
          ( ( aa(num,A,numeral_numeral(A),N) = one_one(A) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_one_iff
tff(fact_3088_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),N) )
        <=> ( one2 = N ) ) ) ).

% one_eq_numeral_iff
tff(fact_3089_floor__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archim6421214686448440834_floor(A,one_one(A)) = one_one(int) ) ) ).

% floor_one
tff(fact_3090_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),N)),one_one(A)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),N),one2)) ) ) ).

% numeral_le_one_iff
tff(fact_3091_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(num,A,numeral_numeral(A),N)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),one2),N)) ) ) ).

% one_less_numeral_iff
tff(fact_3092_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
tff(fact_3093_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] :
          ( ( aa(A,A,uminus_uminus(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) )
        <=> ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
tff(fact_3094_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))))
        <=> ( M2 != one2 ) ) ) ).

% not_neg_one_le_neg_numeral_iff
tff(fact_3095_one__add__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% one_add_one
tff(fact_3096_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))),aa(A,A,uminus_uminus(A),one_one(A))))
        <=> ( M2 != one2 ) ) ) ).

% neg_numeral_less_neg_one_iff
tff(fact_3097_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2)) ) ) ).

% numeral_plus_one
tff(fact_3098_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% one_plus_numeral
tff(fact_3099_zero__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),archim6421214686448440834_floor(A,X2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X2)) ) ) ).

% zero_less_floor
tff(fact_3100_floor__le__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X2)),zero_zero(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),one_one(A))) ) ) ).

% floor_le_zero
tff(fact_3101_one__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),one_one(int)),archim6421214686448440834_floor(A,X2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X2)) ) ) ).

% one_le_floor
tff(fact_3102_floor__less__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archim6421214686448440834_floor(A,X2)),one_one(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),one_one(A))) ) ) ).

% floor_less_one
tff(fact_3103_floor__diff__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),one_one(A))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(A,X2)),one_one(int)) ) ) ).

% floor_diff_one
tff(fact_3104_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% bits_1_div_2
tff(fact_3105_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% one_div_two_eq_zero
tff(fact_3106_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% add_neg_numeral_special(9)
tff(fact_3107_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% diff_numeral_special(11)
tff(fact_3108_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% diff_numeral_special(10)
tff(fact_3109_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% minus_1_div_2_eq
tff(fact_3110_card__doubleton__eq__2__iff,axiom,
    ! [A: $tType,A4: A,B3: A] :
      ( ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ( A4 != B3 ) ) ).

% card_doubleton_eq_2_iff
tff(fact_3111_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% diff_numeral_special(3)
tff(fact_3112_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M2: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M2),one2))) ) ) ).

% diff_numeral_special(4)
tff(fact_3113_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = one_one(A) ) ) ).

% power_minus1_even
tff(fact_3114_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(A,X2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),X2)) ) ) ).

% numeral_less_floor
tff(fact_3115_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X2)),aa(num,int,numeral_numeral(int),V)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A)))) ) ) ).

% floor_le_numeral
tff(fact_3116_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),zero_zero(nat))) ) ) ).

% one_div_2_pow_eq
tff(fact_3117_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),zero_zero(nat))) ) ) ).

% bits_1_div_exp
tff(fact_3118_Ints__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(set(A),bool,member(A,A4),ring_1_Ints(A)))
         => ( pp(aa(set(A),bool,member(A,B3),ring_1_Ints(A)))
           => pp(aa(set(A),bool,member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),ring_1_Ints(A))) ) ) ) ).

% Ints_mult
tff(fact_3119_Ints__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => pp(aa(set(A),bool,member(A,one_one(A)),ring_1_Ints(A))) ) ).

% Ints_1
tff(fact_3120_mult__2,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Z2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),Z2) ) ) ).

% mult_2
tff(fact_3121_mult__2__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),Z2) ) ) ).

% mult_2_right
tff(fact_3122_left__add__twice,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4)),B3) ) ) ).

% left_add_twice
tff(fact_3123_power2__eq__square,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A4: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),A4) ) ) ).

% power2_eq_square
tff(fact_3124_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),X2)),X2) ) ) ).

% power4_eq_xxxx
tff(fact_3125_one__power2,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),one_one(A)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% one_power2
tff(fact_3126_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A4: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) )
        <=> ( ( A4 = one_one(A) )
            | ( A4 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% power2_eq_1_iff
tff(fact_3127_card__2__iff,axiom,
    ! [A: $tType,S: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),S) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ? [X3: A,Y4: A] :
          ( ( S = aa(set(A),set(A),insert(A,X3),aa(set(A),set(A),insert(A,Y4),bot_bot(set(A)))) )
          & ( X3 != Y4 ) ) ) ).

% card_2_iff
tff(fact_3128_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) )
        <=> ( aa(A,A,abs_abs(A),X2) = one_one(A) ) ) ) ).

% abs_square_eq_1
tff(fact_3129_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(num,A,numeral_numeral(A),one2)) = A4 ) ) ).

% mult_numeral_1_right
tff(fact_3130_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),one2)),A4) = A4 ) ) ).

% mult_numeral_1
tff(fact_3131_numeral__One,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(num,A,numeral_numeral(A),one2) = one_one(A) ) ) ).

% numeral_One
tff(fact_3132_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K))
     => order_mono(nat,nat,aTP_Lamp_yc(nat,fun(nat,nat),K)) ) ).

% mono_ge2_power_minus_self
tff(fact_3133_floor__rat__def,axiom,
    ! [X2: rat] : ( archim6421214686448440834_floor(rat,X2) = the(int,aTP_Lamp_yd(rat,fun(int,bool),X2)) ) ).

% floor_rat_def
tff(fact_3134_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & linordered_idom(A) )
     => ! [A4: B,B3: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),A4))
         => ( pp(aa(set(B),bool,member(B,A4),ring_1_Ints(B)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(B,A4)),archim6421214686448440834_floor(B,B3)))),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))))) ) ) ) ).

% le_mult_floor_Ints
tff(fact_3135_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),aa(num,num,bit0,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),aa(num,A,numeral_numeral(A),N)) ) ) ).

% numeral_code(2)
tff(fact_3136_power2__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X2: A,Y: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2)),Y)) ) ) ).

% power2_sum
tff(fact_3137_square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),X2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A))) ) ) ) ).

% square_le_1
tff(fact_3138_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X2)),one_one(A))) ) ) ).

% abs_square_le_1
tff(fact_3139_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),X2)),one_one(A))) ) ) ).

% abs_square_less_1
tff(fact_3140_bits__induct,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [P: fun(A,bool),A4: A] :
          ( ! [A5: A] :
              ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A5),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A5 )
             => pp(aa(A,bool,P,A5)) )
         => ( ! [A5: A,B4: bool] :
                ( pp(aa(A,bool,P,A5))
               => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(bool,A,zero_neq_one_of_bool(A),B4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A5))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A5 )
                 => pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(bool,A,zero_neq_one_of_bool(A),B4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A5)))) ) )
           => pp(aa(A,bool,P,A4)) ) ) ) ).

% bits_induct
tff(fact_3141_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A4: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A4)),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A4)),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) ) ) ).

% minus_power_mult_self
tff(fact_3142_power__odd__eq,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A4: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% power_odd_eq
tff(fact_3143_finite__int__segment,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A4: A,B3: A] : pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_ye(A,fun(A,fun(A,bool)),A4),B3)))) ) ).

% finite_int_segment
tff(fact_3144_power2__diff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X2: A,Y: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2)),Y)) ) ) ).

% power2_diff
tff(fact_3145_choose__row__sum,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),binomial(N)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N) ) ).

% choose_row_sum
tff(fact_3146_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% power_minus1_odd
tff(fact_3147_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)),one_one(A)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N))) ) ) ).

% mask_eq_sum_exp
tff(fact_3148_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))),B3) = aa(A,A,uminus_uminus(A),B3) ) ) ).

% mult_1s_ring_1(1)
tff(fact_3149_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))) = aa(A,A,uminus_uminus(A),B3) ) ) ).

% mult_1s_ring_1(2)
tff(fact_3150_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% uminus_numeral_One
tff(fact_3151_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M2: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_yf(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% sum.in_pairs
tff(fact_3152_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M2: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_yg(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% prod.in_pairs
tff(fact_3153_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [A4: A] :
          ( pp(aa(set(A),bool,member(A,A4),ring_1_Ints(A)))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A4)),A4) != zero_zero(A) ) ) ) ).

% Ints_odd_nonzero
tff(fact_3154_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_yf(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% sum.in_pairs_0
tff(fact_3155_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_yg(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% prod.in_pairs_0
tff(fact_3156_power__numeral__even,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z2: A,W2: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,W2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),W2))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),W2))) ) ) ).

% power_numeral_even
tff(fact_3157_choose__square__sum,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_yh(nat,fun(nat,nat),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)),N) ) ).

% choose_square_sum
tff(fact_3158_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A4: A] : pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_yi(A,fun(A,bool),A4)))) ) ).

% finite_abs_int_segment
tff(fact_3159_one__add__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X2)),one_one(int)) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),one_one(A))) ) ) ).

% one_add_floor
tff(fact_3160_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)),aa(nat,nat,suc,zero_zero(nat))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N))) ) ).

% mask_eq_sum_exp_nat
tff(fact_3161_gauss__sum__nat,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vy(nat,nat)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,suc,N))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% gauss_sum_nat
tff(fact_3162_sum__power2,axiom,
    ! [K: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)),one_one(nat)) ) ).

% sum_power2
tff(fact_3163_Sum__Ico__nat,axiom,
    ! [M2: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vy(nat,nat)),set_or7035219750837199246ssThan(nat,M2,N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),one_one(nat))))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% Sum_Ico_nat
tff(fact_3164_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M2: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),fconj(aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),fequal(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2)),zero_zero(A))),aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),N))) ) ) ).

% exp_div_exp_eq
tff(fact_3165_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))) ) ) ).

% double_gauss_sum
tff(fact_3166_double__arith__series,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A,D3: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_yj(A,fun(A,fun(nat,A)),A4),D3)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),D3))) ) ) ).

% double_arith_series
tff(fact_3167_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] :
          ( pp(aa(set(A),bool,member(A,A4),ring_1_Ints(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A4)),A4)),zero_zero(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A))) ) ) ) ).

% Ints_odd_less_0
tff(fact_3168_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_yk(nat,fun(nat,A),M2)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2) ) ) ).

% gbinomial_sum_nat_pow2
tff(fact_3169_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( pp(aa(set(A),bool,member(A,X2),ring_1_Ints(A)))
         => ( ( X2 != zero_zero(A) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,abs_abs(A),X2))) ) ) ) ).

% Ints_nonzero_abs_ge1
tff(fact_3170_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( pp(aa(set(A),bool,member(A,X2),ring_1_Ints(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),X2)),one_one(A)))
           => ( X2 = zero_zero(A) ) ) ) ) ).

% Ints_nonzero_abs_less1
tff(fact_3171_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(set(A),bool,member(A,X2),ring_1_Ints(A)))
         => ( pp(aa(set(A),bool,member(A,Y),ring_1_Ints(A)))
           => ( ( X2 = Y )
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y))),one_one(A))) ) ) ) ) ).

% Ints_eq_abs_less1
tff(fact_3172_arith__series__nat,axiom,
    ! [A4: nat,D3: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_yl(nat,fun(nat,fun(nat,nat)),A4),D3)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,N)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),A4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),D3)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% arith_series_nat
tff(fact_3173_Sum__Icc__int,axiom,
    ! [M2: int,N: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),M2),N))
     => ( aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7311177749621191930dd_sum(int,int),aTP_Lamp_ry(int,int)),set_or1337092689740270186AtMost(int,M2,N)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),N),aa(int,int,aa(int,fun(int,int),plus_plus(int),N),one_one(int)))),aa(int,int,aa(int,fun(int,int),times_times(int),M2),aa(int,int,aa(int,fun(int,int),minus_minus(int),M2),one_one(int))))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ) ).

% Sum_Icc_int
tff(fact_3174_Sum__Icc__nat,axiom,
    ! [M2: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vy(nat,nat)),set_or1337092689740270186AtMost(nat,M2,N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),one_one(nat))))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% Sum_Icc_nat
tff(fact_3175_binomial__r__part__sum,axiom,
    ! [M2: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2)),one_one(nat)))),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2)) ) ).

% binomial_r_part_sum
tff(fact_3176_choose__linear__sum,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_ym(nat,fun(nat,nat),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ).

% choose_linear_sum
tff(fact_3177_floor__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,bool),T3: A] :
          ( pp(aa(int,bool,P,archim6421214686448440834_floor(A,T3)))
        <=> ! [I6: int] :
              ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),I6)),T3))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),T3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),I6)),one_one(A)))) )
             => pp(aa(int,bool,P,I6)) ) ) ) ).

% floor_split
tff(fact_3178_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,A4: int] :
          ( ( archim6421214686448440834_floor(A,X2) = A4 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),A4)),X2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),A4)),one_one(A)))) ) ) ) ).

% floor_eq_iff
tff(fact_3179_floor__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z2: int,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z2)),X2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A))))
           => ( archim6421214686448440834_floor(A,X2) = Z2 ) ) ) ) ).

% floor_unique
tff(fact_3180_le__mult__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B3))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(A,A4)),archim6421214686448440834_floor(A,B3))),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))) ) ) ) ).

% le_mult_floor
tff(fact_3181_fact__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N))),semiring_char_0_fact(A,N)) ) ) ).

% fact_double
tff(fact_3182_less__floor__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z2: int,X2: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z2),archim6421214686448440834_floor(A,X2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A))),X2)) ) ) ).

% less_floor_iff
tff(fact_3183_floor__le__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Z2: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X2)),Z2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A)))) ) ) ).

% floor_le_iff
tff(fact_3184_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))) ) ) ).

% double_gauss_sum_from_Suc_0
tff(fact_3185_arith__series,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A4: A,D3: A,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_yn(A,fun(A,fun(nat,A)),A4),D3)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),D3)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% arith_series
tff(fact_3186_gauss__sum,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum
tff(fact_3187_dup_Orsp,axiom,
    pp(aa(fun(int,int),bool,aa(fun(int,int),fun(fun(int,int),bool),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int)),aTP_Lamp_yo(int,int)),aTP_Lamp_yo(int,int))) ).

% dup.rsp
tff(fact_3188_pochhammer__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z2: A,N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Z2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))),comm_s3205402744901411588hammer(A,Z2,N))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),N)) ) ) ).

% pochhammer_double
tff(fact_3189_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum_from_Suc_0
tff(fact_3190_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [R2: A,M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_yp(A,fun(nat,A),R2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),M2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,M2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,gbinomial(A,R2),aa(nat,nat,suc,M2))) ) ) ).

% gchoose_row_sum_weighted
tff(fact_3191_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q3: A,P5: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P5),Q3)))),Q3)),P5)) ) ) ).

% floor_divide_lower
tff(fact_3192_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,semiring_1_of_nat(A),M2))),one_one(A)))),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2)) ) ) ).

% gbinomial_r_part_sum
tff(fact_3193_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: A,M2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_yp(A,fun(nat,A),A4)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),M2)),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,gbinomial(A,A4),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),one_one(nat)))) ) ) ).

% gbinomial_partial_row_sum
tff(fact_3194_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q3: A,P5: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),P5),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P5),Q3)))),one_one(A))),Q3))) ) ) ).

% floor_divide_upper
tff(fact_3195_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,R2: A,Q3: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),L)),R2))
           => ( unique1321980374590559556d_step(A,L,aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),R2)) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Q3)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),R2),aa(num,A,numeral_numeral(A),L))) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),L)),R2))
           => ( unique1321980374590559556d_step(A,L,aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),R2)) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Q3)),R2) ) ) ) ) ).

% divmod_step_eq
tff(fact_3196_divmod__step__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,Qr: product_prod(A,A)] : ( unique1321980374590559556d_step(A,L,Qr) = aa(product_prod(A,A),product_prod(A,A),aa(fun(A,fun(A,product_prod(A,A))),fun(product_prod(A,A),product_prod(A,A)),product_case_prod(A,A,product_prod(A,A)),aTP_Lamp_yq(num,fun(A,fun(A,product_prod(A,A))),L)),Qr) ) ) ).

% divmod_step_def
tff(fact_3197_divmod__step__nat__def,axiom,
    ! [L: num,Qr: product_prod(nat,nat)] : ( unique1321980374590559556d_step(nat,L,Qr) = aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_yr(num,fun(nat,fun(nat,product_prod(nat,nat))),L)),Qr) ) ).

% divmod_step_nat_def
tff(fact_3198_set__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A] : ( bit_se5668285175392031749et_bit(A,zero_zero(nat),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% set_bit_0
tff(fact_3199_divmod__step__int__def,axiom,
    ! [L: num,Qr: product_prod(int,int)] : ( unique1321980374590559556d_step(int,L,Qr) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_ys(num,fun(int,fun(int,product_prod(int,int))),L)),Qr) ) ).

% divmod_step_int_def
tff(fact_3200_divmod__step__integer__def,axiom,
    ! [L: num,Qr: product_prod(code_integer,code_integer)] : ( unique1321980374590559556d_step(code_integer,L,Qr) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_yt(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),Qr) ) ).

% divmod_step_integer_def
tff(fact_3201_unset__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A] : ( bit_se2638667681897837118et_bit(A,zero_zero(nat),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% unset_bit_0
tff(fact_3202_round__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Y: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(int,A,ring_1_of_int(A),Y)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))))
           => ( archimedean_round(A,X2) = Y ) ) ) ) ).

% round_unique
tff(fact_3203_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_yu(nat,fun(nat,A),N)),aa(nat,set(nat),set_ord_atMost(nat),N))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N) ) ) ) ).

% choose_odd_sum
tff(fact_3204_choose__even__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_yv(nat,fun(nat,A),N)),aa(nat,set(nat),set_ord_atMost(nat),N))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N) ) ) ) ).

% choose_even_sum
tff(fact_3205_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% dbl_simps(4)
tff(fact_3206_dvd__0__right,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),zero_zero(A))) ) ).

% dvd_0_right
tff(fact_3207_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),zero_zero(A)),A4))
        <=> ( A4 = zero_zero(A) ) ) ) ).

% dvd_0_left_iff
tff(fact_3208_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ).

% dvd_add_triv_left_iff
tff(fact_3209_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ).

% dvd_add_triv_right_iff
tff(fact_3210_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X2),aa(A,A,uminus_uminus(A),Y)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X2),Y)) ) ) ).

% dvd_minus_iff
tff(fact_3211_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,uminus_uminus(A),X2)),Y))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X2),Y)) ) ) ).

% minus_dvd_iff
tff(fact_3212_div__dvd__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A4)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),C2)) ) ) ) ) ).

% div_dvd_div
tff(fact_3213_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: A,K: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,abs_abs(A),M2)),K))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),M2),K)) ) ) ).

% abs_dvd_iff
tff(fact_3214_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M2: A,K: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),M2),aa(A,A,abs_abs(A),K)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),M2),K)) ) ) ).

% dvd_abs_iff
tff(fact_3215_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
        <=> ( ( C2 = zero_zero(A) )
            | pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ) ).

% dvd_mult_cancel_left
tff(fact_3216_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)))
        <=> ( ( C2 = zero_zero(A) )
            | pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ) ).

% dvd_mult_cancel_right
tff(fact_3217_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),C2)) ) ) ) ).

% dvd_times_left_cancel_iff
tff(fact_3218_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),C2)) ) ) ) ).

% dvd_times_right_cancel_iff
tff(fact_3219_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ).

% dvd_add_times_triv_left_iff
tff(fact_3220_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ).

% dvd_add_times_triv_right_iff
tff(fact_3221_unit__prod,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),one_one(A))) ) ) ) ).

% unit_prod
tff(fact_3222_div__add,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)) ) ) ) ) ).

% div_add
tff(fact_3223_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)) = B3 ) ) ) ).

% dvd_mult_div_cancel
tff(fact_3224_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)),A4) = B3 ) ) ) ).

% dvd_div_mult_self
tff(fact_3225_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4)) = A4 ) ) ) ).

% unit_div_1_div_1
tff(fact_3226_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4)),one_one(A))) ) ) ).

% unit_div_1_unit
tff(fact_3227_unit__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),one_one(A))) ) ) ) ).

% unit_div
tff(fact_3228_div__diff,axiom,
    ! [A: $tType] :
      ( idom_modulo(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)) ) ) ) ) ).

% div_diff
tff(fact_3229_round__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_round(A,one_one(A)) = one_one(int) ) ) ).

% round_1
tff(fact_3230_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4) ) ) ) ).

% unit_mult_div_div
tff(fact_3231_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)),A4) = B3 ) ) ) ).

% unit_div_mult_self
tff(fact_3232_even__mult__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
            | pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3)) ) ) ) ).

% even_mult_iff
tff(fact_3233_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% dbl_simps(3)
tff(fact_3234_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))))
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4)) ) ) ).

% even_plus_one_iff
tff(fact_3235_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A4)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_2
tff(fact_3236_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_two
tff(fact_3237_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A4: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ) ).

% odd_succ_div_two
tff(fact_3238_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N) = one_one(A) ) ) ) ).

% neg_one_even_power
tff(fact_3239_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% neg_one_odd_power
tff(fact_3240_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A4: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),one_one(A)) = A4 ) ) ) ).

% odd_two_times_div_two_succ
tff(fact_3241_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)),one_one(A))))
        <=> ( N = zero_zero(nat) ) ) ) ).

% semiring_parity_class.even_mask_iff
tff(fact_3242_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) ) ) ) ) ).

% even_succ_div_exp
tff(fact_3243_div__div__div__same,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [D3: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D3),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),D3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),D3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) ) ) ) ) ).

% div_div_div_same
tff(fact_3244_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A4: A,C2: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
             => ( A4 = B3 ) ) ) ) ) ).

% dvd_div_eq_cancel
tff(fact_3245_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2) )
            <=> ( A4 = B3 ) ) ) ) ) ).

% dvd_div_eq_iff
tff(fact_3246_image__add__integer__atLeastLessThan,axiom,
    ! [L: code_integer,U: code_integer] : ( aa(set(code_integer),set(code_integer),image2(code_integer,code_integer,aTP_Lamp_yw(code_integer,fun(code_integer,code_integer),L)),set_or7035219750837199246ssThan(code_integer,zero_zero(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),U),L))) = set_or7035219750837199246ssThan(code_integer,L,U) ) ).

% image_add_integer_atLeastLessThan
tff(fact_3247_dvd__0__left,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),zero_zero(A)),A4))
         => ( A4 = zero_zero(A) ) ) ) ).

% dvd_0_left
tff(fact_3248_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2)) ) ) ) ).

% dvd_add_right_iff
tff(fact_3249_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ) ).

% dvd_add_left_iff
tff(fact_3250_dvd__add,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),plus_plus(A),B3),C2))) ) ) ) ).

% dvd_add
tff(fact_3251_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4))) ) ).

% dvd_triv_right
tff(fact_3252_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),C2)) ) ) ).

% dvd_mult_right
tff(fact_3253_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),D3))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),D3))) ) ) ) ).

% mult_dvd_mono
tff(fact_3254_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3))) ) ).

% dvd_triv_left
tff(fact_3255_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2)) ) ) ).

% dvd_mult_left
tff(fact_3256_dvd__mult2,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2))) ) ) ).

% dvd_mult2
tff(fact_3257_dvd__mult,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2))) ) ) ).

% dvd_mult
tff(fact_3258_dvd__def,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
        <=> ? [K6: A] : ( A4 = aa(A,A,aa(A,fun(A,A),times_times(A),B3),K6) ) ) ) ).

% dvd_def
tff(fact_3259_dvdI,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [A4: A,B3: A,K: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),times_times(A),B3),K) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4)) ) ) ).

% dvdI
tff(fact_3260_dvdE,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
         => ~ ! [K2: A] : ( A4 != aa(A,A,aa(A,fun(A,A),times_times(A),B3),K2) ) ) ) ).

% dvdE
tff(fact_3261_one__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),one_one(A)),A4)) ) ).

% one_dvd
tff(fact_3262_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4)) ) ) ).

% unit_imp_dvd
tff(fact_3263_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A))) ) ) ) ).

% dvd_unit_imp_unit
tff(fact_3264_dvd__diff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X2),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X2),Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X2),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z2))) ) ) ) ).

% dvd_diff
tff(fact_3265_dvd__refl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),A4)) ) ).

% dvd_refl
tff(fact_3266_dvd__trans,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2)) ) ) ) ).

% dvd_trans
tff(fact_3267_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [L: A,K: A] :
          ( ( aa(A,A,abs_abs(A),L) = aa(A,A,abs_abs(A),K) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),L),K)) ) ) ).

% dvd_if_abs_eq
tff(fact_3268_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_yx(A,fun(A,bool),A4))),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_yx(A,fun(A,bool),B3))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ).

% subset_divisors_dvd
tff(fact_3269_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_yx(A,fun(A,bool),A4))),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_yx(A,fun(A,bool),B3))))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4)) ) ) ) ).

% strict_subset_divisors_dvd
tff(fact_3270_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),zero_zero(A)),one_one(A))) ) ).

% not_is_unit_0
tff(fact_3271_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),one_one(A)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A))) ) ) ) ).

% is_unit_mult_iff
tff(fact_3272_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2)) ) ) ) ).

% dvd_mult_unit_iff
tff(fact_3273_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2)) ) ) ) ).

% mult_unit_dvd_iff
tff(fact_3274_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2)) ) ) ) ).

% dvd_mult_unit_iff'
tff(fact_3275_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),C2)) ) ) ) ).

% mult_unit_dvd_iff'
tff(fact_3276_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2) )
          <=> ( B3 = C2 ) ) ) ) ).

% unit_mult_left_cancel
tff(fact_3277_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4) )
          <=> ( B3 = C2 ) ) ) ) ).

% unit_mult_right_cancel
tff(fact_3278_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) = zero_zero(A) )
          <=> ( A4 = zero_zero(A) ) ) ) ) ).

% dvd_div_eq_0_iff
tff(fact_3279_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A,D3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D3),C2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),D3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),D3)) ) ) ) ) ).

% div_mult_div_if_dvd
tff(fact_3280_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))) ) ) ).

% dvd_mult_imp_div
tff(fact_3281_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)),A4))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),C2) ) ) ) ).

% dvd_div_mult2_eq
tff(fact_3282_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),C2) ) ) ) ) ).

% div_div_eq_right
tff(fact_3283_div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2) ) ) ) ).

% div_mult_swap
tff(fact_3284_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)),A4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)),C2) ) ) ) ).

% dvd_div_mult
tff(fact_3285_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2)) ) ) ) ).

% dvd_div_unit_iff
tff(fact_3286_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),C2))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2)) ) ) ) ).

% div_unit_dvd_iff
tff(fact_3287_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A4) )
          <=> ( B3 = C2 ) ) ) ) ).

% unit_div_cancel
tff(fact_3288_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A4)),B3) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)) ) ) ) ).

% dvd_neg_div
tff(fact_3289_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,uminus_uminus(A),B3)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)) ) ) ) ).

% dvd_div_neg
tff(fact_3290_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( dvd(A)
        & semiring_0(A) )
     => ! [P: fun(A,bool),L: A] :
          ( ? [X3: A] : pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),times_times(A),L),X3)))
        <=> ? [X3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),L),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),zero_zero(A))))
              & pp(aa(A,bool,P,X3)) ) ) ) ).

% unity_coeff_ex
tff(fact_3291_unit__dvdE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ~ ( ( A4 != zero_zero(A) )
             => ! [C4: A] : ( B3 != aa(A,A,aa(A,fun(A,A),times_times(A),A4),C4) ) ) ) ) ).

% unit_dvdE
tff(fact_3292_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D3: A,D2: A,T3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D3),D2))
         => ! [X4: A,K3: A] :
              ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D3),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),T3)))
            <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D2))),T3))) ) ) ) ).

% inf_period(4)
tff(fact_3293_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D3: A,D2: A,T3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D3),D2))
         => ! [X4: A,K3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D3),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),T3)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),D3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D2))),T3))) ) ) ) ).

% inf_period(3)
tff(fact_3294_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( ( A4 != zero_zero(A) )
         => ( ( C2 != zero_zero(A) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),D3))
               => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),D3),C2) )
                <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),D3) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
tff(fact_3295_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B3: A,A4: A] :
          ( ( C2 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3)) ) ) ) ) ).

% dvd_div_iff_mult
tff(fact_3296_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A,C2: A] :
          ( ( B3 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),C2))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3))) ) ) ) ) ).

% div_dvd_iff_mult
tff(fact_3297_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4) = C2 )
            <=> ( B3 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4) ) ) ) ) ) ).

% dvd_div_eq_mult
tff(fact_3298_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) = zero_zero(A) )
          <=> ( A4 = zero_zero(A) ) ) ) ) ).

% unit_div_eq_0_iff
tff(fact_3299_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) = C2 )
          <=> ( A4 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3) ) ) ) ) ).

% unit_eq_div1
tff(fact_3300_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( ( A4 = aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B3) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3) = C2 ) ) ) ) ).

% unit_eq_div2
tff(fact_3301_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),C2) ) ) ) ) ).

% div_mult_unit2
tff(fact_3302_unit__div__commute,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3) ) ) ) ).

% unit_div_commute
tff(fact_3303_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2) ) ) ) ).

% unit_div_mult_swap
tff(fact_3304_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),one_one(A)))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),C2) ) ) ) ) ).

% is_unit_div_mult2_eq
tff(fact_3305_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),N)),one_one(A)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
            | ( N = zero_zero(nat) ) ) ) ) ).

% is_unit_power_iff
tff(fact_3306_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,N))),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N)))) ) ).

% fact_fact_dvd_fact
tff(fact_3307_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_parity(A)
     => ! [A3: set(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)))
          <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(set(B),nat,finite_card(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_yy(set(B),fun(fun(B,A),fun(B,bool)),A3),F2))))) ) ) ) ).

% even_sum_iff
tff(fact_3308_is__unitE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ~ ( ( A4 != zero_zero(A) )
             => ! [B4: A] :
                  ( ( B4 != zero_zero(A) )
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B4),one_one(A)))
                   => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4) = B4 )
                     => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B4) = A4 )
                       => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),B4) = one_one(A) )
                         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A4) != aa(A,A,aa(A,fun(A,A),times_times(A),C2),B4) ) ) ) ) ) ) ) ) ) ).

% is_unitE
tff(fact_3309_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B3) ) ) ) ) ).

% is_unit_div_mult_cancel_left
tff(fact_3310_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B3) ) ) ) ) ).

% is_unit_div_mult_cancel_right
tff(fact_3311_evenE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
         => ~ ! [B4: A] : ( A4 != aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B4) ) ) ) ).

% evenE
tff(fact_3312_odd__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),one_one(A))) ) ).

% odd_one
tff(fact_3313_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [X2: A,M2: nat,N: nat] :
          ( ( X2 != zero_zero(A) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N)))
          <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X2),one_one(A)))
              | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N)) ) ) ) ) ).

% dvd_power_iff
tff(fact_3314_dvd__power,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat,X2: A] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
            | ( X2 = one_one(A) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X2),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N))) ) ) ).

% dvd_power
tff(fact_3315_choose__dvd,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))),semiring_char_0_fact(A,N))) ) ) ).

% choose_dvd
tff(fact_3316_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = A4 ) ) ) ).

% even_two_times_div_two
tff(fact_3317_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(set(A),nat,finite_card(A),A3)))
     => ( A3 != bot_bot(set(A)) ) ) ).

% odd_card_imp_not_empty
tff(fact_3318_dvd__partition,axiom,
    ! [A: $tType,C3: set(set(A)),K: nat] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C3)))
     => ( ! [X: set(A)] :
            ( pp(aa(set(set(A)),bool,member(set(A),X),C3))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),aa(set(A),nat,finite_card(A),X))) )
       => ( ! [X: set(A)] :
              ( pp(aa(set(set(A)),bool,member(set(A),X),C3))
             => ! [Xa4: set(A)] :
                  ( pp(aa(set(set(A)),bool,member(set(A),Xa4),C3))
                 => ( ( X != Xa4 )
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),X),Xa4) = bot_bot(set(A)) ) ) ) )
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),K),aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C3)))) ) ) ) ).

% dvd_partition
tff(fact_3319_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: set(B),F2: fun(B,A),B3: A] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_yz(fun(B,A),fun(A,fun(B,A)),F2),B3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,bool),set(B),collect(B),aa(A,fun(B,bool),aTP_Lamp_za(fun(B,A),fun(A,fun(B,bool)),F2),B3))))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,bool),set(B),collect(B),aa(A,fun(B,bool),aTP_Lamp_zb(fun(B,A),fun(A,fun(B,bool)),F2),B3))))),B3)) ) ) ) ).

% sum_div_partition
tff(fact_3320_oddE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A4: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
         => ~ ! [B4: A] : ( A4 != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B4)),one_one(A)) ) ) ) ).

% oddE
tff(fact_3321_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N) = one_one(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% minus_one_power_iff
tff(fact_3322_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M2: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2)),one_one(A))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N))))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N)) ) ) ).

% even_mask_div_iff'
tff(fact_3323_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M2: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2)),one_one(A))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N))))
        <=> ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N) = zero_zero(A) )
            | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N)) ) ) ) ).

% even_mask_div_iff
tff(fact_3324_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A4: A,M2: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N))))
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M2))
            | ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N) = zero_zero(A) )
            | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
              & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2))))) ) ) ) ) ).

% even_mult_exp_div_exp_iff
tff(fact_3325_round__def,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : ( archimedean_round(A,X2) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% round_def
tff(fact_3326_of__int__round__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archimedean_round(A,X2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ).

% of_int_round_le
tff(fact_3327_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(int,A,ring_1_of_int(A),archimedean_round(A,X2)))) ) ).

% of_int_round_ge
tff(fact_3328_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(int,A,ring_1_of_int(A),archimedean_round(A,X2)))) ) ).

% of_int_round_gt
tff(fact_3329_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_round(A,X2))),X2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ).

% of_int_round_abs_le
tff(fact_3330_round__unique_H,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(int,A,ring_1_of_int(A),N)))),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))
         => ( archimedean_round(A,X2) = N ) ) ) ).

% round_unique'
tff(fact_3331_flip__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A] : ( bit_se8732182000553998342ip_bit(A,zero_zero(nat),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(bool,A,zero_neq_one_of_bool(A),aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% flip_bit_0
tff(fact_3332_finite__divisors__nat,axiom,
    ! [M2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M2))
     => pp(aa(set(nat),bool,finite_finite2(nat),aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_zc(nat,fun(nat,bool),M2)))) ) ).

% finite_divisors_nat
tff(fact_3333_round__altdef,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),archimedean_frac(A,X2)))
           => ( archimedean_round(A,X2) = archimedean_ceiling(A,X2) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),archimedean_frac(A,X2)))
           => ( archimedean_round(A,X2) = archim6421214686448440834_floor(A,X2) ) ) ) ) ).

% round_altdef
tff(fact_3334_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M2: num,N: num] : ( unique8689654367752047608divmod(A,aa(num,num,bit0,M2),aa(num,num,bit0,N)) = aa(product_prod(A,A),product_prod(A,A),aa(fun(A,fun(A,product_prod(A,A))),fun(product_prod(A,A),product_prod(A,A)),product_case_prod(A,A,product_prod(A,A)),aTP_Lamp_zd(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,M2,N)) ) ) ).

% divmod_algorithm_code(5)
tff(fact_3335_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),modulo_modulo(A,A4,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N))) ) ) ) ) ).

% even_succ_mod_exp
tff(fact_3336_mod__self,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A4: A] : ( modulo_modulo(A,A4,A4) = zero_zero(A) ) ) ).

% mod_self
tff(fact_3337_mod__by__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A4: A] : ( modulo_modulo(A,A4,zero_zero(A)) = A4 ) ) ).

% mod_by_0
tff(fact_3338_mod__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A4: A] : ( modulo_modulo(A,zero_zero(A),A4) = zero_zero(A) ) ) ).

% mod_0
tff(fact_3339_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A4: A,B3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3),B3) = zero_zero(A) ) ) ).

% mod_mult_self2_is_0
tff(fact_3340_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B3: A,A4: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4),B3) = zero_zero(A) ) ) ).

% mod_mult_self1_is_0
tff(fact_3341_mod__by__1,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A4: A] : ( modulo_modulo(A,A4,one_one(A)) = zero_zero(A) ) ) ).

% mod_by_1
tff(fact_3342_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A4: A] : ( modulo_modulo(A,A4,one_one(A)) = zero_zero(A) ) ) ).

% bits_mod_by_1
tff(fact_3343_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B3: A,C2: A,A4: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)),A4),B3) = modulo_modulo(A,A4,B3) ) ) ).

% mod_mult_self4
tff(fact_3344_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B3: A,A4: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)),A4),B3) = modulo_modulo(A,A4,B3) ) ) ).

% mod_mult_self3
tff(fact_3345_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A4: A,B3: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)),B3) = modulo_modulo(A,A4,B3) ) ) ).

% mod_mult_self2
tff(fact_3346_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A4: A,C2: A,B3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)),B3) = modulo_modulo(A,A4,B3) ) ) ).

% mod_mult_self1
tff(fact_3347_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => ( modulo_modulo(A,B3,A4) = zero_zero(A) ) ) ) ).

% dvd_imp_mod_0
tff(fact_3348_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A4: A] : ( modulo_modulo(A,A4,aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% mod_minus1_right
tff(fact_3349_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% bits_one_mod_two_eq_one
tff(fact_3350_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% one_mod_two_eq_one
tff(fact_3351_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A4: A] :
          ( ( modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != one_one(A) )
        <=> ( modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ) ).

% not_mod_2_eq_1_eq_0
tff(fact_3352_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A4: A] :
          ( ( modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != zero_zero(A) )
        <=> ( modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ) ).

% not_mod_2_eq_0_eq_1
tff(fact_3353_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% bits_minus_1_mod_2_eq
tff(fact_3354_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% minus_1_mod_2_eq
tff(fact_3355_one__div__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),N)) = aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,one2,N)) ) ) ).

% one_div_numeral
tff(fact_3356_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),N)) = aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,one2,N)) ) ) ).

% one_mod_numeral
tff(fact_3357_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( modulo_modulo(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% one_mod_2_pow_eq
tff(fact_3358_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A4: A,B3: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),modulo_modulo(A,B3,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3),C2) ) ) ).

% mod_mult_right_eq
tff(fact_3359_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A4: A,C2: A,B3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A4,C2)),B3),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3),C2) ) ) ).

% mod_mult_left_eq
tff(fact_3360_mult__mod__right,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),modulo_modulo(A,A4,B3)) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) ) ) ).

% mult_mod_right
tff(fact_3361_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A4: A,C2: A,B3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A4,B3)),C2) ) ) ).

% mod_mult_mult2
tff(fact_3362_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A4: A,C2: A,A7: A,B3: A,B6: A] :
          ( ( modulo_modulo(A,A4,C2) = modulo_modulo(A,A7,C2) )
         => ( ( modulo_modulo(A,B3,C2) = modulo_modulo(A,B6,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A7),B6),C2) ) ) ) ) ).

% mod_mult_cong
tff(fact_3363_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A4: A,C2: A,B3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A4,C2)),modulo_modulo(A,B3,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3),C2) ) ) ).

% mod_mult_eq
tff(fact_3364_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),modulo_modulo(A,A4,B3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A4)) ) ) ) ).

% dvd_mod_iff
tff(fact_3365_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),modulo_modulo(A,A4,B3)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A4)) ) ) ) ).

% dvd_mod_imp_dvd
tff(fact_3366_nat__mod__as__int,axiom,
    ! [X4: nat,Xa3: nat] : ( modulo_modulo(nat,X4,Xa3) = aa(int,nat,nat2,modulo_modulo(int,aa(nat,int,semiring_1_of_nat(int),X4),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_mod_as_int
tff(fact_3367_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [F2: fun(B,A),A4: A,A3: set(B)] : ( modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_ze(fun(B,A),fun(A,fun(B,A)),F2),A4)),A3),A4) = modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3),A4) ) ) ).

% mod_sum_eq
tff(fact_3368_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [F2: fun(B,A),A4: A,A3: set(B)] : ( modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(A,fun(B,A),aTP_Lamp_ze(fun(B,A),fun(A,fun(B,A)),F2),A4)),A3),A4) = modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3),A4) ) ) ).

% mod_prod_eq
tff(fact_3369_finite__divisors__int,axiom,
    ! [I2: int] :
      ( ( I2 != zero_zero(int) )
     => pp(aa(set(int),bool,finite_finite2(int),aa(fun(int,bool),set(int),collect(int),aTP_Lamp_zf(int,fun(int,bool),I2)))) ) ).

% finite_divisors_int
tff(fact_3370_mod__eqE,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A4: A,C2: A,B3: A] :
          ( ( modulo_modulo(A,A4,C2) = modulo_modulo(A,B3,C2) )
         => ~ ! [D4: A] : ( B3 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D4)) ) ) ) ).

% mod_eqE
tff(fact_3371_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A4: A,B3: A] :
          ( ( modulo_modulo(A,A4,B3) = zero_zero(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4)) ) ) ).

% mod_eq_0_iff_dvd
tff(fact_3372_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
        <=> ( modulo_modulo(A,B3,A4) = zero_zero(A) ) ) ) ).

% dvd_eq_mod_eq_0
tff(fact_3373_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A4: A,B3: A] :
          ( ( modulo_modulo(A,A4,B3) = zero_zero(A) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4)) ) ) ).

% mod_0_imp_dvd
tff(fact_3374_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [B3: A,A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),modulo_modulo(A,A4,B3)))) ) ).

% dvd_minus_mod
tff(fact_3375_frac__lt__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),archimedean_frac(A,X2)),one_one(A))) ) ).

% frac_lt_1
tff(fact_3376_frac__1__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),one_one(A))) = archimedean_frac(A,X2) ) ) ).

% frac_1_eq
tff(fact_3377_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( modulo_modulo(A,A4,B3) = zero_zero(A) ) ) ) ).

% unit_imp_mod_eq_0
tff(fact_3378_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),C2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),modulo_modulo(A,B3,C2))),C2)) ) ) ).

% div_mult1_eq
tff(fact_3379_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [B3: A,A4: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3))),modulo_modulo(A,A4,B3))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2) ) ) ).

% cancel_div_mod_rules(2)
tff(fact_3380_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),B3)),modulo_modulo(A,A4,B3))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),C2) ) ) ).

% cancel_div_mod_rules(1)
tff(fact_3381_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A4: A,B3: A] : ( A4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),B3)),modulo_modulo(A,A4,B3)) ) ) ).

% mod_div_decomp
tff(fact_3382_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),B3)),modulo_modulo(A,A4,B3)) = A4 ) ) ).

% div_mult_mod_eq
tff(fact_3383_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A4,B3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),B3)) = A4 ) ) ).

% mod_div_mult_eq
tff(fact_3384_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A4,B3)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3))) = A4 ) ) ).

% mod_mult_div_eq
tff(fact_3385_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [B3: A,A4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3))),modulo_modulo(A,A4,B3)) = A4 ) ) ).

% mult_div_mod_eq
tff(fact_3386_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),B3)) = modulo_modulo(A,A4,B3) ) ) ).

% minus_div_mult_eq_mod
tff(fact_3387_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),modulo_modulo(A,A4,B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),B3) ) ) ).

% minus_mod_eq_div_mult
tff(fact_3388_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),modulo_modulo(A,A4,B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)) ) ) ).

% minus_mod_eq_mult_div
tff(fact_3389_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3))) = modulo_modulo(A,A4,B3) ) ) ).

% minus_mult_div_eq_mod
tff(fact_3390_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A4: A,M2: nat,N: nat] : ( modulo_modulo(A,A4,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M2)),aa(nat,A,semiring_1_of_nat(A),N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M2)),modulo_modulo(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(nat,A,semiring_1_of_nat(A),M2)),aa(nat,A,semiring_1_of_nat(A),N)))),modulo_modulo(A,A4,aa(nat,A,semiring_1_of_nat(A),M2))) ) ) ).

% mod_mult2_eq'
tff(fact_3391_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A4: A] : ( bit_se8732182000553998342ip_bit(A,aa(nat,nat,suc,N),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se8732182000553998342ip_bit(A,N,aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% flip_bit_Suc
tff(fact_3392_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
         => ( modulo_modulo(A,A4,aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),modulo_modulo(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3),C2))),modulo_modulo(A,A4,B3)) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
tff(fact_3393_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A4: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
        <=> ( modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ) ).

% odd_iff_mod_2_eq_one
tff(fact_3394_frac__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( ( archimedean_frac(A,X2) = X2 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),one_one(A))) ) ) ) ).

% frac_eq
tff(fact_3395_frac__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X2)),archimedean_frac(A,Y))),one_one(A)))
           => ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X2)),archimedean_frac(A,Y)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X2)),archimedean_frac(A,Y))),one_one(A)))
           => ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X2)),archimedean_frac(A,Y))),one_one(A)) ) ) ) ) ).

% frac_add
tff(fact_3396_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),modulo_modulo(A,A4,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3))),B3))
           => ( modulo_modulo(A,A4,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3)) = modulo_modulo(A,A4,B3) ) ) ) ) ).

% divmod_digit_0(2)
tff(fact_3397_parity__cases,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
           => ( modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != zero_zero(A) ) )
         => ~ ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
             => ( modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != one_one(A) ) ) ) ) ).

% parity_cases
tff(fact_3398_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A4: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
           => ( modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
           => ( modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ) ) ).

% mod2_eq_if
tff(fact_3399_range__mod,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(set(nat),set(nat),image2(nat,nat,aTP_Lamp_zg(nat,fun(nat,nat),N)),top_top(set(nat))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),N) ) ) ).

% range_mod
tff(fact_3400_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),modulo_modulo(A,A4,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3))),B3))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) ) ) ) ) ).

% divmod_digit_0(1)
tff(fact_3401_frac__neg,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( ( pp(aa(set(A),bool,member(A,X2),ring_1_Ints(A)))
           => ( archimedean_frac(A,aa(A,A,uminus_uminus(A),X2)) = zero_zero(A) ) )
          & ( ~ pp(aa(set(A),bool,member(A,X2),ring_1_Ints(A)))
           => ( archimedean_frac(A,aa(A,A,uminus_uminus(A),X2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),archimedean_frac(A,X2)) ) ) ) ) ).

% frac_neg
tff(fact_3402_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M2: nat,N: nat,A4: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A4,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2)) ) ) ) ).

% mult_exp_mod_exp_eq
tff(fact_3403_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M2: nat,N: nat] : ( modulo_modulo(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M2),N))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2)) ) ) ).

% exp_mod_exp
tff(fact_3404_division__decomp,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)))
         => ? [B11: A,C7: A] :
              ( ( A4 = aa(A,A,aa(A,fun(A,A),times_times(A),B11),C7) )
              & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B11),B3))
              & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C7),C2)) ) ) ) ).

% division_decomp
tff(fact_3405_dvd__productE,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [P5: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),P5),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))
         => ~ ! [X: A,Y2: A] :
                ( ( P5 = aa(A,A,aa(A,fun(A,A),times_times(A),X),Y2) )
               => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X),A4))
                 => ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Y2),B3)) ) ) ) ) ).

% dvd_productE
tff(fact_3406_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M2: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),M2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X2))
           => ( ( modulo_modulo(A,X2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2)) = modulo_modulo(A,X2,M2) )
              | ( modulo_modulo(A,X2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,X2,M2)),M2) ) ) ) ) ) ).

% mod_double_modulus
tff(fact_3407_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),modulo_modulo(A,A4,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3))))
             => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A4,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3))),B3) = modulo_modulo(A,A4,B3) ) ) ) ) ) ).

% divmod_digit_1(2)
tff(fact_3408_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,A4: A] :
          ( ( archimedean_frac(A,X2) = A4 )
        <=> ( pp(aa(set(A),bool,member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),A4)),ring_1_Ints(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),one_one(A))) ) ) ) ).

% frac_unique_iff
tff(fact_3409_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A4: A] : ( bit_se2638667681897837118et_bit(A,aa(nat,nat,suc,N),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2638667681897837118et_bit(A,N,aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% unset_bit_Suc
tff(fact_3410_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A4: A] : ( bit_se5668285175392031749et_bit(A,aa(nat,nat,suc,N),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se5668285175392031749et_bit(A,N,aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% set_bit_Suc
tff(fact_3411_floor__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X2)),archimedean_frac(A,Y))),one_one(A)))
           => ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X2)),archim6421214686448440834_floor(A,Y)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X2)),archimedean_frac(A,Y))),one_one(A)))
           => ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X2)),archim6421214686448440834_floor(A,Y))),one_one(int)) ) ) ) ) ).

% floor_add
tff(fact_3412_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),modulo_modulo(A,A4,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3))))
             => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3)))),one_one(A)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) ) ) ) ) ) ).

% divmod_digit_1(1)
tff(fact_3413_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A4: A] :
          ( ( ( N = zero_zero(nat) )
           => ( bit_ri4674362597316999326ke_bit(A,N,A4) = aa(A,A,uminus_uminus(A),modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) )
          & ( ( N != zero_zero(nat) )
           => ( bit_ri4674362597316999326ke_bit(A,N,A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_ri4674362597316999326ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ) ) ).

% signed_take_bit_rec
tff(fact_3414_integer__of__int__code,axiom,
    ! [K: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
       => ( aa(int,code_integer,code_integer_of_int,K) = aa(code_integer,code_integer,uminus_uminus(code_integer),aa(int,code_integer,code_integer_of_int,aa(int,int,uminus_uminus(int),K))) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),K),zero_zero(int)))
       => ( ( ( K = zero_zero(int) )
           => ( aa(int,code_integer,code_integer_of_int,K) = zero_zero(code_integer) ) )
          & ( ( K != zero_zero(int) )
           => ( aa(int,code_integer,code_integer_of_int,K) = if(code_integer,aa(int,bool,aa(int,fun(int,bool),fequal(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),zero_zero(int)),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),aa(int,code_integer,code_integer_of_int,aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),aa(int,code_integer,code_integer_of_int,aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))),one_one(code_integer))) ) ) ) ) ) ).

% integer_of_int_code
tff(fact_3415_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M2: num,N: num] : ( unique8689654367752047608divmod(A,aa(num,num,bit1,M2),aa(num,num,bit0,N)) = aa(product_prod(A,A),product_prod(A,A),aa(fun(A,fun(A,product_prod(A,A))),fun(product_prod(A,A),product_prod(A,A)),product_case_prod(A,A,product_prod(A,A)),aTP_Lamp_zh(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,M2,N)) ) ) ).

% divmod_algorithm_code(6)
tff(fact_3416_and__int_Osimps,axiom,
    ! [K: int,L: int] :
      ( ( ( pp(aa(set(int),bool,member(int,K),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
          & pp(aa(set(int),bool,member(int,L),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
       => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))))) ) )
      & ( ~ ( pp(aa(set(int),bool,member(int,K),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
            & pp(aa(set(int),bool,member(int,L),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
       => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ).

% and_int.simps
tff(fact_3417_and__int_Oelims,axiom,
    ! [X2: int,Xa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Xa) = Y )
     => ( ( ( pp(aa(set(int),bool,member(int,X2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
            & pp(aa(set(int),bool,member(int,Xa),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( Y = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))))) ) )
        & ( ~ ( pp(aa(set(int),bool,member(int,X2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
              & pp(aa(set(int),bool,member(int,Xa),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( Y = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ) ).

% and_int.elims
tff(fact_3418_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),aa(A,A,uminus_uminus(A),one_one(A))) = X2 ) ) ).

% bit.conj_one_right
tff(fact_3419_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A4),aa(A,A,uminus_uminus(A),one_one(A))) = A4 ) ) ).

% and.right_neutral
tff(fact_3420_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))),A4) = A4 ) ) ).

% and.left_neutral
tff(fact_3421_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( bit_ri4674362597316999326ke_bit(A,N,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% signed_take_bit_of_minus_1
tff(fact_3422_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,N),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_Suc_1
tff(fact_3423_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( bit_ri4674362597316999326ke_bit(A,aa(num,nat,numeral_numeral(nat),K),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_numeral_of_1
tff(fact_3424_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = one_one(A) ) ) ).

% and_numerals(2)
tff(fact_3425_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),one_one(A)) = one_one(A) ) ) ).

% and_numerals(8)
tff(fact_3426_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),one_one(A)) = zero_zero(A) ) ) ).

% and_numerals(5)
tff(fact_3427_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = zero_zero(A) ) ) ).

% and_numerals(1)
tff(fact_3428_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(3)
tff(fact_3429_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2)) ) ) ).

% dbl_inc_simps(3)
tff(fact_3430_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(4)
tff(fact_3431_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(6)
tff(fact_3432_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2))) ) ) ).

% dbl_dec_simps(4)
tff(fact_3433_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% and_numerals(7)
tff(fact_3434_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A4),B3) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( A4 = aa(A,A,uminus_uminus(A),one_one(A)) )
            & ( B3 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% and_eq_minus_1_iff
tff(fact_3435_and_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => comm_monoid(A,bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% and.comm_monoid_axioms
tff(fact_3436_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),aa(num,num,bit1,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),aa(num,A,numeral_numeral(A),N))),one_one(A)) ) ) ).

% numeral_Bit1
tff(fact_3437_and_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => monoid(A,bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% and.monoid_axioms
tff(fact_3438_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),aa(num,num,bit1,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),aa(num,A,numeral_numeral(A),N))),one_one(A)) ) ) ).

% numeral_code(3)
tff(fact_3439_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z2: A,W2: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,W2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),W2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),W2))) ) ) ).

% power_numeral_odd
tff(fact_3440_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A4: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),A4)),A4) ) ) ).

% power3_eq_cube
tff(fact_3441_and__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A4),one_one(A)) = modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% and_one_eq
tff(fact_3442_one__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),A4) = modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% one_and_eq
tff(fact_3443_card__3__iff,axiom,
    ! [A: $tType,S: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),S) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) )
    <=> ? [X3: A,Y4: A,Z5: A] :
          ( ( S = aa(set(A),set(A),insert(A,X3),aa(set(A),set(A),insert(A,Y4),aa(set(A),set(A),insert(A,Z5),bot_bot(set(A))))) )
          & ( X3 != Y4 )
          & ( Y4 != Z5 )
          & ( X3 != Z5 ) ) ) ).

% card_3_iff
tff(fact_3444_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A4: A] : ( bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,N),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_ri4674362597316999326ke_bit(A,N,aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% signed_take_bit_Suc
tff(fact_3445_and__int_Opelims,axiom,
    ! [X2: int,Xa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Xa) = Y )
     => ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X2),Xa)))
       => ~ ( ( ( ( pp(aa(set(int),bool,member(int,X2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
                  & pp(aa(set(int),bool,member(int,Xa),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
               => ( Y = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))))) ) )
              & ( ~ ( pp(aa(set(int),bool,member(int,X2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
                    & pp(aa(set(int),bool,member(int,Xa),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
               => ( Y = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) )
           => ~ pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X2),Xa))) ) ) ) ).

% and_int.pelims
tff(fact_3446_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),K),L)))
     => ( ( ( pp(aa(set(int),bool,member(int,K),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
            & pp(aa(set(int),bool,member(int,L),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))))) ) )
        & ( ~ ( pp(aa(set(int),bool,member(int,K),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
              & pp(aa(set(int),bool,member(int,L),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ) ).

% and_int.psimps
tff(fact_3447_take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A4: A] :
          ( ( ( N = zero_zero(nat) )
           => ( bit_se2584673776208193580ke_bit(A,N,A4) = zero_zero(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( bit_se2584673776208193580ke_bit(A,N,A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ) ) ).

% take_bit_rec
tff(fact_3448_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: num] : ( bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),N),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),N))) ) ) ).

% push_bit_numeral_minus_1
tff(fact_3449_num__of__integer__code,axiom,
    ! [K: code_integer] :
      ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),K),one_one(code_integer)))
       => ( code_num_of_integer(K) = one2 ) )
      & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),K),one_one(code_integer)))
       => ( code_num_of_integer(K) = aa(product_prod(code_integer,code_integer),num,aa(fun(code_integer,fun(code_integer,num)),fun(product_prod(code_integer,code_integer),num),product_case_prod(code_integer,code_integer,num),aTP_Lamp_zi(code_integer,fun(code_integer,num))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))) ) ) ) ).

% num_of_integer_code
tff(fact_3450_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),one_one(A)) = one_one(A) ) ) ).

% take_bit_Suc_1
tff(fact_3451_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num] : ( bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L),one_one(A)) = one_one(A) ) ) ).

% take_bit_numeral_1
tff(fact_3452_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit(A,N,one_one(A)) = zero_zero(A) )
        <=> ( N = zero_zero(nat) ) ) ) ).

% take_bit_of_1_eq_0_iff
tff(fact_3453_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(A,N,one_one(A)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% take_bit_of_1
tff(fact_3454_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A4: A] : ( bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N),A4) = bit_se4730199178511100633sh_bit(A,N,aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% push_bit_Suc
tff(fact_3455_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se4730199178511100633sh_bit(A,N,one_one(A)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N) ) ) ).

% push_bit_of_1
tff(fact_3456_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M2: nat,N: nat] : ( bit_se2584673776208193580ke_bit(A,M2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M2))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) ) ) ).

% take_bit_of_exp
tff(fact_3457_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(A,N,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_of_2
tff(fact_3458_push__bit__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A4: A] : ( bit_se4730199178511100633sh_bit(A,N,aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),bit_se4730199178511100633sh_bit(A,N,A4)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% push_bit_double
tff(fact_3459_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,N,aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_Suc_bit0
tff(fact_3460_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A4: A] : ( bit_se4730199178511100633sh_bit(A,N,A4) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) ) ) ).

% push_bit_eq_mult
tff(fact_3461_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,N,aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% take_bit_Suc_bit1
tff(fact_3462_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,suc,N))),one_one(A)) ) ) ).

% take_bit_Suc_minus_1_eq
tff(fact_3463_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A4: A] : ( bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,N,aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),modulo_modulo(A,A4,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% take_bit_Suc
tff(fact_3464_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),K),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),K))),one_one(A)) ) ) ).

% take_bit_numeral_minus_1_eq
tff(fact_3465_and__int_Opinduct,axiom,
    ! [A0: int,A13: int,P: fun(int,fun(int,bool))] :
      ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A0),A13)))
     => ( ! [K2: int,L3: int] :
            ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),K2),L3)))
           => ( ( ~ ( pp(aa(set(int),bool,member(int,K2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
                    & pp(aa(set(int),bool,member(int,L3),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
               => pp(aa(int,bool,aa(int,fun(int,bool),P,aa(int,int,aa(int,fun(int,int),divide_divide(int),K2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L3),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))) )
             => pp(aa(int,bool,aa(int,fun(int,bool),P,K2),L3)) ) )
       => pp(aa(int,bool,aa(int,fun(int,bool),P,A0),A13)) ) ) ).

% and_int.pinduct
tff(fact_3466_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A4 )
         => ( ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
             => ( bit_se2584673776208193580ke_bit(A,N,A4) = zero_zero(A) ) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
             => ( bit_se2584673776208193580ke_bit(A,N,A4) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)),one_one(A)) ) ) ) ) ) ).

% stable_imp_take_bit_eq
tff(fact_3467_nat__of__integer__code,axiom,
    ! [K: code_integer] :
      ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),K),zero_zero(code_integer)))
       => ( code_nat_of_integer(K) = zero_zero(nat) ) )
      & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),K),zero_zero(code_integer)))
       => ( code_nat_of_integer(K) = aa(product_prod(code_integer,code_integer),nat,aa(fun(code_integer,fun(code_integer,nat)),fun(product_prod(code_integer,code_integer),nat),product_case_prod(code_integer,code_integer,nat),aTP_Lamp_zj(code_integer,fun(code_integer,nat))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))) ) ) ) ).

% nat_of_integer_code
tff(fact_3468_divmod__integer__code,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( ( K = zero_zero(code_integer) )
       => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ) )
      & ( ( K != zero_zero(code_integer) )
       => ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),L))
           => ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),K))
               => ( code_divmod_integer(K,L) = code_divmod_abs(K,L) ) )
              & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),K))
               => ( code_divmod_integer(K,L) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zk(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)) ) ) ) )
          & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),L))
           => ( ( ( L = zero_zero(code_integer) )
               => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),K) ) )
              & ( ( L != zero_zero(code_integer) )
               => ( code_divmod_integer(K,L) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_apsnd(code_integer,code_integer,code_integer),uminus_uminus(code_integer)),if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),zero_zero(code_integer)),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zl(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ) ) ) ) ).

% divmod_integer_code
tff(fact_3469_int__of__integer__code,axiom,
    ! [K: code_integer] :
      ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),zero_zero(code_integer)))
       => ( aa(code_integer,int,code_int_of_integer,K) = aa(int,int,uminus_uminus(int),aa(code_integer,int,code_int_of_integer,aa(code_integer,code_integer,uminus_uminus(code_integer),K))) ) )
      & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),zero_zero(code_integer)))
       => ( ( ( K = zero_zero(code_integer) )
           => ( aa(code_integer,int,code_int_of_integer,K) = zero_zero(int) ) )
          & ( ( K != zero_zero(code_integer) )
           => ( aa(code_integer,int,code_int_of_integer,K) = aa(product_prod(code_integer,code_integer),int,aa(fun(code_integer,fun(code_integer,int)),fun(product_prod(code_integer,code_integer),int),product_case_prod(code_integer,code_integer,int),aTP_Lamp_zm(code_integer,fun(code_integer,int))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))) ) ) ) ) ) ).

% int_of_integer_code
tff(fact_3470_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,pred_numeral(L),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% take_bit_numeral_bit1
tff(fact_3471_Divides_Oadjust__div__def,axiom,
    ! [Qr: product_prod(int,int)] : ( adjust_div(Qr) = aa(product_prod(int,int),int,aa(fun(int,fun(int,int)),fun(product_prod(int,int),int),product_case_prod(int,int,int),aTP_Lamp_zn(int,fun(int,int))),Qr) ) ).

% Divides.adjust_div_def
tff(fact_3472_fact__numeral,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: num] : ( semiring_char_0_fact(A,aa(num,nat,numeral_numeral(nat),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),semiring_char_0_fact(A,pred_numeral(K))) ) ) ).

% fact_numeral
tff(fact_3473_atLeastLessThan__nat__numeral,axiom,
    ! [M2: nat,K: num] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),pred_numeral(K)))
       => ( set_or7035219750837199246ssThan(nat,M2,aa(num,nat,numeral_numeral(nat),K)) = aa(set(nat),set(nat),insert(nat,pred_numeral(K)),set_or7035219750837199246ssThan(nat,M2,pred_numeral(K))) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),pred_numeral(K)))
       => ( set_or7035219750837199246ssThan(nat,M2,aa(num,nat,numeral_numeral(nat),K)) = bot_bot(set(nat)) ) ) ) ).

% atLeastLessThan_nat_numeral
tff(fact_3474_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,pred_numeral(L),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_numeral_bit0
tff(fact_3475_bit__cut__integer__code,axiom,
    ! [K: code_integer] :
      ( ( ( K = zero_zero(code_integer) )
       => ( code_bit_cut_integer(K) = aa(bool,product_prod(code_integer,bool),aa(code_integer,fun(bool,product_prod(code_integer,bool)),product_Pair(code_integer,bool),zero_zero(code_integer)),fFalse) ) )
      & ( ( K != zero_zero(code_integer) )
       => ( code_bit_cut_integer(K) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,bool),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,bool))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,bool)),product_case_prod(code_integer,code_integer,product_prod(code_integer,bool)),aTP_Lamp_zo(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,bool))),K)),code_divmod_abs(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))) ) ) ) ).

% bit_cut_integer_code
tff(fact_3476_divmod__integer__eq__cases,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( ( K = zero_zero(code_integer) )
       => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ) )
      & ( ( K != zero_zero(code_integer) )
       => ( ( ( L = zero_zero(code_integer) )
           => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),K) ) )
          & ( ( L != zero_zero(code_integer) )
           => ( code_divmod_integer(K,L) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),aa(fun(code_integer,code_integer),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,aa(fun(code_integer,fun(code_integer,code_integer)),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,product_apsnd(code_integer,code_integer,code_integer)),times_times(code_integer))),sgn_sgn(code_integer)),L),if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),aa(code_integer,code_integer,sgn_sgn(code_integer),K)),aa(code_integer,code_integer,sgn_sgn(code_integer),L)),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zp(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ) ) ).

% divmod_integer_eq_cases
tff(fact_3477_mask__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: num] : ( bit_se2239418461657761734s_mask(A,aa(num,nat,numeral_numeral(nat),N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(A,pred_numeral(N)))) ) ) ).

% mask_numeral
tff(fact_3478_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% xor_numerals(6)
tff(fact_3479_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% xor_numerals(4)
tff(fact_3480_sgn__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,sgn_sgn(A),A4)) = aa(A,A,sgn_sgn(A),A4) ) ) ).

% sgn_sgn
tff(fact_3481_sgn__0,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),zero_zero(A)) = zero_zero(A) ) ) ).

% sgn_0
tff(fact_3482_sgn__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),one_one(A)) = one_one(A) ) ) ).

% sgn_1
tff(fact_3483_sgn__minus,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,uminus_uminus(A),A4)) = aa(A,A,uminus_uminus(A),aa(A,A,sgn_sgn(A),A4)) ) ) ).

% sgn_minus
tff(fact_3484_sgn__less,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,sgn_sgn(A),A4)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A))) ) ) ).

% sgn_less
tff(fact_3485_sgn__greater,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,sgn_sgn(A),A4)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4)) ) ) ).

% sgn_greater
tff(fact_3486_divide__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,sgn_sgn(A),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,sgn_sgn(A),B3)) ) ) ).

% divide_sgn
tff(fact_3487_sgn__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( aa(A,A,sgn_sgn(A),A4) = one_one(A) ) ) ) ).

% sgn_pos
tff(fact_3488_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] :
          ( ( A4 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A4)) = one_one(A) ) ) ) ).

% abs_sgn_eq_1
tff(fact_3489_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% mask_Suc_0
tff(fact_3490_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A4)),aa(A,A,sgn_sgn(A),A4)) = aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),fequal(A),A4),zero_zero(A)))) ) ) ).

% sgn_mult_self_eq
tff(fact_3491_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(A,N,aa(A,A,uminus_uminus(A),one_one(A))) = bit_se2239418461657761734s_mask(A,N) ) ) ).

% take_bit_minus_one_eq_mask
tff(fact_3492_sgn__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A] : ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A4)) = aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),fequal(A),A4),zero_zero(A)))) ) ) ).

% sgn_abs
tff(fact_3493_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,abs_abs(A),A4)) = aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),fequal(A),A4),zero_zero(A)))) ) ) ).

% idom_abs_sgn_class.abs_sgn
tff(fact_3494_sgn__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A)))
         => ( aa(A,A,sgn_sgn(A),A4) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% sgn_neg
tff(fact_3495_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% xor_numerals(3)
tff(fact_3496_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% xor_numerals(1)
tff(fact_3497_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y)) ) ) ).

% xor_numerals(2)
tff(fact_3498_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2)) ) ) ).

% xor_numerals(5)
tff(fact_3499_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2)) ) ) ).

% xor_numerals(8)
tff(fact_3500_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% xor_numerals(7)
tff(fact_3501_sgn__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A,B3: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A4)),aa(A,A,sgn_sgn(A),B3)) ) ) ).

% sgn_mult
tff(fact_3502_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B3: A,A4: A] :
          ( ( aa(A,A,sgn_sgn(A),B3) = aa(A,A,sgn_sgn(A),A4) )
         => ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)) = aa(A,A,sgn_sgn(A),A4) ) ) ) ).

% same_sgn_sgn_add
tff(fact_3503_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A] :
          ( ( aa(A,A,sgn_sgn(A),A4) = zero_zero(A) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% sgn_eq_0_iff
tff(fact_3504_sgn__0__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] :
          ( ( aa(A,A,sgn_sgn(A),A4) = zero_zero(A) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% sgn_0_0
tff(fact_3505_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B3: A,A4: A] :
          ( ( aa(A,A,sgn_sgn(A),B3) != aa(A,A,sgn_sgn(A),A4) )
         => ( ( aa(A,A,sgn_sgn(A),A4) != zero_zero(A) )
           => ( ( aa(A,A,sgn_sgn(A),B3) != zero_zero(A) )
             => ( aa(A,A,sgn_sgn(A),A4) = aa(A,A,uminus_uminus(A),aa(A,A,sgn_sgn(A),B3)) ) ) ) ) ) ).

% sgn_not_eq_imp
tff(fact_3506_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% sgn_minus_1
tff(fact_3507_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B3: A,A4: A] :
          ( ( aa(A,A,sgn_sgn(A),B3) = aa(A,A,sgn_sgn(A),A4) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A4)),aa(A,A,abs_abs(A),B3)) ) ) ) ).

% same_sgn_abs_add
tff(fact_3508_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [K: A] : ( aa(A,A,abs_abs(A),K) = aa(A,A,aa(A,fun(A,A),times_times(A),K),aa(A,A,sgn_sgn(A),K)) ) ) ).

% linordered_idom_class.abs_sgn
tff(fact_3509_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A4)),aa(A,A,sgn_sgn(A),A4)) = A4 ) ) ).

% abs_mult_sgn
tff(fact_3510_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A4)),aa(A,A,abs_abs(A),A4)) = A4 ) ) ).

% sgn_mult_abs
tff(fact_3511_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),X2)),aa(A,A,abs_abs(A),X2)) = X2 ) ) ).

% mult_sgn_abs
tff(fact_3512_xor_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => comm_monoid(A,bit_se5824344971392196577ns_xor(A),zero_zero(A)) ) ).

% xor.comm_monoid_axioms
tff(fact_3513_xor_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => monoid(A,bit_se5824344971392196577ns_xor(A),zero_zero(A)) ) ).

% xor.monoid_axioms
tff(fact_3514_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] :
          ( ( aa(A,A,sgn_sgn(A),A4) = one_one(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4)) ) ) ).

% sgn_1_pos
tff(fact_3515_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] :
          ( ( ( A4 = zero_zero(A) )
           => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A4)) = zero_zero(A) ) )
          & ( ( A4 != zero_zero(A) )
           => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A4)) = one_one(A) ) ) ) ) ).

% abs_sgn_eq
tff(fact_3516_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A4: A] : ( bit_se8732182000553998342ip_bit(A,N,A4) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A4),bit_se4730199178511100633sh_bit(A,N,one_one(A))) ) ) ).

% flip_bit_eq_xor
tff(fact_3517_sgn__if,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( ( ( X2 = zero_zero(A) )
           => ( aa(A,A,sgn_sgn(A),X2) = zero_zero(A) ) )
          & ( ( X2 != zero_zero(A) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X2))
               => ( aa(A,A,sgn_sgn(A),X2) = one_one(A) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X2))
               => ( aa(A,A,sgn_sgn(A),X2) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ) ) ).

% sgn_if
tff(fact_3518_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A4: A] :
          ( ( aa(A,A,sgn_sgn(A),A4) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),zero_zero(A))) ) ) ).

% sgn_1_neg
tff(fact_3519_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(A,N) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)),one_one(A)) ) ) ).

% mask_eq_exp_minus_1
tff(fact_3520_one__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),A4) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(bool,A,zero_neq_one_of_bool(A),aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4)))),aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4)))) ) ) ).

% one_xor_eq
tff(fact_3521_xor__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A4),one_one(A)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(bool,A,zero_neq_one_of_bool(A),aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4)))),aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4)))) ) ) ).

% xor_one_eq
tff(fact_3522_integer__of__num_I3_J,axiom,
    ! [N: num] : ( code_integer_of_num(aa(num,num,bit1,N)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),code_integer_of_num(N)),code_integer_of_num(N))),one_one(code_integer)) ) ).

% integer_of_num(3)
tff(fact_3523_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A4: A,F2: fun(nat,fun(A,A)),V: num,N: nat] : ( aa(nat,A,rec_nat(A,A4,F2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),N)) = aa(A,A,aa(nat,fun(A,A),F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pred_numeral(V)),N)),aa(nat,A,rec_nat(A,A4,F2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pred_numeral(V)),N))) ) ).

% rec_nat_add_eq_if
tff(fact_3524_case__nat__add__eq__if,axiom,
    ! [A: $tType,A4: A,F2: fun(nat,A),V: num,N: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),case_nat(A),A4),F2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),N)) = aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pred_numeral(V)),N)) ) ).

% case_nat_add_eq_if
tff(fact_3525_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(4)
tff(fact_3526_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(6)
tff(fact_3527_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_right
tff(fact_3528_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,uminus_uminus(A),one_one(A))),X2) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_left
tff(fact_3529_case__nat__numeral,axiom,
    ! [A: $tType,A4: A,F2: fun(nat,A),V: num] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),case_nat(A),A4),F2),aa(num,nat,numeral_numeral(nat),V)) = aa(nat,A,F2,pred_numeral(V)) ) ).

% case_nat_numeral
tff(fact_3530_rec__nat__numeral,axiom,
    ! [A: $tType,A4: A,F2: fun(nat,fun(A,A)),V: num] : ( aa(nat,A,rec_nat(A,A4,F2),aa(num,nat,numeral_numeral(nat),V)) = aa(A,A,aa(nat,fun(A,A),F2,pred_numeral(V)),aa(nat,A,rec_nat(A,A4,F2),pred_numeral(V))) ) ).

% rec_nat_numeral
tff(fact_3531_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(2)
tff(fact_3532_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2)) ) ) ).

% or_numerals(8)
tff(fact_3533_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% or_numerals(3)
tff(fact_3534_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2)) ) ) ).

% or_numerals(5)
tff(fact_3535_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(1)
tff(fact_3536_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(7)
tff(fact_3537_nat_Ocase__distrib,axiom,
    ! [A: $tType,B: $tType,H2: fun(A,B),F1: A,F22: fun(nat,A),Nat: nat] : ( aa(A,B,H2,aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),case_nat(A),F1),F22),Nat)) = aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(B,fun(fun(nat,B),fun(nat,B)),case_nat(B),aa(A,B,H2,F1)),aa(fun(nat,A),fun(nat,B),aTP_Lamp_zq(fun(A,B),fun(fun(nat,A),fun(nat,B)),H2),F22)),Nat) ) ).

% nat.case_distrib
tff(fact_3538_or_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => comm_monoid(A,bit_se1065995026697491101ons_or(A),zero_zero(A)) ) ).

% or.comm_monoid_axioms
tff(fact_3539_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat = zero_zero(nat) )
    <=> pp(aa(nat,bool,aa(fun(nat,bool),fun(nat,bool),aa(bool,fun(fun(nat,bool),fun(nat,bool)),case_nat(bool),fTrue),aTP_Lamp_xr(nat,bool)),Nat)) ) ).

% nat.disc_eq_case(1)
tff(fact_3540_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( Nat != zero_zero(nat) )
    <=> pp(aa(nat,bool,aa(fun(nat,bool),fun(nat,bool),aa(bool,fun(fun(nat,bool),fun(nat,bool)),case_nat(bool),fFalse),aTP_Lamp_zr(nat,bool)),Nat)) ) ).

% nat.disc_eq_case(2)
tff(fact_3541_or_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => monoid(A,bit_se1065995026697491101ons_or(A),zero_zero(A)) ) ).

% or.monoid_axioms
tff(fact_3542_rec__nat__0__imp,axiom,
    ! [A: $tType,F2: fun(nat,A),F1: A,F22: fun(nat,fun(A,A))] :
      ( ( F2 = rec_nat(A,F1,F22) )
     => ( aa(nat,A,F2,zero_zero(nat)) = F1 ) ) ).

% rec_nat_0_imp
tff(fact_3543_rec__nat__Suc__imp,axiom,
    ! [A: $tType,F2: fun(nat,A),F1: A,F22: fun(nat,fun(A,A)),N: nat] :
      ( ( F2 = rec_nat(A,F1,F22) )
     => ( aa(nat,A,F2,aa(nat,nat,suc,N)) = aa(A,A,aa(nat,fun(A,A),F22,N),aa(nat,A,F2,N)) ) ) ).

% rec_nat_Suc_imp
tff(fact_3544_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A4: A] : ( bit_se5668285175392031749et_bit(A,N,A4) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A4),bit_se4730199178511100633sh_bit(A,N,one_one(A))) ) ) ).

% set_bit_eq_or
tff(fact_3545_less__eq__nat_Osimps_I2_J,axiom,
    ! [M2: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,M2)),N))
    <=> pp(aa(nat,bool,aa(fun(nat,bool),fun(nat,bool),aa(bool,fun(fun(nat,bool),fun(nat,bool)),case_nat(bool),fFalse),aa(nat,fun(nat,bool),ord_less_eq(nat),M2)),N)) ) ).

% less_eq_nat.simps(2)
tff(fact_3546_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A4: A,X2: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A4),X2) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A4),X2) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A4),Y) = zero_zero(A) )
             => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A4),Y) = aa(A,A,uminus_uminus(A),one_one(A)) )
               => ( X2 = Y ) ) ) ) ) ) ).

% bit.complement_unique
tff(fact_3547_diff__Suc,axiom,
    ! [M2: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),aa(nat,nat,suc,N)) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),zero_zero(nat)),aTP_Lamp_vy(nat,nat)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),N)) ) ).

% diff_Suc
tff(fact_3548_integer__of__num_I2_J,axiom,
    ! [N: num] : ( code_integer_of_num(aa(num,num,bit0,N)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),code_integer_of_num(N)),code_integer_of_num(N)) ) ).

% integer_of_num(2)
tff(fact_3549_one__or__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(bool,A,zero_neq_one_of_bool(A),aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))) ) ) ).

% one_or_eq
tff(fact_3550_or__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A4),one_one(A)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(bool,A,zero_neq_one_of_bool(A),aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))) ) ) ).

% or_one_eq
tff(fact_3551_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(A,N))) ) ) ).

% mask_Suc_double
tff(fact_3552_old_Orec__nat__def,axiom,
    ! [T: $tType,X4: T,Xa3: fun(nat,fun(T,T)),Xb3: nat] : ( aa(nat,T,rec_nat(T,X4,Xa3),Xb3) = the(T,rec_set_nat(T,X4,Xa3,Xb3)) ) ).

% old.rec_nat_def
tff(fact_3553_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A,B3: A,N: nat] :
          ( ! [J4: nat] : ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A4),aa(nat,nat,suc,J4)))
         => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3))),N))
          <=> ( ( ( N = zero_zero(nat) )
               => ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4)) )
              & ( ( N != zero_zero(nat) )
               => pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3)),N)) ) ) ) ) ) ).

% bit_sum_mult_2_cases
tff(fact_3554_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A4: A] : ( bit_ri4674362597316999326ke_bit(A,N,A4) = if(A,aa(nat,bool,bit_se5641148757651400278ts_bit(A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),A4)),N),aa(A,A,aa(A,fun(A,A),plus_plus(A),bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),A4)),bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N),aa(A,A,uminus_uminus(A),one_one(A)))),bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),A4)) ) ) ).

% signed_take_bit_code
tff(fact_3555_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M2: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),neg_numeral_sub(A,M2,one2))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2)) ) ) ).

% minus_sub_one_diff_one
tff(fact_3556_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = neg_numeral_sub(A,N,one2) ) ) ).

% diff_numeral_special(7)
tff(fact_3557_bit__0__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( bit_se5641148757651400278ts_bit(A,zero_zero(A)) = bot_bot(fun(nat,bool)) ) ) ).

% bit_0_eq
tff(fact_3558_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,one2,N) ) ) ).

% diff_numeral_special(1)
tff(fact_3559_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M2: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M2)),one_one(A)) = neg_numeral_sub(A,M2,one2) ) ) ).

% diff_numeral_special(2)
tff(fact_3560_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,N,one2) ) ) ).

% add_neg_numeral_special(4)
tff(fact_3561_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M2: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M2)),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,M2,one2) ) ) ).

% add_neg_numeral_special(3)
tff(fact_3562_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M2: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))),one_one(A)) = neg_numeral_sub(A,one2,M2) ) ) ).

% add_neg_numeral_special(2)
tff(fact_3563_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M2: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))) = neg_numeral_sub(A,one2,M2) ) ) ).

% add_neg_numeral_special(1)
tff(fact_3564_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M2: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,one2,M2) ) ) ).

% diff_numeral_special(8)
tff(fact_3565_bit__1__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,one_one(A)),N))
        <=> ( N = zero_zero(nat) ) ) ) ).

% bit_1_iff
tff(fact_3566_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(nat,nat,suc,N))) ) ).

% not_bit_1_Suc
tff(fact_3567_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: num] : ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(num,nat,numeral_numeral(nat),N))) ) ).

% bit_numeral_simps(1)
tff(fact_3568_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W2: num,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,W2))),N))
        <=> pp(aa(nat,bool,aa(fun(nat,bool),fun(nat,bool),aa(bool,fun(fun(nat,bool),fun(nat,bool)),case_nat(bool),fFalse),bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W2))),N)) ) ) ).

% bit_numeral_rec(1)
tff(fact_3569_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W2: num,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,W2))),N))
        <=> pp(aa(nat,bool,aa(fun(nat,bool),fun(nat,bool),aa(bool,fun(fun(nat,bool),fun(nat,bool)),case_nat(bool),fTrue),bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W2))),N)) ) ) ).

% bit_numeral_rec(2)
tff(fact_3570_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A4),N))
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A4),bit_se4730199178511100633sh_bit(A,N,one_one(A))) != zero_zero(A) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
tff(fact_3571_take__bit__sum,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,A4: A] : ( bit_se2584673776208193580ke_bit(A,N,A4) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_zs(A,fun(nat,A),A4)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% take_bit_sum
tff(fact_3572_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
         => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A4)),N))
          <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A4),N))
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% even_bit_succ_iff
tff(fact_3573_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A4: A,N: nat] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))
         => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A4),N))
          <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))),N))
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
tff(fact_3574_pred__def,axiom,
    ! [Nat: nat] : ( pred(Nat) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),zero_zero(nat)),aTP_Lamp_vy(nat,nat)),Nat) ) ).

% pred_def
tff(fact_3575_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A4: A] : ( bit_ri4674362597316999326ke_bit(A,N,A4) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),bit_se2584673776208193580ke_bit(A,N,A4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,bit_se5641148757651400278ts_bit(A,A4),N))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N)))) ) ) ).

% signed_take_bit_def
tff(fact_3576_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( one_one(A) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Y))) ) ) ).

% eq_numeral_iff_iszero(8)
tff(fact_3577_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X2)) = one_one(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),X2),one2))) ) ) ).

% eq_numeral_iff_iszero(7)
tff(fact_3578_Gcd__remove0__nat,axiom,
    ! [M: set(nat)] :
      ( pp(aa(set(nat),bool,finite_finite2(nat),M))
     => ( gcd_Gcd(nat,M) = gcd_Gcd(nat,aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),M),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))))) ) ) ).

% Gcd_remove0_nat
tff(fact_3579_Gcd__empty,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Gcd(A,bot_bot(set(A))) = zero_zero(A) ) ) ).

% Gcd_empty
tff(fact_3580_Gcd__UNIV,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Gcd(A,top_top(set(A))) = one_one(A) ) ) ).

% Gcd_UNIV
tff(fact_3581_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.compl_zero
tff(fact_3582_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% bit.compl_one
tff(fact_3583_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_right
tff(fact_3584_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)),X2) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_left
tff(fact_3585_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_right
tff(fact_3586_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)),X2) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_left
tff(fact_3587_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),X2) ) ) ).

% bit.xor_one_right
tff(fact_3588_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,uminus_uminus(A),one_one(A))),X2) = aa(A,A,bit_ri4277139882892585799ns_not(A),X2) ) ) ).

% bit.xor_one_left
tff(fact_3589_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ( gcd_Gcd(A,A3) = zero_zero(A) )
        <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A))))) ) ) ).

% Gcd_0_iff
tff(fact_3590_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( bit_se4730199178511100633sh_bit(A,N,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N)) ) ) ).

% push_bit_minus_one_eq_not_mask
tff(fact_3591_not__one__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% not_one_eq
tff(fact_3592_Gcd__1,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,member(A,one_one(A)),A3))
         => ( gcd_Gcd(A,A3) = one_one(A) ) ) ) ).

% Gcd_1
tff(fact_3593_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,one_one(A)) ) ).

% not_iszero_1
tff(fact_3594_Gcd__eq__1__I,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: A,A3: set(A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( pp(aa(set(A),bool,member(A,A4),A3))
           => ( gcd_Gcd(A,A3) = one_one(A) ) ) ) ) ).

% Gcd_eq_1_I
tff(fact_3595_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_iszero_neg_1
tff(fact_3596_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A4: A] : ( aa(A,A,uminus_uminus(A),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A4)),one_one(A)) ) ) ).

% minus_eq_not_plus_1
tff(fact_3597_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A4: A] : ( aa(A,A,uminus_uminus(A),A4) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))) ) ) ).

% minus_eq_not_minus_1
tff(fact_3598_not__eq__complement,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A4: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),A4) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A4)),one_one(A)) ) ) ).

% not_eq_complement
tff(fact_3599_Gcd__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(B,A,F2,X)),aa(B,A,G,X))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),gcd_Gcd(A,aa(set(B),set(A),image2(B,A,F2),A3))),gcd_Gcd(A,aa(set(B),set(A),image2(B,A,G),A3)))) ) ) ).

% Gcd_mono
tff(fact_3600_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A4: A] : ( bit_se2638667681897837118et_bit(A,N,A4) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A4),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se4730199178511100633sh_bit(A,N,one_one(A)))) ) ) ).

% unset_bit_eq_and_not
tff(fact_3601_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),Y) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),Y) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( aa(A,A,bit_ri4277139882892585799ns_not(A),X2) = Y ) ) ) ) ).

% bit.compl_unique
tff(fact_3602_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),Y) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,one2,Y)) ) ) ).

% eq_numeral_iff_iszero(6)
tff(fact_3603_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: num] :
          ( ( aa(num,A,numeral_numeral(A),X2) = one_one(A) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,X2,one2)) ) ) ).

% eq_numeral_iff_iszero(5)
tff(fact_3604_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea2506097494486148201lgebra(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% bit.abstract_boolean_algebra_axioms
tff(fact_3605_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea3799213064322606851m_diff(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A)),bit_se5824344971392196577ns_xor(A)) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
tff(fact_3606_Gcd__eq__Max,axiom,
    ! [M: set(nat)] :
      ( pp(aa(set(nat),bool,finite_finite2(nat),M))
     => ( ( M != bot_bot(set(nat)) )
       => ( ~ pp(aa(set(nat),bool,member(nat,zero_zero(nat)),M))
         => ( gcd_Gcd(nat,M) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(set(set(nat)),set(nat),complete_Inf_Inf(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),aTP_Lamp_zt(nat,set(nat))),M))) ) ) ) ) ).

% Gcd_eq_Max
tff(fact_3607_semiring__char__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: itself(A)] : ( semiri4206861660011772517g_char(A,Uu) = gcd_Gcd(nat,aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_zu(nat,bool))) ) ) ).

% semiring_char_def
tff(fact_3608_set__decode__def,axiom,
    ! [X2: nat] : ( nat_set_decode(X2) = aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_zv(nat,fun(nat,bool),X2)) ) ).

% set_decode_def
tff(fact_3609_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(N))) ) ) ).

% diff_numeral_special(5)
tff(fact_3610_Gcd__abs__eq,axiom,
    ! [K5: set(int)] : ( gcd_Gcd(int,aa(set(int),set(int),image2(int,int,abs_abs(int)),K5)) = gcd_Gcd(int,K5) ) ).

% Gcd_abs_eq
tff(fact_3611_Gcd__int__eq,axiom,
    ! [N4: set(nat)] : ( gcd_Gcd(int,aa(set(nat),set(int),image2(nat,int,semiring_1_of_nat(int)),N4)) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,N4)) ) ).

% Gcd_int_eq
tff(fact_3612_Gcd__nat__abs__eq,axiom,
    ! [K5: set(int)] : ( gcd_Gcd(nat,aa(set(int),set(nat),image2(int,nat,aTP_Lamp_zw(int,nat)),K5)) = aa(int,nat,nat2,gcd_Gcd(int,K5)) ) ).

% Gcd_nat_abs_eq
tff(fact_3613_Max__singleton,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A] : ( aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = X2 ) ) ).

% Max_singleton
tff(fact_3614_set__decode__zero,axiom,
    nat_set_decode(zero_zero(nat)) = bot_bot(set(nat)) ).

% set_decode_zero
tff(fact_3615_Max__divisors__self__nat,axiom,
    ! [N: nat] :
      ( ( N != zero_zero(nat) )
     => ( aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_zc(nat,fun(nat,bool),N))) = N ) ) ).

% Max_divisors_self_nat
tff(fact_3616_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic643756798349783984er_Max(A),A3)),X2))
            <=> ! [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),X2)) ) ) ) ) ) ).

% Max.bounded_iff
tff(fact_3617_Max__less__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,lattic643756798349783984er_Max(A),A3)),X2))
            <=> ! [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),X2)) ) ) ) ) ) ).

% Max_less_iff
tff(fact_3618_Max__const,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [A3: set(B),C2: A] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_zx(A,fun(B,A),C2)),A3)) = C2 ) ) ) ) ).

% Max_const
tff(fact_3619_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M2: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M2))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(M2))) ) ) ).

% add_neg_numeral_special(6)
tff(fact_3620_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(N))) ) ) ).

% add_neg_numeral_special(5)
tff(fact_3621_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M2: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M2)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),inc(M2)) ) ) ).

% diff_numeral_special(6)
tff(fact_3622_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib2,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),Y: A,Z2: A,X2: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Xor,Y),Z2)),X2) = aa(A,A,aa(A,fun(A,A),Xor,aa(A,A,aa(A,fun(A,A),Conj,Y),X2)),aa(A,A,aa(A,fun(A,A),Conj,Z2),X2)) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib2
tff(fact_3623_abstract__boolean__algebra__sym__diff_Oxor__cancel__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X2: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X2),aa(A,A,Compl,X2)) = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_right
tff(fact_3624_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X2: A,Y: A,Z2: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Conj,X2),aa(A,A,aa(A,fun(A,A),Xor,Y),Z2)) = aa(A,A,aa(A,fun(A,A),Xor,aa(A,A,aa(A,fun(A,A),Conj,X2),Y)),aa(A,A,aa(A,fun(A,A),Conj,X2),Z2)) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib
tff(fact_3625_abstract__boolean__algebra__sym__diff_Oxor__compl__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X2: A,Y: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X2),aa(A,A,Compl,Y)) = aa(A,A,Compl,aa(A,A,aa(A,fun(A,A),Xor,X2),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_right
tff(fact_3626_abstract__boolean__algebra__sym__diff_Oxor__cancel__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X2: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,aa(A,A,Compl,X2)),X2) = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_left
tff(fact_3627_abstract__boolean__algebra__sym__diff_Oxor__compl__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X2: A,Y: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,aa(A,A,Compl,X2)),Y) = aa(A,A,Compl,aa(A,A,aa(A,fun(A,A),Xor,X2),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_left
tff(fact_3628_abstract__boolean__algebra__sym__diff_Oxor__one__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X2: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X2),One) = aa(A,A,Compl,X2) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_right
tff(fact_3629_abstract__boolean__algebra__sym__diff_Oxor__left__self,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X2: A,Y: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X2),aa(A,A,aa(A,fun(A,A),Xor,X2),Y)) = Y ) ) ).

% abstract_boolean_algebra_sym_diff.xor_left_self
tff(fact_3630_abstract__boolean__algebra__sym__diff_Oxor__one__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X2: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,One),X2) = aa(A,A,Compl,X2) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_left
tff(fact_3631_abstract__boolean__algebra__sym__diff_Oxor__self,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X2: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X2),X2) = Zero ) ) ).

% abstract_boolean_algebra_sym_diff.xor_self
tff(fact_3632_abstract__boolean__algebra__sym__diff_Oxor__def2,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X2: A,Y: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X2),Y) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,X2),Y)),aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,Compl,X2)),aa(A,A,Compl,Y))) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def2
tff(fact_3633_abstract__boolean__algebra__sym__diff_Oxor__def,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X2: A,Y: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X2),Y) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X2),aa(A,A,Compl,Y))),aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,Compl,X2)),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def
tff(fact_3634_abstract__boolean__algebra__sym__diff_Oaxioms_I1_J,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A))] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One) ) ).

% abstract_boolean_algebra_sym_diff.axioms(1)
tff(fact_3635_Max__in,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => pp(aa(set(A),bool,member(A,aa(set(A),A,lattic643756798349783984er_Max(A),A3)),A3)) ) ) ) ).

% Max_in
tff(fact_3636_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),M2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ( aa(set(A),A,lattic643756798349783984er_Max(A),A3) = M2 )
            <=> ( pp(aa(set(A),bool,member(A,M2),A3))
                & ! [X3: A] :
                    ( pp(aa(set(A),bool,member(A,X3),A3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),M2)) ) ) ) ) ) ) ).

% Max_eq_iff
tff(fact_3637_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(set(A),A,lattic643756798349783984er_Max(A),A3)))
            <=> ? [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),X3)) ) ) ) ) ) ).

% Max_ge_iff
tff(fact_3638_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),M2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ( M2 = aa(set(A),A,lattic643756798349783984er_Max(A),A3) )
            <=> ( pp(aa(set(A),bool,member(A,M2),A3))
                & ! [X3: A] :
                    ( pp(aa(set(A),bool,member(A,X3),A3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),M2)) ) ) ) ) ) ) ).

% eq_Max_iff
tff(fact_3639_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic643756798349783984er_Max(A),A3)),X2))
             => ! [A14: A] :
                  ( pp(aa(set(A),bool,member(A,A14),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A14),X2)) ) ) ) ) ) ).

% Max.boundedE
tff(fact_3640_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [A5: A] :
                  ( pp(aa(set(A),bool,member(A,A5),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A5),X2)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic643756798349783984er_Max(A),A3)),X2)) ) ) ) ) ).

% Max.boundedI
tff(fact_3641_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(set(A),A,lattic643756798349783984er_Max(A),A3)))
            <=> ? [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),X3)) ) ) ) ) ) ).

% Max_gr_iff
tff(fact_3642_Max__Sup,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic643756798349783984er_Max(A),A3) = aa(set(A),A,complete_Sup_Sup(A),A3) ) ) ) ) ).

% Max_Sup
tff(fact_3643_cSup__eq__Max,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X5: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),X5))
         => ( ( X5 != bot_bot(set(A)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),X5) = aa(set(A),A,lattic643756798349783984er_Max(A),X5) ) ) ) ) ).

% cSup_eq_Max
tff(fact_3644_Sup__nat__def,axiom,
    ! [X5: set(nat)] :
      ( ( ( X5 = bot_bot(set(nat)) )
       => ( aa(set(nat),nat,complete_Sup_Sup(nat),X5) = zero_zero(nat) ) )
      & ( ( X5 != bot_bot(set(nat)) )
       => ( aa(set(nat),nat,complete_Sup_Sup(nat),X5) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),X5) ) ) ) ).

% Sup_nat_def
tff(fact_3645_numeral__inc,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [X2: num] : ( aa(num,A,numeral_numeral(A),inc(X2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),X2)),one_one(A)) ) ) ).

% numeral_inc
tff(fact_3646_Max_Osubset__imp,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),B2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic643756798349783984er_Max(A),A3)),aa(set(A),A,lattic643756798349783984er_Max(A),B2))) ) ) ) ) ).

% Max.subset_imp
tff(fact_3647_Max__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [M: set(A),N4: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),M),N4))
         => ( ( M != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),N4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic643756798349783984er_Max(A),M)),aa(set(A),A,lattic643756798349783984er_Max(A),N4))) ) ) ) ) ).

% Max_mono
tff(fact_3648_mono__Max__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F2: fun(A,B),A3: set(A)] :
          ( order_mono(A,B,F2)
         => ( pp(aa(set(A),bool,finite_finite2(A),A3))
           => ( ( A3 != bot_bot(set(A)) )
             => ( aa(A,B,F2,aa(set(A),A,lattic643756798349783984er_Max(A),A3)) = aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(A),set(B),image2(A,B,F2),A3)) ) ) ) ) ) ).

% mono_Max_commute
tff(fact_3649_Gcd__int__def,axiom,
    ! [K5: set(int)] : ( gcd_Gcd(int,K5) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,aa(set(int),set(nat),image2(int,nat,aa(fun(int,int),fun(int,nat),comp(int,nat,int,nat2),abs_abs(int))),K5))) ) ).

% Gcd_int_def
tff(fact_3650_Max__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( linord4140545234300271783up_add(A)
     => ! [S: set(B),F2: fun(B,A),K: A] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( ( S != bot_bot(set(B)) )
           => ( aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_zy(fun(B,A),fun(A,fun(B,A)),F2),K)),S)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(B),set(A),image2(B,A,F2),S))),K) ) ) ) ) ).

% Max_add_commute
tff(fact_3651_divide__nat__def,axiom,
    ! [N: nat,M2: nat] :
      ( ( ( N = zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M2),N) = zero_zero(nat) ) )
      & ( ( N != zero_zero(nat) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M2),N) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_zz(nat,fun(nat,fun(nat,bool)),N),M2))) ) ) ) ).

% divide_nat_def
tff(fact_3652_dual__Min,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( lattices_Min(A,aTP_Lamp_pz(A,fun(A,bool))) = lattic643756798349783984er_Max(A) ) ) ).

% dual_Min
tff(fact_3653_INT__greaterThan__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Inf_Inf(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),set_ord_greaterThan(nat)),top_top(set(nat)))) = bot_bot(set(nat)) ).

% INT_greaterThan_UNIV
tff(fact_3654_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat,M2: nat] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M2),N))),one_one(A)) ) ) ).

% mask_mod_exp
tff(fact_3655_Code__Numeral_Odup__def,axiom,
    code_dup = aa(fun(int,int),fun(code_integer,code_integer),map_fun(code_integer,int,int,code_integer,code_int_of_integer,code_integer_of_int),aTP_Lamp_yo(int,int)) ).

% Code_Numeral.dup_def
tff(fact_3656_min_Oidem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),A4) = A4 ) ) ).

% min.idem
tff(fact_3657_min_Oleft__idem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) ) ) ).

% min.left_idem
tff(fact_3658_min_Oright__idem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)),B3) = aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) ) ) ).

% min.right_idem
tff(fact_3659_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),C2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2)) ) ) ) ).

% min.bounded_iff
tff(fact_3660_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) = B3 ) ) ) ).

% min.absorb2
tff(fact_3661_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) = A4 ) ) ) ).

% min.absorb1
tff(fact_3662_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),X2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),Y)) ) ) ) ).

% min_less_iff_conj
tff(fact_3663_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) = B3 ) ) ) ).

% min.absorb4
tff(fact_3664_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) = A4 ) ) ) ).

% min.absorb3
tff(fact_3665_min__bot,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),bot_bot(A)),X2) = bot_bot(A) ) ) ).

% min_bot
tff(fact_3666_min__bot2,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),X2),bot_bot(A)) = bot_bot(A) ) ) ).

% min_bot2
tff(fact_3667_min__top2,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),X2),top_top(A)) = X2 ) ) ).

% min_top2
tff(fact_3668_min__top,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),top_top(A)),X2) = X2 ) ) ).

% min_top
tff(fact_3669_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),zero_zero(A)),one_one(A)) = zero_zero(A) ) ) ).

% min_0_1(1)
tff(fact_3670_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),zero_zero(A)) = zero_zero(A) ) ) ).

% min_0_1(2)
tff(fact_3671_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),X2)),one_one(A)) = one_one(A) ) ) ).

% min_0_1(6)
tff(fact_3672_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),aa(num,A,numeral_numeral(A),X2)) = one_one(A) ) ) ).

% min_0_1(5)
tff(fact_3673_Int__atMost,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_atMost(A),A4)),aa(A,set(A),set_ord_atMost(A),B3)) = aa(A,set(A),set_ord_atMost(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)) ) ) ).

% Int_atMost
tff(fact_3674_Max__divisors__self__int,axiom,
    ! [N: int] :
      ( ( N != zero_zero(int) )
     => ( aa(set(int),int,lattic643756798349783984er_Max(int),aa(fun(int,bool),set(int),collect(int),aTP_Lamp_zf(int,fun(int,bool),N))) = aa(int,int,abs_abs(int),N) ) ) ).

% Max_divisors_self_int
tff(fact_3675_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),top_top(A)))
         => ( aa(set(A),A,complete_Sup_Sup(A),aa(A,set(A),set_ord_greaterThan(A),X2)) = top_top(A) ) ) ) ).

% Sup_greaterThanAtLeast
tff(fact_3676_Int__atLeastAtMostR1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,C2: A,D3: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_atMost(A),B3)),set_or1337092689740270186AtMost(A,C2,D3)) = set_or1337092689740270186AtMost(A,C2,aa(A,A,aa(A,fun(A,A),ord_min(A),B3),D3)) ) ) ).

% Int_atLeastAtMostR1
tff(fact_3677_Int__atLeastAtMostL1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,D3: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,A4,B3)),aa(A,set(A),set_ord_atMost(A),D3)) = set_or1337092689740270186AtMost(A,A4,aa(A,A,aa(A,fun(A,A),ord_min(A),B3),D3)) ) ) ).

% Int_atLeastAtMostL1
tff(fact_3678_min__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F2: fun(A,B),M2: A,N: A] :
          ( order_mono(A,B,F2)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(A,B,F2,M2)),aa(A,B,F2,N)) = aa(A,B,F2,aa(A,A,aa(A,fun(A,A),ord_min(A),M2),N)) ) ) ) ).

% min_of_mono
tff(fact_3679_min_Oassoc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),ord_min(A),A4),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),C2)) ) ) ).

% min.assoc
tff(fact_3680_min_Ocommute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) = aa(A,A,aa(A,fun(A,A),ord_min(A),B3),A4) ) ) ).

% min.commute
tff(fact_3681_min_Oleft__commute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),B3),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),C2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),A4),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),C2)) ) ) ).

% min.left_commute
tff(fact_3682_inf__nat__def,axiom,
    inf_inf(nat) = ord_min(nat) ).

% inf_nat_def
tff(fact_3683_complete__linorder__inf__min,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ( inf_inf(A) = ord_min(A) ) ) ).

% complete_linorder_inf_min
tff(fact_3684_inf__min,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf(A)
        & linorder(A) )
     => ( inf_inf(A) = ord_min(A) ) ) ).

% inf_min
tff(fact_3685_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)),Z2) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Z2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z2)) ) ) ).

% min_diff_distrib_left
tff(fact_3686_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),ord_min(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Z2)) ) ) ).

% min_add_distrib_right
tff(fact_3687_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)),Z2) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Z2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y),Z2)) ) ) ).

% min_add_distrib_left
tff(fact_3688_min_Omono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),D3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)),aa(A,A,aa(A,fun(A,A),ord_min(A),C2),D3))) ) ) ) ).

% min.mono
tff(fact_3689_min_OorderE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( A4 = aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) ) ) ) ).

% min.orderE
tff(fact_3690_min_OorderI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ).

% min.orderI
tff(fact_3691_min_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2)) ) ) ) ).

% min.boundedE
tff(fact_3692_min_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),C2))) ) ) ) ).

% min.boundedI
tff(fact_3693_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
        <=> ( A4 = aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) ) ) ) ).

% min.order_iff
tff(fact_3694_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)),A4)) ) ).

% min.cobounded1
tff(fact_3695_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)),B3)) ) ).

% min.cobounded2
tff(fact_3696_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) = A4 ) ) ) ).

% min.absorb_iff1
tff(fact_3697_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) = B3 ) ) ) ).

% min.absorb_iff2
tff(fact_3698_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)),C2)) ) ) ).

% min.coboundedI1
tff(fact_3699_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)),C2)) ) ) ).

% min.coboundedI2
tff(fact_3700_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)),Z2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ) ).

% min_le_iff_disj
tff(fact_3701_min__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A4: A,B3: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) = A4 ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) = B3 ) ) ) ) ).

% min_def
tff(fact_3702_min__absorb1,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y) = X2 ) ) ) ).

% min_absorb1
tff(fact_3703_min__absorb2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y) = Y ) ) ) ).

% min_absorb2
tff(fact_3704_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)),C2)) ) ) ).

% min.strict_coboundedI2
tff(fact_3705_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)),C2)) ) ) ).

% min.strict_coboundedI1
tff(fact_3706_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
        <=> ( ( A4 = aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3) )
            & ( A4 != B3 ) ) ) ) ).

% min.strict_order_iff
tff(fact_3707_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),C2)) ) ) ) ).

% min.strict_boundedE
tff(fact_3708_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)),Z2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),Z2)) ) ) ) ).

% min_less_iff_disj
tff(fact_3709_min_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semigroup(A,ord_min(A)) ) ).

% min.semigroup_axioms
tff(fact_3710_min__def__raw,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X4: A,Xa3: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Xa3))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),X4),Xa3) = X4 ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Xa3))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),X4),Xa3) = Xa3 ) ) ) ) ).

% min_def_raw
tff(fact_3711_greaterThan__non__empty,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [X2: A] : ( aa(A,set(A),set_ord_greaterThan(A),X2) != bot_bot(set(A)) ) ) ).

% greaterThan_non_empty
tff(fact_3712_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A] : ( aa(A,set(A),set_ord_greaterThan(A),L) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),ord_less(A),L)) ) ) ).

% greaterThan_def
tff(fact_3713_greaterThan__Int__greaterThan,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_lessThan(A),A4)),aa(A,set(A),set_ord_lessThan(A),B3)) = aa(A,set(A),set_ord_lessThan(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)) ) ) ).

% greaterThan_Int_greaterThan
tff(fact_3714_Inf__insert__finite,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [S: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( ( ( S = bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert(A,X2),S)) = X2 ) )
            & ( ( S != bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert(A,X2),S)) = aa(A,A,aa(A,fun(A,A),ord_min(A),X2),aa(set(A),A,complete_Inf_Inf(A),S)) ) ) ) ) ) ).

% Inf_insert_finite
tff(fact_3715_min__Suc1,axiom,
    ! [N: nat,M2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,N)),M2) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),zero_zero(nat)),aTP_Lamp_aaa(nat,fun(nat,nat),N)),M2) ) ).

% min_Suc1
tff(fact_3716_min__Suc2,axiom,
    ! [M2: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M2),aa(nat,nat,suc,N)) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),zero_zero(nat)),aTP_Lamp_aab(nat,fun(nat,nat),N)),M2) ) ).

% min_Suc2
tff(fact_3717_ivl__disj__int__one_I7_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,L,U)),aa(A,set(A),set_ord_greaterThan(A),U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(7)
tff(fact_3718_ivl__disj__un__singleton_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert(A,L),bot_bot(set(A)))),aa(A,set(A),set_ord_greaterThan(A),L)) = aa(A,set(A),set_ord_atLeast(A),L) ) ) ).

% ivl_disj_un_singleton(1)
tff(fact_3719_greaterThan__Suc,axiom,
    ! [K: nat] : ( aa(nat,set(nat),set_ord_greaterThan(nat),aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_greaterThan(nat),K)),aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,K)),bot_bot(set(nat)))) ) ).

% greaterThan_Suc
tff(fact_3720_dual__max,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( max(A,aTP_Lamp_pz(A,fun(A,bool))) = ord_min(A) ) ) ).

% dual_max
tff(fact_3721_minus__Max__eq__Min,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [S: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( ( S != bot_bot(set(A)) )
           => ( aa(A,A,uminus_uminus(A),aa(set(A),A,lattic643756798349783984er_Max(A),S)) = aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),image2(A,A,uminus_uminus(A)),S)) ) ) ) ) ).

% minus_Max_eq_Min
tff(fact_3722_minus__Min__eq__Max,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [S: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( ( S != bot_bot(set(A)) )
           => ( aa(A,A,uminus_uminus(A),aa(set(A),A,lattic643756798350308766er_Min(A),S)) = aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),image2(A,A,uminus_uminus(A)),S)) ) ) ) ) ).

% minus_Min_eq_Max
tff(fact_3723_take__bit__numeral__minus__numeral__int,axiom,
    ! [M2: num,N: num] : ( bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),M2),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = case_option(int,num,zero_zero(int),aTP_Lamp_aac(num,fun(num,int),M2),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),M2),N)) ) ).

% take_bit_numeral_minus_numeral_int
tff(fact_3724_Min__singleton,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A] : ( aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = X2 ) ) ).

% Min_singleton
tff(fact_3725_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(set(A),A,lattic643756798350308766er_Min(A),A3)))
            <=> ! [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),X3)) ) ) ) ) ) ).

% Min.bounded_iff
tff(fact_3726_Min__gr__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),aa(set(A),A,lattic643756798350308766er_Min(A),A3)))
            <=> ! [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),X3)) ) ) ) ) ) ).

% Min_gr_iff
tff(fact_3727_Min__const,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [A3: set(B),C2: A] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_zx(A,fun(B,A),C2)),A3)) = C2 ) ) ) ) ).

% Min_const
tff(fact_3728_Min__insert,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),ord_min(A),X2),aa(set(A),A,lattic643756798350308766er_Min(A),A3)) ) ) ) ) ).

% Min_insert
tff(fact_3729_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M2: num,N: num] : ( bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),M2),aa(num,A,numeral_numeral(A),N)) = case_option(A,num,zero_zero(A),numeral_numeral(A),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),M2),N)) ) ) ).

% take_bit_numeral_numeral
tff(fact_3730_disjE__realizer2,axiom,
    ! [B: $tType,A: $tType,P: bool,Q: fun(A,bool),X2: option(A),R: fun(B,bool),F2: B,G: fun(A,B)] :
      ( pp(case_option(bool,A,P,Q,X2))
     => ( ( pp(P)
         => pp(aa(B,bool,R,F2)) )
       => ( ! [Q8: A] :
              ( pp(aa(A,bool,Q,Q8))
             => pp(aa(B,bool,R,aa(A,B,G,Q8))) )
         => pp(aa(B,bool,R,case_option(B,A,F2,G,X2))) ) ) ) ).

% disjE_realizer2
tff(fact_3731_ord_Omax_Ocong,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool))] : ( max(A,Less_eq) = max(A,Less_eq) ) ).

% ord.max.cong
tff(fact_3732_ord_Omax__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
       => ( aa(A,A,aa(A,fun(A,A),max(A,Less_eq),A4),B3) = B3 ) )
      & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
       => ( aa(A,A,aa(A,fun(A,A),max(A,Less_eq),A4),B3) = A4 ) ) ) ).

% ord.max_def
tff(fact_3733_Min__in,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => pp(aa(set(A),bool,member(A,aa(set(A),A,lattic643756798350308766er_Min(A),A3)),A3)) ) ) ) ).

% Min_in
tff(fact_3734_Least__Min,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,bool)] :
          ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),P)))
         => ( ? [X_13: A] : pp(aa(A,bool,P,X_13))
           => ( ord_Least(A,P) = aa(set(A),A,lattic643756798350308766er_Min(A),aa(fun(A,bool),set(A),collect(A),P)) ) ) ) ) ).

% Least_Min
tff(fact_3735_Min__eq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),M2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ( aa(set(A),A,lattic643756798350308766er_Min(A),A3) = M2 )
            <=> ( pp(aa(set(A),bool,member(A,M2),A3))
                & ! [X3: A] :
                    ( pp(aa(set(A),bool,member(A,X3),A3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M2),X3)) ) ) ) ) ) ) ).

% Min_eq_iff
tff(fact_3736_Min__le__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic643756798350308766er_Min(A),A3)),X2))
            <=> ? [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),X2)) ) ) ) ) ) ).

% Min_le_iff
tff(fact_3737_eq__Min__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),M2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ( M2 = aa(set(A),A,lattic643756798350308766er_Min(A),A3) )
            <=> ( pp(aa(set(A),bool,member(A,M2),A3))
                & ! [X3: A] :
                    ( pp(aa(set(A),bool,member(A,X3),A3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M2),X3)) ) ) ) ) ) ) ).

% eq_Min_iff
tff(fact_3738_Min_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(set(A),A,lattic643756798350308766er_Min(A),A3)))
             => ! [A14: A] :
                  ( pp(aa(set(A),bool,member(A,A14),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A14)) ) ) ) ) ) ).

% Min.boundedE
tff(fact_3739_Min_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [A5: A] :
                  ( pp(aa(set(A),bool,member(A,A5),A3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A5)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(set(A),A,lattic643756798350308766er_Min(A),A3))) ) ) ) ) ).

% Min.boundedI
tff(fact_3740_Min__less__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,lattic643756798350308766er_Min(A),A3)),X2))
            <=> ? [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A3))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),X2)) ) ) ) ) ) ).

% Min_less_iff
tff(fact_3741_Min__Inf,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic643756798350308766er_Min(A),A3) = aa(set(A),A,complete_Inf_Inf(A),A3) ) ) ) ) ).

% Min_Inf
tff(fact_3742_cInf__eq__Min,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X5: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),X5))
         => ( ( X5 != bot_bot(set(A)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),X5) = aa(set(A),A,lattic643756798350308766er_Min(A),X5) ) ) ) ) ).

% cInf_eq_Min
tff(fact_3743_Min_Osubset__imp,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),B2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic643756798350308766er_Min(A),B2)),aa(set(A),A,lattic643756798350308766er_Min(A),A3))) ) ) ) ) ).

% Min.subset_imp
tff(fact_3744_Min__antimono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [M: set(A),N4: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),M),N4))
         => ( ( M != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),N4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic643756798350308766er_Min(A),N4)),aa(set(A),A,lattic643756798350308766er_Min(A),M))) ) ) ) ) ).

% Min_antimono
tff(fact_3745_hom__Min__commute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [H2: fun(A,A),N4: set(A)] :
          ( ! [X: A,Y2: A] : ( aa(A,A,H2,aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,H2,X)),aa(A,A,H2,Y2)) )
         => ( pp(aa(set(A),bool,finite_finite2(A),N4))
           => ( ( N4 != bot_bot(set(A)) )
             => ( aa(A,A,H2,aa(set(A),A,lattic643756798350308766er_Min(A),N4)) = aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),image2(A,A,H2),N4)) ) ) ) ) ) ).

% hom_Min_commute
tff(fact_3746_Min_Osubset,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( B2 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),A3))
             => ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(set(A),A,lattic643756798350308766er_Min(A),B2)),aa(set(A),A,lattic643756798350308766er_Min(A),A3)) = aa(set(A),A,lattic643756798350308766er_Min(A),A3) ) ) ) ) ) ).

% Min.subset
tff(fact_3747_Min_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ~ pp(aa(set(A),bool,member(A,X2),A3))
           => ( ( A3 != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),ord_min(A),X2),aa(set(A),A,lattic643756798350308766er_Min(A),A3)) ) ) ) ) ) ).

% Min.insert_not_elem
tff(fact_3748_Min_Oclosed,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [X: A,Y2: A] : pp(aa(set(A),bool,member(A,aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y2)),aa(set(A),set(A),insert(A,X),aa(set(A),set(A),insert(A,Y2),bot_bot(set(A))))))
             => pp(aa(set(A),bool,member(A,aa(set(A),A,lattic643756798350308766er_Min(A),A3)),A3)) ) ) ) ) ).

% Min.closed
tff(fact_3749_mono__Min__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F2: fun(A,B),A3: set(A)] :
          ( order_mono(A,B,F2)
         => ( pp(aa(set(A),bool,finite_finite2(A),A3))
           => ( ( A3 != bot_bot(set(A)) )
             => ( aa(A,B,F2,aa(set(A),A,lattic643756798350308766er_Min(A),A3)) = aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(A),set(B),image2(A,B,F2),A3)) ) ) ) ) ) ).

% mono_Min_commute
tff(fact_3750_Min_Ounion,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),B2))
             => ( ( B2 != bot_bot(set(A)) )
               => ( aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(set(A),A,lattic643756798350308766er_Min(A),A3)),aa(set(A),A,lattic643756798350308766er_Min(A),B2)) ) ) ) ) ) ) ).

% Min.union
tff(fact_3751_Min__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( linord4140545234300271783up_add(A)
     => ! [S: set(B),F2: fun(B,A),K: A] :
          ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( ( S != bot_bot(set(B)) )
           => ( aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_zy(fun(B,A),fun(A,fun(B,A)),F2),K)),S)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(B),set(A),image2(B,A,F2),S))),K) ) ) ) ) ).

% Min_add_commute
tff(fact_3752_Min_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( pp(aa(set(A),bool,member(A,X2),A3))
           => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = bot_bot(set(A)) )
               => ( aa(set(A),A,lattic643756798350308766er_Min(A),A3) = X2 ) )
              & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) != bot_bot(set(A)) )
               => ( aa(set(A),A,lattic643756798350308766er_Min(A),A3) = aa(A,A,aa(A,fun(A,A),ord_min(A),X2),aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ) ).

% Min.remove
tff(fact_3753_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = bot_bot(set(A)) )
             => ( aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),insert(A,X2),A3)) = X2 ) )
            & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),ord_min(A),X2),aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ).

% Min.insert_remove
tff(fact_3754_and__minus__numerals_I4_J,axiom,
    ! [M2: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M2,aa(num,num,bit0,N))) ) ).

% and_minus_numerals(4)
tff(fact_3755_and__minus__numerals_I8_J,axiom,
    ! [N: num,M2: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))),aa(num,int,numeral_numeral(int),M2)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M2,aa(num,num,bit0,N))) ) ).

% and_minus_numerals(8)
tff(fact_3756_dual__Max,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( lattices_Max(A,aTP_Lamp_pz(A,fun(A,bool))) = lattic643756798350308766er_Min(A) ) ) ).

% dual_Max
tff(fact_3757_int__numeral__and__not__num,axiom,
    ! [M2: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M2)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M2,N)) ) ).

% int_numeral_and_not_num
tff(fact_3758_int__numeral__not__and__num,axiom,
    ! [M2: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),M2))),aa(num,int,numeral_numeral(int),N)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(N,M2)) ) ).

% int_numeral_not_and_num
tff(fact_3759_and__minus__numerals_I7_J,axiom,
    ! [N: num,M2: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,N)))),aa(num,int,numeral_numeral(int),M2)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M2,bitM(N))) ) ).

% and_minus_numerals(7)
tff(fact_3760_and__minus__numerals_I3_J,axiom,
    ! [M2: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,N)))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M2,bitM(N))) ) ).

% and_minus_numerals(3)
tff(fact_3761_less__option__def,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: option(A),Y: option(A)] :
          ( pp(aa(option(A),bool,aa(option(A),fun(option(A),bool),ord_less(option(A)),X2),Y))
        <=> pp(case_option(bool,A,fFalse,aTP_Lamp_aae(option(A),fun(A,bool),X2),Y)) ) ) ).

% less_option_def
tff(fact_3762_less__eq__option__def,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: option(A),Y: option(A)] :
          ( pp(aa(option(A),bool,aa(option(A),fun(option(A),bool),ord_less_eq(option(A)),X2),Y))
        <=> pp(case_option(bool,A,fTrue,aTP_Lamp_aaf(option(A),fun(A,bool),Y),X2)) ) ) ).

% less_eq_option_def
tff(fact_3763_numeral__BitM,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),bitM(N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,N))),one_one(A)) ) ) ).

% numeral_BitM
tff(fact_3764_take__bit__num__simps_I7_J,axiom,
    ! [R2: num,M2: num] : ( bit_take_bit_num(aa(num,nat,numeral_numeral(nat),R2),aa(num,num,bit1,M2)) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(pred_numeral(R2),M2))) ) ).

% take_bit_num_simps(7)
tff(fact_3765_abstract__boolean__algebra__sym__diff_Ointro,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A))] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( boolea5476839437570043046axioms(A,Conj,Disj,Compl,Xor)
       => boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor) ) ) ).

% abstract_boolean_algebra_sym_diff.intro
tff(fact_3766_abstract__boolean__algebra__sym__diff__def,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A))] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
    <=> ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
        & boolea5476839437570043046axioms(A,Conj,Disj,Compl,Xor) ) ) ).

% abstract_boolean_algebra_sym_diff_def
tff(fact_3767_rat__floor__code,axiom,
    ! [P5: rat] : ( archim6421214686448440834_floor(rat,P5) = aa(product_prod(int,int),int,aa(fun(int,fun(int,int)),fun(product_prod(int,int),int),product_case_prod(int,int,int),divide_divide(int)),quotient_of(P5)) ) ).

% rat_floor_code
tff(fact_3768_inf__Some,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [X2: A,Y: A] : ( aa(option(A),option(A),aa(option(A),fun(option(A),option(A)),inf_inf(option(A)),aa(A,option(A),some(A),X2)),aa(A,option(A),some(A),Y)) = aa(A,option(A),some(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y)) ) ) ).

% inf_Some
tff(fact_3769_take__bit__num__simps_I4_J,axiom,
    ! [N: nat,M2: num] : ( bit_take_bit_num(aa(nat,nat,suc,N),aa(num,num,bit1,M2)) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(N,M2))) ) ).

% take_bit_num_simps(4)
tff(fact_3770_top__option__def,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ( top_top(option(A)) = aa(A,option(A),some(A),top_top(A)) ) ) ).

% top_option_def
tff(fact_3771_abstract__boolean__algebra__sym__diff__axioms_Ointro,axiom,
    ! [A: $tType,Xor: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Conj: fun(A,fun(A,A)),Compl: fun(A,A)] :
      ( ! [X: A,Y2: A] : ( aa(A,A,aa(A,fun(A,A),Xor,X),Y2) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X),aa(A,A,Compl,Y2))),aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,Compl,X)),Y2)) )
     => boolea5476839437570043046axioms(A,Conj,Disj,Compl,Xor) ) ).

% abstract_boolean_algebra_sym_diff_axioms.intro
tff(fact_3772_abstract__boolean__algebra__sym__diff__axioms__def,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Xor: fun(A,fun(A,A))] :
      ( boolea5476839437570043046axioms(A,Conj,Disj,Compl,Xor)
    <=> ! [X3: A,Y4: A] : ( aa(A,A,aa(A,fun(A,A),Xor,X3),Y4) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X3),aa(A,A,Compl,Y4))),aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,Compl,X3)),Y4)) ) ) ).

% abstract_boolean_algebra_sym_diff_axioms_def
tff(fact_3773_sup__option__def,axiom,
    ! [A: $tType] :
      ( sup(A)
     => ! [X2: option(A),Y: option(A)] : ( aa(option(A),option(A),aa(option(A),fun(option(A),option(A)),sup_sup(option(A)),X2),Y) = case_option(option(A),A,Y,aa(option(A),fun(A,option(A)),aTP_Lamp_aah(option(A),fun(option(A),fun(A,option(A))),X2),Y),X2) ) ) ).

% sup_option_def
tff(fact_3774_Some__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( aa(A,option(A),some(A),aa(set(A),A,complete_Sup_Sup(A),A3)) = aa(set(option(A)),option(A),complete_Sup_Sup(option(A)),aa(set(A),set(option(A)),image2(A,option(A),some(A)),A3)) ) ) ) ).

% Some_Sup
tff(fact_3775_Some__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),A3: set(B)] : ( aa(A,option(A),some(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),A3))) = aa(set(option(A)),option(A),complete_Inf_Inf(option(A)),aa(set(B),set(option(A)),image2(B,option(A),aTP_Lamp_aai(fun(B,A),fun(B,option(A)),F2)),A3)) ) ) ).

% Some_INF
tff(fact_3776_Some__SUP,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( aa(B,option(B),some(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image2(A,B,F2),A3))) = aa(set(option(B)),option(B),complete_Sup_Sup(option(B)),aa(set(A),set(option(B)),image2(A,option(B),aTP_Lamp_aaj(fun(A,B),fun(A,option(B)),F2)),A3)) ) ) ) ).

% Some_SUP
tff(fact_3777_abstract__boolean__algebra__sym__diff_Oaxioms_I2_J,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A))] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => boolea5476839437570043046axioms(A,Conj,Disj,Compl,Xor) ) ).

% abstract_boolean_algebra_sym_diff.axioms(2)
tff(fact_3778_rat__uminus__code,axiom,
    ! [P5: rat] : ( quotient_of(aa(rat,rat,uminus_uminus(rat),P5)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aak(int,fun(int,product_prod(int,int)))),quotient_of(P5)) ) ).

% rat_uminus_code
tff(fact_3779_and__not__num_Osimps_I8_J,axiom,
    ! [M2: num,N: num] : ( bit_and_not_num(aa(num,num,bit1,M2),aa(num,num,bit0,N)) = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aal(num,option(num)),bit_and_not_num(M2,N)) ) ).

% and_not_num.simps(8)
tff(fact_3780_rat__abs__code,axiom,
    ! [P5: rat] : ( quotient_of(aa(rat,rat,abs_abs(rat),P5)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aam(int,fun(int,product_prod(int,int)))),quotient_of(P5)) ) ).

% rat_abs_code
tff(fact_3781_rat__less__code,axiom,
    ! [P5: rat,Q3: rat] :
      ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),P5),Q3))
    <=> pp(aa(product_prod(int,int),bool,aa(fun(int,fun(int,bool)),fun(product_prod(int,int),bool),product_case_prod(int,int,bool),aTP_Lamp_aao(rat,fun(int,fun(int,bool)),Q3)),quotient_of(P5))) ) ).

% rat_less_code
tff(fact_3782_rat__less__eq__code,axiom,
    ! [P5: rat,Q3: rat] :
      ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),P5),Q3))
    <=> pp(aa(product_prod(int,int),bool,aa(fun(int,fun(int,bool)),fun(product_prod(int,int),bool),product_case_prod(int,int,bool),aTP_Lamp_aaq(rat,fun(int,fun(int,bool)),Q3)),quotient_of(P5))) ) ).

% rat_less_eq_code
tff(fact_3783_rel__of__def,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B)),P: fun(product_prod(A,B),bool)] : ( rel_of(A,B,M2,P) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(fun(product_prod(A,B),bool),fun(A,fun(B,bool)),aTP_Lamp_aar(fun(A,option(B)),fun(fun(product_prod(A,B),bool),fun(A,fun(B,bool))),M2),P))) ) ).

% rel_of_def
tff(fact_3784_map__to__set__upd,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B)),K: A,V: B] : ( map_to_set(A,B,fun_upd(A,option(B),M2,K,aa(B,option(B),some(B),V))) = aa(set(product_prod(A,B)),set(product_prod(A,B)),insert(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V)),aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),map_to_set(A,B,M2)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aTP_Lamp_aas(A,fun(product_prod(A,B),bool),K)))) ) ).

% map_to_set_upd
tff(fact_3785_rat__minus__code,axiom,
    ! [P5: rat,Q3: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),P5),Q3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aau(rat,fun(int,fun(int,product_prod(int,int))),Q3)),quotient_of(P5)) ) ).

% rat_minus_code
tff(fact_3786_rat__plus__code,axiom,
    ! [P5: rat,Q3: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),P5),Q3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aaw(rat,fun(int,fun(int,product_prod(int,int))),Q3)),quotient_of(P5)) ) ).

% rat_plus_code
tff(fact_3787_map__to__set__def,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B))] : ( map_to_set(A,B,M2) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_aax(fun(A,option(B)),fun(A,fun(B,bool)),M2))) ) ).

% map_to_set_def
tff(fact_3788_rat__divide__code,axiom,
    ! [P5: rat,Q3: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),P5),Q3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aaz(rat,fun(int,fun(int,product_prod(int,int))),Q3)),quotient_of(P5)) ) ).

% rat_divide_code
tff(fact_3789_rat__times__code,axiom,
    ! [P5: rat,Q3: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),P5),Q3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_abb(rat,fun(int,fun(int,product_prod(int,int))),Q3)),quotient_of(P5)) ) ).

% rat_times_code
tff(fact_3790_take__bit__num__simps_I6_J,axiom,
    ! [R2: num,M2: num] : ( bit_take_bit_num(aa(num,nat,numeral_numeral(nat),R2),aa(num,num,bit0,M2)) = case_option(option(num),num,none(num),aTP_Lamp_abc(num,option(num)),bit_take_bit_num(pred_numeral(R2),M2)) ) ).

% take_bit_num_simps(6)
tff(fact_3791_take__bit__num__simps_I3_J,axiom,
    ! [N: nat,M2: num] : ( bit_take_bit_num(aa(nat,nat,suc,N),aa(num,num,bit0,M2)) = case_option(option(num),num,none(num),aTP_Lamp_abc(num,option(num)),bit_take_bit_num(N,M2)) ) ).

% take_bit_num_simps(3)
tff(fact_3792_rat__inverse__code,axiom,
    ! [P5: rat] : ( quotient_of(aa(rat,rat,inverse_inverse(rat),P5)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_abd(int,fun(int,product_prod(int,int)))),quotient_of(P5)) ) ).

% rat_inverse_code
tff(fact_3793_normalize__def,axiom,
    ! [P5: product_prod(int,int)] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),P5)))
       => ( normalize(P5) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_fst(int,int),P5)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P5)),aa(product_prod(int,int),int,product_snd(int,int),P5)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_snd(int,int),P5)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P5)),aa(product_prod(int,int),int,product_snd(int,int),P5)))) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),P5)))
       => ( ( ( aa(product_prod(int,int),int,product_snd(int,int),P5) = zero_zero(int) )
           => ( normalize(P5) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)) ) )
          & ( ( aa(product_prod(int,int),int,product_snd(int,int),P5) != zero_zero(int) )
           => ( normalize(P5) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_fst(int,int),P5)),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P5)),aa(product_prod(int,int),int,product_snd(int,int),P5))))),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_snd(int,int),P5)),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P5)),aa(product_prod(int,int),int,product_snd(int,int),P5))))) ) ) ) ) ) ).

% normalize_def
tff(fact_3794_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),one_one(A)),A4) = one_one(A) ) ) ).

% gcd.bottom_left_bottom
tff(fact_3795_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),one_one(A)) = one_one(A) ) ) ).

% gcd.bottom_right_bottom
tff(fact_3796_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A,B3: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A4)),aa(A,A,inverse_inverse(A),B3)) ) ) ).

% inverse_mult_distrib
tff(fact_3797_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A] :
          ( ( aa(A,A,inverse_inverse(A),X2) = one_one(A) )
        <=> ( X2 = one_one(A) ) ) ) ).

% inverse_eq_1_iff
tff(fact_3798_inverse__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),one_one(A)) = one_one(A) ) ) ).

% inverse_1
tff(fact_3799_singleton__None__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ( aa(set(option(A)),option(A),complete_Sup_Sup(option(A)),aa(set(option(A)),set(option(A)),insert(option(A),none(A)),bot_bot(set(option(A))))) = none(A) ) ) ).

% singleton_None_Sup
tff(fact_3800_empty__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ( aa(set(option(A)),option(A),complete_Sup_Sup(option(A)),bot_bot(set(option(A)))) = none(A) ) ) ).

% empty_Sup
tff(fact_3801_inf__None__1,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [Y: option(A)] : ( aa(option(A),option(A),aa(option(A),fun(option(A),option(A)),inf_inf(option(A)),none(A)),Y) = none(A) ) ) ).

% inf_None_1
tff(fact_3802_inf__None__2,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [X2: option(A)] : ( aa(option(A),option(A),aa(option(A),fun(option(A),option(A)),inf_inf(option(A)),X2),none(A)) = none(A) ) ) ).

% inf_None_2
tff(fact_3803_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)),one_one(A)))
        <=> ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) = one_one(A) ) ) ) ).

% is_unit_gcd_iff
tff(fact_3804_map__to__set__empty,axiom,
    ! [B: $tType,A: $tType] : ( map_to_set(A,B,aTP_Lamp_abe(A,option(B))) = bot_bot(set(product_prod(A,B))) ) ).

% map_to_set_empty
tff(fact_3805_left__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A] :
          ( ( A4 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A4)),A4) = one_one(A) ) ) ) ).

% left_inverse
tff(fact_3806_right__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A] :
          ( ( A4 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,inverse_inverse(A),A4)) = one_one(A) ) ) ) ).

% right_inverse
tff(fact_3807_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W2: num] : ( aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),W2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),W2)) ) ) ).

% inverse_eq_divide_numeral
tff(fact_3808_Gcd__2,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: A,B3: A] : ( gcd_Gcd(A,aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) ) ) ).

% Gcd_2
tff(fact_3809_rel__of__empty,axiom,
    ! [B: $tType,A: $tType,P: fun(product_prod(A,B),bool)] : ( rel_of(A,B,aTP_Lamp_abe(A,option(B)),P) = bot_bot(set(product_prod(A,B))) ) ).

% rel_of_empty
tff(fact_3810_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W2: num] : ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) ) ) ).

% inverse_eq_divide_neg_numeral
tff(fact_3811_bot__option__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ( bot_bot(option(A)) = none(A) ) ) ).

% bot_option_def
tff(fact_3812_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Y: A,X2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),Y),X2) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),Y)),X2) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(A,A,inverse_inverse(A),Y)) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
tff(fact_3813_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( ( B3 != zero_zero(A) )
           => ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B3)),aa(A,A,inverse_inverse(A),A4)) ) ) ) ) ).

% nonzero_inverse_mult_distrib
tff(fact_3814_inverse__unique,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3) = one_one(A) )
         => ( aa(A,A,inverse_inverse(A),A4) = B3 ) ) ) ).

% inverse_unique
tff(fact_3815_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M2: A,K: A,N: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),K),M2)),N)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M2),N) ) ) ).

% gcd_add_mult
tff(fact_3816_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B3)),A4) ) ) ).

% divide_inverse_commute
tff(fact_3817_divide__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,inverse_inverse(A),B3)) ) ) ).

% divide_inverse
tff(fact_3818_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,inverse_inverse(A),B3)) ) ) ).

% field_class.field_divide_inverse
tff(fact_3819_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A] : ( aa(A,A,inverse_inverse(A),A4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4) ) ) ).

% inverse_eq_divide
tff(fact_3820_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,K: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),K),B3))) ) ).

% gcd_dvd_prod
tff(fact_3821_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,M2: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),M2)),aa(A,A,inverse_inverse(A),X2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),X2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),M2)) ) ) ).

% power_mult_inverse_distrib
tff(fact_3822_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,M2: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),M2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),X2)),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),X2)),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),M2)) ) ) ).

% power_mult_power_inverse_commute
tff(fact_3823_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: nat,X2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa))),X2) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa))) ) ) ).

% mult_inverse_of_nat_commute
tff(fact_3824_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: int,X2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(int,A,ring_1_of_int(A),Xa))),X2) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(A,A,inverse_inverse(A),aa(int,A,ring_1_of_int(A),Xa))) ) ) ).

% mult_inverse_of_int_commute
tff(fact_3825_map__to__set__empty__iff_I1_J,axiom,
    ! [A: $tType,B: $tType,M2: fun(A,option(B))] :
      ( ( map_to_set(A,B,M2) = bot_bot(set(product_prod(A,B))) )
    <=> ! [X3: A] : ( aa(A,option(B),M2,X3) = none(B) ) ) ).

% map_to_set_empty_iff(1)
tff(fact_3826_map__to__set__empty__iff_I2_J,axiom,
    ! [A: $tType,B: $tType,M2: fun(A,option(B))] :
      ( ( bot_bot(set(product_prod(A,B))) = map_to_set(A,B,M2) )
    <=> ! [X3: A] : ( aa(A,option(B),M2,X3) = none(B) ) ) ).

% map_to_set_empty_iff(2)
tff(fact_3827_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),X2)),one_one(A)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),zero_zero(A)))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X2)) ) ) ) ).

% inverse_le_1_iff
tff(fact_3828_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),X2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),one_one(A))) ) ) ) ).

% one_less_inverse_iff
tff(fact_3829_one__less__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),A4))) ) ) ) ).

% one_less_inverse
tff(fact_3830_inverse__add,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( ( B3 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A4)),aa(A,A,inverse_inverse(A),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3)),aa(A,A,inverse_inverse(A),A4))),aa(A,A,inverse_inverse(A),B3)) ) ) ) ) ).

% inverse_add
tff(fact_3831_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( ( B3 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A4)),aa(A,A,inverse_inverse(A),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A4)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B3))),aa(A,A,inverse_inverse(A),B3)) ) ) ) ) ).

% division_ring_inverse_add
tff(fact_3832_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: A] :
          ( ( A4 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A4)),A4) = one_one(A) ) ) ) ).

% field_class.field_inverse
tff(fact_3833_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( ( B3 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,inverse_inverse(A),A4)),aa(A,A,inverse_inverse(A),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A4)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B3),A4))),aa(A,A,inverse_inverse(A),B3)) ) ) ) ) ).

% division_ring_inverse_diff
tff(fact_3834_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: A] :
          ( ( A4 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),A4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A4) ) ) ) ).

% nonzero_inverse_eq_divide
tff(fact_3835_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B3),C2) ) ) ) ).

% gcd_mult_unit1
tff(fact_3836_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B3),C2) ) ) ) ).

% gcd_mult_unit2
tff(fact_3837_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B3),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A4)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B3),C2) ) ) ) ).

% gcd_div_unit2
tff(fact_3838_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B3),C2) ) ) ) ).

% gcd_div_unit1
tff(fact_3839_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),A4)),aa(A,A,inverse_inverse(A),B3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3)) ) ) ) ) ).

% inverse_less_iff
tff(fact_3840_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),A4)),aa(A,A,inverse_inverse(A),B3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3)) ) ) ) ) ).

% inverse_le_iff
tff(fact_3841_one__le__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),A4))) ) ) ) ).

% one_le_inverse
tff(fact_3842_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),X2)),one_one(A)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),zero_zero(A)))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X2)) ) ) ) ).

% inverse_less_1_iff
tff(fact_3843_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),X2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),one_one(A))) ) ) ) ).

% one_le_inverse_iff
tff(fact_3844_gcd__is__Max__divisors__int,axiom,
    ! [N: int,M2: int] :
      ( ( N != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M2),N) = aa(set(int),int,lattic643756798349783984er_Max(int),aa(fun(int,bool),set(int),collect(int),aa(int,fun(int,bool),aTP_Lamp_abf(int,fun(int,fun(int,bool)),N),M2))) ) ) ).

% gcd_is_Max_divisors_int
tff(fact_3845_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,M2: nat,N: nat] :
          ( ( X2 != zero_zero(A) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),X2)),M2)) ) ) ) ) ).

% power_diff_conv_inverse
tff(fact_3846_inf__option__def,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [X2: option(A),Y: option(A)] : ( aa(option(A),option(A),aa(option(A),fun(option(A),option(A)),inf_inf(option(A)),X2),Y) = case_option(option(A),A,none(A),aTP_Lamp_abh(option(A),fun(A,option(A)),Y),X2) ) ) ).

% inf_option_def
tff(fact_3847_empty__upd__none,axiom,
    ! [A: $tType,B: $tType,X2: A,X4: A] : ( aa(A,option(B),fun_upd(A,option(B),aTP_Lamp_abe(A,option(B)),X2,none(B)),X4) = none(B) ) ).

% empty_upd_none
tff(fact_3848_take__bit__num__code,axiom,
    ! [N: nat,M2: num] : ( bit_take_bit_num(N,M2) = aa(product_prod(nat,num),option(num),aa(fun(nat,fun(num,option(num))),fun(product_prod(nat,num),option(num)),product_case_prod(nat,num,option(num)),aTP_Lamp_abl(nat,fun(num,option(num)))),aa(num,product_prod(nat,num),aa(nat,fun(num,product_prod(nat,num)),product_Pair(nat,num),N),M2)) ) ).

% take_bit_num_code
tff(fact_3849_case__optionE,axiom,
    ! [A: $tType,P: bool,Q: fun(A,bool),X2: option(A)] :
      ( pp(case_option(bool,A,P,Q,X2))
     => ( ( ( X2 = none(A) )
         => ~ pp(P) )
       => ~ ! [Y2: A] :
              ( ( X2 = aa(A,option(A),some(A),Y2) )
             => ~ pp(aa(A,bool,Q,Y2)) ) ) ) ).

% case_optionE
tff(fact_3850_option_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,Option: option(A)] :
      ( ( Option != none(A) )
    <=> pp(case_option(bool,A,fFalse,aTP_Lamp_nn(A,bool),Option)) ) ).

% option.disc_eq_case(2)
tff(fact_3851_num_Ocase__distrib,axiom,
    ! [A: $tType,B: $tType,H2: fun(A,B),F1: A,F22: fun(num,A),F33: fun(num,A),Num: num] : ( aa(A,B,H2,case_num(A,F1,F22,F33,Num)) = case_num(B,aa(A,B,H2,F1),aa(fun(num,A),fun(num,B),aTP_Lamp_abm(fun(A,B),fun(fun(num,A),fun(num,B)),H2),F22),aa(fun(num,A),fun(num,B),aTP_Lamp_abm(fun(A,B),fun(fun(num,A),fun(num,B)),H2),F33),Num) ) ).

% num.case_distrib
tff(fact_3852_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,gcd_gcd(nat),zero_zero(nat),dvd_dvd(nat),aTP_Lamp_abn(nat,fun(nat,bool))) ).

% gcd_nat.semilattice_neutr_order_axioms
tff(fact_3853_Gcd__in,axiom,
    ! [A3: set(nat)] :
      ( ! [A5: nat,B4: nat] :
          ( pp(aa(set(nat),bool,member(nat,A5),A3))
         => ( pp(aa(set(nat),bool,member(nat,B4),A3))
           => pp(aa(set(nat),bool,member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A5),B4)),A3)) ) )
     => ( ( A3 != bot_bot(set(nat)) )
       => pp(aa(set(nat),bool,member(nat,gcd_Gcd(nat,A3)),A3)) ) ) ).

% Gcd_in
tff(fact_3854_gcd__is__Max__divisors__nat,axiom,
    ! [N: nat,M2: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M2),N) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_abo(nat,fun(nat,fun(nat,bool)),N),M2))) ) ) ).

% gcd_is_Max_divisors_nat
tff(fact_3855_option_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H2: fun(B,C),F1: B,F22: fun(A,B),Option: option(A)] : ( aa(B,C,H2,case_option(B,A,F1,F22,Option)) = case_option(C,A,aa(B,C,H2,F1),aa(fun(A,B),fun(A,C),aTP_Lamp_abp(fun(B,C),fun(fun(A,B),fun(A,C)),H2),F22),Option) ) ).

% option.case_distrib
tff(fact_3856_option_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,Option: option(A)] :
      ( ( Option = none(A) )
    <=> pp(case_option(bool,A,fTrue,aTP_Lamp_ao(A,bool),Option)) ) ).

% option.disc_eq_case(1)
tff(fact_3857_Sup__option__def,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(option(A))] :
          ( ( ( ( A3 = bot_bot(set(option(A))) )
              | ( A3 = aa(set(option(A)),set(option(A)),insert(option(A),none(A)),bot_bot(set(option(A)))) ) )
           => ( aa(set(option(A)),option(A),complete_Sup_Sup(option(A)),A3) = none(A) ) )
          & ( ~ ( ( A3 = bot_bot(set(option(A))) )
                | ( A3 = aa(set(option(A)),set(option(A)),insert(option(A),none(A)),bot_bot(set(option(A)))) ) )
           => ( aa(set(option(A)),option(A),complete_Sup_Sup(option(A)),A3) = aa(A,option(A),some(A),aa(set(A),A,complete_Sup_Sup(A),these(A,A3))) ) ) ) ) ).

% Sup_option_def
tff(fact_3858_plus__rat_Otransfer,axiom,
    pp(aa(fun(rat,fun(rat,rat)),bool,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(rat,fun(rat,rat)),bool),bNF_rel_fun(product_prod(int,int),rat,fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),pcr_rat,bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat)),aTP_Lamp_abq(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),plus_plus(rat))) ).

% plus_rat.transfer
tff(fact_3859_inverse__rat_Otransfer,axiom,
    pp(aa(fun(rat,rat),bool,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(rat,rat),bool),bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat),aTP_Lamp_abr(product_prod(int,int),product_prod(int,int))),inverse_inverse(rat))) ).

% inverse_rat.transfer
tff(fact_3860_these__not__empty__eq,axiom,
    ! [A: $tType,B2: set(option(A))] :
      ( ( these(A,B2) != bot_bot(set(A)) )
    <=> ( ( B2 != bot_bot(set(option(A))) )
        & ( B2 != aa(set(option(A)),set(option(A)),insert(option(A),none(A)),bot_bot(set(option(A)))) ) ) ) ).

% these_not_empty_eq
tff(fact_3861_these__empty,axiom,
    ! [A: $tType] : ( these(A,bot_bot(set(option(A)))) = bot_bot(set(A)) ) ).

% these_empty
tff(fact_3862_Some__image__these__eq,axiom,
    ! [A: $tType,A3: set(option(A))] : ( aa(set(A),set(option(A)),image2(A,option(A),some(A)),these(A,A3)) = aa(fun(option(A),bool),set(option(A)),collect(option(A)),aTP_Lamp_abs(set(option(A)),fun(option(A),bool),A3)) ) ).

% Some_image_these_eq
tff(fact_3863_uminus__rat_Otransfer,axiom,
    pp(aa(fun(rat,rat),bool,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(rat,rat),bool),bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat),aTP_Lamp_abt(product_prod(int,int),product_prod(int,int))),uminus_uminus(rat))) ).

% uminus_rat.transfer
tff(fact_3864_times__rat_Otransfer,axiom,
    pp(aa(fun(rat,fun(rat,rat)),bool,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(rat,fun(rat,rat)),bool),bNF_rel_fun(product_prod(int,int),rat,fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),pcr_rat,bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat)),aTP_Lamp_abu(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),times_times(rat))) ).

% times_rat.transfer
tff(fact_3865_these__empty__eq,axiom,
    ! [A: $tType,B2: set(option(A))] :
      ( ( these(A,B2) = bot_bot(set(A)) )
    <=> ( ( B2 = bot_bot(set(option(A))) )
        | ( B2 = aa(set(option(A)),set(option(A)),insert(option(A),none(A)),bot_bot(set(option(A)))) ) ) ) ).

% these_empty_eq
tff(fact_3866_positive_Otransfer,axiom,
    pp(aa(fun(rat,bool),bool,aa(fun(product_prod(int,int),bool),fun(fun(rat,bool),bool),bNF_rel_fun(product_prod(int,int),rat,bool,bool,pcr_rat,fequal(bool)),aTP_Lamp_abv(product_prod(int,int),bool)),positive)) ).

% positive.transfer
tff(fact_3867_and__not__num_Oelims,axiom,
    ! [X2: num,Xa: num,Y: option(num)] :
      ( ( bit_and_not_num(X2,Xa) = Y )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y != none(num) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N2: num] : ( Xa = aa(num,num,bit0,N2) )
             => ( Y != aa(num,option(num),some(num),one2) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N2: num] : ( Xa = aa(num,num,bit1,N2) )
               => ( Y != none(num) ) ) )
           => ( ! [M3: num] :
                  ( ( X2 = aa(num,num,bit0,M3) )
                 => ( ( Xa = one2 )
                   => ( Y != aa(num,option(num),some(num),aa(num,num,bit0,M3)) ) ) )
             => ( ! [M3: num] :
                    ( ( X2 = aa(num,num,bit0,M3) )
                   => ! [N2: num] :
                        ( ( Xa = aa(num,num,bit0,N2) )
                       => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) ) ) )
               => ( ! [M3: num] :
                      ( ( X2 = aa(num,num,bit0,M3) )
                     => ! [N2: num] :
                          ( ( Xa = aa(num,num,bit1,N2) )
                         => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2 = aa(num,num,bit1,M3) )
                       => ( ( Xa = one2 )
                         => ( Y != aa(num,option(num),some(num),aa(num,num,bit0,M3)) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2 = aa(num,num,bit1,M3) )
                         => ! [N2: num] :
                              ( ( Xa = aa(num,num,bit0,N2) )
                             => ( Y != case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aal(num,option(num)),bit_and_not_num(M3,N2)) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X2 = aa(num,num,bit1,M3) )
                           => ! [N2: num] :
                                ( ( Xa = aa(num,num,bit1,N2) )
                               => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
tff(fact_3868_of__rat_Otransfer,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => pp(aa(fun(rat,A),bool,aa(fun(product_prod(int,int),A),fun(fun(rat,A),bool),bNF_rel_fun(product_prod(int,int),rat,A,A,pcr_rat,fequal(A)),aTP_Lamp_abw(product_prod(int,int),A)),field_char_0_of_rat(A))) ) ).

% of_rat.transfer
tff(fact_3869_restrict__upd__same,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B)),X2: A,Y: B] : ( restrict_map(A,B,fun_upd(A,option(B),M2,X2,aa(B,option(B),some(B),Y)),aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))) = restrict_map(A,B,M2,aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))) ) ).

% restrict_upd_same
tff(fact_3870_of__rat__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( aa(rat,A,field_char_0_of_rat(A),one_one(rat)) = one_one(A) ) ) ).

% of_rat_1
tff(fact_3871_of__rat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: rat] :
          ( ( aa(rat,A,field_char_0_of_rat(A),A4) = one_one(A) )
        <=> ( A4 = one_one(rat) ) ) ) ).

% of_rat_eq_1_iff
tff(fact_3872_one__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: rat] :
          ( ( one_one(A) = aa(rat,A,field_char_0_of_rat(A),A4) )
        <=> ( one_one(rat) = A4 ) ) ) ).

% one_eq_of_rat_iff
tff(fact_3873_restrict__restrict,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B)),A3: set(A),B2: set(A)] : ( restrict_map(A,B,restrict_map(A,B,M2,A3),B2) = restrict_map(A,B,M2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) ) ).

% restrict_restrict
tff(fact_3874_map__option__o__empty,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: fun(C,B),X4: A] : ( aa(A,option(B),aa(fun(A,option(C)),fun(A,option(B)),comp(option(C),option(B),A,map_option(C,B,F2)),aTP_Lamp_abx(A,option(C))),X4) = none(B) ) ).

% map_option_o_empty
tff(fact_3875_restrict__map__empty,axiom,
    ! [A: $tType,B: $tType,D2: set(A),X4: A] : ( aa(A,option(B),restrict_map(A,B,aTP_Lamp_abe(A,option(B)),D2),X4) = none(B) ) ).

% restrict_map_empty
tff(fact_3876_restrict__map__to__empty,axiom,
    ! [A: $tType,B: $tType,M2: fun(A,option(B)),X4: A] : ( aa(A,option(B),restrict_map(A,B,M2,bot_bot(set(A))),X4) = none(B) ) ).

% restrict_map_to_empty
tff(fact_3877_of__rat__neg__one,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( aa(rat,A,field_char_0_of_rat(A),aa(rat,rat,uminus_uminus(rat),one_one(rat))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% of_rat_neg_one
tff(fact_3878_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(rat,A,field_char_0_of_rat(A),R2)))
        <=> pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),one_one(rat)),R2)) ) ) ).

% one_less_of_rat_iff
tff(fact_3879_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(rat,A,field_char_0_of_rat(A),R2)),one_one(A)))
        <=> pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),R2),one_one(rat))) ) ) ).

% of_rat_less_1_iff
tff(fact_3880_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(rat,A,field_char_0_of_rat(A),R2)),one_one(A)))
        <=> pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),R2),one_one(rat))) ) ) ).

% of_rat_le_1_iff
tff(fact_3881_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(rat,A,field_char_0_of_rat(A),R2)))
        <=> pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),one_one(rat)),R2)) ) ) ).

% one_le_of_rat_iff
tff(fact_3882_fun__upd__restrict__conv,axiom,
    ! [A: $tType,B: $tType,X2: A,D2: set(A),M2: fun(A,option(B)),Y: option(B)] :
      ( pp(aa(set(A),bool,member(A,X2),D2))
     => ( fun_upd(A,option(B),restrict_map(A,B,M2,D2),X2,Y) = fun_upd(A,option(B),restrict_map(A,B,M2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),X2,Y) ) ) ).

% fun_upd_restrict_conv
tff(fact_3883_restrict__fun__upd,axiom,
    ! [B: $tType,A: $tType,X2: A,D2: set(A),M2: fun(A,option(B)),Y: option(B)] :
      ( ( pp(aa(set(A),bool,member(A,X2),D2))
       => ( restrict_map(A,B,fun_upd(A,option(B),M2,X2,Y),D2) = fun_upd(A,option(B),restrict_map(A,B,M2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),X2,Y) ) )
      & ( ~ pp(aa(set(A),bool,member(A,X2),D2))
       => ( restrict_map(A,B,fun_upd(A,option(B),M2,X2,Y),D2) = restrict_map(A,B,M2,D2) ) ) ) ).

% restrict_fun_upd
tff(fact_3884_fun__upd__None__restrict,axiom,
    ! [B: $tType,A: $tType,X2: A,D2: set(A),M2: fun(A,option(B))] :
      ( ( pp(aa(set(A),bool,member(A,X2),D2))
       => ( fun_upd(A,option(B),restrict_map(A,B,M2,D2),X2,none(B)) = restrict_map(A,B,M2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))) ) )
      & ( ~ pp(aa(set(A),bool,member(A,X2),D2))
       => ( fun_upd(A,option(B),restrict_map(A,B,M2,D2),X2,none(B)) = restrict_map(A,B,M2,D2) ) ) ) ).

% fun_upd_None_restrict
tff(fact_3885_option_Omap__ident,axiom,
    ! [A: $tType,T3: option(A)] : ( aa(option(A),option(A),map_option(A,A,aTP_Lamp_bk(A,A)),T3) = T3 ) ).

% option.map_ident
tff(fact_3886_map__option_Oidentity,axiom,
    ! [A: $tType] : ( map_option(A,A,aTP_Lamp_bk(A,A)) = id(option(A)) ) ).

% map_option.identity
tff(fact_3887_of__rat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( field_char_0(A)
     => ! [F2: fun(B,rat),A3: set(B)] : ( aa(rat,A,field_char_0_of_rat(A),aa(set(B),rat,aa(fun(B,rat),fun(set(B),rat),groups7311177749621191930dd_sum(B,rat),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_aby(fun(B,rat),fun(B,A),F2)),A3) ) ) ).

% of_rat_sum
tff(fact_3888_of__rat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( field_char_0(A)
     => ! [F2: fun(B,rat),A3: set(B)] : ( aa(rat,A,field_char_0_of_rat(A),aa(set(B),rat,aa(fun(B,rat),fun(set(B),rat),groups7121269368397514597t_prod(B,rat),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_aby(fun(B,rat),fun(B,A),F2)),A3) ) ) ).

% of_rat_prod
tff(fact_3889_of__rat__mult,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A4: rat,B3: rat] : ( aa(rat,A,field_char_0_of_rat(A),aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(rat,A,field_char_0_of_rat(A),A4)),aa(rat,A,field_char_0_of_rat(A),B3)) ) ) ).

% of_rat_mult
tff(fact_3890_map__option__case,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Y: option(B)] : ( aa(option(B),option(A),map_option(B,A,F2),Y) = case_option(option(A),B,none(A),aTP_Lamp_abz(fun(B,A),fun(B,option(A)),F2),Y) ) ).

% map_option_case
tff(fact_3891_fun__upd__restrict,axiom,
    ! [A: $tType,B: $tType,M2: fun(A,option(B)),D2: set(A),X2: A,Y: option(B)] : ( fun_upd(A,option(B),restrict_map(A,B,M2,D2),X2,Y) = fun_upd(A,option(B),restrict_map(A,B,M2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),X2,Y) ) ).

% fun_upd_restrict
tff(fact_3892_restrict__complement__singleton__eq,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,option(B)),X2: A] : ( restrict_map(A,B,F2,aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))) = fun_upd(A,option(B),F2,X2,none(B)) ) ).

% restrict_complement_singleton_eq
tff(fact_3893_map__upd__eq__restrict,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B)),X2: A] : ( fun_upd(A,option(B),M2,X2,none(B)) = restrict_map(A,B,M2,aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))) ) ).

% map_upd_eq_restrict
tff(fact_3894_positive__def,axiom,
    positive = aa(fun(product_prod(int,int),bool),fun(rat,bool),map_fun(rat,product_prod(int,int),bool,bool,rep_Rat,id(bool)),aTP_Lamp_abv(product_prod(int,int),bool)) ).

% positive_def
tff(fact_3895_and__num_Oelims,axiom,
    ! [X2: num,Xa: num,Y: option(num)] :
      ( ( bit_un7362597486090784418nd_num(X2,Xa) = Y )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y != aa(num,option(num),some(num),one2) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N2: num] : ( Xa = aa(num,num,bit0,N2) )
             => ( Y != none(num) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N2: num] : ( Xa = aa(num,num,bit1,N2) )
               => ( Y != aa(num,option(num),some(num),one2) ) ) )
           => ( ( ? [M3: num] : ( X2 = aa(num,num,bit0,M3) )
               => ( ( Xa = one2 )
                 => ( Y != none(num) ) ) )
             => ( ! [M3: num] :
                    ( ( X2 = aa(num,num,bit0,M3) )
                   => ! [N2: num] :
                        ( ( Xa = aa(num,num,bit0,N2) )
                       => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) ) ) )
               => ( ! [M3: num] :
                      ( ( X2 = aa(num,num,bit0,M3) )
                     => ! [N2: num] :
                          ( ( Xa = aa(num,num,bit1,N2) )
                         => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) ) ) )
                 => ( ( ? [M3: num] : ( X2 = aa(num,num,bit1,M3) )
                     => ( ( Xa = one2 )
                       => ( Y != aa(num,option(num),some(num),one2) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2 = aa(num,num,bit1,M3) )
                         => ! [N2: num] :
                              ( ( Xa = aa(num,num,bit0,N2) )
                             => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X2 = aa(num,num,bit1,M3) )
                           => ! [N2: num] :
                                ( ( Xa = aa(num,num,bit1,N2) )
                               => ( Y != case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aal(num,option(num)),bit_un7362597486090784418nd_num(M3,N2)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
tff(fact_3896_of__rat__def,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( field_char_0_of_rat(A) = aa(fun(product_prod(int,int),A),fun(rat,A),map_fun(rat,product_prod(int,int),A,A,rep_Rat,id(A)),aTP_Lamp_abw(product_prod(int,int),A)) ) ) ).

% of_rat_def
tff(fact_3897_Min_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : ( aa(set(A),A,lattic643756798350308766er_Min(A),A3) = aa(option(A),A,the2(A),finite_fold(A,option(A),aTP_Lamp_aca(A,fun(option(A),option(A))),none(A),A3)) ) ) ).

% Min.eq_fold'
tff(fact_3898_Option_Othese__def,axiom,
    ! [A: $tType,A3: set(option(A))] : ( these(A,A3) = aa(set(option(A)),set(A),image2(option(A),A,the2(A)),aa(fun(option(A),bool),set(option(A)),collect(option(A)),aTP_Lamp_abs(set(option(A)),fun(option(A),bool),A3))) ) ).

% Option.these_def
tff(fact_3899_numeral__and__num,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M2: num,N: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),M2)),aa(num,A,numeral_numeral(A),N)) = case_option(A,num,zero_zero(A),numeral_numeral(A),bit_un7362597486090784418nd_num(M2,N)) ) ) ).

% numeral_and_num
tff(fact_3900_and__num_Osimps_I9_J,axiom,
    ! [M2: num,N: num] : ( bit_un7362597486090784418nd_num(aa(num,num,bit1,M2),aa(num,num,bit1,N)) = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aal(num,option(num)),bit_un7362597486090784418nd_num(M2,N)) ) ).

% and_num.simps(9)
tff(fact_3901_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A)] : ( aa(set(A),A,lattic7752659483105999362nf_fin(A),A3) = aa(option(A),A,the2(A),finite_fold(A,option(A),aTP_Lamp_acb(A,fun(option(A),option(A))),none(A),A3)) ) ) ).

% Inf_fin.eq_fold'
tff(fact_3902_Sup__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A)] : ( lattic5882676163264333800up_fin(A,A3) = aa(option(A),A,the2(A),finite_fold(A,option(A),aTP_Lamp_acc(A,fun(option(A),option(A))),none(A),A3)) ) ) ).

% Sup_fin.eq_fold'
tff(fact_3903_plus__rat__def,axiom,
    plus_plus(rat) = aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(rat,fun(rat,rat)),map_fun(rat,product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),rep_Rat,map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat)),aTP_Lamp_abq(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% plus_rat_def
tff(fact_3904_inverse__rat__def,axiom,
    inverse_inverse(rat) = aa(fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat),aTP_Lamp_abr(product_prod(int,int),product_prod(int,int))) ).

% inverse_rat_def
tff(fact_3905_times__rat__def,axiom,
    times_times(rat) = aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(rat,fun(rat,rat)),map_fun(rat,product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),rep_Rat,map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat)),aTP_Lamp_abu(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% times_rat_def
tff(fact_3906_uminus__rat__def,axiom,
    uminus_uminus(rat) = aa(fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat),aTP_Lamp_abt(product_prod(int,int),product_prod(int,int))) ).

% uminus_rat_def
tff(fact_3907_Max_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : ( aa(set(A),A,lattic643756798349783984er_Max(A),A3) = aa(option(A),A,the2(A),finite_fold(A,option(A),aTP_Lamp_acd(A,fun(option(A),option(A))),none(A),A3)) ) ) ).

% Max.eq_fold'
tff(fact_3908_Gcd__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( ( pp(aa(set(A),bool,finite_finite2(A),A3))
           => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = finite_fold(A,A,gcd_gcd(A),zero_zero(A),A3) ) )
          & ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
           => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = one_one(A) ) ) ) ) ).

% Gcd_fin.eq_fold
tff(fact_3909_plus__rat_Orsp,axiom,
    pp(aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),bool,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(product_prod(int,int),product_prod(int,int)),ratrel,bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel)),aTP_Lamp_abq(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),aTP_Lamp_abq(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))))) ).

% plus_rat.rsp
tff(fact_3910_inverse__rat_Orsp,axiom,
    pp(aa(fun(product_prod(int,int),product_prod(int,int)),bool,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(product_prod(int,int),product_prod(int,int)),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel),aTP_Lamp_abr(product_prod(int,int),product_prod(int,int))),aTP_Lamp_abr(product_prod(int,int),product_prod(int,int)))) ).

% inverse_rat.rsp
tff(fact_3911_max_Oidem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),A4) = A4 ) ) ).

% max.idem
tff(fact_3912_max_Oleft__idem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) ) ) ).

% max.left_idem
tff(fact_3913_max_Oright__idem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3)),B3) = aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) ) ) ).

% max.right_idem
tff(fact_3914_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) = A4 ) ) ) ).

% max.absorb1
tff(fact_3915_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) = B3 ) ) ) ).

% max.absorb2
tff(fact_3916_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B3),C2)),A4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A4)) ) ) ) ).

% max.bounded_iff
tff(fact_3917_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y)),Z2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),Z2)) ) ) ) ).

% max_less_iff_conj
tff(fact_3918_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),B3))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) = B3 ) ) ) ).

% max.absorb4
tff(fact_3919_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) = A4 ) ) ) ).

% max.absorb3
tff(fact_3920_max__bot2,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),X2),bot_bot(A)) = X2 ) ) ).

% max_bot2
tff(fact_3921_max__bot,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),bot_bot(A)),X2) = X2 ) ) ).

% max_bot
tff(fact_3922_max__top,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),top_top(A)),X2) = top_top(A) ) ) ).

% max_top
tff(fact_3923_max__top2,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),X2),top_top(A)) = top_top(A) ) ) ).

% max_top2
tff(fact_3924_max__min__same_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),X2),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)) = X2 ) ) ).

% max_min_same(1)
tff(fact_3925_max__min__same_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)),X2) = X2 ) ) ).

% max_min_same(2)
tff(fact_3926_max__min__same_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)),Y) = Y ) ) ).

% max_min_same(3)
tff(fact_3927_max__min__same_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y: A,X2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),Y),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)) = Y ) ) ).

% max_min_same(4)
tff(fact_3928_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool,Q: bool] : ( aa(bool,A,zero_neq_one_of_bool(A),fdisj(P,Q)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(bool,A,zero_neq_one_of_bool(A),P)),aa(bool,A,zero_neq_one_of_bool(A),Q)) ) ) ).

% of_bool_or_iff
tff(fact_3929_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),zero_zero(A)),one_one(A)) = one_one(A) ) ) ).

% max_0_1(1)
tff(fact_3930_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),zero_zero(A)) = one_one(A) ) ) ).

% max_0_1(2)
tff(fact_3931_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),X2)),one_one(A)) = aa(num,A,numeral_numeral(A),X2) ) ) ).

% max_0_1(6)
tff(fact_3932_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),aa(num,A,numeral_numeral(A),X2)) = aa(num,A,numeral_numeral(A),X2) ) ) ).

% max_0_1(5)
tff(fact_3933_Gcd__fin_Oempty,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),bot_bot(set(A))) = zero_zero(A) ) ) ).

% Gcd_fin.empty
tff(fact_3934_Gcd__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = one_one(A) ) ) ) ).

% Gcd_fin.infinite
tff(fact_3935_is__unit__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)),one_one(A)))
        <=> ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = one_one(A) ) ) ) ).

% is_unit_Gcd_fin_iff
tff(fact_3936_Int__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A,D3: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,A4,B3)),set_or1337092689740270186AtMost(A,C2,D3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A4),C2),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),D3)) ) ) ).

% Int_atLeastAtMost
tff(fact_3937_Int__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A,D3: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or7035219750837199246ssThan(A,A4,B3)),set_or7035219750837199246ssThan(A,C2,D3)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A4),C2),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),D3)) ) ) ).

% Int_atLeastLessThan
tff(fact_3938_Int__atLeastAtMostR2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,C2: A,D3: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_atLeast(A),A4)),set_or1337092689740270186AtMost(A,C2,D3)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A4),C2),D3) ) ) ).

% Int_atLeastAtMostR2
tff(fact_3939_Int__atLeastAtMostL2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,A4,B3)),aa(A,set(A),set_ord_atLeast(A),C2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A4),C2),B3) ) ) ).

% Int_atLeastAtMostL2
tff(fact_3940_Max__insert,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),ord_max(A),X2),aa(set(A),A,lattic643756798349783984er_Max(A),A3)) ) ) ) ) ).

% Max_insert
tff(fact_3941_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y)),Z2) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Z2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y),Z2)) ) ) ).

% max_add_distrib_left
tff(fact_3942_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),ord_max(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Z2)) ) ) ).

% max_add_distrib_right
tff(fact_3943_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [X2: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y)),Z2) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Z2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z2)) ) ) ).

% max_diff_distrib_left
tff(fact_3944_sup__max,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup(A)
        & linorder(A) )
     => ( sup_sup(A) = ord_max(A) ) ) ).

% sup_max
tff(fact_3945_max__def__raw,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X4: A,Xa3: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Xa3))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),X4),Xa3) = Xa3 ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Xa3))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),X4),Xa3) = X4 ) ) ) ) ).

% max_def_raw
tff(fact_3946_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),X2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),Y)) ) ) ) ).

% less_max_iff_disj
tff(fact_3947_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B3),C2)),A4))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A4)) ) ) ) ).

% max.strict_boundedE
tff(fact_3948_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B3),A4))
        <=> ( ( A4 = aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) )
            & ( A4 != B3 ) ) ) ) ).

% max.strict_order_iff
tff(fact_3949_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3))) ) ) ).

% max.strict_coboundedI1
tff(fact_3950_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3))) ) ) ).

% max.strict_coboundedI2
tff(fact_3951_max__absorb2,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y) = Y ) ) ) ).

% max_absorb2
tff(fact_3952_max__absorb1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y) = X2 ) ) ) ).

% max_absorb1
tff(fact_3953_max__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A4: A,B3: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) = B3 ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) = A4 ) ) ) ) ).

% max_def
tff(fact_3954_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3))) ) ) ).

% max.coboundedI2
tff(fact_3955_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A4))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3))) ) ) ).

% max.coboundedI1
tff(fact_3956_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),B3))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) = B3 ) ) ) ).

% max.absorb_iff2
tff(fact_3957_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) = A4 ) ) ) ).

% max.absorb_iff1
tff(fact_3958_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z2: A,X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),X2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),Y)) ) ) ) ).

% le_max_iff_disj
tff(fact_3959_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3))) ) ).

% max.cobounded2
tff(fact_3960_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3))) ) ).

% max.cobounded1
tff(fact_3961_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
        <=> ( A4 = aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) ) ) ) ).

% max.order_iff
tff(fact_3962_max_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B3),C2)),A4)) ) ) ) ).

% max.boundedI
tff(fact_3963_max_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,C2: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B3),C2)),A4))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A4)) ) ) ) ).

% max.boundedE
tff(fact_3964_max_OorderI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ).

% max.orderI
tff(fact_3965_max_OorderE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
         => ( A4 = aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) ) ) ) ).

% max.orderE
tff(fact_3966_max_Omono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A4: A,D3: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D3),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),C2),D3)),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3))) ) ) ) ).

% max.mono
tff(fact_3967_max__min__distrib1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,C2: A,A4: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),C2)),A4) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B3),A4)),aa(A,A,aa(A,fun(A,A),ord_max(A),C2),A4)) ) ) ).

% max_min_distrib1
tff(fact_3968_max__min__distrib2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3)),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),C2)) ) ) ).

% max_min_distrib2
tff(fact_3969_min__max__distrib1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,C2: A,A4: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B3),C2)),A4) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),A4)),aa(A,A,aa(A,fun(A,A),ord_min(A),C2),A4)) ) ) ).

% min_max_distrib1
tff(fact_3970_min__max__distrib2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),A4),aa(A,A,aa(A,fun(A,A),ord_max(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),B3)),aa(A,A,aa(A,fun(A,A),ord_min(A),A4),C2)) ) ) ).

% min_max_distrib2
tff(fact_3971_max__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F2: fun(A,B),M2: A,N: A] :
          ( order_mono(A,B,F2)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(A,B,F2,M2)),aa(A,B,F2,N)) = aa(A,B,F2,aa(A,A,aa(A,fun(A,A),ord_max(A),M2),N)) ) ) ) ).

% max_of_mono
tff(fact_3972_max_Oassoc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),ord_max(A),A4),aa(A,A,aa(A,fun(A,A),ord_max(A),B3),C2)) ) ) ).

% max.assoc
tff(fact_3973_max_Ocommute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3) = aa(A,A,aa(A,fun(A,A),ord_max(A),B3),A4) ) ) ).

% max.commute
tff(fact_3974_max_Oleft__commute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B3: A,A4: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),B3),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),C2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),A4),aa(A,A,aa(A,fun(A,A),ord_max(A),B3),C2)) ) ) ).

% max.left_commute
tff(fact_3975_max_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semigroup(A,ord_max(A)) ) ).

% max.semigroup_axioms
tff(fact_3976_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [X2: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% minus_max_eq_min
tff(fact_3977_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [X2: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% minus_min_eq_max
tff(fact_3978_lessThan__Int__lessThan,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_greaterThan(A),A4)),aa(A,set(A),set_ord_greaterThan(A),B3)) = aa(A,set(A),set_ord_greaterThan(A),aa(A,A,aa(A,fun(A,A),ord_max(A),A4),B3)) ) ) ).

% lessThan_Int_lessThan
tff(fact_3979_max__Suc1,axiom,
    ! [N: nat,M2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,N)),M2) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),aa(nat,nat,suc,N)),aTP_Lamp_ace(nat,fun(nat,nat),N)),M2) ) ).

% max_Suc1
tff(fact_3980_max__Suc2,axiom,
    ! [M2: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M2),aa(nat,nat,suc,N)) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),aa(nat,nat,suc,N)),aTP_Lamp_acf(nat,fun(nat,nat),N)),M2) ) ).

% max_Suc2
tff(fact_3981_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P5: A,X2: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P5))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P5),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P5),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),P5),Y)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P5))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P5),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P5),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),P5),Y)) ) ) ) ) ).

% max_mult_distrib_left
tff(fact_3982_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P5: A,X2: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P5))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P5),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P5),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),P5),Y)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P5))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P5),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P5),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),P5),Y)) ) ) ) ) ).

% min_mult_distrib_left
tff(fact_3983_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P5: A,X2: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P5))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y)),P5) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),P5)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P5)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P5))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y)),P5) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),P5)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P5)) ) ) ) ) ).

% max_mult_distrib_right
tff(fact_3984_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P5: A,X2: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P5))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)),P5) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),P5)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P5)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P5))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)),P5) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),P5)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P5)) ) ) ) ) ).

% min_mult_distrib_right
tff(fact_3985_Fract_Orsp,axiom,
    pp(aa(fun(int,fun(int,product_prod(int,int))),bool,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,product_prod(int,int))),bool),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,product_prod(int,int)),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),product_prod(int,int),fequal(int),ratrel)),aTP_Lamp_acg(int,fun(int,product_prod(int,int)))),aTP_Lamp_acg(int,fun(int,product_prod(int,int))))) ).

% Fract.rsp
tff(fact_3986_Sup__insert__finite,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [S: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( ( ( S = bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert(A,X2),S)) = X2 ) )
            & ( ( S != bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert(A,X2),S)) = aa(A,A,aa(A,fun(A,A),ord_max(A),X2),aa(set(A),A,complete_Sup_Sup(A),S)) ) ) ) ) ) ).

% Sup_insert_finite
tff(fact_3987_hom__Max__commute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [H2: fun(A,A),N4: set(A)] :
          ( ! [X: A,Y2: A] : ( aa(A,A,H2,aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,H2,X)),aa(A,A,H2,Y2)) )
         => ( pp(aa(set(A),bool,finite_finite2(A),N4))
           => ( ( N4 != bot_bot(set(A)) )
             => ( aa(A,A,H2,aa(set(A),A,lattic643756798349783984er_Max(A),N4)) = aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),image2(A,A,H2),N4)) ) ) ) ) ) ).

% hom_Max_commute
tff(fact_3988_Max_Osubset,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( B2 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),A3))
             => ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(set(A),A,lattic643756798349783984er_Max(A),B2)),aa(set(A),A,lattic643756798349783984er_Max(A),A3)) = aa(set(A),A,lattic643756798349783984er_Max(A),A3) ) ) ) ) ) ).

% Max.subset
tff(fact_3989_Max_Oclosed,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [X: A,Y2: A] : pp(aa(set(A),bool,member(A,aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y2)),aa(set(A),set(A),insert(A,X),aa(set(A),set(A),insert(A,Y2),bot_bot(set(A))))))
             => pp(aa(set(A),bool,member(A,aa(set(A),A,lattic643756798349783984er_Max(A),A3)),A3)) ) ) ) ) ).

% Max.closed
tff(fact_3990_Max_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ~ pp(aa(set(A),bool,member(A,X2),A3))
           => ( ( A3 != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),ord_max(A),X2),aa(set(A),A,lattic643756798349783984er_Max(A),A3)) ) ) ) ) ) ).

% Max.insert_not_elem
tff(fact_3991_Max_Ounion,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite2(A),B2))
             => ( ( B2 != bot_bot(set(A)) )
               => ( aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(set(A),A,lattic643756798349783984er_Max(A),A3)),aa(set(A),A,lattic643756798349783984er_Max(A),B2)) ) ) ) ) ) ) ).

% Max.union
tff(fact_3992_Max_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( pp(aa(set(A),bool,member(A,X2),A3))
           => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = bot_bot(set(A)) )
               => ( aa(set(A),A,lattic643756798349783984er_Max(A),A3) = X2 ) )
              & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) != bot_bot(set(A)) )
               => ( aa(set(A),A,lattic643756798349783984er_Max(A),A3) = aa(A,A,aa(A,fun(A,A),ord_max(A),X2),aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ) ).

% Max.remove
tff(fact_3993_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = bot_bot(set(A)) )
             => ( aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),insert(A,X2),A3)) = X2 ) )
            & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),ord_max(A),X2),aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ).

% Max.insert_remove
tff(fact_3994_Gcd__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,A3: set(A)] :
          ( pp(aa(set(A),bool,member(A,A4),A3))
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))) ) ) ) ).

% Gcd_fin.remove
tff(fact_3995_Gcd__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,A3: set(A)] : ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),insert(A,A4),A3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))) ) ) ).

% Gcd_fin.insert_remove
tff(fact_3996_of__rat_Orsp,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => pp(aa(fun(product_prod(int,int),A),bool,aa(fun(product_prod(int,int),A),fun(fun(product_prod(int,int),A),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),A,A,ratrel,fequal(A)),aTP_Lamp_abw(product_prod(int,int),A)),aTP_Lamp_abw(product_prod(int,int),A))) ) ).

% of_rat.rsp
tff(fact_3997_ratrel__def,axiom,
    ! [X4: product_prod(int,int),Xa3: product_prod(int,int)] :
      ( pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,X4),Xa3))
    <=> ( ( aa(product_prod(int,int),int,product_snd(int,int),X4) != zero_zero(int) )
        & ( aa(product_prod(int,int),int,product_snd(int,int),Xa3) != zero_zero(int) )
        & ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),X4)),aa(product_prod(int,int),int,product_snd(int,int),Xa3)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa3)),aa(product_prod(int,int),int,product_snd(int,int),X4)) ) ) ) ).

% ratrel_def
tff(fact_3998_times__rat_Orsp,axiom,
    pp(aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),bool,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(product_prod(int,int),product_prod(int,int)),ratrel,bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel)),aTP_Lamp_abu(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),aTP_Lamp_abu(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))))) ).

% times_rat.rsp
tff(fact_3999_uminus__rat_Orsp,axiom,
    pp(aa(fun(product_prod(int,int),product_prod(int,int)),bool,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(product_prod(int,int),product_prod(int,int)),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel),aTP_Lamp_abt(product_prod(int,int),product_prod(int,int))),aTP_Lamp_abt(product_prod(int,int),product_prod(int,int)))) ).

% uminus_rat.rsp
tff(fact_4000_max__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,ord_max(nat),zero_zero(nat),aTP_Lamp_rb(nat,fun(nat,bool)),aTP_Lamp_tj(nat,fun(nat,bool))) ).

% max_nat.semilattice_neutr_order_axioms
tff(fact_4001_Gcd__fin__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = zero_zero(A) )
        <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A)))))
            & pp(aa(set(A),bool,finite_finite2(A),A3)) ) ) ) ).

% Gcd_fin_0_iff
tff(fact_4002_positive_Orsp,axiom,
    pp(aa(fun(product_prod(int,int),bool),bool,aa(fun(product_prod(int,int),bool),fun(fun(product_prod(int,int),bool),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),bool,bool,ratrel,fequal(bool)),aTP_Lamp_abv(product_prod(int,int),bool)),aTP_Lamp_abv(product_prod(int,int),bool))) ).

% positive.rsp
tff(fact_4003_cr__rat__def,axiom,
    ! [X4: product_prod(int,int),Xa3: rat] :
      ( cr_rat(X4,Xa3)
    <=> ( pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,X4),X4))
        & ( aa(product_prod(int,int),rat,abs_Rat,X4) = Xa3 ) ) ) ).

% cr_rat_def
tff(fact_4004_dual__min,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( min(A,aTP_Lamp_pz(A,fun(A,bool))) = ord_max(A) ) ) ).

% dual_min
tff(fact_4005_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M2: num,N: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),M2)),aa(num,A,numeral_numeral(A),N)) = case_option(A,num,zero_zero(A),numeral_numeral(A),bit_un2480387367778600638or_num(M2,N)) ) ) ).

% numeral_xor_num
tff(fact_4006_the__dflt__None__nonempty,axiom,
    ! [A: $tType,S: set(A)] :
      ( ( S != bot_bot(set(A)) )
     => ( dflt_None_set(A,S) = aa(set(A),option(set(A)),some(set(A)),S) ) ) ).

% the_dflt_None_nonempty
tff(fact_4007_the__dflt__None__empty,axiom,
    ! [A: $tType] : ( dflt_None_set(A,bot_bot(set(A))) = none(set(A)) ) ).

% the_dflt_None_empty
tff(fact_4008_ord_Omin_Ocong,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool))] : ( min(A,Less_eq) = min(A,Less_eq) ) ).

% ord.min.cong
tff(fact_4009_ord_Omin__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
       => ( aa(A,A,aa(A,fun(A,A),min(A,Less_eq),A4),B3) = A4 ) )
      & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
       => ( aa(A,A,aa(A,fun(A,A),min(A,Less_eq),A4),B3) = B3 ) ) ) ).

% ord.min_def
tff(fact_4010_dflt__None__set__def,axiom,
    ! [A: $tType,S: set(A)] :
      ( ( ( S = bot_bot(set(A)) )
       => ( dflt_None_set(A,S) = none(set(A)) ) )
      & ( ( S != bot_bot(set(A)) )
       => ( dflt_None_set(A,S) = aa(set(A),option(set(A)),some(set(A)),S) ) ) ) ).

% dflt_None_set_def
tff(fact_4011_the__dflt__None__set,axiom,
    ! [A: $tType,X2: set(A)] : ( the_default(set(A),bot_bot(set(A)),dflt_None_set(A,X2)) = X2 ) ).

% the_dflt_None_set
tff(fact_4012_and__not__num_Opelims,axiom,
    ! [X2: num,Xa: num,Y: option(num)] :
      ( ( bit_and_not_num(X2,Xa) = Y )
     => ( pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X2),Xa)))
       => ( ( ( X2 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = none(num) )
               => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2))) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N2: num] :
                  ( ( Xa = aa(num,num,bit0,N2) )
                 => ( ( Y = aa(num,option(num),some(num),one2) )
                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N2)))) ) ) )
           => ( ( ( X2 = one2 )
               => ! [N2: num] :
                    ( ( Xa = aa(num,num,bit1,N2) )
                   => ( ( Y = none(num) )
                     => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N2)))) ) ) )
             => ( ! [M3: num] :
                    ( ( X2 = aa(num,num,bit0,M3) )
                   => ( ( Xa = one2 )
                     => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,M3)) )
                       => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),one2))) ) ) )
               => ( ! [M3: num] :
                      ( ( X2 = aa(num,num,bit0,M3) )
                     => ! [N2: num] :
                          ( ( Xa = aa(num,num,bit0,N2) )
                         => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) )
                           => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),aa(num,num,bit0,N2)))) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2 = aa(num,num,bit0,M3) )
                       => ! [N2: num] :
                            ( ( Xa = aa(num,num,bit1,N2) )
                           => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),aa(num,num,bit1,N2)))) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2 = aa(num,num,bit1,M3) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,M3)) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),one2))) ) ) )
                     => ( ! [M3: num] :
                            ( ( X2 = aa(num,num,bit1,M3) )
                           => ! [N2: num] :
                                ( ( Xa = aa(num,num,bit0,N2) )
                               => ( ( Y = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aal(num,option(num)),bit_and_not_num(M3,N2)) )
                                 => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),aa(num,num,bit0,N2)))) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X2 = aa(num,num,bit1,M3) )
                             => ! [N2: num] :
                                  ( ( Xa = aa(num,num,bit1,N2) )
                                 => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) )
                                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),aa(num,num,bit1,N2)))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
tff(fact_4013_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert(A,L),bot_bot(set(A)))),set_or5935395276787703475ssThan(A,L,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(3)
tff(fact_4014_and__num_Opelims,axiom,
    ! [X2: num,Xa: num,Y: option(num)] :
      ( ( bit_un7362597486090784418nd_num(X2,Xa) = Y )
     => ( pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X2),Xa)))
       => ( ( ( X2 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = aa(num,option(num),some(num),one2) )
               => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2))) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N2: num] :
                  ( ( Xa = aa(num,num,bit0,N2) )
                 => ( ( Y = none(num) )
                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N2)))) ) ) )
           => ( ( ( X2 = one2 )
               => ! [N2: num] :
                    ( ( Xa = aa(num,num,bit1,N2) )
                   => ( ( Y = aa(num,option(num),some(num),one2) )
                     => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N2)))) ) ) )
             => ( ! [M3: num] :
                    ( ( X2 = aa(num,num,bit0,M3) )
                   => ( ( Xa = one2 )
                     => ( ( Y = none(num) )
                       => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),one2))) ) ) )
               => ( ! [M3: num] :
                      ( ( X2 = aa(num,num,bit0,M3) )
                     => ! [N2: num] :
                          ( ( Xa = aa(num,num,bit0,N2) )
                         => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) )
                           => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),aa(num,num,bit0,N2)))) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2 = aa(num,num,bit0,M3) )
                       => ! [N2: num] :
                            ( ( Xa = aa(num,num,bit1,N2) )
                           => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),aa(num,num,bit1,N2)))) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2 = aa(num,num,bit1,M3) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,option(num),some(num),one2) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),one2))) ) ) )
                     => ( ! [M3: num] :
                            ( ( X2 = aa(num,num,bit1,M3) )
                           => ! [N2: num] :
                                ( ( Xa = aa(num,num,bit0,N2) )
                               => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) )
                                 => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),aa(num,num,bit0,N2)))) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X2 = aa(num,num,bit1,M3) )
                             => ! [N2: num] :
                                  ( ( Xa = aa(num,num,bit1,N2) )
                                 => ( ( Y = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aal(num,option(num)),bit_un7362597486090784418nd_num(M3,N2)) )
                                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),aa(num,num,bit1,N2)))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
tff(fact_4015_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,K: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),K))
         => ( set_or5935395276787703475ssThan(A,K,L) = bot_bot(set(A)) ) ) ) ).

% greaterThanLessThan_empty
tff(fact_4016_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A4: A,B3: A] :
          ( ( set_or5935395276787703475ssThan(A,A4,B3) = bot_bot(set(A)) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ).

% greaterThanLessThan_empty_iff
tff(fact_4017_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A4: A,B3: A] :
          ( ( bot_bot(set(A)) = set_or5935395276787703475ssThan(A,A4,B3) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4)) ) ) ).

% greaterThanLessThan_empty_iff2
tff(fact_4018_Int__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A,D3: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or5935395276787703475ssThan(A,A4,B3)),set_or5935395276787703475ssThan(A,C2,D3)) = set_or5935395276787703475ssThan(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A4),C2),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),D3)) ) ) ).

% Int_greaterThanLessThan
tff(fact_4019_ivl__disj__int__two_I5_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M2: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or5935395276787703475ssThan(A,L,M2)),set_or1337092689740270186AtMost(A,M2,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(5)
tff(fact_4020_ivl__disj__int__two_I4_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M2: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,L,M2)),set_or5935395276787703475ssThan(A,M2,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(4)
tff(fact_4021_ivl__disj__int__two_I1_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M2: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or5935395276787703475ssThan(A,L,M2)),set_or7035219750837199246ssThan(A,M2,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(1)
tff(fact_4022_ivl__disj__int__one_I1_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_atMost(A),L)),set_or5935395276787703475ssThan(A,L,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(1)
tff(fact_4023_ivl__disj__int__one_I6_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or5935395276787703475ssThan(A,L,U)),aa(A,set(A),set_ord_atLeast(A),U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(6)
tff(fact_4024_greaterThanLessThan__eq,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A4: A,B3: A] : ( set_or5935395276787703475ssThan(A,A4,B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_greaterThan(A),A4)),aa(A,set(A),set_ord_lessThan(A),B3)) ) ) ).

% greaterThanLessThan_eq
tff(fact_4025_greaterThanLessThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A,U: A] : ( set_or5935395276787703475ssThan(A,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_greaterThan(A),L)),aa(A,set(A),set_ord_lessThan(A),U)) ) ) ).

% greaterThanLessThan_def
tff(fact_4026_atLeastAtMost__diff__ends,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A4,B3)),aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))) = set_or5935395276787703475ssThan(A,A4,B3) ) ) ).

% atLeastAtMost_diff_ends
tff(fact_4027_interval__cases,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [S: set(A)] :
          ( ! [A5: A,B4: A,X: A] :
              ( pp(aa(set(A),bool,member(A,A5),S))
             => ( pp(aa(set(A),bool,member(A,B4),S))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A5),X))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),B4))
                   => pp(aa(set(A),bool,member(A,X),S)) ) ) ) )
         => ? [A5: A,B4: A] :
              ( ( S = bot_bot(set(A)) )
              | ( S = top_top(set(A)) )
              | ( S = aa(A,set(A),set_ord_lessThan(A),B4) )
              | ( S = aa(A,set(A),set_ord_atMost(A),B4) )
              | ( S = aa(A,set(A),set_ord_greaterThan(A),A5) )
              | ( S = aa(A,set(A),set_ord_atLeast(A),A5) )
              | ( S = set_or5935395276787703475ssThan(A,A5,B4) )
              | ( S = set_or3652927894154168847AtMost(A,A5,B4) )
              | ( S = set_or7035219750837199246ssThan(A,A5,B4) )
              | ( S = set_or1337092689740270186AtMost(A,A5,B4) ) ) ) ) ).

% interval_cases
tff(fact_4028_set__to__map__empty,axiom,
    ! [A: $tType,B: $tType,X4: A] : ( aa(A,option(B),set_to_map(A,B,bot_bot(set(product_prod(A,B)))),X4) = none(B) ) ).

% set_to_map_empty
tff(fact_4029_bot_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ordering_top(A,aTP_Lamp_ach(A,fun(A,bool)),aTP_Lamp_aci(A,fun(A,bool)),bot_bot(A)) ) ).

% bot.ordering_top_axioms
tff(fact_4030_euclidean__size__times__nonunit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( ( B3 != zero_zero(A) )
           => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
             => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),euclid6346220572633701492n_size(A,B3)),euclid6346220572633701492n_size(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))) ) ) ) ) ).

% euclidean_size_times_nonunit
tff(fact_4031_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,K: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),K))
         => ( set_or3652927894154168847AtMost(A,K,L) = bot_bot(set(A)) ) ) ) ).

% greaterThanAtMost_empty
tff(fact_4032_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A,L: A] :
          ( ( bot_bot(set(A)) = set_or3652927894154168847AtMost(A,K,L) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) ) ) ).

% greaterThanAtMost_empty_iff2
tff(fact_4033_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A,L: A] :
          ( ( set_or3652927894154168847AtMost(A,K,L) = bot_bot(set(A)) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) ) ) ).

% greaterThanAtMost_empty_iff
tff(fact_4034_euclidean__size__1,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( euclid6346220572633701492n_size(A,one_one(A)) = one_one(nat) ) ) ).

% euclidean_size_1
tff(fact_4035_Int__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A,D3: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,A4,B3)),set_or3652927894154168847AtMost(A,C2,D3)) = set_or3652927894154168847AtMost(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A4),C2),aa(A,A,aa(A,fun(A,A),ord_min(A),B3),D3)) ) ) ).

% Int_greaterThanAtMost
tff(fact_4036_ordering__top_Oextremum__uniqueI,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A,A4: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,Top),A4))
       => ( A4 = Top ) ) ) ).

% ordering_top.extremum_uniqueI
tff(fact_4037_ordering__top_Onot__eq__extremum,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A,A4: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ( ( A4 != Top )
      <=> pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),Top)) ) ) ).

% ordering_top.not_eq_extremum
tff(fact_4038_ordering__top_Oextremum__unique,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A,A4: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,Top),A4))
      <=> ( A4 = Top ) ) ) ).

% ordering_top.extremum_unique
tff(fact_4039_ordering__top_Oextremum__strict,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A,A4: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,Top),A4)) ) ).

% ordering_top.extremum_strict
tff(fact_4040_ordering__top_Oextremum,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A,A4: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),Top)) ) ).

% ordering_top.extremum
tff(fact_4041_ivl__disj__int__two_I6_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M2: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,L,M2)),set_or3652927894154168847AtMost(A,M2,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(6)
tff(fact_4042_euclidean__size__unit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( euclid6346220572633701492n_size(A,A4) = euclid6346220572633701492n_size(A,one_one(A)) ) ) ) ).

% euclidean_size_unit
tff(fact_4043_euclidean__size__mult,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A4: A,B3: A] : ( euclid6346220572633701492n_size(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),euclid6346220572633701492n_size(A,A4)),euclid6346220572633701492n_size(A,B3)) ) ) ).

% euclidean_size_mult
tff(fact_4044_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,B3: A,C2: A,D3: A] :
          ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,A4,B3)),set_or3652927894154168847AtMost(A,C2,D3)) = bot_bot(set(A)) )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),A4))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D3),C2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B3),C2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D3),A4)) ) ) ) ).

% Ioc_disjoint
tff(fact_4045_ivl__disj__int__two_I8_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M2: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,L,M2)),set_or3652927894154168847AtMost(A,M2,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(8)
tff(fact_4046_ivl__disj__int__one_I3_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_atMost(A),L)),set_or3652927894154168847AtMost(A,L,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(3)
tff(fact_4047_unit__iff__euclidean__size,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
        <=> ( ( euclid6346220572633701492n_size(A,A4) = euclid6346220572633701492n_size(A,one_one(A)) )
            & ( A4 != zero_zero(A) ) ) ) ) ).

% unit_iff_euclidean_size
tff(fact_4048_size__mult__mono_H,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B3: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),euclid6346220572633701492n_size(A,A4)),euclid6346220572633701492n_size(A,aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)))) ) ) ).

% size_mult_mono'
tff(fact_4049_size__mult__mono,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B3: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),euclid6346220572633701492n_size(A,A4)),euclid6346220572633701492n_size(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)))) ) ) ).

% size_mult_mono
tff(fact_4050_euclidean__size__times__unit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( euclid6346220572633701492n_size(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = euclid6346220572633701492n_size(A,B3) ) ) ) ).

% euclidean_size_times_unit
tff(fact_4051_ivl__disj__int__two_I2_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M2: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,L,M2)),set_or5935395276787703475ssThan(A,M2,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(2)
tff(fact_4052_ivl__disj__int__one_I5_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,L,U)),aa(A,set(A),set_ord_greaterThan(A),U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(5)
tff(fact_4053_greaterThanAtMost__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A,U: A] : ( set_or3652927894154168847AtMost(A,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_greaterThan(A),L)),aa(A,set(A),set_ord_atMost(A),U)) ) ) ).

% greaterThanAtMost_def
tff(fact_4054_gcd__nat_Oordering__top__axioms,axiom,
    ordering_top(nat,dvd_dvd(nat),aTP_Lamp_abn(nat,fun(nat,bool)),zero_zero(nat)) ).

% gcd_nat.ordering_top_axioms
tff(fact_4055_set__to__map__empty__iff_I1_J,axiom,
    ! [B: $tType,A: $tType,S: set(product_prod(A,B))] :
      ( ! [X3: A] : ( aa(A,option(B),set_to_map(A,B,S),X3) = none(B) )
    <=> ( S = bot_bot(set(product_prod(A,B))) ) ) ).

% set_to_map_empty_iff(1)
tff(fact_4056_prod_Ohead,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M2: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M2,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or3652927894154168847AtMost(nat,M2,N))) ) ) ) ).

% prod.head
tff(fact_4057_greaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: A,B3: A] : ( set_or3652927894154168847AtMost(A,A4,B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A4,B3)),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) ) ) ).

% greaterThanAtMost_eq_atLeastAtMost_diff
tff(fact_4058_set__to__map__empty__iff_I2_J,axiom,
    ! [B: $tType,A: $tType,S: set(product_prod(A,B))] :
      ( ( aTP_Lamp_abe(A,option(B)) = set_to_map(A,B,S) )
    <=> ( S = bot_bot(set(product_prod(A,B))) ) ) ).

% set_to_map_empty_iff(2)
tff(fact_4059_top_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ordering_top(A,ord_less_eq(A),ord_less(A),top_top(A)) ) ).

% top.ordering_top_axioms
tff(fact_4060_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert(A,L),bot_bot(set(A)))),set_or3652927894154168847AtMost(A,L,U)) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(5)
tff(fact_4061_bot__nat__0_Oordering__top__axioms,axiom,
    ordering_top(nat,aTP_Lamp_rb(nat,fun(nat,bool)),aTP_Lamp_tj(nat,fun(nat,bool)),zero_zero(nat)) ).

% bot_nat_0.ordering_top_axioms
tff(fact_4062_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,U)),aa(set(A),set(A),insert(A,U),bot_bot(set(A)))) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(4)
tff(fact_4063_divmod__cases,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B3: A,A4: A] :
          ( ( ( B3 != zero_zero(A) )
           => ( ( modulo_modulo(A,A4,B3) = zero_zero(A) )
             => ( A4 != aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)),B3) ) ) )
         => ( ( ( B3 != zero_zero(A) )
             => ! [Q8: A,R3: A] :
                  ( ( euclid7384307370059645450egment(A,R3) = euclid7384307370059645450egment(A,B3) )
                 => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),euclid6346220572633701492n_size(A,R3)),euclid6346220572633701492n_size(A,B3)))
                   => ( ( R3 != zero_zero(A) )
                     => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) = Q8 )
                       => ( ( modulo_modulo(A,A4,B3) = R3 )
                         => ( A4 != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q8),B3)),R3) ) ) ) ) ) ) )
           => ( B3 = zero_zero(A) ) ) ) ) ).

% divmod_cases
tff(fact_4064_mod__eqI,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B3: A,R2: A,Q3: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R2) = euclid7384307370059645450egment(A,B3) )
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),euclid6346220572633701492n_size(A,R2)),euclid6346220572633701492n_size(A,B3)))
             => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q3),B3)),R2) = A4 )
               => ( modulo_modulo(A,A4,B3) = R2 ) ) ) ) ) ) ).

% mod_eqI
tff(fact_4065_div__bounded,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B3: A,R2: A,Q3: A] :
          ( ( B3 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R2) = euclid7384307370059645450egment(A,B3) )
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),euclid6346220572633701492n_size(A,R2)),euclid6346220572633701492n_size(A,B3)))
             => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q3),B3)),R2)),B3) = Q3 ) ) ) ) ) ).

% div_bounded
tff(fact_4066_div__eqI,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B3: A,R2: A,Q3: A,A4: A] :
          ( ( B3 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R2) = euclid7384307370059645450egment(A,B3) )
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),euclid6346220572633701492n_size(A,R2)),euclid6346220572633701492n_size(A,B3)))
             => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q3),B3)),R2) = A4 )
               => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3) = Q3 ) ) ) ) ) ) ).

% div_eqI
tff(fact_4067_division__segment__1,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( euclid7384307370059645450egment(A,one_one(A)) = one_one(A) ) ) ).

% division_segment_1
tff(fact_4068_division__segment__numeral,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [K: num] : ( euclid7384307370059645450egment(A,aa(num,A,numeral_numeral(A),K)) = one_one(A) ) ) ).

% division_segment_numeral
tff(fact_4069_division__segment__of__nat,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( euclid7384307370059645450egment(A,aa(nat,A,semiring_1_of_nat(A),N)) = one_one(A) ) ) ).

% division_segment_of_nat
tff(fact_4070_division__segment__euclidean__size,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),euclid7384307370059645450egment(A,A4)),aa(nat,A,semiring_1_of_nat(A),euclid6346220572633701492n_size(A,A4))) = A4 ) ) ).

% division_segment_euclidean_size
tff(fact_4071_division__segment__mult,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( ( B3 != zero_zero(A) )
           => ( euclid7384307370059645450egment(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),euclid7384307370059645450egment(A,A4)),euclid7384307370059645450egment(A,B3)) ) ) ) ) ).

% division_segment_mult
tff(fact_4072_is__unit__division__segment,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),euclid7384307370059645450egment(A,A4)),one_one(A))) ) ).

% is_unit_division_segment
tff(fact_4073_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( ( ( N = zero_zero(nat) )
           => ( aa(num,A,numeral_numeral(A),num_of_nat(N)) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(num,A,numeral_numeral(A),num_of_nat(N)) = aa(nat,A,semiring_1_of_nat(A),N) ) ) ) ) ).

% numeral_num_of_nat_unfold
tff(fact_4074_Max_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => lattic4895041142388067077er_set(A,ord_max(A),aTP_Lamp_pz(A,fun(A,bool)),aTP_Lamp_acj(A,fun(A,bool))) ) ).

% Max.semilattice_order_set_axioms
tff(fact_4075_set__to__map__def,axiom,
    ! [A: $tType,B: $tType,S: set(product_prod(B,A)),K: B] : ( aa(B,option(A),set_to_map(B,A,S),K) = eps_Opt(A,aa(B,fun(A,bool),aTP_Lamp_jt(set(product_prod(B,A)),fun(B,fun(A,bool)),S),K)) ) ).

% set_to_map_def
tff(fact_4076_Gcd__fin__def,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( semiring_gcd_Gcd_fin(A) = bounde2362111253966948842tice_F(A,gcd_gcd(A),zero_zero(A),one_one(A)) ) ) ).

% Gcd_fin_def
tff(fact_4077_some__opt__eq__trivial,axiom,
    ! [A: $tType,X2: A] : ( eps_Opt(A,aTP_Lamp_ct(A,fun(A,bool),X2)) = aa(A,option(A),some(A),X2) ) ).

% some_opt_eq_trivial
tff(fact_4078_some__opt__false__trivial,axiom,
    ! [A: $tType] : ( eps_Opt(A,aTP_Lamp_ao(A,bool)) = none(A) ) ).

% some_opt_false_trivial
tff(fact_4079_Inf__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => lattic4895041142388067077er_set(A,inf_inf(A),ord_less_eq(A),ord_less(A)) ) ).

% Inf_fin.semilattice_order_set_axioms
tff(fact_4080_Sup__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => lattic4895041142388067077er_set(A,sup_sup(A),aTP_Lamp_ack(A,fun(A,bool)),aTP_Lamp_acl(A,fun(A,bool))) ) ).

% Sup_fin.semilattice_order_set_axioms
tff(fact_4081_bounded__quasi__semilattice__set_Oremove,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A4: A,A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( pp(aa(set(A),bool,member(A,A4),A3))
       => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3) = aa(A,A,aa(A,fun(A,A),F2,A4),aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))) ) ) ) ).

% bounded_quasi_semilattice_set.remove
tff(fact_4082_bounded__quasi__semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A4: A,A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),aa(set(A),set(A),insert(A,A4),A3)) = aa(A,A,aa(A,fun(A,A),F2,A4),aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))) ) ) ).

% bounded_quasi_semilattice_set.insert_remove
tff(fact_4083_dom__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y: option(B),F2: fun(A,option(B)),X2: A] :
      ( ( ( Y = none(B) )
       => ( dom(A,B,fun_upd(A,option(B),F2,X2,Y)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),dom(A,B,F2)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) ) )
      & ( ( Y != none(B) )
       => ( dom(A,B,fun_upd(A,option(B),F2,X2,Y)) = aa(set(A),set(A),insert(A,X2),dom(A,B,F2)) ) ) ) ).

% dom_fun_upd
tff(fact_4084_card__def,axiom,
    ! [B: $tType] : ( finite_card(B) = finite_folding_F(B,nat,aTP_Lamp_acm(B,fun(nat,nat)),zero_zero(nat)) ) ).

% card_def
tff(fact_4085_dom__eq__empty__conv,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,option(B))] :
      ( ( dom(A,B,F2) = bot_bot(set(A)) )
    <=> ! [X3: A] : ( aa(A,option(B),F2,X3) = none(B) ) ) ).

% dom_eq_empty_conv
tff(fact_4086_dom__restrict,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B)),A3: set(A)] : ( dom(A,B,restrict_map(A,B,M2,A3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,M2)),A3) ) ).

% dom_restrict
tff(fact_4087_dom__empty,axiom,
    ! [B: $tType,A: $tType] : ( dom(A,B,aTP_Lamp_abe(A,option(B))) = bot_bot(set(A)) ) ).

% dom_empty
tff(fact_4088_map__update__eta__repair_I1_J,axiom,
    ! [B: $tType,A: $tType,K: A,V: B,M2: fun(A,option(B))] : ( dom(A,B,aa(fun(A,option(B)),fun(A,option(B)),aa(B,fun(fun(A,option(B)),fun(A,option(B))),aTP_Lamp_acn(A,fun(B,fun(fun(A,option(B)),fun(A,option(B)))),K),V),M2)) = aa(set(A),set(A),insert(A,K),dom(A,B,M2)) ) ).

% map_update_eta_repair(1)
tff(fact_4089_dom__const_H,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B)] : ( dom(A,B,aTP_Lamp_aco(fun(A,B),fun(A,option(B)),F2)) = top_top(set(A)) ) ).

% dom_const'
tff(fact_4090_dom__map__option,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: fun(A,fun(C,B)),M2: fun(A,option(C))] : ( dom(A,B,aa(fun(A,option(C)),fun(A,option(B)),aTP_Lamp_acp(fun(A,fun(C,B)),fun(fun(A,option(C)),fun(A,option(B))),F2),M2)) = dom(A,C,M2) ) ).

% dom_map_option
tff(fact_4091_dom__def,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B))] : ( dom(A,B,M2) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_acq(fun(A,option(B)),fun(A,bool),M2)) ) ).

% dom_def
tff(fact_4092_dom__if,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),F2: fun(A,option(B)),G: fun(A,option(B))] : ( dom(A,B,aa(fun(A,option(B)),fun(A,option(B)),aa(fun(A,option(B)),fun(fun(A,option(B)),fun(A,option(B))),aTP_Lamp_acr(fun(A,bool),fun(fun(A,option(B)),fun(fun(A,option(B)),fun(A,option(B)))),P),F2),G)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,F2)),aa(fun(A,bool),set(A),collect(A),P))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,G)),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_as(fun(A,bool),fun(A,bool),P)))) ) ).

% dom_if
tff(fact_4093_restrict__map__eq_I1_J,axiom,
    ! [A: $tType,B: $tType,M2: fun(B,option(A)),A3: set(B),K: B] :
      ( ( aa(B,option(A),restrict_map(B,A,M2,A3),K) = none(A) )
    <=> ~ pp(aa(set(B),bool,member(B,K),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,A,M2)),A3))) ) ).

% restrict_map_eq(1)
tff(fact_4094_bounded__quasi__semilattice__set_Oempty,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),bot_bot(set(A))) = Top ) ) ).

% bounded_quasi_semilattice_set.empty
tff(fact_4095_finite__Map__induct,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B)),P: fun(fun(A,option(B)),bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),dom(A,B,M2)))
     => ( pp(aa(fun(A,option(B)),bool,P,aTP_Lamp_abe(A,option(B))))
       => ( ! [K2: A,V2: B,M3: fun(A,option(B))] :
              ( pp(aa(set(A),bool,finite_finite2(A),dom(A,B,M3)))
             => ( ~ pp(aa(set(A),bool,member(A,K2),dom(A,B,M3)))
               => ( pp(aa(fun(A,option(B)),bool,P,M3))
                 => pp(aa(fun(A,option(B)),bool,P,fun_upd(A,option(B),M3,K2,aa(B,option(B),some(B),V2)))) ) ) )
         => pp(aa(fun(A,option(B)),bool,P,M2)) ) ) ) ).

% finite_Map_induct
tff(fact_4096_dom__eq__singleton__conv,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,option(B)),X2: A] :
      ( ( dom(A,B,F2) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) )
    <=> ? [V4: B] : ( F2 = fun_upd(A,option(B),aTP_Lamp_abe(A,option(B)),X2,aa(B,option(B),some(B),V4)) ) ) ).

% dom_eq_singleton_conv
tff(fact_4097_dom__override__on,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,option(B)),G: fun(A,option(B)),A3: set(A)] : ( dom(A,B,override_on(A,option(B),F2,G,A3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),dom(A,B,F2)),aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_acs(fun(A,option(B)),fun(set(A),fun(A,bool)),G),A3)))),aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_act(fun(A,option(B)),fun(set(A),fun(A,bool)),G),A3))) ) ).

% dom_override_on
tff(fact_4098_folding__on_Oremove,axiom,
    ! [B: $tType,A: $tType,S: set(A),F2: fun(A,fun(B,B)),A3: set(A),X2: A,Z2: B] :
      ( finite_folding_on(A,B,S,F2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),S))
       => ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( pp(aa(set(A),bool,member(A,X2),A3))
           => ( aa(set(A),B,finite_folding_F(A,B,F2,Z2),A3) = aa(B,B,aa(A,fun(B,B),F2,X2),aa(set(A),B,finite_folding_F(A,B,F2,Z2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ).

% folding_on.remove
tff(fact_4099_folding__on_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType,S: set(A),F2: fun(A,fun(B,B)),X2: A,A3: set(A),Z2: B] :
      ( finite_folding_on(A,B,S,F2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,X2),A3)),S))
       => ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( aa(set(A),B,finite_folding_F(A,B,F2,Z2),aa(set(A),set(A),insert(A,X2),A3)) = aa(B,B,aa(A,fun(B,B),F2,X2),aa(set(A),B,finite_folding_F(A,B,F2,Z2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ).

% folding_on.insert_remove
tff(fact_4100_ran__map__upd__Some,axiom,
    ! [B: $tType,A: $tType,M2: fun(B,option(A)),X2: B,Y: A,Z2: A] :
      ( ( aa(B,option(A),M2,X2) = aa(A,option(A),some(A),Y) )
     => ( inj_on(B,option(A),M2,dom(B,A,M2))
       => ( ~ pp(aa(set(A),bool,member(A,Z2),ran(B,A,M2)))
         => ( ran(B,A,fun_upd(B,option(A),M2,X2,aa(A,option(A),some(A),Z2))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),ran(B,A,M2)),aa(set(A),set(A),insert(A,Y),bot_bot(set(A))))),aa(set(A),set(A),insert(A,Z2),bot_bot(set(A)))) ) ) ) ) ).

% ran_map_upd_Some
tff(fact_4101_override__on__emptyset,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),G: fun(A,B)] : ( override_on(A,B,F2,G,bot_bot(set(A))) = F2 ) ).

% override_on_emptyset
tff(fact_4102_ran__empty,axiom,
    ! [B: $tType,A: $tType] : ( ran(B,A,aTP_Lamp_acu(B,option(A))) = bot_bot(set(A)) ) ).

% ran_empty
tff(fact_4103_map__update__eta__repair_I2_J,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B)),K: A,V: B] :
      ( ( aa(A,option(B),M2,K) = none(B) )
     => ( ran(A,B,aa(B,fun(A,option(B)),aa(A,fun(B,fun(A,option(B))),aTP_Lamp_acv(fun(A,option(B)),fun(A,fun(B,fun(A,option(B)))),M2),K),V)) = aa(set(B),set(B),insert(B,V),ran(A,B,M2)) ) ) ).

% map_update_eta_repair(2)
tff(fact_4104_ran__def,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B))] : ( ran(A,B,M2) = aa(fun(B,bool),set(B),collect(B),aTP_Lamp_acw(fun(A,option(B)),fun(B,bool),M2)) ) ).

% ran_def
tff(fact_4105_ran__map__option,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: fun(C,A),M2: fun(B,option(C))] : ( ran(B,A,aa(fun(B,option(C)),fun(B,option(A)),aTP_Lamp_acx(fun(C,A),fun(fun(B,option(C)),fun(B,option(A))),F2),M2)) = aa(set(C),set(A),image2(C,A,F2),ran(B,C,M2)) ) ).

% ran_map_option
tff(fact_4106_folding__on_Oempty,axiom,
    ! [A: $tType,B: $tType,S: set(A),F2: fun(A,fun(B,B)),Z2: B] :
      ( finite_folding_on(A,B,S,F2)
     => ( aa(set(A),B,finite_folding_F(A,B,F2,Z2),bot_bot(set(A))) = Z2 ) ) ).

% folding_on.empty
tff(fact_4107_card_Ofolding__on__axioms,axiom,
    ! [A: $tType] : finite_folding_on(A,nat,top_top(set(A)),aTP_Lamp_sv(A,fun(nat,nat))) ).

% card.folding_on_axioms
tff(fact_4108_finite__set__of__finite__maps,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(B),bool,finite_finite2(B),B2))
       => pp(aa(set(fun(A,option(B))),bool,finite_finite2(fun(A,option(B))),aa(fun(fun(A,option(B)),bool),set(fun(A,option(B))),collect(fun(A,option(B))),aa(set(B),fun(fun(A,option(B)),bool),aTP_Lamp_acy(set(A),fun(set(B),fun(fun(A,option(B)),bool)),A3),B2)))) ) ) ).

% finite_set_of_finite_maps
tff(fact_4109_ran__add,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,option(B)),G: fun(A,option(B))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,F2)),dom(A,B,G)) = bot_bot(set(A)) )
     => ( ran(A,B,map_add(A,B,F2,G)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),ran(A,B,F2)),ran(A,B,G)) ) ) ).

% ran_add
tff(fact_4110_ran__map__add,axiom,
    ! [B: $tType,A: $tType,M1: fun(A,option(B)),M22: fun(A,option(B))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,M1)),dom(A,B,M22)) = bot_bot(set(A)) )
     => ( ran(A,B,map_add(A,B,M1,M22)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),ran(A,B,M1)),ran(A,B,M22)) ) ) ).

% ran_map_add
tff(fact_4111_graph__eq__to__snd__dom,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B))] : ( graph(A,B,M2) = aa(set(A),set(product_prod(A,B)),image2(A,product_prod(A,B),aTP_Lamp_acz(fun(A,option(B)),fun(A,product_prod(A,B)),M2)),dom(A,B,M2)) ) ).

% graph_eq_to_snd_dom
tff(fact_4112_empty__eq__map__add__iff,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,option(B)),G: fun(A,option(B))] :
      ( ( aTP_Lamp_abe(A,option(B)) = map_add(A,B,F2,G) )
    <=> ( ! [X3: A] : ( aa(A,option(B),F2,X3) = none(B) )
        & ! [X3: A] : ( aa(A,option(B),G,X3) = none(B) ) ) ) ).

% empty_eq_map_add_iff
tff(fact_4113_map__add__empty,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B))] : ( map_add(A,B,M2,aTP_Lamp_abe(A,option(B))) = M2 ) ).

% map_add_empty
tff(fact_4114_empty__map__add,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B))] : ( map_add(A,B,aTP_Lamp_abe(A,option(B)),M2) = M2 ) ).

% empty_map_add
tff(fact_4115_graph__empty,axiom,
    ! [B: $tType,A: $tType] : ( graph(A,B,aTP_Lamp_abe(A,option(B))) = bot_bot(set(product_prod(A,B))) ) ).

% graph_empty
tff(fact_4116_bot__filter__parametric,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool))] : pp(aa(filter(B),bool,aa(filter(A),fun(filter(B),bool),rel_filter(A,B,A3),bot_bot(filter(A))),bot_bot(filter(B)))) ).

% bot_filter_parametric
tff(fact_4117_graph__map__add,axiom,
    ! [B: $tType,A: $tType,M1: fun(A,option(B)),M22: fun(A,option(B))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,M1)),dom(A,B,M22)) = bot_bot(set(A)) )
     => ( graph(A,B,map_add(A,B,M1,M22)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),sup_sup(set(product_prod(A,B))),graph(A,B,M1)),graph(A,B,M22)) ) ) ).

% graph_map_add
tff(fact_4118_map__add__def,axiom,
    ! [B: $tType,A: $tType,M1: fun(A,option(B)),M22: fun(A,option(B)),X4: A] : ( aa(A,option(B),map_add(A,B,M1,M22),X4) = case_option(option(B),B,aa(A,option(B),M1,X4),some(B),aa(A,option(B),M22,X4)) ) ).

% map_add_def
tff(fact_4119_map__add__distinct__le,axiom,
    ! [B: $tType,A: $tType] :
      ( preorder(B)
     => ! [M2: fun(A,option(B)),M6: fun(A,option(B)),N: fun(A,option(B)),N8: fun(A,option(B))] :
          ( pp(aa(fun(A,option(B)),bool,aa(fun(A,option(B)),fun(fun(A,option(B)),bool),ord_less_eq(fun(A,option(B))),M2),M6))
         => ( pp(aa(fun(A,option(B)),bool,aa(fun(A,option(B)),fun(fun(A,option(B)),bool),ord_less_eq(fun(A,option(B))),N),N8))
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,M6)),dom(A,B,N8)) = bot_bot(set(A)) )
             => pp(aa(fun(A,option(B)),bool,aa(fun(A,option(B)),fun(fun(A,option(B)),bool),ord_less_eq(fun(A,option(B))),map_add(A,B,M2,N)),map_add(A,B,M6,N8))) ) ) ) ) ).

% map_add_distinct_le
tff(fact_4120_map__add__comm,axiom,
    ! [B: $tType,A: $tType,M1: fun(A,option(B)),M22: fun(A,option(B))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,M1)),dom(A,B,M22)) = bot_bot(set(A)) )
     => ( map_add(A,B,M1,M22) = map_add(A,B,M22,M1) ) ) ).

% map_add_comm
tff(fact_4121_map__add__left__comm,axiom,
    ! [B: $tType,A: $tType,A3: fun(A,option(B)),B2: fun(A,option(B)),C3: fun(A,option(B))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,A3)),dom(A,B,B2)) = bot_bot(set(A)) )
     => ( map_add(A,B,A3,map_add(A,B,B2,C3)) = map_add(A,B,B2,map_add(A,B,A3,C3)) ) ) ).

% map_add_left_comm
tff(fact_4122_graph__def,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B))] : ( graph(A,B,M2) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aTP_Lamp_ada(fun(A,option(B)),fun(product_prod(A,B),bool),M2)) ) ).

% graph_def
tff(fact_4123_graph__fun__upd__None,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B)),K: A] : ( graph(A,B,fun_upd(A,option(B),M2,K,none(B))) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(A,fun(product_prod(A,B),bool),aTP_Lamp_adb(fun(A,option(B)),fun(A,fun(product_prod(A,B),bool)),M2),K)) ) ).

% graph_fun_upd_None
tff(fact_4124_rel__filter_Ocases,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),F: filter(A),G4: filter(B)] :
      ( pp(aa(filter(B),bool,aa(filter(A),fun(filter(B),bool),rel_filter(A,B,R),F),G4))
     => ~ ! [Z8: filter(product_prod(A,B))] :
            ( eventually(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),R),Z8)
           => ( ( map_filter_on(product_prod(A,B),A,aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),R)),product_fst(A,B),Z8) = F )
             => ( map_filter_on(product_prod(A,B),B,aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),R)),product_snd(A,B),Z8) != G4 ) ) ) ) ).

% rel_filter.cases
tff(fact_4125_rel__filter_Osimps,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),F: filter(A),G4: filter(B)] :
      ( pp(aa(filter(B),bool,aa(filter(A),fun(filter(B),bool),rel_filter(A,B,R),F),G4))
    <=> ? [Z6: filter(product_prod(A,B))] :
          ( eventually(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),R),Z6)
          & ( map_filter_on(product_prod(A,B),A,aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),R)),product_fst(A,B),Z6) = F )
          & ( map_filter_on(product_prod(A,B),B,aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),R)),product_snd(A,B),Z6) = G4 ) ) ) ).

% rel_filter.simps
tff(fact_4126_rel__filter_Ointros,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),Z4: filter(product_prod(A,B)),F: filter(A),G4: filter(B)] :
      ( eventually(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),R),Z4)
     => ( ( map_filter_on(product_prod(A,B),A,aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),R)),product_fst(A,B),Z4) = F )
       => ( ( map_filter_on(product_prod(A,B),B,aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),R)),product_snd(A,B),Z4) = G4 )
         => pp(aa(filter(B),bool,aa(filter(A),fun(filter(B),bool),rel_filter(A,B,R),F),G4)) ) ) ) ).

% rel_filter.intros
tff(fact_4127_arg__min__SOME__Min,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [S: set(A),F2: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite2(A),S))
         => ( lattic7623131987881927897min_on(A,B,F2,S) = fChoice(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_adc(set(A),fun(fun(A,B),fun(A,bool)),S),F2)) ) ) ) ).

% arg_min_SOME_Min
tff(fact_4128_map__comp__def,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(B,option(C)),G: fun(A,option(B)),X4: A] : ( map_comp(B,C,A,F2,G,X4) = case_option(option(C),B,none(C),F2,aa(A,option(B),G,X4)) ) ).

% map_comp_def
tff(fact_4129_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( semiring_1_Nats(A) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_add(A,bool)) ) ) ).

% Nats_altdef1
tff(fact_4130_cSup__cInf,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S: set(A)] :
          ( ( S != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,S)
           => ( aa(set(A),A,complete_Sup_Sup(A),S) = aa(set(A),A,complete_Inf_Inf(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_ade(set(A),fun(A,bool),S))) ) ) ) ) ).

% cSup_cInf
tff(fact_4131_some__sym__eq__trivial,axiom,
    ! [A: $tType,X2: A] : ( fChoice(A,aa(A,fun(A,bool),fequal(A),X2)) = X2 ) ).

% some_sym_eq_trivial
tff(fact_4132_some__eq__trivial,axiom,
    ! [A: $tType,X2: A] : ( fChoice(A,aTP_Lamp_ct(A,fun(A,bool),X2)) = X2 ) ).

% some_eq_trivial
tff(fact_4133_some__equality,axiom,
    ! [A: $tType,P: fun(A,bool),A4: A] :
      ( pp(aa(A,bool,P,A4))
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
           => ( X = A4 ) )
       => ( fChoice(A,P) = A4 ) ) ) ).

% some_equality
tff(fact_4134_ball__empty,axiom,
    ! [A: $tType,P: fun(A,bool),X4: A] :
      ( pp(aa(set(A),bool,member(A,X4),bot_bot(set(A))))
     => pp(aa(A,bool,P,X4)) ) ).

% ball_empty
tff(fact_4135_Eps__case__prod__eq,axiom,
    ! [A: $tType,B: $tType,X2: A,Y: B] : ( fChoice(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(B,fun(A,fun(B,bool)),aTP_Lamp_et(A,fun(B,fun(A,fun(B,bool))),X2),Y))) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y) ) ).

% Eps_case_prod_eq
tff(fact_4136_map__comp__empty_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,M2: fun(C,option(B)),X4: A] : ( map_comp(C,B,A,M2,aTP_Lamp_abx(A,option(C)),X4) = none(B) ) ).

% map_comp_empty(1)
tff(fact_4137_map__comp__empty_I2_J,axiom,
    ! [C: $tType,B: $tType,D: $tType,M2: fun(C,option(B)),X4: C] : ( map_comp(B,D,C,aTP_Lamp_adf(B,option(D)),M2,X4) = none(D) ) ).

% map_comp_empty(2)
tff(fact_4138_some__insert__self,axiom,
    ! [A: $tType,S: set(A)] :
      ( ( S != bot_bot(set(A)) )
     => ( aa(set(A),set(A),insert(A,fChoice(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),S))),S) = S ) ) ).

% some_insert_self
tff(fact_4139_INF__bool__eq,axiom,
    ! [A: $tType] : ( aTP_Lamp_adg(set(A),fun(fun(A,bool),bool)) = ball(A) ) ).

% INF_bool_eq
tff(fact_4140_Ball__fold,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),A3))
           => pp(aa(A,bool,P,X3)) )
      <=> pp(finite_fold(A,bool,aTP_Lamp_adh(fun(A,bool),fun(A,fun(bool,bool)),P),fTrue,A3)) ) ) ).

% Ball_fold
tff(fact_4141_someI2,axiom,
    ! [A: $tType,P: fun(A,bool),A4: A,Q: fun(A,bool)] :
      ( pp(aa(A,bool,P,A4))
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
           => pp(aa(A,bool,Q,X)) )
       => pp(aa(A,bool,Q,fChoice(A,P))) ) ) ).

% someI2
tff(fact_4142_someI__ex,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ? [X_13: A] : pp(aa(A,bool,P,X_13))
     => pp(aa(A,bool,P,fChoice(A,P))) ) ).

% someI_ex
tff(fact_4143_someI2__ex,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( ? [X_13: A] : pp(aa(A,bool,P,X_13))
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
           => pp(aa(A,bool,Q,X)) )
       => pp(aa(A,bool,Q,fChoice(A,P))) ) ) ).

% someI2_ex
tff(fact_4144_someI2__bex,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,bool),Q: fun(A,bool)] :
      ( ? [X4: A] :
          ( pp(aa(set(A),bool,member(A,X4),A3))
          & pp(aa(A,bool,P,X4)) )
     => ( ! [X: A] :
            ( ( pp(aa(set(A),bool,member(A,X),A3))
              & pp(aa(A,bool,P,X)) )
           => pp(aa(A,bool,Q,X)) )
       => pp(aa(A,bool,Q,fChoice(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_dh(set(A),fun(fun(A,bool),fun(A,bool)),A3),P)))) ) ) ).

% someI2_bex
tff(fact_4145_some__eq__ex,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( pp(aa(A,bool,P,fChoice(A,P)))
    <=> ? [X_12: A] : pp(aa(A,bool,P,X_12)) ) ).

% some_eq_ex
tff(fact_4146_some1__equality,axiom,
    ! [A: $tType,P: fun(A,bool),A4: A] :
      ( ? [X4: A] :
          ( pp(aa(A,bool,P,X4))
          & ! [Y2: A] :
              ( pp(aa(A,bool,P,Y2))
             => ( Y2 = X4 ) ) )
     => ( pp(aa(A,bool,P,A4))
       => ( fChoice(A,P) = A4 ) ) ) ).

% some1_equality
tff(fact_4147_verit__sko__ex_H,axiom,
    ! [A: $tType,P: fun(A,bool),A3: bool] :
      ( ( pp(aa(A,bool,P,fChoice(A,P)))
      <=> pp(A3) )
     => ( ? [X_12: A] : pp(aa(A,bool,P,X_12))
      <=> pp(A3) ) ) ).

% verit_sko_ex'
tff(fact_4148_verit__sko__forall,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ! [X_12: A] : pp(aa(A,bool,P,X_12))
    <=> pp(aa(A,bool,P,fChoice(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P)))) ) ).

% verit_sko_forall
tff(fact_4149_verit__sko__forall_H,axiom,
    ! [A: $tType,P: fun(A,bool),A3: bool] :
      ( ( pp(aa(A,bool,P,fChoice(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P))))
      <=> pp(A3) )
     => ( ! [X_12: A] : pp(aa(A,bool,P,X_12))
      <=> pp(A3) ) ) ).

% verit_sko_forall'
tff(fact_4150_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B2: A,A3: A,P: fun(A,bool)] :
      ( ( B2 = A3 )
     => ( ( fChoice(A,P) = A3 )
      <=> ( fChoice(A,P) = B2 ) ) ) ).

% verit_sko_forall''
tff(fact_4151_verit__sko__ex__indirect,axiom,
    ! [A: $tType,X2: A,P: fun(A,bool)] :
      ( ( X2 = fChoice(A,P) )
     => ( ? [X_12: A] : pp(aa(A,bool,P,X_12))
      <=> pp(aa(A,bool,P,X2)) ) ) ).

% verit_sko_ex_indirect
tff(fact_4152_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,X2: A,P: fun(A,bool),P2: fun(A,bool)] :
      ( ( X2 = fChoice(A,P) )
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
          <=> pp(aa(A,bool,P2,X)) )
       => ( ? [X_12: A] : pp(aa(A,bool,P2,X_12))
        <=> pp(aa(A,bool,P,X2)) ) ) ) ).

% verit_sko_ex_indirect2
tff(fact_4153_verit__sko__forall__indirect,axiom,
    ! [A: $tType,X2: A,P: fun(A,bool)] :
      ( ( X2 = fChoice(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P)) )
     => ( ! [X_12: A] : pp(aa(A,bool,P,X_12))
      <=> pp(aa(A,bool,P,X2)) ) ) ).

% verit_sko_forall_indirect
tff(fact_4154_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,X2: A,P: fun(A,bool),P2: fun(A,bool)] :
      ( ( X2 = fChoice(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P)) )
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
          <=> pp(aa(A,bool,P2,X)) )
       => ( ! [X_12: A] : pp(aa(A,bool,P2,X_12))
        <=> pp(aa(A,bool,P,X2)) ) ) ) ).

% verit_sko_forall_indirect2
tff(fact_4155_Inter__eq,axiom,
    ! [A: $tType,A3: set(set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_adi(set(set(A)),fun(A,bool),A3)) ) ).

% Inter_eq
tff(fact_4156_some__elem,axiom,
    ! [A: $tType,S: set(A)] :
      ( ( S != bot_bot(set(A)) )
     => pp(aa(set(A),bool,member(A,fChoice(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),S))),S)) ) ).

% some_elem
tff(fact_4157_some__in__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,member(A,fChoice(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3))),A3))
    <=> ( A3 != bot_bot(set(A)) ) ) ).

% some_in_eq
tff(fact_4158_Ball__comp__iff,axiom,
    ! [A: $tType,B: $tType,C: $tType,A3: fun(B,set(C)),F2: fun(C,bool),G: fun(A,B),X4: A] :
      ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),comp(B,bool,A,aa(fun(C,bool),fun(B,bool),aTP_Lamp_adj(fun(B,set(C)),fun(fun(C,bool),fun(B,bool)),A3),F2)),G),X4))
    <=> ! [Xa2: C] :
          ( pp(aa(set(C),bool,member(C,Xa2),aa(A,set(C),aa(fun(A,B),fun(A,set(C)),comp(B,set(C),A,A3),G),X4)))
         => pp(aa(C,bool,F2,Xa2)) ) ) ).

% Ball_comp_iff
tff(fact_4159_Nats__mult,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(set(A),bool,member(A,A4),semiring_1_Nats(A)))
         => ( pp(aa(set(A),bool,member(A,B3),semiring_1_Nats(A)))
           => pp(aa(set(A),bool,member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),semiring_1_Nats(A))) ) ) ) ).

% Nats_mult
tff(fact_4160_Nats__1,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => pp(aa(set(A),bool,member(A,one_one(A)),semiring_1_Nats(A))) ) ).

% Nats_1
tff(fact_4161_eventually__ball__finite__distrib,axiom,
    ! [A: $tType,B: $tType,A3: set(A),P: fun(B,fun(A,bool)),Net: filter(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( eventually(B,aa(fun(B,fun(A,bool)),fun(B,bool),aTP_Lamp_adk(set(A),fun(fun(B,fun(A,bool)),fun(B,bool)),A3),P),Net)
      <=> ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),A3))
           => eventually(B,aa(A,fun(B,bool),aTP_Lamp_kr(fun(B,fun(A,bool)),fun(A,fun(B,bool)),P),X3),Net) ) ) ) ).

% eventually_ball_finite_distrib
tff(fact_4162_eventually__ball__finite,axiom,
    ! [A: $tType,B: $tType,A3: set(A),P: fun(B,fun(A,bool)),Net: filter(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),A3))
           => eventually(B,aa(A,fun(B,bool),aTP_Lamp_kr(fun(B,fun(A,bool)),fun(A,fun(B,bool)),P),X),Net) )
       => eventually(B,aa(fun(B,fun(A,bool)),fun(B,bool),aTP_Lamp_adk(set(A),fun(fun(B,fun(A,bool)),fun(B,bool)),A3),P),Net) ) ) ).

% eventually_ball_finite
tff(fact_4163_Field__not__elem,axiom,
    ! [A: $tType,V: A,R: set(product_prod(A,A))] :
      ( ~ pp(aa(set(A),bool,member(A,V),field2(A,R)))
     => ! [X4: product_prod(A,A)] :
          ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),X4),R))
         => pp(aa(product_prod(A,A),bool,aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aTP_Lamp_adl(A,fun(A,fun(A,bool)),V)),X4)) ) ) ).

% Field_not_elem
tff(fact_4164_Collect__ball__eq,axiom,
    ! [A: $tType,B: $tType,A3: set(B),P: fun(A,fun(B,bool))] : ( aa(fun(A,bool),set(A),collect(A),aa(fun(A,fun(B,bool)),fun(A,bool),aTP_Lamp_adm(set(B),fun(fun(A,fun(B,bool)),fun(A,bool)),A3),P)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_gw(fun(A,fun(B,bool)),fun(B,set(A)),P)),A3)) ) ).

% Collect_ball_eq
tff(fact_4165_INTER__eq,axiom,
    ! [A: $tType,B: $tType,B2: fun(B,set(A)),A3: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3)) = aa(fun(A,bool),set(A),collect(A),aa(set(B),fun(A,bool),aTP_Lamp_adn(fun(B,set(A)),fun(set(B),fun(A,bool)),B2),A3)) ) ).

% INTER_eq
tff(fact_4166_split__paired__Eps,axiom,
    ! [B: $tType,A: $tType,P: fun(product_prod(A,B),bool)] : ( fChoice(product_prod(A,B),P) = fChoice(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_ado(fun(product_prod(A,B),bool),fun(A,fun(B,bool)),P))) ) ).

% split_paired_Eps
tff(fact_4167_irrefl__distinct,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( irrefl(A,R2)
    <=> ! [X3: product_prod(A,A)] :
          ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),X3),R2))
         => pp(aa(product_prod(A,A),bool,aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aTP_Lamp_adp(A,fun(A,bool))),X3)) ) ) ).

% irrefl_distinct
tff(fact_4168_some__theI,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool))] :
      ( ? [A14: A,X_13: B] : pp(aa(B,bool,aa(A,fun(B,bool),P,A14),X_13))
     => ( ! [B13: B,B24: B] :
            ( ? [A5: A] : pp(aa(B,bool,aa(A,fun(B,bool),P,A5),B13))
           => ( ? [A5: A] : pp(aa(B,bool,aa(A,fun(B,bool),P,A5),B24))
             => ( B13 = B24 ) ) )
       => pp(aa(B,bool,aa(A,fun(B,bool),P,fChoice(A,aTP_Lamp_gu(fun(A,fun(B,bool)),fun(A,bool),P))),the(B,aTP_Lamp_adq(fun(A,fun(B,bool)),fun(B,bool),P)))) ) ) ).

% some_theI
tff(fact_4169_congruent__def,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,A)),F2: fun(A,B)] :
      ( equiv_congruent(A,B,R2,F2)
    <=> ! [X3: product_prod(A,A)] :
          ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),X3),R2))
         => pp(aa(product_prod(A,A),bool,aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aTP_Lamp_adr(fun(A,B),fun(A,fun(A,bool)),F2)),X3)) ) ) ).

% congruent_def
tff(fact_4170_congruent2__def,axiom,
    ! [B: $tType,C: $tType,A: $tType,R12: set(product_prod(A,A)),R23: set(product_prod(B,B)),F2: fun(A,fun(B,C))] :
      ( equiv_congruent2(A,B,C,R12,R23,F2)
    <=> ! [X3: product_prod(A,A)] :
          ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),X3),R12))
         => pp(aa(product_prod(A,A),bool,aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(fun(A,fun(B,C)),fun(A,fun(A,bool)),aTP_Lamp_adt(set(product_prod(B,B)),fun(fun(A,fun(B,C)),fun(A,fun(A,bool))),R23),F2)),X3)) ) ) ).

% congruent2_def
tff(fact_4171_equiv__Eps__in,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X5: set(A)] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(set(A)),bool,member(set(A),X5),equiv_quotient(A,A3,R2)))
       => pp(aa(set(A),bool,member(A,fChoice(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),X5))),X5)) ) ) ).

% equiv_Eps_in
tff(fact_4172_equiv__Eps__preserves,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X5: set(A)] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(set(A)),bool,member(set(A),X5),equiv_quotient(A,A3,R2)))
       => pp(aa(set(A),bool,member(A,fChoice(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),X5))),A3)) ) ) ).

% equiv_Eps_preserves
tff(fact_4173_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] : ( aa(set(A),A,complete_Sup_Sup(A),A3) = aa(set(A),A,complete_Inf_Inf(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_adu(set(A),fun(A,bool),A3))) ) ) ).

% Sup_eq_Inf
tff(fact_4174_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),A3) = aa(set(A),A,complete_Sup_Sup(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_adv(set(A),fun(A,bool),A3))) ) ) ).

% Inf_eq_Sup
tff(fact_4175_trans__join,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( trans(A,R2)
    <=> ! [X3: product_prod(A,A)] :
          ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),X3),R2))
         => pp(aa(product_prod(A,A),bool,aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aTP_Lamp_adx(set(product_prod(A,A)),fun(A,fun(A,bool)),R2)),X3)) ) ) ).

% trans_join
tff(fact_4176_refl__on__def_H,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A))] :
      ( refl_on(A,A3,R2)
    <=> ( ! [X3: product_prod(A,A)] :
            ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),X3),R2))
           => pp(aa(product_prod(A,A),bool,aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aTP_Lamp_ady(set(A),fun(A,fun(A,bool)),A3)),X3)) )
        & ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),A3))
           => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),X3)),R2)) ) ) ) ).

% refl_on_def'
tff(fact_4177_Sup__int__def,axiom,
    ! [X5: set(int)] : ( aa(set(int),int,complete_Sup_Sup(int),X5) = the(int,aTP_Lamp_adz(set(int),fun(int,bool),X5)) ) ).

% Sup_int_def
tff(fact_4178_arg__min__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ord(A)
     => ! [F2: fun(B,A),P: fun(B,bool)] : ( lattices_ord_arg_min(B,A,F2,P) = fChoice(B,lattic501386751177426532rg_min(B,A,F2,P)) ) ) ).

% arg_min_def
tff(fact_4179_Eps__case__prod,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool))] : ( fChoice(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),P)) = fChoice(product_prod(A,B),aTP_Lamp_ev(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),P)) ) ).

% Eps_case_prod
tff(fact_4180_Union__maximal__sets,axiom,
    ! [A: $tType,F14: set(set(A))] :
      ( pp(aa(set(set(A)),bool,finite_finite2(set(A)),F14))
     => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_aea(set(set(A)),fun(set(A),bool),F14))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),F14) ) ) ).

% Union_maximal_sets
tff(fact_4181_Sup__Inf,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: set(set(A))] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image2(set(A),A,complete_Inf_Inf(A)),A3)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image2(set(A),A,complete_Sup_Sup(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_aeb(set(set(A)),fun(set(A),bool),A3)))) ) ) ).

% Sup_Inf
tff(fact_4182_Inf__Sup,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: set(set(A))] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image2(set(A),A,complete_Sup_Sup(A)),A3)) = aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image2(set(A),A,complete_Inf_Inf(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_aeb(set(set(A)),fun(set(A),bool),A3)))) ) ) ).

% Inf_Sup
tff(fact_4183_Inf__filter__def,axiom,
    ! [A: $tType,S: set(filter(A))] : ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),S) = aa(set(filter(A)),filter(A),complete_Sup_Sup(filter(A)),aa(fun(filter(A),bool),set(filter(A)),collect(filter(A)),aTP_Lamp_aec(set(filter(A)),fun(filter(A),bool),S))) ) ).

% Inf_filter_def
tff(fact_4184_proj__Eps,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A)),X5: set(A)] :
      ( equiv_equiv(A,A3,R2)
     => ( pp(aa(set(set(A)),bool,member(set(A),X5),equiv_quotient(A,A3,R2)))
       => ( equiv_proj(A,A,R2,fChoice(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),X5))) = X5 ) ) ) ).

% proj_Eps
tff(fact_4185_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(set(A))] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image2(set(A),A,complete_Inf_Inf(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_aed(set(set(A)),fun(set(A),bool),A3))))),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image2(set(A),A,complete_Sup_Sup(A)),A3)))) ) ).

% Sup_Inf_le
tff(fact_4186_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: set(set(A))] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image2(set(A),A,complete_Sup_Sup(A)),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image2(set(A),A,complete_Inf_Inf(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_aeb(set(set(A)),fun(set(A),bool),A3)))))) ) ).

% Inf_Sup_le
tff(fact_4187_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [A3: set(set(A))] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image2(set(A),A,complete_Sup_Sup(A)),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image2(set(A),A,complete_Inf_Inf(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_aee(set(set(A)),fun(set(A),bool),A3)))))) ) ).

% finite_Inf_Sup
tff(fact_4188_INF__SUP__set,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [G: fun(B,A),A3: set(set(B))] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(set(B)),set(A),image2(set(B),A,aTP_Lamp_aef(fun(B,A),fun(set(B),A),G)),A3)) = aa(set(A),A,complete_Sup_Sup(A),aa(set(set(B)),set(A),image2(set(B),A,aTP_Lamp_aeg(fun(B,A),fun(set(B),A),G)),aa(fun(set(B),bool),set(set(B)),collect(set(B)),aTP_Lamp_aeh(set(set(B)),fun(set(B),bool),A3)))) ) ) ).

% INF_SUP_set
tff(fact_4189_SUP__INF__set,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [G: fun(B,A),A3: set(set(B))] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(set(B)),set(A),image2(set(B),A,aTP_Lamp_aeg(fun(B,A),fun(set(B),A),G)),A3)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(set(B)),set(A),image2(set(B),A,aTP_Lamp_aef(fun(B,A),fun(set(B),A),G)),aa(fun(set(B),bool),set(set(B)),collect(set(B)),aTP_Lamp_aeh(set(set(B)),fun(set(B),bool),A3)))) ) ) ).

% SUP_INF_set
tff(fact_4190_option__Inf__Sup,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: set(set(option(A)))] : pp(aa(option(A),bool,aa(option(A),fun(option(A),bool),ord_less_eq(option(A)),aa(set(option(A)),option(A),complete_Inf_Inf(option(A)),aa(set(set(option(A))),set(option(A)),image2(set(option(A)),option(A),complete_Sup_Sup(option(A))),A3))),aa(set(option(A)),option(A),complete_Sup_Sup(option(A)),aa(set(set(option(A))),set(option(A)),image2(set(option(A)),option(A),complete_Inf_Inf(option(A))),aa(fun(set(option(A)),bool),set(set(option(A))),collect(set(option(A))),aTP_Lamp_aei(set(set(option(A))),fun(set(option(A)),bool),A3)))))) ) ).

% option_Inf_Sup
tff(fact_4191_Eps__Opt__def,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ( ? [X_13: A] : pp(aa(A,bool,P,X_13))
       => ( eps_Opt(A,P) = aa(A,option(A),some(A),fChoice(A,P)) ) )
      & ( ~ ? [X_1: A] : pp(aa(A,bool,P,X_1))
       => ( eps_Opt(A,P) = none(A) ) ) ) ).

% Eps_Opt_def
tff(fact_4192_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( semiring_1_Nats(A) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_aej(A,bool)) ) ) ).

% Nats_altdef2
tff(fact_4193_cInf__cSup,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S: set(A)] :
          ( ( S != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,condit1013018076250108175_below(A),S))
           => ( aa(set(A),A,complete_Inf_Inf(A),S) = aa(set(A),A,complete_Sup_Sup(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_aek(set(A),fun(A,bool),S))) ) ) ) ) ).

% cInf_cSup
tff(fact_4194_Under__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] : ( order_Under(A,R2,A3) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_ael(set(product_prod(A,A)),fun(set(A),fun(A,bool)),R2),A3)) ) ).

% Under_def
tff(fact_4195_UnderS__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] : ( order_UnderS(A,R2,A3) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_aem(set(product_prod(A,A)),fun(set(A),fun(A,bool)),R2),A3)) ) ).

% UnderS_def
tff(fact_4196_Above__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] : ( order_Above(A,R2,A3) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_aen(set(product_prod(A,A)),fun(set(A),fun(A,bool)),R2),A3)) ) ).

% Above_def
tff(fact_4197_fun__of__rel__def,axiom,
    ! [A: $tType,B: $tType,R: set(product_prod(B,A)),X2: B] : ( fun_of_rel(B,A,R,X2) = fChoice(A,aa(B,fun(A,bool),aTP_Lamp_jt(set(product_prod(B,A)),fun(B,fun(A,bool)),R),X2)) ) ).

% fun_of_rel_def
tff(fact_4198_conj__comp__iff,axiom,
    ! [B: $tType,A: $tType,P: fun(B,bool),Q: fun(B,bool),G: fun(A,B),X4: A] :
      ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),comp(B,bool,A,aa(fun(B,bool),fun(B,bool),aTP_Lamp_aeo(fun(B,bool),fun(fun(B,bool),fun(B,bool)),P),Q)),G),X4))
    <=> ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),comp(B,bool,A,P),G),X4))
        & pp(aa(A,bool,aa(fun(A,B),fun(A,bool),comp(B,bool,A,Q),G),X4)) ) ) ).

% conj_comp_iff
tff(fact_4199_iteratesp_Omono,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [F2: fun(A,A)] : order_mono(fun(A,bool),fun(A,bool),aTP_Lamp_aep(fun(A,A),fun(fun(A,bool),fun(A,bool)),F2)) ) ).

% iteratesp.mono
tff(fact_4200_Sup__filter__def,axiom,
    ! [A: $tType,S: set(filter(A))] : ( aa(set(filter(A)),filter(A),complete_Sup_Sup(filter(A)),S) = aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),aTP_Lamp_aeq(set(filter(A)),fun(fun(A,bool),bool),S)) ) ).

% Sup_filter_def
tff(fact_4201_min__ext__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( min_ext(A,R2) = aa(fun(product_prod(set(A),set(A)),bool),set(product_prod(set(A),set(A))),collect(product_prod(set(A),set(A))),aTP_Lamp_aer(set(product_prod(A,A)),fun(product_prod(set(A),set(A)),bool),R2)) ) ).

% min_ext_def
tff(fact_4202_AboveS__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] : ( order_AboveS(A,R2,A3) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_aes(set(product_prod(A,A)),fun(set(A),fun(A,bool)),R2),A3)) ) ).

% AboveS_def
tff(fact_4203_bex__empty,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ~ ? [X4: A] :
          ( pp(aa(set(A),bool,member(A,X4),bot_bot(set(A))))
          & pp(aa(A,bool,P,X4)) ) ).

% bex_empty
tff(fact_4204_finite__Collect__bex,axiom,
    ! [B: $tType,A: $tType,A3: set(A),Q: fun(B,fun(A,bool))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,fun(A,bool)),fun(B,bool),aTP_Lamp_aet(set(A),fun(fun(B,fun(A,bool)),fun(B,bool)),A3),Q))))
      <=> ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),A3))
           => pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(A,fun(B,bool),aTP_Lamp_kr(fun(B,fun(A,bool)),fun(A,fun(B,bool)),Q),X3)))) ) ) ) ).

% finite_Collect_bex
tff(fact_4205_Image__Collect__case__prod,axiom,
    ! [A: $tType,B: $tType,P: fun(B,fun(A,bool)),A3: set(B)] : ( aa(set(B),set(A),image(B,A,aa(fun(product_prod(B,A),bool),set(product_prod(B,A)),collect(product_prod(B,A)),aa(fun(B,fun(A,bool)),fun(product_prod(B,A),bool),product_case_prod(B,A,bool),P))),A3) = aa(fun(A,bool),set(A),collect(A),aa(set(B),fun(A,bool),aTP_Lamp_aeu(fun(B,fun(A,bool)),fun(set(B),fun(A,bool)),P),A3)) ) ).

% Image_Collect_case_prod
tff(fact_4206_SUP__bool__eq,axiom,
    ! [A: $tType] : ( aTP_Lamp_aev(set(A),fun(fun(A,bool),bool)) = bex(A) ) ).

% SUP_bool_eq
tff(fact_4207_image__def,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A3: set(A)] : ( aa(set(A),set(B),image2(A,B,F2),A3) = aa(fun(B,bool),set(B),collect(B),aa(set(A),fun(B,bool),aTP_Lamp_aew(fun(A,B),fun(set(A),fun(B,bool)),F2),A3)) ) ).

% image_def
tff(fact_4208_Union__eq,axiom,
    ! [A: $tType,A3: set(set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_aex(set(set(A)),fun(A,bool),A3)) ) ).

% Union_eq
tff(fact_4209_chain__compr,axiom,
    ! [A: $tType,Ord: fun(A,fun(A,bool)),A3: set(A),P: fun(A,bool)] :
      ( comple1602240252501008431_chain(A,Ord,A3)
     => comple1602240252501008431_chain(A,Ord,aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_dh(set(A),fun(fun(A,bool),fun(A,bool)),A3),P))) ) ).

% chain_compr
tff(fact_4210_chain__empty,axiom,
    ! [A: $tType,Ord: fun(A,fun(A,bool))] : comple1602240252501008431_chain(A,Ord,bot_bot(set(A))) ).

% chain_empty
tff(fact_4211_sup__filter__def,axiom,
    ! [A: $tType,F: filter(A),F3: filter(A)] : ( aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),sup_sup(filter(A)),F),F3) = aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),aa(filter(A),fun(fun(A,bool),bool),aTP_Lamp_aey(filter(A),fun(filter(A),fun(fun(A,bool),bool)),F),F3)) ) ).

% sup_filter_def
tff(fact_4212_bot__filter__def,axiom,
    ! [A: $tType] : ( bot_bot(filter(A)) = aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),aTP_Lamp_aez(fun(A,bool),bool)) ) ).

% bot_filter_def
tff(fact_4213_Image__def,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B)),S2: set(A)] : ( aa(set(A),set(B),image(A,B,R2),S2) = aa(fun(B,bool),set(B),collect(B),aa(set(A),fun(B,bool),aTP_Lamp_afa(set(product_prod(A,B)),fun(set(A),fun(B,bool)),R2),S2)) ) ).

% Image_def
tff(fact_4214_Collect__bex__eq,axiom,
    ! [A: $tType,B: $tType,A3: set(B),P: fun(A,fun(B,bool))] : ( aa(fun(A,bool),set(A),collect(A),aa(fun(A,fun(B,bool)),fun(A,bool),aTP_Lamp_afb(set(B),fun(fun(A,fun(B,bool)),fun(A,bool)),A3),P)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_gw(fun(A,fun(B,bool)),fun(B,set(A)),P)),A3)) ) ).

% Collect_bex_eq
tff(fact_4215_UNION__eq,axiom,
    ! [A: $tType,B: $tType,B2: fun(B,set(A)),A3: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B2),A3)) = aa(fun(A,bool),set(A),collect(A),aa(set(B),fun(A,bool),aTP_Lamp_afc(fun(B,set(A)),fun(set(B),fun(A,bool)),B2),A3)) ) ).

% UNION_eq
tff(fact_4216_vimage__image__eq,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A3: set(A)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F2),aa(set(A),set(B),image2(A,B,F2),A3)) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_afd(fun(A,B),fun(set(A),fun(A,bool)),F2),A3)) ) ).

% vimage_image_eq
tff(fact_4217_chain__singleton,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [X2: A] : comple1602240252501008431_chain(A,ord_less_eq(A),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) ) ).

% chain_singleton
tff(fact_4218_Bex__fold,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ? [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),A3))
            & pp(aa(A,bool,P,X3)) )
      <=> pp(finite_fold(A,bool,aTP_Lamp_afe(fun(A,bool),fun(A,fun(bool,bool)),P),fFalse,A3)) ) ) ).

% Bex_fold
tff(fact_4219_AboveS__disjoint,axiom,
    ! [A: $tType,A3: set(A),R2: set(product_prod(A,A))] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),order_AboveS(A,R2,A3)) = bot_bot(set(A)) ) ).

% AboveS_disjoint
tff(fact_4220_max__extp_Omax__extI,axiom,
    ! [A: $tType,X5: set(A),Y3: set(A),R: fun(A,fun(A,bool))] :
      ( pp(aa(set(A),bool,finite_finite2(A),X5))
     => ( pp(aa(set(A),bool,finite_finite2(A),Y3))
       => ( ( Y3 != aa(fun(A,bool),set(A),collect(A),bot_bot(fun(A,bool))) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),X5))
               => ? [Xa3: A] :
                    ( pp(aa(set(A),bool,member(A,Xa3),Y3))
                    & pp(aa(A,bool,aa(A,fun(A,bool),R,X),Xa3)) ) )
           => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),max_extp(A,R),X5),Y3)) ) ) ) ) ).

% max_extp.max_extI
tff(fact_4221_max__extp_Osimps,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),A13: set(A),A23: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),max_extp(A,R),A13),A23))
    <=> ( pp(aa(set(A),bool,finite_finite2(A),A13))
        & pp(aa(set(A),bool,finite_finite2(A),A23))
        & ( A23 != aa(fun(A,bool),set(A),collect(A),bot_bot(fun(A,bool))) )
        & ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),A13))
           => ? [Xa2: A] :
                ( pp(aa(set(A),bool,member(A,Xa2),A23))
                & pp(aa(A,bool,aa(A,fun(A,bool),R,X3),Xa2)) ) ) ) ) ).

% max_extp.simps
tff(fact_4222_max__extp_Ocases,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),A13: set(A),A23: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),max_extp(A,R),A13),A23))
     => ~ ( pp(aa(set(A),bool,finite_finite2(A),A13))
         => ( pp(aa(set(A),bool,finite_finite2(A),A23))
           => ( ( A23 != aa(fun(A,bool),set(A),collect(A),bot_bot(fun(A,bool))) )
             => ~ ! [X4: A] :
                    ( pp(aa(set(A),bool,member(A,X4),A13))
                   => ? [Xa4: A] :
                        ( pp(aa(set(A),bool,member(A,Xa4),A23))
                        & pp(aa(A,bool,aa(A,fun(A,bool),R,X4),Xa4)) ) ) ) ) ) ) ).

% max_extp.cases
tff(fact_4223_principal__def,axiom,
    ! [A: $tType,S: set(A)] : ( principal(A,S) = aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),aa(set(A),fun(fun(A,bool),bool),ball(A),S)) ) ).

% principal_def
tff(fact_4224_filtermap__def,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),F: filter(A)] : ( filtermap(A,B,F2,F) = aa(fun(fun(B,bool),bool),filter(B),abs_filter(B),aa(filter(A),fun(fun(B,bool),bool),aTP_Lamp_aff(fun(A,B),fun(filter(A),fun(fun(B,bool),bool)),F2),F)) ) ).

% filtermap_def
tff(fact_4225_map__filter__on__def,axiom,
    ! [B: $tType,A: $tType,X5: set(A),F2: fun(A,B),F: filter(A)] : ( map_filter_on(A,B,X5,F2,F) = aa(fun(fun(B,bool),bool),filter(B),abs_filter(B),aa(filter(A),fun(fun(B,bool),bool),aa(fun(A,B),fun(filter(A),fun(fun(B,bool),bool)),aTP_Lamp_afh(set(A),fun(fun(A,B),fun(filter(A),fun(fun(B,bool),bool))),X5),F2),F)) ) ).

% map_filter_on_def
tff(fact_4226_in__chain__finite,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [A3: set(A)] :
          ( comple1602240252501008431_chain(A,ord_less_eq(A),A3)
         => ( pp(aa(set(A),bool,finite_finite2(A),A3))
           => ( ( A3 != bot_bot(set(A)) )
             => pp(aa(set(A),bool,member(A,aa(set(A),A,complete_Sup_Sup(A),A3)),A3)) ) ) ) ) ).

% in_chain_finite
tff(fact_4227_map__project__def,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,option(B)),A3: set(A)] : ( map_project(A,B,F2,A3) = aa(fun(B,bool),set(B),collect(B),aa(set(A),fun(B,bool),aTP_Lamp_afi(fun(A,option(B)),fun(set(A),fun(B,bool)),F2),A3)) ) ).

% map_project_def
tff(fact_4228_iteratesp__def,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [X4: fun(A,A)] : ( comple7512665784863727008ratesp(A,X4) = complete_lattice_lfp(fun(A,bool),aTP_Lamp_aep(fun(A,A),fun(fun(A,bool),fun(A,bool)),X4)) ) ) ).

% iteratesp_def
tff(fact_4229_wo__rel_Osuc__greater,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),B2: set(A),B3: A] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),field2(A,R2)))
       => ( ( order_AboveS(A,R2,B2) != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,member(A,B3),B2))
           => ( ( bNF_Wellorder_wo_suc(A,R2,B2) != B3 )
              & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B3),bNF_Wellorder_wo_suc(A,R2,B2))),R2)) ) ) ) ) ) ).

% wo_rel.suc_greater
tff(fact_4230_wo__rel_Osuc__AboveS,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),B2: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),field2(A,R2)))
       => ( ( order_AboveS(A,R2,B2) != bot_bot(set(A)) )
         => pp(aa(set(A),bool,member(A,bNF_Wellorder_wo_suc(A,R2,B2)),order_AboveS(A,R2,B2))) ) ) ) ).

% wo_rel.suc_AboveS
tff(fact_4231_wo__rel_Osuc__inField,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),B2: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),field2(A,R2)))
       => ( ( order_AboveS(A,R2,B2) != bot_bot(set(A)) )
         => pp(aa(set(A),bool,member(A,bNF_Wellorder_wo_suc(A,R2,B2)),field2(A,R2))) ) ) ) ).

% wo_rel.suc_inField
tff(fact_4232_max__ext__eq,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( max_ext(A,R) = aa(fun(product_prod(set(A),set(A)),bool),set(product_prod(set(A),set(A))),collect(product_prod(set(A),set(A))),aa(fun(set(A),fun(set(A),bool)),fun(product_prod(set(A),set(A)),bool),product_case_prod(set(A),set(A),bool),aTP_Lamp_afj(set(product_prod(A,A)),fun(set(A),fun(set(A),bool)),R))) ) ).

% max_ext_eq
tff(fact_4233_wo__rel_Osuc__ofilter__in,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A),B3: A] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( order_ofilter(A,R2,A3)
       => ( ( order_AboveS(A,R2,A3) != bot_bot(set(A)) )
         => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B3),bNF_Wellorder_wo_suc(A,R2,A3))),R2))
           => ( ( B3 != bNF_Wellorder_wo_suc(A,R2,A3) )
             => pp(aa(set(A),bool,member(A,B3),A3)) ) ) ) ) ) ).

% wo_rel.suc_ofilter_in
tff(fact_4234_univ__def,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),X5: set(B)] : ( bNF_Greatest_univ(B,A,F2,X5) = aa(B,A,F2,fChoice(B,aTP_Lamp_ni(set(B),fun(B,bool),X5))) ) ).

% univ_def
tff(fact_4235_flip__pred,axiom,
    ! [A: $tType,B: $tType,A3: set(product_prod(A,B)),R: fun(B,fun(A,bool))] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),A3),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),conversep(B,A,R)))))
     => pp(aa(set(product_prod(B,A)),bool,aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),bool),ord_less_eq(set(product_prod(B,A))),aa(set(product_prod(A,B)),set(product_prod(B,A)),image2(product_prod(A,B),product_prod(B,A),aa(fun(A,fun(B,product_prod(B,A))),fun(product_prod(A,B),product_prod(B,A)),product_case_prod(A,B,product_prod(B,A)),aTP_Lamp_ei(A,fun(B,product_prod(B,A))))),A3)),aa(fun(product_prod(B,A),bool),set(product_prod(B,A)),collect(product_prod(B,A)),aa(fun(B,fun(A,bool)),fun(product_prod(B,A),bool),product_case_prod(B,A,bool),R)))) ) ).

% flip_pred
tff(fact_4236_conversep__noteq,axiom,
    ! [A: $tType,X4: A,Xa3: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),conversep(A,A,aTP_Lamp_adp(A,fun(A,bool))),X4),Xa3))
    <=> ( X4 != Xa3 ) ) ).

% conversep_noteq
tff(fact_4237_eventually__all__finite,axiom,
    ! [B: $tType,A: $tType] :
      ( finite_finite(B)
     => ! [P: fun(A,fun(B,bool)),Net: filter(A)] :
          ( ! [Y2: B] : eventually(A,aa(B,fun(A,bool),aTP_Lamp_afk(fun(A,fun(B,bool)),fun(B,fun(A,bool)),P),Y2),Net)
         => eventually(A,aTP_Lamp_afl(fun(A,fun(B,bool)),fun(A,bool),P),Net) ) ) ).

% eventually_all_finite
tff(fact_4238_converse__meet,axiom,
    ! [A: $tType,B: $tType,R2: fun(B,fun(A,bool)),S2: fun(B,fun(A,bool))] : ( conversep(B,A,aa(fun(B,fun(A,bool)),fun(B,fun(A,bool)),aa(fun(B,fun(A,bool)),fun(fun(B,fun(A,bool)),fun(B,fun(A,bool))),inf_inf(fun(B,fun(A,bool))),R2),S2)) = aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),conversep(B,A,R2)),conversep(B,A,S2)) ) ).

% converse_meet
tff(fact_4239_rel__fun__def,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A3: fun(A,fun(C,bool)),B2: fun(B,fun(D,bool)),X4: fun(A,B),Xa3: fun(C,D)] :
      ( pp(aa(fun(C,D),bool,aa(fun(A,B),fun(fun(C,D),bool),bNF_rel_fun(A,C,B,D,A3,B2),X4),Xa3))
    <=> ! [Xb2: A,Y4: C] :
          ( pp(aa(C,bool,aa(A,fun(C,bool),A3,Xb2),Y4))
         => pp(aa(D,bool,aa(B,fun(D,bool),B2,aa(A,B,X4,Xb2)),aa(C,D,Xa3,Y4))) ) ) ).

% rel_fun_def
tff(fact_4240_rel__fun__eq__rel,axiom,
    ! [B: $tType,C: $tType,A: $tType,R: fun(B,fun(C,bool)),X4: fun(A,B),Xa3: fun(A,C)] :
      ( pp(aa(fun(A,C),bool,aa(fun(A,B),fun(fun(A,C),bool),bNF_rel_fun(A,A,B,C,fequal(A),R),X4),Xa3))
    <=> ! [Xb2: A] : pp(aa(C,bool,aa(B,fun(C,bool),R,aa(A,B,X4,Xb2)),aa(A,C,Xa3,Xb2))) ) ).

% rel_fun_eq_rel
tff(fact_4241_top__filter__def,axiom,
    ! [A: $tType] : ( top_top(filter(A)) = aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),fAll(A)) ) ).

% top_filter_def
tff(fact_4242_conversep__converse__eq,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B)),X4: B,Xa3: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),conversep(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),R2)),X4),Xa3))
    <=> pp(aa(set(product_prod(B,A)),bool,member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X4),Xa3)),converse(A,B,R2))) ) ).

% conversep_converse_eq
tff(fact_4243_converse__def,axiom,
    ! [B: $tType,A: $tType,X4: set(product_prod(A,B))] : ( converse(A,B,X4) = aa(fun(product_prod(B,A),bool),set(product_prod(B,A)),collect(product_prod(B,A)),aa(fun(B,fun(A,bool)),fun(product_prod(B,A),bool),product_case_prod(B,A,bool),conversep(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),X4)))) ) ).

% converse_def
tff(fact_4244_finite__set__of__finite__funs,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B),D3: B] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(B),bool,finite_finite2(B),B2))
       => pp(aa(set(fun(A,B)),bool,finite_finite2(fun(A,B)),aa(fun(fun(A,B),bool),set(fun(A,B)),collect(fun(A,B)),aa(B,fun(fun(A,B),bool),aa(set(B),fun(B,fun(fun(A,B),bool)),aTP_Lamp_afm(set(A),fun(set(B),fun(B,fun(fun(A,B),bool))),A3),B2),D3)))) ) ) ).

% finite_set_of_finite_funs
tff(fact_4245_Collect__all__eq,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,bool))] : ( aa(fun(A,bool),set(A),collect(A),aTP_Lamp_afn(fun(A,fun(B,bool)),fun(A,bool),P)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_gw(fun(A,fun(B,bool)),fun(B,set(A)),P)),top_top(set(B)))) ) ).

% Collect_all_eq
tff(fact_4246_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,bool)] :
          ( eventually(A,P,at_top(A))
         => eventually(A,aTP_Lamp_afo(fun(A,bool),fun(A,bool),P),at_top(A)) ) ) ).

% eventually_all_ge_at_top
tff(fact_4247_Least__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [P: fun(A,bool)] : ( ord_Least(A,P) = the(A,aTP_Lamp_afp(fun(A,bool),fun(A,bool),P)) ) ) ).

% Least_def
tff(fact_4248_wo__rel_Oofilter__UNION,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(A,A)),I: set(B),A3: fun(B,set(A))] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( ! [I3: B] :
            ( pp(aa(set(B),bool,member(B,I3),I))
           => order_ofilter(A,R2,aa(B,set(A),A3,I3)) )
       => order_ofilter(A,R2,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))) ) ) ).

% wo_rel.ofilter_UNION
tff(fact_4249_inf__filter__def,axiom,
    ! [A: $tType,F: filter(A),F3: filter(A)] : ( aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F),F3) = aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),aa(filter(A),fun(fun(A,bool),bool),aTP_Lamp_afq(filter(A),fun(filter(A),fun(fun(A,bool),bool)),F),F3)) ) ).

% inf_filter_def
tff(fact_4250_ofilterIncl__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( bNF_We413866401316099525erIncl(A,R2) = aa(fun(product_prod(set(A),set(A)),bool),set(product_prod(set(A),set(A))),collect(product_prod(set(A),set(A))),aa(fun(set(A),fun(set(A),bool)),fun(product_prod(set(A),set(A)),bool),product_case_prod(set(A),set(A),bool),aTP_Lamp_afr(set(product_prod(A,A)),fun(set(A),fun(set(A),bool)),R2))) ) ).

% ofilterIncl_def
tff(fact_4251_Greatest__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool)] : ( order_Greatest(A,P) = the(A,aTP_Lamp_afs(fun(A,bool),fun(A,bool),P)) ) ) ).

% Greatest_def
tff(fact_4252_ord_OLeast__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),P: fun(A,bool)] : ( aa(fun(A,bool),A,least(A,Less_eq),P) = the(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aft(fun(A,fun(A,bool)),fun(fun(A,bool),fun(A,bool)),Less_eq),P)) ) ).

% ord.Least_def
tff(fact_4253_transfer__bforall__def,axiom,
    ! [A: $tType,X4: fun(A,bool),Xa3: fun(A,bool)] :
      ( transfer_bforall(A,X4,Xa3)
    <=> ! [Xb2: A] :
          ( pp(aa(A,bool,X4,Xb2))
         => pp(aa(A,bool,Xa3,Xb2)) ) ) ).

% transfer_bforall_def
tff(fact_4254_ord_OLeast_Ocong,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool))] : ( least(A,Less_eq) = least(A,Less_eq) ) ).

% ord.Least.cong
tff(fact_4255_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),X2: A,Q: fun(A,bool)] :
          ( pp(aa(A,bool,P,X2))
         => ( ! [Y2: A] :
                ( pp(aa(A,bool,P,Y2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X2)) )
           => ( ! [X: A] :
                  ( pp(aa(A,bool,P,X))
                 => ( ! [Y5: A] :
                        ( pp(aa(A,bool,P,Y5))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y5),X)) )
                   => pp(aa(A,bool,Q,X)) ) )
             => pp(aa(A,bool,Q,order_Greatest(A,P))) ) ) ) ) ).

% GreatestI2_order
tff(fact_4256_Greatest__equality,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),X2: A] :
          ( pp(aa(A,bool,P,X2))
         => ( ! [Y2: A] :
                ( pp(aa(A,bool,P,Y2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X2)) )
           => ( order_Greatest(A,P) = X2 ) ) ) ) ).

% Greatest_equality
tff(fact_4257_filtercomap__def,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),F: filter(B)] : ( filtercomap(A,B,F2,F) = aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),aa(filter(B),fun(fun(A,bool),bool),aTP_Lamp_afu(fun(A,B),fun(filter(B),fun(fun(A,bool),bool)),F2),F)) ) ).

% filtercomap_def
tff(fact_4258_init__seg__of__def,axiom,
    ! [A: $tType] : ( init_seg_of(A) = aa(fun(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),bool),set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),collect(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),aa(fun(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool)),fun(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),bool),product_case_prod(set(product_prod(A,A)),set(product_prod(A,A)),bool),aTP_Lamp_afv(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool)))) ) ).

% init_seg_of_def
tff(fact_4259_wo__rel_Oofilter__under__UNION,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R2)
     => ( order_ofilter(A,R2,A3)
       => ( A3 = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(A),set(set(A)),image2(A,set(A),order_under(A,R2)),A3)) ) ) ) ).

% wo_rel.ofilter_under_UNION
tff(fact_4260_ofilter__Restr__Int,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A),B2: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(A,R2,A3)
       => order_ofilter(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,B2,aTP_Lamp_cr(set(A),fun(A,set(A)),B2))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) ) ) ).

% ofilter_Restr_Int
tff(fact_4261_filtercomap__bot,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B)] : ( filtercomap(A,B,F2,bot_bot(filter(B))) = bot_bot(filter(A)) ) ).

% filtercomap_bot
tff(fact_4262_eventually__filtercomapI,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),F: filter(A),F2: fun(B,A)] :
      ( eventually(A,P,F)
     => eventually(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_ns(fun(A,bool),fun(fun(B,A),fun(B,bool)),P),F2),filtercomap(B,A,F2,F)) ) ).

% eventually_filtercomapI
tff(fact_4263_filtercomap__filtercomap,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(A,B),G: fun(B,C),F: filter(C)] : ( filtercomap(A,B,F2,filtercomap(B,C,G,F)) = filtercomap(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_afw(fun(A,B),fun(fun(B,C),fun(A,C)),F2),G),F) ) ).

% filtercomap_filtercomap
tff(fact_4264_filtercomap__ident,axiom,
    ! [A: $tType,F: filter(A)] : ( filtercomap(A,A,aTP_Lamp_bk(A,A),F) = F ) ).

% filtercomap_ident
tff(fact_4265_filtercomap__inf,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),F12: filter(B),F23: filter(B)] : ( filtercomap(A,B,F2,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F12),F23)) = aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),filtercomap(A,B,F2,F12)),filtercomap(A,B,F2,F23)) ) ).

% filtercomap_inf
tff(fact_4266_under__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A] : ( aa(A,set(A),order_under(A,R2),A4) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_na(set(product_prod(A,A)),fun(A,fun(A,bool)),R2),A4)) ) ).

% under_def
tff(fact_4267_well__order__on__empty,axiom,
    ! [A: $tType] : order_well_order_on(A,bot_bot(set(A)),bot_bot(set(product_prod(A,A)))) ).

% well_order_on_empty
tff(fact_4268_ofilter__Restr__under,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A),A4: A] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(A,R2,A3)
       => ( pp(aa(set(A),bool,member(A,A4),A3))
         => ( aa(A,set(A),order_under(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),A4) = aa(A,set(A),order_under(A,R2),A4) ) ) ) ) ).

% ofilter_Restr_under
tff(fact_4269_filtercomap__neq__bot,axiom,
    ! [A: $tType,B: $tType,F: filter(A),F2: fun(B,A)] :
      ( ! [P3: fun(A,bool)] :
          ( eventually(A,P3,F)
         => ? [X4: B] : pp(aa(A,bool,P3,aa(B,A,F2,X4))) )
     => ( filtercomap(B,A,F2,F) != bot_bot(filter(B)) ) ) ).

% filtercomap_neq_bot
tff(fact_4270_filtercomap__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(A,B),F: fun(C,filter(B)),B2: set(C)] : ( filtercomap(A,B,F2,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(C),set(filter(B)),image2(C,filter(B),F),B2))) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(C),set(filter(A)),image2(C,filter(A),aa(fun(C,filter(B)),fun(C,filter(A)),aTP_Lamp_afx(fun(A,B),fun(fun(C,filter(B)),fun(C,filter(A))),F2),F)),B2)) ) ).

% filtercomap_INF
tff(fact_4271_Well__order__Restr,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => order_well_order_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ).

% Well_order_Restr
tff(fact_4272_natLeq__on__well__order__on,axiom,
    ! [N: nat] : order_well_order_on(nat,aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N)),aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_tr(nat,fun(nat,fun(nat,bool)),N)))) ).

% natLeq_on_well_order_on
tff(fact_4273_bsqr__ofilter,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),D2: set(product_prod(A,A))] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(product_prod(A,A),bNF_Wellorder_bsqr(A,R2),D2)
       => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less(set(product_prod(A,A))),D2),product_Sigma(A,A,field2(A,R2),aTP_Lamp_ey(set(product_prod(A,A)),fun(A,set(A)),R2))))
         => ( ~ ? [A5: A] : ( field2(A,R2) = aa(A,set(A),order_under(A,R2),A5) )
           => ? [A11: set(A)] :
                ( order_ofilter(A,R2,A11)
                & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A11),field2(A,R2)))
                & pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),D2),product_Sigma(A,A,A11,aTP_Lamp_cr(set(A),fun(A,set(A)),A11)))) ) ) ) ) ) ).

% bsqr_ofilter
tff(fact_4274_filtercomap__neq__bot__surj,axiom,
    ! [A: $tType,B: $tType,F: filter(A),F2: fun(B,A)] :
      ( ( F != bot_bot(filter(A)) )
     => ( ( aa(set(B),set(A),image2(B,A,F2),top_top(set(B))) = top_top(set(A)) )
       => ( filtercomap(B,A,F2,F) != bot_bot(filter(B)) ) ) ) ).

% filtercomap_neq_bot_surj
tff(fact_4275_well__order__on__Restr,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),field2(A,R2)))
       => order_well_order_on(A,A3,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) ) ) ).

% well_order_on_Restr
tff(fact_4276_Field__Restr__ofilter,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(A,R2,A3)
       => ( field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))) = A3 ) ) ) ).

% Field_Restr_ofilter
tff(fact_4277_natLeq__on__Well__order,axiom,
    ! [N: nat] : order_well_order_on(nat,field2(nat,aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_tr(nat,fun(nat,fun(nat,bool)),N)))),aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_tr(nat,fun(nat,fun(nat,bool)),N)))) ).

% natLeq_on_Well_order
tff(fact_4278_filtercomap__SUP,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: fun(A,C),F: fun(B,filter(C)),B2: set(B)] : pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),aa(set(filter(A)),filter(A),complete_Sup_Sup(filter(A)),aa(set(B),set(filter(A)),image2(B,filter(A),aa(fun(B,filter(C)),fun(B,filter(A)),aTP_Lamp_afy(fun(A,C),fun(fun(B,filter(C)),fun(B,filter(A))),F2),F)),B2))),filtercomap(A,C,F2,aa(set(filter(C)),filter(C),complete_Sup_Sup(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),F),B2))))) ).

% filtercomap_SUP
tff(fact_4279_Linear__order__Well__order__iff,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( order_679001287576687338der_on(A,field2(A,R2),R2)
     => ( order_well_order_on(A,field2(A,R2),R2)
      <=> ! [A12: set(A)] :
            ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A12),field2(A,R2)))
           => ( ( A12 != bot_bot(set(A)) )
             => ? [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A12))
                  & ! [Xa2: A] :
                      ( pp(aa(set(A),bool,member(A,Xa2),A12))
                     => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa2)),R2)) ) ) ) ) ) ) ).

% Linear_order_Well_order_iff
tff(fact_4280_ofilter__Restr__subset,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A),B2: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(A,R2,A3)
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
         => order_ofilter(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,B2,aTP_Lamp_cr(set(A),fun(A,set(A)),B2))),A3) ) ) ) ).

% ofilter_Restr_subset
tff(fact_4281_UNION__inj__on__ofilter,axiom,
    ! [C: $tType,A: $tType,B: $tType,R2: set(product_prod(A,A)),I: set(B),A3: fun(B,set(A)),F2: fun(A,C)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( ! [I3: B] :
            ( pp(aa(set(B),bool,member(B,I3),I))
           => order_ofilter(A,R2,aa(B,set(A),A3,I3)) )
       => ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),I))
             => inj_on(A,C,F2,aa(B,set(A),A3,I3)) )
         => inj_on(A,C,F2,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I))) ) ) ) ).

% UNION_inj_on_ofilter
tff(fact_4282_ofilter__subset__embedS,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A),B2: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(A,R2,A3)
       => ( order_ofilter(A,R2,B2)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A3),B2))
          <=> bNF_Wellorder_embedS(A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,B2,aTP_Lamp_cr(set(A),fun(A,set(A)),B2))),id(A)) ) ) ) ) ).

% ofilter_subset_embedS
tff(fact_4283_ofilter__subset__embed,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A),B2: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(A,R2,A3)
       => ( order_ofilter(A,R2,B2)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
          <=> pp(aa(fun(A,A),bool,bNF_Wellorder_embed(A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,B2,aTP_Lamp_cr(set(A),fun(A,set(A)),B2)))),id(A))) ) ) ) ) ).

% ofilter_subset_embed
tff(fact_4284_ofilter__embed,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(A,R2,A3)
      <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),field2(A,R2)))
          & pp(aa(fun(A,A),bool,bNF_Wellorder_embed(A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))),R2),id(A))) ) ) ) ).

% ofilter_embed
tff(fact_4285_embedS__defs_I2_J,axiom,
    ! [A: $tType,A2: $tType,X4: set(product_prod(A,A)),Xa3: set(product_prod(A2,A2)),Xb3: fun(A,A2)] :
      ( bNF_Wellorder_embedS(A,A2,X4,Xa3,Xb3)
    <=> ( pp(aa(fun(A,A2),bool,bNF_Wellorder_embed(A,A2,X4,Xa3),Xb3))
        & ~ bij_betw(A,A2,Xb3,field2(A,X4),field2(A2,Xa3)) ) ) ).

% embedS_defs(2)
tff(fact_4286_embed__defs_I2_J,axiom,
    ! [A2: $tType,A: $tType,X4: set(product_prod(A,A)),Xa3: set(product_prod(A2,A2)),Xb3: fun(A,A2)] :
      ( pp(aa(fun(A,A2),bool,bNF_Wellorder_embed(A,A2,X4,Xa3),Xb3))
    <=> ! [Xc: A] :
          ( pp(aa(set(A),bool,member(A,Xc),field2(A,X4)))
         => bij_betw(A,A2,Xb3,aa(A,set(A),order_under(A,X4),Xc),aa(A2,set(A2),order_under(A2,Xa3),aa(A,A2,Xb3,Xc))) ) ) ).

% embed_defs(2)
tff(fact_4287_ord__to__filter__def,axiom,
    ! [A: $tType,R0: set(product_prod(A,A)),R2: set(product_prod(A,A))] : ( aa(set(product_prod(A,A)),set(A),bNF_We8469521843155493636filter(A,R0),R2) = aa(set(A),set(A),image2(A,A,fChoice(fun(A,A),bNF_Wellorder_embed(A,A,R2,R0))),field2(A,R2)) ) ).

% ord_to_filter_def
tff(fact_4288_ofilter__subset__embedS__iso,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A),B2: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(A,R2,A3)
       => ( order_ofilter(A,R2,B2)
         => ( ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A3),B2))
            <=> bNF_Wellorder_embedS(A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,B2,aTP_Lamp_cr(set(A),fun(A,set(A)),B2))),id(A)) )
            & ( ( A3 = B2 )
            <=> bNF_Wellorder_iso(A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,B2,aTP_Lamp_cr(set(A),fun(A,set(A)),B2))),id(A)) ) ) ) ) ) ).

% ofilter_subset_embedS_iso
tff(fact_4289_embed__implies__iso__Restr,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(A,A)),R5: set(product_prod(B,B)),F2: fun(B,A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_well_order_on(B,field2(B,R5),R5)
       => ( pp(aa(fun(B,A),bool,bNF_Wellorder_embed(B,A,R5,R2),F2))
         => bNF_Wellorder_iso(B,A,R5,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,aa(set(B),set(A),image2(B,A,F2),field2(B,R5)),aa(fun(B,A),fun(A,set(A)),aTP_Lamp_afz(set(product_prod(B,B)),fun(fun(B,A),fun(A,set(A))),R5),F2))),F2) ) ) ) ).

% embed_implies_iso_Restr
tff(fact_4290_ordLess__def,axiom,
    ! [A2: $tType,A: $tType] : ( bNF_We4044943003108391690rdLess(A,A2) = aa(fun(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2))),bool),set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))),collect(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))),aa(fun(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool)),fun(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2))),bool),product_case_prod(set(product_prod(A,A)),set(product_prod(A2,A2)),bool),aTP_Lamp_aga(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool)))) ) ).

% ordLess_def
tff(fact_4291_iso__defs_I2_J,axiom,
    ! [A: $tType,A2: $tType,X4: set(product_prod(A,A)),Xa3: set(product_prod(A2,A2)),Xb3: fun(A,A2)] :
      ( bNF_Wellorder_iso(A,A2,X4,Xa3,Xb3)
    <=> ( pp(aa(fun(A,A2),bool,bNF_Wellorder_embed(A,A2,X4,Xa3),Xb3))
        & bij_betw(A,A2,Xb3,field2(A,X4),field2(A2,Xa3)) ) ) ).

% iso_defs(2)
tff(fact_4292_ofilter__ordLess,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(A,R2,A3)
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A3),field2(A,R2)))
        <=> pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),R2)),bNF_We4044943003108391690rdLess(A,A))) ) ) ) ).

% ofilter_ordLess
tff(fact_4293_ofilter__subset__ordLess,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A),B2: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(A,R2,A3)
       => ( order_ofilter(A,R2,B2)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A3),B2))
          <=> pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,B2,aTP_Lamp_cr(set(A),fun(A,set(A)),B2))))),bNF_We4044943003108391690rdLess(A,A))) ) ) ) ) ).

% ofilter_subset_ordLess
tff(fact_4294_ord__to__filter__compat,axiom,
    ! [A: $tType,R0: set(product_prod(A,A))] : bNF_Wellorder_compat(set(product_prod(A,A)),set(A),aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),fun(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),set(product_prod(set(product_prod(A,A)),set(product_prod(A,A))))),inf_inf(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A))))),bNF_We4044943003108391690rdLess(A,A)),product_Sigma(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(set(product_prod(A,A))),set(set(product_prod(A,A))),image(set(product_prod(A,A)),set(product_prod(A,A)),converse(set(product_prod(A,A)),set(product_prod(A,A)),bNF_We4044943003108391690rdLess(A,A))),aa(set(set(product_prod(A,A))),set(set(product_prod(A,A))),insert(set(product_prod(A,A)),R0),bot_bot(set(set(product_prod(A,A)))))),aTP_Lamp_agb(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(set(product_prod(A,A)))),R0))),bNF_We413866401316099525erIncl(A,R0),bNF_We8469521843155493636filter(A,R0)) ).

% ord_to_filter_compat
tff(fact_4295_underS__Restr__ordLess,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( ( field2(A,R2) != bot_bot(set(A)) )
       => pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,order_underS(A,R2,A4),aa(A,fun(A,set(A)),aTP_Lamp_agc(set(product_prod(A,A)),fun(A,fun(A,set(A))),R2),A4)))),R2)),bNF_We4044943003108391690rdLess(A,A))) ) ) ).

% underS_Restr_ordLess
tff(fact_4296_Refl__under__underS,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A] :
      ( refl_on(A,field2(A,R2),R2)
     => ( pp(aa(set(A),bool,member(A,A4),field2(A,R2)))
       => ( aa(A,set(A),order_under(A,R2),A4) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),order_underS(A,R2,A4)),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) ) ) ) ).

% Refl_under_underS
tff(fact_4297_ordIso__def,axiom,
    ! [A2: $tType,A: $tType] : ( bNF_Wellorder_ordIso(A,A2) = aa(fun(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2))),bool),set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))),collect(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))),aa(fun(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool)),fun(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2))),bool),product_case_prod(set(product_prod(A,A)),set(product_prod(A2,A2)),bool),aTP_Lamp_agd(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool)))) ) ).

% ordIso_def
tff(fact_4298_underS__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A] : ( order_underS(A,R2,A4) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_age(set(product_prod(A,A)),fun(A,fun(A,bool)),R2),A4)) ) ).

% underS_def
tff(fact_4299_underS__empty,axiom,
    ! [A: $tType,A4: A,R2: set(product_prod(A,A))] :
      ( ~ pp(aa(set(A),bool,member(A,A4),field2(A,R2)))
     => ( order_underS(A,R2,A4) = bot_bot(set(A)) ) ) ).

% underS_empty
tff(fact_4300_ordLess__iff__ordIso__Restr,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(A,A)),R5: set(product_prod(B,B))] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_well_order_on(B,field2(B,R5),R5)
       => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R5),R2)),bNF_We4044943003108391690rdLess(B,A)))
        <=> ? [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),field2(A,R2)))
              & pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R5),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,order_underS(A,R2,X3),aa(A,fun(A,set(A)),aTP_Lamp_agc(set(product_prod(A,A)),fun(A,fun(A,set(A))),R2),X3))))),bNF_Wellorder_ordIso(B,A))) ) ) ) ) ).

% ordLess_iff_ordIso_Restr
tff(fact_4301_underS__Field3,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A] :
      ( ( field2(A,R2) != bot_bot(set(A)) )
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),order_underS(A,R2,A4)),field2(A,R2))) ) ).

% underS_Field3
tff(fact_4302_ordLeq__iff__ordLess__Restr,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,A)),R5: set(product_prod(B,B))] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_well_order_on(B,field2(B,R5),R5)
       => ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R2),R5)),bNF_Wellorder_ordLeq(A,B)))
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),field2(A,R2)))
             => pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,order_underS(A,R2,X3),aa(A,fun(A,set(A)),aTP_Lamp_agc(set(product_prod(A,A)),fun(A,fun(A,set(A))),R2),X3)))),R5)),bNF_We4044943003108391690rdLess(A,B))) ) ) ) ) ).

% ordLeq_iff_ordLess_Restr
tff(fact_4303_ofilter__subset__ordLeq,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A),B2: set(A)] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( order_ofilter(A,R2,A3)
       => ( order_ofilter(A,R2,B2)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
          <=> pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,B2,aTP_Lamp_cr(set(A),fun(A,set(A)),B2))))),bNF_Wellorder_ordLeq(A,A))) ) ) ) ) ).

% ofilter_subset_ordLeq
tff(fact_4304_ordLeq__def,axiom,
    ! [A2: $tType,A: $tType] : ( bNF_Wellorder_ordLeq(A,A2) = aa(fun(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2))),bool),set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))),collect(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))),aa(fun(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool)),fun(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2))),bool),product_case_prod(set(product_prod(A,A)),set(product_prod(A2,A2)),bool),aTP_Lamp_agf(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool)))) ) ).

% ordLeq_def
tff(fact_4305_finite__subset__Union__chain,axiom,
    ! [A: $tType,A3: set(A),B7: set(set(A)),A16: set(set(A))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B7)))
       => ( ( B7 != bot_bot(set(set(A))) )
         => ( pp(aa(set(set(A)),bool,pred_chain(set(A),A16,ord_less(set(A))),B7))
           => ~ ! [B8: set(A)] :
                  ( pp(aa(set(set(A)),bool,member(set(A),B8),B7))
                 => ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B8)) ) ) ) ) ) ).

% finite_subset_Union_chain
tff(fact_4306_pred__on_Ochain__empty,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,fun(A,bool))] : pp(aa(set(A),bool,pred_chain(A,A3,P),bot_bot(set(A)))) ).

% pred_on.chain_empty
tff(fact_4307_subset_Ochain__empty,axiom,
    ! [A: $tType,A3: set(set(A))] : pp(aa(set(set(A)),bool,pred_chain(set(A),A3,ord_less(set(A))),bot_bot(set(set(A))))) ).

% subset.chain_empty
tff(fact_4308_chains__alt__def,axiom,
    ! [A: $tType,A3: set(set(A))] : ( chains2(A,A3) = aa(fun(set(set(A)),bool),set(set(set(A))),collect(set(set(A))),pred_chain(set(A),A3,ord_less(set(A)))) ) ).

% chains_alt_def
tff(fact_4309_subset__Zorn__nonempty,axiom,
    ! [A: $tType,A16: set(set(A))] :
      ( ( A16 != bot_bot(set(set(A))) )
     => ( ! [C8: set(set(A))] :
            ( ( C8 != bot_bot(set(set(A))) )
           => ( pp(aa(set(set(A)),bool,pred_chain(set(A),A16,ord_less(set(A))),C8))
             => pp(aa(set(set(A)),bool,member(set(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C8)),A16)) ) )
       => ? [X: set(A)] :
            ( pp(aa(set(set(A)),bool,member(set(A),X),A16))
            & ! [Xa3: set(A)] :
                ( pp(aa(set(set(A)),bool,member(set(A),Xa3),A16))
               => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X),Xa3))
                 => ( Xa3 = X ) ) ) ) ) ) ).

% subset_Zorn_nonempty
tff(fact_4310_Union__in__chain,axiom,
    ! [A: $tType,B7: set(set(A)),A16: set(set(A))] :
      ( pp(aa(set(set(A)),bool,finite_finite2(set(A)),B7))
     => ( ( B7 != bot_bot(set(set(A))) )
       => ( pp(aa(set(set(A)),bool,pred_chain(set(A),A16,ord_less(set(A))),B7))
         => pp(aa(set(set(A)),bool,member(set(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B7)),B7)) ) ) ) ).

% Union_in_chain
tff(fact_4311_Inter__in__chain,axiom,
    ! [A: $tType,B7: set(set(A)),A16: set(set(A))] :
      ( pp(aa(set(set(A)),bool,finite_finite2(set(A)),B7))
     => ( ( B7 != bot_bot(set(set(A))) )
       => ( pp(aa(set(set(A)),bool,pred_chain(set(A),A16,ord_less(set(A))),B7))
         => pp(aa(set(set(A)),bool,member(set(A),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B7)),B7)) ) ) ) ).

% Inter_in_chain
tff(fact_4312_exists__minim__Well__order,axiom,
    ! [A: $tType,R: set(set(product_prod(A,A)))] :
      ( ( R != bot_bot(set(set(product_prod(A,A)))) )
     => ( ! [X: set(product_prod(A,A))] :
            ( pp(aa(set(set(product_prod(A,A))),bool,member(set(product_prod(A,A)),X),R))
           => order_well_order_on(A,field2(A,X),X) )
       => ? [X: set(product_prod(A,A))] :
            ( pp(aa(set(set(product_prod(A,A))),bool,member(set(product_prod(A,A)),X),R))
            & ! [Xa3: set(product_prod(A,A))] :
                ( pp(aa(set(set(product_prod(A,A))),bool,member(set(product_prod(A,A)),Xa3),R))
               => pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),X),Xa3)),bNF_Wellorder_ordLeq(A,A))) ) ) ) ) ).

% exists_minim_Well_order
tff(fact_4313_subset_Ochain__extend,axiom,
    ! [A: $tType,A3: set(set(A)),C3: set(set(A)),Z2: set(A)] :
      ( pp(aa(set(set(A)),bool,pred_chain(set(A),A3,ord_less(set(A))),C3))
     => ( pp(aa(set(set(A)),bool,member(set(A),Z2),A3))
       => ( ! [X: set(A)] :
              ( pp(aa(set(set(A)),bool,member(set(A),X),C3))
             => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aa(fun(set(A),fun(set(A),bool)),fun(set(A),fun(set(A),bool)),aa(fun(set(A),fun(set(A),bool)),fun(fun(set(A),fun(set(A),bool)),fun(set(A),fun(set(A),bool))),sup_sup(fun(set(A),fun(set(A),bool))),ord_less(set(A))),fequal(set(A))),X),Z2)) )
         => pp(aa(set(set(A)),bool,pred_chain(set(A),A3,ord_less(set(A))),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),aa(set(set(A)),set(set(A)),insert(set(A),Z2),bot_bot(set(set(A))))),C3))) ) ) ) ).

% subset.chain_extend
tff(fact_4314_pred__on_Ochain__extend,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,fun(A,bool)),C3: set(A),Z2: A] :
      ( pp(aa(set(A),bool,pred_chain(A,A3,P),C3))
     => ( pp(aa(set(A),bool,member(A,Z2),A3))
       => ( ! [X: A] :
              ( pp(aa(set(A),bool,member(A,X),C3))
             => pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),sup_sup(fun(A,fun(A,bool))),P),fequal(A)),X),Z2)) )
         => pp(aa(set(A),bool,pred_chain(A,A3,P),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert(A,Z2),bot_bot(set(A)))),C3))) ) ) ) ).

% pred_on.chain_extend
tff(fact_4315_Chains__subset_H,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( refl_on(A,top_top(set(A)),R2)
     => pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),aa(fun(set(A),bool),set(set(A)),collect(set(A)),pred_chain(A,top_top(set(A)),aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2)))),chains(A,R2))) ) ).

% Chains_subset'
tff(fact_4316_Chains__subset,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),chains(A,R2)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),pred_chain(A,top_top(set(A)),aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2))))) ).

% Chains_subset
tff(fact_4317_Chains__alt__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( refl_on(A,top_top(set(A)),R2)
     => ( chains(A,R2) = aa(fun(set(A),bool),set(set(A)),collect(set(A)),pred_chain(A,top_top(set(A)),aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2))) ) ) ).

% Chains_alt_def
tff(fact_4318_comp__set__bd__Union__o__collect,axiom,
    ! [C: $tType,B: $tType,A: $tType,X2: C,X5: set(fun(C,set(set(A)))),Hbd: set(product_prod(B,B))] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(set(A))),set(set(A)),complete_Sup_Sup(set(set(A))),aa(set(fun(C,set(set(A)))),set(set(set(A))),image2(fun(C,set(set(A))),set(set(A)),aTP_Lamp_agg(C,fun(fun(C,set(set(A))),set(set(A))),X2)),X5))))),Hbd)),bNF_Wellorder_ordLeq(A,B)))
     => pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,aa(C,set(A),aa(fun(C,set(set(A))),fun(C,set(A)),comp(set(set(A)),set(A),C,complete_Sup_Sup(set(A))),bNF_collect(C,set(A),X5)),X2))),Hbd)),bNF_Wellorder_ordLeq(A,B))) ) ).

% comp_set_bd_Union_o_collect
tff(fact_4319_card__of__Times3,axiom,
    ! [A: $tType,A3: set(A)] : pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,A),product_prod(A,A))))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,A),product_prod(A,A)))),aa(set(product_prod(product_prod(A,A),product_prod(A,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,A),product_prod(A,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(A,A),product_prod(A,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,A),product_prod(A,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(A,A),product_prod(A,A)))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Ca6860139660246222851ard_of(product_prod(A,A),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))))),bNF_Wellorder_ordLeq(A,product_prod(A,A)))) ).

% card_of_Times3
tff(fact_4320_card__of__Times2,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( ( A3 != bot_bot(set(A)) )
     => pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B))))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B)))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))),bNF_Wellorder_ordLeq(B,product_prod(A,B)))) ) ).

% card_of_Times2
tff(fact_4321_card__of__Times1,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( ( A3 != bot_bot(set(A)) )
     => pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,A),product_prod(B,A))))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(B,A),product_prod(B,A)))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,B2,aTP_Lamp_bv(set(A),fun(B,set(A)),A3))))),bNF_Wellorder_ordLeq(B,product_prod(B,A)))) ) ).

% card_of_Times1
tff(fact_4322_card__of__bool,axiom,
    ! [A: $tType,A13: A,A23: A] :
      ( ( A13 != A23 )
     => pp(aa(set(product_prod(set(product_prod(bool,bool)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(bool,bool)),fun(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A)))),product_Pair(set(product_prod(bool,bool)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(bool,top_top(set(bool)))),bNF_Ca6860139660246222851ard_of(A,aa(set(A),set(A),insert(A,A13),aa(set(A),set(A),insert(A,A23),bot_bot(set(A))))))),bNF_Wellorder_ordIso(bool,A))) ) ).

% card_of_bool
tff(fact_4323_card__of__Times__same__infinite,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => pp(aa(set(product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,A),product_prod(A,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(A,A),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3)))),bNF_Ca6860139660246222851ard_of(A,A3))),bNF_Wellorder_ordIso(product_prod(A,A),A))) ) ).

% card_of_Times_same_infinite
tff(fact_4324_card__of__Times__commute,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: set(B)] : pp(aa(set(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A))))),bool,member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A)))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)))),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,B2,aTP_Lamp_bv(set(A),fun(B,set(A)),A3))))),bNF_Wellorder_ordIso(product_prod(A,B),product_prod(B,A)))) ).

% card_of_Times_commute
tff(fact_4325_Func__Times__Range,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: set(A),B2: set(B),C3: set(C)] : pp(aa(set(product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C)))))),bool,member(product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C))))),aa(set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C)))),product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C))))),aa(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),fun(set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C)))),product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C)))))),product_Pair(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C))))),bNF_Ca6860139660246222851ard_of(fun(A,product_prod(B,C)),bNF_Wellorder_Func(A,product_prod(B,C),A3,product_Sigma(B,C,B2,aTP_Lamp_eq(set(C),fun(B,set(C)),C3))))),bNF_Ca6860139660246222851ard_of(product_prod(fun(A,B),fun(A,C)),product_Sigma(fun(A,B),fun(A,C),bNF_Wellorder_Func(A,B,A3,B2),aa(set(C),fun(fun(A,B),set(fun(A,C))),aTP_Lamp_agh(set(A),fun(set(C),fun(fun(A,B),set(fun(A,C)))),A3),C3))))),bNF_Wellorder_ordIso(fun(A,product_prod(B,C)),product_prod(fun(A,B),fun(A,C))))) ).

% Func_Times_Range
tff(fact_4326_card__of__UNION__Sigma,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),I: set(B)] : pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A))))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),bNF_Ca6860139660246222851ard_of(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A3),I)))),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,I,A3)))),bNF_Wellorder_ordLeq(A,product_prod(B,A)))) ).

% card_of_UNION_Sigma
tff(fact_4327_card__of__Sigma__mono1,axiom,
    ! [C: $tType,B: $tType,A: $tType,I: set(A),A3: fun(A,set(B)),B2: fun(A,set(C))] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),I))
         => pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(A,set(B),A3,X))),bNF_Ca6860139660246222851ard_of(C,aa(A,set(C),B2,X)))),bNF_Wellorder_ordLeq(B,C))) )
     => pp(aa(set(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C))))),bool,member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(product_prod(A,C),product_prod(A,C))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C))))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,I,A3))),bNF_Ca6860139660246222851ard_of(product_prod(A,C),product_Sigma(A,C,I,B2)))),bNF_Wellorder_ordLeq(product_prod(A,B),product_prod(A,C)))) ) ).

% card_of_Sigma_mono1
tff(fact_4328_card__of__Times__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,A3: set(A),B2: set(B),C3: set(C)] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_Wellorder_ordLeq(A,B)))
     => pp(aa(set(product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),bool,member(product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(product_prod(A,C),product_Sigma(A,C,A3,aTP_Lamp_md(set(C),fun(A,set(C)),C3)))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,B2,aTP_Lamp_eq(set(C),fun(B,set(C)),C3))))),bNF_Wellorder_ordLeq(product_prod(A,C),product_prod(B,C)))) ) ).

% card_of_Times_mono1
tff(fact_4329_card__of__Times__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,A3: set(A),B2: set(B),C3: set(C)] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_Wellorder_ordLeq(A,B)))
     => pp(aa(set(product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B))))),bool,member(product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,A),product_prod(C,A))),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(product_prod(C,A),product_Sigma(C,A,C3,aTP_Lamp_agi(set(A),fun(C,set(A)),A3)))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,C3,aTP_Lamp_agj(set(B),fun(C,set(B)),B2))))),bNF_Wellorder_ordLeq(product_prod(C,A),product_prod(C,B)))) ) ).

% card_of_Times_mono2
tff(fact_4330_card__of__Sigma__ordLeq__infinite,axiom,
    ! [A: $tType,C: $tType,B: $tType,B2: set(A),I: set(B),A3: fun(B,set(C))] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),B2))
     => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,I)),bNF_Ca6860139660246222851ard_of(A,B2))),bNF_Wellorder_ordLeq(B,A)))
       => ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),I))
             => pp(aa(set(product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A3,X))),bNF_Ca6860139660246222851ard_of(A,B2))),bNF_Wellorder_ordLeq(C,A))) )
         => pp(aa(set(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,I,A3))),bNF_Ca6860139660246222851ard_of(A,B2))),bNF_Wellorder_ordLeq(product_prod(B,C),A))) ) ) ) ).

% card_of_Sigma_ordLeq_infinite
tff(fact_4331_card__of__Times__infinite,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ( B2 != bot_bot(set(B)) )
       => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Ca6860139660246222851ard_of(A,A3))),bNF_Wellorder_ordLeq(B,A)))
         => ( pp(aa(set(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)))),bNF_Ca6860139660246222851ard_of(A,A3))),bNF_Wellorder_ordIso(product_prod(A,B),A)))
            & pp(aa(set(product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,B2,aTP_Lamp_bv(set(A),fun(B,set(A)),A3)))),bNF_Ca6860139660246222851ard_of(A,A3))),bNF_Wellorder_ordIso(product_prod(B,A),A))) ) ) ) ) ).

% card_of_Times_infinite
tff(fact_4332_card__of__Times__infinite__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ( B2 != bot_bot(set(B)) )
       => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Ca6860139660246222851ard_of(A,A3))),bNF_Wellorder_ordLeq(B,A)))
         => pp(aa(set(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)))),bNF_Ca6860139660246222851ard_of(A,A3))),bNF_Wellorder_ordIso(product_prod(A,B),A))) ) ) ) ).

% card_of_Times_infinite_simps(1)
tff(fact_4333_card__of__Times__infinite__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ( B2 != bot_bot(set(B)) )
       => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Ca6860139660246222851ard_of(A,A3))),bNF_Wellorder_ordLeq(B,A)))
         => pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B))))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))),bNF_Wellorder_ordIso(A,product_prod(A,B)))) ) ) ) ).

% card_of_Times_infinite_simps(2)
tff(fact_4334_card__of__Times__infinite__simps_I3_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ( B2 != bot_bot(set(B)) )
       => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Ca6860139660246222851ard_of(A,A3))),bNF_Wellorder_ordLeq(B,A)))
         => pp(aa(set(product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,B2,aTP_Lamp_bv(set(A),fun(B,set(A)),A3)))),bNF_Ca6860139660246222851ard_of(A,A3))),bNF_Wellorder_ordIso(product_prod(B,A),A))) ) ) ) ).

% card_of_Times_infinite_simps(3)
tff(fact_4335_card__of__Times__infinite__simps_I4_J,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( ( B2 != bot_bot(set(B)) )
       => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Ca6860139660246222851ard_of(A,A3))),bNF_Wellorder_ordLeq(B,A)))
         => pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A))))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,B2,aTP_Lamp_bv(set(A),fun(B,set(A)),A3))))),bNF_Wellorder_ordIso(A,product_prod(B,A)))) ) ) ) ).

% card_of_Times_infinite_simps(4)
tff(fact_4336_card__of__Func__Times,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: set(A),B2: set(B),C3: set(C)] : pp(aa(set(product_prod(set(product_prod(fun(product_prod(A,B),C),fun(product_prod(A,B),C))),set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C)))))),bool,member(product_prod(set(product_prod(fun(product_prod(A,B),C),fun(product_prod(A,B),C))),set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C))))),aa(set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C)))),product_prod(set(product_prod(fun(product_prod(A,B),C),fun(product_prod(A,B),C))),set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C))))),aa(set(product_prod(fun(product_prod(A,B),C),fun(product_prod(A,B),C))),fun(set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C)))),product_prod(set(product_prod(fun(product_prod(A,B),C),fun(product_prod(A,B),C))),set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C)))))),product_Pair(set(product_prod(fun(product_prod(A,B),C),fun(product_prod(A,B),C))),set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C))))),bNF_Ca6860139660246222851ard_of(fun(product_prod(A,B),C),bNF_Wellorder_Func(product_prod(A,B),C,product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)),C3))),bNF_Ca6860139660246222851ard_of(fun(A,fun(B,C)),bNF_Wellorder_Func(A,fun(B,C),A3,bNF_Wellorder_Func(B,C,B2,C3))))),bNF_Wellorder_ordIso(fun(product_prod(A,B),C),fun(A,fun(B,C))))) ).

% card_of_Func_Times
tff(fact_4337_card__of__empty,axiom,
    ! [B: $tType,A: $tType,A3: set(B)] : pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,bot_bot(set(A)))),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordLeq(A,B))) ).

% card_of_empty
tff(fact_4338_card__of__empty3,axiom,
    ! [B: $tType,A: $tType,A3: set(A)] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B))))),bNF_Wellorder_ordLeq(A,B)))
     => ( A3 = bot_bot(set(A)) ) ) ).

% card_of_empty3
tff(fact_4339_card__of__empty__ordIso,axiom,
    ! [B: $tType,A: $tType] : pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,bot_bot(set(A)))),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B))))),bNF_Wellorder_ordIso(A,B))) ).

% card_of_empty_ordIso
tff(fact_4340_card__of__empty2,axiom,
    ! [B: $tType,A: $tType,A3: set(A)] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B))))),bNF_Wellorder_ordIso(A,B)))
     => ( A3 = bot_bot(set(A)) ) ) ).

% card_of_empty2
tff(fact_4341_card__of__ordLeq2,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: set(B)] :
      ( ( A3 != bot_bot(set(A)) )
     => ( ? [G2: fun(B,A)] : ( aa(set(B),set(A),image2(B,A,G2),B2) = A3 )
      <=> pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_Wellorder_ordLeq(A,B))) ) ) ).

% card_of_ordLeq2
tff(fact_4342_card__of__singl__ordLeq,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: B] :
      ( ( A3 != bot_bot(set(A)) )
     => pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))),bNF_Ca6860139660246222851ard_of(A,A3))),bNF_Wellorder_ordLeq(B,A))) ) ).

% card_of_singl_ordLeq
tff(fact_4343_card__of__ordLess2,axiom,
    ! [A: $tType,B: $tType,B2: set(A),A3: set(B)] :
      ( ( B2 != bot_bot(set(A)) )
     => ( ~ ? [F8: fun(B,A)] : ( aa(set(B),set(A),image2(B,A,F8),A3) = B2 )
      <=> pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(A,B2))),bNF_We4044943003108391690rdLess(B,A))) ) ) ).

% card_of_ordLess2
tff(fact_4344_card__of__Func__UNIV,axiom,
    ! [B: $tType,A: $tType,B2: set(B)] : pp(aa(set(product_prod(set(product_prod(fun(A,B),fun(A,B))),set(product_prod(fun(A,B),fun(A,B))))),bool,member(product_prod(set(product_prod(fun(A,B),fun(A,B))),set(product_prod(fun(A,B),fun(A,B)))),aa(set(product_prod(fun(A,B),fun(A,B))),product_prod(set(product_prod(fun(A,B),fun(A,B))),set(product_prod(fun(A,B),fun(A,B)))),aa(set(product_prod(fun(A,B),fun(A,B))),fun(set(product_prod(fun(A,B),fun(A,B))),product_prod(set(product_prod(fun(A,B),fun(A,B))),set(product_prod(fun(A,B),fun(A,B))))),product_Pair(set(product_prod(fun(A,B),fun(A,B))),set(product_prod(fun(A,B),fun(A,B)))),bNF_Ca6860139660246222851ard_of(fun(A,B),bNF_Wellorder_Func(A,B,top_top(set(A)),B2))),bNF_Ca6860139660246222851ard_of(fun(A,B),aa(fun(fun(A,B),bool),set(fun(A,B)),collect(fun(A,B)),aTP_Lamp_agk(set(B),fun(fun(A,B),bool),B2))))),bNF_Wellorder_ordIso(fun(A,B),fun(A,B)))) ).

% card_of_Func_UNIV
tff(fact_4345_ordLeq__Times__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,R2: set(product_prod(A,A)),R5: set(product_prod(B,B)),C3: set(C)] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R2),R5)),bNF_Wellorder_ordLeq(A,B)))
     => pp(aa(set(product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),bool,member(product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(product_prod(A,C),product_Sigma(A,C,field2(A,R2),aTP_Lamp_md(set(C),fun(A,set(C)),C3)))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,field2(B,R5),aTP_Lamp_eq(set(C),fun(B,set(C)),C3))))),bNF_Wellorder_ordLeq(product_prod(A,C),product_prod(B,C)))) ) ).

% ordLeq_Times_mono1
tff(fact_4346_ordLeq__Times__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,R2: set(product_prod(A,A)),R5: set(product_prod(B,B)),A3: set(C)] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R2),R5)),bNF_Wellorder_ordLeq(A,B)))
     => pp(aa(set(product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B))))),bool,member(product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,A),product_prod(C,A))),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(product_prod(C,A),product_Sigma(C,A,A3,aTP_Lamp_agl(set(product_prod(A,A)),fun(C,set(A)),R2)))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,A3,aTP_Lamp_agm(set(product_prod(B,B)),fun(C,set(B)),R5))))),bNF_Wellorder_ordLeq(product_prod(C,A),product_prod(C,B)))) ) ).

% ordLeq_Times_mono2
tff(fact_4347_Chains__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( chains(A,R2) = aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_agn(set(product_prod(A,A)),fun(set(A),bool),R2)) ) ).

% Chains_def
tff(fact_4348_Chains__inits__DiffI,axiom,
    ! [A: $tType,R: set(set(product_prod(A,A))),S2: set(product_prod(A,A))] :
      ( pp(aa(set(set(set(product_prod(A,A)))),bool,member(set(set(product_prod(A,A))),R),chains(set(product_prod(A,A)),init_seg_of(A))))
     => pp(aa(set(set(set(product_prod(A,A)))),bool,member(set(set(product_prod(A,A))),aa(fun(set(product_prod(A,A)),bool),set(set(product_prod(A,A))),collect(set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),aTP_Lamp_ago(set(set(product_prod(A,A))),fun(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool)),R),S2))),chains(set(product_prod(A,A)),init_seg_of(A)))) ) ).

% Chains_inits_DiffI
tff(fact_4349_card__of__UNION__ordLeq__infinite,axiom,
    ! [B: $tType,A: $tType,C: $tType,B2: set(A),I: set(B),A3: fun(B,set(C))] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),B2))
     => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,I)),bNF_Ca6860139660246222851ard_of(A,B2))),bNF_Wellorder_ordLeq(B,A)))
       => ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),I))
             => pp(aa(set(product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A3,X))),bNF_Ca6860139660246222851ard_of(A,B2))),bNF_Wellorder_ordLeq(C,A))) )
         => pp(aa(set(product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I)))),bNF_Ca6860139660246222851ard_of(A,B2))),bNF_Wellorder_ordLeq(C,A))) ) ) ) ).

% card_of_UNION_ordLeq_infinite
tff(fact_4350_Card__order__iff__Restr__underS,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( order_well_order_on(A,field2(A,R2),R2)
     => ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
      <=> ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),field2(A,R2)))
           => pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),product_Sigma(A,A,order_underS(A,R2,X3),aa(A,fun(A,set(A)),aTP_Lamp_agc(set(product_prod(A,A)),fun(A,fun(A,set(A))),R2),X3)))),bNF_Ca6860139660246222851ard_of(A,field2(A,R2)))),bNF_We4044943003108391690rdLess(A,A))) ) ) ) ).

% Card_order_iff_Restr_underS
tff(fact_4351_card__of__Plus__Times__aux,axiom,
    ! [B: $tType,A: $tType,A13: A,A23: A,A3: set(A),B2: set(B)] :
      ( ( ( A13 != A23 )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,A13),aa(set(A),set(A),insert(A,A23),bot_bot(set(A))))),A3)) )
     => ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_Wellorder_ordLeq(A,B)))
       => pp(aa(set(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B))))),bool,member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B))))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,A3,B2))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))),bNF_Wellorder_ordLeq(sum_sum(A,B),product_prod(A,B)))) ) ) ).

% card_of_Plus_Times_aux
tff(fact_4352_card__of__UNION__ordLeq__infinite__Field,axiom,
    ! [B: $tType,A: $tType,C: $tType,R2: set(product_prod(A,A)),I: set(B),A3: fun(B,set(C))] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),field2(A,R2)))
     => ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
       => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,I)),R2)),bNF_Wellorder_ordLeq(B,A)))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),I))
               => pp(aa(set(product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A3,X))),R2)),bNF_Wellorder_ordLeq(C,A))) )
           => pp(aa(set(product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I)))),R2)),bNF_Wellorder_ordLeq(C,A))) ) ) ) ) ).

% card_of_UNION_ordLeq_infinite_Field
tff(fact_4353_card__of__Times__ordLeq__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R2: set(product_prod(A,A)),A3: set(B),B2: set(C)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),field2(A,R2)))
     => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,A3)),R2)),bNF_Wellorder_ordLeq(B,A)))
       => ( pp(aa(set(product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,B2)),R2)),bNF_Wellorder_ordLeq(C,A)))
         => ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
           => pp(aa(set(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A3,aTP_Lamp_eq(set(C),fun(B,set(C)),B2)))),R2)),bNF_Wellorder_ordLeq(product_prod(B,C),A))) ) ) ) ) ).

% card_of_Times_ordLeq_infinite_Field
tff(fact_4354_card__of__def,axiom,
    ! [A: $tType,A3: set(A)] : ( bNF_Ca6860139660246222851ard_of(A,A3) = fChoice(set(product_prod(A,A)),bNF_Ca8970107618336181345der_on(A,A3)) ) ).

% card_of_def
tff(fact_4355_card__of__Times__Plus__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: set(A),B2: set(B),C3: set(C)] : pp(aa(set(product_prod(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))))),bool,member(product_prod(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C))))),aa(set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))),product_prod(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C))))),aa(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),fun(set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))),product_prod(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))))),product_Pair(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C))))),bNF_Ca6860139660246222851ard_of(product_prod(A,sum_sum(B,C)),product_Sigma(A,sum_sum(B,C),A3,aa(set(C),fun(A,set(sum_sum(B,C))),aTP_Lamp_agp(set(B),fun(set(C),fun(A,set(sum_sum(B,C)))),B2),C3)))),bNF_Ca6860139660246222851ard_of(sum_sum(product_prod(A,B),product_prod(A,C)),sum_Plus(product_prod(A,B),product_prod(A,C),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)),product_Sigma(A,C,A3,aTP_Lamp_md(set(C),fun(A,set(C)),C3)))))),bNF_Wellorder_ordIso(product_prod(A,sum_sum(B,C)),sum_sum(product_prod(A,B),product_prod(A,C))))) ).

% card_of_Times_Plus_distrib
tff(fact_4356_card__of__Plus__Times__bool,axiom,
    ! [A: $tType,A3: set(A)] : pp(aa(set(product_prod(set(product_prod(sum_sum(A,A),sum_sum(A,A))),set(product_prod(product_prod(A,bool),product_prod(A,bool))))),bool,member(product_prod(set(product_prod(sum_sum(A,A),sum_sum(A,A))),set(product_prod(product_prod(A,bool),product_prod(A,bool)))),aa(set(product_prod(product_prod(A,bool),product_prod(A,bool))),product_prod(set(product_prod(sum_sum(A,A),sum_sum(A,A))),set(product_prod(product_prod(A,bool),product_prod(A,bool)))),aa(set(product_prod(sum_sum(A,A),sum_sum(A,A))),fun(set(product_prod(product_prod(A,bool),product_prod(A,bool))),product_prod(set(product_prod(sum_sum(A,A),sum_sum(A,A))),set(product_prod(product_prod(A,bool),product_prod(A,bool))))),product_Pair(set(product_prod(sum_sum(A,A),sum_sum(A,A))),set(product_prod(product_prod(A,bool),product_prod(A,bool)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,A),sum_Plus(A,A,A3,A3))),bNF_Ca6860139660246222851ard_of(product_prod(A,bool),product_Sigma(A,bool,A3,aTP_Lamp_agq(A,set(bool)))))),bNF_Wellorder_ordIso(sum_sum(A,A),product_prod(A,bool)))) ).

% card_of_Plus_Times_bool
tff(fact_4357_card__of__Plus__empty2,axiom,
    ! [B: $tType,A: $tType,A3: set(A)] : pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A))))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Ca6860139660246222851ard_of(sum_sum(B,A),sum_Plus(B,A,bot_bot(set(B)),A3)))),bNF_Wellorder_ordIso(A,sum_sum(B,A)))) ).

% card_of_Plus_empty2
tff(fact_4358_card__of__Plus__empty1,axiom,
    ! [B: $tType,A: $tType,A3: set(A)] : pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B))))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,A3,bot_bot(set(B)))))),bNF_Wellorder_ordIso(A,sum_sum(A,B)))) ).

% card_of_Plus_empty1
tff(fact_4359_Card__order__Times2,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,A)),A3: set(B)] :
      ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
     => ( ( A3 != bot_bot(set(B)) )
       => pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A))))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),R2),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,A3,aTP_Lamp_agr(set(product_prod(A,A)),fun(B,set(A)),R2))))),bNF_Wellorder_ordLeq(A,product_prod(B,A)))) ) ) ).

% Card_order_Times2
tff(fact_4360_Card__order__Times1,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,A)),B2: set(B)] :
      ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
     => ( ( B2 != bot_bot(set(B)) )
       => pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B))))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),R2),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,field2(A,R2),aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))),bNF_Wellorder_ordLeq(A,product_prod(A,B)))) ) ) ).

% Card_order_Times1
tff(fact_4361_Card__order__Times__same__infinite,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
     => ( ~ pp(aa(set(A),bool,finite_finite2(A),field2(A,R2)))
       => pp(aa(set(product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,A),product_prod(A,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(A,A),product_Sigma(A,A,field2(A,R2),aTP_Lamp_ey(set(product_prod(A,A)),fun(A,set(A)),R2)))),R2)),bNF_Wellorder_ordLeq(product_prod(A,A),A))) ) ) ).

% Card_order_Times_same_infinite
tff(fact_4362_card__of__Plus__Times,axiom,
    ! [B: $tType,A: $tType,A13: A,A23: A,A3: set(A),B12: B,B23: B,B2: set(B)] :
      ( ( ( A13 != A23 )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,A13),aa(set(A),set(A),insert(A,A23),bot_bot(set(A))))),A3)) )
     => ( ( ( B12 != B23 )
          & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,B12),aa(set(B),set(B),insert(B,B23),bot_bot(set(B))))),B2)) )
       => pp(aa(set(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B))))),bool,member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B))))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,A3,B2))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))))),bNF_Wellorder_ordLeq(sum_sum(A,B),product_prod(A,B)))) ) ) ).

% card_of_Plus_Times
tff(fact_4363_exists__minim__Card__order,axiom,
    ! [A: $tType,R: set(set(product_prod(A,A)))] :
      ( ( R != bot_bot(set(set(product_prod(A,A)))) )
     => ( ! [X: set(product_prod(A,A))] :
            ( pp(aa(set(set(product_prod(A,A))),bool,member(set(product_prod(A,A)),X),R))
           => pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,X)),X)) )
       => ? [X: set(product_prod(A,A))] :
            ( pp(aa(set(set(product_prod(A,A))),bool,member(set(product_prod(A,A)),X),R))
            & ! [Xa3: set(product_prod(A,A))] :
                ( pp(aa(set(set(product_prod(A,A))),bool,member(set(product_prod(A,A)),Xa3),R))
               => pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),X),Xa3)),bNF_Wellorder_ordLeq(A,A))) ) ) ) ) ).

% exists_minim_Card_order
tff(fact_4364_Card__order__empty,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
     => pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B)))),R2)),bNF_Wellorder_ordLeq(B,A))) ) ).

% Card_order_empty
tff(fact_4365_Card__order__singl__ordLeq,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(A,A)),B3: B] :
      ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
     => ( ( field2(A,R2) != bot_bot(set(A)) )
       => pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))),R2)),bNF_Wellorder_ordLeq(B,A))) ) ) ).

% Card_order_singl_ordLeq
tff(fact_4366_card__of__empty1,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(A,A))] :
      ( ( order_well_order_on(A,field2(A,R2),R2)
        | pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2)) )
     => pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B)))),R2)),bNF_Wellorder_ordLeq(B,A))) ) ).

% card_of_empty1
tff(fact_4367_Card__order__Times__infinite,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(A,A)),P5: set(product_prod(B,B))] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),field2(A,R2)))
     => ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
       => ( ( field2(B,P5) != bot_bot(set(B)) )
         => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),P5),R2)),bNF_Wellorder_ordLeq(B,A)))
           => ( pp(aa(set(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,field2(A,R2),aTP_Lamp_ags(set(product_prod(B,B)),fun(A,set(B)),P5)))),R2)),bNF_Wellorder_ordIso(product_prod(A,B),A)))
              & pp(aa(set(product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,field2(B,P5),aTP_Lamp_agr(set(product_prod(A,A)),fun(B,set(A)),R2)))),R2)),bNF_Wellorder_ordIso(product_prod(B,A),A))) ) ) ) ) ) ).

% Card_order_Times_infinite
tff(fact_4368_card__of__Sigma__ordLeq__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R2: set(product_prod(A,A)),I: set(B),A3: fun(B,set(C))] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),field2(A,R2)))
     => ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
       => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,I)),R2)),bNF_Wellorder_ordLeq(B,A)))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),I))
               => pp(aa(set(product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A3,X))),R2)),bNF_Wellorder_ordLeq(C,A))) )
           => pp(aa(set(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,I,A3))),R2)),bNF_Wellorder_ordLeq(product_prod(B,C),A))) ) ) ) ) ).

% card_of_Sigma_ordLeq_infinite_Field
tff(fact_4369_Plus__eq__empty__conv,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( ( sum_Plus(A,B,A3,B2) = bot_bot(set(sum_sum(A,B))) )
    <=> ( ( A3 = bot_bot(set(A)) )
        & ( B2 = bot_bot(set(B)) ) ) ) ).

% Plus_eq_empty_conv
tff(fact_4370_regularCard__UNION,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,A)),As8: fun(A,set(B)),B2: set(B)] :
      ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
     => ( bNF_Ca7133664381575040944arCard(A,R2)
       => ( bNF_Ca3754400796208372196lChain(A,set(B),R2,As8)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),As8),field2(A,R2)))))
           => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B2)),R2)),bNF_We4044943003108391690rdLess(B,A)))
             => ? [X: A] :
                  ( pp(aa(set(A),bool,member(A,X),field2(A,R2)))
                  & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B2),aa(A,set(B),As8,X))) ) ) ) ) ) ) ).

% regularCard_UNION
tff(fact_4371_cardSuc__UNION,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,A)),As8: fun(set(A),set(B)),B2: set(B)] :
      ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
     => ( ~ pp(aa(set(A),bool,finite_finite2(A),field2(A,R2)))
       => ( bNF_Ca3754400796208372196lChain(set(A),set(B),bNF_Ca8387033319878233205ardSuc(A,R2),As8)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(A)),set(set(B)),image2(set(A),set(B),As8),field2(set(A),bNF_Ca8387033319878233205ardSuc(A,R2))))))
           => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B2)),R2)),bNF_Wellorder_ordLeq(B,A)))
             => ? [X: set(A)] :
                  ( pp(aa(set(set(A)),bool,member(set(A),X),field2(set(A),bNF_Ca8387033319878233205ardSuc(A,R2))))
                  & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B2),aa(set(A),set(B),As8,X))) ) ) ) ) ) ) ).

% cardSuc_UNION
tff(fact_4372_UNION__Cinfinite__bound,axiom,
    ! [A: $tType,B: $tType,C: $tType,I: set(A),R2: set(product_prod(B,B)),A3: fun(A,set(C))] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,I)),R2)),bNF_Wellorder_ordLeq(A,B)))
     => ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),I))
           => pp(aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,aa(A,set(C),A3,X))),R2)),bNF_Wellorder_ordLeq(C,B))) )
       => ( ( bNF_Ca4139267488887388095finite(B,R2)
            & pp(aa(set(product_prod(B,B)),bool,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)) )
         => pp(aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image2(A,set(C),A3),I)))),R2)),bNF_Wellorder_ordLeq(C,B))) ) ) ) ).

% UNION_Cinfinite_bound
tff(fact_4373_cardSuc__UNION__Cinfinite,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,A)),As8: fun(set(A),set(B)),B2: set(B)] :
      ( ( bNF_Ca4139267488887388095finite(A,R2)
        & pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2)) )
     => ( bNF_Ca3754400796208372196lChain(set(A),set(B),bNF_Ca8387033319878233205ardSuc(A,R2),As8)
       => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(A)),set(set(B)),image2(set(A),set(B),As8),field2(set(A),bNF_Ca8387033319878233205ardSuc(A,R2))))))
         => ( pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B2)),R2)),bNF_Wellorder_ordLeq(B,A)))
           => ? [X: set(A)] :
                ( pp(aa(set(set(A)),bool,member(set(A),X),field2(set(A),bNF_Ca8387033319878233205ardSuc(A,R2))))
                & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B2),aa(set(A),set(B),As8,X))) ) ) ) ) ) ).

% cardSuc_UNION_Cinfinite
tff(fact_4374_SIGMA__CSUM,axiom,
    ! [B: $tType,A: $tType,I: set(A),As8: fun(A,set(B))] : ( bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,I,As8)) = bNF_Cardinal_Csum(A,B,bNF_Ca6860139660246222851ard_of(A,I),aTP_Lamp_agt(fun(A,set(B)),fun(A,set(product_prod(B,B))),As8)) ) ).

% SIGMA_CSUM
tff(fact_4375_Csum__def,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,A)),Rs: fun(A,set(product_prod(B,B)))] : ( bNF_Cardinal_Csum(A,B,R2,Rs) = bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,field2(A,R2),aTP_Lamp_agu(fun(A,set(product_prod(B,B))),fun(A,set(B)),Rs))) ) ).

% Csum_def
tff(fact_4376_cexp__mono2_H,axiom,
    ! [B: $tType,C: $tType,A: $tType,P22: set(product_prod(A,A)),R23: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P22),R23)),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(aa(set(product_prod(C,C)),bool,bNF_Ca8970107618336181345der_on(C,field2(C,Q3)),Q3))
       => ( ( ( field2(A,P22) = bot_bot(set(A)) )
           => ( field2(B,R23) = bot_bot(set(B)) ) )
         => pp(aa(set(product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C))))),bool,member(product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(A,C),fun(A,C))),fun(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C))))),product_Pair(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),bNF_Cardinal_cexp(C,A,Q3,P22)),bNF_Cardinal_cexp(C,B,Q3,R23))),bNF_Wellorder_ordLeq(fun(A,C),fun(B,C)))) ) ) ) ).

% cexp_mono2'
tff(fact_4377_pred__on_Onot__maxchain__Some,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,fun(A,bool)),C3: set(A)] :
      ( pp(aa(set(A),bool,pred_chain(A,A3,P),C3))
     => ( ~ pred_maxchain(A,A3,P,C3)
       => ( pp(aa(set(A),bool,pred_chain(A,A3,P),fChoice(set(A),aa(set(A),fun(set(A),bool),aa(fun(A,fun(A,bool)),fun(set(A),fun(set(A),bool)),aTP_Lamp_agv(set(A),fun(fun(A,fun(A,bool)),fun(set(A),fun(set(A),bool))),A3),P),C3))))
          & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),C3),fChoice(set(A),aa(set(A),fun(set(A),bool),aa(fun(A,fun(A,bool)),fun(set(A),fun(set(A),bool)),aTP_Lamp_agv(set(A),fun(fun(A,fun(A,bool)),fun(set(A),fun(set(A),bool))),A3),P),C3)))) ) ) ) ).

% pred_on.not_maxchain_Some
tff(fact_4378_subset_Onot__maxchain__Some,axiom,
    ! [A: $tType,A3: set(set(A)),C3: set(set(A))] :
      ( pp(aa(set(set(A)),bool,pred_chain(set(A),A3,ord_less(set(A))),C3))
     => ( ~ pred_maxchain(set(A),A3,ord_less(set(A)),C3)
       => ( pp(aa(set(set(A)),bool,pred_chain(set(A),A3,ord_less(set(A))),fChoice(set(set(A)),aa(set(set(A)),fun(set(set(A)),bool),aTP_Lamp_agw(set(set(A)),fun(set(set(A)),fun(set(set(A)),bool)),A3),C3))))
          & pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less(set(set(A))),C3),fChoice(set(set(A)),aa(set(set(A)),fun(set(set(A)),bool),aTP_Lamp_agw(set(set(A)),fun(set(set(A)),fun(set(set(A)),bool)),A3),C3)))) ) ) ) ).

% subset.not_maxchain_Some
tff(fact_4379_cexp__mono_H,axiom,
    ! [B: $tType,D: $tType,A: $tType,C: $tType,P1: set(product_prod(A,A)),R12: set(product_prod(B,B)),P22: set(product_prod(C,C)),R23: set(product_prod(D,D))] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R12)),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(aa(set(product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),bool,member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),P22),R23)),bNF_Wellorder_ordLeq(C,D)))
       => ( ( ( field2(C,P22) = bot_bot(set(C)) )
           => ( field2(D,R23) = bot_bot(set(D)) ) )
         => pp(aa(set(product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B))))),bool,member(product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),aa(set(product_prod(fun(D,B),fun(D,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),aa(set(product_prod(fun(C,A),fun(C,A))),fun(set(product_prod(fun(D,B),fun(D,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B))))),product_Pair(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),bNF_Cardinal_cexp(A,C,P1,P22)),bNF_Cardinal_cexp(B,D,R12,R23))),bNF_Wellorder_ordLeq(fun(C,A),fun(D,B)))) ) ) ) ).

% cexp_mono'
tff(fact_4380_card__of__Csum__Times_H,axiom,
    ! [A: $tType,C: $tType,B: $tType,R2: set(product_prod(A,A)),I: set(B),A3: fun(B,set(C))] :
      ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
     => ( ! [X: B] :
            ( pp(aa(set(B),bool,member(B,X),I))
           => pp(aa(set(product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A3,X))),R2)),bNF_Wellorder_ordLeq(C,A))) )
       => pp(aa(set(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,A),product_prod(B,A))))),bool,member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,A),product_prod(B,A)))),bNF_Cardinal_Csum(B,C,bNF_Ca6860139660246222851ard_of(B,I),aTP_Lamp_agx(fun(B,set(C)),fun(B,set(product_prod(C,C))),A3))),bNF_Cardinal_cprod(B,A,bNF_Ca6860139660246222851ard_of(B,I),R2))),bNF_Wellorder_ordLeq(product_prod(B,C),product_prod(B,A)))) ) ) ).

% card_of_Csum_Times'
tff(fact_4381_card__of__Csum__Times,axiom,
    ! [C: $tType,B: $tType,A: $tType,I: set(A),A3: fun(A,set(B)),B2: set(C)] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),I))
         => pp(aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),bool,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(A,set(B),A3,X))),bNF_Ca6860139660246222851ard_of(C,B2))),bNF_Wellorder_ordLeq(B,C))) )
     => pp(aa(set(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C))))),bool,member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(product_prod(A,C),product_prod(A,C))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C))))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),bNF_Cardinal_Csum(A,B,bNF_Ca6860139660246222851ard_of(A,I),aTP_Lamp_agt(fun(A,set(B)),fun(A,set(product_prod(B,B))),A3))),bNF_Cardinal_cprod(A,C,bNF_Ca6860139660246222851ard_of(A,I),bNF_Ca6860139660246222851ard_of(C,B2)))),bNF_Wellorder_ordLeq(product_prod(A,B),product_prod(A,C)))) ) ).

% card_of_Csum_Times
tff(fact_4382_czeroI,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2))
     => ( ( field2(A,R2) = bot_bot(set(A)) )
       => pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R2),bNF_Cardinal_czero(B))),bNF_Wellorder_ordIso(A,B))) ) ) ).

% czeroI
tff(fact_4383_Cnotzero__imp__not__empty,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( ( ~ pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R2),bNF_Cardinal_czero(A))),bNF_Wellorder_ordIso(A,A)))
        & pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,field2(A,R2)),R2)) )
     => ( field2(A,R2) != bot_bot(set(A)) ) ) ).

% Cnotzero_imp_not_empty
tff(fact_4384_czero__def,axiom,
    ! [A: $tType] : ( bNF_Cardinal_czero(A) = bNF_Ca6860139660246222851ard_of(A,bot_bot(set(A))) ) ).

% czero_def
tff(fact_4385_cprod__def,axiom,
    ! [A: $tType,B: $tType,R12: set(product_prod(A,A)),R23: set(product_prod(B,B))] : ( bNF_Cardinal_cprod(A,B,R12,R23) = bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,field2(A,R12),aTP_Lamp_ags(set(product_prod(B,B)),fun(A,set(B)),R23))) ) ).

% cprod_def
tff(fact_4386_czeroE,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R2),bNF_Cardinal_czero(B))),bNF_Wellorder_ordIso(A,B)))
     => ( field2(A,R2) = bot_bot(set(A)) ) ) ).

% czeroE
tff(fact_4387_card__of__ordIso__czero__iff__empty,axiom,
    ! [B: $tType,A: $tType,A3: set(A)] :
      ( pp(aa(set(product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),bool,member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A3)),bNF_Cardinal_czero(B))),bNF_Wellorder_ordIso(A,B)))
    <=> ( A3 = bot_bot(set(A)) ) ) ).

% card_of_ordIso_czero_iff_empty
tff(fact_4388_subset_Osuc__def,axiom,
    ! [A: $tType,A3: set(set(A)),C3: set(set(A))] :
      ( ( ( ~ pp(aa(set(set(A)),bool,pred_chain(set(A),A3,ord_less(set(A))),C3))
          | pred_maxchain(set(A),A3,ord_less(set(A)),C3) )
       => ( pred_suc(set(A),A3,ord_less(set(A)),C3) = C3 ) )
      & ( ~ ( ~ pp(aa(set(set(A)),bool,pred_chain(set(A),A3,ord_less(set(A))),C3))
            | pred_maxchain(set(A),A3,ord_less(set(A)),C3) )
       => ( pred_suc(set(A),A3,ord_less(set(A)),C3) = fChoice(set(set(A)),aa(set(set(A)),fun(set(set(A)),bool),aTP_Lamp_agw(set(set(A)),fun(set(set(A)),fun(set(set(A)),bool)),A3),C3)) ) ) ) ).

% subset.suc_def
tff(fact_4389_pred__on_Osuc__def,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,fun(A,bool)),C3: set(A)] :
      ( ( ( ~ pp(aa(set(A),bool,pred_chain(A,A3,P),C3))
          | pred_maxchain(A,A3,P,C3) )
       => ( pred_suc(A,A3,P,C3) = C3 ) )
      & ( ~ ( ~ pp(aa(set(A),bool,pred_chain(A,A3,P),C3))
            | pred_maxchain(A,A3,P,C3) )
       => ( pred_suc(A,A3,P,C3) = fChoice(set(A),aa(set(A),fun(set(A),bool),aa(fun(A,fun(A,bool)),fun(set(A),fun(set(A),bool)),aTP_Lamp_agv(set(A),fun(fun(A,fun(A,bool)),fun(set(A),fun(set(A),bool))),A3),P),C3)) ) ) ) ).

% pred_on.suc_def
tff(fact_4390_prod__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,X2: A,Y: B] : ( aa(product_prod(A,B),set(A),basic_fsts(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y)) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ).

% prod_set_simps(1)
tff(fact_4391_prod__set__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X2: A,Y: B] : ( basic_snds(A,B,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y)) = aa(set(B),set(B),insert(B,Y),bot_bot(set(B))) ) ).

% prod_set_simps(2)
tff(fact_4392_prod__set__defs_I1_J,axiom,
    ! [B: $tType,A: $tType,X4: product_prod(A,B)] : ( aa(product_prod(A,B),set(A),basic_fsts(A,B),X4) = aa(set(A),set(A),insert(A,aa(product_prod(A,B),A,product_fst(A,B),X4)),bot_bot(set(A))) ) ).

% prod_set_defs(1)
tff(fact_4393_prod__set__defs_I2_J,axiom,
    ! [C: $tType,D: $tType,X4: product_prod(C,D)] : ( basic_snds(C,D,X4) = aa(set(D),set(D),insert(D,aa(product_prod(C,D),D,product_snd(C,D),X4)),bot_bot(set(D))) ) ).

% prod_set_defs(2)
tff(fact_4394_funpow__inj__finite,axiom,
    ! [A: $tType,P5: fun(A,A),X2: A] :
      ( inj_on(A,A,P5,top_top(set(A)))
     => ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_agy(fun(A,A),fun(A,fun(A,bool)),P5),X2))))
       => ~ ! [N2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N2))
             => ( aa(A,A,compow(fun(A,A),N2,P5),X2) != X2 ) ) ) ) ).

% funpow_inj_finite
tff(fact_4395_single__valuedp__single__valued__eq,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B))] :
      ( single_valuedp(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),R2))
    <=> single_valued(A,B,R2) ) ).

% single_valuedp_single_valued_eq
tff(fact_4396_Code__Numeral_Osub__def,axiom,
    code_sub = aa(fun(num,fun(num,int)),fun(num,fun(num,code_integer)),map_fun(num,num,fun(num,int),fun(num,code_integer),id(num),map_fun(num,num,int,code_integer,id(num),code_integer_of_int)),aTP_Lamp_ya(num,fun(num,int))) ).

% Code_Numeral.sub_def
tff(fact_4397_set__encode__empty,axiom,
    nat_set_encode(bot_bot(set(nat))) = zero_zero(nat) ).

% set_encode_empty
tff(fact_4398_comp__fun__commute_Ocomp__fun__commute__funpow,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(B,B)),G: fun(A,nat)] :
      ( finite6289374366891150609ommute(A,B,F2)
     => finite6289374366891150609ommute(A,B,aa(fun(A,nat),fun(A,fun(B,B)),aTP_Lamp_agz(fun(A,fun(B,B)),fun(fun(A,nat),fun(A,fun(B,B))),F2),G)) ) ).

% comp_fun_commute.comp_fun_commute_funpow
tff(fact_4399_comp__fun__commute__on_Ocomp__fun__commute__on__funpow,axiom,
    ! [B: $tType,A: $tType,S: set(A),F2: fun(A,fun(B,B)),G: fun(A,nat)] :
      ( finite4664212375090638736ute_on(A,B,S,F2)
     => finite4664212375090638736ute_on(A,B,S,aa(fun(A,nat),fun(A,fun(B,B)),aTP_Lamp_agz(fun(A,fun(B,B)),fun(fun(A,nat),fun(A,fun(B,B))),F2),G)) ) ).

% comp_fun_commute_on.comp_fun_commute_on_funpow
tff(fact_4400_funpow__times__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [F2: fun(A,nat),X2: A] : ( compow(fun(A,A),aa(A,nat,F2,X2),aa(A,fun(A,A),times_times(A),X2)) = aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X2),aa(A,nat,F2,X2))) ) ) ).

% funpow_times_power
tff(fact_4401_relpowp__relpow__eq,axiom,
    ! [A: $tType,N: nat,R: set(product_prod(A,A)),X4: A,Xa3: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),compow(fun(A,fun(A,bool)),N,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R)),X4),Xa3))
    <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa3)),compow(set(product_prod(A,A)),N,R))) ) ).

% relpowp_relpow_eq
tff(fact_4402_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [F2: fun(A,A),P5: A,K: nat] :
          ( order_mono(A,A,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,F2,P5)),P5))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,compow(fun(A,A),K,F2),bot_bot(A))),P5)) ) ) ) ).

% Kleene_iter_lpfp
tff(fact_4403_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [F2: fun(A,A),P5: A,K: nat] :
          ( order_mono(A,A,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),P5),aa(A,A,F2,P5)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),P5),aa(A,A,compow(fun(A,A),K,F2),top_top(A)))) ) ) ) ).

% Kleene_iter_gpfp
tff(fact_4404_single__valuedp__bot,axiom,
    ! [B: $tType,A: $tType] : single_valuedp(A,B,bot_bot(fun(A,fun(B,bool)))) ).

% single_valuedp_bot
tff(fact_4405_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( compow(fun(A,fun(A,bool)),N,bot_bot(fun(A,fun(A,bool)))) = bot_bot(fun(A,fun(A,bool))) ) ) ).

% relpowp_bot
tff(fact_4406_single__valuedp__iff__Uniq,axiom,
    ! [B: $tType,A: $tType,R2: fun(A,fun(B,bool))] :
      ( single_valuedp(A,B,R2)
    <=> ! [X3: A] : uniq(B,aa(A,fun(B,bool),R2,X3)) ) ).

% single_valuedp_iff_Uniq
tff(fact_4407_of__nat__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),N) = aa(A,A,compow(fun(A,A),N,aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% of_nat_def
tff(fact_4408_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num,A4: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),K)),A4) = aa(A,A,compow(fun(A,A),aa(num,nat,numeral_numeral(nat),K),aa(A,fun(A,A),plus_plus(A),one_one(A))),A4) ) ) ).

% numeral_add_unfold_funpow
tff(fact_4409_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Q: fun(A,A)] :
          ( order_mono(A,A,Q)
         => order_mono(nat,A,aTP_Lamp_aha(fun(A,A),fun(nat,A),Q)) ) ) ).

% mono_funpow
tff(fact_4410_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [M2: nat,N: nat,F2: fun(A,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( order_mono(A,A,F2)
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,compow(fun(A,A),M2,F2),bot_bot(A))),aa(A,A,compow(fun(A,A),N,F2),bot_bot(A)))) ) ) ) ).

% funpow_decreasing
tff(fact_4411_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [M2: nat,N: nat,F2: fun(A,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
         => ( order_mono(A,A,F2)
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,compow(fun(A,A),N,F2),top_top(A))),aa(A,A,compow(fun(A,A),M2,F2),top_top(A)))) ) ) ) ).

% funpow_increasing
tff(fact_4412_lfp__Kleene__iter,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,A),K: nat] :
          ( order_mono(A,A,F2)
         => ( ( aa(A,A,compow(fun(A,A),aa(nat,nat,suc,K),F2),bot_bot(A)) = aa(A,A,compow(fun(A,A),K,F2),bot_bot(A)) )
           => ( complete_lattice_lfp(A,F2) = aa(A,A,compow(fun(A,A),K,F2),bot_bot(A)) ) ) ) ) ).

% lfp_Kleene_iter
tff(fact_4413_gfp__Kleene__iter,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,A),K: nat] :
          ( order_mono(A,A,F2)
         => ( ( aa(A,A,compow(fun(A,A),aa(nat,nat,suc,K),F2),top_top(A)) = aa(A,A,compow(fun(A,A),K,F2),top_top(A)) )
           => ( complete_lattice_gfp(A,F2) = aa(A,A,compow(fun(A,A),K,F2),top_top(A)) ) ) ) ) ).

% gfp_Kleene_iter
tff(fact_4414_inj__on__funpow__least,axiom,
    ! [A: $tType,N: nat,F2: fun(A,A),S2: A] :
      ( ( aa(A,A,compow(fun(A,A),N,F2),S2) = S2 )
     => ( ! [M3: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),M3))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M3),N))
             => ( aa(A,A,compow(fun(A,A),M3,F2),S2) != S2 ) ) )
       => inj_on(nat,A,aa(A,fun(nat,A),aTP_Lamp_ahb(fun(A,A),fun(A,fun(nat,A)),F2),S2),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% inj_on_funpow_least
tff(fact_4415_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),K) = aa(A,A,compow(fun(A,A),aa(num,nat,numeral_numeral(nat),K),aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% numeral_unfold_funpow
tff(fact_4416_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [Q: fun(A,A)] :
          ( order_mono(A,A,Q)
         => order_antimono(nat,A,aTP_Lamp_ahc(fun(A,A),fun(nat,A),Q)) ) ) ).

% antimono_funpow
tff(fact_4417_su__rel__fun__def,axiom,
    ! [B: $tType,A: $tType,F: set(product_prod(A,B)),F2: fun(A,B)] :
      ( su_rel_fun(A,B,F,F2)
    <=> ( ! [A12: A,B9: B,B14: B] :
            ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A12),B9)),F))
           => ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A12),B14)),F))
             => ( B9 = B14 ) ) )
        & ! [A12: A,P4: bool] :
            ( ! [B9: B] :
                ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A12),B9)),F))
               => pp(P4) )
           => pp(P4) )
        & ! [A12: A] : ( aa(A,B,F2,A12) = the(B,aa(A,fun(B,bool),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),F),A12)) ) ) ) ).

% su_rel_fun_def
tff(fact_4418_su__rel__fun_Ointro,axiom,
    ! [B: $tType,A: $tType,F: set(product_prod(A,B)),F2: fun(A,B)] :
      ( ! [A11: A,B8: B,B15: B] :
          ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A11),B8)),F))
         => ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A11),B15)),F))
           => ( B8 = B15 ) ) )
     => ( ! [A11: A,P3: bool] :
            ( ! [B16: B] :
                ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A11),B16)),F))
               => pp(P3) )
           => pp(P3) )
       => ( ! [A11: A] : ( aa(A,B,F2,A11) = the(B,aa(A,fun(B,bool),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),F),A11)) )
         => su_rel_fun(A,B,F,F2) ) ) ) ).

% su_rel_fun.intro
tff(fact_4419_su__rel__fun_Of__def,axiom,
    ! [B: $tType,A: $tType,F: set(product_prod(A,B)),F2: fun(A,B),A3: A] :
      ( su_rel_fun(A,B,F,F2)
     => ( aa(A,B,F2,A3) = the(B,aa(A,fun(B,bool),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),F),A3)) ) ) ).

% su_rel_fun.f_def
tff(fact_4420_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( order_antimono(A,B,F2)
        <=> ! [X3: A,Y4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y4))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,Y4)),aa(A,B,F2,X3))) ) ) ) ).

% antimono_def
tff(fact_4421_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( ! [X: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,Y2)),aa(A,B,F2,X))) )
         => order_antimono(A,B,F2) ) ) ).

% antimonoI
tff(fact_4422_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B),X2: A,Y: A] :
          ( order_antimono(A,B,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,Y)),aa(A,B,F2,X2))) ) ) ) ).

% antimonoE
tff(fact_4423_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B),X2: A,Y: A] :
          ( order_antimono(A,B,F2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,Y)),aa(A,B,F2,X2))) ) ) ) ).

% antimonoD
tff(fact_4424_min__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F2: fun(A,B),X2: A,Y: A] :
          ( order_antimono(A,B,F2)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(A,B,F2,X2)),aa(A,B,F2,Y)) = aa(A,B,F2,aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y)) ) ) ) ).

% min_of_antimono
tff(fact_4425_max__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F2: fun(A,B),X2: A,Y: A] :
          ( order_antimono(A,B,F2)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(A,B,F2,X2)),aa(A,B,F2,Y)) = aa(A,B,F2,aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y)) ) ) ) ).

% max_of_antimono
tff(fact_4426_aboveS__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A4: A] : ( order_aboveS(A,R2,A4) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_ahd(set(product_prod(A,A)),fun(A,fun(A,bool)),R2),A4)) ) ).

% aboveS_def
tff(fact_4427_cardSuc__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( bNF_Ca8387033319878233205ardSuc(A,R2) = fChoice(set(product_prod(set(A),set(A))),bNF_Ca6246979054910435723ardSuc(A,R2)) ) ).

% cardSuc_def
tff(fact_4428_scomp__unfold,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,X4: fun(A,product_prod(B,C)),Xa3: fun(B,fun(C,D)),Xb3: A] : ( aa(A,D,product_scomp(A,B,C,D,X4,Xa3),Xb3) = aa(C,D,aa(B,fun(C,D),Xa3,aa(product_prod(B,C),B,product_fst(B,C),aa(A,product_prod(B,C),X4,Xb3))),aa(product_prod(B,C),C,product_snd(B,C),aa(A,product_prod(B,C),X4,Xb3))) ) ).

% scomp_unfold
tff(fact_4429_semilattice__order__set_Osubset__imp,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: set(A),B2: set(A)] :
      ( lattic4895041142388067077er_set(A,F2,Less_eq,Less)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),B2))
       => ( ( A3 != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,finite_finite2(A),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(set(A),A,lattic1715443433743089157tice_F(A,F2),B2)),aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3))) ) ) ) ) ).

% semilattice_order_set.subset_imp
tff(fact_4430_scomp__scomp,axiom,
    ! [A: $tType,E: $tType,F10: $tType,B: $tType,D: $tType,C: $tType,F2: fun(A,product_prod(E,F10)),G: fun(E,fun(F10,product_prod(C,D))),H2: fun(C,fun(D,B))] : ( product_scomp(A,C,D,B,product_scomp(A,E,F10,product_prod(C,D),F2,G),H2) = product_scomp(A,E,F10,B,F2,aa(fun(C,fun(D,B)),fun(E,fun(F10,B)),aTP_Lamp_ahe(fun(E,fun(F10,product_prod(C,D))),fun(fun(C,fun(D,B)),fun(E,fun(F10,B))),G),H2)) ) ).

% scomp_scomp
tff(fact_4431_Inf__fin__def,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ( lattic7752659483105999362nf_fin(A) = lattic1715443433743089157tice_F(A,inf_inf(A)) ) ) ).

% Inf_fin_def
tff(fact_4432_semilattice__order__set_Obounded__iff,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: set(A),X2: A] :
      ( lattic4895041142388067077er_set(A,F2,Less_eq,Less)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( ( A3 != bot_bot(set(A)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X2),aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3)))
          <=> ! [X3: A] :
                ( pp(aa(set(A),bool,member(A,X3),A3))
               => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X2),X3)) ) ) ) ) ) ).

% semilattice_order_set.bounded_iff
tff(fact_4433_semilattice__order__set_OboundedI,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: set(A),X2: A] :
      ( lattic4895041142388067077er_set(A,F2,Less_eq,Less)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( ( A3 != bot_bot(set(A)) )
         => ( ! [A5: A] :
                ( pp(aa(set(A),bool,member(A,A5),A3))
               => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X2),A5)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X2),aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3))) ) ) ) ) ).

% semilattice_order_set.boundedI
tff(fact_4434_semilattice__order__set_OboundedE,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: set(A),X2: A] :
      ( lattic4895041142388067077er_set(A,F2,Less_eq,Less)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( ( A3 != bot_bot(set(A)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X2),aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3)))
           => ! [A14: A] :
                ( pp(aa(set(A),bool,member(A,A14),A3))
               => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X2),A14)) ) ) ) ) ) ).

% semilattice_order_set.boundedE
tff(fact_4435_semilattice__set_Oeq__fold_H,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A3: set(A)] :
      ( lattic149705377957585745ce_set(A,F2)
     => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3) = aa(option(A),A,the2(A),finite_fold(A,option(A),aTP_Lamp_ahf(fun(A,fun(A,A)),fun(A,fun(option(A),option(A))),F2),none(A),A3)) ) ) ).

% semilattice_set.eq_fold'
tff(fact_4436_semilattice__set_Oremove,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A3: set(A),X2: A] :
      ( lattic149705377957585745ce_set(A,F2)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( pp(aa(set(A),bool,member(A,X2),A3))
         => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = bot_bot(set(A)) )
             => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3) = X2 ) )
            & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3) = aa(A,A,aa(A,fun(A,A),F2,X2),aa(set(A),A,lattic1715443433743089157tice_F(A,F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ) ).

% semilattice_set.remove
tff(fact_4437_semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A3: set(A),X2: A] :
      ( lattic149705377957585745ce_set(A,F2)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = bot_bot(set(A)) )
           => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F2),aa(set(A),set(A),insert(A,X2),A3)) = X2 ) )
          & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F2),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),F2,X2),aa(set(A),A,lattic1715443433743089157tice_F(A,F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ) ).

% semilattice_set.insert_remove
tff(fact_4438_semilattice__set_Ounion,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A3: set(A),B2: set(A)] :
      ( lattic149705377957585745ce_set(A,F2)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( ( A3 != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,finite_finite2(A),B2))
           => ( ( B2 != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(A,A,aa(A,fun(A,A),F2,aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3)),aa(set(A),A,lattic1715443433743089157tice_F(A,F2),B2)) ) ) ) ) ) ) ).

% semilattice_set.union
tff(fact_4439_Inf__fin_Osemilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => lattic149705377957585745ce_set(A,inf_inf(A)) ) ).

% Inf_fin.semilattice_set_axioms
tff(fact_4440_semilattice__set_Osingleton,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),X2: A] :
      ( lattic149705377957585745ce_set(A,F2)
     => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) = X2 ) ) ).

% semilattice_set.singleton
tff(fact_4441_semilattice__set_Ohom__commute,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),H2: fun(A,A),N4: set(A)] :
      ( lattic149705377957585745ce_set(A,F2)
     => ( ! [X: A,Y2: A] : ( aa(A,A,H2,aa(A,A,aa(A,fun(A,A),F2,X),Y2)) = aa(A,A,aa(A,fun(A,A),F2,aa(A,A,H2,X)),aa(A,A,H2,Y2)) )
       => ( pp(aa(set(A),bool,finite_finite2(A),N4))
         => ( ( N4 != bot_bot(set(A)) )
           => ( aa(A,A,H2,aa(set(A),A,lattic1715443433743089157tice_F(A,F2),N4)) = aa(set(A),A,lattic1715443433743089157tice_F(A,F2),aa(set(A),set(A),image2(A,A,H2),N4)) ) ) ) ) ) ).

% semilattice_set.hom_commute
tff(fact_4442_semilattice__set_Osubset,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A3: set(A),B2: set(A)] :
      ( lattic149705377957585745ce_set(A,F2)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( ( B2 != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),A3))
           => ( aa(A,A,aa(A,fun(A,A),F2,aa(set(A),A,lattic1715443433743089157tice_F(A,F2),B2)),aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3)) = aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3) ) ) ) ) ) ).

% semilattice_set.subset
tff(fact_4443_semilattice__set_Oinsert__not__elem,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A3: set(A),X2: A] :
      ( lattic149705377957585745ce_set(A,F2)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( ~ pp(aa(set(A),bool,member(A,X2),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F2),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),F2,X2),aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3)) ) ) ) ) ) ).

% semilattice_set.insert_not_elem
tff(fact_4444_semilattice__set_Oinsert,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A3: set(A),X2: A] :
      ( lattic149705377957585745ce_set(A,F2)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( ( A3 != bot_bot(set(A)) )
         => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F2),aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),F2,X2),aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3)) ) ) ) ) ).

% semilattice_set.insert
tff(fact_4445_semilattice__set_Oclosed,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A3: set(A)] :
      ( lattic149705377957585745ce_set(A,F2)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( ( A3 != bot_bot(set(A)) )
         => ( ! [X: A,Y2: A] : pp(aa(set(A),bool,member(A,aa(A,A,aa(A,fun(A,A),F2,X),Y2)),aa(set(A),set(A),insert(A,X),aa(set(A),set(A),insert(A,Y2),bot_bot(set(A))))))
           => pp(aa(set(A),bool,member(A,aa(set(A),A,lattic1715443433743089157tice_F(A,F2),A3)),A3)) ) ) ) ) ).

% semilattice_set.closed
tff(fact_4446_cr__int__def,axiom,
    ! [X4: product_prod(nat,nat)] : ( cr_int(X4) = aa(int,fun(int,bool),fequal(int),aa(product_prod(nat,nat),int,abs_Integ,X4)) ) ).

% cr_int_def
tff(fact_4447_antisymp__antisym__eq,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( antisymp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2))
    <=> antisym(A,R2) ) ).

% antisymp_antisym_eq
tff(fact_4448_mult__inj__if__coprime__nat,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,nat),A3: set(A),G: fun(B,nat),B2: set(B)] :
      ( inj_on(A,nat,F2,A3)
     => ( inj_on(B,nat,G,B2)
       => ( ! [A5: A,B4: B] :
              ( pp(aa(set(A),bool,member(A,A5),A3))
             => ( pp(aa(set(B),bool,member(B,B4),B2))
               => algebr8660921524188924756oprime(nat,aa(A,nat,F2,A5),aa(B,nat,G,B4)) ) )
         => inj_on(product_prod(A,B),nat,aa(fun(A,fun(B,nat)),fun(product_prod(A,B),nat),product_case_prod(A,B,nat),aa(fun(B,nat),fun(A,fun(B,nat)),aTP_Lamp_ahg(fun(A,nat),fun(fun(B,nat),fun(A,fun(B,nat))),F2),G)),product_Sigma(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2))) ) ) ) ).

% mult_inj_if_coprime_nat
tff(fact_4449_K__record__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,C2: B,F2: fun(A,C),X4: A] : ( aa(A,B,aa(fun(A,C),fun(A,B),comp(C,B,A,aTP_Lamp_ahh(B,fun(C,B),C2)),F2),X4) = C2 ) ).

% K_record_comp
tff(fact_4450_coprime__mult__right__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A4: A,B3: A] :
          ( algebr8660921524188924756oprime(A,C2,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3))
        <=> ( algebr8660921524188924756oprime(A,C2,A4)
            & algebr8660921524188924756oprime(A,C2,B3) ) ) ) ).

% coprime_mult_right_iff
tff(fact_4451_coprime__mult__left__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,C2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3),C2)
        <=> ( algebr8660921524188924756oprime(A,A4,C2)
            & algebr8660921524188924756oprime(A,B3,C2) ) ) ) ).

% coprime_mult_left_iff
tff(fact_4452_coprime__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A] :
          ( algebr8660921524188924756oprime(A,A4,A4)
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A))) ) ) ).

% coprime_self
tff(fact_4453_coprime__imp__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] :
          ( algebr8660921524188924756oprime(A,A4,B3)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) = one_one(A) ) ) ) ).

% coprime_imp_gcd_eq_1
tff(fact_4454_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A] :
          ( algebr8660921524188924756oprime(A,A4,zero_zero(A))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A))) ) ) ).

% coprime_0_right_iff
tff(fact_4455_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A] :
          ( algebr8660921524188924756oprime(A,zero_zero(A),A4)
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A))) ) ) ).

% coprime_0_left_iff
tff(fact_4456_coprime__mult__self__left__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A4: A,B3: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),one_one(A)))
            & algebr8660921524188924756oprime(A,A4,B3) ) ) ) ).

% coprime_mult_self_left_iff
tff(fact_4457_coprime__mult__self__right__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,C2: A,B3: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),one_one(A)))
            & algebr8660921524188924756oprime(A,A4,B3) ) ) ) ).

% coprime_mult_self_right_iff
tff(fact_4458_is__unit__gcd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)),one_one(A)))
        <=> algebr8660921524188924756oprime(A,A4,B3) ) ) ).

% is_unit_gcd
tff(fact_4459_prod__coprime__left,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(B),F2: fun(B,A),A4: A] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),A3))
             => algebr8660921524188924756oprime(A,aa(B,A,F2,I3),A4) )
         => algebr8660921524188924756oprime(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3),A4) ) ) ).

% prod_coprime_left
tff(fact_4460_prod__coprime__right,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(B),A4: A,F2: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),A3))
             => algebr8660921524188924756oprime(A,A4,aa(B,A,F2,I3)) )
         => algebr8660921524188924756oprime(A,A4,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3)) ) ) ).

% prod_coprime_right
tff(fact_4461_coprime__commute,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A] :
          ( algebr8660921524188924756oprime(A,B3,A4)
        <=> algebr8660921524188924756oprime(A,A4,B3) ) ) ).

% coprime_commute
tff(fact_4462_coprime__divisors,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,C2: A,B3: A,D3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),D3))
           => ( algebr8660921524188924756oprime(A,C2,D3)
             => algebr8660921524188924756oprime(A,A4,B3) ) ) ) ) ).

% coprime_divisors
tff(fact_4463_coprime__1__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A] : algebr8660921524188924756oprime(A,one_one(A),A4) ) ).

% coprime_1_left
tff(fact_4464_coprime__1__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A] : algebr8660921524188924756oprime(A,A4,one_one(A)) ) ).

% coprime_1_right
tff(fact_4465_coprime__add__one__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A] : algebr8660921524188924756oprime(A,A4,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A))) ) ).

% coprime_add_one_right
tff(fact_4466_coprime__add__one__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A] : algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),one_one(A)),A4) ) ).

% coprime_add_one_left
tff(fact_4467_coprime__doff__one__right,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A4: A] : algebr8660921524188924756oprime(A,A4,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))) ) ).

% coprime_doff_one_right
tff(fact_4468_coprime__diff__one__left,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A4: A] : algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A)),A4) ) ).

% coprime_diff_one_left
tff(fact_4469_coprime__dvd__mult__right__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,C2: A,B3: A] :
          ( algebr8660921524188924756oprime(A,A4,C2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ) ).

% coprime_dvd_mult_right_iff
tff(fact_4470_coprime__dvd__mult__left__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,C2: A,B3: A] :
          ( algebr8660921524188924756oprime(A,A4,C2)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ) ).

% coprime_dvd_mult_left_iff
tff(fact_4471_divides__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,C2: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),C2))
           => ( algebr8660921524188924756oprime(A,A4,B3)
             => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),C2)) ) ) ) ) ).

% divides_mult
tff(fact_4472_is__unit__right__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => algebr8660921524188924756oprime(A,A4,B3) ) ) ).

% is_unit_right_imp_coprime
tff(fact_4473_is__unit__left__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => algebr8660921524188924756oprime(A,A4,B3) ) ) ).

% is_unit_left_imp_coprime
tff(fact_4474_coprime__common__divisor,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A,C2: A] :
          ( algebr8660921524188924756oprime(A,A4,B3)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
             => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),one_one(A))) ) ) ) ) ).

% coprime_common_divisor
tff(fact_4475_coprime__absorb__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [Y: A,X2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Y),X2))
         => ( algebr8660921524188924756oprime(A,X2,Y)
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Y),one_one(A))) ) ) ) ).

% coprime_absorb_right
tff(fact_4476_coprime__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,D3: A,A4: A,B3: A] :
          ( algebr8660921524188924756oprime(A,C2,D3)
         => ( ! [E4: A] :
                ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),E4),one_one(A)))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),E4),A4))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),E4),B3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),E4),C2)) ) ) )
           => ( ! [E4: A] :
                  ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),E4),one_one(A)))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),E4),A4))
                   => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),E4),B3))
                     => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),E4),D3)) ) ) )
             => algebr8660921524188924756oprime(A,A4,B3) ) ) ) ) ).

% coprime_imp_coprime
tff(fact_4477_coprime__absorb__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [X2: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X2),Y))
         => ( algebr8660921524188924756oprime(A,X2,Y)
          <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X2),one_one(A))) ) ) ) ).

% coprime_absorb_left
tff(fact_4478_not__coprimeI,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),A4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),B3))
           => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C2),one_one(A)))
             => ~ algebr8660921524188924756oprime(A,A4,B3) ) ) ) ) ).

% not_coprimeI
tff(fact_4479_not__coprimeE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( ~ algebr8660921524188924756oprime(A,A4,B3)
         => ~ ! [C4: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C4),A4))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C4),B3))
                 => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C4),one_one(A))) ) ) ) ) ).

% not_coprimeE
tff(fact_4480_coprime__def,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( algebr8660921524188924756oprime(A,A4,B3)
        <=> ! [C5: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C5),A4))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C5),B3))
               => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C5),one_one(A))) ) ) ) ) ).

% coprime_def
tff(fact_4481_coprimeI,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: A,B3: A] :
          ( ! [C4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C4),A4))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C4),B3))
               => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),C4),one_one(A))) ) )
         => algebr8660921524188924756oprime(A,A4,B3) ) ) ).

% coprimeI
tff(fact_4482_mult__mod__cancel__left,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel(A)
        & semiring_gcd(A) )
     => ! [N: A,A4: A,M2: A,B3: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),N),A4),M2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),N),B3),M2) )
         => ( algebr8660921524188924756oprime(A,M2,N)
           => ( modulo_modulo(A,A4,M2) = modulo_modulo(A,B3,M2) ) ) ) ) ).

% mult_mod_cancel_left
tff(fact_4483_mult__mod__cancel__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel(A)
        & semiring_gcd(A) )
     => ! [A4: A,N: A,M2: A,B3: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),N),M2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),B3),N),M2) )
         => ( algebr8660921524188924756oprime(A,M2,N)
           => ( modulo_modulo(A,A4,M2) = modulo_modulo(A,B3,M2) ) ) ) ) ).

% mult_mod_cancel_right
tff(fact_4484_gcd__mult__right__right__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,C2: A,B3: A] :
          ( algebr8660921524188924756oprime(A,A4,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) ) ) ) ).

% gcd_mult_right_right_cancel
tff(fact_4485_gcd__mult__right__left__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,C2: A,B3: A] :
          ( algebr8660921524188924756oprime(A,A4,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) ) ) ) ).

% gcd_mult_right_left_cancel
tff(fact_4486_gcd__mult__left__right__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B3: A,C2: A,A4: A] :
          ( algebr8660921524188924756oprime(A,B3,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),B3) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) ) ) ) ).

% gcd_mult_left_right_cancel
tff(fact_4487_gcd__mult__left__left__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B3: A,C2: A,A4: A] :
          ( algebr8660921524188924756oprime(A,B3,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),B3) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) ) ) ) ).

% gcd_mult_left_left_cancel
tff(fact_4488_gcd__eq__1__imp__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) = one_one(A) )
         => algebr8660921524188924756oprime(A,A4,B3) ) ) ).

% gcd_eq_1_imp_coprime
tff(fact_4489_coprime__iff__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] :
          ( algebr8660921524188924756oprime(A,A4,B3)
        <=> ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) = one_one(A) ) ) ) ).

% coprime_iff_gcd_eq_1
tff(fact_4490_antisym__bot,axiom,
    ! [A: $tType] : antisymp(A,bot_bot(fun(A,fun(A,bool)))) ).

% antisym_bot
tff(fact_4491_invertible__coprime,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A4: A,B3: A,C2: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3),C2) = one_one(A) )
         => algebr8660921524188924756oprime(A,A4,C2) ) ) ).

% invertible_coprime
tff(fact_4492_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) != zero_zero(A) )
         => ? [A9: A,B11: A] :
              ( ( A4 = aa(A,A,aa(A,fun(A,A),times_times(A),A9),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)) )
              & ( B3 = aa(A,A,aa(A,fun(A,A),times_times(A),B11),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)) )
              & algebr8660921524188924756oprime(A,A9,B11) ) ) ) ).

% gcd_coprime_exists
tff(fact_4493_gcd__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,A7: A,B6: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) != zero_zero(A) )
         => ( ( A4 = aa(A,A,aa(A,fun(A,A),times_times(A),A7),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)) )
           => ( ( B3 = aa(A,A,aa(A,fun(A,A),times_times(A),B6),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)) )
             => algebr8660921524188924756oprime(A,A7,B6) ) ) ) ) ).

% gcd_coprime
tff(fact_4494_bind__singleton__conv__image,axiom,
    ! [A: $tType,B: $tType,A3: set(B),F2: fun(B,A)] : ( bind3(B,A,A3,aTP_Lamp_gy(fun(B,A),fun(B,set(A)),F2)) = aa(set(B),set(A),image2(B,A,F2),A3) ) ).

% bind_singleton_conv_image
tff(fact_4495_and_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => semilattice_neutr(A,bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% and.semilattice_neutr_axioms
tff(fact_4496_Func__empty,axiom,
    ! [B: $tType,A: $tType,B2: set(B)] : ( bNF_Wellorder_Func(A,B,bot_bot(set(A)),B2) = aa(set(fun(A,B)),set(fun(A,B)),insert(fun(A,B),aTP_Lamp_ahi(A,B)),bot_bot(set(fun(A,B)))) ) ).

% Func_empty
tff(fact_4497_Restr__natLeq2,axiom,
    ! [N: nat] : ( aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),inf_inf(set(product_prod(nat,nat))),bNF_Ca8665028551170535155natLeq),product_Sigma(nat,nat,order_underS(nat,bNF_Ca8665028551170535155natLeq,N),aTP_Lamp_ahj(nat,fun(nat,set(nat)),N))) = aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_tr(nat,fun(nat,fun(nat,bool)),N))) ) ).

% Restr_natLeq2
tff(fact_4498_empty__bind,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,set(A))] : ( bind3(B,A,bot_bot(set(B)),F2) = bot_bot(set(A)) ) ).

% empty_bind
tff(fact_4499_mod__h__bot__normalize,axiom,
    ! [A: $tType,H2: heap_ext(product_unit),P: assn] :
      ( syntax7388354845996824322omatch(A,heap_ext(product_unit),undefined(A),H2)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
      <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),undefined(heap_ext(product_unit))),bot_bot(set(nat))))) ) ) ).

% mod_h_bot_normalize
tff(fact_4500_Set_Obind__bind,axiom,
    ! [A: $tType,B: $tType,C: $tType,A3: set(A),B2: fun(A,set(C)),C3: fun(C,set(B))] : ( bind3(C,B,bind3(A,C,A3,B2),C3) = bind3(A,B,A3,aa(fun(C,set(B)),fun(A,set(B)),aTP_Lamp_ahk(fun(A,set(C)),fun(fun(C,set(B)),fun(A,set(B))),B2),C3)) ) ).

% Set.bind_bind
tff(fact_4501_natLeq__underS__less,axiom,
    ! [N: nat] : ( order_underS(nat,bNF_Ca8665028551170535155natLeq,N) = aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N)) ) ).

% natLeq_underS_less
tff(fact_4502_semilattice__neutr_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( semilattice_neutr(A,F2,Z2)
     => comm_monoid(A,F2,Z2) ) ).

% semilattice_neutr.axioms(2)
tff(fact_4503_bind__const,axiom,
    ! [B: $tType,A: $tType,A3: set(B),B2: set(A)] :
      ( ( ( A3 = bot_bot(set(B)) )
       => ( bind3(B,A,A3,aTP_Lamp_bv(set(A),fun(B,set(A)),B2)) = bot_bot(set(A)) ) )
      & ( ( A3 != bot_bot(set(B)) )
       => ( bind3(B,A,A3,aTP_Lamp_bv(set(A),fun(B,set(A)),B2)) = B2 ) ) ) ).

% bind_const
tff(fact_4504_nonempty__bind__const,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] :
      ( ( A3 != bot_bot(set(A)) )
     => ( bind3(A,B,A3,aTP_Lamp_bq(set(B),fun(A,set(B)),B2)) = B2 ) ) ).

% nonempty_bind_const
tff(fact_4505_semilattice__neutr__order_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semila1105856199041335345_order(A,F2,Z2,Less_eq,Less)
     => semilattice_neutr(A,F2,Z2) ) ).

% semilattice_neutr_order.axioms(1)
tff(fact_4506_option_Othe__def,axiom,
    ! [A: $tType,Option: option(A)] : ( aa(option(A),A,the2(A),Option) = case_option(A,A,undefined(A),aTP_Lamp_bk(A,A),Option) ) ).

% option.the_def
tff(fact_4507_sup__bot_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => semilattice_neutr(A,sup_sup(A),bot_bot(A)) ) ).

% sup_bot.semilattice_neutr_axioms
tff(fact_4508_inf__top_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => semilattice_neutr(A,inf_inf(A),top_top(A)) ) ).

% inf_top.semilattice_neutr_axioms
tff(fact_4509_curr__def,axiom,
    ! [A: $tType,C: $tType,B: $tType,A3: set(A),F2: fun(product_prod(A,B),C),X4: A] :
      ( ( pp(aa(set(A),bool,member(A,X4),A3))
       => ( aa(A,fun(B,C),aa(fun(product_prod(A,B),C),fun(A,fun(B,C)),bNF_Wellorder_curr(A,B,C,A3),F2),X4) = aa(A,fun(B,C),aTP_Lamp_dr(fun(product_prod(A,B),C),fun(A,fun(B,C)),F2),X4) ) )
      & ( ~ pp(aa(set(A),bool,member(A,X4),A3))
       => ( aa(A,fun(B,C),aa(fun(product_prod(A,B),C),fun(A,fun(B,C)),bNF_Wellorder_curr(A,B,C,A3),F2),X4) = undefined(fun(B,C)) ) ) ) ).

% curr_def
tff(fact_4510_natLeq__def,axiom,
    bNF_Ca8665028551170535155natLeq = aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),ord_less_eq(nat))) ).

% natLeq_def
tff(fact_4511_Set_Obind__def,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,set(B))] : ( bind3(A,B,A3,F2) = aa(fun(B,bool),set(B),collect(B),aa(fun(A,set(B)),fun(B,bool),aTP_Lamp_ahl(set(A),fun(fun(A,set(B)),fun(B,bool)),A3),F2)) ) ).

% Set.bind_def
tff(fact_4512_Func__def,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B2: set(B)] : ( bNF_Wellorder_Func(A,B,A3,B2) = aa(fun(fun(A,B),bool),set(fun(A,B)),collect(fun(A,B)),aa(set(B),fun(fun(A,B),bool),aTP_Lamp_ahm(set(A),fun(set(B),fun(fun(A,B),bool)),A3),B2)) ) ).

% Func_def
tff(fact_4513_Restr__natLeq,axiom,
    ! [N: nat] : ( aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),inf_inf(set(product_prod(nat,nat))),bNF_Ca8665028551170535155natLeq),product_Sigma(nat,nat,aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),N)),aTP_Lamp_ahn(nat,fun(nat,set(nat)),N))) = aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_tr(nat,fun(nat,fun(nat,bool)),N))) ) ).

% Restr_natLeq
tff(fact_4514_quotient__of__def,axiom,
    ! [X2: rat] : ( quotient_of(X2) = the(product_prod(int,int),aTP_Lamp_aho(rat,fun(product_prod(int,int),bool),X2)) ) ).

% quotient_of_def
tff(fact_4515_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,M2: int] :
          ( ( ( X2 != zero_zero(A) )
            | ( M2 != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(A,X2,aa(int,int,aa(int,fun(int,int),plus_plus(int),M2),one_one(int))) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),power_int(A,X2,M2)) ) ) ) ).

% power_int_add_1'
tff(fact_4516_power__int__add__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,M2: int] :
          ( ( ( X2 != zero_zero(A) )
            | ( M2 != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(A,X2,aa(int,int,aa(int,fun(int,int),plus_plus(int),M2),one_one(int))) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X2,M2)),X2) ) ) ) ).

% power_int_add_1
tff(fact_4517_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A,N: int] :
          ( ( ( X2 != zero_zero(A) )
            | ( N != zero_zero(int) ) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X2,aa(int,int,aa(int,fun(int,int),minus_minus(int),N),one_one(int)))),X2) = power_int(A,X2,N) ) ) ) ).

% power_int_minus_mult
tff(fact_4518_power__int__1__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [N: int] : ( power_int(A,one_one(A),N) = one_one(A) ) ) ).

% power_int_1_left
tff(fact_4519_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A,W2: num,M2: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(num,A,numeral_numeral(A),W2)),M2) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X2,M2)),power_int(A,aa(num,A,numeral_numeral(A),W2),M2)) ) ) ).

% power_int_mult_distrib_numeral2
tff(fact_4520_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [W2: num,Y: A,M2: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),Y),M2) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(num,A,numeral_numeral(A),W2),M2)),power_int(A,Y,M2)) ) ) ).

% power_int_mult_distrib_numeral1
tff(fact_4521_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( inverse(B)
        & power(B) )
     => ! [X2: B] : ( power_int(B,X2,zero_zero(int)) = one_one(B) ) ) ).

% power_int_0_right
tff(fact_4522_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M2: int] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M2)),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M2)) = one_one(A) ) ) ).

% power_int_minus_one_mult_self
tff(fact_4523_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M2: int,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M2)),aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M2)),B3)) = B3 ) ) ).

% power_int_minus_one_mult_self'
tff(fact_4524_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,M2: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X2,aa(num,int,numeral_numeral(int),M2))),power_int(A,X2,aa(num,int,numeral_numeral(int),N))) = power_int(A,X2,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M2),N))) ) ) ).

% power_int_add_numeral
tff(fact_4525_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,M2: num,N: num,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X2,aa(num,int,numeral_numeral(int),M2))),aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X2,aa(num,int,numeral_numeral(int),N))),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X2,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M2),N)))),B3) ) ) ).

% power_int_add_numeral2
tff(fact_4526_power__int__commutes,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,N: int] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X2,N)),X2) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),power_int(A,X2,N)) ) ) ).

% power_int_commutes
tff(fact_4527_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A,Y: A,M2: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y),M2) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X2,M2)),power_int(A,Y,M2)) ) ) ).

% power_int_mult_distrib
tff(fact_4528_power__int__one__over,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,N: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),X2),N) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),power_int(A,X2,N)) ) ) ).

% power_int_one_over
tff(fact_4529_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M2: int] :
          ( ( ( M2 = zero_zero(int) )
           => ( power_int(A,zero_zero(A),M2) = one_one(A) ) )
          & ( ( M2 != zero_zero(int) )
           => ( power_int(A,zero_zero(A),M2) = zero_zero(A) ) ) ) ) ).

% power_int_0_left_If
tff(fact_4530_power__int__increasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N4: int,A4: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,A4,N)),power_int(A,A4,N4))) ) ) ) ).

% power_int_increasing
tff(fact_4531_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N4: int,A4: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),power_int(A,A4,N)),power_int(A,A4,N4))) ) ) ) ).

% power_int_strict_increasing
tff(fact_4532_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [N: int] : ( power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,uminus_uminus(int),N)) = power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),N) ) ) ).

% power_int_minus_one_minus
tff(fact_4533_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: int,B3: int] : ( power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,aa(int,fun(int,int),minus_minus(int),A4),B3)) = power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,aa(int,fun(int,int),minus_minus(int),B3),A4)) ) ) ).

% power_int_minus_one_diff_commute
tff(fact_4534_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N4: int,A4: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A4),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),power_int(A,A4,N4)),power_int(A,A4,N))) ) ) ) ) ).

% power_int_strict_decreasing
tff(fact_4535_one__le__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X2))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),power_int(A,X2,N))) ) ) ) ).

% one_le_power_int
tff(fact_4536_one__less__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A4: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A4))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),power_int(A,A4,N))) ) ) ) ).

% one_less_power_int
tff(fact_4537_power__int__add,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,M2: int,N: int] :
          ( ( ( X2 != zero_zero(A) )
            | ( aa(int,int,aa(int,fun(int,int),plus_plus(int),M2),N) != zero_zero(int) ) )
         => ( power_int(A,X2,aa(int,int,aa(int,fun(int,int),plus_plus(int),M2),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X2,M2)),power_int(A,X2,N)) ) ) ) ).

% power_int_add
tff(fact_4538_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( division_ring(A)
        & one(B)
        & uminus(B) )
     => ! [X2: C,A4: A,N: int] :
          ( nO_MATCH(B,C,aa(B,B,uminus_uminus(B),one_one(B)),X2)
         => ( power_int(A,aa(A,A,uminus_uminus(A),A4),N) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),N)),power_int(A,A4,N)) ) ) ) ).

% power_int_minus_left_distrib
tff(fact_4539_power__int__le__one,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X2))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,X2,N)),one_one(A))) ) ) ) ) ).

% power_int_le_one
tff(fact_4540_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N4: int,A4: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),one_one(A)))
             => ( ( ( A4 != zero_zero(A) )
                  | ( N4 != zero_zero(int) )
                  | ( N = zero_zero(int) ) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,A4,N4)),power_int(A,A4,N))) ) ) ) ) ) ).

% power_int_decreasing
tff(fact_4541_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,M2: int,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,X2,M2)),power_int(A,X2,N)))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
             => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),M2),N)) ) ) ) ) ).

% power_int_le_imp_le_exp
tff(fact_4542_Fract_Otransfer,axiom,
    pp(aa(fun(int,fun(int,rat)),bool,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,rat)),bool),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,rat),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),rat,fequal(int),pcr_rat)),aTP_Lamp_acg(int,fun(int,product_prod(int,int)))),fract)) ).

% Fract.transfer
tff(fact_4543_Fract__def,axiom,
    fract = aa(fun(int,fun(int,product_prod(int,int))),fun(int,fun(int,rat)),map_fun(int,int,fun(int,product_prod(int,int)),fun(int,rat),id(int),map_fun(int,int,product_prod(int,int),rat,id(int),abs_Rat)),aTP_Lamp_acg(int,fun(int,product_prod(int,int)))) ).

% Fract_def
tff(fact_4544_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,M2: int,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),power_int(A,X2,M2)),power_int(A,X2,N)))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
             => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),M2),N)) ) ) ) ) ).

% power_int_le_imp_less_exp
tff(fact_4545_fun_Opred__set,axiom,
    ! [D: $tType,A: $tType,P: fun(A,bool),X4: fun(D,A)] :
      ( pp(aa(fun(D,A),bool,aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),P),X4))
    <=> ! [Xa2: A] :
          ( pp(aa(set(A),bool,member(A,Xa2),aa(set(D),set(A),image2(D,A,X4),top_top(set(D)))))
         => pp(aa(A,bool,P,Xa2)) ) ) ).

% fun.pred_set
tff(fact_4546_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => folding_insort_key(A,A,ord_less_eq(A),ord_less(A),top_top(set(A)),aTP_Lamp_eh(A,A)) ) ).

% sorted_list_of_set.folding_insort_key_axioms
tff(fact_4547_mset__set__Union,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(A),bool,finite_finite2(A),B2))
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) )
         => ( mset_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B2)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),mset_set(A,A3)),mset_set(A,B2)) ) ) ) ) ).

% mset_set_Union
tff(fact_4548_MOST__const,axiom,
    ! [A: $tType,P: bool] :
      ( eventually(A,aTP_Lamp_an(bool,fun(A,bool),P),cofinite(A))
    <=> ( pp(P)
        | pp(aa(set(A),bool,finite_finite2(A),top_top(set(A)))) ) ) ).

% MOST_const
tff(fact_4549_mset__set_Oempty,axiom,
    ! [A: $tType] : ( mset_set(A,bot_bot(set(A))) = zero_zero(multiset(A)) ) ).

% mset_set.empty
tff(fact_4550_cofinite__bot,axiom,
    ! [A: $tType] :
      ( ( cofinite(A) = bot_bot(filter(A)) )
    <=> pp(aa(set(A),bool,finite_finite2(A),top_top(set(A)))) ) ).

% cofinite_bot
tff(fact_4551_MOST__eq_I2_J,axiom,
    ! [A: $tType,A4: A] :
      ( eventually(A,aa(A,fun(A,bool),fequal(A),A4),cofinite(A))
    <=> pp(aa(set(A),bool,finite_finite2(A),top_top(set(A)))) ) ).

% MOST_eq(2)
tff(fact_4552_MOST__eq_I1_J,axiom,
    ! [A: $tType,A4: A] :
      ( eventually(A,aTP_Lamp_ct(A,fun(A,bool),A4),cofinite(A))
    <=> pp(aa(set(A),bool,finite_finite2(A),top_top(set(A)))) ) ).

% MOST_eq(1)
tff(fact_4553_fun_Opred__True,axiom,
    ! [A: $tType,D: $tType,X4: fun(D,A)] : pp(aa(fun(D,A),bool,aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),aTP_Lamp_nn(A,bool)),X4)) ).

% fun.pred_True
tff(fact_4554_MOST__neq_I2_J,axiom,
    ! [A: $tType,A4: A] : eventually(A,aa(A,fun(A,bool),aTP_Lamp_adp(A,fun(A,bool)),A4),cofinite(A)) ).

% MOST_neq(2)
tff(fact_4555_MOST__neq_I1_J,axiom,
    ! [A: $tType,A4: A] : eventually(A,aa(A,fun(A,bool),aTP_Lamp_rz(A,fun(A,bool)),A4),cofinite(A)) ).

% MOST_neq(1)
tff(fact_4556_MOST__eq__imp_I2_J,axiom,
    ! [A: $tType,A4: A,P: fun(A,bool)] : eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_ahq(A,fun(fun(A,bool),fun(A,bool)),A4),P),cofinite(A)) ).

% MOST_eq_imp(2)
tff(fact_4557_MOST__eq__imp_I1_J,axiom,
    ! [A: $tType,A4: A,P: fun(A,bool)] : eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_ahr(A,fun(fun(A,bool),fun(A,bool)),A4),P),cofinite(A)) ).

% MOST_eq_imp(1)
tff(fact_4558_MOST__I,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ! [X: A] : pp(aa(A,bool,P,X))
     => eventually(A,P,cofinite(A)) ) ).

% MOST_I
tff(fact_4559_ALL__MOST,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ! [X_1: A] : pp(aa(A,bool,P,X_1))
     => eventually(A,P,cofinite(A)) ) ).

% ALL_MOST
tff(fact_4560_MOST__mono,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( eventually(A,P,cofinite(A))
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
           => pp(aa(A,bool,Q,X)) )
       => eventually(A,Q,cofinite(A)) ) ) ).

% MOST_mono
tff(fact_4561_MOST__conjI,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( eventually(A,P,cofinite(A))
     => ( eventually(A,Q,cofinite(A))
       => eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),cofinite(A)) ) ) ).

% MOST_conjI
tff(fact_4562_MOST__rev__mp,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( eventually(A,P,cofinite(A))
     => ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aw(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),cofinite(A))
       => eventually(A,Q,cofinite(A)) ) ) ).

% MOST_rev_mp
tff(fact_4563_MOST__imp__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( eventually(A,P,cofinite(A))
     => ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aw(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),cofinite(A))
      <=> eventually(A,Q,cofinite(A)) ) ) ).

% MOST_imp_iff
tff(fact_4564_MOST__conj__distrib,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),cofinite(A))
    <=> ( eventually(A,P,cofinite(A))
        & eventually(A,Q,cofinite(A)) ) ) ).

% MOST_conj_distrib
tff(fact_4565_pred__fun__def,axiom,
    ! [B: $tType,A: $tType,A3: fun(A,bool),B2: fun(B,bool),X4: fun(A,B)] :
      ( pp(aa(fun(A,B),bool,aa(fun(B,bool),fun(fun(A,B),bool),basic_pred_fun(A,B,A3),B2),X4))
    <=> ! [Xa2: A] :
          ( pp(aa(A,bool,A3,Xa2))
         => pp(aa(B,bool,B2,aa(A,B,X4,Xa2))) ) ) ).

% pred_fun_def
tff(fact_4566_fun_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,D: $tType,X2: fun(D,A),Ya2: fun(D,A),F2: fun(A,B),G: fun(A,B)] :
      ( ( X2 = Ya2 )
     => ( pp(aa(fun(D,A),bool,aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),aa(fun(A,B),fun(A,bool),aTP_Lamp_nv(fun(A,B),fun(fun(A,B),fun(A,bool)),F2),G)),Ya2))
       => ( aa(fun(D,A),fun(D,B),comp(A,B,D,F2),X2) = aa(fun(D,A),fun(D,B),comp(A,B,D,G),Ya2) ) ) ) ).

% fun.map_cong_pred
tff(fact_4567_fun_Opred__mono,axiom,
    ! [D: $tType,A: $tType,P: fun(A,bool),Pa: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),P),Pa))
     => pp(aa(fun(fun(D,A),bool),bool,aa(fun(fun(D,A),bool),fun(fun(fun(D,A),bool),bool),ord_less_eq(fun(fun(D,A),bool)),aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),P)),aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),Pa))) ) ).

% fun.pred_mono
tff(fact_4568_pred__fun__True__id,axiom,
    ! [A: $tType,B: $tType,C: $tType,P5: fun(B,bool),F2: fun(C,B)] :
      ( nO_MATCH(fun(A,A),fun(B,bool),id(A),P5)
     => ( pp(aa(fun(C,B),bool,aa(fun(B,bool),fun(fun(C,B),bool),basic_pred_fun(C,B,aTP_Lamp_ahs(C,bool)),P5),F2))
      <=> pp(aa(fun(C,bool),bool,aa(fun(bool,bool),fun(fun(C,bool),bool),basic_pred_fun(C,bool,aTP_Lamp_ahs(C,bool)),id(bool)),aa(fun(C,B),fun(C,bool),comp(B,bool,C,P5),F2))) ) ) ).

% pred_fun_True_id
tff(fact_4569_MOST__iff__finiteNeg,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( eventually(A,P,cofinite(A))
    <=> pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_as(fun(A,bool),fun(A,bool),P)))) ) ).

% MOST_iff_finiteNeg
tff(fact_4570_eventually__cofinite,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( eventually(A,P,cofinite(A))
    <=> pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_as(fun(A,bool),fun(A,bool),P)))) ) ).

% eventually_cofinite
tff(fact_4571_MOST__SucD,axiom,
    ! [P: fun(nat,bool)] :
      ( eventually(nat,aTP_Lamp_xf(fun(nat,bool),fun(nat,bool),P),cofinite(nat))
     => eventually(nat,P,cofinite(nat)) ) ).

% MOST_SucD
tff(fact_4572_MOST__SucI,axiom,
    ! [P: fun(nat,bool)] :
      ( eventually(nat,P,cofinite(nat))
     => eventually(nat,aTP_Lamp_xf(fun(nat,bool),fun(nat,bool),P),cofinite(nat)) ) ).

% MOST_SucI
tff(fact_4573_MOST__Suc__iff,axiom,
    ! [P: fun(nat,bool)] :
      ( eventually(nat,aTP_Lamp_xf(fun(nat,bool),fun(nat,bool),P),cofinite(nat))
    <=> eventually(nat,P,cofinite(nat)) ) ).

% MOST_Suc_iff
tff(fact_4574_MOST__nat,axiom,
    ! [P: fun(nat,bool)] :
      ( eventually(nat,P,cofinite(nat))
    <=> ? [M5: nat] :
        ! [N5: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M5),N5))
         => pp(aa(nat,bool,P,N5)) ) ) ).

% MOST_nat
tff(fact_4575_MOST__ge__nat,axiom,
    ! [M2: nat] : eventually(nat,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),cofinite(nat)) ).

% MOST_ge_nat
tff(fact_4576_MOST__nat__le,axiom,
    ! [P: fun(nat,bool)] :
      ( eventually(nat,P,cofinite(nat))
    <=> ? [M5: nat] :
        ! [N5: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M5),N5))
         => pp(aa(nat,bool,P,N5)) ) ) ).

% MOST_nat_le
tff(fact_4577_fun_Opred__cong,axiom,
    ! [A: $tType,D: $tType,X2: fun(D,A),Ya2: fun(D,A),P: fun(A,bool),Pa: fun(A,bool)] :
      ( ( X2 = Ya2 )
     => ( ! [Z3: A] :
            ( pp(aa(set(A),bool,member(A,Z3),aa(set(D),set(A),image2(D,A,Ya2),top_top(set(D)))))
           => ( pp(aa(A,bool,P,Z3))
            <=> pp(aa(A,bool,Pa,Z3)) ) )
       => ( pp(aa(fun(D,A),bool,aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),P),X2))
        <=> pp(aa(fun(D,A),bool,aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),Pa),Ya2)) ) ) ) ).

% fun.pred_cong
tff(fact_4578_fun_Opred__mono__strong,axiom,
    ! [A: $tType,D: $tType,P: fun(A,bool),X2: fun(D,A),Pa: fun(A,bool)] :
      ( pp(aa(fun(D,A),bool,aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),P),X2))
     => ( ! [Z3: A] :
            ( pp(aa(set(A),bool,member(A,Z3),aa(set(D),set(A),image2(D,A,X2),top_top(set(D)))))
           => ( pp(aa(A,bool,P,Z3))
             => pp(aa(A,bool,Pa,Z3)) ) )
       => pp(aa(fun(D,A),bool,aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),Pa),X2)) ) ) ).

% fun.pred_mono_strong
tff(fact_4579_cofinite__def,axiom,
    ! [A: $tType] : ( cofinite(A) = aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),aTP_Lamp_aht(fun(A,bool),bool)) ) ).

% cofinite_def
tff(fact_4580_fun_Opred__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,R: fun(A,fun(B,bool))] : pp(aa(fun(fun(B,bool),fun(fun(D,B),bool)),bool,aa(fun(fun(A,bool),fun(fun(D,A),bool)),fun(fun(fun(B,bool),fun(fun(D,B),bool)),bool),bNF_rel_fun(fun(A,bool),fun(B,bool),fun(fun(D,A),bool),fun(fun(D,B),bool),bNF_rel_fun(A,B,bool,bool,R,fequal(bool)),bNF_rel_fun(fun(D,A),fun(D,B),bool,bool,bNF_rel_fun(D,D,A,B,fequal(D),R),fequal(bool))),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool))),basic_pred_fun(D,B,aTP_Lamp_ahp(D,bool)))) ).

% fun.pred_transfer
tff(fact_4581_mset__set__empty__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( mset_set(A,A3) = zero_zero(multiset(A)) )
    <=> ( ( A3 = bot_bot(set(A)) )
        | ~ pp(aa(set(A),bool,finite_finite2(A),A3)) ) ) ).

% mset_set_empty_iff
tff(fact_4582_fun_Opred__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,Q: fun(B,bool),F2: fun(A,B),X2: fun(D,A)] :
      ( pp(aa(fun(D,B),bool,aa(fun(B,bool),fun(fun(D,B),bool),basic_pred_fun(D,B,aTP_Lamp_ahp(D,bool)),Q),aa(fun(D,A),fun(D,B),comp(A,B,D,F2),X2)))
    <=> pp(aa(fun(D,A),bool,aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),aa(fun(A,B),fun(A,bool),comp(B,bool,A,Q),F2)),X2)) ) ).

% fun.pred_map
tff(fact_4583_MOST__finite__Ball__distrib,axiom,
    ! [A: $tType,B: $tType,A3: set(A),P: fun(A,fun(B,bool))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( eventually(B,aa(fun(A,fun(B,bool)),fun(B,bool),aTP_Lamp_ahu(set(A),fun(fun(A,fun(B,bool)),fun(B,bool)),A3),P),cofinite(B))
      <=> ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),A3))
           => eventually(B,aa(A,fun(B,bool),P,X3),cofinite(B)) ) ) ) ).

% MOST_finite_Ball_distrib
tff(fact_4584_MOST__inj,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F2: fun(B,A)] :
      ( eventually(A,P,cofinite(A))
     => ( inj_on(B,A,F2,top_top(set(B)))
       => eventually(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_ns(fun(A,bool),fun(fun(B,A),fun(B,bool)),P),F2),cofinite(B)) ) ) ).

% MOST_inj
tff(fact_4585_mset__set_Oinsert__remove,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( mset_set(A,aa(set(A),set(A),insert(A,X2),A3)) = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X2),mset_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ).

% mset_set.insert_remove
tff(fact_4586_mset__set_Oremove,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(set(A),bool,member(A,X2),A3))
       => ( mset_set(A,A3) = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X2),mset_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ).

% mset_set.remove
tff(fact_4587_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S: set(B),F2: fun(B,A),X2: B,A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,X2),A3)),S))
       => ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( sorted8670434370408473282of_set(A,B,Less_eq,F2,aa(set(B),set(B),insert(B,X2),A3)) = insort_key(A,B,Less_eq,F2,X2,sorted8670434370408473282of_set(A,B,Less_eq,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
tff(fact_4588_cr__integer__def,axiom,
    ! [X4: int,Xa3: code_integer] :
      ( code_cr_integer(X4,Xa3)
    <=> ( X4 = aa(code_integer,int,code_int_of_integer,Xa3) ) ) ).

% cr_integer_def
tff(fact_4589_sum__multiset__singleton,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),multiset(A),aa(fun(A,multiset(A)),fun(set(A),multiset(A)),groups7311177749621191930dd_sum(A,multiset(A)),aTP_Lamp_ahv(A,multiset(A))),A3) = mset_set(A,A3) ) ).

% sum_multiset_singleton
tff(fact_4590_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S: set(B),F2: fun(B,A),X2: B,A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,X2),A3)),S))
       => ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( sorted8670434370408473282of_set(A,B,Less_eq,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))) = remove1(B,X2,sorted8670434370408473282of_set(A,B,Less_eq,F2,A3)) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
tff(fact_4591_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S: set(B),F2: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S,F2)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A3),S))
       => ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( ( sorted8670434370408473282of_set(A,B,Less_eq,F2,A3) = nil(B) )
          <=> ( A3 = bot_bot(set(B)) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
tff(fact_4592_at__most__one__mset__mset__diff,axiom,
    ! [A: $tType,A4: A,M: multiset(A)] :
      ( ~ pp(aa(set(A),bool,member(A,A4),aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),M),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A4),zero_zero(multiset(A)))))))
     => ( aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),M),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A4),zero_zero(multiset(A))))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(multiset(A),set(A),set_mset(A),M)),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) ) ) ).

% at_most_one_mset_mset_diff
tff(fact_4593_set__mset__empty,axiom,
    ! [A: $tType] : ( aa(multiset(A),set(A),set_mset(A),zero_zero(multiset(A))) = bot_bot(set(A)) ) ).

% set_mset_empty
tff(fact_4594_set__mset__eq__empty__iff,axiom,
    ! [A: $tType,M: multiset(A)] :
      ( ( aa(multiset(A),set(A),set_mset(A),M) = bot_bot(set(A)) )
    <=> ( M = zero_zero(multiset(A)) ) ) ).

% set_mset_eq_empty_iff
tff(fact_4595_in__Inf__multiset__iff,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: A] :
      ( ( A3 != bot_bot(set(multiset(A))) )
     => ( pp(aa(set(A),bool,member(A,X2),aa(multiset(A),set(A),set_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A3))))
      <=> ! [X3: multiset(A)] :
            ( pp(aa(set(multiset(A)),bool,member(multiset(A),X3),A3))
           => pp(aa(set(A),bool,member(A,X2),aa(multiset(A),set(A),set_mset(A),X3))) ) ) ) ).

% in_Inf_multiset_iff
tff(fact_4596_infinite__set__mset__mset__set,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( aa(multiset(A),set(A),set_mset(A),mset_set(A,A3)) = bot_bot(set(A)) ) ) ).

% infinite_set_mset_mset_set
tff(fact_4597_set__mset__Inf,axiom,
    ! [A: $tType,A3: set(multiset(A))] :
      ( ( A3 != bot_bot(set(multiset(A))) )
     => ( aa(multiset(A),set(A),set_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A3)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(multiset(A)),set(set(A)),image2(multiset(A),set(A),set_mset(A)),A3)) ) ) ).

% set_mset_Inf
tff(fact_4598_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S: set(B),F2: fun(B,A)] :
      ( folding_insort_key(A,B,Less_eq,Less,S,F2)
     => ( sorted8670434370408473282of_set(A,B,Less_eq,F2,bot_bot(set(B))) = nil(B) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
tff(fact_4599_set__mset__single,axiom,
    ! [A: $tType,B3: A] : ( aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),B3),zero_zero(multiset(A)))) = aa(set(A),set(A),insert(A,B3),bot_bot(set(A))) ) ).

% set_mset_single
tff(fact_4600_mult1__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( mult1(A,R2) = aa(fun(product_prod(multiset(A),multiset(A)),bool),set(product_prod(multiset(A),multiset(A))),collect(product_prod(multiset(A),multiset(A))),aa(fun(multiset(A),fun(multiset(A),bool)),fun(product_prod(multiset(A),multiset(A)),bool),product_case_prod(multiset(A),multiset(A),bool),aTP_Lamp_ahw(set(product_prod(A,A)),fun(multiset(A),fun(multiset(A),bool)),R2))) ) ).

% mult1_def
tff(fact_4601_sum__wcount__Int,axiom,
    ! [A: $tType,A3: set(A),F2: fun(A,nat),N4: multiset(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),wcount(A,F2,N4)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(multiset(A),set(A),set_mset(A),N4))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),wcount(A,F2,N4)),A3) ) ) ).

% sum_wcount_Int
tff(fact_4602_set__mset__replicate__mset__subset,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( ( N = zero_zero(nat) )
       => ( aa(multiset(A),set(A),set_mset(A),replicate_mset(A,N,X2)) = bot_bot(set(A)) ) )
      & ( ( N != zero_zero(nat) )
       => ( aa(multiset(A),set(A),set_mset(A),replicate_mset(A,N,X2)) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ) ) ).

% set_mset_replicate_mset_subset
tff(fact_4603_mult1__lessE,axiom,
    ! [A: $tType,N4: multiset(A),M: multiset(A),R2: fun(A,fun(A,bool))] :
      ( pp(aa(set(product_prod(multiset(A),multiset(A))),bool,member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),N4),M)),mult1(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2)))))
     => ( asymp(A,R2)
       => ~ ! [A5: A,M0: multiset(A)] :
              ( ( M = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A5),M0) )
             => ! [K7: multiset(A)] :
                  ( ( N4 = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),M0),K7) )
                 => ( ~ pp(aa(set(A),bool,member(A,A5),aa(multiset(A),set(A),set_mset(A),K7)))
                   => ~ ! [B10: A] :
                          ( pp(aa(set(A),bool,member(A,B10),aa(multiset(A),set(A),set_mset(A),K7)))
                         => pp(aa(A,bool,aa(A,fun(A,bool),R2,B10),A5)) ) ) ) ) ) ) ).

% mult1_lessE
tff(fact_4604_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))) = remove1(A,X2,aa(set(A),list(A),linord4507533701916653071of_set(A),A3)) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
tff(fact_4605_Pow__set_I1_J,axiom,
    ! [A: $tType] : ( pow(A,aa(list(A),set(A),set2(A),nil(A))) = aa(set(set(A)),set(set(A)),insert(set(A),bot_bot(set(A))),bot_bot(set(set(A)))) ) ).

% Pow_set(1)
tff(fact_4606_set__empty,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),set(A),set2(A),Xs) = bot_bot(set(A)) )
    <=> ( Xs = nil(A) ) ) ).

% set_empty
tff(fact_4607_set__empty2,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( bot_bot(set(A)) = aa(list(A),set(A),set2(A),Xs) )
    <=> ( Xs = nil(A) ) ) ).

% set_empty2
tff(fact_4608_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( aa(set(A),list(A),linord4507533701916653071of_set(A),bot_bot(set(A))) = nil(A) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
tff(fact_4609_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( aa(set(A),list(A),linord4507533701916653071of_set(A),A3) = nil(A) )
          <=> ( A3 = bot_bot(set(A)) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
tff(fact_4610_empty__set,axiom,
    ! [A: $tType] : ( bot_bot(set(A)) = aa(list(A),set(A),set2(A),nil(A)) ) ).

% empty_set
tff(fact_4611_asymp__greater,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => asymp(A,aTP_Lamp_aad(A,fun(A,bool))) ) ).

% asymp_greater
tff(fact_4612_card__lists__length__le,axiom,
    ! [A: $tType,A3: set(A),N: nat] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( aa(set(list(A)),nat,finite_card(list(A)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(nat,fun(list(A),bool),aTP_Lamp_ahx(set(A),fun(nat,fun(list(A),bool)),A3),N))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(set(A),nat,finite_card(A),A3))),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% card_lists_length_le
tff(fact_4613_set__removeAll,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),removeAll(A,X2),Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) ) ).

% set_removeAll
tff(fact_4614_set__list__bind,axiom,
    ! [A: $tType,B: $tType,Xs: list(B),F2: fun(B,list(A))] : ( aa(list(A),set(A),set2(A),bind(B,A,Xs,F2)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_ahy(fun(B,list(A)),fun(B,set(A)),F2)),aa(list(B),set(B),set2(B),Xs))) ) ).

% set_list_bind
tff(fact_4615_finite__lists__length__eq,axiom,
    ! [A: $tType,A3: set(A),N: nat] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => pp(aa(set(list(A)),bool,finite_finite2(list(A)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(nat,fun(list(A),bool),aTP_Lamp_ahz(set(A),fun(nat,fun(list(A),bool)),A3),N)))) ) ).

% finite_lists_length_eq
tff(fact_4616_finite__lists__length__le,axiom,
    ! [A: $tType,A3: set(A),N: nat] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => pp(aa(set(list(A)),bool,finite_finite2(list(A)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(nat,fun(list(A),bool),aTP_Lamp_ahx(set(A),fun(nat,fun(list(A),bool)),A3),N)))) ) ).

% finite_lists_length_le
tff(fact_4617_card__lists__length__eq,axiom,
    ! [A: $tType,A3: set(A),N: nat] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( aa(set(list(A)),nat,finite_card(list(A)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(nat,fun(list(A),bool),aTP_Lamp_ahz(set(A),fun(nat,fun(list(A),bool)),A3),N))) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(set(A),nat,finite_card(A),A3)),N) ) ) ).

% card_lists_length_eq
tff(fact_4618_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),aa(set(A),nat,finite_card(A),A3)))
       => ( aa(set(list(A)),nat,finite_card(list(A)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(nat,fun(list(A),bool),aTP_Lamp_aia(set(A),fun(nat,fun(list(A),bool)),A3),K))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_vy(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),K)),one_one(nat)),aa(set(A),nat,finite_card(A),A3))) ) ) ) ).

% card_lists_distinct_length_eq
tff(fact_4619_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A3: set(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(set(A),nat,finite_card(A),A3)))
     => ( aa(set(list(A)),nat,finite_card(list(A)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(set(A),fun(list(A),bool),aTP_Lamp_aib(nat,fun(set(A),fun(list(A),bool)),K),A3))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_vy(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),K)),one_one(nat)),aa(set(A),nat,finite_card(A),A3))) ) ) ).

% card_lists_distinct_length_eq'
tff(fact_4620_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( aa(set(list(A)),nat,finite_card(list(A)),shuffles(A,Xs,Ys)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys))),aa(list(A),nat,size_size(list(A)),Xs)) ) ) ).

% card_disjoint_shuffles
tff(fact_4621_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( distinct(A,Xs)
     => ( aa(list(A),set(A),set2(A),remove1(A,X2,Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) ) ) ).

% set_remove1_eq
tff(fact_4622_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set(A),N: nat] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => pp(aa(set(list(A)),bool,finite_finite2(list(A)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(nat,fun(list(A),bool),aTP_Lamp_aia(set(A),fun(nat,fun(list(A),bool)),A3),N)))) ) ).

% finite_lists_distinct_length_eq
tff(fact_4623_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list(A)] : ( shuffles(A,Xs,nil(A)) = aa(set(list(A)),set(list(A)),insert(list(A),Xs),bot_bot(set(list(A)))) ) ).

% shuffles.simps(2)
tff(fact_4624_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list(A)] : ( shuffles(A,nil(A),Ys) = aa(set(list(A)),set(list(A)),insert(list(A),Ys),bot_bot(set(list(A)))) ) ).

% shuffles.simps(1)
tff(fact_4625_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( distinct(A,Xs)
     => ( distinct(A,Ys)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
         => ( pp(aa(set(list(A)),bool,member(list(A),Zs),shuffles(A,Xs,Ys)))
           => distinct(A,Zs) ) ) ) ) ).

% distinct_disjoint_shuffles
tff(fact_4626_distinct__finite__set,axiom,
    ! [A: $tType,X2: set(A)] : pp(aa(set(list(A)),bool,finite_finite2(list(A)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aTP_Lamp_aic(set(A),fun(list(A),bool),X2)))) ).

% distinct_finite_set
tff(fact_4627_distinct__finite__subset,axiom,
    ! [A: $tType,X2: set(A)] :
      ( pp(aa(set(A),bool,finite_finite2(A),X2))
     => pp(aa(set(list(A)),bool,finite_finite2(list(A)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aTP_Lamp_aid(set(A),fun(list(A),bool),X2)))) ) ).

% distinct_finite_subset
tff(fact_4628_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),X2),aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
tff(fact_4629_set__map__filter,axiom,
    ! [A: $tType,B: $tType,G: fun(B,option(A)),Xs: list(B)] : ( aa(list(A),set(A),set2(A),map_filter(B,A,G,Xs)) = aa(fun(A,bool),set(A),collect(A),aa(list(B),fun(A,bool),aTP_Lamp_aie(fun(B,option(A)),fun(list(B),fun(A,bool)),G),Xs)) ) ).

% set_map_filter
tff(fact_4630_distinct__foldl__invar,axiom,
    ! [B: $tType,A: $tType,S: list(A),I: fun(set(A),fun(B,bool)),Sigma_0: B,F2: fun(B,fun(A,B))] :
      ( distinct(A,S)
     => ( pp(aa(B,bool,aa(set(A),fun(B,bool),I,aa(list(A),set(A),set2(A),S)),Sigma_0))
       => ( ! [X: A,It: set(A),Sigma: B] :
              ( pp(aa(set(A),bool,member(A,X),It))
             => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),It),aa(list(A),set(A),set2(A),S)))
               => ( pp(aa(B,bool,aa(set(A),fun(B,bool),I,It),Sigma))
                 => pp(aa(B,bool,aa(set(A),fun(B,bool),I,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),It),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))),aa(A,B,aa(B,fun(A,B),F2,Sigma),X))) ) ) )
         => pp(aa(B,bool,aa(set(A),fun(B,bool),I,bot_bot(set(A))),foldl(B,A,F2,Sigma_0,S))) ) ) ) ).

% distinct_foldl_invar
tff(fact_4631_foldl__length,axiom,
    ! [A: $tType,L: list(A)] : ( foldl(nat,A,aTP_Lamp_aif(nat,fun(A,nat)),zero_zero(nat),L) = aa(list(A),nat,size_size(list(A)),L) ) ).

% foldl_length
tff(fact_4632_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ~ pp(aa(set(A),bool,member(A,X2),A3))
           => ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),X2),aa(set(A),list(A),linord4507533701916653071of_set(A),A3)) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
tff(fact_4633_insort__left__comm,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y: A,Xs: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),Y),Xs)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),Y),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),X2),Xs)) ) ) ).

% insort_left_comm
tff(fact_4634_comp__fun__commute__insort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => finite6289374366891150609ommute(A,list(A),linorder_insort_key(A,A,aTP_Lamp_eh(A,A))) ) ).

% comp_fun_commute_insort
tff(fact_4635_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y: A,X2: A] : ( aa(fun(list(A),list(A)),fun(list(A),list(A)),comp(list(A),list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),Y)),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),X2)) = aa(fun(list(A),list(A)),fun(list(A),list(A)),comp(list(A),list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),X2)),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),Y)) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
tff(fact_4636_sorted__list__of__set_Ofold__insort__key_Ofolding__on__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => finite_folding_on(A,list(A),top_top(set(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A))) ) ).

% sorted_list_of_set.fold_insort_key.folding_on_axioms
tff(fact_4637_comp__fun__commute_Ofoldl__f__commute,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(B,B)),A4: A,B3: B,Xs: list(A)] :
      ( finite6289374366891150609ommute(A,B,F2)
     => ( aa(B,B,aa(A,fun(B,B),F2,A4),foldl(B,A,aTP_Lamp_aig(fun(A,fun(B,B)),fun(B,fun(A,B)),F2),B3,Xs)) = foldl(B,A,aTP_Lamp_aig(fun(A,fun(B,B)),fun(B,fun(A,B)),F2),aa(B,B,aa(A,fun(B,B),F2,A4),B3),Xs) ) ) ).

% comp_fun_commute.foldl_f_commute
tff(fact_4638_fst__foldl,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(A,fun(C,A)),G: fun(A,fun(B,fun(C,B))),A4: A,B3: B,Xs: list(C)] : ( aa(product_prod(A,B),A,product_fst(A,B),foldl(product_prod(A,B),C,aa(fun(A,fun(B,fun(C,product_prod(A,B)))),fun(product_prod(A,B),fun(C,product_prod(A,B))),product_case_prod(A,B,fun(C,product_prod(A,B))),aa(fun(A,fun(B,fun(C,B))),fun(A,fun(B,fun(C,product_prod(A,B)))),aTP_Lamp_aih(fun(A,fun(C,A)),fun(fun(A,fun(B,fun(C,B))),fun(A,fun(B,fun(C,product_prod(A,B))))),F2),G)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3),Xs)) = foldl(A,C,F2,A4,Xs) ) ).

% fst_foldl
tff(fact_4639_foldl__absorb1,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X2: A,Zs: list(A)] : ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),foldl(A,A,times_times(A),one_one(A),Zs)) = foldl(A,A,times_times(A),X2,Zs) ) ) ).

% foldl_absorb1
tff(fact_4640_foldl__un__empty__eq,axiom,
    ! [A: $tType,I2: set(A),Ww: list(set(A))] : ( foldl(set(A),set(A),sup_sup(set(A)),I2,Ww) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),I2),foldl(set(A),set(A),sup_sup(set(A)),bot_bot(set(A)),Ww)) ) ).

% foldl_un_empty_eq
tff(fact_4641_sorted__list__of__set_Ofold__insort__key_Oeq__fold,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : ( aa(set(A),list(A),linord4507533701916653071of_set(A),A3) = finite_fold(A,list(A),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),nil(A),A3) ) ) ).

% sorted_list_of_set.fold_insort_key.eq_fold
tff(fact_4642_foldl__set,axiom,
    ! [A: $tType,L: list(set(A))] : ( foldl(set(A),set(A),sup_sup(set(A)),bot_bot(set(A)),L) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_aii(list(set(A)),fun(set(A),bool),L))) ) ).

% foldl_set
tff(fact_4643_foldl__length__aux,axiom,
    ! [A: $tType,A4: nat,L: list(A)] : ( foldl(nat,A,aTP_Lamp_aif(nat,fun(A,nat)),A4,L) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),aa(list(A),nat,size_size(list(A)),L)) ) ).

% foldl_length_aux
tff(fact_4644_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( pp(aa(set(A),bool,member(A,X2),A3))
           => ( aa(set(A),list(A),linord4507533701916653071of_set(A),A3) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),X2),aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
tff(fact_4645_listset_Osimps_I1_J,axiom,
    ! [A: $tType] : ( listset(A,nil(set(A))) = aa(set(list(A)),set(list(A)),insert(list(A),nil(A)),bot_bot(set(list(A)))) ) ).

% listset.simps(1)
tff(fact_4646_sorted__list__of__multiset__insert,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,M: multiset(A)] : ( linord6283353356039996273ltiset(A,aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X2),M)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),X2),linord6283353356039996273ltiset(A,M)) ) ) ).

% sorted_list_of_multiset_insert
tff(fact_4647_set__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(list(A)),set(list(A)),set2(list(A)),n_lists(A,N,Xs)) = aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(list(A),fun(list(A),bool),aTP_Lamp_aij(nat,fun(list(A),fun(list(A),bool)),N),Xs)) ) ).

% set_n_lists
tff(fact_4648_distinct__n__lists,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( distinct(A,Xs)
     => distinct(list(A),n_lists(A,N,Xs)) ) ).

% distinct_n_lists
tff(fact_4649_length__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(list(A)),nat,size_size(list(list(A))),n_lists(A,N,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(list(A),nat,size_size(list(A)),Xs)),N) ) ).

% length_n_lists
tff(fact_4650_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( linord4507533701916653071of_set(A) = linord144544945434240204of_set(A,A,aTP_Lamp_eh(A,A)) ) ) ).

% sorted_list_of_set_def
tff(fact_4651_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( distinct(A,concat(A,Xs))
    <=> ( distinct(list(A),aa(list(list(A)),list(list(A)),removeAll(list(A),nil(A)),Xs))
        & ! [Ys2: list(A)] :
            ( pp(aa(set(list(A)),bool,member(list(A),Ys2),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
           => distinct(A,Ys2) )
        & ! [Ys2: list(A),Zs2: list(A)] :
            ( ( pp(aa(set(list(A)),bool,member(list(A),Ys2),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
              & pp(aa(set(list(A)),bool,member(list(A),Zs2),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
              & ( Ys2 != Zs2 ) )
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Ys2)),aa(list(A),set(A),set2(A),Zs2)) = bot_bot(set(A)) ) ) ) ) ).

% distinct_concat_iff
tff(fact_4652_set__product,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] : ( aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),product(A,B,Xs,Ys)) = product_Sigma(A,B,aa(list(A),set(A),set2(A),Xs),aTP_Lamp_aik(list(B),fun(A,set(B)),Ys)) ) ).

% set_product
tff(fact_4653_set__concat,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(A),set(A),set2(A),concat(A,Xs)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(list(A)),set(set(A)),image2(list(A),set(A),set2(A)),aa(list(list(A)),set(list(A)),set2(list(A)),Xs))) ) ).

% set_concat
tff(fact_4654_distinct__concat,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( distinct(list(A),Xs)
     => ( ! [Ys3: list(A)] :
            ( pp(aa(set(list(A)),bool,member(list(A),Ys3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
           => distinct(A,Ys3) )
       => ( ! [Ys3: list(A),Zs3: list(A)] :
              ( pp(aa(set(list(A)),bool,member(list(A),Ys3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
             => ( pp(aa(set(list(A)),bool,member(list(A),Zs3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
               => ( ( Ys3 != Zs3 )
                 => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Ys3)),aa(list(A),set(A),set2(A),Zs3)) = bot_bot(set(A)) ) ) ) )
         => distinct(A,concat(A,Xs)) ) ) ) ).

% distinct_concat
tff(fact_4655_distinct__concat_H,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( distinct(list(A),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_ail(list(A),bool)),Xs))
     => ( ! [Ys3: list(A)] :
            ( pp(aa(set(list(A)),bool,member(list(A),Ys3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
           => distinct(A,Ys3) )
       => ( ! [Ys3: list(A),Zs3: list(A)] :
              ( pp(aa(set(list(A)),bool,member(list(A),Ys3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
             => ( pp(aa(set(list(A)),bool,member(list(A),Zs3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
               => ( ( Ys3 != Zs3 )
                 => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Ys3)),aa(list(A),set(A),set2(A),Zs3)) = bot_bot(set(A)) ) ) ) )
         => distinct(A,concat(A,Xs)) ) ) ) ).

% distinct_concat'
tff(fact_4656_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),remdups(A),concat(A,Xss))) = aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(list(A)),set(set(A)),image2(list(A),set(A),set2(A)),aa(list(list(A)),set(list(A)),set2(list(A)),Xss)))) ) ).

% length_remdups_concat
tff(fact_4657_sorted__list__of__set__nonempty,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),list(A),linord4507533701916653071of_set(A),A3) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),aa(set(A),A,lattic643756798350308766er_Min(A),A3)),aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,aa(set(A),A,lattic643756798350308766er_Min(A),A3)),bot_bot(set(A)))))) ) ) ) ) ).

% sorted_list_of_set_nonempty
tff(fact_4658_filter__filter,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),Xs: list(A)] : ( aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),filter2(A,Q),Xs)) = aa(list(A),list(A),filter2(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aim(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q)),Xs) ) ).

% filter_filter
tff(fact_4659_set__filter,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,P),Xs)) = aa(fun(A,bool),set(A),collect(A),aa(list(A),fun(A,bool),aTP_Lamp_ain(fun(A,bool),fun(list(A),fun(A,bool)),P),Xs)) ) ).

% set_filter
tff(fact_4660_removeAll__filter__not__eq,axiom,
    ! [A: $tType,X2: A] : ( removeAll(A,X2) = filter2(A,aa(A,fun(A,bool),aTP_Lamp_adp(A,fun(A,bool)),X2)) ) ).

% removeAll_filter_not_eq
tff(fact_4661_partition__in__shuffles,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] : pp(aa(set(list(A)),bool,member(list(A),Xs),shuffles(A,aa(list(A),list(A),filter2(A,P),Xs),aa(list(A),list(A),filter2(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P)),Xs)))) ).

% partition_in_shuffles
tff(fact_4662_inj__split__Cons,axiom,
    ! [A: $tType,X5: set(product_prod(list(A),A))] : inj_on(product_prod(list(A),A),list(A),aa(fun(list(A),fun(A,list(A))),fun(product_prod(list(A),A),list(A)),product_case_prod(list(A),A,list(A)),aTP_Lamp_aio(list(A),fun(A,list(A)))),X5) ).

% inj_split_Cons
tff(fact_4663_map__filter__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,option(A)),X2: B,Xs: list(B)] : ( map_filter(B,A,F2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = case_option(list(A),A,map_filter(B,A,F2,Xs),aa(list(B),fun(A,list(A)),aTP_Lamp_aip(fun(B,option(A)),fun(list(B),fun(A,list(A))),F2),Xs),aa(B,option(A),F2,X2)) ) ).

% map_filter_simps(1)
tff(fact_4664_sum__length__filter__compl,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),Xs))),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P)),Xs))) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% sum_length_filter_compl
tff(fact_4665_inter__set__filter,axiom,
    ! [A: $tType,A3: set(A),Xs: list(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(list(A),set(A),set2(A),Xs)) = aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3)),Xs)) ) ).

% inter_set_filter
tff(fact_4666_concat__filter__neq__Nil,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( concat(A,aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_ail(list(A),bool)),Xs)) = concat(A,Xs) ) ).

% concat_filter_neq_Nil
tff(fact_4667_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool))] : order_mono(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool)),aTP_Lamp_aiq(fun(A,fun(A,bool)),fun(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool))),Less)) ).

% ord.lexordp.mono
tff(fact_4668_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),Y: A,Xs: list(A)] :
      ( inj_on(A,B,F2,aa(set(A),set(A),insert(A,Y),aa(list(A),set(A),set2(A),Xs)))
     => ( aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),aTP_Lamp_adr(fun(A,B),fun(A,fun(A,bool)),F2),Y)),Xs) = aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),fequal(A),Y)),Xs) ) ) ).

% inj_on_filter_key_eq
tff(fact_4669_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ord(A)
     => order_mono(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool)),aTP_Lamp_air(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool)))) ) ).

% lexordp.mono
tff(fact_4670_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list(A),Y: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,Y),bot_bot(set(A)))) = aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),aTP_Lamp_rz(A,fun(A,bool)),Y)),Xs)) ) ).

% set_minus_filter_out
tff(fact_4671_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( pp(aa(set(list(A)),bool,member(list(A),Zs),shuffles(A,Xs,Ys)))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_ais(list(A),fun(A,bool),Xs)),Zs) = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
tff(fact_4672_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( pp(aa(set(list(A)),bool,member(list(A),Zs),shuffles(A,Xs,Ys)))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_ait(list(A),fun(A,bool),Xs)),Zs) = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
tff(fact_4673_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( pp(aa(set(list(A)),bool,member(list(A),Zs),shuffles(A,Xs,Ys)))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_ais(list(A),fun(A,bool),Ys)),Zs) = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
tff(fact_4674_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( pp(aa(set(list(A)),bool,member(list(A),Zs),shuffles(A,Xs,Ys)))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_ait(list(A),fun(A,bool),Ys)),Zs) = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
tff(fact_4675_lists__length__Suc__eq,axiom,
    ! [A: $tType,A3: set(A),N: nat] : ( aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(nat,fun(list(A),bool),aTP_Lamp_aiu(set(A),fun(nat,fun(list(A),bool)),A3),N)) = aa(set(product_prod(list(A),A)),set(list(A)),image2(product_prod(list(A),A),list(A),aa(fun(list(A),fun(A,list(A))),fun(product_prod(list(A),A),list(A)),product_case_prod(list(A),A,list(A)),aTP_Lamp_aio(list(A),fun(A,list(A))))),product_Sigma(list(A),A,aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(nat,fun(list(A),bool),aTP_Lamp_ahz(set(A),fun(nat,fun(list(A),bool)),A3),N)),aTP_Lamp_aiv(set(A),fun(list(A),set(A)),A3))) ) ).

% lists_length_Suc_eq
tff(fact_4676_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( distinct(A,Xs)
     => ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),Xs)) = aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(fun(A,bool),set(A),collect(A),P)),aa(list(A),set(A),set2(A),Xs))) ) ) ).

% distinct_length_filter
tff(fact_4677_shuffles_Oelims,axiom,
    ! [A: $tType,X2: list(A),Xa: list(A),Y: set(list(A))] :
      ( ( shuffles(A,X2,Xa) = Y )
     => ( ( ( X2 = nil(A) )
         => ( Y != aa(set(list(A)),set(list(A)),insert(list(A),Xa),bot_bot(set(list(A)))) ) )
       => ( ( ( Xa = nil(A) )
           => ( Y != aa(set(list(A)),set(list(A)),insert(list(A),X2),bot_bot(set(list(A)))) ) )
         => ~ ! [X: A,Xs2: list(A)] :
                ( ( X2 = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2) )
               => ! [Y2: A,Ys3: list(A)] :
                    ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys3) )
                   => ( Y != aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),sup_sup(set(list(A))),aa(set(list(A)),set(list(A)),image2(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X)),shuffles(A,Xs2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys3)))),aa(set(list(A)),set(list(A)),image2(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2)),shuffles(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2),Ys3))) ) ) ) ) ) ) ).

% shuffles.elims
tff(fact_4678_Pow__set_I2_J,axiom,
    ! [B: $tType,X2: B,Xs: list(B)] : ( pow(B,aa(list(B),set(B),set2(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs))) = aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),sup_sup(set(set(B))),pow(B,aa(list(B),set(B),set2(B),Xs))),aa(set(set(B)),set(set(B)),image2(set(B),set(B),insert(B,X2)),pow(B,aa(list(B),set(B),set2(B),Xs)))) ) ).

% Pow_set(2)
tff(fact_4679_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A3: set(A)] : ( set_Cons(A,A3,aa(set(list(A)),set(list(A)),insert(list(A),nil(A)),bot_bot(set(list(A))))) = aa(set(A),set(list(A)),image2(A,list(A),aTP_Lamp_aiw(A,list(A))),A3) ) ).

% set_Cons_sing_Nil
tff(fact_4680_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Xss: list(list(B))] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs))),aa(nat,nat,foldr(list(B),nat,aTP_Lamp_aix(list(B),fun(nat,nat)),Xss),zero_zero(nat))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(nat,nat,foldr(list(B),nat,aTP_Lamp_aiy(list(B),fun(nat,nat)),aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_aiz(list(B),bool)),Xss)),zero_zero(nat)))) ) ).

% transpose_aux_max
tff(fact_4681_foldr__length,axiom,
    ! [A: $tType,L: list(A)] : ( aa(nat,nat,foldr(A,nat,aTP_Lamp_sv(A,fun(nat,nat)),L),zero_zero(nat)) = aa(list(A),nat,size_size(list(A)),L) ) ).

% foldr_length
tff(fact_4682_foldr__filter,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,fun(A,A)),P: fun(B,bool),Xs: list(B)] : ( foldr(B,A,F2,aa(list(B),list(B),filter2(B,P),Xs)) = foldr(B,A,aa(fun(B,bool),fun(B,fun(A,A)),aTP_Lamp_aja(fun(B,fun(A,A)),fun(fun(B,bool),fun(B,fun(A,A))),F2),P),Xs) ) ).

% foldr_filter
tff(fact_4683_comp__fun__commute_Ofoldr__conv__foldl,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(B,B)),Xs: list(A),A4: B] :
      ( finite6289374366891150609ommute(A,B,F2)
     => ( aa(B,B,foldr(A,B,F2,Xs),A4) = foldl(B,A,aTP_Lamp_aig(fun(A,fun(B,B)),fun(B,fun(A,B)),F2),A4,Xs) ) ) ).

% comp_fun_commute.foldr_conv_foldl
tff(fact_4684_foldr__length__aux,axiom,
    ! [A: $tType,L: list(A),A4: nat] : ( aa(nat,nat,foldr(A,nat,aTP_Lamp_sv(A,fun(nat,nat)),L),A4) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),aa(list(A),nat,size_size(list(A)),L)) ) ).

% foldr_length_aux
tff(fact_4685_set__Cons__def,axiom,
    ! [A: $tType,A3: set(A),XS: set(list(A))] : ( set_Cons(A,A3,XS) = aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(set(list(A)),fun(list(A),bool),aTP_Lamp_ajb(set(A),fun(set(list(A)),fun(list(A),bool)),A3),XS)) ) ).

% set_Cons_def
tff(fact_4686_transpose__max__length,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(nat,nat,foldr(list(A),nat,aTP_Lamp_ajc(list(A),fun(nat,nat)),transpose(A,Xs)),zero_zero(nat)) = aa(list(list(A)),nat,size_size(list(list(A))),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_ail(list(A),bool)),Xs)) ) ).

% transpose_max_length
tff(fact_4687_listrel__Cons,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(B,A)),X2: B,Xs: list(B)] : ( aa(set(list(B)),set(list(A)),image(list(B),list(A),listrel(B,A,R2)),aa(set(list(B)),set(list(B)),insert(list(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)),bot_bot(set(list(B))))) = set_Cons(A,aa(set(B),set(A),image(B,A,R2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))),aa(set(list(B)),set(list(A)),image(list(B),list(A),listrel(B,A,R2)),aa(set(list(B)),set(list(B)),insert(list(B),Xs),bot_bot(set(list(B)))))) ) ).

% listrel_Cons
tff(fact_4688_arg__min__list_Oelims,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [X2: fun(A,B),Xa: list(A),Y: A] :
          ( ( arg_min_list(A,B,X2,Xa) = Y )
         => ( ! [X: A] :
                ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),nil(A)) )
               => ( Y != X ) )
           => ( ! [X: A,Y2: A,Zs3: list(A)] :
                  ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs3)) )
                 => ( Y != if(A,aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,X2,X)),aa(A,B,X2,arg_min_list(A,B,X2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs3)))),X,arg_min_list(A,B,X2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs3))) ) )
             => ~ ( ( Xa = nil(A) )
                 => ( Y != undefined(A) ) ) ) ) ) ) ).

% arg_min_list.elims
tff(fact_4689_listrel__Nil,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(B,A))] : ( aa(set(list(B)),set(list(A)),image(list(B),list(A),listrel(B,A,R2)),aa(set(list(B)),set(list(B)),insert(list(B),nil(B)),bot_bot(set(list(B))))) = aa(set(list(A)),set(list(A)),insert(list(A),nil(A)),bot_bot(set(list(A)))) ) ).

% listrel_Nil
tff(fact_4690_filter__conv__foldr,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(list(A),list(A),filter2(A,P),Xs) = aa(list(A),list(A),foldr(A,list(A),aTP_Lamp_ajd(fun(A,bool),fun(A,fun(list(A),list(A))),P),Xs),nil(A)) ) ).

% filter_conv_foldr
tff(fact_4691_arg__min__list_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),X2: A,Y: A,Zs: list(A)] : ( arg_min_list(A,B,F2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Zs))) = if(A,aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X2)),aa(A,B,F2,arg_min_list(A,B,F2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Zs)))),X2,arg_min_list(A,B,F2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Zs))) ) ) ).

% arg_min_list.simps(2)
tff(fact_4692_length__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)) = aa(nat,nat,foldr(list(A),nat,aTP_Lamp_ajc(list(A),fun(nat,nat)),Xs),zero_zero(nat)) ) ).

% length_transpose
tff(fact_4693_horner__sum__foldr,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A4: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A4),Xs) = aa(A,A,foldr(B,A,aa(A,fun(B,fun(A,A)),aTP_Lamp_aje(fun(B,A),fun(A,fun(B,fun(A,A))),F2),A4),Xs),zero_zero(A)) ) ) ).

% horner_sum_foldr
tff(fact_4694_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A4: A,X2: B,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A4),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,F2,X2)),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A4),Xs))) ) ) ).

% horner_sum_simps(2)
tff(fact_4695_ord__class_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ( ord_lexordp(A) = complete_lattice_lfp(fun(list(A),fun(list(A),bool)),aTP_Lamp_air(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool)))) ) ) ).

% ord_class.lexordp_def
tff(fact_4696_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A4: A] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A4),nil(B)) = zero_zero(A) ) ) ).

% horner_sum_simps(1)
tff(fact_4697_ord_Olexordp__def,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool))] : ( lexordp2(A,Less) = complete_lattice_lfp(fun(list(A),fun(list(A),bool)),aTP_Lamp_aiq(fun(A,fun(A,bool)),fun(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool))),Less)) ) ).

% ord.lexordp_def
tff(fact_4698_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A4: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A4),Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_ajf(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F2),A4),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% horner_sum_eq_sum_funpow
tff(fact_4699_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F2: fun(B,A),A4: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A4),Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_ajg(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F2),A4),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% horner_sum_eq_sum
tff(fact_4700_ran__nth__set__encoding__conv,axiom,
    ! [A: $tType,L: list(A)] : ( ran(nat,A,aTP_Lamp_ajh(list(A),fun(nat,option(A)),L)) = aa(list(A),set(A),set2(A),L) ) ).

% ran_nth_set_encoding_conv
tff(fact_4701_nth__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list(A),N: nat] : ( aa(nat,A,nth(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)),N) = aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),case_nat(A),X2),nth(A,Xs)),N) ) ).

% nth_Cons
tff(fact_4702_set__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),Xs) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_aji(list(A),fun(A,bool),Xs)) ) ).

% set_conv_nth
tff(fact_4703_length__filter__conv__card,axiom,
    ! [A: $tType,P5: fun(A,bool),Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P5),Xs)) = aa(set(nat),nat,finite_card(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(list(A),fun(nat,bool),aTP_Lamp_ajj(fun(A,bool),fun(list(A),fun(nat,bool)),P5),Xs))) ) ).

% length_filter_conv_card
tff(fact_4704_list__collect__set__alt,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,set(A)),L: list(B)] : ( list_collect_set(B,A,F2,L) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aa(list(B),fun(set(A),bool),aTP_Lamp_ajk(fun(B,set(A)),fun(list(B),fun(set(A),bool)),F2),L))) ) ).

% list_collect_set_alt
tff(fact_4705_set__update__distinct,axiom,
    ! [A: $tType,Xs: list(A),N: nat,X2: A] :
      ( distinct(A,Xs)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( aa(list(A),set(A),set2(A),list_update(A,Xs,N,X2)) = aa(set(A),set(A),insert(A,X2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,aa(nat,A,nth(A,Xs),N)),bot_bot(set(A))))) ) ) ) ).

% set_update_distinct
tff(fact_4706_set__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] : ( aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys)) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(list(B),fun(product_prod(A,B),bool),aTP_Lamp_ajl(list(A),fun(list(B),fun(product_prod(A,B),bool)),Xs),Ys)) ) ).

% set_zip
tff(fact_4707_list__collect__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,set(A))] : ( list_collect_set(B,A,F2,nil(B)) = bot_bot(set(A)) ) ).

% list_collect_set_simps(1)
tff(fact_4708_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A),I2: nat,V: A] : ( list_update(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs),I2,V) = aa(nat,list(A),aa(fun(nat,list(A)),fun(nat,list(A)),aa(list(A),fun(fun(nat,list(A)),fun(nat,list(A))),case_nat(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V),Xs)),aa(A,fun(nat,list(A)),aa(list(A),fun(A,fun(nat,list(A))),aTP_Lamp_ajm(A,fun(list(A),fun(A,fun(nat,list(A)))),X2),Xs),V)),I2) ) ).

% list_update.simps(2)
tff(fact_4709_set__zip__cart,axiom,
    ! [A: $tType,B: $tType,X2: product_prod(A,B),L: list(A),L4: list(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),X2),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,L,L4))))
     => pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),X2),product_Sigma(A,B,aa(list(A),set(A),set2(A),L),aTP_Lamp_aik(list(B),fun(A,set(B)),L4)))) ) ).

% set_zip_cart
tff(fact_4710_concat__injective,axiom,
    ! [A: $tType,Xs: list(list(A)),Ys: list(list(A))] :
      ( ( concat(A,Xs) = concat(A,Ys) )
     => ( ( aa(list(list(A)),nat,size_size(list(list(A))),Xs) = aa(list(list(A)),nat,size_size(list(list(A))),Ys) )
       => ( ! [X: product_prod(list(A),list(A))] :
              ( pp(aa(set(product_prod(list(A),list(A))),bool,member(product_prod(list(A),list(A)),X),aa(list(product_prod(list(A),list(A))),set(product_prod(list(A),list(A))),set2(product_prod(list(A),list(A))),zip(list(A),list(A),Xs,Ys))))
             => pp(aa(product_prod(list(A),list(A)),bool,aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_ajn(list(A),fun(list(A),bool))),X)) )
         => ( Xs = Ys ) ) ) ) ).

% concat_injective
tff(fact_4711_concat__eq__concat__iff,axiom,
    ! [A: $tType,Xs: list(list(A)),Ys: list(list(A))] :
      ( ! [X: product_prod(list(A),list(A))] :
          ( pp(aa(set(product_prod(list(A),list(A))),bool,member(product_prod(list(A),list(A)),X),aa(list(product_prod(list(A),list(A))),set(product_prod(list(A),list(A))),set2(product_prod(list(A),list(A))),zip(list(A),list(A),Xs,Ys))))
         => pp(aa(product_prod(list(A),list(A)),bool,aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_ajn(list(A),fun(list(A),bool))),X)) )
     => ( ( aa(list(list(A)),nat,size_size(list(list(A))),Xs) = aa(list(list(A)),nat,size_size(list(list(A))),Ys) )
       => ( ( concat(A,Xs) = concat(A,Ys) )
        <=> ( Xs = Ys ) ) ) ) ).

% concat_eq_concat_iff
tff(fact_4712_foldl__snd__zip,axiom,
    ! [B: $tType,C: $tType,A: $tType,Ys: list(A),Xs: list(B),F2: fun(C,fun(A,C)),B3: C] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Ys)),aa(list(B),nat,size_size(list(B)),Xs)))
     => ( foldl(C,product_prod(B,A),aTP_Lamp_ajp(fun(C,fun(A,C)),fun(C,fun(product_prod(B,A),C)),F2),B3,zip(B,A,Xs,Ys)) = foldl(C,A,F2,B3,Ys) ) ) ).

% foldl_snd_zip
tff(fact_4713_foldr__snd__zip,axiom,
    ! [B: $tType,A: $tType,C: $tType,Ys: list(A),Xs: list(B),F2: fun(A,fun(C,C)),B3: C] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Ys)),aa(list(B),nat,size_size(list(B)),Xs)))
     => ( aa(C,C,foldr(product_prod(B,A),C,aa(fun(B,fun(A,fun(C,C))),fun(product_prod(B,A),fun(C,C)),product_case_prod(B,A,fun(C,C)),aTP_Lamp_ajq(fun(A,fun(C,C)),fun(B,fun(A,fun(C,C))),F2)),zip(B,A,Xs,Ys)),B3) = aa(C,C,foldr(A,C,F2,Ys),B3) ) ) ).

% foldr_snd_zip
tff(fact_4714_list__eq__iff__zip__eq,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs = Ys )
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
        & ! [X3: product_prod(A,A)] :
            ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),X3),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),zip(A,A,Xs,Ys))))
           => pp(aa(product_prod(A,A),bool,aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),fequal(A)),X3)) ) ) ) ).

% list_eq_iff_zip_eq
tff(fact_4715_list__collect__set__def,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,set(A)),L: list(B)] : ( list_collect_set(B,A,F2,L) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aa(list(B),fun(set(A),bool),aTP_Lamp_ajr(fun(B,set(A)),fun(list(B),fun(set(A),bool)),F2),L))) ) ).

% list_collect_set_def
tff(fact_4716_distinct__list__update,axiom,
    ! [A: $tType,Xs: list(A),A4: A,I2: nat] :
      ( distinct(A,Xs)
     => ( ~ pp(aa(set(A),bool,member(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,aa(nat,A,nth(A,Xs),I2)),bot_bot(set(A))))))
       => distinct(A,list_update(A,Xs,I2,A4)) ) ) ).

% distinct_list_update
tff(fact_4717_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B),R2: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(list(A),list(B))),bool,member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xs),Ys)),listrel(A,B,R2)))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
        & ! [X3: product_prod(A,B)] :
            ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),X3),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys))))
           => pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),R2)),X3)) ) ) ) ).

% listrel_iff_zip
tff(fact_4718_set__nths,axiom,
    ! [A: $tType,Xs: list(A),I: set(nat)] : ( aa(list(A),set(A),set2(A),nths(A,Xs,I)) = aa(fun(A,bool),set(A),collect(A),aa(set(nat),fun(A,bool),aTP_Lamp_ajs(list(A),fun(set(nat),fun(A,bool)),Xs),I)) ) ).

% set_nths
tff(fact_4719_nth__transpose,axiom,
    ! [A: $tType,I2: nat,Xs: list(list(A))] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs))))
     => ( aa(nat,list(A),nth(list(A),transpose(A,Xs)),I2) = aa(list(list(A)),list(A),map(list(A),A,aTP_Lamp_ajt(nat,fun(list(A),A),I2)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_aju(nat,fun(list(A),bool),I2)),Xs)) ) ) ).

% nth_transpose
tff(fact_4720_sum__list__update,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [K: nat,Xs: list(A),X2: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Xs)))
         => ( aa(list(A),A,groups8242544230860333062m_list(A),list_update(A,Xs,K,X2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),Xs)),X2)),aa(nat,A,nth(A,Xs),K)) ) ) ) ).

% sum_list_update
tff(fact_4721_map__ident,axiom,
    ! [A: $tType,X4: list(A)] : ( aa(list(A),list(A),map(A,A,aTP_Lamp_bk(A,A)),X4) = X4 ) ).

% map_ident
tff(fact_4722_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ( aa(list(A),A,groups8242544230860333062m_list(A),nil(A)) = zero_zero(A) ) ) ).

% sum_list.Nil
tff(fact_4723_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [X2: A,Xs: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(list(A),A,groups8242544230860333062m_list(A),Xs)) ) ) ).

% sum_list.Cons
tff(fact_4724_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Ns: list(A)] :
          ( ( aa(list(A),A,groups8242544230860333062m_list(A),Ns) = zero_zero(A) )
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),aa(list(A),set(A),set2(A),Ns)))
             => ( X3 = zero_zero(A) ) ) ) ) ).

% sum_list_eq_0_iff
tff(fact_4725_nths__empty,axiom,
    ! [A: $tType,Xs: list(A)] : ( nths(A,Xs,bot_bot(set(nat))) = nil(A) ) ).

% nths_empty
tff(fact_4726_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,aTP_Lamp_ajv(B,A)),Xs)) = zero_zero(A) ) ) ).

% sum_list_0
tff(fact_4727_list__collect__set__map__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(B,set(A)),X2: fun(C,B)] : ( list_collect_set(B,A,F2,aa(list(C),list(B),map(C,B,X2),nil(C))) = bot_bot(set(A)) ) ).

% list_collect_set_map_simps(1)
tff(fact_4728_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] : ( concat(A,aa(list(B),list(list(A)),map(B,list(A),aTP_Lamp_ajw(fun(B,A),fun(B,list(A)),F2)),Xs)) = aa(list(B),list(A),map(B,A,F2),Xs) ) ).

% concat_map_singleton
tff(fact_4729_map__zip__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: fun(product_prod(B,C),A),G: fun(D,B),Xs: list(D),Ys: list(C)] : ( aa(list(product_prod(B,C)),list(A),map(product_prod(B,C),A,F2),zip(B,C,aa(list(D),list(B),map(D,B,G),Xs),Ys)) = aa(list(product_prod(D,C)),list(A),map(product_prod(D,C),A,aa(fun(D,fun(C,A)),fun(product_prod(D,C),A),product_case_prod(D,C,A),aa(fun(D,B),fun(D,fun(C,A)),aTP_Lamp_ajx(fun(product_prod(B,C),A),fun(fun(D,B),fun(D,fun(C,A))),F2),G))),zip(D,C,Xs,Ys)) ) ).

% map_zip_map
tff(fact_4730_map__zip__map2,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: fun(product_prod(B,C),A),Xs: list(B),G: fun(D,C),Ys: list(D)] : ( aa(list(product_prod(B,C)),list(A),map(product_prod(B,C),A,F2),zip(B,C,Xs,aa(list(D),list(C),map(D,C,G),Ys))) = aa(list(product_prod(B,D)),list(A),map(product_prod(B,D),A,aa(fun(B,fun(D,A)),fun(product_prod(B,D),A),product_case_prod(B,D,A),aa(fun(D,C),fun(B,fun(D,A)),aTP_Lamp_ajy(fun(product_prod(B,C),A),fun(fun(D,C),fun(B,fun(D,A))),F2),G))),zip(B,D,Xs,Ys)) ) ).

% map_zip_map2
tff(fact_4731_zip__map1,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: fun(C,A),Xs: list(C),Ys: list(B)] : ( zip(A,B,aa(list(C),list(A),map(C,A,F2),Xs),Ys) = aa(list(product_prod(C,B)),list(product_prod(A,B)),map(product_prod(C,B),product_prod(A,B),aa(fun(C,fun(B,product_prod(A,B))),fun(product_prod(C,B),product_prod(A,B)),product_case_prod(C,B,product_prod(A,B)),aTP_Lamp_ajz(fun(C,A),fun(C,fun(B,product_prod(A,B))),F2))),zip(C,B,Xs,Ys)) ) ).

% zip_map1
tff(fact_4732_zip__map2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),F2: fun(C,B),Ys: list(C)] : ( zip(A,B,Xs,aa(list(C),list(B),map(C,B,F2),Ys)) = aa(list(product_prod(A,C)),list(product_prod(A,B)),map(product_prod(A,C),product_prod(A,B),aa(fun(A,fun(C,product_prod(A,B))),fun(product_prod(A,C),product_prod(A,B)),product_case_prod(A,C,product_prod(A,B)),aTP_Lamp_aka(fun(C,B),fun(A,fun(C,product_prod(A,B))),F2))),zip(A,C,Xs,Ys)) ) ).

% zip_map2
tff(fact_4733_map__prod__fun__zip,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: fun(C,A),G: fun(D,B),Xs: list(C),Ys: list(D)] : ( aa(list(product_prod(C,D)),list(product_prod(A,B)),map(product_prod(C,D),product_prod(A,B),aa(fun(C,fun(D,product_prod(A,B))),fun(product_prod(C,D),product_prod(A,B)),product_case_prod(C,D,product_prod(A,B)),aa(fun(D,B),fun(C,fun(D,product_prod(A,B))),aTP_Lamp_ek(fun(C,A),fun(fun(D,B),fun(C,fun(D,product_prod(A,B)))),F2),G))),zip(C,D,Xs,Ys)) = zip(A,B,aa(list(C),list(A),map(C,A,F2),Xs),aa(list(D),list(B),map(D,B,G),Ys)) ) ).

% map_prod_fun_zip
tff(fact_4734_map2__map__map,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,H2: fun(B,fun(C,A)),F2: fun(D,B),Xs: list(D),G: fun(D,C)] : ( aa(list(product_prod(B,C)),list(A),map(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),H2)),zip(B,C,aa(list(D),list(B),map(D,B,F2),Xs),aa(list(D),list(C),map(D,C,G),Xs))) = aa(list(D),list(A),map(D,A,aa(fun(D,C),fun(D,A),aa(fun(D,B),fun(fun(D,C),fun(D,A)),aTP_Lamp_akb(fun(B,fun(C,A)),fun(fun(D,B),fun(fun(D,C),fun(D,A))),H2),F2),G)),Xs) ) ).

% map2_map_map
tff(fact_4735_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(B),P: fun(B,bool),F2: fun(B,A)] :
          ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),aa(list(B),set(B),set2(B),Xs)))
             => ( ~ pp(aa(B,bool,P,X))
               => ( aa(B,A,F2,X) = zero_zero(A) ) ) )
         => ( aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),filter2(B,P),Xs))) = aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,F2),Xs)) ) ) ) ).

% sum_list_map_filter
tff(fact_4736_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( monoid_add(A)
     => ! [F2: fun(B,A),P: fun(B,bool),Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),filter2(B,P),Xs))) = aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,aa(fun(B,bool),fun(B,A),aTP_Lamp_akc(fun(B,A),fun(fun(B,bool),fun(B,A)),F2),P)),Xs)) ) ) ).

% sum_list_map_filter'
tff(fact_4737_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add(B)
        & strict9044650504122735259up_add(B) )
     => ! [Xs: list(A),F2: fun(A,B),G: fun(A,B)] :
          ( ( Xs != nil(A) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),aa(list(A),set(A),set2(A),Xs)))
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F2,X)),aa(A,B,G,X))) )
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(A),list(B),map(A,B,F2),Xs))),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(A),list(B),map(A,B,G),Xs)))) ) ) ) ).

% sum_list_strict_mono
tff(fact_4738_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [X2: B,Xs: list(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,member(B,X2),aa(list(B),set(B),set2(B),Xs)))
         => ( aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,F2),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,F2,X2)),aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,F2),remove1(B,X2,Xs)))) ) ) ) ).

% sum_list_map_remove1
tff(fact_4739_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add(B)
        & ordere6658533253407199908up_add(B) )
     => ! [Xs: list(A),F2: fun(A,B),G: fun(A,B)] :
          ( ! [X: A] :
              ( pp(aa(set(A),bool,member(A,X),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F2,X)),aa(A,B,G,X))) )
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(A),list(B),map(A,B,F2),Xs))),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(A),list(B),map(A,B,G),Xs)))) ) ) ).

% sum_list_mono
tff(fact_4740_sum__list__distinct__conv__sum__set,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Xs: list(B),F2: fun(B,C)] :
          ( distinct(B,Xs)
         => ( aa(list(C),C,groups8242544230860333062m_list(C),aa(list(B),list(C),map(B,C,F2),Xs)) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(list(B),set(B),set2(B),Xs)) ) ) ) ).

% sum_list_distinct_conv_sum_set
tff(fact_4741_sum_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Xs: list(B),G: fun(B,A)] :
          ( distinct(B,Xs)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(list(B),set(B),set2(B),Xs)) = aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,G),Xs)) ) ) ) ).

% sum.distinct_set_conv_list
tff(fact_4742_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [R2: B,Xs: list(C)] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,aTP_Lamp_akd(B,fun(C,B),R2)),Xs)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(list(C),nat,size_size(list(C)),Xs))),R2) ) ) ).

% sum_list_triv
tff(fact_4743_length__concat,axiom,
    ! [B: $tType,Xss: list(list(B))] : ( aa(list(B),nat,size_size(list(B)),concat(B,Xss)) = aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(list(B)),list(nat),map(list(B),nat,size_size(list(B))),Xss)) ) ).

% length_concat
tff(fact_4744_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [Xs: list(A)] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(list(A),A,groups8242544230860333062m_list(A),Xs))),aa(list(A),A,groups8242544230860333062m_list(A),aa(list(A),list(A),map(A,A,abs_abs(A)),Xs)))) ) ).

% sum_list_abs
tff(fact_4745_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [C2: A,F2: fun(B,A),Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ow(A,fun(fun(B,A),fun(B,A)),C2),F2)),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,F2),Xs))) ) ) ).

% sum_list_const_mult
tff(fact_4746_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_0(A)
     => ! [F2: fun(B,A),C2: A,Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,aa(A,fun(B,A),aTP_Lamp_ov(fun(B,A),fun(A,fun(B,A)),F2),C2)),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,F2),Xs))),C2) ) ) ).

% sum_list_mult_const
tff(fact_4747_list_Omap__ident,axiom,
    ! [A: $tType,T3: list(A)] : ( aa(list(A),list(A),map(A,A,aTP_Lamp_bk(A,A)),T3) = T3 ) ).

% list.map_ident
tff(fact_4748_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(B,A),G: fun(B,A),Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_mg(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,F2),Xs))),aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,G),Xs))) ) ) ).

% sum_list_addf
tff(fact_4749_List_Omap_Oidentity,axiom,
    ! [A: $tType] : ( map(A,A,aTP_Lamp_bk(A,A)) = id(list(A)) ) ).

% List.map.identity
tff(fact_4750_sum__list__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(B,A),G: fun(B,A),Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ox(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),Xs)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,F2),Xs))),aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,G),Xs))) ) ) ).

% sum_list_subtractf
tff(fact_4751_uminus__sum__list__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(B,A),Xs: list(B)] : ( aa(A,A,uminus_uminus(A),aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,F2),Xs))) = aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),comp(A,A,B,uminus_uminus(A)),F2)),Xs)) ) ) ).

% uminus_sum_list_map
tff(fact_4752_foldl__map,axiom,
    ! [A: $tType,B: $tType,C: $tType,G: fun(A,fun(B,A)),A4: A,F2: fun(C,B),Xs: list(C)] : ( foldl(A,B,G,A4,aa(list(C),list(B),map(C,B,F2),Xs)) = foldl(A,C,aa(fun(C,B),fun(A,fun(C,A)),aTP_Lamp_ake(fun(A,fun(B,A)),fun(fun(C,B),fun(A,fun(C,A))),G),F2),A4,Xs) ) ).

% foldl_map
tff(fact_4753_sum__code,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),Xs: list(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(list(B),set(B),set2(B),Xs)) = aa(list(A),A,groups8242544230860333062m_list(A),aa(list(B),list(A),map(B,A,G),aa(list(B),list(B),remdups(B),Xs))) ) ) ).

% sum_code
tff(fact_4754_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X2: A,Xs: list(A)] :
          ( pp(aa(set(A),bool,member(A,X2),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(list(A),A,groups8242544230860333062m_list(A),Xs))) ) ) ).

% member_le_sum_list
tff(fact_4755_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X: A] :
              ( pp(aa(set(A),bool,member(A,X),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(list(A),A,groups8242544230860333062m_list(A),Xs))) ) ) ).

% Groups_List.sum_list_nonneg
tff(fact_4756_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X: A] :
              ( pp(aa(set(A),bool,member(A,X),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X)) )
         => ( ( aa(list(A),A,groups8242544230860333062m_list(A),Xs) = zero_zero(A) )
          <=> ! [X3: A] :
                ( pp(aa(set(A),bool,member(A,X3),aa(list(A),set(A),set2(A),Xs)))
               => ( X3 = zero_zero(A) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
tff(fact_4757_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X: A] :
              ( pp(aa(set(A),bool,member(A,X),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),zero_zero(A))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(list(A),A,groups8242544230860333062m_list(A),Xs)),zero_zero(A))) ) ) ).

% sum_list_nonpos
tff(fact_4758_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),Xs) = aa(A,A,foldr(A,A,plus_plus(A),Xs),zero_zero(A)) ) ) ).

% sum_list.eq_foldr
tff(fact_4759_nths__nths,axiom,
    ! [A: $tType,Xs: list(A),A3: set(nat),B2: set(nat)] : ( nths(A,nths(A,Xs,A3),B2) = nths(A,Xs,aa(fun(nat,bool),set(nat),collect(nat),aa(set(nat),fun(nat,bool),aTP_Lamp_akg(set(nat),fun(set(nat),fun(nat,bool)),A3),B2))) ) ).

% nths_nths
tff(fact_4760_distinct__sum__list__conv__Sum,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Xs: list(A)] :
          ( distinct(A,Xs)
         => ( aa(list(A),A,groups8242544230860333062m_list(A),Xs) = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_pm(A,A)),aa(list(A),set(A),set2(A),Xs)) ) ) ) ).

% distinct_sum_list_conv_Sum
tff(fact_4761_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [K: nat,Ns: list(A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Ns)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,nth(A,Ns),K)),aa(list(A),A,groups8242544230860333062m_list(A),Ns))) ) ) ).

% elem_le_sum_list
tff(fact_4762_filter__in__nths,axiom,
    ! [A: $tType,Xs: list(A),S2: set(nat)] :
      ( distinct(A,Xs)
     => ( aa(list(A),list(A),filter2(A,aa(set(nat),fun(A,bool),aTP_Lamp_akh(list(A),fun(set(nat),fun(A,bool)),Xs),S2)),Xs) = nths(A,Xs,S2) ) ) ).

% filter_in_nths
tff(fact_4763_card__length__sum__list__rec,axiom,
    ! [M2: nat,N4: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),M2))
     => ( aa(set(list(nat)),nat,finite_card(list(nat)),aa(fun(list(nat),bool),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),bool),aTP_Lamp_aki(nat,fun(nat,fun(list(nat),bool)),M2),N4))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(list(nat)),nat,finite_card(list(nat)),aa(fun(list(nat),bool),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),bool),aTP_Lamp_akj(nat,fun(nat,fun(list(nat),bool)),M2),N4)))),aa(set(list(nat)),nat,finite_card(list(nat)),aa(fun(list(nat),bool),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),bool),aTP_Lamp_akk(nat,fun(nat,fun(list(nat),bool)),M2),N4)))) ) ) ).

% card_length_sum_list_rec
tff(fact_4764_card__length__sum__list,axiom,
    ! [M2: nat,N4: nat] : ( aa(set(list(nat)),nat,finite_card(list(nat)),aa(fun(list(nat),bool),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),bool),aTP_Lamp_aki(nat,fun(nat,fun(list(nat),bool)),M2),N4))) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N4),M2)),one_one(nat))),N4) ) ).

% card_length_sum_list
tff(fact_4765_length__nths,axiom,
    ! [A: $tType,Xs: list(A),I: set(nat)] : ( aa(list(A),nat,size_size(list(A)),nths(A,Xs,I)) = aa(set(nat),nat,finite_card(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(set(nat),fun(nat,bool),aTP_Lamp_akl(list(A),fun(set(nat),fun(nat,bool)),Xs),I))) ) ).

% length_nths
tff(fact_4766_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),P: fun(B,bool),Xs: list(B)] : ( aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),filter2(B,P),Xs)) = map_filter(B,A,aa(fun(B,bool),fun(B,option(A)),aTP_Lamp_akm(fun(B,A),fun(fun(B,bool),fun(B,option(A))),F2),P),Xs) ) ).

% map_filter_map_filter
tff(fact_4767_filter__eq__nths,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(list(A),list(A),filter2(A,P),Xs) = nths(A,Xs,aa(fun(nat,bool),set(nat),collect(nat),aa(list(A),fun(nat,bool),aTP_Lamp_ajj(fun(A,bool),fun(list(A),fun(nat,bool)),P),Xs))) ) ).

% filter_eq_nths
tff(fact_4768_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Xs: list(B)] : ( aa(list(B),B,groups8242544230860333062m_list(B),Xs) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),nth(B,Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% sum_list_sum_nth
tff(fact_4769_map__filter__def,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,option(B)),Xs: list(A)] : ( map_filter(A,B,F2,Xs) = aa(list(A),list(B),map(A,B,aa(fun(A,option(B)),fun(A,B),comp(option(B),B,A,the2(B)),F2)),aa(list(A),list(A),filter2(A,aTP_Lamp_acq(fun(A,option(B)),fun(A,bool),F2)),Xs)) ) ).

% map_filter_def
tff(fact_4770_length__product__lists,axiom,
    ! [B: $tType,Xss: list(list(B))] : ( aa(list(list(B)),nat,size_size(list(list(B))),product_lists(B,Xss)) = aa(nat,nat,foldr(nat,nat,times_times(nat),aa(list(list(B)),list(nat),map(list(B),nat,size_size(list(B))),Xss)),one_one(nat)) ) ).

% length_product_lists
tff(fact_4771_part__def,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Pivot: A,Xs: list(B)] : ( linorder_part(B,A,F2,Pivot,Xs) = aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),aa(list(B),list(B),filter2(B,aa(A,fun(B,bool),aTP_Lamp_akn(fun(B,A),fun(A,fun(B,bool)),F2),Pivot)),Xs)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),filter2(B,aa(A,fun(B,bool),aTP_Lamp_ako(fun(B,A),fun(A,fun(B,bool)),F2),Pivot)),Xs)),aa(list(B),list(B),filter2(B,aa(A,fun(B,bool),aTP_Lamp_akp(fun(B,A),fun(A,fun(B,bool)),F2),Pivot)),Xs))) ) ) ).

% part_def
tff(fact_4772_part__code_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Pivot: A,X2: B,Xs: list(B)] : ( linorder_part(B,A,F2,Pivot,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(product_prod(list(B),product_prod(list(B),list(B))),product_prod(list(B),product_prod(list(B),list(B))),aa(fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),fun(product_prod(list(B),product_prod(list(B),list(B))),product_prod(list(B),product_prod(list(B),list(B)))),product_case_prod(list(B),product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),aa(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),aa(A,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))))),aTP_Lamp_akr(fun(B,A),fun(A,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))))),F2),Pivot),X2)),linorder_part(B,A,F2,Pivot,Xs)) ) ) ).

% part_code(2)
tff(fact_4773_map__fst__mk__snd,axiom,
    ! [B: $tType,A: $tType,K: B,L: list(A)] : ( aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_ej(B,fun(A,product_prod(A,B))),K)),L)) = L ) ).

% map_fst_mk_snd
tff(fact_4774_map__snd__mk__fst,axiom,
    ! [B: $tType,A: $tType,K: B,L: list(A)] : ( aa(list(product_prod(B,A)),list(A),map(product_prod(B,A),A,product_snd(B,A)),aa(list(A),list(product_prod(B,A)),map(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),K)),L)) = L ) ).

% map_snd_mk_fst
tff(fact_4775_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: fun(nat,bool),Xs: list(A),Is: list(nat)] : ( aa(list(product_prod(A,nat)),list(A),map(product_prod(A,nat),A,product_fst(A,nat)),aa(list(product_prod(A,nat)),list(product_prod(A,nat)),filter2(product_prod(A,nat),aTP_Lamp_aks(fun(nat,bool),fun(product_prod(A,nat),bool),P)),zip(A,nat,Xs,Is))) = aa(list(product_prod(A,nat)),list(A),map(product_prod(A,nat),A,product_fst(A,nat)),aa(list(product_prod(A,nat)),list(product_prod(A,nat)),filter2(product_prod(A,nat),aTP_Lamp_akt(fun(nat,bool),fun(product_prod(A,nat),bool),P)),zip(A,nat,Xs,aa(list(nat),list(nat),map(nat,nat,suc),Is)))) ) ).

% nths_shift_lemma_Suc
tff(fact_4776_product__concat__map,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B)] : ( product(A,B,Xs,Ys) = concat(product_prod(A,B),aa(list(A),list(list(product_prod(A,B))),map(A,list(product_prod(A,B)),aTP_Lamp_aku(list(B),fun(A,list(product_prod(A,B))),Ys)),Xs)) ) ).

% product_concat_map
tff(fact_4777_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list(A),Xss: list(list(A))] : ( product_lists(A,aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),Xs),Xss)) = concat(list(A),aa(list(A),list(list(list(A))),map(A,list(list(A)),aTP_Lamp_akv(list(list(A)),fun(A,list(list(A))),Xss)),Xs)) ) ).

% product_lists.simps(2)
tff(fact_4778_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: fun(A,nat),P: fun(A,bool),Xs: list(A)] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(A),list(nat),map(A,nat,F2),aa(list(A),list(A),filter2(A,P),Xs)))),aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(A),list(nat),map(A,nat,F2),Xs)))) ).

% sum_list_filter_le_nat
tff(fact_4779_zip__same__conv__map,axiom,
    ! [A: $tType,Xs: list(A)] : ( zip(A,A,Xs,Xs) = aa(list(A),list(product_prod(A,A)),map(A,product_prod(A,A),aTP_Lamp_hl(A,product_prod(A,A))),Xs) ) ).

% zip_same_conv_map
tff(fact_4780_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B)] : ( product_product(A,B,aa(list(A),set(A),set2(A),Xs),aa(list(B),set(B),set2(B),Ys)) = aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),concat(product_prod(A,B),aa(list(A),list(list(product_prod(A,B))),map(A,list(product_prod(A,B)),aTP_Lamp_aku(list(B),fun(A,list(product_prod(A,B))),Ys)),Xs))) ) ).

% product_code
tff(fact_4781_sum__list__Suc,axiom,
    ! [A: $tType,F2: fun(A,nat),Xs: list(A)] : ( aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(A),list(nat),map(A,nat,aTP_Lamp_sy(fun(A,nat),fun(A,nat),F2)),Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(A),list(nat),map(A,nat,F2),Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% sum_list_Suc
tff(fact_4782_zip__left__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),Ys: list(B),Zs: list(C)] : ( zip(A,product_prod(B,C),Xs,zip(B,C,Ys,Zs)) = aa(list(product_prod(B,product_prod(A,C))),list(product_prod(A,product_prod(B,C))),map(product_prod(B,product_prod(A,C)),product_prod(A,product_prod(B,C)),aa(fun(B,fun(product_prod(A,C),product_prod(A,product_prod(B,C)))),fun(product_prod(B,product_prod(A,C)),product_prod(A,product_prod(B,C))),product_case_prod(B,product_prod(A,C),product_prod(A,product_prod(B,C))),aTP_Lamp_akx(B,fun(product_prod(A,C),product_prod(A,product_prod(B,C)))))),zip(B,product_prod(A,C),Ys,zip(A,C,Xs,Zs))) ) ).

% zip_left_commute
tff(fact_4783_zip__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),Ys: list(B),Zs: list(C)] : ( zip(A,product_prod(B,C),Xs,zip(B,C,Ys,Zs)) = aa(list(product_prod(product_prod(A,B),C)),list(product_prod(A,product_prod(B,C))),map(product_prod(product_prod(A,B),C),product_prod(A,product_prod(B,C)),aa(fun(product_prod(A,B),fun(C,product_prod(A,product_prod(B,C)))),fun(product_prod(product_prod(A,B),C),product_prod(A,product_prod(B,C))),product_case_prod(product_prod(A,B),C,product_prod(A,product_prod(B,C))),aa(fun(A,fun(B,fun(C,product_prod(A,product_prod(B,C))))),fun(product_prod(A,B),fun(C,product_prod(A,product_prod(B,C)))),product_case_prod(A,B,fun(C,product_prod(A,product_prod(B,C)))),aTP_Lamp_aky(A,fun(B,fun(C,product_prod(A,product_prod(B,C)))))))),zip(product_prod(A,B),C,zip(A,B,Xs,Ys),Zs)) ) ).

% zip_assoc
tff(fact_4784_zip__commute,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B)] : ( zip(A,B,Xs,Ys) = aa(list(product_prod(B,A)),list(product_prod(A,B)),map(product_prod(B,A),product_prod(A,B),aa(fun(B,fun(A,product_prod(A,B))),fun(product_prod(B,A),product_prod(A,B)),product_case_prod(B,A,product_prod(A,B)),aTP_Lamp_ej(B,fun(A,product_prod(A,B))))),zip(B,A,Ys,Xs)) ) ).

% zip_commute
tff(fact_4785_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( n_lists(A,aa(nat,nat,suc,N),Xs) = concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),aTP_Lamp_akz(list(A),fun(list(A),list(list(A))),Xs)),n_lists(A,N,Xs))) ) ).

% n_lists.simps(2)
tff(fact_4786_Id__on__set,axiom,
    ! [A: $tType,Xs: list(A)] : ( id_on(A,aa(list(A),set(A),set2(A),Xs)) = aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),aa(list(A),list(product_prod(A,A)),map(A,product_prod(A,A),aTP_Lamp_hl(A,product_prod(A,A))),Xs)) ) ).

% Id_on_set
tff(fact_4787_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys: list(product_prod(A,C)),Yzs: list(product_prod(C,B))] : ( relcomp(A,C,B,aa(list(product_prod(A,C)),set(product_prod(A,C)),set2(product_prod(A,C)),Xys),aa(list(product_prod(C,B)),set(product_prod(C,B)),set2(product_prod(C,B)),Yzs)) = aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),concat(product_prod(A,B),aa(list(product_prod(A,C)),list(list(product_prod(A,B))),map(product_prod(A,C),list(product_prod(A,B)),aTP_Lamp_alb(list(product_prod(C,B)),fun(product_prod(A,C),list(product_prod(A,B))),Yzs)),Xys))) ) ).

% set_relcomp
tff(fact_4788_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs: list(A),X5: set(A),F2: fun(A,nat)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),X5))
     => ( pp(aa(set(A),bool,finite_finite2(A),X5))
       => ( aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(A),list(nat),map(A,nat,F2),Xs)) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_alc(list(A),fun(fun(A,nat),fun(A,nat)),Xs),F2)),X5) ) ) ) ).

% sum_list_map_eq_sum_count2
tff(fact_4789_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F2: fun(A,nat),Xs: list(A)] : ( aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(A),list(nat),map(A,nat,F2),Xs)) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(list(A),fun(A,nat),aTP_Lamp_ald(fun(A,nat),fun(list(A),fun(A,nat)),F2),Xs)),aa(list(A),set(A),set2(A),Xs)) ) ).

% sum_list_map_eq_sum_count
tff(fact_4790_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [F2: fun(nat,B),Ns: list(nat)] :
          ( ! [X: nat,Y2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X),Y2))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(nat,B,F2,X)),aa(nat,B,F2,Y2))) )
         => ( sorted_wrt(nat,ord_less(nat),Ns)
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),F2),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(nat),nat,size_size(list(nat)),Ns)))),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(nat),list(B),map(nat,B,F2),Ns)))) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
tff(fact_4791_sorted__wrt__map__linord,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [L: list(product_prod(A,B))] :
          ( sorted_wrt(product_prod(A,B),aTP_Lamp_ale(product_prod(A,B),fun(product_prod(A,B),bool)),L)
        <=> sorted_wrt(A,ord_less_eq(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),L)) ) ) ).

% sorted_wrt_map_linord
tff(fact_4792_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(A,bool)),F2: fun(B,A),Xs: list(B)] :
      ( sorted_wrt(A,R,aa(list(B),list(A),map(B,A,F2),Xs))
    <=> sorted_wrt(B,aa(fun(B,A),fun(B,fun(B,bool)),aTP_Lamp_alf(fun(A,fun(A,bool)),fun(fun(B,A),fun(B,fun(B,bool))),R),F2),Xs) ) ).

% sorted_wrt_map
tff(fact_4793_sorted__wrt__true,axiom,
    ! [A: $tType,Xs: list(A)] : sorted_wrt(A,aTP_Lamp_alg(A,fun(A,bool)),Xs) ).

% sorted_wrt_true
tff(fact_4794_strict__sorted__equal__Uniq,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : uniq(list(A),aTP_Lamp_alh(set(A),fun(list(A),bool),A3)) ) ).

% strict_sorted_equal_Uniq
tff(fact_4795_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Xs: list(B)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),Xs))
        <=> sorted_wrt(B,aTP_Lamp_ali(fun(B,A),fun(B,fun(B,bool)),F2),Xs) ) ) ).

% sorted_map
tff(fact_4796_sorted__same,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [G: fun(list(A),A),Xs: list(A)] : sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),filter2(A,aa(list(A),fun(A,bool),aTP_Lamp_alj(fun(list(A),A),fun(list(A),fun(A,bool)),G),Xs)),Xs)) ) ).

% sorted_same
tff(fact_4797_sorted__insort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),X2),Xs))
        <=> sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% sorted_insort
tff(fact_4798_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),G: fun(list(B),A),Xs: list(B)] : sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),aa(list(B),list(B),filter2(B,aa(list(B),fun(B,bool),aa(fun(list(B),A),fun(list(B),fun(B,bool)),aTP_Lamp_alk(fun(B,A),fun(fun(list(B),A),fun(list(B),fun(B,bool))),F2),G),Xs)),Xs))) ) ).

% sorted_map_same
tff(fact_4799_insort__remove1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: A,Xs: list(A)] :
          ( pp(aa(set(A),bool,member(A,A4),aa(list(A),set(A),set2(A),Xs)))
         => ( sorted_wrt(A,ord_less_eq(A),Xs)
           => ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),A4),remove1(A,A4,Xs)) = Xs ) ) ) ) ).

% insort_remove1
tff(fact_4800_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list(list(A)),I2: nat,J2: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs))))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J2),aa(list(list(A)),nat,size_size(list(list(A))),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_aju(nat,fun(list(A),bool),I2)),Xs))))
         => ( aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),transpose(A,Xs)),I2)),J2) = aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),Xs),J2)),I2) ) ) ) ) ).

% nth_nth_transpose_sorted
tff(fact_4801_transpose__column,axiom,
    ! [A: $tType,Xs: list(list(A)),I2: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(list(A)),nat,size_size(list(list(A))),Xs)))
       => ( aa(list(list(A)),list(A),map(list(A),A,aTP_Lamp_ajt(nat,fun(list(A),A),I2)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_aju(nat,fun(list(A),bool),I2)),transpose(A,Xs))) = aa(nat,list(A),nth(list(A),Xs),I2) ) ) ) ).

% transpose_column
tff(fact_4802_transpose__column__length,axiom,
    ! [A: $tType,Xs: list(list(A)),I2: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(list(A)),nat,size_size(list(list(A))),Xs)))
       => ( aa(list(list(A)),nat,size_size(list(list(A))),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_aju(nat,fun(list(A),bool),I2)),transpose(A,Xs))) = aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),I2)) ) ) ) ).

% transpose_column_length
tff(fact_4803_sum__list__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Xs: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),rev(A,Xs)) = aa(list(A),A,groups8242544230860333062m_list(A),Xs) ) ) ).

% sum_list_rev
tff(fact_4804_sorted__wrt__rev__linord,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: list(A)] :
          ( sorted_wrt(A,aTP_Lamp_pz(A,fun(A,bool)),L)
        <=> sorted_wrt(A,ord_less_eq(A),rev(A,L)) ) ) ).

% sorted_wrt_rev_linord
tff(fact_4805_sorted__wrt__map__rev__linord,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [L: list(product_prod(A,B))] :
          ( sorted_wrt(product_prod(A,B),aTP_Lamp_all(product_prod(A,B),fun(product_prod(A,B),bool)),L)
        <=> sorted_wrt(A,ord_less_eq(A),rev(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),L))) ) ) ).

% sorted_wrt_map_rev_linord
tff(fact_4806_sorted__wrt__rev,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),Xs: list(A)] :
      ( sorted_wrt(A,P,rev(A,Xs))
    <=> sorted_wrt(A,aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),P),Xs) ) ).

% sorted_wrt_rev
tff(fact_4807_foldr__conv__foldl,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,fun(A,A)),Xs: list(B),A4: A] : ( aa(A,A,foldr(B,A,F2,Xs),A4) = foldl(A,B,aTP_Lamp_aln(fun(B,fun(A,A)),fun(A,fun(B,A)),F2),A4,rev(B,Xs)) ) ).

% foldr_conv_foldl
tff(fact_4808_foldl__conv__foldr,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(B,A)),A4: A,Xs: list(B)] : ( foldl(A,B,F2,A4,Xs) = aa(A,A,foldr(B,A,aTP_Lamp_alo(fun(A,fun(B,A)),fun(B,fun(A,A)),F2),rev(B,Xs)),A4) ) ).

% foldl_conv_foldr
tff(fact_4809_remove__rev__alt__def,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( remove_rev(A,X2,Xs) = aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),aTP_Lamp_rz(A,fun(A,bool)),X2)),rev(A,Xs)) ) ).

% remove_rev_alt_def
tff(fact_4810_nths__def,axiom,
    ! [A: $tType,Xs: list(A),A3: set(nat)] : ( nths(A,Xs,A3) = aa(list(product_prod(A,nat)),list(A),map(product_prod(A,nat),A,product_fst(A,nat)),aa(list(product_prod(A,nat)),list(product_prod(A,nat)),filter2(product_prod(A,nat),aTP_Lamp_alp(set(nat),fun(product_prod(A,nat),bool),A3)),zip(A,nat,Xs,upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))))) ) ).

% nths_def
tff(fact_4811_nths__shift__lemma,axiom,
    ! [A: $tType,A3: set(nat),Xs: list(A),I2: nat] : ( aa(list(product_prod(A,nat)),list(A),map(product_prod(A,nat),A,product_fst(A,nat)),aa(list(product_prod(A,nat)),list(product_prod(A,nat)),filter2(product_prod(A,nat),aTP_Lamp_alp(set(nat),fun(product_prod(A,nat),bool),A3)),zip(A,nat,Xs,upt(I2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),aa(list(A),nat,size_size(list(A)),Xs)))))) = aa(list(product_prod(A,nat)),list(A),map(product_prod(A,nat),A,product_fst(A,nat)),aa(list(product_prod(A,nat)),list(product_prod(A,nat)),filter2(product_prod(A,nat),aa(nat,fun(product_prod(A,nat),bool),aTP_Lamp_alq(set(nat),fun(nat,fun(product_prod(A,nat),bool)),A3),I2)),zip(A,nat,Xs,upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))))) ) ).

% nths_shift_lemma
tff(fact_4812_sum__list__upt,axiom,
    ! [M2: nat,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
     => ( aa(list(nat),nat,groups8242544230860333062m_list(nat),upt(M2,N)) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vy(nat,nat)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% sum_list_upt
tff(fact_4813_map__add__upt_H,axiom,
    ! [Ofs: nat,A4: nat,B3: nat] : ( aa(list(nat),list(nat),map(nat,nat,aTP_Lamp_alr(nat,fun(nat,nat),Ofs)),upt(A4,B3)) = upt(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),Ofs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),B3),Ofs)) ) ).

% map_add_upt'
tff(fact_4814_upt__filter__extend,axiom,
    ! [U: nat,U4: nat,P: fun(nat,bool)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),U),U4))
     => ( ! [I3: nat] :
            ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),U),I3))
              & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),U4)) )
           => ~ pp(aa(nat,bool,P,I3)) )
       => ( aa(list(nat),list(nat),filter2(nat,P),upt(zero_zero(nat),U)) = aa(list(nat),list(nat),filter2(nat,P),upt(zero_zero(nat),U4)) ) ) ) ).

% upt_filter_extend
tff(fact_4815_interv__sum__list__conv__sum__set__nat,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [F2: fun(nat,B),M2: nat,N: nat] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(nat),list(B),map(nat,B,F2),upt(M2,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),F2),aa(list(nat),set(nat),set2(nat),upt(M2,N))) ) ) ).

% interv_sum_list_conv_sum_set_nat
tff(fact_4816_sum__set__upt__conv__sum__list__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),M2: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),aa(list(nat),set(nat),set2(nat),upt(M2,N))) = aa(list(A),A,groups8242544230860333062m_list(A),aa(list(nat),list(A),map(nat,A,F2),upt(M2,N))) ) ) ).

% sum_set_upt_conv_sum_list_nat
tff(fact_4817_map__add__upt,axiom,
    ! [N: nat,M2: nat] : ( aa(list(nat),list(nat),map(nat,nat,aTP_Lamp_alr(nat,fun(nat,nat),N)),upt(zero_zero(nat),M2)) = upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),N)) ) ).

% map_add_upt
tff(fact_4818_map__upt__Suc,axiom,
    ! [A: $tType,F2: fun(nat,A),N: nat] : ( aa(list(nat),list(A),map(nat,A,F2),upt(zero_zero(nat),aa(nat,nat,suc,N))) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),aa(nat,A,F2,zero_zero(nat))),aa(list(nat),list(A),map(nat,A,aTP_Lamp_xk(fun(nat,A),fun(nat,A),F2)),upt(zero_zero(nat),N))) ) ).

% map_upt_Suc
tff(fact_4819_map__nth,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(nat),list(A),map(nat,A,nth(A,Xs)),upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) = Xs ) ).

% map_nth
tff(fact_4820_map__decr__upt,axiom,
    ! [M2: nat,N: nat] : ( aa(list(nat),list(nat),map(nat,nat,aTP_Lamp_sx(nat,nat)),upt(aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = upt(M2,N) ) ).

% map_decr_upt
tff(fact_4821_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list(list(A)),N: nat] :
      ( ( ( Xs = nil(list(A)) )
       => ( N = zero_zero(nat) ) )
     => ( ! [I3: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),aa(list(list(A)),nat,size_size(list(list(A))),Xs)))
           => ( aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),I3)) = N ) )
       => ( transpose(A,Xs) = aa(list(nat),list(list(A)),map(nat,list(A),aTP_Lamp_alt(list(list(A)),fun(nat,list(A)),Xs)),upt(zero_zero(nat),N)) ) ) ) ).

% transpose_rectangle
tff(fact_4822_transpose__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( transpose(A,transpose(A,Xs)) = takeWhile(list(A),aTP_Lamp_ail(list(A),bool),Xs) ) ) ).

% transpose_transpose
tff(fact_4823_sorted__find__Min,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),P: fun(A,bool)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( ? [X4: A] :
                ( pp(aa(set(A),bool,member(A,X4),aa(list(A),set(A),set2(A),Xs)))
                & pp(aa(A,bool,P,X4)) )
           => ( find(A,P,Xs) = aa(A,option(A),some(A),aa(set(A),A,lattic643756798350308766er_Min(A),aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_alu(list(A),fun(fun(A,bool),fun(A,bool)),Xs),P)))) ) ) ) ) ).

% sorted_find_Min
tff(fact_4824_extract__Cons__code,axiom,
    ! [A: $tType,P: fun(A,bool),X2: A,Xs: list(A)] :
      ( ( pp(aa(A,bool,P,X2))
       => ( extract(A,P,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),nil(A)),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),X2),Xs))) ) )
      & ( ~ pp(aa(A,bool,P,X2))
       => ( extract(A,P,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = case_option(option(product_prod(list(A),product_prod(A,list(A)))),product_prod(list(A),product_prod(A,list(A))),none(product_prod(list(A),product_prod(A,list(A)))),aa(fun(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))))),fun(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A))))),product_case_prod(list(A),product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A))))),aTP_Lamp_alw(A,fun(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))))),X2)),extract(A,P,Xs)) ) ) ) ).

% extract_Cons_code
tff(fact_4825_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Xs: list(B),T3: A] :
          ( sorted_wrt(A,ord_less_eq(A),rev(A,aa(list(B),list(A),map(B,A,F2),Xs)))
         => ( aa(list(B),list(B),filter2(B,aa(A,fun(B,bool),aTP_Lamp_akp(fun(B,A),fun(A,fun(B,bool)),F2),T3)),Xs) = takeWhile(B,aa(A,fun(B,bool),aTP_Lamp_akp(fun(B,A),fun(A,fun(B,bool)),F2),T3),Xs) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
tff(fact_4826_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [A4: B,Xs: list(B),F2: fun(B,A)] :
          ( pp(aa(set(B),bool,member(B,A4),aa(list(B),set(B),set2(B),Xs)))
         => ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),Xs))
           => ( ( aa(list(B),B,hd(B),aa(list(B),list(B),filter2(B,aa(fun(B,A),fun(B,bool),aTP_Lamp_alx(B,fun(fun(B,A),fun(B,bool)),A4),F2)),Xs)) = A4 )
             => ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F2),A4),remove1(B,A4,Xs)) = Xs ) ) ) ) ) ).

% insort_key_remove1
tff(fact_4827_map__of__distinct__upd,axiom,
    ! [A: $tType,B: $tType,X2: A,Xs: list(product_prod(A,B)),Y: B] :
      ( ~ pp(aa(set(A),bool,member(A,X2),aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))))
     => ( map_add(A,B,fun_upd(A,option(B),aTP_Lamp_abe(A,option(B)),X2,aa(B,option(B),some(B),Y)),map_of(A,B,Xs)) = fun_upd(A,option(B),map_of(A,B,Xs),X2,aa(B,option(B),some(B),Y)) ) ) ).

% map_of_distinct_upd
tff(fact_4828_empty__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list(product_prod(A,B))] :
      ( ( aTP_Lamp_abe(A,option(B)) = map_of(A,B,Xys) )
    <=> ( Xys = nil(product_prod(A,B)) ) ) ).

% empty_eq_map_of_iff
tff(fact_4829_hd__def,axiom,
    ! [A: $tType,List: list(A)] : ( aa(list(A),A,hd(A),List) = aa(list(A),A,case_list(A,A,undefined(A),aTP_Lamp_aly(A,fun(list(A),A))),List) ) ).

% hd_def
tff(fact_4830_list_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H2: fun(B,C),F1: B,F22: fun(A,fun(list(A),B)),List: list(A)] : ( aa(B,C,H2,aa(list(A),B,case_list(B,A,F1,F22),List)) = aa(list(A),C,case_list(C,A,aa(B,C,H2,F1),aa(fun(A,fun(list(A),B)),fun(A,fun(list(A),C)),aTP_Lamp_alz(fun(B,C),fun(fun(A,fun(list(A),B)),fun(A,fun(list(A),C))),H2),F22)),List) ) ).

% list.case_distrib
tff(fact_4831_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_ama(A,fun(list(A),list(A))))),Xss)) = aa(list(list(A)),list(A),map(list(A),A,hd(A)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_ail(list(A),bool)),Xss)) ) ).

% transpose_aux_filter_head
tff(fact_4832_map__add__map__of__foldr,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B)),Ps: list(product_prod(A,B))] : ( map_add(A,B,M2,map_of(A,B,Ps)) = aa(fun(A,option(B)),fun(A,option(B)),foldr(product_prod(A,B),fun(A,option(B)),aa(fun(A,fun(B,fun(fun(A,option(B)),fun(A,option(B))))),fun(product_prod(A,B),fun(fun(A,option(B)),fun(A,option(B)))),product_case_prod(A,B,fun(fun(A,option(B)),fun(A,option(B)))),aTP_Lamp_amb(A,fun(B,fun(fun(A,option(B)),fun(A,option(B)))))),Ps),M2) ) ).

% map_add_map_of_foldr
tff(fact_4833_map__of__concat,axiom,
    ! [B: $tType,A: $tType,Xss: list(list(product_prod(A,B)))] : ( map_of(A,B,concat(product_prod(A,B),Xss)) = aa(fun(A,option(B)),fun(A,option(B)),foldr(list(product_prod(A,B)),fun(A,option(B)),aTP_Lamp_amc(list(product_prod(A,B)),fun(fun(A,option(B)),fun(A,option(B)))),Xss),aTP_Lamp_abe(A,option(B))) ) ).

% map_of_concat
tff(fact_4834_map__of__map__keys,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),M2: fun(A,option(B))] :
      ( ( aa(list(A),set(A),set2(A),Xs) = dom(A,B,M2) )
     => ( map_of(A,B,aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aTP_Lamp_acz(fun(A,option(B)),fun(A,product_prod(A,B)),M2)),Xs)) = M2 ) ) ).

% map_of_map_keys
tff(fact_4835_map__of__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: fun(C,B),Xs: list(product_prod(A,C))] : ( map_of(A,B,aa(list(product_prod(A,C)),list(product_prod(A,B)),map(product_prod(A,C),product_prod(A,B),aa(fun(A,fun(C,product_prod(A,B))),fun(product_prod(A,C),product_prod(A,B)),product_case_prod(A,C,product_prod(A,B)),aTP_Lamp_aka(fun(C,B),fun(A,fun(C,product_prod(A,B))),F2))),Xs)) = aa(fun(A,option(C)),fun(A,option(B)),comp(option(C),option(B),A,map_option(C,B,F2)),map_of(A,C,Xs)) ) ).

% map_of_map
tff(fact_4836_transpose_Oelims,axiom,
    ! [A: $tType,X2: list(list(A)),Y: list(list(A))] :
      ( ( transpose(A,X2) = Y )
     => ( ( ( X2 = nil(list(A)) )
         => ( Y != nil(list(A)) ) )
       => ( ! [Xss2: list(list(A))] :
              ( ( X2 = aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),nil(A)),Xss2) )
             => ( Y != transpose(A,Xss2) ) )
         => ~ ! [X: A,Xs2: list(A),Xss2: list(list(A))] :
                ( ( X2 = aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2)),Xss2) )
               => ( Y != aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_ama(A,fun(list(A),list(A))))),Xss2)))),transpose(A,aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),Xs2),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_amd(A,fun(list(A),list(list(A)))))),Xss2))))) ) ) ) ) ) ).

% transpose.elims
tff(fact_4837_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Xss: list(list(A))] : ( transpose(A,aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)),Xss)) = aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_ama(A,fun(list(A),list(A))))),Xss)))),transpose(A,aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),Xs),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_amd(A,fun(list(A),list(list(A)))))),Xss))))) ) ).

% transpose.simps(3)
tff(fact_4838_set__map__of__compr,axiom,
    ! [B: $tType,A: $tType,Xs: list(product_prod(A,B))] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))
     => ( aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xs) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_ame(list(product_prod(A,B)),fun(A,fun(B,bool)),Xs))) ) ) ).

% set_map_of_compr
tff(fact_4839_map__of__mapk__SomeI,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(A,B),T3: list(product_prod(A,C)),K: A,X2: C] :
      ( inj_on(A,B,F2,top_top(set(A)))
     => ( ( aa(A,option(C),map_of(A,C,T3),K) = aa(C,option(C),some(C),X2) )
       => ( aa(B,option(C),map_of(B,C,aa(list(product_prod(A,C)),list(product_prod(B,C)),map(product_prod(A,C),product_prod(B,C),aa(fun(A,fun(C,product_prod(B,C))),fun(product_prod(A,C),product_prod(B,C)),product_case_prod(A,C,product_prod(B,C)),aTP_Lamp_amf(fun(A,B),fun(A,fun(C,product_prod(B,C))),F2))),T3)),aa(A,B,F2,K)) = aa(C,option(C),some(C),X2) ) ) ) ).

% map_of_mapk_SomeI
tff(fact_4840_map__of__map__restrict,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),Ks: list(A)] : ( map_of(A,B,aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aTP_Lamp_dm(fun(A,B),fun(A,product_prod(A,B)),F2)),Ks)) = restrict_map(A,B,aa(fun(A,B),fun(A,option(B)),comp(B,option(B),A,some(B)),F2),aa(list(A),set(A),set2(A),Ks)) ) ).

% map_of_map_restrict
tff(fact_4841_min__list_Oelims,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X2: list(A),Y: A] :
          ( ( min_list(A,X2) = Y )
         => ( ! [X: A,Xs2: list(A)] :
                ( ( X2 = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2) )
               => ( Y != aa(list(A),A,case_list(A,A,X,aa(list(A),fun(A,fun(list(A),A)),aTP_Lamp_amg(A,fun(list(A),fun(A,fun(list(A),A))),X),Xs2)),Xs2) ) )
           => ~ ( ( X2 = nil(A) )
               => ( Y != undefined(A) ) ) ) ) ) ).

% min_list.elims
tff(fact_4842_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_amd(A,fun(list(A),list(list(A)))))),Xss)) = aa(list(list(A)),list(list(A)),map(list(A),list(A),tl(A)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_ail(list(A),bool)),Xss)) ) ).

% transpose_aux_filter_tail
tff(fact_4843_transpose_Opelims,axiom,
    ! [A: $tType,X2: list(list(A)),Y: list(list(A))] :
      ( ( transpose(A,X2) = Y )
     => ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),X2))
       => ( ( ( X2 = nil(list(A)) )
           => ( ( Y = nil(list(A)) )
             => ~ pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),nil(list(A)))) ) )
         => ( ! [Xss2: list(list(A))] :
                ( ( X2 = aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),nil(A)),Xss2) )
               => ( ( Y = transpose(A,Xss2) )
                 => ~ pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),nil(A)),Xss2))) ) )
           => ~ ! [X: A,Xs2: list(A),Xss2: list(list(A))] :
                  ( ( X2 = aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2)),Xss2) )
                 => ( ( Y = aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_ama(A,fun(list(A),list(A))))),Xss2)))),transpose(A,aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),Xs2),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_amd(A,fun(list(A),list(list(A)))))),Xss2))))) )
                   => ~ pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2)),Xss2))) ) ) ) ) ) ) ).

% transpose.pelims
tff(fact_4844_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list(A)] :
      ( ( List = nil(A) )
    <=> pp(aa(list(A),bool,case_list(bool,A,fTrue,aTP_Lamp_amh(A,fun(list(A),bool))),List)) ) ).

% list.disc_eq_case(1)
tff(fact_4845_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list(A)] :
      ( ( List != nil(A) )
    <=> pp(aa(list(A),bool,case_list(bool,A,fFalse,aTP_Lamp_ami(A,fun(list(A),bool))),List)) ) ).

% list.disc_eq_case(2)
tff(fact_4846_tl__def,axiom,
    ! [A: $tType,List: list(A)] : ( aa(list(A),list(A),tl(A),List) = aa(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_amj(A,fun(list(A),list(A)))),List) ) ).

% tl_def
tff(fact_4847_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list(list(A)),P: fun(list(list(A)),bool)] :
      ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),A0))
     => ( ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),nil(list(A))))
         => pp(aa(list(list(A)),bool,P,nil(list(A)))) )
       => ( ! [Xss2: list(list(A))] :
              ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),nil(A)),Xss2)))
             => ( pp(aa(list(list(A)),bool,P,Xss2))
               => pp(aa(list(list(A)),bool,P,aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),nil(A)),Xss2))) ) )
         => ( ! [X: A,Xs2: list(A),Xss2: list(list(A))] :
                ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2)),Xss2)))
               => ( pp(aa(list(list(A)),bool,P,aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),Xs2),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_amd(A,fun(list(A),list(list(A)))))),Xss2)))))
                 => pp(aa(list(list(A)),bool,P,aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2)),Xss2))) ) )
           => pp(aa(list(list(A)),bool,P,A0)) ) ) ) ) ).

% transpose.pinduct
tff(fact_4848_zip__Cons1,axiom,
    ! [A: $tType,B: $tType,X2: A,Xs: list(A),Ys: list(B)] : ( zip(A,B,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs),Ys) = aa(list(B),list(product_prod(A,B)),case_list(list(product_prod(A,B)),B,nil(product_prod(A,B)),aa(list(A),fun(B,fun(list(B),list(product_prod(A,B)))),aTP_Lamp_amk(A,fun(list(A),fun(B,fun(list(B),list(product_prod(A,B))))),X2),Xs)),Ys) ) ).

% zip_Cons1
tff(fact_4849_zip__Cons,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Y: B,Ys: list(B)] : ( zip(A,B,Xs,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)) = aa(list(A),list(product_prod(A,B)),case_list(list(product_prod(A,B)),A,nil(product_prod(A,B)),aa(list(B),fun(A,fun(list(A),list(product_prod(A,B)))),aTP_Lamp_aml(B,fun(list(B),fun(A,fun(list(A),list(product_prod(A,B))))),Y),Ys)),Xs) ) ).

% zip_Cons
tff(fact_4850_min__list_Osimps,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X2: A,Xs: list(A)] : ( min_list(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(list(A),A,case_list(A,A,X2,aa(list(A),fun(A,fun(list(A),A)),aTP_Lamp_amg(A,fun(list(A),fun(A,fun(list(A),A))),X2),Xs)),Xs) ) ) ).

% min_list.simps
tff(fact_4851_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Xss: list(list(A))] :
      ( pp(aa(list(list(A)),bool,accp(list(list(A)),transpose_rel(A)),aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)),Xss)))
     => ( transpose(A,aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)),Xss)) = aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_ama(A,fun(list(A),list(A))))),Xss)))),transpose(A,aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),Xs),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_amd(A,fun(list(A),list(list(A)))))),Xss))))) ) ) ).

% transpose.psimps(3)
tff(fact_4852_min__list_Opelims,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X2: list(A),Y: A] :
          ( ( min_list(A,X2) = Y )
         => ( pp(aa(list(A),bool,accp(list(A),min_list_rel(A)),X2))
           => ( ! [X: A,Xs2: list(A)] :
                  ( ( X2 = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2) )
                 => ( ( Y = aa(list(A),A,case_list(A,A,X,aa(list(A),fun(A,fun(list(A),A)),aTP_Lamp_amg(A,fun(list(A),fun(A,fun(list(A),A))),X),Xs2)),Xs2) )
                   => ~ pp(aa(list(A),bool,accp(list(A),min_list_rel(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2))) ) )
             => ~ ( ( X2 = nil(A) )
                 => ( ( Y = undefined(A) )
                   => ~ pp(aa(list(A),bool,accp(list(A),min_list_rel(A)),nil(A))) ) ) ) ) ) ) ).

% min_list.pelims
tff(fact_4853_extract__def,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( extract(A,P,Xs) = aa(list(A),option(product_prod(list(A),product_prod(A,list(A)))),case_list(option(product_prod(list(A),product_prod(A,list(A)))),A,none(product_prod(list(A),product_prod(A,list(A)))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_amm(fun(A,bool),fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),P),Xs)),dropWhile(A,aa(fun(A,bool),fun(A,bool),comp(bool,bool,A,fNot),P),Xs)) ) ).

% extract_def
tff(fact_4854_Bleast__code,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),P: fun(A,bool)] : ( bleast(A,aa(list(A),set(A),set2(A),Xs),P) = aa(list(A),A,case_list(A,A,abort_Bleast(A,aa(list(A),set(A),set2(A),Xs),P),aTP_Lamp_amn(A,fun(list(A),A))),aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),linorder_sort_key(A,A,aTP_Lamp_eh(A,A)),Xs))) ) ) ).

% Bleast_code
tff(fact_4855_sort__upt,axiom,
    ! [M2: nat,N: nat] : ( aa(list(nat),list(nat),linorder_sort_key(nat,nat,aTP_Lamp_vy(nat,nat)),upt(M2,N)) = upt(M2,N) ) ).

% sort_upt
tff(fact_4856_sort__key__stable,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),K: B,Xs: list(A)] : ( aa(list(A),list(A),filter2(A,aa(B,fun(A,bool),aTP_Lamp_amo(fun(A,B),fun(B,fun(A,bool)),F2),K)),aa(list(A),list(A),linorder_sort_key(A,B,F2),Xs)) = aa(list(A),list(A),filter2(A,aa(B,fun(A,bool),aTP_Lamp_amo(fun(A,B),fun(B,fun(A,bool)),F2),K)),Xs) ) ) ).

% sort_key_stable
tff(fact_4857_sort__key__const,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [C2: B,Xs: list(A)] : ( aa(list(A),list(A),linorder_sort_key(A,B,aTP_Lamp_amp(B,fun(A,B),C2)),Xs) = Xs ) ) ).

% sort_key_const
tff(fact_4858_sorted__sort__id,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( aa(list(A),list(A),linorder_sort_key(A,A,aTP_Lamp_eh(A,A)),Xs) = Xs ) ) ) ).

% sorted_sort_id
tff(fact_4859_sorted__sort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] : sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),linorder_sort_key(A,A,aTP_Lamp_eh(A,A)),Xs)) ) ).

% sorted_sort
tff(fact_4860_find__dropWhile,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( find(A,P,Xs) = aa(list(A),option(A),case_list(option(A),A,none(A),aTP_Lamp_amq(A,fun(list(A),option(A)))),dropWhile(A,aa(fun(A,bool),fun(A,bool),comp(bool,bool,A,fNot),P),Xs)) ) ).

% find_dropWhile
tff(fact_4861_sorted__list__of__set__sort__remdups,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] : ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(list(A),set(A),set2(A),Xs)) = aa(list(A),list(A),linorder_sort_key(A,A,aTP_Lamp_eh(A,A)),aa(list(A),list(A),remdups(A),Xs)) ) ) ).

% sorted_list_of_set_sort_remdups
tff(fact_4862_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( distinct(A,Xs)
     => ( pp(aa(set(A),bool,member(A,X2),aa(list(A),set(A),set2(A),Xs)))
       => ( dropWhile(A,aa(A,fun(A,bool),aTP_Lamp_rz(A,fun(A,bool)),X2),rev(A,Xs)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),rev(A,takeWhile(A,aa(A,fun(A,bool),aTP_Lamp_rz(A,fun(A,bool)),X2),Xs))) ) ) ) ).

% dropWhile_neq_rev
tff(fact_4863_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( distinct(A,Xs)
     => ( pp(aa(set(A),bool,member(A,X2),aa(list(A),set(A),set2(A),Xs)))
       => ( takeWhile(A,aa(A,fun(A,bool),aTP_Lamp_rz(A,fun(A,bool)),X2),rev(A,Xs)) = rev(A,aa(list(A),list(A),tl(A),dropWhile(A,aa(A,fun(A,bool),aTP_Lamp_rz(A,fun(A,bool)),X2),Xs))) ) ) ) ).

% takeWhile_neq_rev
tff(fact_4864_sort__key__by__quicksort__code,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Xs: list(B)] : ( aa(list(B),list(B),linorder_sort_key(B,A,F2),Xs) = aa(list(B),list(B),case_list(list(B),B,nil(B),aa(list(B),fun(B,fun(list(B),list(B))),aTP_Lamp_amv(fun(B,A),fun(list(B),fun(B,fun(list(B),list(B)))),F2),Xs)),Xs) ) ) ).

% sort_key_by_quicksort_code
tff(fact_4865_remdup__sort__mergesort__remdups,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( aa(fun(list(A),list(A)),fun(list(A),list(A)),comp(list(A),list(A),list(A),remdups(A)),linorder_sort_key(A,A,aTP_Lamp_eh(A,A))) = mergesort_remdups(A) ) ) ).

% remdup_sort_mergesort_remdups
tff(fact_4866_sort__key__by__quicksort,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Xs: list(B)] : ( aa(list(B),list(B),linorder_sort_key(B,A,F2),Xs) = append(B,aa(list(B),list(B),linorder_sort_key(B,A,F2),aa(list(B),list(B),filter2(B,aa(list(B),fun(B,bool),aTP_Lamp_amw(fun(B,A),fun(list(B),fun(B,bool)),F2),Xs)),Xs)),append(B,aa(list(B),list(B),filter2(B,aa(list(B),fun(B,bool),aTP_Lamp_amx(fun(B,A),fun(list(B),fun(B,bool)),F2),Xs)),Xs),aa(list(B),list(B),linorder_sort_key(B,A,F2),aa(list(B),list(B),filter2(B,aa(list(B),fun(B,bool),aTP_Lamp_amy(fun(B,A),fun(list(B),fun(B,bool)),F2),Xs)),Xs)))) ) ) ).

% sort_key_by_quicksort
tff(fact_4867_sum__list__append,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A),Ys: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),append(A,Xs,Ys)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),Xs)),aa(list(A),A,groups8242544230860333062m_list(A),Ys)) ) ) ).

% sum_list_append
tff(fact_4868_distinct__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( distinct(A,append(A,Xs,Ys))
    <=> ( distinct(A,Xs)
        & distinct(A,Ys)
        & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) ) ) ) ).

% distinct_append
tff(fact_4869_tl__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : ( aa(list(A),list(A),tl(A),append(A,Xs,Ys)) = aa(list(A),list(A),case_list(list(A),A,aa(list(A),list(A),tl(A),Ys),aTP_Lamp_amz(list(A),fun(A,fun(list(A),list(A))),Ys)),Xs) ) ).

% tl_append
tff(fact_4870_map__by__foldl,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),L: list(A)] : ( foldl(list(B),A,aTP_Lamp_ana(fun(A,B),fun(list(B),fun(A,list(B))),F2),nil(B),L) = aa(list(A),list(B),map(A,B,F2),L) ) ).

% map_by_foldl
tff(fact_4871_takeWhile__append,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool),Ys: list(A)] :
      ( ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),aa(list(A),set(A),set2(A),Xs)))
           => pp(aa(A,bool,P,X)) )
       => ( takeWhile(A,P,append(A,Xs,Ys)) = append(A,Xs,takeWhile(A,P,Ys)) ) )
      & ( ~ ! [X4: A] :
              ( pp(aa(set(A),bool,member(A,X4),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(A,bool,P,X4)) )
       => ( takeWhile(A,P,append(A,Xs,Ys)) = takeWhile(A,P,Xs) ) ) ) ).

% takeWhile_append
tff(fact_4872_dropWhile__append,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool),Ys: list(A)] :
      ( ( ! [X: A] :
            ( pp(aa(set(A),bool,member(A,X),aa(list(A),set(A),set2(A),Xs)))
           => pp(aa(A,bool,P,X)) )
       => ( dropWhile(A,P,append(A,Xs,Ys)) = dropWhile(A,P,Ys) ) )
      & ( ~ ! [X4: A] :
              ( pp(aa(set(A),bool,member(A,X4),aa(list(A),set(A),set2(A),Xs)))
             => pp(aa(A,bool,P,X4)) )
       => ( dropWhile(A,P,append(A,Xs,Ys)) = append(A,dropWhile(A,P,Xs),Ys) ) ) ) ).

% dropWhile_append
tff(fact_4873_nths__append,axiom,
    ! [A: $tType,L: list(A),L4: list(A),A3: set(nat)] : ( nths(A,append(A,L,L4),A3) = append(A,nths(A,L,A3),nths(A,L4,aa(fun(nat,bool),set(nat),collect(nat),aa(set(nat),fun(nat,bool),aTP_Lamp_anb(list(A),fun(set(nat),fun(nat,bool)),L),A3)))) ) ).

% nths_append
tff(fact_4874_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F2: fun(B,A),A4: A,Xs: list(B),Ys: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A4),append(B,Xs,Ys)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A4),Xs)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A4),aa(list(B),nat,size_size(list(B)),Xs))),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A4),Ys))) ) ) ).

% horner_sum_append
tff(fact_4875_nths__Cons,axiom,
    ! [A: $tType,X2: A,L: list(A),A3: set(nat)] : ( nths(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),L),A3) = append(A,if(list(A),aa(set(nat),bool,member(nat,zero_zero(nat)),A3),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A)),nil(A)),nths(A,L,aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_anc(set(nat),fun(nat,bool),A3)))) ) ).

% nths_Cons
tff(fact_4876_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),A4: A] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),aa(list(A),set(A),set2(A),Xs)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),A4)) )
           => ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),A4),Xs) = append(A,Xs,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A4),nil(A))) ) ) ) ) ).

% sorted_insort_is_snoc
tff(fact_4877_filter__upt__last,axiom,
    ! [A: $tType,P: fun(A,bool),L: list(A),Js: list(nat),J2: nat,I2: nat] :
      ( ( aa(list(nat),list(nat),filter2(nat,aa(list(A),fun(nat,bool),aTP_Lamp_and(fun(A,bool),fun(list(A),fun(nat,bool)),P),L)),upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),L))) = append(nat,Js,aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),J2),nil(nat))) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),J2),I2))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),L)))
         => ~ pp(aa(A,bool,P,aa(nat,A,nth(A,L),I2))) ) ) ) ).

% filter_upt_last
tff(fact_4878_sort__by__quicksort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] : ( aa(list(A),list(A),linorder_sort_key(A,A,aTP_Lamp_eh(A,A)),Xs) = append(A,aa(list(A),list(A),linorder_sort_key(A,A,aTP_Lamp_eh(A,A)),aa(list(A),list(A),filter2(A,aTP_Lamp_ane(list(A),fun(A,bool),Xs)),Xs)),append(A,aa(list(A),list(A),filter2(A,aTP_Lamp_anf(list(A),fun(A,bool),Xs)),Xs),aa(list(A),list(A),linorder_sort_key(A,A,aTP_Lamp_eh(A,A)),aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),ord_less(A),aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),Xs)))) ) ) ).

% sort_by_quicksort
tff(fact_4879_lexn__conv,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),N: nat] : ( aa(nat,set(product_prod(list(A),list(A))),lexn(A,R2),N) = aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aa(nat,fun(list(A),fun(list(A),bool)),aTP_Lamp_ang(set(product_prod(A,A)),fun(nat,fun(list(A),fun(list(A),bool))),R2),N))) ) ).

% lexn_conv
tff(fact_4880_lex__conv,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lex(A,R2) = aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_anh(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R2))) ) ).

% lex_conv
tff(fact_4881_subset__eq__mset__impl_Oelims,axiom,
    ! [A: $tType,X2: list(A),Xa: list(A),Y: option(bool)] :
      ( ( subset_eq_mset_impl(A,X2,Xa) = Y )
     => ( ( ( X2 = nil(A) )
         => ( Y != aa(bool,option(bool),some(bool),aa(bool,bool,fNot,aa(list(A),bool,aa(list(A),fun(list(A),bool),fequal(list(A)),Xa),nil(A)))) ) )
       => ~ ! [X: A,Xs2: list(A)] :
              ( ( X2 = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2) )
             => ( Y != case_option(option(bool),product_prod(list(A),product_prod(A,list(A))),none(bool),aa(fun(list(A),fun(product_prod(A,list(A)),option(bool))),fun(product_prod(list(A),product_prod(A,list(A))),option(bool)),product_case_prod(list(A),product_prod(A,list(A)),option(bool)),aTP_Lamp_anj(list(A),fun(list(A),fun(product_prod(A,list(A)),option(bool))),Xs2)),extract(A,aa(A,fun(A,bool),fequal(A),X),Xa)) ) ) ) ) ).

% subset_eq_mset_impl.elims
tff(fact_4882_lex__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lex(A,R2) = aa(set(set(product_prod(list(A),list(A)))),set(product_prod(list(A),list(A))),complete_Sup_Sup(set(product_prod(list(A),list(A)))),aa(set(nat),set(set(product_prod(list(A),list(A)))),image2(nat,set(product_prod(list(A),list(A))),lexn(A,R2)),top_top(set(nat)))) ) ).

% lex_def
tff(fact_4883_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( aa(nat,set(product_prod(list(A),list(A))),lexn(A,R2),zero_zero(nat)) = bot_bot(set(product_prod(list(A),list(A)))) ) ).

% lexn.simps(1)
tff(fact_4884_subset__eq__mset__impl_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Ys: list(A)] : ( subset_eq_mset_impl(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs),Ys) = case_option(option(bool),product_prod(list(A),product_prod(A,list(A))),none(bool),aa(fun(list(A),fun(product_prod(A,list(A)),option(bool))),fun(product_prod(list(A),product_prod(A,list(A))),option(bool)),product_case_prod(list(A),product_prod(A,list(A)),option(bool)),aTP_Lamp_anj(list(A),fun(list(A),fun(product_prod(A,list(A)),option(bool))),Xs)),extract(A,aa(A,fun(A,bool),fequal(A),X2),Ys)) ) ).

% subset_eq_mset_impl.simps(2)
tff(fact_4885_subset__eq__mset__impl_Opelims,axiom,
    ! [A: $tType,X2: list(A),Xa: list(A),Y: option(bool)] :
      ( ( subset_eq_mset_impl(A,X2,Xa) = Y )
     => ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),subset751672762298770561pl_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),Xa)))
       => ( ( ( X2 = nil(A) )
           => ( ( Y = aa(bool,option(bool),some(bool),aa(bool,bool,fNot,aa(list(A),bool,aa(list(A),fun(list(A),bool),fequal(list(A)),Xa),nil(A)))) )
             => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),subset751672762298770561pl_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Xa))) ) )
         => ~ ! [X: A,Xs2: list(A)] :
                ( ( X2 = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2) )
               => ( ( Y = case_option(option(bool),product_prod(list(A),product_prod(A,list(A))),none(bool),aa(fun(list(A),fun(product_prod(A,list(A)),option(bool))),fun(product_prod(list(A),product_prod(A,list(A))),option(bool)),product_case_prod(list(A),product_prod(A,list(A)),option(bool)),aTP_Lamp_anj(list(A),fun(list(A),fun(product_prod(A,list(A)),option(bool))),Xs2)),extract(A,aa(A,fun(A,bool),fequal(A),X),Xa)) )
                 => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),subset751672762298770561pl_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2)),Xa))) ) ) ) ) ) ).

% subset_eq_mset_impl.pelims
tff(fact_4886_lenlex__conv,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lenlex(A,R2) = aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_ank(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R2))) ) ).

% lenlex_conv
tff(fact_4887_quicksort_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Xs: list(A)] : ( aa(list(A),list(A),linorder_quicksort(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = append(A,aa(list(A),list(A),linorder_quicksort(A),aa(list(A),list(A),filter2(A,aTP_Lamp_anl(A,fun(A,bool),X2)),Xs)),append(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A)),aa(list(A),list(A),linorder_quicksort(A),aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),ord_less_eq(A),X2)),Xs)))) ) ) ).

% quicksort.simps(2)
tff(fact_4888_sort__quicksort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( linorder_sort_key(A,A,aTP_Lamp_eh(A,A)) = linorder_quicksort(A) ) ) ).

% sort_quicksort
tff(fact_4889_quicksort_Oelims,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: list(A),Y: list(A)] :
          ( ( aa(list(A),list(A),linorder_quicksort(A),X2) = Y )
         => ( ( ( X2 = nil(A) )
             => ( Y != nil(A) ) )
           => ~ ! [X: A,Xs2: list(A)] :
                  ( ( X2 = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2) )
                 => ( Y != append(A,aa(list(A),list(A),linorder_quicksort(A),aa(list(A),list(A),filter2(A,aTP_Lamp_anl(A,fun(A,bool),X)),Xs2)),append(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),nil(A)),aa(list(A),list(A),linorder_quicksort(A),aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),ord_less_eq(A),X)),Xs2)))) ) ) ) ) ) ).

% quicksort.elims
tff(fact_4890_quicksort_Opelims,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: list(A),Y: list(A)] :
          ( ( aa(list(A),list(A),linorder_quicksort(A),X2) = Y )
         => ( pp(aa(list(A),bool,accp(list(A),linord6200660962353139674rt_rel(A)),X2))
           => ( ( ( X2 = nil(A) )
               => ( ( Y = nil(A) )
                 => ~ pp(aa(list(A),bool,accp(list(A),linord6200660962353139674rt_rel(A)),nil(A))) ) )
             => ~ ! [X: A,Xs2: list(A)] :
                    ( ( X2 = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2) )
                   => ( ( Y = append(A,aa(list(A),list(A),linorder_quicksort(A),aa(list(A),list(A),filter2(A,aTP_Lamp_anl(A,fun(A,bool),X)),Xs2)),append(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),nil(A)),aa(list(A),list(A),linorder_quicksort(A),aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),ord_less_eq(A),X)),Xs2)))) )
                     => ~ pp(aa(list(A),bool,accp(list(A),linord6200660962353139674rt_rel(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2))) ) ) ) ) ) ) ).

% quicksort.pelims
tff(fact_4891_shuffles_Opelims,axiom,
    ! [A: $tType,X2: list(A),Xa: list(A),Y: set(list(A))] :
      ( ( shuffles(A,X2,Xa) = Y )
     => ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),Xa)))
       => ( ( ( X2 = nil(A) )
           => ( ( Y = aa(set(list(A)),set(list(A)),insert(list(A),Xa),bot_bot(set(list(A)))) )
             => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Xa))) ) )
         => ( ( ( Xa = nil(A) )
             => ( ( Y = aa(set(list(A)),set(list(A)),insert(list(A),X2),bot_bot(set(list(A)))) )
               => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),nil(A)))) ) )
           => ~ ! [X: A,Xs2: list(A)] :
                  ( ( X2 = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2) )
                 => ! [Y2: A,Ys3: list(A)] :
                      ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys3) )
                     => ( ( Y = aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),sup_sup(set(list(A))),aa(set(list(A)),set(list(A)),image2(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X)),shuffles(A,Xs2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys3)))),aa(set(list(A)),set(list(A)),image2(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2)),shuffles(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2),Ys3))) )
                       => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys3)))) ) ) ) ) ) ) ) ).

% shuffles.pelims
tff(fact_4892_shuffles_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ys)))
     => ( shuffles(A,nil(A),Ys) = aa(set(list(A)),set(list(A)),insert(list(A),Ys),bot_bot(set(list(A)))) ) ) ).

% shuffles.psimps(1)
tff(fact_4893_shuffles_Opsimps_I2_J,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),nil(A))))
     => ( shuffles(A,Xs,nil(A)) = aa(set(list(A)),set(list(A)),insert(list(A),Xs),bot_bot(set(list(A)))) ) ) ).

% shuffles.psimps(2)
tff(fact_4894_inv__image__partition,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool),Ys: list(A)] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,P,X)) )
     => ( ! [Y2: A] :
            ( pp(aa(set(A),bool,member(A,Y2),aa(list(A),set(A),set2(A),Ys)))
           => ~ pp(aa(A,bool,P,Y2)) )
       => ( aa(set(product_prod(list(A),list(A))),set(list(A)),aa(fun(list(A),product_prod(list(A),list(A))),fun(set(product_prod(list(A),list(A))),set(list(A))),vimage(list(A),product_prod(list(A),list(A))),partition(A,P)),aa(set(product_prod(list(A),list(A))),set(product_prod(list(A),list(A))),insert(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),bot_bot(set(product_prod(list(A),list(A)))))) = shuffles(A,Xs,Ys) ) ) ) ).

% inv_image_partition
tff(fact_4895_mergesort__remdups__def,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] : ( aa(list(A),list(A),mergesort_remdups(A),Xs) = merge_list(A,nil(list(A)),aa(list(A),list(list(A)),map(A,list(A),aTP_Lamp_anm(A,list(A))),Xs)) ) ) ).

% mergesort_remdups_def
tff(fact_4896_lexord__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lexord(A,R2) = aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_ann(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R2))) ) ).

% lexord_def
tff(fact_4897_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,bool),X2: A,Xs: list(A)] : ( aa(list(A),product_prod(list(A),list(A)),partition(A,P),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(product_prod(list(A),list(A)),product_prod(list(A),list(A)),aa(fun(list(A),fun(list(A),product_prod(list(A),list(A)))),fun(product_prod(list(A),list(A)),product_prod(list(A),list(A))),product_case_prod(list(A),list(A),product_prod(list(A),list(A))),aa(A,fun(list(A),fun(list(A),product_prod(list(A),list(A)))),aTP_Lamp_ano(fun(A,bool),fun(A,fun(list(A),fun(list(A),product_prod(list(A),list(A))))),P),X2)),aa(list(A),product_prod(list(A),list(A)),partition(A,P),Xs)) ) ).

% partition.simps(2)
tff(fact_4898_lexordp__conv__lexord,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A)] :
          ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),ord_lexordp(A),Xs),Ys))
        <=> pp(aa(set(product_prod(list(A),list(A))),bool,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),lexord(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),ord_less(A)))))) ) ) ).

% lexordp_conv_lexord
tff(fact_4899_List_Olexordp__def,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),Xs: list(A),Ys: list(A)] :
      ( lexordp(A,R2,Xs,Ys)
    <=> pp(aa(set(product_prod(list(A),list(A))),bool,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),lexord(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2))))) ) ).

% List.lexordp_def
tff(fact_4900_Succ__def,axiom,
    ! [A: $tType,Kl: set(list(A)),Kl2: list(A)] : ( bNF_Greatest_Succ(A,Kl,Kl2) = aa(fun(A,bool),set(A),collect(A),aa(list(A),fun(A,bool),aTP_Lamp_anp(set(list(A)),fun(list(A),fun(A,bool)),Kl),Kl2)) ) ).

% Succ_def
tff(fact_4901_listrel1__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( listrel1(A,R2) = aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_anq(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R2))) ) ).

% listrel1_def
tff(fact_4902_listrel1p__def,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),Xs: list(A),Ys: list(A)] :
      ( listrel1p(A,R2,Xs,Ys)
    <=> pp(aa(set(product_prod(list(A),list(A))),bool,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),listrel1(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2))))) ) ).

% listrel1p_def
tff(fact_4903_slice__prepend,axiom,
    ! [A: $tType,I2: nat,K: nat,Xs: list(A),Ys: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I2),K))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),aa(list(A),nat,size_size(list(A)),Xs)))
       => ( slice(A,I2,K,Xs) = slice(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),aa(list(A),nat,size_size(list(A)),Ys)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(list(A),nat,size_size(list(A)),Ys)),append(A,Ys,Xs)) ) ) ) ).

% slice_prepend
tff(fact_4904_lexn_Osimps_I2_J,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),N: nat] : ( aa(nat,set(product_prod(list(A),list(A))),lexn(A,R2),aa(nat,nat,suc,N)) = aa(set(product_prod(list(A),list(A))),set(product_prod(list(A),list(A))),aa(set(product_prod(list(A),list(A))),fun(set(product_prod(list(A),list(A))),set(product_prod(list(A),list(A)))),inf_inf(set(product_prod(list(A),list(A)))),aa(set(product_prod(product_prod(A,list(A)),product_prod(A,list(A)))),set(product_prod(list(A),list(A))),image2(product_prod(product_prod(A,list(A)),product_prod(A,list(A))),product_prod(list(A),list(A)),product_map_prod(product_prod(A,list(A)),list(A),product_prod(A,list(A)),list(A),aa(fun(A,fun(list(A),list(A))),fun(product_prod(A,list(A)),list(A)),product_case_prod(A,list(A),list(A)),cons(A)),aa(fun(A,fun(list(A),list(A))),fun(product_prod(A,list(A)),list(A)),product_case_prod(A,list(A),list(A)),cons(A)))),lex_prod(A,list(A),R2,aa(nat,set(product_prod(list(A),list(A))),lexn(A,R2),N)))),aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_anr(nat,fun(list(A),fun(list(A),bool)),N)))) ) ).

% lexn.simps(2)
tff(fact_4905_map__prod__ident,axiom,
    ! [B: $tType,A: $tType,X4: product_prod(A,B)] : ( aa(product_prod(A,B),product_prod(A,B),product_map_prod(A,A,B,B,aTP_Lamp_bk(A,A),aTP_Lamp_xj(B,B)),X4) = X4 ) ).

% map_prod_ident
tff(fact_4906_case__prod__map__prod,axiom,
    ! [C: $tType,A: $tType,B: $tType,E: $tType,D: $tType,H2: fun(B,fun(C,A)),F2: fun(D,B),G: fun(E,C),X2: product_prod(D,E)] : ( aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),H2),aa(product_prod(D,E),product_prod(B,C),product_map_prod(D,B,E,C,F2,G),X2)) = aa(product_prod(D,E),A,aa(fun(D,fun(E,A)),fun(product_prod(D,E),A),product_case_prod(D,E,A),aa(fun(E,C),fun(D,fun(E,A)),aa(fun(D,B),fun(fun(E,C),fun(D,fun(E,A))),aTP_Lamp_ans(fun(B,fun(C,A)),fun(fun(D,B),fun(fun(E,C),fun(D,fun(E,A)))),H2),F2),G)),X2) ) ).

% case_prod_map_prod
tff(fact_4907_prod_Omap__ident,axiom,
    ! [B: $tType,A: $tType,T3: product_prod(A,B)] : ( aa(product_prod(A,B),product_prod(A,B),product_map_prod(A,A,B,B,aTP_Lamp_bk(A,A),aTP_Lamp_xj(B,B)),T3) = T3 ) ).

% prod.map_ident
tff(fact_4908_map__prod_Oidentity,axiom,
    ! [B: $tType,A: $tType] : ( product_map_prod(A,A,B,B,aTP_Lamp_bk(A,A),aTP_Lamp_xj(B,B)) = id(product_prod(A,B)) ) ).

% map_prod.identity
tff(fact_4909_map__prod__def,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F2: fun(A,C),G: fun(B,D)] : ( product_map_prod(A,C,B,D,F2,G) = aa(fun(A,fun(B,product_prod(C,D))),fun(product_prod(A,B),product_prod(C,D)),product_case_prod(A,B,product_prod(C,D)),aa(fun(B,D),fun(A,fun(B,product_prod(C,D))),aTP_Lamp_ant(fun(A,C),fun(fun(B,D),fun(A,fun(B,product_prod(C,D)))),F2),G)) ) ).

% map_prod_def
tff(fact_4910_case__prod__o__map__prod,axiom,
    ! [A: $tType,D: $tType,C: $tType,E: $tType,B: $tType,F2: fun(D,fun(E,C)),G1: fun(A,D),G22: fun(B,E)] : ( aa(fun(product_prod(A,B),product_prod(D,E)),fun(product_prod(A,B),C),comp(product_prod(D,E),C,product_prod(A,B),aa(fun(D,fun(E,C)),fun(product_prod(D,E),C),product_case_prod(D,E,C),F2)),product_map_prod(A,D,B,E,G1,G22)) = aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),aa(fun(B,E),fun(A,fun(B,C)),aa(fun(A,D),fun(fun(B,E),fun(A,fun(B,C))),aTP_Lamp_anu(fun(D,fun(E,C)),fun(fun(A,D),fun(fun(B,E),fun(A,fun(B,C)))),F2),G1),G22)) ) ).

% case_prod_o_map_prod
tff(fact_4911_map__prod__surj__on,axiom,
    ! [D: $tType,B: $tType,A: $tType,C: $tType,F2: fun(B,A),A3: set(B),A10: set(A),G: fun(D,C),B2: set(D),B17: set(C)] :
      ( ( aa(set(B),set(A),image2(B,A,F2),A3) = A10 )
     => ( ( aa(set(D),set(C),image2(D,C,G),B2) = B17 )
       => ( aa(set(product_prod(B,D)),set(product_prod(A,C)),image2(product_prod(B,D),product_prod(A,C),product_map_prod(B,A,D,C,F2,G)),product_Sigma(B,D,A3,aTP_Lamp_anv(set(D),fun(B,set(D)),B2))) = product_Sigma(A,C,A10,aTP_Lamp_md(set(C),fun(A,set(C)),B17)) ) ) ) ).

% map_prod_surj_on
tff(fact_4912_map__prod__inj__on,axiom,
    ! [D: $tType,B: $tType,A: $tType,C: $tType,F2: fun(A,B),A3: set(A),G: fun(C,D),B2: set(C)] :
      ( inj_on(A,B,F2,A3)
     => ( inj_on(C,D,G,B2)
       => inj_on(product_prod(A,C),product_prod(B,D),product_map_prod(A,B,C,D,F2,G),product_Sigma(A,C,A3,aTP_Lamp_md(set(C),fun(A,set(C)),B2))) ) ) ).

% map_prod_inj_on
tff(fact_4913_sort__mergesort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( linorder_sort_key(A,A,aTP_Lamp_eh(A,A)) = mergesort(A) ) ) ).

% sort_mergesort
tff(fact_4914_listrel__def,axiom,
    ! [B: $tType,A: $tType,X4: set(product_prod(A,B))] : ( listrel(A,B,X4) = aa(fun(product_prod(list(A),list(B)),bool),set(product_prod(list(A),list(B))),collect(product_prod(list(A),list(B))),aa(fun(list(A),fun(list(B),bool)),fun(product_prod(list(A),list(B)),bool),product_case_prod(list(A),list(B),bool),listrelp(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),X4)))) ) ).

% listrel_def
tff(fact_4915_size__list__conv__sum__list,axiom,
    ! [B: $tType,F2: fun(B,nat),Xs: list(B)] : ( size_list(B,F2,Xs) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(B),list(nat),map(B,nat,F2),Xs))),aa(list(B),nat,size_size(list(B)),Xs)) ) ).

% size_list_conv_sum_list
tff(fact_4916_listrelp__listrel__eq,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B)),X4: list(A),Xa3: list(B)] :
      ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),listrelp(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),R2)),X4),Xa3))
    <=> pp(aa(set(product_prod(list(A),list(B))),bool,member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),X4),Xa3)),listrel(A,B,R2))) ) ).

% listrelp_listrel_eq
tff(fact_4917_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X2: fun(A,nat),X21: A,X222: list(A)] : ( size_list(A,X2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X21),X222)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,X2,X21)),size_list(A,X2,X222))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% list.size_gen(2)
tff(fact_4918_map__snd__mk__snd,axiom,
    ! [B: $tType,A: $tType,K: A,L: list(B)] : ( aa(list(product_prod(B,A)),list(A),map(product_prod(B,A),A,product_snd(B,A)),aa(list(B),list(product_prod(B,A)),map(B,product_prod(B,A),aa(A,fun(B,product_prod(B,A)),aTP_Lamp_ei(A,fun(B,product_prod(B,A))),K)),L)) = replicate(A,aa(list(B),nat,size_size(list(B)),L),K) ) ).

% map_snd_mk_snd
tff(fact_4919_map__fst__mk__fst,axiom,
    ! [B: $tType,A: $tType,K: A,L: list(B)] : ( aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K)),L)) = replicate(A,aa(list(B),nat,size_size(list(B)),L),K) ) ).

% map_fst_mk_fst
tff(fact_4920_lists__empty,axiom,
    ! [A: $tType] : ( lists(A,bot_bot(set(A))) = aa(set(list(A)),set(list(A)),insert(list(A),nil(A)),bot_bot(set(list(A)))) ) ).

% lists_empty
tff(fact_4921_lists__Int__eq,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] : ( lists(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)) = aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),inf_inf(set(list(A))),lists(A,A3)),lists(A,B2)) ) ).

% lists_Int_eq
tff(fact_4922_set__replicate,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( N != zero_zero(nat) )
     => ( aa(list(A),set(A),set2(A),replicate(A,N,X2)) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ) ).

% set_replicate
tff(fact_4923_lists__IntI,axiom,
    ! [A: $tType,L: list(A),A3: set(A),B2: set(A)] :
      ( pp(aa(set(list(A)),bool,member(list(A),L),lists(A,A3)))
     => ( pp(aa(set(list(A)),bool,member(list(A),L),lists(A,B2)))
       => pp(aa(set(list(A)),bool,member(list(A),L),lists(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2)))) ) ) ).

% lists_IntI
tff(fact_4924_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list(B)] : ( aa(list(B),list(A),map(B,A,aa(A,fun(B,A),aTP_Lamp_cy(A,fun(B,A)),K)),Lst) = replicate(A,aa(list(B),nat,size_size(list(B)),Lst),K) ) ).

% map_replicate_const
tff(fact_4925_replicate__length__filter,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( replicate(A,aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),fequal(A),X2)),Xs)),X2) = aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),fequal(A),X2)),Xs) ) ).

% replicate_length_filter
tff(fact_4926_lists__eq__set,axiom,
    ! [A: $tType,A3: set(A)] : ( lists(A,A3) = aa(fun(list(A),bool),set(list(A)),collect(list(A)),aTP_Lamp_anw(set(A),fun(list(A),bool),A3)) ) ).

% lists_eq_set
tff(fact_4927_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat,C2: A] : ( aa(list(A),A,groups8242544230860333062m_list(A),replicate(A,N,C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),C2) ) ) ).

% sum_list_replicate
tff(fact_4928_map__replicate__trivial,axiom,
    ! [A: $tType,X2: A,I2: nat] : ( aa(list(nat),list(A),map(nat,A,aTP_Lamp_anx(A,fun(nat,A),X2)),upt(zero_zero(nat),I2)) = replicate(A,I2,X2) ) ).

% map_replicate_trivial
tff(fact_4929_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X2: A] :
      ( ( ( N = zero_zero(nat) )
       => ( aa(list(A),set(A),set2(A),replicate(A,N,X2)) = bot_bot(set(A)) ) )
      & ( ( N != zero_zero(nat) )
       => ( aa(list(A),set(A),set2(A),replicate(A,N,X2)) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ) ) ).

% set_replicate_conv_if
tff(fact_4930_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X2: A] : ( aa(list(A),set(A),set2(A),replicate(A,aa(nat,nat,suc,N),X2)) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ).

% set_replicate_Suc
tff(fact_4931_listrel__subset,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),A3: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R2),product_Sigma(A,A,A3,aTP_Lamp_cr(set(A),fun(A,set(A)),A3))))
     => pp(aa(set(product_prod(list(A),list(A))),bool,aa(set(product_prod(list(A),list(A))),fun(set(product_prod(list(A),list(A))),bool),ord_less_eq(set(product_prod(list(A),list(A)))),listrel(A,A,R2)),product_Sigma(list(A),list(A),lists(A,A3),aTP_Lamp_any(set(A),fun(list(A),set(list(A))),A3)))) ) ).

% listrel_subset
tff(fact_4932_lists__of__len__fin2,axiom,
    ! [A: $tType,P: set(A),N: nat] :
      ( pp(aa(set(A),bool,finite_finite2(A),P))
     => pp(aa(set(list(A)),bool,finite_finite2(list(A)),aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),inf_inf(set(list(A))),lists(A,P)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aTP_Lamp_anz(nat,fun(list(A),bool),N))))) ) ).

% lists_of_len_fin2
tff(fact_4933_lists__of__len__fin1,axiom,
    ! [A: $tType,P: set(A),N: nat] :
      ( pp(aa(set(A),bool,finite_finite2(A),P))
     => pp(aa(set(list(A)),bool,finite_finite2(list(A)),aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),inf_inf(set(list(A))),lists(A,P)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aTP_Lamp_aoa(nat,fun(list(A),bool),N))))) ) ).

% lists_of_len_fin1
tff(fact_4934_map__zip2,axiom,
    ! [A: $tType,B: $tType,K: A,L: list(B)] : ( aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K)),L) = zip(A,B,replicate(A,aa(list(B),nat,size_size(list(B)),L),K),L) ) ).

% map_zip2
tff(fact_4935_map__zip1,axiom,
    ! [A: $tType,B: $tType,K: B,L: list(A)] : ( aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_ej(B,fun(A,product_prod(A,B))),K)),L) = zip(A,B,L,replicate(B,aa(list(A),nat,size_size(list(A)),L),K)) ) ).

% map_zip1
tff(fact_4936_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M2: nat,A4: A] : ( enumerate(A,N,replicate(A,M2,A4)) = aa(list(nat),list(product_prod(nat,A)),map(nat,product_prod(nat,A),aTP_Lamp_aob(A,fun(nat,product_prod(nat,A)),A4)),upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M2))) ) ).

% enumerate_replicate_eq
tff(fact_4937_prod_Oset__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),Xs: list(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(list(B),set(B),set2(B),Xs)) = aa(list(A),A,groups5270119922927024881d_list(A),aa(list(B),list(A),map(B,A,G),aa(list(B),list(B),remdups(B),Xs))) ) ) ).

% prod.set_conv_list
tff(fact_4938_INF__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),Xs: list(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F2),aa(list(B),set(B),set2(B),Xs))) = aa(A,A,fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,inf_inf(A)),F2),Xs),top_top(A)) ) ) ).

% INF_set_fold
tff(fact_4939_prod__list_Orev,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Xs: list(A)] : ( aa(list(A),A,groups5270119922927024881d_list(A),rev(A,Xs)) = aa(list(A),A,groups5270119922927024881d_list(A),Xs) ) ) ).

% prod_list.rev
tff(fact_4940_prod__list_OCons,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X2: A,Xs: list(A)] : ( aa(list(A),A,groups5270119922927024881d_list(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(list(A),A,groups5270119922927024881d_list(A),Xs)) ) ) ).

% prod_list.Cons
tff(fact_4941_prod__list_ONil,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( aa(list(A),A,groups5270119922927024881d_list(A),nil(A)) = one_one(A) ) ) ).

% prod_list.Nil
tff(fact_4942_prod__list_Oappend,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Xs: list(A),Ys: list(A)] : ( aa(list(A),A,groups5270119922927024881d_list(A),append(A,Xs,Ys)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(list(A),A,groups5270119922927024881d_list(A),Xs)),aa(list(A),A,groups5270119922927024881d_list(A),Ys)) ) ) ).

% prod_list.append
tff(fact_4943_foldl__conv__fold,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(B,A)),S2: A,Xs: list(B)] : ( foldl(A,B,F2,S2,Xs) = aa(A,A,fold(B,A,aTP_Lamp_alo(fun(A,fun(B,A)),fun(B,fun(A,A)),F2),Xs),S2) ) ).

% foldl_conv_fold
tff(fact_4944_fold__filter,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,fun(A,A)),P: fun(B,bool),Xs: list(B)] : ( fold(B,A,F2,aa(list(B),list(B),filter2(B,P),Xs)) = fold(B,A,aa(fun(B,bool),fun(B,fun(A,A)),aTP_Lamp_aja(fun(B,fun(A,A)),fun(fun(B,bool),fun(B,fun(A,A))),F2),P),Xs) ) ).

% fold_filter
tff(fact_4945_prod__list__zero__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1(A)
        & semiri3467727345109120633visors(A) )
     => ! [Xs: list(A)] :
          ( ( aa(list(A),A,groups5270119922927024881d_list(A),Xs) = zero_zero(A) )
        <=> pp(aa(set(A),bool,member(A,zero_zero(A)),aa(list(A),set(A),set2(A),Xs))) ) ) ).

% prod_list_zero_iff
tff(fact_4946_fold__plus__sum__list__rev,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A)] : ( fold(A,A,plus_plus(A),Xs) = aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),rev(A,Xs))) ) ) ).

% fold_plus_sum_list_rev
tff(fact_4947_sort__conv__fold,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] : ( aa(list(A),list(A),linorder_sort_key(A,A,aTP_Lamp_eh(A,A)),Xs) = aa(list(A),list(A),fold(A,list(A),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),Xs),nil(A)) ) ) ).

% sort_conv_fold
tff(fact_4948_Sup__set__fold,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Xs: list(A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,sup_sup(A),Xs),bot_bot(A)) ) ) ).

% Sup_set_fold
tff(fact_4949_Inf__set__fold,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Xs: list(A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,inf_inf(A),Xs),top_top(A)) ) ) ).

% Inf_set_fold
tff(fact_4950_Inf__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X2: A,Xs: list(A)] : ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(list(A),set(A),set2(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs))) = aa(A,A,fold(A,A,inf_inf(A),Xs),X2) ) ) ).

% Inf_fin.set_eq_fold
tff(fact_4951_prod__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Xs: list(A)] : ( aa(list(A),A,groups5270119922927024881d_list(A),Xs) = aa(A,A,foldr(A,A,times_times(A),Xs),one_one(A)) ) ) ).

% prod_list.eq_foldr
tff(fact_4952_enumerate__map__upt,axiom,
    ! [A: $tType,N: nat,F2: fun(nat,A),M2: nat] : ( enumerate(A,N,aa(list(nat),list(A),map(nat,A,F2),upt(N,M2))) = aa(list(nat),list(product_prod(nat,A)),map(nat,product_prod(nat,A),aTP_Lamp_aoc(fun(nat,A),fun(nat,product_prod(nat,A)),F2)),upt(N,M2)) ) ).

% enumerate_map_upt
tff(fact_4953_prod_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Xs: list(B),G: fun(B,A)] :
          ( distinct(B,Xs)
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(list(B),set(B),set2(B),Xs)) = aa(list(A),A,groups5270119922927024881d_list(A),aa(list(B),list(A),map(B,A,G),Xs)) ) ) ) ).

% prod.distinct_set_conv_list
tff(fact_4954_SUP__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),Xs: list(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F2),aa(list(B),set(B),set2(B),Xs))) = aa(A,A,fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,sup_sup(A)),F2),Xs),bot_bot(A)) ) ) ).

% SUP_set_fold
tff(fact_4955_list_Oin__rel,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),A4: list(A),B3: list(B)] :
      ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),list_all2(A,B,R),A4),B3))
    <=> ? [Z5: list(product_prod(A,B))] :
          ( pp(aa(set(list(product_prod(A,B))),bool,member(list(product_prod(A,B)),Z5),aa(fun(list(product_prod(A,B)),bool),set(list(product_prod(A,B))),collect(list(product_prod(A,B))),aTP_Lamp_aod(fun(A,fun(B,bool)),fun(list(product_prod(A,B)),bool),R))))
          & ( aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Z5) = A4 )
          & ( aa(list(product_prod(A,B)),list(B),map(product_prod(A,B),B,product_snd(A,B)),Z5) = B3 ) ) ) ).

% list.in_rel
tff(fact_4956_properties__for__sort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Ys: list(B),Xs: list(B),F2: fun(B,A)] :
          ( ( mset(B,Ys) = mset(B,Xs) )
         => ( ! [K2: B] :
                ( pp(aa(set(B),bool,member(B,K2),aa(list(B),set(B),set2(B),Ys)))
               => ( aa(list(B),list(B),filter2(B,aa(B,fun(B,bool),aTP_Lamp_aoe(fun(B,A),fun(B,fun(B,bool)),F2),K2)),Ys) = aa(list(B),list(B),filter2(B,aa(B,fun(B,bool),aTP_Lamp_aoe(fun(B,A),fun(B,fun(B,bool)),F2),K2)),Xs) ) )
           => ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F2),Ys))
             => ( aa(list(B),list(B),linorder_sort_key(B,A,F2),Xs) = Ys ) ) ) ) ) ).

% properties_for_sort_key
tff(fact_4957_set__drop__conv,axiom,
    ! [A: $tType,N: nat,L: list(A)] : ( aa(list(A),set(A),set2(A),drop(A,N,L)) = aa(fun(A,bool),set(A),collect(A),aa(list(A),fun(A,bool),aTP_Lamp_aof(nat,fun(list(A),fun(A,bool)),N),L)) ) ).

% set_drop_conv
tff(fact_4958_Multiset_Omset__insort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Xs: list(A)] : ( mset(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),X2),Xs)) = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X2),mset(A,Xs)) ) ) ).

% Multiset.mset_insort
tff(fact_4959_sorted__list__of__multiset__mset,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] : ( linord6283353356039996273ltiset(A,mset(A,Xs)) = aa(list(A),list(A),linorder_sort_key(A,A,aTP_Lamp_eh(A,A)),Xs) ) ) ).

% sorted_list_of_multiset_mset
tff(fact_4960_list_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: fun(A,fun(C,bool)),X2: list(A),G: fun(B,C),Y: list(B)] :
      ( pp(aa(list(C),bool,aa(list(A),fun(list(C),bool),list_all2(A,C,Sa),X2),aa(list(B),list(C),map(B,C,G),Y)))
    <=> pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),list_all2(A,B,aa(fun(B,C),fun(A,fun(B,bool)),aTP_Lamp_fm(fun(A,fun(C,bool)),fun(fun(B,C),fun(A,fun(B,bool))),Sa),G)),X2),Y)) ) ).

% list.rel_map(2)
tff(fact_4961_list_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: fun(C,fun(B,bool)),I2: fun(A,C),X2: list(A),Y: list(B)] :
      ( pp(aa(list(B),bool,aa(list(C),fun(list(B),bool),list_all2(C,B,Sb),aa(list(A),list(C),map(A,C,I2),X2)),Y))
    <=> pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),list_all2(A,B,aa(fun(A,C),fun(A,fun(B,bool)),aTP_Lamp_fn(fun(C,fun(B,bool)),fun(fun(A,C),fun(A,fun(B,bool))),Sb),I2)),X2),Y)) ) ).

% list.rel_map(1)
tff(fact_4962_list__all2__map1,axiom,
    ! [C: $tType,A: $tType,B: $tType,P: fun(A,fun(B,bool)),F2: fun(C,A),As2: list(C),Bs: list(B)] :
      ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),list_all2(A,B,P),aa(list(C),list(A),map(C,A,F2),As2)),Bs))
    <=> pp(aa(list(B),bool,aa(list(C),fun(list(B),bool),list_all2(C,B,aa(fun(C,A),fun(C,fun(B,bool)),aTP_Lamp_aog(fun(A,fun(B,bool)),fun(fun(C,A),fun(C,fun(B,bool))),P),F2)),As2),Bs)) ) ).

% list_all2_map1
tff(fact_4963_list__all2__map2,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: fun(A,fun(B,bool)),As2: list(A),F2: fun(C,B),Bs: list(C)] :
      ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),list_all2(A,B,P),As2),aa(list(C),list(B),map(C,B,F2),Bs)))
    <=> pp(aa(list(C),bool,aa(list(A),fun(list(C),bool),list_all2(A,C,aa(fun(C,B),fun(A,fun(C,bool)),aTP_Lamp_aoh(fun(A,fun(B,bool)),fun(fun(C,B),fun(A,fun(C,bool))),P),F2)),As2),Bs)) ) ).

% list_all2_map2
tff(fact_4964_list_Odisc__transfer_I1_J,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool))] : pp(aa(fun(list(B),bool),bool,aa(fun(list(A),bool),fun(fun(list(B),bool),bool),bNF_rel_fun(list(A),list(B),bool,bool,list_all2(A,B,R),fequal(bool)),aTP_Lamp_aoi(list(A),bool)),aTP_Lamp_aoj(list(B),bool))) ).

% list.disc_transfer(1)
tff(fact_4965_list_Odisc__transfer_I2_J,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool))] : pp(aa(fun(list(B),bool),bool,aa(fun(list(A),bool),fun(fun(list(B),bool),bool),bNF_rel_fun(list(A),list(B),bool,bool,list_all2(A,B,R),fequal(bool)),aTP_Lamp_ail(list(A),bool)),aTP_Lamp_aiz(list(B),bool))) ).

% list.disc_transfer(2)
tff(fact_4966_mset__eq__finite,axiom,
    ! [A: $tType,Xs: list(A)] : pp(aa(set(list(A)),bool,finite_finite2(list(A)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aTP_Lamp_aok(list(A),fun(list(A),bool),Xs)))) ).

% mset_eq_finite
tff(fact_4967_mset__eq__length__filter,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Z2: A] :
      ( ( mset(A,Xs) = mset(A,Ys) )
     => ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),fequal(A),Z2)),Xs)) = aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),fequal(A),Z2)),Ys)) ) ) ).

% mset_eq_length_filter
tff(fact_4968_drop__eq__nths,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( drop(A,N,Xs) = nths(A,Xs,aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),ord_less_eq(nat),N))) ) ).

% drop_eq_nths
tff(fact_4969_drop__Cons,axiom,
    ! [A: $tType,N: nat,X2: A,Xs: list(A)] : ( drop(A,N,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(nat,list(A),aa(fun(nat,list(A)),fun(nat,list(A)),aa(list(A),fun(fun(nat,list(A)),fun(nat,list(A))),case_nat(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)),aTP_Lamp_aol(list(A),fun(nat,list(A)),Xs)),N) ) ).

% drop_Cons
tff(fact_4970_properties__for__sort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Ys: list(A),Xs: list(A)] :
          ( ( mset(A,Ys) = mset(A,Xs) )
         => ( sorted_wrt(A,ord_less_eq(A),Ys)
           => ( aa(list(A),list(A),linorder_sort_key(A,A,aTP_Lamp_eh(A,A)),Xs) = Ys ) ) ) ) ).

% properties_for_sort
tff(fact_4971_product__lists__set,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( aa(list(list(A)),set(list(A)),set2(list(A)),product_lists(A,Xss)) = aa(fun(list(A),bool),set(list(A)),collect(list(A)),aTP_Lamp_aon(list(list(A)),fun(list(A),bool),Xss)) ) ).

% product_lists_set
tff(fact_4972_sum__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add(B)
        & monoid_add(A) )
     => ! [A3: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),A3,zero_zero(A)),zero_zero(B)))
         => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),plus_plus(A)),plus_plus(B)))
           => pp(aa(fun(list(B),B),bool,aa(fun(list(A),A),fun(fun(list(B),B),bool),bNF_rel_fun(list(A),list(B),A,B,list_all2(A,B,A3),A3),groups8242544230860333062m_list(A)),groups8242544230860333062m_list(B))) ) ) ) ).

% sum_list_transfer
tff(fact_4973_prod__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_mult(B)
        & monoid_mult(A) )
     => ! [A3: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),A3,one_one(A)),one_one(B)))
         => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),times_times(A)),times_times(B)))
           => pp(aa(fun(list(B),B),bool,aa(fun(list(A),A),fun(fun(list(B),B),bool),bNF_rel_fun(list(A),list(B),A,B,list_all2(A,B,A3),A3),groups5270119922927024881d_list(A)),groups5270119922927024881d_list(B))) ) ) ) ).

% prod_list_transfer
tff(fact_4974_list__all2__iff,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool)),Xs: list(A),Ys: list(B)] :
      ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),list_all2(A,B,P),Xs),Ys))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
        & ! [X3: product_prod(A,B)] :
            ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),X3),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys))))
           => pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),P),X3)) ) ) ) ).

% list_all2_iff
tff(fact_4975_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( comm_semiring_0(B)
        & comm_semiring_0(A) )
     => ! [A3: fun(A,fun(B,bool)),B2: fun(C,fun(D,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),A3,zero_zero(A)),zero_zero(B)))
         => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),plus_plus(A)),plus_plus(B)))
           => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),times_times(A)),times_times(B)))
             => pp(aa(fun(fun(D,B),fun(B,fun(list(D),B))),bool,aa(fun(fun(C,A),fun(A,fun(list(C),A))),fun(fun(fun(D,B),fun(B,fun(list(D),B))),bool),bNF_rel_fun(fun(C,A),fun(D,B),fun(A,fun(list(C),A)),fun(B,fun(list(D),B)),bNF_rel_fun(C,D,A,B,B2,A3),bNF_rel_fun(A,B,fun(list(C),A),fun(list(D),B),A3,bNF_rel_fun(list(C),list(D),A,B,list_all2(C,D,B2),A3))),groups4207007520872428315er_sum(C,A)),groups4207007520872428315er_sum(D,B))) ) ) ) ) ).

% horner_sum_transfer
tff(fact_4976_image__mset__map__of,axiom,
    ! [B: $tType,A: $tType,Xs: list(product_prod(A,B))] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))
     => ( aa(multiset(A),multiset(B),image_mset(A,B,aTP_Lamp_aoo(list(product_prod(A,B)),fun(A,B),Xs)),mset(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))) = mset(B,aa(list(product_prod(A,B)),list(B),map(product_prod(A,B),B,product_snd(A,B)),Xs)) ) ) ).

% image_mset_map_of
tff(fact_4977_stable__sort__key__def,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Sk: fun(fun(B,A),fun(list(B),list(B)))] :
          ( linord3483353639454293061rt_key(B,A,Sk)
        <=> ! [F8: fun(B,A),Xs3: list(B),K6: A] : ( aa(list(B),list(B),filter2(B,aa(A,fun(B,bool),aTP_Lamp_ako(fun(B,A),fun(A,fun(B,bool)),F8),K6)),aa(list(B),list(B),aa(fun(B,A),fun(list(B),list(B)),Sk,F8),Xs3)) = aa(list(B),list(B),filter2(B,aa(A,fun(B,bool),aTP_Lamp_ako(fun(B,A),fun(A,fun(B,bool)),F8),K6)),Xs3) ) ) ) ).

% stable_sort_key_def
tff(fact_4978_map__rec,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] : ( aa(list(B),list(A),map(B,A,F2),Xs) = aa(list(B),list(A),rec_list(list(A),B,nil(A),aTP_Lamp_aop(fun(B,A),fun(B,fun(list(B),fun(list(A),list(A)))),F2)),Xs) ) ).

% map_rec
tff(fact_4979_image__mset_Oidentity,axiom,
    ! [A: $tType] : ( image_mset(A,A,aTP_Lamp_bk(A,A)) = id(multiset(A)) ) ).

% image_mset.identity
tff(fact_4980_multiset_Omap__ident,axiom,
    ! [A: $tType,T3: multiset(A)] : ( aa(multiset(A),multiset(A),image_mset(A,A,aTP_Lamp_bk(A,A)),T3) = T3 ) ).

% multiset.map_ident
tff(fact_4981_image__mset__cong,axiom,
    ! [B: $tType,A: $tType,M: multiset(A),F2: fun(A,B),G: fun(A,B)] :
      ( ! [X: A] :
          ( pp(aa(set(A),bool,member(A,X),aa(multiset(A),set(A),set_mset(A),M)))
         => ( aa(A,B,F2,X) = aa(A,B,G,X) ) )
     => ( aa(multiset(A),multiset(B),image_mset(A,B,F2),M) = aa(multiset(A),multiset(B),image_mset(A,B,G),M) ) ) ).

% image_mset_cong
tff(fact_4982_image__mset__cong__pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,M: multiset(product_prod(A,B)),F2: fun(A,fun(B,C)),G: fun(A,fun(B,C))] :
      ( ! [X: A,Y2: B] :
          ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y2)),aa(multiset(product_prod(A,B)),set(product_prod(A,B)),set_mset(product_prod(A,B)),M)))
         => ( aa(B,C,aa(A,fun(B,C),F2,X),Y2) = aa(B,C,aa(A,fun(B,C),G,X),Y2) ) )
     => ( aa(multiset(product_prod(A,B)),multiset(C),image_mset(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F2)),M) = aa(multiset(product_prod(A,B)),multiset(C),image_mset(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),G)),M) ) ) ).

% image_mset_cong_pair
tff(fact_4983_in__image__mset,axiom,
    ! [A: $tType,B: $tType,Y: A,F2: fun(B,A),M: multiset(B)] :
      ( pp(aa(set(A),bool,member(A,Y),aa(multiset(A),set(A),set_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,F2),M))))
    <=> pp(aa(set(A),bool,member(A,Y),aa(set(B),set(A),image2(B,A,F2),aa(multiset(B),set(B),set_mset(B),M)))) ) ).

% in_image_mset
tff(fact_4984_rec__list__Cons__imp,axiom,
    ! [B: $tType,A: $tType,F2: fun(list(A),B),F1: B,F22: fun(A,fun(list(A),fun(B,B))),X2: A,Xs: list(A)] :
      ( ( F2 = rec_list(B,A,F1,F22) )
     => ( aa(list(A),B,F2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(B,B,aa(list(A),fun(B,B),aa(A,fun(list(A),fun(B,B)),F22,X2),Xs),aa(list(A),B,F2,Xs)) ) ) ).

% rec_list_Cons_imp
tff(fact_4985_rec__list__Nil__imp,axiom,
    ! [A: $tType,B: $tType,F2: fun(list(A),B),F1: B,F22: fun(A,fun(list(A),fun(B,B)))] :
      ( ( F2 = rec_list(B,A,F1,F22) )
     => ( aa(list(A),B,F2,nil(A)) = F1 ) ) ).

% rec_list_Nil_imp
tff(fact_4986_list_Orec__o__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: C,Ga: fun(B,fun(list(B),fun(C,C))),F2: fun(A,B)] : ( aa(fun(list(A),list(B)),fun(list(A),C),comp(list(B),C,list(A),rec_list(C,B,G,Ga)),map(A,B,F2)) = rec_list(C,A,G,aa(fun(A,B),fun(A,fun(list(A),fun(C,C))),aTP_Lamp_aoq(fun(B,fun(list(B),fun(C,C))),fun(fun(A,B),fun(A,fun(list(A),fun(C,C)))),Ga),F2)) ) ).

% list.rec_o_map
tff(fact_4987_count__image__mset,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: multiset(B),X2: A] : ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(multiset(B),multiset(A),image_mset(B,A,F2),A3)),X2) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(multiset(B),fun(B,nat),count(B),A3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F2),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),aa(multiset(B),set(B),set_mset(B),A3))) ) ).

% count_image_mset
tff(fact_4988_set__rec,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),Xs) = aa(list(A),set(A),rec_list(set(A),A,bot_bot(set(A)),aTP_Lamp_aor(A,fun(list(A),fun(set(A),set(A))))),Xs) ) ).

% set_rec
tff(fact_4989_prod_Oin__rel,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: fun(A,fun(C,bool)),R22: fun(B,fun(D,bool)),A4: product_prod(A,B),B3: product_prod(C,D)] :
      ( pp(aa(product_prod(C,D),bool,aa(product_prod(A,B),fun(product_prod(C,D),bool),basic_rel_prod(A,C,B,D,R1,R22),A4),B3))
    <=> ? [Z5: product_prod(product_prod(A,C),product_prod(B,D))] :
          ( pp(aa(set(product_prod(product_prod(A,C),product_prod(B,D))),bool,member(product_prod(product_prod(A,C),product_prod(B,D)),Z5),aa(fun(product_prod(product_prod(A,C),product_prod(B,D)),bool),set(product_prod(product_prod(A,C),product_prod(B,D))),collect(product_prod(product_prod(A,C),product_prod(B,D))),aa(fun(B,fun(D,bool)),fun(product_prod(product_prod(A,C),product_prod(B,D)),bool),aTP_Lamp_aos(fun(A,fun(C,bool)),fun(fun(B,fun(D,bool)),fun(product_prod(product_prod(A,C),product_prod(B,D)),bool)),R1),R22))))
          & ( aa(product_prod(product_prod(A,C),product_prod(B,D)),product_prod(A,B),product_map_prod(product_prod(A,C),A,product_prod(B,D),B,product_fst(A,C),product_fst(B,D)),Z5) = A4 )
          & ( aa(product_prod(product_prod(A,C),product_prod(B,D)),product_prod(C,D),product_map_prod(product_prod(A,C),C,product_prod(B,D),D,product_snd(A,C),product_snd(B,D)),Z5) = B3 ) ) ) ).

% prod.in_rel
tff(fact_4990_prod_Orel__map_I1_J,axiom,
    ! [A: $tType,B: $tType,E: $tType,F10: $tType,D: $tType,C: $tType,S1b: fun(E,fun(C,bool)),S2b: fun(F10,fun(D,bool)),I1: fun(A,E),I22: fun(B,F10),X2: product_prod(A,B),Y: product_prod(C,D)] :
      ( pp(aa(product_prod(C,D),bool,aa(product_prod(E,F10),fun(product_prod(C,D),bool),basic_rel_prod(E,C,F10,D,S1b,S2b),aa(product_prod(A,B),product_prod(E,F10),product_map_prod(A,E,B,F10,I1,I22),X2)),Y))
    <=> pp(aa(product_prod(C,D),bool,aa(product_prod(A,B),fun(product_prod(C,D),bool),basic_rel_prod(A,C,B,D,aa(fun(A,E),fun(A,fun(C,bool)),aTP_Lamp_aot(fun(E,fun(C,bool)),fun(fun(A,E),fun(A,fun(C,bool))),S1b),I1),aa(fun(B,F10),fun(B,fun(D,bool)),aTP_Lamp_aou(fun(F10,fun(D,bool)),fun(fun(B,F10),fun(B,fun(D,bool))),S2b),I22)),X2),Y)) ) ).

% prod.rel_map(1)
tff(fact_4991_prod_Orel__map_I2_J,axiom,
    ! [A: $tType,B: $tType,E: $tType,F10: $tType,D: $tType,C: $tType,S1a: fun(A,fun(E,bool)),S2a: fun(B,fun(F10,bool)),X2: product_prod(A,B),G1: fun(C,E),G22: fun(D,F10),Y: product_prod(C,D)] :
      ( pp(aa(product_prod(E,F10),bool,aa(product_prod(A,B),fun(product_prod(E,F10),bool),basic_rel_prod(A,E,B,F10,S1a,S2a),X2),aa(product_prod(C,D),product_prod(E,F10),product_map_prod(C,E,D,F10,G1,G22),Y)))
    <=> pp(aa(product_prod(C,D),bool,aa(product_prod(A,B),fun(product_prod(C,D),bool),basic_rel_prod(A,C,B,D,aa(fun(C,E),fun(A,fun(C,bool)),aTP_Lamp_aov(fun(A,fun(E,bool)),fun(fun(C,E),fun(A,fun(C,bool))),S1a),G1),aa(fun(D,F10),fun(B,fun(D,bool)),aTP_Lamp_aow(fun(B,fun(F10,bool)),fun(fun(D,F10),fun(B,fun(D,bool))),S2a),G22)),X2),Y)) ) ).

% prod.rel_map(2)
tff(fact_4992_rel__prod__conv,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: fun(A,fun(C,bool)),R22: fun(B,fun(D,bool))] : ( basic_rel_prod(A,C,B,D,R1,R22) = aa(fun(A,fun(B,fun(product_prod(C,D),bool))),fun(product_prod(A,B),fun(product_prod(C,D),bool)),product_case_prod(A,B,fun(product_prod(C,D),bool)),aa(fun(B,fun(D,bool)),fun(A,fun(B,fun(product_prod(C,D),bool))),aTP_Lamp_aoy(fun(A,fun(C,bool)),fun(fun(B,fun(D,bool)),fun(A,fun(B,fun(product_prod(C,D),bool)))),R1),R22)) ) ).

% rel_prod_conv
tff(fact_4993_int_Oid__abs__transfer,axiom,
    pp(aa(fun(product_prod(nat,nat),int),bool,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(product_prod(nat,nat),int),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),int,basic_rel_prod(nat,nat,nat,nat,fequal(nat),fequal(nat)),pcr_int),aTP_Lamp_aoz(product_prod(nat,nat),product_prod(nat,nat))),abs_Integ)) ).

% int.id_abs_transfer
tff(fact_4994_count__sum,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,multiset(A)),A3: set(B),X2: A] : ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(set(B),multiset(A),aa(fun(B,multiset(A)),fun(set(B),multiset(A)),groups7311177749621191930dd_sum(B,multiset(A)),F2),A3)),X2) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(A,fun(B,nat),aTP_Lamp_apa(fun(B,multiset(A)),fun(A,fun(B,nat)),F2),X2)),A3) ) ).

% count_sum
tff(fact_4995_set__mset__def,axiom,
    ! [A: $tType,M: multiset(A)] : ( aa(multiset(A),set(A),set_mset(A),M) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_apb(multiset(A),fun(A,bool),M)) ) ).

% set_mset_def
tff(fact_4996_set__mset__diff,axiom,
    ! [A: $tType,M: multiset(A),N4: multiset(A)] : ( aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),M),N4)) = aa(fun(A,bool),set(A),collect(A),aa(multiset(A),fun(A,bool),aTP_Lamp_apc(multiset(A),fun(multiset(A),fun(A,bool)),M),N4)) ) ).

% set_mset_diff
tff(fact_4997_count__mset,axiom,
    ! [A: $tType,Xs: list(A),X2: A] : ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),mset(A,Xs)),X2) = aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,aa(A,fun(A,bool),fequal(A),X2)),Xs)) ) ).

% count_mset
tff(fact_4998_count__image__mset_H,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),X5: multiset(B),Y: A] : ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(multiset(B),multiset(A),image_mset(B,A,F2),X5)),Y) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(multiset(B),fun(B,nat),count(B),X5)),aa(fun(B,bool),set(B),collect(B),aa(A,fun(B,bool),aa(multiset(B),fun(A,fun(B,bool)),aTP_Lamp_apd(fun(B,A),fun(multiset(B),fun(A,fun(B,bool))),F2),X5),Y))) ) ).

% count_image_mset'
tff(fact_4999_count__induct,axiom,
    ! [A: $tType,Y: fun(A,nat),P: fun(fun(A,nat),bool)] :
      ( pp(aa(set(fun(A,nat)),bool,member(fun(A,nat),Y),aa(fun(fun(A,nat),bool),set(fun(A,nat)),collect(fun(A,nat)),aTP_Lamp_ape(fun(A,nat),bool))))
     => ( ! [X: multiset(A)] : pp(aa(fun(A,nat),bool,P,aa(multiset(A),fun(A,nat),count(A),X)))
       => pp(aa(fun(A,nat),bool,P,Y)) ) ) ).

% count_induct
tff(fact_5000_count__cases,axiom,
    ! [A: $tType,Y: fun(A,nat)] :
      ( pp(aa(set(fun(A,nat)),bool,member(fun(A,nat),Y),aa(fun(fun(A,nat),bool),set(fun(A,nat)),collect(fun(A,nat)),aTP_Lamp_ape(fun(A,nat),bool))))
     => ~ ! [X: multiset(A)] : ( Y != aa(multiset(A),fun(A,nat),count(A),X) ) ) ).

% count_cases
tff(fact_5001_count,axiom,
    ! [A: $tType,X2: multiset(A)] : pp(aa(set(fun(A,nat)),bool,member(fun(A,nat),aa(multiset(A),fun(A,nat),count(A),X2)),aa(fun(fun(A,nat),bool),set(fun(A,nat)),collect(fun(A,nat)),aTP_Lamp_ape(fun(A,nat),bool)))) ).

% count
tff(fact_5002_Inf__multiset_Orep__eq,axiom,
    ! [A: $tType,X2: set(multiset(A)),X4: A] :
      ( ( ( aa(set(multiset(A)),set(fun(A,nat)),image2(multiset(A),fun(A,nat),count(A)),X2) = bot_bot(set(fun(A,nat))) )
       => ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X2)),X4) = zero_zero(nat) ) )
      & ( ( aa(set(multiset(A)),set(fun(A,nat)),image2(multiset(A),fun(A,nat),count(A)),X2) != bot_bot(set(fun(A,nat))) )
       => ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X2)),X4) = aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(fun(A,nat)),set(nat),image2(fun(A,nat),nat,aTP_Lamp_apf(A,fun(fun(A,nat),nat),X4)),aa(set(multiset(A)),set(fun(A,nat)),image2(multiset(A),fun(A,nat),count(A)),X2))) ) ) ) ).

% Inf_multiset.rep_eq
tff(fact_5003_count__Inf__multiset__nonempty,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: A] :
      ( ( A3 != bot_bot(set(multiset(A))) )
     => ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A3)),X2) = aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(multiset(A)),set(nat),image2(multiset(A),nat,aTP_Lamp_apg(A,fun(multiset(A),nat),X2)),A3)) ) ) ).

% count_Inf_multiset_nonempty
tff(fact_5004_size__multiset__eq,axiom,
    ! [A: $tType,F2: fun(A,nat),M: multiset(A)] : ( aa(multiset(A),nat,size_multiset(A,F2),M) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(multiset(A),fun(A,nat),aTP_Lamp_aph(fun(A,nat),fun(multiset(A),fun(A,nat)),F2),M)),aa(multiset(A),set(A),set_mset(A),M)) ) ).

% size_multiset_eq
tff(fact_5005_multiset_Oin__rel,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),A4: multiset(A),B3: multiset(B)] :
      ( pp(aa(multiset(B),bool,aa(multiset(A),fun(multiset(B),bool),rel_mset(A,B,R),A4),B3))
    <=> ? [Z5: multiset(product_prod(A,B))] :
          ( pp(aa(set(multiset(product_prod(A,B))),bool,member(multiset(product_prod(A,B)),Z5),aa(fun(multiset(product_prod(A,B)),bool),set(multiset(product_prod(A,B))),collect(multiset(product_prod(A,B))),aTP_Lamp_api(fun(A,fun(B,bool)),fun(multiset(product_prod(A,B)),bool),R))))
          & ( aa(multiset(product_prod(A,B)),multiset(A),image_mset(product_prod(A,B),A,product_fst(A,B)),Z5) = A4 )
          & ( aa(multiset(product_prod(A,B)),multiset(B),image_mset(product_prod(A,B),B,product_snd(A,B)),Z5) = B3 ) ) ) ).

% multiset.in_rel
tff(fact_5006_fold__mset__def,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(B,B)),S2: B,M: multiset(A)] : ( fold_mset(A,B,F2,S2,M) = finite_fold(A,B,aa(multiset(A),fun(A,fun(B,B)),aTP_Lamp_apj(fun(A,fun(B,B)),fun(multiset(A),fun(A,fun(B,B))),F2),M),S2,aa(multiset(A),set(A),set_mset(A),M)) ) ).

% fold_mset_def
tff(fact_5007_multiset_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: fun(A,fun(C,bool)),X2: multiset(A),G: fun(B,C),Y: multiset(B)] :
      ( pp(aa(multiset(C),bool,aa(multiset(A),fun(multiset(C),bool),rel_mset(A,C,Sa),X2),aa(multiset(B),multiset(C),image_mset(B,C,G),Y)))
    <=> pp(aa(multiset(B),bool,aa(multiset(A),fun(multiset(B),bool),rel_mset(A,B,aa(fun(B,C),fun(A,fun(B,bool)),aTP_Lamp_fm(fun(A,fun(C,bool)),fun(fun(B,C),fun(A,fun(B,bool))),Sa),G)),X2),Y)) ) ).

% multiset.rel_map(2)
tff(fact_5008_multiset_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: fun(C,fun(B,bool)),I2: fun(A,C),X2: multiset(A),Y: multiset(B)] :
      ( pp(aa(multiset(B),bool,aa(multiset(C),fun(multiset(B),bool),rel_mset(C,B,Sb),aa(multiset(A),multiset(C),image_mset(A,C,I2),X2)),Y))
    <=> pp(aa(multiset(B),bool,aa(multiset(A),fun(multiset(B),bool),rel_mset(A,B,aa(fun(A,C),fun(A,fun(B,bool)),aTP_Lamp_fn(fun(C,fun(B,bool)),fun(fun(A,C),fun(A,fun(B,bool))),Sb),I2)),X2),Y)) ) ).

% multiset.rel_map(1)
tff(fact_5009_sorted__list__of__multiset__def,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [M: multiset(A)] : ( linord6283353356039996273ltiset(A,M) = fold_mset(A,list(A),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),nil(A),M) ) ) ).

% sorted_list_of_multiset_def
tff(fact_5010_Inf__multiset__def,axiom,
    ! [A: $tType] : ( complete_Inf_Inf(multiset(A)) = aa(fun(set(fun(A,nat)),fun(A,nat)),fun(set(multiset(A)),multiset(A)),map_fun(set(multiset(A)),set(fun(A,nat)),fun(A,nat),multiset(A),image2(multiset(A),fun(A,nat),count(A)),abs_multiset(A)),aTP_Lamp_apk(set(fun(A,nat)),fun(A,nat))) ) ).

% Inf_multiset_def
tff(fact_5011_count__Abs__multiset,axiom,
    ! [A: $tType,F2: fun(A,nat)] :
      ( pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_tm(fun(A,nat),fun(A,bool),F2))))
     => ( aa(multiset(A),fun(A,nat),count(A),aa(fun(A,nat),multiset(A),abs_multiset(A),F2)) = F2 ) ) ).

% count_Abs_multiset
tff(fact_5012_sum__mset__delta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Y: B,C2: A,A3: multiset(B)] : ( comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_apl(B,fun(A,fun(B,A)),Y),C2)),A3)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(nat,A,semiring_1_of_nat(A),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),A3),Y))) ) ) ).

% sum_mset_delta'
tff(fact_5013_Union__image__single__mset,axiom,
    ! [A: $tType,M2: multiset(A)] : ( comm_m7189776963980413722m_mset(multiset(A),aa(multiset(A),multiset(multiset(A)),image_mset(A,multiset(A),aTP_Lamp_ahv(A,multiset(A))),M2)) = M2 ) ).

% Union_image_single_mset
tff(fact_5014_sum__mset_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: multiset(B)] : ( comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aTP_Lamp_od(B,A)),A3)) = zero_zero(A) ) ) ).

% sum_mset.neutral_const
tff(fact_5015_set__mset__Union__mset,axiom,
    ! [A: $tType,MM: multiset(multiset(A))] : ( aa(multiset(A),set(A),set_mset(A),comm_m7189776963980413722m_mset(multiset(A),MM)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(multiset(A)),set(set(A)),image2(multiset(A),set(A),set_mset(A)),aa(multiset(multiset(A)),set(multiset(A)),set_mset(multiset(A)),MM))) ) ).

% set_mset_Union_mset
tff(fact_5016_sum__mset__replicate__mset,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat,A4: A] : ( comm_m7189776963980413722m_mset(A,replicate_mset(A,N,A4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),A4) ) ) ).

% sum_mset_replicate_mset
tff(fact_5017_sum__mset_Oswap,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,fun(C,A)),B2: multiset(C),A3: multiset(B)] : ( comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aa(multiset(C),fun(B,A),aTP_Lamp_apm(fun(B,fun(C,A)),fun(multiset(C),fun(B,A)),G),B2)),A3)) = comm_m7189776963980413722m_mset(A,aa(multiset(C),multiset(A),image_mset(C,A,aa(multiset(B),fun(C,A),aTP_Lamp_apn(fun(B,fun(C,A)),fun(multiset(B),fun(C,A)),G),A3)),B2)) ) ) ).

% sum_mset.swap
tff(fact_5018_sum__mset_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),H2: fun(B,A),A3: multiset(B)] : ( comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_mg(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2)),A3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,G),A3))),comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,H2),A3))) ) ) ).

% sum_mset.distrib
tff(fact_5019_sum__mset__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [C2: A,F2: fun(B,A),M: multiset(B)] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,F2),M))) = comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ow(A,fun(fun(B,A),fun(B,A)),C2),F2)),M)) ) ) ).

% sum_mset_distrib_left
tff(fact_5020_sum__mset__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [F2: fun(B,A),M: multiset(B),C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,F2),M))),C2) = comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_ov(fun(B,A),fun(A,fun(B,A)),F2),C2)),M)) ) ) ).

% sum_mset_distrib_right
tff(fact_5021_sum__mset__product,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( comm_monoid_add(A)
        & times(A)
        & semiring_0(B) )
     => ! [F2: fun(A,B),A3: multiset(A),G: fun(C,B),B2: multiset(C)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),comm_m7189776963980413722m_mset(B,aa(multiset(A),multiset(B),image_mset(A,B,F2),A3))),comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,G),B2))) = comm_m7189776963980413722m_mset(B,aa(multiset(A),multiset(B),image_mset(A,B,aa(multiset(C),fun(A,B),aa(fun(C,B),fun(multiset(C),fun(A,B)),aTP_Lamp_app(fun(A,B),fun(fun(C,B),fun(multiset(C),fun(A,B))),F2),G),B2)),A3)) ) ) ).

% sum_mset_product
tff(fact_5022_zero__multiset__def,axiom,
    ! [A: $tType] : ( zero_zero(multiset(A)) = aa(fun(A,nat),multiset(A),abs_multiset(A),aTP_Lamp_apq(A,nat)) ) ).

% zero_multiset_def
tff(fact_5023_Abs__multiset__inject,axiom,
    ! [A: $tType,X2: fun(A,nat),Y: fun(A,nat)] :
      ( pp(aa(set(fun(A,nat)),bool,member(fun(A,nat),X2),aa(fun(fun(A,nat),bool),set(fun(A,nat)),collect(fun(A,nat)),aTP_Lamp_ape(fun(A,nat),bool))))
     => ( pp(aa(set(fun(A,nat)),bool,member(fun(A,nat),Y),aa(fun(fun(A,nat),bool),set(fun(A,nat)),collect(fun(A,nat)),aTP_Lamp_ape(fun(A,nat),bool))))
       => ( ( aa(fun(A,nat),multiset(A),abs_multiset(A),X2) = aa(fun(A,nat),multiset(A),abs_multiset(A),Y) )
        <=> ( X2 = Y ) ) ) ) ).

% Abs_multiset_inject
tff(fact_5024_Abs__multiset__induct,axiom,
    ! [A: $tType,P: fun(multiset(A),bool),X2: multiset(A)] :
      ( ! [Y2: fun(A,nat)] :
          ( pp(aa(set(fun(A,nat)),bool,member(fun(A,nat),Y2),aa(fun(fun(A,nat),bool),set(fun(A,nat)),collect(fun(A,nat)),aTP_Lamp_ape(fun(A,nat),bool))))
         => pp(aa(multiset(A),bool,P,aa(fun(A,nat),multiset(A),abs_multiset(A),Y2))) )
     => pp(aa(multiset(A),bool,P,X2)) ) ).

% Abs_multiset_induct
tff(fact_5025_Abs__multiset__cases,axiom,
    ! [A: $tType,X2: multiset(A)] :
      ~ ! [Y2: fun(A,nat)] :
          ( ( X2 = aa(fun(A,nat),multiset(A),abs_multiset(A),Y2) )
         => ~ pp(aa(set(fun(A,nat)),bool,member(fun(A,nat),Y2),aa(fun(fun(A,nat),bool),set(fun(A,nat)),collect(fun(A,nat)),aTP_Lamp_ape(fun(A,nat),bool)))) ) ).

% Abs_multiset_cases
tff(fact_5026_plus__multiset__def,axiom,
    ! [A: $tType] : ( plus_plus(multiset(A)) = aa(fun(fun(A,nat),fun(fun(A,nat),fun(A,nat))),fun(multiset(A),fun(multiset(A),multiset(A))),map_fun(multiset(A),fun(A,nat),fun(fun(A,nat),fun(A,nat)),fun(multiset(A),multiset(A)),count(A),map_fun(multiset(A),fun(A,nat),fun(A,nat),multiset(A),count(A),abs_multiset(A))),aTP_Lamp_apr(fun(A,nat),fun(fun(A,nat),fun(A,nat)))) ) ).

% plus_multiset_def
tff(fact_5027_minus__multiset__def,axiom,
    ! [A: $tType] : ( minus_minus(multiset(A)) = aa(fun(fun(A,nat),fun(fun(A,nat),fun(A,nat))),fun(multiset(A),fun(multiset(A),multiset(A))),map_fun(multiset(A),fun(A,nat),fun(fun(A,nat),fun(A,nat)),fun(multiset(A),multiset(A)),count(A),map_fun(multiset(A),fun(A,nat),fun(A,nat),multiset(A),count(A),abs_multiset(A))),aTP_Lamp_aps(fun(A,nat),fun(fun(A,nat),fun(A,nat)))) ) ).

% minus_multiset_def
tff(fact_5028_type__definition__multiset,axiom,
    ! [A: $tType] : type_definition(multiset(A),fun(A,nat),count(A),abs_multiset(A),aa(fun(fun(A,nat),bool),set(fun(A,nat)),collect(fun(A,nat)),aTP_Lamp_ape(fun(A,nat),bool))) ).

% type_definition_multiset
tff(fact_5029_Abs__multiset__inverse,axiom,
    ! [A: $tType,Y: fun(A,nat)] :
      ( pp(aa(set(fun(A,nat)),bool,member(fun(A,nat),Y),aa(fun(fun(A,nat),bool),set(fun(A,nat)),collect(fun(A,nat)),aTP_Lamp_ape(fun(A,nat),bool))))
     => ( aa(multiset(A),fun(A,nat),count(A),aa(fun(A,nat),multiset(A),abs_multiset(A),Y)) = Y ) ) ).

% Abs_multiset_inverse
tff(fact_5030_add__mset__def,axiom,
    ! [A: $tType] : ( add_mset(A) = aa(fun(A,fun(fun(A,nat),fun(A,nat))),fun(A,fun(multiset(A),multiset(A))),map_fun(A,A,fun(fun(A,nat),fun(A,nat)),fun(multiset(A),multiset(A)),id(A),map_fun(multiset(A),fun(A,nat),fun(A,nat),multiset(A),count(A),abs_multiset(A))),aTP_Lamp_apt(A,fun(fun(A,nat),fun(A,nat)))) ) ).

% add_mset_def
tff(fact_5031_sum__mset__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Y: B,C2: A,A3: multiset(B)] : ( comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_apu(B,fun(A,fun(B,A)),Y),C2)),A3)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(nat,A,semiring_1_of_nat(A),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),A3),Y))) ) ) ).

% sum_mset_delta
tff(fact_5032_minus__multiset_Oabs__eq,axiom,
    ! [A: $tType,Xa: fun(A,nat),X2: fun(A,nat)] :
      ( pp(aa(fun(A,nat),bool,aa(fun(A,nat),fun(fun(A,nat),bool),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),Xa),Xa))
     => ( pp(aa(fun(A,nat),bool,aa(fun(A,nat),fun(fun(A,nat),bool),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),X2),X2))
       => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),aa(fun(A,nat),multiset(A),abs_multiset(A),Xa)),aa(fun(A,nat),multiset(A),abs_multiset(A),X2)) = aa(fun(A,nat),multiset(A),abs_multiset(A),aa(fun(A,nat),fun(A,nat),aa(fun(A,nat),fun(fun(A,nat),fun(A,nat)),aTP_Lamp_aps(fun(A,nat),fun(fun(A,nat),fun(A,nat))),Xa),X2)) ) ) ) ).

% minus_multiset.abs_eq
tff(fact_5033_plus__multiset_Oabs__eq,axiom,
    ! [A: $tType,Xa: fun(A,nat),X2: fun(A,nat)] :
      ( pp(aa(fun(A,nat),bool,aa(fun(A,nat),fun(fun(A,nat),bool),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),Xa),Xa))
     => ( pp(aa(fun(A,nat),bool,aa(fun(A,nat),fun(fun(A,nat),bool),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),X2),X2))
       => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),aa(fun(A,nat),multiset(A),abs_multiset(A),Xa)),aa(fun(A,nat),multiset(A),abs_multiset(A),X2)) = aa(fun(A,nat),multiset(A),abs_multiset(A),aa(fun(A,nat),fun(A,nat),aa(fun(A,nat),fun(fun(A,nat),fun(A,nat)),aTP_Lamp_apr(fun(A,nat),fun(fun(A,nat),fun(A,nat))),Xa),X2)) ) ) ) ).

% plus_multiset.abs_eq
tff(fact_5034_add__mset_Oabs__eq,axiom,
    ! [A: $tType,X2: fun(A,nat),Xa: A] :
      ( pp(aa(fun(A,nat),bool,aa(fun(A,nat),fun(fun(A,nat),bool),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),X2),X2))
     => ( aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),Xa),aa(fun(A,nat),multiset(A),abs_multiset(A),X2)) = aa(fun(A,nat),multiset(A),abs_multiset(A),aa(A,fun(A,nat),aTP_Lamp_apv(fun(A,nat),fun(A,fun(A,nat)),X2),Xa)) ) ) ).

% add_mset.abs_eq
tff(fact_5035_eq__onp__def,axiom,
    ! [A: $tType,R: fun(A,bool),X4: A,Xa3: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),bNF_eq_onp(A,R),X4),Xa3))
    <=> ( pp(aa(A,bool,R,X4))
        & ( X4 = Xa3 ) ) ) ).

% eq_onp_def
tff(fact_5036_eq__onp__True,axiom,
    ! [A: $tType] : ( bNF_eq_onp(A,aTP_Lamp_nn(A,bool)) = fequal(A) ) ).

% eq_onp_True
tff(fact_5037_fun_Orel__eq__onp,axiom,
    ! [D: $tType,A: $tType,P: fun(A,bool)] : ( bNF_rel_fun(D,D,A,A,fequal(D),bNF_eq_onp(A,P)) = bNF_eq_onp(fun(D,A),aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),P)) ) ).

% fun.rel_eq_onp
tff(fact_5038_rel__fun__eq__eq__onp,axiom,
    ! [A: $tType,B: $tType,P: fun(B,bool)] : ( bNF_rel_fun(A,A,B,B,fequal(A),bNF_eq_onp(B,P)) = bNF_eq_onp(fun(A,B),aTP_Lamp_apw(fun(B,bool),fun(fun(A,B),bool),P)) ) ).

% rel_fun_eq_eq_onp
tff(fact_5039_fun_Opred__rel,axiom,
    ! [A: $tType,D: $tType,P: fun(A,bool),X2: fun(D,A)] :
      ( pp(aa(fun(D,A),bool,aa(fun(A,bool),fun(fun(D,A),bool),basic_pred_fun(D,A,aTP_Lamp_ahp(D,bool)),P),X2))
    <=> pp(aa(fun(D,A),bool,aa(fun(D,A),fun(fun(D,A),bool),bNF_rel_fun(D,D,A,A,fequal(D),bNF_eq_onp(A,P)),X2),X2)) ) ).

% fun.pred_rel
tff(fact_5040_rel__fun__eq__onp__rel,axiom,
    ! [B: $tType,C: $tType,A: $tType,R: fun(A,bool),S: fun(B,fun(C,bool)),X4: fun(A,B),Xa3: fun(A,C)] :
      ( pp(aa(fun(A,C),bool,aa(fun(A,B),fun(fun(A,C),bool),bNF_rel_fun(A,A,B,C,bNF_eq_onp(A,R),S),X4),Xa3))
    <=> ! [Xb2: A] :
          ( pp(aa(A,bool,R,Xb2))
         => pp(aa(C,bool,aa(B,fun(C,bool),S,aa(A,B,X4,Xb2)),aa(A,C,Xa3,Xb2))) ) ) ).

% rel_fun_eq_onp_rel
tff(fact_5041_filter__mset_Orsp,axiom,
    ! [A: $tType] : pp(aa(fun(fun(A,bool),fun(fun(A,nat),fun(A,nat))),bool,aa(fun(fun(A,bool),fun(fun(A,nat),fun(A,nat))),fun(fun(fun(A,bool),fun(fun(A,nat),fun(A,nat))),bool),bNF_rel_fun(fun(A,bool),fun(A,bool),fun(fun(A,nat),fun(A,nat)),fun(fun(A,nat),fun(A,nat)),fequal(fun(A,bool)),bNF_rel_fun(fun(A,nat),fun(A,nat),fun(A,nat),fun(A,nat),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)))),aTP_Lamp_apx(fun(A,bool),fun(fun(A,nat),fun(A,nat)))),aTP_Lamp_apx(fun(A,bool),fun(fun(A,nat),fun(A,nat))))) ).

% filter_mset.rsp
tff(fact_5042_zero__multiset_Orsp,axiom,
    ! [A: $tType] : pp(aa(fun(A,nat),bool,aa(fun(A,nat),fun(fun(A,nat),bool),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),aTP_Lamp_apq(A,nat)),aTP_Lamp_apq(A,nat))) ).

% zero_multiset.rsp
tff(fact_5043_add__mset_Orsp,axiom,
    ! [A: $tType] : pp(aa(fun(A,fun(fun(A,nat),fun(A,nat))),bool,aa(fun(A,fun(fun(A,nat),fun(A,nat))),fun(fun(A,fun(fun(A,nat),fun(A,nat))),bool),bNF_rel_fun(A,A,fun(fun(A,nat),fun(A,nat)),fun(fun(A,nat),fun(A,nat)),fequal(A),bNF_rel_fun(fun(A,nat),fun(A,nat),fun(A,nat),fun(A,nat),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)))),aTP_Lamp_apt(A,fun(fun(A,nat),fun(A,nat)))),aTP_Lamp_apt(A,fun(fun(A,nat),fun(A,nat))))) ).

% add_mset.rsp
tff(fact_5044_plus__multiset_Orsp,axiom,
    ! [A: $tType] : pp(aa(fun(fun(A,nat),fun(fun(A,nat),fun(A,nat))),bool,aa(fun(fun(A,nat),fun(fun(A,nat),fun(A,nat))),fun(fun(fun(A,nat),fun(fun(A,nat),fun(A,nat))),bool),bNF_rel_fun(fun(A,nat),fun(A,nat),fun(fun(A,nat),fun(A,nat)),fun(fun(A,nat),fun(A,nat)),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),bNF_rel_fun(fun(A,nat),fun(A,nat),fun(A,nat),fun(A,nat),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)))),aTP_Lamp_apr(fun(A,nat),fun(fun(A,nat),fun(A,nat)))),aTP_Lamp_apr(fun(A,nat),fun(fun(A,nat),fun(A,nat))))) ).

% plus_multiset.rsp
tff(fact_5045_minus__multiset_Orsp,axiom,
    ! [A: $tType] : pp(aa(fun(fun(A,nat),fun(fun(A,nat),fun(A,nat))),bool,aa(fun(fun(A,nat),fun(fun(A,nat),fun(A,nat))),fun(fun(fun(A,nat),fun(fun(A,nat),fun(A,nat))),bool),bNF_rel_fun(fun(A,nat),fun(A,nat),fun(fun(A,nat),fun(A,nat)),fun(fun(A,nat),fun(A,nat)),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),bNF_rel_fun(fun(A,nat),fun(A,nat),fun(A,nat),fun(A,nat),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)))),aTP_Lamp_aps(fun(A,nat),fun(fun(A,nat),fun(A,nat)))),aTP_Lamp_aps(fun(A,nat),fun(fun(A,nat),fun(A,nat))))) ).

% minus_multiset.rsp
tff(fact_5046_repeat__mset_Orsp,axiom,
    ! [A: $tType] : pp(aa(fun(nat,fun(fun(A,nat),fun(A,nat))),bool,aa(fun(nat,fun(fun(A,nat),fun(A,nat))),fun(fun(nat,fun(fun(A,nat),fun(A,nat))),bool),bNF_rel_fun(nat,nat,fun(fun(A,nat),fun(A,nat)),fun(fun(A,nat),fun(A,nat)),fequal(nat),bNF_rel_fun(fun(A,nat),fun(A,nat),fun(A,nat),fun(A,nat),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)))),aTP_Lamp_apy(nat,fun(fun(A,nat),fun(A,nat)))),aTP_Lamp_apy(nat,fun(fun(A,nat),fun(A,nat))))) ).

% repeat_mset.rsp
tff(fact_5047_Inf__multiset_Oabs__eq,axiom,
    ! [A: $tType,X2: set(fun(A,nat))] :
      ( pp(aa(set(fun(A,nat)),bool,aa(set(fun(A,nat)),fun(set(fun(A,nat)),bool),bNF_rel_set(fun(A,nat),fun(A,nat),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool))),X2),X2))
     => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(fun(A,nat)),set(multiset(A)),image2(fun(A,nat),multiset(A),abs_multiset(A)),X2)) = aa(fun(A,nat),multiset(A),abs_multiset(A),aa(set(fun(A,nat)),fun(A,nat),aTP_Lamp_apk(set(fun(A,nat)),fun(A,nat)),X2)) ) ) ).

% Inf_multiset.abs_eq
tff(fact_5048_repeat__mset_Oabs__eq,axiom,
    ! [A: $tType,X2: fun(A,nat),Xa: nat] :
      ( pp(aa(fun(A,nat),bool,aa(fun(A,nat),fun(fun(A,nat),bool),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),X2),X2))
     => ( aa(multiset(A),multiset(A),aa(nat,fun(multiset(A),multiset(A)),repeat_mset(A),Xa),aa(fun(A,nat),multiset(A),abs_multiset(A),X2)) = aa(fun(A,nat),multiset(A),abs_multiset(A),aa(nat,fun(A,nat),aTP_Lamp_apz(fun(A,nat),fun(nat,fun(A,nat)),X2),Xa)) ) ) ).

% repeat_mset.abs_eq
tff(fact_5049_Inf__multiset_Orsp,axiom,
    ! [A: $tType] : pp(aa(fun(set(fun(A,nat)),fun(A,nat)),bool,aa(fun(set(fun(A,nat)),fun(A,nat)),fun(fun(set(fun(A,nat)),fun(A,nat)),bool),bNF_rel_fun(set(fun(A,nat)),set(fun(A,nat)),fun(A,nat),fun(A,nat),bNF_rel_set(fun(A,nat),fun(A,nat),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool))),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool))),aTP_Lamp_apk(set(fun(A,nat)),fun(A,nat))),aTP_Lamp_apk(set(fun(A,nat)),fun(A,nat)))) ).

% Inf_multiset.rsp
tff(fact_5050_rel__set__def,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),X4: set(A),Xa3: set(B)] :
      ( pp(aa(set(B),bool,aa(set(A),fun(set(B),bool),bNF_rel_set(A,B,R),X4),Xa3))
    <=> ( ! [Xb2: A] :
            ( pp(aa(set(A),bool,member(A,Xb2),X4))
           => ? [Xc: B] :
                ( pp(aa(set(B),bool,member(B,Xc),Xa3))
                & pp(aa(B,bool,aa(A,fun(B,bool),R,Xb2),Xc)) ) )
        & ! [Xb2: B] :
            ( pp(aa(set(B),bool,member(B,Xb2),Xa3))
           => ? [Xc: A] :
                ( pp(aa(set(A),bool,member(A,Xc),X4))
                & pp(aa(B,bool,aa(A,fun(B,bool),R,Xc),Xb2)) ) ) ) ) ).

% rel_set_def
tff(fact_5051_fun_Oset__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,R: fun(A,fun(B,bool))] : pp(aa(fun(fun(D,B),set(B)),bool,aa(fun(fun(D,A),set(A)),fun(fun(fun(D,B),set(B)),bool),bNF_rel_fun(fun(D,A),fun(D,B),set(A),set(B),bNF_rel_fun(D,D,A,B,fequal(D),R),bNF_rel_set(A,B,R)),aTP_Lamp_aqa(fun(D,A),set(A))),aTP_Lamp_aqb(fun(D,B),set(B)))) ).

% fun.set_transfer
tff(fact_5052_repeat__mset__def,axiom,
    ! [A: $tType] : ( repeat_mset(A) = aa(fun(nat,fun(fun(A,nat),fun(A,nat))),fun(nat,fun(multiset(A),multiset(A))),map_fun(nat,nat,fun(fun(A,nat),fun(A,nat)),fun(multiset(A),multiset(A)),id(nat),map_fun(multiset(A),fun(A,nat),fun(A,nat),multiset(A),count(A),abs_multiset(A))),aTP_Lamp_apy(nat,fun(fun(A,nat),fun(A,nat)))) ) ).

% repeat_mset_def
tff(fact_5053_INF__parametric,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( complete_Inf(C)
     => ! [A3: fun(A,fun(B,bool))] : pp(aa(fun(set(B),fun(fun(B,C),C)),bool,aa(fun(set(A),fun(fun(A,C),C)),fun(fun(set(B),fun(fun(B,C),C)),bool),bNF_rel_fun(set(A),set(B),fun(fun(A,C),C),fun(fun(B,C),C),bNF_rel_set(A,B,A3),bNF_rel_fun(fun(A,C),fun(B,C),C,C,bNF_rel_fun(A,B,C,C,A3,fequal(C)),fequal(C))),aTP_Lamp_aqc(set(A),fun(fun(A,C),C))),aTP_Lamp_aqd(set(B),fun(fun(B,C),C)))) ) ).

% INF_parametric
tff(fact_5054_SUP__parametric,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( complete_Sup(C)
     => ! [R: fun(A,fun(B,bool))] : pp(aa(fun(set(B),fun(fun(B,C),C)),bool,aa(fun(set(A),fun(fun(A,C),C)),fun(fun(set(B),fun(fun(B,C),C)),bool),bNF_rel_fun(set(A),set(B),fun(fun(A,C),C),fun(fun(B,C),C),bNF_rel_set(A,B,R),bNF_rel_fun(fun(A,C),fun(B,C),C,C,bNF_rel_fun(A,B,C,C,R,fequal(C)),fequal(C))),aTP_Lamp_aqe(set(A),fun(fun(A,C),C))),aTP_Lamp_aqf(set(B),fun(fun(B,C),C)))) ) ).

% SUP_parametric
tff(fact_5055_UNION__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A3: fun(A,fun(B,bool)),B2: fun(C,fun(D,bool))] : pp(aa(fun(set(B),fun(fun(B,set(D)),set(D))),bool,aa(fun(set(A),fun(fun(A,set(C)),set(C))),fun(fun(set(B),fun(fun(B,set(D)),set(D))),bool),bNF_rel_fun(set(A),set(B),fun(fun(A,set(C)),set(C)),fun(fun(B,set(D)),set(D)),bNF_rel_set(A,B,A3),bNF_rel_fun(fun(A,set(C)),fun(B,set(D)),set(C),set(D),bNF_rel_fun(A,B,set(C),set(D),A3,bNF_rel_set(C,D,B2)),bNF_rel_set(C,D,B2))),aTP_Lamp_aqg(set(A),fun(fun(A,set(C)),set(C)))),aTP_Lamp_aqh(set(B),fun(fun(B,set(D)),set(D))))) ).

% UNION_transfer
tff(fact_5056_empty__transfer,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool))] : pp(aa(set(B),bool,aa(set(A),fun(set(B),bool),bNF_rel_set(A,B,A3),bot_bot(set(A))),bot_bot(set(B)))) ).

% empty_transfer
tff(fact_5057_Union__transfer,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool))] : pp(aa(fun(set(set(B)),set(B)),bool,aa(fun(set(set(A)),set(A)),fun(fun(set(set(B)),set(B)),bool),bNF_rel_fun(set(set(A)),set(set(B)),set(A),set(B),bNF_rel_set(set(A),set(B),bNF_rel_set(A,B,A3)),bNF_rel_set(A,B,A3)),complete_Sup_Sup(set(A))),complete_Sup_Sup(set(B)))) ).

% Union_transfer
tff(fact_5058_set__relator__eq__onp,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( bNF_rel_set(A,A,bNF_eq_onp(A,P)) = bNF_eq_onp(set(A),aTP_Lamp_aqi(fun(A,bool),fun(set(A),bool),P)) ) ).

% set_relator_eq_onp
tff(fact_5059_Inf__multiset_Otransfer,axiom,
    ! [A: $tType] : pp(aa(fun(set(multiset(A)),multiset(A)),bool,aa(fun(set(fun(A,nat)),fun(A,nat)),fun(fun(set(multiset(A)),multiset(A)),bool),bNF_rel_fun(set(fun(A,nat)),set(multiset(A)),fun(A,nat),multiset(A),bNF_rel_set(fun(A,nat),multiset(A),pcr_multiset(A,A,fequal(A))),pcr_multiset(A,A,fequal(A))),aTP_Lamp_apk(set(fun(A,nat)),fun(A,nat))),complete_Inf_Inf(multiset(A)))) ).

% Inf_multiset.transfer
tff(fact_5060_filter__mset_Oabs__eq,axiom,
    ! [A: $tType,X2: fun(A,nat),Xa: fun(A,bool)] :
      ( pp(aa(fun(A,nat),bool,aa(fun(A,nat),fun(fun(A,nat),bool),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),X2),X2))
     => ( aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),Xa),aa(fun(A,nat),multiset(A),abs_multiset(A),X2)) = aa(fun(A,nat),multiset(A),abs_multiset(A),aa(fun(A,bool),fun(A,nat),aTP_Lamp_aqj(fun(A,nat),fun(fun(A,bool),fun(A,nat)),X2),Xa)) ) ) ).

% filter_mset.abs_eq
tff(fact_5061_filter__mset__def,axiom,
    ! [A: $tType] : ( filter_mset(A) = aa(fun(fun(A,bool),fun(fun(A,nat),fun(A,nat))),fun(fun(A,bool),fun(multiset(A),multiset(A))),map_fun(fun(A,bool),fun(A,bool),fun(fun(A,nat),fun(A,nat)),fun(multiset(A),multiset(A)),id(fun(A,bool)),map_fun(multiset(A),fun(A,nat),fun(A,nat),multiset(A),count(A),abs_multiset(A))),aTP_Lamp_apx(fun(A,bool),fun(fun(A,nat),fun(A,nat)))) ) ).

% filter_mset_def
tff(fact_5062_filter__mset__True,axiom,
    ! [A: $tType,M: multiset(A)] : ( aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),aTP_Lamp_nn(A,bool)),M) = M ) ).

% filter_mset_True
tff(fact_5063_filter__mset__False,axiom,
    ! [A: $tType,M: multiset(A)] : ( aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),aTP_Lamp_ao(A,bool)),M) = zero_zero(multiset(A)) ) ).

% filter_mset_False
tff(fact_5064_set__mset__filter,axiom,
    ! [A: $tType,P: fun(A,bool),M: multiset(A)] : ( aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),P),M)) = aa(fun(A,bool),set(A),collect(A),aa(multiset(A),fun(A,bool),aTP_Lamp_aqk(fun(A,bool),fun(multiset(A),fun(A,bool)),P),M)) ) ).

% set_mset_filter
tff(fact_5065_filter__mset__mset__set,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),P),mset_set(A,A3)) = mset_set(A,aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_dh(set(A),fun(fun(A,bool),fun(A,bool)),A3),P))) ) ) ).

% filter_mset_mset_set
tff(fact_5066_mset__filter,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( mset(A,aa(list(A),list(A),filter2(A,P),Xs)) = aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),P),mset(A,Xs)) ) ).

% mset_filter
tff(fact_5067_filter__mset_Otransfer,axiom,
    ! [A: $tType] : pp(aa(fun(fun(A,bool),fun(multiset(A),multiset(A))),bool,aa(fun(fun(A,bool),fun(fun(A,nat),fun(A,nat))),fun(fun(fun(A,bool),fun(multiset(A),multiset(A))),bool),bNF_rel_fun(fun(A,bool),fun(A,bool),fun(fun(A,nat),fun(A,nat)),fun(multiset(A),multiset(A)),fequal(fun(A,bool)),bNF_rel_fun(fun(A,nat),multiset(A),fun(A,nat),multiset(A),pcr_multiset(A,A,fequal(A)),pcr_multiset(A,A,fequal(A)))),aTP_Lamp_apx(fun(A,bool),fun(fun(A,nat),fun(A,nat)))),filter_mset(A))) ).

% filter_mset.transfer
tff(fact_5068_filter__filter__mset,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),M: multiset(A)] : ( aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),P),aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),Q),M)) = aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_aim(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q)),M) ) ).

% filter_filter_mset
tff(fact_5069_multiset__partition,axiom,
    ! [A: $tType,M: multiset(A),P: fun(A,bool)] : ( M = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),P),M)),aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),aTP_Lamp_as(fun(A,bool),fun(A,bool),P)),M)) ) ).

% multiset_partition
tff(fact_5070_image__mset__If,axiom,
    ! [A: $tType,B: $tType,P: fun(B,bool),F2: fun(B,A),G: fun(B,A),A3: multiset(B)] : ( aa(multiset(B),multiset(A),image_mset(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_ca(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),F2),G)),A3) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),aa(multiset(B),multiset(A),image_mset(B,A,F2),aa(multiset(B),multiset(B),aa(fun(B,bool),fun(multiset(B),multiset(B)),filter_mset(B),P),A3))),aa(multiset(B),multiset(A),image_mset(B,A,G),aa(multiset(B),multiset(B),aa(fun(B,bool),fun(multiset(B),multiset(B)),filter_mset(B),aTP_Lamp_cb(fun(B,bool),fun(B,bool),P)),A3))) ) ).

% image_mset_If
tff(fact_5071_filter__eq__replicate__mset,axiom,
    ! [A: $tType,X2: A,D2: multiset(A)] : ( aa(multiset(A),multiset(A),aa(fun(A,bool),fun(multiset(A),multiset(A)),filter_mset(A),aTP_Lamp_ct(A,fun(A,bool),X2)),D2) = replicate_mset(A,aa(A,nat,aa(multiset(A),fun(A,nat),count(A),D2),X2),X2) ) ).

% filter_eq_replicate_mset
tff(fact_5072_zero__multiset_Otransfer,axiom,
    ! [A: $tType] : pp(aa(multiset(A),bool,aa(fun(A,nat),fun(multiset(A),bool),pcr_multiset(A,A,fequal(A)),aTP_Lamp_apq(A,nat)),zero_zero(multiset(A)))) ).

% zero_multiset.transfer
tff(fact_5073_multiset_Orep__transfer,axiom,
    ! [D: $tType,E: $tType,T2: fun(D,fun(E,bool))] : pp(aa(fun(multiset(E),fun(E,nat)),bool,aa(fun(fun(D,nat),fun(D,nat)),fun(fun(multiset(E),fun(E,nat)),bool),bNF_rel_fun(fun(D,nat),multiset(E),fun(D,nat),fun(E,nat),pcr_multiset(D,E,T2),bNF_rel_fun(D,E,nat,nat,T2,fequal(nat))),aTP_Lamp_aql(fun(D,nat),fun(D,nat))),count(E))) ).

% multiset.rep_transfer
tff(fact_5074_add__mset_Otransfer,axiom,
    ! [A: $tType] : pp(aa(fun(A,fun(multiset(A),multiset(A))),bool,aa(fun(A,fun(fun(A,nat),fun(A,nat))),fun(fun(A,fun(multiset(A),multiset(A))),bool),bNF_rel_fun(A,A,fun(fun(A,nat),fun(A,nat)),fun(multiset(A),multiset(A)),fequal(A),bNF_rel_fun(fun(A,nat),multiset(A),fun(A,nat),multiset(A),pcr_multiset(A,A,fequal(A)),pcr_multiset(A,A,fequal(A)))),aTP_Lamp_apt(A,fun(fun(A,nat),fun(A,nat)))),add_mset(A))) ).

% add_mset.transfer
tff(fact_5075_plus__multiset_Otransfer,axiom,
    ! [A: $tType] : pp(aa(fun(multiset(A),fun(multiset(A),multiset(A))),bool,aa(fun(fun(A,nat),fun(fun(A,nat),fun(A,nat))),fun(fun(multiset(A),fun(multiset(A),multiset(A))),bool),bNF_rel_fun(fun(A,nat),multiset(A),fun(fun(A,nat),fun(A,nat)),fun(multiset(A),multiset(A)),pcr_multiset(A,A,fequal(A)),bNF_rel_fun(fun(A,nat),multiset(A),fun(A,nat),multiset(A),pcr_multiset(A,A,fequal(A)),pcr_multiset(A,A,fequal(A)))),aTP_Lamp_apr(fun(A,nat),fun(fun(A,nat),fun(A,nat)))),plus_plus(multiset(A)))) ).

% plus_multiset.transfer
tff(fact_5076_minus__multiset_Otransfer,axiom,
    ! [A: $tType] : pp(aa(fun(multiset(A),fun(multiset(A),multiset(A))),bool,aa(fun(fun(A,nat),fun(fun(A,nat),fun(A,nat))),fun(fun(multiset(A),fun(multiset(A),multiset(A))),bool),bNF_rel_fun(fun(A,nat),multiset(A),fun(fun(A,nat),fun(A,nat)),fun(multiset(A),multiset(A)),pcr_multiset(A,A,fequal(A)),bNF_rel_fun(fun(A,nat),multiset(A),fun(A,nat),multiset(A),pcr_multiset(A,A,fequal(A)),pcr_multiset(A,A,fequal(A)))),aTP_Lamp_aps(fun(A,nat),fun(fun(A,nat),fun(A,nat)))),minus_minus(multiset(A)))) ).

% minus_multiset.transfer
tff(fact_5077_repeat__mset_Otransfer,axiom,
    ! [A: $tType] : pp(aa(fun(nat,fun(multiset(A),multiset(A))),bool,aa(fun(nat,fun(fun(A,nat),fun(A,nat))),fun(fun(nat,fun(multiset(A),multiset(A))),bool),bNF_rel_fun(nat,nat,fun(fun(A,nat),fun(A,nat)),fun(multiset(A),multiset(A)),fequal(nat),bNF_rel_fun(fun(A,nat),multiset(A),fun(A,nat),multiset(A),pcr_multiset(A,A,fequal(A)),pcr_multiset(A,A,fequal(A)))),aTP_Lamp_apy(nat,fun(fun(A,nat),fun(A,nat)))),repeat_mset(A))) ).

% repeat_mset.transfer
tff(fact_5078_minus__coset__filter,axiom,
    ! [A: $tType,A3: set(A),Xs: list(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),coset(A,Xs)) = aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3)),Xs)) ) ).

% minus_coset_filter
tff(fact_5079_multiset_Odomain,axiom,
    ! [C: $tType,B: $tType,T2: fun(C,fun(B,bool)),X4: fun(C,nat)] :
      ( pp(aa(fun(C,nat),bool,aa(fun(fun(C,nat),fun(multiset(B),bool)),fun(fun(C,nat),bool),domainp(fun(C,nat),multiset(B)),pcr_multiset(C,B,T2)),X4))
    <=> ? [Y4: fun(B,nat)] :
          ( pp(aa(fun(B,nat),bool,aa(fun(C,nat),fun(fun(B,nat),bool),bNF_rel_fun(C,B,nat,nat,T2,fequal(nat)),X4),Y4))
          & pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aTP_Lamp_aqm(fun(B,nat),fun(B,bool),Y4)))) ) ) ).

% multiset.domain
tff(fact_5080_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list(A),I2: nat,J2: nat] :
      ( distinct(A,Vs)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I2),J2))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),take(A,I2,Vs))),aa(list(A),set(A),set2(A),drop(A,J2,Vs))) = bot_bot(set(A)) ) ) ) ).

% set_take_disj_set_drop_if_distinct
tff(fact_5081_fun_ODomainp__rel,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( aa(fun(fun(C,A),fun(fun(C,B),bool)),fun(fun(C,A),bool),domainp(fun(C,A),fun(C,B)),bNF_rel_fun(C,C,A,B,fequal(C),R)) = aa(fun(A,bool),fun(fun(C,A),bool),basic_pred_fun(C,A,aTP_Lamp_ahs(C,bool)),aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),R)) ) ).

% fun.Domainp_rel
tff(fact_5082_filter__upt__take__conv,axiom,
    ! [A: $tType,P: fun(A,bool),M2: nat,L: list(A),N: nat] : ( aa(list(nat),list(nat),filter2(nat,aa(list(A),fun(nat,bool),aa(nat,fun(list(A),fun(nat,bool)),aTP_Lamp_aqn(fun(A,bool),fun(nat,fun(list(A),fun(nat,bool))),P),M2),L)),upt(N,M2)) = aa(list(nat),list(nat),filter2(nat,aa(list(A),fun(nat,bool),aTP_Lamp_and(fun(A,bool),fun(list(A),fun(nat,bool)),P),L)),upt(N,M2)) ) ).

% filter_upt_take_conv
tff(fact_5083_take__Cons,axiom,
    ! [A: $tType,N: nat,X2: A,Xs: list(A)] : ( take(A,N,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(nat,list(A),aa(fun(nat,list(A)),fun(nat,list(A)),aa(list(A),fun(fun(nat,list(A)),fun(nat,list(A))),case_nat(list(A)),nil(A)),aa(list(A),fun(nat,list(A)),aTP_Lamp_aqo(A,fun(list(A),fun(nat,list(A))),X2),Xs)),N) ) ).

% take_Cons
tff(fact_5084_union__coset__filter,axiom,
    ! [A: $tType,Xs: list(A),A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),coset(A,Xs)),A3) = coset(A,aa(list(A),list(A),filter2(A,aTP_Lamp_at(set(A),fun(A,bool),A3)),Xs)) ) ).

% union_coset_filter
tff(fact_5085_inter__coset__fold,axiom,
    ! [A: $tType,A3: set(A),Xs: list(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),coset(A,Xs)) = aa(set(A),set(A),fold(A,set(A),remove(A),Xs),A3) ) ).

% inter_coset_fold
tff(fact_5086_multiset_Odomain__eq,axiom,
    ! [A: $tType,X4: fun(A,nat)] :
      ( pp(aa(fun(A,nat),bool,aa(fun(fun(A,nat),fun(multiset(A),bool)),fun(fun(A,nat),bool),domainp(fun(A,nat),multiset(A)),pcr_multiset(A,A,fequal(A))),X4))
    <=> pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_tm(fun(A,nat),fun(A,bool),X4)))) ) ).

% multiset.domain_eq
tff(fact_5087_zip__replicate2,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),N: nat,Y: B] : ( zip(A,B,Xs,replicate(B,N,Y)) = aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_ej(B,fun(A,product_prod(A,B))),Y)),take(A,N,Xs)) ) ).

% zip_replicate2
tff(fact_5088_multiset_Odomain__par,axiom,
    ! [B: $tType,C: $tType,T2: fun(C,fun(B,bool)),DT: fun(C,bool),DS: fun(nat,bool),P23: fun(fun(C,nat),bool)] :
      ( ( aa(fun(C,fun(B,bool)),fun(C,bool),domainp(C,B),T2) = DT )
     => ( ( aa(fun(nat,fun(nat,bool)),fun(nat,bool),domainp(nat,nat),fequal(nat)) = DS )
       => ( left_unique(C,B,T2)
         => ( pp(aa(fun(fun(B,nat),bool),bool,aa(fun(fun(C,nat),bool),fun(fun(fun(B,nat),bool),bool),bNF_rel_fun(fun(C,nat),fun(B,nat),bool,bool,bNF_rel_fun(C,B,nat,nat,T2,fequal(nat)),fequal(bool)),P23),aTP_Lamp_aqp(fun(B,nat),bool)))
           => ( aa(fun(fun(C,nat),fun(multiset(B),bool)),fun(fun(C,nat),bool),domainp(fun(C,nat),multiset(B)),pcr_multiset(C,B,T2)) = aa(fun(fun(C,nat),bool),fun(fun(C,nat),bool),aa(fun(fun(C,nat),bool),fun(fun(fun(C,nat),bool),fun(fun(C,nat),bool)),inf_inf(fun(fun(C,nat),bool)),aa(fun(nat,bool),fun(fun(C,nat),bool),basic_pred_fun(C,nat,DT),DS)),P23) ) ) ) ) ) ).

% multiset.domain_par
tff(fact_5089_multiset_Odomain__par__left__total,axiom,
    ! [B: $tType,C: $tType,T2: fun(C,fun(B,bool)),P2: fun(fun(C,nat),bool)] :
      ( left_total(fun(C,nat),fun(B,nat),bNF_rel_fun(C,B,nat,nat,T2,fequal(nat)))
     => ( pp(aa(fun(fun(B,nat),bool),bool,aa(fun(fun(C,nat),bool),fun(fun(fun(B,nat),bool),bool),bNF_rel_fun(fun(C,nat),fun(B,nat),bool,bool,bNF_rel_fun(C,B,nat,nat,T2,fequal(nat)),fequal(bool)),P2),aTP_Lamp_aqp(fun(B,nat),bool)))
       => ( aa(fun(fun(C,nat),fun(multiset(B),bool)),fun(fun(C,nat),bool),domainp(fun(C,nat),multiset(B)),pcr_multiset(C,B,T2)) = P2 ) ) ) ).

% multiset.domain_par_left_total
tff(fact_5090_prod__mset_Oremove,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [X2: A,A3: multiset(A)] :
          ( pp(aa(set(A),bool,member(A,X2),aa(multiset(A),set(A),set_mset(A),A3)))
         => ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),A3),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X2),zero_zero(multiset(A)))))) ) ) ) ).

% prod_mset.remove
tff(fact_5091_prod__mset__empty,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),zero_zero(multiset(A))) = one_one(A) ) ) ).

% prod_mset_empty
tff(fact_5092_prod__mset_Oadd__mset,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [X2: A,N4: multiset(A)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X2),N4)) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),N4)) ) ) ).

% prod_mset.add_mset
tff(fact_5093_prod__mset_Ounion,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: multiset(A),N4: multiset(A)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),M),N4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),M)),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),N4)) ) ) ).

% prod_mset.union
tff(fact_5094_prod__mset__Un,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: multiset(A),B2: multiset(A)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),A3)),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),B2)) ) ) ).

% prod_mset_Un
tff(fact_5095_prod__mset_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,aTP_Lamp_oe(B,A)),A3)) = one_one(A) ) ) ).

% prod_mset.neutral_const
tff(fact_5096_prod__mset_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),X2: B,A3: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X2),A3))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X2)),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),A3))) ) ) ).

% prod_mset.insert
tff(fact_5097_prod__mset_Oswap,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,fun(C,A)),B2: multiset(C),A3: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,aa(multiset(C),fun(B,A),aTP_Lamp_aqq(fun(B,fun(C,A)),fun(multiset(C),fun(B,A)),G),B2)),A3)) = aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(C),multiset(A),image_mset(C,A,aa(multiset(B),fun(C,A),aTP_Lamp_aqr(fun(B,fun(C,A)),fun(multiset(B),fun(C,A)),G),A3)),B2)) ) ) ).

% prod_mset.swap
tff(fact_5098_typedef__left__unique,axiom,
    ! [B: $tType,A: $tType,Rep: fun(B,A),Abs: fun(A,B),A3: set(A),T2: fun(A,fun(B,bool))] :
      ( type_definition(B,A,Rep,Abs,A3)
     => ( ! [X: A,Xa4: B] :
            ( pp(aa(B,bool,aa(A,fun(B,bool),T2,X),Xa4))
          <=> ( X = aa(B,A,Rep,Xa4) ) )
       => left_unique(A,B,T2) ) ) ).

% typedef_left_unique
tff(fact_5099_left__unique__iff,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool))] :
      ( left_unique(A,B,R)
    <=> ! [Z5: B] : uniq(A,aa(B,fun(A,bool),aTP_Lamp_gv(fun(A,fun(B,bool)),fun(B,fun(A,bool)),R),Z5)) ) ).

% left_unique_iff
tff(fact_5100_prod__mset_Oneutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: multiset(A)] :
          ( ! [X: A] :
              ( pp(aa(set(A),bool,member(A,X),aa(multiset(A),set(A),set_mset(A),A3)))
             => ( X = one_one(A) ) )
         => ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),A3) = one_one(A) ) ) ) ).

% prod_mset.neutral
tff(fact_5101_prod__mset_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),H2: fun(B,A),A3: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_mv(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2)),A3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),A3))),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,H2),A3))) ) ) ).

% prod_mset.distrib
tff(fact_5102_rat_Odomain,axiom,
    ! [X4: product_prod(int,int)] :
      ( pp(aa(product_prod(int,int),bool,aa(fun(product_prod(int,int),fun(rat,bool)),fun(product_prod(int,int),bool),domainp(product_prod(int,int),rat),pcr_rat),X4))
    <=> ? [Y4: product_prod(int,int)] :
          ( pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),basic_rel_prod(int,int,int,int,fequal(int),fequal(int)),X4),Y4))
          & pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,Y4),Y4)) ) ) ).

% rat.domain
tff(fact_5103_is__unit__prod__mset__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: multiset(A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),A3)),one_one(A)))
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),aa(multiset(A),set(A),set_mset(A),A3)))
             => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),one_one(A))) ) ) ) ).

% is_unit_prod_mset_iff
tff(fact_5104_prod__mset_Oeq__fold,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: multiset(A)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),M) = fold_mset(A,A,times_times(A),one_one(A),M) ) ) ).

% prod_mset.eq_fold
tff(fact_5105_prod__mset__delta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Y: B,C2: A,A3: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_aqs(B,fun(A,fun(B,A)),Y),C2)),A3)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),C2),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),A3),Y)) ) ) ).

% prod_mset_delta'
tff(fact_5106_prod__mset__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Y: B,C2: A,A3: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_aqt(B,fun(A,fun(B,A)),Y),C2)),A3)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),C2),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),A3),Y)) ) ) ).

% prod_mset_delta
tff(fact_5107_prod__mset__multiplicity,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: multiset(A)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),M) = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7121269368397514597t_prod(A,A),aTP_Lamp_aqu(multiset(A),fun(A,A),M)),aa(multiset(A),set(A),set_mset(A),M)) ) ) ).

% prod_mset_multiplicity
tff(fact_5108_composed__equiv__rel__eq__onp,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool)),P: fun(A,bool),P2: fun(B,bool),P9: fun(A,bool)] :
      ( left_unique(A,B,R)
     => ( pp(aa(fun(B,bool),bool,aa(fun(A,bool),fun(fun(B,bool),bool),bNF_rel_fun(A,B,bool,bool,R,fequal(bool)),P),P2))
       => ( ( aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),R) = P9 )
         => ( aa(fun(B,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(B,bool)),fun(fun(B,fun(A,bool)),fun(A,fun(A,bool))),relcompp(A,B,A),R),aa(fun(B,fun(A,bool)),fun(B,fun(A,bool)),aa(fun(B,fun(B,bool)),fun(fun(B,fun(A,bool)),fun(B,fun(A,bool))),relcompp(B,B,A),bNF_eq_onp(B,P2)),conversep(A,B,R))) = bNF_eq_onp(A,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),P9),P)) ) ) ) ) ).

% composed_equiv_rel_eq_onp
tff(fact_5109_rat_Odomain__par,axiom,
    ! [DR1: fun(int,bool),DR2: fun(int,bool),P23: fun(product_prod(int,int),bool)] :
      ( ( aa(fun(int,fun(int,bool)),fun(int,bool),domainp(int,int),fequal(int)) = DR1 )
     => ( ( aa(fun(int,fun(int,bool)),fun(int,bool),domainp(int,int),fequal(int)) = DR2 )
       => ( pp(aa(fun(product_prod(int,int),bool),bool,aa(fun(product_prod(int,int),bool),fun(fun(product_prod(int,int),bool),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),bool,bool,basic_rel_prod(int,int,int,int,fequal(int),fequal(int)),fequal(bool)),P23),aTP_Lamp_aqv(product_prod(int,int),bool)))
         => ( aa(fun(product_prod(int,int),fun(rat,bool)),fun(product_prod(int,int),bool),domainp(product_prod(int,int),rat),pcr_rat) = aa(fun(product_prod(int,int),bool),fun(product_prod(int,int),bool),aa(fun(product_prod(int,int),bool),fun(fun(product_prod(int,int),bool),fun(product_prod(int,int),bool)),inf_inf(fun(product_prod(int,int),bool)),basic_pred_prod(int,int,DR1,DR2)),P23) ) ) ) ) ).

% rat.domain_par
tff(fact_5110_wfP__SUP,axiom,
    ! [B: $tType,A: $tType,R2: fun(A,fun(B,fun(B,bool)))] :
      ( ! [I3: A] : wfP(B,aa(A,fun(B,fun(B,bool)),R2,I3))
     => ( ! [I3: A,J4: A] :
            ( ( aa(A,fun(B,fun(B,bool)),R2,I3) != aa(A,fun(B,fun(B,bool)),R2,J4) )
           => ( aa(fun(B,bool),fun(B,bool),aa(fun(B,bool),fun(fun(B,bool),fun(B,bool)),inf_inf(fun(B,bool)),aa(fun(B,fun(B,bool)),fun(B,bool),domainp(B,B),aa(A,fun(B,fun(B,bool)),R2,I3))),rangep(B,B,aa(A,fun(B,fun(B,bool)),R2,J4))) = bot_bot(fun(B,bool)) ) )
       => wfP(B,aa(set(fun(B,fun(B,bool))),fun(B,fun(B,bool)),complete_Sup_Sup(fun(B,fun(B,bool))),aa(set(A),set(fun(B,fun(B,bool))),image2(A,fun(B,fun(B,bool)),R2),top_top(set(A))))) ) ) ).

% wfP_SUP
tff(fact_5111_wfP__empty,axiom,
    ! [A: $tType] : wfP(A,aTP_Lamp_aqw(A,fun(A,bool))) ).

% wfP_empty
tff(fact_5112_relcompp__bot1,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: fun(C,fun(B,bool))] : ( aa(fun(C,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(C,bool)),fun(fun(C,fun(B,bool)),fun(A,fun(B,bool))),relcompp(A,C,B),bot_bot(fun(A,fun(C,bool)))),R) = bot_bot(fun(A,fun(B,bool))) ) ).

% relcompp_bot1
tff(fact_5113_relcompp__bot2,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: fun(A,fun(C,bool))] : ( aa(fun(C,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(C,bool)),fun(fun(C,fun(B,bool)),fun(A,fun(B,bool))),relcompp(A,C,B),R),bot_bot(fun(C,fun(B,bool)))) = bot_bot(fun(A,fun(B,bool))) ) ).

% relcompp_bot2
tff(fact_5114_prod_Opred__True,axiom,
    ! [B: $tType,A: $tType,X4: product_prod(A,B)] : pp(aa(product_prod(A,B),bool,basic_pred_prod(A,B,aTP_Lamp_nn(A,bool),aTP_Lamp_aqx(B,bool)),X4)) ).

% prod.pred_True
tff(fact_5115_OO__def,axiom,
    ! [A: $tType,C: $tType,B: $tType,R: fun(A,fun(C,bool)),S: fun(C,fun(B,bool)),X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(C,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(C,bool)),fun(fun(C,fun(B,bool)),fun(A,fun(B,bool))),relcompp(A,C,B),R),S),X4),Xa3))
    <=> ? [Y4: C] :
          ( pp(aa(C,bool,aa(A,fun(C,bool),R,X4),Y4))
          & pp(aa(B,bool,aa(C,fun(B,bool),S,Y4),Xa3)) ) ) ).

% OO_def
tff(fact_5116_prod_Omap__cong__pred,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,X2: product_prod(A,B),Ya2: product_prod(A,B),F1: fun(A,C),G1: fun(A,C),F22: fun(B,D),G22: fun(B,D)] :
      ( ( X2 = Ya2 )
     => ( pp(aa(product_prod(A,B),bool,basic_pred_prod(A,B,aa(fun(A,C),fun(A,bool),aTP_Lamp_aqy(fun(A,C),fun(fun(A,C),fun(A,bool)),F1),G1),aa(fun(B,D),fun(B,bool),aTP_Lamp_aqz(fun(B,D),fun(fun(B,D),fun(B,bool)),F22),G22)),Ya2))
       => ( aa(product_prod(A,B),product_prod(C,D),product_map_prod(A,C,B,D,F1,F22),X2) = aa(product_prod(A,B),product_prod(C,D),product_map_prod(A,C,B,D,G1,G22),Ya2) ) ) ) ).

% prod.map_cong_pred
tff(fact_5117_relcompp__relcomp__eq,axiom,
    ! [A: $tType,C: $tType,B: $tType,R2: set(product_prod(A,B)),S2: set(product_prod(B,C)),X4: A,Xa3: C] :
      ( pp(aa(C,bool,aa(A,fun(C,bool),aa(fun(B,fun(C,bool)),fun(A,fun(C,bool)),aa(fun(A,fun(B,bool)),fun(fun(B,fun(C,bool)),fun(A,fun(C,bool))),relcompp(A,B,C),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),R2)),aTP_Lamp_ara(set(product_prod(B,C)),fun(B,fun(C,bool)),S2)),X4),Xa3))
    <=> pp(aa(set(product_prod(A,C)),bool,member(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),X4),Xa3)),relcomp(A,B,C,R2,S2))) ) ).

% relcompp_relcomp_eq
tff(fact_5118_pcr__Domainp,axiom,
    ! [C: $tType,B: $tType,A: $tType,B2: fun(A,fun(B,bool)),P: fun(A,bool),A3: fun(C,fun(A,bool))] :
      ( ( aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),B2) = P )
     => ! [X4: C] :
          ( pp(aa(C,bool,aa(fun(C,fun(B,bool)),fun(C,bool),domainp(C,B),aa(fun(A,fun(B,bool)),fun(C,fun(B,bool)),aa(fun(C,fun(A,bool)),fun(fun(A,fun(B,bool)),fun(C,fun(B,bool))),relcompp(C,A,B),A3),B2)),X4))
        <=> ? [Y4: A] :
              ( pp(aa(A,bool,aa(C,fun(A,bool),A3,X4),Y4))
              & pp(aa(A,bool,P,Y4)) ) ) ) ).

% pcr_Domainp
tff(fact_5119_relcompp__SUP__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,S2: fun(A,fun(C,bool)),R2: fun(D,fun(C,fun(B,bool))),I: set(D)] : ( aa(fun(C,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(C,bool)),fun(fun(C,fun(B,bool)),fun(A,fun(B,bool))),relcompp(A,C,B),S2),aa(set(fun(C,fun(B,bool))),fun(C,fun(B,bool)),complete_Sup_Sup(fun(C,fun(B,bool))),aa(set(D),set(fun(C,fun(B,bool))),image2(D,fun(C,fun(B,bool)),R2),I))) = aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Sup_Sup(fun(A,fun(B,bool))),aa(set(D),set(fun(A,fun(B,bool))),image2(D,fun(A,fun(B,bool)),aa(fun(D,fun(C,fun(B,bool))),fun(D,fun(A,fun(B,bool))),aTP_Lamp_arb(fun(A,fun(C,bool)),fun(fun(D,fun(C,fun(B,bool))),fun(D,fun(A,fun(B,bool)))),S2),R2)),I)) ) ).

% relcompp_SUP_distrib
tff(fact_5120_relcompp__SUP__distrib2,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,R2: fun(D,fun(A,fun(C,bool))),I: set(D),S2: fun(C,fun(B,bool))] : ( aa(fun(C,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(C,bool)),fun(fun(C,fun(B,bool)),fun(A,fun(B,bool))),relcompp(A,C,B),aa(set(fun(A,fun(C,bool))),fun(A,fun(C,bool)),complete_Sup_Sup(fun(A,fun(C,bool))),aa(set(D),set(fun(A,fun(C,bool))),image2(D,fun(A,fun(C,bool)),R2),I))),S2) = aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Sup_Sup(fun(A,fun(B,bool))),aa(set(D),set(fun(A,fun(B,bool))),image2(D,fun(A,fun(B,bool)),aa(fun(C,fun(B,bool)),fun(D,fun(A,fun(B,bool))),aTP_Lamp_arc(fun(D,fun(A,fun(C,bool))),fun(fun(C,fun(B,bool)),fun(D,fun(A,fun(B,bool)))),R2),S2)),I)) ) ).

% relcompp_SUP_distrib2
tff(fact_5121_pcr__Domainp__par,axiom,
    ! [A: $tType,B: $tType,C: $tType,B2: fun(A,fun(B,bool)),P24: fun(A,bool),A3: fun(C,fun(A,bool)),P12: fun(C,bool),P23: fun(C,bool)] :
      ( ( aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),B2) = P24 )
     => ( ( aa(fun(C,fun(A,bool)),fun(C,bool),domainp(C,A),A3) = P12 )
       => ( pp(aa(fun(A,bool),bool,aa(fun(C,bool),fun(fun(A,bool),bool),bNF_rel_fun(C,A,bool,bool,A3,fequal(bool)),P23),P24))
         => ( aa(fun(C,fun(B,bool)),fun(C,bool),domainp(C,B),aa(fun(A,fun(B,bool)),fun(C,fun(B,bool)),aa(fun(C,fun(A,bool)),fun(fun(A,fun(B,bool)),fun(C,fun(B,bool))),relcompp(C,A,B),A3),B2)) = aa(fun(C,bool),fun(C,bool),aa(fun(C,bool),fun(fun(C,bool),fun(C,bool)),inf_inf(fun(C,bool)),P12),P23) ) ) ) ) ).

% pcr_Domainp_par
tff(fact_5122_relcomp__def,axiom,
    ! [A: $tType,C: $tType,B: $tType,X4: set(product_prod(A,B)),Xa3: set(product_prod(B,C))] : ( relcomp(A,B,C,X4,Xa3) = aa(fun(product_prod(A,C),bool),set(product_prod(A,C)),collect(product_prod(A,C)),aa(fun(A,fun(C,bool)),fun(product_prod(A,C),bool),product_case_prod(A,C,bool),aa(fun(B,fun(C,bool)),fun(A,fun(C,bool)),aa(fun(A,fun(B,bool)),fun(fun(B,fun(C,bool)),fun(A,fun(C,bool))),relcompp(A,B,C),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),X4)),aTP_Lamp_ara(set(product_prod(B,C)),fun(B,fun(C,bool)),Xa3)))) ) ).

% relcomp_def
tff(fact_5123_wfP__wf__eq,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( wfP(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2))
    <=> wf(A,R2) ) ).

% wfP_wf_eq
tff(fact_5124_wfP__def,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool))] :
      ( wfP(A,R2)
    <=> wf(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2))) ) ).

% wfP_def
tff(fact_5125_prod_Orel__compp__Grp,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: fun(A,fun(C,bool)),R22: fun(B,fun(D,bool))] : ( basic_rel_prod(A,C,B,D,R1,R22) = aa(fun(product_prod(product_prod(A,C),product_prod(B,D)),fun(product_prod(C,D),bool)),fun(product_prod(A,B),fun(product_prod(C,D),bool)),aa(fun(product_prod(A,B),fun(product_prod(product_prod(A,C),product_prod(B,D)),bool)),fun(fun(product_prod(product_prod(A,C),product_prod(B,D)),fun(product_prod(C,D),bool)),fun(product_prod(A,B),fun(product_prod(C,D),bool))),relcompp(product_prod(A,B),product_prod(product_prod(A,C),product_prod(B,D)),product_prod(C,D)),conversep(product_prod(product_prod(A,C),product_prod(B,D)),product_prod(A,B),bNF_Grp(product_prod(product_prod(A,C),product_prod(B,D)),product_prod(A,B),aa(fun(product_prod(product_prod(A,C),product_prod(B,D)),bool),set(product_prod(product_prod(A,C),product_prod(B,D))),collect(product_prod(product_prod(A,C),product_prod(B,D))),aa(fun(B,fun(D,bool)),fun(product_prod(product_prod(A,C),product_prod(B,D)),bool),aTP_Lamp_aos(fun(A,fun(C,bool)),fun(fun(B,fun(D,bool)),fun(product_prod(product_prod(A,C),product_prod(B,D)),bool)),R1),R22)),product_map_prod(product_prod(A,C),A,product_prod(B,D),B,product_fst(A,C),product_fst(B,D))))),bNF_Grp(product_prod(product_prod(A,C),product_prod(B,D)),product_prod(C,D),aa(fun(product_prod(product_prod(A,C),product_prod(B,D)),bool),set(product_prod(product_prod(A,C),product_prod(B,D))),collect(product_prod(product_prod(A,C),product_prod(B,D))),aa(fun(B,fun(D,bool)),fun(product_prod(product_prod(A,C),product_prod(B,D)),bool),aTP_Lamp_aos(fun(A,fun(C,bool)),fun(fun(B,fun(D,bool)),fun(product_prod(product_prod(A,C),product_prod(B,D)),bool)),R1),R22)),product_map_prod(product_prod(A,C),C,product_prod(B,D),D,product_snd(A,C),product_snd(B,D)))) ) ).

% prod.rel_compp_Grp
tff(fact_5126_multiset_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( rel_mset(A,B,R) = aa(fun(multiset(product_prod(A,B)),fun(multiset(B),bool)),fun(multiset(A),fun(multiset(B),bool)),aa(fun(multiset(A),fun(multiset(product_prod(A,B)),bool)),fun(fun(multiset(product_prod(A,B)),fun(multiset(B),bool)),fun(multiset(A),fun(multiset(B),bool))),relcompp(multiset(A),multiset(product_prod(A,B)),multiset(B)),conversep(multiset(product_prod(A,B)),multiset(A),bNF_Grp(multiset(product_prod(A,B)),multiset(A),aa(fun(multiset(product_prod(A,B)),bool),set(multiset(product_prod(A,B))),collect(multiset(product_prod(A,B))),aTP_Lamp_api(fun(A,fun(B,bool)),fun(multiset(product_prod(A,B)),bool),R)),image_mset(product_prod(A,B),A,product_fst(A,B))))),bNF_Grp(multiset(product_prod(A,B)),multiset(B),aa(fun(multiset(product_prod(A,B)),bool),set(multiset(product_prod(A,B))),collect(multiset(product_prod(A,B))),aTP_Lamp_api(fun(A,fun(B,bool)),fun(multiset(product_prod(A,B)),bool),R)),image_mset(product_prod(A,B),B,product_snd(A,B)))) ) ).

% multiset.rel_compp_Grp
tff(fact_5127_fun_Orel__compp__Grp,axiom,
    ! [D: $tType,B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( bNF_rel_fun(D,D,A,B,fequal(D),R) = aa(fun(fun(D,product_prod(A,B)),fun(fun(D,B),bool)),fun(fun(D,A),fun(fun(D,B),bool)),aa(fun(fun(D,A),fun(fun(D,product_prod(A,B)),bool)),fun(fun(fun(D,product_prod(A,B)),fun(fun(D,B),bool)),fun(fun(D,A),fun(fun(D,B),bool))),relcompp(fun(D,A),fun(D,product_prod(A,B)),fun(D,B)),conversep(fun(D,product_prod(A,B)),fun(D,A),bNF_Grp(fun(D,product_prod(A,B)),fun(D,A),aa(fun(fun(D,product_prod(A,B)),bool),set(fun(D,product_prod(A,B))),collect(fun(D,product_prod(A,B))),aTP_Lamp_fc(fun(A,fun(B,bool)),fun(fun(D,product_prod(A,B)),bool),R)),comp(product_prod(A,B),A,D,product_fst(A,B))))),bNF_Grp(fun(D,product_prod(A,B)),fun(D,B),aa(fun(fun(D,product_prod(A,B)),bool),set(fun(D,product_prod(A,B))),collect(fun(D,product_prod(A,B))),aTP_Lamp_fc(fun(A,fun(B,bool)),fun(fun(D,product_prod(A,B)),bool),R)),comp(product_prod(A,B),B,D,product_snd(A,B)))) ) ).

% fun.rel_compp_Grp
tff(fact_5128_Grp__def,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,B),X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),bNF_Grp(A,B,A3,F2),X4),Xa3))
    <=> ( ( Xa3 = aa(A,B,F2,X4) )
        & pp(aa(set(A),bool,member(A,X4),A3)) ) ) ).

% Grp_def
tff(fact_5129_list_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,B)] : ( list_all2(A,B,bNF_Grp(A,B,A3,F2)) = bNF_Grp(list(A),list(B),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aTP_Lamp_anw(set(A),fun(list(A),bool),A3)),map(A,B,F2)) ) ).

% list.rel_Grp
tff(fact_5130_multiset_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,B)] : ( rel_mset(A,B,bNF_Grp(A,B,A3,F2)) = bNF_Grp(multiset(A),multiset(B),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aTP_Lamp_ard(set(A),fun(multiset(A),bool),A3)),image_mset(A,B,F2)) ) ).

% multiset.rel_Grp
tff(fact_5131_fun_Orel__Grp,axiom,
    ! [D: $tType,B: $tType,A: $tType,A3: set(A),F2: fun(A,B)] : ( bNF_rel_fun(D,D,A,B,fequal(D),bNF_Grp(A,B,A3,F2)) = bNF_Grp(fun(D,A),fun(D,B),aa(fun(fun(D,A),bool),set(fun(D,A)),collect(fun(D,A)),aTP_Lamp_are(set(A),fun(fun(D,A),bool),A3)),comp(A,B,D,F2)) ) ).

% fun.rel_Grp
tff(fact_5132_prod_Orel__Grp,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A1: set(A),F1: fun(A,C),A22: set(B),F22: fun(B,D)] : ( basic_rel_prod(A,C,B,D,bNF_Grp(A,C,A1,F1),bNF_Grp(B,D,A22,F22)) = bNF_Grp(product_prod(A,B),product_prod(C,D),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(set(B),fun(product_prod(A,B),bool),aTP_Lamp_arf(set(A),fun(set(B),fun(product_prod(A,B),bool)),A1),A22)),product_map_prod(A,C,B,D,F1,F22)) ) ).

% prod.rel_Grp
tff(fact_5133_OO__Grp__alt,axiom,
    ! [A: $tType,C: $tType,B: $tType,A3: set(C),F2: fun(C,A),G: fun(C,B),X4: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(C,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(C,bool)),fun(fun(C,fun(B,bool)),fun(A,fun(B,bool))),relcompp(A,C,B),conversep(C,A,bNF_Grp(C,A,A3,F2))),bNF_Grp(C,B,A3,G)),X4),Xa3))
    <=> ? [Z5: C] :
          ( pp(aa(set(C),bool,member(C,Z5),A3))
          & ( aa(C,A,F2,Z5) = X4 )
          & ( aa(C,B,G,Z5) = Xa3 ) ) ) ).

% OO_Grp_alt
tff(fact_5134_rat_Odomain__par__left__total,axiom,
    ! [P2: fun(product_prod(int,int),bool)] :
      ( left_total(product_prod(int,int),product_prod(int,int),basic_rel_prod(int,int,int,int,fequal(int),fequal(int)))
     => ( pp(aa(fun(product_prod(int,int),bool),bool,aa(fun(product_prod(int,int),bool),fun(fun(product_prod(int,int),bool),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),bool,bool,basic_rel_prod(int,int,int,int,fequal(int),fequal(int)),fequal(bool)),P2),aTP_Lamp_aqv(product_prod(int,int),bool)))
       => ( aa(fun(product_prod(int,int),fun(rat,bool)),fun(product_prod(int,int),bool),domainp(product_prod(int,int),rat),pcr_rat) = P2 ) ) ) ).

% rat.domain_par_left_total
tff(fact_5135_list_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( list_all2(A,B,R) = aa(fun(list(product_prod(A,B)),fun(list(B),bool)),fun(list(A),fun(list(B),bool)),aa(fun(list(A),fun(list(product_prod(A,B)),bool)),fun(fun(list(product_prod(A,B)),fun(list(B),bool)),fun(list(A),fun(list(B),bool))),relcompp(list(A),list(product_prod(A,B)),list(B)),conversep(list(product_prod(A,B)),list(A),bNF_Grp(list(product_prod(A,B)),list(A),aa(fun(list(product_prod(A,B)),bool),set(list(product_prod(A,B))),collect(list(product_prod(A,B))),aTP_Lamp_aod(fun(A,fun(B,bool)),fun(list(product_prod(A,B)),bool),R)),map(product_prod(A,B),A,product_fst(A,B))))),bNF_Grp(list(product_prod(A,B)),list(B),aa(fun(list(product_prod(A,B)),bool),set(list(product_prod(A,B))),collect(list(product_prod(A,B))),aTP_Lamp_aod(fun(A,fun(B,bool)),fun(list(product_prod(A,B)),bool),R)),map(product_prod(A,B),B,product_snd(A,B)))) ) ).

% list.rel_compp_Grp
tff(fact_5136_right__total__relcompp__transfer,axiom,
    ! [A: $tType,E: $tType,C: $tType,F10: $tType,B: $tType,D: $tType,B2: fun(A,fun(B,bool)),A3: fun(C,fun(D,bool)),C3: fun(E,fun(F10,bool))] :
      ( right_total(A,B,B2)
     => pp(aa(fun(fun(D,fun(B,bool)),fun(fun(B,fun(F10,bool)),fun(D,fun(F10,bool)))),bool,aa(fun(fun(C,fun(A,bool)),fun(fun(A,fun(E,bool)),fun(C,fun(E,bool)))),fun(fun(fun(D,fun(B,bool)),fun(fun(B,fun(F10,bool)),fun(D,fun(F10,bool)))),bool),bNF_rel_fun(fun(C,fun(A,bool)),fun(D,fun(B,bool)),fun(fun(A,fun(E,bool)),fun(C,fun(E,bool))),fun(fun(B,fun(F10,bool)),fun(D,fun(F10,bool))),bNF_rel_fun(C,D,fun(A,bool),fun(B,bool),A3,bNF_rel_fun(A,B,bool,bool,B2,fequal(bool))),bNF_rel_fun(fun(A,fun(E,bool)),fun(B,fun(F10,bool)),fun(C,fun(E,bool)),fun(D,fun(F10,bool)),bNF_rel_fun(A,B,fun(E,bool),fun(F10,bool),B2,bNF_rel_fun(E,F10,bool,bool,C3,fequal(bool))),bNF_rel_fun(C,D,fun(E,bool),fun(F10,bool),A3,bNF_rel_fun(E,F10,bool,bool,C3,fequal(bool))))),aTP_Lamp_arg(fun(A,fun(B,bool)),fun(fun(C,fun(A,bool)),fun(fun(A,fun(E,bool)),fun(C,fun(E,bool)))),B2)),relcompp(D,B,F10))) ) ).

% right_total_relcompp_transfer
tff(fact_5137_typedef__right__total,axiom,
    ! [B: $tType,A: $tType,Rep: fun(B,A),Abs: fun(A,B),A3: set(A),T2: fun(A,fun(B,bool))] :
      ( type_definition(B,A,Rep,Abs,A3)
     => ( ! [X: A,Xa4: B] :
            ( pp(aa(B,bool,aa(A,fun(B,bool),T2,X),Xa4))
          <=> ( X = aa(B,A,Rep,Xa4) ) )
       => right_total(A,B,T2) ) ) ).

% typedef_right_total
tff(fact_5138_right__total__Collect__transfer,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool))] :
      ( right_total(A,B,A3)
     => pp(aa(fun(fun(B,bool),set(B)),bool,aa(fun(fun(A,bool),set(A)),fun(fun(fun(B,bool),set(B)),bool),bNF_rel_fun(fun(A,bool),fun(B,bool),set(A),set(B),bNF_rel_fun(A,B,bool,bool,A3,fequal(bool)),bNF_rel_set(A,B,A3)),aTP_Lamp_ari(fun(A,fun(B,bool)),fun(fun(A,bool),set(A)),A3)),collect(B))) ) ).

% right_total_Collect_transfer
tff(fact_5139_right__total__Domainp__transfer,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,B2: fun(A,fun(B,bool)),A3: fun(C,fun(D,bool))] :
      ( right_total(A,B,B2)
     => pp(aa(fun(fun(D,fun(B,bool)),fun(D,bool)),bool,aa(fun(fun(C,fun(A,bool)),fun(C,bool)),fun(fun(fun(D,fun(B,bool)),fun(D,bool)),bool),bNF_rel_fun(fun(C,fun(A,bool)),fun(D,fun(B,bool)),fun(C,bool),fun(D,bool),bNF_rel_fun(C,D,fun(A,bool),fun(B,bool),A3,bNF_rel_fun(A,B,bool,bool,B2,fequal(bool))),bNF_rel_fun(C,D,bool,bool,A3,fequal(bool))),aTP_Lamp_arj(fun(A,fun(B,bool)),fun(fun(C,fun(A,bool)),fun(C,bool)),B2)),domainp(D,B))) ) ).

% right_total_Domainp_transfer
tff(fact_5140_right__total__Inter__transfer,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool))] :
      ( bi_unique(A,B,A3)
     => ( right_total(A,B,A3)
       => pp(aa(fun(set(set(B)),set(B)),bool,aa(fun(set(set(A)),set(A)),fun(fun(set(set(B)),set(B)),bool),bNF_rel_fun(set(set(A)),set(set(B)),set(A),set(B),bNF_rel_set(set(A),set(B),bNF_rel_set(A,B,A3)),bNF_rel_set(A,B,A3)),aTP_Lamp_ark(fun(A,fun(B,bool)),fun(set(set(A)),set(A)),A3)),complete_Inf_Inf(set(B)))) ) ) ).

% right_total_Inter_transfer
tff(fact_5141_vimage__right__total__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,B2: fun(A,fun(B,bool)),A3: fun(C,fun(D,bool))] :
      ( bi_unique(A,B,B2)
     => ( right_total(C,D,A3)
       => pp(aa(fun(fun(D,B),fun(set(B),set(D))),bool,aa(fun(fun(C,A),fun(set(A),set(C))),fun(fun(fun(D,B),fun(set(B),set(D))),bool),bNF_rel_fun(fun(C,A),fun(D,B),fun(set(A),set(C)),fun(set(B),set(D)),bNF_rel_fun(C,D,A,B,A3,B2),bNF_rel_fun(set(A),set(B),set(C),set(D),bNF_rel_set(A,B,B2),bNF_rel_set(C,D,A3))),aTP_Lamp_arl(fun(C,fun(D,bool)),fun(fun(C,A),fun(set(A),set(C))),A3)),vimage(D,B))) ) ) ).

% vimage_right_total_transfer
tff(fact_5142_right__total__fun__eq__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A3: fun(A,fun(B,bool)),B2: fun(C,fun(D,bool))] :
      ( right_total(A,B,A3)
     => ( bi_unique(C,D,B2)
       => pp(aa(fun(fun(B,D),fun(fun(B,D),bool)),bool,aa(fun(fun(A,C),fun(fun(A,C),bool)),fun(fun(fun(B,D),fun(fun(B,D),bool)),bool),bNF_rel_fun(fun(A,C),fun(B,D),fun(fun(A,C),bool),fun(fun(B,D),bool),bNF_rel_fun(A,B,C,D,A3,B2),bNF_rel_fun(fun(A,C),fun(B,D),bool,bool,bNF_rel_fun(A,B,C,D,A3,B2),fequal(bool))),aTP_Lamp_arm(fun(A,fun(B,bool)),fun(fun(A,C),fun(fun(A,C),bool)),A3)),fequal(fun(B,D)))) ) ) ).

% right_total_fun_eq_transfer
tff(fact_5143_typedef__bi__unique,axiom,
    ! [B: $tType,A: $tType,Rep: fun(B,A),Abs: fun(A,B),A3: set(A),T2: fun(A,fun(B,bool))] :
      ( type_definition(B,A,Rep,Abs,A3)
     => ( ! [X: A,Xa4: B] :
            ( pp(aa(B,bool,aa(A,fun(B,bool),T2,X),Xa4))
          <=> ( X = aa(B,A,Rep,Xa4) ) )
       => bi_unique(A,B,T2) ) ) ).

% typedef_bi_unique
tff(fact_5144_bi__unique__iff,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] :
      ( bi_unique(A,B,R)
    <=> ( ! [Z5: B] : uniq(A,aa(B,fun(A,bool),aTP_Lamp_gv(fun(A,fun(B,bool)),fun(B,fun(A,bool)),R),Z5))
        & ! [Z5: A] : uniq(B,aa(A,fun(B,bool),R,Z5)) ) ) ).

% bi_unique_iff
tff(fact_5145_inter__transfer,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool))] :
      ( bi_unique(A,B,A3)
     => pp(aa(fun(set(B),fun(set(B),set(B))),bool,aa(fun(set(A),fun(set(A),set(A))),fun(fun(set(B),fun(set(B),set(B))),bool),bNF_rel_fun(set(A),set(B),fun(set(A),set(A)),fun(set(B),set(B)),bNF_rel_set(A,B,A3),bNF_rel_fun(set(A),set(B),set(A),set(B),bNF_rel_set(A,B,A3),bNF_rel_set(A,B,A3))),inf_inf(set(A))),inf_inf(set(B)))) ) ).

% inter_transfer
tff(fact_5146_right__total__Compl__transfer,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool))] :
      ( bi_unique(A,B,A3)
     => ( right_total(A,B,A3)
       => pp(aa(fun(set(B),set(B)),bool,aa(fun(set(A),set(A)),fun(fun(set(B),set(B)),bool),bNF_rel_fun(set(A),set(B),set(A),set(B),bNF_rel_set(A,B,A3),bNF_rel_set(A,B,A3)),aTP_Lamp_arn(fun(A,fun(B,bool)),fun(set(A),set(A)),A3)),uminus_uminus(set(B)))) ) ) ).

% right_total_Compl_transfer
tff(fact_5147_Inter__transfer,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool))] :
      ( bi_unique(A,B,A3)
     => ( bi_total(A,B,A3)
       => pp(aa(fun(set(set(B)),set(B)),bool,aa(fun(set(set(A)),set(A)),fun(fun(set(set(B)),set(B)),bool),bNF_rel_fun(set(set(A)),set(set(B)),set(A),set(B),bNF_rel_set(set(A),set(B),bNF_rel_set(A,B,A3)),bNF_rel_set(A,B,A3)),complete_Inf_Inf(set(A))),complete_Inf_Inf(set(B)))) ) ) ).

% Inter_transfer
tff(fact_5148_Abs__rat__cases,axiom,
    ! [X2: rat] :
      ~ ! [Y2: set(product_prod(int,int))] :
          ( ( X2 = aa(set(product_prod(int,int)),rat,abs_rat,Y2) )
         => ~ pp(aa(set(set(product_prod(int,int))),bool,member(set(product_prod(int,int)),Y2),aa(fun(set(product_prod(int,int)),bool),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_aro(set(product_prod(int,int)),bool)))) ) ).

% Abs_rat_cases
tff(fact_5149_Abs__rat__induct,axiom,
    ! [P: fun(rat,bool),X2: rat] :
      ( ! [Y2: set(product_prod(int,int))] :
          ( pp(aa(set(set(product_prod(int,int))),bool,member(set(product_prod(int,int)),Y2),aa(fun(set(product_prod(int,int)),bool),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_aro(set(product_prod(int,int)),bool))))
         => pp(aa(rat,bool,P,aa(set(product_prod(int,int)),rat,abs_rat,Y2))) )
     => pp(aa(rat,bool,P,X2)) ) ).

% Abs_rat_induct
tff(fact_5150_inf__filter__parametric,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,bool))] :
      ( bi_unique(A,B,A3)
     => ( bi_total(A,B,A3)
       => pp(aa(fun(filter(B),fun(filter(B),filter(B))),bool,aa(fun(filter(A),fun(filter(A),filter(A))),fun(fun(filter(B),fun(filter(B),filter(B))),bool),bNF_rel_fun(filter(A),filter(B),fun(filter(A),filter(A)),fun(filter(B),filter(B)),rel_filter(A,B,A3),bNF_rel_fun(filter(A),filter(B),filter(A),filter(B),rel_filter(A,B,A3),rel_filter(A,B,A3))),inf_inf(filter(A))),inf_inf(filter(B)))) ) ) ).

% inf_filter_parametric
tff(fact_5151_Abs__rat__inject,axiom,
    ! [X2: set(product_prod(int,int)),Y: set(product_prod(int,int))] :
      ( pp(aa(set(set(product_prod(int,int))),bool,member(set(product_prod(int,int)),X2),aa(fun(set(product_prod(int,int)),bool),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_aro(set(product_prod(int,int)),bool))))
     => ( pp(aa(set(set(product_prod(int,int))),bool,member(set(product_prod(int,int)),Y),aa(fun(set(product_prod(int,int)),bool),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_aro(set(product_prod(int,int)),bool))))
       => ( ( aa(set(product_prod(int,int)),rat,abs_rat,X2) = aa(set(product_prod(int,int)),rat,abs_rat,Y) )
        <=> ( X2 = Y ) ) ) ) ).

% Abs_rat_inject
tff(fact_5152_type__definition__rat,axiom,
    type_definition(rat,set(product_prod(int,int)),rep_rat,abs_rat,aa(fun(set(product_prod(int,int)),bool),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_aro(set(product_prod(int,int)),bool))) ).

% type_definition_rat
tff(fact_5153_Abs__rat__inverse,axiom,
    ! [Y: set(product_prod(int,int))] :
      ( pp(aa(set(set(product_prod(int,int))),bool,member(set(product_prod(int,int)),Y),aa(fun(set(product_prod(int,int)),bool),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_aro(set(product_prod(int,int)),bool))))
     => ( aa(rat,set(product_prod(int,int)),rep_rat,aa(set(product_prod(int,int)),rat,abs_rat,Y)) = Y ) ) ).

% Abs_rat_inverse
tff(fact_5154_Rep__rat__induct,axiom,
    ! [Y: set(product_prod(int,int)),P: fun(set(product_prod(int,int)),bool)] :
      ( pp(aa(set(set(product_prod(int,int))),bool,member(set(product_prod(int,int)),Y),aa(fun(set(product_prod(int,int)),bool),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_aro(set(product_prod(int,int)),bool))))
     => ( ! [X: rat] : pp(aa(set(product_prod(int,int)),bool,P,aa(rat,set(product_prod(int,int)),rep_rat,X)))
       => pp(aa(set(product_prod(int,int)),bool,P,Y)) ) ) ).

% Rep_rat_induct
tff(fact_5155_Rep__rat,axiom,
    ! [X2: rat] : pp(aa(set(set(product_prod(int,int))),bool,member(set(product_prod(int,int)),aa(rat,set(product_prod(int,int)),rep_rat,X2)),aa(fun(set(product_prod(int,int)),bool),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_aro(set(product_prod(int,int)),bool)))) ).

% Rep_rat
tff(fact_5156_Rep__rat__cases,axiom,
    ! [Y: set(product_prod(int,int))] :
      ( pp(aa(set(set(product_prod(int,int))),bool,member(set(product_prod(int,int)),Y),aa(fun(set(product_prod(int,int)),bool),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_aro(set(product_prod(int,int)),bool))))
     => ~ ! [X: rat] : ( Y != aa(rat,set(product_prod(int,int)),rep_rat,X) ) ) ).

% Rep_rat_cases
tff(fact_5157_type__copy__vimage2p__Grp__Abs,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Rep: fun(A,B),Abs: fun(B,A),G: fun(D,C),P: fun(C,bool),H2: fun(C,A)] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( bNF_vimage2p(D,C,B,A,bool,G,Abs,bNF_Grp(C,A,aa(fun(C,bool),set(C),collect(C),P),H2)) = bNF_Grp(D,B,aa(fun(D,bool),set(D),collect(D),aa(fun(C,bool),fun(D,bool),aTP_Lamp_arp(fun(D,C),fun(fun(C,bool),fun(D,bool)),G),P)),aa(fun(D,C),fun(D,B),comp(C,B,D,aa(fun(C,A),fun(C,B),comp(A,B,C,Rep),H2)),G)) ) ) ).

% type_copy_vimage2p_Grp_Abs
tff(fact_5158_type__copy__vimage2p__Grp__Rep,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,Rep: fun(A,B),Abs: fun(B,A),F2: fun(C,D),P: fun(D,bool),H2: fun(D,B)] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( bNF_vimage2p(C,D,A,B,bool,F2,Rep,bNF_Grp(D,B,aa(fun(D,bool),set(D),collect(D),P),H2)) = bNF_Grp(C,A,aa(fun(C,bool),set(C),collect(C),aa(fun(D,bool),fun(C,bool),aTP_Lamp_arq(fun(C,D),fun(fun(D,bool),fun(C,bool)),F2),P)),aa(fun(C,D),fun(C,A),comp(D,A,C,aa(fun(D,B),fun(D,A),comp(B,A,D,Abs),H2)),F2)) ) ) ).

% type_copy_vimage2p_Grp_Rep
tff(fact_5159_sum__mset__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Y: B,A3: multiset(A)] : ( comm_m7189776963980413722m_mset(B,aa(multiset(A),multiset(B),image_mset(A,B,aTP_Lamp_arr(B,fun(A,B),Y)),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(multiset(A),nat,size_size(multiset(A)),A3))),Y) ) ) ).

% sum_mset_constant
tff(fact_5160_prod__mset__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C2: A,A3: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,aTP_Lamp_rw(A,fun(B,A),C2)),A3)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),C2),aa(multiset(B),nat,size_size(multiset(B)),A3)) ) ) ).

% prod_mset_constant
tff(fact_5161_vimage2p__def,axiom,
    ! [A: $tType,D: $tType,C: $tType,E: $tType,B: $tType,F2: fun(A,D),G: fun(B,E),R: fun(D,fun(E,C)),X4: A,Xa3: B] : ( aa(B,C,aa(A,fun(B,C),bNF_vimage2p(A,D,B,E,C,F2,G,R),X4),Xa3) = aa(E,C,aa(D,fun(E,C),R,aa(A,D,F2,X4)),aa(B,E,G,Xa3)) ) ).

% vimage2p_def
tff(fact_5162_size__eq__sum__mset,axiom,
    ! [A: $tType,M: multiset(A)] : ( aa(multiset(A),nat,size_size(multiset(A)),M) = comm_m7189776963980413722m_mset(nat,aa(multiset(A),multiset(nat),image_mset(A,nat,aTP_Lamp_rl(A,nat)),M)) ) ).

% size_eq_sum_mset
tff(fact_5163_image__mset__const__eq,axiom,
    ! [B: $tType,A: $tType,C2: A,M: multiset(B)] : ( aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_cy(A,fun(B,A)),C2)),M) = replicate_mset(A,aa(multiset(B),nat,size_size(multiset(B)),M),C2) ) ).

% image_mset_const_eq
tff(fact_5164_size__multiset__overloaded__def,axiom,
    ! [B: $tType] : ( size_size(multiset(B)) = size_multiset(B,aTP_Lamp_ars(B,nat)) ) ).

% size_multiset_overloaded_def
tff(fact_5165_size__multiset__overloaded__eq,axiom,
    ! [B: $tType,X2: multiset(B)] : ( aa(multiset(B),nat,size_size(multiset(B)),X2) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(multiset(B),fun(B,nat),count(B),X2)),aa(multiset(B),set(B),set_mset(B),X2)) ) ).

% size_multiset_overloaded_eq
tff(fact_5166_tl__remdups__adj,axiom,
    ! [A: $tType,Ys: list(A)] :
      ( ( Ys != nil(A) )
     => ( aa(list(A),list(A),tl(A),remdups_adj(A,Ys)) = remdups_adj(A,dropWhile(A,aTP_Lamp_art(list(A),fun(A,bool),Ys),aa(list(A),list(A),tl(A),Ys))) ) ) ).

% tl_remdups_adj
tff(fact_5167_map__upds__fold__map__upd,axiom,
    ! [A: $tType,B: $tType,M2: fun(A,option(B)),Ks: list(A),Vs: list(B)] : ( map_upds(A,B,M2,Ks,Vs) = foldl(fun(A,option(B)),product_prod(A,B),aTP_Lamp_arv(fun(A,option(B)),fun(product_prod(A,B),fun(A,option(B)))),M2,zip(A,B,Ks,Vs)) ) ).

% map_upds_fold_map_upd
tff(fact_5168_prod__list__def,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( groups5270119922927024881d_list(A) = groups_monoid_F(A,times_times(A),one_one(A)) ) ) ).

% prod_list_def
tff(fact_5169_monoid__list_OF_Ocong,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] : ( groups_monoid_F(A,F2,Z2) = groups_monoid_F(A,F2,Z2) ) ).

% monoid_list.F.cong
tff(fact_5170_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( remdups_adj(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),remdups_adj(A,dropWhile(A,aTP_Lamp_ct(A,fun(A,bool),X2),Xs))) ) ).

% remdups_adj_Cons'
tff(fact_5171_monoid__list_OCons,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,X2: A,Xs: list(A)] :
      ( groups_monoid_list(A,F2,Z2)
     => ( aa(list(A),A,groups_monoid_F(A,F2,Z2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(A,A,aa(A,fun(A,A),F2,X2),aa(list(A),A,groups_monoid_F(A,F2,Z2),Xs)) ) ) ).

% monoid_list.Cons
tff(fact_5172_monoid__list_ONil,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups_monoid_list(A,F2,Z2)
     => ( aa(list(A),A,groups_monoid_F(A,F2,Z2),nil(A)) = Z2 ) ) ).

% monoid_list.Nil
tff(fact_5173_monoid__list_Oappend,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Xs: list(A),Ys: list(A)] :
      ( groups_monoid_list(A,F2,Z2)
     => ( aa(list(A),A,groups_monoid_F(A,F2,Z2),append(A,Xs,Ys)) = aa(A,A,aa(A,fun(A,A),F2,aa(list(A),A,groups_monoid_F(A,F2,Z2),Xs)),aa(list(A),A,groups_monoid_F(A,F2,Z2),Ys)) ) ) ).

% monoid_list.append
tff(fact_5174_remdups__adj__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( remdups_adj(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(list(A),list(A),case_list(list(A),A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A)),aTP_Lamp_arw(A,fun(A,fun(list(A),list(A))),X2)),remdups_adj(A,Xs)) ) ).

% remdups_adj_Cons
tff(fact_5175_comm__monoid__list_Orev,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Xs: list(A)] :
      ( groups1828464146339083142d_list(A,F2,Z2)
     => ( aa(list(A),A,groups_monoid_F(A,F2,Z2),rev(A,Xs)) = aa(list(A),A,groups_monoid_F(A,F2,Z2),Xs) ) ) ).

% comm_monoid_list.rev
tff(fact_5176_monoid__list_Oeq__foldr,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Xs: list(A)] :
      ( groups_monoid_list(A,F2,Z2)
     => ( aa(list(A),A,groups_monoid_F(A,F2,Z2),Xs) = aa(A,A,foldr(A,A,F2,Xs),Z2) ) ) ).

% monoid_list.eq_foldr
tff(fact_5177_sum__list__def,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ( groups8242544230860333062m_list(A) = groups_monoid_F(A,plus_plus(A),zero_zero(A)) ) ) ).

% sum_list_def
tff(fact_5178_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs: list(A),Y: A,Ys: list(A)] : ( remdups_adj(A,append(A,Xs,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Ys))) = append(A,remdups_adj(A,append(A,Xs,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),nil(A)))),remdups_adj(A,dropWhile(A,aTP_Lamp_ct(A,fun(A,bool),Y),Ys))) ) ).

% remdups_adj_append_dropWhile
tff(fact_5179_comm__monoid__list__set_Oset__conv__list,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(B,A),Xs: list(B)] :
      ( groups4802862169904069756st_set(A,F2,Z2)
     => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(list(B),set(B),set2(B),Xs)) = aa(list(A),A,groups_monoid_F(A,F2,Z2),aa(list(B),list(A),map(B,A,G),aa(list(B),list(B),remdups(B),Xs))) ) ) ).

% comm_monoid_list_set.set_conv_list
tff(fact_5180_comm__monoid__list__set_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,Xs: list(B),G: fun(B,A)] :
      ( groups4802862169904069756st_set(A,F2,Z2)
     => ( distinct(B,Xs)
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(list(B),set(B),set2(B),Xs)) = aa(list(A),A,groups_monoid_F(A,F2,Z2),aa(list(B),list(A),map(B,A,G),Xs)) ) ) ) ).

% comm_monoid_list_set.distinct_set_conv_list
tff(fact_5181_remdups__adj__append_H_H,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs != nil(A) )
     => ( remdups_adj(A,append(A,Xs,Ys)) = append(A,remdups_adj(A,Xs),remdups_adj(A,dropWhile(A,aTP_Lamp_arx(list(A),fun(A,bool),Xs),Ys))) ) ) ).

% remdups_adj_append''
tff(fact_5182_comm__monoid__mult__class_Oprod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ( groups7121269368397514597t_prod(B,A) = groups_comm_monoid_F(A,B,times_times(A),one_one(A)) ) ) ).

% comm_monoid_mult_class.prod_def
tff(fact_5183_comm__monoid__set_Otriangle__reindex,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,fun(nat,A)),N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups_comm_monoid_F(A,product_prod(nat,nat),F2,Z2),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),G)),aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_ut(nat,fun(nat,fun(nat,bool)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(fun(nat,fun(nat,A)),fun(nat,A),aa(A,fun(fun(nat,fun(nat,A)),fun(nat,A)),aTP_Lamp_arz(fun(A,fun(A,A)),fun(A,fun(fun(nat,fun(nat,A)),fun(nat,A))),F2),Z2),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% comm_monoid_set.triangle_reindex
tff(fact_5184_comm__monoid__set_Ozero__middle,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,P5: nat,K: nat,G: fun(nat,A),H2: fun(nat,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),P5))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),P5))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aa(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),aTP_Lamp_asa(A,fun(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A)))),Z2),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),P5)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_asb(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P5),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% comm_monoid_set.zero_middle
tff(fact_5185_comm__monoid__set_Otriangle__reindex__eq,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,fun(nat,A)),N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups_comm_monoid_F(A,product_prod(nat,nat),F2,Z2),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),G)),aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_rd(nat,fun(nat,fun(nat,bool)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(fun(nat,fun(nat,A)),fun(nat,A),aa(A,fun(fun(nat,fun(nat,A)),fun(nat,A)),aTP_Lamp_arz(fun(A,fun(A,A)),fun(A,fun(fun(nat,fun(nat,A)),fun(nat,A))),F2),Z2),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% comm_monoid_set.triangle_reindex_eq
tff(fact_5186_comm__monoid__set_Oswap,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(B,fun(C,A)),B2: set(C),A3: set(B)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(set(C),fun(B,A),aa(fun(B,fun(C,A)),fun(set(C),fun(B,A)),aa(A,fun(fun(B,fun(C,A)),fun(set(C),fun(B,A))),aTP_Lamp_asc(fun(A,fun(A,A)),fun(A,fun(fun(B,fun(C,A)),fun(set(C),fun(B,A)))),F2),Z2),G),B2)),A3) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,F2,Z2),aa(set(B),fun(C,A),aa(fun(B,fun(C,A)),fun(set(B),fun(C,A)),aa(A,fun(fun(B,fun(C,A)),fun(set(B),fun(C,A))),aTP_Lamp_ase(fun(A,fun(A,A)),fun(A,fun(fun(B,fun(C,A)),fun(set(B),fun(C,A)))),F2),Z2),G),A3)),B2) ) ) ).

% comm_monoid_set.swap
tff(fact_5187_comm__monoid__set_Odistrib,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(B,A),H2: fun(B,A),A3: set(B)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_asf(fun(A,fun(A,A)),fun(fun(B,A),fun(fun(B,A),fun(B,A))),F2),G),H2)),A3) = aa(A,A,aa(A,fun(A,A),F2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),H2),A3)) ) ) ).

% comm_monoid_set.distrib
tff(fact_5188_comm__monoid__set_Oneutral__const,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(A,fun(B,A),aTP_Lamp_cy(A,fun(B,A)),Z2)),A3) = Z2 ) ) ).

% comm_monoid_set.neutral_const
tff(fact_5189_comm__monoid__set_Oempty,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),bot_bot(set(B))) = Z2 ) ) ).

% comm_monoid_set.empty
tff(fact_5190_comm__monoid__set_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,I: set(B),X2: fun(B,A),Y: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(set(B),fun(fun(B,A),fun(B,bool)),aTP_Lamp_asg(A,fun(set(B),fun(fun(B,A),fun(B,bool))),Z2),I),X2))))
       => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(set(B),fun(fun(B,A),fun(B,bool)),aTP_Lamp_asg(A,fun(set(B),fun(fun(B,A),fun(B,bool))),Z2),I),Y))))
         => pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aa(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),aa(A,fun(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool)))),aTP_Lamp_ash(fun(A,fun(A,A)),fun(A,fun(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))))),F2),Z2),I),X2),Y)))) ) ) ) ).

% comm_monoid_set.finite_Collect_op
tff(fact_5191_comm__monoid__set__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups778175481326437816id_set(A,F2,Z2)
    <=> comm_monoid(A,F2,Z2) ) ).

% comm_monoid_set_def
tff(fact_5192_comm__monoid__set_Oaxioms,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => comm_monoid(A,F2,Z2) ) ).

% comm_monoid_set.axioms
tff(fact_5193_comm__monoid__set_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid(A,F2,Z2)
     => groups778175481326437816id_set(A,F2,Z2) ) ).

% comm_monoid_set.intro
tff(fact_5194_comm__monoid__list__set_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups4802862169904069756st_set(A,F2,Z2)
     => groups778175481326437816id_set(A,F2,Z2) ) ).

% comm_monoid_list_set.axioms(2)
tff(fact_5195_prod_Ocomm__monoid__set__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => groups778175481326437816id_set(A,times_times(A),one_one(A)) ) ).

% prod.comm_monoid_set_axioms
tff(fact_5196_comm__monoid__set_Odelta,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(A,A)),Z2: A,S: set(B),A4: B,B3: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),S))
       => ( ( pp(aa(set(B),bool,member(B,A4),S))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_asi(A,fun(B,fun(fun(B,A),fun(B,A))),Z2),A4),B3)),S) = aa(B,A,B3,A4) ) )
          & ( ~ pp(aa(set(B),bool,member(B,A4),S))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_asi(A,fun(B,fun(fun(B,A),fun(B,A))),Z2),A4),B3)),S) = Z2 ) ) ) ) ) ).

% comm_monoid_set.delta
tff(fact_5197_comm__monoid__set_Odelta_H,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(A,A)),Z2: A,S: set(B),A4: B,B3: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),S))
       => ( ( pp(aa(set(B),bool,member(B,A4),S))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_asj(A,fun(B,fun(fun(B,A),fun(B,A))),Z2),A4),B3)),S) = aa(B,A,B3,A4) ) )
          & ( ~ pp(aa(set(B),bool,member(B,A4),S))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_asj(A,fun(B,fun(fun(B,A),fun(B,A))),Z2),A4),B3)),S) = Z2 ) ) ) ) ) ).

% comm_monoid_set.delta'
tff(fact_5198_comm__monoid__set_Ointer__filter,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),G: fun(B,A),P: fun(B,bool)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(fun(B,bool),set(B),collect(B),aa(fun(B,bool),fun(B,bool),aTP_Lamp_pf(set(B),fun(fun(B,bool),fun(B,bool)),A3),P))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(B,bool),fun(B,A),aa(fun(B,A),fun(fun(B,bool),fun(B,A)),aTP_Lamp_ask(A,fun(fun(B,A),fun(fun(B,bool),fun(B,A))),Z2),G),P)),A3) ) ) ) ).

% comm_monoid_set.inter_filter
tff(fact_5199_comm__monoid__set_Oswap__restrict,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),B2: set(C),G: fun(B,fun(C,A)),R: fun(B,fun(C,bool))] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( pp(aa(set(C),bool,finite_finite2(C),B2))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(B,fun(C,bool)),fun(B,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A)),aa(set(C),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A))),aa(A,fun(set(C),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A)))),aTP_Lamp_asl(fun(A,fun(A,A)),fun(A,fun(set(C),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A))))),F2),Z2),B2),G),R)),A3) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,F2,Z2),aa(fun(B,fun(C,bool)),fun(C,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A)),aa(set(B),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A))),aa(A,fun(set(B),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A)))),aTP_Lamp_asm(fun(A,fun(A,A)),fun(A,fun(set(B),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A))))),F2),Z2),A3),G),R)),B2) ) ) ) ) ).

% comm_monoid_set.swap_restrict
tff(fact_5200_comm__monoid__set_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M2: nat,N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aTP_Lamp_xk(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% comm_monoid_set.shift_bounds_cl_Suc_ivl
tff(fact_5201_comm__monoid__set_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M2: nat,N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aTP_Lamp_xk(fun(nat,A),fun(nat,A),G)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% comm_monoid_set.shift_bounds_Suc_ivl
tff(fact_5202_comm__monoid__set_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M2: nat,K: nat,N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(nat,fun(nat,A),aTP_Lamp_asn(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% comm_monoid_set.shift_bounds_cl_nat_ivl
tff(fact_5203_comm__monoid__set_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M2: nat,K: nat,N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(nat,fun(nat,A),aTP_Lamp_asn(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% comm_monoid_set.shift_bounds_nat_ivl
tff(fact_5204_comm__monoid__set_Oreindex__bij__betw,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(A,fun(A,A)),Z2: A,H2: fun(B,C),S: set(B),T2: set(C),G: fun(C,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( bij_betw(B,C,H2,S,T2)
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(C,A),fun(B,A),aTP_Lamp_aso(fun(B,C),fun(fun(C,A),fun(B,A)),H2),G)),S) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,F2,Z2),G),T2) ) ) ) ).

% comm_monoid_set.reindex_bij_betw
tff(fact_5205_comm__monoid__list__set__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups4802862169904069756st_set(A,F2,Z2)
    <=> ( groups1828464146339083142d_list(A,F2,Z2)
        & groups778175481326437816id_set(A,F2,Z2) ) ) ).

% comm_monoid_list_set_def
tff(fact_5206_comm__monoid__list__set_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( groups1828464146339083142d_list(A,F2,Z2)
     => ( groups778175481326437816id_set(A,F2,Z2)
       => groups4802862169904069756st_set(A,F2,Z2) ) ) ).

% comm_monoid_list_set.intro
tff(fact_5207_comm__monoid__set_Oimage__gen,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,S: set(B),H2: fun(B,A),G: fun(B,C)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),S))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),H2),S) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,F2,Z2),aa(fun(B,C),fun(C,A),aa(fun(B,A),fun(fun(B,C),fun(C,A)),aa(set(B),fun(fun(B,A),fun(fun(B,C),fun(C,A))),aa(A,fun(set(B),fun(fun(B,A),fun(fun(B,C),fun(C,A)))),aTP_Lamp_asp(fun(A,fun(A,A)),fun(A,fun(set(B),fun(fun(B,A),fun(fun(B,C),fun(C,A))))),F2),Z2),S),H2),G)),aa(set(B),set(C),image2(B,C,G),S)) ) ) ) ).

% comm_monoid_set.image_gen
tff(fact_5208_comm__monoid__set_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),G: fun(B,A),B2: set(B)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(set(B),fun(B,A),aa(fun(B,A),fun(set(B),fun(B,A)),aTP_Lamp_asq(A,fun(fun(B,A),fun(set(B),fun(B,A))),Z2),G),B2)),A3) ) ) ) ).

% comm_monoid_set.inter_restrict
tff(fact_5209_comm__monoid__set_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_asr(A,fun(fun(B,A),fun(B,bool)),Z2),G)))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),A3) ) ) ) ).

% comm_monoid_set.setdiff_irrelevant
tff(fact_5210_comm__monoid__set_OSuc__reindex__ivl,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,M2: nat,N: nat,G: fun(nat,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N))
       => ( aa(A,A,aa(A,fun(A,A),F2,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,M2,N))),aa(nat,A,G,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),F2,aa(nat,A,G,M2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aTP_Lamp_xk(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M2,N))) ) ) ) ).

% comm_monoid_set.Suc_reindex_ivl
tff(fact_5211_comm__monoid__set_Oimage__eq,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(B,A),A3: set(B)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( inj_on(B,A,G,A3)
       => ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups_comm_monoid_F(A,A,F2,Z2),aTP_Lamp_bk(A,A)),aa(set(B),set(A),image2(B,A,G),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),A3) ) ) ) ).

% comm_monoid_set.image_eq
tff(fact_5212_comm__monoid__set_OatMost__Suc__shift,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),F2,aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aTP_Lamp_xk(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_atMost(nat),N))) ) ) ).

% comm_monoid_set.atMost_Suc_shift
tff(fact_5213_comm__monoid__set_OatLeastAtMost__rev,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),N: nat,M2: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,N,M2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_ass(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M2)),set_or1337092689740270186AtMost(nat,N,M2)) ) ) ).

% comm_monoid_set.atLeastAtMost_rev
tff(fact_5214_comm__monoid__set_OlessThan__Suc__shift,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),F2,aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aTP_Lamp_xk(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% comm_monoid_set.lessThan_Suc_shift
tff(fact_5215_comm__monoid__set_Ocartesian__product,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(B,fun(C,A)),B2: set(C),A3: set(B)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(set(C),fun(B,A),aa(fun(B,fun(C,A)),fun(set(C),fun(B,A)),aa(A,fun(fun(B,fun(C,A)),fun(set(C),fun(B,A))),aTP_Lamp_asc(fun(A,fun(A,A)),fun(A,fun(fun(B,fun(C,A)),fun(set(C),fun(B,A)))),F2),Z2),G),B2)),A3) = aa(set(product_prod(B,C)),A,aa(fun(product_prod(B,C),A),fun(set(product_prod(B,C)),A),groups_comm_monoid_F(A,product_prod(B,C),F2,Z2),aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),G)),product_Sigma(B,C,A3,aTP_Lamp_eq(set(C),fun(B,set(C)),B2))) ) ) ).

% comm_monoid_set.cartesian_product
tff(fact_5216_comm__monoid__set_Onat__diff__reindex,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(nat,fun(nat,A),aTP_Lamp_ast(fun(nat,A),fun(nat,fun(nat,A)),G),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% comm_monoid_set.nat_diff_reindex
tff(fact_5217_comm__monoid__set_Ounion__inter,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),B2: set(B),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( pp(aa(set(B),bool,finite_finite2(B),B2))
         => ( aa(A,A,aa(A,fun(A,A),F2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) = aa(A,A,aa(A,fun(A,A),F2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),B2)) ) ) ) ) ).

% comm_monoid_set.union_inter
tff(fact_5218_comm__monoid__set_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),B2: set(B),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( pp(aa(set(B),bool,finite_finite2(B),B2))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)))
               => ( aa(B,A,G,X) = Z2 ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(A,A,aa(A,fun(A,A),F2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),B2)) ) ) ) ) ) ).

% comm_monoid_set.union_inter_neutral
tff(fact_5219_comm__monoid__set_OInt__Diff,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),G: fun(B,A),B2: set(B)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),A3) = aa(A,A,aa(A,fun(A,A),F2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))) ) ) ) ).

% comm_monoid_set.Int_Diff
tff(fact_5220_comm__monoid__set_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,T2: set(B),S: set(B),H2: fun(B,A),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),T2))
       => ( pp(aa(set(B),bool,finite_finite2(B),S))
         => ( ! [I3: B] :
                ( pp(aa(set(B),bool,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S)))
               => ( aa(B,A,H2,I3) = Z2 ) )
           => ( ! [I3: B] :
                  ( pp(aa(set(B),bool,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),T2)))
                 => ( aa(B,A,G,I3) = Z2 ) )
             => ( ! [X: B] :
                    ( pp(aa(set(B),bool,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),T2)))
                   => ( aa(B,A,G,X) = aa(B,A,H2,X) ) )
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),S) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),H2),T2) ) ) ) ) ) ) ) ).

% comm_monoid_set.mono_neutral_cong
tff(fact_5221_comm__monoid__set_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,S: set(B),T2: set(C),G: fun(B,C),H2: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),S))
       => ( pp(aa(set(C),bool,finite_finite2(C),T2))
         => ( pp(aa(set(C),bool,aa(set(C),fun(set(C),bool),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,G),S)),T2))
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,F2,Z2),aa(fun(B,A),fun(C,A),aa(fun(B,C),fun(fun(B,A),fun(C,A)),aa(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))),aa(A,fun(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A)))),aTP_Lamp_asu(fun(A,fun(A,A)),fun(A,fun(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))))),F2),Z2),S),G),H2)),T2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),H2),S) ) ) ) ) ) ).

% comm_monoid_set.group
tff(fact_5222_comm__monoid__set_OatLeastLessThan__rev,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),N: nat,M2: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_asv(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M2)),set_or7035219750837199246ssThan(nat,N,M2)) ) ) ).

% comm_monoid_set.atLeastLessThan_rev
tff(fact_5223_comm__monoid__set_OSigma,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),B2: fun(B,set(C)),G: fun(B,fun(C,A))] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),A3))
             => pp(aa(set(C),bool,finite_finite2(C),aa(B,set(C),B2,X))) )
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(B,fun(C,A)),fun(B,A),aa(fun(B,set(C)),fun(fun(B,fun(C,A)),fun(B,A)),aa(A,fun(fun(B,set(C)),fun(fun(B,fun(C,A)),fun(B,A))),aTP_Lamp_asw(fun(A,fun(A,A)),fun(A,fun(fun(B,set(C)),fun(fun(B,fun(C,A)),fun(B,A)))),F2),Z2),B2),G)),A3) = aa(set(product_prod(B,C)),A,aa(fun(product_prod(B,C),A),fun(set(product_prod(B,C)),A),groups_comm_monoid_F(A,product_prod(B,C),F2,Z2),aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),G)),product_Sigma(B,C,A3,B2)) ) ) ) ) ).

% comm_monoid_set.Sigma
tff(fact_5224_comm__monoid__set_Onested__swap,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,A4: fun(nat,fun(nat,A)),N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(fun(nat,fun(nat,A)),fun(nat,A),aa(A,fun(fun(nat,fun(nat,A)),fun(nat,A)),aTP_Lamp_asx(fun(A,fun(A,A)),fun(A,fun(fun(nat,fun(nat,A)),fun(nat,A))),F2),Z2),A4)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(nat,fun(nat,A),aa(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),aa(A,fun(fun(nat,fun(nat,A)),fun(nat,fun(nat,A))),aTP_Lamp_asz(fun(A,fun(A,A)),fun(A,fun(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)))),F2),Z2),A4),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% comm_monoid_set.nested_swap
tff(fact_5225_comm__monoid__set_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(A,fun(A,A)),Z2: A,S3: set(B),T4: set(C),H2: fun(B,C),S: set(B),T2: set(C),G: fun(C,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),S3))
       => ( pp(aa(set(C),bool,finite_finite2(C),T4))
         => ( bij_betw(B,C,H2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),S3),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),T4))
           => ( ! [A5: B] :
                  ( pp(aa(set(B),bool,member(B,A5),S3))
                 => ( aa(C,A,G,aa(B,C,H2,A5)) = Z2 ) )
             => ( ! [B4: C] :
                    ( pp(aa(set(C),bool,member(C,B4),T4))
                   => ( aa(C,A,G,B4) = Z2 ) )
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(C,A),fun(B,A),aTP_Lamp_aso(fun(B,C),fun(fun(C,A),fun(B,A)),H2),G)),S) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,F2,Z2),G),T2) ) ) ) ) ) ) ) ).

% comm_monoid_set.reindex_bij_betw_not_neutral
tff(fact_5226_comm__monoid__set_OIf__cases,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),P: fun(B,bool),H2: fun(B,A),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_ca(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),H2),G)),A3) = aa(A,A,aa(A,fun(A,A),F2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),H2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,bool),set(B),collect(B),P)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,bool),set(B),collect(B),P))))) ) ) ) ).

% comm_monoid_set.If_cases
tff(fact_5227_comm__monoid__set_OatLeast1__atMost__eq,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aTP_Lamp_xk(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% comm_monoid_set.atLeast1_atMost_eq
tff(fact_5228_comm__monoid__set_OatMost__shift,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(A,A,aa(A,fun(A,A),F2,aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aTP_Lamp_xk(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% comm_monoid_set.atMost_shift
tff(fact_5229_comm__monoid__set_Onat__group,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),K: nat,N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aa(A,fun(fun(nat,A),fun(nat,fun(nat,A))),aTP_Lamp_ata(fun(A,fun(A,A)),fun(A,fun(fun(nat,A),fun(nat,fun(nat,A)))),F2),Z2),G),K)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))) ) ) ).

% comm_monoid_set.nat_group
tff(fact_5230_comm__monoid__set_Onested__swap_H,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,A4: fun(nat,fun(nat,A)),N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(fun(nat,fun(nat,A)),fun(nat,A),aa(A,fun(fun(nat,fun(nat,A)),fun(nat,A)),aTP_Lamp_atb(fun(A,fun(A,A)),fun(A,fun(fun(nat,fun(nat,A)),fun(nat,A))),F2),Z2),A4)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(nat,fun(nat,A),aa(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),aa(A,fun(fun(nat,fun(nat,A)),fun(nat,fun(nat,A))),aTP_Lamp_asz(fun(A,fun(A,A)),fun(A,fun(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)))),F2),Z2),A4),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% comm_monoid_set.nested_swap'
tff(fact_5231_comm__monoid__set_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),G: fun(B,A),X2: B] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),insert(B,X2),A3)) = aa(A,A,aa(A,fun(A,A),F2,aa(B,A,G,X2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ).

% comm_monoid_set.insert_remove
tff(fact_5232_comm__monoid__set_Oremove,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),X2: B,G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( pp(aa(set(B),bool,member(B,X2),A3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),A3) = aa(A,A,aa(A,fun(A,A),F2,aa(B,A,G,X2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ).

% comm_monoid_set.remove
tff(fact_5233_comm__monoid__set_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),B2: set(B),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( pp(aa(set(B),bool,finite_finite2(B),B2))
         => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(A,A,aa(A,fun(A,A),F2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),B2)) ) ) ) ) ) ).

% comm_monoid_set.union_disjoint
tff(fact_5234_comm__monoid__set_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(B),B2: set(B),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),A3))
       => ( pp(aa(set(B),bool,finite_finite2(B),B2))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A3)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ) ).

% comm_monoid_set.union_diff2
tff(fact_5235_comm__monoid__set_Odelta__remove,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,S: set(B),A4: B,B3: fun(B,A),C2: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),S))
       => ( ( pp(aa(set(B),bool,member(B,A4),S))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_atc(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A4),B3),C2)),S) = aa(A,A,aa(A,fun(A,A),F2,aa(B,A,B3,A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) )
          & ( ~ pp(aa(set(B),bool,member(B,A4),S))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_atc(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A4),B3),C2)),S) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) ) ) ) ) ) ).

% comm_monoid_set.delta_remove
tff(fact_5236_comm__monoid__set_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),N: nat,M2: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_ass(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M2)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M2)) ) ) ).

% comm_monoid_set.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_5237_comm__monoid__set_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M2: nat,N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_sx(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% comm_monoid_set.atLeast_atMost_pred_shift
tff(fact_5238_comm__monoid__set_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M2: nat,N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_sx(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% comm_monoid_set.atLeast_lessThan_pred_shift
tff(fact_5239_comm__monoid__set_Oin__pairs,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M2: nat,N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(fun(nat,A),fun(nat,A),aTP_Lamp_atd(fun(A,fun(A,A)),fun(fun(nat,A),fun(nat,A)),F2),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% comm_monoid_set.in_pairs
tff(fact_5240_comm__monoid__set_OUNION__disjoint,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,I: set(B),A3: fun(B,set(C)),G: fun(C,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),I))
       => ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),I))
             => pp(aa(set(C),bool,finite_finite2(C),aa(B,set(C),A3,X))) )
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),I))
               => ! [Xa4: B] :
                    ( pp(aa(set(B),bool,member(B,Xa4),I))
                   => ( ( X != Xa4 )
                     => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A3,X)),aa(B,set(C),A3,Xa4)) = bot_bot(set(C)) ) ) ) )
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,F2,Z2),G),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),aa(fun(C,A),fun(B,A),aa(fun(B,set(C)),fun(fun(C,A),fun(B,A)),aa(A,fun(fun(B,set(C)),fun(fun(C,A),fun(B,A))),aTP_Lamp_ate(fun(A,fun(A,A)),fun(A,fun(fun(B,set(C)),fun(fun(C,A),fun(B,A)))),F2),Z2),A3),G)),I) ) ) ) ) ) ).

% comm_monoid_set.UNION_disjoint
tff(fact_5241_comm__monoid__set_Oin__pairs__0,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),N: nat] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F2,Z2),aa(fun(nat,A),fun(nat,A),aTP_Lamp_atd(fun(A,fun(A,A)),fun(fun(nat,A),fun(nat,A)),F2),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% comm_monoid_set.in_pairs_0
tff(fact_5242_comm__monoid__set_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,C3: set(set(B)),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( ! [X: set(B)] :
            ( pp(aa(set(set(B)),bool,member(set(B),X),C3))
           => pp(aa(set(B),bool,finite_finite2(B),X)) )
       => ( ! [X: set(B)] :
              ( pp(aa(set(set(B)),bool,member(set(B),X),C3))
             => ! [Xa4: set(B)] :
                  ( pp(aa(set(set(B)),bool,member(set(B),Xa4),C3))
                 => ( ( X != Xa4 )
                   => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X),Xa4) = bot_bot(set(B)) ) ) ) )
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3)) = aa(set(set(B)),A,aa(fun(B,A),fun(set(set(B)),A),aa(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A)),comp(fun(set(B),A),fun(set(set(B)),A),fun(B,A),groups_comm_monoid_F(A,set(B),F2,Z2)),groups_comm_monoid_F(A,B,F2,Z2)),G),C3) ) ) ) ) ).

% comm_monoid_set.Union_disjoint
tff(fact_5243_insort__insert__insort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Xs: list(A)] :
          ( ~ pp(aa(set(A),bool,member(A,X2),aa(list(A),set(A),set2(A),Xs)))
         => ( linord329482645794927042rt_key(A,A,aTP_Lamp_eh(A,A),X2,Xs) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_eh(A,A)),X2),Xs) ) ) ) ).

% insort_insert_insort
tff(fact_5244_Quotient__multiset,axiom,
    ! [A: $tType] : quotient(fun(A,nat),multiset(A),bNF_eq_onp(fun(A,nat),aTP_Lamp_ape(fun(A,nat),bool)),abs_multiset(A),count(A),cr_multiset(A)) ).

% Quotient_multiset
tff(fact_5245_sorted__insort__insert,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),X2: A] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),linord329482645794927042rt_key(A,A,aTP_Lamp_eh(A,A),X2,Xs)) ) ) ).

% sorted_insort_insert
tff(fact_5246_QuotientI,axiom,
    ! [A: $tType,B: $tType,Abs: fun(B,A),Rep: fun(A,B),R: fun(B,fun(B,bool)),T2: fun(B,fun(A,bool))] :
      ( ! [A5: A] : ( aa(B,A,Abs,aa(A,B,Rep,A5)) = A5 )
     => ( ! [A5: A] : pp(aa(B,bool,aa(B,fun(B,bool),R,aa(A,B,Rep,A5)),aa(A,B,Rep,A5)))
       => ( ! [R3: B,S7: B] :
              ( pp(aa(B,bool,aa(B,fun(B,bool),R,R3),S7))
            <=> ( pp(aa(B,bool,aa(B,fun(B,bool),R,R3),R3))
                & pp(aa(B,bool,aa(B,fun(B,bool),R,S7),S7))
                & ( aa(B,A,Abs,R3) = aa(B,A,Abs,S7) ) ) )
         => ( ! [X: B,Xa4: A] :
                ( pp(aa(A,bool,aa(B,fun(A,bool),T2,X),Xa4))
              <=> ( pp(aa(B,bool,aa(B,fun(B,bool),R,X),X))
                  & ( aa(B,A,Abs,X) = Xa4 ) ) )
           => quotient(B,A,R,Abs,Rep,T2) ) ) ) ) ).

% QuotientI
tff(fact_5247_Quotient__def,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(A,bool)),Abs: fun(A,B),Rep: fun(B,A),T2: fun(A,fun(B,bool))] :
      ( quotient(A,B,R,Abs,Rep,T2)
    <=> ( ! [A6: B] : ( aa(A,B,Abs,aa(B,A,Rep,A6)) = A6 )
        & ! [A6: B] : pp(aa(A,bool,aa(A,fun(A,bool),R,aa(B,A,Rep,A6)),aa(B,A,Rep,A6)))
        & ! [R7: A,S8: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),R,R7),S8))
          <=> ( pp(aa(A,bool,aa(A,fun(A,bool),R,R7),R7))
              & pp(aa(A,bool,aa(A,fun(A,bool),R,S8),S8))
              & ( aa(A,B,Abs,R7) = aa(A,B,Abs,S8) ) ) )
        & ! [X3: A,Xa2: B] :
            ( pp(aa(B,bool,aa(A,fun(B,bool),T2,X3),Xa2))
          <=> ( pp(aa(A,bool,aa(A,fun(A,bool),R,X3),X3))
              & ( aa(A,B,Abs,X3) = Xa2 ) ) ) ) ) ).

% Quotient_def
tff(fact_5248_Quotient__cr__rel,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(A,bool)),Abs: fun(A,B),Rep: fun(B,A),T2: fun(A,fun(B,bool))] :
      ( quotient(A,B,R,Abs,Rep,T2)
     => ! [X4: A,Xa3: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),T2,X4),Xa3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),R,X4),X4))
            & ( aa(A,B,Abs,X4) = Xa3 ) ) ) ) ).

% Quotient_cr_rel
tff(fact_5249_UNIV__typedef__to__Quotient,axiom,
    ! [A: $tType,B: $tType,Rep: fun(A,B),Abs: fun(B,A),T2: fun(B,fun(A,bool))] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( ! [X: B,Xa4: A] :
            ( pp(aa(A,bool,aa(B,fun(A,bool),T2,X),Xa4))
          <=> ( X = aa(A,B,Rep,Xa4) ) )
       => quotient(B,A,fequal(B),Abs,Rep,T2) ) ) ).

% UNIV_typedef_to_Quotient
tff(fact_5250_open__typedef__to__Quotient,axiom,
    ! [A: $tType,B: $tType,Rep: fun(A,B),Abs: fun(B,A),P: fun(B,bool),T2: fun(B,fun(A,bool))] :
      ( type_definition(A,B,Rep,Abs,aa(fun(B,bool),set(B),collect(B),P))
     => ( ! [X: B,Xa4: A] :
            ( pp(aa(A,bool,aa(B,fun(A,bool),T2,X),Xa4))
          <=> ( X = aa(A,B,Rep,Xa4) ) )
       => quotient(B,A,bNF_eq_onp(B,P),Abs,Rep,T2) ) ) ).

% open_typedef_to_Quotient
tff(fact_5251_typedef__to__Quotient,axiom,
    ! [A: $tType,B: $tType,Rep: fun(A,B),Abs: fun(B,A),S: set(B),T2: fun(B,fun(A,bool))] :
      ( type_definition(A,B,Rep,Abs,S)
     => ( ! [X: B,Xa4: A] :
            ( pp(aa(A,bool,aa(B,fun(A,bool),T2,X),Xa4))
          <=> ( X = aa(A,B,Rep,Xa4) ) )
       => quotient(B,A,bNF_eq_onp(B,aTP_Lamp_ni(set(B),fun(B,bool),S)),Abs,Rep,T2) ) ) ).

% typedef_to_Quotient
tff(fact_5252_insort__insert__triv,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Xs: list(A)] :
          ( pp(aa(set(A),bool,member(A,X2),aa(list(A),set(A),set2(A),Xs)))
         => ( linord329482645794927042rt_key(A,A,aTP_Lamp_eh(A,A),X2,Xs) = Xs ) ) ) ).

% insort_insert_triv
tff(fact_5253_cr__multiset__def,axiom,
    ! [A: $tType,X4: fun(A,nat),Xa3: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(fun(A,nat),fun(multiset(A),bool),cr_multiset(A),X4),Xa3))
    <=> ( X4 = aa(multiset(A),fun(A,nat),count(A),Xa3) ) ) ).

% cr_multiset_def
tff(fact_5254_set__insort__insert,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Xs: list(A)] : ( aa(list(A),set(A),set2(A),linord329482645794927042rt_key(A,A,aTP_Lamp_eh(A,A),X2,Xs)) = aa(set(A),set(A),insert(A,X2),aa(list(A),set(A),set2(A),Xs)) ) ) ).

% set_insort_insert
tff(fact_5255_Quotient__eq__onp__typedef,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),Abs: fun(A,B),Rep: fun(B,A),Cr: fun(A,fun(B,bool))] :
      ( quotient(A,B,bNF_eq_onp(A,P),Abs,Rep,Cr)
     => type_definition(B,A,Rep,Abs,aa(fun(A,bool),set(A),collect(A),P)) ) ).

% Quotient_eq_onp_typedef
tff(fact_5256_Quotient__crel__typedef,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),Abs: fun(A,B),Rep: fun(B,A),T2: fun(A,fun(B,bool))] :
      ( quotient(A,B,bNF_eq_onp(A,P),Abs,Rep,T2)
     => ! [X4: A,Xa3: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),T2,X4),Xa3))
        <=> ( X4 = aa(B,A,Rep,Xa3) ) ) ) ).

% Quotient_crel_typedef
tff(fact_5257_Quotient__crel__typecopy,axiom,
    ! [A: $tType,B: $tType,Abs: fun(A,B),Rep: fun(B,A),T2: fun(A,fun(B,bool))] :
      ( quotient(A,B,fequal(A),Abs,Rep,T2)
     => ! [X4: A,Xa3: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),T2,X4),Xa3))
        <=> ( X4 = aa(B,A,Rep,Xa3) ) ) ) ).

% Quotient_crel_typecopy
tff(fact_5258_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( subseqs(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = append(list(A),aa(list(list(A)),list(list(A)),map(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2)),subseqs(A,Xs)),subseqs(A,Xs)) ) ).

% subseqs.simps(2)
tff(fact_5259_sort__quicksort__by__rel,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( linorder_sort_key(A,A,aTP_Lamp_eh(A,A)) = quicksort_by_rel(A,ord_less_eq(A),nil(A)) ) ) ).

% sort_quicksort_by_rel
tff(fact_5260_Powp__Pow__eq,axiom,
    ! [A: $tType,A3: set(A),X4: set(A)] :
      ( powp(A,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),A3),X4)
    <=> pp(aa(set(set(A)),bool,member(set(A),X4),pow(A,A3))) ) ).

% Powp_Pow_eq
tff(fact_5261_Powp__def,axiom,
    ! [A: $tType,A3: fun(A,bool),X4: set(A)] :
      ( powp(A,A3,X4)
    <=> ! [Xa2: A] :
          ( pp(aa(set(A),bool,member(A,Xa2),X4))
         => pp(aa(A,bool,A3,Xa2)) ) ) ).

% Powp_def
tff(fact_5262_quicksort__by__rel_Oelims,axiom,
    ! [A: $tType,X2: fun(A,fun(A,bool)),Xa: list(A),Xb: list(A),Y: list(A)] :
      ( ( aa(list(A),list(A),quicksort_by_rel(A,X2,Xa),Xb) = Y )
     => ( ( ( Xb = nil(A) )
         => ( Y != Xa ) )
       => ~ ! [X: A,Xs2: list(A)] :
              ( ( Xb = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2) )
             => ( Y != aa(product_prod(list(A),list(A)),list(A),aa(fun(list(A),fun(list(A),list(A))),fun(product_prod(list(A),list(A)),list(A)),product_case_prod(list(A),list(A),list(A)),aa(A,fun(list(A),fun(list(A),list(A))),aa(list(A),fun(A,fun(list(A),fun(list(A),list(A)))),aTP_Lamp_atf(fun(A,fun(A,bool)),fun(list(A),fun(A,fun(list(A),fun(list(A),list(A))))),X2),Xa),X)),partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),X2),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs2)) ) ) ) ) ).

% quicksort_by_rel.elims
tff(fact_5263_quicksort__by__rel_Osimps_I2_J,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),Sl: list(A),X2: A,Xs: list(A)] : ( aa(list(A),list(A),quicksort_by_rel(A,R,Sl),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(product_prod(list(A),list(A)),list(A),aa(fun(list(A),fun(list(A),list(A))),fun(product_prod(list(A),list(A)),list(A)),product_case_prod(list(A),list(A),list(A)),aa(A,fun(list(A),fun(list(A),list(A))),aa(list(A),fun(A,fun(list(A),fun(list(A),list(A)))),aTP_Lamp_atf(fun(A,fun(A,bool)),fun(list(A),fun(A,fun(list(A),fun(list(A),list(A))))),R),Sl),X2)),partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),R),X2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs)) ) ).

% quicksort_by_rel.simps(2)
tff(fact_5264_quicksort__by__rel_Opsimps_I2_J,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),Sl: list(A),X2: A,Xs: list(A)] :
      ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Sl),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)))))
     => ( aa(list(A),list(A),quicksort_by_rel(A,R,Sl),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs)) = aa(product_prod(list(A),list(A)),list(A),aa(fun(list(A),fun(list(A),list(A))),fun(product_prod(list(A),list(A)),list(A)),product_case_prod(list(A),list(A),list(A)),aa(A,fun(list(A),fun(list(A),list(A))),aa(list(A),fun(A,fun(list(A),fun(list(A),list(A)))),aTP_Lamp_atf(fun(A,fun(A,bool)),fun(list(A),fun(A,fun(list(A),fun(list(A),list(A))))),R),Sl),X2)),partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),R),X2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs)) ) ) ).

% quicksort_by_rel.psimps(2)
tff(fact_5265_quicksort__by__rel_Opelims,axiom,
    ! [A: $tType,X2: fun(A,fun(A,bool)),Xa: list(A),Xb: list(A),Y: list(A)] :
      ( ( aa(list(A),list(A),quicksort_by_rel(A,X2,Xa),Xb) = Y )
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),X2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xa),Xb))))
       => ( ( ( Xb = nil(A) )
           => ( ( Y = Xa )
             => ~ pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),X2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xa),nil(A))))) ) )
         => ~ ! [X: A,Xs2: list(A)] :
                ( ( Xb = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2) )
               => ( ( Y = aa(product_prod(list(A),list(A)),list(A),aa(fun(list(A),fun(list(A),list(A))),fun(product_prod(list(A),list(A)),list(A)),product_case_prod(list(A),list(A),list(A)),aa(A,fun(list(A),fun(list(A),list(A))),aa(list(A),fun(A,fun(list(A),fun(list(A),list(A)))),aTP_Lamp_atf(fun(A,fun(A,bool)),fun(list(A),fun(A,fun(list(A),fun(list(A),list(A))))),X2),Xa),X)),partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),X2),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs2)) )
                 => ~ pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),X2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xa),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2))))) ) ) ) ) ) ).

% quicksort_by_rel.pelims
tff(fact_5266_quicksort__by__rel_Opinduct,axiom,
    ! [A: $tType,A0: fun(A,fun(A,bool)),A13: list(A),A23: list(A),P: fun(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)))] :
      ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),A0),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),A13),A23))))
     => ( ! [R8: fun(A,fun(A,bool)),Sl2: list(A)] :
            ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R8),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Sl2),nil(A)))))
           => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)),P,R8),Sl2),nil(A))) )
       => ( ! [R8: fun(A,fun(A,bool)),Sl2: list(A),X: A,Xs2: list(A)] :
              ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R8),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Sl2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2)))))
             => ( ! [Xa3: product_prod(list(A),list(A)),Xb3: list(A),Y5: list(A)] :
                    ( ( Xa3 = partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),R8),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs2) )
                   => ( ( aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xb3),Y5) = Xa3 )
                     => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)),P,R8),Sl2),Y5)) ) )
               => ( ! [Xa3: product_prod(list(A),list(A)),Xb3: list(A),Y5: list(A)] :
                      ( ( Xa3 = partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),R8),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs2) )
                     => ( ( aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xb3),Y5) = Xa3 )
                       => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)),P,R8),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),aa(list(A),list(A),quicksort_by_rel(A,R8,Sl2),Y5))),Xb3)) ) )
                 => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)),P,R8),Sl2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs2))) ) ) )
         => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)),P,A0),A13),A23)) ) ) ) ).

% quicksort_by_rel.pinduct
tff(fact_5267_arg__min__list_Opelims,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [X2: fun(A,B),Xa: list(A),Y: A] :
          ( ( arg_min_list(A,B,X2,Xa) = Y )
         => ( pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),X2),Xa)))
           => ( ! [X: A] :
                  ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),nil(A)) )
                 => ( ( Y = X )
                   => ~ pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),nil(A))))) ) )
             => ( ! [X: A,Y2: A,Zs3: list(A)] :
                    ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs3)) )
                   => ( ( Y = if(A,aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,X2,X)),aa(A,B,X2,arg_min_list(A,B,X2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs3)))),X,arg_min_list(A,B,X2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs3))) )
                     => ~ pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs3))))) ) )
               => ~ ( ( Xa = nil(A) )
                   => ( ( Y = undefined(A) )
                     => ~ pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),X2),nil(A)))) ) ) ) ) ) ) ) ).

% arg_min_list.pelims
tff(fact_5268_product__swap,axiom,
    ! [A: $tType,B: $tType,A3: set(B),B2: set(A)] : ( aa(set(product_prod(B,A)),set(product_prod(A,B)),image2(product_prod(B,A),product_prod(A,B),product_swap(B,A)),product_Sigma(B,A,A3,aTP_Lamp_bv(set(A),fun(B,set(A)),B2))) = product_Sigma(A,B,B2,aTP_Lamp_bq(set(B),fun(A,set(B)),A3)) ) ).

% product_swap
tff(fact_5269_MOST__INFM,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ~ pp(aa(set(A),bool,finite_finite2(A),top_top(set(A))))
     => ( eventually(A,P,cofinite(A))
       => frequently(A,P,cofinite(A)) ) ) ).

% MOST_INFM
tff(fact_5270_frequently__const,axiom,
    ! [A: $tType,F: filter(A),P: bool] :
      ( ( F != bot_bot(filter(A)) )
     => ( frequently(A,aTP_Lamp_an(bool,fun(A,bool),P),F)
      <=> pp(P) ) ) ).

% frequently_const
tff(fact_5271_case__swap,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(C,fun(B,A)),P5: product_prod(C,B)] : ( aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),aTP_Lamp_atg(fun(C,fun(B,A)),fun(B,fun(C,A)),F2)),aa(product_prod(C,B),product_prod(B,C),product_swap(C,B),P5)) = aa(product_prod(C,B),A,aa(fun(C,fun(B,A)),fun(product_prod(C,B),A),product_case_prod(C,B,A),F2),P5) ) ).

% case_swap
tff(fact_5272_not__INFM,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ~ frequently(A,P,cofinite(A))
    <=> eventually(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P),cofinite(A)) ) ).

% not_INFM
tff(fact_5273_not__MOST,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ~ eventually(A,P,cofinite(A))
    <=> frequently(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P),cofinite(A)) ) ).

% not_MOST
tff(fact_5274_INFM__const,axiom,
    ! [A: $tType,P: bool] :
      ( frequently(A,aTP_Lamp_an(bool,fun(A,bool),P),cofinite(A))
    <=> ( pp(P)
        & ~ pp(aa(set(A),bool,finite_finite2(A),top_top(set(A)))) ) ) ).

% INFM_const
tff(fact_5275_INFM__neq_I1_J,axiom,
    ! [A: $tType,A4: A] :
      ( frequently(A,aa(A,fun(A,bool),aTP_Lamp_rz(A,fun(A,bool)),A4),cofinite(A))
    <=> ~ pp(aa(set(A),bool,finite_finite2(A),top_top(set(A)))) ) ).

% INFM_neq(1)
tff(fact_5276_INFM__neq_I2_J,axiom,
    ! [A: $tType,A4: A] :
      ( frequently(A,aa(A,fun(A,bool),aTP_Lamp_adp(A,fun(A,bool)),A4),cofinite(A))
    <=> ~ pp(aa(set(A),bool,finite_finite2(A),top_top(set(A)))) ) ).

% INFM_neq(2)
tff(fact_5277_frequently__const__iff,axiom,
    ! [A: $tType,P: bool,F: filter(A)] :
      ( frequently(A,aTP_Lamp_an(bool,fun(A,bool),P),F)
    <=> ( pp(P)
        & ( F != bot_bot(filter(A)) ) ) ) ).

% frequently_const_iff
tff(fact_5278_frequently__all,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool)),F: filter(A)] :
      ( frequently(A,aTP_Lamp_afn(fun(A,fun(B,bool)),fun(A,bool),P),F)
    <=> ! [Y7: fun(A,B)] : frequently(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_nr(fun(A,fun(B,bool)),fun(fun(A,B),fun(A,bool)),P),Y7),F) ) ).

% frequently_all
tff(fact_5279_not__frequently__False,axiom,
    ! [A: $tType,F: filter(A)] : ~ frequently(A,aTP_Lamp_ao(A,bool),F) ).

% not_frequently_False
tff(fact_5280_frequently__disj__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),F: filter(A)] :
      ( frequently(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_au(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F)
    <=> ( frequently(A,P,F)
        | frequently(A,Q,F) ) ) ).

% frequently_disj_iff
tff(fact_5281_frequently__elim1,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A),Q: fun(A,bool)] :
      ( frequently(A,P,F)
     => ( ! [I3: A] :
            ( pp(aa(A,bool,P,I3))
           => pp(aa(A,bool,Q,I3)) )
       => frequently(A,Q,F) ) ) ).

% frequently_elim1
tff(fact_5282_frequently__disj,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A),Q: fun(A,bool)] :
      ( frequently(A,P,F)
     => ( frequently(A,Q,F)
       => frequently(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_au(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F) ) ) ).

% frequently_disj
tff(fact_5283_frequently__ex,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A)] :
      ( frequently(A,P,F)
     => ? [X_1: A] : pp(aa(A,bool,P,X_1)) ) ).

% frequently_ex
tff(fact_5284_eventually__frequently__const__simps_I1_J,axiom,
    ! [A: $tType,P: fun(A,bool),C3: bool,F: filter(A)] :
      ( frequently(A,aa(bool,fun(A,bool),aTP_Lamp_ath(fun(A,bool),fun(bool,fun(A,bool)),P),C3),F)
    <=> ( frequently(A,P,F)
        & pp(C3) ) ) ).

% eventually_frequently_const_simps(1)
tff(fact_5285_eventually__frequently__const__simps_I2_J,axiom,
    ! [A: $tType,C3: bool,P: fun(A,bool),F: filter(A)] :
      ( frequently(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_ati(bool,fun(fun(A,bool),fun(A,bool)),C3),P),F)
    <=> ( pp(C3)
        & frequently(A,P,F) ) ) ).

% eventually_frequently_const_simps(2)
tff(fact_5286_eventually__frequently__const__simps_I5_J,axiom,
    ! [A: $tType,P: fun(A,bool),C3: bool,F: filter(A)] :
      ( eventually(A,aa(bool,fun(A,bool),aTP_Lamp_atj(fun(A,bool),fun(bool,fun(A,bool)),P),C3),F)
    <=> ( frequently(A,P,F)
       => pp(C3) ) ) ).

% eventually_frequently_const_simps(5)
tff(fact_5287_frequently__mp,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),F: filter(A)] :
      ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aw(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F)
     => ( frequently(A,P,F)
       => frequently(A,Q,F) ) ) ).

% frequently_mp
tff(fact_5288_frequently__def,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A)] :
      ( frequently(A,P,F)
    <=> ~ eventually(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P),F) ) ).

% frequently_def
tff(fact_5289_not__eventually,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A)] :
      ( ~ eventually(A,P,F)
    <=> frequently(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P),F) ) ).

% not_eventually
tff(fact_5290_not__frequently,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A)] :
      ( ~ frequently(A,P,F)
    <=> eventually(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P),F) ) ).

% not_frequently
tff(fact_5291_frequently__rev__mp,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A),Q: fun(A,bool)] :
      ( frequently(A,P,F)
     => ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aw(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F)
       => frequently(A,Q,F) ) ) ).

% frequently_rev_mp
tff(fact_5292_frequently__imp__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),F: filter(A)] :
      ( frequently(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aw(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F)
    <=> ( eventually(A,P,F)
       => frequently(A,Q,F) ) ) ).

% frequently_imp_iff
tff(fact_5293_INFM__disj__distrib,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( frequently(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_au(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),cofinite(A))
    <=> ( frequently(A,P,cofinite(A))
        | frequently(A,Q,cofinite(A)) ) ) ).

% INFM_disj_distrib
tff(fact_5294_INFM__mono,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( frequently(A,P,cofinite(A))
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
           => pp(aa(A,bool,Q,X)) )
       => frequently(A,Q,cofinite(A)) ) ) ).

% INFM_mono
tff(fact_5295_INFM__EX,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( frequently(A,P,cofinite(A))
     => ? [X_1: A] : pp(aa(A,bool,P,X_1)) ) ).

% INFM_EX
tff(fact_5296_INFM__E,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( frequently(A,P,cofinite(A))
     => ~ ! [X: A] : ~ pp(aa(A,bool,P,X)) ) ).

% INFM_E
tff(fact_5297_not__INFM__eq_I1_J,axiom,
    ! [A: $tType,A4: A] : ~ frequently(A,aTP_Lamp_ct(A,fun(A,bool),A4),cofinite(A)) ).

% not_INFM_eq(1)
tff(fact_5298_not__INFM__eq_I2_J,axiom,
    ! [A: $tType,A4: A] : ~ frequently(A,aa(A,fun(A,bool),fequal(A),A4),cofinite(A)) ).

% not_INFM_eq(2)
tff(fact_5299_eventually__frequently,axiom,
    ! [A: $tType,F: filter(A),P: fun(A,bool)] :
      ( ( F != bot_bot(filter(A)) )
     => ( eventually(A,P,F)
       => frequently(A,P,F) ) ) ).

% eventually_frequently
tff(fact_5300_frequently__bex__finite__distrib,axiom,
    ! [A: $tType,B: $tType,A3: set(A),P: fun(B,fun(A,bool)),F: filter(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( frequently(B,aa(fun(B,fun(A,bool)),fun(B,bool),aTP_Lamp_aet(set(A),fun(fun(B,fun(A,bool)),fun(B,bool)),A3),P),F)
      <=> ? [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),A3))
            & frequently(B,aa(A,fun(B,bool),aTP_Lamp_kr(fun(B,fun(A,bool)),fun(A,fun(B,bool)),P),X3),F) ) ) ) ).

% frequently_bex_finite_distrib
tff(fact_5301_frequently__bex__finite,axiom,
    ! [A: $tType,B: $tType,A3: set(A),P: fun(B,fun(A,bool)),F: filter(B)] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( frequently(B,aa(fun(B,fun(A,bool)),fun(B,bool),aTP_Lamp_aet(set(A),fun(fun(B,fun(A,bool)),fun(B,bool)),A3),P),F)
       => ? [X: A] :
            ( pp(aa(set(A),bool,member(A,X),A3))
            & frequently(B,aa(A,fun(B,bool),aTP_Lamp_kr(fun(B,fun(A,bool)),fun(A,fun(B,bool)),P),X),F) ) ) ) ).

% frequently_bex_finite
tff(fact_5302_frequently__cofinite,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( frequently(A,P,cofinite(A))
    <=> ~ pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),P))) ) ).

% frequently_cofinite
tff(fact_5303_INFM__iff__infinite,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( frequently(A,P,cofinite(A))
    <=> ~ pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),P))) ) ).

% INFM_iff_infinite
tff(fact_5304_INFM__conjI,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( frequently(A,P,cofinite(A))
     => ( eventually(A,Q,cofinite(A))
       => frequently(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),cofinite(A)) ) ) ).

% INFM_conjI
tff(fact_5305_Alm__all__def,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( eventually(A,P,cofinite(A))
    <=> ~ frequently(A,aTP_Lamp_as(fun(A,bool),fun(A,bool),P),cofinite(A)) ) ).

% Alm_all_def
tff(fact_5306_INFM__imp__distrib,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( frequently(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aw(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),cofinite(A))
    <=> ( eventually(A,P,cofinite(A))
       => frequently(A,Q,cofinite(A)) ) ) ).

% INFM_imp_distrib
tff(fact_5307_eventually__frequentlyE,axiom,
    ! [A: $tType,P: fun(A,bool),F: filter(A),Q: fun(A,bool)] :
      ( eventually(A,P,F)
     => ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_atk(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F)
       => ( ( F != bot_bot(filter(A)) )
         => frequently(A,Q,F) ) ) ) ).

% eventually_frequentlyE
tff(fact_5308_INFM__nat,axiom,
    ! [P: fun(nat,bool)] :
      ( frequently(nat,P,cofinite(nat))
    <=> ! [M5: nat] :
        ? [N5: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M5),N5))
          & pp(aa(nat,bool,P,N5)) ) ) ).

% INFM_nat
tff(fact_5309_INFM__nat__le,axiom,
    ! [P: fun(nat,bool)] :
      ( frequently(nat,P,cofinite(nat))
    <=> ! [M5: nat] :
        ? [N5: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M5),N5))
          & pp(aa(nat,bool,P,N5)) ) ) ).

% INFM_nat_le
tff(fact_5310_INFM__inj,axiom,
    ! [A: $tType,B: $tType,P: fun(B,bool),F2: fun(A,B)] :
      ( frequently(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_atl(fun(B,bool),fun(fun(A,B),fun(A,bool)),P),F2),cofinite(A))
     => ( inj_on(A,B,F2,top_top(set(A)))
       => frequently(B,P,cofinite(B)) ) ) ).

% INFM_inj
tff(fact_5311_INFM__finite__Bex__distrib,axiom,
    ! [A: $tType,B: $tType,A3: set(A),P: fun(A,fun(B,bool))] :
      ( pp(aa(set(A),bool,finite_finite2(A),A3))
     => ( frequently(B,aa(fun(A,fun(B,bool)),fun(B,bool),aTP_Lamp_atm(set(A),fun(fun(A,fun(B,bool)),fun(B,bool)),A3),P),cofinite(B))
      <=> ? [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),A3))
            & frequently(B,aa(A,fun(B,bool),P,X3),cofinite(B)) ) ) ) ).

% INFM_finite_Bex_distrib
tff(fact_5312_INFM__nat__inductI,axiom,
    ! [P: fun(nat,bool),Q: fun(nat,bool)] :
      ( pp(aa(nat,bool,P,zero_zero(nat)))
     => ( ! [I3: nat] :
            ( pp(aa(nat,bool,P,I3))
           => ? [J5: nat] :
                ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),J5))
                & pp(aa(nat,bool,P,J5))
                & pp(aa(nat,bool,Q,J5)) ) )
       => frequently(nat,Q,cofinite(nat)) ) ) ).

% INFM_nat_inductI
tff(fact_5313_Sup__multiset__def,axiom,
    ! [A: $tType,A3: set(multiset(A))] :
      ( ( ( ( A3 != bot_bot(set(multiset(A))) )
          & condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3) )
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A3) = aa(fun(A,nat),multiset(A),abs_multiset(A),aTP_Lamp_atn(set(multiset(A)),fun(A,nat),A3)) ) )
      & ( ~ ( ( A3 != bot_bot(set(multiset(A))) )
            & condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3) )
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A3) = zero_zero(multiset(A)) ) ) ) ).

% Sup_multiset_def
tff(fact_5314_irreflp__irrefl__eq,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( irreflp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R))
    <=> irrefl(A,R) ) ).

% irreflp_irrefl_eq
tff(fact_5315_comm__monoid__set_OG__def,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(A,A)),Z2: A,I: set(B),P5: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(set(B),fun(fun(B,A),fun(B,bool)),aTP_Lamp_asg(A,fun(set(B),fun(fun(B,A),fun(B,bool))),Z2),I),P5))))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),P5),I) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F2,Z2),P5),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(set(B),fun(fun(B,A),fun(B,bool)),aTP_Lamp_asg(A,fun(set(B),fun(fun(B,A),fun(B,bool))),Z2),I),P5))) ) )
        & ( ~ pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(set(B),fun(fun(B,A),fun(B,bool)),aTP_Lamp_asg(A,fun(set(B),fun(fun(B,A),fun(B,bool))),Z2),I),P5))))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),P5),I) = Z2 ) ) ) ) ).

% comm_monoid_set.G_def
tff(fact_5316_subset__mset_Obdd__above__empty,axiom,
    ! [A: $tType] : condit8047198070973881523_above(multiset(A),subseteq_mset(A),bot_bot(set(multiset(A)))) ).

% subset_mset.bdd_above_empty
tff(fact_5317_subset__mset_Obdd__above__UN,axiom,
    ! [A: $tType,B: $tType,I: set(B),A3: fun(B,set(multiset(A)))] :
      ( pp(aa(set(B),bool,finite_finite2(B),I))
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(set(multiset(A))),set(multiset(A)),complete_Sup_Sup(set(multiset(A))),aa(set(B),set(set(multiset(A))),image2(B,set(multiset(A)),A3),I)))
      <=> ! [X3: B] :
            ( pp(aa(set(B),bool,member(B,X3),I))
           => condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(B,set(multiset(A)),A3,X3)) ) ) ) ).

% subset_mset.bdd_above_UN
tff(fact_5318_bdd__above__multiset__imp__bdd__above__count,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: A] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3)
     => condit941137186595557371_above(nat,aa(set(multiset(A)),set(nat),image2(multiset(A),nat,aTP_Lamp_apg(A,fun(multiset(A),nat),X2)),A3)) ) ).

% bdd_above_multiset_imp_bdd_above_count
tff(fact_5319_subset__mset_OcSUP__le__iff,axiom,
    ! [B: $tType,A: $tType,A3: set(B),F2: fun(B,multiset(A)),U: multiset(A)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))),U))
        <=> ! [X3: B] :
              ( pp(aa(set(B),bool,member(B,X3),A3))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),F2,X3)),U)) ) ) ) ) ).

% subset_mset.cSUP_le_iff
tff(fact_5320_subset__mset_OcSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType,A3: set(B),G: fun(C,multiset(A)),B2: set(C),F2: fun(B,multiset(A))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(C),set(multiset(A)),image2(C,multiset(A),G),B2))
       => ( ! [N2: B] :
              ( pp(aa(set(B),bool,member(B,N2),A3))
             => ? [X4: C] :
                  ( pp(aa(set(C),bool,member(C,X4),B2))
                  & pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),F2,N2)),aa(C,multiset(A),G,X4))) ) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(C),set(multiset(A)),image2(C,multiset(A),G),B2)))) ) ) ) ).

% subset_mset.cSUP_mono
tff(fact_5321_subset__mset_OLeast__def,axiom,
    ! [A: $tType,P: fun(multiset(A),bool)] : ( aa(fun(multiset(A),bool),multiset(A),least(multiset(A),subseteq_mset(A)),P) = the(multiset(A),aTP_Lamp_ato(fun(multiset(A),bool),fun(multiset(A),bool),P)) ) ).

% subset_mset.Least_def
tff(fact_5322_subset__mset_OcSup__subset__mono,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( ( A3 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),B2)
       => ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),A3),B2))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A3)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),B2))) ) ) ) ).

% subset_mset.cSup_subset_mono
tff(fact_5323_subset__mset_Ofinite__has__maximal,axiom,
    ! [A: $tType,A3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ? [X: multiset(A)] :
            ( pp(aa(set(multiset(A)),bool,member(multiset(A),X),A3))
            & ! [Xa3: multiset(A)] :
                ( pp(aa(set(multiset(A)),bool,member(multiset(A),Xa3),A3))
               => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X),Xa3))
                 => ( X = Xa3 ) ) ) ) ) ) ).

% subset_mset.finite_has_maximal
tff(fact_5324_subset__mset_Ofinite__has__minimal,axiom,
    ! [A: $tType,A3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ? [X: multiset(A)] :
            ( pp(aa(set(multiset(A)),bool,member(multiset(A),X),A3))
            & ! [Xa3: multiset(A)] :
                ( pp(aa(set(multiset(A)),bool,member(multiset(A),Xa3),A3))
               => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Xa3),X))
                 => ( X = Xa3 ) ) ) ) ) ) ).

% subset_mset.finite_has_minimal
tff(fact_5325_subset__mset_OcSup__le__iff,axiom,
    ! [A: $tType,S: set(multiset(A)),A4: multiset(A)] :
      ( ( S != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),S)
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),S)),A4))
        <=> ! [X3: multiset(A)] :
              ( pp(aa(set(multiset(A)),bool,member(multiset(A),X3),S))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X3),A4)) ) ) ) ) ).

% subset_mset.cSup_le_iff
tff(fact_5326_subset__mset_OcSup__mono,axiom,
    ! [A: $tType,B2: set(multiset(A)),A3: set(multiset(A))] :
      ( ( B2 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3)
       => ( ! [B4: multiset(A)] :
              ( pp(aa(set(multiset(A)),bool,member(multiset(A),B4),B2))
             => ? [X4: multiset(A)] :
                  ( pp(aa(set(multiset(A)),bool,member(multiset(A),X4),A3))
                  & pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),B4),X4)) ) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),B2)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A3))) ) ) ) ).

% subset_mset.cSup_mono
tff(fact_5327_subset__mset_OcSup__cInf,axiom,
    ! [A: $tType,S: set(multiset(A))] :
      ( ( S != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),S)
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),S) = aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aTP_Lamp_atp(set(multiset(A)),fun(multiset(A),bool),S))) ) ) ) ).

% subset_mset.cSup_cInf
tff(fact_5328_subset__mset_Obdd__above__Int1,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3)
     => condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A3),B2)) ) ).

% subset_mset.bdd_above_Int1
tff(fact_5329_subset__mset_Obdd__above__Int2,axiom,
    ! [A: $tType,B2: set(multiset(A)),A3: set(multiset(A))] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),B2)
     => condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A3),B2)) ) ).

% subset_mset.bdd_above_Int2
tff(fact_5330_comm__monoid__set_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(B,A),I: set(B)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),G),aa(fun(B,bool),set(B),collect(B),aa(set(B),fun(B,bool),aa(fun(B,A),fun(set(B),fun(B,bool)),aTP_Lamp_atq(A,fun(fun(B,A),fun(set(B),fun(B,bool))),Z2),G),I))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),G),I) ) ) ).

% comm_monoid_set.non_neutral'
tff(fact_5331_subset__mset_OcSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType,A3: set(B),G: fun(B,multiset(A)),B2: set(B),F2: fun(B,multiset(A))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),B2))
       => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A3),B2))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),A3))
               => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),F2,X)),aa(B,multiset(A),G,X))) )
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),B2)))) ) ) ) ) ).

% subset_mset.cSUP_subset_mono
tff(fact_5332_subset__mset_OcInf__eq__non__empty,axiom,
    ! [A: $tType,X5: set(multiset(A)),A4: multiset(A)] :
      ( ( X5 != bot_bot(set(multiset(A))) )
     => ( ! [X: multiset(A)] :
            ( pp(aa(set(multiset(A)),bool,member(multiset(A),X),X5))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A4),X)) )
       => ( ! [Y2: multiset(A)] :
              ( ! [X4: multiset(A)] :
                  ( pp(aa(set(multiset(A)),bool,member(multiset(A),X4),X5))
                 => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Y2),X4)) )
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Y2),A4)) )
         => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X5) = A4 ) ) ) ) ).

% subset_mset.cInf_eq_non_empty
tff(fact_5333_subset__mset_OcInf__greatest,axiom,
    ! [A: $tType,X5: set(multiset(A)),Z2: multiset(A)] :
      ( ( X5 != bot_bot(set(multiset(A))) )
     => ( ! [X: multiset(A)] :
            ( pp(aa(set(multiset(A)),bool,member(multiset(A),X),X5))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Z2),X)) )
       => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Z2),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X5))) ) ) ).

% subset_mset.cInf_greatest
tff(fact_5334_subset__mset_OcSup__eq__non__empty,axiom,
    ! [A: $tType,X5: set(multiset(A)),A4: multiset(A)] :
      ( ( X5 != bot_bot(set(multiset(A))) )
     => ( ! [X: multiset(A)] :
            ( pp(aa(set(multiset(A)),bool,member(multiset(A),X),X5))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X),A4)) )
       => ( ! [Y2: multiset(A)] :
              ( ! [X4: multiset(A)] :
                  ( pp(aa(set(multiset(A)),bool,member(multiset(A),X4),X5))
                 => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X4),Y2)) )
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A4),Y2)) )
         => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),X5) = A4 ) ) ) ) ).

% subset_mset.cSup_eq_non_empty
tff(fact_5335_subset__mset_OcSup__least,axiom,
    ! [A: $tType,X5: set(multiset(A)),Z2: multiset(A)] :
      ( ( X5 != bot_bot(set(multiset(A))) )
     => ( ! [X: multiset(A)] :
            ( pp(aa(set(multiset(A)),bool,member(multiset(A),X),X5))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X),Z2)) )
       => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),X5)),Z2)) ) ) ).

% subset_mset.cSup_least
tff(fact_5336_irreflp__greater,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => irreflp(A,aTP_Lamp_aad(A,fun(A,bool))) ) ).

% irreflp_greater
tff(fact_5337_set__mset__Sup,axiom,
    ! [A: $tType,A3: set(multiset(A))] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3)
     => ( aa(multiset(A),set(A),set_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A3)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(multiset(A)),set(set(A)),image2(multiset(A),set(A),set_mset(A)),A3)) ) ) ).

% set_mset_Sup
tff(fact_5338_comm__monoid__set_Oempty_H,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(A,A)),Z2: A,P5: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),P5),bot_bot(set(B))) = Z2 ) ) ).

% comm_monoid_set.empty'
tff(fact_5339_comm__monoid__set_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,I: set(B),G: fun(B,A),H2: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),I))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_asf(fun(A,fun(A,A)),fun(fun(B,A),fun(fun(B,A),fun(B,A))),F2),G),H2)),I) = aa(A,A,aa(A,fun(A,A),F2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),G),I)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),H2),I)) ) ) ) ).

% comm_monoid_set.distrib_triv'
tff(fact_5340_comm__monoid__set_Odistrib_H,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,I: set(B),G: fun(B,A),H2: fun(B,A)] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(set(B),fun(fun(B,A),fun(B,bool)),aTP_Lamp_asg(A,fun(set(B),fun(fun(B,A),fun(B,bool))),Z2),I),G))))
       => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(set(B),fun(fun(B,A),fun(B,bool)),aTP_Lamp_asg(A,fun(set(B),fun(fun(B,A),fun(B,bool))),Z2),I),H2))))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_asf(fun(A,fun(A,A)),fun(fun(B,A),fun(fun(B,A),fun(B,A))),F2),G),H2)),I) = aa(A,A,aa(A,fun(A,A),F2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),G),I)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),H2),I)) ) ) ) ) ).

% comm_monoid_set.distrib'
tff(fact_5341_count__Sup__multiset__nonempty,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: A] :
      ( ( A3 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3)
       => ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A3)),X2) = aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(A)),set(nat),image2(multiset(A),nat,aTP_Lamp_apg(A,fun(multiset(A),nat),X2)),A3)) ) ) ) ).

% count_Sup_multiset_nonempty
tff(fact_5342_subset__mset_OcINF__greatest,axiom,
    ! [A: $tType,B: $tType,A3: set(B),M2: multiset(A),F2: fun(B,multiset(A))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( ! [X: B] :
            ( pp(aa(set(B),bool,member(B,X),A3))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),M2),aa(B,multiset(A),F2,X))) )
       => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),M2),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3)))) ) ) ).

% subset_mset.cINF_greatest
tff(fact_5343_subset__mset_OcSUP__least,axiom,
    ! [B: $tType,A: $tType,A3: set(B),F2: fun(B,multiset(A)),M: multiset(A)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( ! [X: B] :
            ( pp(aa(set(B),bool,member(B,X),A3))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),F2,X)),M)) )
       => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))),M)) ) ) ).

% subset_mset.cSUP_least
tff(fact_5344_prod_H__def,axiom,
    ! [C: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ( groups1962203154675924110t_prod(C,A) = groups_comm_monoid_G(A,C,times_times(A),one_one(A)) ) ) ).

% prod'_def
tff(fact_5345_bdd__above__multiset__imp__finite__support,axiom,
    ! [A: $tType,A3: set(multiset(A))] :
      ( ( A3 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3)
       => pp(aa(set(A),bool,finite_finite2(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(multiset(A)),set(set(A)),image2(multiset(A),set(A),aTP_Lamp_atr(multiset(A),set(A))),A3)))) ) ) ).

% bdd_above_multiset_imp_finite_support
tff(fact_5346_Sup__multiset__in__multiset,axiom,
    ! [A: $tType,A3: set(multiset(A))] :
      ( ( A3 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3)
       => pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_ats(set(multiset(A)),fun(A,bool),A3)))) ) ) ).

% Sup_multiset_in_multiset
tff(fact_5347_comm__monoid__set_Oinsert_H,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,I: set(B),P5: fun(B,A),I2: B] :
      ( groups778175481326437816id_set(A,F2,Z2)
     => ( pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(set(B),fun(fun(B,A),fun(B,bool)),aTP_Lamp_asg(A,fun(set(B),fun(fun(B,A),fun(B,bool))),Z2),I),P5))))
       => ( ( pp(aa(set(B),bool,member(B,I2),I))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),P5),aa(set(B),set(B),insert(B,I2),I)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),P5),I) ) )
          & ( ~ pp(aa(set(B),bool,member(B,I2),I))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),P5),aa(set(B),set(B),insert(B,I2),I)) = aa(A,A,aa(A,fun(A,A),F2,aa(B,A,P5,I2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F2,Z2),P5),I)) ) ) ) ) ) ).

% comm_monoid_set.insert'
tff(fact_5348_subset__mset_Omono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F2: fun(multiset(A),B),A3: fun(C,multiset(A)),I: set(C)] :
          ( pp(aa(fun(multiset(A),B),bool,mono(multiset(A),B,subseteq_mset(A)),F2))
         => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(C),set(multiset(A)),image2(C,multiset(A),A3),I))
           => ( ( I != bot_bot(set(C)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(C,multiset(A)),fun(C,B),aTP_Lamp_att(fun(multiset(A),B),fun(fun(C,multiset(A)),fun(C,B)),F2),A3)),I))),aa(multiset(A),B,F2,aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(C),set(multiset(A)),image2(C,multiset(A),A3),I))))) ) ) ) ) ).

% subset_mset.mono_cSUP
tff(fact_5349_subset__mset_Omono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F2: fun(multiset(A),B),A3: set(multiset(A))] :
          ( pp(aa(fun(multiset(A),B),bool,mono(multiset(A),B,subseteq_mset(A)),F2))
         => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3)
           => ( ( A3 != bot_bot(set(multiset(A))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(multiset(A)),set(B),image2(multiset(A),B,F2),A3))),aa(multiset(A),B,F2,aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A3)))) ) ) ) ) ).

% subset_mset.mono_cSup
tff(fact_5350_subset__mset_Osum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType,S2: set(B),F2: fun(B,multiset(A)),B2: multiset(A),I2: B] :
      ( pp(aa(set(B),bool,finite_finite2(B),S2))
     => ( ! [I3: B] :
            ( pp(aa(set(B),bool,member(B,I3),S2))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),zero_zero(multiset(A))),aa(B,multiset(A),F2,I3))) )
       => ( ( groups3894954378712506084id_sum(multiset(A),B,plus_plus(multiset(A)),zero_zero(multiset(A)),F2,S2) = B2 )
         => ( pp(aa(set(B),bool,member(B,I2),S2))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),F2,I2)),B2)) ) ) ) ) ).

% subset_mset.sum_nonneg_leq_bound
tff(fact_5351_order_Omono_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [Less_eq: fun(A,fun(A,bool))] : ( mono(A,B,Less_eq) = mono(A,B,Less_eq) ) ) ).

% order.mono.cong
tff(fact_5352_subset__mset_Osum__mono,axiom,
    ! [A: $tType,B: $tType,K5: set(B),F2: fun(B,multiset(A)),G: fun(B,multiset(A))] :
      ( ! [I3: B] :
          ( pp(aa(set(B),bool,member(B,I3),K5))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),F2,I3)),aa(B,multiset(A),G,I3))) )
     => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),groups3894954378712506084id_sum(multiset(A),B,plus_plus(multiset(A)),zero_zero(multiset(A)),F2,K5)),groups3894954378712506084id_sum(multiset(A),B,plus_plus(multiset(A)),zero_zero(multiset(A)),G,K5))) ) ).

% subset_mset.sum_mono
tff(fact_5353_subset__mset_Osum__nonneg__0,axiom,
    ! [B: $tType,A: $tType,S2: set(B),F2: fun(B,multiset(A)),I2: B] :
      ( pp(aa(set(B),bool,finite_finite2(B),S2))
     => ( ! [I3: B] :
            ( pp(aa(set(B),bool,member(B,I3),S2))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),zero_zero(multiset(A))),aa(B,multiset(A),F2,I3))) )
       => ( ( groups3894954378712506084id_sum(multiset(A),B,plus_plus(multiset(A)),zero_zero(multiset(A)),F2,S2) = zero_zero(multiset(A)) )
         => ( pp(aa(set(B),bool,member(B,I2),S2))
           => ( aa(B,multiset(A),F2,I2) = zero_zero(multiset(A)) ) ) ) ) ) ).

% subset_mset.sum_nonneg_0
tff(fact_5354_subset__mset_OGreatest__def,axiom,
    ! [A: $tType,P: fun(multiset(A),bool)] : ( aa(fun(multiset(A),bool),multiset(A),greatest(multiset(A),subseteq_mset(A)),P) = the(multiset(A),aTP_Lamp_atu(fun(multiset(A),bool),fun(multiset(A),bool),P)) ) ).

% subset_mset.Greatest_def
tff(fact_5355_subset__mset_Omono__cINF,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F2: fun(multiset(A),B),A3: fun(C,multiset(A)),I: set(C)] :
          ( pp(aa(fun(multiset(A),B),bool,mono(multiset(A),B,subseteq_mset(A)),F2))
         => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(C),set(multiset(A)),image2(C,multiset(A),A3),I)))
           => ( ( I != bot_bot(set(C)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(multiset(A),B,F2,aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(C),set(multiset(A)),image2(C,multiset(A),A3),I)))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(C,multiset(A)),fun(C,B),aTP_Lamp_att(fun(multiset(A),B),fun(fun(C,multiset(A)),fun(C,B)),F2),A3)),I)))) ) ) ) ) ).

% subset_mset.mono_cINF
tff(fact_5356_subset__mset_Omono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F2: fun(multiset(A),B),A3: set(multiset(A))] :
          ( pp(aa(fun(multiset(A),B),bool,mono(multiset(A),B,subseteq_mset(A)),F2))
         => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),A3))
           => ( ( A3 != bot_bot(set(multiset(A))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(multiset(A),B,F2,aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(multiset(A)),set(B),image2(multiset(A),B,F2),A3)))) ) ) ) ) ).

% subset_mset.mono_cInf
tff(fact_5357_subset__mset_Obdd__below__empty,axiom,
    ! [A: $tType] : pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),bot_bot(set(multiset(A))))) ).

% subset_mset.bdd_below_empty
tff(fact_5358_subset__mset_Obdd__below__UN,axiom,
    ! [A: $tType,B: $tType,I: set(B),A3: fun(B,set(multiset(A)))] :
      ( pp(aa(set(B),bool,finite_finite2(B),I))
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(set(multiset(A))),set(multiset(A)),complete_Sup_Sup(set(multiset(A))),aa(set(B),set(set(multiset(A))),image2(B,set(multiset(A)),A3),I))))
      <=> ! [X3: B] :
            ( pp(aa(set(B),bool,member(B,X3),I))
           => pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(B,set(multiset(A)),A3,X3))) ) ) ) ).

% subset_mset.bdd_below_UN
tff(fact_5359_order_OGreatest_Ocong,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool))] : ( greatest(A,Less_eq) = greatest(A,Less_eq) ) ).

% order.Greatest.cong
tff(fact_5360_subset__mset_Obdd__below__Int2,axiom,
    ! [A: $tType,B2: set(multiset(A)),A3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),B2))
     => pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A3),B2))) ) ).

% subset_mset.bdd_below_Int2
tff(fact_5361_subset__mset_Obdd__below__Int1,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),A3))
     => pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A3),B2))) ) ).

% subset_mset.bdd_below_Int1
tff(fact_5362_subset__mset_Ole__cInf__iff,axiom,
    ! [A: $tType,S: set(multiset(A)),A4: multiset(A)] :
      ( ( S != bot_bot(set(multiset(A))) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),S))
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A4),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),S)))
        <=> ! [X3: multiset(A)] :
              ( pp(aa(set(multiset(A)),bool,member(multiset(A),X3),S))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A4),X3)) ) ) ) ) ).

% subset_mset.le_cInf_iff
tff(fact_5363_subset__mset_OcInf__mono,axiom,
    ! [A: $tType,B2: set(multiset(A)),A3: set(multiset(A))] :
      ( ( B2 != bot_bot(set(multiset(A))) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),A3))
       => ( ! [B4: multiset(A)] :
              ( pp(aa(set(multiset(A)),bool,member(multiset(A),B4),B2))
             => ? [X4: multiset(A)] :
                  ( pp(aa(set(multiset(A)),bool,member(multiset(A),X4),A3))
                  & pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X4),B4)) ) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A3)),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),B2))) ) ) ) ).

% subset_mset.cInf_mono
tff(fact_5364_subset__mset_OcINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType,B2: set(B),F2: fun(C,multiset(A)),A3: set(C),G: fun(B,multiset(A))] :
      ( ( B2 != bot_bot(set(B)) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(C),set(multiset(A)),image2(C,multiset(A),F2),A3)))
       => ( ! [M3: B] :
              ( pp(aa(set(B),bool,member(B,M3),B2))
             => ? [X4: C] :
                  ( pp(aa(set(C),bool,member(C,X4),A3))
                  & pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(C,multiset(A),F2,X4)),aa(B,multiset(A),G,M3))) ) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(C),set(multiset(A)),image2(C,multiset(A),F2),A3))),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),B2)))) ) ) ) ).

% subset_mset.cINF_mono
tff(fact_5365_subset__mset_Ole__cINF__iff,axiom,
    ! [A: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(A)),U: multiset(A)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3)))
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),U),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))))
        <=> ! [X3: B] :
              ( pp(aa(set(B),bool,member(B,X3),A3))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),U),aa(B,multiset(A),F2,X3))) ) ) ) ) ).

% subset_mset.le_cINF_iff
tff(fact_5366_subset__mset_OcInf__superset__mono,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( ( A3 != bot_bot(set(multiset(A))) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),B2))
       => ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),A3),B2))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),B2)),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A3))) ) ) ) ).

% subset_mset.cInf_superset_mono
tff(fact_5367_subset__mset_OcINF__superset__mono,axiom,
    ! [A: $tType,B: $tType,A3: set(B),G: fun(B,multiset(A)),B2: set(B),F2: fun(B,multiset(A))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),B2)))
       => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A3),B2))
         => ( ! [X: B] :
                ( pp(aa(set(B),bool,member(B,X),B2))
               => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),G,X)),aa(B,multiset(A),F2,X))) )
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),B2))),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3)))) ) ) ) ) ).

% subset_mset.cINF_superset_mono
tff(fact_5368_subset__mset_OcInf__le__cSup,axiom,
    ! [A: $tType,A3: set(multiset(A))] :
      ( ( A3 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3)
       => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),A3))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A3)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A3))) ) ) ) ).

% subset_mset.cInf_le_cSup
tff(fact_5369_subset__mset_OcInf__cSup,axiom,
    ! [A: $tType,S: set(multiset(A))] :
      ( ( S != bot_bot(set(multiset(A))) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),S))
       => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),S) = aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aTP_Lamp_atv(set(multiset(A)),fun(multiset(A),bool),S))) ) ) ) ).

% subset_mset.cInf_cSup
tff(fact_5370_subset__mset_OcINF__union,axiom,
    ! [A: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(A)),B2: set(B)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3)))
       => ( ( B2 != bot_bot(set(B)) )
         => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),B2)))
           => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),B2))) ) ) ) ) ) ).

% subset_mset.cINF_union
tff(fact_5371_subset__mset_OcINF__insert,axiom,
    ! [A: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(A)),A4: B] :
      ( ( A3 != bot_bot(set(B)) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3)))
       => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),aa(set(B),set(B),insert(B,A4),A3))) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(B,multiset(A),F2,A4)),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))) ) ) ) ).

% subset_mset.cINF_insert
tff(fact_5372_subset__mset_OcSUP__union,axiom,
    ! [A: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(A)),B2: set(B)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))
       => ( ( B2 != bot_bot(set(B)) )
         => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),B2))
           => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),B2))) ) ) ) ) ) ).

% subset_mset.cSUP_union
tff(fact_5373_set__mset__inter,axiom,
    ! [A: $tType,A3: multiset(A),B2: multiset(A)] : ( aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),A3),B2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(multiset(A),set(A),set_mset(A),A3)),aa(multiset(A),set(A),set_mset(A),B2)) ) ).

% set_mset_inter
tff(fact_5374_subset__mset_Obdd__above__image__sup,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,multiset(A)),G: fun(B,multiset(A)),A3: set(B)] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),aa(fun(B,multiset(A)),fun(B,multiset(A)),aTP_Lamp_atw(fun(B,multiset(A)),fun(fun(B,multiset(A)),fun(B,multiset(A))),F2),G)),A3))
    <=> ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))
        & condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),A3)) ) ) ).

% subset_mset.bdd_above_image_sup
tff(fact_5375_subset__mset_Obdd__below__image__inf,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,multiset(A)),G: fun(B,multiset(A)),A3: set(B)] :
      ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),aa(fun(B,multiset(A)),fun(B,multiset(A)),aTP_Lamp_atx(fun(B,multiset(A)),fun(fun(B,multiset(A)),fun(B,multiset(A))),F2),G)),A3)))
    <=> ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3)))
        & pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),A3))) ) ) ).

% subset_mset.bdd_below_image_inf
tff(fact_5376_prod__mset_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: multiset(B),B2: multiset(B),G: fun(B,A)] :
          ( ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A3),B2) = zero_zero(multiset(B)) )
         => ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),A3),B2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),A3))),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),B2))) ) ) ) ).

% prod_mset.union_disjoint
tff(fact_5377_subset__mset_Omono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( semilattice_inf(B)
     => ! [F2: fun(multiset(A),B),A3: multiset(A),B2: multiset(A)] :
          ( pp(aa(fun(multiset(A),B),bool,mono(multiset(A),B,subseteq_mset(A)),F2))
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(multiset(A),B,F2,aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),A3),B2))),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(multiset(A),B,F2,A3)),aa(multiset(A),B,F2,B2)))) ) ) ).

% subset_mset.mono_inf
tff(fact_5378_subset__mset_OcSup__union__distrib,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( ( A3 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3)
       => ( ( B2 != bot_bot(set(multiset(A))) )
         => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),B2)
           => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),sup_sup(set(multiset(A))),A3),B2)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A3)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),B2)) ) ) ) ) ) ).

% subset_mset.cSup_union_distrib
tff(fact_5379_subset__mset_OcInf__union__distrib,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( ( A3 != bot_bot(set(multiset(A))) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),A3))
       => ( ( B2 != bot_bot(set(multiset(A))) )
         => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),B2))
           => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),sup_sup(set(multiset(A))),A3),B2)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A3)),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),B2)) ) ) ) ) ) ).

% subset_mset.cInf_union_distrib
tff(fact_5380_subset__mset_OcSup__insert__If,axiom,
    ! [A: $tType,X5: set(multiset(A)),A4: multiset(A)] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),X5)
     => ( ( ( X5 = bot_bot(set(multiset(A))) )
         => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),A4),X5)) = A4 ) )
        & ( ( X5 != bot_bot(set(multiset(A))) )
         => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),A4),X5)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),A4),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),X5)) ) ) ) ) ).

% subset_mset.cSup_insert_If
tff(fact_5381_subset__mset_OcSup__insert,axiom,
    ! [A: $tType,X5: set(multiset(A)),A4: multiset(A)] :
      ( ( X5 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),X5)
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),A4),X5)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),A4),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),X5)) ) ) ) ).

% subset_mset.cSup_insert
tff(fact_5382_subset__mset_OcInf__insert,axiom,
    ! [A: $tType,X5: set(multiset(A)),A4: multiset(A)] :
      ( ( X5 != bot_bot(set(multiset(A))) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),X5))
       => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),A4),X5)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),A4),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X5)) ) ) ) ).

% subset_mset.cInf_insert
tff(fact_5383_subset__mset_OcInf__insert__If,axiom,
    ! [A: $tType,X5: set(multiset(A)),A4: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),X5))
     => ( ( ( X5 = bot_bot(set(multiset(A))) )
         => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),A4),X5)) = A4 ) )
        & ( ( X5 != bot_bot(set(multiset(A))) )
         => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),A4),X5)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),A4),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X5)) ) ) ) ) ).

% subset_mset.cInf_insert_If
tff(fact_5384_subset__mset_OcSup__inter__less__eq,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A3)
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),B2)
       => ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A3),B2) != bot_bot(set(multiset(A))) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A3),B2))),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A3)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),B2)))) ) ) ) ).

% subset_mset.cSup_inter_less_eq
tff(fact_5385_subset__mset_Oless__eq__cInf__inter,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),A3))
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),B2))
       => ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A3),B2) != bot_bot(set(multiset(A))) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A3)),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),B2))),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A3),B2)))) ) ) ) ).

% subset_mset.less_eq_cInf_inter
tff(fact_5386_subset__mset_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(A)),G: fun(B,multiset(A))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))
       => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),A3))
         => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),A3))) = aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),aa(fun(B,multiset(A)),fun(B,multiset(A)),aTP_Lamp_atw(fun(B,multiset(A)),fun(fun(B,multiset(A)),fun(B,multiset(A))),F2),G)),A3)) ) ) ) ) ).

% subset_mset.SUP_sup_distrib
tff(fact_5387_subset__mset_OcINF__inf__distrib,axiom,
    ! [A: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(A)),G: fun(B,multiset(A))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3)))
       => ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),A3)))
         => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),A3))) = aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),aa(fun(B,multiset(A)),fun(B,multiset(A)),aTP_Lamp_atx(fun(B,multiset(A)),fun(fun(B,multiset(A)),fun(B,multiset(A))),F2),G)),A3)) ) ) ) ) ).

% subset_mset.cINF_inf_distrib
tff(fact_5388_subset__mset_OcSUP__insert,axiom,
    ! [A: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(A)),A4: B] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),aa(set(B),set(B),insert(B,A4),A3))) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(B,multiset(A),F2,A4)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))) ) ) ) ).

% subset_mset.cSUP_insert
tff(fact_5389_multp__code__def,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),N4: multiset(A),M: multiset(A)] :
      ( multp_code(A,P,N4,M)
    <=> ( ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),M),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),M),N4)) != zero_zero(multiset(A)) )
        & ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),N4),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),M),N4)))))
           => ? [Xa2: A] :
                ( pp(aa(set(A),bool,member(A,Xa2),aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),M),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),M),N4)))))
                & pp(aa(A,bool,aa(A,fun(A,bool),P,X3),Xa2)) ) ) ) ) ).

% multp_code_def
tff(fact_5390_multeqp__code__def,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),N4: multiset(A),M: multiset(A)] :
      ( multeqp_code(A,P,N4,M)
    <=> ! [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),N4),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),M),N4)))))
         => ? [Xa2: A] :
              ( pp(aa(set(A),bool,member(A,Xa2),aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),M),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),M),N4)))))
              & pp(aa(A,bool,aa(A,fun(A,bool),P,X3),Xa2)) ) ) ) ).

% multeqp_code_def
tff(fact_5391_subset__mset_Oinf__Sup1__distrib,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X2),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3)) = lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_aty(set(multiset(A)),fun(multiset(A),fun(multiset(A),bool)),A3),X2))) ) ) ) ).

% subset_mset.inf_Sup1_distrib
tff(fact_5392_subset__mset_OSup__fin_Osingleton,axiom,
    ! [A: $tType,X2: multiset(A)] : ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) = X2 ) ).

% subset_mset.Sup_fin.singleton
tff(fact_5393_subset__mset_OSup__fin_Oinsert,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),A3)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X2),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3)) ) ) ) ).

% subset_mset.Sup_fin.insert
tff(fact_5394_subset__mset_OSup__fin_Oeq__fold_H,axiom,
    ! [A: $tType,A3: set(multiset(A))] : ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3) = aa(option(multiset(A)),multiset(A),the2(multiset(A)),finite_fold(multiset(A),option(multiset(A)),aTP_Lamp_atz(multiset(A),fun(option(multiset(A)),option(multiset(A)))),none(multiset(A)),A3)) ) ).

% subset_mset.Sup_fin.eq_fold'
tff(fact_5395_subset__mset_OSup__fin_Ounion,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),B2))
         => ( ( B2 != bot_bot(set(multiset(A))) )
           => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),sup_sup(set(multiset(A))),A3),B2)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3)),lattic4630905495605216202up_fin(multiset(A),union_mset(A),B2)) ) ) ) ) ) ).

% subset_mset.Sup_fin.union
tff(fact_5396_subset__mset_OSup__fin_Ohom__commute,axiom,
    ! [A: $tType,H2: fun(multiset(A),multiset(A)),N4: set(multiset(A))] :
      ( ! [X: multiset(A),Y2: multiset(A)] : ( aa(multiset(A),multiset(A),H2,aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X),Y2)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(multiset(A),multiset(A),H2,X)),aa(multiset(A),multiset(A),H2,Y2)) )
     => ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),N4))
       => ( ( N4 != bot_bot(set(multiset(A))) )
         => ( aa(multiset(A),multiset(A),H2,lattic4630905495605216202up_fin(multiset(A),union_mset(A),N4)) = lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),image2(multiset(A),multiset(A),H2),N4)) ) ) ) ) ).

% subset_mset.Sup_fin.hom_commute
tff(fact_5397_subset__mset_OSup__fin_Obounded__iff,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3)),X2))
        <=> ! [X3: multiset(A)] :
              ( pp(aa(set(multiset(A)),bool,member(multiset(A),X3),A3))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X3),X2)) ) ) ) ) ).

% subset_mset.Sup_fin.bounded_iff
tff(fact_5398_subset__mset_OSup__fin_OboundedI,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( ! [A5: multiset(A)] :
              ( pp(aa(set(multiset(A)),bool,member(multiset(A),A5),A3))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A5),X2)) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3)),X2)) ) ) ) ).

% subset_mset.Sup_fin.boundedI
tff(fact_5399_subset__mset_OSup__fin_OboundedE,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3)),X2))
         => ! [A14: multiset(A)] :
              ( pp(aa(set(multiset(A)),bool,member(multiset(A),A14),A3))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A14),X2)) ) ) ) ) ).

% subset_mset.Sup_fin.boundedE
tff(fact_5400_subset__mset_OcSup__eq__Sup__fin,axiom,
    ! [A: $tType,X5: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),X5))
     => ( ( X5 != bot_bot(set(multiset(A))) )
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),X5) = lattic4630905495605216202up_fin(multiset(A),union_mset(A),X5) ) ) ) ).

% subset_mset.cSup_eq_Sup_fin
tff(fact_5401_subset__mset_OSup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ~ pp(aa(set(multiset(A)),bool,member(multiset(A),X2),A3))
       => ( ( A3 != bot_bot(set(multiset(A))) )
         => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),A3)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X2),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3)) ) ) ) ) ).

% subset_mset.Sup_fin.insert_not_elem
tff(fact_5402_subset__mset_OSup__fin_Oclosed,axiom,
    ! [A: $tType,A3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( ! [X: multiset(A),Y2: multiset(A)] : pp(aa(set(multiset(A)),bool,member(multiset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X),Y2)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),Y2),bot_bot(set(multiset(A)))))))
         => pp(aa(set(multiset(A)),bool,member(multiset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3)),A3)) ) ) ) ).

% subset_mset.Sup_fin.closed
tff(fact_5403_subset__mset_OSup__fin_Oinsert__remove,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) = bot_bot(set(multiset(A))) )
         => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),A3)) = X2 ) )
        & ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) != bot_bot(set(multiset(A))) )
         => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),A3)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X2),lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))))) ) ) ) ) ).

% subset_mset.Sup_fin.insert_remove
tff(fact_5404_subset__mset_OSup__fin_Oremove,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( pp(aa(set(multiset(A)),bool,member(multiset(A),X2),A3))
       => ( ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) = bot_bot(set(multiset(A))) )
           => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3) = X2 ) )
          & ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) != bot_bot(set(multiset(A))) )
           => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X2),lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))))) ) ) ) ) ) ).

% subset_mset.Sup_fin.remove
tff(fact_5405_subset__mset_OSup__fin_Osubset,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( B2 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),B2),A3))
         => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),B2)),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3)) = lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3) ) ) ) ) ).

% subset_mset.Sup_fin.subset
tff(fact_5406_subset__mset_OSup__fin_Osubset__imp,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),A3),B2))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),B2))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3)),lattic4630905495605216202up_fin(multiset(A),union_mset(A),B2))) ) ) ) ).

% subset_mset.Sup_fin.subset_imp
tff(fact_5407_subset__mset_Oinf__Sup2__distrib,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),B2))
         => ( ( B2 != bot_bot(set(multiset(A))) )
           => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3)),lattic4630905495605216202up_fin(multiset(A),union_mset(A),B2)) = lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(set(multiset(A)),fun(multiset(A),bool),aTP_Lamp_aua(set(multiset(A)),fun(set(multiset(A)),fun(multiset(A),bool)),A3),B2))) ) ) ) ) ) ).

% subset_mset.inf_Sup2_distrib
tff(fact_5408_subset__mset_OInf__fin__le__Sup__fin,axiom,
    ! [A: $tType,A3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3)),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A3))) ) ) ).

% subset_mset.Inf_fin_le_Sup_fin
tff(fact_5409_subset__mset_Osup__Inf2__distrib,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),B2))
         => ( ( B2 != bot_bot(set(multiset(A))) )
           => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3)),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),B2)) = lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(set(multiset(A)),fun(multiset(A),bool),aTP_Lamp_aub(set(multiset(A)),fun(set(multiset(A)),fun(multiset(A),bool)),A3),B2))) ) ) ) ) ) ).

% subset_mset.sup_Inf2_distrib
tff(fact_5410_subset__mset_Osup__Inf1__distrib,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X2),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3)) = lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_auc(set(multiset(A)),fun(multiset(A),fun(multiset(A),bool)),A3),X2))) ) ) ) ).

% subset_mset.sup_Inf1_distrib
tff(fact_5411_subset__mset_OInf__fin_Osingleton,axiom,
    ! [A: $tType,X2: multiset(A)] : ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) = X2 ) ).

% subset_mset.Inf_fin.singleton
tff(fact_5412_subset__mset_OInf__fin_Oinsert,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),A3)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X2),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3)) ) ) ) ).

% subset_mset.Inf_fin.insert
tff(fact_5413_subset__mset_OInf__fin_Oeq__fold_H,axiom,
    ! [A: $tType,A3: set(multiset(A))] : ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3) = aa(option(multiset(A)),multiset(A),the2(multiset(A)),finite_fold(multiset(A),option(multiset(A)),aTP_Lamp_aud(multiset(A),fun(option(multiset(A)),option(multiset(A)))),none(multiset(A)),A3)) ) ).

% subset_mset.Inf_fin.eq_fold'
tff(fact_5414_subset__mset_OInf__fin_Ohom__commute,axiom,
    ! [A: $tType,H2: fun(multiset(A),multiset(A)),N4: set(multiset(A))] :
      ( ! [X: multiset(A),Y2: multiset(A)] : ( aa(multiset(A),multiset(A),H2,aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X),Y2)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(multiset(A),multiset(A),H2,X)),aa(multiset(A),multiset(A),H2,Y2)) )
     => ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),N4))
       => ( ( N4 != bot_bot(set(multiset(A))) )
         => ( aa(multiset(A),multiset(A),H2,lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),N4)) = lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),image2(multiset(A),multiset(A),H2),N4)) ) ) ) ) ).

% subset_mset.Inf_fin.hom_commute
tff(fact_5415_subset__mset_OInf__fin_OboundedE,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X2),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3)))
         => ! [A14: multiset(A)] :
              ( pp(aa(set(multiset(A)),bool,member(multiset(A),A14),A3))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X2),A14)) ) ) ) ) ).

% subset_mset.Inf_fin.boundedE
tff(fact_5416_subset__mset_OInf__fin_OboundedI,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( ! [A5: multiset(A)] :
              ( pp(aa(set(multiset(A)),bool,member(multiset(A),A5),A3))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X2),A5)) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X2),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3))) ) ) ) ).

% subset_mset.Inf_fin.boundedI
tff(fact_5417_subset__mset_OInf__fin_Obounded__iff,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X2),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3)))
        <=> ! [X3: multiset(A)] :
              ( pp(aa(set(multiset(A)),bool,member(multiset(A),X3),A3))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X2),X3)) ) ) ) ) ).

% subset_mset.Inf_fin.bounded_iff
tff(fact_5418_subset__mset_OcInf__eq__Inf__fin,axiom,
    ! [A: $tType,X5: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),X5))
     => ( ( X5 != bot_bot(set(multiset(A))) )
       => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X5) = lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),X5) ) ) ) ).

% subset_mset.cInf_eq_Inf_fin
tff(fact_5419_subset__mset_OInf__fin_Oremove,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( pp(aa(set(multiset(A)),bool,member(multiset(A),X2),A3))
       => ( ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) = bot_bot(set(multiset(A))) )
           => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3) = X2 ) )
          & ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) != bot_bot(set(multiset(A))) )
           => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X2),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))))) ) ) ) ) ) ).

% subset_mset.Inf_fin.remove
tff(fact_5420_subset__mset_OInf__fin_Oinsert__remove,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) = bot_bot(set(multiset(A))) )
         => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),A3)) = X2 ) )
        & ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) != bot_bot(set(multiset(A))) )
         => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),A3)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X2),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A3),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))))) ) ) ) ) ).

% subset_mset.Inf_fin.insert_remove
tff(fact_5421_subset__mset_OInf__fin_Oclosed,axiom,
    ! [A: $tType,A3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( ! [X: multiset(A),Y2: multiset(A)] : pp(aa(set(multiset(A)),bool,member(multiset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X),Y2)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),Y2),bot_bot(set(multiset(A)))))))
         => pp(aa(set(multiset(A)),bool,member(multiset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3)),A3)) ) ) ) ).

% subset_mset.Inf_fin.closed
tff(fact_5422_subset__mset_OInf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType,A3: set(multiset(A)),X2: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ~ pp(aa(set(multiset(A)),bool,member(multiset(A),X2),A3))
       => ( ( A3 != bot_bot(set(multiset(A))) )
         => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),A3)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X2),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3)) ) ) ) ) ).

% subset_mset.Inf_fin.insert_not_elem
tff(fact_5423_subset__mset_OInf__fin_Osubset,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( B2 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),B2),A3))
         => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),B2)),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3)) = lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3) ) ) ) ) ).

% subset_mset.Inf_fin.subset
tff(fact_5424_subset__mset_OInf__fin_Ounion,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),A3))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),B2))
         => ( ( B2 != bot_bot(set(multiset(A))) )
           => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),sup_sup(set(multiset(A))),A3),B2)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3)),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),B2)) ) ) ) ) ) ).

% subset_mset.Inf_fin.union
tff(fact_5425_subset__mset_OInf__fin_Osubset__imp,axiom,
    ! [A: $tType,A3: set(multiset(A)),B2: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),A3),B2))
     => ( ( A3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite2(multiset(A)),B2))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),B2)),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A3))) ) ) ) ).

% subset_mset.Inf_fin.subset_imp
tff(fact_5426_subset__mset_Osum__pos,axiom,
    ! [A: $tType,B: $tType,I: set(B),F2: fun(B,multiset(A))] :
      ( pp(aa(set(B),bool,finite_finite2(B),I))
     => ( ( I != bot_bot(set(B)) )
       => ( ! [I3: B] :
              ( pp(aa(set(B),bool,member(B,I3),I))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),zero_zero(multiset(A))),aa(B,multiset(A),F2,I3))) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),zero_zero(multiset(A))),groups3894954378712506084id_sum(multiset(A),B,plus_plus(multiset(A)),zero_zero(multiset(A)),F2,I))) ) ) ) ).

% subset_mset.sum_pos
tff(fact_5427_subset__mset_Osum__strict__mono,axiom,
    ! [A: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(A)),G: fun(B,multiset(A))] :
      ( pp(aa(set(B),bool,finite_finite2(B),A3))
     => ( ( A3 != bot_bot(set(B)) )
       => ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),A3))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),aa(B,multiset(A),F2,X)),aa(B,multiset(A),G,X))) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),groups3894954378712506084id_sum(multiset(A),B,plus_plus(multiset(A)),zero_zero(multiset(A)),F2,A3)),groups3894954378712506084id_sum(multiset(A),B,plus_plus(multiset(A)),zero_zero(multiset(A)),G,A3))) ) ) ) ).

% subset_mset.sum_strict_mono
tff(fact_5428_subset__mset_OatLeastAtMost__singleton,axiom,
    ! [A: $tType,A4: multiset(A)] : ( set_atLeastAtMost(multiset(A),subseteq_mset(A),A4,A4) = aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),A4),bot_bot(set(multiset(A)))) ) ).

% subset_mset.atLeastAtMost_singleton
tff(fact_5429_subset__mset_OatLeastatMost__empty__iff,axiom,
    ! [A: $tType,A4: multiset(A),B3: multiset(A)] :
      ( ( set_atLeastAtMost(multiset(A),subseteq_mset(A),A4,B3) = bot_bot(set(multiset(A))) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A4),B3)) ) ).

% subset_mset.atLeastatMost_empty_iff
tff(fact_5430_subset__mset_OatLeastatMost__empty__iff2,axiom,
    ! [A: $tType,A4: multiset(A),B3: multiset(A)] :
      ( ( bot_bot(set(multiset(A))) = set_atLeastAtMost(multiset(A),subseteq_mset(A),A4,B3) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A4),B3)) ) ).

% subset_mset.atLeastatMost_empty_iff2
tff(fact_5431_subset__mset_OatLeastatMost__empty,axiom,
    ! [A: $tType,B3: multiset(A),A4: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),B3),A4))
     => ( set_atLeastAtMost(multiset(A),subseteq_mset(A),A4,B3) = bot_bot(set(multiset(A))) ) ) ).

% subset_mset.atLeastatMost_empty
tff(fact_5432_subset__mset_OatLeastAtMost__singleton__iff,axiom,
    ! [A: $tType,A4: multiset(A),B3: multiset(A),C2: multiset(A)] :
      ( ( set_atLeastAtMost(multiset(A),subseteq_mset(A),A4,B3) = aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),C2),bot_bot(set(multiset(A)))) )
    <=> ( ( A4 = B3 )
        & ( B3 = C2 ) ) ) ).

% subset_mset.atLeastAtMost_singleton_iff
tff(fact_5433_subset__mset_Oasymp__greater,axiom,
    ! [A: $tType] : asymp(multiset(A),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool))) ).

% subset_mset.asymp_greater
tff(fact_5434_subset__mset_Oirreflp__greater,axiom,
    ! [A: $tType] : irreflp(multiset(A),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool))) ).

% subset_mset.irreflp_greater
tff(fact_5435_subset__mset_Olexordp_Omono,axiom,
    ! [A: $tType] : order_mono(fun(list(multiset(A)),fun(list(multiset(A)),bool)),fun(list(multiset(A)),fun(list(multiset(A)),bool)),aTP_Lamp_auf(fun(list(multiset(A)),fun(list(multiset(A)),bool)),fun(list(multiset(A)),fun(list(multiset(A)),bool)))) ).

% subset_mset.lexordp.mono
tff(fact_5436_subset__mset_Olexordp__def,axiom,
    ! [A: $tType] : ( lexordp2(multiset(A),subset_mset(A)) = complete_lattice_lfp(fun(list(multiset(A)),fun(list(multiset(A)),bool)),aTP_Lamp_auf(fun(list(multiset(A)),fun(list(multiset(A)),bool)),fun(list(multiset(A)),fun(list(multiset(A)),bool)))) ) ).

% subset_mset.lexordp_def
tff(fact_5437_subset__mset_Oordering__top__axioms,axiom,
    ! [A: $tType] : ordering_top(multiset(A),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool)),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool)),zero_zero(multiset(A))) ).

% subset_mset.ordering_top_axioms
tff(fact_5438_subset__mset_OSup__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] : lattic4895041142388067077er_set(multiset(A),union_mset(A),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool)),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool))) ).

% subset_mset.Sup_fin.semilattice_order_set_axioms
tff(fact_5439_wf__subset__mset__rel,axiom,
    ! [A: $tType] : wf(multiset(A),aa(fun(product_prod(multiset(A),multiset(A)),bool),set(product_prod(multiset(A),multiset(A))),collect(product_prod(multiset(A),multiset(A))),aa(fun(multiset(A),fun(multiset(A),bool)),fun(product_prod(multiset(A),multiset(A)),bool),product_case_prod(multiset(A),multiset(A),bool),subset_mset(A)))) ).

% wf_subset_mset_rel
tff(fact_5440_subset__mset_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] : semila1105856199041335345_order(multiset(A),union_mset(A),zero_zero(multiset(A)),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool)),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool))) ).

% subset_mset.semilattice_neutr_order_axioms
tff(fact_5441_subset__mset_OatLeastAtMost__singleton_H,axiom,
    ! [A: $tType,A4: multiset(A),B3: multiset(A)] :
      ( ( A4 = B3 )
     => ( set_atLeastAtMost(multiset(A),subseteq_mset(A),A4,B3) = aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),A4),bot_bot(set(multiset(A)))) ) ) ).

% subset_mset.atLeastAtMost_singleton'
tff(fact_5442_subset__mset_OcSUP__lessD,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,multiset(A)),A3: set(B),Y: multiset(A),I2: B] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))
     => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))),Y))
       => ( pp(aa(set(B),bool,member(B,I2),A3))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),aa(B,multiset(A),F2,I2)),Y)) ) ) ) ).

% subset_mset.cSUP_lessD
tff(fact_5443_subset__mset_Oless__cINF__D,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,multiset(A)),A3: set(B),Y: multiset(A),I2: B] :
      ( pp(aa(set(multiset(A)),bool,condit8119078960628432327_below(multiset(A),subseteq_mset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3)))
     => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),Y),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F2),A3))))
       => ( pp(aa(set(B),bool,member(B,I2),A3))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),Y),aa(B,multiset(A),F2,I2))) ) ) ) ).

% subset_mset.less_cINF_D
tff(fact_5444_subset__mset_OgreaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType,A4: multiset(A),B3: multiset(A)] : ( set_gr3752724095348155675AtMost(multiset(A),subseteq_mset(A),subset_mset(A),A4,B3) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),set_atLeastAtMost(multiset(A),subseteq_mset(A),A4,B3)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),A4),bot_bot(set(multiset(A))))) ) ).

% subset_mset.greaterThanAtMost_eq_atLeastAtMost_diff
tff(fact_5445_subset__mset_OatLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType,A4: multiset(A),B3: multiset(A)] : ( set_atLeastLessThan(multiset(A),subseteq_mset(A),subset_mset(A),A4,B3) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),set_atLeastAtMost(multiset(A),subseteq_mset(A),A4,B3)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),B3),bot_bot(set(multiset(A))))) ) ).

% subset_mset.atLeastLessThan_eq_atLeastAtMost_diff
tff(fact_5446_subset__mset_OgreaterThanLessThan__empty,axiom,
    ! [A: $tType,L: multiset(A),K: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),L),K))
     => ( set_gr287244882034783167ssThan(multiset(A),subset_mset(A),K,L) = bot_bot(set(multiset(A))) ) ) ).

% subset_mset.greaterThanLessThan_empty
tff(fact_5447_subset__mset_OatLeastLessThan__empty,axiom,
    ! [A: $tType,B3: multiset(A),A4: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),B3),A4))
     => ( set_atLeastLessThan(multiset(A),subseteq_mset(A),subset_mset(A),A4,B3) = bot_bot(set(multiset(A))) ) ) ).

% subset_mset.atLeastLessThan_empty
tff(fact_5448_subset__mset_OatLeastLessThan__empty__iff,axiom,
    ! [A: $tType,A4: multiset(A),B3: multiset(A)] :
      ( ( set_atLeastLessThan(multiset(A),subseteq_mset(A),subset_mset(A),A4,B3) = bot_bot(set(multiset(A))) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),A4),B3)) ) ).

% subset_mset.atLeastLessThan_empty_iff
tff(fact_5449_subset__mset_OatLeastLessThan__empty__iff2,axiom,
    ! [A: $tType,A4: multiset(A),B3: multiset(A)] :
      ( ( bot_bot(set(multiset(A))) = set_atLeastLessThan(multiset(A),subseteq_mset(A),subset_mset(A),A4,B3) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),A4),B3)) ) ).

% subset_mset.atLeastLessThan_empty_iff2
tff(fact_5450_subset__mset_OgreaterThanAtMost__empty,axiom,
    ! [A: $tType,L: multiset(A),K: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),L),K))
     => ( set_gr3752724095348155675AtMost(multiset(A),subseteq_mset(A),subset_mset(A),K,L) = bot_bot(set(multiset(A))) ) ) ).

% subset_mset.greaterThanAtMost_empty
tff(fact_5451_subset__mset_OgreaterThanAtMost__empty__iff,axiom,
    ! [A: $tType,K: multiset(A),L: multiset(A)] :
      ( ( set_gr3752724095348155675AtMost(multiset(A),subseteq_mset(A),subset_mset(A),K,L) = bot_bot(set(multiset(A))) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),K),L)) ) ).

% subset_mset.greaterThanAtMost_empty_iff
tff(fact_5452_subset__mset_OgreaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType,K: multiset(A),L: multiset(A)] :
      ( ( bot_bot(set(multiset(A))) = set_gr3752724095348155675AtMost(multiset(A),subseteq_mset(A),subset_mset(A),K,L) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),K),L)) ) ).

% subset_mset.greaterThanAtMost_empty_iff2
tff(fact_5453_subset__mset_OIio__Int__singleton,axiom,
    ! [A: $tType,X2: multiset(A),K: multiset(A)] :
      ( ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),X2),K))
       => ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_lessThan(multiset(A),subset_mset(A),K)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) = aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A)))) ) )
      & ( ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),X2),K))
       => ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_lessThan(multiset(A),subset_mset(A),K)),aa(set(multiset(A)),set(multiset(A)),insert(multiset(A),X2),bot_bot(set(multiset(A))))) = bot_bot(set(multiset(A))) ) ) ) ).

% subset_mset.Iio_Int_singleton
tff(fact_5454_equivp__equiv,axiom,
    ! [A: $tType,A3: set(product_prod(A,A))] :
      ( equiv_equiv(A,top_top(set(A)),A3)
    <=> equiv_equivp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),A3)) ) ).

% equivp_equiv
tff(fact_5455_asymp__asym__eq,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( asymp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R))
    <=> asym(A,R) ) ).

% asymp_asym_eq
tff(fact_5456_ord_OlessThan__def,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool)),U: A] : ( set_lessThan(A,Less,U) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Less),U)) ) ).

% ord.lessThan_def
tff(fact_5457_Quotient__crel__quotient,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(A,bool)),Abs: fun(A,B),Rep: fun(B,A),T2: fun(A,fun(B,bool))] :
      ( quotient(A,B,R,Abs,Rep,T2)
     => ( equiv_equivp(A,R)
       => ! [X4: A] : ( aa(A,fun(B,bool),T2,X4) = aa(B,fun(B,bool),fequal(B),aa(A,B,Abs,X4)) ) ) ) ).

% Quotient_crel_quotient
tff(fact_5458_subset__mset_OlessThan__def,axiom,
    ! [A: $tType,U: multiset(A)] : ( set_lessThan(multiset(A),subset_mset(A),U) = aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool)),U)) ) ).

% subset_mset.lessThan_def
tff(fact_5459_subset__mset_OatLeastLessThan__def,axiom,
    ! [A: $tType,L: multiset(A),U: multiset(A)] : ( set_atLeastLessThan(multiset(A),subseteq_mset(A),subset_mset(A),L,U) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_atLeast(multiset(A),subseteq_mset(A),L)),set_lessThan(multiset(A),subset_mset(A),U)) ) ).

% subset_mset.atLeastLessThan_def
tff(fact_5460_subset__mset_OgreaterThanLessThan__eq,axiom,
    ! [A: $tType,A4: multiset(A),B3: multiset(A)] : ( set_gr287244882034783167ssThan(multiset(A),subset_mset(A),A4,B3) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_greaterThan(multiset(A),subset_mset(A),A4)),set_lessThan(multiset(A),subset_mset(A),B3)) ) ).

% subset_mset.greaterThanLessThan_eq
tff(fact_5461_subset__mset_OgreaterThanLessThan__def,axiom,
    ! [A: $tType,L: multiset(A),U: multiset(A)] : ( set_gr287244882034783167ssThan(multiset(A),subset_mset(A),L,U) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_greaterThan(multiset(A),subset_mset(A),L)),set_lessThan(multiset(A),subset_mset(A),U)) ) ).

% subset_mset.greaterThanLessThan_def
tff(fact_5462_ord_OgreaterThan__def,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool)),L: A] : ( set_greaterThan(A,Less,L) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),Less,L)) ) ).

% ord.greaterThan_def
tff(fact_5463_ord_OatLeast__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),L: A] : ( set_atLeast(A,Less_eq,L) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),Less_eq,L)) ) ).

% ord.atLeast_def
tff(fact_5464_subset__mset_OatLeast__def,axiom,
    ! [A: $tType,L: multiset(A)] : ( set_atLeast(multiset(A),subseteq_mset(A),L) = aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),L)) ) ).

% subset_mset.atLeast_def
tff(fact_5465_subset__mset_OgreaterThan__def,axiom,
    ! [A: $tType,L: multiset(A)] : ( set_greaterThan(multiset(A),subset_mset(A),L) = aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(multiset(A),fun(multiset(A),bool),subset_mset(A),L)) ) ).

% subset_mset.greaterThan_def
tff(fact_5466_subset__mset_Onot__empty__eq__Ici__eq__empty,axiom,
    ! [A: $tType,L: multiset(A)] : ( bot_bot(set(multiset(A))) != set_atLeast(multiset(A),subseteq_mset(A),L) ) ).

% subset_mset.not_empty_eq_Ici_eq_empty
tff(fact_5467_ord_OgreaterThanLessThan__eq,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool)),A4: A,B3: A] : ( set_gr287244882034783167ssThan(A,Less,A4,B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_greaterThan(A,Less,A4)),set_lessThan(A,Less,B3)) ) ).

% ord.greaterThanLessThan_eq
tff(fact_5468_ord_OgreaterThanLessThan__def,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool)),L: A,U: A] : ( set_gr287244882034783167ssThan(A,Less,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_greaterThan(A,Less,L)),set_lessThan(A,Less,U)) ) ).

% ord.greaterThanLessThan_def
tff(fact_5469_ord_OatLeastLessThan__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),L: A,U: A] : ( set_atLeastLessThan(A,Less_eq,Less,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_atLeast(A,Less_eq,L)),set_lessThan(A,Less,U)) ) ).

% ord.atLeastLessThan_def
tff(fact_5470_subset__mset_OgreaterThanAtMost__def,axiom,
    ! [A: $tType,L: multiset(A),U: multiset(A)] : ( set_gr3752724095348155675AtMost(multiset(A),subseteq_mset(A),subset_mset(A),L,U) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_greaterThan(multiset(A),subset_mset(A),L)),set_atMost(multiset(A),subseteq_mset(A),U)) ) ).

% subset_mset.greaterThanAtMost_def
tff(fact_5471_ord_OgreaterThanAtMost__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),L: A,U: A] : ( set_gr3752724095348155675AtMost(A,Less_eq,Less,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_greaterThan(A,Less,L)),set_atMost(A,Less_eq,U)) ) ).

% ord.greaterThanAtMost_def
tff(fact_5472_ord_OatLeastAtMost__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),L: A,U: A] : ( set_atLeastAtMost(A,Less_eq,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_atLeast(A,Less_eq,L)),set_atMost(A,Less_eq,U)) ) ).

% ord.atLeastAtMost_def
tff(fact_5473_ord_OatMost__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),U: A] : ( set_atMost(A,Less_eq,U) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Less_eq),U)) ) ).

% ord.atMost_def
tff(fact_5474_subset__mset_OatMost__def,axiom,
    ! [A: $tType,U: multiset(A)] : ( set_atMost(multiset(A),subseteq_mset(A),U) = aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool)),U)) ) ).

% subset_mset.atMost_def
tff(fact_5475_subset__mset_Onot__empty__eq__Iic__eq__empty,axiom,
    ! [A: $tType,H2: multiset(A)] : ( bot_bot(set(multiset(A))) != set_atMost(multiset(A),subseteq_mset(A),H2) ) ).

% subset_mset.not_empty_eq_Iic_eq_empty
tff(fact_5476_subset__mset_OatLeastAtMost__def,axiom,
    ! [A: $tType,L: multiset(A),U: multiset(A)] : ( set_atLeastAtMost(multiset(A),subseteq_mset(A),L,U) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_atLeast(multiset(A),subseteq_mset(A),L)),set_atMost(multiset(A),subseteq_mset(A),U)) ) ).

% subset_mset.atLeastAtMost_def
tff(fact_5477_Shift__def,axiom,
    ! [A: $tType,Kl: set(list(A)),K: A] : ( bNF_Greatest_Shift(A,Kl,K) = aa(fun(list(A),bool),set(list(A)),collect(list(A)),aa(A,fun(list(A),bool),aTP_Lamp_auh(set(list(A)),fun(A,fun(list(A),bool)),Kl),K)) ) ).

% Shift_def
tff(fact_5478_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se4197421643247451524op_bit(A,N,one_one(A)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),zero_zero(nat))) ) ) ).

% drop_bit_of_1
tff(fact_5479_bit__double__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4)),N))
        <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))))
            & ( N != zero_zero(nat) )
            & pp(bit_se6407376104438227557le_bit(A,type2(A),N)) ) ) ) ).

% bit_double_iff
tff(fact_5480_bit__minus__1__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),one_one(A))),N))
        <=> pp(bit_se6407376104438227557le_bit(A,type2(A),N)) ) ) ).

% bit_minus_1_iff
tff(fact_5481_bit__minus__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),A4)),N))
        <=> ( pp(bit_se6407376104438227557le_bit(A,type2(A),N))
            & ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),one_one(A))),N)) ) ) ) ).

% bit_minus_iff
tff(fact_5482_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M2: nat,N: nat] : ( bit_se4197421643247451524op_bit(A,M2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),fconj(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M2),N),bit_se6407376104438227557le_bit(A,type2(A),N)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2))) ) ) ).

% drop_bit_exp_eq
tff(fact_5483_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),bit_se4730199178511100633sh_bit(A,N,one_one(A))) = bit_se4197421643247451524op_bit(A,N,A4) ) ) ).

% div_push_bit_of_1_eq_drop_bit
tff(fact_5484_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A4: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A4),N))
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se4197421643247451524op_bit(A,N,A4)),one_one(A)) = one_one(A) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
tff(fact_5485_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M2: nat,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M2)),one_one(A))),N))
        <=> ( pp(bit_se6407376104438227557le_bit(A,type2(A),N))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M2)) ) ) ) ).

% bit_mask_sub_iff
tff(fact_5486_old_Orec__unit__def,axiom,
    ! [T: $tType,X4: T,Xa3: product_unit] : ( product_rec_unit(T,X4,Xa3) = the(T,product_rec_set_unit(T,X4,Xa3)) ) ).

% old.rec_unit_def
tff(fact_5487_Gcd__Lcm,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] : ( gcd_Gcd(A,A3) = gcd_Lcm(A,aa(fun(A,bool),set(A),collect(A),aTP_Lamp_aui(set(A),fun(A,bool),A3))) ) ) ).

% Gcd_Lcm
tff(fact_5488_Lcm__Gcd,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] : ( gcd_Lcm(A,A3) = gcd_Gcd(A,aa(fun(A,bool),set(A),collect(A),aTP_Lamp_auj(set(A),fun(A,bool),A3))) ) ) ).

% Lcm_Gcd
tff(fact_5489_Lcm__abs__eq,axiom,
    ! [K5: set(int)] : ( gcd_Lcm(int,aa(set(int),set(int),image2(int,int,abs_abs(int)),K5)) = gcd_Lcm(int,K5) ) ).

% Lcm_abs_eq
tff(fact_5490_Lcm__int__eq,axiom,
    ! [N4: set(nat)] : ( gcd_Lcm(int,aa(set(nat),set(int),image2(nat,int,semiring_1_of_nat(int)),N4)) = aa(nat,int,semiring_1_of_nat(int),gcd_Lcm(nat,N4)) ) ).

% Lcm_int_eq
tff(fact_5491_Lcm__empty,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Lcm(A,bot_bot(set(A))) = one_one(A) ) ) ).

% Lcm_empty
tff(fact_5492_Lcm__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ( gcd_Lcm(A,A3) = one_one(A) )
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),one_one(A))) ) ) ) ).

% Lcm_1_iff
tff(fact_5493_Lcm__nat__abs__eq,axiom,
    ! [K5: set(int)] : ( gcd_Lcm(nat,aa(set(int),set(nat),image2(int,nat,aTP_Lamp_zw(int,nat)),K5)) = aa(int,nat,nat2,gcd_Lcm(int,K5)) ) ).

% Lcm_nat_abs_eq
tff(fact_5494_Lcm__nat__empty,axiom,
    gcd_Lcm(nat,bot_bot(set(nat))) = one_one(nat) ).

% Lcm_nat_empty
tff(fact_5495_Lcm__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(B),F2: fun(B,A),G: fun(B,A)] :
          ( ! [X: B] :
              ( pp(aa(set(B),bool,member(B,X),A3))
             => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(B,A,F2,X)),aa(B,A,G,X))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),gcd_Lcm(A,aa(set(B),set(A),image2(B,A,F2),A3))),gcd_Lcm(A,aa(set(B),set(A),image2(B,A,G),A3)))) ) ) ).

% Lcm_mono
tff(fact_5496_Gcd__nat__def,axiom,
    ! [M: set(nat)] : ( gcd_Gcd(nat,M) = gcd_Lcm(nat,aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_auk(set(nat),fun(nat,bool),M))) ) ).

% Gcd_nat_def
tff(fact_5497_Lcm__int__def,axiom,
    ! [K5: set(int)] : ( gcd_Lcm(int,K5) = aa(nat,int,semiring_1_of_nat(int),gcd_Lcm(nat,aa(set(int),set(nat),image2(int,nat,aa(fun(int,int),fun(int,nat),comp(int,nat,int,nat2),abs_abs(int))),K5))) ) ).

% Lcm_int_def
tff(fact_5498_Lcm__no__units,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] : ( gcd_Lcm(A,A3) = gcd_Lcm(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_aul(A,bool)))) ) ) ).

% Lcm_no_units
tff(fact_5499_Lcm__coprime_H,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),nat,finite_card(A),A3) != zero_zero(nat) )
         => ( ! [A5: A,B4: A] :
                ( pp(aa(set(A),bool,member(A,A5),A3))
               => ( pp(aa(set(A),bool,member(A,B4),A3))
                 => ( ( A5 != B4 )
                   => algebr8660921524188924756oprime(A,A5,B4) ) ) )
           => ( gcd_Lcm(A,A3) = aa(A,A,normal6383669964737779283malize(A),aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7121269368397514597t_prod(A,A),aTP_Lamp_aum(A,A)),A3)) ) ) ) ) ).

% Lcm_coprime'
tff(fact_5500_Lcm__coprime,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [A5: A,B4: A] :
                  ( pp(aa(set(A),bool,member(A,A5),A3))
                 => ( pp(aa(set(A),bool,member(A,B4),A3))
                   => ( ( A5 != B4 )
                     => algebr8660921524188924756oprime(A,A5,B4) ) ) )
             => ( gcd_Lcm(A,A3) = aa(A,A,normal6383669964737779283malize(A),aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7121269368397514597t_prod(A,A),aTP_Lamp_aum(A,A)),A3)) ) ) ) ) ) ).

% Lcm_coprime
tff(fact_5501_Lcm__eq__Max__nat,axiom,
    ! [M: set(nat)] :
      ( pp(aa(set(nat),bool,finite_finite2(nat),M))
     => ( ( M != bot_bot(set(nat)) )
       => ( ~ pp(aa(set(nat),bool,member(nat,zero_zero(nat)),M))
         => ( ! [M3: nat,N2: nat] :
                ( pp(aa(set(nat),bool,member(nat,M3),M))
               => ( pp(aa(set(nat),bool,member(nat,N2),M))
                 => pp(aa(set(nat),bool,member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M3),N2)),M)) ) )
           => ( gcd_Lcm(nat,M) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),M) ) ) ) ) ) ).

% Lcm_eq_Max_nat
tff(fact_5502_normalize__idem,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,normal6383669964737779283malize(A),A4)) = aa(A,A,normal6383669964737779283malize(A),A4) ) ) ).

% normalize_idem
tff(fact_5503_normalize__eq__0__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A4) = zero_zero(A) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% normalize_eq_0_iff
tff(fact_5504_normalize__0,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ( aa(A,A,normal6383669964737779283malize(A),zero_zero(A)) = zero_zero(A) ) ) ).

% normalize_0
tff(fact_5505_normalize__mult__normalize__left,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A4)),B3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) ) ) ).

% normalize_mult_normalize_left
tff(fact_5506_normalize__mult__normalize__right,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,normal6383669964737779283malize(A),B3))) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) ) ) ).

% normalize_mult_normalize_right
tff(fact_5507_normalize__1,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ( aa(A,A,normal6383669964737779283malize(A),one_one(A)) = one_one(A) ) ) ).

% normalize_1
tff(fact_5508_gcd_Onormalize__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( aa(A,A,normal6383669964737779283malize(A),one_one(A)) = one_one(A) ) ) ).

% gcd.normalize_bottom
tff(fact_5509_normalize__dvd__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(A,A,normal6383669964737779283malize(A),A4)),B3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ).

% normalize_dvd_iff
tff(fact_5510_dvd__normalize__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),aa(A,A,normal6383669964737779283malize(A),B3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ).

% dvd_normalize_iff
tff(fact_5511_coprime__normalize__right__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( algebr8660921524188924756oprime(A,A4,aa(A,A,normal6383669964737779283malize(A),B3))
        <=> algebr8660921524188924756oprime(A,A4,B3) ) ) ).

% coprime_normalize_right_iff
tff(fact_5512_coprime__normalize__left__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,normal6383669964737779283malize(A),A4),B3)
        <=> algebr8660921524188924756oprime(A,A4,B3) ) ) ).

% coprime_normalize_left_iff
tff(fact_5513_lcm__eq__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3) = one_one(A) )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A))) ) ) ) ).

% lcm_eq_1_iff
tff(fact_5514_lcm_Otop__left__normalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),one_one(A)),A4) = aa(A,A,normal6383669964737779283malize(A),A4) ) ) ).

% lcm.top_left_normalize
tff(fact_5515_lcm_Otop__right__normalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),one_one(A)) = aa(A,A,normal6383669964737779283malize(A),A4) ) ) ).

% lcm.top_right_normalize
tff(fact_5516_normalize__mult__unit__left,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,normal6383669964737779283malize(A),B3) ) ) ) ).

% normalize_mult_unit_left
tff(fact_5517_normalize__mult__unit__right,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A)))
         => ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,normal6383669964737779283malize(A),A4) ) ) ) ).

% normalize_mult_unit_right
tff(fact_5518_gcd__mult__lcm,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A4)),aa(A,A,normal6383669964737779283malize(A),B3)) ) ) ).

% gcd_mult_lcm
tff(fact_5519_lcm__mult__gcd,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A4)),aa(A,A,normal6383669964737779283malize(A),B3)) ) ) ).

% lcm_mult_gcd
tff(fact_5520_Lcm__2,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: A,B3: A] : ( gcd_Lcm(A,aa(set(A),set(A),insert(A,A4),aa(set(A),set(A),insert(A,B3),bot_bot(set(A))))) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3) ) ) ).

% Lcm_2
tff(fact_5521_Lcm__singleton,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: A] : ( gcd_Lcm(A,aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) = aa(A,A,normal6383669964737779283malize(A),A4) ) ) ).

% Lcm_singleton
tff(fact_5522_Gcd__singleton,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: A] : ( gcd_Gcd(A,aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))) = aa(A,A,normal6383669964737779283malize(A),A4) ) ) ).

% Gcd_singleton
tff(fact_5523_coprime__crossproduct,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,D3: A,B3: A,C2: A] :
          ( algebr8660921524188924756oprime(A,A4,D3)
         => ( algebr8660921524188924756oprime(A,B3,C2)
           => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A4)),aa(A,A,normal6383669964737779283malize(A),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),B3)),aa(A,A,normal6383669964737779283malize(A),D3)) )
            <=> ( ( aa(A,A,normal6383669964737779283malize(A),A4) = aa(A,A,normal6383669964737779283malize(A),B3) )
                & ( aa(A,A,normal6383669964737779283malize(A),C2) = aa(A,A,normal6383669964737779283malize(A),D3) ) ) ) ) ) ) ).

% coprime_crossproduct
tff(fact_5524_dvd__normalize__div,axiom,
    ! [A: $tType] :
      ( normal6328177297339901930cative(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
         => ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,normal6383669964737779283malize(A),A4)),aa(A,A,normal6383669964737779283malize(A),B3)) ) ) ) ).

% dvd_normalize_div
tff(fact_5525_associated__unit,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A4) = aa(A,A,normal6383669964737779283malize(A),B3) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),one_one(A))) ) ) ) ).

% associated_unit
tff(fact_5526_normalize__1__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A4) = one_one(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A))) ) ) ).

% normalize_1_iff
tff(fact_5527_is__unit__normalize,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,normal6383669964737779283malize(A),A4) = one_one(A) ) ) ) ).

% is_unit_normalize
tff(fact_5528_normalize__idem__imp__is__unit__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A4) = A4 )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
          <=> ( A4 = one_one(A) ) ) ) ) ).

% normalize_idem_imp_is_unit_iff
tff(fact_5529_gcd__lcm,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => ( ( B3 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3))) ) ) ) ) ).

% gcd_lcm
tff(fact_5530_associated__iff__dvd,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A4) = aa(A,A,normal6383669964737779283malize(A),B3) )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
            & pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4)) ) ) ) ).

% associated_iff_dvd
tff(fact_5531_associated__eqI,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
           => ( ( aa(A,A,normal6383669964737779283malize(A),A4) = A4 )
             => ( ( aa(A,A,normal6383669964737779283malize(A),B3) = B3 )
               => ( A4 = B3 ) ) ) ) ) ) ).

% associated_eqI
tff(fact_5532_associatedD2,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A4) = aa(A,A,normal6383669964737779283malize(A),B3) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4)) ) ) ).

% associatedD2
tff(fact_5533_associatedD1,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A4) = aa(A,A,normal6383669964737779283malize(A),B3) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3)) ) ) ).

% associatedD1
tff(fact_5534_associatedI,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),B3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
           => ( aa(A,A,normal6383669964737779283malize(A),A4) = aa(A,A,normal6383669964737779283malize(A),B3) ) ) ) ) ).

% associatedI
tff(fact_5535_normalize__mult,axiom,
    ! [A: $tType] :
      ( normal6328177297339901930cative(A)
     => ! [A4: A,B3: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A4)),aa(A,A,normal6383669964737779283malize(A),B3)) ) ) ).

% normalize_mult
tff(fact_5536_lcm__mult__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3))) ) ) ).

% lcm_mult_left
tff(fact_5537_lcm__mult__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,C2: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B3),A4)),C2)) ) ) ).

% lcm_mult_right
tff(fact_5538_lcm__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [C2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),C2)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) ) ) ).

% lcm_mult_distrib'
tff(fact_5539_lcm__gcd__prod,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) ) ) ).

% lcm_gcd_prod
tff(fact_5540_lcm__gcd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3))) ) ) ).

% lcm_gcd
tff(fact_5541_Lcm__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde6485984586167503788ce_set(A,gcd_lcm(A),one_one(A),zero_zero(A),normal6383669964737779283malize(A)) ) ).

% Lcm_fin.bounded_quasi_semilattice_set_axioms
tff(fact_5542_lcm__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] :
          ( algebr8660921524188924756oprime(A,A4,B3)
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) ) ) ) ).

% lcm_coprime
tff(fact_5543_gcd__mult__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3))) ) ) ).

% gcd_mult_left
tff(fact_5544_gcd__mult__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,C2: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B3),A4)),C2)) ) ) ).

% gcd_mult_right
tff(fact_5545_gcd__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [C2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),C2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3)) ) ) ).

% gcd_mult_distrib'
tff(fact_5546_Lcm__in__lcm__closed__set__nat,axiom,
    ! [M: set(nat)] :
      ( pp(aa(set(nat),bool,finite_finite2(nat),M))
     => ( ( M != bot_bot(set(nat)) )
       => ( ! [M3: nat,N2: nat] :
              ( pp(aa(set(nat),bool,member(nat,M3),M))
             => ( pp(aa(set(nat),bool,member(nat,N2),M))
               => pp(aa(set(nat),bool,member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M3),N2)),M)) ) )
         => pp(aa(set(nat),bool,member(nat,gcd_Lcm(nat,M)),M)) ) ) ) ).

% Lcm_in_lcm_closed_set_nat
tff(fact_5547_lcm__mult__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)),C2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B3),C2) ) ) ) ).

% lcm_mult_unit1
tff(fact_5548_lcm__mult__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B3),C2) ) ) ) ).

% lcm_mult_unit2
tff(fact_5549_lcm__div__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B3),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A4)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B3),C2) ) ) ) ).

% lcm_div_unit2
tff(fact_5550_lcm__div__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B3),A4)),C2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B3),C2) ) ) ) ).

% lcm_div_unit1
tff(fact_5551_Gcd__mult,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [C2: A,A3: set(A)] : ( gcd_Gcd(A,aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),C2)),A3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),gcd_Gcd(A,A3))) ) ) ).

% Gcd_mult
tff(fact_5552_Lcm__mult,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A),C2: A] :
          ( ( A3 != bot_bot(set(A)) )
         => ( gcd_Lcm(A,aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),C2)),A3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),gcd_Lcm(A,A3))) ) ) ) ).

% Lcm_mult
tff(fact_5553_Gcd__fin__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),B3: A] :
          ( pp(aa(set(A),bool,finite_finite2(A),A3))
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),B3)),A3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3))) ) ) ) ).

% Gcd_fin_mult
tff(fact_5554_Lcm__set__eq__fold,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Xs: list(A)] : ( gcd_Lcm(A,aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,gcd_lcm(A),Xs),one_one(A)) ) ) ).

% Lcm_set_eq_fold
tff(fact_5555_Gcd__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde6485984586167503788ce_set(A,gcd_gcd(A),zero_zero(A),one_one(A),normal6383669964737779283malize(A)) ) ).

% Gcd_fin.bounded_quasi_semilattice_set_axioms
tff(fact_5556_Lcm__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( ( pp(aa(set(A),bool,finite_finite2(A),A3))
           => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) = finite_fold(A,A,gcd_lcm(A),one_one(A),A3) ) )
          & ( ~ pp(aa(set(A),bool,finite_finite2(A),A3))
           => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) = zero_zero(A) ) ) ) ) ).

% Lcm_fin.eq_fold
tff(fact_5557_lcm_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde8507323023520639062attice(A,gcd_lcm(A),one_one(A),zero_zero(A),normal6383669964737779283malize(A)) ) ).

% lcm.bounded_quasi_semilattice_axioms
tff(fact_5558_gcd_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde8507323023520639062attice(A,gcd_gcd(A),zero_zero(A),one_one(A),normal6383669964737779283malize(A)) ) ).

% gcd.bounded_quasi_semilattice_axioms
tff(fact_5559_Lcm__fin_Oempty,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),bot_bot(set(A))) = one_one(A) ) ) ).

% Lcm_fin.empty
tff(fact_5560_is__unit__Lcm__fin__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3)),one_one(A)))
        <=> ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) = one_one(A) ) ) ) ).

% is_unit_Lcm_fin_iff
tff(fact_5561_Lcm__fin__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) = one_one(A) )
        <=> ( ! [X3: A] :
                ( pp(aa(set(A),bool,member(A,X3),A3))
               => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),one_one(A))) )
            & pp(aa(set(A),bool,finite_finite2(A),A3)) ) ) ) ).

% Lcm_fin_1_iff
tff(fact_5562_Lcm__fin__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),B3: A] :
          ( ( A3 != bot_bot(set(A)) )
         => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),B3)),A3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),B3),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3))) ) ) ) ).

% Lcm_fin_mult
tff(fact_5563_Lcm__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,A3: set(A)] : ( aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),insert(A,A4),A3)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))) ) ) ).

% Lcm_fin.insert_remove
tff(fact_5564_Lcm__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,A3: set(A)] :
          ( pp(aa(set(A),bool,member(A,A4),A3))
         => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A4),bot_bot(set(A)))))) ) ) ) ).

% Lcm_fin.remove
tff(fact_5565_Lcm__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Xs: list(A)] : ( aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,gcd_lcm(A),Xs),one_one(A)) ) ) ).

% Lcm_fin.set_eq_fold
tff(fact_5566_Lcm__fin__def,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( semiring_gcd_Lcm_fin(A) = bounde2362111253966948842tice_F(A,gcd_lcm(A),one_one(A),zero_zero(A)) ) ) ).

% Lcm_fin_def
tff(fact_5567_combine__options__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),X2: option(A),Y: option(A)] : ( combine_options(A,F2,X2,Y) = case_option(option(A),A,Y,aa(option(A),fun(A,option(A)),aTP_Lamp_auo(fun(A,fun(A,A)),fun(option(A),fun(A,option(A))),F2),Y),X2) ) ).

% combine_options_def
tff(fact_5568_inv__image__def,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(B,B)),F2: fun(A,B)] : ( inv_image(B,A,R2,F2) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(fun(A,B),fun(A,fun(A,bool)),aTP_Lamp_aup(set(product_prod(B,B)),fun(fun(A,B),fun(A,fun(A,bool))),R2),F2))) ) ).

% inv_image_def
tff(fact_5569_normalize__div,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,normal6383669964737779283malize(A),A4)),A4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),unit_f5069060285200089521factor(A,A4)) ) ) ).

% normalize_div
tff(fact_5570_unit__factor__idem,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] : ( unit_f5069060285200089521factor(A,unit_f5069060285200089521factor(A,A4)) = unit_f5069060285200089521factor(A,A4) ) ) ).

% unit_factor_idem
tff(fact_5571_unit__factor__eq__0__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] :
          ( ( unit_f5069060285200089521factor(A,A4) = zero_zero(A) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% unit_factor_eq_0_iff
tff(fact_5572_unit__factor__0,axiom,
    ! [A: $tType] :
      ( semido2269285787275462019factor(A)
     => ( unit_f5069060285200089521factor(A,zero_zero(A)) = zero_zero(A) ) ) ).

% unit_factor_0
tff(fact_5573_unit__factor__1,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ( unit_f5069060285200089521factor(A,one_one(A)) = one_one(A) ) ) ).

% unit_factor_1
tff(fact_5574_normalize__mult__unit__factor,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A4)),unit_f5069060285200089521factor(A,A4)) = A4 ) ) ).

% normalize_mult_unit_factor
tff(fact_5575_unit__factor__mult__normalize,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),unit_f5069060285200089521factor(A,A4)),aa(A,A,normal6383669964737779283malize(A),A4)) = A4 ) ) ).

% unit_factor_mult_normalize
tff(fact_5576_div__unit__factor,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),unit_f5069060285200089521factor(A,A4)) = aa(A,A,normal6383669964737779283malize(A),A4) ) ) ).

% div_unit_factor
tff(fact_5577_div__normalize,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(A,A,normal6383669964737779283malize(A),A4)) = unit_f5069060285200089521factor(A,A4) ) ) ).

% div_normalize
tff(fact_5578_inv__unit__factor__eq__0__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),unit_f5069060285200089521factor(A,A4)) = zero_zero(A) )
        <=> ( A4 = zero_zero(A) ) ) ) ).

% inv_unit_factor_eq_0_iff
tff(fact_5579_unit__factor__mult__unit__left,axiom,
    ! [A: $tType] :
      ( semido2269285787275462019factor(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),A4),unit_f5069060285200089521factor(A,B3)) ) ) ) ).

% unit_factor_mult_unit_left
tff(fact_5580_unit__factor__mult__unit__right,axiom,
    ! [A: $tType] :
      ( semido2269285787275462019factor(A)
     => ! [A4: A,B3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),times_times(A),B3),A4)) = aa(A,A,aa(A,fun(A,A),times_times(A),unit_f5069060285200089521factor(A,B3)),A4) ) ) ) ).

% unit_factor_mult_unit_right
tff(fact_5581_mult__one__div__unit__factor,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),unit_f5069060285200089521factor(A,B3))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),unit_f5069060285200089521factor(A,B3)) ) ) ).

% mult_one_div_unit_factor
tff(fact_5582_unit__factor__lcm,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] :
          ( ( ( ( A4 = zero_zero(A) )
              | ( B3 = zero_zero(A) ) )
           => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3)) = zero_zero(A) ) )
          & ( ~ ( ( A4 = zero_zero(A) )
                | ( B3 = zero_zero(A) ) )
           => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3)) = one_one(A) ) ) ) ) ).

% unit_factor_lcm
tff(fact_5583_unit__factor__normalize,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] :
          ( ( A4 != zero_zero(A) )
         => ( unit_f5069060285200089521factor(A,aa(A,A,normal6383669964737779283malize(A),A4)) = one_one(A) ) ) ) ).

% unit_factor_normalize
tff(fact_5584_normalize__unit__factor,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] :
          ( ( A4 != zero_zero(A) )
         => ( aa(A,A,normal6383669964737779283malize(A),unit_f5069060285200089521factor(A,A4)) = one_one(A) ) ) ) ).

% normalize_unit_factor
tff(fact_5585_unit__factor__self,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] : pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),unit_f5069060285200089521factor(A,A4)),A4)) ) ).

% unit_factor_self
tff(fact_5586_unit__factor__mult,axiom,
    ! [A: $tType] :
      ( normal6328177297339901930cative(A)
     => ! [A4: A,B3: A] : ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),unit_f5069060285200089521factor(A,A4)),unit_f5069060285200089521factor(A,B3)) ) ) ).

% unit_factor_mult
tff(fact_5587_normalize__unit__factor__eqI,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A4) = aa(A,A,normal6383669964737779283malize(A),B3) )
         => ( ( unit_f5069060285200089521factor(A,A4) = unit_f5069060285200089521factor(A,B3) )
           => ( A4 = B3 ) ) ) ) ).

% normalize_unit_factor_eqI
tff(fact_5588_unit__factor__dvd,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A,B3: A] :
          ( ( A4 != zero_zero(A) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),unit_f5069060285200089521factor(A,A4)),B3)) ) ) ).

% unit_factor_dvd
tff(fact_5589_is__unit__unit__factor,axiom,
    ! [A: $tType] :
      ( semido2269285787275462019factor(A)
     => ! [A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),A4),one_one(A)))
         => ( unit_f5069060285200089521factor(A,A4) = A4 ) ) ) ).

% is_unit_unit_factor
tff(fact_5590_dvd__unit__factor__div,axiom,
    ! [A: $tType] :
      ( normal6328177297339901930cative(A)
     => ! [B3: A,A4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),B3),A4))
         => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),unit_f5069060285200089521factor(A,A4)),unit_f5069060285200089521factor(A,B3)) ) ) ) ).

% dvd_unit_factor_div
tff(fact_5591_gcd__mult__distrib,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [K: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),K),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),K),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),K),B3))),unit_f5069060285200089521factor(A,K)) ) ) ).

% gcd_mult_distrib
tff(fact_5592_mult__gcd__right,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2))),unit_f5069060285200089521factor(A,C2)) ) ) ).

% mult_gcd_right
tff(fact_5593_mult__gcd__left,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [C2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),unit_f5069060285200089521factor(A,C2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3))) ) ) ).

% mult_gcd_left
tff(fact_5594_mult__lcm__left,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [C2: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),unit_f5069060285200089521factor(A,C2)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3))) ) ) ).

% mult_lcm_left
tff(fact_5595_mult__lcm__right,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A4: A,B3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),A4),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2))),unit_f5069060285200089521factor(A,C2)) ) ) ).

% mult_lcm_right
tff(fact_5596_lcm__mult__distrib,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [K: A,A4: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),K),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),K),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),K),B3))),unit_f5069060285200089521factor(A,K)) ) ) ).

% lcm_mult_distrib
tff(fact_5597_unit__factor__is__unit,axiom,
    ! [A: $tType] :
      ( semido2269285787275462019factor(A)
     => ! [A4: A] :
          ( ( A4 != zero_zero(A) )
         => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),unit_f5069060285200089521factor(A,A4)),one_one(A))) ) ) ).

% unit_factor_is_unit
tff(fact_5598_unit__factor__gcd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: A,B3: A] :
          ( ( ( ( A4 = zero_zero(A) )
              & ( B3 = zero_zero(A) ) )
           => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)) = zero_zero(A) ) )
          & ( ~ ( ( A4 = zero_zero(A) )
                & ( B3 = zero_zero(A) ) )
           => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A4),B3)) = one_one(A) ) ) ) ) ).

% unit_factor_gcd
tff(fact_5599_coprime__crossproduct_H,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [B3: A,D3: A,A4: A,C2: A] :
          ( ( B3 != zero_zero(A) )
         => ( ( unit_f5069060285200089521factor(A,B3) = unit_f5069060285200089521factor(A,D3) )
           => ( algebr8660921524188924756oprime(A,A4,B3)
             => ( algebr8660921524188924756oprime(A,C2,D3)
               => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A4),D3) = aa(A,A,aa(A,fun(A,A),times_times(A),B3),C2) )
                <=> ( ( A4 = C2 )
                    & ( B3 = D3 ) ) ) ) ) ) ) ) ).

% coprime_crossproduct'
tff(fact_5600_unit__factor__Lcm,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ( ( gcd_Lcm(A,A3) = zero_zero(A) )
           => ( unit_f5069060285200089521factor(A,gcd_Lcm(A,A3)) = zero_zero(A) ) )
          & ( ( gcd_Lcm(A,A3) != zero_zero(A) )
           => ( unit_f5069060285200089521factor(A,gcd_Lcm(A,A3)) = one_one(A) ) ) ) ) ).

% unit_factor_Lcm
tff(fact_5601_unit__factor__Gcd,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ( ( gcd_Gcd(A,A3) = zero_zero(A) )
           => ( unit_f5069060285200089521factor(A,gcd_Gcd(A,A3)) = zero_zero(A) ) )
          & ( ( gcd_Gcd(A,A3) != zero_zero(A) )
           => ( unit_f5069060285200089521factor(A,gcd_Gcd(A,A3)) = one_one(A) ) ) ) ) ).

% unit_factor_Gcd
tff(fact_5602_normalize__idem__imp__unit__factor__eq,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A4: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A4) = A4 )
         => ( unit_f5069060285200089521factor(A,A4) = aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),fequal(A),A4),zero_zero(A)))) ) ) ) ).

% normalize_idem_imp_unit_factor_eq
tff(fact_5603_rp__inv__image__def,axiom,
    ! [B: $tType,A: $tType] : ( fun_rp_inv_image(A,B) = aa(fun(set(product_prod(A,A)),fun(set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))))),fun(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))),product_case_prod(set(product_prod(A,A)),set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))),aTP_Lamp_auq(set(product_prod(A,A)),fun(set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))))) ) ).

% rp_inv_image_def
tff(fact_5604_lenlex__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lenlex(A,R2) = inv_image(product_prod(nat,list(A)),list(A),lex_prod(nat,list(A),less_than,lex(A,R2)),aTP_Lamp_aur(list(A),product_prod(nat,list(A)))) ) ).

% lenlex_def
tff(fact_5605_mlex__prod__def,axiom,
    ! [A: $tType,F2: fun(A,nat),R: set(product_prod(A,A))] : ( mlex_prod(A,F2,R) = inv_image(product_prod(nat,A),A,lex_prod(nat,A,less_than,R),aTP_Lamp_aus(fun(A,nat),fun(A,product_prod(nat,A)),F2)) ) ).

% mlex_prod_def
tff(fact_5606_measures__def,axiom,
    ! [A: $tType,Fs: list(fun(A,nat))] : ( measures(A,Fs) = inv_image(list(nat),A,lex(nat,less_than),aTP_Lamp_aut(list(fun(A,nat)),fun(A,list(nat)),Fs)) ) ).

% measures_def
tff(fact_5607_old_Orec__sum__def,axiom,
    ! [T: $tType,B: $tType,A: $tType,X4: fun(A,T),Xa3: fun(B,T),Xb3: sum_sum(A,B)] : ( sum_rec_sum(A,T,B,X4,Xa3,Xb3) = the(T,sum_rec_set_sum(A,T,B,X4,Xa3,Xb3)) ) ).

% old.rec_sum_def
tff(fact_5608_takeWhile__not__last,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => ( takeWhile(A,aTP_Lamp_auu(list(A),fun(A,bool),Xs),Xs) = butlast(A,Xs) ) ) ).

% takeWhile_not_last
tff(fact_5609_uncurry__def,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(A,fun(B,C))] : ( uncurry(A,B,C,F2) = aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F2) ) ).

% uncurry_def
tff(fact_5610_img__ord__def,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: fun(A,C),Ord: fun(C,fun(C,B)),X4: A,Xa3: A] : ( partial_img_ord(A,C,B,F2,Ord,X4,Xa3) = aa(C,B,aa(C,fun(C,B),Ord,aa(A,C,F2,X4)),aa(A,C,F2,Xa3)) ) ).

% img_ord_def
tff(fact_5611_mk__less__def,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),X4: A,Xa3: A] :
      ( partial_mk_less(A,R,X4,Xa3)
    <=> ( pp(aa(A,bool,aa(A,fun(A,bool),R,X4),Xa3))
        & ~ pp(aa(A,bool,aa(A,fun(A,bool),R,Xa3),X4)) ) ) ).

% mk_less_def
tff(fact_5612_ID_Oin__rel,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),A4: A,B3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),bNF_id_bnf(fun(A,fun(B,bool)),R),A4),B3))
    <=> ? [Z5: product_prod(A,B)] :
          ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),Z5),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aTP_Lamp_auv(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),R))))
          & ( aa(product_prod(A,B),A,bNF_id_bnf(fun(product_prod(A,B),A),product_fst(A,B)),Z5) = A4 )
          & ( aa(product_prod(A,B),B,bNF_id_bnf(fun(product_prod(A,B),B),product_snd(A,B)),Z5) = B3 ) ) ) ).

% ID.in_rel
tff(fact_5613_is__num_Ocases,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A4: A] :
          ( neg_numeral_is_num(A,A4)
         => ( ( A4 != one_one(A) )
           => ( ! [X: A] :
                  ( ( A4 = aa(A,A,uminus_uminus(A),X) )
                 => ~ neg_numeral_is_num(A,X) )
             => ~ ! [X: A,Y2: A] :
                    ( ( A4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y2) )
                   => ( neg_numeral_is_num(A,X)
                     => ~ neg_numeral_is_num(A,Y2) ) ) ) ) ) ) ).

% is_num.cases
tff(fact_5614_pred__on_Osuc__Union__closed__empty,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,fun(A,bool))] : pp(aa(set(set(A)),bool,member(set(A),bot_bot(set(A))),pred_s596693808085603175closed(A,A3,P))) ).

% pred_on.suc_Union_closed_empty
tff(fact_5615_ID_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X2: A,Ya2: A,F2: fun(A,B),G: fun(A,B)] :
      ( ( X2 = Ya2 )
     => ( pp(aa(A,bool,bNF_id_bnf(fun(A,bool),aa(fun(A,B),fun(A,bool),aTP_Lamp_nv(fun(A,B),fun(fun(A,B),fun(A,bool)),F2),G)),Ya2))
       => ( aa(A,B,bNF_id_bnf(fun(A,B),F2),X2) = aa(A,B,bNF_id_bnf(fun(A,B),G),Ya2) ) ) ) ).

% ID.map_cong_pred
tff(fact_5616_is__num__normalize_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => neg_numeral_is_num(A,one_one(A)) ) ).

% is_num_normalize(4)
tff(fact_5617_pred__on_Osuc__Union__closed__def,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,fun(A,bool))] : ( pred_s596693808085603175closed(A,A3,P) = aa(fun(set(A),bool),set(set(A)),collect(set(A)),pred_s7749564232668923593losedp(A,A3,P)) ) ).

% pred_on.suc_Union_closed_def
tff(fact_5618_subset_Osuc__Union__closed__empty,axiom,
    ! [A: $tType,A3: set(set(A))] : pp(aa(set(set(set(A))),bool,member(set(set(A)),bot_bot(set(set(A)))),pred_s596693808085603175closed(set(A),A3,ord_less(set(A))))) ).

% subset.suc_Union_closed_empty
tff(fact_5619_ID_Orel__cong,axiom,
    ! [A: $tType,B: $tType,X2: A,Ya2: A,Y: B,Xa: B,R: fun(A,fun(B,bool)),Ra2: fun(A,fun(B,bool))] :
      ( ( X2 = Ya2 )
     => ( ( Y = Xa )
       => ( ! [Z3: A,Yb: B] :
              ( pp(aa(set(A),bool,member(A,Z3),aa(set(A),set(A),insert(A,Ya2),bot_bot(set(A)))))
             => ( pp(aa(set(B),bool,member(B,Yb),aa(set(B),set(B),insert(B,Xa),bot_bot(set(B)))))
               => ( pp(aa(B,bool,aa(A,fun(B,bool),R,Z3),Yb))
                <=> pp(aa(B,bool,aa(A,fun(B,bool),Ra2,Z3),Yb)) ) ) )
         => ( pp(aa(B,bool,aa(A,fun(B,bool),bNF_id_bnf(fun(A,fun(B,bool)),R),X2),Y))
          <=> pp(aa(B,bool,aa(A,fun(B,bool),bNF_id_bnf(fun(A,fun(B,bool)),Ra2),Ya2),Xa)) ) ) ) ) ).

% ID.rel_cong
tff(fact_5620_ID_Orel__mono__strong,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),X2: A,Y: B,Ra2: fun(A,fun(B,bool))] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),bNF_id_bnf(fun(A,fun(B,bool)),R),X2),Y))
     => ( ! [Z3: A,Yb: B] :
            ( pp(aa(set(A),bool,member(A,Z3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))
           => ( pp(aa(set(B),bool,member(B,Yb),aa(set(B),set(B),insert(B,Y),bot_bot(set(B)))))
             => ( pp(aa(B,bool,aa(A,fun(B,bool),R,Z3),Yb))
               => pp(aa(B,bool,aa(A,fun(B,bool),Ra2,Z3),Yb)) ) ) )
       => pp(aa(B,bool,aa(A,fun(B,bool),bNF_id_bnf(fun(A,fun(B,bool)),Ra2),X2),Y)) ) ) ).

% ID.rel_mono_strong
tff(fact_5621_ID_Orel__refl__strong,axiom,
    ! [A: $tType,X2: A,Ra2: fun(A,fun(A,bool))] :
      ( ! [Z3: A] :
          ( pp(aa(set(A),bool,member(A,Z3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))
         => pp(aa(A,bool,aa(A,fun(A,bool),Ra2,Z3),Z3)) )
     => pp(aa(A,bool,aa(A,fun(A,bool),bNF_id_bnf(fun(A,fun(A,bool)),Ra2),X2),X2)) ) ).

% ID.rel_refl_strong
tff(fact_5622_subset_Osuc__Union__closed__def,axiom,
    ! [A: $tType,A3: set(set(A))] : ( pred_s596693808085603175closed(set(A),A3,ord_less(set(A))) = aa(fun(set(set(A)),bool),set(set(set(A))),collect(set(set(A))),pred_s7749564232668923593losedp(set(A),A3,ord_less(set(A)))) ) ).

% subset.suc_Union_closed_def
tff(fact_5623_is__num_Osimps,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A4: A] :
          ( neg_numeral_is_num(A,A4)
        <=> ( ( A4 = one_one(A) )
            | ? [X3: A] :
                ( ( A4 = aa(A,A,uminus_uminus(A),X3) )
                & neg_numeral_is_num(A,X3) )
            | ? [X3: A,Y4: A] :
                ( ( A4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4) )
                & neg_numeral_is_num(A,X3)
                & neg_numeral_is_num(A,Y4) ) ) ) ) ).

% is_num.simps
tff(fact_5624_acyclicP__converse,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool))] :
      ( transitive_acyclic(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),conversep(A,A,R2))))
    <=> transitive_acyclic(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2))) ) ).

% acyclicP_converse
tff(fact_5625_typedef__to__part__equivp,axiom,
    ! [A: $tType,B: $tType,Rep: fun(A,B),Abs: fun(B,A),S: set(B)] :
      ( type_definition(A,B,Rep,Abs,S)
     => equiv_part_equivp(B,bNF_eq_onp(B,aTP_Lamp_ni(set(B),fun(B,bool),S))) ) ).

% typedef_to_part_equivp
tff(fact_5626_open__typedef__to__part__equivp,axiom,
    ! [A: $tType,B: $tType,Rep: fun(A,B),Abs: fun(B,A),P: fun(B,bool)] :
      ( type_definition(A,B,Rep,Abs,aa(fun(B,bool),set(B),collect(B),P))
     => equiv_part_equivp(B,bNF_eq_onp(B,P)) ) ).

% open_typedef_to_part_equivp
tff(fact_5627_acyclic__empty,axiom,
    ! [A: $tType] : transitive_acyclic(A,bot_bot(set(product_prod(A,A)))) ).

% acyclic_empty
tff(fact_5628_ID_Opred__True,axiom,
    ! [A: $tType,X4: A] : pp(aa(A,bool,bNF_id_bnf(fun(A,bool),aTP_Lamp_nn(A,bool)),X4)) ).

% ID.pred_True
tff(fact_5629_part__equivp__typedef,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool))] :
      ( equiv_part_equivp(A,R)
     => ? [D4: set(A)] : pp(aa(set(set(A)),bool,member(set(A),D4),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_auw(fun(A,fun(A,bool)),fun(set(A),bool),R)))) ) ).

% part_equivp_typedef
tff(fact_5630_ID_Opred__mono__strong,axiom,
    ! [A: $tType,P: fun(A,bool),X2: A,Pa: fun(A,bool)] :
      ( pp(aa(A,bool,bNF_id_bnf(fun(A,bool),P),X2))
     => ( ! [Z3: A] :
            ( pp(aa(set(A),bool,member(A,Z3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))
           => ( pp(aa(A,bool,P,Z3))
             => pp(aa(A,bool,Pa,Z3)) ) )
       => pp(aa(A,bool,bNF_id_bnf(fun(A,bool),Pa),X2)) ) ) ).

% ID.pred_mono_strong
tff(fact_5631_ID_Opred__cong,axiom,
    ! [A: $tType,X2: A,Ya2: A,P: fun(A,bool),Pa: fun(A,bool)] :
      ( ( X2 = Ya2 )
     => ( ! [Z3: A] :
            ( pp(aa(set(A),bool,member(A,Z3),aa(set(A),set(A),insert(A,Ya2),bot_bot(set(A)))))
           => ( pp(aa(A,bool,P,Z3))
            <=> pp(aa(A,bool,Pa,Z3)) ) )
       => ( pp(aa(A,bool,bNF_id_bnf(fun(A,bool),P),X2))
        <=> pp(aa(A,bool,bNF_id_bnf(fun(A,bool),Pa),Ya2)) ) ) ) ).

% ID.pred_cong
tff(fact_5632_wfP__acyclicP,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool))] :
      ( wfP(A,R2)
     => transitive_acyclic(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2))) ) ).

% wfP_acyclicP
tff(fact_5633_ID_Opred__set,axiom,
    ! [A: $tType,P: fun(A,bool),X4: A] :
      ( pp(aa(A,bool,bNF_id_bnf(fun(A,bool),P),X4))
    <=> ! [Xa2: A] :
          ( pp(aa(set(A),bool,member(A,Xa2),aa(set(A),set(A),insert(A,X4),bot_bot(set(A)))))
         => pp(aa(A,bool,P,Xa2)) ) ) ).

% ID.pred_set
tff(fact_5634_old_Orec__prod__def,axiom,
    ! [T: $tType,B: $tType,A: $tType,X4: fun(A,fun(B,T)),Xa3: product_prod(A,B)] : ( product_rec_prod(A,B,T,X4,Xa3) = the(T,product_rec_set_prod(A,B,T,X4,Xa3)) ) ).

% old.rec_prod_def
tff(fact_5635_snds__def,axiom,
    ! [B: $tType,A: $tType,X4: product_prod(A,B)] : ( basic_snds(A,B,X4) = aa(fun(B,bool),set(B),collect(B),basic_sndsp(A,B,X4)) ) ).

% snds_def
tff(fact_5636_nat__of__num__code_I3_J,axiom,
    ! [N: num] : ( nat_of_num(aa(num,num,bit1,N)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_of_num(N)),nat_of_num(N))) ) ).

% nat_of_num_code(3)
tff(fact_5637_nat__of__num__code_I2_J,axiom,
    ! [N: num] : ( nat_of_num(aa(num,num,bit0,N)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_of_num(N)),nat_of_num(N)) ) ).

% nat_of_num_code(2)
tff(fact_5638_fsts__def,axiom,
    ! [B: $tType,A: $tType,X4: product_prod(A,B)] : ( aa(product_prod(A,B),set(A),basic_fsts(A,B),X4) = aa(fun(A,bool),set(A),collect(A),basic_fstsp(A,B,X4)) ) ).

% fsts_def
tff(fact_5639_inv__on__def,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A3: set(A),X2: B] : ( inv_on(A,B,F2,A3,X2) = fChoice(A,aa(B,fun(A,bool),aa(set(A),fun(B,fun(A,bool)),aTP_Lamp_eo(fun(A,B),fun(set(A),fun(B,fun(A,bool))),F2),A3),X2)) ) ).

% inv_on_def
tff(fact_5640_pick__middlep__def,axiom,
    ! [B: $tType,A: $tType,C: $tType,P: fun(B,fun(A,bool)),Q: fun(A,fun(C,bool)),A4: B,C2: C] : ( bNF_pick_middlep(B,A,C,P,Q,A4,C2) = fChoice(A,aa(C,fun(A,bool),aa(B,fun(C,fun(A,bool)),aa(fun(A,fun(C,bool)),fun(B,fun(C,fun(A,bool))),aTP_Lamp_aux(fun(B,fun(A,bool)),fun(fun(A,fun(C,bool)),fun(B,fun(C,fun(A,bool)))),P),Q),A4),C2)) ) ).

% pick_middlep_def
tff(fact_5641_subset__mset_Osemilattice__order__axioms,axiom,
    ! [A: $tType] : semilattice_order(multiset(A),union_mset(A),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool)),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool))) ).

% subset_mset.semilattice_order_axioms
tff(fact_5642_max_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semilattice_order(A,ord_max(A),aTP_Lamp_pz(A,fun(A,bool)),aTP_Lamp_acj(A,fun(A,bool))) ) ).

% max.semilattice_order_axioms
tff(fact_5643_prod__mset__def,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ( comm_m9189036328036947845d_mset(A) = comm_monoid_F(A,times_times(A),one_one(A)) ) ) ).

% prod_mset_def
tff(fact_5644_semilattice__order_Omono,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,C2: A,B3: A,D3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),C2))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B3),D3))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),aa(A,A,aa(A,fun(A,A),F2,C2),D3))) ) ) ) ).

% semilattice_order.mono
tff(fact_5645_semilattice__order_OorderE,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
       => ( A4 = aa(A,A,aa(A,fun(A,A),F2,A4),B3) ) ) ) ).

% semilattice_order.orderE
tff(fact_5646_semilattice__order_OorderI,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( ( A4 = aa(A,A,aa(A,fun(A,A),F2,A4),B3) )
       => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3)) ) ) ).

% semilattice_order.orderI
tff(fact_5647_semilattice__order_Oabsorb1,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
       => ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = A4 ) ) ) ).

% semilattice_order.absorb1
tff(fact_5648_semilattice__order_Oabsorb2,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),B3: A,A4: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B3),A4))
       => ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = B3 ) ) ) ).

% semilattice_order.absorb2
tff(fact_5649_semilattice__order_Oabsorb3,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3))
       => ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = A4 ) ) ) ).

% semilattice_order.absorb3
tff(fact_5650_semilattice__order_Oabsorb4,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),B3: A,A4: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B3),A4))
       => ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = B3 ) ) ) ).

% semilattice_order.absorb4
tff(fact_5651_semilattice__order_OboundedE,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A,C2: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),aa(A,A,aa(A,fun(A,A),F2,B3),C2)))
       => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
           => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),C2)) ) ) ) ).

% semilattice_order.boundedE
tff(fact_5652_semilattice__order_OboundedI,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A,C2: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),aa(A,A,aa(A,fun(A,A),F2,B3),C2))) ) ) ) ).

% semilattice_order.boundedI
tff(fact_5653_semilattice__order_Oorder__iff,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
      <=> ( A4 = aa(A,A,aa(A,fun(A,A),F2,A4),B3) ) ) ) ).

% semilattice_order.order_iff
tff(fact_5654_semilattice__order_Ocobounded1,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),A4)) ) ).

% semilattice_order.cobounded1
tff(fact_5655_semilattice__order_Ocobounded2,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),B3)) ) ).

% semilattice_order.cobounded2
tff(fact_5656_semilattice__order_Oabsorb__iff1,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
      <=> ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = A4 ) ) ) ).

% semilattice_order.absorb_iff1
tff(fact_5657_semilattice__order_Oabsorb__iff2,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),B3: A,A4: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B3),A4))
      <=> ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = B3 ) ) ) ).

% semilattice_order.absorb_iff2
tff(fact_5658_semilattice__order_Obounded__iff,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A,C2: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),aa(A,A,aa(A,fun(A,A),F2,B3),C2)))
      <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
          & pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),C2)) ) ) ) ).

% semilattice_order.bounded_iff
tff(fact_5659_semilattice__order_OcoboundedI1,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,C2: A,B3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),C2))
       => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),C2)) ) ) ).

% semilattice_order.coboundedI1
tff(fact_5660_semilattice__order_OcoboundedI2,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),B3: A,C2: A,A4: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B3),C2))
       => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),C2)) ) ) ).

% semilattice_order.coboundedI2
tff(fact_5661_semilattice__order_Ostrict__boundedE,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A,C2: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),aa(A,A,aa(A,fun(A,A),F2,B3),C2)))
       => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3))
           => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),C2)) ) ) ) ).

% semilattice_order.strict_boundedE
tff(fact_5662_semilattice__order_Ostrict__order__iff,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3))
      <=> ( ( A4 = aa(A,A,aa(A,fun(A,A),F2,A4),B3) )
          & ( A4 != B3 ) ) ) ) ).

% semilattice_order.strict_order_iff
tff(fact_5663_semilattice__order_Ostrict__coboundedI1,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,C2: A,B3: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),C2))
       => pp(aa(A,bool,aa(A,fun(A,bool),Less,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),C2)) ) ) ).

% semilattice_order.strict_coboundedI1
tff(fact_5664_semilattice__order_Ostrict__coboundedI2,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),B3: A,C2: A,A4: A] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B3),C2))
       => pp(aa(A,bool,aa(A,fun(A,bool),Less,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),C2)) ) ) ).

% semilattice_order.strict_coboundedI2
tff(fact_5665_semilattice__neutr__order_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semila1105856199041335345_order(A,F2,Z2,Less_eq,Less)
     => semilattice_order(A,F2,Less_eq,Less) ) ).

% semilattice_neutr_order.axioms(2)
tff(fact_5666_gcd__nat_Osemilattice__order__axioms,axiom,
    semilattice_order(nat,gcd_gcd(nat),dvd_dvd(nat),aTP_Lamp_abn(nat,fun(nat,bool))) ).

% gcd_nat.semilattice_order_axioms
tff(fact_5667_semilattice__neutr__order_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semilattice_neutr(A,F2,Z2)
     => ( semilattice_order(A,F2,Less_eq,Less)
       => semila1105856199041335345_order(A,F2,Z2,Less_eq,Less) ) ) ).

% semilattice_neutr_order.intro
tff(fact_5668_semilattice__neutr__order__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semila1105856199041335345_order(A,F2,Z2,Less_eq,Less)
    <=> ( semilattice_neutr(A,F2,Z2)
        & semilattice_order(A,F2,Less_eq,Less) ) ) ).

% semilattice_neutr_order_def
tff(fact_5669_inf_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => semilattice_order(A,inf_inf(A),ord_less_eq(A),ord_less(A)) ) ).

% inf.semilattice_order_axioms
tff(fact_5670_min_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semilattice_order(A,ord_min(A),ord_less_eq(A),ord_less(A)) ) ).

% min.semilattice_order_axioms
tff(fact_5671_sup_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => semilattice_order(A,sup_sup(A),aTP_Lamp_ack(A,fun(A,bool)),aTP_Lamp_acl(A,fun(A,bool))) ) ).

% sup.semilattice_order_axioms
tff(fact_5672_comm__monoid__mset_Oneutral__const,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: multiset(B)] :
      ( comm_monoid_mset(A,F2,Z2)
     => ( aa(multiset(A),A,comm_monoid_F(A,F2,Z2),aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_cy(A,fun(B,A)),Z2)),A3)) = Z2 ) ) ).

% comm_monoid_mset.neutral_const
tff(fact_5673_comm__monoid__mset_Odistrib,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(B,A),H2: fun(B,A),A3: multiset(B)] :
      ( comm_monoid_mset(A,F2,Z2)
     => ( aa(multiset(A),A,comm_monoid_F(A,F2,Z2),aa(multiset(B),multiset(A),image_mset(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_asf(fun(A,fun(A,A)),fun(fun(B,A),fun(fun(B,A),fun(B,A))),F2),G),H2)),A3)) = aa(A,A,aa(A,fun(A,A),F2,aa(multiset(A),A,comm_monoid_F(A,F2,Z2),aa(multiset(B),multiset(A),image_mset(B,A,G),A3))),aa(multiset(A),A,comm_monoid_F(A,F2,Z2),aa(multiset(B),multiset(A),image_mset(B,A,H2),A3))) ) ) ).

% comm_monoid_mset.distrib
tff(fact_5674_comm__monoid__mset_Oswap,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(A,fun(A,A)),Z2: A,G: fun(B,fun(C,A)),B2: multiset(C),A3: multiset(B)] :
      ( comm_monoid_mset(A,F2,Z2)
     => ( aa(multiset(A),A,comm_monoid_F(A,F2,Z2),aa(multiset(B),multiset(A),image_mset(B,A,aa(multiset(C),fun(B,A),aa(fun(B,fun(C,A)),fun(multiset(C),fun(B,A)),aa(A,fun(fun(B,fun(C,A)),fun(multiset(C),fun(B,A))),aTP_Lamp_auy(fun(A,fun(A,A)),fun(A,fun(fun(B,fun(C,A)),fun(multiset(C),fun(B,A)))),F2),Z2),G),B2)),A3)) = aa(multiset(A),A,comm_monoid_F(A,F2,Z2),aa(multiset(C),multiset(A),image_mset(C,A,aa(multiset(B),fun(C,A),aa(fun(B,fun(C,A)),fun(multiset(B),fun(C,A)),aa(A,fun(fun(B,fun(C,A)),fun(multiset(B),fun(C,A))),aTP_Lamp_auz(fun(A,fun(A,A)),fun(A,fun(fun(B,fun(C,A)),fun(multiset(B),fun(C,A)))),F2),Z2),G),A3)),B2)) ) ) ).

% comm_monoid_mset.swap
tff(fact_5675_comm__monoid__mset__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid_mset(A,F2,Z2)
    <=> comm_monoid(A,F2,Z2) ) ).

% comm_monoid_mset_def
tff(fact_5676_comm__monoid__mset_Oaxioms,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid_mset(A,F2,Z2)
     => comm_monoid(A,F2,Z2) ) ).

% comm_monoid_mset.axioms
tff(fact_5677_comm__monoid__mset_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid(A,F2,Z2)
     => comm_monoid_mset(A,F2,Z2) ) ).

% comm_monoid_mset.intro
tff(fact_5678_prod__mset_Ocomm__monoid__mset__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => comm_monoid_mset(A,times_times(A),one_one(A)) ) ).

% prod_mset.comm_monoid_mset_axioms
tff(fact_5679_bdd__below__primitive__def,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ( condit1013018076250108175_below(A) = condit16957441358409770ng_bdd(A,aTP_Lamp_ava(A,fun(A,bool))) ) ) ).

% bdd_below_primitive_def
tff(fact_5680_option_Osimps_I15_J,axiom,
    ! [A: $tType,X24: A] : ( set_option(A,aa(A,option(A),some(A),X24)) = aa(set(A),set(A),insert(A,X24),bot_bot(set(A))) ) ).

% option.simps(15)
tff(fact_5681_those_Osimps_I2_J,axiom,
    ! [A: $tType,X2: option(A),Xs: list(option(A))] : ( those(A,aa(list(option(A)),list(option(A)),aa(option(A),fun(list(option(A)),list(option(A))),cons(option(A)),X2),Xs)) = case_option(option(list(A)),A,none(list(A)),aTP_Lamp_avb(list(option(A)),fun(A,option(list(A))),Xs),X2) ) ).

% those.simps(2)
tff(fact_5682_set__empty__eq,axiom,
    ! [A: $tType,Xo: option(A)] :
      ( ( set_option(A,Xo) = bot_bot(set(A)) )
    <=> ( Xo = none(A) ) ) ).

% set_empty_eq
tff(fact_5683_option_Osimps_I14_J,axiom,
    ! [A: $tType] : ( set_option(A,none(A)) = bot_bot(set(A)) ) ).

% option.simps(14)
tff(fact_5684_subset__mset_Obdd__below__primitive__def,axiom,
    ! [A: $tType] : ( condit8119078960628432327_below(multiset(A),subseteq_mset(A)) = condit16957441358409770ng_bdd(multiset(A),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool))) ) ).

% subset_mset.bdd_below_primitive_def
tff(fact_5685_option_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,B)] : ( rel_option(A,B,bNF_Grp(A,B,A3,F2)) = bNF_Grp(option(A),option(B),aa(fun(option(A),bool),set(option(A)),collect(option(A)),aTP_Lamp_avc(set(A),fun(option(A),bool),A3)),map_option(A,B,F2)) ) ).

% option.rel_Grp
tff(fact_5686_option_Oin__rel,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),A4: option(A),B3: option(B)] :
      ( pp(aa(option(B),bool,aa(option(A),fun(option(B),bool),rel_option(A,B,R),A4),B3))
    <=> ? [Z5: option(product_prod(A,B))] :
          ( pp(aa(set(option(product_prod(A,B))),bool,member(option(product_prod(A,B)),Z5),aa(fun(option(product_prod(A,B)),bool),set(option(product_prod(A,B))),collect(option(product_prod(A,B))),aTP_Lamp_avd(fun(A,fun(B,bool)),fun(option(product_prod(A,B)),bool),R))))
          & ( aa(option(product_prod(A,B)),option(A),map_option(product_prod(A,B),A,product_fst(A,B)),Z5) = A4 )
          & ( aa(option(product_prod(A,B)),option(B),map_option(product_prod(A,B),B,product_snd(A,B)),Z5) = B3 ) ) ) ).

% option.in_rel
tff(fact_5687_option_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( rel_option(A,B,R) = aa(fun(option(product_prod(A,B)),fun(option(B),bool)),fun(option(A),fun(option(B),bool)),aa(fun(option(A),fun(option(product_prod(A,B)),bool)),fun(fun(option(product_prod(A,B)),fun(option(B),bool)),fun(option(A),fun(option(B),bool))),relcompp(option(A),option(product_prod(A,B)),option(B)),conversep(option(product_prod(A,B)),option(A),bNF_Grp(option(product_prod(A,B)),option(A),aa(fun(option(product_prod(A,B)),bool),set(option(product_prod(A,B))),collect(option(product_prod(A,B))),aTP_Lamp_avd(fun(A,fun(B,bool)),fun(option(product_prod(A,B)),bool),R)),map_option(product_prod(A,B),A,product_fst(A,B))))),bNF_Grp(option(product_prod(A,B)),option(B),aa(fun(option(product_prod(A,B)),bool),set(option(product_prod(A,B))),collect(option(product_prod(A,B))),aTP_Lamp_avd(fun(A,fun(B,bool)),fun(option(product_prod(A,B)),bool),R)),map_option(product_prod(A,B),B,product_snd(A,B)))) ) ).

% option.rel_compp_Grp
tff(fact_5688_rel__option__iff,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),X2: option(A),Y: option(B)] :
      ( pp(aa(option(B),bool,aa(option(A),fun(option(B),bool),rel_option(A,B,R),X2),Y))
    <=> pp(aa(product_prod(option(A),option(B)),bool,aa(fun(option(A),fun(option(B),bool)),fun(product_prod(option(A),option(B)),bool),product_case_prod(option(A),option(B),bool),aTP_Lamp_avg(fun(A,fun(B,bool)),fun(option(A),fun(option(B),bool)),R)),aa(option(B),product_prod(option(A),option(B)),aa(option(A),fun(option(B),product_prod(option(A),option(B))),product_Pair(option(A),option(B)),X2),Y))) ) ).

% rel_option_iff
tff(fact_5689_option_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: fun(A,fun(C,bool)),X2: option(A),G: fun(B,C),Y: option(B)] :
      ( pp(aa(option(C),bool,aa(option(A),fun(option(C),bool),rel_option(A,C,Sa),X2),aa(option(B),option(C),map_option(B,C,G),Y)))
    <=> pp(aa(option(B),bool,aa(option(A),fun(option(B),bool),rel_option(A,B,aa(fun(B,C),fun(A,fun(B,bool)),aTP_Lamp_fm(fun(A,fun(C,bool)),fun(fun(B,C),fun(A,fun(B,bool))),Sa),G)),X2),Y)) ) ).

% option.rel_map(2)
tff(fact_5690_option_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: fun(C,fun(B,bool)),I2: fun(A,C),X2: option(A),Y: option(B)] :
      ( pp(aa(option(B),bool,aa(option(C),fun(option(B),bool),rel_option(C,B,Sb),aa(option(A),option(C),map_option(A,C,I2),X2)),Y))
    <=> pp(aa(option(B),bool,aa(option(A),fun(option(B),bool),rel_option(A,B,aa(fun(A,C),fun(A,fun(B,bool)),aTP_Lamp_fn(fun(C,fun(B,bool)),fun(fun(A,C),fun(A,fun(B,bool))),Sb),I2)),X2),Y)) ) ).

% option.rel_map(1)
tff(fact_5691_option_Odisc__transfer_I2_J,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool))] : pp(aa(fun(option(B),bool),bool,aa(fun(option(A),bool),fun(fun(option(B),bool),bool),bNF_rel_fun(option(A),option(B),bool,bool,rel_option(A,B,R),fequal(bool)),aTP_Lamp_avh(option(A),bool)),aTP_Lamp_avi(option(B),bool))) ).

% option.disc_transfer(2)
tff(fact_5692_option_Odisc__transfer_I1_J,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool))] : pp(aa(fun(option(B),bool),bool,aa(fun(option(A),bool),fun(fun(option(B),bool),bool),bNF_rel_fun(option(A),option(B),bool,bool,rel_option(A,B,R),fequal(bool)),aTP_Lamp_avj(option(A),bool)),aTP_Lamp_avk(option(B),bool))) ).

% option.disc_transfer(1)
tff(fact_5693_rel__option__inf,axiom,
    ! [B: $tType,A: $tType,A3: fun(A,fun(B,bool)),B2: fun(A,fun(B,bool))] : ( aa(fun(option(A),fun(option(B),bool)),fun(option(A),fun(option(B),bool)),aa(fun(option(A),fun(option(B),bool)),fun(fun(option(A),fun(option(B),bool)),fun(option(A),fun(option(B),bool))),inf_inf(fun(option(A),fun(option(B),bool))),rel_option(A,B,A3)),rel_option(A,B,B2)) = rel_option(A,B,aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),A3),B2)) ) ).

% rel_option_inf
tff(fact_5694_preordering__bdd_OInt1,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: set(A),B2: set(A)] :
      ( condit622319405099724424ng_bdd(A,Less_eq,Less)
     => ( pp(aa(set(A),bool,condit16957441358409770ng_bdd(A,Less_eq),A3))
       => pp(aa(set(A),bool,condit16957441358409770ng_bdd(A,Less_eq),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))) ) ) ).

% preordering_bdd.Int1
tff(fact_5695_preordering__bdd_OInt2,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),B2: set(A),A3: set(A)] :
      ( condit622319405099724424ng_bdd(A,Less_eq,Less)
     => ( pp(aa(set(A),bool,condit16957441358409770ng_bdd(A,Less_eq),B2))
       => pp(aa(set(A),bool,condit16957441358409770ng_bdd(A,Less_eq),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2))) ) ) ).

% preordering_bdd.Int2
tff(fact_5696_numeral__sqr,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),sqr(K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),K)) ) ) ).

% numeral_sqr
tff(fact_5697_subset__mset_Obdd__below_Opreordering__bdd__axioms,axiom,
    ! [A: $tType] : condit622319405099724424ng_bdd(multiset(A),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool)),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool))) ).

% subset_mset.bdd_below.preordering_bdd_axioms
tff(fact_5698_preordering__bdd_Oempty,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( condit622319405099724424ng_bdd(A,Less_eq,Less)
     => pp(aa(set(A),bool,condit16957441358409770ng_bdd(A,Less_eq),bot_bot(set(A)))) ) ).

% preordering_bdd.empty
tff(fact_5699_bdd__below_Opreordering__bdd__axioms,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => condit622319405099724424ng_bdd(A,aTP_Lamp_ava(A,fun(A,bool)),aTP_Lamp_aad(A,fun(A,bool))) ) ).

% bdd_below.preordering_bdd_axioms
tff(fact_5700_in__range_Osimps,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
    <=> ! [X3: nat] :
          ( pp(aa(set(nat),bool,member(nat,X3),As2))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),lim(product_unit,H2))) ) ) ).

% in_range.simps
tff(fact_5701_in__range_Oelims_I1_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X2))
      <=> pp(Y) )
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( pp(Y)
            <=> ~ ! [X3: nat] :
                    ( pp(aa(set(nat),bool,member(nat,X3),As))
                   => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),lim(product_unit,H4))) ) ) ) ) ).

% in_range.elims(1)
tff(fact_5702_in__range_Oelims_I2_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X2))
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ~ ! [X4: nat] :
                  ( pp(aa(set(nat),bool,member(nat,X4),As))
                 => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X4),lim(product_unit,H4))) ) ) ) ).

% in_range.elims(2)
tff(fact_5703_in__range_Oelims_I3_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X2))
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ! [X: nat] :
                ( pp(aa(set(nat),bool,member(nat,X),As))
               => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X),lim(product_unit,H4))) ) ) ) ).

% in_range.elims(3)
tff(fact_5704_new__addrs__def,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat),H5: heap_ext(product_unit)] : ( hoare_new_addrs(H2,As2,H5) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),aa(fun(nat,bool),set(nat),collect(nat),aa(heap_ext(product_unit),fun(nat,bool),aTP_Lamp_avl(heap_ext(product_unit),fun(heap_ext(product_unit),fun(nat,bool)),H2),H5))) ) ).

% new_addrs_def
tff(fact_5705_hoare__tripleE,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn),H2: heap_ext(product_unit),As2: set(nat)] :
      ( hoare_hoare_triple(A,P,C2,Q)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
       => ~ ! [R3: A,H3: heap_ext(product_unit)] :
              ( ? [T6: nat] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(A,C2),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H3),T6))) )
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,Q,R3)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),hoare_new_addrs(H2,As2,H3))))
               => ( relH(aa(fun(nat,bool),set(nat),collect(nat),aa(set(nat),fun(nat,bool),aTP_Lamp_avm(heap_ext(product_unit),fun(set(nat),fun(nat,bool)),H2),As2)),H2,H3)
                 => ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),lim(product_unit,H2)),lim(product_unit,H3))) ) ) ) ) ) ).

% hoare_tripleE
tff(fact_5706_hoare__tripleI,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( ! [H4: heap_ext(product_unit),As: set(nat)] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
         => ? [R9: A,H6: heap_ext(product_unit),T7: nat] :
              ( ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(A,C2),H4) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R9),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H6),T7))) )
              & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,Q,R9)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),hoare_new_addrs(H4,As,H6))))
              & relH(aa(fun(nat,bool),set(nat),collect(nat),aa(set(nat),fun(nat,bool),aTP_Lamp_avm(heap_ext(product_unit),fun(set(nat),fun(nat,bool)),H4),As)),H4,H6)
              & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),lim(product_unit,H4)),lim(product_unit,H6))) ) )
     => hoare_hoare_triple(A,P,C2,Q) ) ).

% hoare_tripleI
tff(fact_5707_new__addr__refl,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat)] : ( hoare_new_addrs(H2,As2,H2) = As2 ) ).

% new_addr_refl
tff(fact_5708_hoare__triple__def,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( hoare_hoare_triple(A,P,C2,Q)
    <=> ! [H: heap_ext(product_unit),As7: set(nat)] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As7)))
         => ? [R7: A,H7: heap_ext(product_unit)] :
              ( ? [T8: nat] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(A,C2),H) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R7),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H7),T8))) )
              & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,Q,R7)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),hoare_new_addrs(H,As7,H7))))
              & relH(aa(fun(nat,bool),set(nat),collect(nat),aa(set(nat),fun(nat,bool),aTP_Lamp_avm(heap_ext(product_unit),fun(set(nat),fun(nat,bool)),H),As7)),H,H7)
              & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),lim(product_unit,H)),lim(product_unit,H7))) ) ) ) ).

% hoare_triple_def
tff(fact_5709_execute__ureturn,axiom,
    ! [A: $tType,X2: A] : ( heap_Time_execute(A,heap_Time_ureturn(A,X2)) = aa(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),comp(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit),some(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_avn(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),X2)) ) ).

% execute_ureturn
tff(fact_5710_execute__return,axiom,
    ! [A: $tType,X2: A] : ( heap_Time_execute(A,aa(A,heap_Time_Heap(A),heap_Time_return(A),X2)) = aa(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),comp(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit),some(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_avo(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),X2)) ) ).

% execute_return
tff(fact_5711_hoare__triple__effect,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn),H2: heap_ext(product_unit),As2: set(nat)] :
      ( hoare_hoare_triple(A,P,C2,Q)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
       => ? [H3: heap_ext(product_unit),R3: A,T6: nat] :
            ( heap_Time_effect(A,C2,H2,H3,R3,T6)
            & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,Q,R3)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),hoare_new_addrs(H2,As2,H3)))) ) ) ) ).

% hoare_triple_effect
tff(fact_5712_effect__LetI,axiom,
    ! [B: $tType,A: $tType,X2: A,T3: A,F2: fun(A,heap_Time_Heap(B)),H2: heap_ext(product_unit),H5: heap_ext(product_unit),R2: B,N: nat] :
      ( ( X2 = T3 )
     => ( heap_Time_effect(B,aa(A,heap_Time_Heap(B),F2,X2),H2,H5,R2,N)
       => heap_Time_effect(B,aa(A,heap_Time_Heap(B),F2,T3),H2,H5,R2,N) ) ) ).

% effect_LetI
tff(fact_5713_ureturn__def,axiom,
    ! [A: $tType,X2: A] : ( heap_Time_ureturn(A,X2) = heap_Time_heap(A,aTP_Lamp_avn(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),X2)) ) ).

% ureturn_def
tff(fact_5714_return__def,axiom,
    ! [A: $tType,X2: A] : ( aa(A,heap_Time_Heap(A),heap_Time_return(A),X2) = heap_Time_heap(A,aTP_Lamp_avo(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),X2)) ) ).

% return_def
tff(fact_5715_sngr__assn__raw_Oelims_I3_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X2,Xa),Xb))
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ( ( ref_get(A,H4,X2) = Xa )
                  & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(A,X2)),bot_bot(set(nat))) )
                  & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_ref(A,X2)),lim(product_unit,H4))) ) ) ) ) ).

% sngr_assn_raw.elims(3)
tff(fact_5716_relH__ref,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit),R2: ref(A)] :
          ( relH(As2,H2,H5)
         => ( pp(aa(set(nat),bool,member(nat,addr_of_ref(A,R2)),As2))
           => ( ref_get(A,H2,R2) = ref_get(A,H5,R2) ) ) ) ) ).

% relH_ref
tff(fact_5717_sngr__assn__raw_Osimps,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R2: ref(A),X2: A,H2: heap_ext(product_unit),As2: set(nat)] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,R2,X2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
        <=> ( ( ref_get(A,H2,R2) = X2 )
            & ( As2 = aa(set(nat),set(nat),insert(nat,addr_of_ref(A,R2)),bot_bot(set(nat))) )
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_ref(A,R2)),lim(product_unit,H2))) ) ) ) ).

% sngr_assn_raw.simps
tff(fact_5718_sngr__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
          ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X2,Xa),Xb))
          <=> pp(Y) )
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ( pp(Y)
                <=> ~ ( ( ref_get(A,H4,X2) = Xa )
                      & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(A,X2)),bot_bot(set(nat))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_ref(A,X2)),lim(product_unit,H4))) ) ) ) ) ) ).

% sngr_assn_raw.elims(1)
tff(fact_5719_sngr__assn__raw_Oelims_I2_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X2,Xa),Xb))
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ~ ( ( ref_get(A,H4,X2) = Xa )
                    & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(A,X2)),bot_bot(set(nat))) )
                    & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_ref(A,X2)),lim(product_unit,H4))) ) ) ) ) ).

% sngr_assn_raw.elims(2)
tff(fact_5720_sngr__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
          ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X2,Xa),Xb))
          <=> pp(Y) )
         => ( pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( ( pp(Y)
                    <=> ( ( ref_get(A,H4,X2) = Xa )
                        & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(A,X2)),bot_bot(set(nat))) )
                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_ref(A,X2)),lim(product_unit,H4))) ) )
                   => ~ pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))) ) ) ) ) ) ).

% sngr_assn_raw.pelims(1)
tff(fact_5721_sngr__assn__raw_Opelims_I2_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X2,Xa),Xb))
         => ( pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))))
                   => ~ ( ( ref_get(A,H4,X2) = Xa )
                        & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(A,X2)),bot_bot(set(nat))) )
                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_ref(A,X2)),lim(product_unit,H4))) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(2)
tff(fact_5722_sngr__assn__raw_Opelims_I3_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X2,Xa),Xb))
         => ( pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))))
                   => ( ( ref_get(A,H4,X2) = Xa )
                      & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(A,X2)),bot_bot(set(nat))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_ref(A,X2)),lim(product_unit,H4))) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(3)
tff(fact_5723_relH__set__ref,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R2: ref(A),As2: set(nat),H2: heap_ext(product_unit),X2: A] :
          ( ~ pp(aa(set(nat),bool,member(nat,addr_of_ref(A,R2)),As2))
         => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
           => relH(As2,H2,aa(heap_ext(product_unit),heap_ext(product_unit),ref_set(A,R2,X2),H2)) ) ) ) ).

% relH_set_ref
tff(fact_5724_snga__assn__raw_Oelims_I3_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X2,Xa),Xb))
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ( ( array_get(A,H4,X2) = Xa )
                  & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(A,X2)),bot_bot(set(nat))) )
                  & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X2)),lim(product_unit,H4))) ) ) ) ) ).

% snga_assn_raw.elims(3)
tff(fact_5725_snga__assn__raw_Oelims_I2_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X2,Xa),Xb))
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ~ ( ( array_get(A,H4,X2) = Xa )
                    & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(A,X2)),bot_bot(set(nat))) )
                    & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X2)),lim(product_unit,H4))) ) ) ) ) ).

% snga_assn_raw.elims(2)
tff(fact_5726_relH__array,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit),R2: array(A)] :
          ( relH(As2,H2,H5)
         => ( pp(aa(set(nat),bool,member(nat,addr_of_array(A,R2)),As2))
           => ( array_get(A,H2,R2) = array_get(A,H5,R2) ) ) ) ) ).

% relH_array
tff(fact_5727_snga__assn__raw_Osimps,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R2: array(A),X2: list(A),H2: heap_ext(product_unit),As2: set(nat)] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,R2,X2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
        <=> ( ( array_get(A,H2,R2) = X2 )
            & ( As2 = aa(set(nat),set(nat),insert(nat,addr_of_array(A,R2)),bot_bot(set(nat))) )
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,R2)),lim(product_unit,H2))) ) ) ) ).

% snga_assn_raw.simps
tff(fact_5728_snga__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
          ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X2,Xa),Xb))
          <=> pp(Y) )
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ( pp(Y)
                <=> ~ ( ( array_get(A,H4,X2) = Xa )
                      & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(A,X2)),bot_bot(set(nat))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X2)),lim(product_unit,H4))) ) ) ) ) ) ).

% snga_assn_raw.elims(1)
tff(fact_5729_snga__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
          ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X2,Xa),Xb))
          <=> pp(Y) )
         => ( pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( ( pp(Y)
                    <=> ( ( array_get(A,H4,X2) = Xa )
                        & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(A,X2)),bot_bot(set(nat))) )
                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X2)),lim(product_unit,H4))) ) )
                   => ~ pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))) ) ) ) ) ) ).

% snga_assn_raw.pelims(1)
tff(fact_5730_snga__assn__raw_Opelims_I2_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X2,Xa),Xb))
         => ( pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))))
                   => ~ ( ( array_get(A,H4,X2) = Xa )
                        & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(A,X2)),bot_bot(set(nat))) )
                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X2)),lim(product_unit,H4))) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(2)
tff(fact_5731_snga__assn__raw_Opelims_I3_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X2,Xa),Xb))
         => ( pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))))
                   => ( ( array_get(A,H4,X2) = Xa )
                      & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(A,X2)),bot_bot(set(nat))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X2)),lim(product_unit,H4))) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(3)
tff(fact_5732_relH__set__array,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R2: array(A),As2: set(nat),H2: heap_ext(product_unit),X2: list(A)] :
          ( ~ pp(aa(set(nat),bool,member(nat,addr_of_array(A,R2)),As2))
         => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
           => relH(As2,H2,aa(heap_ext(product_unit),heap_ext(product_unit),array_set(A,R2,X2),H2)) ) ) ) ).

% relH_set_array
tff(fact_5733_execute__make,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [N: nat,F2: fun(nat,A),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),heap_Time_execute(array(A),array_make(A,N,F2)),H2) = aa(product_prod(array(A),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avp(nat,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),N)),array_alloc(A,aa(list(nat),list(A),map(nat,A,F2),upt(zero_zero(nat),N)),H2))) ) ) ).

% execute_make
tff(fact_5734_Array__Time_Omake__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [N: nat,F2: fun(nat,A)] : ( array_make(A,N,F2) = heap_Time_heap(array(A),aa(fun(nat,A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avq(nat,fun(fun(nat,A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),N),F2)) ) ) ).

% Array_Time.make_def
tff(fact_5735_execute__of__list,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Xs: list(A),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),heap_Time_execute(array(A),array_of_list(A,Xs)),H2) = aa(product_prod(array(A),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avr(list(A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Xs)),array_alloc(A,Xs,H2))) ) ) ).

% execute_of_list
tff(fact_5736_execute__new,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [N: nat,X2: A,H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),heap_Time_execute(array(A),array_new(A,N,X2)),H2) = aa(product_prod(array(A),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avp(nat,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),N)),array_alloc(A,replicate(A,N,X2),H2))) ) ) ).

% execute_new
tff(fact_5737_of__list__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Xs: list(A)] : ( array_of_list(A,Xs) = heap_Time_heap(array(A),aTP_Lamp_avs(list(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),Xs)) ) ) ).

% of_list_def
tff(fact_5738_array__make,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [N: nat,X2: A] : ( array_new(A,N,X2) = array_make(A,N,aTP_Lamp_avt(A,fun(nat,A),X2)) ) ) ).

% array_make
tff(fact_5739_array__of__list__make,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Xs: list(A)] : ( array_of_list(A,Xs) = array_make(A,aa(list(A),nat,size_size(list(A)),Xs),nth(A,Xs)) ) ) ).

% array_of_list_make
tff(fact_5740_new__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [N: nat,X2: A] : ( array_new(A,N,X2) = heap_Time_heap(array(A),aa(A,fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avu(nat,fun(A,fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),N),X2)) ) ) ).

% new_def
tff(fact_5741_Array__Time_Oalloc__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Xs: list(A),H2: heap_ext(product_unit)] : ( array_alloc(A,Xs,H2) = aa(heap_ext(product_unit),product_prod(array(A),heap_ext(product_unit)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),heap_ext(product_unit))),product_Pair(array(A),heap_ext(product_unit)),array2(A,lim(product_unit,H2))),aa(heap_ext(product_unit),heap_ext(product_unit),array_set(A,array2(A,lim(product_unit,H2)),Xs),lim_update(product_unit,aTP_Lamp_avv(heap_ext(product_unit),fun(nat,nat),H2),H2))) ) ) ).

% Array_Time.alloc_def
tff(fact_5742_freeze__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A4: array(A)] : ( array_freeze(A,A4) = heap_Time_heap(list(A),aTP_Lamp_avw(array(A),fun(heap_ext(product_unit),product_prod(list(A),product_prod(heap_ext(product_unit),nat))),A4)) ) ) ).

% freeze_def
tff(fact_5743_trancl__def,axiom,
    ! [A: $tType,X4: set(product_prod(A,A))] : ( transitive_trancl(A,X4) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),transitive_tranclp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),X4)))) ) ).

% trancl_def
tff(fact_5744_less__nat__rel,axiom,
    ord_less(nat) = transitive_tranclp(nat,aTP_Lamp_wy(nat,fun(nat,bool))) ).

% less_nat_rel
tff(fact_5745_tranclp__trancl__eq,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),X4: A,Xa3: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),transitive_tranclp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2)),X4),Xa3))
    <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa3)),transitive_trancl(A,R2))) ) ).

% tranclp_trancl_eq
tff(fact_5746_tranclp__def,axiom,
    ! [A: $tType,X4: fun(A,fun(A,bool))] : ( transitive_tranclp(A,X4) = complete_lattice_lfp(fun(A,fun(A,bool)),aTP_Lamp_la(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),X4)) ) ).

% tranclp_def
tff(fact_5747_Nitpick_Otranclp__unfold,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),transitive_tranclp(A,R2),A4),B3))
    <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),transitive_trancl(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2))))) ) ).

% Nitpick.tranclp_unfold
tff(fact_5748_Array__Time_Onth__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A4: array(A),I2: nat] : ( array_nth(A,A4,I2) = heap_Time_guard(A,aa(nat,fun(heap_ext(product_unit),bool),aTP_Lamp_avx(array(A),fun(nat,fun(heap_ext(product_unit),bool)),A4),I2),aa(nat,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avy(array(A),fun(nat,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))),A4),I2)) ) ) ).

% Array_Time.nth_def
tff(fact_5749_swap__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I2: nat,X2: A,A4: array(A)] : ( array_swap(A,I2,X2,A4) = heap_Time_guard(A,aa(array(A),fun(heap_ext(product_unit),bool),aTP_Lamp_avz(nat,fun(array(A),fun(heap_ext(product_unit),bool)),I2),A4),aa(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(A,fun(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awa(nat,fun(A,fun(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))))),I2),X2),A4)) ) ) ).

% swap_def
tff(fact_5750_map__entry__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I2: nat,F2: fun(A,A),A4: array(A)] : ( array_map_entry(A,I2,F2,A4) = heap_Time_guard(array(A),aa(array(A),fun(heap_ext(product_unit),bool),aTP_Lamp_avz(nat,fun(array(A),fun(heap_ext(product_unit),bool)),I2),A4),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(fun(A,A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awb(nat,fun(fun(A,A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))))),I2),F2),A4)) ) ) ).

% map_entry_def
tff(fact_5751_upd__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I2: nat,X2: A,A4: array(A)] : ( array_upd(A,I2,X2,A4) = heap_Time_guard(array(A),aa(array(A),fun(heap_ext(product_unit),bool),aTP_Lamp_avz(nat,fun(array(A),fun(heap_ext(product_unit),bool)),I2),A4),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(A,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awc(nat,fun(A,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))))),I2),X2),A4)) ) ) ).

% upd_def
tff(fact_5752_reflp__refl__eq,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( reflp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2))
    <=> refl_on(A,top_top(set(A)),R2) ) ).

% reflp_refl_eq
tff(fact_5753_reflp__inf,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),S2: fun(A,fun(A,bool))] :
      ( reflp(A,R2)
     => ( reflp(A,S2)
       => reflp(A,aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),inf_inf(fun(A,fun(A,bool))),R2),S2)) ) ) ).

% reflp_inf
tff(fact_5754_Quotient__id__abs__transfer,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(A,bool)),Abs: fun(A,B),Rep: fun(B,A),T2: fun(A,fun(B,bool))] :
      ( quotient(A,B,R,Abs,Rep,T2)
     => ( reflp(A,R)
       => pp(aa(fun(A,B),bool,aa(fun(A,A),fun(fun(A,B),bool),bNF_rel_fun(A,A,A,B,fequal(A),T2),aTP_Lamp_bk(A,A)),Abs)) ) ) ).

% Quotient_id_abs_transfer
tff(fact_5755_sub_Otransfer,axiom,
    pp(aa(fun(num,fun(num,code_integer)),bool,aa(fun(num,fun(num,int)),fun(fun(num,fun(num,code_integer)),bool),bNF_rel_fun(num,num,fun(num,int),fun(num,code_integer),fequal(num),bNF_rel_fun(num,num,int,code_integer,fequal(num),code_pcr_integer)),aTP_Lamp_ya(num,fun(num,int))),code_sub)) ).

% sub.transfer
tff(fact_5756_image2p__def,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F2: fun(C,A),G: fun(D,B),R: fun(C,fun(D,bool)),X4: A,Xa3: B] :
      ( bNF_Greatest_image2p(C,A,D,B,F2,G,R,X4,Xa3)
    <=> ? [X8: C,Y8: D] :
          ( pp(aa(D,bool,aa(C,fun(D,bool),R,X8),Y8))
          & ( aa(C,A,F2,X8) = X4 )
          & ( aa(D,B,G,Y8) = Xa3 ) ) ) ).

% image2p_def
tff(fact_5757_rtranclp__imp__Sup__relpowp,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),X2: A,Y: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),transitive_rtranclp(A,P),X2),Y))
     => pp(aa(A,bool,aa(A,fun(A,bool),aa(set(fun(A,fun(A,bool))),fun(A,fun(A,bool)),complete_Sup_Sup(fun(A,fun(A,bool))),aa(set(nat),set(fun(A,fun(A,bool))),image2(nat,fun(A,fun(A,bool)),aTP_Lamp_awd(fun(A,fun(A,bool)),fun(nat,fun(A,fun(A,bool))),P)),top_top(set(nat)))),X2),Y)) ) ).

% rtranclp_imp_Sup_relpowp
tff(fact_5758_rtranclp__r__diff__Id,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool))] : ( transitive_rtranclp(A,aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),inf_inf(fun(A,fun(A,bool))),R2),aTP_Lamp_adp(A,fun(A,bool)))) = transitive_rtranclp(A,R2) ) ).

% rtranclp_r_diff_Id
tff(fact_5759_integer_Oid__abs__transfer,axiom,
    pp(aa(fun(int,code_integer),bool,aa(fun(int,int),fun(fun(int,code_integer),bool),bNF_rel_fun(int,int,int,code_integer,fequal(int),code_pcr_integer),aTP_Lamp_ry(int,int)),code_integer_of_int)) ).

% integer.id_abs_transfer
tff(fact_5760_integer_Orep__transfer,axiom,
    pp(aa(fun(code_integer,int),bool,aa(fun(int,int),fun(fun(code_integer,int),bool),bNF_rel_fun(int,code_integer,int,int,code_pcr_integer,fequal(int)),aTP_Lamp_ry(int,int)),code_int_of_integer)) ).

% integer.rep_transfer
tff(fact_5761_Transitive__Closure_Ortranclp__rtrancl__eq,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),X4: A,Xa3: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),transitive_rtranclp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2)),X4),Xa3))
    <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa3)),transitive_rtrancl(A,R2))) ) ).

% Transitive_Closure.rtranclp_rtrancl_eq
tff(fact_5762_dup_Otransfer,axiom,
    pp(aa(fun(code_integer,code_integer),bool,aa(fun(int,int),fun(fun(code_integer,code_integer),bool),bNF_rel_fun(int,code_integer,int,code_integer,code_pcr_integer,code_pcr_integer),aTP_Lamp_yo(int,int)),code_dup)) ).

% dup.transfer
tff(fact_5763_rtranclp__def,axiom,
    ! [A: $tType,X4: fun(A,fun(A,bool))] : ( transitive_rtranclp(A,X4) = complete_lattice_lfp(fun(A,fun(A,bool)),aTP_Lamp_kz(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),X4)) ) ).

% rtranclp_def
tff(fact_5764_rtrancl__def,axiom,
    ! [A: $tType,X4: set(product_prod(A,A))] : ( transitive_rtrancl(A,X4) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),transitive_rtranclp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),X4)))) ) ).

% rtrancl_def
tff(fact_5765_Enum_Ortranclp__rtrancl__eq,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),X2: A,Y: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),transitive_rtranclp(A,R2),X2),Y))
    <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y)),transitive_rtrancl(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2))))) ) ).

% Enum.rtranclp_rtrancl_eq
tff(fact_5766_rtranclp__is__Sup__relpowp,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool))] : ( transitive_rtranclp(A,P) = aa(set(fun(A,fun(A,bool))),fun(A,fun(A,bool)),complete_Sup_Sup(fun(A,fun(A,bool))),aa(set(nat),set(fun(A,fun(A,bool))),image2(nat,fun(A,fun(A,bool)),aTP_Lamp_awd(fun(A,fun(A,bool)),fun(nat,fun(A,fun(A,bool))),P)),top_top(set(nat)))) ) ).

% rtranclp_is_Sup_relpowp
tff(fact_5767_old_Orec__bool__def,axiom,
    ! [T: $tType,X4: T,Xa3: T,Xb3: bool] : ( product_rec_bool(T,X4,Xa3,Xb3) = the(T,product_rec_set_bool(T,X4,Xa3,Xb3)) ) ).

% old.rec_bool_def
tff(fact_5768_Ref__Time_Oalloc__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X2: A,H2: heap_ext(product_unit)] : ( ref_alloc(A,X2,H2) = aa(heap_ext(product_unit),product_prod(ref(A),heap_ext(product_unit)),aa(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),heap_ext(product_unit))),product_Pair(ref(A),heap_ext(product_unit)),ref2(A,lim(product_unit,H2))),aa(heap_ext(product_unit),heap_ext(product_unit),ref_set(A,ref2(A,lim(product_unit,H2)),X2),lim_update(product_unit,aTP_Lamp_avv(heap_ext(product_unit),fun(nat,nat),H2),H2))) ) ) ).

% Ref_Time.alloc_def
tff(fact_5769_sum__encode__def,axiom,
    ! [X2: sum_sum(nat,nat)] : ( nat_sum_encode(X2) = aa(sum_sum(nat,nat),nat,sum_case_sum(nat,nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aTP_Lamp_awe(nat,nat)),X2) ) ).

% sum_encode_def
tff(fact_5770_case__sum__KK,axiom,
    ! [A: $tType,B: $tType,C: $tType,A4: C,X4: sum_sum(A,B)] : ( aa(sum_sum(A,B),C,sum_case_sum(A,C,B,aTP_Lamp_awf(C,fun(A,C),A4),aTP_Lamp_awg(C,fun(B,C),A4)),X4) = A4 ) ).

% case_sum_KK
tff(fact_5771_disjE__realizer,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: fun(A,bool),Q: fun(B,bool),X2: sum_sum(A,B),R: fun(C,bool),F2: fun(A,C),G: fun(B,C)] :
      ( pp(aa(sum_sum(A,B),bool,sum_case_sum(A,bool,B,P,Q),X2))
     => ( ! [P7: A] :
            ( pp(aa(A,bool,P,P7))
           => pp(aa(C,bool,R,aa(A,C,F2,P7))) )
       => ( ! [Q8: B] :
              ( pp(aa(B,bool,Q,Q8))
             => pp(aa(C,bool,R,aa(B,C,G,Q8))) )
         => pp(aa(C,bool,R,aa(sum_sum(A,B),C,sum_case_sum(A,C,B,F2,G),X2))) ) ) ) ).

% disjE_realizer
tff(fact_5772_sum_Ocase__distrib,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,H2: fun(C,D),F1: fun(A,C),F22: fun(B,C),Sum: sum_sum(A,B)] : ( aa(C,D,H2,aa(sum_sum(A,B),C,sum_case_sum(A,C,B,F1,F22),Sum)) = aa(sum_sum(A,B),D,sum_case_sum(A,D,B,aa(fun(A,C),fun(A,D),aTP_Lamp_awh(fun(C,D),fun(fun(A,C),fun(A,D)),H2),F1),aa(fun(B,C),fun(B,D),aTP_Lamp_awi(fun(C,D),fun(fun(B,C),fun(B,D)),H2),F22)),Sum) ) ).

% sum.case_distrib
tff(fact_5773_execute__ref,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [V: A,H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),heap_Time_execute(ref(A),ref_ref(A,V)),H2) = aa(product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),option(product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),some(product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),aa(product_prod(ref(A),heap_ext(product_unit)),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),aa(fun(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(ref(A),heap_ext(product_unit)),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(ref(A),heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_awj(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))))),ref_alloc(A,V,H2))) ) ) ).

% execute_ref
tff(fact_5774_ref__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [V: A] : ( ref_ref(A,V) = heap_Time_heap(ref(A),aTP_Lamp_awk(A,fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),V)) ) ) ).

% ref_def
tff(fact_5775_projr__def,axiom,
    ! [B: $tType,A: $tType,Sum: sum_sum(A,B)] : ( sum_projr(A,B,Sum) = aa(sum_sum(A,B),B,sum_case_sum(A,B,B,aTP_Lamp_ahi(A,B),aTP_Lamp_xj(B,B)),Sum) ) ).

% projr_def
tff(fact_5776_projl__def,axiom,
    ! [B: $tType,A: $tType,Sum: sum_sum(A,B)] : ( sum_projl(A,B,Sum) = aa(sum_sum(A,B),A,sum_case_sum(A,A,B,aTP_Lamp_bk(A,A),aTP_Lamp_awl(B,A)),Sum) ) ).

% projl_def
tff(fact_5777_laz__weak__Pb,axiom,
    ! [A: $tType,B: $tType,P: fun(B,bool),A3: list(A),B2: list(B)] :
      ( list_all_zip(A,B,aTP_Lamp_qw(fun(B,bool),fun(A,fun(B,bool)),P),A3,B2)
    <=> ( ( aa(list(A),nat,size_size(list(A)),A3) = aa(list(B),nat,size_size(list(B)),B2) )
        & ! [X3: B] :
            ( pp(aa(set(B),bool,member(B,X3),aa(list(B),set(B),set2(B),B2)))
           => pp(aa(B,bool,P,X3)) ) ) ) ).

% laz_weak_Pb
tff(fact_5778_laz__weak__Pa,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),A3: list(A),B2: list(B)] :
      ( list_all_zip(A,B,aTP_Lamp_awm(fun(A,bool),fun(A,fun(B,bool)),P),A3,B2)
    <=> ( ( aa(list(A),nat,size_size(list(A)),A3) = aa(list(B),nat,size_size(list(B)),B2) )
        & ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),aa(list(A),set(A),set2(A),A3)))
           => pp(aa(A,bool,P,X3)) ) ) ) ).

% laz_weak_Pa
tff(fact_5779_laz__conj,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,bool)),Q: fun(A,fun(B,bool)),A4: list(A),B3: list(B)] :
      ( list_all_zip(A,B,aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aTP_Lamp_awn(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),P),Q),A4,B3)
    <=> ( list_all_zip(A,B,P,A4,B3)
        & list_all_zip(A,B,Q,A4,B3) ) ) ).

% laz_conj
tff(fact_5780_laz__swap__ex,axiom,
    ! [B: $tType,A: $tType,C: $tType,P: fun(A,fun(B,fun(C,bool))),A3: list(A),B2: list(B)] :
      ( list_all_zip(A,B,aTP_Lamp_awo(fun(A,fun(B,fun(C,bool))),fun(A,fun(B,bool)),P),A3,B2)
     => ~ ! [C6: list(C)] :
            ( list_all_zip(A,C,aTP_Lamp_awp(fun(A,fun(B,fun(C,bool))),fun(A,fun(C,bool)),P),A3,C6)
           => ~ list_all_zip(B,C,aTP_Lamp_awq(fun(A,fun(B,fun(C,bool))),fun(B,fun(C,bool)),P),B2,C6) ) ) ).

% laz_swap_ex
tff(fact_5781_list__all__zip__map1,axiom,
    ! [C: $tType,A: $tType,B: $tType,P: fun(A,fun(B,bool)),F2: fun(C,A),As2: list(C),Bs: list(B)] :
      ( list_all_zip(A,B,P,aa(list(C),list(A),map(C,A,F2),As2),Bs)
    <=> list_all_zip(C,B,aa(fun(C,A),fun(C,fun(B,bool)),aTP_Lamp_aog(fun(A,fun(B,bool)),fun(fun(C,A),fun(C,fun(B,bool))),P),F2),As2,Bs) ) ).

% list_all_zip_map1
tff(fact_5782_list__all__zip__map2,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: fun(A,fun(B,bool)),As2: list(A),F2: fun(C,B),Bs: list(C)] :
      ( list_all_zip(A,B,P,As2,aa(list(C),list(B),map(C,B,F2),Bs))
    <=> list_all_zip(A,C,aa(fun(C,B),fun(A,fun(C,bool)),aTP_Lamp_aoh(fun(A,fun(B,bool)),fun(fun(C,B),fun(A,fun(C,bool))),P),F2),As2,Bs) ) ).

% list_all_zip_map2
tff(fact_5783_option_Orec__o__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: C,Ga: fun(B,C),F2: fun(A,B)] : ( aa(fun(option(A),option(B)),fun(option(A),C),comp(option(B),C,option(A),rec_option(C,B,G,Ga)),map_option(A,B,F2)) = rec_option(C,A,G,aa(fun(A,B),fun(A,C),aTP_Lamp_abp(fun(B,C),fun(fun(A,B),fun(A,C)),Ga),F2)) ) ).

% option.rec_o_map
tff(fact_5784_tap__def,axiom,
    ! [A: $tType,F2: fun(heap_ext(product_unit),A)] : ( heap_Time_tap(A,F2) = heap_Time_Heap2(A,aTP_Lamp_awr(fun(heap_ext(product_unit),A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),F2)) ) ).

% tap_def
tff(fact_5785_ordering__top_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ordering_top_axioms(A,Less_eq,Top) ) ).

% ordering_top.axioms(2)
tff(fact_5786_ordering__top__axioms__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Top: A] :
      ( ordering_top_axioms(A,Less_eq,Top)
    <=> ! [A6: A] : pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),Top)) ) ).

% ordering_top_axioms_def
tff(fact_5787_ordering__top__axioms_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Top: A] :
      ( ! [A5: A] : pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A5),Top))
     => ordering_top_axioms(A,Less_eq,Top) ) ).

% ordering_top_axioms.intro
tff(fact_5788_guard__def,axiom,
    ! [A: $tType,P: fun(heap_ext(product_unit),bool),F2: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))] : ( heap_Time_guard(A,P,F2) = heap_Time_Heap2(A,aa(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_aws(fun(heap_ext(product_unit),bool),fun(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),P),F2)) ) ).

% guard_def
tff(fact_5789_lookup__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R2: ref(A)] : ( ref_lookup(A,R2) = heap_Time_tap(A,aTP_Lamp_awt(ref(A),fun(heap_ext(product_unit),A),R2)) ) ) ).

% lookup_def
tff(fact_5790_ordering__top_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A] :
      ( ordering(A,Less_eq,Less)
     => ( ordering_top_axioms(A,Less_eq,Top)
       => ordering_top(A,Less_eq,Less,Top) ) ) ).

% ordering_top.intro
tff(fact_5791_ordering__top__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A] :
      ( ordering_top(A,Less_eq,Less,Top)
    <=> ( ordering(A,Less_eq,Less)
        & ordering_top_axioms(A,Less_eq,Top) ) ) ).

% ordering_top_def
tff(fact_5792_ordering__top_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ordering(A,Less_eq,Less) ) ).

% ordering_top.axioms(1)
tff(fact_5793_ordering_Oeq__iff,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( ordering(A,Less_eq,Less)
     => ( ( A4 = B3 )
      <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
          & pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B3),A4)) ) ) ) ).

% ordering.eq_iff
tff(fact_5794_ordering_Oantisym,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( ordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B3),A4))
         => ( A4 = B3 ) ) ) ) ).

% ordering.antisym
tff(fact_5795_ordering_Oorder__iff__strict,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( ordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
      <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3))
          | ( A4 = B3 ) ) ) ) ).

% ordering.order_iff_strict
tff(fact_5796_ordering_Ostrict__iff__order,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( ordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3))
      <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
          & ( A4 != B3 ) ) ) ) ).

% ordering.strict_iff_order
tff(fact_5797_ordering_Ostrict__implies__not__eq,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( ordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3))
       => ( A4 != B3 ) ) ) ).

% ordering.strict_implies_not_eq
tff(fact_5798_ordering_Onot__eq__order__implies__strict,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( ordering(A,Less_eq,Less)
     => ( ( A4 != B3 )
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3)) ) ) ) ).

% ordering.not_eq_order_implies_strict
tff(fact_5799_ordering__strictI,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ! [A5: A,B4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A5),B4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),B4))
            | ( A5 = B4 ) ) )
     => ( ! [A5: A,B4: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),B4))
           => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,B4),A5)) )
       => ( ! [A5: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),A5))
         => ( ! [A5: A,B4: A,C4: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),B4))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B4),C4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),C4)) ) )
           => ordering(A,Less_eq,Less) ) ) ) ) ).

% ordering_strictI
tff(fact_5800_ordering__dualI,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ordering(A,aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Less_eq),aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Less))
     => ordering(A,Less_eq,Less) ) ).

% ordering_dualI
tff(fact_5801_gcd__nat_Oordering__axioms,axiom,
    ordering(nat,dvd_dvd(nat),aTP_Lamp_abn(nat,fun(nat,bool))) ).

% gcd_nat.ordering_axioms
tff(fact_5802_order_Oordering__axioms,axiom,
    ! [A: $tType] :
      ( order(A)
     => ordering(A,ord_less_eq(A),ord_less(A)) ) ).

% order.ordering_axioms
tff(fact_5803_dual__order_Oordering__axioms,axiom,
    ! [A: $tType] :
      ( order(A)
     => ordering(A,aTP_Lamp_awu(A,fun(A,bool)),aTP_Lamp_awv(A,fun(A,bool))) ) ).

% dual_order.ordering_axioms
tff(fact_5804_subset__mset_Odual__order_Oordering__axioms,axiom,
    ! [A: $tType] : ordering(multiset(A),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool)),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool))) ).

% subset_mset.dual_order.ordering_axioms
tff(fact_5805_raise__def,axiom,
    ! [A: $tType,S2: list(char)] : ( heap_Time_raise(A,S2) = heap_Time_Heap2(A,aTP_Lamp_aww(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))) ) ).

% raise_def
tff(fact_5806_Heap__lub__empty,axiom,
    ! [A: $tType] : ( aa(set(heap_Time_Heap(A)),heap_Time_Heap(A),heap_Time_Heap_lub(A),bot_bot(set(heap_Time_Heap(A)))) = heap_Time_Heap2(A,aTP_Lamp_aww(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))) ) ).

% Heap_lub_empty
tff(fact_5807_len__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A4: array(A)] : ( array_len(A,A4) = heap_Time_tap(nat,aTP_Lamp_awx(array(A),fun(heap_ext(product_unit),nat),A4)) ) ) ).

% len_def
tff(fact_5808_len_H__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1(A)
        & heap(B) )
     => ! [A4: array(B)] : ( array_len2(B,A,A4) = heap_Time_bind(nat,A,array_len(B,A4),aTP_Lamp_awy(nat,heap_Time_Heap(A))) ) ) ).

% len'_def
tff(fact_5809_Heap_Oset,axiom,
    ! [A: $tType,X2: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( heap_Time_set_Heap(A,heap_Time_Heap2(A,X2)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),set(set(A)),image2(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(A),aTP_Lamp_awz(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(A))),aa(set(heap_ext(product_unit)),set(option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),image2(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),X2),top_top(set(heap_ext(product_unit)))))) ) ).

% Heap.set
tff(fact_5810_Range__Int__subset,axiom,
    ! [A: $tType,B: $tType,A3: set(product_prod(B,A)),B2: set(product_prod(B,A))] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(product_prod(B,A)),set(A),range2(B,A),aa(set(product_prod(B,A)),set(product_prod(B,A)),aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),set(product_prod(B,A))),inf_inf(set(product_prod(B,A))),A3),B2))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(product_prod(B,A)),set(A),range2(B,A),A3)),aa(set(product_prod(B,A)),set(A),range2(B,A),B2)))) ).

% Range_Int_subset
tff(fact_5811_Heap__Time__Monad_Obind__bind,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: heap_Time_Heap(A),G: fun(A,heap_Time_Heap(C)),K: fun(C,heap_Time_Heap(B))] : ( heap_Time_bind(C,B,heap_Time_bind(A,C,F2,G),K) = heap_Time_bind(A,B,F2,aa(fun(C,heap_Time_Heap(B)),fun(A,heap_Time_Heap(B)),aTP_Lamp_axa(fun(A,heap_Time_Heap(C)),fun(fun(C,heap_Time_Heap(B)),fun(A,heap_Time_Heap(B))),G),K)) ) ).

% Heap_Time_Monad.bind_bind
tff(fact_5812_Range__empty,axiom,
    ! [B: $tType,A: $tType] : ( aa(set(product_prod(B,A)),set(A),range2(B,A),bot_bot(set(product_prod(B,A)))) = bot_bot(set(A)) ) ).

% Range_empty
tff(fact_5813_Range__Collect__case__prod,axiom,
    ! [A: $tType,B: $tType,P: fun(B,fun(A,bool))] : ( aa(set(product_prod(B,A)),set(A),range2(B,A),aa(fun(product_prod(B,A),bool),set(product_prod(B,A)),collect(product_prod(B,A)),aa(fun(B,fun(A,bool)),fun(product_prod(B,A),bool),product_case_prod(B,A,bool),P))) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_axb(fun(B,fun(A,bool)),fun(A,bool),P)) ) ).

% Range_Collect_case_prod
tff(fact_5814_distrib__if__bind,axiom,
    ! [A: $tType,B: $tType,B3: bool,C2: heap_Time_Heap(B),D3: heap_Time_Heap(B),F2: fun(B,heap_Time_Heap(A))] :
      ( ( pp(B3)
       => ( heap_Time_bind(B,A,if(heap_Time_Heap(B),B3,C2,D3),F2) = heap_Time_bind(B,A,C2,F2) ) )
      & ( ~ pp(B3)
       => ( heap_Time_bind(B,A,if(heap_Time_Heap(B),B3,C2,D3),F2) = heap_Time_bind(B,A,D3,F2) ) ) ) ).

% distrib_if_bind
tff(fact_5815_Range__empty__iff,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(B,A))] :
      ( ( aa(set(product_prod(B,A)),set(A),range2(B,A),R2) = bot_bot(set(A)) )
    <=> ( R2 = bot_bot(set(product_prod(B,A))) ) ) ).

% Range_empty_iff
tff(fact_5816_Range__Union,axiom,
    ! [A: $tType,B: $tType,S: set(set(product_prod(B,A)))] : ( aa(set(product_prod(B,A)),set(A),range2(B,A),aa(set(set(product_prod(B,A))),set(product_prod(B,A)),complete_Sup_Sup(set(product_prod(B,A))),S)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(product_prod(B,A))),set(set(A)),image2(set(product_prod(B,A)),set(A),range2(B,A)),S)) ) ).

% Range_Union
tff(fact_5817_Range__def,axiom,
    ! [B: $tType,A: $tType,X4: set(product_prod(A,B))] : ( aa(set(product_prod(A,B)),set(B),range2(A,B),X4) = aa(fun(B,bool),set(B),collect(B),rangep(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),X4))) ) ).

% Range_def
tff(fact_5818_Rangep__Range__eq,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B)),X4: B] :
      ( pp(aa(B,bool,rangep(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),R2)),X4))
    <=> pp(aa(set(B),bool,member(B,X4),aa(set(product_prod(A,B)),set(B),range2(A,B),R2))) ) ).

% Rangep_Range_eq
tff(fact_5819_lookup__chain,axiom,
    ! [B: $tType,A: $tType] :
      ( heap(B)
     => ! [R2: ref(B),F2: heap_Time_Heap(A)] : ( heap_Time_bind(B,A,ref_lookup(B,R2),aTP_Lamp_axc(heap_Time_Heap(A),fun(B,heap_Time_Heap(A)),F2)) = heap_Time_bind(product_unit,A,heap_Time_wait(one_one(nat)),aTP_Lamp_axd(heap_Time_Heap(A),fun(product_unit,heap_Time_Heap(A)),F2)) ) ) ).

% lookup_chain
tff(fact_5820_bind__return,axiom,
    ! [A: $tType,F2: heap_Time_Heap(A)] : ( heap_Time_bind(A,A,F2,heap_Time_return(A)) = heap_Time_bind(product_unit,A,heap_Time_wait(one_one(nat)),aTP_Lamp_axd(heap_Time_Heap(A),fun(product_unit,heap_Time_Heap(A)),F2)) ) ).

% bind_return
tff(fact_5821_return__bind,axiom,
    ! [A: $tType,B: $tType,X2: B,F2: fun(B,heap_Time_Heap(A))] : ( heap_Time_bind(B,A,aa(B,heap_Time_Heap(B),heap_Time_return(B),X2),F2) = heap_Time_bind(product_unit,A,heap_Time_wait(one_one(nat)),aa(fun(B,heap_Time_Heap(A)),fun(product_unit,heap_Time_Heap(A)),aTP_Lamp_axe(B,fun(fun(B,heap_Time_Heap(A)),fun(product_unit,heap_Time_Heap(A))),X2),F2)) ) ).

% return_bind
tff(fact_5822_upd__ureturn,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I2: nat,X2: A,A4: array(A)] : ( heap_Time_bind(array(A),array(A),array_upd(A,I2,X2,A4),aTP_Lamp_axf(array(A),fun(array(A),heap_Time_Heap(array(A))),A4)) = array_upd(A,I2,X2,A4) ) ) ).

% upd_ureturn
tff(fact_5823_bind__lift,axiom,
    ! [A: $tType,B: $tType,F2: heap_Time_Heap(B),G: fun(B,A)] : ( heap_Time_bind(B,A,F2,heap_Time_lift(B,A,G)) = heap_Time_bind(B,A,F2,aTP_Lamp_axg(fun(B,A),fun(B,heap_Time_Heap(A)),G)) ) ).

% bind_lift
tff(fact_5824_Heap__Time__Monad_Obind__def,axiom,
    ! [B: $tType,A: $tType,F2: heap_Time_Heap(A),G: fun(A,heap_Time_Heap(B))] : ( heap_Time_bind(A,B,F2,G) = heap_Time_Heap2(B,aa(fun(A,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_axj(heap_Time_Heap(A),fun(fun(A,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),F2),G)) ) ).

% Heap_Time_Monad.bind_def
tff(fact_5825_wf__UN,axiom,
    ! [B: $tType,A: $tType,I: set(A),R2: fun(A,set(product_prod(B,B)))] :
      ( ! [I3: A] :
          ( pp(aa(set(A),bool,member(A,I3),I))
         => wf(B,aa(A,set(product_prod(B,B)),R2,I3)) )
     => ( ! [I3: A,J4: A] :
            ( pp(aa(set(A),bool,member(A,I3),I))
           => ( pp(aa(set(A),bool,member(A,J4),I))
             => ( ( aa(A,set(product_prod(B,B)),R2,I3) != aa(A,set(product_prod(B,B)),R2,J4) )
               => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(product_prod(B,B)),set(B),domain(B,B),aa(A,set(product_prod(B,B)),R2,I3))),aa(set(product_prod(B,B)),set(B),range2(B,B),aa(A,set(product_prod(B,B)),R2,J4))) = bot_bot(set(B)) ) ) ) )
       => wf(B,aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),aa(set(A),set(set(product_prod(B,B))),image2(A,set(product_prod(B,B)),R2),I))) ) ) ).

% wf_UN
tff(fact_5826_Domain__empty,axiom,
    ! [B: $tType,A: $tType] : ( aa(set(product_prod(A,B)),set(A),domain(A,B),bot_bot(set(product_prod(A,B)))) = bot_bot(set(A)) ) ).

% Domain_empty
tff(fact_5827_Domain__Collect__case__prod,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool))] : ( aa(set(product_prod(A,B)),set(A),domain(A,B),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),P))) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_gu(fun(A,fun(B,bool)),fun(A,bool),P)) ) ).

% Domain_Collect_case_prod
tff(fact_5828_dom__ran__disj__comp,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(product_prod(A,A)),set(A),domain(A,A),R)),aa(set(product_prod(A,A)),set(A),range2(A,A),R)) = bot_bot(set(A)) )
     => ( relcomp(A,A,A,R,R) = bot_bot(set(product_prod(A,A))) ) ) ).

% dom_ran_disj_comp
tff(fact_5829_Domain__empty__iff,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B))] :
      ( ( aa(set(product_prod(A,B)),set(A),domain(A,B),R2) = bot_bot(set(A)) )
    <=> ( R2 = bot_bot(set(product_prod(A,B))) ) ) ).

% Domain_empty_iff
tff(fact_5830_Domain__unfold,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B))] : ( aa(set(product_prod(A,B)),set(A),domain(A,B),R2) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_axk(set(product_prod(A,B)),fun(A,bool),R2)) ) ).

% Domain_unfold
tff(fact_5831_Domainp__Domain__eq,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B)),X4: A] :
      ( pp(aa(A,bool,aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),R2)),X4))
    <=> pp(aa(set(A),bool,member(A,X4),aa(set(product_prod(A,B)),set(A),domain(A,B),R2))) ) ).

% Domainp_Domain_eq
tff(fact_5832_Domain__def,axiom,
    ! [B: $tType,A: $tType,X4: set(product_prod(A,B))] : ( aa(set(product_prod(A,B)),set(A),domain(A,B),X4) = aa(fun(A,bool),set(A),collect(A),aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),X4))) ) ).

% Domain_def
tff(fact_5833_Domain__Int__subset,axiom,
    ! [B: $tType,A: $tType,A3: set(product_prod(A,B)),B2: set(product_prod(A,B))] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(product_prod(A,B)),set(A),domain(A,B),aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),A3),B2))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(product_prod(A,B)),set(A),domain(A,B),A3)),aa(set(product_prod(A,B)),set(A),domain(A,B),B2)))) ).

% Domain_Int_subset
tff(fact_5834_wf__no__path,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(product_prod(A,A)),set(A),domain(A,A),R)),aa(set(product_prod(A,A)),set(A),range2(A,A),R)) = bot_bot(set(A)) )
     => wf(A,R) ) ).

% wf_no_path
tff(fact_5835_wf__min,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( wf(A,R)
     => ( ( R != bot_bot(set(product_prod(A,A))) )
       => ~ ! [M3: A] : ~ pp(aa(set(A),bool,member(A,M3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(product_prod(A,A)),set(A),domain(A,A),R)),aa(set(product_prod(A,A)),set(A),range2(A,A),R)))) ) ) ).

% wf_min
tff(fact_5836_Domain__Union,axiom,
    ! [B: $tType,A: $tType,S: set(set(product_prod(A,B)))] : ( aa(set(product_prod(A,B)),set(A),domain(A,B),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),S)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(product_prod(A,B))),set(set(A)),image2(set(product_prod(A,B)),set(A),domain(A,B)),S)) ) ).

% Domain_Union
tff(fact_5837_wf__Un,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( wf(A,R2)
     => ( wf(A,S2)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(product_prod(A,A)),set(A),domain(A,A),R2)),aa(set(product_prod(A,A)),set(A),range2(A,A),S2)) = bot_bot(set(A)) )
         => wf(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R2),S2)) ) ) ) ).

% wf_Un
tff(fact_5838_wf__Union,axiom,
    ! [A: $tType,R: set(set(product_prod(A,A)))] :
      ( ! [X: set(product_prod(A,A))] :
          ( pp(aa(set(set(product_prod(A,A))),bool,member(set(product_prod(A,A)),X),R))
         => wf(A,X) )
     => ( ! [X: set(product_prod(A,A))] :
            ( pp(aa(set(set(product_prod(A,A))),bool,member(set(product_prod(A,A)),X),R))
           => ! [Xa4: set(product_prod(A,A))] :
                ( pp(aa(set(set(product_prod(A,A))),bool,member(set(product_prod(A,A)),Xa4),R))
               => ( ( X != Xa4 )
                 => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(product_prod(A,A)),set(A),domain(A,A),X)),aa(set(product_prod(A,A)),set(A),range2(A,A),Xa4)) = bot_bot(set(A)) ) ) ) )
       => wf(A,aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),R)) ) ) ).

% wf_Union
tff(fact_5839_wf__max,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( wf(A,converse(A,A,R))
     => ( ( R != bot_bot(set(product_prod(A,A))) )
       => ~ ! [M3: A] : ~ pp(aa(set(A),bool,member(A,M3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(product_prod(A,A)),set(A),range2(A,A),R)),aa(set(product_prod(A,A)),set(A),domain(A,A),R)))) ) ) ).

% wf_max
tff(fact_5840_execute__bind__case,axiom,
    ! [A: $tType,B: $tType,F2: heap_Time_Heap(B),G: fun(B,heap_Time_Heap(A)),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(A,heap_Time_bind(B,A,F2,G)),H2) = case_option(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(B,product_prod(heap_ext(product_unit),nat)),none(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(fun(B,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),product_case_prod(B,product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_axm(fun(B,heap_Time_Heap(A)),fun(B,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),G)),aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(B,F2),H2)) ) ).

% execute_bind_case
tff(fact_5841_change__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [F2: fun(A,A),R2: ref(A)] : ( ref_change(A,F2,R2) = heap_Time_bind(A,A,ref_lookup(A,R2),aa(ref(A),fun(A,heap_Time_Heap(A)),aTP_Lamp_axo(fun(A,A),fun(ref(A),fun(A,heap_Time_Heap(A))),F2),R2)) ) ) ).

% change_def
tff(fact_5842_wait__def,axiom,
    ! [N: nat] : ( heap_Time_wait(N) = heap_Time_Heap2(product_unit,aTP_Lamp_axp(nat,fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),N)) ) ).

% wait_def
tff(fact_5843_rec__natural__def,axiom,
    ! [T: $tType,X4: T,Xa3: fun(code_natural,fun(T,T)),Xb3: code_natural] : ( aa(code_natural,T,code_rec_natural(T,X4,Xa3),Xb3) = the(T,code_rec_set_natural(T,X4,Xa3,Xb3)) ) ).

% rec_natural_def
tff(fact_5844_unit__abs__eta__conv,axiom,
    ! [A: $tType,F2: fun(product_unit,A)] : ( aTP_Lamp_axq(fun(product_unit,A),fun(product_unit,A),F2) = F2 ) ).

% unit_abs_eta_conv
tff(fact_5845_UNIV__unit,axiom,
    top_top(set(product_unit)) = aa(set(product_unit),set(product_unit),insert(product_unit,product_Unity),bot_bot(set(product_unit))) ).

% UNIV_unit
tff(fact_5846_inf__unit__def,axiom,
    ! [Uu: product_unit,Uv: product_unit] : ( aa(product_unit,product_unit,aa(product_unit,fun(product_unit,product_unit),inf_inf(product_unit),Uu),Uv) = product_Unity ) ).

% inf_unit_def
tff(fact_5847_bot__unit__def,axiom,
    bot_bot(product_unit) = product_Unity ).

% bot_unit_def
tff(fact_5848_Ref__Time_Oupdate__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R2: ref(A),V: A] : ( ref_update(A,R2,V) = heap_Time_heap(product_unit,aa(A,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_axr(ref(A),fun(A,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),R2),V)) ) ) ).

% Ref_Time.update_def
tff(fact_5849_upd_H__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A4: array(A),I2: code_integer,X2: A] : ( array_upd2(A,A4,I2,X2) = heap_Time_bind(array(A),product_unit,array_upd(A,code_nat_of_integer(I2),X2,A4),aTP_Lamp_axs(array(A),heap_Time_Heap(product_unit))) ) ) ).

% upd'_def
tff(fact_5850_case__natural__def,axiom,
    ! [T: $tType,X4: T,Xa3: fun(code_natural,T)] : ( code_case_natural(T,X4,Xa3) = code_rec_natural(T,X4,aTP_Lamp_axt(fun(code_natural,T),fun(code_natural,fun(T,T)),Xa3)) ) ).

% case_natural_def
tff(fact_5851_cone__def,axiom,
    bNF_Cardinal_cone = bNF_Ca6860139660246222851ard_of(product_unit,aa(set(product_unit),set(product_unit),insert(product_unit,product_Unity),bot_bot(set(product_unit)))) ).

% cone_def
tff(fact_5852_next_Osimps,axiom,
    ! [V: code_natural,W2: code_natural] : ( aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),V),W2)) = aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,V,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),divide_divide(code_natural),V),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,one2)))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,W2,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),divide_divide(code_natural),W2),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))),one_one(code_natural)))),one_one(code_natural))),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,V,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),divide_divide(code_natural),V),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,one2))))))))))))))))),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,W2,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),divide_divide(code_natural),W2),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,one2)))))))))))))))) ) ).

% next.simps
tff(fact_5853_Abs__int__cases,axiom,
    ! [X2: int] :
      ~ ! [Y2: set(product_prod(nat,nat))] :
          ( ( X2 = aa(set(product_prod(nat,nat)),int,abs_int,Y2) )
         => ~ pp(aa(set(set(product_prod(nat,nat))),bool,member(set(product_prod(nat,nat)),Y2),aa(fun(set(product_prod(nat,nat)),bool),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axu(set(product_prod(nat,nat)),bool)))) ) ).

% Abs_int_cases
tff(fact_5854_Abs__int__inject,axiom,
    ! [X2: set(product_prod(nat,nat)),Y: set(product_prod(nat,nat))] :
      ( pp(aa(set(set(product_prod(nat,nat))),bool,member(set(product_prod(nat,nat)),X2),aa(fun(set(product_prod(nat,nat)),bool),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axu(set(product_prod(nat,nat)),bool))))
     => ( pp(aa(set(set(product_prod(nat,nat))),bool,member(set(product_prod(nat,nat)),Y),aa(fun(set(product_prod(nat,nat)),bool),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axu(set(product_prod(nat,nat)),bool))))
       => ( ( aa(set(product_prod(nat,nat)),int,abs_int,X2) = aa(set(product_prod(nat,nat)),int,abs_int,Y) )
        <=> ( X2 = Y ) ) ) ) ).

% Abs_int_inject
tff(fact_5855_Abs__int__induct,axiom,
    ! [P: fun(int,bool),X2: int] :
      ( ! [Y2: set(product_prod(nat,nat))] :
          ( pp(aa(set(set(product_prod(nat,nat))),bool,member(set(product_prod(nat,nat)),Y2),aa(fun(set(product_prod(nat,nat)),bool),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axu(set(product_prod(nat,nat)),bool))))
         => pp(aa(int,bool,P,aa(set(product_prod(nat,nat)),int,abs_int,Y2))) )
     => pp(aa(int,bool,P,X2)) ) ).

% Abs_int_induct
tff(fact_5856_split__seed__def,axiom,
    ! [S2: product_prod(code_natural,code_natural)] : ( split_seed(S2) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_case_prod(code_natural,code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aTP_Lamp_axw(product_prod(code_natural,code_natural),fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),S2)),S2) ) ).

% split_seed_def
tff(fact_5857_Random_Orange__def,axiom,
    ! [K: code_natural] : ( range(K) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),iterate(code_natural,product_prod(code_natural,code_natural),log(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),K),aTP_Lamp_axy(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),one_one(code_natural)),aTP_Lamp_axz(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),K)) ) ).

% Random.range_def
tff(fact_5858_Abs__int__inverse,axiom,
    ! [Y: set(product_prod(nat,nat))] :
      ( pp(aa(set(set(product_prod(nat,nat))),bool,member(set(product_prod(nat,nat)),Y),aa(fun(set(product_prod(nat,nat)),bool),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axu(set(product_prod(nat,nat)),bool))))
     => ( aa(int,set(product_prod(nat,nat)),rep_int,aa(set(product_prod(nat,nat)),int,abs_int,Y)) = Y ) ) ).

% Abs_int_inverse
tff(fact_5859_Rep__int,axiom,
    ! [X2: int] : pp(aa(set(set(product_prod(nat,nat))),bool,member(set(product_prod(nat,nat)),aa(int,set(product_prod(nat,nat)),rep_int,X2)),aa(fun(set(product_prod(nat,nat)),bool),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axu(set(product_prod(nat,nat)),bool)))) ).

% Rep_int
tff(fact_5860_Rep__int__cases,axiom,
    ! [Y: set(product_prod(nat,nat))] :
      ( pp(aa(set(set(product_prod(nat,nat))),bool,member(set(product_prod(nat,nat)),Y),aa(fun(set(product_prod(nat,nat)),bool),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axu(set(product_prod(nat,nat)),bool))))
     => ~ ! [X: int] : ( Y != aa(int,set(product_prod(nat,nat)),rep_int,X) ) ) ).

% Rep_int_cases
tff(fact_5861_Rep__int__induct,axiom,
    ! [Y: set(product_prod(nat,nat)),P: fun(set(product_prod(nat,nat)),bool)] :
      ( pp(aa(set(set(product_prod(nat,nat))),bool,member(set(product_prod(nat,nat)),Y),aa(fun(set(product_prod(nat,nat)),bool),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axu(set(product_prod(nat,nat)),bool))))
     => ( ! [X: int] : pp(aa(set(product_prod(nat,nat)),bool,P,aa(int,set(product_prod(nat,nat)),rep_int,X)))
       => pp(aa(set(product_prod(nat,nat)),bool,P,Y)) ) ) ).

% Rep_int_induct
tff(fact_5862_type__definition__int,axiom,
    type_definition(int,set(product_prod(nat,nat)),rep_int,abs_int,aa(fun(set(product_prod(nat,nat)),bool),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axu(set(product_prod(nat,nat)),bool))) ).

% type_definition_int
tff(fact_5863_select__weight__def,axiom,
    ! [A: $tType,Xs: list(product_prod(code_natural,A))] : ( select_weight(A,Xs) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)),range(aa(list(code_natural),code_natural,groups8242544230860333062m_list(code_natural),aa(list(product_prod(code_natural,A)),list(code_natural),map(product_prod(code_natural,A),code_natural,product_fst(code_natural,A)),Xs))),aTP_Lamp_aya(list(product_prod(code_natural,A)),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)))),Xs)) ) ).

% select_weight_def
tff(fact_5864_pick__drop__zero,axiom,
    ! [A: $tType,Xs: list(product_prod(code_natural,A))] : ( pick(A,aa(list(product_prod(code_natural,A)),list(product_prod(code_natural,A)),filter2(product_prod(code_natural,A),aa(fun(code_natural,fun(A,bool)),fun(product_prod(code_natural,A),bool),product_case_prod(code_natural,A,bool),aTP_Lamp_ayb(code_natural,fun(A,bool)))),Xs)) = pick(A,Xs) ) ).

% pick_drop_zero
tff(fact_5865_select__weight__drop__zero,axiom,
    ! [A: $tType,Xs: list(product_prod(code_natural,A))] : ( select_weight(A,aa(list(product_prod(code_natural,A)),list(product_prod(code_natural,A)),filter2(product_prod(code_natural,A),aa(fun(code_natural,fun(A,bool)),fun(product_prod(code_natural,A),bool),product_case_prod(code_natural,A,bool),aTP_Lamp_ayb(code_natural,fun(A,bool)))),Xs)) = select_weight(A,Xs) ) ).

% select_weight_drop_zero
tff(fact_5866_comm__monoid__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid(A,F2,Z2)
    <=> ( abel_semigroup(A,F2)
        & comm_monoid_axioms(A,F2,Z2) ) ) ).

% comm_monoid_def
tff(fact_5867_comm__monoid_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( abel_semigroup(A,F2)
     => ( comm_monoid_axioms(A,F2,Z2)
       => comm_monoid(A,F2,Z2) ) ) ).

% comm_monoid.intro
tff(fact_5868_ordering_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ordering(A,Less_eq,Less)
     => ordering_axioms(A,Less_eq,Less) ) ).

% ordering.axioms(2)
tff(fact_5869_mult_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => abel_semigroup(A,times_times(A)) ) ).

% mult.abel_semigroup_axioms
tff(fact_5870_add_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => abel_semigroup(A,plus_plus(A)) ) ).

% add.abel_semigroup_axioms
tff(fact_5871_sup_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => abel_semigroup(A,sup_sup(A)) ) ).

% sup.abel_semigroup_axioms
tff(fact_5872_comm__monoid_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid(A,F2,Z2)
     => abel_semigroup(A,F2) ) ).

% comm_monoid.axioms(1)
tff(fact_5873_min_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => abel_semigroup(A,ord_min(A)) ) ).

% min.abel_semigroup_axioms
tff(fact_5874_max_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => abel_semigroup(A,ord_max(A)) ) ).

% max.abel_semigroup_axioms
tff(fact_5875_ordering__axioms_Ointro,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool)),Less_eq: fun(A,fun(A,bool))] :
      ( ! [A5: A,B4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),B4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A5),B4))
            & ( A5 != B4 ) ) )
     => ( ! [A5: A,B4: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A5),B4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B4),A5))
             => ( A5 = B4 ) ) )
       => ordering_axioms(A,Less_eq,Less) ) ) ).

% ordering_axioms.intro
tff(fact_5876_ordering__axioms__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ordering_axioms(A,Less_eq,Less)
    <=> ( ! [A6: A,B5: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A6),B5))
          <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),B5))
              & ( A6 != B5 ) ) )
        & ! [A6: A,B5: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),B5))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B5),A6))
             => ( A6 = B5 ) ) ) ) ) ).

% ordering_axioms_def
tff(fact_5877_abel__semigroup_Ocommute,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A4: A,B3: A] :
      ( abel_semigroup(A,F2)
     => ( aa(A,A,aa(A,fun(A,A),F2,A4),B3) = aa(A,A,aa(A,fun(A,A),F2,B3),A4) ) ) ).

% abel_semigroup.commute
tff(fact_5878_abel__semigroup_Oleft__commute,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),B3: A,A4: A,C2: A] :
      ( abel_semigroup(A,F2)
     => ( aa(A,A,aa(A,fun(A,A),F2,B3),aa(A,A,aa(A,fun(A,A),F2,A4),C2)) = aa(A,A,aa(A,fun(A,A),F2,A4),aa(A,A,aa(A,fun(A,A),F2,B3),C2)) ) ) ).

% abel_semigroup.left_commute
tff(fact_5879_abstract__boolean__algebra_Oaxioms_I1_J,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => abel_semigroup(A,Conj) ) ).

% abstract_boolean_algebra.axioms(1)
tff(fact_5880_abstract__boolean__algebra_Oaxioms_I2_J,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => abel_semigroup(A,Disj) ) ).

% abstract_boolean_algebra.axioms(2)
tff(fact_5881_abel__semigroup_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( abel_semigroup(A,F2)
     => semigroup(A,F2) ) ).

% abel_semigroup.axioms(1)
tff(fact_5882_inf_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => abel_semigroup(A,inf_inf(A)) ) ).

% inf.abel_semigroup_axioms
tff(fact_5883_abel__semigroup__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( abel_semigroup(A,F2)
    <=> ( semigroup(A,F2)
        & abel_s757365448890700780axioms(A,F2) ) ) ).

% abel_semigroup_def
tff(fact_5884_abel__semigroup_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( semigroup(A,F2)
     => ( abel_s757365448890700780axioms(A,F2)
       => abel_semigroup(A,F2) ) ) ).

% abel_semigroup.intro
tff(fact_5885_abstract__boolean__algebra__def,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
    <=> ( abel_semigroup(A,Conj)
        & abel_semigroup(A,Disj)
        & boolea6902313364301356556axioms(A,Conj,Disj,Compl,Zero,One) ) ) ).

% abstract_boolean_algebra_def
tff(fact_5886_abel__semigroup__axioms__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( abel_s757365448890700780axioms(A,F2)
    <=> ! [A6: A,B5: A] : ( aa(A,A,aa(A,fun(A,A),F2,A6),B5) = aa(A,A,aa(A,fun(A,A),F2,B5),A6) ) ) ).

% abel_semigroup_axioms_def
tff(fact_5887_abel__semigroup__axioms_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( ! [A5: A,B4: A] : ( aa(A,A,aa(A,fun(A,A),F2,A5),B4) = aa(A,A,aa(A,fun(A,A),F2,B4),A5) )
     => abel_s757365448890700780axioms(A,F2) ) ).

% abel_semigroup_axioms.intro
tff(fact_5888_abstract__boolean__algebra__axioms__def,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea6902313364301356556axioms(A,Conj,Disj,Compl,Zero,One)
    <=> ( ! [X3: A,Y4: A,Z5: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X3),aa(A,A,aa(A,fun(A,A),Disj,Y4),Z5)) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X3),Y4)),aa(A,A,aa(A,fun(A,A),Conj,X3),Z5)) )
        & ! [X3: A,Y4: A,Z5: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X3),aa(A,A,aa(A,fun(A,A),Conj,Y4),Z5)) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,X3),Y4)),aa(A,A,aa(A,fun(A,A),Disj,X3),Z5)) )
        & ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X3),One) = X3 )
        & ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X3),Zero) = X3 )
        & ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X3),aa(A,A,Compl,X3)) = Zero )
        & ! [X3: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X3),aa(A,A,Compl,X3)) = One ) ) ) ).

% abstract_boolean_algebra_axioms_def
tff(fact_5889_abstract__boolean__algebra__axioms_Ointro,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),One: A,Zero: A,Compl: fun(A,A)] :
      ( ! [X: A,Y2: A,Z3: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X),aa(A,A,aa(A,fun(A,A),Disj,Y2),Z3)) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X),Y2)),aa(A,A,aa(A,fun(A,A),Conj,X),Z3)) )
     => ( ! [X: A,Y2: A,Z3: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X),aa(A,A,aa(A,fun(A,A),Conj,Y2),Z3)) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,X),Y2)),aa(A,A,aa(A,fun(A,A),Disj,X),Z3)) )
       => ( ! [X: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X),One) = X )
         => ( ! [X: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X),Zero) = X )
           => ( ! [X: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X),aa(A,A,Compl,X)) = Zero )
             => ( ! [X: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X),aa(A,A,Compl,X)) = One )
               => boolea6902313364301356556axioms(A,Conj,Disj,Compl,Zero,One) ) ) ) ) ) ) ).

% abstract_boolean_algebra_axioms.intro
tff(fact_5890_abel__semigroup_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( abel_semigroup(A,F2)
     => abel_s757365448890700780axioms(A,F2) ) ).

% abel_semigroup.axioms(2)
tff(fact_5891_abstract__boolean__algebra_Oaxioms_I3_J,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => boolea6902313364301356556axioms(A,Conj,Disj,Compl,Zero,One) ) ).

% abstract_boolean_algebra.axioms(3)
tff(fact_5892_abstract__boolean__algebra_Ointro,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( abel_semigroup(A,Conj)
     => ( abel_semigroup(A,Disj)
       => ( boolea6902313364301356556axioms(A,Conj,Disj,Compl,Zero,One)
         => boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One) ) ) ) ).

% abstract_boolean_algebra.intro
tff(fact_5893_ordering__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ordering(A,Less_eq,Less)
    <=> ( partial_preordering(A,Less_eq)
        & ordering_axioms(A,Less_eq,Less) ) ) ).

% ordering_def
tff(fact_5894_ordering_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( partial_preordering(A,Less_eq)
     => ( ordering_axioms(A,Less_eq,Less)
       => ordering(A,Less_eq,Less) ) ) ).

% ordering.intro
tff(fact_5895_sort__mergesort__by__rel,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( linorder_sort_key(A,A,aTP_Lamp_eh(A,A)) = mergesort_by_rel(A,ord_less_eq(A)) ) ) ).

% sort_mergesort_by_rel
tff(fact_5896_partial__preordering_Orefl,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),A4: A] :
      ( partial_preordering(A,Less_eq)
     => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),A4)) ) ).

% partial_preordering.refl
tff(fact_5897_partial__preordering_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool))] :
      ( ! [A5: A] : pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A5),A5))
     => ( ! [A5: A,B4: A,C4: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A5),B4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B4),C4))
             => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A5),C4)) ) )
       => partial_preordering(A,Less_eq) ) ) ).

% partial_preordering.intro
tff(fact_5898_partial__preordering_Otrans,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),A4: A,B3: A,C2: A] :
      ( partial_preordering(A,Less_eq)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),C2)) ) ) ) ).

% partial_preordering.trans
tff(fact_5899_partial__preordering__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool))] :
      ( partial_preordering(A,Less_eq)
    <=> ( ! [A6: A] : pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),A6))
        & ! [A6: A,B5: A,C5: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),B5))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B5),C5))
             => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),C5)) ) ) ) ) ).

% partial_preordering_def
tff(fact_5900_order_Opartial__preordering__axioms,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => partial_preordering(A,ord_less_eq(A)) ) ).

% order.partial_preordering_axioms
tff(fact_5901_ordering_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ordering(A,Less_eq,Less)
     => partial_preordering(A,Less_eq) ) ).

% ordering.axioms(1)
tff(fact_5902_subset__mset_Odual__order_Opartial__preordering__axioms,axiom,
    ! [A: $tType] : partial_preordering(multiset(A),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool))) ).

% subset_mset.dual_order.partial_preordering_axioms
tff(fact_5903_dual__order_Opartial__preordering__axioms,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => partial_preordering(A,aTP_Lamp_ava(A,fun(A,bool))) ) ).

% dual_order.partial_preordering_axioms
tff(fact_5904_mergesort__by__rel__simps_I3_J,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),X13: A,X24: A,Xs: list(A)] : ( aa(list(A),list(A),mergesort_by_rel(A,R),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X13),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X24),Xs))) = aa(product_prod(list(A),list(A)),list(A),aa(fun(list(A),fun(list(A),list(A))),fun(product_prod(list(A),list(A)),list(A)),product_case_prod(list(A),list(A),list(A)),aTP_Lamp_ayc(fun(A,fun(A,bool)),fun(list(A),fun(list(A),list(A))),R)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X13),nil(A))),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X24),nil(A))),Xs)) ) ).

% mergesort_by_rel_simps(3)
tff(fact_5905_semilattice__neutr_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( semilattice(A,F2)
     => ( comm_monoid(A,F2,Z2)
       => semilattice_neutr(A,F2,Z2) ) ) ).

% semilattice_neutr.intro
tff(fact_5906_semilattice__neutr__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( semilattice_neutr(A,F2,Z2)
    <=> ( semilattice(A,F2)
        & comm_monoid(A,F2,Z2) ) ) ).

% semilattice_neutr_def
tff(fact_5907_semilattice__map2,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( semilattice(A,F2)
     => semilattice(list(A),aTP_Lamp_ayd(fun(A,fun(A,A)),fun(list(A),fun(list(A),list(A))),F2)) ) ).

% semilattice_map2
tff(fact_5908_semilattice_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( semilattice(A,F2)
     => abel_semigroup(A,F2) ) ).

% semilattice.axioms(1)
tff(fact_5909_inf_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => semilattice(A,inf_inf(A)) ) ).

% inf.semilattice_axioms
tff(fact_5910_semilattice__neutr_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( semilattice_neutr(A,F2,Z2)
     => semilattice(A,F2) ) ).

% semilattice_neutr.axioms(1)
tff(fact_5911_max_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semilattice(A,ord_max(A)) ) ).

% max.semilattice_axioms
tff(fact_5912_min_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semilattice(A,ord_min(A)) ) ).

% min.semilattice_axioms
tff(fact_5913_semilattice_Oright__idem,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A4: A,B3: A] :
      ( semilattice(A,F2)
     => ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,A4),B3)),B3) = aa(A,A,aa(A,fun(A,A),F2,A4),B3) ) ) ).

% semilattice.right_idem
tff(fact_5914_semilattice_Oleft__idem,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A4: A,B3: A] :
      ( semilattice(A,F2)
     => ( aa(A,A,aa(A,fun(A,A),F2,A4),aa(A,A,aa(A,fun(A,A),F2,A4),B3)) = aa(A,A,aa(A,fun(A,A),F2,A4),B3) ) ) ).

% semilattice.left_idem
tff(fact_5915_semilattice_Oidem,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),A4: A] :
      ( semilattice(A,F2)
     => ( aa(A,A,aa(A,fun(A,A),F2,A4),A4) = A4 ) ) ).

% semilattice.idem
tff(fact_5916_sup_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => semilattice(A,sup_sup(A)) ) ).

% sup.semilattice_axioms
tff(fact_5917_semilattice__order_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => semilattice(A,F2) ) ).

% semilattice_order.axioms(1)
tff(fact_5918_semilattice_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( abel_semigroup(A,F2)
     => ( semilattice_axioms(A,F2)
       => semilattice(A,F2) ) ) ).

% semilattice.intro
tff(fact_5919_semilattice__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( semilattice(A,F2)
    <=> ( abel_semigroup(A,F2)
        & semilattice_axioms(A,F2) ) ) ).

% semilattice_def
tff(fact_5920_semilattice__order__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semilattice_order(A,F2,Less_eq,Less)
    <=> ( semilattice(A,F2)
        & semila6385135966242565138axioms(A,F2,Less_eq,Less) ) ) ).

% semilattice_order_def
tff(fact_5921_semilattice__axioms_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( ! [A5: A] : ( aa(A,A,aa(A,fun(A,A),F2,A5),A5) = A5 )
     => semilattice_axioms(A,F2) ) ).

% semilattice_axioms.intro
tff(fact_5922_semilattice__order__axioms_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),F2: fun(A,fun(A,A)),Less: fun(A,fun(A,bool))] :
      ( ! [A5: A,B4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A5),B4))
        <=> ( A5 = aa(A,A,aa(A,fun(A,A),F2,A5),B4) ) )
     => ( ! [A5: A,B4: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),B4))
          <=> ( ( A5 = aa(A,A,aa(A,fun(A,A),F2,A5),B4) )
              & ( A5 != B4 ) ) )
       => semila6385135966242565138axioms(A,F2,Less_eq,Less) ) ) ).

% semilattice_order_axioms.intro
tff(fact_5923_semilattice__axioms__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( semilattice_axioms(A,F2)
    <=> ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F2,A6),A6) = A6 ) ) ).

% semilattice_axioms_def
tff(fact_5924_semilattice__order__axioms__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semila6385135966242565138axioms(A,F2,Less_eq,Less)
    <=> ( ! [A6: A,B5: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),B5))
          <=> ( A6 = aa(A,A,aa(A,fun(A,A),F2,A6),B5) ) )
        & ! [A6: A,B5: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A6),B5))
          <=> ( ( A6 = aa(A,A,aa(A,fun(A,A),F2,A6),B5) )
              & ( A6 != B5 ) ) ) ) ) ).

% semilattice_order_axioms_def
tff(fact_5925_semilattice__order_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semilattice_order(A,F2,Less_eq,Less)
     => semila6385135966242565138axioms(A,F2,Less_eq,Less) ) ).

% semilattice_order.axioms(2)
tff(fact_5926_semilattice_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A))] :
      ( semilattice(A,F2)
     => semilattice_axioms(A,F2) ) ).

% semilattice.axioms(2)
tff(fact_5927_semilattice__order_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semilattice(A,F2)
     => ( semila6385135966242565138axioms(A,F2,Less_eq,Less)
       => semilattice_order(A,F2,Less_eq,Less) ) ) ).

% semilattice_order.intro
tff(fact_5928_subset__mset_Odual__order_Opreordering__axioms,axiom,
    ! [A: $tType] : preordering(multiset(A),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool)),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool))) ).

% subset_mset.dual_order.preordering_axioms
tff(fact_5929_list__decode_Oelims,axiom,
    ! [X2: nat,Y: list(nat)] :
      ( ( nat_list_decode(X2) = Y )
     => ( ( ( X2 = zero_zero(nat) )
         => ( Y != nil(nat) ) )
       => ~ ! [N2: nat] :
              ( ( X2 = aa(nat,nat,suc,N2) )
             => ( Y != aa(product_prod(nat,nat),list(nat),aa(fun(nat,fun(nat,list(nat))),fun(product_prod(nat,nat),list(nat)),product_case_prod(nat,nat,list(nat)),aTP_Lamp_aye(nat,fun(nat,list(nat)))),nat_prod_decode(N2)) ) ) ) ) ).

% list_decode.elims
tff(fact_5930_dual__order_Opreordering__axioms,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => preordering(A,aTP_Lamp_ava(A,fun(A,bool)),aTP_Lamp_aad(A,fun(A,bool))) ) ).

% dual_order.preordering_axioms
tff(fact_5931_preordering__dualI,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( preordering(A,aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Less_eq),aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Less))
     => preordering(A,Less_eq,Less) ) ).

% preordering_dualI
tff(fact_5932_preordering__strictI,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ! [A5: A,B4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A5),B4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),B4))
            | ( A5 = B4 ) ) )
     => ( ! [A5: A,B4: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),B4))
           => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,B4),A5)) )
       => ( ! [A5: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),A5))
         => ( ! [A5: A,B4: A,C4: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),B4))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B4),C4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),C4)) ) )
           => preordering(A,Less_eq,Less) ) ) ) ) ).

% preordering_strictI
tff(fact_5933_preordering_Ostrict__implies__order,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3))
       => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3)) ) ) ).

% preordering.strict_implies_order
tff(fact_5934_preordering_Ostrict__iff__not,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3))
      <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
          & ~ pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B3),A4)) ) ) ) ).

% preordering.strict_iff_not
tff(fact_5935_preordering_Ostrict__trans2,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A,C2: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),C2)) ) ) ) ).

% preordering.strict_trans2
tff(fact_5936_preordering_Ostrict__trans1,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A,C2: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A4),B3))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),C2)) ) ) ) ).

% preordering.strict_trans1
tff(fact_5937_preordering_Ostrict__trans,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A,C2: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),C2)) ) ) ) ).

% preordering.strict_trans
tff(fact_5938_preordering_Oirrefl,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A] :
      ( preordering(A,Less_eq,Less)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),A4)) ) ).

% preordering.irrefl
tff(fact_5939_preordering_Oasym,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: A,B3: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A4),B3))
       => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,B3),A4)) ) ) ).

% preordering.asym
tff(fact_5940_gcd__nat_Opreordering__axioms,axiom,
    preordering(nat,dvd_dvd(nat),aTP_Lamp_abn(nat,fun(nat,bool))) ).

% gcd_nat.preordering_axioms
tff(fact_5941_list__decode_Osimps_I2_J,axiom,
    ! [N: nat] : ( nat_list_decode(aa(nat,nat,suc,N)) = aa(product_prod(nat,nat),list(nat),aa(fun(nat,fun(nat,list(nat))),fun(product_prod(nat,nat),list(nat)),product_case_prod(nat,nat,list(nat)),aTP_Lamp_aye(nat,fun(nat,list(nat)))),nat_prod_decode(N)) ) ).

% list_decode.simps(2)
tff(fact_5942_preordering_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( preordering(A,Less_eq,Less)
     => partial_preordering(A,Less_eq) ) ).

% preordering.axioms(1)
tff(fact_5943_order_Opreordering__axioms,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => preordering(A,ord_less_eq(A),ord_less(A)) ) ).

% order.preordering_axioms
tff(fact_5944_preordering__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( preordering(A,Less_eq,Less)
    <=> ( partial_preordering(A,Less_eq)
        & preordering_axioms(A,Less_eq,Less) ) ) ).

% preordering_def
tff(fact_5945_preordering_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( partial_preordering(A,Less_eq)
     => ( preordering_axioms(A,Less_eq,Less)
       => preordering(A,Less_eq,Less) ) ) ).

% preordering.intro
tff(fact_5946_list__decode_Opelims,axiom,
    ! [X2: nat,Y: list(nat)] :
      ( ( nat_list_decode(X2) = Y )
     => ( pp(aa(nat,bool,accp(nat,nat_list_decode_rel),X2))
       => ( ( ( X2 = zero_zero(nat) )
           => ( ( Y = nil(nat) )
             => ~ pp(aa(nat,bool,accp(nat,nat_list_decode_rel),zero_zero(nat))) ) )
         => ~ ! [N2: nat] :
                ( ( X2 = aa(nat,nat,suc,N2) )
               => ( ( Y = aa(product_prod(nat,nat),list(nat),aa(fun(nat,fun(nat,list(nat))),fun(product_prod(nat,nat),list(nat)),product_case_prod(nat,nat,list(nat)),aTP_Lamp_aye(nat,fun(nat,list(nat)))),nat_prod_decode(N2)) )
                 => ~ pp(aa(nat,bool,accp(nat,nat_list_decode_rel),aa(nat,nat,suc,N2))) ) ) ) ) ) ).

% list_decode.pelims
tff(fact_5947_preordering__axioms_Ointro,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool)),Less_eq: fun(A,fun(A,bool))] :
      ( ! [A5: A,B4: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A5),B4))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A5),B4))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B4),A5)) ) )
     => preordering_axioms(A,Less_eq,Less) ) ).

% preordering_axioms.intro
tff(fact_5948_preordering__axioms__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( preordering_axioms(A,Less_eq,Less)
    <=> ! [A6: A,B5: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A6),B5))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),B5))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B5),A6)) ) ) ) ).

% preordering_axioms_def
tff(fact_5949_preordering_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( preordering(A,Less_eq,Less)
     => preordering_axioms(A,Less_eq,Less) ) ).

% preordering.axioms(2)
tff(fact_5950_list__decode_Opsimps_I2_J,axiom,
    ! [N: nat] :
      ( pp(aa(nat,bool,accp(nat,nat_list_decode_rel),aa(nat,nat,suc,N)))
     => ( nat_list_decode(aa(nat,nat,suc,N)) = aa(product_prod(nat,nat),list(nat),aa(fun(nat,fun(nat,list(nat))),fun(product_prod(nat,nat),list(nat)),product_case_prod(nat,nat,list(nat)),aTP_Lamp_aye(nat,fun(nat,list(nat)))),nat_prod_decode(N)) ) ) ).

% list_decode.psimps(2)
tff(fact_5951_admissible__disj,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [P: fun(A,bool),Q: fun(A,bool)] :
          ( comple1908693960933563346ssible(A,complete_Sup_Sup(A),ord_less_eq(A),P)
         => ( comple1908693960933563346ssible(A,complete_Sup_Sup(A),ord_less_eq(A),Q)
           => comple1908693960933563346ssible(A,complete_Sup_Sup(A),ord_less_eq(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_ayf(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q)) ) ) ) ).

% admissible_disj
tff(fact_5952_ndepth__Push__Node__aux,axiom,
    ! [A: $tType,I2: nat,F2: fun(nat,sum_sum(A,nat)),K: nat] :
      ( ( aa(nat,sum_sum(A,nat),aa(fun(nat,sum_sum(A,nat)),fun(nat,sum_sum(A,nat)),aa(sum_sum(A,nat),fun(fun(nat,sum_sum(A,nat)),fun(nat,sum_sum(A,nat))),case_nat(sum_sum(A,nat)),aa(nat,sum_sum(A,nat),sum_Inr(nat,A),aa(nat,nat,suc,I2))),F2),K) = aa(nat,sum_sum(A,nat),sum_Inr(nat,A),zero_zero(nat)) )
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,suc,ord_Least(nat,aTP_Lamp_ayg(fun(nat,sum_sum(A,nat)),fun(nat,bool),F2)))),K)) ) ).

% ndepth_Push_Node_aux
tff(fact_5953_bij__image__Collect__eq,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),P: fun(A,bool)] :
      ( bij_betw(A,B,F2,top_top(set(A)),top_top(set(B)))
     => ( aa(set(A),set(B),image2(A,B,F2),aa(fun(A,bool),set(A),collect(A),P)) = aa(fun(B,bool),set(B),collect(B),aa(fun(A,bool),fun(B,bool),aTP_Lamp_ayh(fun(A,B),fun(fun(A,bool),fun(B,bool)),F2),P)) ) ) ).

% bij_image_Collect_eq
tff(fact_5954_inv__identity,axiom,
    ! [A: $tType,X4: A] : ( hilbert_inv_into(A,A,top_top(set(A)),aTP_Lamp_bk(A,A),X4) = X4 ) ).

% inv_identity
tff(fact_5955_inv__into__def,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F2: fun(A,B),X4: B] : ( hilbert_inv_into(A,B,A3,F2,X4) = fChoice(A,aa(B,fun(A,bool),aa(fun(A,B),fun(B,fun(A,bool)),aTP_Lamp_kk(set(A),fun(fun(A,B),fun(B,fun(A,bool))),A3),F2),X4)) ) ).

% inv_into_def
tff(fact_5956_inv__into__def2,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F2: fun(A,B),X2: B] : ( hilbert_inv_into(A,B,A3,F2,X2) = fChoice(A,aa(B,fun(A,bool),aa(fun(A,B),fun(B,fun(A,bool)),aTP_Lamp_kk(set(A),fun(fun(A,B),fun(B,fun(A,bool))),A3),F2),X2)) ) ).

% inv_into_def2
tff(fact_5957_admissible__True,axiom,
    ! [A: $tType,Lub: fun(set(A),A),Ord: fun(A,fun(A,bool))] : comple1908693960933563346ssible(A,Lub,Ord,aTP_Lamp_nn(A,bool)) ).

% admissible_True
tff(fact_5958_admissible__conj,axiom,
    ! [A: $tType,Lub: fun(set(A),A),Ord: fun(A,fun(A,bool)),P: fun(A,bool),Q: fun(A,bool)] :
      ( comple1908693960933563346ssible(A,Lub,Ord,P)
     => ( comple1908693960933563346ssible(A,Lub,Ord,Q)
       => comple1908693960933563346ssible(A,Lub,Ord,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q)) ) ) ).

% admissible_conj
tff(fact_5959_admissible__const,axiom,
    ! [A: $tType,Lub: fun(set(A),A),Ord: fun(A,fun(A,bool)),T3: bool] : comple1908693960933563346ssible(A,Lub,Ord,aTP_Lamp_an(bool,fun(A,bool),T3)) ).

% admissible_const
tff(fact_5960_admissible__ball,axiom,
    ! [A: $tType,B: $tType,A3: set(A),Lub: fun(set(B),B),Ord: fun(B,fun(B,bool)),P: fun(B,fun(A,bool))] :
      ( ! [Y2: A] :
          ( pp(aa(set(A),bool,member(A,Y2),A3))
         => comple1908693960933563346ssible(B,Lub,Ord,aa(A,fun(B,bool),aTP_Lamp_kr(fun(B,fun(A,bool)),fun(A,fun(B,bool)),P),Y2)) )
     => comple1908693960933563346ssible(B,Lub,Ord,aa(fun(B,fun(A,bool)),fun(B,bool),aTP_Lamp_adk(set(A),fun(fun(B,fun(A,bool)),fun(B,bool)),A3),P)) ) ).

% admissible_ball
tff(fact_5961_admissible__all,axiom,
    ! [A: $tType,B: $tType,Lub: fun(set(B),B),Ord: fun(B,fun(B,bool)),P: fun(B,fun(A,bool))] :
      ( ! [Y2: A] : comple1908693960933563346ssible(B,Lub,Ord,aa(A,fun(B,bool),aTP_Lamp_kr(fun(B,fun(A,bool)),fun(A,fun(B,bool)),P),Y2))
     => comple1908693960933563346ssible(B,Lub,Ord,aTP_Lamp_ayi(fun(B,fun(A,bool)),fun(B,bool),P)) ) ).

% admissible_all
tff(fact_5962_inv__def,axiom,
    ! [B: $tType,A: $tType,F2: fun(B,A),X4: A] : ( hilbert_inv_into(B,A,top_top(set(B)),F2,X4) = fChoice(B,aa(A,fun(B,bool),aTP_Lamp_ayj(fun(B,A),fun(A,fun(B,bool)),F2),X4)) ) ).

% inv_def
tff(fact_5963_ccpo_Oadmissible__def,axiom,
    ! [A: $tType,Lub: fun(set(A),A),Ord: fun(A,fun(A,bool)),P: fun(A,bool)] :
      ( comple1908693960933563346ssible(A,Lub,Ord,P)
    <=> ! [A12: set(A)] :
          ( comple1602240252501008431_chain(A,Ord,A12)
         => ( ( A12 != bot_bot(set(A)) )
           => ( ! [X3: A] :
                  ( pp(aa(set(A),bool,member(A,X3),A12))
                 => pp(aa(A,bool,P,X3)) )
             => pp(aa(A,bool,P,aa(set(A),A,Lub,A12))) ) ) ) ) ).

% ccpo.admissible_def
tff(fact_5964_ccpo_OadmissibleI,axiom,
    ! [A: $tType,Ord: fun(A,fun(A,bool)),P: fun(A,bool),Lub: fun(set(A),A)] :
      ( ! [A11: set(A)] :
          ( comple1602240252501008431_chain(A,Ord,A11)
         => ( ( A11 != bot_bot(set(A)) )
           => ( ! [X4: A] :
                  ( pp(aa(set(A),bool,member(A,X4),A11))
                 => pp(aa(A,bool,P,X4)) )
             => pp(aa(A,bool,P,aa(set(A),A,Lub,A11))) ) ) )
     => comple1908693960933563346ssible(A,Lub,Ord,P) ) ).

% ccpo.admissibleI
tff(fact_5965_ccpo_OadmissibleD,axiom,
    ! [A: $tType,Lub: fun(set(A),A),Ord: fun(A,fun(A,bool)),P: fun(A,bool),A3: set(A)] :
      ( comple1908693960933563346ssible(A,Lub,Ord,P)
     => ( comple1602240252501008431_chain(A,Ord,A3)
       => ( ( A3 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( pp(aa(set(A),bool,member(A,X),A3))
               => pp(aa(A,bool,P,X)) )
           => pp(aa(A,bool,P,aa(set(A),A,Lub,A3))) ) ) ) ) ).

% ccpo.admissibleD
tff(fact_5966_Node__def,axiom,
    ! [A: $tType,B: $tType] : ( old_Node(B,A) = aa(fun(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),bool),set(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))),collect(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))),aTP_Lamp_ayk(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),bool)) ) ).

% Node_def
tff(fact_5967_Union__plus,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: fun(sum_sum(B,C),set(A)),A3: set(B),B2: set(C)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(sum_sum(B,C)),set(set(A)),image2(sum_sum(B,C),set(A),F2),sum_Plus(B,C,A3,B2))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_ayl(fun(sum_sum(B,C),set(A)),fun(B,set(A)),F2)),A3))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aTP_Lamp_aym(fun(sum_sum(B,C),set(A)),fun(C,set(A)),F2)),B2))) ) ).

% Union_plus
tff(fact_5968_Union__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: fun(sum_sum(A,B),set(C))] : ( aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(sum_sum(A,B)),set(set(C)),image2(sum_sum(A,B),set(C),F2),top_top(set(sum_sum(A,B))))) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image2(A,set(C),aTP_Lamp_ayn(fun(sum_sum(A,B),set(C)),fun(A,set(C)),F2)),top_top(set(A))))),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),aTP_Lamp_ayo(fun(sum_sum(A,B),set(C)),fun(B,set(C)),F2)),top_top(set(B))))) ) ).

% Union_sum
tff(fact_5969_surjective__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: fun(sum_sum(A,B),C)] : ( sum_case_sum(A,C,B,aTP_Lamp_ayp(fun(sum_sum(A,B),C),fun(A,C),F2),aTP_Lamp_ayq(fun(sum_sum(A,B),C),fun(B,C),F2)) = F2 ) ).

% surjective_sum
tff(fact_5970_Node__K0__I,axiom,
    ! [B: $tType,A: $tType,A4: sum_sum(B,nat)] : pp(aa(set(product_prod(fun(nat,sum_sum(A,nat)),sum_sum(B,nat))),bool,member(product_prod(fun(nat,sum_sum(A,nat)),sum_sum(B,nat)),aa(sum_sum(B,nat),product_prod(fun(nat,sum_sum(A,nat)),sum_sum(B,nat)),aa(fun(nat,sum_sum(A,nat)),fun(sum_sum(B,nat),product_prod(fun(nat,sum_sum(A,nat)),sum_sum(B,nat))),product_Pair(fun(nat,sum_sum(A,nat)),sum_sum(B,nat)),aTP_Lamp_ayr(nat,sum_sum(A,nat))),A4)),old_Node(A,B))) ).

% Node_K0_I
tff(fact_5971_prod_OPlus,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B),B2: set(C),G: fun(sum_sum(B,C),A)] :
          ( pp(aa(set(B),bool,finite_finite2(B),A3))
         => ( pp(aa(set(C),bool,finite_finite2(C),B2))
           => ( aa(set(sum_sum(B,C)),A,aa(fun(sum_sum(B,C),A),fun(set(sum_sum(B,C)),A),groups7121269368397514597t_prod(sum_sum(B,C),A),G),sum_Plus(B,C,A3,B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,sum_sum(B,C)),fun(B,A),comp(sum_sum(B,C),A,B,G),sum_Inl(B,C))),A3)),aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),aa(fun(C,sum_sum(B,C)),fun(C,A),comp(sum_sum(B,C),A,C,G),sum_Inr(C,B))),B2)) ) ) ) ) ).

% prod.Plus
tff(fact_5972_card__order__csum__cone__cexp__def,axiom,
    ! [A: $tType,B: $tType,R2: set(product_prod(A,A)),A1: set(B)] :
      ( pp(aa(set(product_prod(A,A)),bool,bNF_Ca8970107618336181345der_on(A,top_top(set(A))),R2))
     => ( bNF_Cardinal_cexp(sum_sum(B,product_unit),A,bNF_Cardinal_csum(B,product_unit,bNF_Ca6860139660246222851ard_of(B,A1),bNF_Cardinal_cone),R2) = bNF_Ca6860139660246222851ard_of(fun(A,sum_sum(B,product_unit)),bNF_Wellorder_Func(A,sum_sum(B,product_unit),top_top(set(A)),aa(set(sum_sum(B,product_unit)),set(sum_sum(B,product_unit)),aa(set(sum_sum(B,product_unit)),fun(set(sum_sum(B,product_unit)),set(sum_sum(B,product_unit))),sup_sup(set(sum_sum(B,product_unit))),aa(set(B),set(sum_sum(B,product_unit)),image2(B,sum_sum(B,product_unit),sum_Inl(B,product_unit)),A1)),aa(set(sum_sum(B,product_unit)),set(sum_sum(B,product_unit)),insert(sum_sum(B,product_unit),aa(product_unit,sum_sum(B,product_unit),sum_Inr(product_unit,B),product_Unity)),bot_bot(set(sum_sum(B,product_unit))))))) ) ) ).

% card_order_csum_cone_cexp_def
tff(fact_5973_sum__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,X2: A] : ( aa(sum_sum(A,B),set(A),basic_setl(A,B),aa(A,sum_sum(A,B),sum_Inl(A,B),X2)) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ).

% sum_set_simps(1)
tff(fact_5974_sum__set__simps_I2_J,axiom,
    ! [A: $tType,C: $tType,X2: A] : ( aa(sum_sum(C,A),set(C),basic_setl(C,A),aa(A,sum_sum(C,A),sum_Inr(A,C),X2)) = bot_bot(set(C)) ) ).

% sum_set_simps(2)
tff(fact_5975_sum__set__defs_I1_J,axiom,
    ! [A: $tType,B: $tType] : ( basic_setl(A,B) = sum_case_sum(A,set(A),B,aTP_Lamp_dj(A,set(A)),aTP_Lamp_gi(B,set(A))) ) ).

% sum_set_defs(1)
tff(fact_5976_sum__set__simps_I4_J,axiom,
    ! [E: $tType,A: $tType,X2: A] : ( aa(sum_sum(E,A),set(A),basic_setr(E,A),aa(A,sum_sum(E,A),sum_Inr(A,E),X2)) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ).

% sum_set_simps(4)
tff(fact_5977_Push__def,axiom,
    ! [B: $tType] : ( old_Push(B) = case_nat(sum_sum(B,nat)) ) ).

% Push_def
tff(fact_5978_sum__set__simps_I3_J,axiom,
    ! [A: $tType,D: $tType,X2: A] : ( aa(sum_sum(A,D),set(D),basic_setr(A,D),aa(A,sum_sum(A,D),sum_Inl(A,D),X2)) = bot_bot(set(D)) ) ).

% sum_set_simps(3)
tff(fact_5979_sum__set__defs_I2_J,axiom,
    ! [C: $tType,D: $tType] : ( basic_setr(C,D) = sum_case_sum(C,set(D),D,aTP_Lamp_ays(C,set(D)),aTP_Lamp_ayt(D,set(D))) ) ).

% sum_set_defs(2)
tff(fact_5980_ndepth__def,axiom,
    ! [B: $tType,A: $tType,N: old_node(A,B)] : ( old_ndepth(A,B,N) = aa(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),nat,aa(fun(fun(nat,sum_sum(B,nat)),fun(sum_sum(A,nat),nat)),fun(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),nat),product_case_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat),nat),aTP_Lamp_ayv(fun(nat,sum_sum(B,nat)),fun(sum_sum(A,nat),nat))),old_Rep_Node(A,B,N)) ) ).

% ndepth_def
tff(fact_5981_ndepth__K0,axiom,
    ! [A: $tType,B: $tType,X2: sum_sum(A,nat)] : ( old_ndepth(A,B,old_Abs_Node(B,A,aa(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),aa(fun(nat,sum_sum(B,nat)),fun(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))),product_Pair(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),aTP_Lamp_ayw(nat,sum_sum(B,nat))),X2))) = zero_zero(nat) ) ).

% ndepth_K0
tff(fact_5982_Atom__def,axiom,
    ! [B: $tType,A: $tType,X4: sum_sum(A,nat)] : ( old_Atom(A,B,X4) = aa(set(old_node(A,B)),set(old_node(A,B)),insert(old_node(A,B),old_Abs_Node(B,A,aa(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),aa(fun(nat,sum_sum(B,nat)),fun(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))),product_Pair(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),aTP_Lamp_ayw(nat,sum_sum(B,nat))),X4))),bot_bot(set(old_node(A,B)))) ) ).

% Atom_def
tff(fact_5983_Push__Node__def,axiom,
    ! [B: $tType,A: $tType,X4: sum_sum(B,nat),Xa3: old_node(A,B)] : ( aa(old_node(A,B),old_node(A,B),old_Push_Node(B,A,X4),Xa3) = old_Abs_Node(B,A,aa(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),product_apfst(fun(nat,sum_sum(B,nat)),fun(nat,sum_sum(B,nat)),sum_sum(A,nat),aa(sum_sum(B,nat),fun(fun(nat,sum_sum(B,nat)),fun(nat,sum_sum(B,nat))),old_Push(B),X4)),old_Rep_Node(A,B,Xa3))) ) ).

% Push_Node_def
tff(fact_5984_Lim__def,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,set(old_node(A,B)))] : ( old_Lim(B,A,F2) = aa(set(set(old_node(A,B))),set(old_node(A,B)),complete_Sup_Sup(set(old_node(A,B))),aa(fun(set(old_node(A,B)),bool),set(set(old_node(A,B))),collect(set(old_node(A,B))),aTP_Lamp_ayx(fun(B,set(old_node(A,B))),fun(set(old_node(A,B)),bool),F2))) ) ).

% Lim_def
tff(fact_5985_ntrunc__0,axiom,
    ! [B: $tType,A: $tType,M: set(old_node(A,B))] : ( old_ntrunc(A,B,zero_zero(nat),M) = bot_bot(set(old_node(A,B))) ) ).

% ntrunc_0
tff(fact_5986_ntrunc__UN1,axiom,
    ! [A: $tType,B: $tType,C: $tType,K: nat,F2: fun(C,set(old_node(A,B)))] : ( old_ntrunc(A,B,K,aa(set(set(old_node(A,B))),set(old_node(A,B)),complete_Sup_Sup(set(old_node(A,B))),aa(set(C),set(set(old_node(A,B))),image2(C,set(old_node(A,B)),F2),top_top(set(C))))) = aa(set(set(old_node(A,B))),set(old_node(A,B)),complete_Sup_Sup(set(old_node(A,B))),aa(set(C),set(set(old_node(A,B))),image2(C,set(old_node(A,B)),aa(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B))),aTP_Lamp_ayy(nat,fun(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B)))),K),F2)),top_top(set(C)))) ) ).

% ntrunc_UN1
tff(fact_5987_ntrunc__def,axiom,
    ! [B: $tType,A: $tType,K: nat,N4: set(old_node(A,B))] : ( old_ntrunc(A,B,K,N4) = aa(fun(old_node(A,B),bool),set(old_node(A,B)),collect(old_node(A,B)),aa(set(old_node(A,B)),fun(old_node(A,B),bool),aTP_Lamp_ayz(nat,fun(set(old_node(A,B)),fun(old_node(A,B),bool)),K),N4)) ) ).

% ntrunc_def
tff(fact_5988_ntrunc__one__In1,axiom,
    ! [B: $tType,A: $tType,M: set(old_node(A,B))] : ( old_ntrunc(A,B,aa(nat,nat,suc,zero_zero(nat)),old_In1(A,B,M)) = bot_bot(set(old_node(A,B))) ) ).

% ntrunc_one_In1
tff(fact_5989_ntrunc__one__In0,axiom,
    ! [B: $tType,A: $tType,M: set(old_node(A,B))] : ( old_ntrunc(A,B,aa(nat,nat,suc,zero_zero(nat)),old_In0(A,B,M)) = bot_bot(set(old_node(A,B))) ) ).

% ntrunc_one_In0
tff(fact_5990_In1__UN1,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(C,set(old_node(A,B)))] : ( old_In1(A,B,aa(set(set(old_node(A,B))),set(old_node(A,B)),complete_Sup_Sup(set(old_node(A,B))),aa(set(C),set(set(old_node(A,B))),image2(C,set(old_node(A,B)),F2),top_top(set(C))))) = aa(set(set(old_node(A,B))),set(old_node(A,B)),complete_Sup_Sup(set(old_node(A,B))),aa(set(C),set(set(old_node(A,B))),image2(C,set(old_node(A,B)),aTP_Lamp_aza(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B))),F2)),top_top(set(C)))) ) ).

% In1_UN1
tff(fact_5991_In0__UN1,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(C,set(old_node(A,B)))] : ( old_In0(A,B,aa(set(set(old_node(A,B))),set(old_node(A,B)),complete_Sup_Sup(set(old_node(A,B))),aa(set(C),set(set(old_node(A,B))),image2(C,set(old_node(A,B)),F2),top_top(set(C))))) = aa(set(set(old_node(A,B))),set(old_node(A,B)),complete_Sup_Sup(set(old_node(A,B))),aa(set(C),set(set(old_node(A,B))),image2(C,set(old_node(A,B)),aTP_Lamp_azb(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B))),F2)),top_top(set(C)))) ) ).

% In0_UN1
tff(fact_5992_Case__def,axiom,
    ! [C: $tType,B: $tType,A: $tType,C2: fun(set(old_node(A,B)),C),D3: fun(set(old_node(A,B)),C),M: set(old_node(A,B))] : ( old_Case(A,B,C,C2,D3,M) = the(C,aa(set(old_node(A,B)),fun(C,bool),aa(fun(set(old_node(A,B)),C),fun(set(old_node(A,B)),fun(C,bool)),aTP_Lamp_azc(fun(set(old_node(A,B)),C),fun(fun(set(old_node(A,B)),C),fun(set(old_node(A,B)),fun(C,bool))),C2),D3),M)) ) ).

% Case_def
tff(fact_5993_dsum__def,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),S2: set(product_prod(set(old_node(A,B)),set(old_node(A,B))))] : ( old_dsum(A,B,R2,S2) = aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),sup_sup(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),complete_Sup_Sup(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),image2(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),fun(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),product_case_prod(set(old_node(A,B)),set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_azd(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))))),R2))),aa(set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),complete_Sup_Sup(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),image2(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),fun(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),product_case_prod(set(old_node(A,B)),set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_aze(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))))),S2))) ) ).

% dsum_def
tff(fact_5994_dprod__def,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),S2: set(product_prod(set(old_node(A,B)),set(old_node(A,B))))] : ( old_dprod(A,B,R2,S2) = aa(set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),complete_Sup_Sup(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),image2(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),fun(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),product_case_prod(set(old_node(A,B)),set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_azg(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),S2))),R2)) ) ).

% dprod_def
tff(fact_5995_Scons__UN1__y,axiom,
    ! [A: $tType,B: $tType,C: $tType,M: set(old_node(A,B)),F2: fun(C,set(old_node(A,B)))] : ( old_Scons(A,B,M,aa(set(set(old_node(A,B))),set(old_node(A,B)),complete_Sup_Sup(set(old_node(A,B))),aa(set(C),set(set(old_node(A,B))),image2(C,set(old_node(A,B)),F2),top_top(set(C))))) = aa(set(set(old_node(A,B))),set(old_node(A,B)),complete_Sup_Sup(set(old_node(A,B))),aa(set(C),set(set(old_node(A,B))),image2(C,set(old_node(A,B)),aa(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B))),aTP_Lamp_azh(set(old_node(A,B)),fun(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B)))),M),F2)),top_top(set(C)))) ) ).

% Scons_UN1_y
tff(fact_5996_Scons__UN1__x,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(C,set(old_node(A,B))),M: set(old_node(A,B))] : ( old_Scons(A,B,aa(set(set(old_node(A,B))),set(old_node(A,B)),complete_Sup_Sup(set(old_node(A,B))),aa(set(C),set(set(old_node(A,B))),image2(C,set(old_node(A,B)),F2),top_top(set(C)))),M) = aa(set(set(old_node(A,B))),set(old_node(A,B)),complete_Sup_Sup(set(old_node(A,B))),aa(set(C),set(set(old_node(A,B))),image2(C,set(old_node(A,B)),aa(set(old_node(A,B)),fun(C,set(old_node(A,B))),aTP_Lamp_azi(fun(C,set(old_node(A,B))),fun(set(old_node(A,B)),fun(C,set(old_node(A,B)))),F2),M)),top_top(set(C)))) ) ).

% Scons_UN1_x
tff(fact_5997_Split__def,axiom,
    ! [C: $tType,B: $tType,A: $tType,C2: fun(set(old_node(A,B)),fun(set(old_node(A,B)),C)),M: set(old_node(A,B))] : ( aa(set(old_node(A,B)),C,old_Split(A,B,C,C2),M) = the(C,aa(set(old_node(A,B)),fun(C,bool),aTP_Lamp_azj(fun(set(old_node(A,B)),fun(set(old_node(A,B)),C)),fun(set(old_node(A,B)),fun(C,bool)),C2),M)) ) ).

% Split_def
tff(fact_5998_setr__def,axiom,
    ! [B: $tType,A: $tType,X4: sum_sum(A,B)] : ( aa(sum_sum(A,B),set(B),basic_setr(A,B),X4) = aa(fun(B,bool),set(B),collect(B),basic_setrp(A,B,X4)) ) ).

% setr_def
tff(fact_5999_setl__def,axiom,
    ! [B: $tType,A: $tType,X4: sum_sum(A,B)] : ( aa(sum_sum(A,B),set(A),basic_setl(A,B),X4) = aa(fun(A,bool),set(A),collect(A),basic_setlp(A,B,X4)) ) ).

% setl_def
tff(fact_6000_dsum__subset__Sigma,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),A3: set(set(old_node(A,B))),B2: set(set(old_node(A,B))),S2: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),C3: set(set(old_node(A,B))),D2: set(set(old_node(A,B)))] :
      ( pp(aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool,aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool),ord_less_eq(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),R2),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),A3,aTP_Lamp_azk(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),B2))))
     => ( pp(aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool,aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool),ord_less_eq(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),S2),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),C3,aTP_Lamp_azk(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),D2))))
       => pp(aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool,aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool),ord_less_eq(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),old_dsum(A,B,R2,S2)),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),old_usum(A,B,A3,C3),aa(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),aTP_Lamp_azl(set(set(old_node(A,B))),fun(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B))))),B2),D2)))) ) ) ).

% dsum_subset_Sigma
tff(fact_6001_dsum__Sigma,axiom,
    ! [B: $tType,A: $tType,A3: set(set(old_node(A,B))),B2: set(set(old_node(A,B))),C3: set(set(old_node(A,B))),D2: set(set(old_node(A,B)))] : pp(aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool,aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool),ord_less_eq(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),old_dsum(A,B,product_Sigma(set(old_node(A,B)),set(old_node(A,B)),A3,aTP_Lamp_azk(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),B2)),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),C3,aTP_Lamp_azk(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),D2)))),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),old_usum(A,B,A3,C3),aa(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),aTP_Lamp_azl(set(set(old_node(A,B))),fun(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B))))),B2),D2)))) ).

% dsum_Sigma
tff(fact_6002_dprod__Sigma,axiom,
    ! [B: $tType,A: $tType,A3: set(set(old_node(A,B))),B2: set(set(old_node(A,B))),C3: set(set(old_node(A,B))),D2: set(set(old_node(A,B)))] : pp(aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool,aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool),ord_less_eq(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),old_dprod(A,B,product_Sigma(set(old_node(A,B)),set(old_node(A,B)),A3,aTP_Lamp_azk(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),B2)),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),C3,aTP_Lamp_azk(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),D2)))),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),old_uprod(A,B,A3,C3),aa(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),aTP_Lamp_azm(set(set(old_node(A,B))),fun(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B))))),B2),D2)))) ).

% dprod_Sigma
tff(fact_6003_dprod__subset__Sigma,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),A3: set(set(old_node(A,B))),B2: set(set(old_node(A,B))),S2: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),C3: set(set(old_node(A,B))),D2: set(set(old_node(A,B)))] :
      ( pp(aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool,aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool),ord_less_eq(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),R2),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),A3,aTP_Lamp_azk(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),B2))))
     => ( pp(aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool,aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool),ord_less_eq(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),S2),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),C3,aTP_Lamp_azk(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),D2))))
       => pp(aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool,aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool),ord_less_eq(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),old_dprod(A,B,R2,S2)),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),old_uprod(A,B,A3,C3),aa(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),aTP_Lamp_azm(set(set(old_node(A,B))),fun(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B))))),B2),D2)))) ) ) ).

% dprod_subset_Sigma
tff(fact_6004_uprod__def,axiom,
    ! [B: $tType,A: $tType,A3: set(set(old_node(A,B))),B2: set(set(old_node(A,B)))] : ( old_uprod(A,B,A3,B2) = aa(set(set(set(old_node(A,B)))),set(set(old_node(A,B))),complete_Sup_Sup(set(set(old_node(A,B)))),aa(set(set(old_node(A,B))),set(set(set(old_node(A,B)))),image2(set(old_node(A,B)),set(set(old_node(A,B))),aTP_Lamp_azo(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),B2)),A3)) ) ).

% uprod_def
tff(fact_6005_dprod__subset__Sigma2,axiom,
    ! [B: $tType,A: $tType,A3: set(set(old_node(A,B))),B2: fun(set(old_node(A,B)),set(set(old_node(A,B)))),C3: set(set(old_node(A,B))),D2: fun(set(old_node(A,B)),set(set(old_node(A,B))))] : pp(aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool,aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),bool),ord_less_eq(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),old_dprod(A,B,product_Sigma(set(old_node(A,B)),set(old_node(A,B)),A3,B2),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),C3,D2))),product_Sigma(set(old_node(A,B)),set(old_node(A,B)),old_uprod(A,B,A3,C3),old_Split(A,B,set(set(old_node(A,B))),aa(fun(set(old_node(A,B)),set(set(old_node(A,B)))),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(set(old_node(A,B))))),aTP_Lamp_azp(fun(set(old_node(A,B)),set(set(old_node(A,B)))),fun(fun(set(old_node(A,B)),set(set(old_node(A,B)))),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(set(old_node(A,B)))))),B2),D2))))) ).

% dprod_subset_Sigma2
tff(fact_6006_relH__def,axiom,
    ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( relH(As2,H2,H5)
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2)))
        & ! [T8: typerep,X3: nat] :
            ( pp(aa(set(nat),bool,member(nat,X3),As2))
           => ( ( refs(product_unit,H2,T8,X3) = refs(product_unit,H5,T8,X3) )
              & ( arrays(product_unit,H2,T8,X3) = arrays(product_unit,H5,T8,X3) ) ) ) ) ) ).

% relH_def
tff(fact_6007_int__decode__def,axiom,
    ! [N: nat] : ( nat_int_decode(N) = aa(sum_sum(nat,nat),int,sum_case_sum(nat,int,nat,semiring_1_of_nat(int),aTP_Lamp_azq(nat,int)),nat_sum_decode(N)) ) ).

% int_decode_def
tff(fact_6008_nat__to__rat__surj__def,axiom,
    ! [N: nat] : ( nat_to_rat_surj(N) = aa(product_prod(nat,nat),rat,aa(fun(nat,fun(nat,rat)),fun(product_prod(nat,nat),rat),product_case_prod(nat,nat,rat),aTP_Lamp_azr(nat,fun(nat,rat))),nat_prod_decode(N)) ) ).

% nat_to_rat_surj_def
tff(fact_6009_accp__eq__acc,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),X4: A] :
      ( pp(aa(A,bool,accp(A,R2),X4))
    <=> pp(aa(set(A),bool,member(A,X4),acc(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2))))) ) ).

% accp_eq_acc
tff(fact_6010_acc__def,axiom,
    ! [A: $tType,X4: set(product_prod(A,A))] : ( acc(A,X4) = aa(fun(A,bool),set(A),collect(A),accp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),X4))) ) ).

% acc_def
tff(fact_6011_accp__acc__eq,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),X4: A] :
      ( pp(aa(A,bool,accp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2)),X4))
    <=> pp(aa(set(A),bool,member(A,X4),acc(A,R2))) ) ).

% accp_acc_eq
tff(fact_6012_in__range_Opelims_I1_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X2))
      <=> pp(Y) )
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X2))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( ( pp(Y)
                <=> ! [X3: nat] :
                      ( pp(aa(set(nat),bool,member(nat,X3),As))
                     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),lim(product_unit,H4))) ) )
               => ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ) ) ) ).

% in_range.pelims(1)
tff(fact_6013_in__range_Opelims_I2_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X2))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X2))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
               => ~ ! [X4: nat] :
                      ( pp(aa(set(nat),bool,member(nat,X4),As))
                     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X4),lim(product_unit,H4))) ) ) ) ) ) ).

% in_range.pelims(2)
tff(fact_6014_in__range_Opelims_I3_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X2))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X2))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
               => ! [X: nat] :
                    ( pp(aa(set(nat),bool,member(nat,X),As))
                   => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X),lim(product_unit,H4))) ) ) ) ) ) ).

% in_range.pelims(3)
tff(fact_6015_one__assn__raw_Opelims_I3_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X2))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X2))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
               => ( As = bot_bot(set(nat)) ) ) ) ) ) ).

% one_assn_raw.pelims(3)
tff(fact_6016_one__assn__raw_Opelims_I2_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X2))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X2))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
               => ( As != bot_bot(set(nat)) ) ) ) ) ) ).

% one_assn_raw.pelims(2)
tff(fact_6017_one__assn__raw_Opelims_I1_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X2))
      <=> pp(Y) )
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X2))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( ( pp(Y)
                <=> ( As = bot_bot(set(nat)) ) )
               => ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ) ) ) ).

% one_assn_raw.pelims(1)
tff(fact_6018_to__nat__def,axiom,
    ! [A: $tType] :
      ( countable(A)
     => ( to_nat(A) = fChoice(fun(A,nat),aTP_Lamp_azs(fun(A,nat),bool)) ) ) ).

% to_nat_def
tff(fact_6019_fixp__induct,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [P: fun(A,bool),F2: fun(A,A)] :
          ( comple1908693960933563346ssible(A,complete_Sup_Sup(A),ord_less_eq(A),P)
         => ( comple7038119648293358887notone(A,A,ord_less_eq(A),ord_less_eq(A),F2)
           => ( pp(aa(A,bool,P,aa(set(A),A,complete_Sup_Sup(A),bot_bot(set(A)))))
             => ( ! [X: A] :
                    ( pp(aa(A,bool,P,X))
                   => pp(aa(A,bool,P,aa(A,A,F2,X))) )
               => pp(aa(A,bool,P,comple115746919287870866o_fixp(A,F2))) ) ) ) ) ) ).

% fixp_induct
tff(fact_6020_let__mono,axiom,
    ! [B: $tType,C: $tType,A: $tType,Orda: fun(B,fun(B,bool)),Ordb: fun(C,fun(C,bool)),B3: fun(B,fun(A,C)),T3: A] :
      ( ! [X: A] : comple7038119648293358887notone(B,C,Orda,Ordb,aa(A,fun(B,C),aTP_Lamp_azt(fun(B,fun(A,C)),fun(A,fun(B,C)),B3),X))
     => comple7038119648293358887notone(B,C,Orda,Ordb,aa(A,fun(B,C),aTP_Lamp_azt(fun(B,fun(A,C)),fun(A,fun(B,C)),B3),T3)) ) ).

% let_mono
tff(fact_6021_if__mono,axiom,
    ! [A: $tType,B: $tType,Orda: fun(A,fun(A,bool)),Ordb: fun(B,fun(B,bool)),F: fun(A,B),G4: fun(A,B),C2: bool] :
      ( comple7038119648293358887notone(A,B,Orda,Ordb,F)
     => ( comple7038119648293358887notone(A,B,Orda,Ordb,G4)
       => comple7038119648293358887notone(A,B,Orda,Ordb,aa(bool,fun(A,B),aa(fun(A,B),fun(bool,fun(A,B)),aTP_Lamp_azu(fun(A,B),fun(fun(A,B),fun(bool,fun(A,B))),F),G4),C2)) ) ) ).

% if_mono
tff(fact_6022_Array__Time_Oset__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A4: array(A),X2: list(A)] : ( array_set(A,A4,X2) = arrays_update(product_unit,aa(list(A),fun(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat)))),aTP_Lamp_azv(array(A),fun(list(A),fun(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat))))),A4),X2)) ) ) ).

% Array_Time.set_def
tff(fact_6023_Ref__Time_Oset__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R2: ref(A),X2: A] : ( ref_set(A,R2,X2) = refs_update(product_unit,aa(A,fun(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat))),aTP_Lamp_azw(ref(A),fun(A,fun(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat)))),R2),X2)) ) ) ).

% Ref_Time.set_def
tff(fact_6024_tailrec_Oconst__mono,axiom,
    ! [B: $tType,A: $tType,Ord: fun(B,fun(B,bool)),C2: A] : comple7038119648293358887notone(B,A,Ord,partial_flat_ord(A,undefined(A)),aa(A,fun(B,A),aTP_Lamp_cy(A,fun(B,A)),C2)) ).

% tailrec.const_mono
tff(fact_6025_dir__image__def,axiom,
    ! [A2: $tType,A: $tType,R2: set(product_prod(A,A)),F2: fun(A,A2)] : ( bNF_We2720479622203943262_image(A,A2,R2,F2) = aa(fun(product_prod(A2,A2),bool),set(product_prod(A2,A2)),collect(product_prod(A2,A2)),aa(fun(A,A2),fun(product_prod(A2,A2),bool),aTP_Lamp_azx(set(product_prod(A,A)),fun(fun(A,A2),fun(product_prod(A2,A2),bool)),R2),F2)) ) ).

% dir_image_def
tff(fact_6026_option_Oconst__mono,axiom,
    ! [B: $tType,A: $tType,Ord: fun(B,fun(B,bool)),C2: option(A)] : comple7038119648293358887notone(B,option(A),Ord,partial_flat_ord(option(A),none(A)),aTP_Lamp_azy(option(A),fun(B,option(A)),C2)) ).

% option.const_mono
tff(fact_6027_heap__step__admissible,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,P: fun(E,fun(A,fun(C,fun(B,fun(D,bool))))),X2: E] : comple1908693960933563346ssible(fun(A,option(product_prod(B,product_prod(C,D)))),partial_fun_lub(option(product_prod(B,product_prod(C,D))),option(product_prod(B,product_prod(C,D))),A,partial_flat_lub(option(product_prod(B,product_prod(C,D))),none(product_prod(B,product_prod(C,D))))),partial_fun_ord(option(product_prod(B,product_prod(C,D))),option(product_prod(B,product_prod(C,D))),A,partial_flat_ord(option(product_prod(B,product_prod(C,D))),none(product_prod(B,product_prod(C,D))))),aa(E,fun(fun(A,option(product_prod(B,product_prod(C,D)))),bool),aTP_Lamp_azz(fun(E,fun(A,fun(C,fun(B,fun(D,bool))))),fun(E,fun(fun(A,option(product_prod(B,product_prod(C,D)))),bool)),P),X2)) ).

% heap_step_admissible
tff(fact_6028_map__mmupd__empty,axiom,
    ! [B: $tType,A: $tType,M2: fun(A,option(B)),V: B] : ( map_mmupd(A,B,M2,bot_bot(set(A)),V) = M2 ) ).

% map_mmupd_empty
tff(fact_6029_option__admissible,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool))] : comple1908693960933563346ssible(fun(A,option(B)),partial_fun_lub(option(B),option(B),A,partial_flat_lub(option(B),none(B))),partial_fun_ord(option(B),option(B),A,partial_flat_ord(option(B),none(B))),aTP_Lamp_baa(fun(A,fun(B,bool)),fun(fun(A,option(B)),bool),P)) ).

% option_admissible
tff(fact_6030_call__mono,axiom,
    ! [B: $tType,A: $tType,Ord: fun(B,fun(B,bool)),T3: A] : comple7038119648293358887notone(fun(A,B),B,partial_fun_ord(B,B,A,Ord),Ord,aTP_Lamp_bab(A,fun(fun(A,B),B),T3)) ).

% call_mono
tff(fact_6031_fun__lub__def,axiom,
    ! [B: $tType,C: $tType,A: $tType,L5: fun(set(C),B),A3: set(fun(A,C)),X4: A] : ( aa(A,B,aa(set(fun(A,C)),fun(A,B),partial_fun_lub(C,B,A,L5),A3),X4) = aa(set(C),B,L5,aa(fun(C,bool),set(C),collect(C),aa(A,fun(C,bool),aTP_Lamp_bac(set(fun(A,C)),fun(A,fun(C,bool)),A3),X4))) ) ).

% fun_lub_def
tff(fact_6032_chain__fun,axiom,
    ! [B: $tType,A: $tType,Ord: fun(B,fun(B,bool)),A3: set(fun(A,B)),A4: A] :
      ( comple1602240252501008431_chain(fun(A,B),partial_fun_ord(B,B,A,Ord),A3)
     => comple1602240252501008431_chain(B,Ord,aa(fun(B,bool),set(B),collect(B),aa(A,fun(B,bool),aTP_Lamp_bad(set(fun(A,B)),fun(A,fun(B,bool)),A3),A4))) ) ).

% chain_fun
tff(fact_6033_tailrec__admissible,axiom,
    ! [B: $tType,A: $tType,C2: B,P: fun(A,fun(B,bool))] : comple1908693960933563346ssible(fun(A,B),partial_fun_lub(B,B,A,partial_flat_lub(B,C2)),partial_fun_ord(B,B,A,partial_flat_ord(B,C2)),aa(fun(A,fun(B,bool)),fun(fun(A,B),bool),aTP_Lamp_bae(B,fun(fun(A,fun(B,bool)),fun(fun(A,B),bool)),C2),P)) ).

% tailrec_admissible
tff(fact_6034_tailrec_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U2: fun(C,fun(B,A)),F: fun(C,C),C3: fun(fun(B,A),C),F2: C,P: fun(fun(B,A),bool)] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,A),A,partial_fun_ord(A,A,B,partial_flat_ord(A,undefined(A))),partial_flat_ord(A,undefined(A)),aa(B,fun(fun(B,A),A),aa(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A))),aTP_Lamp_baf(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)))),U2),F),C3),X))
     => ( ( F2 = aa(fun(B,A),C,C3,comple187402453842119260l_fixp(fun(B,A),partial_fun_lub(A,A,B,partial_flat_lub(A,undefined(A))),partial_fun_ord(A,A,B,partial_flat_ord(A,undefined(A))),aa(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A))),aTP_Lamp_bag(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)))),U2),F),C3))) )
       => ( ! [F9: fun(B,A)] : ( aa(C,fun(B,A),U2,aa(fun(B,A),C,C3,F9)) = F9 )
         => ( comple1908693960933563346ssible(fun(B,A),partial_fun_lub(A,A,B,partial_flat_lub(A,undefined(A))),partial_fun_ord(A,A,B,partial_flat_ord(A,undefined(A))),P)
           => ( pp(aa(fun(B,A),bool,P,aTP_Lamp_awl(B,A)))
             => ( ! [F9: C] :
                    ( pp(aa(fun(B,A),bool,P,aa(C,fun(B,A),U2,F9)))
                   => pp(aa(fun(B,A),bool,P,aa(C,fun(B,A),U2,aa(C,C,F,F9)))) )
               => pp(aa(fun(B,A),bool,P,aa(C,fun(B,A),U2,F2))) ) ) ) ) ) ) ).

% tailrec.fixp_induct_uc
tff(fact_6035_option_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U2: fun(C,fun(B,option(A))),F: fun(C,C),C3: fun(fun(B,option(A)),C),F2: C,P: fun(fun(B,option(A)),bool)] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,option(A)),option(A),partial_fun_ord(option(A),option(A),B,partial_flat_ord(option(A),none(A))),partial_flat_ord(option(A),none(A)),aa(B,fun(fun(B,option(A)),option(A)),aa(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A))),aa(fun(C,C),fun(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A)))),aTP_Lamp_bah(fun(C,fun(B,option(A))),fun(fun(C,C),fun(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A))))),U2),F),C3),X))
     => ( ( F2 = aa(fun(B,option(A)),C,C3,comple187402453842119260l_fixp(fun(B,option(A)),partial_fun_lub(option(A),option(A),B,partial_flat_lub(option(A),none(A))),partial_fun_ord(option(A),option(A),B,partial_flat_ord(option(A),none(A))),aa(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A))),aa(fun(C,C),fun(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A)))),aTP_Lamp_bai(fun(C,fun(B,option(A))),fun(fun(C,C),fun(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A))))),U2),F),C3))) )
       => ( ! [F9: fun(B,option(A))] : ( aa(C,fun(B,option(A)),U2,aa(fun(B,option(A)),C,C3,F9)) = F9 )
         => ( comple1908693960933563346ssible(fun(B,option(A)),partial_fun_lub(option(A),option(A),B,partial_flat_lub(option(A),none(A))),partial_fun_ord(option(A),option(A),B,partial_flat_ord(option(A),none(A))),P)
           => ( pp(aa(fun(B,option(A)),bool,P,aTP_Lamp_acu(B,option(A))))
             => ( ! [F9: C] :
                    ( pp(aa(fun(B,option(A)),bool,P,aa(C,fun(B,option(A)),U2,F9)))
                   => pp(aa(fun(B,option(A)),bool,P,aa(C,fun(B,option(A)),U2,aa(C,C,F,F9)))) )
               => pp(aa(fun(B,option(A)),bool,P,aa(C,fun(B,option(A)),U2,F2))) ) ) ) ) ) ) ).

% option.fixp_induct_uc
tff(fact_6036_fixp__induct__tailrec,axiom,
    ! [C: $tType,B: $tType,A: $tType,C2: A,U2: fun(C,fun(B,A)),F: fun(C,C),C3: fun(fun(B,A),C),F2: C,P: fun(B,fun(A,bool)),X2: B,Y: A] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,A),A,partial_fun_ord(A,A,B,partial_flat_ord(A,C2)),partial_flat_ord(A,C2),aa(B,fun(fun(B,A),A),aa(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A))),aTP_Lamp_baf(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)))),U2),F),C3),X))
     => ( ( F2 = aa(fun(B,A),C,C3,comple187402453842119260l_fixp(fun(B,A),partial_fun_lub(A,A,B,partial_flat_lub(A,C2)),partial_fun_ord(A,A,B,partial_flat_ord(A,C2)),aa(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A))),aTP_Lamp_bag(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)))),U2),F),C3))) )
       => ( ! [F9: fun(B,A)] : ( aa(C,fun(B,A),U2,aa(fun(B,A),C,C3,F9)) = F9 )
         => ( ! [F9: C,X: B,Y2: A] :
                ( ! [Xa3: B,Ya: A] :
                    ( ( aa(B,A,aa(C,fun(B,A),U2,F9),Xa3) = Ya )
                   => ( ( Ya != C2 )
                     => pp(aa(A,bool,aa(B,fun(A,bool),P,Xa3),Ya)) ) )
               => ( ( aa(B,A,aa(C,fun(B,A),U2,aa(C,C,F,F9)),X) = Y2 )
                 => ( ( Y2 != C2 )
                   => pp(aa(A,bool,aa(B,fun(A,bool),P,X),Y2)) ) ) )
           => ( ( aa(B,A,aa(C,fun(B,A),U2,F2),X2) = Y )
             => ( ( Y != C2 )
               => pp(aa(A,bool,aa(B,fun(A,bool),P,X2),Y)) ) ) ) ) ) ) ).

% fixp_induct_tailrec
tff(fact_6037_option_Omono__body__fixp,axiom,
    ! [A: $tType,B: $tType,F: fun(fun(B,option(A)),fun(B,option(A)))] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,option(A)),option(A),partial_fun_ord(option(A),option(A),B,partial_flat_ord(option(A),none(A))),partial_flat_ord(option(A),none(A)),aa(B,fun(fun(B,option(A)),option(A)),aTP_Lamp_baj(fun(fun(B,option(A)),fun(B,option(A))),fun(B,fun(fun(B,option(A)),option(A))),F),X))
     => ( comple187402453842119260l_fixp(fun(B,option(A)),partial_fun_lub(option(A),option(A),B,partial_flat_lub(option(A),none(A))),partial_fun_ord(option(A),option(A),B,partial_flat_ord(option(A),none(A))),F) = aa(fun(B,option(A)),fun(B,option(A)),F,comple187402453842119260l_fixp(fun(B,option(A)),partial_fun_lub(option(A),option(A),B,partial_flat_lub(option(A),none(A))),partial_fun_ord(option(A),option(A),B,partial_flat_ord(option(A),none(A))),F)) ) ) ).

% option.mono_body_fixp
tff(fact_6038_option_Ofixp__rule__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U2: fun(C,fun(B,option(A))),F: fun(C,C),C3: fun(fun(B,option(A)),C),F2: C] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,option(A)),option(A),partial_fun_ord(option(A),option(A),B,partial_flat_ord(option(A),none(A))),partial_flat_ord(option(A),none(A)),aa(B,fun(fun(B,option(A)),option(A)),aa(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A))),aa(fun(C,C),fun(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A)))),aTP_Lamp_bah(fun(C,fun(B,option(A))),fun(fun(C,C),fun(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A))))),U2),F),C3),X))
     => ( ( F2 = aa(fun(B,option(A)),C,C3,comple187402453842119260l_fixp(fun(B,option(A)),partial_fun_lub(option(A),option(A),B,partial_flat_lub(option(A),none(A))),partial_fun_ord(option(A),option(A),B,partial_flat_ord(option(A),none(A))),aa(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A))),aa(fun(C,C),fun(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A)))),aTP_Lamp_bai(fun(C,fun(B,option(A))),fun(fun(C,C),fun(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A))))),U2),F),C3))) )
       => ( ! [F9: C] : ( aa(fun(B,option(A)),C,C3,aa(C,fun(B,option(A)),U2,F9)) = F9 )
         => ( F2 = aa(C,C,F,F2) ) ) ) ) ).

% option.fixp_rule_uc
tff(fact_6039_tailrec_Omono__body__fixp,axiom,
    ! [A: $tType,B: $tType,F: fun(fun(B,A),fun(B,A))] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,A),A,partial_fun_ord(A,A,B,partial_flat_ord(A,undefined(A))),partial_flat_ord(A,undefined(A)),aa(B,fun(fun(B,A),A),aTP_Lamp_bak(fun(fun(B,A),fun(B,A)),fun(B,fun(fun(B,A),A)),F),X))
     => ( comple187402453842119260l_fixp(fun(B,A),partial_fun_lub(A,A,B,partial_flat_lub(A,undefined(A))),partial_fun_ord(A,A,B,partial_flat_ord(A,undefined(A))),F) = aa(fun(B,A),fun(B,A),F,comple187402453842119260l_fixp(fun(B,A),partial_fun_lub(A,A,B,partial_flat_lub(A,undefined(A))),partial_fun_ord(A,A,B,partial_flat_ord(A,undefined(A))),F)) ) ) ).

% tailrec.mono_body_fixp
tff(fact_6040_tailrec_Ofixp__rule__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U2: fun(C,fun(B,A)),F: fun(C,C),C3: fun(fun(B,A),C),F2: C] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,A),A,partial_fun_ord(A,A,B,partial_flat_ord(A,undefined(A))),partial_flat_ord(A,undefined(A)),aa(B,fun(fun(B,A),A),aa(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A))),aTP_Lamp_baf(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)))),U2),F),C3),X))
     => ( ( F2 = aa(fun(B,A),C,C3,comple187402453842119260l_fixp(fun(B,A),partial_fun_lub(A,A,B,partial_flat_lub(A,undefined(A))),partial_fun_ord(A,A,B,partial_flat_ord(A,undefined(A))),aa(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A))),aTP_Lamp_bag(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)))),U2),F),C3))) )
       => ( ! [F9: C] : ( aa(fun(B,A),C,C3,aa(C,fun(B,A),U2,F9)) = F9 )
         => ( F2 = aa(C,C,F,F2) ) ) ) ) ).

% tailrec.fixp_rule_uc
tff(fact_6041_fixp__induct__option,axiom,
    ! [C: $tType,B: $tType,A: $tType,U2: fun(C,fun(B,option(A))),F: fun(C,C),C3: fun(fun(B,option(A)),C),F2: C,P: fun(B,fun(A,bool)),X2: B,Y: A] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,option(A)),option(A),partial_fun_ord(option(A),option(A),B,partial_flat_ord(option(A),none(A))),partial_flat_ord(option(A),none(A)),aa(B,fun(fun(B,option(A)),option(A)),aa(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A))),aa(fun(C,C),fun(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A)))),aTP_Lamp_bah(fun(C,fun(B,option(A))),fun(fun(C,C),fun(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A))))),U2),F),C3),X))
     => ( ( F2 = aa(fun(B,option(A)),C,C3,comple187402453842119260l_fixp(fun(B,option(A)),partial_fun_lub(option(A),option(A),B,partial_flat_lub(option(A),none(A))),partial_fun_ord(option(A),option(A),B,partial_flat_ord(option(A),none(A))),aa(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A))),aa(fun(C,C),fun(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A)))),aTP_Lamp_bai(fun(C,fun(B,option(A))),fun(fun(C,C),fun(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A))))),U2),F),C3))) )
       => ( ! [F9: fun(B,option(A))] : ( aa(C,fun(B,option(A)),U2,aa(fun(B,option(A)),C,C3,F9)) = F9 )
         => ( ! [F9: C,X: B,Y2: A] :
                ( ! [Xa3: B,Ya: A] :
                    ( ( aa(B,option(A),aa(C,fun(B,option(A)),U2,F9),Xa3) = aa(A,option(A),some(A),Ya) )
                   => pp(aa(A,bool,aa(B,fun(A,bool),P,Xa3),Ya)) )
               => ( ( aa(B,option(A),aa(C,fun(B,option(A)),U2,aa(C,C,F,F9)),X) = aa(A,option(A),some(A),Y2) )
                 => pp(aa(A,bool,aa(B,fun(A,bool),P,X),Y2)) ) )
           => ( ( aa(B,option(A),aa(C,fun(B,option(A)),U2,F2),X2) = aa(A,option(A),some(A),Y) )
             => pp(aa(A,bool,aa(B,fun(A,bool),P,X2),Y)) ) ) ) ) ) ).

% fixp_induct_option
tff(fact_6042_partial__function__definitions_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Leq: fun(A,fun(A,bool)),Lub: fun(set(A),A),U2: fun(C,fun(B,A)),F: fun(C,C),C3: fun(fun(B,A),C),F2: C,P: fun(fun(B,A),bool)] :
      ( partia7178651479351089652itions(A,Leq,Lub)
     => ( ! [X: B] : comple7038119648293358887notone(fun(B,A),A,partial_fun_ord(A,A,B,Leq),Leq,aa(B,fun(fun(B,A),A),aa(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A))),aTP_Lamp_baf(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)))),U2),F),C3),X))
       => ( ( F2 = aa(fun(B,A),C,C3,comple187402453842119260l_fixp(fun(B,A),partial_fun_lub(A,A,B,Lub),partial_fun_ord(A,A,B,Leq),aa(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A))),aTP_Lamp_bag(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)))),U2),F),C3))) )
         => ( ! [F9: fun(B,A)] : ( aa(C,fun(B,A),U2,aa(fun(B,A),C,C3,F9)) = F9 )
           => ( comple1908693960933563346ssible(fun(B,A),partial_fun_lub(A,A,B,Lub),partial_fun_ord(A,A,B,Leq),P)
             => ( pp(aa(fun(B,A),bool,P,aTP_Lamp_bal(fun(set(A),A),fun(B,A),Lub)))
               => ( ! [F9: C] :
                      ( pp(aa(fun(B,A),bool,P,aa(C,fun(B,A),U2,F9)))
                     => pp(aa(fun(B,A),bool,P,aa(C,fun(B,A),U2,aa(C,C,F,F9)))) )
                 => pp(aa(fun(B,A),bool,P,aa(C,fun(B,A),U2,F2))) ) ) ) ) ) ) ) ).

% partial_function_definitions.fixp_induct_uc
tff(fact_6043_admissible__fun,axiom,
    ! [A: $tType,B: $tType,Le: fun(A,fun(A,bool)),Lub: fun(set(A),A),Q: fun(B,fun(A,bool))] :
      ( partia7178651479351089652itions(A,Le,Lub)
     => ( ! [X: B] : comple1908693960933563346ssible(A,Lub,Le,aa(B,fun(A,bool),Q,X))
       => comple1908693960933563346ssible(fun(B,A),partial_fun_lub(A,A,B,Lub),partial_fun_ord(A,A,B,Le),aTP_Lamp_bam(fun(B,fun(A,bool)),fun(fun(B,A),bool),Q)) ) ) ).

% admissible_fun
tff(fact_6044_partial__function__definitions_Oconst__mono,axiom,
    ! [B: $tType,A: $tType,Leq: fun(A,fun(A,bool)),Lub: fun(set(A),A),Ord: fun(B,fun(B,bool)),C2: A] :
      ( partia7178651479351089652itions(A,Leq,Lub)
     => comple7038119648293358887notone(B,A,Ord,Leq,aa(A,fun(B,A),aTP_Lamp_cy(A,fun(B,A)),C2)) ) ).

% partial_function_definitions.const_mono
tff(fact_6045_partial__function__definitions_Ofixp__rule__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Leq: fun(A,fun(A,bool)),Lub: fun(set(A),A),U2: fun(C,fun(B,A)),F: fun(C,C),C3: fun(fun(B,A),C),F2: C] :
      ( partia7178651479351089652itions(A,Leq,Lub)
     => ( ! [X: B] : comple7038119648293358887notone(fun(B,A),A,partial_fun_ord(A,A,B,Leq),Leq,aa(B,fun(fun(B,A),A),aa(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A))),aTP_Lamp_baf(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)))),U2),F),C3),X))
       => ( ( F2 = aa(fun(B,A),C,C3,comple187402453842119260l_fixp(fun(B,A),partial_fun_lub(A,A,B,Lub),partial_fun_ord(A,A,B,Leq),aa(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A))),aTP_Lamp_bag(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)))),U2),F),C3))) )
         => ( ! [F9: C] : ( aa(fun(B,A),C,C3,aa(C,fun(B,A),U2,F9)) = F9 )
           => ( F2 = aa(C,C,F,F2) ) ) ) ) ) ).

% partial_function_definitions.fixp_rule_uc
tff(fact_6046_partial__function__definitions_Omono__body__fixp,axiom,
    ! [A: $tType,B: $tType,Leq: fun(A,fun(A,bool)),Lub: fun(set(A),A),F: fun(fun(B,A),fun(B,A))] :
      ( partia7178651479351089652itions(A,Leq,Lub)
     => ( ! [X: B] : comple7038119648293358887notone(fun(B,A),A,partial_fun_ord(A,A,B,Leq),Leq,aa(B,fun(fun(B,A),A),aTP_Lamp_bak(fun(fun(B,A),fun(B,A)),fun(B,fun(fun(B,A),A)),F),X))
       => ( comple187402453842119260l_fixp(fun(B,A),partial_fun_lub(A,A,B,Lub),partial_fun_ord(A,A,B,Leq),F) = aa(fun(B,A),fun(B,A),F,comple187402453842119260l_fixp(fun(B,A),partial_fun_lub(A,A,B,Lub),partial_fun_ord(A,A,B,Leq),F)) ) ) ) ).

% partial_function_definitions.mono_body_fixp
tff(fact_6047_Partial__Function_Obind__mono,axiom,
    ! [D: $tType,B: $tType,A: $tType,C: $tType,B2: fun(fun(A,option(B)),option(C)),C3: fun(C,fun(fun(A,option(B)),option(D)))] :
      ( comple7038119648293358887notone(fun(A,option(B)),option(C),partial_fun_ord(option(B),option(B),A,partial_flat_ord(option(B),none(B))),partial_flat_ord(option(C),none(C)),B2)
     => ( ! [Y2: C] : comple7038119648293358887notone(fun(A,option(B)),option(D),partial_fun_ord(option(B),option(B),A,partial_flat_ord(option(B),none(B))),partial_flat_ord(option(D),none(D)),aa(C,fun(fun(A,option(B)),option(D)),C3,Y2))
       => comple7038119648293358887notone(fun(A,option(B)),option(D),partial_fun_ord(option(B),option(B),A,partial_flat_ord(option(B),none(B))),partial_flat_ord(option(D),none(D)),aa(fun(C,fun(fun(A,option(B)),option(D))),fun(fun(A,option(B)),option(D)),aTP_Lamp_bao(fun(fun(A,option(B)),option(C)),fun(fun(C,fun(fun(A,option(B)),option(D))),fun(fun(A,option(B)),option(D))),B2),C3)) ) ) ).

% Partial_Function.bind_mono
tff(fact_6048_heap_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U2: fun(C,fun(B,heap_Time_Heap(A))),F: fun(C,C),C3: fun(fun(B,heap_Time_Heap(A)),C),F2: C,P: fun(fun(B,heap_Time_Heap(A)),bool)] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),heap_Time_Heap_ord(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)))),aTP_Lamp_bap(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))))),U2),F),C3),X))
     => ( ( F2 = aa(fun(B,heap_Time_Heap(A)),C,C3,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)))),aTP_Lamp_baq(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))))),U2),F),C3))) )
       => ( ! [F9: fun(B,heap_Time_Heap(A))] : ( aa(C,fun(B,heap_Time_Heap(A)),U2,aa(fun(B,heap_Time_Heap(A)),C,C3,F9)) = F9 )
         => ( comple1908693960933563346ssible(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),P)
           => ( pp(aa(fun(B,heap_Time_Heap(A)),bool,P,aTP_Lamp_bar(B,heap_Time_Heap(A))))
             => ( ! [F9: C] :
                    ( pp(aa(fun(B,heap_Time_Heap(A)),bool,P,aa(C,fun(B,heap_Time_Heap(A)),U2,F9)))
                   => pp(aa(fun(B,heap_Time_Heap(A)),bool,P,aa(C,fun(B,heap_Time_Heap(A)),U2,aa(C,C,F,F9)))) )
               => pp(aa(fun(B,heap_Time_Heap(A)),bool,P,aa(C,fun(B,heap_Time_Heap(A)),U2,F2))) ) ) ) ) ) ) ).

% heap.fixp_induct_uc
tff(fact_6049_bind__assoc,axiom,
    ! [C: $tType,A: $tType,B: $tType,X2: option(C),F2: fun(C,option(B)),G: fun(B,option(A))] : ( bind2(B,A,bind2(C,B,X2,F2),G) = bind2(C,A,X2,aa(fun(B,option(A)),fun(C,option(A)),aTP_Lamp_bas(fun(C,option(B)),fun(fun(B,option(A)),fun(C,option(A))),F2),G)) ) ).

% bind_assoc
tff(fact_6050_bind__rzero,axiom,
    ! [B: $tType,A: $tType,X2: option(B)] : ( bind2(B,A,X2,aTP_Lamp_acu(B,option(A))) = none(A) ) ).

% bind_rzero
tff(fact_6051_heap_Oconst__mono,axiom,
    ! [B: $tType,A: $tType,Ord: fun(B,fun(B,bool)),C2: heap_Time_Heap(A)] : comple7038119648293358887notone(B,heap_Time_Heap(A),Ord,heap_Time_Heap_ord(A),aTP_Lamp_bat(heap_Time_Heap(A),fun(B,heap_Time_Heap(A)),C2)) ).

% heap.const_mono
tff(fact_6052_heap_Omono__body__fixp,axiom,
    ! [A: $tType,B: $tType,F: fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)))] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),heap_Time_Heap_ord(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aTP_Lamp_bau(fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),F),X))
     => ( comple187402453842119260l_fixp(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),F) = aa(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)),F,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),F)) ) ) ).

% heap.mono_body_fixp
tff(fact_6053_heap_Ofixp__rule__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U2: fun(C,fun(B,heap_Time_Heap(A))),F: fun(C,C),C3: fun(fun(B,heap_Time_Heap(A)),C),F2: C] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),heap_Time_Heap_ord(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)))),aTP_Lamp_bap(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))))),U2),F),C3),X))
     => ( ( F2 = aa(fun(B,heap_Time_Heap(A)),C,C3,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)))),aTP_Lamp_baq(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))))),U2),F),C3))) )
       => ( ! [F9: C] : ( aa(fun(B,heap_Time_Heap(A)),C,C3,aa(C,fun(B,heap_Time_Heap(A)),U2,F9)) = F9 )
         => ( F2 = aa(C,C,F,F2) ) ) ) ) ).

% heap.fixp_rule_uc
tff(fact_6054_Heap__Time__Monad_Obind__mono,axiom,
    ! [D: $tType,B: $tType,A: $tType,C: $tType,B2: fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C)),C3: fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D)))] :
      ( comple7038119648293358887notone(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C),partial_fun_ord(heap_Time_Heap(B),heap_Time_Heap(B),A,heap_Time_Heap_ord(B)),heap_Time_Heap_ord(C),B2)
     => ( ! [Y2: C] : comple7038119648293358887notone(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D),partial_fun_ord(heap_Time_Heap(B),heap_Time_Heap(B),A,heap_Time_Heap_ord(B)),heap_Time_Heap_ord(D),aa(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D)),C3,Y2))
       => comple7038119648293358887notone(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D),partial_fun_ord(heap_Time_Heap(B),heap_Time_Heap(B),A,heap_Time_Heap_ord(B)),heap_Time_Heap_ord(D),aa(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D)),aTP_Lamp_baw(fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C)),fun(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),B2),C3)) ) ) ).

% Heap_Time_Monad.bind_mono
tff(fact_6055_fixp__induct__heap,axiom,
    ! [C: $tType,A: $tType,B: $tType,U2: fun(C,fun(B,heap_Time_Heap(A))),F: fun(C,C),C3: fun(fun(B,heap_Time_Heap(A)),C),F2: C,P: fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool))))),X2: B,H2: heap_ext(product_unit),H5: heap_ext(product_unit),R2: A,N: nat] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),heap_Time_Heap_ord(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)))),aTP_Lamp_bap(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))))),U2),F),C3),X))
     => ( ( F2 = aa(fun(B,heap_Time_Heap(A)),C,C3,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)))),aTP_Lamp_baq(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))))),U2),F),C3))) )
       => ( ! [F9: fun(B,heap_Time_Heap(A))] : ( aa(C,fun(B,heap_Time_Heap(A)),U2,aa(fun(B,heap_Time_Heap(A)),C,C3,F9)) = F9 )
         => ( ! [F9: C,X: B,H4: heap_ext(product_unit),H3: heap_ext(product_unit),R3: A,N2: nat] :
                ( ! [Xa3: B,Ha: heap_ext(product_unit),H_a: heap_ext(product_unit),Ra3: A,Na: nat] :
                    ( heap_Time_effect(A,aa(B,heap_Time_Heap(A),aa(C,fun(B,heap_Time_Heap(A)),U2,F9),Xa3),Ha,H_a,Ra3,Na)
                   => pp(aa(nat,bool,aa(A,fun(nat,bool),aa(heap_ext(product_unit),fun(A,fun(nat,bool)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool)))),P,Xa3),Ha),H_a),Ra3),Na)) )
               => ( heap_Time_effect(A,aa(B,heap_Time_Heap(A),aa(C,fun(B,heap_Time_Heap(A)),U2,aa(C,C,F,F9)),X),H4,H3,R3,N2)
                 => pp(aa(nat,bool,aa(A,fun(nat,bool),aa(heap_ext(product_unit),fun(A,fun(nat,bool)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool)))),P,X),H4),H3),R3),N2)) ) )
           => ( heap_Time_effect(A,aa(B,heap_Time_Heap(A),aa(C,fun(B,heap_Time_Heap(A)),U2,F2),X2),H2,H5,R2,N)
             => pp(aa(nat,bool,aa(A,fun(nat,bool),aa(heap_ext(product_unit),fun(A,fun(nat,bool)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool)))),P,X2),H2),H5),R2),N)) ) ) ) ) ) ).

% fixp_induct_heap
tff(fact_6056_admissible__heap,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool)))))] : comple1908693960933563346ssible(fun(A,heap_Time_Heap(B)),partial_fun_lub(heap_Time_Heap(B),heap_Time_Heap(B),A,heap_Time_Heap_lub(B)),partial_fun_ord(heap_Time_Heap(B),heap_Time_Heap(B),A,heap_Time_Heap_ord(B)),aTP_Lamp_bax(fun(A,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool))))),fun(fun(A,heap_Time_Heap(B)),bool),P)) ).

% admissible_heap
tff(fact_6057_sum__set__upto__conv__sum__list__int,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(int,A),I2: int,J2: int] : ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups7311177749621191930dd_sum(int,A),F2),aa(list(int),set(int),set2(int),upto(I2,J2))) = aa(list(A),A,groups8242544230860333062m_list(A),aa(list(int),list(A),map(int,A,F2),upto(I2,J2))) ) ) ).

% sum_set_upto_conv_sum_list_int
tff(fact_6058_interv__sum__list__conv__sum__set__int,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [F2: fun(int,B),K: int,L: int] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(int),list(B),map(int,B,F2),upto(K,L))) = aa(set(int),B,aa(fun(int,B),fun(set(int),B),groups7311177749621191930dd_sum(int,B),F2),aa(list(int),set(int),set2(int),upto(K,L))) ) ) ).

% interv_sum_list_conv_sum_set_int
tff(fact_6059_sort__upto,axiom,
    ! [I2: int,J2: int] : ( aa(list(int),list(int),linorder_sort_key(int,int,aTP_Lamp_ry(int,int)),upto(I2,J2)) = upto(I2,J2) ) ).

% sort_upto
tff(fact_6060_card_Ofolding__axioms,axiom,
    ! [A: $tType] : finite_folding(A,nat,aTP_Lamp_sv(A,fun(nat,nat))) ).

% card.folding_axioms
tff(fact_6061_sum_Odisc__eq__case_I1_J,axiom,
    ! [B: $tType,A: $tType,Sum: sum_sum(A,B)] :
      ( sum_isl(A,B,Sum)
    <=> pp(aa(sum_sum(A,B),bool,sum_case_sum(A,bool,B,aTP_Lamp_nn(A,bool),aTP_Lamp_ave(B,bool)),Sum)) ) ).

% sum.disc_eq_case(1)
tff(fact_6062_sum_Odisc__eq__case_I2_J,axiom,
    ! [B: $tType,A: $tType,Sum: sum_sum(A,B)] :
      ( ~ sum_isl(A,B,Sum)
    <=> pp(aa(sum_sum(A,B),bool,sum_case_sum(A,bool,B,aTP_Lamp_ao(A,bool),aTP_Lamp_aqx(B,bool)),Sum)) ) ).

% sum.disc_eq_case(2)
tff(fact_6063_scomp__fcomp,axiom,
    ! [A: $tType,D: $tType,E: $tType,B: $tType,C: $tType,F2: fun(A,product_prod(D,E)),G: fun(D,fun(E,C)),H2: fun(C,B)] : ( fcomp(A,C,B,product_scomp(A,D,E,C,F2,G),H2) = product_scomp(A,D,E,B,F2,aa(fun(C,B),fun(D,fun(E,B)),aTP_Lamp_bay(fun(D,fun(E,C)),fun(fun(C,B),fun(D,fun(E,B))),G),H2)) ) ).

% scomp_fcomp
tff(fact_6064_bot__in__iterates,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [F2: fun(A,A)] : pp(aa(set(A),bool,member(A,aa(set(A),A,complete_Sup_Sup(A),bot_bot(set(A)))),comple6359979572994053840erates(A,F2))) ) ).

% bot_in_iterates
tff(fact_6065_iterates__def,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [X4: fun(A,A)] : ( comple6359979572994053840erates(A,X4) = aa(fun(A,bool),set(A),collect(A),comple7512665784863727008ratesp(A,X4)) ) ) ).

% iterates_def
tff(fact_6066_sym__Int__converse,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : sym(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),converse(A,A,R2))) ).

% sym_Int_converse
tff(fact_6067_Heap_Oempty__def,axiom,
    empty = heap_ext2(product_unit,aTP_Lamp_baz(typerep,fun(nat,list(nat))),aTP_Lamp_bba(typerep,fun(nat,nat)),zero_zero(nat),product_Unity) ).

% Heap.empty_def
tff(fact_6068_sym__Int,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( sym(A,R2)
     => ( sym(A,S2)
       => sym(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R2),S2)) ) ) ).

% sym_Int
tff(fact_6069_array_Oset,axiom,
    ! [A: $tType,X2: nat] : ( set_array(A,array2(A,X2)) = bot_bot(set(A)) ) ).

% array.set
tff(fact_6070_ref_Oset,axiom,
    ! [A: $tType,X2: nat] : ( set_ref(A,ref2(A,X2)) = bot_bot(set(A)) ) ).

% ref.set
tff(fact_6071_Quotient3__to__Quotient__equivp,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(A,bool)),Abs: fun(A,B),Rep: fun(B,A),T2: fun(A,fun(B,bool))] :
      ( quotient3(A,B,R,Abs,Rep)
     => ( ! [X: A] : ( aa(A,fun(B,bool),T2,X) = aa(B,fun(B,bool),fequal(B),aa(A,B,Abs,X)) )
       => ( equiv_equivp(A,R)
         => quotient(A,B,R,Abs,Rep,T2) ) ) ) ).

% Quotient3_to_Quotient_equivp
tff(fact_6072_quot__type_Osome__collect,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(A,bool)),Abs: fun(set(A),B),Rep: fun(B,set(A)),R2: A] :
      ( quot_type(A,B,R,Abs,Rep)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),R,R2),R2))
       => ( aa(A,fun(A,bool),R,fChoice(A,aa(A,fun(A,bool),aTP_Lamp_bbb(fun(A,fun(A,bool)),fun(A,fun(A,bool)),R),R2))) = aa(A,fun(A,bool),R,R2) ) ) ) ).

% quot_type.some_collect
tff(fact_6073_lambda__prs1,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: fun(A,fun(A,bool)),Abs1: fun(A,B),Rep1: fun(B,A),R22: fun(C,fun(C,bool)),Abs2: fun(C,D),Rep2: fun(D,C),F2: fun(B,D)] :
      ( quotient3(A,B,R1,Abs1,Rep1)
     => ( quotient3(C,D,R22,Abs2,Rep2)
       => ( aa(fun(A,C),fun(B,D),map_fun(B,A,C,D,Rep1,Abs2),aa(fun(B,D),fun(A,C),map_fun(A,B,D,C,Abs1,Rep2),F2)) = F2 ) ) ) ).

% lambda_prs1
tff(fact_6074_lambda__prs,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: fun(A,fun(A,bool)),Abs1: fun(A,B),Rep1: fun(B,A),R22: fun(C,fun(C,bool)),Abs2: fun(C,D),Rep2: fun(D,C),F2: fun(B,D)] :
      ( quotient3(A,B,R1,Abs1,Rep1)
     => ( quotient3(C,D,R22,Abs2,Rep2)
       => ( aa(fun(A,C),fun(B,D),map_fun(B,A,C,D,Rep1,Abs2),aa(fun(B,D),fun(A,C),aa(fun(D,C),fun(fun(B,D),fun(A,C)),aTP_Lamp_bbc(fun(A,B),fun(fun(D,C),fun(fun(B,D),fun(A,C))),Abs1),Rep2),F2)) = F2 ) ) ) ).

% lambda_prs
tff(fact_6075_Quotient3__to__Quotient,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(A,bool)),Abs: fun(A,B),Rep: fun(B,A),T2: fun(A,fun(B,bool))] :
      ( quotient3(A,B,R,Abs,Rep)
     => ( ! [X: A,Xa4: B] :
            ( pp(aa(B,bool,aa(A,fun(B,bool),T2,X),Xa4))
          <=> ( pp(aa(A,bool,aa(A,fun(A,bool),R,X),X))
              & ( aa(A,B,Abs,X) = Xa4 ) ) )
       => quotient(A,B,R,Abs,Rep,T2) ) ) ).

% Quotient3_to_Quotient
tff(fact_6076_quot__type_Orep__def,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(A,bool)),Abs: fun(set(A),B),Rep: fun(B,set(A)),A4: B] :
      ( quot_type(A,B,R,Abs,Rep)
     => ( quot_rep(B,A,Rep,A4) = fChoice(A,aa(B,fun(A,bool),aTP_Lamp_hk(fun(B,set(A)),fun(B,fun(A,bool)),Rep),A4)) ) ) ).

% quot_type.rep_def
tff(fact_6077_toCard__def,axiom,
    ! [A: $tType,B: $tType,A3: set(A),R2: set(product_prod(B,B))] : ( bNF_Greatest_toCard(A,B,A3,R2) = fChoice(fun(A,B),bNF_Gr1419584066657907630d_pred(A,B,A3,R2)) ) ).

% toCard_def
tff(fact_6078_fromCard__def,axiom,
    ! [A: $tType,B: $tType,A3: set(A),R2: set(product_prod(B,B)),K: B] : ( bNF_Gr5436034075474128252omCard(A,B,A3,R2,K) = fChoice(A,aa(B,fun(A,bool),aa(set(product_prod(B,B)),fun(B,fun(A,bool)),aTP_Lamp_bbd(set(A),fun(set(product_prod(B,B)),fun(B,fun(A,bool))),A3),R2),K)) ) ).

% fromCard_def
tff(fact_6079_symp__sym__eq,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( symp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2))
    <=> sym(A,R2) ) ).

% symp_sym_eq
tff(fact_6080_symp__inf,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),S2: fun(A,fun(A,bool))] :
      ( symp(A,R2)
     => ( symp(A,S2)
       => symp(A,aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),inf_inf(fun(A,fun(A,bool))),R2),S2)) ) ) ).

% symp_inf
tff(fact_6081_select__def,axiom,
    ! [A: $tType,Xs: list(A)] : ( select(A,Xs) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)),range(code_natural_of_nat(aa(list(A),nat,size_size(list(A)),Xs))),aTP_Lamp_bbe(list(A),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)))),Xs)) ) ).

% select_def
tff(fact_6082_subset__mset_Oarg__max__def,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,multiset(A)),P: fun(B,bool)] : ( lattices_arg_max(multiset(A),B,subset_mset(A),F2,P) = fChoice(B,lattices_is_arg_max(multiset(A),B,subset_mset(A),F2,P)) ) ).

% subset_mset.arg_max_def
tff(fact_6083_ord_Oarg__max__def,axiom,
    ! [A: $tType,B: $tType,Less: fun(A,fun(A,bool)),F2: fun(B,A),P: fun(B,bool)] : ( lattices_arg_max(A,B,Less,F2,P) = fChoice(B,lattices_is_arg_max(A,B,Less,F2,P)) ) ).

% ord.arg_max_def
tff(fact_6084_subset__mset_Oarg__max__on__def,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,multiset(A)),S: set(B)] : ( lattices_arg_max_on(multiset(A),B,subset_mset(A),F2,S) = lattices_arg_max(multiset(A),B,subset_mset(A),F2,aTP_Lamp_ni(set(B),fun(B,bool),S)) ) ).

% subset_mset.arg_max_on_def
tff(fact_6085_ord_Oarg__max__on__def,axiom,
    ! [A: $tType,B: $tType,Less: fun(A,fun(A,bool)),F2: fun(B,A),S: set(B)] : ( lattices_arg_max_on(A,B,Less,F2,S) = lattices_arg_max(A,B,Less,F2,aTP_Lamp_ni(set(B),fun(B,bool),S)) ) ).

% ord.arg_max_on_def
tff(fact_6086_cr__natural__def,axiom,
    ! [X4: nat,Xa3: code_natural] :
      ( code_cr_natural(X4,Xa3)
    <=> ( X4 = code_nat_of_natural(Xa3) ) ) ).

% cr_natural_def
tff(fact_6087_subset__mset_Oarg__min__def,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,multiset(A)),P: fun(B,bool)] : ( lattices_arg_min(multiset(A),B,subset_mset(A),F2,P) = fChoice(B,lattices_is_arg_min(multiset(A),B,subset_mset(A),F2,P)) ) ).

% subset_mset.arg_min_def
tff(fact_6088_ord_Oarg__min__def,axiom,
    ! [A: $tType,B: $tType,Less: fun(A,fun(A,bool)),F2: fun(B,A),P: fun(B,bool)] : ( lattices_arg_min(A,B,Less,F2,P) = fChoice(B,lattices_is_arg_min(A,B,Less,F2,P)) ) ).

% ord.arg_min_def
tff(fact_6089_subset__mset_Oarg__min__on__def,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,multiset(A)),S: set(B)] : ( lattices_arg_min_on(multiset(A),B,subset_mset(A),F2,S) = lattices_arg_min(multiset(A),B,subset_mset(A),F2,aTP_Lamp_ni(set(B),fun(B,bool),S)) ) ).

% subset_mset.arg_min_on_def
tff(fact_6090_ord_Oarg__min__on__def,axiom,
    ! [A: $tType,B: $tType,Less: fun(A,fun(A,bool)),F2: fun(B,A),S: set(B)] : ( lattices_arg_min_on(A,B,Less,F2,S) = lattices_arg_min(A,B,Less,F2,aTP_Lamp_ni(set(B),fun(B,bool),S)) ) ).

% ord.arg_min_on_def
tff(fact_6091_Nitpick_OEx1__unfold,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ? [X3: A] :
          ( pp(aa(A,bool,P,X3))
          & ! [Y4: A] :
              ( pp(aa(A,bool,P,Y4))
             => ( Y4 = X3 ) ) )
    <=> ? [X3: A] : ( aa(fun(A,bool),set(A),collect(A),P) = aa(set(A),set(A),insert(A,X3),bot_bot(set(A))) ) ) ).

% Nitpick.Ex1_unfold
tff(fact_6092_transp__trans,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool))] :
      ( transp(A,R2)
    <=> trans(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2))) ) ).

% transp_trans
tff(fact_6093_transp__ge,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => transp(A,aTP_Lamp_ava(A,fun(A,bool))) ) ).

% transp_ge
tff(fact_6094_transp__inf,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),S2: fun(A,fun(A,bool))] :
      ( transp(A,R2)
     => ( transp(A,S2)
       => transp(A,aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),inf_inf(fun(A,fun(A,bool))),R2),S2)) ) ) ).

% transp_inf
tff(fact_6095_transp__empty,axiom,
    ! [A: $tType] : transp(A,aTP_Lamp_aqw(A,fun(A,bool))) ).

% transp_empty
tff(fact_6096_transp__singleton,axiom,
    ! [A: $tType,A4: A] : transp(A,aTP_Lamp_bbf(A,fun(A,fun(A,bool)),A4)) ).

% transp_singleton
tff(fact_6097_subset__mset_Otransp__ge,axiom,
    ! [A: $tType] : transp(multiset(A),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool))) ).

% subset_mset.transp_ge
tff(fact_6098_subset__mset_Otransp__gr,axiom,
    ! [A: $tType] : transp(multiset(A),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool))) ).

% subset_mset.transp_gr
tff(fact_6099_transp__gr,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => transp(A,aTP_Lamp_aad(A,fun(A,bool))) ) ).

% transp_gr
tff(fact_6100_transp__trans__eq,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( transp(A,aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),R2))
    <=> trans(A,R2) ) ).

% transp_trans_eq
tff(fact_6101_irreflp__multp,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool))] :
      ( transp(A,R2)
     => ( irreflp(A,R2)
       => irreflp(multiset(A),multp(A,R2)) ) ) ).

% irreflp_multp
tff(fact_6102_multp__cancel__max,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),X5: multiset(A),Y3: multiset(A)] :
      ( transp(A,R2)
     => ( irreflp(A,R2)
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),multp(A,R2),X5),Y3))
        <=> pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),multp(A,R2),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),X5),Y3)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),Y3),X5))) ) ) ) ).

% multp_cancel_max
tff(fact_6103_multp__cancel__add__mset,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),Uu: A,X5: multiset(A),Y3: multiset(A)] :
      ( transp(A,R2)
     => ( irreflp(A,R2)
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),multp(A,R2),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),Uu),X5)),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),Uu),Y3)))
        <=> pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),multp(A,R2),X5),Y3)) ) ) ) ).

% multp_cancel_add_mset
tff(fact_6104_multp__cancel,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),X5: multiset(A),Z4: multiset(A),Y3: multiset(A)] :
      ( transp(A,R2)
     => ( irreflp(A,R2)
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),multp(A,R2),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),X5),Z4)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),Y3),Z4)))
        <=> pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),multp(A,R2),X5),Y3)) ) ) ) ).

% multp_cancel
tff(fact_6105_multp__def,axiom,
    ! [A: $tType,R2: fun(A,fun(A,bool)),M: multiset(A),N4: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),multp(A,R2),M),N4))
    <=> pp(aa(set(product_prod(multiset(A),multiset(A))),bool,member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),M),N4)),mult(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R2))))) ) ).

% multp_def
tff(fact_6106_THE__default__def,axiom,
    ! [A: $tType,P: fun(A,bool),D3: A] :
      ( ( ? [X4: A] :
            ( pp(aa(A,bool,P,X4))
            & ! [Y2: A] :
                ( pp(aa(A,bool,P,Y2))
               => ( Y2 = X4 ) ) )
       => ( fun_THE_default(A,D3,P) = the(A,P) ) )
      & ( ~ ? [X: A] :
              ( pp(aa(A,bool,P,X))
              & ! [Y5: A] :
                  ( pp(aa(A,bool,P,Y5))
                 => ( Y5 = X ) ) )
       => ( fun_THE_default(A,D3,P) = D3 ) ) ) ).

% THE_default_def
tff(fact_6107_fundef__ex1__uniqueness,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),D3: fun(A,B),G4: fun(A,fun(B,bool)),X2: A,H2: fun(A,B)] :
      ( ! [X: A] : ( aa(A,B,F2,X) = fun_THE_default(B,aa(A,B,D3,X),aa(A,fun(B,bool),G4,X)) )
     => ( ? [X4: B] :
            ( pp(aa(B,bool,aa(A,fun(B,bool),G4,X2),X4))
            & ! [Y2: B] :
                ( pp(aa(B,bool,aa(A,fun(B,bool),G4,X2),Y2))
               => ( Y2 = X4 ) ) )
       => ( pp(aa(B,bool,aa(A,fun(B,bool),G4,X2),aa(A,B,H2,X2)))
         => ( aa(A,B,H2,X2) = aa(A,B,F2,X2) ) ) ) ) ).

% fundef_ex1_uniqueness
tff(fact_6108_fundef__ex1__existence,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),D3: fun(A,B),G4: fun(A,fun(B,bool)),X2: A] :
      ( ! [X: A] : ( aa(A,B,F2,X) = fun_THE_default(B,aa(A,B,D3,X),aa(A,fun(B,bool),G4,X)) )
     => ( ? [X4: B] :
            ( pp(aa(B,bool,aa(A,fun(B,bool),G4,X2),X4))
            & ! [Y2: B] :
                ( pp(aa(B,bool,aa(A,fun(B,bool),G4,X2),Y2))
               => ( Y2 = X4 ) ) )
       => pp(aa(B,bool,aa(A,fun(B,bool),G4,X2),aa(A,B,F2,X2))) ) ) ).

% fundef_ex1_existence
tff(fact_6109_fundef__default__value,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),D3: fun(A,B),G4: fun(A,fun(B,bool)),D2: fun(A,bool),X2: A] :
      ( ! [X: A] : ( aa(A,B,F2,X) = fun_THE_default(B,aa(A,B,D3,X),aa(A,fun(B,bool),G4,X)) )
     => ( ! [X: A,Y2: B] :
            ( pp(aa(B,bool,aa(A,fun(B,bool),G4,X),Y2))
           => pp(aa(A,bool,D2,X)) )
       => ( ~ pp(aa(A,bool,D2,X2))
         => ( aa(A,B,F2,X2) = aa(A,B,D3,X2) ) ) ) ) ).

% fundef_default_value
tff(fact_6110_fundef__ex1__iff,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),D3: fun(A,B),G4: fun(A,fun(B,bool)),X2: A,Y: B] :
      ( ! [X: A] : ( aa(A,B,F2,X) = fun_THE_default(B,aa(A,B,D3,X),aa(A,fun(B,bool),G4,X)) )
     => ( ? [X4: B] :
            ( pp(aa(B,bool,aa(A,fun(B,bool),G4,X2),X4))
            & ! [Y2: B] :
                ( pp(aa(B,bool,aa(A,fun(B,bool),G4,X2),Y2))
               => ( Y2 = X4 ) ) )
       => ( pp(aa(B,bool,aa(A,fun(B,bool),G4,X2),Y))
        <=> ( aa(A,B,F2,X2) = Y ) ) ) ) ).

% fundef_ex1_iff
tff(fact_6111_curry__def,axiom,
    ! [C: $tType,A: $tType,B: $tType,X4: fun(product_prod(A,B),C),Xa3: A,Xb3: B] : ( product_curry(A,B,C,X4,Xa3,Xb3) = aa(product_prod(A,B),C,X4,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Xa3),Xb3)) ) ).

% curry_def
tff(fact_6112_prod__encode__def,axiom,
    nat_prod_encode = aa(fun(nat,fun(nat,nat)),fun(product_prod(nat,nat),nat),product_case_prod(nat,nat,nat),aTP_Lamp_bbg(nat,fun(nat,nat))) ).

% prod_encode_def
tff(fact_6113_curry__K,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: C,X4: A,Xa3: B] : ( product_curry(A,B,C,aTP_Lamp_bbh(C,fun(product_prod(A,B),C),C2),X4,Xa3) = C2 ) ).

% curry_K
tff(fact_6114_successively__altdef,axiom,
    ! [A: $tType,X4: fun(A,fun(A,bool))] : ( successively(A,X4) = rec_list(bool,A,fTrue,aTP_Lamp_bbj(fun(A,fun(A,bool)),fun(A,fun(list(A),fun(bool,bool))),X4)) ) ).

% successively_altdef
tff(fact_6115_semilattice__neutr__set_Oremove,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(A),X2: A] :
      ( lattic5652469242046573047tr_set(A,F2,Z2)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( pp(aa(set(A),bool,member(A,X2),A3))
         => ( lattic5214292709420241887eutr_F(A,F2,Z2,A3) = aa(A,A,aa(A,fun(A,A),F2,X2),lattic5214292709420241887eutr_F(A,F2,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ).

% semilattice_neutr_set.remove
tff(fact_6116_successively__rev,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),Xs: list(A)] :
      ( pp(aa(list(A),bool,successively(A,P),rev(A,Xs)))
    <=> pp(aa(list(A),bool,successively(A,aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),P)),Xs)) ) ).

% successively_rev
tff(fact_6117_semilattice__neutr__set_Oclosed,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(A)] :
      ( lattic5652469242046573047tr_set(A,F2,Z2)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( ( A3 != bot_bot(set(A)) )
         => ( ! [X: A,Y2: A] : pp(aa(set(A),bool,member(A,aa(A,A,aa(A,fun(A,A),F2,X),Y2)),aa(set(A),set(A),insert(A,X),aa(set(A),set(A),insert(A,Y2),bot_bot(set(A))))))
           => pp(aa(set(A),bool,member(A,lattic5214292709420241887eutr_F(A,F2,Z2,A3)),A3)) ) ) ) ) ).

% semilattice_neutr_set.closed
tff(fact_6118_semilattice__neutr__set_Oempty,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A] :
      ( lattic5652469242046573047tr_set(A,F2,Z2)
     => ( lattic5214292709420241887eutr_F(A,F2,Z2,bot_bot(set(A))) = Z2 ) ) ).

% semilattice_neutr_set.empty
tff(fact_6119_successively__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(A,bool)),F2: fun(B,A),Xs: list(B)] :
      ( pp(aa(list(A),bool,successively(A,P),aa(list(B),list(A),map(B,A,F2),Xs)))
    <=> pp(aa(list(B),bool,successively(B,aa(fun(B,A),fun(B,fun(B,bool)),aTP_Lamp_alf(fun(A,fun(A,bool)),fun(fun(B,A),fun(B,fun(B,bool))),P),F2)),Xs)) ) ).

% successively_map
tff(fact_6120_semilattice__neutr__set_Oinsert__remove,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z2: A,A3: set(A),X2: A] :
      ( lattic5652469242046573047tr_set(A,F2,Z2)
     => ( pp(aa(set(A),bool,finite_finite2(A),A3))
       => ( lattic5214292709420241887eutr_F(A,F2,Z2,aa(set(A),set(A),insert(A,X2),A3)) = aa(A,A,aa(A,fun(A,A),F2,X2),lattic5214292709420241887eutr_F(A,F2,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ).

% semilattice_neutr_set.insert_remove
tff(fact_6121_inv__imagep__def,axiom,
    ! [B: $tType,A: $tType,R2: fun(B,fun(B,bool)),F2: fun(A,B),X4: A,Xa3: A] :
      ( inv_imagep(B,A,R2,F2,X4,Xa3)
    <=> pp(aa(B,bool,aa(B,fun(B,bool),R2,aa(A,B,F2,X4)),aa(A,B,F2,Xa3))) ) ).

% inv_imagep_def
tff(fact_6122_is__filter__map__filter__on,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),X5: set(B),F: filter(B)] :
      ( pp(aa(fun(fun(A,bool),bool),bool,is_filter(A),aa(filter(B),fun(fun(A,bool),bool),aa(set(B),fun(filter(B),fun(fun(A,bool),bool)),aTP_Lamp_bbl(fun(B,A),fun(set(B),fun(filter(B),fun(fun(A,bool),bool))),F2),X5),F)))
    <=> eventually(B,aTP_Lamp_ni(set(B),fun(B,bool),X5),F) ) ).

% is_filter_map_filter_on
tff(fact_6123_is__filter_OTrue,axiom,
    ! [A: $tType,F: fun(fun(A,bool),bool)] :
      ( pp(aa(fun(fun(A,bool),bool),bool,is_filter(A),F))
     => pp(aa(fun(A,bool),bool,F,aTP_Lamp_nn(A,bool))) ) ).

% is_filter.True
tff(fact_6124_is__filter_Oconj,axiom,
    ! [A: $tType,F: fun(fun(A,bool),bool),P: fun(A,bool),Q: fun(A,bool)] :
      ( pp(aa(fun(fun(A,bool),bool),bool,is_filter(A),F))
     => ( pp(aa(fun(A,bool),bool,F,P))
       => ( pp(aa(fun(A,bool),bool,F,Q))
         => pp(aa(fun(A,bool),bool,F,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q))) ) ) ) ).

% is_filter.conj
tff(fact_6125_is__filter_Omono,axiom,
    ! [A: $tType,F: fun(fun(A,bool),bool),P: fun(A,bool),Q: fun(A,bool)] :
      ( pp(aa(fun(fun(A,bool),bool),bool,is_filter(A),F))
     => ( ! [X: A] :
            ( pp(aa(A,bool,P,X))
           => pp(aa(A,bool,Q,X)) )
       => ( pp(aa(fun(A,bool),bool,F,P))
         => pp(aa(fun(A,bool),bool,F,Q)) ) ) ) ).

% is_filter.mono
tff(fact_6126_is__filter_Ointro,axiom,
    ! [A: $tType,F: fun(fun(A,bool),bool)] :
      ( pp(aa(fun(A,bool),bool,F,aTP_Lamp_nn(A,bool)))
     => ( ! [P3: fun(A,bool)] :
            ( pp(aa(fun(A,bool),bool,F,P3))
           => ! [Q4: fun(A,bool)] :
                ( pp(aa(fun(A,bool),bool,F,Q4))
               => pp(aa(fun(A,bool),bool,F,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P3),Q4))) ) )
       => ( ! [P3: fun(A,bool),Q4: fun(A,bool)] :
              ( ! [X4: A] :
                  ( pp(aa(A,bool,P3,X4))
                 => pp(aa(A,bool,Q4,X4)) )
             => ( pp(aa(fun(A,bool),bool,F,P3))
               => pp(aa(fun(A,bool),bool,F,Q4)) ) )
         => pp(aa(fun(fun(A,bool),bool),bool,is_filter(A),F)) ) ) ) ).

% is_filter.intro
tff(fact_6127_is__filter__def,axiom,
    ! [A: $tType,F: fun(fun(A,bool),bool)] :
      ( pp(aa(fun(fun(A,bool),bool),bool,is_filter(A),F))
    <=> ( pp(aa(fun(A,bool),bool,F,aTP_Lamp_nn(A,bool)))
        & ! [P4: fun(A,bool)] :
            ( pp(aa(fun(A,bool),bool,F,P4))
           => ! [Q7: fun(A,bool)] :
                ( pp(aa(fun(A,bool),bool,F,Q7))
               => pp(aa(fun(A,bool),bool,F,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P4),Q7))) ) )
        & ! [P4: fun(A,bool),Q7: fun(A,bool)] :
            ( ! [X3: A] :
                ( pp(aa(A,bool,P4,X3))
               => pp(aa(A,bool,Q7,X3)) )
           => ( pp(aa(fun(A,bool),bool,F,P4))
             => pp(aa(fun(A,bool),bool,F,Q7)) ) ) ) ) ).

% is_filter_def
tff(fact_6128_Abs__filter__cases,axiom,
    ! [A: $tType,X2: filter(A)] :
      ~ ! [Y2: fun(fun(A,bool),bool)] :
          ( ( X2 = aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),Y2) )
         => ~ pp(aa(set(fun(fun(A,bool),bool)),bool,member(fun(fun(A,bool),bool),Y2),aa(fun(fun(fun(A,bool),bool),bool),set(fun(fun(A,bool),bool)),collect(fun(fun(A,bool),bool)),is_filter(A)))) ) ).

% Abs_filter_cases
tff(fact_6129_Abs__filter__induct,axiom,
    ! [A: $tType,P: fun(filter(A),bool),X2: filter(A)] :
      ( ! [Y2: fun(fun(A,bool),bool)] :
          ( pp(aa(set(fun(fun(A,bool),bool)),bool,member(fun(fun(A,bool),bool),Y2),aa(fun(fun(fun(A,bool),bool),bool),set(fun(fun(A,bool),bool)),collect(fun(fun(A,bool),bool)),is_filter(A))))
         => pp(aa(filter(A),bool,P,aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),Y2))) )
     => pp(aa(filter(A),bool,P,X2)) ) ).

% Abs_filter_induct
tff(fact_6130_Abs__filter__inject,axiom,
    ! [A: $tType,X2: fun(fun(A,bool),bool),Y: fun(fun(A,bool),bool)] :
      ( pp(aa(set(fun(fun(A,bool),bool)),bool,member(fun(fun(A,bool),bool),X2),aa(fun(fun(fun(A,bool),bool),bool),set(fun(fun(A,bool),bool)),collect(fun(fun(A,bool),bool)),is_filter(A))))
     => ( pp(aa(set(fun(fun(A,bool),bool)),bool,member(fun(fun(A,bool),bool),Y),aa(fun(fun(fun(A,bool),bool),bool),set(fun(fun(A,bool),bool)),collect(fun(fun(A,bool),bool)),is_filter(A))))
       => ( ( aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),X2) = aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),Y) )
        <=> ( X2 = Y ) ) ) ) ).

% Abs_filter_inject
tff(fact_6131_type__definition__filter,axiom,
    ! [A: $tType] : type_definition(filter(A),fun(fun(A,bool),bool),rep_filter(A),abs_filter(A),aa(fun(fun(fun(A,bool),bool),bool),set(fun(fun(A,bool),bool)),collect(fun(fun(A,bool),bool)),is_filter(A))) ).

% type_definition_filter
tff(fact_6132_Abs__filter__inverse,axiom,
    ! [A: $tType,Y: fun(fun(A,bool),bool)] :
      ( pp(aa(set(fun(fun(A,bool),bool)),bool,member(fun(fun(A,bool),bool),Y),aa(fun(fun(fun(A,bool),bool),bool),set(fun(fun(A,bool),bool)),collect(fun(fun(A,bool),bool)),is_filter(A))))
     => ( aa(filter(A),fun(fun(A,bool),bool),rep_filter(A),aa(fun(fun(A,bool),bool),filter(A),abs_filter(A),Y)) = Y ) ) ).

% Abs_filter_inverse
tff(fact_6133_Rep__filter,axiom,
    ! [A: $tType,X2: filter(A)] : pp(aa(set(fun(fun(A,bool),bool)),bool,member(fun(fun(A,bool),bool),aa(filter(A),fun(fun(A,bool),bool),rep_filter(A),X2)),aa(fun(fun(fun(A,bool),bool),bool),set(fun(fun(A,bool),bool)),collect(fun(fun(A,bool),bool)),is_filter(A)))) ).

% Rep_filter
tff(fact_6134_Rep__filter__cases,axiom,
    ! [A: $tType,Y: fun(fun(A,bool),bool)] :
      ( pp(aa(set(fun(fun(A,bool),bool)),bool,member(fun(fun(A,bool),bool),Y),aa(fun(fun(fun(A,bool),bool),bool),set(fun(fun(A,bool),bool)),collect(fun(fun(A,bool),bool)),is_filter(A))))
     => ~ ! [X: filter(A)] : ( Y != aa(filter(A),fun(fun(A,bool),bool),rep_filter(A),X) ) ) ).

% Rep_filter_cases
tff(fact_6135_Rep__filter__induct,axiom,
    ! [A: $tType,Y: fun(fun(A,bool),bool),P: fun(fun(fun(A,bool),bool),bool)] :
      ( pp(aa(set(fun(fun(A,bool),bool)),bool,member(fun(fun(A,bool),bool),Y),aa(fun(fun(fun(A,bool),bool),bool),set(fun(fun(A,bool),bool)),collect(fun(fun(A,bool),bool)),is_filter(A))))
     => ( ! [X: filter(A)] : pp(aa(fun(fun(A,bool),bool),bool,P,aa(filter(A),fun(fun(A,bool),bool),rep_filter(A),X)))
       => pp(aa(fun(fun(A,bool),bool),bool,P,Y)) ) ) ).

% Rep_filter_induct
tff(fact_6136_ref_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( rel_ref(A,B,R) = aa(fun(ref(product_prod(A,B)),fun(ref(B),bool)),fun(ref(A),fun(ref(B),bool)),aa(fun(ref(A),fun(ref(product_prod(A,B)),bool)),fun(fun(ref(product_prod(A,B)),fun(ref(B),bool)),fun(ref(A),fun(ref(B),bool))),relcompp(ref(A),ref(product_prod(A,B)),ref(B)),conversep(ref(product_prod(A,B)),ref(A),bNF_Grp(ref(product_prod(A,B)),ref(A),aa(fun(ref(product_prod(A,B)),bool),set(ref(product_prod(A,B))),collect(ref(product_prod(A,B))),aTP_Lamp_bbm(fun(A,fun(B,bool)),fun(ref(product_prod(A,B)),bool),R)),map_ref(product_prod(A,B),A,product_fst(A,B))))),bNF_Grp(ref(product_prod(A,B)),ref(B),aa(fun(ref(product_prod(A,B)),bool),set(ref(product_prod(A,B))),collect(ref(product_prod(A,B))),aTP_Lamp_bbm(fun(A,fun(B,bool)),fun(ref(product_prod(A,B)),bool),R)),map_ref(product_prod(A,B),B,product_snd(A,B)))) ) ).

% ref.rel_compp_Grp
tff(fact_6137_array_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( rel_array(A,B,R) = aa(fun(array(product_prod(A,B)),fun(array(B),bool)),fun(array(A),fun(array(B),bool)),aa(fun(array(A),fun(array(product_prod(A,B)),bool)),fun(fun(array(product_prod(A,B)),fun(array(B),bool)),fun(array(A),fun(array(B),bool))),relcompp(array(A),array(product_prod(A,B)),array(B)),conversep(array(product_prod(A,B)),array(A),bNF_Grp(array(product_prod(A,B)),array(A),aa(fun(array(product_prod(A,B)),bool),set(array(product_prod(A,B))),collect(array(product_prod(A,B))),aTP_Lamp_bbn(fun(A,fun(B,bool)),fun(array(product_prod(A,B)),bool),R)),map_array(product_prod(A,B),A,product_fst(A,B))))),bNF_Grp(array(product_prod(A,B)),array(B),aa(fun(array(product_prod(A,B)),bool),set(array(product_prod(A,B))),collect(array(product_prod(A,B))),aTP_Lamp_bbn(fun(A,fun(B,bool)),fun(array(product_prod(A,B)),bool),R)),map_array(product_prod(A,B),B,product_snd(A,B)))) ) ).

% array.rel_compp_Grp
tff(fact_6138_ref_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: fun(A,fun(C,bool)),X2: ref(A),G: fun(B,C),Y: ref(B)] :
      ( pp(aa(ref(C),bool,aa(ref(A),fun(ref(C),bool),rel_ref(A,C,Sa),X2),aa(ref(B),ref(C),map_ref(B,C,G),Y)))
    <=> pp(aa(ref(B),bool,aa(ref(A),fun(ref(B),bool),rel_ref(A,B,aa(fun(B,C),fun(A,fun(B,bool)),aTP_Lamp_fm(fun(A,fun(C,bool)),fun(fun(B,C),fun(A,fun(B,bool))),Sa),G)),X2),Y)) ) ).

% ref.rel_map(2)
tff(fact_6139_ref_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: fun(C,fun(B,bool)),I2: fun(A,C),X2: ref(A),Y: ref(B)] :
      ( pp(aa(ref(B),bool,aa(ref(C),fun(ref(B),bool),rel_ref(C,B,Sb),aa(ref(A),ref(C),map_ref(A,C,I2),X2)),Y))
    <=> pp(aa(ref(B),bool,aa(ref(A),fun(ref(B),bool),rel_ref(A,B,aa(fun(A,C),fun(A,fun(B,bool)),aTP_Lamp_fn(fun(C,fun(B,bool)),fun(fun(A,C),fun(A,fun(B,bool))),Sb),I2)),X2),Y)) ) ).

% ref.rel_map(1)
tff(fact_6140_array_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: fun(A,fun(C,bool)),X2: array(A),G: fun(B,C),Y: array(B)] :
      ( pp(aa(array(C),bool,aa(array(A),fun(array(C),bool),rel_array(A,C,Sa),X2),aa(array(B),array(C),map_array(B,C,G),Y)))
    <=> pp(aa(array(B),bool,aa(array(A),fun(array(B),bool),rel_array(A,B,aa(fun(B,C),fun(A,fun(B,bool)),aTP_Lamp_fm(fun(A,fun(C,bool)),fun(fun(B,C),fun(A,fun(B,bool))),Sa),G)),X2),Y)) ) ).

% array.rel_map(2)
tff(fact_6141_array_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: fun(C,fun(B,bool)),I2: fun(A,C),X2: array(A),Y: array(B)] :
      ( pp(aa(array(B),bool,aa(array(C),fun(array(B),bool),rel_array(C,B,Sb),aa(array(A),array(C),map_array(A,C,I2),X2)),Y))
    <=> pp(aa(array(B),bool,aa(array(A),fun(array(B),bool),rel_array(A,B,aa(fun(A,C),fun(A,fun(B,bool)),aTP_Lamp_fn(fun(C,fun(B,bool)),fun(fun(A,C),fun(A,fun(B,bool))),Sb),I2)),X2),Y)) ) ).

% array.rel_map(1)
tff(fact_6142_ref_Omap__ident,axiom,
    ! [A: $tType,T3: ref(A)] : ( aa(ref(A),ref(A),map_ref(A,A,aTP_Lamp_bk(A,A)),T3) = T3 ) ).

% ref.map_ident
tff(fact_6143_array_Omap__ident,axiom,
    ! [A: $tType,T3: array(A)] : ( aa(array(A),array(A),map_array(A,A,aTP_Lamp_bk(A,A)),T3) = T3 ) ).

% array.map_ident
tff(fact_6144_ref_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,B)] : ( rel_ref(A,B,bNF_Grp(A,B,A3,F2)) = bNF_Grp(ref(A),ref(B),aa(fun(ref(A),bool),set(ref(A)),collect(ref(A)),aTP_Lamp_bbo(set(A),fun(ref(A),bool),A3)),map_ref(A,B,F2)) ) ).

% ref.rel_Grp
tff(fact_6145_array_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,B)] : ( rel_array(A,B,bNF_Grp(A,B,A3,F2)) = bNF_Grp(array(A),array(B),aa(fun(array(A),bool),set(array(A)),collect(array(A)),aTP_Lamp_bbp(set(A),fun(array(A),bool),A3)),map_array(A,B,F2)) ) ).

% array.rel_Grp
tff(fact_6146_ref_Oin__rel,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),A4: ref(A),B3: ref(B)] :
      ( pp(aa(ref(B),bool,aa(ref(A),fun(ref(B),bool),rel_ref(A,B,R),A4),B3))
    <=> ? [Z5: ref(product_prod(A,B))] :
          ( pp(aa(set(ref(product_prod(A,B))),bool,member(ref(product_prod(A,B)),Z5),aa(fun(ref(product_prod(A,B)),bool),set(ref(product_prod(A,B))),collect(ref(product_prod(A,B))),aTP_Lamp_bbm(fun(A,fun(B,bool)),fun(ref(product_prod(A,B)),bool),R))))
          & ( aa(ref(product_prod(A,B)),ref(A),map_ref(product_prod(A,B),A,product_fst(A,B)),Z5) = A4 )
          & ( aa(ref(product_prod(A,B)),ref(B),map_ref(product_prod(A,B),B,product_snd(A,B)),Z5) = B3 ) ) ) ).

% ref.in_rel
tff(fact_6147_array_Oin__rel,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),A4: array(A),B3: array(B)] :
      ( pp(aa(array(B),bool,aa(array(A),fun(array(B),bool),rel_array(A,B,R),A4),B3))
    <=> ? [Z5: array(product_prod(A,B))] :
          ( pp(aa(set(array(product_prod(A,B))),bool,member(array(product_prod(A,B)),Z5),aa(fun(array(product_prod(A,B)),bool),set(array(product_prod(A,B))),collect(array(product_prod(A,B))),aTP_Lamp_bbn(fun(A,fun(B,bool)),fun(array(product_prod(A,B)),bool),R))))
          & ( aa(array(product_prod(A,B)),array(A),map_array(product_prod(A,B),A,product_fst(A,B)),Z5) = A4 )
          & ( aa(array(product_prod(A,B)),array(B),map_array(product_prod(A,B),B,product_snd(A,B)),Z5) = B3 ) ) ) ).

% array.in_rel
tff(fact_6148_array_Orec__o__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: fun(nat,C),F2: fun(A,B)] : ( aa(fun(array(A),array(B)),fun(array(A),C),comp(array(B),C,array(A),rec_array(C,B,G)),map_array(A,B,F2)) = rec_array(C,A,G) ) ).

% array.rec_o_map
tff(fact_6149_ref_Orec__o__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: fun(nat,C),F2: fun(A,B)] : ( aa(fun(ref(A),ref(B)),fun(ref(A),C),comp(ref(B),C,ref(A),rec_ref(C,B,G)),map_ref(A,B,F2)) = rec_ref(C,A,G) ) ).

% ref.rec_o_map
tff(fact_6150_array_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X2: array(A),Ya2: array(A),F2: fun(A,B),G: fun(A,B)] :
      ( ( X2 = Ya2 )
     => ( pred_array(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_nv(fun(A,B),fun(fun(A,B),fun(A,bool)),F2),G),Ya2)
       => ( aa(array(A),array(B),map_array(A,B,F2),X2) = aa(array(A),array(B),map_array(A,B,G),Ya2) ) ) ) ).

% array.map_cong_pred
tff(fact_6151_ref_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X2: ref(A),Ya2: ref(A),F2: fun(A,B),G: fun(A,B)] :
      ( ( X2 = Ya2 )
     => ( pred_ref(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_nv(fun(A,B),fun(fun(A,B),fun(A,bool)),F2),G),Ya2)
       => ( aa(ref(A),ref(B),map_ref(A,B,F2),X2) = aa(ref(A),ref(B),map_ref(A,B,G),Ya2) ) ) ) ).

% ref.map_cong_pred
tff(fact_6152_ref_Opred__True,axiom,
    ! [A: $tType,X4: ref(A)] : pred_ref(A,aTP_Lamp_nn(A,bool),X4) ).

% ref.pred_True
tff(fact_6153_array_Opred__True,axiom,
    ! [A: $tType,X4: array(A)] : pred_array(A,aTP_Lamp_nn(A,bool),X4) ).

% array.pred_True
tff(fact_6154_Heap_Oin__rel,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),A4: heap_Time_Heap(A),B3: heap_Time_Heap(B)] :
      ( pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),heap_Time_rel_Heap(A,B,R),A4),B3))
    <=> ? [Z5: heap_Time_Heap(product_prod(A,B))] :
          ( pp(aa(set(heap_Time_Heap(product_prod(A,B))),bool,member(heap_Time_Heap(product_prod(A,B)),Z5),aa(fun(heap_Time_Heap(product_prod(A,B)),bool),set(heap_Time_Heap(product_prod(A,B))),collect(heap_Time_Heap(product_prod(A,B))),aTP_Lamp_bbq(fun(A,fun(B,bool)),fun(heap_Time_Heap(product_prod(A,B)),bool),R))))
          & ( aa(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(A),heap_Time_map_Heap(product_prod(A,B),A,product_fst(A,B)),Z5) = A4 )
          & ( aa(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(B),heap_Time_map_Heap(product_prod(A,B),B,product_snd(A,B)),Z5) = B3 ) ) ) ).

% Heap.in_rel
tff(fact_6155_Heap_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( heap_Time_rel_Heap(A,B,R) = aa(fun(heap_Time_Heap(product_prod(A,B)),fun(heap_Time_Heap(B),bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),aa(fun(heap_Time_Heap(A),fun(heap_Time_Heap(product_prod(A,B)),bool)),fun(fun(heap_Time_Heap(product_prod(A,B)),fun(heap_Time_Heap(B),bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool))),relcompp(heap_Time_Heap(A),heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(B)),conversep(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(A),bNF_Grp(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(A),aa(fun(heap_Time_Heap(product_prod(A,B)),bool),set(heap_Time_Heap(product_prod(A,B))),collect(heap_Time_Heap(product_prod(A,B))),aTP_Lamp_bbq(fun(A,fun(B,bool)),fun(heap_Time_Heap(product_prod(A,B)),bool),R)),heap_Time_map_Heap(product_prod(A,B),A,product_fst(A,B))))),bNF_Grp(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(B),aa(fun(heap_Time_Heap(product_prod(A,B)),bool),set(heap_Time_Heap(product_prod(A,B))),collect(heap_Time_Heap(product_prod(A,B))),aTP_Lamp_bbq(fun(A,fun(B,bool)),fun(heap_Time_Heap(product_prod(A,B)),bool),R)),heap_Time_map_Heap(product_prod(A,B),B,product_snd(A,B)))) ) ).

% Heap.rel_compp_Grp
tff(fact_6156_Heap_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: fun(C,fun(B,bool)),I2: fun(A,C),X2: heap_Time_Heap(A),Y: heap_Time_Heap(B)] :
      ( pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(C),fun(heap_Time_Heap(B),bool),heap_Time_rel_Heap(C,B,Sb),aa(heap_Time_Heap(A),heap_Time_Heap(C),heap_Time_map_Heap(A,C,I2),X2)),Y))
    <=> pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),heap_Time_rel_Heap(A,B,aa(fun(A,C),fun(A,fun(B,bool)),aTP_Lamp_fn(fun(C,fun(B,bool)),fun(fun(A,C),fun(A,fun(B,bool))),Sb),I2)),X2),Y)) ) ).

% Heap.rel_map(1)
tff(fact_6157_Heap_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: fun(A,fun(C,bool)),X2: heap_Time_Heap(A),G: fun(B,C),Y: heap_Time_Heap(B)] :
      ( pp(aa(heap_Time_Heap(C),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(C),bool),heap_Time_rel_Heap(A,C,Sa),X2),aa(heap_Time_Heap(B),heap_Time_Heap(C),heap_Time_map_Heap(B,C,G),Y)))
    <=> pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),heap_Time_rel_Heap(A,B,aa(fun(B,C),fun(A,fun(B,bool)),aTP_Lamp_fm(fun(A,fun(C,bool)),fun(fun(B,C),fun(A,fun(B,bool))),Sa),G)),X2),Y)) ) ).

% Heap.rel_map(2)
tff(fact_6158_Heap_Omap__ident,axiom,
    ! [A: $tType,T3: heap_Time_Heap(A)] : ( aa(heap_Time_Heap(A),heap_Time_Heap(A),heap_Time_map_Heap(A,A,aTP_Lamp_bk(A,A)),T3) = T3 ) ).

% Heap.map_ident
tff(fact_6159_Heap_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F2: fun(A,B)] : ( heap_Time_rel_Heap(A,B,bNF_Grp(A,B,A3,F2)) = bNF_Grp(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(heap_Time_Heap(A),bool),set(heap_Time_Heap(A)),collect(heap_Time_Heap(A)),aTP_Lamp_bbr(set(A),fun(heap_Time_Heap(A),bool),A3)),heap_Time_map_Heap(A,B,F2)) ) ).

% Heap.rel_Grp
tff(fact_6160_Heap_Orec__o__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),F2: fun(A,B)] : ( aa(fun(heap_Time_Heap(A),heap_Time_Heap(B)),fun(heap_Time_Heap(A),C),comp(heap_Time_Heap(B),C,heap_Time_Heap(A),heap_Time_rec_Heap(B,C,G)),heap_Time_map_Heap(A,B,F2)) = heap_Time_rec_Heap(A,C,aa(fun(A,B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),aTP_Lamp_bbs(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(A,B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C)),G),F2)) ) ).

% Heap.rec_o_map
tff(fact_6161_Heap_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X2: heap_Time_Heap(A),Ya2: heap_Time_Heap(A),F2: fun(A,B),G: fun(A,B)] :
      ( ( X2 = Ya2 )
     => ( heap_Time_pred_Heap(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_nv(fun(A,B),fun(fun(A,B),fun(A,bool)),F2),G),Ya2)
       => ( aa(heap_Time_Heap(A),heap_Time_Heap(B),heap_Time_map_Heap(A,B,F2),X2) = aa(heap_Time_Heap(A),heap_Time_Heap(B),heap_Time_map_Heap(A,B,G),Ya2) ) ) ) ).

% Heap.map_cong_pred
tff(fact_6162_Heap_Opred__True,axiom,
    ! [A: $tType,X4: heap_Time_Heap(A)] : heap_Time_pred_Heap(A,aTP_Lamp_nn(A,bool),X4) ).

% Heap.pred_True
tff(fact_6163_Heap_Opred__inject,axiom,
    ! [A: $tType,P: fun(A,bool),A4: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] :
      ( heap_Time_pred_Heap(A,P,heap_Time_Heap2(A,A4))
    <=> pp(aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),bool,aa(fun(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),bool),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),bool),basic_pred_fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_bbt(heap_ext(product_unit),bool)),pred_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),basic_pred_prod(A,product_prod(heap_ext(product_unit),nat),P,top_top(fun(product_prod(heap_ext(product_unit),nat),bool))))),A4)) ) ).

% Heap.pred_inject
tff(fact_6164_option_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X2: option(A),Ya2: option(A),F2: fun(A,B),G: fun(A,B)] :
      ( ( X2 = Ya2 )
     => ( pp(aa(option(A),bool,pred_option(A,aa(fun(A,B),fun(A,bool),aTP_Lamp_nv(fun(A,B),fun(fun(A,B),fun(A,bool)),F2),G)),Ya2))
       => ( aa(option(A),option(B),map_option(A,B,F2),X2) = aa(option(A),option(B),map_option(A,B,G),Ya2) ) ) ) ).

% option.map_cong_pred
tff(fact_6165_option_Opred__True,axiom,
    ! [A: $tType,X4: option(A)] : pp(aa(option(A),bool,pred_option(A,aTP_Lamp_nn(A,bool)),X4)) ).

% option.pred_True
tff(fact_6166_ATP_Olambda__1,axiom,
    ! [Uu: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aTP_Lamp_abr(product_prod(int,int),product_prod(int,int)),Uu) = if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),fequal(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_fst(int,int),Uu))) ) ).

% ATP.lambda_1
tff(fact_6167_ATP_Olambda__2,axiom,
    ! [A: $tType,Uu: set(set(A))] : ( aa(set(set(A)),int,aTP_Lamp_tb(set(set(A)),int),Uu) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(set(A)),nat,finite_card(set(A)),Uu)),one_one(nat)))),aa(nat,int,semiring_1_of_nat(int),aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),Uu)))) ) ).

% ATP.lambda_2
tff(fact_6168_ATP_Olambda__3,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,set(product_prod(A,A)),aTP_Lamp_hc(A,set(product_prod(A,A))),Uu) = aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),Uu)),bot_bot(set(product_prod(A,A)))) ) ).

% ATP.lambda_3
tff(fact_6169_ATP_Olambda__4,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: A] :
          ( pp(aa(A,bool,aTP_Lamp_aej(A,bool),Uu))
        <=> ( pp(aa(set(A),bool,member(A,Uu),ring_1_Ints(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Uu)) ) ) ) ).

% ATP.lambda_4
tff(fact_6170_ATP_Olambda__5,axiom,
    ! [Uu: a] : ( aa(a,assn,aTP_Lamp_a(a,assn),Uu) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),q(Uu)),top_top(assn)) ) ).

% ATP.lambda_5
tff(fact_6171_ATP_Olambda__6,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: product_prod(int,int)] : ( aa(product_prod(int,int),A,aTP_Lamp_abw(product_prod(int,int),A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),aa(product_prod(int,int),int,product_fst(int,int),Uu))),aa(int,A,ring_1_of_int(A),aa(product_prod(int,int),int,product_snd(int,int),Uu))) ) ) ).

% ATP.lambda_6
tff(fact_6172_ATP_Olambda__7,axiom,
    ! [Uu: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aTP_Lamp_abt(product_prod(int,int),product_prod(int,int)),Uu) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),aa(product_prod(int,int),int,product_fst(int,int),Uu))),aa(product_prod(int,int),int,product_snd(int,int),Uu)) ) ).

% ATP.lambda_7
tff(fact_6173_ATP_Olambda__8,axiom,
    ! [Uu: nat] : ( aa(nat,int,aTP_Lamp_azq(nat,int),Uu) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),Uu))),one_one(int)) ) ).

% ATP.lambda_8
tff(fact_6174_ATP_Olambda__9,axiom,
    ! [A: $tType,Uu: product_prod(A,A)] :
      ( pp(aa(product_prod(A,A),bool,aTP_Lamp_is(product_prod(A,A),bool),Uu))
    <=> ( aa(product_prod(A,A),A,product_fst(A,A),Uu) = aa(product_prod(A,A),A,product_snd(A,A),Uu) ) ) ).

% ATP.lambda_9
tff(fact_6175_ATP_Olambda__10,axiom,
    ! [A: $tType,Uu: list(A)] : ( aa(list(A),product_prod(nat,list(A)),aTP_Lamp_aur(list(A),product_prod(nat,list(A))),Uu) = aa(list(A),product_prod(nat,list(A)),aa(nat,fun(list(A),product_prod(nat,list(A))),product_Pair(nat,list(A)),aa(list(A),nat,size_size(list(A)),Uu)),Uu) ) ).

% ATP.lambda_10
tff(fact_6176_ATP_Olambda__11,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: nat] :
          ( pp(aa(nat,bool,aTP_Lamp_zu(nat,bool),Uu))
        <=> ( aa(nat,A,semiring_1_of_nat(A),Uu) = zero_zero(A) ) ) ) ).

% ATP.lambda_11
tff(fact_6177_ATP_Olambda__12,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_sx(nat,nat),Uu) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),aa(nat,nat,suc,zero_zero(nat))) ) ).

% ATP.lambda_12
tff(fact_6178_ATP_Olambda__13,axiom,
    ! [Uu: int] : ( aa(int,int,aTP_Lamp_yo(int,int),Uu) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uu),Uu) ) ).

% ATP.lambda_13
tff(fact_6179_ATP_Olambda__14,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,product_prod(B,B),aTP_Lamp_hm(B,product_prod(B,B)),Uu) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),Uu) ) ).

% ATP.lambda_14
tff(fact_6180_ATP_Olambda__15,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,product_prod(A,A),aTP_Lamp_hl(A,product_prod(A,A)),Uu) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),Uu) ) ).

% ATP.lambda_15
tff(fact_6181_ATP_Olambda__16,axiom,
    ! [Uu: product_prod(int,int)] :
      ( pp(aa(product_prod(int,int),bool,aTP_Lamp_aqv(product_prod(int,int),bool),Uu))
    <=> pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,Uu),Uu)) ) ).

% ATP.lambda_16
tff(fact_6182_ATP_Olambda__17,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_sr(A,A),Uu) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),one_one(A)) ) ) ).

% ATP.lambda_17
tff(fact_6183_ATP_Olambda__18,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Uu: A] :
          ( pp(aa(A,bool,aTP_Lamp_aul(A,bool),Uu))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Uu),one_one(A))) ) ) ).

% ATP.lambda_18
tff(fact_6184_ATP_Olambda__19,axiom,
    ! [Uu: nat] : ( aa(nat,product_prod(nat,nat),aTP_Lamp_wk(nat,product_prod(nat,nat)),Uu) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Uu),zero_zero(nat)) ) ).

% ATP.lambda_19
tff(fact_6185_ATP_Olambda__20,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,multiset(A),aTP_Lamp_ahv(A,multiset(A)),Uu) = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),Uu),zero_zero(multiset(A))) ) ).

% ATP.lambda_20
tff(fact_6186_ATP_Olambda__21,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A] : ( aa(A,list(A),aTP_Lamp_anm(A,list(A)),Uu) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uu),nil(A)) ) ) ).

% ATP.lambda_21
tff(fact_6187_ATP_Olambda__22,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,list(A),aTP_Lamp_aiw(A,list(A)),Uu) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uu),nil(A)) ) ).

% ATP.lambda_22
tff(fact_6188_ATP_Olambda__23,axiom,
    ! [D: $tType,Uu: D] : ( aa(D,set(D),aTP_Lamp_ayt(D,set(D)),Uu) = aa(set(D),set(D),insert(D,Uu),bot_bot(set(D))) ) ).

% ATP.lambda_23
tff(fact_6189_ATP_Olambda__24,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,set(A),aTP_Lamp_dj(A,set(A)),Uu) = aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))) ) ).

% ATP.lambda_24
tff(fact_6190_ATP_Olambda__25,axiom,
    ! [A: $tType] :
      ( countable(A)
     => ! [Uu: fun(A,nat)] :
          ( pp(aa(fun(A,nat),bool,aTP_Lamp_azs(fun(A,nat),bool),Uu))
        <=> inj_on(A,nat,Uu,top_top(set(A))) ) ) ).

% ATP.lambda_25
tff(fact_6191_ATP_Olambda__26,axiom,
    ! [B: $tType,D: $tType,Uu: fun(D,B)] : ( aa(fun(D,B),set(B),aTP_Lamp_aqb(fun(D,B),set(B)),Uu) = aa(set(D),set(B),image2(D,B,Uu),top_top(set(D))) ) ).

% ATP.lambda_26
tff(fact_6192_ATP_Olambda__27,axiom,
    ! [A: $tType,D: $tType,Uu: fun(D,A)] : ( aa(fun(D,A),set(A),aTP_Lamp_aqa(fun(D,A),set(A)),Uu) = aa(set(D),set(A),image2(D,A,Uu),top_top(set(D))) ) ).

% ATP.lambda_27
tff(fact_6193_ATP_Olambda__28,axiom,
    ! [B: $tType,Uu: option(B)] :
      ( pp(aa(option(B),bool,aTP_Lamp_avk(option(B),bool),Uu))
    <=> ( Uu = none(B) ) ) ).

% ATP.lambda_28
tff(fact_6194_ATP_Olambda__29,axiom,
    ! [A: $tType,Uu: option(A)] :
      ( pp(aa(option(A),bool,aTP_Lamp_avj(option(A),bool),Uu))
    <=> ( Uu = none(A) ) ) ).

% ATP.lambda_29
tff(fact_6195_ATP_Olambda__30,axiom,
    ! [B: $tType,Uu: list(B)] :
      ( pp(aa(list(B),bool,aTP_Lamp_aoj(list(B),bool),Uu))
    <=> ( Uu = nil(B) ) ) ).

% ATP.lambda_30
tff(fact_6196_ATP_Olambda__31,axiom,
    ! [A: $tType,Uu: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_aoi(list(A),bool),Uu))
    <=> ( Uu = nil(A) ) ) ).

% ATP.lambda_31
tff(fact_6197_ATP_Olambda__32,axiom,
    ! [Uu: product_prod(int,int)] :
      ( pp(aa(product_prod(int,int),bool,aTP_Lamp_abv(product_prod(int,int),bool),Uu))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uu)))) ) ).

% ATP.lambda_32
tff(fact_6198_ATP_Olambda__33,axiom,
    ! [Uu: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_axy(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,aTP_Lamp_axx(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu)) ) ).

% ATP.lambda_33
tff(fact_6199_ATP_Olambda__34,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_awe(nat,nat),Uu) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uu)) ) ).

% ATP.lambda_34
tff(fact_6200_ATP_Olambda__35,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),fun(nat,nat),aTP_Lamp_aiy(list(B),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(B),nat,size_size(list(B)),Uu)),aa(nat,nat,suc,zero_zero(nat)))) ) ).

% ATP.lambda_35
tff(fact_6201_ATP_Olambda__36,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,fun(set(product_prod(A,A)),set(product_prod(A,A))),aTP_Lamp_lx(A,fun(set(product_prod(A,A)),set(product_prod(A,A)))),Uu) = insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),Uu)) ) ).

% ATP.lambda_36
tff(fact_6202_ATP_Olambda__37,axiom,
    ! [B: $tType,Uu: option(B)] :
      ( pp(aa(option(B),bool,aTP_Lamp_avi(option(B),bool),Uu))
    <=> ( Uu != none(B) ) ) ).

% ATP.lambda_37
tff(fact_6203_ATP_Olambda__38,axiom,
    ! [A: $tType,Uu: option(A)] :
      ( pp(aa(option(A),bool,aTP_Lamp_avh(option(A),bool),Uu))
    <=> ( Uu != none(A) ) ) ).

% ATP.lambda_38
tff(fact_6204_ATP_Olambda__39,axiom,
    ! [B: $tType,Uu: list(B)] :
      ( pp(aa(list(B),bool,aTP_Lamp_aiz(list(B),bool),Uu))
    <=> ( Uu != nil(B) ) ) ).

% ATP.lambda_39
tff(fact_6205_ATP_Olambda__40,axiom,
    ! [A: $tType,Uu: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_ail(list(A),bool),Uu))
    <=> ( Uu != nil(A) ) ) ).

% ATP.lambda_40
tff(fact_6206_ATP_Olambda__41,axiom,
    ! [A: $tType,Uu: option(product_prod(A,product_prod(heap_ext(product_unit),nat)))] : ( aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(A),aTP_Lamp_awz(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(A)),Uu) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(set(A)),image2(product_prod(A,product_prod(heap_ext(product_unit),nat)),set(A),basic_fsts(A,product_prod(heap_ext(product_unit),nat))),set_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),Uu))) ) ).

% ATP.lambda_41
tff(fact_6207_ATP_Olambda__42,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B))] : ( aa(fun(A,option(B)),fun(product_prod(A,B),fun(A,option(B))),aTP_Lamp_arv(fun(A,option(B)),fun(product_prod(A,B),fun(A,option(B)))),Uu) = aa(fun(A,fun(B,fun(A,option(B)))),fun(product_prod(A,B),fun(A,option(B))),product_case_prod(A,B,fun(A,option(B))),aTP_Lamp_aru(fun(A,option(B)),fun(A,fun(B,fun(A,option(B)))),Uu)) ) ).

% ATP.lambda_42
tff(fact_6208_ATP_Olambda__43,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: B] : ( aa(B,fun(product_prod(A,C),product_prod(A,product_prod(B,C))),aTP_Lamp_akx(B,fun(product_prod(A,C),product_prod(A,product_prod(B,C)))),Uu) = aa(fun(A,fun(C,product_prod(A,product_prod(B,C)))),fun(product_prod(A,C),product_prod(A,product_prod(B,C))),product_case_prod(A,C,product_prod(A,product_prod(B,C))),aTP_Lamp_akw(B,fun(A,fun(C,product_prod(A,product_prod(B,C)))),Uu)) ) ).

% ATP.lambda_43
tff(fact_6209_ATP_Olambda__44,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: A] : ( aa(A,fun(product_prod(B,C),product_prod(product_prod(A,B),C)),aTP_Lamp_qm(A,fun(product_prod(B,C),product_prod(product_prod(A,B),C))),Uu) = aa(fun(B,fun(C,product_prod(product_prod(A,B),C))),fun(product_prod(B,C),product_prod(product_prod(A,B),C)),product_case_prod(B,C,product_prod(product_prod(A,B),C)),aTP_Lamp_ql(A,fun(B,fun(C,product_prod(product_prod(A,B),C))),Uu)) ) ).

% ATP.lambda_44
tff(fact_6210_ATP_Olambda__45,axiom,
    ! [A: $tType,Uu: multiset(A)] : ( aa(multiset(A),set(A),aTP_Lamp_atr(multiset(A),set(A)),Uu) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_apb(multiset(A),fun(A,bool),Uu)) ) ).

% ATP.lambda_45
tff(fact_6211_ATP_Olambda__46,axiom,
    ! [Uu: nat] : ( aa(nat,set(nat),aTP_Lamp_zt(nat,set(nat)),Uu) = aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_zc(nat,fun(nat,bool),Uu)) ) ).

% ATP.lambda_46
tff(fact_6212_ATP_Olambda__47,axiom,
    ! [B: $tType,Uu: fun(B,nat)] :
      ( pp(aa(fun(B,nat),bool,aTP_Lamp_aqp(fun(B,nat),bool),Uu))
    <=> pp(aa(set(B),bool,finite_finite2(B),aa(fun(B,bool),set(B),collect(B),aTP_Lamp_aqm(fun(B,nat),fun(B,bool),Uu)))) ) ).

% ATP.lambda_47
tff(fact_6213_ATP_Olambda__48,axiom,
    ! [A: $tType,Uu: fun(A,nat)] :
      ( pp(aa(fun(A,nat),bool,aTP_Lamp_ape(fun(A,nat),bool),Uu))
    <=> pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_tm(fun(A,nat),fun(A,bool),Uu)))) ) ).

% ATP.lambda_48
tff(fact_6214_ATP_Olambda__49,axiom,
    ! [A: $tType,Uu: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aTP_Lamp_aht(fun(A,bool),bool),Uu))
    <=> pp(aa(set(A),bool,finite_finite2(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_as(fun(A,bool),fun(A,bool),Uu)))) ) ).

% ATP.lambda_49
tff(fact_6215_ATP_Olambda__50,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B)] : ( aa(fun(A,B),set(product_prod(A,B)),aTP_Lamp_es(fun(A,B),set(product_prod(A,B))),Uu) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_er(fun(A,B),fun(A,fun(B,bool)),Uu))) ) ).

% ATP.lambda_50
tff(fact_6216_ATP_Olambda__51,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),fun(nat,nat),aTP_Lamp_aix(list(B),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(B),nat,size_size(list(B)),Uu)) ) ).

% ATP.lambda_51
tff(fact_6217_ATP_Olambda__52,axiom,
    ! [A: $tType,Uu: list(A)] : ( aa(list(A),fun(nat,nat),aTP_Lamp_ajc(list(A),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(A),nat,size_size(list(A)),Uu)) ) ).

% ATP.lambda_52
tff(fact_6218_ATP_Olambda__53,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: nat] : ( aa(nat,heap_Time_Heap(A),aTP_Lamp_awy(nat,heap_Time_Heap(A)),Uu) = heap_Time_ureturn(A,aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_53
tff(fact_6219_ATP_Olambda__54,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_aal(num,option(num)),Uu) = aa(num,option(num),some(num),aa(num,num,bit1,Uu)) ) ).

% ATP.lambda_54
tff(fact_6220_ATP_Olambda__55,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_abc(num,option(num)),Uu) = aa(num,option(num),some(num),aa(num,num,bit0,Uu)) ) ).

% ATP.lambda_55
tff(fact_6221_ATP_Olambda__56,axiom,
    ! [Uu: int] : ( aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aak(int,fun(int,product_prod(int,int))),Uu) = aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),Uu)) ) ).

% ATP.lambda_56
tff(fact_6222_ATP_Olambda__57,axiom,
    ! [Uu: int] : ( aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aam(int,fun(int,product_prod(int,int))),Uu) = aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,abs_abs(int),Uu)) ) ).

% ATP.lambda_57
tff(fact_6223_ATP_Olambda__58,axiom,
    ! [Uu: nat] : ( aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_ua(nat,fun(nat,product_prod(nat,nat))),Uu) = aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_58
tff(fact_6224_ATP_Olambda__59,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A] : ( aa(A,filter(A),aTP_Lamp_xz(A,filter(A)),Uu) = principal(A,aa(A,set(A),set_ord_atLeast(A),Uu)) ) ) ).

% ATP.lambda_59
tff(fact_6225_ATP_Olambda__60,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: A] : ( aa(A,filter(A),aTP_Lamp_xw(A,filter(A)),Uu) = principal(A,aa(A,set(A),set_ord_atLeast(A),Uu)) ) ) ).

% ATP.lambda_60
tff(fact_6226_ATP_Olambda__61,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A] : ( aa(A,filter(A),aTP_Lamp_qh(A,filter(A)),Uu) = principal(A,aa(A,set(A),set_ord_atMost(A),Uu)) ) ) ).

% ATP.lambda_61
tff(fact_6227_ATP_Olambda__62,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: A] : ( aa(A,filter(A),aTP_Lamp_qe(A,filter(A)),Uu) = principal(A,aa(A,set(A),set_ord_atMost(A),Uu)) ) ) ).

% ATP.lambda_62
tff(fact_6228_ATP_Olambda__63,axiom,
    ! [Uu: int] : ( aa(int,nat,aTP_Lamp_zw(int,nat),Uu) = aa(int,nat,nat2,aa(int,int,abs_abs(int),Uu)) ) ).

% ATP.lambda_63
tff(fact_6229_ATP_Olambda__64,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: A] :
          ( pp(aa(A,bool,aTP_Lamp_add(A,bool),Uu))
        <=> ? [N5: int] :
              ( ( Uu = aa(int,A,ring_1_of_int(A),N5) )
              & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N5)) ) ) ) ).

% ATP.lambda_64
tff(fact_6230_ATP_Olambda__65,axiom,
    ! [Uu: set(product_prod(int,int))] :
      ( pp(aa(set(product_prod(int,int)),bool,aTP_Lamp_aro(set(product_prod(int,int)),bool),Uu))
    <=> ? [X3: product_prod(int,int)] :
          ( pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,X3),X3))
          & ( Uu = aa(fun(product_prod(int,int),bool),set(product_prod(int,int)),collect(product_prod(int,int)),aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,X3)) ) ) ) ).

% ATP.lambda_65
tff(fact_6231_ATP_Olambda__66,axiom,
    ! [Uu: set(product_prod(nat,nat))] :
      ( pp(aa(set(product_prod(nat,nat)),bool,aTP_Lamp_axu(set(product_prod(nat,nat)),bool),Uu))
    <=> ? [X3: product_prod(nat,nat)] :
          ( pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),intrel,X3),X3))
          & ( Uu = aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),intrel,X3)) ) ) ) ).

% ATP.lambda_66
tff(fact_6232_ATP_Olambda__67,axiom,
    ! [A: $tType,Uu: product_prod(A,A)] :
      ( pp(aa(product_prod(A,A),bool,aTP_Lamp_ir(product_prod(A,A),bool),Uu))
    <=> ? [X3: A] : ( Uu = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),X3) ) ) ).

% ATP.lambda_67
tff(fact_6233_ATP_Olambda__68,axiom,
    ! [A: $tType,B: $tType,Uu: product_prod(product_prod(bool,A),product_prod(bool,B))] :
      ( pp(aa(product_prod(product_prod(bool,A),product_prod(bool,B)),bool,aTP_Lamp_bc(product_prod(product_prod(bool,A),product_prod(bool,B)),bool),Uu))
    <=> ? [X3: A,Y4: B] : ( Uu = aa(product_prod(bool,B),product_prod(product_prod(bool,A),product_prod(bool,B)),aa(product_prod(bool,A),fun(product_prod(bool,B),product_prod(product_prod(bool,A),product_prod(bool,B))),product_Pair(product_prod(bool,A),product_prod(bool,B)),aa(A,product_prod(bool,A),aa(bool,fun(A,product_prod(bool,A)),product_Pair(bool,A),fTrue),X3)),aa(B,product_prod(bool,B),aa(bool,fun(B,product_prod(bool,B)),product_Pair(bool,B),fFalse),Y4)) ) ) ).

% ATP.lambda_68
tff(fact_6234_ATP_Olambda__69,axiom,
    ! [A: $tType,B: $tType,Uu: product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))] :
      ( pp(aa(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),bool,aTP_Lamp_ayk(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),bool),Uu))
    <=> ? [F8: fun(nat,sum_sum(B,nat)),X3: sum_sum(A,nat),K6: nat] :
          ( ( Uu = aa(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),aa(fun(nat,sum_sum(B,nat)),fun(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))),product_Pair(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),F8),X3) )
          & ( aa(nat,sum_sum(B,nat),F8,K6) = aa(nat,sum_sum(B,nat),sum_Inr(nat,B),zero_zero(nat)) ) ) ) ).

% ATP.lambda_69
tff(fact_6235_ATP_Olambda__70,axiom,
    ! [B: $tType,A: $tType,Uu: B] : ( aa(B,heap_Time_Heap(A),aTP_Lamp_bar(B,heap_Time_Heap(A)),Uu) = heap_Time_Heap2(A,aTP_Lamp_aww(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))) ) ).

% ATP.lambda_70
tff(fact_6236_ATP_Olambda__71,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A)] : ( aa(array(A),heap_Time_Heap(product_unit),aTP_Lamp_axs(array(A),heap_Time_Heap(product_unit)),Uu) = heap_Time_ureturn(product_unit,product_Unity) ) ) ).

% ATP.lambda_71
tff(fact_6237_ATP_Olambda__72,axiom,
    ! [B: $tType,Uu: nat] : ( aa(nat,sum_sum(B,nat),aTP_Lamp_ayw(nat,sum_sum(B,nat)),Uu) = aa(nat,sum_sum(B,nat),sum_Inr(nat,B),zero_zero(nat)) ) ).

% ATP.lambda_72
tff(fact_6238_ATP_Olambda__73,axiom,
    ! [A: $tType,Uu: nat] : ( aa(nat,sum_sum(A,nat),aTP_Lamp_ayr(nat,sum_sum(A,nat)),Uu) = aa(nat,sum_sum(A,nat),sum_Inr(nat,A),zero_zero(nat)) ) ).

% ATP.lambda_73
tff(fact_6239_ATP_Olambda__74,axiom,
    ! [Uu: num,Uua: nat] : ( aa(nat,option(num),aTP_Lamp_abk(num,fun(nat,option(num)),Uu),Uua) = case_num(option(num),aa(num,option(num),some(num),one2),aTP_Lamp_abi(nat,fun(num,option(num)),Uua),aTP_Lamp_abj(nat,fun(num,option(num)),Uua),Uu) ) ).

% ATP.lambda_74
tff(fact_6240_ATP_Olambda__75,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_yv(nat,fun(nat,A),Uu),Uua) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_75
tff(fact_6241_ATP_Olambda__76,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: product_prod(A,C),Uua: product_prod(C,B)] : ( aa(product_prod(C,B),list(product_prod(A,B)),aTP_Lamp_ala(product_prod(A,C),fun(product_prod(C,B),list(product_prod(A,B))),Uu),Uua) = if(list(product_prod(A,B)),aa(C,bool,aa(C,fun(C,bool),fequal(C),aa(product_prod(A,C),C,product_snd(A,C),Uu)),aa(product_prod(C,B),C,product_fst(C,B),Uua)),aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(product_prod(A,C),A,product_fst(A,C),Uu)),aa(product_prod(C,B),B,product_snd(C,B),Uua))),nil(product_prod(A,B))),nil(product_prod(A,B))) ) ).

% ATP.lambda_76
tff(fact_6242_ATP_Olambda__77,axiom,
    ! [A: $tType,Uu: list(A),Uua: nat] : ( aa(nat,option(A),aTP_Lamp_ajh(list(A),fun(nat,option(A)),Uu),Uua) = if(option(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uua),aa(list(A),nat,size_size(list(A)),Uu)),aa(A,option(A),some(A),aa(nat,A,nth(A,Uu),Uua)),none(A)) ) ).

% ATP.lambda_77
tff(fact_6243_ATP_Olambda__78,axiom,
    ! [Uu: code_integer,Uua: code_integer] : ( aa(code_integer,int,aa(code_integer,fun(code_integer,int),aTP_Lamp_zm(code_integer,fun(code_integer,int)),Uu),Uua) = if(int,aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uua),zero_zero(code_integer)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(code_integer,int,code_int_of_integer,Uu)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(code_integer,int,code_int_of_integer,Uu))),one_one(int))) ) ).

% ATP.lambda_78
tff(fact_6244_ATP_Olambda__79,axiom,
    ! [Uu: code_integer,Uua: code_integer] : ( aa(code_integer,num,aa(code_integer,fun(code_integer,num),aTP_Lamp_zi(code_integer,fun(code_integer,num)),Uu),Uua) = if(num,aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uua),zero_zero(code_integer)),aa(num,num,aa(num,fun(num,num),plus_plus(num),code_num_of_integer(Uu)),code_num_of_integer(Uu)),aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),plus_plus(num),code_num_of_integer(Uu)),code_num_of_integer(Uu))),one2)) ) ).

% ATP.lambda_79
tff(fact_6245_ATP_Olambda__80,axiom,
    ! [Uu: code_integer,Uua: code_integer] : ( aa(code_integer,nat,aa(code_integer,fun(code_integer,nat),aTP_Lamp_zj(code_integer,fun(code_integer,nat)),Uu),Uua) = if(nat,aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uua),zero_zero(code_integer)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),code_nat_of_integer(Uu)),code_nat_of_integer(Uu)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),code_nat_of_integer(Uu)),code_nat_of_integer(Uu))),one_one(nat))) ) ).

% ATP.lambda_80
tff(fact_6246_ATP_Olambda__81,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_abd(int,fun(int,product_prod(int,int))),Uu),Uua) = if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),fequal(int),Uu),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),Uu)),Uua)),aa(int,int,abs_abs(int),Uu))) ) ).

% ATP.lambda_81
tff(fact_6247_ATP_Olambda__82,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_acg(int,fun(int,product_prod(int,int))),Uu),Uua) = if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),fequal(int),Uua),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Uu),Uua)) ) ).

% ATP.lambda_82
tff(fact_6248_ATP_Olambda__83,axiom,
    ! [A: $tType,Uu: set(fun(A,nat)),Uua: A] : ( aa(A,nat,aa(set(fun(A,nat)),fun(A,nat),aTP_Lamp_apk(set(fun(A,nat)),fun(A,nat)),Uu),Uua) = if(nat,aa(set(fun(A,nat)),bool,aa(set(fun(A,nat)),fun(set(fun(A,nat)),bool),fequal(set(fun(A,nat))),Uu),bot_bot(set(fun(A,nat)))),zero_zero(nat),aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(fun(A,nat)),set(nat),image2(fun(A,nat),nat,aTP_Lamp_apf(A,fun(fun(A,nat),nat),Uua)),Uu))) ) ).

% ATP.lambda_83
tff(fact_6249_ATP_Olambda__84,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_yu(nat,fun(nat,A),Uu),Uua) = if(A,aa(bool,bool,fNot,aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_84
tff(fact_6250_ATP_Olambda__85,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ahc(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,compow(fun(A,A),Uua,Uu),top_top(A)) ) ) ).

% ATP.lambda_85
tff(fact_6251_ATP_Olambda__86,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_aha(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,compow(fun(A,A),Uua,Uu),bot_bot(A)) ) ) ).

% ATP.lambda_86
tff(fact_6252_ATP_Olambda__87,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_aon(list(list(A)),fun(list(A),bool),Uu),Uua))
    <=> pp(aa(list(list(A)),bool,aa(list(A),fun(list(list(A)),bool),list_all2(A,list(A),aTP_Lamp_aom(A,fun(list(A),bool))),Uua),Uu)) ) ).

% ATP.lambda_87
tff(fact_6253_ATP_Olambda__88,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [Uu: option(A),Uua: A] : ( aa(A,option(A),aTP_Lamp_abh(option(A),fun(A,option(A)),Uu),Uua) = case_option(option(A),A,none(A),aTP_Lamp_abg(A,fun(A,option(A)),Uua),Uu) ) ) ).

% ATP.lambda_88
tff(fact_6254_ATP_Olambda__89,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Uu: option(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_aae(option(A),fun(A,bool),Uu),Uua))
        <=> pp(case_option(bool,A,fTrue,aa(A,fun(A,bool),aTP_Lamp_aad(A,fun(A,bool)),Uua),Uu)) ) ) ).

% ATP.lambda_89
tff(fact_6255_ATP_Olambda__90,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aa(nat,fun(num,option(num)),aTP_Lamp_abl(nat,fun(num,option(num))),Uu),Uua) = aa(nat,option(num),aa(fun(nat,option(num)),fun(nat,option(num)),aa(option(num),fun(fun(nat,option(num)),fun(nat,option(num))),case_nat(option(num)),none(num)),aTP_Lamp_abk(num,fun(nat,option(num)),Uua)),Uu) ) ).

% ATP.lambda_90
tff(fact_6256_ATP_Olambda__91,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Uu: option(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_aaf(option(A),fun(A,bool),Uu),Uua))
        <=> pp(case_option(bool,A,fFalse,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_91
tff(fact_6257_ATP_Olambda__92,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_abi(nat,fun(num,option(num)),Uu),Uua) = case_option(option(num),num,none(num),aTP_Lamp_abc(num,option(num)),bit_take_bit_num(Uu,Uua)) ) ).

% ATP.lambda_92
tff(fact_6258_ATP_Olambda__93,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aTP_Lamp_ev(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),Uu),Uua))
    <=> pp(aa(B,bool,aa(A,fun(B,bool),Uu,aa(product_prod(A,B),A,product_fst(A,B),Uua)),aa(product_prod(A,B),B,product_snd(A,B),Uua))) ) ).

% ATP.lambda_93
tff(fact_6259_ATP_Olambda__94,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(A,fun(A,A)),Uua: A] : ( aa(A,A,aTP_Lamp_mo(fun(A,fun(A,A)),fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),Uu,Uua),Uua) ) ) ).

% ATP.lambda_94
tff(fact_6260_ATP_Olambda__95,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: nat] : ( aa(nat,list(A),aTP_Lamp_alt(list(list(A)),fun(nat,list(A)),Uu),Uua) = aa(list(nat),list(A),map(nat,A,aa(nat,fun(nat,A),aTP_Lamp_als(list(list(A)),fun(nat,fun(nat,A)),Uu),Uua)),upt(zero_zero(nat),aa(list(list(A)),nat,size_size(list(list(A))),Uu))) ) ).

% ATP.lambda_95
tff(fact_6261_ATP_Olambda__96,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_rh(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_rg(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua)),aa(nat,set(nat),set_ord_atMost(nat),Uua)) ) ) ).

% ATP.lambda_96
tff(fact_6262_ATP_Olambda__97,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_rf(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_re(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua)),aa(nat,set(nat),set_ord_atMost(nat),Uua)) ) ) ).

% ATP.lambda_97
tff(fact_6263_ATP_Olambda__98,axiom,
    ! [Uu: product_prod(int,int),Uua: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aa(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),aTP_Lamp_abq(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),Uu),Uua) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uua)),aa(product_prod(int,int),int,product_snd(int,int),Uu)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))) ) ).

% ATP.lambda_98
tff(fact_6264_ATP_Olambda__99,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_up(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),Uua))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_99
tff(fact_6265_ATP_Olambda__100,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_yk(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua))),Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)) ) ) ).

% ATP.lambda_100
tff(fact_6266_ATP_Olambda__101,axiom,
    ! [Uu: product_prod(int,int),Uua: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aa(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),aTP_Lamp_abu(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),Uu),Uua) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_fst(int,int),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))) ) ).

% ATP.lambda_101
tff(fact_6267_ATP_Olambda__102,axiom,
    ! [B: $tType,A: $tType,Uu: set(old_node(A,B)),Uua: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_aze(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),Uu),Uua) = aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),insert(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_In1(A,B,Uu)),old_In1(A,B,Uua))),bot_bot(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))) ) ).

% ATP.lambda_102
tff(fact_6268_ATP_Olambda__103,axiom,
    ! [B: $tType,A: $tType,Uu: set(old_node(A,B)),Uua: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_azd(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),Uu),Uua) = aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),insert(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_In0(A,B,Uu)),old_In0(A,B,Uua))),bot_bot(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))) ) ).

% ATP.lambda_103
tff(fact_6269_ATP_Olambda__104,axiom,
    ! [A2: $tType,A: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(A2,A2))] :
      ( pp(aa(set(product_prod(A2,A2)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool),aTP_Lamp_aga(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool)),Uu),Uua))
    <=> ( order_well_order_on(A,field2(A,Uu),Uu)
        & order_well_order_on(A2,field2(A2,Uua),Uua)
        & ? [X_12: fun(A,A2)] : bNF_Wellorder_embedS(A,A2,Uu,Uua,X_12) ) ) ).

% ATP.lambda_104
tff(fact_6270_ATP_Olambda__105,axiom,
    ! [A2: $tType,A: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(A2,A2))] :
      ( pp(aa(set(product_prod(A2,A2)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool),aTP_Lamp_agf(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool)),Uu),Uua))
    <=> ( order_well_order_on(A,field2(A,Uu),Uu)
        & order_well_order_on(A2,field2(A2,Uua),Uua)
        & ? [X_12: fun(A,A2)] : pp(aa(fun(A,A2),bool,bNF_Wellorder_embed(A,A2,Uu,Uua),X_12)) ) ) ).

% ATP.lambda_105
tff(fact_6271_ATP_Olambda__106,axiom,
    ! [A2: $tType,A: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(A2,A2))] :
      ( pp(aa(set(product_prod(A2,A2)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool),aTP_Lamp_agd(set(product_prod(A,A)),fun(set(product_prod(A2,A2)),bool)),Uu),Uua))
    <=> ( order_well_order_on(A,field2(A,Uu),Uu)
        & order_well_order_on(A2,field2(A2,Uua),Uua)
        & ? [X_12: fun(A,A2)] : bNF_Wellorder_iso(A,A2,Uu,Uua,X_12) ) ) ).

% ATP.lambda_106
tff(fact_6272_ATP_Olambda__107,axiom,
    ! [Uu: rat,Uua: int] :
      ( pp(aa(int,bool,aTP_Lamp_yd(rat,fun(int,bool),Uu),Uua))
    <=> ( pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),aa(int,rat,ring_1_of_int(rat),Uua)),Uu))
        & pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),Uu),aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),one_one(int))))) ) ) ).

% ATP.lambda_107
tff(fact_6273_ATP_Olambda__108,axiom,
    ! [A: $tType,Uu: set(A),Uua: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_aid(set(A),fun(list(A),bool),Uu),Uua))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uua)),Uu))
        & distinct(A,Uua) ) ) ).

% ATP.lambda_108
tff(fact_6274_ATP_Olambda__109,axiom,
    ! [A: $tType,Uu: set(A),Uua: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_aic(set(A),fun(list(A),bool),Uu),Uua))
    <=> ( ( aa(list(A),set(A),set2(A),Uua) = Uu )
        & distinct(A,Uua) ) ) ).

% ATP.lambda_109
tff(fact_6275_ATP_Olambda__110,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_ub(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_110
tff(fact_6276_ATP_Olambda__111,axiom,
    ! [Uu: rat,Uua: product_prod(int,int)] :
      ( pp(aa(product_prod(int,int),bool,aTP_Lamp_aho(rat,fun(product_prod(int,int),bool),Uu),Uua))
    <=> ( ( Uu = aa(int,rat,aa(int,fun(int,rat),fract,aa(product_prod(int,int),int,product_fst(int,int),Uua)),aa(product_prod(int,int),int,product_snd(int,int),Uua)) )
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),Uua)))
        & algebr8660921524188924756oprime(int,aa(product_prod(int,int),int,product_fst(int,int),Uua),aa(product_prod(int,int),int,product_snd(int,int),Uua)) ) ) ).

% ATP.lambda_111
tff(fact_6277_ATP_Olambda__112,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A] : ( aa(A,set(set(A)),aTP_Lamp_jw(set(product_prod(A,A)),fun(A,set(set(A))),Uu),Uua) = aa(set(set(A)),set(set(A)),insert(set(A),aa(set(A),set(A),image(A,A,Uu),aa(set(A),set(A),insert(A,Uua),bot_bot(set(A))))),bot_bot(set(set(A)))) ) ).

% ATP.lambda_112
tff(fact_6278_ATP_Olambda__113,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_vh(A,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))),Uua) ) ) ).

% ATP.lambda_113
tff(fact_6279_ATP_Olambda__114,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_yp(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uu),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_114
tff(fact_6280_ATP_Olambda__115,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_vo(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)) ) ) ).

% ATP.lambda_115
tff(fact_6281_ATP_Olambda__116,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(list(A),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_avw(array(A),fun(heap_ext(product_unit),product_prod(list(A),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(list(A),product_prod(heap_ext(product_unit),nat)),aa(list(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(list(A),product_prod(heap_ext(product_unit),nat))),product_Pair(list(A),product_prod(heap_ext(product_unit),nat)),array_get(A,Uua,Uu)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),array_length(A,Uua,Uu)))) ) ) ).

% ATP.lambda_116
tff(fact_6282_ATP_Olambda__117,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_abn(nat,fun(nat,bool)),Uu),Uua))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),Uu),Uua))
        & ( Uu != Uua ) ) ) ).

% ATP.lambda_117
tff(fact_6283_ATP_Olambda__118,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(set(A))] :
      ( pp(aa(set(set(A)),bool,aTP_Lamp_tc(set(set(A)),fun(set(set(A)),bool),Uu),Uua))
    <=> ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),Uua),Uu))
        & ( Uua != bot_bot(set(set(A))) ) ) ) ).

% ATP.lambda_118
tff(fact_6284_ATP_Olambda__119,axiom,
    ! [A: $tType,Uu: set(option(A)),Uua: option(A)] :
      ( pp(aa(option(A),bool,aTP_Lamp_abs(set(option(A)),fun(option(A),bool),Uu),Uua))
    <=> ( pp(aa(set(option(A)),bool,member(option(A),Uua),Uu))
        & ( Uua != none(A) ) ) ) ).

% ATP.lambda_119
tff(fact_6285_ATP_Olambda__120,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_yh(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(nat,nat,binomial(Uu),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% ATP.lambda_120
tff(fact_6286_ATP_Olambda__121,axiom,
    ! [Uu: set(int),Uua: int] :
      ( pp(aa(int,bool,aTP_Lamp_adz(set(int),fun(int,bool),Uu),Uua))
    <=> ( pp(aa(set(int),bool,member(int,Uua),Uu))
        & ! [X3: int] :
            ( pp(aa(set(int),bool,member(int,X3),Uu))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X3),Uua)) ) ) ) ).

% ATP.lambda_121
tff(fact_6287_ATP_Olambda__122,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_aea(set(set(A)),fun(set(A),bool),Uu),Uua))
    <=> ( pp(aa(set(set(A)),bool,member(set(A),Uua),Uu))
        & ! [X3: set(A)] :
            ( pp(aa(set(set(A)),bool,member(set(A),X3),Uu))
           => ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),Uua),X3)) ) ) ) ).

% ATP.lambda_122
tff(fact_6288_ATP_Olambda__123,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),aTP_Lamp_afv(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool)),Uu),Uua))
    <=> ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),Uu),Uua))
        & ! [A6: A,B5: A,C5: A] :
            ( ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A6),B5)),Uua))
              & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B5),C5)),Uu)) )
           => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A6),B5)),Uu)) ) ) ) ).

% ATP.lambda_123
tff(fact_6289_ATP_Olambda__124,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(set(A))] :
      ( pp(aa(set(set(A)),bool,aTP_Lamp_jz(set(set(A)),fun(set(set(A)),bool),Uu),Uua))
    <=> ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),Uua),Uu))
        & chain_subset(A,Uua) ) ) ).

% ATP.lambda_124
tff(fact_6290_ATP_Olambda__125,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_lu(set(A),fun(set(A),bool),Uu),Uua))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Uua),Uu))
        & pp(aa(set(A),bool,finite_finite2(A),Uua)) ) ) ).

% ATP.lambda_125
tff(fact_6291_ATP_Olambda__126,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aTP_Lamp_vt(set(A),fun(set(A),bool)),Uu),Uua))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),Uu),Uua))
        & pp(aa(set(A),bool,finite_finite2(A),Uua)) ) ) ).

% ATP.lambda_126
tff(fact_6292_ATP_Olambda__127,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_yc(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uu),Uua)),Uua) ) ).

% ATP.lambda_127
tff(fact_6293_ATP_Olambda__128,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_uh(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uu) ) ).

% ATP.lambda_128
tff(fact_6294_ATP_Olambda__129,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ug(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uua) ) ).

% ATP.lambda_129
tff(fact_6295_ATP_Olambda__130,axiom,
    ! [B: $tType,A: $tType,Uu: set(old_node(A,B)),Uua: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(set(old_node(A,B))),aTP_Lamp_azn(set(old_node(A,B)),fun(set(old_node(A,B)),set(set(old_node(A,B)))),Uu),Uua) = aa(set(set(old_node(A,B))),set(set(old_node(A,B))),insert(set(old_node(A,B)),old_Scons(A,B,Uu,Uua)),bot_bot(set(set(old_node(A,B))))) ) ).

% ATP.lambda_130
tff(fact_6296_ATP_Olambda__131,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: A] : ( aa(A,set(product_prod(B,A)),aTP_Lamp_lm(B,fun(A,set(product_prod(B,A))),Uu),Uua) = aa(set(product_prod(B,A)),set(product_prod(B,A)),insert(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uu),Uua)),bot_bot(set(product_prod(B,A)))) ) ).

% ATP.lambda_131
tff(fact_6297_ATP_Olambda__132,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] : ( aa(B,set(product_prod(A,B)),aTP_Lamp_ha(A,fun(B,set(product_prod(A,B))),Uu),Uua) = aa(set(product_prod(A,B)),set(product_prod(A,B)),insert(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uu),Uua)),bot_bot(set(product_prod(A,B)))) ) ).

% ATP.lambda_132
tff(fact_6298_ATP_Olambda__133,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_yi(A,fun(A,bool),Uu),Uua))
        <=> ( pp(aa(set(A),bool,member(A,Uua),ring_1_Ints(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),Uua)),Uu)) ) ) ) ).

% ATP.lambda_133
tff(fact_6299_ATP_Olambda__134,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aTP_Lamp_auv(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),Uu),Uua))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),aa(set(product_prod(A,B)),set(product_prod(A,B)),insert(product_prod(A,B),Uua),bot_bot(set(product_prod(A,B))))),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Uu)))) ) ).

% ATP.lambda_134
tff(fact_6300_ATP_Olambda__135,axiom,
    ! [D: $tType,B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(D,product_prod(A,B))] :
      ( pp(aa(fun(D,product_prod(A,B)),bool,aTP_Lamp_fc(fun(A,fun(B,bool)),fun(fun(D,product_prod(A,B)),bool),Uu),Uua))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),aa(set(D),set(product_prod(A,B)),image2(D,product_prod(A,B),Uua),top_top(set(D)))),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Uu)))) ) ).

% ATP.lambda_135
tff(fact_6301_ATP_Olambda__136,axiom,
    ! [A: $tType,Uu: fun(set(A),bool),Uua: set(A)] :
      ( pp(aa(set(A),bool,aa(fun(set(A),bool),fun(set(A),bool),aTP_Lamp_lh(fun(set(A),bool),fun(set(A),bool)),Uu),Uua))
    <=> ( ( Uua = bot_bot(set(A)) )
        | ? [A12: set(A),A6: A] :
            ( ( Uua = aa(set(A),set(A),insert(A,A6),A12) )
            & pp(aa(set(A),bool,Uu,A12)) ) ) ) ).

% ATP.lambda_136
tff(fact_6302_ATP_Olambda__137,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: fun(A,B)] :
      ( pp(aa(fun(A,B),bool,aTP_Lamp_agk(set(B),fun(fun(A,B),bool),Uu),Uua))
    <=> pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image2(A,B,Uua),top_top(set(A)))),Uu)) ) ).

% ATP.lambda_137
tff(fact_6303_ATP_Olambda__138,axiom,
    ! [D: $tType,A: $tType,Uu: set(A),Uua: fun(D,A)] :
      ( pp(aa(fun(D,A),bool,aTP_Lamp_are(set(A),fun(fun(D,A),bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(D),set(A),image2(D,A,Uua),top_top(set(D)))),Uu)) ) ).

% ATP.lambda_138
tff(fact_6304_ATP_Olambda__139,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A] : ( aa(A,set(set(A)),aTP_Lamp_jx(set(product_prod(A,A)),fun(A,set(set(A))),Uu),Uua) = equiv_quotient(A,aa(set(A),set(A),insert(A,Uua),bot_bot(set(A))),Uu) ) ).

% ATP.lambda_139
tff(fact_6305_ATP_Olambda__140,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: set(A),Uua: list(A)] :
          ( pp(aa(list(A),bool,aTP_Lamp_alh(set(A),fun(list(A),bool),Uu),Uua))
        <=> ( sorted_wrt(A,ord_less(A),Uua)
            & ( aa(list(A),set(A),set2(A),Uua) = Uu ) ) ) ) ).

% ATP.lambda_140
tff(fact_6306_ATP_Olambda__141,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_uw(set(product_prod(A,A)),fun(nat,bool),Uu),Uua))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),Uua))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uua),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),Uu))) ) ) ).

% ATP.lambda_141
tff(fact_6307_ATP_Olambda__142,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_vs(nat,fun(nat,bool),Uu),Uua))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),Uua))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uua),aa(nat,nat,suc,Uu))) ) ) ).

% ATP.lambda_142
tff(fact_6308_ATP_Olambda__143,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,product_prod(A,B)),Uua: A] : ( aa(A,set(B),aTP_Lamp_en(fun(C,product_prod(A,B)),fun(A,set(B)),Uu),Uua) = aa(set(C),set(B),image2(C,B,aa(fun(C,product_prod(A,B)),fun(C,B),comp(product_prod(A,B),B,C,product_snd(A,B)),Uu)),top_top(set(C))) ) ).

% ATP.lambda_143
tff(fact_6309_ATP_Olambda__144,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_yg(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))),aa(nat,A,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))) ) ) ).

% ATP.lambda_144
tff(fact_6310_ATP_Olambda__145,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_yf(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))),aa(nat,A,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))) ) ) ).

% ATP.lambda_145
tff(fact_6311_ATP_Olambda__146,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_sw(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,aa(nat,nat,suc,Uua))),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_146
tff(fact_6312_ATP_Olambda__147,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_wi(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_147
tff(fact_6313_ATP_Olambda__148,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_wg(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_148
tff(fact_6314_ATP_Olambda__149,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_rq(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_149
tff(fact_6315_ATP_Olambda__150,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ta(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_150
tff(fact_6316_ATP_Olambda__151,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_sk(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_151
tff(fact_6317_ATP_Olambda__152,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_sz(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_152
tff(fact_6318_ATP_Olambda__153,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(A,bool),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_afp(fun(A,bool),fun(A,bool),Uu),Uua))
        <=> ( pp(aa(A,bool,Uu,Uua))
            & ! [Y4: A] :
                ( pp(aa(A,bool,Uu,Y4))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Y4)) ) ) ) ) ).

% ATP.lambda_153
tff(fact_6319_ATP_Olambda__154,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: fun(A,bool),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_afs(fun(A,bool),fun(A,bool),Uu),Uua))
        <=> ( pp(aa(A,bool,Uu,Uua))
            & ! [Y4: A] :
                ( pp(aa(A,bool,Uu,Y4))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),Uua)) ) ) ) ) ).

% ATP.lambda_154
tff(fact_6320_ATP_Olambda__155,axiom,
    ! [A: $tType,Uu: fun(multiset(A),bool),Uua: multiset(A)] :
      ( pp(aa(multiset(A),bool,aTP_Lamp_ato(fun(multiset(A),bool),fun(multiset(A),bool),Uu),Uua))
    <=> ( pp(aa(multiset(A),bool,Uu,Uua))
        & ! [Y4: multiset(A)] :
            ( pp(aa(multiset(A),bool,Uu,Y4))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Uua),Y4)) ) ) ) ).

% ATP.lambda_155
tff(fact_6321_ATP_Olambda__156,axiom,
    ! [A: $tType,Uu: fun(multiset(A),bool),Uua: multiset(A)] :
      ( pp(aa(multiset(A),bool,aTP_Lamp_atu(fun(multiset(A),bool),fun(multiset(A),bool),Uu),Uua))
    <=> ( pp(aa(multiset(A),bool,Uu,Uua))
        & ! [Y4: multiset(A)] :
            ( pp(aa(multiset(A),bool,Uu,Y4))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Y4),Uua)) ) ) ) ).

% ATP.lambda_156
tff(fact_6322_ATP_Olambda__157,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_ve(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),Uu,Uua)),aa(nat,set(nat),set_ord_lessThan(nat),Uua)) ) ) ).

% ATP.lambda_157
tff(fact_6323_ATP_Olambda__158,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_vb(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),Uu,Uua)),aa(nat,set(nat),set_ord_lessThan(nat),Uua)) ) ) ).

% ATP.lambda_158
tff(fact_6324_ATP_Olambda__159,axiom,
    ! [B: $tType,Uu: fun(nat,sum_sum(B,nat)),Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_ayu(fun(nat,sum_sum(B,nat)),fun(nat,bool),Uu),Uua))
    <=> ( aa(nat,sum_sum(B,nat),Uu,Uua) = aa(nat,sum_sum(B,nat),sum_Inr(nat,B),zero_zero(nat)) ) ) ).

% ATP.lambda_159
tff(fact_6325_ATP_Olambda__160,axiom,
    ! [A: $tType,Uu: fun(nat,sum_sum(A,nat)),Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_ayg(fun(nat,sum_sum(A,nat)),fun(nat,bool),Uu),Uua))
    <=> ( aa(nat,sum_sum(A,nat),Uu,Uua) = aa(nat,sum_sum(A,nat),sum_Inr(nat,A),zero_zero(nat)) ) ) ).

% ATP.lambda_160
tff(fact_6326_ATP_Olambda__161,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(A,A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_mu(fun(A,A),fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,Uu,Uua)),Uua)) ) ) ).

% ATP.lambda_161
tff(fact_6327_ATP_Olambda__162,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] : ( aa(A,product_prod(nat,A),aTP_Lamp_aus(fun(A,nat),fun(A,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),aa(A,nat,Uu,Uua)),Uua) ) ).

% ATP.lambda_162
tff(fact_6328_ATP_Olambda__163,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,product_prod(B,A),aTP_Lamp_dn(fun(A,B),fun(A,product_prod(B,A)),Uu),Uua) = aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),aa(A,B,Uu,Uua)),Uua) ) ).

% ATP.lambda_163
tff(fact_6329_ATP_Olambda__164,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: B] : ( aa(B,list(A),aTP_Lamp_ajw(fun(B,A),fun(B,list(A)),Uu),Uua) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),aa(B,A,Uu,Uua)),nil(A)) ) ).

% ATP.lambda_164
tff(fact_6330_ATP_Olambda__165,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: B] : ( aa(B,set(A),aTP_Lamp_gy(fun(B,A),fun(B,set(A)),Uu),Uua) = aa(set(A),set(A),insert(A,aa(B,A,Uu,Uua)),bot_bot(set(A))) ) ).

% ATP.lambda_165
tff(fact_6331_ATP_Olambda__166,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: B] :
          ( pp(aa(B,bool,aTP_Lamp_pu(fun(B,A),fun(B,bool),Uu),Uua))
        <=> ( aa(B,A,Uu,Uua) = zero_zero(A) ) ) ) ).

% ATP.lambda_166
tff(fact_6332_ATP_Olambda__167,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: B] :
          ( pp(aa(B,bool,aTP_Lamp_pr(fun(B,A),fun(B,bool),Uu),Uua))
        <=> ( aa(B,A,Uu,Uua) = one_one(A) ) ) ) ).

% ATP.lambda_167
tff(fact_6333_ATP_Olambda__168,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: list(A),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_avs(list(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avr(list(A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(A,Uu,Uua)) ) ) ).

% ATP.lambda_168
tff(fact_6334_ATP_Olambda__169,axiom,
    ! [A: $tType,Uu: list(fun(A,nat)),Uua: A] : ( aa(A,list(nat),aTP_Lamp_aut(list(fun(A,nat)),fun(A,list(nat)),Uu),Uua) = aa(list(fun(A,nat)),list(nat),map(fun(A,nat),nat,aTP_Lamp_apf(A,fun(fun(A,nat),nat),Uua)),Uu) ) ).

% ATP.lambda_169
tff(fact_6335_ATP_Olambda__170,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A)] : ( aa(list(A),list(list(A)),aTP_Lamp_akz(list(A),fun(list(A),list(list(A))),Uu),Uua) = aa(list(A),list(list(A)),map(A,list(A),aa(list(A),fun(A,list(A)),aTP_Lamp_aio(list(A),fun(A,list(A))),Uua)),Uu) ) ).

% ATP.lambda_170
tff(fact_6336_ATP_Olambda__171,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_bbg(nat,fun(nat,nat)),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua))),Uu) ) ).

% ATP.lambda_171
tff(fact_6337_ATP_Olambda__172,axiom,
    ! [Uu: num,Uua: num] : ( aa(num,int,aTP_Lamp_aac(num,fun(num,int),Uu),Uua) = bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),Uu),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),Uu))),aa(num,int,numeral_numeral(int),Uua))) ) ).

% ATP.lambda_172
tff(fact_6338_ATP_Olambda__173,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_mz(set(A),fun(set(A),bool),Uu),Uua))
    <=> ( pp(aa(set(A),bool,finite_finite2(A),Uua))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Uua),Uu)) ) ) ).

% ATP.lambda_173
tff(fact_6339_ATP_Olambda__174,axiom,
    ! [Uu: assn,Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aTP_Lamp_aj(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uu),Uua))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,Uua))
        & ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Uu),Uua)) ) ) ).

% ATP.lambda_174
tff(fact_6340_ATP_Olambda__175,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aTP_Lamp_bg(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uu),Uua))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,Uua))
        & ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Uu,Uua)) ) ) ).

% ATP.lambda_175
tff(fact_6341_ATP_Olambda__176,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: heap_Time_Heap(product_prod(A,B))] :
      ( pp(aa(heap_Time_Heap(product_prod(A,B)),bool,aTP_Lamp_bbq(fun(A,fun(B,bool)),fun(heap_Time_Heap(product_prod(A,B)),bool),Uu),Uua))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),heap_Time_set_Heap(product_prod(A,B),Uua)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Uu)))) ) ).

% ATP.lambda_176
tff(fact_6342_ATP_Olambda__177,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: option(product_prod(A,B))] :
      ( pp(aa(option(product_prod(A,B)),bool,aTP_Lamp_avd(fun(A,fun(B,bool)),fun(option(product_prod(A,B)),bool),Uu),Uua))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),set_option(product_prod(A,B),Uua)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Uu)))) ) ).

% ATP.lambda_177
tff(fact_6343_ATP_Olambda__178,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: array(product_prod(A,B))] :
      ( pp(aa(array(product_prod(A,B)),bool,aTP_Lamp_bbn(fun(A,fun(B,bool)),fun(array(product_prod(A,B)),bool),Uu),Uua))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),set_array(product_prod(A,B),Uua)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Uu)))) ) ).

% ATP.lambda_178
tff(fact_6344_ATP_Olambda__179,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: multiset(product_prod(A,B))] :
      ( pp(aa(multiset(product_prod(A,B)),bool,aTP_Lamp_api(fun(A,fun(B,bool)),fun(multiset(product_prod(A,B)),bool),Uu),Uua))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),aa(multiset(product_prod(A,B)),set(product_prod(A,B)),set_mset(product_prod(A,B)),Uua)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Uu)))) ) ).

% ATP.lambda_179
tff(fact_6345_ATP_Olambda__180,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: ref(product_prod(A,B))] :
      ( pp(aa(ref(product_prod(A,B)),bool,aTP_Lamp_bbm(fun(A,fun(B,bool)),fun(ref(product_prod(A,B)),bool),Uu),Uua))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),set_ref(product_prod(A,B),Uua)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Uu)))) ) ).

% ATP.lambda_180
tff(fact_6346_ATP_Olambda__181,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: list(product_prod(A,B))] :
      ( pp(aa(list(product_prod(A,B)),bool,aTP_Lamp_aod(fun(A,fun(B,bool)),fun(list(product_prod(A,B)),bool),Uu),Uua))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Uua)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Uu)))) ) ).

% ATP.lambda_181
tff(fact_6347_ATP_Olambda__182,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: set(set(A))] : ( aa(set(set(A)),set(A),aTP_Lamp_ark(fun(A,fun(B,bool)),fun(set(set(A)),set(A)),Uu),Uua) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),Uua)),aa(fun(A,bool),set(A),collect(A),aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),Uu))) ) ).

% ATP.lambda_182
tff(fact_6348_ATP_Olambda__183,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: set(A)] : ( aa(set(A),set(A),aTP_Lamp_arn(fun(A,fun(B,bool)),fun(set(A),set(A)),Uu),Uua) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),Uua)),aa(fun(A,bool),set(A),collect(A),aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),Uu))) ) ).

% ATP.lambda_183
tff(fact_6349_ATP_Olambda__184,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [Uu: product_prod(A,B),Uua: product_prod(A,B)] :
          ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),aTP_Lamp_ale(product_prod(A,B),fun(product_prod(A,B),bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(product_prod(A,B),A,product_fst(A,B),Uu)),aa(product_prod(A,B),A,product_fst(A,B),Uua))) ) ) ).

% ATP.lambda_184
tff(fact_6350_ATP_Olambda__185,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [Uu: product_prod(A,B),Uua: product_prod(A,B)] :
          ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),aTP_Lamp_all(product_prod(A,B),fun(product_prod(A,B),bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(product_prod(A,B),A,product_fst(A,B),Uua)),aa(product_prod(A,B),A,product_fst(A,B),Uu))) ) ) ).

% ATP.lambda_185
tff(fact_6351_ATP_Olambda__186,axiom,
    ! [A: $tType,Uu: list(option(A)),Uua: A] : ( aa(A,option(list(A)),aTP_Lamp_avb(list(option(A)),fun(A,option(list(A))),Uu),Uua) = aa(option(list(A)),option(list(A)),map_option(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uua)),those(A,Uu)) ) ).

% ATP.lambda_186
tff(fact_6352_ATP_Olambda__187,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_xa(nat,fun(nat,A)),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),Uu)),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_187
tff(fact_6353_ATP_Olambda__188,axiom,
    ! [Uu: num,Uua: num] : ( aa(num,int,aa(num,fun(num,int),aTP_Lamp_ya(num,fun(num,int)),Uu),Uua) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Uu)),aa(num,int,numeral_numeral(int),Uua)) ) ).

% ATP.lambda_188
tff(fact_6354_ATP_Olambda__189,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: A] : ( aa(A,list(list(A)),aTP_Lamp_akv(list(list(A)),fun(A,list(list(A))),Uu),Uua) = aa(list(list(A)),list(list(A)),map(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uua)),product_lists(A,Uu)) ) ).

% ATP.lambda_189
tff(fact_6355_ATP_Olambda__190,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,rat,aa(nat,fun(nat,rat),aTP_Lamp_azr(nat,fun(nat,rat)),Uu),Uua) = aa(int,rat,aa(int,fun(int,rat),fract,nat_int_decode(Uu)),nat_int_decode(Uua)) ) ).

% ATP.lambda_190
tff(fact_6356_ATP_Olambda__191,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_ajn(list(A),fun(list(A),bool)),Uu),Uua))
    <=> ( aa(list(A),nat,size_size(list(A)),Uu) = aa(list(A),nat,size_size(list(A)),Uua) ) ) ).

% ATP.lambda_191
tff(fact_6357_ATP_Olambda__192,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_aok(list(A),fun(list(A),bool),Uu),Uua))
    <=> ( mset(A,Uua) = mset(A,Uu) ) ) ).

% ATP.lambda_192
tff(fact_6358_ATP_Olambda__193,axiom,
    ! [A: $tType,Uu: set(A),Uua: heap_Time_Heap(A)] :
      ( pp(aa(heap_Time_Heap(A),bool,aTP_Lamp_bbr(set(A),fun(heap_Time_Heap(A),bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),heap_Time_set_Heap(A,Uua)),Uu)) ) ).

% ATP.lambda_193
tff(fact_6359_ATP_Olambda__194,axiom,
    ! [A: $tType,Uu: set(A),Uua: option(A)] :
      ( pp(aa(option(A),bool,aTP_Lamp_avc(set(A),fun(option(A),bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_option(A,Uua)),Uu)) ) ).

% ATP.lambda_194
tff(fact_6360_ATP_Olambda__195,axiom,
    ! [A: $tType,Uu: set(A),Uua: array(A)] :
      ( pp(aa(array(A),bool,aTP_Lamp_bbp(set(A),fun(array(A),bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_array(A,Uua)),Uu)) ) ).

% ATP.lambda_195
tff(fact_6361_ATP_Olambda__196,axiom,
    ! [A: $tType,Uu: set(A),Uua: multiset(A)] :
      ( pp(aa(multiset(A),bool,aTP_Lamp_ard(set(A),fun(multiset(A),bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(multiset(A),set(A),set_mset(A),Uua)),Uu)) ) ).

% ATP.lambda_196
tff(fact_6362_ATP_Olambda__197,axiom,
    ! [A: $tType,Uu: set(A),Uua: ref(A)] :
      ( pp(aa(ref(A),bool,aTP_Lamp_bbo(set(A),fun(ref(A),bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),set_ref(A,Uua)),Uu)) ) ).

% ATP.lambda_197
tff(fact_6363_ATP_Olambda__198,axiom,
    ! [A: $tType,Uu: set(A),Uua: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_anw(set(A),fun(list(A),bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uua)),Uu)) ) ).

% ATP.lambda_198
tff(fact_6364_ATP_Olambda__199,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_vq(nat,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),Uua)),Uu) ) ) ).

% ATP.lambda_199
tff(fact_6365_ATP_Olambda__200,axiom,
    ! [A: $tType,B: $tType,Uu: list(B),Uua: A] : ( aa(A,list(product_prod(A,B)),aTP_Lamp_aku(list(B),fun(A,list(product_prod(A,B))),Uu),Uua) = aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua)),Uu) ) ).

% ATP.lambda_200
tff(fact_6366_ATP_Olambda__201,axiom,
    ! [A: $tType,Uu: set(nat),Uua: product_prod(A,nat)] :
      ( pp(aa(product_prod(A,nat),bool,aTP_Lamp_alp(set(nat),fun(product_prod(A,nat),bool),Uu),Uua))
    <=> pp(aa(set(nat),bool,member(nat,aa(product_prod(A,nat),nat,product_snd(A,nat),Uua)),Uu)) ) ).

% ATP.lambda_201
tff(fact_6367_ATP_Olambda__202,axiom,
    ! [Uu: set(nat),Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_anc(set(nat),fun(nat,bool),Uu),Uua))
    <=> pp(aa(set(nat),bool,member(nat,aa(nat,nat,suc,Uua)),Uu)) ) ).

% ATP.lambda_202
tff(fact_6368_ATP_Olambda__203,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_aoa(nat,fun(list(A),bool),Uu),Uua))
    <=> ( aa(list(A),nat,size_size(list(A)),Uua) = Uu ) ) ).

% ATP.lambda_203
tff(fact_6369_ATP_Olambda__204,axiom,
    ! [Uu: heap_ext(product_unit),Uua: nat] : ( aa(nat,nat,aTP_Lamp_avv(heap_ext(product_unit),fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),lim(product_unit,Uu)),one_one(nat)) ) ).

% ATP.lambda_204
tff(fact_6370_ATP_Olambda__205,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(A,A))] : ( aa(set(product_prod(A,A)),set(set(product_prod(A,A))),aTP_Lamp_agb(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(set(product_prod(A,A)))),Uu),Uua) = aa(set(set(product_prod(A,A))),set(set(product_prod(A,A))),image(set(product_prod(A,A)),set(product_prod(A,A)),converse(set(product_prod(A,A)),set(product_prod(A,A)),bNF_We4044943003108391690rdLess(A,A))),aa(set(set(product_prod(A,A))),set(set(product_prod(A,A))),insert(set(product_prod(A,A)),Uu),bot_bot(set(set(product_prod(A,A)))))) ) ).

% ATP.lambda_205
tff(fact_6371_ATP_Olambda__206,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_zh(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),one_one(A))) ) ) ).

% ATP.lambda_206
tff(fact_6372_ATP_Olambda__207,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_zd(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)) ) ) ).

% ATP.lambda_207
tff(fact_6373_ATP_Olambda__208,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_yb(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Uua)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_208
tff(fact_6374_ATP_Olambda__209,axiom,
    ! [A: $tType,Uu: A,Uua: set(set(A))] : ( aa(set(set(A)),set(set(A)),aa(A,fun(set(set(A)),set(set(A))),aTP_Lamp_ko(A,fun(set(set(A)),set(set(A)))),Uu),Uua) = aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),Uua),aa(set(set(A)),set(set(A)),image2(set(A),set(A),insert(A,Uu)),Uua)) ) ).

% ATP.lambda_209
tff(fact_6375_ATP_Olambda__210,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: list(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_ane(list(A),fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),aa(nat,A,nth(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(A),nat,size_size(list(A)),Uu)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% ATP.lambda_210
tff(fact_6376_ATP_Olambda__211,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: list(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_anf(list(A),fun(A,bool),Uu),Uua))
        <=> ( Uua = aa(nat,A,nth(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(A),nat,size_size(list(A)),Uu)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ) ).

% ATP.lambda_211
tff(fact_6377_ATP_Olambda__212,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ym(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(nat,nat,binomial(Uu),Uua)) ) ).

% ATP.lambda_212
tff(fact_6378_ATP_Olambda__213,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: multiset(A),Uua: A] : ( aa(A,A,aTP_Lamp_aqu(multiset(A),fun(A,A),Uu),Uua) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(A,nat,aa(multiset(A),fun(A,nat),count(A),Uu),Uua)) ) ) ).

% ATP.lambda_213
tff(fact_6379_ATP_Olambda__214,axiom,
    ! [A: $tType,Uu: A,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),aTP_Lamp_avn(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),zero_zero(nat))) ) ).

% ATP.lambda_214
tff(fact_6380_ATP_Olambda__215,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: ref(A),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),aa(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_awj(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),aa(ref(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),product_Pair(ref(A),product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat))) ) ) ).

% ATP.lambda_215
tff(fact_6381_ATP_Olambda__216,axiom,
    ! [A: $tType,Uu: A,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),aTP_Lamp_avo(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat))) ) ).

% ATP.lambda_216
tff(fact_6382_ATP_Olambda__217,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,A)),Uua: B] : ( aa(B,set(A),aTP_Lamp_ju(set(product_prod(B,A)),fun(B,set(A)),Uu),Uua) = aa(set(B),set(A),image(B,A,Uu),aa(set(B),set(B),insert(B,Uua),bot_bot(set(B)))) ) ).

% ATP.lambda_217
tff(fact_6383_ATP_Olambda__218,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: B] : ( aa(B,set(A),aTP_Lamp_gz(fun(A,B),fun(B,set(A)),Uu),Uua) = aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),Uu),aa(set(B),set(B),insert(B,Uua),bot_bot(set(B)))) ) ).

% ATP.lambda_218
tff(fact_6384_ATP_Olambda__219,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ew(set(A),fun(A,bool),Uu),Uua))
    <=> ( Uu = aa(set(A),set(A),insert(A,Uua),bot_bot(set(A))) ) ) ).

% ATP.lambda_219
tff(fact_6385_ATP_Olambda__220,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(A,A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_nx(fun(A,A),fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),aa(A,A,Uu,Uua))) ) ) ).

% ATP.lambda_220
tff(fact_6386_ATP_Olambda__221,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat] : ( aa(nat,product_prod(nat,A),aTP_Lamp_aoc(fun(nat,A),fun(nat,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),Uua),aa(nat,A,Uu,Uua)) ) ).

% ATP.lambda_221
tff(fact_6387_ATP_Olambda__222,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,product_prod(A,B),aTP_Lamp_dm(fun(A,B),fun(A,product_prod(A,B)),Uu),Uua) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),aa(A,B,Uu,Uua)) ) ).

% ATP.lambda_222
tff(fact_6388_ATP_Olambda__223,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_zs(A,fun(nat,A),Uu),Uua) = bit_se4730199178511100633sh_bit(A,Uua,aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,bit_se5641148757651400278ts_bit(A,Uu),Uua))) ) ) ).

% ATP.lambda_223
tff(fact_6389_ATP_Olambda__224,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B)),Uua: A] : ( aa(A,product_prod(A,B),aTP_Lamp_acz(fun(A,option(B)),fun(A,product_prod(A,B)),Uu),Uua) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),aa(option(B),B,the2(B),aa(A,option(B),Uu,Uua))) ) ).

% ATP.lambda_224
tff(fact_6390_ATP_Olambda__225,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aa(int,fun(int,int),aTP_Lamp_zn(int,fun(int,int)),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uu),aa(bool,int,zero_neq_one_of_bool(int),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),fequal(int),Uua),zero_zero(int))))) ) ).

% ATP.lambda_225
tff(fact_6391_ATP_Olambda__226,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_vk(set(product_prod(A,A)),fun(nat,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uua),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),Uu))) ) ).

% ATP.lambda_226
tff(fact_6392_ATP_Olambda__227,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_aju(nat,fun(list(A),bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uu),aa(list(A),nat,size_size(list(A)),Uua))) ) ).

% ATP.lambda_227
tff(fact_6393_ATP_Olambda__228,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_vx(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_228
tff(fact_6394_ATP_Olambda__229,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_vz(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_229
tff(fact_6395_ATP_Olambda__230,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_vm(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_230
tff(fact_6396_ATP_Olambda__231,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,list(nat),aa(nat,fun(nat,list(nat)),aTP_Lamp_aye(nat,fun(nat,list(nat))),Uu),Uua) = aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),Uu),nat_list_decode(Uua)) ) ).

% ATP.lambda_231
tff(fact_6397_ATP_Olambda__232,axiom,
    ! [B: $tType,A: $tType,Uu: list(product_prod(A,B)),Uua: fun(A,option(B))] : ( aa(fun(A,option(B)),fun(A,option(B)),aa(list(product_prod(A,B)),fun(fun(A,option(B)),fun(A,option(B))),aTP_Lamp_amc(list(product_prod(A,B)),fun(fun(A,option(B)),fun(A,option(B)))),Uu),Uua) = map_add(A,B,Uua,map_of(A,B,Uu)) ) ).

% ATP.lambda_232
tff(fact_6398_ATP_Olambda__233,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] :
      ( pp(aa(list(A),bool,aa(A,fun(list(A),bool),aTP_Lamp_aom(A,fun(list(A),bool)),Uu),Uua))
    <=> pp(aa(set(A),bool,member(A,Uu),aa(list(A),set(A),set2(A),Uua))) ) ).

% ATP.lambda_233
tff(fact_6399_ATP_Olambda__234,axiom,
    ! [A: $tType,Uu: list(set(A)),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_aii(list(set(A)),fun(set(A),bool),Uu),Uua))
    <=> pp(aa(set(set(A)),bool,member(set(A),Uua),aa(list(set(A)),set(set(A)),set2(set(A)),Uu))) ) ).

% ATP.lambda_234
tff(fact_6400_ATP_Olambda__235,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ait(list(A),fun(A,bool),Uu),Uua))
    <=> pp(aa(set(A),bool,member(A,Uua),aa(list(A),set(A),set2(A),Uu))) ) ).

% ATP.lambda_235
tff(fact_6401_ATP_Olambda__236,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_anz(nat,fun(list(A),bool),Uu),Uua))
    <=> ( Uu = aa(list(A),nat,size_size(list(A)),Uua) ) ) ).

% ATP.lambda_236
tff(fact_6402_ATP_Olambda__237,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_art(list(A),fun(A,bool),Uu),Uua))
    <=> ( Uua = aa(list(A),A,hd(A),Uu) ) ) ).

% ATP.lambda_237
tff(fact_6403_ATP_Olambda__238,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_arx(list(A),fun(A,bool),Uu),Uua))
    <=> ( Uua = last(A,Uu) ) ) ).

% ATP.lambda_238
tff(fact_6404_ATP_Olambda__239,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_wy(nat,fun(nat,bool)),Uu),Uua))
    <=> ( Uua = aa(nat,nat,suc,Uu) ) ) ).

% ATP.lambda_239
tff(fact_6405_ATP_Olambda__240,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_kf(set(A),fun(set(A),bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Uua),Uu)) ) ).

% ATP.lambda_240
tff(fact_6406_ATP_Olambda__241,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_rb(nat,fun(nat,bool)),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uua),Uu)) ) ).

% ATP.lambda_241
tff(fact_6407_ATP_Olambda__242,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ww(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_242
tff(fact_6408_ATP_Olambda__243,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ack(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_243
tff(fact_6409_ATP_Olambda__244,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ach(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_244
tff(fact_6410_ATP_Olambda__245,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ava(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_245
tff(fact_6411_ATP_Olambda__246,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_pz(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_246
tff(fact_6412_ATP_Olambda__247,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_awu(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_247
tff(fact_6413_ATP_Olambda__248,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_ri(A,fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_248
tff(fact_6414_ATP_Olambda__249,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_zg(nat,fun(nat,nat),Uu),Uua) = modulo_modulo(nat,Uua,Uu) ) ).

% ATP.lambda_249
tff(fact_6415_ATP_Olambda__250,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_tk(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),Uu) ) ) ).

% ATP.lambda_250
tff(fact_6416_ATP_Olambda__251,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_qj(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),Uu) ) ) ).

% ATP.lambda_251
tff(fact_6417_ATP_Olambda__252,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uua),Uu)) ) ).

% ATP.lambda_252
tff(fact_6418_ATP_Olambda__253,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_wx(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_253
tff(fact_6419_ATP_Olambda__254,axiom,
    ! [A: $tType] :
      ( unboun7993243217541854897norder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_ts(A,fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_254
tff(fact_6420_ATP_Olambda__255,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_acl(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_255
tff(fact_6421_ATP_Olambda__256,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_aci(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_256
tff(fact_6422_ATP_Olambda__257,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_aad(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_257
tff(fact_6423_ATP_Olambda__258,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_acj(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_258
tff(fact_6424_ATP_Olambda__259,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_awv(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_259
tff(fact_6425_ATP_Olambda__260,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_ux(A,fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_260
tff(fact_6426_ATP_Olambda__261,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ty(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_261
tff(fact_6427_ATP_Olambda__262,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_rj(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uu) ) ).

% ATP.lambda_262
tff(fact_6428_ATP_Olambda__263,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_rv(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uua),Uu) ) ) ).

% ATP.lambda_263
tff(fact_6429_ATP_Olambda__264,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_cl(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uua),Uu) ) ) ).

% ATP.lambda_264
tff(fact_6430_ATP_Olambda__265,axiom,
    ! [A: $tType,Uu: A,Uua: multiset(A)] : ( aa(multiset(A),nat,aTP_Lamp_apg(A,fun(multiset(A),nat),Uu),Uua) = aa(A,nat,aa(multiset(A),fun(A,nat),count(A),Uua),Uu) ) ).

% ATP.lambda_265
tff(fact_6431_ATP_Olambda__266,axiom,
    ! [A: $tType,Uu: multiset(A),Uua: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_aug(multiset(A),fun(multiset(A),bool)),Uu),Uua))
    <=> pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Uua),Uu)) ) ).

% ATP.lambda_266
tff(fact_6432_ATP_Olambda__267,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ih(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Uua),Uu) ) ) ).

% ATP.lambda_267
tff(fact_6433_ATP_Olambda__268,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] : ( aa(set(A),set(A),aTP_Lamp_gs(set(A),fun(set(A),set(A)),Uu),Uua) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uua),Uu) ) ).

% ATP.lambda_268
tff(fact_6434_ATP_Olambda__269,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_gd(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uua),Uu) ) ) ).

% ATP.lambda_269
tff(fact_6435_ATP_Olambda__270,axiom,
    ! [Uu: code_integer,Uua: code_integer] : ( aa(code_integer,code_integer,aTP_Lamp_yw(code_integer,fun(code_integer,code_integer),Uu),Uua) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),Uua),Uu) ) ).

% ATP.lambda_270
tff(fact_6436_ATP_Olambda__271,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_alr(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uu) ) ).

% ATP.lambda_271
tff(fact_6437_ATP_Olambda__272,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aTP_Lamp_wz(int,fun(int,int),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),Uu) ) ).

% ATP.lambda_272
tff(fact_6438_ATP_Olambda__273,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_do(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_273
tff(fact_6439_ATP_Olambda__274,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ru(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_274
tff(fact_6440_ATP_Olambda__275,axiom,
    ! [A: $tType,Uu: multiset(A),Uua: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_aue(multiset(A),fun(multiset(A),bool)),Uu),Uua))
    <=> pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),Uua),Uu)) ) ).

% ATP.lambda_275
tff(fact_6441_ATP_Olambda__276,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: A,Uua: ref(A)] : ( aa(ref(A),assn,aa(A,fun(ref(A),assn),aTP_Lamp_al(A,fun(ref(A),assn)),Uu),Uua) = sngr_assn(A,Uua,Uu) ) ) ).

% ATP.lambda_276
tff(fact_6442_ATP_Olambda__277,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: list(A),Uua: array(A)] : ( aa(array(A),assn,aa(list(A),fun(array(A),assn),aTP_Lamp_am(list(A),fun(array(A),assn)),Uu),Uua) = snga_assn(A,Uua,Uu) ) ) ).

% ATP.lambda_277
tff(fact_6443_ATP_Olambda__278,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_zc(nat,fun(nat,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),Uua),Uu)) ) ).

% ATP.lambda_278
tff(fact_6444_ATP_Olambda__279,axiom,
    ! [Uu: int,Uua: int] :
      ( pp(aa(int,bool,aTP_Lamp_zf(int,fun(int,bool),Uu),Uua))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),Uua),Uu)) ) ).

% ATP.lambda_279
tff(fact_6445_ATP_Olambda__280,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_yx(A,fun(A,bool),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Uua),Uu)) ) ) ).

% ATP.lambda_280
tff(fact_6446_ATP_Olambda__281,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: set(A)] : ( aa(set(A),set(product_prod(A,B)),aTP_Lamp_fl(fun(A,set(B)),fun(set(A),set(product_prod(A,B))),Uu),Uua) = product_Sigma(A,B,Uua,Uu) ) ).

% ATP.lambda_281
tff(fact_6447_ATP_Olambda__282,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_wn(nat,fun(nat,product_prod(nat,nat))),Uu),Uua) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Uua),Uu) ) ).

% ATP.lambda_282
tff(fact_6448_ATP_Olambda__283,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: A] : ( aa(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_ej(B,fun(A,product_prod(A,B))),Uu),Uua) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uu) ) ).

% ATP.lambda_283
tff(fact_6449_ATP_Olambda__284,axiom,
    ! [A: $tType,Uu: A,Uua: nat] : ( aa(nat,product_prod(nat,A),aTP_Lamp_aob(A,fun(nat,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),Uua),Uu) ) ).

% ATP.lambda_284
tff(fact_6450_ATP_Olambda__285,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] : ( aa(B,product_prod(B,A),aa(A,fun(B,product_prod(B,A)),aTP_Lamp_ei(A,fun(B,product_prod(B,A))),Uu),Uua) = aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uua),Uu) ) ).

% ATP.lambda_285
tff(fact_6451_ATP_Olambda__286,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_uf(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(Uua),Uu) ) ).

% ATP.lambda_286
tff(fact_6452_ATP_Olambda__287,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),nat,aTP_Lamp_awx(array(A),fun(heap_ext(product_unit),nat),Uu),Uua) = array_length(A,Uua,Uu) ) ) ).

% ATP.lambda_287
tff(fact_6453_ATP_Olambda__288,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] : ( aa(A,list(A),aa(list(A),fun(A,list(A)),aTP_Lamp_aio(list(A),fun(A,list(A))),Uu),Uua) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uua),Uu) ) ).

% ATP.lambda_288
tff(fact_6454_ATP_Olambda__289,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: ref(A),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),A,aTP_Lamp_awt(ref(A),fun(heap_ext(product_unit),A),Uu),Uua) = ref_get(A,Uua,Uu) ) ) ).

% ATP.lambda_289
tff(fact_6455_ATP_Olambda__290,axiom,
    ! [Uu: set(nat),Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_xs(set(nat),fun(nat,bool),Uu),Uua))
    <=> pp(aa(set(nat),bool,member(nat,Uua),Uu)) ) ).

% ATP.lambda_290
tff(fact_6456_ATP_Olambda__291,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] :
      ( pp(aa(B,bool,aTP_Lamp_ni(set(B),fun(B,bool),Uu),Uua))
    <=> pp(aa(set(B),bool,member(B,Uua),Uu)) ) ).

% ATP.lambda_291
tff(fact_6457_ATP_Olambda__292,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_xq(set(A),fun(A,bool),Uu),Uua))
        <=> pp(aa(set(A),bool,member(A,Uua),Uu)) ) ) ).

% ATP.lambda_292
tff(fact_6458_ATP_Olambda__293,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_xu(set(A),fun(A,bool),Uu),Uua))
        <=> pp(aa(set(A),bool,member(A,Uua),Uu)) ) ) ).

% ATP.lambda_293
tff(fact_6459_ATP_Olambda__294,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_ad(set(A),fun(A,bool)),Uu),Uua))
    <=> pp(aa(set(A),bool,member(A,Uua),Uu)) ) ).

% ATP.lambda_294
tff(fact_6460_ATP_Olambda__295,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] : ( aa(nat,set(product_prod(A,A)),aTP_Lamp_uv(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),Uu),Uua) = compow(set(product_prod(A,A)),Uua,Uu) ) ).

% ATP.lambda_295
tff(fact_6461_ATP_Olambda__296,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: nat] : ( aa(nat,fun(A,fun(A,bool)),aTP_Lamp_awd(fun(A,fun(A,bool)),fun(nat,fun(A,fun(A,bool))),Uu),Uua) = compow(fun(A,fun(A,bool)),Uua,Uu) ) ).

% ATP.lambda_296
tff(fact_6462_ATP_Olambda__297,axiom,
    ! [A: $tType,Uu: list(A),Uua: nat] : ( aa(nat,list(A),aTP_Lamp_aol(list(A),fun(nat,list(A)),Uu),Uua) = drop(A,Uua,Uu) ) ).

% ATP.lambda_297
tff(fact_6463_ATP_Olambda__298,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] : ( aa(list(A),A,aTP_Lamp_ajt(nat,fun(list(A),A),Uu),Uua) = aa(nat,A,nth(A,Uua),Uu) ) ).

% ATP.lambda_298
tff(fact_6464_ATP_Olambda__299,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(A,C),Uua: fun(C,set(B))] : ( aa(fun(C,set(B)),fun(A,set(B)),aTP_Lamp_jn(fun(A,C),fun(fun(C,set(B)),fun(A,set(B))),Uu),Uua) = aa(fun(A,C),fun(A,set(B)),comp(C,set(B),A,Uua),Uu) ) ).

% ATP.lambda_299
tff(fact_6465_ATP_Olambda__300,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ct(A,fun(A,bool),Uu),Uua))
    <=> ( Uua = Uu ) ) ).

% ATP.lambda_300
tff(fact_6466_ATP_Olambda__301,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_ama(A,fun(list(A),list(A))),Uu),Uua) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uu),nil(A)) ) ).

% ATP.lambda_301
tff(fact_6467_ATP_Olambda__302,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),list(list(A)),aa(A,fun(list(A),list(list(A))),aTP_Lamp_amd(A,fun(list(A),list(list(A)))),Uu),Uua) = aa(list(list(A)),list(list(A)),aa(list(A),fun(list(list(A)),list(list(A))),cons(list(A)),Uua),nil(list(A))) ) ).

% ATP.lambda_302
tff(fact_6468_ATP_Olambda__303,axiom,
    ! [A: $tType,Uu: A,Uua: A] : ( aa(A,set(A),aTP_Lamp_fa(A,fun(A,set(A)),Uu),Uua) = aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))) ) ).

% ATP.lambda_303
tff(fact_6469_ATP_Olambda__304,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: A,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_awk(A,fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(ref(A),heap_ext(product_unit)),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),aa(fun(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(ref(A),heap_ext(product_unit)),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(ref(A),heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_awj(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))))),ref_alloc(A,Uu,Uua)) ) ) ).

% ATP.lambda_304
tff(fact_6470_ATP_Olambda__305,axiom,
    ! [A: $tType,Uu: multiset(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_apb(multiset(A),fun(A,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(A,nat,aa(multiset(A),fun(A,nat),count(A),Uu),Uua))) ) ).

% ATP.lambda_305
tff(fact_6471_ATP_Olambda__306,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B] :
      ( pp(aa(B,bool,aTP_Lamp_aqm(fun(B,nat),fun(B,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(B,nat,Uu,Uua))) ) ).

% ATP.lambda_306
tff(fact_6472_ATP_Olambda__307,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_tm(fun(A,nat),fun(A,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(A,nat,Uu,Uua))) ) ).

% ATP.lambda_307
tff(fact_6473_ATP_Olambda__308,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ats(set(multiset(A)),fun(A,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(A)),set(nat),image2(multiset(A),nat,aTP_Lamp_apg(A,fun(multiset(A),nat),Uua)),Uu)))) ) ).

% ATP.lambda_308
tff(fact_6474_ATP_Olambda__309,axiom,
    ! [A: $tType,Uu: code_natural,Uua: A] :
      ( pp(aa(A,bool,aa(code_natural,fun(A,bool),aTP_Lamp_ayb(code_natural,fun(A,bool)),Uu),Uua))
    <=> pp(aa(code_natural,bool,aa(code_natural,fun(code_natural,bool),ord_less(code_natural),zero_zero(code_natural)),Uu)) ) ).

% ATP.lambda_309
tff(fact_6475_ATP_Olambda__310,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_ahj(nat,fun(nat,set(nat)),Uu),Uua) = order_underS(nat,bNF_Ca8665028551170535155natLeq,Uu) ) ).

% ATP.lambda_310
tff(fact_6476_ATP_Olambda__311,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: A] : ( aa(A,set(B),aTP_Lamp_dy(set(product_prod(A,B)),fun(A,set(B)),Uu),Uua) = aa(set(product_prod(A,B)),set(B),image2(product_prod(A,B),B,product_snd(A,B)),Uu) ) ).

% ATP.lambda_311
tff(fact_6477_ATP_Olambda__312,axiom,
    ! [A: $tType,Uu: fun(nat,bool),Uua: product_prod(A,nat)] :
      ( pp(aa(product_prod(A,nat),bool,aTP_Lamp_aks(fun(nat,bool),fun(product_prod(A,nat),bool),Uu),Uua))
    <=> pp(aa(nat,bool,Uu,aa(nat,nat,suc,aa(product_prod(A,nat),nat,product_snd(A,nat),Uua)))) ) ).

% ATP.lambda_312
tff(fact_6478_ATP_Olambda__313,axiom,
    ! [A: $tType,Uu: fun(nat,bool),Uua: product_prod(A,nat)] :
      ( pp(aa(product_prod(A,nat),bool,aTP_Lamp_akt(fun(nat,bool),fun(product_prod(A,nat),bool),Uu),Uua))
    <=> pp(aa(nat,bool,Uu,aa(product_prod(A,nat),nat,product_snd(A,nat),Uua))) ) ).

% ATP.lambda_313
tff(fact_6479_ATP_Olambda__314,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(B,C),Uua: product_prod(A,B)] : ( aa(product_prod(A,B),C,aTP_Lamp_du(fun(B,C),fun(product_prod(A,B),C),Uu),Uua) = aa(B,C,Uu,aa(product_prod(A,B),B,product_snd(A,B),Uua)) ) ).

% ATP.lambda_314
tff(fact_6480_ATP_Olambda__315,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(A,C),Uua: product_prod(A,B)] : ( aa(product_prod(A,B),C,aTP_Lamp_dc(fun(A,C),fun(product_prod(A,B),C),Uu),Uua) = aa(A,C,Uu,aa(product_prod(A,B),A,product_fst(A,B),Uua)) ) ).

% ATP.lambda_315
tff(fact_6481_ATP_Olambda__316,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(sum_sum(B,C),set(A)),Uua: C] : ( aa(C,set(A),aTP_Lamp_aym(fun(sum_sum(B,C),set(A)),fun(C,set(A)),Uu),Uua) = aa(sum_sum(B,C),set(A),Uu,aa(C,sum_sum(B,C),sum_Inr(C,B),Uua)) ) ).

% ATP.lambda_316
tff(fact_6482_ATP_Olambda__317,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(sum_sum(A,B),set(C)),Uua: B] : ( aa(B,set(C),aTP_Lamp_ayo(fun(sum_sum(A,B),set(C)),fun(B,set(C)),Uu),Uua) = aa(sum_sum(A,B),set(C),Uu,aa(B,sum_sum(A,B),sum_Inr(B,A),Uua)) ) ).

% ATP.lambda_317
tff(fact_6483_ATP_Olambda__318,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(sum_sum(A,B),C),Uua: B] : ( aa(B,C,aTP_Lamp_ayq(fun(sum_sum(A,B),C),fun(B,C),Uu),Uua) = aa(sum_sum(A,B),C,Uu,aa(B,sum_sum(A,B),sum_Inr(B,A),Uua)) ) ).

% ATP.lambda_318
tff(fact_6484_ATP_Olambda__319,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(sum_sum(B,C),set(A)),Uua: B] : ( aa(B,set(A),aTP_Lamp_ayl(fun(sum_sum(B,C),set(A)),fun(B,set(A)),Uu),Uua) = aa(sum_sum(B,C),set(A),Uu,aa(B,sum_sum(B,C),sum_Inl(B,C),Uua)) ) ).

% ATP.lambda_319
tff(fact_6485_ATP_Olambda__320,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(sum_sum(A,B),set(C)),Uua: A] : ( aa(A,set(C),aTP_Lamp_ayn(fun(sum_sum(A,B),set(C)),fun(A,set(C)),Uu),Uua) = aa(sum_sum(A,B),set(C),Uu,aa(A,sum_sum(A,B),sum_Inl(A,B),Uua)) ) ).

% ATP.lambda_320
tff(fact_6486_ATP_Olambda__321,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(sum_sum(A,B),C),Uua: A] : ( aa(A,C,aTP_Lamp_ayp(fun(sum_sum(A,B),C),fun(A,C),Uu),Uua) = aa(sum_sum(A,B),C,Uu,aa(A,sum_sum(A,B),sum_Inl(A,B),Uua)) ) ).

% ATP.lambda_321
tff(fact_6487_ATP_Olambda__322,axiom,
    ! [Uu: fun(nat,bool),Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_xf(fun(nat,bool),fun(nat,bool),Uu),Uua))
    <=> pp(aa(nat,bool,Uu,aa(nat,nat,suc,Uua))) ) ).

% ATP.lambda_322
tff(fact_6488_ATP_Olambda__323,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_su(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_323
tff(fact_6489_ATP_Olambda__324,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_st(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_324
tff(fact_6490_ATP_Olambda__325,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_xk(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ).

% ATP.lambda_325
tff(fact_6491_ATP_Olambda__326,axiom,
    ! [A: $tType,C: $tType,Uu: C,Uua: fun(C,set(set(A)))] : ( aa(fun(C,set(set(A))),set(set(A)),aTP_Lamp_agg(C,fun(fun(C,set(set(A))),set(set(A))),Uu),Uua) = aa(C,set(set(A)),Uua,Uu) ) ).

% ATP.lambda_326
tff(fact_6492_ATP_Olambda__327,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: fun(B,set(A))] : ( aa(fun(B,set(A)),set(A),aTP_Lamp_jm(B,fun(fun(B,set(A)),set(A)),Uu),Uua) = aa(B,set(A),Uua,Uu) ) ).

% ATP.lambda_327
tff(fact_6493_ATP_Olambda__328,axiom,
    ! [A: $tType,Uu: A,Uua: fun(A,nat)] : ( aa(fun(A,nat),nat,aTP_Lamp_apf(A,fun(fun(A,nat),nat),Uu),Uua) = aa(A,nat,Uua,Uu) ) ).

% ATP.lambda_328
tff(fact_6494_ATP_Olambda__329,axiom,
    ! [B: $tType,A: $tType] :
      ( complete_Sup(B)
     => ! [Uu: A,Uua: fun(A,B)] : ( aa(fun(A,B),B,aTP_Lamp_fd(A,fun(fun(A,B),B),Uu),Uua) = aa(A,B,Uua,Uu) ) ) ).

% ATP.lambda_329
tff(fact_6495_ATP_Olambda__330,axiom,
    ! [B: $tType,A: $tType] :
      ( complete_Inf(B)
     => ! [Uu: A,Uua: fun(A,B)] : ( aa(fun(A,B),B,aTP_Lamp_hu(A,fun(fun(A,B),B),Uu),Uua) = aa(A,B,Uua,Uu) ) ) ).

% ATP.lambda_330
tff(fact_6496_ATP_Olambda__331,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: fun(A,B)] : ( aa(fun(A,B),B,aTP_Lamp_bab(A,fun(fun(A,B),B),Uu),Uua) = aa(A,B,Uua,Uu) ) ).

% ATP.lambda_331
tff(fact_6497_ATP_Olambda__332,axiom,
    ! [B: $tType,A: $tType,Uu: fun(set(A),A),Uua: B] : ( aa(B,A,aTP_Lamp_bal(fun(set(A),A),fun(B,A),Uu),Uua) = aa(set(A),A,Uu,bot_bot(set(A))) ) ).

% ATP.lambda_332
tff(fact_6498_ATP_Olambda__333,axiom,
    ! [A: $tType,Uu: fun(product_unit,A),Uua: product_unit] : ( aa(product_unit,A,aTP_Lamp_axq(fun(product_unit,A),fun(product_unit,A),Uu),Uua) = aa(product_unit,A,Uu,product_Unity) ) ).

% ATP.lambda_333
tff(fact_6499_ATP_Olambda__334,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: option(A)] : ( aa(option(A),option(A),aa(A,fun(option(A),option(A)),aTP_Lamp_aca(A,fun(option(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),case_option(A,A,Uu,aa(A,fun(A,A),ord_min(A),Uu),Uua)) ) ) ).

% ATP.lambda_334
tff(fact_6500_ATP_Olambda__335,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: option(A)] : ( aa(option(A),option(A),aa(A,fun(option(A),option(A)),aTP_Lamp_acd(A,fun(option(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),case_option(A,A,Uu,aa(A,fun(A,A),ord_max(A),Uu),Uua)) ) ) ).

% ATP.lambda_335
tff(fact_6501_ATP_Olambda__336,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Uu: A,Uua: option(A)] : ( aa(option(A),option(A),aa(A,fun(option(A),option(A)),aTP_Lamp_acc(A,fun(option(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),case_option(A,A,Uu,aa(A,fun(A,A),sup_sup(A),Uu),Uua)) ) ) ).

% ATP.lambda_336
tff(fact_6502_ATP_Olambda__337,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Uu: A,Uua: option(A)] : ( aa(option(A),option(A),aa(A,fun(option(A),option(A)),aTP_Lamp_acb(A,fun(option(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),case_option(A,A,Uu,aa(A,fun(A,A),inf_inf(A),Uu),Uua)) ) ) ).

% ATP.lambda_337
tff(fact_6503_ATP_Olambda__338,axiom,
    ! [A: $tType,Uu: multiset(A),Uua: option(multiset(A))] : ( aa(option(multiset(A)),option(multiset(A)),aa(multiset(A),fun(option(multiset(A)),option(multiset(A))),aTP_Lamp_atz(multiset(A),fun(option(multiset(A)),option(multiset(A)))),Uu),Uua) = aa(multiset(A),option(multiset(A)),some(multiset(A)),case_option(multiset(A),multiset(A),Uu,aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),Uu),Uua)) ) ).

% ATP.lambda_338
tff(fact_6504_ATP_Olambda__339,axiom,
    ! [A: $tType,Uu: multiset(A),Uua: option(multiset(A))] : ( aa(option(multiset(A)),option(multiset(A)),aa(multiset(A),fun(option(multiset(A)),option(multiset(A))),aTP_Lamp_aud(multiset(A),fun(option(multiset(A)),option(multiset(A)))),Uu),Uua) = aa(multiset(A),option(multiset(A)),some(multiset(A)),case_option(multiset(A),multiset(A),Uu,aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),Uu),Uua)) ) ).

% ATP.lambda_339
tff(fact_6505_ATP_Olambda__340,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_abj(nat,fun(num,option(num)),Uu),Uua) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(Uu,Uua))) ) ).

% ATP.lambda_340
tff(fact_6506_ATP_Olambda__341,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,heap_Time_Heap(A)),Uua: B] : ( aa(B,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_axm(fun(B,heap_Time_Heap(A)),fun(B,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),Uu),Uua) = aa(fun(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),product_case_prod(heap_ext(product_unit),nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(B,fun(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_axl(fun(B,heap_Time_Heap(A)),fun(B,fun(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua)) ) ).

% ATP.lambda_341
tff(fact_6507_ATP_Olambda__342,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,heap_Time_Heap(B)),Uua: A] : ( aa(A,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_axi(fun(A,heap_Time_Heap(B)),fun(A,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua) = aa(fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),product_case_prod(heap_ext(product_unit),nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(A,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_axh(fun(A,heap_Time_Heap(B)),fun(A,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua)) ) ).

% ATP.lambda_342
tff(fact_6508_ATP_Olambda__343,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A)] : ( aa(list(A),fun(product_prod(A,list(A)),option(bool)),aTP_Lamp_anj(list(A),fun(list(A),fun(product_prod(A,list(A)),option(bool))),Uu),Uua) = aa(fun(A,fun(list(A),option(bool))),fun(product_prod(A,list(A)),option(bool)),product_case_prod(A,list(A),option(bool)),aa(list(A),fun(A,fun(list(A),option(bool))),aTP_Lamp_ani(list(A),fun(list(A),fun(A,fun(list(A),option(bool)))),Uu),Uua)) ) ).

% ATP.lambda_343
tff(fact_6509_ATP_Olambda__344,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: list(B)] : ( aa(list(B),fun(product_prod(list(B),list(B)),list(B)),aTP_Lamp_ams(fun(B,A),fun(list(B),fun(product_prod(list(B),list(B)),list(B))),Uu),Uua) = aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aa(list(B),fun(list(B),fun(list(B),list(B))),aTP_Lamp_amr(fun(B,A),fun(list(B),fun(list(B),fun(list(B),list(B)))),Uu),Uua)) ) ) ).

% ATP.lambda_344
tff(fact_6510_ATP_Olambda__345,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A))))),aTP_Lamp_alw(A,fun(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))))),Uu),Uua) = aa(fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A))))),product_case_prod(A,list(A),option(product_prod(list(A),product_prod(A,list(A))))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_alv(A,fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua)) ) ).

% ATP.lambda_345
tff(fact_6511_ATP_Olambda__346,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,fun(A,C)),Uua: C] : ( aa(C,fun(product_prod(B,A),C),aTP_Lamp_ajp(fun(C,fun(A,C)),fun(C,fun(product_prod(B,A),C)),Uu),Uua) = aa(fun(B,fun(A,C)),fun(product_prod(B,A),C),product_case_prod(B,A,C),aa(C,fun(B,fun(A,C)),aTP_Lamp_ajo(fun(C,fun(A,C)),fun(C,fun(B,fun(A,C))),Uu),Uua)) ) ).

% ATP.lambda_346
tff(fact_6512_ATP_Olambda__347,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),bool),aa(nat,fun(nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_xc(nat,fun(nat,fun(product_prod(nat,nat),bool))),Uu),Uua) = aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aa(nat,fun(nat,fun(nat,bool)),aTP_Lamp_xb(nat,fun(nat,fun(nat,fun(nat,bool))),Uu),Uua)) ) ).

% ATP.lambda_347
tff(fact_6513_ATP_Olambda__348,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wv(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_wu(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_348
tff(fact_6514_ATP_Olambda__349,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_ws(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_349
tff(fact_6515_ATP_Olambda__350,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),bool),aa(nat,fun(nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),bool))),Uu),Uua) = aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aa(nat,fun(nat,fun(nat,bool)),aTP_Lamp_wq(nat,fun(nat,fun(nat,fun(nat,bool))),Uu),Uua)) ) ).

% ATP.lambda_350
tff(fact_6516_ATP_Olambda__351,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),bool),aa(nat,fun(nat,fun(product_prod(nat,nat),bool)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),bool))),Uu),Uua) = aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aa(nat,fun(nat,fun(nat,bool)),aTP_Lamp_wo(nat,fun(nat,fun(nat,fun(nat,bool))),Uu),Uua)) ) ).

% ATP.lambda_351
tff(fact_6517_ATP_Olambda__352,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wd(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_wc(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_352
tff(fact_6518_ATP_Olambda__353,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(A,bool)] : ( aa(fun(A,bool),set(A),aTP_Lamp_ari(fun(A,fun(B,bool)),fun(fun(A,bool),set(A)),Uu),Uua) = aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_arh(fun(A,fun(B,bool)),fun(fun(A,bool),fun(A,bool)),Uu),Uua)) ) ).

% ATP.lambda_353
tff(fact_6519_ATP_Olambda__354,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,bool)),Uua: B] : ( aa(B,set(A),aTP_Lamp_gw(fun(A,fun(B,bool)),fun(B,set(A)),Uu),Uua) = aa(fun(A,bool),set(A),collect(A),aa(B,fun(A,bool),aTP_Lamp_gv(fun(A,fun(B,bool)),fun(B,fun(A,bool)),Uu),Uua)) ) ).

% ATP.lambda_354
tff(fact_6520_ATP_Olambda__355,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: fun(B,C)] : ( aa(fun(B,C),A,aTP_Lamp_jd(fun(C,fun(B,A)),fun(fun(B,C),A),Uu),Uua) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_jc(fun(C,fun(B,A)),fun(fun(B,C),fun(B,A)),Uu),Uua)),top_top(set(B)))) ) ) ).

% ATP.lambda_355
tff(fact_6521_ATP_Olambda__356,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B] : ( aa(B,A,aTP_Lamp_je(fun(C,fun(B,A)),fun(B,A),Uu),Uua) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,aa(B,fun(C,A),aTP_Lamp_ja(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua)),top_top(set(C)))) ) ) ).

% ATP.lambda_356
tff(fact_6522_ATP_Olambda__357,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: fun(B,C)] : ( aa(fun(B,C),A,aTP_Lamp_jf(fun(C,fun(B,A)),fun(fun(B,C),A),Uu),Uua) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_jc(fun(C,fun(B,A)),fun(fun(B,C),fun(B,A)),Uu),Uua)),top_top(set(B)))) ) ) ).

% ATP.lambda_357
tff(fact_6523_ATP_Olambda__358,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B] : ( aa(B,A,aTP_Lamp_jb(fun(C,fun(B,A)),fun(B,A),Uu),Uua) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,aa(B,fun(C,A),aTP_Lamp_ja(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua)),top_top(set(C)))) ) ) ).

% ATP.lambda_358
tff(fact_6524_ATP_Olambda__359,axiom,
    ! [A: $tType,Uu: fun(heap_ext(product_unit),A),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_awr(fun(heap_ext(product_unit),A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),A,Uu,Uua)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat)))) ) ).

% ATP.lambda_359
tff(fact_6525_ATP_Olambda__360,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,option(B)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_acq(fun(A,option(B)),fun(A,bool),Uu),Uua))
    <=> ( aa(A,option(B),Uu,Uua) != none(B) ) ) ).

% ATP.lambda_360
tff(fact_6526_ATP_Olambda__361,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,set(product_prod(A,B)),aTP_Lamp_hb(fun(A,set(B)),fun(A,set(product_prod(A,B))),Uu),Uua) = aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(B),set(set(product_prod(A,B))),image2(B,set(product_prod(A,B)),aTP_Lamp_ha(A,fun(B,set(product_prod(A,B))),Uua)),aa(A,set(B),Uu,Uua))) ) ).

% ATP.lambda_361
tff(fact_6527_ATP_Olambda__362,axiom,
    ! [B: $tType,A: $tType,Uu: set(set(old_node(A,B))),Uua: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(set(old_node(A,B))),aTP_Lamp_azo(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),Uu),Uua) = aa(set(set(set(old_node(A,B)))),set(set(old_node(A,B))),complete_Sup_Sup(set(set(old_node(A,B)))),aa(set(set(old_node(A,B))),set(set(set(old_node(A,B)))),image2(set(old_node(A,B)),set(set(old_node(A,B))),aTP_Lamp_azn(set(old_node(A,B)),fun(set(old_node(A,B)),set(set(old_node(A,B)))),Uua)),Uu)) ) ).

% ATP.lambda_362
tff(fact_6528_ATP_Olambda__363,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: A] : ( aa(A,nat,aTP_Lamp_atn(set(multiset(A)),fun(A,nat),Uu),Uua) = aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(A)),set(nat),image2(multiset(A),nat,aTP_Lamp_apg(A,fun(multiset(A),nat),Uua)),Uu)) ) ).

% ATP.lambda_363
tff(fact_6529_ATP_Olambda__364,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: list(product_prod(C,B)),Uua: product_prod(A,C)] : ( aa(product_prod(A,C),list(product_prod(A,B)),aTP_Lamp_alb(list(product_prod(C,B)),fun(product_prod(A,C),list(product_prod(A,B))),Uu),Uua) = concat(product_prod(A,B),aa(list(product_prod(C,B)),list(list(product_prod(A,B))),map(product_prod(C,B),list(product_prod(A,B)),aTP_Lamp_ala(product_prod(A,C),fun(product_prod(C,B),list(product_prod(A,B))),Uua)),Uu)) ) ).

% ATP.lambda_364
tff(fact_6530_ATP_Olambda__365,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_zv(nat,fun(nat,bool),Uu),Uua))
    <=> ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uu),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))) ) ).

% ATP.lambda_365
tff(fact_6531_ATP_Olambda__366,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_hj(set(set(A)),fun(A,bool),Uu),Uua))
    <=> pp(aa(set(bool),bool,complete_Sup_Sup(bool),aa(set(set(A)),set(bool),image2(set(A),bool,member(A,Uua)),Uu))) ) ).

% ATP.lambda_366
tff(fact_6532_ATP_Olambda__367,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_jl(set(set(A)),fun(A,bool),Uu),Uua))
    <=> pp(aa(set(bool),bool,complete_Inf_Inf(bool),aa(set(set(A)),set(bool),image2(set(A),bool,member(A,Uua)),Uu))) ) ).

% ATP.lambda_367
tff(fact_6533_ATP_Olambda__368,axiom,
    ! [Uu: code_natural,Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_axx(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),Uua),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),Uu),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2)))))))))))))))))))))))))))))))))) ) ).

% ATP.lambda_368
tff(fact_6534_ATP_Olambda__369,axiom,
    ! [A: $tType,Uu: fun(nat,set(A)),Uua: nat] : ( aa(nat,set(A),aTP_Lamp_wm(fun(nat,set(A)),fun(nat,set(A)),Uu),Uua) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image2(nat,set(A),Uu),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua))) ) ).

% ATP.lambda_369
tff(fact_6535_ATP_Olambda__370,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_vu(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_370
tff(fact_6536_ATP_Olambda__371,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_uu(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_371
tff(fact_6537_ATP_Olambda__372,axiom,
    ! [A: $tType,Uu: list(A),Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))),aTP_Lamp_bbe(list(A),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(A,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))),product_Pair(A,product_prod(code_natural,code_natural)),aa(nat,A,nth(A,Uu),code_nat_of_natural(Uua))) ) ).

% ATP.lambda_372
tff(fact_6538_ATP_Olambda__373,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ais(list(A),fun(A,bool),Uu),Uua))
    <=> ~ pp(aa(set(A),bool,member(A,Uua),aa(list(A),set(A),set2(A),Uu))) ) ).

% ATP.lambda_373
tff(fact_6539_ATP_Olambda__374,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_auu(list(A),fun(A,bool),Uu),Uua))
    <=> ( Uua != last(A,Uu) ) ) ).

% ATP.lambda_374
tff(fact_6540_ATP_Olambda__375,axiom,
    ! [P8: $tType,O: $tType,Uu: fun(O,set(P8)),Uua: set(O)] : ( aa(set(O),set(P8),aTP_Lamp_gt(fun(O,set(P8)),fun(set(O),set(P8)),Uu),Uua) = aa(set(set(P8)),set(P8),complete_Sup_Sup(set(P8)),aa(set(O),set(set(P8)),image2(O,set(P8),Uu),Uua)) ) ).

% ATP.lambda_375
tff(fact_6541_ATP_Olambda__376,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: set(B)] : ( aa(set(B),A,aTP_Lamp_aef(fun(B,A),fun(set(B),A),Uu),Uua) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,Uu),Uua)) ) ) ).

% ATP.lambda_376
tff(fact_6542_ATP_Olambda__377,axiom,
    ! [D: $tType,B: $tType,Uu: set(B),Uua: fun(B,set(D))] : ( aa(fun(B,set(D)),set(D),aa(set(B),fun(fun(B,set(D)),set(D)),aTP_Lamp_aqh(set(B),fun(fun(B,set(D)),set(D))),Uu),Uua) = aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),Uua),Uu)) ) ).

% ATP.lambda_377
tff(fact_6543_ATP_Olambda__378,axiom,
    ! [C: $tType,B: $tType] :
      ( complete_Sup(C)
     => ! [Uu: set(B),Uua: fun(B,C)] : ( aa(fun(B,C),C,aa(set(B),fun(fun(B,C),C),aTP_Lamp_aqf(set(B),fun(fun(B,C),C)),Uu),Uua) = aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Uua),Uu)) ) ) ).

% ATP.lambda_378
tff(fact_6544_ATP_Olambda__379,axiom,
    ! [A: $tType,Uu: set(A),Uua: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aa(set(A),fun(fun(A,bool),bool),aTP_Lamp_aev(set(A),fun(fun(A,bool),bool)),Uu),Uua))
    <=> pp(aa(set(bool),bool,complete_Sup_Sup(bool),aa(set(A),set(bool),image2(A,bool,Uua),Uu))) ) ).

% ATP.lambda_379
tff(fact_6545_ATP_Olambda__380,axiom,
    ! [C: $tType,A: $tType,Uu: set(A),Uua: fun(A,set(C))] : ( aa(fun(A,set(C)),set(C),aa(set(A),fun(fun(A,set(C)),set(C)),aTP_Lamp_aqg(set(A),fun(fun(A,set(C)),set(C))),Uu),Uua) = aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image2(A,set(C),Uua),Uu)) ) ).

% ATP.lambda_380
tff(fact_6546_ATP_Olambda__381,axiom,
    ! [C: $tType,A: $tType] :
      ( complete_Sup(C)
     => ! [Uu: set(A),Uua: fun(A,C)] : ( aa(fun(A,C),C,aa(set(A),fun(fun(A,C),C),aTP_Lamp_aqe(set(A),fun(fun(A,C),C)),Uu),Uua) = aa(set(C),C,complete_Sup_Sup(C),aa(set(A),set(C),image2(A,C,Uua),Uu)) ) ) ).

% ATP.lambda_381
tff(fact_6547_ATP_Olambda__382,axiom,
    ! [P8: $tType,O: $tType,Uu: fun(O,set(P8)),Uua: set(O)] : ( aa(set(O),set(P8),aTP_Lamp_ix(fun(O,set(P8)),fun(set(O),set(P8)),Uu),Uua) = aa(set(set(P8)),set(P8),complete_Inf_Inf(set(P8)),aa(set(O),set(set(P8)),image2(O,set(P8),Uu),Uua)) ) ).

% ATP.lambda_382
tff(fact_6548_ATP_Olambda__383,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: set(B)] : ( aa(set(B),A,aTP_Lamp_aeg(fun(B,A),fun(set(B),A),Uu),Uua) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,Uu),Uua)) ) ) ).

% ATP.lambda_383
tff(fact_6549_ATP_Olambda__384,axiom,
    ! [C: $tType,B: $tType] :
      ( complete_Inf(C)
     => ! [Uu: set(B),Uua: fun(B,C)] : ( aa(fun(B,C),C,aa(set(B),fun(fun(B,C),C),aTP_Lamp_aqd(set(B),fun(fun(B,C),C)),Uu),Uua) = aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Uua),Uu)) ) ) ).

% ATP.lambda_384
tff(fact_6550_ATP_Olambda__385,axiom,
    ! [A: $tType,Uu: set(A),Uua: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aa(set(A),fun(fun(A,bool),bool),aTP_Lamp_adg(set(A),fun(fun(A,bool),bool)),Uu),Uua))
    <=> pp(aa(set(bool),bool,complete_Inf_Inf(bool),aa(set(A),set(bool),image2(A,bool,Uua),Uu))) ) ).

% ATP.lambda_385
tff(fact_6551_ATP_Olambda__386,axiom,
    ! [C: $tType,A: $tType] :
      ( complete_Inf(C)
     => ! [Uu: set(A),Uua: fun(A,C)] : ( aa(fun(A,C),C,aa(set(A),fun(fun(A,C),C),aTP_Lamp_aqc(set(A),fun(fun(A,C),C)),Uu),Uua) = aa(set(C),C,complete_Inf_Inf(C),aa(set(A),set(C),image2(A,C,Uua),Uu)) ) ) ).

% ATP.lambda_386
tff(fact_6552_ATP_Olambda__387,axiom,
    ! [A: $tType] :
      ( sup(A)
     => ! [Uu: A,Uua: A] : ( aa(A,option(A),aTP_Lamp_aag(A,fun(A,option(A)),Uu),Uua) = aa(A,option(A),some(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Uu),Uua)) ) ) ).

% ATP.lambda_387
tff(fact_6553_ATP_Olambda__388,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [Uu: A,Uua: A] : ( aa(A,option(A),aTP_Lamp_abg(A,fun(A,option(A)),Uu),Uua) = aa(A,option(A),some(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Uu),Uua)) ) ) ).

% ATP.lambda_388
tff(fact_6554_ATP_Olambda__389,axiom,
    ! [Uu: code_natural,Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_axz(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),modulo_modulo(code_natural,Uua,Uu)) ) ).

% ATP.lambda_389
tff(fact_6555_ATP_Olambda__390,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: A,Uua: B] : ( aa(B,fun(C,product_prod(product_prod(A,B),C)),aTP_Lamp_ql(A,fun(B,fun(C,product_prod(product_prod(A,B),C))),Uu),Uua) = aa(product_prod(A,B),fun(C,product_prod(product_prod(A,B),C)),product_Pair(product_prod(A,B),C),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uu),Uua)) ) ).

% ATP.lambda_390
tff(fact_6556_ATP_Olambda__391,axiom,
    ! [A: $tType,Uu: list(product_prod(code_natural,A)),Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))),aTP_Lamp_aya(list(product_prod(code_natural,A)),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(A,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))),product_Pair(A,product_prod(code_natural,code_natural)),aa(code_natural,A,pick(A,Uu),Uua)) ) ).

% ATP.lambda_391
tff(fact_6557_ATP_Olambda__392,axiom,
    ! [B: $tType,A: $tType,Uu: list(product_prod(A,B)),Uua: A] : ( aa(A,B,aTP_Lamp_aoo(list(product_prod(A,B)),fun(A,B),Uu),Uua) = aa(option(B),B,the2(B),aa(A,option(B),map_of(A,B,Uu),Uua)) ) ).

% ATP.lambda_392
tff(fact_6558_ATP_Olambda__393,axiom,
    ! [B: $tType,A: $tType,Uu: B,Uua: A] : ( aa(A,fun(set(product_prod(B,A)),set(product_prod(B,A))),aTP_Lamp_ln(B,fun(A,fun(set(product_prod(B,A)),set(product_prod(B,A)))),Uu),Uua) = insert(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uu),Uua)) ) ).

% ATP.lambda_393
tff(fact_6559_ATP_Olambda__394,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: B] : ( aa(B,fun(set(product_prod(A,B)),set(product_prod(A,B))),aTP_Lamp_lv(A,fun(B,fun(set(product_prod(A,B)),set(product_prod(A,B)))),Uu),Uua) = insert(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uu),Uua)) ) ).

% ATP.lambda_394
tff(fact_6560_ATP_Olambda__395,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_aaa(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uu),Uua)) ) ).

% ATP.lambda_395
tff(fact_6561_ATP_Olambda__396,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_aab(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uua),Uu)) ) ).

% ATP.lambda_396
tff(fact_6562_ATP_Olambda__397,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ace(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uu),Uua)) ) ).

% ATP.lambda_397
tff(fact_6563_ATP_Olambda__398,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_acf(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uua),Uu)) ) ).

% ATP.lambda_398
tff(fact_6564_ATP_Olambda__399,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_anl(A,fun(A,bool),Uu),Uua))
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uu),Uua)) ) ) ).

% ATP.lambda_399
tff(fact_6565_ATP_Olambda__400,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_at(set(A),fun(A,bool),Uu),Uua))
    <=> ~ pp(aa(set(A),bool,member(A,Uua),Uu)) ) ).

% ATP.lambda_400
tff(fact_6566_ATP_Olambda__401,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_adp(A,fun(A,bool)),Uu),Uua))
    <=> ( Uu != Uua ) ) ).

% ATP.lambda_401
tff(fact_6567_ATP_Olambda__402,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_top(A) )
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_xl(A,fun(A,bool),Uu),Uua))
        <=> ( Uua != Uu ) ) ) ).

% ATP.lambda_402
tff(fact_6568_ATP_Olambda__403,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_bot(A) )
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_pn(A,fun(A,bool),Uu),Uua))
        <=> ( Uua != Uu ) ) ) ).

% ATP.lambda_403
tff(fact_6569_ATP_Olambda__404,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_rz(A,fun(A,bool)),Uu),Uua))
    <=> ( Uua != Uu ) ) ).

% ATP.lambda_404
tff(fact_6570_ATP_Olambda__405,axiom,
    ! [A: $tType,Uu: A,Uua: A] : ( aa(A,set(A),aTP_Lamp_ea(A,fun(A,set(A)),Uu),Uua) = aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A)))) ) ).

% ATP.lambda_405
tff(fact_6571_ATP_Olambda__406,axiom,
    ! [Uu: nat,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_axp(nat,fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),some(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(product_unit,fun(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),product_Pair(product_unit,product_prod(heap_ext(product_unit),nat)),product_Unity),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),Uu))) ) ).

% ATP.lambda_406
tff(fact_6572_ATP_Olambda__407,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(A,fun(A,A)),Uua: A] : ( aa(A,A,aTP_Lamp_mn(fun(A,fun(A,A)),fun(A,A),Uu),Uua) = complete_lattice_lfp(A,aa(A,fun(A,A),Uu,Uua)) ) ) ).

% ATP.lambda_407
tff(fact_6573_ATP_Olambda__408,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(A,fun(A,A)),Uua: A] : ( aa(A,A,aTP_Lamp_nu(fun(A,fun(A,A)),fun(A,A),Uu),Uua) = complete_lattice_gfp(A,aa(A,fun(A,A),Uu,Uua)) ) ) ).

% ATP.lambda_408
tff(fact_6574_ATP_Olambda__409,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: B] : ( aa(B,set(product_prod(C,C)),aTP_Lamp_agx(fun(B,set(C)),fun(B,set(product_prod(C,C))),Uu),Uua) = bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),Uu,Uua)) ) ).

% ATP.lambda_409
tff(fact_6575_ATP_Olambda__410,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,set(product_prod(B,B)),aTP_Lamp_agt(fun(A,set(B)),fun(A,set(product_prod(B,B))),Uu),Uua) = bNF_Ca6860139660246222851ard_of(B,aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_410
tff(fact_6576_ATP_Olambda__411,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,bool),Uua: B] : ( aa(B,A,aTP_Lamp_xe(fun(B,bool),fun(B,A),Uu),Uua) = aa(bool,A,zero_neq_one_of_bool(A),aa(B,bool,Uu,Uua)) ) ) ).

% ATP.lambda_411
tff(fact_6577_ATP_Olambda__412,axiom,
    ! [A: $tType,B: $tType] :
      ( field_char_0(A)
     => ! [Uu: fun(B,rat),Uua: B] : ( aa(B,A,aTP_Lamp_aby(fun(B,rat),fun(B,A),Uu),Uua) = aa(rat,A,field_char_0_of_rat(A),aa(B,rat,Uu,Uua)) ) ) ).

% ATP.lambda_412
tff(fact_6578_ATP_Olambda__413,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B] : ( aa(B,int,aTP_Lamp_ss(fun(B,nat),fun(B,int),Uu),Uua) = aa(nat,int,semiring_1_of_nat(int),aa(B,nat,Uu,Uua)) ) ).

% ATP.lambda_413
tff(fact_6579_ATP_Olambda__414,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,nat),Uua: B] : ( aa(B,A,aTP_Lamp_sq(fun(B,nat),fun(B,A),Uu),Uua) = aa(nat,A,semiring_1_of_nat(A),aa(B,nat,Uu,Uua)) ) ) ).

% ATP.lambda_414
tff(fact_6580_ATP_Olambda__415,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,nat),Uua: B] : ( aa(B,A,aTP_Lamp_sp(fun(B,nat),fun(B,A),Uu),Uua) = aa(nat,A,semiring_1_of_nat(A),aa(B,nat,Uu,Uua)) ) ) ).

% ATP.lambda_415
tff(fact_6581_ATP_Olambda__416,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: B] : ( aa(B,set(A),aTP_Lamp_hx(fun(B,set(A)),fun(B,set(A)),Uu),Uua) = aa(set(A),set(A),uminus_uminus(set(A)),aa(B,set(A),Uu,Uua)) ) ).

% ATP.lambda_416
tff(fact_6582_ATP_Olambda__417,axiom,
    ! [A: $tType,B: $tType] :
      ( comple489889107523837845lgebra(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_iv(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_417
tff(fact_6583_ATP_Olambda__418,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_pa(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_418
tff(fact_6584_ATP_Olambda__419,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(product_prod(B,B))),Uua: A] : ( aa(A,set(product_prod(B,B)),aTP_Lamp_jj(fun(A,set(product_prod(B,B))),fun(A,set(product_prod(B,B))),Uu),Uua) = transitive_trancl(B,aa(A,set(product_prod(B,B)),Uu,Uua)) ) ).

% ATP.lambda_419
tff(fact_6585_ATP_Olambda__420,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_th(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_420
tff(fact_6586_ATP_Olambda__421,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: fun(B,int),Uua: B] : ( aa(B,A,aTP_Lamp_xx(fun(B,int),fun(B,A),Uu),Uua) = aa(int,A,ring_1_of_int(A),aa(B,int,Uu,Uua)) ) ) ).

% ATP.lambda_421
tff(fact_6587_ATP_Olambda__422,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(A)
     => ! [Uu: fun(B,int),Uua: B] : ( aa(B,A,aTP_Lamp_xy(fun(B,int),fun(B,A),Uu),Uua) = aa(int,A,ring_1_of_int(A),aa(B,int,Uu,Uua)) ) ) ).

% ATP.lambda_422
tff(fact_6588_ATP_Olambda__423,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: B] : ( aa(B,heap_Time_Heap(A),aTP_Lamp_axg(fun(B,A),fun(B,heap_Time_Heap(A)),Uu),Uua) = aa(A,heap_Time_Heap(A),heap_Time_return(A),aa(B,A,Uu,Uua)) ) ).

% ATP.lambda_423
tff(fact_6589_ATP_Olambda__424,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_tz(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_424
tff(fact_6590_ATP_Olambda__425,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_field(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_qn(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,abs_abs(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_425
tff(fact_6591_ATP_Olambda__426,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_qi(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,abs_abs(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_426
tff(fact_6592_ATP_Olambda__427,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,option(A),aTP_Lamp_aai(fun(B,A),fun(B,option(A)),Uu),Uua) = aa(A,option(A),some(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_427
tff(fact_6593_ATP_Olambda__428,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: B] : ( aa(B,option(A),aTP_Lamp_abz(fun(B,A),fun(B,option(A)),Uu),Uua) = aa(A,option(A),some(A),aa(B,A,Uu,Uua)) ) ).

% ATP.lambda_428
tff(fact_6594_ATP_Olambda__429,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,option(B),aTP_Lamp_aaj(fun(A,B),fun(A,option(B)),Uu),Uua) = aa(B,option(B),some(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_429
tff(fact_6595_ATP_Olambda__430,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,option(B),aTP_Lamp_aco(fun(A,B),fun(A,option(B)),Uu),Uua) = aa(B,option(B),some(B),aa(A,B,Uu,Uua)) ) ).

% ATP.lambda_430
tff(fact_6596_ATP_Olambda__431,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(C,set(product_prod(B,A))),Uua: C] : ( aa(C,set(product_prod(A,B)),aTP_Lamp_mt(fun(C,set(product_prod(B,A))),fun(C,set(product_prod(A,B))),Uu),Uua) = converse(B,A,aa(C,set(product_prod(B,A)),Uu,Uua)) ) ).

% ATP.lambda_431
tff(fact_6597_ATP_Olambda__432,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(C,A),Uua: C] : ( aa(C,fun(B,product_prod(A,B)),aTP_Lamp_ajz(fun(C,A),fun(C,fun(B,product_prod(A,B))),Uu),Uua) = aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,Uu,Uua)) ) ).

% ATP.lambda_432
tff(fact_6598_ATP_Olambda__433,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,fun(C,product_prod(B,C)),aTP_Lamp_amf(fun(A,B),fun(A,fun(C,product_prod(B,C))),Uu),Uua) = aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(A,B,Uu,Uua)) ) ).

% ATP.lambda_433
tff(fact_6599_ATP_Olambda__434,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,set(old_node(A,B))),Uua: C] : ( aa(C,set(old_node(A,B)),aTP_Lamp_aza(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B))),Uu),Uua) = old_In1(A,B,aa(C,set(old_node(A,B)),Uu,Uua)) ) ).

% ATP.lambda_434
tff(fact_6600_ATP_Olambda__435,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,set(old_node(A,B))),Uua: C] : ( aa(C,set(old_node(A,B)),aTP_Lamp_azb(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B))),Uu),Uua) = old_In0(A,B,aa(C,set(old_node(A,B)),Uu,Uua)) ) ).

% ATP.lambda_435
tff(fact_6601_ATP_Olambda__436,axiom,
    ! [C: $tType,D: $tType,Uu: fun(D,set(C)),Uua: D] : ( aa(D,filter(C),aTP_Lamp_nb(fun(D,set(C)),fun(D,filter(C)),Uu),Uua) = principal(C,aa(D,set(C),Uu,Uua)) ) ).

% ATP.lambda_436
tff(fact_6602_ATP_Olambda__437,axiom,
    ! [D: $tType,C: $tType,Uu: fun(C,set(D)),Uua: C] : ( aa(C,filter(D),aTP_Lamp_nf(fun(C,set(D)),fun(C,filter(D)),Uu),Uua) = principal(D,aa(C,set(D),Uu,Uua)) ) ).

% ATP.lambda_437
tff(fact_6603_ATP_Olambda__438,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: B] : ( aa(B,filter(A),aTP_Lamp_ml(fun(B,set(A)),fun(B,filter(A)),Uu),Uua) = principal(A,aa(B,set(A),Uu,Uua)) ) ).

% ATP.lambda_438
tff(fact_6604_ATP_Olambda__439,axiom,
    ! [E: $tType,A: $tType,Uu: fun(A,set(E)),Uua: A] : ( aa(A,filter(E),aTP_Lamp_ne(fun(A,set(E)),fun(A,filter(E)),Uu),Uua) = principal(E,aa(A,set(E),Uu,Uua)) ) ).

% ATP.lambda_439
tff(fact_6605_ATP_Olambda__440,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,filter(B),aTP_Lamp_mk(fun(A,set(B)),fun(A,filter(B)),Uu),Uua) = principal(B,aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_440
tff(fact_6606_ATP_Olambda__441,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,nat,aTP_Lamp_rk(fun(A,set(B)),fun(A,nat),Uu),Uua) = aa(set(B),nat,finite_card(B),aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_441
tff(fact_6607_ATP_Olambda__442,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(product_prod(B,B))),Uua: A] : ( aa(A,set(B),aTP_Lamp_agu(fun(A,set(product_prod(B,B))),fun(A,set(B)),Uu),Uua) = field2(B,aa(A,set(product_prod(B,B)),Uu,Uua)) ) ).

% ATP.lambda_442
tff(fact_6608_ATP_Olambda__443,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,list(A)),Uua: B] : ( aa(B,set(A),aTP_Lamp_ahy(fun(B,list(A)),fun(B,set(A)),Uu),Uua) = aa(list(A),set(A),set2(A),aa(B,list(A),Uu,Uua)) ) ).

% ATP.lambda_443
tff(fact_6609_ATP_Olambda__444,axiom,
    ! [A: $tType,Uu: fun(set(A),fun(A,bool)),Uua: set(A)] : ( aa(set(A),set(A),aTP_Lamp_ny(fun(set(A),fun(A,bool)),fun(set(A),set(A)),Uu),Uua) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),Uu,Uua)) ) ).

% ATP.lambda_444
tff(fact_6610_ATP_Olambda__445,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: A] : ( aa(A,set(B),aTP_Lamp_dq(fun(A,fun(B,bool)),fun(A,set(B)),Uu),Uua) = aa(fun(B,bool),set(B),collect(B),aa(A,fun(B,bool),Uu,Uua)) ) ).

% ATP.lambda_445
tff(fact_6611_ATP_Olambda__446,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,fun(set(B),set(B)),aTP_Lamp_lt(fun(A,B),fun(A,fun(set(B),set(B))),Uu),Uua) = insert(B,aa(A,B,Uu,Uua)) ) ).

% ATP.lambda_446
tff(fact_6612_ATP_Olambda__447,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: B] : ( aa(B,set(set(A)),aTP_Lamp_jy(fun(B,set(A)),fun(B,set(set(A))),Uu),Uua) = pow(A,aa(B,set(A),Uu,Uua)) ) ).

% ATP.lambda_447
tff(fact_6613_ATP_Olambda__448,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] : ( aa(A,nat,aTP_Lamp_sy(fun(A,nat),fun(A,nat),Uu),Uua) = aa(nat,nat,suc,aa(A,nat,Uu,Uua)) ) ).

% ATP.lambda_448
tff(fact_6614_ATP_Olambda__449,axiom,
    ! [B: $tType,Uu: fun(B,bool),Uua: B] :
      ( pp(aa(B,bool,aTP_Lamp_cb(fun(B,bool),fun(B,bool),Uu),Uua))
    <=> ~ pp(aa(B,bool,Uu,Uua)) ) ).

% ATP.lambda_449
tff(fact_6615_ATP_Olambda__450,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_as(fun(A,bool),fun(A,bool),Uu),Uua))
    <=> ~ pp(aa(A,bool,Uu,Uua)) ) ).

% ATP.lambda_450
tff(fact_6616_ATP_Olambda__451,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,fun(A,bool)),Uua: B] :
      ( pp(aa(B,bool,aTP_Lamp_ayi(fun(B,fun(A,bool)),fun(B,bool),Uu),Uua))
    <=> ! [X_12: A] : pp(aa(A,bool,aa(B,fun(A,bool),Uu,Uua),X_12)) ) ).

% ATP.lambda_451
tff(fact_6617_ATP_Olambda__452,axiom,
    ! [A: $tType,B: $tType] :
      ( finite_finite(B)
     => ! [Uu: fun(A,fun(B,bool)),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_afl(fun(A,fun(B,bool)),fun(A,bool),Uu),Uua))
        <=> ! [X_12: B] : pp(aa(B,bool,aa(A,fun(B,bool),Uu,Uua),X_12)) ) ) ).

% ATP.lambda_452
tff(fact_6618_ATP_Olambda__453,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,bool)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_afn(fun(A,fun(B,bool)),fun(A,bool),Uu),Uua))
    <=> ! [X_12: B] : pp(aa(B,bool,aa(A,fun(B,bool),Uu,Uua),X_12)) ) ).

% ATP.lambda_453
tff(fact_6619_ATP_Olambda__454,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,bool)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_gu(fun(A,fun(B,bool)),fun(A,bool),Uu),Uua))
    <=> ? [X_12: B] : pp(aa(B,bool,aa(A,fun(B,bool),Uu,Uua),X_12)) ) ).

% ATP.lambda_454
tff(fact_6620_ATP_Olambda__455,axiom,
    ! [A: $tType,B: $tType,Uu: fun(nat,sum_sum(B,nat)),Uua: sum_sum(A,nat)] : ( aa(sum_sum(A,nat),nat,aa(fun(nat,sum_sum(B,nat)),fun(sum_sum(A,nat),nat),aTP_Lamp_ayv(fun(nat,sum_sum(B,nat)),fun(sum_sum(A,nat),nat)),Uu),Uua) = ord_Least(nat,aTP_Lamp_ayu(fun(nat,sum_sum(B,nat)),fun(nat,bool),Uu)) ) ).

% ATP.lambda_455
tff(fact_6621_ATP_Olambda__456,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_ahn(nat,fun(nat,set(nat)),Uu),Uua) = aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_tj(nat,fun(nat,bool)),Uu)) ) ).

% ATP.lambda_456
tff(fact_6622_ATP_Olambda__457,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] : ( aa(set(A),filter(set(A)),aTP_Lamp_my(set(A),fun(set(A),filter(set(A))),Uu),Uua) = principal(set(A),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aa(set(A),fun(set(A),bool),aTP_Lamp_mx(set(A),fun(set(A),fun(set(A),bool)),Uu),Uua))) ) ).

% ATP.lambda_457
tff(fact_6623_ATP_Olambda__458,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,bool),Uua: fun(B,bool)] : ( aa(fun(B,bool),filter(product_prod(A,B)),aa(fun(A,bool),fun(fun(B,bool),filter(product_prod(A,B))),aTP_Lamp_qr(fun(A,bool),fun(fun(B,bool),filter(product_prod(A,B)))),Uu),Uua) = principal(product_prod(A,B),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(fun(B,bool),fun(A,fun(B,bool)),aTP_Lamp_cv(fun(A,bool),fun(fun(B,bool),fun(A,fun(B,bool))),Uu),Uua)))) ) ).

% ATP.lambda_458
tff(fact_6624_ATP_Olambda__459,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,fun(A,bool)),Uua: fun(B,A)] :
      ( pp(aa(fun(B,A),bool,aTP_Lamp_bam(fun(B,fun(A,bool)),fun(fun(B,A),bool),Uu),Uua))
    <=> ! [X3: B] : pp(aa(A,bool,aa(B,fun(A,bool),Uu,X3),aa(B,A,Uua,X3))) ) ).

% ATP.lambda_459
tff(fact_6625_ATP_Olambda__460,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,fun(A,bool)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_axb(fun(B,fun(A,bool)),fun(A,bool),Uu),Uua))
    <=> ? [X3: B] : pp(aa(A,bool,aa(B,fun(A,bool),Uu,X3),Uua)) ) ).

% ATP.lambda_460
tff(fact_6626_ATP_Olambda__461,axiom,
    ! [A: $tType,Uu: fun(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aTP_Lamp_bf(fun(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uu),Uua))
    <=> ? [X3: A] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uu,X3),Uua)) ) ).

% ATP.lambda_461
tff(fact_6627_ATP_Olambda__462,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,bool)),Uua: B] :
      ( pp(aa(B,bool,aTP_Lamp_adq(fun(A,fun(B,bool)),fun(B,bool),Uu),Uua))
    <=> ? [A6: A] : pp(aa(B,bool,aa(A,fun(B,bool),Uu,A6),Uua)) ) ).

% ATP.lambda_462
tff(fact_6628_ATP_Olambda__463,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_auw(fun(A,fun(A,bool)),fun(set(A),bool),Uu),Uua))
    <=> ? [X3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Uu,X3),X3))
          & ( Uua = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),Uu,X3)) ) ) ) ).

% ATP.lambda_463
tff(fact_6629_ATP_Olambda__464,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_aji(list(A),fun(A,bool),Uu),Uua))
    <=> ? [I6: nat] :
          ( ( Uua = aa(nat,A,nth(A,Uu),I6) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I6),aa(list(A),nat,size_size(list(A)),Uu))) ) ) ).

% ATP.lambda_464
tff(fact_6630_ATP_Olambda__465,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: set(set(option(A))),Uua: set(option(A))] :
          ( pp(aa(set(option(A)),bool,aTP_Lamp_aei(set(set(option(A))),fun(set(option(A)),bool),Uu),Uua))
        <=> ? [F8: fun(set(option(A)),option(A))] :
              ( ( Uua = aa(set(set(option(A))),set(option(A)),image2(set(option(A)),option(A),F8),Uu) )
              & ! [X3: set(option(A))] :
                  ( pp(aa(set(set(option(A))),bool,member(set(option(A)),X3),Uu))
                 => pp(aa(set(option(A)),bool,member(option(A),aa(set(option(A)),option(A),F8,X3)),X3)) ) ) ) ) ).

% ATP.lambda_465
tff(fact_6631_ATP_Olambda__466,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: set(B)] :
      ( pp(aa(set(B),bool,aTP_Lamp_aeh(set(set(B)),fun(set(B),bool),Uu),Uua))
    <=> ? [F8: fun(set(B),B)] :
          ( ( Uua = aa(set(set(B)),set(B),image2(set(B),B,F8),Uu) )
          & ! [X3: set(B)] :
              ( pp(aa(set(set(B)),bool,member(set(B),X3),Uu))
             => pp(aa(set(B),bool,member(B,aa(set(B),B,F8,X3)),X3)) ) ) ) ).

% ATP.lambda_466
tff(fact_6632_ATP_Olambda__467,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( pp(aa(set(A),bool,aTP_Lamp_aeb(set(set(A)),fun(set(A),bool),Uu),Uua))
        <=> ? [F8: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image2(set(A),A,F8),Uu) )
              & ! [X3: set(A)] :
                  ( pp(aa(set(set(A)),bool,member(set(A),X3),Uu))
                 => pp(aa(set(A),bool,member(A,aa(set(A),A,F8,X3)),X3)) ) ) ) ) ).

% ATP.lambda_467
tff(fact_6633_ATP_Olambda__468,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( pp(aa(set(A),bool,aTP_Lamp_aed(set(set(A)),fun(set(A),bool),Uu),Uua))
        <=> ? [F8: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image2(set(A),A,F8),Uu) )
              & ! [X3: set(A)] :
                  ( pp(aa(set(set(A)),bool,member(set(A),X3),Uu))
                 => pp(aa(set(A),bool,member(A,aa(set(A),A,F8,X3)),X3)) ) ) ) ) ).

% ATP.lambda_468
tff(fact_6634_ATP_Olambda__469,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( pp(aa(set(A),bool,aTP_Lamp_aee(set(set(A)),fun(set(A),bool),Uu),Uua))
        <=> ? [F8: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image2(set(A),A,F8),Uu) )
              & ! [X3: set(A)] :
                  ( pp(aa(set(set(A)),bool,member(set(A),X3),Uu))
                 => pp(aa(set(A),bool,member(A,aa(set(A),A,F8,X3)),X3)) ) ) ) ) ).

% ATP.lambda_469
tff(fact_6635_ATP_Olambda__470,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_kg(set(A),fun(set(A),bool),Uu),Uua))
    <=> ? [B9: set(A)] :
          ( ( Uua = aa(set(A),set(A),uminus_uminus(set(A)),B9) )
          & pp(aa(set(set(A)),bool,member(set(A),Uu),pow(A,B9))) ) ) ).

% ATP.lambda_470
tff(fact_6636_ATP_Olambda__471,axiom,
    ! [A: $tType,Uu: set(filter(A)),Uua: filter(A)] :
      ( pp(aa(filter(A),bool,aTP_Lamp_aec(set(filter(A)),fun(filter(A),bool),Uu),Uua))
    <=> ! [X3: filter(A)] :
          ( pp(aa(set(filter(A)),bool,member(filter(A),X3),Uu))
         => pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),Uua),X3)) ) ) ).

% ATP.lambda_471
tff(fact_6637_ATP_Olambda__472,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_aek(set(A),fun(A,bool),Uu),Uua))
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),Uu))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),X3)) ) ) ) ).

% ATP.lambda_472
tff(fact_6638_ATP_Olambda__473,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_adv(set(A),fun(A,bool),Uu),Uua))
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),Uu))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),X3)) ) ) ) ).

% ATP.lambda_473
tff(fact_6639_ATP_Olambda__474,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_ade(set(A),fun(A,bool),Uu),Uua))
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),Uu))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Uua)) ) ) ) ).

% ATP.lambda_474
tff(fact_6640_ATP_Olambda__475,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_adu(set(A),fun(A,bool),Uu),Uua))
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),Uu))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Uua)) ) ) ) ).

% ATP.lambda_475
tff(fact_6641_ATP_Olambda__476,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: multiset(A)] :
      ( pp(aa(multiset(A),bool,aTP_Lamp_atv(set(multiset(A)),fun(multiset(A),bool),Uu),Uua))
    <=> ! [X3: multiset(A)] :
          ( pp(aa(set(multiset(A)),bool,member(multiset(A),X3),Uu))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Uua),X3)) ) ) ).

% ATP.lambda_476
tff(fact_6642_ATP_Olambda__477,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: multiset(A)] :
      ( pp(aa(multiset(A),bool,aTP_Lamp_atp(set(multiset(A)),fun(multiset(A),bool),Uu),Uua))
    <=> ! [X3: multiset(A)] :
          ( pp(aa(set(multiset(A)),bool,member(multiset(A),X3),Uu))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X3),Uua)) ) ) ).

% ATP.lambda_477
tff(fact_6643_ATP_Olambda__478,axiom,
    ! [Uu: set(nat),Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_auk(set(nat),fun(nat,bool),Uu),Uua))
    <=> ! [X3: nat] :
          ( pp(aa(set(nat),bool,member(nat,X3),Uu))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),Uua),X3)) ) ) ).

% ATP.lambda_478
tff(fact_6644_ATP_Olambda__479,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_aui(set(A),fun(A,bool),Uu),Uua))
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),Uu))
             => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Uua),X3)) ) ) ) ).

% ATP.lambda_479
tff(fact_6645_ATP_Olambda__480,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_auj(set(A),fun(A,bool),Uu),Uua))
        <=> ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),Uu))
             => pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),X3),Uua)) ) ) ) ).

% ATP.lambda_480
tff(fact_6646_ATP_Olambda__481,axiom,
    ! [A: $tType,Uu: set(filter(A)),Uua: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aTP_Lamp_aeq(set(filter(A)),fun(fun(A,bool),bool),Uu),Uua))
    <=> ! [X3: filter(A)] :
          ( pp(aa(set(filter(A)),bool,member(filter(A),X3),Uu))
         => eventually(A,Uua,X3) ) ) ).

% ATP.lambda_481
tff(fact_6647_ATP_Olambda__482,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_adi(set(set(A)),fun(A,bool),Uu),Uua))
    <=> ! [X3: set(A)] :
          ( pp(aa(set(set(A)),bool,member(set(A),X3),Uu))
         => pp(aa(set(A),bool,member(A,Uua),X3)) ) ) ).

% ATP.lambda_482
tff(fact_6648_ATP_Olambda__483,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_aex(set(set(A)),fun(A,bool),Uu),Uua))
    <=> ? [X3: set(A)] :
          ( pp(aa(set(set(A)),bool,member(set(A),X3),Uu))
          & pp(aa(set(A),bool,member(A,Uua),X3)) ) ) ).

% ATP.lambda_483
tff(fact_6649_ATP_Olambda__484,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(A,bool),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_afo(fun(A,bool),fun(A,bool),Uu),Uua))
        <=> ! [Y4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Y4))
             => pp(aa(A,bool,Uu,Y4)) ) ) ) ).

% ATP.lambda_484
tff(fact_6650_ATP_Olambda__485,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_aqi(fun(A,bool),fun(set(A),bool),Uu),Uua))
    <=> ! [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),Uua))
         => pp(aa(A,bool,Uu,X3)) ) ) ).

% ATP.lambda_485
tff(fact_6651_ATP_Olambda__486,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_agn(set(product_prod(A,A)),fun(set(A),bool),Uu),Uua))
    <=> ! [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),Uua))
         => ! [Xa2: A] :
              ( pp(aa(set(A),bool,member(A,Xa2),Uua))
             => ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa2)),Uu))
                | pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa2),X3)),Uu)) ) ) ) ) ).

% ATP.lambda_486
tff(fact_6652_ATP_Olambda__487,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_axk(set(product_prod(A,B)),fun(A,bool),Uu),Uua))
    <=> ? [Y4: B] : pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Y4)),Uu)) ) ).

% ATP.lambda_487
tff(fact_6653_ATP_Olambda__488,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,option(B)),Uua: B] :
      ( pp(aa(B,bool,aTP_Lamp_acw(fun(A,option(B)),fun(B,bool),Uu),Uua))
    <=> ? [A6: A] : ( aa(A,option(B),Uu,A6) = aa(B,option(B),some(B),Uua) ) ) ).

% ATP.lambda_488
tff(fact_6654_ATP_Olambda__489,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aTP_Lamp_ak(fun(A,assn),fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uu),Uua))
    <=> ? [X3: A] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,Uu,X3)),Uua)) ) ).

% ATP.lambda_489
tff(fact_6655_ATP_Olambda__490,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(old_node(A,B))),Uua: set(old_node(A,B))] :
      ( pp(aa(set(old_node(A,B)),bool,aTP_Lamp_ayx(fun(B,set(old_node(A,B))),fun(set(old_node(A,B)),bool),Uu),Uua))
    <=> ? [X3: B] : ( Uua = aa(set(old_node(A,B)),set(old_node(A,B)),image2(old_node(A,B),old_node(A,B),old_Push_Node(B,A,aa(B,sum_sum(B,nat),sum_Inl(B,nat),X3))),aa(B,set(old_node(A,B)),Uu,X3)) ) ) ).

% ATP.lambda_490
tff(fact_6656_ATP_Olambda__491,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aTP_Lamp_aas(A,fun(product_prod(A,B),bool),Uu),Uua))
    <=> ? [V5: B] : ( Uua = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uu),V5) ) ) ).

% ATP.lambda_491
tff(fact_6657_ATP_Olambda__492,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ck(fun(B,A),fun(A,bool),Uu),Uua))
    <=> ? [X3: B] : ( Uua = aa(B,A,Uu,X3) ) ) ).

% ATP.lambda_492
tff(fact_6658_ATP_Olambda__493,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,bool),Uua: fun(A,B)] :
      ( pp(aa(fun(A,B),bool,aTP_Lamp_apw(fun(B,bool),fun(fun(A,B),bool),Uu),Uua))
    <=> ! [X3: A] : pp(aa(B,bool,Uu,aa(A,B,Uua,X3))) ) ).

% ATP.lambda_493
tff(fact_6659_ATP_Olambda__494,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(A,option(B))] :
      ( pp(aa(fun(A,option(B)),bool,aTP_Lamp_baa(fun(A,fun(B,bool)),fun(fun(A,option(B)),bool),Uu),Uua))
    <=> ! [X3: A,Y4: B] :
          ( ( aa(A,option(B),Uua,X3) = aa(B,option(B),some(B),Y4) )
         => pp(aa(B,bool,aa(A,fun(B,bool),Uu,X3),Y4)) ) ) ).

% ATP.lambda_494
tff(fact_6660_ATP_Olambda__495,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: product_prod(product_prod(bool,A),product_prod(bool,B))] :
      ( pp(aa(product_prod(product_prod(bool,A),product_prod(bool,B)),bool,aTP_Lamp_bb(set(product_prod(A,B)),fun(product_prod(product_prod(bool,A),product_prod(bool,B)),bool),Uu),Uua))
    <=> ? [X3: A,Y4: B] :
          ( ( Uua = aa(product_prod(bool,B),product_prod(product_prod(bool,A),product_prod(bool,B)),aa(product_prod(bool,A),fun(product_prod(bool,B),product_prod(product_prod(bool,A),product_prod(bool,B))),product_Pair(product_prod(bool,A),product_prod(bool,B)),aa(A,product_prod(bool,A),aa(bool,fun(A,product_prod(bool,A)),product_Pair(bool,A),fFalse),X3)),aa(B,product_prod(bool,B),aa(bool,fun(B,product_prod(bool,B)),product_Pair(bool,B),fFalse),Y4)) )
          & pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Y4)),Uu)) ) ) ).

% ATP.lambda_495
tff(fact_6661_ATP_Olambda__496,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,option(B)),Uua: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aTP_Lamp_ada(fun(A,option(B)),fun(product_prod(A,B),bool),Uu),Uua))
    <=> ? [A6: A,B5: B] :
          ( ( Uua = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A6),B5) )
          & ( aa(A,option(B),Uu,A6) = aa(B,option(B),some(B),B5) ) ) ) ).

% ATP.lambda_496
tff(fact_6662_ATP_Olambda__497,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: product_prod(set(A),set(A))] :
      ( pp(aa(product_prod(set(A),set(A)),bool,aTP_Lamp_aer(set(product_prod(A,A)),fun(product_prod(set(A),set(A)),bool),Uu),Uua))
    <=> ? [X7: set(A),Y7: set(A)] :
          ( ( Uua = aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),X7),Y7) )
          & ( X7 != bot_bot(set(A)) )
          & ! [X3: A] :
              ( pp(aa(set(A),bool,member(A,X3),Y7))
             => ? [Xa2: A] :
                  ( pp(aa(set(A),bool,member(A,Xa2),X7))
                  & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa2),X3)),Uu)) ) ) ) ) ).

% ATP.lambda_497
tff(fact_6663_ATP_Olambda__498,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool))))),Uua: fun(A,heap_Time_Heap(B))] :
      ( pp(aa(fun(A,heap_Time_Heap(B)),bool,aTP_Lamp_bax(fun(A,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool))))),fun(fun(A,heap_Time_Heap(B)),bool),Uu),Uua))
    <=> ! [X3: A,H: heap_ext(product_unit),H7: heap_ext(product_unit),R7: B,N5: nat] :
          ( heap_Time_effect(B,aa(A,heap_Time_Heap(B),Uua,X3),H,H7,R7,N5)
         => pp(aa(nat,bool,aa(B,fun(nat,bool),aa(heap_ext(product_unit),fun(B,fun(nat,bool)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool))),aa(A,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool)))),Uu,X3),H),H7),R7),N5)) ) ) ).

% ATP.lambda_498
tff(fact_6664_ATP_Olambda__499,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: A] : ( aa(A,set(B),aTP_Lamp_br(set(B),fun(A,set(B)),Uu),Uua) = aa(set(B),set(B),uminus_uminus(set(B)),Uu) ) ).

% ATP.lambda_499
tff(fact_6665_ATP_Olambda__500,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] : ( aa(A,set(A),aTP_Lamp_bi(set(A),fun(A,set(A)),Uu),Uua) = aa(set(A),set(A),uminus_uminus(set(A)),Uu) ) ).

% ATP.lambda_500
tff(fact_6666_ATP_Olambda__501,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A),Uua: array(A)] : ( aa(array(A),heap_Time_Heap(array(A)),aTP_Lamp_axf(array(A),fun(array(A),heap_Time_Heap(array(A))),Uu),Uua) = heap_Time_ureturn(array(A),Uu) ) ) ).

% ATP.lambda_501
tff(fact_6667_ATP_Olambda__502,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),option(A),aa(A,fun(list(A),option(A)),aTP_Lamp_amq(A,fun(list(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),Uu) ) ).

% ATP.lambda_502
tff(fact_6668_ATP_Olambda__503,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: C] : ( aa(C,set(B),aTP_Lamp_agm(set(product_prod(B,B)),fun(C,set(B)),Uu),Uua) = field2(B,Uu) ) ).

% ATP.lambda_503
tff(fact_6669_ATP_Olambda__504,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: A] : ( aa(A,set(B),aTP_Lamp_ags(set(product_prod(B,B)),fun(A,set(B)),Uu),Uua) = field2(B,Uu) ) ).

% ATP.lambda_504
tff(fact_6670_ATP_Olambda__505,axiom,
    ! [C: $tType,A: $tType,Uu: set(product_prod(A,A)),Uua: C] : ( aa(C,set(A),aTP_Lamp_agl(set(product_prod(A,A)),fun(C,set(A)),Uu),Uua) = field2(A,Uu) ) ).

% ATP.lambda_505
tff(fact_6671_ATP_Olambda__506,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,A)),Uua: B] : ( aa(B,set(A),aTP_Lamp_agr(set(product_prod(A,A)),fun(B,set(A)),Uu),Uua) = field2(A,Uu) ) ).

% ATP.lambda_506
tff(fact_6672_ATP_Olambda__507,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A] : ( aa(A,set(A),aTP_Lamp_ey(set(product_prod(A,A)),fun(A,set(A)),Uu),Uua) = field2(A,Uu) ) ).

% ATP.lambda_507
tff(fact_6673_ATP_Olambda__508,axiom,
    ! [A: $tType,B: $tType,Uu: list(B),Uua: A] : ( aa(A,set(B),aTP_Lamp_aik(list(B),fun(A,set(B)),Uu),Uua) = aa(list(B),set(B),set2(B),Uu) ) ).

% ATP.lambda_508
tff(fact_6674_ATP_Olambda__509,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,bool),Uua: A] : ( aa(A,set(B),aTP_Lamp_cw(fun(B,bool),fun(A,set(B)),Uu),Uua) = aa(fun(B,bool),set(B),collect(B),Uu) ) ).

% ATP.lambda_509
tff(fact_6675_ATP_Olambda__510,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),fun(set(A),set(A)),aa(A,fun(list(A),fun(set(A),set(A))),aTP_Lamp_aor(A,fun(list(A),fun(set(A),set(A)))),Uu),Uua) = insert(A,Uu) ) ).

% ATP.lambda_510
tff(fact_6676_ATP_Olambda__511,axiom,
    ! [A: $tType,Uu: set(A),Uua: list(A)] : ( aa(list(A),set(list(A)),aTP_Lamp_any(set(A),fun(list(A),set(list(A))),Uu),Uua) = lists(A,Uu) ) ).

% ATP.lambda_511
tff(fact_6677_ATP_Olambda__512,axiom,
    ! [A: $tType,Uu: nat,Uua: A] : ( aa(A,nat,aa(nat,fun(A,nat),aTP_Lamp_aif(nat,fun(A,nat)),Uu),Uua) = aa(nat,nat,suc,Uu) ) ).

% ATP.lambda_512
tff(fact_6678_ATP_Olambda__513,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: option(A),Uub: option(B)] :
      ( pp(aa(option(B),bool,aa(option(A),fun(option(B),bool),aTP_Lamp_avg(fun(A,fun(B,bool)),fun(option(A),fun(option(B),bool)),Uu),Uua),Uub))
    <=> pp(case_option(bool,A,case_option(bool,B,fTrue,aTP_Lamp_ave(B,bool),Uub),aa(option(B),fun(A,bool),aTP_Lamp_avf(fun(A,fun(B,bool)),fun(option(B),fun(A,bool)),Uu),Uub),Uua)) ) ).

% ATP.lambda_513
tff(fact_6679_ATP_Olambda__514,axiom,
    ! [Uu: num,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_yt(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),aa(num,code_integer,numeral_numeral(code_integer),Uu)),Uub),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uub),aa(num,code_integer,numeral_numeral(code_integer),Uu))),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_514
tff(fact_6680_ATP_Olambda__515,axiom,
    ! [Uu: num,Uua: nat,Uub: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_yr(num,fun(nat,fun(nat,product_prod(nat,nat))),Uu),Uua),Uub) = if(product_prod(nat,nat),aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Uu)),Uub),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),Uu))),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_515
tff(fact_6681_ATP_Olambda__516,axiom,
    ! [Uu: num,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_ys(num,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),Uu)),Uub),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),Uub),aa(num,int,numeral_numeral(int),Uu))),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_516
tff(fact_6682_ATP_Olambda__517,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: num,Uua: A,Uub: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_yq(num,fun(A,fun(A,product_prod(A,A))),Uu),Uua),Uub) = if(product_prod(A,A),aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),Uu)),Uub),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),aa(num,A,numeral_numeral(A),Uu))),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),Uub)) ) ) ).

% ATP.lambda_517
tff(fact_6683_ATP_Olambda__518,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_arw(A,fun(A,fun(list(A),list(A))),Uu),Uua),Uub) = if(list(A),aa(A,bool,aa(A,fun(A,bool),fequal(A),Uu),Uua),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uua),Uub),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uu),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uua),Uub))) ) ).

% ATP.lambda_518
tff(fact_6684_ATP_Olambda__519,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] : ( aa(B,A,aa(set(B),fun(B,A),aTP_Lamp_pt(fun(B,A),fun(set(B),fun(B,A)),Uu),Uua),Uub) = if(A,aa(set(B),bool,member(B,Uub),Uua),aa(B,A,Uu,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_519
tff(fact_6685_ATP_Olambda__520,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] : ( aa(B,A,aa(set(B),fun(B,A),aTP_Lamp_pq(fun(B,A),fun(set(B),fun(B,A)),Uu),Uua),Uub) = if(A,aa(set(B),bool,member(B,Uub),Uua),aa(B,A,Uu,Uub),one_one(A)) ) ) ).

% ATP.lambda_520
tff(fact_6686_ATP_Olambda__521,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_og(B,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uu),Uub),aa(B,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_521
tff(fact_6687_ATP_Olambda__522,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_oi(B,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uu),Uub),aa(B,A,Uua,Uub),one_one(A)) ) ) ).

% ATP.lambda_522
tff(fact_6688_ATP_Olambda__523,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_of(B,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uub),Uu),aa(B,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_523
tff(fact_6689_ATP_Olambda__524,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_oh(B,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uub),Uu),aa(B,A,Uua,Uub),one_one(A)) ) ) ).

% ATP.lambda_524
tff(fact_6690_ATP_Olambda__525,axiom,
    ! [A: $tType,Uu: A,Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aa(A,fun(fun(A,nat),fun(A,nat)),aTP_Lamp_apt(A,fun(fun(A,nat),fun(A,nat))),Uu),Uua),Uub) = if(nat,aa(A,bool,aa(A,fun(A,bool),fequal(A),Uub),Uu),aa(nat,nat,suc,aa(A,nat,Uua,Uub)),aa(A,nat,Uua,Uub)) ) ).

% ATP.lambda_525
tff(fact_6691_ATP_Olambda__526,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A,Uub: A] : ( aa(A,nat,aa(A,fun(A,nat),aTP_Lamp_apv(fun(A,nat),fun(A,fun(A,nat)),Uu),Uua),Uub) = if(nat,aa(A,bool,aa(A,fun(A,bool),fequal(A),Uub),Uua),aa(nat,nat,suc,aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uub)) ) ).

% ATP.lambda_526
tff(fact_6692_ATP_Olambda__527,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Uu: B,Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_apl(B,fun(A,fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uu),Uub),Uua,zero_zero(A)) ) ) ).

% ATP.lambda_527
tff(fact_6693_ATP_Olambda__528,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_aqs(B,fun(A,fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uu),Uub),Uua,one_one(A)) ) ) ).

% ATP.lambda_528
tff(fact_6694_ATP_Olambda__529,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Uu: B,Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_apu(B,fun(A,fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uub),Uu),Uua,zero_zero(A)) ) ) ).

% ATP.lambda_529
tff(fact_6695_ATP_Olambda__530,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_aqt(B,fun(A,fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uub),Uu),Uua,one_one(A)) ) ) ).

% ATP.lambda_530
tff(fact_6696_ATP_Olambda__531,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zl(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_531
tff(fact_6697_ATP_Olambda__532,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zp(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,abs_abs(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_532
tff(fact_6698_ATP_Olambda__533,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zk(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uu),Uub))) ) ).

% ATP.lambda_533
tff(fact_6699_ATP_Olambda__534,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_ajd(fun(A,bool),fun(A,fun(list(A),list(A))),Uu),Uua),Uub) = if(list(A),aa(A,bool,Uu,Uua),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uua),Uub),Uub) ) ).

% ATP.lambda_534
tff(fact_6700_ATP_Olambda__535,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: set(A)] : ( aa(set(A),set(A),aa(A,fun(set(A),set(A)),aTP_Lamp_ld(fun(A,bool),fun(A,fun(set(A),set(A))),Uu),Uua),Uub) = if(set(A),aa(A,bool,Uu,Uua),aa(set(A),set(A),insert(A,Uua),Uub),Uub) ) ).

% ATP.lambda_535
tff(fact_6701_ATP_Olambda__536,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aa(fun(A,bool),fun(fun(A,nat),fun(A,nat)),aTP_Lamp_apx(fun(A,bool),fun(fun(A,nat),fun(A,nat))),Uu),Uua),Uub) = if(nat,aa(A,bool,Uu,Uub),aa(A,nat,Uua,Uub),zero_zero(nat)) ) ).

% ATP.lambda_536
tff(fact_6702_ATP_Olambda__537,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,bool),Uub: B] : ( aa(B,A,aa(fun(B,bool),fun(B,A),aTP_Lamp_pj(fun(B,A),fun(fun(B,bool),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,Uua,Uub),aa(B,A,Uu,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_537
tff(fact_6703_ATP_Olambda__538,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,bool),Uub: B] : ( aa(B,A,aa(fun(B,bool),fun(B,A),aTP_Lamp_akc(fun(B,A),fun(fun(B,bool),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,Uua,Uub),aa(B,A,Uu,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_538
tff(fact_6704_ATP_Olambda__539,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: fun(A,bool),Uub: A] : ( aa(A,nat,aa(fun(A,bool),fun(A,nat),aTP_Lamp_aqj(fun(A,nat),fun(fun(A,bool),fun(A,nat)),Uu),Uua),Uub) = if(nat,aa(A,bool,Uua,Uub),aa(A,nat,Uu,Uub),zero_zero(nat)) ) ).

% ATP.lambda_539
tff(fact_6705_ATP_Olambda__540,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: fun(B,bool),Uub: B] : ( aa(B,A,aa(fun(B,bool),fun(B,A),aTP_Lamp_pg(fun(B,A),fun(fun(B,bool),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,Uua,Uub),aa(B,A,Uu,Uub),one_one(A)) ) ) ).

% ATP.lambda_540
tff(fact_6706_ATP_Olambda__541,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,fun(A,A)),Uua: fun(B,bool),Uub: B] : ( aa(B,fun(A,A),aa(fun(B,bool),fun(B,fun(A,A)),aTP_Lamp_aja(fun(B,fun(A,A)),fun(fun(B,bool),fun(B,fun(A,A))),Uu),Uua),Uub) = if(fun(A,A),aa(B,bool,Uua,Uub),aa(B,fun(A,A),Uu,Uub),id(A)) ) ).

% ATP.lambda_541
tff(fact_6707_ATP_Olambda__542,axiom,
    ! [A: $tType,Uu: fun(heap_ext(product_unit),bool),Uua: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_aws(fun(heap_ext(product_unit),bool),fun(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub) = if(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),bool,Uu,Uub),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),Uua,Uub)),none(product_prod(A,product_prod(heap_ext(product_unit),nat)))) ) ).

% ATP.lambda_542
tff(fact_6708_ATP_Olambda__543,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: fun(B,bool),Uub: B] : ( aa(B,option(A),aa(fun(B,bool),fun(B,option(A)),aTP_Lamp_akm(fun(B,A),fun(fun(B,bool),fun(B,option(A))),Uu),Uua),Uub) = if(option(A),aa(B,bool,Uua,Uub),aa(A,option(A),some(A),aa(B,A,Uu,Uub)),none(A)) ) ).

% ATP.lambda_543
tff(fact_6709_ATP_Olambda__544,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: A,Uub: set(product_prod(A,B))] : ( aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(A,fun(set(product_prod(A,B)),set(product_prod(A,B))),aTP_Lamp_lw(set(B),fun(A,fun(set(product_prod(A,B)),set(product_prod(A,B)))),Uu),Uua),Uub) = finite_fold(B,set(product_prod(A,B)),aTP_Lamp_lv(A,fun(B,fun(set(product_prod(A,B)),set(product_prod(A,B)))),Uua),Uub,Uu) ) ).

% ATP.lambda_544
tff(fact_6710_ATP_Olambda__545,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: B,Uub: set(product_prod(B,A))] : ( aa(set(product_prod(B,A)),set(product_prod(B,A)),aa(B,fun(set(product_prod(B,A)),set(product_prod(B,A))),aTP_Lamp_lr(set(A),fun(B,fun(set(product_prod(B,A)),set(product_prod(B,A)))),Uu),Uua),Uub) = finite_fold(A,set(product_prod(B,A)),aTP_Lamp_ln(B,fun(A,fun(set(product_prod(B,A)),set(product_prod(B,A)))),Uua),Uub,Uu) ) ).

% ATP.lambda_545
tff(fact_6711_ATP_Olambda__546,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,A)),Uua: option(A),Uub: A] : ( aa(A,option(A),aa(option(A),fun(A,option(A)),aTP_Lamp_auo(fun(A,fun(A,A)),fun(option(A),fun(A,option(A))),Uu),Uua),Uub) = case_option(option(A),A,aa(A,option(A),some(A),Uub),aa(A,fun(A,option(A)),aTP_Lamp_aun(fun(A,fun(A,A)),fun(A,fun(A,option(A))),Uu),Uub),Uua) ) ).

% ATP.lambda_546
tff(fact_6712_ATP_Olambda__547,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: list(A),Uub: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),aTP_Lamp_ayc(fun(A,fun(A,bool)),fun(list(A),fun(list(A),list(A))),Uu),Uua),Uub) = merges9089515139780605204_merge(A,Uu,aa(list(A),list(A),mergesort_by_rel(A,Uu),Uua),aa(list(A),list(A),mergesort_by_rel(A,Uu),Uub)) ) ).

% ATP.lambda_547
tff(fact_6713_ATP_Olambda__548,axiom,
    ! [A: $tType] :
      ( sup(A)
     => ! [Uu: option(A),Uua: option(A),Uub: A] : ( aa(A,option(A),aa(option(A),fun(A,option(A)),aTP_Lamp_aah(option(A),fun(option(A),fun(A,option(A))),Uu),Uua),Uub) = case_option(option(A),A,Uu,aTP_Lamp_aag(A,fun(A,option(A)),Uub),Uua) ) ) ).

% ATP.lambda_548
tff(fact_6714_ATP_Olambda__549,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A),Uua: list(A),Uub: fun(typerep,fun(nat,list(nat)))] : ( aa(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat))),aa(list(A),fun(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat)))),aTP_Lamp_azv(array(A),fun(list(A),fun(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat))))),Uu),Uua),Uub) = fun_upd(typerep,fun(nat,list(nat)),Uub,typerep_typerep(A,type2(A)),fun_upd(nat,list(nat),aa(typerep,fun(nat,list(nat)),Uub,typerep_typerep(A,type2(A))),addr_of_array(A,Uu),aa(list(A),list(nat),map(A,nat,to_nat(A)),Uua))) ) ) ).

% ATP.lambda_549
tff(fact_6715_ATP_Olambda__550,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: ref(A),Uua: A,Uub: fun(typerep,fun(nat,nat))] : ( aa(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat)),aa(A,fun(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat))),aTP_Lamp_azw(ref(A),fun(A,fun(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat)))),Uu),Uua),Uub) = fun_upd(typerep,fun(nat,nat),Uub,typerep_typerep(A,type2(A)),fun_upd(nat,nat,aa(typerep,fun(nat,nat),Uub,typerep_typerep(A,type2(A))),addr_of_ref(A,Uu),aa(A,nat,to_nat(A),Uua))) ) ) ).

% ATP.lambda_550
tff(fact_6716_ATP_Olambda__551,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,option(B)),Uua: A,Uub: B] : ( aa(B,fun(A,option(B)),aa(A,fun(B,fun(A,option(B))),aTP_Lamp_aru(fun(A,option(B)),fun(A,fun(B,fun(A,option(B)))),Uu),Uua),Uub) = fun_upd(A,option(B),Uu,Uua,aa(B,option(B),some(B),Uub)) ) ).

% ATP.lambda_551
tff(fact_6717_ATP_Olambda__552,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: B,Uub: fun(A,option(B))] : ( aa(fun(A,option(B)),fun(A,option(B)),aa(B,fun(fun(A,option(B)),fun(A,option(B))),aa(A,fun(B,fun(fun(A,option(B)),fun(A,option(B)))),aTP_Lamp_amb(A,fun(B,fun(fun(A,option(B)),fun(A,option(B))))),Uu),Uua),Uub) = fun_upd(A,option(B),Uub,Uu,aa(B,option(B),some(B),Uua)) ) ).

% ATP.lambda_552
tff(fact_6718_ATP_Olambda__553,axiom,
    ! [A: $tType,Uu: fun(A,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ahb(fun(A,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,compow(fun(A,A),Uub,Uu),Uua) ) ).

% ATP.lambda_553
tff(fact_6719_ATP_Olambda__554,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: bool] : ( aa(bool,set(A),aa(set(A),fun(bool,set(A)),aTP_Lamp_fx(set(A),fun(set(A),fun(bool,set(A))),Uu),Uua),Uub) = if(set(A),Uub,Uu,Uua) ) ).

% ATP.lambda_554
tff(fact_6720_ATP_Olambda__555,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,bool)),Uua: option(B),Uub: A] :
      ( pp(aa(A,bool,aa(option(B),fun(A,bool),aTP_Lamp_avf(fun(A,fun(B,bool)),fun(option(B),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(case_option(bool,B,fFalse,aa(A,fun(B,bool),Uu,Uub),Uua)) ) ).

% ATP.lambda_555
tff(fact_6721_ATP_Olambda__556,axiom,
    ! [B: $tType,A: $tType,Uu: heap_Time_Heap(A),Uua: fun(A,heap_Time_Heap(B)),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(A,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_axj(heap_Time_Heap(A),fun(fun(A,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub) = case_option(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(A,product_prod(heap_ext(product_unit),nat)),none(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(A,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),product_case_prod(A,product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_axi(fun(A,heap_Time_Heap(B)),fun(A,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uua)),aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(A,Uu),Uub)) ) ).

% ATP.lambda_556
tff(fact_6722_ATP_Olambda__557,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,A)),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_atd(fun(A,fun(A,A)),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),Uu,aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub))),aa(nat,A,Uua,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub)))) ) ).

% ATP.lambda_557
tff(fact_6723_ATP_Olambda__558,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Uu: fun(A,fun(B,C)),Uua: fun(D,A),Uub: product_prod(D,B)] : ( aa(product_prod(D,B),C,aa(fun(D,A),fun(product_prod(D,B),C),aTP_Lamp_dk(fun(A,fun(B,C)),fun(fun(D,A),fun(product_prod(D,B),C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,aa(D,A,Uua,aa(product_prod(D,B),D,product_fst(D,B),Uub))),aa(product_prod(D,B),B,product_snd(D,B),Uub)) ) ).

% ATP.lambda_558
tff(fact_6724_ATP_Olambda__559,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: fun(B,C),Uub: B] : ( aa(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_jc(fun(C,fun(B,A)),fun(fun(B,C),fun(B,A)),Uu),Uua),Uub) = aa(B,A,aa(C,fun(B,A),Uu,aa(B,C,Uua,Uub)),Uub) ) ) ).

% ATP.lambda_559
tff(fact_6725_ATP_Olambda__560,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_rg(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_560
tff(fact_6726_ATP_Olambda__561,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_re(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_561
tff(fact_6727_ATP_Olambda__562,axiom,
    ! [A: $tType,Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ary(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ).

% ATP.lambda_562
tff(fact_6728_ATP_Olambda__563,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(A,B),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_nr(fun(A,fun(B,bool)),fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(B,bool,aa(A,fun(B,bool),Uu,Uub),aa(A,B,Uua,Uub))) ) ).

% ATP.lambda_563
tff(fact_6729_ATP_Olambda__564,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_vf(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_564
tff(fact_6730_ATP_Olambda__565,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_vc(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_565
tff(fact_6731_ATP_Olambda__566,axiom,
    ! [A: $tType,Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_asy(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),Uua) ) ).

% ATP.lambda_566
tff(fact_6732_ATP_Olambda__567,axiom,
    ! [A: $tType,B: $tType,Uu: fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),Uua: B,Uub: fun(B,heap_Time_Heap(A))] : ( aa(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aTP_Lamp_bau(fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),Uu),Uua),Uub) = aa(B,heap_Time_Heap(A),aa(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)),Uu,Uub),Uua) ) ).

% ATP.lambda_567
tff(fact_6733_ATP_Olambda__568,axiom,
    ! [A: $tType,B: $tType,Uu: fun(fun(B,option(A)),fun(B,option(A))),Uua: B,Uub: fun(B,option(A))] : ( aa(fun(B,option(A)),option(A),aa(B,fun(fun(B,option(A)),option(A)),aTP_Lamp_baj(fun(fun(B,option(A)),fun(B,option(A))),fun(B,fun(fun(B,option(A)),option(A))),Uu),Uua),Uub) = aa(B,option(A),aa(fun(B,option(A)),fun(B,option(A)),Uu,Uub),Uua) ) ).

% ATP.lambda_568
tff(fact_6734_ATP_Olambda__569,axiom,
    ! [A: $tType,B: $tType,Uu: fun(fun(B,A),fun(B,A)),Uua: B,Uub: fun(B,A)] : ( aa(fun(B,A),A,aa(B,fun(fun(B,A),A),aTP_Lamp_bak(fun(fun(B,A),fun(B,A)),fun(B,fun(fun(B,A),A)),Uu),Uua),Uub) = aa(B,A,aa(fun(B,A),fun(B,A),Uu,Uub),Uua) ) ).

% ATP.lambda_569
tff(fact_6735_ATP_Olambda__570,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,Uu: fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),Uua: fun(A,heap_Time_Heap(B)),Uub: C] : ( aa(C,heap_Time_Heap(D),aa(fun(A,heap_Time_Heap(B)),fun(C,heap_Time_Heap(D)),aTP_Lamp_bav(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),fun(C,heap_Time_Heap(D))),Uu),Uua),Uub) = aa(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D),aa(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D)),Uu,Uub),Uua) ) ).

% ATP.lambda_570
tff(fact_6736_ATP_Olambda__571,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,Uu: fun(C,fun(fun(A,option(B)),option(D))),Uua: fun(A,option(B)),Uub: C] : ( aa(C,option(D),aa(fun(A,option(B)),fun(C,option(D)),aTP_Lamp_ban(fun(C,fun(fun(A,option(B)),option(D))),fun(fun(A,option(B)),fun(C,option(D))),Uu),Uua),Uub) = aa(fun(A,option(B)),option(D),aa(C,fun(fun(A,option(B)),option(D)),Uu,Uub),Uua) ) ).

% ATP.lambda_571
tff(fact_6737_ATP_Olambda__572,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B,Uub: C] : ( aa(C,A,aa(B,fun(C,A),aTP_Lamp_ja(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua),Uub) = aa(B,A,aa(C,fun(B,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_572
tff(fact_6738_ATP_Olambda__573,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( complete_Sup(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B,Uub: C] : ( aa(C,A,aa(B,fun(C,A),aTP_Lamp_fe(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua),Uub) = aa(B,A,aa(C,fun(B,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_573
tff(fact_6739_ATP_Olambda__574,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( complete_Inf(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B,Uub: C] : ( aa(C,A,aa(B,fun(C,A),aTP_Lamp_hw(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua),Uub) = aa(B,A,aa(C,fun(B,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_574
tff(fact_6740_ATP_Olambda__575,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(C,fun(B,A)),Uua: B,Uub: C] : ( aa(C,A,aa(B,fun(C,A),aTP_Lamp_atg(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua),Uub) = aa(B,A,aa(C,fun(B,A),Uu,Uub),Uua) ) ).

% ATP.lambda_575
tff(fact_6741_ATP_Olambda__576,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: C,Uub: B] : ( aa(B,A,aa(C,fun(B,A),aTP_Lamp_ft(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uua),Uub) = aa(C,A,aa(B,fun(C,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_576
tff(fact_6742_ATP_Olambda__577,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: C,Uub: B] : ( aa(B,A,aa(C,fun(B,A),aTP_Lamp_on(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uua),Uub) = aa(C,A,aa(B,fun(C,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_577
tff(fact_6743_ATP_Olambda__578,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: C,Uub: B] : ( aa(B,A,aa(C,fun(B,A),aTP_Lamp_ok(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uua),Uub) = aa(C,A,aa(B,fun(C,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_578
tff(fact_6744_ATP_Olambda__579,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,fun(C,A)),Uua: C,Uub: B] : ( aa(B,A,aa(C,fun(B,A),aTP_Lamp_asd(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uua),Uub) = aa(C,A,aa(B,fun(C,A),Uu,Uub),Uua) ) ).

% ATP.lambda_579
tff(fact_6745_ATP_Olambda__580,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,fun(A,bool)),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_kr(fun(B,fun(A,bool)),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(A,bool,aa(B,fun(A,bool),Uu,Uub),Uua)) ) ).

% ATP.lambda_580
tff(fact_6746_ATP_Olambda__581,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(B,fun(A,C)),Uua: A,Uub: B] : ( aa(B,C,aa(A,fun(B,C),aTP_Lamp_azt(fun(B,fun(A,C)),fun(A,fun(B,C)),Uu),Uua),Uub) = aa(A,C,aa(B,fun(A,C),Uu,Uub),Uua) ) ).

% ATP.lambda_581
tff(fact_6747_ATP_Olambda__582,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,fun(A,A)),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_aln(fun(B,fun(A,A)),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(B,fun(A,A),Uu,Uub),Uua) ) ).

% ATP.lambda_582
tff(fact_6748_ATP_Olambda__583,axiom,
    ! [A: $tType,B: $tType] :
      ( finite_finite(B)
     => ! [Uu: fun(A,fun(B,bool)),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_afk(fun(A,fun(B,bool)),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(A,fun(B,bool),Uu,Uub),Uua)) ) ) ).

% ATP.lambda_583
tff(fact_6749_ATP_Olambda__584,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,bool)),Uua: B,Uub: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_gv(fun(A,fun(B,bool)),fun(B,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(B,bool,aa(A,fun(B,bool),Uu,Uub),Uua)) ) ).

% ATP.lambda_584
tff(fact_6750_ATP_Olambda__585,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,B)),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_aig(fun(A,fun(B,B)),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(A,fun(B,B),Uu,Uub),Uua) ) ).

% ATP.lambda_585
tff(fact_6751_ATP_Olambda__586,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,A)),Uua: B,Uub: A] : ( aa(A,A,aa(B,fun(A,A),aTP_Lamp_alo(fun(A,fun(B,A)),fun(B,fun(A,A)),Uu),Uua),Uub) = aa(B,A,aa(A,fun(B,A),Uu,Uub),Uua) ) ).

% ATP.lambda_586
tff(fact_6752_ATP_Olambda__587,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_alm(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(A,bool,aa(A,fun(A,bool),Uu,Uub),Uua)) ) ).

% ATP.lambda_587
tff(fact_6753_ATP_Olambda__588,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,bool),aa(code_integer,fun(code_integer,product_prod(code_integer,bool)),aTP_Lamp_zo(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,bool))),Uu),Uua),Uub) = aa(bool,product_prod(code_integer,bool),aa(code_integer,fun(bool,product_prod(code_integer,bool)),product_Pair(code_integer,bool),if(code_integer,aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),Uu),Uua,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),Uub))),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),one_one(code_integer))) ) ).

% ATP.lambda_588
tff(fact_6754_ATP_Olambda__589,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(set(A)),Uub: set(set(A))] :
      ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),aTP_Lamp_agw(set(set(A)),fun(set(set(A)),fun(set(set(A)),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(set(A)),bool,pred_chain(set(A),Uu,ord_less(set(A))),Uub))
        & pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less(set(set(A))),Uua),Uub)) ) ) ).

% ATP.lambda_589
tff(fact_6755_ATP_Olambda__590,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_eu(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Uu,Uua),Uub))
        | ( Uua = Uub ) ) ) ).

% ATP.lambda_590
tff(fact_6756_ATP_Olambda__591,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_vg(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_vf(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uub)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_591
tff(fact_6757_ATP_Olambda__592,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_vd(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_vc(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uub)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_592
tff(fact_6758_ATP_Olambda__593,axiom,
    ! [Uu: product_prod(code_natural,code_natural),Uua: code_natural,Uub: code_natural] : ( aa(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aTP_Lamp_axw(product_prod(code_natural,code_natural),fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),Uu),Uua),Uub) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_case_prod(code_natural,code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aa(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),aTP_Lamp_axv(code_natural,fun(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))))),Uua),Uub)),aa(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(code_natural,code_natural),product_snd(code_natural,product_prod(code_natural,code_natural)),aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,Uu))) ) ).

% ATP.lambda_593
tff(fact_6759_ATP_Olambda__594,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_abb(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aba(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_594
tff(fact_6760_ATP_Olambda__595,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aaz(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aay(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_595
tff(fact_6761_ATP_Olambda__596,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aaw(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aav(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_596
tff(fact_6762_ATP_Olambda__597,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aau(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aat(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_597
tff(fact_6763_ATP_Olambda__598,axiom,
    ! [Uu: rat,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_aaq(rat,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> pp(aa(product_prod(int,int),bool,aa(fun(int,fun(int,bool)),fun(product_prod(int,int),bool),product_case_prod(int,int,bool),aa(int,fun(int,fun(int,bool)),aTP_Lamp_aap(int,fun(int,fun(int,fun(int,bool))),Uua),Uub)),quotient_of(Uu))) ) ).

% ATP.lambda_598
tff(fact_6764_ATP_Olambda__599,axiom,
    ! [Uu: rat,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_aao(rat,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> pp(aa(product_prod(int,int),bool,aa(fun(int,fun(int,bool)),fun(product_prod(int,int),bool),product_case_prod(int,int,bool),aa(int,fun(int,fun(int,bool)),aTP_Lamp_aan(int,fun(int,fun(int,fun(int,bool))),Uua),Uub)),quotient_of(Uu))) ) ).

% ATP.lambda_599
tff(fact_6765_ATP_Olambda__600,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(B),Uub: C] : ( aa(C,A,aa(set(B),fun(C,A),aTP_Lamp_oo(fun(B,fun(C,A)),fun(set(B),fun(C,A)),Uu),Uua),Uub) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(C,fun(B,A),aTP_Lamp_on(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_600
tff(fact_6766_ATP_Olambda__601,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(B),Uub: C] : ( aa(C,A,aa(set(B),fun(C,A),aTP_Lamp_ol(fun(B,fun(C,A)),fun(set(B),fun(C,A)),Uu),Uua),Uub) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(C,fun(B,A),aTP_Lamp_ok(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_601
tff(fact_6767_ATP_Olambda__602,axiom,
    ! [D: $tType,E: $tType,A: $tType,C: $tType,B: $tType,Uu: fun(B,fun(C,fun(D,fun(E,set(A))))),Uua: product_prod(B,C),Uub: product_prod(D,E)] : ( aa(product_prod(D,E),set(A),aa(product_prod(B,C),fun(product_prod(D,E),set(A)),aTP_Lamp_hp(fun(B,fun(C,fun(D,fun(E,set(A))))),fun(product_prod(B,C),fun(product_prod(D,E),set(A))),Uu),Uua),Uub) = aa(product_prod(B,C),set(A),aa(fun(B,fun(C,set(A))),fun(product_prod(B,C),set(A)),product_case_prod(B,C,set(A)),aa(product_prod(D,E),fun(B,fun(C,set(A))),aTP_Lamp_ho(fun(B,fun(C,fun(D,fun(E,set(A))))),fun(product_prod(D,E),fun(B,fun(C,set(A)))),Uu),Uub)),Uua) ) ).

% ATP.lambda_602
tff(fact_6768_ATP_Olambda__603,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: filter(A),Uub: fun(B,bool)] :
      ( pp(aa(fun(B,bool),bool,aa(filter(A),fun(fun(B,bool),bool),aTP_Lamp_aff(fun(A,B),fun(filter(A),fun(fun(B,bool),bool)),Uu),Uua),Uub))
    <=> eventually(A,aa(fun(B,bool),fun(A,bool),aTP_Lamp_bl(fun(A,B),fun(fun(B,bool),fun(A,bool)),Uu),Uub),Uua) ) ).

% ATP.lambda_603
tff(fact_6769_ATP_Olambda__604,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A),Uua: nat,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(nat,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avy(array(A),fun(nat,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),aa(nat,A,nth(A,array_get(A,Uub,Uu)),Uua)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),one_one(nat))) ) ) ).

% ATP.lambda_604
tff(fact_6770_ATP_Olambda__605,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_rp(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uub))),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_605
tff(fact_6771_ATP_Olambda__606,axiom,
    ! [A: $tType,Uu: fun(set(A),set(A)),Uua: set(A),Uub: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),aTP_Lamp_nl(fun(set(A),set(A)),fun(set(A),fun(set(A),set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),Uu,Uub)),Uua)),complete_lattice_gfp(set(A),Uu)) ) ).

% ATP.lambda_606
tff(fact_6772_ATP_Olambda__607,axiom,
    ! [A: $tType,Uu: set(A),Uua: fun(set(A),set(A)),Uub: set(A)] : ( aa(set(A),set(A),aa(fun(set(A),set(A)),fun(set(A),set(A)),aTP_Lamp_nj(set(A),fun(fun(set(A),set(A)),fun(set(A),set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),Uua,Uub)),Uu)),complete_lattice_gfp(set(A),Uua)) ) ).

% ATP.lambda_607
tff(fact_6773_ATP_Olambda__608,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( pp(aa(list(nat),bool,aa(nat,fun(list(nat),bool),aTP_Lamp_akj(nat,fun(nat,fun(list(nat),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),one_one(nat)) )
        & ( aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_608
tff(fact_6774_ATP_Olambda__609,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Uu: fun(A,fun(C,bool)),Uua: fun(B,fun(D,bool)),Uub: product_prod(product_prod(A,C),product_prod(B,D))] :
      ( pp(aa(product_prod(product_prod(A,C),product_prod(B,D)),bool,aa(fun(B,fun(D,bool)),fun(product_prod(product_prod(A,C),product_prod(B,D)),bool),aTP_Lamp_aos(fun(A,fun(C,bool)),fun(fun(B,fun(D,bool)),fun(product_prod(product_prod(A,C),product_prod(B,D)),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(product_prod(A,C)),bool,aa(set(product_prod(A,C)),fun(set(product_prod(A,C)),bool),ord_less_eq(set(product_prod(A,C))),aa(product_prod(product_prod(A,C),product_prod(B,D)),set(product_prod(A,C)),basic_fsts(product_prod(A,C),product_prod(B,D)),Uub)),aa(fun(product_prod(A,C),bool),set(product_prod(A,C)),collect(product_prod(A,C)),aa(fun(A,fun(C,bool)),fun(product_prod(A,C),bool),product_case_prod(A,C,bool),Uu))))
        & pp(aa(set(product_prod(B,D)),bool,aa(set(product_prod(B,D)),fun(set(product_prod(B,D)),bool),ord_less_eq(set(product_prod(B,D))),basic_snds(product_prod(A,C),product_prod(B,D),Uub)),aa(fun(product_prod(B,D),bool),set(product_prod(B,D)),collect(product_prod(B,D)),aa(fun(B,fun(D,bool)),fun(product_prod(B,D),bool),product_case_prod(B,D,bool),Uua)))) ) ) ).

% ATP.lambda_609
tff(fact_6775_ATP_Olambda__610,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_ank(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(list(A),nat,size_size(list(A)),Uua)),aa(list(A),nat,size_size(list(A)),Uub)))
        | ( ( aa(list(A),nat,size_size(list(A)),Uua) = aa(list(A),nat,size_size(list(A)),Uub) )
          & pp(aa(set(product_prod(list(A),list(A))),bool,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Uua),Uub)),lex(A,Uu))) ) ) ) ).

% ATP.lambda_610
tff(fact_6776_ATP_Olambda__611,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_anr(nat,fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uua) = aa(nat,nat,suc,Uu) )
        & ( aa(list(A),nat,size_size(list(A)),Uub) = aa(nat,nat,suc,Uu) ) ) ) ).

% ATP.lambda_611
tff(fact_6777_ATP_Olambda__612,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_anh(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uua) = aa(list(A),nat,size_size(list(A)),Uub) )
        & ? [Xys2: list(A),X3: A,Y4: A,Xs4: list(A),Ys4: list(A)] :
            ( ( Uua = append(A,Xys2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X3),Xs4)) )
            & ( Uub = append(A,Xys2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y4),Ys4)) )
            & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Y4)),Uu)) ) ) ) ).

% ATP.lambda_612
tff(fact_6778_ATP_Olambda__613,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( pp(aa(list(nat),bool,aa(nat,fun(list(nat),bool),aTP_Lamp_akk(nat,fun(nat,fun(list(nat),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub)),one_one(nat)) = Uua ) ) ) ).

% ATP.lambda_613
tff(fact_6779_ATP_Olambda__614,axiom,
    ! [A: $tType,Uu: nat,Uua: set(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(set(A),fun(list(A),bool),aTP_Lamp_aib(nat,fun(set(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uu )
        & distinct(A,Uub)
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uua)) ) ) ).

% ATP.lambda_614
tff(fact_6780_ATP_Olambda__615,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(nat,fun(list(A),bool),aTP_Lamp_aia(set(A),fun(nat,fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uua )
        & distinct(A,Uub)
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu)) ) ) ).

% ATP.lambda_615
tff(fact_6781_ATP_Olambda__616,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(nat,fun(list(A),bool),aTP_Lamp_aiu(set(A),fun(nat,fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu))
        & ( aa(list(A),nat,size_size(list(A)),Uub) = aa(nat,nat,suc,Uua) ) ) ) ).

% ATP.lambda_616
tff(fact_6782_ATP_Olambda__617,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_aij(nat,fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uu )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),aa(list(A),set(A),set2(A),Uua))) ) ) ).

% ATP.lambda_617
tff(fact_6783_ATP_Olambda__618,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: set(B),Uub: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(set(B),fun(product_prod(A,B),bool),aTP_Lamp_arf(set(A),fun(set(B),fun(product_prod(A,B),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(product_prod(A,B),set(A),basic_fsts(A,B),Uub)),Uu))
        & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),basic_snds(A,B,Uub)),Uua)) ) ) ).

% ATP.lambda_618
tff(fact_6784_ATP_Olambda__619,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(nat,fun(list(A),bool),aTP_Lamp_ahx(set(A),fun(nat,fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Uub)),Uua)) ) ) ).

% ATP.lambda_619
tff(fact_6785_ATP_Olambda__620,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(nat,fun(list(A),bool),aTP_Lamp_ahz(set(A),fun(nat,fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu))
        & ( aa(list(A),nat,size_size(list(A)),Uub) = Uua ) ) ) ).

% ATP.lambda_620
tff(fact_6786_ATP_Olambda__621,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( pp(aa(list(nat),bool,aa(nat,fun(list(nat),bool),aTP_Lamp_aki(nat,fun(nat,fun(list(nat),bool)),Uu),Uua),Uub))
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_621
tff(fact_6787_ATP_Olambda__622,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: set(B),Uub: fun(A,option(B))] :
      ( pp(aa(fun(A,option(B)),bool,aa(set(B),fun(fun(A,option(B)),bool),aTP_Lamp_acy(set(A),fun(set(B),fun(fun(A,option(B)),bool)),Uu),Uua),Uub))
    <=> ( ( dom(A,B,Uub) = Uu )
        & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),ran(A,B,Uub)),Uua)) ) ) ).

% ATP.lambda_622
tff(fact_6788_ATP_Olambda__623,axiom,
    ! [Uu: heap_ext(product_unit),Uua: heap_ext(product_unit),Uub: nat] :
      ( pp(aa(nat,bool,aa(heap_ext(product_unit),fun(nat,bool),aTP_Lamp_avl(heap_ext(product_unit),fun(heap_ext(product_unit),fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),lim(product_unit,Uu)),Uub))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),lim(product_unit,Uua))) ) ) ).

% ATP.lambda_623
tff(fact_6789_ATP_Olambda__624,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_to(set(nat),fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(nat),bool,member(nat,aa(nat,nat,suc,Uub)),Uu))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),Uua)) ) ) ).

% ATP.lambda_624
tff(fact_6790_ATP_Olambda__625,axiom,
    ! [A: $tType,Uu: set(nat),Uua: nat,Uub: product_prod(A,nat)] :
      ( pp(aa(product_prod(A,nat),bool,aa(nat,fun(product_prod(A,nat),bool),aTP_Lamp_alq(set(nat),fun(nat,fun(product_prod(A,nat),bool)),Uu),Uua),Uub))
    <=> pp(aa(set(nat),bool,member(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(product_prod(A,nat),nat,product_snd(A,nat),Uub)),Uua)),Uu)) ) ).

% ATP.lambda_625
tff(fact_6791_ATP_Olambda__626,axiom,
    ! [A: $tType,Uu: set(list(A)),Uua: list(A),Uub: A] :
      ( pp(aa(A,bool,aa(list(A),fun(A,bool),aTP_Lamp_anp(set(list(A)),fun(list(A),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(list(A)),bool,member(list(A),append(A,Uua,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uub),nil(A)))),Uu)) ) ).

% ATP.lambda_626
tff(fact_6792_ATP_Olambda__627,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: fun(A,A),Uua: ref(A),Uub: A] : ( aa(A,heap_Time_Heap(A),aa(ref(A),fun(A,heap_Time_Heap(A)),aTP_Lamp_axo(fun(A,A),fun(ref(A),fun(A,heap_Time_Heap(A))),Uu),Uua),Uub) = heap_Time_bind(product_unit,A,ref_update(A,Uua,aa(A,A,Uu,Uub)),aa(A,fun(product_unit,heap_Time_Heap(A)),aTP_Lamp_axn(fun(A,A),fun(A,fun(product_unit,heap_Time_Heap(A))),Uu),Uub)) ) ) ).

% ATP.lambda_627
tff(fact_6793_ATP_Olambda__628,axiom,
    ! [Uu: nat,Uua: nat,Uub: set(nat)] :
      ( pp(aa(set(nat),bool,aa(nat,fun(set(nat),bool),aTP_Lamp_we(nat,fun(nat,fun(set(nat),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(set(nat)),bool,member(set(nat),Uub),pow(nat,set_or7035219750837199246ssThan(nat,zero_zero(nat),Uu))))
        & ( aa(set(nat),nat,finite_card(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_628
tff(fact_6794_ATP_Olambda__629,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: nat] :
      ( pp(aa(nat,bool,aa(set(nat),fun(nat,bool),aTP_Lamp_akl(list(A),fun(set(nat),fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),aa(list(A),nat,size_size(list(A)),Uu)))
        & pp(aa(set(nat),bool,member(nat,Uub),Uua)) ) ) ).

% ATP.lambda_629
tff(fact_6795_ATP_Olambda__630,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: list(A),Uub: nat] :
      ( pp(aa(nat,bool,aa(list(A),fun(nat,bool),aTP_Lamp_ajj(fun(A,bool),fun(list(A),fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),aa(list(A),nat,size_size(list(A)),Uua)))
        & pp(aa(A,bool,Uu,aa(nat,A,nth(A,Uua),Uub))) ) ) ).

% ATP.lambda_630
tff(fact_6796_ATP_Olambda__631,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: multiset(A),Uub: A] :
      ( pp(aa(A,bool,aa(multiset(A),fun(A,bool),aTP_Lamp_aqk(fun(A,bool),fun(multiset(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),aa(multiset(A),set(A),set_mset(A),Uua)))
        & pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_631
tff(fact_6797_ATP_Olambda__632,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: list(A),Uua: fun(A,bool),Uub: A] :
          ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_alu(list(A),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(A),bool,member(A,Uub),aa(list(A),set(A),set2(A),Uu)))
            & pp(aa(A,bool,Uua,Uub)) ) ) ) ).

% ATP.lambda_632
tff(fact_6798_ATP_Olambda__633,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: list(A),Uub: A] :
      ( pp(aa(A,bool,aa(list(A),fun(A,bool),aTP_Lamp_ain(fun(A,bool),fun(list(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),aa(list(A),set(A),set2(A),Uua)))
        & pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_633
tff(fact_6799_ATP_Olambda__634,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B)),Uua: A,Uub: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(A,fun(product_prod(A,B),bool),aTP_Lamp_adb(fun(A,option(B)),fun(A,fun(product_prod(A,B),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),Uub),graph(A,B,Uu)))
        & ( aa(product_prod(A,B),A,product_fst(A,B),Uub) != Uua ) ) ) ).

% ATP.lambda_634
tff(fact_6800_ATP_Olambda__635,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_wb(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uub))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_635
tff(fact_6801_ATP_Olambda__636,axiom,
    ! [Uu: heap_ext(product_unit),Uua: set(nat),Uub: nat] :
      ( pp(aa(nat,bool,aa(set(nat),fun(nat,bool),aTP_Lamp_avm(heap_ext(product_unit),fun(set(nat),fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),lim(product_unit,Uu)))
        & ~ pp(aa(set(nat),bool,member(nat,Uub),Uua)) ) ) ).

% ATP.lambda_636
tff(fact_6802_ATP_Olambda__637,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_ael(set(product_prod(A,A)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),field2(A,Uu)))
        & ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),Uua))
           => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),X3)),Uu)) ) ) ) ).

% ATP.lambda_637
tff(fact_6803_ATP_Olambda__638,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_aen(set(product_prod(A,A)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),field2(A,Uu)))
        & ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),Uua))
           => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Uub)),Uu)) ) ) ) ).

% ATP.lambda_638
tff(fact_6804_ATP_Olambda__639,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_aem(set(product_prod(A,A)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),field2(A,Uu)))
        & ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),Uua))
           => ( ( Uub != X3 )
              & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),X3)),Uu)) ) ) ) ) ).

% ATP.lambda_639
tff(fact_6805_ATP_Olambda__640,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_aes(set(product_prod(A,A)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),field2(A,Uu)))
        & ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),Uua))
           => ( ( Uub != X3 )
              & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Uub)),Uu)) ) ) ) ) ).

% ATP.lambda_640
tff(fact_6806_ATP_Olambda__641,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: nat] :
      ( pp(aa(nat,bool,aa(set(nat),fun(nat,bool),aTP_Lamp_anb(list(A),fun(set(nat),fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(nat),bool,member(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),aa(list(A),nat,size_size(list(A)),Uu))),Uua)) ) ).

% ATP.lambda_641
tff(fact_6807_ATP_Olambda__642,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_tr(nat,fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uua),Uu))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),Uu))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uua),Uub)) ) ) ).

% ATP.lambda_642
tff(fact_6808_ATP_Olambda__643,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [Uu: set(A),Uua: nat,Uub: A] :
          ( pp(aa(A,bool,aa(nat,fun(A,bool),aTP_Lamp_xp(set(A),fun(nat,fun(A,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(A),bool,member(A,Uub),Uu))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),infini527867602293511546merate(A,Uu,Uua)),Uub)) ) ) ) ).

% ATP.lambda_643
tff(fact_6809_ATP_Olambda__644,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_adc(set(A),fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(A),bool,member(A,Uub),Uu))
            & ( aa(A,B,Uua,Uub) = aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(A),set(B),image2(A,B,Uua),Uu)) ) ) ) ) ).

% ATP.lambda_644
tff(fact_6810_ATP_Olambda__645,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aTP_Lamp_afr(set(product_prod(A,A)),fun(set(A),fun(set(A),bool)),Uu),Uua),Uub))
    <=> ( order_ofilter(A,Uu,Uua)
        & ( Uua != field2(A,Uu) )
        & order_ofilter(A,Uu,Uub)
        & ( Uub != field2(A,Uu) )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),Uua),Uub)) ) ) ).

% ATP.lambda_645
tff(fact_6811_ATP_Olambda__646,axiom,
    ! [Uu: set(nat),Uua: set(nat),Uub: nat] :
      ( pp(aa(nat,bool,aa(set(nat),fun(nat,bool),aTP_Lamp_akg(set(nat),fun(set(nat),fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(nat),bool,member(nat,Uub),Uu))
        & pp(aa(set(nat),bool,member(nat,aa(set(nat),nat,finite_card(nat),aa(fun(nat,bool),set(nat),collect(nat),aa(nat,fun(nat,bool),aTP_Lamp_akf(set(nat),fun(nat,fun(nat,bool)),Uu),Uub)))),Uua)) ) ) ).

% ATP.lambda_646
tff(fact_6812_ATP_Olambda__647,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(nat,fun(set(A),bool),aTP_Lamp_un(set(A),fun(nat,fun(set(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Uub),Uu))
        & ( aa(set(A),nat,finite_card(A),Uub) = Uua ) ) ) ).

% ATP.lambda_647
tff(fact_6813_ATP_Olambda__648,axiom,
    ! [A: $tType,B: $tType,Uu: nat,Uua: set(old_node(A,B)),Uub: old_node(A,B)] :
      ( pp(aa(old_node(A,B),bool,aa(set(old_node(A,B)),fun(old_node(A,B),bool),aTP_Lamp_ayz(nat,fun(set(old_node(A,B)),fun(old_node(A,B),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(old_node(A,B)),bool,member(old_node(A,B),Uub),Uua))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),old_ndepth(A,B,Uub)),Uu)) ) ) ).

% ATP.lambda_648
tff(fact_6814_ATP_Olambda__649,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_tp(set(nat),fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(nat),bool,member(nat,Uub),Uu))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_649
tff(fact_6815_ATP_Olambda__650,axiom,
    ! [A: $tType,Uu: multiset(A),Uua: multiset(A),Uub: A] :
      ( pp(aa(A,bool,aa(multiset(A),fun(A,bool),aTP_Lamp_apc(multiset(A),fun(multiset(A),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,aa(multiset(A),fun(A,nat),count(A),Uua),Uub)),aa(A,nat,aa(multiset(A),fun(A,nat),count(A),Uu),Uub))) ) ).

% ATP.lambda_650
tff(fact_6816_ATP_Olambda__651,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(A,A)),Uub: fun(B,A)] : ( aa(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))),aTP_Lamp_auq(set(product_prod(A,A)),fun(set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))))),Uu),Uua),Uub) = aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),inv_image(A,B,Uu,Uub)),inv_image(A,B,Uua,Uub)) ) ).

% ATP.lambda_651
tff(fact_6817_ATP_Olambda__652,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_uk(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub)) ) ).

% ATP.lambda_652
tff(fact_6818_ATP_Olambda__653,axiom,
    ! [Uu: assn,Uua: assn,Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_ba(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Uu),Uub))
        | pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Uua),Uub)) ) ) ).

% ATP.lambda_653
tff(fact_6819_ATP_Olambda__654,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_av(set(A),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),Uu))
        | pp(aa(set(A),bool,member(A,Uub),Uua)) ) ) ).

% ATP.lambda_654
tff(fact_6820_ATP_Olambda__655,axiom,
    ! [A: $tType,Uu: A,Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_de(A,fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uub = Uu )
        | pp(aa(set(A),bool,member(A,Uub),Uua)) ) ) ).

% ATP.lambda_655
tff(fact_6821_ATP_Olambda__656,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_vv(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uu),Uua))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uua),Uub)) ) ) ).

% ATP.lambda_656
tff(fact_6822_ATP_Olambda__657,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_ti(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uu),Uub))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uub),Uua)) ) ) ).

% ATP.lambda_657
tff(fact_6823_ATP_Olambda__658,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_vw(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uu),Uub))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uua),Uub)) ) ) ).

% ATP.lambda_658
tff(fact_6824_ATP_Olambda__659,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_ud(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uu),Uub))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uub),Uua)) ) ) ).

% ATP.lambda_659
tff(fact_6825_ATP_Olambda__660,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_ue(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uu),Uub))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Uub),Uua)) ) ) ).

% ATP.lambda_660
tff(fact_6826_ATP_Olambda__661,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_uc(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uu),Uub))
        & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Uub),Uua)) ) ) ).

% ATP.lambda_661
tff(fact_6827_ATP_Olambda__662,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aTP_Lamp_uj(set(A),fun(set(A),fun(set(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),Uua),Uub))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Uub),Uu)) ) ) ).

% ATP.lambda_662
tff(fact_6828_ATP_Olambda__663,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aTP_Lamp_ui(set(A),fun(set(A),fun(set(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),Uub),Uua))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Uua),Uu)) ) ) ).

% ATP.lambda_663
tff(fact_6829_ATP_Olambda__664,axiom,
    ! [Uu: assn,Uua: assn,Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_ah(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Uu),Uub))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Uua),Uub)) ) ) ).

% ATP.lambda_664
tff(fact_6830_ATP_Olambda__665,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_abo(nat,fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),Uub),Uua))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),dvd_dvd(nat),Uub),Uu)) ) ) ).

% ATP.lambda_665
tff(fact_6831_ATP_Olambda__666,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aTP_Lamp_abf(int,fun(int,fun(int,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),Uub),Uua))
        & pp(aa(int,bool,aa(int,fun(int,bool),dvd_dvd(int),Uub),Uu)) ) ) ).

% ATP.lambda_666
tff(fact_6832_ATP_Olambda__667,axiom,
    ! [A: $tType,Uu: filter(A),Uua: filter(A),Uub: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aa(filter(A),fun(fun(A,bool),bool),aTP_Lamp_aey(filter(A),fun(filter(A),fun(fun(A,bool),bool)),Uu),Uua),Uub))
    <=> ( eventually(A,Uub,Uu)
        & eventually(A,Uub,Uua) ) ) ).

% ATP.lambda_667
tff(fact_6833_ATP_Olambda__668,axiom,
    ! [A: $tType,Uu: set(A),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ady(set(A),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uua),Uu))
        & pp(aa(set(A),bool,member(A,Uub),Uu)) ) ) ).

% ATP.lambda_668
tff(fact_6834_ATP_Olambda__669,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_akf(set(nat),fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(nat),bool,member(nat,Uub),Uu))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),Uua)) ) ) ).

% ATP.lambda_669
tff(fact_6835_ATP_Olambda__670,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: A,Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(A,fun(set(A),bool),aTP_Lamp_sc(set(set(A)),fun(A,fun(set(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(set(A)),bool,member(set(A),Uub),Uu))
        & pp(aa(set(A),bool,member(A,Uua),Uub)) ) ) ).

% ATP.lambda_670
tff(fact_6836_ATP_Olambda__671,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_ar(set(A),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),Uu))
        & pp(aa(set(A),bool,member(A,Uub),Uua)) ) ) ).

% ATP.lambda_671
tff(fact_6837_ATP_Olambda__672,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_bbf(A,fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uua = Uu )
        & ( Uub = Uu ) ) ) ).

% ATP.lambda_672
tff(fact_6838_ATP_Olambda__673,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aTP_Lamp_ks(set(A),fun(set(A),fun(set(A),bool)),Uu),Uua),Uub))
    <=> ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uub),Uu) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uua),Uu) ) ) ).

% ATP.lambda_673
tff(fact_6839_ATP_Olambda__674,axiom,
    ! [A: $tType,Uu: list(A),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_alc(list(A),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),count_list(A,Uu,Uub)),aa(A,nat,Uua,Uub)) ) ).

% ATP.lambda_674
tff(fact_6840_ATP_Olambda__675,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: list(A),Uub: A] : ( aa(A,nat,aa(list(A),fun(A,nat),aTP_Lamp_ald(fun(A,nat),fun(list(A),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),count_list(A,Uua,Uub)),aa(A,nat,Uu,Uub)) ) ).

% ATP.lambda_675
tff(fact_6841_ATP_Olambda__676,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_nw(fun(A,bool),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),Uua))
       => pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_676
tff(fact_6842_ATP_Olambda__677,axiom,
    ! [A: $tType,Uu: A,Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_ahq(A,fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uu = Uub )
       => pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_677
tff(fact_6843_ATP_Olambda__678,axiom,
    ! [A: $tType,Uu: A,Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_ahr(A,fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uub = Uu )
       => pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_678
tff(fact_6844_ATP_Olambda__679,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,B)),Uua: multiset(A),Uub: A] : ( aa(A,fun(B,B),aa(multiset(A),fun(A,fun(B,B)),aTP_Lamp_apj(fun(A,fun(B,B)),fun(multiset(A),fun(A,fun(B,B))),Uu),Uua),Uub) = compow(fun(B,B),aa(A,nat,aa(multiset(A),fun(A,nat),count(A),Uua),Uub),aa(A,fun(B,B),Uu,Uub)) ) ).

% ATP.lambda_679
tff(fact_6845_ATP_Olambda__680,axiom,
    ! [B: $tType,Uu: set(B),Uua: fun(B,bool),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,bool),fun(B,bool),aTP_Lamp_pf(set(B),fun(fun(B,bool),fun(B,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(B),bool,member(B,Uub),Uu))
        & pp(aa(B,bool,Uua,Uub)) ) ) ).

% ATP.lambda_680
tff(fact_6846_ATP_Olambda__681,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: set(A),Uua: fun(A,bool),Uub: A] :
          ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_xv(set(A),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(A),bool,member(A,Uub),Uu))
            & pp(aa(A,bool,Uua,Uub)) ) ) ) ).

% ATP.lambda_681
tff(fact_6847_ATP_Olambda__682,axiom,
    ! [A: $tType,Uu: set(A),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_dh(set(A),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),Uu))
        & pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_682
tff(fact_6848_ATP_Olambda__683,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_mb(fun(A,bool),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),Uua))
        & pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_683
tff(fact_6849_ATP_Olambda__684,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_dx(fun(A,bool),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uua = Uub )
        & pp(aa(A,bool,Uu,Uua)) ) ) ).

% ATP.lambda_684
tff(fact_6850_ATP_Olambda__685,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_dt(fun(A,bool),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uua = Uub )
        & pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_685
tff(fact_6851_ATP_Olambda__686,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ds(fun(A,bool),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uub = Uua )
        & pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_686
tff(fact_6852_ATP_Olambda__687,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,set(B)),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,set(B)),fun(A,bool),aTP_Lamp_eb(set(A),fun(fun(A,set(B)),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),Uu))
        & ( aa(A,set(B),Uua,Uub) != bot_bot(set(B)) ) ) ) ).

% ATP.lambda_687
tff(fact_6853_ATP_Olambda__688,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_lk(set(B),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(B),bool,member(B,Uub),Uu))
            & ( aa(B,A,Uua,Uub) != zero_zero(A) ) ) ) ) ).

% ATP.lambda_688
tff(fact_6854_ATP_Olambda__689,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_lz(set(A),fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(A),bool,member(A,Uub),Uu))
            & ( aa(A,B,Uua,Uub) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_689
tff(fact_6855_ATP_Olambda__690,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_li(set(B),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(B),bool,member(B,Uub),Uu))
            & ( aa(B,A,Uua,Uub) != one_one(A) ) ) ) ) ).

% ATP.lambda_690
tff(fact_6856_ATP_Olambda__691,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] :
          ( pp(aa(B,bool,aa(set(B),fun(B,bool),aTP_Lamp_mc(fun(B,A),fun(set(B),fun(B,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(B),bool,member(B,Uub),Uua))
            & ( aa(B,A,Uu,Uub) != zero_zero(A) ) ) ) ) ).

% ATP.lambda_691
tff(fact_6857_ATP_Olambda__692,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] :
          ( pp(aa(B,bool,aa(set(B),fun(B,bool),aTP_Lamp_mp(fun(B,A),fun(set(B),fun(B,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(B),bool,member(B,Uub),Uua))
            & ( aa(B,A,Uu,Uub) != one_one(A) ) ) ) ) ).

% ATP.lambda_692
tff(fact_6858_ATP_Olambda__693,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_parity(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_yy(set(B),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(B),bool,member(B,Uub),Uu))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(B,A,Uua,Uub))) ) ) ) ).

% ATP.lambda_693
tff(fact_6859_ATP_Olambda__694,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_cf(set(A),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,member(A,Uub),Uu))
        & ~ pp(aa(set(A),bool,member(A,Uub),Uua)) ) ) ).

% ATP.lambda_694
tff(fact_6860_ATP_Olambda__695,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: multiset(A),Uub: A] : ( aa(A,nat,aa(multiset(A),fun(A,nat),aTP_Lamp_aph(fun(A,nat),fun(multiset(A),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,aa(multiset(A),fun(A,nat),count(A),Uua),Uub)),aa(nat,nat,suc,aa(A,nat,Uu,Uub))) ) ).

% ATP.lambda_695
tff(fact_6861_ATP_Olambda__696,axiom,
    ! [A: $tType,D: $tType,C: $tType,Uu: fun(C,fun(D,bool)),Uua: fun(C,A),Uub: set(A)] : ( aa(set(A),set(C),aa(fun(C,A),fun(set(A),set(C)),aTP_Lamp_arl(fun(C,fun(D,bool)),fun(fun(C,A),fun(set(A),set(C))),Uu),Uua),Uub) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(A),set(C),aa(fun(C,A),fun(set(A),set(C)),vimage(C,A),Uua),Uub)),aa(fun(C,bool),set(C),collect(C),aa(fun(C,fun(D,bool)),fun(C,bool),domainp(C,D),Uu))) ) ).

% ATP.lambda_696
tff(fact_6862_ATP_Olambda__697,axiom,
    ! [A: $tType,B: $tType,Uu: list(product_prod(A,B)),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_ame(list(product_prod(A,B)),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> ( aa(A,option(B),map_of(A,B,Uu),Uua) = aa(B,option(B),some(B),Uub) ) ) ).

% ATP.lambda_697
tff(fact_6863_ATP_Olambda__698,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_zz(nat,fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uu)),Uua)) ) ).

% ATP.lambda_698
tff(fact_6864_ATP_Olambda__699,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_rd(nat,fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu)) ) ).

% ATP.lambda_699
tff(fact_6865_ATP_Olambda__700,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_ut(nat,fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu)) ) ).

% ATP.lambda_700
tff(fact_6866_ATP_Olambda__701,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_rt(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uub),Uu)),Uua) ) ) ).

% ATP.lambda_701
tff(fact_6867_ATP_Olambda__702,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_sn(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_702
tff(fact_6868_ATP_Olambda__703,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_so(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uub),Uu)),Uua) ) ) ).

% ATP.lambda_703
tff(fact_6869_ATP_Olambda__704,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_sm(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_704
tff(fact_6870_ATP_Olambda__705,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: B,Uub: C] :
      ( pp(aa(C,bool,aa(B,fun(C,bool),aTP_Lamp_ara(set(product_prod(B,C)),fun(B,fun(C,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(product_prod(B,C)),bool,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uub)),Uu)) ) ).

% ATP.lambda_705
tff(fact_6871_ATP_Olambda__706,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,A)),Uua: B,Uub: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_jt(set(product_prod(B,A)),fun(B,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(product_prod(B,A)),bool,member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uua),Uub)),Uu)) ) ).

% ATP.lambda_706
tff(fact_6872_ATP_Olambda__707,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_ap(set(product_prod(A,B)),fun(A,fun(B,bool))),Uu),Uua),Uub))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uub)),Uu)) ) ).

% ATP.lambda_707
tff(fact_6873_ATP_Olambda__708,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_iy(set(product_prod(A,A)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uub)),Uu)) ) ).

% ATP.lambda_708
tff(fact_6874_ATP_Olambda__709,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,A)),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_ms(set(product_prod(B,A)),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(product_prod(B,A)),bool,member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uub),Uua)),Uu)) ) ).

% ATP.lambda_709
tff(fact_6875_ATP_Olambda__710,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_na(set(product_prod(A,A)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uua)),Uu)) ) ).

% ATP.lambda_710
tff(fact_6876_ATP_Olambda__711,axiom,
    ! [A: $tType,Uu: set(list(A)),Uua: A,Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(A,fun(list(A),bool),aTP_Lamp_auh(set(list(A)),fun(A,fun(list(A),bool)),Uu),Uua),Uub))
    <=> pp(aa(set(list(A)),bool,member(list(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uua),Uub)),Uu)) ) ).

% ATP.lambda_711
tff(fact_6877_ATP_Olambda__712,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_als(list(list(A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),Uu),Uub)),Uua) ) ).

% ATP.lambda_712
tff(fact_6878_ATP_Olambda__713,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Uu: A,Uua: A,Uub: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ye(A,fun(A,fun(A,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(set(A),bool,member(A,Uub),ring_1_Ints(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uu),Uub))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uub),Uua)) ) ) ) ).

% ATP.lambda_713
tff(fact_6879_ATP_Olambda__714,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: list(B),Uub: B] :
          ( pp(aa(B,bool,aa(list(B),fun(B,bool),aTP_Lamp_amy(fun(B,A),fun(list(B),fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,Uu,aa(nat,B,nth(B,Uua),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(B),nat,size_size(list(B)),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_714
tff(fact_6880_ATP_Olambda__715,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(B,A),Uub: A] :
      ( pp(aa(A,bool,aa(fun(B,A),fun(A,bool),aTP_Lamp_po(fun(A,B),fun(fun(B,A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( aa(B,A,Uua,aa(A,B,Uu,Uub)) = Uub ) ) ).

% ATP.lambda_715
tff(fact_6881_ATP_Olambda__716,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,bool),Uua: fun(B,bool),Uub: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(fun(B,bool),fun(product_prod(A,B),bool),aTP_Lamp_qt(fun(A,bool),fun(fun(B,bool),fun(product_prod(A,B),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uu,aa(product_prod(A,B),A,product_fst(A,B),Uub)))
        & pp(aa(B,bool,Uua,aa(product_prod(A,B),B,product_snd(A,B),Uub))) ) ) ).

% ATP.lambda_716
tff(fact_6882_ATP_Olambda__717,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,Uu: fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C)),Uua: fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),Uub: fun(A,heap_Time_Heap(B))] : ( aa(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D),aa(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D)),aTP_Lamp_baw(fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C)),fun(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),Uu),Uua),Uub) = heap_Time_bind(C,D,aa(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C),Uu,Uub),aa(fun(A,heap_Time_Heap(B)),fun(C,heap_Time_Heap(D)),aTP_Lamp_bav(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),fun(C,heap_Time_Heap(D))),Uua),Uub)) ) ).

% ATP.lambda_717
tff(fact_6883_ATP_Olambda__718,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,Uu: fun(fun(A,option(B)),option(C)),Uua: fun(C,fun(fun(A,option(B)),option(D))),Uub: fun(A,option(B))] : ( aa(fun(A,option(B)),option(D),aa(fun(C,fun(fun(A,option(B)),option(D))),fun(fun(A,option(B)),option(D)),aTP_Lamp_bao(fun(fun(A,option(B)),option(C)),fun(fun(C,fun(fun(A,option(B)),option(D))),fun(fun(A,option(B)),option(D))),Uu),Uua),Uub) = bind2(C,D,aa(fun(A,option(B)),option(C),Uu,Uub),aa(fun(A,option(B)),fun(C,option(D)),aTP_Lamp_ban(fun(C,fun(fun(A,option(B)),option(D))),fun(fun(A,option(B)),fun(C,option(D))),Uua),Uub)) ) ).

% ATP.lambda_718
tff(fact_6884_ATP_Olambda__719,axiom,
    ! [Uu: fun(nat,bool),Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_tl(fun(nat,bool),fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,Uu,Uub))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),Uua)) ) ) ).

% ATP.lambda_719
tff(fact_6885_ATP_Olambda__720,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_arh(fun(A,fun(B,bool)),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uua,Uub))
        & pp(aa(A,bool,aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),Uu),Uub)) ) ) ).

% ATP.lambda_720
tff(fact_6886_ATP_Olambda__721,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: list(B),Uub: B] :
          ( pp(aa(B,bool,aa(list(B),fun(B,bool),aTP_Lamp_amw(fun(B,A),fun(list(B),fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,Uu,Uub)),aa(B,A,Uu,aa(nat,B,nth(B,Uua),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(B),nat,size_size(list(B)),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))) ) ) ).

% ATP.lambda_721
tff(fact_6887_ATP_Olambda__722,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: list(B),Uub: B] :
          ( pp(aa(B,bool,aa(list(B),fun(B,bool),aTP_Lamp_amx(fun(B,A),fun(list(B),fun(B,bool)),Uu),Uua),Uub))
        <=> ( aa(B,A,Uu,Uub) = aa(B,A,Uu,aa(nat,B,nth(B,Uua),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(B),nat,size_size(list(B)),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ).

% ATP.lambda_722
tff(fact_6888_ATP_Olambda__723,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,set(C)),Uua: fun(B,fun(C,A)),Uub: B] : ( aa(B,A,aa(fun(B,fun(C,A)),fun(B,A),aTP_Lamp_pd(fun(B,set(C)),fun(fun(B,fun(C,A)),fun(B,A)),Uu),Uua),Uub) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),aa(B,fun(C,A),Uua,Uub)),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_723
tff(fact_6889_ATP_Olambda__724,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,set(C)),Uua: fun(B,fun(C,A)),Uub: B] : ( aa(B,A,aa(fun(B,fun(C,A)),fun(B,A),aTP_Lamp_pe(fun(B,set(C)),fun(fun(B,fun(C,A)),fun(B,A)),Uu),Uua),Uub) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(B,fun(C,A),Uua,Uub)),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_724
tff(fact_6890_ATP_Olambda__725,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: B,Uub: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),aTP_Lamp_ali(fun(B,A),fun(B,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,Uu,Uua)),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_725
tff(fact_6891_ATP_Olambda__726,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_xn(fun(B,A),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub))) ) ) ).

% ATP.lambda_726
tff(fact_6892_ATP_Olambda__727,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_qp(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_727
tff(fact_6893_ATP_Olambda__728,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(A,fun(C,B)),Uua: fun(A,option(C)),Uub: A] : ( aa(A,option(B),aa(fun(A,option(C)),fun(A,option(B)),aTP_Lamp_acp(fun(A,fun(C,B)),fun(fun(A,option(C)),fun(A,option(B))),Uu),Uua),Uub) = aa(option(C),option(B),map_option(C,B,aa(A,fun(C,B),Uu,Uub)),aa(A,option(C),Uua,Uub)) ) ).

% ATP.lambda_728
tff(fact_6894_ATP_Olambda__729,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_mv(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_729
tff(fact_6895_ATP_Olambda__730,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qg(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uub)),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_730
tff(fact_6896_ATP_Olambda__731,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ox(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_731
tff(fact_6897_ATP_Olambda__732,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: fun(A,set(B)),Uub: A] : ( aa(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_cg(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(A,set(B),Uu,Uub)),aa(A,set(B),Uua,Uub)) ) ).

% ATP.lambda_732
tff(fact_6898_ATP_Olambda__733,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aa(fun(A,nat),fun(fun(A,nat),fun(A,nat)),aTP_Lamp_aps(fun(A,nat),fun(fun(A,nat),fun(A,nat))),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uua,Uub)) ) ).

% ATP.lambda_733
tff(fact_6899_ATP_Olambda__734,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_va(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uua,Uub)),aa(A,nat,Uu,Uub)) ) ) ).

% ATP.lambda_734
tff(fact_6900_ATP_Olambda__735,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_qk(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uua,Uub)),aa(A,nat,Uu,Uub)) ) ).

% ATP.lambda_735
tff(fact_6901_ATP_Olambda__736,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_gp(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(B,set(A),Uu,Uub)),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_736
tff(fact_6902_ATP_Olambda__737,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ki(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_737
tff(fact_6903_ATP_Olambda__738,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_gf(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_738
tff(fact_6904_ATP_Olambda__739,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ke(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_739
tff(fact_6905_ATP_Olambda__740,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: fun(A,assn),Uub: A] : ( aa(A,assn,aa(fun(A,assn),fun(A,assn),aTP_Lamp_ay(fun(A,assn),fun(fun(A,assn),fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(A,assn,Uu,Uub)),aa(A,assn,Uua,Uub)) ) ).

% ATP.lambda_740
tff(fact_6906_ATP_Olambda__741,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: fun(A,set(B)),Uub: A] : ( aa(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_bt(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(A,set(B),Uu,Uub)),aa(A,set(B),Uua,Uub)) ) ).

% ATP.lambda_741
tff(fact_6907_ATP_Olambda__742,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_ik(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(B,set(A),Uu,Uub)),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_742
tff(fact_6908_ATP_Olambda__743,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_kh(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_743
tff(fact_6909_ATP_Olambda__744,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_id(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_744
tff(fact_6910_ATP_Olambda__745,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_kd(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_745
tff(fact_6911_ATP_Olambda__746,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: fun(A,set(B)),Uub: A] : ( aa(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_bu(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),Uu,Uub)),aa(A,set(B),Uua,Uub)) ) ).

% ATP.lambda_746
tff(fact_6912_ATP_Olambda__747,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_mg(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_747
tff(fact_6913_ATP_Olambda__748,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aa(fun(A,nat),fun(fun(A,nat),fun(A,nat)),aTP_Lamp_apr(fun(A,nat),fun(fun(A,nat),fun(A,nat))),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uua,Uub)) ) ).

% ATP.lambda_748
tff(fact_6914_ATP_Olambda__749,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,multiset(A)),Uua: fun(B,multiset(A)),Uub: B] : ( aa(B,multiset(A),aa(fun(B,multiset(A)),fun(B,multiset(A)),aTP_Lamp_atw(fun(B,multiset(A)),fun(fun(B,multiset(A)),fun(B,multiset(A))),Uu),Uua),Uub) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(B,multiset(A),Uu,Uub)),aa(B,multiset(A),Uua,Uub)) ) ).

% ATP.lambda_749
tff(fact_6915_ATP_Olambda__750,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,multiset(A)),Uua: fun(B,multiset(A)),Uub: B] : ( aa(B,multiset(A),aa(fun(B,multiset(A)),fun(B,multiset(A)),aTP_Lamp_atx(fun(B,multiset(A)),fun(fun(B,multiset(A)),fun(B,multiset(A))),Uu),Uua),Uub) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(B,multiset(A),Uu,Uub)),aa(B,multiset(A),Uua,Uub)) ) ).

% ATP.lambda_750
tff(fact_6916_ATP_Olambda__751,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,A),Uua: fun(C,B),Uub: C] : ( aa(C,product_prod(A,B),aa(fun(C,B),fun(C,product_prod(A,B)),aTP_Lamp_co(fun(C,A),fun(fun(C,B),fun(C,product_prod(A,B))),Uu),Uua),Uub) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,Uu,Uub)),aa(C,B,Uua,Uub)) ) ).

% ATP.lambda_751
tff(fact_6917_ATP_Olambda__752,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,C),Uub: A] : ( aa(A,product_prod(B,C),aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_qq(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),Uu),Uua),Uub) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(A,B,Uu,Uub)),aa(A,C,Uua,Uub)) ) ).

% ATP.lambda_752
tff(fact_6918_ATP_Olambda__753,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aw(fun(A,bool),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uu,Uub))
       => pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_753
tff(fact_6919_ATP_Olambda__754,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ro(fun(A,set(B)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),disjnt(B),aa(A,set(B),Uu,Uua)),aa(A,set(B),Uu,Uub))) ) ).

% ATP.lambda_754
tff(fact_6920_ATP_Olambda__755,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,B)),Uua: fun(A,nat),Uub: A] : ( aa(A,fun(B,B),aa(fun(A,nat),fun(A,fun(B,B)),aTP_Lamp_agz(fun(A,fun(B,B)),fun(fun(A,nat),fun(A,fun(B,B))),Uu),Uua),Uub) = compow(fun(B,B),aa(A,nat,Uua,Uub),aa(A,fun(B,B),Uu,Uub)) ) ).

% ATP.lambda_755
tff(fact_6921_ATP_Olambda__756,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uua: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_bd(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Uu,Uub))
        | pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Uua,Uub)) ) ) ).

% ATP.lambda_756
tff(fact_6922_ATP_Olambda__757,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [Uu: fun(A,bool),Uua: fun(A,bool),Uub: A] :
          ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_ayf(fun(A,bool),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
        <=> ( pp(aa(A,bool,Uu,Uub))
            | pp(aa(A,bool,Uua,Uub)) ) ) ) ).

% ATP.lambda_757
tff(fact_6923_ATP_Olambda__758,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_au(fun(A,bool),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uu,Uub))
        | pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_758
tff(fact_6924_ATP_Olambda__759,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uua: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_be(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Uu,Uub))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Uua,Uub)) ) ) ).

% ATP.lambda_759
tff(fact_6925_ATP_Olambda__760,axiom,
    ! [B: $tType,Uu: fun(B,bool),Uua: fun(B,bool),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,bool),fun(B,bool),aTP_Lamp_aeo(fun(B,bool),fun(fun(B,bool),fun(B,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(B,bool,Uu,Uub))
        & pp(aa(B,bool,Uua,Uub)) ) ) ).

% ATP.lambda_760
tff(fact_6926_ATP_Olambda__761,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aq(fun(A,bool),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uu,Uub))
        & pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_761
tff(fact_6927_ATP_Olambda__762,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aim(fun(A,bool),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uua,Uub))
        & pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_762
tff(fact_6928_ATP_Olambda__763,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: B,Uub: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),aTP_Lamp_aoe(fun(B,A),fun(B,fun(B,bool)),Uu),Uua),Uub))
        <=> ( aa(B,A,Uu,Uua) = aa(B,A,Uu,Uub) ) ) ) ).

% ATP.lambda_763
tff(fact_6929_ATP_Olambda__764,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_adr(fun(A,B),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( aa(A,B,Uu,Uua) = aa(A,B,Uu,Uub) ) ) ).

% ATP.lambda_764
tff(fact_6930_ATP_Olambda__765,axiom,
    ! [D: $tType,B: $tType,Uu: fun(B,D),Uua: fun(B,D),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,D),fun(B,bool),aTP_Lamp_aqz(fun(B,D),fun(fun(B,D),fun(B,bool)),Uu),Uua),Uub))
    <=> ( aa(B,D,Uu,Uub) = aa(B,D,Uua,Uub) ) ) ).

% ATP.lambda_765
tff(fact_6931_ATP_Olambda__766,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(B,A),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_nt(fun(B,A),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
    <=> ( aa(B,A,Uu,Uub) = aa(B,A,Uua,Uub) ) ) ).

% ATP.lambda_766
tff(fact_6932_ATP_Olambda__767,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_nm(fun(A,bool),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uu,Uub))
      <=> pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_767
tff(fact_6933_ATP_Olambda__768,axiom,
    ! [C: $tType,A: $tType,Uu: fun(A,C),Uua: fun(A,C),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,C),fun(A,bool),aTP_Lamp_aqy(fun(A,C),fun(fun(A,C),fun(A,bool)),Uu),Uua),Uub))
    <=> ( aa(A,C,Uu,Uub) = aa(A,C,Uua,Uub) ) ) ).

% ATP.lambda_768
tff(fact_6934_ATP_Olambda__769,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_nv(fun(A,B),fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
    <=> ( aa(A,B,Uu,Uub) = aa(A,B,Uua,Uub) ) ) ).

% ATP.lambda_769
tff(fact_6935_ATP_Olambda__770,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_alx(B,fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> ( aa(B,A,Uua,Uu) = aa(B,A,Uua,Uub) ) ) ) ).

% ATP.lambda_770
tff(fact_6936_ATP_Olambda__771,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,A),Uua: fun(B,bool),Uub: B] : ( aa(B,A,aa(fun(B,bool),fun(B,A),aTP_Lamp_xh(fun(B,A),fun(fun(B,bool),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(bool,A,zero_neq_one_of_bool(A),aa(B,bool,Uua,Uub))) ) ) ).

% ATP.lambda_771
tff(fact_6937_ATP_Olambda__772,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aft(fun(A,fun(A,bool)),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uua,Uub))
        & ! [Y4: A] :
            ( pp(aa(A,bool,Uua,Y4))
           => pp(aa(A,bool,aa(A,fun(A,bool),Uu,Uub),Y4)) ) ) ) ).

% ATP.lambda_772
tff(fact_6938_ATP_Olambda__773,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: fun(A,assn),Uub: A] : ( aa(A,assn,aa(fun(A,assn),fun(A,assn),aTP_Lamp_ax(fun(A,assn),fun(fun(A,assn),fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(A,assn,Uu,Uub)),ex_assn(A,Uua)) ) ).

% ATP.lambda_773
tff(fact_6939_ATP_Olambda__774,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,option(B)),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_aax(fun(A,option(B)),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> ( aa(A,option(B),Uu,Uua) = aa(B,option(B),some(B),Uub) ) ) ).

% ATP.lambda_774
tff(fact_6940_ATP_Olambda__775,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(C),Uub: B] : ( aa(B,A,aa(set(C),fun(B,A),aTP_Lamp_om(fun(B,fun(C,A)),fun(set(C),fun(B,A)),Uu),Uua),Uub) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),aa(B,fun(C,A),Uu,Uub)),Uua) ) ) ).

% ATP.lambda_775
tff(fact_6941_ATP_Olambda__776,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(C),Uub: B] : ( aa(B,A,aa(set(C),fun(B,A),aTP_Lamp_oj(fun(B,fun(C,A)),fun(set(C),fun(B,A)),Uu),Uua),Uub) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(B,fun(C,A),Uu,Uub)),Uua) ) ) ).

% ATP.lambda_776
tff(fact_6942_ATP_Olambda__777,axiom,
    ! [Uu: fun(nat,nat),Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_rc(fun(nat,nat),fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,Uu,Uub)),Uua)) ) ).

% ATP.lambda_777
tff(fact_6943_ATP_Olambda__778,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,set(A)),Uua: set(A),Uub: B] :
      ( pp(aa(B,bool,aa(set(A),fun(B,bool),aTP_Lamp_he(fun(B,set(A)),fun(set(A),fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(B,set(A),Uu,Uub)),Uua)) ) ).

% ATP.lambda_778
tff(fact_6944_ATP_Olambda__779,axiom,
    ! [A: $tType,B: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_tx(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_779
tff(fact_6945_ATP_Olambda__780,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_oc(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_780
tff(fact_6946_ATP_Olambda__781,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_ze(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = modulo_modulo(A,aa(B,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_781
tff(fact_6947_ATP_Olambda__782,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_yz(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_782
tff(fact_6948_ATP_Olambda__783,axiom,
    ! [B: $tType,A: $tType] :
      ( field(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_qo(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_783
tff(fact_6949_ATP_Olambda__784,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_akn(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_784
tff(fact_6950_ATP_Olambda__785,axiom,
    ! [A: $tType,B: $tType] :
      ( ( dense_linorder(B)
        & no_bot(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_tw(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_785
tff(fact_6951_ATP_Olambda__786,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_ov(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_786
tff(fact_6952_ATP_Olambda__787,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: assn,Uub: A] : ( aa(A,assn,aa(assn,fun(A,assn),aTP_Lamp_aa(fun(A,assn),fun(assn,fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(A,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_787
tff(fact_6953_ATP_Olambda__788,axiom,
    ! [K4: $tType,L2: $tType,Uu: fun(K4,set(L2)),Uua: set(L2),Uub: K4] : ( aa(K4,set(L2),aa(set(L2),fun(K4,set(L2)),aTP_Lamp_gq(fun(K4,set(L2)),fun(set(L2),fun(K4,set(L2))),Uu),Uua),Uub) = aa(set(L2),set(L2),aa(set(L2),fun(set(L2),set(L2)),minus_minus(set(L2)),aa(K4,set(L2),Uu,Uub)),Uua) ) ).

% ATP.lambda_788
tff(fact_6954_ATP_Olambda__789,axiom,
    ! [E: $tType,F10: $tType,Uu: fun(E,set(F10)),Uua: set(F10),Uub: E] : ( aa(E,set(F10),aa(set(F10),fun(E,set(F10)),aTP_Lamp_ia(fun(E,set(F10)),fun(set(F10),fun(E,set(F10))),Uu),Uua),Uub) = aa(set(F10),set(F10),aa(set(F10),fun(set(F10),set(F10)),minus_minus(set(F10)),aa(E,set(F10),Uu,Uub)),Uua) ) ).

% ATP.lambda_789
tff(fact_6955_ATP_Olambda__790,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_sa(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_790
tff(fact_6956_ATP_Olambda__791,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,multiset(A)),Uua: A,Uub: B] : ( aa(B,nat,aa(A,fun(B,nat),aTP_Lamp_apa(fun(B,multiset(A)),fun(A,fun(B,nat)),Uu),Uua),Uub) = aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(B,multiset(A),Uu,Uub)),Uua) ) ).

% ATP.lambda_791
tff(fact_6957_ATP_Olambda__792,axiom,
    ! [K4: $tType,L2: $tType,Uu: fun(K4,set(L2)),Uua: set(L2),Uub: K4] : ( aa(K4,set(L2),aa(set(L2),fun(K4,set(L2)),aTP_Lamp_io(fun(K4,set(L2)),fun(set(L2),fun(K4,set(L2))),Uu),Uua),Uub) = aa(set(L2),set(L2),aa(set(L2),fun(set(L2),set(L2)),sup_sup(set(L2)),aa(K4,set(L2),Uu,Uub)),Uua) ) ).

% ATP.lambda_792
tff(fact_6958_ATP_Olambda__793,axiom,
    ! [C: $tType,D: $tType,Uu: fun(C,set(D)),Uua: set(D),Uub: C] : ( aa(C,set(D),aa(set(D),fun(C,set(D)),aTP_Lamp_fk(fun(C,set(D)),fun(set(D),fun(C,set(D))),Uu),Uua),Uub) = aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),sup_sup(set(D)),aa(C,set(D),Uu,Uub)),Uua) ) ).

% ATP.lambda_793
tff(fact_6959_ATP_Olambda__794,axiom,
    ! [B: $tType,A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_ii(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_794
tff(fact_6960_ATP_Olambda__795,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: assn,Uub: A] : ( aa(A,assn,aa(assn,fun(A,assn),aTP_Lamp_az(fun(A,assn),fun(assn,fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(A,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_795
tff(fact_6961_ATP_Olambda__796,axiom,
    ! [G3: $tType,H8: $tType,Uu: fun(G3,set(H8)),Uua: set(H8),Uub: G3] : ( aa(G3,set(H8),aa(set(H8),fun(G3,set(H8)),aTP_Lamp_gn(fun(G3,set(H8)),fun(set(H8),fun(G3,set(H8))),Uu),Uua),Uub) = aa(set(H8),set(H8),aa(set(H8),fun(set(H8),set(H8)),inf_inf(set(H8)),aa(G3,set(H8),Uu,Uub)),Uua) ) ).

% ATP.lambda_796
tff(fact_6962_ATP_Olambda__797,axiom,
    ! [B: $tType,A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_ge(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_797
tff(fact_6963_ATP_Olambda__798,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_iu(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_798
tff(fact_6964_ATP_Olambda__799,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: assn,Uub: A] : ( aa(A,assn,aa(assn,fun(A,assn),aTP_Lamp_ai(fun(A,assn),fun(assn,fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(A,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_799
tff(fact_6965_ATP_Olambda__800,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,set(B)),Uua: set(B),Uub: A] : ( aa(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_hy(fun(A,set(B)),fun(set(B),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),Uu,Uub)),Uua) ) ).

% ATP.lambda_800
tff(fact_6966_ATP_Olambda__801,axiom,
    ! [B: $tType,A: $tType] :
      ( linord4140545234300271783up_add(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_zy(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_801
tff(fact_6967_ATP_Olambda__802,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,heap_Time_Heap(C)),Uua: fun(C,heap_Time_Heap(B)),Uub: A] : ( aa(A,heap_Time_Heap(B),aa(fun(C,heap_Time_Heap(B)),fun(A,heap_Time_Heap(B)),aTP_Lamp_axa(fun(A,heap_Time_Heap(C)),fun(fun(C,heap_Time_Heap(B)),fun(A,heap_Time_Heap(B))),Uu),Uua),Uub) = heap_Time_bind(C,B,aa(A,heap_Time_Heap(C),Uu,Uub),Uua) ) ).

% ATP.lambda_802
tff(fact_6968_ATP_Olambda__803,axiom,
    ! [E: $tType,F10: $tType,B: $tType,D: $tType,C: $tType,Uu: fun(E,fun(F10,product_prod(C,D))),Uua: fun(C,fun(D,B)),Uub: E] : ( aa(E,fun(F10,B),aa(fun(C,fun(D,B)),fun(E,fun(F10,B)),aTP_Lamp_ahe(fun(E,fun(F10,product_prod(C,D))),fun(fun(C,fun(D,B)),fun(E,fun(F10,B))),Uu),Uua),Uub) = product_scomp(F10,C,D,B,aa(E,fun(F10,product_prod(C,D)),Uu,Uub),Uua) ) ).

% ATP.lambda_803
tff(fact_6969_ATP_Olambda__804,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(C,set(old_node(A,B))),Uua: set(old_node(A,B)),Uub: C] : ( aa(C,set(old_node(A,B)),aa(set(old_node(A,B)),fun(C,set(old_node(A,B))),aTP_Lamp_azi(fun(C,set(old_node(A,B))),fun(set(old_node(A,B)),fun(C,set(old_node(A,B)))),Uu),Uua),Uub) = old_Scons(A,B,aa(C,set(old_node(A,B)),Uu,Uub),Uua) ) ).

% ATP.lambda_804
tff(fact_6970_ATP_Olambda__805,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,filter(B)),Uua: filter(C),Uub: A] : ( aa(A,filter(product_prod(B,C)),aa(filter(C),fun(A,filter(product_prod(B,C))),aTP_Lamp_qy(fun(A,filter(B)),fun(filter(C),fun(A,filter(product_prod(B,C)))),Uu),Uua),Uub) = prod_filter(B,C,aa(A,filter(B),Uu,Uub),Uua) ) ).

% ATP.lambda_805
tff(fact_6971_ATP_Olambda__806,axiom,
    ! [D: $tType,A: $tType,B: $tType,C: $tType,Uu: fun(D,fun(A,fun(C,bool))),Uua: fun(C,fun(B,bool)),Uub: D] : ( aa(D,fun(A,fun(B,bool)),aa(fun(C,fun(B,bool)),fun(D,fun(A,fun(B,bool))),aTP_Lamp_arc(fun(D,fun(A,fun(C,bool))),fun(fun(C,fun(B,bool)),fun(D,fun(A,fun(B,bool)))),Uu),Uua),Uub) = aa(fun(C,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(C,bool)),fun(fun(C,fun(B,bool)),fun(A,fun(B,bool))),relcompp(A,C,B),aa(D,fun(A,fun(C,bool)),Uu,Uub)),Uua) ) ).

% ATP.lambda_806
tff(fact_6972_ATP_Olambda__807,axiom,
    ! [D: $tType,A: $tType,B: $tType,C: $tType,Uu: fun(D,set(product_prod(A,C))),Uua: set(product_prod(C,B)),Uub: D] : ( aa(D,set(product_prod(A,B)),aa(set(product_prod(C,B)),fun(D,set(product_prod(A,B))),aTP_Lamp_mf(fun(D,set(product_prod(A,C))),fun(set(product_prod(C,B)),fun(D,set(product_prod(A,B)))),Uu),Uua),Uub) = relcomp(A,C,B,aa(D,set(product_prod(A,C)),Uu,Uub),Uua) ) ).

% ATP.lambda_807
tff(fact_6973_ATP_Olambda__808,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(C,set(product_prod(B,A))),Uua: set(B),Uub: C] : ( aa(C,set(A),aa(set(B),fun(C,set(A)),aTP_Lamp_jv(fun(C,set(product_prod(B,A))),fun(set(B),fun(C,set(A))),Uu),Uua),Uub) = aa(set(B),set(A),image(B,A,aa(C,set(product_prod(B,A)),Uu,Uub)),Uua) ) ).

% ATP.lambda_808
tff(fact_6974_ATP_Olambda__809,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(C,option(B)),Uua: fun(B,option(A)),Uub: C] : ( aa(C,option(A),aa(fun(B,option(A)),fun(C,option(A)),aTP_Lamp_bas(fun(C,option(B)),fun(fun(B,option(A)),fun(C,option(A))),Uu),Uua),Uub) = bind2(B,A,aa(C,option(B),Uu,Uub),Uua) ) ).

% ATP.lambda_809
tff(fact_6975_ATP_Olambda__810,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: bool,Uub: A] :
      ( pp(aa(A,bool,aa(bool,fun(A,bool),aTP_Lamp_atj(fun(A,bool),fun(bool,fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uu,Uub))
       => pp(Uua) ) ) ).

% ATP.lambda_810
tff(fact_6976_ATP_Olambda__811,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: set(B),Uub: A] :
      ( pp(aa(A,bool,aa(set(B),fun(A,bool),aTP_Lamp_bn(fun(A,B),fun(set(B),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(B),bool,member(B,aa(A,B,Uu,Uub)),Uua)) ) ).

% ATP.lambda_811
tff(fact_6977_ATP_Olambda__812,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(B,A),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_lf(set(A),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(A),bool,member(A,aa(B,A,Uua,Uub)),Uu)) ) ).

% ATP.lambda_812
tff(fact_6978_ATP_Olambda__813,axiom,
    ! [D: $tType,E: $tType,B: $tType,C: $tType,Uu: fun(D,fun(E,C)),Uua: fun(C,B),Uub: D] : ( aa(D,fun(E,B),aa(fun(C,B),fun(D,fun(E,B)),aTP_Lamp_bay(fun(D,fun(E,C)),fun(fun(C,B),fun(D,fun(E,B))),Uu),Uua),Uub) = fcomp(E,C,B,aa(D,fun(E,C),Uu,Uub),Uua) ) ).

% ATP.lambda_813
tff(fact_6979_ATP_Olambda__814,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,set(C)),Uua: fun(C,set(B)),Uub: A] : ( aa(A,set(B),aa(fun(C,set(B)),fun(A,set(B)),aTP_Lamp_ahk(fun(A,set(C)),fun(fun(C,set(B)),fun(A,set(B))),Uu),Uua),Uub) = bind3(C,B,aa(A,set(C),Uu,Uub),Uua) ) ).

% ATP.lambda_814
tff(fact_6980_ATP_Olambda__815,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: bool,Uub: A] :
      ( pp(aa(A,bool,aa(bool,fun(A,bool),aTP_Lamp_no(fun(A,bool),fun(bool,fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uu,Uub))
        | pp(Uua) ) ) ).

% ATP.lambda_815
tff(fact_6981_ATP_Olambda__816,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: bool,Uub: A] :
      ( pp(aa(A,bool,aa(bool,fun(A,bool),aTP_Lamp_ath(fun(A,bool),fun(bool,fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uu,Uub))
        & pp(Uua) ) ) ).

% ATP.lambda_816
tff(fact_6982_ATP_Olambda__817,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_ako(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> ( aa(B,A,Uu,Uub) = Uua ) ) ) ).

% ATP.lambda_817
tff(fact_6983_ATP_Olambda__818,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_ayj(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> ( aa(B,A,Uu,Uub) = Uua ) ) ).

% ATP.lambda_818
tff(fact_6984_ATP_Olambda__819,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_amo(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> ( aa(A,B,Uu,Uub) = Uua ) ) ) ).

% ATP.lambda_819
tff(fact_6985_ATP_Olambda__820,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: B,Uub: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_ep(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
    <=> ( aa(A,B,Uu,Uub) = Uua ) ) ).

% ATP.lambda_820
tff(fact_6986_ATP_Olambda__821,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: fun(B,A),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_asr(A,fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
    <=> ( aa(B,A,Uua,Uub) = Uu ) ) ).

% ATP.lambda_821
tff(fact_6987_ATP_Olambda__822,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(nat,A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avq(nat,fun(fun(nat,A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avp(nat,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(A,aa(list(nat),list(A),map(nat,A,Uua),upt(zero_zero(nat),Uu)),Uub)) ) ) ).

% ATP.lambda_822
tff(fact_6988_ATP_Olambda__823,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: A,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(A,fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avu(nat,fun(A,fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avp(nat,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(A,replicate(A,Uu,Uua),Uub)) ) ) ).

% ATP.lambda_823
tff(fact_6989_ATP_Olambda__824,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ahd(set(product_prod(A,A)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uub != Uua )
        & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uub)),Uu)) ) ) ).

% ATP.lambda_824
tff(fact_6990_ATP_Olambda__825,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_age(set(product_prod(A,A)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uub != Uua )
        & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uua)),Uu)) ) ) ).

% ATP.lambda_825
tff(fact_6991_ATP_Olambda__826,axiom,
    ! [A: $tType,Uu: A,Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_df(A,fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uub != Uu )
       => pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_826
tff(fact_6992_ATP_Olambda__827,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_wa(nat,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub))) ) ) ).

% ATP.lambda_827
tff(fact_6993_ATP_Olambda__828,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_adl(A,fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uua != Uu )
        & ( Uub != Uu ) ) ) ).

% ATP.lambda_828
tff(fact_6994_ATP_Olambda__829,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,bool),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_xi(fun(B,bool),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(B,bool,Uu,Uub))),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_829
tff(fact_6995_ATP_Olambda__830,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_atk(fun(A,bool),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( ~ pp(aa(A,bool,Uu,Uub))
        | pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_830
tff(fact_6996_ATP_Olambda__831,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [Uu: fun(A,A),Uua: fun(A,bool),Uub: A] :
          ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_aep(fun(A,A),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
        <=> ( ? [X3: A] :
                ( ( Uub = aa(A,A,Uu,X3) )
                & pp(aa(A,bool,Uua,X3)) )
            | ? [M7: set(A)] :
                ( ( Uub = aa(set(A),A,complete_Sup_Sup(A),M7) )
                & comple1602240252501008431_chain(A,ord_less_eq(A),M7)
                & ! [X3: A] :
                    ( pp(aa(set(A),bool,member(A,X3),M7))
                   => pp(aa(A,bool,Uua,X3)) ) ) ) ) ) ).

% ATP.lambda_831
tff(fact_6997_ATP_Olambda__832,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: set(B),Uub: fun(A,B)] :
      ( pp(aa(fun(A,B),bool,aa(set(B),fun(fun(A,B),bool),aTP_Lamp_ahm(set(A),fun(set(B),fun(fun(A,B),bool)),Uu),Uua),Uub))
    <=> ( ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),Uu))
           => pp(aa(set(B),bool,member(B,aa(A,B,Uub,X3)),Uua)) )
        & ! [A6: A] :
            ( ~ pp(aa(set(A),bool,member(A,A6),Uu))
           => ( aa(A,B,Uub,A6) = undefined(B) ) ) ) ) ).

% ATP.lambda_832
tff(fact_6998_ATP_Olambda__833,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(list(A),fun(list(A),bool)),Uua: list(A),Uub: list(A)] :
          ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool)),aTP_Lamp_air(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool))),Uu),Uua),Uub))
        <=> ( ? [Y4: A,Ys2: list(A)] :
                ( ( Uua = nil(A) )
                & ( Uub = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y4),Ys2) ) )
            | ? [X3: A,Y4: A,Xs3: list(A),Ys2: list(A)] :
                ( ( Uua = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X3),Xs3) )
                & ( Uub = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y4),Ys2) )
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4)) )
            | ? [X3: A,Y4: A,Xs3: list(A),Ys2: list(A)] :
                ( ( Uua = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X3),Xs3) )
                & ( Uub = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y4),Ys2) )
                & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),Y4))
                & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X3))
                & pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),Uu,Xs3),Ys2)) ) ) ) ) ).

% ATP.lambda_833
tff(fact_6999_ATP_Olambda__834,axiom,
    ! [A: $tType,Uu: fun(list(multiset(A)),fun(list(multiset(A)),bool)),Uua: list(multiset(A)),Uub: list(multiset(A))] :
      ( pp(aa(list(multiset(A)),bool,aa(list(multiset(A)),fun(list(multiset(A)),bool),aa(fun(list(multiset(A)),fun(list(multiset(A)),bool)),fun(list(multiset(A)),fun(list(multiset(A)),bool)),aTP_Lamp_auf(fun(list(multiset(A)),fun(list(multiset(A)),bool)),fun(list(multiset(A)),fun(list(multiset(A)),bool))),Uu),Uua),Uub))
    <=> ( ? [Y4: multiset(A),Ys2: list(multiset(A))] :
            ( ( Uua = nil(multiset(A)) )
            & ( Uub = aa(list(multiset(A)),list(multiset(A)),aa(multiset(A),fun(list(multiset(A)),list(multiset(A))),cons(multiset(A)),Y4),Ys2) ) )
        | ? [X3: multiset(A),Y4: multiset(A),Xs3: list(multiset(A)),Ys2: list(multiset(A))] :
            ( ( Uua = aa(list(multiset(A)),list(multiset(A)),aa(multiset(A),fun(list(multiset(A)),list(multiset(A))),cons(multiset(A)),X3),Xs3) )
            & ( Uub = aa(list(multiset(A)),list(multiset(A)),aa(multiset(A),fun(list(multiset(A)),list(multiset(A))),cons(multiset(A)),Y4),Ys2) )
            & pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),X3),Y4)) )
        | ? [X3: multiset(A),Y4: multiset(A),Xs3: list(multiset(A)),Ys2: list(multiset(A))] :
            ( ( Uua = aa(list(multiset(A)),list(multiset(A)),aa(multiset(A),fun(list(multiset(A)),list(multiset(A))),cons(multiset(A)),X3),Xs3) )
            & ( Uub = aa(list(multiset(A)),list(multiset(A)),aa(multiset(A),fun(list(multiset(A)),list(multiset(A))),cons(multiset(A)),Y4),Ys2) )
            & ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),X3),Y4))
            & ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),Y4),X3))
            & pp(aa(list(multiset(A)),bool,aa(list(multiset(A)),fun(list(multiset(A)),bool),Uu,Xs3),Ys2)) ) ) ) ).

% ATP.lambda_834
tff(fact_7000_ATP_Olambda__835,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aTP_Lamp_mx(set(A),fun(set(A),fun(set(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,finite_finite2(A),Uub))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Uua),Uub))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),Uub),Uu)) ) ) ).

% ATP.lambda_835
tff(fact_7001_ATP_Olambda__836,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aTP_Lamp_afj(set(product_prod(A,A)),fun(set(A),fun(set(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,finite_finite2(A),Uua))
        & pp(aa(set(A),bool,finite_finite2(A),Uub))
        & ( Uub != bot_bot(set(A)) )
        & ! [X3: A] :
            ( pp(aa(set(A),bool,member(A,X3),Uua))
           => ? [Xa2: A] :
                ( pp(aa(set(A),bool,member(A,Xa2),Uub))
                & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa2)),Uu)) ) ) ) ) ).

% ATP.lambda_836
tff(fact_7002_ATP_Olambda__837,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,A)),Uua: list(A),Uub: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),aTP_Lamp_ayd(fun(A,fun(A,A)),fun(list(A),fun(list(A),list(A))),Uu),Uua),Uub) = aa(list(product_prod(A,A)),list(A),map(product_prod(A,A),A,aa(fun(A,fun(A,A)),fun(product_prod(A,A),A),product_case_prod(A,A,A),Uu)),zip(A,A,Uua,Uub)) ) ).

% ATP.lambda_837
tff(fact_7003_ATP_Olambda__838,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] : ( aa(A,set(A),aa(A,fun(A,set(A)),aTP_Lamp_mw(set(product_prod(A,A)),fun(A,fun(A,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),image(A,A,converse(A,A,Uu)),aa(set(A),set(A),insert(A,Uua),bot_bot(set(A)))) ) ).

% ATP.lambda_838
tff(fact_7004_ATP_Olambda__839,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: list(B),Uub: B] : ( aa(B,fun(list(B),list(B)),aa(list(B),fun(B,fun(list(B),list(B))),aTP_Lamp_amv(fun(B,A),fun(list(B),fun(B,fun(list(B),list(B)))),Uu),Uua),Uub) = case_list(list(B),B,Uua,aa(B,fun(B,fun(list(B),list(B))),aa(list(B),fun(B,fun(B,fun(list(B),list(B)))),aTP_Lamp_amu(fun(B,A),fun(list(B),fun(B,fun(B,fun(list(B),list(B))))),Uu),Uua),Uub)) ) ) ).

% ATP.lambda_839
tff(fact_7005_ATP_Olambda__840,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_wl(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_840
tff(fact_7006_ATP_Olambda__841,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_wj(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_841
tff(fact_7007_ATP_Olambda__842,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: list(B),Uub: A] : ( aa(A,list(B),aa(list(B),fun(A,list(B)),aTP_Lamp_ana(fun(A,B),fun(list(B),fun(A,list(B))),Uu),Uua),Uub) = append(B,Uua,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),aa(A,B,Uu,Uub)),nil(B))) ) ).

% ATP.lambda_842
tff(fact_7008_ATP_Olambda__843,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_yn(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_843
tff(fact_7009_ATP_Olambda__844,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_yj(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_844
tff(fact_7010_ATP_Olambda__845,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: array(A),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avp(nat,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_Pair(array(A),product_prod(heap_ext(product_unit),nat)),Uua),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),one_one(nat)))) ) ) ).

% ATP.lambda_845
tff(fact_7011_ATP_Olambda__846,axiom,
    ! [A: $tType,Uu: set(A),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_fb(set(A),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(A),bool,member(A,Uub),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uu),aa(set(A),set(A),insert(A,Uua),bot_bot(set(A)))))) ) ).

% ATP.lambda_846
tff(fact_7012_ATP_Olambda__847,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: list(A),Uua: array(A),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avr(list(A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_Pair(array(A),product_prod(heap_ext(product_unit),nat)),Uua),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),aa(list(A),nat,size_size(list(A)),Uu)))) ) ) ).

% ATP.lambda_847
tff(fact_7013_ATP_Olambda__848,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_vl(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_848
tff(fact_7014_ATP_Olambda__849,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_acs(fun(A,option(B)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(A),bool,member(A,Uub),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uua),dom(A,B,Uu)))) ) ).

% ATP.lambda_849
tff(fact_7015_ATP_Olambda__850,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_act(fun(A,option(B)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(A),bool,member(A,Uub),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uua),dom(A,B,Uu)))) ) ).

% ATP.lambda_850
tff(fact_7016_ATP_Olambda__851,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: array(A),Uub: heap_ext(product_unit)] :
          ( pp(aa(heap_ext(product_unit),bool,aa(array(A),fun(heap_ext(product_unit),bool),aTP_Lamp_avz(nat,fun(array(A),fun(heap_ext(product_unit),bool)),Uu),Uua),Uub))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uu),array_length(A,Uub,Uua))) ) ) ).

% ATP.lambda_851
tff(fact_7017_ATP_Olambda__852,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A),Uua: nat,Uub: heap_ext(product_unit)] :
          ( pp(aa(heap_ext(product_unit),bool,aa(nat,fun(heap_ext(product_unit),bool),aTP_Lamp_avx(array(A),fun(nat,fun(heap_ext(product_unit),bool)),Uu),Uua),Uub))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uua),array_length(A,Uub,Uu))) ) ) ).

% ATP.lambda_852
tff(fact_7018_ATP_Olambda__853,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_si(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_853
tff(fact_7019_ATP_Olambda__854,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_yl(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)) ) ).

% ATP.lambda_854
tff(fact_7020_ATP_Olambda__855,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: A,Uua: B,Uub: C] : ( aa(C,product_prod(A,product_prod(B,C)),aa(B,fun(C,product_prod(A,product_prod(B,C))),aa(A,fun(B,fun(C,product_prod(A,product_prod(B,C)))),aTP_Lamp_aky(A,fun(B,fun(C,product_prod(A,product_prod(B,C))))),Uu),Uua),Uub) = aa(product_prod(B,C),product_prod(A,product_prod(B,C)),aa(A,fun(product_prod(B,C),product_prod(A,product_prod(B,C))),product_Pair(A,product_prod(B,C)),Uu),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uub)) ) ).

% ATP.lambda_855
tff(fact_7021_ATP_Olambda__856,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: B,Uua: A,Uub: C] : ( aa(C,product_prod(A,product_prod(B,C)),aa(A,fun(C,product_prod(A,product_prod(B,C))),aTP_Lamp_akw(B,fun(A,fun(C,product_prod(A,product_prod(B,C)))),Uu),Uua),Uub) = aa(product_prod(B,C),product_prod(A,product_prod(B,C)),aa(A,fun(product_prod(B,C),product_prod(A,product_prod(B,C))),product_Pair(A,product_prod(B,C)),Uua),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),Uub)) ) ).

% ATP.lambda_856
tff(fact_7022_ATP_Olambda__857,axiom,
    ! [A: $tType,Uu: A,Uua: list(A),Uub: nat] : ( aa(nat,list(A),aa(list(A),fun(nat,list(A)),aTP_Lamp_aqo(A,fun(list(A),fun(nat,list(A))),Uu),Uua),Uub) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uu),take(A,Uub,Uua)) ) ).

% ATP.lambda_857
tff(fact_7023_ATP_Olambda__858,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,option(A)),Uua: list(B),Uub: A] : ( aa(A,list(A),aa(list(B),fun(A,list(A)),aTP_Lamp_aip(fun(B,option(A)),fun(list(B),fun(A,list(A))),Uu),Uua),Uub) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uub),map_filter(B,A,Uu,Uua)) ) ).

% ATP.lambda_858
tff(fact_7024_ATP_Olambda__859,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [Uu: fun(A,B),Uua: set(A),Uub: B] :
          ( pp(aa(B,bool,aa(set(A),fun(B,bool),aTP_Lamp_xt(fun(A,B),fun(set(A),fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(set(B),bool,member(B,Uub),aa(set(A),set(B),image2(A,B,Uu),Uua))) ) ) ).

% ATP.lambda_859
tff(fact_7025_ATP_Olambda__860,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,A),Uub: B] : ( aa(B,A,aa(fun(C,A),fun(B,A),aTP_Lamp_qc(fun(B,set(C)),fun(fun(C,A),fun(B,A)),Uu),Uua),Uub) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),Uua),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_860
tff(fact_7026_ATP_Olambda__861,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,A),Uub: B] : ( aa(B,A,aa(fun(C,A),fun(B,A),aTP_Lamp_qd(fun(B,set(C)),fun(fun(C,A),fun(B,A)),Uu),Uua),Uub) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),Uua),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_861
tff(fact_7027_ATP_Olambda__862,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_xd(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),Uua),aa(A,B,Uu,Uub))) ) ) ).

% ATP.lambda_862
tff(fact_7028_ATP_Olambda__863,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_xm(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),Uua),aa(A,B,Uu,Uub))) ) ) ).

% ATP.lambda_863
tff(fact_7029_ATP_Olambda__864,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_akp(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_864
tff(fact_7030_ATP_Olambda__865,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_xo(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
        <=> pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),Uua),aa(A,B,Uu,Uub))) ) ) ).

% ATP.lambda_865
tff(fact_7031_ATP_Olambda__866,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,A),Uua: fun(B,option(C)),Uub: B] : ( aa(B,option(A),aa(fun(B,option(C)),fun(B,option(A)),aTP_Lamp_acx(fun(C,A),fun(fun(B,option(C)),fun(B,option(A))),Uu),Uua),Uub) = aa(option(C),option(A),map_option(C,A,Uu),aa(B,option(C),Uua,Uub)) ) ).

% ATP.lambda_866
tff(fact_7032_ATP_Olambda__867,axiom,
    ! [A: $tType,Uu: nat,Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aa(nat,fun(fun(A,nat),fun(A,nat)),aTP_Lamp_apy(nat,fun(fun(A,nat),fun(A,nat))),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),aa(A,nat,Uua,Uub)) ) ).

% ATP.lambda_867
tff(fact_7033_ATP_Olambda__868,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ow(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_868
tff(fact_7034_ATP_Olambda__869,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: nat,Uub: A] : ( aa(A,nat,aa(nat,fun(A,nat),aTP_Lamp_apz(fun(A,nat),fun(nat,fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(A,nat,Uu,Uub)) ) ).

% ATP.lambda_869
tff(fact_7035_ATP_Olambda__870,axiom,
    ! [M4: $tType,N3: $tType,Uu: set(M4),Uua: fun(N3,set(M4)),Uub: N3] : ( aa(N3,set(M4),aa(fun(N3,set(M4)),fun(N3,set(M4)),aTP_Lamp_iw(set(M4),fun(fun(N3,set(M4)),fun(N3,set(M4))),Uu),Uua),Uub) = aa(set(M4),set(M4),aa(set(M4),fun(set(M4),set(M4)),minus_minus(set(M4)),Uu),aa(N3,set(M4),Uua,Uub)) ) ).

% ATP.lambda_870
tff(fact_7036_ATP_Olambda__871,axiom,
    ! [G3: $tType,H8: $tType,Uu: set(G3),Uua: fun(H8,set(G3)),Uub: H8] : ( aa(H8,set(G3),aa(fun(H8,set(G3)),fun(H8,set(G3)),aTP_Lamp_hs(set(G3),fun(fun(H8,set(G3)),fun(H8,set(G3))),Uu),Uua),Uub) = aa(set(G3),set(G3),aa(set(G3),fun(set(G3),set(G3)),minus_minus(set(G3)),Uu),aa(H8,set(G3),Uua,Uub)) ) ).

% ATP.lambda_871
tff(fact_7037_ATP_Olambda__872,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: fun(B,nat),Uub: B] : ( aa(B,A,aa(fun(B,nat),fun(B,A),aTP_Lamp_sf(A,fun(fun(B,nat),fun(B,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(B,nat,Uua,Uub)) ) ) ).

% ATP.lambda_872
tff(fact_7038_ATP_Olambda__873,axiom,
    ! [M4: $tType,N3: $tType,Uu: set(M4),Uua: fun(N3,set(M4)),Uub: N3] : ( aa(N3,set(M4),aa(fun(N3,set(M4)),fun(N3,set(M4)),aTP_Lamp_ip(set(M4),fun(fun(N3,set(M4)),fun(N3,set(M4))),Uu),Uua),Uub) = aa(set(M4),set(M4),aa(set(M4),fun(set(M4),set(M4)),sup_sup(set(M4)),Uu),aa(N3,set(M4),Uua,Uub)) ) ).

% ATP.lambda_873
tff(fact_7039_ATP_Olambda__874,axiom,
    ! [E: $tType,F10: $tType,Uu: set(E),Uua: fun(F10,set(E)),Uub: F10] : ( aa(F10,set(E),aa(fun(F10,set(E)),fun(F10,set(E)),aTP_Lamp_fj(set(E),fun(fun(F10,set(E)),fun(F10,set(E))),Uu),Uua),Uub) = aa(set(E),set(E),aa(set(E),fun(set(E),set(E)),sup_sup(set(E)),Uu),aa(F10,set(E),Uua,Uub)) ) ).

% ATP.lambda_874
tff(fact_7040_ATP_Olambda__875,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_in(set(A),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),Uu),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_875
tff(fact_7041_ATP_Olambda__876,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ig(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_876
tff(fact_7042_ATP_Olambda__877,axiom,
    ! [I5: $tType,J3: $tType,Uu: set(I5),Uua: fun(J3,set(I5)),Uub: J3] : ( aa(J3,set(I5),aa(fun(J3,set(I5)),fun(J3,set(I5)),aTP_Lamp_go(set(I5),fun(fun(J3,set(I5)),fun(J3,set(I5))),Uu),Uua),Uub) = aa(set(I5),set(I5),aa(set(I5),fun(set(I5),set(I5)),inf_inf(set(I5)),Uu),aa(J3,set(I5),Uua,Uub)) ) ).

% ATP.lambda_877
tff(fact_7043_ATP_Olambda__878,axiom,
    ! [C: $tType,D: $tType,Uu: set(C),Uua: fun(D,set(C)),Uub: D] : ( aa(D,set(C),aa(fun(D,set(C)),fun(D,set(C)),aTP_Lamp_hz(set(C),fun(fun(D,set(C)),fun(D,set(C))),Uu),Uua),Uub) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),Uu),aa(D,set(C),Uua,Uub)) ) ).

% ATP.lambda_878
tff(fact_7044_ATP_Olambda__879,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_gm(set(A),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uu),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_879
tff(fact_7045_ATP_Olambda__880,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_gc(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_880
tff(fact_7046_ATP_Olambda__881,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_it(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_881
tff(fact_7047_ATP_Olambda__882,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_za(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Uua),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_882
tff(fact_7048_ATP_Olambda__883,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: nat,Uua: fun(C,set(old_node(A,B))),Uub: C] : ( aa(C,set(old_node(A,B)),aa(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B))),aTP_Lamp_ayy(nat,fun(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B)))),Uu),Uua),Uub) = old_ntrunc(A,B,Uu,aa(C,set(old_node(A,B)),Uua,Uub)) ) ).

% ATP.lambda_883
tff(fact_7049_ATP_Olambda__884,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: set(old_node(A,B)),Uua: fun(C,set(old_node(A,B))),Uub: C] : ( aa(C,set(old_node(A,B)),aa(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B))),aTP_Lamp_azh(set(old_node(A,B)),fun(fun(C,set(old_node(A,B))),fun(C,set(old_node(A,B)))),Uu),Uua),Uub) = old_Scons(A,B,Uu,aa(C,set(old_node(A,B)),Uua,Uub)) ) ).

% ATP.lambda_884
tff(fact_7050_ATP_Olambda__885,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: filter(B),Uua: fun(A,filter(C)),Uub: A] : ( aa(A,filter(product_prod(B,C)),aa(fun(A,filter(C)),fun(A,filter(product_prod(B,C))),aTP_Lamp_qx(filter(B),fun(fun(A,filter(C)),fun(A,filter(product_prod(B,C)))),Uu),Uua),Uub) = prod_filter(B,C,Uu,aa(A,filter(C),Uua,Uub)) ) ).

% ATP.lambda_885
tff(fact_7051_ATP_Olambda__886,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,C),Uua: fun(B,filter(C)),Uub: B] : ( aa(B,filter(A),aa(fun(B,filter(C)),fun(B,filter(A)),aTP_Lamp_afy(fun(A,C),fun(fun(B,filter(C)),fun(B,filter(A))),Uu),Uua),Uub) = filtercomap(A,C,Uu,aa(B,filter(C),Uua,Uub)) ) ).

% ATP.lambda_886
tff(fact_7052_ATP_Olambda__887,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,B),Uua: fun(C,filter(B)),Uub: C] : ( aa(C,filter(A),aa(fun(C,filter(B)),fun(C,filter(A)),aTP_Lamp_afx(fun(A,B),fun(fun(C,filter(B)),fun(C,filter(A))),Uu),Uua),Uub) = filtercomap(A,B,Uu,aa(C,filter(B),Uua,Uub)) ) ).

% ATP.lambda_887
tff(fact_7053_ATP_Olambda__888,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Uu: fun(A,fun(C,bool)),Uua: fun(D,fun(C,fun(B,bool))),Uub: D] : ( aa(D,fun(A,fun(B,bool)),aa(fun(D,fun(C,fun(B,bool))),fun(D,fun(A,fun(B,bool))),aTP_Lamp_arb(fun(A,fun(C,bool)),fun(fun(D,fun(C,fun(B,bool))),fun(D,fun(A,fun(B,bool)))),Uu),Uua),Uub) = aa(fun(C,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(C,bool)),fun(fun(C,fun(B,bool)),fun(A,fun(B,bool))),relcompp(A,C,B),Uu),aa(D,fun(C,fun(B,bool)),Uua,Uub)) ) ).

% ATP.lambda_888
tff(fact_7054_ATP_Olambda__889,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,B),Uua: A,Uub: C] : ( aa(C,product_prod(A,B),aa(A,fun(C,product_prod(A,B)),aTP_Lamp_aka(fun(C,B),fun(A,fun(C,product_prod(A,B))),Uu),Uua),Uub) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),aa(C,B,Uu,Uub)) ) ).

% ATP.lambda_889
tff(fact_7055_ATP_Olambda__890,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Uu: set(product_prod(A,C)),Uua: fun(D,set(product_prod(C,B))),Uub: D] : ( aa(D,set(product_prod(A,B)),aa(fun(D,set(product_prod(C,B))),fun(D,set(product_prod(A,B))),aTP_Lamp_me(set(product_prod(A,C)),fun(fun(D,set(product_prod(C,B))),fun(D,set(product_prod(A,B)))),Uu),Uua),Uub) = relcomp(A,C,B,Uu,aa(D,set(product_prod(C,B)),Uua,Uub)) ) ).

% ATP.lambda_890
tff(fact_7056_ATP_Olambda__891,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(B,A),Uua: fun(C,filter(B)),Uub: C] : ( aa(C,filter(A),aa(fun(C,filter(B)),fun(C,filter(A)),aTP_Lamp_pv(fun(B,A),fun(fun(C,filter(B)),fun(C,filter(A))),Uu),Uua),Uub) = filtermap(B,A,Uu,aa(C,filter(B),Uua,Uub)) ) ).

% ATP.lambda_891
tff(fact_7057_ATP_Olambda__892,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: set(product_prod(B,A)),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_js(set(product_prod(B,A)),fun(fun(C,set(B)),fun(C,set(A))),Uu),Uua),Uub) = aa(set(B),set(A),image(B,A,Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_892
tff(fact_7058_ATP_Olambda__893,axiom,
    ! [A: $tType,Uu: bool,Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_nq(bool,fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(Uu)
       => pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_893
tff(fact_7059_ATP_Olambda__894,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,B),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_gr(fun(A,B),fun(fun(C,set(B)),fun(C,set(A))),Uu),Uua),Uub) = aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_894
tff(fact_7060_ATP_Olambda__895,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: B,Uub: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_hk(fun(B,set(A)),fun(B,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(A),bool,member(A,Uub),aa(B,set(A),Uu,Uua))) ) ).

% ATP.lambda_895
tff(fact_7061_ATP_Olambda__896,axiom,
    ! [I5: $tType,J3: $tType,Uu: I5,Uua: fun(J3,set(I5)),Uub: J3] : ( aa(J3,set(I5),aa(fun(J3,set(I5)),fun(J3,set(I5)),aTP_Lamp_ij(I5,fun(fun(J3,set(I5)),fun(J3,set(I5))),Uu),Uua),Uub) = aa(set(I5),set(I5),insert(I5,Uu),aa(J3,set(I5),Uua,Uub)) ) ).

% ATP.lambda_896
tff(fact_7062_ATP_Olambda__897,axiom,
    ! [B: $tType,A: $tType,Uu: B,Uua: fun(A,set(B)),Uub: A] : ( aa(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_gj(B,fun(fun(A,set(B)),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),insert(B,Uu),aa(A,set(B),Uua,Uub)) ) ).

% ATP.lambda_897
tff(fact_7063_ATP_Olambda__898,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_fi(A,fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),insert(A,Uu),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_898
tff(fact_7064_ATP_Olambda__899,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(B,A),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_gh(fun(B,A),fun(fun(C,set(B)),fun(C,set(A))),Uu),Uua),Uub) = aa(set(B),set(A),image2(B,A,Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_899
tff(fact_7065_ATP_Olambda__900,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,B),Uua: fun(C,set(A)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(A)),fun(C,set(B)),aTP_Lamp_iz(fun(A,B),fun(fun(C,set(A)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(A),set(B),image2(A,B,Uu),aa(C,set(A),Uua,Uub)) ) ).

% ATP.lambda_900
tff(fact_7066_ATP_Olambda__901,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: fun(C,set(D)),Uua: fun(D,B),Uub: C] : ( aa(C,set(B),aa(fun(D,B),fun(C,set(B)),aTP_Lamp_ka(fun(C,set(D)),fun(fun(D,B),fun(C,set(B))),Uu),Uua),Uub) = aa(set(D),set(B),image2(D,B,Uua),aa(C,set(D),Uu,Uub)) ) ) ).

% ATP.lambda_901
tff(fact_7067_ATP_Olambda__902,axiom,
    ! [A: $tType,Uu: bool,Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_np(bool,fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(Uu)
        | pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_902
tff(fact_7068_ATP_Olambda__903,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: bool] :
      ( pp(aa(bool,bool,aa(A,fun(bool,bool),aTP_Lamp_afe(fun(A,bool),fun(A,fun(bool,bool)),Uu),Uua),Uub))
    <=> ( pp(Uub)
        | pp(aa(A,bool,Uu,Uua)) ) ) ).

% ATP.lambda_903
tff(fact_7069_ATP_Olambda__904,axiom,
    ! [A: $tType,Uu: bool,Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_ati(bool,fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(Uu)
        & pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_904
tff(fact_7070_ATP_Olambda__905,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: bool] :
      ( pp(aa(bool,bool,aa(A,fun(bool,bool),aTP_Lamp_adh(fun(A,bool),fun(A,fun(bool,bool)),Uu),Uua),Uub))
    <=> ( pp(Uub)
        & pp(aa(A,bool,Uu,Uua)) ) ) ).

% ATP.lambda_905
tff(fact_7071_ATP_Olambda__906,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(list(A),A),Uua: list(A),Uub: A] :
          ( pp(aa(A,bool,aa(list(A),fun(A,bool),aTP_Lamp_alj(fun(list(A),A),fun(list(A),fun(A,bool)),Uu),Uua),Uub))
        <=> ( Uub = aa(list(A),A,Uu,Uua) ) ) ) ).

% ATP.lambda_906
tff(fact_7072_ATP_Olambda__907,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_er(fun(A,B),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> ( Uub = aa(A,B,Uu,Uua) ) ) ).

% ATP.lambda_907
tff(fact_7073_ATP_Olambda__908,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_vn(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_908
tff(fact_7074_ATP_Olambda__909,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: A] :
      ( pp(aa(A,bool,aa(set(nat),fun(A,bool),aTP_Lamp_akh(list(A),fun(set(nat),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(A),bool,member(A,Uub),aa(list(A),set(A),set2(A),nths(A,Uu,Uua)))) ) ).

% ATP.lambda_909
tff(fact_7075_ATP_Olambda__910,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_bbb(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(set(A),bool,member(A,Uub),aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),Uu,Uua)))) ) ).

% ATP.lambda_910
tff(fact_7076_ATP_Olambda__911,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: fun(B,A),Uub: A] : ( aa(A,set(A),aa(fun(B,A),fun(A,set(A)),aTP_Lamp_afz(set(product_prod(B,B)),fun(fun(B,A),fun(A,set(A))),Uu),Uua),Uub) = aa(set(B),set(A),image2(B,A,Uua),field2(B,Uu)) ) ).

% ATP.lambda_911
tff(fact_7077_ATP_Olambda__912,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: set(A),Uua: set(C),Uub: fun(A,B)] : ( aa(fun(A,B),set(fun(A,C)),aa(set(C),fun(fun(A,B),set(fun(A,C))),aTP_Lamp_agh(set(A),fun(set(C),fun(fun(A,B),set(fun(A,C)))),Uu),Uua),Uub) = bNF_Wellorder_Func(A,C,Uu,Uua) ) ).

% ATP.lambda_912
tff(fact_7078_ATP_Olambda__913,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: A] : ( aa(A,set(A),aa(set(A),fun(A,set(A)),aTP_Lamp_ee(set(A),fun(set(A),fun(A,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uu),Uua) ) ).

% ATP.lambda_913
tff(fact_7079_ATP_Olambda__914,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: set(B),Uub: A] : ( aa(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_bw(set(B),fun(set(B),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),Uu),Uua) ) ).

% ATP.lambda_914
tff(fact_7080_ATP_Olambda__915,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] : ( aa(A,set(A),aa(A,fun(A,set(A)),aTP_Lamp_agc(set(product_prod(A,A)),fun(A,fun(A,set(A))),Uu),Uua),Uub) = order_underS(A,Uu,Uua) ) ).

% ATP.lambda_915
tff(fact_7081_ATP_Olambda__916,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] : ( aa(A,set(A),aa(A,fun(A,set(A)),aTP_Lamp_jg(set(product_prod(A,A)),fun(A,fun(A,set(A))),Uu),Uua),Uub) = order_above(A,Uu,Uua) ) ).

% ATP.lambda_916
tff(fact_7082_ATP_Olambda__917,axiom,
    ! [B: $tType,A: $tType,Uu: set(set(old_node(A,B))),Uua: set(set(old_node(A,B))),Uub: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(set(old_node(A,B))),aa(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),aTP_Lamp_azm(set(set(old_node(A,B))),fun(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B))))),Uu),Uua),Uub) = old_uprod(A,B,Uu,Uua) ) ).

% ATP.lambda_917
tff(fact_7083_ATP_Olambda__918,axiom,
    ! [B: $tType,A: $tType,Uu: set(set(old_node(A,B))),Uua: set(set(old_node(A,B))),Uub: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(set(old_node(A,B))),aa(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),aTP_Lamp_azl(set(set(old_node(A,B))),fun(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B))))),Uu),Uua),Uub) = old_usum(A,B,Uu,Uua) ) ).

% ATP.lambda_918
tff(fact_7084_ATP_Olambda__919,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: set(B),Uua: set(C),Uub: A] : ( aa(A,set(sum_sum(B,C)),aa(set(C),fun(A,set(sum_sum(B,C))),aTP_Lamp_agp(set(B),fun(set(C),fun(A,set(sum_sum(B,C)))),Uu),Uua),Uub) = sum_Plus(B,C,Uu,Uua) ) ).

% ATP.lambda_919
tff(fact_7085_ATP_Olambda__920,axiom,
    ! [A: $tType,Uu: list(A),Uua: A,Uub: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_amz(list(A),fun(A,fun(list(A),list(A))),Uu),Uua),Uub) = append(A,Uub,Uu) ) ).

% ATP.lambda_920
tff(fact_7086_ATP_Olambda__921,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: set(B),Uub: A] : ( aa(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_cz(B,fun(set(B),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),insert(B,Uu),Uua) ) ).

% ATP.lambda_921
tff(fact_7087_ATP_Olambda__922,axiom,
    ! [A: $tType,B: $tType,D: $tType,Uu: fun(D,B),Uua: set(D),Uub: A] : ( aa(A,set(B),aa(set(D),fun(A,set(B)),aTP_Lamp_em(fun(D,B),fun(set(D),fun(A,set(B))),Uu),Uua),Uub) = aa(set(D),set(B),image2(D,B,Uu),Uua) ) ).

% ATP.lambda_922
tff(fact_7088_ATP_Olambda__923,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: set(B),Uub: A] : ( aa(A,set(A),aa(set(B),fun(A,set(A)),aTP_Lamp_cn(fun(B,A),fun(set(B),fun(A,set(A))),Uu),Uua),Uub) = aa(set(B),set(A),image2(B,A,Uu),Uua) ) ).

% ATP.lambda_923
tff(fact_7089_ATP_Olambda__924,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_tu(fun(A,nat),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),if(nat,aa(A,bool,aa(A,fun(A,bool),fequal(A),Uub),Uua),aa(nat,nat,suc,aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uub)))) ) ).

% ATP.lambda_924
tff(fact_7090_ATP_Olambda__925,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_tn(fun(A,nat),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),if(nat,aa(A,bool,Uua,Uub),aa(A,nat,Uu,Uub),zero_zero(nat)))) ) ).

% ATP.lambda_925
tff(fact_7091_ATP_Olambda__926,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: ref(A),Uua: A,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(A,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_axr(ref(A),fun(A,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(product_unit,fun(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),product_Pair(product_unit,product_prod(heap_ext(product_unit),nat)),product_Unity),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),aa(heap_ext(product_unit),heap_ext(product_unit),ref_set(A,Uu,Uua),Uub)),one_one(nat))) ) ) ).

% ATP.lambda_926
tff(fact_7092_ATP_Olambda__927,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,nat),fun(A,bool),aTP_Lamp_tv(fun(A,nat),fun(fun(A,nat),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uua,Uub)))) ) ).

% ATP.lambda_927
tff(fact_7093_ATP_Olambda__928,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: fun(A,bool),Uub: B] :
      ( pp(aa(B,bool,aa(fun(A,bool),fun(B,bool),aTP_Lamp_ayh(fun(A,B),fun(fun(A,bool),fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(A,bool,Uua,hilbert_inv_into(A,B,top_top(set(A)),Uu,Uub))) ) ).

% ATP.lambda_928
tff(fact_7094_ATP_Olambda__929,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),Uua: fun(A,B),Uub: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C,aa(fun(A,B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),aTP_Lamp_bbs(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(A,B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C)),Uu),Uua),Uub) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C,Uu,aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),comp(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit),map_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(B,product_prod(heap_ext(product_unit),nat)),product_map_prod(A,B,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),Uua,id(product_prod(heap_ext(product_unit),nat))))),Uub)) ) ).

% ATP.lambda_929
tff(fact_7095_ATP_Olambda__930,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_uz(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_930
tff(fact_7096_ATP_Olambda__931,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_uy(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_931
tff(fact_7097_ATP_Olambda__932,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ast(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ).

% ATP.lambda_932
tff(fact_7098_ATP_Olambda__933,axiom,
    ! [Uu: fun(nat,bool),Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_xg(fun(nat,bool),fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(nat,bool,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua))) ) ).

% ATP.lambda_933
tff(fact_7099_ATP_Olambda__934,axiom,
    ! [A: $tType,Uu: fun(nat,set(A)),Uua: nat,Uub: nat] : ( aa(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_sj(fun(nat,set(A)),fun(nat,fun(nat,set(A))),Uu),Uua),Uub) = aa(nat,set(A),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_934
tff(fact_7100_ATP_Olambda__935,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_se(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_935
tff(fact_7101_ATP_Olambda__936,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_sd(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_936
tff(fact_7102_ATP_Olambda__937,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_asn(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_937
tff(fact_7103_ATP_Olambda__938,axiom,
    ! [A: $tType,B: $tType,Uu: fun(product_prod(A,B),bool),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_ado(fun(product_prod(A,B),bool),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(product_prod(A,B),bool,Uu,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uub))) ) ).

% ATP.lambda_938
tff(fact_7104_ATP_Olambda__939,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(product_prod(A,B),C),Uua: A,Uub: B] : ( aa(B,C,aa(A,fun(B,C),aTP_Lamp_dr(fun(product_prod(A,B),C),fun(A,fun(B,C)),Uu),Uua),Uub) = aa(product_prod(A,B),C,Uu,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uub)) ) ).

% ATP.lambda_939
tff(fact_7105_ATP_Olambda__940,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: list(A),Uub: nat] :
      ( pp(aa(nat,bool,aa(list(A),fun(nat,bool),aTP_Lamp_and(fun(A,bool),fun(list(A),fun(nat,bool)),Uu),Uua),Uub))
    <=> pp(aa(A,bool,Uu,aa(nat,A,nth(A,Uua),Uub))) ) ).

% ATP.lambda_940
tff(fact_7106_ATP_Olambda__941,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: fun(multiset(A),B),Uua: fun(C,multiset(A)),Uub: C] : ( aa(C,B,aa(fun(C,multiset(A)),fun(C,B),aTP_Lamp_att(fun(multiset(A),B),fun(fun(C,multiset(A)),fun(C,B)),Uu),Uua),Uub) = aa(multiset(A),B,Uu,aa(C,multiset(A),Uua,Uub)) ) ) ).

% ATP.lambda_941
tff(fact_7107_ATP_Olambda__942,axiom,
    ! [V3: $tType,U3: $tType,T: $tType,Uu: fun(U3,set(V3)),Uua: fun(T,U3),Uub: T] : ( aa(T,set(V3),aa(fun(T,U3),fun(T,set(V3)),aTP_Lamp_gg(fun(U3,set(V3)),fun(fun(T,U3),fun(T,set(V3))),Uu),Uua),Uub) = aa(U3,set(V3),Uu,aa(T,U3,Uua,Uub)) ) ).

% ATP.lambda_942
tff(fact_7108_ATP_Olambda__943,axiom,
    ! [D: $tType,F10: $tType,B: $tType,Uu: fun(F10,fun(D,bool)),Uua: fun(B,F10),Uub: B] : ( aa(B,fun(D,bool),aa(fun(B,F10),fun(B,fun(D,bool)),aTP_Lamp_aou(fun(F10,fun(D,bool)),fun(fun(B,F10),fun(B,fun(D,bool))),Uu),Uua),Uub) = aa(F10,fun(D,bool),Uu,aa(B,F10,Uua,Uub)) ) ).

% ATP.lambda_943
tff(fact_7109_ATP_Olambda__944,axiom,
    ! [C: $tType,E: $tType,A: $tType,Uu: fun(E,fun(C,bool)),Uua: fun(A,E),Uub: A] : ( aa(A,fun(C,bool),aa(fun(A,E),fun(A,fun(C,bool)),aTP_Lamp_aot(fun(E,fun(C,bool)),fun(fun(A,E),fun(A,fun(C,bool))),Uu),Uua),Uub) = aa(E,fun(C,bool),Uu,aa(A,E,Uua,Uub)) ) ).

% ATP.lambda_944
tff(fact_7110_ATP_Olambda__945,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(C,fun(B,bool)),Uua: fun(A,C),Uub: A] : ( aa(A,fun(B,bool),aa(fun(A,C),fun(A,fun(B,bool)),aTP_Lamp_fn(fun(C,fun(B,bool)),fun(fun(A,C),fun(A,fun(B,bool))),Uu),Uua),Uub) = aa(C,fun(B,bool),Uu,aa(A,C,Uua,Uub)) ) ).

% ATP.lambda_945
tff(fact_7111_ATP_Olambda__946,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(C,D),Uua: fun(B,C),Uub: B] : ( aa(B,D,aa(fun(B,C),fun(B,D),aTP_Lamp_awi(fun(C,D),fun(fun(B,C),fun(B,D)),Uu),Uua),Uub) = aa(C,D,Uu,aa(B,C,Uua,Uub)) ) ).

% ATP.lambda_946
tff(fact_7112_ATP_Olambda__947,axiom,
    ! [D: $tType,C: $tType,A: $tType,Uu: fun(C,D),Uua: fun(A,C),Uub: A] : ( aa(A,D,aa(fun(A,C),fun(A,D),aTP_Lamp_awh(fun(C,D),fun(fun(A,C),fun(A,D)),Uu),Uua),Uub) = aa(C,D,Uu,aa(A,C,Uua,Uub)) ) ).

% ATP.lambda_947
tff(fact_7113_ATP_Olambda__948,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,A),Uua: fun(B,C),Uub: B] : ( aa(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_cj(fun(C,A),fun(fun(B,C),fun(B,A)),Uu),Uua),Uub) = aa(C,A,Uu,aa(B,C,Uua,Uub)) ) ).

% ATP.lambda_948
tff(fact_7114_ATP_Olambda__949,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,bool),Uua: fun(A,B),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_atl(fun(B,bool),fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(B,bool,Uu,aa(A,B,Uua,Uub))) ) ).

% ATP.lambda_949
tff(fact_7115_ATP_Olambda__950,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(B,C),Uua: fun(A,B),Uub: A] : ( aa(A,C,aa(fun(A,B),fun(A,C),aTP_Lamp_abp(fun(B,C),fun(fun(A,B),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uu,aa(A,B,Uua,Uub)) ) ).

% ATP.lambda_950
tff(fact_7116_ATP_Olambda__951,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(B,A),Uua: fun(C,B),Uub: C] : ( aa(C,A,aa(fun(C,B),fun(C,A),aTP_Lamp_cc(fun(B,A),fun(fun(C,B),fun(C,A)),Uu),Uua),Uub) = aa(B,A,Uu,aa(C,B,Uua,Uub)) ) ).

% ATP.lambda_951
tff(fact_7117_ATP_Olambda__952,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_kp(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_952
tff(fact_7118_ATP_Olambda__953,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_lg(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_953
tff(fact_7119_ATP_Olambda__954,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(A) )
     => ! [Uu: fun(A,B),Uua: fun(B,A),Uub: B] : ( aa(B,B,aa(fun(B,A),fun(B,B),aTP_Lamp_mr(fun(A,B),fun(fun(B,A),fun(B,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_954
tff(fact_7120_ATP_Olambda__955,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,bool),Uua: fun(B,A),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_ns(fun(A,bool),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(A,bool,Uu,aa(B,A,Uua,Uub))) ) ).

% ATP.lambda_955
tff(fact_7121_ATP_Olambda__956,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(C,A),Uub: C] : ( aa(C,fun(B,bool),aa(fun(C,A),fun(C,fun(B,bool)),aTP_Lamp_aog(fun(A,fun(B,bool)),fun(fun(C,A),fun(C,fun(B,bool))),Uu),Uua),Uub) = aa(A,fun(B,bool),Uu,aa(C,A,Uua,Uub)) ) ).

% ATP.lambda_956
tff(fact_7122_ATP_Olambda__957,axiom,
    ! [B: $tType,C: $tType,A: $tType,D: $tType,Uu: fun(A,fun(B,C)),Uua: fun(D,A),Uub: D] : ( aa(D,fun(B,C),aa(fun(D,A),fun(D,fun(B,C)),aTP_Lamp_dl(fun(A,fun(B,C)),fun(fun(D,A),fun(D,fun(B,C))),Uu),Uua),Uub) = aa(A,fun(B,C),Uu,aa(D,A,Uua,Uub)) ) ).

% ATP.lambda_957
tff(fact_7123_ATP_Olambda__958,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(num,A),Uub: num] : ( aa(num,B,aa(fun(num,A),fun(num,B),aTP_Lamp_abm(fun(A,B),fun(fun(num,A),fun(num,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(num,A,Uua,Uub)) ) ).

% ATP.lambda_958
tff(fact_7124_ATP_Olambda__959,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(nat,A),Uub: nat] : ( aa(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_zq(fun(A,B),fun(fun(nat,A),fun(nat,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(nat,A,Uua,Uub)) ) ).

% ATP.lambda_959
tff(fact_7125_ATP_Olambda__960,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_nc(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ).

% ATP.lambda_960
tff(fact_7126_ATP_Olambda__961,axiom,
    ! [C: $tType,D: $tType,Uu: fun(D,C),Uua: fun(C,bool),Uub: D] :
      ( pp(aa(D,bool,aa(fun(C,bool),fun(D,bool),aTP_Lamp_arp(fun(D,C),fun(fun(C,bool),fun(D,bool)),Uu),Uua),Uub))
    <=> pp(aa(C,bool,Uua,aa(D,C,Uu,Uub))) ) ).

% ATP.lambda_961
tff(fact_7127_ATP_Olambda__962,axiom,
    ! [D: $tType,C: $tType,Uu: fun(C,D),Uua: fun(D,bool),Uub: C] :
      ( pp(aa(C,bool,aa(fun(D,bool),fun(C,bool),aTP_Lamp_arq(fun(C,D),fun(fun(D,bool),fun(C,bool)),Uu),Uua),Uub))
    <=> pp(aa(D,bool,Uua,aa(C,D,Uu,Uub))) ) ).

% ATP.lambda_962
tff(fact_7128_ATP_Olambda__963,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,C),Uua: fun(C,A),Uub: B] : ( aa(B,A,aa(fun(C,A),fun(B,A),aTP_Lamp_pb(fun(B,C),fun(fun(C,A),fun(B,A)),Uu),Uua),Uub) = aa(C,A,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_963
tff(fact_7129_ATP_Olambda__964,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,C),Uua: fun(C,A),Uub: B] : ( aa(B,A,aa(fun(C,A),fun(B,A),aTP_Lamp_pc(fun(B,C),fun(fun(C,A),fun(B,A)),Uu),Uua),Uub) = aa(C,A,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_964
tff(fact_7130_ATP_Olambda__965,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(B,C),Uua: fun(C,A),Uub: B] : ( aa(B,A,aa(fun(C,A),fun(B,A),aTP_Lamp_aso(fun(B,C),fun(fun(C,A),fun(B,A)),Uu),Uua),Uub) = aa(C,A,Uua,aa(B,C,Uu,Uub)) ) ).

% ATP.lambda_965
tff(fact_7131_ATP_Olambda__966,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(A,C),Uub: B] : ( aa(B,C,aa(fun(A,C),fun(B,C),aTP_Lamp_le(fun(B,A),fun(fun(A,C),fun(B,C)),Uu),Uua),Uub) = aa(A,C,Uua,aa(B,A,Uu,Uub)) ) ).

% ATP.lambda_966
tff(fact_7132_ATP_Olambda__967,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [Uu: fun(A,B),Uua: fun(B,A),Uub: A] : ( aa(A,A,aa(fun(B,A),fun(A,A),aTP_Lamp_mq(fun(A,B),fun(fun(B,A),fun(A,A)),Uu),Uua),Uub) = aa(B,A,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_967
tff(fact_7133_ATP_Olambda__968,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(B,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(B,bool),fun(A,bool),aTP_Lamp_bl(fun(A,B),fun(fun(B,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(B,bool,Uua,aa(A,B,Uu,Uub))) ) ).

% ATP.lambda_968
tff(fact_7134_ATP_Olambda__969,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( semiring_1(C)
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_rr(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_969
tff(fact_7135_ATP_Olambda__970,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_afw(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ).

% ATP.lambda_970
tff(fact_7136_ATP_Olambda__971,axiom,
    ! [T: $tType,Uu: fun(code_natural,T),Uua: code_natural,Uub: T] : ( aa(T,T,aa(code_natural,fun(T,T),aTP_Lamp_axt(fun(code_natural,T),fun(code_natural,fun(T,T)),Uu),Uua),Uub) = aa(code_natural,T,Uu,Uua) ) ).

% ATP.lambda_971
tff(fact_7137_ATP_Olambda__972,axiom,
    ! [A: $tType,B: $tType,D: $tType,Uu: fun(D,set(B)),Uua: D,Uub: A] : ( aa(A,set(B),aa(D,fun(A,set(B)),aTP_Lamp_fp(fun(D,set(B)),fun(D,fun(A,set(B))),Uu),Uua),Uub) = aa(D,set(B),Uu,Uua) ) ).

% ATP.lambda_972
tff(fact_7138_ATP_Olambda__973,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(C,fun(A,C)),Uua: C,Uub: B] : ( aa(B,fun(A,C),aa(C,fun(B,fun(A,C)),aTP_Lamp_ajo(fun(C,fun(A,C)),fun(C,fun(B,fun(A,C))),Uu),Uua),Uub) = aa(C,fun(A,C),Uu,Uua) ) ).

% ATP.lambda_973
tff(fact_7139_ATP_Olambda__974,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,bool),Uua: B,Uub: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_qv(fun(B,bool),fun(B,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(B,bool,Uu,Uua)) ) ).

% ATP.lambda_974
tff(fact_7140_ATP_Olambda__975,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,bool),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_awm(fun(A,bool),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(A,bool,Uu,Uua)) ) ).

% ATP.lambda_975
tff(fact_7141_ATP_Olambda__976,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(A,C),Uua: A,Uub: B] : ( aa(B,C,aa(A,fun(B,C),aTP_Lamp_dd(fun(A,C),fun(A,fun(B,C)),Uu),Uua),Uub) = aa(A,C,Uu,Uua) ) ).

% ATP.lambda_976
tff(fact_7142_ATP_Olambda__977,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(A,B),Uua: A,Uub: C] : ( aa(C,B,aa(A,fun(C,B),aTP_Lamp_di(fun(A,B),fun(A,fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,Uua) ) ).

% ATP.lambda_977
tff(fact_7143_ATP_Olambda__978,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: fun(B,heap_Time_Heap(A)),Uub: product_unit] : ( aa(product_unit,heap_Time_Heap(A),aa(fun(B,heap_Time_Heap(A)),fun(product_unit,heap_Time_Heap(A)),aTP_Lamp_axe(B,fun(fun(B,heap_Time_Heap(A)),fun(product_unit,heap_Time_Heap(A))),Uu),Uua),Uub) = aa(B,heap_Time_Heap(A),Uua,Uu) ) ).

% ATP.lambda_978
tff(fact_7144_ATP_Olambda__979,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] : ( aa(A,fun(product_prod(A,A),bool),aa(A,fun(A,fun(product_prod(A,A),bool)),aTP_Lamp_ji(set(product_prod(A,A)),fun(A,fun(A,fun(product_prod(A,A),bool))),Uu),Uua),Uub) = aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(A,fun(A,fun(A,bool)),aa(A,fun(A,fun(A,fun(A,bool))),aTP_Lamp_jh(set(product_prod(A,A)),fun(A,fun(A,fun(A,fun(A,bool)))),Uu),Uua),Uub)) ) ).

% ATP.lambda_979
tff(fact_7145_ATP_Olambda__980,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: option(A)] : ( aa(option(A),option(A),aa(A,fun(option(A),option(A)),aTP_Lamp_ahf(fun(A,fun(A,A)),fun(A,fun(option(A),option(A))),Uu),Uua),Uub) = aa(A,option(A),some(A),case_option(A,A,Uua,aa(A,fun(A,A),Uu,Uua),Uub)) ) ).

% ATP.lambda_980
tff(fact_7146_ATP_Olambda__981,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: A] : ( aa(A,option(A),aa(A,fun(A,option(A)),aTP_Lamp_aun(fun(A,fun(A,A)),fun(A,fun(A,option(A))),Uu),Uua),Uub) = aa(A,option(A),some(A),aa(A,A,aa(A,fun(A,A),Uu,Uua),Uub)) ) ).

% ATP.lambda_981
tff(fact_7147_ATP_Olambda__982,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,fun(B,fun(C,bool))),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_awo(fun(A,fun(B,fun(C,bool))),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> ? [X_12: C] : pp(aa(C,bool,aa(B,fun(C,bool),aa(A,fun(B,fun(C,bool)),Uu,Uua),Uub),X_12)) ) ).

% ATP.lambda_982
tff(fact_7148_ATP_Olambda__983,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: multiset(B),Uub: C] : ( aa(C,A,aa(multiset(B),fun(C,A),aTP_Lamp_aqr(fun(B,fun(C,A)),fun(multiset(B),fun(C,A)),Uu),Uua),Uub) = aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,aa(C,fun(B,A),aTP_Lamp_on(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uub)),Uua)) ) ) ).

% ATP.lambda_983
tff(fact_7149_ATP_Olambda__984,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: multiset(B),Uub: C] : ( aa(C,A,aa(multiset(B),fun(C,A),aTP_Lamp_apn(fun(B,fun(C,A)),fun(multiset(B),fun(C,A)),Uu),Uua),Uub) = comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aa(C,fun(B,A),aTP_Lamp_ok(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uub)),Uua)) ) ) ).

% ATP.lambda_984
tff(fact_7150_ATP_Olambda__985,axiom,
    ! [B: $tType,C: $tType,A: $tType,E: $tType,D: $tType,Uu: fun(B,fun(C,fun(D,fun(E,set(A))))),Uua: set(product_prod(D,E)),Uub: product_prod(B,C)] : ( aa(product_prod(B,C),set(A),aa(set(product_prod(D,E)),fun(product_prod(B,C),set(A)),aTP_Lamp_hq(fun(B,fun(C,fun(D,fun(E,set(A))))),fun(set(product_prod(D,E)),fun(product_prod(B,C),set(A))),Uu),Uua),Uub) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(product_prod(D,E)),set(set(A)),image2(product_prod(D,E),set(A),aa(product_prod(B,C),fun(product_prod(D,E),set(A)),aTP_Lamp_hp(fun(B,fun(C,fun(D,fun(E,set(A))))),fun(product_prod(B,C),fun(product_prod(D,E),set(A))),Uu),Uub)),Uua)) ) ).

% ATP.lambda_985
tff(fact_7151_ATP_Olambda__986,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(B),Uub: C] : ( aa(C,A,aa(set(B),fun(C,A),aTP_Lamp_fu(fun(B,fun(C,A)),fun(set(B),fun(C,A)),Uu),Uua),Uub) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(C,fun(B,A),aTP_Lamp_ft(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uub)),Uua)) ) ) ).

% ATP.lambda_986
tff(fact_7152_ATP_Olambda__987,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(B),Uub: C] : ( aa(C,A,aa(set(B),fun(C,A),aTP_Lamp_ic(fun(B,fun(C,A)),fun(set(B),fun(C,A)),Uu),Uua),Uub) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(C,fun(B,A),aTP_Lamp_ft(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uub)),Uua)) ) ) ).

% ATP.lambda_987
tff(fact_7153_ATP_Olambda__988,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: multiset(C),Uub: B] : ( aa(B,A,aa(multiset(C),fun(B,A),aTP_Lamp_aqq(fun(B,fun(C,A)),fun(multiset(C),fun(B,A)),Uu),Uua),Uub) = aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(C),multiset(A),image_mset(C,A,aa(B,fun(C,A),Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_988
tff(fact_7154_ATP_Olambda__989,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: multiset(C),Uub: B] : ( aa(B,A,aa(multiset(C),fun(B,A),aTP_Lamp_apm(fun(B,fun(C,A)),fun(multiset(C),fun(B,A)),Uu),Uua),Uub) = comm_m7189776963980413722m_mset(A,aa(multiset(C),multiset(A),image_mset(C,A,aa(B,fun(C,A),Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_989
tff(fact_7155_ATP_Olambda__990,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(C),Uub: B] : ( aa(B,A,aa(set(C),fun(B,A),aTP_Lamp_fs(fun(B,fun(C,A)),fun(set(C),fun(B,A)),Uu),Uua),Uub) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,aa(B,fun(C,A),Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_990
tff(fact_7156_ATP_Olambda__991,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,fun(B,set(C))),Uua: set(B),Uub: A] : ( aa(A,set(C),aa(set(B),fun(A,set(C)),aTP_Lamp_kn(fun(A,fun(B,set(C))),fun(set(B),fun(A,set(C))),Uu),Uua),Uub) = aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),aa(A,fun(B,set(C)),Uu,Uub)),Uua)) ) ).

% ATP.lambda_991
tff(fact_7157_ATP_Olambda__992,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(C),Uub: B] : ( aa(B,A,aa(set(C),fun(B,A),aTP_Lamp_ib(fun(B,fun(C,A)),fun(set(C),fun(B,A)),Uu),Uua),Uub) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,aa(B,fun(C,A),Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_992
tff(fact_7158_ATP_Olambda__993,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: B,Uub: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_lb(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
    <=> ( aa(A,B,Uu,Uub) != Uua ) ) ).

% ATP.lambda_993
tff(fact_7159_ATP_Olambda__994,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: fun(A,B),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_lc(B,fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
    <=> ( aa(A,B,Uua,Uub) != Uu ) ) ).

% ATP.lambda_994
tff(fact_7160_ATP_Olambda__995,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),Uua: set(old_node(A,B)),Uub: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_azg(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),Uu),Uua),Uub) = aa(set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),complete_Sup_Sup(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),image2(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),fun(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),product_case_prod(set(old_node(A,B)),set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),aTP_Lamp_azf(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))))),Uua),Uub))),Uu)) ) ).

% ATP.lambda_995
tff(fact_7161_ATP_Olambda__996,axiom,
    ! [S5: $tType,R4: $tType,Q6: $tType,Uu: fun(R4,set(S5)),Uua: fun(Q6,set(R4)),Uub: Q6] : ( aa(Q6,set(S5),aa(fun(Q6,set(R4)),fun(Q6,set(S5)),aTP_Lamp_fy(fun(R4,set(S5)),fun(fun(Q6,set(R4)),fun(Q6,set(S5))),Uu),Uua),Uub) = aa(set(set(S5)),set(S5),complete_Sup_Sup(set(S5)),aa(set(R4),set(set(S5)),image2(R4,set(S5),Uu),aa(Q6,set(R4),Uua,Uub))) ) ).

% ATP.lambda_996
tff(fact_7162_ATP_Olambda__997,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_fz(fun(B,set(A)),fun(fun(C,set(B)),fun(C,set(A))),Uu),Uua),Uub) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),Uu),aa(C,set(B),Uua,Uub))) ) ).

% ATP.lambda_997
tff(fact_7163_ATP_Olambda__998,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,set(B)),Uub: C] : ( aa(C,A,aa(fun(C,set(B)),fun(C,A),aTP_Lamp_fo(fun(B,A),fun(fun(C,set(B)),fun(C,A)),Uu),Uua),Uub) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,Uu),aa(C,set(B),Uua,Uub))) ) ) ).

% ATP.lambda_998
tff(fact_7164_ATP_Olambda__999,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: fun(C,set(D)),Uua: fun(D,B),Uub: C] : ( aa(C,B,aa(fun(D,B),fun(C,B),aTP_Lamp_kb(fun(C,set(D)),fun(fun(D,B),fun(C,B)),Uu),Uua),Uub) = aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,Uua),aa(C,set(D),Uu,Uub))) ) ) ).

% ATP.lambda_999
tff(fact_7165_ATP_Olambda__1000,axiom,
    ! [S5: $tType,R4: $tType,Q6: $tType,Uu: fun(R4,set(S5)),Uua: fun(Q6,set(R4)),Uub: Q6] : ( aa(Q6,set(S5),aa(fun(Q6,set(R4)),fun(Q6,set(S5)),aTP_Lamp_iq(fun(R4,set(S5)),fun(fun(Q6,set(R4)),fun(Q6,set(S5))),Uu),Uua),Uub) = aa(set(set(S5)),set(S5),complete_Inf_Inf(set(S5)),aa(set(R4),set(set(S5)),image2(R4,set(S5),Uu),aa(Q6,set(R4),Uua,Uub))) ) ).

% ATP.lambda_1000
tff(fact_7166_ATP_Olambda__1001,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: fun(C,set(D)),Uua: fun(D,B),Uub: C] : ( aa(C,B,aa(fun(D,B),fun(C,B),aTP_Lamp_kc(fun(C,set(D)),fun(fun(D,B),fun(C,B)),Uu),Uua),Uub) = aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,Uua),aa(C,set(D),Uu,Uub))) ) ) ).

% ATP.lambda_1001
tff(fact_7167_ATP_Olambda__1002,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_zb(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),dvd_dvd(A),Uua),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_1002
tff(fact_7168_ATP_Olambda__1003,axiom,
    ! [A: $tType,B: $tType,D: $tType,Uu: fun(D,set(B)),Uua: set(D),Uub: A] : ( aa(A,set(B),aa(set(D),fun(A,set(B)),aTP_Lamp_fr(fun(D,set(B)),fun(set(D),fun(A,set(B))),Uu),Uua),Uub) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),Uu),Uua)) ) ).

% ATP.lambda_1003
tff(fact_7169_ATP_Olambda__1004,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: product_unit] : ( aa(product_unit,heap_Time_Heap(A),aa(A,fun(product_unit,heap_Time_Heap(A)),aTP_Lamp_axn(fun(A,A),fun(A,fun(product_unit,heap_Time_Heap(A))),Uu),Uua),Uub) = aa(A,heap_Time_Heap(A),heap_Time_return(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_1004
tff(fact_7170_ATP_Olambda__1005,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: B,Uub: list(B)] : ( aa(list(B),fun(list(A),list(A)),aa(B,fun(list(B),fun(list(A),list(A))),aTP_Lamp_aop(fun(B,A),fun(B,fun(list(B),fun(list(A),list(A)))),Uu),Uua),Uub) = aa(A,fun(list(A),list(A)),cons(A),aa(B,A,Uu,Uua)) ) ).

% ATP.lambda_1005
tff(fact_7171_ATP_Olambda__1006,axiom,
    ! [B: $tType,A: $tType,Uu: set(B),Uua: fun(A,fun(B,bool)),Uub: A] : ( aa(A,nat,aa(fun(A,fun(B,bool)),fun(A,nat),aTP_Lamp_rn(set(B),fun(fun(A,fun(B,bool)),fun(A,nat)),Uu),Uua),Uub) = aa(set(B),nat,finite_card(B),aa(fun(B,bool),set(B),collect(B),aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aTP_Lamp_rm(set(B),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),Uu),Uua),Uub))) ) ).

% ATP.lambda_1006
tff(fact_7172_ATP_Olambda__1007,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,fun(B,fun(C,bool))),Uua: A,Uub: C] :
      ( pp(aa(C,bool,aa(A,fun(C,bool),aTP_Lamp_awp(fun(A,fun(B,fun(C,bool))),fun(A,fun(C,bool)),Uu),Uua),Uub))
    <=> ? [B5: B] : pp(aa(C,bool,aa(B,fun(C,bool),aa(A,fun(B,fun(C,bool)),Uu,Uua),B5),Uub)) ) ).

% ATP.lambda_1007
tff(fact_7173_ATP_Olambda__1008,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,fun(B,fun(C,bool))),Uua: B,Uub: C] :
      ( pp(aa(C,bool,aa(B,fun(C,bool),aTP_Lamp_awq(fun(A,fun(B,fun(C,bool))),fun(B,fun(C,bool)),Uu),Uua),Uub))
    <=> ? [A6: A] : pp(aa(C,bool,aa(B,fun(C,bool),aa(A,fun(B,fun(C,bool)),Uu,A6),Uua),Uub)) ) ).

% ATP.lambda_1008
tff(fact_7174_ATP_Olambda__1009,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,fun(B,C)),Uua: set(C),Uub: A] :
      ( pp(aa(A,bool,aa(set(C),fun(A,bool),aTP_Lamp_ed(fun(A,fun(B,C)),fun(set(C),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [B5: B] : pp(aa(set(C),bool,member(C,aa(B,C,aa(A,fun(B,C),Uu,Uub),B5)),Uua)) ) ).

% ATP.lambda_1009
tff(fact_7175_ATP_Olambda__1010,axiom,
    ! [A: $tType,B: $tType,Uu: list(A),Uua: list(B),Uub: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(list(B),fun(product_prod(A,B),bool),aTP_Lamp_ajl(list(A),fun(list(B),fun(product_prod(A,B),bool)),Uu),Uua),Uub))
    <=> ? [I6: nat] :
          ( ( Uub = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(nat,A,nth(A,Uu),I6)),aa(nat,B,nth(B,Uua),I6)) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I6),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Uu)),aa(list(B),nat,size_size(list(B)),Uua)))) ) ) ).

% ATP.lambda_1010
tff(fact_7176_ATP_Olambda__1011,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(A,B),Uub: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(fun(A,B),fun(product_prod(A,B),bool),aTP_Lamp_ex(set(A),fun(fun(A,B),fun(product_prod(A,B),bool)),Uu),Uua),Uub))
    <=> ? [A6: A] :
          ( ( Uub = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A6),aa(A,B,Uua,A6)) )
          & pp(aa(set(A),bool,member(A,A6),Uu)) ) ) ).

% ATP.lambda_1011
tff(fact_7177_ATP_Olambda__1012,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: A] :
      ( pp(aa(A,bool,aa(set(nat),fun(A,bool),aTP_Lamp_ajs(list(A),fun(set(nat),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [I6: nat] :
          ( ( Uub = aa(nat,A,nth(A,Uu),I6) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I6),aa(list(A),nat,size_size(list(A)),Uu)))
          & pp(aa(set(nat),bool,member(nat,I6),Uua)) ) ) ).

% ATP.lambda_1012
tff(fact_7178_ATP_Olambda__1013,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A),Uub: A] :
      ( pp(aa(A,bool,aa(list(A),fun(A,bool),aTP_Lamp_aof(nat,fun(list(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [I6: nat] :
          ( ( Uub = aa(nat,A,nth(A,Uua),I6) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uu),I6))
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I6),aa(list(A),nat,size_size(list(A)),Uua))) ) ) ).

% ATP.lambda_1013
tff(fact_7179_ATP_Olambda__1014,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,set(B)),Uub: B] :
      ( pp(aa(B,bool,aa(fun(A,set(B)),fun(B,bool),aTP_Lamp_ahl(set(A),fun(fun(A,set(B)),fun(B,bool)),Uu),Uua),Uub))
    <=> ? [X3: set(B)] :
          ( pp(aa(set(set(B)),bool,member(set(B),X3),aa(set(A),set(set(B)),image2(A,set(B),Uua),Uu)))
          & pp(aa(set(B),bool,member(B,Uub),X3)) ) ) ).

% ATP.lambda_1014
tff(fact_7180_ATP_Olambda__1015,axiom,
    ! [A: $tType,Uu: set(set(product_prod(A,A))),Uua: set(product_prod(A,A)),Uub: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),aTP_Lamp_ago(set(set(product_prod(A,A))),fun(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool)),Uu),Uua),Uub))
    <=> ? [R7: set(product_prod(A,A))] :
          ( ( Uub = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R7),Uua) )
          & pp(aa(set(set(product_prod(A,A))),bool,member(set(product_prod(A,A)),R7),Uu)) ) ) ).

% ATP.lambda_1015
tff(fact_7181_ATP_Olambda__1016,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Uu: set(A),Uua: A,Uub: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ob(set(A),fun(A,fun(A,bool)),Uu),Uua),Uub))
        <=> ? [A6: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),sup_sup(A),Uua),A6) )
              & pp(aa(set(A),bool,member(A,A6),Uu)) ) ) ) ).

% ATP.lambda_1016
tff(fact_7182_ATP_Olambda__1017,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [Uu: A,Uua: set(A),Uub: A] :
          ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_hf(A,fun(set(A),fun(A,bool)),Uu),Uua),Uub))
        <=> ? [B5: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uu),B5) )
              & pp(aa(set(A),bool,member(A,B5),Uua)) ) ) ) ).

% ATP.lambda_1017
tff(fact_7183_ATP_Olambda__1018,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Uu: set(A),Uua: A,Uub: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ng(set(A),fun(A,fun(A,bool)),Uu),Uua),Uub))
        <=> ? [A6: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uua),A6) )
              & pp(aa(set(A),bool,member(A,A6),Uu)) ) ) ) ).

% ATP.lambda_1018
tff(fact_7184_ATP_Olambda__1019,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: multiset(A),Uub: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_auc(set(multiset(A)),fun(multiset(A),fun(multiset(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: multiset(A)] :
          ( ( Uub = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),Uua),A6) )
          & pp(aa(set(multiset(A)),bool,member(multiset(A),A6),Uu)) ) ) ).

% ATP.lambda_1019
tff(fact_7185_ATP_Olambda__1020,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: multiset(A),Uub: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_aty(set(multiset(A)),fun(multiset(A),fun(multiset(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: multiset(A)] :
          ( ( Uub = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),Uua),A6) )
          & pp(aa(set(multiset(A)),bool,member(multiset(A),A6),Uu)) ) ) ).

% ATP.lambda_1020
tff(fact_7186_ATP_Olambda__1021,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: list(B),Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(list(B),fun(set(A),bool),aTP_Lamp_ajk(fun(B,set(A)),fun(list(B),fun(set(A),bool)),Uu),Uua),Uub))
    <=> ? [I6: nat] :
          ( ( Uub = aa(B,set(A),Uu,aa(nat,B,nth(B,Uua),I6)) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I6),aa(list(B),nat,size_size(list(B)),Uua))) ) ) ).

% ATP.lambda_1021
tff(fact_7187_ATP_Olambda__1022,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: list(B),Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(list(B),fun(set(A),bool),aTP_Lamp_ajr(fun(B,set(A)),fun(list(B),fun(set(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: B] :
          ( ( Uub = aa(B,set(A),Uu,A6) )
          & pp(aa(set(B),bool,member(B,A6),aa(list(B),set(B),set2(B),Uua))) ) ) ).

% ATP.lambda_1022
tff(fact_7188_ATP_Olambda__1023,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: set(B),Uub: A] :
      ( pp(aa(A,bool,aa(set(B),fun(A,bool),aTP_Lamp_ch(fun(B,A),fun(set(B),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [X3: B] :
          ( ( Uub = aa(B,A,Uu,X3) )
          & pp(aa(set(B),bool,member(B,X3),Uua)) ) ) ).

% ATP.lambda_1023
tff(fact_7189_ATP_Olambda__1024,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,set(C)),Uua: fun(C,bool),Uub: B] :
      ( pp(aa(B,bool,aa(fun(C,bool),fun(B,bool),aTP_Lamp_adj(fun(B,set(C)),fun(fun(C,bool),fun(B,bool)),Uu),Uua),Uub))
    <=> ! [X3: C] :
          ( pp(aa(set(C),bool,member(C,X3),aa(B,set(C),Uu,Uub)))
         => pp(aa(C,bool,Uua,X3)) ) ) ).

% ATP.lambda_1024
tff(fact_7190_ATP_Olambda__1025,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: fun(B,bool),Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(fun(B,bool),fun(set(A),bool),aTP_Lamp_fv(fun(B,set(A)),fun(fun(B,bool),fun(set(A),bool)),Uu),Uua),Uub))
    <=> ? [X3: B] :
          ( ( Uub = aa(B,set(A),Uu,X3) )
          & pp(aa(B,bool,Uua,X3)) ) ) ).

% ATP.lambda_1025
tff(fact_7191_ATP_Olambda__1026,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(B,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(B,bool),fun(A,bool),aTP_Lamp_ci(fun(B,A),fun(fun(B,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [X3: B] :
          ( ( Uub = aa(B,A,Uu,X3) )
          & pp(aa(B,bool,Uua,X3)) ) ) ).

% ATP.lambda_1026
tff(fact_7192_ATP_Olambda__1027,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,bool),Uua: fun(A,B),Uub: B] :
      ( pp(aa(B,bool,aa(fun(A,B),fun(B,bool),aTP_Lamp_kx(fun(A,bool),fun(fun(A,B),fun(B,bool)),Uu),Uua),Uub))
    <=> ? [X3: A] :
          ( ( Uub = aa(A,B,Uua,X3) )
          & pp(aa(A,bool,Uu,X3)) ) ) ).

% ATP.lambda_1027
tff(fact_7193_ATP_Olambda__1028,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(C,fun(A,bool)),Uub: C] :
      ( pp(aa(C,bool,aa(fun(C,fun(A,bool)),fun(C,bool),aTP_Lamp_arj(fun(A,fun(B,bool)),fun(fun(C,fun(A,bool)),fun(C,bool)),Uu),Uua),Uub))
    <=> ? [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),aa(fun(A,bool),set(A),collect(A),aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),Uu))))
          & pp(aa(A,bool,aa(C,fun(A,bool),Uua,Uub),X3)) ) ) ).

% ATP.lambda_1028
tff(fact_7194_ATP_Olambda__1029,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(A,C),Uub: fun(A,C)] :
      ( pp(aa(fun(A,C),bool,aa(fun(A,C),fun(fun(A,C),bool),aTP_Lamp_arm(fun(A,fun(B,bool)),fun(fun(A,C),fun(fun(A,C),bool)),Uu),Uua),Uub))
    <=> ! [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),aa(fun(A,bool),set(A),collect(A),aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),Uu))))
         => ( aa(A,C,Uua,X3) = aa(A,C,Uub,X3) ) ) ) ).

% ATP.lambda_1029
tff(fact_7195_ATP_Olambda__1030,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,option(A)),Uua: list(B),Uub: A] :
      ( pp(aa(A,bool,aa(list(B),fun(A,bool),aTP_Lamp_aie(fun(B,option(A)),fun(list(B),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),aa(list(B),set(B),set2(B),Uua)))
          & ( aa(B,option(A),Uu,X3) = aa(A,option(A),some(A),Uub) ) ) ) ).

% ATP.lambda_1030
tff(fact_7196_ATP_Olambda__1031,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: fun(A,fun(B,bool)),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,fun(B,bool)),fun(A,bool),aTP_Lamp_adm(set(B),fun(fun(A,fun(B,bool)),fun(A,bool)),Uu),Uua),Uub))
    <=> ! [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),Uu))
         => pp(aa(B,bool,aa(A,fun(B,bool),Uua,Uub),X3)) ) ) ).

% ATP.lambda_1031
tff(fact_7197_ATP_Olambda__1032,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(B,fun(A,bool)),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,fun(A,bool)),fun(B,bool),aTP_Lamp_adk(set(A),fun(fun(B,fun(A,bool)),fun(B,bool)),Uu),Uua),Uub))
    <=> ! [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),Uu))
         => pp(aa(A,bool,aa(B,fun(A,bool),Uua,Uub),X3)) ) ) ).

% ATP.lambda_1032
tff(fact_7198_ATP_Olambda__1033,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,fun(B,bool)),Uub: B] :
      ( pp(aa(B,bool,aa(fun(A,fun(B,bool)),fun(B,bool),aTP_Lamp_ahu(set(A),fun(fun(A,fun(B,bool)),fun(B,bool)),Uu),Uua),Uub))
    <=> ! [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),Uu))
         => pp(aa(B,bool,aa(A,fun(B,bool),Uua,X3),Uub)) ) ) ).

% ATP.lambda_1033
tff(fact_7199_ATP_Olambda__1034,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: fun(A,fun(B,bool)),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,fun(B,bool)),fun(A,bool),aTP_Lamp_afb(set(B),fun(fun(A,fun(B,bool)),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),Uu))
          & pp(aa(B,bool,aa(A,fun(B,bool),Uua,Uub),X3)) ) ) ).

% ATP.lambda_1034
tff(fact_7200_ATP_Olambda__1035,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(B,fun(A,bool)),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,fun(A,bool)),fun(B,bool),aTP_Lamp_aet(set(A),fun(fun(B,fun(A,bool)),fun(B,bool)),Uu),Uua),Uub))
    <=> ? [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),Uu))
          & pp(aa(A,bool,aa(B,fun(A,bool),Uua,Uub),X3)) ) ) ).

% ATP.lambda_1035
tff(fact_7201_ATP_Olambda__1036,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,fun(B,bool)),Uub: B] :
      ( pp(aa(B,bool,aa(fun(A,fun(B,bool)),fun(B,bool),aTP_Lamp_atm(set(A),fun(fun(A,fun(B,bool)),fun(B,bool)),Uu),Uua),Uub))
    <=> ? [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),Uu))
          & pp(aa(B,bool,aa(A,fun(B,bool),Uua,X3),Uub)) ) ) ).

% ATP.lambda_1036
tff(fact_7202_ATP_Olambda__1037,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,fun(A,bool)),Uua: set(B),Uub: A] :
      ( pp(aa(A,bool,aa(set(B),fun(A,bool),aTP_Lamp_aeu(fun(B,fun(A,bool)),fun(set(B),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),Uua))
          & pp(aa(A,bool,aa(B,fun(A,bool),Uu,X3),Uub)) ) ) ).

% ATP.lambda_1037
tff(fact_7203_ATP_Olambda__1038,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_adx(set(product_prod(A,A)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ! [X3: product_prod(A,A)] :
          ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),X3),Uu))
         => pp(aa(product_prod(A,A),bool,aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(A,fun(A,fun(A,bool)),aa(A,fun(A,fun(A,fun(A,bool))),aTP_Lamp_adw(set(product_prod(A,A)),fun(A,fun(A,fun(A,fun(A,bool)))),Uu),Uua),Uub)),X3)) ) ) ).

% ATP.lambda_1038
tff(fact_7204_ATP_Olambda__1039,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,fun(B,C)),Uua: set(C),Uub: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(set(C),fun(product_prod(A,B),bool),aTP_Lamp_ec(fun(A,fun(B,C)),fun(set(C),fun(product_prod(A,B),bool)),Uu),Uua),Uub))
    <=> ? [P6: product_prod(A,B)] :
          ( ( Uub = P6 )
          & pp(aa(set(C),bool,member(C,aa(B,C,aa(A,fun(B,C),Uu,aa(product_prod(A,B),A,product_fst(A,B),P6)),aa(product_prod(A,B),B,product_snd(A,B),P6))),Uua)) ) ) ).

% ATP.lambda_1039
tff(fact_7205_ATP_Olambda__1040,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: set(A),Uub: B] :
      ( pp(aa(B,bool,aa(set(A),fun(B,bool),aTP_Lamp_afa(set(product_prod(A,B)),fun(set(A),fun(B,bool)),Uu),Uua),Uub))
    <=> ? [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),Uua))
          & pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Uub)),Uu)) ) ) ).

% ATP.lambda_1040
tff(fact_7206_ATP_Olambda__1041,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_afd(fun(A,B),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),Uua))
          & ( aa(A,B,Uu,X3) = aa(A,B,Uu,Uub) ) ) ) ).

% ATP.lambda_1041
tff(fact_7207_ATP_Olambda__1042,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,option(B)),Uua: set(A),Uub: B] :
      ( pp(aa(B,bool,aa(set(A),fun(B,bool),aTP_Lamp_afi(fun(A,option(B)),fun(set(A),fun(B,bool)),Uu),Uua),Uub))
    <=> ? [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),Uua))
          & ( aa(A,option(B),Uu,X3) = aa(B,option(B),some(B),Uub) ) ) ) ).

% ATP.lambda_1042
tff(fact_7208_ATP_Olambda__1043,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: set(B),Uub: A] :
      ( pp(aa(A,bool,aa(set(B),fun(A,bool),aTP_Lamp_adn(fun(B,set(A)),fun(set(B),fun(A,bool)),Uu),Uua),Uub))
    <=> ! [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),Uua))
         => pp(aa(set(A),bool,member(A,Uub),aa(B,set(A),Uu,X3))) ) ) ).

% ATP.lambda_1043
tff(fact_7209_ATP_Olambda__1044,axiom,
    ! [C: $tType,A: $tType,Uu: set(fun(A,C)),Uua: A,Uub: C] :
      ( pp(aa(C,bool,aa(A,fun(C,bool),aTP_Lamp_bac(set(fun(A,C)),fun(A,fun(C,bool)),Uu),Uua),Uub))
    <=> ? [X3: fun(A,C)] :
          ( pp(aa(set(fun(A,C)),bool,member(fun(A,C),X3),Uu))
          & ( Uub = aa(A,C,X3,Uua) ) ) ) ).

% ATP.lambda_1044
tff(fact_7210_ATP_Olambda__1045,axiom,
    ! [B: $tType,A: $tType,Uu: set(fun(A,B)),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_bad(set(fun(A,B)),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> ? [X3: fun(A,B)] :
          ( pp(aa(set(fun(A,B)),bool,member(fun(A,B),X3),Uu))
          & ( Uub = aa(A,B,X3,Uua) ) ) ) ).

% ATP.lambda_1045
tff(fact_7211_ATP_Olambda__1046,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: set(B),Uub: A] :
      ( pp(aa(A,bool,aa(set(B),fun(A,bool),aTP_Lamp_afc(fun(B,set(A)),fun(set(B),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [X3: B] :
          ( pp(aa(set(B),bool,member(B,X3),Uua))
          & pp(aa(set(A),bool,member(A,Uub),aa(B,set(A),Uu,X3))) ) ) ).

% ATP.lambda_1046
tff(fact_7212_ATP_Olambda__1047,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: set(A),Uub: B] :
      ( pp(aa(B,bool,aa(set(A),fun(B,bool),aTP_Lamp_aew(fun(A,B),fun(set(A),fun(B,bool)),Uu),Uua),Uub))
    <=> ? [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),Uua))
          & ( Uub = aa(A,B,Uu,X3) ) ) ) ).

% ATP.lambda_1047
tff(fact_7213_ATP_Olambda__1048,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: filter(B),Uub: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aa(filter(B),fun(fun(A,bool),bool),aTP_Lamp_afu(fun(A,B),fun(filter(B),fun(fun(A,bool),bool)),Uu),Uua),Uub))
    <=> ? [Q7: fun(B,bool)] :
          ( eventually(B,Q7,Uua)
          & ! [X3: A] :
              ( pp(aa(B,bool,Q7,aa(A,B,Uu,X3)))
             => pp(aa(A,bool,Uub,X3)) ) ) ) ).

% ATP.lambda_1048
tff(fact_7214_ATP_Olambda__1049,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,bool),Uua: fun(B,fun(A,bool)),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,fun(A,bool)),fun(B,bool),aTP_Lamp_kq(fun(A,bool),fun(fun(B,fun(A,bool)),fun(B,bool)),Uu),Uua),Uub))
    <=> ? [Y4: A] :
          ( pp(aa(A,bool,Uu,Y4))
          & pp(aa(A,bool,aa(B,fun(A,bool),Uua,Uub),Y4)) ) ) ).

% ATP.lambda_1049
tff(fact_7215_ATP_Olambda__1050,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: fun(B,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(B,bool),fun(A,bool),aTP_Lamp_fw(fun(B,set(A)),fun(fun(B,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ? [X3: B] :
          ( pp(aa(B,bool,Uua,X3))
          & pp(aa(set(A),bool,member(A,Uub),aa(B,set(A),Uu,X3))) ) ) ).

% ATP.lambda_1050
tff(fact_7216_ATP_Olambda__1051,axiom,
    ! [B: $tType,A: $tType,Uu: B,Uua: fun(A,fun(B,bool)),Uub: fun(A,B)] :
      ( pp(aa(fun(A,B),bool,aa(fun(A,fun(B,bool)),fun(fun(A,B),bool),aTP_Lamp_bae(B,fun(fun(A,fun(B,bool)),fun(fun(A,B),bool)),Uu),Uua),Uub))
    <=> ! [X3: A] :
          ( ( aa(A,B,Uub,X3) != Uu )
         => pp(aa(B,bool,aa(A,fun(B,bool),Uua,X3),aa(A,B,Uub,X3))) ) ) ).

% ATP.lambda_1051
tff(fact_7217_ATP_Olambda__1052,axiom,
    ! [A: $tType,Uu: fun(A,A),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_agy(fun(A,A),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ? [N5: nat] : ( Uub = aa(A,A,compow(fun(A,A),N5,Uu),Uua) ) ) ).

% ATP.lambda_1052
tff(fact_7218_ATP_Olambda__1053,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(B,fun(B,bool)),Uub: product_prod(A,A)] :
      ( pp(aa(product_prod(A,A),bool,aa(fun(B,fun(B,bool)),fun(product_prod(A,A),bool),aTP_Lamp_cq(fun(B,A),fun(fun(B,fun(B,bool)),fun(product_prod(A,A),bool)),Uu),Uua),Uub))
    <=> ? [A6: B,B5: B] :
          ( ( Uub = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(B,A,Uu,A6)),aa(B,A,Uu,B5)) )
          & pp(aa(B,bool,aa(B,fun(B,bool),Uua,A6),B5)) ) ) ).

% ATP.lambda_1053
tff(fact_7219_ATP_Olambda__1054,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: fun(B,A),Uub: product_prod(A,A)] :
      ( pp(aa(product_prod(A,A),bool,aa(fun(B,A),fun(product_prod(A,A),bool),aTP_Lamp_bx(set(product_prod(B,B)),fun(fun(B,A),fun(product_prod(A,A),bool)),Uu),Uua),Uub))
    <=> ? [A17: B,A25: B] :
          ( ( Uub = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(B,A,Uua,A17)),aa(B,A,Uua,A25)) )
          & pp(aa(set(product_prod(B,B)),bool,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A17),A25)),Uu)) ) ) ).

% ATP.lambda_1054
tff(fact_7220_ATP_Olambda__1055,axiom,
    ! [A2: $tType,A: $tType,Uu: set(product_prod(A,A)),Uua: fun(A,A2),Uub: product_prod(A2,A2)] :
      ( pp(aa(product_prod(A2,A2),bool,aa(fun(A,A2),fun(product_prod(A2,A2),bool),aTP_Lamp_azx(set(product_prod(A,A)),fun(fun(A,A2),fun(product_prod(A2,A2),bool)),Uu),Uua),Uub))
    <=> ? [A6: A,B5: A] :
          ( ( Uub = aa(A2,product_prod(A2,A2),aa(A2,fun(A2,product_prod(A2,A2)),product_Pair(A2,A2),aa(A,A2,Uua,A6)),aa(A,A2,Uua,B5)) )
          & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A6),B5)),Uu)) ) ) ).

% ATP.lambda_1055
tff(fact_7221_ATP_Olambda__1056,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_ann(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: A,V4: list(A)] :
          ( ( Uub = append(A,Uua,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A6),V4)) )
          | ? [U5: list(A),Aa2: A,B5: A,Va: list(A),W3: list(A)] :
              ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Aa2),B5)),Uu))
              & ( Uua = append(A,U5,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Aa2),Va)) )
              & ( Uub = append(A,U5,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),B5),W3)) ) ) ) ) ).

% ATP.lambda_1056
tff(fact_7222_ATP_Olambda__1057,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Uu: set(A),Uua: set(A),Uub: A] :
          ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_oa(set(A),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
        <=> ? [A6: A,B5: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),sup_sup(A),A6),B5) )
              & pp(aa(set(A),bool,member(A,A6),Uu))
              & pp(aa(set(A),bool,member(A,B5),Uua)) ) ) ) ).

% ATP.lambda_1057
tff(fact_7223_ATP_Olambda__1058,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Uu: set(A),Uua: set(A),Uub: A] :
          ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_nh(set(A),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
        <=> ? [A6: A,B5: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),inf_inf(A),A6),B5) )
              & pp(aa(set(A),bool,member(A,A6),Uu))
              & pp(aa(set(A),bool,member(A,B5),Uua)) ) ) ) ).

% ATP.lambda_1058
tff(fact_7224_ATP_Olambda__1059,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: set(multiset(A)),Uub: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(set(multiset(A)),fun(multiset(A),bool),aTP_Lamp_aub(set(multiset(A)),fun(set(multiset(A)),fun(multiset(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: multiset(A),B5: multiset(A)] :
          ( ( Uub = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),A6),B5) )
          & pp(aa(set(multiset(A)),bool,member(multiset(A),A6),Uu))
          & pp(aa(set(multiset(A)),bool,member(multiset(A),B5),Uua)) ) ) ).

% ATP.lambda_1059
tff(fact_7225_ATP_Olambda__1060,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: set(multiset(A)),Uub: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(set(multiset(A)),fun(multiset(A),bool),aTP_Lamp_aua(set(multiset(A)),fun(set(multiset(A)),fun(multiset(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: multiset(A),B5: multiset(A)] :
          ( ( Uub = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),A6),B5) )
          & pp(aa(set(multiset(A)),bool,member(multiset(A),A6),Uu))
          & pp(aa(set(multiset(A)),bool,member(multiset(A),B5),Uua)) ) ) ).

% ATP.lambda_1060
tff(fact_7226_ATP_Olambda__1061,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(list(A)),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(set(list(A)),fun(list(A),bool),aTP_Lamp_ajb(set(A),fun(set(list(A)),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ? [X3: A,Xs3: list(A)] :
          ( ( Uub = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X3),Xs3) )
          & pp(aa(set(A),bool,member(A,X3),Uu))
          & pp(aa(set(list(A)),bool,member(list(A),Xs3),Uua)) ) ) ).

% ATP.lambda_1061
tff(fact_7227_ATP_Olambda__1062,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(set(old_node(A,B)),fun(set(old_node(A,B)),C)),Uua: set(old_node(A,B)),Uub: C] :
      ( pp(aa(C,bool,aa(set(old_node(A,B)),fun(C,bool),aTP_Lamp_azj(fun(set(old_node(A,B)),fun(set(old_node(A,B)),C)),fun(set(old_node(A,B)),fun(C,bool)),Uu),Uua),Uub))
    <=> ? [X3: set(old_node(A,B)),Y4: set(old_node(A,B))] :
          ( ( Uua = old_Scons(A,B,X3,Y4) )
          & ( Uub = aa(set(old_node(A,B)),C,aa(set(old_node(A,B)),fun(set(old_node(A,B)),C),Uu,X3),Y4) ) ) ) ).

% ATP.lambda_1062
tff(fact_7228_ATP_Olambda__1063,axiom,
    ! [A: $tType,Uu: filter(A),Uua: filter(A),Uub: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aa(filter(A),fun(fun(A,bool),bool),aTP_Lamp_afq(filter(A),fun(filter(A),fun(fun(A,bool),bool)),Uu),Uua),Uub))
    <=> ? [Q7: fun(A,bool),R6: fun(A,bool)] :
          ( eventually(A,Q7,Uu)
          & eventually(A,R6,Uua)
          & ! [X3: A] :
              ( ( pp(aa(A,bool,Q7,X3))
                & pp(aa(A,bool,R6,X3)) )
             => pp(aa(A,bool,Uub,X3)) ) ) ) ).

% ATP.lambda_1063
tff(fact_7229_ATP_Olambda__1064,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: multiset(A),Uub: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_ahw(set(product_prod(A,A)),fun(multiset(A),fun(multiset(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: A,M02: multiset(A),K8: multiset(A)] :
          ( ( Uub = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A6),M02) )
          & ( Uua = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),M02),K8) )
          & ! [B5: A] :
              ( pp(aa(set(A),bool,member(A,B5),aa(multiset(A),set(A),set_mset(A),K8)))
             => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B5),A6)),Uu)) ) ) ) ).

% ATP.lambda_1064
tff(fact_7230_ATP_Olambda__1065,axiom,
    ! [B: $tType,A: $tType,E: $tType,C: $tType,D: $tType,Uu: fun(E,fun(A,fun(C,fun(B,fun(D,bool))))),Uua: E,Uub: fun(A,option(product_prod(B,product_prod(C,D))))] :
      ( pp(aa(fun(A,option(product_prod(B,product_prod(C,D)))),bool,aa(E,fun(fun(A,option(product_prod(B,product_prod(C,D)))),bool),aTP_Lamp_azz(fun(E,fun(A,fun(C,fun(B,fun(D,bool))))),fun(E,fun(fun(A,option(product_prod(B,product_prod(C,D)))),bool)),Uu),Uua),Uub))
    <=> ! [H: A,H7: C,R7: B,N5: D] :
          ( ( aa(A,option(product_prod(B,product_prod(C,D))),Uub,H) = aa(product_prod(B,product_prod(C,D)),option(product_prod(B,product_prod(C,D))),some(product_prod(B,product_prod(C,D))),aa(product_prod(C,D),product_prod(B,product_prod(C,D)),aa(B,fun(product_prod(C,D),product_prod(B,product_prod(C,D))),product_Pair(B,product_prod(C,D)),R7),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),H7),N5))) )
         => pp(aa(D,bool,aa(B,fun(D,bool),aa(C,fun(B,fun(D,bool)),aa(A,fun(C,fun(B,fun(D,bool))),aa(E,fun(A,fun(C,fun(B,fun(D,bool)))),Uu,Uua),H),H7),R7),N5)) ) ) ).

% ATP.lambda_1065
tff(fact_7231_ATP_Olambda__1066,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_anq(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ? [Us: list(A),Z5: A,Z9: A,Vs2: list(A)] :
          ( ( Uua = append(A,Us,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Z5),Vs2)) )
          & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z5),Z9)),Uu))
          & ( Uub = append(A,Us,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Z9),Vs2)) ) ) ) ).

% ATP.lambda_1066
tff(fact_7232_ATP_Olambda__1067,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(nat,fun(nat,A)),Uuc: nat] : ( aa(nat,A,aa(fun(nat,fun(nat,A)),fun(nat,A),aa(A,fun(fun(nat,fun(nat,A)),fun(nat,A)),aTP_Lamp_arz(fun(A,fun(A,A)),fun(A,fun(fun(nat,fun(nat,A)),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,Uu,Uua),aa(nat,fun(nat,A),aTP_Lamp_ary(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uub),Uuc)),aa(nat,set(nat),set_ord_atMost(nat),Uuc)) ) ).

% ATP.lambda_1067
tff(fact_7233_ATP_Olambda__1068,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(nat,fun(nat,A)),Uuc: nat] : ( aa(nat,A,aa(fun(nat,fun(nat,A)),fun(nat,A),aa(A,fun(fun(nat,fun(nat,A)),fun(nat,A)),aTP_Lamp_asx(fun(A,fun(A,A)),fun(A,fun(fun(nat,fun(nat,A)),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,Uu,Uua),aa(nat,fun(nat,A),Uub,Uuc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uuc)) ) ).

% ATP.lambda_1068
tff(fact_7234_ATP_Olambda__1069,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(nat,fun(nat,A)),Uuc: nat] : ( aa(nat,A,aa(fun(nat,fun(nat,A)),fun(nat,A),aa(A,fun(fun(nat,fun(nat,A)),fun(nat,A)),aTP_Lamp_atb(fun(A,fun(A,A)),fun(A,fun(fun(nat,fun(nat,A)),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,Uu,Uua),aa(nat,fun(nat,A),Uub,Uuc)),aa(nat,set(nat),set_ord_lessThan(nat),Uuc)) ) ).

% ATP.lambda_1069
tff(fact_7235_ATP_Olambda__1070,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Uu: fun(B,fun(C,fun(D,A))),Uua: D,Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(D,fun(B,fun(C,A)),aTP_Lamp_db(fun(B,fun(C,fun(D,A))),fun(D,fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(D,A,aa(C,fun(D,A),aa(B,fun(C,fun(D,A)),Uu,Uub),Uuc),Uua) ) ).

% ATP.lambda_1070
tff(fact_7236_ATP_Olambda__1071,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: product_prod(C,A),Uua: A,Uub: B,Uuc: set(product_prod(C,B))] : ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(B,fun(set(product_prod(C,B)),set(product_prod(C,B))),aa(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_ma(product_prod(C,A),fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),Uu),Uua),Uub),Uuc) = if(set(product_prod(C,B)),aa(A,bool,aa(A,fun(A,bool),fequal(A),aa(product_prod(C,A),A,product_snd(C,A),Uu)),Uua),aa(set(product_prod(C,B)),set(product_prod(C,B)),insert(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),aa(product_prod(C,A),C,product_fst(C,A),Uu)),Uub)),Uuc),Uuc) ) ).

% ATP.lambda_1071
tff(fact_7237_ATP_Olambda__1072,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: set(A),Uub: A,Uuc: B] : ( aa(B,A,aa(A,fun(B,A),aa(set(A),fun(A,fun(B,A)),aTP_Lamp_kj(fun(A,B),fun(set(A),fun(A,fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(set(B),bool,member(B,Uuc),aa(set(A),set(B),image2(A,B,Uu),Uua)),the_inv_into(A,B,Uua,Uu,Uuc),Uub) ) ).

% ATP.lambda_1072
tff(fact_7238_ATP_Olambda__1073,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(A,B),Uub: A,Uuc: B] : ( aa(B,A,aa(A,fun(B,A),aa(fun(A,B),fun(A,fun(B,A)),aTP_Lamp_qu(set(A),fun(fun(A,B),fun(A,fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(set(B),bool,member(B,Uuc),aa(set(A),set(B),image2(A,B,Uua),Uu)),the_inv_into(A,B,Uu,Uua,Uuc),Uub) ) ).

% ATP.lambda_1073
tff(fact_7239_ATP_Olambda__1074,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: A,Uub: B,Uuc: set(B)] : ( aa(set(B),set(B),aa(B,fun(set(B),set(B)),aa(A,fun(B,fun(set(B),set(B))),aTP_Lamp_ls(set(A),fun(A,fun(B,fun(set(B),set(B)))),Uu),Uua),Uub),Uuc) = if(set(B),aa(set(A),bool,member(A,Uua),Uu),aa(set(B),set(B),insert(B,Uub),Uuc),Uuc) ) ).

% ATP.lambda_1074
tff(fact_7240_ATP_Olambda__1075,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_tf(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),if(A,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uuc),Uu),zero_zero(A),aa(nat,A,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat)))))) ) ) ).

% ATP.lambda_1075
tff(fact_7241_ATP_Olambda__1076,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_td(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),if(A,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uuc),Uu),one_one(A),aa(nat,A,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat)))))) ) ) ).

% ATP.lambda_1076
tff(fact_7242_ATP_Olambda__1077,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_te(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_1077
tff(fact_7243_ATP_Olambda__1078,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_tg(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_1078
tff(fact_7244_ATP_Olambda__1079,axiom,
    ! [A: $tType,Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_asb(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ).

% ATP.lambda_1079
tff(fact_7245_ATP_Olambda__1080,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: set(A),Uub: fun(A,B),Uuc: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(set(A),fun(fun(A,B),fun(A,B)),aTP_Lamp_ef(fun(A,B),fun(set(A),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc) = if(B,aa(set(A),bool,member(A,Uuc),Uua),aa(A,B,Uu,Uuc),aa(A,B,Uub,Uuc)) ) ).

% ATP.lambda_1080
tff(fact_7246_ATP_Olambda__1081,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_qa(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uu),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_1081
tff(fact_7247_ATP_Olambda__1082,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_qb(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uu),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_1082
tff(fact_7248_ATP_Olambda__1083,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_atc(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uu),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ).

% ATP.lambda_1083
tff(fact_7249_ATP_Olambda__1084,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: fun(B,A),Uub: set(B),Uuc: B] : ( aa(B,A,aa(set(B),fun(B,A),aa(fun(B,A),fun(set(B),fun(B,A)),aTP_Lamp_asq(A,fun(fun(B,A),fun(set(B),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(set(B),bool,member(B,Uuc),Uub),aa(B,A,Uua,Uuc),Uu) ) ).

% ATP.lambda_1084
tff(fact_7250_ATP_Olambda__1085,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B,Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_asj(A,fun(B,fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uua),Uuc),aa(B,A,Uub,Uuc),Uu) ) ).

% ATP.lambda_1085
tff(fact_7251_ATP_Olambda__1086,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: A,Uuc: B] : ( aa(B,A,aa(A,fun(B,A),aa(fun(B,A),fun(A,fun(B,A)),aTP_Lamp_sl(B,fun(fun(B,A),fun(A,fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uu),aa(B,A,Uua,Uuc),Uub) ) ) ).

% ATP.lambda_1086
tff(fact_7252_ATP_Olambda__1087,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B,Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_asi(A,fun(B,fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uua),aa(B,A,Uub,Uuc),Uu) ) ).

% ATP.lambda_1087
tff(fact_7253_ATP_Olambda__1088,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B,Uub: fun(A,option(B)),Uuc: A] : ( aa(A,option(B),aa(fun(A,option(B)),fun(A,option(B)),aa(B,fun(fun(A,option(B)),fun(A,option(B))),aTP_Lamp_acn(A,fun(B,fun(fun(A,option(B)),fun(A,option(B)))),Uu),Uua),Uub),Uuc) = if(option(B),aa(A,bool,aa(A,fun(A,bool),fequal(A),Uuc),Uu),aa(B,option(B),some(B),Uua),aa(A,option(B),Uub,Uuc)) ) ).

% ATP.lambda_1088
tff(fact_7254_ATP_Olambda__1089,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B)),Uua: A,Uub: B,Uuc: A] : ( aa(A,option(B),aa(B,fun(A,option(B)),aa(A,fun(B,fun(A,option(B))),aTP_Lamp_acv(fun(A,option(B)),fun(A,fun(B,fun(A,option(B)))),Uu),Uua),Uub),Uuc) = if(option(B),aa(A,bool,aa(A,fun(A,bool),fequal(A),Uuc),Uua),aa(B,option(B),some(B),Uub),aa(A,option(B),Uu,Uuc)) ) ).

% ATP.lambda_1089
tff(fact_7255_ATP_Olambda__1090,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: B,Uub: set(A),Uuc: A] : ( aa(A,B,aa(set(A),fun(A,B),aa(B,fun(set(A),fun(A,B)),aTP_Lamp_bh(B,fun(B,fun(set(A),fun(A,B))),Uu),Uua),Uub),Uuc) = if(B,aa(set(A),bool,member(A,Uuc),Uub),Uu,Uua) ) ).

% ATP.lambda_1090
tff(fact_7256_ATP_Olambda__1091,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: list(A),Uuc: list(A)] : ( aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),aa(A,fun(list(A),fun(list(A),product_prod(list(A),list(A)))),aTP_Lamp_ano(fun(A,bool),fun(A,fun(list(A),fun(list(A),product_prod(list(A),list(A))))),Uu),Uua),Uub),Uuc) = if(product_prod(list(A),list(A)),aa(A,bool,Uu,Uua),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uua),Uub)),Uuc),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Uub),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uua),Uuc))) ) ).

% ATP.lambda_1091
tff(fact_7257_ATP_Olambda__1092,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,bool),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_px(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,Uu,Uuc),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_1092
tff(fact_7258_ATP_Olambda__1093,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,bool),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_py(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,Uu,Uuc),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_1093
tff(fact_7259_ATP_Olambda__1094,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,bool),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_ca(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,Uu,Uuc),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ).

% ATP.lambda_1094
tff(fact_7260_ATP_Olambda__1095,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,bool),Uua: fun(A,option(B)),Uub: fun(A,option(B)),Uuc: A] : ( aa(A,option(B),aa(fun(A,option(B)),fun(A,option(B)),aa(fun(A,option(B)),fun(fun(A,option(B)),fun(A,option(B))),aTP_Lamp_acr(fun(A,bool),fun(fun(A,option(B)),fun(fun(A,option(B)),fun(A,option(B)))),Uu),Uua),Uub),Uuc) = if(option(B),aa(A,bool,Uu,Uuc),aa(A,option(B),Uua,Uuc),aa(A,option(B),Uub,Uuc)) ) ).

% ATP.lambda_1095
tff(fact_7261_ATP_Olambda__1096,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,bool),Uub: fun(A,B),Uuc: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,bool),fun(fun(A,B),fun(A,B)),aTP_Lamp_nd(fun(A,B),fun(fun(A,bool),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc) = if(B,aa(A,bool,Uua,Uuc),aa(A,B,Uu,Uuc),aa(A,B,Uub,Uuc)) ) ).

% ATP.lambda_1096
tff(fact_7262_ATP_Olambda__1097,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: fun(B,A),Uub: fun(B,bool),Uuc: B] : ( aa(B,A,aa(fun(B,bool),fun(B,A),aa(fun(B,A),fun(fun(B,bool),fun(B,A)),aTP_Lamp_ask(A,fun(fun(B,A),fun(fun(B,bool),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,Uub,Uuc),aa(B,A,Uua,Uuc),Uu) ) ).

% ATP.lambda_1097
tff(fact_7263_ATP_Olambda__1098,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: A,Uub: B,Uuc: set(product_prod(A,C))] : ( aa(set(product_prod(A,C)),set(product_prod(A,C)),aa(B,fun(set(product_prod(A,C)),set(product_prod(A,C))),aa(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aTP_Lamp_mj(set(product_prod(B,C)),fun(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C))))),Uu),Uua),Uub),Uuc) = finite_fold(product_prod(B,C),set(product_prod(A,C)),aa(fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C))))),fun(product_prod(B,C),fun(set(product_prod(A,C)),set(product_prod(A,C)))),product_case_prod(B,C,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aa(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C))))),aTP_Lamp_mi(A,fun(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C)))))),Uua),Uub)),Uuc,Uu) ) ).

% ATP.lambda_1098
tff(fact_7264_ATP_Olambda__1099,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: C,Uub: A,Uuc: set(product_prod(C,B))] : ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(A,fun(set(product_prod(C,B)),set(product_prod(C,B))),aa(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_lq(set(product_prod(A,B)),fun(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B))))),Uu),Uua),Uub),Uuc) = finite_fold(product_prod(A,B),set(product_prod(C,B)),aa(fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(A,B),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(A,B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aa(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),aTP_Lamp_lp(C,fun(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))))),Uua),Uub)),Uuc,Uu) ) ).

% ATP.lambda_1099
tff(fact_7265_ATP_Olambda__1100,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,B),Uub: bool,Uuc: A] : ( aa(A,B,aa(bool,fun(A,B),aa(fun(A,B),fun(bool,fun(A,B)),aTP_Lamp_azu(fun(A,B),fun(fun(A,B),fun(bool,fun(A,B))),Uu),Uua),Uub),Uuc) = if(B,Uub,aa(A,B,Uu,Uuc),aa(A,B,Uua,Uuc)) ) ).

% ATP.lambda_1100
tff(fact_7266_ATP_Olambda__1101,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_ajf(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,compow(fun(A,A),Uuc,aa(A,fun(A,A),times_times(A),Uua)),aa(B,A,Uu,aa(nat,B,nth(B,Uub),Uuc))) ) ) ).

% ATP.lambda_1101
tff(fact_7267_ATP_Olambda__1102,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: A,Uub: list(A),Uuc: bool] :
      ( pp(aa(bool,bool,aa(list(A),fun(bool,bool),aa(A,fun(list(A),fun(bool,bool)),aTP_Lamp_bbj(fun(A,fun(A,bool)),fun(A,fun(list(A),fun(bool,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(list(A),bool,case_list(bool,A,fTrue,aa(bool,fun(A,fun(list(A),bool)),aa(A,fun(bool,fun(A,fun(list(A),bool))),aTP_Lamp_bbi(fun(A,fun(A,bool)),fun(A,fun(bool,fun(A,fun(list(A),bool)))),Uu),Uua),Uuc)),Uub)) ) ).

% ATP.lambda_1102
tff(fact_7268_ATP_Olambda__1103,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(B,fun(list(B),fun(C,C))),Uua: fun(A,B),Uub: A,Uuc: list(A)] : ( aa(list(A),fun(C,C),aa(A,fun(list(A),fun(C,C)),aa(fun(A,B),fun(A,fun(list(A),fun(C,C))),aTP_Lamp_aoq(fun(B,fun(list(B),fun(C,C))),fun(fun(A,B),fun(A,fun(list(A),fun(C,C)))),Uu),Uua),Uub),Uuc) = aa(list(B),fun(C,C),aa(B,fun(list(B),fun(C,C)),Uu,aa(A,B,Uua,Uub)),aa(list(A),list(B),map(A,B,Uua),Uuc)) ) ).

% ATP.lambda_1103
tff(fact_7269_ATP_Olambda__1104,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(A,bool)),Uua: fun(B,A),Uub: B,Uuc: B] :
      ( pp(aa(B,bool,aa(B,fun(B,bool),aa(fun(B,A),fun(B,fun(B,bool)),aTP_Lamp_alf(fun(A,fun(A,bool)),fun(fun(B,A),fun(B,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(A,bool,aa(A,fun(A,bool),Uu,aa(B,A,Uua,Uub)),aa(B,A,Uua,Uuc))) ) ).

% ATP.lambda_1104
tff(fact_7270_ATP_Olambda__1105,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,Uu: fun(B,fun(C,A)),Uua: fun(D,B),Uub: fun(D,C),Uuc: D] : ( aa(D,A,aa(fun(D,C),fun(D,A),aa(fun(D,B),fun(fun(D,C),fun(D,A)),aTP_Lamp_akb(fun(B,fun(C,A)),fun(fun(D,B),fun(fun(D,C),fun(D,A))),Uu),Uua),Uub),Uuc) = aa(C,A,aa(B,fun(C,A),Uu,aa(D,B,Uua,Uuc)),aa(D,C,Uub,Uuc)) ) ).

% ATP.lambda_1105
tff(fact_7271_ATP_Olambda__1106,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(A,A)),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_asf(fun(A,fun(A,A)),fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),Uu,aa(B,A,Uua,Uuc)),aa(B,A,Uub,Uuc)) ) ).

% ATP.lambda_1106
tff(fact_7272_ATP_Olambda__1107,axiom,
    ! [B: $tType,F10: $tType,D: $tType,Uu: fun(B,fun(F10,bool)),Uua: fun(D,F10),Uub: B,Uuc: D] :
      ( pp(aa(D,bool,aa(B,fun(D,bool),aa(fun(D,F10),fun(B,fun(D,bool)),aTP_Lamp_aow(fun(B,fun(F10,bool)),fun(fun(D,F10),fun(B,fun(D,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(F10,bool,aa(B,fun(F10,bool),Uu,Uub),aa(D,F10,Uua,Uuc))) ) ).

% ATP.lambda_1107
tff(fact_7273_ATP_Olambda__1108,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,B),Uub: A,Uuc: D] : ( aa(D,C,aa(A,fun(D,C),aa(fun(D,B),fun(A,fun(D,C)),aTP_Lamp_lo(fun(A,fun(B,C)),fun(fun(D,B),fun(A,fun(D,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,Uub),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_1108
tff(fact_7274_ATP_Olambda__1109,axiom,
    ! [A: $tType,E: $tType,C: $tType,Uu: fun(A,fun(E,bool)),Uua: fun(C,E),Uub: A,Uuc: C] :
      ( pp(aa(C,bool,aa(A,fun(C,bool),aa(fun(C,E),fun(A,fun(C,bool)),aTP_Lamp_aov(fun(A,fun(E,bool)),fun(fun(C,E),fun(A,fun(C,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(E,bool,aa(A,fun(E,bool),Uu,Uub),aa(C,E,Uua,Uuc))) ) ).

% ATP.lambda_1109
tff(fact_7275_ATP_Olambda__1110,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,fun(C,bool)),Uua: fun(B,C),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(B,C),fun(A,fun(B,bool)),aTP_Lamp_fm(fun(A,fun(C,bool)),fun(fun(B,C),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(C,bool,aa(A,fun(C,bool),Uu,Uub),aa(B,C,Uua,Uuc))) ) ).

% ATP.lambda_1110
tff(fact_7276_ATP_Olambda__1111,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(C,B),Uub: A,Uuc: C] :
      ( pp(aa(C,bool,aa(A,fun(C,bool),aa(fun(C,B),fun(A,fun(C,bool)),aTP_Lamp_aoh(fun(A,fun(B,bool)),fun(fun(C,B),fun(A,fun(C,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(B,bool,aa(A,fun(B,bool),Uu,Uub),aa(C,B,Uua,Uuc))) ) ).

% ATP.lambda_1111
tff(fact_7277_ATP_Olambda__1112,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,fun(B,A)),Uua: fun(C,B),Uub: A,Uuc: C] : ( aa(C,A,aa(A,fun(C,A),aa(fun(C,B),fun(A,fun(C,A)),aTP_Lamp_ake(fun(A,fun(B,A)),fun(fun(C,B),fun(A,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(B,A,aa(A,fun(B,A),Uu,Uub),aa(C,B,Uua,Uuc)) ) ).

% ATP.lambda_1112
tff(fact_7278_ATP_Olambda__1113,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: set(C),Uuc: A] : ( aa(A,B,aa(set(C),fun(A,B),aa(fun(C,B),fun(set(C),fun(A,B)),aTP_Lamp_ou(fun(A,B),fun(fun(C,B),fun(set(C),fun(A,B))),Uu),Uua),Uub),Uuc) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(A,fun(C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_ot(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),Uu),Uua),Uuc)),Uub) ) ) ).

% ATP.lambda_1113
tff(fact_7279_ATP_Olambda__1114,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: set(B),Uub: filter(B),Uuc: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aa(filter(B),fun(fun(A,bool),bool),aa(set(B),fun(filter(B),fun(fun(A,bool),bool)),aTP_Lamp_bbl(fun(B,A),fun(set(B),fun(filter(B),fun(fun(A,bool),bool))),Uu),Uua),Uub),Uuc))
    <=> eventually(B,aa(fun(A,bool),fun(B,bool),aa(set(B),fun(fun(A,bool),fun(B,bool)),aTP_Lamp_bbk(fun(B,A),fun(set(B),fun(fun(A,bool),fun(B,bool))),Uu),Uua),Uuc),Uub) ) ).

% ATP.lambda_1114
tff(fact_7280_ATP_Olambda__1115,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(A,B),Uub: filter(A),Uuc: fun(B,bool)] :
      ( pp(aa(fun(B,bool),bool,aa(filter(A),fun(fun(B,bool),bool),aa(fun(A,B),fun(filter(A),fun(fun(B,bool),bool)),aTP_Lamp_afh(set(A),fun(fun(A,B),fun(filter(A),fun(fun(B,bool),bool))),Uu),Uua),Uub),Uuc))
    <=> eventually(A,aa(fun(B,bool),fun(A,bool),aa(fun(A,B),fun(fun(B,bool),fun(A,bool)),aTP_Lamp_afg(set(A),fun(fun(A,B),fun(fun(B,bool),fun(A,bool))),Uu),Uua),Uuc),Uub) ) ).

% ATP.lambda_1115
tff(fact_7281_ATP_Olambda__1116,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: list(B),Uub: B,Uuc: B] : ( aa(B,fun(list(B),list(B)),aa(B,fun(B,fun(list(B),list(B))),aa(list(B),fun(B,fun(B,fun(list(B),list(B)))),aTP_Lamp_amu(fun(B,A),fun(list(B),fun(B,fun(B,fun(list(B),list(B))))),Uu),Uua),Uub),Uuc) = case_list(list(B),B,if(list(B),aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,Uu,Uub)),aa(B,A,Uu,Uuc)),Uua,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uuc),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),nil(B)))),aa(list(B),fun(B,fun(list(B),list(B))),aTP_Lamp_amt(fun(B,A),fun(list(B),fun(B,fun(list(B),list(B)))),Uu),Uua)) ) ) ).

% ATP.lambda_1116
tff(fact_7282_ATP_Olambda__1117,axiom,
    ! [A: $tType,Uu: set(A),Uua: fun(A,fun(A,bool)),Uub: set(A),Uuc: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aa(fun(A,fun(A,bool)),fun(set(A),fun(set(A),bool)),aTP_Lamp_agv(set(A),fun(fun(A,fun(A,bool)),fun(set(A),fun(set(A),bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(A),bool,pred_chain(A,Uu,Uua),Uuc))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),Uub),Uuc)) ) ) ).

% ATP.lambda_1117
tff(fact_7283_ATP_Olambda__1118,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(A,fun(B,bool)),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aTP_Lamp_awn(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(B,bool,aa(A,fun(B,bool),Uu,Uub),Uuc))
        & pp(aa(B,bool,aa(A,fun(B,bool),Uua,Uub),Uuc)) ) ) ).

% ATP.lambda_1118
tff(fact_7284_ATP_Olambda__1119,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,assn)),Uua: bool,Uub: A,Uuc: B] : ( aa(B,assn,aa(A,fun(B,assn),aa(bool,fun(A,fun(B,assn)),aTP_Lamp_ab(fun(A,fun(B,assn)),fun(bool,fun(A,fun(B,assn))),Uu),Uua),Uub),Uuc) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),Uu,Uub),Uuc)),pure_assn(Uua)) ) ).

% ATP.lambda_1119
tff(fact_7285_ATP_Olambda__1120,axiom,
    ! [C: $tType,A: $tType,B: $tType,E: $tType,D: $tType,Uu: fun(B,fun(C,fun(D,fun(E,set(A))))),Uua: product_prod(D,E),Uub: B,Uuc: C] : ( aa(C,set(A),aa(B,fun(C,set(A)),aa(product_prod(D,E),fun(B,fun(C,set(A))),aTP_Lamp_ho(fun(B,fun(C,fun(D,fun(E,set(A))))),fun(product_prod(D,E),fun(B,fun(C,set(A)))),Uu),Uua),Uub),Uuc) = aa(product_prod(D,E),set(A),aa(fun(D,fun(E,set(A))),fun(product_prod(D,E),set(A)),product_case_prod(D,E,set(A)),aa(C,fun(D,fun(E,set(A))),aa(B,fun(C,fun(D,fun(E,set(A)))),Uu,Uub),Uuc)),Uua) ) ).

% ATP.lambda_1120
tff(fact_7286_ATP_Olambda__1121,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: set(B),Uua: fun(B,fun(C,A)),Uub: fun(B,fun(C,bool)),Uuc: C] : ( aa(C,A,aa(fun(B,fun(C,bool)),fun(C,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A)),aTP_Lamp_os(set(B),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A))),Uu),Uua),Uub),Uuc) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(C,fun(B,A),aTP_Lamp_on(fun(B,fun(C,A)),fun(C,fun(B,A)),Uua),Uuc)),aa(fun(B,bool),set(B),collect(B),aa(C,fun(B,bool),aa(fun(B,fun(C,bool)),fun(C,fun(B,bool)),aTP_Lamp_or(set(B),fun(fun(B,fun(C,bool)),fun(C,fun(B,bool))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1121
tff(fact_7287_ATP_Olambda__1122,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: set(B),Uua: fun(B,fun(C,A)),Uub: fun(B,fun(C,bool)),Uuc: C] : ( aa(C,A,aa(fun(B,fun(C,bool)),fun(C,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A)),aTP_Lamp_oz(set(B),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A))),Uu),Uua),Uub),Uuc) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(C,fun(B,A),aTP_Lamp_ok(fun(B,fun(C,A)),fun(C,fun(B,A)),Uua),Uuc)),aa(fun(B,bool),set(B),collect(B),aa(C,fun(B,bool),aa(fun(B,fun(C,bool)),fun(C,fun(B,bool)),aTP_Lamp_or(set(B),fun(fun(B,fun(C,bool)),fun(C,fun(B,bool))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1122
tff(fact_7288_ATP_Olambda__1123,axiom,
    ! [Uu: code_natural,Uua: code_natural,Uub: code_natural,Uuc: code_natural] : ( aa(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aa(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),aTP_Lamp_axv(code_natural,fun(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))))),Uu),Uua),Uub),Uuc) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_Pair(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),inc_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),Uu)),Uuc)),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),Uub),inc_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),Uua))) ) ).

% ATP.lambda_1123
tff(fact_7289_ATP_Olambda__1124,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: set(A),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(A),fun(A,fun(A,bool)),aTP_Lamp_jk(fun(A,fun(A,bool)),fun(set(A),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uuc)),product_Sigma(A,A,Uua,aTP_Lamp_cr(set(A),fun(A,set(A)),Uua))))
        & pp(aa(A,bool,aa(A,fun(A,bool),Uu,Uub),Uuc)) ) ) ).

% ATP.lambda_1124
tff(fact_7290_ATP_Olambda__1125,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_wc(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uub))) ) ).

% ATP.lambda_1125
tff(fact_7291_ATP_Olambda__1126,axiom,
    ! [B: $tType,A: $tType,Uu: set(old_node(A,B)),Uua: set(old_node(A,B)),Uub: set(old_node(A,B)),Uuc: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),aTP_Lamp_azf(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))))),Uu),Uua),Uub),Uuc) = aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),insert(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_Scons(A,B,Uu,Uub)),old_Scons(A,B,Uua,Uuc))),bot_bot(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))) ) ).

% ATP.lambda_1126
tff(fact_7292_ATP_Olambda__1127,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: A,Uub: array(A),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(A,fun(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awa(nat,fun(A,fun(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),aa(nat,A,nth(A,array_get(A,Uuc,Uub)),Uu)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(A,Uub,Uu,Uua,Uuc)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_1127
tff(fact_7293_ATP_Olambda__1128,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(A),fun(A,fun(A,bool)),aTP_Lamp_dz(set(product_prod(A,A)),fun(set(A),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uuc)),Uu))
        & ~ pp(aa(set(A),bool,member(A,Uub),Uua))
        & ~ pp(aa(set(A),bool,member(A,Uuc),Uua)) ) ) ).

% ATP.lambda_1128
tff(fact_7294_ATP_Olambda__1129,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: set(product_prod(A,A)),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aTP_Lamp_uq(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc)))
        | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc)))
          & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uuc)),Uua)) ) ) ) ).

% ATP.lambda_1129
tff(fact_7295_ATP_Olambda__1130,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: fun(A,B),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,B),fun(A,fun(A,bool)),aTP_Lamp_aup(set(product_prod(B,B)),fun(fun(A,B),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(set(product_prod(B,B)),bool,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,Uua,Uub)),aa(A,B,Uua,Uuc))),Uu)) ) ).

% ATP.lambda_1130
tff(fact_7296_ATP_Olambda__1131,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,option(B)),Uua: fun(product_prod(A,B),bool),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(product_prod(A,B),bool),fun(A,fun(B,bool)),aTP_Lamp_aar(fun(A,option(B)),fun(fun(product_prod(A,B),bool),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( ( aa(A,option(B),Uu,Uub) = aa(B,option(B),some(B),Uuc) )
        & pp(aa(product_prod(A,B),bool,Uua,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uub),Uuc))) ) ) ).

% ATP.lambda_1131
tff(fact_7297_ATP_Olambda__1132,axiom,
    ! [A: $tType,B: $tType] :
      ( order(A)
     => ! [Uu: fun(A,set(B)),Uua: set(B),Uub: set(B),Uuc: A] : ( aa(A,set(B),aa(set(B),fun(A,set(B)),aa(set(B),fun(set(B),fun(A,set(B))),aTP_Lamp_ly(fun(A,set(B)),fun(set(B),fun(set(B),fun(A,set(B)))),Uu),Uua),Uub),Uuc) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(A,set(B),Uu,Uuc)),Uua)),Uub) ) ) ).

% ATP.lambda_1132
tff(fact_7298_ATP_Olambda__1133,axiom,
    ! [A: $tType,Uu: set(A),Uua: fun(set(A),set(A)),Uub: set(A),Uuc: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),aa(fun(set(A),set(A)),fun(set(A),fun(set(A),set(A))),aTP_Lamp_nk(set(A),fun(fun(set(A),set(A)),fun(set(A),fun(set(A),set(A)))),Uu),Uua),Uub),Uuc) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),Uua,Uuc)),Uub)),Uu) ) ).

% ATP.lambda_1133
tff(fact_7299_ATP_Olambda__1134,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_vp(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uub),Uuc))),comm_s3205402744901411588hammer(A,Uu,Uuc))),comm_s3205402744901411588hammer(A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_1134
tff(fact_7300_ATP_Olambda__1135,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_um(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,semiring_1_of_nat(nat),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uu),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_1135
tff(fact_7301_ATP_Olambda__1136,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_uo(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_1136
tff(fact_7302_ATP_Olambda__1137,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat,Uub: list(A),Uuc: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(nat,fun(list(A),fun(list(A),bool)),aTP_Lamp_ang(set(product_prod(A,A)),fun(nat,fun(list(A),fun(list(A),bool))),Uu),Uua),Uub),Uuc))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uua )
        & ( aa(list(A),nat,size_size(list(A)),Uuc) = Uua )
        & ? [Xys2: list(A),X3: A,Y4: A,Xs4: list(A),Ys4: list(A)] :
            ( ( Uub = append(A,Xys2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X3),Xs4)) )
            & ( Uuc = append(A,Xys2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y4),Ys4)) )
            & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Y4)),Uu)) ) ) ) ).

% ATP.lambda_1137
tff(fact_7303_ATP_Olambda__1138,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_vi(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uuc)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc)) ) ) ).

% ATP.lambda_1138
tff(fact_7304_ATP_Olambda__1139,axiom,
    ! [A: $tType,Uu: bool,Uua: A,Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(A,fun(A,fun(A,bool)),aTP_Lamp_ez(bool,fun(A,fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( ( pp(Uu)
         => ( Uuc = Uua ) )
        & ( ~ pp(Uu)
         => ( Uuc = Uub ) ) ) ) ).

% ATP.lambda_1139
tff(fact_7305_ATP_Olambda__1140,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: set(B),Uub: fun(A,bool),Uuc: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(set(B),fun(fun(A,bool),fun(A,bool)),aTP_Lamp_cd(fun(B,A),fun(set(B),fun(fun(A,bool),fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(A),bool,member(A,Uuc),aa(set(B),set(A),image2(B,A,Uu),Uua)))
        & pp(aa(A,bool,Uub,Uuc)) ) ) ).

% ATP.lambda_1140
tff(fact_7306_ATP_Olambda__1141,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: multiset(B),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(multiset(B),fun(A,fun(B,bool)),aTP_Lamp_apd(fun(B,A),fun(multiset(B),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(B),bool,member(B,Uuc),aa(multiset(B),set(B),set_mset(B),Uua)))
        & ( Uub = aa(B,A,Uu,Uuc) ) ) ) ).

% ATP.lambda_1141
tff(fact_7307_ATP_Olambda__1142,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: fun(B,fun(C,bool)),Uub: B,Uuc: C] :
      ( pp(aa(C,bool,aa(B,fun(C,bool),aa(fun(B,fun(C,bool)),fun(B,fun(C,bool)),aTP_Lamp_op(set(C),fun(fun(B,fun(C,bool)),fun(B,fun(C,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(C),bool,member(C,Uuc),Uu))
        & pp(aa(C,bool,aa(B,fun(C,bool),Uua,Uub),Uuc)) ) ) ).

% ATP.lambda_1142
tff(fact_7308_ATP_Olambda__1143,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: fun(A,fun(B,bool)),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aTP_Lamp_rm(set(B),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(B),bool,member(B,Uuc),Uu))
        & pp(aa(B,bool,aa(A,fun(B,bool),Uua,Uub),Uuc)) ) ) ).

% ATP.lambda_1143
tff(fact_7309_ATP_Olambda__1144,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(B,fun(C,bool)),Uub: C,Uuc: B] :
      ( pp(aa(B,bool,aa(C,fun(B,bool),aa(fun(B,fun(C,bool)),fun(C,fun(B,bool)),aTP_Lamp_or(set(B),fun(fun(B,fun(C,bool)),fun(C,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(B),bool,member(B,Uuc),Uu))
        & pp(aa(C,bool,aa(B,fun(C,bool),Uua,Uuc),Uub)) ) ) ).

% ATP.lambda_1144
tff(fact_7310_ATP_Olambda__1145,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,fun(B,bool)),Uub: B,Uuc: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aa(fun(A,fun(B,bool)),fun(B,fun(A,bool)),aTP_Lamp_kt(set(A),fun(fun(A,fun(B,bool)),fun(B,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(A),bool,member(A,Uuc),Uu))
        & pp(aa(B,bool,aa(A,fun(B,bool),Uua,Uuc),Uub)) ) ) ).

% ATP.lambda_1145
tff(fact_7311_ATP_Olambda__1146,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: set(product_prod(B,B)),Uub: B,Uuc: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aa(set(product_prod(B,B)),fun(B,fun(A,bool)),aTP_Lamp_bbd(set(A),fun(set(product_prod(B,B)),fun(B,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(A),bool,member(A,Uuc),Uu))
        & ( aa(A,B,bNF_Greatest_toCard(A,B,Uu,Uua),Uuc) = Uub ) ) ) ).

% ATP.lambda_1146
tff(fact_7312_ATP_Olambda__1147,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(A,B),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,B),fun(A,fun(A,bool)),aTP_Lamp_kv(set(A),fun(fun(A,B),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(A),bool,member(A,Uuc),Uu))
        & ( aa(A,B,Uua,Uuc) = aa(A,B,Uua,Uub) ) ) ) ).

% ATP.lambda_1147
tff(fact_7313_ATP_Olambda__1148,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: set(A),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(A),fun(A,fun(A,bool)),aTP_Lamp_kl(fun(A,B),fun(set(A),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(A),bool,member(A,Uuc),Uua))
        & ( aa(A,B,Uu,Uub) = aa(A,B,Uu,Uuc) ) ) ) ).

% ATP.lambda_1148
tff(fact_7314_ATP_Olambda__1149,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(B,C),Uub: C,Uuc: B] :
      ( pp(aa(B,bool,aa(C,fun(B,bool),aa(fun(B,C),fun(C,fun(B,bool)),aTP_Lamp_ph(set(B),fun(fun(B,C),fun(C,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(B),bool,member(B,Uuc),Uu))
        & ( aa(B,C,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_1149
tff(fact_7315_ATP_Olambda__1150,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,B),Uub: B,Uuc: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aa(fun(A,B),fun(B,fun(A,bool)),aTP_Lamp_kk(set(A),fun(fun(A,B),fun(B,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(A),bool,member(A,Uuc),Uu))
        & ( aa(A,B,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_1150
tff(fact_7316_ATP_Olambda__1151,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: set(A),Uub: B,Uuc: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aa(set(A),fun(B,fun(A,bool)),aTP_Lamp_eo(fun(A,B),fun(set(A),fun(B,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(A),bool,member(A,Uuc),Uua))
        & ( aa(A,B,Uu,Uuc) = Uub ) ) ) ).

% ATP.lambda_1151
tff(fact_7317_ATP_Olambda__1152,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(B,A),Uub: set(B),Uuc: B] :
      ( pp(aa(B,bool,aa(set(B),fun(B,bool),aa(fun(B,A),fun(set(B),fun(B,bool)),aTP_Lamp_ky(set(A),fun(fun(B,A),fun(set(B),fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(B),bool,member(B,Uuc),Uub))
        & pp(aa(set(A),bool,member(A,aa(B,A,Uua,Uuc)),Uu)) ) ) ).

% ATP.lambda_1152
tff(fact_7318_ATP_Olambda__1153,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_vj(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uuc))) ) ) ).

% ATP.lambda_1153
tff(fact_7319_ATP_Olambda__1154,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_ul(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(Uu),Uuc)),aa(nat,nat,binomial(Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_1154
tff(fact_7320_ATP_Olambda__1155,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: list(B),Uub: list(B),Uuc: list(B)] : ( aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),aa(list(B),fun(list(B),fun(list(B),list(B))),aTP_Lamp_amr(fun(B,A),fun(list(B),fun(list(B),fun(list(B),list(B)))),Uu),Uua),Uub),Uuc) = append(B,aa(list(B),list(B),linorder_sort_key(B,A,Uu),Uua),append(B,Uub,aa(list(B),list(B),linorder_sort_key(B,A,Uu),Uuc))) ) ) ).

% ATP.lambda_1155
tff(fact_7321_ATP_Olambda__1156,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aa(int,fun(int,fun(int,bool)),aTP_Lamp_aap(int,fun(int,fun(int,fun(int,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub))) ) ).

% ATP.lambda_1156
tff(fact_7322_ATP_Olambda__1157,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aa(nat,fun(nat,fun(nat,bool)),aTP_Lamp_wq(nat,fun(nat,fun(nat,fun(nat,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua))) ) ).

% ATP.lambda_1157
tff(fact_7323_ATP_Olambda__1158,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),aa(int,fun(int,fun(int,bool)),aTP_Lamp_aan(int,fun(int,fun(int,fun(int,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub))) ) ).

% ATP.lambda_1158
tff(fact_7324_ATP_Olambda__1159,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aa(nat,fun(nat,fun(nat,bool)),aTP_Lamp_wo(nat,fun(nat,fun(nat,fun(nat,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua))) ) ).

% ATP.lambda_1159
tff(fact_7325_ATP_Olambda__1160,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_ws(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)) ) ).

% ATP.lambda_1160
tff(fact_7326_ATP_Olambda__1161,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_wu(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ).

% ATP.lambda_1161
tff(fact_7327_ATP_Olambda__1162,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: list(A),Uub: B,Uuc: list(B)] : ( aa(list(B),list(product_prod(A,B)),aa(B,fun(list(B),list(product_prod(A,B))),aa(list(A),fun(B,fun(list(B),list(product_prod(A,B)))),aTP_Lamp_amk(A,fun(list(A),fun(B,fun(list(B),list(product_prod(A,B))))),Uu),Uua),Uub),Uuc) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uu),Uub)),zip(A,B,Uua,Uuc)) ) ).

% ATP.lambda_1162
tff(fact_7328_ATP_Olambda__1163,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: list(B),Uub: A,Uuc: list(A)] : ( aa(list(A),list(product_prod(A,B)),aa(A,fun(list(A),list(product_prod(A,B))),aa(list(B),fun(A,fun(list(A),list(product_prod(A,B)))),aTP_Lamp_aml(B,fun(list(B),fun(A,fun(list(A),list(product_prod(A,B))))),Uu),Uua),Uub),Uuc) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uub),Uu)),zip(A,B,Uuc,Uua)) ) ).

% ATP.lambda_1163
tff(fact_7329_ATP_Olambda__1164,axiom,
    ! [A: $tType,B: $tType,Uu: filter(A),Uua: filter(B),Uub: fun(A,bool),Uuc: fun(B,bool)] :
      ( pp(aa(fun(B,bool),bool,aa(fun(A,bool),fun(fun(B,bool),bool),aa(filter(B),fun(fun(A,bool),fun(fun(B,bool),bool)),aTP_Lamp_qs(filter(A),fun(filter(B),fun(fun(A,bool),fun(fun(B,bool),bool))),Uu),Uua),Uub),Uuc))
    <=> ( eventually(A,Uub,Uu)
        & eventually(B,Uuc,Uua) ) ) ).

% ATP.lambda_1164
tff(fact_7330_ATP_Olambda__1165,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: B,Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(B,fun(A,fun(B,bool)),aTP_Lamp_et(A,fun(B,fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( ( Uu = Uub )
        & ( Uua = Uuc ) ) ) ).

% ATP.lambda_1165
tff(fact_7331_ATP_Olambda__1166,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aa(nat,fun(nat,fun(nat,bool)),aTP_Lamp_xb(nat,fun(nat,fun(nat,fun(nat,bool))),Uu),Uua),Uub),Uuc))
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua) ) ) ).

% ATP.lambda_1166
tff(fact_7332_ATP_Olambda__1167,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: set(B),Uub: fun(A,bool),Uuc: B] :
      ( pp(aa(B,bool,aa(fun(A,bool),fun(B,bool),aa(set(B),fun(fun(A,bool),fun(B,bool)),aTP_Lamp_ce(fun(B,A),fun(set(B),fun(fun(A,bool),fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(B),bool,member(B,Uuc),Uua))
        & pp(aa(A,bool,Uub,aa(B,A,Uu,Uuc))) ) ) ).

% ATP.lambda_1167
tff(fact_7333_ATP_Olambda__1168,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,set(product_prod(A,B))),Uua: C,Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(C,fun(A,fun(B,bool)),aTP_Lamp_hi(fun(C,set(product_prod(A,B))),fun(C,fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(set(product_prod(A,B)),bool,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uub),Uuc)),aa(C,set(product_prod(A,B)),Uu,Uua))) ) ).

% ATP.lambda_1168
tff(fact_7334_ATP_Olambda__1169,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aTP_Lamp_lj(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),Uu),Uua),Uub),Uuc))
        <=> ( pp(aa(set(B),bool,member(B,Uuc),Uu))
            & ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uua,Uuc)),aa(B,A,Uub,Uuc)) != one_one(A) ) ) ) ) ).

% ATP.lambda_1169
tff(fact_7335_ATP_Olambda__1170,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aTP_Lamp_ll(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),Uu),Uua),Uub),Uuc))
        <=> ( pp(aa(set(B),bool,member(B,Uuc),Uu))
            & ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uua,Uuc)),aa(B,A,Uub,Uuc)) != zero_zero(A) ) ) ) ) ).

% ATP.lambda_1170
tff(fact_7336_ATP_Olambda__1171,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: set(B),Uub: fun(B,A),Uuc: B] :
      ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aa(set(B),fun(fun(B,A),fun(B,bool)),aTP_Lamp_asg(A,fun(set(B),fun(fun(B,A),fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(B),bool,member(B,Uuc),Uua))
        & ( aa(B,A,Uub,Uuc) != Uu ) ) ) ).

% ATP.lambda_1171
tff(fact_7337_ATP_Olambda__1172,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: fun(B,A),Uub: set(B),Uuc: B] :
      ( pp(aa(B,bool,aa(set(B),fun(B,bool),aa(fun(B,A),fun(set(B),fun(B,bool)),aTP_Lamp_atq(A,fun(fun(B,A),fun(set(B),fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(B),bool,member(B,Uuc),Uub))
        & ( aa(B,A,Uua,Uuc) != Uu ) ) ) ).

% ATP.lambda_1172
tff(fact_7338_ATP_Olambda__1173,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_ajg(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,aa(nat,B,nth(B,Uub),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uuc)) ) ) ).

% ATP.lambda_1173
tff(fact_7339_ATP_Olambda__1174,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(B,bool),Uub: fun(A,B),Uuc: A] :
      ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),aTP_Lamp_pw(set(A),fun(fun(B,bool),fun(fun(A,B),fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(B,bool,Uua,aa(A,B,Uub,Uuc)))
        & pp(aa(set(A),bool,member(A,Uuc),Uu)) ) ) ).

% ATP.lambda_1174
tff(fact_7340_ATP_Olambda__1175,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: set(B),Uub: fun(A,bool),Uuc: B] :
      ( pp(aa(B,bool,aa(fun(A,bool),fun(B,bool),aa(set(B),fun(fun(A,bool),fun(B,bool)),aTP_Lamp_bbk(fun(B,A),fun(set(B),fun(fun(A,bool),fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(A,bool,Uub,aa(B,A,Uu,Uuc)))
        & pp(aa(set(B),bool,member(B,Uuc),Uua)) ) ) ).

% ATP.lambda_1175
tff(fact_7341_ATP_Olambda__1176,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(A,B),Uub: fun(B,bool),Uuc: A] :
      ( pp(aa(A,bool,aa(fun(B,bool),fun(A,bool),aa(fun(A,B),fun(fun(B,bool),fun(A,bool)),aTP_Lamp_afg(set(A),fun(fun(A,B),fun(fun(B,bool),fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(B,bool,Uub,aa(A,B,Uua,Uuc)))
        & pp(aa(set(A),bool,member(A,Uuc),Uu)) ) ) ).

% ATP.lambda_1176
tff(fact_7342_ATP_Olambda__1177,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,bool),Uua: fun(A,fun(B,bool)),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aTP_Lamp_dp(fun(A,bool),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(A,bool,Uu,Uub))
        & pp(aa(B,bool,aa(A,fun(B,bool),Uua,Uub),Uuc)) ) ) ).

% ATP.lambda_1177
tff(fact_7343_ATP_Olambda__1178,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,Uu: fun(C,set(A)),Uua: fun(D,set(B)),Uub: C,Uuc: D] : ( aa(D,set(product_prod(A,B)),aa(C,fun(D,set(product_prod(A,B))),aa(fun(D,set(B)),fun(C,fun(D,set(product_prod(A,B)))),aTP_Lamp_fq(fun(C,set(A)),fun(fun(D,set(B)),fun(C,fun(D,set(product_prod(A,B))))),Uu),Uua),Uub),Uuc) = product_Sigma(A,B,aa(C,set(A),Uu,Uub),aa(D,fun(A,set(B)),aTP_Lamp_fp(fun(D,set(B)),fun(D,fun(A,set(B))),Uua),Uuc)) ) ).

% ATP.lambda_1178
tff(fact_7344_ATP_Olambda__1179,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,A),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,A),fun(A,fun(A,bool)),aTP_Lamp_tq(fun(A,bool),fun(fun(A,A),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(A,bool,Uu,Uuc))
        & ( Uub = aa(A,A,Uua,Uuc) ) ) ) ).

% ATP.lambda_1179
tff(fact_7345_ATP_Olambda__1180,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B,Uuc: A] : ( aa(A,A,aa(B,fun(A,A),aa(A,fun(B,fun(A,A)),aTP_Lamp_aje(fun(B,A),fun(A,fun(B,fun(A,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uuc)) ) ) ).

% ATP.lambda_1180
tff(fact_7346_ATP_Olambda__1181,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( semiring_0(B)
        & comm_monoid_add(A)
        & times(A) )
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: A,Uuc: C] : ( aa(C,B,aa(A,fun(C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_apo(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(C,B,Uua,Uuc)) ) ) ).

% ATP.lambda_1181
tff(fact_7347_ATP_Olambda__1182,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,nat),Uua: fun(B,nat),Uub: A,Uuc: B] : ( aa(B,nat,aa(A,fun(B,nat),aa(fun(B,nat),fun(A,fun(B,nat)),aTP_Lamp_ahg(fun(A,nat),fun(fun(B,nat),fun(A,fun(B,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,Uu,Uub)),aa(B,nat,Uua,Uuc)) ) ).

% ATP.lambda_1182
tff(fact_7348_ATP_Olambda__1183,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: A,Uuc: C] : ( aa(C,B,aa(A,fun(C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_ot(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(C,B,Uua,Uuc)) ) ) ).

% ATP.lambda_1183
tff(fact_7349_ATP_Olambda__1184,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(A)),Uub: B,Uuc: C] : ( aa(C,set(A),aa(B,fun(C,set(A)),aa(fun(C,set(A)),fun(B,fun(C,set(A))),aTP_Lamp_il(fun(B,set(A)),fun(fun(C,set(A)),fun(B,fun(C,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(B,set(A),Uu,Uub)),aa(C,set(A),Uua,Uuc)) ) ).

% ATP.lambda_1184
tff(fact_7350_ATP_Olambda__1185,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_ie(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(C,A,Uua,Uuc)) ) ) ).

% ATP.lambda_1185
tff(fact_7351_ATP_Olambda__1186,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(A)),Uub: B,Uuc: C] : ( aa(C,set(A),aa(B,fun(C,set(A)),aa(fun(C,set(A)),fun(B,fun(C,set(A))),aTP_Lamp_gk(fun(B,set(A)),fun(fun(C,set(A)),fun(B,fun(C,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(B,set(A),Uu,Uub)),aa(C,set(A),Uua,Uuc)) ) ).

% ATP.lambda_1186
tff(fact_7352_ATP_Olambda__1187,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_ga(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(C,A,Uua,Uuc)) ) ) ).

% ATP.lambda_1187
tff(fact_7353_ATP_Olambda__1188,axiom,
    ! [B: $tType,A: $tType,Uu: fun(set(old_node(A,B)),set(set(old_node(A,B)))),Uua: fun(set(old_node(A,B)),set(set(old_node(A,B)))),Uub: set(old_node(A,B)),Uuc: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),set(set(old_node(A,B)))),aa(fun(set(old_node(A,B)),set(set(old_node(A,B)))),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(set(old_node(A,B))))),aTP_Lamp_azp(fun(set(old_node(A,B)),set(set(old_node(A,B)))),fun(fun(set(old_node(A,B)),set(set(old_node(A,B)))),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(set(old_node(A,B)))))),Uu),Uua),Uub),Uuc) = old_uprod(A,B,aa(set(old_node(A,B)),set(set(old_node(A,B))),Uu,Uub),aa(set(old_node(A,B)),set(set(old_node(A,B))),Uua,Uuc)) ) ).

% ATP.lambda_1188
tff(fact_7354_ATP_Olambda__1189,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Uu: fun(A,filter(C)),Uua: fun(B,filter(D)),Uub: A,Uuc: B] : ( aa(B,filter(product_prod(C,D)),aa(A,fun(B,filter(product_prod(C,D))),aa(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D)))),aTP_Lamp_qz(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D))))),Uu),Uua),Uub),Uuc) = prod_filter(C,D,aa(A,filter(C),Uu,Uub),aa(B,filter(D),Uua,Uuc)) ) ).

% ATP.lambda_1189
tff(fact_7355_ATP_Olambda__1190,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Uu: fun(C,A),Uua: fun(D,B),Uub: C,Uuc: D] : ( aa(D,product_prod(A,B),aa(C,fun(D,product_prod(A,B)),aa(fun(D,B),fun(C,fun(D,product_prod(A,B))),aTP_Lamp_ek(fun(C,A),fun(fun(D,B),fun(C,fun(D,product_prod(A,B)))),Uu),Uua),Uub),Uuc) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,Uu,Uub)),aa(D,B,Uua,Uuc)) ) ).

% ATP.lambda_1190
tff(fact_7356_ATP_Olambda__1191,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Uu: fun(A,C),Uua: fun(B,D),Uub: A,Uuc: B] : ( aa(B,product_prod(C,D),aa(A,fun(B,product_prod(C,D)),aa(fun(B,D),fun(A,fun(B,product_prod(C,D))),aTP_Lamp_ant(fun(A,C),fun(fun(B,D),fun(A,fun(B,product_prod(C,D)))),Uu),Uua),Uub),Uuc) = aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(A,C,Uu,Uub)),aa(B,D,Uua,Uuc)) ) ).

% ATP.lambda_1191
tff(fact_7357_ATP_Olambda__1192,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,bool),Uua: fun(B,bool),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(B,bool),fun(A,fun(B,bool)),aTP_Lamp_cv(fun(A,bool),fun(fun(B,bool),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(A,bool,Uu,Uub))
        & pp(aa(B,bool,Uua,Uuc)) ) ) ).

% ATP.lambda_1192
tff(fact_7358_ATP_Olambda__1193,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: fun(list(B),A),Uub: list(B),Uuc: B] :
          ( pp(aa(B,bool,aa(list(B),fun(B,bool),aa(fun(list(B),A),fun(list(B),fun(B,bool)),aTP_Lamp_alk(fun(B,A),fun(fun(list(B),A),fun(list(B),fun(B,bool))),Uu),Uua),Uub),Uuc))
        <=> ( aa(B,A,Uu,Uuc) = aa(list(B),A,Uua,Uub) ) ) ) ).

% ATP.lambda_1193
tff(fact_7359_ATP_Olambda__1194,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: set(C),Uua: fun(B,fun(C,A)),Uub: fun(B,fun(C,bool)),Uuc: B] : ( aa(B,A,aa(fun(B,fun(C,bool)),fun(B,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A)),aTP_Lamp_oq(set(C),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),aa(B,fun(C,A),Uua,Uuc)),aa(fun(C,bool),set(C),collect(C),aa(B,fun(C,bool),aa(fun(B,fun(C,bool)),fun(B,fun(C,bool)),aTP_Lamp_op(set(C),fun(fun(B,fun(C,bool)),fun(B,fun(C,bool))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1194
tff(fact_7360_ATP_Olambda__1195,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: set(C),Uua: fun(B,fun(C,A)),Uub: fun(B,fun(C,bool)),Uuc: B] : ( aa(B,A,aa(fun(B,fun(C,bool)),fun(B,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A)),aTP_Lamp_oy(set(C),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(B,fun(C,A),Uua,Uuc)),aa(fun(C,bool),set(C),collect(C),aa(B,fun(C,bool),aa(fun(B,fun(C,bool)),fun(B,fun(C,bool)),aTP_Lamp_op(set(C),fun(fun(B,fun(C,bool)),fun(B,fun(C,bool))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1195
tff(fact_7361_ATP_Olambda__1196,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: list(B),Uub: B,Uuc: list(B)] : ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),aa(list(B),fun(B,fun(list(B),list(B))),aTP_Lamp_amt(fun(B,A),fun(list(B),fun(B,fun(list(B),list(B)))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(B),product_prod(list(B),list(B))),list(B),aa(fun(list(B),fun(product_prod(list(B),list(B)),list(B))),fun(product_prod(list(B),product_prod(list(B),list(B))),list(B)),product_case_prod(list(B),product_prod(list(B),list(B)),list(B)),aTP_Lamp_ams(fun(B,A),fun(list(B),fun(product_prod(list(B),list(B)),list(B))),Uu)),linorder_part(B,A,Uu,aa(B,A,Uu,aa(nat,B,nth(B,Uua),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(B),nat,size_size(list(B)),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),Uua)) ) ) ).

% ATP.lambda_1196
tff(fact_7362_ATP_Olambda__1197,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(A,bool)),Uua: fun(B,A),Uub: B,Uuc: B] :
      ( pp(aa(B,bool,aa(B,fun(B,bool),aa(fun(B,A),fun(B,fun(B,bool)),aTP_Lamp_sb(fun(A,fun(A,bool)),fun(fun(B,A),fun(B,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( ( aa(B,A,Uua,Uub) != aa(B,A,Uua,Uuc) )
       => pp(aa(A,bool,aa(A,fun(A,bool),Uu,aa(B,A,Uua,Uub)),aa(B,A,Uua,Uuc))) ) ) ).

% ATP.lambda_1197
tff(fact_7363_ATP_Olambda__1198,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,set(B)),Uua: set(B),Uub: set(B),Uuc: A] :
      ( pp(aa(A,bool,aa(set(B),fun(A,bool),aa(set(B),fun(set(B),fun(A,bool)),aTP_Lamp_nz(fun(A,set(B)),fun(set(B),fun(set(B),fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(set(B),bool,finite_finite2(B),aa(A,set(B),Uu,Uuc)))
        & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),Uub),aa(A,set(B),Uu,Uuc)))
        & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),Uu,Uuc)),Uua)) ) ) ).

% ATP.lambda_1198
tff(fact_7364_ATP_Olambda__1199,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(B,C),Uuc: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(A,B),fun(fun(B,C),fun(B,C)),aTP_Lamp_rs(set(A),fun(fun(A,B),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(nat,C,semiring_1_of_nat(C),aa(set(A),nat,finite_card(A),aa(fun(A,bool),set(A),collect(A),aa(B,fun(A,bool),aa(fun(A,B),fun(B,fun(A,bool)),aTP_Lamp_kk(set(A),fun(fun(A,B),fun(B,fun(A,bool))),Uu),Uua),Uuc))))),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_1199
tff(fact_7365_ATP_Olambda__1200,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(set(old_node(A,B)),C),Uua: fun(set(old_node(A,B)),C),Uub: set(old_node(A,B)),Uuc: C] :
      ( pp(aa(C,bool,aa(set(old_node(A,B)),fun(C,bool),aa(fun(set(old_node(A,B)),C),fun(set(old_node(A,B)),fun(C,bool)),aTP_Lamp_azc(fun(set(old_node(A,B)),C),fun(fun(set(old_node(A,B)),C),fun(set(old_node(A,B)),fun(C,bool))),Uu),Uua),Uub),Uuc))
    <=> ( ? [X3: set(old_node(A,B))] :
            ( ( Uub = old_In0(A,B,X3) )
            & ( Uuc = aa(set(old_node(A,B)),C,Uu,X3) ) )
        | ? [Y4: set(old_node(A,B))] :
            ( ( Uub = old_In1(A,B,Y4) )
            & ( Uuc = aa(set(old_node(A,B)),C,Uua,Y4) ) ) ) ) ).

% ATP.lambda_1200
tff(fact_7366_ATP_Olambda__1201,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: fun(A,fun(A,bool)),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aTP_Lamp_kz(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( ? [A6: A] :
            ( ( Uub = A6 )
            & ( Uuc = A6 ) )
        | ? [A6: A,B5: A,C5: A] :
            ( ( Uub = A6 )
            & ( Uuc = C5 )
            & pp(aa(A,bool,aa(A,fun(A,bool),Uua,A6),B5))
            & pp(aa(A,bool,aa(A,fun(A,bool),Uu,B5),C5)) ) ) ) ).

% ATP.lambda_1201
tff(fact_7367_ATP_Olambda__1202,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: fun(A,fun(A,bool)),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aTP_Lamp_la(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( ? [A6: A,B5: A] :
            ( ( Uub = A6 )
            & ( Uuc = B5 )
            & pp(aa(A,bool,aa(A,fun(A,bool),Uu,A6),B5)) )
        | ? [A6: A,B5: A,C5: A] :
            ( ( Uub = A6 )
            & ( Uuc = C5 )
            & pp(aa(A,bool,aa(A,fun(A,bool),Uua,A6),B5))
            & pp(aa(A,bool,aa(A,fun(A,bool),Uu,B5),C5)) ) ) ) ).

% ATP.lambda_1202
tff(fact_7368_ATP_Olambda__1203,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: fun(list(A),fun(list(A),bool)),Uub: list(A),Uuc: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool)),aTP_Lamp_aiq(fun(A,fun(A,bool)),fun(fun(list(A),fun(list(A),bool)),fun(list(A),fun(list(A),bool))),Uu),Uua),Uub),Uuc))
    <=> ( ? [Y4: A,Ys2: list(A)] :
            ( ( Uub = nil(A) )
            & ( Uuc = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y4),Ys2) ) )
        | ? [X3: A,Y4: A,Xs3: list(A),Ys2: list(A)] :
            ( ( Uub = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X3),Xs3) )
            & ( Uuc = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y4),Ys2) )
            & pp(aa(A,bool,aa(A,fun(A,bool),Uu,X3),Y4)) )
        | ? [X3: A,Y4: A,Xs3: list(A),Ys2: list(A)] :
            ( ( Uub = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X3),Xs3) )
            & ( Uuc = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y4),Ys2) )
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),Uu,X3),Y4))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),Uu,Y4),X3))
            & pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),Uua,Xs3),Ys2)) ) ) ) ).

% ATP.lambda_1203
tff(fact_7369_ATP_Olambda__1204,axiom,
    ! [A: $tType,B: $tType,Uu: bool,Uua: fun(A,fun(B,assn)),Uub: A,Uuc: B] : ( aa(B,assn,aa(A,fun(B,assn),aa(fun(A,fun(B,assn)),fun(A,fun(B,assn)),aTP_Lamp_ac(bool,fun(fun(A,fun(B,assn)),fun(A,fun(B,assn))),Uu),Uua),Uub),Uuc) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),pure_assn(Uu)),aa(B,assn,aa(A,fun(B,assn),Uua,Uub),Uuc)) ) ).

% ATP.lambda_1204
tff(fact_7370_ATP_Olambda__1205,axiom,
    ! [A: $tType,Uu: A,Uua: list(A),Uub: A,Uuc: nat] : ( aa(nat,list(A),aa(A,fun(nat,list(A)),aa(list(A),fun(A,fun(nat,list(A))),aTP_Lamp_ajm(A,fun(list(A),fun(A,fun(nat,list(A)))),Uu),Uua),Uub),Uuc) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uu),list_update(A,Uua,Uuc,Uub)) ) ).

% ATP.lambda_1205
tff(fact_7371_ATP_Olambda__1206,axiom,
    ! [A: $tType,B: $tType,Uu: bool,Uua: fun(A,fun(B,bool)),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aTP_Lamp_cs(bool,fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(Uu)
        & pp(aa(B,bool,aa(A,fun(B,bool),Uua,Uub),Uuc)) ) ) ).

% ATP.lambda_1206
tff(fact_7372_ATP_Olambda__1207,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: fun(A,A),Uub: array(A),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(fun(A,A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awb(nat,fun(fun(A,A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_Pair(array(A),product_prod(heap_ext(product_unit),nat)),Uub),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(A,Uub,Uu,aa(A,A,Uua,aa(nat,A,nth(A,array_get(A,Uuc,Uub)),Uu)),Uuc)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_1207
tff(fact_7373_ATP_Olambda__1208,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: A,Uub: array(A),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(A,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awc(nat,fun(A,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_Pair(array(A),product_prod(heap_ext(product_unit),nat)),Uub),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(A,Uub,Uu,Uua,Uuc)),one_one(nat))) ) ) ).

% ATP.lambda_1208
tff(fact_7374_ATP_Olambda__1209,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(C,A),Uua: fun(C,B),Uub: set(C),Uuc: A] : ( aa(A,set(B),aa(set(C),fun(A,set(B)),aa(fun(C,B),fun(set(C),fun(A,set(B))),aTP_Lamp_cp(fun(C,A),fun(fun(C,B),fun(set(C),fun(A,set(B)))),Uu),Uua),Uub),Uuc) = aa(set(C),set(B),image2(C,B,Uua),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(A),set(C),aa(fun(C,A),fun(set(A),set(C)),vimage(C,A),Uu),aa(set(A),set(A),insert(A,Uuc),bot_bot(set(A))))),Uub)) ) ).

% ATP.lambda_1209
tff(fact_7375_ATP_Olambda__1210,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,heap_Time_Heap(A)),Uua: B,Uub: heap_ext(product_unit),Uuc: nat] : ( aa(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(B,fun(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_axl(fun(B,heap_Time_Heap(A)),fun(B,fun(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua),Uub),Uuc) = heap_Time_timeFrame(A,Uuc,aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(A,aa(B,heap_Time_Heap(A),Uu,Uua)),Uub)) ) ).

% ATP.lambda_1210
tff(fact_7376_ATP_Olambda__1211,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,heap_Time_Heap(B)),Uua: A,Uub: heap_ext(product_unit),Uuc: nat] : ( aa(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(A,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_axh(fun(A,heap_Time_Heap(B)),fun(A,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua),Uub),Uuc) = heap_Time_timeFrame(B,Uuc,aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(B,aa(A,heap_Time_Heap(B),Uu,Uua)),Uub)) ) ).

% ATP.lambda_1211
tff(fact_7377_ATP_Olambda__1212,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),option(bool),aa(A,fun(list(A),option(bool)),aa(list(A),fun(A,fun(list(A),option(bool))),aTP_Lamp_ani(list(A),fun(list(A),fun(A,fun(list(A),option(bool)))),Uu),Uua),Uub),Uuc) = subset_eq_mset_impl(A,Uu,append(A,Uua,Uuc)) ) ).

% ATP.lambda_1212
tff(fact_7378_ATP_Olambda__1213,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: fun(B,C),Uuc: C] : ( aa(C,A,aa(fun(B,C),fun(C,A),aa(fun(B,A),fun(fun(B,C),fun(C,A)),aTP_Lamp_pi(set(B),fun(fun(B,A),fun(fun(B,C),fun(C,A))),Uu),Uua),Uub),Uuc) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),Uua),aa(fun(B,bool),set(B),collect(B),aa(C,fun(B,bool),aa(fun(B,C),fun(C,fun(B,bool)),aTP_Lamp_ph(set(B),fun(fun(B,C),fun(C,fun(B,bool))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1213
tff(fact_7379_ATP_Olambda__1214,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(B,A),Uuc: C] : ( aa(C,A,aa(fun(B,A),fun(C,A),aa(fun(B,C),fun(fun(B,A),fun(C,A)),aTP_Lamp_pp(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))),Uu),Uua),Uub),Uuc) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),Uub),aa(fun(B,bool),set(B),collect(B),aa(C,fun(B,bool),aa(fun(B,C),fun(C,fun(B,bool)),aTP_Lamp_ph(set(B),fun(fun(B,C),fun(C,fun(B,bool))),Uu),Uua),Uuc))) ) ) ).

% ATP.lambda_1214
tff(fact_7380_ATP_Olambda__1215,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: fun(B,C),Uuc: C] : ( aa(C,A,aa(fun(B,C),fun(C,A),aa(fun(B,A),fun(fun(B,C),fun(C,A)),aTP_Lamp_pk(set(B),fun(fun(B,A),fun(fun(B,C),fun(C,A))),Uu),Uua),Uub),Uuc) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),Uua),aa(fun(B,bool),set(B),collect(B),aa(C,fun(B,bool),aa(fun(B,C),fun(C,fun(B,bool)),aTP_Lamp_ph(set(B),fun(fun(B,C),fun(C,fun(B,bool))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1215
tff(fact_7381_ATP_Olambda__1216,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(B,A),Uuc: C] : ( aa(C,A,aa(fun(B,A),fun(C,A),aa(fun(B,C),fun(fun(B,A),fun(C,A)),aTP_Lamp_ps(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))),Uu),Uua),Uub),Uuc) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),Uub),aa(fun(B,bool),set(B),collect(B),aa(C,fun(B,bool),aa(fun(B,C),fun(C,fun(B,bool)),aTP_Lamp_ph(set(B),fun(fun(B,C),fun(C,fun(B,bool))),Uu),Uua),Uuc))) ) ) ).

% ATP.lambda_1216
tff(fact_7382_ATP_Olambda__1217,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: A,Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),A,aa(A,fun(list(A),A),aa(list(A),fun(A,fun(list(A),A)),aTP_Lamp_amg(A,fun(list(A),fun(A,fun(list(A),A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),ord_min(A),Uu),min_list(A,Uua)) ) ) ).

% ATP.lambda_1217
tff(fact_7383_ATP_Olambda__1218,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType,Uu: fun(C,D),Uua: fun(A,fun(B,C)),Uub: A,Uuc: B] : ( aa(B,D,aa(A,fun(B,D),aa(fun(A,fun(B,C)),fun(A,fun(B,D)),aTP_Lamp_dg(fun(C,D),fun(fun(A,fun(B,C)),fun(A,fun(B,D))),Uu),Uua),Uub),Uuc) = aa(C,D,Uu,aa(B,C,aa(A,fun(B,C),Uua,Uub),Uuc)) ) ).

% ATP.lambda_1218
tff(fact_7384_ATP_Olambda__1219,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(B,C),Uua: fun(A,fun(list(A),B)),Uub: A,Uuc: list(A)] : ( aa(list(A),C,aa(A,fun(list(A),C),aa(fun(A,fun(list(A),B)),fun(A,fun(list(A),C)),aTP_Lamp_alz(fun(B,C),fun(fun(A,fun(list(A),B)),fun(A,fun(list(A),C))),Uu),Uua),Uub),Uuc) = aa(B,C,Uu,aa(list(A),B,aa(A,fun(list(A),B),Uua,Uub),Uuc)) ) ).

% ATP.lambda_1219
tff(fact_7385_ATP_Olambda__1220,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_wh(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_1220
tff(fact_7386_ATP_Olambda__1221,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_wf(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_1221
tff(fact_7387_ATP_Olambda__1222,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_asv(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ).

% ATP.lambda_1222
tff(fact_7388_ATP_Olambda__1223,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_sh(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_1223
tff(fact_7389_ATP_Olambda__1224,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_sg(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_1224
tff(fact_7390_ATP_Olambda__1225,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_ass(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ).

% ATP.lambda_1225
tff(fact_7391_ATP_Olambda__1226,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: nat,Uub: list(A),Uuc: nat] :
      ( pp(aa(nat,bool,aa(list(A),fun(nat,bool),aa(nat,fun(list(A),fun(nat,bool)),aTP_Lamp_aqn(fun(A,bool),fun(nat,fun(list(A),fun(nat,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(A,bool,Uu,aa(nat,A,nth(A,take(A,Uua,Uub)),Uuc))) ) ).

% ATP.lambda_1226
tff(fact_7392_ATP_Olambda__1227,axiom,
    ! [A: $tType,D: $tType,B: $tType,C: $tType,Uu: fun(product_prod(B,C),A),Uua: fun(D,B),Uub: D,Uuc: C] : ( aa(C,A,aa(D,fun(C,A),aa(fun(D,B),fun(D,fun(C,A)),aTP_Lamp_ajx(fun(product_prod(B,C),A),fun(fun(D,B),fun(D,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(product_prod(B,C),A,Uu,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Uua,Uub)),Uuc)) ) ).

% ATP.lambda_1227
tff(fact_7393_ATP_Olambda__1228,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Uu: fun(product_prod(B,C),A),Uua: fun(D,C),Uub: B,Uuc: D] : ( aa(D,A,aa(B,fun(D,A),aa(fun(D,C),fun(B,fun(D,A)),aTP_Lamp_ajy(fun(product_prod(B,C),A),fun(fun(D,C),fun(B,fun(D,A))),Uu),Uua),Uub),Uuc) = aa(product_prod(B,C),A,Uu,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uub),aa(D,C,Uua,Uuc))) ) ).

% ATP.lambda_1228
tff(fact_7394_ATP_Olambda__1229,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(C,fun(B,heap_Time_Heap(A))),Uua: fun(C,C),Uub: fun(fun(B,heap_Time_Heap(A)),C),Uuc: fun(B,heap_Time_Heap(A))] : ( aa(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)))),aTP_Lamp_baq(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))))),Uu),Uua),Uub),Uuc) = aa(C,fun(B,heap_Time_Heap(A)),Uu,aa(C,C,Uua,aa(fun(B,heap_Time_Heap(A)),C,Uub,Uuc))) ) ).

% ATP.lambda_1229
tff(fact_7395_ATP_Olambda__1230,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(C,fun(B,option(A))),Uua: fun(C,C),Uub: fun(fun(B,option(A)),C),Uuc: fun(B,option(A))] : ( aa(fun(B,option(A)),fun(B,option(A)),aa(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A))),aa(fun(C,C),fun(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A)))),aTP_Lamp_bai(fun(C,fun(B,option(A))),fun(fun(C,C),fun(fun(fun(B,option(A)),C),fun(fun(B,option(A)),fun(B,option(A))))),Uu),Uua),Uub),Uuc) = aa(C,fun(B,option(A)),Uu,aa(C,C,Uua,aa(fun(B,option(A)),C,Uub,Uuc))) ) ).

% ATP.lambda_1230
tff(fact_7396_ATP_Olambda__1231,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(C,fun(B,A)),Uua: fun(C,C),Uub: fun(fun(B,A),C),Uuc: fun(B,A)] : ( aa(fun(B,A),fun(B,A),aa(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A))),aTP_Lamp_bag(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)))),Uu),Uua),Uub),Uuc) = aa(C,fun(B,A),Uu,aa(C,C,Uua,aa(fun(B,A),C,Uub,Uuc))) ) ).

% ATP.lambda_1231
tff(fact_7397_ATP_Olambda__1232,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(D,C),Uub: fun(B,D),Uuc: A] : ( aa(A,C,aa(fun(B,D),fun(A,C),aa(fun(D,C),fun(fun(B,D),fun(A,C)),aTP_Lamp_bbc(fun(A,B),fun(fun(D,C),fun(fun(B,D),fun(A,C))),Uu),Uua),Uub),Uuc) = aa(D,C,Uua,aa(B,D,Uub,aa(A,B,Uu,Uuc))) ) ).

% ATP.lambda_1232
tff(fact_7398_ATP_Olambda__1233,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Uu: fun(A,fun(C,bool)),Uua: fun(B,fun(D,bool)),Uub: A,Uuc: B] : ( aa(B,fun(product_prod(C,D),bool),aa(A,fun(B,fun(product_prod(C,D),bool)),aa(fun(B,fun(D,bool)),fun(A,fun(B,fun(product_prod(C,D),bool))),aTP_Lamp_aoy(fun(A,fun(C,bool)),fun(fun(B,fun(D,bool)),fun(A,fun(B,fun(product_prod(C,D),bool)))),Uu),Uua),Uub),Uuc) = aa(fun(C,fun(D,bool)),fun(product_prod(C,D),bool),product_case_prod(C,D,bool),aa(B,fun(C,fun(D,bool)),aa(A,fun(B,fun(C,fun(D,bool))),aa(fun(B,fun(D,bool)),fun(A,fun(B,fun(C,fun(D,bool)))),aTP_Lamp_aox(fun(A,fun(C,bool)),fun(fun(B,fun(D,bool)),fun(A,fun(B,fun(C,fun(D,bool))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_1233
tff(fact_7399_ATP_Olambda__1234,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B,Uuc: list(B)] : ( aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),aa(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),aa(A,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))))),aTP_Lamp_akr(fun(B,A),fun(A,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))))),Uu),Uua),Uub),Uuc) = aa(fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_case_prod(list(B),list(B),product_prod(list(B),product_prod(list(B),list(B)))),aa(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))),aa(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))),aa(A,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))))),aTP_Lamp_akq(fun(B,A),fun(A,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))))),Uu),Uua),Uub),Uuc)) ) ) ).

% ATP.lambda_1234
tff(fact_7400_ATP_Olambda__1235,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(B,B)),Uub: A,Uuc: B] : ( aa(B,fun(product_prod(A,B),bool),aa(A,fun(B,fun(product_prod(A,B),bool)),aa(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),bool))),aTP_Lamp_jr(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),bool)))),Uu),Uua),Uub),Uuc) = aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(B,fun(A,fun(B,bool)),aa(A,fun(B,fun(A,fun(B,bool))),aa(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,bool)))),aTP_Lamp_jq(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,bool))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_1235
tff(fact_7401_ATP_Olambda__1236,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,bool),Uua: fun(A,set(product_prod(B,B))),Uub: A,Uuc: B] : ( aa(B,fun(product_prod(A,B),bool),aa(A,fun(B,fun(product_prod(A,B),bool)),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),bool))),aTP_Lamp_jp(fun(A,bool),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),bool)))),Uu),Uua),Uub),Uuc) = aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(B,fun(A,fun(B,bool)),aa(A,fun(B,fun(A,fun(B,bool))),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,bool)))),aTP_Lamp_jo(fun(A,bool),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,bool))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_1236
tff(fact_7402_ATP_Olambda__1237,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( semiring_0(B)
        & comm_monoid_add(A)
        & times(A) )
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: multiset(C),Uuc: A] : ( aa(A,B,aa(multiset(C),fun(A,B),aa(fun(C,B),fun(multiset(C),fun(A,B)),aTP_Lamp_app(fun(A,B),fun(fun(C,B),fun(multiset(C),fun(A,B))),Uu),Uua),Uub),Uuc) = comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(A,fun(C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_apo(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_1237
tff(fact_7403_ATP_Olambda__1238,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(A)),Uub: set(C),Uuc: B] : ( aa(B,set(A),aa(set(C),fun(B,set(A)),aa(fun(C,set(A)),fun(set(C),fun(B,set(A))),aTP_Lamp_gl(fun(B,set(A)),fun(fun(C,set(A)),fun(set(C),fun(B,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(B,fun(C,set(A)),aa(fun(C,set(A)),fun(B,fun(C,set(A))),aTP_Lamp_gk(fun(B,set(A)),fun(fun(C,set(A)),fun(B,fun(C,set(A)))),Uu),Uua),Uuc)),Uub)) ) ).

% ATP.lambda_1238
tff(fact_7404_ATP_Olambda__1239,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: set(C),Uuc: B] : ( aa(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_gb(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_ga(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_1239
tff(fact_7405_ATP_Olambda__1240,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Uu: set(B),Uua: fun(A,filter(C)),Uub: fun(B,filter(D)),Uuc: A] : ( aa(A,filter(product_prod(C,D)),aa(fun(B,filter(D)),fun(A,filter(product_prod(C,D))),aa(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D)))),aTP_Lamp_ra(set(B),fun(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D))))),Uu),Uua),Uub),Uuc) = aa(set(filter(product_prod(C,D))),filter(product_prod(C,D)),complete_Inf_Inf(filter(product_prod(C,D))),aa(set(B),set(filter(product_prod(C,D))),image2(B,filter(product_prod(C,D)),aa(A,fun(B,filter(product_prod(C,D))),aa(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D)))),aTP_Lamp_qz(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D))))),Uua),Uub),Uuc)),Uu)) ) ).

% ATP.lambda_1240
tff(fact_7406_ATP_Olambda__1241,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(A)),Uub: set(C),Uuc: B] : ( aa(B,set(A),aa(set(C),fun(B,set(A)),aa(fun(C,set(A)),fun(set(C),fun(B,set(A))),aTP_Lamp_im(fun(B,set(A)),fun(fun(C,set(A)),fun(set(C),fun(B,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(B,fun(C,set(A)),aa(fun(C,set(A)),fun(B,fun(C,set(A))),aTP_Lamp_il(fun(B,set(A)),fun(fun(C,set(A)),fun(B,fun(C,set(A)))),Uu),Uua),Uuc)),Uub)) ) ).

% ATP.lambda_1241
tff(fact_7407_ATP_Olambda__1242,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: set(C),Uuc: B] : ( aa(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_if(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_ie(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_1242
tff(fact_7408_ATP_Olambda__1243,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aat(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_1243
tff(fact_7409_ATP_Olambda__1244,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aav(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_1244
tff(fact_7410_ATP_Olambda__1245,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),option(product_prod(list(A),product_prod(A,list(A)))),aa(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_amm(fun(A,bool),fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),takeWhile(A,aa(fun(A,bool),fun(A,bool),comp(bool,bool,A,fNot),Uu),Uua)),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),Uub),Uuc))) ) ).

% ATP.lambda_1245
tff(fact_7411_ATP_Olambda__1246,axiom,
    ! [A: $tType,Uu: A,Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),option(product_prod(list(A),product_prod(A,list(A)))),aa(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_alv(A,fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uu),Uua)),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),Uub),Uuc))) ) ).

% ATP.lambda_1246
tff(fact_7412_ATP_Olambda__1247,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aba(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uub)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_1247
tff(fact_7413_ATP_Olambda__1248,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aay(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub))) ) ).

% ATP.lambda_1248
tff(fact_7414_ATP_Olambda__1249,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: fun(A,fun(B,set(C))),Uub: B,Uuc: A] : ( aa(A,set(C),aa(B,fun(A,set(C)),aa(fun(A,fun(B,set(C))),fun(B,fun(A,set(C))),aTP_Lamp_km(set(product_prod(B,B)),fun(fun(A,fun(B,set(C))),fun(B,fun(A,set(C)))),Uu),Uua),Uub),Uuc) = aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),aa(A,fun(B,set(C)),Uua,Uuc)),aa(set(B),set(B),image(B,B,Uu),aa(set(B),set(B),insert(B,Uub),bot_bot(set(B)))))) ) ).

% ATP.lambda_1249
tff(fact_7415_ATP_Olambda__1250,axiom,
    ! [C: $tType,A: $tType,B: $tType,E: $tType,D: $tType,Uu: fun(B,fun(C,fun(D,fun(E,set(A))))),Uua: set(product_prod(D,E)),Uub: B,Uuc: C] : ( aa(C,set(A),aa(B,fun(C,set(A)),aa(set(product_prod(D,E)),fun(B,fun(C,set(A))),aTP_Lamp_hn(fun(B,fun(C,fun(D,fun(E,set(A))))),fun(set(product_prod(D,E)),fun(B,fun(C,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(product_prod(D,E)),set(set(A)),image2(product_prod(D,E),set(A),aa(fun(D,fun(E,set(A))),fun(product_prod(D,E),set(A)),product_case_prod(D,E,set(A)),aa(C,fun(D,fun(E,set(A))),aa(B,fun(C,fun(D,fun(E,set(A)))),Uu,Uub),Uuc))),Uua)) ) ).

% ATP.lambda_1250
tff(fact_7416_ATP_Olambda__1251,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: set(B),Uub: B,Uuc: fun(A,B)] :
      ( pp(aa(fun(A,B),bool,aa(B,fun(fun(A,B),bool),aa(set(B),fun(B,fun(fun(A,B),bool)),aTP_Lamp_afm(set(A),fun(set(B),fun(B,fun(fun(A,B),bool))),Uu),Uua),Uub),Uuc))
    <=> ! [X3: A] :
          ( ( pp(aa(set(A),bool,member(A,X3),Uu))
           => pp(aa(set(B),bool,member(B,aa(A,B,Uuc,X3)),Uua)) )
          & ( ~ pp(aa(set(A),bool,member(A,X3),Uu))
           => ( aa(A,B,Uuc,X3) = Uub ) ) ) ) ).

% ATP.lambda_1251
tff(fact_7417_ATP_Olambda__1252,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: set(product_prod(A,C)),Uua: set(product_prod(C,B)),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(product_prod(C,B)),fun(A,fun(B,bool)),aTP_Lamp_mh(set(product_prod(A,C)),fun(set(product_prod(C,B)),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ? [Y4: C] :
          ( pp(aa(set(product_prod(A,C)),bool,member(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),Uub),Y4)),Uu))
          & pp(aa(set(product_prod(C,B)),bool,member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Y4),Uuc)),Uua)) ) ) ).

% ATP.lambda_1252
tff(fact_7418_ATP_Olambda__1253,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: set(C),Uua: fun(C,A),Uub: fun(C,B),Uuc: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(fun(C,B),fun(product_prod(A,B),bool),aa(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),bool)),aTP_Lamp_bj(set(C),fun(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),bool))),Uu),Uua),Uub),Uuc))
    <=> ? [A6: C] :
          ( ( Uuc = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,Uua,A6)),aa(C,B,Uub,A6)) )
          & pp(aa(set(C),bool,member(C,A6),Uu)) ) ) ).

% ATP.lambda_1253
tff(fact_7419_ATP_Olambda__1254,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: B,Uub: set(B),Uuc: A] :
      ( pp(aa(A,bool,aa(set(B),fun(A,bool),aa(B,fun(set(B),fun(A,bool)),aTP_Lamp_cu(fun(B,A),fun(B,fun(set(B),fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ? [L6: B] :
          ( ( Uuc = aa(B,A,Uu,L6) )
          & ( ( L6 = Uua )
            | pp(aa(set(B),bool,member(B,L6),Uub)) ) ) ) ).

% ATP.lambda_1254
tff(fact_7420_ATP_Olambda__1255,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A,Uub: fun(A,B),Uuc: B] :
          ( pp(aa(B,bool,aa(fun(A,B),fun(B,bool),aa(A,fun(fun(A,B),fun(B,bool)),aTP_Lamp_tt(A,fun(A,fun(fun(A,B),fun(B,bool))),Uu),Uua),Uub),Uuc))
        <=> ? [I6: A] :
              ( ( Uuc = aa(A,B,Uub,I6) )
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uu),I6))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I6),Uua)) ) ) ) ).

% ATP.lambda_1255
tff(fact_7421_ATP_Olambda__1256,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: fun(A,fun(B,C)),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(B,C)),fun(A,fun(A,bool)),aTP_Lamp_adt(set(product_prod(B,B)),fun(fun(A,fun(B,C)),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ! [X3: product_prod(B,B)] :
          ( pp(aa(set(product_prod(B,B)),bool,member(product_prod(B,B),X3),Uu))
         => pp(aa(product_prod(B,B),bool,aa(fun(B,fun(B,bool)),fun(product_prod(B,B),bool),product_case_prod(B,B,bool),aa(A,fun(B,fun(B,bool)),aa(A,fun(A,fun(B,fun(B,bool))),aTP_Lamp_ads(fun(A,fun(B,C)),fun(A,fun(A,fun(B,fun(B,bool)))),Uua),Uub),Uuc)),X3)) ) ) ).

% ATP.lambda_1256
tff(fact_7422_ATP_Olambda__1257,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,bool),Uua: fun(B,bool),Uub: fun(A,fun(B,C)),Uuc: C] :
      ( pp(aa(C,bool,aa(fun(A,fun(B,C)),fun(C,bool),aa(fun(B,bool),fun(fun(A,fun(B,C)),fun(C,bool)),aTP_Lamp_kw(fun(A,bool),fun(fun(B,bool),fun(fun(A,fun(B,C)),fun(C,bool))),Uu),Uua),Uub),Uuc))
    <=> ? [X3: A,Y4: B] :
          ( ( Uuc = aa(B,C,aa(A,fun(B,C),Uub,X3),Y4) )
          & pp(aa(A,bool,Uu,X3))
          & pp(aa(B,bool,Uua,Y4)) ) ) ).

% ATP.lambda_1257
tff(fact_7423_ATP_Olambda__1258,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: set(product_prod(B,B)),Uub: fun(A,B),Uuc: product_prod(A,A)] :
      ( pp(aa(product_prod(A,A),bool,aa(fun(A,B),fun(product_prod(A,A),bool),aa(set(product_prod(B,B)),fun(fun(A,B),fun(product_prod(A,A),bool)),aTP_Lamp_by(set(A),fun(set(product_prod(B,B)),fun(fun(A,B),fun(product_prod(A,A),bool))),Uu),Uua),Uub),Uuc))
    <=> ? [A17: A,A25: A] :
          ( ( Uuc = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A17),A25) )
          & pp(aa(set(A),bool,member(A,A17),Uu))
          & pp(aa(set(A),bool,member(A,A25),Uu))
          & pp(aa(set(product_prod(B,B)),bool,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,Uub,A17)),aa(A,B,Uub,A25))),Uua)) ) ) ).

% ATP.lambda_1258
tff(fact_7424_ATP_Olambda__1259,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(nat,fun(nat,A)),Uuc: nat,Uud: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),aa(A,fun(fun(nat,fun(nat,A)),fun(nat,fun(nat,A))),aTP_Lamp_asz(fun(A,fun(A,A)),fun(A,fun(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,Uu,Uua),aa(nat,fun(nat,A),aTP_Lamp_asy(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uub),Uud)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uud),Uuc)) ) ).

% ATP.lambda_1259
tff(fact_7425_ATP_Olambda__1260,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(B,fun(C,A)),Uuc: set(B),Uud: C] : ( aa(C,A,aa(set(B),fun(C,A),aa(fun(B,fun(C,A)),fun(set(B),fun(C,A)),aa(A,fun(fun(B,fun(C,A)),fun(set(B),fun(C,A))),aTP_Lamp_ase(fun(A,fun(A,A)),fun(A,fun(fun(B,fun(C,A)),fun(set(B),fun(C,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,Uu,Uua),aa(C,fun(B,A),aTP_Lamp_asd(fun(B,fun(C,A)),fun(C,fun(B,A)),Uub),Uud)),Uuc) ) ).

% ATP.lambda_1260
tff(fact_7426_ATP_Olambda__1261,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(B,set(C)),Uuc: fun(B,fun(C,A)),Uud: B] : ( aa(B,A,aa(fun(B,fun(C,A)),fun(B,A),aa(fun(B,set(C)),fun(fun(B,fun(C,A)),fun(B,A)),aa(A,fun(fun(B,set(C)),fun(fun(B,fun(C,A)),fun(B,A))),aTP_Lamp_asw(fun(A,fun(A,A)),fun(A,fun(fun(B,set(C)),fun(fun(B,fun(C,A)),fun(B,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,Uu,Uua),aa(B,fun(C,A),Uuc,Uud)),aa(B,set(C),Uub,Uud)) ) ).

% ATP.lambda_1261
tff(fact_7427_ATP_Olambda__1262,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(B,fun(C,A)),Uuc: set(C),Uud: B] : ( aa(B,A,aa(set(C),fun(B,A),aa(fun(B,fun(C,A)),fun(set(C),fun(B,A)),aa(A,fun(fun(B,fun(C,A)),fun(set(C),fun(B,A))),aTP_Lamp_asc(fun(A,fun(A,A)),fun(A,fun(fun(B,fun(C,A)),fun(set(C),fun(B,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,Uu,Uua),aa(B,fun(C,A),Uub,Uud)),Uuc) ) ).

% ATP.lambda_1262
tff(fact_7428_ATP_Olambda__1263,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(nat,A),Uuc: nat,Uud: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aa(A,fun(fun(nat,A),fun(nat,fun(nat,A))),aTP_Lamp_ata(fun(A,fun(A,A)),fun(A,fun(fun(nat,A),fun(nat,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,Uu,Uua),Uub),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uud),Uuc),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uud),Uuc)),Uuc))) ) ).

% ATP.lambda_1263
tff(fact_7429_ATP_Olambda__1264,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(B,set(C)),Uuc: fun(C,A),Uud: B] : ( aa(B,A,aa(fun(C,A),fun(B,A),aa(fun(B,set(C)),fun(fun(C,A),fun(B,A)),aa(A,fun(fun(B,set(C)),fun(fun(C,A),fun(B,A))),aTP_Lamp_ate(fun(A,fun(A,A)),fun(A,fun(fun(B,set(C)),fun(fun(C,A),fun(B,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,Uu,Uua),Uuc),aa(B,set(C),Uub,Uud)) ) ).

% ATP.lambda_1264
tff(fact_7430_ATP_Olambda__1265,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: C,Uua: A,Uub: A,Uuc: B,Uud: set(product_prod(C,B))] : ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(B,fun(set(product_prod(C,B)),set(product_prod(C,B))),aa(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aa(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),aTP_Lamp_lp(C,fun(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))))),Uu),Uua),Uub),Uuc),Uud) = if(set(product_prod(C,B)),aa(A,bool,aa(A,fun(A,bool),fequal(A),Uua),Uub),aa(set(product_prod(C,B)),set(product_prod(C,B)),insert(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uu),Uuc)),Uud),Uud) ) ).

% ATP.lambda_1265
tff(fact_7431_ATP_Olambda__1266,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: A,Uua: B,Uub: B,Uuc: C,Uud: set(product_prod(A,C))] : ( aa(set(product_prod(A,C)),set(product_prod(A,C)),aa(C,fun(set(product_prod(A,C)),set(product_prod(A,C))),aa(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aa(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C))))),aTP_Lamp_mi(A,fun(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C)))))),Uu),Uua),Uub),Uuc),Uud) = if(set(product_prod(A,C)),aa(B,bool,aa(B,fun(B,bool),fequal(B),Uua),Uub),aa(set(product_prod(A,C)),set(product_prod(A,C)),insert(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),Uu),Uuc)),Uud),Uud) ) ).

% ATP.lambda_1266
tff(fact_7432_ATP_Olambda__1267,axiom,
    ! [A: $tType,Uu: A,Uua: nat,Uub: fun(nat,A),Uuc: fun(nat,A),Uud: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aa(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),aTP_Lamp_asa(A,fun(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uud),Uua),aa(nat,A,Uub,Uud),if(A,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uud),Uua),Uu,aa(nat,A,Uuc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uud),aa(nat,nat,suc,zero_zero(nat)))))) ) ).

% ATP.lambda_1267
tff(fact_7433_ATP_Olambda__1268,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: list(A),Uub: A,Uuc: list(A),Uud: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),aa(A,fun(list(A),fun(list(A),list(A))),aa(list(A),fun(A,fun(list(A),fun(list(A),list(A)))),aTP_Lamp_atf(fun(A,fun(A,bool)),fun(list(A),fun(A,fun(list(A),fun(list(A),list(A))))),Uu),Uua),Uub),Uuc),Uud) = aa(list(A),list(A),quicksort_by_rel(A,Uu,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uub),aa(list(A),list(A),quicksort_by_rel(A,Uu,Uua),Uud))),Uuc) ) ).

% ATP.lambda_1268
tff(fact_7434_ATP_Olambda__1269,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(B,fun(C,A)),Uuc: multiset(B),Uud: C] : ( aa(C,A,aa(multiset(B),fun(C,A),aa(fun(B,fun(C,A)),fun(multiset(B),fun(C,A)),aa(A,fun(fun(B,fun(C,A)),fun(multiset(B),fun(C,A))),aTP_Lamp_auz(fun(A,fun(A,A)),fun(A,fun(fun(B,fun(C,A)),fun(multiset(B),fun(C,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(multiset(A),A,comm_monoid_F(A,Uu,Uua),aa(multiset(B),multiset(A),image_mset(B,A,aa(C,fun(B,A),aTP_Lamp_asd(fun(B,fun(C,A)),fun(C,fun(B,A)),Uub),Uud)),Uuc)) ) ).

% ATP.lambda_1269
tff(fact_7435_ATP_Olambda__1270,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(B,fun(C,A)),Uuc: multiset(C),Uud: B] : ( aa(B,A,aa(multiset(C),fun(B,A),aa(fun(B,fun(C,A)),fun(multiset(C),fun(B,A)),aa(A,fun(fun(B,fun(C,A)),fun(multiset(C),fun(B,A))),aTP_Lamp_auy(fun(A,fun(A,A)),fun(A,fun(fun(B,fun(C,A)),fun(multiset(C),fun(B,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(multiset(A),A,comm_monoid_F(A,Uu,Uua),aa(multiset(C),multiset(A),image_mset(C,A,aa(B,fun(C,A),Uub,Uud)),Uuc)) ) ).

% ATP.lambda_1270
tff(fact_7436_ATP_Olambda__1271,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,fun(B,heap_Time_Heap(A))),Uua: fun(C,C),Uub: fun(fun(B,heap_Time_Heap(A)),C),Uuc: B,Uud: fun(B,heap_Time_Heap(A))] : ( aa(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)))),aTP_Lamp_bap(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))))),Uu),Uua),Uub),Uuc),Uud) = aa(B,heap_Time_Heap(A),aa(C,fun(B,heap_Time_Heap(A)),Uu,aa(C,C,Uua,aa(fun(B,heap_Time_Heap(A)),C,Uub,Uud))),Uuc) ) ).

% ATP.lambda_1271
tff(fact_7437_ATP_Olambda__1272,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,fun(B,option(A))),Uua: fun(C,C),Uub: fun(fun(B,option(A)),C),Uuc: B,Uud: fun(B,option(A))] : ( aa(fun(B,option(A)),option(A),aa(B,fun(fun(B,option(A)),option(A)),aa(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A))),aa(fun(C,C),fun(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A)))),aTP_Lamp_bah(fun(C,fun(B,option(A))),fun(fun(C,C),fun(fun(fun(B,option(A)),C),fun(B,fun(fun(B,option(A)),option(A))))),Uu),Uua),Uub),Uuc),Uud) = aa(B,option(A),aa(C,fun(B,option(A)),Uu,aa(C,C,Uua,aa(fun(B,option(A)),C,Uub,Uud))),Uuc) ) ).

% ATP.lambda_1272
tff(fact_7438_ATP_Olambda__1273,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,fun(B,A)),Uua: fun(C,C),Uub: fun(fun(B,A),C),Uuc: B,Uud: fun(B,A)] : ( aa(fun(B,A),A,aa(B,fun(fun(B,A),A),aa(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A))),aTP_Lamp_baf(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,A,aa(C,fun(B,A),Uu,aa(C,C,Uua,aa(fun(B,A),C,Uub,Uud))),Uuc) ) ).

% ATP.lambda_1273
tff(fact_7439_ATP_Olambda__1274,axiom,
    ! [A: $tType,D: $tType,C: $tType,E: $tType,B: $tType,Uu: fun(D,fun(E,C)),Uua: fun(A,D),Uub: fun(B,E),Uuc: A,Uud: B] : ( aa(B,C,aa(A,fun(B,C),aa(fun(B,E),fun(A,fun(B,C)),aa(fun(A,D),fun(fun(B,E),fun(A,fun(B,C))),aTP_Lamp_anu(fun(D,fun(E,C)),fun(fun(A,D),fun(fun(B,E),fun(A,fun(B,C)))),Uu),Uua),Uub),Uuc),Uud) = aa(E,C,aa(D,fun(E,C),Uu,aa(A,D,Uua,Uuc)),aa(B,E,Uub,Uud)) ) ).

% ATP.lambda_1274
tff(fact_7440_ATP_Olambda__1275,axiom,
    ! [D: $tType,B: $tType,A: $tType,C: $tType,E: $tType,Uu: fun(B,fun(C,A)),Uua: fun(D,B),Uub: fun(E,C),Uuc: D,Uud: E] : ( aa(E,A,aa(D,fun(E,A),aa(fun(E,C),fun(D,fun(E,A)),aa(fun(D,B),fun(fun(E,C),fun(D,fun(E,A))),aTP_Lamp_ans(fun(B,fun(C,A)),fun(fun(D,B),fun(fun(E,C),fun(D,fun(E,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(C,A,aa(B,fun(C,A),Uu,aa(D,B,Uua,Uuc)),aa(E,C,Uub,Uud)) ) ).

% ATP.lambda_1275
tff(fact_7441_ATP_Olambda__1276,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,fun(C,A)),Uua: fun(A,fun(B,fun(C,B))),Uub: A,Uuc: B,Uud: C] : ( aa(C,product_prod(A,B),aa(B,fun(C,product_prod(A,B)),aa(A,fun(B,fun(C,product_prod(A,B))),aa(fun(A,fun(B,fun(C,B))),fun(A,fun(B,fun(C,product_prod(A,B)))),aTP_Lamp_aih(fun(A,fun(C,A)),fun(fun(A,fun(B,fun(C,B))),fun(A,fun(B,fun(C,product_prod(A,B))))),Uu),Uua),Uub),Uuc),Uud) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,aa(A,fun(C,A),Uu,Uub),Uud)),aa(C,B,aa(B,fun(C,B),aa(A,fun(B,fun(C,B)),Uua,Uub),Uuc),Uud)) ) ).

% ATP.lambda_1276
tff(fact_7442_ATP_Olambda__1277,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,fun(A,bool)),Uua: fun(A,fun(C,bool)),Uub: B,Uuc: C,Uud: A] :
      ( pp(aa(A,bool,aa(C,fun(A,bool),aa(B,fun(C,fun(A,bool)),aa(fun(A,fun(C,bool)),fun(B,fun(C,fun(A,bool))),aTP_Lamp_aux(fun(B,fun(A,bool)),fun(fun(A,fun(C,bool)),fun(B,fun(C,fun(A,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( pp(aa(A,bool,aa(B,fun(A,bool),Uu,Uub),Uud))
        & pp(aa(C,bool,aa(A,fun(C,bool),Uua,Uud),Uuc)) ) ) ).

% ATP.lambda_1277
tff(fact_7443_ATP_Olambda__1278,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,fun(B,C)),Uua: A,Uub: A,Uuc: B,Uud: B] :
      ( pp(aa(B,bool,aa(B,fun(B,bool),aa(A,fun(B,fun(B,bool)),aa(A,fun(A,fun(B,fun(B,bool))),aTP_Lamp_ads(fun(A,fun(B,C)),fun(A,fun(A,fun(B,fun(B,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( aa(B,C,aa(A,fun(B,C),Uu,Uua),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uud) ) ) ).

% ATP.lambda_1278
tff(fact_7444_ATP_Olambda__1279,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: A,Uub: bool,Uuc: A,Uud: list(A)] :
      ( pp(aa(list(A),bool,aa(A,fun(list(A),bool),aa(bool,fun(A,fun(list(A),bool)),aa(A,fun(bool,fun(A,fun(list(A),bool))),aTP_Lamp_bbi(fun(A,fun(A,bool)),fun(A,fun(bool,fun(A,fun(list(A),bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Uu,Uua),Uuc))
        & pp(Uub) ) ) ).

% ATP.lambda_1279
tff(fact_7445_ATP_Olambda__1280,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_us(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uud)),Uua)),one_one(A))),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_1280
tff(fact_7446_ATP_Olambda__1281,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ur(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uu)),Uua)),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uuc),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_1281
tff(fact_7447_ATP_Olambda__1282,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: set(product_prod(A,A)),Uuc: A,Uud: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool))),aTP_Lamp_gx(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uuc),Uu)),transitive_trancl(A,Uub)))
          | ( Uuc = Uu ) )
        & ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uud)),transitive_trancl(A,Uub)))
          | ( Uud = Uua ) ) ) ) ).

% ATP.lambda_1282
tff(fact_7448_ATP_Olambda__1283,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_vr(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),Uua)),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),Uub)),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_1283
tff(fact_7449_ATP_Olambda__1284,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A,Uuc: A,Uud: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(A,fun(A,fun(A,bool)),aa(A,fun(A,fun(A,fun(A,bool))),aTP_Lamp_jh(set(product_prod(A,A)),fun(A,fun(A,fun(A,fun(A,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Uua),aa(set(A),set(A),insert(A,Uub),aa(set(A),set(A),insert(A,Uuc),aa(set(A),set(A),insert(A,Uud),bot_bot(set(A))))))),field2(A,Uu)))
        & ( ( ( Uua = Uuc )
            & ( Uub = Uud ) )
          | pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),bNF_We1388413361240627857o_max2(A,Uu,Uua,Uub)),bNF_We1388413361240627857o_max2(A,Uu,Uuc,Uud))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),Uu),id2(A))))
          | ( ( bNF_We1388413361240627857o_max2(A,Uu,Uua,Uub) = bNF_We1388413361240627857o_max2(A,Uu,Uuc,Uud) )
            & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uuc)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),Uu),id2(A)))) )
          | ( ( bNF_We1388413361240627857o_max2(A,Uu,Uua,Uub) = bNF_We1388413361240627857o_max2(A,Uu,Uuc,Uud) )
            & ( Uua = Uuc )
            & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uud)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),Uu),id2(A)))) ) ) ) ) ).

% ATP.lambda_1284
tff(fact_7450_ATP_Olambda__1285,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: set(product_prod(A,A)),Uuc: A,Uud: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool))),aTP_Lamp_eg(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uuc),Uu)),transitive_rtrancl(A,Uub)))
        & pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uud)),transitive_rtrancl(A,Uub))) ) ) ).

% ATP.lambda_1285
tff(fact_7451_ATP_Olambda__1286,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A,Uuc: A,Uud: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(A,fun(A,fun(A,bool)),aa(A,fun(A,fun(A,fun(A,bool))),aTP_Lamp_adw(set(product_prod(A,A)),fun(A,fun(A,fun(A,fun(A,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( ( Uub = Uuc )
       => pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uud)),Uu)) ) ) ).

% ATP.lambda_1286
tff(fact_7452_ATP_Olambda__1287,axiom,
    ! [C: $tType,B: $tType,A: $tType,E: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(C,fun(A,bool)),Uub: fun(A,fun(E,bool)),Uuc: C,Uud: E] :
      ( pp(aa(E,bool,aa(C,fun(E,bool),aa(fun(A,fun(E,bool)),fun(C,fun(E,bool)),aa(fun(C,fun(A,bool)),fun(fun(A,fun(E,bool)),fun(C,fun(E,bool))),aTP_Lamp_arg(fun(A,fun(B,bool)),fun(fun(C,fun(A,bool)),fun(fun(A,fun(E,bool)),fun(C,fun(E,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ? [X3: A] :
          ( pp(aa(set(A),bool,member(A,X3),aa(fun(A,bool),set(A),collect(A),aa(fun(A,fun(B,bool)),fun(A,bool),domainp(A,B),Uu))))
          & pp(aa(A,bool,aa(C,fun(A,bool),Uua,Uuc),X3))
          & pp(aa(E,bool,aa(A,fun(E,bool),Uub,X3),Uud)) ) ) ).

% ATP.lambda_1287
tff(fact_7453_ATP_Olambda__1288,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: set(A),Uuc: set(C),Uud: B] :
          ( pp(aa(B,bool,aa(set(C),fun(B,bool),aa(set(A),fun(set(C),fun(B,bool)),aa(fun(C,B),fun(set(A),fun(set(C),fun(B,bool))),aTP_Lamp_qf(fun(A,B),fun(fun(C,B),fun(set(A),fun(set(C),fun(B,bool)))),Uu),Uua),Uub),Uuc),Uud))
        <=> ? [A6: A,B5: C] :
              ( ( Uud = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,A6)),aa(C,B,Uua,B5)) )
              & pp(aa(set(A),bool,member(A,A6),Uub))
              & pp(aa(set(C),bool,member(C,B5),Uuc)) ) ) ) ).

% ATP.lambda_1288
tff(fact_7454_ATP_Olambda__1289,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: set(B),Uuc: fun(B,fun(C,A)),Uud: fun(B,fun(C,bool)),Uue: C] : ( aa(C,A,aa(fun(B,fun(C,bool)),fun(C,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A)),aa(set(B),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A))),aa(A,fun(set(B),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A)))),aTP_Lamp_asm(fun(A,fun(A,A)),fun(A,fun(set(B),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(C,A))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,Uu,Uua),aa(C,fun(B,A),aTP_Lamp_asd(fun(B,fun(C,A)),fun(C,fun(B,A)),Uuc),Uue)),aa(fun(B,bool),set(B),collect(B),aa(C,fun(B,bool),aa(fun(B,fun(C,bool)),fun(C,fun(B,bool)),aTP_Lamp_or(set(B),fun(fun(B,fun(C,bool)),fun(C,fun(B,bool))),Uub),Uud),Uue))) ) ).

% ATP.lambda_1289
tff(fact_7455_ATP_Olambda__1290,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: set(C),Uuc: fun(B,fun(C,A)),Uud: fun(B,fun(C,bool)),Uue: B] : ( aa(B,A,aa(fun(B,fun(C,bool)),fun(B,A),aa(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A)),aa(set(C),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A))),aa(A,fun(set(C),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A)))),aTP_Lamp_asl(fun(A,fun(A,A)),fun(A,fun(set(C),fun(fun(B,fun(C,A)),fun(fun(B,fun(C,bool)),fun(B,A))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,Uu,Uua),aa(B,fun(C,A),Uuc,Uue)),aa(fun(C,bool),set(C),collect(C),aa(B,fun(C,bool),aa(fun(B,fun(C,bool)),fun(B,fun(C,bool)),aTP_Lamp_op(set(C),fun(fun(B,fun(C,bool)),fun(B,fun(C,bool))),Uub),Uud),Uue))) ) ).

% ATP.lambda_1290
tff(fact_7456_ATP_Olambda__1291,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: set(B),Uuc: fun(B,A),Uud: fun(B,C),Uue: C] : ( aa(C,A,aa(fun(B,C),fun(C,A),aa(fun(B,A),fun(fun(B,C),fun(C,A)),aa(set(B),fun(fun(B,A),fun(fun(B,C),fun(C,A))),aa(A,fun(set(B),fun(fun(B,A),fun(fun(B,C),fun(C,A)))),aTP_Lamp_asp(fun(A,fun(A,A)),fun(A,fun(set(B),fun(fun(B,A),fun(fun(B,C),fun(C,A))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,Uu,Uua),Uuc),aa(fun(B,bool),set(B),collect(B),aa(C,fun(B,bool),aa(fun(B,C),fun(C,fun(B,bool)),aTP_Lamp_ph(set(B),fun(fun(B,C),fun(C,fun(B,bool))),Uub),Uud),Uue))) ) ).

% ATP.lambda_1291
tff(fact_7457_ATP_Olambda__1292,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: set(B),Uuc: fun(B,C),Uud: fun(B,A),Uue: C] : ( aa(C,A,aa(fun(B,A),fun(C,A),aa(fun(B,C),fun(fun(B,A),fun(C,A)),aa(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))),aa(A,fun(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A)))),aTP_Lamp_asu(fun(A,fun(A,A)),fun(A,fun(set(B),fun(fun(B,C),fun(fun(B,A),fun(C,A))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,Uu,Uua),Uud),aa(fun(B,bool),set(B),collect(B),aa(C,fun(B,bool),aa(fun(B,C),fun(C,fun(B,bool)),aTP_Lamp_ph(set(B),fun(fun(B,C),fun(C,fun(B,bool))),Uub),Uuc),Uue))) ) ).

% ATP.lambda_1292
tff(fact_7458_ATP_Olambda__1293,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B,Uuc: list(B),Uud: list(B),Uue: list(B)] : ( aa(list(B),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))),aa(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))),aa(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))),aa(A,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))))),aTP_Lamp_akq(fun(B,A),fun(A,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))))),Uu),Uua),Uub),Uuc),Uud),Uue) = if(product_prod(list(B),product_prod(list(B),list(B))),aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,Uu,Uub)),Uua),aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),Uuc)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Uud),Uue)),if(product_prod(list(B),product_prod(list(B),list(B))),aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),aa(B,A,Uu,Uub)),aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),Uuc),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Uud),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),Uue))),aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),Uuc),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),Uud)),Uue)))) ) ) ).

% ATP.lambda_1293
tff(fact_7459_ATP_Olambda__1294,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Uu: fun(A,fun(C,bool)),Uua: fun(B,fun(D,bool)),Uub: A,Uuc: B,Uud: C,Uue: D] :
      ( pp(aa(D,bool,aa(C,fun(D,bool),aa(B,fun(C,fun(D,bool)),aa(A,fun(B,fun(C,fun(D,bool))),aa(fun(B,fun(D,bool)),fun(A,fun(B,fun(C,fun(D,bool)))),aTP_Lamp_aox(fun(A,fun(C,bool)),fun(fun(B,fun(D,bool)),fun(A,fun(B,fun(C,fun(D,bool))))),Uu),Uua),Uub),Uuc),Uud),Uue))
    <=> ( pp(aa(C,bool,aa(A,fun(C,bool),Uu,Uub),Uud))
        & pp(aa(D,bool,aa(B,fun(D,bool),Uua,Uuc),Uue)) ) ) ).

% ATP.lambda_1294
tff(fact_7460_ATP_Olambda__1295,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(B,B)),Uub: A,Uuc: B,Uud: A,Uue: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(B,fun(A,fun(B,bool)),aa(A,fun(B,fun(A,fun(B,bool))),aa(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,bool)))),aTP_Lamp_jq(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,bool))))),Uu),Uua),Uub),Uuc),Uud),Uue))
    <=> ( pp(aa(set(product_prod(A,A)),bool,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uud)),Uu))
        | ( ( Uub = Uud )
          & pp(aa(set(product_prod(B,B)),bool,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uuc),Uue)),Uua)) ) ) ) ).

% ATP.lambda_1295
tff(fact_7461_ATP_Olambda__1296,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,bool),Uua: fun(A,set(product_prod(B,B))),Uub: A,Uuc: B,Uud: A,Uue: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(B,fun(A,fun(B,bool)),aa(A,fun(B,fun(A,fun(B,bool))),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,bool)))),aTP_Lamp_jo(fun(A,bool),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,bool))))),Uu),Uua),Uub),Uuc),Uud),Uue))
    <=> ( ( Uub = Uud )
        & pp(aa(A,bool,Uu,Uud))
        & pp(aa(set(product_prod(B,B)),bool,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uuc),Uue)),aa(A,set(product_prod(B,B)),Uua,Uud))) ) ) ).

% ATP.lambda_1296
tff(fact_7462_ATP_Olambda__1297,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: set(B),Uuc: fun(B,A),Uud: fun(B,A),Uue: B] :
      ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aa(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),aa(A,fun(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool)))),aTP_Lamp_ash(fun(A,fun(A,A)),fun(A,fun(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))))),Uu),Uua),Uub),Uuc),Uud),Uue))
    <=> ( pp(aa(set(B),bool,member(B,Uue),Uub))
        & ( aa(A,A,aa(A,fun(A,A),Uu,aa(B,A,Uuc,Uue)),aa(B,A,Uud,Uue)) != Uua ) ) ) ).

% ATP.lambda_1297
tff(fact_7463_ATP_Olambda__1298,axiom,
    ! [B: $tType,A: $tType,Uu: bool,Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_cx(bool,fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> pp(Uu) ) ).

% ATP.lambda_1298
tff(fact_7464_ATP_Olambda__1299,axiom,
    ! [A: $tType,Uu: heap_Time_Heap(A),Uua: product_unit] : ( aa(product_unit,heap_Time_Heap(A),aTP_Lamp_axd(heap_Time_Heap(A),fun(product_unit,heap_Time_Heap(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1299
tff(fact_7465_ATP_Olambda__1300,axiom,
    ! [B: $tType,A: $tType] :
      ( heap(B)
     => ! [Uu: heap_Time_Heap(A),Uua: B] : ( aa(B,heap_Time_Heap(A),aTP_Lamp_axc(heap_Time_Heap(A),fun(B,heap_Time_Heap(A)),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1300
tff(fact_7466_ATP_Olambda__1301,axiom,
    ! [B: $tType,A: $tType,Uu: heap_Time_Heap(A),Uua: B] : ( aa(B,heap_Time_Heap(A),aTP_Lamp_bat(heap_Time_Heap(A),fun(B,heap_Time_Heap(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1301
tff(fact_7467_ATP_Olambda__1302,axiom,
    ! [B: $tType,A: $tType,Uu: multiset(A),Uua: B] : ( aa(B,multiset(A),aTP_Lamp_hr(multiset(A),fun(B,multiset(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1302
tff(fact_7468_ATP_Olambda__1303,axiom,
    ! [A: $tType,Uu: assn,Uua: A] : ( aa(A,assn,aTP_Lamp_ae(assn,fun(A,assn),Uu),Uua) = Uu ) ).

% ATP.lambda_1303
tff(fact_7469_ATP_Olambda__1304,axiom,
    ! [B: $tType,A: $tType,Uu: option(A),Uua: B] : ( aa(B,option(A),aTP_Lamp_azy(option(A),fun(B,option(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1304
tff(fact_7470_ATP_Olambda__1305,axiom,
    ! [A: $tType,Uu: bool,Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_an(bool,fun(A,bool),Uu),Uua))
    <=> pp(Uu) ) ).

% ATP.lambda_1305
tff(fact_7471_ATP_Olambda__1306,axiom,
    ! [B: $tType,A: $tType,Uu: set(set(old_node(A,B))),Uua: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(set(old_node(A,B))),aTP_Lamp_azk(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),Uu),Uua) = Uu ) ).

% ATP.lambda_1306
tff(fact_7472_ATP_Olambda__1307,axiom,
    ! [C: $tType,D: $tType,Uu: set(D),Uua: C] : ( aa(C,set(D),aTP_Lamp_el(set(D),fun(C,set(D)),Uu),Uua) = Uu ) ).

% ATP.lambda_1307
tff(fact_7473_ATP_Olambda__1308,axiom,
    ! [B: $tType,D: $tType,Uu: set(D),Uua: B] : ( aa(B,set(D),aTP_Lamp_anv(set(D),fun(B,set(D)),Uu),Uua) = Uu ) ).

% ATP.lambda_1308
tff(fact_7474_ATP_Olambda__1309,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: B] : ( aa(B,set(C),aTP_Lamp_eq(set(C),fun(B,set(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_1309
tff(fact_7475_ATP_Olambda__1310,axiom,
    ! [A: $tType,C: $tType,Uu: set(C),Uua: A] : ( aa(A,set(C),aTP_Lamp_md(set(C),fun(A,set(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_1310
tff(fact_7476_ATP_Olambda__1311,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: C] : ( aa(C,set(B),aTP_Lamp_agj(set(B),fun(C,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1311
tff(fact_7477_ATP_Olambda__1312,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] : ( aa(B,set(B),aTP_Lamp_cm(set(B),fun(B,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1312
tff(fact_7478_ATP_Olambda__1313,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: A] : ( aa(A,set(B),aTP_Lamp_bq(set(B),fun(A,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1313
tff(fact_7479_ATP_Olambda__1314,axiom,
    ! [A: $tType,Uu: set(A),Uua: list(A)] : ( aa(list(A),set(A),aTP_Lamp_aiv(set(A),fun(list(A),set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1314
tff(fact_7480_ATP_Olambda__1315,axiom,
    ! [C: $tType,A: $tType,Uu: set(A),Uua: C] : ( aa(C,set(A),aTP_Lamp_agi(set(A),fun(C,set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1315
tff(fact_7481_ATP_Olambda__1316,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: B] : ( aa(B,set(A),aTP_Lamp_bv(set(A),fun(B,set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1316
tff(fact_7482_ATP_Olambda__1317,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] : ( aa(A,set(A),aTP_Lamp_cr(set(A),fun(A,set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1317
tff(fact_7483_ATP_Olambda__1318,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,bool),Uua: A] : ( aa(A,fun(B,bool),aTP_Lamp_qw(fun(B,bool),fun(A,fun(B,bool)),Uu),Uua) = Uu ) ).

% ATP.lambda_1318
tff(fact_7484_ATP_Olambda__1319,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(B,C),Uua: A] : ( aa(A,fun(B,C),aTP_Lamp_dv(fun(B,C),fun(A,fun(B,C)),Uu),Uua) = Uu ) ).

% ATP.lambda_1319
tff(fact_7485_ATP_Olambda__1320,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,B),Uua: A] : ( aa(A,fun(B,B),aTP_Lamp_ku(fun(B,B),fun(A,fun(B,B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1320
tff(fact_7486_ATP_Olambda__1321,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(A,fun(C,C)),Uua: B] : ( aa(B,fun(A,fun(C,C)),aTP_Lamp_ajq(fun(A,fun(C,C)),fun(B,fun(A,fun(C,C))),Uu),Uua) = Uu ) ).

% ATP.lambda_1321
tff(fact_7487_ATP_Olambda__1322,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: C,Uua: product_prod(A,B)] : ( aa(product_prod(A,B),C,aTP_Lamp_bbh(C,fun(product_prod(A,B),C),Uu),Uua) = Uu ) ).

% ATP.lambda_1322
tff(fact_7488_ATP_Olambda__1323,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: B] : ( aa(B,C,aTP_Lamp_awg(C,fun(B,C),Uu),Uua) = Uu ) ).

% ATP.lambda_1323
tff(fact_7489_ATP_Olambda__1324,axiom,
    ! [A: $tType,C: $tType,Uu: C,Uua: A] : ( aa(A,C,aTP_Lamp_awf(C,fun(A,C),Uu),Uua) = Uu ) ).

% ATP.lambda_1324
tff(fact_7490_ATP_Olambda__1325,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(B)
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_amp(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1325
tff(fact_7491_ATP_Olambda__1326,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Uu: B,Uua: C] : ( aa(C,B,aTP_Lamp_akd(B,fun(C,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1326
tff(fact_7492_ATP_Olambda__1327,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_arr(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1327
tff(fact_7493_ATP_Olambda__1328,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C] : ( aa(C,B,aTP_Lamp_ahh(B,fun(C,B),Uu),Uua) = Uu ) ).

% ATP.lambda_1328
tff(fact_7494_ATP_Olambda__1329,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_bm(B,fun(A,B),Uu),Uua) = Uu ) ).

% ATP.lambda_1329
tff(fact_7495_ATP_Olambda__1330,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_hd(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1330
tff(fact_7496_ATP_Olambda__1331,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_fh(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1331
tff(fact_7497_ATP_Olambda__1332,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_mm(A,fun(A,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1332
tff(fact_7498_ATP_Olambda__1333,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_rw(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1333
tff(fact_7499_ATP_Olambda__1334,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: list(A)] : ( aa(list(A),A,aa(A,fun(list(A),A),aTP_Lamp_amn(A,fun(list(A),A)),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1334
tff(fact_7500_ATP_Olambda__1335,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_zx(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1335
tff(fact_7501_ATP_Olambda__1336,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_rx(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1336
tff(fact_7502_ATP_Olambda__1337,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_avt(A,fun(nat,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1337
tff(fact_7503_ATP_Olambda__1338,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),A,aa(A,fun(list(A),A),aTP_Lamp_aly(A,fun(list(A),A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1338
tff(fact_7504_ATP_Olambda__1339,axiom,
    ! [A: $tType,Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_anx(A,fun(nat,A),Uu),Uua) = Uu ) ).

% ATP.lambda_1339
tff(fact_7505_ATP_Olambda__1340,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_cy(A,fun(B,A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1340
tff(fact_7506_ATP_Olambda__1341,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_amj(A,fun(list(A),list(A))),Uu),Uua) = Uua ) ).

% ATP.lambda_1341
tff(fact_7507_ATP_Olambda__1342,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: B] : ( aa(B,B,aa(A,fun(B,B),aTP_Lamp_dw(A,fun(B,B)),Uu),Uua) = Uua ) ).

% ATP.lambda_1342
tff(fact_7508_ATP_Olambda__1343,axiom,
    ! [Uu: typerep,Uua: nat] : ( aa(nat,nat,aa(typerep,fun(nat,nat),aTP_Lamp_bba(typerep,fun(nat,nat)),Uu),Uua) = zero_zero(nat) ) ).

% ATP.lambda_1343
tff(fact_7509_ATP_Olambda__1344,axiom,
    ! [Uu: typerep,Uua: nat] : ( aa(nat,list(nat),aa(typerep,fun(nat,list(nat)),aTP_Lamp_baz(typerep,fun(nat,list(nat))),Uu),Uua) = nil(nat) ) ).

% ATP.lambda_1344
tff(fact_7510_ATP_Olambda__1345,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] :
      ( pp(aa(list(A),bool,aa(A,fun(list(A),bool),aTP_Lamp_amh(A,fun(list(A),bool)),Uu),Uua))
    <=> $false ) ).

% ATP.lambda_1345
tff(fact_7511_ATP_Olambda__1346,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_aqw(A,fun(A,bool)),Uu),Uua))
    <=> $false ) ).

% ATP.lambda_1346
tff(fact_7512_ATP_Olambda__1347,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] :
      ( pp(aa(list(A),bool,aa(A,fun(list(A),bool),aTP_Lamp_ami(A,fun(list(A),bool)),Uu),Uua))
    <=> $true ) ).

% ATP.lambda_1347
tff(fact_7513_ATP_Olambda__1348,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_da(A,fun(B,bool)),Uu),Uua))
    <=> $true ) ).

% ATP.lambda_1348
tff(fact_7514_ATP_Olambda__1349,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_alg(A,fun(A,bool)),Uu),Uua))
    <=> $true ) ).

% ATP.lambda_1349
tff(fact_7515_ATP_Olambda__1350,axiom,
    ! [Uu: product_prod(nat,nat)] : ( aa(product_prod(nat,nat),product_prod(nat,nat),aTP_Lamp_aoz(product_prod(nat,nat),product_prod(nat,nat)),Uu) = Uu ) ).

% ATP.lambda_1350
tff(fact_7516_ATP_Olambda__1351,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_vy(nat,nat),Uu) = Uu ) ).

% ATP.lambda_1351
tff(fact_7517_ATP_Olambda__1352,axiom,
    ! [Uu: int] : ( aa(int,int,aTP_Lamp_ry(int,int),Uu) = Uu ) ).

% ATP.lambda_1352
tff(fact_7518_ATP_Olambda__1353,axiom,
    ! [D: $tType,Uu: fun(D,nat)] : ( aa(fun(D,nat),fun(D,nat),aTP_Lamp_aql(fun(D,nat),fun(D,nat)),Uu) = Uu ) ).

% ATP.lambda_1353
tff(fact_7519_ATP_Olambda__1354,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,B,aTP_Lamp_xj(B,B),Uu) = Uu ) ).

% ATP.lambda_1354
tff(fact_7520_ATP_Olambda__1355,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_pl(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1355
tff(fact_7521_ATP_Olambda__1356,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_pm(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1356
tff(fact_7522_ATP_Olambda__1357,axiom,
    ! [A: $tType] :
      ( complete_Sup(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_ff(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1357
tff(fact_7523_ATP_Olambda__1358,axiom,
    ! [A: $tType] :
      ( complete_Inf(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_ht(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1358
tff(fact_7524_ATP_Olambda__1359,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_eh(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1359
tff(fact_7525_ATP_Olambda__1360,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_af(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1360
tff(fact_7526_ATP_Olambda__1361,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_aum(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1361
tff(fact_7527_ATP_Olambda__1362,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,A,aTP_Lamp_bk(A,A),Uu) = Uu ) ).

% ATP.lambda_1362
tff(fact_7528_ATP_Olambda__1363,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_hv(B,A),Uu) = top_top(A) ) ) ).

% ATP.lambda_1363
tff(fact_7529_ATP_Olambda__1364,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,set(bool),aTP_Lamp_agq(A,set(bool)),Uu) = top_top(set(bool)) ) ).

% ATP.lambda_1364
tff(fact_7530_ATP_Olambda__1365,axiom,
    ! [A: $tType,B: $tType,Uu: A] : ( aa(A,set(B),aTP_Lamp_bp(A,set(B)),Uu) = top_top(set(B)) ) ).

% ATP.lambda_1365
tff(fact_7531_ATP_Olambda__1366,axiom,
    ! [C: $tType,D: $tType,Uu: C] : ( aa(C,set(D),aTP_Lamp_ays(C,set(D)),Uu) = bot_bot(set(D)) ) ).

% ATP.lambda_1366
tff(fact_7532_ATP_Olambda__1367,axiom,
    ! [C: $tType,B: $tType,Uu: C] : ( aa(C,set(B),aTP_Lamp_hg(C,set(B)),Uu) = bot_bot(set(B)) ) ).

% ATP.lambda_1367
tff(fact_7533_ATP_Olambda__1368,axiom,
    ! [B: $tType,A: $tType,Uu: B] : ( aa(B,set(A),aTP_Lamp_gi(B,set(A)),Uu) = bot_bot(set(A)) ) ).

% ATP.lambda_1368
tff(fact_7534_ATP_Olambda__1369,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_fg(B,A),Uu) = bot_bot(A) ) ) ).

% ATP.lambda_1369
tff(fact_7535_ATP_Olambda__1370,axiom,
    ! [A: $tType,D: $tType,Uu: A] : ( aa(A,set(D),aTP_Lamp_hh(A,set(D)),Uu) = bot_bot(set(D)) ) ).

% ATP.lambda_1370
tff(fact_7536_ATP_Olambda__1371,axiom,
    ! [A: $tType,B: $tType,Uu: A] : ( aa(A,set(B),aTP_Lamp_bs(A,set(B)),Uu) = bot_bot(set(B)) ) ).

% ATP.lambda_1371
tff(fact_7537_ATP_Olambda__1372,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,nat,aTP_Lamp_ars(B,nat),Uu) = zero_zero(nat) ) ).

% ATP.lambda_1372
tff(fact_7538_ATP_Olambda__1373,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_od(B,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_1373
tff(fact_7539_ATP_Olambda__1374,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_ajv(B,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_1374
tff(fact_7540_ATP_Olambda__1375,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_bo(A,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_1375
tff(fact_7541_ATP_Olambda__1376,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,nat,aTP_Lamp_apq(A,nat),Uu) = zero_zero(nat) ) ).

% ATP.lambda_1376
tff(fact_7542_ATP_Olambda__1377,axiom,
    ! [A: $tType,B: $tType] :
      ( zero(B)
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_bz(A,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_1377
tff(fact_7543_ATP_Olambda__1378,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_oe(B,A),Uu) = one_one(A) ) ) ).

% ATP.lambda_1378
tff(fact_7544_ATP_Olambda__1379,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,nat,aTP_Lamp_rl(A,nat),Uu) = one_one(nat) ) ).

% ATP.lambda_1379
tff(fact_7545_ATP_Olambda__1380,axiom,
    ! [A: $tType,Uu: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_aww(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),Uu) = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ).

% ATP.lambda_1380
tff(fact_7546_ATP_Olambda__1381,axiom,
    ! [B: $tType,D: $tType,Uu: B] : ( aa(B,option(D),aTP_Lamp_adf(B,option(D)),Uu) = none(D) ) ).

% ATP.lambda_1381
tff(fact_7547_ATP_Olambda__1382,axiom,
    ! [B: $tType,A: $tType,Uu: B] : ( aa(B,option(A),aTP_Lamp_acu(B,option(A)),Uu) = none(A) ) ).

% ATP.lambda_1382
tff(fact_7548_ATP_Olambda__1383,axiom,
    ! [A: $tType,C: $tType,Uu: A] : ( aa(A,option(C),aTP_Lamp_abx(A,option(C)),Uu) = none(C) ) ).

% ATP.lambda_1383
tff(fact_7549_ATP_Olambda__1384,axiom,
    ! [A: $tType,B: $tType,Uu: A] : ( aa(A,option(B),aTP_Lamp_abe(A,option(B)),Uu) = none(B) ) ).

% ATP.lambda_1384
tff(fact_7550_ATP_Olambda__1385,axiom,
    ! [B: $tType,A: $tType,Uu: B] : ( aa(B,A,aTP_Lamp_awl(B,A),Uu) = undefined(A) ) ).

% ATP.lambda_1385
tff(fact_7551_ATP_Olambda__1386,axiom,
    ! [A: $tType,B: $tType,Uu: A] : ( aa(A,B,aTP_Lamp_ahi(A,B),Uu) = undefined(B) ) ).

% ATP.lambda_1386
tff(fact_7552_ATP_Olambda__1387,axiom,
    ! [Uu: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aTP_Lamp_ag(product_prod(heap_ext(product_unit),set(nat)),bool),Uu))
    <=> $false ) ).

% ATP.lambda_1387
tff(fact_7553_ATP_Olambda__1388,axiom,
    ! [Uu: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_xr(nat,bool),Uu))
    <=> $false ) ).

% ATP.lambda_1388
tff(fact_7554_ATP_Olambda__1389,axiom,
    ! [B: $tType,Uu: B] :
      ( pp(aa(B,bool,aTP_Lamp_ave(B,bool),Uu))
    <=> $false ) ).

% ATP.lambda_1389
tff(fact_7555_ATP_Olambda__1390,axiom,
    ! [A: $tType,Uu: A] :
      ( pp(aa(A,bool,aTP_Lamp_ao(A,bool),Uu))
    <=> $false ) ).

% ATP.lambda_1390
tff(fact_7556_ATP_Olambda__1391,axiom,
    ! [Uu: heap_ext(product_unit)] :
      ( pp(aa(heap_ext(product_unit),bool,aTP_Lamp_bbt(heap_ext(product_unit),bool),Uu))
    <=> $true ) ).

% ATP.lambda_1391
tff(fact_7557_ATP_Olambda__1392,axiom,
    ! [Uu: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_zr(nat,bool),Uu))
    <=> $true ) ).

% ATP.lambda_1392
tff(fact_7558_ATP_Olambda__1393,axiom,
    ! [A: $tType,Uu: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aTP_Lamp_aez(fun(A,bool),bool),Uu))
    <=> $true ) ).

% ATP.lambda_1393
tff(fact_7559_ATP_Olambda__1394,axiom,
    ! [D: $tType,Uu: D] :
      ( pp(aa(D,bool,aTP_Lamp_ahp(D,bool),Uu))
    <=> $true ) ).

% ATP.lambda_1394
tff(fact_7560_ATP_Olambda__1395,axiom,
    ! [C: $tType,Uu: C] :
      ( pp(aa(C,bool,aTP_Lamp_ahs(C,bool),Uu))
    <=> $true ) ).

% ATP.lambda_1395
tff(fact_7561_ATP_Olambda__1396,axiom,
    ! [B: $tType,Uu: B] :
      ( pp(aa(B,bool,aTP_Lamp_aqx(B,bool),Uu))
    <=> $true ) ).

% ATP.lambda_1396
tff(fact_7562_ATP_Olambda__1397,axiom,
    ! [A: $tType,Uu: A] :
      ( pp(aa(A,bool,aTP_Lamp_nn(A,bool),Uu))
    <=> $true ) ).

% ATP.lambda_1397
tff(fact_7563_ATP_Olambda__1398,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,fun(nat,nat),aTP_Lamp_acm(B,fun(nat,nat)),Uu) = suc ) ).

% ATP.lambda_1398
tff(fact_7564_ATP_Olambda__1399,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,fun(nat,nat),aTP_Lamp_sv(A,fun(nat,nat)),Uu) = suc ) ).

% ATP.lambda_1399

% Type constructors (712)
tff(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => condit1219197933456340205attice(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( comple592849572758109894attice(A19)
     => comple592849572758109894attice(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__boolean__algebra,axiom,
    ! [A18: $tType,A19: $tType] :
      ( comple489889107523837845lgebra(A19)
     => comple489889107523837845lgebra(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bounded_lattice(A19)
     => bounde4967611905675639751up_bot(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bounded_lattice(A19)
     => bounde4346867609351753570nf_top(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => comple6319245703460814977attice(fun(A18,A19)) ) ).

tff(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A18: $tType,A19: $tType] :
      ( boolea8198339166811842893lgebra(A19)
     => boolea8198339166811842893lgebra(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice__top,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bounded_lattice(A19)
     => bounded_lattice_top(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice__bot,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bounded_lattice(A19)
     => bounded_lattice_bot(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Partial__Order_Occpo,axiom,
    ! [A18: $tType,A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => comple9053668089753744459l_ccpo(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A18: $tType,A19: $tType] :
      ( semilattice_sup(A19)
     => semilattice_sup(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A18: $tType,A19: $tType] :
      ( semilattice_inf(A19)
     => semilattice_inf(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( distrib_lattice(A19)
     => distrib_lattice(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bounded_lattice(A19)
     => bounded_lattice(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Lattices_OSup,axiom,
    ! [A18: $tType,A19: $tType] :
      ( complete_Sup(A19)
     => complete_Sup(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Lattices_OInf,axiom,
    ! [A18: $tType,A19: $tType] :
      ( complete_Inf(A19)
     => complete_Inf(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A18: $tType,A19: $tType] :
      ( order_top(A19)
     => order_top(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A18: $tType,A19: $tType] :
      ( order_bot(A19)
     => order_bot(fun(A18,A19)) ) ).

tff(tcon_fun___Countable_Ocountable,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( finite_finite(A18)
        & countable(A19) )
     => countable(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Opreorder,axiom,
    ! [A18: $tType,A19: $tType] :
      ( preorder(A19)
     => preorder(fun(A18,A19)) ) ).

tff(tcon_fun___Finite__Set_Ofinite,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( finite_finite(A18)
        & finite_finite(A19) )
     => finite_finite(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Olattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( lattice(A19)
     => lattice(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Oorder,axiom,
    ! [A18: $tType,A19: $tType] :
      ( order(A19)
     => order(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Otop,axiom,
    ! [A18: $tType,A19: $tType] :
      ( top(A19)
     => top(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Oord,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ord(A19)
     => ord(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Obot,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bot(A19)
     => bot(fun(A18,A19)) ) ).

tff(tcon_fun___Groups_Ouminus,axiom,
    ! [A18: $tType,A19: $tType] :
      ( uminus(A19)
     => uminus(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Osup,axiom,
    ! [A18: $tType,A19: $tType] :
      ( semilattice_sup(A19)
     => sup(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Oinf,axiom,
    ! [A18: $tType,A19: $tType] :
      ( semilattice_inf(A19)
     => inf(fun(A18,A19)) ) ).

tff(tcon_fun___Groups_Ominus,axiom,
    ! [A18: $tType,A19: $tType] :
      ( minus(A19)
     => minus(fun(A18,A19)) ) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder(int) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_1,axiom,
    condit1219197933456340205attice(int) ).

tff(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations(int) ).

tff(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel(int) ).

tff(tcon_Int_Oint___Rings_Onormalization__semidom__multiplicative,axiom,
    normal6328177297339901930cative(int) ).

tff(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add(int) ).

tff(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide__unit__factor,axiom,
    semido2269285787275462019factor(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize(int) ).

tff(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add(int) ).

tff(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits(int) ).

tff(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring(int) ).

tff(tcon_Int_Oint___Rings_Onormalization__semidom,axiom,
    normal8620421768224518004emidom(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__sup_2,axiom,
    semilattice_sup(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__inf_3,axiom,
    semilattice_inf(int) ).

tff(tcon_Int_Oint___Lattices_Odistrib__lattice_4,axiom,
    distrib_lattice(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult(int) ).

tff(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs(int) ).

tff(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult(int) ).

tff(tcon_Int_Oint___Complete__Lattices_OSup_5,axiom,
    complete_Sup(int) ).

tff(tcon_Int_Oint___Complete__Lattices_OInf_6,axiom,
    complete_Inf(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide(int) ).

tff(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring(int) ).

tff(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0(int) ).

tff(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add(int) ).

tff(tcon_Int_Oint___Countable_Ocountable_7,axiom,
    countable(int) ).

tff(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn(int) ).

tff(tcon_Int_Oint___Orderings_Opreorder_8,axiom,
    preorder(int) ).

tff(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult(int) ).

tff(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0(int) ).

tff(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top(int) ).

tff(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot(int) ).

tff(tcon_Int_Oint___Lattices_Olattice_9,axiom,
    lattice(int) ).

tff(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd(int) ).

tff(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring(int) ).

tff(tcon_Int_Oint___Orderings_Oorder_10,axiom,
    order(int) ).

tff(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral(int) ).

tff(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0(int) ).

tff(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring(int) ).

tff(tcon_Int_Oint___Orderings_Oord_11,axiom,
    ord(int) ).

tff(tcon_Int_Oint___Groups_Ouminus_12,axiom,
    uminus(int) ).

tff(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1(int) ).

tff(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if(int) ).

tff(tcon_Int_Oint___Lattices_Osup_13,axiom,
    sup(int) ).

tff(tcon_Int_Oint___Lattices_Oinf_14,axiom,
    inf(int) ).

tff(tcon_Int_Oint___Groups_Otimes,axiom,
    times(int) ).

tff(tcon_Int_Oint___Groups_Ominus_15,axiom,
    minus(int) ).

tff(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd(int) ).

tff(tcon_Int_Oint___Power_Opower,axiom,
    power(int) ).

tff(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral(int) ).

tff(tcon_Int_Oint___Groups_Ozero,axiom,
    zero(int) ).

tff(tcon_Int_Oint___Rings_Oring,axiom,
    ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom,axiom,
    idom(int) ).

tff(tcon_Int_Oint___Groups_Oone,axiom,
    one(int) ).

tff(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd(int) ).

tff(tcon_Int_Oint___Heap_Oheap,axiom,
    heap(int) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_16,axiom,
    condit6923001295902523014norder(nat) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_17,axiom,
    condit1219197933456340205attice(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_18,axiom,
    bit_un5681908812861735899ations(nat) ).

tff(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_19,axiom,
    semiri1453513574482234551roduct(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_20,axiom,
    euclid5411537665997757685th_nat(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_21,axiom,
    ordere1937475149494474687imp_le(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_22,axiom,
    euclid3128863361964157862miring(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_23,axiom,
    euclid4440199948858584721cancel(nat) ).

tff(tcon_Nat_Onat___Rings_Onormalization__semidom__multiplicative_24,axiom,
    normal6328177297339901930cative(nat) ).

tff(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_25,axiom,
    unique1627219031080169319umeral(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_26,axiom,
    semiri6575147826004484403cancel(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_27,axiom,
    strict9044650504122735259up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_28,axiom,
    ordere580206878836729694up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_29,axiom,
    ordere2412721322843649153imp_le(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_30,axiom,
    bit_se359711467146920520ations(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_31,axiom,
    linord2810124833399127020strict(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_32,axiom,
    strict7427464778891057005id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_33,axiom,
    ordere8940638589300402666id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_34,axiom,
    euclid3725896446679973847miring(nat) ).

tff(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_35,axiom,
    linord4140545234300271783up_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_36,axiom,
    linord181362715937106298miring(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide__unit__factor_37,axiom,
    semido2269285787275462019factor(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_38,axiom,
    linord8928482502909563296strict(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_39,axiom,
    semiri3467727345109120633visors(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_40,axiom,
    ordere6658533253407199908up_add(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_41,axiom,
    semiri6843258321239162965malize(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_42,axiom,
    ordere6911136660526730532id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_43,axiom,
    cancel2418104881723323429up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_44,axiom,
    cancel1802427076303600483id_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_45,axiom,
    comm_s4317794764714335236cancel(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_46,axiom,
    bit_semiring_bits(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__comm__semiring_47,axiom,
    ordere2520102378445227354miring(nat) ).

tff(tcon_Nat_Onat___Rings_Onormalization__semidom_48,axiom,
    normal8620421768224518004emidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_49,axiom,
    cancel_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring_50,axiom,
    linordered_semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring__0_51,axiom,
    ordered_semiring_0(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semidom_52,axiom,
    linordered_semidom(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__sup_53,axiom,
    semilattice_sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__inf_54,axiom,
    semilattice_inf(nat) ).

tff(tcon_Nat_Onat___Lattices_Odistrib__lattice_55,axiom,
    distrib_lattice(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__mult_56,axiom,
    ab_semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Oalgebraic__semidom_57,axiom,
    algebraic_semidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_58,axiom,
    comm_monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__add_59,axiom,
    ab_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring_60,axiom,
    ordered_semiring(nat) ).

tff(tcon_Nat_Onat___Parity_Osemiring__parity_61,axiom,
    semiring_parity(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__add_62,axiom,
    comm_monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__modulo_63,axiom,
    semiring_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1_64,axiom,
    comm_semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__0_65,axiom,
    comm_semiring_0(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__mult_66,axiom,
    semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Complete__Lattices_OSup_67,axiom,
    complete_Sup(nat) ).

tff(tcon_Nat_Onat___Complete__Lattices_OInf_68,axiom,
    complete_Inf(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__modulo_69,axiom,
    semidom_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide_70,axiom,
    semidom_divide(nat) ).

tff(tcon_Nat_Onat___Num_Osemiring__numeral_71,axiom,
    semiring_numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__add_72,axiom,
    semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__less__one_73,axiom,
    zero_less_one(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring_74,axiom,
    comm_semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder__bot_75,axiom,
    order_bot(nat) ).

tff(tcon_Nat_Onat___Nat_Osemiring__char__0_76,axiom,
    semiring_char_0(nat) ).

tff(tcon_Nat_Onat___Countable_Ocountable_77,axiom,
    countable(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__neq__one_78,axiom,
    zero_neq_one(nat) ).

tff(tcon_Nat_Onat___Orderings_Opreorder_79,axiom,
    preorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Olinorder_80,axiom,
    linorder(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__mult_81,axiom,
    monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__add_82,axiom,
    monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1_83,axiom,
    semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__0_84,axiom,
    semiring_0(nat) ).

tff(tcon_Nat_Onat___Orderings_Ono__top_85,axiom,
    no_top(nat) ).

tff(tcon_Nat_Onat___Lattices_Olattice_86,axiom,
    lattice(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd_87,axiom,
    semiring_gcd(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__Gcd_88,axiom,
    semiring_Gcd(nat) ).

tff(tcon_Nat_Onat___Rings_Omult__zero_89,axiom,
    mult_zero(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder_90,axiom,
    order(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring_91,axiom,
    semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Oord_92,axiom,
    ord(nat) ).

tff(tcon_Nat_Onat___Orderings_Obot_93,axiom,
    bot(nat) ).

tff(tcon_Nat_Onat___Lattices_Osup_94,axiom,
    sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Oinf_95,axiom,
    inf(nat) ).

tff(tcon_Nat_Onat___Groups_Otimes_96,axiom,
    times(nat) ).

tff(tcon_Nat_Onat___Groups_Ominus_97,axiom,
    minus(nat) ).

tff(tcon_Nat_Onat___Power_Opower_98,axiom,
    power(nat) ).

tff(tcon_Nat_Onat___Num_Onumeral_99,axiom,
    numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Ozero_100,axiom,
    zero(nat) ).

tff(tcon_Nat_Onat___Groups_Oone_101,axiom,
    one(nat) ).

tff(tcon_Nat_Onat___Rings_Odvd_102,axiom,
    dvd(nat) ).

tff(tcon_Nat_Onat___Heap_Oheap_103,axiom,
    heap(nat) ).

tff(tcon_Num_Onum___Orderings_Opreorder_104,axiom,
    preorder(num) ).

tff(tcon_Num_Onum___Orderings_Olinorder_105,axiom,
    linorder(num) ).

tff(tcon_Num_Onum___Orderings_Oorder_106,axiom,
    order(num) ).

tff(tcon_Num_Onum___Orderings_Oord_107,axiom,
    ord(num) ).

tff(tcon_Num_Onum___Groups_Otimes_108,axiom,
    times(num) ).

tff(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_109,axiom,
    semiri1453513574482234551roduct(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_110,axiom,
    ordere1937475149494474687imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_111,axiom,
    semiri6575147826004484403cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_112,axiom,
    strict9044650504122735259up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_113,axiom,
    ordere580206878836729694up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_114,axiom,
    ordere2412721322843649153imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_115,axiom,
    linord2810124833399127020strict(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_116,axiom,
    strict7427464778891057005id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_117,axiom,
    ordere8940638589300402666id_add(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_118,axiom,
    linord715952674999750819strict(rat) ).

tff(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_119,axiom,
    linord4140545234300271783up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_120,axiom,
    linord181362715937106298miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_121,axiom,
    linord8928482502909563296strict(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_122,axiom,
    semiri3467727345109120633visors(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_123,axiom,
    ordere6658533253407199908up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_124,axiom,
    ordere166539214618696060dd_abs(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_125,axiom,
    ordere6911136660526730532id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_126,axiom,
    linord5086331880401160121up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_127,axiom,
    cancel2418104881723323429up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_128,axiom,
    ring_15535105094025558882visors(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_129,axiom,
    cancel1802427076303600483id_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring__strict_130,axiom,
    linord4710134922213307826strict(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_131,axiom,
    comm_s4317794764714335236cancel(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__comm__semiring_132,axiom,
    ordere2520102378445227354miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1_133,axiom,
    linord6961819062388156250ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add_134,axiom,
    ordered_ab_group_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_135,axiom,
    cancel_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring_136,axiom,
    linordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring__0_137,axiom,
    ordered_semiring_0(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semidom_138,axiom,
    linordered_semidom(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__sup_139,axiom,
    semilattice_sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__inf_140,axiom,
    semilattice_inf(rat) ).

tff(tcon_Rat_Orat___Lattices_Odistrib__lattice_141,axiom,
    distrib_lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__mult_142,axiom,
    ab_semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_143,axiom,
    comm_monoid_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__add_144,axiom,
    ab_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring_145,axiom,
    ordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring__abs_146,axiom,
    ordered_ring_abs(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__add_147,axiom,
    comm_monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring_148,axiom,
    linordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__idom_149,axiom,
    linordered_idom(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1_150,axiom,
    comm_semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__0_151,axiom,
    comm_semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__mult_152,axiom,
    semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom__divide_153,axiom,
    semidom_divide(rat) ).

tff(tcon_Rat_Orat___Num_Osemiring__numeral_154,axiom,
    semiring_numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__add_155,axiom,
    semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__less__one_156,axiom,
    zero_less_one(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring_157,axiom,
    comm_semiring(rat) ).

tff(tcon_Rat_Orat___Nat_Osemiring__char__0_158,axiom,
    semiring_char_0(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__group__add_159,axiom,
    ab_group_add(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0(rat) ).

tff(tcon_Rat_Orat___Countable_Ocountable_160,axiom,
    countable(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__neq__one_161,axiom,
    zero_neq_one(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring_162,axiom,
    ordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__abs__sgn_163,axiom,
    idom_abs_sgn(rat) ).

tff(tcon_Rat_Orat___Orderings_Opreorder_164,axiom,
    preorder(rat) ).

tff(tcon_Rat_Orat___Orderings_Olinorder_165,axiom,
    linorder(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__mult_166,axiom,
    monoid_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__divide_167,axiom,
    idom_divide(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring__1_168,axiom,
    comm_ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__add_169,axiom,
    monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1_170,axiom,
    semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__0_171,axiom,
    semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__top_172,axiom,
    no_top(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__bot_173,axiom,
    no_bot(rat) ).

tff(tcon_Rat_Orat___Lattices_Olattice_174,axiom,
    lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Ogroup__add_175,axiom,
    group_add(rat) ).

tff(tcon_Rat_Orat___Rings_Omult__zero_176,axiom,
    mult_zero(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring_177,axiom,
    comm_ring(rat) ).

tff(tcon_Rat_Orat___Orderings_Oorder_178,axiom,
    order(rat) ).

tff(tcon_Rat_Orat___Num_Oneg__numeral_179,axiom,
    neg_numeral(rat) ).

tff(tcon_Rat_Orat___Nat_Oring__char__0_180,axiom,
    ring_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring_181,axiom,
    semiring(rat) ).

tff(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse(rat) ).

tff(tcon_Rat_Orat___Orderings_Oord_182,axiom,
    ord(rat) ).

tff(tcon_Rat_Orat___Groups_Ouminus_183,axiom,
    uminus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1_184,axiom,
    ring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Oabs__if_185,axiom,
    abs_if(rat) ).

tff(tcon_Rat_Orat___Lattices_Osup_186,axiom,
    sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Oinf_187,axiom,
    inf(rat) ).

tff(tcon_Rat_Orat___Groups_Otimes_188,axiom,
    times(rat) ).

tff(tcon_Rat_Orat___Groups_Ominus_189,axiom,
    minus(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield,axiom,
    field(rat) ).

tff(tcon_Rat_Orat___Power_Opower_190,axiom,
    power(rat) ).

tff(tcon_Rat_Orat___Num_Onumeral_191,axiom,
    numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Ozero_192,axiom,
    zero(rat) ).

tff(tcon_Rat_Orat___Rings_Oring_193,axiom,
    ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom_194,axiom,
    idom(rat) ).

tff(tcon_Rat_Orat___Groups_Oone_195,axiom,
    one(rat) ).

tff(tcon_Rat_Orat___Rings_Odvd_196,axiom,
    dvd(rat) ).

tff(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_197,axiom,
    ! [A18: $tType] : condit1219197933456340205attice(set(A18)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_198,axiom,
    ! [A18: $tType] : comple592849572758109894attice(set(A18)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__boolean__algebra_199,axiom,
    ! [A18: $tType] : comple489889107523837845lgebra(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_200,axiom,
    ! [A18: $tType] : bounde4967611905675639751up_bot(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_201,axiom,
    ! [A18: $tType] : bounde4346867609351753570nf_top(set(A18)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_202,axiom,
    ! [A18: $tType] : comple6319245703460814977attice(set(A18)) ).

tff(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_203,axiom,
    ! [A18: $tType] : boolea8198339166811842893lgebra(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice__top_204,axiom,
    ! [A18: $tType] : bounded_lattice_top(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice__bot_205,axiom,
    ! [A18: $tType] : bounded_lattice_bot(set(A18)) ).

tff(tcon_Set_Oset___Complete__Partial__Order_Occpo_206,axiom,
    ! [A18: $tType] : comple9053668089753744459l_ccpo(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__sup_207,axiom,
    ! [A18: $tType] : semilattice_sup(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__inf_208,axiom,
    ! [A18: $tType] : semilattice_inf(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Odistrib__lattice_209,axiom,
    ! [A18: $tType] : distrib_lattice(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice_210,axiom,
    ! [A18: $tType] : bounded_lattice(set(A18)) ).

tff(tcon_Set_Oset___Complete__Lattices_OSup_211,axiom,
    ! [A18: $tType] : complete_Sup(set(A18)) ).

tff(tcon_Set_Oset___Complete__Lattices_OInf_212,axiom,
    ! [A18: $tType] : complete_Inf(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Oorder__top_213,axiom,
    ! [A18: $tType] : order_top(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Oorder__bot_214,axiom,
    ! [A18: $tType] : order_bot(set(A18)) ).

tff(tcon_Set_Oset___Countable_Ocountable_215,axiom,
    ! [A18: $tType] :
      ( finite_finite(A18)
     => countable(set(A18)) ) ).

tff(tcon_Set_Oset___Orderings_Opreorder_216,axiom,
    ! [A18: $tType] : preorder(set(A18)) ).

tff(tcon_Set_Oset___Finite__Set_Ofinite_217,axiom,
    ! [A18: $tType] :
      ( finite_finite(A18)
     => finite_finite(set(A18)) ) ).

tff(tcon_Set_Oset___Lattices_Olattice_218,axiom,
    ! [A18: $tType] : lattice(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Oorder_219,axiom,
    ! [A18: $tType] : order(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Otop_220,axiom,
    ! [A18: $tType] : top(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Oord_221,axiom,
    ! [A18: $tType] : ord(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Obot_222,axiom,
    ! [A18: $tType] : bot(set(A18)) ).

tff(tcon_Set_Oset___Groups_Ouminus_223,axiom,
    ! [A18: $tType] : uminus(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Osup_224,axiom,
    ! [A18: $tType] : sup(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Oinf_225,axiom,
    ! [A18: $tType] : inf(set(A18)) ).

tff(tcon_Set_Oset___Groups_Ominus_226,axiom,
    ! [A18: $tType] : minus(set(A18)) ).

tff(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_227,axiom,
    condit1219197933456340205attice(bool) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_228,axiom,
    comple592849572758109894attice(bool) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__boolean__algebra_229,axiom,
    comple489889107523837845lgebra(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_230,axiom,
    bounde4967611905675639751up_bot(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_231,axiom,
    bounde4346867609351753570nf_top(bool) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_232,axiom,
    comple6319245703460814977attice(bool) ).

tff(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_233,axiom,
    boolea8198339166811842893lgebra(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice__top_234,axiom,
    bounded_lattice_top(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_235,axiom,
    bounded_lattice_bot(bool) ).

tff(tcon_HOL_Obool___Complete__Partial__Order_Occpo_236,axiom,
    comple9053668089753744459l_ccpo(bool) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__sup_237,axiom,
    semilattice_sup(bool) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__inf_238,axiom,
    semilattice_inf(bool) ).

tff(tcon_HOL_Obool___Lattices_Odistrib__lattice_239,axiom,
    distrib_lattice(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice_240,axiom,
    bounded_lattice(bool) ).

tff(tcon_HOL_Obool___Complete__Lattices_OSup_241,axiom,
    complete_Sup(bool) ).

tff(tcon_HOL_Obool___Complete__Lattices_OInf_242,axiom,
    complete_Inf(bool) ).

tff(tcon_HOL_Obool___Orderings_Oorder__top_243,axiom,
    order_top(bool) ).

tff(tcon_HOL_Obool___Orderings_Oorder__bot_244,axiom,
    order_bot(bool) ).

tff(tcon_HOL_Obool___Countable_Ocountable_245,axiom,
    countable(bool) ).

tff(tcon_HOL_Obool___Orderings_Opreorder_246,axiom,
    preorder(bool) ).

tff(tcon_HOL_Obool___Orderings_Olinorder_247,axiom,
    linorder(bool) ).

tff(tcon_HOL_Obool___Finite__Set_Ofinite_248,axiom,
    finite_finite(bool) ).

tff(tcon_HOL_Obool___Lattices_Olattice_249,axiom,
    lattice(bool) ).

tff(tcon_HOL_Obool___Orderings_Oorder_250,axiom,
    order(bool) ).

tff(tcon_HOL_Obool___Orderings_Otop_251,axiom,
    top(bool) ).

tff(tcon_HOL_Obool___Orderings_Oord_252,axiom,
    ord(bool) ).

tff(tcon_HOL_Obool___Orderings_Obot_253,axiom,
    bot(bool) ).

tff(tcon_HOL_Obool___Groups_Ouminus_254,axiom,
    uminus(bool) ).

tff(tcon_HOL_Obool___Lattices_Osup_255,axiom,
    sup(bool) ).

tff(tcon_HOL_Obool___Lattices_Oinf_256,axiom,
    inf(bool) ).

tff(tcon_HOL_Obool___Groups_Ominus_257,axiom,
    minus(bool) ).

tff(tcon_HOL_Obool___Heap_Oheap_258,axiom,
    heap(bool) ).

tff(tcon_Heap_Oref___Countable_Ocountable_259,axiom,
    ! [A18: $tType] : countable(ref(A18)) ).

tff(tcon_Heap_Oref___Heap_Oheap_260,axiom,
    ! [A18: $tType] : heap(ref(A18)) ).

tff(tcon_List_Olist___Countable_Ocountable_261,axiom,
    ! [A18: $tType] :
      ( countable(A18)
     => countable(list(A18)) ) ).

tff(tcon_List_Olist___Heap_Oheap_262,axiom,
    ! [A18: $tType] :
      ( heap(A18)
     => heap(list(A18)) ) ).

tff(tcon_Heap_Oarray___Countable_Ocountable_263,axiom,
    ! [A18: $tType] : countable(array(A18)) ).

tff(tcon_Heap_Oarray___Heap_Oheap_264,axiom,
    ! [A18: $tType] : heap(array(A18)) ).

tff(tcon_Sum__Type_Osum___Countable_Ocountable_265,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( countable(A18)
        & countable(A19) )
     => countable(sum_sum(A18,A19)) ) ).

tff(tcon_Sum__Type_Osum___Finite__Set_Ofinite_266,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( finite_finite(A18)
        & finite_finite(A19) )
     => finite_finite(sum_sum(A18,A19)) ) ).

tff(tcon_Sum__Type_Osum___Heap_Oheap_267,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( heap(A18)
        & heap(A19) )
     => heap(sum_sum(A18,A19)) ) ).

tff(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_268,axiom,
    ! [A18: $tType] : condit1219197933456340205attice(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_269,axiom,
    ! [A18: $tType] : bounde4967611905675639751up_bot(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_270,axiom,
    ! [A18: $tType] : bounde4346867609351753570nf_top(filter(A18)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_271,axiom,
    ! [A18: $tType] : comple6319245703460814977attice(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice__top_272,axiom,
    ! [A18: $tType] : bounded_lattice_top(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice__bot_273,axiom,
    ! [A18: $tType] : bounded_lattice_bot(filter(A18)) ).

tff(tcon_Filter_Ofilter___Complete__Partial__Order_Occpo_274,axiom,
    ! [A18: $tType] : comple9053668089753744459l_ccpo(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_275,axiom,
    ! [A18: $tType] : semilattice_sup(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_276,axiom,
    ! [A18: $tType] : semilattice_inf(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Odistrib__lattice_277,axiom,
    ! [A18: $tType] : distrib_lattice(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice_278,axiom,
    ! [A18: $tType] : bounded_lattice(filter(A18)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_OSup_279,axiom,
    ! [A18: $tType] : complete_Sup(filter(A18)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_OInf_280,axiom,
    ! [A18: $tType] : complete_Inf(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__top_281,axiom,
    ! [A18: $tType] : order_top(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__bot_282,axiom,
    ! [A18: $tType] : order_bot(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Opreorder_283,axiom,
    ! [A18: $tType] : preorder(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Olattice_284,axiom,
    ! [A18: $tType] : lattice(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder_285,axiom,
    ! [A18: $tType] : order(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Otop_286,axiom,
    ! [A18: $tType] : top(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Oord_287,axiom,
    ! [A18: $tType] : ord(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Obot_288,axiom,
    ! [A18: $tType] : bot(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Osup_289,axiom,
    ! [A18: $tType] : sup(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Oinf_290,axiom,
    ! [A18: $tType] : inf(filter(A18)) ).

tff(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_291,axiom,
    ! [A18: $tType] :
      ( comple5582772986160207858norder(A18)
     => condit6923001295902523014norder(option(A18)) ) ).

tff(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_292,axiom,
    ! [A18: $tType] :
      ( comple6319245703460814977attice(A18)
     => condit1219197933456340205attice(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__distrib__lattice_293,axiom,
    ! [A18: $tType] :
      ( comple592849572758109894attice(A18)
     => comple592849572758109894attice(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__semilattice__sup__bot_294,axiom,
    ! [A18: $tType] :
      ( lattice(A18)
     => bounde4967611905675639751up_bot(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__semilattice__inf__top_295,axiom,
    ! [A18: $tType] :
      ( bounded_lattice_top(A18)
     => bounde4346867609351753570nf_top(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__linorder,axiom,
    ! [A18: $tType] :
      ( comple5582772986160207858norder(A18)
     => comple5582772986160207858norder(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__lattice_296,axiom,
    ! [A18: $tType] :
      ( comple6319245703460814977attice(A18)
     => comple6319245703460814977attice(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice__top_297,axiom,
    ! [A18: $tType] :
      ( bounded_lattice_top(A18)
     => bounded_lattice_top(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice__bot_298,axiom,
    ! [A18: $tType] :
      ( lattice(A18)
     => bounded_lattice_bot(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Partial__Order_Occpo_299,axiom,
    ! [A18: $tType] :
      ( comple6319245703460814977attice(A18)
     => comple9053668089753744459l_ccpo(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Osemilattice__sup_300,axiom,
    ! [A18: $tType] :
      ( semilattice_sup(A18)
     => semilattice_sup(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Osemilattice__inf_301,axiom,
    ! [A18: $tType] :
      ( semilattice_inf(A18)
     => semilattice_inf(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Odistrib__lattice_302,axiom,
    ! [A18: $tType] :
      ( distrib_lattice(A18)
     => distrib_lattice(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice_303,axiom,
    ! [A18: $tType] :
      ( bounded_lattice_top(A18)
     => bounded_lattice(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_OSup_304,axiom,
    ! [A18: $tType] :
      ( comple6319245703460814977attice(A18)
     => complete_Sup(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_OInf_305,axiom,
    ! [A18: $tType] :
      ( comple6319245703460814977attice(A18)
     => complete_Inf(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Owellorder_306,axiom,
    ! [A18: $tType] :
      ( wellorder(A18)
     => wellorder(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder__top_307,axiom,
    ! [A18: $tType] :
      ( order_top(A18)
     => order_top(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder__bot_308,axiom,
    ! [A18: $tType] :
      ( order(A18)
     => order_bot(option(A18)) ) ).

tff(tcon_Option_Ooption___Countable_Ocountable_309,axiom,
    ! [A18: $tType] :
      ( countable(A18)
     => countable(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Opreorder_310,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => preorder(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Olinorder_311,axiom,
    ! [A18: $tType] :
      ( linorder(A18)
     => linorder(option(A18)) ) ).

tff(tcon_Option_Ooption___Finite__Set_Ofinite_312,axiom,
    ! [A18: $tType] :
      ( finite_finite(A18)
     => finite_finite(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Olattice_313,axiom,
    ! [A18: $tType] :
      ( lattice(A18)
     => lattice(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder_314,axiom,
    ! [A18: $tType] :
      ( order(A18)
     => order(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Otop_315,axiom,
    ! [A18: $tType] :
      ( order_top(A18)
     => top(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Oord_316,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => ord(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Obot_317,axiom,
    ! [A18: $tType] :
      ( order(A18)
     => bot(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Osup_318,axiom,
    ! [A18: $tType] :
      ( sup(A18)
     => sup(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Oinf_319,axiom,
    ! [A18: $tType] :
      ( inf(A18)
     => inf(option(A18)) ) ).

tff(tcon_Option_Ooption___Heap_Oheap_320,axiom,
    ! [A18: $tType] :
      ( heap(A18)
     => heap(option(A18)) ) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__sup__bot_321,axiom,
    bounde4967611905675639751up_bot(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__inf__top_322,axiom,
    bounde4346867609351753570nf_top(assn) ).

tff(tcon_Assertions_Oassn___Boolean__Algebras_Oboolean__algebra_323,axiom,
    boolea8198339166811842893lgebra(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice__top_324,axiom,
    bounded_lattice_top(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice__bot_325,axiom,
    bounded_lattice_bot(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osemilattice__sup_326,axiom,
    semilattice_sup(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osemilattice__inf_327,axiom,
    semilattice_inf(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Odistrib__lattice_328,axiom,
    distrib_lattice(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice_329,axiom,
    bounded_lattice(assn) ).

tff(tcon_Assertions_Oassn___Groups_Oab__semigroup__mult_330,axiom,
    ab_semigroup_mult(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ocomm__monoid__mult_331,axiom,
    comm_monoid_mult(assn) ).

tff(tcon_Assertions_Oassn___Groups_Osemigroup__mult_332,axiom,
    semigroup_mult(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder__top_333,axiom,
    order_top(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder__bot_334,axiom,
    order_bot(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Opreorder_335,axiom,
    preorder(assn) ).

tff(tcon_Assertions_Oassn___Groups_Omonoid__mult_336,axiom,
    monoid_mult(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Olattice_337,axiom,
    lattice(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder_338,axiom,
    order(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Otop_339,axiom,
    top(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oord_340,axiom,
    ord(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Obot_341,axiom,
    bot(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ouminus_342,axiom,
    uminus(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osup_343,axiom,
    sup(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Oinf_344,axiom,
    inf(assn) ).

tff(tcon_Assertions_Oassn___Groups_Otimes_345,axiom,
    times(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ominus_346,axiom,
    minus(assn) ).

tff(tcon_Assertions_Oassn___Power_Opower_347,axiom,
    power(assn) ).

tff(tcon_Assertions_Oassn___Groups_Oone_348,axiom,
    one(assn) ).

tff(tcon_Assertions_Oassn___Rings_Odvd_349,axiom,
    dvd(assn) ).

tff(tcon_Typerep_Otyperep___Countable_Ocountable_350,axiom,
    countable(typerep) ).

tff(tcon_Typerep_Otyperep___Heap_Oheap_351,axiom,
    heap(typerep) ).

tff(tcon_Multiset_Omultiset___Groups_Oordered__ab__semigroup__add_352,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => ordere6658533253407199908up_add(multiset(A18)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__ab__semigroup__add_353,axiom,
    ! [A18: $tType] : cancel2418104881723323429up_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__comm__monoid__add_354,axiom,
    ! [A18: $tType] : cancel1802427076303600483id_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__semigroup__add_355,axiom,
    ! [A18: $tType] : cancel_semigroup_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__diff_356,axiom,
    ! [A18: $tType] : comm_monoid_diff(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Oab__semigroup__add_357,axiom,
    ! [A18: $tType] : ab_semigroup_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__add_358,axiom,
    ! [A18: $tType] : comm_monoid_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Complete__Lattices_OSup_359,axiom,
    ! [A18: $tType] : complete_Sup(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Complete__Lattices_OInf_360,axiom,
    ! [A18: $tType] : complete_Inf(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Osemigroup__add_361,axiom,
    ! [A18: $tType] : semigroup_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Orderings_Opreorder_362,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => preorder(multiset(A18)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Omonoid__add_363,axiom,
    ! [A18: $tType] : monoid_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Orderings_Oorder_364,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => order(multiset(A18)) ) ).

tff(tcon_Multiset_Omultiset___Orderings_Oord_365,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => ord(multiset(A18)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Ominus_366,axiom,
    ! [A18: $tType] : minus(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Ozero_367,axiom,
    ! [A18: $tType] : zero(multiset(A18)) ).

tff(tcon_Product__Type_Oprod___Countable_Ocountable_368,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( countable(A18)
        & countable(A19) )
     => countable(product_prod(A18,A19)) ) ).

tff(tcon_Product__Type_Oprod___Finite__Set_Ofinite_369,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( finite_finite(A18)
        & finite_finite(A19) )
     => finite_finite(product_prod(A18,A19)) ) ).

tff(tcon_Product__Type_Oprod___Heap_Oheap_370,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( heap(A18)
        & heap(A19) )
     => heap(product_prod(A18,A19)) ) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_371,axiom,
    condit6923001295902523014norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_372,axiom,
    condit1219197933456340205attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_373,axiom,
    comple592849572758109894attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__boolean__algebra_374,axiom,
    comple489889107523837845lgebra(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_375,axiom,
    bounde4967611905675639751up_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_376,axiom,
    bounde4346867609351753570nf_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_377,axiom,
    comple5582772986160207858norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_378,axiom,
    comple6319245703460814977attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_379,axiom,
    boolea8198339166811842893lgebra(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__top_380,axiom,
    bounded_lattice_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__bot_381,axiom,
    bounded_lattice_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Partial__Order_Occpo_382,axiom,
    comple9053668089753744459l_ccpo(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_383,axiom,
    semilattice_sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_384,axiom,
    semilattice_inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Odistrib__lattice_385,axiom,
    distrib_lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice_386,axiom,
    bounded_lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_OSup_387,axiom,
    complete_Sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_OInf_388,axiom,
    complete_Inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Owellorder_389,axiom,
    wellorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__top_390,axiom,
    order_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__bot_391,axiom,
    order_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Countable_Ocountable_392,axiom,
    countable(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Opreorder_393,axiom,
    preorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Olinorder_394,axiom,
    linorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Finite__Set_Ofinite_395,axiom,
    finite_finite(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Olattice_396,axiom,
    lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder_397,axiom,
    order(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Otop_398,axiom,
    top(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oord_399,axiom,
    ord(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Obot_400,axiom,
    bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ouminus_401,axiom,
    uminus(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osup_402,axiom,
    sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Oinf_403,axiom,
    inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ominus_404,axiom,
    minus(product_unit) ).

tff(tcon_Product__Type_Ounit___Heap_Oheap_405,axiom,
    heap(product_unit) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_406,axiom,
    bit_un5681908812861735899ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_407,axiom,
    semiri1453513574482234551roduct(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_408,axiom,
    euclid5411537665997757685th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_409,axiom,
    euclid8789492081693882211th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_410,axiom,
    ordere1937475149494474687imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_411,axiom,
    euclid3128863361964157862miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_412,axiom,
    euclid4440199948858584721cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_413,axiom,
    unique1627219031080169319umeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_414,axiom,
    euclid8851590272496341667cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_415,axiom,
    semiri6575147826004484403cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_416,axiom,
    strict9044650504122735259up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_417,axiom,
    ordere580206878836729694up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_418,axiom,
    ordere2412721322843649153imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_419,axiom,
    bit_se359711467146920520ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_420,axiom,
    linord2810124833399127020strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_421,axiom,
    strict7427464778891057005id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_422,axiom,
    ordere8940638589300402666id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_423,axiom,
    euclid3725896446679973847miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_424,axiom,
    linord715952674999750819strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_425,axiom,
    linord4140545234300271783up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_426,axiom,
    bit_ri3973907225187159222ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_427,axiom,
    linord181362715937106298miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_428,axiom,
    linord8928482502909563296strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_429,axiom,
    semiri3467727345109120633visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_430,axiom,
    ordere6658533253407199908up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_431,axiom,
    ordere166539214618696060dd_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_432,axiom,
    ordere6911136660526730532id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_433,axiom,
    linord5086331880401160121up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_434,axiom,
    cancel2418104881723323429up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_435,axiom,
    ring_15535105094025558882visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_436,axiom,
    cancel1802427076303600483id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_437,axiom,
    linord4710134922213307826strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_438,axiom,
    comm_s4317794764714335236cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_439,axiom,
    bit_semiring_bits(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_440,axiom,
    ordere2520102378445227354miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_441,axiom,
    linord6961819062388156250ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_442,axiom,
    ordered_ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_443,axiom,
    cancel_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_444,axiom,
    linordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_445,axiom,
    ordered_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_446,axiom,
    linordered_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_447,axiom,
    ab_semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_448,axiom,
    algebraic_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_449,axiom,
    comm_monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_450,axiom,
    ab_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_451,axiom,
    ordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_452,axiom,
    ordered_ring_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_453,axiom,
    semiring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_454,axiom,
    comm_monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_455,axiom,
    semiring_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_456,axiom,
    linordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_457,axiom,
    linordered_idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_458,axiom,
    comm_semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_459,axiom,
    comm_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_460,axiom,
    semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_461,axiom,
    semidom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_462,axiom,
    semidom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_463,axiom,
    semiring_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_464,axiom,
    semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_465,axiom,
    zero_less_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_466,axiom,
    comm_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_467,axiom,
    semiring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_468,axiom,
    ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_469,axiom,
    zero_neq_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_470,axiom,
    ordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_471,axiom,
    idom_abs_sgn(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_472,axiom,
    preorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_473,axiom,
    linorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_474,axiom,
    monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_475,axiom,
    idom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_476,axiom,
    idom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_477,axiom,
    comm_ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_478,axiom,
    monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_479,axiom,
    semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_480,axiom,
    semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_481,axiom,
    group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_482,axiom,
    mult_zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_483,axiom,
    comm_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oorder_484,axiom,
    order(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_485,axiom,
    neg_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_486,axiom,
    ring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring_487,axiom,
    semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oord_488,axiom,
    ord(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ouminus_489,axiom,
    uminus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1_490,axiom,
    ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_491,axiom,
    abs_if(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Otimes_492,axiom,
    times(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ominus_493,axiom,
    minus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Power_Opower_494,axiom,
    power(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Onumeral_495,axiom,
    numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ozero_496,axiom,
    zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring_497,axiom,
    ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom_498,axiom,
    idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oone_499,axiom,
    one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Odvd_500,axiom,
    dvd(code_integer) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_501,axiom,
    bit_un5681908812861735899ations(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring__with__nat_502,axiom,
    euclid5411537665997757685th_nat(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__monoid__add__imp__le_503,axiom,
    ordere1937475149494474687imp_le(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring_504,axiom,
    euclid3128863361964157862miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring__cancel_505,axiom,
    euclid4440199948858584721cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors__cancel_506,axiom,
    semiri6575147826004484403cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__ab__semigroup__add_507,axiom,
    strict9044650504122735259up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__ab__semigroup__add_508,axiom,
    ordere580206878836729694up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add__imp__le_509,axiom,
    ordere2412721322843649153imp_le(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bit__operations_510,axiom,
    bit_se359711467146920520ations(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__comm__semiring__strict_511,axiom,
    linord2810124833399127020strict(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__comm__monoid__add_512,axiom,
    strict7427464778891057005id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__comm__monoid__add_513,axiom,
    ordere8940638589300402666id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring_514,axiom,
    euclid3725896446679973847miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Olinordered__ab__semigroup__add_515,axiom,
    linord4140545234300271783up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__nonzero__semiring_516,axiom,
    linord181362715937106298miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring__strict_517,axiom,
    linord8928482502909563296strict(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors_518,axiom,
    semiri3467727345109120633visors(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_519,axiom,
    ordere6658533253407199908up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__comm__monoid__add_520,axiom,
    ordere6911136660526730532id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__ab__semigroup__add_521,axiom,
    cancel2418104881723323429up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_522,axiom,
    cancel1802427076303600483id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1__cancel_523,axiom,
    comm_s4317794764714335236cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bits_524,axiom,
    bit_semiring_bits(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__comm__semiring_525,axiom,
    ordere2520102378445227354miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_526,axiom,
    cancel_semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring_527,axiom,
    linordered_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring__0_528,axiom,
    ordered_semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semidom_529,axiom,
    linordered_semidom(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__mult_530,axiom,
    ab_semigroup_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oalgebraic__semidom_531,axiom,
    algebraic_semidom(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__mult_532,axiom,
    comm_monoid_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__diff_533,axiom,
    comm_monoid_diff(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_534,axiom,
    ab_semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring_535,axiom,
    ordered_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Parity_Osemiring__parity_536,axiom,
    semiring_parity(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_537,axiom,
    comm_monoid_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__modulo_538,axiom,
    semiring_modulo(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_539,axiom,
    comm_semiring_1(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__0_540,axiom,
    comm_semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Osemigroup__mult_541,axiom,
    semigroup_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemidom__modulo_542,axiom,
    semidom_modulo(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemidom__divide_543,axiom,
    semidom_divide(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Num_Osemiring__numeral_544,axiom,
    semiring_numeral(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_545,axiom,
    semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ozero__less__one_546,axiom,
    zero_less_one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring_547,axiom,
    comm_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Nat_Osemiring__char__0_548,axiom,
    semiring_char_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ozero__neq__one_549,axiom,
    zero_neq_one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Opreorder_550,axiom,
    preorder(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Olinorder_551,axiom,
    linorder(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Omonoid__mult_552,axiom,
    monoid_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_553,axiom,
    monoid_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__1_554,axiom,
    semiring_1(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__0_555,axiom,
    semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Omult__zero_556,axiom,
    mult_zero(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Oorder_557,axiom,
    order(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring_558,axiom,
    semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Oord_559,axiom,
    ord(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Otimes_560,axiom,
    times(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ominus_561,axiom,
    minus(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Power_Opower_562,axiom,
    power(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Num_Onumeral_563,axiom,
    numeral(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ozero_564,axiom,
    zero(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oone_565,axiom,
    one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Odvd_566,axiom,
    dvd(code_natural) ).

% Helper facts (17)
tff(help_If_2_1_T,axiom,
    ! [A: $tType,X2: A,Y: A] : ( if(A,fFalse,X2,Y) = Y ) ).

tff(help_If_1_1_T,axiom,
    ! [A: $tType,X2: A,Y: A] : ( if(A,fTrue,X2,Y) = X2 ) ).

tff(help_fAll_1_1_U,axiom,
    ! [A: $tType,P: fun(A,bool),X2: A] :
      ( ~ pp(aa(fun(A,bool),bool,fAll(A),P))
      | pp(aa(A,bool,P,X2)) ) ).

tff(help_fNot_2_1_U,axiom,
    ! [P: bool] :
      ( pp(P)
      | pp(aa(bool,bool,fNot,P)) ) ).

tff(help_fNot_1_1_U,axiom,
    ! [P: bool] :
      ( ~ pp(aa(bool,bool,fNot,P))
      | ~ pp(P) ) ).

tff(help_fTrue_1_1_U,axiom,
    pp(fTrue) ).

tff(help_fconj_3_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(fconj(P,Q))
      | pp(Q) ) ).

tff(help_fconj_2_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(fconj(P,Q))
      | pp(P) ) ).

tff(help_fconj_1_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(P)
      | ~ pp(Q)
      | pp(fconj(P,Q)) ) ).

tff(help_fdisj_3_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(fdisj(P,Q))
      | pp(P)
      | pp(Q) ) ).

tff(help_fdisj_2_1_U,axiom,
    ! [Q: bool,P: bool] :
      ( ~ pp(Q)
      | pp(fdisj(P,Q)) ) ).

tff(help_fdisj_1_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(P)
      | pp(fdisj(P,Q)) ) ).

tff(help_fFalse_1_1_T,axiom,
    ! [P: bool] :
      ( ( P = fTrue )
      | ( P = fFalse ) ) ).

tff(help_fFalse_1_1_U,axiom,
    ~ pp(fFalse) ).

tff(help_fequal_2_1_T,axiom,
    ! [A: $tType,X2: A,Y: A] :
      ( ( X2 != Y )
      | pp(aa(A,bool,aa(A,fun(A,bool),fequal(A),X2),Y)) ) ).

tff(help_fequal_1_1_T,axiom,
    ! [A: $tType,X2: A,Y: A] :
      ( ~ pp(aa(A,bool,aa(A,fun(A,bool),fequal(A),X2),Y))
      | ( X2 = Y ) ) ).

tff(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( aa(A,bool,P,fChoice(A,P)) = aa(fun(A,bool),bool,fEx(A),P) ) ).

% Conjectures (4)
tff(conj_0,hypothesis,
    entails(p,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),p2),top_top(assn))) ).

tff(conj_1,hypothesis,
    ! [X4: a] : entails(q(X4),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),q2(X4)),top_top(assn))) ).

tff(conj_2,hypothesis,
    hoare_hoare_triple(a,p2,c,aTP_Lamp_a(a,assn)) ).

tff(conj_3,conjecture,
    entails(p,p_0_ATP) ).

%------------------------------------------------------------------------------
