%------------------------------------------------------------------------------
% File     : VBT00009_4 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem Hoare_Triple 00195_005707
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0025_Hoare_Triple_00195_005707 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 10678 (3759 unt;2390 typ;   0 def)
%            Number of atoms       : 12995 (6709 equ)
%            Maximal formula atoms :   28 (   1 avg)
%            Number of connectives : 13523 (1401   ~; 181   |;1074   &)
%                                         (1747 <=>;9120  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   31 (   6 avg)
%            Maximal term depth    :   37 (   2 avg)
%            Number of FOOLs       :  610 ( 364 fml; 246 var)
%            Number of X terms     :  380 (   0  []; 343 ite;  37 let)
%            Number of types       :   14 (  13 usr)
%            Number of type conns  : 2287 (1806   >; 481   *;   0   +;   0  <<)
%            Number of predicates  :  296 ( 293 usr;   2 prp; 0-9 aty)
%            Number of functors    : 2103 (2103 usr;  72 con; 0-8 aty)
%            Number of variables   : 32756 (28405   !; 424   ?;32756   :)
%                                         (3927  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TX1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 15:24:28.984
%------------------------------------------------------------------------------
% Could-be-implicit typings (27)
tff(ty_t_Heap__Time__Monad_OHeap,type,
    heap_Time_Heap: $tType > $tType ).

tff(ty_t_Code__Numeral_Onatural,type,
    code_natural: $tType ).

tff(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

tff(ty_t_Heap_Oheap_Oheap__ext,type,
    heap_ext: $tType > $tType ).

tff(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

tff(ty_t_Product__Type_Oprod,type,
    product_prod: ( $tType * $tType ) > $tType ).

tff(ty_t_Old__Datatype_Onode,type,
    old_node: ( $tType * $tType ) > $tType ).

tff(ty_t_Multiset_Omultiset,type,
    multiset: $tType > $tType ).

tff(ty_t_Typerep_Otyperep,type,
    typerep: $tType ).

tff(ty_t_Assertions_Oassn,type,
    assn: $tType ).

tff(ty_t_Sum__Type_Osum,type,
    sum_sum: ( $tType * $tType ) > $tType ).

tff(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

tff(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

tff(ty_t_String_Ochar,type,
    char: $tType ).

tff(ty_t_Heap_Oarray,type,
    array: $tType > $tType ).

tff(ty_t_List_Olist,type,
    list: $tType > $tType ).

tff(ty_t_Heap_Oref,type,
    ref: $tType > $tType ).

tff(ty_t_Set_Oset,type,
    set: $tType > $tType ).

tff(ty_t_Rat_Orat,type,
    rat: $tType ).

tff(ty_t_Num_Onum,type,
    num: $tType ).

tff(ty_t_Nat_Onat,type,
    nat: $tType ).

tff(ty_t_Int_Oint,type,
    int: $tType ).

tff(ty_t_itself,type,
    itself: $tType > $tType ).

tff(ty_t_fun,type,
    fun: ( $tType * $tType ) > $tType ).

tff(ty_tf_c,type,
    c: $tType ).

tff(ty_tf_b,type,
    b: $tType ).

tff(ty_tf_a,type,
    a: $tType ).

% Explicit typings (2363)
tff(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

tff(sy_cl_Heap_Oheap,type,
    heap: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Otimes,type,
    times: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Oinf,type,
    inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osup,type,
    sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Obot,type,
    bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Otop,type,
    top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Countable_Ocountable,type,
    countable: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Ofinite__lattice,type,
    finite_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_OInf,type,
    complete_Inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_OSup,type,
    complete_Sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Partial__Order_Occpo,type,
    comple9053668089753744459l_ccpo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Onormalization__semidom,type,
    normal8620421768224518004emidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice__bot,type,
    bounded_lattice_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice__top,type,
    bounded_lattice_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide__unit__factor,type,
    semido2269285787275462019factor: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__boolean__algebra,type,
    comple489889107523837845lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Onormalization__semidom__multiplicative,type,
    normal6328177297339901930cative: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

tff(sy_c_ATP_058Lamp__a____,type,
    aTP_Lamp_a: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aa____,type,
    aTP_Lamp_aa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaa____,type,
    aTP_Lamp_aaa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aab____,type,
    aTP_Lamp_aab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aac____,type,
    aTP_Lamp_aac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aad____,type,
    aTP_Lamp_aad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aae____,type,
    aTP_Lamp_aae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaf____,type,
    aTP_Lamp_aaf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aag____,type,
    aTP_Lamp_aag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aah____,type,
    aTP_Lamp_aah: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aai____,type,
    aTP_Lamp_aai: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aaj____,type,
    aTP_Lamp_aaj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aak____,type,
    aTP_Lamp_aak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aal____,type,
    aTP_Lamp_aal: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aam____,type,
    aTP_Lamp_aam: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aan____,type,
    aTP_Lamp_aan: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aao____,type,
    aTP_Lamp_aao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aap____,type,
    aTP_Lamp_aap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaq____,type,
    aTP_Lamp_aaq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aar____,type,
    aTP_Lamp_aar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aas____,type,
    aTP_Lamp_aas: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aat____,type,
    aTP_Lamp_aat: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aau____,type,
    aTP_Lamp_aau: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aav____,type,
    aTP_Lamp_aav: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaw____,type,
    aTP_Lamp_aaw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aax____,type,
    aTP_Lamp_aax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aay____,type,
    aTP_Lamp_aay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaz____,type,
    aTP_Lamp_aaz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ab____,type,
    aTP_Lamp_ab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aba____,type,
    aTP_Lamp_aba: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abb____,type,
    aTP_Lamp_abb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abc____,type,
    aTP_Lamp_abc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abd____,type,
    aTP_Lamp_abd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abe____,type,
    aTP_Lamp_abe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abf____,type,
    aTP_Lamp_abf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abg____,type,
    aTP_Lamp_abg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abh____,type,
    aTP_Lamp_abh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abi____,type,
    aTP_Lamp_abi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abj____,type,
    aTP_Lamp_abj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abk____,type,
    aTP_Lamp_abk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abl____,type,
    aTP_Lamp_abl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abm____,type,
    aTP_Lamp_abm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abn____,type,
    aTP_Lamp_abn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abo____,type,
    aTP_Lamp_abo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abp____,type,
    aTP_Lamp_abp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abq____,type,
    aTP_Lamp_abq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abr____,type,
    aTP_Lamp_abr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abs____,type,
    aTP_Lamp_abs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abt____,type,
    aTP_Lamp_abt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abu____,type,
    aTP_Lamp_abu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abv____,type,
    aTP_Lamp_abv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abw____,type,
    aTP_Lamp_abw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abx____,type,
    aTP_Lamp_abx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aby____,type,
    aTP_Lamp_aby: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abz____,type,
    aTP_Lamp_abz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ac____,type,
    aTP_Lamp_ac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aca____,type,
    aTP_Lamp_aca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acb____,type,
    aTP_Lamp_acb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acc____,type,
    aTP_Lamp_acc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acd____,type,
    aTP_Lamp_acd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ace____,type,
    aTP_Lamp_ace: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acf____,type,
    aTP_Lamp_acf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acg____,type,
    aTP_Lamp_acg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ach____,type,
    aTP_Lamp_ach: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aci____,type,
    aTP_Lamp_aci: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acj____,type,
    aTP_Lamp_acj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ack____,type,
    aTP_Lamp_ack: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acl____,type,
    aTP_Lamp_acl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acm____,type,
    aTP_Lamp_acm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acn____,type,
    aTP_Lamp_acn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aco____,type,
    aTP_Lamp_aco: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acp____,type,
    aTP_Lamp_acp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acq____,type,
    aTP_Lamp_acq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acr____,type,
    aTP_Lamp_acr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acs____,type,
    aTP_Lamp_acs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__act____,type,
    aTP_Lamp_act: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acu____,type,
    aTP_Lamp_acu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acv____,type,
    aTP_Lamp_acv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acw____,type,
    aTP_Lamp_acw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acx____,type,
    aTP_Lamp_acx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acy____,type,
    aTP_Lamp_acy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acz____,type,
    aTP_Lamp_acz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ad____,type,
    aTP_Lamp_ad: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ada____,type,
    aTP_Lamp_ada: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adb____,type,
    aTP_Lamp_adb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adc____,type,
    aTP_Lamp_adc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__add____,type,
    aTP_Lamp_add: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ade____,type,
    aTP_Lamp_ade: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adf____,type,
    aTP_Lamp_adf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adg____,type,
    aTP_Lamp_adg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adh____,type,
    aTP_Lamp_adh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adi____,type,
    aTP_Lamp_adi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adj____,type,
    aTP_Lamp_adj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adk____,type,
    aTP_Lamp_adk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adl____,type,
    aTP_Lamp_adl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adm____,type,
    aTP_Lamp_adm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adn____,type,
    aTP_Lamp_adn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ado____,type,
    aTP_Lamp_ado: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adp____,type,
    aTP_Lamp_adp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adq____,type,
    aTP_Lamp_adq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adr____,type,
    aTP_Lamp_adr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ads____,type,
    aTP_Lamp_ads: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adt____,type,
    aTP_Lamp_adt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adu____,type,
    aTP_Lamp_adu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adv____,type,
    aTP_Lamp_adv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adw____,type,
    aTP_Lamp_adw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adx____,type,
    aTP_Lamp_adx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ady____,type,
    aTP_Lamp_ady: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adz____,type,
    aTP_Lamp_adz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ae____,type,
    aTP_Lamp_ae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aea____,type,
    aTP_Lamp_aea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeb____,type,
    aTP_Lamp_aeb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aec____,type,
    aTP_Lamp_aec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aed____,type,
    aTP_Lamp_aed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aee____,type,
    aTP_Lamp_aee: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aef____,type,
    aTP_Lamp_aef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeg____,type,
    aTP_Lamp_aeg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeh____,type,
    aTP_Lamp_aeh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aei____,type,
    aTP_Lamp_aei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aej____,type,
    aTP_Lamp_aej: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aek____,type,
    aTP_Lamp_aek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ael____,type,
    aTP_Lamp_ael: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aem____,type,
    aTP_Lamp_aem: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aen____,type,
    aTP_Lamp_aen: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeo____,type,
    aTP_Lamp_aeo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aep____,type,
    aTP_Lamp_aep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeq____,type,
    aTP_Lamp_aeq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aer____,type,
    aTP_Lamp_aer: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aes____,type,
    aTP_Lamp_aes: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aet____,type,
    aTP_Lamp_aet: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeu____,type,
    aTP_Lamp_aeu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aev____,type,
    aTP_Lamp_aev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aew____,type,
    aTP_Lamp_aew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aex____,type,
    aTP_Lamp_aex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aey____,type,
    aTP_Lamp_aey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aez____,type,
    aTP_Lamp_aez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__af____,type,
    aTP_Lamp_af: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afa____,type,
    aTP_Lamp_afa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afb____,type,
    aTP_Lamp_afb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afc____,type,
    aTP_Lamp_afc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afd____,type,
    aTP_Lamp_afd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afe____,type,
    aTP_Lamp_afe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aff____,type,
    aTP_Lamp_aff: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afg____,type,
    aTP_Lamp_afg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afh____,type,
    aTP_Lamp_afh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afi____,type,
    aTP_Lamp_afi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afj____,type,
    aTP_Lamp_afj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afk____,type,
    aTP_Lamp_afk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afl____,type,
    aTP_Lamp_afl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afm____,type,
    aTP_Lamp_afm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afn____,type,
    aTP_Lamp_afn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afo____,type,
    aTP_Lamp_afo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afp____,type,
    aTP_Lamp_afp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afq____,type,
    aTP_Lamp_afq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afr____,type,
    aTP_Lamp_afr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afs____,type,
    aTP_Lamp_afs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aft____,type,
    aTP_Lamp_aft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afu____,type,
    aTP_Lamp_afu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afv____,type,
    aTP_Lamp_afv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afw____,type,
    aTP_Lamp_afw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afx____,type,
    aTP_Lamp_afx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afy____,type,
    aTP_Lamp_afy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afz____,type,
    aTP_Lamp_afz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ag____,type,
    aTP_Lamp_ag: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aga____,type,
    aTP_Lamp_aga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agb____,type,
    aTP_Lamp_agb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agc____,type,
    aTP_Lamp_agc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agd____,type,
    aTP_Lamp_agd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__age____,type,
    aTP_Lamp_age: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agf____,type,
    aTP_Lamp_agf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agg____,type,
    aTP_Lamp_agg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agh____,type,
    aTP_Lamp_agh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agi____,type,
    aTP_Lamp_agi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agj____,type,
    aTP_Lamp_agj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agk____,type,
    aTP_Lamp_agk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agl____,type,
    aTP_Lamp_agl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agm____,type,
    aTP_Lamp_agm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agn____,type,
    aTP_Lamp_agn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ago____,type,
    aTP_Lamp_ago: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agp____,type,
    aTP_Lamp_agp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agq____,type,
    aTP_Lamp_agq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agr____,type,
    aTP_Lamp_agr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ags____,type,
    aTP_Lamp_ags: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agt____,type,
    aTP_Lamp_agt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agu____,type,
    aTP_Lamp_agu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agv____,type,
    aTP_Lamp_agv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agw____,type,
    aTP_Lamp_agw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agx____,type,
    aTP_Lamp_agx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agy____,type,
    aTP_Lamp_agy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agz____,type,
    aTP_Lamp_agz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ah____,type,
    aTP_Lamp_ah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aha____,type,
    aTP_Lamp_aha: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahb____,type,
    aTP_Lamp_ahb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahc____,type,
    aTP_Lamp_ahc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahd____,type,
    aTP_Lamp_ahd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahe____,type,
    aTP_Lamp_ahe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahf____,type,
    aTP_Lamp_ahf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahg____,type,
    aTP_Lamp_ahg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahh____,type,
    aTP_Lamp_ahh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahi____,type,
    aTP_Lamp_ahi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahj____,type,
    aTP_Lamp_ahj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahk____,type,
    aTP_Lamp_ahk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahl____,type,
    aTP_Lamp_ahl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahm____,type,
    aTP_Lamp_ahm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahn____,type,
    aTP_Lamp_ahn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aho____,type,
    aTP_Lamp_aho: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahp____,type,
    aTP_Lamp_ahp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahq____,type,
    aTP_Lamp_ahq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahr____,type,
    aTP_Lamp_ahr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahs____,type,
    aTP_Lamp_ahs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aht____,type,
    aTP_Lamp_aht: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahu____,type,
    aTP_Lamp_ahu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahv____,type,
    aTP_Lamp_ahv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahw____,type,
    aTP_Lamp_ahw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahx____,type,
    aTP_Lamp_ahx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahy____,type,
    aTP_Lamp_ahy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahz____,type,
    aTP_Lamp_ahz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ai____,type,
    aTP_Lamp_ai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aia____,type,
    aTP_Lamp_aia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aib____,type,
    aTP_Lamp_aib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aic____,type,
    aTP_Lamp_aic: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aid____,type,
    aTP_Lamp_aid: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aie____,type,
    aTP_Lamp_aie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aif____,type,
    aTP_Lamp_aif: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aig____,type,
    aTP_Lamp_aig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aih____,type,
    aTP_Lamp_aih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aii____,type,
    aTP_Lamp_aii: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aij____,type,
    aTP_Lamp_aij: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aik____,type,
    aTP_Lamp_aik: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ail____,type,
    aTP_Lamp_ail: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aim____,type,
    aTP_Lamp_aim: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ain____,type,
    aTP_Lamp_ain: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aio____,type,
    aTP_Lamp_aio: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aip____,type,
    aTP_Lamp_aip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiq____,type,
    aTP_Lamp_aiq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__air____,type,
    aTP_Lamp_air: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ais____,type,
    aTP_Lamp_ais: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ait____,type,
    aTP_Lamp_ait: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aiu____,type,
    aTP_Lamp_aiu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aiv____,type,
    aTP_Lamp_aiv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aiw____,type,
    aTP_Lamp_aiw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aix____,type,
    aTP_Lamp_aix: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiy____,type,
    aTP_Lamp_aiy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiz____,type,
    aTP_Lamp_aiz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aj____,type,
    aTP_Lamp_aj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aja____,type,
    aTP_Lamp_aja: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajb____,type,
    aTP_Lamp_ajb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajc____,type,
    aTP_Lamp_ajc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajd____,type,
    aTP_Lamp_ajd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aje____,type,
    aTP_Lamp_aje: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajf____,type,
    aTP_Lamp_ajf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajg____,type,
    aTP_Lamp_ajg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajh____,type,
    aTP_Lamp_ajh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aji____,type,
    aTP_Lamp_aji: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajj____,type,
    aTP_Lamp_ajj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajk____,type,
    aTP_Lamp_ajk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajl____,type,
    aTP_Lamp_ajl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajm____,type,
    aTP_Lamp_ajm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajn____,type,
    aTP_Lamp_ajn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajo____,type,
    aTP_Lamp_ajo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajp____,type,
    aTP_Lamp_ajp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajq____,type,
    aTP_Lamp_ajq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajr____,type,
    aTP_Lamp_ajr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajs____,type,
    aTP_Lamp_ajs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajt____,type,
    aTP_Lamp_ajt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aju____,type,
    aTP_Lamp_aju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajv____,type,
    aTP_Lamp_ajv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajw____,type,
    aTP_Lamp_ajw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajx____,type,
    aTP_Lamp_ajx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajy____,type,
    aTP_Lamp_ajy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajz____,type,
    aTP_Lamp_ajz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ak____,type,
    aTP_Lamp_ak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aka____,type,
    aTP_Lamp_aka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akb____,type,
    aTP_Lamp_akb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akc____,type,
    aTP_Lamp_akc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akd____,type,
    aTP_Lamp_akd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ake____,type,
    aTP_Lamp_ake: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akf____,type,
    aTP_Lamp_akf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akg____,type,
    aTP_Lamp_akg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akh____,type,
    aTP_Lamp_akh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aki____,type,
    aTP_Lamp_aki: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akj____,type,
    aTP_Lamp_akj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akk____,type,
    aTP_Lamp_akk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akl____,type,
    aTP_Lamp_akl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akm____,type,
    aTP_Lamp_akm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akn____,type,
    aTP_Lamp_akn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ako____,type,
    aTP_Lamp_ako: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akp____,type,
    aTP_Lamp_akp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akq____,type,
    aTP_Lamp_akq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akr____,type,
    aTP_Lamp_akr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aks____,type,
    aTP_Lamp_aks: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akt____,type,
    aTP_Lamp_akt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aku____,type,
    aTP_Lamp_aku: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akv____,type,
    aTP_Lamp_akv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__akw____,type,
    aTP_Lamp_akw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__akx____,type,
    aTP_Lamp_akx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aky____,type,
    aTP_Lamp_aky: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akz____,type,
    aTP_Lamp_akz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__al____,type,
    aTP_Lamp_al: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ala____,type,
    aTP_Lamp_ala: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alb____,type,
    aTP_Lamp_alb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alc____,type,
    aTP_Lamp_alc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ald____,type,
    aTP_Lamp_ald: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ale____,type,
    aTP_Lamp_ale: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__alf____,type,
    aTP_Lamp_alf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alg____,type,
    aTP_Lamp_alg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alh____,type,
    aTP_Lamp_alh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ali____,type,
    aTP_Lamp_ali: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alj____,type,
    aTP_Lamp_alj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__alk____,type,
    aTP_Lamp_alk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__all____,type,
    aTP_Lamp_all: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alm____,type,
    aTP_Lamp_alm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aln____,type,
    aTP_Lamp_aln: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alo____,type,
    aTP_Lamp_alo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alp____,type,
    aTP_Lamp_alp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alq____,type,
    aTP_Lamp_alq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alr____,type,
    aTP_Lamp_alr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__als____,type,
    aTP_Lamp_als: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alt____,type,
    aTP_Lamp_alt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alu____,type,
    aTP_Lamp_alu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alv____,type,
    aTP_Lamp_alv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alw____,type,
    aTP_Lamp_alw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alx____,type,
    aTP_Lamp_alx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aly____,type,
    aTP_Lamp_aly: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alz____,type,
    aTP_Lamp_alz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__am____,type,
    aTP_Lamp_am: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ama____,type,
    aTP_Lamp_ama: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amb____,type,
    aTP_Lamp_amb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amc____,type,
    aTP_Lamp_amc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amd____,type,
    aTP_Lamp_amd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ame____,type,
    aTP_Lamp_ame: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amf____,type,
    aTP_Lamp_amf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amg____,type,
    aTP_Lamp_amg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amh____,type,
    aTP_Lamp_amh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ami____,type,
    aTP_Lamp_ami: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amj____,type,
    aTP_Lamp_amj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amk____,type,
    aTP_Lamp_amk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aml____,type,
    aTP_Lamp_aml: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amm____,type,
    aTP_Lamp_amm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amn____,type,
    aTP_Lamp_amn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amo____,type,
    aTP_Lamp_amo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amp____,type,
    aTP_Lamp_amp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amq____,type,
    aTP_Lamp_amq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amr____,type,
    aTP_Lamp_amr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ams____,type,
    aTP_Lamp_ams: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amt____,type,
    aTP_Lamp_amt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amu____,type,
    aTP_Lamp_amu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amv____,type,
    aTP_Lamp_amv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amw____,type,
    aTP_Lamp_amw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amx____,type,
    aTP_Lamp_amx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amy____,type,
    aTP_Lamp_amy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amz____,type,
    aTP_Lamp_amz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__an____,type,
    aTP_Lamp_an: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ana____,type,
    aTP_Lamp_ana: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anb____,type,
    aTP_Lamp_anb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anc____,type,
    aTP_Lamp_anc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__and____,type,
    aTP_Lamp_and: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ane____,type,
    aTP_Lamp_ane: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anf____,type,
    aTP_Lamp_anf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ang____,type,
    aTP_Lamp_ang: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anh____,type,
    aTP_Lamp_anh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ani____,type,
    aTP_Lamp_ani: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anj____,type,
    aTP_Lamp_anj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ank____,type,
    aTP_Lamp_ank: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anl____,type,
    aTP_Lamp_anl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anm____,type,
    aTP_Lamp_anm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ann____,type,
    aTP_Lamp_ann: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ano____,type,
    aTP_Lamp_ano: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anp____,type,
    aTP_Lamp_anp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anq____,type,
    aTP_Lamp_anq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anr____,type,
    aTP_Lamp_anr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ans____,type,
    aTP_Lamp_ans: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ant____,type,
    aTP_Lamp_ant: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anu____,type,
    aTP_Lamp_anu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anv____,type,
    aTP_Lamp_anv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anw____,type,
    aTP_Lamp_anw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anx____,type,
    aTP_Lamp_anx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__any____,type,
    aTP_Lamp_any: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anz____,type,
    aTP_Lamp_anz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ao____,type,
    aTP_Lamp_ao: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aoa____,type,
    aTP_Lamp_aoa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aob____,type,
    aTP_Lamp_aob: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoc____,type,
    aTP_Lamp_aoc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aod____,type,
    aTP_Lamp_aod: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoe____,type,
    aTP_Lamp_aoe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aof____,type,
    aTP_Lamp_aof: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aog____,type,
    aTP_Lamp_aog: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aoh____,type,
    aTP_Lamp_aoh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoi____,type,
    aTP_Lamp_aoi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoj____,type,
    aTP_Lamp_aoj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aok____,type,
    aTP_Lamp_aok: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aol____,type,
    aTP_Lamp_aol: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aom____,type,
    aTP_Lamp_aom: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aon____,type,
    aTP_Lamp_aon: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoo____,type,
    aTP_Lamp_aoo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aop____,type,
    aTP_Lamp_aop: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoq____,type,
    aTP_Lamp_aoq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aor____,type,
    aTP_Lamp_aor: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aos____,type,
    aTP_Lamp_aos: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aot____,type,
    aTP_Lamp_aot: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aou____,type,
    aTP_Lamp_aou: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aov____,type,
    aTP_Lamp_aov: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aow____,type,
    aTP_Lamp_aow: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aox____,type,
    aTP_Lamp_aox: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoy____,type,
    aTP_Lamp_aoy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoz____,type,
    aTP_Lamp_aoz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ap____,type,
    aTP_Lamp_ap: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apa____,type,
    aTP_Lamp_apa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apb____,type,
    aTP_Lamp_apb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apc____,type,
    aTP_Lamp_apc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apd____,type,
    aTP_Lamp_apd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ape____,type,
    aTP_Lamp_ape: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apf____,type,
    aTP_Lamp_apf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apg____,type,
    aTP_Lamp_apg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aph____,type,
    aTP_Lamp_aph: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__api____,type,
    aTP_Lamp_api: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apj____,type,
    aTP_Lamp_apj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apk____,type,
    aTP_Lamp_apk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apl____,type,
    aTP_Lamp_apl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apm____,type,
    aTP_Lamp_apm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apn____,type,
    aTP_Lamp_apn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apo____,type,
    aTP_Lamp_apo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__app____,type,
    aTP_Lamp_app: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apq____,type,
    aTP_Lamp_apq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apr____,type,
    aTP_Lamp_apr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aps____,type,
    aTP_Lamp_aps: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apt____,type,
    aTP_Lamp_apt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apu____,type,
    aTP_Lamp_apu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apv____,type,
    aTP_Lamp_apv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apw____,type,
    aTP_Lamp_apw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apx____,type,
    aTP_Lamp_apx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apy____,type,
    aTP_Lamp_apy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__apz____,type,
    aTP_Lamp_apz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aq____,type,
    aTP_Lamp_aq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqa____,type,
    aTP_Lamp_aqa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqb____,type,
    aTP_Lamp_aqb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqc____,type,
    aTP_Lamp_aqc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqd____,type,
    aTP_Lamp_aqd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqe____,type,
    aTP_Lamp_aqe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqf____,type,
    aTP_Lamp_aqf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqg____,type,
    aTP_Lamp_aqg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqh____,type,
    aTP_Lamp_aqh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqi____,type,
    aTP_Lamp_aqi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqj____,type,
    aTP_Lamp_aqj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqk____,type,
    aTP_Lamp_aqk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aql____,type,
    aTP_Lamp_aql: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqm____,type,
    aTP_Lamp_aqm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqn____,type,
    aTP_Lamp_aqn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqo____,type,
    aTP_Lamp_aqo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqp____,type,
    aTP_Lamp_aqp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqq____,type,
    aTP_Lamp_aqq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqr____,type,
    aTP_Lamp_aqr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqs____,type,
    aTP_Lamp_aqs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqt____,type,
    aTP_Lamp_aqt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqu____,type,
    aTP_Lamp_aqu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqv____,type,
    aTP_Lamp_aqv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqw____,type,
    aTP_Lamp_aqw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqx____,type,
    aTP_Lamp_aqx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqy____,type,
    aTP_Lamp_aqy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqz____,type,
    aTP_Lamp_aqz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ar____,type,
    aTP_Lamp_ar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ara____,type,
    aTP_Lamp_ara: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arb____,type,
    aTP_Lamp_arb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arc____,type,
    aTP_Lamp_arc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ard____,type,
    aTP_Lamp_ard: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__are____,type,
    aTP_Lamp_are: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arf____,type,
    aTP_Lamp_arf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arg____,type,
    aTP_Lamp_arg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arh____,type,
    aTP_Lamp_arh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ari____,type,
    aTP_Lamp_ari: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arj____,type,
    aTP_Lamp_arj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ark____,type,
    aTP_Lamp_ark: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arl____,type,
    aTP_Lamp_arl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arm____,type,
    aTP_Lamp_arm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__arn____,type,
    aTP_Lamp_arn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aro____,type,
    aTP_Lamp_aro: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arp____,type,
    aTP_Lamp_arp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arq____,type,
    aTP_Lamp_arq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__arr____,type,
    aTP_Lamp_arr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ars____,type,
    aTP_Lamp_ars: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__art____,type,
    aTP_Lamp_art: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aru____,type,
    aTP_Lamp_aru: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arv____,type,
    aTP_Lamp_arv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arw____,type,
    aTP_Lamp_arw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arx____,type,
    aTP_Lamp_arx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ary____,type,
    aTP_Lamp_ary: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arz____,type,
    aTP_Lamp_arz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__as____,type,
    aTP_Lamp_as: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asa____,type,
    aTP_Lamp_asa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asb____,type,
    aTP_Lamp_asb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asc____,type,
    aTP_Lamp_asc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asd____,type,
    aTP_Lamp_asd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ase____,type,
    aTP_Lamp_ase: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asf____,type,
    aTP_Lamp_asf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asg____,type,
    aTP_Lamp_asg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ash____,type,
    aTP_Lamp_ash: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asi____,type,
    aTP_Lamp_asi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asj____,type,
    aTP_Lamp_asj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ask____,type,
    aTP_Lamp_ask: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asl____,type,
    aTP_Lamp_asl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asm____,type,
    aTP_Lamp_asm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asn____,type,
    aTP_Lamp_asn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aso____,type,
    aTP_Lamp_aso: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asp____,type,
    aTP_Lamp_asp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asq____,type,
    aTP_Lamp_asq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asr____,type,
    aTP_Lamp_asr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ass____,type,
    aTP_Lamp_ass: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ast____,type,
    aTP_Lamp_ast: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asu____,type,
    aTP_Lamp_asu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asv____,type,
    aTP_Lamp_asv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asw____,type,
    aTP_Lamp_asw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asx____,type,
    aTP_Lamp_asx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asy____,type,
    aTP_Lamp_asy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asz____,type,
    aTP_Lamp_asz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__at____,type,
    aTP_Lamp_at: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ata____,type,
    aTP_Lamp_ata: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atb____,type,
    aTP_Lamp_atb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atc____,type,
    aTP_Lamp_atc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atd____,type,
    aTP_Lamp_atd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ate____,type,
    aTP_Lamp_ate: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atf____,type,
    aTP_Lamp_atf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atg____,type,
    aTP_Lamp_atg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ath____,type,
    aTP_Lamp_ath: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ati____,type,
    aTP_Lamp_ati: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atj____,type,
    aTP_Lamp_atj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atk____,type,
    aTP_Lamp_atk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atl____,type,
    aTP_Lamp_atl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atm____,type,
    aTP_Lamp_atm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atn____,type,
    aTP_Lamp_atn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ato____,type,
    aTP_Lamp_ato: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atp____,type,
    aTP_Lamp_atp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atq____,type,
    aTP_Lamp_atq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__atr____,type,
    aTP_Lamp_atr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ats____,type,
    aTP_Lamp_ats: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__att____,type,
    aTP_Lamp_att: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atu____,type,
    aTP_Lamp_atu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atv____,type,
    aTP_Lamp_atv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atw____,type,
    aTP_Lamp_atw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atx____,type,
    aTP_Lamp_atx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aty____,type,
    aTP_Lamp_aty: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atz____,type,
    aTP_Lamp_atz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__au____,type,
    aTP_Lamp_au: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aua____,type,
    aTP_Lamp_aua: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aub____,type,
    aTP_Lamp_aub: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auc____,type,
    aTP_Lamp_auc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aud____,type,
    aTP_Lamp_aud: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aue____,type,
    aTP_Lamp_aue: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__auf____,type,
    aTP_Lamp_auf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aug____,type,
    aTP_Lamp_aug: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__auh____,type,
    aTP_Lamp_auh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aui____,type,
    aTP_Lamp_aui: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auj____,type,
    aTP_Lamp_auj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auk____,type,
    aTP_Lamp_auk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aul____,type,
    aTP_Lamp_aul: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aum____,type,
    aTP_Lamp_aum: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aun____,type,
    aTP_Lamp_aun: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__auo____,type,
    aTP_Lamp_auo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aup____,type,
    aTP_Lamp_aup: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auq____,type,
    aTP_Lamp_auq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aur____,type,
    aTP_Lamp_aur: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aus____,type,
    aTP_Lamp_aus: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aut____,type,
    aTP_Lamp_aut: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auu____,type,
    aTP_Lamp_auu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auv____,type,
    aTP_Lamp_auv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auw____,type,
    aTP_Lamp_auw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aux____,type,
    aTP_Lamp_aux: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auy____,type,
    aTP_Lamp_auy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auz____,type,
    aTP_Lamp_auz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__av____,type,
    aTP_Lamp_av: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ava____,type,
    aTP_Lamp_ava: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avb____,type,
    aTP_Lamp_avb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avc____,type,
    aTP_Lamp_avc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avd____,type,
    aTP_Lamp_avd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ave____,type,
    aTP_Lamp_ave: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avf____,type,
    aTP_Lamp_avf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avg____,type,
    aTP_Lamp_avg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avh____,type,
    aTP_Lamp_avh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avi____,type,
    aTP_Lamp_avi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avj____,type,
    aTP_Lamp_avj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avk____,type,
    aTP_Lamp_avk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avl____,type,
    aTP_Lamp_avl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__avm____,type,
    aTP_Lamp_avm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avn____,type,
    aTP_Lamp_avn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avo____,type,
    aTP_Lamp_avo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avp____,type,
    aTP_Lamp_avp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avq____,type,
    aTP_Lamp_avq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avr____,type,
    aTP_Lamp_avr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avs____,type,
    aTP_Lamp_avs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avt____,type,
    aTP_Lamp_avt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avu____,type,
    aTP_Lamp_avu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avv____,type,
    aTP_Lamp_avv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avw____,type,
    aTP_Lamp_avw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avx____,type,
    aTP_Lamp_avx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avy____,type,
    aTP_Lamp_avy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avz____,type,
    aTP_Lamp_avz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aw____,type,
    aTP_Lamp_aw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awa____,type,
    aTP_Lamp_awa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awb____,type,
    aTP_Lamp_awb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awc____,type,
    aTP_Lamp_awc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awd____,type,
    aTP_Lamp_awd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awe____,type,
    aTP_Lamp_awe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awf____,type,
    aTP_Lamp_awf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awg____,type,
    aTP_Lamp_awg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awh____,type,
    aTP_Lamp_awh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awi____,type,
    aTP_Lamp_awi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awj____,type,
    aTP_Lamp_awj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awk____,type,
    aTP_Lamp_awk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awl____,type,
    aTP_Lamp_awl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awm____,type,
    aTP_Lamp_awm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awn____,type,
    aTP_Lamp_awn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awo____,type,
    aTP_Lamp_awo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awp____,type,
    aTP_Lamp_awp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awq____,type,
    aTP_Lamp_awq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awr____,type,
    aTP_Lamp_awr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aws____,type,
    aTP_Lamp_aws: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awt____,type,
    aTP_Lamp_awt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awu____,type,
    aTP_Lamp_awu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awv____,type,
    aTP_Lamp_awv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aww____,type,
    aTP_Lamp_aww: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awx____,type,
    aTP_Lamp_awx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awy____,type,
    aTP_Lamp_awy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awz____,type,
    aTP_Lamp_awz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ax____,type,
    aTP_Lamp_ax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axa____,type,
    aTP_Lamp_axa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__axb____,type,
    aTP_Lamp_axb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axc____,type,
    aTP_Lamp_axc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axd____,type,
    aTP_Lamp_axd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axe____,type,
    aTP_Lamp_axe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axf____,type,
    aTP_Lamp_axf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axg____,type,
    aTP_Lamp_axg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axh____,type,
    aTP_Lamp_axh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axi____,type,
    aTP_Lamp_axi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axj____,type,
    aTP_Lamp_axj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axk____,type,
    aTP_Lamp_axk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axl____,type,
    aTP_Lamp_axl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axm____,type,
    aTP_Lamp_axm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axn____,type,
    aTP_Lamp_axn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axo____,type,
    aTP_Lamp_axo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axp____,type,
    aTP_Lamp_axp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axq____,type,
    aTP_Lamp_axq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axr____,type,
    aTP_Lamp_axr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__axs____,type,
    aTP_Lamp_axs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axt____,type,
    aTP_Lamp_axt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__axu____,type,
    aTP_Lamp_axu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axv____,type,
    aTP_Lamp_axv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axw____,type,
    aTP_Lamp_axw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axx____,type,
    aTP_Lamp_axx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__axy____,type,
    aTP_Lamp_axy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axz____,type,
    aTP_Lamp_axz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ay____,type,
    aTP_Lamp_ay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aya____,type,
    aTP_Lamp_aya: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayb____,type,
    aTP_Lamp_ayb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayc____,type,
    aTP_Lamp_ayc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayd____,type,
    aTP_Lamp_ayd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aye____,type,
    aTP_Lamp_aye: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayf____,type,
    aTP_Lamp_ayf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayg____,type,
    aTP_Lamp_ayg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayh____,type,
    aTP_Lamp_ayh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayi____,type,
    aTP_Lamp_ayi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayj____,type,
    aTP_Lamp_ayj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayk____,type,
    aTP_Lamp_ayk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayl____,type,
    aTP_Lamp_ayl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aym____,type,
    aTP_Lamp_aym: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayn____,type,
    aTP_Lamp_ayn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayo____,type,
    aTP_Lamp_ayo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayp____,type,
    aTP_Lamp_ayp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayq____,type,
    aTP_Lamp_ayq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayr____,type,
    aTP_Lamp_ayr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ays____,type,
    aTP_Lamp_ays: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayt____,type,
    aTP_Lamp_ayt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayu____,type,
    aTP_Lamp_ayu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayv____,type,
    aTP_Lamp_ayv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayw____,type,
    aTP_Lamp_ayw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayx____,type,
    aTP_Lamp_ayx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayy____,type,
    aTP_Lamp_ayy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayz____,type,
    aTP_Lamp_ayz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__az____,type,
    aTP_Lamp_az: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aza____,type,
    aTP_Lamp_aza: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__azb____,type,
    aTP_Lamp_azb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azc____,type,
    aTP_Lamp_azc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azd____,type,
    aTP_Lamp_azd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aze____,type,
    aTP_Lamp_aze: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azf____,type,
    aTP_Lamp_azf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azg____,type,
    aTP_Lamp_azg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azh____,type,
    aTP_Lamp_azh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azi____,type,
    aTP_Lamp_azi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azj____,type,
    aTP_Lamp_azj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azk____,type,
    aTP_Lamp_azk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azl____,type,
    aTP_Lamp_azl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azm____,type,
    aTP_Lamp_azm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__azn____,type,
    aTP_Lamp_azn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__azo____,type,
    aTP_Lamp_azo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__azp____,type,
    aTP_Lamp_azp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azq____,type,
    aTP_Lamp_azq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azr____,type,
    aTP_Lamp_azr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azs____,type,
    aTP_Lamp_azs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azt____,type,
    aTP_Lamp_azt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azu____,type,
    aTP_Lamp_azu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azv____,type,
    aTP_Lamp_azv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azw____,type,
    aTP_Lamp_azw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azx____,type,
    aTP_Lamp_azx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azy____,type,
    aTP_Lamp_azy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azz____,type,
    aTP_Lamp_azz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ba____,type,
    aTP_Lamp_ba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baa____,type,
    aTP_Lamp_baa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bab____,type,
    aTP_Lamp_bab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bac____,type,
    aTP_Lamp_bac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bad____,type,
    aTP_Lamp_bad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bae____,type,
    aTP_Lamp_bae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baf____,type,
    aTP_Lamp_baf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bag____,type,
    aTP_Lamp_bag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bah____,type,
    aTP_Lamp_bah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bai____,type,
    aTP_Lamp_bai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baj____,type,
    aTP_Lamp_baj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bak____,type,
    aTP_Lamp_bak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bal____,type,
    aTP_Lamp_bal: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bam____,type,
    aTP_Lamp_bam: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ban____,type,
    aTP_Lamp_ban: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bao____,type,
    aTP_Lamp_bao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bap____,type,
    aTP_Lamp_bap: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__baq____,type,
    aTP_Lamp_baq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bar____,type,
    aTP_Lamp_bar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bas____,type,
    aTP_Lamp_bas: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bat____,type,
    aTP_Lamp_bat: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bau____,type,
    aTP_Lamp_bau: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bav____,type,
    aTP_Lamp_bav: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baw____,type,
    aTP_Lamp_baw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bax____,type,
    aTP_Lamp_bax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bay____,type,
    aTP_Lamp_bay: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__baz____,type,
    aTP_Lamp_baz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bb____,type,
    aTP_Lamp_bb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bba____,type,
    aTP_Lamp_bba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbb____,type,
    aTP_Lamp_bbb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbc____,type,
    aTP_Lamp_bbc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbd____,type,
    aTP_Lamp_bbd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbe____,type,
    aTP_Lamp_bbe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbf____,type,
    aTP_Lamp_bbf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bbg____,type,
    aTP_Lamp_bbg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbh____,type,
    aTP_Lamp_bbh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbi____,type,
    aTP_Lamp_bbi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbj____,type,
    aTP_Lamp_bbj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbk____,type,
    aTP_Lamp_bbk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbl____,type,
    aTP_Lamp_bbl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbm____,type,
    aTP_Lamp_bbm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbn____,type,
    aTP_Lamp_bbn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbo____,type,
    aTP_Lamp_bbo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbp____,type,
    aTP_Lamp_bbp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbq____,type,
    aTP_Lamp_bbq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbr____,type,
    aTP_Lamp_bbr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbs____,type,
    aTP_Lamp_bbs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bc____,type,
    aTP_Lamp_bc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bd____,type,
    aTP_Lamp_bd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__be____,type,
    aTP_Lamp_be: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bf____,type,
    aTP_Lamp_bf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bg____,type,
    aTP_Lamp_bg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bh____,type,
    aTP_Lamp_bh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bi____,type,
    aTP_Lamp_bi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bj____,type,
    aTP_Lamp_bj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bk____,type,
    aTP_Lamp_bk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bl____,type,
    aTP_Lamp_bl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bm____,type,
    aTP_Lamp_bm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bn____,type,
    aTP_Lamp_bn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bo____,type,
    aTP_Lamp_bo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bp____,type,
    aTP_Lamp_bp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bq____,type,
    aTP_Lamp_bq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__br____,type,
    aTP_Lamp_br: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bs____,type,
    aTP_Lamp_bs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bt____,type,
    aTP_Lamp_bt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bu____,type,
    aTP_Lamp_bu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bv____,type,
    aTP_Lamp_bv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bw____,type,
    aTP_Lamp_bw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bx____,type,
    aTP_Lamp_bx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__by____,type,
    aTP_Lamp_by: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bz____,type,
    aTP_Lamp_bz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ca____,type,
    aTP_Lamp_ca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cb____,type,
    aTP_Lamp_cb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cc____,type,
    aTP_Lamp_cc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cd____,type,
    aTP_Lamp_cd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ce____,type,
    aTP_Lamp_ce: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cf____,type,
    aTP_Lamp_cf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cg____,type,
    aTP_Lamp_cg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ch____,type,
    aTP_Lamp_ch: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ci____,type,
    aTP_Lamp_ci: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cj____,type,
    aTP_Lamp_cj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ck____,type,
    aTP_Lamp_ck: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cl____,type,
    aTP_Lamp_cl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cm____,type,
    aTP_Lamp_cm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cn____,type,
    aTP_Lamp_cn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__co____,type,
    aTP_Lamp_co: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cp____,type,
    aTP_Lamp_cp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cq____,type,
    aTP_Lamp_cq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cr____,type,
    aTP_Lamp_cr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cs____,type,
    aTP_Lamp_cs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ct____,type,
    aTP_Lamp_ct: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cu____,type,
    aTP_Lamp_cu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cv____,type,
    aTP_Lamp_cv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cw____,type,
    aTP_Lamp_cw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cx____,type,
    aTP_Lamp_cx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cy____,type,
    aTP_Lamp_cy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cz____,type,
    aTP_Lamp_cz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__da____,type,
    aTP_Lamp_da: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__db____,type,
    aTP_Lamp_db: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dc____,type,
    aTP_Lamp_dc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dd____,type,
    aTP_Lamp_dd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__de____,type,
    aTP_Lamp_de: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__df____,type,
    aTP_Lamp_df: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dg____,type,
    aTP_Lamp_dg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dh____,type,
    aTP_Lamp_dh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__di____,type,
    aTP_Lamp_di: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dj____,type,
    aTP_Lamp_dj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__dk____,type,
    aTP_Lamp_dk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dl____,type,
    aTP_Lamp_dl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dm____,type,
    aTP_Lamp_dm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dn____,type,
    aTP_Lamp_dn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__do____,type,
    aTP_Lamp_do: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dp____,type,
    aTP_Lamp_dp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dq____,type,
    aTP_Lamp_dq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dr____,type,
    aTP_Lamp_dr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ds____,type,
    aTP_Lamp_ds: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dt____,type,
    aTP_Lamp_dt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__du____,type,
    aTP_Lamp_du: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dv____,type,
    aTP_Lamp_dv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dw____,type,
    aTP_Lamp_dw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__dx____,type,
    aTP_Lamp_dx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dy____,type,
    aTP_Lamp_dy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dz____,type,
    aTP_Lamp_dz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ea____,type,
    aTP_Lamp_ea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eb____,type,
    aTP_Lamp_eb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ec____,type,
    aTP_Lamp_ec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ed____,type,
    aTP_Lamp_ed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ee____,type,
    aTP_Lamp_ee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ef____,type,
    aTP_Lamp_ef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eg____,type,
    aTP_Lamp_eg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eh____,type,
    aTP_Lamp_eh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ei____,type,
    aTP_Lamp_ei: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ej____,type,
    aTP_Lamp_ej: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ek____,type,
    aTP_Lamp_ek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__el____,type,
    aTP_Lamp_el: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__em____,type,
    aTP_Lamp_em: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__en____,type,
    aTP_Lamp_en: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eo____,type,
    aTP_Lamp_eo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ep____,type,
    aTP_Lamp_ep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eq____,type,
    aTP_Lamp_eq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__er____,type,
    aTP_Lamp_er: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__es____,type,
    aTP_Lamp_es: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__et____,type,
    aTP_Lamp_et: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eu____,type,
    aTP_Lamp_eu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ev____,type,
    aTP_Lamp_ev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ew____,type,
    aTP_Lamp_ew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ex____,type,
    aTP_Lamp_ex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ey____,type,
    aTP_Lamp_ey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ez____,type,
    aTP_Lamp_ez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fa____,type,
    aTP_Lamp_fa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fb____,type,
    aTP_Lamp_fb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fc____,type,
    aTP_Lamp_fc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fd____,type,
    aTP_Lamp_fd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fe____,type,
    aTP_Lamp_fe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ff____,type,
    aTP_Lamp_ff: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fg____,type,
    aTP_Lamp_fg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fh____,type,
    aTP_Lamp_fh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fi____,type,
    aTP_Lamp_fi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fj____,type,
    aTP_Lamp_fj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fk____,type,
    aTP_Lamp_fk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fl____,type,
    aTP_Lamp_fl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fm____,type,
    aTP_Lamp_fm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fn____,type,
    aTP_Lamp_fn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fo____,type,
    aTP_Lamp_fo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fp____,type,
    aTP_Lamp_fp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fq____,type,
    aTP_Lamp_fq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fr____,type,
    aTP_Lamp_fr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fs____,type,
    aTP_Lamp_fs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ft____,type,
    aTP_Lamp_ft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fu____,type,
    aTP_Lamp_fu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fv____,type,
    aTP_Lamp_fv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fw____,type,
    aTP_Lamp_fw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fx____,type,
    aTP_Lamp_fx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fy____,type,
    aTP_Lamp_fy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fz____,type,
    aTP_Lamp_fz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ga____,type,
    aTP_Lamp_ga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gb____,type,
    aTP_Lamp_gb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gc____,type,
    aTP_Lamp_gc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gd____,type,
    aTP_Lamp_gd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ge____,type,
    aTP_Lamp_ge: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gf____,type,
    aTP_Lamp_gf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gg____,type,
    aTP_Lamp_gg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gh____,type,
    aTP_Lamp_gh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gi____,type,
    aTP_Lamp_gi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gj____,type,
    aTP_Lamp_gj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gk____,type,
    aTP_Lamp_gk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gl____,type,
    aTP_Lamp_gl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gm____,type,
    aTP_Lamp_gm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gn____,type,
    aTP_Lamp_gn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__go____,type,
    aTP_Lamp_go: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gp____,type,
    aTP_Lamp_gp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gq____,type,
    aTP_Lamp_gq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gr____,type,
    aTP_Lamp_gr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gs____,type,
    aTP_Lamp_gs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gt____,type,
    aTP_Lamp_gt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gu____,type,
    aTP_Lamp_gu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gv____,type,
    aTP_Lamp_gv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gw____,type,
    aTP_Lamp_gw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gx____,type,
    aTP_Lamp_gx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gy____,type,
    aTP_Lamp_gy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gz____,type,
    aTP_Lamp_gz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ha____,type,
    aTP_Lamp_ha: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hb____,type,
    aTP_Lamp_hb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hc____,type,
    aTP_Lamp_hc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hd____,type,
    aTP_Lamp_hd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__he____,type,
    aTP_Lamp_he: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hf____,type,
    aTP_Lamp_hf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hg____,type,
    aTP_Lamp_hg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hh____,type,
    aTP_Lamp_hh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hi____,type,
    aTP_Lamp_hi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hj____,type,
    aTP_Lamp_hj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hk____,type,
    aTP_Lamp_hk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hl____,type,
    aTP_Lamp_hl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hm____,type,
    aTP_Lamp_hm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hn____,type,
    aTP_Lamp_hn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ho____,type,
    aTP_Lamp_ho: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hp____,type,
    aTP_Lamp_hp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hq____,type,
    aTP_Lamp_hq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hr____,type,
    aTP_Lamp_hr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hs____,type,
    aTP_Lamp_hs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ht____,type,
    aTP_Lamp_ht: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hu____,type,
    aTP_Lamp_hu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hv____,type,
    aTP_Lamp_hv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hw____,type,
    aTP_Lamp_hw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hx____,type,
    aTP_Lamp_hx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hy____,type,
    aTP_Lamp_hy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hz____,type,
    aTP_Lamp_hz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ia____,type,
    aTP_Lamp_ia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ib____,type,
    aTP_Lamp_ib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ic____,type,
    aTP_Lamp_ic: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__id____,type,
    aTP_Lamp_id: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ie____,type,
    aTP_Lamp_ie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__if____,type,
    aTP_Lamp_if: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ig____,type,
    aTP_Lamp_ig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ih____,type,
    aTP_Lamp_ih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ii____,type,
    aTP_Lamp_ii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ij____,type,
    aTP_Lamp_ij: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ik____,type,
    aTP_Lamp_ik: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__il____,type,
    aTP_Lamp_il: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__im____,type,
    aTP_Lamp_im: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__in____,type,
    aTP_Lamp_in: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__io____,type,
    aTP_Lamp_io: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ip____,type,
    aTP_Lamp_ip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iq____,type,
    aTP_Lamp_iq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ir____,type,
    aTP_Lamp_ir: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__is____,type,
    aTP_Lamp_is: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__it____,type,
    aTP_Lamp_it: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iu____,type,
    aTP_Lamp_iu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iv____,type,
    aTP_Lamp_iv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iw____,type,
    aTP_Lamp_iw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ix____,type,
    aTP_Lamp_ix: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iy____,type,
    aTP_Lamp_iy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iz____,type,
    aTP_Lamp_iz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ja____,type,
    aTP_Lamp_ja: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jb____,type,
    aTP_Lamp_jb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jc____,type,
    aTP_Lamp_jc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jd____,type,
    aTP_Lamp_jd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__je____,type,
    aTP_Lamp_je: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jf____,type,
    aTP_Lamp_jf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jg____,type,
    aTP_Lamp_jg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jh____,type,
    aTP_Lamp_jh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ji____,type,
    aTP_Lamp_ji: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jj____,type,
    aTP_Lamp_jj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jk____,type,
    aTP_Lamp_jk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jl____,type,
    aTP_Lamp_jl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jm____,type,
    aTP_Lamp_jm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jn____,type,
    aTP_Lamp_jn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jo____,type,
    aTP_Lamp_jo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jp____,type,
    aTP_Lamp_jp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jq____,type,
    aTP_Lamp_jq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jr____,type,
    aTP_Lamp_jr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__js____,type,
    aTP_Lamp_js: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jt____,type,
    aTP_Lamp_jt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ju____,type,
    aTP_Lamp_ju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jv____,type,
    aTP_Lamp_jv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jw____,type,
    aTP_Lamp_jw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jx____,type,
    aTP_Lamp_jx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jy____,type,
    aTP_Lamp_jy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jz____,type,
    aTP_Lamp_jz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ka____,type,
    aTP_Lamp_ka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kb____,type,
    aTP_Lamp_kb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kc____,type,
    aTP_Lamp_kc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kd____,type,
    aTP_Lamp_kd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ke____,type,
    aTP_Lamp_ke: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kf____,type,
    aTP_Lamp_kf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kg____,type,
    aTP_Lamp_kg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kh____,type,
    aTP_Lamp_kh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ki____,type,
    aTP_Lamp_ki: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kj____,type,
    aTP_Lamp_kj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__kk____,type,
    aTP_Lamp_kk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kl____,type,
    aTP_Lamp_kl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__km____,type,
    aTP_Lamp_km: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kn____,type,
    aTP_Lamp_kn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ko____,type,
    aTP_Lamp_ko: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kp____,type,
    aTP_Lamp_kp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kq____,type,
    aTP_Lamp_kq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kr____,type,
    aTP_Lamp_kr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ks____,type,
    aTP_Lamp_ks: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kt____,type,
    aTP_Lamp_kt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ku____,type,
    aTP_Lamp_ku: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kv____,type,
    aTP_Lamp_kv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kw____,type,
    aTP_Lamp_kw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kx____,type,
    aTP_Lamp_kx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ky____,type,
    aTP_Lamp_ky: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kz____,type,
    aTP_Lamp_kz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__la____,type,
    aTP_Lamp_la: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lb____,type,
    aTP_Lamp_lb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lc____,type,
    aTP_Lamp_lc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ld____,type,
    aTP_Lamp_ld: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__le____,type,
    aTP_Lamp_le: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lf____,type,
    aTP_Lamp_lf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lg____,type,
    aTP_Lamp_lg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lh____,type,
    aTP_Lamp_lh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__li____,type,
    aTP_Lamp_li: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lj____,type,
    aTP_Lamp_lj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lk____,type,
    aTP_Lamp_lk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ll____,type,
    aTP_Lamp_ll: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lm____,type,
    aTP_Lamp_lm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ln____,type,
    aTP_Lamp_ln: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lo____,type,
    aTP_Lamp_lo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lp____,type,
    aTP_Lamp_lp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lq____,type,
    aTP_Lamp_lq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lr____,type,
    aTP_Lamp_lr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ls____,type,
    aTP_Lamp_ls: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lt____,type,
    aTP_Lamp_lt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lu____,type,
    aTP_Lamp_lu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lv____,type,
    aTP_Lamp_lv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lw____,type,
    aTP_Lamp_lw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lx____,type,
    aTP_Lamp_lx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ly____,type,
    aTP_Lamp_ly: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lz____,type,
    aTP_Lamp_lz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ma____,type,
    aTP_Lamp_ma: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mb____,type,
    aTP_Lamp_mb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mc____,type,
    aTP_Lamp_mc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__md____,type,
    aTP_Lamp_md: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__me____,type,
    aTP_Lamp_me: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mf____,type,
    aTP_Lamp_mf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mg____,type,
    aTP_Lamp_mg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mh____,type,
    aTP_Lamp_mh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mi____,type,
    aTP_Lamp_mi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mj____,type,
    aTP_Lamp_mj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mk____,type,
    aTP_Lamp_mk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ml____,type,
    aTP_Lamp_ml: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mm____,type,
    aTP_Lamp_mm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mn____,type,
    aTP_Lamp_mn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mo____,type,
    aTP_Lamp_mo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mp____,type,
    aTP_Lamp_mp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mq____,type,
    aTP_Lamp_mq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mr____,type,
    aTP_Lamp_mr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ms____,type,
    aTP_Lamp_ms: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mt____,type,
    aTP_Lamp_mt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mu____,type,
    aTP_Lamp_mu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mv____,type,
    aTP_Lamp_mv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mw____,type,
    aTP_Lamp_mw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mx____,type,
    aTP_Lamp_mx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__my____,type,
    aTP_Lamp_my: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mz____,type,
    aTP_Lamp_mz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__na____,type,
    aTP_Lamp_na: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nb____,type,
    aTP_Lamp_nb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nc____,type,
    aTP_Lamp_nc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nd____,type,
    aTP_Lamp_nd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ne____,type,
    aTP_Lamp_ne: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nf____,type,
    aTP_Lamp_nf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ng____,type,
    aTP_Lamp_ng: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nh____,type,
    aTP_Lamp_nh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ni____,type,
    aTP_Lamp_ni: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nj____,type,
    aTP_Lamp_nj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nk____,type,
    aTP_Lamp_nk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nl____,type,
    aTP_Lamp_nl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nm____,type,
    aTP_Lamp_nm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nn____,type,
    aTP_Lamp_nn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__no____,type,
    aTP_Lamp_no: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__np____,type,
    aTP_Lamp_np: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nq____,type,
    aTP_Lamp_nq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nr____,type,
    aTP_Lamp_nr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ns____,type,
    aTP_Lamp_ns: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nt____,type,
    aTP_Lamp_nt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nu____,type,
    aTP_Lamp_nu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nv____,type,
    aTP_Lamp_nv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nw____,type,
    aTP_Lamp_nw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nx____,type,
    aTP_Lamp_nx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ny____,type,
    aTP_Lamp_ny: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nz____,type,
    aTP_Lamp_nz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__oa____,type,
    aTP_Lamp_oa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ob____,type,
    aTP_Lamp_ob: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oc____,type,
    aTP_Lamp_oc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__od____,type,
    aTP_Lamp_od: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oe____,type,
    aTP_Lamp_oe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__of____,type,
    aTP_Lamp_of: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__og____,type,
    aTP_Lamp_og: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oh____,type,
    aTP_Lamp_oh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oi____,type,
    aTP_Lamp_oi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oj____,type,
    aTP_Lamp_oj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ok____,type,
    aTP_Lamp_ok: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ol____,type,
    aTP_Lamp_ol: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__om____,type,
    aTP_Lamp_om: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__on____,type,
    aTP_Lamp_on: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oo____,type,
    aTP_Lamp_oo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__op____,type,
    aTP_Lamp_op: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oq____,type,
    aTP_Lamp_oq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__or____,type,
    aTP_Lamp_or: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__os____,type,
    aTP_Lamp_os: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ot____,type,
    aTP_Lamp_ot: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ou____,type,
    aTP_Lamp_ou: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ov____,type,
    aTP_Lamp_ov: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ow____,type,
    aTP_Lamp_ow: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ox____,type,
    aTP_Lamp_ox: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oy____,type,
    aTP_Lamp_oy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oz____,type,
    aTP_Lamp_oz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pa____,type,
    aTP_Lamp_pa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pb____,type,
    aTP_Lamp_pb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pc____,type,
    aTP_Lamp_pc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pd____,type,
    aTP_Lamp_pd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pe____,type,
    aTP_Lamp_pe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pf____,type,
    aTP_Lamp_pf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pg____,type,
    aTP_Lamp_pg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ph____,type,
    aTP_Lamp_ph: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pi____,type,
    aTP_Lamp_pi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pj____,type,
    aTP_Lamp_pj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pk____,type,
    aTP_Lamp_pk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pl____,type,
    aTP_Lamp_pl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pm____,type,
    aTP_Lamp_pm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pn____,type,
    aTP_Lamp_pn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__po____,type,
    aTP_Lamp_po: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pp____,type,
    aTP_Lamp_pp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pq____,type,
    aTP_Lamp_pq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pr____,type,
    aTP_Lamp_pr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ps____,type,
    aTP_Lamp_ps: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pt____,type,
    aTP_Lamp_pt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pu____,type,
    aTP_Lamp_pu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pv____,type,
    aTP_Lamp_pv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pw____,type,
    aTP_Lamp_pw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__px____,type,
    aTP_Lamp_px: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__py____,type,
    aTP_Lamp_py: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pz____,type,
    aTP_Lamp_pz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qa____,type,
    aTP_Lamp_qa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qb____,type,
    aTP_Lamp_qb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qc____,type,
    aTP_Lamp_qc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qd____,type,
    aTP_Lamp_qd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qe____,type,
    aTP_Lamp_qe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qf____,type,
    aTP_Lamp_qf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qg____,type,
    aTP_Lamp_qg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qh____,type,
    aTP_Lamp_qh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qi____,type,
    aTP_Lamp_qi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qj____,type,
    aTP_Lamp_qj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qk____,type,
    aTP_Lamp_qk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ql____,type,
    aTP_Lamp_ql: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qm____,type,
    aTP_Lamp_qm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qn____,type,
    aTP_Lamp_qn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qo____,type,
    aTP_Lamp_qo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qp____,type,
    aTP_Lamp_qp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qq____,type,
    aTP_Lamp_qq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qr____,type,
    aTP_Lamp_qr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qs____,type,
    aTP_Lamp_qs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qt____,type,
    aTP_Lamp_qt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qu____,type,
    aTP_Lamp_qu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qv____,type,
    aTP_Lamp_qv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qw____,type,
    aTP_Lamp_qw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qx____,type,
    aTP_Lamp_qx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qy____,type,
    aTP_Lamp_qy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qz____,type,
    aTP_Lamp_qz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ra____,type,
    aTP_Lamp_ra: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rb____,type,
    aTP_Lamp_rb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rc____,type,
    aTP_Lamp_rc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rd____,type,
    aTP_Lamp_rd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__re____,type,
    aTP_Lamp_re: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rf____,type,
    aTP_Lamp_rf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rg____,type,
    aTP_Lamp_rg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rh____,type,
    aTP_Lamp_rh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ri____,type,
    aTP_Lamp_ri: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rj____,type,
    aTP_Lamp_rj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rk____,type,
    aTP_Lamp_rk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rl____,type,
    aTP_Lamp_rl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rm____,type,
    aTP_Lamp_rm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rn____,type,
    aTP_Lamp_rn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ro____,type,
    aTP_Lamp_ro: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rp____,type,
    aTP_Lamp_rp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rq____,type,
    aTP_Lamp_rq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rr____,type,
    aTP_Lamp_rr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rs____,type,
    aTP_Lamp_rs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rt____,type,
    aTP_Lamp_rt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ru____,type,
    aTP_Lamp_ru: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rv____,type,
    aTP_Lamp_rv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rw____,type,
    aTP_Lamp_rw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rx____,type,
    aTP_Lamp_rx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ry____,type,
    aTP_Lamp_ry: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rz____,type,
    aTP_Lamp_rz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sa____,type,
    aTP_Lamp_sa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sb____,type,
    aTP_Lamp_sb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sc____,type,
    aTP_Lamp_sc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sd____,type,
    aTP_Lamp_sd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__se____,type,
    aTP_Lamp_se: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sf____,type,
    aTP_Lamp_sf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sg____,type,
    aTP_Lamp_sg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sh____,type,
    aTP_Lamp_sh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__si____,type,
    aTP_Lamp_si: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sj____,type,
    aTP_Lamp_sj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sk____,type,
    aTP_Lamp_sk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sl____,type,
    aTP_Lamp_sl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sm____,type,
    aTP_Lamp_sm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sn____,type,
    aTP_Lamp_sn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__so____,type,
    aTP_Lamp_so: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sp____,type,
    aTP_Lamp_sp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sq____,type,
    aTP_Lamp_sq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sr____,type,
    aTP_Lamp_sr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ss____,type,
    aTP_Lamp_ss: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__st____,type,
    aTP_Lamp_st: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__su____,type,
    aTP_Lamp_su: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sv____,type,
    aTP_Lamp_sv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sw____,type,
    aTP_Lamp_sw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sx____,type,
    aTP_Lamp_sx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sy____,type,
    aTP_Lamp_sy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sz____,type,
    aTP_Lamp_sz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ta____,type,
    aTP_Lamp_ta: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tb____,type,
    aTP_Lamp_tb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tc____,type,
    aTP_Lamp_tc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__td____,type,
    aTP_Lamp_td: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__te____,type,
    aTP_Lamp_te: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tf____,type,
    aTP_Lamp_tf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tg____,type,
    aTP_Lamp_tg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__th____,type,
    aTP_Lamp_th: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ti____,type,
    aTP_Lamp_ti: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tj____,type,
    aTP_Lamp_tj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tk____,type,
    aTP_Lamp_tk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tl____,type,
    aTP_Lamp_tl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tm____,type,
    aTP_Lamp_tm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tn____,type,
    aTP_Lamp_tn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__to____,type,
    aTP_Lamp_to: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tp____,type,
    aTP_Lamp_tp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tq____,type,
    aTP_Lamp_tq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tr____,type,
    aTP_Lamp_tr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ts____,type,
    aTP_Lamp_ts: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tt____,type,
    aTP_Lamp_tt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tu____,type,
    aTP_Lamp_tu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tv____,type,
    aTP_Lamp_tv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tw____,type,
    aTP_Lamp_tw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tx____,type,
    aTP_Lamp_tx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ty____,type,
    aTP_Lamp_ty: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__tz____,type,
    aTP_Lamp_tz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ua____,type,
    aTP_Lamp_ua: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ub____,type,
    aTP_Lamp_ub: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uc____,type,
    aTP_Lamp_uc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ud____,type,
    aTP_Lamp_ud: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ue____,type,
    aTP_Lamp_ue: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uf____,type,
    aTP_Lamp_uf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ug____,type,
    aTP_Lamp_ug: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uh____,type,
    aTP_Lamp_uh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ui____,type,
    aTP_Lamp_ui: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uj____,type,
    aTP_Lamp_uj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uk____,type,
    aTP_Lamp_uk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ul____,type,
    aTP_Lamp_ul: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__um____,type,
    aTP_Lamp_um: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__un____,type,
    aTP_Lamp_un: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uo____,type,
    aTP_Lamp_uo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__up____,type,
    aTP_Lamp_up: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uq____,type,
    aTP_Lamp_uq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ur____,type,
    aTP_Lamp_ur: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__us____,type,
    aTP_Lamp_us: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ut____,type,
    aTP_Lamp_ut: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uu____,type,
    aTP_Lamp_uu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uv____,type,
    aTP_Lamp_uv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uw____,type,
    aTP_Lamp_uw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ux____,type,
    aTP_Lamp_ux: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uy____,type,
    aTP_Lamp_uy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uz____,type,
    aTP_Lamp_uz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__va____,type,
    aTP_Lamp_va: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vb____,type,
    aTP_Lamp_vb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vc____,type,
    aTP_Lamp_vc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vd____,type,
    aTP_Lamp_vd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ve____,type,
    aTP_Lamp_ve: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vf____,type,
    aTP_Lamp_vf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vg____,type,
    aTP_Lamp_vg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vh____,type,
    aTP_Lamp_vh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vi____,type,
    aTP_Lamp_vi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vj____,type,
    aTP_Lamp_vj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vk____,type,
    aTP_Lamp_vk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vl____,type,
    aTP_Lamp_vl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vm____,type,
    aTP_Lamp_vm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vn____,type,
    aTP_Lamp_vn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vo____,type,
    aTP_Lamp_vo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vp____,type,
    aTP_Lamp_vp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vq____,type,
    aTP_Lamp_vq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vr____,type,
    aTP_Lamp_vr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vs____,type,
    aTP_Lamp_vs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vt____,type,
    aTP_Lamp_vt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vu____,type,
    aTP_Lamp_vu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vv____,type,
    aTP_Lamp_vv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vw____,type,
    aTP_Lamp_vw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vx____,type,
    aTP_Lamp_vx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vy____,type,
    aTP_Lamp_vy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vz____,type,
    aTP_Lamp_vz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wa____,type,
    aTP_Lamp_wa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wb____,type,
    aTP_Lamp_wb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wc____,type,
    aTP_Lamp_wc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wd____,type,
    aTP_Lamp_wd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__we____,type,
    aTP_Lamp_we: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wf____,type,
    aTP_Lamp_wf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wg____,type,
    aTP_Lamp_wg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wh____,type,
    aTP_Lamp_wh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wi____,type,
    aTP_Lamp_wi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wj____,type,
    aTP_Lamp_wj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wk____,type,
    aTP_Lamp_wk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wl____,type,
    aTP_Lamp_wl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wm____,type,
    aTP_Lamp_wm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wn____,type,
    aTP_Lamp_wn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wo____,type,
    aTP_Lamp_wo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wp____,type,
    aTP_Lamp_wp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wq____,type,
    aTP_Lamp_wq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wr____,type,
    aTP_Lamp_wr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ws____,type,
    aTP_Lamp_ws: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wt____,type,
    aTP_Lamp_wt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wu____,type,
    aTP_Lamp_wu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wv____,type,
    aTP_Lamp_wv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ww____,type,
    aTP_Lamp_ww: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wx____,type,
    aTP_Lamp_wx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wy____,type,
    aTP_Lamp_wy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wz____,type,
    aTP_Lamp_wz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xa____,type,
    aTP_Lamp_xa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xb____,type,
    aTP_Lamp_xb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xc____,type,
    aTP_Lamp_xc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xd____,type,
    aTP_Lamp_xd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xe____,type,
    aTP_Lamp_xe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xf____,type,
    aTP_Lamp_xf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xg____,type,
    aTP_Lamp_xg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xh____,type,
    aTP_Lamp_xh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xi____,type,
    aTP_Lamp_xi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xj____,type,
    aTP_Lamp_xj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xk____,type,
    aTP_Lamp_xk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xl____,type,
    aTP_Lamp_xl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xm____,type,
    aTP_Lamp_xm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xn____,type,
    aTP_Lamp_xn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xo____,type,
    aTP_Lamp_xo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xp____,type,
    aTP_Lamp_xp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xq____,type,
    aTP_Lamp_xq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xr____,type,
    aTP_Lamp_xr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xs____,type,
    aTP_Lamp_xs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xt____,type,
    aTP_Lamp_xt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xu____,type,
    aTP_Lamp_xu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xv____,type,
    aTP_Lamp_xv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xw____,type,
    aTP_Lamp_xw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xx____,type,
    aTP_Lamp_xx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xy____,type,
    aTP_Lamp_xy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xz____,type,
    aTP_Lamp_xz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ya____,type,
    aTP_Lamp_ya: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yb____,type,
    aTP_Lamp_yb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yc____,type,
    aTP_Lamp_yc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yd____,type,
    aTP_Lamp_yd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ye____,type,
    aTP_Lamp_ye: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yf____,type,
    aTP_Lamp_yf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yg____,type,
    aTP_Lamp_yg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yh____,type,
    aTP_Lamp_yh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yi____,type,
    aTP_Lamp_yi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yj____,type,
    aTP_Lamp_yj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yk____,type,
    aTP_Lamp_yk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yl____,type,
    aTP_Lamp_yl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ym____,type,
    aTP_Lamp_ym: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yn____,type,
    aTP_Lamp_yn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yo____,type,
    aTP_Lamp_yo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yp____,type,
    aTP_Lamp_yp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yq____,type,
    aTP_Lamp_yq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yr____,type,
    aTP_Lamp_yr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ys____,type,
    aTP_Lamp_ys: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yt____,type,
    aTP_Lamp_yt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yu____,type,
    aTP_Lamp_yu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yv____,type,
    aTP_Lamp_yv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yw____,type,
    aTP_Lamp_yw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yx____,type,
    aTP_Lamp_yx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yy____,type,
    aTP_Lamp_yy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yz____,type,
    aTP_Lamp_yz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__za____,type,
    aTP_Lamp_za: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zb____,type,
    aTP_Lamp_zb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zc____,type,
    aTP_Lamp_zc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zd____,type,
    aTP_Lamp_zd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ze____,type,
    aTP_Lamp_ze: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zf____,type,
    aTP_Lamp_zf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zg____,type,
    aTP_Lamp_zg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zh____,type,
    aTP_Lamp_zh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zi____,type,
    aTP_Lamp_zi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zj____,type,
    aTP_Lamp_zj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zk____,type,
    aTP_Lamp_zk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zl____,type,
    aTP_Lamp_zl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zm____,type,
    aTP_Lamp_zm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zn____,type,
    aTP_Lamp_zn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zo____,type,
    aTP_Lamp_zo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zp____,type,
    aTP_Lamp_zp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zq____,type,
    aTP_Lamp_zq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zr____,type,
    aTP_Lamp_zr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zs____,type,
    aTP_Lamp_zs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zt____,type,
    aTP_Lamp_zt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zu____,type,
    aTP_Lamp_zu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zv____,type,
    aTP_Lamp_zv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zw____,type,
    aTP_Lamp_zw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zx____,type,
    aTP_Lamp_zx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zy____,type,
    aTP_Lamp_zy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zz____,type,
    aTP_Lamp_zz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Array__Time_Oalloc,type,
    array_alloc: 
      !>[A: $tType] : ( ( list(A) * heap_ext(product_unit) ) > product_prod(array(A),heap_ext(product_unit)) ) ).

tff(sy_c_Array__Time_Ofreeze,type,
    array_freeze: 
      !>[A: $tType] : ( array(A) > heap_Time_Heap(list(A)) ) ).

tff(sy_c_Array__Time_Oget,type,
    array_get: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * array(A) ) > list(A) ) ).

tff(sy_c_Array__Time_Olen,type,
    array_len: 
      !>[A: $tType] : ( array(A) > heap_Time_Heap(nat) ) ).

tff(sy_c_Array__Time_Olen_H,type,
    array_len2: 
      !>[B: $tType,A: $tType] : ( array(B) > heap_Time_Heap(A) ) ).

tff(sy_c_Array__Time_Olength,type,
    array_length: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * array(A) ) > nat ) ).

tff(sy_c_Array__Time_Omake,type,
    array_make: 
      !>[A: $tType] : ( ( nat * fun(nat,A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Omap__entry,type,
    array_map_entry: 
      !>[A: $tType] : ( ( nat * fun(A,A) * array(A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Onew,type,
    array_new: 
      !>[A: $tType] : ( ( nat * A ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Onth,type,
    array_nth: 
      !>[A: $tType] : ( ( array(A) * nat ) > heap_Time_Heap(A) ) ).

tff(sy_c_Array__Time_Oof__list,type,
    array_of_list: 
      !>[A: $tType] : ( list(A) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Oset,type,
    array_set: 
      !>[A: $tType] : ( ( array(A) * list(A) ) > fun(heap_ext(product_unit),heap_ext(product_unit)) ) ).

tff(sy_c_Array__Time_Oswap,type,
    array_swap: 
      !>[A: $tType] : ( ( nat * A * array(A) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Array__Time_Oupd,type,
    array_upd: 
      !>[A: $tType] : ( ( nat * A * array(A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Oupd_H,type,
    array_upd2: 
      !>[A: $tType] : ( ( array(A) * code_integer * A ) > heap_Time_Heap(product_unit) ) ).

tff(sy_c_Array__Time_Oupdate,type,
    array_update: 
      !>[A: $tType] : ( ( array(A) * nat * A * heap_ext(product_unit) ) > heap_ext(product_unit) ) ).

tff(sy_c_Assertions_Oassn_OAbs__assn,type,
    abs_assn: fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn) ).

tff(sy_c_Assertions_Oassn_ORep__assn,type,
    rep_assn: fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o)) ).

tff(sy_c_Assertions_Oentails,type,
    entails: ( assn * assn ) > $o ).

tff(sy_c_Assertions_Oentailst,type,
    entailst: ( assn * assn ) > $o ).

tff(sy_c_Assertions_Oex__assn,type,
    ex_assn: 
      !>[A: $tType] : ( fun(A,assn) > assn ) ).

tff(sy_c_Assertions_Oin__range,type,
    in_range: fun(product_prod(heap_ext(product_unit),set(nat)),$o) ).

tff(sy_c_Assertions_Oin__range__rel,type,
    in_range_rel: fun(product_prod(heap_ext(product_unit),set(nat)),fun(product_prod(heap_ext(product_unit),set(nat)),$o)) ).

tff(sy_c_Assertions_Ois__pure__assn,type,
    is_pure_assn: assn > $o ).

tff(sy_c_Assertions_Oone__assn__raw,type,
    one_assn_raw: fun(product_prod(heap_ext(product_unit),set(nat)),$o) ).

tff(sy_c_Assertions_Oone__assn__raw__rel,type,
    one_assn_raw_rel: fun(product_prod(heap_ext(product_unit),set(nat)),fun(product_prod(heap_ext(product_unit),set(nat)),$o)) ).

tff(sy_c_Assertions_Oprecise,type,
    precise: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,assn)) > $o ) ).

tff(sy_c_Assertions_Oproper,type,
    proper: fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o) ).

tff(sy_c_Assertions_Opure__assn,type,
    pure_assn: $o > assn ).

tff(sy_c_Assertions_Opure__assn__raw,type,
    pure_assn_raw: 
      !>[A: $tType,B: $tType] : ( $o > fun(product_prod(A,set(B)),$o) ) ).

tff(sy_c_Assertions_Opure__assn__raw__rel,type,
    pure_assn_raw_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod($o,product_prod(A,set(B))),fun(product_prod($o,product_prod(A,set(B))),$o)) ).

tff(sy_c_Assertions_OrelH,type,
    relH: ( set(nat) * heap_ext(product_unit) * heap_ext(product_unit) ) > $o ).

tff(sy_c_Assertions_Osnga__assn,type,
    snga_assn: 
      !>[A: $tType] : ( ( array(A) * list(A) ) > assn ) ).

tff(sy_c_Assertions_Osnga__assn__raw,type,
    snga_assn_raw: 
      !>[A: $tType] : ( ( array(A) * list(A) ) > fun(product_prod(heap_ext(product_unit),set(nat)),$o) ) ).

tff(sy_c_Assertions_Osnga__assn__raw__rel,type,
    snga_assn_raw_rel: 
      !>[A: $tType] : fun(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),$o)) ).

tff(sy_c_Assertions_Osngr__assn,type,
    sngr_assn: 
      !>[A: $tType] : ( ( ref(A) * A ) > assn ) ).

tff(sy_c_Assertions_Osngr__assn__raw,type,
    sngr_assn_raw: 
      !>[A: $tType] : ( ( ref(A) * A ) > fun(product_prod(heap_ext(product_unit),set(nat)),$o) ) ).

tff(sy_c_Assertions_Osngr__assn__raw__rel,type,
    sngr_assn_raw_rel: 
      !>[A: $tType] : fun(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),$o)) ).

tff(sy_c_Assertions_Otimes__assn__raw,type,
    times_assn_raw: ( fun(product_prod(heap_ext(product_unit),set(nat)),$o) * fun(product_prod(heap_ext(product_unit),set(nat)),$o) ) > fun(product_prod(heap_ext(product_unit),set(nat)),$o) ).

tff(sy_c_Assertions_Otimes__assn__raw__rel,type,
    times_assn_raw_rel: fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o)) ).

tff(sy_c_Assertions_Owand__assn,type,
    wand_assn: ( assn * assn ) > assn ).

tff(sy_c_Assertions_Owand__raw,type,
    wand_raw: ( fun(product_prod(heap_ext(product_unit),set(nat)),$o) * fun(product_prod(heap_ext(product_unit),set(nat)),$o) ) > fun(product_prod(heap_ext(product_unit),set(nat)),$o) ).

tff(sy_c_Assertions_Owand__raw__rel,type,
    wand_raw_rel: fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o)) ).

tff(sy_c_BNF__Cardinal__Arithmetic_OCsum,type,
    bNF_Cardinal_Csum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,set(product_prod(B,B))) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocexp,type,
    bNF_Cardinal_cexp: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * set(product_prod(A,A)) ) > set(product_prod(fun(A,B),fun(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocinfinite,type,
    bNF_Ca4139267488887388095finite: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocone,type,
    bNF_Cardinal_cone: set(product_prod(product_unit,product_unit)) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocprod,type,
    bNF_Cardinal_cprod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocsum,type,
    bNF_Cardinal_csum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(sum_sum(A,B),sum_sum(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Oczero,type,
    bNF_Cardinal_czero: 
      !>[A: $tType] : set(product_prod(A,A)) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OcardSuc,type,
    bNF_Ca8387033319878233205ardSuc: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_Ocard__of,type,
    bNF_Ca6860139660246222851ard_of: 
      !>[A: $tType] : ( set(A) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_Ocard__order__on,type,
    bNF_Ca8970107618336181345der_on: 
      !>[A: $tType] : ( set(A) > fun(set(product_prod(A,A)),$o) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OisCardSuc,type,
    bNF_Ca6246979054910435723ardSuc: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(set(product_prod(set(A),set(A))),$o) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OnatLeq,type,
    bNF_Ca8665028551170535155natLeq: set(product_prod(nat,nat)) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OnatLess,type,
    bNF_Ca8459412986667044542atLess: set(product_prod(nat,nat)) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OregularCard,type,
    bNF_Ca7133664381575040944arCard: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OrelChain,type,
    bNF_Ca3754400796208372196lChain: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,B) ) > $o ) ).

tff(sy_c_BNF__Composition_Oid__bnf,type,
    bNF_id_bnf: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_BNF__Def_OGrp,type,
    bNF_Grp: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > fun(A,fun(B,$o)) ) ).

tff(sy_c_BNF__Def_Ocollect,type,
    bNF_collect: 
      !>[B: $tType,A: $tType] : ( set(fun(B,set(A))) > fun(B,set(A)) ) ).

tff(sy_c_BNF__Def_Oeq__onp,type,
    bNF_eq_onp: 
      !>[A: $tType] : ( fun(A,$o) > fun(A,fun(A,$o)) ) ).

tff(sy_c_BNF__Def_Opick__middlep,type,
    bNF_pick_middlep: 
      !>[B: $tType,A: $tType,C: $tType] : ( ( fun(B,fun(A,$o)) * fun(A,fun(C,$o)) * B * C ) > A ) ).

tff(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,fun(C,$o)) * fun(B,fun(D,$o)) ) > fun(fun(A,B),fun(fun(C,D),$o)) ) ).

tff(sy_c_BNF__Def_Orel__set,type,
    bNF_rel_set: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(set(A),fun(set(B),$o)) ) ).

tff(sy_c_BNF__Def_Ovimage2p,type,
    bNF_vimage2p: 
      !>[A: $tType,D: $tType,B: $tType,E: $tType,C: $tType] : ( ( fun(A,D) * fun(B,E) * fun(D,fun(E,C)) ) > fun(A,fun(B,C)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OShift,type,
    bNF_Greatest_Shift: 
      !>[A: $tType] : ( ( set(list(A)) * A ) > set(list(A)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OSucc,type,
    bNF_Greatest_Succ: 
      !>[A: $tType] : ( ( set(list(A)) * list(A) ) > set(A) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OfromCard,type,
    bNF_Gr5436034075474128252omCard: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) * B ) > A ) ).

tff(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( set(C) * fun(C,A) * fun(C,B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_Oimage2p,type,
    bNF_Greatest_image2p: 
      !>[C: $tType,A: $tType,D: $tType,B: $tType] : ( ( fun(C,A) * fun(D,B) * fun(C,fun(D,$o)) * A * B ) > $o ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OrelImage,type,
    bNF_Gr4221423524335903396lImage: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * fun(B,A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OrelInvImage,type,
    bNF_Gr7122648621184425601vImage: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) * fun(A,B) ) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OtoCard,type,
    bNF_Greatest_toCard: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) ) > fun(A,B) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OtoCard__pred,type,
    bNF_Gr1419584066657907630d_pred: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) ) > fun(fun(A,B),$o) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_Ouniv,type,
    bNF_Greatest_univ: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > A ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(fun(A,B)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set(B) * fun(C,A) * fun(B,D) ) > fun(fun(D,C),fun(B,A)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Obsqr,type,
    bNF_Wellorder_bsqr: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(product_prod(A,A),product_prod(A,A))) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Ocurr,type,
    bNF_Wellorder_curr: 
      !>[A: $tType,B: $tType,C: $tType] : ( set(A) > fun(fun(product_prod(A,B),C),fun(A,fun(B,C))) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Odir__image,type,
    bNF_We2720479622203943262_image: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * fun(A,A2) ) > set(product_prod(A2,A2)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OofilterIncl,type,
    bNF_We413866401316099525erIncl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OordIso,type,
    bNF_Wellorder_ordIso: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_OordLeq,type,
    bNF_Wellorder_ordLeq: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_OordLess,type,
    bNF_We4044943003108391690rdLess: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_Oord__to__filter,type,
    bNF_We8469521843155493636filter: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(set(product_prod(A,A)),set(A)) ) ).

tff(sy_c_BNF__Wellorder__Embedding_Ocompat,type,
    bNF_Wellorder_compat: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Embedding_Oembed,type,
    bNF_Wellorder_embed: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) ) > fun(fun(A,A2),$o) ) ).

tff(sy_c_BNF__Wellorder__Embedding_OembedS,type,
    bNF_Wellorder_embedS: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Embedding_Oiso,type,
    bNF_Wellorder_iso: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel,type,
    bNF_Wellorder_wo_rel: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_OisMinim,type,
    bNF_We4791949203932849705sMinim: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > fun(A,$o) ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Omax2,type,
    bNF_We1388413361240627857o_max2: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A * A ) > A ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Ominim,type,
    bNF_We6954850376910717587_minim: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > A ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Osuc,type,
    bNF_Wellorder_wo_suc: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > A ) ).

tff(sy_c_Basic__BNFs_Ofsts,type,
    basic_fsts: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),set(A)) ).

tff(sy_c_Basic__BNFs_Ofstsp,type,
    basic_fstsp: 
      !>[A: $tType,B: $tType] : ( product_prod(A,B) > fun(A,$o) ) ).

tff(sy_c_Basic__BNFs_Opred__fun,type,
    basic_pred_fun: 
      !>[A: $tType,B: $tType] : ( fun(A,$o) > fun(fun(B,$o),fun(fun(A,B),$o)) ) ).

tff(sy_c_Basic__BNFs_Opred__prod,type,
    basic_pred_prod: 
      !>[A: $tType,B: $tType] : ( ( fun(A,$o) * fun(B,$o) ) > fun(product_prod(A,B),$o) ) ).

tff(sy_c_Basic__BNFs_Orel__prod,type,
    basic_rel_prod: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( fun(A,fun(B,$o)) * fun(C,fun(D,$o)) ) > fun(product_prod(A,C),fun(product_prod(B,D),$o)) ) ).

tff(sy_c_Basic__BNFs_Osetl,type,
    basic_setl: 
      !>[A: $tType,B: $tType] : fun(sum_sum(A,B),set(A)) ).

tff(sy_c_Basic__BNFs_Osetlp,type,
    basic_setlp: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,B) > fun(A,$o) ) ).

tff(sy_c_Basic__BNFs_Osetr,type,
    basic_setr: 
      !>[A: $tType,B: $tType] : fun(sum_sum(A,B),set(B)) ).

tff(sy_c_Basic__BNFs_Osetrp,type,
    basic_setrp: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,B) > fun(B,$o) ) ).

tff(sy_c_Basic__BNFs_Osnds,type,
    basic_snds: 
      !>[A: $tType,B: $tType] : ( product_prod(A,B) > set(B) ) ).

tff(sy_c_Basic__BNFs_Osndsp,type,
    basic_sndsp: 
      !>[A: $tType,B: $tType] : ( product_prod(A,B) > fun(B,$o) ) ).

tff(sy_c_Binomial_Obinomial,type,
    binomial: nat > fun(nat,nat) ).

tff(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > fun(nat,A) ) ).

tff(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > fun(nat,$o) ) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself(A) * nat ) > $o ) ).

tff(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: ( nat * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: ( num * num ) > option(num) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__axioms,type,
    boolea6902313364301356556axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff__axioms,type,
    boolea5476839437570043046axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > product_prod(code_integer,$o) ).

tff(sy_c_Code__Numeral_Ocr__integer,type,
    code_cr_integer: ( int * code_integer ) > $o ).

tff(sy_c_Code__Numeral_Ocr__natural,type,
    code_cr_natural: ( nat * code_natural ) > $o ).

tff(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Odup,type,
    code_dup: fun(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: fun(code_integer,int) ).

tff(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: fun(int,code_integer) ).

tff(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

tff(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

tff(sy_c_Code__Numeral_Onatural_Ocase__natural,type,
    code_case_natural: 
      !>[T: $tType] : ( ( T * fun(code_natural,T) ) > fun(code_natural,T) ) ).

tff(sy_c_Code__Numeral_Onatural_Onat__of__natural,type,
    code_nat_of_natural: code_natural > nat ).

tff(sy_c_Code__Numeral_Onatural_Onatural__of__nat,type,
    code_natural_of_nat: nat > code_natural ).

tff(sy_c_Code__Numeral_Onatural_Orec__natural,type,
    code_rec_natural: 
      !>[T: $tType] : ( ( T * fun(code_natural,fun(T,T)) ) > fun(code_natural,T) ) ).

tff(sy_c_Code__Numeral_Onatural_Orec__set__natural,type,
    code_rec_set_natural: 
      !>[T: $tType] : ( ( T * fun(code_natural,fun(T,T)) * code_natural ) > fun(T,$o) ) ).

tff(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

tff(sy_c_Code__Numeral_Opcr__integer,type,
    code_pcr_integer: fun(int,fun(code_integer,$o)) ).

tff(sy_c_Code__Numeral_Osub,type,
    code_sub: fun(num,fun(num,code_integer)) ).

tff(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complete__Partial__Order_Occpo_Oadmissible,type,
    comple1908693960933563346ssible: 
      !>[A: $tType] : ( ( fun(set(A),A) * fun(A,fun(A,$o)) * fun(A,$o) ) > $o ) ).

tff(sy_c_Complete__Partial__Order_Occpo_Ofixp,type,
    comple187402453842119260l_fixp: 
      !>[A: $tType] : ( ( fun(set(A),A) * fun(A,fun(A,$o)) * fun(A,A) ) > A ) ).

tff(sy_c_Complete__Partial__Order_Occpo__class_Ofixp,type,
    comple115746919287870866o_fixp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Complete__Partial__Order_Occpo__class_Oiterates,type,
    comple6359979572994053840erates: 
      !>[A: $tType] : ( fun(A,A) > set(A) ) ).

tff(sy_c_Complete__Partial__Order_Occpo__class_Oiteratesp,type,
    comple7512665784863727008ratesp: 
      !>[A: $tType] : ( fun(A,A) > fun(A,$o) ) ).

tff(sy_c_Complete__Partial__Order_Ochain,type,
    comple1602240252501008431_chain: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * set(A) ) > $o ) ).

tff(sy_c_Complete__Partial__Order_Omonotone,type,
    comple7038119648293358887notone: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,fun(B,$o)) * fun(A,B) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__above,type,
    condit8047198070973881523_above: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * set(A) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__below,type,
    condit8119078960628432327_below: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(set(A),$o) ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : fun(set(A),$o) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreordering__bdd,type,
    condit622319405099724424ng_bdd: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreordering__bdd_Obdd,type,
    condit16957441358409770ng_bdd: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(set(A),$o) ) ).

tff(sy_c_Countable_Onat__to__rat__surj,type,
    nat_to_rat_surj: nat > rat ).

tff(sy_c_Countable_Oto__nat,type,
    to_nat: 
      !>[A: $tType] : fun(A,nat) ).

tff(sy_c_Divides_Oadjust__div,type,
    adjust_div: product_prod(int,int) > int ).

tff(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( ( num * num ) > product_prod(A,A) ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( ( num * product_prod(A,A) ) > product_prod(A,A) ) ).

tff(sy_c_Equiv__Relations_Ocongruent,type,
    equiv_congruent: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,B) ) > $o ) ).

tff(sy_c_Equiv__Relations_Ocongruent2,type,
    equiv_congruent2: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) * fun(A,fun(B,C)) ) > $o ) ).

tff(sy_c_Equiv__Relations_Oequiv,type,
    equiv_equiv: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Equiv__Relations_Oequivp,type,
    equiv_equivp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Equiv__Relations_Opart__equivp,type,
    equiv_part_equivp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Equiv__Relations_Oproj,type,
    equiv_proj: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,A)) * B ) > set(A) ) ).

tff(sy_c_Equiv__Relations_Oquotient,type,
    equiv_quotient: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > set(set(A)) ) ).

tff(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : ( A > nat ) ).

tff(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( ( A * nat ) > A ) ).

tff(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Ocofinite,type,
    cofinite: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( fun(A,$o) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofilter_OAbs__filter,type,
    abs_filter: 
      !>[A: $tType] : fun(fun(fun(A,$o),$o),filter(A)) ).

tff(sy_c_Filter_Ofilter_ORep__filter,type,
    rep_filter: 
      !>[A: $tType] : fun(filter(A),fun(fun(A,$o),$o)) ).

tff(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) ) > filter(A) ) ).

tff(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Ofinite__subsets__at__top,type,
    finite5375528669736107172at_top: 
      !>[A: $tType] : ( set(A) > filter(set(A)) ) ).

tff(sy_c_Filter_Ofrequently,type,
    frequently: 
      !>[A: $tType] : ( ( fun(A,$o) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ois__filter,type,
    is_filter: 
      !>[A: $tType] : fun(fun(fun(A,$o),$o),$o) ).

tff(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( set(A) > filter(A) ) ).

tff(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter(A) * filter(B) ) > filter(product_prod(A,B)) ) ).

tff(sy_c_Filter_Orel__filter,type,
    rel_filter: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(filter(A),fun(filter(B),$o)) ) ).

tff(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : fun(set(B),nat) ).

tff(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofinite,type,
    finite_finite2: 
      !>[A: $tType] : fun(set(A),$o) ).

tff(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > B ) ).

tff(sy_c_Finite__Set_Ofold__graph,type,
    finite_fold_graph: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > fun(B,$o) ) ).

tff(sy_c_Finite__Set_Ofolding,type,
    finite_folding: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B ) > fun(set(A),B) ) ).

tff(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) * set(B) ) > $o ) ).

tff(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( fun(B,C) > fun(fun(A,B),fun(A,C)) ) ).

tff(sy_c_Fun_Ofcomp,type,
    fcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,B) * fun(B,C) ) > fun(A,C) ) ).

tff(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A * B ) > fun(A,B) ) ).

tff(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( fun(C,A) * fun(B,D) ) > fun(fun(A,B),fun(C,D)) ) ).

tff(sy_c_Fun_Ooverride__on,type,
    override_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * fun(A,B) * set(A) ) > fun(A,B) ) ).

tff(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * B ) > A ) ).

tff(sy_c_Fun__Def_OTHE__default,type,
    fun_THE_default: 
      !>[A: $tType] : ( ( A * fun(A,$o) ) > A ) ).

tff(sy_c_Fun__Def_Orp__inv__image,type,
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] : fun(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))) ).

tff(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_OGcd__class_OLcm,type,
    gcd_Lcm: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice,type,
    bounde8507323023520639062attice: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A * fun(A,A) ) > $o ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set,type,
    bounde6485984586167503788ce_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A * fun(A,A) ) > $o ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set_OF,type,
    bounde2362111253966948842tice_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A ) > fun(set(A),A) ) ).

tff(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Ogcd__class_Olcm,type,
    gcd_lcm: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( itself(A) > nat ) ).

tff(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_GCD_Osemiring__gcd__class_OLcm__fin,type,
    semiring_gcd_Lcm_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Groups_Oabel__semigroup,type,
    abel_semigroup: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Oabel__semigroup__axioms,type,
    abel_s757365448890700780axioms: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ocomm__monoid,type,
    comm_monoid: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Ocomm__monoid__axioms,type,
    comm_monoid_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Ogroup,type,
    group: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,A) ) > $o ) ).

tff(sy_c_Groups_Ogroup__axioms,type,
    group_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,A) ) > $o ) ).

tff(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Omonoid,type,
    monoid: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Omonoid__axioms,type,
    monoid_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

tff(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Osemigroup,type,
    semigroup: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

tff(sy_c_Groups__Big_Ocomm__monoid__add_Osum,type,
    groups3894954378712506084id_sum: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A * fun(B,A) * set(B) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : fun(fun(C,A),fun(set(C),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set,type,
    groups778175481326437816id_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set_OF,type,
    groups_comm_monoid_F: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(fun(B,A),fun(set(B),A)) ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set_OG,type,
    groups_comm_monoid_G: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(fun(B,A),fun(set(B),A)) ) ).

tff(sy_c_Groups__List_Ocomm__monoid__list,type,
    groups1828464146339083142d_list: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Ocomm__monoid__list__set,type,
    groups4802862169904069756st_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(A,fun(list(B),A))) ).

tff(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_Groups__List_Omonoid__list,type,
    groups_monoid_list: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Omonoid__list_OF,type,
    groups_monoid_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(list(A),A) ) ).

tff(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_HOL_OUniq,type,
    uniq: 
      !>[A: $tType] : ( fun(A,$o) > $o ) ).

tff(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

tff(sy_c_Heap_Oaddr__of__array,type,
    addr_of_array: 
      !>[A: $tType] : ( array(A) > nat ) ).

tff(sy_c_Heap_Oaddr__of__ref,type,
    addr_of_ref: 
      !>[A: $tType] : ( ref(A) > nat ) ).

tff(sy_c_Heap_Oarray_OArray,type,
    array2: 
      !>[A: $tType] : ( nat > array(A) ) ).

tff(sy_c_Heap_Oarray_Omap__array,type,
    map_array: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(array(A),array(Aa)) ) ).

tff(sy_c_Heap_Oarray_Opred__array,type,
    pred_array: 
      !>[A: $tType] : ( ( fun(A,$o) * array(A) ) > $o ) ).

tff(sy_c_Heap_Oarray_Orec__array,type,
    rec_array: 
      !>[C: $tType,A: $tType] : ( fun(nat,C) > fun(array(A),C) ) ).

tff(sy_c_Heap_Oarray_Orel__array,type,
    rel_array: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(array(A),fun(array(B),$o)) ) ).

tff(sy_c_Heap_Oarray_Oset__array,type,
    set_array: 
      !>[A: $tType] : ( array(A) > set(A) ) ).

tff(sy_c_Heap_Oempty,type,
    empty: heap_ext(product_unit) ).

tff(sy_c_Heap_Oheap_Oarrays,type,
    arrays: 
      !>[Z: $tType] : ( ( heap_ext(Z) * typerep * nat ) > list(nat) ) ).

tff(sy_c_Heap_Oheap_Oarrays__update,type,
    arrays_update: 
      !>[Z: $tType] : ( fun(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat)))) > fun(heap_ext(Z),heap_ext(Z)) ) ).

tff(sy_c_Heap_Oheap_Oheap__ext,type,
    heap_ext2: 
      !>[Z: $tType] : ( ( fun(typerep,fun(nat,list(nat))) * fun(typerep,fun(nat,nat)) * nat * Z ) > heap_ext(Z) ) ).

tff(sy_c_Heap_Oheap_Olim,type,
    lim: 
      !>[Z: $tType] : ( heap_ext(Z) > nat ) ).

tff(sy_c_Heap_Oheap_Olim__update,type,
    lim_update: 
      !>[Z: $tType] : ( ( fun(nat,nat) * heap_ext(Z) ) > heap_ext(Z) ) ).

tff(sy_c_Heap_Oheap_Orefs,type,
    refs: 
      !>[Z: $tType] : ( ( heap_ext(Z) * typerep * nat ) > nat ) ).

tff(sy_c_Heap_Oheap_Orefs__update,type,
    refs_update: 
      !>[Z: $tType] : ( fun(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat))) > fun(heap_ext(Z),heap_ext(Z)) ) ).

tff(sy_c_Heap_Oref_ORef,type,
    ref2: 
      !>[A: $tType] : ( nat > ref(A) ) ).

tff(sy_c_Heap_Oref_Omap__ref,type,
    map_ref: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(ref(A),ref(Aa)) ) ).

tff(sy_c_Heap_Oref_Opred__ref,type,
    pred_ref: 
      !>[A: $tType] : ( ( fun(A,$o) * ref(A) ) > $o ) ).

tff(sy_c_Heap_Oref_Orec__ref,type,
    rec_ref: 
      !>[C: $tType,A: $tType] : ( fun(nat,C) > fun(ref(A),C) ) ).

tff(sy_c_Heap_Oref_Orel__ref,type,
    rel_ref: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(ref(A),fun(ref(B),$o)) ) ).

tff(sy_c_Heap_Oref_Oset__ref,type,
    set_ref: 
      !>[A: $tType] : ( ref(A) > set(A) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_OHeap,type,
    heap_Time_Heap2: 
      !>[A: $tType] : ( fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_Omap__Heap,type,
    heap_Time_map_Heap: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(heap_Time_Heap(A),heap_Time_Heap(Aa)) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_Opred__Heap,type,
    heap_Time_pred_Heap: 
      !>[A: $tType] : ( ( fun(A,$o) * heap_Time_Heap(A) ) > $o ) ).

tff(sy_c_Heap__Time__Monad_OHeap_Orec__Heap,type,
    heap_Time_rec_Heap: 
      !>[A: $tType,C: $tType] : ( fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C) > fun(heap_Time_Heap(A),C) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_Orel__Heap,type,
    heap_Time_rel_Heap: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),$o)) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_Oset__Heap,type,
    heap_Time_set_Heap: 
      !>[A: $tType] : ( heap_Time_Heap(A) > set(A) ) ).

tff(sy_c_Heap__Time__Monad_OHeap__lub,type,
    heap_Time_Heap_lub: 
      !>[A: $tType] : fun(set(heap_Time_Heap(A)),heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_OHeap__ord,type,
    heap_Time_Heap_ord: 
      !>[A: $tType] : fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),$o)) ).

tff(sy_c_Heap__Time__Monad_Obind,type,
    heap_Time_bind: 
      !>[A: $tType,B: $tType] : ( ( heap_Time_Heap(A) * fun(A,heap_Time_Heap(B)) ) > heap_Time_Heap(B) ) ).

tff(sy_c_Heap__Time__Monad_Oeffect,type,
    heap_Time_effect: 
      !>[A: $tType] : ( ( heap_Time_Heap(A) * heap_ext(product_unit) * heap_ext(product_unit) * A * nat ) > $o ) ).

tff(sy_c_Heap__Time__Monad_Oexecute,type,
    heap_Time_execute: 
      !>[A: $tType] : ( heap_Time_Heap(A) > fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))) ) ).

tff(sy_c_Heap__Time__Monad_Oguard,type,
    heap_Time_guard: 
      !>[A: $tType] : ( ( fun(heap_ext(product_unit),$o) * fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Oheap,type,
    heap_Time_heap: 
      !>[A: $tType] : ( fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Olift,type,
    heap_Time_lift: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(A,heap_Time_Heap(B)) ) ).

tff(sy_c_Heap__Time__Monad_Oraise,type,
    heap_Time_raise: 
      !>[A: $tType] : ( list(char) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Oreturn,type,
    heap_Time_return: 
      !>[A: $tType] : fun(A,heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_Osuccess,type,
    heap_Time_success: 
      !>[A: $tType] : ( ( heap_Time_Heap(A) * heap_ext(product_unit) ) > $o ) ).

tff(sy_c_Heap__Time__Monad_Otap,type,
    heap_Time_tap: 
      !>[A: $tType] : ( fun(heap_ext(product_unit),A) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_OtimeFrame,type,
    heap_Time_timeFrame: 
      !>[A: $tType] : ( ( nat * option(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) > option(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ).

tff(sy_c_Heap__Time__Monad_Oureturn,type,
    heap_Time_ureturn: 
      !>[A: $tType] : ( A > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Owait,type,
    heap_Time_wait: nat > heap_Time_Heap(product_unit) ).

tff(sy_c_Hilbert__Choice_Oinv__into,type,
    hilbert_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * B ) > A ) ).

tff(sy_c_Hoare__Triple_Ohoare__triple,type,
    hoare_hoare_triple: 
      !>[A: $tType] : ( ( assn * heap_Time_Heap(A) * fun(A,assn) ) > $o ) ).

tff(sy_c_Hoare__Triple_Onew__addrs,type,
    hoare_new_addrs: ( heap_ext(product_unit) * set(nat) * heap_ext(product_unit) ) > set(nat) ).

tff(sy_c_Inductive_Ocomplete__lattice__class_Ogfp,type,
    complete_lattice_gfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Inductive_Ocomplete__lattice__class_Olfp,type,
    complete_lattice_lfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set(A) * nat ) > A ) ).

tff(sy_c_Int_OAbs__Integ,type,
    abs_Integ: fun(product_prod(nat,nat),int) ).

tff(sy_c_Int_ORep__Integ,type,
    rep_Integ: fun(int,product_prod(nat,nat)) ).

tff(sy_c_Int_Ocr__int,type,
    cr_int: product_prod(nat,nat) > fun(int,$o) ).

tff(sy_c_Int_Oint_OAbs__int,type,
    abs_int: fun(set(product_prod(nat,nat)),int) ).

tff(sy_c_Int_Oint_ORep__int,type,
    rep_int: fun(int,set(product_prod(nat,nat))) ).

tff(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Ointrel,type,
    intrel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_Int_Onat,type,
    nat2: fun(int,nat) ).

tff(sy_c_Int_Opcr__int,type,
    pcr_int: fun(product_prod(nat,nat),fun(int,$o)) ).

tff(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( ( A * int ) > A ) ).

tff(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : fun(int,A) ).

tff(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices_Osemilattice,type,
    semilattice: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices_Osemilattice__axioms,type,
    semilattice_axioms: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices_Osemilattice__neutr,type,
    semilattice_neutr: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__order,type,
    semilattice_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__order__axioms,type,
    semila6385135966242565138axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices__Big_Olinorder_OMax,type,
    lattices_Max: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(set(A),A) ) ).

tff(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(set(A),A) ) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lattices__Big_Oord_Oarg__max,type,
    lattices_arg_max: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * fun(B,$o) ) > B ) ).

tff(sy_c_Lattices__Big_Oord_Oarg__max__on,type,
    lattices_arg_max_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Lattices__Big_Oord_Oarg__min,type,
    lattices_arg_min: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * fun(B,$o) ) > B ) ).

tff(sy_c_Lattices__Big_Oord_Oarg__min__on,type,
    lattices_arg_min_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Lattices__Big_Oord_Ois__arg__max,type,
    lattices_is_arg_max: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * fun(B,$o) ) > fun(B,$o) ) ).

tff(sy_c_Lattices__Big_Oord_Ois__arg__min,type,
    lattices_is_arg_min: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * fun(B,$o) ) > fun(B,$o) ) ).

tff(sy_c_Lattices__Big_Oord__class_Oarg__min,type,
    lattices_ord_arg_min: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * fun(B,$o) ) > B ) ).

tff(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Lattices__Big_Oord__class_Ois__arg__min,type,
    lattic501386751177426532rg_min: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * fun(B,$o) ) > fun(B,$o) ) ).

tff(sy_c_Lattices__Big_Osemilattice__inf_OInf__fin,type,
    lattic8678736583308907530nf_fin: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lattices__Big_Osemilattice__neutr__set,type,
    lattic5652469242046573047tr_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__neutr__set_OF,type,
    lattic5214292709420241887eutr_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__order__set,type,
    lattic4895041142388067077er_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__set,type,
    lattic149705377957585745ce_set: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__set_OF,type,
    lattic1715443433743089157tice_F: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > fun(set(A),A) ) ).

tff(sy_c_Lattices__Big_Osemilattice__sup_OSup__fin,type,
    lattic4630905495605216202up_fin: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lifting_OQuotient,type,
    quotient: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,B) * fun(B,A) * fun(A,fun(B,$o)) ) > $o ) ).

tff(sy_c_Lifting_Orel__pred__comp,type,
    rel_pred_comp: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,$o)) * fun(B,$o) * A ) > $o ) ).

tff(sy_c_List_OBleast,type,
    bleast: 
      !>[A: $tType] : ( ( set(A) * fun(A,$o) ) > A ) ).

tff(sy_c_List_Oabort__Bleast,type,
    abort_Bleast: 
      !>[A: $tType] : ( ( set(A) * fun(A,$o) ) > A ) ).

tff(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * list(A) ) > A ) ).

tff(sy_c_List_Oarg__min__list__rel,type,
    arg_min_list_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(fun(A,B),list(A)),fun(product_prod(fun(A,B),list(A)),$o)) ).

tff(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list(A) * fun(A,list(B)) ) > list(B) ) ).

tff(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( list(list(A)) > list(A) ) ).

tff(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( list(A) > set(A) ) ).

tff(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list(A) * A ) > nat ) ).

tff(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( list(A) > $o ) ).

tff(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(product_prod(nat,A)) ) ).

tff(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > option(product_prod(list(A),product_prod(A,list(A)))) ) ).

tff(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( fun(A,$o) > fun(list(A),list(A)) ) ).

tff(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > option(A) ) ).

tff(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * set(B) * fun(B,A) ) > $o ) ).

tff(sy_c_List_Ofoldl,type,
    foldl: 
      !>[B: $tType,A: $tType] : ( ( fun(B,fun(A,B)) * B * list(A) ) > B ) ).

tff(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Olast,type,
    last: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(nat,set(product_prod(list(A),list(A)))) ) ).

tff(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * B * list(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * set(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder__class_Oinsort__insert__key,type,
    linord329482645794927042rt_key: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * B * list(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( fun(B,A) > fun(B,fun(list(B),list(B))) ) ).

tff(sy_c_List_Olinorder__class_Osort__key,type,
    linorder_sort_key: 
      !>[B: $tType,A: $tType] : ( fun(B,A) > fun(list(B),list(B)) ) ).

tff(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( fun(B,A) > fun(set(B),list(B)) ) ).

tff(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : fun(set(A),list(A)) ).

tff(sy_c_List_Olinorder__class_Ostable__sort__key,type,
    linord3483353639454293061rt_key: 
      !>[B: $tType,A: $tType] : ( fun(fun(B,A),fun(list(B),list(B))) > $o ) ).

tff(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : fun(A,fun(list(A),list(A))) ).

tff(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : list(A) ).

tff(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,fun(list(A),B)) ) > fun(list(A),B) ) ).

tff(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(list(A),fun(list(B),$o)) ) ).

tff(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(list(A),list(Aa)) ) ).

tff(sy_c_List_Olist_Orec__list,type,
    rec_list: 
      !>[C: $tType,A: $tType] : ( ( C * fun(A,fun(list(A),fun(C,C))) ) > fun(list(A),C) ) ).

tff(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : fun(list(A),set(A)) ).

tff(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( fun(A,nat) * list(A) ) > nat ) ).

tff(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list(A) * nat * A ) > list(A) ) ).

tff(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(list(A),list(B))) ) ).

tff(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(list(A),fun(list(B),$o)) ) ).

tff(sy_c_List_Olists,type,
    lists: 
      !>[A: $tType] : ( set(A) > set(list(A)) ) ).

tff(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( list(set(A)) > set(list(A)) ) ).

tff(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * list(A) ) > list(B) ) ).

tff(sy_c_List_Omap__project,type,
    map_project: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * set(A) ) > set(B) ) ).

tff(sy_c_List_Omeasures,type,
    measures: 
      !>[A: $tType] : ( list(fun(A,nat)) > set(product_prod(A,A)) ) ).

tff(sy_c_List_Omin__list,type,
    min_list: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_List_Omin__list__rel,type,
    min_list_rel: 
      !>[A: $tType] : fun(list(A),fun(list(A),$o)) ).

tff(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(list(A)) ) ).

tff(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( list(A) > fun(nat,A) ) ).

tff(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list(A) * set(nat) ) > list(A) ) ).

tff(sy_c_List_Oord_Olexordp,type,
    lexordp2: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(list(A),fun(list(A),$o)) ) ).

tff(sy_c_List_Oord__class_Olexordp,type,
    ord_lexordp: 
      !>[A: $tType] : fun(list(A),fun(list(A),$o)) ).

tff(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( fun(A,$o) > fun(list(A),product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > fun(list(A),list(A)) ) ).

tff(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( ( nat * A ) > list(A) ) ).

tff(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set(A) * set(list(A)) ) > set(list(A)) ) ).

tff(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > set(list(A)) ) ).

tff(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),$o)) ).

tff(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) ) > $o ) ).

tff(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( list(A) > list(list(A)) ) ).

tff(sy_c_List_Osuccessively,type,
    successively: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(list(A),$o) ) ).

tff(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Othose,type,
    those: 
      !>[A: $tType] : ( list(option(A)) > option(list(A)) ) ).

tff(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : fun(list(list(A)),fun(list(list(A)),$o)) ).

tff(sy_c_List_Oupt,type,
    upt: ( nat * nat ) > list(nat) ).

tff(sy_c_List_Oupto,type,
    upto: ( int * int ) > list(int) ).

tff(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_Map_Odom,type,
    dom: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(A) ) ).

tff(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(product_prod(A,B)) ) ).

tff(sy_c_Map_Omap__add,type,
    map_add: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * fun(A,option(B)) ) > fun(A,option(B)) ) ).

tff(sy_c_Map_Omap__comp,type,
    map_comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( fun(B,option(C)) * fun(A,option(B)) * A ) > option(C) ) ).

tff(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( list(product_prod(A,B)) > fun(A,option(B)) ) ).

tff(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * list(A) * list(B) ) > fun(A,option(B)) ) ).

tff(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(B) ) ).

tff(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * set(A) ) > fun(A,option(B)) ) ).

tff(sy_c_Misc_OEps__Opt,type,
    eps_Opt: 
      !>[A: $tType] : ( fun(A,$o) > option(A) ) ).

tff(sy_c_Misc_Obijective,type,
    bijective: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > $o ) ).

tff(sy_c_Misc_Obrk__rel,type,
    brk_rel: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(product_prod($o,A),product_prod($o,B))) ) ).

tff(sy_c_Misc_Odflt__None__set,type,
    dflt_None_set: 
      !>[A: $tType] : ( set(A) > option(set(A)) ) ).

tff(sy_c_Misc_Ofun__of__rel,type,
    fun_of_rel: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,A)) * B ) > A ) ).

tff(sy_c_Misc_Oinv__on,type,
    inv_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) * B ) > A ) ).

tff(sy_c_Misc_Olist__all__zip,type,
    list_all_zip: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,$o)) * list(A) * list(B) ) > $o ) ).

tff(sy_c_Misc_Olist__collect__set,type,
    list_collect_set: 
      !>[B: $tType,A: $tType] : ( ( fun(B,set(A)) * list(B) ) > set(A) ) ).

tff(sy_c_Misc_Omap__mmupd,type,
    map_mmupd: 
      !>[B: $tType,A: $tType] : ( ( fun(B,option(A)) * set(B) * A ) > fun(B,option(A)) ) ).

tff(sy_c_Misc_Omap__to__set,type,
    map_to_set: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(product_prod(A,B)) ) ).

tff(sy_c_Misc_Omerge__list,type,
    merge_list: 
      !>[A: $tType] : ( ( list(list(A)) * list(list(A)) ) > list(A) ) ).

tff(sy_c_Misc_Omergesort,type,
    mergesort: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_Misc_Omergesort__by__rel,type,
    mergesort_by_rel: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(list(A),list(A)) ) ).

tff(sy_c_Misc_Omergesort__by__rel__merge,type,
    merges9089515139780605204_merge: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Omergesort__by__rel__split,type,
    merges295452479951948502_split: 
      !>[A: $tType] : ( ( product_prod(list(A),list(A)) * list(A) ) > product_prod(list(A),list(A)) ) ).

tff(sy_c_Misc_Omergesort__remdups,type,
    mergesort_remdups: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_Misc_Opairself,type,
    pairself: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(product_prod(A,A),product_prod(B,B)) ) ).

tff(sy_c_Misc_Opartition__rev,type,
    partition_rev: 
      !>[A: $tType] : ( ( fun(A,$o) * product_prod(list(A),list(A)) * list(A) ) > product_prod(list(A),list(A)) ) ).

tff(sy_c_Misc_Oquicksort__by__rel,type,
    quicksort_by_rel: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) ) > fun(list(A),list(A)) ) ).

tff(sy_c_Misc_Oquicksort__by__rel__rel,type,
    quicksort_by_rel_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,$o)),product_prod(list(A),list(A))),fun(product_prod(fun(A,fun(A,$o)),product_prod(list(A),list(A))),$o)) ).

tff(sy_c_Misc_Orel__of,type,
    rel_of: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * fun(product_prod(A,B),$o) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Misc_Orel__restrict,type,
    rel_restrict: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Misc_Oremove__rev,type,
    remove_rev: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Oset__to__map,type,
    set_to_map: 
      !>[B: $tType,A: $tType] : ( set(product_prod(B,A)) > fun(B,option(A)) ) ).

tff(sy_c_Misc_Oslice,type,
    slice: 
      !>[A: $tType] : ( ( nat * nat * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Osu__rel__fun,type,
    su_rel_fun: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,B)) * fun(A,B) ) > $o ) ).

tff(sy_c_Misc_Othe__default,type,
    the_default: 
      !>[A: $tType] : ( ( A * option(A) ) > A ) ).

tff(sy_c_Misc_Ouncurry,type,
    uncurry: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(A,fun(B,C)) > fun(product_prod(A,B),C) ) ).

tff(sy_c_Multiset_Oadd__mset,type,
    add_mset: 
      !>[A: $tType] : fun(A,fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Ocomm__monoid__add__class_Osum__mset,type,
    comm_m7189776963980413722m_mset: 
      !>[A: $tType] : ( multiset(A) > A ) ).

tff(sy_c_Multiset_Ocomm__monoid__mset,type,
    comm_monoid_mset: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Multiset_Ocomm__monoid__mset_OF,type,
    comm_monoid_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(multiset(A),A) ) ).

tff(sy_c_Multiset_Ocomm__monoid__mult__class_Oprod__mset,type,
    comm_m9189036328036947845d_mset: 
      !>[A: $tType] : fun(multiset(A),A) ).

tff(sy_c_Multiset_Ocr__multiset,type,
    cr_multiset: 
      !>[A: $tType] : fun(fun(A,nat),fun(multiset(A),$o)) ).

tff(sy_c_Multiset_Ofilter__mset,type,
    filter_mset: 
      !>[A: $tType] : fun(fun(A,$o),fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Ofold__mset,type,
    fold_mset: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * multiset(A) ) > B ) ).

tff(sy_c_Multiset_Oimage__mset,type,
    image_mset: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(multiset(A),multiset(B)) ) ).

tff(sy_c_Multiset_Ointer__mset,type,
    inter_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Olinorder__class_Opart,type,
    linorder_part: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * A * list(B) ) > product_prod(list(B),product_prod(list(B),list(B))) ) ).

tff(sy_c_Multiset_Olinorder__class_Osorted__list__of__multiset,type,
    linord6283353356039996273ltiset: 
      !>[A: $tType] : ( multiset(A) > list(A) ) ).

tff(sy_c_Multiset_Omset,type,
    mset: 
      !>[A: $tType] : ( list(A) > multiset(A) ) ).

tff(sy_c_Multiset_Omset__set,type,
    mset_set: 
      !>[B: $tType] : ( set(B) > multiset(B) ) ).

tff(sy_c_Multiset_Omult,type,
    mult: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(multiset(A),multiset(A))) ) ).

tff(sy_c_Multiset_Omult1,type,
    mult1: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(multiset(A),multiset(A))) ) ).

tff(sy_c_Multiset_Omulteqp__code,type,
    multeqp_code: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * multiset(A) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Omultiset_OAbs__multiset,type,
    abs_multiset: 
      !>[A: $tType] : fun(fun(A,nat),multiset(A)) ).

tff(sy_c_Multiset_Omultiset_Ocount,type,
    count: 
      !>[A: $tType] : fun(multiset(A),fun(A,nat)) ).

tff(sy_c_Multiset_Omultp,type,
    multp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(multiset(A),fun(multiset(A),$o)) ) ).

tff(sy_c_Multiset_Omultp__code,type,
    multp_code: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * multiset(A) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Opcr__multiset,type,
    pcr_multiset: 
      !>[C: $tType,B: $tType] : ( fun(C,fun(B,$o)) > fun(fun(C,nat),fun(multiset(B),$o)) ) ).

tff(sy_c_Multiset_Orel__mset,type,
    rel_mset: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(multiset(A),fun(multiset(B),$o)) ) ).

tff(sy_c_Multiset_Orepeat__mset,type,
    repeat_mset: 
      !>[A: $tType] : fun(nat,fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Oreplicate__mset,type,
    replicate_mset: 
      !>[A: $tType] : ( ( nat * A ) > multiset(A) ) ).

tff(sy_c_Multiset_Oset__mset,type,
    set_mset: 
      !>[A: $tType] : fun(multiset(A),set(A)) ).

tff(sy_c_Multiset_Osize__multiset,type,
    size_multiset: 
      !>[A: $tType] : ( fun(A,nat) > fun(multiset(A),nat) ) ).

tff(sy_c_Multiset_Osubset__eq__mset__impl,type,
    subset_eq_mset_impl: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > option($o) ) ).

tff(sy_c_Multiset_Osubset__eq__mset__impl__rel,type,
    subset751672762298770561pl_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),$o)) ).

tff(sy_c_Multiset_Osubset__mset,type,
    subset_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),$o)) ).

tff(sy_c_Multiset_Osubseteq__mset,type,
    subseteq_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),$o)) ).

tff(sy_c_Multiset_Ounion__mset,type,
    union_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Owcount,type,
    wcount: 
      !>[A: $tType] : ( ( fun(A,nat) * multiset(A) ) > fun(A,nat) ) ).

tff(sy_c_Nat_OSuc,type,
    suc: fun(nat,nat) ).

tff(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : fun(A,fun(fun(nat,A),fun(nat,A))) ).

tff(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

tff(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( ( T * fun(nat,fun(T,T)) ) > fun(nat,T) ) ).

tff(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( ( T * fun(nat,fun(T,T)) * nat ) > fun(T,$o) ) ).

tff(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : fun(nat,A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( fun(A,A) * nat * A ) > A ) ).

tff(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : fun(A,nat) ).

tff(sy_c_Nat__Bijection_Oint__decode,type,
    nat_int_decode: nat > int ).

tff(sy_c_Nat__Bijection_Olist__decode,type,
    nat_list_decode: nat > list(nat) ).

tff(sy_c_Nat__Bijection_Olist__decode__rel,type,
    nat_list_decode_rel: fun(nat,fun(nat,$o)) ).

tff(sy_c_Nat__Bijection_Oprod__decode,type,
    nat_prod_decode: nat > product_prod(nat,nat) ).

tff(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: fun(product_prod(nat,nat),nat) ).

tff(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > set(nat) ).

tff(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: set(nat) > nat ).

tff(sy_c_Nat__Bijection_Osum__decode,type,
    nat_sum_decode: nat > sum_sum(nat,nat) ).

tff(sy_c_Nat__Bijection_Osum__encode,type,
    nat_sum_encode: sum_sum(nat,nat) > nat ).

tff(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

tff(sy_c_Num_OBitM,type,
    bitM: num > num ).

tff(sy_c_Num_Oinc,type,
    inc: num > num ).

tff(sy_c_Num_Onat__of__num,type,
    nat_of_num: num > nat ).

tff(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Ois__num,type,
    neg_numeral_is_num: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( ( num * num ) > A ) ).

tff(sy_c_Num_Onum_OBit0,type,
    bit0: fun(num,num) ).

tff(sy_c_Num_Onum_OBit1,type,
    bit1: fun(num,num) ).

tff(sy_c_Num_Onum_OOne,type,
    one2: num ).

tff(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( ( A * fun(num,A) * fun(num,A) * num ) > A ) ).

tff(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

tff(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : fun(num,A) ).

tff(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

tff(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Osqr,type,
    sqr: num > num ).

tff(sy_c_Old__Datatype_OAtom,type,
    old_Atom: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,nat) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OCase,type,
    old_Case: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(set(old_node(A,B)),C) * fun(set(old_node(A,B)),C) * set(old_node(A,B)) ) > C ) ).

tff(sy_c_Old__Datatype_OIn0,type,
    old_In0: 
      !>[A: $tType,B: $tType] : ( set(old_node(A,B)) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OIn1,type,
    old_In1: 
      !>[A: $tType,B: $tType] : ( set(old_node(A,B)) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OLim,type,
    old_Lim: 
      !>[B: $tType,A: $tType] : ( fun(B,set(old_node(A,B))) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_ONode,type,
    old_Node: 
      !>[B: $tType,A: $tType] : set(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))) ).

tff(sy_c_Old__Datatype_OPush,type,
    old_Push: 
      !>[B: $tType] : fun(sum_sum(B,nat),fun(fun(nat,sum_sum(B,nat)),fun(nat,sum_sum(B,nat)))) ).

tff(sy_c_Old__Datatype_OPush__Node,type,
    old_Push_Node: 
      !>[B: $tType,A: $tType] : ( sum_sum(B,nat) > fun(old_node(A,B),old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OScons,type,
    old_Scons: 
      !>[A: $tType,B: $tType] : ( ( set(old_node(A,B)) * set(old_node(A,B)) ) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OSplit,type,
    old_Split: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(set(old_node(A,B)),fun(set(old_node(A,B)),C)) > fun(set(old_node(A,B)),C) ) ).

tff(sy_c_Old__Datatype_Odprod,type,
    old_dprod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) * set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) > set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) ).

tff(sy_c_Old__Datatype_Odsum,type,
    old_dsum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) * set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) > set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) ).

tff(sy_c_Old__Datatype_Ondepth,type,
    old_ndepth: 
      !>[A: $tType,B: $tType] : ( old_node(A,B) > nat ) ).

tff(sy_c_Old__Datatype_Onode_OAbs__Node,type,
    old_Abs_Node: 
      !>[B: $tType,A: $tType] : ( product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)) > old_node(A,B) ) ).

tff(sy_c_Old__Datatype_Onode_ORep__Node,type,
    old_Rep_Node: 
      !>[A: $tType,B: $tType] : ( old_node(A,B) > product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)) ) ).

tff(sy_c_Old__Datatype_Ontrunc,type,
    old_ntrunc: 
      !>[A: $tType,B: $tType] : ( ( nat * set(old_node(A,B)) ) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_Ouprod,type,
    old_uprod: 
      !>[A: $tType,B: $tType] : ( ( set(set(old_node(A,B))) * set(set(old_node(A,B))) ) > set(set(old_node(A,B))) ) ).

tff(sy_c_Old__Datatype_Ousum,type,
    old_usum: 
      !>[A: $tType,B: $tType] : ( ( set(set(old_node(A,B))) * set(set(old_node(A,B))) ) > set(set(old_node(A,B))) ) ).

tff(sy_c_Option_Obind,type,
    bind2: 
      !>[A: $tType,B: $tType] : ( ( option(A) * fun(A,option(B)) ) > option(B) ) ).

tff(sy_c_Option_Ocombine__options,type,
    combine_options: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * option(A) * option(A) ) > option(A) ) ).

tff(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : option(A) ).

tff(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : fun(A,option(A)) ).

tff(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,B) * option(A) ) > B ) ).

tff(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(option(A),option(Aa)) ) ).

tff(sy_c_Option_Ooption_Opred__option,type,
    pred_option: 
      !>[A: $tType] : ( fun(A,$o) > fun(option(A),$o) ) ).

tff(sy_c_Option_Ooption_Orec__option,type,
    rec_option: 
      !>[C: $tType,A: $tType] : ( ( C * fun(A,C) ) > fun(option(A),C) ) ).

tff(sy_c_Option_Ooption_Orel__option,type,
    rel_option: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(option(A),fun(option(B),$o)) ) ).

tff(sy_c_Option_Ooption_Oset__option,type,
    set_option: 
      !>[A: $tType] : ( option(A) > set(A) ) ).

tff(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : fun(option(A),A) ).

tff(sy_c_Option_Othese,type,
    these: 
      !>[A: $tType] : ( set(option(A)) > set(A) ) ).

tff(sy_c_Order__Relation_OAbove,type,
    order_Above: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OAboveS,type,
    order_AboveS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OUnder,type,
    order_Under: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OUnderS,type,
    order_UnderS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_Oabove,type,
    order_above: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_OaboveS,type,
    order_aboveS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_Olinear__order__on,type,
    order_679001287576687338der_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Oofilter,type,
    order_ofilter: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > $o ) ).

tff(sy_c_Order__Relation_Opartial__order__on,type,
    order_7125193373082350890der_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Opreorder__on,type,
    order_preorder_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Orelation__of,type,
    order_relation_of: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * set(A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Order__Relation_Ounder,type,
    order_under: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(A,set(A)) ) ).

tff(sy_c_Order__Relation_OunderS,type,
    order_underS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_Owell__order__on,type,
    order_well_order_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

tff(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(fun(A,$o),A) ) ).

tff(sy_c_Orderings_Oord_Omax,type,
    max: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(A,fun(A,A)) ) ).

tff(sy_c_Orderings_Oord_Omin,type,
    min: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(A,fun(A,A)) ) ).

tff(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oorder_OGreatest,type,
    greatest: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(fun(A,$o),A) ) ).

tff(sy_c_Orderings_Oorder_Omono,type,
    mono: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(A,$o)) > fun(fun(A,B),$o) ) ).

tff(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oordering,type,
    ordering: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Orderings_Oordering__axioms,type,
    ordering_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Orderings_Oordering__top,type,
    ordering_top: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * A ) > $o ) ).

tff(sy_c_Orderings_Oordering__top__axioms,type,
    ordering_top_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > $o ) ).

tff(sy_c_Orderings_Opartial__preordering,type,
    partial_preordering: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Orderings_Opreordering,type,
    preordering: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Orderings_Opreordering__axioms,type,
    preordering_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

tff(sy_c_Partial__Function_Oflat__lub,type,
    partial_flat_lub: 
      !>[A: $tType] : ( A > fun(set(A),A) ) ).

tff(sy_c_Partial__Function_Oflat__ord,type,
    partial_flat_ord: 
      !>[A: $tType] : ( A > fun(A,fun(A,$o)) ) ).

tff(sy_c_Partial__Function_Ofun__lub,type,
    partial_fun_lub: 
      !>[C: $tType,B: $tType,A: $tType] : ( fun(set(C),B) > fun(set(fun(A,C)),fun(A,B)) ) ).

tff(sy_c_Partial__Function_Ofun__ord,type,
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(A,fun(B,$o)) > fun(fun(C,A),fun(fun(C,B),$o)) ) ).

tff(sy_c_Partial__Function_Oimg__ord,type,
    partial_img_ord: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( fun(A,C) * fun(C,fun(C,B)) * A * A ) > B ) ).

tff(sy_c_Partial__Function_Omk__less,type,
    partial_mk_less: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A * A ) > $o ) ).

tff(sy_c_Partial__Function_Opartial__function__definitions,type,
    partia7178651479351089652itions: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(set(A),A) ) > $o ) ).

tff(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : fun(A,fun(nat,A)) ).

tff(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : fun(A,fun(B,product_prod(A,B))) ).

tff(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,set(B)) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Product__Type_OUnity,type,
    product_Unity: product_unit ).

tff(sy_c_Product__Type_Oapfst,type,
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] : ( fun(A,C) > fun(product_prod(A,B),product_prod(C,B)) ) ).

tff(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : fun(fun(B,C),fun(product_prod(A,B),product_prod(A,C))) ).

tff(sy_c_Product__Type_Ocurry,type,
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(product_prod(A,B),C) * A * B ) > C ) ).

tff(sy_c_Product__Type_Omap__prod,type,
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,C) * fun(B,D) ) > fun(product_prod(A,B),product_prod(C,D)) ) ).

tff(sy_c_Product__Type_Oold_Obool_Orec__bool,type,
    product_rec_bool: 
      !>[T: $tType] : ( ( T * T * $o ) > T ) ).

tff(sy_c_Product__Type_Oold_Obool_Orec__set__bool,type,
    product_rec_set_bool: 
      !>[T: $tType] : ( ( T * T * $o ) > fun(T,$o) ) ).

tff(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( fun(A,fun(B,T)) * product_prod(A,B) ) > T ) ).

tff(sy_c_Product__Type_Oold_Oprod_Orec__set__prod,type,
    product_rec_set_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( fun(A,fun(B,T)) * product_prod(A,B) ) > fun(T,$o) ) ).

tff(sy_c_Product__Type_Oold_Ounit_Orec__set__unit,type,
    product_rec_set_unit: 
      !>[T: $tType] : ( ( T * product_unit ) > fun(T,$o) ) ).

tff(sy_c_Product__Type_Oold_Ounit_Orec__unit,type,
    product_rec_unit: 
      !>[T: $tType] : ( ( T * product_unit ) > T ) ).

tff(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : fun(fun(A,fun(B,C)),fun(product_prod(A,B),C)) ).

tff(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),A) ).

tff(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),B) ).

tff(sy_c_Product__Type_Oprod_Oswap,type,
    product_swap: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),product_prod(B,A)) ).

tff(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Product__Type_Oscomp,type,
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( fun(A,product_prod(B,C)) * fun(B,fun(C,D)) ) > fun(A,D) ) ).

tff(sy_c_Product__Type_Ounit_OAbs__unit,type,
    product_Abs_unit: fun($o,product_unit) ).

tff(sy_c_Product__Type_Ounit_ORep__unit,type,
    product_Rep_unit: fun(product_unit,$o) ).

tff(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : itself(A) ).

tff(sy_c_Quicksort_Olinorder__class_Oquicksort,type,
    linorder_quicksort: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_Quicksort_Olinorder__class_Oquicksort__rel,type,
    linord6200660962353139674rt_rel: 
      !>[A: $tType] : fun(list(A),fun(list(A),$o)) ).

tff(sy_c_Quotient_OQuotient3,type,
    quotient3: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,B) * fun(B,A) ) > $o ) ).

tff(sy_c_Quotient_Oquot__type,type,
    quot_type: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(set(A),B) * fun(B,set(A)) ) > $o ) ).

tff(sy_c_Quotient_Oquot__type_Orep,type,
    quot_rep: 
      !>[B: $tType,A: $tType] : ( ( fun(B,set(A)) * B ) > A ) ).

tff(sy_c_Random_Oinc__shift,type,
    inc_shift: ( code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Oiterate,type,
    iterate: 
      !>[B: $tType,A: $tType] : ( ( code_natural * fun(B,fun(A,product_prod(B,A))) * B ) > fun(A,product_prod(B,A)) ) ).

tff(sy_c_Random_Olog,type,
    log: ( code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Ominus__shift,type,
    minus_shift: ( code_natural * code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Onext,type,
    next: fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))) ).

tff(sy_c_Random_Opick,type,
    pick: 
      !>[A: $tType] : ( list(product_prod(code_natural,A)) > fun(code_natural,A) ) ).

tff(sy_c_Random_Orange,type,
    range: code_natural > fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))) ).

tff(sy_c_Random_Oselect,type,
    select: 
      !>[A: $tType] : ( list(A) > fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random_Oselect__weight,type,
    select_weight: 
      !>[A: $tType] : ( list(product_prod(code_natural,A)) > fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random_Osplit__seed,type,
    split_seed: product_prod(code_natural,code_natural) > product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)) ).

tff(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: fun(product_prod(int,int),rat) ).

tff(sy_c_Rat_OFract,type,
    fract: fun(int,fun(int,rat)) ).

tff(sy_c_Rat_ORep__Rat,type,
    rep_Rat: fun(rat,product_prod(int,int)) ).

tff(sy_c_Rat_Ocr__rat,type,
    cr_rat: ( product_prod(int,int) * rat ) > $o ).

tff(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : fun(rat,A) ).

tff(sy_c_Rat_Onormalize,type,
    normalize: product_prod(int,int) > product_prod(int,int) ).

tff(sy_c_Rat_Opcr__rat,type,
    pcr_rat: fun(product_prod(int,int),fun(rat,$o)) ).

tff(sy_c_Rat_Opositive,type,
    positive: fun(rat,$o) ).

tff(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > product_prod(int,int) ).

tff(sy_c_Rat_Orat_OAbs__rat,type,
    abs_rat: fun(set(product_prod(int,int)),rat) ).

tff(sy_c_Rat_Orat_ORep__rat,type,
    rep_rat: fun(rat,set(product_prod(int,int))) ).

tff(sy_c_Rat_Oratrel,type,
    ratrel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_Ref__Time_Oalloc,type,
    ref_alloc: 
      !>[A: $tType] : ( ( A * heap_ext(product_unit) ) > product_prod(ref(A),heap_ext(product_unit)) ) ).

tff(sy_c_Ref__Time_Ochange,type,
    ref_change: 
      !>[A: $tType] : ( ( fun(A,A) * ref(A) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Ref__Time_Oget,type,
    ref_get: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * ref(A) ) > A ) ).

tff(sy_c_Ref__Time_Olookup,type,
    ref_lookup: 
      !>[A: $tType] : ( ref(A) > heap_Time_Heap(A) ) ).

tff(sy_c_Ref__Time_Oref,type,
    ref_ref: 
      !>[A: $tType] : ( A > heap_Time_Heap(ref(A)) ) ).

tff(sy_c_Ref__Time_Oset,type,
    ref_set: 
      !>[A: $tType] : ( ( ref(A) * A ) > fun(heap_ext(product_unit),heap_ext(product_unit)) ) ).

tff(sy_c_Ref__Time_Oupdate,type,
    ref_update: 
      !>[A: $tType] : ( ( ref(A) * A ) > heap_Time_Heap(product_unit) ) ).

tff(sy_c_Relation_ODomain,type,
    domain: 
      !>[A: $tType,B: $tType] : fun(set(product_prod(A,B)),set(A)) ).

tff(sy_c_Relation_ODomainp,type,
    domainp: 
      !>[A: $tType,B: $tType] : fun(fun(A,fun(B,$o)),fun(A,$o)) ).

tff(sy_c_Relation_OField,type,
    field2: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(A) ) ).

tff(sy_c_Relation_OId,type,
    id2: 
      !>[A: $tType] : set(product_prod(A,A)) ).

tff(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( set(A) > set(product_prod(A,A)) ) ).

tff(sy_c_Relation_OImage,type,
    image: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > fun(set(A),set(B)) ) ).

tff(sy_c_Relation_OPowp,type,
    powp: 
      !>[A: $tType] : ( ( fun(A,$o) * set(A) ) > $o ) ).

tff(sy_c_Relation_ORange,type,
    range2: 
      !>[A: $tType,B: $tType] : fun(set(product_prod(A,B)),set(B)) ).

tff(sy_c_Relation_ORangep,type,
    rangep: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(B,$o) ) ).

tff(sy_c_Relation_Oantisym,type,
    antisym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oantisymp,type,
    antisymp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Relation_Oasym,type,
    asym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oasymp,type,
    asymp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Relation_Oconverse,type,
    converse: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(B,A)) ) ).

tff(sy_c_Relation_Oconversep,type,
    conversep: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(B,fun(A,$o)) ) ).

tff(sy_c_Relation_Oinv__image,type,
    inv_image: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * fun(A,B) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Relation_Oinv__imagep,type,
    inv_imagep: 
      !>[B: $tType,A: $tType] : ( ( fun(B,fun(B,$o)) * fun(A,B) * A * A ) > $o ) ).

tff(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oirreflp,type,
    irreflp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Relation_Orefl__on,type,
    refl_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Relation_Oreflp,type,
    reflp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(product_prod(A,B)) * set(product_prod(B,C)) ) > set(product_prod(A,C)) ) ).

tff(sy_c_Relation_Orelcompp,type,
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] : fun(fun(A,fun(B,$o)),fun(fun(B,fun(C,$o)),fun(A,fun(C,$o)))) ).

tff(sy_c_Relation_Osingle__valued,type,
    single_valued: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > $o ) ).

tff(sy_c_Relation_Osingle__valuedp,type,
    single_valuedp: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > $o ) ).

tff(sy_c_Relation_Osym,type,
    sym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Osymp,type,
    symp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Relation_Ototal__on,type,
    total_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Relation_Otrans,type,
    trans: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( ( A * A ) > $o ) ).

tff(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Rings_Onormalization__semidom__class_Onormalize,type,
    normal6383669964737779283malize: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Rings_Ounit__factor__class_Ounit__factor,type,
    unit_f5069060285200089521factor: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : fun($o,A) ).

tff(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : fun(set(A),fun(fun(A,$o),$o)) ).

tff(sy_c_Set_OBex,type,
    bex: 
      !>[A: $tType] : fun(set(A),fun(fun(A,$o),$o)) ).

tff(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : fun(fun(A,$o),set(A)) ).

tff(sy_c_Set_OPow,type,
    pow: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Set_Obind,type,
    bind3: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,set(B)) ) > set(B) ) ).

tff(sy_c_Set_Odisjnt,type,
    disjnt: 
      !>[A: $tType] : fun(set(A),fun(set(A),$o)) ).

tff(sy_c_Set_Ofilter,type,
    filter3: 
      !>[A: $tType] : ( ( fun(A,$o) * set(A) ) > set(A) ) ).

tff(sy_c_Set_Oimage,type,
    image2: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(set(A),set(B)) ) ).

tff(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > fun(set(A),set(A)) ) ).

tff(sy_c_Set_Ois__empty,type,
    is_empty: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Set_Ois__singleton,type,
    is_singleton: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Set_Opairwise,type,
    pairwise: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * set(A) ) > $o ) ).

tff(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : fun(A,fun(set(A),set(A))) ).

tff(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : fun(fun(A,B),fun(set(B),set(A))) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( fun(nat,fun(A,A)) * nat * nat * A ) > A ) ).

tff(sy_c_Set__Interval_Oord_OatLeast,type,
    set_atLeast: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatLeastAtMost,type,
    set_atLeastAtMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatLeastLessThan,type,
    set_atLeastLessThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatMost,type,
    set_atMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThan,type,
    set_greaterThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThanAtMost,type,
    set_gr3752724095348155675AtMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThanLessThan,type,
    set_gr287244882034783167ssThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OlessThan,type,
    set_lessThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Sum__Type_OInl,type,
    sum_Inl: 
      !>[A: $tType,B: $tType] : fun(A,sum_sum(A,B)) ).

tff(sy_c_Sum__Type_OInr,type,
    sum_Inr: 
      !>[B: $tType,A: $tType] : fun(B,sum_sum(A,B)) ).

tff(sy_c_Sum__Type_OPlus,type,
    sum_Plus: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(sum_sum(A,B)) ) ).

tff(sy_c_Sum__Type_Oold_Osum_Orec__set__sum,type,
    sum_rec_set_sum: 
      !>[A: $tType,T: $tType,B: $tType] : ( ( fun(A,T) * fun(B,T) * sum_sum(A,B) ) > fun(T,$o) ) ).

tff(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] : ( ( fun(A,T) * fun(B,T) * sum_sum(A,B) ) > T ) ).

tff(sy_c_Sum__Type_Osum_Ocase__sum,type,
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( fun(A,C) * fun(B,C) ) > fun(sum_sum(A,B),C) ) ).

tff(sy_c_Sum__Type_Osum_Oisl,type,
    sum_isl: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,B) > $o ) ).

tff(sy_c_Sum__Type_Osum_Oprojl,type,
    sum_projl: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,B) > A ) ).

tff(sy_c_Sum__Type_Osum_Oprojr,type,
    sum_projr: 
      !>[A: $tType,B: $tType] : ( sum_sum(A,B) > B ) ).

tff(sy_c_Syntax__Match_Oac__operator,type,
    syntax_ac_operator: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Syntax__Match_Osyntax__fo__nomatch,type,
    syntax7388354845996824322omatch: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_Syntax__Match_Osyntax__nomatch,type,
    syntax2379306206330768139omatch: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_Transfer_Obi__total,type,
    bi_total: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > $o ) ).

tff(sy_c_Transfer_Obi__unique,type,
    bi_unique: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > $o ) ).

tff(sy_c_Transfer_Oleft__total,type,
    left_total: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > $o ) ).

tff(sy_c_Transfer_Oleft__unique,type,
    left_unique: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > $o ) ).

tff(sy_c_Transfer_Oright__total,type,
    right_total: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > $o ) ).

tff(sy_c_Transfer_Otransfer__bforall,type,
    transfer_bforall: 
      !>[A: $tType] : ( ( fun(A,$o) * fun(A,$o) ) > $o ) ).

tff(sy_c_Transitive__Closure_Oacyclic,type,
    transitive_acyclic: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( ( nat * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Ortranclp,type,
    transitive_rtranclp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(A,fun(A,$o)) ) ).

tff(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Otranclp,type,
    transitive_tranclp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(A,fun(A,$o)) ) ).

tff(sy_c_Typedef_Otype__definition,type,
    type_definition: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Typerep_Otyperep__class_Otyperep,type,
    typerep_typerep: 
      !>[A: $tType] : ( itself(A) > typerep ) ).

tff(sy_c_Wellfounded_Oacc,type,
    acc: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(A) ) ).

tff(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(A,$o) ) ).

tff(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : set(product_prod(set(A),set(A))) ).

tff(sy_c_Wellfounded_Oless__than,type,
    less_than: set(product_prod(nat,nat)) ).

tff(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_Wellfounded_Omax__extp,type,
    max_extp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(set(A),fun(set(A),$o)) ) ).

tff(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( fun(A,nat) * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set(product_prod(nat,nat)) ).

tff(sy_c_Wellfounded_Owf,type,
    wf: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Wellfounded_OwfP,type,
    wfP: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Wfrec_Osame__fst,type,
    same_fst: 
      !>[A: $tType,B: $tType] : ( ( fun(A,$o) * fun(A,set(product_prod(B,B))) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_Zorn_OChains,type,
    chains: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(set(A)) ) ).

tff(sy_c_Zorn_Ochain__subset,type,
    chain_subset: 
      !>[A: $tType] : ( set(set(A)) > $o ) ).

tff(sy_c_Zorn_Ochains,type,
    chains2: 
      !>[A: $tType] : ( set(set(A)) > set(set(set(A))) ) ).

tff(sy_c_Zorn_Oinit__seg__of,type,
    init_seg_of: 
      !>[A: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))) ).

tff(sy_c_Zorn_Opred__on_Ochain,type,
    pred_chain: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,$o)) ) > fun(set(A),$o) ) ).

tff(sy_c_Zorn_Opred__on_Omaxchain,type,
    pred_maxchain: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,$o)) * set(A) ) > $o ) ).

tff(sy_c_Zorn_Opred__on_Osuc,type,
    pred_suc: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,$o)) * set(A) ) > set(A) ) ).

tff(sy_c_Zorn_Opred__on_Osuc__Union__closed,type,
    pred_s596693808085603175closed: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,$o)) ) > set(set(A)) ) ).

tff(sy_c_Zorn_Opred__on_Osuc__Union__closedp,type,
    pred_s7749564232668923593losedp: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,$o)) ) > fun(set(A),$o) ) ).

tff(sy_c_aa,type,
    aa: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A ) > B ) ).

tff(sy_c_fAll,type,
    fAll: 
      !>[A: $tType] : fun(fun(A,$o),$o) ).

tff(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_fNot,type,
    fNot: fun($o,$o) ).

tff(sy_c_fequal,type,
    fequal: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > fun(set(A),$o) ) ).

tff(sy_v_P,type,
    p: assn ).

tff(sy_v_P_H,type,
    p2: assn ).

tff(sy_v_P_H__0_058ATP,type,
    p_0_ATP: assn ).

tff(sy_v_Q,type,
    q: a > assn ).

tff(sy_v_Q_H,type,
    q2: a > assn ).

tff(sy_v_c,type,
    c2: heap_Time_Heap(a) ).

% Relevant facts (7564)
tff(fact_0_cons__rule,axiom,
    ! [B: $tType,Pa: assn,P_a: assn,Qa: fun(B,assn),Q_a: fun(B,assn),Ca: heap_Time_Heap(B)] :
      ( entails(Pa,P_a)
     => ( ! [X: B] : entails(aa(B,assn,Qa,X),aa(B,assn,Q_a,X))
       => ( hoare_hoare_triple(B,P_a,Ca,Qa)
         => hoare_hoare_triple(B,Pa,Ca,Q_a) ) ) ) ).

% cons_rule
tff(fact_1_frame__rule,axiom,
    ! [B: $tType,Pa: assn,Ca: heap_Time_Heap(B),Qa: fun(B,assn),R: assn] :
      ( hoare_hoare_triple(B,Pa,Ca,Qa)
     => hoare_hoare_triple(B,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),R),Ca,aa(assn,fun(B,assn),aTP_Lamp_aa(fun(B,assn),fun(assn,fun(B,assn)),Qa),R)) ) ).

% frame_rule
tff(fact_2_cons__pre__rule,axiom,
    ! [B: $tType,Pa: assn,P_a: assn,Ca: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( entails(Pa,P_a)
     => ( hoare_hoare_triple(B,P_a,Ca,Qa)
       => hoare_hoare_triple(B,Pa,Ca,Qa) ) ) ).

% cons_pre_rule
tff(fact_3_cons__post__rule,axiom,
    ! [B: $tType,Pa: assn,Ca: heap_Time_Heap(B),Qa: fun(B,assn),Q_a: fun(B,assn)] :
      ( hoare_hoare_triple(B,Pa,Ca,Qa)
     => ( ! [X: B] : entails(aa(B,assn,Qa,X),aa(B,assn,Q_a,X))
       => hoare_hoare_triple(B,Pa,Ca,Q_a) ) ) ).

% cons_post_rule
tff(fact_4_merge__true__star,axiom,
    aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),top_top(assn)),top_top(assn)) = top_top(assn) ).

% merge_true_star
tff(fact_5_top__apply,axiom,
    ! [C: $tType,B: $tType] :
      ( top(B)
     => ! [X2: C] : ( aa(C,B,top_top(fun(C,B)),X2) = top_top(B) ) ) ).

% top_apply
tff(fact_6_ent__true,axiom,
    ! [Pa: assn] : entails(Pa,top_top(assn)) ).

% ent_true
tff(fact_7_ent__star__mono,axiom,
    ! [Pa: assn,P_a: assn,Qa: assn,Q_a: assn] :
      ( entails(Pa,P_a)
     => ( entails(Qa,Q_a)
       => entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P_a),Q_a)) ) ) ).

% ent_star_mono
tff(fact_8_ent__iffI,axiom,
    ! [A3: assn,B2: assn] :
      ( entails(A3,B2)
     => ( entails(B2,A3)
       => ( A3 = B2 ) ) ) ).

% ent_iffI
tff(fact_9_ent__refl,axiom,
    ! [Pa: assn] : entails(Pa,Pa) ).

% ent_refl
tff(fact_10_ent__trans,axiom,
    ! [Pa: assn,Qa: assn,R: assn] :
      ( entails(Pa,Qa)
     => ( entails(Qa,R)
       => entails(Pa,R) ) ) ).

% ent_trans
tff(fact_11_assn__times__comm,axiom,
    ! [Pa: assn,Qa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),Pa) ) ).

% assn_times_comm
tff(fact_12_assn__times__assoc,axiom,
    ! [Pa: assn,Qa: assn,R: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa)),R) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),R)) ) ).

% assn_times_assoc
tff(fact_13_mult_Oright__assoc,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ).

% mult.right_assoc
tff(fact_14_mult_Oright__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3) ) ) ).

% mult.right_commute
tff(fact_15_mult_Oassoc,axiom,
    ! [B: $tType] :
      ( semigroup_mult(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ).

% mult.assoc
tff(fact_16_ab__semigroup__mult__class_Omult_Oleft__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => ! [B3: B,A4: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ).

% ab_semigroup_mult_class.mult.left_commute
tff(fact_17_ab__semigroup__mult__class_Omult_Ocommute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3) = aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4) ) ) ).

% ab_semigroup_mult_class.mult.commute
tff(fact_18_ent__wandI,axiom,
    ! [Qa: assn,Pa: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),Pa),R)
     => entails(Pa,wand_assn(Qa,R)) ) ).

% ent_wandI
tff(fact_19_ent__mp,axiom,
    ! [Pa: assn,Qa: assn] : entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),wand_assn(Pa,Qa)),Qa) ).

% ent_mp
tff(fact_20_entt__def__true,axiom,
    ! [Pa: assn,Qa: assn] :
      ( entailst(Pa,Qa)
    <=> entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),top_top(assn)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),top_top(assn))) ) ).

% entt_def_true
tff(fact_21_entailst__def,axiom,
    ! [A3: assn,B2: assn] :
      ( entailst(A3,B2)
    <=> entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn))) ) ).

% entailst_def
tff(fact_22_enttI__true,axiom,
    ! [Pa: assn,Qa: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),top_top(assn)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),top_top(assn)))
     => entailst(Pa,Qa) ) ).

% enttI_true
tff(fact_23_enttI,axiom,
    ! [A3: assn,B2: assn] :
      ( entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn)))
     => entailst(A3,B2) ) ).

% enttI
tff(fact_24_enttD,axiom,
    ! [A3: assn,B2: assn] :
      ( entailst(A3,B2)
     => entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn))) ) ).

% enttD
tff(fact_25_is__pure__assn__starI,axiom,
    ! [A4: assn,B3: assn] :
      ( is_pure_assn(A4)
     => ( is_pure_assn(B3)
       => is_pure_assn(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),B3)) ) ) ).

% is_pure_assn_starI
tff(fact_26_ent__pure__pre__iff,axiom,
    ! [Pa: assn,B3: $o,Qa: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),pure_assn(B3)),Qa)
    <=> ( (B3)
       => entails(Pa,Qa) ) ) ).

% ent_pure_pre_iff
tff(fact_27_entt__star__true__simp_I1_J,axiom,
    ! [A3: assn,B2: assn] :
      ( entailst(A3,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn)))
    <=> entailst(A3,B2) ) ).

% entt_star_true_simp(1)
tff(fact_28_entt__star__true__simp_I2_J,axiom,
    ! [A3: assn,B2: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),top_top(assn)),B2)
    <=> entailst(A3,B2) ) ).

% entt_star_true_simp(2)
tff(fact_29_mult_Osafe__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => ! [X2: B,Y: B,A4: B,B3: B] :
          ( syntax7388354845996824322omatch(B,B,aa(B,B,aa(B,fun(B,B),times_times(B),X2),Y),A4)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3) = aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4) ) ) ) ).

% mult.safe_commute
tff(fact_30_entt__refl,axiom,
    ! [A3: assn] : entailst(A3,A3) ).

% entt_refl
tff(fact_31_pure__assn__eq__conv,axiom,
    ! [Pa: $o,Qa: $o] :
      ( ( pure_assn(Pa) = pure_assn(Qa) )
    <=> ( (Pa)
      <=> (Qa) ) ) ).

% pure_assn_eq_conv
tff(fact_32_merge__pure__star,axiom,
    ! [A4: $o,B3: $o] :
      ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),pure_assn(A4)),pure_assn(B3))
      = pure_assn(
          (A4)
        & (B3)) ) ).

% merge_pure_star
tff(fact_33_entt__true,axiom,
    ! [A3: assn] : entailst(A3,top_top(assn)) ).

% entt_true
tff(fact_34_is__pure__assn__pure,axiom,
    ! [Pa: $o] : is_pure_assn(pure_assn(Pa)) ).

% is_pure_assn_pure
tff(fact_35_entt__trans,axiom,
    ! [A3: assn,B2: assn,C2: assn] :
      ( entailst(A3,B2)
     => ( entailst(B2,C2)
       => entailst(A3,C2) ) ) ).

% entt_trans
tff(fact_36_is__pure__assnE,axiom,
    ! [A4: assn] :
      ( is_pure_assn(A4)
     => ~ ! [P: $o] : ( A4 != pure_assn(P) ) ) ).

% is_pure_assnE
tff(fact_37_is__pure__assn__def,axiom,
    ! [A4: assn] :
      ( is_pure_assn(A4)
    <=> ? [P2: $o] : ( A4 = pure_assn(P2) ) ) ).

% is_pure_assn_def
tff(fact_38_syntax__fo__nomatch__def,axiom,
    ! [B: $tType,C: $tType,Pat: B,Obj: C] : syntax7388354845996824322omatch(B,C,Pat,Obj) ).

% syntax_fo_nomatch_def
tff(fact_39_entt__frame__fwd,axiom,
    ! [Pa: assn,Qa: assn,A3: assn,F: assn,B2: assn] :
      ( entailst(Pa,Qa)
     => ( entailst(A3,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),F))
       => ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),F),B2)
         => entailst(A3,B2) ) ) ) ).

% entt_frame_fwd
tff(fact_40_entt__star__mono,axiom,
    ! [A3: assn,B2: assn,C2: assn,D2: assn] :
      ( entailst(A3,B2)
     => ( entailst(C2,D2)
       => entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),C2),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),D2)) ) ) ).

% entt_star_mono
tff(fact_41_ent__imp__entt,axiom,
    ! [Pa: assn,Qa: assn] :
      ( entails(Pa,Qa)
     => entailst(Pa,Qa) ) ).

% ent_imp_entt
tff(fact_42_precise__extr__pure_I2_J,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,assn)),Pa: $o] :
      ( precise(B,C,aa($o,fun(B,fun(C,assn)),aTP_Lamp_ab(fun(B,fun(C,assn)),fun($o,fun(B,fun(C,assn))),R),Pa))
    <=> ( (Pa)
       => precise(B,C,R) ) ) ).

% precise_extr_pure(2)
tff(fact_43_precise__extr__pure_I1_J,axiom,
    ! [C: $tType,B: $tType,Pa: $o,R: fun(B,fun(C,assn))] :
      ( precise(B,C,aa(fun(B,fun(C,assn)),fun(B,fun(C,assn)),aTP_Lamp_ac($o,fun(fun(B,fun(C,assn)),fun(B,fun(C,assn))),Pa),R))
    <=> ( (Pa)
       => precise(B,C,R) ) ) ).

% precise_extr_pure(1)
tff(fact_44_ent__pure__post__iff,axiom,
    ! [Pa: assn,Qa: assn,B3: $o] :
      ( entails(Pa,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),pure_assn(B3)))
    <=> ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
            ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H)
           => (B3) )
        & entails(Pa,Qa) ) ) ).

% ent_pure_post_iff
tff(fact_45_mem__Collect__eq,axiom,
    ! [B: $tType,A4: B,Pa: fun(B,$o)] :
      ( aa(set(B),$o,member(B,A4),aa(fun(B,$o),set(B),collect(B),Pa))
    <=> aa(B,$o,Pa,A4) ) ).

% mem_Collect_eq
tff(fact_46_Collect__mem__eq,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3)) = A3 ) ).

% Collect_mem_eq
tff(fact_47_Collect__cong,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( ! [X: B] :
          ( aa(B,$o,Pa,X)
        <=> aa(B,$o,Qa,X) )
     => ( aa(fun(B,$o),set(B),collect(B),Pa) = aa(fun(B,$o),set(B),collect(B),Qa) ) ) ).

% Collect_cong
tff(fact_48_ext,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),G: fun(B,C)] :
      ( ! [X: B] : ( aa(B,C,F2,X) = aa(B,C,G,X) )
     => ( F2 = G ) ) ).

% ext
tff(fact_49_ent__pure__pre__iff__sng,axiom,
    ! [B3: $o,Qa: assn] :
      ( entails(pure_assn(B3),Qa)
    <=> ( (B3)
       => entails(one_one(assn),Qa) ) ) ).

% ent_pure_pre_iff_sng
tff(fact_50_triv__exI,axiom,
    ! [B: $tType,Qa: fun(B,assn),X2: B] : entails(aa(B,assn,Qa,X2),ex_assn(B,Qa)) ).

% triv_exI
tff(fact_51_ac__operator_Osafe__commute,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),X2: B,Y: B,A4: B,B3: B] :
      ( syntax_ac_operator(B,F2)
     => ( syntax7388354845996824322omatch(B,B,aa(B,B,aa(B,fun(B,B),F2,X2),Y),A4)
       => ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = aa(B,B,aa(B,fun(B,B),F2,B3),A4) ) ) ) ).

% ac_operator.safe_commute
tff(fact_52_mod__pure__star__dist,axiom,
    ! [Pa: assn,B3: $o,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),pure_assn(B3))),H2)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
        & (B3) ) ) ).

% mod_pure_star_dist
tff(fact_53_mod__star__trueE,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),top_top(assn))),H2)
     => ~ ! [H3: product_prod(heap_ext(product_unit),set(nat))] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H3) ) ).

% mod_star_trueE
tff(fact_54_mod__star__trueI,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),top_top(assn))),H2) ) ).

% mod_star_trueI
tff(fact_55_ent__ex__preI,axiom,
    ! [B: $tType,Pa: fun(B,assn),Qa: assn] :
      ( ! [X: B] : entails(aa(B,assn,Pa,X),Qa)
     => entails(ex_assn(B,Pa),Qa) ) ).

% ent_ex_preI
tff(fact_56_ent__ex__postI,axiom,
    ! [B: $tType,Pa: assn,Qa: fun(B,assn),X2: B] :
      ( entails(Pa,aa(B,assn,Qa,X2))
     => entails(Pa,ex_assn(B,Qa)) ) ).

% ent_ex_postI
tff(fact_57_ex__distrib__star,axiom,
    ! [B: $tType,Pa: fun(B,assn),Qa: assn] : ( ex_assn(B,aa(assn,fun(B,assn),aTP_Lamp_aa(fun(B,assn),fun(assn,fun(B,assn)),Pa),Qa)) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),ex_assn(B,Pa)),Qa) ) ).

% ex_distrib_star
tff(fact_58_Rep__assn__inject,axiom,
    ! [X2: assn,Y: assn] :
      ( ( aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,X2) = aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Y) )
    <=> ( X2 = Y ) ) ).

% Rep_assn_inject
tff(fact_59_ex__assn__const,axiom,
    ! [B: $tType,Ca: assn] : ( ex_assn(B,aTP_Lamp_ae(assn,fun(B,assn),Ca)) = Ca ) ).

% ex_assn_const
tff(fact_60_mult__1,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),one_one(B)),A4) = A4 ) ) ).

% mult_1
tff(fact_61_mult_Oright__neutral,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),one_one(B)) = A4 ) ) ).

% mult.right_neutral
tff(fact_62_entt__emp,axiom,
    ! [A3: assn] : entailst(A3,one_one(assn)) ).

% entt_emp
tff(fact_63_pure__assn__eq__emp__iff,axiom,
    ! [Pa: $o] :
      ( ( pure_assn(Pa) = one_one(assn) )
    <=> (Pa) ) ).

% pure_assn_eq_emp_iff
tff(fact_64_pure__true,axiom,
    pure_assn($true) = one_one(assn) ).

% pure_true
tff(fact_65_assn__basic__inequalities_I1_J,axiom,
    top_top(assn) != one_one(assn) ).

% assn_basic_inequalities(1)
tff(fact_66_mod__ex__dist,axiom,
    ! [B: $tType,Pa: fun(B,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,ex_assn(B,Pa)),H2)
    <=> ? [X3: B] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Pa,X3)),H2) ) ).

% mod_ex_dist
tff(fact_67_ent__pure__post__iff__sng,axiom,
    ! [Pa: assn,B3: $o] :
      ( entails(Pa,pure_assn(B3))
    <=> ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
            ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H)
           => (B3) )
        & entails(Pa,one_one(assn)) ) ) ).

% ent_pure_post_iff_sng
tff(fact_68_ex__one__point__gen,axiom,
    ! [B: $tType,Pa: fun(B,assn),V: B] :
      ( ! [H4: product_prod(heap_ext(product_unit),set(nat)),X: B] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Pa,X)),H4)
         => ( X = V ) )
     => ( ex_assn(B,Pa) = aa(B,assn,Pa,V) ) ) ).

% ex_one_point_gen
tff(fact_69_one__reorient,axiom,
    ! [B: $tType] :
      ( one(B)
     => ! [X2: B] :
          ( ( one_one(B) = X2 )
        <=> ( X2 = one_one(B) ) ) ) ).

% one_reorient
tff(fact_70_mod__exI,axiom,
    ! [B: $tType,Pa: fun(B,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ? [X4: B] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Pa,X4)),H2)
     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,ex_assn(B,Pa)),H2) ) ).

% mod_exI
tff(fact_71_mod__exE,axiom,
    ! [B: $tType,Pa: fun(B,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,ex_assn(B,Pa)),H2)
     => ~ ! [X: B] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Pa,X)),H2) ) ).

% mod_exE
tff(fact_72_ac__operator_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( ! [A5: B,B4: B,C3: B] : ( aa(B,B,aa(B,fun(B,B),F2,aa(B,B,aa(B,fun(B,B),F2,A5),B4)),C3) = aa(B,B,aa(B,fun(B,B),F2,A5),aa(B,B,aa(B,fun(B,B),F2,B4),C3)) )
     => ( ! [A5: B,B4: B] : ( aa(B,B,aa(B,fun(B,B),F2,A5),B4) = aa(B,B,aa(B,fun(B,B),F2,B4),A5) )
       => syntax_ac_operator(B,F2) ) ) ).

% ac_operator.intro
tff(fact_73_ac__operator_Ocommute,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A4: B,B3: B] :
      ( syntax_ac_operator(B,F2)
     => ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = aa(B,B,aa(B,fun(B,B),F2,B3),A4) ) ) ).

% ac_operator.commute
tff(fact_74_ac__operator_Oleft__assoc,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A4: B,B3: B,Ca: B] :
      ( syntax_ac_operator(B,F2)
     => ( aa(B,B,aa(B,fun(B,B),F2,A4),aa(B,B,aa(B,fun(B,B),F2,B3),Ca)) = aa(B,B,aa(B,fun(B,B),F2,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),Ca) ) ) ).

% ac_operator.left_assoc
tff(fact_75_ac__operator_Oright__assoc,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A4: B,B3: B,Ca: B] :
      ( syntax_ac_operator(B,F2)
     => ( aa(B,B,aa(B,fun(B,B),F2,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),F2,A4),aa(B,B,aa(B,fun(B,B),F2,B3),Ca)) ) ) ).

% ac_operator.right_assoc
tff(fact_76_ac__operator_Oleft__commute,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A4: B,B3: B,Ca: B] :
      ( syntax_ac_operator(B,F2)
     => ( aa(B,B,aa(B,fun(B,B),F2,A4),aa(B,B,aa(B,fun(B,B),F2,B3),Ca)) = aa(B,B,aa(B,fun(B,B),F2,B3),aa(B,B,aa(B,fun(B,B),F2,A4),Ca)) ) ) ).

% ac_operator.left_commute
tff(fact_77_ac__operator_Oright__commute,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A4: B,B3: B,Ca: B] :
      ( syntax_ac_operator(B,F2)
     => ( aa(B,B,aa(B,fun(B,B),F2,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),F2,aa(B,B,aa(B,fun(B,B),F2,A4),Ca)),B3) ) ) ).

% ac_operator.right_commute
tff(fact_78_ac__operator__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( syntax_ac_operator(B,F2)
    <=> ( ! [A6: B,B5: B,C4: B] : ( aa(B,B,aa(B,fun(B,B),F2,aa(B,B,aa(B,fun(B,B),F2,A6),B5)),C4) = aa(B,B,aa(B,fun(B,B),F2,A6),aa(B,B,aa(B,fun(B,B),F2,B5),C4)) )
        & ! [A6: B,B5: B] : ( aa(B,B,aa(B,fun(B,B),F2,A6),B5) = aa(B,B,aa(B,fun(B,B),F2,B5),A6) ) ) ) ).

% ac_operator_def
tff(fact_79_preciseD_H,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,assn)),A4: B,P3: C,F: assn,H2: product_prod(heap_ext(product_unit),set(nat)),A7: B,F3: assn] :
      ( precise(B,C,R)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A4),P3)),F)),H2)
       => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A7),P3)),F3)),H2)
         => ( A4 = A7 ) ) ) ) ).

% preciseD'
tff(fact_80_mod__starE,axiom,
    ! [A4: assn,B3: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),B3)),H2)
     => ~ ( ? [X_1: product_prod(heap_ext(product_unit),set(nat))] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,A4),X_1)
         => ! [H_2: product_prod(heap_ext(product_unit),set(nat))] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,B3),H_2) ) ) ).

% mod_starE
tff(fact_81_mod__starD,axiom,
    ! [A3: assn,B2: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),B2)),H2)
     => ? [H1: product_prod(heap_ext(product_unit),set(nat)),H22: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,A3),H1)
          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,B2),H22) ) ) ).

% mod_starD
tff(fact_82_entails__def,axiom,
    ! [Pa: assn,Qa: assn] :
      ( entails(Pa,Qa)
    <=> ! [H: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H)
         => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H) ) ) ).

% entails_def
tff(fact_83_entailsI,axiom,
    ! [Pa: assn,Qa: assn] :
      ( ! [H4: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H4)
         => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H4) )
     => entails(Pa,Qa) ) ).

% entailsI
tff(fact_84_entailsD,axiom,
    ! [Pa: assn,Qa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( entails(Pa,Qa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H2) ) ) ).

% entailsD
tff(fact_85_ent__fwd,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat)),Qa: assn] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
     => ( entails(Pa,Qa)
       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H2) ) ) ).

% ent_fwd
tff(fact_86_mult_Ocomm__neutral,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),one_one(B)) = A4 ) ) ).

% mult.comm_neutral
tff(fact_87_comm__monoid__mult__class_Omult__1,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),one_one(B)),A4) = A4 ) ) ).

% comm_monoid_mult_class.mult_1
tff(fact_88_hoare__triple__preI,axiom,
    ! [B: $tType,Pa: assn,Ca: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( ! [H4: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H4)
         => hoare_hoare_triple(B,Pa,Ca,Qa) )
     => hoare_hoare_triple(B,Pa,Ca,Qa) ) ).

% hoare_triple_preI
tff(fact_89_assn__one__left,axiom,
    ! [Pa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),one_one(assn)),Pa) = Pa ) ).

% assn_one_left
tff(fact_90_is__pure__assn__basic__simps_I2_J,axiom,
    is_pure_assn(one_one(assn)) ).

% is_pure_assn_basic_simps(2)
tff(fact_91_mult_Oac__operator__axioms,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => syntax_ac_operator(B,times_times(B)) ) ).

% mult.ac_operator_axioms
tff(fact_92_lambda__one,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ( aTP_Lamp_af(B,B) = aa(B,fun(B,B),times_times(B),one_one(B)) ) ) ).

% lambda_one
tff(fact_93_precise__def,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,assn))] :
      ( precise(B,C,R)
    <=> ! [A6: B,A8: B,H: product_prod(heap_ext(product_unit),set(nat)),P4: C,F4: assn,F5: assn] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A6),P4)),F4)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A8),P4)),F5))),H)
         => ( A6 = A8 ) ) ) ).

% precise_def
tff(fact_94_preciseI,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,assn))] :
      ( ! [A5: B,A9: B,H4: product_prod(heap_ext(product_unit),set(nat)),P5: C,F6: assn,F7: assn] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A5),P5)),F6)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A9),P5)),F7))),H4)
         => ( A5 = A9 ) )
     => precise(B,C,R) ) ).

% preciseI
tff(fact_95_preciseD,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,assn)),A4: B,P3: C,F: assn,A7: B,F3: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( precise(B,C,R)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A4),P3)),F)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A7),P3)),F3))),H2)
       => ( A4 = A7 ) ) ) ).

% preciseD
tff(fact_96_mod__true,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,top_top(assn)),H2)
    <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,H2) ) ).

% mod_true
tff(fact_97_mult_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => monoid(B,times_times(B),one_one(B)) ) ).

% mult.monoid_axioms
tff(fact_98_ent__false__iff,axiom,
    ! [Pa: assn] :
      ( entails(Pa,bot_bot(assn))
    <=> ! [H: product_prod(heap_ext(product_unit),set(nat))] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H) ) ).

% ent_false_iff
tff(fact_99_mult_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => comm_monoid(B,times_times(B),one_one(B)) ) ).

% mult.comm_monoid_axioms
tff(fact_100_Rep__assn__inverse,axiom,
    ! [X2: assn] : ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,X2)) = X2 ) ).

% Rep_assn_inverse
tff(fact_101_wand__assn__def,axiom,
    ! [Pa: assn,Qa: assn] : ( wand_assn(Pa,Qa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,wand_raw(aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa))) ) ).

% wand_assn_def
tff(fact_102_prod_Ocomm__monoid__list__set__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => groups4802862169904069756st_set(B,times_times(B),one_one(B)) ) ).

% prod.comm_monoid_list_set_axioms
tff(fact_103_syntax__nomatch__def,axiom,
    ! [B: $tType,C: $tType,Pat: B,Obj: C] : syntax2379306206330768139omatch(B,C,Pat,Obj) ).

% syntax_nomatch_def
tff(fact_104_bot__apply,axiom,
    ! [C: $tType,B: $tType] :
      ( bot(B)
     => ! [X2: C] : ( aa(C,B,bot_bot(fun(C,B)),X2) = bot_bot(B) ) ) ).

% bot_apply
tff(fact_105_star__false__left,axiom,
    ! [Pa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),bot_bot(assn)),Pa) = bot_bot(assn) ) ).

% star_false_left
tff(fact_106_star__false__right,axiom,
    ! [Pa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),bot_bot(assn)) = bot_bot(assn) ) ).

% star_false_right
tff(fact_107_pure__false,axiom,
    pure_assn($false) = bot_bot(assn) ).

% pure_false
tff(fact_108_pure__assn__eq__false__iff,axiom,
    ! [Pa: $o] :
      ( ( pure_assn(Pa) = bot_bot(assn) )
    <=> ~ (Pa) ) ).

% pure_assn_eq_false_iff
tff(fact_109_merge__pure__and,axiom,
    ! [A4: $o,B3: $o] :
      ( aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),pure_assn(A4)),pure_assn(B3))
      = pure_assn(
          (A4)
        & (B3)) ) ).

% merge_pure_and
tff(fact_110_assn__basic__inequalities_I5_J,axiom,
    top_top(assn) != bot_bot(assn) ).

% assn_basic_inequalities(5)
tff(fact_111_false__rule,axiom,
    ! [B: $tType,Ca: heap_Time_Heap(B),Qa: fun(B,assn)] : hoare_hoare_triple(B,bot_bot(assn),Ca,Qa) ).

% false_rule
tff(fact_112_assn__basic__inequalities_I3_J,axiom,
    bot_bot(assn) != one_one(assn) ).

% assn_basic_inequalities(3)
tff(fact_113_monoid_Oleft__neutral,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,A4: B] :
      ( monoid(B,F2,Z2)
     => ( aa(B,B,aa(B,fun(B,B),F2,Z2),A4) = A4 ) ) ).

% monoid.left_neutral
tff(fact_114_monoid_Oright__neutral,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,A4: B] :
      ( monoid(B,F2,Z2)
     => ( aa(B,B,aa(B,fun(B,B),F2,A4),Z2) = A4 ) ) ).

% monoid.right_neutral
tff(fact_115_comm__monoid_Ocomm__neutral,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,A4: B] :
      ( comm_monoid(B,F2,Z2)
     => ( aa(B,B,aa(B,fun(B,B),F2,A4),Z2) = A4 ) ) ).

% comm_monoid.comm_neutral
tff(fact_116_bot__fun__def,axiom,
    ! [B: $tType,C: $tType] :
      ( bot(C)
     => ! [X4: B] : ( aa(B,C,bot_bot(fun(B,C)),X4) = bot_bot(C) ) ) ).

% bot_fun_def
tff(fact_117_bot__assn__def,axiom,
    bot_bot(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aTP_Lamp_ag(product_prod(heap_ext(product_unit),set(nat)),$o)) ).

% bot_assn_def
tff(fact_118_top__assn__def,axiom,
    top_top(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,in_range) ).

% top_assn_def
tff(fact_119_inf__assn__def,axiom,
    ! [Pa: assn,Qa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),Pa),Qa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_ah(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Pa),Qa)) ) ).

% inf_assn_def
tff(fact_120_mod__and__dist,axiom,
    ! [Pa: assn,Qa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),Pa),Qa)),H2)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H2) ) ) ).

% mod_and_dist
tff(fact_121_mod__false,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,bot_bot(assn)),H2) ).

% mod_false
tff(fact_122_ent__conjI,axiom,
    ! [A3: assn,B2: assn,C2: assn] :
      ( entails(A3,B2)
     => ( entails(A3,C2)
       => entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),B2),C2)) ) ) ).

% ent_conjI
tff(fact_123_ent__conjE1,axiom,
    ! [A3: assn,C2: assn,B2: assn] :
      ( entails(A3,C2)
     => entails(aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A3),B2),C2) ) ).

% ent_conjE1
tff(fact_124_ent__conjE2,axiom,
    ! [B2: assn,C2: assn,A3: assn] :
      ( entails(B2,C2)
     => entails(aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A3),B2),C2) ) ).

% ent_conjE2
tff(fact_125_ent__false,axiom,
    ! [Pa: assn] : entails(bot_bot(assn),Pa) ).

% ent_false
tff(fact_126_models__in__range,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,H2) ) ).

% models_in_range
tff(fact_127_is__pure__assn__basic__simps_I1_J,axiom,
    is_pure_assn(bot_bot(assn)) ).

% is_pure_assn_basic_simps(1)
tff(fact_128_Abs__assn__eqI_I2_J,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pr: assn] :
      ( ! [H4: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,H4)
        <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pr),H4) )
     => ( Pr = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Pa) ) ) ).

% Abs_assn_eqI(2)
tff(fact_129_Abs__assn__eqI_I1_J,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pr: assn] :
      ( ! [H4: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,H4)
        <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pr),H4) )
     => ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Pa) = Pr ) ) ).

% Abs_assn_eqI(1)
tff(fact_130_ex__distrib__and,axiom,
    ! [B: $tType,Pa: fun(B,assn),Qa: assn] : ( ex_assn(B,aa(assn,fun(B,assn),aTP_Lamp_ai(fun(B,assn),fun(assn,fun(B,assn)),Pa),Qa)) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),ex_assn(B,Pa)),Qa) ) ).

% ex_distrib_and
tff(fact_131_inf__top__left,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),top_top(B)),X2) = X2 ) ) ).

% inf_top_left
tff(fact_132_inf__top__right,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),top_top(B)) = X2 ) ) ).

% inf_top_right
tff(fact_133_inf__eq__top__iff,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [X2: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) = top_top(B) )
        <=> ( ( X2 = top_top(B) )
            & ( Y = top_top(B) ) ) ) ) ).

% inf_eq_top_iff
tff(fact_134_top__eq__inf__iff,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [X2: B,Y: B] :
          ( ( top_top(B) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) )
        <=> ( ( X2 = top_top(B) )
            & ( Y = top_top(B) ) ) ) ) ).

% top_eq_inf_iff
tff(fact_135_inf__top_Oeq__neutr__iff,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) = top_top(B) )
        <=> ( ( A4 = top_top(B) )
            & ( B3 = top_top(B) ) ) ) ) ).

% inf_top.eq_neutr_iff
tff(fact_136_inf__top_Oleft__neutral,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),top_top(B)),A4) = A4 ) ) ).

% inf_top.left_neutral
tff(fact_137_inf__top_Oneutr__eq__iff,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [A4: B,B3: B] :
          ( ( top_top(B) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) )
        <=> ( ( A4 = top_top(B) )
            & ( B3 = top_top(B) ) ) ) ) ).

% inf_top.neutr_eq_iff
tff(fact_138_inf__top_Oright__neutral,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),top_top(B)) = A4 ) ) ).

% inf_top.right_neutral
tff(fact_139_boolean__algebra_Oconj__zero__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),bot_bot(B)) = bot_bot(B) ) ) ).

% boolean_algebra.conj_zero_right
tff(fact_140_boolean__algebra_Oconj__zero__left,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),bot_bot(B)),X2) = bot_bot(B) ) ) ).

% boolean_algebra.conj_zero_left
tff(fact_141_inf__bot__right,axiom,
    ! [B: $tType] :
      ( bounded_lattice_bot(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),bot_bot(B)) = bot_bot(B) ) ) ).

% inf_bot_right
tff(fact_142_inf__bot__left,axiom,
    ! [B: $tType] :
      ( bounded_lattice_bot(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),bot_bot(B)),X2) = bot_bot(B) ) ) ).

% inf_bot_left
tff(fact_143_inf_Oidem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),A4) = A4 ) ) ).

% inf.idem
tff(fact_144_inf__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),X2) = X2 ) ) ).

% inf_idem
tff(fact_145_inf_Oleft__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) ) ) ).

% inf.left_idem
tff(fact_146_inf__left__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) ) ) ).

% inf_left_idem
tff(fact_147_inf_Oright__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),B3) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) ) ) ).

% inf.right_idem
tff(fact_148_inf__right__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),Y) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) ) ) ).

% inf_right_idem
tff(fact_149_inf__apply,axiom,
    ! [B: $tType,C: $tType] :
      ( semilattice_inf(B)
     => ! [F2: fun(C,B),G: fun(C,B),X2: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),inf_inf(fun(C,B)),F2),G),X2) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,F2,X2)),aa(C,B,G,X2)) ) ) ).

% inf_apply
tff(fact_150_inf__sup__aci_I4_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) ) ) ).

% inf_sup_aci(4)
tff(fact_151_inf__sup__aci_I3_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Z2)) ) ) ).

% inf_sup_aci(3)
tff(fact_152_inf__sup__aci_I2_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),Z2) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) ) ) ).

% inf_sup_aci(2)
tff(fact_153_inf__sup__aci_I1_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),X2) ) ) ).

% inf_sup_aci(1)
tff(fact_154_inf_Oassoc,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),aa(B,B,aa(B,fun(B,B),inf_inf(B),B3),Ca)) ) ) ).

% inf.assoc
tff(fact_155_inf__assoc,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),Z2) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) ) ) ).

% inf_assoc
tff(fact_156_inf_Ocommute,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) = aa(B,B,aa(B,fun(B,B),inf_inf(B),B3),A4) ) ) ).

% inf.commute
tff(fact_157_inf__commute,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),X2) ) ) ).

% inf_commute
tff(fact_158_boolean__algebra__cancel_Oinf1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,K: B,A4: B,B3: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),inf_inf(B),K),A4) )
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),B3) = aa(B,B,aa(B,fun(B,B),inf_inf(B),K),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)) ) ) ) ).

% boolean_algebra_cancel.inf1
tff(fact_159_boolean__algebra__cancel_Oinf2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [B2: B,K: B,B3: B,A4: B] :
          ( ( B2 = aa(B,B,aa(B,fun(B,B),inf_inf(B),K),B3) )
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B2) = aa(B,B,aa(B,fun(B,B),inf_inf(B),K),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)) ) ) ) ).

% boolean_algebra_cancel.inf2
tff(fact_160_inf_Oleft__commute,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [B3: B,A4: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),B3),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),Ca)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),aa(B,B,aa(B,fun(B,B),inf_inf(B),B3),Ca)) ) ) ).

% inf.left_commute
tff(fact_161_inf__left__commute,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Z2)) ) ) ).

% inf_left_commute
tff(fact_162_inf__fun__def,axiom,
    ! [C: $tType,B: $tType] :
      ( semilattice_inf(C)
     => ! [F2: fun(B,C),G: fun(B,C),X4: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),inf_inf(fun(B,C)),F2),G),X4) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,F2,X4)),aa(B,C,G,X4)) ) ) ).

% inf_fun_def
tff(fact_163_boolean__algebra_Oconj__one__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),top_top(B)) = X2 ) ) ).

% boolean_algebra.conj_one_right
tff(fact_164_inf__top_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => comm_monoid(B,inf_inf(B),top_top(B)) ) ).

% inf_top.comm_monoid_axioms
tff(fact_165_inf__top_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => monoid(B,inf_inf(B),top_top(B)) ) ).

% inf_top.monoid_axioms
tff(fact_166_sngr__same__false,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [P3: ref(B),X2: B,Y: B] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),sngr_assn(B,P3,X2)),sngr_assn(B,P3,Y)) = bot_bot(assn) ) ) ).

% sngr_same_false
tff(fact_167_snga__same__false,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [P3: array(B),X2: list(B),Y: list(B)] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(B,P3,X2)),snga_assn(B,P3,Y)) = bot_bot(assn) ) ) ).

% snga_same_false
tff(fact_168_times__assn__def,axiom,
    ! [Pa: assn,Qa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,times_assn_raw(aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa))) ) ).

% times_assn_def
tff(fact_169_one__assn__def,axiom,
    one_one(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,one_assn_raw) ).

% one_assn_def
tff(fact_170_pure__assn__def,axiom,
    ! [B3: $o] : ( pure_assn(B3) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,pure_assn_raw(heap_ext(product_unit),nat,B3)) ) ).

% pure_assn_def
tff(fact_171_uminus__assn__def,axiom,
    ! [Pa: assn] : ( aa(assn,assn,uminus_uminus(assn),Pa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aTP_Lamp_aj(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa)) ) ).

% uminus_assn_def
tff(fact_172_ex__assn__def,axiom,
    ! [B: $tType,Pa: fun(B,assn)] : ( ex_assn(B,Pa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aTP_Lamp_ak(fun(B,assn),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa)) ) ).

% ex_assn_def
tff(fact_173_prod__list_Ocomm__monoid__list__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => groups1828464146339083142d_list(B,times_times(B),one_one(B)) ) ).

% prod_list.comm_monoid_list_axioms
tff(fact_174_mod__h__bot__iff_I8_J,axiom,
    ! [B: $tType,R: fun(B,assn),H2: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,ex_assn(B,R)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> ? [X3: B] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,R,X3)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ).

% mod_h_bot_iff(8)
tff(fact_175_monoid_Oaxioms_I2_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( monoid(B,F2,Z2)
     => monoid_axioms(B,F2,Z2) ) ).

% monoid.axioms(2)
tff(fact_176_prod__list_Omonoid__list__axioms,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => groups_monoid_list(B,times_times(B),one_one(B)) ) ).

% prod_list.monoid_list_axioms
tff(fact_177_comm__monoid_Oaxioms_I2_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid(B,F2,Z2)
     => comm_monoid_axioms(B,F2,Z2) ) ).

% comm_monoid.axioms(2)
tff(fact_178_boolean__algebra__class_Oboolean__algebra_Odouble__compl,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,uminus_uminus(B),X2)) = X2 ) ) ).

% boolean_algebra_class.boolean_algebra.double_compl
tff(fact_179_boolean__algebra__class_Oboolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] :
          ( ( aa(B,B,uminus_uminus(B),X2) = aa(B,B,uminus_uminus(B),Y) )
        <=> ( X2 = Y ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_eq_compl_iff
tff(fact_180_uminus__apply,axiom,
    ! [B: $tType,C: $tType] :
      ( uminus(B)
     => ! [A3: fun(C,B),X2: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),uminus_uminus(fun(C,B)),A3),X2) = aa(B,B,uminus_uminus(B),aa(C,B,A3,X2)) ) ) ).

% uminus_apply
tff(fact_181_add_Oinverse__inverse,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,uminus_uminus(B),A4)) = A4 ) ) ).

% add.inverse_inverse
tff(fact_182_neg__equal__iff__equal,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,uminus_uminus(B),A4) = aa(B,B,uminus_uminus(B),B3) )
        <=> ( A4 = B3 ) ) ) ).

% neg_equal_iff_equal
tff(fact_183_mult__minus__left,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),A4)),B3) = aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ) ).

% mult_minus_left
tff(fact_184_minus__mult__minus,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),A4)),aa(B,B,uminus_uminus(B),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3) ) ) ).

% minus_mult_minus
tff(fact_185_mult__minus__right,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,uminus_uminus(B),B3)) = aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ) ).

% mult_minus_right
tff(fact_186_boolean__algebra_Ocompl__one,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ( aa(B,B,uminus_uminus(B),top_top(B)) = bot_bot(B) ) ) ).

% boolean_algebra.compl_one
tff(fact_187_boolean__algebra_Ocompl__zero,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ( aa(B,B,uminus_uminus(B),bot_bot(B)) = top_top(B) ) ) ).

% boolean_algebra.compl_zero
tff(fact_188_boolean__algebra_Oconj__cancel__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,uminus_uminus(B),X2)) = bot_bot(B) ) ) ).

% boolean_algebra.conj_cancel_right
tff(fact_189_boolean__algebra_Oconj__cancel__left,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X2)),X2) = bot_bot(B) ) ) ).

% boolean_algebra.conj_cancel_left
tff(fact_190_inf__compl__bot__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),aa(B,B,uminus_uminus(B),X2))) = bot_bot(B) ) ) ).

% inf_compl_bot_right
tff(fact_191_inf__compl__bot__left2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X2)),Y)) = bot_bot(B) ) ) ).

% inf_compl_bot_left2
tff(fact_192_inf__compl__bot__left1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X2)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)) = bot_bot(B) ) ) ).

% inf_compl_bot_left1
tff(fact_193_in__range__empty,axiom,
    ! [H2: heap_ext(product_unit)] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ).

% in_range_empty
tff(fact_194_mod__not__dist,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,uminus_uminus(assn),Pa)),H2)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,H2)
        & ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2) ) ) ).

% mod_not_dist
tff(fact_195_mod__h__bot__iff_I5_J,axiom,
    ! [Pa: assn,Qa: assn,H2: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ) ).

% mod_h_bot_iff(5)
tff(fact_196_mod__h__bot__iff_I1_J,axiom,
    ! [B3: $o,H2: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,pure_assn(B3)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> (B3) ) ).

% mod_h_bot_iff(1)
tff(fact_197_mod__h__bot__iff_I6_J,axiom,
    ! [Pa: assn,Qa: assn,H2: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),Pa),Qa)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ) ).

% mod_h_bot_iff(6)
tff(fact_198_mod__h__bot__iff_I4_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Q: array(B),Y: list(B),H2: heap_ext(product_unit)] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,snga_assn(B,Q,Y)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ).

% mod_h_bot_iff(4)
tff(fact_199_mod__h__bot__iff_I3_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [P3: ref(B),X2: B,H2: heap_ext(product_unit)] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,sngr_assn(B,P3,X2)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ).

% mod_h_bot_iff(3)
tff(fact_200_one__assn__raw_Oelims_I3_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X2)
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( As = bot_bot(set(nat)) ) ) ) ).

% one_assn_raw.elims(3)
tff(fact_201_one__assn__raw_Oelims_I2_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X2)
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( As != bot_bot(set(nat)) ) ) ) ).

% one_assn_raw.elims(2)
tff(fact_202_one__assn__raw_Oelims_I1_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X2)
      <=> (Y) )
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( (Y)
            <=> ( As != bot_bot(set(nat)) ) ) ) ) ).

% one_assn_raw.elims(1)
tff(fact_203_pure__assn__raw_Oelims_I3_J,axiom,
    ! [C: $tType,B: $tType,X2: $o,Xa: product_prod(B,set(C))] :
      ( ~ aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X2),Xa)
     => ~ ! [H4: B,As: set(C)] :
            ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H4),As) )
           => ( ( As = bot_bot(set(C)) )
              & (X2) ) ) ) ).

% pure_assn_raw.elims(3)
tff(fact_204_pure__assn__raw_Oelims_I2_J,axiom,
    ! [C: $tType,B: $tType,X2: $o,Xa: product_prod(B,set(C))] :
      ( aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X2),Xa)
     => ~ ! [H4: B,As: set(C)] :
            ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H4),As) )
           => ~ ( ( As = bot_bot(set(C)) )
                & (X2) ) ) ) ).

% pure_assn_raw.elims(2)
tff(fact_205_pure__assn__raw_Oelims_I1_J,axiom,
    ! [C: $tType,B: $tType,X2: $o,Xa: product_prod(B,set(C)),Y: $o] :
      ( ( aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X2),Xa)
      <=> (Y) )
     => ~ ! [H4: B,As: set(C)] :
            ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H4),As) )
           => ( (Y)
            <=> ~ ( ( As = bot_bot(set(C)) )
                  & (X2) ) ) ) ) ).

% pure_assn_raw.elims(1)
tff(fact_206_one__assn__raw_Osimps,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
    <=> ( As2 = bot_bot(set(nat)) ) ) ).

% one_assn_raw.simps
tff(fact_207_pure__assn__raw_Osimps,axiom,
    ! [C: $tType,B: $tType,B3: $o,H2: B,As2: set(C)] :
      ( aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,B3),aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H2),As2))
    <=> ( ( As2 = bot_bot(set(C)) )
        & (B3) ) ) ).

% pure_assn_raw.simps
tff(fact_208_fun__Compl__def,axiom,
    ! [C: $tType,B: $tType] :
      ( uminus(C)
     => ! [A3: fun(B,C),X4: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),uminus_uminus(fun(B,C)),A3),X4) = aa(C,C,uminus_uminus(C),aa(B,C,A3,X4)) ) ) ).

% fun_Compl_def
tff(fact_209_one__assn__raw_Ocases,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ~ ! [H4: heap_ext(product_unit),As: set(nat)] : ( X2 != aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) ) ).

% one_assn_raw.cases
tff(fact_210_equation__minus__iff,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = aa(B,B,uminus_uminus(B),B3) )
        <=> ( B3 = aa(B,B,uminus_uminus(B),A4) ) ) ) ).

% equation_minus_iff
tff(fact_211_minus__equation__iff,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,uminus_uminus(B),A4) = B3 )
        <=> ( aa(B,B,uminus_uminus(B),B3) = A4 ) ) ) ).

% minus_equation_iff
tff(fact_212_comm__monoid__list_Oaxioms_I2_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups1828464146339083142d_list(B,F2,Z2)
     => groups_monoid_list(B,F2,Z2) ) ).

% comm_monoid_list.axioms(2)
tff(fact_213_comm__monoid__axioms__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid_axioms(B,F2,Z2)
    <=> ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),F2,A6),Z2) = A6 ) ) ).

% comm_monoid_axioms_def
tff(fact_214_monoid__axioms__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( monoid_axioms(B,F2,Z2)
    <=> ( ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),F2,Z2),A6) = A6 )
        & ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),F2,A6),Z2) = A6 ) ) ) ).

% monoid_axioms_def
tff(fact_215_comm__monoid__axioms_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( ! [A5: B] : ( aa(B,B,aa(B,fun(B,B),F2,A5),Z2) = A5 )
     => comm_monoid_axioms(B,F2,Z2) ) ).

% comm_monoid_axioms.intro
tff(fact_216_monoid__axioms_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( ! [A5: B] : ( aa(B,B,aa(B,fun(B,B),F2,Z2),A5) = A5 )
     => ( ! [A5: B] : ( aa(B,B,aa(B,fun(B,B),F2,A5),Z2) = A5 )
       => monoid_axioms(B,F2,Z2) ) ) ).

% monoid_axioms.intro
tff(fact_217_comm__monoid__list__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups1828464146339083142d_list(B,F2,Z2)
    <=> ( comm_monoid(B,F2,Z2)
        & groups_monoid_list(B,F2,Z2) ) ) ).

% comm_monoid_list_def
tff(fact_218_comm__monoid__list_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid(B,F2,Z2)
     => ( groups_monoid_list(B,F2,Z2)
       => groups1828464146339083142d_list(B,F2,Z2) ) ) ).

% comm_monoid_list.intro
tff(fact_219_square__eq__iff,axiom,
    ! [B: $tType] :
      ( idom(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),A4) = aa(B,B,aa(B,fun(B,B),times_times(B),B3),B3) )
        <=> ( ( A4 = B3 )
            | ( A4 = aa(B,B,uminus_uminus(B),B3) ) ) ) ) ).

% square_eq_iff
tff(fact_220_minus__mult__commute,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),A4)),B3) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,uminus_uminus(B),B3)) ) ) ).

% minus_mult_commute
tff(fact_221_mod__h__bot__indep,axiom,
    ! [Pa: assn,H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),bot_bot(set(nat)))) ) ).

% mod_h_bot_indep
tff(fact_222_sngr__prec,axiom,
    ! [B: $tType] :
      ( heap(B)
     => precise(B,ref(B),aTP_Lamp_al(B,fun(ref(B),assn))) ) ).

% sngr_prec
tff(fact_223_snga__prec,axiom,
    ! [B: $tType] :
      ( heap(B)
     => precise(list(B),array(B),aTP_Lamp_am(list(B),fun(array(B),assn))) ) ).

% snga_prec
tff(fact_224_square__eq__1__iff,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [X2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),X2),X2) = one_one(B) )
        <=> ( ( X2 = one_one(B) )
            | ( X2 = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ) ) ).

% square_eq_1_iff
tff(fact_225_inf__cancel__left2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X2)),A4)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),B3)) = bot_bot(B) ) ) ).

% inf_cancel_left2
tff(fact_226_inf__cancel__left1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),A4)),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X2)),B3)) = bot_bot(B) ) ) ).

% inf_cancel_left1
tff(fact_227_monoid__list__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups_monoid_list(B,F2,Z2)
    <=> monoid(B,F2,Z2) ) ).

% monoid_list_def
tff(fact_228_monoid__list_Oaxioms,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups_monoid_list(B,F2,Z2)
     => monoid(B,F2,Z2) ) ).

% monoid_list.axioms
tff(fact_229_monoid__list_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( monoid(B,F2,Z2)
     => groups_monoid_list(B,F2,Z2) ) ).

% monoid_list.intro
tff(fact_230_comm__monoid__list_Oaxioms_I1_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups1828464146339083142d_list(B,F2,Z2)
     => comm_monoid(B,F2,Z2) ) ).

% comm_monoid_list.axioms(1)
tff(fact_231_mod__h__bot__iff_I2_J,axiom,
    ! [H2: heap_ext(product_unit)] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,top_top(assn)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ).

% mod_h_bot_iff(2)
tff(fact_232_mod__emp__simp,axiom,
    ! [H2: heap_ext(product_unit)] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,one_one(assn)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ).

% mod_emp_simp
tff(fact_233_comm__monoid__list__set_Oaxioms_I1_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups4802862169904069756st_set(B,F2,Z2)
     => groups1828464146339083142d_list(B,F2,Z2) ) ).

% comm_monoid_list_set.axioms(1)
tff(fact_234_mult__minus1,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Z2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),one_one(B))),Z2) = aa(B,B,uminus_uminus(B),Z2) ) ) ).

% mult_minus1
tff(fact_235_mult__minus1__right,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Z2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),Z2),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),Z2) ) ) ).

% mult_minus1_right
tff(fact_236_Collect__const,axiom,
    ! [B: $tType,Pa: $o] :
      ( aa(fun(B,$o),set(B),collect(B),aTP_Lamp_an($o,fun(B,$o),Pa))
      = $ite((Pa),top_top(set(B)),bot_bot(set(B))) ) ).

% Collect_const
tff(fact_237_empty__Collect__eq,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ( bot_bot(set(B)) = aa(fun(B,$o),set(B),collect(B),Pa) )
    <=> ! [X3: B] : ~ aa(B,$o,Pa,X3) ) ).

% empty_Collect_eq
tff(fact_238_Collect__empty__eq,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ( aa(fun(B,$o),set(B),collect(B),Pa) = bot_bot(set(B)) )
    <=> ! [X3: B] : ~ aa(B,$o,Pa,X3) ) ).

% Collect_empty_eq
tff(fact_239_all__not__in__conv,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ! [X3: B] : ~ aa(set(B),$o,member(B,X3),A3)
    <=> ( A3 = bot_bot(set(B)) ) ) ).

% all_not_in_conv
tff(fact_240_empty__iff,axiom,
    ! [B: $tType,Ca: B] : ~ aa(set(B),$o,member(B,Ca),bot_bot(set(B))) ).

% empty_iff
tff(fact_241_one__neq__neg__one,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ( one_one(B) != aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% one_neq_neg_one
tff(fact_242_snga__assn__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R2: array(B),A4: list(B)] : ( snga_assn(B,R2,A4) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,snga_assn_raw(B,R2,A4)) ) ) ).

% snga_assn_def
tff(fact_243_sngr__assn__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R2: ref(B),X2: B] : ( sngr_assn(B,R2,X2) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,sngr_assn_raw(B,R2,X2)) ) ) ).

% sngr_assn_def
tff(fact_244_Set_Oempty__def,axiom,
    ! [B: $tType] : ( bot_bot(set(B)) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_ao(B,$o)) ) ).

% Set.empty_def
tff(fact_245_Compl__disjoint,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),uminus_uminus(set(B)),A3)) = bot_bot(set(B)) ) ).

% Compl_disjoint
tff(fact_246_Compl__disjoint2,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),uminus_uminus(set(B)),A3)),A3) = bot_bot(set(B)) ) ).

% Compl_disjoint2
tff(fact_247_Int__UNIV,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = top_top(set(B)) )
    <=> ( ( A3 = top_top(set(B)) )
        & ( B2 = top_top(set(B)) ) ) ) ).

% Int_UNIV
tff(fact_248_Int__UNIV__left,axiom,
    ! [B: $tType,B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),top_top(set(B))),B2) = B2 ) ).

% Int_UNIV_left
tff(fact_249_Int__UNIV__right,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),top_top(set(B))) = A3 ) ).

% Int_UNIV_right
tff(fact_250_Compl__empty__eq,axiom,
    ! [B: $tType] : ( aa(set(B),set(B),uminus_uminus(set(B)),bot_bot(set(B))) = top_top(set(B)) ) ).

% Compl_empty_eq
tff(fact_251_Compl__UNIV__eq,axiom,
    ! [B: $tType] : ( aa(set(B),set(B),uminus_uminus(set(B)),top_top(set(B))) = bot_bot(set(B)) ) ).

% Compl_UNIV_eq
tff(fact_252_emptyE,axiom,
    ! [B: $tType,A4: B] : ~ aa(set(B),$o,member(B,A4),bot_bot(set(B))) ).

% emptyE
tff(fact_253_equals0D,axiom,
    ! [B: $tType,A3: set(B),A4: B] :
      ( ( A3 = bot_bot(set(B)) )
     => ~ aa(set(B),$o,member(B,A4),A3) ) ).

% equals0D
tff(fact_254_equals0I,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ! [Y2: B] : ~ aa(set(B),$o,member(B,Y2),A3)
     => ( A3 = bot_bot(set(B)) ) ) ).

% equals0I
tff(fact_255_Int__emptyI,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),A3)
         => ~ aa(set(B),$o,member(B,X),B2) )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) ) ) ).

% Int_emptyI
tff(fact_256_ex__in__conv,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ? [X3: B] : aa(set(B),$o,member(B,X3),A3)
    <=> ( A3 != bot_bot(set(B)) ) ) ).

% ex_in_conv
tff(fact_257_bot__set__def,axiom,
    ! [B: $tType] : ( bot_bot(set(B)) = aa(fun(B,$o),set(B),collect(B),bot_bot(fun(B,$o))) ) ).

% bot_set_def
tff(fact_258_disjoint__iff,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),A3)
         => ~ aa(set(B),$o,member(B,X3),B2) ) ) ).

% disjoint_iff
tff(fact_259_Int__empty__left,axiom,
    ! [B: $tType,B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),bot_bot(set(B))),B2) = bot_bot(set(B)) ) ).

% Int_empty_left
tff(fact_260_Int__empty__right,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),bot_bot(set(B))) = bot_bot(set(B)) ) ).

% Int_empty_right
tff(fact_261_disjoint__iff__not__equal,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),A3)
         => ! [Xa2: B] :
              ( aa(set(B),$o,member(B,Xa2),B2)
             => ( X3 != Xa2 ) ) ) ) ).

% disjoint_iff_not_equal
tff(fact_262_empty__not__UNIV,axiom,
    ! [B: $tType] : ( bot_bot(set(B)) != top_top(set(B)) ) ).

% empty_not_UNIV
tff(fact_263_dbl__inc__simps_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_inc(B,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% dbl_inc_simps(4)
tff(fact_264_Set_Ois__empty__def,axiom,
    ! [B: $tType,A3: set(B)] :
      ( is_empty(B,A3)
    <=> ( A3 = bot_bot(set(B)) ) ) ).

% Set.is_empty_def
tff(fact_265_pred__equals__eq2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S: set(product_prod(B,C))] :
      ( ! [X3: B,Xa2: C] :
          ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa2)),R)
        <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa2)),S) )
    <=> ( R = S ) ) ).

% pred_equals_eq2
tff(fact_266_top__empty__eq2,axiom,
    ! [C: $tType,B: $tType,X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),top_top(fun(B,fun(C,$o))),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),top_top(set(product_prod(B,C)))) ) ).

% top_empty_eq2
tff(fact_267_inf__Int__eq2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S: set(product_prod(B,C)),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),R)),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),S)),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),R),S)) ) ).

% inf_Int_eq2
tff(fact_268_bot__empty__eq2,axiom,
    ! [C: $tType,B: $tType,X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),bot_bot(fun(B,fun(C,$o))),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),bot_bot(set(product_prod(B,C)))) ) ).

% bot_empty_eq2
tff(fact_269_hoare__triple__success,axiom,
    ! [B: $tType,Pa: assn,Ca: heap_Time_Heap(B),Qa: fun(B,assn),H2: heap_ext(product_unit),As2: set(nat)] :
      ( hoare_hoare_triple(B,Pa,Ca,Qa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
       => heap_Time_success(B,Ca,H2) ) ) ).

% hoare_triple_success
tff(fact_270_mod__star__conv,axiom,
    ! [A3: assn,B2: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),B2)),H2)
    <=> ? [Hr: heap_ext(product_unit),As1: set(nat),As22: set(nat)] :
          ( ( H2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22)) )
          & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,A3),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),As1))
          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,B2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),As22)) ) ) ).

% mod_star_conv
tff(fact_271_star__assnI,axiom,
    ! [Pa: assn,H2: heap_ext(product_unit),As2: set(nat),Qa: assn,As3: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3))
       => ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As3) = bot_bot(set(nat)) )
         => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As3))) ) ) ) ).

% star_assnI
tff(fact_272_mod__pure,axiom,
    ! [B3: $o,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,pure_assn(B3)),H2)
    <=> ( ( aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2) = bot_bot(set(nat)) )
        & (B3) ) ) ).

% mod_pure
tff(fact_273_mod__h__bot__iff_I7_J,axiom,
    ! [Pa: assn,Qa: assn,H2: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),Pa),Qa)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
        | aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ) ).

% mod_h_bot_iff(7)
tff(fact_274_sup_Oidem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),A4) = A4 ) ) ).

% sup.idem
tff(fact_275_sup__idem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),X2) = X2 ) ) ).

% sup_idem
tff(fact_276_sup_Oleft__idem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) ) ) ).

% sup.left_idem
tff(fact_277_sup__left__idem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) ) ) ).

% sup_left_idem
tff(fact_278_sup_Oright__idem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)),B3) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) ) ) ).

% sup.right_idem
tff(fact_279_sup__apply,axiom,
    ! [B: $tType,C: $tType] :
      ( semilattice_sup(B)
     => ! [F2: fun(C,B),G: fun(C,B),X2: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),sup_sup(fun(C,B)),F2),G),X2) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,F2,X2)),aa(C,B,G,X2)) ) ) ).

% sup_apply
tff(fact_280_Int__iff,axiom,
    ! [B: $tType,Ca: B,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,member(B,Ca),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))
    <=> ( aa(set(B),$o,member(B,Ca),A3)
        & aa(set(B),$o,member(B,Ca),B2) ) ) ).

% Int_iff
tff(fact_281_IntI,axiom,
    ! [B: $tType,Ca: B,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,member(B,Ca),A3)
     => ( aa(set(B),$o,member(B,Ca),B2)
       => aa(set(B),$o,member(B,Ca),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ) ).

% IntI
tff(fact_282_inf2I,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o)),X2: B,Y: C,B2: fun(B,fun(C,$o))] :
      ( aa(C,$o,aa(B,fun(C,$o),A3,X2),Y)
     => ( aa(C,$o,aa(B,fun(C,$o),B2,X2),Y)
       => aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),A3),B2),X2),Y) ) ) ).

% inf2I
tff(fact_283_sup__bot_Oright__neutral,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),bot_bot(B)) = A4 ) ) ).

% sup_bot.right_neutral
tff(fact_284_sup__bot_Oneutr__eq__iff,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [A4: B,B3: B] :
          ( ( bot_bot(B) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) )
        <=> ( ( A4 = bot_bot(B) )
            & ( B3 = bot_bot(B) ) ) ) ) ).

% sup_bot.neutr_eq_iff
tff(fact_285_sup__bot_Oleft__neutral,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),bot_bot(B)),A4) = A4 ) ) ).

% sup_bot.left_neutral
tff(fact_286_sup__bot_Oeq__neutr__iff,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) = bot_bot(B) )
        <=> ( ( A4 = bot_bot(B) )
            & ( B3 = bot_bot(B) ) ) ) ) ).

% sup_bot.eq_neutr_iff
tff(fact_287_sup__eq__bot__iff,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [X2: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) = bot_bot(B) )
        <=> ( ( X2 = bot_bot(B) )
            & ( Y = bot_bot(B) ) ) ) ) ).

% sup_eq_bot_iff
tff(fact_288_bot__eq__sup__iff,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [X2: B,Y: B] :
          ( ( bot_bot(B) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) )
        <=> ( ( X2 = bot_bot(B) )
            & ( Y = bot_bot(B) ) ) ) ) ).

% bot_eq_sup_iff
tff(fact_289_sup__bot__right,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),bot_bot(B)) = X2 ) ) ).

% sup_bot_right
tff(fact_290_sup__bot__left,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),bot_bot(B)),X2) = X2 ) ) ).

% sup_bot_left
tff(fact_291_sup__top__left,axiom,
    ! [B: $tType] :
      ( bounded_lattice_top(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),top_top(B)),X2) = top_top(B) ) ) ).

% sup_top_left
tff(fact_292_sup__top__right,axiom,
    ! [B: $tType] :
      ( bounded_lattice_top(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),top_top(B)) = top_top(B) ) ) ).

% sup_top_right
tff(fact_293_boolean__algebra_Odisj__one__left,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),top_top(B)),X2) = top_top(B) ) ) ).

% boolean_algebra.disj_one_left
tff(fact_294_boolean__algebra_Odisj__one__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),top_top(B)) = top_top(B) ) ) ).

% boolean_algebra.disj_one_right
tff(fact_295_sup__inf__absorb,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)) = X2 ) ) ).

% sup_inf_absorb
tff(fact_296_inf__sup__absorb,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)) = X2 ) ) ).

% inf_sup_absorb
tff(fact_297_Un__empty,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2) = bot_bot(set(B)) )
    <=> ( ( A3 = bot_bot(set(B)) )
        & ( B2 = bot_bot(set(B)) ) ) ) ).

% Un_empty
tff(fact_298_Un__Int__eq_I1_J,axiom,
    ! [B: $tType,S: set(B),T2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S),T2)),S) = S ) ).

% Un_Int_eq(1)
tff(fact_299_Un__Int__eq_I2_J,axiom,
    ! [B: $tType,S: set(B),T2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S),T2)),T2) = T2 ) ).

% Un_Int_eq(2)
tff(fact_300_Un__Int__eq_I3_J,axiom,
    ! [B: $tType,S: set(B),T2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S),T2)) = S ) ).

% Un_Int_eq(3)
tff(fact_301_Un__Int__eq_I4_J,axiom,
    ! [B: $tType,T2: set(B),S: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),T2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S),T2)) = T2 ) ).

% Un_Int_eq(4)
tff(fact_302_Int__Un__eq_I1_J,axiom,
    ! [B: $tType,S: set(B),T2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),T2)),S) = S ) ).

% Int_Un_eq(1)
tff(fact_303_Int__Un__eq_I2_J,axiom,
    ! [B: $tType,S: set(B),T2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),T2)),T2) = T2 ) ).

% Int_Un_eq(2)
tff(fact_304_Int__Un__eq_I3_J,axiom,
    ! [B: $tType,S: set(B),T2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),T2)) = S ) ).

% Int_Un_eq(3)
tff(fact_305_Int__Un__eq_I4_J,axiom,
    ! [B: $tType,T2: set(B),S: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),T2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),T2)) = T2 ) ).

% Int_Un_eq(4)
tff(fact_306_mod__or__dist,axiom,
    ! [Pa: assn,Qa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),Pa),Qa)),H2)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
        | aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H2) ) ) ).

% mod_or_dist
tff(fact_307_merge__pure__or,axiom,
    ! [A4: $o,B3: $o] :
      ( aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),pure_assn(A4)),pure_assn(B3))
      = pure_assn(
          (A4)
        | (B3)) ) ).

% merge_pure_or
tff(fact_308_sup__compl__top__left1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X2)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)) = top_top(B) ) ) ).

% sup_compl_top_left1
tff(fact_309_sup__compl__top__left2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X2)),Y)) = top_top(B) ) ) ).

% sup_compl_top_left2
tff(fact_310_boolean__algebra_Odisj__cancel__left,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X2)),X2) = top_top(B) ) ) ).

% boolean_algebra.disj_cancel_left
tff(fact_311_boolean__algebra_Odisj__cancel__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,uminus_uminus(B),X2)) = top_top(B) ) ) ).

% boolean_algebra.disj_cancel_right
tff(fact_312_boolean__algebra_Ode__Morgan__conj,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X2)),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% boolean_algebra.de_Morgan_conj
tff(fact_313_boolean__algebra_Ode__Morgan__disj,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X2)),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% boolean_algebra.de_Morgan_disj
tff(fact_314_in__range__dist__union,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat),As3: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As3)))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3)) ) ) ).

% in_range_dist_union
tff(fact_315_bot2E,axiom,
    ! [B: $tType,C: $tType,X2: B,Y: C] : ~ aa(C,$o,aa(B,fun(C,$o),bot_bot(fun(B,fun(C,$o))),X2),Y) ).

% bot2E
tff(fact_316_Int__left__commute,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),C2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),C2)) ) ).

% Int_left_commute
tff(fact_317_Un__Int__distrib2,axiom,
    ! [B: $tType,B2: set(B),C2: set(B),A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2)),A3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),A3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),C2),A3)) ) ).

% Un_Int_distrib2
tff(fact_318_Int__left__absorb,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) ) ).

% Int_left_absorb
tff(fact_319_Int__Un__distrib2,axiom,
    ! [B: $tType,B2: set(B),C2: set(B),A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),C2)),A3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),A3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C2),A3)) ) ).

% Int_Un_distrib2
tff(fact_320_Collect__conj__eq,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] : ( aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(fun(B,$o),set(B),collect(B),Pa)),aa(fun(B,$o),set(B),collect(B),Qa)) ) ).

% Collect_conj_eq
tff(fact_321_Un__Int__distrib,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),C2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),C2)) ) ).

% Un_Int_distrib
tff(fact_322_Int__Un__distrib,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),C2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),C2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),C2)) ) ).

% Int_Un_distrib
tff(fact_323_Un__Int__crazy,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),C2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C2),A3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),C2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),C2),A3)) ) ).

% Un_Int_crazy
tff(fact_324_inf__set__def,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),B2))) ) ).

% inf_set_def
tff(fact_325_Int__commute,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),A3) ) ).

% Int_commute
tff(fact_326_Int__Collect,axiom,
    ! [B: $tType,X2: B,A3: set(B),Pa: fun(B,$o)] :
      ( aa(set(B),$o,member(B,X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,$o),set(B),collect(B),Pa)))
    <=> ( aa(set(B),$o,member(B,X2),A3)
        & aa(B,$o,Pa,X2) ) ) ).

% Int_Collect
tff(fact_327_Int__absorb,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),A3) = A3 ) ).

% Int_absorb
tff(fact_328_Int__assoc,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),C2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)),C2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2)) ) ).

% Int_assoc
tff(fact_329_Compl__Int,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),uminus_uminus(set(B)),A3)),aa(set(B),set(B),uminus_uminus(set(B)),B2)) ) ).

% Compl_Int
tff(fact_330_Compl__Un,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),uminus_uminus(set(B)),A3)),aa(set(B),set(B),uminus_uminus(set(B)),B2)) ) ).

% Compl_Un
tff(fact_331_Int__def,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_ar(set(B),fun(set(B),fun(B,$o)),A3),B2)) ) ).

% Int_def
tff(fact_332_IntD2,axiom,
    ! [B: $tType,Ca: B,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,member(B,Ca),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))
     => aa(set(B),$o,member(B,Ca),B2) ) ).

% IntD2
tff(fact_333_IntD1,axiom,
    ! [B: $tType,Ca: B,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,member(B,Ca),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))
     => aa(set(B),$o,member(B,Ca),A3) ) ).

% IntD1
tff(fact_334_IntE,axiom,
    ! [B: $tType,Ca: B,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,member(B,Ca),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))
     => ~ ( aa(set(B),$o,member(B,Ca),A3)
         => ~ aa(set(B),$o,member(B,Ca),B2) ) ) ).

% IntE
tff(fact_335_uminus__set__def,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),uminus_uminus(set(B)),A3) = aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),uminus_uminus(fun(B,$o)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3))) ) ).

% uminus_set_def
tff(fact_336_Collect__neg__eq,axiom,
    ! [B: $tType,Pa: fun(B,$o)] : ( aa(fun(B,$o),set(B),collect(B),aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa)) = aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,$o),set(B),collect(B),Pa)) ) ).

% Collect_neg_eq
tff(fact_337_Compl__eq,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),uminus_uminus(set(B)),A3) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_at(set(B),fun(B,$o),A3)) ) ).

% Compl_eq
tff(fact_338_inf__sup__aci_I8_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) ) ) ).

% inf_sup_aci(8)
tff(fact_339_inf__sup__aci_I7_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Z2)) ) ) ).

% inf_sup_aci(7)
tff(fact_340_inf__sup__aci_I6_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)),Z2) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) ) ) ).

% inf_sup_aci(6)
tff(fact_341_inf__sup__aci_I5_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),X2) ) ) ).

% inf_sup_aci(5)
tff(fact_342_sup_Oassoc,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),aa(B,B,aa(B,fun(B,B),sup_sup(B),B3),Ca)) ) ) ).

% sup.assoc
tff(fact_343_sup__assoc,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)),Z2) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) ) ) ).

% sup_assoc
tff(fact_344_sup_Ocommute,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) = aa(B,B,aa(B,fun(B,B),sup_sup(B),B3),A4) ) ) ).

% sup.commute
tff(fact_345_sup__commute,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),X2) ) ) ).

% sup_commute
tff(fact_346_boolean__algebra__cancel_Osup1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,K: B,A4: B,B3: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),sup_sup(B),K),A4) )
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),B3) = aa(B,B,aa(B,fun(B,B),sup_sup(B),K),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ) ) ).

% boolean_algebra_cancel.sup1
tff(fact_347_boolean__algebra__cancel_Osup2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B2: B,K: B,B3: B,A4: B] :
          ( ( B2 = aa(B,B,aa(B,fun(B,B),sup_sup(B),K),B3) )
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B2) = aa(B,B,aa(B,fun(B,B),sup_sup(B),K),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ) ) ).

% boolean_algebra_cancel.sup2
tff(fact_348_sup_Oleft__commute,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,A4: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),B3),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),Ca)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),aa(B,B,aa(B,fun(B,B),sup_sup(B),B3),Ca)) ) ) ).

% sup.left_commute
tff(fact_349_sup__left__commute,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Z2)) ) ) ).

% sup_left_commute
tff(fact_350_sup__fun__def,axiom,
    ! [C: $tType,B: $tType] :
      ( semilattice_sup(C)
     => ! [F2: fun(B,C),G: fun(B,C),X4: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),sup_sup(fun(B,C)),F2),G),X4) = aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(B,C,F2,X4)),aa(B,C,G,X4)) ) ) ).

% sup_fun_def
tff(fact_351_inf__Int__eq,axiom,
    ! [B: $tType,R: set(B),S: set(B),X4: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),R)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),S)),X4)
    <=> aa(set(B),$o,member(B,X4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),R),S)) ) ).

% inf_Int_eq
tff(fact_352_inf2E,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o)),B2: fun(B,fun(C,$o)),X2: B,Y: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),A3),B2),X2),Y)
     => ~ ( aa(C,$o,aa(B,fun(C,$o),A3,X2),Y)
         => ~ aa(C,$o,aa(B,fun(C,$o),B2,X2),Y) ) ) ).

% inf2E
tff(fact_353_inf2D1,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o)),B2: fun(B,fun(C,$o)),X2: B,Y: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),A3),B2),X2),Y)
     => aa(C,$o,aa(B,fun(C,$o),A3,X2),Y) ) ).

% inf2D1
tff(fact_354_inf2D2,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o)),B2: fun(B,fun(C,$o)),X2: B,Y: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),A3),B2),X2),Y)
     => aa(C,$o,aa(B,fun(C,$o),B2,X2),Y) ) ).

% inf2D2
tff(fact_355_times__assn__raw_Ocases,axiom,
    ! [X2: product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))] :
      ~ ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Q2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),H4: heap_ext(product_unit),As: set(nat)] : ( X2 != aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),P),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Q2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ).

% times_assn_raw.cases
tff(fact_356_sngr__assn__raw_Ocases,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))] :
          ~ ! [R3: ref(B),X: B,H4: heap_ext(product_unit),As: set(nat)] : ( X2 != aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),R3),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),X),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ) ).

% sngr_assn_raw.cases
tff(fact_357_snga__assn__raw_Ocases,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))] :
          ~ ! [R3: array(B),X: list(B),H4: heap_ext(product_unit),As: set(nat)] : ( X2 != aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),R3),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),X),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ) ).

% snga_assn_raw.cases
tff(fact_358_Collect__disj__eq,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] : ( aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_au(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(fun(B,$o),set(B),collect(B),Pa)),aa(fun(B,$o),set(B),collect(B),Qa)) ) ).

% Collect_disj_eq
tff(fact_359_Un__def,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_av(set(B),fun(set(B),fun(B,$o)),A3),B2)) ) ).

% Un_def
tff(fact_360_Collect__imp__eq,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] : ( aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_aw(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,$o),set(B),collect(B),Pa))),aa(fun(B,$o),set(B),collect(B),Qa)) ) ).

% Collect_imp_eq
tff(fact_361_boolean__algebra_Odisj__zero__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),bot_bot(B)) = X2 ) ) ).

% boolean_algebra.disj_zero_right
tff(fact_362_boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,Z2: B,X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)),X2) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),X2)),aa(B,B,aa(B,fun(B,B),sup_sup(B),Z2),X2)) ) ) ).

% boolean_algebra.disj_conj_distrib2
tff(fact_363_boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,Z2: B,X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)),X2) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),X2)),aa(B,B,aa(B,fun(B,B),inf_inf(B),Z2),X2)) ) ) ).

% boolean_algebra.conj_disj_distrib2
tff(fact_364_boolean__algebra_Odisj__conj__distrib,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Z2)) ) ) ).

% boolean_algebra.disj_conj_distrib
tff(fact_365_boolean__algebra_Oconj__disj__distrib,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Z2)) ) ) ).

% boolean_algebra.conj_disj_distrib
tff(fact_366_sup__inf__distrib2,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Y: B,Z2: B,X2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)),X2) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),X2)),aa(B,B,aa(B,fun(B,B),sup_sup(B),Z2),X2)) ) ) ).

% sup_inf_distrib2
tff(fact_367_sup__inf__distrib1,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Z2)) ) ) ).

% sup_inf_distrib1
tff(fact_368_inf__sup__distrib2,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Y: B,Z2: B,X2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)),X2) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),X2)),aa(B,B,aa(B,fun(B,B),inf_inf(B),Z2),X2)) ) ) ).

% inf_sup_distrib2
tff(fact_369_inf__sup__distrib1,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Z2)) ) ) ).

% inf_sup_distrib1
tff(fact_370_distrib__imp2,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( ! [X: B,Y2: B,Z3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y2),Z3)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y2)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Z3)) )
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Z2)) ) ) ) ).

% distrib_imp2
tff(fact_371_distrib__imp1,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( ! [X: B,Y2: B,Z3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y2),Z3)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y2)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Z3)) )
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Z2)) ) ) ) ).

% distrib_imp1
tff(fact_372_Un__empty__right,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),bot_bot(set(B))) = A3 ) ).

% Un_empty_right
tff(fact_373_Un__empty__left,axiom,
    ! [B: $tType,B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),bot_bot(set(B))),B2) = B2 ) ).

% Un_empty_left
tff(fact_374_pure__assn__raw_Ocases,axiom,
    ! [B: $tType,C: $tType,X2: product_prod($o,product_prod(B,set(C)))] :
      ~ ! [B4: $o,H4: B,As: set(C)] : ( X2 != aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),B4),aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H4),As)) ) ).

% pure_assn_raw.cases
tff(fact_375_star__or__dist1,axiom,
    ! [A3: assn,B2: assn,C2: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)),C2) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),C2)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),C2)) ) ).

% star_or_dist1
tff(fact_376_star__or__dist2,axiom,
    ! [C2: assn,A3: assn,B2: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C2),aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C2),A3)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C2),B2)) ) ).

% star_or_dist2
tff(fact_377_ent__disjE,axiom,
    ! [A3: assn,C2: assn,B2: assn] :
      ( entails(A3,C2)
     => ( entails(B2,C2)
       => entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2),C2) ) ) ).

% ent_disjE
tff(fact_378_ent__disjI1,axiom,
    ! [Pa: assn,Qa: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),Pa),Qa),R)
     => entails(Pa,R) ) ).

% ent_disjI1
tff(fact_379_ent__disjI2,axiom,
    ! [Pa: assn,Qa: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),Pa),Qa),R)
     => entails(Qa,R) ) ).

% ent_disjI2
tff(fact_380_ent__disjI1_H,axiom,
    ! [A3: assn,B2: assn,C2: assn] :
      ( entails(A3,B2)
     => entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C2)) ) ).

% ent_disjI1'
tff(fact_381_ent__disjI2_H,axiom,
    ! [A3: assn,C2: assn,B2: assn] :
      ( entails(A3,C2)
     => entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C2)) ) ).

% ent_disjI2'
tff(fact_382_ent__disjI1__direct,axiom,
    ! [A3: assn,B2: assn] : entails(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)) ).

% ent_disjI1_direct
tff(fact_383_ent__disjI2__direct,axiom,
    ! [B2: assn,A3: assn] : entails(B2,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)) ).

% ent_disjI2_direct
tff(fact_384_entt__disjE,axiom,
    ! [A3: assn,M: assn,B2: assn] :
      ( entailst(A3,M)
     => ( entailst(B2,M)
       => entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2),M) ) ) ).

% entt_disjE
tff(fact_385_entt__disjD1,axiom,
    ! [A3: assn,B2: assn,C2: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2),C2)
     => entailst(A3,C2) ) ).

% entt_disjD1
tff(fact_386_entt__disjD2,axiom,
    ! [A3: assn,B2: assn,C2: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2),C2)
     => entailst(B2,C2) ) ).

% entt_disjD2
tff(fact_387_entt__disjI1_H,axiom,
    ! [A3: assn,B2: assn,C2: assn] :
      ( entailst(A3,B2)
     => entailst(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C2)) ) ).

% entt_disjI1'
tff(fact_388_entt__disjI2_H,axiom,
    ! [A3: assn,C2: assn,B2: assn] :
      ( entailst(A3,C2)
     => entailst(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C2)) ) ).

% entt_disjI2'
tff(fact_389_entt__disjI1__direct,axiom,
    ! [A3: assn,B2: assn] : entailst(A3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)) ).

% entt_disjI1_direct
tff(fact_390_entt__disjI2__direct,axiom,
    ! [B2: assn,A3: assn] : entailst(B2,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A3),B2)) ).

% entt_disjI2_direct
tff(fact_391_ex__join__or,axiom,
    ! [B: $tType,Pa: fun(B,assn),Qa: fun(B,assn)] : ( ex_assn(B,aa(fun(B,assn),fun(B,assn),aTP_Lamp_ax(fun(B,assn),fun(fun(B,assn),fun(B,assn)),Pa),Qa)) = ex_assn(B,aa(fun(B,assn),fun(B,assn),aTP_Lamp_ay(fun(B,assn),fun(fun(B,assn),fun(B,assn)),Pa),Qa)) ) ).

% ex_join_or
tff(fact_392_ex__distrib__or,axiom,
    ! [B: $tType,Pa: fun(B,assn),Qa: assn] : ( ex_assn(B,aa(assn,fun(B,assn),aTP_Lamp_az(fun(B,assn),fun(assn,fun(B,assn)),Pa),Qa)) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),ex_assn(B,Pa)),Qa) ) ).

% ex_distrib_or
tff(fact_393_sup__cancel__left1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),A4)),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X2)),B3)) = top_top(B) ) ) ).

% sup_cancel_left1
tff(fact_394_sup__cancel__left2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X2)),A4)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),B3)) = top_top(B) ) ) ).

% sup_cancel_left2
tff(fact_395_sup__bot_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => comm_monoid(B,sup_sup(B),bot_bot(B)) ) ).

% sup_bot.comm_monoid_axioms
tff(fact_396_sup__bot_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => monoid(B,sup_sup(B),bot_bot(B)) ) ).

% sup_bot.monoid_axioms
tff(fact_397_sup__assn__def,axiom,
    ! [Pa: assn,Qa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),Pa),Qa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_ba(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Pa),Qa)) ) ).

% sup_assn_def
tff(fact_398_boolean__algebra_Ocomplement__unique,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [A4: B,X2: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),X2) = bot_bot(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),X2) = top_top(B) )
           => ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),Y) = bot_bot(B) )
             => ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),Y) = top_top(B) )
               => ( X2 = Y ) ) ) ) ) ) ).

% boolean_algebra.complement_unique
tff(fact_399_bot__empty__eq,axiom,
    ! [B: $tType,X4: B] :
      ( aa(B,$o,bot_bot(fun(B,$o)),X4)
    <=> aa(set(B),$o,member(B,X4),bot_bot(set(B))) ) ).

% bot_empty_eq
tff(fact_400_mod__emp,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,one_one(assn)),H2)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2) = bot_bot(set(nat)) ) ) ).

% mod_emp
tff(fact_401_times__assn__raw_Oelims_I3_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X2,Xa),Xb)
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ? [As12: set(nat),As23: set(nat)] :
                ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As12),As23) )
                & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As12),As23) = bot_bot(set(nat)) )
                & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As12))
                & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As23)) ) ) ) ).

% times_assn_raw.elims(3)
tff(fact_402_times__assn__raw_Oelims_I2_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X2,Xa),Xb)
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ~ ? [As13: set(nat),As24: set(nat)] :
                  ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As13),As24) )
                  & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As13),As24) = bot_bot(set(nat)) )
                  & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As13))
                  & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As24)) ) ) ) ).

% times_assn_raw.elims(2)
tff(fact_403_times__assn__raw_Oelims_I1_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X2,Xa),Xb)
      <=> (Y) )
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( (Y)
            <=> ~ ? [As1: set(nat),As22: set(nat)] :
                    ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
                    & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As1))
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As22)) ) ) ) ) ).

% times_assn_raw.elims(1)
tff(fact_404_times__assn__raw_Osimps,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),H2: heap_ext(product_unit),As2: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(Pa,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
    <=> ? [As1: set(nat),As22: set(nat)] :
          ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
          & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As1))
          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Qa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As22)) ) ) ).

% times_assn_raw.simps
tff(fact_405_boolean__algebra__class_Oboolean__algebra_Ocompl__unique,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) = bot_bot(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) = top_top(B) )
           => ( aa(B,B,uminus_uminus(B),X2) = Y ) ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_unique
tff(fact_406_wand__assnI,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat),Qa: assn,R: assn] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
     => ( ! [H3: heap_ext(product_unit),As4: set(nat)] :
            ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As4) = bot_bot(set(nat)) )
           => ( relH(As2,H2,H3)
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As2))
               => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As4))
                 => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,R),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As4))) ) ) ) )
       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,wand_assn(Qa,R)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)) ) ) ).

% wand_assnI
tff(fact_407_wand__raw_Oelims_I3_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X2,Xa),Xb)
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
              & ! [H3: heap_ext(product_unit),As4: set(nat)] :
                  ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As4) = bot_bot(set(nat)) )
                    & relH(As,H4,H3)
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As))
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As4)) )
                 => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As4))) ) ) ) ) ).

% wand_raw.elims(3)
tff(fact_408_wand__raw_Oelims_I2_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X2,Xa),Xb)
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ~ ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
                & ! [H6: heap_ext(product_unit),As5: set(nat)] :
                    ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As5) = bot_bot(set(nat)) )
                      & relH(As,H4,H6)
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),As))
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),As5)) )
                   => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As5))) ) ) ) ) ).

% wand_raw.elims(2)
tff(fact_409_wand__raw_Oelims_I1_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X2,Xa),Xb)
      <=> (Y) )
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( (Y)
            <=> ~ ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
                  & ! [H7: heap_ext(product_unit),As6: set(nat)] :
                      ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As6) = bot_bot(set(nat)) )
                        & relH(As,H4,H7)
                        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As))
                        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As6)) )
                     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As6))) ) ) ) ) ) ).

% wand_raw.elims(1)
tff(fact_410_wand__raw_Osimps,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),H2: heap_ext(product_unit),As2: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(Pa,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
        & ! [H7: heap_ext(product_unit),As6: set(nat)] :
            ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As6) = bot_bot(set(nat)) )
              & relH(As2,H2,H7)
              & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As2))
              & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As6)) )
           => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Qa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As6))) ) ) ) ).

% wand_raw.simps
tff(fact_411_Collect__empty__eq__bot,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ( aa(fun(B,$o),set(B),collect(B),Pa) = bot_bot(set(B)) )
    <=> ( Pa = bot_bot(fun(B,$o)) ) ) ).

% Collect_empty_eq_bot
tff(fact_412_disjointI,axiom,
    ! [B: $tType,A4: set(B),B3: set(B)] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),A4)
         => ~ aa(set(B),$o,member(B,X),B3) )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3) = bot_bot(set(B)) ) ) ).

% disjointI
tff(fact_413_boolean__algebra_Oabstract__boolean__algebra__axioms,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => boolea2506097494486148201lgebra(B,inf_inf(B),sup_sup(B),uminus_uminus(B),bot_bot(B),top_top(B)) ) ).

% boolean_algebra.abstract_boolean_algebra_axioms
tff(fact_414_success__LetI,axiom,
    ! [B: $tType,C: $tType,X2: B,T3: B,F2: fun(B,heap_Time_Heap(C)),H2: heap_ext(product_unit)] :
      ( ( X2 = T3 )
     => ( heap_Time_success(C,aa(B,heap_Time_Heap(C),F2,X2),H2)
       => heap_Time_success(C,aa(B,heap_Time_Heap(C),F2,T3),H2) ) ) ).

% success_LetI
tff(fact_415_times__assn__raw_Opelims_I3_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X2,Xa),Xb)
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))
               => ? [As12: set(nat),As23: set(nat)] :
                    ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As12),As23) )
                    & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As12),As23) = bot_bot(set(nat)) )
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As12))
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As23)) ) ) ) ) ) ).

% times_assn_raw.pelims(3)
tff(fact_416_times__assn__raw_Opelims_I2_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X2,Xa),Xb)
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))
               => ~ ? [As13: set(nat),As24: set(nat)] :
                      ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As13),As24) )
                      & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As13),As24) = bot_bot(set(nat)) )
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As13))
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As24)) ) ) ) ) ) ).

% times_assn_raw.pelims(2)
tff(fact_417_inf1I,axiom,
    ! [B: $tType,A3: fun(B,$o),X2: B,B2: fun(B,$o)] :
      ( aa(B,$o,A3,X2)
     => ( aa(B,$o,B2,X2)
       => aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),A3),B2),X2) ) ) ).

% inf1I
tff(fact_418_relH__dist__union,axiom,
    ! [As2: set(nat),As3: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( relH(aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As3),H2,H5)
    <=> ( relH(As2,H2,H5)
        & relH(As3,H2,H5) ) ) ).

% relH_dist_union
tff(fact_419_inf1E,axiom,
    ! [B: $tType,A3: fun(B,$o),B2: fun(B,$o),X2: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),A3),B2),X2)
     => ~ ( aa(B,$o,A3,X2)
         => ~ aa(B,$o,B2,X2) ) ) ).

% inf1E
tff(fact_420_inf1D1,axiom,
    ! [B: $tType,A3: fun(B,$o),B2: fun(B,$o),X2: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),A3),B2),X2)
     => aa(B,$o,A3,X2) ) ).

% inf1D1
tff(fact_421_inf1D2,axiom,
    ! [B: $tType,A3: fun(B,$o),B2: fun(B,$o),X2: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),A3),B2),X2)
     => aa(B,$o,B2,X2) ) ).

% inf1D2
tff(fact_422_relH__trans,axiom,
    ! [As2: set(nat),H12: heap_ext(product_unit),H23: heap_ext(product_unit),H32: heap_ext(product_unit)] :
      ( relH(As2,H12,H23)
     => ( relH(As2,H23,H32)
       => relH(As2,H12,H32) ) ) ).

% relH_trans
tff(fact_423_relH__sym,axiom,
    ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( relH(As2,H2,H5)
     => relH(As2,H5,H2) ) ).

% relH_sym
tff(fact_424_abstract__boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Y: B,Z2: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,Y),Z2)),X2) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,Y),X2)),aa(B,B,aa(B,fun(B,B),Disj,Z2),X2)) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib2
tff(fact_425_abstract__boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Y: B,Z2: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,Y),Z2)),X2) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,Y),X2)),aa(B,B,aa(B,fun(B,B),Conj,Z2),X2)) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib2
tff(fact_426_abstract__boolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B,Y: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( ( aa(B,B,Compl,X2) = aa(B,B,Compl,Y) )
      <=> ( X2 = Y ) ) ) ).

% abstract_boolean_algebra.compl_eq_compl_iff
tff(fact_427_abstract__boolean__algebra_Odisj__conj__distrib,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B,Y: B,Z2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,X2),aa(B,B,aa(B,fun(B,B),Conj,Y),Z2)) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,X2),Y)),aa(B,B,aa(B,fun(B,B),Disj,X2),Z2)) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib
tff(fact_428_abstract__boolean__algebra_Odisj__cancel__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,X2),aa(B,B,Compl,X2)) = One ) ) ).

% abstract_boolean_algebra.disj_cancel_right
tff(fact_429_abstract__boolean__algebra_Oconj__disj__distrib,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B,Y: B,Z2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,X2),aa(B,B,aa(B,fun(B,B),Disj,Y),Z2)) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X2),Y)),aa(B,B,aa(B,fun(B,B),Conj,X2),Z2)) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib
tff(fact_430_abstract__boolean__algebra_Oconj__cancel__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,X2),aa(B,B,Compl,X2)) = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_right
tff(fact_431_abstract__boolean__algebra_Ocomplement__unique,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,A4: B,X2: B,Y: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( ( aa(B,B,aa(B,fun(B,B),Conj,A4),X2) = Zero )
       => ( ( aa(B,B,aa(B,fun(B,B),Disj,A4),X2) = One )
         => ( ( aa(B,B,aa(B,fun(B,B),Conj,A4),Y) = Zero )
           => ( ( aa(B,B,aa(B,fun(B,B),Disj,A4),Y) = One )
             => ( X2 = Y ) ) ) ) ) ) ).

% abstract_boolean_algebra.complement_unique
tff(fact_432_abstract__boolean__algebra_Odisj__cancel__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,Compl,X2)),X2) = One ) ) ).

% abstract_boolean_algebra.disj_cancel_left
tff(fact_433_abstract__boolean__algebra_Oconj__cancel__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,Compl,X2)),X2) = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_left
tff(fact_434_abstract__boolean__algebra_Odisj__zero__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,X2),Zero) = X2 ) ) ).

% abstract_boolean_algebra.disj_zero_right
tff(fact_435_abstract__boolean__algebra_Oconj__zero__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,X2),Zero) = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_right
tff(fact_436_abstract__boolean__algebra_Odisj__one__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,X2),One) = One ) ) ).

% abstract_boolean_algebra.disj_one_right
tff(fact_437_abstract__boolean__algebra_Ode__Morgan__disj,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B,Y: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,Compl,aa(B,B,aa(B,fun(B,B),Disj,X2),Y)) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,Compl,X2)),aa(B,B,Compl,Y)) ) ) ).

% abstract_boolean_algebra.de_Morgan_disj
tff(fact_438_abstract__boolean__algebra_Ode__Morgan__conj,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B,Y: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,Compl,aa(B,B,aa(B,fun(B,B),Conj,X2),Y)) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,Compl,X2)),aa(B,B,Compl,Y)) ) ) ).

% abstract_boolean_algebra.de_Morgan_conj
tff(fact_439_abstract__boolean__algebra_Oconj__zero__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,Zero),X2) = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_left
tff(fact_440_abstract__boolean__algebra_Oconj__one__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,X2),One) = X2 ) ) ).

% abstract_boolean_algebra.conj_one_right
tff(fact_441_abstract__boolean__algebra_Odisj__one__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,One),X2) = One ) ) ).

% abstract_boolean_algebra.disj_one_left
tff(fact_442_abstract__boolean__algebra_Odouble__compl,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,Compl,aa(B,B,Compl,X2)) = X2 ) ) ).

% abstract_boolean_algebra.double_compl
tff(fact_443_abstract__boolean__algebra_Ocompl__unique,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X2: B,Y: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( ( aa(B,B,aa(B,fun(B,B),Conj,X2),Y) = Zero )
       => ( ( aa(B,B,aa(B,fun(B,B),Disj,X2),Y) = One )
         => ( aa(B,B,Compl,X2) = Y ) ) ) ) ).

% abstract_boolean_algebra.compl_unique
tff(fact_444_abstract__boolean__algebra_Ocompl__zero,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,Compl,Zero) = One ) ) ).

% abstract_boolean_algebra.compl_zero
tff(fact_445_abstract__boolean__algebra_Ocompl__one,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,Compl,One) = Zero ) ) ).

% abstract_boolean_algebra.compl_one
tff(fact_446_sup__Un__eq2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S: set(product_prod(B,C)),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),sup_sup(fun(B,fun(C,$o))),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),R)),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),S)),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),sup_sup(set(product_prod(B,C))),R),S)) ) ).

% sup_Un_eq2
tff(fact_447_sup__Un__eq,axiom,
    ! [B: $tType,R: set(B),S: set(B),X4: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),sup_sup(fun(B,$o)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),R)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),S)),X4)
    <=> aa(set(B),$o,member(B,X4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),R),S)) ) ).

% sup_Un_eq
tff(fact_448_sup__set__def,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2) = aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),sup_sup(fun(B,$o)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),B2))) ) ).

% sup_set_def
tff(fact_449_mod__relH,axiom,
    ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit),Pa: assn] :
      ( relH(As2,H2,H5)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
      <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2)) ) ) ).

% mod_relH
tff(fact_450_relH__refl,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
     => relH(As2,H2,H2) ) ).

% relH_refl
tff(fact_451_relH__in__rangeI_I1_J,axiom,
    ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( relH(As2,H2,H5)
     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)) ) ).

% relH_in_rangeI(1)
tff(fact_452_relH__in__rangeI_I2_J,axiom,
    ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( relH(As2,H2,H5)
     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2)) ) ).

% relH_in_rangeI(2)
tff(fact_453_set__notEmptyE,axiom,
    ! [B: $tType,S: set(B)] :
      ( ( S != bot_bot(set(B)) )
     => ~ ! [X: B] : ~ aa(set(B),$o,member(B,X),S) ) ).

% set_notEmptyE
tff(fact_454_memb__imp__not__empty,axiom,
    ! [B: $tType,X2: B,S: set(B)] :
      ( aa(set(B),$o,member(B,X2),S)
     => ( S != bot_bot(set(B)) ) ) ).

% memb_imp_not_empty
tff(fact_455_times__assn__raw_Opelims_I1_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X2,Xa),Xb)
      <=> (Y) )
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( ( (Y)
                <=> ? [As1: set(nat),As22: set(nat)] :
                      ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
                      & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As1))
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As22)) ) )
               => ~ aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))) ) ) ) ) ).

% times_assn_raw.pelims(1)
tff(fact_456_wand__raw_Opelims_I1_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X2,Xa),Xb)
      <=> (Y) )
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( ( (Y)
                <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
                    & ! [H7: heap_ext(product_unit),As6: set(nat)] :
                        ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As6) = bot_bot(set(nat)) )
                          & relH(As,H4,H7)
                          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As))
                          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As6)) )
                       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As6))) ) ) )
               => ~ aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))) ) ) ) ) ).

% wand_raw.pelims(1)
tff(fact_457_wand__raw_Opelims_I2_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X2,Xa),Xb)
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))
               => ~ ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
                    & ! [H6: heap_ext(product_unit),As5: set(nat)] :
                        ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As5) = bot_bot(set(nat)) )
                          & relH(As,H4,H6)
                          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),As))
                          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),As5)) )
                       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As5))) ) ) ) ) ) ) ).

% wand_raw.pelims(2)
tff(fact_458_wand__raw_Opelims_I3_J,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X2,Xa),Xb)
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))
               => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
                  & ! [H3: heap_ext(product_unit),As4: set(nat)] :
                      ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As4) = bot_bot(set(nat)) )
                        & relH(As,H4,H3)
                        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As))
                        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X2,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As4)) )
                     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As4))) ) ) ) ) ) ) ).

% wand_raw.pelims(3)
tff(fact_459_brk__rel__def,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C))] : ( brk_rel(B,C,R) = aa(set(product_prod(product_prod($o,B),product_prod($o,C))),set(product_prod(product_prod($o,B),product_prod($o,C))),aa(set(product_prod(product_prod($o,B),product_prod($o,C))),fun(set(product_prod(product_prod($o,B),product_prod($o,C))),set(product_prod(product_prod($o,B),product_prod($o,C)))),sup_sup(set(product_prod(product_prod($o,B),product_prod($o,C)))),aa(fun(product_prod(product_prod($o,B),product_prod($o,C)),$o),set(product_prod(product_prod($o,B),product_prod($o,C))),collect(product_prod(product_prod($o,B),product_prod($o,C))),aTP_Lamp_bb(set(product_prod(B,C)),fun(product_prod(product_prod($o,B),product_prod($o,C)),$o),R))),aa(fun(product_prod(product_prod($o,B),product_prod($o,C)),$o),set(product_prod(product_prod($o,B),product_prod($o,C))),collect(product_prod(product_prod($o,B),product_prod($o,C))),aTP_Lamp_bc(product_prod(product_prod($o,B),product_prod($o,C)),$o))) ) ).

% brk_rel_def
tff(fact_460_bijective__Empty,axiom,
    ! [C: $tType,B: $tType] : bijective(B,C,bot_bot(set(product_prod(B,C)))) ).

% bijective_Empty
tff(fact_461_rel__restrict__compl,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),A3: set(B)] : ( aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),rel_restrict(B,R,A3)),rel_restrict(B,R,aa(set(B),set(B),uminus_uminus(set(B)),A3))) = bot_bot(set(product_prod(B,B))) ) ).

% rel_restrict_compl
tff(fact_462_properI,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( ! [As: set(nat),H4: heap_ext(product_unit)] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
         => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)) )
     => ( ! [As: set(nat),H4: heap_ext(product_unit),H3: heap_ext(product_unit)] :
            ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
           => ( relH(As,H4,H3)
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As))
               => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As)) ) ) )
       => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa) ) ) ).

% properI
tff(fact_463_properD2,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),H2: heap_ext(product_unit),As2: set(nat),H5: heap_ext(product_unit)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
       => ( relH(As2,H2,H5)
         => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2))
           => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2)) ) ) ) ) ).

% properD2
tff(fact_464_proper__def,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
    <=> ! [H: heap_ext(product_unit),H7: heap_ext(product_unit),As7: set(nat)] :
          ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As7))
           => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As7)) )
          & ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As7))
              & relH(As7,H,H7)
              & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As7)) )
           => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As7)) ) ) ) ).

% proper_def
tff(fact_465_proper__iff,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( relH(As2,H2,H5)
       => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2))
         => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
          <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2)) ) ) ) ) ).

% proper_iff
tff(fact_466_Id__on__empty,axiom,
    ! [B: $tType] : ( id_on(B,bot_bot(set(B))) = bot_bot(set(product_prod(B,B))) ) ).

% Id_on_empty
tff(fact_467_sup2CI,axiom,
    ! [B: $tType,C: $tType,B2: fun(B,fun(C,$o)),X2: B,Y: C,A3: fun(B,fun(C,$o))] :
      ( ( ~ aa(C,$o,aa(B,fun(C,$o),B2,X2),Y)
       => aa(C,$o,aa(B,fun(C,$o),A3,X2),Y) )
     => aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),sup_sup(fun(B,fun(C,$o))),A3),B2),X2),Y) ) ).

% sup2CI
tff(fact_468_sup1CI,axiom,
    ! [B: $tType,B2: fun(B,$o),X2: B,A3: fun(B,$o)] :
      ( ( ~ aa(B,$o,B2,X2)
       => aa(B,$o,A3,X2) )
     => aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),sup_sup(fun(B,$o)),A3),B2),X2) ) ).

% sup1CI
tff(fact_469_bool__assn__proper_I2_J,axiom,
    aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aTP_Lamp_ag(product_prod(heap_ext(product_unit),set(nat)),$o)) ).

% bool_assn_proper(2)
tff(fact_470_bool__assn__proper_I3_J,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Qa)
       => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_bd(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Pa),Qa)) ) ) ).

% bool_assn_proper(3)
tff(fact_471_bool__assn__proper_I4_J,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Qa)
       => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_be(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Pa),Qa)) ) ) ).

% bool_assn_proper(4)
tff(fact_472_rel__restrict__empty,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] : ( rel_restrict(B,R,bot_bot(set(B))) = R ) ).

% rel_restrict_empty
tff(fact_473_bool__assn__proper_I1_J,axiom,
    aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,in_range) ).

% bool_assn_proper(1)
tff(fact_474_ex__assn__proper,axiom,
    ! [B: $tType,Pa: fun(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o))] :
      ( ! [X: B] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa,X))
     => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aTP_Lamp_bf(fun(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa)) ) ).

% ex_assn_proper
tff(fact_475_one__assn__proper,axiom,
    aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,one_assn_raw) ).

% one_assn_proper
tff(fact_476_times__assn__proper,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Qa)
       => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,times_assn_raw(Pa,Qa)) ) ) ).

% times_assn_proper
tff(fact_477_wand__proper,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,wand_raw(Pa,Qa)) ).

% wand_proper
tff(fact_478_snga__assn__proper,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R2: array(B),X2: list(B)] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,snga_assn_raw(B,R2,X2)) ) ).

% snga_assn_proper
tff(fact_479_sngr__assn__proper,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R2: ref(B),X2: B] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,sngr_assn_raw(B,R2,X2)) ) ).

% sngr_assn_proper
tff(fact_480_bool__assn__proper_I5_J,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aTP_Lamp_bg(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa)) ) ).

% bool_assn_proper(5)
tff(fact_481_pure__assn__proper,axiom,
    ! [B3: $o] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,pure_assn_raw(heap_ext(product_unit),nat,B3)) ).

% pure_assn_proper
tff(fact_482_sup1E,axiom,
    ! [B: $tType,A3: fun(B,$o),B2: fun(B,$o),X2: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),sup_sup(fun(B,$o)),A3),B2),X2)
     => ( ~ aa(B,$o,A3,X2)
       => aa(B,$o,B2,X2) ) ) ).

% sup1E
tff(fact_483_sup2E,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o)),B2: fun(B,fun(C,$o)),X2: B,Y: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),sup_sup(fun(B,fun(C,$o))),A3),B2),X2),Y)
     => ( ~ aa(C,$o,aa(B,fun(C,$o),A3,X2),Y)
       => aa(C,$o,aa(B,fun(C,$o),B2,X2),Y) ) ) ).

% sup2E
tff(fact_484_sup1I1,axiom,
    ! [B: $tType,A3: fun(B,$o),X2: B,B2: fun(B,$o)] :
      ( aa(B,$o,A3,X2)
     => aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),sup_sup(fun(B,$o)),A3),B2),X2) ) ).

% sup1I1
tff(fact_485_sup1I2,axiom,
    ! [B: $tType,B2: fun(B,$o),X2: B,A3: fun(B,$o)] :
      ( aa(B,$o,B2,X2)
     => aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),sup_sup(fun(B,$o)),A3),B2),X2) ) ).

% sup1I2
tff(fact_486_sup2I1,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o)),X2: B,Y: C,B2: fun(B,fun(C,$o))] :
      ( aa(C,$o,aa(B,fun(C,$o),A3,X2),Y)
     => aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),sup_sup(fun(B,fun(C,$o))),A3),B2),X2),Y) ) ).

% sup2I1
tff(fact_487_sup2I2,axiom,
    ! [B: $tType,C: $tType,B2: fun(B,fun(C,$o)),X2: B,Y: C,A3: fun(B,fun(C,$o))] :
      ( aa(C,$o,aa(B,fun(C,$o),B2,X2),Y)
     => aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),sup_sup(fun(B,fun(C,$o))),A3),B2),X2),Y) ) ).

% sup2I2
tff(fact_488_Rep__assn,axiom,
    ! [X2: assn] : aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),$o,member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,X2)),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper)) ).

% Rep_assn
tff(fact_489_Rep__assn__cases,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),$o,member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
     => ~ ! [X: assn] : ( Y != aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,X) ) ) ).

% Rep_assn_cases
tff(fact_490_Rep__assn__induct,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa: fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o)] :
      ( aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),$o,member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
     => ( ! [X: assn] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,Pa,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,X))
       => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,Pa,Y) ) ) ).

% Rep_assn_induct
tff(fact_491_Abs__assn__cases,axiom,
    ! [X2: assn] :
      ~ ! [Y2: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
          ( ( X2 = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Y2) )
         => ~ aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),$o,member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y2),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper)) ) ).

% Abs_assn_cases
tff(fact_492_Abs__assn__induct,axiom,
    ! [Pa: fun(assn,$o),X2: assn] :
      ( ! [Y2: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
          ( aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),$o,member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y2),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
         => aa(assn,$o,Pa,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Y2)) )
     => aa(assn,$o,Pa,X2) ) ).

% Abs_assn_induct
tff(fact_493_Abs__assn__inject,axiom,
    ! [X2: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),$o,member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),X2),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
     => ( aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),$o,member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
       => ( ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,X2) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Y) )
        <=> ( X2 = Y ) ) ) ) ).

% Abs_assn_inject
tff(fact_494_properD1,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),H2: heap_ext(product_unit),As2: set(nat)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)) ) ) ).

% properD1
tff(fact_495_Abs__assn__inverse,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),$o,member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
     => ( aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Y)) = Y ) ) ).

% Abs_assn_inverse
tff(fact_496_monoid_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( semigroup(B,F2)
     => ( monoid_axioms(B,F2,Z2)
       => monoid(B,F2,Z2) ) ) ).

% monoid.intro
tff(fact_497_monoid__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( monoid(B,F2,Z2)
    <=> ( semigroup(B,F2)
        & monoid_axioms(B,F2,Z2) ) ) ).

% monoid_def
tff(fact_498_vimage__if,axiom,
    ! [C: $tType,B: $tType,B2: set(B),Ca: C,D3: C,A3: set(C)] :
      ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),aa(C,fun(B,C),aa(C,fun(C,fun(B,C)),aTP_Lamp_bh(set(B),fun(C,fun(C,fun(B,C))),B2),Ca),D3)),A3)
      = $ite(
          aa(set(C),$o,member(C,Ca),A3),
          $ite(aa(set(C),$o,member(C,D3),A3),top_top(set(B)),B2),
          $ite(aa(set(C),$o,member(C,D3),A3),aa(set(B),set(B),uminus_uminus(set(B)),B2),bot_bot(set(B))) ) ) ).

% vimage_if
tff(fact_499_type__definition__assn,axiom,
    type_definition(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,abs_assn,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper)) ).

% type_definition_assn
tff(fact_500_pure__assn__raw_Opelims_I3_J,axiom,
    ! [C: $tType,B: $tType,X2: $o,Xa: product_prod(B,set(C))] :
      ( ~ aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X2),Xa)
     => ( aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X2),Xa))
       => ~ ! [H4: B,As: set(C)] :
              ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H4),As) )
             => ( aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X2),aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H4),As)))
               => ( ( As = bot_bot(set(C)) )
                  & (X2) ) ) ) ) ) ).

% pure_assn_raw.pelims(3)
tff(fact_501_pure__assn__raw_Opelims_I2_J,axiom,
    ! [C: $tType,B: $tType,X2: $o,Xa: product_prod(B,set(C))] :
      ( aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X2),Xa)
     => ( aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X2),Xa))
       => ~ ! [H4: B,As: set(C)] :
              ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H4),As) )
             => ( aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X2),aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H4),As)))
               => ~ ( ( As = bot_bot(set(C)) )
                    & (X2) ) ) ) ) ) ).

% pure_assn_raw.pelims(2)
tff(fact_502_pure__assn__raw_Opelims_I1_J,axiom,
    ! [B: $tType,C: $tType,X2: $o,Xa: product_prod(B,set(C)),Y: $o] :
      ( ( aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X2),Xa)
      <=> (Y) )
     => ( aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X2),Xa))
       => ~ ! [H4: B,As: set(C)] :
              ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H4),As) )
             => ( ( (Y)
                <=> ( ( As = bot_bot(set(C)) )
                    & (X2) ) )
               => ~ aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X2),aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H4),As))) ) ) ) ) ).

% pure_assn_raw.pelims(1)
tff(fact_503_rel__restrict__alt__def,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),A3: set(B)] : ( rel_restrict(B,R,A3) = aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R),product_Sigma(B,B,aa(set(B),set(B),uminus_uminus(set(B)),A3),aTP_Lamp_bi(set(B),fun(B,set(B)),A3))) ) ).

% rel_restrict_alt_def
tff(fact_504_dbl__dec__simps_I3_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_dec(B,one_one(B)) = one_one(B) ) ) ).

% dbl_dec_simps(3)
tff(fact_505_image2__def,axiom,
    ! [B: $tType,C: $tType,D: $tType,A3: set(D),F2: fun(D,B),G: fun(D,C)] : ( bNF_Greatest_image2(D,B,C,A3,F2,G) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(D,C),fun(product_prod(B,C),$o),aa(fun(D,B),fun(fun(D,C),fun(product_prod(B,C),$o)),aTP_Lamp_bj(set(D),fun(fun(D,B),fun(fun(D,C),fun(product_prod(B,C),$o))),A3),F2),G)) ) ).

% image2_def
tff(fact_506_dbl__inc__simps_I2_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_inc(B,zero_zero(B)) = one_one(B) ) ) ).

% dbl_inc_simps(2)
tff(fact_507_vimage__ident,axiom,
    ! [B: $tType,Y3: set(B)] : ( aa(set(B),set(B),aa(fun(B,B),fun(set(B),set(B)),vimage(B,B),aTP_Lamp_bk(B,B)),Y3) = Y3 ) ).

% vimage_ident
tff(fact_508_vimage__Collect__eq,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),Pa: fun(C,$o)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),aa(fun(C,$o),set(C),collect(C),Pa)) = aa(fun(B,$o),set(B),collect(B),aa(fun(C,$o),fun(B,$o),aTP_Lamp_bl(fun(B,C),fun(fun(C,$o),fun(B,$o)),F2),Pa)) ) ).

% vimage_Collect_eq
tff(fact_509_mult__cancel__right,axiom,
    ! [B: $tType] :
      ( semiri6575147826004484403cancel(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca) = aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca) )
        <=> ( ( Ca = zero_zero(B) )
            | ( A4 = B3 ) ) ) ) ).

% mult_cancel_right
tff(fact_510_mult__cancel__left,axiom,
    ! [B: $tType] :
      ( semiri6575147826004484403cancel(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4) = aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3) )
        <=> ( ( Ca = zero_zero(B) )
            | ( A4 = B3 ) ) ) ) ).

% mult_cancel_left
tff(fact_511_mult__eq__0__iff,axiom,
    ! [B: $tType] :
      ( semiri3467727345109120633visors(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3) = zero_zero(B) )
        <=> ( ( A4 = zero_zero(B) )
            | ( B3 = zero_zero(B) ) ) ) ) ).

% mult_eq_0_iff
tff(fact_512_mult__zero__right,axiom,
    ! [B: $tType] :
      ( mult_zero(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),zero_zero(B)) = zero_zero(B) ) ) ).

% mult_zero_right
tff(fact_513_mult__zero__left,axiom,
    ! [B: $tType] :
      ( mult_zero(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),zero_zero(B)),A4) = zero_zero(B) ) ) ).

% mult_zero_left
tff(fact_514_neg__equal__zero,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A4: B] :
          ( ( aa(B,B,uminus_uminus(B),A4) = A4 )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% neg_equal_zero
tff(fact_515_equal__neg__zero,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A4: B] :
          ( ( A4 = aa(B,B,uminus_uminus(B),A4) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% equal_neg_zero
tff(fact_516_neg__equal__0__iff__equal,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B] :
          ( ( aa(B,B,uminus_uminus(B),A4) = zero_zero(B) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% neg_equal_0_iff_equal
tff(fact_517_neg__0__equal__iff__equal,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B] :
          ( ( zero_zero(B) = aa(B,B,uminus_uminus(B),A4) )
        <=> ( zero_zero(B) = A4 ) ) ) ).

% neg_0_equal_iff_equal
tff(fact_518_add_Oinverse__neutral,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ( aa(B,B,uminus_uminus(B),zero_zero(B)) = zero_zero(B) ) ) ).

% add.inverse_neutral
tff(fact_519_vimage__empty,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),bot_bot(set(C))) = bot_bot(set(B)) ) ).

% vimage_empty
tff(fact_520_vimage__Int,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),A3: set(C),B2: set(C)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),A3)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),B2)) ) ).

% vimage_Int
tff(fact_521_mult__cancel__right2,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [A4: B,Ca: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca) = Ca )
        <=> ( ( Ca = zero_zero(B) )
            | ( A4 = one_one(B) ) ) ) ) ).

% mult_cancel_right2
tff(fact_522_mult__cancel__right1,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [Ca: B,B3: B] :
          ( ( Ca = aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca) )
        <=> ( ( Ca = zero_zero(B) )
            | ( B3 = one_one(B) ) ) ) ) ).

% mult_cancel_right1
tff(fact_523_mult__cancel__left2,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [Ca: B,A4: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4) = Ca )
        <=> ( ( Ca = zero_zero(B) )
            | ( A4 = one_one(B) ) ) ) ) ).

% mult_cancel_left2
tff(fact_524_mult__cancel__left1,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [Ca: B,B3: B] :
          ( ( Ca = aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3) )
        <=> ( ( Ca = zero_zero(B) )
            | ( B3 = one_one(B) ) ) ) ) ).

% mult_cancel_left1
tff(fact_525_vimage__const,axiom,
    ! [C: $tType,B: $tType,Ca: C,A3: set(C)] :
      ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),aTP_Lamp_bm(C,fun(B,C),Ca)),A3)
      = $ite(aa(set(C),$o,member(C,Ca),A3),top_top(set(B)),bot_bot(set(B))) ) ).

% vimage_const
tff(fact_526_dbl__dec__simps_I2_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_dec(B,zero_zero(B)) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% dbl_dec_simps(2)
tff(fact_527_zero__reorient,axiom,
    ! [B: $tType] :
      ( zero(B)
     => ! [X2: B] :
          ( ( zero_zero(B) = X2 )
        <=> ( X2 = zero_zero(B) ) ) ) ).

% zero_reorient
tff(fact_528_semigroup__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( semigroup(B,F2)
    <=> ! [A6: B,B5: B,C4: B] : ( aa(B,B,aa(B,fun(B,B),F2,aa(B,B,aa(B,fun(B,B),F2,A6),B5)),C4) = aa(B,B,aa(B,fun(B,B),F2,A6),aa(B,B,aa(B,fun(B,B),F2,B5),C4)) ) ) ).

% semigroup_def
tff(fact_529_semigroup_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( ! [A5: B,B4: B,C3: B] : ( aa(B,B,aa(B,fun(B,B),F2,aa(B,B,aa(B,fun(B,B),F2,A5),B4)),C3) = aa(B,B,aa(B,fun(B,B),F2,A5),aa(B,B,aa(B,fun(B,B),F2,B4),C3)) )
     => semigroup(B,F2) ) ).

% semigroup.intro
tff(fact_530_semigroup_Oassoc,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A4: B,B3: B,Ca: B] :
      ( semigroup(B,F2)
     => ( aa(B,B,aa(B,fun(B,B),F2,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),F2,A4),aa(B,B,aa(B,fun(B,B),F2,B3),Ca)) ) ) ).

% semigroup.assoc
tff(fact_531_vimage__def,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),B2: set(C)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),B2) = aa(fun(B,$o),set(B),collect(B),aa(set(C),fun(B,$o),aTP_Lamp_bn(fun(B,C),fun(set(C),fun(B,$o)),F2),B2)) ) ).

% vimage_def
tff(fact_532_vimage__inter__cong,axiom,
    ! [C: $tType,B: $tType,S: set(B),F2: fun(B,C),G: fun(B,C),Y: set(C)] :
      ( ! [W: B] :
          ( aa(set(B),$o,member(B,W),S)
         => ( aa(B,C,F2,W) = aa(B,C,G,W) ) )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),Y)),S) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),G),Y)),S) ) ) ).

% vimage_inter_cong
tff(fact_533_mult__right__cancel,axiom,
    ! [B: $tType] :
      ( semiri6575147826004484403cancel(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( ( Ca != zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca) = aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca) )
          <=> ( A4 = B3 ) ) ) ) ).

% mult_right_cancel
tff(fact_534_mult__left__cancel,axiom,
    ! [B: $tType] :
      ( semiri6575147826004484403cancel(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( ( Ca != zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4) = aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3) )
          <=> ( A4 = B3 ) ) ) ) ).

% mult_left_cancel
tff(fact_535_no__zero__divisors,axiom,
    ! [B: $tType] :
      ( semiri3467727345109120633visors(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( ( B3 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3) != zero_zero(B) ) ) ) ) ).

% no_zero_divisors
tff(fact_536_divisors__zero,axiom,
    ! [B: $tType] :
      ( semiri3467727345109120633visors(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3) = zero_zero(B) )
         => ( ( A4 = zero_zero(B) )
            | ( B3 = zero_zero(B) ) ) ) ) ).

% divisors_zero
tff(fact_537_mult__not__zero,axiom,
    ! [B: $tType] :
      ( mult_zero(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3) != zero_zero(B) )
         => ( ( A4 != zero_zero(B) )
            & ( B3 != zero_zero(B) ) ) ) ) ).

% mult_not_zero
tff(fact_538_zero__neq__one,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ( zero_zero(B) != one_one(B) ) ) ).

% zero_neq_one
tff(fact_539_mult_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( semigroup_mult(B)
     => semigroup(B,times_times(B)) ) ).

% mult.semigroup_axioms
tff(fact_540_inf_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => semigroup(B,inf_inf(B)) ) ).

% inf.semigroup_axioms
tff(fact_541_sup_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => semigroup(B,sup_sup(B)) ) ).

% sup.semigroup_axioms
tff(fact_542_lambda__zero,axiom,
    ! [B: $tType] :
      ( mult_zero(B)
     => ( aTP_Lamp_bo(B,B) = aa(B,fun(B,B),times_times(B),zero_zero(B)) ) ) ).

% lambda_zero
tff(fact_543_monoid_Oaxioms_I1_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( monoid(B,F2,Z2)
     => semigroup(B,F2) ) ).

% monoid.axioms(1)
tff(fact_544_zero__neq__neg__one,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ( zero_zero(B) != aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% zero_neq_neg_one
tff(fact_545_UNIV__Times__UNIV,axiom,
    ! [C: $tType,B: $tType] : ( product_Sigma(B,C,top_top(set(B)),aTP_Lamp_bp(B,set(C))) = top_top(set(product_prod(B,C))) ) ).

% UNIV_Times_UNIV
tff(fact_546_Compl__Times__UNIV1,axiom,
    ! [B: $tType,C: $tType,A3: set(C)] : ( aa(set(product_prod(B,C)),set(product_prod(B,C)),uminus_uminus(set(product_prod(B,C))),product_Sigma(B,C,top_top(set(B)),aTP_Lamp_bq(set(C),fun(B,set(C)),A3))) = product_Sigma(B,C,top_top(set(B)),aTP_Lamp_br(set(C),fun(B,set(C)),A3)) ) ).

% Compl_Times_UNIV1
tff(fact_547_Compl__Times__UNIV2,axiom,
    ! [C: $tType,B: $tType,A3: set(B)] : ( aa(set(product_prod(B,C)),set(product_prod(B,C)),uminus_uminus(set(product_prod(B,C))),product_Sigma(B,C,A3,aTP_Lamp_bp(B,set(C)))) = product_Sigma(B,C,aa(set(B),set(B),uminus_uminus(set(B)),A3),aTP_Lamp_bp(B,set(C))) ) ).

% Compl_Times_UNIV2
tff(fact_548_Times__empty,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( ( product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)) = bot_bot(set(product_prod(B,C))) )
    <=> ( ( A3 = bot_bot(set(B)) )
        | ( B2 = bot_bot(set(C)) ) ) ) ).

% Times_empty
tff(fact_549_Sigma__empty2,axiom,
    ! [C: $tType,B: $tType,A3: set(B)] : ( product_Sigma(B,C,A3,aTP_Lamp_bs(B,set(C))) = bot_bot(set(product_prod(B,C))) ) ).

% Sigma_empty2
tff(fact_550_Sigma__empty1,axiom,
    ! [C: $tType,B: $tType,B2: fun(B,set(C))] : ( product_Sigma(B,C,bot_bot(set(B)),B2) = bot_bot(set(product_prod(B,C))) ) ).

% Sigma_empty1
tff(fact_551_Sigma__Un__distrib2,axiom,
    ! [C: $tType,B: $tType,I: set(B),A3: fun(B,set(C)),B2: fun(B,set(C))] : ( product_Sigma(B,C,I,aa(fun(B,set(C)),fun(B,set(C)),aTP_Lamp_bt(fun(B,set(C)),fun(fun(B,set(C)),fun(B,set(C))),A3),B2)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),sup_sup(set(product_prod(B,C))),product_Sigma(B,C,I,A3)),product_Sigma(B,C,I,B2)) ) ).

% Sigma_Un_distrib2
tff(fact_552_Times__Un__distrib1,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(B),C2: set(C)] : ( product_Sigma(B,C,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2),aTP_Lamp_bq(set(C),fun(B,set(C)),C2)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),sup_sup(set(product_prod(B,C))),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),C2))),product_Sigma(B,C,B2,aTP_Lamp_bq(set(C),fun(B,set(C)),C2))) ) ).

% Times_Un_distrib1
tff(fact_553_Times__Int__distrib1,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(B),C2: set(C)] : ( product_Sigma(B,C,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2),aTP_Lamp_bq(set(C),fun(B,set(C)),C2)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),C2))),product_Sigma(B,C,B2,aTP_Lamp_bq(set(C),fun(B,set(C)),C2))) ) ).

% Times_Int_distrib1
tff(fact_554_Sigma__Int__distrib2,axiom,
    ! [C: $tType,B: $tType,I: set(B),A3: fun(B,set(C)),B2: fun(B,set(C))] : ( product_Sigma(B,C,I,aa(fun(B,set(C)),fun(B,set(C)),aTP_Lamp_bu(fun(B,set(C)),fun(fun(B,set(C)),fun(B,set(C))),A3),B2)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),product_Sigma(B,C,I,A3)),product_Sigma(B,C,I,B2)) ) ).

% Sigma_Int_distrib2
tff(fact_555_Times__eq__cancel2,axiom,
    ! [B: $tType,C: $tType,X2: B,C2: set(B),A3: set(C),B2: set(C)] :
      ( aa(set(B),$o,member(B,X2),C2)
     => ( ( product_Sigma(C,B,A3,aTP_Lamp_bv(set(B),fun(C,set(B)),C2)) = product_Sigma(C,B,B2,aTP_Lamp_bv(set(B),fun(C,set(B)),C2)) )
      <=> ( A3 = B2 ) ) ) ).

% Times_eq_cancel2
tff(fact_556_Sigma__cong,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: set(B),C2: fun(B,set(C)),D2: fun(B,set(C))] :
      ( ( A3 = B2 )
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),B2)
           => ( aa(B,set(C),C2,X) = aa(B,set(C),D2,X) ) )
       => ( product_Sigma(B,C,A3,C2) = product_Sigma(B,C,B2,D2) ) ) ) ).

% Sigma_cong
tff(fact_557_times__eq__iff,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C),C2: set(B),D2: set(C)] :
      ( ( product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)) = product_Sigma(B,C,C2,aTP_Lamp_bq(set(C),fun(B,set(C)),D2)) )
    <=> ( ( ( A3 = C2 )
          & ( B2 = D2 ) )
        | ( ( ( A3 = bot_bot(set(B)) )
            | ( B2 = bot_bot(set(C)) ) )
          & ( ( C2 = bot_bot(set(B)) )
            | ( D2 = bot_bot(set(C)) ) ) ) ) ) ).

% times_eq_iff
tff(fact_558_Pair__vimage__Sigma,axiom,
    ! [C: $tType,B: $tType,X2: C,A3: set(C),F2: fun(C,set(B))] :
      ( aa(set(product_prod(C,B)),set(B),aa(fun(B,product_prod(C,B)),fun(set(product_prod(C,B)),set(B)),vimage(B,product_prod(C,B)),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X2)),product_Sigma(C,B,A3,F2))
      = $ite(aa(set(C),$o,member(C,X2),A3),aa(C,set(B),F2,X2),bot_bot(set(B))) ) ).

% Pair_vimage_Sigma
tff(fact_559_Sigma__Int__distrib1,axiom,
    ! [C: $tType,B: $tType,I: set(B),J: set(B),C2: fun(B,set(C))] : ( product_Sigma(B,C,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),I),J),C2) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),product_Sigma(B,C,I,C2)),product_Sigma(B,C,J,C2)) ) ).

% Sigma_Int_distrib1
tff(fact_560_vimage__snd,axiom,
    ! [B: $tType,C: $tType,A3: set(C)] : ( aa(set(C),set(product_prod(B,C)),aa(fun(product_prod(B,C),C),fun(set(C),set(product_prod(B,C))),vimage(product_prod(B,C),C),product_snd(B,C)),A3) = product_Sigma(B,C,top_top(set(B)),aTP_Lamp_bq(set(C),fun(B,set(C)),A3)) ) ).

% vimage_snd
tff(fact_561_Sigma__empty__iff,axiom,
    ! [B: $tType,C: $tType,I: set(B),X5: fun(B,set(C))] :
      ( ( product_Sigma(B,C,I,X5) = bot_bot(set(product_prod(B,C))) )
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),I)
         => ( aa(B,set(C),X5,X3) = bot_bot(set(C)) ) ) ) ).

% Sigma_empty_iff
tff(fact_562_Times__Int__Times,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C),C2: set(B),D2: set(C)] : ( aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))),product_Sigma(B,C,C2,aTP_Lamp_bq(set(C),fun(B,set(C)),D2))) = product_Sigma(B,C,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),C2),aa(set(C),fun(B,set(C)),aTP_Lamp_bw(set(C),fun(set(C),fun(B,set(C))),B2),D2)) ) ).

% Times_Int_Times
tff(fact_563_relImage__def,axiom,
    ! [B: $tType,C: $tType,R: set(product_prod(C,C)),F2: fun(C,B)] : ( bNF_Gr4221423524335903396lImage(C,B,R,F2) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(C,B),fun(product_prod(B,B),$o),aTP_Lamp_bx(set(product_prod(C,C)),fun(fun(C,B),fun(product_prod(B,B),$o)),R),F2)) ) ).

% relImage_def
tff(fact_564_member__product,axiom,
    ! [B: $tType,C: $tType,X2: product_prod(B,C),A3: set(B),B2: set(C)] :
      ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),X2),product_product(B,C,A3,B2))
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),X2),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))) ) ).

% member_product
tff(fact_565_Product__Type_Oproduct__def,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] : ( product_product(B,C,A3,B2) = product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)) ) ).

% Product_Type.product_def
tff(fact_566_relInvImage__def,axiom,
    ! [C: $tType,B: $tType,A3: set(B),R: set(product_prod(C,C)),F2: fun(B,C)] : ( bNF_Gr7122648621184425601vImage(B,C,A3,R,F2) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,C),fun(product_prod(B,B),$o),aa(set(product_prod(C,C)),fun(fun(B,C),fun(product_prod(B,B),$o)),aTP_Lamp_by(set(B),fun(set(product_prod(C,C)),fun(fun(B,C),fun(product_prod(B,B),$o))),A3),R),F2)) ) ).

% relInvImage_def
tff(fact_567_fun__cong__unused__0,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( zero(C)
     => ! [F2: fun(fun(B,C),D),G: D] :
          ( ! [X: fun(B,C)] : ( aa(fun(B,C),D,F2,X) = G )
         => ( aa(fun(B,C),D,F2,aTP_Lamp_bz(B,C)) = G ) ) ) ).

% fun_cong_unused_0
tff(fact_568_Sigma__UNIV__cancel,axiom,
    ! [C: $tType,B: $tType,A3: set(B),X5: set(C)] : ( aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),minus_minus(set(product_prod(B,C))),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),X5))),product_Sigma(B,C,A3,aTP_Lamp_bp(B,set(C)))) = bot_bot(set(product_prod(B,C))) ) ).

% Sigma_UNIV_cancel
tff(fact_569_snd__image__times,axiom,
    ! [C: $tType,B: $tType,A3: set(C),B2: set(B)] :
      ( aa(set(product_prod(C,B)),set(B),image2(product_prod(C,B),B,product_snd(C,B)),product_Sigma(C,B,A3,aTP_Lamp_bv(set(B),fun(C,set(B)),B2)))
      = $ite(A3 = bot_bot(set(C)),bot_bot(set(B)),B2) ) ).

% snd_image_times
tff(fact_570_add__neg__numeral__special_I7_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,uminus_uminus(B),one_one(B))) = zero_zero(B) ) ) ).

% add_neg_numeral_special(7)
tff(fact_571_add__neg__numeral__special_I8_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),one_one(B))),one_one(B)) = zero_zero(B) ) ) ).

% add_neg_numeral_special(8)
tff(fact_572_image__vimage__eq,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A3: set(B)] : ( aa(set(C),set(B),image2(C,B,F2),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),F2),A3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(C),set(B),image2(C,B,F2),top_top(set(C)))) ) ).

% image_vimage_eq
tff(fact_573_add__right__cancel,axiom,
    ! [B: $tType] :
      ( cancel_semigroup_add(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4) )
        <=> ( B3 = Ca ) ) ) ).

% add_right_cancel
tff(fact_574_add__left__cancel,axiom,
    ! [B: $tType] :
      ( cancel_semigroup_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca) )
        <=> ( B3 = Ca ) ) ) ).

% add_left_cancel
tff(fact_575_minus__apply,axiom,
    ! [B: $tType,C: $tType] :
      ( minus(B)
     => ! [A3: fun(C,B),B2: fun(C,B),X2: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),minus_minus(fun(C,B)),A3),B2),X2) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(C,B,A3,X2)),aa(C,B,B2,X2)) ) ) ).

% minus_apply
tff(fact_576_image__ident,axiom,
    ! [B: $tType,Y3: set(B)] : ( aa(set(B),set(B),image2(B,B,aTP_Lamp_bk(B,B)),Y3) = Y3 ) ).

% image_ident
tff(fact_577_add__0,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),zero_zero(B)),A4) = A4 ) ) ).

% add_0
tff(fact_578_zero__eq__add__iff__both__eq__0,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [X2: B,Y: B] :
          ( ( zero_zero(B) = aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y) )
        <=> ( ( X2 = zero_zero(B) )
            & ( Y = zero_zero(B) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
tff(fact_579_add__eq__0__iff__both__eq__0,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [X2: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y) = zero_zero(B) )
        <=> ( ( X2 = zero_zero(B) )
            & ( Y = zero_zero(B) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
tff(fact_580_add__cancel__right__right,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) )
        <=> ( B3 = zero_zero(B) ) ) ) ).

% add_cancel_right_right
tff(fact_581_add__cancel__right__left,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4) )
        <=> ( B3 = zero_zero(B) ) ) ) ).

% add_cancel_right_left
tff(fact_582_add__cancel__left__right,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) = A4 )
        <=> ( B3 = zero_zero(B) ) ) ) ).

% add_cancel_left_right
tff(fact_583_add__cancel__left__left,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [B3: B,A4: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4) = A4 )
        <=> ( B3 = zero_zero(B) ) ) ) ).

% add_cancel_left_left
tff(fact_584_double__zero__sym,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A4: B] :
          ( ( zero_zero(B) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),A4) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% double_zero_sym
tff(fact_585_add_Oright__neutral,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),zero_zero(B)) = A4 ) ) ).

% add.right_neutral
tff(fact_586_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),A4) = zero_zero(B) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
tff(fact_587_diff__zero,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),zero_zero(B)) = A4 ) ) ).

% diff_zero
tff(fact_588_zero__diff,axiom,
    ! [B: $tType] :
      ( comm_monoid_diff(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),zero_zero(B)),A4) = zero_zero(B) ) ) ).

% zero_diff
tff(fact_589_diff__0__right,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),zero_zero(B)) = A4 ) ) ).

% diff_0_right
tff(fact_590_diff__self,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),A4) = zero_zero(B) ) ) ).

% diff_self
tff(fact_591_add__diff__cancel__right_H,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),B3) = A4 ) ) ).

% add_diff_cancel_right'
tff(fact_592_add__diff__cancel__right,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [A4: B,Ca: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3) ) ) ).

% add_diff_cancel_right
tff(fact_593_add__diff__cancel__left_H,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),A4) = B3 ) ) ).

% add_diff_cancel_left'
tff(fact_594_add__diff__cancel__left,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [Ca: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3) ) ) ).

% add_diff_cancel_left
tff(fact_595_diff__add__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),B3) = A4 ) ) ).

% diff_add_cancel
tff(fact_596_add__diff__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),B3) = A4 ) ) ).

% add_diff_cancel
tff(fact_597_minus__add__distrib,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A4)),aa(B,B,uminus_uminus(B),B3)) ) ) ).

% minus_add_distrib
tff(fact_598_minus__add__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A4)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) = B3 ) ) ).

% minus_add_cancel
tff(fact_599_add__minus__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A4)),B3)) = B3 ) ) ).

% add_minus_cancel
tff(fact_600_image__empty,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,B)] : ( aa(set(C),set(B),image2(C,B,F2),bot_bot(set(C))) = bot_bot(set(B)) ) ).

% image_empty
tff(fact_601_empty__is__image,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A3: set(C)] :
      ( ( bot_bot(set(B)) = aa(set(C),set(B),image2(C,B,F2),A3) )
    <=> ( A3 = bot_bot(set(C)) ) ) ).

% empty_is_image
tff(fact_602_image__is__empty,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A3: set(C)] :
      ( ( aa(set(C),set(B),image2(C,B,F2),A3) = bot_bot(set(B)) )
    <=> ( A3 = bot_bot(set(C)) ) ) ).

% image_is_empty
tff(fact_603_minus__diff__eq,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4) ) ) ).

% minus_diff_eq
tff(fact_604_Diff__empty,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),bot_bot(set(B))) = A3 ) ).

% Diff_empty
tff(fact_605_empty__Diff,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),bot_bot(set(B))),A3) = bot_bot(set(B)) ) ).

% empty_Diff
tff(fact_606_Diff__cancel,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),A3) = bot_bot(set(B)) ) ).

% Diff_cancel
tff(fact_607_diff__add__zero,axiom,
    ! [B: $tType] :
      ( comm_monoid_diff(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) = zero_zero(B) ) ) ).

% diff_add_zero
tff(fact_608_diff__numeral__special_I9_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),one_one(B)) = zero_zero(B) ) ) ).

% diff_numeral_special(9)
tff(fact_609_ab__left__minus,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A4)),A4) = zero_zero(B) ) ) ).

% ab_left_minus
tff(fact_610_add_Oright__inverse,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,uminus_uminus(B),A4)) = zero_zero(B) ) ) ).

% add.right_inverse
tff(fact_611_diff__0,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),zero_zero(B)),A4) = aa(B,B,uminus_uminus(B),A4) ) ) ).

% diff_0
tff(fact_612_uminus__add__conv__diff,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A4)),B3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4) ) ) ).

% uminus_add_conv_diff
tff(fact_613_diff__minus__eq__add,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(B,B,uminus_uminus(B),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) ) ) ).

% diff_minus_eq_add
tff(fact_614_Diff__UNIV,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),top_top(set(B))) = bot_bot(set(B)) ) ).

% Diff_UNIV
tff(fact_615_Diff__disjoint,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A3)) = bot_bot(set(B)) ) ).

% Diff_disjoint
tff(fact_616_inter__compl__diff__conv,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),uminus_uminus(set(B)),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2) ) ).

% inter_compl_diff_conv
tff(fact_617_Diff__Compl,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),uminus_uminus(set(B)),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) ) ).

% Diff_Compl
tff(fact_618_if__image__distrib,axiom,
    ! [B: $tType,C: $tType,Pa: fun(C,$o),F2: fun(C,B),G: fun(C,B),S: set(C)] : ( aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_ca(fun(C,$o),fun(fun(C,B),fun(fun(C,B),fun(C,B))),Pa),F2),G)),S) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(C),set(B),image2(C,B,F2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),S),aa(fun(C,$o),set(C),collect(C),Pa)))),aa(set(C),set(B),image2(C,B,G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),S),aa(fun(C,$o),set(C),collect(C),aTP_Lamp_cb(fun(C,$o),fun(C,$o),Pa))))) ) ).

% if_image_distrib
tff(fact_619_diff__numeral__special_I12_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),one_one(B))) = zero_zero(B) ) ) ).

% diff_numeral_special(12)
tff(fact_620_group__cancel_Osub2,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [B2: B,K: B,B3: B,A4: B] :
          ( ( B2 = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),B3) )
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),K)),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)) ) ) ) ).

% group_cancel.sub2
tff(fact_621_diff__conv__add__uminus,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,uminus_uminus(B),B3)) ) ) ).

% diff_conv_add_uminus
tff(fact_622_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,uminus_uminus(B),B3)) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
tff(fact_623_diff__diff__eq,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) ) ) ).

% diff_diff_eq
tff(fact_624_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [A4: B,Ca: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),Ca)),B3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),Ca) ) ) ).

% cancel_ab_semigroup_add_class.diff_right_commute
tff(fact_625_add__implies__diff,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3) = A4 )
         => ( Ca = aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3) ) ) ) ).

% add_implies_diff
tff(fact_626_add__right__imp__eq,axiom,
    ! [B: $tType] :
      ( cancel_semigroup_add(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4) )
         => ( B3 = Ca ) ) ) ).

% add_right_imp_eq
tff(fact_627_diff__add__eq__diff__diff__swap,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),Ca)),B3) ) ) ).

% diff_add_eq_diff_diff_swap
tff(fact_628_add__left__imp__eq,axiom,
    ! [B: $tType] :
      ( cancel_semigroup_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca) )
         => ( B3 = Ca ) ) ) ).

% add_left_imp_eq
tff(fact_629_ab__semigroup__add__class_Oadd_Oleft__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => ! [B3: B,A4: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) ) ) ).

% ab_semigroup_add_class.add.left_commute
tff(fact_630_ab__semigroup__add__class_Oadd_Ocommute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4) ) ) ).

% ab_semigroup_add_class.add.commute
tff(fact_631_add_Oright__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4) )
        <=> ( B3 = Ca ) ) ) ).

% add.right_cancel
tff(fact_632_diff__eq__diff__eq,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),Ca),D3) )
         => ( ( A4 = B3 )
          <=> ( Ca = D3 ) ) ) ) ).

% diff_eq_diff_eq
tff(fact_633_add_Oleft__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca) )
        <=> ( B3 = Ca ) ) ) ).

% add.left_cancel
tff(fact_634_diff__add__eq,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),B3) ) ) ).

% diff_add_eq
tff(fact_635_add_Oassoc,axiom,
    ! [B: $tType] :
      ( semigroup_add(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) ) ) ).

% add.assoc
tff(fact_636_diff__diff__eq2,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),B3) ) ) ).

% diff_diff_eq2
tff(fact_637_add__diff__eq,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),Ca) ) ) ).

% add_diff_eq
tff(fact_638_eq__diff__eq,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),minus_minus(B),Ca),B3) )
        <=> ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) = Ca ) ) ) ).

% eq_diff_eq
tff(fact_639_diff__eq__eq,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3) = Ca )
        <=> ( A4 = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3) ) ) ) ).

% diff_eq_eq
tff(fact_640_add_Oright__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),B3) ) ) ).

% add.right_commute
tff(fact_641_add_Oright__assoc,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) ) ) ).

% add.right_assoc
tff(fact_642_group__cancel_Osub1,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A3: B,K: B,A4: B,B3: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),A4) )
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)) ) ) ) ).

% group_cancel.sub1
tff(fact_643_group__cancel_Oadd2,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [B2: B,K: B,B3: B,A4: B] :
          ( ( B2 = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),B3) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) ) ) ) ).

% group_cancel.add2
tff(fact_644_group__cancel_Oadd1,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: B,K: B,A4: B,B3: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),A4) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) ) ) ) ).

% group_cancel.add1
tff(fact_645_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [I2: B,J2: B,K: B,L: B] :
          ( ( ( I2 = J2 )
            & ( K = L ) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K) = aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
tff(fact_646_fun__diff__def,axiom,
    ! [C: $tType,B: $tType] :
      ( minus(C)
     => ! [A3: fun(B,C),B2: fun(B,C),X4: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),minus_minus(fun(B,C)),A3),B2),X4) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(B,C,A3,X4)),aa(B,C,B2,X4)) ) ) ).

% fun_diff_def
tff(fact_647_eq__add__iff1,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A4: B,E2: B,Ca: B,B3: B,D3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),E2)),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),E2)),D3) )
        <=> ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),E2)),Ca) = D3 ) ) ) ).

% eq_add_iff1
tff(fact_648_eq__add__iff2,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A4: B,E2: B,Ca: B,B3: B,D3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),E2)),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),E2)),D3) )
        <=> ( Ca = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4)),E2)),D3) ) ) ) ).

% eq_add_iff2
tff(fact_649_square__diff__square__factored,axiom,
    ! [B: $tType] :
      ( comm_ring(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y)),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),Y)) ) ) ).

% square_diff_square_factored
tff(fact_650_imageE,axiom,
    ! [B: $tType,C: $tType,B3: B,F2: fun(C,B),A3: set(C)] :
      ( aa(set(B),$o,member(B,B3),aa(set(C),set(B),image2(C,B,F2),A3))
     => ~ ! [X: C] :
            ( ( B3 = aa(C,B,F2,X) )
           => ~ aa(set(C),$o,member(C,X),A3) ) ) ).

% imageE
tff(fact_651_image__image,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(C,B),G: fun(D,C),A3: set(D)] : ( aa(set(C),set(B),image2(C,B,F2),aa(set(D),set(C),image2(D,C,G),A3)) = aa(set(D),set(B),image2(D,B,aa(fun(D,C),fun(D,B),aTP_Lamp_cc(fun(C,B),fun(fun(D,C),fun(D,B)),F2),G)),A3) ) ).

% image_image
tff(fact_652_Compr__image__eq,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,B),A3: set(C),Pa: fun(B,$o)] : ( aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aa(set(C),fun(fun(B,$o),fun(B,$o)),aTP_Lamp_cd(fun(C,B),fun(set(C),fun(fun(B,$o),fun(B,$o))),F2),A3),Pa)) = aa(set(C),set(B),image2(C,B,F2),aa(fun(C,$o),set(C),collect(C),aa(fun(B,$o),fun(C,$o),aa(set(C),fun(fun(B,$o),fun(C,$o)),aTP_Lamp_ce(fun(C,B),fun(set(C),fun(fun(B,$o),fun(C,$o))),F2),A3),Pa))) ) ).

% Compr_image_eq
tff(fact_653_set__diff__eq,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_cf(set(B),fun(set(B),fun(B,$o)),A3),B2)) ) ).

% set_diff_eq
tff(fact_654_Times__Diff__distrib1,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(B),C2: set(C)] : ( product_Sigma(B,C,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2),aTP_Lamp_bq(set(C),fun(B,set(C)),C2)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),minus_minus(set(product_prod(B,C))),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),C2))),product_Sigma(B,C,B2,aTP_Lamp_bq(set(C),fun(B,set(C)),C2))) ) ).

% Times_Diff_distrib1
tff(fact_655_Sigma__Diff__distrib2,axiom,
    ! [C: $tType,B: $tType,I: set(B),A3: fun(B,set(C)),B2: fun(B,set(C))] : ( product_Sigma(B,C,I,aa(fun(B,set(C)),fun(B,set(C)),aTP_Lamp_cg(fun(B,set(C)),fun(fun(B,set(C)),fun(B,set(C))),A3),B2)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),minus_minus(set(product_prod(B,C))),product_Sigma(B,C,I,A3)),product_Sigma(B,C,I,B2)) ) ).

% Sigma_Diff_distrib2
tff(fact_656_square__diff__one__factored,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),X2)),one_one(B)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),one_one(B))),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),one_one(B))) ) ) ).

% square_diff_one_factored
tff(fact_657_eq__iff__diff__eq__0,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = B3 )
        <=> ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3) = zero_zero(B) ) ) ) ).

% eq_iff_diff_eq_0
tff(fact_658_right__diff__distrib_H,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ).

% right_diff_distrib'
tff(fact_659_left__diff__distrib_H,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [B3: B,Ca: B,A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),Ca)),A4) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)) ) ) ).

% left_diff_distrib'
tff(fact_660_right__diff__distrib,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ).

% right_diff_distrib
tff(fact_661_left__diff__distrib,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ).

% left_diff_distrib
tff(fact_662_minus__diff__commute,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [B3: B,A4: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),B3)),A4) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),A4)),B3) ) ) ).

% minus_diff_commute
tff(fact_663_add_Ogroup__left__neutral,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),zero_zero(B)),A4) = A4 ) ) ).

% add.group_left_neutral
tff(fact_664_add_Ocomm__neutral,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),zero_zero(B)) = A4 ) ) ).

% add.comm_neutral
tff(fact_665_comm__monoid__add__class_Oadd__0,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),zero_zero(B)),A4) = A4 ) ) ).

% comm_monoid_add_class.add_0
tff(fact_666_combine__common__factor,axiom,
    ! [B: $tType] :
      ( semiring(B)
     => ! [A4: B,E2: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),E2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),E2)),Ca)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),E2)),Ca) ) ) ).

% combine_common_factor
tff(fact_667_distrib__right,axiom,
    ! [B: $tType] :
      ( semiring(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ).

% distrib_right
tff(fact_668_distrib__left,axiom,
    ! [B: $tType] :
      ( semiring(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ).

% distrib_left
tff(fact_669_comm__semiring__class_Odistrib,axiom,
    ! [B: $tType] :
      ( comm_semiring(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ).

% comm_semiring_class.distrib
tff(fact_670_ring__class_Oring__distribs_I1_J,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ).

% ring_class.ring_distribs(1)
tff(fact_671_ring__class_Oring__distribs_I2_J,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ).

% ring_class.ring_distribs(2)
tff(fact_672_add_Oinverse__distrib__swap,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,uminus_uminus(B),A4)) ) ) ).

% add.inverse_distrib_swap
tff(fact_673_group__cancel_Oneg1,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A3: B,K: B,A4: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),A4) )
         => ( aa(B,B,uminus_uminus(B),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),K)),aa(B,B,uminus_uminus(B),A4)) ) ) ) ).

% group_cancel.neg1
tff(fact_674_dbl__dec__def,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [X2: B] : ( neg_numeral_dbl_dec(B,X2) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),X2)),one_one(B)) ) ) ).

% dbl_dec_def
tff(fact_675_Int__Diff,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),C2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)),C2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),C2)) ) ).

% Int_Diff
tff(fact_676_Diff__Int2,axiom,
    ! [B: $tType,A3: set(B),C2: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),C2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),C2)),B2) ) ).

% Diff_Int2
tff(fact_677_Diff__Diff__Int,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) ) ).

% Diff_Diff_Int
tff(fact_678_Diff__Int__distrib,axiom,
    ! [B: $tType,C2: set(B),A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C2),A3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C2),B2)) ) ).

% Diff_Int_distrib
tff(fact_679_Diff__Int__distrib2,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),C2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2)),C2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),C2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2)) ) ).

% Diff_Int_distrib2
tff(fact_680_add_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( semigroup_add(B)
     => semigroup(B,plus_plus(B)) ) ).

% add.semigroup_axioms
tff(fact_681_Setcompr__eq__image,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A3: set(C)] : ( aa(fun(B,$o),set(B),collect(B),aa(set(C),fun(B,$o),aTP_Lamp_ch(fun(C,B),fun(set(C),fun(B,$o)),F2),A3)) = aa(set(C),set(B),image2(C,B,F2),A3) ) ).

% Setcompr_eq_image
tff(fact_682_setcompr__eq__image,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),Pa: fun(C,$o)] : ( aa(fun(B,$o),set(B),collect(B),aa(fun(C,$o),fun(B,$o),aTP_Lamp_ci(fun(C,B),fun(fun(C,$o),fun(B,$o)),F2),Pa)) = aa(set(C),set(B),image2(C,B,F2),aa(fun(C,$o),set(C),collect(C),Pa)) ) ).

% setcompr_eq_image
tff(fact_683_range__composition,axiom,
    ! [B: $tType,D: $tType,C: $tType,F2: fun(D,B),G: fun(C,D)] : ( aa(set(C),set(B),image2(C,B,aa(fun(C,D),fun(C,B),aTP_Lamp_cj(fun(D,B),fun(fun(C,D),fun(C,B)),F2),G)),top_top(set(C))) = aa(set(D),set(B),image2(D,B,F2),aa(set(C),set(D),image2(C,D,G),top_top(set(C)))) ) ).

% range_composition
tff(fact_684_rangeE,axiom,
    ! [B: $tType,C: $tType,B3: B,F2: fun(C,B)] :
      ( aa(set(B),$o,member(B,B3),aa(set(C),set(B),image2(C,B,F2),top_top(set(C))))
     => ~ ! [X: C] : ( B3 != aa(C,B,F2,X) ) ) ).

% rangeE
tff(fact_685_add_Oac__operator__axioms,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => syntax_ac_operator(B,plus_plus(B)) ) ).

% add.ac_operator_axioms
tff(fact_686_add_Osafe__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => ! [X2: B,Y: B,A4: B,B3: B] :
          ( syntax7388354845996824322omatch(B,B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y),A4)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4) ) ) ) ).

% add.safe_commute
tff(fact_687_diff__eq,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),Y) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% diff_eq
tff(fact_688_neg__eq__iff__add__eq__0,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,uminus_uminus(B),A4) = B3 )
        <=> ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) = zero_zero(B) ) ) ) ).

% neg_eq_iff_add_eq_0
tff(fact_689_eq__neg__iff__add__eq__0,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = aa(B,B,uminus_uminus(B),B3) )
        <=> ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) = zero_zero(B) ) ) ) ).

% eq_neg_iff_add_eq_0
tff(fact_690_add_Oinverse__unique,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) = zero_zero(B) )
         => ( aa(B,B,uminus_uminus(B),A4) = B3 ) ) ) ).

% add.inverse_unique
tff(fact_691_ab__group__add__class_Oab__left__minus,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A4)),A4) = zero_zero(B) ) ) ).

% ab_group_add_class.ab_left_minus
tff(fact_692_add__eq__0__iff,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3) = zero_zero(B) )
        <=> ( B3 = aa(B,B,uminus_uminus(B),A4) ) ) ) ).

% add_eq_0_iff
tff(fact_693_disjoint__alt__simp1,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2) = A3 )
    <=> ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) ) ) ).

% disjoint_alt_simp1
tff(fact_694_disjoint__alt__simp2,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2) != A3 )
    <=> ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) != bot_bot(set(B)) ) ) ).

% disjoint_alt_simp2
tff(fact_695_Diff__triv,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2) = A3 ) ) ).

% Diff_triv
tff(fact_696_Int__Diff__disjoint,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2)) = bot_bot(set(B)) ) ).

% Int_Diff_disjoint
tff(fact_697_Diff__Un,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),C2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),C2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),C2)) ) ).

% Diff_Un
tff(fact_698_Diff__Int,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),C2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),C2)) ) ).

% Diff_Int
tff(fact_699_Int__Diff__Un,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2)) = A3 ) ).

% Int_Diff_Un
tff(fact_700_Un__Diff__Int,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = A3 ) ).

% Un_Diff_Int
tff(fact_701_add_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => comm_monoid(B,plus_plus(B),zero_zero(B)) ) ).

% add.comm_monoid_axioms
tff(fact_702_add_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => monoid(B,plus_plus(B),zero_zero(B)) ) ).

% add.monoid_axioms
tff(fact_703_full__SetCompr__eq,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B)] : ( aa(fun(B,$o),set(B),collect(B),aTP_Lamp_ck(fun(C,B),fun(B,$o),F2)) = aa(set(C),set(B),image2(C,B,F2),top_top(set(C))) ) ).

% full_SetCompr_eq
tff(fact_704_sum__list_Omonoid__list__axioms,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => groups_monoid_list(B,plus_plus(B),zero_zero(B)) ) ).

% sum_list.monoid_list_axioms
tff(fact_705_sum__list_Ocomm__monoid__list__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => groups1828464146339083142d_list(B,plus_plus(B),zero_zero(B)) ) ).

% sum_list.comm_monoid_list_axioms
tff(fact_706_sum_Ocomm__monoid__list__set__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => groups4802862169904069756st_set(B,plus_plus(B),zero_zero(B)) ) ).

% sum.comm_monoid_list_set_axioms
tff(fact_707_dbl__inc__def,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [X2: B] : ( neg_numeral_dbl_inc(B,X2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),X2)),one_one(B)) ) ) ).

% dbl_inc_def
tff(fact_708_surj__diff__right,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B] : ( aa(set(B),set(B),image2(B,B,aTP_Lamp_cl(B,fun(B,B),A4)),top_top(set(B))) = top_top(set(B)) ) ) ).

% surj_diff_right
tff(fact_709_surj__vimage__empty,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,B),A3: set(B)] :
      ( ( aa(set(C),set(B),image2(C,B,F2),top_top(set(C))) = top_top(set(B)) )
     => ( ( aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),F2),A3) = bot_bot(set(C)) )
      <=> ( A3 = bot_bot(set(B)) ) ) ) ).

% surj_vimage_empty
tff(fact_710_translation__subtract__Compl,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B,T3: set(B)] : ( aa(set(B),set(B),image2(B,B,aTP_Lamp_cl(B,fun(B,B),A4)),aa(set(B),set(B),uminus_uminus(set(B)),T3)) = aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),image2(B,B,aTP_Lamp_cl(B,fun(B,B),A4)),T3)) ) ) ).

% translation_subtract_Compl
tff(fact_711_translation__subtract__diff,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B,S2: set(B),T3: set(B)] : ( aa(set(B),set(B),image2(B,B,aTP_Lamp_cl(B,fun(B,B),A4)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),T3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),image2(B,B,aTP_Lamp_cl(B,fun(B,B),A4)),S2)),aa(set(B),set(B),image2(B,B,aTP_Lamp_cl(B,fun(B,B),A4)),T3)) ) ) ).

% translation_subtract_diff
tff(fact_712_translation__subtract__Int,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B,S2: set(B),T3: set(B)] : ( aa(set(B),set(B),image2(B,B,aTP_Lamp_cl(B,fun(B,B),A4)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),image2(B,B,aTP_Lamp_cl(B,fun(B,B),A4)),S2)),aa(set(B),set(B),image2(B,B,aTP_Lamp_cl(B,fun(B,B),A4)),T3)) ) ) ).

% translation_subtract_Int
tff(fact_713_translation__Int,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B,S2: set(B),T3: set(B)] : ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),plus_plus(B),A4)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),plus_plus(B),A4)),S2)),aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),plus_plus(B),A4)),T3)) ) ) ).

% translation_Int
tff(fact_714_add__scale__eq__noteq,axiom,
    ! [B: $tType] :
      ( semiri1453513574482234551roduct(B)
     => ! [R2: B,A4: B,B3: B,Ca: B,D3: B] :
          ( ( R2 != zero_zero(B) )
         => ( ( ( A4 = B3 )
              & ( Ca != D3 ) )
           => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),R2),Ca)) != aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),R2),D3)) ) ) ) ) ).

% add_scale_eq_noteq
tff(fact_715_sum__squares__eq__zero__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [X2: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y)) = zero_zero(B) )
        <=> ( ( X2 = zero_zero(B) )
            & ( Y = zero_zero(B) ) ) ) ) ).

% sum_squares_eq_zero_iff
tff(fact_716_pairself__image__cart,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A3: set(C),B2: set(C)] : ( aa(set(product_prod(C,C)),set(product_prod(B,B)),image2(product_prod(C,C),product_prod(B,B),pairself(C,B,F2)),product_Sigma(C,C,A3,aTP_Lamp_cm(set(C),fun(C,set(C)),B2))) = product_Sigma(B,B,aa(set(C),set(B),image2(C,B,F2),A3),aa(set(C),fun(B,set(B)),aTP_Lamp_cn(fun(C,B),fun(set(C),fun(B,set(B))),F2),B2)) ) ).

% pairself_image_cart
tff(fact_717_inf__period_I1_J,axiom,
    ! [B: $tType] :
      ( ( comm_ring(B)
        & dvd(B) )
     => ! [Pa: fun(B,$o),D2: B,Qa: fun(B,$o)] :
          ( ! [X: B,K2: B] :
              ( aa(B,$o,Pa,X)
            <=> aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X),aa(B,B,aa(B,fun(B,B),times_times(B),K2),D2))) )
         => ( ! [X: B,K2: B] :
                ( aa(B,$o,Qa,X)
              <=> aa(B,$o,Qa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X),aa(B,B,aa(B,fun(B,B),times_times(B),K2),D2))) )
           => ! [X4: B,K3: B] :
                ( ( aa(B,$o,Pa,X4)
                  & aa(B,$o,Qa,X4) )
              <=> ( aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X4),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D2)))
                  & aa(B,$o,Qa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X4),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D2))) ) ) ) ) ) ).

% inf_period(1)
tff(fact_718_minus__set__def,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2) = aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),minus_minus(fun(B,$o)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),B2))) ) ).

% minus_set_def
tff(fact_719_minus__assn__def,axiom,
    ! [A4: assn,B3: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),minus_minus(assn),A4),B3) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A4),aa(assn,assn,uminus_uminus(assn),B3)) ) ).

% minus_assn_def
tff(fact_720_crossproduct__eq,axiom,
    ! [B: $tType] :
      ( semiri1453513574482234551roduct(B)
     => ! [W2: B,Y: B,X2: B,Z2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y)),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Z2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Y)) )
        <=> ( ( W2 = X2 )
            | ( Y = Z2 ) ) ) ) ).

% crossproduct_eq
tff(fact_721_crossproduct__noteq,axiom,
    ! [B: $tType] :
      ( semiri1453513574482234551roduct(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( ( ( A4 != B3 )
            & ( Ca != D3 ) )
        <=> ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),D3)) != aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),D3)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ) ).

% crossproduct_noteq
tff(fact_722_inf__period_I2_J,axiom,
    ! [B: $tType] :
      ( ( comm_ring(B)
        & dvd(B) )
     => ! [Pa: fun(B,$o),D2: B,Qa: fun(B,$o)] :
          ( ! [X: B,K2: B] :
              ( aa(B,$o,Pa,X)
            <=> aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X),aa(B,B,aa(B,fun(B,B),times_times(B),K2),D2))) )
         => ( ! [X: B,K2: B] :
                ( aa(B,$o,Qa,X)
              <=> aa(B,$o,Qa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X),aa(B,B,aa(B,fun(B,B),times_times(B),K2),D2))) )
           => ! [X4: B,K3: B] :
                ( ( aa(B,$o,Pa,X4)
                  | aa(B,$o,Qa,X4) )
              <=> ( aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X4),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D2)))
                  | aa(B,$o,Qa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X4),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D2))) ) ) ) ) ) ).

% inf_period(2)
tff(fact_723_image__split__eq__Sigma,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(D,B),G: fun(D,C),A3: set(D)] : ( aa(set(D),set(product_prod(B,C)),image2(D,product_prod(B,C),aa(fun(D,C),fun(D,product_prod(B,C)),aTP_Lamp_co(fun(D,B),fun(fun(D,C),fun(D,product_prod(B,C))),F2),G)),A3) = product_Sigma(B,C,aa(set(D),set(B),image2(D,B,F2),A3),aa(set(D),fun(B,set(C)),aa(fun(D,C),fun(set(D),fun(B,set(C))),aTP_Lamp_cp(fun(D,B),fun(fun(D,C),fun(set(D),fun(B,set(C)))),F2),G),A3)) ) ).

% image_split_eq_Sigma
tff(fact_724_relImage__relInvImage,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,B)),F2: fun(C,B),A3: set(C)] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R),product_Sigma(B,B,aa(set(C),set(B),image2(C,B,F2),A3),aa(set(C),fun(B,set(B)),aTP_Lamp_cn(fun(C,B),fun(set(C),fun(B,set(B))),F2),A3)))
     => ( bNF_Gr4221423524335903396lImage(C,B,bNF_Gr7122648621184425601vImage(C,B,A3,R,F2),F2) = R ) ) ).

% relImage_relInvImage
tff(fact_725_pairself__image__eq,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),Pa: fun(C,fun(C,$o))] : ( aa(set(product_prod(C,C)),set(product_prod(B,B)),image2(product_prod(C,C),product_prod(B,B),pairself(C,B,F2)),aa(fun(product_prod(C,C),$o),set(product_prod(C,C)),collect(product_prod(C,C)),aa(fun(C,fun(C,$o)),fun(product_prod(C,C),$o),product_case_prod(C,C,$o),Pa))) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(C,fun(C,$o)),fun(product_prod(B,B),$o),aTP_Lamp_cq(fun(C,B),fun(fun(C,fun(C,$o)),fun(product_prod(B,B),$o)),F2),Pa)) ) ).

% pairself_image_eq
tff(fact_726_rtrancl__restrictI,axiom,
    ! [B: $tType,U: B,V: B,E3: set(product_prod(B,B)),R: set(B)] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V)),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),E3),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_cr(set(B),fun(B,set(B)),R)))))
     => ( ~ aa(set(B),$o,member(B,U),R)
       => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V)),transitive_rtrancl(B,rel_restrict(B,E3,R))) ) ) ).

% rtrancl_restrictI
tff(fact_727_the__elem__image__unique,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,C),X2: B] :
      ( ( A3 != bot_bot(set(B)) )
     => ( ! [Y2: B] :
            ( aa(set(B),$o,member(B,Y2),A3)
           => ( aa(B,C,F2,Y2) = aa(B,C,F2,X2) ) )
       => ( the_elem(C,aa(set(B),set(C),image2(B,C,F2),A3)) = aa(B,C,F2,X2) ) ) ) ).

% the_elem_image_unique
tff(fact_728_Sup_OSUP__identity__eq,axiom,
    ! [B: $tType,Sup: fun(set(B),B),A3: set(B)] : ( aa(set(B),B,Sup,aa(set(B),set(B),image2(B,B,aTP_Lamp_bk(B,B)),A3)) = aa(set(B),B,Sup,A3) ) ).

% Sup.SUP_identity_eq
tff(fact_729_Inf_OINF__identity__eq,axiom,
    ! [B: $tType,Inf: fun(set(B),B),A3: set(B)] : ( aa(set(B),B,Inf,aa(set(B),set(B),image2(B,B,aTP_Lamp_bk(B,B)),A3)) = aa(set(B),B,Inf,A3) ) ).

% Inf.INF_identity_eq
tff(fact_730_inj__on__Un,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),A3: set(B),B2: set(B)] :
      ( inj_on(B,C,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))
    <=> ( inj_on(B,C,F2,A3)
        & inj_on(B,C,F2,B2)
        & ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),image2(B,C,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))),aa(set(B),set(C),image2(B,C,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A3))) = bot_bot(set(C)) ) ) ) ).

% inj_on_Un
tff(fact_731_add_Ogroup__axioms,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => group(B,plus_plus(B),zero_zero(B),uminus_uminus(B)) ) ).

% add.group_axioms
tff(fact_732_vimage__fst,axiom,
    ! [C: $tType,B: $tType,A3: set(B)] : ( aa(set(B),set(product_prod(B,C)),aa(fun(product_prod(B,C),B),fun(set(B),set(product_prod(B,C))),vimage(product_prod(B,C),B),product_fst(B,C)),A3) = product_Sigma(B,C,A3,aTP_Lamp_bp(B,set(C))) ) ).

% vimage_fst
tff(fact_733_dual__order_Orefl,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),A4) ) ).

% dual_order.refl
tff(fact_734_order__refl,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),X2) ) ).

% order_refl
tff(fact_735_split__part,axiom,
    ! [C: $tType,B: $tType,Pa: $o,Qa: fun(B,fun(C,$o)),X4: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aTP_Lamp_cs($o,fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),Pa),Qa)),X4)
    <=> ( (Pa)
        & aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Qa),X4) ) ) ).

% split_part
tff(fact_736_le__zero__eq,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [N: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),N),zero_zero(B))
        <=> ( N = zero_zero(B) ) ) ) ).

% le_zero_eq
tff(fact_737_add__le__cancel__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ).

% add_le_cancel_right
tff(fact_738_add__le__cancel__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ).

% add_le_cancel_left
tff(fact_739_neg__le__iff__le,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,uminus_uminus(B),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ).

% neg_le_iff_le
tff(fact_740_compl__le__compl__iff,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),X2)),aa(B,B,uminus_uminus(B),Y))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2) ) ) ).

% compl_le_compl_iff
tff(fact_741_le__inf__iff,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Z2) ) ) ) ).

% le_inf_iff
tff(fact_742_inf_Obounded__iff,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),inf_inf(B),B3),Ca))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca) ) ) ) ).

% inf.bounded_iff
tff(fact_743_sup_Obounded__iff,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),B3),Ca)),A4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),A4) ) ) ) ).

% sup.bounded_iff
tff(fact_744_le__sup__iff,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)),Z2)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Z2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ) ).

% le_sup_iff
tff(fact_745_subset__empty,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),bot_bot(set(B)))
    <=> ( A3 = bot_bot(set(B)) ) ) ).

% subset_empty
tff(fact_746_empty__subsetI,axiom,
    ! [B: $tType,A3: set(B)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),bot_bot(set(B))),A3) ).

% empty_subsetI
tff(fact_747_singletonI,axiom,
    ! [B: $tType,A4: B] : aa(set(B),$o,member(B,A4),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) ).

% singletonI
tff(fact_748_Int__subset__iff,axiom,
    ! [B: $tType,C2: set(B),A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C2),A3)
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C2),B2) ) ) ).

% Int_subset_iff
tff(fact_749_Int__insert__left__if0,axiom,
    ! [B: $tType,A4: B,C2: set(B),B2: set(B)] :
      ( ~ aa(set(B),$o,member(B,A4),C2)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert(B,A4),B2)),C2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2) ) ) ).

% Int_insert_left_if0
tff(fact_750_Int__insert__left__if1,axiom,
    ! [B: $tType,A4: B,C2: set(B),B2: set(B)] :
      ( aa(set(B),$o,member(B,A4),C2)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert(B,A4),B2)),C2) = aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2)) ) ) ).

% Int_insert_left_if1
tff(fact_751_insert__inter__insert,axiom,
    ! [B: $tType,A4: B,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert(B,A4),A3)),aa(set(B),set(B),insert(B,A4),B2)) = aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ).

% insert_inter_insert
tff(fact_752_Int__insert__right__if0,axiom,
    ! [B: $tType,A4: B,A3: set(B),B2: set(B)] :
      ( ~ aa(set(B),$o,member(B,A4),A3)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),insert(B,A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) ) ) ).

% Int_insert_right_if0
tff(fact_753_Int__insert__right__if1,axiom,
    ! [B: $tType,A4: B,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,member(B,A4),A3)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),insert(B,A4),B2)) = aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ) ).

% Int_insert_right_if1
tff(fact_754_inj__on__empty,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C)] : inj_on(B,C,F2,bot_bot(set(B))) ).

% inj_on_empty
tff(fact_755_singleton__conv,axiom,
    ! [B: $tType,A4: B] : ( aa(fun(B,$o),set(B),collect(B),aTP_Lamp_ct(B,fun(B,$o),A4)) = aa(set(B),set(B),insert(B,A4),bot_bot(set(B))) ) ).

% singleton_conv
tff(fact_756_singleton__conv2,axiom,
    ! [B: $tType,A4: B] : ( aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),fequal(B),A4)) = aa(set(B),set(B),insert(B,A4),bot_bot(set(B))) ) ).

% singleton_conv2
tff(fact_757_case__prod__conv,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(C,fun(D,B)),A4: C,B3: D] : ( aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),F2),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),A4),B3)) = aa(D,B,aa(C,fun(D,B),F2,A4),B3) ) ).

% case_prod_conv
tff(fact_758_eq__or__mem__image__simp,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A4: C,B2: set(C)] : ( aa(fun(B,$o),set(B),collect(B),aa(set(C),fun(B,$o),aa(C,fun(set(C),fun(B,$o)),aTP_Lamp_cu(fun(C,B),fun(C,fun(set(C),fun(B,$o))),F2),A4),B2)) = aa(set(B),set(B),insert(B,aa(C,B,F2,A4)),aa(fun(B,$o),set(B),collect(B),aa(set(C),fun(B,$o),aTP_Lamp_ch(fun(C,B),fun(set(C),fun(B,$o)),F2),B2))) ) ).

% eq_or_mem_image_simp
tff(fact_759_case__prodI,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(C,$o)),A4: B,B3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),F2,A4),B3)
     => aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),F2),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B3)) ) ).

% case_prodI
tff(fact_760_case__prodI2,axiom,
    ! [C: $tType,B: $tType,P3: product_prod(B,C),Ca: fun(B,fun(C,$o))] :
      ( ! [A5: B,B4: C] :
          ( ( P3 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A5),B4) )
         => aa(C,$o,aa(B,fun(C,$o),Ca,A5),B4) )
     => aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Ca),P3) ) ).

% case_prodI2
tff(fact_761_Collect__case__prod,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),Qa: fun(C,$o)] : ( aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(fun(C,$o),fun(B,fun(C,$o)),aTP_Lamp_cv(fun(B,$o),fun(fun(C,$o),fun(B,fun(C,$o))),Pa),Qa))) = product_Sigma(B,C,aa(fun(B,$o),set(B),collect(B),Pa),aTP_Lamp_cw(fun(C,$o),fun(B,set(C)),Qa)) ) ).

% Collect_case_prod
tff(fact_762_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
tff(fact_763_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),A4)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B)) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
tff(fact_764_le__add__same__cancel2,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3) ) ) ).

% le_add_same_cancel2
tff(fact_765_le__add__same__cancel1,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3) ) ) ).

% le_add_same_cancel1
tff(fact_766_add__le__same__cancel2,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),B3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B)) ) ) ).

% add_le_same_cancel2
tff(fact_767_add__le__same__cancel1,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4)),B3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B)) ) ) ).

% add_le_same_cancel1
tff(fact_768_diff__ge__0__iff__ge,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ).

% diff_ge_0_iff_ge
tff(fact_769_neg__less__eq__nonneg,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A4)),A4)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4) ) ) ).

% neg_less_eq_nonneg
tff(fact_770_less__eq__neg__nonpos,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,uminus_uminus(B),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B)) ) ) ).

% less_eq_neg_nonpos
tff(fact_771_neg__le__0__iff__le,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A4)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4) ) ) ).

% neg_le_0_iff_le
tff(fact_772_neg__0__le__iff__le,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,uminus_uminus(B),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B)) ) ) ).

% neg_0_le_iff_le
tff(fact_773_le__add__diff__inverse2,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),B3) = A4 ) ) ) ).

% le_add_diff_inverse2
tff(fact_774_le__add__diff__inverse,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)) = A4 ) ) ) ).

% le_add_diff_inverse
tff(fact_775_singleton__insert__inj__eq_H,axiom,
    ! [B: $tType,A4: B,A3: set(B),B3: B] :
      ( ( aa(set(B),set(B),insert(B,A4),A3) = aa(set(B),set(B),insert(B,B3),bot_bot(set(B))) )
    <=> ( ( A4 = B3 )
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))) ) ) ).

% singleton_insert_inj_eq'
tff(fact_776_singleton__insert__inj__eq,axiom,
    ! [B: $tType,B3: B,A4: B,A3: set(B)] :
      ( ( aa(set(B),set(B),insert(B,B3),bot_bot(set(B))) = aa(set(B),set(B),insert(B,A4),A3) )
    <=> ( ( A4 = B3 )
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))) ) ) ).

% singleton_insert_inj_eq
tff(fact_777_disjoint__insert_I2_J,axiom,
    ! [B: $tType,A3: set(B),B3: B,B2: set(B)] :
      ( ( bot_bot(set(B)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),insert(B,B3),B2)) )
    <=> ( ~ aa(set(B),$o,member(B,B3),A3)
        & ( bot_bot(set(B)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) ) ) ) ).

% disjoint_insert(2)
tff(fact_778_disjoint__insert_I1_J,axiom,
    ! [B: $tType,B2: set(B),A4: B,A3: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),aa(set(B),set(B),insert(B,A4),A3)) = bot_bot(set(B)) )
    <=> ( ~ aa(set(B),$o,member(B,A4),B2)
        & ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),A3) = bot_bot(set(B)) ) ) ) ).

% disjoint_insert(1)
tff(fact_779_insert__disjoint_I2_J,axiom,
    ! [B: $tType,A4: B,A3: set(B),B2: set(B)] :
      ( ( bot_bot(set(B)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert(B,A4),A3)),B2) )
    <=> ( ~ aa(set(B),$o,member(B,A4),B2)
        & ( bot_bot(set(B)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) ) ) ) ).

% insert_disjoint(2)
tff(fact_780_insert__disjoint_I1_J,axiom,
    ! [B: $tType,A4: B,A3: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert(B,A4),A3)),B2) = bot_bot(set(B)) )
    <=> ( ~ aa(set(B),$o,member(B,A4),B2)
        & ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) ) ) ) ).

% insert_disjoint(1)
tff(fact_781_Diff__eq__empty__iff,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2) = bot_bot(set(B)) )
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2) ) ).

% Diff_eq_empty_iff
tff(fact_782_insert__Diff__single,axiom,
    ! [B: $tType,A4: B,A3: set(B)] : ( aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) = aa(set(B),set(B),insert(B,A4),A3) ) ).

% insert_Diff_single
tff(fact_783_pair__imageI,axiom,
    ! [D: $tType,C: $tType,B: $tType,A4: B,B3: C,A3: set(product_prod(B,C)),F2: fun(B,fun(C,D))] :
      ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B3)),A3)
     => aa(set(D),$o,member(D,aa(C,D,aa(B,fun(C,D),F2,A4),B3)),aa(set(product_prod(B,C)),set(D),image2(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),F2)),A3)) ) ).

% pair_imageI
tff(fact_784_the__elem__eq,axiom,
    ! [B: $tType,X2: B] : ( the_elem(B,aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = X2 ) ).

% the_elem_eq
tff(fact_785_Collect__const__case__prod,axiom,
    ! [C: $tType,B: $tType,Pa: $o] :
      ( aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_cx($o,fun(B,fun(C,$o)),Pa)))
      = $ite((Pa),top_top(set(product_prod(B,C))),bot_bot(set(product_prod(B,C)))) ) ).

% Collect_const_case_prod
tff(fact_786_subset__Compl__singleton,axiom,
    ! [B: $tType,A3: set(B),B3: B] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))))
    <=> ~ aa(set(B),$o,member(B,B3),A3) ) ).

% subset_Compl_singleton
tff(fact_787_range__constant,axiom,
    ! [C: $tType,B: $tType,X2: B] : ( aa(set(C),set(B),image2(C,B,aa(B,fun(C,B),aTP_Lamp_cy(B,fun(C,B)),X2)),top_top(set(C))) = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) ).

% range_constant
tff(fact_788_insert__Times__insert,axiom,
    ! [B: $tType,C: $tType,A4: B,A3: set(B),B3: C,B2: set(C)] : ( product_Sigma(B,C,aa(set(B),set(B),insert(B,A4),A3),aa(set(C),fun(B,set(C)),aTP_Lamp_cz(C,fun(set(C),fun(B,set(C))),B3),B2)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),insert(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B3)),aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),sup_sup(set(product_prod(B,C))),product_Sigma(B,C,A3,aa(set(C),fun(B,set(C)),aTP_Lamp_cz(C,fun(set(C),fun(B,set(C))),B3),B2))),product_Sigma(B,C,aa(set(B),set(B),insert(B,A4),A3),aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))) ) ).

% insert_Times_insert
tff(fact_789_fst__image__times,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: set(C)] :
      ( aa(set(product_prod(B,C)),set(B),image2(product_prod(B,C),B,product_fst(B,C)),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))
      = $ite(B2 = bot_bot(set(C)),bot_bot(set(B)),A3) ) ).

% fst_image_times
tff(fact_790_inj__on__insert,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),A4: B,A3: set(B)] :
      ( inj_on(B,C,F2,aa(set(B),set(B),insert(B,A4),A3))
    <=> ( inj_on(B,C,F2,A3)
        & ~ aa(set(C),$o,member(C,aa(B,C,F2,A4)),aa(set(B),set(C),image2(B,C,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) ) ).

% inj_on_insert
tff(fact_791_inj__on__id2,axiom,
    ! [B: $tType,A3: set(B)] : inj_on(B,B,aTP_Lamp_bk(B,B),A3) ).

% inj_on_id2
tff(fact_792_prod_Odisc__eq__case,axiom,
    ! [C: $tType,B: $tType,Prod: product_prod(B,C)] : aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_da(B,fun(C,$o))),Prod) ).

% prod.disc_eq_case
tff(fact_793_subset__singletonD,axiom,
    ! [B: $tType,A3: set(B),X2: B] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))
     => ( ( A3 = bot_bot(set(B)) )
        | ( A3 = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) ) ) ).

% subset_singletonD
tff(fact_794_subset__singleton__iff,axiom,
    ! [B: $tType,X5: set(B),A4: B] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X5),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))
    <=> ( ( X5 = bot_bot(set(B)) )
        | ( X5 = aa(set(B),set(B),insert(B,A4),bot_bot(set(B))) ) ) ) ).

% subset_singleton_iff
tff(fact_795_fst__def,axiom,
    ! [C: $tType,B: $tType,Prod: product_prod(B,C)] : ( aa(product_prod(B,C),B,product_fst(B,C),Prod) = aa(product_prod(B,C),B,aa(fun(B,fun(C,B)),fun(product_prod(B,C),B),product_case_prod(B,C,B),aTP_Lamp_cy(B,fun(C,B))),Prod) ) ).

% fst_def
tff(fact_796_order__antisym__conv,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Y: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
          <=> ( X2 = Y ) ) ) ) ).

% order_antisym_conv
tff(fact_797_linorder__le__cases,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2) ) ) ).

% linorder_le_cases
tff(fact_798_ord__le__eq__subst,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ord(C)
        & ord(B) )
     => ! [A4: B,B3: B,F2: fun(B,C),Ca: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( ( aa(B,C,F2,B3) = Ca )
           => ( ! [X: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),aa(B,C,F2,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,A4)),Ca) ) ) ) ) ).

% ord_le_eq_subst
tff(fact_799_ord__eq__le__subst,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ord(C)
        & ord(B) )
     => ! [A4: B,F2: fun(C,B),B3: C,Ca: C] :
          ( ( A4 = aa(C,B,F2,B3) )
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),B3),Ca)
           => ( ! [X: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),X),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(C,B,F2,X)),aa(C,B,F2,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(C,B,F2,Ca)) ) ) ) ) ).

% ord_eq_le_subst
tff(fact_800_linorder__linear,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
          | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2) ) ) ).

% linorder_linear
tff(fact_801_order__eq__refl,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B,Y: B] :
          ( ( X2 = Y )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y) ) ) ).

% order_eq_refl
tff(fact_802_order__subst2,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A4: B,B3: B,F2: fun(B,C),Ca: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,B3)),Ca)
           => ( ! [X: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),aa(B,C,F2,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,A4)),Ca) ) ) ) ) ).

% order_subst2
tff(fact_803_order__subst1,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A4: B,F2: fun(C,B),B3: C,Ca: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(C,B,F2,B3))
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),B3),Ca)
           => ( ! [X: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),X),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(C,B,F2,X)),aa(C,B,F2,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(C,B,F2,Ca)) ) ) ) ) ).

% order_subst1
tff(fact_804_Orderings_Oorder__eq__iff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = B3 )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ) ).

% Orderings.order_eq_iff
tff(fact_805_le__fun__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [F2: fun(B,C),G: fun(B,C)] :
          ( aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),F2),G)
        <=> ! [X3: B] : aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X3)),aa(B,C,G,X3)) ) ) ).

% le_fun_def
tff(fact_806_le__funI,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [F2: fun(B,C),G: fun(B,C)] :
          ( ! [X: B] : aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),aa(B,C,G,X))
         => aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),F2),G) ) ) ).

% le_funI
tff(fact_807_le__funE,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [F2: fun(B,C),G: fun(B,C),X2: B] :
          ( aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),F2),G)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X2)),aa(B,C,G,X2)) ) ) ).

% le_funE
tff(fact_808_le__funD,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [F2: fun(B,C),G: fun(B,C),X2: B] :
          ( aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),F2),G)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X2)),aa(B,C,G,X2)) ) ) ).

% le_funD
tff(fact_809_antisym,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
           => ( A4 = B3 ) ) ) ) ).

% antisym
tff(fact_810_dual__order_Otrans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),A4) ) ) ) ).

% dual_order.trans
tff(fact_811_dual__order_Oantisym,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
           => ( A4 = B3 ) ) ) ) ).

% dual_order.antisym
tff(fact_812_dual__order_Oeq__iff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = B3 )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ) ).

% dual_order.eq_iff
tff(fact_813_linorder__wlog,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Pa: fun(B,fun(B,$o)),A4: B,B3: B] :
          ( ! [A5: B,B4: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A5),B4)
             => aa(B,$o,aa(B,fun(B,$o),Pa,A5),B4) )
         => ( ! [A5: B,B4: B] :
                ( aa(B,$o,aa(B,fun(B,$o),Pa,B4),A5)
               => aa(B,$o,aa(B,fun(B,$o),Pa,A5),B4) )
           => aa(B,$o,aa(B,fun(B,$o),Pa,A4),B3) ) ) ) ).

% linorder_wlog
tff(fact_814_order__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Z2) ) ) ) ).

% order_trans
tff(fact_815_order_Otrans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca) ) ) ) ).

% order.trans
tff(fact_816_order__antisym,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2)
           => ( X2 = Y ) ) ) ) ).

% order_antisym
tff(fact_817_ord__le__eq__trans,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( ( B3 = Ca )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca) ) ) ) ).

% ord_le_eq_trans
tff(fact_818_ord__eq__le__trans,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( A4 = B3 )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca) ) ) ) ).

% ord_eq_le_trans
tff(fact_819_order__class_Oorder__eq__iff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X2: B,Y: B] :
          ( ( X2 = Y )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2) ) ) ) ).

% order_class.order_eq_iff
tff(fact_820_le__cases3,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
           => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) )
         => ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Z2) )
           => ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Z2)
               => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),Y) )
             => ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),Y)
                 => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2) )
               => ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2)
                   => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),X2) )
                 => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),X2)
                     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y) ) ) ) ) ) ) ) ).

% le_cases3
tff(fact_821_group_Oinverse__distrib__swap,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A4: B,B3: B] :
      ( group(B,F2,Z2,Inverse)
     => ( aa(B,B,Inverse,aa(B,B,aa(B,fun(B,B),F2,A4),B3)) = aa(B,B,aa(B,fun(B,B),F2,aa(B,B,Inverse,B3)),aa(B,B,Inverse,A4)) ) ) ).

% group.inverse_distrib_swap
tff(fact_822_nle__le,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
            & ( B3 != A4 ) ) ) ) ).

% nle_le
tff(fact_823_group_Ogroup__left__neutral,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A4: B] :
      ( group(B,F2,Z2,Inverse)
     => ( aa(B,B,aa(B,fun(B,B),F2,Z2),A4) = A4 ) ) ).

% group.group_left_neutral
tff(fact_824_group_Oinverse__neutral,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( group(B,F2,Z2,Inverse)
     => ( aa(B,B,Inverse,Z2) = Z2 ) ) ).

% group.inverse_neutral
tff(fact_825_group_Oinverse__inverse,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A4: B] :
      ( group(B,F2,Z2,Inverse)
     => ( aa(B,B,Inverse,aa(B,B,Inverse,A4)) = A4 ) ) ).

% group.inverse_inverse
tff(fact_826_group_Oinverse__unique,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A4: B,B3: B] :
      ( group(B,F2,Z2,Inverse)
     => ( ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = Z2 )
       => ( aa(B,B,Inverse,A4) = B3 ) ) ) ).

% group.inverse_unique
tff(fact_827_group_Oright__inverse,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A4: B] :
      ( group(B,F2,Z2,Inverse)
     => ( aa(B,B,aa(B,fun(B,B),F2,A4),aa(B,B,Inverse,A4)) = Z2 ) ) ).

% group.right_inverse
tff(fact_828_group_Oright__cancel,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),B3: B,A4: B,Ca: B] :
      ( group(B,F2,Z2,Inverse)
     => ( ( aa(B,B,aa(B,fun(B,B),F2,B3),A4) = aa(B,B,aa(B,fun(B,B),F2,Ca),A4) )
      <=> ( B3 = Ca ) ) ) ).

% group.right_cancel
tff(fact_829_group_Oleft__inverse,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A4: B] :
      ( group(B,F2,Z2,Inverse)
     => ( aa(B,B,aa(B,fun(B,B),F2,aa(B,B,Inverse,A4)),A4) = Z2 ) ) ).

% group.left_inverse
tff(fact_830_group_Oleft__cancel,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A4: B,B3: B,Ca: B] :
      ( group(B,F2,Z2,Inverse)
     => ( ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = aa(B,B,aa(B,fun(B,B),F2,A4),Ca) )
      <=> ( B3 = Ca ) ) ) ).

% group.left_cancel
tff(fact_831_nested__case__prod__simp,axiom,
    ! [E: $tType,B: $tType,D: $tType,C: $tType,F2: fun(C,fun(D,fun(E,B))),X2: product_prod(C,D),Y: E] : ( aa(E,B,aa(product_prod(C,D),fun(E,B),aa(fun(C,fun(D,fun(E,B))),fun(product_prod(C,D),fun(E,B)),product_case_prod(C,D,fun(E,B)),F2),X2),Y) = aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),aa(E,fun(C,fun(D,B)),aTP_Lamp_db(fun(C,fun(D,fun(E,B))),fun(E,fun(C,fun(D,B))),F2),Y)),X2) ) ).

% nested_case_prod_simp
tff(fact_832_fn__fst__conv,axiom,
    ! [C: $tType,D: $tType,B: $tType,F2: fun(B,D)] : ( aTP_Lamp_dc(fun(B,D),fun(product_prod(B,C),D),F2) = aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),aTP_Lamp_dd(fun(B,D),fun(B,fun(C,D)),F2)) ) ).

% fn_fst_conv
tff(fact_833_case__prod__app,axiom,
    ! [E: $tType,B: $tType,D: $tType,C: $tType,F2: fun(C,fun(D,fun(E,B))),X2: product_prod(C,D),Y: E] : ( aa(E,B,aa(product_prod(C,D),fun(E,B),aa(fun(C,fun(D,fun(E,B))),fun(product_prod(C,D),fun(E,B)),product_case_prod(C,D,fun(E,B)),F2),X2),Y) = aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),aa(E,fun(C,fun(D,B)),aTP_Lamp_db(fun(C,fun(D,fun(E,B))),fun(E,fun(C,fun(D,B))),F2),Y)),X2) ) ).

% case_prod_app
tff(fact_834_insert__compr,axiom,
    ! [B: $tType,A4: B,B2: set(B)] : ( aa(set(B),set(B),insert(B,A4),B2) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_de(B,fun(set(B),fun(B,$o)),A4),B2)) ) ).

% insert_compr
tff(fact_835_insert__Collect,axiom,
    ! [B: $tType,A4: B,Pa: fun(B,$o)] : ( aa(set(B),set(B),insert(B,A4),aa(fun(B,$o),set(B),collect(B),Pa)) = aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_df(B,fun(fun(B,$o),fun(B,$o)),A4),Pa)) ) ).

% insert_Collect
tff(fact_836_prod_Ocase__distrib,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,H2: fun(C,B),F2: fun(D,fun(E,C)),Prod: product_prod(D,E)] : ( aa(C,B,H2,aa(product_prod(D,E),C,aa(fun(D,fun(E,C)),fun(product_prod(D,E),C),product_case_prod(D,E,C),F2),Prod)) = aa(product_prod(D,E),B,aa(fun(D,fun(E,B)),fun(product_prod(D,E),B),product_case_prod(D,E,B),aa(fun(D,fun(E,C)),fun(D,fun(E,B)),aTP_Lamp_dg(fun(C,B),fun(fun(D,fun(E,C)),fun(D,fun(E,B))),H2),F2)),Prod) ) ).

% prod.case_distrib
tff(fact_837_subset__CollectI,axiom,
    ! [B: $tType,B2: set(B),A3: set(B),Qa: fun(B,$o),Pa: fun(B,$o)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A3)
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),B2)
           => ( aa(B,$o,Qa,X)
             => aa(B,$o,Pa,X) ) )
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),B2),Qa))),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),A3),Pa))) ) ) ).

% subset_CollectI
tff(fact_838_subset__Collect__iff,axiom,
    ! [B: $tType,B2: set(B),A3: set(B),Pa: fun(B,$o)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),A3),Pa)))
      <=> ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),B2)
           => aa(B,$o,Pa,X3) ) ) ) ).

% subset_Collect_iff
tff(fact_839_Collect__subset,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,$o)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),A3),Pa))),A3) ).

% Collect_subset
tff(fact_840_inj__fun,axiom,
    ! [C: $tType,D: $tType,B: $tType,F2: fun(B,C)] :
      ( inj_on(B,C,F2,top_top(set(B)))
     => inj_on(B,fun(D,C),aTP_Lamp_di(fun(B,C),fun(B,fun(D,C)),F2),top_top(set(B))) ) ).

% inj_fun
tff(fact_841_inj__singleton,axiom,
    ! [B: $tType,A3: set(B)] : inj_on(B,set(B),aTP_Lamp_dj(B,set(B)),A3) ).

% inj_singleton
tff(fact_842_case__prod__unfold,axiom,
    ! [D: $tType,C: $tType,B: $tType,X4: fun(B,fun(C,D)),Xa3: product_prod(B,C)] : ( aa(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),X4),Xa3) = aa(C,D,aa(B,fun(C,D),X4,aa(product_prod(B,C),B,product_fst(B,C),Xa3)),aa(product_prod(B,C),C,product_snd(B,C),Xa3)) ) ).

% case_prod_unfold
tff(fact_843_case__prod__beta_H,axiom,
    ! [D: $tType,C: $tType,B: $tType,F2: fun(B,fun(C,D)),X4: product_prod(B,C)] : ( aa(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),F2),X4) = aa(C,D,aa(B,fun(C,D),F2,aa(product_prod(B,C),B,product_fst(B,C),X4)),aa(product_prod(B,C),C,product_snd(B,C),X4)) ) ).

% case_prod_beta'
tff(fact_844_split__comp__eq,axiom,
    ! [C: $tType,D: $tType,E: $tType,B: $tType,F2: fun(E,fun(C,D)),G: fun(B,E)] : ( aa(fun(B,E),fun(product_prod(B,C),D),aTP_Lamp_dk(fun(E,fun(C,D)),fun(fun(B,E),fun(product_prod(B,C),D)),F2),G) = aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),aa(fun(B,E),fun(B,fun(C,D)),aTP_Lamp_dl(fun(E,fun(C,D)),fun(fun(B,E),fun(B,fun(C,D))),F2),G)) ) ).

% split_comp_eq
tff(fact_845_Times__subset__cancel2,axiom,
    ! [B: $tType,C: $tType,X2: B,C2: set(B),A3: set(C),B2: set(C)] :
      ( aa(set(B),$o,member(B,X2),C2)
     => ( aa(set(product_prod(C,B)),$o,aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),$o),ord_less_eq(set(product_prod(C,B))),product_Sigma(C,B,A3,aTP_Lamp_bv(set(B),fun(C,set(B)),C2))),product_Sigma(C,B,B2,aTP_Lamp_bv(set(B),fun(C,set(B)),C2)))
      <=> aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),A3),B2) ) ) ).

% Times_subset_cancel2
tff(fact_846_inj__on__image__Int,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),C2: set(B),A3: set(B),B2: set(B)] :
      ( inj_on(B,C,F2,C2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),C2)
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),C2)
         => ( aa(set(B),set(C),image2(B,C,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),image2(B,C,F2),A3)),aa(set(B),set(C),image2(B,C,F2),B2)) ) ) ) ) ).

% inj_on_image_Int
tff(fact_847_Diff__single__insert,axiom,
    ! [B: $tType,A3: set(B),X2: B,B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),B2)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),insert(B,X2),B2)) ) ).

% Diff_single_insert
tff(fact_848_subset__insert__iff,axiom,
    ! [B: $tType,A3: set(B),X2: B,B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),insert(B,X2),B2))
    <=> $ite(aa(set(B),$o,member(B,X2),A3),aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),B2),aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)) ) ).

% subset_insert_iff
tff(fact_849_inj__on__Int,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),A3: set(B),B2: set(B)] :
      ( ( inj_on(B,C,F2,A3)
        | inj_on(B,C,F2,B2) )
     => inj_on(B,C,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ).

% inj_on_Int
tff(fact_850_singletonD,axiom,
    ! [B: $tType,B3: B,A4: B] :
      ( aa(set(B),$o,member(B,B3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))
     => ( B3 = A4 ) ) ).

% singletonD
tff(fact_851_singleton__iff,axiom,
    ! [B: $tType,B3: B,A4: B] :
      ( aa(set(B),$o,member(B,B3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))
    <=> ( B3 = A4 ) ) ).

% singleton_iff
tff(fact_852_doubleton__eq__iff,axiom,
    ! [B: $tType,A4: B,B3: B,Ca: B,D3: B] :
      ( ( aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))) = aa(set(B),set(B),insert(B,Ca),aa(set(B),set(B),insert(B,D3),bot_bot(set(B)))) )
    <=> ( ( ( A4 = Ca )
          & ( B3 = D3 ) )
        | ( ( A4 = D3 )
          & ( B3 = Ca ) ) ) ) ).

% doubleton_eq_iff
tff(fact_853_insert__not__empty,axiom,
    ! [B: $tType,A4: B,A3: set(B)] : ( aa(set(B),set(B),insert(B,A4),A3) != bot_bot(set(B)) ) ).

% insert_not_empty
tff(fact_854_singleton__inject,axiom,
    ! [B: $tType,A4: B,B3: B] :
      ( ( aa(set(B),set(B),insert(B,A4),bot_bot(set(B))) = aa(set(B),set(B),insert(B,B3),bot_bot(set(B))) )
     => ( A4 = B3 ) ) ).

% singleton_inject
tff(fact_855_zero__le,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [X2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X2) ) ).

% zero_le
tff(fact_856_add__le__imp__le__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ).

% add_le_imp_le_right
tff(fact_857_add__le__imp__le__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ).

% add_le_imp_le_left
tff(fact_858_le__iff__add,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
        <=> ? [C4: B] : ( B3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),C4) ) ) ) ).

% le_iff_add
tff(fact_859_add__right__mono,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) ) ) ).

% add_right_mono
tff(fact_860_less__eqE,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ~ ! [C3: B] : ( B3 != aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),C3) ) ) ) ).

% less_eqE
tff(fact_861_add__left__mono,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3)) ) ) ).

% add_left_mono
tff(fact_862_add__mono,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),D3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),D3)) ) ) ) ).

% add_mono
tff(fact_863_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [I2: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),I2),J2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(1)
tff(fact_864_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [I2: B,J2: B,K: B,L: B] :
          ( ( ( I2 = J2 )
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(2)
tff(fact_865_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [I2: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),I2),J2)
            & ( K = L ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(3)
tff(fact_866_Int__insert__left,axiom,
    ! [B: $tType,A4: B,B2: set(B),C2: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert(B,A4),B2)),C2)
      = $ite(aa(set(B),$o,member(B,A4),C2),aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C2)) ) ).

% Int_insert_left
tff(fact_867_Int__insert__right,axiom,
    ! [B: $tType,A3: set(B),A4: B,B2: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),insert(B,A4),B2))
      = $ite(aa(set(B),$o,member(B,A4),A3),aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ).

% Int_insert_right
tff(fact_868_le__numeral__extra_I4_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),one_one(B)) ) ).

% le_numeral_extra(4)
tff(fact_869_diff__eq__diff__less__eq,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),Ca),D3) )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),D3) ) ) ) ).

% diff_eq_diff_less_eq
tff(fact_870_diff__right__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),Ca)) ) ) ).

% diff_right_mono
tff(fact_871_diff__left__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ca),B3)) ) ) ).

% diff_left_mono
tff(fact_872_diff__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B,D3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),D3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),D3)) ) ) ) ).

% diff_mono
tff(fact_873_bot_Oextremum__uniqueI,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),bot_bot(B))
         => ( A4 = bot_bot(B) ) ) ) ).

% bot.extremum_uniqueI
tff(fact_874_bot_Oextremum__unique,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),bot_bot(B))
        <=> ( A4 = bot_bot(B) ) ) ) ).

% bot.extremum_unique
tff(fact_875_bot_Oextremum,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),bot_bot(B)),A4) ) ).

% bot.extremum
tff(fact_876_le__imp__neg__le,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,uminus_uminus(B),A4)) ) ) ).

% le_imp_neg_le
tff(fact_877_minus__le__iff,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A4)),B3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),B3)),A4) ) ) ).

% minus_le_iff
tff(fact_878_le__minus__iff,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,uminus_uminus(B),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,uminus_uminus(B),A4)) ) ) ).

% le_minus_iff
tff(fact_879_compl__le__swap2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),Y)),X2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),X2)),Y) ) ) ).

% compl_le_swap2
tff(fact_880_compl__le__swap1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),aa(B,B,uminus_uminus(B),X2))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% compl_le_swap1
tff(fact_881_compl__mono,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),Y)),aa(B,B,uminus_uminus(B),X2)) ) ) ).

% compl_mono
tff(fact_882_top_Oextremum__uniqueI,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),top_top(B)),A4)
         => ( A4 = top_top(B) ) ) ) ).

% top.extremum_uniqueI
tff(fact_883_top_Oextremum__unique,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),top_top(B)),A4)
        <=> ( A4 = top_top(B) ) ) ) ).

% top.extremum_unique
tff(fact_884_top__greatest,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),top_top(B)) ) ).

% top_greatest
tff(fact_885_inf__sup__ord_I2_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),Y) ) ).

% inf_sup_ord(2)
tff(fact_886_inf__sup__ord_I1_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),X2) ) ).

% inf_sup_ord(1)
tff(fact_887_inf__le1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),X2) ) ).

% inf_le1
tff(fact_888_inf__le2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),Y) ) ).

% inf_le2
tff(fact_889_le__infE,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3))
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),A4)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),B3) ) ) ) ).

% le_infE
tff(fact_890_le__infI,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)) ) ) ) ).

% le_infI
tff(fact_891_inf__mono,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,Ca: B,B3: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),D3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),aa(B,B,aa(B,fun(B,B),inf_inf(B),Ca),D3)) ) ) ) ).

% inf_mono
tff(fact_892_le__infI1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,X2: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),X2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),X2) ) ) ).

% le_infI1
tff(fact_893_le__infI2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [B3: B,X2: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),X2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),X2) ) ) ).

% le_infI2
tff(fact_894_inf_OorderE,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( A4 = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) ) ) ) ).

% inf.orderE
tff(fact_895_inf_OorderI,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ).

% inf.orderI
tff(fact_896_inf__unique,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [F2: fun(B,fun(B,B)),X2: B,Y: B] :
          ( ! [X: B,Y2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),F2,X),Y2)),X)
         => ( ! [X: B,Y2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),F2,X),Y2)),Y2)
           => ( ! [X: B,Y2: B,Z3: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y2)
                 => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Z3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),F2,Y2),Z3)) ) )
             => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) = aa(B,B,aa(B,fun(B,B),F2,X2),Y) ) ) ) ) ) ).

% inf_unique
tff(fact_897_le__iff__inf,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
        <=> ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) = X2 ) ) ) ).

% le_iff_inf
tff(fact_898_inf_Oabsorb1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) = A4 ) ) ) ).

% inf.absorb1
tff(fact_899_inf_Oabsorb2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) = B3 ) ) ) ).

% inf.absorb2
tff(fact_900_inf__absorb1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) = X2 ) ) ) ).

% inf_absorb1
tff(fact_901_inf__absorb2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Y: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) = Y ) ) ) ).

% inf_absorb2
tff(fact_902_inf_OboundedE,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),inf_inf(B),B3),Ca))
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca) ) ) ) ).

% inf.boundedE
tff(fact_903_inf_OboundedI,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),inf_inf(B),B3),Ca)) ) ) ) ).

% inf.boundedI
tff(fact_904_inf__greatest,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) ) ) ) ).

% inf_greatest
tff(fact_905_inf_Oorder__iff,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
        <=> ( A4 = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) ) ) ) ).

% inf.order_iff
tff(fact_906_inf_Ocobounded1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),A4) ) ).

% inf.cobounded1
tff(fact_907_inf_Ocobounded2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),B3) ) ).

% inf.cobounded2
tff(fact_908_inf_Oabsorb__iff1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
        <=> ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) = A4 ) ) ) ).

% inf.absorb_iff1
tff(fact_909_inf_Oabsorb__iff2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
        <=> ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) = B3 ) ) ) ).

% inf.absorb_iff2
tff(fact_910_inf_OcoboundedI1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),Ca) ) ) ).

% inf.coboundedI1
tff(fact_911_inf_OcoboundedI2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),Ca)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),Ca) ) ) ).

% inf.coboundedI2
tff(fact_912_sup_OcoboundedI2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ) ).

% sup.coboundedI2
tff(fact_913_sup_OcoboundedI1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ) ).

% sup.coboundedI1
tff(fact_914_sup_Oabsorb__iff2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
        <=> ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) = B3 ) ) ) ).

% sup.absorb_iff2
tff(fact_915_sup_Oabsorb__iff1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
        <=> ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) = A4 ) ) ) ).

% sup.absorb_iff1
tff(fact_916_sup_Ocobounded2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,A4: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ).

% sup.cobounded2
tff(fact_917_sup_Ocobounded1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ).

% sup.cobounded1
tff(fact_918_sup_Oorder__iff,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
        <=> ( A4 = aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) ) ) ) ).

% sup.order_iff
tff(fact_919_sup_OboundedI,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),A4)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),B3),Ca)),A4) ) ) ) ).

% sup.boundedI
tff(fact_920_sup_OboundedE,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),B3),Ca)),A4)
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),A4) ) ) ) ).

% sup.boundedE
tff(fact_921_sup__absorb2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) = Y ) ) ) ).

% sup_absorb2
tff(fact_922_sup__absorb1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Y: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) = X2 ) ) ) ).

% sup_absorb1
tff(fact_923_sup_Oabsorb2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) = B3 ) ) ) ).

% sup.absorb2
tff(fact_924_sup_Oabsorb1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) = A4 ) ) ) ).

% sup.absorb1
tff(fact_925_sup__unique,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [F2: fun(B,fun(B,B)),X2: B,Y: B] :
          ( ! [X: B,Y2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),F2,X),Y2))
         => ( ! [X: B,Y2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),aa(B,B,aa(B,fun(B,B),F2,X),Y2))
           => ( ! [X: B,Y2: B,Z3: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),X)
                 => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z3),X)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),F2,Y2),Z3)),X) ) )
             => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) = aa(B,B,aa(B,fun(B,B),F2,X2),Y) ) ) ) ) ) ).

% sup_unique
tff(fact_926_sup_OorderI,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ).

% sup.orderI
tff(fact_927_sup_OorderE,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( A4 = aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) ) ) ) ).

% sup.orderE
tff(fact_928_le__iff__sup,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
        <=> ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) = Y ) ) ) ).

% le_iff_sup
tff(fact_929_sup__least,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Y: B,X2: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),X2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)),X2) ) ) ) ).

% sup_least
tff(fact_930_sup__mono,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,Ca: B,B3: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),D3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)),aa(B,B,aa(B,fun(B,B),sup_sup(B),Ca),D3)) ) ) ) ).

% sup_mono
tff(fact_931_sup_Omono,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ca: B,A4: B,D3: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),D3),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Ca),D3)),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ) ) ).

% sup.mono
tff(fact_932_le__supI2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ) ).

% le_supI2
tff(fact_933_le__supI1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ) ).

% le_supI1
tff(fact_934_sup__ge2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Y: B,X2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)) ) ).

% sup_ge2
tff(fact_935_sup__ge1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)) ) ).

% sup_ge1
tff(fact_936_le__supI,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,X2: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),X2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),X2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)),X2) ) ) ) ).

% le_supI
tff(fact_937_le__supE,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,B3: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)),X2)
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),X2)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),X2) ) ) ) ).

% le_supE
tff(fact_938_inf__sup__ord_I3_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)) ) ).

% inf_sup_ord(3)
tff(fact_939_inf__sup__ord_I4_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [Y: B,X2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)) ) ).

% inf_sup_ord(4)
tff(fact_940_times__subset__iff,axiom,
    ! [B: $tType,C: $tType,A3: set(B),C2: set(C),B2: set(B),D2: set(C)] :
      ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),C2))),product_Sigma(B,C,B2,aTP_Lamp_bq(set(C),fun(B,set(C)),D2)))
    <=> ( ( A3 = bot_bot(set(B)) )
        | ( C2 = bot_bot(set(C)) )
        | ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
          & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),C2),D2) ) ) ) ).

% times_subset_iff
tff(fact_941_inter__eq__subsetI,axiom,
    ! [B: $tType,S: set(B),S3: set(B),A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S),S3)
     => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),S3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),S3) )
       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),S) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),S) ) ) ) ).

% inter_eq_subsetI
tff(fact_942_Int__mono,axiom,
    ! [B: $tType,A3: set(B),C2: set(B),B2: set(B),D2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),C2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),D2)
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C2),D2)) ) ) ).

% Int_mono
tff(fact_943_Int__lower1,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)),A3) ).

% Int_lower1
tff(fact_944_Int__lower2,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)),B2) ).

% Int_lower2
tff(fact_945_Int__absorb1,axiom,
    ! [B: $tType,B2: set(B),A3: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A3)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = B2 ) ) ).

% Int_absorb1
tff(fact_946_Int__absorb2,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = A3 ) ) ).

% Int_absorb2
tff(fact_947_Int__greatest,axiom,
    ! [B: $tType,C2: set(B),A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C2),A3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C2),B2)
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ) ).

% Int_greatest
tff(fact_948_Int__Collect__mono,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),A3)
           => ( aa(B,$o,Pa,X)
             => aa(B,$o,Qa,X) ) )
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,$o),set(B),collect(B),Pa))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),aa(fun(B,$o),set(B),collect(B),Qa))) ) ) ).

% Int_Collect_mono
tff(fact_949_case__prodD,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(C,$o)),A4: B,B3: C] :
      ( aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),F2),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B3))
     => aa(C,$o,aa(B,fun(C,$o),F2,A4),B3) ) ).

% case_prodD
tff(fact_950_case__prodE,axiom,
    ! [B: $tType,C: $tType,Ca: fun(B,fun(C,$o)),P3: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Ca),P3)
     => ~ ! [X: B,Y2: C] :
            ( ( P3 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y2) )
           => ~ aa(C,$o,aa(B,fun(C,$o),Ca,X),Y2) ) ) ).

% case_prodE
tff(fact_951_inj__on__convol__ident,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),X5: set(B)] : inj_on(B,product_prod(B,C),aTP_Lamp_dm(fun(B,C),fun(B,product_prod(B,C)),F2),X5) ).

% inj_on_convol_ident
tff(fact_952_inj__Pair_I2_J,axiom,
    ! [C: $tType,B: $tType,Ca: fun(B,C),S: set(B)] : inj_on(B,product_prod(C,B),aTP_Lamp_dn(fun(B,C),fun(B,product_prod(C,B)),Ca),S) ).

% inj_Pair(2)
tff(fact_953_inj__Pair_I1_J,axiom,
    ! [C: $tType,B: $tType,Ca: fun(B,C),S: set(B)] : inj_on(B,product_prod(B,C),aTP_Lamp_dm(fun(B,C),fun(B,product_prod(B,C)),Ca),S) ).

% inj_Pair(1)
tff(fact_954_inj__on__add_H,axiom,
    ! [B: $tType] :
      ( cancel_semigroup_add(B)
     => ! [A4: B,A3: set(B)] : inj_on(B,B,aTP_Lamp_do(B,fun(B,B),A4),A3) ) ).

% inj_on_add'
tff(fact_955_Collect__case__prod__Sigma,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),Qa: fun(B,fun(C,$o))] : ( aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aTP_Lamp_dp(fun(B,$o),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),Pa),Qa))) = product_Sigma(B,C,aa(fun(B,$o),set(B),collect(B),Pa),aTP_Lamp_dq(fun(B,fun(C,$o)),fun(B,set(C)),Qa)) ) ).

% Collect_case_prod_Sigma
tff(fact_956_case__prodE2,axiom,
    ! [C: $tType,B: $tType,D: $tType,Qa: fun(B,$o),Pa: fun(C,fun(D,B)),Z2: product_prod(C,D)] :
      ( aa(B,$o,Qa,aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),Pa),Z2))
     => ~ ! [X: C,Y2: D] :
            ( ( Z2 = aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),X),Y2) )
           => ~ aa(B,$o,Qa,aa(D,B,aa(C,fun(D,B),Pa,X),Y2)) ) ) ).

% case_prodE2
tff(fact_957_case__prod__eta,axiom,
    ! [D: $tType,C: $tType,B: $tType,F2: fun(product_prod(B,C),D)] : ( aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),aTP_Lamp_dr(fun(product_prod(B,C),D),fun(B,fun(C,D)),F2)) = F2 ) ).

% case_prod_eta
tff(fact_958_cond__case__prod__eta,axiom,
    ! [D: $tType,C: $tType,B: $tType,F2: fun(B,fun(C,D)),G: fun(product_prod(B,C),D)] :
      ( ! [X: B,Y2: C] : ( aa(C,D,aa(B,fun(C,D),F2,X),Y2) = aa(product_prod(B,C),D,G,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y2)) )
     => ( aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),F2) = G ) ) ).

% cond_case_prod_eta
tff(fact_959_Collect__conv__if,axiom,
    ! [B: $tType,A4: B,Pa: fun(B,$o)] :
      ( aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_ds(B,fun(fun(B,$o),fun(B,$o)),A4),Pa))
      = $ite(aa(B,$o,Pa,A4),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))),bot_bot(set(B))) ) ).

% Collect_conv_if
tff(fact_960_Collect__conv__if2,axiom,
    ! [B: $tType,A4: B,Pa: fun(B,$o)] :
      ( aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_dt(B,fun(fun(B,$o),fun(B,$o)),A4),Pa))
      = $ite(aa(B,$o,Pa,A4),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))),bot_bot(set(B))) ) ).

% Collect_conv_if2
tff(fact_961_insert__def,axiom,
    ! [B: $tType,A4: B,B2: set(B)] : ( aa(set(B),set(B),insert(B,A4),B2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_ct(B,fun(B,$o),A4))),B2) ) ).

% insert_def
tff(fact_962_fn__snd__conv,axiom,
    ! [B: $tType,D: $tType,C: $tType,F2: fun(C,D)] : ( aTP_Lamp_du(fun(C,D),fun(product_prod(B,C),D),F2) = aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),aTP_Lamp_dv(fun(C,D),fun(B,fun(C,D)),F2)) ) ).

% fn_snd_conv
tff(fact_963_snd__def,axiom,
    ! [B: $tType,C: $tType,Prod: product_prod(C,B)] : ( aa(product_prod(C,B),B,product_snd(C,B),Prod) = aa(product_prod(C,B),B,aa(fun(C,fun(B,B)),fun(product_prod(C,B),B),product_case_prod(C,B,B),aTP_Lamp_dw(C,fun(B,B))),Prod) ) ).

% snd_def
tff(fact_964_Id__on__def_H,axiom,
    ! [B: $tType,A3: fun(B,$o)] : ( id_on(B,aa(fun(B,$o),set(B),collect(B),A3)) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aTP_Lamp_dx(fun(B,$o),fun(B,fun(B,$o)),A3))) ) ).

% Id_on_def'
tff(fact_965_subset__fst__snd,axiom,
    ! [C: $tType,B: $tType,A3: set(product_prod(B,C))] : aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),A3),product_Sigma(B,C,aa(set(product_prod(B,C)),set(B),image2(product_prod(B,C),B,product_fst(B,C)),A3),aTP_Lamp_dy(set(product_prod(B,C)),fun(B,set(C)),A3))) ).

% subset_fst_snd
tff(fact_966_inj__on__mult,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [A4: B,A3: set(B)] :
          ( ( A4 != zero_zero(B) )
         => inj_on(B,B,aa(B,fun(B,B),times_times(B),A4),A3) ) ) ).

% inj_on_mult
tff(fact_967_group_Oaxioms_I1_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( group(B,F2,Z2,Inverse)
     => semigroup(B,F2) ) ).

% group.axioms(1)
tff(fact_968_singleton__Un__iff,axiom,
    ! [B: $tType,X2: B,A3: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2) )
    <=> ( ( ( A3 = bot_bot(set(B)) )
          & ( B2 = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) )
        | ( ( A3 = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) )
          & ( B2 = bot_bot(set(B)) ) )
        | ( ( A3 = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) )
          & ( B2 = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) ) ) ) ).

% singleton_Un_iff
tff(fact_969_Un__singleton__iff,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),X2: B] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2) = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) )
    <=> ( ( ( A3 = bot_bot(set(B)) )
          & ( B2 = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) )
        | ( ( A3 = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) )
          & ( B2 = bot_bot(set(B)) ) )
        | ( ( A3 = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) )
          & ( B2 = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) ) ) ) ).

% Un_singleton_iff
tff(fact_970_insert__is__Un,axiom,
    ! [B: $tType,A4: B,A3: set(B)] : ( aa(set(B),set(B),insert(B,A4),A3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))),A3) ) ).

% insert_is_Un
tff(fact_971_add__decreasing,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),B3) ) ) ) ).

% add_decreasing
tff(fact_972_add__increasing,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)) ) ) ) ).

% add_increasing
tff(fact_973_add__decreasing2,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),B3) ) ) ) ).

% add_decreasing2
tff(fact_974_add__increasing2,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)) ) ) ) ).

% add_increasing2
tff(fact_975_add__nonneg__nonneg,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) ) ) ) ).

% add_nonneg_nonneg
tff(fact_976_add__nonpos__nonpos,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),zero_zero(B)) ) ) ) ).

% add_nonpos_nonpos
tff(fact_977_add__nonneg__eq__0__iff,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Y)
           => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y) = zero_zero(B) )
            <=> ( ( X2 = zero_zero(B) )
                & ( Y = zero_zero(B) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
tff(fact_978_add__nonpos__eq__0__iff,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),zero_zero(B))
           => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y) = zero_zero(B) )
            <=> ( ( X2 = zero_zero(B) )
                & ( Y = zero_zero(B) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
tff(fact_979_Diff__insert,axiom,
    ! [B: $tType,A3: set(B),A4: B,B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2)),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) ) ).

% Diff_insert
tff(fact_980_insert__Diff,axiom,
    ! [B: $tType,A4: B,A3: set(B)] :
      ( aa(set(B),$o,member(B,A4),A3)
     => ( aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) = A3 ) ) ).

% insert_Diff
tff(fact_981_Diff__insert2,axiom,
    ! [B: $tType,A3: set(B),A4: B,B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))),B2) ) ).

% Diff_insert2
tff(fact_982_Diff__insert__absorb,axiom,
    ! [B: $tType,X2: B,A3: set(B)] :
      ( ~ aa(set(B),$o,member(B,X2),A3)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),insert(B,X2),A3)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = A3 ) ) ).

% Diff_insert_absorb
tff(fact_983_insert__minus__eq,axiom,
    ! [B: $tType,X2: B,Y: B,A3: set(B)] :
      ( ( X2 != Y )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),insert(B,X2),A3)),aa(set(B),set(B),insert(B,Y),bot_bot(set(B)))) = aa(set(B),set(B),insert(B,X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,Y),bot_bot(set(B))))) ) ) ).

% insert_minus_eq
tff(fact_984_set__minus__singleton__eq,axiom,
    ! [B: $tType,X2: B,X5: set(B)] :
      ( ~ aa(set(B),$o,member(B,X2),X5)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),X5),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = X5 ) ) ).

% set_minus_singleton_eq
tff(fact_985_in__image__insert__iff,axiom,
    ! [B: $tType,B2: set(set(B)),X2: B,A3: set(B)] :
      ( ! [C5: set(B)] :
          ( aa(set(set(B)),$o,member(set(B),C5),B2)
         => ~ aa(set(B),$o,member(B,X2),C5) )
     => ( aa(set(set(B)),$o,member(set(B),A3),aa(set(set(B)),set(set(B)),image2(set(B),set(B),insert(B,X2)),B2))
      <=> ( aa(set(B),$o,member(B,X2),A3)
          & aa(set(set(B)),$o,member(set(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),B2) ) ) ) ).

% in_image_insert_iff
tff(fact_986_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [B: $tType] :
      ( ordere2520102378445227354miring(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
tff(fact_987_zero__le__mult__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),zero_zero(B)) ) ) ) ) ).

% zero_le_mult_iff
tff(fact_988_mult__nonneg__nonpos2,axiom,
    ! [B: $tType] :
      ( ordered_semiring_0(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4)),zero_zero(B)) ) ) ) ).

% mult_nonneg_nonpos2
tff(fact_989_mult__nonpos__nonneg,axiom,
    ! [B: $tType] :
      ( ordered_semiring_0(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),zero_zero(B)) ) ) ) ).

% mult_nonpos_nonneg
tff(fact_990_mult__nonneg__nonpos,axiom,
    ! [B: $tType] :
      ( ordered_semiring_0(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),zero_zero(B)) ) ) ) ).

% mult_nonneg_nonpos
tff(fact_991_mult__nonneg__nonneg,axiom,
    ! [B: $tType] :
      ( ordered_semiring_0(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ) ) ).

% mult_nonneg_nonneg
tff(fact_992_split__mult__neg__le,axiom,
    ! [B: $tType] :
      ( ordered_semiring_0(B)
     => ! [A4: B,B3: B] :
          ( ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),zero_zero(B)) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),zero_zero(B)) ) ) ).

% split_mult_neg_le
tff(fact_993_mult__le__0__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),zero_zero(B))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),zero_zero(B)) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3) ) ) ) ) ).

% mult_le_0_iff
tff(fact_994_mult__right__mono,axiom,
    ! [B: $tType] :
      ( ordered_semiring(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ) ).

% mult_right_mono
tff(fact_995_mult__right__mono__neg,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ) ).

% mult_right_mono_neg
tff(fact_996_mult__left__mono,axiom,
    ! [B: $tType] :
      ( ordered_semiring(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) ) ) ) ).

% mult_left_mono
tff(fact_997_mult__nonpos__nonpos,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ) ) ).

% mult_nonpos_nonpos
tff(fact_998_mult__left__mono__neg,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) ) ) ) ).

% mult_left_mono_neg
tff(fact_999_split__mult__pos__le,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A4: B,B3: B] :
          ( ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),zero_zero(B)) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ) ).

% split_mult_pos_le
tff(fact_1000_zero__le__square,axiom,
    ! [B: $tType] :
      ( linordered_ring(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),A4)) ) ).

% zero_le_square
tff(fact_1001_mult__mono_H,axiom,
    ! [B: $tType] :
      ( ordered_semiring(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),D3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),D3)) ) ) ) ) ) ).

% mult_mono'
tff(fact_1002_mult__mono,axiom,
    ! [B: $tType] :
      ( ordered_semiring(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),D3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),D3)) ) ) ) ) ) ).

% mult_mono
tff(fact_1003_not__one__le__zero,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),zero_zero(B)) ) ).

% not_one_le_zero
tff(fact_1004_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),one_one(B)) ) ).

% linordered_nonzero_semiring_class.zero_le_one
tff(fact_1005_zero__less__one__class_Ozero__le__one,axiom,
    ! [B: $tType] :
      ( zero_less_one(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),one_one(B)) ) ).

% zero_less_one_class.zero_le_one
tff(fact_1006_le__iff__diff__le__0,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),zero_zero(B)) ) ) ).

% le_iff_diff_le_0
tff(fact_1007_add__le__add__imp__diff__le,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [I2: B,K: B,N: B,J2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K)),N)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),N),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),K))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K)),N)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),N),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),K))
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),N),K)),J2) ) ) ) ) ) ).

% add_le_add_imp_diff_le
tff(fact_1008_add__le__imp__le__diff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [I2: B,K: B,N: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K)),N)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),I2),aa(B,B,aa(B,fun(B,B),minus_minus(B),N),K)) ) ) ).

% add_le_imp_le_diff
tff(fact_1009_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
           => ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4) = Ca )
            <=> ( B3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
tff(fact_1010_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4)) = B3 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
tff(fact_1011_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),Ca),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4)),B3) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
tff(fact_1012_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4)),Ca) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
tff(fact_1013_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4)),Ca) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)),A4) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
tff(fact_1014_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3)),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4)) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
tff(fact_1015_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3)),A4) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
tff(fact_1016_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4)),B3) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
tff(fact_1017_le__add__diff,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)),A4)) ) ) ).

% le_add_diff
tff(fact_1018_ordered__cancel__comm__monoid__diff__class_Odiff__add,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4)),A4) = B3 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add
tff(fact_1019_le__diff__eq,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ca),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),Ca) ) ) ).

% le_diff_eq
tff(fact_1020_diff__le__eq,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),Ca)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3)) ) ) ).

% diff_le_eq
tff(fact_1021_diff__shunt__var,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),Y) = bot_bot(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y) ) ) ).

% diff_shunt_var
tff(fact_1022_le__minus__one__simps_I4_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% le_minus_one_simps(4)
tff(fact_1023_le__minus__one__simps_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),one_one(B))),one_one(B)) ) ).

% le_minus_one_simps(2)
tff(fact_1024_distrib__sup__le,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B,Z2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2))),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Z2))) ) ).

% distrib_sup_le
tff(fact_1025_distrib__inf__le,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X2: B,Y: B,Z2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Z2))),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2))) ) ).

% distrib_inf_le
tff(fact_1026_vimage__singleton__eq,axiom,
    ! [B: $tType,C: $tType,A4: B,F2: fun(B,C),B3: C] :
      ( aa(set(B),$o,member(B,A4),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),aa(set(C),set(C),insert(C,B3),bot_bot(set(C)))))
    <=> ( aa(B,C,F2,A4) = B3 ) ) ).

% vimage_singleton_eq
tff(fact_1027_image__Int__subset,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A3: set(C),B2: set(C)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(C),set(B),image2(C,B,F2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),image2(C,B,F2),A3)),aa(set(C),set(B),image2(C,B,F2),B2))) ).

% image_Int_subset
tff(fact_1028_disjoint__mono,axiom,
    ! [B: $tType,A4: set(B),A7: set(B),B3: set(B),B6: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),A7)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B3),B6)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A7),B6) = bot_bot(set(B)) )
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3) = bot_bot(set(B)) ) ) ) ) ).

% disjoint_mono
tff(fact_1029_subset__minus__empty,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2) = bot_bot(set(B)) ) ) ).

% subset_minus_empty
tff(fact_1030_inj__diff__right,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B] : inj_on(B,B,aTP_Lamp_cl(B,fun(B,B),A4),top_top(set(B))) ) ).

% inj_diff_right
tff(fact_1031_Un__Int__assoc__eq,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),C2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)),C2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),C2)) )
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C2),A3) ) ).

% Un_Int_assoc_eq
tff(fact_1032_subset__Compl__self__eq,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),uminus_uminus(set(B)),A3))
    <=> ( A3 = bot_bot(set(B)) ) ) ).

% subset_Compl_self_eq
tff(fact_1033_rel__restrict__def,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),A3: set(B)] : ( rel_restrict(B,R,A3) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(B),fun(B,fun(B,$o)),aTP_Lamp_dz(set(product_prod(B,B)),fun(set(B),fun(B,fun(B,$o))),R),A3))) ) ).

% rel_restrict_def
tff(fact_1034_in__prod__fst__sndI,axiom,
    ! [B: $tType,C: $tType,X2: product_prod(B,C),A3: set(B),B2: set(C)] :
      ( aa(set(B),$o,member(B,aa(product_prod(B,C),B,product_fst(B,C),X2)),A3)
     => ( aa(set(C),$o,member(C,aa(product_prod(B,C),C,product_snd(B,C),X2)),B2)
       => aa(set(product_prod(B,C)),$o,member(product_prod(B,C),X2),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))) ) ) ).

% in_prod_fst_sndI
tff(fact_1035_mem__Times__iff,axiom,
    ! [B: $tType,C: $tType,X2: product_prod(B,C),A3: set(B),B2: set(C)] :
      ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),X2),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))
    <=> ( aa(set(B),$o,member(B,aa(product_prod(B,C),B,product_fst(B,C),X2)),A3)
        & aa(set(C),$o,member(C,aa(product_prod(B,C),C,product_snd(B,C),X2)),B2) ) ) ).

% mem_Times_iff
tff(fact_1036_image__constant__conv,axiom,
    ! [C: $tType,B: $tType,Ca: B,A3: set(C)] :
      ( aa(set(C),set(B),image2(C,B,aa(B,fun(C,B),aTP_Lamp_cy(B,fun(C,B)),Ca)),A3)
      = $ite(A3 = bot_bot(set(C)),bot_bot(set(B)),aa(set(B),set(B),insert(B,Ca),bot_bot(set(B)))) ) ).

% image_constant_conv
tff(fact_1037_image__constant,axiom,
    ! [B: $tType,C: $tType,X2: B,A3: set(B),Ca: C] :
      ( aa(set(B),$o,member(B,X2),A3)
     => ( aa(set(B),set(C),image2(B,C,aTP_Lamp_bm(C,fun(B,C),Ca)),A3) = aa(set(C),set(C),insert(C,Ca),bot_bot(set(C))) ) ) ).

% image_constant
tff(fact_1038_image__Int,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),A3: set(B),B2: set(B)] :
      ( inj_on(B,C,F2,top_top(set(B)))
     => ( aa(set(B),set(C),image2(B,C,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),image2(B,C,F2),A3)),aa(set(B),set(C),image2(B,C,F2),B2)) ) ) ).

% image_Int
tff(fact_1039_Id__on__subset__Times,axiom,
    ! [B: $tType,A3: set(B)] : aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),id_on(B,A3)),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))) ).

% Id_on_subset_Times
tff(fact_1040_range__eq__singletonD,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,B),A4: B,X2: C] :
      ( ( aa(set(C),set(B),image2(C,B,F2),top_top(set(C))) = aa(set(B),set(B),insert(B,A4),bot_bot(set(B))) )
     => ( aa(C,B,F2,X2) = A4 ) ) ).

% range_eq_singletonD
tff(fact_1041_sum__squares__ge__zero,axiom,
    ! [B: $tType] :
      ( linordered_ring(B)
     => ! [X2: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y))) ) ).

% sum_squares_ge_zero
tff(fact_1042_sum__squares__le__zero__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y))),zero_zero(B))
        <=> ( ( X2 = zero_zero(B) )
            & ( Y = zero_zero(B) ) ) ) ) ).

% sum_squares_le_zero_iff
tff(fact_1043_mult__left__le,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),A4) ) ) ) ).

% mult_left_le
tff(fact_1044_mult__le__one,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),one_one(B)) ) ) ) ) ).

% mult_le_one
tff(fact_1045_mult__right__le__one__le,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Y)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Y)),X2) ) ) ) ) ).

% mult_right_le_one_le
tff(fact_1046_mult__left__le__one__le,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Y)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Y),X2)),X2) ) ) ) ) ).

% mult_left_le_one_le
tff(fact_1047_rtrancl__last__visit__node,axiom,
    ! [B: $tType,S2: B,S4: B,R: set(product_prod(B,B)),Sh: B] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),S2),S4)),transitive_rtrancl(B,R))
     => ( ( ( S2 != Sh )
          & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),S2),S4)),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_ea(B,fun(B,set(B)),Sh))))) )
        | ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),S2),Sh)),transitive_rtrancl(B,R))
          & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Sh),S4)),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_ea(B,fun(B,set(B)),Sh))))) ) ) ) ).

% rtrancl_last_visit_node
tff(fact_1048_le__minus__one__simps_I3_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% le_minus_one_simps(3)
tff(fact_1049_le__minus__one__simps_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),one_one(B))),zero_zero(B)) ) ).

% le_minus_one_simps(1)
tff(fact_1050_le__add__iff1,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A4: B,E2: B,Ca: B,B3: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),E2)),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),E2)),D3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),E2)),Ca)),D3) ) ) ).

% le_add_iff1
tff(fact_1051_le__add__iff2,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A4: B,E2: B,Ca: B,B3: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),E2)),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),E2)),D3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4)),E2)),D3)) ) ) ).

% le_add_iff2
tff(fact_1052_inf__shunt,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y) = bot_bot(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% inf_shunt
tff(fact_1053_sup__shunt,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y) = top_top(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),X2)),Y) ) ) ).

% sup_shunt
tff(fact_1054_shunt1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)),Z2)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),Y)),Z2)) ) ) ).

% shunt1
tff(fact_1055_shunt2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,uminus_uminus(B),Y))),Z2)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) ) ) ).

% shunt2
tff(fact_1056_sup__neg__inf,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [P3: B,Q: B,R2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),P3),aa(B,B,aa(B,fun(B,B),sup_sup(B),Q),R2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),P3),aa(B,B,uminus_uminus(B),Q))),R2) ) ) ).

% sup_neg_inf
tff(fact_1057_vimage__insert,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),A4: C,B2: set(C)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),aa(set(C),set(C),insert(C,A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),aa(set(C),set(C),insert(C,A4),bot_bot(set(C))))),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),B2)) ) ).

% vimage_insert
tff(fact_1058_Compl__insert,axiom,
    ! [B: $tType,X2: B,A3: set(B)] : ( aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert(B,X2),A3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),uminus_uminus(set(B)),A3)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) ) ).

% Compl_insert
tff(fact_1059_disjoint__eq__subset__Compl,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),uminus_uminus(set(B)),B2)) ) ).

% disjoint_eq_subset_Compl
tff(fact_1060_Restr__rtrancl__mono,axiom,
    ! [B: $tType,V: B,W2: B,E3: set(product_prod(B,B)),U2: set(B)] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2)),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),E3),product_Sigma(B,B,U2,aTP_Lamp_cr(set(B),fun(B,set(B)),U2)))))
     => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2)),transitive_rtrancl(B,E3)) ) ).

% Restr_rtrancl_mono
tff(fact_1061_fst__image__Sigma,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: fun(B,set(C))] : ( aa(set(product_prod(B,C)),set(B),image2(product_prod(B,C),B,product_fst(B,C)),product_Sigma(B,C,A3,B2)) = aa(fun(B,$o),set(B),collect(B),aa(fun(B,set(C)),fun(B,$o),aTP_Lamp_eb(set(B),fun(fun(B,set(C)),fun(B,$o)),A3),B2)) ) ).

% fst_image_Sigma
tff(fact_1062_fs__contract,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(B,fun(C,D)),S: set(D)] : ( aa(set(product_prod(B,C)),set(B),image2(product_prod(B,C),B,product_fst(B,C)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(set(D),fun(product_prod(B,C),$o),aTP_Lamp_ec(fun(B,fun(C,D)),fun(set(D),fun(product_prod(B,C),$o)),F2),S))) = aa(fun(B,$o),set(B),collect(B),aa(set(D),fun(B,$o),aTP_Lamp_ed(fun(B,fun(C,D)),fun(set(D),fun(B,$o)),F2),S)) ) ).

% fs_contract
tff(fact_1063_homo__rel__restrict__mono,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),B2: set(B),A3: set(B)] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R),product_Sigma(B,B,B2,aTP_Lamp_cr(set(B),fun(B,set(B)),B2)))
     => aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),rel_restrict(B,R,A3)),product_Sigma(B,B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A3),aa(set(B),fun(B,set(B)),aTP_Lamp_ee(set(B),fun(set(B),fun(B,set(B))),B2),A3))) ) ).

% homo_rel_restrict_mono
tff(fact_1064_inj__on__disjoint__Un,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),A3: set(B),G: fun(B,C),B2: set(B)] :
      ( inj_on(B,C,F2,A3)
     => ( inj_on(B,C,G,B2)
       => ( ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),image2(B,C,F2),A3)),aa(set(B),set(C),image2(B,C,G),B2)) = bot_bot(set(C)) )
         => inj_on(B,C,aa(fun(B,C),fun(B,C),aa(set(B),fun(fun(B,C),fun(B,C)),aTP_Lamp_ef(fun(B,C),fun(set(B),fun(fun(B,C),fun(B,C))),F2),A3),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) ) ) ) ).

% inj_on_disjoint_Un
tff(fact_1065_convex__bound__le,axiom,
    ! [B: $tType] :
      ( linord6961819062388156250ring_1(B)
     => ! [X2: B,A4: B,Y: B,U: B,V: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),A4)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),U)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),V)
               => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),U),V) = one_one(B) )
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),U),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),V),Y))),A4) ) ) ) ) ) ) ).

% convex_bound_le
tff(fact_1066_rtrancl__last__touch,axiom,
    ! [B: $tType,Q: B,Q3: B,R: set(product_prod(B,B)),S: set(B)] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q),Q3)),transitive_rtrancl(B,R))
     => ( aa(set(B),$o,member(B,Q),S)
       => ~ ! [Qt: B] :
              ( aa(set(B),$o,member(B,Qt),S)
             => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q),Qt)),transitive_rtrancl(B,R))
               => ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Qt),Q3)),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_cr(set(B),fun(B,set(B)),S))))) ) ) ) ) ).

% rtrancl_last_touch
tff(fact_1067_rtrancl__last__visit_H,axiom,
    ! [B: $tType,Q: B,Q3: B,R: set(product_prod(B,B)),S: set(B)] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q),Q3)),transitive_rtrancl(B,R))
     => ( ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q),Q3)),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_cr(set(B),fun(B,set(B)),S)))))
       => ~ ! [Qt: B] :
              ( aa(set(B),$o,member(B,Qt),S)
             => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q),Qt)),transitive_rtrancl(B,R))
               => ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Qt),Q3)),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_cr(set(B),fun(B,set(B)),S))))) ) ) ) ) ).

% rtrancl_last_visit'
tff(fact_1068_inj__mult__left,axiom,
    ! [B: $tType] :
      ( idom(B)
     => ! [A4: B] :
          ( inj_on(B,B,aa(B,fun(B,B),times_times(B),A4),top_top(set(B)))
        <=> ( A4 != zero_zero(B) ) ) ) ).

% inj_mult_left
tff(fact_1069_rtrancl__insert,axiom,
    ! [B: $tType,A4: B,B3: B,R2: set(product_prod(B,B))] : ( transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),R2)) = aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),transitive_rtrancl(B,R2)),aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aa(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o))),aTP_Lamp_eg(B,fun(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o)))),A4),B3),R2)))) ) ).

% rtrancl_insert
tff(fact_1070_trancl__subset__Sigma__aux,axiom,
    ! [B: $tType,A4: B,B3: B,R2: set(product_prod(B,B)),A3: set(B)] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),transitive_rtrancl(B,R2))
     => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))
       => ( ( A4 = B3 )
          | aa(set(B),$o,member(B,A4),A3) ) ) ) ).

% trancl_subset_Sigma_aux
tff(fact_1071_inj__on__iff__surj,axiom,
    ! [C: $tType,B: $tType,A3: set(B),A10: set(C)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( ? [F8: fun(B,C)] :
            ( inj_on(B,C,F8,A3)
            & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,F8),A3)),A10) )
      <=> ? [G2: fun(C,B)] : ( aa(set(C),set(B),image2(C,B,G2),A10) = A3 ) ) ) ).

% inj_on_iff_surj
tff(fact_1072_Restr__subset,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),R2: set(product_prod(B,B))] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
     => ( aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,B2,aTP_Lamp_cr(set(B),fun(B,set(B)),B2)))),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))) = aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))) ) ) ).

% Restr_subset
tff(fact_1073_exE__realizer,axiom,
    ! [D: $tType,B: $tType,C: $tType,Pa: fun(B,fun(C,$o)),P3: product_prod(C,B),Qa: fun(D,$o),F2: fun(C,fun(B,D))] :
      ( aa(C,$o,aa(B,fun(C,$o),Pa,aa(product_prod(C,B),B,product_snd(C,B),P3)),aa(product_prod(C,B),C,product_fst(C,B),P3))
     => ( ! [X: C,Y2: B] :
            ( aa(C,$o,aa(B,fun(C,$o),Pa,Y2),X)
           => aa(D,$o,Qa,aa(B,D,aa(C,fun(B,D),F2,X),Y2)) )
       => aa(D,$o,Qa,aa(product_prod(C,B),D,aa(fun(C,fun(B,D)),fun(product_prod(C,B),D),product_case_prod(C,B,D),F2),P3)) ) ) ).

% exE_realizer
tff(fact_1074_sorted__list__of__set_Oinj__on,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => inj_on(B,B,aTP_Lamp_eh(B,B),top_top(set(B))) ) ).

% sorted_list_of_set.inj_on
tff(fact_1075_is__singleton__the__elem,axiom,
    ! [B: $tType,A3: set(B)] :
      ( is_singleton(B,A3)
    <=> ( A3 = aa(set(B),set(B),insert(B,the_elem(B,A3)),bot_bot(set(B))) ) ) ).

% is_singleton_the_elem
tff(fact_1076_image__Collect__subsetI,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),F2: fun(B,C),B2: set(C)] :
      ( ! [X: B] :
          ( aa(B,$o,Pa,X)
         => aa(set(C),$o,member(C,aa(B,C,F2,X)),B2) )
     => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,F2),aa(fun(B,$o),set(B),collect(B),Pa))),B2) ) ).

% image_Collect_subsetI
tff(fact_1077_less__by__empty,axiom,
    ! [B: $tType,A3: set(product_prod(B,B)),B2: set(product_prod(B,B))] :
      ( ( A3 = bot_bot(set(product_prod(B,B))) )
     => aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),A3),B2) ) ).

% less_by_empty
tff(fact_1078_mem__case__prodI2,axiom,
    ! [D: $tType,C: $tType,B: $tType,P3: product_prod(B,C),Z2: D,Ca: fun(B,fun(C,set(D)))] :
      ( ! [A5: B,B4: C] :
          ( ( P3 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A5),B4) )
         => aa(set(D),$o,member(D,Z2),aa(C,set(D),aa(B,fun(C,set(D)),Ca,A5),B4)) )
     => aa(set(D),$o,member(D,Z2),aa(product_prod(B,C),set(D),aa(fun(B,fun(C,set(D))),fun(product_prod(B,C),set(D)),product_case_prod(B,C,set(D)),Ca),P3)) ) ).

% mem_case_prodI2
tff(fact_1079_mem__case__prodI,axiom,
    ! [B: $tType,C: $tType,D: $tType,Z2: B,Ca: fun(C,fun(D,set(B))),A4: C,B3: D] :
      ( aa(set(B),$o,member(B,Z2),aa(D,set(B),aa(C,fun(D,set(B)),Ca,A4),B3))
     => aa(set(B),$o,member(B,Z2),aa(product_prod(C,D),set(B),aa(fun(C,fun(D,set(B))),fun(product_prod(C,D),set(B)),product_case_prod(C,D,set(B)),Ca),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),A4),B3))) ) ).

% mem_case_prodI
tff(fact_1080_case__prodI2_H,axiom,
    ! [B: $tType,C: $tType,D: $tType,P3: product_prod(B,C),Ca: fun(B,fun(C,fun(D,$o))),X2: D] :
      ( ! [A5: B,B4: C] :
          ( ( aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A5),B4) = P3 )
         => aa(D,$o,aa(C,fun(D,$o),aa(B,fun(C,fun(D,$o)),Ca,A5),B4),X2) )
     => aa(D,$o,aa(product_prod(B,C),fun(D,$o),aa(fun(B,fun(C,fun(D,$o))),fun(product_prod(B,C),fun(D,$o)),product_case_prod(B,C,fun(D,$o)),Ca),P3),X2) ) ).

% case_prodI2'
tff(fact_1081_is__singletonI,axiom,
    ! [B: $tType,X2: B] : is_singleton(B,aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) ).

% is_singletonI
tff(fact_1082_case__prod__Pair__iden,axiom,
    ! [C: $tType,B: $tType,P3: product_prod(B,C)] : ( aa(product_prod(B,C),product_prod(B,C),aa(fun(B,fun(C,product_prod(B,C))),fun(product_prod(B,C),product_prod(B,C)),product_case_prod(B,C,product_prod(B,C)),product_Pair(B,C)),P3) = P3 ) ).

% case_prod_Pair_iden
tff(fact_1083_swap__inj__on,axiom,
    ! [C: $tType,B: $tType,A3: set(product_prod(B,C))] : inj_on(product_prod(B,C),product_prod(C,B),aa(fun(B,fun(C,product_prod(C,B))),fun(product_prod(B,C),product_prod(C,B)),product_case_prod(B,C,product_prod(C,B)),aTP_Lamp_ei(B,fun(C,product_prod(C,B)))),A3) ).

% swap_inj_on
tff(fact_1084_relH__subset,axiom,
    ! [Bs: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit),As2: set(nat)] :
      ( relH(Bs,H2,H5)
     => ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),As2),Bs)
       => relH(As2,H2,H5) ) ) ).

% relH_subset
tff(fact_1085_case__prodE_H,axiom,
    ! [C: $tType,B: $tType,D: $tType,Ca: fun(B,fun(C,fun(D,$o))),P3: product_prod(B,C),Z2: D] :
      ( aa(D,$o,aa(product_prod(B,C),fun(D,$o),aa(fun(B,fun(C,fun(D,$o))),fun(product_prod(B,C),fun(D,$o)),product_case_prod(B,C,fun(D,$o)),Ca),P3),Z2)
     => ~ ! [X: B,Y2: C] :
            ( ( P3 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y2) )
           => ~ aa(D,$o,aa(C,fun(D,$o),aa(B,fun(C,fun(D,$o)),Ca,X),Y2),Z2) ) ) ).

% case_prodE'
tff(fact_1086_case__prodD_H,axiom,
    ! [C: $tType,B: $tType,D: $tType,R: fun(B,fun(C,fun(D,$o))),A4: B,B3: C,Ca: D] :
      ( aa(D,$o,aa(product_prod(B,C),fun(D,$o),aa(fun(B,fun(C,fun(D,$o))),fun(product_prod(B,C),fun(D,$o)),product_case_prod(B,C,fun(D,$o)),R),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B3)),Ca)
     => aa(D,$o,aa(C,fun(D,$o),aa(B,fun(C,fun(D,$o)),R,A4),B3),Ca) ) ).

% case_prodD'
tff(fact_1087_less__eq__set__def,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
    <=> aa(fun(B,$o),$o,aa(fun(B,$o),fun(fun(B,$o),$o),ord_less_eq(fun(B,$o)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),B2)) ) ).

% less_eq_set_def
tff(fact_1088_pred__subset__eq,axiom,
    ! [B: $tType,R: set(B),S: set(B)] :
      ( aa(fun(B,$o),$o,aa(fun(B,$o),fun(fun(B,$o),$o),ord_less_eq(fun(B,$o)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),R)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),S))
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),R),S) ) ).

% pred_subset_eq
tff(fact_1089_less__eq__assn__def,axiom,
    ! [A4: assn,B3: assn] :
      ( aa(assn,$o,aa(assn,fun(assn,$o),ord_less_eq(assn),A4),B3)
    <=> ( A4 = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A4),B3) ) ) ).

% less_eq_assn_def
tff(fact_1090_in__range__subset,axiom,
    ! [As2: set(nat),As3: set(nat),H2: heap_ext(product_unit)] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),As2),As3)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3))
       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2)) ) ) ).

% in_range_subset
tff(fact_1091_pred__subset__eq2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S: set(product_prod(B,C))] :
      ( aa(fun(B,fun(C,$o)),$o,aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),$o),ord_less_eq(fun(B,fun(C,$o))),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),R)),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),S))
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),R),S) ) ).

% pred_subset_eq2
tff(fact_1092_is__singletonI_H,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( ! [X: B,Y2: B] :
            ( aa(set(B),$o,member(B,X),A3)
           => ( aa(set(B),$o,member(B,Y2),A3)
             => ( X = Y2 ) ) )
       => is_singleton(B,A3) ) ) ).

% is_singletonI'
tff(fact_1093_swap__product,axiom,
    ! [B: $tType,C: $tType,A3: set(C),B2: set(B)] : ( aa(set(product_prod(C,B)),set(product_prod(B,C)),image2(product_prod(C,B),product_prod(B,C),aa(fun(C,fun(B,product_prod(B,C))),fun(product_prod(C,B),product_prod(B,C)),product_case_prod(C,B,product_prod(B,C)),aTP_Lamp_ej(C,fun(B,product_prod(B,C))))),product_Sigma(C,B,A3,aTP_Lamp_bv(set(B),fun(C,set(B)),B2))) = product_Sigma(B,C,B2,aTP_Lamp_bq(set(C),fun(B,set(C)),A3)) ) ).

% swap_product
tff(fact_1094_image__paired__Times,axiom,
    ! [D: $tType,C: $tType,B: $tType,E: $tType,F2: fun(D,B),G: fun(E,C),A3: set(D),B2: set(E)] : ( aa(set(product_prod(D,E)),set(product_prod(B,C)),image2(product_prod(D,E),product_prod(B,C),aa(fun(D,fun(E,product_prod(B,C))),fun(product_prod(D,E),product_prod(B,C)),product_case_prod(D,E,product_prod(B,C)),aa(fun(E,C),fun(D,fun(E,product_prod(B,C))),aTP_Lamp_ek(fun(D,B),fun(fun(E,C),fun(D,fun(E,product_prod(B,C)))),F2),G))),product_Sigma(D,E,A3,aTP_Lamp_el(set(E),fun(D,set(E)),B2))) = product_Sigma(B,C,aa(set(D),set(B),image2(D,B,F2),A3),aa(set(E),fun(B,set(C)),aTP_Lamp_em(fun(E,C),fun(set(E),fun(B,set(C))),G),B2)) ) ).

% image_paired_Times
tff(fact_1095_Collect__restrict,axiom,
    ! [B: $tType,X5: set(B),Pa: fun(B,$o)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),X5),Pa))),X5) ).

% Collect_restrict
tff(fact_1096_prop__restrict,axiom,
    ! [B: $tType,X2: B,Z4: set(B),X5: set(B),Pa: fun(B,$o)] :
      ( aa(set(B),$o,member(B,X2),Z4)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),Z4),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),X5),Pa)))
       => aa(B,$o,Pa,X2) ) ) ).

% prop_restrict
tff(fact_1097_is__singletonE,axiom,
    ! [B: $tType,A3: set(B)] :
      ( is_singleton(B,A3)
     => ~ ! [X: B] : ( A3 != aa(set(B),set(B),insert(B,X),bot_bot(set(B))) ) ) ).

% is_singletonE
tff(fact_1098_is__singleton__def,axiom,
    ! [B: $tType,A3: set(B)] :
      ( is_singleton(B,A3)
    <=> ? [X3: B] : ( A3 = aa(set(B),set(B),insert(B,X3),bot_bot(set(B))) ) ) ).

% is_singleton_def
tff(fact_1099_mod__star__trueE_H,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),top_top(assn))),H2)
     => ~ ! [H3: product_prod(heap_ext(product_unit),set(nat))] :
            ( ( aa(product_prod(heap_ext(product_unit),set(nat)),heap_ext(product_unit),product_fst(heap_ext(product_unit),set(nat)),H3) = aa(product_prod(heap_ext(product_unit),set(nat)),heap_ext(product_unit),product_fst(heap_ext(product_unit),set(nat)),H2) )
           => ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H3)),aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2))
             => ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H3) ) ) ) ).

% mod_star_trueE'
tff(fact_1100_subset__emptyI,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ! [X: B] : ~ aa(set(B),$o,member(B,X),A3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),bot_bot(set(B))) ) ).

% subset_emptyI
tff(fact_1101_range__prod,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(D,product_prod(B,C))] : aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),aa(set(D),set(product_prod(B,C)),image2(D,product_prod(B,C),F2),top_top(set(D)))),product_Sigma(B,C,aa(set(D),set(B),image2(D,B,aa(fun(D,product_prod(B,C)),fun(D,B),comp(product_prod(B,C),B,D,product_fst(B,C)),F2)),top_top(set(D))),aTP_Lamp_en(fun(D,product_prod(B,C)),fun(B,set(C)),F2))) ).

% range_prod
tff(fact_1102_Gr__incl,axiom,
    ! [B: $tType,C: $tType,A3: set(B),F2: fun(B,C),B2: set(C)] :
      ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),bNF_Gr(B,C,A3,F2)),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))
    <=> aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,F2),A3)),B2) ) ).

% Gr_incl
tff(fact_1103_inj__on__vimage__singleton,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),A3: set(B),A4: C] :
      ( inj_on(B,C,F2,A3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),aa(set(C),set(C),insert(C,A4),bot_bot(set(C))))),A3)),aa(set(B),set(B),insert(B,the(B,aa(C,fun(B,$o),aa(set(B),fun(C,fun(B,$o)),aTP_Lamp_eo(fun(B,C),fun(set(B),fun(C,fun(B,$o))),F2),A3),A4))),bot_bot(set(B)))) ) ).

% inj_on_vimage_singleton
tff(fact_1104_inj__vimage__singleton,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),A4: C] :
      ( inj_on(B,C,F2,top_top(set(B)))
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),aa(set(C),set(C),insert(C,A4),bot_bot(set(C))))),aa(set(B),set(B),insert(B,the(B,aa(C,fun(B,$o),aTP_Lamp_ep(fun(B,C),fun(C,fun(B,$o)),F2),A4))),bot_bot(set(B)))) ) ).

% inj_vimage_singleton
tff(fact_1105_vimage__Times,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(B,product_prod(C,D)),A3: set(C),B2: set(D)] : ( aa(set(product_prod(C,D)),set(B),aa(fun(B,product_prod(C,D)),fun(set(product_prod(C,D)),set(B)),vimage(B,product_prod(C,D)),F2),product_Sigma(C,D,A3,aTP_Lamp_eq(set(D),fun(C,set(D)),B2))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),aa(fun(B,product_prod(C,D)),fun(B,C),comp(product_prod(C,D),C,B,product_fst(C,D)),F2)),A3)),aa(set(D),set(B),aa(fun(B,D),fun(set(D),set(B)),vimage(B,D),aa(fun(B,product_prod(C,D)),fun(B,D),comp(product_prod(C,D),D,B,product_snd(C,D)),F2)),B2)) ) ).

% vimage_Times
tff(fact_1106_total__on__singleton,axiom,
    ! [B: $tType,X2: B] : total_on(B,aa(set(B),set(B),insert(B,X2),bot_bot(set(B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2)),bot_bot(set(product_prod(B,B))))) ).

% total_on_singleton
tff(fact_1107_inj__graph,axiom,
    ! [C: $tType,B: $tType] : inj_on(fun(B,C),set(product_prod(B,C)),aTP_Lamp_es(fun(B,C),set(product_prod(B,C))),top_top(set(fun(B,C)))) ).

% inj_graph
tff(fact_1108_group_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( semigroup(B,F2)
     => ( group_axioms(B,F2,Z2,Inverse)
       => group(B,F2,Z2,Inverse) ) ) ).

% group.intro
tff(fact_1109_group__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( group(B,F2,Z2,Inverse)
    <=> ( semigroup(B,F2)
        & group_axioms(B,F2,Z2,Inverse) ) ) ).

% group_def
tff(fact_1110_predicate2I,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o)),Qa: fun(B,fun(C,$o))] :
      ( ! [X: B,Y2: C] :
          ( aa(C,$o,aa(B,fun(C,$o),Pa,X),Y2)
         => aa(C,$o,aa(B,fun(C,$o),Qa,X),Y2) )
     => aa(fun(B,fun(C,$o)),$o,aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),$o),ord_less_eq(fun(B,fun(C,$o))),Pa),Qa) ) ).

% predicate2I
tff(fact_1111_predicate1I,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( ! [X: B] :
          ( aa(B,$o,Pa,X)
         => aa(B,$o,Qa,X) )
     => aa(fun(B,$o),$o,aa(fun(B,$o),fun(fun(B,$o),$o),ord_less_eq(fun(B,$o)),Pa),Qa) ) ).

% predicate1I
tff(fact_1112_The__split__eq,axiom,
    ! [B: $tType,C: $tType,X2: B,Y: C] : ( the(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(C,fun(B,fun(C,$o)),aTP_Lamp_et(B,fun(C,fun(B,fun(C,$o))),X2),Y))) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y) ) ).

% The_split_eq
tff(fact_1113_rev__predicate2D,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,fun(C,$o)),X2: B,Y: C,Qa: fun(B,fun(C,$o))] :
      ( aa(C,$o,aa(B,fun(C,$o),Pa,X2),Y)
     => ( aa(fun(B,fun(C,$o)),$o,aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),$o),ord_less_eq(fun(B,fun(C,$o))),Pa),Qa)
       => aa(C,$o,aa(B,fun(C,$o),Qa,X2),Y) ) ) ).

% rev_predicate2D
tff(fact_1114_rev__predicate1D,axiom,
    ! [B: $tType,Pa: fun(B,$o),X2: B,Qa: fun(B,$o)] :
      ( aa(B,$o,Pa,X2)
     => ( aa(fun(B,$o),$o,aa(fun(B,$o),fun(fun(B,$o),$o),ord_less_eq(fun(B,$o)),Pa),Qa)
       => aa(B,$o,Qa,X2) ) ) ).

% rev_predicate1D
tff(fact_1115_predicate2D,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,fun(C,$o)),Qa: fun(B,fun(C,$o)),X2: B,Y: C] :
      ( aa(fun(B,fun(C,$o)),$o,aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),$o),ord_less_eq(fun(B,fun(C,$o))),Pa),Qa)
     => ( aa(C,$o,aa(B,fun(C,$o),Pa,X2),Y)
       => aa(C,$o,aa(B,fun(C,$o),Qa,X2),Y) ) ) ).

% predicate2D
tff(fact_1116_predicate1D,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o),X2: B] :
      ( aa(fun(B,$o),$o,aa(fun(B,$o),fun(fun(B,$o),$o),ord_less_eq(fun(B,$o)),Pa),Qa)
     => ( aa(B,$o,Pa,X2)
       => aa(B,$o,Qa,X2) ) ) ).

% predicate1D
tff(fact_1117_eq__subset,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o))] : aa(fun(B,fun(B,$o)),$o,aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),$o),ord_less_eq(fun(B,fun(B,$o))),fequal(B)),aTP_Lamp_eu(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Pa)) ).

% eq_subset
tff(fact_1118_group__axioms_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( ! [A5: B] : ( aa(B,B,aa(B,fun(B,B),F2,Z2),A5) = A5 )
     => ( ! [A5: B] : ( aa(B,B,aa(B,fun(B,B),F2,aa(B,B,Inverse,A5)),A5) = Z2 )
       => group_axioms(B,F2,Z2,Inverse) ) ) ).

% group_axioms.intro
tff(fact_1119_group__axioms__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( group_axioms(B,F2,Z2,Inverse)
    <=> ( ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),F2,Z2),A6) = A6 )
        & ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),F2,aa(B,B,Inverse,A6)),A6) = Z2 ) ) ) ).

% group_axioms_def
tff(fact_1120_total__on__empty,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : total_on(B,bot_bot(set(B)),R2) ).

% total_on_empty
tff(fact_1121_group_Oaxioms_I2_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( group(B,F2,Z2,Inverse)
     => group_axioms(B,F2,Z2,Inverse) ) ).

% group.axioms(2)
tff(fact_1122_The__case__prod,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o))] : ( the(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Pa)) = the(product_prod(B,C),aTP_Lamp_ev(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),Pa)) ) ).

% The_case_prod
tff(fact_1123_the__elem__def,axiom,
    ! [B: $tType,X5: set(B)] : ( the_elem(B,X5) = the(B,aTP_Lamp_ew(set(B),fun(B,$o),X5)) ) ).

% the_elem_def
tff(fact_1124_fst__snd__flip,axiom,
    ! [C: $tType,B: $tType,Xy: product_prod(B,C)] : ( aa(product_prod(B,C),B,product_fst(B,C),Xy) = aa(product_prod(B,C),B,aa(fun(product_prod(B,C),product_prod(C,B)),fun(product_prod(B,C),B),comp(product_prod(C,B),B,product_prod(B,C),product_snd(C,B)),aa(fun(B,fun(C,product_prod(C,B))),fun(product_prod(B,C),product_prod(C,B)),product_case_prod(B,C,product_prod(C,B)),aTP_Lamp_ei(B,fun(C,product_prod(C,B))))),Xy) ) ).

% fst_snd_flip
tff(fact_1125_snd__fst__flip,axiom,
    ! [B: $tType,C: $tType,Xy: product_prod(C,B)] : ( aa(product_prod(C,B),B,product_snd(C,B),Xy) = aa(product_prod(C,B),B,aa(fun(product_prod(C,B),product_prod(B,C)),fun(product_prod(C,B),B),comp(product_prod(B,C),B,product_prod(C,B),product_fst(B,C)),aa(fun(C,fun(B,product_prod(B,C))),fun(product_prod(C,B),product_prod(B,C)),product_case_prod(C,B,product_prod(B,C)),aTP_Lamp_ej(C,fun(B,product_prod(B,C))))),Xy) ) ).

% snd_fst_flip
tff(fact_1126_the__equality,axiom,
    ! [B: $tType,Pa: fun(B,$o),A4: B] :
      ( aa(B,$o,Pa,A4)
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
           => ( X = A4 ) )
       => ( the(B,Pa) = A4 ) ) ) ).

% the_equality
tff(fact_1127_the__eq__trivial,axiom,
    ! [B: $tType,A4: B] : ( the(B,aTP_Lamp_ct(B,fun(B,$o),A4)) = A4 ) ).

% the_eq_trivial
tff(fact_1128_the__sym__eq__trivial,axiom,
    ! [B: $tType,X2: B] : ( the(B,aa(B,fun(B,$o),fequal(B),X2)) = X2 ) ).

% the_sym_eq_trivial
tff(fact_1129_Gr__def,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,C)] : ( bNF_Gr(B,C,A3,F2) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,C),fun(product_prod(B,C),$o),aTP_Lamp_ex(set(B),fun(fun(B,C),fun(product_prod(B,C),$o)),A3),F2)) ) ).

% Gr_def
tff(fact_1130_inj__on__apsnd,axiom,
    ! [B: $tType,D: $tType,C: $tType,F2: fun(C,D),A3: set(C)] :
      ( inj_on(product_prod(B,C),product_prod(B,D),aa(fun(C,D),fun(product_prod(B,C),product_prod(B,D)),product_apsnd(C,D,B),F2),product_Sigma(B,C,top_top(set(B)),aTP_Lamp_bq(set(C),fun(B,set(C)),A3)))
    <=> inj_on(C,D,F2,A3) ) ).

% inj_on_apsnd
tff(fact_1131_inj__on__apfst,axiom,
    ! [C: $tType,D: $tType,B: $tType,F2: fun(B,D),A3: set(B)] :
      ( inj_on(product_prod(B,C),product_prod(D,C),product_apfst(B,D,C,F2),product_Sigma(B,C,A3,aTP_Lamp_bp(B,set(C))))
    <=> inj_on(B,D,F2,A3) ) ).

% inj_on_apfst
tff(fact_1132_Field__insert,axiom,
    ! [B: $tType,A4: B,B3: B,R2: set(product_prod(B,B))] : ( field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),R2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))),field2(B,R2)) ) ).

% Field_insert
tff(fact_1133_Field__square,axiom,
    ! [B: $tType,X2: set(B)] : ( field2(B,product_Sigma(B,B,X2,aTP_Lamp_cr(set(B),fun(B,set(B)),X2))) = X2 ) ).

% Field_square
tff(fact_1134_Field__empty,axiom,
    ! [B: $tType] : ( field2(B,bot_bot(set(product_prod(B,B)))) = bot_bot(set(B)) ) ).

% Field_empty
tff(fact_1135_R__subset__Field,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] : aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R),product_Sigma(B,B,field2(B,R),aTP_Lamp_ey(set(product_prod(B,B)),fun(B,set(B)),R))) ).

% R_subset_Field
tff(fact_1136_Restr__Field,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,field2(B,R2),aTP_Lamp_ey(set(product_prod(B,B)),fun(B,set(B)),R2))) = R2 ) ).

% Restr_Field
tff(fact_1137_rel__restrict__Int__empty,axiom,
    ! [B: $tType,A3: set(B),R: set(product_prod(B,B))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),field2(B,R)) = bot_bot(set(B)) )
     => ( rel_restrict(B,R,A3) = R ) ) ).

% rel_restrict_Int_empty
tff(fact_1138_Field__Restr__subset,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))))),A3) ).

% Field_Restr_subset
tff(fact_1139_Total__Restr,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( total_on(B,field2(B,R2),R2)
     => total_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) ) ).

% Total_Restr
tff(fact_1140_total__on__imp__Total__Restr,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B))] :
      ( total_on(B,A3,R2)
     => total_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) ) ).

% total_on_imp_Total_Restr
tff(fact_1141_the1__equality,axiom,
    ! [B: $tType,Pa: fun(B,$o),A4: B] :
      ( ? [X4: B] :
          ( aa(B,$o,Pa,X4)
          & ! [Y2: B] :
              ( aa(B,$o,Pa,Y2)
             => ( Y2 = X4 ) ) )
     => ( aa(B,$o,Pa,A4)
       => ( the(B,Pa) = A4 ) ) ) ).

% the1_equality
tff(fact_1142_the1I2,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( ? [X4: B] :
          ( aa(B,$o,Pa,X4)
          & ! [Y2: B] :
              ( aa(B,$o,Pa,Y2)
             => ( Y2 = X4 ) ) )
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
           => aa(B,$o,Qa,X) )
       => aa(B,$o,Qa,the(B,Pa)) ) ) ).

% the1I2
tff(fact_1143_If__def,axiom,
    ! [B: $tType,Pa: $o,X2: B,Y: B] :
      ( $ite((Pa),X2,Y)
      = the(B,aa(B,fun(B,$o),aa(B,fun(B,fun(B,$o)),aTP_Lamp_ez($o,fun(B,fun(B,fun(B,$o))),Pa),X2),Y)) ) ).

% If_def
tff(fact_1144_theI2,axiom,
    ! [B: $tType,Pa: fun(B,$o),A4: B,Qa: fun(B,$o)] :
      ( aa(B,$o,Pa,A4)
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
           => ( X = A4 ) )
       => ( ! [X: B] :
              ( aa(B,$o,Pa,X)
             => aa(B,$o,Qa,X) )
         => aa(B,$o,Qa,the(B,Pa)) ) ) ) ).

% theI2
tff(fact_1145_theI_H,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ? [X4: B] :
          ( aa(B,$o,Pa,X4)
          & ! [Y2: B] :
              ( aa(B,$o,Pa,Y2)
             => ( Y2 = X4 ) ) )
     => aa(B,$o,Pa,the(B,Pa)) ) ).

% theI'
tff(fact_1146_theI,axiom,
    ! [B: $tType,Pa: fun(B,$o),A4: B] :
      ( aa(B,$o,Pa,A4)
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
           => ( X = A4 ) )
       => aa(B,$o,Pa,the(B,Pa)) ) ) ).

% theI
tff(fact_1147_Preorder__Restr,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( order_preorder_on(B,field2(B,R2),R2)
     => order_preorder_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) ) ).

% Preorder_Restr
tff(fact_1148_remove__def,axiom,
    ! [B: $tType,X2: B,A3: set(B)] : ( aa(set(B),set(B),aa(B,fun(set(B),set(B)),remove(B),X2),A3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) ) ).

% remove_def
tff(fact_1149_Ex__inj__on__UNION__Sigma,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),I: set(C)] :
    ? [F9: fun(B,product_prod(C,B))] :
      ( inj_on(B,product_prod(C,B),F9,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I)))
      & aa(set(product_prod(C,B)),$o,aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),$o),ord_less_eq(set(product_prod(C,B))),aa(set(B),set(product_prod(C,B)),image2(B,product_prod(C,B),F9),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I)))),product_Sigma(C,B,I,A3)) ) ).

% Ex_inj_on_UNION_Sigma
tff(fact_1150_trancl__multi__insert2,axiom,
    ! [B: $tType,A4: B,B3: B,R2: set(product_prod(B,B)),M2: B,X5: set(B)] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),R2),product_Sigma(B,B,aa(set(B),set(B),insert(B,M2),bot_bot(set(B))),aTP_Lamp_cr(set(B),fun(B,set(B)),X5)))))
     => ( ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),transitive_trancl(B,R2))
       => ~ ! [X: B] :
              ( aa(set(B),$o,member(B,X),X5)
             => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),M2)),transitive_rtrancl(B,R2))
               => ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),B3)),transitive_rtrancl(B,R2)) ) ) ) ) ).

% trancl_multi_insert2
tff(fact_1151_trancl__multi__insert,axiom,
    ! [B: $tType,A4: B,B3: B,R2: set(product_prod(B,B)),X5: set(B),M2: B] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),R2),product_Sigma(B,B,X5,aTP_Lamp_fa(B,fun(B,set(B)),M2)))))
     => ( ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),transitive_trancl(B,R2))
       => ~ ! [X: B] :
              ( aa(set(B),$o,member(B,X),X5)
             => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),X)),transitive_rtrancl(B,R2))
               => ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),M2),B3)),transitive_rtrancl(B,R2)) ) ) ) ) ).

% trancl_multi_insert
tff(fact_1152_flat__lub__def,axiom,
    ! [B: $tType,B3: B,A3: set(B)] :
      ( aa(set(B),B,partial_flat_lub(B,B3),A3)
      = $ite(aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))),B3,the(B,aa(set(B),fun(B,$o),aTP_Lamp_fb(B,fun(set(B),fun(B,$o)),B3),A3))) ) ).

% flat_lub_def
tff(fact_1153_refl__on__singleton,axiom,
    ! [B: $tType,X2: B] : refl_on(B,aa(set(B),set(B),insert(B,X2),bot_bot(set(B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2)),bot_bot(set(product_prod(B,B))))) ).

% refl_on_singleton
tff(fact_1154_fun_Oin__rel,axiom,
    ! [C: $tType,D: $tType,B: $tType,R: fun(C,fun(D,$o)),A4: fun(B,C),B3: fun(B,D)] :
      ( aa(fun(B,D),$o,aa(fun(B,C),fun(fun(B,D),$o),bNF_rel_fun(B,B,C,D,fequal(B),R),A4),B3)
    <=> ? [Z5: fun(B,product_prod(C,D))] :
          ( aa(set(fun(B,product_prod(C,D))),$o,member(fun(B,product_prod(C,D)),Z5),aa(fun(fun(B,product_prod(C,D)),$o),set(fun(B,product_prod(C,D))),collect(fun(B,product_prod(C,D))),aTP_Lamp_fc(fun(C,fun(D,$o)),fun(fun(B,product_prod(C,D)),$o),R)))
          & ( aa(fun(B,product_prod(C,D)),fun(B,C),comp(product_prod(C,D),C,B,product_fst(C,D)),Z5) = A4 )
          & ( aa(fun(B,product_prod(C,D)),fun(B,D),comp(product_prod(C,D),D,B,product_snd(C,D)),Z5) = B3 ) ) ) ).

% fun.in_rel
tff(fact_1155_trancl__insert,axiom,
    ! [B: $tType,Y: B,X2: B,R2: set(product_prod(B,B))] : ( transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),X2)),R2)) = aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),transitive_trancl(B,R2)),aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aa(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o))),aTP_Lamp_eg(B,fun(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o)))),Y),X2),R2)))) ) ).

% trancl_insert
tff(fact_1156_Sup__apply,axiom,
    ! [B: $tType,C: $tType] :
      ( complete_Sup(B)
     => ! [A3: set(fun(C,B)),X2: C] : ( aa(C,B,aa(set(fun(C,B)),fun(C,B),complete_Sup_Sup(fun(C,B)),A3),X2) = aa(set(B),B,complete_Sup_Sup(B),aa(set(fun(C,B)),set(B),image2(fun(C,B),B,aTP_Lamp_fd(C,fun(fun(C,B),B),X2)),A3)) ) ) ).

% Sup_apply
tff(fact_1157_Sup__bot__conv_I2_J,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( ( bot_bot(B) = aa(set(B),B,complete_Sup_Sup(B),A3) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => ( X3 = bot_bot(B) ) ) ) ) ).

% Sup_bot_conv(2)
tff(fact_1158_Sup__bot__conv_I1_J,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( ( aa(set(B),B,complete_Sup_Sup(B),A3) = bot_bot(B) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => ( X3 = bot_bot(B) ) ) ) ) ).

% Sup_bot_conv(1)
tff(fact_1159_trancl__empty,axiom,
    ! [B: $tType] : ( transitive_trancl(B,bot_bot(set(product_prod(B,B)))) = bot_bot(set(product_prod(B,B))) ) ).

% trancl_empty
tff(fact_1160_SUP__apply,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( complete_Sup(B)
     => ! [F2: fun(D,fun(C,B)),A3: set(D),X2: C] : ( aa(C,B,aa(set(fun(C,B)),fun(C,B),complete_Sup_Sup(fun(C,B)),aa(set(D),set(fun(C,B)),image2(D,fun(C,B),F2),A3)),X2) = aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,aa(C,fun(D,B),aTP_Lamp_fe(fun(D,fun(C,B)),fun(C,fun(D,B)),F2),X2)),A3)) ) ) ).

% SUP_apply
tff(fact_1161_SUP__identity__eq,axiom,
    ! [B: $tType] :
      ( complete_Sup(B)
     => ! [A3: set(B)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),image2(B,B,aTP_Lamp_ff(B,B)),A3)) = aa(set(B),B,complete_Sup_Sup(B),A3) ) ) ).

% SUP_identity_eq
tff(fact_1162_UN__I,axiom,
    ! [C: $tType,B: $tType,A4: B,A3: set(B),B3: C,B2: fun(B,set(C))] :
      ( aa(set(B),$o,member(B,A4),A3)
     => ( aa(set(C),$o,member(C,B3),aa(B,set(C),B2,A4))
       => aa(set(C),$o,member(C,B3),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A3))) ) ) ).

% UN_I
tff(fact_1163_UN__iff,axiom,
    ! [B: $tType,C: $tType,B3: B,B2: fun(C,set(B)),A3: set(C)] :
      ( aa(set(B),$o,member(B,B3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)))
    <=> ? [X3: C] :
          ( aa(set(C),$o,member(C,X3),A3)
          & aa(set(B),$o,member(B,B3),aa(C,set(B),B2,X3)) ) ) ).

% UN_iff
tff(fact_1164_Sup__empty,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ( aa(set(B),B,complete_Sup_Sup(B),bot_bot(set(B))) = bot_bot(B) ) ) ).

% Sup_empty
tff(fact_1165_Sup__UNIV,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ( aa(set(B),B,complete_Sup_Sup(B),top_top(set(B))) = top_top(B) ) ) ).

% Sup_UNIV
tff(fact_1166_SUP__bot__conv_I2_J,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [B2: fun(C,B),A3: set(C)] :
          ( ( bot_bot(B) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,B2),A3)) )
        <=> ! [X3: C] :
              ( aa(set(C),$o,member(C,X3),A3)
             => ( aa(C,B,B2,X3) = bot_bot(B) ) ) ) ) ).

% SUP_bot_conv(2)
tff(fact_1167_SUP__bot__conv_I1_J,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [B2: fun(C,B),A3: set(C)] :
          ( ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,B2),A3)) = bot_bot(B) )
        <=> ! [X3: C] :
              ( aa(set(C),$o,member(C,X3),A3)
             => ( aa(C,B,B2,X3) = bot_bot(B) ) ) ) ) ).

% SUP_bot_conv(1)
tff(fact_1168_SUP__bot,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(C)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aTP_Lamp_fg(C,B)),A3)) = bot_bot(B) ) ) ).

% SUP_bot
tff(fact_1169_SUP__const,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),F2: C] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,aTP_Lamp_fh(C,fun(B,C),F2)),A3)) = F2 ) ) ) ).

% SUP_const
tff(fact_1170_UN__constant,axiom,
    ! [C: $tType,B: $tType,Ca: set(B),A3: set(C)] :
      ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_bv(set(B),fun(C,set(B)),Ca)),A3))
      = $ite(A3 = bot_bot(set(C)),bot_bot(set(B)),Ca) ) ).

% UN_constant
tff(fact_1171_UN__Un,axiom,
    ! [B: $tType,C: $tType,M: fun(C,set(B)),A3: set(C),B2: set(C)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),M),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A3),B2))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),M),A3))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),M),B2))) ) ).

% UN_Un
tff(fact_1172_trancl__single,axiom,
    ! [B: $tType,A4: B,B3: B] : ( transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),bot_bot(set(product_prod(B,B))))) = aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),bot_bot(set(product_prod(B,B)))) ) ).

% trancl_single
tff(fact_1173_UN__singleton,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(B),set(set(B)),image2(B,set(B),aTP_Lamp_dj(B,set(B))),A3)) = A3 ) ).

% UN_singleton
tff(fact_1174_UN__simps_I1_J,axiom,
    ! [B: $tType,C: $tType,A4: B,B2: fun(C,set(B)),C2: set(C)] :
      ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_fi(B,fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),C2))
      = $ite(C2 = bot_bot(set(C)),bot_bot(set(B)),aa(set(B),set(B),insert(B,A4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2)))) ) ).

% UN_simps(1)
tff(fact_1175_UN__simps_I3_J,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(C,set(B)),C2: set(C)] :
      ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_fj(set(B),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C2))
      = $ite(C2 = bot_bot(set(C)),bot_bot(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2)))) ) ).

% UN_simps(3)
tff(fact_1176_UN__simps_I2_J,axiom,
    ! [C: $tType,B: $tType,A3: fun(C,set(B)),B2: set(B),C2: set(C)] :
      ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_fk(fun(C,set(B)),fun(set(B),fun(C,set(B))),A3),B2)),C2))
      = $ite(C2 = bot_bot(set(C)),bot_bot(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),C2))),B2)) ) ).

% UN_simps(2)
tff(fact_1177_UN__insert,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,set(B)),A4: C,A3: set(C)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),aa(set(C),set(C),insert(C,A4),A3))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(C,set(B),B2,A4)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3))) ) ).

% UN_insert
tff(fact_1178_Sup__fun__def,axiom,
    ! [C: $tType,B: $tType] :
      ( complete_Sup(C)
     => ! [A3: set(fun(B,C)),X4: B] : ( aa(B,C,aa(set(fun(B,C)),fun(B,C),complete_Sup_Sup(fun(B,C)),A3),X4) = aa(set(C),C,complete_Sup_Sup(C),aa(set(fun(B,C)),set(C),image2(fun(B,C),C,aTP_Lamp_fl(B,fun(fun(B,C),C),X4)),A3)) ) ) ).

% Sup_fun_def
tff(fact_1179_Sigma__Union,axiom,
    ! [C: $tType,B: $tType,X5: set(set(B)),B2: fun(B,set(C))] : ( product_Sigma(B,C,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),X5),B2) = aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(set(B)),set(set(product_prod(B,C))),image2(set(B),set(product_prod(B,C)),aTP_Lamp_fm(fun(B,set(C)),fun(set(B),set(product_prod(B,C))),B2)),X5)) ) ).

% Sigma_Union
tff(fact_1180_fun_Orel__map_I2_J,axiom,
    ! [C: $tType,D: $tType,E: $tType,B: $tType,Sa: fun(C,fun(D,$o)),X2: fun(B,C),G: fun(E,D),Y: fun(B,E)] :
      ( aa(fun(B,D),$o,aa(fun(B,C),fun(fun(B,D),$o),bNF_rel_fun(B,B,C,D,fequal(B),Sa),X2),aa(fun(B,E),fun(B,D),comp(E,D,B,G),Y))
    <=> aa(fun(B,E),$o,aa(fun(B,C),fun(fun(B,E),$o),bNF_rel_fun(B,B,C,E,fequal(B),aa(fun(E,D),fun(C,fun(E,$o)),aTP_Lamp_fn(fun(C,fun(D,$o)),fun(fun(E,D),fun(C,fun(E,$o))),Sa),G)),X2),Y) ) ).

% fun.rel_map(2)
tff(fact_1181_fun_Orel__map_I1_J,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,Sb: fun(C,fun(D,$o)),I2: fun(E,C),X2: fun(B,E),Y: fun(B,D)] :
      ( aa(fun(B,D),$o,aa(fun(B,C),fun(fun(B,D),$o),bNF_rel_fun(B,B,C,D,fequal(B),Sb),aa(fun(B,E),fun(B,C),comp(E,C,B,I2),X2)),Y)
    <=> aa(fun(B,D),$o,aa(fun(B,E),fun(fun(B,D),$o),bNF_rel_fun(B,B,E,D,fequal(B),aa(fun(E,C),fun(E,fun(D,$o)),aTP_Lamp_fo(fun(C,fun(D,$o)),fun(fun(E,C),fun(E,fun(D,$o))),Sb),I2)),X2),Y) ) ).

% fun.rel_map(1)
tff(fact_1182_SUP__UNION,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B),G: fun(D,set(C)),A3: set(D)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(D),set(set(C)),image2(D,set(C),G),A3)))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,aa(fun(D,set(C)),fun(D,B),aTP_Lamp_fp(fun(C,B),fun(fun(D,set(C)),fun(D,B)),F2),G)),A3)) ) ) ).

% SUP_UNION
tff(fact_1183_Union__empty,axiom,
    ! [B: $tType] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),bot_bot(set(set(B)))) = bot_bot(set(B)) ) ).

% Union_empty
tff(fact_1184_Union__empty__conv,axiom,
    ! [B: $tType,A3: set(set(B))] :
      ( ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A3) = bot_bot(set(B)) )
    <=> ! [X3: set(B)] :
          ( aa(set(set(B)),$o,member(set(B),X3),A3)
         => ( X3 = bot_bot(set(B)) ) ) ) ).

% Union_empty_conv
tff(fact_1185_empty__Union__conv,axiom,
    ! [B: $tType,A3: set(set(B))] :
      ( ( bot_bot(set(B)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A3) )
    <=> ! [X3: set(B)] :
          ( aa(set(set(B)),$o,member(set(B),X3),A3)
         => ( X3 = bot_bot(set(B)) ) ) ) ).

% empty_Union_conv
tff(fact_1186_UN__Times__distrib,axiom,
    ! [D: $tType,C: $tType,B: $tType,E: $tType,E3: fun(D,set(B)),F: fun(E,set(C)),A3: set(D),B2: set(E)] : ( aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(product_prod(D,E)),set(set(product_prod(B,C))),image2(product_prod(D,E),set(product_prod(B,C)),aa(fun(D,fun(E,set(product_prod(B,C)))),fun(product_prod(D,E),set(product_prod(B,C))),product_case_prod(D,E,set(product_prod(B,C))),aa(fun(E,set(C)),fun(D,fun(E,set(product_prod(B,C)))),aTP_Lamp_fr(fun(D,set(B)),fun(fun(E,set(C)),fun(D,fun(E,set(product_prod(B,C))))),E3),F))),product_Sigma(D,E,A3,aTP_Lamp_el(set(E),fun(D,set(E)),B2)))) = product_Sigma(B,C,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),E3),A3)),aa(set(E),fun(B,set(C)),aTP_Lamp_fs(fun(E,set(C)),fun(set(E),fun(B,set(C))),F),B2)) ) ).

% UN_Times_distrib
tff(fact_1187_SUP__commute,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,fun(D,B)),B2: set(D),A3: set(C)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(set(D),fun(C,B),aTP_Lamp_ft(fun(C,fun(D,B)),fun(set(D),fun(C,B)),F2),B2)),A3)) = aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,aa(set(C),fun(D,B),aTP_Lamp_fv(fun(C,fun(D,B)),fun(set(C),fun(D,B)),F2),A3)),B2)) ) ) ).

% SUP_commute
tff(fact_1188_SUP__UNIV__bool__expand,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: fun($o,B)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set($o),set(B),image2($o,B,A3),top_top(set($o)))) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa($o,B,A3,$true)),aa($o,B,A3,$false)) ) ) ).

% SUP_UNIV_bool_expand
tff(fact_1189_Union__SetCompr__eq,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,set(B)),Pa: fun(C,$o)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aa(fun(C,$o),fun(set(B),$o),aTP_Lamp_fw(fun(C,set(B)),fun(fun(C,$o),fun(set(B),$o)),F2),Pa))) = aa(fun(B,$o),set(B),collect(B),aa(fun(C,$o),fun(B,$o),aTP_Lamp_fx(fun(C,set(B)),fun(fun(C,$o),fun(B,$o)),F2),Pa)) ) ).

% Union_SetCompr_eq
tff(fact_1190_UN__bool__eq,axiom,
    ! [B: $tType,A3: fun($o,set(B))] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set($o),set(set(B)),image2($o,set(B),A3),top_top(set($o)))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa($o,set(B),A3,$true)),aa($o,set(B),A3,$false)) ) ).

% UN_bool_eq
tff(fact_1191_Un__eq__UN,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set($o),set(set(B)),image2($o,set(B),aa(set(B),fun($o,set(B)),aTP_Lamp_fy(set(B),fun(set(B),fun($o,set(B))),A3),B2)),top_top(set($o)))) ) ).

% Un_eq_UN
tff(fact_1192_UN__extend__simps_I9_J,axiom,
    ! [B: $tType,D: $tType,C: $tType,C2: fun(D,set(B)),B2: fun(C,set(D)),A3: set(C)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(D)),fun(C,set(B)),aTP_Lamp_fz(fun(D,set(B)),fun(fun(C,set(D)),fun(C,set(B))),C2),B2)),A3)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),C2),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),B2),A3)))) ) ).

% UN_extend_simps(9)
tff(fact_1193_UN__E,axiom,
    ! [B: $tType,C: $tType,B3: B,B2: fun(C,set(B)),A3: set(C)] :
      ( aa(set(B),$o,member(B,B3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)))
     => ~ ! [X: C] :
            ( aa(set(C),$o,member(C,X),A3)
           => ~ aa(set(B),$o,member(B,B3),aa(C,set(B),B2,X)) ) ) ).

% UN_E
tff(fact_1194_UN__UN__flatten,axiom,
    ! [C: $tType,B: $tType,D: $tType,C2: fun(C,set(B)),B2: fun(D,set(C)),A3: set(D)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),C2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B2),A3)))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_ga(fun(C,set(B)),fun(fun(D,set(C)),fun(D,set(B))),C2),B2)),A3)) ) ).

% UN_UN_flatten
tff(fact_1195_predicate2__transferD,axiom,
    ! [B: $tType,C: $tType,E: $tType,D: $tType,R1: fun(B,fun(C,$o)),R22: fun(D,fun(E,$o)),Pa: fun(B,fun(D,$o)),Qa: fun(C,fun(E,$o)),A4: product_prod(B,C),A3: set(product_prod(B,C)),B3: product_prod(D,E),B2: set(product_prod(D,E))] :
      ( aa(fun(C,fun(E,$o)),$o,aa(fun(B,fun(D,$o)),fun(fun(C,fun(E,$o)),$o),bNF_rel_fun(B,C,fun(D,$o),fun(E,$o),R1,bNF_rel_fun(D,E,$o,$o,R22,fequal($o))),Pa),Qa)
     => ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),A4),A3)
       => ( aa(set(product_prod(D,E)),$o,member(product_prod(D,E),B3),B2)
         => ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),A3),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),R1)))
           => ( aa(set(product_prod(D,E)),$o,aa(set(product_prod(D,E)),fun(set(product_prod(D,E)),$o),ord_less_eq(set(product_prod(D,E))),B2),aa(fun(product_prod(D,E),$o),set(product_prod(D,E)),collect(product_prod(D,E)),aa(fun(D,fun(E,$o)),fun(product_prod(D,E),$o),product_case_prod(D,E,$o),R22)))
             => ( aa(D,$o,aa(B,fun(D,$o),Pa,aa(product_prod(B,C),B,product_fst(B,C),A4)),aa(product_prod(D,E),D,product_fst(D,E),B3))
              <=> aa(E,$o,aa(C,fun(E,$o),Qa,aa(product_prod(B,C),C,product_snd(B,C),A4)),aa(product_prod(D,E),E,product_snd(D,E),B3)) ) ) ) ) ) ) ).

% predicate2_transferD
tff(fact_1196_less__eq__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B),U: B] :
          ( ! [V2: B] :
              ( aa(set(B),$o,member(B,V2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),V2) )
         => ( ( A3 != bot_bot(set(B)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(set(B),B,complete_Sup_Sup(B),A3)) ) ) ) ).

% less_eq_Sup
tff(fact_1197_SUP__eq__const,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I: set(B),F2: fun(B,C),X2: C] :
          ( ( I != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( aa(set(B),$o,member(B,I3),I)
               => ( aa(B,C,F2,I3) = X2 ) )
           => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),I)) = X2 ) ) ) ) ).

% SUP_eq_const
tff(fact_1198_Sup__inf__eq__bot__iff,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [B2: set(B),A4: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Sup_Sup(B),B2)),A4) = bot_bot(B) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),B2)
             => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X3),A4) = bot_bot(B) ) ) ) ) ).

% Sup_inf_eq_bot_iff
tff(fact_1199_inf__Sup,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [A4: B,B2: set(B)] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),aa(set(B),B,complete_Sup_Sup(B),B2)) = aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),inf_inf(B),A4)),B2)) ) ) ).

% inf_Sup
tff(fact_1200_insert__partition,axiom,
    ! [B: $tType,X2: set(B),F: set(set(B))] :
      ( ~ aa(set(set(B)),$o,member(set(B),X2),F)
     => ( ! [X: set(B)] :
            ( aa(set(set(B)),$o,member(set(B),X),aa(set(set(B)),set(set(B)),insert(set(B),X2),F))
           => ! [Xa4: set(B)] :
                ( aa(set(set(B)),$o,member(set(B),Xa4),aa(set(set(B)),set(set(B)),insert(set(B),X2),F))
               => ( ( X != Xa4 )
                 => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X),Xa4) = bot_bot(set(B)) ) ) ) )
       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),F)) = bot_bot(set(B)) ) ) ) ).

% insert_partition
tff(fact_1201_Union__disjoint,axiom,
    ! [B: $tType,C2: set(set(B)),A3: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C2)),A3) = bot_bot(set(B)) )
    <=> ! [X3: set(B)] :
          ( aa(set(set(B)),$o,member(set(B),X3),C2)
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X3),A3) = bot_bot(set(B)) ) ) ) ).

% Union_disjoint
tff(fact_1202_Union__Int__subset,axiom,
    ! [B: $tType,A3: set(set(B)),B2: set(set(B))] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),inf_inf(set(set(B))),A3),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A3)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B2))) ).

% Union_Int_subset
tff(fact_1203_SUP__eqI,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),F2: fun(B,C),X2: C] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),A3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I3)),X2) )
         => ( ! [Y2: C] :
                ( ! [I4: B] :
                    ( aa(set(B),$o,member(B,I4),A3)
                   => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I4)),Y2) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),X2),Y2) )
           => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3)) = X2 ) ) ) ) ).

% SUP_eqI
tff(fact_1204_SUP__mono,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comple6319245703460814977attice(D)
     => ! [A3: set(B),B2: set(C),F2: fun(B,D),G: fun(C,D)] :
          ( ! [N2: B] :
              ( aa(set(B),$o,member(B,N2),A3)
             => ? [X4: C] :
                  ( aa(set(C),$o,member(C,X4),B2)
                  & aa(D,$o,aa(D,fun(D,$o),ord_less_eq(D),aa(B,D,F2,N2)),aa(C,D,G,X4)) ) )
         => aa(D,$o,aa(D,fun(D,$o),ord_less_eq(D),aa(set(D),D,complete_Sup_Sup(D),aa(set(B),set(D),image2(B,D,F2),A3))),aa(set(D),D,complete_Sup_Sup(D),aa(set(C),set(D),image2(C,D,G),B2))) ) ) ).

% SUP_mono
tff(fact_1205_SUP__least,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),F2: fun(B,C),U: C] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),A3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I3)),U) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))),U) ) ) ).

% SUP_least
tff(fact_1206_SUP__mono_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [F2: fun(B,C),G: fun(B,C),A3: set(B)] :
          ( ! [X: B] : aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),aa(B,C,G,X))
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,G),A3))) ) ) ).

% SUP_mono'
tff(fact_1207_SUP__upper,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I2: B,A3: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,member(B,I2),A3)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I2)),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))) ) ) ).

% SUP_upper
tff(fact_1208_SUP__le__iff,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B),A3: set(C),U: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),A3))),U)
        <=> ! [X3: C] :
              ( aa(set(C),$o,member(C,X3),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(C,B,F2,X3)),U) ) ) ) ).

% SUP_le_iff
tff(fact_1209_SUP__upper2,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I2: B,A3: set(B),U: C,F2: fun(B,C)] :
          ( aa(set(B),$o,member(B,I2),A3)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),U),aa(B,C,F2,I2))
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),U),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))) ) ) ) ).

% SUP_upper2
tff(fact_1210_SUP__inf__distrib2,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [F2: fun(C,B),A3: set(C),G: fun(D,B),B2: set(D)] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,G),B2))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_gc(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),F2),G),B2)),A3)) ) ) ).

% SUP_inf_distrib2
tff(fact_1211_inf__SUP,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [A4: B,F2: fun(C,B),B2: set(C)] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),B2))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_gd(B,fun(fun(C,B),fun(C,B)),A4),F2)),B2)) ) ) ).

% inf_SUP
tff(fact_1212_Sup__inf,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [B2: set(B),A4: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Sup_Sup(B),B2)),A4) = aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),image2(B,B,aTP_Lamp_ge(B,fun(B,B),A4)),B2)) ) ) ).

% Sup_inf
tff(fact_1213_SUP__inf,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [F2: fun(C,B),B2: set(C),A4: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),B2))),A4) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(B,fun(C,B),aTP_Lamp_gf(fun(C,B),fun(B,fun(C,B)),F2),A4)),B2)) ) ) ).

% SUP_inf
tff(fact_1214_complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B),A3: set(C),G: fun(C,B)] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,G),A3))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_gg(fun(C,B),fun(fun(C,B),fun(C,B)),F2),G)),A3)) ) ) ).

% complete_lattice_class.SUP_sup_distrib
tff(fact_1215_SUP__absorb,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [K: B,I: set(B),A3: fun(B,C)] :
          ( aa(set(B),$o,member(B,K),I)
         => ( aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(B,C,A3,K)),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,A3),I))) = aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,A3),I)) ) ) ) ).

% SUP_absorb
tff(fact_1216_refl__on__empty,axiom,
    ! [B: $tType] : refl_on(B,bot_bot(set(B)),bot_bot(set(product_prod(B,B)))) ).

% refl_on_empty
tff(fact_1217_trancl__subset__Sigma,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))
     => aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),transitive_trancl(B,R2)),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))) ) ).

% trancl_subset_Sigma
tff(fact_1218_refl__on__Int,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),B2: set(B),S2: set(product_prod(B,B))] :
      ( refl_on(B,A3,R2)
     => ( refl_on(B,B2,S2)
       => refl_on(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),S2)) ) ) ).

% refl_on_Int
tff(fact_1219_UN__extend__simps_I10_J,axiom,
    ! [B: $tType,D: $tType,C: $tType,B2: fun(D,set(B)),F2: fun(C,D),A3: set(C)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,D),fun(C,set(B)),aTP_Lamp_gh(fun(D,set(B)),fun(fun(C,D),fun(C,set(B))),B2),F2)),A3)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),B2),aa(set(C),set(D),image2(C,D,F2),A3))) ) ).

% UN_extend_simps(10)
tff(fact_1220_image__UN,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(C,B),B2: fun(D,set(C)),A3: set(D)] : ( aa(set(C),set(B),image2(C,B,F2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B2),A3))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_gi(fun(C,B),fun(fun(D,set(C)),fun(D,set(B))),F2),B2)),A3)) ) ).

% image_UN
tff(fact_1221_UN__empty2,axiom,
    ! [C: $tType,B: $tType,A3: set(C)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_gj(C,set(B))),A3)) = bot_bot(set(B)) ) ).

% UN_empty2
tff(fact_1222_UN__empty,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,set(B))] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),bot_bot(set(C)))) = bot_bot(set(B)) ) ).

% UN_empty
tff(fact_1223_UNION__empty__conv_I1_J,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,set(B)),A3: set(C)] :
      ( ( bot_bot(set(B)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)) )
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),A3)
         => ( aa(C,set(B),B2,X3) = bot_bot(set(B)) ) ) ) ).

% UNION_empty_conv(1)
tff(fact_1224_UNION__empty__conv_I2_J,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,set(B)),A3: set(C)] :
      ( ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)) = bot_bot(set(B)) )
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),A3)
         => ( aa(C,set(B),B2,X3) = bot_bot(set(B)) ) ) ) ).

% UNION_empty_conv(2)
tff(fact_1225_UN__mono,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: set(B),F2: fun(B,set(C)),G: fun(B,set(C))] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),A3)
           => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),F2,X)),aa(B,set(C),G,X)) )
       => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),F2),A3))),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),G),B2))) ) ) ).

% UN_mono
tff(fact_1226_UN__least,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(B,set(C)),C2: set(C)] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),A3)
         => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),B2,X)),C2) )
     => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A3))),C2) ) ).

% UN_least
tff(fact_1227_UN__upper,axiom,
    ! [C: $tType,B: $tType,A4: B,A3: set(B),B2: fun(B,set(C))] :
      ( aa(set(B),$o,member(B,A4),A3)
     => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),B2,A4)),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A3))) ) ).

% UN_upper
tff(fact_1228_UN__subset__iff,axiom,
    ! [C: $tType,B: $tType,A3: fun(C,set(B)),I: set(C),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I))),B2)
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),I)
         => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(C,set(B),A3,X3)),B2) ) ) ).

% UN_subset_iff
tff(fact_1229_UN__insert__distrib,axiom,
    ! [C: $tType,B: $tType,U: B,A3: set(B),A4: C,B2: fun(B,set(C))] :
      ( aa(set(B),$o,member(B,U),A3)
     => ( aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),aa(fun(B,set(C)),fun(B,set(C)),aTP_Lamp_gk(C,fun(fun(B,set(C)),fun(B,set(C))),A4),B2)),A3)) = aa(set(C),set(C),insert(C,A4),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A3))) ) ) ).

% UN_insert_distrib
tff(fact_1230_Int__UN__distrib2,axiom,
    ! [D: $tType,B: $tType,C: $tType,A3: fun(C,set(B)),I: set(C),B2: fun(D,set(B)),J: set(D)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),B2),J))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(D),fun(C,set(B)),aa(fun(D,set(B)),fun(set(D),fun(C,set(B))),aTP_Lamp_gm(fun(C,set(B)),fun(fun(D,set(B)),fun(set(D),fun(C,set(B)))),A3),B2),J)),I)) ) ).

% Int_UN_distrib2
tff(fact_1231_Int__UN__distrib,axiom,
    ! [B: $tType,C: $tType,B2: set(B),A3: fun(C,set(B)),I: set(C)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_gn(set(B),fun(fun(C,set(B)),fun(C,set(B))),B2),A3)),I)) ) ).

% Int_UN_distrib
tff(fact_1232_UN__extend__simps_I4_J,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),C2: set(C),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),C2))),B2) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_go(fun(C,set(B)),fun(set(B),fun(C,set(B))),A3),B2)),C2)) ) ).

% UN_extend_simps(4)
tff(fact_1233_UN__extend__simps_I5_J,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(C,set(B)),C2: set(C)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_gn(set(B),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C2)) ) ).

% UN_extend_simps(5)
tff(fact_1234_Un__Union__image,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),B2: fun(C,set(B)),C2: set(C)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_gp(fun(C,set(B)),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),C2))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2))) ) ).

% Un_Union_image
tff(fact_1235_UN__Un__distrib,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),B2: fun(C,set(B)),I: set(C)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_gp(fun(C,set(B)),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),I)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),I))) ) ).

% UN_Un_distrib
tff(fact_1236_UN__absorb,axiom,
    ! [C: $tType,B: $tType,K: B,I: set(B),A3: fun(B,set(C))] :
      ( aa(set(B),$o,member(B,K),I)
     => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),aa(B,set(C),A3,K)),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I))) = aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I)) ) ) ).

% UN_absorb
tff(fact_1237_UN__extend__simps_I6_J,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),C2: set(C),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),C2))),B2) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_gq(fun(C,set(B)),fun(set(B),fun(C,set(B))),A3),B2)),C2)) ) ).

% UN_extend_simps(6)
tff(fact_1238_vimage__UN,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(B,C),B2: fun(D,set(C)),A3: set(D)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B2),A3))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_gr(fun(B,C),fun(fun(D,set(C)),fun(D,set(B))),F2),B2)),A3)) ) ).

% vimage_UN
tff(fact_1239_image__Union,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),S: set(set(C))] : ( aa(set(C),set(B),image2(C,B,F2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),S)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(C)),set(set(B)),image2(set(C),set(B),image2(C,B,F2)),S)) ) ).

% image_Union
tff(fact_1240_Int__Union2,axiom,
    ! [B: $tType,B2: set(set(B)),A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B2)),A3) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(B)),set(set(B)),image2(set(B),set(B),aTP_Lamp_gs(set(B),fun(set(B),set(B)),A3)),B2)) ) ).

% Int_Union2
tff(fact_1241_Int__Union,axiom,
    ! [B: $tType,A3: set(B),B2: set(set(B))] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B2)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(B)),set(set(B)),image2(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3)),B2)) ) ).

% Int_Union
tff(fact_1242_UN__extend__simps_I8_J,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,set(B)),A3: set(set(C))] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(C)),set(set(B)),image2(set(C),set(B),aTP_Lamp_gt(fun(C,set(B)),fun(set(C),set(B)),B2)),A3)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),A3))) ) ).

% UN_extend_simps(8)
tff(fact_1243_vimage__Union,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),A3: set(set(C))] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),A3)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(C)),set(set(B)),image2(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2)),A3)) ) ).

% vimage_Union
tff(fact_1244_SUP__eq__iff,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I: set(B),Ca: C,F2: fun(B,C)] :
          ( ( I != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( aa(set(B),$o,member(B,I3),I)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),Ca),aa(B,C,F2,I3)) )
           => ( ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),I)) = Ca )
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),I)
                 => ( aa(B,C,F2,X3) = Ca ) ) ) ) ) ) ).

% SUP_eq_iff
tff(fact_1245_Sup__inter__less__eq,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B),B2: set(B)] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Sup_Sup(B),A3)),aa(set(B),B,complete_Sup_Sup(B),B2))) ) ).

% Sup_inter_less_eq
tff(fact_1246_SUP__subset__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),B2: set(B),F2: fun(B,C),G: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),aa(B,C,G,X)) )
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,G),B2))) ) ) ) ).

% SUP_subset_mono
tff(fact_1247_SUP__empty,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),bot_bot(set(C)))) = bot_bot(B) ) ) ).

% SUP_empty
tff(fact_1248_SUP__constant,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Ca: B,A3: set(C)] :
          ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aTP_Lamp_gu(B,fun(C,B),Ca)),A3))
          = $ite(A3 = bot_bot(set(C)),bot_bot(B),Ca) ) ) ).

% SUP_constant
tff(fact_1249_trancl__subset__Field2,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),transitive_trancl(B,R2)),product_Sigma(B,B,field2(B,R2),aTP_Lamp_ey(set(product_prod(B,B)),fun(B,set(B)),R2))) ).

% trancl_subset_Field2
tff(fact_1250_SUP__insert,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B),A4: C,A3: set(C)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),aa(set(C),set(C),insert(C,A4),A3))) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,F2,A4)),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),A3))) ) ) ).

% SUP_insert
tff(fact_1251_Restr__trancl__mono,axiom,
    ! [B: $tType,V: B,W2: B,E3: set(product_prod(B,B)),U2: set(B)] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2)),transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),E3),product_Sigma(B,B,U2,aTP_Lamp_cr(set(B),fun(B,set(B)),U2)))))
     => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2)),transitive_trancl(B,E3)) ) ).

% Restr_trancl_mono
tff(fact_1252_SUP__union,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [M: fun(C,B),A3: set(C),B2: set(C)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,M),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A3),B2))) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,M),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,M),B2))) ) ) ).

% SUP_union
tff(fact_1253_UN__extend__simps_I1_J,axiom,
    ! [B: $tType,C: $tType,A4: B,B2: fun(C,set(B)),C2: set(C)] :
      ( aa(set(B),set(B),insert(B,A4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2)))
      = $ite(C2 = bot_bot(set(C)),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_fi(B,fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),C2))) ) ).

% UN_extend_simps(1)
tff(fact_1254_Collect__ex__eq,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,fun(C,$o))] : ( aa(fun(B,$o),set(B),collect(B),aTP_Lamp_gv(fun(B,fun(C,$o)),fun(B,$o),Pa)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_gx(fun(B,fun(C,$o)),fun(C,set(B)),Pa)),top_top(set(C)))) ) ).

% Collect_ex_eq
tff(fact_1255_UN__extend__simps_I3_J,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(C,set(B)),C2: set(C)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2)))
      = $ite(C2 = bot_bot(set(C)),A3,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_fj(set(B),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C2))) ) ).

% UN_extend_simps(3)
tff(fact_1256_UN__extend__simps_I2_J,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),C2: set(C),B2: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),C2))),B2)
      = $ite(C2 = bot_bot(set(C)),B2,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_fk(fun(C,set(B)),fun(set(B),fun(C,set(B))),A3),B2)),C2))) ) ).

% UN_extend_simps(2)
tff(fact_1257_inj__on__UNION__chain,axiom,
    ! [D: $tType,C: $tType,B: $tType,I: set(B),A3: fun(B,set(C)),F2: fun(C,D)] :
      ( ! [I3: B,J3: B] :
          ( aa(set(B),$o,member(B,I3),I)
         => ( aa(set(B),$o,member(B,J3),I)
           => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),A3,I3)),aa(B,set(C),A3,J3))
              | aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),A3,J3)),aa(B,set(C),A3,I3)) ) ) )
     => ( ! [I3: B] :
            ( aa(set(B),$o,member(B,I3),I)
           => inj_on(C,D,F2,aa(B,set(C),A3,I3)) )
       => inj_on(C,D,F2,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I))) ) ) ).

% inj_on_UNION_chain
tff(fact_1258_refl__on__def,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B))] :
      ( refl_on(B,A3,R2)
    <=> ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))
        & ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),A3)
           => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),X3)),R2) ) ) ) ).

% refl_on_def
tff(fact_1259_refl__onI,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),A3)
           => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),X)),R2) )
       => refl_on(B,A3,R2) ) ) ).

% refl_onI
tff(fact_1260_Refl__Restr,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( refl_on(B,field2(B,R2),R2)
     => refl_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) ) ).

% Refl_Restr
tff(fact_1261_trancl__insert2,axiom,
    ! [B: $tType,A4: B,B3: B,R2: set(product_prod(B,B))] : ( transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),R2)) = aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),transitive_trancl(B,R2)),aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aa(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o))),aTP_Lamp_gy(B,fun(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o)))),A4),B3),R2)))) ) ).

% trancl_insert2
tff(fact_1262_rel__restrict__Sigma__sub,axiom,
    ! [B: $tType,A3: set(B),R: set(B)] : aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),rel_restrict(B,transitive_trancl(B,product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))),R)),transitive_trancl(B,product_Sigma(B,B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),R),aa(set(B),fun(B,set(B)),aTP_Lamp_ee(set(B),fun(set(B),fun(B,set(B))),A3),R)))) ).

% rel_restrict_Sigma_sub
tff(fact_1263_UNION__singleton__eq__range,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A3: set(C)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_gz(fun(C,B),fun(C,set(B)),F2)),A3)) = aa(set(C),set(B),image2(C,B,F2),A3) ) ).

% UNION_singleton_eq_range
tff(fact_1264_vimage__eq__UN,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),B2: set(C)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),B2) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_ha(fun(B,C),fun(C,set(B)),F2)),B2)) ) ).

% vimage_eq_UN
tff(fact_1265_snd__image__Sigma,axiom,
    ! [B: $tType,C: $tType,A3: set(C),B2: fun(C,set(B))] : ( aa(set(product_prod(C,B)),set(B),image2(product_prod(C,B),B,product_snd(C,B)),product_Sigma(C,B,A3,B2)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)) ) ).

% snd_image_Sigma
tff(fact_1266_Sigma__def,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: fun(B,set(C))] : ( product_Sigma(B,C,A3,B2) = aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(B),set(set(product_prod(B,C))),image2(B,set(product_prod(B,C)),aTP_Lamp_hc(fun(B,set(C)),fun(B,set(product_prod(B,C))),B2)),A3)) ) ).

% Sigma_def
tff(fact_1267_fun_Omap__ident,axiom,
    ! [C: $tType,B: $tType,T3: fun(B,C)] : ( aa(fun(B,C),fun(B,C),comp(C,C,B,aTP_Lamp_hd(C,C)),T3) = T3 ) ).

% fun.map_ident
tff(fact_1268_Id__on__def,axiom,
    ! [B: $tType,A3: set(B)] : ( id_on(B,A3) = aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),aa(set(B),set(set(product_prod(B,B))),image2(B,set(product_prod(B,B)),aTP_Lamp_he(B,set(product_prod(B,B)))),A3)) ) ).

% Id_on_def
tff(fact_1269_Refl__Field__Restr2,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( refl_on(B,field2(B,R2),R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),field2(B,R2))
       => ( field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) = A3 ) ) ) ).

% Refl_Field_Restr2
tff(fact_1270_Refl__Field__Restr,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( refl_on(B,field2(B,R2),R2)
     => ( field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),field2(B,R2)),A3) ) ) ).

% Refl_Field_Restr
tff(fact_1271_rtrancl__last__visit,axiom,
    ! [B: $tType,Q: B,Q3: B,R: set(product_prod(B,B)),S: set(B)] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q),Q3)),transitive_rtrancl(B,R))
     => ( ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q),Q3)),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_cr(set(B),fun(B,set(B)),S)))))
       => ~ ! [Qt: B] :
              ( aa(set(B),$o,member(B,Qt),S)
             => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q),Qt)),transitive_trancl(B,R))
               => ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Qt),Q3)),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_cr(set(B),fun(B,set(B)),S))))) ) ) ) ) ).

% rtrancl_last_visit
tff(fact_1272_cSUP__const,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),Ca: C] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,aTP_Lamp_hf(C,fun(B,C),Ca)),A3)) = Ca ) ) ) ).

% cSUP_const
tff(fact_1273_cSup__singleton,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X2: B] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = X2 ) ) ).

% cSup_singleton
tff(fact_1274_ccpo__Sup__singleton,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [X2: B] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = X2 ) ) ).

% ccpo_Sup_singleton
tff(fact_1275_Union__image__empty,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(C,set(B))] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),F2),bot_bot(set(C))))) = A3 ) ).

% Union_image_empty
tff(fact_1276_cSUP__least,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),F2: fun(B,C),M: C] :
          ( ( A3 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),M) )
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))),M) ) ) ) ).

% cSUP_least
tff(fact_1277_preorder__on__empty,axiom,
    ! [B: $tType] : order_preorder_on(B,bot_bot(set(B)),bot_bot(set(product_prod(B,B)))) ).

% preorder_on_empty
tff(fact_1278_UN__image__subset,axiom,
    ! [D: $tType,C: $tType,B: $tType,F2: fun(C,set(B)),G: fun(D,set(C)),X2: D,X5: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),F2),aa(D,set(C),G,X2)))),X5)
    <=> aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(D,set(C),G,X2)),aa(fun(C,$o),set(C),collect(C),aa(set(B),fun(C,$o),aTP_Lamp_hg(fun(C,set(B)),fun(set(B),fun(C,$o)),F2),X5))) ) ).

% UN_image_subset
tff(fact_1279_finite__inf__Sup,axiom,
    ! [B: $tType] :
      ( finite8700451911770168679attice(B)
     => ! [A4: B,A3: set(B)] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),aa(set(B),B,complete_Sup_Sup(B),A3)) = aa(set(B),B,complete_Sup_Sup(B),aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_hh(B,fun(set(B),fun(B,$o)),A4),A3))) ) ) ).

% finite_inf_Sup
tff(fact_1280_top__finite__def,axiom,
    ! [B: $tType] :
      ( finite_lattice(B)
     => ( top_top(B) = aa(set(B),B,complete_Sup_Sup(B),top_top(set(B))) ) ) ).

% top_finite_def
tff(fact_1281_Sup__nat__empty,axiom,
    aa(set(nat),nat,complete_Sup_Sup(nat),bot_bot(set(nat))) = zero_zero(nat) ).

% Sup_nat_empty
tff(fact_1282_in__Union__o__assoc,axiom,
    ! [C: $tType,B: $tType,D: $tType,X2: B,Gset: fun(C,set(set(B))),Gmap: fun(D,C),A3: D] :
      ( aa(set(B),$o,member(B,X2),aa(D,set(B),aa(fun(D,C),fun(D,set(B)),comp(C,set(B),D,aa(fun(C,set(set(B))),fun(C,set(B)),comp(set(set(B)),set(B),C,complete_Sup_Sup(set(B))),Gset)),Gmap),A3))
     => aa(set(B),$o,member(B,X2),aa(D,set(B),aa(fun(D,set(set(B))),fun(D,set(B)),comp(set(set(B)),set(B),D,complete_Sup_Sup(set(B))),aa(fun(D,C),fun(D,set(set(B))),comp(C,set(set(B)),D,Gset),Gmap)),A3)) ) ).

% in_Union_o_assoc
tff(fact_1283_UNIV__bool,axiom,
    top_top(set($o)) = aa(set($o),set($o),insert($o,$false),aa(set($o),set($o),insert($o,$true),bot_bot(set($o)))) ).

% UNIV_bool
tff(fact_1284_empty__natural,axiom,
    ! [D: $tType,C: $tType,E: $tType,B: $tType,F2: fun(B,D),G: fun(E,C)] : ( aa(fun(B,D),fun(B,set(C)),comp(D,set(C),B,aTP_Lamp_hi(D,set(C))),F2) = aa(fun(B,set(E)),fun(B,set(C)),comp(set(E),set(C),B,image2(E,C,G)),aTP_Lamp_hj(B,set(E))) ) ).

% empty_natural
tff(fact_1285_Union__natural,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C)] : ( aa(fun(set(set(B)),set(set(C))),fun(set(set(B)),set(C)),comp(set(set(C)),set(C),set(set(B)),complete_Sup_Sup(set(C))),image2(set(B),set(C),image2(B,C,F2))) = aa(fun(set(set(B)),set(B)),fun(set(set(B)),set(C)),comp(set(B),set(C),set(set(B)),image2(B,C,F2)),complete_Sup_Sup(set(B))) ) ).

% Union_natural
tff(fact_1286_SUP__UN__eq2,axiom,
    ! [B: $tType,C: $tType,D: $tType,R2: fun(D,set(product_prod(B,C))),S: set(D),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Sup_Sup(fun(B,fun(C,$o))),aa(set(D),set(fun(B,fun(C,$o))),image2(D,fun(B,fun(C,$o)),aTP_Lamp_hk(fun(D,set(product_prod(B,C))),fun(D,fun(B,fun(C,$o))),R2)),S)),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(D),set(set(product_prod(B,C))),image2(D,set(product_prod(B,C)),R2),S))) ) ).

% SUP_UN_eq2
tff(fact_1287_SUP__Sup__eq2,axiom,
    ! [C: $tType,B: $tType,S: set(set(product_prod(B,C))),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Sup_Sup(fun(B,fun(C,$o))),aa(set(set(product_prod(B,C))),set(fun(B,fun(C,$o))),image2(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o)))),S)),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),S)) ) ).

% SUP_Sup_eq2
tff(fact_1288_SUP__Sup__eq,axiom,
    ! [B: $tType,S: set(set(B)),X4: B] :
      ( aa(B,$o,aa(set(fun(B,$o)),fun(B,$o),complete_Sup_Sup(fun(B,$o)),aa(set(set(B)),set(fun(B,$o)),image2(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o))),S)),X4)
    <=> aa(set(B),$o,member(B,X4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),S)) ) ).

% SUP_Sup_eq
tff(fact_1289_Sup__set__def,axiom,
    ! [B: $tType,A3: set(set(B))] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A3) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_hl(set(set(B)),fun(B,$o),A3)) ) ).

% Sup_set_def
tff(fact_1290_Sup__SUP__eq2,axiom,
    ! [C: $tType,B: $tType,S: set(fun(B,fun(C,$o))),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Sup_Sup(fun(B,fun(C,$o))),S),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(fun(product_prod(B,C),$o)),set(set(product_prod(B,C))),image2(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C))),aa(set(fun(B,fun(C,$o))),set(fun(product_prod(B,C),$o)),image2(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o)),S)))) ) ).

% Sup_SUP_eq2
tff(fact_1291_SUP__UN__eq,axiom,
    ! [B: $tType,C: $tType,R2: fun(C,set(B)),S: set(C),X4: B] :
      ( aa(B,$o,aa(set(fun(B,$o)),fun(B,$o),complete_Sup_Sup(fun(B,$o)),aa(set(C),set(fun(B,$o)),image2(C,fun(B,$o),aTP_Lamp_hm(fun(C,set(B)),fun(C,fun(B,$o)),R2)),S)),X4)
    <=> aa(set(B),$o,member(B,X4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),R2),S))) ) ).

% SUP_UN_eq
tff(fact_1292_case__prod__comp,axiom,
    ! [E: $tType,B: $tType,D: $tType,C: $tType,F2: fun(E,fun(D,B)),G: fun(C,E),X2: product_prod(C,D)] : ( aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),aa(fun(C,E),fun(C,fun(D,B)),comp(E,fun(D,B),C,F2),G)),X2) = aa(D,B,aa(E,fun(D,B),F2,aa(C,E,G,aa(product_prod(C,D),C,product_fst(C,D),X2))),aa(product_prod(C,D),D,product_snd(C,D),X2)) ) ).

% case_prod_comp
tff(fact_1293_fst__diag__fst,axiom,
    ! [C: $tType,B: $tType] : ( aa(fun(product_prod(B,C),product_prod(B,B)),fun(product_prod(B,C),B),comp(product_prod(B,B),B,product_prod(B,C),product_fst(B,B)),aa(fun(product_prod(B,C),B),fun(product_prod(B,C),product_prod(B,B)),comp(B,product_prod(B,B),product_prod(B,C),aTP_Lamp_hn(B,product_prod(B,B))),product_fst(B,C))) = product_fst(B,C) ) ).

% fst_diag_fst
tff(fact_1294_snd__diag__snd,axiom,
    ! [C: $tType,B: $tType] : ( aa(fun(product_prod(B,C),product_prod(C,C)),fun(product_prod(B,C),C),comp(product_prod(C,C),C,product_prod(B,C),product_snd(C,C)),aa(fun(product_prod(B,C),C),fun(product_prod(B,C),product_prod(C,C)),comp(C,product_prod(C,C),product_prod(B,C),aTP_Lamp_ho(C,product_prod(C,C))),product_snd(B,C))) = product_snd(B,C) ) ).

% snd_diag_snd
tff(fact_1295_snd__diag__fst,axiom,
    ! [C: $tType,B: $tType] : ( aa(fun(product_prod(B,C),product_prod(B,B)),fun(product_prod(B,C),B),comp(product_prod(B,B),B,product_prod(B,C),product_snd(B,B)),aa(fun(product_prod(B,C),B),fun(product_prod(B,C),product_prod(B,B)),comp(B,product_prod(B,B),product_prod(B,C),aTP_Lamp_hn(B,product_prod(B,B))),product_fst(B,C))) = product_fst(B,C) ) ).

% snd_diag_fst
tff(fact_1296_fst__diag__snd,axiom,
    ! [C: $tType,B: $tType] : ( aa(fun(product_prod(B,C),product_prod(C,C)),fun(product_prod(B,C),C),comp(product_prod(C,C),C,product_prod(B,C),product_fst(C,C)),aa(fun(product_prod(B,C),C),fun(product_prod(B,C),product_prod(C,C)),comp(C,product_prod(C,C),product_prod(B,C),aTP_Lamp_ho(C,product_prod(C,C))),product_snd(B,C))) = product_snd(B,C) ) ).

% fst_diag_snd
tff(fact_1297_conj__subset__def,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa)))
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(fun(B,$o),set(B),collect(B),Pa))
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(fun(B,$o),set(B),collect(B),Qa)) ) ) ).

% conj_subset_def
tff(fact_1298_cSup__least,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X5: set(B),Z2: B] :
          ( ( X5 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),X5)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Z2) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),X5)),Z2) ) ) ) ).

% cSup_least
tff(fact_1299_cSup__eq__non__empty,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X5: set(B),A4: B] :
          ( ( X5 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),X5)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),A4) )
           => ( ! [Y2: B] :
                  ( ! [X4: B] :
                      ( aa(set(B),$o,member(B,X4),X5)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),Y2) )
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Y2) )
             => ( aa(set(B),B,complete_Sup_Sup(B),X5) = A4 ) ) ) ) ) ).

% cSup_eq_non_empty
tff(fact_1300_UN__UN__split__split__eq,axiom,
    ! [E: $tType,F10: $tType,B: $tType,D: $tType,C: $tType,A3: fun(C,fun(D,fun(E,fun(F10,set(B))))),Y3: set(product_prod(E,F10)),X5: set(product_prod(C,D))] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(product_prod(C,D)),set(set(B)),image2(product_prod(C,D),set(B),aa(fun(C,fun(D,set(B))),fun(product_prod(C,D),set(B)),product_case_prod(C,D,set(B)),aa(set(product_prod(E,F10)),fun(C,fun(D,set(B))),aTP_Lamp_hp(fun(C,fun(D,fun(E,fun(F10,set(B))))),fun(set(product_prod(E,F10)),fun(C,fun(D,set(B)))),A3),Y3))),X5)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(product_prod(C,D)),set(set(B)),image2(product_prod(C,D),set(B),aa(set(product_prod(E,F10)),fun(product_prod(C,D),set(B)),aTP_Lamp_hs(fun(C,fun(D,fun(E,fun(F10,set(B))))),fun(set(product_prod(E,F10)),fun(product_prod(C,D),set(B))),A3),Y3)),X5)) ) ).

% UN_UN_split_split_eq
tff(fact_1301_subset__mset_OcSUP__const,axiom,
    ! [B: $tType,C: $tType,A3: set(B),Ca: multiset(C)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),aTP_Lamp_ht(multiset(C),fun(B,multiset(C)),Ca)),A3)) = Ca ) ) ).

% subset_mset.cSUP_const
tff(fact_1302_typedef__rep__transfer,axiom,
    ! [C: $tType,B: $tType,Rep: fun(B,C),Abs: fun(C,B),A3: set(C),T2: fun(C,fun(B,$o))] :
      ( type_definition(B,C,Rep,Abs,A3)
     => ( ! [X: C,Xa4: B] :
            ( aa(B,$o,aa(C,fun(B,$o),T2,X),Xa4)
          <=> ( X = aa(B,C,Rep,Xa4) ) )
       => aa(fun(B,C),$o,aa(fun(C,C),fun(fun(B,C),$o),bNF_rel_fun(C,B,C,C,T2,fequal(C)),aTP_Lamp_hd(C,C)),Rep) ) ) ).

% typedef_rep_transfer
tff(fact_1303_UN__constant__eq,axiom,
    ! [B: $tType,C: $tType,A4: B,A3: set(B),F2: fun(B,set(C)),Ca: set(C)] :
      ( aa(set(B),$o,member(B,A4),A3)
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),A3)
           => ( aa(B,set(C),F2,X) = Ca ) )
       => ( aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),F2),A3)) = Ca ) ) ) ).

% UN_constant_eq
tff(fact_1304_UNION__fun__upd,axiom,
    ! [C: $tType,B: $tType,A3: fun(C,set(B)),I2: C,B2: set(B),J: set(C)] :
      ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),fun_upd(C,set(B),A3,I2,B2)),J))
      = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),J),aa(set(C),set(C),insert(C,I2),bot_bot(set(C))))))),$ite(aa(set(C),$o,member(C,I2),J),B2,bot_bot(set(B)))) ) ).

% UNION_fun_upd
tff(fact_1305_linear__order__on__singleton,axiom,
    ! [B: $tType,X2: B] : order_679001287576687338der_on(B,aa(set(B),set(B),insert(B,X2),bot_bot(set(B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2)),bot_bot(set(product_prod(B,B))))) ).

% linear_order_on_singleton
tff(fact_1306_Total__subset__Id,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( total_on(B,field2(B,R2),R2)
     => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R2),id2(B))
       => ( ( R2 = bot_bot(set(product_prod(B,B))) )
          | ? [A5: B] : ( R2 = aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A5),A5)),bot_bot(set(product_prod(B,B)))) ) ) ) ) ).

% Total_subset_Id
tff(fact_1307_INT__simps_I4_J,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(C,set(B)),C2: set(C)] :
      ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_hu(set(B),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C2))
      = $ite(C2 = bot_bot(set(C)),top_top(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2)))) ) ).

% INT_simps(4)
tff(fact_1308_subset__mset_OcSup__singleton,axiom,
    ! [B: $tType,X2: multiset(B)] : ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B))))) = X2 ) ).

% subset_mset.cSup_singleton
tff(fact_1309_Inf__top__conv_I1_J,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( ( aa(set(B),B,complete_Inf_Inf(B),A3) = top_top(B) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => ( X3 = top_top(B) ) ) ) ) ).

% Inf_top_conv(1)
tff(fact_1310_Inf__top__conv_I2_J,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( ( top_top(B) = aa(set(B),B,complete_Inf_Inf(B),A3) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => ( X3 = top_top(B) ) ) ) ) ).

% Inf_top_conv(2)
tff(fact_1311_INF__identity__eq,axiom,
    ! [B: $tType] :
      ( complete_Inf(B)
     => ! [A3: set(B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),image2(B,B,aTP_Lamp_hv(B,B)),A3)) = aa(set(B),B,complete_Inf_Inf(B),A3) ) ) ).

% INF_identity_eq
tff(fact_1312_INT__I,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B3: C,B2: fun(B,set(C))] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),A3)
         => aa(set(C),$o,member(C,B3),aa(B,set(C),B2,X)) )
     => aa(set(C),$o,member(C,B3),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A3))) ) ).

% INT_I
tff(fact_1313_INT__iff,axiom,
    ! [B: $tType,C: $tType,B3: B,B2: fun(C,set(B)),A3: set(C)] :
      ( aa(set(B),$o,member(B,B3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)))
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),A3)
         => aa(set(B),$o,member(B,B3),aa(C,set(B),B2,X3)) ) ) ).

% INT_iff
tff(fact_1314_Inf__apply,axiom,
    ! [B: $tType,C: $tType] :
      ( complete_Inf(B)
     => ! [A3: set(fun(C,B)),X2: C] : ( aa(C,B,aa(set(fun(C,B)),fun(C,B),complete_Inf_Inf(fun(C,B)),A3),X2) = aa(set(B),B,complete_Inf_Inf(B),aa(set(fun(C,B)),set(B),image2(fun(C,B),B,aTP_Lamp_hw(C,fun(fun(C,B),B),X2)),A3)) ) ) ).

% Inf_apply
tff(fact_1315_Inf__empty,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ( aa(set(B),B,complete_Inf_Inf(B),bot_bot(set(B))) = top_top(B) ) ) ).

% Inf_empty
tff(fact_1316_SUP2__I,axiom,
    ! [C: $tType,B: $tType,D: $tType,A4: B,A3: set(B),B2: fun(B,fun(C,fun(D,$o))),B3: C,Ca: D] :
      ( aa(set(B),$o,member(B,A4),A3)
     => ( aa(D,$o,aa(C,fun(D,$o),aa(B,fun(C,fun(D,$o)),B2,A4),B3),Ca)
       => aa(D,$o,aa(C,fun(D,$o),aa(set(fun(C,fun(D,$o))),fun(C,fun(D,$o)),complete_Sup_Sup(fun(C,fun(D,$o))),aa(set(B),set(fun(C,fun(D,$o))),image2(B,fun(C,fun(D,$o)),B2),A3)),B3),Ca) ) ) ).

% SUP2_I
tff(fact_1317_Inf__UNIV,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ( aa(set(B),B,complete_Inf_Inf(B),top_top(set(B))) = bot_bot(B) ) ) ).

% Inf_UNIV
tff(fact_1318_cInf__singleton,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X2: B] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = X2 ) ) ).

% cInf_singleton
tff(fact_1319_Inf__insert,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: B,A3: set(B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert(B,A4),A3)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),aa(set(B),B,complete_Inf_Inf(B),A3)) ) ) ).

% Inf_insert
tff(fact_1320_SUP1__I,axiom,
    ! [B: $tType,C: $tType,A4: B,A3: set(B),B2: fun(B,fun(C,$o)),B3: C] :
      ( aa(set(B),$o,member(B,A4),A3)
     => ( aa(C,$o,aa(B,fun(C,$o),B2,A4),B3)
       => aa(C,$o,aa(set(fun(C,$o)),fun(C,$o),complete_Sup_Sup(fun(C,$o)),aa(set(B),set(fun(C,$o)),image2(B,fun(C,$o),B2),A3)),B3) ) ) ).

% SUP1_I
tff(fact_1321_rtrancl__empty,axiom,
    ! [B: $tType] : ( transitive_rtrancl(B,bot_bot(set(product_prod(B,B)))) = id2(B) ) ).

% rtrancl_empty
tff(fact_1322_INF__const,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),F2: C] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,aTP_Lamp_fh(C,fun(B,C),F2)),A3)) = F2 ) ) ) ).

% INF_const
tff(fact_1323_cINF__const,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),Ca: C] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,aTP_Lamp_hf(C,fun(B,C),Ca)),A3)) = Ca ) ) ) ).

% cINF_const
tff(fact_1324_INF__top__conv_I2_J,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [B2: fun(C,B),A3: set(C)] :
          ( ( top_top(B) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,B2),A3)) )
        <=> ! [X3: C] :
              ( aa(set(C),$o,member(C,X3),A3)
             => ( aa(C,B,B2,X3) = top_top(B) ) ) ) ) ).

% INF_top_conv(2)
tff(fact_1325_INF__top__conv_I1_J,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [B2: fun(C,B),A3: set(C)] :
          ( ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,B2),A3)) = top_top(B) )
        <=> ! [X3: C] :
              ( aa(set(C),$o,member(C,X3),A3)
             => ( aa(C,B,B2,X3) = top_top(B) ) ) ) ) ).

% INF_top_conv(1)
tff(fact_1326_INF__top,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(C)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aTP_Lamp_hx(C,B)),A3)) = top_top(B) ) ) ).

% INF_top
tff(fact_1327_INF__apply,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( complete_Inf(B)
     => ! [F2: fun(D,fun(C,B)),A3: set(D),X2: C] : ( aa(C,B,aa(set(fun(C,B)),fun(C,B),complete_Inf_Inf(fun(C,B)),aa(set(D),set(fun(C,B)),image2(D,fun(C,B),F2),A3)),X2) = aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,aa(C,fun(D,B),aTP_Lamp_hy(fun(D,fun(C,B)),fun(C,fun(D,B)),F2),X2)),A3)) ) ) ).

% INF_apply
tff(fact_1328_INT__constant,axiom,
    ! [C: $tType,B: $tType,Ca: set(B),A3: set(C)] :
      ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_bv(set(B),fun(C,set(B)),Ca)),A3))
      = $ite(A3 = bot_bot(set(C)),top_top(set(B)),Ca) ) ).

% INT_constant
tff(fact_1329_INT__insert,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,set(B)),A4: C,A3: set(C)] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),aa(set(C),set(C),insert(C,A4),A3))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(C,set(B),B2,A4)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3))) ) ).

% INT_insert
tff(fact_1330_Compl__UN,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,set(B)),A3: set(C)] : ( aa(set(B),set(B),uminus_uminus(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_hz(fun(C,set(B)),fun(C,set(B)),B2)),A3)) ) ).

% Compl_UN
tff(fact_1331_Compl__INT,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,set(B)),A3: set(C)] : ( aa(set(B),set(B),uminus_uminus(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_hz(fun(C,set(B)),fun(C,set(B)),B2)),A3)) ) ).

% Compl_INT
tff(fact_1332_INT__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,A3: fun(C,set(B)),B2: set(B),C2: set(C)] :
      ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_go(fun(C,set(B)),fun(set(B),fun(C,set(B))),A3),B2)),C2))
      = $ite(C2 = bot_bot(set(C)),top_top(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),C2))),B2)) ) ).

% INT_simps(1)
tff(fact_1333_INT__simps_I2_J,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(C,set(B)),C2: set(C)] :
      ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_gn(set(B),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C2))
      = $ite(C2 = bot_bot(set(C)),top_top(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2)))) ) ).

% INT_simps(2)
tff(fact_1334_INT__simps_I3_J,axiom,
    ! [C: $tType,B: $tType,A3: fun(C,set(B)),B2: set(B),C2: set(C)] :
      ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_gq(fun(C,set(B)),fun(set(B),fun(C,set(B))),A3),B2)),C2))
      = $ite(C2 = bot_bot(set(C)),top_top(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),C2))),B2)) ) ).

% INT_simps(3)
tff(fact_1335_Sup__multiset__empty,axiom,
    ! [B: $tType] : ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),bot_bot(set(multiset(B)))) = zero_zero(multiset(B)) ) ).

% Sup_multiset_empty
tff(fact_1336_SUP2__E,axiom,
    ! [B: $tType,D: $tType,C: $tType,B2: fun(D,fun(B,fun(C,$o))),A3: set(D),B3: B,Ca: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Sup_Sup(fun(B,fun(C,$o))),aa(set(D),set(fun(B,fun(C,$o))),image2(D,fun(B,fun(C,$o)),B2),A3)),B3),Ca)
     => ~ ! [X: D] :
            ( aa(set(D),$o,member(D,X),A3)
           => ~ aa(C,$o,aa(B,fun(C,$o),aa(D,fun(B,fun(C,$o)),B2,X),B3),Ca) ) ) ).

% SUP2_E
tff(fact_1337_SUP1__E,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,fun(B,$o)),A3: set(C),B3: B] :
      ( aa(B,$o,aa(set(fun(B,$o)),fun(B,$o),complete_Sup_Sup(fun(B,$o)),aa(set(C),set(fun(B,$o)),image2(C,fun(B,$o),B2),A3)),B3)
     => ~ ! [X: C] :
            ( aa(set(C),$o,member(C,X),A3)
           => ~ aa(B,$o,aa(C,fun(B,$o),B2,X),B3) ) ) ).

% SUP1_E
tff(fact_1338_Inf__fun__def,axiom,
    ! [C: $tType,B: $tType] :
      ( complete_Inf(C)
     => ! [A3: set(fun(B,C)),X4: B] : ( aa(B,C,aa(set(fun(B,C)),fun(B,C),complete_Inf_Inf(fun(B,C)),A3),X4) = aa(set(C),C,complete_Inf_Inf(C),aa(set(fun(B,C)),set(C),image2(fun(B,C),C,aTP_Lamp_ia(B,fun(fun(B,C),C),X4)),A3)) ) ) ).

% Inf_fun_def
tff(fact_1339_Inter__UNIV,axiom,
    ! [B: $tType] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),top_top(set(set(B)))) = bot_bot(set(B)) ) ).

% Inter_UNIV
tff(fact_1340_Inter__Un__distrib,axiom,
    ! [B: $tType,A3: set(set(B)),B2: set(set(B))] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),sup_sup(set(set(B))),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),A3)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B2)) ) ).

% Inter_Un_distrib
tff(fact_1341_INF__commute,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,fun(D,B)),B2: set(D),A3: set(C)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(set(D),fun(C,B),aTP_Lamp_ib(fun(C,fun(D,B)),fun(set(D),fun(C,B)),F2),B2)),A3)) = aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,aa(set(C),fun(D,B),aTP_Lamp_ic(fun(C,fun(D,B)),fun(set(C),fun(D,B)),F2),A3)),B2)) ) ) ).

% INF_commute
tff(fact_1342_INT__D,axiom,
    ! [B: $tType,C: $tType,B3: B,B2: fun(C,set(B)),A3: set(C),A4: C] :
      ( aa(set(B),$o,member(B,B3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)))
     => ( aa(set(C),$o,member(C,A4),A3)
       => aa(set(B),$o,member(B,B3),aa(C,set(B),B2,A4)) ) ) ).

% INT_D
tff(fact_1343_INT__E,axiom,
    ! [B: $tType,C: $tType,B3: B,B2: fun(C,set(B)),A3: set(C),A4: C] :
      ( aa(set(B),$o,member(B,B3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)))
     => ( ~ aa(set(B),$o,member(B,B3),aa(C,set(B),B2,A4))
       => ~ aa(set(C),$o,member(C,A4),A3) ) ) ).

% INT_E
tff(fact_1344_Inf__less__eq,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B),U: B] :
          ( ! [V2: B] :
              ( aa(set(B),$o,member(B,V2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),V2),U) )
         => ( ( A3 != bot_bot(set(B)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),A3)),U) ) ) ) ).

% Inf_less_eq
tff(fact_1345_cInf__eq__non__empty,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X5: set(B),A4: B] :
          ( ( X5 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),X5)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),X) )
           => ( ! [Y2: B] :
                  ( ! [X4: B] :
                      ( aa(set(B),$o,member(B,X4),X5)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),X4) )
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),A4) )
             => ( aa(set(B),B,complete_Inf_Inf(B),X5) = A4 ) ) ) ) ) ).

% cInf_eq_non_empty
tff(fact_1346_cInf__greatest,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X5: set(B),Z2: B] :
          ( ( X5 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),X5)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),X) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),aa(set(B),B,complete_Inf_Inf(B),X5)) ) ) ) ).

% cInf_greatest
tff(fact_1347_INF__eq__const,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I: set(B),F2: fun(B,C),X2: C] :
          ( ( I != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( aa(set(B),$o,member(B,I3),I)
               => ( aa(B,C,F2,I3) = X2 ) )
           => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),I)) = X2 ) ) ) ) ).

% INF_eq_const
tff(fact_1348_bot__finite__def,axiom,
    ! [B: $tType] :
      ( finite_lattice(B)
     => ( bot_bot(B) = aa(set(B),B,complete_Inf_Inf(B),top_top(set(B))) ) ) ).

% bot_finite_def
tff(fact_1349_Inf__sup__eq__top__iff,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [B2: set(B),A4: B] :
          ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Inf_Inf(B),B2)),A4) = top_top(B) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),B2)
             => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X3),A4) = top_top(B) ) ) ) ) ).

% Inf_sup_eq_top_iff
tff(fact_1350_Inf__finite__insert,axiom,
    ! [B: $tType] :
      ( finite_lattice(B)
     => ! [A4: B,A3: set(B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert(B,A4),A3)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),aa(set(B),B,complete_Inf_Inf(B),A3)) ) ) ).

% Inf_finite_insert
tff(fact_1351_Inf__union__distrib,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B),B2: set(B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),A3)),aa(set(B),B,complete_Inf_Inf(B),B2)) ) ) ).

% Inf_union_distrib
tff(fact_1352_Inter__subset,axiom,
    ! [B: $tType,A3: set(set(B)),B2: set(B)] :
      ( ! [X6: set(B)] :
          ( aa(set(set(B)),$o,member(set(B),X6),A3)
         => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X6),B2) )
     => ( ( A3 != bot_bot(set(set(B))) )
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),A3)),B2) ) ) ).

% Inter_subset
tff(fact_1353_Inter__empty,axiom,
    ! [B: $tType] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),bot_bot(set(set(B)))) = top_top(set(B)) ) ).

% Inter_empty
tff(fact_1354_inj__on__Inter,axiom,
    ! [C: $tType,B: $tType,S: set(set(B)),F2: fun(B,C)] :
      ( ( S != bot_bot(set(set(B))) )
     => ( ! [A11: set(B)] :
            ( aa(set(set(B)),$o,member(set(B),A11),S)
           => inj_on(B,C,F2,A11) )
       => inj_on(B,C,F2,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),S)) ) ) ).

% inj_on_Inter
tff(fact_1355_INF__eqI,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),X2: C,F2: fun(B,C)] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),A3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),X2),aa(B,C,F2,I3)) )
         => ( ! [Y2: C] :
                ( ! [I4: B] :
                    ( aa(set(B),$o,member(B,I4),A3)
                   => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),Y2),aa(B,C,F2,I4)) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),Y2),X2) )
           => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3)) = X2 ) ) ) ) ).

% INF_eqI
tff(fact_1356_INF__mono,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comple6319245703460814977attice(D)
     => ! [B2: set(B),A3: set(C),F2: fun(C,D),G: fun(B,D)] :
          ( ! [M3: B] :
              ( aa(set(B),$o,member(B,M3),B2)
             => ? [X4: C] :
                  ( aa(set(C),$o,member(C,X4),A3)
                  & aa(D,$o,aa(D,fun(D,$o),ord_less_eq(D),aa(C,D,F2,X4)),aa(B,D,G,M3)) ) )
         => aa(D,$o,aa(D,fun(D,$o),ord_less_eq(D),aa(set(D),D,complete_Inf_Inf(D),aa(set(C),set(D),image2(C,D,F2),A3))),aa(set(D),D,complete_Inf_Inf(D),aa(set(B),set(D),image2(B,D,G),B2))) ) ) ).

% INF_mono
tff(fact_1357_INF__lower,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I2: B,A3: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,member(B,I2),A3)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(B,C,F2,I2)) ) ) ).

% INF_lower
tff(fact_1358_INF__mono_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [F2: fun(B,C),G: fun(B,C),A3: set(B)] :
          ( ! [X: B] : aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),aa(B,C,G,X))
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,G),A3))) ) ) ).

% INF_mono'
tff(fact_1359_INF__lower2,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I2: B,A3: set(B),F2: fun(B,C),U: C] :
          ( aa(set(B),$o,member(B,I2),A3)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I2)),U)
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))),U) ) ) ) ).

% INF_lower2
tff(fact_1360_le__INF__iff,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [U: B,F2: fun(C,B),A3: set(C)] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3)))
        <=> ! [X3: C] :
              ( aa(set(C),$o,member(C,X3),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(C,B,F2,X3)) ) ) ) ).

% le_INF_iff
tff(fact_1361_INF__greatest,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),U: C,F2: fun(B,C)] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),A3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),U),aa(B,C,F2,I3)) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),U),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))) ) ) ).

% INF_greatest
tff(fact_1362_INF__inf__distrib,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B),A3: set(C),G: fun(C,B)] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,G),A3))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_id(fun(C,B),fun(fun(C,B),fun(C,B)),F2),G)),A3)) ) ) ).

% INF_inf_distrib
tff(fact_1363_INF__absorb,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [K: B,I: set(B),A3: fun(B,C)] :
          ( aa(set(B),$o,member(B,K),I)
         => ( aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,A3,K)),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,A3),I))) = aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,A3),I)) ) ) ) ).

% INF_absorb
tff(fact_1364_INF__sup__distrib2,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [F2: fun(C,B),A3: set(C),G: fun(D,B),B2: set(D)] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,G),B2))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_if(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),F2),G),B2)),A3)) ) ) ).

% INF_sup_distrib2
tff(fact_1365_sup__INF,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [A4: B,F2: fun(C,B),B2: set(C)] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),B2))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ig(B,fun(fun(C,B),fun(C,B)),A4),F2)),B2)) ) ) ).

% sup_INF
tff(fact_1366_Inf__sup,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [B2: set(B),A4: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Inf_Inf(B),B2)),A4) = aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),image2(B,B,aTP_Lamp_ih(B,fun(B,B),A4)),B2)) ) ) ).

% Inf_sup
tff(fact_1367_INF__sup,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [F2: fun(C,B),B2: set(C),A4: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),B2))),A4) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(B,fun(C,B),aTP_Lamp_ii(fun(C,B),fun(B,fun(C,B)),F2),A4)),B2)) ) ) ).

% INF_sup
tff(fact_1368_Inter__insert,axiom,
    ! [B: $tType,A4: set(B),B2: set(set(B))] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(B)),set(set(B)),insert(set(B),A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B2)) ) ).

% Inter_insert
tff(fact_1369_INT__extend__simps_I10_J,axiom,
    ! [B: $tType,D: $tType,C: $tType,B2: fun(D,set(B)),F2: fun(C,D),A3: set(C)] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,D),fun(C,set(B)),aTP_Lamp_gh(fun(D,set(B)),fun(fun(C,D),fun(C,set(B))),B2),F2)),A3)) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(D),set(set(B)),image2(D,set(B),B2),aa(set(C),set(D),image2(C,D,F2),A3))) ) ).

% INT_extend_simps(10)
tff(fact_1370_INT__lower,axiom,
    ! [C: $tType,B: $tType,A4: B,A3: set(B),B2: fun(B,set(C))] :
      ( aa(set(B),$o,member(B,A4),A3)
     => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A3))),aa(B,set(C),B2,A4)) ) ).

% INT_lower
tff(fact_1371_INT__greatest,axiom,
    ! [C: $tType,B: $tType,A3: set(B),C2: set(C),B2: fun(B,set(C))] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),A3)
         => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),C2),aa(B,set(C),B2,X)) )
     => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),C2),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A3))) ) ).

% INT_greatest
tff(fact_1372_INT__anti__mono,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: set(B),F2: fun(B,set(C)),G: fun(B,set(C))] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),A3)
           => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),F2,X)),aa(B,set(C),G,X)) )
       => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),F2),B2))),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),G),A3))) ) ) ).

% INT_anti_mono
tff(fact_1373_INT__subset__iff,axiom,
    ! [B: $tType,C: $tType,B2: set(B),A3: fun(C,set(B)),I: set(C)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I)))
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),I)
         => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),aa(C,set(B),A3,X3)) ) ) ).

% INT_subset_iff
tff(fact_1374_INT__extend__simps_I5_J,axiom,
    ! [B: $tType,C: $tType,A4: B,B2: fun(C,set(B)),C2: set(C)] : ( aa(set(B),set(B),insert(B,A4),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_fi(B,fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),C2)) ) ).

% INT_extend_simps(5)
tff(fact_1375_INT__insert__distrib,axiom,
    ! [C: $tType,B: $tType,U: B,A3: set(B),A4: C,B2: fun(B,set(C))] :
      ( aa(set(B),$o,member(B,U),A3)
     => ( aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),aa(fun(B,set(C)),fun(B,set(C)),aTP_Lamp_gk(C,fun(fun(B,set(C)),fun(B,set(C))),A4),B2)),A3)) = aa(set(C),set(C),insert(C,A4),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A3))) ) ) ).

% INT_insert_distrib
tff(fact_1376_INTER__UNIV__conv_I1_J,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,set(B)),A3: set(C)] :
      ( ( top_top(set(B)) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)) )
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),A3)
         => ( aa(C,set(B),B2,X3) = top_top(set(B)) ) ) ) ).

% INTER_UNIV_conv(1)
tff(fact_1377_INTER__UNIV__conv_I2_J,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,set(B)),A3: set(C)] :
      ( ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)) = top_top(set(B)) )
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),A3)
         => ( aa(C,set(B),B2,X3) = top_top(set(B)) ) ) ) ).

% INTER_UNIV_conv(2)
tff(fact_1378_Int__Inter__image,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),B2: fun(C,set(B)),C2: set(C)] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_ij(fun(C,set(B)),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),C2))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2))) ) ).

% Int_Inter_image
tff(fact_1379_INT__Int__distrib,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),B2: fun(C,set(B)),I: set(C)] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_ij(fun(C,set(B)),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),I)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),I))) ) ).

% INT_Int_distrib
tff(fact_1380_INT__absorb,axiom,
    ! [C: $tType,B: $tType,K: B,I: set(B),A3: fun(B,set(C))] :
      ( aa(set(B),$o,member(B,K),I)
     => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A3,K)),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I))) = aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I)) ) ) ).

% INT_absorb
tff(fact_1381_Un__INT__distrib2,axiom,
    ! [D: $tType,B: $tType,C: $tType,A3: fun(C,set(B)),I: set(C),B2: fun(D,set(B)),J: set(D)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(D),set(set(B)),image2(D,set(B),B2),J))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(D),fun(C,set(B)),aa(fun(D,set(B)),fun(set(D),fun(C,set(B))),aTP_Lamp_il(fun(C,set(B)),fun(fun(D,set(B)),fun(set(D),fun(C,set(B)))),A3),B2),J)),I)) ) ).

% Un_INT_distrib2
tff(fact_1382_Un__INT__distrib,axiom,
    ! [B: $tType,C: $tType,B2: set(B),A3: fun(C,set(B)),I: set(C)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_fj(set(B),fun(fun(C,set(B)),fun(C,set(B))),B2),A3)),I)) ) ).

% Un_INT_distrib
tff(fact_1383_INT__extend__simps_I6_J,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),C2: set(C),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),C2))),B2) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_fk(fun(C,set(B)),fun(set(B),fun(C,set(B))),A3),B2)),C2)) ) ).

% INT_extend_simps(6)
tff(fact_1384_INT__extend__simps_I7_J,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(C,set(B)),C2: set(C)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_fj(set(B),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C2)) ) ).

% INT_extend_simps(7)
tff(fact_1385_INT__extend__simps_I9_J,axiom,
    ! [B: $tType,D: $tType,C: $tType,C2: fun(D,set(B)),B2: fun(C,set(D)),A3: set(C)] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(D)),fun(C,set(B)),aTP_Lamp_im(fun(D,set(B)),fun(fun(C,set(D)),fun(C,set(B))),C2),B2)),A3)) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(D),set(set(B)),image2(D,set(B),C2),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),B2),A3)))) ) ).

% INT_extend_simps(9)
tff(fact_1386_vimage__INT,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(B,C),B2: fun(D,set(C)),A3: set(D)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B2),A3))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_gr(fun(B,C),fun(fun(D,set(C)),fun(D,set(B))),F2),B2)),A3)) ) ).

% vimage_INT
tff(fact_1387_Id__def,axiom,
    ! [B: $tType] : ( id2(B) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aTP_Lamp_in(product_prod(B,B),$o)) ) ).

% Id_def
tff(fact_1388_Un__Inter,axiom,
    ! [B: $tType,A3: set(B),B2: set(set(B))] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B2)) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(B)),set(set(B)),image2(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3)),B2)) ) ).

% Un_Inter
tff(fact_1389_Id__fstsnd__eq,axiom,
    ! [B: $tType] : ( id2(B) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aTP_Lamp_io(product_prod(B,B),$o)) ) ).

% Id_fstsnd_eq
tff(fact_1390_INF__eq__iff,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I: set(B),F2: fun(B,C),Ca: C] :
          ( ( I != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( aa(set(B),$o,member(B,I3),I)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I3)),Ca) )
           => ( ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),I)) = Ca )
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),I)
                 => ( aa(B,C,F2,X3) = Ca ) ) ) ) ) ) ).

% INF_eq_iff
tff(fact_1391_cINF__greatest,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),M2: C,F2: fun(B,C)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),M2),aa(B,C,F2,X)) )
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),M2),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))) ) ) ) ).

% cINF_greatest
tff(fact_1392_Inf__le__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( ( A3 != bot_bot(set(B)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),A3)),aa(set(B),B,complete_Sup_Sup(B),A3)) ) ) ).

% Inf_le_Sup
tff(fact_1393_less__eq__Inf__inter,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B),B2: set(B)] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Inf_Inf(B),A3)),aa(set(B),B,complete_Inf_Inf(B),B2))),aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ).

% less_eq_Inf_inter
tff(fact_1394_Inf__finite__empty,axiom,
    ! [B: $tType] :
      ( finite_lattice(B)
     => ( aa(set(B),B,complete_Inf_Inf(B),bot_bot(set(B))) = aa(set(B),B,complete_Sup_Sup(B),top_top(set(B))) ) ) ).

% Inf_finite_empty
tff(fact_1395_Sup__finite__empty,axiom,
    ! [B: $tType] :
      ( finite_lattice(B)
     => ( aa(set(B),B,complete_Sup_Sup(B),bot_bot(set(B))) = aa(set(B),B,complete_Inf_Inf(B),top_top(set(B))) ) ) ).

% Sup_finite_empty
tff(fact_1396_lnear__order__on__empty,axiom,
    ! [B: $tType] : order_679001287576687338der_on(B,bot_bot(set(B)),bot_bot(set(product_prod(B,B)))) ).

% lnear_order_on_empty
tff(fact_1397_INF__superset__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [B2: set(B),A3: set(B),F2: fun(B,C),G: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A3)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),B2)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),aa(B,C,G,X)) )
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,G),B2))) ) ) ) ).

% INF_superset_mono
tff(fact_1398_INF__constant,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Ca: B,A3: set(C)] :
          ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aTP_Lamp_gu(B,fun(C,B),Ca)),A3))
          = $ite(A3 = bot_bot(set(C)),top_top(B),Ca) ) ) ).

% INF_constant
tff(fact_1399_INF__empty,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),bot_bot(set(C)))) = top_top(B) ) ) ).

% INF_empty
tff(fact_1400_INF__inf__const1,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I: set(B),X2: C,F2: fun(B,C)] :
          ( ( I != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_ip(C,fun(fun(B,C),fun(B,C)),X2),F2)),I)) = aa(C,C,aa(C,fun(C,C),inf_inf(C),X2),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),I))) ) ) ) ).

% INF_inf_const1
tff(fact_1401_INF__inf__const2,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I: set(B),F2: fun(B,C),X2: C] :
          ( ( I != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,aa(C,fun(B,C),aTP_Lamp_iq(fun(B,C),fun(C,fun(B,C)),F2),X2)),I)) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),I))),X2) ) ) ) ).

% INF_inf_const2
tff(fact_1402_uminus__SUP,axiom,
    ! [B: $tType,C: $tType] :
      ( comple489889107523837845lgebra(B)
     => ! [B2: fun(C,B),A3: set(C)] : ( aa(B,B,uminus_uminus(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,B2),A3))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aTP_Lamp_ir(fun(C,B),fun(C,B),B2)),A3)) ) ) ).

% uminus_SUP
tff(fact_1403_uminus__INF,axiom,
    ! [B: $tType,C: $tType] :
      ( comple489889107523837845lgebra(B)
     => ! [B2: fun(C,B),A3: set(C)] : ( aa(B,B,uminus_uminus(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,B2),A3))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aTP_Lamp_ir(fun(C,B),fun(C,B),B2)),A3)) ) ) ).

% uminus_INF
tff(fact_1404_INF__insert,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B),A4: C,A3: set(C)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),aa(set(C),set(C),insert(C,A4),A3))) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,F2,A4)),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3))) ) ) ).

% INF_insert
tff(fact_1405_INF__union,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [M: fun(C,B),A3: set(C),B2: set(C)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,M),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A3),B2))) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,M),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,M),B2))) ) ) ).

% INF_union
tff(fact_1406_INT__empty,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,set(B))] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),bot_bot(set(C)))) = top_top(set(B)) ) ).

% INT_empty
tff(fact_1407_INT__extend__simps_I2_J,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(C,set(B)),C2: set(C)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2)))
      = $ite(C2 = bot_bot(set(C)),A3,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_gn(set(B),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C2))) ) ).

% INT_extend_simps(2)
tff(fact_1408_INT__extend__simps_I1_J,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),C2: set(C),B2: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),C2))),B2)
      = $ite(C2 = bot_bot(set(C)),B2,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_go(fun(C,set(B)),fun(set(B),fun(C,set(B))),A3),B2)),C2))) ) ).

% INT_extend_simps(1)
tff(fact_1409_inj__on__INTER,axiom,
    ! [D: $tType,C: $tType,B: $tType,I: set(B),F2: fun(C,D),A3: fun(B,set(C))] :
      ( ( I != bot_bot(set(B)) )
     => ( ! [I3: B] :
            ( aa(set(B),$o,member(B,I3),I)
           => inj_on(C,D,F2,aa(B,set(C),A3,I3)) )
       => inj_on(C,D,F2,aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I))) ) ) ).

% inj_on_INTER
tff(fact_1410_INT__Un,axiom,
    ! [B: $tType,C: $tType,M: fun(C,set(B)),A3: set(C),B2: set(C)] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),M),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A3),B2))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),M),A3))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),M),B2))) ) ).

% INT_Un
tff(fact_1411_UN__extend__simps_I7_J,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(C,set(B)),C2: set(C)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_hu(set(B),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C2)) ) ).

% UN_extend_simps(7)
tff(fact_1412_Inter__Un__subset,axiom,
    ! [B: $tType,A3: set(set(B)),B2: set(set(B))] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),A3)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B2))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),inf_inf(set(set(B))),A3),B2))) ).

% Inter_Un_subset
tff(fact_1413_INT__extend__simps_I8_J,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,set(B)),A3: set(set(C))] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(C)),set(set(B)),image2(set(C),set(B),aTP_Lamp_is(fun(C,set(B)),fun(set(C),set(B)),B2)),A3)) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),A3))) ) ).

% INT_extend_simps(8)
tff(fact_1414_Int__Inter__eq_I2_J,axiom,
    ! [B: $tType,B7: set(set(B)),A3: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B7)),A3)
      = $ite(B7 = bot_bot(set(set(B))),A3,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(B)),set(set(B)),image2(set(B),set(B),aTP_Lamp_gs(set(B),fun(set(B),set(B)),A3)),B7))) ) ).

% Int_Inter_eq(2)
tff(fact_1415_Int__Inter__eq_I1_J,axiom,
    ! [B: $tType,A3: set(B),B7: set(set(B))] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B7))
      = $ite(B7 = bot_bot(set(set(B))),A3,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(B)),set(set(B)),image2(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3)),B7))) ) ).

% Int_Inter_eq(1)
tff(fact_1416_INF__le__SUP,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),F2: fun(B,C)] :
          ( ( A3 != bot_bot(set(B)) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))) ) ) ).

% INF_le_SUP
tff(fact_1417_reflcl__set__eq,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),X4: B,Xa3: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),sup_sup(fun(B,fun(B,$o))),aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2)),fequal(B)),X4),Xa3)
    <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa3)),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),R2),id2(B))) ) ).

% reflcl_set_eq
tff(fact_1418_INF__UNIV__bool__expand,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: fun($o,B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set($o),set(B),image2($o,B,A3),top_top(set($o)))) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa($o,B,A3,$true)),aa($o,B,A3,$false)) ) ) ).

% INF_UNIV_bool_expand
tff(fact_1419_image__INT,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(B,C),C2: set(B),A3: set(D),B2: fun(D,set(B)),J2: D] :
      ( inj_on(B,C,F2,C2)
     => ( ! [X: D] :
            ( aa(set(D),$o,member(D,X),A3)
           => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(D,set(B),B2,X)),C2) )
       => ( aa(set(D),$o,member(D,J2),A3)
         => ( aa(set(B),set(C),image2(B,C,F2),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(D),set(set(B)),image2(D,set(B),B2),A3))) = aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),aa(fun(D,set(B)),fun(D,set(C)),aTP_Lamp_iu(fun(B,C),fun(fun(D,set(B)),fun(D,set(C))),F2),B2)),A3)) ) ) ) ) ).

% image_INT
tff(fact_1420_INT__extend__simps_I3_J,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),C2: set(C),B2: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),C2))),B2)
      = $ite(C2 = bot_bot(set(C)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),top_top(set(B))),B2),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_gq(fun(C,set(B)),fun(set(B),fun(C,set(B))),A3),B2)),C2))) ) ).

% INT_extend_simps(3)
tff(fact_1421_INT__extend__simps_I4_J,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(C,set(B)),C2: set(C)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C2)))
      = $ite(C2 = bot_bot(set(C)),A3,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_hu(set(B),fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C2))) ) ).

% INT_extend_simps(4)
tff(fact_1422_INT__bool__eq,axiom,
    ! [B: $tType,A3: fun($o,set(B))] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set($o),set(set(B)),image2($o,set(B),A3),top_top(set($o)))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa($o,set(B),A3,$true)),aa($o,set(B),A3,$false)) ) ).

% INT_bool_eq
tff(fact_1423_fun__upd__image,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),X2: C,Y: B,A3: set(C)] :
      ( aa(set(C),set(B),image2(C,B,fun_upd(C,B,F2,X2,Y)),A3)
      = $ite(aa(set(C),$o,member(C,X2),A3),aa(set(B),set(B),insert(B,Y),aa(set(C),set(B),image2(C,B,F2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A3),aa(set(C),set(C),insert(C,X2),bot_bot(set(C)))))),aa(set(C),set(B),image2(C,B,F2),A3)) ) ).

% fun_upd_image
tff(fact_1424_Linear__order__Restr,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( order_679001287576687338der_on(B,field2(B,R2),R2)
     => order_679001287576687338der_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) ) ).

% Linear_order_Restr
tff(fact_1425_SUP__INF,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Pa: fun(D,fun(C,B))] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aTP_Lamp_iw(fun(D,fun(C,B)),fun(C,B),Pa)),top_top(set(C)))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(fun(C,D)),set(B),image2(fun(C,D),B,aTP_Lamp_iy(fun(D,fun(C,B)),fun(fun(C,D),B),Pa)),top_top(set(fun(C,D))))) ) ) ).

% SUP_INF
tff(fact_1426_INF__SUP,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Pa: fun(D,fun(C,B))] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aTP_Lamp_iz(fun(D,fun(C,B)),fun(C,B),Pa)),top_top(set(C)))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(fun(C,D)),set(B),image2(fun(C,D),B,aTP_Lamp_ja(fun(D,fun(C,B)),fun(fun(C,D),B),Pa)),top_top(set(fun(C,D))))) ) ) ).

% INF_SUP
tff(fact_1427_linear__order__on__Restr,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X2: B] :
      ( order_679001287576687338der_on(B,A3,R2)
     => order_679001287576687338der_on(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),order_above(B,R2,X2)),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,order_above(B,R2,X2),aa(B,fun(B,set(B)),aTP_Lamp_jb(set(product_prod(B,B)),fun(B,fun(B,set(B))),R2),X2)))) ) ).

% linear_order_on_Restr
tff(fact_1428_rel__pred__comp__def,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),Pa: fun(C,$o),X4: B] :
      ( rel_pred_comp(B,C,R,Pa,X4)
    <=> ? [Y4: C] :
          ( aa(C,$o,aa(B,fun(C,$o),R,X4),Y4)
          & aa(C,$o,Pa,Y4) ) ) ).

% rel_pred_comp_def
tff(fact_1429_Linear__order__wf__diff__Id,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( order_679001287576687338der_on(B,field2(B,R2),R2)
     => ( wf(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R2),id2(B)))
      <=> ! [A12: set(B)] :
            ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A12),field2(B,R2))
           => ( ( A12 != bot_bot(set(B)) )
             => ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A12)
                  & ! [Xa2: B] :
                      ( aa(set(B),$o,member(B,Xa2),A12)
                     => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa2)),R2) ) ) ) ) ) ) ).

% Linear_order_wf_diff_Id
tff(fact_1430_image__o__collect,axiom,
    ! [C: $tType,D: $tType,B: $tType,G: fun(D,C),F: set(fun(B,set(D)))] : ( bNF_collect(B,C,aa(set(fun(B,set(D))),set(fun(B,set(C))),image2(fun(B,set(D)),fun(B,set(C)),comp(set(D),set(C),B,image2(D,C,G))),F)) = aa(fun(B,set(D)),fun(B,set(C)),comp(set(D),set(C),B,image2(D,C,G)),bNF_collect(B,D,F)) ) ).

% image_o_collect
tff(fact_1431_bsqr__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( bNF_Wellorder_bsqr(B,R2) = aa(fun(product_prod(product_prod(B,B),product_prod(B,B)),$o),set(product_prod(product_prod(B,B),product_prod(B,B))),collect(product_prod(product_prod(B,B),product_prod(B,B))),aa(fun(product_prod(B,B),fun(product_prod(B,B),$o)),fun(product_prod(product_prod(B,B),product_prod(B,B)),$o),product_case_prod(product_prod(B,B),product_prod(B,B),$o),aa(fun(B,fun(B,fun(product_prod(B,B),$o))),fun(product_prod(B,B),fun(product_prod(B,B),$o)),product_case_prod(B,B,fun(product_prod(B,B),$o)),aTP_Lamp_jd(set(product_prod(B,B)),fun(B,fun(B,fun(product_prod(B,B),$o))),R2)))) ) ).

% bsqr_def
tff(fact_1432_same__fst__trancl,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),R: fun(B,set(product_prod(C,C)))] : ( transitive_trancl(product_prod(B,C),same_fst(B,C,Pa,R)) = same_fst(B,C,Pa,aTP_Lamp_je(fun(B,set(product_prod(C,C))),fun(B,set(product_prod(C,C))),R)) ) ).

% same_fst_trancl
tff(fact_1433_Inf__INT__eq2,axiom,
    ! [C: $tType,B: $tType,S: set(fun(B,fun(C,$o))),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Inf_Inf(fun(B,fun(C,$o))),S),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Inf_Inf(set(product_prod(B,C))),aa(set(fun(product_prod(B,C),$o)),set(set(product_prod(B,C))),image2(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C))),aa(set(fun(B,fun(C,$o))),set(fun(product_prod(B,C),$o)),image2(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o)),S)))) ) ).

% Inf_INT_eq2
tff(fact_1434_relation__of__def,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o)),A3: set(B)] : ( order_relation_of(B,Pa,A3) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(B),fun(B,fun(B,$o)),aTP_Lamp_jf(fun(B,fun(B,$o)),fun(set(B),fun(B,fun(B,$o))),Pa),A3))) ) ).

% relation_of_def
tff(fact_1435_INF1__I,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(B,fun(C,$o)),B3: C] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),A3)
         => aa(C,$o,aa(B,fun(C,$o),B2,X),B3) )
     => aa(C,$o,aa(set(fun(C,$o)),fun(C,$o),complete_Inf_Inf(fun(C,$o)),aa(set(B),set(fun(C,$o)),image2(B,fun(C,$o),B2),A3)),B3) ) ).

% INF1_I
tff(fact_1436_subset__mset_OcInf__singleton,axiom,
    ! [B: $tType,X2: multiset(B)] : ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B))))) = X2 ) ).

% subset_mset.cInf_singleton
tff(fact_1437_subset__mset_OcINF__const,axiom,
    ! [B: $tType,C: $tType,A3: set(B),Ca: multiset(C)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),aTP_Lamp_ht(multiset(C),fun(B,multiset(C)),Ca)),A3)) = Ca ) ) ).

% subset_mset.cINF_const
tff(fact_1438_INF2__I,axiom,
    ! [C: $tType,B: $tType,D: $tType,A3: set(B),B2: fun(B,fun(C,fun(D,$o))),B3: C,Ca: D] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),A3)
         => aa(D,$o,aa(C,fun(D,$o),aa(B,fun(C,fun(D,$o)),B2,X),B3),Ca) )
     => aa(D,$o,aa(C,fun(D,$o),aa(set(fun(C,fun(D,$o))),fun(C,fun(D,$o)),complete_Inf_Inf(fun(C,fun(D,$o))),aa(set(B),set(fun(C,fun(D,$o))),image2(B,fun(C,fun(D,$o)),B2),A3)),B3),Ca) ) ).

% INF2_I
tff(fact_1439_Inf__multiset__empty,axiom,
    ! [B: $tType] : ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),bot_bot(set(multiset(B)))) = zero_zero(multiset(B)) ) ).

% Inf_multiset_empty
tff(fact_1440_Inf__nat__def1,axiom,
    ! [K4: set(nat)] :
      ( ( K4 != bot_bot(set(nat)) )
     => aa(set(nat),$o,member(nat,aa(set(nat),nat,complete_Inf_Inf(nat),K4)),K4) ) ).

% Inf_nat_def1
tff(fact_1441_INF2__D,axiom,
    ! [B: $tType,D: $tType,C: $tType,B2: fun(D,fun(B,fun(C,$o))),A3: set(D),B3: B,Ca: C,A4: D] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Inf_Inf(fun(B,fun(C,$o))),aa(set(D),set(fun(B,fun(C,$o))),image2(D,fun(B,fun(C,$o)),B2),A3)),B3),Ca)
     => ( aa(set(D),$o,member(D,A4),A3)
       => aa(C,$o,aa(B,fun(C,$o),aa(D,fun(B,fun(C,$o)),B2,A4),B3),Ca) ) ) ).

% INF2_D
tff(fact_1442_INF2__E,axiom,
    ! [C: $tType,B: $tType,D: $tType,B2: fun(D,fun(B,fun(C,$o))),A3: set(D),B3: B,Ca: C,A4: D] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Inf_Inf(fun(B,fun(C,$o))),aa(set(D),set(fun(B,fun(C,$o))),image2(D,fun(B,fun(C,$o)),B2),A3)),B3),Ca)
     => ( ~ aa(C,$o,aa(B,fun(C,$o),aa(D,fun(B,fun(C,$o)),B2,A4),B3),Ca)
       => ~ aa(set(D),$o,member(D,A4),A3) ) ) ).

% INF2_E
tff(fact_1443_INF1__D,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,fun(B,$o)),A3: set(C),B3: B,A4: C] :
      ( aa(B,$o,aa(set(fun(B,$o)),fun(B,$o),complete_Inf_Inf(fun(B,$o)),aa(set(C),set(fun(B,$o)),image2(C,fun(B,$o),B2),A3)),B3)
     => ( aa(set(C),$o,member(C,A4),A3)
       => aa(B,$o,aa(C,fun(B,$o),B2,A4),B3) ) ) ).

% INF1_D
tff(fact_1444_INF1__E,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,fun(B,$o)),A3: set(C),B3: B,A4: C] :
      ( aa(B,$o,aa(set(fun(B,$o)),fun(B,$o),complete_Inf_Inf(fun(B,$o)),aa(set(C),set(fun(B,$o)),image2(C,fun(B,$o),B2),A3)),B3)
     => ( ~ aa(B,$o,aa(C,fun(B,$o),B2,A4),B3)
       => ~ aa(set(C),$o,member(C,A4),A3) ) ) ).

% INF1_E
tff(fact_1445_INF__Int__eq2,axiom,
    ! [C: $tType,B: $tType,S: set(set(product_prod(B,C))),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Inf_Inf(fun(B,fun(C,$o))),aa(set(set(product_prod(B,C))),set(fun(B,fun(C,$o))),image2(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o)))),S)),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Inf_Inf(set(product_prod(B,C))),S)) ) ).

% INF_Int_eq2
tff(fact_1446_INF__Int__eq,axiom,
    ! [B: $tType,S: set(set(B)),X4: B] :
      ( aa(B,$o,aa(set(fun(B,$o)),fun(B,$o),complete_Inf_Inf(fun(B,$o)),aa(set(set(B)),set(fun(B,$o)),image2(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o))),S)),X4)
    <=> aa(set(B),$o,member(B,X4),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),S)) ) ).

% INF_Int_eq
tff(fact_1447_INF__INT__eq,axiom,
    ! [B: $tType,C: $tType,R2: fun(C,set(B)),S: set(C),X4: B] :
      ( aa(B,$o,aa(set(fun(B,$o)),fun(B,$o),complete_Inf_Inf(fun(B,$o)),aa(set(C),set(fun(B,$o)),image2(C,fun(B,$o),aTP_Lamp_hm(fun(C,set(B)),fun(C,fun(B,$o)),R2)),S)),X4)
    <=> aa(set(B),$o,member(B,X4),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),R2),S))) ) ).

% INF_INT_eq
tff(fact_1448_INF__INT__eq2,axiom,
    ! [B: $tType,C: $tType,D: $tType,R2: fun(D,set(product_prod(B,C))),S: set(D),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Inf_Inf(fun(B,fun(C,$o))),aa(set(D),set(fun(B,fun(C,$o))),image2(D,fun(B,fun(C,$o)),aTP_Lamp_hk(fun(D,set(product_prod(B,C))),fun(D,fun(B,fun(C,$o))),R2)),S)),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Inf_Inf(set(product_prod(B,C))),aa(set(D),set(set(product_prod(B,C))),image2(D,set(product_prod(B,C)),R2),S))) ) ).

% INF_INT_eq2
tff(fact_1449_Inf__set__def,axiom,
    ! [B: $tType,A3: set(set(B))] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),A3) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_jg(set(set(B)),fun(B,$o),A3)) ) ).

% Inf_set_def
tff(fact_1450_wf__eq__minimal2,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( wf(B,R2)
    <=> ! [A12: set(B)] :
          ( ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A12),field2(B,R2))
            & ( A12 != bot_bot(set(B)) ) )
         => ? [X3: B] :
              ( aa(set(B),$o,member(B,X3),A12)
              & ! [Xa2: B] :
                  ( aa(set(B),$o,member(B,Xa2),A12)
                 => ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa2),X3)),R2) ) ) ) ) ).

% wf_eq_minimal2
tff(fact_1451_collect__def,axiom,
    ! [B: $tType,C: $tType,F: set(fun(C,set(B))),X2: C] : ( aa(C,set(B),bNF_collect(C,B,F),X2) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(fun(C,set(B))),set(set(B)),image2(fun(C,set(B)),set(B),aTP_Lamp_jh(C,fun(fun(C,set(B)),set(B)),X2)),F)) ) ).

% collect_def
tff(fact_1452_Field__bsqr,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( field2(product_prod(B,B),bNF_Wellorder_bsqr(B,R2)) = product_Sigma(B,B,field2(B,R2),aTP_Lamp_ey(set(product_prod(B,B)),fun(B,set(B)),R2)) ) ).

% Field_bsqr
tff(fact_1453_collect__comp,axiom,
    ! [B: $tType,C: $tType,D: $tType,F: set(fun(D,set(C))),G: fun(B,D)] : ( aa(fun(B,D),fun(B,set(C)),comp(D,set(C),B,bNF_collect(D,C,F)),G) = bNF_collect(B,C,aa(set(fun(D,set(C))),set(fun(B,set(C))),image2(fun(D,set(C)),fun(B,set(C)),aTP_Lamp_ji(fun(B,D),fun(fun(D,set(C)),fun(B,set(C))),G)),F)) ) ).

% collect_comp
tff(fact_1454_above__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B] : ( order_above(B,R2,A4) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2),A4)) ) ).

% above_def
tff(fact_1455_same__fst__def,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),R: fun(B,set(product_prod(C,C)))] : ( same_fst(B,C,Pa,R) = aa(fun(product_prod(product_prod(B,C),product_prod(B,C)),$o),set(product_prod(product_prod(B,C),product_prod(B,C))),collect(product_prod(product_prod(B,C),product_prod(B,C))),aa(fun(product_prod(B,C),fun(product_prod(B,C),$o)),fun(product_prod(product_prod(B,C),product_prod(B,C)),$o),product_case_prod(product_prod(B,C),product_prod(B,C),$o),aa(fun(B,fun(C,fun(product_prod(B,C),$o))),fun(product_prod(B,C),fun(product_prod(B,C),$o)),product_case_prod(B,C,fun(product_prod(B,C),$o)),aa(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(product_prod(B,C),$o))),aTP_Lamp_jk(fun(B,$o),fun(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(product_prod(B,C),$o)))),Pa),R)))) ) ).

% same_fst_def
tff(fact_1456_wf__empty,axiom,
    ! [B: $tType] : wf(B,bot_bot(set(product_prod(B,B)))) ).

% wf_empty
tff(fact_1457_wfI,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B),B2: set(B)] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),B2)))
     => ( ! [X: B,P: fun(B,$o)] :
            ( ! [Xa3: B] :
                ( ! [Y2: B] :
                    ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Xa3)),R2)
                   => aa(B,$o,P,Y2) )
               => aa(B,$o,P,Xa3) )
           => ( aa(set(B),$o,member(B,X),A3)
             => ( aa(set(B),$o,member(B,X),B2)
               => aa(B,$o,P,X) ) ) )
       => wf(B,R2) ) ) ).

% wfI
tff(fact_1458_wfE__min_H,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),Qa: set(B)] :
      ( wf(B,R)
     => ( ( Qa != bot_bot(set(B)) )
       => ~ ! [Z3: B] :
              ( aa(set(B),$o,member(B,Z3),Qa)
             => ~ ! [Y5: B] :
                    ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y5),Z3)),R)
                   => ~ aa(set(B),$o,member(B,Y5),Qa) ) ) ) ) ).

% wfE_min'
tff(fact_1459_wf__Int1,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),R4: set(product_prod(B,B))] :
      ( wf(B,R2)
     => wf(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),R4)) ) ).

% wf_Int1
tff(fact_1460_wf__Int2,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),R4: set(product_prod(B,B))] :
      ( wf(B,R2)
     => wf(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R4),R2)) ) ).

% wf_Int2
tff(fact_1461_lex__prod__def,axiom,
    ! [B: $tType,C: $tType,Ra: set(product_prod(B,B)),Rb: set(product_prod(C,C))] : ( lex_prod(B,C,Ra,Rb) = aa(fun(product_prod(product_prod(B,C),product_prod(B,C)),$o),set(product_prod(product_prod(B,C),product_prod(B,C))),collect(product_prod(product_prod(B,C),product_prod(B,C))),aa(fun(product_prod(B,C),fun(product_prod(B,C),$o)),fun(product_prod(product_prod(B,C),product_prod(B,C)),$o),product_case_prod(product_prod(B,C),product_prod(B,C),$o),aa(fun(B,fun(C,fun(product_prod(B,C),$o))),fun(product_prod(B,C),fun(product_prod(B,C),$o)),product_case_prod(B,C,fun(product_prod(B,C),$o)),aa(set(product_prod(C,C)),fun(B,fun(C,fun(product_prod(B,C),$o))),aTP_Lamp_jm(set(product_prod(B,B)),fun(set(product_prod(C,C)),fun(B,fun(C,fun(product_prod(B,C),$o)))),Ra),Rb)))) ) ).

% lex_prod_def
tff(fact_1462_subset__Image1__Image1__iff,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B,B3: B] :
      ( order_preorder_on(B,field2(B,R2),R2)
     => ( aa(set(B),$o,member(B,A4),field2(B,R2))
       => ( aa(set(B),$o,member(B,B3),field2(B,R2))
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))))
          <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B3),A4)),R2) ) ) ) ) ).

% subset_Image1_Image1_iff
tff(fact_1463_Image__empty2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(C,B))] : ( aa(set(C),set(B),image(C,B,R),bot_bot(set(C))) = bot_bot(set(B)) ) ).

% Image_empty2
tff(fact_1464_Image__empty1,axiom,
    ! [C: $tType,B: $tType,X5: set(C)] : ( aa(set(C),set(B),image(C,B,bot_bot(set(product_prod(C,B)))),X5) = bot_bot(set(B)) ) ).

% Image_empty1
tff(fact_1465_Image__Id__on,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(set(B),set(B),image(B,B,id_on(B,A3)),B2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) ) ).

% Image_Id_on
tff(fact_1466_Image__singleton__iff,axiom,
    ! [B: $tType,C: $tType,B3: B,R2: set(product_prod(C,B)),A4: C] :
      ( aa(set(B),$o,member(B,B3),aa(set(C),set(B),image(C,B,R2),aa(set(C),set(C),insert(C,A4),bot_bot(set(C)))))
    <=> aa(set(product_prod(C,B)),$o,member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),A4),B3)),R2) ) ).

% Image_singleton_iff
tff(fact_1467_pair__vimage__is__Image,axiom,
    ! [B: $tType,C: $tType,U: C,E3: set(product_prod(C,B))] : ( aa(set(product_prod(C,B)),set(B),aa(fun(B,product_prod(C,B)),fun(set(product_prod(C,B)),set(B)),vimage(B,product_prod(C,B)),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),U)),E3) = aa(set(C),set(B),image(C,B,E3),aa(set(C),set(C),insert(C,U),bot_bot(set(C)))) ) ).

% pair_vimage_is_Image
tff(fact_1468_Image__Int__subset,axiom,
    ! [B: $tType,C: $tType,R: set(product_prod(C,B)),A3: set(C),B2: set(C)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(C),set(B),image(C,B,R),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),image(C,B,R),A3)),aa(set(C),set(B),image(C,B,R),B2))) ).

% Image_Int_subset
tff(fact_1469_wfE__pf,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),A3: set(B)] :
      ( wf(B,R)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),image(B,B,R),A3))
       => ( A3 = bot_bot(set(B)) ) ) ) ).

% wfE_pf
tff(fact_1470_wfI__pf,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ! [A11: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A11),aa(set(B),set(B),image(B,B,R),A11))
         => ( A11 = bot_bot(set(B)) ) )
     => wf(B,R) ) ).

% wfI_pf
tff(fact_1471_Image__UN,axiom,
    ! [C: $tType,B: $tType,D: $tType,R2: set(product_prod(C,B)),B2: fun(D,set(C)),A3: set(D)] : ( aa(set(C),set(B),image(C,B,R2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B2),A3))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_jn(set(product_prod(C,B)),fun(fun(D,set(C)),fun(D,set(B))),R2),B2)),A3)) ) ).

% Image_UN
tff(fact_1472_Image__empty__rtrancl__Image__id,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),V: B] :
      ( ( aa(set(B),set(B),image(B,B,R),aa(set(B),set(B),insert(B,V),bot_bot(set(B)))) = bot_bot(set(B)) )
     => ( aa(set(B),set(B),image(B,B,transitive_rtrancl(B,R)),aa(set(B),set(B),insert(B,V),bot_bot(set(B)))) = aa(set(B),set(B),insert(B,V),bot_bot(set(B))) ) ) ).

% Image_empty_rtrancl_Image_id
tff(fact_1473_Image__empty__trancl__Image__empty,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),V: B] :
      ( ( aa(set(B),set(B),image(B,B,R),aa(set(B),set(B),insert(B,V),bot_bot(set(B)))) = bot_bot(set(B)) )
     => ( aa(set(B),set(B),image(B,B,transitive_trancl(B,R)),aa(set(B),set(B),insert(B,V),bot_bot(set(B)))) = bot_bot(set(B)) ) ) ).

% Image_empty_trancl_Image_empty
tff(fact_1474_total__on__lex__prod,axiom,
    ! [B: $tType,C: $tType,A3: set(B),R2: set(product_prod(B,B)),B2: set(C),S2: set(product_prod(C,C))] :
      ( total_on(B,A3,R2)
     => ( total_on(C,B2,S2)
       => total_on(product_prod(B,C),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)),lex_prod(B,C,R2,S2)) ) ) ).

% total_on_lex_prod
tff(fact_1475_Image__singleton,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(C,B)),A4: C] : ( aa(set(C),set(B),image(C,B,R2),aa(set(C),set(C),insert(C,A4),bot_bot(set(C)))) = aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aTP_Lamp_jo(set(product_prod(C,B)),fun(C,fun(B,$o)),R2),A4)) ) ).

% Image_singleton
tff(fact_1476_Image__subset,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(B,C)),A3: set(B),B2: set(C),C2: set(B)] :
      ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),R2),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))
     => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image(B,C,R2),C2)),B2) ) ).

% Image_subset
tff(fact_1477_Image__INT__subset,axiom,
    ! [C: $tType,B: $tType,D: $tType,R2: set(product_prod(C,B)),B2: fun(D,set(C)),A3: set(D)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(C),set(B),image(C,B,R2),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B2),A3)))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_jn(set(product_prod(C,B)),fun(fun(D,set(C)),fun(D,set(B))),R2),B2)),A3))) ).

% Image_INT_subset
tff(fact_1478_rtrancl__apply__insert,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),X2: B,S: set(B)] : ( aa(set(B),set(B),image(B,B,transitive_rtrancl(B,R)),aa(set(B),set(B),insert(B,X2),S)) = aa(set(B),set(B),insert(B,X2),aa(set(B),set(B),image(B,B,transitive_rtrancl(B,R)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S),aa(set(B),set(B),image(B,B,R),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))))) ) ).

% rtrancl_apply_insert
tff(fact_1479_Image__eq__UN,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(C,B)),B2: set(C)] : ( aa(set(C),set(B),image(C,B,R2),B2) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_jp(set(product_prod(C,B)),fun(C,set(B)),R2)),B2)) ) ).

% Image_eq_UN
tff(fact_1480_Sigma__Image,axiom,
    ! [B: $tType,C: $tType,A3: set(C),B2: fun(C,set(B)),X5: set(C)] : ( aa(set(C),set(B),image(C,B,product_Sigma(C,B,A3,B2)),X5) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),X5),A3))) ) ).

% Sigma_Image
tff(fact_1481_UN__Image,axiom,
    ! [C: $tType,B: $tType,D: $tType,X5: fun(D,set(product_prod(C,B))),I: set(D),S: set(C)] : ( aa(set(C),set(B),image(C,B,aa(set(set(product_prod(C,B))),set(product_prod(C,B)),complete_Sup_Sup(set(product_prod(C,B))),aa(set(D),set(set(product_prod(C,B))),image2(D,set(product_prod(C,B)),X5),I))),S) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(set(C),fun(D,set(B)),aTP_Lamp_jq(fun(D,set(product_prod(C,B))),fun(set(C),fun(D,set(B))),X5),S)),I)) ) ).

% UN_Image
tff(fact_1482_rtrancl__Image__advance__ss,axiom,
    ! [B: $tType,U: B,V: B,E3: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V)),E3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),image(B,B,transitive_rtrancl(B,E3)),aa(set(B),set(B),insert(B,V),bot_bot(set(B))))),aa(set(B),set(B),image(B,B,transitive_rtrancl(B,E3)),aa(set(B),set(B),insert(B,U),bot_bot(set(B))))) ) ).

% rtrancl_Image_advance_ss
tff(fact_1483_trancl__Image__advance__ss,axiom,
    ! [B: $tType,U: B,V: B,E3: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V)),E3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),image(B,B,transitive_trancl(B,E3)),aa(set(B),set(B),insert(B,V),bot_bot(set(B))))),aa(set(B),set(B),image(B,B,transitive_trancl(B,E3)),aa(set(B),set(B),insert(B,U),bot_bot(set(B))))) ) ).

% trancl_Image_advance_ss
tff(fact_1484_trancl__restrict__reachable,axiom,
    ! [B: $tType,U: B,V: B,E3: set(product_prod(B,B)),S: set(B)] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V)),transitive_trancl(B,E3))
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),image(B,B,E3),S)),S)
       => ( aa(set(B),$o,member(B,U),S)
         => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V)),transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),E3),product_Sigma(B,B,S,aTP_Lamp_cr(set(B),fun(B,set(B)),S))))) ) ) ) ).

% trancl_restrict_reachable
tff(fact_1485_Refl__antisym__eq__Image1__Image1__iff,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B,B3: B] :
      ( refl_on(B,field2(B,R2),R2)
     => ( antisym(B,R2)
       => ( aa(set(B),$o,member(B,A4),field2(B,R2))
         => ( aa(set(B),$o,member(B,B3),field2(B,R2))
           => ( ( aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) = aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))) )
            <=> ( A4 = B3 ) ) ) ) ) ) ).

% Refl_antisym_eq_Image1_Image1_iff
tff(fact_1486_quotient__def,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B))] : ( equiv_quotient(B,A3,R2) = aa(set(set(set(B))),set(set(B)),complete_Sup_Sup(set(set(B))),aa(set(B),set(set(set(B))),image2(B,set(set(B)),aTP_Lamp_jr(set(product_prod(B,B)),fun(B,set(set(B))),R2)),A3)) ) ).

% quotient_def
tff(fact_1487_singleton__quotient,axiom,
    ! [B: $tType,X2: B,R2: set(product_prod(B,B))] : ( equiv_quotient(B,aa(set(B),set(B),insert(B,X2),bot_bot(set(B))),R2) = aa(set(set(B)),set(set(B)),insert(set(B),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),bot_bot(set(set(B)))) ) ).

% singleton_quotient
tff(fact_1488_chains__extend,axiom,
    ! [B: $tType,Ca: set(set(B)),S: set(set(B)),Z2: set(B)] :
      ( aa(set(set(set(B))),$o,member(set(set(B)),Ca),chains2(B,S))
     => ( aa(set(set(B)),$o,member(set(B),Z2),S)
       => ( ! [X: set(B)] :
              ( aa(set(set(B)),$o,member(set(B),X),Ca)
             => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X),Z2) )
         => aa(set(set(set(B))),$o,member(set(set(B)),aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),sup_sup(set(set(B))),aa(set(set(B)),set(set(B)),insert(set(B),Z2),bot_bot(set(set(B))))),Ca)),chains2(B,S)) ) ) ) ).

% chains_extend
tff(fact_1489_Rep__unit,axiom,
    ! [X2: product_unit] : aa(set($o),$o,member($o,aa(product_unit,$o,product_Rep_unit,X2)),aa(set($o),set($o),insert($o,$true),bot_bot(set($o)))) ).

% Rep_unit
tff(fact_1490_Abs__unit__cases,axiom,
    ! [X2: product_unit] :
      ~ ! [Y2: $o] :
          ( ( X2 = aa($o,product_unit,product_Abs_unit,Y2) )
         => ~ aa(set($o),$o,member($o,Y2),aa(set($o),set($o),insert($o,$true),bot_bot(set($o)))) ) ).

% Abs_unit_cases
tff(fact_1491_Rep__unit__cases,axiom,
    ! [Y: $o] :
      ( aa(set($o),$o,member($o,Y),aa(set($o),set($o),insert($o,$true),bot_bot(set($o))))
     => ~ ! [X: product_unit] :
            ( (Y)
          <=> ~ aa(product_unit,$o,product_Rep_unit,X) ) ) ).

% Rep_unit_cases
tff(fact_1492_Abs__unit__induct,axiom,
    ! [Pa: fun(product_unit,$o),X2: product_unit] :
      ( ! [Y2: $o] :
          ( aa(set($o),$o,member($o,Y2),aa(set($o),set($o),insert($o,$true),bot_bot(set($o))))
         => aa(product_unit,$o,Pa,aa($o,product_unit,product_Abs_unit,Y2)) )
     => aa(product_unit,$o,Pa,X2) ) ).

% Abs_unit_induct
tff(fact_1493_quotient__is__empty2,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B))] :
      ( ( bot_bot(set(set(B))) = equiv_quotient(B,A3,R2) )
    <=> ( A3 = bot_bot(set(B)) ) ) ).

% quotient_is_empty2
tff(fact_1494_quotient__is__empty,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B))] :
      ( ( equiv_quotient(B,A3,R2) = bot_bot(set(set(B))) )
    <=> ( A3 = bot_bot(set(B)) ) ) ).

% quotient_is_empty
tff(fact_1495_quotient__empty,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( equiv_quotient(B,bot_bot(set(B)),R2) = bot_bot(set(set(B))) ) ).

% quotient_empty
tff(fact_1496_antisym__empty,axiom,
    ! [B: $tType] : antisym(B,bot_bot(set(product_prod(B,B)))) ).

% antisym_empty
tff(fact_1497_type__definition__unit,axiom,
    type_definition(product_unit,$o,product_Rep_unit,product_Abs_unit,aa(set($o),set($o),insert($o,$true),bot_bot(set($o)))) ).

% type_definition_unit
tff(fact_1498_Abs__unit__inverse,axiom,
    ! [Y: $o] :
      ( aa(set($o),$o,member($o,Y),aa(set($o),set($o),insert($o,$true),bot_bot(set($o))))
     => ( aa(product_unit,$o,product_Rep_unit,aa($o,product_unit,product_Abs_unit,Y))
      <=> (Y) ) ) ).

% Abs_unit_inverse
tff(fact_1499_antisym__singleton,axiom,
    ! [B: $tType,X2: product_prod(B,B)] : antisym(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),X2),bot_bot(set(product_prod(B,B))))) ).

% antisym_singleton
tff(fact_1500_antisym__Restr,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( antisym(B,R2)
     => antisym(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) ) ).

% antisym_Restr
tff(fact_1501_quotientE,axiom,
    ! [B: $tType,X5: set(B),A3: set(B),R2: set(product_prod(B,B))] :
      ( aa(set(set(B)),$o,member(set(B),X5),equiv_quotient(B,A3,R2))
     => ~ ! [X: B] :
            ( ( X5 = aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,X),bot_bot(set(B)))) )
           => ~ aa(set(B),$o,member(B,X),A3) ) ) ).

% quotientE
tff(fact_1502_quotientI,axiom,
    ! [B: $tType,X2: B,A3: set(B),R2: set(product_prod(B,B))] :
      ( aa(set(B),$o,member(B,X2),A3)
     => aa(set(set(B)),$o,member(set(B),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),equiv_quotient(B,A3,R2)) ) ).

% quotientI
tff(fact_1503_quotient__diff1,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B),A4: B] :
      ( inj_on(B,set(set(B)),aTP_Lamp_js(set(product_prod(B,B)),fun(B,set(set(B))),R2),A3)
     => ( aa(set(B),$o,member(B,A4),A3)
       => ( equiv_quotient(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))),R2) = aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),minus_minus(set(set(B))),equiv_quotient(B,A3,R2)),equiv_quotient(B,aa(set(B),set(B),insert(B,A4),bot_bot(set(B))),R2)) ) ) ) ).

% quotient_diff1
tff(fact_1504_Rep__unit__induct,axiom,
    ! [Y: $o,Pa: fun($o,$o)] :
      ( aa(set($o),$o,member($o,Y),aa(set($o),set($o),insert($o,$true),bot_bot(set($o))))
     => ( ! [X: product_unit] : aa($o,$o,Pa,aa(product_unit,$o,product_Rep_unit,X))
       => aa($o,$o,Pa,Y) ) ) ).

% Rep_unit_induct
tff(fact_1505_Abs__unit__inject,axiom,
    ! [X2: $o,Y: $o] :
      ( aa(set($o),$o,member($o,X2),aa(set($o),set($o),insert($o,$true),bot_bot(set($o))))
     => ( aa(set($o),$o,member($o,Y),aa(set($o),set($o),insert($o,$true),bot_bot(set($o))))
       => ( ( aa($o,product_unit,product_Abs_unit,X2) = aa($o,product_unit,product_Abs_unit,Y) )
        <=> ( (X2)
          <=> (Y) ) ) ) ) ).

% Abs_unit_inject
tff(fact_1506_Partial__order__eq__Image1__Image1__iff,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B,B3: B] :
      ( order_7125193373082350890der_on(B,field2(B,R2),R2)
     => ( aa(set(B),$o,member(B,A4),field2(B,R2))
       => ( aa(set(B),$o,member(B,B3),field2(B,R2))
         => ( ( aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) = aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))) )
          <=> ( A4 = B3 ) ) ) ) ) ).

% Partial_order_eq_Image1_Image1_iff
tff(fact_1507_UN__Pow__subset,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,set(B)),A3: set(C)] : aa(set(set(B)),$o,aa(set(set(B)),fun(set(set(B)),$o),ord_less_eq(set(set(B))),aa(set(set(set(B))),set(set(B)),complete_Sup_Sup(set(set(B))),aa(set(C),set(set(set(B))),image2(C,set(set(B)),aTP_Lamp_jt(fun(C,set(B)),fun(C,set(set(B))),B2)),A3))),pow(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)))) ).

% UN_Pow_subset
tff(fact_1508_wo__rel_Ocases__Total3,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B,B3: B,Phi: fun(B,fun(B,$o))] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))),field2(B,R2))
       => ( ( ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R2),id2(B)))
              | aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B3),A4)),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R2),id2(B))) )
           => aa(B,$o,aa(B,fun(B,$o),Phi,A4),B3) )
         => ( ( ( A4 = B3 )
             => aa(B,$o,aa(B,fun(B,$o),Phi,A4),B3) )
           => aa(B,$o,aa(B,fun(B,$o),Phi,A4),B3) ) ) ) ) ).

% wo_rel.cases_Total3
tff(fact_1509_chains__def,axiom,
    ! [B: $tType,A3: set(set(B))] : ( chains2(B,A3) = aa(fun(set(set(B)),$o),set(set(set(B))),collect(set(set(B))),aTP_Lamp_ju(set(set(B)),fun(set(set(B)),$o),A3)) ) ).

% chains_def
tff(fact_1510_proj__def,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(C,B)),X2: C] : ( equiv_proj(C,B,R2,X2) = aa(set(C),set(B),image(C,B,R2),aa(set(C),set(C),insert(C,X2),bot_bot(set(C)))) ) ).

% proj_def
tff(fact_1511_cSUP__UNION,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( condit1219197933456340205attice(D)
     => ! [A3: set(B),B2: fun(B,set(C)),F2: fun(C,D)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => ( aa(B,set(C),B2,X) != bot_bot(set(C)) ) )
           => ( condit941137186595557371_above(D,aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),aa(fun(C,D),fun(B,set(D)),aTP_Lamp_jv(fun(B,set(C)),fun(fun(C,D),fun(B,set(D))),B2),F2)),A3)))
             => ( aa(set(D),D,complete_Sup_Sup(D),aa(set(C),set(D),image2(C,D,F2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A3)))) = aa(set(D),D,complete_Sup_Sup(D),aa(set(B),set(D),image2(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_jw(fun(B,set(C)),fun(fun(C,D),fun(B,D)),B2),F2)),A3)) ) ) ) ) ) ).

% cSUP_UNION
tff(fact_1512_cINF__UNION,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( condit1219197933456340205attice(D)
     => ! [A3: set(B),B2: fun(B,set(C)),F2: fun(C,D)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => ( aa(B,set(C),B2,X) != bot_bot(set(C)) ) )
           => ( aa(set(D),$o,condit1013018076250108175_below(D),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),aa(fun(C,D),fun(B,set(D)),aTP_Lamp_jv(fun(B,set(C)),fun(fun(C,D),fun(B,set(D))),B2),F2)),A3)))
             => ( aa(set(D),D,complete_Inf_Inf(D),aa(set(C),set(D),image2(C,D,F2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A3)))) = aa(set(D),D,complete_Inf_Inf(D),aa(set(B),set(D),image2(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_jx(fun(B,set(C)),fun(fun(C,D),fun(B,D)),B2),F2)),A3)) ) ) ) ) ) ).

% cINF_UNION
tff(fact_1513_Func__map__surj,axiom,
    ! [D: $tType,B: $tType,E: $tType,C: $tType,F1: fun(C,B),A1: set(C),B1: set(B),F22: fun(D,E),B22: set(D),A22: set(E)] :
      ( ( aa(set(C),set(B),image2(C,B,F1),A1) = B1 )
     => ( inj_on(D,E,F22,B22)
       => ( aa(set(E),$o,aa(set(E),fun(set(E),$o),ord_less_eq(set(E)),aa(set(D),set(E),image2(D,E,F22),B22)),A22)
         => ( ( ( B22 = bot_bot(set(D)) )
             => ( A22 = bot_bot(set(E)) ) )
           => ( bNF_Wellorder_Func(D,B,B22,B1) = aa(set(fun(E,C)),set(fun(D,B)),image2(fun(E,C),fun(D,B),bNF_We4925052301507509544nc_map(D,C,B,E,B22,F1,F22)),bNF_Wellorder_Func(E,C,A22,A1)) ) ) ) ) ) ).

% Func_map_surj
tff(fact_1514_bdd__below__empty,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => aa(set(B),$o,condit1013018076250108175_below(B),bot_bot(set(B))) ) ).

% bdd_below_empty
tff(fact_1515_bdd__above__empty,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => condit941137186595557371_above(B,bot_bot(set(B))) ) ).

% bdd_above_empty
tff(fact_1516_bdd__below__image__inf,axiom,
    ! [B: $tType,C: $tType] :
      ( lattice(B)
     => ! [F2: fun(C,B),G: fun(C,B),A3: set(C)] :
          ( aa(set(B),$o,condit1013018076250108175_below(B),aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_jy(fun(C,B),fun(fun(C,B),fun(C,B)),F2),G)),A3))
        <=> ( aa(set(B),$o,condit1013018076250108175_below(B),aa(set(C),set(B),image2(C,B,F2),A3))
            & aa(set(B),$o,condit1013018076250108175_below(B),aa(set(C),set(B),image2(C,B,G),A3)) ) ) ) ).

% bdd_below_image_inf
tff(fact_1517_bdd__above__image__sup,axiom,
    ! [B: $tType,C: $tType] :
      ( lattice(B)
     => ! [F2: fun(C,B),G: fun(C,B),A3: set(C)] :
          ( condit941137186595557371_above(B,aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_jz(fun(C,B),fun(fun(C,B),fun(C,B)),F2),G)),A3))
        <=> ( condit941137186595557371_above(B,aa(set(C),set(B),image2(C,B,F2),A3))
            & condit941137186595557371_above(B,aa(set(C),set(B),image2(C,B,G),A3)) ) ) ) ).

% bdd_above_image_sup
tff(fact_1518_Pow__Int__eq,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( pow(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),inf_inf(set(set(B))),pow(B,A3)),pow(B,B2)) ) ).

% Pow_Int_eq
tff(fact_1519_Pow__singleton__iff,axiom,
    ! [B: $tType,X5: set(B),Y3: set(B)] :
      ( ( pow(B,X5) = aa(set(set(B)),set(set(B)),insert(set(B),Y3),bot_bot(set(set(B)))) )
    <=> ( ( X5 = bot_bot(set(B)) )
        & ( Y3 = bot_bot(set(B)) ) ) ) ).

% Pow_singleton_iff
tff(fact_1520_Pow__empty,axiom,
    ! [B: $tType] : ( pow(B,bot_bot(set(B))) = aa(set(set(B)),set(set(B)),insert(set(B),bot_bot(set(B))),bot_bot(set(set(B)))) ) ).

% Pow_empty
tff(fact_1521_bdd__below__Int1,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,condit1013018076250108175_below(B),A3)
         => aa(set(B),$o,condit1013018076250108175_below(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ) ).

% bdd_below_Int1
tff(fact_1522_bdd__below__Int2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [B2: set(B),A3: set(B)] :
          ( aa(set(B),$o,condit1013018076250108175_below(B),B2)
         => aa(set(B),$o,condit1013018076250108175_below(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ) ).

% bdd_below_Int2
tff(fact_1523_bdd__above__Int1,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: set(B),B2: set(B)] :
          ( condit941137186595557371_above(B,A3)
         => condit941137186595557371_above(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ) ).

% bdd_above_Int1
tff(fact_1524_bdd__above__Int2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [B2: set(B),A3: set(B)] :
          ( condit941137186595557371_above(B,B2)
         => condit941137186595557371_above(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ) ).

% bdd_above_Int2
tff(fact_1525_Pow__bottom,axiom,
    ! [B: $tType,B2: set(B)] : aa(set(set(B)),$o,member(set(B),bot_bot(set(B))),pow(B,B2)) ).

% Pow_bottom
tff(fact_1526_Pow__not__empty,axiom,
    ! [B: $tType,A3: set(B)] : ( pow(B,A3) != bot_bot(set(set(B))) ) ).

% Pow_not_empty
tff(fact_1527_Pow__def,axiom,
    ! [B: $tType,A3: set(B)] : ( pow(B,A3) = aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_ka(set(B),fun(set(B),$o),A3)) ) ).

% Pow_def
tff(fact_1528_cSUP__eq__cINF__D,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F2: fun(C,B),A3: set(C),A4: C] :
          ( ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),A3)) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3)) )
         => ( condit941137186595557371_above(B,aa(set(C),set(B),image2(C,B,F2),A3))
           => ( aa(set(B),$o,condit1013018076250108175_below(B),aa(set(C),set(B),image2(C,B,F2),A3))
             => ( aa(set(C),$o,member(C,A4),A3)
               => ( aa(C,B,F2,A4) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3)) ) ) ) ) ) ) ).

% cSUP_eq_cINF_D
tff(fact_1529_Func__is__emp,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( ( bNF_Wellorder_Func(B,C,A3,B2) = bot_bot(set(fun(B,C))) )
    <=> ( ( A3 != bot_bot(set(B)) )
        & ( B2 = bot_bot(set(C)) ) ) ) ).

% Func_is_emp
tff(fact_1530_Func__non__emp,axiom,
    ! [B: $tType,C: $tType,B2: set(B),A3: set(C)] :
      ( ( B2 != bot_bot(set(B)) )
     => ( bNF_Wellorder_Func(C,B,A3,B2) != bot_bot(set(fun(C,B))) ) ) ).

% Func_non_emp
tff(fact_1531_Pow__Compl,axiom,
    ! [B: $tType,A3: set(B)] : ( pow(B,aa(set(B),set(B),uminus_uminus(set(B)),A3)) = aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_kb(set(B),fun(set(B),$o),A3)) ) ).

% Pow_Compl
tff(fact_1532_cInf__le__cSup,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(B)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,A3)
           => ( aa(set(B),$o,condit1013018076250108175_below(B),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),A3)),aa(set(B),B,complete_Sup_Sup(B),A3)) ) ) ) ) ).

% cInf_le_cSup
tff(fact_1533_le__cInf__iff,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [S: set(B),A4: B] :
          ( ( S != bot_bot(set(B)) )
         => ( aa(set(B),$o,condit1013018076250108175_below(B),S)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(set(B),B,complete_Inf_Inf(B),S))
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),S)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),X3) ) ) ) ) ) ).

% le_cInf_iff
tff(fact_1534_cInf__mono,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [B2: set(B),A3: set(B)] :
          ( ( B2 != bot_bot(set(B)) )
         => ( aa(set(B),$o,condit1013018076250108175_below(B),A3)
           => ( ! [B4: B] :
                  ( aa(set(B),$o,member(B,B4),B2)
                 => ? [X4: B] :
                      ( aa(set(B),$o,member(B,X4),A3)
                      & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),B4) ) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),A3)),aa(set(B),B,complete_Inf_Inf(B),B2)) ) ) ) ) ).

% cInf_mono
tff(fact_1535_cSup__le__iff,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [S: set(B),A4: B] :
          ( ( S != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,S)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),S)),A4)
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),S)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),A4) ) ) ) ) ) ).

% cSup_le_iff
tff(fact_1536_cSup__mono,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [B2: set(B),A3: set(B)] :
          ( ( B2 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,A3)
           => ( ! [B4: B] :
                  ( aa(set(B),$o,member(B,B4),B2)
                 => ? [X4: B] :
                      ( aa(set(B),$o,member(B,X4),A3)
                      & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B4),X4) ) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),B2)),aa(set(B),B,complete_Sup_Sup(B),A3)) ) ) ) ) ).

% cSup_mono
tff(fact_1537_partial__order__on__empty,axiom,
    ! [B: $tType] : order_7125193373082350890der_on(B,bot_bot(set(B)),bot_bot(set(product_prod(B,B)))) ).

% partial_order_on_empty
tff(fact_1538_wo__rel_Omax2__among,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B,B3: B] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( aa(set(B),$o,member(B,A4),field2(B,R2))
       => ( aa(set(B),$o,member(B,B3),field2(B,R2))
         => aa(set(B),$o,member(B,bNF_We1388413361240627857o_max2(B,R2,A4,B3)),aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))) ) ) ) ).

% wo_rel.max2_among
tff(fact_1539_wo__rel_Ocases__Total,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B,B3: B,Phi: fun(B,fun(B,$o))] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))),field2(B,R2))
       => ( ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),R2)
           => aa(B,$o,aa(B,fun(B,$o),Phi,A4),B3) )
         => ( ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B3),A4)),R2)
             => aa(B,$o,aa(B,fun(B,$o),Phi,A4),B3) )
           => aa(B,$o,aa(B,fun(B,$o),Phi,A4),B3) ) ) ) ) ).

% wo_rel.cases_Total
tff(fact_1540_le__cINF__iff,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),F2: fun(B,C),U: C] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(C),$o,condit1013018076250108175_below(C),aa(set(B),set(C),image2(B,C,F2),A3))
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),U),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3)))
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),U),aa(B,C,F2,X3)) ) ) ) ) ) ).

% le_cINF_iff
tff(fact_1541_cINF__mono,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [B2: set(B),F2: fun(D,C),A3: set(D),G: fun(B,C)] :
          ( ( B2 != bot_bot(set(B)) )
         => ( aa(set(C),$o,condit1013018076250108175_below(C),aa(set(D),set(C),image2(D,C,F2),A3))
           => ( ! [M3: B] :
                  ( aa(set(B),$o,member(B,M3),B2)
                 => ? [X4: D] :
                      ( aa(set(D),$o,member(D,X4),A3)
                      & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(D,C,F2,X4)),aa(B,C,G,M3)) ) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(D),set(C),image2(D,C,F2),A3))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,G),B2))) ) ) ) ) ).

% cINF_mono
tff(fact_1542_cInf__superset__mono,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(B),B2: set(B)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(B),$o,condit1013018076250108175_below(B),B2)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),B2)),aa(set(B),B,complete_Inf_Inf(B),A3)) ) ) ) ) ).

% cInf_superset_mono
tff(fact_1543_cSUP__le__iff,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),F2: fun(B,C),U: C] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,F2),A3))
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))),U)
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X3)),U) ) ) ) ) ) ).

% cSUP_le_iff
tff(fact_1544_cSUP__mono,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),G: fun(D,C),B2: set(D),F2: fun(B,C)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(D),set(C),image2(D,C,G),B2))
           => ( ! [N2: B] :
                  ( aa(set(B),$o,member(B,N2),A3)
                 => ? [X4: D] :
                      ( aa(set(D),$o,member(D,X4),B2)
                      & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,N2)),aa(D,C,G,X4)) ) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(set(C),C,complete_Sup_Sup(C),aa(set(D),set(C),image2(D,C,G),B2))) ) ) ) ) ).

% cSUP_mono
tff(fact_1545_wo__rel_Omax2__greater__among,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B,B3: B] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( aa(set(B),$o,member(B,A4),field2(B,R2))
       => ( aa(set(B),$o,member(B,B3),field2(B,R2))
         => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),bNF_We1388413361240627857o_max2(B,R2,A4,B3))),R2)
            & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B3),bNF_We1388413361240627857o_max2(B,R2,A4,B3))),R2)
            & aa(set(B),$o,member(B,bNF_We1388413361240627857o_max2(B,R2,A4,B3)),aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))) ) ) ) ) ).

% wo_rel.max2_greater_among
tff(fact_1546_cSup__subset__mono,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(B),B2: set(B)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,B2)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),A3)),aa(set(B),B,complete_Sup_Sup(B),B2)) ) ) ) ) ).

% cSup_subset_mono
tff(fact_1547_cInf__insert,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X5: set(B),A4: B] :
          ( ( X5 != bot_bot(set(B)) )
         => ( aa(set(B),$o,condit1013018076250108175_below(B),X5)
           => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert(B,A4),X5)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),aa(set(B),B,complete_Inf_Inf(B),X5)) ) ) ) ) ).

% cInf_insert
tff(fact_1548_cInf__insert__If,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X5: set(B),A4: B] :
          ( aa(set(B),$o,condit1013018076250108175_below(B),X5)
         => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert(B,A4),X5))
            = $ite(X5 = bot_bot(set(B)),A4,aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),aa(set(B),B,complete_Inf_Inf(B),X5))) ) ) ) ).

% cInf_insert_If
tff(fact_1549_cSup__insert__If,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X5: set(B),A4: B] :
          ( condit941137186595557371_above(B,X5)
         => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert(B,A4),X5))
            = $ite(X5 = bot_bot(set(B)),A4,aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),aa(set(B),B,complete_Sup_Sup(B),X5))) ) ) ) ).

% cSup_insert_If
tff(fact_1550_cSup__insert,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X5: set(B),A4: B] :
          ( ( X5 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,X5)
           => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert(B,A4),X5)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),aa(set(B),B,complete_Sup_Sup(B),X5)) ) ) ) ) ).

% cSup_insert
tff(fact_1551_cInf__union__distrib,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(B),B2: set(B)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(B),$o,condit1013018076250108175_below(B),A3)
           => ( ( B2 != bot_bot(set(B)) )
             => ( aa(set(B),$o,condit1013018076250108175_below(B),B2)
               => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),A3)),aa(set(B),B,complete_Inf_Inf(B),B2)) ) ) ) ) ) ) ).

% cInf_union_distrib
tff(fact_1552_cSup__union__distrib,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(B),B2: set(B)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,A3)
           => ( ( B2 != bot_bot(set(B)) )
             => ( condit941137186595557371_above(B,B2)
               => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Sup_Sup(B),A3)),aa(set(B),B,complete_Sup_Sup(B),B2)) ) ) ) ) ) ) ).

% cSup_union_distrib
tff(fact_1553_Pow__INT__eq,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,set(B)),A3: set(C)] : ( pow(B,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3))) = aa(set(set(set(B))),set(set(B)),complete_Inf_Inf(set(set(B))),aa(set(C),set(set(set(B))),image2(C,set(set(B)),aTP_Lamp_jt(fun(C,set(B)),fun(C,set(set(B))),B2)),A3)) ) ).

% Pow_INT_eq
tff(fact_1554_cINF__inf__distrib,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),F2: fun(B,C),G: fun(B,C)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(C),$o,condit1013018076250108175_below(C),aa(set(B),set(C),image2(B,C,F2),A3))
           => ( aa(set(C),$o,condit1013018076250108175_below(C),aa(set(B),set(C),image2(B,C,G),A3))
             => ( aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,G),A3))) = aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_kc(fun(B,C),fun(fun(B,C),fun(B,C)),F2),G)),A3)) ) ) ) ) ) ).

% cINF_inf_distrib
tff(fact_1555_conditionally__complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),F2: fun(B,C),G: fun(B,C)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,F2),A3))
           => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,G),A3))
             => ( aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,G),A3))) = aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_kd(fun(B,C),fun(fun(B,C),fun(B,C)),F2),G)),A3)) ) ) ) ) ) ).

% conditionally_complete_lattice_class.SUP_sup_distrib
tff(fact_1556_cINF__superset__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),G: fun(B,C),B2: set(B),F2: fun(B,C)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(C),$o,condit1013018076250108175_below(C),aa(set(B),set(C),image2(B,C,G),B2))
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
             => ( ! [X: B] :
                    ( aa(set(B),$o,member(B,X),B2)
                   => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,G,X)),aa(B,C,F2,X)) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,G),B2))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))) ) ) ) ) ) ).

% cINF_superset_mono
tff(fact_1557_cSUP__subset__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),G: fun(B,C),B2: set(B),F2: fun(B,C)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,G),B2))
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
             => ( ! [X: B] :
                    ( aa(set(B),$o,member(B,X),A3)
                   => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),aa(B,C,G,X)) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,G),B2))) ) ) ) ) ) ).

% cSUP_subset_mono
tff(fact_1558_less__eq__cInf__inter,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,condit1013018076250108175_below(B),A3)
         => ( aa(set(B),$o,condit1013018076250108175_below(B),B2)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) != bot_bot(set(B)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),A3)),aa(set(B),B,complete_Inf_Inf(B),B2))),aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ) ).

% less_eq_cInf_inter
tff(fact_1559_cINF__insert,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),F2: fun(B,C),A4: B] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(C),$o,condit1013018076250108175_below(C),aa(set(B),set(C),image2(B,C,F2),A3))
           => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),aa(set(B),set(B),insert(B,A4),A3))) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,F2,A4)),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))) ) ) ) ) ).

% cINF_insert
tff(fact_1560_cSup__inter__less__eq,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(B),B2: set(B)] :
          ( condit941137186595557371_above(B,A3)
         => ( condit941137186595557371_above(B,B2)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) != bot_bot(set(B)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Sup_Sup(B),A3)),aa(set(B),B,complete_Sup_Sup(B),B2))) ) ) ) ) ).

% cSup_inter_less_eq
tff(fact_1561_cSUP__insert,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),F2: fun(B,C),A4: B] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,F2),A3))
           => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),aa(set(B),set(B),insert(B,A4),A3))) = aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(B,C,F2,A4)),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))) ) ) ) ) ).

% cSUP_insert
tff(fact_1562_cINF__union,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),F2: fun(B,C),B2: set(B)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(C),$o,condit1013018076250108175_below(C),aa(set(B),set(C),image2(B,C,F2),A3))
           => ( ( B2 != bot_bot(set(B)) )
             => ( aa(set(C),$o,condit1013018076250108175_below(C),aa(set(B),set(C),image2(B,C,F2),B2))
               => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),B2))) ) ) ) ) ) ) ).

% cINF_union
tff(fact_1563_Partial__order__Restr,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( order_7125193373082350890der_on(B,field2(B,R2),R2)
     => order_7125193373082350890der_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) ) ).

% Partial_order_Restr
tff(fact_1564_cSUP__union,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(B),F2: fun(B,C),B2: set(B)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,F2),A3))
           => ( ( B2 != bot_bot(set(B)) )
             => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,F2),B2))
               => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),B2))) ) ) ) ) ) ) ).

% cSUP_union
tff(fact_1565_If__the__inv__into__in__Func,axiom,
    ! [C: $tType,B: $tType,G: fun(B,C),C2: set(B),B2: set(B),X2: B] :
      ( inj_on(B,C,G,C2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))
       => aa(set(fun(C,B)),$o,member(fun(C,B),aa(B,fun(C,B),aa(set(B),fun(B,fun(C,B)),aTP_Lamp_ke(fun(B,C),fun(set(B),fun(B,fun(C,B))),G),C2),X2)),bNF_Wellorder_Func(C,B,top_top(set(C)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ).

% If_the_inv_into_in_Func
tff(fact_1566_wo__rel_OWell__order__isMinim__exists,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R2))
       => ( ( B2 != bot_bot(set(B)) )
         => ? [X_1: B] : aa(B,$o,bNF_We4791949203932849705sMinim(B,R2,B2),X_1) ) ) ) ).

% wo_rel.Well_order_isMinim_exists
tff(fact_1567_wo__rel_Ominim__in,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R2))
       => ( ( B2 != bot_bot(set(B)) )
         => aa(set(B),$o,member(B,bNF_We6954850376910717587_minim(B,R2,B2)),B2) ) ) ) ).

% wo_rel.minim_in
tff(fact_1568_wo__rel_Ominim__inField,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R2))
       => ( ( B2 != bot_bot(set(B)) )
         => aa(set(B),$o,member(B,bNF_We6954850376910717587_minim(B,R2,B2)),field2(B,R2)) ) ) ) ).

% wo_rel.minim_inField
tff(fact_1569_curr__surj,axiom,
    ! [D: $tType,C: $tType,B: $tType,G: fun(B,fun(C,D)),A3: set(B),B2: set(C),C2: set(D)] :
      ( aa(set(fun(B,fun(C,D))),$o,member(fun(B,fun(C,D)),G),bNF_Wellorder_Func(B,fun(C,D),A3,bNF_Wellorder_Func(C,D,B2,C2)))
     => ? [X: fun(product_prod(B,C),D)] :
          ( aa(set(fun(product_prod(B,C),D)),$o,member(fun(product_prod(B,C),D),X),bNF_Wellorder_Func(product_prod(B,C),D,product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)),C2))
          & ( aa(fun(product_prod(B,C),D),fun(B,fun(C,D)),bNF_Wellorder_curr(B,C,D,A3),X) = G ) ) ) ).

% curr_surj
tff(fact_1570_curr__in,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(product_prod(B,C),D),A3: set(B),B2: set(C),C2: set(D)] :
      ( aa(set(fun(product_prod(B,C),D)),$o,member(fun(product_prod(B,C),D),F2),bNF_Wellorder_Func(product_prod(B,C),D,product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)),C2))
     => aa(set(fun(B,fun(C,D))),$o,member(fun(B,fun(C,D)),aa(fun(product_prod(B,C),D),fun(B,fun(C,D)),bNF_Wellorder_curr(B,C,D,A3),F2)),bNF_Wellorder_Func(B,fun(C,D),A3,bNF_Wellorder_Func(C,D,B2,C2))) ) ).

% curr_in
tff(fact_1571_proj__iff,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X2: B,Y: B] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,X2),aa(set(B),set(B),insert(B,Y),bot_bot(set(B))))),A3)
       => ( ( equiv_proj(B,B,R2,X2) = equiv_proj(B,B,R2,Y) )
        <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y)),R2) ) ) ) ).

% proj_iff
tff(fact_1572_subset__singleton__iff__Uniq,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ? [A6: B] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),insert(B,A6),bot_bot(set(B))))
    <=> uniq(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3)) ) ).

% subset_singleton_iff_Uniq
tff(fact_1573_alt__ex1E_H,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ? [X4: B] :
          ( aa(B,$o,Pa,X4)
          & ! [Y2: B] :
              ( aa(B,$o,Pa,Y2)
             => ( Y2 = X4 ) ) )
     => ~ ( ? [X_1: B] : aa(B,$o,Pa,X_1)
         => ~ uniq(B,Pa) ) ) ).

% alt_ex1E'
tff(fact_1574_ex1__iff__ex__Uniq,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ? [X3: B] :
          ( aa(B,$o,Pa,X3)
          & ! [Y4: B] :
              ( aa(B,$o,Pa,Y4)
             => ( Y4 = X3 ) ) )
    <=> ( ? [X_12: B] : aa(B,$o,Pa,X_12)
        & uniq(B,Pa) ) ) ).

% ex1_iff_ex_Uniq
tff(fact_1575_in__quotient__imp__non__empty,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X5: set(B)] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(set(B)),$o,member(set(B),X5),equiv_quotient(B,A3,R2))
       => ( X5 != bot_bot(set(B)) ) ) ) ).

% in_quotient_imp_non_empty
tff(fact_1576_the__inv__into__def,axiom,
    ! [C: $tType,B: $tType,A3: set(C),F2: fun(C,B),X4: B] : ( the_inv_into(C,B,A3,F2,X4) = the(C,aa(B,fun(C,$o),aa(fun(C,B),fun(B,fun(C,$o)),aTP_Lamp_kf(set(C),fun(fun(C,B),fun(B,fun(C,$o))),A3),F2),X4)) ) ).

% the_inv_into_def
tff(fact_1577_inj__on__iff__Uniq,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),A3: set(B)] :
      ( inj_on(B,C,F2,A3)
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),A3)
         => uniq(B,aa(B,fun(B,$o),aa(set(B),fun(B,fun(B,$o)),aTP_Lamp_kg(fun(B,C),fun(set(B),fun(B,fun(B,$o))),F2),A3),X3)) ) ) ).

% inj_on_iff_Uniq
tff(fact_1578_wo__rel_Ominim__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( bNF_We6954850376910717587_minim(B,R2,A3) = the(B,bNF_We4791949203932849705sMinim(B,R2,A3)) ) ) ).

% wo_rel.minim_def
tff(fact_1579_the1__equality_H,axiom,
    ! [B: $tType,Pa: fun(B,$o),A4: B] :
      ( uniq(B,Pa)
     => ( aa(B,$o,Pa,A4)
       => ( the(B,Pa) = A4 ) ) ) ).

% the1_equality'
tff(fact_1580_equiv__type,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B))] :
      ( equiv_equiv(B,A3,R2)
     => aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))) ) ).

% equiv_type
tff(fact_1581_equiv__class__self,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),A4: B] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(B),$o,member(B,A4),A3)
       => aa(set(B),$o,member(B,A4),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) ) ) ).

% equiv_class_self
tff(fact_1582_quotient__disj,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X5: set(B),Y3: set(B)] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(set(B)),$o,member(set(B),X5),equiv_quotient(B,A3,R2))
       => ( aa(set(set(B)),$o,member(set(B),Y3),equiv_quotient(B,A3,R2))
         => ( ( X5 = Y3 )
            | ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X5),Y3) = bot_bot(set(B)) ) ) ) ) ) ).

% quotient_disj
tff(fact_1583_curr__inj,axiom,
    ! [D: $tType,C: $tType,B: $tType,F1: fun(product_prod(B,C),D),A3: set(B),B2: set(C),C2: set(D),F22: fun(product_prod(B,C),D)] :
      ( aa(set(fun(product_prod(B,C),D)),$o,member(fun(product_prod(B,C),D),F1),bNF_Wellorder_Func(product_prod(B,C),D,product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)),C2))
     => ( aa(set(fun(product_prod(B,C),D)),$o,member(fun(product_prod(B,C),D),F22),bNF_Wellorder_Func(product_prod(B,C),D,product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)),C2))
       => ( ( aa(fun(product_prod(B,C),D),fun(B,fun(C,D)),bNF_Wellorder_curr(B,C,D,A3),F1) = aa(fun(product_prod(B,C),D),fun(B,fun(C,D)),bNF_Wellorder_curr(B,C,D,A3),F22) )
        <=> ( F1 = F22 ) ) ) ) ).

% curr_inj
tff(fact_1584_wo__rel_Ominim__isMinim,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R2))
       => ( ( B2 != bot_bot(set(B)) )
         => aa(B,$o,bNF_We4791949203932849705sMinim(B,R2,B2),bNF_We6954850376910717587_minim(B,R2,B2)) ) ) ) ).

% wo_rel.minim_isMinim
tff(fact_1585_eq__equiv__class,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B,B3: B,A3: set(B)] :
      ( ( aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) = aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))) )
     => ( equiv_equiv(B,A3,R2)
       => ( aa(set(B),$o,member(B,B3),A3)
         => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),R2) ) ) ) ).

% eq_equiv_class
tff(fact_1586_equiv__class__eq,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),A4: B,B3: B] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),R2)
       => ( aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) = aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))) ) ) ) ).

% equiv_class_eq
tff(fact_1587_eq__equiv__class__iff,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X2: B,Y: B] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(B),$o,member(B,X2),A3)
       => ( aa(set(B),$o,member(B,Y),A3)
         => ( ( aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,Y),bot_bot(set(B)))) )
          <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y)),R2) ) ) ) ) ).

% eq_equiv_class_iff
tff(fact_1588_equiv__class__eq__iff,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X2: B,Y: B] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y)),R2)
      <=> ( ( aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,Y),bot_bot(set(B)))) )
          & aa(set(B),$o,member(B,X2),A3)
          & aa(set(B),$o,member(B,Y),A3) ) ) ) ).

% equiv_class_eq_iff
tff(fact_1589_eq__equiv__class__iff2,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X2: B,Y: B] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(B),$o,member(B,X2),A3)
       => ( aa(set(B),$o,member(B,Y),A3)
         => ( ( equiv_quotient(B,aa(set(B),set(B),insert(B,X2),bot_bot(set(B))),R2) = equiv_quotient(B,aa(set(B),set(B),insert(B,Y),bot_bot(set(B))),R2) )
          <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y)),R2) ) ) ) ) ).

% eq_equiv_class_iff2
tff(fact_1590_refines__equiv__class__eq,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),S: set(product_prod(B,B)),A3: set(B),A4: B] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R),S)
     => ( equiv_equiv(B,A3,R)
       => ( equiv_equiv(B,A3,S)
         => ( aa(set(B),set(B),image(B,B,R),aa(set(B),set(B),image(B,B,S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) = aa(set(B),set(B),image(B,B,S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) ) ) ) ) ).

% refines_equiv_class_eq
tff(fact_1591_refines__equiv__class__eq2,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),S: set(product_prod(B,B)),A3: set(B),A4: B] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R),S)
     => ( equiv_equiv(B,A3,R)
       => ( equiv_equiv(B,A3,S)
         => ( aa(set(B),set(B),image(B,B,S),aa(set(B),set(B),image(B,B,R),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) = aa(set(B),set(B),image(B,B,S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) ) ) ) ) ).

% refines_equiv_class_eq2
tff(fact_1592_refines__equiv__image__eq,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),S: set(product_prod(B,B)),A3: set(B)] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R),S)
     => ( equiv_equiv(B,A3,R)
       => ( equiv_equiv(B,A3,S)
         => ( aa(set(set(B)),set(set(B)),image2(set(B),set(B),image(B,B,S)),equiv_quotient(B,A3,R)) = equiv_quotient(B,A3,S) ) ) ) ) ).

% refines_equiv_image_eq
tff(fact_1593_equiv__class__subset,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),A4: B,B3: B] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),R2)
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))) ) ) ).

% equiv_class_subset
tff(fact_1594_subset__equiv__class,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),B3: B,A4: B] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))
       => ( aa(set(B),$o,member(B,B3),A3)
         => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),R2) ) ) ) ).

% subset_equiv_class
tff(fact_1595_equiv__class__nondisjoint,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X2: B,A4: B,B3: B] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(B),$o,member(B,X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))))
       => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),R2) ) ) ).

% equiv_class_nondisjoint
tff(fact_1596_in__quotient__imp__in__rel,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X5: set(B),X2: B,Y: B] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(set(B)),$o,member(set(B),X5),equiv_quotient(B,A3,R2))
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,X2),aa(set(B),set(B),insert(B,Y),bot_bot(set(B))))),X5)
         => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y)),R2) ) ) ) ).

% in_quotient_imp_in_rel
tff(fact_1597_UN__equiv__class2,axiom,
    ! [B: $tType,D: $tType,C: $tType,A1: set(B),R12: set(product_prod(B,B)),A22: set(C),R23: set(product_prod(C,C)),F2: fun(B,fun(C,set(D))),A13: B,A23: C] :
      ( equiv_equiv(B,A1,R12)
     => ( equiv_equiv(C,A22,R23)
       => ( equiv_congruent2(B,C,set(D),R12,R23,F2)
         => ( aa(set(B),$o,member(B,A13),A1)
           => ( aa(set(C),$o,member(C,A23),A22)
             => ( aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),aa(C,fun(B,set(D)),aa(fun(B,fun(C,set(D))),fun(C,fun(B,set(D))),aTP_Lamp_kh(set(product_prod(C,C)),fun(fun(B,fun(C,set(D))),fun(C,fun(B,set(D)))),R23),F2),A23)),aa(set(B),set(B),image(B,B,R12),aa(set(B),set(B),insert(B,A13),bot_bot(set(B)))))) = aa(C,set(D),aa(B,fun(C,set(D)),F2,A13),A23) ) ) ) ) ) ) ).

% UN_equiv_class2
tff(fact_1598_UN__equiv__class,axiom,
    ! [C: $tType,B: $tType,A3: set(B),R2: set(product_prod(B,B)),F2: fun(B,set(C)),A4: B] :
      ( equiv_equiv(B,A3,R2)
     => ( equiv_congruent(B,set(C),R2,F2)
       => ( aa(set(B),$o,member(B,A4),A3)
         => ( aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),F2),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) = aa(B,set(C),F2,A4) ) ) ) ) ).

% UN_equiv_class
tff(fact_1599_UN__equiv__class__inject,axiom,
    ! [C: $tType,B: $tType,A3: set(B),R2: set(product_prod(B,B)),F2: fun(B,set(C)),X5: set(B),Y3: set(B)] :
      ( equiv_equiv(B,A3,R2)
     => ( equiv_congruent(B,set(C),R2,F2)
       => ( ( aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),F2),X5)) = aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),F2),Y3)) )
         => ( aa(set(set(B)),$o,member(set(B),X5),equiv_quotient(B,A3,R2))
           => ( aa(set(set(B)),$o,member(set(B),Y3),equiv_quotient(B,A3,R2))
             => ( ! [X: B,Y2: B] :
                    ( aa(set(B),$o,member(B,X),A3)
                   => ( aa(set(B),$o,member(B,Y2),A3)
                     => ( ( aa(B,set(C),F2,X) = aa(B,set(C),F2,Y2) )
                       => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y2)),R2) ) ) )
               => ( X5 = Y3 ) ) ) ) ) ) ) ).

% UN_equiv_class_inject
tff(fact_1600_UN__equiv__class__type2,axiom,
    ! [B: $tType,C: $tType,D: $tType,A1: set(B),R12: set(product_prod(B,B)),A22: set(C),R23: set(product_prod(C,C)),F2: fun(B,fun(C,set(D))),X1: set(B),X22: set(C),B2: set(set(D))] :
      ( equiv_equiv(B,A1,R12)
     => ( equiv_equiv(C,A22,R23)
       => ( equiv_congruent2(B,C,set(D),R12,R23,F2)
         => ( aa(set(set(B)),$o,member(set(B),X1),equiv_quotient(B,A1,R12))
           => ( aa(set(set(C)),$o,member(set(C),X22),equiv_quotient(C,A22,R23))
             => ( ! [X12: B,X23: C] :
                    ( aa(set(B),$o,member(B,X12),A1)
                   => ( aa(set(C),$o,member(C,X23),A22)
                     => aa(set(set(D)),$o,member(set(D),aa(C,set(D),aa(B,fun(C,set(D)),F2,X12),X23)),B2) ) )
               => aa(set(set(D)),$o,member(set(D),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),aa(set(C),fun(B,set(D)),aTP_Lamp_ki(fun(B,fun(C,set(D))),fun(set(C),fun(B,set(D))),F2),X22)),X1))),B2) ) ) ) ) ) ) ).

% UN_equiv_class_type2
tff(fact_1601_UN__equiv__class__type,axiom,
    ! [B: $tType,C: $tType,A3: set(B),R2: set(product_prod(B,B)),F2: fun(B,set(C)),X5: set(B),B2: set(set(C))] :
      ( equiv_equiv(B,A3,R2)
     => ( equiv_congruent(B,set(C),R2,F2)
       => ( aa(set(set(B)),$o,member(set(B),X5),equiv_quotient(B,A3,R2))
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => aa(set(set(C)),$o,member(set(C),aa(B,set(C),F2,X)),B2) )
           => aa(set(set(C)),$o,member(set(C),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),F2),X5))),B2) ) ) ) ) ).

% UN_equiv_class_type
tff(fact_1602_bij__betw__curr,axiom,
    ! [B: $tType,C: $tType,D: $tType,A3: set(B),B2: set(C),C2: set(D)] : bij_betw(fun(product_prod(B,C),D),fun(B,fun(C,D)),bNF_Wellorder_curr(B,C,D,A3),bNF_Wellorder_Func(product_prod(B,C),D,product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)),C2),bNF_Wellorder_Func(B,fun(C,D),A3,bNF_Wellorder_Func(C,D,B2,C2))) ).

% bij_betw_curr
tff(fact_1603_disjnt__equiv__class,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),A4: B,B3: B] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),disjnt(B),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))),aa(set(B),set(B),image(B,B,R2),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))))
      <=> ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),R2) ) ) ).

% disjnt_equiv_class
tff(fact_1604_congruent2__implies__congruent__UN,axiom,
    ! [B: $tType,D: $tType,C: $tType,A1: set(B),R12: set(product_prod(B,B)),A22: set(C),R23: set(product_prod(C,C)),F2: fun(B,fun(C,set(D))),A4: C] :
      ( equiv_equiv(B,A1,R12)
     => ( equiv_equiv(C,A22,R23)
       => ( equiv_congruent2(B,C,set(D),R12,R23,F2)
         => ( aa(set(C),$o,member(C,A4),A22)
           => equiv_congruent(B,set(D),R12,aa(C,fun(B,set(D)),aa(fun(B,fun(C,set(D))),fun(C,fun(B,set(D))),aTP_Lamp_kh(set(product_prod(C,C)),fun(fun(B,fun(C,set(D))),fun(C,fun(B,set(D)))),R23),F2),A4)) ) ) ) ) ).

% congruent2_implies_congruent_UN
tff(fact_1605_disjnt__self__iff__empty,axiom,
    ! [B: $tType,S: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),disjnt(B),S),S)
    <=> ( S = bot_bot(set(B)) ) ) ).

% disjnt_self_iff_empty
tff(fact_1606_disjnt__Times2__iff,axiom,
    ! [C: $tType,B: $tType,A3: set(B),C2: set(C),B2: set(B)] :
      ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),disjnt(product_prod(B,C)),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),C2))),product_Sigma(B,C,B2,aTP_Lamp_bq(set(C),fun(B,set(C)),C2)))
    <=> ( ( C2 = bot_bot(set(C)) )
        | aa(set(B),$o,aa(set(B),fun(set(B),$o),disjnt(B),A3),B2) ) ) ).

% disjnt_Times2_iff
tff(fact_1607_disjnt__Times1__iff,axiom,
    ! [B: $tType,C: $tType,C2: set(B),A3: set(C),B2: set(C)] :
      ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),disjnt(product_prod(B,C)),product_Sigma(B,C,C2,aTP_Lamp_bq(set(C),fun(B,set(C)),A3))),product_Sigma(B,C,C2,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))
    <=> ( ( C2 = bot_bot(set(B)) )
        | aa(set(C),$o,aa(set(C),fun(set(C),$o),disjnt(C),A3),B2) ) ) ).

% disjnt_Times1_iff
tff(fact_1608_bij__betw__empty1,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),A3: set(C)] :
      ( bij_betw(B,C,F2,bot_bot(set(B)),A3)
     => ( A3 = bot_bot(set(C)) ) ) ).

% bij_betw_empty1
tff(fact_1609_bij__betw__empty2,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),A3: set(B)] :
      ( bij_betw(B,C,F2,A3,bot_bot(set(C)))
     => ( A3 = bot_bot(set(B)) ) ) ).

% bij_betw_empty2
tff(fact_1610_disjnt__empty1,axiom,
    ! [B: $tType,A3: set(B)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),disjnt(B),bot_bot(set(B))),A3) ).

% disjnt_empty1
tff(fact_1611_disjnt__empty2,axiom,
    ! [B: $tType,A3: set(B)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),disjnt(B),A3),bot_bot(set(B))) ).

% disjnt_empty2
tff(fact_1612_disjnt__Sigma__iff,axiom,
    ! [C: $tType,B: $tType,A3: set(B),C2: fun(B,set(C)),B2: set(B)] :
      ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),disjnt(product_prod(B,C)),product_Sigma(B,C,A3,C2)),product_Sigma(B,C,B2,C2))
    <=> ( ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))
           => ( aa(B,set(C),C2,X3) = bot_bot(set(C)) ) )
        | aa(set(B),$o,aa(set(B),fun(set(B),$o),disjnt(B),A3),B2) ) ) ).

% disjnt_Sigma_iff
tff(fact_1613_disjnt__def,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),disjnt(B),A3),B2)
    <=> ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) ) ) ).

% disjnt_def
tff(fact_1614_notIn__Un__bij__betw,axiom,
    ! [B: $tType,C: $tType,B3: B,A3: set(B),F2: fun(B,C),A10: set(C)] :
      ( ~ aa(set(B),$o,member(B,B3),A3)
     => ( ~ aa(set(C),$o,member(C,aa(B,C,F2,B3)),A10)
       => ( bij_betw(B,C,F2,A3,A10)
         => bij_betw(B,C,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A10),aa(set(C),set(C),insert(C,aa(B,C,F2,B3)),bot_bot(set(C))))) ) ) ) ).

% notIn_Un_bij_betw
tff(fact_1615_notIn__Un__bij__betw3,axiom,
    ! [B: $tType,C: $tType,B3: B,A3: set(B),F2: fun(B,C),A10: set(C)] :
      ( ~ aa(set(B),$o,member(B,B3),A3)
     => ( ~ aa(set(C),$o,member(C,aa(B,C,F2,B3)),A10)
       => ( bij_betw(B,C,F2,A3,A10)
        <=> bij_betw(B,C,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A10),aa(set(C),set(C),insert(C,aa(B,C,F2,B3)),bot_bot(set(C))))) ) ) ) ).

% notIn_Un_bij_betw3
tff(fact_1616_bij__betw__combine,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),A3: set(B),B2: set(C),C2: set(B),D2: set(C)] :
      ( bij_betw(B,C,F2,A3,B2)
     => ( bij_betw(B,C,F2,C2,D2)
       => ( ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),B2),D2) = bot_bot(set(C)) )
         => bij_betw(B,C,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),C2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),B2),D2)) ) ) ) ).

% bij_betw_combine
tff(fact_1617_bij__betw__partition,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),A3: set(B),C2: set(B),B2: set(C),D2: set(C)] :
      ( bij_betw(B,C,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),C2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),B2),D2))
     => ( bij_betw(B,C,F2,C2,D2)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),C2) = bot_bot(set(B)) )
         => ( ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),B2),D2) = bot_bot(set(C)) )
           => bij_betw(B,C,F2,A3,B2) ) ) ) ) ).

% bij_betw_partition
tff(fact_1618_disjoint__UN__iff,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: fun(C,set(B)),I: set(C)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),disjnt(B),A3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),I)))
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),I)
         => aa(set(B),$o,aa(set(B),fun(set(B),$o),disjnt(B),A3),aa(C,set(B),B2,X3)) ) ) ).

% disjoint_UN_iff
tff(fact_1619_bij__betw__disjoint__Un,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),A3: set(B),C2: set(C),G: fun(B,C),B2: set(B),D2: set(C)] :
      ( bij_betw(B,C,F2,A3,C2)
     => ( bij_betw(B,C,G,B2,D2)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
         => ( ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),C2),D2) = bot_bot(set(C)) )
           => bij_betw(B,C,aa(fun(B,C),fun(B,C),aa(set(B),fun(fun(B,C),fun(B,C)),aTP_Lamp_ef(fun(B,C),fun(set(B),fun(fun(B,C),fun(B,C))),F2),A3),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),C2),D2)) ) ) ) ) ).

% bij_betw_disjoint_Un
tff(fact_1620_bij__betw__UNION__chain,axiom,
    ! [C: $tType,D: $tType,B: $tType,I: set(B),A3: fun(B,set(C)),F2: fun(C,D),A10: fun(B,set(D))] :
      ( ! [I3: B,J3: B] :
          ( aa(set(B),$o,member(B,I3),I)
         => ( aa(set(B),$o,member(B,J3),I)
           => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),A3,I3)),aa(B,set(C),A3,J3))
              | aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),A3,J3)),aa(B,set(C),A3,I3)) ) ) )
     => ( ! [I3: B] :
            ( aa(set(B),$o,member(B,I3),I)
           => bij_betw(C,D,F2,aa(B,set(C),A3,I3),aa(B,set(D),A10,I3)) )
       => bij_betw(C,D,F2,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I)),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),A10),I))) ) ) ).

% bij_betw_UNION_chain
tff(fact_1621_bij__image__INT,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(B,C),B2: fun(D,set(B)),A3: set(D)] :
      ( bij_betw(B,C,F2,top_top(set(B)),top_top(set(C)))
     => ( aa(set(B),set(C),image2(B,C,F2),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(D),set(set(B)),image2(D,set(B),B2),A3))) = aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),aa(fun(D,set(B)),fun(D,set(C)),aTP_Lamp_iu(fun(B,C),fun(fun(D,set(B)),fun(D,set(C))),F2),B2)),A3)) ) ) ).

% bij_image_INT
tff(fact_1622_comp__fun__commute__Pow__fold,axiom,
    ! [B: $tType] : finite6289374366891150609ommute(B,set(set(B)),aTP_Lamp_kj(B,fun(set(set(B)),set(set(B))))) ).

% comp_fun_commute_Pow_fold
tff(fact_1623_inf__img__fin__dom_H,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A3: set(C)] :
      ( aa(set(B),$o,finite_finite2(B),aa(set(C),set(B),image2(C,B,F2),A3))
     => ( ~ aa(set(C),$o,finite_finite2(C),A3)
       => ? [X: B] :
            ( aa(set(B),$o,member(B,X),aa(set(C),set(B),image2(C,B,F2),A3))
            & ~ aa(set(C),$o,finite_finite2(C),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),F2),aa(set(B),set(B),insert(B,X),bot_bot(set(B))))),A3)) ) ) ) ).

% inf_img_fin_dom'
tff(fact_1624_inf__img__fin__domE_H,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A3: set(C)] :
      ( aa(set(B),$o,finite_finite2(B),aa(set(C),set(B),image2(C,B,F2),A3))
     => ( ~ aa(set(C),$o,finite_finite2(C),A3)
       => ~ ! [Y2: B] :
              ( aa(set(B),$o,member(B,Y2),aa(set(C),set(B),image2(C,B,F2),A3))
             => aa(set(C),$o,finite_finite2(C),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),F2),aa(set(B),set(B),insert(B,Y2),bot_bot(set(B))))),A3)) ) ) ) ).

% inf_img_fin_domE'
tff(fact_1625_finite__reachable__advance,axiom,
    ! [B: $tType,E3: set(product_prod(B,B)),V0: B,V: B] :
      ( aa(set(B),$o,finite_finite2(B),aa(set(B),set(B),image(B,B,transitive_rtrancl(B,E3)),aa(set(B),set(B),insert(B,V0),bot_bot(set(B)))))
     => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V0),V)),transitive_rtrancl(B,E3))
       => aa(set(B),$o,finite_finite2(B),aa(set(B),set(B),image(B,B,transitive_rtrancl(B,E3)),aa(set(B),set(B),insert(B,V),bot_bot(set(B))))) ) ) ).

% finite_reachable_advance
tff(fact_1626_mono__cInf,axiom,
    ! [C: $tType,B: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(C) )
     => ! [F2: fun(B,C),A3: set(B)] :
          ( order_mono(B,C,F2)
         => ( aa(set(B),$o,condit1013018076250108175_below(B),A3)
           => ( ( A3 != bot_bot(set(B)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,aa(set(B),B,complete_Inf_Inf(B),A3))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))) ) ) ) ) ).

% mono_cInf
tff(fact_1627_mono__cINF,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( ( condit1219197933456340205attice(C)
        & condit1219197933456340205attice(B) )
     => ! [F2: fun(B,C),A3: fun(D,B),I: set(D)] :
          ( order_mono(B,C,F2)
         => ( aa(set(B),$o,condit1013018076250108175_below(B),aa(set(D),set(B),image2(D,B,A3),I))
           => ( ( I != bot_bot(set(D)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,A3),I)))),aa(set(C),C,complete_Inf_Inf(C),aa(set(D),set(C),image2(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_kk(fun(B,C),fun(fun(D,B),fun(D,C)),F2),A3)),I))) ) ) ) ) ).

% mono_cINF
tff(fact_1628_mono__cSup,axiom,
    ! [C: $tType,B: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(C) )
     => ! [F2: fun(B,C),A3: set(B)] :
          ( order_mono(B,C,F2)
         => ( condit941137186595557371_above(B,A3)
           => ( ( A3 != bot_bot(set(B)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(B,C,F2,aa(set(B),B,complete_Sup_Sup(B),A3))) ) ) ) ) ).

% mono_cSup
tff(fact_1629_mono__cSUP,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(C) )
     => ! [F2: fun(B,C),A3: fun(D,B),I: set(D)] :
          ( order_mono(B,C,F2)
         => ( condit941137186595557371_above(B,aa(set(D),set(B),image2(D,B,A3),I))
           => ( ( I != bot_bot(set(D)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(D),set(C),image2(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_kk(fun(B,C),fun(fun(D,B),fun(D,C)),F2),A3)),I))),aa(B,C,F2,aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,A3),I)))) ) ) ) ) ).

% mono_cSUP
tff(fact_1630_finite__Collect__disjI,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_au(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa)))
    <=> ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Pa))
        & aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Qa)) ) ) ).

% finite_Collect_disjI
tff(fact_1631_finite__Collect__conjI,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Pa))
        | aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Qa)) )
     => aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa))) ) ).

% finite_Collect_conjI
tff(fact_1632_finite__Int,axiom,
    ! [B: $tType,F: set(B),G3: set(B)] :
      ( ( aa(set(B),$o,finite_finite2(B),F)
        | aa(set(B),$o,finite_finite2(B),G3) )
     => aa(set(B),$o,finite_finite2(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),F),G3)) ) ).

% finite_Int
tff(fact_1633_finite__Collect__bounded__ex,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),Qa: fun(C,fun(B,$o))] :
      ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Pa))
     => ( aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(fun(C,fun(B,$o)),fun(C,$o),aTP_Lamp_kl(fun(B,$o),fun(fun(C,fun(B,$o)),fun(C,$o)),Pa),Qa)))
      <=> ! [Y4: B] :
            ( aa(B,$o,Pa,Y4)
           => aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(B,fun(C,$o),aTP_Lamp_km(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Qa),Y4))) ) ) ) ).

% finite_Collect_bounded_ex
tff(fact_1634_finite__Collect__subsets,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => aa(set(set(B)),$o,finite_finite2(set(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_ka(set(B),fun(set(B),$o),A3))) ) ).

% finite_Collect_subsets
tff(fact_1635_finite__Collect__not,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Pa))
     => ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa)))
      <=> aa(set(B),$o,finite_finite2(B),top_top(set(B))) ) ) ).

% finite_Collect_not
tff(fact_1636_finite__SigmaI,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: fun(B,set(C))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( ! [A5: B] :
            ( aa(set(B),$o,member(B,A5),A3)
           => aa(set(C),$o,finite_finite2(C),aa(B,set(C),B2,A5)) )
       => aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),product_Sigma(B,C,A3,B2)) ) ) ).

% finite_SigmaI
tff(fact_1637_finite__UN__I,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: fun(B,set(C))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( ! [A5: B] :
            ( aa(set(B),$o,member(B,A5),A3)
           => aa(set(C),$o,finite_finite2(C),aa(B,set(C),B2,A5)) )
       => aa(set(C),$o,finite_finite2(C),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A3))) ) ) ).

% finite_UN_I
tff(fact_1638_finite__INT,axiom,
    ! [C: $tType,B: $tType,I: set(B),A3: fun(B,set(C))] :
      ( ? [X4: B] :
          ( aa(set(B),$o,member(B,X4),I)
          & aa(set(C),$o,finite_finite2(C),aa(B,set(C),A3,X4)) )
     => aa(set(C),$o,finite_finite2(C),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I))) ) ).

% finite_INT
tff(fact_1639_bdd__above__UN,axiom,
    ! [C: $tType,B: $tType] :
      ( lattice(C)
     => ! [I: set(B),A3: fun(B,set(C))] :
          ( aa(set(B),$o,finite_finite2(B),I)
         => ( condit941137186595557371_above(C,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I)))
          <=> ! [X3: B] :
                ( aa(set(B),$o,member(B,X3),I)
               => condit941137186595557371_above(C,aa(B,set(C),A3,X3)) ) ) ) ) ).

% bdd_above_UN
tff(fact_1640_bdd__below__UN,axiom,
    ! [C: $tType,B: $tType] :
      ( lattice(C)
     => ! [I: set(B),A3: fun(B,set(C))] :
          ( aa(set(B),$o,finite_finite2(B),I)
         => ( aa(set(C),$o,condit1013018076250108175_below(C),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I)))
          <=> ! [X3: B] :
                ( aa(set(B),$o,member(B,X3),I)
               => aa(set(C),$o,condit1013018076250108175_below(C),aa(B,set(C),A3,X3)) ) ) ) ) ).

% bdd_below_UN
tff(fact_1641_finite__if__eq__beyond__finite,axiom,
    ! [B: $tType,S: set(B),S4: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),S)
     => aa(set(set(B)),$o,finite_finite2(set(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aa(set(B),fun(set(B),$o),aTP_Lamp_kn(set(B),fun(set(B),fun(set(B),$o)),S),S4))) ) ).

% finite_if_eq_beyond_finite
tff(fact_1642_not__finite__existsD,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ~ aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Pa))
     => ? [X_1: B] : aa(B,$o,Pa,X_1) ) ).

% not_finite_existsD
tff(fact_1643_pigeonhole__infinite__rel,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C),R: fun(B,fun(C,$o))] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(C),$o,finite_finite2(C),B2)
       => ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),A3)
             => ? [Xa3: C] :
                  ( aa(set(C),$o,member(C,Xa3),B2)
                  & aa(C,$o,aa(B,fun(C,$o),R,X),Xa3) ) )
         => ? [X: C] :
              ( aa(set(C),$o,member(C,X),B2)
              & ~ aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aa(fun(B,fun(C,$o)),fun(C,fun(B,$o)),aTP_Lamp_ko(set(B),fun(fun(B,fun(C,$o)),fun(C,fun(B,$o))),A3),R),X))) ) ) ) ) ).

% pigeonhole_infinite_rel
tff(fact_1644_finite__cartesian__product,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(C),$o,finite_finite2(C),B2)
       => aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))) ) ) ).

% finite_cartesian_product
tff(fact_1645_comp__fun__commute__const,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,C)] : finite6289374366891150609ommute(B,C,aTP_Lamp_kp(fun(C,C),fun(B,fun(C,C)),F2)) ).

% comp_fun_commute_const
tff(fact_1646_monoD,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [F2: fun(B,C),X2: B,Y: B] :
          ( order_mono(B,C,F2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X2)),aa(B,C,F2,Y)) ) ) ) ).

% monoD
tff(fact_1647_monoE,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [F2: fun(B,C),X2: B,Y: B] :
          ( order_mono(B,C,F2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X2)),aa(B,C,F2,Y)) ) ) ) ).

% monoE
tff(fact_1648_monoI,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [F2: fun(B,C)] :
          ( ! [X: B,Y2: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y2)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),aa(B,C,F2,Y2)) )
         => order_mono(B,C,F2) ) ) ).

% monoI
tff(fact_1649_mono__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [F2: fun(B,C)] :
          ( order_mono(B,C,F2)
        <=> ! [X3: B,Y4: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),Y4)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X3)),aa(B,C,F2,Y4)) ) ) ) ).

% mono_def
tff(fact_1650_mono__add,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [A4: B] : order_mono(B,B,aa(B,fun(B,B),plus_plus(B),A4)) ) ).

% mono_add
tff(fact_1651_finite_OemptyI,axiom,
    ! [B: $tType] : aa(set(B),$o,finite_finite2(B),bot_bot(set(B))) ).

% finite.emptyI
tff(fact_1652_infinite__imp__nonempty,axiom,
    ! [B: $tType,S: set(B)] :
      ( ~ aa(set(B),$o,finite_finite2(B),S)
     => ( S != bot_bot(set(B)) ) ) ).

% infinite_imp_nonempty
tff(fact_1653_finite__SigmaI2,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: fun(B,set(C))] :
      ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,set(C)),fun(B,$o),aTP_Lamp_eb(set(B),fun(fun(B,set(C)),fun(B,$o)),A3),B2)))
     => ( ! [A5: B] :
            ( aa(set(B),$o,member(B,A5),A3)
           => aa(set(C),$o,finite_finite2(C),aa(B,set(C),B2,A5)) )
       => aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),product_Sigma(B,C,A3,B2)) ) ) ).

% finite_SigmaI2
tff(fact_1654_finite__cartesian__productD1,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: set(C)] :
      ( aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))
     => ( ( B2 != bot_bot(set(C)) )
       => aa(set(B),$o,finite_finite2(B),A3) ) ) ).

% finite_cartesian_productD1
tff(fact_1655_finite__cartesian__productD2,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))
     => ( ( A3 != bot_bot(set(B)) )
       => aa(set(C),$o,finite_finite2(C),B2) ) ) ).

% finite_cartesian_productD2
tff(fact_1656_finite__cartesian__product__iff,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))
    <=> ( ( A3 = bot_bot(set(B)) )
        | ( B2 = bot_bot(set(C)) )
        | ( aa(set(B),$o,finite_finite2(B),A3)
          & aa(set(C),$o,finite_finite2(C),B2) ) ) ) ).

% finite_cartesian_product_iff
tff(fact_1657_pigeonhole__infinite,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,C)] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(C),$o,finite_finite2(C),aa(set(B),set(C),image2(B,C,F2),A3))
       => ? [X: B] :
            ( aa(set(B),$o,member(B,X),A3)
            & ~ aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aa(fun(B,C),fun(B,fun(B,$o)),aTP_Lamp_kq(set(B),fun(fun(B,C),fun(B,fun(B,$o))),A3),F2),X))) ) ) ) ).

% pigeonhole_infinite
tff(fact_1658_finite__image__set2,axiom,
    ! [D: $tType,C: $tType,B: $tType,Pa: fun(B,$o),Qa: fun(C,$o),F2: fun(B,fun(C,D))] :
      ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Pa))
     => ( aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),Qa))
       => aa(set(D),$o,finite_finite2(D),aa(fun(D,$o),set(D),collect(D),aa(fun(B,fun(C,D)),fun(D,$o),aa(fun(C,$o),fun(fun(B,fun(C,D)),fun(D,$o)),aTP_Lamp_kr(fun(B,$o),fun(fun(C,$o),fun(fun(B,fun(C,D)),fun(D,$o))),Pa),Qa),F2))) ) ) ).

% finite_image_set2
tff(fact_1659_finite__image__set,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),F2: fun(B,C)] :
      ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Pa))
     => aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(fun(B,C),fun(C,$o),aTP_Lamp_ks(fun(B,$o),fun(fun(B,C),fun(C,$o)),Pa),F2))) ) ).

% finite_image_set
tff(fact_1660_INF__filter__not__bot,axiom,
    ! [B: $tType,C: $tType,B2: set(B),F: fun(B,filter(C))] :
      ( ! [X6: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X6),B2)
         => ( aa(set(B),$o,finite_finite2(B),X6)
           => ( aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),F),X6)) != bot_bot(filter(C)) ) ) )
     => ( aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),F),B2)) != bot_bot(filter(C)) ) ) ).

% INF_filter_not_bot
tff(fact_1661_finite__inverse__image__gen,axiom,
    ! [B: $tType,C: $tType,A3: set(B),F2: fun(C,B),D2: set(C)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( inj_on(C,B,F2,D2)
       => aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aa(fun(C,B),fun(set(C),fun(C,$o)),aTP_Lamp_kt(set(B),fun(fun(C,B),fun(set(C),fun(C,$o))),A3),F2),D2))) ) ) ).

% finite_inverse_image_gen
tff(fact_1662_rtranclp_Omono,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o))] : order_mono(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aTP_Lamp_ku(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),R2)) ).

% rtranclp.mono
tff(fact_1663_tranclp_Omono,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o))] : order_mono(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aTP_Lamp_kv(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),R2)) ).

% tranclp.mono
tff(fact_1664_finite__update__induct,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),Ca: C,Pa: fun(fun(B,C),$o)] :
      ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aTP_Lamp_kw(fun(B,C),fun(C,fun(B,$o)),F2),Ca)))
     => ( aa(fun(B,C),$o,Pa,aTP_Lamp_bm(C,fun(B,C),Ca))
       => ( ! [A5: B,B4: C,F9: fun(B,C)] :
              ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_kx(C,fun(fun(B,C),fun(B,$o)),Ca),F9)))
             => ( ( aa(B,C,F9,A5) = Ca )
               => ( ( B4 != Ca )
                 => ( aa(fun(B,C),$o,Pa,F9)
                   => aa(fun(B,C),$o,Pa,fun_upd(B,C,F9,A5,B4)) ) ) ) )
         => aa(fun(B,C),$o,Pa,F2) ) ) ) ).

% finite_update_induct
tff(fact_1665_finite__quotient,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))
       => aa(set(set(B)),$o,finite_finite2(set(B)),equiv_quotient(B,A3,R2)) ) ) ).

% finite_quotient
tff(fact_1666_mono__Int,axiom,
    ! [C: $tType,B: $tType,F2: fun(set(B),set(C)),A3: set(B),B2: set(B)] :
      ( order_mono(set(B),set(C),F2)
     => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),F2,A3)),aa(set(B),set(C),F2,B2))) ) ).

% mono_Int
tff(fact_1667_mono__inf,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semilattice_inf(B)
        & semilattice_inf(C) )
     => ! [F2: fun(B,C),A3: B,B2: B] :
          ( order_mono(B,C,F2)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),B2))),aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,F2,A3)),aa(B,C,F2,B2))) ) ) ).

% mono_inf
tff(fact_1668_mono__sup,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semilattice_sup(B)
        & semilattice_sup(C) )
     => ! [F2: fun(B,C),A3: B,B2: B] :
          ( order_mono(B,C,F2)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(B,C,F2,A3)),aa(B,C,F2,B2))),aa(B,C,F2,aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),B2))) ) ) ).

% mono_sup
tff(fact_1669_comp__fun__commute__filter__fold,axiom,
    ! [B: $tType,Pa: fun(B,$o)] : finite6289374366891150609ommute(B,set(B),aTP_Lamp_ky(fun(B,$o),fun(B,fun(set(B),set(B))),Pa)) ).

% comp_fun_commute_filter_fold
tff(fact_1670_finite__has__maximal,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ? [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
                & ! [Xa3: B] :
                    ( aa(set(B),$o,member(B,Xa3),A3)
                   => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Xa3)
                     => ( X = Xa3 ) ) ) ) ) ) ) ).

% finite_has_maximal
tff(fact_1671_finite__has__minimal,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ? [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
                & ! [Xa3: B] :
                    ( aa(set(B),$o,member(B,Xa3),A3)
                   => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Xa3),X)
                     => ( X = Xa3 ) ) ) ) ) ) ) ).

% finite_has_minimal
tff(fact_1672_finite_Ocases,axiom,
    ! [B: $tType,A4: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A4)
     => ( ( A4 != bot_bot(set(B)) )
       => ~ ! [A11: set(B)] :
              ( ? [A5: B] : ( A4 = aa(set(B),set(B),insert(B,A5),A11) )
             => ~ aa(set(B),$o,finite_finite2(B),A11) ) ) ) ).

% finite.cases
tff(fact_1673_finite_Osimps,axiom,
    ! [B: $tType,A4: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A4)
    <=> ( ( A4 = bot_bot(set(B)) )
        | ? [A12: set(B),A6: B] :
            ( ( A4 = aa(set(B),set(B),insert(B,A6),A12) )
            & aa(set(B),$o,finite_finite2(B),A12) ) ) ) ).

% finite.simps
tff(fact_1674_finite__induct,axiom,
    ! [B: $tType,F: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite2(B),F)
     => ( aa(set(B),$o,Pa,bot_bot(set(B)))
       => ( ! [X: B,F6: set(B)] :
              ( aa(set(B),$o,finite_finite2(B),F6)
             => ( ~ aa(set(B),$o,member(B,X),F6)
               => ( aa(set(B),$o,Pa,F6)
                 => aa(set(B),$o,Pa,aa(set(B),set(B),insert(B,X),F6)) ) ) )
         => aa(set(B),$o,Pa,F) ) ) ) ).

% finite_induct
tff(fact_1675_finite__ne__induct,axiom,
    ! [B: $tType,F: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite2(B),F)
     => ( ( F != bot_bot(set(B)) )
       => ( ! [X: B] : aa(set(B),$o,Pa,aa(set(B),set(B),insert(B,X),bot_bot(set(B))))
         => ( ! [X: B,F6: set(B)] :
                ( aa(set(B),$o,finite_finite2(B),F6)
               => ( ( F6 != bot_bot(set(B)) )
                 => ( ~ aa(set(B),$o,member(B,X),F6)
                   => ( aa(set(B),$o,Pa,F6)
                     => aa(set(B),$o,Pa,aa(set(B),set(B),insert(B,X),F6)) ) ) ) )
           => aa(set(B),$o,Pa,F) ) ) ) ) ).

% finite_ne_induct
tff(fact_1676_infinite__finite__induct,axiom,
    ! [B: $tType,Pa: fun(set(B),$o),A3: set(B)] :
      ( ! [A11: set(B)] :
          ( ~ aa(set(B),$o,finite_finite2(B),A11)
         => aa(set(B),$o,Pa,A11) )
     => ( aa(set(B),$o,Pa,bot_bot(set(B)))
       => ( ! [X: B,F6: set(B)] :
              ( aa(set(B),$o,finite_finite2(B),F6)
             => ( ~ aa(set(B),$o,member(B,X),F6)
               => ( aa(set(B),$o,Pa,F6)
                 => aa(set(B),$o,Pa,aa(set(B),set(B),insert(B,X),F6)) ) ) )
         => aa(set(B),$o,Pa,A3) ) ) ) ).

% infinite_finite_induct
tff(fact_1677_finite__range__imageI,axiom,
    ! [B: $tType,D: $tType,C: $tType,G: fun(C,B),F2: fun(B,D)] :
      ( aa(set(B),$o,finite_finite2(B),aa(set(C),set(B),image2(C,B,G),top_top(set(C))))
     => aa(set(D),$o,finite_finite2(D),aa(set(C),set(D),image2(C,D,aa(fun(B,D),fun(C,D),aTP_Lamp_kz(fun(C,B),fun(fun(B,D),fun(C,D)),G),F2)),top_top(set(C)))) ) ).

% finite_range_imageI
tff(fact_1678_finite__Collect,axiom,
    ! [B: $tType,C: $tType,S: set(B),F2: fun(C,B)] :
      ( aa(set(B),$o,finite_finite2(B),S)
     => ( inj_on(C,B,F2,top_top(set(C)))
       => aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(fun(C,B),fun(C,$o),aTP_Lamp_la(set(B),fun(fun(C,B),fun(C,$o)),S),F2))) ) ) ).

% finite_Collect
tff(fact_1679_finite__inverse__image,axiom,
    ! [B: $tType,C: $tType,A3: set(B),F2: fun(C,B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( inj_on(C,B,F2,top_top(set(C)))
       => aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(fun(C,B),fun(C,$o),aTP_Lamp_la(set(B),fun(fun(C,B),fun(C,$o)),A3),F2))) ) ) ).

% finite_inverse_image
tff(fact_1680_Rings_Omono__mult,axiom,
    ! [B: $tType] :
      ( ordered_semiring(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => order_mono(B,B,aa(B,fun(B,B),times_times(B),A4)) ) ) ).

% Rings.mono_mult
tff(fact_1681_finite__subset__induct,axiom,
    ! [B: $tType,F: set(B),A3: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite2(B),F)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),F),A3)
       => ( aa(set(B),$o,Pa,bot_bot(set(B)))
         => ( ! [A5: B,F6: set(B)] :
                ( aa(set(B),$o,finite_finite2(B),F6)
               => ( aa(set(B),$o,member(B,A5),A3)
                 => ( ~ aa(set(B),$o,member(B,A5),F6)
                   => ( aa(set(B),$o,Pa,F6)
                     => aa(set(B),$o,Pa,aa(set(B),set(B),insert(B,A5),F6)) ) ) ) )
           => aa(set(B),$o,Pa,F) ) ) ) ) ).

% finite_subset_induct
tff(fact_1682_finite__subset__induct_H,axiom,
    ! [B: $tType,F: set(B),A3: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite2(B),F)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),F),A3)
       => ( aa(set(B),$o,Pa,bot_bot(set(B)))
         => ( ! [A5: B,F6: set(B)] :
                ( aa(set(B),$o,finite_finite2(B),F6)
               => ( aa(set(B),$o,member(B,A5),A3)
                 => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),F6),A3)
                   => ( ~ aa(set(B),$o,member(B,A5),F6)
                     => ( aa(set(B),$o,Pa,F6)
                       => aa(set(B),$o,Pa,aa(set(B),set(B),insert(B,A5),F6)) ) ) ) ) )
           => aa(set(B),$o,Pa,F) ) ) ) ) ).

% finite_subset_induct'
tff(fact_1683_finite__Sup__in,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [X: B,Y2: B] :
                  ( aa(set(B),$o,member(B,X),A3)
                 => ( aa(set(B),$o,member(B,Y2),A3)
                   => aa(set(B),$o,member(B,aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y2)),A3) ) )
             => aa(set(B),$o,member(B,aa(set(B),B,complete_Sup_Sup(B),A3)),A3) ) ) ) ) ).

% finite_Sup_in
tff(fact_1684_finite__Inf__in,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [X: B,Y2: B] :
                  ( aa(set(B),$o,member(B,X),A3)
                 => ( aa(set(B),$o,member(B,Y2),A3)
                   => aa(set(B),$o,member(B,aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y2)),A3) ) )
             => aa(set(B),$o,member(B,aa(set(B),B,complete_Inf_Inf(B),A3)),A3) ) ) ) ) ).

% finite_Inf_in
tff(fact_1685_infinite__remove,axiom,
    ! [B: $tType,S: set(B),A4: B] :
      ( ~ aa(set(B),$o,finite_finite2(B),S)
     => ~ aa(set(B),$o,finite_finite2(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) ) ).

% infinite_remove
tff(fact_1686_infinite__coinduct,axiom,
    ! [B: $tType,X5: fun(set(B),$o),A3: set(B)] :
      ( aa(set(B),$o,X5,A3)
     => ( ! [A11: set(B)] :
            ( aa(set(B),$o,X5,A11)
           => ? [X4: B] :
                ( aa(set(B),$o,member(B,X4),A11)
                & ( aa(set(B),$o,X5,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A11),aa(set(B),set(B),insert(B,X4),bot_bot(set(B)))))
                  | ~ aa(set(B),$o,finite_finite2(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A11),aa(set(B),set(B),insert(B,X4),bot_bot(set(B))))) ) ) )
       => ~ aa(set(B),$o,finite_finite2(B),A3) ) ) ).

% infinite_coinduct
tff(fact_1687_finite__empty__induct,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),$o,Pa,A3)
       => ( ! [A5: B,A11: set(B)] :
              ( aa(set(B),$o,finite_finite2(B),A11)
             => ( aa(set(B),$o,member(B,A5),A11)
               => ( aa(set(B),$o,Pa,A11)
                 => aa(set(B),$o,Pa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A11),aa(set(B),set(B),insert(B,A5),bot_bot(set(B))))) ) ) )
         => aa(set(B),$o,Pa,bot_bot(set(B))) ) ) ) ).

% finite_empty_induct
tff(fact_1688_mono__Sup,axiom,
    ! [C: $tType,B: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(C) )
     => ! [F2: fun(B,C),A3: set(B)] :
          ( order_mono(B,C,F2)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))),aa(B,C,F2,aa(set(B),B,complete_Sup_Sup(B),A3))) ) ) ).

% mono_Sup
tff(fact_1689_mono__SUP,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(C) )
     => ! [F2: fun(B,C),A3: fun(D,B),I: set(D)] :
          ( order_mono(B,C,F2)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(D),set(C),image2(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_lb(fun(B,C),fun(fun(D,B),fun(D,C)),F2),A3)),I))),aa(B,C,F2,aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,A3),I)))) ) ) ).

% mono_SUP
tff(fact_1690_mono__Inf,axiom,
    ! [C: $tType,B: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(C) )
     => ! [F2: fun(B,C),A3: set(B)] :
          ( order_mono(B,C,F2)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,aa(set(B),B,complete_Inf_Inf(B),A3))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))) ) ) ).

% mono_Inf
tff(fact_1691_mono__INF,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( ( comple6319245703460814977attice(C)
        & comple6319245703460814977attice(B) )
     => ! [F2: fun(B,C),A3: fun(D,B),I: set(D)] :
          ( order_mono(B,C,F2)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,A3),I)))),aa(set(C),C,complete_Inf_Inf(C),aa(set(D),set(C),image2(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_lb(fun(B,C),fun(fun(D,B),fun(D,C)),F2),A3)),I))) ) ) ).

% mono_INF
tff(fact_1692_finite__vimage__IntI,axiom,
    ! [B: $tType,C: $tType,F: set(B),H2: fun(C,B),A3: set(C)] :
      ( aa(set(B),$o,finite_finite2(B),F)
     => ( inj_on(C,B,H2,A3)
       => aa(set(C),$o,finite_finite2(C),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),H2),F)),A3)) ) ) ).

% finite_vimage_IntI
tff(fact_1693_finite__equiv__class,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X5: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))
       => ( aa(set(set(B)),$o,member(set(B),X5),equiv_quotient(B,A3,R2))
         => aa(set(B),$o,finite_finite2(B),X5) ) ) ) ).

% finite_equiv_class
tff(fact_1694_remove__induct,axiom,
    ! [B: $tType,Pa: fun(set(B),$o),B2: set(B)] :
      ( aa(set(B),$o,Pa,bot_bot(set(B)))
     => ( ( ~ aa(set(B),$o,finite_finite2(B),B2)
         => aa(set(B),$o,Pa,B2) )
       => ( ! [A11: set(B)] :
              ( aa(set(B),$o,finite_finite2(B),A11)
             => ( ( A11 != bot_bot(set(B)) )
               => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A11),B2)
                 => ( ! [X4: B] :
                        ( aa(set(B),$o,member(B,X4),A11)
                       => aa(set(B),$o,Pa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A11),aa(set(B),set(B),insert(B,X4),bot_bot(set(B))))) )
                   => aa(set(B),$o,Pa,A11) ) ) ) )
         => aa(set(B),$o,Pa,B2) ) ) ) ).

% remove_induct
tff(fact_1695_finite__remove__induct,axiom,
    ! [B: $tType,B2: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite2(B),B2)
     => ( aa(set(B),$o,Pa,bot_bot(set(B)))
       => ( ! [A11: set(B)] :
              ( aa(set(B),$o,finite_finite2(B),A11)
             => ( ( A11 != bot_bot(set(B)) )
               => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A11),B2)
                 => ( ! [X4: B] :
                        ( aa(set(B),$o,member(B,X4),A11)
                       => aa(set(B),$o,Pa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A11),aa(set(B),set(B),insert(B,X4),bot_bot(set(B))))) )
                   => aa(set(B),$o,Pa,A11) ) ) ) )
         => aa(set(B),$o,Pa,B2) ) ) ) ).

% finite_remove_induct
tff(fact_1696_inf__img__fin__domE,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,B),A3: set(C)] :
      ( aa(set(B),$o,finite_finite2(B),aa(set(C),set(B),image2(C,B,F2),A3))
     => ( ~ aa(set(C),$o,finite_finite2(C),A3)
       => ~ ! [Y2: B] :
              ( aa(set(B),$o,member(B,Y2),aa(set(C),set(B),image2(C,B,F2),A3))
             => aa(set(C),$o,finite_finite2(C),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),F2),aa(set(B),set(B),insert(B,Y2),bot_bot(set(B))))) ) ) ) ).

% inf_img_fin_domE
tff(fact_1697_inf__img__fin__dom,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,B),A3: set(C)] :
      ( aa(set(B),$o,finite_finite2(B),aa(set(C),set(B),image2(C,B,F2),A3))
     => ( ~ aa(set(C),$o,finite_finite2(C),A3)
       => ? [X: B] :
            ( aa(set(B),$o,member(B,X),aa(set(C),set(B),image2(C,B,F2),A3))
            & ~ aa(set(C),$o,finite_finite2(C),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),F2),aa(set(B),set(B),insert(B,X),bot_bot(set(B))))) ) ) ) ).

% inf_img_fin_dom
tff(fact_1698_infinite__imp__bij__betw2,axiom,
    ! [B: $tType,A3: set(B),A4: B] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => ? [H4: fun(B,B)] : bij_betw(B,B,H4,A3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) ) ).

% infinite_imp_bij_betw2
tff(fact_1699_infinite__imp__bij__betw,axiom,
    ! [B: $tType,A3: set(B),A4: B] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => ? [H4: fun(B,B)] : bij_betw(B,B,H4,A3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))) ) ).

% infinite_imp_bij_betw
tff(fact_1700_finite__finite__vimage__IntI,axiom,
    ! [B: $tType,C: $tType,F: set(B),H2: fun(C,B),A3: set(C)] :
      ( aa(set(B),$o,finite_finite2(B),F)
     => ( ! [Y2: B] :
            ( aa(set(B),$o,member(B,Y2),F)
           => aa(set(C),$o,finite_finite2(C),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),H2),aa(set(B),set(B),insert(B,Y2),bot_bot(set(B))))),A3)) )
       => aa(set(C),$o,finite_finite2(C),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),H2),F)),A3)) ) ) ).

% finite_finite_vimage_IntI
tff(fact_1701_finite_Omono,axiom,
    ! [B: $tType] : order_mono(fun(set(B),$o),fun(set(B),$o),aTP_Lamp_lc(fun(set(B),$o),fun(set(B),$o))) ).

% finite.mono
tff(fact_1702_finite__ranking__induct,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [S: set(B),Pa: fun(set(B),$o),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),$o,Pa,bot_bot(set(B)))
           => ( ! [X: B,S5: set(B)] :
                  ( aa(set(B),$o,finite_finite2(B),S5)
                 => ( ! [Y5: B] :
                        ( aa(set(B),$o,member(B,Y5),S5)
                       => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,Y5)),aa(B,C,F2,X)) )
                   => ( aa(set(B),$o,Pa,S5)
                     => aa(set(B),$o,Pa,aa(set(B),set(B),insert(B,X),S5)) ) ) )
             => aa(set(B),$o,Pa,S) ) ) ) ) ).

% finite_ranking_induct
tff(fact_1703_prod_Ofinite__Collect__op,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [I: set(B),X2: fun(B,C),Y: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_ld(set(B),fun(fun(B,C),fun(B,$o)),I),X2)))
         => ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_ld(set(B),fun(fun(B,C),fun(B,$o)),I),Y)))
           => aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aa(fun(B,C),fun(fun(B,C),fun(B,$o)),aTP_Lamp_le(set(B),fun(fun(B,C),fun(fun(B,C),fun(B,$o))),I),X2),Y))) ) ) ) ).

% prod.finite_Collect_op
tff(fact_1704_sum_Ofinite__Collect__op,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [I: set(B),X2: fun(B,C),Y: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_lf(set(B),fun(fun(B,C),fun(B,$o)),I),X2)))
         => ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_lf(set(B),fun(fun(B,C),fun(B,$o)),I),Y)))
           => aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aa(fun(B,C),fun(fun(B,C),fun(B,$o)),aTP_Lamp_lg(set(B),fun(fun(B,C),fun(fun(B,C),fun(B,$o))),I),X2),Y))) ) ) ) ).

% sum.finite_Collect_op
tff(fact_1705_Pow__fold,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( pow(B,A3) = finite_fold(B,set(set(B)),aTP_Lamp_kj(B,fun(set(set(B)),set(set(B)))),aa(set(set(B)),set(set(B)),insert(set(B),bot_bot(set(B))),bot_bot(set(set(B)))),A3) ) ) ).

% Pow_fold
tff(fact_1706_infinite__cartesian__product,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => ( ~ aa(set(C),$o,finite_finite2(C),B2)
       => ~ aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))) ) ) ).

% infinite_cartesian_product
tff(fact_1707_fold__union__pair,axiom,
    ! [C: $tType,B: $tType,B2: set(B),X2: C,A3: set(product_prod(C,B))] :
      ( aa(set(B),$o,finite_finite2(B),B2)
     => ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),set(product_prod(C,B))),sup_sup(set(product_prod(C,B))),aa(set(set(product_prod(C,B))),set(product_prod(C,B)),complete_Sup_Sup(set(product_prod(C,B))),aa(set(B),set(set(product_prod(C,B))),image2(B,set(product_prod(C,B)),aTP_Lamp_lh(C,fun(B,set(product_prod(C,B))),X2)),B2))),A3) = finite_fold(B,set(product_prod(C,B)),aTP_Lamp_li(C,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),X2),A3,B2) ) ) ).

% fold_union_pair
tff(fact_1708_Fpow__Pow__finite,axiom,
    ! [B: $tType,A3: set(B)] : ( finite_Fpow(B,A3) = aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),inf_inf(set(set(B))),pow(B,A3)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),finite_finite2(B))) ) ).

% Fpow_Pow_finite
tff(fact_1709_finite__transitivity__chain,axiom,
    ! [B: $tType,A3: set(B),R: fun(B,fun(B,$o))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( ! [X: B] : ~ aa(B,$o,aa(B,fun(B,$o),R,X),X)
       => ( ! [X: B,Y2: B,Z3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),R,X),Y2)
             => ( aa(B,$o,aa(B,fun(B,$o),R,Y2),Z3)
               => aa(B,$o,aa(B,fun(B,$o),R,X),Z3) ) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => ? [Y5: B] :
                    ( aa(set(B),$o,member(B,Y5),A3)
                    & aa(B,$o,aa(B,fun(B,$o),R,X),Y5) ) )
           => ( A3 = bot_bot(set(B)) ) ) ) ) ) ).

% finite_transitivity_chain
tff(fact_1710_fold__empty,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,fun(B,B)),Z2: B] : ( finite_fold(C,B,F2,Z2,bot_bot(set(C))) = Z2 ) ).

% fold_empty
tff(fact_1711_mono__compose,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType] :
      ( ( order(D)
        & order(B) )
     => ! [Qa: fun(B,fun(C,D)),F2: fun(E,C)] :
          ( order_mono(B,fun(C,D),Qa)
         => order_mono(B,fun(E,D),aa(fun(E,C),fun(B,fun(E,D)),aTP_Lamp_lj(fun(B,fun(C,D)),fun(fun(E,C),fun(B,fun(E,D))),Qa),F2)) ) ) ).

% mono_compose
tff(fact_1712_Inf__filter__not__bot,axiom,
    ! [B: $tType,B2: set(filter(B))] :
      ( ! [X6: set(filter(B))] :
          ( aa(set(filter(B)),$o,aa(set(filter(B)),fun(set(filter(B)),$o),ord_less_eq(set(filter(B))),X6),B2)
         => ( aa(set(filter(B)),$o,finite_finite2(filter(B)),X6)
           => ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),X6) != bot_bot(filter(B)) ) ) )
     => ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),B2) != bot_bot(filter(B)) ) ) ).

% Inf_filter_not_bot
tff(fact_1713_INF__filter__bot__base,axiom,
    ! [B: $tType,C: $tType,I: set(B),F: fun(B,filter(C))] :
      ( ! [I3: B] :
          ( aa(set(B),$o,member(B,I3),I)
         => ! [J3: B] :
              ( aa(set(B),$o,member(B,J3),I)
             => ? [X4: B] :
                  ( aa(set(B),$o,member(B,X4),I)
                  & aa(filter(C),$o,aa(filter(C),fun(filter(C),$o),ord_less_eq(filter(C)),aa(B,filter(C),F,X4)),aa(filter(C),filter(C),aa(filter(C),fun(filter(C),filter(C)),inf_inf(filter(C)),aa(B,filter(C),F,I3)),aa(B,filter(C),F,J3))) ) ) )
     => ( ( aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),F),I)) = bot_bot(filter(C)) )
      <=> ? [X3: B] :
            ( aa(set(B),$o,member(B,X3),I)
            & ( aa(B,filter(C),F,X3) = bot_bot(filter(C)) ) ) ) ) ).

% INF_filter_bot_base
tff(fact_1714_comp__fun__commute__relcomp__fold,axiom,
    ! [D: $tType,C: $tType,B: $tType,S: set(product_prod(B,C))] :
      ( aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),S)
     => finite6289374366891150609ommute(product_prod(D,B),set(product_prod(D,C)),aa(fun(D,fun(B,fun(set(product_prod(D,C)),set(product_prod(D,C))))),fun(product_prod(D,B),fun(set(product_prod(D,C)),set(product_prod(D,C)))),product_case_prod(D,B,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aTP_Lamp_ll(set(product_prod(B,C)),fun(D,fun(B,fun(set(product_prod(D,C)),set(product_prod(D,C))))),S))) ) ).

% comp_fun_commute_relcomp_fold
tff(fact_1715_comp__fun__commute__product__fold,axiom,
    ! [C: $tType,B: $tType,B2: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),B2)
     => finite6289374366891150609ommute(C,set(product_prod(C,B)),aTP_Lamp_lm(set(B),fun(C,fun(set(product_prod(C,B)),set(product_prod(C,B)))),B2)) ) ).

% comp_fun_commute_product_fold
tff(fact_1716_comp__fun__commute__Image__fold,axiom,
    ! [C: $tType,B: $tType,S: set(B)] : finite6289374366891150609ommute(product_prod(B,C),set(C),aa(fun(B,fun(C,fun(set(C),set(C)))),fun(product_prod(B,C),fun(set(C),set(C))),product_case_prod(B,C,fun(set(C),set(C))),aTP_Lamp_ln(set(B),fun(B,fun(C,fun(set(C),set(C)))),S))) ).

% comp_fun_commute_Image_fold
tff(fact_1717_empty__in__Fpow,axiom,
    ! [B: $tType,A3: set(B)] : aa(set(set(B)),$o,member(set(B),bot_bot(set(B))),finite_Fpow(B,A3)) ).

% empty_in_Fpow
tff(fact_1718_Fpow__not__empty,axiom,
    ! [B: $tType,A3: set(B)] : ( finite_Fpow(B,A3) != bot_bot(set(set(B))) ) ).

% Fpow_not_empty
tff(fact_1719_inf__Inf__fold__inf,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B),B2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),A3)),B2) = finite_fold(B,B,inf_inf(B),B2,A3) ) ) ) ).

% inf_Inf_fold_inf
tff(fact_1720_Sup__fold__sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),B,complete_Sup_Sup(B),A3) = finite_fold(B,B,sup_sup(B),bot_bot(B),A3) ) ) ) ).

% Sup_fold_sup
tff(fact_1721_Inf__fold__inf,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),B,complete_Inf_Inf(B),A3) = finite_fold(B,B,inf_inf(B),top_top(B),A3) ) ) ) ).

% Inf_fold_inf
tff(fact_1722_image__fold__insert,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,C)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),set(C),image2(B,C,F2),A3) = finite_fold(B,set(C),aTP_Lamp_lo(fun(B,C),fun(B,fun(set(C),set(C))),F2),bot_bot(set(C)),A3) ) ) ).

% image_fold_insert
tff(fact_1723_Fpow__def,axiom,
    ! [B: $tType,A3: set(B)] : ( finite_Fpow(B,A3) = aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_lp(set(B),fun(set(B),$o),A3)) ) ).

% Fpow_def
tff(fact_1724_inf__INF__fold__inf,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),B2: C,F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(C,C,aa(C,fun(C,C),inf_inf(C),B2),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))) = finite_fold(B,C,aa(fun(B,C),fun(B,fun(C,C)),comp(C,fun(C,C),B,inf_inf(C)),F2),B2,A3) ) ) ) ).

% inf_INF_fold_inf
tff(fact_1725_product__fold,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: set(C)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(C),$o,finite_finite2(C),B2)
       => ( product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)) = finite_fold(B,set(product_prod(B,C)),aTP_Lamp_lr(set(C),fun(B,fun(set(product_prod(B,C)),set(product_prod(B,C)))),B2),bot_bot(set(product_prod(B,C))),A3) ) ) ) ).

% product_fold
tff(fact_1726_Id__on__fold,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( id_on(B,A3) = finite_fold(B,set(product_prod(B,B)),aTP_Lamp_ls(B,fun(set(product_prod(B,B)),set(product_prod(B,B)))),bot_bot(set(product_prod(B,B))),A3) ) ) ).

% Id_on_fold
tff(fact_1727_SUP__fold__sup,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3)) = finite_fold(B,C,aa(fun(B,C),fun(B,fun(C,C)),comp(C,fun(C,C),B,sup_sup(C)),F2),bot_bot(C),A3) ) ) ) ).

% SUP_fold_sup
tff(fact_1728_INF__fold__inf,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3)) = finite_fold(B,C,aa(fun(B,C),fun(B,fun(C,C)),comp(C,fun(C,C),B,inf_inf(C)),F2),top_top(C),A3) ) ) ) ).

% INF_fold_inf
tff(fact_1729_coinduct3__mono__lemma,axiom,
    ! [B: $tType,C: $tType] :
      ( order(B)
     => ! [F2: fun(B,set(C)),X5: set(C),B2: set(C)] :
          ( order_mono(B,set(C),F2)
         => order_mono(B,set(C),aa(set(C),fun(B,set(C)),aa(set(C),fun(set(C),fun(B,set(C))),aTP_Lamp_lt(fun(B,set(C)),fun(set(C),fun(set(C),fun(B,set(C)))),F2),X5),B2)) ) ) ).

% coinduct3_mono_lemma
tff(fact_1730_Set__filter__fold,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,$o)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( filter3(B,Pa,A3) = finite_fold(B,set(B),aTP_Lamp_ky(fun(B,$o),fun(B,fun(set(B),set(B))),Pa),bot_bot(set(B)),A3) ) ) ).

% Set_filter_fold
tff(fact_1731_sum__diff1_H__aux,axiom,
    ! [C: $tType,B: $tType] :
      ( ab_group_add(C)
     => ! [F: set(B),I: set(B),F2: fun(B,C),I2: B] :
          ( aa(set(B),$o,finite_finite2(B),F)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_lu(set(B),fun(fun(B,C),fun(B,$o)),I),F2))),F)
           => ( groups1027152243600224163dd_sum(B,C,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),I),aa(set(B),set(B),insert(B,I2),bot_bot(set(B)))))
              = $ite(aa(set(B),$o,member(B,I2),I),aa(C,C,aa(C,fun(C,C),minus_minus(C),groups1027152243600224163dd_sum(B,C,F2,I)),aa(B,C,F2,I2)),groups1027152243600224163dd_sum(B,C,F2,I)) ) ) ) ) ).

% sum_diff1'_aux
tff(fact_1732_insert__relcomp__union__fold,axiom,
    ! [D: $tType,C: $tType,B: $tType,S: set(product_prod(B,C)),X2: product_prod(D,B),X5: set(product_prod(D,C))] :
      ( aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),S)
     => ( aa(set(product_prod(D,C)),set(product_prod(D,C)),aa(set(product_prod(D,C)),fun(set(product_prod(D,C)),set(product_prod(D,C))),sup_sup(set(product_prod(D,C))),relcomp(D,B,C,aa(set(product_prod(D,B)),set(product_prod(D,B)),insert(product_prod(D,B),X2),bot_bot(set(product_prod(D,B)))),S)),X5) = finite_fold(product_prod(B,C),set(product_prod(D,C)),aa(fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),fun(product_prod(B,C),fun(set(product_prod(D,C)),set(product_prod(D,C)))),product_case_prod(B,C,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aTP_Lamp_lv(product_prod(D,B),fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),X2)),X5,S) ) ) ).

% insert_relcomp_union_fold
tff(fact_1733_sum__diff1_H,axiom,
    ! [C: $tType,B: $tType] :
      ( ab_group_add(C)
     => ! [I: set(B),F2: fun(B,C),I2: B] :
          ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_lu(set(B),fun(fun(B,C),fun(B,$o)),I),F2)))
         => ( groups1027152243600224163dd_sum(B,C,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),I),aa(set(B),set(B),insert(B,I2),bot_bot(set(B)))))
            = $ite(aa(set(B),$o,member(B,I2),I),aa(C,C,aa(C,fun(C,C),minus_minus(C),groups1027152243600224163dd_sum(B,C,F2,I)),aa(B,C,F2,I2)),groups1027152243600224163dd_sum(B,C,F2,I)) ) ) ) ).

% sum_diff1'
tff(fact_1734_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [C: $tType,B: $tType,S: set(B),F2: fun(B,fun(C,C)),A3: set(B),B2: set(B),Z2: C] :
      ( finite4664212375090638736ute_on(B,C,S,F2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S)
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),S)
         => ( aa(set(B),$o,finite_finite2(B),A3)
           => ( aa(set(B),$o,finite_finite2(B),B2)
             => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
               => ( finite_fold(B,C,F2,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = finite_fold(B,C,F2,finite_fold(B,C,F2,Z2,A3),B2) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
tff(fact_1735_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [C: $tType,B: $tType,S: set(B),F2: fun(B,fun(C,C)),X2: B,A3: set(B),Z2: C] :
      ( finite4664212375090638736ute_on(B,C,S,F2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,X2),A3)),S)
       => ( aa(set(B),$o,finite_finite2(B),A3)
         => ( finite_fold(B,C,F2,Z2,aa(set(B),set(B),insert(B,X2),A3)) = aa(C,C,aa(B,fun(C,C),F2,X2),finite_fold(B,C,F2,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
tff(fact_1736_relcomp__empty2,axiom,
    ! [D: $tType,C: $tType,B: $tType,R: set(product_prod(B,D))] : ( relcomp(B,D,C,R,bot_bot(set(product_prod(D,C)))) = bot_bot(set(product_prod(B,C))) ) ).

% relcomp_empty2
tff(fact_1737_relcomp__empty1,axiom,
    ! [D: $tType,C: $tType,B: $tType,R: set(product_prod(D,C))] : ( relcomp(B,D,C,bot_bot(set(product_prod(B,D))),R) = bot_bot(set(product_prod(B,C))) ) ).

% relcomp_empty1
tff(fact_1738_sum_Oempty_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [P3: fun(C,B)] : ( groups1027152243600224163dd_sum(C,B,P3,bot_bot(set(C))) = zero_zero(B) ) ) ).

% sum.empty'
tff(fact_1739_sum_Oinsert_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [I: set(B),P3: fun(B,C),I2: B] :
          ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_lf(set(B),fun(fun(B,C),fun(B,$o)),I),P3)))
         => ( groups1027152243600224163dd_sum(B,C,P3,aa(set(B),set(B),insert(B,I2),I))
            = $ite(aa(set(B),$o,member(B,I2),I),groups1027152243600224163dd_sum(B,C,P3,I),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,P3,I2)),groups1027152243600224163dd_sum(B,C,P3,I))) ) ) ) ).

% sum.insert'
tff(fact_1740_Set_Ofilter__def,axiom,
    ! [B: $tType,Pa: fun(B,$o),A3: set(B)] : ( filter3(B,Pa,A3) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_lw(fun(B,$o),fun(set(B),fun(B,$o)),Pa),A3)) ) ).

% Set.filter_def
tff(fact_1741_sum_Onon__neutral_H,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(C,B),I: set(C)] : ( groups1027152243600224163dd_sum(C,B,G,aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aTP_Lamp_lx(fun(C,B),fun(set(C),fun(C,$o)),G),I))) = groups1027152243600224163dd_sum(C,B,G,I) ) ) ).

% sum.non_neutral'
tff(fact_1742_wf__no__loop,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ( relcomp(B,B,B,R,R) = bot_bot(set(product_prod(B,B))) )
     => wf(B,R) ) ).

% wf_no_loop
tff(fact_1743_union__comp__emptyL,axiom,
    ! [B: $tType,A3: set(product_prod(B,B)),C2: set(product_prod(B,B)),B2: set(product_prod(B,B))] :
      ( ( relcomp(B,B,B,A3,C2) = bot_bot(set(product_prod(B,B))) )
     => ( ( relcomp(B,B,B,B2,C2) = bot_bot(set(product_prod(B,B))) )
       => ( relcomp(B,B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),A3),B2),C2) = bot_bot(set(product_prod(B,B))) ) ) ) ).

% union_comp_emptyL
tff(fact_1744_union__comp__emptyR,axiom,
    ! [B: $tType,A3: set(product_prod(B,B)),B2: set(product_prod(B,B)),C2: set(product_prod(B,B))] :
      ( ( relcomp(B,B,B,A3,B2) = bot_bot(set(product_prod(B,B))) )
     => ( ( relcomp(B,B,B,A3,C2) = bot_bot(set(product_prod(B,B))) )
       => ( relcomp(B,B,B,A3,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),B2),C2)) = bot_bot(set(product_prod(B,B))) ) ) ) ).

% union_comp_emptyR
tff(fact_1745_relcomp__subset__Sigma,axiom,
    ! [C: $tType,B: $tType,D: $tType,R2: set(product_prod(B,C)),A3: set(B),B2: set(C),S2: set(product_prod(C,D)),C2: set(D)] :
      ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),R2),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))
     => ( aa(set(product_prod(C,D)),$o,aa(set(product_prod(C,D)),fun(set(product_prod(C,D)),$o),ord_less_eq(set(product_prod(C,D))),S2),product_Sigma(C,D,B2,aTP_Lamp_eq(set(D),fun(C,set(D)),C2)))
       => aa(set(product_prod(B,D)),$o,aa(set(product_prod(B,D)),fun(set(product_prod(B,D)),$o),ord_less_eq(set(product_prod(B,D))),relcomp(B,C,D,R2,S2)),product_Sigma(B,D,A3,aTP_Lamp_ly(set(D),fun(B,set(D)),C2))) ) ) ).

% relcomp_subset_Sigma
tff(fact_1746_relcomp__UNION__distrib,axiom,
    ! [D: $tType,C: $tType,B: $tType,E: $tType,S2: set(product_prod(B,D)),R2: fun(E,set(product_prod(D,C))),I: set(E)] : ( relcomp(B,D,C,S2,aa(set(set(product_prod(D,C))),set(product_prod(D,C)),complete_Sup_Sup(set(product_prod(D,C))),aa(set(E),set(set(product_prod(D,C))),image2(E,set(product_prod(D,C)),R2),I))) = aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(E),set(set(product_prod(B,C))),image2(E,set(product_prod(B,C)),aa(fun(E,set(product_prod(D,C))),fun(E,set(product_prod(B,C))),aTP_Lamp_lz(set(product_prod(B,D)),fun(fun(E,set(product_prod(D,C))),fun(E,set(product_prod(B,C)))),S2),R2)),I)) ) ).

% relcomp_UNION_distrib
tff(fact_1747_relcomp__UNION__distrib2,axiom,
    ! [D: $tType,C: $tType,B: $tType,E: $tType,R2: fun(E,set(product_prod(B,D))),I: set(E),S2: set(product_prod(D,C))] : ( relcomp(B,D,C,aa(set(set(product_prod(B,D))),set(product_prod(B,D)),complete_Sup_Sup(set(product_prod(B,D))),aa(set(E),set(set(product_prod(B,D))),image2(E,set(product_prod(B,D)),R2),I)),S2) = aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(E),set(set(product_prod(B,C))),image2(E,set(product_prod(B,C)),aa(set(product_prod(D,C)),fun(E,set(product_prod(B,C))),aTP_Lamp_ma(fun(E,set(product_prod(B,D))),fun(set(product_prod(D,C)),fun(E,set(product_prod(B,C)))),R2),S2)),I)) ) ).

% relcomp_UNION_distrib2
tff(fact_1748_sum_Odistrib__triv_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [I: set(B),G: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),I)
         => ( groups1027152243600224163dd_sum(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_mb(fun(B,C),fun(fun(B,C),fun(B,C)),G),H2),I) = aa(C,C,aa(C,fun(C,C),plus_plus(C),groups1027152243600224163dd_sum(B,C,G,I)),groups1027152243600224163dd_sum(B,C,H2,I)) ) ) ) ).

% sum.distrib_triv'
tff(fact_1749_trancl__Int__subset,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),S2: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R2),S2)
     => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),relcomp(B,B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),transitive_trancl(B,R2)),S2),R2)),S2)
       => aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),transitive_trancl(B,R2)),S2) ) ) ).

% trancl_Int_subset
tff(fact_1750_relcomp__unfold,axiom,
    ! [B: $tType,C: $tType,D: $tType,R2: set(product_prod(B,D)),S2: set(product_prod(D,C))] : ( relcomp(B,D,C,R2,S2) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(set(product_prod(D,C)),fun(B,fun(C,$o)),aTP_Lamp_mc(set(product_prod(B,D)),fun(set(product_prod(D,C)),fun(B,fun(C,$o))),R2),S2))) ) ).

% relcomp_unfold
tff(fact_1751_sum_Odistrib_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [I: set(B),G: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_lf(set(B),fun(fun(B,C),fun(B,$o)),I),G)))
         => ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_lf(set(B),fun(fun(B,C),fun(B,$o)),I),H2)))
           => ( groups1027152243600224163dd_sum(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_mb(fun(B,C),fun(fun(B,C),fun(B,C)),G),H2),I) = aa(C,C,aa(C,fun(C,C),plus_plus(C),groups1027152243600224163dd_sum(B,C,G,I)),groups1027152243600224163dd_sum(B,C,H2,I)) ) ) ) ) ).

% sum.distrib'
tff(fact_1752_rtrancl__Int__subset,axiom,
    ! [B: $tType,S2: set(product_prod(B,B)),R2: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),id2(B)),S2)
     => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),relcomp(B,B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),transitive_rtrancl(B,R2)),S2),R2)),S2)
       => aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),transitive_rtrancl(B,R2)),S2) ) ) ).

% rtrancl_Int_subset
tff(fact_1753_relcomp__fold,axiom,
    ! [D: $tType,C: $tType,B: $tType,R: set(product_prod(B,C)),S: set(product_prod(C,D))] :
      ( aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),R)
     => ( aa(set(product_prod(C,D)),$o,finite_finite2(product_prod(C,D)),S)
       => ( relcomp(B,C,D,R,S) = finite_fold(product_prod(B,C),set(product_prod(B,D)),aa(fun(B,fun(C,fun(set(product_prod(B,D)),set(product_prod(B,D))))),fun(product_prod(B,C),fun(set(product_prod(B,D)),set(product_prod(B,D)))),product_case_prod(B,C,fun(set(product_prod(B,D)),set(product_prod(B,D)))),aTP_Lamp_me(set(product_prod(C,D)),fun(B,fun(C,fun(set(product_prod(B,D)),set(product_prod(B,D))))),S)),bot_bot(set(product_prod(B,D))),R) ) ) ) ).

% relcomp_fold
tff(fact_1754_Image__fold,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S: set(B)] :
      ( aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),R)
     => ( aa(set(B),set(C),image(B,C,R),S) = finite_fold(product_prod(B,C),set(C),aa(fun(B,fun(C,fun(set(C),set(C)))),fun(product_prod(B,C),fun(set(C),set(C))),product_case_prod(B,C,fun(set(C),set(C))),aTP_Lamp_ln(set(B),fun(B,fun(C,fun(set(C),set(C)))),S)),bot_bot(set(C)),R) ) ) ).

% Image_fold
tff(fact_1755_inter__Set__filter,axiom,
    ! [B: $tType,B2: set(B),A3: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),B2)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = filter3(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3),B2) ) ) ).

% inter_Set_filter
tff(fact_1756_insert__relcomp__fold,axiom,
    ! [D: $tType,C: $tType,B: $tType,S: set(product_prod(B,C)),X2: product_prod(D,B),R: set(product_prod(D,B))] :
      ( aa(set(product_prod(B,C)),$o,finite_finite2(product_prod(B,C)),S)
     => ( relcomp(D,B,C,aa(set(product_prod(D,B)),set(product_prod(D,B)),insert(product_prod(D,B),X2),R),S) = finite_fold(product_prod(B,C),set(product_prod(D,C)),aa(fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),fun(product_prod(B,C),fun(set(product_prod(D,C)),set(product_prod(D,C)))),product_case_prod(B,C,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aTP_Lamp_lv(product_prod(D,B),fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),X2)),relcomp(D,B,C,R,S),S) ) ) ).

% insert_relcomp_fold
tff(fact_1757_comp__fun__commute__on_Ofold__rec,axiom,
    ! [C: $tType,B: $tType,S: set(B),F2: fun(B,fun(C,C)),A3: set(B),X2: B,Z2: C] :
      ( finite4664212375090638736ute_on(B,C,S,F2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S)
       => ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,member(B,X2),A3)
           => ( finite_fold(B,C,F2,Z2,A3) = aa(C,C,aa(B,fun(C,C),F2,X2),finite_fold(B,C,F2,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
tff(fact_1758_min__ext__compat,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),S: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),relcomp(B,B,B,R,S)),R)
     => aa(set(product_prod(set(B),set(B))),$o,aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(B),set(B))),$o),ord_less_eq(set(product_prod(set(B),set(B)))),relcomp(set(B),set(B),set(B),min_ext(B,R),aa(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B))),aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B)))),sup_sup(set(product_prod(set(B),set(B)))),min_ext(B,S)),aa(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B))),insert(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),bot_bot(set(B))),bot_bot(set(B)))),bot_bot(set(product_prod(set(B),set(B)))))))),min_ext(B,R)) ) ).

% min_ext_compat
tff(fact_1759_arg__min__least,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [S: set(B),Y: B,F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( ( S != bot_bot(set(B)) )
           => ( aa(set(B),$o,member(B,Y),S)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,lattic7623131987881927897min_on(B,C,F2,S))),aa(B,C,F2,Y)) ) ) ) ) ).

% arg_min_least
tff(fact_1760_prod_Oinsert_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [I: set(B),P3: fun(B,C),I2: B] :
          ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_ld(set(B),fun(fun(B,C),fun(B,$o)),I),P3)))
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),P3),aa(set(B),set(B),insert(B,I2),I))
            = $ite(aa(set(B),$o,member(B,I2),I),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),P3),I),aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,P3,I2)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),P3),I))) ) ) ) ).

% prod.insert'
tff(fact_1761_finite__def,axiom,
    ! [B: $tType] : ( finite_finite2(B) = complete_lattice_lfp(fun(set(B),$o),aTP_Lamp_lc(fun(set(B),$o),fun(set(B),$o))) ) ).

% finite_def
tff(fact_1762_INF__principal__finite,axiom,
    ! [C: $tType,B: $tType,X5: set(B),F2: fun(B,set(C))] :
      ( aa(set(B),$o,finite_finite2(B),X5)
     => ( aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),aTP_Lamp_mf(fun(B,set(C)),fun(B,filter(C)),F2)),X5)) = principal(C,aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),F2),X5))) ) ) ).

% INF_principal_finite
tff(fact_1763_comp__fun__commute__on_Ofold__graph__insertE__aux,axiom,
    ! [B: $tType,C: $tType,S: set(B),F2: fun(B,fun(C,C)),A3: set(B),Z2: C,Y: C,A4: B] :
      ( finite4664212375090638736ute_on(B,C,S,F2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S)
       => ( aa(C,$o,finite_fold_graph(B,C,F2,Z2,A3),Y)
         => ( aa(set(B),$o,member(B,A4),A3)
           => ? [Y6: C] :
                ( ( Y = aa(C,C,aa(B,fun(C,C),F2,A4),Y6) )
                & aa(C,$o,finite_fold_graph(B,C,F2,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B))))),Y6) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE_aux
tff(fact_1764_relImage__Gr,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,B)),A3: set(B),F2: fun(B,C)] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))
     => ( bNF_Gr4221423524335903396lImage(B,C,R,F2) = relcomp(C,B,C,converse(B,C,bNF_Gr(B,C,A3,F2)),relcomp(B,B,C,R,bNF_Gr(B,C,A3,F2))) ) ) ).

% relImage_Gr
tff(fact_1765_converse__empty,axiom,
    ! [C: $tType,B: $tType] : ( converse(C,B,bot_bot(set(product_prod(C,B)))) = bot_bot(set(product_prod(B,C))) ) ).

% converse_empty
tff(fact_1766_pair__set__inverse,axiom,
    ! [B: $tType,C: $tType,Pa: fun(C,fun(B,$o))] : ( converse(C,B,aa(fun(product_prod(C,B),$o),set(product_prod(C,B)),collect(product_prod(C,B)),aa(fun(C,fun(B,$o)),fun(product_prod(C,B),$o),product_case_prod(C,B,$o),Pa))) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_km(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Pa))) ) ).

% pair_set_inverse
tff(fact_1767_prod_Oempty_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [P3: fun(C,B)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups1962203154675924110t_prod(C,B),P3),bot_bot(set(C))) = one_one(B) ) ) ).

% prod.empty'
tff(fact_1768_inf__principal,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),principal(B,A3)),principal(B,B2)) = principal(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ).

% inf_principal
tff(fact_1769_SUP__principal,axiom,
    ! [B: $tType,C: $tType,A3: fun(C,set(B)),I: set(C)] : ( aa(set(filter(B)),filter(B),complete_Sup_Sup(filter(B)),aa(set(C),set(filter(B)),image2(C,filter(B),aTP_Lamp_mg(fun(C,set(B)),fun(C,filter(B)),A3)),I)) = principal(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I))) ) ).

% SUP_principal
tff(fact_1770_lfp__const,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [T3: B] : ( complete_lattice_lfp(B,aTP_Lamp_mh(B,fun(B,B),T3)) = T3 ) ) ).

% lfp_const
tff(fact_1771_converse__Int,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(C,B)),S2: set(product_prod(C,B))] : ( converse(C,B,aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),set(product_prod(C,B))),inf_inf(set(product_prod(C,B))),R2),S2)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),converse(C,B,R2)),converse(C,B,S2)) ) ).

% converse_Int
tff(fact_1772_fold__graph_OemptyI,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(C,C)),Z2: C] : aa(C,$o,finite_fold_graph(B,C,F2,Z2,bot_bot(set(B))),Z2) ).

% fold_graph.emptyI
tff(fact_1773_empty__fold__graphE,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(C,C)),Z2: C,X2: C] :
      ( aa(C,$o,finite_fold_graph(B,C,F2,Z2,bot_bot(set(B))),X2)
     => ( X2 = Z2 ) ) ).

% empty_fold_graphE
tff(fact_1774_converse__Times,axiom,
    ! [B: $tType,C: $tType,A3: set(C),B2: set(B)] : ( converse(C,B,product_Sigma(C,B,A3,aTP_Lamp_bv(set(B),fun(C,set(B)),B2))) = product_Sigma(B,C,B2,aTP_Lamp_bq(set(C),fun(B,set(C)),A3)) ) ).

% converse_Times
tff(fact_1775_lfp__lfp,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(B,fun(B,B))] :
          ( ! [X: B,Y2: B,W: B,Z3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y2)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),W),Z3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),F2,X),W)),aa(B,B,aa(B,fun(B,B),F2,Y2),Z3)) ) )
         => ( complete_lattice_lfp(B,aTP_Lamp_mi(fun(B,fun(B,B)),fun(B,B),F2)) = complete_lattice_lfp(B,aTP_Lamp_mj(fun(B,fun(B,B)),fun(B,B),F2)) ) ) ) ).

% lfp_lfp
tff(fact_1776_prod_Onon__neutral_H,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(C,B),I: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups1962203154675924110t_prod(C,B),G),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aTP_Lamp_mk(fun(C,B),fun(set(C),fun(C,$o)),G),I))) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups1962203154675924110t_prod(C,B),G),I) ) ) ).

% prod.non_neutral'
tff(fact_1777_lfp__rolling,axiom,
    ! [B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(C)
        & comple6319245703460814977attice(B) )
     => ! [G: fun(B,C),F2: fun(C,B)] :
          ( order_mono(B,C,G)
         => ( order_mono(C,B,F2)
           => ( aa(B,C,G,complete_lattice_lfp(B,aa(fun(C,B),fun(B,B),aTP_Lamp_ml(fun(B,C),fun(fun(C,B),fun(B,B)),G),F2))) = complete_lattice_lfp(C,aa(fun(C,B),fun(C,C),aTP_Lamp_mm(fun(B,C),fun(fun(C,B),fun(C,C)),G),F2)) ) ) ) ) ).

% lfp_rolling
tff(fact_1778_converse__unfold,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(C,B))] : ( converse(C,B,R2) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_mn(set(product_prod(C,B)),fun(B,fun(C,$o)),R2))) ) ).

% converse_unfold
tff(fact_1779_fold__graph_Osimps,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(C,C)),Z2: C,A13: set(B),A23: C] :
      ( aa(C,$o,finite_fold_graph(B,C,F2,Z2,A13),A23)
    <=> ( ( ( A13 = bot_bot(set(B)) )
          & ( A23 = Z2 ) )
        | ? [X3: B,A12: set(B),Y4: C] :
            ( ( A13 = aa(set(B),set(B),insert(B,X3),A12) )
            & ( A23 = aa(C,C,aa(B,fun(C,C),F2,X3),Y4) )
            & ~ aa(set(B),$o,member(B,X3),A12)
            & aa(C,$o,finite_fold_graph(B,C,F2,Z2,A12),Y4) ) ) ) ).

% fold_graph.simps
tff(fact_1780_fold__graph_Ocases,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(C,C)),Z2: C,A13: set(B),A23: C] :
      ( aa(C,$o,finite_fold_graph(B,C,F2,Z2,A13),A23)
     => ( ( ( A13 = bot_bot(set(B)) )
         => ( A23 != Z2 ) )
       => ~ ! [X: B,A11: set(B)] :
              ( ( A13 = aa(set(B),set(B),insert(B,X),A11) )
             => ! [Y2: C] :
                  ( ( A23 = aa(C,C,aa(B,fun(C,C),F2,X),Y2) )
                 => ( ~ aa(set(B),$o,member(B,X),A11)
                   => ~ aa(C,$o,finite_fold_graph(B,C,F2,Z2,A11),Y2) ) ) ) ) ) ).

% fold_graph.cases
tff(fact_1781_principal__eq__bot__iff,axiom,
    ! [B: $tType,X5: set(B)] :
      ( ( principal(B,X5) = bot_bot(filter(B)) )
    <=> ( X5 = bot_bot(set(B)) ) ) ).

% principal_eq_bot_iff
tff(fact_1782_bot__eq__principal__empty,axiom,
    ! [B: $tType] : ( bot_bot(filter(B)) = principal(B,bot_bot(set(B))) ) ).

% bot_eq_principal_empty
tff(fact_1783_converse__UNION,axiom,
    ! [C: $tType,B: $tType,D: $tType,R2: fun(D,set(product_prod(C,B))),S: set(D)] : ( converse(C,B,aa(set(set(product_prod(C,B))),set(product_prod(C,B)),complete_Sup_Sup(set(product_prod(C,B))),aa(set(D),set(set(product_prod(C,B))),image2(D,set(product_prod(C,B)),R2),S))) = aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(D),set(set(product_prod(B,C))),image2(D,set(product_prod(B,C)),aTP_Lamp_mo(fun(D,set(product_prod(C,B))),fun(D,set(product_prod(B,C))),R2)),S)) ) ).

% converse_UNION
tff(fact_1784_converse__INTER,axiom,
    ! [C: $tType,B: $tType,D: $tType,R2: fun(D,set(product_prod(C,B))),S: set(D)] : ( converse(C,B,aa(set(set(product_prod(C,B))),set(product_prod(C,B)),complete_Inf_Inf(set(product_prod(C,B))),aa(set(D),set(set(product_prod(C,B))),image2(D,set(product_prod(C,B)),R2),S))) = aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Inf_Inf(set(product_prod(B,C))),aa(set(D),set(set(product_prod(B,C))),image2(D,set(product_prod(B,C)),aTP_Lamp_mo(fun(D,set(product_prod(C,B))),fun(D,set(product_prod(B,C))),R2)),S)) ) ).

% converse_INTER
tff(fact_1785_lfp__def,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(B,B)] : ( complete_lattice_lfp(B,F2) = aa(set(B),B,complete_Inf_Inf(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_mp(fun(B,B),fun(B,$o),F2))) ) ) ).

% lfp_def
tff(fact_1786_prod_Odistrib__triv_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [I: set(B),G: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),I)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_mq(fun(B,C),fun(fun(B,C),fun(B,C)),G),H2)),I) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),G),I)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),H2),I)) ) ) ) ).

% prod.distrib_triv'
tff(fact_1787_def__lfp__induct,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: B,F2: fun(B,B),Pa: B] :
          ( ( A3 = complete_lattice_lfp(B,F2) )
         => ( order_mono(B,B,F2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,F2,aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Pa))),Pa)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Pa) ) ) ) ) ).

% def_lfp_induct
tff(fact_1788_lfp__induct,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(B,B),Pa: B] :
          ( order_mono(B,B,F2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,F2,aa(B,B,aa(B,fun(B,B),inf_inf(B),complete_lattice_lfp(B,F2)),Pa))),Pa)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),complete_lattice_lfp(B,F2)),Pa) ) ) ) ).

% lfp_induct
tff(fact_1789_prod_Omono__neutral__left_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S: set(B),T2: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S),T2)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S))
               => ( aa(B,C,G,X) = one_one(C) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),G),S) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),G),T2) ) ) ) ) ).

% prod.mono_neutral_left'
tff(fact_1790_prod_Omono__neutral__right_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S: set(B),T2: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S),T2)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S))
               => ( aa(B,C,G,X) = one_one(C) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),G),T2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),G),S) ) ) ) ) ).

% prod.mono_neutral_right'
tff(fact_1791_prod_Omono__neutral__cong__left_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S: set(B),T2: set(B),H2: fun(B,C),G: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S),T2)
         => ( ! [I3: B] :
                ( aa(set(B),$o,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S))
               => ( aa(B,C,H2,I3) = one_one(C) ) )
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),S)
                 => ( aa(B,C,G,X) = aa(B,C,H2,X) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),G),S) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),H2),T2) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
tff(fact_1792_prod_Omono__neutral__cong__right_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S: set(B),T2: set(B),G: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S),T2)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S))
               => ( aa(B,C,G,X) = one_one(C) ) )
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),S)
                 => ( aa(B,C,G,X) = aa(B,C,H2,X) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),G),T2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),H2),S) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
tff(fact_1793_prod_Odistrib_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [I: set(B),G: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_ld(set(B),fun(fun(B,C),fun(B,$o)),I),G)))
         => ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_ld(set(B),fun(fun(B,C),fun(B,$o)),I),H2)))
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_mq(fun(B,C),fun(fun(B,C),fun(B,C)),G),H2)),I) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),G),I)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),H2),I)) ) ) ) ) ).

% prod.distrib'
tff(fact_1794_Finite__Set_Ofold__def,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,fun(B,B)),Z2: B,A3: set(C)] :
      ( finite_fold(C,B,F2,Z2,A3)
      = $ite(aa(set(C),$o,finite_finite2(C),A3),the(B,finite_fold_graph(C,B,F2,Z2,A3)),Z2) ) ).

% Finite_Set.fold_def
tff(fact_1795_arg__min__if__finite_I1_J,axiom,
    ! [C: $tType,B: $tType] :
      ( order(C)
     => ! [S: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( ( S != bot_bot(set(B)) )
           => aa(set(B),$o,member(B,lattic7623131987881927897min_on(B,C,F2,S)),S) ) ) ) ).

% arg_min_if_finite(1)
tff(fact_1796_irrefl__tranclI,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),X2: B] :
      ( ( aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),converse(B,B,R2)),transitive_rtrancl(B,R2)) = bot_bot(set(product_prod(B,B))) )
     => ~ aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2)),transitive_trancl(B,R2)) ) ).

% irrefl_tranclI
tff(fact_1797_relInvImage__Gr,axiom,
    ! [B: $tType,C: $tType,R: set(product_prod(B,B)),B2: set(B),A3: set(C),F2: fun(C,B)] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R),product_Sigma(B,B,B2,aTP_Lamp_cr(set(B),fun(B,set(B)),B2)))
     => ( bNF_Gr7122648621184425601vImage(C,B,A3,R,F2) = relcomp(C,B,C,bNF_Gr(C,B,A3,F2),relcomp(B,B,C,R,converse(C,B,bNF_Gr(C,B,A3,F2)))) ) ) ).

% relInvImage_Gr
tff(fact_1798_max__ext__compat,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),S: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),relcomp(B,B,B,R,S)),R)
     => aa(set(product_prod(set(B),set(B))),$o,aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(B),set(B))),$o),ord_less_eq(set(product_prod(set(B),set(B)))),relcomp(set(B),set(B),set(B),max_ext(B,R),aa(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B))),aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B)))),sup_sup(set(product_prod(set(B),set(B)))),max_ext(B,S)),aa(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B))),insert(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),bot_bot(set(B))),bot_bot(set(B)))),bot_bot(set(product_prod(set(B),set(B)))))))),max_ext(B,R)) ) ).

% max_ext_compat
tff(fact_1799_trans__wf__iff,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( trans(B,R2)
     => ( wf(B,R2)
      <=> ! [A6: B] : wf(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,aa(set(B),set(B),image(B,B,converse(B,B,R2)),aa(set(B),set(B),insert(B,A6),bot_bot(set(B)))),aa(B,fun(B,set(B)),aTP_Lamp_mr(set(product_prod(B,B)),fun(B,fun(B,set(B))),R2),A6)))) ) ) ).

% trans_wf_iff
tff(fact_1800_Image__INT__eq,axiom,
    ! [C: $tType,B: $tType,D: $tType,R2: set(product_prod(C,B)),A3: set(D),B2: fun(D,set(C))] :
      ( single_valued(B,C,converse(C,B,R2))
     => ( ( A3 != bot_bot(set(D)) )
       => ( aa(set(C),set(B),image(C,B,R2),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B2),A3))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_jn(set(product_prod(C,B)),fun(fun(D,set(C)),fun(D,set(B))),R2),B2)),A3)) ) ) ) ).

% Image_INT_eq
tff(fact_1801_finite__subsets__at__top__finite,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( finite5375528669736107172at_top(B,A3) = principal(set(B),aa(set(set(B)),set(set(B)),insert(set(B),A3),bot_bot(set(set(B))))) ) ) ).

% finite_subsets_at_top_finite
tff(fact_1802_max__ext_Ocases,axiom,
    ! [B: $tType,A13: set(B),A23: set(B),R: set(product_prod(B,B))] :
      ( aa(set(product_prod(set(B),set(B))),$o,member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),A13),A23)),max_ext(B,R))
     => ~ ( aa(set(B),$o,finite_finite2(B),A13)
         => ( aa(set(B),$o,finite_finite2(B),A23)
           => ( ( A23 != bot_bot(set(B)) )
             => ~ ! [X4: B] :
                    ( aa(set(B),$o,member(B,X4),A13)
                   => ? [Xa4: B] :
                        ( aa(set(B),$o,member(B,Xa4),A23)
                        & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa4)),R) ) ) ) ) ) ) ).

% max_ext.cases
tff(fact_1803_max__ext_Osimps,axiom,
    ! [B: $tType,A13: set(B),A23: set(B),R: set(product_prod(B,B))] :
      ( aa(set(product_prod(set(B),set(B))),$o,member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),A13),A23)),max_ext(B,R))
    <=> ( aa(set(B),$o,finite_finite2(B),A13)
        & aa(set(B),$o,finite_finite2(B),A23)
        & ( A23 != bot_bot(set(B)) )
        & ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),A13)
           => ? [Xa2: B] :
                ( aa(set(B),$o,member(B,Xa2),A23)
                & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa2)),R) ) ) ) ) ).

% max_ext.simps
tff(fact_1804_finite__subsets__at__top__neq__bot,axiom,
    ! [B: $tType,A3: set(B)] : ( finite5375528669736107172at_top(B,A3) != bot_bot(filter(set(B))) ) ).

% finite_subsets_at_top_neq_bot
tff(fact_1805_trans__empty,axiom,
    ! [B: $tType] : trans(B,bot_bot(set(product_prod(B,B)))) ).

% trans_empty
tff(fact_1806_trans__Int,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),S2: set(product_prod(B,B))] :
      ( trans(B,R2)
     => ( trans(B,S2)
       => trans(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),S2)) ) ) ).

% trans_Int
tff(fact_1807_single__valued__empty,axiom,
    ! [C: $tType,B: $tType] : single_valued(B,C,bot_bot(set(product_prod(B,C)))) ).

% single_valued_empty
tff(fact_1808_single__valued__inter1,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S: set(product_prod(B,C))] :
      ( single_valued(B,C,R)
     => single_valued(B,C,aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),R),S)) ) ).

% single_valued_inter1
tff(fact_1809_single__valued__inter2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S: set(product_prod(B,C))] :
      ( single_valued(B,C,R)
     => single_valued(B,C,aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),S),R)) ) ).

% single_valued_inter2
tff(fact_1810_trans__Restr,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( trans(B,R2)
     => trans(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) ) ).

% trans_Restr
tff(fact_1811_lfp__induct__set,axiom,
    ! [B: $tType,A4: B,F2: fun(set(B),set(B)),Pa: fun(B,$o)] :
      ( aa(set(B),$o,member(B,A4),complete_lattice_lfp(set(B),F2))
     => ( order_mono(set(B),set(B),F2)
       => ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),aa(set(B),set(B),F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),complete_lattice_lfp(set(B),F2)),aa(fun(B,$o),set(B),collect(B),Pa))))
             => aa(B,$o,Pa,X) )
         => aa(B,$o,Pa,A4) ) ) ) ).

% lfp_induct_set
tff(fact_1812_def__lfp__induct__set,axiom,
    ! [B: $tType,A3: set(B),F2: fun(set(B),set(B)),A4: B,Pa: fun(B,$o)] :
      ( ( A3 = complete_lattice_lfp(set(B),F2) )
     => ( order_mono(set(B),set(B),F2)
       => ( aa(set(B),$o,member(B,A4),A3)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),aa(set(B),set(B),F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,$o),set(B),collect(B),Pa))))
               => aa(B,$o,Pa,X) )
           => aa(B,$o,Pa,A4) ) ) ) ) ).

% def_lfp_induct_set
tff(fact_1813_trans__singleton,axiom,
    ! [B: $tType,A4: B] : trans(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),A4)),bot_bot(set(product_prod(B,B))))) ).

% trans_singleton
tff(fact_1814_lfp__induct2,axiom,
    ! [B: $tType,C: $tType,A4: B,B3: C,F2: fun(set(product_prod(B,C)),set(product_prod(B,C))),Pa: fun(B,fun(C,$o))] :
      ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B3)),complete_lattice_lfp(set(product_prod(B,C)),F2))
     => ( order_mono(set(product_prod(B,C)),set(product_prod(B,C)),F2)
       => ( ! [A5: B,B4: C] :
              ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A5),B4)),aa(set(product_prod(B,C)),set(product_prod(B,C)),F2,aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),complete_lattice_lfp(set(product_prod(B,C)),F2)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Pa)))))
             => aa(C,$o,aa(B,fun(C,$o),Pa,A5),B4) )
         => aa(C,$o,aa(B,fun(C,$o),Pa,A4),B3) ) ) ) ).

% lfp_induct2
tff(fact_1815_Image__Int__eq,axiom,
    ! [B: $tType,C: $tType,R: set(product_prod(C,B)),A3: set(C),B2: set(C)] :
      ( single_valued(B,C,converse(C,B,R))
     => ( aa(set(C),set(B),image(C,B,R),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),image(C,B,R),A3)),aa(set(C),set(B),image(C,B,R),B2)) ) ) ).

% Image_Int_eq
tff(fact_1816_finite__subsets__at__top__def,axiom,
    ! [B: $tType,A3: set(B)] : ( finite5375528669736107172at_top(B,A3) = aa(set(filter(set(B))),filter(set(B)),complete_Inf_Inf(filter(set(B))),aa(set(set(B)),set(filter(set(B))),image2(set(B),filter(set(B)),aTP_Lamp_mt(set(B),fun(set(B),filter(set(B))),A3)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_mu(set(B),fun(set(B),$o),A3)))) ) ).

% finite_subsets_at_top_def
tff(fact_1817_max__ext_Omax__extI,axiom,
    ! [B: $tType,X5: set(B),Y3: set(B),R: set(product_prod(B,B))] :
      ( aa(set(B),$o,finite_finite2(B),X5)
     => ( aa(set(B),$o,finite_finite2(B),Y3)
       => ( ( Y3 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),X5)
               => ? [Xa3: B] :
                    ( aa(set(B),$o,member(B,Xa3),Y3)
                    & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Xa3)),R) ) )
           => aa(set(product_prod(set(B),set(B))),$o,member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),X5),Y3)),max_ext(B,R)) ) ) ) ) ).

% max_ext.max_extI
tff(fact_1818_max__extp__eq,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),X2: set(B),Y: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),max_extp(B,R2),X2),Y)
    <=> aa(set(product_prod(set(B),set(B))),$o,member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),X2),Y)),max_ext(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2)))) ) ).

% max_extp_eq
tff(fact_1819_max__extp__max__ext__eq,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),X4: set(B),Xa3: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),max_extp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R)),X4),Xa3)
    <=> aa(set(product_prod(set(B),set(B))),$o,member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),X4),Xa3)),max_ext(B,R)) ) ).

% max_extp_max_ext_eq
tff(fact_1820_wf__finite__segments,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( irrefl(B,R2)
     => ( trans(B,R2)
       => ( ! [X: B] : aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_mv(set(product_prod(B,B)),fun(B,fun(B,$o)),R2),X)))
         => wf(B,R2) ) ) ) ).

% wf_finite_segments
tff(fact_1821_filterlim__base__iff,axiom,
    ! [B: $tType,C: $tType,D: $tType,E: $tType,I: set(B),F: fun(B,set(C)),F2: fun(C,D),G3: fun(E,set(D)),J: set(E)] :
      ( ( I != bot_bot(set(B)) )
     => ( ! [I3: B] :
            ( aa(set(B),$o,member(B,I3),I)
           => ! [J3: B] :
                ( aa(set(B),$o,member(B,J3),I)
               => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),F,I3)),aa(B,set(C),F,J3))
                  | aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),F,J3)),aa(B,set(C),F,I3)) ) ) )
       => ( filterlim(C,D,F2,aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(E),set(filter(D)),image2(E,filter(D),aTP_Lamp_mw(fun(E,set(D)),fun(E,filter(D)),G3)),J)),aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),aTP_Lamp_mf(fun(B,set(C)),fun(B,filter(C)),F)),I)))
        <=> ! [X3: E] :
              ( aa(set(E),$o,member(E,X3),J)
             => ? [Xa2: B] :
                  ( aa(set(B),$o,member(B,Xa2),I)
                  & ! [Xb2: C] :
                      ( aa(set(C),$o,member(C,Xb2),aa(B,set(C),F,Xa2))
                     => aa(set(D),$o,member(D,aa(C,D,F2,Xb2)),aa(E,set(D),G3,X3)) ) ) ) ) ) ) ).

% filterlim_base_iff
tff(fact_1822_arg__min__inj__eq,axiom,
    ! [C: $tType,B: $tType] :
      ( order(C)
     => ! [F2: fun(B,C),Pa: fun(B,$o),A4: B] :
          ( inj_on(B,C,F2,aa(fun(B,$o),set(B),collect(B),Pa))
         => ( aa(B,$o,Pa,A4)
           => ( ! [Y2: B] :
                  ( aa(B,$o,Pa,Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,A4)),aa(B,C,F2,Y2)) )
             => ( lattices_ord_arg_min(B,C,F2,Pa) = A4 ) ) ) ) ) ).

% arg_min_inj_eq
tff(fact_1823_Sup__fin_Oremove,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,member(B,X2),A3)
           => ( lattic5882676163264333800up_fin(B,A3)
              = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),lattic5882676163264333800up_fin(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))))) ) ) ) ) ).

% Sup_fin.remove
tff(fact_1824_Sup__fin_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( lattic5882676163264333800up_fin(B,aa(set(B),set(B),insert(B,X2),A3))
            = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),lattic5882676163264333800up_fin(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))))) ) ) ) ).

% Sup_fin.insert_remove
tff(fact_1825_Sup__fin_Osingleton,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B] : ( lattic5882676163264333800up_fin(B,aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = X2 ) ) ).

% Sup_fin.singleton
tff(fact_1826_inf__Sup__absorb,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [A3: set(B),A4: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,member(B,A4),A3)
           => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),lattic5882676163264333800up_fin(B,A3)) = A4 ) ) ) ) ).

% inf_Sup_absorb
tff(fact_1827_Sup__fin_Oinsert,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( lattic5882676163264333800up_fin(B,aa(set(B),set(B),insert(B,X2),A3)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),lattic5882676163264333800up_fin(B,A3)) ) ) ) ) ).

% Sup_fin.insert
tff(fact_1828_filterlim__ident,axiom,
    ! [B: $tType,F: filter(B)] : filterlim(B,B,aTP_Lamp_bk(B,B),F,F) ).

% filterlim_ident
tff(fact_1829_filterlim__compose,axiom,
    ! [C: $tType,B: $tType,D: $tType,G: fun(B,C),F32: filter(C),F23: filter(B),F2: fun(D,B),F12: filter(D)] :
      ( filterlim(B,C,G,F32,F23)
     => ( filterlim(D,B,F2,F23,F12)
       => filterlim(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_mx(fun(B,C),fun(fun(D,B),fun(D,C)),G),F2),F32,F12) ) ) ).

% filterlim_compose
tff(fact_1830_filterlim__inf,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),F23: filter(C),F32: filter(C),F12: filter(B)] :
      ( filterlim(B,C,F2,aa(filter(C),filter(C),aa(filter(C),fun(filter(C),filter(C)),inf_inf(filter(C)),F23),F32),F12)
    <=> ( filterlim(B,C,F2,F23,F12)
        & filterlim(B,C,F2,F32,F12) ) ) ).

% filterlim_inf
tff(fact_1831_filterlim__INF,axiom,
    ! [D: $tType,C: $tType,B: $tType,F2: fun(B,C),G3: fun(D,filter(C)),B2: set(D),F: filter(B)] :
      ( filterlim(B,C,F2,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(D),set(filter(C)),image2(D,filter(C),G3),B2)),F)
    <=> ! [X3: D] :
          ( aa(set(D),$o,member(D,X3),B2)
         => filterlim(B,C,F2,aa(D,filter(C),G3,X3),F) ) ) ).

% filterlim_INF
tff(fact_1832_filterlim__INF_H,axiom,
    ! [D: $tType,C: $tType,B: $tType,X2: B,A3: set(B),F2: fun(C,D),F: filter(D),G3: fun(B,filter(C))] :
      ( aa(set(B),$o,member(B,X2),A3)
     => ( filterlim(C,D,F2,F,aa(B,filter(C),G3,X2))
       => filterlim(C,D,F2,F,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),G3),A3))) ) ) ).

% filterlim_INF'
tff(fact_1833_filterlim__If,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),G3: filter(C),F: filter(B),Pa: fun(B,$o),G: fun(B,C)] :
      ( filterlim(B,C,F2,G3,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F),principal(B,aa(fun(B,$o),set(B),collect(B),Pa))))
     => ( filterlim(B,C,G,G3,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F),principal(B,aa(fun(B,$o),set(B),collect(B),aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa)))))
       => filterlim(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,$o),fun(fun(B,C),fun(B,C)),aTP_Lamp_my(fun(B,C),fun(fun(B,$o),fun(fun(B,C),fun(B,C))),F2),Pa),G),G3,F) ) ) ).

% filterlim_If
tff(fact_1834_Sup__fin_OboundedE,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic5882676163264333800up_fin(B,A3)),X2)
             => ! [A14: B] :
                  ( aa(set(B),$o,member(B,A14),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A14),X2) ) ) ) ) ) ).

% Sup_fin.boundedE
tff(fact_1835_Sup__fin_OboundedI,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [A5: B] :
                  ( aa(set(B),$o,member(B,A5),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A5),X2) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic5882676163264333800up_fin(B,A3)),X2) ) ) ) ) ).

% Sup_fin.boundedI
tff(fact_1836_Sup__fin_Obounded__iff,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic5882676163264333800up_fin(B,A3)),X2)
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),X2) ) ) ) ) ) ).

% Sup_fin.bounded_iff
tff(fact_1837_Sup__fin__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( lattic5882676163264333800up_fin(B,A3) = aa(set(B),B,complete_Sup_Sup(B),A3) ) ) ) ) ).

% Sup_fin_Sup
tff(fact_1838_cSup__eq__Sup__fin,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X5: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),X5)
         => ( ( X5 != bot_bot(set(B)) )
           => ( aa(set(B),B,complete_Sup_Sup(B),X5) = lattic5882676163264333800up_fin(B,X5) ) ) ) ) ).

% cSup_eq_Sup_fin
tff(fact_1839_filterlim__base,axiom,
    ! [C: $tType,B: $tType,F10: $tType,E: $tType,D: $tType,J: set(B),I2: fun(B,D),I: set(D),F: fun(D,set(E)),F2: fun(E,F10),G3: fun(B,set(F10))] :
      ( ! [M3: B,X: C] :
          ( aa(set(B),$o,member(B,M3),J)
         => aa(set(D),$o,member(D,aa(B,D,I2,M3)),I) )
     => ( ! [M3: B,X: E] :
            ( aa(set(B),$o,member(B,M3),J)
           => ( aa(set(E),$o,member(E,X),aa(D,set(E),F,aa(B,D,I2,M3)))
             => aa(set(F10),$o,member(F10,aa(E,F10,F2,X)),aa(B,set(F10),G3,M3)) ) )
       => filterlim(E,F10,F2,aa(set(filter(F10)),filter(F10),complete_Inf_Inf(filter(F10)),aa(set(B),set(filter(F10)),image2(B,filter(F10),aTP_Lamp_mz(fun(B,set(F10)),fun(B,filter(F10)),G3)),J)),aa(set(filter(E)),filter(E),complete_Inf_Inf(filter(E)),aa(set(D),set(filter(E)),image2(D,filter(E),aTP_Lamp_na(fun(D,set(E)),fun(D,filter(E)),F)),I))) ) ) ).

% filterlim_base
tff(fact_1840_Sup__fin_Osubset__imp,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic5882676163264333800up_fin(B,A3)),lattic5882676163264333800up_fin(B,B2)) ) ) ) ) ).

% Sup_fin.subset_imp
tff(fact_1841_Sup__fin_Ohom__commute,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [H2: fun(B,B),N3: set(B)] :
          ( ! [X: B,Y2: B] : ( aa(B,B,H2,aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,H2,X)),aa(B,B,H2,Y2)) )
         => ( aa(set(B),$o,finite_finite2(B),N3)
           => ( ( N3 != bot_bot(set(B)) )
             => ( aa(B,B,H2,lattic5882676163264333800up_fin(B,N3)) = lattic5882676163264333800up_fin(B,aa(set(B),set(B),image2(B,B,H2),N3)) ) ) ) ) ) ).

% Sup_fin.hom_commute
tff(fact_1842_Sup__fin_Osubset,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( B2 != bot_bot(set(B)) )
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A3)
             => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),lattic5882676163264333800up_fin(B,B2)),lattic5882676163264333800up_fin(B,A3)) = lattic5882676163264333800up_fin(B,A3) ) ) ) ) ) ).

% Sup_fin.subset
tff(fact_1843_Sup__fin_Oinsert__not__elem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ~ aa(set(B),$o,member(B,X2),A3)
           => ( ( A3 != bot_bot(set(B)) )
             => ( lattic5882676163264333800up_fin(B,aa(set(B),set(B),insert(B,X2),A3)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),lattic5882676163264333800up_fin(B,A3)) ) ) ) ) ) ).

% Sup_fin.insert_not_elem
tff(fact_1844_Sup__fin_Oclosed,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [X: B,Y2: B] : aa(set(B),$o,member(B,aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y2)),aa(set(B),set(B),insert(B,X),aa(set(B),set(B),insert(B,Y2),bot_bot(set(B)))))
             => aa(set(B),$o,member(B,lattic5882676163264333800up_fin(B,A3)),A3) ) ) ) ) ).

% Sup_fin.closed
tff(fact_1845_Sup__fin_Ounion,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( lattic5882676163264333800up_fin(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),lattic5882676163264333800up_fin(B,A3)),lattic5882676163264333800up_fin(B,B2)) ) ) ) ) ) ) ).

% Sup_fin.union
tff(fact_1846_inf__Sup1__distrib,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),lattic5882676163264333800up_fin(B,A3)) = lattic5882676163264333800up_fin(B,aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_nb(set(B),fun(B,fun(B,$o)),A3),X2))) ) ) ) ) ).

% inf_Sup1_distrib
tff(fact_1847_inf__Sup2__distrib,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),lattic5882676163264333800up_fin(B,A3)),lattic5882676163264333800up_fin(B,B2)) = lattic5882676163264333800up_fin(B,aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_nc(set(B),fun(set(B),fun(B,$o)),A3),B2))) ) ) ) ) ) ) ).

% inf_Sup2_distrib
tff(fact_1848_arg__min__on__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [F2: fun(B,C),S: set(B)] : ( lattic7623131987881927897min_on(B,C,F2,S) = lattices_ord_arg_min(B,C,F2,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),S)) ) ) ).

% arg_min_on_def
tff(fact_1849_max__ext__def,axiom,
    ! [B: $tType,X4: set(product_prod(B,B))] : ( max_ext(B,X4) = aa(fun(product_prod(set(B),set(B)),$o),set(product_prod(set(B),set(B))),collect(product_prod(set(B),set(B))),aa(fun(set(B),fun(set(B),$o)),fun(product_prod(set(B),set(B)),$o),product_case_prod(set(B),set(B),$o),max_extp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),X4)))) ) ).

% max_ext_def
tff(fact_1850_Inf__fin_Oremove,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,member(B,X2),A3)
           => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)
              = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))))) ) ) ) ) ).

% Inf_fin.remove
tff(fact_1851_Inf__fin_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),insert(B,X2),A3))
            = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))))) ) ) ) ).

% Inf_fin.insert_remove
tff(fact_1852_Inf__fin_Oinsert,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),insert(B,X2),A3)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)) ) ) ) ) ).

% Inf_fin.insert
tff(fact_1853_eventually__INF__base,axiom,
    ! [C: $tType,B: $tType,B2: set(B),F: fun(B,filter(C)),Pa: fun(C,$o)] :
      ( ( B2 != bot_bot(set(B)) )
     => ( ! [A5: B] :
            ( aa(set(B),$o,member(B,A5),B2)
           => ! [B4: B] :
                ( aa(set(B),$o,member(B,B4),B2)
               => ? [X4: B] :
                    ( aa(set(B),$o,member(B,X4),B2)
                    & aa(filter(C),$o,aa(filter(C),fun(filter(C),$o),ord_less_eq(filter(C)),aa(B,filter(C),F,X4)),aa(filter(C),filter(C),aa(filter(C),fun(filter(C),filter(C)),inf_inf(filter(C)),aa(B,filter(C),F,A5)),aa(B,filter(C),F,B4))) ) ) )
       => ( eventually(C,Pa,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),F),B2)))
        <=> ? [X3: B] :
              ( aa(set(B),$o,member(B,X3),B2)
              & eventually(C,Pa,aa(B,filter(C),F,X3)) ) ) ) ) ).

% eventually_INF_base
tff(fact_1854_coinduct3__lemma,axiom,
    ! [B: $tType,X5: set(B),F2: fun(set(B),set(B))] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X5),aa(set(B),set(B),F2,complete_lattice_lfp(set(B),aa(fun(set(B),set(B)),fun(set(B),set(B)),aTP_Lamp_nd(set(B),fun(fun(set(B),set(B)),fun(set(B),set(B))),X5),F2))))
     => ( order_mono(set(B),set(B),F2)
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),complete_lattice_lfp(set(B),aa(fun(set(B),set(B)),fun(set(B),set(B)),aTP_Lamp_nd(set(B),fun(fun(set(B),set(B)),fun(set(B),set(B))),X5),F2))),aa(set(B),set(B),F2,complete_lattice_lfp(set(B),aa(fun(set(B),set(B)),fun(set(B),set(B)),aTP_Lamp_nd(set(B),fun(fun(set(B),set(B)),fun(set(B),set(B))),X5),F2)))) ) ) ).

% coinduct3_lemma
tff(fact_1855_def__coinduct3,axiom,
    ! [B: $tType,A3: set(B),F2: fun(set(B),set(B)),A4: B,X5: set(B)] :
      ( ( A3 = complete_lattice_gfp(set(B),F2) )
     => ( order_mono(set(B),set(B),F2)
       => ( aa(set(B),$o,member(B,A4),X5)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X5),aa(set(B),set(B),F2,complete_lattice_lfp(set(B),aa(set(B),fun(set(B),set(B)),aa(fun(set(B),set(B)),fun(set(B),fun(set(B),set(B))),aTP_Lamp_ne(set(B),fun(fun(set(B),set(B)),fun(set(B),fun(set(B),set(B)))),A3),F2),X5))))
           => aa(set(B),$o,member(B,A4),A3) ) ) ) ) ).

% def_coinduct3
tff(fact_1856_coinduct3,axiom,
    ! [B: $tType,F2: fun(set(B),set(B)),A4: B,X5: set(B)] :
      ( order_mono(set(B),set(B),F2)
     => ( aa(set(B),$o,member(B,A4),X5)
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X5),aa(set(B),set(B),F2,complete_lattice_lfp(set(B),aa(set(B),fun(set(B),set(B)),aTP_Lamp_nf(fun(set(B),set(B)),fun(set(B),fun(set(B),set(B))),F2),X5))))
         => aa(set(B),$o,member(B,A4),complete_lattice_gfp(set(B),F2)) ) ) ) ).

% coinduct3
tff(fact_1857_eventually__const,axiom,
    ! [B: $tType,F: filter(B),Pa: $o] :
      ( ( F != bot_bot(filter(B)) )
     => ( eventually(B,aTP_Lamp_an($o,fun(B,$o),Pa),F)
      <=> (Pa) ) ) ).

% eventually_const
tff(fact_1858_Inf__fin_Osingleton,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B] : ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = X2 ) ) ).

% Inf_fin.singleton
tff(fact_1859_not__eventually__impI,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),Qa: fun(B,$o)] :
      ( eventually(B,Pa,F)
     => ( ~ eventually(B,Qa,F)
       => ~ eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aw(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F) ) ) ).

% not_eventually_impI
tff(fact_1860_eventually__conj__iff,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o),F: filter(B)] :
      ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F)
    <=> ( eventually(B,Pa,F)
        & eventually(B,Qa,F) ) ) ).

% eventually_conj_iff
tff(fact_1861_eventually__rev__mp,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),Qa: fun(B,$o)] :
      ( eventually(B,Pa,F)
     => ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aw(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F)
       => eventually(B,Qa,F) ) ) ).

% eventually_rev_mp
tff(fact_1862_eventually__subst,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o),F: filter(B)] :
      ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_ng(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F)
     => ( eventually(B,Pa,F)
      <=> eventually(B,Qa,F) ) ) ).

% eventually_subst
tff(fact_1863_eventually__elim2,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),Qa: fun(B,$o),R: fun(B,$o)] :
      ( eventually(B,Pa,F)
     => ( eventually(B,Qa,F)
       => ( ! [I3: B] :
              ( aa(B,$o,Pa,I3)
             => ( aa(B,$o,Qa,I3)
               => aa(B,$o,R,I3) ) )
         => eventually(B,R,F) ) ) ) ).

% eventually_elim2
tff(fact_1864_eventually__conj,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),Qa: fun(B,$o)] :
      ( eventually(B,Pa,F)
     => ( eventually(B,Qa,F)
       => eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F) ) ) ).

% eventually_conj
tff(fact_1865_eventually__True,axiom,
    ! [B: $tType,F: filter(B)] : eventually(B,aTP_Lamp_nh(B,$o),F) ).

% eventually_True
tff(fact_1866_eventually__mp,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o),F: filter(B)] :
      ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aw(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F)
     => ( eventually(B,Pa,F)
       => eventually(B,Qa,F) ) ) ).

% eventually_mp
tff(fact_1867_eventually__frequently__const__simps_I3_J,axiom,
    ! [B: $tType,Pa: fun(B,$o),C2: $o,F: filter(B)] :
      ( eventually(B,aa($o,fun(B,$o),aTP_Lamp_ni(fun(B,$o),fun($o,fun(B,$o)),Pa),C2),F)
    <=> ( eventually(B,Pa,F)
        | (C2) ) ) ).

% eventually_frequently_const_simps(3)
tff(fact_1868_eventually__frequently__const__simps_I4_J,axiom,
    ! [B: $tType,C2: $o,Pa: fun(B,$o),F: filter(B)] :
      ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_nj($o,fun(fun(B,$o),fun(B,$o)),C2),Pa),F)
    <=> ( (C2)
        | eventually(B,Pa,F) ) ) ).

% eventually_frequently_const_simps(4)
tff(fact_1869_eventually__frequently__const__simps_I6_J,axiom,
    ! [B: $tType,C2: $o,Pa: fun(B,$o),F: filter(B)] :
      ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_nk($o,fun(fun(B,$o),fun(B,$o)),C2),Pa),F)
    <=> ( (C2)
       => eventually(B,Pa,F) ) ) ).

% eventually_frequently_const_simps(6)
tff(fact_1870_gfp__const,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [T3: B] : ( complete_lattice_gfp(B,aTP_Lamp_mh(B,fun(B,B),T3)) = T3 ) ) ).

% gfp_const
tff(fact_1871_eventually__happens_H,axiom,
    ! [B: $tType,F: filter(B),Pa: fun(B,$o)] :
      ( ( F != bot_bot(filter(B)) )
     => ( eventually(B,Pa,F)
       => ? [X_1: B] : aa(B,$o,Pa,X_1) ) ) ).

% eventually_happens'
tff(fact_1872_eventually__happens,axiom,
    ! [B: $tType,Pa: fun(B,$o),Net: filter(B)] :
      ( eventually(B,Pa,Net)
     => ( ( Net = bot_bot(filter(B)) )
        | ? [X_1: B] : aa(B,$o,Pa,X_1) ) ) ).

% eventually_happens
tff(fact_1873_eventually__bot,axiom,
    ! [B: $tType,Pa: fun(B,$o)] : eventually(B,Pa,bot_bot(filter(B))) ).

% eventually_bot
tff(fact_1874_eventually__inf,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),F3: filter(B)] :
      ( eventually(B,Pa,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F),F3))
    <=> ? [Q4: fun(B,$o),R5: fun(B,$o)] :
          ( eventually(B,Q4,F)
          & eventually(B,R5,F3)
          & ! [X3: B] :
              ( ( aa(B,$o,Q4,X3)
                & aa(B,$o,R5,X3) )
             => aa(B,$o,Pa,X3) ) ) ) ).

% eventually_inf
tff(fact_1875_eventually__ex,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o)),F: filter(B)] :
      ( eventually(B,aTP_Lamp_gv(fun(B,fun(C,$o)),fun(B,$o),Pa),F)
    <=> ? [Y7: fun(B,C)] : eventually(B,aa(fun(B,C),fun(B,$o),aTP_Lamp_nl(fun(B,fun(C,$o)),fun(fun(B,C),fun(B,$o)),Pa),Y7),F) ) ).

% eventually_ex
tff(fact_1876_eventually__compose__filterlim,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),F: filter(B),F2: fun(C,B),G3: filter(C)] :
      ( eventually(B,Pa,F)
     => ( filterlim(C,B,F2,F,G3)
       => eventually(C,aa(fun(C,B),fun(C,$o),aTP_Lamp_nm(fun(B,$o),fun(fun(C,B),fun(C,$o)),Pa),F2),G3) ) ) ).

% eventually_compose_filterlim
tff(fact_1877_filterlim__cong,axiom,
    ! [B: $tType,C: $tType,F12: filter(B),F13: filter(B),F23: filter(C),F24: filter(C),F2: fun(C,B),G: fun(C,B)] :
      ( ( F12 = F13 )
     => ( ( F23 = F24 )
       => ( eventually(C,aa(fun(C,B),fun(C,$o),aTP_Lamp_nn(fun(C,B),fun(fun(C,B),fun(C,$o)),F2),G),F23)
         => ( filterlim(C,B,F2,F12,F23)
          <=> filterlim(C,B,G,F13,F24) ) ) ) ) ).

% filterlim_cong
tff(fact_1878_filterlim__iff,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),F23: filter(C),F12: filter(B)] :
      ( filterlim(B,C,F2,F23,F12)
    <=> ! [P2: fun(C,$o)] :
          ( eventually(C,P2,F23)
         => eventually(B,aa(fun(C,$o),fun(B,$o),aTP_Lamp_bl(fun(B,C),fun(fun(C,$o),fun(B,$o)),F2),P2),F12) ) ) ).

% filterlim_iff
tff(fact_1879_trivial__limit__def,axiom,
    ! [B: $tType,F: filter(B)] :
      ( ( F = bot_bot(filter(B)) )
    <=> eventually(B,aTP_Lamp_ao(B,$o),F) ) ).

% trivial_limit_def
tff(fact_1880_eventually__const__iff,axiom,
    ! [B: $tType,Pa: $o,F: filter(B)] :
      ( eventually(B,aTP_Lamp_an($o,fun(B,$o),Pa),F)
    <=> ( (Pa)
        | ( F = bot_bot(filter(B)) ) ) ) ).

% eventually_const_iff
tff(fact_1881_False__imp__not__eventually,axiom,
    ! [B: $tType,Pa: fun(B,$o),Net: filter(B)] :
      ( ! [X: B] : ~ aa(B,$o,Pa,X)
     => ( ( Net != bot_bot(filter(B)) )
       => ~ eventually(B,Pa,Net) ) ) ).

% False_imp_not_eventually
tff(fact_1882_gfp__gfp,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(B,fun(B,B))] :
          ( ! [X: B,Y2: B,W: B,Z3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y2)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),W),Z3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),F2,X),W)),aa(B,B,aa(B,fun(B,B),F2,Y2),Z3)) ) )
         => ( complete_lattice_gfp(B,aTP_Lamp_no(fun(B,fun(B,B)),fun(B,B),F2)) = complete_lattice_gfp(B,aTP_Lamp_mj(fun(B,fun(B,B)),fun(B,B),F2)) ) ) ) ).

% gfp_gfp
tff(fact_1883_gfp__rolling,axiom,
    ! [B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(C)
        & comple6319245703460814977attice(B) )
     => ! [G: fun(B,C),F2: fun(C,B)] :
          ( order_mono(B,C,G)
         => ( order_mono(C,B,F2)
           => ( aa(B,C,G,complete_lattice_gfp(B,aa(fun(C,B),fun(B,B),aTP_Lamp_ml(fun(B,C),fun(fun(C,B),fun(B,B)),G),F2))) = complete_lattice_gfp(C,aa(fun(C,B),fun(C,C),aTP_Lamp_mm(fun(B,C),fun(fun(C,B),fun(C,C)),G),F2)) ) ) ) ) ).

% gfp_rolling
tff(fact_1884_Inf__fin_Oin__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,member(B,X2),A3)
           => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)) = aa(set(B),B,lattic7752659483105999362nf_fin(B),A3) ) ) ) ) ).

% Inf_fin.in_idem
tff(fact_1885_filterlim__mono__eventually,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),F: filter(C),G3: filter(B),F3: filter(C),G4: filter(B),F11: fun(B,C)] :
      ( filterlim(B,C,F2,F,G3)
     => ( aa(filter(C),$o,aa(filter(C),fun(filter(C),$o),ord_less_eq(filter(C)),F),F3)
       => ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),G4),G3)
         => ( eventually(B,aa(fun(B,C),fun(B,$o),aTP_Lamp_np(fun(B,C),fun(fun(B,C),fun(B,$o)),F2),F11),G4)
           => filterlim(B,C,F11,F3,G4) ) ) ) ) ).

% filterlim_mono_eventually
tff(fact_1886_filterlim__principal,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),S: set(C),F: filter(B)] :
      ( filterlim(B,C,F2,principal(C,S),F)
    <=> eventually(B,aa(set(C),fun(B,$o),aTP_Lamp_bn(fun(B,C),fun(set(C),fun(B,$o)),F2),S),F) ) ).

% filterlim_principal
tff(fact_1887_le__principal,axiom,
    ! [B: $tType,F: filter(B),A3: set(B)] :
      ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),F),principal(B,A3))
    <=> eventually(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3),F) ) ).

% le_principal
tff(fact_1888_eventually__INF1,axiom,
    ! [C: $tType,B: $tType,I2: B,I: set(B),Pa: fun(C,$o),F: fun(B,filter(C))] :
      ( aa(set(B),$o,member(B,I2),I)
     => ( eventually(C,Pa,aa(B,filter(C),F,I2))
       => eventually(C,Pa,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),F),I))) ) ) ).

% eventually_INF1
tff(fact_1889_eventually__inf__principal,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),S2: set(B)] :
      ( eventually(B,Pa,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F),principal(B,S2)))
    <=> eventually(B,aa(set(B),fun(B,$o),aTP_Lamp_nq(fun(B,$o),fun(set(B),fun(B,$o)),Pa),S2),F) ) ).

% eventually_inf_principal
tff(fact_1890_gfp__def,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(B,B)] : ( complete_lattice_gfp(B,F2) = aa(set(B),B,complete_Sup_Sup(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_nr(fun(B,B),fun(B,$o),F2))) ) ) ).

% gfp_def
tff(fact_1891_def__Collect__coinduct,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(set(B),fun(B,$o)),A4: B,X5: set(B)] :
      ( ( A3 = complete_lattice_gfp(set(B),aTP_Lamp_ns(fun(set(B),fun(B,$o)),fun(set(B),set(B)),Pa)) )
     => ( order_mono(set(B),set(B),aTP_Lamp_ns(fun(set(B),fun(B,$o)),fun(set(B),set(B)),Pa))
       => ( aa(set(B),$o,member(B,A4),X5)
         => ( ! [Z3: B] :
                ( aa(set(B),$o,member(B,Z3),X5)
               => aa(B,$o,aa(set(B),fun(B,$o),Pa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),X5),A3)),Z3) )
           => aa(set(B),$o,member(B,A4),A3) ) ) ) ) ).

% def_Collect_coinduct
tff(fact_1892_eventually__Inf__base,axiom,
    ! [B: $tType,B2: set(filter(B)),Pa: fun(B,$o)] :
      ( ( B2 != bot_bot(set(filter(B))) )
     => ( ! [F6: filter(B)] :
            ( aa(set(filter(B)),$o,member(filter(B),F6),B2)
           => ! [G5: filter(B)] :
                ( aa(set(filter(B)),$o,member(filter(B),G5),B2)
               => ? [X4: filter(B)] :
                    ( aa(set(filter(B)),$o,member(filter(B),X4),B2)
                    & aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),X4),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F6),G5)) ) ) )
       => ( eventually(B,Pa,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),B2))
        <=> ? [X3: filter(B)] :
              ( aa(set(filter(B)),$o,member(filter(B),X3),B2)
              & eventually(B,Pa,X3) ) ) ) ) ).

% eventually_Inf_base
tff(fact_1893_Inf__fin_Obounded__iff,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3))
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),X3) ) ) ) ) ) ).

% Inf_fin.bounded_iff
tff(fact_1894_Inf__fin_OboundedI,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [A5: B] :
                  ( aa(set(B),$o,member(B,A5),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),A5) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)) ) ) ) ) ).

% Inf_fin.boundedI
tff(fact_1895_Inf__fin_OboundedE,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3))
             => ! [A14: B] :
                  ( aa(set(B),$o,member(B,A14),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),A14) ) ) ) ) ) ).

% Inf_fin.boundedE
tff(fact_1896_eventually__INF__finite,axiom,
    ! [B: $tType,C: $tType,A3: set(B),Pa: fun(C,$o),F: fun(B,filter(C))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( eventually(C,Pa,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),F),A3)))
      <=> ? [Q4: fun(B,fun(C,$o))] :
            ( ! [X3: B] :
                ( aa(set(B),$o,member(B,X3),A3)
               => eventually(C,aa(B,fun(C,$o),Q4,X3),aa(B,filter(C),F,X3)) )
            & ! [Y4: C] :
                ( ! [X3: B] :
                    ( aa(set(B),$o,member(B,X3),A3)
                   => aa(C,$o,aa(B,fun(C,$o),Q4,X3),Y4) )
               => aa(C,$o,Pa,Y4) ) ) ) ) ).

% eventually_INF_finite
tff(fact_1897_filterlim__finite__subsets__at__top,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,set(C)),A3: set(C),F: filter(B)] :
      ( filterlim(B,set(C),F2,finite5375528669736107172at_top(C,A3),F)
    <=> ! [X7: set(C)] :
          ( ( aa(set(C),$o,finite_finite2(C),X7)
            & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),X7),A3) )
         => eventually(B,aa(set(C),fun(B,$o),aa(set(C),fun(set(C),fun(B,$o)),aTP_Lamp_nt(fun(B,set(C)),fun(set(C),fun(set(C),fun(B,$o))),F2),A3),X7),F) ) ) ).

% filterlim_finite_subsets_at_top
tff(fact_1898_cInf__eq__Inf__fin,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X5: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),X5)
         => ( ( X5 != bot_bot(set(B)) )
           => ( aa(set(B),B,complete_Inf_Inf(B),X5) = aa(set(B),B,lattic7752659483105999362nf_fin(B),X5) ) ) ) ) ).

% cInf_eq_Inf_fin
tff(fact_1899_Inf__fin__Inf,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),A3) = aa(set(B),B,complete_Inf_Inf(B),A3) ) ) ) ) ).

% Inf_fin_Inf
tff(fact_1900_eventually__INF,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),F: fun(C,filter(B)),B2: set(C)] :
      ( eventually(B,Pa,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(C),set(filter(B)),image2(C,filter(B),F),B2)))
    <=> ? [X7: set(C)] :
          ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),X7),B2)
          & aa(set(C),$o,finite_finite2(C),X7)
          & eventually(B,Pa,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(C),set(filter(B)),image2(C,filter(B),F),X7))) ) ) ).

% eventually_INF
tff(fact_1901_Inf__fin_Osubset__imp,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic7752659483105999362nf_fin(B),B2)),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)) ) ) ) ) ).

% Inf_fin.subset_imp
tff(fact_1902_Inf__fin_Ohom__commute,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [H2: fun(B,B),N3: set(B)] :
          ( ! [X: B,Y2: B] : ( aa(B,B,H2,aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,H2,X)),aa(B,B,H2,Y2)) )
         => ( aa(set(B),$o,finite_finite2(B),N3)
           => ( ( N3 != bot_bot(set(B)) )
             => ( aa(B,B,H2,aa(set(B),B,lattic7752659483105999362nf_fin(B),N3)) = aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),image2(B,B,H2),N3)) ) ) ) ) ) ).

% Inf_fin.hom_commute
tff(fact_1903_Inf__fin_Osubset,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( B2 != bot_bot(set(B)) )
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A3)
             => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,lattic7752659483105999362nf_fin(B),B2)),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)) = aa(set(B),B,lattic7752659483105999362nf_fin(B),A3) ) ) ) ) ) ).

% Inf_fin.subset
tff(fact_1904_Inf__fin_Oinsert__not__elem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ~ aa(set(B),$o,member(B,X2),A3)
           => ( ( A3 != bot_bot(set(B)) )
             => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),insert(B,X2),A3)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)) ) ) ) ) ) ).

% Inf_fin.insert_not_elem
tff(fact_1905_Inf__fin_Oclosed,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [X: B,Y2: B] : aa(set(B),$o,member(B,aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y2)),aa(set(B),set(B),insert(B,X),aa(set(B),set(B),insert(B,Y2),bot_bot(set(B)))))
             => aa(set(B),$o,member(B,aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)),A3) ) ) ) ) ).

% Inf_fin.closed
tff(fact_1906_Inf__fin_Ounion,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)),aa(set(B),B,lattic7752659483105999362nf_fin(B),B2)) ) ) ) ) ) ) ).

% Inf_fin.union
tff(fact_1907_Inf__fin_Oeq__fold,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),insert(B,X2),A3)) = finite_fold(B,B,inf_inf(B),X2,A3) ) ) ) ).

% Inf_fin.eq_fold
tff(fact_1908_Inf__fin__le__Sup__fin,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)),lattic5882676163264333800up_fin(B,A3)) ) ) ) ).

% Inf_fin_le_Sup_fin
tff(fact_1909_sup__Inf2__distrib,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)),aa(set(B),B,lattic7752659483105999362nf_fin(B),B2)) = aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_nu(set(B),fun(set(B),fun(B,$o)),A3),B2))) ) ) ) ) ) ) ).

% sup_Inf2_distrib
tff(fact_1910_sup__Inf1__distrib,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(set(B),B,lattic7752659483105999362nf_fin(B),A3)) = aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_nv(set(B),fun(B,fun(B,$o)),A3),X2))) ) ) ) ) ).

% sup_Inf1_distrib
tff(fact_1911_map__filter__on__comp,axiom,
    ! [B: $tType,D: $tType,C: $tType,G: fun(C,B),Y3: set(C),X5: set(B),F: filter(C),F2: fun(B,D)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(C),set(B),image2(C,B,G),Y3)),X5)
     => ( eventually(C,aTP_Lamp_nw(set(C),fun(C,$o),Y3),F)
       => ( map_filter_on(B,D,X5,F2,map_filter_on(C,B,Y3,G,F)) = map_filter_on(C,D,Y3,aa(fun(C,B),fun(C,D),comp(B,D,C,F2),G),F) ) ) ) ).

% map_filter_on_comp
tff(fact_1912_filterlim__at__bot,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [F2: fun(B,C),F: filter(B)] :
          ( filterlim(B,C,F2,at_bot(C),F)
        <=> ! [Z6: C] : eventually(B,aa(C,fun(B,$o),aTP_Lamp_nx(fun(B,C),fun(C,fun(B,$o)),F2),Z6),F) ) ) ).

% filterlim_at_bot
tff(fact_1913_filterlim__at__bot__le,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [F2: fun(B,C),F: filter(B),Ca: C] :
          ( filterlim(B,C,F2,at_bot(C),F)
        <=> ! [Z6: C] :
              ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),Z6),Ca)
             => eventually(B,aa(C,fun(B,$o),aTP_Lamp_nx(fun(B,C),fun(C,fun(B,$o)),F2),Z6),F) ) ) ) ).

% filterlim_at_bot_le
tff(fact_1914_filterlim__INF__INF,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,J: set(B),I: set(C),F2: fun(E,D),F: fun(C,filter(E)),G3: fun(B,filter(D))] :
      ( ! [M3: B] :
          ( aa(set(B),$o,member(B,M3),J)
         => ? [X4: C] :
              ( aa(set(C),$o,member(C,X4),I)
              & aa(filter(D),$o,aa(filter(D),fun(filter(D),$o),ord_less_eq(filter(D)),filtermap(E,D,F2,aa(C,filter(E),F,X4))),aa(B,filter(D),G3,M3)) ) )
     => filterlim(E,D,F2,aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(B),set(filter(D)),image2(B,filter(D),G3),J)),aa(set(filter(E)),filter(E),complete_Inf_Inf(filter(E)),aa(set(C),set(filter(E)),image2(C,filter(E),F),I))) ) ).

% filterlim_INF_INF
tff(fact_1915_member__le__sum,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add(C)
        & semiring_1(C) )
     => ! [I2: B,A3: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,member(B,I2),A3)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,I2),bot_bot(set(B)))))
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,F2,X)) )
           => ( aa(set(B),$o,finite_finite2(B),A3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I2)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),A3)) ) ) ) ) ).

% member_le_sum
tff(fact_1916_prod__mono2,axiom,
    ! [C: $tType,B: $tType] :
      ( linordered_idom(C)
     => ! [B2: set(B),A3: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),B2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
           => ( ! [B4: B] :
                  ( aa(set(B),$o,member(B,B4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A3))
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),one_one(C)),aa(B,C,F2,B4)) )
             => ( ! [A5: B] :
                    ( aa(set(B),$o,member(B,A5),A3)
                   => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,F2,A5)) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),B2)) ) ) ) ) ) ).

% prod_mono2
tff(fact_1917_ex__is__arg__min__if__finite,axiom,
    ! [C: $tType,B: $tType] :
      ( order(C)
     => ! [S: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( ( S != bot_bot(set(B)) )
           => ? [X_1: B] : aa(B,$o,lattic501386751177426532rg_min(B,C,F2,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),S)),X_1) ) ) ) ).

% ex_is_arg_min_if_finite
tff(fact_1918_filtermap__id_H,axiom,
    ! [B: $tType,X4: filter(B)] : ( filtermap(B,B,aTP_Lamp_bk(B,B),X4) = X4 ) ).

% filtermap_id'
tff(fact_1919_filtermap__bot,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,B)] : ( filtermap(C,B,F2,bot_bot(filter(C))) = bot_bot(filter(B)) ) ).

% filtermap_bot
tff(fact_1920_sum_Oneutral__const,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aTP_Lamp_ny(C,B)),A3) = zero_zero(B) ) ) ).

% sum.neutral_const
tff(fact_1921_prod_Oneutral__const,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aTP_Lamp_nz(C,B)),A3) = one_one(B) ) ) ).

% prod.neutral_const
tff(fact_1922_sum_Oempty,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(C,B)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),bot_bot(set(C))) = zero_zero(B) ) ) ).

% sum.empty
tff(fact_1923_prod_Oempty,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(C,B)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),G),bot_bot(set(C))) = one_one(B) ) ) ).

% prod.empty
tff(fact_1924_prod_Oinfinite,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),G: fun(B,C)] :
          ( ~ aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3) = one_one(C) ) ) ) ).

% prod.infinite
tff(fact_1925_sum_Odelta,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(C)
     => ! [S: set(B),A4: B,B3: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_oa(B,fun(fun(B,C),fun(B,C)),A4),B3)),S)
            = $ite(aa(set(B),$o,member(B,A4),S),aa(B,C,B3,A4),zero_zero(C)) ) ) ) ).

% sum.delta
tff(fact_1926_sum_Odelta_H,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(C)
     => ! [S: set(B),A4: B,B3: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_ob(B,fun(fun(B,C),fun(B,C)),A4),B3)),S)
            = $ite(aa(set(B),$o,member(B,A4),S),aa(B,C,B3,A4),zero_zero(C)) ) ) ) ).

% sum.delta'
tff(fact_1927_prod_Odelta,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [S: set(B),A4: B,B3: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_oc(B,fun(fun(B,C),fun(B,C)),A4),B3)),S)
            = $ite(aa(set(B),$o,member(B,A4),S),aa(B,C,B3,A4),one_one(C)) ) ) ) ).

% prod.delta
tff(fact_1928_prod_Odelta_H,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [S: set(B),A4: B,B3: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_od(B,fun(fun(B,C),fun(B,C)),A4),B3)),S)
            = $ite(aa(set(B),$o,member(B,A4),S),aa(B,C,B3,A4),one_one(C)) ) ) ) ).

% prod.delta'
tff(fact_1929_prod_Oinsert,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),X2: B,G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ~ aa(set(B),$o,member(B,X2),A3)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),insert(B,X2),A3)) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,G,X2)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3)) ) ) ) ) ).

% prod.insert
tff(fact_1930_filtermap__filtermap,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(C,B),G: fun(D,C),F: filter(D)] : ( filtermap(C,B,F2,filtermap(D,C,G,F)) = filtermap(D,B,aa(fun(D,C),fun(D,B),aTP_Lamp_cc(fun(C,B),fun(fun(D,C),fun(D,B)),F2),G),F) ) ).

% filtermap_filtermap
tff(fact_1931_filtermap__ident,axiom,
    ! [B: $tType,F: filter(B)] : ( filtermap(B,B,aTP_Lamp_bk(B,B),F) = F ) ).

% filtermap_ident
tff(fact_1932_sum_Oswap,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(C,fun(D,B)),B2: set(D),A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(set(D),fun(C,B),aTP_Lamp_oe(fun(C,fun(D,B)),fun(set(D),fun(C,B)),G),B2)),A3) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups7311177749621191930dd_sum(D,B),aa(set(C),fun(D,B),aTP_Lamp_og(fun(C,fun(D,B)),fun(set(C),fun(D,B)),G),A3)),B2) ) ) ).

% sum.swap
tff(fact_1933_prod_Oswap,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(C,fun(D,B)),B2: set(D),A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aa(set(D),fun(C,B),aTP_Lamp_oh(fun(C,fun(D,B)),fun(set(D),fun(C,B)),G),B2)),A3) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups7121269368397514597t_prod(D,B),aa(set(C),fun(D,B),aTP_Lamp_oj(fun(C,fun(D,B)),fun(set(C),fun(D,B)),G),A3)),B2) ) ) ).

% prod.swap
tff(fact_1934_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(C,B),A3: set(C)] :
          ( ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),G),A3) != one_one(B) )
         => ~ ! [A5: C] :
                ( aa(set(C),$o,member(C,A5),A3)
               => ( aa(C,B,G,A5) = one_one(B) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
tff(fact_1935_prod_Oneutral,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),G: fun(B,C)] :
          ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),A3)
             => ( aa(B,C,G,X) = one_one(C) ) )
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3) = one_one(C) ) ) ) ).

% prod.neutral
tff(fact_1936_prod_Ocartesian__product,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(C,fun(D,B)),B2: set(D),A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aa(set(D),fun(C,B),aTP_Lamp_oh(fun(C,fun(D,B)),fun(set(D),fun(C,B)),G),B2)),A3) = aa(set(product_prod(C,D)),B,aa(fun(product_prod(C,D),B),fun(set(product_prod(C,D)),B),groups7121269368397514597t_prod(product_prod(C,D),B),aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),G)),product_Sigma(C,D,A3,aTP_Lamp_eq(set(D),fun(C,set(D)),B2))) ) ) ).

% prod.cartesian_product
tff(fact_1937_sum_Ocartesian__product,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(C,fun(D,B)),B2: set(D),A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(set(D),fun(C,B),aTP_Lamp_oe(fun(C,fun(D,B)),fun(set(D),fun(C,B)),G),B2)),A3) = aa(set(product_prod(C,D)),B,aa(fun(product_prod(C,D),B),fun(set(product_prod(C,D)),B),groups7311177749621191930dd_sum(product_prod(C,D),B),aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),G)),product_Sigma(C,D,A3,aTP_Lamp_eq(set(D),fun(C,set(D)),B2))) ) ) ).

% sum.cartesian_product
tff(fact_1938_prod_OUnion__comp,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [B2: set(set(B)),G: fun(B,C)] :
          ( ! [X: set(B)] :
              ( aa(set(set(B)),$o,member(set(B),X),B2)
             => aa(set(B),$o,finite_finite2(B),X) )
         => ( ! [A15: set(B)] :
                ( aa(set(set(B)),$o,member(set(B),A15),B2)
               => ! [A24: set(B)] :
                    ( aa(set(set(B)),$o,member(set(B),A24),B2)
                   => ( ( A15 != A24 )
                     => ! [X: B] :
                          ( aa(set(B),$o,member(B,X),A15)
                         => ( aa(set(B),$o,member(B,X),A24)
                           => ( aa(B,C,G,X) = one_one(C) ) ) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B2)) = aa(set(set(B)),C,aa(fun(B,C),fun(set(set(B)),C),aa(fun(fun(B,C),fun(set(B),C)),fun(fun(B,C),fun(set(set(B)),C)),comp(fun(set(B),C),fun(set(set(B)),C),fun(B,C),groups7121269368397514597t_prod(set(B),C)),groups7121269368397514597t_prod(B,C)),G),B2) ) ) ) ) ).

% prod.Union_comp
tff(fact_1939_sum__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(C)
     => ! [K4: set(B),F2: fun(B,C),G: fun(B,C)] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),K4)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I3)),aa(B,C,G,I3)) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),K4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),K4)) ) ) ).

% sum_mono
tff(fact_1940_prod_Odistrib,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(C,B),H2: fun(C,B),A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aa(fun(C,B),fun(C,B),aTP_Lamp_ok(fun(C,B),fun(fun(C,B),fun(C,B)),G),H2)),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),G),A3)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),H2),A3)) ) ) ).

% prod.distrib
tff(fact_1941_prod_Oswap__restrict,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_mult(D)
     => ! [A3: set(B),B2: set(C),G: fun(B,fun(C,D)),R: fun(B,fun(C,$o))] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(C),$o,finite_finite2(C),B2)
           => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(B,fun(C,$o)),fun(B,D),aa(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(B,D)),aTP_Lamp_om(set(C),fun(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(B,D))),B2),G),R)),A3) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),aa(fun(B,fun(C,$o)),fun(C,D),aa(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(C,D)),aTP_Lamp_oo(set(B),fun(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(C,D))),A3),G),R)),B2) ) ) ) ) ).

% prod.swap_restrict
tff(fact_1942_sum_Odistrib,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(C,B),H2: fun(C,B),A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(fun(C,B),fun(C,B),aTP_Lamp_op(fun(C,B),fun(fun(C,B),fun(C,B)),G),H2)),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),A3)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),H2),A3)) ) ) ).

% sum.distrib
tff(fact_1943_sum__product,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [F2: fun(C,B),A3: set(C),G: fun(D,B),B2: set(D)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),F2),A3)),aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups7311177749621191930dd_sum(D,B),G),B2)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_or(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),F2),G),B2)),A3) ) ) ).

% sum_product
tff(fact_1944_sum__distrib__right,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [F2: fun(C,B),A3: set(C),R2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),F2),A3)),R2) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(B,fun(C,B),aTP_Lamp_os(fun(C,B),fun(B,fun(C,B)),F2),R2)),A3) ) ) ).

% sum_distrib_right
tff(fact_1945_sum__distrib__left,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [R2: B,F2: fun(C,B),A3: set(C)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),R2),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),F2),A3)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(fun(C,B),fun(C,B),aTP_Lamp_ot(B,fun(fun(C,B),fun(C,B)),R2),F2)),A3) ) ) ).

% sum_distrib_left
tff(fact_1946_sum__subtractf,axiom,
    ! [B: $tType,C: $tType] :
      ( ab_group_add(B)
     => ! [F2: fun(C,B),G: fun(C,B),A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(fun(C,B),fun(C,B),aTP_Lamp_ou(fun(C,B),fun(fun(C,B),fun(C,B)),F2),G)),A3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),F2),A3)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),A3)) ) ) ).

% sum_subtractf
tff(fact_1947_sum_Oswap__restrict,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_add(D)
     => ! [A3: set(B),B2: set(C),G: fun(B,fun(C,D)),R: fun(B,fun(C,$o))] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(C),$o,finite_finite2(C),B2)
           => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(fun(B,fun(C,$o)),fun(B,D),aa(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(B,D)),aTP_Lamp_ov(set(C),fun(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(B,D))),B2),G),R)),A3) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),aa(fun(B,fun(C,$o)),fun(C,D),aa(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(C,D)),aTP_Lamp_ox(set(B),fun(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(C,D))),A3),G),R)),B2) ) ) ) ) ).

% sum.swap_restrict
tff(fact_1948_sum__negf,axiom,
    ! [B: $tType,C: $tType] :
      ( ab_group_add(B)
     => ! [F2: fun(C,B),A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aTP_Lamp_oy(fun(C,B),fun(C,B),F2)),A3) = aa(B,B,uminus_uminus(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),F2),A3)) ) ) ).

% sum_negf
tff(fact_1949_filtermap__bot__iff,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),F: filter(C)] :
      ( ( filtermap(C,B,F2,F) = bot_bot(filter(B)) )
    <=> ( F = bot_bot(filter(C)) ) ) ).

% filtermap_bot_iff
tff(fact_1950_prod_Oreindex__bij__betw,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_mult(D)
     => ! [H2: fun(B,C),S: set(B),T2: set(C),G: fun(C,D)] :
          ( bij_betw(B,C,H2,S,T2)
         => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(C,D),fun(B,D),aTP_Lamp_oz(fun(B,C),fun(fun(C,D),fun(B,D)),H2),G)),S) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),G),T2) ) ) ) ).

% prod.reindex_bij_betw
tff(fact_1951_sum_Oreindex__bij__betw,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_add(D)
     => ! [H2: fun(B,C),S: set(B),T2: set(C),G: fun(C,D)] :
          ( bij_betw(B,C,H2,S,T2)
         => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(fun(C,D),fun(B,D),aTP_Lamp_pa(fun(B,C),fun(fun(C,D),fun(B,D)),H2),G)),S) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),G),T2) ) ) ) ).

% sum.reindex_bij_betw
tff(fact_1952_prod_OSigma,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [A3: set(B),B2: fun(B,set(C)),G: fun(B,fun(C,D))] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => aa(set(C),$o,finite_finite2(C),aa(B,set(C),B2,X)) )
           => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(B,fun(C,D)),fun(B,D),aTP_Lamp_pb(fun(B,set(C)),fun(fun(B,fun(C,D)),fun(B,D)),B2),G)),A3) = aa(set(product_prod(B,C)),D,aa(fun(product_prod(B,C),D),fun(set(product_prod(B,C)),D),groups7121269368397514597t_prod(product_prod(B,C),D),aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),G)),product_Sigma(B,C,A3,B2)) ) ) ) ) ).

% prod.Sigma
tff(fact_1953_sum_OSigma,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(D)
     => ! [A3: set(B),B2: fun(B,set(C)),G: fun(B,fun(C,D))] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => aa(set(C),$o,finite_finite2(C),aa(B,set(C),B2,X)) )
           => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(fun(B,fun(C,D)),fun(B,D),aTP_Lamp_pc(fun(B,set(C)),fun(fun(B,fun(C,D)),fun(B,D)),B2),G)),A3) = aa(set(product_prod(B,C)),D,aa(fun(product_prod(B,C),D),fun(set(product_prod(B,C)),D),groups7311177749621191930dd_sum(product_prod(B,C),D),aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),G)),product_Sigma(B,C,A3,B2)) ) ) ) ) ).

% sum.Sigma
tff(fact_1954_eventually__filtermap,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),F2: fun(C,B),F: filter(C)] :
      ( eventually(B,Pa,filtermap(C,B,F2,F))
    <=> eventually(C,aa(fun(C,B),fun(C,$o),aTP_Lamp_nm(fun(B,$o),fun(fun(C,B),fun(C,$o)),Pa),F2),F) ) ).

% eventually_filtermap
tff(fact_1955_prod_OUnion__disjoint,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [C2: set(set(B)),G: fun(B,C)] :
          ( ! [X: set(B)] :
              ( aa(set(set(B)),$o,member(set(B),X),C2)
             => aa(set(B),$o,finite_finite2(B),X) )
         => ( ! [X: set(B)] :
                ( aa(set(set(B)),$o,member(set(B),X),C2)
               => ! [Xa4: set(B)] :
                    ( aa(set(set(B)),$o,member(set(B),Xa4),C2)
                   => ( ( X != Xa4 )
                     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X),Xa4) = bot_bot(set(B)) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C2)) = aa(set(set(B)),C,aa(fun(B,C),fun(set(set(B)),C),aa(fun(fun(B,C),fun(set(B),C)),fun(fun(B,C),fun(set(set(B)),C)),comp(fun(set(B),C),fun(set(set(B)),C),fun(B,C),groups7121269368397514597t_prod(set(B),C)),groups7121269368397514597t_prod(B,C)),G),C2) ) ) ) ) ).

% prod.Union_disjoint
tff(fact_1956_sum_OUnion__disjoint,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [C2: set(set(B)),G: fun(B,C)] :
          ( ! [X: set(B)] :
              ( aa(set(set(B)),$o,member(set(B),X),C2)
             => aa(set(B),$o,finite_finite2(B),X) )
         => ( ! [X: set(B)] :
                ( aa(set(set(B)),$o,member(set(B),X),C2)
               => ! [Xa4: set(B)] :
                    ( aa(set(set(B)),$o,member(set(B),Xa4),C2)
                   => ( ( X != Xa4 )
                     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X),Xa4) = bot_bot(set(B)) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C2)) = aa(set(set(B)),C,aa(fun(B,C),fun(set(set(B)),C),aa(fun(fun(B,C),fun(set(B),C)),fun(fun(B,C),fun(set(set(B)),C)),comp(fun(set(B),C),fun(set(set(B)),C),fun(B,C),groups7311177749621191930dd_sum(set(B),C)),groups7311177749621191930dd_sum(B,C)),G),C2) ) ) ) ) ).

% sum.Union_disjoint
tff(fact_1957_filterlim__filtermap,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(B,C),F12: filter(C),G: fun(D,B),F23: filter(D)] :
      ( filterlim(B,C,F2,F12,filtermap(D,B,G,F23))
    <=> filterlim(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_mx(fun(B,C),fun(fun(D,B),fun(D,C)),F2),G),F12,F23) ) ).

% filterlim_filtermap
tff(fact_1958_prod__ge__1,axiom,
    ! [C: $tType,B: $tType] :
      ( linord181362715937106298miring(C)
     => ! [A3: set(B),F2: fun(B,C)] :
          ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),A3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),one_one(C)),aa(B,C,F2,X)) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),one_one(C)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),A3)) ) ) ).

% prod_ge_1
tff(fact_1959_prod_Ointer__filter,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),G: fun(B,C),Pa: fun(B,$o)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),A3),Pa))) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(fun(B,$o),fun(B,C),aTP_Lamp_pd(fun(B,C),fun(fun(B,$o),fun(B,C)),G),Pa)),A3) ) ) ) ).

% prod.inter_filter
tff(fact_1960_prod_Oimage__gen,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S: set(B),H2: fun(B,C),G: fun(B,D)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),S) = aa(set(D),C,aa(fun(D,C),fun(set(D),C),groups7121269368397514597t_prod(D,C),aa(fun(B,D),fun(D,C),aa(fun(B,C),fun(fun(B,D),fun(D,C)),aTP_Lamp_pf(set(B),fun(fun(B,C),fun(fun(B,D),fun(D,C))),S),H2),G)),aa(set(B),set(D),image2(B,D,G),S)) ) ) ) ).

% prod.image_gen
tff(fact_1961_sum_Ointer__filter,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),G: fun(B,C),Pa: fun(B,$o)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),A3),Pa))) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,$o),fun(B,C),aTP_Lamp_pg(fun(B,C),fun(fun(B,$o),fun(B,C)),G),Pa)),A3) ) ) ) ).

% sum.inter_filter
tff(fact_1962_sum_Oimage__gen,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [S: set(B),H2: fun(B,C),G: fun(B,D)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),H2),S) = aa(set(D),C,aa(fun(D,C),fun(set(D),C),groups7311177749621191930dd_sum(D,C),aa(fun(B,D),fun(D,C),aa(fun(B,C),fun(fun(B,D),fun(D,C)),aTP_Lamp_ph(set(B),fun(fun(B,C),fun(fun(B,D),fun(D,C))),S),H2),G)),aa(set(B),set(D),image2(B,D,G),S)) ) ) ) ).

% sum.image_gen
tff(fact_1963_prod_Oimage__eq,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [G: fun(B,C),A3: set(B)] :
          ( inj_on(B,C,G,A3)
         => ( aa(set(C),C,aa(fun(C,C),fun(set(C),C),groups7121269368397514597t_prod(C,C),aTP_Lamp_pi(C,C)),aa(set(B),set(C),image2(B,C,G),A3)) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3) ) ) ) ).

% prod.image_eq
tff(fact_1964_sum_Oimage__eq,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [G: fun(B,C),A3: set(B)] :
          ( inj_on(B,C,G,A3)
         => ( aa(set(C),C,aa(fun(C,C),fun(set(C),C),groups7311177749621191930dd_sum(C,C),aTP_Lamp_pj(C,C)),aa(set(B),set(C),image2(B,C,G),A3)) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),A3) ) ) ) ).

% sum.image_eq
tff(fact_1965_trivial__limit__at__bot__linorder,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( at_bot(B) != bot_bot(filter(B)) ) ) ).

% trivial_limit_at_bot_linorder
tff(fact_1966_prod__le__1,axiom,
    ! [B: $tType,C: $tType] :
      ( linord181362715937106298miring(C)
     => ! [A3: set(B),F2: fun(B,C)] :
          ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),A3)
             => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,F2,X))
                & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),one_one(C)) ) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),A3)),one_one(C)) ) ) ).

% prod_le_1
tff(fact_1967_eventually__at__bot__not__equal,axiom,
    ! [B: $tType] :
      ( ( linorder(B)
        & no_bot(B) )
     => ! [Ca: B] : eventually(B,aTP_Lamp_pk(B,fun(B,$o),Ca),at_bot(B)) ) ).

% eventually_at_bot_not_equal
tff(fact_1968_prod_Orelated,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [R: fun(B,fun(B,$o)),S: set(C),H2: fun(C,B),G: fun(C,B)] :
          ( aa(B,$o,aa(B,fun(B,$o),R,one_one(B)),one_one(B))
         => ( ! [X12: B,Y1: B,X23: B,Y22: B] :
                ( ( aa(B,$o,aa(B,fun(B,$o),R,X12),X23)
                  & aa(B,$o,aa(B,fun(B,$o),R,Y1),Y22) )
               => aa(B,$o,aa(B,fun(B,$o),R,aa(B,B,aa(B,fun(B,B),times_times(B),X12),Y1)),aa(B,B,aa(B,fun(B,B),times_times(B),X23),Y22)) )
           => ( aa(set(C),$o,finite_finite2(C),S)
             => ( ! [X: C] :
                    ( aa(set(C),$o,member(C,X),S)
                   => aa(B,$o,aa(B,fun(B,$o),R,aa(C,B,H2,X)),aa(C,B,G,X)) )
               => aa(B,$o,aa(B,fun(B,$o),R,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),H2),S)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),G),S)) ) ) ) ) ) ).

% prod.related
tff(fact_1969_prod_Oinsert__if,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),G: fun(B,C),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),insert(B,X2),A3))
            = $ite(aa(set(B),$o,member(B,X2),A3),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3),aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,G,X2)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3))) ) ) ) ).

% prod.insert_if
tff(fact_1970_filtermap__inf,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),F12: filter(C),F23: filter(C)] : aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),filtermap(C,B,F2,aa(filter(C),filter(C),aa(filter(C),fun(filter(C),filter(C)),inf_inf(filter(C)),F12),F23))),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),filtermap(C,B,F2,F12)),filtermap(C,B,F2,F23))) ).

% filtermap_inf
tff(fact_1971_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_mult(D)
     => ! [S3: set(B),T4: set(C),S: set(B),I2: fun(C,B),J2: fun(B,C),T2: set(C),G: fun(B,D),H2: fun(C,D)] :
          ( aa(set(B),$o,finite_finite2(B),S3)
         => ( aa(set(C),$o,finite_finite2(C),T4)
           => ( ! [A5: B] :
                  ( aa(set(B),$o,member(B,A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),S3))
                 => ( aa(C,B,I2,aa(B,C,J2,A5)) = A5 ) )
             => ( ! [A5: B] :
                    ( aa(set(B),$o,member(B,A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),S3))
                   => aa(set(C),$o,member(C,aa(B,C,J2,A5)),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),T4)) )
               => ( ! [B4: C] :
                      ( aa(set(C),$o,member(C,B4),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),T4))
                     => ( aa(B,C,J2,aa(C,B,I2,B4)) = B4 ) )
                 => ( ! [B4: C] :
                        ( aa(set(C),$o,member(C,B4),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),T4))
                       => aa(set(B),$o,member(B,aa(C,B,I2,B4)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),S3)) )
                   => ( ! [A5: B] :
                          ( aa(set(B),$o,member(B,A5),S3)
                         => ( aa(B,D,G,A5) = one_one(D) ) )
                     => ( ! [B4: C] :
                            ( aa(set(C),$o,member(C,B4),T4)
                           => ( aa(C,D,H2,B4) = one_one(D) ) )
                       => ( ! [A5: B] :
                              ( aa(set(B),$o,member(B,A5),S)
                             => ( aa(C,D,H2,aa(B,C,J2,A5)) = aa(B,D,G,A5) ) )
                         => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),G),S) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),H2),T2) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
tff(fact_1972_sum__diff1__nat,axiom,
    ! [B: $tType,F2: fun(B,nat),A3: set(B),A4: B] :
      ( aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))
      = $ite(aa(set(B),$o,member(B,A4),A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A3)),aa(B,nat,F2,A4)),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A3)) ) ).

% sum_diff1_nat
tff(fact_1973_filtermap__fun__inverse,axiom,
    ! [C: $tType,B: $tType,G: fun(B,C),F: filter(C),G3: filter(B),F2: fun(C,B)] :
      ( filterlim(B,C,G,F,G3)
     => ( filterlim(C,B,F2,G3,F)
       => ( eventually(B,aa(fun(C,B),fun(B,$o),aTP_Lamp_pl(fun(B,C),fun(fun(C,B),fun(B,$o)),G),F2),G3)
         => ( filtermap(C,B,F2,F) = G3 ) ) ) ) ).

% filtermap_fun_inverse
tff(fact_1974_sum__Un__nat,axiom,
    ! [B: $tType,A3: set(B),B2: set(B),F2: fun(B,nat)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),$o,finite_finite2(B),B2)
       => ( aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A3)),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),B2))),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ).

% sum_Un_nat
tff(fact_1975_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,C: $tType] :
      ( ordere6911136660526730532id_add(C)
     => ! [S2: set(B),F2: fun(B,C),B2: C,I2: B] :
          ( aa(set(B),$o,finite_finite2(B),S2)
         => ( ! [I3: B] :
                ( aa(set(B),$o,member(B,I3),S2)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,F2,I3)) )
           => ( ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),S2) = B2 )
             => ( aa(set(B),$o,member(B,I2),S2)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I2)),B2) ) ) ) ) ) ).

% sum_nonneg_leq_bound
tff(fact_1976_sum__nonneg__0,axiom,
    ! [B: $tType,C: $tType] :
      ( ordere6911136660526730532id_add(C)
     => ! [S2: set(B),F2: fun(B,C),I2: B] :
          ( aa(set(B),$o,finite_finite2(B),S2)
         => ( ! [I3: B] :
                ( aa(set(B),$o,member(B,I3),S2)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,F2,I3)) )
           => ( ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),S2) = zero_zero(C) )
             => ( aa(set(B),$o,member(B,I2),S2)
               => ( aa(B,C,F2,I2) = zero_zero(C) ) ) ) ) ) ) ).

% sum_nonneg_0
tff(fact_1977_prod_Ogroup,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [S: set(B),T2: set(C),G: fun(B,C),H2: fun(B,D)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(C),$o,finite_finite2(C),T2)
           => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,G),S)),T2)
             => ( aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),aa(fun(B,D),fun(C,D),aa(fun(B,C),fun(fun(B,D),fun(C,D)),aTP_Lamp_pn(set(B),fun(fun(B,C),fun(fun(B,D),fun(C,D))),S),G),H2)),T2) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),H2),S) ) ) ) ) ) ).

% prod.group
tff(fact_1978_prod_Ointer__restrict,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),G: fun(B,C),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(set(B),fun(B,C),aTP_Lamp_po(fun(B,C),fun(set(B),fun(B,C)),G),B2)),A3) ) ) ) ).

% prod.inter_restrict
tff(fact_1979_prod_Osetdiff__irrelevant,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_pp(fun(B,C),fun(B,$o),G)))) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3) ) ) ) ).

% prod.setdiff_irrelevant
tff(fact_1980_sum_Ogroup,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_add(D)
     => ! [S: set(B),T2: set(C),G: fun(B,C),H2: fun(B,D)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(C),$o,finite_finite2(C),T2)
           => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,G),S)),T2)
             => ( aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),aa(fun(B,D),fun(C,D),aa(fun(B,C),fun(fun(B,D),fun(C,D)),aTP_Lamp_pq(set(B),fun(fun(B,C),fun(fun(B,D),fun(C,D))),S),G),H2)),T2) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),H2),S) ) ) ) ) ) ).

% sum.group
tff(fact_1981_sum_Ointer__restrict,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),G: fun(B,C),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(set(B),fun(B,C),aTP_Lamp_pr(fun(B,C),fun(set(B),fun(B,C)),G),B2)),A3) ) ) ) ).

% sum.inter_restrict
tff(fact_1982_sum_Osetdiff__irrelevant,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_ps(fun(B,C),fun(B,$o),G)))) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),A3) ) ) ) ).

% sum.setdiff_irrelevant
tff(fact_1983_filtermap__SUP,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(C,B),F: fun(D,filter(C)),B2: set(D)] : ( filtermap(C,B,F2,aa(set(filter(C)),filter(C),complete_Sup_Sup(filter(C)),aa(set(D),set(filter(C)),image2(D,filter(C),F),B2))) = aa(set(filter(B)),filter(B),complete_Sup_Sup(filter(B)),aa(set(D),set(filter(B)),image2(D,filter(B),aa(fun(D,filter(C)),fun(D,filter(B)),aTP_Lamp_pt(fun(C,B),fun(fun(D,filter(C)),fun(D,filter(B))),F2),F)),B2)) ) ).

% filtermap_SUP
tff(fact_1984_sum_OG__def,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [P3: fun(C,B),I: set(C)] :
          ( groups1027152243600224163dd_sum(C,B,P3,I)
          = $ite(aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aTP_Lamp_lx(fun(C,B),fun(set(C),fun(C,$o)),P3),I))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),P3),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aTP_Lamp_lx(fun(C,B),fun(set(C),fun(C,$o)),P3),I))),zero_zero(B)) ) ) ).

% sum.G_def
tff(fact_1985_prod_OG__def,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [P3: fun(C,B),I: set(C)] :
          ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups1962203154675924110t_prod(C,B),P3),I)
          = $ite(aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aTP_Lamp_mk(fun(C,B),fun(set(C),fun(C,$o)),P3),I))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),P3),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aTP_Lamp_mk(fun(C,B),fun(set(C),fun(C,$o)),P3),I))),one_one(B)) ) ) ).

% prod.G_def
tff(fact_1986_eventually__map__filter__on,axiom,
    ! [C: $tType,B: $tType,X5: set(B),F: filter(B),Pa: fun(C,$o),F2: fun(B,C)] :
      ( eventually(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),X5),F)
     => ( eventually(C,Pa,map_filter_on(B,C,X5,F2,F))
      <=> eventually(B,aa(fun(B,C),fun(B,$o),aa(fun(C,$o),fun(fun(B,C),fun(B,$o)),aTP_Lamp_pu(set(B),fun(fun(C,$o),fun(fun(B,C),fun(B,$o))),X5),Pa),F2),F) ) ) ).

% eventually_map_filter_on
tff(fact_1987_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [A3: set(B),H2: fun(B,C),G: fun(C,D)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ! [X: B,Y2: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => ( aa(set(B),$o,member(B,Y2),A3)
                 => ( ( X != Y2 )
                   => ( ( aa(B,C,H2,X) = aa(B,C,H2,Y2) )
                     => ( aa(C,D,G,aa(B,C,H2,X)) = one_one(D) ) ) ) ) )
           => ( aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),G),aa(set(B),set(C),image2(B,C,H2),A3)) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(B,C),fun(B,D),comp(C,D,B,G),H2)),A3) ) ) ) ) ).

% prod.reindex_nontrivial
tff(fact_1988_prod_Osubset__diff,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [B2: set(B),A3: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A3)
         => ( aa(set(B),$o,finite_finite2(B),A3)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),B2)) ) ) ) ) ).

% prod.subset_diff
tff(fact_1989_prod_Osame__carrier,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [C2: set(B),A3: set(B),B2: set(B),G: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),C2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),C2)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),C2)
             => ( ! [A5: B] :
                    ( aa(set(B),$o,member(B,A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C2),A3))
                   => ( aa(B,C,G,A5) = one_one(C) ) )
               => ( ! [B4: B] :
                      ( aa(set(B),$o,member(B,B4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C2),B2))
                     => ( aa(B,C,H2,B4) = one_one(C) ) )
                 => ( ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),B2) )
                  <=> ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),C2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),C2) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
tff(fact_1990_prod_Osame__carrierI,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [C2: set(B),A3: set(B),B2: set(B),G: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),C2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),C2)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),C2)
             => ( ! [A5: B] :
                    ( aa(set(B),$o,member(B,A5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C2),A3))
                   => ( aa(B,C,G,A5) = one_one(C) ) )
               => ( ! [B4: B] :
                      ( aa(set(B),$o,member(B,B4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C2),B2))
                     => ( aa(B,C,H2,B4) = one_one(C) ) )
                 => ( ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),C2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),C2) )
                   => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),B2) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
tff(fact_1991_prod_Omono__neutral__left,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [T2: set(B),S: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),T2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S),T2)
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S))
                 => ( aa(B,C,G,X) = one_one(C) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),S) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),T2) ) ) ) ) ) ).

% prod.mono_neutral_left
tff(fact_1992_prod_Omono__neutral__right,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [T2: set(B),S: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),T2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S),T2)
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S))
                 => ( aa(B,C,G,X) = one_one(C) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),T2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),S) ) ) ) ) ) ).

% prod.mono_neutral_right
tff(fact_1993_prod_Omono__neutral__cong__left,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [T2: set(B),S: set(B),H2: fun(B,C),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),T2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S),T2)
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S))
                 => ( aa(B,C,H2,X) = one_one(C) ) )
             => ( ! [X: B] :
                    ( aa(set(B),$o,member(B,X),S)
                   => ( aa(B,C,G,X) = aa(B,C,H2,X) ) )
               => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),S) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),T2) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
tff(fact_1994_prod_Omono__neutral__cong__right,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [T2: set(B),S: set(B),G: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),T2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S),T2)
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S))
                 => ( aa(B,C,G,X) = one_one(C) ) )
             => ( ! [X: B] :
                    ( aa(set(B),$o,member(B,X),S)
                   => ( aa(B,C,G,X) = aa(B,C,H2,X) ) )
               => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),T2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),S) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
tff(fact_1995_prod_Ounion__inter,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),B2: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => ( aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),B2)) ) ) ) ) ).

% prod.union_inter
tff(fact_1996_prod_OInt__Diff,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),G: fun(B,C),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))) ) ) ) ).

% prod.Int_Diff
tff(fact_1997_prod_Omono__neutral__cong,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [T2: set(B),S: set(B),H2: fun(B,C),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),T2)
         => ( aa(set(B),$o,finite_finite2(B),S)
           => ( ! [I3: B] :
                  ( aa(set(B),$o,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S))
                 => ( aa(B,C,H2,I3) = one_one(C) ) )
             => ( ! [I3: B] :
                    ( aa(set(B),$o,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),T2))
                   => ( aa(B,C,G,I3) = one_one(C) ) )
               => ( ! [X: B] :
                      ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),T2))
                     => ( aa(B,C,G,X) = aa(B,C,H2,X) ) )
                 => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),S) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),T2) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
tff(fact_1998_sum_Omono__neutral__cong,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [T2: set(B),S: set(B),H2: fun(B,C),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),T2)
         => ( aa(set(B),$o,finite_finite2(B),S)
           => ( ! [I3: B] :
                  ( aa(set(B),$o,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T2),S))
                 => ( aa(B,C,H2,I3) = zero_zero(C) ) )
             => ( ! [I3: B] :
                    ( aa(set(B),$o,member(B,I3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),T2))
                   => ( aa(B,C,G,I3) = zero_zero(C) ) )
               => ( ! [X: B] :
                      ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),T2))
                     => ( aa(B,C,G,X) = aa(B,C,H2,X) ) )
                 => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),S) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),H2),T2) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
tff(fact_1999_sum_Ounion__inter,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),B2: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => ( aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),B2)) ) ) ) ) ).

% sum.union_inter
tff(fact_2000_sum_OInt__Diff,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),G: fun(B,C),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),A3) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))) ) ) ) ).

% sum.Int_Diff
tff(fact_2001_prod_Oeq__fold,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(C,B),A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),G),A3) = finite_fold(C,B,aa(fun(C,B),fun(C,fun(B,B)),comp(B,fun(B,B),C,times_times(B)),G),one_one(B),A3) ) ) ).

% prod.eq_fold
tff(fact_2002_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_mult(D)
     => ! [S3: set(B),T4: set(C),H2: fun(B,C),S: set(B),T2: set(C),G: fun(C,D)] :
          ( aa(set(B),$o,finite_finite2(B),S3)
         => ( aa(set(C),$o,finite_finite2(C),T4)
           => ( bij_betw(B,C,H2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),S3),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),T4))
             => ( ! [A5: B] :
                    ( aa(set(B),$o,member(B,A5),S3)
                   => ( aa(C,D,G,aa(B,C,H2,A5)) = one_one(D) ) )
               => ( ! [B4: C] :
                      ( aa(set(C),$o,member(C,B4),T4)
                     => ( aa(C,D,G,B4) = one_one(D) ) )
                 => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(C,D),fun(B,D),aTP_Lamp_oz(fun(B,C),fun(fun(C,D),fun(B,D)),H2),G)),S) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),G),T2) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
tff(fact_2003_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_add(D)
     => ! [S3: set(B),T4: set(C),H2: fun(B,C),S: set(B),T2: set(C),G: fun(C,D)] :
          ( aa(set(B),$o,finite_finite2(B),S3)
         => ( aa(set(C),$o,finite_finite2(C),T4)
           => ( bij_betw(B,C,H2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),S3),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),T4))
             => ( ! [A5: B] :
                    ( aa(set(B),$o,member(B,A5),S3)
                   => ( aa(C,D,G,aa(B,C,H2,A5)) = zero_zero(D) ) )
               => ( ! [B4: C] :
                      ( aa(set(C),$o,member(C,B4),T4)
                     => ( aa(C,D,G,B4) = zero_zero(D) ) )
                 => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(fun(C,D),fun(B,D),aTP_Lamp_pa(fun(B,C),fun(fun(C,D),fun(B,D)),H2),G)),S) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),G),T2) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
tff(fact_2004_prod_OIf__cases,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),Pa: fun(B,$o),H2: fun(B,C),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_pv(fun(B,$o),fun(fun(B,C),fun(fun(B,C),fun(B,C))),Pa),H2),G)),A3) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,$o),set(B),collect(B),Pa)))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,$o),set(B),collect(B),Pa))))) ) ) ) ).

% prod.If_cases
tff(fact_2005_sum_OIf__cases,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),Pa: fun(B,$o),H2: fun(B,C),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_pw(fun(B,$o),fun(fun(B,C),fun(fun(B,C),fun(B,C))),Pa),H2),G)),A3) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),H2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,$o),set(B),collect(B),Pa)))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,$o),set(B),collect(B),Pa))))) ) ) ) ).

% sum.If_cases
tff(fact_2006_filtermap__INF,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(C,B),F: fun(D,filter(C)),B2: set(D)] : aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),filtermap(C,B,F2,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(D),set(filter(C)),image2(D,filter(C),F),B2)))),aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(D),set(filter(B)),image2(D,filter(B),aa(fun(D,filter(C)),fun(D,filter(B)),aTP_Lamp_pt(fun(C,B),fun(fun(D,filter(C)),fun(D,filter(B))),F2),F)),B2))) ).

% filtermap_INF
tff(fact_2007_eventually__le__at__bot,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ca: B] : eventually(B,aa(B,fun(B,$o),aTP_Lamp_px(B,fun(B,$o)),Ca),at_bot(B)) ) ).

% eventually_le_at_bot
tff(fact_2008_prod_Oremove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),X2: B,G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,member(B,X2),A3)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,G,X2)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ).

% prod.remove
tff(fact_2009_prod_Oinsert__remove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),G: fun(B,C),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),insert(B,X2),A3)) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,G,X2)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ).

% prod.insert_remove
tff(fact_2010_prod_Ounion__inter__neutral,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),B2: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))
                 => ( aa(B,C,G,X) = one_one(C) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),B2)) ) ) ) ) ) ).

% prod.union_inter_neutral
tff(fact_2011_prod_Ounion__disjoint,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),B2: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),B2)) ) ) ) ) ) ).

% prod.union_disjoint
tff(fact_2012_sum_Ounion__inter__neutral,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),B2: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))
                 => ( aa(B,C,G,X) = zero_zero(C) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),B2)) ) ) ) ) ) ).

% sum.union_inter_neutral
tff(fact_2013_sum_Oinsert__remove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),G: fun(B,C),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),insert(B,X2),A3)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,G,X2)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ).

% sum.insert_remove
tff(fact_2014_sum_Oremove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),X2: B,G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,member(B,X2),A3)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),A3) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,G,X2)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ).

% sum.remove
tff(fact_2015_sum__diff1,axiom,
    ! [C: $tType,B: $tType] :
      ( ab_group_add(C)
     => ! [A3: set(B),F2: fun(B,C),A4: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))
            = $ite(aa(set(B),$o,member(B,A4),A3),aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),A3)),aa(B,C,F2,A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),A3)) ) ) ) ).

% sum_diff1
tff(fact_2016_sum__Un,axiom,
    ! [C: $tType,B: $tType] :
      ( ab_group_add(C)
     => ! [A3: set(B),B2: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ) ).

% sum_Un
tff(fact_2017_prod_Ounion__diff2,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(B),B2: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A3)))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ) ).

% prod.union_diff2
tff(fact_2018_sum_Ounion__disjoint,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),B2: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),B2)) ) ) ) ) ) ).

% sum.union_disjoint
tff(fact_2019_sum_Ounion__diff2,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),B2: set(B),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A3)))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ) ).

% sum.union_diff2
tff(fact_2020_sum__Un2,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(B),B2: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A3)))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ).

% sum_Un2
tff(fact_2021_prod_Odelta__remove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S: set(B),A4: B,B3: fun(B,C),Ca: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_py(B,fun(fun(B,C),fun(fun(B,C),fun(B,C))),A4),B3),Ca)),S)
            = $ite(aa(set(B),$o,member(B,A4),S),aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,B3,A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ca),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ca),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) ) ) ).

% prod.delta_remove
tff(fact_2022_sum_Odelta__remove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [S: set(B),A4: B,B3: fun(B,C),Ca: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_pz(B,fun(fun(B,C),fun(fun(B,C),fun(B,C))),A4),B3),Ca)),S)
            = $ite(aa(set(B),$o,member(B,A4),S),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,B3,A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ca),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ca),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) ) ) ).

% sum.delta_remove
tff(fact_2023_prod_OUNION__disjoint,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [I: set(B),A3: fun(B,set(C)),G: fun(C,D)] :
          ( aa(set(B),$o,finite_finite2(B),I)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),I)
               => aa(set(C),$o,finite_finite2(C),aa(B,set(C),A3,X)) )
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),I)
                 => ! [Xa4: B] :
                      ( aa(set(B),$o,member(B,Xa4),I)
                     => ( ( X != Xa4 )
                       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A3,X)),aa(B,set(C),A3,Xa4)) = bot_bot(set(C)) ) ) ) )
             => ( aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),G),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I))) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(C,D),fun(B,D),aTP_Lamp_qa(fun(B,set(C)),fun(fun(C,D),fun(B,D)),A3),G)),I) ) ) ) ) ) ).

% prod.UNION_disjoint
tff(fact_2024_sum_OUNION__disjoint,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_add(D)
     => ! [I: set(B),A3: fun(B,set(C)),G: fun(C,D)] :
          ( aa(set(B),$o,finite_finite2(B),I)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),I)
               => aa(set(C),$o,finite_finite2(C),aa(B,set(C),A3,X)) )
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),I)
                 => ! [Xa4: B] :
                      ( aa(set(B),$o,member(B,Xa4),I)
                     => ( ( X != Xa4 )
                       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A3,X)),aa(B,set(C),A3,Xa4)) = bot_bot(set(C)) ) ) ) )
             => ( aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),G),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I))) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(fun(C,D),fun(B,D),aTP_Lamp_qb(fun(B,set(C)),fun(fun(C,D),fun(B,D)),A3),G)),I) ) ) ) ) ) ).

% sum.UNION_disjoint
tff(fact_2025_at__bot__def,axiom,
    ! [B: $tType] :
      ( order(B)
     => ( at_bot(B) = aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(B),set(filter(B)),image2(B,filter(B),aTP_Lamp_qc(B,filter(B))),top_top(set(B)))) ) ) ).

% at_bot_def
tff(fact_2026_sum__mult__sum__if__inj,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( semiring_0(D)
     => ! [F2: fun(B,D),G: fun(C,D),A3: set(B),B2: set(C)] :
          ( inj_on(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),aa(fun(C,D),fun(B,fun(C,D)),aTP_Lamp_qd(fun(B,D),fun(fun(C,D),fun(B,fun(C,D))),F2),G)),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))
         => ( aa(D,D,aa(D,fun(D,D),times_times(D),aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),F2),A3)),aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),G),B2)) = aa(set(D),D,aa(fun(D,D),fun(set(D),D),groups7311177749621191930dd_sum(D,D),id(D)),aa(fun(D,$o),set(D),collect(D),aa(set(C),fun(D,$o),aa(set(B),fun(set(C),fun(D,$o)),aa(fun(C,D),fun(set(B),fun(set(C),fun(D,$o))),aTP_Lamp_qe(fun(B,D),fun(fun(C,D),fun(set(B),fun(set(C),fun(D,$o)))),F2),G),A3),B2))) ) ) ) ).

% sum_mult_sum_if_inj
tff(fact_2027_prod__Un,axiom,
    ! [C: $tType,B: $tType] :
      ( field(C)
     => ! [A3: set(B),B2: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))
                 => ( aa(B,C,F2,X) != zero_zero(C) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(C,C,aa(C,fun(C,C),divide_divide(C),aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ) ) ).

% prod_Un
tff(fact_2028_prod__diff1,axiom,
    ! [C: $tType,B: $tType] :
      ( semidom_divide(C)
     => ! [A3: set(B),F2: fun(B,C),A4: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( aa(B,C,F2,A4) != zero_zero(C) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))
              = $ite(aa(set(B),$o,member(B,A4),A3),aa(C,C,aa(C,fun(C,C),divide_divide(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),A3)),aa(B,C,F2,A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),A3)) ) ) ) ) ).

% prod_diff1
tff(fact_2029_convex__sum__bound__le,axiom,
    ! [B: $tType,C: $tType] :
      ( linordered_idom(C)
     => ! [I: set(B),X2: fun(B,C),A4: fun(B,C),B3: C,Delta: C] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),I)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,X2,I3)) )
         => ( ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),X2),I) = one_one(C) )
           => ( ! [I3: B] :
                  ( aa(set(B),$o,member(B,I3),I)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(C,C,abs_abs(C),aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(B,C,A4,I3)),B3))),Delta) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(C,C,abs_abs(C),aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_qf(fun(B,C),fun(fun(B,C),fun(B,C)),X2),A4)),I)),B3))),Delta) ) ) ) ) ).

% convex_sum_bound_le
tff(fact_2030_at__bot__sub,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ca: B] : ( at_bot(B) = aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(B),set(filter(B)),image2(B,filter(B),aTP_Lamp_qg(B,filter(B))),aa(B,set(B),set_ord_atMost(B),Ca))) ) ) ).

% at_bot_sub
tff(fact_2031_prod__filter__principal__singleton2,axiom,
    ! [C: $tType,B: $tType,F: filter(B),X2: C] : ( prod_filter(B,C,F,principal(C,aa(set(C),set(C),insert(C,X2),bot_bot(set(C))))) = filtermap(B,product_prod(B,C),aa(C,fun(B,product_prod(B,C)),aTP_Lamp_ej(C,fun(B,product_prod(B,C))),X2),F) ) ).

% prod_filter_principal_singleton2
tff(fact_2032_abs__idempotent,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] : ( aa(B,B,abs_abs(B),aa(B,B,abs_abs(B),A4)) = aa(B,B,abs_abs(B),A4) ) ) ).

% abs_idempotent
tff(fact_2033_abs__abs,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B] : ( aa(B,B,abs_abs(B),aa(B,B,abs_abs(B),A4)) = aa(B,B,abs_abs(B),A4) ) ) ).

% abs_abs
tff(fact_2034_div__0,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),zero_zero(B)),A4) = zero_zero(B) ) ) ).

% div_0
tff(fact_2035_div__by__0,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),zero_zero(B)) = zero_zero(B) ) ) ).

% div_by_0
tff(fact_2036_times__divide__eq__left,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [B3: B,Ca: B,A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),A4) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4)),Ca) ) ) ).

% times_divide_eq_left
tff(fact_2037_divide__divide__eq__left,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ).

% divide_divide_eq_left
tff(fact_2038_divide__divide__eq__right,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3) ) ) ).

% divide_divide_eq_right
tff(fact_2039_times__divide__eq__right,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca) ) ) ).

% times_divide_eq_right
tff(fact_2040_div__by__1,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),one_one(B)) = A4 ) ) ).

% div_by_1
tff(fact_2041_abs__0__eq,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] :
          ( ( zero_zero(B) = aa(B,B,abs_abs(B),A4) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% abs_0_eq
tff(fact_2042_abs__eq__0,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] :
          ( ( aa(B,B,abs_abs(B),A4) = zero_zero(B) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% abs_eq_0
tff(fact_2043_abs__zero,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ( aa(B,B,abs_abs(B),zero_zero(B)) = zero_zero(B) ) ) ).

% abs_zero
tff(fact_2044_abs__0,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ( aa(B,B,abs_abs(B),zero_zero(B)) = zero_zero(B) ) ) ).

% abs_0
tff(fact_2045_abs__add__abs,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B] : ( aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),B3))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),B3)) ) ) ).

% abs_add_abs
tff(fact_2046_abs__mult__self__eq,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),A4)) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),A4) ) ) ).

% abs_mult_self_eq
tff(fact_2047_abs__1,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ( aa(B,B,abs_abs(B),one_one(B)) = one_one(B) ) ) ).

% abs_1
tff(fact_2048_abs__minus__cancel,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] : ( aa(B,B,abs_abs(B),aa(B,B,uminus_uminus(B),A4)) = aa(B,B,abs_abs(B),A4) ) ) ).

% abs_minus_cancel
tff(fact_2049_abs__minus,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B] : ( aa(B,B,abs_abs(B),aa(B,B,uminus_uminus(B),A4)) = aa(B,B,abs_abs(B),A4) ) ) ).

% abs_minus
tff(fact_2050_abs__sum__abs,axiom,
    ! [B: $tType,C: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [F2: fun(C,B),A3: set(C)] : ( aa(B,B,abs_abs(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aTP_Lamp_qh(fun(C,B),fun(C,B),F2)),A3)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aTP_Lamp_qh(fun(C,B),fun(C,B),F2)),A3) ) ) ).

% abs_sum_abs
tff(fact_2051_mult__divide__mult__cancel__left__if,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
          = $ite(Ca = zero_zero(B),zero_zero(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) ) ) ).

% mult_divide_mult_cancel_left_if
tff(fact_2052_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( ( Ca != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
tff(fact_2053_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( ( Ca != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
tff(fact_2054_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( ( Ca != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
tff(fact_2055_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( ( Ca != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
tff(fact_2056_nonzero__mult__div__cancel__left,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),A4) = B3 ) ) ) ).

% nonzero_mult_div_cancel_left
tff(fact_2057_nonzero__mult__div__cancel__right,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [B3: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),B3) = A4 ) ) ) ).

% nonzero_mult_div_cancel_right
tff(fact_2058_zero__eq__1__divide__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B] :
          ( ( zero_zero(B) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% zero_eq_1_divide_iff
tff(fact_2059_one__divide__eq__0__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4) = zero_zero(B) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% one_divide_eq_0_iff
tff(fact_2060_eq__divide__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,A4: B] :
          ( ( one_one(B) = aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4) )
        <=> ( ( A4 != zero_zero(B) )
            & ( A4 = B3 ) ) ) ) ).

% eq_divide_eq_1
tff(fact_2061_divide__eq__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,A4: B] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4) = one_one(B) )
        <=> ( ( A4 != zero_zero(B) )
            & ( A4 = B3 ) ) ) ) ).

% divide_eq_eq_1
tff(fact_2062_divide__self__if,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B] :
          ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),A4)
          = $ite(A4 = zero_zero(B),zero_zero(B),one_one(B)) ) ) ).

% divide_self_if
tff(fact_2063_divide__self,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),A4) = one_one(B) ) ) ) ).

% divide_self
tff(fact_2064_one__eq__divide__iff,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B,B3: B] :
          ( ( one_one(B) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) )
        <=> ( ( B3 != zero_zero(B) )
            & ( A4 = B3 ) ) ) ) ).

% one_eq_divide_iff
tff(fact_2065_divide__eq__1__iff,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) = one_one(B) )
        <=> ( ( B3 != zero_zero(B) )
            & ( A4 = B3 ) ) ) ) ).

% divide_eq_1_iff
tff(fact_2066_div__self,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [A4: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),A4) = one_one(B) ) ) ) ).

% div_self
tff(fact_2067_abs__le__zero__iff,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A4)),zero_zero(B))
        <=> ( A4 = zero_zero(B) ) ) ) ).

% abs_le_zero_iff
tff(fact_2068_abs__le__self__iff,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A4)),A4)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4) ) ) ).

% abs_le_self_iff
tff(fact_2069_abs__of__nonneg,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,B,abs_abs(B),A4) = A4 ) ) ) ).

% abs_of_nonneg
tff(fact_2070_divide__minus1,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),X2) ) ) ).

% divide_minus1
tff(fact_2071_abs__neg__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ( aa(B,B,abs_abs(B),aa(B,B,uminus_uminus(B),one_one(B))) = one_one(B) ) ) ).

% abs_neg_one
tff(fact_2072_sum__abs,axiom,
    ! [B: $tType,C: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [F2: fun(C,B),A3: set(C)] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),F2),A3))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aTP_Lamp_qh(fun(C,B),fun(C,B),F2)),A3)) ) ).

% sum_abs
tff(fact_2073_zero__le__divide__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4) ) ) ).

% zero_le_divide_1_iff
tff(fact_2074_divide__le__0__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B)) ) ) ).

% divide_le_0_1_iff
tff(fact_2075_nonzero__divide__mult__cancel__left,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),B3) ) ) ) ).

% nonzero_divide_mult_cancel_left
tff(fact_2076_nonzero__divide__mult__cancel__right,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [B3: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4) ) ) ) ).

% nonzero_divide_mult_cancel_right
tff(fact_2077_abs__of__nonpos,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))
         => ( aa(B,B,abs_abs(B),A4) = aa(B,B,uminus_uminus(B),A4) ) ) ) ).

% abs_of_nonpos
tff(fact_2078_sum__abs__ge__zero,axiom,
    ! [B: $tType,C: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [F2: fun(C,B),A3: set(C)] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aTP_Lamp_qh(fun(C,B),fun(C,B),F2)),A3)) ) ).

% sum_abs_ge_zero
tff(fact_2079_inj__divide__right,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B] :
          ( inj_on(B,B,aTP_Lamp_qi(B,fun(B,B),A4),top_top(set(B)))
        <=> ( A4 != zero_zero(B) ) ) ) ).

% inj_divide_right
tff(fact_2080_sum__subtractf__nat,axiom,
    ! [B: $tType,A3: set(B),G: fun(B,nat),F2: fun(B,nat)] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),A3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(B,nat,G,X)),aa(B,nat,F2,X)) )
     => ( aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(fun(B,nat),fun(B,nat),aTP_Lamp_qj(fun(B,nat),fun(fun(B,nat),fun(B,nat)),G),F2)),A3) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A3)),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),G),A3)) ) ) ).

% sum_subtractf_nat
tff(fact_2081_prod__filter__assoc,axiom,
    ! [B: $tType,C: $tType,D: $tType,F: filter(B),G3: filter(C),H8: filter(D)] : ( prod_filter(product_prod(B,C),D,prod_filter(B,C,F,G3),H8) = filtermap(product_prod(B,product_prod(C,D)),product_prod(product_prod(B,C),D),aa(fun(B,fun(product_prod(C,D),product_prod(product_prod(B,C),D))),fun(product_prod(B,product_prod(C,D)),product_prod(product_prod(B,C),D)),product_case_prod(B,product_prod(C,D),product_prod(product_prod(B,C),D)),aTP_Lamp_ql(B,fun(product_prod(C,D),product_prod(product_prod(B,C),D)))),prod_filter(B,product_prod(C,D),F,prod_filter(C,D,G3,H8))) ) ).

% prod_filter_assoc
tff(fact_2082_abs__le__D1,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A4)),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ).

% abs_le_D1
tff(fact_2083_abs__ge__self,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,abs_abs(B),A4)) ) ).

% abs_ge_self
tff(fact_2084_abs__eq__0__iff,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B] :
          ( ( aa(B,B,abs_abs(B),A4) = zero_zero(B) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% abs_eq_0_iff
tff(fact_2085_abs__mult,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B,B3: B] : ( aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),B3)) ) ) ).

% abs_mult
tff(fact_2086_abs__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ( aa(B,B,abs_abs(B),one_one(B)) = one_one(B) ) ) ).

% abs_one
tff(fact_2087_abs__minus__commute,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B] : ( aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)) = aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4)) ) ) ).

% abs_minus_commute
tff(fact_2088_abs__eq__iff,axiom,
    ! [B: $tType] :
      ( linordered_ring(B)
     => ! [X2: B,Y: B] :
          ( ( aa(B,B,abs_abs(B),X2) = aa(B,B,abs_abs(B),Y) )
        <=> ( ( X2 = Y )
            | ( X2 = aa(B,B,uminus_uminus(B),Y) ) ) ) ) ).

% abs_eq_iff
tff(fact_2089_times__divide__times__eq,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X2: B,Y: B,Z2: B,W2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)),aa(B,B,aa(B,fun(B,B),divide_divide(B),Z2),W2)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),W2)) ) ) ).

% times_divide_times_eq
tff(fact_2090_divide__divide__times__eq,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X2: B,Y: B,Z2: B,W2: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)),aa(B,B,aa(B,fun(B,B),divide_divide(B),Z2),W2)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),W2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2)) ) ) ).

% divide_divide_times_eq
tff(fact_2091_divide__divide__eq__left_H,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) ) ) ).

% divide_divide_eq_left'
tff(fact_2092_abs__prod,axiom,
    ! [B: $tType,C: $tType] :
      ( linordered_field(B)
     => ! [F2: fun(C,B),A3: set(C)] : ( aa(B,B,abs_abs(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),F2),A3)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aTP_Lamp_qm(fun(C,B),fun(C,B),F2)),A3) ) ) ).

% abs_prod
tff(fact_2093_set_Oidentity,axiom,
    ! [B: $tType] : ( aa(fun(B,B),fun(set(B),set(B)),vimage(B,B),aTP_Lamp_bk(B,B)) = id(set(B)) ) ).

% set.identity
tff(fact_2094_sum__divide__distrib,axiom,
    ! [B: $tType,C: $tType] :
      ( field(B)
     => ! [F2: fun(C,B),A3: set(C),R2: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),F2),A3)),R2) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(B,fun(C,B),aTP_Lamp_qn(fun(C,B),fun(B,fun(C,B)),F2),R2)),A3) ) ) ).

% sum_divide_distrib
tff(fact_2095_prod__dividef,axiom,
    ! [B: $tType,C: $tType] :
      ( field(B)
     => ! [F2: fun(C,B),G: fun(C,B),A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aa(fun(C,B),fun(C,B),aTP_Lamp_qo(fun(C,B),fun(fun(C,B),fun(C,B)),F2),G)),A3) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),F2),A3)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),G),A3)) ) ) ).

% prod_dividef
tff(fact_2096_prod__filter__eq__bot,axiom,
    ! [B: $tType,C: $tType,A3: filter(B),B2: filter(C)] :
      ( ( prod_filter(B,C,A3,B2) = bot_bot(filter(product_prod(B,C))) )
    <=> ( ( A3 = bot_bot(filter(B)) )
        | ( B2 = bot_bot(filter(C)) ) ) ) ).

% prod_filter_eq_bot
tff(fact_2097_abs__ge__zero,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,abs_abs(B),A4)) ) ).

% abs_ge_zero
tff(fact_2098_abs__triangle__ineq,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3))),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),B3))) ) ).

% abs_triangle_ineq
tff(fact_2099_abs__triangle__ineq2,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),B3))),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3))) ) ).

% abs_triangle_ineq2
tff(fact_2100_abs__triangle__ineq3,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),B3)))),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3))) ) ).

% abs_triangle_ineq3
tff(fact_2101_abs__triangle__ineq2__sym,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),B3))),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4))) ) ).

% abs_triangle_ineq2_sym
tff(fact_2102_abs__leI,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A4)),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A4)),B3) ) ) ) ).

% abs_leI
tff(fact_2103_abs__le__D2,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A4)),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A4)),B3) ) ) ).

% abs_le_D2
tff(fact_2104_abs__le__iff,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A4)),B3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A4)),B3) ) ) ) ).

% abs_le_iff
tff(fact_2105_abs__ge__minus__self,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A4)),aa(B,B,abs_abs(B),A4)) ) ).

% abs_ge_minus_self
tff(fact_2106_frac__eq__eq,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Y: B,Z2: B,X2: B,W2: B] :
          ( ( Y != zero_zero(B) )
         => ( ( Z2 != zero_zero(B) )
           => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y) = aa(B,B,aa(B,fun(B,B),divide_divide(B),W2),Z2) )
            <=> ( aa(B,B,aa(B,fun(B,B),times_times(B),X2),Z2) = aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y) ) ) ) ) ) ).

% frac_eq_eq
tff(fact_2107_divide__eq__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) = A4 )
        <=> $ite(Ca != zero_zero(B),B3 = aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca),A4 = zero_zero(B)) ) ) ).

% divide_eq_eq
tff(fact_2108_eq__divide__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) )
        <=> $ite(Ca != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca) = B3,A4 = zero_zero(B)) ) ) ).

% eq_divide_eq
tff(fact_2109_divide__eq__imp,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( ( Ca != zero_zero(B) )
         => ( ( B3 = aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca) )
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) = A4 ) ) ) ) ).

% divide_eq_imp
tff(fact_2110_eq__divide__imp,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( ( Ca != zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca) = B3 )
           => ( A4 = aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) ) ) ) ) ).

% eq_divide_imp
tff(fact_2111_nonzero__divide__eq__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( ( Ca != zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) = A4 )
          <=> ( B3 = aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca) ) ) ) ) ).

% nonzero_divide_eq_eq
tff(fact_2112_nonzero__eq__divide__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( ( Ca != zero_zero(B) )
         => ( ( A4 = aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) )
          <=> ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca) = B3 ) ) ) ) ).

% nonzero_eq_divide_eq
tff(fact_2113_right__inverse__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [B3: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) = one_one(B) )
          <=> ( A4 = B3 ) ) ) ) ).

% right_inverse_eq
tff(fact_2114_abs__eq__mult,axiom,
    ! [B: $tType] :
      ( ordered_ring_abs(B)
     => ! [A4: B,B3: B] :
          ( ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
              | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B)) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3)
              | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),zero_zero(B)) ) )
         => ( aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),B3)) ) ) ) ).

% abs_eq_mult
tff(fact_2115_abs__mult__pos,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),Y)),X2) = aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),times_times(B),Y),X2)) ) ) ) ).

% abs_mult_pos
tff(fact_2116_abs__minus__le__zero,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(B,B,abs_abs(B),A4))),zero_zero(B)) ) ).

% abs_minus_le_zero
tff(fact_2117_abs__eq__iff_H,axiom,
    ! [B: $tType] :
      ( linordered_ring(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,abs_abs(B),A4) = B3 )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3)
            & ( ( A4 = B3 )
              | ( A4 = aa(B,B,uminus_uminus(B),B3) ) ) ) ) ) ).

% abs_eq_iff'
tff(fact_2118_eq__abs__iff_H,axiom,
    ! [B: $tType] :
      ( linordered_ring(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = aa(B,B,abs_abs(B),B3) )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
            & ( ( B3 = A4 )
              | ( B3 = aa(B,B,uminus_uminus(B),A4) ) ) ) ) ) ).

% eq_abs_iff'
tff(fact_2119_abs__triangle__ineq4,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3))),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),B3))) ) ).

% abs_triangle_ineq4
tff(fact_2120_abs__diff__triangle__ineq,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),D3)))),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),Ca))),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),D3)))) ) ).

% abs_diff_triangle_ineq
tff(fact_2121_abs__diff__le__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B,A4: B,R2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),A4))),R2)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),R2)),X2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),R2)) ) ) ) ).

% abs_diff_le_iff
tff(fact_2122_cSup__abs__le,axiom,
    ! [B: $tType] :
      ( ( condit6923001295902523014norder(B)
        & linordered_idom(B) )
     => ! [S: set(B),A4: B] :
          ( ( S != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),X)),A4) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(set(B),B,complete_Sup_Sup(B),S))),A4) ) ) ) ).

% cSup_abs_le
tff(fact_2123_prod__filter__mono__iff,axiom,
    ! [B: $tType,C: $tType,A3: filter(B),B2: filter(C),C2: filter(B),D2: filter(C)] :
      ( ( A3 != bot_bot(filter(B)) )
     => ( ( B2 != bot_bot(filter(C)) )
       => ( aa(filter(product_prod(B,C)),$o,aa(filter(product_prod(B,C)),fun(filter(product_prod(B,C)),$o),ord_less_eq(filter(product_prod(B,C))),prod_filter(B,C,A3,B2)),prod_filter(B,C,C2,D2))
        <=> ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),A3),C2)
            & aa(filter(C),$o,aa(filter(C),fun(filter(C),$o),ord_less_eq(filter(C)),B2),D2) ) ) ) ) ).

% prod_filter_mono_iff
tff(fact_2124_add__divide__eq__if__simps_I2_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,Z2: B,B3: B] :
          ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),Z2)),B3)
          = $ite(Z2 = zero_zero(B),B3,aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Z2))),Z2)) ) ) ).

% add_divide_eq_if_simps(2)
tff(fact_2125_add__divide__eq__if__simps_I1_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B,Z2: B] :
          ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Z2))
          = $ite(Z2 = zero_zero(B),A4,aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Z2)),B3)),Z2)) ) ) ).

% add_divide_eq_if_simps(1)
tff(fact_2126_add__frac__eq,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Y: B,Z2: B,X2: B,W2: B] :
          ( ( Y != zero_zero(B) )
         => ( ( Z2 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)),aa(B,B,aa(B,fun(B,B),divide_divide(B),W2),Z2)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y))),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2)) ) ) ) ) ).

% add_frac_eq
tff(fact_2127_add__frac__num,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Y: B,X2: B,Z2: B] :
          ( ( Y != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)),Z2) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y))),Y) ) ) ) ).

% add_frac_num
tff(fact_2128_add__num__frac,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Y: B,Z2: B,X2: B] :
          ( ( Y != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y))),Y) ) ) ) ).

% add_num_frac
tff(fact_2129_add__divide__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),aa(B,B,aa(B,fun(B,B),divide_divide(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Z2)),Y)),Z2) ) ) ) ).

% add_divide_eq_iff
tff(fact_2130_divide__add__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Z2)),Y) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))),Z2) ) ) ) ).

% divide_add_eq_iff
tff(fact_2131_add__divide__eq__if__simps_I4_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B,Z2: B] :
          ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Z2))
          = $ite(Z2 = zero_zero(B),A4,aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Z2)),B3)),Z2)) ) ) ).

% add_divide_eq_if_simps(4)
tff(fact_2132_diff__frac__eq,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Y: B,Z2: B,X2: B,W2: B] :
          ( ( Y != zero_zero(B) )
         => ( ( Z2 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)),aa(B,B,aa(B,fun(B,B),divide_divide(B),W2),Z2)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y))),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2)) ) ) ) ) ).

% diff_frac_eq
tff(fact_2133_diff__divide__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),aa(B,B,aa(B,fun(B,B),divide_divide(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Z2)),Y)),Z2) ) ) ) ).

% diff_divide_eq_iff
tff(fact_2134_divide__diff__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Z2)),Y) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))),Z2) ) ) ) ).

% divide_diff_eq_iff
tff(fact_2135_eq__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( A4 = aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)) )
        <=> $ite(Ca != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca) = aa(B,B,uminus_uminus(B),B3),A4 = zero_zero(B)) ) ) ).

% eq_minus_divide_eq
tff(fact_2136_minus__divide__eq__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)) = A4 )
        <=> $ite(Ca != zero_zero(B),aa(B,B,uminus_uminus(B),B3) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca),A4 = zero_zero(B)) ) ) ).

% minus_divide_eq_eq
tff(fact_2137_nonzero__neg__divide__eq__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( ( B3 != zero_zero(B) )
         => ( ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) = Ca )
          <=> ( aa(B,B,uminus_uminus(B),A4) = aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
tff(fact_2138_nonzero__neg__divide__eq__eq2,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => ( ( Ca = aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) )
          <=> ( aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3) = aa(B,B,uminus_uminus(B),A4) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
tff(fact_2139_divide__eq__minus__1__iff,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) = aa(B,B,uminus_uminus(B),one_one(B)) )
        <=> ( ( B3 != zero_zero(B) )
            & ( A4 = aa(B,B,uminus_uminus(B),B3) ) ) ) ) ).

% divide_eq_minus_1_iff
tff(fact_2140_filterlim__Pair,axiom,
    ! [D: $tType,C: $tType,B: $tType,F2: fun(B,C),G3: filter(C),F: filter(B),G: fun(B,D),H8: filter(D)] :
      ( filterlim(B,C,F2,G3,F)
     => ( filterlim(B,D,G,H8,F)
       => filterlim(B,product_prod(C,D),aa(fun(B,D),fun(B,product_prod(C,D)),aTP_Lamp_qp(fun(B,C),fun(fun(B,D),fun(B,product_prod(C,D))),F2),G),prod_filter(C,D,G3,H8),F) ) ) ).

% filterlim_Pair
tff(fact_2141_filtermap__Pair,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(D,B),G: fun(D,C),F: filter(D)] : aa(filter(product_prod(B,C)),$o,aa(filter(product_prod(B,C)),fun(filter(product_prod(B,C)),$o),ord_less_eq(filter(product_prod(B,C))),filtermap(D,product_prod(B,C),aa(fun(D,C),fun(D,product_prod(B,C)),aTP_Lamp_co(fun(D,B),fun(fun(D,C),fun(D,product_prod(B,C))),F2),G),F)),prod_filter(B,C,filtermap(D,B,F2,F),filtermap(D,C,G,F))) ).

% filtermap_Pair
tff(fact_2142_principal__prod__principal,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] : ( prod_filter(B,C,principal(B,A3),principal(C,B2)) = principal(product_prod(B,C),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))) ) ).

% principal_prod_principal
tff(fact_2143_fst__diag__id,axiom,
    ! [B: $tType,Z2: B] : ( aa(B,B,aa(fun(B,product_prod(B,B)),fun(B,B),comp(product_prod(B,B),B,B,product_fst(B,B)),aTP_Lamp_hn(B,product_prod(B,B))),Z2) = aa(B,B,id(B),Z2) ) ).

% fst_diag_id
tff(fact_2144_snd__diag__id,axiom,
    ! [B: $tType,Z2: B] : ( aa(B,B,aa(fun(B,product_prod(B,B)),fun(B,B),comp(product_prod(B,B),B,B,product_snd(B,B)),aTP_Lamp_hn(B,product_prod(B,B))),Z2) = aa(B,B,id(B),Z2) ) ).

% snd_diag_id
tff(fact_2145_prod__filter__def,axiom,
    ! [B: $tType,C: $tType,F: filter(B),G3: filter(C)] : ( prod_filter(B,C,F,G3) = aa(set(filter(product_prod(B,C))),filter(product_prod(B,C)),complete_Inf_Inf(filter(product_prod(B,C))),aa(set(product_prod(fun(B,$o),fun(C,$o))),set(filter(product_prod(B,C))),image2(product_prod(fun(B,$o),fun(C,$o)),filter(product_prod(B,C)),aa(fun(fun(B,$o),fun(fun(C,$o),filter(product_prod(B,C)))),fun(product_prod(fun(B,$o),fun(C,$o)),filter(product_prod(B,C))),product_case_prod(fun(B,$o),fun(C,$o),filter(product_prod(B,C))),aTP_Lamp_qq(fun(B,$o),fun(fun(C,$o),filter(product_prod(B,C)))))),aa(fun(product_prod(fun(B,$o),fun(C,$o)),$o),set(product_prod(fun(B,$o),fun(C,$o))),collect(product_prod(fun(B,$o),fun(C,$o))),aa(fun(fun(B,$o),fun(fun(C,$o),$o)),fun(product_prod(fun(B,$o),fun(C,$o)),$o),product_case_prod(fun(B,$o),fun(C,$o),$o),aa(filter(C),fun(fun(B,$o),fun(fun(C,$o),$o)),aTP_Lamp_qr(filter(B),fun(filter(C),fun(fun(B,$o),fun(fun(C,$o),$o))),F),G3))))) ) ).

% prod_filter_def
tff(fact_2146_frac__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,Z2: B,X2: B,W2: B] :
          ( ( Y != zero_zero(B) )
         => ( ( Z2 != zero_zero(B) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)),aa(B,B,aa(B,fun(B,B),divide_divide(B),W2),Z2))
            <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y))),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))),zero_zero(B)) ) ) ) ) ).

% frac_le_eq
tff(fact_2147_minus__divide__add__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Z2))),Y) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))),Z2) ) ) ) ).

% minus_divide_add_eq_iff
tff(fact_2148_add__divide__eq__if__simps_I3_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,Z2: B,B3: B] :
          ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),Z2))),B3)
          = $ite(Z2 = zero_zero(B),B3,aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Z2))),Z2)) ) ) ).

% add_divide_eq_if_simps(3)
tff(fact_2149_add__divide__eq__if__simps_I6_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,Z2: B,B3: B] :
          ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),Z2))),B3)
          = $ite(Z2 = zero_zero(B),aa(B,B,uminus_uminus(B),B3),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Z2))),Z2)) ) ) ).

% add_divide_eq_if_simps(6)
tff(fact_2150_add__divide__eq__if__simps_I5_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,Z2: B,B3: B] :
          ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),Z2)),B3)
          = $ite(Z2 = zero_zero(B),aa(B,B,uminus_uminus(B),B3),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Z2))),Z2)) ) ) ).

% add_divide_eq_if_simps(5)
tff(fact_2151_minus__divide__diff__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Z2))),Y) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))),Z2) ) ) ) ).

% minus_divide_diff_eq_iff
tff(fact_2152_eventually__prodI,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),F: filter(B),Qa: fun(C,$o),G3: filter(C)] :
      ( eventually(B,Pa,F)
     => ( eventually(C,Qa,G3)
       => eventually(product_prod(B,C),aa(fun(C,$o),fun(product_prod(B,C),$o),aTP_Lamp_qs(fun(B,$o),fun(fun(C,$o),fun(product_prod(B,C),$o)),Pa),Qa),prod_filter(B,C,F,G3)) ) ) ).

% eventually_prodI
tff(fact_2153_If__the__inv__into__f__f,axiom,
    ! [C: $tType,B: $tType,I2: B,C2: set(B),G: fun(B,C),X2: B] :
      ( aa(set(B),$o,member(B,I2),C2)
     => ( inj_on(B,C,G,C2)
       => ( aa(B,B,aa(fun(B,C),fun(B,B),comp(C,B,B,aa(B,fun(C,B),aa(fun(B,C),fun(B,fun(C,B)),aTP_Lamp_qt(set(B),fun(fun(B,C),fun(B,fun(C,B))),C2),G),X2)),G),I2) = aa(B,B,id(B),I2) ) ) ) ).

% If_the_inv_into_f_f
tff(fact_2154_eventually__prod1,axiom,
    ! [B: $tType,C: $tType,B2: filter(B),Pa: fun(C,$o),A3: filter(C)] :
      ( ( B2 != bot_bot(filter(B)) )
     => ( eventually(product_prod(C,B),aa(fun(C,fun(B,$o)),fun(product_prod(C,B),$o),product_case_prod(C,B,$o),aTP_Lamp_qu(fun(C,$o),fun(C,fun(B,$o)),Pa)),prod_filter(C,B,A3,B2))
      <=> eventually(C,Pa,A3) ) ) ).

% eventually_prod1
tff(fact_2155_eventually__prod2,axiom,
    ! [B: $tType,C: $tType,A3: filter(B),Pa: fun(C,$o),B2: filter(C)] :
      ( ( A3 != bot_bot(filter(B)) )
     => ( eventually(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_qv(fun(C,$o),fun(B,fun(C,$o)),Pa)),prod_filter(B,C,A3,B2))
      <=> eventually(C,Pa,B2) ) ) ).

% eventually_prod2
tff(fact_2156_prod__filter__INF2,axiom,
    ! [D: $tType,C: $tType,B: $tType,J: set(B),A3: filter(C),B2: fun(B,filter(D))] :
      ( ( J != bot_bot(set(B)) )
     => ( prod_filter(C,D,A3,aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(B),set(filter(D)),image2(B,filter(D),B2),J))) = aa(set(filter(product_prod(C,D))),filter(product_prod(C,D)),complete_Inf_Inf(filter(product_prod(C,D))),aa(set(B),set(filter(product_prod(C,D))),image2(B,filter(product_prod(C,D)),aa(fun(B,filter(D)),fun(B,filter(product_prod(C,D))),aTP_Lamp_qw(filter(C),fun(fun(B,filter(D)),fun(B,filter(product_prod(C,D)))),A3),B2)),J)) ) ) ).

% prod_filter_INF2
tff(fact_2157_prod__filter__INF1,axiom,
    ! [D: $tType,C: $tType,B: $tType,I: set(B),A3: fun(B,filter(C)),B2: filter(D)] :
      ( ( I != bot_bot(set(B)) )
     => ( prod_filter(C,D,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),A3),I)),B2) = aa(set(filter(product_prod(C,D))),filter(product_prod(C,D)),complete_Inf_Inf(filter(product_prod(C,D))),aa(set(B),set(filter(product_prod(C,D))),image2(B,filter(product_prod(C,D)),aa(filter(D),fun(B,filter(product_prod(C,D))),aTP_Lamp_qx(fun(B,filter(C)),fun(filter(D),fun(B,filter(product_prod(C,D)))),A3),B2)),I)) ) ) ).

% prod_filter_INF1
tff(fact_2158_prod__filter__INF,axiom,
    ! [C: $tType,E: $tType,D: $tType,B: $tType,I: set(B),J: set(C),A3: fun(B,filter(D)),B2: fun(C,filter(E))] :
      ( ( I != bot_bot(set(B)) )
     => ( ( J != bot_bot(set(C)) )
       => ( prod_filter(D,E,aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(B),set(filter(D)),image2(B,filter(D),A3),I)),aa(set(filter(E)),filter(E),complete_Inf_Inf(filter(E)),aa(set(C),set(filter(E)),image2(C,filter(E),B2),J))) = aa(set(filter(product_prod(D,E))),filter(product_prod(D,E)),complete_Inf_Inf(filter(product_prod(D,E))),aa(set(B),set(filter(product_prod(D,E))),image2(B,filter(product_prod(D,E)),aa(fun(C,filter(E)),fun(B,filter(product_prod(D,E))),aa(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,filter(product_prod(D,E)))),aTP_Lamp_qz(set(C),fun(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,filter(product_prod(D,E))))),J),A3),B2)),I)) ) ) ) ).

% prod_filter_INF
tff(fact_2159_scaling__mono,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [U: B,V: B,R2: B,S2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),V)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),R2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),R2),S2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),U),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),R2),aa(B,B,aa(B,fun(B,B),minus_minus(B),V),U))),S2))),V) ) ) ) ) ).

% scaling_mono
tff(fact_2160_prod__filter__principal__singleton,axiom,
    ! [B: $tType,C: $tType,X2: B,F: filter(C)] : ( prod_filter(B,C,principal(B,aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))),F) = filtermap(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),F) ) ).

% prod_filter_principal_singleton
tff(fact_2161_div__mult__self1,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( ( B3 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) ) ) ) ).

% div_mult_self1
tff(fact_2162_div__mult__self2,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( ( B3 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) ) ) ) ).

% div_mult_self2
tff(fact_2163_div__mult__self3,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)),A4)),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) ) ) ) ).

% div_mult_self3
tff(fact_2164_div__mult__self4,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)),A4)),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) ) ) ) ).

% div_mult_self4
tff(fact_2165_Inf__atMost,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [X2: B] : ( aa(set(B),B,complete_Inf_Inf(B),aa(B,set(B),set_ord_atMost(B),X2)) = bot_bot(B) ) ) ).

% Inf_atMost
tff(fact_2166_div__minus1__right,axiom,
    ! [B: $tType] :
      ( euclid8851590272496341667cancel(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),A4) ) ) ).

% div_minus1_right
tff(fact_2167_div__mult__mult1,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( ( Ca != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) ) ) ) ).

% div_mult_mult1
tff(fact_2168_finite__Collect__le__nat,axiom,
    ! [K: nat] : aa(set(nat),$o,finite_finite2(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_ra(nat,fun(nat,$o)),K))) ).

% finite_Collect_le_nat
tff(fact_2169_atMost__0,axiom,
    aa(nat,set(nat),set_ord_atMost(nat),zero_zero(nat)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))) ).

% atMost_0
tff(fact_2170_div__mult__mult1__if,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
          = $ite(Ca = zero_zero(B),zero_zero(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) ) ) ).

% div_mult_mult1_if
tff(fact_2171_div__mult__mult2,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( ( Ca != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) ) ) ) ).

% div_mult_mult2
tff(fact_2172_finite__less__ub,axiom,
    ! [F2: fun(nat,nat),U: nat] :
      ( ! [N2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N2),aa(nat,nat,F2,N2))
     => aa(set(nat),$o,finite_finite2(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_rb(fun(nat,nat),fun(nat,fun(nat,$o)),F2),U))) ) ).

% finite_less_ub
tff(fact_2173_not__empty__eq__Iic__eq__empty,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [H2: B] : ( bot_bot(set(B)) != aa(B,set(B),set_ord_atMost(B),H2) ) ) ).

% not_empty_eq_Iic_eq_empty
tff(fact_2174_sum_Otriangle__reindex__eq,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,fun(nat,B)),N: nat] : ( aa(set(product_prod(nat,nat)),B,aa(fun(product_prod(nat,nat),B),fun(set(product_prod(nat,nat)),B),groups7311177749621191930dd_sum(product_prod(nat,nat),B),aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),G)),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_rc(nat,fun(nat,fun(nat,$o)),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_re(fun(nat,fun(nat,B)),fun(nat,B),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% sum.triangle_reindex_eq
tff(fact_2175_prod_Otriangle__reindex__eq,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,fun(nat,B)),N: nat] : ( aa(set(product_prod(nat,nat)),B,aa(fun(product_prod(nat,nat),B),fun(set(product_prod(nat,nat)),B),groups7121269368397514597t_prod(product_prod(nat,nat),B),aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),G)),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_rc(nat,fun(nat,fun(nat,$o)),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_rg(fun(nat,fun(nat,B)),fun(nat,B),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% prod.triangle_reindex_eq
tff(fact_2176_atMost__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [U: B] : ( aa(B,set(B),set_ord_atMost(B),U) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_rh(B,fun(B,$o),U)) ) ) ).

% atMost_def
tff(fact_2177_atMost__eq__UNIV__iff,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [X2: B] :
          ( ( aa(B,set(B),set_ord_atMost(B),X2) = top_top(set(B)) )
        <=> ( X2 = top_top(B) ) ) ) ).

% atMost_eq_UNIV_iff
tff(fact_2178_div__add__self1,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [B3: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4)),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),one_one(B)) ) ) ) ).

% div_add_self1
tff(fact_2179_div__add__self2,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [B3: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),B3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),one_one(B)) ) ) ) ).

% div_add_self2
tff(fact_2180_cInf__asclose,axiom,
    ! [B: $tType] :
      ( ( condit6923001295902523014norder(B)
        & linordered_idom(B) )
     => ! [S: set(B),L: B,E2: B] :
          ( ( S != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),L))),E2) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(B),B,complete_Inf_Inf(B),S)),L))),E2) ) ) ) ).

% cInf_asclose
tff(fact_2181_cSup__asclose,axiom,
    ! [B: $tType] :
      ( ( condit6923001295902523014norder(B)
        & linordered_idom(B) )
     => ! [S: set(B),L: B,E2: B] :
          ( ( S != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),L))),E2) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(B),B,complete_Sup_Sup(B),S)),L))),E2) ) ) ) ).

% cSup_asclose
tff(fact_2182_bits__div__by__1,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),one_one(B)) = A4 ) ) ).

% bits_div_by_1
tff(fact_2183_cInf__abs__ge,axiom,
    ! [B: $tType] :
      ( ( condit6923001295902523014norder(B)
        & linordered_idom(B) )
     => ! [S: set(B),A4: B] :
          ( ( S != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),X)),A4) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(set(B),B,complete_Inf_Inf(B),S))),A4) ) ) ) ).

% cInf_abs_ge
tff(fact_2184_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),Ca) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
tff(fact_2185_inj__on__diff__nat,axiom,
    ! [N3: set(nat),K: nat] :
      ( ! [N2: nat] :
          ( aa(set(nat),$o,member(nat,N2),N3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N2) )
     => inj_on(nat,nat,aTP_Lamp_ri(nat,fun(nat,nat),K),N3) ) ).

% inj_on_diff_nat
tff(fact_2186_card__UN__disjoint,axiom,
    ! [C: $tType,B: $tType,I: set(B),A3: fun(B,set(C))] :
      ( aa(set(B),$o,finite_finite2(B),I)
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),I)
           => aa(set(C),$o,finite_finite2(C),aa(B,set(C),A3,X)) )
       => ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),I)
             => ! [Xa4: B] :
                  ( aa(set(B),$o,member(B,Xa4),I)
                 => ( ( X != Xa4 )
                   => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A3,X)),aa(B,set(C),A3,Xa4)) = bot_bot(set(C)) ) ) ) )
         => ( aa(set(C),nat,finite_card(C),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I))) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aTP_Lamp_rj(fun(B,set(C)),fun(B,nat),A3)),I) ) ) ) ) ).

% card_UN_disjoint
tff(fact_2187_card_Oempty,axiom,
    ! [B: $tType] : ( aa(set(B),nat,finite_card(B),bot_bot(set(B))) = zero_zero(nat) ) ).

% card.empty
tff(fact_2188_card__0__eq,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( ( aa(set(B),nat,finite_card(B),A3) = zero_zero(nat) )
      <=> ( A3 = bot_bot(set(B)) ) ) ) ).

% card_0_eq
tff(fact_2189_card__SigmaI,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: fun(B,set(C))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),A3)
           => aa(set(C),$o,finite_finite2(C),aa(B,set(C),B2,X)) )
       => ( aa(set(product_prod(B,C)),nat,finite_card(product_prod(B,C)),product_Sigma(B,C,A3,B2)) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aTP_Lamp_rj(fun(B,set(C)),fun(B,nat),B2)),A3) ) ) ) ).

% card_SigmaI
tff(fact_2190_UN__atMost__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Sup_Sup(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),set_ord_atMost(nat)),top_top(set(nat)))) = top_top(set(nat)) ).

% UN_atMost_UNIV
tff(fact_2191_card__cartesian__product,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] : ( aa(set(product_prod(B,C)),nat,finite_card(product_prod(B,C)),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(B),nat,finite_card(B),A3)),aa(set(C),nat,finite_card(C),B2)) ) ).

% card_cartesian_product
tff(fact_2192_card__cartesian__product__singleton,axiom,
    ! [B: $tType,C: $tType,X2: B,A3: set(C)] : ( aa(set(product_prod(B,C)),nat,finite_card(product_prod(B,C)),product_Sigma(B,C,aa(set(B),set(B),insert(B,X2),bot_bot(set(B))),aTP_Lamp_bq(set(C),fun(B,set(C)),A3))) = aa(set(C),nat,finite_card(C),A3) ) ).

% card_cartesian_product_singleton
tff(fact_2193_card__eq__sum,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),nat,finite_card(B),A3) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aTP_Lamp_rk(B,nat)),A3) ) ).

% card_eq_sum
tff(fact_2194_card__1__singletonE,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ( aa(set(B),nat,finite_card(B),A3) = one_one(nat) )
     => ~ ! [X: B] : ( A3 != aa(set(B),set(B),insert(B,X),bot_bot(set(B))) ) ) ).

% card_1_singletonE
tff(fact_2195_card__partition,axiom,
    ! [B: $tType,C2: set(set(B)),K: nat] :
      ( aa(set(set(B)),$o,finite_finite2(set(B)),C2)
     => ( aa(set(B),$o,finite_finite2(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C2))
       => ( ! [C3: set(B)] :
              ( aa(set(set(B)),$o,member(set(B),C3),C2)
             => ( aa(set(B),nat,finite_card(B),C3) = K ) )
         => ( ! [C1: set(B),C22: set(B)] :
                ( aa(set(set(B)),$o,member(set(B),C1),C2)
               => ( aa(set(set(B)),$o,member(set(B),C22),C2)
                 => ( ( C1 != C22 )
                   => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C1),C22) = bot_bot(set(B)) ) ) ) )
           => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(set(set(B)),nat,finite_card(set(B)),C2)) = aa(set(B),nat,finite_card(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C2)) ) ) ) ) ) ).

% card_partition
tff(fact_2196_sum__multicount,axiom,
    ! [B: $tType,C: $tType,S: set(B),T2: set(C),R: fun(B,fun(C,$o)),K: nat] :
      ( aa(set(B),$o,finite_finite2(B),S)
     => ( aa(set(C),$o,finite_finite2(C),T2)
       => ( ! [X: C] :
              ( aa(set(C),$o,member(C,X),T2)
             => ( aa(set(B),nat,finite_card(B),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aa(fun(B,fun(C,$o)),fun(C,fun(B,$o)),aTP_Lamp_ko(set(B),fun(fun(B,fun(C,$o)),fun(C,fun(B,$o))),S),R),X))) = K ) )
         => ( aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(fun(B,fun(C,$o)),fun(B,nat),aTP_Lamp_rl(set(C),fun(fun(B,fun(C,$o)),fun(B,nat)),T2),R)),S) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(set(C),nat,finite_card(C),T2)) ) ) ) ) ).

% sum_multicount
tff(fact_2197_sum__multicount__gen,axiom,
    ! [B: $tType,C: $tType,S2: set(B),T3: set(C),R: fun(B,fun(C,$o)),K: fun(C,nat)] :
      ( aa(set(B),$o,finite_finite2(B),S2)
     => ( aa(set(C),$o,finite_finite2(C),T3)
       => ( ! [X: C] :
              ( aa(set(C),$o,member(C,X),T3)
             => ( aa(set(B),nat,finite_card(B),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aa(fun(B,fun(C,$o)),fun(C,fun(B,$o)),aTP_Lamp_ko(set(B),fun(fun(B,fun(C,$o)),fun(C,fun(B,$o))),S2),R),X))) = aa(C,nat,K,X) ) )
         => ( aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(fun(B,fun(C,$o)),fun(B,nat),aTP_Lamp_rl(set(C),fun(fun(B,fun(C,$o)),fun(B,nat)),T3),R)),S2) = aa(set(C),nat,aa(fun(C,nat),fun(set(C),nat),groups7311177749621191930dd_sum(C,nat),K),T3) ) ) ) ) ).

% sum_multicount_gen
tff(fact_2198_card__eq__0__iff,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ( aa(set(B),nat,finite_card(B),A3) = zero_zero(nat) )
    <=> ( ( A3 = bot_bot(set(B)) )
        | ~ aa(set(B),$o,finite_finite2(B),A3) ) ) ).

% card_eq_0_iff
tff(fact_2199_card__1__singletonI,axiom,
    ! [B: $tType,S: set(B),X2: B] :
      ( aa(set(B),$o,finite_finite2(B),S)
     => ( ( aa(set(B),nat,finite_card(B),S) = one_one(nat) )
       => ( aa(set(B),$o,member(B,X2),S)
         => ( S = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) ) ) ) ).

% card_1_singletonI
tff(fact_2200_card__quotient__disjoint,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( inj_on(B,set(set(B)),aTP_Lamp_js(set(product_prod(B,B)),fun(B,set(set(B))),R2),A3)
       => ( aa(set(set(B)),nat,finite_card(set(B)),equiv_quotient(B,A3,R2)) = aa(set(B),nat,finite_card(B),A3) ) ) ) ).

% card_quotient_disjoint
tff(fact_2201_bot__nat__def,axiom,
    bot_bot(nat) = zero_zero(nat) ).

% bot_nat_def
tff(fact_2202_card__Diff1__le,axiom,
    ! [B: $tType,A3: set(B),X2: B] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))),aa(set(B),nat,finite_card(B),A3)) ).

% card_Diff1_le
tff(fact_2203_card__Diff__singleton,axiom,
    ! [B: $tType,X2: B,A3: set(B)] :
      ( aa(set(B),$o,member(B,X2),A3)
     => ( aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,finite_card(B),A3)),one_one(nat)) ) ) ).

% card_Diff_singleton
tff(fact_2204_card__Diff__singleton__if,axiom,
    ! [B: $tType,A3: set(B),X2: B] :
      ( aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))
      = $ite(aa(set(B),$o,member(B,X2),A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,finite_card(B),A3)),one_one(nat)),aa(set(B),nat,finite_card(B),A3)) ) ).

% card_Diff_singleton_if
tff(fact_2205_card__Un__Int,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),$o,finite_finite2(B),B2)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(B),nat,finite_card(B),A3)),aa(set(B),nat,finite_card(B),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))),aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ) ).

% card_Un_Int
tff(fact_2206_card__Diff__subset__Int,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))
     => ( aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,finite_card(B),A3)),aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ).

% card_Diff_subset_Int
tff(fact_2207_card__Un__disjoint,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),$o,finite_finite2(B),B2)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
         => ( aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(B),nat,finite_card(B),A3)),aa(set(B),nat,finite_card(B),B2)) ) ) ) ) ).

% card_Un_disjoint
tff(fact_2208_card__vimage__inj__on__le,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),D2: set(B),A3: set(C)] :
      ( inj_on(B,C,F2,D2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),A3)),D2))),aa(set(C),nat,finite_card(C),A3)) ) ) ).

% card_vimage_inj_on_le
tff(fact_2209_card__UN__le,axiom,
    ! [C: $tType,B: $tType,I: set(B),A3: fun(B,set(C))] :
      ( aa(set(B),$o,finite_finite2(B),I)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(C),nat,finite_card(C),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A3),I)))),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aTP_Lamp_rj(fun(B,set(C)),fun(B,nat),A3)),I)) ) ).

% card_UN_le
tff(fact_2210_sum__card__image,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,set(C))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( pairwise(B,aTP_Lamp_rm(fun(B,set(C)),fun(B,fun(B,$o)),F2),A3)
       => ( aa(set(set(C)),nat,aa(fun(set(C),nat),fun(set(set(C)),nat),groups7311177749621191930dd_sum(set(C),nat),finite_card(C)),aa(set(B),set(set(C)),image2(B,set(C),F2),A3)) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aTP_Lamp_rj(fun(B,set(C)),fun(B,nat),F2)),A3) ) ) ) ).

% sum_card_image
tff(fact_2211_sum__zero__power_H,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Ca: fun(nat,B),D3: fun(nat,B),A3: set(nat)] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,B),fun(nat,B),aTP_Lamp_rn(fun(nat,B),fun(fun(nat,B),fun(nat,B)),Ca),D3)),A3)
          = $ite(
              ( aa(set(nat),$o,finite_finite2(nat),A3)
              & aa(set(nat),$o,member(nat,zero_zero(nat)),A3) ),
              aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(nat,B,Ca,zero_zero(nat))),aa(nat,B,D3,zero_zero(nat))),
              zero_zero(B) ) ) ) ).

% sum_zero_power'
tff(fact_2212_sum__zero__power,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ca: fun(nat,B),A3: set(nat)] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_ro(fun(nat,B),fun(nat,B),Ca)),A3)
          = $ite(
              ( aa(set(nat),$o,finite_finite2(nat),A3)
              & aa(set(nat),$o,member(nat,zero_zero(nat)),A3) ),
              aa(nat,B,Ca,zero_zero(nat)),
              zero_zero(B) ) ) ) ).

% sum_zero_power
tff(fact_2213_sum__fun__comp,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( semiring_1(D)
     => ! [S: set(B),R: set(C),G: fun(B,C),F2: fun(C,D)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(C),$o,finite_finite2(C),R)
           => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,G),S)),R)
             => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(fun(C,D),fun(B,D),aTP_Lamp_rp(fun(B,C),fun(fun(C,D),fun(B,D)),G),F2)),S) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),aa(fun(C,D),fun(C,D),aa(fun(B,C),fun(fun(C,D),fun(C,D)),aTP_Lamp_rq(set(B),fun(fun(B,C),fun(fun(C,D),fun(C,D))),S),G),F2)),R) ) ) ) ) ) ).

% sum_fun_comp
tff(fact_2214_prod__le__power,axiom,
    ! [B: $tType,C: $tType] :
      ( linordered_semidom(C)
     => ! [A3: set(B),F2: fun(B,C),N: C,K: nat] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),A3)
             => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,F2,I3))
                & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I3)),N) ) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(B),nat,finite_card(B),A3)),K)
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),one_one(C)),N)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),A3)),aa(nat,C,aa(C,fun(nat,C),power_power(C),N),K)) ) ) ) ) ).

% prod_le_power
tff(fact_2215_sum__bounded__above__divide,axiom,
    ! [B: $tType,C: $tType] :
      ( linordered_field(C)
     => ! [A3: set(B),F2: fun(B,C),K4: C] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),A3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I3)),aa(C,C,aa(C,fun(C,C),divide_divide(C),K4),aa(nat,C,semiring_1_of_nat(C),aa(set(B),nat,finite_card(B),A3)))) )
         => ( aa(set(B),$o,finite_finite2(B),A3)
           => ( ( A3 != bot_bot(set(B)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),A3)),K4) ) ) ) ) ).

% sum_bounded_above_divide
tff(fact_2216_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [M2: B,Ca: B,A4: B,B3: B] :
          ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),aTP_Lamp_rr(B,fun(B,fun(B,B)),M2),Ca)),set_or1337092689740270186AtMost(B,A4,B3))
          = $ite(
              set_or1337092689740270186AtMost(B,A4,B3) = bot_bot(set(B)),
              bot_bot(set(B)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),M2),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),M2)),Ca),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),M2)),Ca)),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),M2)),Ca),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),M2)),Ca))) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
tff(fact_2217_power__one,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),one_one(B)),N) = one_one(B) ) ) ).

% power_one
tff(fact_2218_atLeastatMost__empty__iff2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B] :
          ( ( bot_bot(set(B)) = set_or1337092689740270186AtMost(B,A4,B3) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ).

% atLeastatMost_empty_iff2
tff(fact_2219_atLeastatMost__empty__iff,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B] :
          ( ( set_or1337092689740270186AtMost(B,A4,B3) = bot_bot(set(B)) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ).

% atLeastatMost_empty_iff
tff(fact_2220_atLeastAtMost__singleton__iff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( set_or1337092689740270186AtMost(B,A4,B3) = aa(set(B),set(B),insert(B,Ca),bot_bot(set(B))) )
        <=> ( ( A4 = B3 )
            & ( B3 = Ca ) ) ) ) ).

% atLeastAtMost_singleton_iff
tff(fact_2221_atLeastAtMost__singleton,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B] : ( set_or1337092689740270186AtMost(B,A4,A4) = aa(set(B),set(B),insert(B,A4),bot_bot(set(B))) ) ) ).

% atLeastAtMost_singleton
tff(fact_2222_of__nat__mult,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [M2: nat,N: nat] : ( aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M2),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),M2)),aa(nat,B,semiring_1_of_nat(B),N)) ) ) ).

% of_nat_mult
tff(fact_2223_of__nat__eq__1__iff,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: nat] :
          ( ( aa(nat,B,semiring_1_of_nat(B),N) = one_one(B) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_eq_1_iff
tff(fact_2224_of__nat__1__eq__iff,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: nat] :
          ( ( one_one(B) = aa(nat,B,semiring_1_of_nat(B),N) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_1_eq_iff
tff(fact_2225_of__nat__1,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ( aa(nat,B,semiring_1_of_nat(B),one_one(nat)) = one_one(B) ) ) ).

% of_nat_1
tff(fact_2226_image__add__atLeastAtMost_H,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [K: B,I2: B,J2: B] : ( aa(set(B),set(B),image2(B,B,aTP_Lamp_rs(B,fun(B,B),K)),set_or1337092689740270186AtMost(B,I2,J2)) = set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),K)) ) ) ).

% image_add_atLeastAtMost'
tff(fact_2227_image__minus__const__atLeastAtMost_H,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [D3: B,A4: B,B3: B] : ( aa(set(B),set(B),image2(B,B,aTP_Lamp_rt(B,fun(B,B),D3)),set_or1337092689740270186AtMost(B,A4,B3)) = set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),D3),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),D3)) ) ) ).

% image_minus_const_atLeastAtMost'
tff(fact_2228_prod__constant,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Y: B,A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aTP_Lamp_ru(B,fun(C,B),Y)),A3) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Y),aa(set(C),nat,finite_card(C),A3)) ) ) ).

% prod_constant
tff(fact_2229_left__minus__one__mult__self,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat,A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),A4)) = A4 ) ) ).

% left_minus_one_mult_self
tff(fact_2230_minus__one__mult__self,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)) = one_one(B) ) ) ).

% minus_one_mult_self
tff(fact_2231_sum__constant,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Y: B,A3: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aTP_Lamp_rv(B,fun(C,B),Y)),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(set(C),nat,finite_card(C),A3))),Y) ) ) ).

% sum_constant
tff(fact_2232_prod__int__plus__eq,axiom,
    ! [I2: nat,J2: nat] : ( aa(set(nat),int,aa(fun(nat,int),fun(set(nat),int),groups7121269368397514597t_prod(nat,int),semiring_1_of_nat(int)),set_or1337092689740270186AtMost(nat,I2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2))) = aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7121269368397514597t_prod(int,int),aTP_Lamp_rw(int,int)),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),I2),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2)))) ) ).

% prod_int_plus_eq
tff(fact_2233_pairwise__trivial,axiom,
    ! [B: $tType,I: set(B)] : pairwise(B,aTP_Lamp_rx(B,fun(B,$o)),I) ).

% pairwise_trivial
tff(fact_2234_mult__of__nat__commute,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [X2: nat,Y: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),X2)),Y) = aa(B,B,aa(B,fun(B,B),times_times(B),Y),aa(nat,B,semiring_1_of_nat(B),X2)) ) ) ).

% mult_of_nat_commute
tff(fact_2235_power__commuting__commutes,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [X2: B,Y: B,N: nat] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),X2),Y) = aa(B,B,aa(B,fun(B,B),times_times(B),Y),X2) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N)),Y) = aa(B,B,aa(B,fun(B,B),times_times(B),Y),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N)) ) ) ) ).

% power_commuting_commutes
tff(fact_2236_power__mult__distrib,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B,B3: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),B3),N)) ) ) ).

% power_mult_distrib
tff(fact_2237_power__commutes,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A4: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)),A4) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)) ) ) ).

% power_commutes
tff(fact_2238_prod__power__distrib,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_1(B)
     => ! [F2: fun(C,B),A3: set(C),N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),F2),A3)),N) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aa(nat,fun(C,B),aTP_Lamp_ry(fun(C,B),fun(nat,fun(C,B)),F2),N)),A3) ) ) ).

% prod_power_distrib
tff(fact_2239_pairwise__empty,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o))] : pairwise(B,Pa,bot_bot(set(B))) ).

% pairwise_empty
tff(fact_2240_atLeastAtMost__singleton_H,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = B3 )
         => ( set_or1337092689740270186AtMost(B,A4,B3) = aa(set(B),set(B),insert(B,A4),bot_bot(set(B))) ) ) ) ).

% atLeastAtMost_singleton'
tff(fact_2241_div__mult2__eq_H,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A4: B,M2: nat,N: nat] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),M2)),aa(nat,B,semiring_1_of_nat(B),N))) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(nat,B,semiring_1_of_nat(B),M2))),aa(nat,B,semiring_1_of_nat(B),N)) ) ) ).

% div_mult2_eq'
tff(fact_2242_one__le__power,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)) ) ) ).

% one_le_power
tff(fact_2243_left__right__inverse__power,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [X2: B,Y: B,N: nat] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),X2),Y) = one_one(B) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Y),N)) = one_one(B) ) ) ) ).

% left_right_inverse_power
tff(fact_2244_power__0,axiom,
    ! [B: $tType] :
      ( power(B)
     => ! [A4: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),zero_zero(nat)) = one_one(B) ) ) ).

% power_0
tff(fact_2245_power__one__over,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4)),N) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)) ) ) ).

% power_one_over
tff(fact_2246_pairwise__image,axiom,
    ! [B: $tType,C: $tType,R2: fun(B,fun(B,$o)),F2: fun(C,B),S2: set(C)] :
      ( pairwise(B,R2,aa(set(C),set(B),image2(C,B,F2),S2))
    <=> pairwise(C,aa(fun(C,B),fun(C,fun(C,$o)),aTP_Lamp_rz(fun(B,fun(B,$o)),fun(fun(C,B),fun(C,fun(C,$o))),R2),F2),S2) ) ).

% pairwise_image
tff(fact_2247_power__add,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A4: B,M2: nat,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)) ) ) ).

% power_add
tff(fact_2248_pairwise__disjnt__iff,axiom,
    ! [B: $tType,A16: set(set(B))] :
      ( pairwise(set(B),disjnt(B),A16)
    <=> ! [X3: B] : uniq(set(B),aa(B,fun(set(B),$o),aTP_Lamp_sa(set(set(B)),fun(B,fun(set(B),$o)),A16),X3)) ) ).

% pairwise_disjnt_iff
tff(fact_2249_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),M2: nat,K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_sb(fun(nat,B),fun(nat,fun(nat,B)),G),K)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% sum.shift_bounds_cl_nat_ivl
tff(fact_2250_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),M2: nat,K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_sc(fun(nat,B),fun(nat,fun(nat,B)),G),K)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% prod.shift_bounds_cl_nat_ivl
tff(fact_2251_power__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ca: B,F2: fun(C,nat),A3: set(C)] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),Ca),aa(set(C),nat,aa(fun(C,nat),fun(set(C),nat),groups7311177749621191930dd_sum(C,nat),F2),A3)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aa(fun(C,nat),fun(C,B),aTP_Lamp_sd(B,fun(fun(C,nat),fun(C,B)),Ca),F2)),A3) ) ) ).

% power_sum
tff(fact_2252_sum__power__shift,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [M2: nat,N: nat,X2: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),set_or1337092689740270186AtMost(nat,M2,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),M2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2)))) ) ) ) ).

% sum_power_shift
tff(fact_2253_atLeastAtMost__eq__UNIV__iff,axiom,
    ! [B: $tType] :
      ( bounded_lattice(B)
     => ! [X2: B,Y: B] :
          ( ( set_or1337092689740270186AtMost(B,X2,Y) = top_top(set(B)) )
        <=> ( ( X2 = bot_bot(B) )
            & ( Y = top_top(B) ) ) ) ) ).

% atLeastAtMost_eq_UNIV_iff
tff(fact_2254_pairwise__singleton,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o)),A3: B] : pairwise(B,Pa,aa(set(B),set(B),insert(B,A3),bot_bot(set(B)))) ).

% pairwise_singleton
tff(fact_2255_power__le__one,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)),one_one(B)) ) ) ) ).

% power_le_one
tff(fact_2256_power__0__left,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat] :
          ( aa(nat,B,aa(B,fun(nat,B),power_power(B),zero_zero(B)),N)
          = $ite(N = zero_zero(nat),one_one(B),zero_zero(B)) ) ) ).

% power_0_left
tff(fact_2257_power__increasing,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [N: nat,N3: nat,A4: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A4)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N3)) ) ) ) ).

% power_increasing
tff(fact_2258_power__minus,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [A4: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),A4)),N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)) ) ) ).

% power_minus
tff(fact_2259_sum_OatLeastAtMost__rev,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),N: nat,M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or1337092689740270186AtMost(nat,N,M2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_se(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),G),N),M2)),set_or1337092689740270186AtMost(nat,N,M2)) ) ) ).

% sum.atLeastAtMost_rev
tff(fact_2260_prod_OatLeastAtMost__rev,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat,M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,N,M2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_sf(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),G),N),M2)),set_or1337092689740270186AtMost(nat,N,M2)) ) ) ).

% prod.atLeastAtMost_rev
tff(fact_2261_sum__power__add,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X2: B,M2: nat,I: set(nat)] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_sg(B,fun(nat,fun(nat,B)),X2),M2)),I) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),M2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),I)) ) ) ).

% sum_power_add
tff(fact_2262_UN__le__add__shift,axiom,
    ! [B: $tType,M: fun(nat,set(B)),K: nat,N: nat] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),aa(nat,fun(nat,set(B)),aTP_Lamp_sh(fun(nat,set(B)),fun(nat,fun(nat,set(B))),M),K)),aa(nat,set(nat),set_ord_atMost(nat),N))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),M),set_or1337092689740270186AtMost(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))) ) ).

% UN_le_add_shift
tff(fact_2263_power__decreasing,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [N: nat,N3: nat,A4: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N3)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)) ) ) ) ) ).

% power_decreasing
tff(fact_2264_sum__bounded__above,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add(C)
        & semiring_1(C) )
     => ! [A3: set(B),F2: fun(B,C),K4: C] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),A3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,I3)),K4) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),A3)),aa(C,C,aa(C,fun(C,C),times_times(C),aa(nat,C,semiring_1_of_nat(C),aa(set(B),nat,finite_card(B),A3))),K4)) ) ) ).

% sum_bounded_above
tff(fact_2265_sum__bounded__below,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add(C)
        & semiring_1(C) )
     => ! [A3: set(B),K4: C,F2: fun(B,C)] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),A3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),K4),aa(B,C,F2,I3)) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(C,C,aa(C,fun(C,C),times_times(C),aa(nat,C,semiring_1_of_nat(C),aa(set(B),nat,finite_card(B),A3))),K4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),A3)) ) ) ).

% sum_bounded_below
tff(fact_2266_power__eq__if,axiom,
    ! [B: $tType] :
      ( power(B)
     => ! [P3: B,M2: nat] :
          ( aa(nat,B,aa(B,fun(nat,B),power_power(B),P3),M2)
          = $ite(M2 = zero_zero(nat),one_one(B),aa(B,B,aa(B,fun(B,B),times_times(B),P3),aa(nat,B,aa(B,fun(nat,B),power_power(B),P3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),one_one(nat))))) ) ) ).

% power_eq_if
tff(fact_2267_power__transfer,axiom,
    ! [B: $tType,C: $tType] :
      ( ( power(C)
        & power(B) )
     => ! [R: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),R,one_one(B)),one_one(C))
         => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),R,bNF_rel_fun(B,C,B,C,R,R)),times_times(B)),times_times(C))
           => aa(fun(C,fun(nat,C)),$o,aa(fun(B,fun(nat,B)),fun(fun(C,fun(nat,C)),$o),bNF_rel_fun(B,C,fun(nat,B),fun(nat,C),R,bNF_rel_fun(nat,nat,B,C,fequal(nat),R)),power_power(B)),power_power(C)) ) ) ) ).

% power_transfer
tff(fact_2268_prod_Oub__add__nat,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M2: nat,N: nat,G: fun(nat,B),P3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P3))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,N))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P3)))) ) ) ) ).

% prod.ub_add_nat
tff(fact_2269_pairwise__alt,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),S: set(B)] :
      ( pairwise(B,R,S)
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),S)
         => ! [Xa2: B] :
              ( aa(set(B),$o,member(B,Xa2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,X3),bot_bot(set(B)))))
             => aa(B,$o,aa(B,fun(B,$o),R,X3),Xa2) ) ) ) ).

% pairwise_alt
tff(fact_2270_UN__le__eq__Un0,axiom,
    ! [B: $tType,M: fun(nat,set(B)),N: nat] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),M),aa(nat,set(nat),set_ord_atMost(nat),N))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),M),set_or1337092689740270186AtMost(nat,one_one(nat),N)))),aa(nat,set(B),M,zero_zero(nat))) ) ).

% UN_le_eq_Un0
tff(fact_2271_power__diff__power__eq,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A4: B,M2: nat,N: nat] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N))
            = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M2),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),N)),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2)))) ) ) ) ).

% power_diff_power_eq
tff(fact_2272_sum__natinterval__diff,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [F2: fun(nat,B),M2: nat,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_si(fun(nat,B),fun(nat,B),F2)),set_or1337092689740270186AtMost(nat,M2,N))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,F2,M2)),aa(nat,B,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))),zero_zero(B)) ) ) ).

% sum_natinterval_diff
tff(fact_2273_prod__gen__delta,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S: set(B),A4: B,B3: fun(B,C),Ca: C] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(C,fun(B,C),aa(fun(B,C),fun(C,fun(B,C)),aTP_Lamp_sj(B,fun(fun(B,C),fun(C,fun(B,C))),A4),B3),Ca)),S)
            = $ite(aa(set(B),$o,member(B,A4),S),aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,B3,A4)),aa(nat,C,aa(C,fun(nat,C),power_power(C),Ca),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,finite_card(B),S)),one_one(nat)))),aa(nat,C,aa(C,fun(nat,C),power_power(C),Ca),aa(set(B),nat,finite_card(B),S))) ) ) ) ).

% prod_gen_delta
tff(fact_2274_image__affinity__atLeastAtMost,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [M2: B,Ca: B,A4: B,B3: B] :
          ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),aTP_Lamp_sk(B,fun(B,fun(B,B)),M2),Ca)),set_or1337092689740270186AtMost(B,A4,B3))
          = $ite(
              set_or1337092689740270186AtMost(B,A4,B3) = bot_bot(set(B)),
              bot_bot(set(B)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),M2),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M2),A4)),Ca),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M2),B3)),Ca)),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M2),B3)),Ca),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M2),A4)),Ca))) ) ) ) ).

% image_affinity_atLeastAtMost
tff(fact_2275_image__affinity__atLeastAtMost__diff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [M2: B,Ca: B,A4: B,B3: B] :
          ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),aTP_Lamp_sl(B,fun(B,fun(B,B)),M2),Ca)),set_or1337092689740270186AtMost(B,A4,B3))
          = $ite(
              set_or1337092689740270186AtMost(B,A4,B3) = bot_bot(set(B)),
              bot_bot(set(B)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),M2),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M2),A4)),Ca),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M2),B3)),Ca)),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M2),B3)),Ca),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M2),A4)),Ca))) ) ) ) ).

% image_affinity_atLeastAtMost_diff
tff(fact_2276_image__affinity__atLeastAtMost__div,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [M2: B,Ca: B,A4: B,B3: B] :
          ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),aTP_Lamp_sm(B,fun(B,fun(B,B)),M2),Ca)),set_or1337092689740270186AtMost(B,A4,B3))
          = $ite(
              set_or1337092689740270186AtMost(B,A4,B3) = bot_bot(set(B)),
              bot_bot(set(B)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),M2),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),M2)),Ca),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),M2)),Ca)),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),M2)),Ca),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),M2)),Ca))) ) ) ) ).

% image_affinity_atLeastAtMost_div
tff(fact_2277_of__nat__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_1(B)
     => ! [F2: fun(C,nat),A3: set(C)] : ( aa(nat,B,semiring_1_of_nat(B),aa(set(C),nat,aa(fun(C,nat),fun(set(C),nat),groups7311177749621191930dd_sum(C,nat),F2),A3)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aTP_Lamp_sn(fun(C,nat),fun(C,B),F2)),A3) ) ) ).

% of_nat_sum
tff(fact_2278_of__nat__prod,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_1(B)
     => ! [F2: fun(C,nat),A3: set(C)] : ( aa(nat,B,semiring_1_of_nat(B),aa(set(C),nat,aa(fun(C,nat),fun(set(C),nat),groups7121269368397514597t_prod(C,nat),F2),A3)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aTP_Lamp_so(fun(C,nat),fun(C,B),F2)),A3) ) ) ).

% of_nat_prod
tff(fact_2279_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
tff(fact_2280_transfer__rule__of__nat,axiom,
    ! [B: $tType,C: $tType] :
      ( ( semiring_1(C)
        & semiring_1(B) )
     => ! [R: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),R,zero_zero(B)),zero_zero(C))
         => ( aa(C,$o,aa(B,fun(C,$o),R,one_one(B)),one_one(C))
           => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),R,bNF_rel_fun(B,C,B,C,R,R)),plus_plus(B)),plus_plus(C))
             => aa(fun(nat,C),$o,aa(fun(nat,B),fun(fun(nat,C),$o),bNF_rel_fun(nat,nat,B,C,fequal(nat),R),semiring_1_of_nat(B)),semiring_1_of_nat(C)) ) ) ) ) ).

% transfer_rule_of_nat
tff(fact_2281_of__nat__code,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat] : ( aa(nat,B,semiring_1_of_nat(B),N) = semiri8178284476397505188at_aux(B,aTP_Lamp_sp(B,B),N,zero_zero(B)) ) ) ).

% of_nat_code
tff(fact_2282_sum__gp0,axiom,
    ! [B: $tType] :
      ( ( division_ring(B)
        & comm_ring(B) )
     => ! [X2: B,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),aa(nat,set(nat),set_ord_atMost(nat),N))
          = $ite(X2 = one_one(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(nat,nat,suc,N)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X2))) ) ) ).

% sum_gp0
tff(fact_2283_sum__gp__offset,axiom,
    ! [B: $tType] :
      ( ( division_ring(B)
        & comm_ring(B) )
     => ! [X2: B,M2: nat,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),set_or1337092689740270186AtMost(nat,M2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),N)))
          = $ite(X2 = one_one(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B)),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),M2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(nat,nat,suc,N))))),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X2))) ) ) ).

% sum_gp_offset
tff(fact_2284_card__Collect__le__nat,axiom,
    ! [N: nat] : ( aa(set(nat),nat,finite_card(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_ra(nat,fun(nat,$o)),N))) = aa(nat,nat,suc,N) ) ).

% card_Collect_le_nat
tff(fact_2285_of__nat__Suc,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [M2: nat] : ( aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,M2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(nat,B,semiring_1_of_nat(B),M2)) ) ) ).

% of_nat_Suc
tff(fact_2286_prod_OatMost__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),aa(nat,set(nat),set_ord_atMost(nat),N))),aa(nat,B,G,aa(nat,nat,suc,N))) ) ) ).

% prod.atMost_Suc
tff(fact_2287_prod__int__eq,axiom,
    ! [I2: nat,J2: nat] : ( aa(set(nat),int,aa(fun(nat,int),fun(set(nat),int),groups7121269368397514597t_prod(nat,int),semiring_1_of_nat(int)),set_or1337092689740270186AtMost(nat,I2,J2)) = aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7121269368397514597t_prod(int,int),aTP_Lamp_rw(int,int)),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),I2),aa(nat,int,semiring_1_of_nat(int),J2))) ) ).

% prod_int_eq
tff(fact_2288_int__prod,axiom,
    ! [B: $tType,F2: fun(B,nat),A3: set(B)] : ( aa(nat,int,semiring_1_of_nat(int),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7121269368397514597t_prod(B,nat),F2),A3)) = aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7121269368397514597t_prod(B,int),aTP_Lamp_sq(fun(B,nat),fun(B,int),F2)),A3) ) ).

% int_prod
tff(fact_2289_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_sr(fun(nat,B),fun(nat,B),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
tff(fact_2290_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_ss(fun(nat,B),fun(nat,B),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
tff(fact_2291_power__Suc2,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A4: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)),A4) ) ) ).

% power_Suc2
tff(fact_2292_power__Suc,axiom,
    ! [B: $tType] :
      ( power(B)
     => ! [A4: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)) ) ) ).

% power_Suc
tff(fact_2293_card_Oeq__fold,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),nat,finite_card(B),A3) = finite_fold(B,nat,aTP_Lamp_st(B,fun(nat,nat)),zero_zero(nat),A3) ) ).

% card.eq_fold
tff(fact_2294_prod_OatLeast0__atMost__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))),aa(nat,B,G,aa(nat,nat,suc,N))) ) ) ).

% prod.atLeast0_atMost_Suc
tff(fact_2295_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,G,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),comp(nat,B,nat,G),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_atMost_Suc_shift
tff(fact_2296_prod_Onat__ivl__Suc_H,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M2: nat,N: nat,G: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),aa(nat,nat,suc,N))
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,G,aa(nat,nat,suc,N))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,N))) ) ) ) ).

% prod.nat_ivl_Suc'
tff(fact_2297_prod_OatLeast__Suc__atMost,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M2: nat,N: nat,G: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,G,M2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),N))) ) ) ) ).

% prod.atLeast_Suc_atMost
tff(fact_2298_sum_OSuc__reindex__ivl,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [M2: nat,N: nat,G: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or1337092689740270186AtMost(nat,M2,N))),aa(nat,B,G,aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,G,M2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_sr(fun(nat,B),fun(nat,B),G)),set_or1337092689740270186AtMost(nat,M2,N))) ) ) ) ).

% sum.Suc_reindex_ivl
tff(fact_2299_sum__Suc__diff,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [M2: nat,N: nat,F2: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),aa(nat,nat,suc,N))
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_su(fun(nat,B),fun(nat,B),F2)),set_or1337092689740270186AtMost(nat,M2,N)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,F2,aa(nat,nat,suc,N))),aa(nat,B,F2,M2)) ) ) ) ).

% sum_Suc_diff
tff(fact_2300_prod_OSuc__reindex__ivl,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M2: nat,N: nat,G: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,N))),aa(nat,B,G,aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,G,M2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_ss(fun(nat,B),fun(nat,B),G)),set_or1337092689740270186AtMost(nat,M2,N))) ) ) ) ).

% prod.Suc_reindex_ivl
tff(fact_2301_sum_OatLeast__atMost__pred__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),comp(nat,B,nat,G),aTP_Lamp_sv(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% sum.atLeast_atMost_pred_shift
tff(fact_2302_prod_OatLeast__atMost__pred__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),comp(nat,B,nat,G),aTP_Lamp_sv(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% prod.atLeast_atMost_pred_shift
tff(fact_2303_sum__Suc,axiom,
    ! [B: $tType,F2: fun(B,nat),A3: set(B)] : ( aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aTP_Lamp_sw(fun(B,nat),fun(B,nat),F2)),A3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A3)),aa(set(B),nat,finite_card(B),A3)) ) ).

% sum_Suc
tff(fact_2304_power__Suc__le__self,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(nat,nat,suc,N))),A4) ) ) ) ).

% power_Suc_le_self
tff(fact_2305_card__1__singleton__iff,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ( aa(set(B),nat,finite_card(B),A3) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ? [X3: B] : ( A3 = aa(set(B),set(B),insert(B,X3),bot_bot(set(B))) ) ) ).

% card_1_singleton_iff
tff(fact_2306_card__eq__SucD,axiom,
    ! [B: $tType,A3: set(B),K: nat] :
      ( ( aa(set(B),nat,finite_card(B),A3) = aa(nat,nat,suc,K) )
     => ? [B4: B,B8: set(B)] :
          ( ( A3 = aa(set(B),set(B),insert(B,B4),B8) )
          & ~ aa(set(B),$o,member(B,B4),B8)
          & ( aa(set(B),nat,finite_card(B),B8) = K )
          & ( ( K = zero_zero(nat) )
           => ( B8 = bot_bot(set(B)) ) ) ) ) ).

% card_eq_SucD
tff(fact_2307_card__Suc__eq,axiom,
    ! [B: $tType,A3: set(B),K: nat] :
      ( ( aa(set(B),nat,finite_card(B),A3) = aa(nat,nat,suc,K) )
    <=> ? [B5: B,B9: set(B)] :
          ( ( A3 = aa(set(B),set(B),insert(B,B5),B9) )
          & ~ aa(set(B),$o,member(B,B5),B9)
          & ( aa(set(B),nat,finite_card(B),B9) = K )
          & ( ( K = zero_zero(nat) )
           => ( B9 = bot_bot(set(B)) ) ) ) ) ).

% card_Suc_eq
tff(fact_2308_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] : ( set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_atMost(nat),N)),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_atMost_eq_remove0
tff(fact_2309_sum_OatMost__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,G,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_sr(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_atMost(nat),N))) ) ) ).

% sum.atMost_Suc_shift
tff(fact_2310_sum__telescope,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [F2: fun(nat,B),I2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_sx(fun(nat,B),fun(nat,B),F2)),aa(nat,set(nat),set_ord_atMost(nat),I2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,F2,zero_zero(nat))),aa(nat,B,F2,aa(nat,nat,suc,I2))) ) ) ).

% sum_telescope
tff(fact_2311_prod_OatMost__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,G,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_ss(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_atMost(nat),N))) ) ) ).

% prod.atMost_Suc_shift
tff(fact_2312_card_Oremove,axiom,
    ! [B: $tType,A3: set(B),X2: B] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),$o,member(B,X2),A3)
       => ( aa(set(B),nat,finite_card(B),A3) = aa(nat,nat,suc,aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ).

% card.remove
tff(fact_2313_card_Oinsert__remove,axiom,
    ! [B: $tType,A3: set(B),X2: B] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),nat,finite_card(B),aa(set(B),set(B),insert(B,X2),A3)) = aa(nat,nat,suc,aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ).

% card.insert_remove
tff(fact_2314_card__Suc__Diff1,axiom,
    ! [B: $tType,A3: set(B),X2: B] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),$o,member(B,X2),A3)
       => ( aa(nat,nat,suc,aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) = aa(set(B),nat,finite_card(B),A3) ) ) ) ).

% card_Suc_Diff1
tff(fact_2315_int__sum,axiom,
    ! [B: $tType,F2: fun(B,nat),A3: set(B)] : ( aa(nat,int,semiring_1_of_nat(int),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A3)) = aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7311177749621191930dd_sum(B,int),aTP_Lamp_sq(fun(B,nat),fun(B,int),F2)),A3) ) ).

% int_sum
tff(fact_2316_sum__telescope_H_H,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [M2: nat,N: nat,F2: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_sy(fun(nat,B),fun(nat,B),F2)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),N)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,F2,N)),aa(nat,B,F2,M2)) ) ) ) ).

% sum_telescope''
tff(fact_2317_sum__gp__multiplied,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [M2: nat,N: nat,X2: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),set_or1337092689740270186AtMost(nat,M2,N))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(nat,nat,suc,N))) ) ) ) ).

% sum_gp_multiplied
tff(fact_2318_sum__gp__basic,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X2: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),aa(nat,set(nat),set_ord_atMost(nat),N))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(nat,nat,suc,N))) ) ) ).

% sum_gp_basic
tff(fact_2319_sum__gp,axiom,
    ! [B: $tType] :
      ( ( division_ring(B)
        & comm_ring(B) )
     => ! [X2: B,M2: nat,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),set_or1337092689740270186AtMost(nat,M2,N))
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M2),
              zero_zero(B),
              $ite(X2 = one_one(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))),M2)),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(nat,nat,suc,N)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X2))) ) ) ) ).

% sum_gp
tff(fact_2320_card__UNION,axiom,
    ! [B: $tType,A3: set(set(B))] :
      ( aa(set(set(B)),$o,finite_finite2(set(B)),A3)
     => ( ! [X: set(B)] :
            ( aa(set(set(B)),$o,member(set(B),X),A3)
           => aa(set(B),$o,finite_finite2(B),X) )
       => ( aa(set(B),nat,finite_card(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A3)) = aa(int,nat,nat2,aa(set(set(set(B))),int,aa(fun(set(set(B)),int),fun(set(set(set(B))),int),groups7311177749621191930dd_sum(set(set(B)),int),aTP_Lamp_sz(set(set(B)),int)),aa(fun(set(set(B)),$o),set(set(set(B))),collect(set(set(B))),aTP_Lamp_ta(set(set(B)),fun(set(set(B)),$o),A3)))) ) ) ) ).

% card_UNION
tff(fact_2321_prod_Ozero__middle,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [P3: nat,K: nat,G: fun(nat,B),H2: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),P3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),P3)
           => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_tb(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),P3)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_tc(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P3),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% prod.zero_middle
tff(fact_2322_sum_Ozero__middle,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [P3: nat,K: nat,G: fun(nat,B),H2: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),P3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),P3)
           => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_td(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),P3)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_te(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P3),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% sum.zero_middle
tff(fact_2323_nat__leq__as__int,axiom,
    ! [X4: nat,Xa3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X4),Xa3)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3)) ) ).

% nat_leq_as_int
tff(fact_2324_prod__atLeastAtMost__code,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [F2: fun(nat,B),A4: nat,B3: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),F2),set_or1337092689740270186AtMost(nat,A4,B3)) = set_fo6178422350223883121st_nat(B,aTP_Lamp_tf(fun(nat,B),fun(nat,fun(B,B)),F2),A4,B3,one_one(B)) ) ) ).

% prod_atLeastAtMost_code
tff(fact_2325_finite__interval__int1,axiom,
    ! [A4: int,B3: int] : aa(set(int),$o,finite_finite2(int),aa(fun(int,$o),set(int),collect(int),aa(int,fun(int,$o),aTP_Lamp_tg(int,fun(int,fun(int,$o)),A4),B3))) ).

% finite_interval_int1
tff(fact_2326_not__gr__zero,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [N: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),N)
        <=> ( N = zero_zero(B) ) ) ) ).

% not_gr_zero
tff(fact_2327_add__less__cancel__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ).

% add_less_cancel_right
tff(fact_2328_add__less__cancel__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ).

% add_less_cancel_left
tff(fact_2329_neg__less__iff__less,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,uminus_uminus(B),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ).

% neg_less_iff_less
tff(fact_2330_compl__less__compl__iff,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),X2)),aa(B,B,uminus_uminus(B),Y))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ).

% compl_less_compl_iff
tff(fact_2331_finite__Collect__less__nat,axiom,
    ! [K: nat] : aa(set(nat),$o,finite_finite2(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),K))) ).

% finite_Collect_less_nat
tff(fact_2332_card__Collect__less__nat,axiom,
    ! [N: nat] : ( aa(set(nat),nat,finite_card(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N))) = N ) ).

% card_Collect_less_nat
tff(fact_2333_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
tff(fact_2334_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),A4)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B)) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
tff(fact_2335_less__add__same__cancel2,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3) ) ) ).

% less_add_same_cancel2
tff(fact_2336_less__add__same__cancel1,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3) ) ) ).

% less_add_same_cancel1
tff(fact_2337_add__less__same__cancel2,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),B3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B)) ) ) ).

% add_less_same_cancel2
tff(fact_2338_add__less__same__cancel1,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4)),B3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B)) ) ) ).

% add_less_same_cancel1
tff(fact_2339_diff__gt__0__iff__gt,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) ) ) ).

% diff_gt_0_iff_gt
tff(fact_2340_neg__less__0__iff__less,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),A4)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4) ) ) ).

% neg_less_0_iff_less
tff(fact_2341_neg__0__less__iff__less,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,uminus_uminus(B),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B)) ) ) ).

% neg_0_less_iff_less
tff(fact_2342_neg__less__pos,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),A4)),A4)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4) ) ) ).

% neg_less_pos
tff(fact_2343_less__neg__neg,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,uminus_uminus(B),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B)) ) ) ).

% less_neg_neg
tff(fact_2344_power__inject__exp,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,M2: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4)
         => ( ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),M2) = aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N) )
          <=> ( M2 = N ) ) ) ) ).

% power_inject_exp
tff(fact_2345_zero__less__abs__iff,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,abs_abs(B),A4))
        <=> ( A4 != zero_zero(B) ) ) ) ).

% zero_less_abs_iff
tff(fact_2346_Inf__eq__bot__iff,axiom,
    ! [B: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [A3: set(B)] :
          ( ( aa(set(B),B,complete_Inf_Inf(B),A3) = bot_bot(B) )
        <=> ! [X3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),bot_bot(B)),X3)
             => ? [Xa2: B] :
                  ( aa(set(B),$o,member(B,Xa2),A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Xa2),X3) ) ) ) ) ).

% Inf_eq_bot_iff
tff(fact_2347_Sup__eq__top__iff,axiom,
    ! [B: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [A3: set(B)] :
          ( ( aa(set(B),B,complete_Sup_Sup(B),A3) = top_top(B) )
        <=> ! [X3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),top_top(B))
             => ? [Xa2: B] :
                  ( aa(set(B),$o,member(B,Xa2),A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),Xa2) ) ) ) ) ).

% Sup_eq_top_iff
tff(fact_2348_atLeastatMost__empty,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ( set_or1337092689740270186AtMost(B,A4,B3) = bot_bot(set(B)) ) ) ) ).

% atLeastatMost_empty
tff(fact_2349_divide__less__0__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B)) ) ) ).

% divide_less_0_1_iff
tff(fact_2350_divide__less__eq__1__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)),one_one(B))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ) ).

% divide_less_eq_1_neg
tff(fact_2351_divide__less__eq__1__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)),one_one(B))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) ) ) ) ).

% divide_less_eq_1_pos
tff(fact_2352_less__divide__eq__1__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) ) ) ) ).

% less_divide_eq_1_neg
tff(fact_2353_less__divide__eq__1__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ) ).

% less_divide_eq_1_pos
tff(fact_2354_zero__less__divide__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4) ) ) ).

% zero_less_divide_1_iff
tff(fact_2355_power__strict__increasing__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [B3: B,X2: nat,Y: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),B3),X2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),B3),Y))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),Y) ) ) ) ).

% power_strict_increasing_iff
tff(fact_2356_INF__eq__bot__iff,axiom,
    ! [C: $tType,B: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [F2: fun(C,B),A3: set(C)] :
          ( ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3)) = bot_bot(B) )
        <=> ! [X3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),bot_bot(B)),X3)
             => ? [Xa2: C] :
                  ( aa(set(C),$o,member(C,Xa2),A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(C,B,F2,Xa2)),X3) ) ) ) ) ).

% INF_eq_bot_iff
tff(fact_2357_SUP__eq__top__iff,axiom,
    ! [B: $tType,C: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [F2: fun(C,B),A3: set(C)] :
          ( ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),A3)) = top_top(B) )
        <=> ! [X3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),top_top(B))
             => ? [Xa2: C] :
                  ( aa(set(C),$o,member(C,Xa2),A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),aa(C,B,F2,Xa2)) ) ) ) ) ).

% SUP_eq_top_iff
tff(fact_2358_le__divide__eq__1__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ) ).

% le_divide_eq_1_pos
tff(fact_2359_le__divide__eq__1__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ) ).

% le_divide_eq_1_neg
tff(fact_2360_divide__le__eq__1__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)),one_one(B))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ) ).

% divide_le_eq_1_pos
tff(fact_2361_divide__le__eq__1__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)),one_one(B))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ) ).

% divide_le_eq_1_neg
tff(fact_2362_power__strict__decreasing__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [B3: B,M2: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),one_one(B))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),B3),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),B3),N))
            <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M2) ) ) ) ) ).

% power_strict_decreasing_iff
tff(fact_2363_image__mult__atLeastAtMost,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [D3: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),D3)
         => ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),D3)),set_or1337092689740270186AtMost(B,A4,B3)) = set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),times_times(B),D3),A4),aa(B,B,aa(B,fun(B,B),times_times(B),D3),B3)) ) ) ) ).

% image_mult_atLeastAtMost
tff(fact_2364_power__increasing__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [B3: B,X2: nat,Y: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),B3),X2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),B3),Y))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X2),Y) ) ) ) ).

% power_increasing_iff
tff(fact_2365_image__divide__atLeastAtMost,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [D3: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),D3)
         => ( aa(set(B),set(B),image2(B,B,aTP_Lamp_ti(B,fun(B,B),D3)),set_or1337092689740270186AtMost(B,A4,B3)) = set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),D3),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),D3)) ) ) ) ).

% image_divide_atLeastAtMost
tff(fact_2366_power__decreasing__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [B3: B,M2: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),one_one(B))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),B3),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),B3),N))
            <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M2) ) ) ) ) ).

% power_decreasing_iff
tff(fact_2367_prod_Ocl__ivl__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,aa(nat,nat,suc,N)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,N)),M2),one_one(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,N))),aa(nat,B,G,aa(nat,nat,suc,N)))) ) ) ).

% prod.cl_ivl_Suc
tff(fact_2368_nat__div__as__int,axiom,
    ! [X4: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X4),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_div_as_int
tff(fact_2369_linorder__neqE__linordered__idom,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B,Y: B] :
          ( ( X2 != Y )
         => ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ) ).

% linorder_neqE_linordered_idom
tff(fact_2370_order__less__imp__not__less,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ).

% order_less_imp_not_less
tff(fact_2371_order__less__imp__not__eq2,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ( Y != X2 ) ) ) ).

% order_less_imp_not_eq2
tff(fact_2372_order__less__imp__not__eq,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ( X2 != Y ) ) ) ).

% order_less_imp_not_eq
tff(fact_2373_linorder__less__linear,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
          | ( X2 = Y )
          | aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ).

% linorder_less_linear
tff(fact_2374_order__less__imp__triv,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B,Y: B,Pa: $o] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2)
           => (Pa) ) ) ) ).

% order_less_imp_triv
tff(fact_2375_order__less__not__sym,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ).

% order_less_not_sym
tff(fact_2376_order__less__subst2,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A4: B,B3: B,F2: fun(B,C),Ca: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,B3)),Ca)
           => ( ! [X: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,X)),aa(B,C,F2,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,A4)),Ca) ) ) ) ) ).

% order_less_subst2
tff(fact_2377_order__less__subst1,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A4: B,F2: fun(C,B),B3: C,Ca: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(C,B,F2,B3))
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),B3),Ca)
           => ( ! [X: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),X),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(C,B,F2,X)),aa(C,B,F2,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(C,B,F2,Ca)) ) ) ) ) ).

% order_less_subst1
tff(fact_2378_order__less__irrefl,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),X2) ) ).

% order_less_irrefl
tff(fact_2379_ord__less__eq__subst,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ord(C)
        & ord(B) )
     => ! [A4: B,B3: B,F2: fun(B,C),Ca: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( ( aa(B,C,F2,B3) = Ca )
           => ( ! [X: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,X)),aa(B,C,F2,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,A4)),Ca) ) ) ) ) ).

% ord_less_eq_subst
tff(fact_2380_ord__eq__less__subst,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ord(C)
        & ord(B) )
     => ! [A4: B,F2: fun(C,B),B3: C,Ca: C] :
          ( ( A4 = aa(C,B,F2,B3) )
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),B3),Ca)
           => ( ! [X: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),X),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(C,B,F2,X)),aa(C,B,F2,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(C,B,F2,Ca)) ) ) ) ) ).

% ord_eq_less_subst
tff(fact_2381_order__less__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Z2) ) ) ) ).

% order_less_trans
tff(fact_2382_order__less__asym_H,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) ) ) ).

% order_less_asym'
tff(fact_2383_linorder__neq__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] :
          ( ( X2 != Y )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
            | aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ) ).

% linorder_neq_iff
tff(fact_2384_order__less__asym,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ).

% order_less_asym
tff(fact_2385_linorder__neqE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] :
          ( ( X2 != Y )
         => ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ) ).

% linorder_neqE
tff(fact_2386_dual__order_Ostrict__implies__not__eq,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ( A4 != B3 ) ) ) ).

% dual_order.strict_implies_not_eq
tff(fact_2387_order_Ostrict__implies__not__eq,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( A4 != B3 ) ) ) ).

% order.strict_implies_not_eq
tff(fact_2388_dual__order_Ostrict__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),A4) ) ) ) ).

% dual_order.strict_trans
tff(fact_2389_not__less__iff__gr__or__eq,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2)
            | ( X2 = Y ) ) ) ) ).

% not_less_iff_gr_or_eq
tff(fact_2390_order_Ostrict__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),Ca) ) ) ) ).

% order.strict_trans
tff(fact_2391_linorder__less__wlog,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Pa: fun(B,fun(B,$o)),A4: B,B3: B] :
          ( ! [A5: B,B4: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A5),B4)
             => aa(B,$o,aa(B,fun(B,$o),Pa,A5),B4) )
         => ( ! [A5: B] : aa(B,$o,aa(B,fun(B,$o),Pa,A5),A5)
           => ( ! [A5: B,B4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),Pa,B4),A5)
                 => aa(B,$o,aa(B,fun(B,$o),Pa,A5),B4) )
             => aa(B,$o,aa(B,fun(B,$o),Pa,A4),B3) ) ) ) ) ).

% linorder_less_wlog
tff(fact_2392_exists__least__iff,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o)] :
          ( ? [X_12: B] : aa(B,$o,Pa,X_12)
        <=> ? [N4: B] :
              ( aa(B,$o,Pa,N4)
              & ! [M4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),M4),N4)
                 => ~ aa(B,$o,Pa,M4) ) ) ) ) ).

% exists_least_iff
tff(fact_2393_dual__order_Oirrefl,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),A4) ) ).

% dual_order.irrefl
tff(fact_2394_dual__order_Oasym,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ).

% dual_order.asym
tff(fact_2395_linorder__cases,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ( ( X2 != Y )
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ) ).

% linorder_cases
tff(fact_2396_antisym__conv3,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Y: B,X2: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2)
         => ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
          <=> ( X2 = Y ) ) ) ) ).

% antisym_conv3
tff(fact_2397_less__induct,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),A4: B] :
          ( ! [X: B] :
              ( ! [Y5: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y5),X)
                 => aa(B,$o,Pa,Y5) )
             => aa(B,$o,Pa,X) )
         => aa(B,$o,Pa,A4) ) ) ).

% less_induct
tff(fact_2398_ord__less__eq__trans,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( ( B3 = Ca )
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),Ca) ) ) ) ).

% ord_less_eq_trans
tff(fact_2399_ord__eq__less__trans,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( A4 = B3 )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),Ca) ) ) ) ).

% ord_eq_less_trans
tff(fact_2400_order_Oasym,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) ) ) ).

% order.asym
tff(fact_2401_less__imp__neq,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ( X2 != Y ) ) ) ).

% less_imp_neq
tff(fact_2402_dense,axiom,
    ! [B: $tType] :
      ( dense_order(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ? [Z3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Z3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z3),Y) ) ) ) ).

% dense
tff(fact_2403_gt__ex,axiom,
    ! [B: $tType] :
      ( no_top(B)
     => ! [X2: B] :
        ? [X_1: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),X_1) ) ).

% gt_ex
tff(fact_2404_lt__ex,axiom,
    ! [B: $tType] :
      ( no_bot(B)
     => ! [X2: B] :
        ? [Y2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y2),X2) ) ).

% lt_ex
tff(fact_2405_power__strict__increasing,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [N: nat,N3: nat,A4: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),N3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N3)) ) ) ) ).

% power_strict_increasing
tff(fact_2406_power__less__imp__less__exp,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,M2: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N))
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N) ) ) ) ).

% power_less_imp_less_exp
tff(fact_2407_order__le__imp__less__or__eq,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
            | ( X2 = Y ) ) ) ) ).

% order_le_imp_less_or_eq
tff(fact_2408_linorder__le__less__linear,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
          | aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ).

% linorder_le_less_linear
tff(fact_2409_order__less__le__subst2,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A4: B,B3: B,F2: fun(B,C),Ca: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,B3)),Ca)
           => ( ! [X: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,X)),aa(B,C,F2,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,A4)),Ca) ) ) ) ) ).

% order_less_le_subst2
tff(fact_2410_order__less__le__subst1,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A4: B,F2: fun(C,B),B3: C,Ca: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(C,B,F2,B3))
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),B3),Ca)
           => ( ! [X: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),X),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(C,B,F2,X)),aa(C,B,F2,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(C,B,F2,Ca)) ) ) ) ) ).

% order_less_le_subst1
tff(fact_2411_order__le__less__subst2,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A4: B,B3: B,F2: fun(B,C),Ca: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,B3)),Ca)
           => ( ! [X: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),aa(B,C,F2,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,A4)),Ca) ) ) ) ) ).

% order_le_less_subst2
tff(fact_2412_order__le__less__subst1,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A4: B,F2: fun(C,B),B3: C,Ca: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(C,B,F2,B3))
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),B3),Ca)
           => ( ! [X: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),X),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(C,B,F2,X)),aa(C,B,F2,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(C,B,F2,Ca)) ) ) ) ) ).

% order_le_less_subst1
tff(fact_2413_order__less__le__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Z2) ) ) ) ).

% order_less_le_trans
tff(fact_2414_order__le__less__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Z2) ) ) ) ).

% order_le_less_trans
tff(fact_2415_order__neq__le__trans,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != B3 )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ) ).

% order_neq_le_trans
tff(fact_2416_order__le__neq__trans,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( ( A4 != B3 )
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ) ).

% order_le_neq_trans
tff(fact_2417_order__less__imp__le,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y) ) ) ).

% order_less_imp_le
tff(fact_2418_linorder__not__less,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2) ) ) ).

% linorder_not_less
tff(fact_2419_linorder__not__le,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ).

% linorder_not_le
tff(fact_2420_order__less__le,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
            & ( X2 != Y ) ) ) ) ).

% order_less_le
tff(fact_2421_order__le__less,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
            | ( X2 = Y ) ) ) ) ).

% order_le_less
tff(fact_2422_dual__order_Ostrict__implies__order,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ).

% dual_order.strict_implies_order
tff(fact_2423_order_Ostrict__implies__order,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ).

% order.strict_implies_order
tff(fact_2424_dual__order_Ostrict__iff__not,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
            & ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ) ).

% dual_order.strict_iff_not
tff(fact_2425_dual__order_Ostrict__trans2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),A4) ) ) ) ).

% dual_order.strict_trans2
tff(fact_2426_dual__order_Ostrict__trans1,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),A4) ) ) ) ).

% dual_order.strict_trans1
tff(fact_2427_dual__order_Ostrict__iff__order,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
            & ( A4 != B3 ) ) ) ) ).

% dual_order.strict_iff_order
tff(fact_2428_dual__order_Oorder__iff__strict,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
            | ( A4 = B3 ) ) ) ) ).

% dual_order.order_iff_strict
tff(fact_2429_dense__le__bounded,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ( ! [W: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),W)
               => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),W),Y)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),W),Z2) ) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ) ).

% dense_le_bounded
tff(fact_2430_dense__ge__bounded,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),X2)
         => ( ! [W: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),W)
               => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),W),X2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),W) ) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ) ).

% dense_ge_bounded
tff(fact_2431_order_Ostrict__iff__not,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
            & ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ) ).

% order.strict_iff_not
tff(fact_2432_order_Ostrict__trans2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),Ca) ) ) ) ).

% order.strict_trans2
tff(fact_2433_order_Ostrict__trans1,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),Ca) ) ) ) ).

% order.strict_trans1
tff(fact_2434_order_Ostrict__iff__order,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
            & ( A4 != B3 ) ) ) ) ).

% order.strict_iff_order
tff(fact_2435_order_Oorder__iff__strict,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
            | ( A4 = B3 ) ) ) ) ).

% order.order_iff_strict
tff(fact_2436_not__le__imp__less,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Y: B,X2: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y) ) ) ).

% not_le_imp_less
tff(fact_2437_less__le__not__le,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
            & ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2) ) ) ) ).

% less_le_not_le
tff(fact_2438_dense__le,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [Y: B,Z2: B] :
          ( ! [X: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Z2) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ).

% dense_le
tff(fact_2439_dense__ge,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [Z2: B,Y: B] :
          ( ! [X: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),X)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ).

% dense_ge
tff(fact_2440_antisym__conv2,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
          <=> ( X2 = Y ) ) ) ) ).

% antisym_conv2
tff(fact_2441_antisym__conv1,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X2: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
          <=> ( X2 = Y ) ) ) ) ).

% antisym_conv1
tff(fact_2442_nless__le,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
        <=> ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
            | ( A4 = B3 ) ) ) ) ).

% nless_le
tff(fact_2443_leI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2) ) ) ).

% leI
tff(fact_2444_leD,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Y: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y) ) ) ).

% leD
tff(fact_2445_zero__less__iff__neq__zero,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [N: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),N)
        <=> ( N != zero_zero(B) ) ) ) ).

% zero_less_iff_neq_zero
tff(fact_2446_gr__implies__not__zero,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [M2: B,N: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),M2),N)
         => ( N != zero_zero(B) ) ) ) ).

% gr_implies_not_zero
tff(fact_2447_not__less__zero,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [N: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),N),zero_zero(B)) ) ).

% not_less_zero
tff(fact_2448_gr__zeroI,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [N: B] :
          ( ( N != zero_zero(B) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),N) ) ) ).

% gr_zeroI
tff(fact_2449_add__less__imp__less__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca))
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ).

% add_less_imp_less_right
tff(fact_2450_add__less__imp__less__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3))
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ).

% add_less_imp_less_left
tff(fact_2451_add__strict__right__mono,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) ) ) ).

% add_strict_right_mono
tff(fact_2452_add__strict__left__mono,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3)) ) ) ).

% add_strict_left_mono
tff(fact_2453_add__strict__mono,axiom,
    ! [B: $tType] :
      ( strict9044650504122735259up_add(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),D3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),D3)) ) ) ) ).

% add_strict_mono
tff(fact_2454_add__mono__thms__linordered__field_I1_J,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [I2: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),I2),J2)
            & ( K = L ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_field(1)
tff(fact_2455_add__mono__thms__linordered__field_I2_J,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [I2: B,J2: B,K: B,L: B] :
          ( ( ( I2 = J2 )
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_field(2)
tff(fact_2456_add__mono__thms__linordered__field_I5_J,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [I2: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),I2),J2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_field(5)
tff(fact_2457_less__numeral__extra_I4_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),one_one(B)) ) ).

% less_numeral_extra(4)
tff(fact_2458_diff__strict__right__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),Ca)) ) ) ).

% diff_strict_right_mono
tff(fact_2459_diff__strict__left__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ca),B3)) ) ) ).

% diff_strict_left_mono
tff(fact_2460_diff__eq__diff__less,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),Ca),D3) )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),D3) ) ) ) ).

% diff_eq_diff_less
tff(fact_2461_diff__strict__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B,D3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),D3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),D3)) ) ) ) ).

% diff_strict_mono
tff(fact_2462_bot_Onot__eq__extremum,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [A4: B] :
          ( ( A4 != bot_bot(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),bot_bot(B)),A4) ) ) ).

% bot.not_eq_extremum
tff(fact_2463_bot_Oextremum__strict,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [A4: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),bot_bot(B)) ) ).

% bot.extremum_strict
tff(fact_2464_minus__less__iff,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),A4)),B3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),B3)),A4) ) ) ).

% minus_less_iff
tff(fact_2465_less__minus__iff,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,uminus_uminus(B),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,uminus_uminus(B),A4)) ) ) ).

% less_minus_iff
tff(fact_2466_compl__less__swap2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),Y)),X2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),X2)),Y) ) ) ).

% compl_less_swap2
tff(fact_2467_compl__less__swap1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(B,B,uminus_uminus(B),X2))
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% compl_less_swap1
tff(fact_2468_top_Onot__eq__extremum,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [A4: B] :
          ( ( A4 != top_top(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),top_top(B)) ) ) ).

% top.not_eq_extremum
tff(fact_2469_top_Oextremum__strict,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [A4: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),top_top(B)),A4) ) ).

% top.extremum_strict
tff(fact_2470_less__infI1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,X2: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),X2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),X2) ) ) ).

% less_infI1
tff(fact_2471_less__infI2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [B3: B,X2: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),X2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),X2) ) ) ).

% less_infI2
tff(fact_2472_inf_Oabsorb3,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) = A4 ) ) ) ).

% inf.absorb3
tff(fact_2473_inf_Oabsorb4,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) = B3 ) ) ) ).

% inf.absorb4
tff(fact_2474_inf_Ostrict__boundedE,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),inf_inf(B),B3),Ca))
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),Ca) ) ) ) ).

% inf.strict_boundedE
tff(fact_2475_inf_Ostrict__order__iff,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
        <=> ( ( A4 = aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3) )
            & ( A4 != B3 ) ) ) ) ).

% inf.strict_order_iff
tff(fact_2476_inf_Ostrict__coboundedI1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),Ca)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),Ca) ) ) ).

% inf.strict_coboundedI1
tff(fact_2477_inf_Ostrict__coboundedI2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),Ca)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B3)),Ca) ) ) ).

% inf.strict_coboundedI2
tff(fact_2478_sup_Ostrict__coboundedI2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ) ).

% sup.strict_coboundedI2
tff(fact_2479_sup_Ostrict__coboundedI1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ) ).

% sup.strict_coboundedI1
tff(fact_2480_sup_Ostrict__order__iff,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
        <=> ( ( A4 = aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) )
            & ( A4 != B3 ) ) ) ) ).

% sup.strict_order_iff
tff(fact_2481_sup_Ostrict__boundedE,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),B3),Ca)),A4)
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),A4) ) ) ) ).

% sup.strict_boundedE
tff(fact_2482_sup_Oabsorb4,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) = B3 ) ) ) ).

% sup.absorb4
tff(fact_2483_sup_Oabsorb3,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3) = A4 ) ) ) ).

% sup.absorb3
tff(fact_2484_less__supI2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ) ).

% less_supI2
tff(fact_2485_less__supI1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X2: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B3)) ) ) ).

% less_supI1
tff(fact_2486_mono__strict__invE,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & order(C) )
     => ! [F2: fun(B,C),X2: B,Y: B] :
          ( order_mono(B,C,F2)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,X2)),aa(B,C,F2,Y))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y) ) ) ) ).

% mono_strict_invE
tff(fact_2487_power__strict__decreasing,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [N: nat,N3: nat,A4: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),N3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N3)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)) ) ) ) ) ).

% power_strict_decreasing
tff(fact_2488_one__less__power,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)) ) ) ) ).

% one_less_power
tff(fact_2489_nat__plus__as__int,axiom,
    ! [X4: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X4),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_plus_as_int
tff(fact_2490_nat__minus__as__int,axiom,
    ! [X4: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X4),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_minus_as_int
tff(fact_2491_nat__times__as__int,axiom,
    ! [X4: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),X4),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_times_as_int
tff(fact_2492_finite__M__bounded__by__nat,axiom,
    ! [Pa: fun(nat,$o),I2: nat] : aa(set(nat),$o,finite_finite2(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_tj(fun(nat,$o),fun(nat,fun(nat,$o)),Pa),I2))) ).

% finite_M_bounded_by_nat
tff(fact_2493_wf__less,axiom,
    wf(nat,aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),ord_less(nat)))) ).

% wf_less
tff(fact_2494_add__mono__thms__linordered__field_I4_J,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [I2: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),I2),J2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_field(4)
tff(fact_2495_add__mono__thms__linordered__field_I3_J,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [I2: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),I2),J2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_field(3)
tff(fact_2496_add__le__less__mono,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),D3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),D3)) ) ) ) ).

% add_le_less_mono
tff(fact_2497_add__less__le__mono,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),D3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),D3)) ) ) ) ).

% add_less_le_mono
tff(fact_2498_add__neg__neg,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),zero_zero(B)) ) ) ) ).

% add_neg_neg
tff(fact_2499_add__pos__pos,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) ) ) ) ).

% add_pos_pos
tff(fact_2500_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ~ ! [C3: B] :
                ( ( B3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),C3) )
               => ( C3 = zero_zero(B) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
tff(fact_2501_pos__add__strict,axiom,
    ! [B: $tType] :
      ( strict7427464778891057005id_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)) ) ) ) ).

% pos_add_strict
tff(fact_2502_add__less__zeroD,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y)),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),zero_zero(B))
            | aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),zero_zero(B)) ) ) ) ).

% add_less_zeroD
tff(fact_2503_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [B: $tType] :
      ( linord2810124833399127020strict(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
tff(fact_2504_mult__less__cancel__right__disj,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) ) ) ) ) ).

% mult_less_cancel_right_disj
tff(fact_2505_mult__strict__right__mono,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ) ).

% mult_strict_right_mono
tff(fact_2506_mult__strict__right__mono__neg,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ) ).

% mult_strict_right_mono_neg
tff(fact_2507_mult__less__cancel__left__disj,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) ) ) ) ) ).

% mult_less_cancel_left_disj
tff(fact_2508_mult__strict__left__mono,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) ) ) ) ).

% mult_strict_left_mono
tff(fact_2509_mult__strict__left__mono__neg,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) ) ) ) ).

% mult_strict_left_mono_neg
tff(fact_2510_mult__less__cancel__left__pos,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ) ).

% mult_less_cancel_left_pos
tff(fact_2511_mult__less__cancel__left__neg,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) ) ) ) ).

% mult_less_cancel_left_neg
tff(fact_2512_zero__less__mult__pos2,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3) ) ) ) ).

% zero_less_mult_pos2
tff(fact_2513_zero__less__mult__pos,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3) ) ) ) ).

% zero_less_mult_pos
tff(fact_2514_zero__less__mult__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),zero_zero(B)) ) ) ) ) ).

% zero_less_mult_iff
tff(fact_2515_mult__pos__neg2,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4)),zero_zero(B)) ) ) ) ).

% mult_pos_neg2
tff(fact_2516_mult__pos__pos,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ) ) ).

% mult_pos_pos
tff(fact_2517_mult__pos__neg,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),zero_zero(B)) ) ) ) ).

% mult_pos_neg
tff(fact_2518_mult__neg__pos,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),zero_zero(B)) ) ) ) ).

% mult_neg_pos
tff(fact_2519_mult__less__0__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),zero_zero(B))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),zero_zero(B)) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3) ) ) ) ) ).

% mult_less_0_iff
tff(fact_2520_not__square__less__zero,axiom,
    ! [B: $tType] :
      ( linordered_ring(B)
     => ! [A4: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),A4)),zero_zero(B)) ) ).

% not_square_less_zero
tff(fact_2521_mult__neg__neg,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ) ) ).

% mult_neg_neg
tff(fact_2522_less__numeral__extra_I1_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),one_one(B)) ) ).

% less_numeral_extra(1)
tff(fact_2523_not__one__less__zero,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),zero_zero(B)) ) ).

% not_one_less_zero
tff(fact_2524_zero__less__one,axiom,
    ! [B: $tType] :
      ( zero_less_one(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),one_one(B)) ) ).

% zero_less_one
tff(fact_2525_less__iff__diff__less__0,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),zero_zero(B)) ) ) ).

% less_iff_diff_less_0
tff(fact_2526_add__mono1,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),one_one(B))) ) ) ).

% add_mono1
tff(fact_2527_less__add__one,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))) ) ).

% less_add_one
tff(fact_2528_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,B3: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)) = A4 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
tff(fact_2529_less__diff__eq,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ca),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),Ca) ) ) ).

% less_diff_eq
tff(fact_2530_diff__less__eq,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),Ca)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ca),B3)) ) ) ).

% diff_less_eq
tff(fact_2531_less__1__mult,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [M2: B,N: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),M2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),N)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),M2),N)) ) ) ) ).

% less_1_mult
tff(fact_2532_less__minus__one__simps_I4_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% less_minus_one_simps(4)
tff(fact_2533_less__minus__one__simps_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),one_one(B))),one_one(B)) ) ).

% less_minus_one_simps(2)
tff(fact_2534_ex__min__if__finite,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [S: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( ( S != bot_bot(set(B)) )
           => ? [X: B] :
                ( aa(set(B),$o,member(B,X),S)
                & ~ ? [Xa3: B] :
                      ( aa(set(B),$o,member(B,Xa3),S)
                      & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Xa3),X) ) ) ) ) ) ).

% ex_min_if_finite
tff(fact_2535_infinite__growing,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X5: set(B)] :
          ( ( X5 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),X5)
               => ? [Xa3: B] :
                    ( aa(set(B),$o,member(B,Xa3),X5)
                    & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Xa3) ) )
           => ~ aa(set(B),$o,finite_finite2(B),X5) ) ) ) ).

% infinite_growing
tff(fact_2536_less__cSupE,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [Y: B,X5: set(B)] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(set(B),B,complete_Sup_Sup(B),X5))
         => ( ( X5 != bot_bot(set(B)) )
           => ~ ! [X: B] :
                  ( aa(set(B),$o,member(B,X),X5)
                 => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X) ) ) ) ) ).

% less_cSupE
tff(fact_2537_less__cSupD,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X5: set(B),Z2: B] :
          ( ( X5 != bot_bot(set(B)) )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),aa(set(B),B,complete_Sup_Sup(B),X5))
           => ? [X: B] :
                ( aa(set(B),$o,member(B,X),X5)
                & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),X) ) ) ) ) ).

% less_cSupD
tff(fact_2538_abs__of__pos,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,B,abs_abs(B),A4) = A4 ) ) ) ).

% abs_of_pos
tff(fact_2539_abs__not__less__zero,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),A4)),zero_zero(B)) ) ).

% abs_not_less_zero
tff(fact_2540_cInf__lessD,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X5: set(B),Z2: B] :
          ( ( X5 != bot_bot(set(B)) )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,complete_Inf_Inf(B),X5)),Z2)
           => ? [X: B] :
                ( aa(set(B),$o,member(B,X),X5)
                & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Z2) ) ) ) ) ).

% cInf_lessD
tff(fact_2541_abs__mult__less,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B,Ca: B,B3: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),A4)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),B3)),D3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),B3))),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),D3)) ) ) ) ).

% abs_mult_less
tff(fact_2542_abs__less__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),A4)),B3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),A4)),B3) ) ) ) ).

% abs_less_iff
tff(fact_2543_mono__invE,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & order(C) )
     => ! [F2: fun(B,C),X2: B,Y: B] :
          ( order_mono(B,C,F2)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,X2)),aa(B,C,F2,Y))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y) ) ) ) ).

% mono_invE
tff(fact_2544_sum__bounded__above__strict,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ordere8940638589300402666id_add(C)
        & semiring_1(C) )
     => ! [A3: set(B),F2: fun(B,C),K4: C] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),A3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,I3)),K4) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(B),nat,finite_card(B),A3))
           => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),A3)),aa(C,C,aa(C,fun(C,C),times_times(C),aa(nat,C,semiring_1_of_nat(C),aa(set(B),nat,finite_card(B),A3))),K4)) ) ) ) ).

% sum_bounded_above_strict
tff(fact_2545_SUP__lessD,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B),A3: set(C),Y: B,I2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),A3))),Y)
         => ( aa(set(C),$o,member(C,I2),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(C,B,F2,I2)),Y) ) ) ) ).

% SUP_lessD
tff(fact_2546_less__SUP__iff,axiom,
    ! [B: $tType,C: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [A4: B,F2: fun(C,B),A3: set(C)] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),A3)))
        <=> ? [X3: C] :
              ( aa(set(C),$o,member(C,X3),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(C,B,F2,X3)) ) ) ) ).

% less_SUP_iff
tff(fact_2547_less__INF__D,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Y: B,F2: fun(C,B),A3: set(C),I2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3)))
         => ( aa(set(C),$o,member(C,I2),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(C,B,F2,I2)) ) ) ) ).

% less_INF_D
tff(fact_2548_INF__less__iff,axiom,
    ! [C: $tType,B: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [F2: fun(C,B),A3: set(C),A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3))),A4)
        <=> ? [X3: C] :
              ( aa(set(C),$o,member(C,X3),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(C,B,F2,X3)),A4) ) ) ) ).

% INF_less_iff
tff(fact_2549_filter__preserves__multiset,axiom,
    ! [B: $tType,M: fun(B,nat),Pa: fun(B,$o)] :
      ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_tk(fun(B,nat),fun(B,$o),M)))
     => aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_tl(fun(B,nat),fun(fun(B,$o),fun(B,$o)),M),Pa))) ) ).

% filter_preserves_multiset
tff(fact_2550_card__less__Suc2,axiom,
    ! [M: set(nat),I2: nat] :
      ( ~ aa(set(nat),$o,member(nat,zero_zero(nat)),M)
     => ( aa(set(nat),nat,finite_card(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_tm(set(nat),fun(nat,fun(nat,$o)),M),I2))) = aa(set(nat),nat,finite_card(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_tn(set(nat),fun(nat,fun(nat,$o)),M),I2))) ) ) ).

% card_less_Suc2
tff(fact_2551_card__less__Suc,axiom,
    ! [M: set(nat),I2: nat] :
      ( aa(set(nat),$o,member(nat,zero_zero(nat)),M)
     => ( aa(nat,nat,suc,aa(set(nat),nat,finite_card(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_tm(set(nat),fun(nat,fun(nat,$o)),M),I2)))) = aa(set(nat),nat,finite_card(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_tn(set(nat),fun(nat,fun(nat,$o)),M),I2))) ) ) ).

% card_less_Suc
tff(fact_2552_card__less,axiom,
    ! [M: set(nat),I2: nat] :
      ( aa(set(nat),$o,member(nat,zero_zero(nat)),M)
     => ( aa(set(nat),nat,finite_card(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_tn(set(nat),fun(nat,fun(nat,$o)),M),I2))) != zero_zero(nat) ) ) ).

% card_less
tff(fact_2553_wf,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => wf(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),ord_less(B)))) ) ).

% wf
tff(fact_2554_nat__seg__image__imp__finite,axiom,
    ! [B: $tType,A3: set(B),F2: fun(nat,B),N: nat] :
      ( ( A3 = aa(set(nat),set(B),image2(nat,B,F2),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N))) )
     => aa(set(B),$o,finite_finite2(B),A3) ) ).

% nat_seg_image_imp_finite
tff(fact_2555_finite__conv__nat__seg__image,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
    <=> ? [N4: nat,F8: fun(nat,B)] : ( A3 = aa(set(nat),set(B),image2(nat,B,F8),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N4))) ) ) ).

% finite_conv_nat_seg_image
tff(fact_2556_wf__if__measure,axiom,
    ! [B: $tType,Pa: fun(B,$o),F2: fun(B,nat),G: fun(B,B)] :
      ( ! [X: B] :
          ( aa(B,$o,Pa,X)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,F2,aa(B,B,G,X))),aa(B,nat,F2,X)) )
     => wf(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(fun(B,B),fun(B,fun(B,$o)),aTP_Lamp_to(fun(B,$o),fun(fun(B,B),fun(B,fun(B,$o))),Pa),G)))) ) ).

% wf_if_measure
tff(fact_2557_Field__natLeq__on,axiom,
    ! [N: nat] : ( field2(nat,aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_tp(nat,fun(nat,fun(nat,$o)),N)))) = aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N)) ) ).

% Field_natLeq_on
tff(fact_2558_natLeq__on__wo__rel,axiom,
    ! [N: nat] : bNF_Wellorder_wo_rel(nat,aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_tp(nat,fun(nat,fun(nat,$o)),N)))) ).

% natLeq_on_wo_rel
tff(fact_2559_finite__imp__inj__to__nat__seg,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ? [F9: fun(B,nat),N2: nat] :
          ( ( aa(set(B),set(nat),image2(B,nat,F9),A3) = aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N2)) )
          & inj_on(B,nat,F9,A3) ) ) ).

% finite_imp_inj_to_nat_seg
tff(fact_2560_finite__imp__inj__to__nat__seg_H,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ~ ! [F9: fun(B,nat)] :
            ( ? [N2: nat] : ( aa(set(B),set(nat),image2(B,nat,F9),A3) = aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N2)) )
           => ~ inj_on(B,nat,F9,A3) ) ) ).

% finite_imp_inj_to_nat_seg'
tff(fact_2561_eventually__gt__at__bot,axiom,
    ! [B: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Ca: B] : eventually(B,aTP_Lamp_tq(B,fun(B,$o),Ca),at_bot(B)) ) ).

% eventually_gt_at_bot
tff(fact_2562_add__neg__nonpos,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),zero_zero(B)) ) ) ) ).

% add_neg_nonpos
tff(fact_2563_add__nonneg__pos,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) ) ) ) ).

% add_nonneg_pos
tff(fact_2564_add__nonpos__neg,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),zero_zero(B)) ) ) ) ).

% add_nonpos_neg
tff(fact_2565_add__pos__nonneg,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) ) ) ) ).

% add_pos_nonneg
tff(fact_2566_add__strict__increasing,axiom,
    ! [B: $tType] :
      ( ordere8940638589300402666id_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)) ) ) ) ).

% add_strict_increasing
tff(fact_2567_add__strict__increasing2,axiom,
    ! [B: $tType] :
      ( ordere8940638589300402666id_add(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca)) ) ) ) ).

% add_strict_increasing2
tff(fact_2568_mult__le__cancel__left,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ) ) ).

% mult_le_cancel_left
tff(fact_2569_mult__le__cancel__right,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ) ) ).

% mult_le_cancel_right
tff(fact_2570_mult__left__less__imp__less,axiom,
    ! [B: $tType] :
      ( linordered_semiring(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ) ).

% mult_left_less_imp_less
tff(fact_2571_mult__strict__mono,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),D3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),D3)) ) ) ) ) ) ).

% mult_strict_mono
tff(fact_2572_mult__less__cancel__left,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) ) ) ) ) ).

% mult_less_cancel_left
tff(fact_2573_mult__right__less__imp__less,axiom,
    ! [B: $tType] :
      ( linordered_semiring(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ) ).

% mult_right_less_imp_less
tff(fact_2574_mult__strict__mono_H,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),D3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),D3)) ) ) ) ) ) ).

% mult_strict_mono'
tff(fact_2575_mult__less__cancel__right,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) ) ) ) ) ).

% mult_less_cancel_right
tff(fact_2576_mult__le__cancel__left__neg,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ) ).

% mult_le_cancel_left_neg
tff(fact_2577_mult__le__cancel__left__pos,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ) ).

% mult_le_cancel_left_pos
tff(fact_2578_mult__left__le__imp__le,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ) ).

% mult_left_le_imp_le
tff(fact_2579_mult__right__le__imp__le,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ) ).

% mult_right_le_imp_le
tff(fact_2580_mult__le__less__imp__less,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),D3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),D3)) ) ) ) ) ) ).

% mult_le_less_imp_less
tff(fact_2581_mult__less__le__imp__less,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),D3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),D3)) ) ) ) ) ) ).

% mult_less_le_imp_less
tff(fact_2582_not__sum__squares__lt__zero,axiom,
    ! [B: $tType] :
      ( linordered_ring(B)
     => ! [X2: B,Y: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y))),zero_zero(B)) ) ).

% not_sum_squares_lt_zero
tff(fact_2583_sum__squares__gt__zero__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y)))
        <=> ( ( X2 != zero_zero(B) )
            | ( Y != zero_zero(B) ) ) ) ) ).

% sum_squares_gt_zero_iff
tff(fact_2584_discrete,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))),B3) ) ) ).

% discrete
tff(fact_2585_zero__less__two,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),one_one(B))) ) ).

% zero_less_two
tff(fact_2586_less__minus__one__simps_I3_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% less_minus_one_simps(3)
tff(fact_2587_less__minus__one__simps_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),one_one(B))),zero_zero(B)) ) ).

% less_minus_one_simps(1)
tff(fact_2588_less__add__iff1,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A4: B,E2: B,Ca: B,B3: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),E2)),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),E2)),D3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),E2)),Ca)),D3) ) ) ).

% less_add_iff1
tff(fact_2589_less__add__iff2,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A4: B,E2: B,Ca: B,B3: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),E2)),Ca)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),E2)),D3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4)),E2)),D3)) ) ) ).

% less_add_iff2
tff(fact_2590_divide__strict__left__mono__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),B3)) ) ) ) ) ).

% divide_strict_left_mono_neg
tff(fact_2591_divide__strict__left__mono,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),B3)) ) ) ) ) ).

% divide_strict_left_mono
tff(fact_2592_mult__imp__less__div__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,Z2: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y)),X2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)) ) ) ) ).

% mult_imp_less_div_pos
tff(fact_2593_mult__imp__div__pos__less,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,X2: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)),Z2) ) ) ) ).

% mult_imp_div_pos_less
tff(fact_2594_pos__less__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3) ) ) ) ).

% pos_less_divide_eq
tff(fact_2595_pos__divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),A4)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ) ).

% pos_divide_less_eq
tff(fact_2596_neg__less__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ) ).

% neg_less_divide_eq
tff(fact_2597_neg__divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),A4)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3) ) ) ) ).

% neg_divide_less_eq
tff(fact_2598_less__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))) ) ) ) ).

% less_divide_eq
tff(fact_2599_divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),A4)
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3),aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)) ) ) ) ).

% divide_less_eq
tff(fact_2600_divide__less__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)),one_one(B))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) )
            | ( A4 = zero_zero(B) ) ) ) ) ).

% divide_less_eq_1
tff(fact_2601_less__divide__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) ) ) ) ) ).

% less_divide_eq_1
tff(fact_2602_ex__less__of__nat__mult,axiom,
    ! [B: $tType] :
      ( archim462609752435547400_field(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),X2)
         => ? [N2: nat] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N2)),X2)) ) ) ).

% ex_less_of_nat_mult
tff(fact_2603_gt__half__sum,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),one_one(B)))),B3) ) ) ).

% gt_half_sum
tff(fact_2604_less__half__sum,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),one_one(B)))) ) ) ).

% less_half_sum
tff(fact_2605_dense__eq0__I,axiom,
    ! [B: $tType] :
      ( ( ordere166539214618696060dd_abs(B)
        & dense_linorder(B) )
     => ! [X2: B] :
          ( ! [E4: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),E4)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),X2)),E4) )
         => ( X2 = zero_zero(B) ) ) ) ).

% dense_eq0_I
tff(fact_2606_power__less__power__Suc,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N))) ) ) ).

% power_less_power_Suc
tff(fact_2607_power__gt1__lemma,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N))) ) ) ).

% power_gt1_lemma
tff(fact_2608_finite__linorder__min__induct,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),Pa: fun(set(B),$o)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,Pa,bot_bot(set(B)))
           => ( ! [B4: B,A11: set(B)] :
                  ( aa(set(B),$o,finite_finite2(B),A11)
                 => ( ! [X4: B] :
                        ( aa(set(B),$o,member(B,X4),A11)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less(B),B4),X4) )
                   => ( aa(set(B),$o,Pa,A11)
                     => aa(set(B),$o,Pa,aa(set(B),set(B),insert(B,B4),A11)) ) ) )
             => aa(set(B),$o,Pa,A3) ) ) ) ) ).

% finite_linorder_min_induct
tff(fact_2609_finite__linorder__max__induct,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),Pa: fun(set(B),$o)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,Pa,bot_bot(set(B)))
           => ( ! [B4: B,A11: set(B)] :
                  ( aa(set(B),$o,finite_finite2(B),A11)
                 => ( ! [X4: B] :
                        ( aa(set(B),$o,member(B,X4),A11)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X4),B4) )
                   => ( aa(set(B),$o,Pa,A11)
                     => aa(set(B),$o,Pa,aa(set(B),set(B),insert(B,B4),A11)) ) ) )
             => aa(set(B),$o,Pa,A3) ) ) ) ) ).

% finite_linorder_max_induct
tff(fact_2610_finite__Sup__less__iff,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X5: set(B),A4: B] :
          ( aa(set(B),$o,finite_finite2(B),X5)
         => ( ( X5 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,complete_Sup_Sup(B),X5)),A4)
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),X5)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),A4) ) ) ) ) ) ).

% finite_Sup_less_iff
tff(fact_2611_power__gt1,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(nat,nat,suc,N))) ) ) ).

% power_gt1
tff(fact_2612_abs__if,axiom,
    ! [B: $tType] :
      ( abs_if(B)
     => ! [A4: B] :
          ( aa(B,B,abs_abs(B),A4)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B)),aa(B,B,uminus_uminus(B),A4),A4) ) ) ).

% abs_if
tff(fact_2613_abs__of__neg,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
         => ( aa(B,B,abs_abs(B),A4) = aa(B,B,uminus_uminus(B),A4) ) ) ) ).

% abs_of_neg
tff(fact_2614_abs__diff__less__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B,A4: B,R2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),A4))),R2)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),R2)),X2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),R2)) ) ) ) ).

% abs_diff_less_iff
tff(fact_2615_finite__less__Inf__iff,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X5: set(B),A4: B] :
          ( aa(set(B),$o,finite_finite2(B),X5)
         => ( ( X5 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(set(B),B,complete_Inf_Inf(B),X5))
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),X5)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),X3) ) ) ) ) ) ).

% finite_less_Inf_iff
tff(fact_2616_sum__strict__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( strict7427464778891057005id_add(C)
     => ! [A3: set(B),F2: fun(B,C),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [X: B] :
                  ( aa(set(B),$o,member(B,X),A3)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,X)),aa(B,C,G,X)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),A3)) ) ) ) ) ).

% sum_strict_mono
tff(fact_2617_less__cSup__iff,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X5: set(B),Y: B] :
          ( ( X5 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,X5)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(set(B),B,complete_Sup_Sup(B),X5))
            <=> ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),X5)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X3) ) ) ) ) ) ).

% less_cSup_iff
tff(fact_2618_cInf__less__iff,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X5: set(B),Y: B] :
          ( ( X5 != bot_bot(set(B)) )
         => ( aa(set(B),$o,condit1013018076250108175_below(B),X5)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,complete_Inf_Inf(B),X5)),Y)
            <=> ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),X5)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),Y) ) ) ) ) ) ).

% cInf_less_iff
tff(fact_2619_Un__interval,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(B)
     => ! [B12: B,B23: B,B32: B,F2: fun(B,C)] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B12),B23)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B23),B32)
           => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),aa(fun(C,$o),set(C),collect(C),aa(fun(B,C),fun(C,$o),aa(B,fun(fun(B,C),fun(C,$o)),aTP_Lamp_tr(B,fun(B,fun(fun(B,C),fun(C,$o))),B12),B23),F2))),aa(fun(C,$o),set(C),collect(C),aa(fun(B,C),fun(C,$o),aa(B,fun(fun(B,C),fun(C,$o)),aTP_Lamp_tr(B,fun(B,fun(fun(B,C),fun(C,$o))),B23),B32),F2))) = aa(fun(C,$o),set(C),collect(C),aa(fun(B,C),fun(C,$o),aa(B,fun(fun(B,C),fun(C,$o)),aTP_Lamp_tr(B,fun(B,fun(fun(B,C),fun(C,$o))),B12),B32),F2)) ) ) ) ) ).

% Un_interval
tff(fact_2620_add__mset__in__multiset,axiom,
    ! [B: $tType,M: fun(B,nat),A4: B] :
      ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_tk(fun(B,nat),fun(B,$o),M)))
     => aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_ts(fun(B,nat),fun(B,fun(B,$o)),M),A4))) ) ).

% add_mset_in_multiset
tff(fact_2621_diff__preserves__multiset,axiom,
    ! [B: $tType,M: fun(B,nat),N3: fun(B,nat)] :
      ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_tk(fun(B,nat),fun(B,$o),M)))
     => aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,nat),fun(B,$o),aTP_Lamp_tt(fun(B,nat),fun(fun(B,nat),fun(B,$o)),M),N3))) ) ).

% diff_preserves_multiset
tff(fact_2622_cSUP__lessD,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F2: fun(C,B),A3: set(C),Y: B,I2: C] :
          ( condit941137186595557371_above(B,aa(set(C),set(B),image2(C,B,F2),A3))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),A3))),Y)
           => ( aa(set(C),$o,member(C,I2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(C,B,F2,I2)),Y) ) ) ) ) ).

% cSUP_lessD
tff(fact_2623_less__cINF__D,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F2: fun(C,B),A3: set(C),Y: B,I2: C] :
          ( aa(set(B),$o,condit1013018076250108175_below(B),aa(set(C),set(B),image2(C,B,F2),A3))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3)))
           => ( aa(set(C),$o,member(C,I2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(C,B,F2,I2)) ) ) ) ) ).

% less_cINF_D
tff(fact_2624_arg__min__if__finite_I2_J,axiom,
    ! [C: $tType,B: $tType] :
      ( order(C)
     => ! [S: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( ( S != bot_bot(set(B)) )
           => ~ ? [X4: B] :
                  ( aa(set(B),$o,member(B,X4),S)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,X4)),aa(B,C,F2,lattic7623131987881927897min_on(B,C,F2,S))) ) ) ) ) ).

% arg_min_if_finite(2)
tff(fact_2625_finite__imp__nat__seg__image__inj__on,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ? [N2: nat,F9: fun(nat,B)] :
          ( ( A3 = aa(set(nat),set(B),image2(nat,B,F9),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N2))) )
          & inj_on(nat,B,F9,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N2))) ) ) ).

% finite_imp_nat_seg_image_inj_on
tff(fact_2626_mult__less__cancel__right2,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),Ca)
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),one_one(B)) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4) ) ) ) ) ).

% mult_less_cancel_right2
tff(fact_2627_mult__less__cancel__right1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),B3) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),one_one(B)) ) ) ) ) ).

% mult_less_cancel_right1
tff(fact_2628_mult__less__cancel__left2,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),Ca)
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),one_one(B)) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4) ) ) ) ) ).

% mult_less_cancel_left2
tff(fact_2629_mult__less__cancel__left1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),B3) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),one_one(B)) ) ) ) ) ).

% mult_less_cancel_left1
tff(fact_2630_mult__le__cancel__right2,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),Ca)
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),one_one(B)) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A4) ) ) ) ) ).

% mult_le_cancel_right2
tff(fact_2631_mult__le__cancel__right1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),B3) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),one_one(B)) ) ) ) ) ).

% mult_le_cancel_right1
tff(fact_2632_mult__le__cancel__left2,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),Ca)
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),one_one(B)) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A4) ) ) ) ) ).

% mult_le_cancel_left2
tff(fact_2633_mult__le__cancel__left1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),B3) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),one_one(B)) ) ) ) ) ).

% mult_le_cancel_left1
tff(fact_2634_field__le__mult__one__interval,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X2: B,Y: B] :
          ( ! [Z3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Z3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z3),one_one(B))
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Z3),X2)),Y) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y) ) ) ).

% field_le_mult_one_interval
tff(fact_2635_divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),A4)
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)) ) ) ) ).

% divide_le_eq
tff(fact_2636_le__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))) ) ) ) ).

% le_divide_eq
tff(fact_2637_divide__left__mono,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),B3)) ) ) ) ) ).

% divide_left_mono
tff(fact_2638_neg__divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),A4)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3) ) ) ) ).

% neg_divide_le_eq
tff(fact_2639_neg__le__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ) ).

% neg_le_divide_eq
tff(fact_2640_pos__divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),A4)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ) ).

% pos_divide_le_eq
tff(fact_2641_pos__le__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3) ) ) ) ).

% pos_le_divide_eq
tff(fact_2642_mult__imp__div__pos__le,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,X2: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)),Z2) ) ) ) ).

% mult_imp_div_pos_le
tff(fact_2643_mult__imp__le__div__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,Z2: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y)),X2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)) ) ) ) ).

% mult_imp_le_div_pos
tff(fact_2644_divide__left__mono__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),zero_zero(B))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),B3)) ) ) ) ) ).

% divide_left_mono_neg
tff(fact_2645_le__divide__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ) ) ).

% le_divide_eq_1
tff(fact_2646_divide__le__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)),one_one(B))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) )
            | ( A4 = zero_zero(B) ) ) ) ) ).

% divide_le_eq_1
tff(fact_2647_frac__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,Z2: B,X2: B,W2: B] :
          ( ( Y != zero_zero(B) )
         => ( ( Z2 != zero_zero(B) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y)),aa(B,B,aa(B,fun(B,B),divide_divide(B),W2),Z2))
            <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y))),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))),zero_zero(B)) ) ) ) ) ).

% frac_less_eq
tff(fact_2648_power__Suc__less,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N))),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)) ) ) ) ).

% power_Suc_less
tff(fact_2649_less__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,uminus_uminus(B),B3)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))) ) ) ) ).

% less_minus_divide_eq
tff(fact_2650_minus__divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))),A4)
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,uminus_uminus(B),B3)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)) ) ) ) ).

% minus_divide_less_eq
tff(fact_2651_neg__less__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ) ).

% neg_less_minus_divide_eq
tff(fact_2652_neg__minus__divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))),A4)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,uminus_uminus(B),B3)) ) ) ) ).

% neg_minus_divide_less_eq
tff(fact_2653_pos__less__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,uminus_uminus(B),B3)) ) ) ) ).

% pos_less_minus_divide_eq
tff(fact_2654_pos__minus__divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))),A4)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ) ).

% pos_minus_divide_less_eq
tff(fact_2655_filterlim__at__bot__dense,axiom,
    ! [C: $tType,B: $tType] :
      ( ( dense_linorder(C)
        & no_bot(C) )
     => ! [F2: fun(B,C),F: filter(B)] :
          ( filterlim(B,C,F2,at_bot(C),F)
        <=> ! [Z6: C] : eventually(B,aa(C,fun(B,$o),aTP_Lamp_tu(fun(B,C),fun(C,fun(B,$o)),F2),Z6),F) ) ) ).

% filterlim_at_bot_dense
tff(fact_2656_power__Suc__less__one,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(nat,nat,suc,N))),one_one(B)) ) ) ) ).

% power_Suc_less_one
tff(fact_2657_abs__add__one__gt__zero,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,abs_abs(B),X2))) ) ).

% abs_add_one_gt_zero
tff(fact_2658_sum__pos,axiom,
    ! [C: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(C)
     => ! [I: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),I)
         => ( ( I != bot_bot(set(B)) )
           => ( ! [I3: B] :
                  ( aa(set(B),$o,member(B,I3),I)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),zero_zero(C)),aa(B,C,F2,I3)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),zero_zero(C)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),I)) ) ) ) ) ).

% sum_pos
tff(fact_2659_power__le__imp__le__exp,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,M2: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N))
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N) ) ) ) ).

% power_le_imp_le_exp
tff(fact_2660_less__1__prod2,axiom,
    ! [C: $tType,B: $tType] :
      ( linordered_idom(C)
     => ! [I: set(B),I2: B,F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),I)
         => ( aa(set(B),$o,member(B,I2),I)
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),one_one(C)),aa(B,C,F2,I2))
             => ( ! [I3: B] :
                    ( aa(set(B),$o,member(B,I3),I)
                   => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),one_one(C)),aa(B,C,F2,I3)) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less(C),one_one(C)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),I)) ) ) ) ) ) ).

% less_1_prod2
tff(fact_2661_less__1__prod,axiom,
    ! [C: $tType,B: $tType] :
      ( linordered_idom(C)
     => ! [I: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),I)
         => ( ( I != bot_bot(set(B)) )
           => ( ! [I3: B] :
                  ( aa(set(B),$o,member(B,I3),I)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),one_one(C)),aa(B,C,F2,I3)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),one_one(C)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),I)) ) ) ) ) ).

% less_1_prod
tff(fact_2662_self__le__power,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A4)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)) ) ) ) ).

% self_le_power
tff(fact_2663_card__gt__0__iff,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(B),nat,finite_card(B),A3))
    <=> ( ( A3 != bot_bot(set(B)) )
        & aa(set(B),$o,finite_finite2(B),A3) ) ) ).

% card_gt_0_iff
tff(fact_2664_less__cSUP__iff,axiom,
    ! [C: $tType,B: $tType] :
      ( condit6923001295902523014norder(C)
     => ! [A3: set(B),F2: fun(B,C),A4: C] :
          ( ( A3 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,F2),A3))
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),A4),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3)))
            <=> ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less(C),A4),aa(B,C,F2,X3)) ) ) ) ) ) ).

% less_cSUP_iff
tff(fact_2665_cINF__less__iff,axiom,
    ! [B: $tType,C: $tType] :
      ( condit6923001295902523014norder(C)
     => ! [A3: set(B),F2: fun(B,C),A4: C] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(C),$o,condit1013018076250108175_below(C),aa(set(B),set(C),image2(B,C,F2),A3))
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,F2),A3))),A4)
            <=> ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,X3)),A4) ) ) ) ) ) ).

% cINF_less_iff
tff(fact_2666_convex__bound__lt,axiom,
    ! [B: $tType] :
      ( linord715952674999750819strict(B)
     => ! [X2: B,A4: B,Y: B,U: B,V: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),A4)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),U)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),V)
               => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),U),V) = one_one(B) )
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),U),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),V),Y))),A4) ) ) ) ) ) ) ).

% convex_bound_lt
tff(fact_2667_pos__minus__divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))),A4)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ) ).

% pos_minus_divide_le_eq
tff(fact_2668_pos__le__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,uminus_uminus(B),B3)) ) ) ) ).

% pos_le_minus_divide_eq
tff(fact_2669_neg__minus__divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))),A4)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,uminus_uminus(B),B3)) ) ) ) ).

% neg_minus_divide_le_eq
tff(fact_2670_neg__le__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)) ) ) ) ).

% neg_le_minus_divide_eq
tff(fact_2671_minus__divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))),A4)
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,uminus_uminus(B),B3)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)) ) ) ) ).

% minus_divide_le_eq
tff(fact_2672_le__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,uminus_uminus(B),B3)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),zero_zero(B))) ) ) ) ).

% le_minus_divide_eq
tff(fact_2673_filterlim__at__bot__lt,axiom,
    ! [C: $tType,B: $tType] :
      ( unboun7993243217541854897norder(C)
     => ! [F2: fun(B,C),F: filter(B),Ca: C] :
          ( filterlim(B,C,F2,at_bot(C),F)
        <=> ! [Z6: C] :
              ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),Z6),Ca)
             => eventually(B,aa(C,fun(B,$o),aTP_Lamp_tv(fun(B,C),fun(C,fun(B,$o)),F2),Z6),F) ) ) ) ).

% filterlim_at_bot_lt
tff(fact_2674_prod__mono__strict,axiom,
    ! [C: $tType,B: $tType] :
      ( linordered_semidom(C)
     => ! [A3: set(B),F2: fun(B,C),G: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ! [I3: B] :
                ( aa(set(B),$o,member(B,I3),A3)
               => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,F2,I3))
                  & aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,I3)),aa(B,C,G,I3)) ) )
           => ( ( A3 != bot_bot(set(B)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),A3)) ) ) ) ) ).

% prod_mono_strict
tff(fact_2675_nat__approx__posE,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [E2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),E2)
         => ~ ! [N2: nat] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,N2)))),E2) ) ) ).

% nat_approx_posE
tff(fact_2676_card__Diff1__less__iff,axiom,
    ! [B: $tType,A3: set(B),X2: B] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))),aa(set(B),nat,finite_card(B),A3))
    <=> ( aa(set(B),$o,finite_finite2(B),A3)
        & aa(set(B),$o,member(B,X2),A3) ) ) ).

% card_Diff1_less_iff
tff(fact_2677_card__Diff2__less,axiom,
    ! [B: $tType,A3: set(B),X2: B,Y: B] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),$o,member(B,X2),A3)
       => ( aa(set(B),$o,member(B,Y),A3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),aa(set(B),set(B),insert(B,Y),bot_bot(set(B)))))),aa(set(B),nat,finite_card(B),A3)) ) ) ) ).

% card_Diff2_less
tff(fact_2678_card__Diff1__less,axiom,
    ! [B: $tType,A3: set(B),X2: B] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),$o,member(B,X2),A3)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))),aa(set(B),nat,finite_card(B),A3)) ) ) ).

% card_Diff1_less
tff(fact_2679_power__minus__mult,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [N: nat,A4: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))),A4) = aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N) ) ) ) ).

% power_minus_mult
tff(fact_2680_image__mult__atLeastAtMost__if,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,X2: B,Y: B] :
          ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),Ca)),set_or1337092689740270186AtMost(B,X2,Y))
          = $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),times_times(B),Ca),X2),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),Y)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),times_times(B),Ca),Y),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),X2)),bot_bot(set(B))) ) ) ) ).

% image_mult_atLeastAtMost_if
tff(fact_2681_image__mult__atLeastAtMost__if_H,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ca: B,X2: B,Y: B] :
          ( aa(set(B),set(B),image2(B,B,aTP_Lamp_tw(B,fun(B,B),Ca)),set_or1337092689740270186AtMost(B,X2,Y))
          = $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),times_times(B),X2),Ca),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Ca)),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),times_times(B),Y),Ca),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Ca))),
              bot_bot(set(B)) ) ) ) ).

% image_mult_atLeastAtMost_if'
tff(fact_2682_sum__atLeastAtMost__code,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [F2: fun(nat,B),A4: nat,B3: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),F2),set_or1337092689740270186AtMost(nat,A4,B3)) = set_fo6178422350223883121st_nat(B,aTP_Lamp_tx(fun(nat,B),fun(nat,fun(B,B)),F2),A4,B3,zero_zero(B)) ) ) ).

% sum_atLeastAtMost_code
tff(fact_2683_mult__le__cancel__iff2,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Z2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y) ) ) ) ).

% mult_le_cancel_iff2
tff(fact_2684_mult__le__cancel__iff1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Z2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y) ) ) ) ).

% mult_le_cancel_iff1
tff(fact_2685_natLess__def,axiom,
    bNF_Ca8459412986667044542atLess = aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),ord_less(nat))) ).

% natLess_def
tff(fact_2686_divmod__nat__if,axiom,
    ! [M2: nat,N: nat] :
      ( divmod_nat(M2,N)
      = $ite(
          ( ( N = zero_zero(nat) )
          | aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N) ),
          aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),M2),
          aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_ty(nat,fun(nat,product_prod(nat,nat)))),divmod_nat(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),N),N)) ) ) ).

% divmod_nat_if
tff(fact_2687_mult__less__iff1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Z2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y) ) ) ) ).

% mult_less_iff1
tff(fact_2688_choose__alternating__sum,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_tz(nat,fun(nat,B),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) = zero_zero(B) ) ) ) ).

% choose_alternating_sum
tff(fact_2689_finite__interval__int4,axiom,
    ! [A4: int,B3: int] : aa(set(int),$o,finite_finite2(int),aa(fun(int,$o),set(int),collect(int),aa(int,fun(int,$o),aTP_Lamp_ua(int,fun(int,fun(int,$o)),A4),B3))) ).

% finite_interval_int4
tff(fact_2690_finite__interval__int2,axiom,
    ! [A4: int,B3: int] : aa(set(int),$o,finite_finite2(int),aa(fun(int,$o),set(int),collect(int),aa(int,fun(int,$o),aTP_Lamp_ub(int,fun(int,fun(int,$o)),A4),B3))) ).

% finite_interval_int2
tff(fact_2691_finite__interval__int3,axiom,
    ! [A4: int,B3: int] : aa(set(int),$o,finite_finite2(int),aa(fun(int,$o),set(int),collect(int),aa(int,fun(int,$o),aTP_Lamp_uc(int,fun(int,fun(int,$o)),A4),B3))) ).

% finite_interval_int3
tff(fact_2692_not__psubset__empty,axiom,
    ! [B: $tType,A3: set(B)] : ~ aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A3),bot_bot(set(B))) ).

% not_psubset_empty
tff(fact_2693_less__fun__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [F2: fun(B,C),G: fun(B,C)] :
          ( aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less(fun(B,C)),F2),G)
        <=> ( aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),F2),G)
            & ~ aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),G),F2) ) ) ) ).

% less_fun_def
tff(fact_2694_less__assn__def,axiom,
    ! [A4: assn,B3: assn] :
      ( aa(assn,$o,aa(assn,fun(assn,$o),ord_less(assn),A4),B3)
    <=> ( aa(assn,$o,aa(assn,fun(assn,$o),ord_less_eq(assn),A4),B3)
        & ( A4 != B3 ) ) ) ).

% less_assn_def
tff(fact_2695_simp__from__to,axiom,
    ! [I2: int,J2: int] :
      ( set_or1337092689740270186AtMost(int,I2,J2)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I2),bot_bot(set(int)),aa(set(int),set(int),insert(int,I2),set_or1337092689740270186AtMost(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int)),J2))) ) ).

% simp_from_to
tff(fact_2696_sum__choose__upper,axiom,
    ! [M2: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_ud(nat,fun(nat,nat),M2)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,nat,binomial(aa(nat,nat,suc,N)),aa(nat,nat,suc,M2)) ) ).

% sum_choose_upper
tff(fact_2697_nat__less__as__int,axiom,
    ! [X4: nat,Xa3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X4),Xa3)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa3)) ) ).

% nat_less_as_int
tff(fact_2698_remove__subset,axiom,
    ! [B: $tType,X2: B,S: set(B)] :
      ( aa(set(B),$o,member(B,X2),S)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),S) ) ).

% remove_subset
tff(fact_2699_disjoint__alt__simp3,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B2)),A3)
    <=> ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) != bot_bot(set(B)) ) ) ).

% disjoint_alt_simp3
tff(fact_2700_sum__choose__lower,axiom,
    ! [R2: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_ue(nat,fun(nat,nat),R2)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),R2),N))),N) ) ).

% sum_choose_lower
tff(fact_2701_choose__rising__sum_I1_J,axiom,
    ! [N: nat,M2: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_uf(nat,fun(nat,nat),N)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M2)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))) ) ).

% choose_rising_sum(1)
tff(fact_2702_choose__rising__sum_I2_J,axiom,
    ! [N: nat,M2: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_uf(nat,fun(nat,nat),N)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M2)),one_one(nat))),M2) ) ).

% choose_rising_sum(2)
tff(fact_2703_diff__nat__eq__if,axiom,
    ! [Z2: int,Z7: int] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z2)),aa(int,nat,nat2,Z7))
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z7),zero_zero(int)),
          aa(int,nat,nat2,Z2),
          $let(
            d: int,
            d := aa(int,int,aa(int,fun(int,int),minus_minus(int),Z2),Z7),
            $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),d),zero_zero(int)),zero_zero(nat),aa(int,nat,nat2,d)) ) ) ) ).

% diff_nat_eq_if
tff(fact_2704_wf__bounded__supset,axiom,
    ! [B: $tType,S: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),S)
     => wf(set(B),aa(fun(product_prod(set(B),set(B)),$o),set(product_prod(set(B),set(B))),collect(product_prod(set(B),set(B))),aa(fun(set(B),fun(set(B),$o)),fun(product_prod(set(B),set(B)),$o),product_case_prod(set(B),set(B),$o),aTP_Lamp_ug(set(B),fun(set(B),fun(set(B),$o)),S)))) ) ).

% wf_bounded_supset
tff(fact_2705_finite__subset__wf,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => wf(set(B),aa(fun(product_prod(set(B),set(B)),$o),set(product_prod(set(B),set(B))),collect(product_prod(set(B),set(B))),aa(fun(set(B),fun(set(B),$o)),fun(product_prod(set(B),set(B)),$o),product_case_prod(set(B),set(B),$o),aTP_Lamp_uh(set(B),fun(set(B),fun(set(B),$o)),A3)))) ) ).

% finite_subset_wf
tff(fact_2706_finite__induct__select,axiom,
    ! [B: $tType,S: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite2(B),S)
     => ( aa(set(B),$o,Pa,bot_bot(set(B)))
       => ( ! [T5: set(B)] :
              ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),T5),S)
             => ( aa(set(B),$o,Pa,T5)
               => ? [X4: B] :
                    ( aa(set(B),$o,member(B,X4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),T5))
                    & aa(set(B),$o,Pa,aa(set(B),set(B),insert(B,X4),T5)) ) ) )
         => aa(set(B),$o,Pa,S) ) ) ) ).

% finite_induct_select
tff(fact_2707_psubset__insert__iff,axiom,
    ! [B: $tType,A3: set(B),X2: B,B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A3),aa(set(B),set(B),insert(B,X2),B2))
    <=> $ite(
          aa(set(B),$o,member(B,X2),B2),
          aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A3),B2),
          $ite(aa(set(B),$o,member(B,X2),A3),aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),B2),aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)) ) ) ).

% psubset_insert_iff
tff(fact_2708_sum__choose__diagonal,axiom,
    ! [M2: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
     => ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_ui(nat,fun(nat,fun(nat,nat)),M2),N)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,nat,binomial(aa(nat,nat,suc,N)),M2) ) ) ).

% sum_choose_diagonal
tff(fact_2709_vandermonde,axiom,
    ! [M2: nat,N: nat,R2: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_uj(nat,fun(nat,fun(nat,fun(nat,nat))),M2),N),R2)),aa(nat,set(nat),set_ord_atMost(nat),R2)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),N)),R2) ) ).

% vandermonde
tff(fact_2710_binomial,axiom,
    ! [A4: nat,B3: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),B3)),N) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_uk(nat,fun(nat,fun(nat,fun(nat,nat))),A4),B3),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ).

% binomial
tff(fact_2711_n__subsets,axiom,
    ! [B: $tType,A3: set(B),K: nat] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(set(B)),nat,finite_card(set(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aa(nat,fun(set(B),$o),aTP_Lamp_ul(set(B),fun(nat,fun(set(B),$o)),A3),K))) = aa(nat,nat,binomial(aa(set(B),nat,finite_card(B),A3)),K) ) ) ).

% n_subsets
tff(fact_2712_binomial__ring,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B,B3: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),N) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aa(B,fun(nat,fun(nat,B)),aTP_Lamp_um(B,fun(B,fun(nat,fun(nat,B))),A4),B3),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% binomial_ring
tff(fact_2713_choose__alternating__linear__sum,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat] :
          ( ( N != one_one(nat) )
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_un(nat,fun(nat,B),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) = zero_zero(B) ) ) ) ).

% choose_alternating_linear_sum
tff(fact_2714_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [B: $tType,F2: fun(nat,set(B)),S: set(B)] :
      ( ! [I3: nat] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(nat,set(B),F2,I3)),S)
     => ( aa(set(B),$o,finite_finite2(B),S)
       => ( ? [N5: nat] :
              ( ! [N2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N2),N5)
                 => ! [M3: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M3),N5)
                     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N2)
                       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),aa(nat,set(B),F2,M3)),aa(nat,set(B),F2,N2)) ) ) )
              & ! [N2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N5),N2)
                 => ( aa(nat,set(B),F2,N5) = aa(nat,set(B),F2,N2) ) ) )
         => ( aa(nat,set(B),F2,aa(set(B),nat,finite_card(B),S)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),F2),top_top(set(nat)))) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
tff(fact_2715_mlex__eq,axiom,
    ! [B: $tType,F2: fun(B,nat),R: set(product_prod(B,B))] : ( mlex_prod(B,F2,R) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aTP_Lamp_uo(fun(B,nat),fun(set(product_prod(B,B)),fun(B,fun(B,$o))),F2),R))) ) ).

% mlex_eq
tff(fact_2716_gbinomial__partial__sum__poly__xpos,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [M2: nat,A4: B,X2: B,Y: B] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_up(nat,fun(B,fun(B,fun(B,fun(nat,B)))),M2),A4),X2),Y)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_uq(nat,fun(B,fun(B,fun(B,fun(nat,B)))),M2),A4),X2),Y)),aa(nat,set(nat),set_ord_atMost(nat),M2)) ) ) ).

% gbinomial_partial_sum_poly_xpos
tff(fact_2717_prod_Otriangle__reindex,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,fun(nat,B)),N: nat] : ( aa(set(product_prod(nat,nat)),B,aa(fun(product_prod(nat,nat),B),fun(set(product_prod(nat,nat)),B),groups7121269368397514597t_prod(product_prod(nat,nat),B),aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),G)),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_ur(nat,fun(nat,fun(nat,$o)),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_rg(fun(nat,fun(nat,B)),fun(nat,B),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% prod.triangle_reindex
tff(fact_2718_sum_Otriangle__reindex,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,fun(nat,B)),N: nat] : ( aa(set(product_prod(nat,nat)),B,aa(fun(product_prod(nat,nat),B),fun(set(product_prod(nat,nat)),B),groups7311177749621191930dd_sum(product_prod(nat,nat),B),aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),G)),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_ur(nat,fun(nat,fun(nat,$o)),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_re(fun(nat,fun(nat,B)),fun(nat,B),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% sum.triangle_reindex
tff(fact_2719_pochhammer__code,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B,N: nat] :
          ( comm_s3205402744901411588hammer(B,A4,N)
          = $ite(N = zero_zero(nat),one_one(B),set_fo6178422350223883121st_nat(B,aTP_Lamp_us(B,fun(nat,fun(B,B)),A4),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),one_one(B))) ) ) ).

% pochhammer_code
tff(fact_2720_trancl__finite__eq__relpow,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,finite_finite2(product_prod(B,B)),R)
     => ( transitive_trancl(B,R) = aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),aa(set(nat),set(set(product_prod(B,B))),image2(nat,set(product_prod(B,B)),aTP_Lamp_ut(set(product_prod(B,B)),fun(nat,set(product_prod(B,B))),R)),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_uu(set(product_prod(B,B)),fun(nat,$o),R)))) ) ) ).

% trancl_finite_eq_relpow
tff(fact_2721_gbinomial__0_I1_J,axiom,
    ! [B: $tType] :
      ( ( semiring_char_0(B)
        & semidom_divide(B) )
     => ! [A4: B] : ( aa(nat,B,gbinomial(B,A4),zero_zero(nat)) = one_one(B) ) ) ).

% gbinomial_0(1)
tff(fact_2722_pochhammer__0,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B] : ( comm_s3205402744901411588hammer(B,A4,zero_zero(nat)) = one_one(B) ) ) ).

% pochhammer_0
tff(fact_2723_lessThan__0,axiom,
    aa(nat,set(nat),set_ord_lessThan(nat),zero_zero(nat)) = bot_bot(set(nat)) ).

% lessThan_0
tff(fact_2724_single__Diff__lessThan,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [K: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),insert(B,K),bot_bot(set(B)))),aa(B,set(B),set_ord_lessThan(B),K)) = aa(set(B),set(B),insert(B,K),bot_bot(set(B))) ) ) ).

% single_Diff_lessThan
tff(fact_2725_prod_OlessThan__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),aa(nat,set(nat),set_ord_lessThan(nat),N))),aa(nat,B,G,N)) ) ) ).

% prod.lessThan_Suc
tff(fact_2726_Inf__atMostLessThan,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),top_top(B)),X2)
         => ( aa(set(B),B,complete_Inf_Inf(B),aa(B,set(B),set_ord_lessThan(B),X2)) = bot_bot(B) ) ) ) ).

% Inf_atMostLessThan
tff(fact_2727_less__set__def,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A3),B2)
    <=> aa(fun(B,$o),$o,aa(fun(B,$o),fun(fun(B,$o),$o),ord_less(fun(B,$o)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3)),aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),B2)) ) ).

% less_set_def
tff(fact_2728_lessThan__non__empty,axiom,
    ! [B: $tType] :
      ( no_bot(B)
     => ! [X2: B] : ( aa(B,set(B),set_ord_lessThan(B),X2) != bot_bot(set(B)) ) ) ).

% lessThan_non_empty
tff(fact_2729_lessThan__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [U: B] : ( aa(B,set(B),set_ord_lessThan(B),U) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_uv(B,fun(B,$o),U)) ) ) ).

% lessThan_def
tff(fact_2730_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( aa(nat,set(nat),set_ord_lessThan(nat),N) = bot_bot(set(nat)) )
    <=> ( N = zero_zero(nat) ) ) ).

% lessThan_empty_iff
tff(fact_2731_Iio__eq__empty__iff,axiom,
    ! [B: $tType] :
      ( ( linorder(B)
        & order_bot(B) )
     => ! [N: B] :
          ( ( aa(B,set(B),set_ord_lessThan(B),N) = bot_bot(set(B)) )
        <=> ( N = bot_bot(B) ) ) ) ).

% Iio_eq_empty_iff
tff(fact_2732_gbinomial__Suc__Suc,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))),aa(nat,nat,suc,K)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,gbinomial(B,A4),K)),aa(nat,B,gbinomial(B,A4),aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc_Suc
tff(fact_2733_pochhammer__0__left,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [N: nat] :
          ( comm_s3205402744901411588hammer(B,zero_zero(B),N)
          = $ite(N = zero_zero(nat),one_one(B),zero_zero(B)) ) ) ).

% pochhammer_0_left
tff(fact_2734_sum_Onat__diff__reindex,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_uw(fun(nat,B),fun(nat,fun(nat,B)),G),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% sum.nat_diff_reindex
tff(fact_2735_prod_Onat__diff__reindex,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_ux(fun(nat,B),fun(nat,fun(nat,B)),G),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% prod.nat_diff_reindex
tff(fact_2736_relpow__empty,axiom,
    ! [B: $tType,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( compow(set(product_prod(B,B)),N,bot_bot(set(product_prod(B,B)))) = bot_bot(set(product_prod(B,B))) ) ) ).

% relpow_empty
tff(fact_2737_ivl__disj__int__one_I4_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_lessThan(B),L)),set_or1337092689740270186AtMost(B,L,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(4)
tff(fact_2738_gbinomial__addition__formula,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(nat,B,gbinomial(B,A4),aa(nat,nat,suc,K)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))),aa(nat,nat,suc,K))),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))),K)) ) ) ).

% gbinomial_addition_formula
tff(fact_2739_gbinomial__absorb__comp,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(nat,B,semiring_1_of_nat(B),K))),aa(nat,B,gbinomial(B,A4),K)) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))),K)) ) ) ).

% gbinomial_absorb_comp
tff(fact_2740_gbinomial__mult__1_H,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,A4),K)),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),K)),aa(nat,B,gbinomial(B,A4),K))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K))),aa(nat,B,gbinomial(B,A4),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1'
tff(fact_2741_gbinomial__mult__1,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,gbinomial(B,A4),K)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),K)),aa(nat,B,gbinomial(B,A4),K))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K))),aa(nat,B,gbinomial(B,A4),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1
tff(fact_2742_sum__diff__distrib,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [Qa: fun(B,nat),Pa: fun(B,nat),N: B] :
          ( ! [X: B] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(B,nat,Qa,X)),aa(B,nat,Pa,X))
         => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),Pa),aa(B,set(B),set_ord_lessThan(B),N))),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),Qa),aa(B,set(B),set_ord_lessThan(B),N))) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(fun(B,nat),fun(B,nat),aTP_Lamp_uy(fun(B,nat),fun(fun(B,nat),fun(B,nat)),Qa),Pa)),aa(B,set(B),set_ord_lessThan(B),N)) ) ) ) ).

% sum_diff_distrib
tff(fact_2743_sum_OlessThan__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,G,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_sr(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% sum.lessThan_Suc_shift
tff(fact_2744_sum__lessThan__telescope,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [F2: fun(nat,B),M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_su(fun(nat,B),fun(nat,B),F2)),aa(nat,set(nat),set_ord_lessThan(nat),M2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,F2,M2)),aa(nat,B,F2,zero_zero(nat))) ) ) ).

% sum_lessThan_telescope
tff(fact_2745_sum__lessThan__telescope_H,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [F2: fun(nat,B),M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_sx(fun(nat,B),fun(nat,B),F2)),aa(nat,set(nat),set_ord_lessThan(nat),M2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,F2,zero_zero(nat))),aa(nat,B,F2,M2)) ) ) ).

% sum_lessThan_telescope'
tff(fact_2746_prod_OlessThan__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,G,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_ss(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% prod.lessThan_Suc_shift
tff(fact_2747_rtrancl__is__UN__relpow,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] : ( transitive_rtrancl(B,R) = aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),aa(set(nat),set(set(product_prod(B,B))),image2(nat,set(product_prod(B,B)),aTP_Lamp_ut(set(product_prod(B,B)),fun(nat,set(product_prod(B,B))),R)),top_top(set(nat)))) ) ).

% rtrancl_is_UN_relpow
tff(fact_2748_rtrancl__imp__UN__relpow,axiom,
    ! [B: $tType,P3: product_prod(B,B),R: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),P3),transitive_rtrancl(B,R))
     => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),P3),aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),aa(set(nat),set(set(product_prod(B,B))),image2(nat,set(product_prod(B,B)),aTP_Lamp_ut(set(product_prod(B,B)),fun(nat,set(product_prod(B,B))),R)),top_top(set(nat))))) ) ).

% rtrancl_imp_UN_relpow
tff(fact_2749_sum_OatLeast1__atMost__eq,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_sr(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% sum.atLeast1_atMost_eq
tff(fact_2750_prod_OatLeast1__atMost__eq,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_ss(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% prod.atLeast1_atMost_eq
tff(fact_2751_pochhammer__rec,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B,N: nat] : ( comm_s3205402744901411588hammer(B,A4,aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B)),N)) ) ) ).

% pochhammer_rec
tff(fact_2752_sum__bounds__lt__plus1,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [F2: fun(nat,B),Mm: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_sr(fun(nat,B),fun(nat,B),F2)),aa(nat,set(nat),set_ord_lessThan(nat),Mm)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),F2),set_or1337092689740270186AtMost(nat,one_one(nat),Mm)) ) ) ).

% sum_bounds_lt_plus1
tff(fact_2753_pochhammer__rec_H,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Z2: B,N: nat] : ( comm_s3205402744901411588hammer(B,Z2,aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),aa(nat,B,semiring_1_of_nat(B),N))),comm_s3205402744901411588hammer(B,Z2,N)) ) ) ).

% pochhammer_rec'
tff(fact_2754_pochhammer__Suc,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B,N: nat] : ( comm_s3205402744901411588hammer(B,A4,aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),comm_s3205402744901411588hammer(B,A4,N)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(nat,B,semiring_1_of_nat(B),N))) ) ) ).

% pochhammer_Suc
tff(fact_2755_pochhammer__product_H,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Z2: B,N: nat,M2: nat] : ( comm_s3205402744901411588hammer(B,Z2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M2)) = aa(B,B,aa(B,fun(B,B),times_times(B),comm_s3205402744901411588hammer(B,Z2,N)),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),aa(nat,B,semiring_1_of_nat(B),N)),M2)) ) ) ).

% pochhammer_product'
tff(fact_2756_sum_Onested__swap_H,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [A4: fun(nat,fun(nat,B)),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_uz(fun(nat,fun(nat,B)),fun(nat,B),A4)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_vb(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),A4),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% sum.nested_swap'
tff(fact_2757_prod_Onested__swap_H,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: fun(nat,fun(nat,B)),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_vc(fun(nat,fun(nat,B)),fun(nat,B),A4)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_ve(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),A4),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% prod.nested_swap'
tff(fact_2758_Iio__Int__singleton,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [K: B,X2: B] :
          ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_lessThan(B),K)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),K),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))),bot_bot(set(B))) ) ) ).

% Iio_Int_singleton
tff(fact_2759_ivl__disj__un__singleton_I2_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(B,set(B),set_ord_lessThan(B),U)),aa(set(B),set(B),insert(B,U),bot_bot(set(B)))) = aa(B,set(B),set_ord_atMost(B),U) ) ) ).

% ivl_disj_un_singleton(2)
tff(fact_2760_UN__lessThan__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Sup_Sup(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),set_ord_lessThan(nat)),top_top(set(nat)))) = top_top(set(nat)) ).

% UN_lessThan_UNIV
tff(fact_2761_Suc__times__gbinomial,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K))),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))),aa(nat,nat,suc,K))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))),aa(nat,B,gbinomial(B,A4),K)) ) ) ).

% Suc_times_gbinomial
tff(fact_2762_gbinomial__absorption,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K))),aa(nat,B,gbinomial(B,A4),aa(nat,nat,suc,K))) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))),K)) ) ) ).

% gbinomial_absorption
tff(fact_2763_gbinomial__trinomial__revision,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,M2: nat,A4: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,A4),M2)),aa(nat,B,gbinomial(B,aa(nat,B,semiring_1_of_nat(B),M2)),K)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,A4),K)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(nat,B,semiring_1_of_nat(B),K))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),K))) ) ) ) ).

% gbinomial_trinomial_revision
tff(fact_2764_power__diff__1__eq,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X2: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N)),one_one(B)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),one_one(B))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% power_diff_1_eq
tff(fact_2765_one__diff__power__eq,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X2: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% one_diff_power_eq
tff(fact_2766_geometric__sum,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X2: B,N: nat] :
          ( ( X2 != one_one(B) )
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N)),one_one(B))),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),one_one(B))) ) ) ) ).

% geometric_sum
tff(fact_2767_sum_OatMost__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,G,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_sr(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% sum.atMost_shift
tff(fact_2768_prod_OatMost__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,G,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_ss(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% prod.atMost_shift
tff(fact_2769_pochhammer__product,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [M2: nat,N: nat,Z2: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( comm_s3205402744901411588hammer(B,Z2,N) = aa(B,B,aa(B,fun(B,B),times_times(B),comm_s3205402744901411588hammer(B,Z2,M2)),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),aa(nat,B,semiring_1_of_nat(B),M2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2))) ) ) ) ).

% pochhammer_product
tff(fact_2770_gbinomial__parallel__sum,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_vf(B,fun(nat,B),A4)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(nat,B,semiring_1_of_nat(B),N))),one_one(B))),N) ) ) ).

% gbinomial_parallel_sum
tff(fact_2771_gbinomial__rec,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))),aa(nat,nat,suc,K)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,A4),K)),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_rec
tff(fact_2772_gbinomial__factors,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))),aa(nat,nat,suc,K)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K)))),aa(nat,B,gbinomial(B,A4),K)) ) ) ).

% gbinomial_factors
tff(fact_2773_gbinomial__negated__upper,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(nat,B,gbinomial(B,A4),K) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,semiring_1_of_nat(B),K)),A4)),one_one(B))),K)) ) ) ).

% gbinomial_negated_upper
tff(fact_2774_gbinomial__index__swap,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(nat,B,semiring_1_of_nat(B),N))),one_one(B))),K)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(nat,B,semiring_1_of_nat(B),K))),one_one(B))),N)) ) ) ).

% gbinomial_index_swap
tff(fact_2775_sum__gp__strict,axiom,
    ! [B: $tType] :
      ( ( division_ring(B)
        & comm_ring(B) )
     => ! [X2: B,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X2)),aa(nat,set(nat),set_ord_lessThan(nat),N))
          = $ite(X2 = one_one(B),aa(nat,B,semiring_1_of_nat(B),N),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N))),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X2))) ) ) ).

% sum_gp_strict
tff(fact_2776_power__diff__sumr2,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X2: B,N: nat,Y: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Y),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),Y)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(nat,fun(B,fun(nat,B)),aTP_Lamp_vg(B,fun(nat,fun(B,fun(nat,B))),X2),N),Y)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% power_diff_sumr2
tff(fact_2777_diff__power__eq__sum,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X2: B,N: nat,Y: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(nat,nat,suc,N))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Y),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),Y)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(nat,fun(B,fun(nat,B)),aTP_Lamp_vh(B,fun(nat,fun(B,fun(nat,B))),X2),N),Y)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,N)))) ) ) ).

% diff_power_eq_sum
tff(fact_2778_pochhammer__absorb__comp,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [R2: B,K: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),R2),aa(nat,B,semiring_1_of_nat(B),K))),comm_s3205402744901411588hammer(B,aa(B,B,uminus_uminus(B),R2),K)) = aa(B,B,aa(B,fun(B,B),times_times(B),R2),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),R2)),one_one(B)),K)) ) ) ).

% pochhammer_absorb_comp
tff(fact_2779_rtrancl__finite__eq__relpow,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,finite_finite2(product_prod(B,B)),R)
     => ( transitive_rtrancl(B,R) = aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),aa(set(nat),set(set(product_prod(B,B))),image2(nat,set(product_prod(B,B)),aTP_Lamp_ut(set(product_prod(B,B)),fun(nat,set(product_prod(B,B))),R)),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_vi(set(product_prod(B,B)),fun(nat,$o),R)))) ) ) ).

% rtrancl_finite_eq_relpow
tff(fact_2780_relpow__finite__bounded,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),K: nat] :
      ( aa(set(product_prod(B,B)),$o,finite_finite2(product_prod(B,B)),R)
     => aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),compow(set(product_prod(B,B)),K,R)),aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),aa(set(nat),set(set(product_prod(B,B))),image2(nat,set(product_prod(B,B)),aTP_Lamp_ut(set(product_prod(B,B)),fun(nat,set(product_prod(B,B))),R)),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_vi(set(product_prod(B,B)),fun(nat,$o),R))))) ) ).

% relpow_finite_bounded
tff(fact_2781_gbinomial__minus,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(nat,B,gbinomial(B,aa(B,B,uminus_uminus(B),A4)),K) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(nat,B,semiring_1_of_nat(B),K))),one_one(B))),K)) ) ) ).

% gbinomial_minus
tff(fact_2782_one__diff__power__eq_H,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X2: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_vj(B,fun(nat,fun(nat,B)),X2),N)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% one_diff_power_eq'
tff(fact_2783_gbinomial__reduce__nat,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,A4: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
         => ( aa(nat,B,gbinomial(B,A4),K) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))),K)) ) ) ) ).

% gbinomial_reduce_nat
tff(fact_2784_pochhammer__Suc__prod,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B,N: nat] : ( comm_s3205402744901411588hammer(B,A4,aa(nat,nat,suc,N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_vk(B,fun(nat,B),A4)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_Suc_prod
tff(fact_2785_pochhammer__prod__rev,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B,N: nat] : ( comm_s3205402744901411588hammer(B,A4,N) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_vl(B,fun(nat,fun(nat,B)),A4),N)),set_or1337092689740270186AtMost(nat,one_one(nat),N)) ) ) ).

% pochhammer_prod_rev
tff(fact_2786_pochhammer__minus,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [B3: B,K: nat] : ( comm_s3205402744901411588hammer(B,aa(B,B,uminus_uminus(B),B3),K) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),aa(nat,B,semiring_1_of_nat(B),K))),one_one(B)),K)) ) ) ).

% pochhammer_minus
tff(fact_2787_pochhammer__minus_H,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [B3: B,K: nat] : ( comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),aa(nat,B,semiring_1_of_nat(B),K))),one_one(B)),K) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),comm_s3205402744901411588hammer(B,aa(B,B,uminus_uminus(B),B3),K)) ) ) ).

% pochhammer_minus'
tff(fact_2788_gbinomial__sum__lower__neg,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_vm(B,fun(nat,B),A4)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),M2)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))),M2)) ) ) ).

% gbinomial_sum_lower_neg
tff(fact_2789_pochhammer__Suc__prod__rev,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B,N: nat] : ( comm_s3205402744901411588hammer(B,A4,aa(nat,nat,suc,N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_vl(B,fun(nat,fun(nat,B)),A4),N)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_Suc_prod_rev
tff(fact_2790_pochhammer__binomial__sum,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [A4: B,B3: B,N: nat] : ( comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3),N) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aa(B,fun(nat,fun(nat,B)),aTP_Lamp_vn(B,fun(B,fun(nat,fun(nat,B))),A4),B3),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% pochhammer_binomial_sum
tff(fact_2791_gbinomial__sum__up__index,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_vo(nat,fun(nat,B),K)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat))) ) ) ).

% gbinomial_sum_up_index
tff(fact_2792_gbinomial__partial__sum__poly,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [M2: nat,A4: B,X2: B,Y: B] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_up(nat,fun(B,fun(B,fun(B,fun(nat,B)))),M2),A4),X2),Y)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_vp(nat,fun(B,fun(B,fun(B,fun(nat,B)))),M2),A4),X2),Y)),aa(nat,set(nat),set_ord_atMost(nat),M2)) ) ) ).

% gbinomial_partial_sum_poly
tff(fact_2793_gbinomial__absorption_H,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,A4: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
         => ( aa(nat,B,gbinomial(B,A4),K) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(nat,B,semiring_1_of_nat(B),K))),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ) ).

% gbinomial_absorption'
tff(fact_2794_relpow__finite__bounded1,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),K: nat] :
      ( aa(set(product_prod(B,B)),$o,finite_finite2(product_prod(B,B)),R)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),compow(set(product_prod(B,B)),K,R)),aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),aa(set(nat),set(set(product_prod(B,B))),image2(nat,set(product_prod(B,B)),aTP_Lamp_ut(set(product_prod(B,B)),fun(nat,set(product_prod(B,B))),R)),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_uu(set(product_prod(B,B)),fun(nat,$o),R))))) ) ) ).

% relpow_finite_bounded1
tff(fact_2795_ntrancl__def,axiom,
    ! [B: $tType,N: nat,R: set(product_prod(B,B))] : ( transitive_ntrancl(B,N,R) = aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),aa(set(nat),set(set(product_prod(B,B))),image2(nat,set(product_prod(B,B)),aTP_Lamp_ut(set(product_prod(B,B)),fun(nat,set(product_prod(B,B))),R)),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_vq(nat,fun(nat,$o),N)))) ) ).

% ntrancl_def
tff(fact_2796_finite__psubset__def,axiom,
    ! [B: $tType] : ( finite_psubset(B) = aa(fun(product_prod(set(B),set(B)),$o),set(product_prod(set(B),set(B))),collect(product_prod(set(B),set(B))),aa(fun(set(B),fun(set(B),$o)),fun(product_prod(set(B),set(B)),$o),product_case_prod(set(B),set(B),$o),aTP_Lamp_vr(set(B),fun(set(B),$o)))) ) ).

% finite_psubset_def
tff(fact_2797_gbinomial__code,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] :
          ( aa(nat,B,gbinomial(B,A4),K)
          = $ite(K = zero_zero(nat),one_one(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),set_fo6178422350223883121st_nat(B,aTP_Lamp_vs(B,fun(nat,fun(B,B)),A4),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)),one_one(B))),semiring_char_0_fact(B,K))) ) ) ).

% gbinomial_code
tff(fact_2798_int__ge__less__than__def,axiom,
    ! [D3: int] : ( int_ge_less_than(D3) = aa(fun(product_prod(int,int),$o),set(product_prod(int,int)),collect(product_prod(int,int)),aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aTP_Lamp_vt(int,fun(int,fun(int,$o)),D3))) ) ).

% int_ge_less_than_def
tff(fact_2799_int__ge__less__than2__def,axiom,
    ! [D3: int] : ( int_ge_less_than2(D3) = aa(fun(product_prod(int,int),$o),set(product_prod(int,int)),collect(product_prod(int,int)),aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aTP_Lamp_vu(int,fun(int,fun(int,$o)),D3))) ) ).

% int_ge_less_than2_def
tff(fact_2800_gbinomial__Suc,axiom,
    ! [B: $tType] :
      ( ( semiring_char_0(B)
        & semidom_divide(B) )
     => ! [A4: B,K: nat] : ( aa(nat,B,gbinomial(B,A4),aa(nat,nat,suc,K)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_vv(B,fun(nat,B),A4)),set_or1337092689740270186AtMost(nat,zero_zero(nat),K))),semiring_char_0_fact(B,aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc
tff(fact_2801_fact__0,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ( semiring_char_0_fact(B,zero_zero(nat)) = one_one(B) ) ) ).

% fact_0
tff(fact_2802_fact__1,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ( semiring_char_0_fact(B,one_one(nat)) = one_one(B) ) ) ).

% fact_1
tff(fact_2803_fact__Suc__0,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ( semiring_char_0_fact(B,aa(nat,nat,suc,zero_zero(nat))) = one_one(B) ) ) ).

% fact_Suc_0
tff(fact_2804_fact__Suc,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: nat] : ( semiring_char_0_fact(B,aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,N))),semiring_char_0_fact(B,N)) ) ) ).

% fact_Suc
tff(fact_2805_fact__ge__1,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [N: nat] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),semiring_char_0_fact(B,N)) ) ).

% fact_ge_1
tff(fact_2806_pochhammer__fact,axiom,
    ! [B: $tType] :
      ( ( semiring_char_0(B)
        & comm_semiring_1(B) )
     => ! [N: nat] : ( semiring_char_0_fact(B,N) = comm_s3205402744901411588hammer(B,one_one(B),N) ) ) ).

% pochhammer_fact
tff(fact_2807_fact__prod,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: nat] : ( semiring_char_0_fact(B,N) = aa(nat,B,semiring_1_of_nat(B),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_vw(nat,nat)),set_or1337092689740270186AtMost(nat,one_one(nat),N))) ) ) ).

% fact_prod
tff(fact_2808_fact__eq__fact__times,axiom,
    ! [N: nat,M2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M2)
     => ( semiring_char_0_fact(nat,M2) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,N)),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_vw(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M2))) ) ) ).

% fact_eq_fact_times
tff(fact_2809_fact__div__fact,axiom,
    ! [N: nat,M2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),semiring_char_0_fact(nat,M2)),semiring_char_0_fact(nat,N)) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_vw(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),M2)) ) ) ).

% fact_div_fact
tff(fact_2810_fact__num__eq__if,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [M2: nat] :
          ( semiring_char_0_fact(B,M2)
          = $ite(M2 = zero_zero(nat),one_one(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),M2)),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),one_one(nat))))) ) ) ).

% fact_num_eq_if
tff(fact_2811_fact__reduce,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( semiring_char_0_fact(B,N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ) ) ).

% fact_reduce
tff(fact_2812_pochhammer__same,axiom,
    ! [B: $tType] :
      ( ( semiring_char_0(B)
        & comm_ring_1(B)
        & semiri3467727345109120633visors(B) )
     => ! [N: nat] : ( comm_s3205402744901411588hammer(B,aa(B,B,uminus_uminus(B),aa(nat,B,semiring_1_of_nat(B),N)),N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),semiring_char_0_fact(B,N)) ) ) ).

% pochhammer_same
tff(fact_2813_fact__binomial,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),semiring_char_0_fact(B,K)),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,binomial(N),K))) = aa(B,B,aa(B,fun(B,B),divide_divide(B),semiring_char_0_fact(B,N)),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_binomial
tff(fact_2814_binomial__fact,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,binomial(N),K)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),semiring_char_0_fact(B,N)),aa(B,B,aa(B,fun(B,B),times_times(B),semiring_char_0_fact(B,K)),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))) ) ) ) ).

% binomial_fact
tff(fact_2815_gbinomial__pochhammer_H,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(nat,B,gbinomial(B,A4),K) = aa(B,B,aa(B,fun(B,B),divide_divide(B),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(nat,B,semiring_1_of_nat(B),K))),one_one(B)),K)),semiring_char_0_fact(B,K)) ) ) ).

% gbinomial_pochhammer'
tff(fact_2816_gbinomial__pochhammer,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(nat,B,gbinomial(B,A4),K) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),comm_s3205402744901411588hammer(B,aa(B,B,uminus_uminus(B),A4),K))),semiring_char_0_fact(B,K)) ) ) ).

% gbinomial_pochhammer
tff(fact_2817_gbinomial__prod__rev,axiom,
    ! [B: $tType] :
      ( ( semiring_char_0(B)
        & semidom_divide(B) )
     => ! [A4: B,K: nat] : ( aa(nat,B,gbinomial(B,A4),K) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_vv(B,fun(nat,B),A4)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K))),semiring_char_0_fact(B,K)) ) ) ).

% gbinomial_prod_rev
tff(fact_2818_gbinomial__mult__fact_H,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,A4),K)),semiring_char_0_fact(B,K)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_vx(B,fun(nat,B),A4)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact'
tff(fact_2819_gbinomial__mult__fact,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),semiring_char_0_fact(B,K)),aa(nat,B,gbinomial(B,A4),K)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_vx(B,fun(nat,B),A4)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact
tff(fact_2820_binomial__altdef__of__nat,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,binomial(N),K)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_vy(nat,fun(nat,fun(nat,B)),K),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ) ).

% binomial_altdef_of_nat
tff(fact_2821_gbinomial__altdef__of__nat,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,K: nat] : ( aa(nat,B,gbinomial(B,A4),K) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_vz(B,fun(nat,fun(nat,B)),A4),K)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_altdef_of_nat
tff(fact_2822_times__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wb(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),times_times(int)) ).

% times_int.transfer
tff(fact_2823_atLeastLessThan__empty,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( set_or7035219750837199246ssThan(B,A4,B3) = bot_bot(set(B)) ) ) ) ).

% atLeastLessThan_empty
tff(fact_2824_atLeastLessThan__empty__iff2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B] :
          ( ( bot_bot(set(B)) = set_or7035219750837199246ssThan(B,A4,B3) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ).

% atLeastLessThan_empty_iff2
tff(fact_2825_atLeastLessThan__empty__iff,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: B,B3: B] :
          ( ( set_or7035219750837199246ssThan(B,A4,B3) = bot_bot(set(B)) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ).

% atLeastLessThan_empty_iff
tff(fact_2826_image__add__atLeastLessThan_H,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [K: B,I2: B,J2: B] : ( aa(set(B),set(B),image2(B,B,aTP_Lamp_rs(B,fun(B,B),K)),set_or7035219750837199246ssThan(B,I2,J2)) = set_or7035219750837199246ssThan(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),I2),K),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),K)) ) ) ).

% image_add_atLeastLessThan'
tff(fact_2827_atLeastLessThan__singleton,axiom,
    ! [M2: nat] : ( set_or7035219750837199246ssThan(nat,M2,aa(nat,nat,suc,M2)) = aa(set(nat),set(nat),insert(nat,M2),bot_bot(set(nat))) ) ).

% atLeastLessThan_singleton
tff(fact_2828_prod_Oop__ivl__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,M2,aa(nat,nat,suc,N)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M2),one_one(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,M2,N))),aa(nat,B,G,N))) ) ) ).

% prod.op_ivl_Suc
tff(fact_2829_ivl__disj__int__two_I3_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M2: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or7035219750837199246ssThan(B,L,M2)),set_or7035219750837199246ssThan(B,M2,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(3)
tff(fact_2830_atLeastLessThan0,axiom,
    ! [M2: nat] : ( set_or7035219750837199246ssThan(nat,M2,zero_zero(nat)) = bot_bot(set(nat)) ) ).

% atLeastLessThan0
tff(fact_2831_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_sr(fun(nat,B),fun(nat,B),G)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% sum.shift_bounds_Suc_ivl
tff(fact_2832_sum_Oshift__bounds__nat__ivl,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),M2: nat,K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_sb(fun(nat,B),fun(nat,fun(nat,B)),G),K)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% sum.shift_bounds_nat_ivl
tff(fact_2833_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_ss(fun(nat,B),fun(nat,B),G)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% prod.shift_bounds_Suc_ivl
tff(fact_2834_prod_Oshift__bounds__nat__ivl,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),M2: nat,K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_sc(fun(nat,B),fun(nat,fun(nat,B)),G),K)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% prod.shift_bounds_nat_ivl
tff(fact_2835_ivl__disj__int__two_I7_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M2: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or7035219750837199246ssThan(B,L,M2)),set_or1337092689740270186AtMost(B,M2,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(7)
tff(fact_2836_prod_OatLeastLessThan__concat,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M2: nat,N: nat,P3: nat,G: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),P3)
           => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,M2,N))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,N,P3))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,M2,P3)) ) ) ) ) ).

% prod.atLeastLessThan_concat
tff(fact_2837_ivl__disj__int__one_I2_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_lessThan(B),L)),set_or7035219750837199246ssThan(B,L,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(2)
tff(fact_2838_nat_Otransfer,axiom,
    aa(fun(int,nat),$o,aa(fun(product_prod(nat,nat),nat),fun(fun(int,nat),$o),bNF_rel_fun(product_prod(nat,nat),int,nat,nat,pcr_int,fequal(nat)),aa(fun(nat,fun(nat,nat)),fun(product_prod(nat,nat),nat),product_case_prod(nat,nat,nat),minus_minus(nat))),nat2) ).

% nat.transfer
tff(fact_2839_binomial__def,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,binomial(N),K) = aa(set(set(nat)),nat,finite_card(set(nat)),aa(fun(set(nat),$o),set(set(nat)),collect(set(nat)),aa(nat,fun(set(nat),$o),aTP_Lamp_wc(nat,fun(nat,fun(set(nat),$o)),N),K))) ) ).

% binomial_def
tff(fact_2840_prod_OatLeast0__lessThan__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(nat,B,G,N)) ) ) ).

% prod.atLeast0_lessThan_Suc
tff(fact_2841_atLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] : ( set_or7035219750837199246ssThan(B,A4,B3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),set_or1337092689740270186AtMost(B,A4,B3)),aa(set(B),set(B),insert(B,B3),bot_bot(set(B)))) ) ) ).

% atLeastLessThan_eq_atLeastAtMost_diff
tff(fact_2842_prod_OatLeast__Suc__lessThan,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M2: nat,N: nat,G: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,M2,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,G,M2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),N))) ) ) ) ).

% prod.atLeast_Suc_lessThan
tff(fact_2843_prod_OatLeastLessThan__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: nat,B3: nat,G: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A4),B3)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,A4,aa(nat,nat,suc,B3))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,A4,B3))),aa(nat,B,G,B3)) ) ) ) ).

% prod.atLeastLessThan_Suc
tff(fact_2844_prod_Olast__plus,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M2: nat,N: nat,G: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,G,N)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,M2,N))) ) ) ) ).

% prod.last_plus
tff(fact_2845_atLeastLessThanSuc,axiom,
    ! [M2: nat,N: nat] :
      ( set_or7035219750837199246ssThan(nat,M2,aa(nat,nat,suc,N))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N),aa(set(nat),set(nat),insert(nat,N),set_or7035219750837199246ssThan(nat,M2,N)),bot_bot(set(nat))) ) ).

% atLeastLessThanSuc
tff(fact_2846_sum__Suc__diff_H,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [M2: nat,N: nat,F2: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_su(fun(nat,B),fun(nat,B),F2)),set_or7035219750837199246ssThan(nat,M2,N)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,F2,N)),aa(nat,B,F2,M2)) ) ) ) ).

% sum_Suc_diff'
tff(fact_2847_sum_OatLeastLessThan__rev,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),N: nat,M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_wd(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),G),N),M2)),set_or7035219750837199246ssThan(nat,N,M2)) ) ) ).

% sum.atLeastLessThan_rev
tff(fact_2848_sum_Onested__swap,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [A4: fun(nat,fun(nat,B)),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_we(fun(nat,fun(nat,B)),fun(nat,B),A4)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_vb(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),A4),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% sum.nested_swap
tff(fact_2849_prod_OatLeastLessThan__rev,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat,M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_wf(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),G),N),M2)),set_or7035219750837199246ssThan(nat,N,M2)) ) ) ).

% prod.atLeastLessThan_rev
tff(fact_2850_prod_Onested__swap,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: fun(nat,fun(nat,B)),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_wg(fun(nat,fun(nat,B)),fun(nat,B),A4)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_ve(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),A4),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% prod.nested_swap
tff(fact_2851_fact__prod__rev,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: nat] : ( semiring_char_0_fact(B,N) = aa(nat,B,semiring_1_of_nat(B),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aa(nat,fun(nat,nat),minus_minus(nat),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% fact_prod_rev
tff(fact_2852_sum_Onat__group,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_wh(fun(nat,B),fun(nat,fun(nat,B)),G),K)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))) ) ) ).

% sum.nat_group
tff(fact_2853_int__transfer,axiom,
    aa(fun(nat,int),$o,aa(fun(nat,product_prod(nat,nat)),fun(fun(nat,int),$o),bNF_rel_fun(nat,nat,product_prod(nat,nat),int,fequal(nat),pcr_int),aTP_Lamp_wi(nat,product_prod(nat,nat))),semiring_1_of_nat(int)) ).

% int_transfer
tff(fact_2854_prod_Onat__group,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_wj(fun(nat,B),fun(nat,fun(nat,B)),G),K)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))) ) ) ).

% prod.nat_group
tff(fact_2855_UN__UN__finite__eq,axiom,
    ! [B: $tType,A3: fun(nat,set(B))] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),aTP_Lamp_wk(fun(nat,set(B)),fun(nat,set(B)),A3)),top_top(set(nat)))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),A3),top_top(set(nat)))) ) ).

% UN_UN_finite_eq
tff(fact_2856_UN__le__add__shift__strict,axiom,
    ! [B: $tType,M: fun(nat,set(B)),K: nat,N: nat] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),aa(nat,fun(nat,set(B)),aTP_Lamp_sh(fun(nat,set(B)),fun(nat,fun(nat,set(B))),M),K)),aa(nat,set(nat),set_ord_lessThan(nat),N))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),M),set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))) ) ).

% UN_le_add_shift_strict
tff(fact_2857_card__sum__le__nat__sum,axiom,
    ! [S: set(nat)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vw(nat,nat)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(set(nat),nat,finite_card(nat),S)))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vw(nat,nat)),S)) ).

% card_sum_le_nat_sum
tff(fact_2858_uminus__int_Otransfer,axiom,
    aa(fun(int,int),$o,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(int,int),$o),bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_wl(nat,fun(nat,product_prod(nat,nat))))),uminus_uminus(int)) ).

% uminus_int.transfer
tff(fact_2859_ivl__disj__un__singleton_I6_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [L: B,U: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),L),U)
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),set_or7035219750837199246ssThan(B,L,U)),aa(set(B),set(B),insert(B,U),bot_bot(set(B)))) = set_or1337092689740270186AtMost(B,L,U) ) ) ) ).

% ivl_disj_un_singleton(6)
tff(fact_2860_prod_Ohead__if,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,N))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M2),one_one(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,M2,N))),aa(nat,B,G,N))) ) ) ).

% prod.head_if
tff(fact_2861_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,G,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),comp(nat,B,nat,G),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
tff(fact_2862_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),N: nat,M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_se(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),G),N),M2)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M2)) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_2863_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat,M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_sf(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),G),N),M2)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M2)) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_2864_pochhammer__prod,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B,N: nat] : ( comm_s3205402744901411588hammer(B,A4,N) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_vk(B,fun(nat,B),A4)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_prod
tff(fact_2865_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),comp(nat,B,nat,G),aTP_Lamp_sv(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% sum.atLeast_lessThan_pred_shift
tff(fact_2866_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),comp(nat,B,nat,G),aTP_Lamp_sv(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% prod.atLeast_lessThan_pred_shift
tff(fact_2867_image__minus__const__atLeastLessThan__nat,axiom,
    ! [Ca: nat,X2: nat,Y: nat] :
      ( aa(set(nat),set(nat),image2(nat,nat,aTP_Lamp_ri(nat,fun(nat,nat),Ca)),set_or7035219750837199246ssThan(nat,X2,Y))
      = $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ca),Y),
          set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X2),Ca),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Y),Ca)),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),Y),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))),bot_bot(set(nat))) ) ) ).

% image_minus_const_atLeastLessThan_nat
tff(fact_2868_UN__finite__subset,axiom,
    ! [B: $tType,A3: fun(nat,set(B)),C2: set(B)] :
      ( ! [N2: nat] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2)))),C2)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),A3),top_top(set(nat))))),C2) ) ).

% UN_finite_subset
tff(fact_2869_UN__finite2__eq,axiom,
    ! [B: $tType,A3: fun(nat,set(B)),B2: fun(nat,set(B)),K: nat] :
      ( ! [N2: nat] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),K)))) )
     => ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),A3),top_top(set(nat)))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),B2),top_top(set(nat)))) ) ) ).

% UN_finite2_eq
tff(fact_2870_less__int_Otransfer,axiom,
    aa(fun(int,fun(int,$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(int,fun(int,$o)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),$o),fun(int,$o),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,$o,$o,pcr_int,fequal($o))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wn(nat,fun(nat,fun(product_prod(nat,nat),$o))))),ord_less(int)) ).

% less_int.transfer
tff(fact_2871_less__eq__int_Otransfer,axiom,
    aa(fun(int,fun(int,$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(int,fun(int,$o)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),$o),fun(int,$o),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,$o,$o,pcr_int,fequal($o))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),$o))))),ord_less_eq(int)) ).

% less_eq_int.transfer
tff(fact_2872_fact__split,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( semiring_char_0_fact(B,N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K),N)))),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_split
tff(fact_2873_plus__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),plus_plus(int)) ).

% plus_int.transfer
tff(fact_2874_minus__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),minus_minus(int)) ).

% minus_int.transfer
tff(fact_2875_UN__finite2__subset,axiom,
    ! [B: $tType,A3: fun(nat,set(B)),B2: fun(nat,set(B)),K: nat] :
      ( ! [N2: nat] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2)))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),K)))))
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),A3),top_top(set(nat))))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),B2),top_top(set(nat))))) ) ).

% UN_finite2_subset
tff(fact_2876_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] : ( set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_lessThan(nat),N)),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_lessThan_eq_remove0
tff(fact_2877_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X2: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wb(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X2)) ) ).

% times_int.abs_eq
tff(fact_2878_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X2: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X2)) ) ).

% minus_int.abs_eq
tff(fact_2879_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X2: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X2)) ) ).

% plus_int.abs_eq
tff(fact_2880_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => semila1105856199041335345_order(B,sup_sup(B),bot_bot(B),aTP_Lamp_wu(B,fun(B,$o)),aTP_Lamp_wv(B,fun(B,$o))) ) ).

% sup_bot.semilattice_neutr_order_axioms
tff(fact_2881_pred__nat__def,axiom,
    pred_nat = aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_ww(nat,fun(nat,$o)))) ).

% pred_nat_def
tff(fact_2882_power__minus_H,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X2: B,N: nat] :
          ( nO_MATCH(B,B,one_one(B),X2)
         => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),X2)),N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N)) ) ) ) ).

% power_minus'
tff(fact_2883_semilattice__neutr__order_Oeq__neutr__iff,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( semila1105856199041335345_order(B,F2,Z2,Less_eq,Less)
     => ( ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = Z2 )
      <=> ( ( A4 = Z2 )
          & ( B3 = Z2 ) ) ) ) ).

% semilattice_neutr_order.eq_neutr_iff
tff(fact_2884_semilattice__neutr__order_Oneutr__eq__iff,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( semila1105856199041335345_order(B,F2,Z2,Less_eq,Less)
     => ( ( Z2 = aa(B,B,aa(B,fun(B,B),F2,A4),B3) )
      <=> ( ( A4 = Z2 )
          & ( B3 = Z2 ) ) ) ) ).

% semilattice_neutr_order.neutr_eq_iff
tff(fact_2885_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] : ( aa(set(int),set(int),image2(int,int,aTP_Lamp_wx(int,fun(int,int),L)),set_or7035219750837199246ssThan(int,zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L))) = set_or7035219750837199246ssThan(int,L,U) ) ).

% image_add_int_atLeastLessThan
tff(fact_2886_uminus__int_Oabs__eq,axiom,
    ! [X2: product_prod(nat,nat)] : ( aa(int,int,uminus_uminus(int),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_wl(nat,fun(nat,product_prod(nat,nat)))),X2)) ) ).

% uminus_int.abs_eq
tff(fact_2887_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring(C)
     => ! [X2: B,Y: B,Ca: C,A4: C,B3: C] :
          ( nO_MATCH(B,C,aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y),Ca)
         => ( aa(C,C,aa(C,fun(C,C),times_times(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),A4),B3)),Ca) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),times_times(C),A4),Ca)),aa(C,C,aa(C,fun(C,C),times_times(C),B3),Ca)) ) ) ) ).

% distrib_right_NO_MATCH
tff(fact_2888_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring(C)
     => ! [X2: B,Y: B,A4: C,B3: C,Ca: C] :
          ( nO_MATCH(B,C,aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y),A4)
         => ( aa(C,C,aa(C,fun(C,C),times_times(C),A4),aa(C,C,aa(C,fun(C,C),plus_plus(C),B3),Ca)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),times_times(C),A4),B3)),aa(C,C,aa(C,fun(C,C),times_times(C),A4),Ca)) ) ) ) ).

% distrib_left_NO_MATCH
tff(fact_2889_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,C: $tType] :
      ( ring(C)
     => ! [X2: B,Y: B,A4: C,B3: C,Ca: C] :
          ( nO_MATCH(B,C,aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y),A4)
         => ( aa(C,C,aa(C,fun(C,C),times_times(C),A4),aa(C,C,aa(C,fun(C,C),minus_minus(C),B3),Ca)) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(C,C,aa(C,fun(C,C),times_times(C),A4),B3)),aa(C,C,aa(C,fun(C,C),times_times(C),A4),Ca)) ) ) ) ).

% right_diff_distrib_NO_MATCH
tff(fact_2890_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,C: $tType] :
      ( ring(C)
     => ! [X2: B,Y: B,Ca: C,A4: C,B3: C] :
          ( nO_MATCH(B,C,aa(B,B,aa(B,fun(B,B),divide_divide(B),X2),Y),Ca)
         => ( aa(C,C,aa(C,fun(C,C),times_times(C),aa(C,C,aa(C,fun(C,C),minus_minus(C),A4),B3)),Ca) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(C,C,aa(C,fun(C,C),times_times(C),A4),Ca)),aa(C,C,aa(C,fun(C,C),times_times(C),B3),Ca)) ) ) ) ).

% left_diff_distrib_NO_MATCH
tff(fact_2891_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X2: product_prod(nat,nat)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X2))
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wn(nat,fun(nat,fun(product_prod(nat,nat),$o)))),Xa),X2) ) ).

% less_int.abs_eq
tff(fact_2892_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X2: product_prod(nat,nat)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X2))
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),$o)))),Xa),X2) ) ).

% less_eq_int.abs_eq
tff(fact_2893_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => semila1105856199041335345_order(B,inf_inf(B),top_top(B),ord_less_eq(B),ord_less(B)) ) ).

% inf_top.semilattice_neutr_order_axioms
tff(fact_2894_div__add__self2__no__field,axiom,
    ! [B: $tType,C: $tType] :
      ( ( euclid4440199948858584721cancel(C)
        & field(B) )
     => ! [X2: B,B3: C,A4: C] :
          ( nO_MATCH(B,C,X2,B3)
         => ( ( B3 != zero_zero(C) )
           => ( aa(C,C,aa(C,fun(C,C),divide_divide(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),A4),B3)),B3) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),divide_divide(C),A4),B3)),one_one(C)) ) ) ) ) ).

% div_add_self2_no_field
tff(fact_2895_div__add__self1__no__field,axiom,
    ! [B: $tType,C: $tType] :
      ( ( euclid4440199948858584721cancel(C)
        & field(B) )
     => ! [X2: B,B3: C,A4: C] :
          ( nO_MATCH(B,C,X2,B3)
         => ( ( B3 != zero_zero(C) )
           => ( aa(C,C,aa(C,fun(C,C),divide_divide(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),B3),A4)),B3) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),divide_divide(C),A4),B3)),one_one(C)) ) ) ) ) ).

% div_add_self1_no_field
tff(fact_2896_less__eq__int_Orep__eq,axiom,
    ! [X2: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X2),Xa)
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),$o)))),aa(int,product_prod(nat,nat),rep_Integ,X2)),aa(int,product_prod(nat,nat),rep_Integ,Xa)) ) ).

% less_eq_int.rep_eq
tff(fact_2897_less__int_Orep__eq,axiom,
    ! [X2: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X2),Xa)
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wn(nat,fun(nat,fun(product_prod(nat,nat),$o)))),aa(int,product_prod(nat,nat),rep_Integ,X2)),aa(int,product_prod(nat,nat),rep_Integ,Xa)) ) ).

% less_int.rep_eq
tff(fact_2898_times__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wb(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wb(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int.rsp
tff(fact_2899_uminus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),product_prod(nat,nat)),$o,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(product_prod(nat,nat),product_prod(nat,nat)),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_wl(nat,fun(nat,product_prod(nat,nat))))),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_wl(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int.rsp
tff(fact_2900_nat_Orsp,axiom,
    aa(fun(product_prod(nat,nat),nat),$o,aa(fun(product_prod(nat,nat),nat),fun(fun(product_prod(nat,nat),nat),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),nat,nat,intrel,fequal(nat)),aa(fun(nat,fun(nat,nat)),fun(product_prod(nat,nat),nat),product_case_prod(nat,nat,nat),minus_minus(nat))),aa(fun(nat,fun(nat,nat)),fun(product_prod(nat,nat),nat),product_case_prod(nat,nat,nat),minus_minus(nat))) ).

% nat.rsp
tff(fact_2901_of__int_Orsp,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => aa(fun(product_prod(nat,nat),B),$o,aa(fun(product_prod(nat,nat),B),fun(fun(product_prod(nat,nat),B),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),B,B,intrel,fequal(B)),aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),aTP_Lamp_wy(nat,fun(nat,B)))),aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),aTP_Lamp_wy(nat,fun(nat,B)))) ) ).

% of_int.rsp
tff(fact_2902_intrel__def,axiom,
    intrel = aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_xa(nat,fun(nat,fun(product_prod(nat,nat),$o)))) ).

% intrel_def
tff(fact_2903_less__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(product_prod(nat,nat),$o),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),$o,$o,intrel,fequal($o))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wn(nat,fun(nat,fun(product_prod(nat,nat),$o))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wn(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_int.rsp
tff(fact_2904_less__eq__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(product_prod(nat,nat),$o),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),$o,$o,intrel,fequal($o))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),$o))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_eq_int.rsp
tff(fact_2905_minus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int.rsp
tff(fact_2906_plus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int.rsp
tff(fact_2907_uminus__int__def,axiom,
    uminus_uminus(int) = aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_wl(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int_def
tff(fact_2908_filterlim__at__top__gt,axiom,
    ! [C: $tType,B: $tType] :
      ( unboun7993243217541854897norder(C)
     => ! [F2: fun(B,C),F: filter(B),Ca: C] :
          ( filterlim(B,C,F2,at_top(C),F)
        <=> ! [Z6: C] :
              ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),Ca),Z6)
             => eventually(B,aa(C,fun(B,$o),aTP_Lamp_xb(fun(B,C),fun(C,fun(B,$o)),F2),Z6),F) ) ) ) ).

% filterlim_at_top_gt
tff(fact_2909_sum__of__bool__eq,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [A3: set(B),Pa: fun(B,$o)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),A3)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aTP_Lamp_xc(fun(B,$o),fun(B,C),Pa)),A3) = aa(nat,C,semiring_1_of_nat(C),aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,$o),set(B),collect(B),Pa)))) ) ) ) ) ).

% sum_of_bool_eq
tff(fact_2910_finite__enumerate__initial__segment,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [S: set(B),N: nat,S2: B] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),aa(B,set(B),set_ord_lessThan(B),S2))))
           => ( infini527867602293511546merate(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),aa(B,set(B),set_ord_lessThan(B),S2)),N) = infini527867602293511546merate(B,S,N) ) ) ) ) ).

% finite_enumerate_initial_segment
tff(fact_2911_nat__def,axiom,
    nat2 = aa(fun(product_prod(nat,nat),nat),fun(int,nat),map_fun(int,product_prod(nat,nat),nat,nat,rep_Integ,id(nat)),aa(fun(nat,fun(nat,nat)),fun(product_prod(nat,nat),nat),product_case_prod(nat,nat,nat),minus_minus(nat))) ).

% nat_def
tff(fact_2912_eventually__sequentially__Suc,axiom,
    ! [Pa: fun(nat,$o)] :
      ( eventually(nat,aTP_Lamp_xd(fun(nat,$o),fun(nat,$o),Pa),at_top(nat))
    <=> eventually(nat,Pa,at_top(nat)) ) ).

% eventually_sequentially_Suc
tff(fact_2913_eventually__sequentially__seg,axiom,
    ! [Pa: fun(nat,$o),K: nat] :
      ( eventually(nat,aa(nat,fun(nat,$o),aTP_Lamp_xe(fun(nat,$o),fun(nat,fun(nat,$o)),Pa),K),at_top(nat))
    <=> eventually(nat,Pa,at_top(nat)) ) ).

% eventually_sequentially_seg
tff(fact_2914_of__bool__less__eq__iff,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [Pa: $o,Qa: $o] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa($o,B,zero_neq_one_of_bool(B),Pa)),aa($o,B,zero_neq_one_of_bool(B),Qa))
        <=> ( (Pa)
           => (Qa) ) ) ) ).

% of_bool_less_eq_iff
tff(fact_2915_of__bool__eq_I1_J,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ( aa($o,B,zero_neq_one_of_bool(B),$false) = zero_zero(B) ) ) ).

% of_bool_eq(1)
tff(fact_2916_of__bool__eq__0__iff,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ! [Pa: $o] :
          ( ( aa($o,B,zero_neq_one_of_bool(B),Pa) = zero_zero(B) )
        <=> ~ (Pa) ) ) ).

% of_bool_eq_0_iff
tff(fact_2917_of__bool__less__iff,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [Pa: $o,Qa: $o] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa($o,B,zero_neq_one_of_bool(B),Pa)),aa($o,B,zero_neq_one_of_bool(B),Qa))
        <=> ( ~ (Pa)
            & (Qa) ) ) ) ).

% of_bool_less_iff
tff(fact_2918_of__bool__eq__1__iff,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ! [Pa: $o] :
          ( ( aa($o,B,zero_neq_one_of_bool(B),Pa) = one_one(B) )
        <=> (Pa) ) ) ).

% of_bool_eq_1_iff
tff(fact_2919_of__bool__eq_I2_J,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ( aa($o,B,zero_neq_one_of_bool(B),$true) = one_one(B) ) ) ).

% of_bool_eq(2)
tff(fact_2920_abs__bool__eq,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Pa: $o] : ( aa(B,B,abs_abs(B),aa($o,B,zero_neq_one_of_bool(B),Pa)) = aa($o,B,zero_neq_one_of_bool(B),Pa) ) ) ).

% abs_bool_eq
tff(fact_2921_zero__less__of__bool__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Pa: $o] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa($o,B,zero_neq_one_of_bool(B),Pa))
        <=> (Pa) ) ) ).

% zero_less_of_bool_iff
tff(fact_2922_of__bool__less__one__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Pa: $o] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa($o,B,zero_neq_one_of_bool(B),Pa)),one_one(B))
        <=> ~ (Pa) ) ) ).

% of_bool_less_one_iff
tff(fact_2923_of__bool__not__iff,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Pa: $o] : ( aa($o,B,zero_neq_one_of_bool(B),~ (Pa)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa($o,B,zero_neq_one_of_bool(B),Pa)) ) ) ).

% of_bool_not_iff
tff(fact_2924_sum__mult__of__bool__eq,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [A3: set(B),F2: fun(B,C),Pa: fun(B,$o)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,$o),fun(B,C),aTP_Lamp_xf(fun(B,C),fun(fun(B,$o),fun(B,C)),F2),Pa)),A3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,$o),set(B),collect(B),Pa))) ) ) ) ).

% sum_mult_of_bool_eq
tff(fact_2925_sum__of__bool__mult__eq,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [A3: set(B),Pa: fun(B,$o),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_xg(fun(B,$o),fun(fun(B,C),fun(B,C)),Pa),F2)),A3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,$o),set(B),collect(B),Pa))) ) ) ) ).

% sum_of_bool_mult_eq
tff(fact_2926_map__fun_Oidentity,axiom,
    ! [C: $tType,B: $tType] : ( map_fun(B,B,C,C,aTP_Lamp_bk(B,B),aTP_Lamp_hd(C,C)) = id(fun(B,C)) ) ).

% map_fun.identity
tff(fact_2927_of__bool__eq__iff,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ! [P3: $o,Q: $o] :
          ( ( aa($o,B,zero_neq_one_of_bool(B),P3) = aa($o,B,zero_neq_one_of_bool(B),Q) )
        <=> ( (P3)
          <=> (Q) ) ) ) ).

% of_bool_eq_iff
tff(fact_2928_of__bool__conj,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [Pa: $o,Qa: $o] :
          ( aa($o,B,zero_neq_one_of_bool(B),
              (Pa)
            & (Qa))
          = aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),Pa)),aa($o,B,zero_neq_one_of_bool(B),Qa)) ) ) ).

% of_bool_conj
tff(fact_2929_filtermap__sequentually__ne__bot,axiom,
    ! [B: $tType,F2: fun(nat,B)] : ( filtermap(nat,B,F2,at_top(nat)) != bot_bot(filter(B)) ) ).

% filtermap_sequentually_ne_bot
tff(fact_2930_filterlim__sequentially__Suc,axiom,
    ! [B: $tType,F2: fun(nat,B),F: filter(B)] :
      ( filterlim(nat,B,aTP_Lamp_xh(fun(nat,B),fun(nat,B),F2),F,at_top(nat))
    <=> filterlim(nat,B,F2,F,at_top(nat)) ) ).

% filterlim_sequentially_Suc
tff(fact_2931_le__sequentially,axiom,
    ! [F: filter(nat)] :
      ( aa(filter(nat),$o,aa(filter(nat),fun(filter(nat),$o),ord_less_eq(filter(nat)),F),at_top(nat))
    <=> ! [N6: nat] : eventually(nat,aa(nat,fun(nat,$o),ord_less_eq(nat),N6),F) ) ).

% le_sequentially
tff(fact_2932_trivial__limit__at__top__linorder,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( at_top(B) != bot_bot(filter(B)) ) ) ).

% trivial_limit_at_top_linorder
tff(fact_2933_zero__less__eq__of__bool,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Pa: $o] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa($o,B,zero_neq_one_of_bool(B),Pa)) ) ).

% zero_less_eq_of_bool
tff(fact_2934_of__bool__less__eq__one,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Pa: $o] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa($o,B,zero_neq_one_of_bool(B),Pa)),one_one(B)) ) ).

% of_bool_less_eq_one
tff(fact_2935_of__bool__def,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ! [P3: $o] :
          ( aa($o,B,zero_neq_one_of_bool(B),P3)
          = $ite((P3),one_one(B),zero_zero(B)) ) ) ).

% of_bool_def
tff(fact_2936_split__of__bool,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ! [Pa: fun(B,$o),P3: $o] :
          ( aa(B,$o,Pa,aa($o,B,zero_neq_one_of_bool(B),P3))
        <=> ( ( (P3)
             => aa(B,$o,Pa,one_one(B)) )
            & ( ~ (P3)
             => aa(B,$o,Pa,zero_zero(B)) ) ) ) ) ).

% split_of_bool
tff(fact_2937_split__of__bool__asm,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ! [Pa: fun(B,$o),P3: $o] :
          ( aa(B,$o,Pa,aa($o,B,zero_neq_one_of_bool(B),P3))
        <=> ~ ( ( (P3)
                & ~ aa(B,$o,Pa,one_one(B)) )
              | ( ~ (P3)
                & ~ aa(B,$o,Pa,zero_zero(B)) ) ) ) ) ).

% split_of_bool_asm
tff(fact_2938_eventually__at__top__not__equal,axiom,
    ! [B: $tType] :
      ( ( linorder(B)
        & no_top(B) )
     => ! [Ca: B] : eventually(B,aTP_Lamp_xi(B,fun(B,$o),Ca),at_top(B)) ) ).

% eventually_at_top_not_equal
tff(fact_2939_transfer__rule__of__bool,axiom,
    ! [B: $tType,C: $tType] :
      ( ( zero_neq_one(C)
        & zero_neq_one(B) )
     => ! [R: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),R,zero_zero(B)),zero_zero(C))
         => ( aa(C,$o,aa(B,fun(C,$o),R,one_one(B)),one_one(C))
           => aa(fun($o,C),$o,aa(fun($o,B),fun(fun($o,C),$o),bNF_rel_fun($o,$o,B,C,fequal($o),R),zero_neq_one_of_bool(B)),zero_neq_one_of_bool(C)) ) ) ) ).

% transfer_rule_of_bool
tff(fact_2940_filterlim__atMost__at__top,axiom,
    filterlim(nat,set(nat),set_ord_atMost(nat),finite5375528669736107172at_top(nat,top_top(set(nat))),at_top(nat)) ).

% filterlim_atMost_at_top
tff(fact_2941_filterlim__lessThan__at__top,axiom,
    filterlim(nat,set(nat),set_ord_lessThan(nat),finite5375528669736107172at_top(nat,top_top(set(nat))),at_top(nat)) ).

% filterlim_lessThan_at_top
tff(fact_2942_eventually__ge__at__top,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ca: B] : eventually(B,aa(B,fun(B,$o),ord_less_eq(B),Ca),at_top(B)) ) ).

% eventually_ge_at_top
tff(fact_2943_eventually__gt__at__top,axiom,
    ! [B: $tType] :
      ( ( linorder(B)
        & no_top(B) )
     => ! [Ca: B] : eventually(B,aa(B,fun(B,$o),ord_less(B),Ca),at_top(B)) ) ).

% eventually_gt_at_top
tff(fact_2944_filterlim__at__top,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [F2: fun(B,C),F: filter(B)] :
          ( filterlim(B,C,F2,at_top(C),F)
        <=> ! [Z6: C] : eventually(B,aa(C,fun(B,$o),aTP_Lamp_xj(fun(B,C),fun(C,fun(B,$o)),F2),Z6),F) ) ) ).

% filterlim_at_top
tff(fact_2945_filterlim__at__top__ge,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [F2: fun(B,C),F: filter(B),Ca: C] :
          ( filterlim(B,C,F2,at_top(C),F)
        <=> ! [Z6: C] :
              ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),Ca),Z6)
             => eventually(B,aa(C,fun(B,$o),aTP_Lamp_xj(fun(B,C),fun(C,fun(B,$o)),F2),Z6),F) ) ) ) ).

% filterlim_at_top_ge
tff(fact_2946_filterlim__at__top__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [F2: fun(B,C),F: filter(B),G: fun(B,C)] :
          ( filterlim(B,C,F2,at_top(C),F)
         => ( eventually(B,aa(fun(B,C),fun(B,$o),aTP_Lamp_xk(fun(B,C),fun(fun(B,C),fun(B,$o)),F2),G),F)
           => filterlim(B,C,G,at_top(C),F) ) ) ) ).

% filterlim_at_top_mono
tff(fact_2947_filterlim__at__top__dense,axiom,
    ! [C: $tType,B: $tType] :
      ( unboun7993243217541854897norder(C)
     => ! [F2: fun(B,C),F: filter(B)] :
          ( filterlim(B,C,F2,at_top(C),F)
        <=> ! [Z6: C] : eventually(B,aa(C,fun(B,$o),aTP_Lamp_xl(fun(B,C),fun(C,fun(B,$o)),F2),Z6),F) ) ) ).

% filterlim_at_top_dense
tff(fact_2948_enumerate__Suc_H,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [S: set(B),N: nat] : ( infini527867602293511546merate(B,S,aa(nat,nat,suc,N)) = infini527867602293511546merate(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,infini527867602293511546merate(B,S,zero_zero(nat))),bot_bot(set(B)))),N) ) ) ).

% enumerate_Suc'
tff(fact_2949_times__int__def,axiom,
    times_times(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wb(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int_def
tff(fact_2950_minus__int__def,axiom,
    minus_minus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int_def
tff(fact_2951_plus__int__def,axiom,
    plus_plus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int_def
tff(fact_2952_finite__enumerate__Suc_H_H,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [S: set(B),N: nat] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,N)),aa(set(B),nat,finite_card(B),S))
           => ( infini527867602293511546merate(B,S,aa(nat,nat,suc,N)) = ord_Least(B,aa(nat,fun(B,$o),aTP_Lamp_xm(set(B),fun(nat,fun(B,$o)),S),N)) ) ) ) ) ).

% finite_enumerate_Suc''
tff(fact_2953_enumerate__Suc,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [S: set(B),N: nat] : ( infini527867602293511546merate(B,S,aa(nat,nat,suc,N)) = infini527867602293511546merate(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S),aa(set(B),set(B),insert(B,ord_Least(B,aTP_Lamp_xn(set(B),fun(B,$o),S))),bot_bot(set(B)))),N) ) ) ).

% enumerate_Suc
tff(fact_2954_trivial__limit__sequentially,axiom,
    at_top(nat) != bot_bot(filter(nat)) ).

% trivial_limit_sequentially
tff(fact_2955_eventually__False__sequentially,axiom,
    ~ eventually(nat,aTP_Lamp_xo(nat,$o),at_top(nat)) ).

% eventually_False_sequentially
tff(fact_2956_LeastI,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),K: B] :
          ( aa(B,$o,Pa,K)
         => aa(B,$o,Pa,ord_Least(B,Pa)) ) ) ).

% LeastI
tff(fact_2957_LeastI2__ex,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),Qa: fun(B,$o)] :
          ( ? [X_13: B] : aa(B,$o,Pa,X_13)
         => ( ! [X: B] :
                ( aa(B,$o,Pa,X)
               => aa(B,$o,Qa,X) )
           => aa(B,$o,Qa,ord_Least(B,Pa)) ) ) ) ).

% LeastI2_ex
tff(fact_2958_LeastI__ex,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o)] :
          ( ? [X_13: B] : aa(B,$o,Pa,X_13)
         => aa(B,$o,Pa,ord_Least(B,Pa)) ) ) ).

% LeastI_ex
tff(fact_2959_LeastI2,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),A4: B,Qa: fun(B,$o)] :
          ( aa(B,$o,Pa,A4)
         => ( ! [X: B] :
                ( aa(B,$o,Pa,X)
               => aa(B,$o,Qa,X) )
           => aa(B,$o,Qa,ord_Least(B,Pa)) ) ) ) ).

% LeastI2
tff(fact_2960_LeastI2__wellorder__ex,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),Qa: fun(B,$o)] :
          ( ? [X_13: B] : aa(B,$o,Pa,X_13)
         => ( ! [A5: B] :
                ( aa(B,$o,Pa,A5)
               => ( ! [B10: B] :
                      ( aa(B,$o,Pa,B10)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A5),B10) )
                 => aa(B,$o,Qa,A5) ) )
           => aa(B,$o,Qa,ord_Least(B,Pa)) ) ) ) ).

% LeastI2_wellorder_ex
tff(fact_2961_LeastI2__wellorder,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),A4: B,Qa: fun(B,$o)] :
          ( aa(B,$o,Pa,A4)
         => ( ! [A5: B] :
                ( aa(B,$o,Pa,A5)
               => ( ! [B10: B] :
                      ( aa(B,$o,Pa,B10)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A5),B10) )
                 => aa(B,$o,Qa,A5) ) )
           => aa(B,$o,Qa,ord_Least(B,Pa)) ) ) ) ).

% LeastI2_wellorder
tff(fact_2962_Least__equality,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o),X2: B] :
          ( aa(B,$o,Pa,X2)
         => ( ! [Y2: B] :
                ( aa(B,$o,Pa,Y2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y2) )
           => ( ord_Least(B,Pa) = X2 ) ) ) ) ).

% Least_equality
tff(fact_2963_LeastI2__order,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o),X2: B,Qa: fun(B,$o)] :
          ( aa(B,$o,Pa,X2)
         => ( ! [Y2: B] :
                ( aa(B,$o,Pa,Y2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y2) )
           => ( ! [X: B] :
                  ( aa(B,$o,Pa,X)
                 => ( ! [Y5: B] :
                        ( aa(B,$o,Pa,Y5)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y5) )
                   => aa(B,$o,Qa,X) ) )
             => aa(B,$o,Qa,ord_Least(B,Pa)) ) ) ) ) ).

% LeastI2_order
tff(fact_2964_Least1__le,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o),Z2: B] :
          ( ? [X4: B] :
              ( aa(B,$o,Pa,X4)
              & ! [Y2: B] :
                  ( aa(B,$o,Pa,Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),Y2) )
              & ! [Y2: B] :
                  ( ( aa(B,$o,Pa,Y2)
                    & ! [Ya: B] :
                        ( aa(B,$o,Pa,Ya)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),Ya) ) )
                 => ( Y2 = X4 ) ) )
         => ( aa(B,$o,Pa,Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),ord_Least(B,Pa)),Z2) ) ) ) ).

% Least1_le
tff(fact_2965_Least1I,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o)] :
          ( ? [X4: B] :
              ( aa(B,$o,Pa,X4)
              & ! [Y2: B] :
                  ( aa(B,$o,Pa,Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),Y2) )
              & ! [Y2: B] :
                  ( ( aa(B,$o,Pa,Y2)
                    & ! [Ya: B] :
                        ( aa(B,$o,Pa,Ya)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),Ya) ) )
                 => ( Y2 = X4 ) ) )
         => aa(B,$o,Pa,ord_Least(B,Pa)) ) ) ).

% Least1I
tff(fact_2966_Least__le,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),K: B] :
          ( aa(B,$o,Pa,K)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),ord_Least(B,Pa)),K) ) ) ).

% Least_le
tff(fact_2967_not__less__Least,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [K: B,Pa: fun(B,$o)] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),ord_Least(B,Pa))
         => ~ aa(B,$o,Pa,K) ) ) ).

% not_less_Least
tff(fact_2968_Inf__nat__def,axiom,
    ! [X5: set(nat)] : ( aa(set(nat),nat,complete_Inf_Inf(nat),X5) = ord_Least(nat,aTP_Lamp_xp(set(nat),fun(nat,$o),X5)) ) ).

% Inf_nat_def
tff(fact_2969_Least__Suc,axiom,
    ! [Pa: fun(nat,$o),N: nat] :
      ( aa(nat,$o,Pa,N)
     => ( ~ aa(nat,$o,Pa,zero_zero(nat))
       => ( ord_Least(nat,Pa) = aa(nat,nat,suc,ord_Least(nat,aTP_Lamp_xd(fun(nat,$o),fun(nat,$o),Pa))) ) ) ) ).

% Least_Suc
tff(fact_2970_enumerate__0,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [S: set(B)] : ( infini527867602293511546merate(B,S,zero_zero(nat)) = ord_Least(B,aTP_Lamp_xn(set(B),fun(B,$o),S)) ) ) ).

% enumerate_0
tff(fact_2971_less__int__def,axiom,
    ord_less(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(int,fun(int,$o)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(int,$o),rep_Integ,map_fun(int,product_prod(nat,nat),$o,$o,rep_Integ,id($o))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wn(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_int_def
tff(fact_2972_less__eq__int__def,axiom,
    ord_less_eq(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(int,fun(int,$o)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(int,$o),rep_Integ,map_fun(int,product_prod(nat,nat),$o,$o,rep_Integ,id($o))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_eq_int_def
tff(fact_2973_Least__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [F2: fun(B,C),S: set(B)] :
          ( order_mono(B,C,F2)
         => ( ? [X4: B] :
                ( aa(set(B),$o,member(B,X4),S)
                & ! [Xa4: B] :
                    ( aa(set(B),$o,member(B,Xa4),S)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),Xa4) ) )
           => ( ord_Least(C,aa(set(B),fun(C,$o),aTP_Lamp_xq(fun(B,C),fun(set(B),fun(C,$o)),F2),S)) = aa(B,C,F2,ord_Least(B,aTP_Lamp_xr(set(B),fun(B,$o),S))) ) ) ) ) ).

% Least_mono
tff(fact_2974_enumerate__Suc_H_H,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [S: set(B),N: nat] :
          ( ~ aa(set(B),$o,finite_finite2(B),S)
         => ( infini527867602293511546merate(B,S,aa(nat,nat,suc,N)) = ord_Least(B,aa(nat,fun(B,$o),aTP_Lamp_xm(set(B),fun(nat,fun(B,$o)),S),N)) ) ) ) ).

% enumerate_Suc''
tff(fact_2975_Bleast__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [S: set(B),Pa: fun(B,$o)] : ( bleast(B,S,Pa) = ord_Least(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_xs(set(B),fun(fun(B,$o),fun(B,$o)),S),Pa)) ) ) ).

% Bleast_def
tff(fact_2976_abort__Bleast__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [S: set(B),Pa: fun(B,$o)] : ( abort_Bleast(B,S,Pa) = ord_Least(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_xs(set(B),fun(fun(B,$o),fun(B,$o)),S),Pa)) ) ) ).

% abort_Bleast_def
tff(fact_2977_ring__1__class_Oof__int__def,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ( ring_1_of_int(B) = aa(fun(product_prod(nat,nat),B),fun(int,B),map_fun(int,product_prod(nat,nat),B,B,rep_Integ,id(B)),aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),aTP_Lamp_wy(nat,fun(nat,B)))) ) ) ).

% ring_1_class.of_int_def
tff(fact_2978_at__top__def,axiom,
    ! [B: $tType] :
      ( order(B)
     => ( at_top(B) = aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(B),set(filter(B)),image2(B,filter(B),aTP_Lamp_xt(B,filter(B))),top_top(set(B)))) ) ) ).

% at_top_def
tff(fact_2979_le__divide__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [W2: num,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Ca)),B3),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Ca)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),zero_zero(B))) ) ) ) ).

% le_divide_eq_numeral(2)
tff(fact_2980_numeral__times__numeral,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [M2: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),M2)),aa(num,B,numeral_numeral(B),N)) = aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),M2),N)) ) ) ).

% numeral_times_numeral
tff(fact_2981_mult__numeral__left__semiring__numeral,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [V: num,W2: num,Z2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Z2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2))),Z2) ) ) ).

% mult_numeral_left_semiring_numeral
tff(fact_2982_power__add__numeral2,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A4: B,M2: num,N: num,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(num,nat,numeral_numeral(nat),M2))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(num,nat,numeral_numeral(nat),N))),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M2),N)))),B3) ) ) ).

% power_add_numeral2
tff(fact_2983_power__add__numeral,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A4: B,M2: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(num,nat,numeral_numeral(nat),M2))),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(num,nat,numeral_numeral(nat),N))) = aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M2),N))) ) ) ).

% power_add_numeral
tff(fact_2984_atLeast__empty__triv,axiom,
    ! [B: $tType] : ( aa(set(B),set(set(B)),set_ord_atLeast(set(B)),bot_bot(set(B))) = top_top(set(set(B))) ) ).

% atLeast_empty_triv
tff(fact_2985_distrib__left__numeral,axiom,
    ! [B: $tType] :
      ( ( numeral(B)
        & semiring(B) )
     => ! [V: num,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),Ca)) ) ) ).

% distrib_left_numeral
tff(fact_2986_distrib__right__numeral,axiom,
    ! [B: $tType] :
      ( ( numeral(B)
        & semiring(B) )
     => ! [A4: B,B3: B,V: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),aa(num,B,numeral_numeral(B),V)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(num,B,numeral_numeral(B),V))),aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(num,B,numeral_numeral(B),V))) ) ) ).

% distrib_right_numeral
tff(fact_2987_left__diff__distrib__numeral,axiom,
    ! [B: $tType] :
      ( ( numeral(B)
        & ring(B) )
     => ! [A4: B,B3: B,V: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),aa(num,B,numeral_numeral(B),V)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(num,B,numeral_numeral(B),V))),aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(num,B,numeral_numeral(B),V))) ) ) ).

% left_diff_distrib_numeral
tff(fact_2988_right__diff__distrib__numeral,axiom,
    ! [B: $tType] :
      ( ( numeral(B)
        & ring(B) )
     => ! [V: num,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),Ca)) ) ) ).

% right_diff_distrib_numeral
tff(fact_2989_mult__neg__numeral__simps_I3_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [M2: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),M2)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),M2),N))) ) ) ).

% mult_neg_numeral_simps(3)
tff(fact_2990_mult__neg__numeral__simps_I2_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [M2: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))),aa(num,B,numeral_numeral(B),N)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),M2),N))) ) ) ).

% mult_neg_numeral_simps(2)
tff(fact_2991_mult__neg__numeral__simps_I1_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [M2: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N))) = aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),M2),N)) ) ) ).

% mult_neg_numeral_simps(1)
tff(fact_2992_of__int__eq__1__iff,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [Z2: int] :
          ( ( aa(int,B,ring_1_of_int(B),Z2) = one_one(B) )
        <=> ( Z2 = one_one(int) ) ) ) ).

% of_int_eq_1_iff
tff(fact_2993_of__int__1,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ( aa(int,B,ring_1_of_int(B),one_one(int)) = one_one(B) ) ) ).

% of_int_1
tff(fact_2994_of__int__mult,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [W2: int,Z2: int] : ( aa(int,B,ring_1_of_int(B),aa(int,int,aa(int,fun(int,int),times_times(int),W2),Z2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(int,B,ring_1_of_int(B),W2)),aa(int,B,ring_1_of_int(B),Z2)) ) ) ).

% of_int_mult
tff(fact_2995_Sup__atLeast,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [X2: B] : ( aa(set(B),B,complete_Sup_Sup(B),aa(B,set(B),set_ord_atLeast(B),X2)) = top_top(B) ) ) ).

% Sup_atLeast
tff(fact_2996_le__divide__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(num,B,numeral_numeral(B),W2)))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(num,B,numeral_numeral(B),W2))),B3) ) ) ).

% le_divide_eq_numeral1(1)
tff(fact_2997_divide__le__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,W2: num,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(num,B,numeral_numeral(B),W2))),A4)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(num,B,numeral_numeral(B),W2))) ) ) ).

% divide_le_eq_numeral1(1)
tff(fact_2998_eq__divide__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B,W2: num] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(num,B,numeral_numeral(B),W2)) )
        <=> $ite(aa(num,B,numeral_numeral(B),W2) != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(num,B,numeral_numeral(B),W2)) = B3,A4 = zero_zero(B)) ) ) ).

% eq_divide_eq_numeral1(1)
tff(fact_2999_divide__eq__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [B3: B,W2: num,A4: B] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(num,B,numeral_numeral(B),W2)) = A4 )
        <=> $ite(aa(num,B,numeral_numeral(B),W2) != zero_zero(B),B3 = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(num,B,numeral_numeral(B),W2)),A4 = zero_zero(B)) ) ) ).

% divide_eq_eq_numeral1(1)
tff(fact_3000_less__divide__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(num,B,numeral_numeral(B),W2)))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(num,B,numeral_numeral(B),W2))),B3) ) ) ).

% less_divide_eq_numeral1(1)
tff(fact_3001_divide__less__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,W2: num,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(num,B,numeral_numeral(B),W2))),A4)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(num,B,numeral_numeral(B),W2))) ) ) ).

% divide_less_eq_numeral1(1)
tff(fact_3002_of__int__prod,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_ring_1(B)
     => ! [F2: fun(C,int),A3: set(C)] : ( aa(int,B,ring_1_of_int(B),aa(set(C),int,aa(fun(C,int),fun(set(C),int),groups7121269368397514597t_prod(C,int),F2),A3)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aTP_Lamp_xu(fun(C,int),fun(C,B),F2)),A3) ) ) ).

% of_int_prod
tff(fact_3003_of__int__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ring_1(B)
     => ! [F2: fun(C,int),A3: set(C)] : ( aa(int,B,ring_1_of_int(B),aa(set(C),int,aa(fun(C,int),fun(set(C),int),groups7311177749621191930dd_sum(C,int),F2),A3)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aTP_Lamp_xv(fun(C,int),fun(C,B),F2)),A3) ) ) ).

% of_int_sum
tff(fact_3004_divide__le__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,W2: num,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))),A4)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))),B3) ) ) ).

% divide_le_eq_numeral1(2)
tff(fact_3005_le__divide__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))) ) ) ).

% le_divide_eq_numeral1(2)
tff(fact_3006_divide__eq__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [B3: B,W2: num,A4: B] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) = A4 )
        <=> $ite(aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) != zero_zero(B),B3 = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),A4 = zero_zero(B)) ) ) ).

% divide_eq_eq_numeral1(2)
tff(fact_3007_eq__divide__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B,W2: num] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) )
        <=> $ite(aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) = B3,A4 = zero_zero(B)) ) ) ).

% eq_divide_eq_numeral1(2)
tff(fact_3008_less__divide__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))) ) ) ).

% less_divide_eq_numeral1(2)
tff(fact_3009_divide__less__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,W2: num,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))),A4)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))),B3) ) ) ).

% divide_less_eq_numeral1(2)
tff(fact_3010_of__int__le__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z2),one_one(int)) ) ) ).

% of_int_le_1_iff
tff(fact_3011_of__int__1__le__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(int,B,ring_1_of_int(B),Z2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),Z2) ) ) ).

% of_int_1_le_iff
tff(fact_3012_of__int__less__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z2),one_one(int)) ) ) ).

% of_int_less_1_iff
tff(fact_3013_of__int__1__less__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(int,B,ring_1_of_int(B),Z2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),Z2) ) ) ).

% of_int_1_less_iff
tff(fact_3014_mult__of__int__commute,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X2: int,Y: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(int,B,ring_1_of_int(B),X2)),Y) = aa(B,B,aa(B,fun(B,B),times_times(B),Y),aa(int,B,ring_1_of_int(B),X2)) ) ) ).

% mult_of_int_commute
tff(fact_3015_not__empty__eq__Ici__eq__empty,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [L: B] : ( bot_bot(set(B)) != aa(B,set(B),set_ord_atLeast(B),L) ) ) ).

% not_empty_eq_Ici_eq_empty
tff(fact_3016_atLeast__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [L: B] : ( aa(B,set(B),set_ord_atLeast(B),L) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),ord_less_eq(B),L)) ) ) ).

% atLeast_def
tff(fact_3017_one__le__numeral,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [N: num] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(num,B,numeral_numeral(B),N)) ) ).

% one_le_numeral
tff(fact_3018_not__numeral__less__one,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [N: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(num,B,numeral_numeral(B),N)),one_one(B)) ) ).

% not_numeral_less_one
tff(fact_3019_one__plus__numeral__commute,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [X2: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(num,B,numeral_numeral(B),X2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),X2)),one_one(B)) ) ) ).

% one_plus_numeral_commute
tff(fact_3020_one__neq__neg__numeral,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [N: num] : ( one_one(B) != aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N)) ) ) ).

% one_neq_neg_numeral
tff(fact_3021_numeral__neq__neg__one,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [N: num] : ( aa(num,B,numeral_numeral(B),N) != aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% numeral_neq_neg_one
tff(fact_3022_atLeast__eq__UNIV__iff,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [X2: B] :
          ( ( aa(B,set(B),set_ord_atLeast(B),X2) = top_top(set(B)) )
        <=> ( X2 = bot_bot(B) ) ) ) ).

% atLeast_eq_UNIV_iff
tff(fact_3023_not__one__le__neg__numeral,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))) ) ).

% not_one_le_neg_numeral
tff(fact_3024_not__numeral__le__neg__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),M2)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% not_numeral_le_neg_one
tff(fact_3025_neg__numeral__le__neg__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% neg_numeral_le_neg_one
tff(fact_3026_neg__one__le__numeral,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(num,B,numeral_numeral(B),M2)) ) ).

% neg_one_le_numeral
tff(fact_3027_neg__numeral__le__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))),one_one(B)) ) ).

% neg_numeral_le_one
tff(fact_3028_eq__divide__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [W2: num,B3: B,Ca: B] :
          ( ( aa(num,B,numeral_numeral(B),W2) = aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) )
        <=> $ite(Ca != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Ca) = B3,aa(num,B,numeral_numeral(B),W2) = zero_zero(B)) ) ) ).

% eq_divide_eq_numeral(1)
tff(fact_3029_divide__eq__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [B3: B,Ca: B,W2: num] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) = aa(num,B,numeral_numeral(B),W2) )
        <=> $ite(Ca != zero_zero(B),B3 = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Ca),aa(num,B,numeral_numeral(B),W2) = zero_zero(B)) ) ) ).

% divide_eq_eq_numeral(1)
tff(fact_3030_not__neg__one__less__neg__numeral,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))) ) ).

% not_neg_one_less_neg_numeral
tff(fact_3031_not__one__less__neg__numeral,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))) ) ).

% not_one_less_neg_numeral
tff(fact_3032_not__numeral__less__neg__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(num,B,numeral_numeral(B),M2)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% not_numeral_less_neg_one
tff(fact_3033_neg__one__less__numeral,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(num,B,numeral_numeral(B),M2)) ) ).

% neg_one_less_numeral
tff(fact_3034_neg__numeral__less__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))),one_one(B)) ) ).

% neg_numeral_less_one
tff(fact_3035_ivl__disj__int__one_I8_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or7035219750837199246ssThan(B,L,U)),aa(B,set(B),set_ord_atLeast(B),U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(8)
tff(fact_3036_atLeastAtMost__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [L: B,U: B] : ( set_or1337092689740270186AtMost(B,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_atLeast(B),L)),aa(B,set(B),set_ord_atMost(B),U)) ) ) ).

% atLeastAtMost_def
tff(fact_3037_atLeastLessThan__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [L: B,U: B] : ( set_or7035219750837199246ssThan(B,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_atLeast(B),L)),aa(B,set(B),set_ord_lessThan(B),U)) ) ) ).

% atLeastLessThan_def
tff(fact_3038_of__int__leD,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [N: int,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(int,B,ring_1_of_int(B),N))),X2)
         => ( ( N = zero_zero(int) )
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),X2) ) ) ) ).

% of_int_leD
tff(fact_3039_of__int__lessD,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [N: int,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),aa(int,B,ring_1_of_int(B),N))),X2)
         => ( ( N = zero_zero(int) )
            | aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),X2) ) ) ) ).

% of_int_lessD
tff(fact_3040_divide__less__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,Ca: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),aa(num,B,numeral_numeral(B),W2))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Ca)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Ca)),B3),aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(num,B,numeral_numeral(B),W2))) ) ) ) ).

% divide_less_eq_numeral(1)
tff(fact_3041_less__divide__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [W2: num,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(num,B,numeral_numeral(B),W2)),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Ca)),B3),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Ca)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(num,B,numeral_numeral(B),W2)),zero_zero(B))) ) ) ) ).

% less_divide_eq_numeral(1)
tff(fact_3042_divide__eq__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [B3: B,Ca: B,W2: num] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) )
        <=> $ite(Ca != zero_zero(B),B3 = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Ca),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) = zero_zero(B)) ) ) ).

% divide_eq_eq_numeral(2)
tff(fact_3043_eq__divide__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [W2: num,B3: B,Ca: B] :
          ( ( aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) )
        <=> $ite(Ca != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Ca) = B3,aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) = zero_zero(B)) ) ) ).

% eq_divide_eq_numeral(2)
tff(fact_3044_of__int_Oabs__eq,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X2: product_prod(nat,nat)] : ( aa(int,B,ring_1_of_int(B),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),B,aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),aTP_Lamp_wy(nat,fun(nat,B))),X2) ) ) ).

% of_int.abs_eq
tff(fact_3045_atMost__Int__atLeast,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [N: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_atMost(B),N)),aa(B,set(B),set_ord_atLeast(B),N)) = aa(set(B),set(B),insert(B,N),bot_bot(set(B))) ) ) ).

% atMost_Int_atLeast
tff(fact_3046_of__int_Orep__eq,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X2: int] : ( aa(int,B,ring_1_of_int(B),X2) = aa(product_prod(nat,nat),B,aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),aTP_Lamp_wy(nat,fun(nat,B))),aa(int,product_prod(nat,nat),rep_Integ,X2)) ) ) ).

% of_int.rep_eq
tff(fact_3047_divide__le__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,Ca: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),aa(num,B,numeral_numeral(B),W2))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Ca)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Ca)),B3),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(num,B,numeral_numeral(B),W2))) ) ) ) ).

% divide_le_eq_numeral(1)
tff(fact_3048_le__divide__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [W2: num,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),W2)),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Ca)),B3),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Ca)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),W2)),zero_zero(B))) ) ) ) ).

% le_divide_eq_numeral(1)
tff(fact_3049_divide__less__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,Ca: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Ca)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Ca)),B3),aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))) ) ) ) ).

% divide_less_eq_numeral(2)
tff(fact_3050_less__divide__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [W2: num,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Ca)),B3),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Ca)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),zero_zero(B))) ) ) ) ).

% less_divide_eq_numeral(2)
tff(fact_3051_transfer__rule__numeral,axiom,
    ! [B: $tType,C: $tType] :
      ( ( monoid_add(C)
        & semiring_numeral(C)
        & monoid_add(B)
        & semiring_numeral(B) )
     => ! [R: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),R,zero_zero(B)),zero_zero(C))
         => ( aa(C,$o,aa(B,fun(C,$o),R,one_one(B)),one_one(C))
           => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),R,bNF_rel_fun(B,C,B,C,R,R)),plus_plus(B)),plus_plus(C))
             => aa(fun(num,C),$o,aa(fun(num,B),fun(fun(num,C),$o),bNF_rel_fun(num,num,B,C,fequal(num),R),numeral_numeral(B)),numeral_numeral(C)) ) ) ) ) ).

% transfer_rule_numeral
tff(fact_3052_atLeast__Suc,axiom,
    ! [K: nat] : ( aa(nat,set(nat),set_ord_atLeast(nat),aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_atLeast(nat),K)),aa(set(nat),set(nat),insert(nat,K),bot_bot(set(nat)))) ) ).

% atLeast_Suc
tff(fact_3053_UN__atLeast__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Sup_Sup(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),set_ord_atLeast(nat)),top_top(set(nat)))) = top_top(set(nat)) ).

% UN_atLeast_UNIV
tff(fact_3054_at__top__sub,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ca: B] : ( at_top(B) = aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(B),set(filter(B)),image2(B,filter(B),aTP_Lamp_xw(B,filter(B))),aa(B,set(B),set_ord_atLeast(B),Ca))) ) ) ).

% at_top_sub
tff(fact_3055_transfer__rule__of__int,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ring_1(C)
        & ring_1(B) )
     => ! [R: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),R,zero_zero(B)),zero_zero(C))
         => ( aa(C,$o,aa(B,fun(C,$o),R,one_one(B)),one_one(C))
           => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),R,bNF_rel_fun(B,C,B,C,R,R)),plus_plus(B)),plus_plus(C))
             => ( aa(fun(C,C),$o,aa(fun(B,B),fun(fun(C,C),$o),bNF_rel_fun(B,C,B,C,R,R),uminus_uminus(B)),uminus_uminus(C))
               => aa(fun(int,C),$o,aa(fun(int,B),fun(fun(int,C),$o),bNF_rel_fun(int,int,B,C,fequal(int),R),ring_1_of_int(B)),ring_1_of_int(C)) ) ) ) ) ) ).

% transfer_rule_of_int
tff(fact_3056_of__int_Otransfer,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => aa(fun(int,B),$o,aa(fun(product_prod(nat,nat),B),fun(fun(int,B),$o),bNF_rel_fun(product_prod(nat,nat),int,B,B,pcr_int,fequal(B)),aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),aTP_Lamp_wy(nat,fun(nat,B)))),ring_1_of_int(B)) ) ).

% of_int.transfer
tff(fact_3057_divide__le__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [B3: B,Ca: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ca),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Ca)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Ca)),B3),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))) ) ) ) ).

% divide_le_eq_numeral(2)
tff(fact_3058_semiring__norm_I172_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [V: num,W2: num,Y: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Y)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2))),Y) ) ) ).

% semiring_norm(172)
tff(fact_3059_semiring__norm_I171_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [V: num,W2: num,Y: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Y)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2)))),Y) ) ) ).

% semiring_norm(171)
tff(fact_3060_semiring__norm_I170_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [V: num,W2: num,Y: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Y)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2)))),Y) ) ) ).

% semiring_norm(170)
tff(fact_3061_numeral__times__minus__swap,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [W2: num,X2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),aa(B,B,uminus_uminus(B),X2)) = aa(B,B,aa(B,fun(B,B),times_times(B),X2),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) ) ) ).

% numeral_times_minus_swap
tff(fact_3062_neg__numeral__le__ceiling,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [V: num,X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(B,X2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),one_one(B))),X2) ) ) ).

% neg_numeral_le_ceiling
tff(fact_3063_ceiling__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ( archimedean_ceiling(B,one_one(B)) = one_one(int) ) ) ).

% ceiling_one
tff(fact_3064_ceiling__le__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(B,X2)),one_one(int))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),one_one(B)) ) ) ).

% ceiling_le_one
tff(fact_3065_one__less__ceiling,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),archimedean_ceiling(B,X2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),X2) ) ) ).

% one_less_ceiling
tff(fact_3066_ceiling__add__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] : ( archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),one_one(B))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(B,X2)),one_one(int)) ) ) ).

% ceiling_add_one
tff(fact_3067_ceiling__diff__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] : ( archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),one_one(B))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(B,X2)),one_one(int)) ) ) ).

% ceiling_diff_one
tff(fact_3068_ceiling__less__zero,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(B,X2)),zero_zero(int))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,uminus_uminus(B),one_one(B))) ) ) ).

% ceiling_less_zero
tff(fact_3069_zero__le__ceiling,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),archimedean_ceiling(B,X2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),one_one(B))),X2) ) ) ).

% zero_le_ceiling
tff(fact_3070_ceiling__less__numeral,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(B,X2)),aa(num,int,numeral_numeral(int),V))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(num,B,numeral_numeral(B),V)),one_one(B))) ) ) ).

% ceiling_less_numeral
tff(fact_3071_numeral__le__ceiling,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [V: num,X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(B,X2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(num,B,numeral_numeral(B),V)),one_one(B))),X2) ) ) ).

% numeral_le_ceiling
tff(fact_3072_ceiling__less__neg__numeral,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(B,X2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),one_one(B))) ) ) ).

% ceiling_less_neg_numeral
tff(fact_3073_ceiling__split,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Pa: fun(int,$o),T3: B] :
          ( aa(int,$o,Pa,archimedean_ceiling(B,T3))
        <=> ! [I5: int] :
              ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),I5)),one_one(B))),T3)
                & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),T3),aa(int,B,ring_1_of_int(B),I5)) )
             => aa(int,$o,Pa,I5) ) ) ) ).

% ceiling_split
tff(fact_3074_ceiling__eq__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,A4: int] :
          ( ( archimedean_ceiling(B,X2) = A4 )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),A4)),one_one(B))),X2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(int,B,ring_1_of_int(B),A4)) ) ) ) ).

% ceiling_eq_iff
tff(fact_3075_ceiling__unique,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Z2: int,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))),X2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(int,B,ring_1_of_int(B),Z2))
           => ( archimedean_ceiling(B,X2) = Z2 ) ) ) ) ).

% ceiling_unique
tff(fact_3076_ceiling__correct,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),archimedean_ceiling(B,X2))),one_one(B))),X2)
          & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(int,B,ring_1_of_int(B),archimedean_ceiling(B,X2))) ) ) ).

% ceiling_correct
tff(fact_3077_mult__ceiling__le,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(B,A4)),archimedean_ceiling(B,B3))) ) ) ) ).

% mult_ceiling_le
tff(fact_3078_ceiling__less__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,Z2: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(B,X2)),Z2)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))) ) ) ).

% ceiling_less_iff
tff(fact_3079_le__ceiling__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Z2: int,X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z2),archimedean_ceiling(B,X2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))),X2) ) ) ).

% le_ceiling_iff
tff(fact_3080_ceiling__divide__upper,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Q: B,P3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Q)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),P3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(int,B,ring_1_of_int(B),archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),P3),Q)))),Q)) ) ) ).

% ceiling_divide_upper
tff(fact_3081_ceiling__divide__lower,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Q: B,P3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Q)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),P3),Q)))),one_one(B))),Q)),P3) ) ) ).

% ceiling_divide_lower
tff(fact_3082_floor__le__neg__numeral,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(B,X2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),one_one(B))) ) ) ).

% floor_le_neg_numeral
tff(fact_3083_neg__numeral__less__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [V: num,X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(B,X2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),one_one(B))),X2) ) ) ).

% neg_numeral_less_floor
tff(fact_3084_sub_Orsp,axiom,
    aa(fun(num,fun(num,int)),$o,aa(fun(num,fun(num,int)),fun(fun(num,fun(num,int)),$o),bNF_rel_fun(num,num,fun(num,int),fun(num,int),fequal(num),bNF_rel_fun(num,num,int,int,fequal(num),fequal(int))),aTP_Lamp_xx(num,fun(num,int))),aTP_Lamp_xx(num,fun(num,int))) ).

% sub.rsp
tff(fact_3085_pochhammer__times__pochhammer__half,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Z2: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),comm_s3205402744901411588hammer(B,Z2,aa(nat,nat,suc,N))),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_xy(B,fun(nat,B),Z2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)),one_one(nat)))) ) ) ).

% pochhammer_times_pochhammer_half
tff(fact_3086_mult__ceiling__le__Ints,axiom,
    ! [C: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & linordered_idom(C) )
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(set(B),$o,member(B,A4),ring_1_Ints(B))
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(int,C,ring_1_of_int(C),archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)))),aa(int,C,ring_1_of_int(C),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(B,A4)),archimedean_ceiling(B,B3)))) ) ) ) ).

% mult_ceiling_le_Ints
tff(fact_3087_numeral__eq__one__iff,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: num] :
          ( ( aa(num,B,numeral_numeral(B),N) = one_one(B) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_one_iff
tff(fact_3088_one__eq__numeral__iff,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: num] :
          ( ( one_one(B) = aa(num,B,numeral_numeral(B),N) )
        <=> ( one2 = N ) ) ) ).

% one_eq_numeral_iff
tff(fact_3089_floor__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ( archim6421214686448440834_floor(B,one_one(B)) = one_one(int) ) ) ).

% floor_one
tff(fact_3090_numeral__le__one__iff,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [N: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),N)),one_one(B))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),N),one2) ) ) ).

% numeral_le_one_iff
tff(fact_3091_one__less__numeral__iff,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [N: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(num,B,numeral_numeral(B),N))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),one2),N) ) ) ).

% one_less_numeral_iff
tff(fact_3092_numeral__eq__neg__one__iff,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [N: num] :
          ( ( aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N)) = aa(B,B,uminus_uminus(B),one_one(B)) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
tff(fact_3093_neg__one__eq__numeral__iff,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [N: num] :
          ( ( aa(B,B,uminus_uminus(B),one_one(B)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N)) )
        <=> ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
tff(fact_3094_not__neg__one__le__neg__numeral__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2)))
        <=> ( M2 != one2 ) ) ) ).

% not_neg_one_le_neg_numeral_iff
tff(fact_3095_one__add__one,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)) ) ) ).

% one_add_one
tff(fact_3096_neg__numeral__less__neg__one__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))),aa(B,B,uminus_uminus(B),one_one(B)))
        <=> ( M2 != one2 ) ) ) ).

% neg_numeral_less_neg_one_iff
tff(fact_3097_numeral__plus__one,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),N)),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2)) ) ) ).

% numeral_plus_one
tff(fact_3098_one__plus__numeral,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(num,B,numeral_numeral(B),N)) = aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% one_plus_numeral
tff(fact_3099_zero__less__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),archim6421214686448440834_floor(B,X2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),X2) ) ) ).

% zero_less_floor
tff(fact_3100_floor__le__zero,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(B,X2)),zero_zero(int))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),one_one(B)) ) ) ).

% floor_le_zero
tff(fact_3101_one__le__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),archim6421214686448440834_floor(B,X2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),X2) ) ) ).

% one_le_floor
tff(fact_3102_floor__less__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(B,X2)),one_one(int))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),one_one(B)) ) ) ).

% floor_less_one
tff(fact_3103_floor__diff__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] : ( archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),one_one(B))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(B,X2)),one_one(int)) ) ) ).

% floor_diff_one
tff(fact_3104_bits__1__div__2,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = zero_zero(B) ) ) ).

% bits_1_div_2
tff(fact_3105_one__div__two__eq__zero,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = zero_zero(B) ) ) ).

% one_div_two_eq_zero
tff(fact_3106_add__neg__numeral__special_I9_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% add_neg_numeral_special(9)
tff(fact_3107_diff__numeral__special_I11_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(B,B,uminus_uminus(B),one_one(B))) = aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)) ) ) ).

% diff_numeral_special(11)
tff(fact_3108_diff__numeral__special_I10_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),one_one(B))),one_one(B)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% diff_numeral_special(10)
tff(fact_3109_minus__1__div__2__eq,axiom,
    ! [B: $tType] :
      ( euclid8789492081693882211th_nat(B)
     => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% minus_1_div_2_eq
tff(fact_3110_card__doubleton__eq__2__iff,axiom,
    ! [B: $tType,A4: B,B3: B] :
      ( ( aa(set(B),nat,finite_card(B),aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ( A4 != B3 ) ) ).

% card_doubleton_eq_2_iff
tff(fact_3111_diff__numeral__special_I3_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N))) = aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% diff_numeral_special(3)
tff(fact_3112_diff__numeral__special_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M2: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))),one_one(B)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),M2),one2))) ) ) ).

% diff_numeral_special(4)
tff(fact_3113_power__minus1__even,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = one_one(B) ) ) ).

% power_minus1_even
tff(fact_3114_numeral__less__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [V: num,X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(B,X2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),V)),one_one(B))),X2) ) ) ).

% numeral_less_floor
tff(fact_3115_floor__le__numeral,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(B,X2)),aa(num,int,numeral_numeral(int),V))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),V)),one_one(B))) ) ) ).

% floor_le_numeral
tff(fact_3116_one__div__2__pow__eq,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa($o,B,zero_neq_one_of_bool(B),( N = zero_zero(nat) )) ) ) ).

% one_div_2_pow_eq
tff(fact_3117_bits__1__div__exp,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [N: nat] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa($o,B,zero_neq_one_of_bool(B),( N = zero_zero(nat) )) ) ) ).

% bits_1_div_exp
tff(fact_3118_Ints__mult,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [A4: B,B3: B] :
          ( aa(set(B),$o,member(B,A4),ring_1_Ints(B))
         => ( aa(set(B),$o,member(B,B3),ring_1_Ints(B))
           => aa(set(B),$o,member(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),ring_1_Ints(B)) ) ) ) ).

% Ints_mult
tff(fact_3119_Ints__1,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => aa(set(B),$o,member(B,one_one(B)),ring_1_Ints(B)) ) ).

% Ints_1
tff(fact_3120_mult__2,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [Z2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Z2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),Z2) ) ) ).

% mult_2
tff(fact_3121_mult__2__right,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [Z2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),Z2),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),Z2) ) ) ).

% mult_2_right
tff(fact_3122_left__add__twice,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)),B3) ) ) ).

% left_add_twice
tff(fact_3123_power2__eq__square,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A4: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),A4) ) ) ).

% power2_eq_square
tff(fact_3124_power4__eq__xxxx,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [X2: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),X2)),X2)),X2) ) ) ).

% power4_eq_xxxx
tff(fact_3125_one__power2,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),one_one(B)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(B) ) ) ).

% one_power2
tff(fact_3126_power2__eq__1__iff,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [A4: B] :
          ( ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(B) )
        <=> ( ( A4 = one_one(B) )
            | ( A4 = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ) ) ).

% power2_eq_1_iff
tff(fact_3127_card__2__iff,axiom,
    ! [B: $tType,S: set(B)] :
      ( ( aa(set(B),nat,finite_card(B),S) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ? [X3: B,Y4: B] :
          ( ( S = aa(set(B),set(B),insert(B,X3),aa(set(B),set(B),insert(B,Y4),bot_bot(set(B)))) )
          & ( X3 != Y4 ) ) ) ).

% card_2_iff
tff(fact_3128_abs__square__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B] :
          ( ( aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(B) )
        <=> ( aa(B,B,abs_abs(B),X2) = one_one(B) ) ) ) ).

% abs_square_eq_1
tff(fact_3129_mult__numeral__1__right,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(num,B,numeral_numeral(B),one2)) = A4 ) ) ).

% mult_numeral_1_right
tff(fact_3130_mult__numeral__1,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),one2)),A4) = A4 ) ) ).

% mult_numeral_1
tff(fact_3131_numeral__One,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ( aa(num,B,numeral_numeral(B),one2) = one_one(B) ) ) ).

% numeral_One
tff(fact_3132_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)
     => order_mono(nat,nat,aTP_Lamp_xz(nat,fun(nat,nat),K)) ) ).

% mono_ge2_power_minus_self
tff(fact_3133_floor__rat__def,axiom,
    ! [X2: rat] : ( archim6421214686448440834_floor(rat,X2) = the(int,aTP_Lamp_ya(rat,fun(int,$o),X2)) ) ).

% floor_rat_def
tff(fact_3134_le__mult__floor__Ints,axiom,
    ! [C: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & linordered_idom(C) )
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(set(B),$o,member(B,A4),ring_1_Ints(B))
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(int,C,ring_1_of_int(C),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(B,A4)),archim6421214686448440834_floor(B,B3)))),aa(int,C,ring_1_of_int(C),archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)))) ) ) ) ).

% le_mult_floor_Ints
tff(fact_3135_numeral__code_I2_J,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [N: num] :
          ( aa(num,B,numeral_numeral(B),aa(num,num,bit0,N))
          = $let(
              m: B,
              m := aa(num,B,numeral_numeral(B),N),
              aa(B,B,aa(B,fun(B,B),plus_plus(B),m),m) ) ) ) ).

% numeral_code(2)
tff(fact_3136_power2__sum,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [X2: B,Y: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),X2)),Y)) ) ) ).

% power2_sum
tff(fact_3137_square__le__1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),one_one(B))),X2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(B)) ) ) ) ).

% square_le_1
tff(fact_3138_abs__square__le__1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),X2)),one_one(B)) ) ) ).

% abs_square_le_1
tff(fact_3139_abs__square__less__1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),X2)),one_one(B)) ) ) ).

% abs_square_less_1
tff(fact_3140_bits__induct,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [Pa: fun(B,$o),A4: B] :
          ( ! [A5: B] :
              ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A5),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = A5 )
             => aa(B,$o,Pa,A5) )
         => ( ! [A5: B,B4: $o] :
                ( aa(B,$o,Pa,A5)
               => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa($o,B,zero_neq_one_of_bool(B),B4)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A5))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = A5 )
                 => aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa($o,B,zero_neq_one_of_bool(B),B4)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A5))) ) )
           => aa(B,$o,Pa,A4) ) ) ) ).

% bits_induct
tff(fact_3141_minus__power__mult__self,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [A4: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),A4)),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),A4)),N)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) ) ) ).

% minus_power_mult_self
tff(fact_3142_power__odd__eq,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A4: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% power_odd_eq
tff(fact_3143_finite__int__segment,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [A4: B,B3: B] : aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_yb(B,fun(B,fun(B,$o)),A4),B3))) ) ).

% finite_int_segment
tff(fact_3144_power2__diff,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [X2: B,Y: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),X2)),Y)) ) ) ).

% power2_diff
tff(fact_3145_choose__row__sum,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),binomial(N)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N) ) ).

% choose_row_sum
tff(fact_3146_power__minus1__odd,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% power_minus1_odd
tff(fact_3147_mask__eq__sum__exp,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [N: nat] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)),one_one(B)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N))) ) ) ).

% mask_eq_sum_exp
tff(fact_3148_mult__1s__ring__1_I1_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),one2))),B3) = aa(B,B,uminus_uminus(B),B3) ) ) ).

% mult_1s_ring_1(1)
tff(fact_3149_mult__1s__ring__1_I2_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),one2))) = aa(B,B,uminus_uminus(B),B3) ) ) ).

% mult_1s_ring_1(2)
tff(fact_3150_uminus__numeral__One,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),one2)) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% uminus_numeral_One
tff(fact_3151_sum_Oin__pairs,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_yc(fun(nat,B),fun(nat,B),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% sum.in_pairs
tff(fact_3152_prod_Oin__pairs,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),M2: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_yd(fun(nat,B),fun(nat,B),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% prod.in_pairs
tff(fact_3153_Ints__odd__nonzero,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [A4: B] :
          ( aa(set(B),$o,member(B,A4),ring_1_Ints(B))
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A4)),A4) != zero_zero(B) ) ) ) ).

% Ints_odd_nonzero
tff(fact_3154_sum_Oin__pairs__0,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_yc(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% sum.in_pairs_0
tff(fact_3155_prod_Oin__pairs__0,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_yd(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% prod.in_pairs_0
tff(fact_3156_power__numeral__even,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [Z2: B,W2: num] :
          ( aa(nat,B,aa(B,fun(nat,B),power_power(B),Z2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,W2)))
          = $let(
              w: B,
              w := aa(nat,B,aa(B,fun(nat,B),power_power(B),Z2),aa(num,nat,numeral_numeral(nat),W2)),
              aa(B,B,aa(B,fun(B,B),times_times(B),w),w) ) ) ) ).

% power_numeral_even
tff(fact_3157_choose__square__sum,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_ye(nat,fun(nat,nat),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)),N) ) ).

% choose_square_sum
tff(fact_3158_finite__abs__int__segment,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [A4: B] : aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_yf(B,fun(B,$o),A4))) ) ).

% finite_abs_int_segment
tff(fact_3159_one__add__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(B,X2)),one_one(int)) = archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),one_one(B))) ) ) ).

% one_add_floor
tff(fact_3160_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)),aa(nat,nat,suc,zero_zero(nat))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N))) ) ).

% mask_eq_sum_exp_nat
tff(fact_3161_gauss__sum__nat,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vw(nat,nat)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,suc,N))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% gauss_sum_nat
tff(fact_3162_sum__power2,axiom,
    ! [K: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)),one_one(nat)) ) ).

% sum_power2
tff(fact_3163_Sum__Ico__nat,axiom,
    ! [M2: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vw(nat,nat)),set_or7035219750837199246ssThan(nat,M2,N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),one_one(nat))))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% Sum_Ico_nat
tff(fact_3164_exp__div__exp__eq,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [M2: nat,N: nat] :
          ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N))
          = aa(B,B,
              aa(B,fun(B,B),times_times(B),
                aa($o,B,zero_neq_one_of_bool(B),
                  ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2) != zero_zero(B) )
                & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M2))),
              aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),N))) ) ) ).

% exp_div_exp_eq
tff(fact_3165_double__gauss__sum,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),semiring_1_of_nat(B)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))) ) ) ).

% double_gauss_sum
tff(fact_3166_double__arith__series,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B,D3: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aTP_Lamp_yg(B,fun(B,fun(nat,B)),A4),D3)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),D3))) ) ) ).

% double_arith_series
tff(fact_3167_Ints__odd__less__0,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] :
          ( aa(set(B),$o,member(B,A4),ring_1_Ints(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A4)),A4)),zero_zero(B))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B)) ) ) ) ).

% Ints_odd_less_0
tff(fact_3168_gbinomial__sum__nat__pow2,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_yh(nat,fun(nat,B),M2)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2) ) ) ).

% gbinomial_sum_nat_pow2
tff(fact_3169_Ints__nonzero__abs__ge1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B] :
          ( aa(set(B),$o,member(B,X2),ring_1_Ints(B))
         => ( ( X2 != zero_zero(B) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,abs_abs(B),X2)) ) ) ) ).

% Ints_nonzero_abs_ge1
tff(fact_3170_Ints__nonzero__abs__less1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B] :
          ( aa(set(B),$o,member(B,X2),ring_1_Ints(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),X2)),one_one(B))
           => ( X2 = zero_zero(B) ) ) ) ) ).

% Ints_nonzero_abs_less1
tff(fact_3171_Ints__eq__abs__less1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B,Y: B] :
          ( aa(set(B),$o,member(B,X2),ring_1_Ints(B))
         => ( aa(set(B),$o,member(B,Y),ring_1_Ints(B))
           => ( ( X2 = Y )
            <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),Y))),one_one(B)) ) ) ) ) ).

% Ints_eq_abs_less1
tff(fact_3172_arith__series__nat,axiom,
    ! [A4: nat,D3: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_yi(nat,fun(nat,fun(nat,nat)),A4),D3)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,N)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),A4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),D3)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% arith_series_nat
tff(fact_3173_Sum__Icc__int,axiom,
    ! [M2: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),M2),N)
     => ( aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7311177749621191930dd_sum(int,int),aTP_Lamp_rw(int,int)),set_or1337092689740270186AtMost(int,M2,N)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),N),aa(int,int,aa(int,fun(int,int),plus_plus(int),N),one_one(int)))),aa(int,int,aa(int,fun(int,int),times_times(int),M2),aa(int,int,aa(int,fun(int,int),minus_minus(int),M2),one_one(int))))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ) ).

% Sum_Icc_int
tff(fact_3174_Sum__Icc__nat,axiom,
    ! [M2: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vw(nat,nat)),set_or1337092689740270186AtMost(nat,M2,N)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),one_one(nat))))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% Sum_Icc_nat
tff(fact_3175_binomial__r__part__sum,axiom,
    ! [M2: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2)),one_one(nat)))),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2)) ) ).

% binomial_r_part_sum
tff(fact_3176_choose__linear__sum,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_yj(nat,fun(nat,nat),N)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ).

% choose_linear_sum
tff(fact_3177_floor__split,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Pa: fun(int,$o),T3: B] :
          ( aa(int,$o,Pa,archim6421214686448440834_floor(B,T3))
        <=> ! [I5: int] :
              ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),I5)),T3)
                & aa(B,$o,aa(B,fun(B,$o),ord_less(B),T3),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),I5)),one_one(B))) )
             => aa(int,$o,Pa,I5) ) ) ) ).

% floor_split
tff(fact_3178_floor__eq__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,A4: int] :
          ( ( archim6421214686448440834_floor(B,X2) = A4 )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),A4)),X2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),A4)),one_one(B))) ) ) ) ).

% floor_eq_iff
tff(fact_3179_floor__unique,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Z2: int,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),Z2)),X2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B)))
           => ( archim6421214686448440834_floor(B,X2) = Z2 ) ) ) ) ).

% floor_unique
tff(fact_3180_le__mult__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),B3)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(B,A4)),archim6421214686448440834_floor(B,B3))),archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))) ) ) ) ).

% le_mult_floor
tff(fact_3181_fact__double,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [N: nat] : ( semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N))),semiring_char_0_fact(B,N)) ) ) ).

% fact_double
tff(fact_3182_less__floor__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Z2: int,X2: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z2),archim6421214686448440834_floor(B,X2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))),X2) ) ) ).

% less_floor_iff
tff(fact_3183_floor__le__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,Z2: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(B,X2)),Z2)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))) ) ) ).

% floor_le_iff
tff(fact_3184_double__gauss__sum__from__Suc__0,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),semiring_1_of_nat(B)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))) ) ) ).

% double_gauss_sum_from_Suc_0
tff(fact_3185_arith__series,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A4: B,D3: B,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aTP_Lamp_yk(B,fun(B,fun(nat,B)),A4),D3)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),D3)))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% arith_series
tff(fact_3186_gauss__sum,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),semiring_1_of_nat(B)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B)))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum
tff(fact_3187_dup_Orsp,axiom,
    aa(fun(int,int),$o,aa(fun(int,int),fun(fun(int,int),$o),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int)),aTP_Lamp_yl(int,int)),aTP_Lamp_yl(int,int)) ).

% dup.rsp
tff(fact_3188_pochhammer__double,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Z2: B,N: nat] : ( comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Z2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))),comm_s3205402744901411588hammer(B,Z2,N))),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),N)) ) ) ).

% pochhammer_double
tff(fact_3189_gauss__sum__from__Suc__0,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),semiring_1_of_nat(B)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B)))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum_from_Suc_0
tff(fact_3190_gchoose__row__sum__weighted,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [R2: B,M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_ym(B,fun(nat,B),R2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),M2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,M2))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(nat,B,gbinomial(B,R2),aa(nat,nat,suc,M2))) ) ) ).

% gchoose_row_sum_weighted
tff(fact_3191_floor__divide__lower,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Q: B,P3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Q)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(int,B,ring_1_of_int(B),archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),P3),Q)))),Q)),P3) ) ) ).

% floor_divide_lower
tff(fact_3192_gbinomial__r__part__sum,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,B,semiring_1_of_nat(B),M2))),one_one(B)))),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2)) ) ) ).

% gbinomial_r_part_sum
tff(fact_3193_gbinomial__partial__row__sum,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: B,M2: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_ym(B,fun(nat,B),A4)),aa(nat,set(nat),set_ord_atMost(nat),M2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),M2)),one_one(B))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(nat,B,gbinomial(B,A4),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),one_one(nat)))) ) ) ).

% gbinomial_partial_row_sum
tff(fact_3194_floor__divide__upper,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Q: B,P3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Q)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),P3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),P3),Q)))),one_one(B))),Q)) ) ) ).

% floor_divide_upper
tff(fact_3195_divmod__step__eq,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [L: num,Q: B,R2: B] :
          ( unique1321980374590559556d_step(B,L,aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q),R2))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),L)),R2),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Q)),one_one(B))),aa(B,B,aa(B,fun(B,B),minus_minus(B),R2),aa(num,B,numeral_numeral(B),L))),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Q)),R2)) ) ) ).

% divmod_step_eq
tff(fact_3196_divmod__step__def,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [L: num,Qr: product_prod(B,B)] : ( unique1321980374590559556d_step(B,L,Qr) = aa(product_prod(B,B),product_prod(B,B),aa(fun(B,fun(B,product_prod(B,B))),fun(product_prod(B,B),product_prod(B,B)),product_case_prod(B,B,product_prod(B,B)),aTP_Lamp_yn(num,fun(B,fun(B,product_prod(B,B))),L)),Qr) ) ) ).

% divmod_step_def
tff(fact_3197_divmod__step__nat__def,axiom,
    ! [L: num,Qr: product_prod(nat,nat)] : ( unique1321980374590559556d_step(nat,L,Qr) = aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_yo(num,fun(nat,fun(nat,product_prod(nat,nat))),L)),Qr) ) ).

% divmod_step_nat_def
tff(fact_3198_set__bit__0,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B] : ( bit_se5668285175392031749et_bit(B,zero_zero(nat),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))) ) ) ).

% set_bit_0
tff(fact_3199_divmod__step__int__def,axiom,
    ! [L: num,Qr: product_prod(int,int)] : ( unique1321980374590559556d_step(int,L,Qr) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_yp(num,fun(int,fun(int,product_prod(int,int))),L)),Qr) ) ).

% divmod_step_int_def
tff(fact_3200_divmod__step__integer__def,axiom,
    ! [L: num,Qr: product_prod(code_integer,code_integer)] : ( unique1321980374590559556d_step(code_integer,L,Qr) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_yq(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),Qr) ) ).

% divmod_step_integer_def
tff(fact_3201_unset__bit__0,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B] : ( bit_se2638667681897837118et_bit(B,zero_zero(nat),A4) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) ) ) ).

% unset_bit_0
tff(fact_3202_round__unique,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,Y: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),aa(int,B,ring_1_of_int(B),Y))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),Y)),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))))
           => ( archimedean_round(B,X2) = Y ) ) ) ) ).

% round_unique
tff(fact_3203_choose__odd__sum,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_yr(nat,fun(nat,B),N)),aa(nat,set(nat),set_ord_atMost(nat),N))) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N) ) ) ) ).

% choose_odd_sum
tff(fact_3204_choose__even__sum,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_ys(nat,fun(nat,B),N)),aa(nat,set(nat),set_ord_atMost(nat),N))) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N) ) ) ) ).

% choose_even_sum
tff(fact_3205_dbl__simps_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl(B,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% dbl_simps(4)
tff(fact_3206_dvd__0__right,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),zero_zero(B)) ) ).

% dvd_0_right
tff(fact_3207_dvd__0__left__iff,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),zero_zero(B)),A4)
        <=> ( A4 = zero_zero(B) ) ) ) ).

% dvd_0_left_iff
tff(fact_3208_dvd__add__triv__left__iff,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ).

% dvd_add_triv_left_iff
tff(fact_3209_dvd__add__triv__right__iff,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ).

% dvd_add_triv_right_iff
tff(fact_3210_dvd__minus__iff,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X2),aa(B,B,uminus_uminus(B),Y))
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X2),Y) ) ) ).

% dvd_minus_iff
tff(fact_3211_minus__dvd__iff,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,uminus_uminus(B),X2)),Y)
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X2),Y) ) ) ).

% minus_dvd_iff
tff(fact_3212_div__dvd__div,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca)
           => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),A4))
            <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),Ca) ) ) ) ) ).

% div_dvd_div
tff(fact_3213_abs__dvd__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: B,K: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,abs_abs(B),M2)),K)
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),M2),K) ) ) ).

% abs_dvd_iff
tff(fact_3214_dvd__abs__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M2: B,K: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),M2),aa(B,B,abs_abs(B),K))
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),M2),K) ) ) ).

% dvd_abs_iff
tff(fact_3215_dvd__mult__cancel__left,axiom,
    ! [B: $tType] :
      ( idom(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
        <=> ( ( Ca = zero_zero(B) )
            | aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ) ).

% dvd_mult_cancel_left
tff(fact_3216_dvd__mult__cancel__right,axiom,
    ! [B: $tType] :
      ( idom(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
        <=> ( ( Ca = zero_zero(B) )
            | aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ) ).

% dvd_mult_cancel_right
tff(fact_3217_dvd__times__left__cancel__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca))
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),Ca) ) ) ) ).

% dvd_times_left_cancel_iff
tff(fact_3218_dvd__times__right__cancel__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4))
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),Ca) ) ) ) ).

% dvd_times_right_cancel_iff
tff(fact_3219_dvd__add__times__triv__left__iff,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ).

% dvd_add_times_triv_left_iff
tff(fact_3220_dvd__add__times__triv__right__iff,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)))
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ).

% dvd_add_times_triv_right_iff
tff(fact_3221_unit__prod,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),one_one(B)) ) ) ) ).

% unit_prod
tff(fact_3222_div__add,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)) ) ) ) ) ).

% div_add
tff(fact_3223_dvd__mult__div__cancel,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)) = B3 ) ) ) ).

% dvd_mult_div_cancel
tff(fact_3224_dvd__div__mult__self,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)),A4) = B3 ) ) ) ).

% dvd_div_mult_self
tff(fact_3225_unit__div__1__div__1,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4)) = A4 ) ) ) ).

% unit_div_1_div_1
tff(fact_3226_unit__div__1__unit,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4)),one_one(B)) ) ) ).

% unit_div_1_unit
tff(fact_3227_unit__div,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),one_one(B)) ) ) ) ).

% unit_div
tff(fact_3228_div__diff,axiom,
    ! [B: $tType] :
      ( idom_modulo(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)) ) ) ) ) ).

% div_diff
tff(fact_3229_round__1,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ( archimedean_round(B,one_one(B)) = one_one(int) ) ) ).

% round_1
tff(fact_3230_unit__mult__div__div,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4) ) ) ) ).

% unit_mult_div_div
tff(fact_3231_unit__div__mult__self,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)),A4) = B3 ) ) ) ).

% unit_div_mult_self
tff(fact_3232_even__mult__iff,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
        <=> ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
            | aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B3) ) ) ) ).

% even_mult_iff
tff(fact_3233_dbl__simps_I3_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl(B,one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)) ) ) ).

% dbl_simps(3)
tff(fact_3234_even__plus__one__iff,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B)))
        <=> ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4) ) ) ).

% even_plus_one_iff
tff(fact_3235_even__succ__div__2,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A4)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_2
tff(fact_3236_even__succ__div__two,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_two
tff(fact_3237_odd__succ__div__two,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A4: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),one_one(B)) ) ) ) ).

% odd_succ_div_two
tff(fact_3238_neg__one__even__power,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)
         => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N) = one_one(B) ) ) ) ).

% neg_one_even_power
tff(fact_3239_neg__one__odd__power,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [N: nat] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)
         => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ) ).

% neg_one_odd_power
tff(fact_3240_odd__two__times__div__two__succ,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A4: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),one_one(B)) = A4 ) ) ) ).

% odd_two_times_div_two_succ
tff(fact_3241_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)),one_one(B)))
        <=> ( N = zero_zero(nat) ) ) ) ).

% semiring_parity_class.even_mask_iff
tff(fact_3242_even__succ__div__exp,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) ) ) ) ) ).

% even_succ_div_exp
tff(fact_3243_div__div__div__same,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [D3: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),D3),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),D3)),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),D3)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) ) ) ) ) ).

% div_div_div_same
tff(fact_3244_dvd__div__eq__cancel,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),Ca) = aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) )
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),A4)
           => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
             => ( A4 = B3 ) ) ) ) ) ).

% dvd_div_eq_cancel
tff(fact_3245_dvd__div__eq__iff,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
           => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),Ca) = aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca) )
            <=> ( A4 = B3 ) ) ) ) ) ).

% dvd_div_eq_iff
tff(fact_3246_image__add__integer__atLeastLessThan,axiom,
    ! [L: code_integer,U: code_integer] : ( aa(set(code_integer),set(code_integer),image2(code_integer,code_integer,aTP_Lamp_yt(code_integer,fun(code_integer,code_integer),L)),set_or7035219750837199246ssThan(code_integer,zero_zero(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),U),L))) = set_or7035219750837199246ssThan(code_integer,L,U) ) ).

% image_add_integer_atLeastLessThan
tff(fact_3247_dvd__0__left,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),zero_zero(B)),A4)
         => ( A4 = zero_zero(B) ) ) ) ).

% dvd_0_left
tff(fact_3248_dvd__add__right__iff,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca))
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca) ) ) ) ).

% dvd_add_right_iff
tff(fact_3249_dvd__add__left__iff,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca))
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ) ).

% dvd_add_left_iff
tff(fact_3250_dvd__add,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca)
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B3),Ca)) ) ) ) ).

% dvd_add
tff(fact_3251_dvd__triv__right,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4)) ) ).

% dvd_triv_right
tff(fact_3252_dvd__mult__right,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca)
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),Ca) ) ) ).

% dvd_mult_right
tff(fact_3253_mult__dvd__mono,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),D3)
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),D3)) ) ) ) ).

% mult_dvd_mono
tff(fact_3254_dvd__triv__left,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ).

% dvd_triv_left
tff(fact_3255_dvd__mult__left,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca)
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca) ) ) ).

% dvd_mult_left
tff(fact_3256_dvd__mult2,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ).

% dvd_mult2
tff(fact_3257_dvd__mult,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca)
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) ) ) ).

% dvd_mult
tff(fact_3258_dvd__def,axiom,
    ! [B: $tType] :
      ( dvd(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
        <=> ? [K5: B] : ( A4 = aa(B,B,aa(B,fun(B,B),times_times(B),B3),K5) ) ) ) ).

% dvd_def
tff(fact_3259_dvdI,axiom,
    ! [B: $tType] :
      ( dvd(B)
     => ! [A4: B,B3: B,K: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),times_times(B),B3),K) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4) ) ) ).

% dvdI
tff(fact_3260_dvdE,axiom,
    ! [B: $tType] :
      ( dvd(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
         => ~ ! [K2: B] : ( A4 != aa(B,B,aa(B,fun(B,B),times_times(B),B3),K2) ) ) ) ).

% dvdE
tff(fact_3261_one__dvd,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),one_one(B)),A4) ) ).

% one_dvd
tff(fact_3262_unit__imp__dvd,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4) ) ) ).

% unit_imp_dvd
tff(fact_3263_dvd__unit__imp__unit,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B)) ) ) ) ).

% dvd_unit_imp_unit
tff(fact_3264_dvd__diff,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X2),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X2),Z2)
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X2),aa(B,B,aa(B,fun(B,B),minus_minus(B),Y),Z2)) ) ) ) ).

% dvd_diff
tff(fact_3265_dvd__refl,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),A4) ) ).

% dvd_refl
tff(fact_3266_dvd__trans,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),Ca)
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca) ) ) ) ).

% dvd_trans
tff(fact_3267_dvd__if__abs__eq,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [L: B,K: B] :
          ( ( aa(B,B,abs_abs(B),L) = aa(B,B,abs_abs(B),K) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),L),K) ) ) ).

% dvd_if_abs_eq
tff(fact_3268_subset__divisors__dvd,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B,B3: B] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_yu(B,fun(B,$o),A4))),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_yu(B,fun(B,$o),B3)))
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ).

% subset_divisors_dvd
tff(fact_3269_strict__subset__divisors__dvd,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: B,B3: B] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_yu(B,fun(B,$o),A4))),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_yu(B,fun(B,$o),B3)))
        <=> ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
            & ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4) ) ) ) ).

% strict_subset_divisors_dvd
tff(fact_3270_not__is__unit__0,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),zero_zero(B)),one_one(B)) ) ).

% not_is_unit_0
tff(fact_3271_is__unit__mult__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),one_one(B))
        <=> ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
            & aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B)) ) ) ) ).

% is_unit_mult_iff
tff(fact_3272_dvd__mult__unit__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca) ) ) ) ).

% dvd_mult_unit_iff
tff(fact_3273_mult__unit__dvd__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca)
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca) ) ) ) ).

% mult_unit_dvd_iff
tff(fact_3274_dvd__mult__unit__iff_H,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca) ) ) ) ).

% dvd_mult_unit_iff'
tff(fact_3275_mult__unit__dvd__iff_H,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca)
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),Ca) ) ) ) ).

% mult_unit_dvd_iff'
tff(fact_3276_unit__mult__left__cancel,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca) )
          <=> ( B3 = Ca ) ) ) ) ).

% unit_mult_left_cancel
tff(fact_3277_unit__mult__right__cancel,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4) = aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4) )
          <=> ( B3 = Ca ) ) ) ) ).

% unit_mult_right_cancel
tff(fact_3278_dvd__div__eq__0__iff,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
         => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) = zero_zero(B) )
          <=> ( A4 = zero_zero(B) ) ) ) ) ).

% dvd_div_eq_0_iff
tff(fact_3279_div__mult__div__if__dvd,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B,D3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),D3),Ca)
           => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),D3)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),D3)) ) ) ) ) ).

% div_mult_div_if_dvd
tff(fact_3280_dvd__mult__imp__div,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3)
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)) ) ) ).

% dvd_mult_imp_div
tff(fact_3281_dvd__div__mult2__eq,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)),A4)
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),Ca) ) ) ) ).

% dvd_div_mult2_eq
tff(fact_3282_div__div__eq__right,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),Ca) ) ) ) ) ).

% div_div_eq_right
tff(fact_3283_div__mult__swap,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca) ) ) ) ).

% div_mult_swap
tff(fact_3284_dvd__div__mult,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)),A4) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4)),Ca) ) ) ) ).

% dvd_div_mult
tff(fact_3285_dvd__div__unit__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),B3))
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca) ) ) ) ).

% dvd_div_unit_iff
tff(fact_3286_div__unit__dvd__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),Ca)
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca) ) ) ) ).

% div_unit_dvd_iff
tff(fact_3287_unit__div__cancel,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4) = aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),A4) )
          <=> ( B3 = Ca ) ) ) ) ).

% unit_div_cancel
tff(fact_3288_dvd__neg__div,axiom,
    ! [B: $tType] :
      ( idom_divide(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,uminus_uminus(B),A4)),B3) = aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) ) ) ) ).

% dvd_neg_div
tff(fact_3289_dvd__div__neg,axiom,
    ! [B: $tType] :
      ( idom_divide(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,uminus_uminus(B),B3)) = aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) ) ) ) ).

% dvd_div_neg
tff(fact_3290_unity__coeff__ex,axiom,
    ! [B: $tType] :
      ( ( dvd(B)
        & semiring_0(B) )
     => ! [Pa: fun(B,$o),L: B] :
          ( ? [X3: B] : aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),times_times(B),L),X3))
        <=> ? [X3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),L),aa(B,B,aa(B,fun(B,B),plus_plus(B),X3),zero_zero(B)))
              & aa(B,$o,Pa,X3) ) ) ) ).

% unity_coeff_ex
tff(fact_3291_unit__dvdE,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ~ ( ( A4 != zero_zero(B) )
             => ! [C3: B] : ( B3 != aa(B,B,aa(B,fun(B,B),times_times(B),A4),C3) ) ) ) ) ).

% unit_dvdE
tff(fact_3292_inf__period_I4_J,axiom,
    ! [B: $tType] :
      ( ( comm_ring(B)
        & dvd(B) )
     => ! [D3: B,D2: B,T3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),D3),D2)
         => ! [X4: B,K3: B] :
              ( ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),D3),aa(B,B,aa(B,fun(B,B),plus_plus(B),X4),T3))
            <=> ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),D3),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X4),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D2))),T3)) ) ) ) ).

% inf_period(4)
tff(fact_3293_inf__period_I3_J,axiom,
    ! [B: $tType] :
      ( ( comm_ring(B)
        & dvd(B) )
     => ! [D3: B,D2: B,T3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),D3),D2)
         => ! [X4: B,K3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),D3),aa(B,B,aa(B,fun(B,B),plus_plus(B),X4),T3))
            <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),D3),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X4),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D2))),T3)) ) ) ) ).

% inf_period(3)
tff(fact_3294_dvd__div__div__eq__mult,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,Ca: B,B3: B,D3: B] :
          ( ( A4 != zero_zero(B) )
         => ( ( Ca != zero_zero(B) )
           => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
             => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),D3)
               => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4) = aa(B,B,aa(B,fun(B,B),divide_divide(B),D3),Ca) )
                <=> ( aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),D3) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
tff(fact_3295_dvd__div__iff__mult,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( ( Ca != zero_zero(B) )
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
           => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))
            <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3) ) ) ) ) ).

% dvd_div_iff_mult
tff(fact_3296_div__dvd__iff__mult,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( ( B3 != zero_zero(B) )
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
           => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),Ca)
            <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) ) ) ) ) ).

% div_dvd_iff_mult
tff(fact_3297_dvd__div__eq__mult,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
           => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4) = Ca )
            <=> ( B3 = aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4) ) ) ) ) ) ).

% dvd_div_eq_mult
tff(fact_3298_unit__div__eq__0__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) = zero_zero(B) )
          <=> ( A4 = zero_zero(B) ) ) ) ) ).

% unit_div_eq_0_iff
tff(fact_3299_unit__eq__div1,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) = Ca )
          <=> ( A4 = aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3) ) ) ) ) ).

% unit_eq_div1
tff(fact_3300_unit__eq__div2,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( ( A4 = aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),B3) )
          <=> ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3) = Ca ) ) ) ) ).

% unit_eq_div2
tff(fact_3301_div__mult__unit2,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),Ca) ) ) ) ) ).

% div_mult_unit2
tff(fact_3302_unit__div__commute,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3) ) ) ) ).

% unit_div_commute
tff(fact_3303_unit__div__mult__swap,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca) ) ) ) ).

% unit_div_mult_swap
tff(fact_3304_is__unit__div__mult2__eq,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),one_one(B))
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),Ca) ) ) ) ) ).

% is_unit_div_mult2_eq
tff(fact_3305_is__unit__power__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),N)),one_one(B))
        <=> ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
            | ( N = zero_zero(nat) ) ) ) ) ).

% is_unit_power_iff
tff(fact_3306_fact__fact__dvd__fact,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [K: nat,N: nat] : aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),semiring_char_0_fact(B,K)),semiring_char_0_fact(B,N))),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N))) ) ).

% fact_fact_dvd_fact
tff(fact_3307_even__sum__iff,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_parity(C)
     => ! [A3: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(C,$o,aa(C,fun(C,$o),dvd_dvd(C),aa(num,C,numeral_numeral(C),aa(num,num,bit0,one2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),A3))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(set(B),nat,finite_card(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_yv(set(B),fun(fun(B,C),fun(B,$o)),A3),F2)))) ) ) ) ).

% even_sum_iff
tff(fact_3308_is__unitE,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ~ ( ( A4 != zero_zero(B) )
             => ! [B4: B] :
                  ( ( B4 != zero_zero(B) )
                 => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B4),one_one(B))
                   => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4) = B4 )
                     => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),B4) = A4 )
                       => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),B4) = one_one(B) )
                         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),A4) != aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B4) ) ) ) ) ) ) ) ) ) ).

% is_unitE
tff(fact_3309_is__unit__div__mult__cancel__left,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),B3) ) ) ) ) ).

% is_unit_div_mult_cancel_left
tff(fact_3310_is__unit__div__mult__cancel__right,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),B3) ) ) ) ) ).

% is_unit_div_mult_cancel_right
tff(fact_3311_evenE,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
         => ~ ! [B4: B] : ( A4 != aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B4) ) ) ) ).

% evenE
tff(fact_3312_odd__one,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),one_one(B)) ) ).

% odd_one
tff(fact_3313_dvd__power__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [X2: B,M2: nat,N: nat] :
          ( ( X2 != zero_zero(B) )
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N))
          <=> ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X2),one_one(B))
              | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N) ) ) ) ) ).

% dvd_power_iff
tff(fact_3314_dvd__power,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [N: nat,X2: B] :
          ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
            | ( X2 = one_one(B) ) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X2),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N)) ) ) ).

% dvd_power
tff(fact_3315_choose__dvd,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),semiring_char_0_fact(B,K)),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))),semiring_char_0_fact(B,N)) ) ) ).

% choose_dvd
tff(fact_3316_even__two__times__div__two,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) = A4 ) ) ) ).

% even_two_times_div_two
tff(fact_3317_odd__card__imp__not__empty,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(set(B),nat,finite_card(B),A3))
     => ( A3 != bot_bot(set(B)) ) ) ).

% odd_card_imp_not_empty
tff(fact_3318_dvd__partition,axiom,
    ! [B: $tType,C2: set(set(B)),K: nat] :
      ( aa(set(B),$o,finite_finite2(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C2))
     => ( ! [X: set(B)] :
            ( aa(set(set(B)),$o,member(set(B),X),C2)
           => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(set(B),nat,finite_card(B),X)) )
       => ( ! [X: set(B)] :
              ( aa(set(set(B)),$o,member(set(B),X),C2)
             => ! [Xa4: set(B)] :
                  ( aa(set(set(B)),$o,member(set(B),Xa4),C2)
                 => ( ( X != Xa4 )
                   => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X),Xa4) = bot_bot(set(B)) ) ) ) )
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(set(B),nat,finite_card(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C2))) ) ) ) ).

% dvd_partition
tff(fact_3319_sum__div__partition,axiom,
    ! [B: $tType,C: $tType] :
      ( euclid4440199948858584721cancel(C)
     => ! [A3: set(B),F2: fun(B,C),B3: C] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(C,C,aa(C,fun(C,C),divide_divide(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),A3)),B3) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(C,fun(B,C),aTP_Lamp_yw(fun(B,C),fun(C,fun(B,C)),F2),B3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aTP_Lamp_yx(fun(B,C),fun(C,fun(B,$o)),F2),B3))))),aa(C,C,aa(C,fun(C,C),divide_divide(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aTP_Lamp_yy(fun(B,C),fun(C,fun(B,$o)),F2),B3))))),B3)) ) ) ) ).

% sum_div_partition
tff(fact_3320_oddE,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A4: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
         => ~ ! [B4: B] : ( A4 != aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B4)),one_one(B)) ) ) ) ).

% oddE
tff(fact_3321_minus__one__power__iff,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [N: nat] :
          ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N),one_one(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ) ).

% minus_one_power_iff
tff(fact_3322_even__mask__div__iff_H,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [M2: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2)),one_one(B))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N) ) ) ).

% even_mask_div_iff'
tff(fact_3323_even__mask__div__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [M2: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2)),one_one(B))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)))
        <=> ( ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N) = zero_zero(B) )
            | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N) ) ) ) ).

% even_mask_div_iff
tff(fact_3324_even__mult__exp__div__exp__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A4: B,M2: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M2)
            | ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N) = zero_zero(B) )
            | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
              & aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2)))) ) ) ) ) ).

% even_mult_exp_div_exp_iff
tff(fact_3325_round__def,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] : ( archimedean_round(B,X2) = archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))) ) ) ).

% round_def
tff(fact_3326_of__int__round__le,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),archimedean_round(B,X2))),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))) ) ).

% of_int_round_le
tff(fact_3327_of__int__round__ge,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),aa(int,B,ring_1_of_int(B),archimedean_round(B,X2))) ) ).

% of_int_round_ge
tff(fact_3328_of__int__round__gt,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),aa(int,B,ring_1_of_int(B),archimedean_round(B,X2))) ) ).

% of_int_round_gt
tff(fact_3329_of__int__round__abs__le,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),archimedean_round(B,X2))),X2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) ) ).

% of_int_round_abs_le
tff(fact_3330_round__unique_H,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),aa(int,B,ring_1_of_int(B),N)))),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))
         => ( archimedean_round(B,X2) = N ) ) ) ).

% round_unique'
tff(fact_3331_flip__bit__0,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B] : ( bit_se8732182000553998342ip_bit(B,zero_zero(nat),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa($o,B,zero_neq_one_of_bool(B),aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))) ) ) ).

% flip_bit_0
tff(fact_3332_finite__divisors__nat,axiom,
    ! [M2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M2)
     => aa(set(nat),$o,finite_finite2(nat),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_yz(nat,fun(nat,$o),M2))) ) ).

% finite_divisors_nat
tff(fact_3333_round__altdef,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( archimedean_round(B,X2)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),archimedean_frac(B,X2)),archimedean_ceiling(B,X2),archim6421214686448440834_floor(B,X2)) ) ) ).

% round_altdef
tff(fact_3334_divmod__algorithm__code_I5_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [M2: num,N: num] : ( unique8689654367752047608divmod(B,aa(num,num,bit0,M2),aa(num,num,bit0,N)) = aa(product_prod(B,B),product_prod(B,B),aa(fun(B,fun(B,product_prod(B,B))),fun(product_prod(B,B),product_prod(B,B)),product_case_prod(B,B,product_prod(B,B)),aTP_Lamp_za(B,fun(B,product_prod(B,B)))),unique8689654367752047608divmod(B,M2,N)) ) ) ).

% divmod_algorithm_code(5)
tff(fact_3335_even__succ__mod__exp,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),modulo_modulo(B,A4,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N))) ) ) ) ) ).

% even_succ_mod_exp
tff(fact_3336_mod__self,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [A4: B] : ( modulo_modulo(B,A4,A4) = zero_zero(B) ) ) ).

% mod_self
tff(fact_3337_mod__by__0,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [A4: B] : ( modulo_modulo(B,A4,zero_zero(B)) = A4 ) ) ).

% mod_by_0
tff(fact_3338_mod__0,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [A4: B] : ( modulo_modulo(B,zero_zero(B),A4) = zero_zero(B) ) ) ).

% mod_0
tff(fact_3339_mod__mult__self2__is__0,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A4: B,B3: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3),B3) = zero_zero(B) ) ) ).

% mod_mult_self2_is_0
tff(fact_3340_mod__mult__self1__is__0,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [B3: B,A4: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4),B3) = zero_zero(B) ) ) ).

% mod_mult_self1_is_0
tff(fact_3341_mod__by__1,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [A4: B] : ( modulo_modulo(B,A4,one_one(B)) = zero_zero(B) ) ) ).

% mod_by_1
tff(fact_3342_bits__mod__by__1,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A4: B] : ( modulo_modulo(B,A4,one_one(B)) = zero_zero(B) ) ) ).

% bits_mod_by_1
tff(fact_3343_mod__mult__self4,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [B3: B,Ca: B,A4: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)),A4),B3) = modulo_modulo(B,A4,B3) ) ) ).

% mod_mult_self4
tff(fact_3344_mod__mult__self3,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ca: B,B3: B,A4: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)),A4),B3) = modulo_modulo(B,A4,B3) ) ) ).

% mod_mult_self3
tff(fact_3345_mod__mult__self2,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A4: B,B3: B,Ca: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)),B3) = modulo_modulo(B,A4,B3) ) ) ).

% mod_mult_self2
tff(fact_3346_mod__mult__self1,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A4: B,Ca: B,B3: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)),B3) = modulo_modulo(B,A4,B3) ) ) ).

% mod_mult_self1
tff(fact_3347_dvd__imp__mod__0,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => ( modulo_modulo(B,B3,A4) = zero_zero(B) ) ) ) ).

% dvd_imp_mod_0
tff(fact_3348_mod__minus1__right,axiom,
    ! [B: $tType] :
      ( euclid8851590272496341667cancel(B)
     => ! [A4: B] : ( modulo_modulo(B,A4,aa(B,B,uminus_uminus(B),one_one(B))) = zero_zero(B) ) ) ).

% mod_minus1_right
tff(fact_3349_bits__one__mod__two__eq__one,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ( modulo_modulo(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ).

% bits_one_mod_two_eq_one
tff(fact_3350_one__mod__two__eq__one,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ( modulo_modulo(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ).

% one_mod_two_eq_one
tff(fact_3351_not__mod__2__eq__1__eq__0,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A4: B] :
          ( ( modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) != one_one(B) )
        <=> ( modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = zero_zero(B) ) ) ) ).

% not_mod_2_eq_1_eq_0
tff(fact_3352_not__mod__2__eq__0__eq__1,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A4: B] :
          ( ( modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) != zero_zero(B) )
        <=> ( modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ) ).

% not_mod_2_eq_0_eq_1
tff(fact_3353_bits__minus__1__mod__2__eq,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ( modulo_modulo(B,aa(B,B,uminus_uminus(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ).

% bits_minus_1_mod_2_eq
tff(fact_3354_minus__1__mod__2__eq,axiom,
    ! [B: $tType] :
      ( euclid8789492081693882211th_nat(B)
     => ( modulo_modulo(B,aa(B,B,uminus_uminus(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ).

% minus_1_mod_2_eq
tff(fact_3355_one__div__numeral,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),N)) = aa(product_prod(B,B),B,product_fst(B,B),unique8689654367752047608divmod(B,one2,N)) ) ) ).

% one_div_numeral
tff(fact_3356_one__mod__numeral,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [N: num] : ( modulo_modulo(B,one_one(B),aa(num,B,numeral_numeral(B),N)) = aa(product_prod(B,B),B,product_snd(B,B),unique8689654367752047608divmod(B,one2,N)) ) ) ).

% one_mod_numeral
tff(fact_3357_one__mod__2__pow__eq,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat] : ( modulo_modulo(B,one_one(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% one_mod_2_pow_eq
tff(fact_3358_mod__mult__right__eq,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A4: B,B3: B,Ca: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),modulo_modulo(B,B3,Ca)),Ca) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3),Ca) ) ) ).

% mod_mult_right_eq
tff(fact_3359_mod__mult__left__eq,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A4: B,Ca: B,B3: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),modulo_modulo(B,A4,Ca)),B3),Ca) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3),Ca) ) ) ).

% mod_mult_left_eq
tff(fact_3360_mult__mod__right,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ca: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),Ca),modulo_modulo(B,A4,B3)) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) ) ) ).

% mult_mod_right
tff(fact_3361_mod__mult__mult2,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A4: B,Ca: B,B3: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),times_times(B),modulo_modulo(B,A4,B3)),Ca) ) ) ).

% mod_mult_mult2
tff(fact_3362_mod__mult__cong,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A4: B,Ca: B,A7: B,B3: B,B6: B] :
          ( ( modulo_modulo(B,A4,Ca) = modulo_modulo(B,A7,Ca) )
         => ( ( modulo_modulo(B,B3,Ca) = modulo_modulo(B,B6,Ca) )
           => ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3),Ca) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A7),B6),Ca) ) ) ) ) ).

% mod_mult_cong
tff(fact_3363_mod__mult__eq,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A4: B,Ca: B,B3: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),modulo_modulo(B,A4,Ca)),modulo_modulo(B,B3,Ca)),Ca) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3),Ca) ) ) ).

% mod_mult_eq
tff(fact_3364_dvd__mod__iff,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),modulo_modulo(B,A4,B3))
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),A4) ) ) ) ).

% dvd_mod_iff
tff(fact_3365_dvd__mod__imp__dvd,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),modulo_modulo(B,A4,B3))
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),A4) ) ) ) ).

% dvd_mod_imp_dvd
tff(fact_3366_nat__mod__as__int,axiom,
    ! [X4: nat,Xa3: nat] : ( modulo_modulo(nat,X4,Xa3) = aa(int,nat,nat2,modulo_modulo(int,aa(nat,int,semiring_1_of_nat(int),X4),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_mod_as_int
tff(fact_3367_mod__sum__eq,axiom,
    ! [C: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [F2: fun(C,B),A4: B,A3: set(C)] : ( modulo_modulo(B,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(B,fun(C,B),aTP_Lamp_zb(fun(C,B),fun(B,fun(C,B)),F2),A4)),A3),A4) = modulo_modulo(B,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),F2),A3),A4) ) ) ).

% mod_sum_eq
tff(fact_3368_mod__prod__eq,axiom,
    ! [C: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [F2: fun(C,B),A4: B,A3: set(C)] : ( modulo_modulo(B,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aa(B,fun(C,B),aTP_Lamp_zb(fun(C,B),fun(B,fun(C,B)),F2),A4)),A3),A4) = modulo_modulo(B,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),F2),A3),A4) ) ) ).

% mod_prod_eq
tff(fact_3369_finite__divisors__int,axiom,
    ! [I2: int] :
      ( ( I2 != zero_zero(int) )
     => aa(set(int),$o,finite_finite2(int),aa(fun(int,$o),set(int),collect(int),aTP_Lamp_zc(int,fun(int,$o),I2))) ) ).

% finite_divisors_int
tff(fact_3370_mod__eqE,axiom,
    ! [B: $tType] :
      ( euclid8851590272496341667cancel(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( ( modulo_modulo(B,A4,Ca) = modulo_modulo(B,B3,Ca) )
         => ~ ! [D4: B] : ( B3 != aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),D4)) ) ) ) ).

% mod_eqE
tff(fact_3371_mod__eq__0__iff__dvd,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [A4: B,B3: B] :
          ( ( modulo_modulo(B,A4,B3) = zero_zero(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4) ) ) ).

% mod_eq_0_iff_dvd
tff(fact_3372_dvd__eq__mod__eq__0,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
        <=> ( modulo_modulo(B,B3,A4) = zero_zero(B) ) ) ) ).

% dvd_eq_mod_eq_0
tff(fact_3373_mod__0__imp__dvd,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A4: B,B3: B] :
          ( ( modulo_modulo(B,A4,B3) = zero_zero(B) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4) ) ) ).

% mod_0_imp_dvd
tff(fact_3374_dvd__minus__mod,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [B3: B,A4: B] : aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),modulo_modulo(B,A4,B3))) ) ).

% dvd_minus_mod
tff(fact_3375_frac__lt__1,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),archimedean_frac(B,X2)),one_one(B)) ) ).

% frac_lt_1
tff(fact_3376_frac__1__eq,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] : ( archimedean_frac(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),one_one(B))) = archimedean_frac(B,X2) ) ) ).

% frac_1_eq
tff(fact_3377_unit__imp__mod__eq__0,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( modulo_modulo(B,A4,B3) = zero_zero(B) ) ) ) ).

% unit_imp_mod_eq_0
tff(fact_3378_div__mult1__eq,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),Ca))),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),modulo_modulo(B,B3,Ca))),Ca)) ) ) ).

% div_mult1_eq
tff(fact_3379_cancel__div__mod__rules_I2_J,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [B3: B,A4: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3))),modulo_modulo(B,A4,B3))),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca) ) ) ).

% cancel_div_mod_rules(2)
tff(fact_3380_cancel__div__mod__rules_I1_J,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),B3)),modulo_modulo(B,A4,B3))),Ca) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ca) ) ) ).

% cancel_div_mod_rules(1)
tff(fact_3381_mod__div__decomp,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A4: B,B3: B] : ( A4 = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),B3)),modulo_modulo(B,A4,B3)) ) ) ).

% mod_div_decomp
tff(fact_3382_div__mult__mod__eq,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),B3)),modulo_modulo(B,A4,B3)) = A4 ) ) ).

% div_mult_mod_eq
tff(fact_3383_mod__div__mult__eq,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A4,B3)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),B3)) = A4 ) ) ).

% mod_div_mult_eq
tff(fact_3384_mod__mult__div__eq,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A4,B3)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3))) = A4 ) ) ).

% mod_mult_div_eq
tff(fact_3385_mult__div__mod__eq,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [B3: B,A4: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3))),modulo_modulo(B,A4,B3)) = A4 ) ) ).

% mult_div_mod_eq
tff(fact_3386_minus__div__mult__eq__mod,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),B3)) = modulo_modulo(B,A4,B3) ) ) ).

% minus_div_mult_eq_mod
tff(fact_3387_minus__mod__eq__div__mult,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),modulo_modulo(B,A4,B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),B3) ) ) ).

% minus_mod_eq_div_mult
tff(fact_3388_minus__mod__eq__mult__div,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),modulo_modulo(B,A4,B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) ) ) ).

% minus_mod_eq_mult_div
tff(fact_3389_minus__mult__div__eq__mod,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3))) = modulo_modulo(B,A4,B3) ) ) ).

% minus_mult_div_eq_mod
tff(fact_3390_mod__mult2__eq_H,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A4: B,M2: nat,N: nat] : ( modulo_modulo(B,A4,aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),M2)),aa(nat,B,semiring_1_of_nat(B),N))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),M2)),modulo_modulo(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(nat,B,semiring_1_of_nat(B),M2)),aa(nat,B,semiring_1_of_nat(B),N)))),modulo_modulo(B,A4,aa(nat,B,semiring_1_of_nat(B),M2))) ) ) ).

% mod_mult2_eq'
tff(fact_3391_flip__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A4: B] : ( bit_se8732182000553998342ip_bit(B,aa(nat,nat,suc,N),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_se8732182000553998342ip_bit(B,N,aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))))) ) ) ).

% flip_bit_Suc
tff(fact_3392_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ca)
         => ( modulo_modulo(B,A4,aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),modulo_modulo(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3),Ca))),modulo_modulo(B,A4,B3)) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
tff(fact_3393_odd__iff__mod__2__eq__one,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A4: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
        <=> ( modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ) ).

% odd_iff_mod_2_eq_one
tff(fact_3394_frac__eq,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( ( archimedean_frac(B,X2) = X2 )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),one_one(B)) ) ) ) ).

% frac_eq
tff(fact_3395_frac__add,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,Y: B] :
          ( archimedean_frac(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),archimedean_frac(B,X2)),archimedean_frac(B,Y))),one_one(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),archimedean_frac(B,X2)),archimedean_frac(B,Y)),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),archimedean_frac(B,X2)),archimedean_frac(B,Y))),one_one(B))) ) ) ).

% frac_add
tff(fact_3396_divmod__digit__0_I2_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),modulo_modulo(B,A4,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B3))),B3)
           => ( modulo_modulo(B,A4,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B3)) = modulo_modulo(B,A4,B3) ) ) ) ) ).

% divmod_digit_0(2)
tff(fact_3397_parity__cases,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A4: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
           => ( modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) != zero_zero(B) ) )
         => ~ ( ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
             => ( modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) != one_one(B) ) ) ) ) ).

% parity_cases
tff(fact_3398_mod2__eq__if,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A4: B] :
          ( modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))
          = $ite(aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4),zero_zero(B),one_one(B)) ) ) ).

% mod2_eq_if
tff(fact_3399_range__mod,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(set(nat),set(nat),image2(nat,nat,aTP_Lamp_zd(nat,fun(nat,nat),N)),top_top(set(nat))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),N) ) ) ).

% range_mod
tff(fact_3400_divmod__digit__0_I1_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),modulo_modulo(B,A4,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B3))),B3)
           => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B3))) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) ) ) ) ) ).

% divmod_digit_0(1)
tff(fact_3401_frac__neg,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B] :
          ( archimedean_frac(B,aa(B,B,uminus_uminus(B),X2))
          = $ite(aa(set(B),$o,member(B,X2),ring_1_Ints(B)),zero_zero(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),archimedean_frac(B,X2))) ) ) ).

% frac_neg
tff(fact_3402_mult__exp__mod__exp__eq,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [M2: nat,N: nat,A4: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),modulo_modulo(B,A4,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2)))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2)) ) ) ) ).

% mult_exp_mod_exp_eq
tff(fact_3403_exp__mod__exp,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [M2: nat,N: nat] : ( modulo_modulo(B,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2)) ) ) ).

% exp_mod_exp
tff(fact_3404_division__decomp,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
         => ? [B11: B,C6: B] :
              ( ( A4 = aa(B,B,aa(B,fun(B,B),times_times(B),B11),C6) )
              & aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B11),B3)
              & aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),C6),Ca) ) ) ) ).

% division_decomp
tff(fact_3405_dvd__productE,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [P3: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),P3),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
         => ~ ! [X: B,Y2: B] :
                ( ( P3 = aa(B,B,aa(B,fun(B,B),times_times(B),X),Y2) )
               => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X),A4)
                 => ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Y2),B3) ) ) ) ) ).

% dvd_productE
tff(fact_3406_mod__double__modulus,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [M2: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),M2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X2)
           => ( ( modulo_modulo(B,X2,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2)) = modulo_modulo(B,X2,M2) )
              | ( modulo_modulo(B,X2,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,X2,M2)),M2) ) ) ) ) ) ).

% mod_double_modulus
tff(fact_3407_divmod__digit__1_I2_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),modulo_modulo(B,A4,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B3)))
             => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),modulo_modulo(B,A4,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B3))),B3) = modulo_modulo(B,A4,B3) ) ) ) ) ) ).

% divmod_digit_1(2)
tff(fact_3408_frac__unique__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,A4: B] :
          ( ( archimedean_frac(B,X2) = A4 )
        <=> ( aa(set(B),$o,member(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),A4)),ring_1_Ints(B))
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),one_one(B)) ) ) ) ).

% frac_unique_iff
tff(fact_3409_unset__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A4: B] : ( bit_se2638667681897837118et_bit(B,aa(nat,nat,suc,N),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_se2638667681897837118et_bit(B,N,aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))))) ) ) ).

% unset_bit_Suc
tff(fact_3410_set__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A4: B] : ( bit_se5668285175392031749et_bit(B,aa(nat,nat,suc,N),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_se5668285175392031749et_bit(B,N,aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))))) ) ) ).

% set_bit_Suc
tff(fact_3411_floor__add,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X2: B,Y: B] :
          ( archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),archimedean_frac(B,X2)),archimedean_frac(B,Y))),one_one(B)),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(B,X2)),archim6421214686448440834_floor(B,Y)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(B,X2)),archim6421214686448440834_floor(B,Y))),one_one(int))) ) ) ).

% floor_add
tff(fact_3412_divmod__digit__1_I1_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),B3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),modulo_modulo(B,A4,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B3)))
             => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B3)))),one_one(B)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) ) ) ) ) ) ).

% divmod_digit_1(1)
tff(fact_3413_signed__take__bit__rec,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat,A4: B] :
          ( bit_ri4674362597316999326ke_bit(B,N,A4)
          = $ite(N = zero_zero(nat),aa(B,B,uminus_uminus(B),modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_ri4674362597316999326ke_bit(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))))) ) ) ).

% signed_take_bit_rec
tff(fact_3414_integer__of__int__code,axiom,
    ! [K: int] :
      ( aa(int,code_integer,code_integer_of_int,K)
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)),
          aa(code_integer,code_integer,uminus_uminus(code_integer),aa(int,code_integer,code_integer_of_int,aa(int,int,uminus_uminus(int),K))),
          $ite(
            K = zero_zero(int),
            zero_zero(code_integer),
            $let(
              l: code_integer,
              l := aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),aa(int,code_integer,code_integer_of_int,aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))),
              $ite(modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) = zero_zero(int),l,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),l),one_one(code_integer))) ) ) ) ) ).

% integer_of_int_code
tff(fact_3415_divmod__algorithm__code_I6_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [M2: num,N: num] : ( unique8689654367752047608divmod(B,aa(num,num,bit1,M2),aa(num,num,bit0,N)) = aa(product_prod(B,B),product_prod(B,B),aa(fun(B,fun(B,product_prod(B,B))),fun(product_prod(B,B),product_prod(B,B)),product_case_prod(B,B,product_prod(B,B)),aTP_Lamp_ze(B,fun(B,product_prod(B,B)))),unique8689654367752047608divmod(B,M2,N)) ) ) ).

% divmod_algorithm_code(6)
tff(fact_3416_and__int_Osimps,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
      = $ite(
          ( aa(set(int),$o,member(int,K),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
          & aa(set(int),$o,member(int,L),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
          aa(int,int,uminus_uminus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
            & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
          aa(int,int,
            aa(int,fun(int,int),plus_plus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
            aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ).

% and_int.simps
tff(fact_3417_and__int_Oelims,axiom,
    ! [X2: int,Xa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Xa) = Y )
     => ( Y
        = $ite(
            ( aa(set(int),$o,member(int,X2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
            & aa(set(int),$o,member(int,Xa),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
            aa(int,int,uminus_uminus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))),
            aa(int,int,
              aa(int,fun(int,int),plus_plus(int),
                aa($o,int,zero_neq_one_of_bool(int),
                  ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)
                & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))),
              aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ).

% and_int.elims
tff(fact_3418_bit_Oconj__one__right,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),X2),aa(B,B,uminus_uminus(B),one_one(B))) = X2 ) ) ).

% bit.conj_one_right
tff(fact_3419_and_Oright__neutral,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A4),aa(B,B,uminus_uminus(B),one_one(B))) = A4 ) ) ).

% and.right_neutral
tff(fact_3420_and_Oleft__neutral,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(B,B,uminus_uminus(B),one_one(B))),A4) = A4 ) ) ).

% and.left_neutral
tff(fact_3421_signed__take__bit__of__minus__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] : ( bit_ri4674362597316999326ke_bit(B,N,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% signed_take_bit_of_minus_1
tff(fact_3422_signed__take__bit__Suc__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] : ( bit_ri4674362597316999326ke_bit(B,aa(nat,nat,suc,N),one_one(B)) = one_one(B) ) ) ).

% signed_take_bit_Suc_1
tff(fact_3423_signed__take__bit__numeral__of__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [K: num] : ( bit_ri4674362597316999326ke_bit(B,aa(num,nat,numeral_numeral(nat),K),one_one(B)) = one_one(B) ) ) ).

% signed_take_bit_numeral_of_1
tff(fact_3424_and__numerals_I2_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = one_one(B) ) ) ).

% and_numerals(2)
tff(fact_3425_and__numerals_I8_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2))),one_one(B)) = one_one(B) ) ) ).

% and_numerals(8)
tff(fact_3426_and__numerals_I5_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X2))),one_one(B)) = zero_zero(B) ) ) ).

% and_numerals(5)
tff(fact_3427_and__numerals_I1_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = zero_zero(B) ) ) ).

% and_numerals(1)
tff(fact_3428_and__numerals_I3_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% and_numerals(3)
tff(fact_3429_dbl__inc__simps_I3_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_inc(B,one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,one2)) ) ) ).

% dbl_inc_simps(3)
tff(fact_3430_and__numerals_I4_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% and_numerals(4)
tff(fact_3431_and__numerals_I6_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% and_numerals(6)
tff(fact_3432_dbl__dec__simps_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_dec(B,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,one2))) ) ) ).

% dbl_dec_simps(4)
tff(fact_3433_and__numerals_I7_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% and_numerals(7)
tff(fact_3434_and__eq__minus__1__iff,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A4),B3) = aa(B,B,uminus_uminus(B),one_one(B)) )
        <=> ( ( A4 = aa(B,B,uminus_uminus(B),one_one(B)) )
            & ( B3 = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ) ) ).

% and_eq_minus_1_iff
tff(fact_3435_and_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => comm_monoid(B,bit_se5824344872417868541ns_and(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% and.comm_monoid_axioms
tff(fact_3436_numeral__Bit1,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [N: num] : ( aa(num,B,numeral_numeral(B),aa(num,num,bit1,N)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),N)),aa(num,B,numeral_numeral(B),N))),one_one(B)) ) ) ).

% numeral_Bit1
tff(fact_3437_and_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => monoid(B,bit_se5824344872417868541ns_and(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% and.monoid_axioms
tff(fact_3438_numeral__code_I3_J,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [N: num] :
          ( aa(num,B,numeral_numeral(B),aa(num,num,bit1,N))
          = $let(
              m: B,
              m := aa(num,B,numeral_numeral(B),N),
              aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),m),m)),one_one(B)) ) ) ) ).

% numeral_code(3)
tff(fact_3439_power__numeral__odd,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [Z2: B,W2: num] :
          ( aa(nat,B,aa(B,fun(nat,B),power_power(B),Z2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,W2)))
          = $let(
              w: B,
              w := aa(nat,B,aa(B,fun(nat,B),power_power(B),Z2),aa(num,nat,numeral_numeral(nat),W2)),
              aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),w)),w) ) ) ) ).

% power_numeral_odd
tff(fact_3440_power3__eq__cube,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A4: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),A4)),A4) ) ) ).

% power3_eq_cube
tff(fact_3441_and__one__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A4),one_one(B)) = modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% and_one_eq
tff(fact_3442_one__and__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),one_one(B)),A4) = modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% one_and_eq
tff(fact_3443_card__3__iff,axiom,
    ! [B: $tType,S: set(B)] :
      ( ( aa(set(B),nat,finite_card(B),S) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) )
    <=> ? [X3: B,Y4: B,Z5: B] :
          ( ( S = aa(set(B),set(B),insert(B,X3),aa(set(B),set(B),insert(B,Y4),aa(set(B),set(B),insert(B,Z5),bot_bot(set(B))))) )
          & ( X3 != Y4 )
          & ( Y4 != Z5 )
          & ( X3 != Z5 ) ) ) ).

% card_3_iff
tff(fact_3444_signed__take__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat,A4: B] : ( bit_ri4674362597316999326ke_bit(B,aa(nat,nat,suc,N),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_ri4674362597316999326ke_bit(B,N,aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))))) ) ) ).

% signed_take_bit_Suc
tff(fact_3445_and__int_Opelims,axiom,
    ! [X2: int,Xa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Xa) = Y )
     => ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X2),Xa))
       => ~ ( ( Y
              = $ite(
                  ( aa(set(int),$o,member(int,X2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
                  & aa(set(int),$o,member(int,Xa),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
                  aa(int,int,uminus_uminus(int),
                    aa($o,int,zero_neq_one_of_bool(int),
                      ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)
                    & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))),
                  aa(int,int,
                    aa(int,fun(int,int),plus_plus(int),
                      aa($o,int,zero_neq_one_of_bool(int),
                        ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)
                      & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))),
                    aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) )
           => ~ aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X2),Xa)) ) ) ) ).

% and_int.pelims
tff(fact_3446_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),K),L))
     => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
        = $ite(
            ( aa(set(int),$o,member(int,K),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
            & aa(set(int),$o,member(int,L),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
            aa(int,int,uminus_uminus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
            aa(int,int,
              aa(int,fun(int,int),plus_plus(int),
                aa($o,int,zero_neq_one_of_bool(int),
                  ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
                & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
              aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ).

% and_int.psimps
tff(fact_3447_take__bit__rec,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A4: B] :
          ( bit_se2584673776208193580ke_bit(B,N,A4)
          = $ite(N = zero_zero(nat),zero_zero(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))) ) ) ).

% take_bit_rec
tff(fact_3448_push__bit__numeral__minus__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: num] : ( bit_se4730199178511100633sh_bit(B,aa(num,nat,numeral_numeral(nat),N),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),N))) ) ) ).

% push_bit_numeral_minus_1
tff(fact_3449_num__of__integer__code,axiom,
    ! [K: code_integer] :
      ( code_num_of_integer(K)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),one_one(code_integer)),one2,aa(product_prod(code_integer,code_integer),num,aa(fun(code_integer,fun(code_integer,num)),fun(product_prod(code_integer,code_integer),num),product_case_prod(code_integer,code_integer,num),aTP_Lamp_zf(code_integer,fun(code_integer,num))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ).

% num_of_integer_code
tff(fact_3450_take__bit__Suc__1,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),one_one(B)) = one_one(B) ) ) ).

% take_bit_Suc_1
tff(fact_3451_take__bit__numeral__1,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [L: num] : ( bit_se2584673776208193580ke_bit(B,aa(num,nat,numeral_numeral(nat),L),one_one(B)) = one_one(B) ) ) ).

% take_bit_numeral_1
tff(fact_3452_take__bit__of__1__eq__0__iff,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit(B,N,one_one(B)) = zero_zero(B) )
        <=> ( N = zero_zero(nat) ) ) ) ).

% take_bit_of_1_eq_0_iff
tff(fact_3453_take__bit__of__1,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(B,N,one_one(B)) = aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% take_bit_of_1
tff(fact_3454_push__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A4: B] : ( bit_se4730199178511100633sh_bit(B,aa(nat,nat,suc,N),A4) = bit_se4730199178511100633sh_bit(B,N,aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) ) ) ).

% push_bit_Suc
tff(fact_3455_push__bit__of__1,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ( bit_se4730199178511100633sh_bit(B,N,one_one(B)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N) ) ) ).

% push_bit_of_1
tff(fact_3456_take__bit__of__exp,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [M2: nat,N: nat] : ( bit_se2584673776208193580ke_bit(B,M2,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M2))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) ) ) ).

% take_bit_of_exp
tff(fact_3457_take__bit__of__2,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(B,N,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% take_bit_of_2
tff(fact_3458_push__bit__double,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A4: B] : ( bit_se4730199178511100633sh_bit(B,N,aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) = aa(B,B,aa(B,fun(B,B),times_times(B),bit_se4730199178511100633sh_bit(B,N,A4)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% push_bit_double
tff(fact_3459_take__bit__Suc__bit0,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: nat,K: num] : ( bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),aa(num,B,numeral_numeral(B),aa(num,num,bit0,K))) = aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,N,aa(num,B,numeral_numeral(B),K))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% take_bit_Suc_bit0
tff(fact_3460_push__bit__eq__mult,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A4: B] : ( bit_se4730199178511100633sh_bit(B,N,A4) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) ) ) ).

% push_bit_eq_mult
tff(fact_3461_take__bit__Suc__bit1,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: nat,K: num] : ( bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),aa(num,B,numeral_numeral(B),aa(num,num,bit1,K))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,N,aa(num,B,numeral_numeral(B),K))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),one_one(B)) ) ) ).

% take_bit_Suc_bit1
tff(fact_3462_take__bit__Suc__minus__1__eq,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,suc,N))),one_one(B)) ) ) ).

% take_bit_Suc_minus_1_eq
tff(fact_3463_take__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A4: B] : ( bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,N,aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),modulo_modulo(B,A4,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) ) ) ).

% take_bit_Suc
tff(fact_3464_take__bit__numeral__minus__1__eq,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [K: num] : ( bit_se2584673776208193580ke_bit(B,aa(num,nat,numeral_numeral(nat),K),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),K))),one_one(B)) ) ) ).

% take_bit_numeral_minus_1_eq
tff(fact_3465_and__int_Opinduct,axiom,
    ! [A0: int,A13: int,Pa: fun(int,fun(int,$o))] :
      ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A0),A13))
     => ( ! [K2: int,L2: int] :
            ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),K2),L2))
           => ( ( ~ ( aa(set(int),$o,member(int,K2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
                    & aa(set(int),$o,member(int,L2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) )
               => aa(int,$o,aa(int,fun(int,$o),Pa,aa(int,int,aa(int,fun(int,int),divide_divide(int),K2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))) )
             => aa(int,$o,aa(int,fun(int,$o),Pa,K2),L2) ) )
       => aa(int,$o,aa(int,fun(int,$o),Pa,A0),A13) ) ) ).

% and_int.pinduct
tff(fact_3466_stable__imp__take__bit__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B,N: nat] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = A4 )
         => ( bit_se2584673776208193580ke_bit(B,N,A4)
            = $ite(aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4),zero_zero(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)),one_one(B))) ) ) ) ).

% stable_imp_take_bit_eq
tff(fact_3467_nat__of__integer__code,axiom,
    ! [K: code_integer] :
      ( code_nat_of_integer(K)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),zero_zero(code_integer)),zero_zero(nat),aa(product_prod(code_integer,code_integer),nat,aa(fun(code_integer,fun(code_integer,nat)),fun(product_prod(code_integer,code_integer),nat),product_case_prod(code_integer,code_integer,nat),aTP_Lamp_zg(code_integer,fun(code_integer,nat))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ).

% nat_of_integer_code
tff(fact_3468_divmod__integer__code,axiom,
    ! [K: code_integer,L: code_integer] :
      ( code_divmod_integer(K,L)
      = $ite(
          K = zero_zero(code_integer),
          aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)),
          $ite(
            aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),L),
            $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),K),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zh(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L))),
            $ite(
              L = zero_zero(code_integer),
              aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),K),
              aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_apsnd(code_integer,code_integer,code_integer),uminus_uminus(code_integer)),$ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zi(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ) ).

% divmod_integer_code
tff(fact_3469_int__of__integer__code,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,int,code_int_of_integer,K)
      = $ite(
          aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),
          aa(int,int,uminus_uminus(int),aa(code_integer,int,code_int_of_integer,aa(code_integer,code_integer,uminus_uminus(code_integer),K))),
          $ite(K = zero_zero(code_integer),zero_zero(int),aa(product_prod(code_integer,code_integer),int,aa(fun(code_integer,fun(code_integer,int)),fun(product_prod(code_integer,code_integer),int),product_case_prod(code_integer,code_integer,int),aTP_Lamp_zj(code_integer,fun(code_integer,int))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ) ).

% int_of_integer_code
tff(fact_3470_take__bit__numeral__bit1,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [L: num,K: num] : ( bit_se2584673776208193580ke_bit(B,aa(num,nat,numeral_numeral(nat),L),aa(num,B,numeral_numeral(B),aa(num,num,bit1,K))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,pred_numeral(L),aa(num,B,numeral_numeral(B),K))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),one_one(B)) ) ) ).

% take_bit_numeral_bit1
tff(fact_3471_Divides_Oadjust__div__def,axiom,
    ! [Qr: product_prod(int,int)] : ( adjust_div(Qr) = aa(product_prod(int,int),int,aa(fun(int,fun(int,int)),fun(product_prod(int,int),int),product_case_prod(int,int,int),aTP_Lamp_zk(int,fun(int,int))),Qr) ) ).

% Divides.adjust_div_def
tff(fact_3472_fact__numeral,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [K: num] : ( semiring_char_0_fact(B,aa(num,nat,numeral_numeral(nat),K)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),K)),semiring_char_0_fact(B,pred_numeral(K))) ) ) ).

% fact_numeral
tff(fact_3473_atLeastLessThan__nat__numeral,axiom,
    ! [M2: nat,K: num] :
      ( set_or7035219750837199246ssThan(nat,M2,aa(num,nat,numeral_numeral(nat),K))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),pred_numeral(K)),aa(set(nat),set(nat),insert(nat,pred_numeral(K)),set_or7035219750837199246ssThan(nat,M2,pred_numeral(K))),bot_bot(set(nat))) ) ).

% atLeastLessThan_nat_numeral
tff(fact_3474_take__bit__numeral__bit0,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [L: num,K: num] : ( bit_se2584673776208193580ke_bit(B,aa(num,nat,numeral_numeral(nat),L),aa(num,B,numeral_numeral(B),aa(num,num,bit0,K))) = aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,pred_numeral(L),aa(num,B,numeral_numeral(B),K))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% take_bit_numeral_bit0
tff(fact_3475_bit__cut__integer__code,axiom,
    ! [K: code_integer] :
      ( code_bit_cut_integer(K)
      = $ite(K = zero_zero(code_integer),aa($o,product_prod(code_integer,$o),aa(code_integer,fun($o,product_prod(code_integer,$o)),product_Pair(code_integer,$o),zero_zero(code_integer)),$false),aa(product_prod(code_integer,code_integer),product_prod(code_integer,$o),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,$o)),product_case_prod(code_integer,code_integer,product_prod(code_integer,$o)),aTP_Lamp_zl(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),K)),code_divmod_abs(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ).

% bit_cut_integer_code
tff(fact_3476_divmod__integer__eq__cases,axiom,
    ! [K: code_integer,L: code_integer] :
      ( code_divmod_integer(K,L)
      = $ite(
          K = zero_zero(code_integer),
          aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)),
          $ite(
            L = zero_zero(code_integer),
            aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),K),
            aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),aa(fun(code_integer,code_integer),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,aa(fun(code_integer,fun(code_integer,code_integer)),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,product_apsnd(code_integer,code_integer,code_integer)),times_times(code_integer))),sgn_sgn(code_integer)),L),$ite(aa(code_integer,code_integer,sgn_sgn(code_integer),K) = aa(code_integer,code_integer,sgn_sgn(code_integer),L),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zm(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ).

% divmod_integer_eq_cases
tff(fact_3477_mask__numeral,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: num] : ( bit_se2239418461657761734s_mask(B,aa(num,nat,numeral_numeral(nat),N)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(B,pred_numeral(N)))) ) ) ).

% mask_numeral
tff(fact_3478_xor__numerals_I6_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% xor_numerals(6)
tff(fact_3479_xor__numerals_I4_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% xor_numerals(4)
tff(fact_3480_sgn__sgn,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B] : ( aa(B,B,sgn_sgn(B),aa(B,B,sgn_sgn(B),A4)) = aa(B,B,sgn_sgn(B),A4) ) ) ).

% sgn_sgn
tff(fact_3481_sgn__0,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ( aa(B,B,sgn_sgn(B),zero_zero(B)) = zero_zero(B) ) ) ).

% sgn_0
tff(fact_3482_sgn__1,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ( aa(B,B,sgn_sgn(B),one_one(B)) = one_one(B) ) ) ).

% sgn_1
tff(fact_3483_sgn__minus,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B] : ( aa(B,B,sgn_sgn(B),aa(B,B,uminus_uminus(B),A4)) = aa(B,B,uminus_uminus(B),aa(B,B,sgn_sgn(B),A4)) ) ) ).

% sgn_minus
tff(fact_3484_sgn__less,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,sgn_sgn(B),A4)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B)) ) ) ).

% sgn_less
tff(fact_3485_sgn__greater,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,sgn_sgn(B),A4))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4) ) ) ).

% sgn_greater
tff(fact_3486_divide__sgn,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,sgn_sgn(B),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,sgn_sgn(B),B3)) ) ) ).

% divide_sgn
tff(fact_3487_sgn__pos,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,B,sgn_sgn(B),A4) = one_one(B) ) ) ) ).

% sgn_pos
tff(fact_3488_abs__sgn__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,B,abs_abs(B),aa(B,B,sgn_sgn(B),A4)) = one_one(B) ) ) ) ).

% abs_sgn_eq_1
tff(fact_3489_mask__Suc__0,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ( bit_se2239418461657761734s_mask(B,aa(nat,nat,suc,zero_zero(nat))) = one_one(B) ) ) ).

% mask_Suc_0
tff(fact_3490_sgn__mult__self__eq,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,sgn_sgn(B),A4)),aa(B,B,sgn_sgn(B),A4)) = aa($o,B,zero_neq_one_of_bool(B),( A4 != zero_zero(B) )) ) ) ).

% sgn_mult_self_eq
tff(fact_3491_take__bit__minus__one__eq__mask,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(B,N,aa(B,B,uminus_uminus(B),one_one(B))) = bit_se2239418461657761734s_mask(B,N) ) ) ).

% take_bit_minus_one_eq_mask
tff(fact_3492_sgn__abs,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B] : ( aa(B,B,abs_abs(B),aa(B,B,sgn_sgn(B),A4)) = aa($o,B,zero_neq_one_of_bool(B),( A4 != zero_zero(B) )) ) ) ).

% sgn_abs
tff(fact_3493_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B] : ( aa(B,B,sgn_sgn(B),aa(B,B,abs_abs(B),A4)) = aa($o,B,zero_neq_one_of_bool(B),( A4 != zero_zero(B) )) ) ) ).

% idom_abs_sgn_class.abs_sgn
tff(fact_3494_sgn__neg,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B))
         => ( aa(B,B,sgn_sgn(B),A4) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ) ).

% sgn_neg
tff(fact_3495_xor__numerals_I3_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% xor_numerals(3)
tff(fact_3496_xor__numerals_I1_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y)) ) ) ).

% xor_numerals(1)
tff(fact_3497_xor__numerals_I2_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y)) ) ) ).

% xor_numerals(2)
tff(fact_3498_xor__numerals_I5_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X2))),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2)) ) ) ).

% xor_numerals(5)
tff(fact_3499_xor__numerals_I8_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2))),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit0,X2)) ) ) ).

% xor_numerals(8)
tff(fact_3500_xor__numerals_I7_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% xor_numerals(7)
tff(fact_3501_sgn__mult,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B,B3: B] : ( aa(B,B,sgn_sgn(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,sgn_sgn(B),A4)),aa(B,B,sgn_sgn(B),B3)) ) ) ).

% sgn_mult
tff(fact_3502_same__sgn__sgn__add,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [B3: B,A4: B] :
          ( ( aa(B,B,sgn_sgn(B),B3) = aa(B,B,sgn_sgn(B),A4) )
         => ( aa(B,B,sgn_sgn(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) = aa(B,B,sgn_sgn(B),A4) ) ) ) ).

% same_sgn_sgn_add
tff(fact_3503_sgn__eq__0__iff,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B] :
          ( ( aa(B,B,sgn_sgn(B),A4) = zero_zero(B) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% sgn_eq_0_iff
tff(fact_3504_sgn__0__0,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] :
          ( ( aa(B,B,sgn_sgn(B),A4) = zero_zero(B) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% sgn_0_0
tff(fact_3505_sgn__not__eq__imp,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [B3: B,A4: B] :
          ( ( aa(B,B,sgn_sgn(B),B3) != aa(B,B,sgn_sgn(B),A4) )
         => ( ( aa(B,B,sgn_sgn(B),A4) != zero_zero(B) )
           => ( ( aa(B,B,sgn_sgn(B),B3) != zero_zero(B) )
             => ( aa(B,B,sgn_sgn(B),A4) = aa(B,B,uminus_uminus(B),aa(B,B,sgn_sgn(B),B3)) ) ) ) ) ) ).

% sgn_not_eq_imp
tff(fact_3506_sgn__minus__1,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ( aa(B,B,sgn_sgn(B),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% sgn_minus_1
tff(fact_3507_same__sgn__abs__add,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [B3: B,A4: B] :
          ( ( aa(B,B,sgn_sgn(B),B3) = aa(B,B,sgn_sgn(B),A4) )
         => ( aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,abs_abs(B),A4)),aa(B,B,abs_abs(B),B3)) ) ) ) ).

% same_sgn_abs_add
tff(fact_3508_linordered__idom__class_Oabs__sgn,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [K: B] : ( aa(B,B,abs_abs(B),K) = aa(B,B,aa(B,fun(B,B),times_times(B),K),aa(B,B,sgn_sgn(B),K)) ) ) ).

% linordered_idom_class.abs_sgn
tff(fact_3509_abs__mult__sgn,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),A4)),aa(B,B,sgn_sgn(B),A4)) = A4 ) ) ).

% abs_mult_sgn
tff(fact_3510_sgn__mult__abs,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,sgn_sgn(B),A4)),aa(B,B,abs_abs(B),A4)) = A4 ) ) ).

% sgn_mult_abs
tff(fact_3511_mult__sgn__abs,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,sgn_sgn(B),X2)),aa(B,B,abs_abs(B),X2)) = X2 ) ) ).

% mult_sgn_abs
tff(fact_3512_xor_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => comm_monoid(B,bit_se5824344971392196577ns_xor(B),zero_zero(B)) ) ).

% xor.comm_monoid_axioms
tff(fact_3513_xor_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => monoid(B,bit_se5824344971392196577ns_xor(B),zero_zero(B)) ) ).

% xor.monoid_axioms
tff(fact_3514_sgn__1__pos,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] :
          ( ( aa(B,B,sgn_sgn(B),A4) = one_one(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4) ) ) ).

% sgn_1_pos
tff(fact_3515_abs__sgn__eq,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] :
          ( aa(B,B,abs_abs(B),aa(B,B,sgn_sgn(B),A4))
          = $ite(A4 = zero_zero(B),zero_zero(B),one_one(B)) ) ) ).

% abs_sgn_eq
tff(fact_3516_flip__bit__eq__xor,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A4: B] : ( bit_se8732182000553998342ip_bit(B,N,A4) = aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),A4),bit_se4730199178511100633sh_bit(B,N,one_one(B))) ) ) ).

% flip_bit_eq_xor
tff(fact_3517_sgn__if,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B] :
          ( aa(B,B,sgn_sgn(B),X2)
          = $ite(
              X2 = zero_zero(B),
              zero_zero(B),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),X2),one_one(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ) ) ).

% sgn_if
tff(fact_3518_sgn__1__neg,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A4: B] :
          ( ( aa(B,B,sgn_sgn(B),A4) = aa(B,B,uminus_uminus(B),one_one(B)) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),zero_zero(B)) ) ) ).

% sgn_1_neg
tff(fact_3519_mask__eq__exp__minus__1,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(B,N) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)),one_one(B)) ) ) ).

% mask_eq_exp_minus_1
tff(fact_3520_one__xor__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),one_one(B)),A4) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa($o,B,zero_neq_one_of_bool(B),aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)))),aa($o,B,zero_neq_one_of_bool(B),~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4))) ) ) ).

% one_xor_eq
tff(fact_3521_xor__one__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),A4),one_one(B)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa($o,B,zero_neq_one_of_bool(B),aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)))),aa($o,B,zero_neq_one_of_bool(B),~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4))) ) ) ).

% xor_one_eq
tff(fact_3522_integer__of__num_I3_J,axiom,
    ! [N: num] :
      ( code_integer_of_num(aa(num,num,bit1,N))
      = $let(
          k: code_integer,
          k := code_integer_of_num(N),
          aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),k),k)),one_one(code_integer)) ) ) ).

% integer_of_num(3)
tff(fact_3523_rec__nat__add__eq__if,axiom,
    ! [B: $tType,A4: B,F2: fun(nat,fun(B,B)),V: num,N: nat] :
      ( aa(nat,B,rec_nat(B,A4,F2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),N))
      = $let(
          pv: nat,
          pv := pred_numeral(V),
          aa(B,B,aa(nat,fun(B,B),F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pv),N)),aa(nat,B,rec_nat(B,A4,F2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pv),N))) ) ) ).

% rec_nat_add_eq_if
tff(fact_3524_case__nat__add__eq__if,axiom,
    ! [B: $tType,A4: B,F2: fun(nat,B),V: num,N: nat] : ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(B,fun(fun(nat,B),fun(nat,B)),case_nat(B),A4),F2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),N)) = aa(nat,B,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pred_numeral(V)),N)) ) ).

% case_nat_add_eq_if
tff(fact_3525_or__numerals_I4_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% or_numerals(4)
tff(fact_3526_or__numerals_I6_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% or_numerals(6)
tff(fact_3527_bit_Odisj__one__right,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),X2),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.disj_one_right
tff(fact_3528_bit_Odisj__one__left,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(B,B,uminus_uminus(B),one_one(B))),X2) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.disj_one_left
tff(fact_3529_case__nat__numeral,axiom,
    ! [B: $tType,A4: B,F2: fun(nat,B),V: num] : ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(B,fun(fun(nat,B),fun(nat,B)),case_nat(B),A4),F2),aa(num,nat,numeral_numeral(nat),V)) = aa(nat,B,F2,pred_numeral(V)) ) ).

% case_nat_numeral
tff(fact_3530_rec__nat__numeral,axiom,
    ! [B: $tType,A4: B,F2: fun(nat,fun(B,B)),V: num] :
      ( aa(nat,B,rec_nat(B,A4,F2),aa(num,nat,numeral_numeral(nat),V))
      = $let(
          pv: nat,
          pv := pred_numeral(V),
          aa(B,B,aa(nat,fun(B,B),F2,pv),aa(nat,B,rec_nat(B,A4,F2),pv)) ) ) ).

% rec_nat_numeral
tff(fact_3531_or__numerals_I2_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(2)
tff(fact_3532_or__numerals_I8_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2))),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2)) ) ) ).

% or_numerals(8)
tff(fact_3533_or__numerals_I3_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% or_numerals(3)
tff(fact_3534_or__numerals_I5_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X2))),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2)) ) ) ).

% or_numerals(5)
tff(fact_3535_or__numerals_I1_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(1)
tff(fact_3536_or__numerals_I7_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X2: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X2))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),X2)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% or_numerals(7)
tff(fact_3537_nat_Ocase__distrib,axiom,
    ! [C: $tType,B: $tType,H2: fun(C,B),F1: C,F22: fun(nat,C),Nat: nat] : ( aa(C,B,H2,aa(nat,C,aa(fun(nat,C),fun(nat,C),aa(C,fun(fun(nat,C),fun(nat,C)),case_nat(C),F1),F22),Nat)) = aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(B,fun(fun(nat,B),fun(nat,B)),case_nat(B),aa(C,B,H2,F1)),aa(fun(nat,C),fun(nat,B),aTP_Lamp_zn(fun(C,B),fun(fun(nat,C),fun(nat,B)),H2),F22)),Nat) ) ).

% nat.case_distrib
tff(fact_3538_or_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => comm_monoid(B,bit_se1065995026697491101ons_or(B),zero_zero(B)) ) ).

% or.comm_monoid_axioms
tff(fact_3539_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat = zero_zero(nat) )
    <=> aa(nat,$o,aa(fun(nat,$o),fun(nat,$o),aa($o,fun(fun(nat,$o),fun(nat,$o)),case_nat($o),$true),aTP_Lamp_xo(nat,$o)),Nat) ) ).

% nat.disc_eq_case(1)
tff(fact_3540_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( Nat != zero_zero(nat) )
    <=> aa(nat,$o,aa(fun(nat,$o),fun(nat,$o),aa($o,fun(fun(nat,$o),fun(nat,$o)),case_nat($o),$false),aTP_Lamp_zo(nat,$o)),Nat) ) ).

% nat.disc_eq_case(2)
tff(fact_3541_or_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => monoid(B,bit_se1065995026697491101ons_or(B),zero_zero(B)) ) ).

% or.monoid_axioms
tff(fact_3542_rec__nat__0__imp,axiom,
    ! [B: $tType,F2: fun(nat,B),F1: B,F22: fun(nat,fun(B,B))] :
      ( ( F2 = rec_nat(B,F1,F22) )
     => ( aa(nat,B,F2,zero_zero(nat)) = F1 ) ) ).

% rec_nat_0_imp
tff(fact_3543_rec__nat__Suc__imp,axiom,
    ! [B: $tType,F2: fun(nat,B),F1: B,F22: fun(nat,fun(B,B)),N: nat] :
      ( ( F2 = rec_nat(B,F1,F22) )
     => ( aa(nat,B,F2,aa(nat,nat,suc,N)) = aa(B,B,aa(nat,fun(B,B),F22,N),aa(nat,B,F2,N)) ) ) ).

% rec_nat_Suc_imp
tff(fact_3544_set__bit__eq__or,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A4: B] : ( bit_se5668285175392031749et_bit(B,N,A4) = aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),A4),bit_se4730199178511100633sh_bit(B,N,one_one(B))) ) ) ).

% set_bit_eq_or
tff(fact_3545_less__eq__nat_Osimps_I2_J,axiom,
    ! [M2: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M2)),N)
    <=> aa(nat,$o,aa(fun(nat,$o),fun(nat,$o),aa($o,fun(fun(nat,$o),fun(nat,$o)),case_nat($o),$false),aa(nat,fun(nat,$o),ord_less_eq(nat),M2)),N) ) ).

% less_eq_nat.simps(2)
tff(fact_3546_bit_Ocomplement__unique,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A4: B,X2: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A4),X2) = zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),A4),X2) = aa(B,B,uminus_uminus(B),one_one(B)) )
           => ( ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A4),Y) = zero_zero(B) )
             => ( ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),A4),Y) = aa(B,B,uminus_uminus(B),one_one(B)) )
               => ( X2 = Y ) ) ) ) ) ) ).

% bit.complement_unique
tff(fact_3547_diff__Suc,axiom,
    ! [M2: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),aa(nat,nat,suc,N)) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),zero_zero(nat)),aTP_Lamp_vw(nat,nat)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M2),N)) ) ).

% diff_Suc
tff(fact_3548_integer__of__num_I2_J,axiom,
    ! [N: num] :
      ( code_integer_of_num(aa(num,num,bit0,N))
      = $let(
          k: code_integer,
          k := code_integer_of_num(N),
          aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),k),k) ) ) ).

% integer_of_num(2)
tff(fact_3549_one__or__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),one_one(B)),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa($o,B,zero_neq_one_of_bool(B),aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4))) ) ) ).

% one_or_eq
tff(fact_3550_or__one__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),A4),one_one(B)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa($o,B,zero_neq_one_of_bool(B),aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4))) ) ) ).

% or_one_eq
tff(fact_3551_mask__Suc__double,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(B,aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(B,N))) ) ) ).

% mask_Suc_double
tff(fact_3552_old_Orec__nat__def,axiom,
    ! [B: $tType,X4: B,Xa3: fun(nat,fun(B,B)),Xb3: nat] : ( aa(nat,B,rec_nat(B,X4,Xa3),Xb3) = the(B,rec_set_nat(B,X4,Xa3,Xb3)) ) ).

% old.rec_nat_def
tff(fact_3553_bit__sum__mult__2__cases,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B,B3: B,N: nat] :
          ( ! [J3: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(B,A4),aa(nat,nat,suc,J3))
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B3))),N)
          <=> $ite(N = zero_zero(nat),~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4),aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B3)),N)) ) ) ) ).

% bit_sum_mult_2_cases
tff(fact_3554_signed__take__bit__code,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat,A4: B] :
          ( bit_ri4674362597316999326ke_bit(B,N,A4)
          = $let(
              l: B,
              l := bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),A4),
              $ite(aa(nat,$o,bit_se5641148757651400278ts_bit(B,l),N),aa(B,B,aa(B,fun(B,B),plus_plus(B),l),bit_se4730199178511100633sh_bit(B,aa(nat,nat,suc,N),aa(B,B,uminus_uminus(B),one_one(B)))),l) ) ) ) ).

% signed_take_bit_code
tff(fact_3555_minus__sub__one__diff__one,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [M2: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),neg_numeral_sub(B,M2,one2))),one_one(B)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2)) ) ) ).

% minus_sub_one_diff_one
tff(fact_3556_diff__numeral__special_I7_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N))) = neg_numeral_sub(B,N,one2) ) ) ).

% diff_numeral_special(7)
tff(fact_3557_bit__0__eq,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ( bit_se5641148757651400278ts_bit(B,zero_zero(B)) = bot_bot(fun(nat,$o)) ) ) ).

% bit_0_eq
tff(fact_3558_diff__numeral__special_I1_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(num,B,numeral_numeral(B),N)) = neg_numeral_sub(B,one2,N) ) ) ).

% diff_numeral_special(1)
tff(fact_3559_diff__numeral__special_I2_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M2: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(num,B,numeral_numeral(B),M2)),one_one(B)) = neg_numeral_sub(B,M2,one2) ) ) ).

% diff_numeral_special(2)
tff(fact_3560_add__neg__numeral__special_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(num,B,numeral_numeral(B),N)) = neg_numeral_sub(B,N,one2) ) ) ).

% add_neg_numeral_special(4)
tff(fact_3561_add__neg__numeral__special_I3_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M2: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),M2)),aa(B,B,uminus_uminus(B),one_one(B))) = neg_numeral_sub(B,M2,one2) ) ) ).

% add_neg_numeral_special(3)
tff(fact_3562_add__neg__numeral__special_I2_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M2: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))),one_one(B)) = neg_numeral_sub(B,one2,M2) ) ) ).

% add_neg_numeral_special(2)
tff(fact_3563_add__neg__numeral__special_I1_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M2: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))) = neg_numeral_sub(B,one2,M2) ) ) ).

% add_neg_numeral_special(1)
tff(fact_3564_diff__numeral__special_I8_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M2: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))),aa(B,B,uminus_uminus(B),one_one(B))) = neg_numeral_sub(B,one2,M2) ) ) ).

% diff_numeral_special(8)
tff(fact_3565_bit__1__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,one_one(B)),N)
        <=> ( N = zero_zero(nat) ) ) ) ).

% bit_1_iff
tff(fact_3566_not__bit__1__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(B,one_one(B)),aa(nat,nat,suc,N)) ) ).

% not_bit_1_Suc
tff(fact_3567_bit__numeral__simps_I1_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: num] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(B,one_one(B)),aa(num,nat,numeral_numeral(nat),N)) ) ).

% bit_numeral_simps(1)
tff(fact_3568_bit__numeral__rec_I1_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [W2: num,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,W2))),N)
        <=> aa(nat,$o,aa(fun(nat,$o),fun(nat,$o),aa($o,fun(fun(nat,$o),fun(nat,$o)),case_nat($o),$false),bit_se5641148757651400278ts_bit(B,aa(num,B,numeral_numeral(B),W2))),N) ) ) ).

% bit_numeral_rec(1)
tff(fact_3569_bit__numeral__rec_I2_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [W2: num,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(num,B,numeral_numeral(B),aa(num,num,bit1,W2))),N)
        <=> aa(nat,$o,aa(fun(nat,$o),fun(nat,$o),aa($o,fun(fun(nat,$o),fun(nat,$o)),case_nat($o),$true),bit_se5641148757651400278ts_bit(B,aa(num,B,numeral_numeral(B),W2))),N) ) ) ).

% bit_numeral_rec(2)
tff(fact_3570_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,A4),N)
        <=> ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A4),bit_se4730199178511100633sh_bit(B,N,one_one(B))) != zero_zero(B) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
tff(fact_3571_take__bit__sum,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: nat,A4: B] : ( bit_se2584673776208193580ke_bit(B,N,A4) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_zp(B,fun(nat,B),A4)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% take_bit_sum
tff(fact_3572_even__bit__succ__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A4: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A4)),N)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,A4),N)
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% even_bit_succ_iff
tff(fact_3573_odd__bit__iff__bit__pred,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A4: B,N: nat] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,A4),N)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))),N)
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
tff(fact_3574_pred__def,axiom,
    ! [Nat: nat] : ( pred(Nat) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),zero_zero(nat)),aTP_Lamp_vw(nat,nat)),Nat) ) ).

% pred_def
tff(fact_3575_signed__take__bit__def,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat,A4: B] : ( bit_ri4674362597316999326ke_bit(B,N,A4) = aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),bit_se2584673776208193580ke_bit(B,N,A4)),aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,bit_se5641148757651400278ts_bit(B,A4),N))),aa(B,B,bit_ri4277139882892585799ns_not(B),bit_se2239418461657761734s_mask(B,N)))) ) ) ).

% signed_take_bit_def
tff(fact_3576_eq__numeral__iff__iszero_I8_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Y: num] :
          ( ( one_one(B) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),Y)) )
        <=> ring_1_iszero(B,aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Y))) ) ) ).

% eq_numeral_iff_iszero(8)
tff(fact_3577_eq__numeral__iff__iszero_I7_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X2: num] :
          ( ( aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),X2)) = one_one(B) )
        <=> ring_1_iszero(B,aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),X2),one2))) ) ) ).

% eq_numeral_iff_iszero(7)
tff(fact_3578_Gcd__remove0__nat,axiom,
    ! [M: set(nat)] :
      ( aa(set(nat),$o,finite_finite2(nat),M)
     => ( gcd_Gcd(nat,M) = gcd_Gcd(nat,aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),M),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))))) ) ) ).

% Gcd_remove0_nat
tff(fact_3579_Gcd__empty,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ( gcd_Gcd(B,bot_bot(set(B))) = zero_zero(B) ) ) ).

% Gcd_empty
tff(fact_3580_Gcd__UNIV,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ( gcd_Gcd(B,top_top(set(B))) = one_one(B) ) ) ).

% Gcd_UNIV
tff(fact_3581_bit_Ocompl__zero,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ( aa(B,B,bit_ri4277139882892585799ns_not(B),zero_zero(B)) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.compl_zero
tff(fact_3582_bit_Ocompl__one,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ( aa(B,B,bit_ri4277139882892585799ns_not(B),aa(B,B,uminus_uminus(B),one_one(B))) = zero_zero(B) ) ) ).

% bit.compl_one
tff(fact_3583_bit_Odisj__cancel__right,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),X2),aa(B,B,bit_ri4277139882892585799ns_not(B),X2)) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.disj_cancel_right
tff(fact_3584_bit_Odisj__cancel__left,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(B,B,bit_ri4277139882892585799ns_not(B),X2)),X2) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.disj_cancel_left
tff(fact_3585_bit_Oxor__cancel__right,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),X2),aa(B,B,bit_ri4277139882892585799ns_not(B),X2)) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.xor_cancel_right
tff(fact_3586_bit_Oxor__cancel__left,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(B,B,bit_ri4277139882892585799ns_not(B),X2)),X2) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.xor_cancel_left
tff(fact_3587_bit_Oxor__one__right,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),X2),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,bit_ri4277139882892585799ns_not(B),X2) ) ) ).

% bit.xor_one_right
tff(fact_3588_bit_Oxor__one__left,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(B,B,uminus_uminus(B),one_one(B))),X2) = aa(B,B,bit_ri4277139882892585799ns_not(B),X2) ) ) ).

% bit.xor_one_left
tff(fact_3589_Gcd__0__iff,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(B)] :
          ( ( gcd_Gcd(B,A3) = zero_zero(B) )
        <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),insert(B,zero_zero(B)),bot_bot(set(B)))) ) ) ).

% Gcd_0_iff
tff(fact_3590_push__bit__minus__one__eq__not__mask,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] : ( bit_se4730199178511100633sh_bit(B,N,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,bit_ri4277139882892585799ns_not(B),bit_se2239418461657761734s_mask(B,N)) ) ) ).

% push_bit_minus_one_eq_not_mask
tff(fact_3591_not__one__eq,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ( aa(B,B,bit_ri4277139882892585799ns_not(B),one_one(B)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% not_one_eq
tff(fact_3592_Gcd__1,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,member(B,one_one(B)),A3)
         => ( gcd_Gcd(B,A3) = one_one(B) ) ) ) ).

% Gcd_1
tff(fact_3593_not__iszero__1,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ~ ring_1_iszero(B,one_one(B)) ) ).

% not_iszero_1
tff(fact_3594_Gcd__eq__1__I,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: B,A3: set(B)] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(set(B),$o,member(B,A4),A3)
           => ( gcd_Gcd(B,A3) = one_one(B) ) ) ) ) ).

% Gcd_eq_1_I
tff(fact_3595_not__iszero__neg__1,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ~ ring_1_iszero(B,aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% not_iszero_neg_1
tff(fact_3596_minus__eq__not__plus__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A4: B] : ( aa(B,B,uminus_uminus(B),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,bit_ri4277139882892585799ns_not(B),A4)),one_one(B)) ) ) ).

% minus_eq_not_plus_1
tff(fact_3597_minus__eq__not__minus__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A4: B] : ( aa(B,B,uminus_uminus(B),A4) = aa(B,B,bit_ri4277139882892585799ns_not(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))) ) ) ).

% minus_eq_not_minus_1
tff(fact_3598_not__eq__complement,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A4: B] : ( aa(B,B,bit_ri4277139882892585799ns_not(B),A4) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),A4)),one_one(B)) ) ) ).

% not_eq_complement
tff(fact_3599_Gcd__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_Gcd(C)
     => ! [A3: set(B),F2: fun(B,C),G: fun(B,C)] :
          ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),A3)
             => aa(C,$o,aa(C,fun(C,$o),dvd_dvd(C),aa(B,C,F2,X)),aa(B,C,G,X)) )
         => aa(C,$o,aa(C,fun(C,$o),dvd_dvd(C),gcd_Gcd(C,aa(set(B),set(C),image2(B,C,F2),A3))),gcd_Gcd(C,aa(set(B),set(C),image2(B,C,G),A3))) ) ) ).

% Gcd_mono
tff(fact_3600_unset__bit__eq__and__not,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat,A4: B] : ( bit_se2638667681897837118et_bit(B,N,A4) = aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A4),aa(B,B,bit_ri4277139882892585799ns_not(B),bit_se4730199178511100633sh_bit(B,N,one_one(B)))) ) ) ).

% unset_bit_eq_and_not
tff(fact_3601_bit_Ocompl__unique,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X2: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),X2),Y) = zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),X2),Y) = aa(B,B,uminus_uminus(B),one_one(B)) )
           => ( aa(B,B,bit_ri4277139882892585799ns_not(B),X2) = Y ) ) ) ) ).

% bit.compl_unique
tff(fact_3602_eq__numeral__iff__iszero_I6_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Y: num] :
          ( ( one_one(B) = aa(num,B,numeral_numeral(B),Y) )
        <=> ring_1_iszero(B,neg_numeral_sub(B,one2,Y)) ) ) ).

% eq_numeral_iff_iszero(6)
tff(fact_3603_eq__numeral__iff__iszero_I5_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X2: num] :
          ( ( aa(num,B,numeral_numeral(B),X2) = one_one(B) )
        <=> ring_1_iszero(B,neg_numeral_sub(B,X2,one2)) ) ) ).

% eq_numeral_iff_iszero(5)
tff(fact_3604_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => boolea2506097494486148201lgebra(B,bit_se5824344872417868541ns_and(B),bit_se1065995026697491101ons_or(B),bit_ri4277139882892585799ns_not(B),zero_zero(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% bit.abstract_boolean_algebra_axioms
tff(fact_3605_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => boolea3799213064322606851m_diff(B,bit_se5824344872417868541ns_and(B),bit_se1065995026697491101ons_or(B),bit_ri4277139882892585799ns_not(B),zero_zero(B),aa(B,B,uminus_uminus(B),one_one(B)),bit_se5824344971392196577ns_xor(B)) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
tff(fact_3606_Gcd__eq__Max,axiom,
    ! [M: set(nat)] :
      ( aa(set(nat),$o,finite_finite2(nat),M)
     => ( ( M != bot_bot(set(nat)) )
       => ( ~ aa(set(nat),$o,member(nat,zero_zero(nat)),M)
         => ( gcd_Gcd(nat,M) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(set(set(nat)),set(nat),complete_Inf_Inf(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),aTP_Lamp_zq(nat,set(nat))),M))) ) ) ) ) ).

% Gcd_eq_Max
tff(fact_3607_semiring__char__def,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [Uu: itself(B)] : ( semiri4206861660011772517g_char(B,Uu) = gcd_Gcd(nat,aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_zr(nat,$o))) ) ) ).

% semiring_char_def
tff(fact_3608_set__decode__def,axiom,
    ! [X2: nat] : ( nat_set_decode(X2) = aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_zs(nat,fun(nat,$o),X2)) ) ).

% set_decode_def
tff(fact_3609_diff__numeral__special_I5_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(num,B,numeral_numeral(B),N)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),inc(N))) ) ) ).

% diff_numeral_special(5)
tff(fact_3610_Gcd__abs__eq,axiom,
    ! [K4: set(int)] : ( gcd_Gcd(int,aa(set(int),set(int),image2(int,int,abs_abs(int)),K4)) = gcd_Gcd(int,K4) ) ).

% Gcd_abs_eq
tff(fact_3611_Gcd__int__eq,axiom,
    ! [N3: set(nat)] : ( gcd_Gcd(int,aa(set(nat),set(int),image2(nat,int,semiring_1_of_nat(int)),N3)) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,N3)) ) ).

% Gcd_int_eq
tff(fact_3612_Gcd__nat__abs__eq,axiom,
    ! [K4: set(int)] : ( gcd_Gcd(nat,aa(set(int),set(nat),image2(int,nat,aTP_Lamp_zt(int,nat)),K4)) = aa(int,nat,nat2,gcd_Gcd(int,K4)) ) ).

% Gcd_nat_abs_eq
tff(fact_3613_Max__singleton,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B] : ( aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = X2 ) ) ).

% Max_singleton
tff(fact_3614_set__decode__zero,axiom,
    nat_set_decode(zero_zero(nat)) = bot_bot(set(nat)) ).

% set_decode_zero
tff(fact_3615_Max__divisors__self__nat,axiom,
    ! [N: nat] :
      ( ( N != zero_zero(nat) )
     => ( aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_yz(nat,fun(nat,$o),N))) = N ) ) ).

% Max_divisors_self_nat
tff(fact_3616_Max_Obounded__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic643756798349783984er_Max(B),A3)),X2)
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),X2) ) ) ) ) ) ).

% Max.bounded_iff
tff(fact_3617_Max__less__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,lattic643756798349783984er_Max(B),A3)),X2)
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),X2) ) ) ) ) ) ).

% Max_less_iff
tff(fact_3618_Max__const,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(C)
     => ! [A3: set(B),Ca: C] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(C),C,lattic643756798349783984er_Max(C),aa(set(B),set(C),image2(B,C,aTP_Lamp_zu(C,fun(B,C),Ca)),A3)) = Ca ) ) ) ) ).

% Max_const
tff(fact_3619_add__neg__numeral__special_I6_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M2: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M2))),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),inc(M2))) ) ) ).

% add_neg_numeral_special(6)
tff(fact_3620_add__neg__numeral__special_I5_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),inc(N))) ) ) ).

% add_neg_numeral_special(5)
tff(fact_3621_diff__numeral__special_I6_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M2: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(num,B,numeral_numeral(B),M2)),aa(B,B,uminus_uminus(B),one_one(B))) = aa(num,B,numeral_numeral(B),inc(M2)) ) ) ).

% diff_numeral_special(6)
tff(fact_3622_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib2,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),Y: B,Z2: B,X2: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Xor,Y),Z2)),X2) = aa(B,B,aa(B,fun(B,B),Xor,aa(B,B,aa(B,fun(B,B),Conj,Y),X2)),aa(B,B,aa(B,fun(B,B),Conj,Z2),X2)) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib2
tff(fact_3623_abstract__boolean__algebra__sym__diff_Oxor__cancel__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X2: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X2),aa(B,B,Compl,X2)) = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_right
tff(fact_3624_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X2: B,Y: B,Z2: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Conj,X2),aa(B,B,aa(B,fun(B,B),Xor,Y),Z2)) = aa(B,B,aa(B,fun(B,B),Xor,aa(B,B,aa(B,fun(B,B),Conj,X2),Y)),aa(B,B,aa(B,fun(B,B),Conj,X2),Z2)) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib
tff(fact_3625_abstract__boolean__algebra__sym__diff_Oxor__compl__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X2: B,Y: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X2),aa(B,B,Compl,Y)) = aa(B,B,Compl,aa(B,B,aa(B,fun(B,B),Xor,X2),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_right
tff(fact_3626_abstract__boolean__algebra__sym__diff_Oxor__cancel__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X2: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,aa(B,B,Compl,X2)),X2) = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_left
tff(fact_3627_abstract__boolean__algebra__sym__diff_Oxor__compl__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X2: B,Y: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,aa(B,B,Compl,X2)),Y) = aa(B,B,Compl,aa(B,B,aa(B,fun(B,B),Xor,X2),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_left
tff(fact_3628_abstract__boolean__algebra__sym__diff_Oxor__one__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X2: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X2),One) = aa(B,B,Compl,X2) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_right
tff(fact_3629_abstract__boolean__algebra__sym__diff_Oxor__left__self,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X2: B,Y: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X2),aa(B,B,aa(B,fun(B,B),Xor,X2),Y)) = Y ) ) ).

% abstract_boolean_algebra_sym_diff.xor_left_self
tff(fact_3630_abstract__boolean__algebra__sym__diff_Oxor__one__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X2: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,One),X2) = aa(B,B,Compl,X2) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_left
tff(fact_3631_abstract__boolean__algebra__sym__diff_Oxor__self,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X2: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X2),X2) = Zero ) ) ).

% abstract_boolean_algebra_sym_diff.xor_self
tff(fact_3632_abstract__boolean__algebra__sym__diff_Oxor__def2,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X2: B,Y: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X2),Y) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,X2),Y)),aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,Compl,X2)),aa(B,B,Compl,Y))) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def2
tff(fact_3633_abstract__boolean__algebra__sym__diff_Oxor__def,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X2: B,Y: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X2),Y) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X2),aa(B,B,Compl,Y))),aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,Compl,X2)),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def
tff(fact_3634_abstract__boolean__algebra__sym__diff_Oaxioms_I1_J,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B))] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One) ) ).

% abstract_boolean_algebra_sym_diff.axioms(1)
tff(fact_3635_Max__in,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => aa(set(B),$o,member(B,aa(set(B),B,lattic643756798349783984er_Max(B),A3)),A3) ) ) ) ).

% Max_in
tff(fact_3636_Max__eq__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),M2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ( aa(set(B),B,lattic643756798349783984er_Max(B),A3) = M2 )
            <=> ( aa(set(B),$o,member(B,M2),A3)
                & ! [X3: B] :
                    ( aa(set(B),$o,member(B,X3),A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),M2) ) ) ) ) ) ) ).

% Max_eq_iff
tff(fact_3637_Max__ge__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(set(B),B,lattic643756798349783984er_Max(B),A3))
            <=> ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),X3) ) ) ) ) ) ).

% Max_ge_iff
tff(fact_3638_eq__Max__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),M2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ( M2 = aa(set(B),B,lattic643756798349783984er_Max(B),A3) )
            <=> ( aa(set(B),$o,member(B,M2),A3)
                & ! [X3: B] :
                    ( aa(set(B),$o,member(B,X3),A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),M2) ) ) ) ) ) ) ).

% eq_Max_iff
tff(fact_3639_Max_OboundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic643756798349783984er_Max(B),A3)),X2)
             => ! [A14: B] :
                  ( aa(set(B),$o,member(B,A14),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A14),X2) ) ) ) ) ) ).

% Max.boundedE
tff(fact_3640_Max_OboundedI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [A5: B] :
                  ( aa(set(B),$o,member(B,A5),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A5),X2) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic643756798349783984er_Max(B),A3)),X2) ) ) ) ) ).

% Max.boundedI
tff(fact_3641_Max__gr__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(set(B),B,lattic643756798349783984er_Max(B),A3))
            <=> ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),X3) ) ) ) ) ) ).

% Max_gr_iff
tff(fact_3642_Max__Sup,axiom,
    ! [B: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic643756798349783984er_Max(B),A3) = aa(set(B),B,complete_Sup_Sup(B),A3) ) ) ) ) ).

% Max_Sup
tff(fact_3643_cSup__eq__Max,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X5: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),X5)
         => ( ( X5 != bot_bot(set(B)) )
           => ( aa(set(B),B,complete_Sup_Sup(B),X5) = aa(set(B),B,lattic643756798349783984er_Max(B),X5) ) ) ) ) ).

% cSup_eq_Max
tff(fact_3644_Sup__nat__def,axiom,
    ! [X5: set(nat)] :
      ( aa(set(nat),nat,complete_Sup_Sup(nat),X5)
      = $ite(X5 = bot_bot(set(nat)),zero_zero(nat),aa(set(nat),nat,lattic643756798349783984er_Max(nat),X5)) ) ).

% Sup_nat_def
tff(fact_3645_numeral__inc,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [X2: num] : ( aa(num,B,numeral_numeral(B),inc(X2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),X2)),one_one(B)) ) ) ).

% numeral_inc
tff(fact_3646_Max_Osubset__imp,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic643756798349783984er_Max(B),A3)),aa(set(B),B,lattic643756798349783984er_Max(B),B2)) ) ) ) ) ).

% Max.subset_imp
tff(fact_3647_Max__mono,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [M: set(B),N3: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),M),N3)
         => ( ( M != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),N3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic643756798349783984er_Max(B),M)),aa(set(B),B,lattic643756798349783984er_Max(B),N3)) ) ) ) ) ).

% Max_mono
tff(fact_3648_mono__Max__commute,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [F2: fun(B,C),A3: set(B)] :
          ( order_mono(B,C,F2)
         => ( aa(set(B),$o,finite_finite2(B),A3)
           => ( ( A3 != bot_bot(set(B)) )
             => ( aa(B,C,F2,aa(set(B),B,lattic643756798349783984er_Max(B),A3)) = aa(set(C),C,lattic643756798349783984er_Max(C),aa(set(B),set(C),image2(B,C,F2),A3)) ) ) ) ) ) ).

% mono_Max_commute
tff(fact_3649_Gcd__int__def,axiom,
    ! [K4: set(int)] : ( gcd_Gcd(int,K4) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,aa(set(int),set(nat),image2(int,nat,aa(fun(int,int),fun(int,nat),comp(int,nat,int,nat2),abs_abs(int))),K4))) ) ).

% Gcd_int_def
tff(fact_3650_Max__add__commute,axiom,
    ! [B: $tType,C: $tType] :
      ( linord4140545234300271783up_add(C)
     => ! [S: set(B),F2: fun(B,C),K: C] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( ( S != bot_bot(set(B)) )
           => ( aa(set(C),C,lattic643756798349783984er_Max(C),aa(set(B),set(C),image2(B,C,aa(C,fun(B,C),aTP_Lamp_zv(fun(B,C),fun(C,fun(B,C)),F2),K)),S)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(C),C,lattic643756798349783984er_Max(C),aa(set(B),set(C),image2(B,C,F2),S))),K) ) ) ) ) ).

% Max_add_commute
tff(fact_3651_divide__nat__def,axiom,
    ! [M2: nat,N: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M2),N)
      = $ite(N = zero_zero(nat),zero_zero(nat),aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_zw(nat,fun(nat,fun(nat,$o)),M2),N)))) ) ).

% divide_nat_def
tff(fact_3652_dual__Min,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( lattices_Min(B,aTP_Lamp_px(B,fun(B,$o))) = lattic643756798349783984er_Max(B) ) ) ).

% dual_Min
tff(fact_3653_INT__greaterThan__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Inf_Inf(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),set_ord_greaterThan(nat)),top_top(set(nat)))) = bot_bot(set(nat)) ).

% INT_greaterThan_UNIV
tff(fact_3654_mask__mod__exp,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat,M2: nat] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M2),N))),one_one(B)) ) ) ).

% mask_mod_exp
tff(fact_3655_Code__Numeral_Odup__def,axiom,
    code_dup = aa(fun(int,int),fun(code_integer,code_integer),map_fun(code_integer,int,int,code_integer,code_int_of_integer,code_integer_of_int),aTP_Lamp_yl(int,int)) ).

% Code_Numeral.dup_def
tff(fact_3656_min_Oidem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),A4),A4) = A4 ) ) ).

% min.idem
tff(fact_3657_min_Oleft__idem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),A4),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) ) ) ).

% min.left_idem
tff(fact_3658_min_Oright__idem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)),B3) = aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) ) ) ).

% min.right_idem
tff(fact_3659_min_Obounded__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),Ca))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca) ) ) ) ).

% min.bounded_iff
tff(fact_3660_min_Oabsorb2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) = B3 ) ) ) ).

% min.absorb2
tff(fact_3661_min_Oabsorb1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) = A4 ) ) ) ).

% min.absorb1
tff(fact_3662_min__less__iff__conj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),X2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),Y) ) ) ) ).

% min_less_iff_conj
tff(fact_3663_min_Oabsorb4,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) = B3 ) ) ) ).

% min.absorb4
tff(fact_3664_min_Oabsorb3,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) = A4 ) ) ) ).

% min.absorb3
tff(fact_3665_min__bot,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),bot_bot(B)),X2) = bot_bot(B) ) ) ).

% min_bot
tff(fact_3666_min__bot2,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),X2),bot_bot(B)) = bot_bot(B) ) ) ).

% min_bot2
tff(fact_3667_min__top2,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),X2),top_top(B)) = X2 ) ) ).

% min_top2
tff(fact_3668_min__top,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),top_top(B)),X2) = X2 ) ) ).

% min_top
tff(fact_3669_min__0__1_I1_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ( aa(B,B,aa(B,fun(B,B),ord_min(B),zero_zero(B)),one_one(B)) = zero_zero(B) ) ) ).

% min_0_1(1)
tff(fact_3670_min__0__1_I2_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ( aa(B,B,aa(B,fun(B,B),ord_min(B),one_one(B)),zero_zero(B)) = zero_zero(B) ) ) ).

% min_0_1(2)
tff(fact_3671_min__0__1_I6_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [X2: num] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(num,B,numeral_numeral(B),X2)),one_one(B)) = one_one(B) ) ) ).

% min_0_1(6)
tff(fact_3672_min__0__1_I5_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [X2: num] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),one_one(B)),aa(num,B,numeral_numeral(B),X2)) = one_one(B) ) ) ).

% min_0_1(5)
tff(fact_3673_Int__atMost,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_atMost(B),A4)),aa(B,set(B),set_ord_atMost(B),B3)) = aa(B,set(B),set_ord_atMost(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)) ) ) ).

% Int_atMost
tff(fact_3674_Max__divisors__self__int,axiom,
    ! [N: int] :
      ( ( N != zero_zero(int) )
     => ( aa(set(int),int,lattic643756798349783984er_Max(int),aa(fun(int,$o),set(int),collect(int),aTP_Lamp_zc(int,fun(int,$o),N))) = aa(int,int,abs_abs(int),N) ) ) ).

% Max_divisors_self_int
tff(fact_3675_Sup__greaterThanAtLeast,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),top_top(B))
         => ( aa(set(B),B,complete_Sup_Sup(B),aa(B,set(B),set_ord_greaterThan(B),X2)) = top_top(B) ) ) ) ).

% Sup_greaterThanAtLeast
tff(fact_3676_Int__atLeastAtMostR1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,Ca: B,D3: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_atMost(B),B3)),set_or1337092689740270186AtMost(B,Ca,D3)) = set_or1337092689740270186AtMost(B,Ca,aa(B,B,aa(B,fun(B,B),ord_min(B),B3),D3)) ) ) ).

% Int_atLeastAtMostR1
tff(fact_3677_Int__atLeastAtMostL1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,D3: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,A4,B3)),aa(B,set(B),set_ord_atMost(B),D3)) = set_or1337092689740270186AtMost(B,A4,aa(B,B,aa(B,fun(B,B),ord_min(B),B3),D3)) ) ) ).

% Int_atLeastAtMostL1
tff(fact_3678_min__of__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [F2: fun(B,C),M2: B,N: B] :
          ( order_mono(B,C,F2)
         => ( aa(C,C,aa(C,fun(C,C),ord_min(C),aa(B,C,F2,M2)),aa(B,C,F2,N)) = aa(B,C,F2,aa(B,B,aa(B,fun(B,B),ord_min(B),M2),N)) ) ) ) ).

% min_of_mono
tff(fact_3679_min_Oassoc,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),ord_min(B),A4),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),Ca)) ) ) ).

% min.assoc
tff(fact_3680_min_Ocommute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) = aa(B,B,aa(B,fun(B,B),ord_min(B),B3),A4) ) ) ).

% min.commute
tff(fact_3681_min_Oleft__commute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),B3),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),Ca)) = aa(B,B,aa(B,fun(B,B),ord_min(B),A4),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),Ca)) ) ) ).

% min.left_commute
tff(fact_3682_inf__nat__def,axiom,
    inf_inf(nat) = ord_min(nat) ).

% inf_nat_def
tff(fact_3683_complete__linorder__inf__min,axiom,
    ! [B: $tType] :
      ( comple5582772986160207858norder(B)
     => ( inf_inf(B) = ord_min(B) ) ) ).

% complete_linorder_inf_min
tff(fact_3684_inf__min,axiom,
    ! [B: $tType] :
      ( ( semilattice_inf(B)
        & linorder(B) )
     => ( inf_inf(B) = ord_min(B) ) ) ).

% inf_min
tff(fact_3685_min__diff__distrib__left,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y)),Z2) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),Z2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Y),Z2)) ) ) ).

% min_diff_distrib_left
tff(fact_3686_min__add__distrib__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),aa(B,B,aa(B,fun(B,B),ord_min(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y)),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Z2)) ) ) ).

% min_add_distrib_right
tff(fact_3687_min__add__distrib__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y)),Z2) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Z2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Y),Z2)) ) ) ).

% min_add_distrib_left
tff(fact_3688_min_Omono,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,Ca: B,B3: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),D3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)),aa(B,B,aa(B,fun(B,B),ord_min(B),Ca),D3)) ) ) ) ).

% min.mono
tff(fact_3689_min_OorderE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( A4 = aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) ) ) ) ).

% min.orderE
tff(fact_3690_min_OorderI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ).

% min.orderI
tff(fact_3691_min_OboundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),Ca))
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca) ) ) ) ).

% min.boundedE
tff(fact_3692_min_OboundedI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),Ca)) ) ) ) ).

% min.boundedI
tff(fact_3693_min_Oorder__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
        <=> ( A4 = aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) ) ) ) ).

% min.order_iff
tff(fact_3694_min_Ocobounded1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)),A4) ) ).

% min.cobounded1
tff(fact_3695_min_Ocobounded2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)),B3) ) ).

% min.cobounded2
tff(fact_3696_min_Oabsorb__iff1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
        <=> ( aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) = A4 ) ) ) ).

% min.absorb_iff1
tff(fact_3697_min_Oabsorb__iff2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
        <=> ( aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) = B3 ) ) ) ).

% min.absorb_iff2
tff(fact_3698_min_OcoboundedI1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Ca)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)),Ca) ) ) ).

% min.coboundedI1
tff(fact_3699_min_OcoboundedI2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),Ca)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)),Ca) ) ) ).

% min.coboundedI2
tff(fact_3700_min__le__iff__disj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y)),Z2)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Z2)
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ) ).

% min_le_iff_disj
tff(fact_3701_min__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A4: B,B3: B] :
          ( aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3),A4,B3) ) ) ).

% min_def
tff(fact_3702_min__absorb1,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y) = X2 ) ) ) ).

% min_absorb1
tff(fact_3703_min__absorb2,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Y: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y) = Y ) ) ) ).

% min_absorb2
tff(fact_3704_min_Ostrict__coboundedI2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),Ca)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)),Ca) ) ) ).

% min.strict_coboundedI2
tff(fact_3705_min_Ostrict__coboundedI1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),Ca)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)),Ca) ) ) ).

% min.strict_coboundedI1
tff(fact_3706_min_Ostrict__order__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
        <=> ( ( A4 = aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3) )
            & ( A4 != B3 ) ) ) ) ).

% min.strict_order_iff
tff(fact_3707_min_Ostrict__boundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),Ca))
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),Ca) ) ) ) ).

% min.strict_boundedE
tff(fact_3708_min__less__iff__disj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y)),Z2)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Z2)
            | aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),Z2) ) ) ) ).

% min_less_iff_disj
tff(fact_3709_min_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semigroup(B,ord_min(B)) ) ).

% min.semigroup_axioms
tff(fact_3710_min__def__raw,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [X4: B,Xa3: B] :
          ( aa(B,B,aa(B,fun(B,B),ord_min(B),X4),Xa3)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),Xa3),X4,Xa3) ) ) ).

% min_def_raw
tff(fact_3711_greaterThan__non__empty,axiom,
    ! [B: $tType] :
      ( no_top(B)
     => ! [X2: B] : ( aa(B,set(B),set_ord_greaterThan(B),X2) != bot_bot(set(B)) ) ) ).

% greaterThan_non_empty
tff(fact_3712_greaterThan__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [L: B] : ( aa(B,set(B),set_ord_greaterThan(B),L) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),ord_less(B),L)) ) ) ).

% greaterThan_def
tff(fact_3713_greaterThan__Int__greaterThan,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_lessThan(B),A4)),aa(B,set(B),set_ord_lessThan(B),B3)) = aa(B,set(B),set_ord_lessThan(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)) ) ) ).

% greaterThan_Int_greaterThan
tff(fact_3714_Inf__insert__finite,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [S: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert(B,X2),S))
            = $ite(S = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),ord_min(B),X2),aa(set(B),B,complete_Inf_Inf(B),S))) ) ) ) ).

% Inf_insert_finite
tff(fact_3715_min__Suc1,axiom,
    ! [N: nat,M2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,N)),M2) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),zero_zero(nat)),aTP_Lamp_zx(nat,fun(nat,nat),N)),M2) ) ).

% min_Suc1
tff(fact_3716_min__Suc2,axiom,
    ! [M2: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M2),aa(nat,nat,suc,N)) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),zero_zero(nat)),aTP_Lamp_zy(nat,fun(nat,nat),N)),M2) ) ).

% min_Suc2
tff(fact_3717_ivl__disj__int__one_I7_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,L,U)),aa(B,set(B),set_ord_greaterThan(B),U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(7)
tff(fact_3718_ivl__disj__un__singleton_I1_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [L: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert(B,L),bot_bot(set(B)))),aa(B,set(B),set_ord_greaterThan(B),L)) = aa(B,set(B),set_ord_atLeast(B),L) ) ) ).

% ivl_disj_un_singleton(1)
tff(fact_3719_greaterThan__Suc,axiom,
    ! [K: nat] : ( aa(nat,set(nat),set_ord_greaterThan(nat),aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_greaterThan(nat),K)),aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,K)),bot_bot(set(nat)))) ) ).

% greaterThan_Suc
tff(fact_3720_dual__max,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( max(B,aTP_Lamp_px(B,fun(B,$o))) = ord_min(B) ) ) ).

% dual_max
tff(fact_3721_minus__Max__eq__Min,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [S: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( ( S != bot_bot(set(B)) )
           => ( aa(B,B,uminus_uminus(B),aa(set(B),B,lattic643756798349783984er_Max(B),S)) = aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(B),set(B),image2(B,B,uminus_uminus(B)),S)) ) ) ) ) ).

% minus_Max_eq_Min
tff(fact_3722_minus__Min__eq__Max,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [S: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( ( S != bot_bot(set(B)) )
           => ( aa(B,B,uminus_uminus(B),aa(set(B),B,lattic643756798350308766er_Min(B),S)) = aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(B),set(B),image2(B,B,uminus_uminus(B)),S)) ) ) ) ) ).

% minus_Min_eq_Max
tff(fact_3723_take__bit__numeral__minus__numeral__int,axiom,
    ! [M2: num,N: num] : ( bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),M2),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = case_option(int,num,zero_zero(int),aTP_Lamp_zz(num,fun(num,int),M2),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),M2),N)) ) ).

% take_bit_numeral_minus_numeral_int
tff(fact_3724_Min__singleton,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B] : ( aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = X2 ) ) ).

% Min_singleton
tff(fact_3725_Min_Obounded__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(set(B),B,lattic643756798350308766er_Min(B),A3))
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),X3) ) ) ) ) ) ).

% Min.bounded_iff
tff(fact_3726_Min__gr__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),aa(set(B),B,lattic643756798350308766er_Min(B),A3))
            <=> ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),X3) ) ) ) ) ) ).

% Min_gr_iff
tff(fact_3727_Min__const,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(C)
     => ! [A3: set(B),Ca: C] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(C),C,lattic643756798350308766er_Min(C),aa(set(B),set(C),image2(B,C,aTP_Lamp_zu(C,fun(B,C),Ca)),A3)) = Ca ) ) ) ) ).

% Min_const
tff(fact_3728_Min__insert,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(B),set(B),insert(B,X2),A3)) = aa(B,B,aa(B,fun(B,B),ord_min(B),X2),aa(set(B),B,lattic643756798350308766er_Min(B),A3)) ) ) ) ) ).

% Min_insert
tff(fact_3729_take__bit__numeral__numeral,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [M2: num,N: num] : ( bit_se2584673776208193580ke_bit(B,aa(num,nat,numeral_numeral(nat),M2),aa(num,B,numeral_numeral(B),N)) = case_option(B,num,zero_zero(B),numeral_numeral(B),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),M2),N)) ) ) ).

% take_bit_numeral_numeral
tff(fact_3730_disjE__realizer2,axiom,
    ! [C: $tType,B: $tType,Pa: $o,Qa: fun(B,$o),X2: option(B),R: fun(C,$o),F2: C,G: fun(B,C)] :
      ( case_option($o,B,Pa,Qa,X2)
     => ( ( (Pa)
         => aa(C,$o,R,F2) )
       => ( ! [Q5: B] :
              ( aa(B,$o,Qa,Q5)
             => aa(C,$o,R,aa(B,C,G,Q5)) )
         => aa(C,$o,R,case_option(C,B,F2,G,X2)) ) ) ) ).

% disjE_realizer2
tff(fact_3731_ord_Omax_Ocong,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o))] : ( max(B,Less_eq) = max(B,Less_eq) ) ).

% ord.max.cong
tff(fact_3732_ord_Omax__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( aa(B,B,aa(B,fun(B,B),max(B,Less_eq),A4),B3)
      = $ite(aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3),B3,A4) ) ).

% ord.max_def
tff(fact_3733_Min__in,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => aa(set(B),$o,member(B,aa(set(B),B,lattic643756798350308766er_Min(B),A3)),A3) ) ) ) ).

% Min_in
tff(fact_3734_Least__Min,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Pa: fun(B,$o)] :
          ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Pa))
         => ( ? [X_13: B] : aa(B,$o,Pa,X_13)
           => ( ord_Least(B,Pa) = aa(set(B),B,lattic643756798350308766er_Min(B),aa(fun(B,$o),set(B),collect(B),Pa)) ) ) ) ) ).

% Least_Min
tff(fact_3735_Min__eq__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),M2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ( aa(set(B),B,lattic643756798350308766er_Min(B),A3) = M2 )
            <=> ( aa(set(B),$o,member(B,M2),A3)
                & ! [X3: B] :
                    ( aa(set(B),$o,member(B,X3),A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),M2),X3) ) ) ) ) ) ) ).

% Min_eq_iff
tff(fact_3736_Min__le__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic643756798350308766er_Min(B),A3)),X2)
            <=> ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),X2) ) ) ) ) ) ).

% Min_le_iff
tff(fact_3737_eq__Min__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),M2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ( M2 = aa(set(B),B,lattic643756798350308766er_Min(B),A3) )
            <=> ( aa(set(B),$o,member(B,M2),A3)
                & ! [X3: B] :
                    ( aa(set(B),$o,member(B,X3),A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),M2),X3) ) ) ) ) ) ) ).

% eq_Min_iff
tff(fact_3738_Min_OboundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(set(B),B,lattic643756798350308766er_Min(B),A3))
             => ! [A14: B] :
                  ( aa(set(B),$o,member(B,A14),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),A14) ) ) ) ) ) ).

% Min.boundedE
tff(fact_3739_Min_OboundedI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [A5: B] :
                  ( aa(set(B),$o,member(B,A5),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),A5) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(set(B),B,lattic643756798350308766er_Min(B),A3)) ) ) ) ) ).

% Min.boundedI
tff(fact_3740_Min__less__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,lattic643756798350308766er_Min(B),A3)),X2)
            <=> ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),X2) ) ) ) ) ) ).

% Min_less_iff
tff(fact_3741_Min__Inf,axiom,
    ! [B: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic643756798350308766er_Min(B),A3) = aa(set(B),B,complete_Inf_Inf(B),A3) ) ) ) ) ).

% Min_Inf
tff(fact_3742_cInf__eq__Min,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X5: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),X5)
         => ( ( X5 != bot_bot(set(B)) )
           => ( aa(set(B),B,complete_Inf_Inf(B),X5) = aa(set(B),B,lattic643756798350308766er_Min(B),X5) ) ) ) ) ).

% cInf_eq_Min
tff(fact_3743_Min_Osubset__imp,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic643756798350308766er_Min(B),B2)),aa(set(B),B,lattic643756798350308766er_Min(B),A3)) ) ) ) ) ).

% Min.subset_imp
tff(fact_3744_Min__antimono,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [M: set(B),N3: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),M),N3)
         => ( ( M != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),N3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic643756798350308766er_Min(B),N3)),aa(set(B),B,lattic643756798350308766er_Min(B),M)) ) ) ) ) ).

% Min_antimono
tff(fact_3745_hom__Min__commute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [H2: fun(B,B),N3: set(B)] :
          ( ! [X: B,Y2: B] : ( aa(B,B,H2,aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y2)) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,H2,X)),aa(B,B,H2,Y2)) )
         => ( aa(set(B),$o,finite_finite2(B),N3)
           => ( ( N3 != bot_bot(set(B)) )
             => ( aa(B,B,H2,aa(set(B),B,lattic643756798350308766er_Min(B),N3)) = aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(B),set(B),image2(B,B,H2),N3)) ) ) ) ) ) ).

% hom_Min_commute
tff(fact_3746_Min_Osubset,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( B2 != bot_bot(set(B)) )
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A3)
             => ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(set(B),B,lattic643756798350308766er_Min(B),B2)),aa(set(B),B,lattic643756798350308766er_Min(B),A3)) = aa(set(B),B,lattic643756798350308766er_Min(B),A3) ) ) ) ) ) ).

% Min.subset
tff(fact_3747_Min_Oinsert__not__elem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ~ aa(set(B),$o,member(B,X2),A3)
           => ( ( A3 != bot_bot(set(B)) )
             => ( aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(B),set(B),insert(B,X2),A3)) = aa(B,B,aa(B,fun(B,B),ord_min(B),X2),aa(set(B),B,lattic643756798350308766er_Min(B),A3)) ) ) ) ) ) ).

% Min.insert_not_elem
tff(fact_3748_Min_Oclosed,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [X: B,Y2: B] : aa(set(B),$o,member(B,aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y2)),aa(set(B),set(B),insert(B,X),aa(set(B),set(B),insert(B,Y2),bot_bot(set(B)))))
             => aa(set(B),$o,member(B,aa(set(B),B,lattic643756798350308766er_Min(B),A3)),A3) ) ) ) ) ).

% Min.closed
tff(fact_3749_mono__Min__commute,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [F2: fun(B,C),A3: set(B)] :
          ( order_mono(B,C,F2)
         => ( aa(set(B),$o,finite_finite2(B),A3)
           => ( ( A3 != bot_bot(set(B)) )
             => ( aa(B,C,F2,aa(set(B),B,lattic643756798350308766er_Min(B),A3)) = aa(set(C),C,lattic643756798350308766er_Min(C),aa(set(B),set(C),image2(B,C,F2),A3)) ) ) ) ) ) ).

% mono_Min_commute
tff(fact_3750_Min_Ounion,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(set(B),B,lattic643756798350308766er_Min(B),A3)),aa(set(B),B,lattic643756798350308766er_Min(B),B2)) ) ) ) ) ) ) ).

% Min.union
tff(fact_3751_Min__add__commute,axiom,
    ! [B: $tType,C: $tType] :
      ( linord4140545234300271783up_add(C)
     => ! [S: set(B),F2: fun(B,C),K: C] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( ( S != bot_bot(set(B)) )
           => ( aa(set(C),C,lattic643756798350308766er_Min(C),aa(set(B),set(C),image2(B,C,aa(C,fun(B,C),aTP_Lamp_zv(fun(B,C),fun(C,fun(B,C)),F2),K)),S)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(C),C,lattic643756798350308766er_Min(C),aa(set(B),set(C),image2(B,C,F2),S))),K) ) ) ) ) ).

% Min_add_commute
tff(fact_3752_Min_Oremove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,member(B,X2),A3)
           => ( aa(set(B),B,lattic643756798350308766er_Min(B),A3)
              = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),ord_min(B),X2),aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))))) ) ) ) ) ).

% Min.remove
tff(fact_3753_Min_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(B),set(B),insert(B,X2),A3))
            = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),ord_min(B),X2),aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))))) ) ) ) ).

% Min.insert_remove
tff(fact_3754_and__minus__numerals_I4_J,axiom,
    ! [M2: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M2,aa(num,num,bit0,N))) ) ).

% and_minus_numerals(4)
tff(fact_3755_and__minus__numerals_I8_J,axiom,
    ! [N: num,M2: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))),aa(num,int,numeral_numeral(int),M2)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M2,aa(num,num,bit0,N))) ) ).

% and_minus_numerals(8)
tff(fact_3756_dual__Max,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( lattices_Max(B,aTP_Lamp_px(B,fun(B,$o))) = lattic643756798350308766er_Min(B) ) ) ).

% dual_Max
tff(fact_3757_int__numeral__and__not__num,axiom,
    ! [M2: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M2)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M2,N)) ) ).

% int_numeral_and_not_num
tff(fact_3758_int__numeral__not__and__num,axiom,
    ! [M2: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),M2))),aa(num,int,numeral_numeral(int),N)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(N,M2)) ) ).

% int_numeral_not_and_num
tff(fact_3759_and__minus__numerals_I7_J,axiom,
    ! [N: num,M2: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,N)))),aa(num,int,numeral_numeral(int),M2)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M2,bitM(N))) ) ).

% and_minus_numerals(7)
tff(fact_3760_and__minus__numerals_I3_J,axiom,
    ! [M2: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,N)))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M2,bitM(N))) ) ).

% and_minus_numerals(3)
tff(fact_3761_less__option__def,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: option(B),Y: option(B)] :
          ( aa(option(B),$o,aa(option(B),fun(option(B),$o),ord_less(option(B)),X2),Y)
        <=> case_option($o,B,$false,aTP_Lamp_aab(option(B),fun(B,$o),X2),Y) ) ) ).

% less_option_def
tff(fact_3762_less__eq__option__def,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X2: option(B),Y: option(B)] :
          ( aa(option(B),$o,aa(option(B),fun(option(B),$o),ord_less_eq(option(B)),X2),Y)
        <=> case_option($o,B,$true,aTP_Lamp_aac(option(B),fun(B,$o),Y),X2) ) ) ).

% less_eq_option_def
tff(fact_3763_numeral__BitM,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(num,B,numeral_numeral(B),bitM(N)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,N))),one_one(B)) ) ) ).

% numeral_BitM
tff(fact_3764_take__bit__num__simps_I7_J,axiom,
    ! [R2: num,M2: num] : ( bit_take_bit_num(aa(num,nat,numeral_numeral(nat),R2),aa(num,num,bit1,M2)) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(pred_numeral(R2),M2))) ) ).

% take_bit_num_simps(7)
tff(fact_3765_abstract__boolean__algebra__sym__diff_Ointro,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B))] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( boolea5476839437570043046axioms(B,Conj,Disj,Compl,Xor)
       => boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor) ) ) ).

% abstract_boolean_algebra_sym_diff.intro
tff(fact_3766_abstract__boolean__algebra__sym__diff__def,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B))] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
    <=> ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
        & boolea5476839437570043046axioms(B,Conj,Disj,Compl,Xor) ) ) ).

% abstract_boolean_algebra_sym_diff_def
tff(fact_3767_rat__floor__code,axiom,
    ! [P3: rat] : ( archim6421214686448440834_floor(rat,P3) = aa(product_prod(int,int),int,aa(fun(int,fun(int,int)),fun(product_prod(int,int),int),product_case_prod(int,int,int),divide_divide(int)),quotient_of(P3)) ) ).

% rat_floor_code
tff(fact_3768_inf__Some,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [X2: B,Y: B] : ( aa(option(B),option(B),aa(option(B),fun(option(B),option(B)),inf_inf(option(B)),aa(B,option(B),some(B),X2)),aa(B,option(B),some(B),Y)) = aa(B,option(B),some(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y)) ) ) ).

% inf_Some
tff(fact_3769_take__bit__num__simps_I4_J,axiom,
    ! [N: nat,M2: num] : ( bit_take_bit_num(aa(nat,nat,suc,N),aa(num,num,bit1,M2)) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(N,M2))) ) ).

% take_bit_num_simps(4)
tff(fact_3770_top__option__def,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ( top_top(option(B)) = aa(B,option(B),some(B),top_top(B)) ) ) ).

% top_option_def
tff(fact_3771_abstract__boolean__algebra__sym__diff__axioms_Ointro,axiom,
    ! [B: $tType,Xor: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Conj: fun(B,fun(B,B)),Compl: fun(B,B)] :
      ( ! [X: B,Y2: B] : ( aa(B,B,aa(B,fun(B,B),Xor,X),Y2) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X),aa(B,B,Compl,Y2))),aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,Compl,X)),Y2)) )
     => boolea5476839437570043046axioms(B,Conj,Disj,Compl,Xor) ) ).

% abstract_boolean_algebra_sym_diff_axioms.intro
tff(fact_3772_abstract__boolean__algebra__sym__diff__axioms__def,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Xor: fun(B,fun(B,B))] :
      ( boolea5476839437570043046axioms(B,Conj,Disj,Compl,Xor)
    <=> ! [X3: B,Y4: B] : ( aa(B,B,aa(B,fun(B,B),Xor,X3),Y4) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X3),aa(B,B,Compl,Y4))),aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,Compl,X3)),Y4)) ) ) ).

% abstract_boolean_algebra_sym_diff_axioms_def
tff(fact_3773_sup__option__def,axiom,
    ! [B: $tType] :
      ( sup(B)
     => ! [X2: option(B),Y: option(B)] : ( aa(option(B),option(B),aa(option(B),fun(option(B),option(B)),sup_sup(option(B)),X2),Y) = case_option(option(B),B,Y,aa(option(B),fun(B,option(B)),aTP_Lamp_aae(option(B),fun(option(B),fun(B,option(B))),X2),Y),X2) ) ) ).

% sup_option_def
tff(fact_3774_Some__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(B,option(B),some(B),aa(set(B),B,complete_Sup_Sup(B),A3)) = aa(set(option(B)),option(B),complete_Sup_Sup(option(B)),aa(set(B),set(option(B)),image2(B,option(B),some(B)),A3)) ) ) ) ).

% Some_Sup
tff(fact_3775_Some__INF,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B),A3: set(C)] : ( aa(B,option(B),some(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),A3))) = aa(set(option(B)),option(B),complete_Inf_Inf(option(B)),aa(set(C),set(option(B)),image2(C,option(B),aTP_Lamp_aaf(fun(C,B),fun(C,option(B)),F2)),A3)) ) ) ).

% Some_INF
tff(fact_3776_Some__SUP,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(B),F2: fun(B,C)] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(C,option(C),some(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,F2),A3))) = aa(set(option(C)),option(C),complete_Sup_Sup(option(C)),aa(set(B),set(option(C)),image2(B,option(C),aTP_Lamp_aag(fun(B,C),fun(B,option(C)),F2)),A3)) ) ) ) ).

% Some_SUP
tff(fact_3777_abstract__boolean__algebra__sym__diff_Oaxioms_I2_J,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B))] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => boolea5476839437570043046axioms(B,Conj,Disj,Compl,Xor) ) ).

% abstract_boolean_algebra_sym_diff.axioms(2)
tff(fact_3778_rat__uminus__code,axiom,
    ! [P3: rat] : ( quotient_of(aa(rat,rat,uminus_uminus(rat),P3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aah(int,fun(int,product_prod(int,int)))),quotient_of(P3)) ) ).

% rat_uminus_code
tff(fact_3779_and__not__num_Osimps_I8_J,axiom,
    ! [M2: num,N: num] : ( bit_and_not_num(aa(num,num,bit1,M2),aa(num,num,bit0,N)) = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aai(num,option(num)),bit_and_not_num(M2,N)) ) ).

% and_not_num.simps(8)
tff(fact_3780_rat__abs__code,axiom,
    ! [P3: rat] : ( quotient_of(aa(rat,rat,abs_abs(rat),P3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aaj(int,fun(int,product_prod(int,int)))),quotient_of(P3)) ) ).

% rat_abs_code
tff(fact_3781_rat__less__code,axiom,
    ! [P3: rat,Q: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),P3),Q)
    <=> aa(product_prod(int,int),$o,aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aTP_Lamp_aal(rat,fun(int,fun(int,$o)),Q)),quotient_of(P3)) ) ).

% rat_less_code
tff(fact_3782_rat__less__eq__code,axiom,
    ! [P3: rat,Q: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),P3),Q)
    <=> aa(product_prod(int,int),$o,aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aTP_Lamp_aan(rat,fun(int,fun(int,$o)),Q)),quotient_of(P3)) ) ).

% rat_less_eq_code
tff(fact_3783_rel__of__def,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),Pa: fun(product_prod(B,C),$o)] : ( rel_of(B,C,M2,Pa) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(fun(product_prod(B,C),$o),fun(B,fun(C,$o)),aTP_Lamp_aao(fun(B,option(C)),fun(fun(product_prod(B,C),$o),fun(B,fun(C,$o))),M2),Pa))) ) ).

% rel_of_def
tff(fact_3784_map__to__set__upd,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),K: B,V: C] : ( map_to_set(B,C,fun_upd(B,option(C),M2,K,aa(C,option(C),some(C),V))) = aa(set(product_prod(B,C)),set(product_prod(B,C)),insert(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K),V)),aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),minus_minus(set(product_prod(B,C))),map_to_set(B,C,M2)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aTP_Lamp_aap(B,fun(product_prod(B,C),$o),K)))) ) ).

% map_to_set_upd
tff(fact_3785_rat__minus__code,axiom,
    ! [P3: rat,Q: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),P3),Q)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aar(rat,fun(int,fun(int,product_prod(int,int))),Q)),quotient_of(P3)) ) ).

% rat_minus_code
tff(fact_3786_rat__plus__code,axiom,
    ! [P3: rat,Q: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),P3),Q)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aat(rat,fun(int,fun(int,product_prod(int,int))),Q)),quotient_of(P3)) ) ).

% rat_plus_code
tff(fact_3787_map__to__set__def,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C))] : ( map_to_set(B,C,M2) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_aau(fun(B,option(C)),fun(B,fun(C,$o)),M2))) ) ).

% map_to_set_def
tff(fact_3788_rat__divide__code,axiom,
    ! [P3: rat,Q: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),P3),Q)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aaw(rat,fun(int,fun(int,product_prod(int,int))),Q)),quotient_of(P3)) ) ).

% rat_divide_code
tff(fact_3789_rat__times__code,axiom,
    ! [P3: rat,Q: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),P3),Q)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aay(rat,fun(int,fun(int,product_prod(int,int))),Q)),quotient_of(P3)) ) ).

% rat_times_code
tff(fact_3790_take__bit__num__simps_I6_J,axiom,
    ! [R2: num,M2: num] : ( bit_take_bit_num(aa(num,nat,numeral_numeral(nat),R2),aa(num,num,bit0,M2)) = case_option(option(num),num,none(num),aTP_Lamp_aaz(num,option(num)),bit_take_bit_num(pred_numeral(R2),M2)) ) ).

% take_bit_num_simps(6)
tff(fact_3791_take__bit__num__simps_I3_J,axiom,
    ! [N: nat,M2: num] : ( bit_take_bit_num(aa(nat,nat,suc,N),aa(num,num,bit0,M2)) = case_option(option(num),num,none(num),aTP_Lamp_aaz(num,option(num)),bit_take_bit_num(N,M2)) ) ).

% take_bit_num_simps(3)
tff(fact_3792_rat__inverse__code,axiom,
    ! [P3: rat] : ( quotient_of(aa(rat,rat,inverse_inverse(rat),P3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_aba(int,fun(int,product_prod(int,int)))),quotient_of(P3)) ) ).

% rat_inverse_code
tff(fact_3793_normalize__def,axiom,
    ! [P3: product_prod(int,int)] :
      ( normalize(P3)
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),P3)),
          $let(
            a2: int,
            a2 := aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),aa(product_prod(int,int),int,product_snd(int,int),P3)),
            aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),a2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_snd(int,int),P3)),a2)) ),
          $ite(
            aa(product_prod(int,int),int,product_snd(int,int),P3) = zero_zero(int),
            aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),
            $let(
              a2: int,
              a2 := aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),aa(product_prod(int,int),int,product_snd(int,int),P3))),
              aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),a2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_snd(int,int),P3)),a2)) ) ) ) ) ).

% normalize_def
tff(fact_3794_gcd_Obottom__left__bottom,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),one_one(B)),A4) = one_one(B) ) ) ).

% gcd.bottom_left_bottom
tff(fact_3795_gcd_Obottom__right__bottom,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),one_one(B)) = one_one(B) ) ) ).

% gcd.bottom_right_bottom
tff(fact_3796_inverse__mult__distrib,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B,B3: B] : ( aa(B,B,inverse_inverse(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),A4)),aa(B,B,inverse_inverse(B),B3)) ) ) ).

% inverse_mult_distrib
tff(fact_3797_inverse__eq__1__iff,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X2: B] :
          ( ( aa(B,B,inverse_inverse(B),X2) = one_one(B) )
        <=> ( X2 = one_one(B) ) ) ) ).

% inverse_eq_1_iff
tff(fact_3798_inverse__1,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ( aa(B,B,inverse_inverse(B),one_one(B)) = one_one(B) ) ) ).

% inverse_1
tff(fact_3799_singleton__None__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ( aa(set(option(B)),option(B),complete_Sup_Sup(option(B)),aa(set(option(B)),set(option(B)),insert(option(B),none(B)),bot_bot(set(option(B))))) = none(B) ) ) ).

% singleton_None_Sup
tff(fact_3800_empty__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ( aa(set(option(B)),option(B),complete_Sup_Sup(option(B)),bot_bot(set(option(B)))) = none(B) ) ) ).

% empty_Sup
tff(fact_3801_inf__None__1,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [Y: option(B)] : ( aa(option(B),option(B),aa(option(B),fun(option(B),option(B)),inf_inf(option(B)),none(B)),Y) = none(B) ) ) ).

% inf_None_1
tff(fact_3802_inf__None__2,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [X2: option(B)] : ( aa(option(B),option(B),aa(option(B),fun(option(B),option(B)),inf_inf(option(B)),X2),none(B)) = none(B) ) ) ).

% inf_None_2
tff(fact_3803_is__unit__gcd__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)),one_one(B))
        <=> ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) = one_one(B) ) ) ) ).

% is_unit_gcd_iff
tff(fact_3804_map__to__set__empty,axiom,
    ! [C: $tType,B: $tType] : ( map_to_set(B,C,aTP_Lamp_abb(B,option(C))) = bot_bot(set(product_prod(B,C))) ) ).

% map_to_set_empty
tff(fact_3805_left__inverse,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),A4)),A4) = one_one(B) ) ) ) ).

% left_inverse
tff(fact_3806_right__inverse,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,inverse_inverse(B),A4)) = one_one(B) ) ) ) ).

% right_inverse
tff(fact_3807_inverse__eq__divide__numeral,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [W2: num] : ( aa(B,B,inverse_inverse(B),aa(num,B,numeral_numeral(B),W2)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(num,B,numeral_numeral(B),W2)) ) ) ).

% inverse_eq_divide_numeral
tff(fact_3808_Gcd__2,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: B,B3: B] : ( gcd_Gcd(B,aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) ) ) ).

% Gcd_2
tff(fact_3809_rel__of__empty,axiom,
    ! [C: $tType,B: $tType,Pa: fun(product_prod(B,C),$o)] : ( rel_of(B,C,aTP_Lamp_abb(B,option(C)),Pa) = bot_bot(set(product_prod(B,C))) ) ).

% rel_of_empty
tff(fact_3810_inverse__eq__divide__neg__numeral,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [W2: num] : ( aa(B,B,inverse_inverse(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) ) ) ).

% inverse_eq_divide_neg_numeral
tff(fact_3811_bot__option__def,axiom,
    ! [B: $tType] :
      ( order(B)
     => ( bot_bot(option(B)) = none(B) ) ) ).

% bot_option_def
tff(fact_3812_mult__commute__imp__mult__inverse__commute,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Y: B,X2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),Y),X2) = aa(B,B,aa(B,fun(B,B),times_times(B),X2),Y) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),Y)),X2) = aa(B,B,aa(B,fun(B,B),times_times(B),X2),aa(B,B,inverse_inverse(B),Y)) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
tff(fact_3813_nonzero__inverse__mult__distrib,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( ( B3 != zero_zero(B) )
           => ( aa(B,B,inverse_inverse(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),B3)),aa(B,B,inverse_inverse(B),A4)) ) ) ) ) ).

% nonzero_inverse_mult_distrib
tff(fact_3814_inverse__unique,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3) = one_one(B) )
         => ( aa(B,B,inverse_inverse(B),A4) = B3 ) ) ) ).

% inverse_unique
tff(fact_3815_gcd__add__mult,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [M2: B,K: B,N: B] : ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),M2),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),K),M2)),N)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),M2),N) ) ) ).

% gcd_add_mult
tff(fact_3816_divide__inverse__commute,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),B3)),A4) ) ) ).

% divide_inverse_commute
tff(fact_3817_divide__inverse,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,inverse_inverse(B),B3)) ) ) ).

% divide_inverse
tff(fact_3818_field__class_Ofield__divide__inverse,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,inverse_inverse(B),B3)) ) ) ).

% field_class.field_divide_inverse
tff(fact_3819_inverse__eq__divide,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B] : ( aa(B,B,inverse_inverse(B),A4) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4) ) ) ).

% inverse_eq_divide
tff(fact_3820_gcd__dvd__prod,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,K: B] : aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)),aa(B,B,aa(B,fun(B,B),times_times(B),K),B3)) ) ).

% gcd_dvd_prod
tff(fact_3821_power__mult__inverse__distrib,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X2: B,M2: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),M2)),aa(B,B,inverse_inverse(B),X2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),X2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),M2)) ) ) ).

% power_mult_inverse_distrib
tff(fact_3822_power__mult__power__inverse__commute,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X2: B,M2: nat,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),M2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,inverse_inverse(B),X2)),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,inverse_inverse(B),X2)),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),M2)) ) ) ).

% power_mult_power_inverse_commute
tff(fact_3823_mult__inverse__of__nat__commute,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Xa: nat,X2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),aa(nat,B,semiring_1_of_nat(B),Xa))),X2) = aa(B,B,aa(B,fun(B,B),times_times(B),X2),aa(B,B,inverse_inverse(B),aa(nat,B,semiring_1_of_nat(B),Xa))) ) ) ).

% mult_inverse_of_nat_commute
tff(fact_3824_mult__inverse__of__int__commute,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Xa: int,X2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),aa(int,B,ring_1_of_int(B),Xa))),X2) = aa(B,B,aa(B,fun(B,B),times_times(B),X2),aa(B,B,inverse_inverse(B),aa(int,B,ring_1_of_int(B),Xa))) ) ) ).

% mult_inverse_of_int_commute
tff(fact_3825_map__to__set__empty__iff_I1_J,axiom,
    ! [B: $tType,C: $tType,M2: fun(B,option(C))] :
      ( ( map_to_set(B,C,M2) = bot_bot(set(product_prod(B,C))) )
    <=> ! [X3: B] : ( aa(B,option(C),M2,X3) = none(C) ) ) ).

% map_to_set_empty_iff(1)
tff(fact_3826_map__to__set__empty__iff_I2_J,axiom,
    ! [B: $tType,C: $tType,M2: fun(B,option(C))] :
      ( ( bot_bot(set(product_prod(B,C))) = map_to_set(B,C,M2) )
    <=> ! [X3: B] : ( aa(B,option(C),M2,X3) = none(C) ) ) ).

% map_to_set_empty_iff(2)
tff(fact_3827_inverse__le__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,inverse_inverse(B),X2)),one_one(B))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),zero_zero(B))
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),X2) ) ) ) ).

% inverse_le_1_iff
tff(fact_3828_one__less__inverse__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,inverse_inverse(B),X2))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),X2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),one_one(B)) ) ) ) ).

% one_less_inverse_iff
tff(fact_3829_one__less__inverse,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,inverse_inverse(B),A4)) ) ) ) ).

% one_less_inverse
tff(fact_3830_inverse__add,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( ( B3 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,inverse_inverse(B),A4)),aa(B,B,inverse_inverse(B),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3)),aa(B,B,inverse_inverse(B),A4))),aa(B,B,inverse_inverse(B),B3)) ) ) ) ) ).

% inverse_add
tff(fact_3831_division__ring__inverse__add,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( ( B3 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,inverse_inverse(B),A4)),aa(B,B,inverse_inverse(B),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),A4)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),B3))),aa(B,B,inverse_inverse(B),B3)) ) ) ) ) ).

% division_ring_inverse_add
tff(fact_3832_field__class_Ofield__inverse,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A4: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),A4)),A4) = one_one(B) ) ) ) ).

% field_class.field_inverse
tff(fact_3833_division__ring__inverse__diff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( ( B3 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,inverse_inverse(B),A4)),aa(B,B,inverse_inverse(B),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),A4)),aa(B,B,aa(B,fun(B,B),minus_minus(B),B3),A4))),aa(B,B,inverse_inverse(B),B3)) ) ) ) ) ).

% division_ring_inverse_diff
tff(fact_3834_nonzero__inverse__eq__divide,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,B,inverse_inverse(B),A4) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),A4) ) ) ) ).

% nonzero_inverse_eq_divide
tff(fact_3835_gcd__mult__unit1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4)),Ca) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),B3),Ca) ) ) ) ).

% gcd_mult_unit1
tff(fact_3836_gcd__mult__unit2,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),B3),Ca) ) ) ) ).

% gcd_mult_unit2
tff(fact_3837_gcd__div__unit2,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),B3),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),A4)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),B3),Ca) ) ) ) ).

% gcd_div_unit2
tff(fact_3838_gcd__div__unit1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)),Ca) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),B3),Ca) ) ) ) ).

% gcd_div_unit1
tff(fact_3839_inverse__less__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,inverse_inverse(B),A4)),aa(B,B,inverse_inverse(B),B3))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3) ) ) ) ) ).

% inverse_less_iff
tff(fact_3840_inverse__le__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,inverse_inverse(B),A4)),aa(B,B,inverse_inverse(B),B3))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3) ) ) ) ) ).

% inverse_le_iff
tff(fact_3841_one__le__inverse,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,inverse_inverse(B),A4)) ) ) ) ).

% one_le_inverse
tff(fact_3842_inverse__less__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,inverse_inverse(B),X2)),one_one(B))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),zero_zero(B))
            | aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),X2) ) ) ) ).

% inverse_less_1_iff
tff(fact_3843_one__le__inverse__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,inverse_inverse(B),X2))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),X2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),one_one(B)) ) ) ) ).

% one_le_inverse_iff
tff(fact_3844_gcd__is__Max__divisors__int,axiom,
    ! [N: int,M2: int] :
      ( ( N != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M2),N) = aa(set(int),int,lattic643756798349783984er_Max(int),aa(fun(int,$o),set(int),collect(int),aa(int,fun(int,$o),aTP_Lamp_abc(int,fun(int,fun(int,$o)),N),M2))) ) ) ).

% gcd_is_Max_divisors_int
tff(fact_3845_power__diff__conv__inverse,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X2: B,M2: nat,N: nat] :
          ( ( X2 != zero_zero(B) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
           => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,inverse_inverse(B),X2)),M2)) ) ) ) ) ).

% power_diff_conv_inverse
tff(fact_3846_inf__option__def,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [X2: option(B),Y: option(B)] : ( aa(option(B),option(B),aa(option(B),fun(option(B),option(B)),inf_inf(option(B)),X2),Y) = case_option(option(B),B,none(B),aTP_Lamp_abe(option(B),fun(B,option(B)),Y),X2) ) ) ).

% inf_option_def
tff(fact_3847_empty__upd__none,axiom,
    ! [B: $tType,C: $tType,X2: B,X4: B] : ( aa(B,option(C),fun_upd(B,option(C),aTP_Lamp_abb(B,option(C)),X2,none(C)),X4) = none(C) ) ).

% empty_upd_none
tff(fact_3848_take__bit__num__code,axiom,
    ! [N: nat,M2: num] : ( bit_take_bit_num(N,M2) = aa(product_prod(nat,num),option(num),aa(fun(nat,fun(num,option(num))),fun(product_prod(nat,num),option(num)),product_case_prod(nat,num,option(num)),aTP_Lamp_abi(nat,fun(num,option(num)))),aa(num,product_prod(nat,num),aa(nat,fun(num,product_prod(nat,num)),product_Pair(nat,num),N),M2)) ) ).

% take_bit_num_code
tff(fact_3849_case__optionE,axiom,
    ! [B: $tType,Pa: $o,Qa: fun(B,$o),X2: option(B)] :
      ( case_option($o,B,Pa,Qa,X2)
     => ( ( ( X2 = none(B) )
         => ~ (Pa) )
       => ~ ! [Y2: B] :
              ( ( X2 = aa(B,option(B),some(B),Y2) )
             => ~ aa(B,$o,Qa,Y2) ) ) ) ).

% case_optionE
tff(fact_3850_option_Odisc__eq__case_I2_J,axiom,
    ! [B: $tType,Option: option(B)] :
      ( ( Option != none(B) )
    <=> case_option($o,B,$false,aTP_Lamp_nh(B,$o),Option) ) ).

% option.disc_eq_case(2)
tff(fact_3851_num_Ocase__distrib,axiom,
    ! [C: $tType,B: $tType,H2: fun(C,B),F1: C,F22: fun(num,C),F33: fun(num,C),Num: num] : ( aa(C,B,H2,case_num(C,F1,F22,F33,Num)) = case_num(B,aa(C,B,H2,F1),aa(fun(num,C),fun(num,B),aTP_Lamp_abj(fun(C,B),fun(fun(num,C),fun(num,B)),H2),F22),aa(fun(num,C),fun(num,B),aTP_Lamp_abj(fun(C,B),fun(fun(num,C),fun(num,B)),H2),F33),Num) ) ).

% num.case_distrib
tff(fact_3852_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,gcd_gcd(nat),zero_zero(nat),dvd_dvd(nat),aTP_Lamp_abk(nat,fun(nat,$o))) ).

% gcd_nat.semilattice_neutr_order_axioms
tff(fact_3853_Gcd__in,axiom,
    ! [A3: set(nat)] :
      ( ! [A5: nat,B4: nat] :
          ( aa(set(nat),$o,member(nat,A5),A3)
         => ( aa(set(nat),$o,member(nat,B4),A3)
           => aa(set(nat),$o,member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A5),B4)),A3) ) )
     => ( ( A3 != bot_bot(set(nat)) )
       => aa(set(nat),$o,member(nat,gcd_Gcd(nat,A3)),A3) ) ) ).

% Gcd_in
tff(fact_3854_gcd__is__Max__divisors__nat,axiom,
    ! [N: nat,M2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M2),N) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_abl(nat,fun(nat,fun(nat,$o)),N),M2))) ) ) ).

% gcd_is_Max_divisors_nat
tff(fact_3855_option_Ocase__distrib,axiom,
    ! [C: $tType,B: $tType,D: $tType,H2: fun(C,B),F1: C,F22: fun(D,C),Option: option(D)] : ( aa(C,B,H2,case_option(C,D,F1,F22,Option)) = case_option(B,D,aa(C,B,H2,F1),aa(fun(D,C),fun(D,B),aTP_Lamp_cc(fun(C,B),fun(fun(D,C),fun(D,B)),H2),F22),Option) ) ).

% option.case_distrib
tff(fact_3856_option_Odisc__eq__case_I1_J,axiom,
    ! [B: $tType,Option: option(B)] :
      ( ( Option = none(B) )
    <=> case_option($o,B,$true,aTP_Lamp_ao(B,$o),Option) ) ).

% option.disc_eq_case(1)
tff(fact_3857_Sup__option__def,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(option(B))] :
          ( aa(set(option(B)),option(B),complete_Sup_Sup(option(B)),A3)
          = $ite(
              ( ( A3 = bot_bot(set(option(B))) )
              | ( A3 = aa(set(option(B)),set(option(B)),insert(option(B),none(B)),bot_bot(set(option(B)))) ) ),
              none(B),
              aa(B,option(B),some(B),aa(set(B),B,complete_Sup_Sup(B),these(B,A3))) ) ) ) ).

% Sup_option_def
tff(fact_3858_plus__rat_Otransfer,axiom,
    aa(fun(rat,fun(rat,rat)),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(rat,fun(rat,rat)),$o),bNF_rel_fun(product_prod(int,int),rat,fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),pcr_rat,bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat)),aTP_Lamp_abm(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),plus_plus(rat)) ).

% plus_rat.transfer
tff(fact_3859_inverse__rat_Otransfer,axiom,
    aa(fun(rat,rat),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(rat,rat),$o),bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat),aTP_Lamp_abn(product_prod(int,int),product_prod(int,int))),inverse_inverse(rat)) ).

% inverse_rat.transfer
tff(fact_3860_these__not__empty__eq,axiom,
    ! [B: $tType,B2: set(option(B))] :
      ( ( these(B,B2) != bot_bot(set(B)) )
    <=> ( ( B2 != bot_bot(set(option(B))) )
        & ( B2 != aa(set(option(B)),set(option(B)),insert(option(B),none(B)),bot_bot(set(option(B)))) ) ) ) ).

% these_not_empty_eq
tff(fact_3861_these__empty,axiom,
    ! [B: $tType] : ( these(B,bot_bot(set(option(B)))) = bot_bot(set(B)) ) ).

% these_empty
tff(fact_3862_Some__image__these__eq,axiom,
    ! [B: $tType,A3: set(option(B))] : ( aa(set(B),set(option(B)),image2(B,option(B),some(B)),these(B,A3)) = aa(fun(option(B),$o),set(option(B)),collect(option(B)),aTP_Lamp_abo(set(option(B)),fun(option(B),$o),A3)) ) ).

% Some_image_these_eq
tff(fact_3863_uminus__rat_Otransfer,axiom,
    aa(fun(rat,rat),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(rat,rat),$o),bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat),aTP_Lamp_abp(product_prod(int,int),product_prod(int,int))),uminus_uminus(rat)) ).

% uminus_rat.transfer
tff(fact_3864_times__rat_Otransfer,axiom,
    aa(fun(rat,fun(rat,rat)),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(rat,fun(rat,rat)),$o),bNF_rel_fun(product_prod(int,int),rat,fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),pcr_rat,bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat)),aTP_Lamp_abq(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),times_times(rat)) ).

% times_rat.transfer
tff(fact_3865_these__empty__eq,axiom,
    ! [B: $tType,B2: set(option(B))] :
      ( ( these(B,B2) = bot_bot(set(B)) )
    <=> ( ( B2 = bot_bot(set(option(B))) )
        | ( B2 = aa(set(option(B)),set(option(B)),insert(option(B),none(B)),bot_bot(set(option(B)))) ) ) ) ).

% these_empty_eq
tff(fact_3866_positive_Otransfer,axiom,
    aa(fun(rat,$o),$o,aa(fun(product_prod(int,int),$o),fun(fun(rat,$o),$o),bNF_rel_fun(product_prod(int,int),rat,$o,$o,pcr_rat,fequal($o)),aTP_Lamp_abr(product_prod(int,int),$o)),positive) ).

% positive.transfer
tff(fact_3867_and__not__num_Oelims,axiom,
    ! [X2: num,Xa: num,Y: option(num)] :
      ( ( bit_and_not_num(X2,Xa) = Y )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y != none(num) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N2: num] : ( Xa = aa(num,num,bit0,N2) )
             => ( Y != aa(num,option(num),some(num),one2) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N2: num] : ( Xa = aa(num,num,bit1,N2) )
               => ( Y != none(num) ) ) )
           => ( ! [M3: num] :
                  ( ( X2 = aa(num,num,bit0,M3) )
                 => ( ( Xa = one2 )
                   => ( Y != aa(num,option(num),some(num),aa(num,num,bit0,M3)) ) ) )
             => ( ! [M3: num] :
                    ( ( X2 = aa(num,num,bit0,M3) )
                   => ! [N2: num] :
                        ( ( Xa = aa(num,num,bit0,N2) )
                       => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) ) ) )
               => ( ! [M3: num] :
                      ( ( X2 = aa(num,num,bit0,M3) )
                     => ! [N2: num] :
                          ( ( Xa = aa(num,num,bit1,N2) )
                         => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2 = aa(num,num,bit1,M3) )
                       => ( ( Xa = one2 )
                         => ( Y != aa(num,option(num),some(num),aa(num,num,bit0,M3)) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2 = aa(num,num,bit1,M3) )
                         => ! [N2: num] :
                              ( ( Xa = aa(num,num,bit0,N2) )
                             => ( Y != case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aai(num,option(num)),bit_and_not_num(M3,N2)) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X2 = aa(num,num,bit1,M3) )
                           => ! [N2: num] :
                                ( ( Xa = aa(num,num,bit1,N2) )
                               => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
tff(fact_3868_of__rat_Otransfer,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => aa(fun(rat,B),$o,aa(fun(product_prod(int,int),B),fun(fun(rat,B),$o),bNF_rel_fun(product_prod(int,int),rat,B,B,pcr_rat,fequal(B)),aTP_Lamp_abs(product_prod(int,int),B)),field_char_0_of_rat(B)) ) ).

% of_rat.transfer
tff(fact_3869_restrict__upd__same,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),X2: B,Y: C] : ( restrict_map(B,C,fun_upd(B,option(C),M2,X2,aa(C,option(C),some(C),Y)),aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))) = restrict_map(B,C,M2,aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))) ) ).

% restrict_upd_same
tff(fact_3870_of__rat__1,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ( aa(rat,B,field_char_0_of_rat(B),one_one(rat)) = one_one(B) ) ) ).

% of_rat_1
tff(fact_3871_of__rat__eq__1__iff,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: rat] :
          ( ( aa(rat,B,field_char_0_of_rat(B),A4) = one_one(B) )
        <=> ( A4 = one_one(rat) ) ) ) ).

% of_rat_eq_1_iff
tff(fact_3872_one__eq__of__rat__iff,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: rat] :
          ( ( one_one(B) = aa(rat,B,field_char_0_of_rat(B),A4) )
        <=> ( one_one(rat) = A4 ) ) ) ).

% one_eq_of_rat_iff
tff(fact_3873_restrict__restrict,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),A3: set(B),B2: set(B)] : ( restrict_map(B,C,restrict_map(B,C,M2,A3),B2) = restrict_map(B,C,M2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ).

% restrict_restrict
tff(fact_3874_map__option__o__empty,axiom,
    ! [B: $tType,D: $tType,C: $tType,F2: fun(D,C),X4: B] : ( aa(B,option(C),aa(fun(B,option(D)),fun(B,option(C)),comp(option(D),option(C),B,map_option(D,C,F2)),aTP_Lamp_abt(B,option(D))),X4) = none(C) ) ).

% map_option_o_empty
tff(fact_3875_restrict__map__empty,axiom,
    ! [B: $tType,C: $tType,D2: set(B),X4: B] : ( aa(B,option(C),restrict_map(B,C,aTP_Lamp_abb(B,option(C)),D2),X4) = none(C) ) ).

% restrict_map_empty
tff(fact_3876_restrict__map__to__empty,axiom,
    ! [B: $tType,C: $tType,M2: fun(B,option(C)),X4: B] : ( aa(B,option(C),restrict_map(B,C,M2,bot_bot(set(B))),X4) = none(C) ) ).

% restrict_map_to_empty
tff(fact_3877_of__rat__neg__one,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ( aa(rat,B,field_char_0_of_rat(B),aa(rat,rat,uminus_uminus(rat),one_one(rat))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% of_rat_neg_one
tff(fact_3878_one__less__of__rat__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [R2: rat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(rat,B,field_char_0_of_rat(B),R2))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),one_one(rat)),R2) ) ) ).

% one_less_of_rat_iff
tff(fact_3879_of__rat__less__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [R2: rat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(rat,B,field_char_0_of_rat(B),R2)),one_one(B))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R2),one_one(rat)) ) ) ).

% of_rat_less_1_iff
tff(fact_3880_of__rat__le__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [R2: rat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(rat,B,field_char_0_of_rat(B),R2)),one_one(B))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),R2),one_one(rat)) ) ) ).

% of_rat_le_1_iff
tff(fact_3881_one__le__of__rat__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [R2: rat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(rat,B,field_char_0_of_rat(B),R2))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),one_one(rat)),R2) ) ) ).

% one_le_of_rat_iff
tff(fact_3882_fun__upd__restrict__conv,axiom,
    ! [B: $tType,C: $tType,X2: B,D2: set(B),M2: fun(B,option(C)),Y: option(C)] :
      ( aa(set(B),$o,member(B,X2),D2)
     => ( fun_upd(B,option(C),restrict_map(B,C,M2,D2),X2,Y) = fun_upd(B,option(C),restrict_map(B,C,M2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),D2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),X2,Y) ) ) ).

% fun_upd_restrict_conv
tff(fact_3883_restrict__fun__upd,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),X2: B,Y: option(C),D2: set(B)] :
      ( restrict_map(B,C,fun_upd(B,option(C),M2,X2,Y),D2)
      = $ite(aa(set(B),$o,member(B,X2),D2),fun_upd(B,option(C),restrict_map(B,C,M2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),D2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),X2,Y),restrict_map(B,C,M2,D2)) ) ).

% restrict_fun_upd
tff(fact_3884_fun__upd__None__restrict,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),D2: set(B),X2: B] :
      ( fun_upd(B,option(C),restrict_map(B,C,M2,D2),X2,none(C))
      = $ite(aa(set(B),$o,member(B,X2),D2),restrict_map(B,C,M2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),D2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),restrict_map(B,C,M2,D2)) ) ).

% fun_upd_None_restrict
tff(fact_3885_option_Omap__ident,axiom,
    ! [B: $tType,T3: option(B)] : ( aa(option(B),option(B),map_option(B,B,aTP_Lamp_bk(B,B)),T3) = T3 ) ).

% option.map_ident
tff(fact_3886_map__option_Oidentity,axiom,
    ! [B: $tType] : ( map_option(B,B,aTP_Lamp_bk(B,B)) = id(option(B)) ) ).

% map_option.identity
tff(fact_3887_of__rat__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( field_char_0(B)
     => ! [F2: fun(C,rat),A3: set(C)] : ( aa(rat,B,field_char_0_of_rat(B),aa(set(C),rat,aa(fun(C,rat),fun(set(C),rat),groups7311177749621191930dd_sum(C,rat),F2),A3)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aTP_Lamp_abu(fun(C,rat),fun(C,B),F2)),A3) ) ) ).

% of_rat_sum
tff(fact_3888_of__rat__prod,axiom,
    ! [B: $tType,C: $tType] :
      ( field_char_0(B)
     => ! [F2: fun(C,rat),A3: set(C)] : ( aa(rat,B,field_char_0_of_rat(B),aa(set(C),rat,aa(fun(C,rat),fun(set(C),rat),groups7121269368397514597t_prod(C,rat),F2),A3)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aTP_Lamp_abu(fun(C,rat),fun(C,B),F2)),A3) ) ) ).

% of_rat_prod
tff(fact_3889_of__rat__mult,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A4: rat,B3: rat] : ( aa(rat,B,field_char_0_of_rat(B),aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(rat,B,field_char_0_of_rat(B),A4)),aa(rat,B,field_char_0_of_rat(B),B3)) ) ) ).

% of_rat_mult
tff(fact_3890_map__option__case,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),Y: option(C)] : ( aa(option(C),option(B),map_option(C,B,F2),Y) = case_option(option(B),C,none(B),aTP_Lamp_abv(fun(C,B),fun(C,option(B)),F2),Y) ) ).

% map_option_case
tff(fact_3891_fun__upd__restrict,axiom,
    ! [B: $tType,C: $tType,M2: fun(B,option(C)),D2: set(B),X2: B,Y: option(C)] : ( fun_upd(B,option(C),restrict_map(B,C,M2,D2),X2,Y) = fun_upd(B,option(C),restrict_map(B,C,M2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),D2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),X2,Y) ) ).

% fun_upd_restrict
tff(fact_3892_restrict__complement__singleton__eq,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,option(C)),X2: B] : ( restrict_map(B,C,F2,aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))) = fun_upd(B,option(C),F2,X2,none(C)) ) ).

% restrict_complement_singleton_eq
tff(fact_3893_map__upd__eq__restrict,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),X2: B] : ( fun_upd(B,option(C),M2,X2,none(C)) = restrict_map(B,C,M2,aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))) ) ).

% map_upd_eq_restrict
tff(fact_3894_positive__def,axiom,
    positive = aa(fun(product_prod(int,int),$o),fun(rat,$o),map_fun(rat,product_prod(int,int),$o,$o,rep_Rat,id($o)),aTP_Lamp_abr(product_prod(int,int),$o)) ).

% positive_def
tff(fact_3895_and__num_Oelims,axiom,
    ! [X2: num,Xa: num,Y: option(num)] :
      ( ( bit_un7362597486090784418nd_num(X2,Xa) = Y )
     => ( ( ( X2 = one2 )
         => ( ( Xa = one2 )
           => ( Y != aa(num,option(num),some(num),one2) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N2: num] : ( Xa = aa(num,num,bit0,N2) )
             => ( Y != none(num) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N2: num] : ( Xa = aa(num,num,bit1,N2) )
               => ( Y != aa(num,option(num),some(num),one2) ) ) )
           => ( ( ? [M3: num] : ( X2 = aa(num,num,bit0,M3) )
               => ( ( Xa = one2 )
                 => ( Y != none(num) ) ) )
             => ( ! [M3: num] :
                    ( ( X2 = aa(num,num,bit0,M3) )
                   => ! [N2: num] :
                        ( ( Xa = aa(num,num,bit0,N2) )
                       => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) ) ) )
               => ( ! [M3: num] :
                      ( ( X2 = aa(num,num,bit0,M3) )
                     => ! [N2: num] :
                          ( ( Xa = aa(num,num,bit1,N2) )
                         => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) ) ) )
                 => ( ( ? [M3: num] : ( X2 = aa(num,num,bit1,M3) )
                     => ( ( Xa = one2 )
                       => ( Y != aa(num,option(num),some(num),one2) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2 = aa(num,num,bit1,M3) )
                         => ! [N2: num] :
                              ( ( Xa = aa(num,num,bit0,N2) )
                             => ( Y != aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X2 = aa(num,num,bit1,M3) )
                           => ! [N2: num] :
                                ( ( Xa = aa(num,num,bit1,N2) )
                               => ( Y != case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aai(num,option(num)),bit_un7362597486090784418nd_num(M3,N2)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
tff(fact_3896_of__rat__def,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ( field_char_0_of_rat(B) = aa(fun(product_prod(int,int),B),fun(rat,B),map_fun(rat,product_prod(int,int),B,B,rep_Rat,id(B)),aTP_Lamp_abs(product_prod(int,int),B)) ) ) ).

% of_rat_def
tff(fact_3897_Min_Oeq__fold_H,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B)] : ( aa(set(B),B,lattic643756798350308766er_Min(B),A3) = aa(option(B),B,the2(B),finite_fold(B,option(B),aTP_Lamp_abw(B,fun(option(B),option(B))),none(B),A3)) ) ) ).

% Min.eq_fold'
tff(fact_3898_Option_Othese__def,axiom,
    ! [B: $tType,A3: set(option(B))] : ( these(B,A3) = aa(set(option(B)),set(B),image2(option(B),B,the2(B)),aa(fun(option(B),$o),set(option(B)),collect(option(B)),aTP_Lamp_abo(set(option(B)),fun(option(B),$o),A3))) ) ).

% Option.these_def
tff(fact_3899_numeral__and__num,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [M2: num,N: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),M2)),aa(num,B,numeral_numeral(B),N)) = case_option(B,num,zero_zero(B),numeral_numeral(B),bit_un7362597486090784418nd_num(M2,N)) ) ) ).

% numeral_and_num
tff(fact_3900_and__num_Osimps_I9_J,axiom,
    ! [M2: num,N: num] : ( bit_un7362597486090784418nd_num(aa(num,num,bit1,M2),aa(num,num,bit1,N)) = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aai(num,option(num)),bit_un7362597486090784418nd_num(M2,N)) ) ).

% and_num.simps(9)
tff(fact_3901_Inf__fin_Oeq__fold_H,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: set(B)] : ( aa(set(B),B,lattic7752659483105999362nf_fin(B),A3) = aa(option(B),B,the2(B),finite_fold(B,option(B),aTP_Lamp_abx(B,fun(option(B),option(B))),none(B),A3)) ) ) ).

% Inf_fin.eq_fold'
tff(fact_3902_Sup__fin_Oeq__fold_H,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: set(B)] : ( lattic5882676163264333800up_fin(B,A3) = aa(option(B),B,the2(B),finite_fold(B,option(B),aTP_Lamp_aby(B,fun(option(B),option(B))),none(B),A3)) ) ) ).

% Sup_fin.eq_fold'
tff(fact_3903_plus__rat__def,axiom,
    plus_plus(rat) = aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(rat,fun(rat,rat)),map_fun(rat,product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),rep_Rat,map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat)),aTP_Lamp_abm(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% plus_rat_def
tff(fact_3904_inverse__rat__def,axiom,
    inverse_inverse(rat) = aa(fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat),aTP_Lamp_abn(product_prod(int,int),product_prod(int,int))) ).

% inverse_rat_def
tff(fact_3905_times__rat__def,axiom,
    times_times(rat) = aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(rat,fun(rat,rat)),map_fun(rat,product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),rep_Rat,map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat)),aTP_Lamp_abq(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% times_rat_def
tff(fact_3906_uminus__rat__def,axiom,
    uminus_uminus(rat) = aa(fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat),aTP_Lamp_abp(product_prod(int,int),product_prod(int,int))) ).

% uminus_rat_def
tff(fact_3907_Max_Oeq__fold_H,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B)] : ( aa(set(B),B,lattic643756798349783984er_Max(B),A3) = aa(option(B),B,the2(B),finite_fold(B,option(B),aTP_Lamp_abz(B,fun(option(B),option(B))),none(B),A3)) ) ) ).

% Max.eq_fold'
tff(fact_3908_Gcd__fin_Oeq__fold,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(B)] :
          ( aa(set(B),B,semiring_gcd_Gcd_fin(B),A3)
          = $ite(aa(set(B),$o,finite_finite2(B),A3),finite_fold(B,B,gcd_gcd(B),zero_zero(B),A3),one_one(B)) ) ) ).

% Gcd_fin.eq_fold
tff(fact_3909_plus__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(product_prod(int,int),product_prod(int,int)),ratrel,bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel)),aTP_Lamp_abm(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),aTP_Lamp_abm(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% plus_rat.rsp
tff(fact_3910_inverse__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),product_prod(int,int)),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(product_prod(int,int),product_prod(int,int)),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel),aTP_Lamp_abn(product_prod(int,int),product_prod(int,int))),aTP_Lamp_abn(product_prod(int,int),product_prod(int,int))) ).

% inverse_rat.rsp
tff(fact_3911_max_Oidem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),A4),A4) = A4 ) ) ).

% max.idem
tff(fact_3912_max_Oleft__idem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),A4),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) ) ) ).

% max.left_idem
tff(fact_3913_max_Oright__idem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)),B3) = aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) ) ) ).

% max.right_idem
tff(fact_3914_max_Oabsorb1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) = A4 ) ) ) ).

% max.absorb1
tff(fact_3915_max_Oabsorb2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) = B3 ) ) ) ).

% max.absorb2
tff(fact_3916_max_Obounded__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_max(B),B3),Ca)),A4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),A4) ) ) ) ).

% max.bounded_iff
tff(fact_3917_max__less__iff__conj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y)),Z2)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Z2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),Z2) ) ) ) ).

% max_less_iff_conj
tff(fact_3918_max_Oabsorb4,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),B3)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) = B3 ) ) ) ).

% max.absorb4
tff(fact_3919_max_Oabsorb3,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) = A4 ) ) ) ).

% max.absorb3
tff(fact_3920_max__bot2,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),X2),bot_bot(B)) = X2 ) ) ).

% max_bot2
tff(fact_3921_max__bot,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),bot_bot(B)),X2) = X2 ) ) ).

% max_bot
tff(fact_3922_max__top,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),top_top(B)),X2) = top_top(B) ) ) ).

% max_top
tff(fact_3923_max__top2,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),X2),top_top(B)) = top_top(B) ) ) ).

% max_top2
tff(fact_3924_max__min__same_I1_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),X2),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y)) = X2 ) ) ).

% max_min_same(1)
tff(fact_3925_max__min__same_I2_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y)),X2) = X2 ) ) ).

% max_min_same(2)
tff(fact_3926_max__min__same_I3_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y)),Y) = Y ) ) ).

% max_min_same(3)
tff(fact_3927_max__min__same_I4_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Y: B,X2: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),Y),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y)) = Y ) ) ).

% max_min_same(4)
tff(fact_3928_of__bool__or__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Pa: $o,Qa: $o] :
          ( aa($o,B,zero_neq_one_of_bool(B),
              (Pa)
            | (Qa))
          = aa(B,B,aa(B,fun(B,B),ord_max(B),aa($o,B,zero_neq_one_of_bool(B),Pa)),aa($o,B,zero_neq_one_of_bool(B),Qa)) ) ) ).

% of_bool_or_iff
tff(fact_3929_max__0__1_I1_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ( aa(B,B,aa(B,fun(B,B),ord_max(B),zero_zero(B)),one_one(B)) = one_one(B) ) ) ).

% max_0_1(1)
tff(fact_3930_max__0__1_I2_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ( aa(B,B,aa(B,fun(B,B),ord_max(B),one_one(B)),zero_zero(B)) = one_one(B) ) ) ).

% max_0_1(2)
tff(fact_3931_max__0__1_I6_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [X2: num] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(num,B,numeral_numeral(B),X2)),one_one(B)) = aa(num,B,numeral_numeral(B),X2) ) ) ).

% max_0_1(6)
tff(fact_3932_max__0__1_I5_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [X2: num] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),one_one(B)),aa(num,B,numeral_numeral(B),X2)) = aa(num,B,numeral_numeral(B),X2) ) ) ).

% max_0_1(5)
tff(fact_3933_Gcd__fin_Oempty,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ( aa(set(B),B,semiring_gcd_Gcd_fin(B),bot_bot(set(B))) = zero_zero(B) ) ) ).

% Gcd_fin.empty
tff(fact_3934_Gcd__fin_Oinfinite,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(B)] :
          ( ~ aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),B,semiring_gcd_Gcd_fin(B),A3) = one_one(B) ) ) ) ).

% Gcd_fin.infinite
tff(fact_3935_is__unit__Gcd__fin__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(B)] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(set(B),B,semiring_gcd_Gcd_fin(B),A3)),one_one(B))
        <=> ( aa(set(B),B,semiring_gcd_Gcd_fin(B),A3) = one_one(B) ) ) ) ).

% is_unit_Gcd_fin_iff
tff(fact_3936_Int__atLeastAtMost,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,A4,B3)),set_or1337092689740270186AtMost(B,Ca,D3)) = set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A4),Ca),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),D3)) ) ) ).

% Int_atLeastAtMost
tff(fact_3937_Int__atLeastLessThan,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or7035219750837199246ssThan(B,A4,B3)),set_or7035219750837199246ssThan(B,Ca,D3)) = set_or7035219750837199246ssThan(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A4),Ca),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),D3)) ) ) ).

% Int_atLeastLessThan
tff(fact_3938_Int__atLeastAtMostR2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,Ca: B,D3: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_atLeast(B),A4)),set_or1337092689740270186AtMost(B,Ca,D3)) = set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A4),Ca),D3) ) ) ).

% Int_atLeastAtMostR2
tff(fact_3939_Int__atLeastAtMostL2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,A4,B3)),aa(B,set(B),set_ord_atLeast(B),Ca)) = set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A4),Ca),B3) ) ) ).

% Int_atLeastAtMostL2
tff(fact_3940_Max__insert,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(B),set(B),insert(B,X2),A3)) = aa(B,B,aa(B,fun(B,B),ord_max(B),X2),aa(set(B),B,lattic643756798349783984er_Max(B),A3)) ) ) ) ) ).

% Max_insert
tff(fact_3941_max__add__distrib__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y)),Z2) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Z2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Y),Z2)) ) ) ).

% max_add_distrib_left
tff(fact_3942_max__add__distrib__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),aa(B,B,aa(B,fun(B,B),ord_max(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y)),aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Z2)) ) ) ).

% max_add_distrib_right
tff(fact_3943_max__diff__distrib__left,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [X2: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y)),Z2) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),Z2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Y),Z2)) ) ) ).

% max_diff_distrib_left
tff(fact_3944_sup__max,axiom,
    ! [B: $tType] :
      ( ( semilattice_sup(B)
        & linorder(B) )
     => ( sup_sup(B) = ord_max(B) ) ) ).

% sup_max
tff(fact_3945_max__def__raw,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [X4: B,Xa3: B] :
          ( aa(B,B,aa(B,fun(B,B),ord_max(B),X4),Xa3)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),Xa3),Xa3,X4) ) ) ).

% max_def_raw
tff(fact_3946_less__max__iff__disj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),X2)
            | aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),Y) ) ) ) ).

% less_max_iff_disj
tff(fact_3947_max_Ostrict__boundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),ord_max(B),B3),Ca)),A4)
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),A4) ) ) ) ).

% max.strict_boundedE
tff(fact_3948_max_Ostrict__order__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B3),A4)
        <=> ( ( A4 = aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) )
            & ( A4 != B3 ) ) ) ) ).

% max.strict_order_iff
tff(fact_3949_max_Ostrict__coboundedI1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)) ) ) ).

% max.strict_coboundedI1
tff(fact_3950_max_Ostrict__coboundedI2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ca),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)) ) ) ).

% max.strict_coboundedI2
tff(fact_3951_max__absorb2,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y) = Y ) ) ) ).

% max_absorb2
tff(fact_3952_max__absorb1,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Y: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y) = X2 ) ) ) ).

% max_absorb1
tff(fact_3953_max__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A4: B,B3: B] :
          ( aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3),B3,A4) ) ) ).

% max_def
tff(fact_3954_max_OcoboundedI2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ca: B,B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),B3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)) ) ) ).

% max.coboundedI2
tff(fact_3955_max_OcoboundedI1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),A4)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)) ) ) ).

% max.coboundedI1
tff(fact_3956_max_Oabsorb__iff2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),B3)
        <=> ( aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) = B3 ) ) ) ).

% max.absorb_iff2
tff(fact_3957_max_Oabsorb__iff1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
        <=> ( aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) = A4 ) ) ) ).

% max.absorb_iff1
tff(fact_3958_le__max__iff__disj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Z2: B,X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),X2)
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),Y) ) ) ) ).

% le_max_iff_disj
tff(fact_3959_max_Ocobounded2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)) ) ).

% max.cobounded2
tff(fact_3960_max_Ocobounded1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)) ) ).

% max.cobounded1
tff(fact_3961_max_Oorder__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
        <=> ( A4 = aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) ) ) ) ).

% max.order_iff
tff(fact_3962_max_OboundedI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),A4)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_max(B),B3),Ca)),A4) ) ) ) ).

% max.boundedI
tff(fact_3963_max_OboundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_max(B),B3),Ca)),A4)
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),A4) ) ) ) ).

% max.boundedE
tff(fact_3964_max_OorderI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ).

% max.orderI
tff(fact_3965_max_OorderE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
         => ( A4 = aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) ) ) ) ).

% max.orderE
tff(fact_3966_max_Omono,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ca: B,A4: B,D3: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ca),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),D3),B3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_max(B),Ca),D3)),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)) ) ) ) ).

% max.mono
tff(fact_3967_max__min__distrib1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,Ca: B,A4: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),Ca)),A4) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),ord_max(B),B3),A4)),aa(B,B,aa(B,fun(B,B),ord_max(B),Ca),A4)) ) ) ).

% max_min_distrib1
tff(fact_3968_max__min__distrib2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),A4),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),Ca)) ) ) ).

% max_min_distrib2
tff(fact_3969_min__max__distrib1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,Ca: B,A4: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),ord_max(B),B3),Ca)),A4) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),A4)),aa(B,B,aa(B,fun(B,B),ord_min(B),Ca),A4)) ) ) ).

% min_max_distrib1
tff(fact_3970_min__max__distrib2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),A4),aa(B,B,aa(B,fun(B,B),ord_max(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),B3)),aa(B,B,aa(B,fun(B,B),ord_min(B),A4),Ca)) ) ) ).

% min_max_distrib2
tff(fact_3971_max__of__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [F2: fun(B,C),M2: B,N: B] :
          ( order_mono(B,C,F2)
         => ( aa(C,C,aa(C,fun(C,C),ord_max(C),aa(B,C,F2,M2)),aa(B,C,F2,N)) = aa(B,C,F2,aa(B,B,aa(B,fun(B,B),ord_max(B),M2),N)) ) ) ) ).

% max_of_mono
tff(fact_3972_max_Oassoc,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),ord_max(B),A4),aa(B,B,aa(B,fun(B,B),ord_max(B),B3),Ca)) ) ) ).

% max.assoc
tff(fact_3973_max_Ocommute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3) = aa(B,B,aa(B,fun(B,B),ord_max(B),B3),A4) ) ) ).

% max.commute
tff(fact_3974_max_Oleft__commute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [B3: B,A4: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),B3),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),Ca)) = aa(B,B,aa(B,fun(B,B),ord_max(B),A4),aa(B,B,aa(B,fun(B,B),ord_max(B),B3),Ca)) ) ) ).

% max.left_commute
tff(fact_3975_max_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semigroup(B,ord_max(B)) ) ).

% max.semigroup_axioms
tff(fact_3976_minus__max__eq__min,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [X2: B,Y: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y)) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,uminus_uminus(B),X2)),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% minus_max_eq_min
tff(fact_3977_minus__min__eq__max,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [X2: B,Y: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y)) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,uminus_uminus(B),X2)),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% minus_min_eq_max
tff(fact_3978_lessThan__Int__lessThan,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_greaterThan(B),A4)),aa(B,set(B),set_ord_greaterThan(B),B3)) = aa(B,set(B),set_ord_greaterThan(B),aa(B,B,aa(B,fun(B,B),ord_max(B),A4),B3)) ) ) ).

% lessThan_Int_lessThan
tff(fact_3979_max__Suc1,axiom,
    ! [N: nat,M2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,N)),M2) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),aa(nat,nat,suc,N)),aTP_Lamp_aca(nat,fun(nat,nat),N)),M2) ) ).

% max_Suc1
tff(fact_3980_max__Suc2,axiom,
    ! [M2: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M2),aa(nat,nat,suc,N)) = aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),case_nat(nat),aa(nat,nat,suc,N)),aTP_Lamp_acb(nat,fun(nat,nat),N)),M2) ) ).

% max_Suc2
tff(fact_3981_max__mult__distrib__left,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [P3: B,X2: B,Y: B] :
          ( aa(B,B,aa(B,fun(B,B),times_times(B),P3),aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),P3),aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),times_times(B),P3),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),P3),Y)),aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),times_times(B),P3),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),P3),Y))) ) ) ).

% max_mult_distrib_left
tff(fact_3982_min__mult__distrib__left,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [P3: B,X2: B,Y: B] :
          ( aa(B,B,aa(B,fun(B,B),times_times(B),P3),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),P3),aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),times_times(B),P3),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),P3),Y)),aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),times_times(B),P3),X2)),aa(B,B,aa(B,fun(B,B),times_times(B),P3),Y))) ) ) ).

% min_mult_distrib_left
tff(fact_3983_max__mult__distrib__right,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B,Y: B,P3: B] :
          ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y)),P3)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),P3),aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),P3)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),P3)),aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),P3)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),P3))) ) ) ).

% max_mult_distrib_right
tff(fact_3984_min__mult__distrib__right,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X2: B,Y: B,P3: B] :
          ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y)),P3)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),P3),aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),P3)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),P3)),aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),times_times(B),X2),P3)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),P3))) ) ) ).

% min_mult_distrib_right
tff(fact_3985_Fract_Orsp,axiom,
    aa(fun(int,fun(int,product_prod(int,int))),$o,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,product_prod(int,int))),$o),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,product_prod(int,int)),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),product_prod(int,int),fequal(int),ratrel)),aTP_Lamp_acc(int,fun(int,product_prod(int,int)))),aTP_Lamp_acc(int,fun(int,product_prod(int,int)))) ).

% Fract.rsp
tff(fact_3986_Sup__insert__finite,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [S: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert(B,X2),S))
            = $ite(S = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),ord_max(B),X2),aa(set(B),B,complete_Sup_Sup(B),S))) ) ) ) ).

% Sup_insert_finite
tff(fact_3987_hom__Max__commute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [H2: fun(B,B),N3: set(B)] :
          ( ! [X: B,Y2: B] : ( aa(B,B,H2,aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y2)) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,H2,X)),aa(B,B,H2,Y2)) )
         => ( aa(set(B),$o,finite_finite2(B),N3)
           => ( ( N3 != bot_bot(set(B)) )
             => ( aa(B,B,H2,aa(set(B),B,lattic643756798349783984er_Max(B),N3)) = aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(B),set(B),image2(B,B,H2),N3)) ) ) ) ) ) ).

% hom_Max_commute
tff(fact_3988_Max_Osubset,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( B2 != bot_bot(set(B)) )
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A3)
             => ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(set(B),B,lattic643756798349783984er_Max(B),B2)),aa(set(B),B,lattic643756798349783984er_Max(B),A3)) = aa(set(B),B,lattic643756798349783984er_Max(B),A3) ) ) ) ) ) ).

% Max.subset
tff(fact_3989_Max_Oclosed,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [X: B,Y2: B] : aa(set(B),$o,member(B,aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y2)),aa(set(B),set(B),insert(B,X),aa(set(B),set(B),insert(B,Y2),bot_bot(set(B)))))
             => aa(set(B),$o,member(B,aa(set(B),B,lattic643756798349783984er_Max(B),A3)),A3) ) ) ) ) ).

% Max.closed
tff(fact_3990_Max_Oinsert__not__elem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ~ aa(set(B),$o,member(B,X2),A3)
           => ( ( A3 != bot_bot(set(B)) )
             => ( aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(B),set(B),insert(B,X2),A3)) = aa(B,B,aa(B,fun(B,B),ord_max(B),X2),aa(set(B),B,lattic643756798349783984er_Max(B),A3)) ) ) ) ) ) ).

% Max.insert_not_elem
tff(fact_3991_Max_Ounion,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite2(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(set(B),B,lattic643756798349783984er_Max(B),A3)),aa(set(B),B,lattic643756798349783984er_Max(B),B2)) ) ) ) ) ) ) ).

% Max.union
tff(fact_3992_Max_Oremove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,member(B,X2),A3)
           => ( aa(set(B),B,lattic643756798349783984er_Max(B),A3)
              = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),ord_max(B),X2),aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))))) ) ) ) ) ).

% Max.remove
tff(fact_3993_Max_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(B),set(B),insert(B,X2),A3))
            = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),ord_max(B),X2),aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))))) ) ) ) ).

% Max.insert_remove
tff(fact_3994_Gcd__fin_Oremove,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,A3: set(B)] :
          ( aa(set(B),$o,member(B,A4),A3)
         => ( aa(set(B),B,semiring_gcd_Gcd_fin(B),A3) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),aa(set(B),B,semiring_gcd_Gcd_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) ) ) ).

% Gcd_fin.remove
tff(fact_3995_Gcd__fin_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,A3: set(B)] : ( aa(set(B),B,semiring_gcd_Gcd_fin(B),aa(set(B),set(B),insert(B,A4),A3)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),aa(set(B),B,semiring_gcd_Gcd_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) ) ).

% Gcd_fin.insert_remove
tff(fact_3996_of__rat_Orsp,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => aa(fun(product_prod(int,int),B),$o,aa(fun(product_prod(int,int),B),fun(fun(product_prod(int,int),B),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),B,B,ratrel,fequal(B)),aTP_Lamp_abs(product_prod(int,int),B)),aTP_Lamp_abs(product_prod(int,int),B)) ) ).

% of_rat.rsp
tff(fact_3997_ratrel__def,axiom,
    ! [X4: product_prod(int,int),Xa3: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X4),Xa3)
    <=> ( ( aa(product_prod(int,int),int,product_snd(int,int),X4) != zero_zero(int) )
        & ( aa(product_prod(int,int),int,product_snd(int,int),Xa3) != zero_zero(int) )
        & ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),X4)),aa(product_prod(int,int),int,product_snd(int,int),Xa3)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa3)),aa(product_prod(int,int),int,product_snd(int,int),X4)) ) ) ) ).

% ratrel_def
tff(fact_3998_times__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(product_prod(int,int),product_prod(int,int)),ratrel,bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel)),aTP_Lamp_abq(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),aTP_Lamp_abq(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% times_rat.rsp
tff(fact_3999_uminus__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),product_prod(int,int)),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(product_prod(int,int),product_prod(int,int)),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel),aTP_Lamp_abp(product_prod(int,int),product_prod(int,int))),aTP_Lamp_abp(product_prod(int,int),product_prod(int,int))) ).

% uminus_rat.rsp
tff(fact_4000_max__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,ord_max(nat),zero_zero(nat),aTP_Lamp_ra(nat,fun(nat,$o)),aTP_Lamp_th(nat,fun(nat,$o))) ).

% max_nat.semilattice_neutr_order_axioms
tff(fact_4001_Gcd__fin__0__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(B)] :
          ( ( aa(set(B),B,semiring_gcd_Gcd_fin(B),A3) = zero_zero(B) )
        <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(B),set(B),insert(B,zero_zero(B)),bot_bot(set(B))))
            & aa(set(B),$o,finite_finite2(B),A3) ) ) ) ).

% Gcd_fin_0_iff
tff(fact_4002_positive_Orsp,axiom,
    aa(fun(product_prod(int,int),$o),$o,aa(fun(product_prod(int,int),$o),fun(fun(product_prod(int,int),$o),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),$o,$o,ratrel,fequal($o)),aTP_Lamp_abr(product_prod(int,int),$o)),aTP_Lamp_abr(product_prod(int,int),$o)) ).

% positive.rsp
tff(fact_4003_cr__rat__def,axiom,
    ! [X4: product_prod(int,int),Xa3: rat] :
      ( cr_rat(X4,Xa3)
    <=> ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X4),X4)
        & ( aa(product_prod(int,int),rat,abs_Rat,X4) = Xa3 ) ) ) ).

% cr_rat_def
tff(fact_4004_dual__min,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( min(B,aTP_Lamp_px(B,fun(B,$o))) = ord_max(B) ) ) ).

% dual_min
tff(fact_4005_numeral__xor__num,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [M2: num,N: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),M2)),aa(num,B,numeral_numeral(B),N)) = case_option(B,num,zero_zero(B),numeral_numeral(B),bit_un2480387367778600638or_num(M2,N)) ) ) ).

% numeral_xor_num
tff(fact_4006_the__dflt__None__nonempty,axiom,
    ! [B: $tType,S: set(B)] :
      ( ( S != bot_bot(set(B)) )
     => ( dflt_None_set(B,S) = aa(set(B),option(set(B)),some(set(B)),S) ) ) ).

% the_dflt_None_nonempty
tff(fact_4007_the__dflt__None__empty,axiom,
    ! [B: $tType] : ( dflt_None_set(B,bot_bot(set(B))) = none(set(B)) ) ).

% the_dflt_None_empty
tff(fact_4008_ord_Omin_Ocong,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o))] : ( min(B,Less_eq) = min(B,Less_eq) ) ).

% ord.min.cong
tff(fact_4009_ord_Omin__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( aa(B,B,aa(B,fun(B,B),min(B,Less_eq),A4),B3)
      = $ite(aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3),A4,B3) ) ).

% ord.min_def
tff(fact_4010_dflt__None__set__def,axiom,
    ! [B: $tType,S: set(B)] :
      ( dflt_None_set(B,S)
      = $ite(S = bot_bot(set(B)),none(set(B)),aa(set(B),option(set(B)),some(set(B)),S)) ) ).

% dflt_None_set_def
tff(fact_4011_the__dflt__None__set,axiom,
    ! [B: $tType,X2: set(B)] : ( the_default(set(B),bot_bot(set(B)),dflt_None_set(B,X2)) = X2 ) ).

% the_dflt_None_set
tff(fact_4012_and__not__num_Opelims,axiom,
    ! [X2: num,Xa: num,Y: option(num)] :
      ( ( bit_and_not_num(X2,Xa) = Y )
     => ( aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X2),Xa))
       => ( ( ( X2 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = none(num) )
               => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2)) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N2: num] :
                  ( ( Xa = aa(num,num,bit0,N2) )
                 => ( ( Y = aa(num,option(num),some(num),one2) )
                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N2))) ) ) )
           => ( ( ( X2 = one2 )
               => ! [N2: num] :
                    ( ( Xa = aa(num,num,bit1,N2) )
                   => ( ( Y = none(num) )
                     => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N2))) ) ) )
             => ( ! [M3: num] :
                    ( ( X2 = aa(num,num,bit0,M3) )
                   => ( ( Xa = one2 )
                     => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,M3)) )
                       => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),one2)) ) ) )
               => ( ! [M3: num] :
                      ( ( X2 = aa(num,num,bit0,M3) )
                     => ! [N2: num] :
                          ( ( Xa = aa(num,num,bit0,N2) )
                         => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) )
                           => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),aa(num,num,bit0,N2))) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2 = aa(num,num,bit0,M3) )
                       => ! [N2: num] :
                            ( ( Xa = aa(num,num,bit1,N2) )
                           => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),aa(num,num,bit1,N2))) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2 = aa(num,num,bit1,M3) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,M3)) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),one2)) ) ) )
                     => ( ! [M3: num] :
                            ( ( X2 = aa(num,num,bit1,M3) )
                           => ! [N2: num] :
                                ( ( Xa = aa(num,num,bit0,N2) )
                               => ( ( Y = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aai(num,option(num)),bit_and_not_num(M3,N2)) )
                                 => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),aa(num,num,bit0,N2))) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X2 = aa(num,num,bit1,M3) )
                             => ! [N2: num] :
                                  ( ( Xa = aa(num,num,bit1,N2) )
                                 => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N2)) )
                                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),aa(num,num,bit1,N2))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
tff(fact_4013_ivl__disj__un__singleton_I3_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [L: B,U: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),L),U)
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert(B,L),bot_bot(set(B)))),set_or5935395276787703475ssThan(B,L,U)) = set_or7035219750837199246ssThan(B,L,U) ) ) ) ).

% ivl_disj_un_singleton(3)
tff(fact_4014_and__num_Opelims,axiom,
    ! [X2: num,Xa: num,Y: option(num)] :
      ( ( bit_un7362597486090784418nd_num(X2,Xa) = Y )
     => ( aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X2),Xa))
       => ( ( ( X2 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = aa(num,option(num),some(num),one2) )
               => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2)) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N2: num] :
                  ( ( Xa = aa(num,num,bit0,N2) )
                 => ( ( Y = none(num) )
                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N2))) ) ) )
           => ( ( ( X2 = one2 )
               => ! [N2: num] :
                    ( ( Xa = aa(num,num,bit1,N2) )
                   => ( ( Y = aa(num,option(num),some(num),one2) )
                     => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N2))) ) ) )
             => ( ! [M3: num] :
                    ( ( X2 = aa(num,num,bit0,M3) )
                   => ( ( Xa = one2 )
                     => ( ( Y = none(num) )
                       => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),one2)) ) ) )
               => ( ! [M3: num] :
                      ( ( X2 = aa(num,num,bit0,M3) )
                     => ! [N2: num] :
                          ( ( Xa = aa(num,num,bit0,N2) )
                         => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) )
                           => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),aa(num,num,bit0,N2))) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2 = aa(num,num,bit0,M3) )
                       => ! [N2: num] :
                            ( ( Xa = aa(num,num,bit1,N2) )
                           => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),aa(num,num,bit1,N2))) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2 = aa(num,num,bit1,M3) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,option(num),some(num),one2) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),one2)) ) ) )
                     => ( ! [M3: num] :
                            ( ( X2 = aa(num,num,bit1,M3) )
                           => ! [N2: num] :
                                ( ( Xa = aa(num,num,bit0,N2) )
                               => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M3,N2)) )
                                 => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),aa(num,num,bit0,N2))) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X2 = aa(num,num,bit1,M3) )
                             => ! [N2: num] :
                                  ( ( Xa = aa(num,num,bit1,N2) )
                                 => ( ( Y = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_aai(num,option(num)),bit_un7362597486090784418nd_num(M3,N2)) )
                                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),aa(num,num,bit1,N2))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
tff(fact_4015_greaterThanLessThan__empty,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,K: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),L),K)
         => ( set_or5935395276787703475ssThan(B,K,L) = bot_bot(set(B)) ) ) ) ).

% greaterThanLessThan_empty
tff(fact_4016_greaterThanLessThan__empty__iff,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [A4: B,B3: B] :
          ( ( set_or5935395276787703475ssThan(B,A4,B3) = bot_bot(set(B)) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ).

% greaterThanLessThan_empty_iff
tff(fact_4017_greaterThanLessThan__empty__iff2,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [A4: B,B3: B] :
          ( ( bot_bot(set(B)) = set_or5935395276787703475ssThan(B,A4,B3) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4) ) ) ).

% greaterThanLessThan_empty_iff2
tff(fact_4018_Int__greaterThanLessThan,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or5935395276787703475ssThan(B,A4,B3)),set_or5935395276787703475ssThan(B,Ca,D3)) = set_or5935395276787703475ssThan(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A4),Ca),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),D3)) ) ) ).

% Int_greaterThanLessThan
tff(fact_4019_ivl__disj__int__two_I5_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M2: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or5935395276787703475ssThan(B,L,M2)),set_or1337092689740270186AtMost(B,M2,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(5)
tff(fact_4020_ivl__disj__int__two_I4_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M2: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,L,M2)),set_or5935395276787703475ssThan(B,M2,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(4)
tff(fact_4021_ivl__disj__int__two_I1_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M2: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or5935395276787703475ssThan(B,L,M2)),set_or7035219750837199246ssThan(B,M2,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(1)
tff(fact_4022_ivl__disj__int__one_I1_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_atMost(B),L)),set_or5935395276787703475ssThan(B,L,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(1)
tff(fact_4023_ivl__disj__int__one_I6_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or5935395276787703475ssThan(B,L,U)),aa(B,set(B),set_ord_atLeast(B),U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(6)
tff(fact_4024_greaterThanLessThan__eq,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A4: B,B3: B] : ( set_or5935395276787703475ssThan(B,A4,B3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_greaterThan(B),A4)),aa(B,set(B),set_ord_lessThan(B),B3)) ) ) ).

% greaterThanLessThan_eq
tff(fact_4025_greaterThanLessThan__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [L: B,U: B] : ( set_or5935395276787703475ssThan(B,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_greaterThan(B),L)),aa(B,set(B),set_ord_lessThan(B),U)) ) ) ).

% greaterThanLessThan_def
tff(fact_4026_atLeastAtMost__diff__ends,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),set_or1337092689740270186AtMost(B,A4,B3)),aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))) = set_or5935395276787703475ssThan(B,A4,B3) ) ) ).

% atLeastAtMost_diff_ends
tff(fact_4027_interval__cases,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [S: set(B)] :
          ( ! [A5: B,B4: B,X: B] :
              ( aa(set(B),$o,member(B,A5),S)
             => ( aa(set(B),$o,member(B,B4),S)
               => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A5),X)
                 => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),B4)
                   => aa(set(B),$o,member(B,X),S) ) ) ) )
         => ? [A5: B,B4: B] :
              ( ( S = bot_bot(set(B)) )
              | ( S = top_top(set(B)) )
              | ( S = aa(B,set(B),set_ord_lessThan(B),B4) )
              | ( S = aa(B,set(B),set_ord_atMost(B),B4) )
              | ( S = aa(B,set(B),set_ord_greaterThan(B),A5) )
              | ( S = aa(B,set(B),set_ord_atLeast(B),A5) )
              | ( S = set_or5935395276787703475ssThan(B,A5,B4) )
              | ( S = set_or3652927894154168847AtMost(B,A5,B4) )
              | ( S = set_or7035219750837199246ssThan(B,A5,B4) )
              | ( S = set_or1337092689740270186AtMost(B,A5,B4) ) ) ) ) ).

% interval_cases
tff(fact_4028_set__to__map__empty,axiom,
    ! [B: $tType,C: $tType,X4: B] : ( aa(B,option(C),set_to_map(B,C,bot_bot(set(product_prod(B,C)))),X4) = none(C) ) ).

% set_to_map_empty
tff(fact_4029_bot_Oordering__top__axioms,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ordering_top(B,aTP_Lamp_acd(B,fun(B,$o)),aTP_Lamp_ace(B,fun(B,$o)),bot_bot(B)) ) ).

% bot.ordering_top_axioms
tff(fact_4030_euclidean__size__times__nonunit,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( ( B3 != zero_zero(B) )
           => ( ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
             => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(B,B3)),euclid6346220572633701492n_size(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))) ) ) ) ) ).

% euclidean_size_times_nonunit
tff(fact_4031_greaterThanAtMost__empty,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,K: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),L),K)
         => ( set_or3652927894154168847AtMost(B,K,L) = bot_bot(set(B)) ) ) ) ).

% greaterThanAtMost_empty
tff(fact_4032_greaterThanAtMost__empty__iff2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [K: B,L: B] :
          ( ( bot_bot(set(B)) = set_or3652927894154168847AtMost(B,K,L) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),L) ) ) ).

% greaterThanAtMost_empty_iff2
tff(fact_4033_greaterThanAtMost__empty__iff,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [K: B,L: B] :
          ( ( set_or3652927894154168847AtMost(B,K,L) = bot_bot(set(B)) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),L) ) ) ).

% greaterThanAtMost_empty_iff
tff(fact_4034_euclidean__size__1,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ( euclid6346220572633701492n_size(B,one_one(B)) = one_one(nat) ) ) ).

% euclidean_size_1
tff(fact_4035_Int__greaterThanAtMost,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or3652927894154168847AtMost(B,A4,B3)),set_or3652927894154168847AtMost(B,Ca,D3)) = set_or3652927894154168847AtMost(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A4),Ca),aa(B,B,aa(B,fun(B,B),ord_min(B),B3),D3)) ) ) ).

% Int_greaterThanAtMost
tff(fact_4036_ordering__top_Oextremum__uniqueI,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B,A4: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,Top),A4)
       => ( A4 = Top ) ) ) ).

% ordering_top.extremum_uniqueI
tff(fact_4037_ordering__top_Onot__eq__extremum,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B,A4: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ( ( A4 != Top )
      <=> aa(B,$o,aa(B,fun(B,$o),Less,A4),Top) ) ) ).

% ordering_top.not_eq_extremum
tff(fact_4038_ordering__top_Oextremum__unique,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B,A4: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,Top),A4)
      <=> ( A4 = Top ) ) ) ).

% ordering_top.extremum_unique
tff(fact_4039_ordering__top_Oextremum__strict,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B,A4: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ~ aa(B,$o,aa(B,fun(B,$o),Less,Top),A4) ) ).

% ordering_top.extremum_strict
tff(fact_4040_ordering__top_Oextremum,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B,A4: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),Top) ) ).

% ordering_top.extremum
tff(fact_4041_ivl__disj__int__two_I6_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M2: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or3652927894154168847AtMost(B,L,M2)),set_or3652927894154168847AtMost(B,M2,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(6)
tff(fact_4042_euclidean__size__unit,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( euclid6346220572633701492n_size(B,A4) = euclid6346220572633701492n_size(B,one_one(B)) ) ) ) ).

% euclidean_size_unit
tff(fact_4043_euclidean__size__mult,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [A4: B,B3: B] : ( euclid6346220572633701492n_size(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),euclid6346220572633701492n_size(B,A4)),euclid6346220572633701492n_size(B,B3)) ) ) ).

% euclidean_size_mult
tff(fact_4044_Ioc__disjoint,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,B3: B,Ca: B,D3: B] :
          ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or3652927894154168847AtMost(B,A4,B3)),set_or3652927894154168847AtMost(B,Ca,D3)) = bot_bot(set(B)) )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),A4)
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),D3),Ca)
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B3),Ca)
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),D3),A4) ) ) ) ).

% Ioc_disjoint
tff(fact_4045_ivl__disj__int__two_I8_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M2: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,L,M2)),set_or3652927894154168847AtMost(B,M2,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(8)
tff(fact_4046_ivl__disj__int__one_I3_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_atMost(B),L)),set_or3652927894154168847AtMost(B,L,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(3)
tff(fact_4047_unit__iff__euclidean__size,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
        <=> ( ( euclid6346220572633701492n_size(B,A4) = euclid6346220572633701492n_size(B,one_one(B)) )
            & ( A4 != zero_zero(B) ) ) ) ) ).

% unit_iff_euclidean_size
tff(fact_4048_size__mult__mono_H,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [B3: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),euclid6346220572633701492n_size(B,A4)),euclid6346220572633701492n_size(B,aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4))) ) ) ).

% size_mult_mono'
tff(fact_4049_size__mult__mono,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [B3: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),euclid6346220572633701492n_size(B,A4)),euclid6346220572633701492n_size(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))) ) ) ).

% size_mult_mono
tff(fact_4050_euclidean__size__times__unit,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( euclid6346220572633701492n_size(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = euclid6346220572633701492n_size(B,B3) ) ) ) ).

% euclidean_size_times_unit
tff(fact_4051_ivl__disj__int__two_I2_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M2: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or3652927894154168847AtMost(B,L,M2)),set_or5935395276787703475ssThan(B,M2,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(2)
tff(fact_4052_ivl__disj__int__one_I5_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or3652927894154168847AtMost(B,L,U)),aa(B,set(B),set_ord_greaterThan(B),U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(5)
tff(fact_4053_greaterThanAtMost__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [L: B,U: B] : ( set_or3652927894154168847AtMost(B,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_greaterThan(B),L)),aa(B,set(B),set_ord_atMost(B),U)) ) ) ).

% greaterThanAtMost_def
tff(fact_4054_gcd__nat_Oordering__top__axioms,axiom,
    ordering_top(nat,dvd_dvd(nat),aTP_Lamp_abk(nat,fun(nat,$o)),zero_zero(nat)) ).

% gcd_nat.ordering_top_axioms
tff(fact_4055_set__to__map__empty__iff_I1_J,axiom,
    ! [C: $tType,B: $tType,S: set(product_prod(B,C))] :
      ( ! [X3: B] : ( aa(B,option(C),set_to_map(B,C,S),X3) = none(C) )
    <=> ( S = bot_bot(set(product_prod(B,C))) ) ) ).

% set_to_map_empty_iff(1)
tff(fact_4056_prod_Ohead,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M2: nat,N: nat,G: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or1337092689740270186AtMost(nat,M2,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,G,M2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),G),set_or3652927894154168847AtMost(nat,M2,N))) ) ) ) ).

% prod.head
tff(fact_4057_greaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: B,B3: B] : ( set_or3652927894154168847AtMost(B,A4,B3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),set_or1337092689740270186AtMost(B,A4,B3)),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) ) ) ).

% greaterThanAtMost_eq_atLeastAtMost_diff
tff(fact_4058_set__to__map__empty__iff_I2_J,axiom,
    ! [C: $tType,B: $tType,S: set(product_prod(B,C))] :
      ( ( aTP_Lamp_abb(B,option(C)) = set_to_map(B,C,S) )
    <=> ( S = bot_bot(set(product_prod(B,C))) ) ) ).

% set_to_map_empty_iff(2)
tff(fact_4059_top_Oordering__top__axioms,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ordering_top(B,ord_less_eq(B),ord_less(B),top_top(B)) ) ).

% top.ordering_top_axioms
tff(fact_4060_ivl__disj__un__singleton_I5_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [L: B,U: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),L),U)
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert(B,L),bot_bot(set(B)))),set_or3652927894154168847AtMost(B,L,U)) = set_or1337092689740270186AtMost(B,L,U) ) ) ) ).

% ivl_disj_un_singleton(5)
tff(fact_4061_bot__nat__0_Oordering__top__axioms,axiom,
    ordering_top(nat,aTP_Lamp_ra(nat,fun(nat,$o)),aTP_Lamp_th(nat,fun(nat,$o)),zero_zero(nat)) ).

% bot_nat_0.ordering_top_axioms
tff(fact_4062_ivl__disj__un__singleton_I4_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [L: B,U: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),L),U)
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),set_or5935395276787703475ssThan(B,L,U)),aa(set(B),set(B),insert(B,U),bot_bot(set(B)))) = set_or3652927894154168847AtMost(B,L,U) ) ) ) ).

% ivl_disj_un_singleton(4)
tff(fact_4063_divmod__cases,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [B3: B,A4: B] :
          ( ( ( B3 != zero_zero(B) )
           => ( ( modulo_modulo(B,A4,B3) = zero_zero(B) )
             => ( A4 != aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)),B3) ) ) )
         => ( ( ( B3 != zero_zero(B) )
             => ! [Q5: B,R3: B] :
                  ( ( euclid7384307370059645450egment(B,R3) = euclid7384307370059645450egment(B,B3) )
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(B,R3)),euclid6346220572633701492n_size(B,B3))
                   => ( ( R3 != zero_zero(B) )
                     => ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) = Q5 )
                       => ( ( modulo_modulo(B,A4,B3) = R3 )
                         => ( A4 != aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Q5),B3)),R3) ) ) ) ) ) ) )
           => ( B3 = zero_zero(B) ) ) ) ) ).

% divmod_cases
tff(fact_4064_mod__eqI,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [B3: B,R2: B,Q: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => ( ( euclid7384307370059645450egment(B,R2) = euclid7384307370059645450egment(B,B3) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(B,R2)),euclid6346220572633701492n_size(B,B3))
             => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Q),B3)),R2) = A4 )
               => ( modulo_modulo(B,A4,B3) = R2 ) ) ) ) ) ) ).

% mod_eqI
tff(fact_4065_div__bounded,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [B3: B,R2: B,Q: B] :
          ( ( B3 != zero_zero(B) )
         => ( ( euclid7384307370059645450egment(B,R2) = euclid7384307370059645450egment(B,B3) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(B,R2)),euclid6346220572633701492n_size(B,B3))
             => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Q),B3)),R2)),B3) = Q ) ) ) ) ) ).

% div_bounded
tff(fact_4066_div__eqI,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [B3: B,R2: B,Q: B,A4: B] :
          ( ( B3 != zero_zero(B) )
         => ( ( euclid7384307370059645450egment(B,R2) = euclid7384307370059645450egment(B,B3) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(B,R2)),euclid6346220572633701492n_size(B,B3))
             => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Q),B3)),R2) = A4 )
               => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3) = Q ) ) ) ) ) ) ).

% div_eqI
tff(fact_4067_division__segment__1,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ( euclid7384307370059645450egment(B,one_one(B)) = one_one(B) ) ) ).

% division_segment_1
tff(fact_4068_division__segment__numeral,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [K: num] : ( euclid7384307370059645450egment(B,aa(num,B,numeral_numeral(B),K)) = one_one(B) ) ) ).

% division_segment_numeral
tff(fact_4069_division__segment__of__nat,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat] : ( euclid7384307370059645450egment(B,aa(nat,B,semiring_1_of_nat(B),N)) = one_one(B) ) ) ).

% division_segment_of_nat
tff(fact_4070_division__segment__euclidean__size,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),euclid7384307370059645450egment(B,A4)),aa(nat,B,semiring_1_of_nat(B),euclid6346220572633701492n_size(B,A4))) = A4 ) ) ).

% division_segment_euclidean_size
tff(fact_4071_division__segment__mult,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( ( B3 != zero_zero(B) )
           => ( euclid7384307370059645450egment(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),euclid7384307370059645450egment(B,A4)),euclid7384307370059645450egment(B,B3)) ) ) ) ) ).

% division_segment_mult
tff(fact_4072_is__unit__division__segment,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),euclid7384307370059645450egment(B,A4)),one_one(B)) ) ).

% is_unit_division_segment
tff(fact_4073_numeral__num__of__nat__unfold,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat] :
          ( aa(num,B,numeral_numeral(B),num_of_nat(N))
          = $ite(N = zero_zero(nat),one_one(B),aa(nat,B,semiring_1_of_nat(B),N)) ) ) ).

% numeral_num_of_nat_unfold
tff(fact_4074_Max_Osemilattice__order__set__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => lattic4895041142388067077er_set(B,ord_max(B),aTP_Lamp_px(B,fun(B,$o)),aTP_Lamp_acf(B,fun(B,$o))) ) ).

% Max.semilattice_order_set_axioms
tff(fact_4075_set__to__map__def,axiom,
    ! [B: $tType,C: $tType,S: set(product_prod(C,B)),K: C] : ( aa(C,option(B),set_to_map(C,B,S),K) = eps_Opt(B,aa(C,fun(B,$o),aTP_Lamp_jo(set(product_prod(C,B)),fun(C,fun(B,$o)),S),K)) ) ).

% set_to_map_def
tff(fact_4076_Gcd__fin__def,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ( semiring_gcd_Gcd_fin(B) = bounde2362111253966948842tice_F(B,gcd_gcd(B),zero_zero(B),one_one(B)) ) ) ).

% Gcd_fin_def
tff(fact_4077_some__opt__eq__trivial,axiom,
    ! [B: $tType,X2: B] : ( eps_Opt(B,aTP_Lamp_ct(B,fun(B,$o),X2)) = aa(B,option(B),some(B),X2) ) ).

% some_opt_eq_trivial
tff(fact_4078_some__opt__false__trivial,axiom,
    ! [B: $tType] : ( eps_Opt(B,aTP_Lamp_ao(B,$o)) = none(B) ) ).

% some_opt_false_trivial
tff(fact_4079_Inf__fin_Osemilattice__order__set__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => lattic4895041142388067077er_set(B,inf_inf(B),ord_less_eq(B),ord_less(B)) ) ).

% Inf_fin.semilattice_order_set_axioms
tff(fact_4080_Sup__fin_Osemilattice__order__set__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => lattic4895041142388067077er_set(B,sup_sup(B),aTP_Lamp_acg(B,fun(B,$o)),aTP_Lamp_ach(B,fun(B,$o))) ) ).

% Sup_fin.semilattice_order_set_axioms
tff(fact_4081_bounded__quasi__semilattice__set_Oremove,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Top: B,Bot: B,Normalize: fun(B,B),A4: B,A3: set(B)] :
      ( bounde6485984586167503788ce_set(B,F2,Top,Bot,Normalize)
     => ( aa(set(B),$o,member(B,A4),A3)
       => ( aa(set(B),B,bounde2362111253966948842tice_F(B,F2,Top,Bot),A3) = aa(B,B,aa(B,fun(B,B),F2,A4),aa(set(B),B,bounde2362111253966948842tice_F(B,F2,Top,Bot),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) ) ) ).

% bounded_quasi_semilattice_set.remove
tff(fact_4082_bounded__quasi__semilattice__set_Oinsert__remove,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Top: B,Bot: B,Normalize: fun(B,B),A4: B,A3: set(B)] :
      ( bounde6485984586167503788ce_set(B,F2,Top,Bot,Normalize)
     => ( aa(set(B),B,bounde2362111253966948842tice_F(B,F2,Top,Bot),aa(set(B),set(B),insert(B,A4),A3)) = aa(B,B,aa(B,fun(B,B),F2,A4),aa(set(B),B,bounde2362111253966948842tice_F(B,F2,Top,Bot),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) ) ).

% bounded_quasi_semilattice_set.insert_remove
tff(fact_4083_dom__fun__upd,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,option(C)),X2: B,Y: option(C)] :
      ( dom(B,C,fun_upd(B,option(C),F2,X2,Y))
      = $ite(Y = none(C),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),dom(B,C,F2)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))),aa(set(B),set(B),insert(B,X2),dom(B,C,F2))) ) ).

% dom_fun_upd
tff(fact_4084_card__def,axiom,
    ! [B: $tType] : ( finite_card(B) = finite_folding_F(B,nat,aTP_Lamp_st(B,fun(nat,nat)),zero_zero(nat)) ) ).

% card_def
tff(fact_4085_dom__eq__empty__conv,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,option(C))] :
      ( ( dom(B,C,F2) = bot_bot(set(B)) )
    <=> ! [X3: B] : ( aa(B,option(C),F2,X3) = none(C) ) ) ).

% dom_eq_empty_conv
tff(fact_4086_dom__restrict,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),A3: set(B)] : ( dom(B,C,restrict_map(B,C,M2,A3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,M2)),A3) ) ).

% dom_restrict
tff(fact_4087_dom__empty,axiom,
    ! [C: $tType,B: $tType] : ( dom(B,C,aTP_Lamp_abb(B,option(C))) = bot_bot(set(B)) ) ).

% dom_empty
tff(fact_4088_map__update__eta__repair_I1_J,axiom,
    ! [C: $tType,B: $tType,K: B,V: C,M2: fun(B,option(C))] : ( dom(B,C,aa(fun(B,option(C)),fun(B,option(C)),aa(C,fun(fun(B,option(C)),fun(B,option(C))),aTP_Lamp_aci(B,fun(C,fun(fun(B,option(C)),fun(B,option(C)))),K),V),M2)) = aa(set(B),set(B),insert(B,K),dom(B,C,M2)) ) ).

% map_update_eta_repair(1)
tff(fact_4089_dom__const_H,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C)] : ( dom(B,C,aTP_Lamp_acj(fun(B,C),fun(B,option(C)),F2)) = top_top(set(B)) ) ).

% dom_const'
tff(fact_4090_dom__map__option,axiom,
    ! [C: $tType,D: $tType,B: $tType,F2: fun(B,fun(D,C)),M2: fun(B,option(D))] : ( dom(B,C,aa(fun(B,option(D)),fun(B,option(C)),aTP_Lamp_ack(fun(B,fun(D,C)),fun(fun(B,option(D)),fun(B,option(C))),F2),M2)) = dom(B,D,M2) ) ).

% dom_map_option
tff(fact_4091_dom__def,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C))] : ( dom(B,C,M2) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_acl(fun(B,option(C)),fun(B,$o),M2)) ) ).

% dom_def
tff(fact_4092_dom__if,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),F2: fun(B,option(C)),G: fun(B,option(C))] : ( dom(B,C,aa(fun(B,option(C)),fun(B,option(C)),aa(fun(B,option(C)),fun(fun(B,option(C)),fun(B,option(C))),aTP_Lamp_acm(fun(B,$o),fun(fun(B,option(C)),fun(fun(B,option(C)),fun(B,option(C)))),Pa),F2),G)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,F2)),aa(fun(B,$o),set(B),collect(B),Pa))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,G)),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa)))) ) ).

% dom_if
tff(fact_4093_restrict__map__eq_I1_J,axiom,
    ! [B: $tType,C: $tType,M2: fun(C,option(B)),A3: set(C),K: C] :
      ( ( aa(C,option(B),restrict_map(C,B,M2,A3),K) = none(B) )
    <=> ~ aa(set(C),$o,member(C,K),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),dom(C,B,M2)),A3)) ) ).

% restrict_map_eq(1)
tff(fact_4094_bounded__quasi__semilattice__set_Oempty,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Top: B,Bot: B,Normalize: fun(B,B)] :
      ( bounde6485984586167503788ce_set(B,F2,Top,Bot,Normalize)
     => ( aa(set(B),B,bounde2362111253966948842tice_F(B,F2,Top,Bot),bot_bot(set(B))) = Top ) ) ).

% bounded_quasi_semilattice_set.empty
tff(fact_4095_finite__Map__induct,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),Pa: fun(fun(B,option(C)),$o)] :
      ( aa(set(B),$o,finite_finite2(B),dom(B,C,M2))
     => ( aa(fun(B,option(C)),$o,Pa,aTP_Lamp_abb(B,option(C)))
       => ( ! [K2: B,V2: C,M3: fun(B,option(C))] :
              ( aa(set(B),$o,finite_finite2(B),dom(B,C,M3))
             => ( ~ aa(set(B),$o,member(B,K2),dom(B,C,M3))
               => ( aa(fun(B,option(C)),$o,Pa,M3)
                 => aa(fun(B,option(C)),$o,Pa,fun_upd(B,option(C),M3,K2,aa(C,option(C),some(C),V2))) ) ) )
         => aa(fun(B,option(C)),$o,Pa,M2) ) ) ) ).

% finite_Map_induct
tff(fact_4096_dom__eq__singleton__conv,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,option(C)),X2: B] :
      ( ( dom(B,C,F2) = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) )
    <=> ? [V3: C] : ( F2 = fun_upd(B,option(C),aTP_Lamp_abb(B,option(C)),X2,aa(C,option(C),some(C),V3)) ) ) ).

% dom_eq_singleton_conv
tff(fact_4097_dom__override__on,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,option(C)),G: fun(B,option(C)),A3: set(B)] : ( dom(B,C,override_on(B,option(C),F2,G,A3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),dom(B,C,F2)),aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_acn(fun(B,option(C)),fun(set(B),fun(B,$o)),G),A3)))),aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_aco(fun(B,option(C)),fun(set(B),fun(B,$o)),G),A3))) ) ).

% dom_override_on
tff(fact_4098_folding__on_Oremove,axiom,
    ! [C: $tType,B: $tType,S: set(B),F2: fun(B,fun(C,C)),A3: set(B),X2: B,Z2: C] :
      ( finite_folding_on(B,C,S,F2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S)
       => ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,member(B,X2),A3)
           => ( aa(set(B),C,finite_folding_F(B,C,F2,Z2),A3) = aa(C,C,aa(B,fun(C,C),F2,X2),aa(set(B),C,finite_folding_F(B,C,F2,Z2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ) ).

% folding_on.remove
tff(fact_4099_folding__on_Oinsert__remove,axiom,
    ! [C: $tType,B: $tType,S: set(B),F2: fun(B,fun(C,C)),X2: B,A3: set(B),Z2: C] :
      ( finite_folding_on(B,C,S,F2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,X2),A3)),S)
       => ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),C,finite_folding_F(B,C,F2,Z2),aa(set(B),set(B),insert(B,X2),A3)) = aa(C,C,aa(B,fun(C,C),F2,X2),aa(set(B),C,finite_folding_F(B,C,F2,Z2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ).

% folding_on.insert_remove
tff(fact_4100_ran__map__upd__Some,axiom,
    ! [C: $tType,B: $tType,M2: fun(C,option(B)),X2: C,Y: B,Z2: B] :
      ( ( aa(C,option(B),M2,X2) = aa(B,option(B),some(B),Y) )
     => ( inj_on(C,option(B),M2,dom(C,B,M2))
       => ( ~ aa(set(B),$o,member(B,Z2),ran(C,B,M2))
         => ( ran(C,B,fun_upd(C,option(B),M2,X2,aa(B,option(B),some(B),Z2))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),ran(C,B,M2)),aa(set(B),set(B),insert(B,Y),bot_bot(set(B))))),aa(set(B),set(B),insert(B,Z2),bot_bot(set(B)))) ) ) ) ) ).

% ran_map_upd_Some
tff(fact_4101_override__on__emptyset,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),G: fun(B,C)] : ( override_on(B,C,F2,G,bot_bot(set(B))) = F2 ) ).

% override_on_emptyset
tff(fact_4102_ran__empty,axiom,
    ! [C: $tType,B: $tType] : ( ran(C,B,aTP_Lamp_acp(C,option(B))) = bot_bot(set(B)) ) ).

% ran_empty
tff(fact_4103_map__update__eta__repair_I2_J,axiom,
    ! [B: $tType,C: $tType,M2: fun(C,option(B)),K: C,V: B] :
      ( ( aa(C,option(B),M2,K) = none(B) )
     => ( ran(C,B,aa(B,fun(C,option(B)),aa(C,fun(B,fun(C,option(B))),aTP_Lamp_acq(fun(C,option(B)),fun(C,fun(B,fun(C,option(B)))),M2),K),V)) = aa(set(B),set(B),insert(B,V),ran(C,B,M2)) ) ) ).

% map_update_eta_repair(2)
tff(fact_4104_ran__def,axiom,
    ! [B: $tType,C: $tType,M2: fun(C,option(B))] : ( ran(C,B,M2) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_acr(fun(C,option(B)),fun(B,$o),M2)) ) ).

% ran_def
tff(fact_4105_ran__map__option,axiom,
    ! [B: $tType,D: $tType,C: $tType,F2: fun(D,B),M2: fun(C,option(D))] : ( ran(C,B,aa(fun(C,option(D)),fun(C,option(B)),aTP_Lamp_acs(fun(D,B),fun(fun(C,option(D)),fun(C,option(B))),F2),M2)) = aa(set(D),set(B),image2(D,B,F2),ran(C,D,M2)) ) ).

% ran_map_option
tff(fact_4106_folding__on_Oempty,axiom,
    ! [B: $tType,C: $tType,S: set(B),F2: fun(B,fun(C,C)),Z2: C] :
      ( finite_folding_on(B,C,S,F2)
     => ( aa(set(B),C,finite_folding_F(B,C,F2,Z2),bot_bot(set(B))) = Z2 ) ) ).

% folding_on.empty
tff(fact_4107_card_Ofolding__on__axioms,axiom,
    ! [B: $tType] : finite_folding_on(B,nat,top_top(set(B)),aTP_Lamp_st(B,fun(nat,nat))) ).

% card.folding_on_axioms
tff(fact_4108_finite__set__of__finite__maps,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(C),$o,finite_finite2(C),B2)
       => aa(set(fun(B,option(C))),$o,finite_finite2(fun(B,option(C))),aa(fun(fun(B,option(C)),$o),set(fun(B,option(C))),collect(fun(B,option(C))),aa(set(C),fun(fun(B,option(C)),$o),aTP_Lamp_act(set(B),fun(set(C),fun(fun(B,option(C)),$o)),A3),B2))) ) ) ).

% finite_set_of_finite_maps
tff(fact_4109_ran__add,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,option(C)),G: fun(B,option(C))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,F2)),dom(B,C,G)) = bot_bot(set(B)) )
     => ( ran(B,C,map_add(B,C,F2,G)) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),ran(B,C,F2)),ran(B,C,G)) ) ) ).

% ran_add
tff(fact_4110_ran__map__add,axiom,
    ! [C: $tType,B: $tType,M1: fun(B,option(C)),M22: fun(B,option(C))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,M1)),dom(B,C,M22)) = bot_bot(set(B)) )
     => ( ran(B,C,map_add(B,C,M1,M22)) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),ran(B,C,M1)),ran(B,C,M22)) ) ) ).

% ran_map_add
tff(fact_4111_graph__eq__to__snd__dom,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C))] : ( graph(B,C,M2) = aa(set(B),set(product_prod(B,C)),image2(B,product_prod(B,C),aTP_Lamp_acu(fun(B,option(C)),fun(B,product_prod(B,C)),M2)),dom(B,C,M2)) ) ).

% graph_eq_to_snd_dom
tff(fact_4112_empty__eq__map__add__iff,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,option(C)),G: fun(B,option(C))] :
      ( ( aTP_Lamp_abb(B,option(C)) = map_add(B,C,F2,G) )
    <=> ( ! [X3: B] : ( aa(B,option(C),F2,X3) = none(C) )
        & ! [X3: B] : ( aa(B,option(C),G,X3) = none(C) ) ) ) ).

% empty_eq_map_add_iff
tff(fact_4113_map__add__empty,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C))] : ( map_add(B,C,M2,aTP_Lamp_abb(B,option(C))) = M2 ) ).

% map_add_empty
tff(fact_4114_empty__map__add,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C))] : ( map_add(B,C,aTP_Lamp_abb(B,option(C)),M2) = M2 ) ).

% empty_map_add
tff(fact_4115_graph__empty,axiom,
    ! [C: $tType,B: $tType] : ( graph(B,C,aTP_Lamp_abb(B,option(C))) = bot_bot(set(product_prod(B,C))) ) ).

% graph_empty
tff(fact_4116_bot__filter__parametric,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o))] : aa(filter(C),$o,aa(filter(B),fun(filter(C),$o),rel_filter(B,C,A3),bot_bot(filter(B))),bot_bot(filter(C))) ).

% bot_filter_parametric
tff(fact_4117_graph__map__add,axiom,
    ! [C: $tType,B: $tType,M1: fun(B,option(C)),M22: fun(B,option(C))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,M1)),dom(B,C,M22)) = bot_bot(set(B)) )
     => ( graph(B,C,map_add(B,C,M1,M22)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),sup_sup(set(product_prod(B,C))),graph(B,C,M1)),graph(B,C,M22)) ) ) ).

% graph_map_add
tff(fact_4118_map__add__def,axiom,
    ! [C: $tType,B: $tType,M1: fun(B,option(C)),M22: fun(B,option(C)),X4: B] : ( aa(B,option(C),map_add(B,C,M1,M22),X4) = case_option(option(C),C,aa(B,option(C),M1,X4),some(C),aa(B,option(C),M22,X4)) ) ).

% map_add_def
tff(fact_4119_map__add__distinct__le,axiom,
    ! [C: $tType,B: $tType] :
      ( preorder(C)
     => ! [M2: fun(B,option(C)),M5: fun(B,option(C)),N: fun(B,option(C)),N7: fun(B,option(C))] :
          ( aa(fun(B,option(C)),$o,aa(fun(B,option(C)),fun(fun(B,option(C)),$o),ord_less_eq(fun(B,option(C))),M2),M5)
         => ( aa(fun(B,option(C)),$o,aa(fun(B,option(C)),fun(fun(B,option(C)),$o),ord_less_eq(fun(B,option(C))),N),N7)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,M5)),dom(B,C,N7)) = bot_bot(set(B)) )
             => aa(fun(B,option(C)),$o,aa(fun(B,option(C)),fun(fun(B,option(C)),$o),ord_less_eq(fun(B,option(C))),map_add(B,C,M2,N)),map_add(B,C,M5,N7)) ) ) ) ) ).

% map_add_distinct_le
tff(fact_4120_map__add__comm,axiom,
    ! [C: $tType,B: $tType,M1: fun(B,option(C)),M22: fun(B,option(C))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,M1)),dom(B,C,M22)) = bot_bot(set(B)) )
     => ( map_add(B,C,M1,M22) = map_add(B,C,M22,M1) ) ) ).

% map_add_comm
tff(fact_4121_map__add__left__comm,axiom,
    ! [C: $tType,B: $tType,A3: fun(B,option(C)),B2: fun(B,option(C)),C2: fun(B,option(C))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,A3)),dom(B,C,B2)) = bot_bot(set(B)) )
     => ( map_add(B,C,A3,map_add(B,C,B2,C2)) = map_add(B,C,B2,map_add(B,C,A3,C2)) ) ) ).

% map_add_left_comm
tff(fact_4122_graph__def,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C))] : ( graph(B,C,M2) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aTP_Lamp_acv(fun(B,option(C)),fun(product_prod(B,C),$o),M2)) ) ).

% graph_def
tff(fact_4123_graph__fun__upd__None,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),K: B] : ( graph(B,C,fun_upd(B,option(C),M2,K,none(C))) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(B,fun(product_prod(B,C),$o),aTP_Lamp_acw(fun(B,option(C)),fun(B,fun(product_prod(B,C),$o)),M2),K)) ) ).

% graph_fun_upd_None
tff(fact_4124_rel__filter_Ocases,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),F: filter(B),G3: filter(C)] :
      ( aa(filter(C),$o,aa(filter(B),fun(filter(C),$o),rel_filter(B,C,R),F),G3)
     => ~ ! [Z8: filter(product_prod(B,C))] :
            ( eventually(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),R),Z8)
           => ( ( map_filter_on(product_prod(B,C),B,aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),R)),product_fst(B,C),Z8) = F )
             => ( map_filter_on(product_prod(B,C),C,aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),R)),product_snd(B,C),Z8) != G3 ) ) ) ) ).

% rel_filter.cases
tff(fact_4125_rel__filter_Osimps,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),F: filter(B),G3: filter(C)] :
      ( aa(filter(C),$o,aa(filter(B),fun(filter(C),$o),rel_filter(B,C,R),F),G3)
    <=> ? [Z6: filter(product_prod(B,C))] :
          ( eventually(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),R),Z6)
          & ( map_filter_on(product_prod(B,C),B,aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),R)),product_fst(B,C),Z6) = F )
          & ( map_filter_on(product_prod(B,C),C,aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),R)),product_snd(B,C),Z6) = G3 ) ) ) ).

% rel_filter.simps
tff(fact_4126_rel__filter_Ointros,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),Z4: filter(product_prod(B,C)),F: filter(B),G3: filter(C)] :
      ( eventually(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),R),Z4)
     => ( ( map_filter_on(product_prod(B,C),B,aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),R)),product_fst(B,C),Z4) = F )
       => ( ( map_filter_on(product_prod(B,C),C,aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),R)),product_snd(B,C),Z4) = G3 )
         => aa(filter(C),$o,aa(filter(B),fun(filter(C),$o),rel_filter(B,C,R),F),G3) ) ) ) ).

% rel_filter.intros
tff(fact_4127_arg__min__SOME__Min,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [S: set(B),F2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite2(B),S)
         => ( lattic7623131987881927897min_on(B,C,F2,S) = fChoice(B,aa(fun(B,C),fun(B,$o),aTP_Lamp_acx(set(B),fun(fun(B,C),fun(B,$o)),S),F2)) ) ) ) ).

% arg_min_SOME_Min
tff(fact_4128_map__comp__def,axiom,
    ! [C: $tType,D: $tType,B: $tType,F2: fun(D,option(C)),G: fun(B,option(D)),X4: B] : ( map_comp(D,C,B,F2,G,X4) = case_option(option(C),D,none(C),F2,aa(B,option(D),G,X4)) ) ).

% map_comp_def
tff(fact_4129_Nats__altdef1,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ( semiring_1_Nats(B) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_acy(B,$o)) ) ) ).

% Nats_altdef1
tff(fact_4130_cSup__cInf,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [S: set(B)] :
          ( ( S != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,S)
           => ( aa(set(B),B,complete_Sup_Sup(B),S) = aa(set(B),B,complete_Inf_Inf(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_acz(set(B),fun(B,$o),S))) ) ) ) ) ).

% cSup_cInf
tff(fact_4131_some__sym__eq__trivial,axiom,
    ! [B: $tType,X2: B] : ( fChoice(B,aa(B,fun(B,$o),fequal(B),X2)) = X2 ) ).

% some_sym_eq_trivial
tff(fact_4132_some__eq__trivial,axiom,
    ! [B: $tType,X2: B] : ( fChoice(B,aTP_Lamp_ct(B,fun(B,$o),X2)) = X2 ) ).

% some_eq_trivial
tff(fact_4133_some__equality,axiom,
    ! [B: $tType,Pa: fun(B,$o),A4: B] :
      ( aa(B,$o,Pa,A4)
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
           => ( X = A4 ) )
       => ( fChoice(B,Pa) = A4 ) ) ) ).

% some_equality
tff(fact_4134_ball__empty,axiom,
    ! [B: $tType,Pa: fun(B,$o),X4: B] :
      ( aa(set(B),$o,member(B,X4),bot_bot(set(B)))
     => aa(B,$o,Pa,X4) ) ).

% ball_empty
tff(fact_4135_Eps__case__prod__eq,axiom,
    ! [B: $tType,C: $tType,X2: B,Y: C] : ( fChoice(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(C,fun(B,fun(C,$o)),aTP_Lamp_et(B,fun(C,fun(B,fun(C,$o))),X2),Y))) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y) ) ).

% Eps_case_prod_eq
tff(fact_4136_map__comp__empty_I1_J,axiom,
    ! [B: $tType,D: $tType,C: $tType,M2: fun(D,option(C)),X4: B] : ( map_comp(D,C,B,M2,aTP_Lamp_abt(B,option(D)),X4) = none(C) ) ).

% map_comp_empty(1)
tff(fact_4137_map__comp__empty_I2_J,axiom,
    ! [B: $tType,D: $tType,C: $tType,M2: fun(B,option(D)),X4: B] : ( map_comp(D,C,B,aTP_Lamp_ada(D,option(C)),M2,X4) = none(C) ) ).

% map_comp_empty(2)
tff(fact_4138_some__insert__self,axiom,
    ! [B: $tType,S: set(B)] :
      ( ( S != bot_bot(set(B)) )
     => ( aa(set(B),set(B),insert(B,fChoice(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),S))),S) = S ) ) ).

% some_insert_self
tff(fact_4139_INF__bool__eq,axiom,
    ! [B: $tType] : ( aTP_Lamp_adb(set(B),fun(fun(B,$o),$o)) = ball(B) ) ).

% INF_bool_eq
tff(fact_4140_Ball__fold,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,$o)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),A3)
           => aa(B,$o,Pa,X3) )
      <=> finite_fold(B,$o,aTP_Lamp_adc(fun(B,$o),fun(B,fun($o,$o)),Pa),$true,A3) ) ) ).

% Ball_fold
tff(fact_4141_someI2,axiom,
    ! [B: $tType,Pa: fun(B,$o),A4: B,Qa: fun(B,$o)] :
      ( aa(B,$o,Pa,A4)
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
           => aa(B,$o,Qa,X) )
       => aa(B,$o,Qa,fChoice(B,Pa)) ) ) ).

% someI2
tff(fact_4142_someI__ex,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ? [X_13: B] : aa(B,$o,Pa,X_13)
     => aa(B,$o,Pa,fChoice(B,Pa)) ) ).

% someI_ex
tff(fact_4143_someI2__ex,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( ? [X_13: B] : aa(B,$o,Pa,X_13)
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
           => aa(B,$o,Qa,X) )
       => aa(B,$o,Qa,fChoice(B,Pa)) ) ) ).

% someI2_ex
tff(fact_4144_someI2__bex,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( ? [X4: B] :
          ( aa(set(B),$o,member(B,X4),A3)
          & aa(B,$o,Pa,X4) )
     => ( ! [X: B] :
            ( ( aa(set(B),$o,member(B,X),A3)
              & aa(B,$o,Pa,X) )
           => aa(B,$o,Qa,X) )
       => aa(B,$o,Qa,fChoice(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),A3),Pa))) ) ) ).

% someI2_bex
tff(fact_4145_some__eq__ex,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( aa(B,$o,Pa,fChoice(B,Pa))
    <=> ? [X_12: B] : aa(B,$o,Pa,X_12) ) ).

% some_eq_ex
tff(fact_4146_some1__equality,axiom,
    ! [B: $tType,Pa: fun(B,$o),A4: B] :
      ( ? [X4: B] :
          ( aa(B,$o,Pa,X4)
          & ! [Y2: B] :
              ( aa(B,$o,Pa,Y2)
             => ( Y2 = X4 ) ) )
     => ( aa(B,$o,Pa,A4)
       => ( fChoice(B,Pa) = A4 ) ) ) ).

% some1_equality
tff(fact_4147_verit__sko__ex_H,axiom,
    ! [B: $tType,Pa: fun(B,$o),A3: $o] :
      ( ( aa(B,$o,Pa,fChoice(B,Pa))
      <=> (A3) )
     => ( ? [X_12: B] : aa(B,$o,Pa,X_12)
      <=> (A3) ) ) ).

% verit_sko_ex'
tff(fact_4148_verit__sko__forall,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ! [X_12: B] : aa(B,$o,Pa,X_12)
    <=> aa(B,$o,Pa,fChoice(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa))) ) ).

% verit_sko_forall
tff(fact_4149_verit__sko__forall_H,axiom,
    ! [B: $tType,Pa: fun(B,$o),A3: $o] :
      ( ( aa(B,$o,Pa,fChoice(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa)))
      <=> (A3) )
     => ( ! [X_12: B] : aa(B,$o,Pa,X_12)
      <=> (A3) ) ) ).

% verit_sko_forall'
tff(fact_4150_verit__sko__forall_H_H,axiom,
    ! [B: $tType,B2: B,A3: B,Pa: fun(B,$o)] :
      ( ( B2 = A3 )
     => ( ( fChoice(B,Pa) = A3 )
      <=> ( fChoice(B,Pa) = B2 ) ) ) ).

% verit_sko_forall''
tff(fact_4151_verit__sko__ex__indirect,axiom,
    ! [B: $tType,X2: B,Pa: fun(B,$o)] :
      ( ( X2 = fChoice(B,Pa) )
     => ( ? [X_12: B] : aa(B,$o,Pa,X_12)
      <=> aa(B,$o,Pa,X2) ) ) ).

% verit_sko_ex_indirect
tff(fact_4152_verit__sko__ex__indirect2,axiom,
    ! [B: $tType,X2: B,Pa: fun(B,$o),P_a: fun(B,$o)] :
      ( ( X2 = fChoice(B,Pa) )
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
          <=> aa(B,$o,P_a,X) )
       => ( ? [X_12: B] : aa(B,$o,P_a,X_12)
        <=> aa(B,$o,Pa,X2) ) ) ) ).

% verit_sko_ex_indirect2
tff(fact_4153_verit__sko__forall__indirect,axiom,
    ! [B: $tType,X2: B,Pa: fun(B,$o)] :
      ( ( X2 = fChoice(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa)) )
     => ( ! [X_12: B] : aa(B,$o,Pa,X_12)
      <=> aa(B,$o,Pa,X2) ) ) ).

% verit_sko_forall_indirect
tff(fact_4154_verit__sko__forall__indirect2,axiom,
    ! [B: $tType,X2: B,Pa: fun(B,$o),P_a: fun(B,$o)] :
      ( ( X2 = fChoice(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa)) )
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
          <=> aa(B,$o,P_a,X) )
       => ( ! [X_12: B] : aa(B,$o,P_a,X_12)
        <=> aa(B,$o,Pa,X2) ) ) ) ).

% verit_sko_forall_indirect2
tff(fact_4155_Inter__eq,axiom,
    ! [B: $tType,A3: set(set(B))] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),A3) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_add(set(set(B)),fun(B,$o),A3)) ) ).

% Inter_eq
tff(fact_4156_some__elem,axiom,
    ! [B: $tType,S: set(B)] :
      ( ( S != bot_bot(set(B)) )
     => aa(set(B),$o,member(B,fChoice(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),S))),S) ) ).

% some_elem
tff(fact_4157_some__in__eq,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,member(B,fChoice(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3))),A3)
    <=> ( A3 != bot_bot(set(B)) ) ) ).

% some_in_eq
tff(fact_4158_Ball__comp__iff,axiom,
    ! [B: $tType,C: $tType,D: $tType,A3: fun(C,set(D)),F2: fun(D,$o),G: fun(B,C),X4: B] :
      ( aa(B,$o,aa(fun(B,C),fun(B,$o),comp(C,$o,B,aa(fun(D,$o),fun(C,$o),aTP_Lamp_ade(fun(C,set(D)),fun(fun(D,$o),fun(C,$o)),A3),F2)),G),X4)
    <=> ! [Xa2: D] :
          ( aa(set(D),$o,member(D,Xa2),aa(B,set(D),aa(fun(B,C),fun(B,set(D)),comp(C,set(D),B,A3),G),X4))
         => aa(D,$o,F2,Xa2) ) ) ).

% Ball_comp_iff
tff(fact_4159_Nats__mult,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [A4: B,B3: B] :
          ( aa(set(B),$o,member(B,A4),semiring_1_Nats(B))
         => ( aa(set(B),$o,member(B,B3),semiring_1_Nats(B))
           => aa(set(B),$o,member(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),semiring_1_Nats(B)) ) ) ) ).

% Nats_mult
tff(fact_4160_Nats__1,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => aa(set(B),$o,member(B,one_one(B)),semiring_1_Nats(B)) ) ).

% Nats_1
tff(fact_4161_eventually__ball__finite__distrib,axiom,
    ! [B: $tType,C: $tType,A3: set(B),Pa: fun(C,fun(B,$o)),Net: filter(C)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( eventually(C,aa(fun(C,fun(B,$o)),fun(C,$o),aTP_Lamp_adf(set(B),fun(fun(C,fun(B,$o)),fun(C,$o)),A3),Pa),Net)
      <=> ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),A3)
           => eventually(C,aa(B,fun(C,$o),aTP_Lamp_km(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Pa),X3),Net) ) ) ) ).

% eventually_ball_finite_distrib
tff(fact_4162_eventually__ball__finite,axiom,
    ! [B: $tType,C: $tType,A3: set(B),Pa: fun(C,fun(B,$o)),Net: filter(C)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),A3)
           => eventually(C,aa(B,fun(C,$o),aTP_Lamp_km(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Pa),X),Net) )
       => eventually(C,aa(fun(C,fun(B,$o)),fun(C,$o),aTP_Lamp_adf(set(B),fun(fun(C,fun(B,$o)),fun(C,$o)),A3),Pa),Net) ) ) ).

% eventually_ball_finite
tff(fact_4163_Field__not__elem,axiom,
    ! [B: $tType,V: B,R: set(product_prod(B,B))] :
      ( ~ aa(set(B),$o,member(B,V),field2(B,R))
     => ! [X4: product_prod(B,B)] :
          ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),X4),R)
         => aa(product_prod(B,B),$o,aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aTP_Lamp_adg(B,fun(B,fun(B,$o)),V)),X4) ) ) ).

% Field_not_elem
tff(fact_4164_Collect__ball__eq,axiom,
    ! [B: $tType,C: $tType,A3: set(C),Pa: fun(B,fun(C,$o))] : ( aa(fun(B,$o),set(B),collect(B),aa(fun(B,fun(C,$o)),fun(B,$o),aTP_Lamp_adh(set(C),fun(fun(B,fun(C,$o)),fun(B,$o)),A3),Pa)) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_gx(fun(B,fun(C,$o)),fun(C,set(B)),Pa)),A3)) ) ).

% Collect_ball_eq
tff(fact_4165_INTER__eq,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,set(B)),A3: set(C)] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)) = aa(fun(B,$o),set(B),collect(B),aa(set(C),fun(B,$o),aTP_Lamp_adi(fun(C,set(B)),fun(set(C),fun(B,$o)),B2),A3)) ) ).

% INTER_eq
tff(fact_4166_split__paired__Eps,axiom,
    ! [C: $tType,B: $tType,Pa: fun(product_prod(B,C),$o)] : ( fChoice(product_prod(B,C),Pa) = fChoice(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_adj(fun(product_prod(B,C),$o),fun(B,fun(C,$o)),Pa))) ) ).

% split_paired_Eps
tff(fact_4167_irrefl__distinct,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( irrefl(B,R2)
    <=> ! [X3: product_prod(B,B)] :
          ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),X3),R2)
         => aa(product_prod(B,B),$o,aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aTP_Lamp_adk(B,fun(B,$o))),X3) ) ) ).

% irrefl_distinct
tff(fact_4168_some__theI,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o))] :
      ( ? [A14: B,X_13: C] : aa(C,$o,aa(B,fun(C,$o),Pa,A14),X_13)
     => ( ! [B13: C,B24: C] :
            ( ? [A5: B] : aa(C,$o,aa(B,fun(C,$o),Pa,A5),B13)
           => ( ? [A5: B] : aa(C,$o,aa(B,fun(C,$o),Pa,A5),B24)
             => ( B13 = B24 ) ) )
       => aa(C,$o,aa(B,fun(C,$o),Pa,fChoice(B,aTP_Lamp_gv(fun(B,fun(C,$o)),fun(B,$o),Pa))),the(C,aTP_Lamp_adl(fun(B,fun(C,$o)),fun(C,$o),Pa))) ) ) ).

% some_theI
tff(fact_4169_congruent__def,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,B)),F2: fun(B,C)] :
      ( equiv_congruent(B,C,R2,F2)
    <=> ! [X3: product_prod(B,B)] :
          ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),X3),R2)
         => aa(product_prod(B,B),$o,aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aTP_Lamp_adm(fun(B,C),fun(B,fun(B,$o)),F2)),X3) ) ) ).

% congruent_def
tff(fact_4170_congruent2__def,axiom,
    ! [C: $tType,D: $tType,B: $tType,R12: set(product_prod(B,B)),R23: set(product_prod(C,C)),F2: fun(B,fun(C,D))] :
      ( equiv_congruent2(B,C,D,R12,R23,F2)
    <=> ! [X3: product_prod(B,B)] :
          ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),X3),R12)
         => aa(product_prod(B,B),$o,aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(fun(B,fun(C,D)),fun(B,fun(B,$o)),aTP_Lamp_ado(set(product_prod(C,C)),fun(fun(B,fun(C,D)),fun(B,fun(B,$o))),R23),F2)),X3) ) ) ).

% congruent2_def
tff(fact_4171_equiv__Eps__in,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X5: set(B)] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(set(B)),$o,member(set(B),X5),equiv_quotient(B,A3,R2))
       => aa(set(B),$o,member(B,fChoice(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),X5))),X5) ) ) ).

% equiv_Eps_in
tff(fact_4172_equiv__Eps__preserves,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X5: set(B)] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(set(B)),$o,member(set(B),X5),equiv_quotient(B,A3,R2))
       => aa(set(B),$o,member(B,fChoice(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),X5))),A3) ) ) ).

% equiv_Eps_preserves
tff(fact_4173_Sup__eq__Inf,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] : ( aa(set(B),B,complete_Sup_Sup(B),A3) = aa(set(B),B,complete_Inf_Inf(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_adp(set(B),fun(B,$o),A3))) ) ) ).

% Sup_eq_Inf
tff(fact_4174_Inf__eq__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(B)] : ( aa(set(B),B,complete_Inf_Inf(B),A3) = aa(set(B),B,complete_Sup_Sup(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_adq(set(B),fun(B,$o),A3))) ) ) ).

% Inf_eq_Sup
tff(fact_4175_trans__join,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( trans(B,R2)
    <=> ! [X3: product_prod(B,B)] :
          ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),X3),R2)
         => aa(product_prod(B,B),$o,aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aTP_Lamp_ads(set(product_prod(B,B)),fun(B,fun(B,$o)),R2)),X3) ) ) ).

% trans_join
tff(fact_4176_refl__on__def_H,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B))] :
      ( refl_on(B,A3,R2)
    <=> ( ! [X3: product_prod(B,B)] :
            ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),X3),R2)
           => aa(product_prod(B,B),$o,aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aTP_Lamp_adt(set(B),fun(B,fun(B,$o)),A3)),X3) )
        & ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),A3)
           => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),X3)),R2) ) ) ) ).

% refl_on_def'
tff(fact_4177_Sup__int__def,axiom,
    ! [X5: set(int)] : ( aa(set(int),int,complete_Sup_Sup(int),X5) = the(int,aTP_Lamp_adu(set(int),fun(int,$o),X5)) ) ).

% Sup_int_def
tff(fact_4178_arg__min__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [F2: fun(B,C),Pa: fun(B,$o)] : ( lattices_ord_arg_min(B,C,F2,Pa) = fChoice(B,lattic501386751177426532rg_min(B,C,F2,Pa)) ) ) ).

% arg_min_def
tff(fact_4179_Eps__case__prod,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o))] : ( fChoice(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Pa)) = fChoice(product_prod(B,C),aTP_Lamp_ev(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),Pa)) ) ).

% Eps_case_prod
tff(fact_4180_Union__maximal__sets,axiom,
    ! [B: $tType,F14: set(set(B))] :
      ( aa(set(set(B)),$o,finite_finite2(set(B)),F14)
     => ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_adv(set(set(B)),fun(set(B),$o),F14))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),F14) ) ) ).

% Union_maximal_sets
tff(fact_4181_Sup__Inf,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [A3: set(set(B))] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(set(B)),set(B),image2(set(B),B,complete_Inf_Inf(B)),A3)) = aa(set(B),B,complete_Inf_Inf(B),aa(set(set(B)),set(B),image2(set(B),B,complete_Sup_Sup(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_adw(set(set(B)),fun(set(B),$o),A3)))) ) ) ).

% Sup_Inf
tff(fact_4182_Inf__Sup,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [A3: set(set(B))] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(set(B)),set(B),image2(set(B),B,complete_Sup_Sup(B)),A3)) = aa(set(B),B,complete_Sup_Sup(B),aa(set(set(B)),set(B),image2(set(B),B,complete_Inf_Inf(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_adw(set(set(B)),fun(set(B),$o),A3)))) ) ) ).

% Inf_Sup
tff(fact_4183_Inf__filter__def,axiom,
    ! [B: $tType,S: set(filter(B))] : ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),S) = aa(set(filter(B)),filter(B),complete_Sup_Sup(filter(B)),aa(fun(filter(B),$o),set(filter(B)),collect(filter(B)),aTP_Lamp_adx(set(filter(B)),fun(filter(B),$o),S))) ) ).

% Inf_filter_def
tff(fact_4184_proj__Eps,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B)),X5: set(B)] :
      ( equiv_equiv(B,A3,R2)
     => ( aa(set(set(B)),$o,member(set(B),X5),equiv_quotient(B,A3,R2))
       => ( equiv_proj(B,B,R2,fChoice(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),X5))) = X5 ) ) ) ).

% proj_Eps
tff(fact_4185_Sup__Inf__le,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(set(B))] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(set(B)),set(B),image2(set(B),B,complete_Inf_Inf(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_ady(set(set(B)),fun(set(B),$o),A3))))),aa(set(B),B,complete_Inf_Inf(B),aa(set(set(B)),set(B),image2(set(B),B,complete_Sup_Sup(B)),A3))) ) ).

% Sup_Inf_le
tff(fact_4186_Inf__Sup__le,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [A3: set(set(B))] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(set(B)),set(B),image2(set(B),B,complete_Sup_Sup(B)),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(set(B)),set(B),image2(set(B),B,complete_Inf_Inf(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_adw(set(set(B)),fun(set(B),$o),A3))))) ) ).

% Inf_Sup_le
tff(fact_4187_finite__Inf__Sup,axiom,
    ! [B: $tType] :
      ( finite8700451911770168679attice(B)
     => ! [A3: set(set(B))] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(set(B)),set(B),image2(set(B),B,complete_Sup_Sup(B)),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(set(B)),set(B),image2(set(B),B,complete_Inf_Inf(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_adz(set(set(B)),fun(set(B),$o),A3))))) ) ).

% finite_Inf_Sup
tff(fact_4188_INF__SUP__set,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [G: fun(C,B),A3: set(set(C))] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(set(C)),set(B),image2(set(C),B,aTP_Lamp_aea(fun(C,B),fun(set(C),B),G)),A3)) = aa(set(B),B,complete_Sup_Sup(B),aa(set(set(C)),set(B),image2(set(C),B,aTP_Lamp_aeb(fun(C,B),fun(set(C),B),G)),aa(fun(set(C),$o),set(set(C)),collect(set(C)),aTP_Lamp_aec(set(set(C)),fun(set(C),$o),A3)))) ) ) ).

% INF_SUP_set
tff(fact_4189_SUP__INF__set,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [G: fun(C,B),A3: set(set(C))] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(set(C)),set(B),image2(set(C),B,aTP_Lamp_aeb(fun(C,B),fun(set(C),B),G)),A3)) = aa(set(B),B,complete_Inf_Inf(B),aa(set(set(C)),set(B),image2(set(C),B,aTP_Lamp_aea(fun(C,B),fun(set(C),B),G)),aa(fun(set(C),$o),set(set(C)),collect(set(C)),aTP_Lamp_aec(set(set(C)),fun(set(C),$o),A3)))) ) ) ).

% SUP_INF_set
tff(fact_4190_option__Inf__Sup,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [A3: set(set(option(B)))] : aa(option(B),$o,aa(option(B),fun(option(B),$o),ord_less_eq(option(B)),aa(set(option(B)),option(B),complete_Inf_Inf(option(B)),aa(set(set(option(B))),set(option(B)),image2(set(option(B)),option(B),complete_Sup_Sup(option(B))),A3))),aa(set(option(B)),option(B),complete_Sup_Sup(option(B)),aa(set(set(option(B))),set(option(B)),image2(set(option(B)),option(B),complete_Inf_Inf(option(B))),aa(fun(set(option(B)),$o),set(set(option(B))),collect(set(option(B))),aTP_Lamp_aed(set(set(option(B))),fun(set(option(B)),$o),A3))))) ) ).

% option_Inf_Sup
tff(fact_4191_Eps__Opt__def,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( eps_Opt(B,Pa)
      = $ite(
          ? [X7: B] : aa(B,$o,Pa,X7),
          aa(B,option(B),some(B),fChoice(B,Pa)),
          none(B) ) ) ).

% Eps_Opt_def
tff(fact_4192_Nats__altdef2,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ( semiring_1_Nats(B) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_aee(B,$o)) ) ) ).

% Nats_altdef2
tff(fact_4193_cInf__cSup,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [S: set(B)] :
          ( ( S != bot_bot(set(B)) )
         => ( aa(set(B),$o,condit1013018076250108175_below(B),S)
           => ( aa(set(B),B,complete_Inf_Inf(B),S) = aa(set(B),B,complete_Sup_Sup(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_aef(set(B),fun(B,$o),S))) ) ) ) ) ).

% cInf_cSup
tff(fact_4194_Under__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] : ( order_Under(B,R2,A3) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_aeg(set(product_prod(B,B)),fun(set(B),fun(B,$o)),R2),A3)) ) ).

% Under_def
tff(fact_4195_UnderS__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] : ( order_UnderS(B,R2,A3) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_aeh(set(product_prod(B,B)),fun(set(B),fun(B,$o)),R2),A3)) ) ).

% UnderS_def
tff(fact_4196_Above__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] : ( order_Above(B,R2,A3) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_aei(set(product_prod(B,B)),fun(set(B),fun(B,$o)),R2),A3)) ) ).

% Above_def
tff(fact_4197_fun__of__rel__def,axiom,
    ! [B: $tType,C: $tType,R: set(product_prod(C,B)),X2: C] : ( fun_of_rel(C,B,R,X2) = fChoice(B,aa(C,fun(B,$o),aTP_Lamp_jo(set(product_prod(C,B)),fun(C,fun(B,$o)),R),X2)) ) ).

% fun_of_rel_def
tff(fact_4198_conj__comp__iff,axiom,
    ! [C: $tType,B: $tType,Pa: fun(C,$o),Qa: fun(C,$o),G: fun(B,C),X4: B] :
      ( aa(B,$o,aa(fun(B,C),fun(B,$o),comp(C,$o,B,aa(fun(C,$o),fun(C,$o),aTP_Lamp_aej(fun(C,$o),fun(fun(C,$o),fun(C,$o)),Pa),Qa)),G),X4)
    <=> ( aa(B,$o,aa(fun(B,C),fun(B,$o),comp(C,$o,B,Pa),G),X4)
        & aa(B,$o,aa(fun(B,C),fun(B,$o),comp(C,$o,B,Qa),G),X4) ) ) ).

% conj_comp_iff
tff(fact_4199_iteratesp_Omono,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [F2: fun(B,B)] : order_mono(fun(B,$o),fun(B,$o),aTP_Lamp_aek(fun(B,B),fun(fun(B,$o),fun(B,$o)),F2)) ) ).

% iteratesp.mono
tff(fact_4200_Sup__filter__def,axiom,
    ! [B: $tType,S: set(filter(B))] : ( aa(set(filter(B)),filter(B),complete_Sup_Sup(filter(B)),S) = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),aTP_Lamp_ael(set(filter(B)),fun(fun(B,$o),$o),S)) ) ).

% Sup_filter_def
tff(fact_4201_min__ext__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( min_ext(B,R2) = aa(fun(product_prod(set(B),set(B)),$o),set(product_prod(set(B),set(B))),collect(product_prod(set(B),set(B))),aTP_Lamp_aem(set(product_prod(B,B)),fun(product_prod(set(B),set(B)),$o),R2)) ) ).

% min_ext_def
tff(fact_4202_AboveS__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] : ( order_AboveS(B,R2,A3) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_aen(set(product_prod(B,B)),fun(set(B),fun(B,$o)),R2),A3)) ) ).

% AboveS_def
tff(fact_4203_bex__empty,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ~ ? [X4: B] :
          ( aa(set(B),$o,member(B,X4),bot_bot(set(B)))
          & aa(B,$o,Pa,X4) ) ).

% bex_empty
tff(fact_4204_finite__Collect__bex,axiom,
    ! [C: $tType,B: $tType,A3: set(B),Qa: fun(C,fun(B,$o))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(fun(C,fun(B,$o)),fun(C,$o),aTP_Lamp_aeo(set(B),fun(fun(C,fun(B,$o)),fun(C,$o)),A3),Qa)))
      <=> ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),A3)
           => aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(B,fun(C,$o),aTP_Lamp_km(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Qa),X3))) ) ) ) ).

% finite_Collect_bex
tff(fact_4205_Image__Collect__case__prod,axiom,
    ! [B: $tType,C: $tType,Pa: fun(C,fun(B,$o)),A3: set(C)] : ( aa(set(C),set(B),image(C,B,aa(fun(product_prod(C,B),$o),set(product_prod(C,B)),collect(product_prod(C,B)),aa(fun(C,fun(B,$o)),fun(product_prod(C,B),$o),product_case_prod(C,B,$o),Pa))),A3) = aa(fun(B,$o),set(B),collect(B),aa(set(C),fun(B,$o),aTP_Lamp_aep(fun(C,fun(B,$o)),fun(set(C),fun(B,$o)),Pa),A3)) ) ).

% Image_Collect_case_prod
tff(fact_4206_SUP__bool__eq,axiom,
    ! [B: $tType] : ( aTP_Lamp_aeq(set(B),fun(fun(B,$o),$o)) = bex(B) ) ).

% SUP_bool_eq
tff(fact_4207_image__def,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A3: set(C)] : ( aa(set(C),set(B),image2(C,B,F2),A3) = aa(fun(B,$o),set(B),collect(B),aa(set(C),fun(B,$o),aTP_Lamp_aer(fun(C,B),fun(set(C),fun(B,$o)),F2),A3)) ) ).

% image_def
tff(fact_4208_Union__eq,axiom,
    ! [B: $tType,A3: set(set(B))] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A3) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_aes(set(set(B)),fun(B,$o),A3)) ) ).

% Union_eq
tff(fact_4209_chain__compr,axiom,
    ! [B: $tType,Ord: fun(B,fun(B,$o)),A3: set(B),Pa: fun(B,$o)] :
      ( comple1602240252501008431_chain(B,Ord,A3)
     => comple1602240252501008431_chain(B,Ord,aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),A3),Pa))) ) ).

% chain_compr
tff(fact_4210_chain__empty,axiom,
    ! [B: $tType,Ord: fun(B,fun(B,$o))] : comple1602240252501008431_chain(B,Ord,bot_bot(set(B))) ).

% chain_empty
tff(fact_4211_sup__filter__def,axiom,
    ! [B: $tType,F: filter(B),F3: filter(B)] : ( aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),sup_sup(filter(B)),F),F3) = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),aa(filter(B),fun(fun(B,$o),$o),aTP_Lamp_aet(filter(B),fun(filter(B),fun(fun(B,$o),$o)),F),F3)) ) ).

% sup_filter_def
tff(fact_4212_bot__filter__def,axiom,
    ! [B: $tType] : ( bot_bot(filter(B)) = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),aTP_Lamp_aeu(fun(B,$o),$o)) ) ).

% bot_filter_def
tff(fact_4213_Image__def,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(C,B)),S2: set(C)] : ( aa(set(C),set(B),image(C,B,R2),S2) = aa(fun(B,$o),set(B),collect(B),aa(set(C),fun(B,$o),aTP_Lamp_aev(set(product_prod(C,B)),fun(set(C),fun(B,$o)),R2),S2)) ) ).

% Image_def
tff(fact_4214_Collect__bex__eq,axiom,
    ! [B: $tType,C: $tType,A3: set(C),Pa: fun(B,fun(C,$o))] : ( aa(fun(B,$o),set(B),collect(B),aa(fun(B,fun(C,$o)),fun(B,$o),aTP_Lamp_aew(set(C),fun(fun(B,fun(C,$o)),fun(B,$o)),A3),Pa)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_gx(fun(B,fun(C,$o)),fun(C,set(B)),Pa)),A3)) ) ).

% Collect_bex_eq
tff(fact_4215_UNION__eq,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,set(B)),A3: set(C)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A3)) = aa(fun(B,$o),set(B),collect(B),aa(set(C),fun(B,$o),aTP_Lamp_aex(fun(C,set(B)),fun(set(C),fun(B,$o)),B2),A3)) ) ).

% UNION_eq
tff(fact_4216_vimage__image__eq,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),A3: set(B)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),F2),aa(set(B),set(C),image2(B,C,F2),A3)) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_aey(fun(B,C),fun(set(B),fun(B,$o)),F2),A3)) ) ).

% vimage_image_eq
tff(fact_4217_chain__singleton,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [X2: B] : comple1602240252501008431_chain(B,ord_less_eq(B),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) ) ).

% chain_singleton
tff(fact_4218_Bex__fold,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,$o)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( ? [X3: B] :
            ( aa(set(B),$o,member(B,X3),A3)
            & aa(B,$o,Pa,X3) )
      <=> finite_fold(B,$o,aTP_Lamp_aez(fun(B,$o),fun(B,fun($o,$o)),Pa),$false,A3) ) ) ).

% Bex_fold
tff(fact_4219_AboveS__disjoint,axiom,
    ! [B: $tType,A3: set(B),R2: set(product_prod(B,B))] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),order_AboveS(B,R2,A3)) = bot_bot(set(B)) ) ).

% AboveS_disjoint
tff(fact_4220_max__extp_Omax__extI,axiom,
    ! [B: $tType,X5: set(B),Y3: set(B),R: fun(B,fun(B,$o))] :
      ( aa(set(B),$o,finite_finite2(B),X5)
     => ( aa(set(B),$o,finite_finite2(B),Y3)
       => ( ( Y3 != aa(fun(B,$o),set(B),collect(B),bot_bot(fun(B,$o))) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),X5)
               => ? [Xa3: B] :
                    ( aa(set(B),$o,member(B,Xa3),Y3)
                    & aa(B,$o,aa(B,fun(B,$o),R,X),Xa3) ) )
           => aa(set(B),$o,aa(set(B),fun(set(B),$o),max_extp(B,R),X5),Y3) ) ) ) ) ).

% max_extp.max_extI
tff(fact_4221_max__extp_Osimps,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),A13: set(B),A23: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),max_extp(B,R),A13),A23)
    <=> ( aa(set(B),$o,finite_finite2(B),A13)
        & aa(set(B),$o,finite_finite2(B),A23)
        & ( A23 != aa(fun(B,$o),set(B),collect(B),bot_bot(fun(B,$o))) )
        & ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),A13)
           => ? [Xa2: B] :
                ( aa(set(B),$o,member(B,Xa2),A23)
                & aa(B,$o,aa(B,fun(B,$o),R,X3),Xa2) ) ) ) ) ).

% max_extp.simps
tff(fact_4222_max__extp_Ocases,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),A13: set(B),A23: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),max_extp(B,R),A13),A23)
     => ~ ( aa(set(B),$o,finite_finite2(B),A13)
         => ( aa(set(B),$o,finite_finite2(B),A23)
           => ( ( A23 != aa(fun(B,$o),set(B),collect(B),bot_bot(fun(B,$o))) )
             => ~ ! [X4: B] :
                    ( aa(set(B),$o,member(B,X4),A13)
                   => ? [Xa4: B] :
                        ( aa(set(B),$o,member(B,Xa4),A23)
                        & aa(B,$o,aa(B,fun(B,$o),R,X4),Xa4) ) ) ) ) ) ) ).

% max_extp.cases
tff(fact_4223_principal__def,axiom,
    ! [B: $tType,S: set(B)] : ( principal(B,S) = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),aa(set(B),fun(fun(B,$o),$o),ball(B),S)) ) ).

% principal_def
tff(fact_4224_filtermap__def,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),F: filter(C)] : ( filtermap(C,B,F2,F) = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),aa(filter(C),fun(fun(B,$o),$o),aTP_Lamp_afb(fun(C,B),fun(filter(C),fun(fun(B,$o),$o)),F2),F)) ) ).

% filtermap_def
tff(fact_4225_map__filter__on__def,axiom,
    ! [B: $tType,C: $tType,X5: set(C),F2: fun(C,B),F: filter(C)] : ( map_filter_on(C,B,X5,F2,F) = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),aa(filter(C),fun(fun(B,$o),$o),aa(fun(C,B),fun(filter(C),fun(fun(B,$o),$o)),aTP_Lamp_afd(set(C),fun(fun(C,B),fun(filter(C),fun(fun(B,$o),$o))),X5),F2),F)) ) ).

% map_filter_on_def
tff(fact_4226_in__chain__finite,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [A3: set(B)] :
          ( comple1602240252501008431_chain(B,ord_less_eq(B),A3)
         => ( aa(set(B),$o,finite_finite2(B),A3)
           => ( ( A3 != bot_bot(set(B)) )
             => aa(set(B),$o,member(B,aa(set(B),B,complete_Sup_Sup(B),A3)),A3) ) ) ) ) ).

% in_chain_finite
tff(fact_4227_map__project__def,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,option(B)),A3: set(C)] : ( map_project(C,B,F2,A3) = aa(fun(B,$o),set(B),collect(B),aa(set(C),fun(B,$o),aTP_Lamp_afe(fun(C,option(B)),fun(set(C),fun(B,$o)),F2),A3)) ) ).

% map_project_def
tff(fact_4228_iteratesp__def,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [X4: fun(B,B)] : ( comple7512665784863727008ratesp(B,X4) = complete_lattice_lfp(fun(B,$o),aTP_Lamp_aek(fun(B,B),fun(fun(B,$o),fun(B,$o)),X4)) ) ) ).

% iteratesp_def
tff(fact_4229_wo__rel_Osuc__greater,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),B2: set(B),B3: B] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R2))
       => ( ( order_AboveS(B,R2,B2) != bot_bot(set(B)) )
         => ( aa(set(B),$o,member(B,B3),B2)
           => ( ( bNF_Wellorder_wo_suc(B,R2,B2) != B3 )
              & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B3),bNF_Wellorder_wo_suc(B,R2,B2))),R2) ) ) ) ) ) ).

% wo_rel.suc_greater
tff(fact_4230_wo__rel_Osuc__AboveS,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R2))
       => ( ( order_AboveS(B,R2,B2) != bot_bot(set(B)) )
         => aa(set(B),$o,member(B,bNF_Wellorder_wo_suc(B,R2,B2)),order_AboveS(B,R2,B2)) ) ) ) ).

% wo_rel.suc_AboveS
tff(fact_4231_wo__rel_Osuc__inField,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R2))
       => ( ( order_AboveS(B,R2,B2) != bot_bot(set(B)) )
         => aa(set(B),$o,member(B,bNF_Wellorder_wo_suc(B,R2,B2)),field2(B,R2)) ) ) ) ).

% wo_rel.suc_inField
tff(fact_4232_max__ext__eq,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] : ( max_ext(B,R) = aa(fun(product_prod(set(B),set(B)),$o),set(product_prod(set(B),set(B))),collect(product_prod(set(B),set(B))),aa(fun(set(B),fun(set(B),$o)),fun(product_prod(set(B),set(B)),$o),product_case_prod(set(B),set(B),$o),aTP_Lamp_aff(set(product_prod(B,B)),fun(set(B),fun(set(B),$o)),R))) ) ).

% max_ext_eq
tff(fact_4233_wo__rel_Osuc__ofilter__in,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B),B3: B] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( order_ofilter(B,R2,A3)
       => ( ( order_AboveS(B,R2,A3) != bot_bot(set(B)) )
         => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B3),bNF_Wellorder_wo_suc(B,R2,A3))),R2)
           => ( ( B3 != bNF_Wellorder_wo_suc(B,R2,A3) )
             => aa(set(B),$o,member(B,B3),A3) ) ) ) ) ) ).

% wo_rel.suc_ofilter_in
tff(fact_4234_univ__def,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),X5: set(C)] : ( bNF_Greatest_univ(C,B,F2,X5) = aa(C,B,F2,fChoice(C,aTP_Lamp_nw(set(C),fun(C,$o),X5))) ) ).

% univ_def
tff(fact_4235_flip__pred,axiom,
    ! [B: $tType,C: $tType,A3: set(product_prod(B,C)),R: fun(C,fun(B,$o))] :
      ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),A3),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),conversep(C,B,R))))
     => aa(set(product_prod(C,B)),$o,aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),$o),ord_less_eq(set(product_prod(C,B))),aa(set(product_prod(B,C)),set(product_prod(C,B)),image2(product_prod(B,C),product_prod(C,B),aa(fun(B,fun(C,product_prod(C,B))),fun(product_prod(B,C),product_prod(C,B)),product_case_prod(B,C,product_prod(C,B)),aTP_Lamp_ei(B,fun(C,product_prod(C,B))))),A3)),aa(fun(product_prod(C,B),$o),set(product_prod(C,B)),collect(product_prod(C,B)),aa(fun(C,fun(B,$o)),fun(product_prod(C,B),$o),product_case_prod(C,B,$o),R))) ) ).

% flip_pred
tff(fact_4236_conversep__noteq,axiom,
    ! [B: $tType,X4: B,Xa3: B] :
      ( aa(B,$o,aa(B,fun(B,$o),conversep(B,B,aTP_Lamp_adk(B,fun(B,$o))),X4),Xa3)
    <=> ( X4 != Xa3 ) ) ).

% conversep_noteq
tff(fact_4237_eventually__all__finite,axiom,
    ! [B: $tType,C: $tType] :
      ( finite_finite(B)
     => ! [Pa: fun(C,fun(B,$o)),Net: filter(C)] :
          ( ! [Y2: B] : eventually(C,aa(B,fun(C,$o),aTP_Lamp_afg(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Pa),Y2),Net)
         => eventually(C,aTP_Lamp_afh(fun(C,fun(B,$o)),fun(C,$o),Pa),Net) ) ) ).

% eventually_all_finite
tff(fact_4238_converse__meet,axiom,
    ! [B: $tType,C: $tType,R2: fun(C,fun(B,$o)),S2: fun(C,fun(B,$o))] : ( conversep(C,B,aa(fun(C,fun(B,$o)),fun(C,fun(B,$o)),aa(fun(C,fun(B,$o)),fun(fun(C,fun(B,$o)),fun(C,fun(B,$o))),inf_inf(fun(C,fun(B,$o))),R2),S2)) = aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),conversep(C,B,R2)),conversep(C,B,S2)) ) ).

% converse_meet
tff(fact_4239_rel__fun__def,axiom,
    ! [B: $tType,C: $tType,E: $tType,D: $tType,A3: fun(B,fun(D,$o)),B2: fun(C,fun(E,$o)),X4: fun(B,C),Xa3: fun(D,E)] :
      ( aa(fun(D,E),$o,aa(fun(B,C),fun(fun(D,E),$o),bNF_rel_fun(B,D,C,E,A3,B2),X4),Xa3)
    <=> ! [Xb2: B,Y4: D] :
          ( aa(D,$o,aa(B,fun(D,$o),A3,Xb2),Y4)
         => aa(E,$o,aa(C,fun(E,$o),B2,aa(B,C,X4,Xb2)),aa(D,E,Xa3,Y4)) ) ) ).

% rel_fun_def
tff(fact_4240_rel__fun__eq__rel,axiom,
    ! [C: $tType,D: $tType,B: $tType,R: fun(C,fun(D,$o)),X4: fun(B,C),Xa3: fun(B,D)] :
      ( aa(fun(B,D),$o,aa(fun(B,C),fun(fun(B,D),$o),bNF_rel_fun(B,B,C,D,fequal(B),R),X4),Xa3)
    <=> ! [Xb2: B] : aa(D,$o,aa(C,fun(D,$o),R,aa(B,C,X4,Xb2)),aa(B,D,Xa3,Xb2)) ) ).

% rel_fun_eq_rel
tff(fact_4241_top__filter__def,axiom,
    ! [B: $tType] : ( top_top(filter(B)) = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),fAll(B)) ) ).

% top_filter_def
tff(fact_4242_conversep__converse__eq,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(C,B)),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),conversep(C,B,aTP_Lamp_jo(set(product_prod(C,B)),fun(C,fun(B,$o)),R2)),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),converse(C,B,R2)) ) ).

% conversep_converse_eq
tff(fact_4243_converse__def,axiom,
    ! [C: $tType,B: $tType,X4: set(product_prod(B,C))] : ( converse(B,C,X4) = aa(fun(product_prod(C,B),$o),set(product_prod(C,B)),collect(product_prod(C,B)),aa(fun(C,fun(B,$o)),fun(product_prod(C,B),$o),product_case_prod(C,B,$o),conversep(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),X4)))) ) ).

% converse_def
tff(fact_4244_finite__set__of__finite__funs,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C),D3: C] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(C),$o,finite_finite2(C),B2)
       => aa(set(fun(B,C)),$o,finite_finite2(fun(B,C)),aa(fun(fun(B,C),$o),set(fun(B,C)),collect(fun(B,C)),aa(C,fun(fun(B,C),$o),aa(set(C),fun(C,fun(fun(B,C),$o)),aTP_Lamp_afi(set(B),fun(set(C),fun(C,fun(fun(B,C),$o))),A3),B2),D3))) ) ) ).

% finite_set_of_finite_funs
tff(fact_4245_Collect__all__eq,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,fun(C,$o))] : ( aa(fun(B,$o),set(B),collect(B),aTP_Lamp_afj(fun(B,fun(C,$o)),fun(B,$o),Pa)) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_gx(fun(B,fun(C,$o)),fun(C,set(B)),Pa)),top_top(set(C)))) ) ).

% Collect_all_eq
tff(fact_4246_eventually__all__ge__at__top,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Pa: fun(B,$o)] :
          ( eventually(B,Pa,at_top(B))
         => eventually(B,aTP_Lamp_afk(fun(B,$o),fun(B,$o),Pa),at_top(B)) ) ) ).

% eventually_all_ge_at_top
tff(fact_4247_Least__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [Pa: fun(B,$o)] : ( ord_Least(B,Pa) = the(B,aTP_Lamp_afl(fun(B,$o),fun(B,$o),Pa)) ) ) ).

% Least_def
tff(fact_4248_wo__rel_Oofilter__UNION,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(B,B)),I: set(C),A3: fun(C,set(B))] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( ! [I3: C] :
            ( aa(set(C),$o,member(C,I3),I)
           => order_ofilter(B,R2,aa(C,set(B),A3,I3)) )
       => order_ofilter(B,R2,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I))) ) ) ).

% wo_rel.ofilter_UNION
tff(fact_4249_inf__filter__def,axiom,
    ! [B: $tType,F: filter(B),F3: filter(B)] : ( aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F),F3) = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),aa(filter(B),fun(fun(B,$o),$o),aTP_Lamp_afm(filter(B),fun(filter(B),fun(fun(B,$o),$o)),F),F3)) ) ).

% inf_filter_def
tff(fact_4250_ofilterIncl__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( bNF_We413866401316099525erIncl(B,R2) = aa(fun(product_prod(set(B),set(B)),$o),set(product_prod(set(B),set(B))),collect(product_prod(set(B),set(B))),aa(fun(set(B),fun(set(B),$o)),fun(product_prod(set(B),set(B)),$o),product_case_prod(set(B),set(B),$o),aTP_Lamp_afn(set(product_prod(B,B)),fun(set(B),fun(set(B),$o)),R2))) ) ).

% ofilterIncl_def
tff(fact_4251_Greatest__def,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o)] : ( order_Greatest(B,Pa) = the(B,aTP_Lamp_afo(fun(B,$o),fun(B,$o),Pa)) ) ) ).

% Greatest_def
tff(fact_4252_ord_OLeast__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Pa: fun(B,$o)] : ( aa(fun(B,$o),B,least(B,Less_eq),Pa) = the(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_afp(fun(B,fun(B,$o)),fun(fun(B,$o),fun(B,$o)),Less_eq),Pa)) ) ).

% ord.Least_def
tff(fact_4253_transfer__bforall__def,axiom,
    ! [B: $tType,X4: fun(B,$o),Xa3: fun(B,$o)] :
      ( transfer_bforall(B,X4,Xa3)
    <=> ! [Xb2: B] :
          ( aa(B,$o,X4,Xb2)
         => aa(B,$o,Xa3,Xb2) ) ) ).

% transfer_bforall_def
tff(fact_4254_ord_OLeast_Ocong,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o))] : ( least(B,Less_eq) = least(B,Less_eq) ) ).

% ord.Least.cong
tff(fact_4255_GreatestI2__order,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o),X2: B,Qa: fun(B,$o)] :
          ( aa(B,$o,Pa,X2)
         => ( ! [Y2: B] :
                ( aa(B,$o,Pa,Y2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),X2) )
           => ( ! [X: B] :
                  ( aa(B,$o,Pa,X)
                 => ( ! [Y5: B] :
                        ( aa(B,$o,Pa,Y5)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y5),X) )
                   => aa(B,$o,Qa,X) ) )
             => aa(B,$o,Qa,order_Greatest(B,Pa)) ) ) ) ) ).

% GreatestI2_order
tff(fact_4256_Greatest__equality,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o),X2: B] :
          ( aa(B,$o,Pa,X2)
         => ( ! [Y2: B] :
                ( aa(B,$o,Pa,Y2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),X2) )
           => ( order_Greatest(B,Pa) = X2 ) ) ) ) ).

% Greatest_equality
tff(fact_4257_filtercomap__def,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),F: filter(C)] : ( filtercomap(B,C,F2,F) = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),aa(filter(C),fun(fun(B,$o),$o),aTP_Lamp_afq(fun(B,C),fun(filter(C),fun(fun(B,$o),$o)),F2),F)) ) ).

% filtercomap_def
tff(fact_4258_init__seg__of__def,axiom,
    ! [B: $tType] : ( init_seg_of(B) = aa(fun(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),$o),set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),collect(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),aa(fun(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o)),fun(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),$o),product_case_prod(set(product_prod(B,B)),set(product_prod(B,B)),$o),aTP_Lamp_afr(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o)))) ) ).

% init_seg_of_def
tff(fact_4259_wo__rel_Oofilter__under__UNION,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R2)
     => ( order_ofilter(B,R2,A3)
       => ( A3 = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(B),set(set(B)),image2(B,set(B),order_under(B,R2)),A3)) ) ) ) ).

% wo_rel.ofilter_under_UNION
tff(fact_4260_ofilter__Restr__Int,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(B,R2,A3)
       => order_ofilter(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,B2,aTP_Lamp_cr(set(B),fun(B,set(B)),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ) ).

% ofilter_Restr_Int
tff(fact_4261_filtercomap__bot,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C)] : ( filtercomap(B,C,F2,bot_bot(filter(C))) = bot_bot(filter(B)) ) ).

% filtercomap_bot
tff(fact_4262_eventually__filtercomapI,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),F: filter(B),F2: fun(C,B)] :
      ( eventually(B,Pa,F)
     => eventually(C,aa(fun(C,B),fun(C,$o),aTP_Lamp_nm(fun(B,$o),fun(fun(C,B),fun(C,$o)),Pa),F2),filtercomap(C,B,F2,F)) ) ).

% eventually_filtercomapI
tff(fact_4263_filtercomap__filtercomap,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(B,C),G: fun(C,D),F: filter(D)] : ( filtercomap(B,C,F2,filtercomap(C,D,G,F)) = filtercomap(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_afs(fun(B,C),fun(fun(C,D),fun(B,D)),F2),G),F) ) ).

% filtercomap_filtercomap
tff(fact_4264_filtercomap__ident,axiom,
    ! [B: $tType,F: filter(B)] : ( filtercomap(B,B,aTP_Lamp_bk(B,B),F) = F ) ).

% filtercomap_ident
tff(fact_4265_filtercomap__inf,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),F12: filter(C),F23: filter(C)] : ( filtercomap(B,C,F2,aa(filter(C),filter(C),aa(filter(C),fun(filter(C),filter(C)),inf_inf(filter(C)),F12),F23)) = aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),filtercomap(B,C,F2,F12)),filtercomap(B,C,F2,F23)) ) ).

% filtercomap_inf
tff(fact_4266_under__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B] : ( aa(B,set(B),order_under(B,R2),A4) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_mv(set(product_prod(B,B)),fun(B,fun(B,$o)),R2),A4)) ) ).

% under_def
tff(fact_4267_well__order__on__empty,axiom,
    ! [B: $tType] : order_well_order_on(B,bot_bot(set(B)),bot_bot(set(product_prod(B,B)))) ).

% well_order_on_empty
tff(fact_4268_ofilter__Restr__under,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B),A4: B] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(B,R2,A3)
       => ( aa(set(B),$o,member(B,A4),A3)
         => ( aa(B,set(B),order_under(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),A4) = aa(B,set(B),order_under(B,R2),A4) ) ) ) ) ).

% ofilter_Restr_under
tff(fact_4269_filtercomap__neq__bot,axiom,
    ! [B: $tType,C: $tType,F: filter(B),F2: fun(C,B)] :
      ( ! [P: fun(B,$o)] :
          ( eventually(B,P,F)
         => ? [X4: C] : aa(B,$o,P,aa(C,B,F2,X4)) )
     => ( filtercomap(C,B,F2,F) != bot_bot(filter(C)) ) ) ).

% filtercomap_neq_bot
tff(fact_4270_filtercomap__INF,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(B,C),F: fun(D,filter(C)),B2: set(D)] : ( filtercomap(B,C,F2,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(D),set(filter(C)),image2(D,filter(C),F),B2))) = aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(D),set(filter(B)),image2(D,filter(B),aa(fun(D,filter(C)),fun(D,filter(B)),aTP_Lamp_aft(fun(B,C),fun(fun(D,filter(C)),fun(D,filter(B))),F2),F)),B2)) ) ).

% filtercomap_INF
tff(fact_4271_Well__order__Restr,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => order_well_order_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) ) ).

% Well_order_Restr
tff(fact_4272_natLeq__on__well__order__on,axiom,
    ! [N: nat] : order_well_order_on(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N)),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_tp(nat,fun(nat,fun(nat,$o)),N)))) ).

% natLeq_on_well_order_on
tff(fact_4273_bsqr__ofilter,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),D2: set(product_prod(B,B))] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(product_prod(B,B),bNF_Wellorder_bsqr(B,R2),D2)
       => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less(set(product_prod(B,B))),D2),product_Sigma(B,B,field2(B,R2),aTP_Lamp_ey(set(product_prod(B,B)),fun(B,set(B)),R2)))
         => ( ~ ? [A5: B] : ( field2(B,R2) = aa(B,set(B),order_under(B,R2),A5) )
           => ? [A11: set(B)] :
                ( order_ofilter(B,R2,A11)
                & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A11),field2(B,R2))
                & aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),D2),product_Sigma(B,B,A11,aTP_Lamp_cr(set(B),fun(B,set(B)),A11))) ) ) ) ) ) ).

% bsqr_ofilter
tff(fact_4274_filtercomap__neq__bot__surj,axiom,
    ! [B: $tType,C: $tType,F: filter(B),F2: fun(C,B)] :
      ( ( F != bot_bot(filter(B)) )
     => ( ( aa(set(C),set(B),image2(C,B,F2),top_top(set(C))) = top_top(set(B)) )
       => ( filtercomap(C,B,F2,F) != bot_bot(filter(C)) ) ) ) ).

% filtercomap_neq_bot_surj
tff(fact_4275_well__order__on__Restr,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),field2(B,R2))
       => order_well_order_on(B,A3,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) ) ) ).

% well_order_on_Restr
tff(fact_4276_Field__Restr__ofilter,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(B,R2,A3)
       => ( field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))) = A3 ) ) ) ).

% Field_Restr_ofilter
tff(fact_4277_natLeq__on__Well__order,axiom,
    ! [N: nat] : order_well_order_on(nat,field2(nat,aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_tp(nat,fun(nat,fun(nat,$o)),N)))),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_tp(nat,fun(nat,fun(nat,$o)),N)))) ).

% natLeq_on_Well_order
tff(fact_4278_filtercomap__SUP,axiom,
    ! [B: $tType,D: $tType,C: $tType,F2: fun(B,D),F: fun(C,filter(D)),B2: set(C)] : aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),aa(set(filter(B)),filter(B),complete_Sup_Sup(filter(B)),aa(set(C),set(filter(B)),image2(C,filter(B),aa(fun(C,filter(D)),fun(C,filter(B)),aTP_Lamp_afu(fun(B,D),fun(fun(C,filter(D)),fun(C,filter(B))),F2),F)),B2))),filtercomap(B,D,F2,aa(set(filter(D)),filter(D),complete_Sup_Sup(filter(D)),aa(set(C),set(filter(D)),image2(C,filter(D),F),B2)))) ).

% filtercomap_SUP
tff(fact_4279_Linear__order__Well__order__iff,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( order_679001287576687338der_on(B,field2(B,R2),R2)
     => ( order_well_order_on(B,field2(B,R2),R2)
      <=> ! [A12: set(B)] :
            ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A12),field2(B,R2))
           => ( ( A12 != bot_bot(set(B)) )
             => ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A12)
                  & ! [Xa2: B] :
                      ( aa(set(B),$o,member(B,Xa2),A12)
                     => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa2)),R2) ) ) ) ) ) ) ).

% Linear_order_Well_order_iff
tff(fact_4280_ofilter__Restr__subset,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(B,R2,A3)
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
         => order_ofilter(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,B2,aTP_Lamp_cr(set(B),fun(B,set(B)),B2))),A3) ) ) ) ).

% ofilter_Restr_subset
tff(fact_4281_UNION__inj__on__ofilter,axiom,
    ! [D: $tType,B: $tType,C: $tType,R2: set(product_prod(B,B)),I: set(C),A3: fun(C,set(B)),F2: fun(B,D)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( ! [I3: C] :
            ( aa(set(C),$o,member(C,I3),I)
           => order_ofilter(B,R2,aa(C,set(B),A3,I3)) )
       => ( ! [I3: C] :
              ( aa(set(C),$o,member(C,I3),I)
             => inj_on(B,D,F2,aa(C,set(B),A3,I3)) )
         => inj_on(B,D,F2,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I))) ) ) ) ).

% UNION_inj_on_ofilter
tff(fact_4282_ofilter__subset__embedS,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(B,R2,A3)
       => ( order_ofilter(B,R2,B2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A3),B2)
          <=> bNF_Wellorder_embedS(B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,B2,aTP_Lamp_cr(set(B),fun(B,set(B)),B2))),id(B)) ) ) ) ) ).

% ofilter_subset_embedS
tff(fact_4283_ofilter__subset__embed,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(B,R2,A3)
       => ( order_ofilter(B,R2,B2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
          <=> aa(fun(B,B),$o,bNF_Wellorder_embed(B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,B2,aTP_Lamp_cr(set(B),fun(B,set(B)),B2)))),id(B)) ) ) ) ) ).

% ofilter_subset_embed
tff(fact_4284_ofilter__embed,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(B,R2,A3)
      <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),field2(B,R2))
          & aa(fun(B,B),$o,bNF_Wellorder_embed(B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))),R2),id(B)) ) ) ) ).

% ofilter_embed
tff(fact_4285_embedS__defs_I2_J,axiom,
    ! [B: $tType,C: $tType,X4: set(product_prod(B,B)),Xa3: set(product_prod(C,C)),Xb3: fun(B,C)] :
      ( bNF_Wellorder_embedS(B,C,X4,Xa3,Xb3)
    <=> ( aa(fun(B,C),$o,bNF_Wellorder_embed(B,C,X4,Xa3),Xb3)
        & ~ bij_betw(B,C,Xb3,field2(B,X4),field2(C,Xa3)) ) ) ).

% embedS_defs(2)
tff(fact_4286_embed__defs_I2_J,axiom,
    ! [C: $tType,B: $tType,X4: set(product_prod(B,B)),Xa3: set(product_prod(C,C)),Xb3: fun(B,C)] :
      ( aa(fun(B,C),$o,bNF_Wellorder_embed(B,C,X4,Xa3),Xb3)
    <=> ! [Xc: B] :
          ( aa(set(B),$o,member(B,Xc),field2(B,X4))
         => bij_betw(B,C,Xb3,aa(B,set(B),order_under(B,X4),Xc),aa(C,set(C),order_under(C,Xa3),aa(B,C,Xb3,Xc))) ) ) ).

% embed_defs(2)
tff(fact_4287_ord__to__filter__def,axiom,
    ! [B: $tType,R0: set(product_prod(B,B)),R2: set(product_prod(B,B))] : ( aa(set(product_prod(B,B)),set(B),bNF_We8469521843155493636filter(B,R0),R2) = aa(set(B),set(B),image2(B,B,fChoice(fun(B,B),bNF_Wellorder_embed(B,B,R2,R0))),field2(B,R2)) ) ).

% ord_to_filter_def
tff(fact_4288_ofilter__subset__embedS__iso,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(B,R2,A3)
       => ( order_ofilter(B,R2,B2)
         => ( ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A3),B2)
            <=> bNF_Wellorder_embedS(B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,B2,aTP_Lamp_cr(set(B),fun(B,set(B)),B2))),id(B)) )
            & ( ( A3 = B2 )
            <=> bNF_Wellorder_iso(B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,B2,aTP_Lamp_cr(set(B),fun(B,set(B)),B2))),id(B)) ) ) ) ) ) ).

% ofilter_subset_embedS_iso
tff(fact_4289_embed__implies__iso__Restr,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(B,B)),R4: set(product_prod(C,C)),F2: fun(C,B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( aa(fun(C,B),$o,bNF_Wellorder_embed(C,B,R4,R2),F2)
         => bNF_Wellorder_iso(C,B,R4,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,aa(set(C),set(B),image2(C,B,F2),field2(C,R4)),aa(fun(C,B),fun(B,set(B)),aTP_Lamp_afv(set(product_prod(C,C)),fun(fun(C,B),fun(B,set(B))),R4),F2))),F2) ) ) ) ).

% embed_implies_iso_Restr
tff(fact_4290_ordLess__def,axiom,
    ! [C: $tType,B: $tType] : ( bNF_We4044943003108391690rdLess(B,C) = aa(fun(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),$o),set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),collect(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),aa(fun(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o)),fun(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),$o),product_case_prod(set(product_prod(B,B)),set(product_prod(C,C)),$o),aTP_Lamp_afw(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o)))) ) ).

% ordLess_def
tff(fact_4291_iso__defs_I2_J,axiom,
    ! [B: $tType,C: $tType,X4: set(product_prod(B,B)),Xa3: set(product_prod(C,C)),Xb3: fun(B,C)] :
      ( bNF_Wellorder_iso(B,C,X4,Xa3,Xb3)
    <=> ( aa(fun(B,C),$o,bNF_Wellorder_embed(B,C,X4,Xa3),Xb3)
        & bij_betw(B,C,Xb3,field2(B,X4),field2(C,Xa3)) ) ) ).

% iso_defs(2)
tff(fact_4292_ofilter__ordLess,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(B,R2,A3)
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A3),field2(B,R2))
        <=> aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),R2)),bNF_We4044943003108391690rdLess(B,B)) ) ) ) ).

% ofilter_ordLess
tff(fact_4293_ofilter__subset__ordLess,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(B,R2,A3)
       => ( order_ofilter(B,R2,B2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A3),B2)
          <=> aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,B2,aTP_Lamp_cr(set(B),fun(B,set(B)),B2))))),bNF_We4044943003108391690rdLess(B,B)) ) ) ) ) ).

% ofilter_subset_ordLess
tff(fact_4294_ord__to__filter__compat,axiom,
    ! [B: $tType,R0: set(product_prod(B,B))] : bNF_Wellorder_compat(set(product_prod(B,B)),set(B),aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),fun(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),set(product_prod(set(product_prod(B,B)),set(product_prod(B,B))))),inf_inf(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B))))),bNF_We4044943003108391690rdLess(B,B)),product_Sigma(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(set(product_prod(B,B))),set(set(product_prod(B,B))),image(set(product_prod(B,B)),set(product_prod(B,B)),converse(set(product_prod(B,B)),set(product_prod(B,B)),bNF_We4044943003108391690rdLess(B,B))),aa(set(set(product_prod(B,B))),set(set(product_prod(B,B))),insert(set(product_prod(B,B)),R0),bot_bot(set(set(product_prod(B,B)))))),aTP_Lamp_afx(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(set(product_prod(B,B)))),R0))),bNF_We413866401316099525erIncl(B,R0),bNF_We8469521843155493636filter(B,R0)) ).

% ord_to_filter_compat
tff(fact_4295_underS__Restr__ordLess,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( ( field2(B,R2) != bot_bot(set(B)) )
       => aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,order_underS(B,R2,A4),aa(B,fun(B,set(B)),aTP_Lamp_afy(set(product_prod(B,B)),fun(B,fun(B,set(B))),R2),A4)))),R2)),bNF_We4044943003108391690rdLess(B,B)) ) ) ).

% underS_Restr_ordLess
tff(fact_4296_Refl__under__underS,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B] :
      ( refl_on(B,field2(B,R2),R2)
     => ( aa(set(B),$o,member(B,A4),field2(B,R2))
       => ( aa(B,set(B),order_under(B,R2),A4) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),order_underS(B,R2,A4)),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) ) ) ) ).

% Refl_under_underS
tff(fact_4297_ordIso__def,axiom,
    ! [C: $tType,B: $tType] : ( bNF_Wellorder_ordIso(B,C) = aa(fun(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),$o),set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),collect(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),aa(fun(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o)),fun(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),$o),product_case_prod(set(product_prod(B,B)),set(product_prod(C,C)),$o),aTP_Lamp_afz(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o)))) ) ).

% ordIso_def
tff(fact_4298_underS__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B] : ( order_underS(B,R2,A4) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_aga(set(product_prod(B,B)),fun(B,fun(B,$o)),R2),A4)) ) ).

% underS_def
tff(fact_4299_underS__empty,axiom,
    ! [B: $tType,A4: B,R2: set(product_prod(B,B))] :
      ( ~ aa(set(B),$o,member(B,A4),field2(B,R2))
     => ( order_underS(B,R2,A4) = bot_bot(set(B)) ) ) ).

% underS_empty
tff(fact_4300_ordLess__iff__ordIso__Restr,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),R2)),bNF_We4044943003108391690rdLess(C,B))
        <=> ? [X3: B] :
              ( aa(set(B),$o,member(B,X3),field2(B,R2))
              & aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,order_underS(B,R2,X3),aa(B,fun(B,set(B)),aTP_Lamp_afy(set(product_prod(B,B)),fun(B,fun(B,set(B))),R2),X3))))),bNF_Wellorder_ordIso(C,B)) ) ) ) ) ).

% ordLess_iff_ordIso_Restr
tff(fact_4301_underS__Field3,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B] :
      ( ( field2(B,R2) != bot_bot(set(B)) )
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),order_underS(B,R2,A4)),field2(B,R2)) ) ).

% underS_Field3
tff(fact_4302_ordLeq__iff__ordLess__Restr,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R2),R4)),bNF_Wellorder_ordLeq(B,C))
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),field2(B,R2))
             => aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,order_underS(B,R2,X3),aa(B,fun(B,set(B)),aTP_Lamp_afy(set(product_prod(B,B)),fun(B,fun(B,set(B))),R2),X3)))),R4)),bNF_We4044943003108391690rdLess(B,C)) ) ) ) ) ).

% ordLeq_iff_ordLess_Restr
tff(fact_4303_ofilter__subset__ordLeq,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( order_ofilter(B,R2,A3)
       => ( order_ofilter(B,R2,B2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
          <=> aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,B2,aTP_Lamp_cr(set(B),fun(B,set(B)),B2))))),bNF_Wellorder_ordLeq(B,B)) ) ) ) ) ).

% ofilter_subset_ordLeq
tff(fact_4304_ordLeq__def,axiom,
    ! [C: $tType,B: $tType] : ( bNF_Wellorder_ordLeq(B,C) = aa(fun(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),$o),set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),collect(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),aa(fun(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o)),fun(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),$o),product_case_prod(set(product_prod(B,B)),set(product_prod(C,C)),$o),aTP_Lamp_agb(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o)))) ) ).

% ordLeq_def
tff(fact_4305_finite__subset__Union__chain,axiom,
    ! [B: $tType,A3: set(B),B7: set(set(B)),A16: set(set(B))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B7))
       => ( ( B7 != bot_bot(set(set(B))) )
         => ( aa(set(set(B)),$o,pred_chain(set(B),A16,ord_less(set(B))),B7)
           => ~ ! [B8: set(B)] :
                  ( aa(set(set(B)),$o,member(set(B),B8),B7)
                 => ~ aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B8) ) ) ) ) ) ).

% finite_subset_Union_chain
tff(fact_4306_pred__on_Ochain__empty,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,fun(B,$o))] : aa(set(B),$o,pred_chain(B,A3,Pa),bot_bot(set(B))) ).

% pred_on.chain_empty
tff(fact_4307_subset_Ochain__empty,axiom,
    ! [B: $tType,A3: set(set(B))] : aa(set(set(B)),$o,pred_chain(set(B),A3,ord_less(set(B))),bot_bot(set(set(B)))) ).

% subset.chain_empty
tff(fact_4308_chains__alt__def,axiom,
    ! [B: $tType,A3: set(set(B))] : ( chains2(B,A3) = aa(fun(set(set(B)),$o),set(set(set(B))),collect(set(set(B))),pred_chain(set(B),A3,ord_less(set(B)))) ) ).

% chains_alt_def
tff(fact_4309_subset__Zorn__nonempty,axiom,
    ! [B: $tType,A16: set(set(B))] :
      ( ( A16 != bot_bot(set(set(B))) )
     => ( ! [C7: set(set(B))] :
            ( ( C7 != bot_bot(set(set(B))) )
           => ( aa(set(set(B)),$o,pred_chain(set(B),A16,ord_less(set(B))),C7)
             => aa(set(set(B)),$o,member(set(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C7)),A16) ) )
       => ? [X: set(B)] :
            ( aa(set(set(B)),$o,member(set(B),X),A16)
            & ! [Xa3: set(B)] :
                ( aa(set(set(B)),$o,member(set(B),Xa3),A16)
               => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X),Xa3)
                 => ( Xa3 = X ) ) ) ) ) ) ).

% subset_Zorn_nonempty
tff(fact_4310_Union__in__chain,axiom,
    ! [B: $tType,B7: set(set(B)),A16: set(set(B))] :
      ( aa(set(set(B)),$o,finite_finite2(set(B)),B7)
     => ( ( B7 != bot_bot(set(set(B))) )
       => ( aa(set(set(B)),$o,pred_chain(set(B),A16,ord_less(set(B))),B7)
         => aa(set(set(B)),$o,member(set(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B7)),B7) ) ) ) ).

% Union_in_chain
tff(fact_4311_Inter__in__chain,axiom,
    ! [B: $tType,B7: set(set(B)),A16: set(set(B))] :
      ( aa(set(set(B)),$o,finite_finite2(set(B)),B7)
     => ( ( B7 != bot_bot(set(set(B))) )
       => ( aa(set(set(B)),$o,pred_chain(set(B),A16,ord_less(set(B))),B7)
         => aa(set(set(B)),$o,member(set(B),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B7)),B7) ) ) ) ).

% Inter_in_chain
tff(fact_4312_exists__minim__Well__order,axiom,
    ! [B: $tType,R: set(set(product_prod(B,B)))] :
      ( ( R != bot_bot(set(set(product_prod(B,B)))) )
     => ( ! [X: set(product_prod(B,B))] :
            ( aa(set(set(product_prod(B,B))),$o,member(set(product_prod(B,B)),X),R)
           => order_well_order_on(B,field2(B,X),X) )
       => ? [X: set(product_prod(B,B))] :
            ( aa(set(set(product_prod(B,B))),$o,member(set(product_prod(B,B)),X),R)
            & ! [Xa3: set(product_prod(B,B))] :
                ( aa(set(set(product_prod(B,B))),$o,member(set(product_prod(B,B)),Xa3),R)
               => aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),X),Xa3)),bNF_Wellorder_ordLeq(B,B)) ) ) ) ) ).

% exists_minim_Well_order
tff(fact_4313_subset_Ochain__extend,axiom,
    ! [B: $tType,A3: set(set(B)),C2: set(set(B)),Z2: set(B)] :
      ( aa(set(set(B)),$o,pred_chain(set(B),A3,ord_less(set(B))),C2)
     => ( aa(set(set(B)),$o,member(set(B),Z2),A3)
       => ( ! [X: set(B)] :
              ( aa(set(set(B)),$o,member(set(B),X),C2)
             => aa(set(B),$o,aa(set(B),fun(set(B),$o),aa(fun(set(B),fun(set(B),$o)),fun(set(B),fun(set(B),$o)),aa(fun(set(B),fun(set(B),$o)),fun(fun(set(B),fun(set(B),$o)),fun(set(B),fun(set(B),$o))),sup_sup(fun(set(B),fun(set(B),$o))),ord_less(set(B))),fequal(set(B))),X),Z2) )
         => aa(set(set(B)),$o,pred_chain(set(B),A3,ord_less(set(B))),aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),sup_sup(set(set(B))),aa(set(set(B)),set(set(B)),insert(set(B),Z2),bot_bot(set(set(B))))),C2)) ) ) ) ).

% subset.chain_extend
tff(fact_4314_pred__on_Ochain__extend,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,fun(B,$o)),C2: set(B),Z2: B] :
      ( aa(set(B),$o,pred_chain(B,A3,Pa),C2)
     => ( aa(set(B),$o,member(B,Z2),A3)
       => ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),C2)
             => aa(B,$o,aa(B,fun(B,$o),aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),sup_sup(fun(B,fun(B,$o))),Pa),fequal(B)),X),Z2) )
         => aa(set(B),$o,pred_chain(B,A3,Pa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert(B,Z2),bot_bot(set(B)))),C2)) ) ) ) ).

% pred_on.chain_extend
tff(fact_4315_Chains__subset_H,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( refl_on(B,top_top(set(B)),R2)
     => aa(set(set(B)),$o,aa(set(set(B)),fun(set(set(B)),$o),ord_less_eq(set(set(B))),aa(fun(set(B),$o),set(set(B)),collect(set(B)),pred_chain(B,top_top(set(B)),aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2)))),chains(B,R2)) ) ).

% Chains_subset'
tff(fact_4316_Chains__subset,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : aa(set(set(B)),$o,aa(set(set(B)),fun(set(set(B)),$o),ord_less_eq(set(set(B))),chains(B,R2)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),pred_chain(B,top_top(set(B)),aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2)))) ).

% Chains_subset
tff(fact_4317_Chains__alt__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( refl_on(B,top_top(set(B)),R2)
     => ( chains(B,R2) = aa(fun(set(B),$o),set(set(B)),collect(set(B)),pred_chain(B,top_top(set(B)),aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2))) ) ) ).

% Chains_alt_def
tff(fact_4318_comp__set__bd__Union__o__collect,axiom,
    ! [D: $tType,C: $tType,B: $tType,X2: D,X5: set(fun(D,set(set(B)))),Hbd: set(product_prod(C,C))] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(set(B))),set(set(B)),complete_Sup_Sup(set(set(B))),aa(set(fun(D,set(set(B)))),set(set(set(B))),image2(fun(D,set(set(B))),set(set(B)),aTP_Lamp_agc(D,fun(fun(D,set(set(B))),set(set(B))),X2)),X5))))),Hbd)),bNF_Wellorder_ordLeq(B,C))
     => aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(D,set(B),aa(fun(D,set(set(B))),fun(D,set(B)),comp(set(set(B)),set(B),D,complete_Sup_Sup(set(B))),bNF_collect(D,set(B),X5)),X2))),Hbd)),bNF_Wellorder_ordLeq(B,C)) ) ).

% comp_set_bd_Union_o_collect
tff(fact_4319_card__of__Times3,axiom,
    ! [B: $tType,A3: set(B)] : aa(set(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,B),product_prod(B,B))))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,B),product_prod(B,B)))),aa(set(product_prod(product_prod(B,B),product_prod(B,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,B),product_prod(B,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(B,B),product_prod(B,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,B),product_prod(B,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(B,B),product_prod(B,B)))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(product_prod(B,B),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3))))),bNF_Wellorder_ordLeq(B,product_prod(B,B))) ).

% card_of_Times3
tff(fact_4320_card__of__Times2,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( ( A3 != bot_bot(set(B)) )
     => aa(set(product_prod(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C))))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(C,C)),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))))),bNF_Wellorder_ordLeq(C,product_prod(B,C))) ) ).

% card_of_Times2
tff(fact_4321_card__of__Times1,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( ( A3 != bot_bot(set(B)) )
     => aa(set(product_prod(set(product_prod(C,C)),set(product_prod(product_prod(C,B),product_prod(C,B))))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(C,C)),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(C,C)),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,B2,aTP_Lamp_bv(set(B),fun(C,set(B)),A3))))),bNF_Wellorder_ordLeq(C,product_prod(C,B))) ) ).

% card_of_Times1
tff(fact_4322_card__of__bool,axiom,
    ! [B: $tType,A13: B,A23: B] :
      ( ( A13 != A23 )
     => aa(set(product_prod(set(product_prod($o,$o)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod($o,$o)),fun(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B)))),product_Pair(set(product_prod($o,$o)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of($o,top_top(set($o)))),bNF_Ca6860139660246222851ard_of(B,aa(set(B),set(B),insert(B,A13),aa(set(B),set(B),insert(B,A23),bot_bot(set(B))))))),bNF_Wellorder_ordIso($o,B)) ) ).

% card_of_bool
tff(fact_4323_card__of__Times__same__infinite,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => aa(set(product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,B),product_prod(B,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(B,B),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordIso(product_prod(B,B),B)) ) ).

% card_of_Times_same_infinite
tff(fact_4324_card__of__Times__commute,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: set(C)] : aa(set(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B))))),$o,member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,B2,aTP_Lamp_bv(set(B),fun(C,set(B)),A3))))),bNF_Wellorder_ordIso(product_prod(B,C),product_prod(C,B))) ).

% card_of_Times_commute
tff(fact_4325_Func__Times__Range,axiom,
    ! [D: $tType,C: $tType,B: $tType,A3: set(B),B2: set(C),C2: set(D)] : aa(set(product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D)))))),$o,member(product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D))))),aa(set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D)))),product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D))))),aa(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),fun(set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D)))),product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D)))))),product_Pair(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D))))),bNF_Ca6860139660246222851ard_of(fun(B,product_prod(C,D)),bNF_Wellorder_Func(B,product_prod(C,D),A3,product_Sigma(C,D,B2,aTP_Lamp_eq(set(D),fun(C,set(D)),C2))))),bNF_Ca6860139660246222851ard_of(product_prod(fun(B,C),fun(B,D)),product_Sigma(fun(B,C),fun(B,D),bNF_Wellorder_Func(B,C,A3,B2),aa(set(D),fun(fun(B,C),set(fun(B,D))),aTP_Lamp_agd(set(B),fun(set(D),fun(fun(B,C),set(fun(B,D)))),A3),C2))))),bNF_Wellorder_ordIso(fun(B,product_prod(C,D)),product_prod(fun(B,C),fun(B,D)))) ).

% Func_Times_Range
tff(fact_4326_card__of__UNION__Sigma,axiom,
    ! [C: $tType,B: $tType,A3: fun(C,set(B)),I: set(C)] : aa(set(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B))))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A3),I)))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,I,A3)))),bNF_Wellorder_ordLeq(B,product_prod(C,B))) ).

% card_of_UNION_Sigma
tff(fact_4327_card__of__Sigma__mono1,axiom,
    ! [D: $tType,C: $tType,B: $tType,I: set(B),A3: fun(B,set(C)),B2: fun(B,set(D))] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),I)
         => aa(set(product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A3,X))),bNF_Ca6860139660246222851ard_of(D,aa(B,set(D),B2,X)))),bNF_Wellorder_ordLeq(C,D)) )
     => aa(set(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D))))),$o,member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D))))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,I,A3))),bNF_Ca6860139660246222851ard_of(product_prod(B,D),product_Sigma(B,D,I,B2)))),bNF_Wellorder_ordLeq(product_prod(B,C),product_prod(B,D))) ) ).

% card_of_Sigma_mono1
tff(fact_4328_card__of__Times__mono1,axiom,
    ! [C: $tType,D: $tType,B: $tType,A3: set(B),B2: set(C),C2: set(D)] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(C,B2))),bNF_Wellorder_ordLeq(B,C))
     => aa(set(product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D))))),$o,member(product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),fun(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D))))),product_Pair(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),bNF_Ca6860139660246222851ard_of(product_prod(B,D),product_Sigma(B,D,A3,aTP_Lamp_ly(set(D),fun(B,set(D)),C2)))),bNF_Ca6860139660246222851ard_of(product_prod(C,D),product_Sigma(C,D,B2,aTP_Lamp_eq(set(D),fun(C,set(D)),C2))))),bNF_Wellorder_ordLeq(product_prod(B,D),product_prod(C,D))) ) ).

% card_of_Times_mono1
tff(fact_4329_card__of__Times__mono2,axiom,
    ! [C: $tType,B: $tType,D: $tType,A3: set(B),B2: set(C),C2: set(D)] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(C,B2))),bNF_Wellorder_ordLeq(B,C))
     => aa(set(product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C))))),$o,member(product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,B),product_prod(D,B))),fun(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C))))),product_Pair(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),bNF_Ca6860139660246222851ard_of(product_prod(D,B),product_Sigma(D,B,C2,aTP_Lamp_age(set(B),fun(D,set(B)),A3)))),bNF_Ca6860139660246222851ard_of(product_prod(D,C),product_Sigma(D,C,C2,aTP_Lamp_agf(set(C),fun(D,set(C)),B2))))),bNF_Wellorder_ordLeq(product_prod(D,B),product_prod(D,C))) ) ).

% card_of_Times_mono2
tff(fact_4330_card__of__Sigma__ordLeq__infinite,axiom,
    ! [B: $tType,D: $tType,C: $tType,B2: set(B),I: set(C),A3: fun(C,set(D))] :
      ( ~ aa(set(B),$o,finite_finite2(B),B2)
     => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,I)),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_Wellorder_ordLeq(C,B))
       => ( ! [X: C] :
              ( aa(set(C),$o,member(C,X),I)
             => aa(set(product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),A3,X))),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_Wellorder_ordLeq(D,B)) )
         => aa(set(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,D),product_Sigma(C,D,I,A3))),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_Wellorder_ordLeq(product_prod(C,D),B)) ) ) ) ).

% card_of_Sigma_ordLeq_infinite
tff(fact_4331_card__of__Times__infinite,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => ( ( B2 != bot_bot(set(C)) )
       => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordLeq(C,B))
         => ( aa(set(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordIso(product_prod(B,C),B))
            & aa(set(product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,B2,aTP_Lamp_bv(set(B),fun(C,set(B)),A3)))),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordIso(product_prod(C,B),B)) ) ) ) ) ).

% card_of_Times_infinite
tff(fact_4332_card__of__Times__infinite__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => ( ( B2 != bot_bot(set(C)) )
       => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordLeq(C,B))
         => aa(set(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)))),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordIso(product_prod(B,C),B)) ) ) ) ).

% card_of_Times_infinite_simps(1)
tff(fact_4333_card__of__Times__infinite__simps_I2_J,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => ( ( B2 != bot_bot(set(C)) )
       => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordLeq(C,B))
         => aa(set(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C))))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))))),bNF_Wellorder_ordIso(B,product_prod(B,C))) ) ) ) ).

% card_of_Times_infinite_simps(2)
tff(fact_4334_card__of__Times__infinite__simps_I3_J,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => ( ( B2 != bot_bot(set(C)) )
       => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordLeq(C,B))
         => aa(set(product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,B2,aTP_Lamp_bv(set(B),fun(C,set(B)),A3)))),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordIso(product_prod(C,B),B)) ) ) ) ).

% card_of_Times_infinite_simps(3)
tff(fact_4335_card__of__Times__infinite__simps_I4_J,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => ( ( B2 != bot_bot(set(C)) )
       => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordLeq(C,B))
         => aa(set(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B))))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,B2,aTP_Lamp_bv(set(B),fun(C,set(B)),A3))))),bNF_Wellorder_ordIso(B,product_prod(C,B))) ) ) ) ).

% card_of_Times_infinite_simps(4)
tff(fact_4336_card__of__Func__Times,axiom,
    ! [D: $tType,C: $tType,B: $tType,A3: set(B),B2: set(C),C2: set(D)] : aa(set(product_prod(set(product_prod(fun(product_prod(B,C),D),fun(product_prod(B,C),D))),set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D)))))),$o,member(product_prod(set(product_prod(fun(product_prod(B,C),D),fun(product_prod(B,C),D))),set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D))))),aa(set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D)))),product_prod(set(product_prod(fun(product_prod(B,C),D),fun(product_prod(B,C),D))),set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D))))),aa(set(product_prod(fun(product_prod(B,C),D),fun(product_prod(B,C),D))),fun(set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D)))),product_prod(set(product_prod(fun(product_prod(B,C),D),fun(product_prod(B,C),D))),set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D)))))),product_Pair(set(product_prod(fun(product_prod(B,C),D),fun(product_prod(B,C),D))),set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D))))),bNF_Ca6860139660246222851ard_of(fun(product_prod(B,C),D),bNF_Wellorder_Func(product_prod(B,C),D,product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)),C2))),bNF_Ca6860139660246222851ard_of(fun(B,fun(C,D)),bNF_Wellorder_Func(B,fun(C,D),A3,bNF_Wellorder_Func(C,D,B2,C2))))),bNF_Wellorder_ordIso(fun(product_prod(B,C),D),fun(B,fun(C,D)))) ).

% card_of_Func_Times
tff(fact_4337_card__of__empty,axiom,
    ! [C: $tType,B: $tType,A3: set(C)] : aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B)))),bNF_Ca6860139660246222851ard_of(C,A3))),bNF_Wellorder_ordLeq(B,C)) ).

% card_of_empty
tff(fact_4338_card__of__empty3,axiom,
    ! [C: $tType,B: $tType,A3: set(B)] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(C,bot_bot(set(C))))),bNF_Wellorder_ordLeq(B,C))
     => ( A3 = bot_bot(set(B)) ) ) ).

% card_of_empty3
tff(fact_4339_card__of__empty__ordIso,axiom,
    ! [C: $tType,B: $tType] : aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B)))),bNF_Ca6860139660246222851ard_of(C,bot_bot(set(C))))),bNF_Wellorder_ordIso(B,C)) ).

% card_of_empty_ordIso
tff(fact_4340_card__of__empty2,axiom,
    ! [C: $tType,B: $tType,A3: set(B)] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(C,bot_bot(set(C))))),bNF_Wellorder_ordIso(B,C))
     => ( A3 = bot_bot(set(B)) ) ) ).

% card_of_empty2
tff(fact_4341_card__of__ordLeq2,axiom,
    ! [C: $tType,B: $tType,A3: set(B),B2: set(C)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( ? [G2: fun(C,B)] : ( aa(set(C),set(B),image2(C,B,G2),B2) = A3 )
      <=> aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(C,B2))),bNF_Wellorder_ordLeq(B,C)) ) ) ).

% card_of_ordLeq2
tff(fact_4342_card__of__singl__ordLeq,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B3: C] :
      ( ( A3 != bot_bot(set(B)) )
     => aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,aa(set(C),set(C),insert(C,B3),bot_bot(set(C))))),bNF_Ca6860139660246222851ard_of(B,A3))),bNF_Wellorder_ordLeq(C,B)) ) ).

% card_of_singl_ordLeq
tff(fact_4343_card__of__ordLess2,axiom,
    ! [B: $tType,C: $tType,B2: set(B),A3: set(C)] :
      ( ( B2 != bot_bot(set(B)) )
     => ( ~ ? [F8: fun(C,B)] : ( aa(set(C),set(B),image2(C,B,F8),A3) = B2 )
      <=> aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,A3)),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_We4044943003108391690rdLess(C,B)) ) ) ).

% card_of_ordLess2
tff(fact_4344_card__of__Func__UNIV,axiom,
    ! [C: $tType,B: $tType,B2: set(C)] : aa(set(product_prod(set(product_prod(fun(B,C),fun(B,C))),set(product_prod(fun(B,C),fun(B,C))))),$o,member(product_prod(set(product_prod(fun(B,C),fun(B,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(B,C),fun(B,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(B,C),fun(B,C))),fun(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(B,C),fun(B,C))),set(product_prod(fun(B,C),fun(B,C))))),product_Pair(set(product_prod(fun(B,C),fun(B,C))),set(product_prod(fun(B,C),fun(B,C)))),bNF_Ca6860139660246222851ard_of(fun(B,C),bNF_Wellorder_Func(B,C,top_top(set(B)),B2))),bNF_Ca6860139660246222851ard_of(fun(B,C),aa(fun(fun(B,C),$o),set(fun(B,C)),collect(fun(B,C)),aTP_Lamp_agg(set(C),fun(fun(B,C),$o),B2))))),bNF_Wellorder_ordIso(fun(B,C),fun(B,C))) ).

% card_of_Func_UNIV
tff(fact_4345_ordLeq__Times__mono1,axiom,
    ! [C: $tType,D: $tType,B: $tType,R2: set(product_prod(B,B)),R4: set(product_prod(C,C)),C2: set(D)] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R2),R4)),bNF_Wellorder_ordLeq(B,C))
     => aa(set(product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D))))),$o,member(product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),fun(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D))))),product_Pair(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),bNF_Ca6860139660246222851ard_of(product_prod(B,D),product_Sigma(B,D,field2(B,R2),aTP_Lamp_ly(set(D),fun(B,set(D)),C2)))),bNF_Ca6860139660246222851ard_of(product_prod(C,D),product_Sigma(C,D,field2(C,R4),aTP_Lamp_eq(set(D),fun(C,set(D)),C2))))),bNF_Wellorder_ordLeq(product_prod(B,D),product_prod(C,D))) ) ).

% ordLeq_Times_mono1
tff(fact_4346_ordLeq__Times__mono2,axiom,
    ! [C: $tType,B: $tType,D: $tType,R2: set(product_prod(B,B)),R4: set(product_prod(C,C)),A3: set(D)] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R2),R4)),bNF_Wellorder_ordLeq(B,C))
     => aa(set(product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C))))),$o,member(product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,B),product_prod(D,B))),fun(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C))))),product_Pair(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),bNF_Ca6860139660246222851ard_of(product_prod(D,B),product_Sigma(D,B,A3,aTP_Lamp_agh(set(product_prod(B,B)),fun(D,set(B)),R2)))),bNF_Ca6860139660246222851ard_of(product_prod(D,C),product_Sigma(D,C,A3,aTP_Lamp_agi(set(product_prod(C,C)),fun(D,set(C)),R4))))),bNF_Wellorder_ordLeq(product_prod(D,B),product_prod(D,C))) ) ).

% ordLeq_Times_mono2
tff(fact_4347_Chains__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( chains(B,R2) = aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_agj(set(product_prod(B,B)),fun(set(B),$o),R2)) ) ).

% Chains_def
tff(fact_4348_Chains__inits__DiffI,axiom,
    ! [B: $tType,R: set(set(product_prod(B,B))),S2: set(product_prod(B,B))] :
      ( aa(set(set(set(product_prod(B,B)))),$o,member(set(set(product_prod(B,B))),R),chains(set(product_prod(B,B)),init_seg_of(B)))
     => aa(set(set(set(product_prod(B,B)))),$o,member(set(set(product_prod(B,B))),aa(fun(set(product_prod(B,B)),$o),set(set(product_prod(B,B))),collect(set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),aTP_Lamp_agk(set(set(product_prod(B,B))),fun(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o)),R),S2))),chains(set(product_prod(B,B)),init_seg_of(B))) ) ).

% Chains_inits_DiffI
tff(fact_4349_card__of__UNION__ordLeq__infinite,axiom,
    ! [C: $tType,B: $tType,D: $tType,B2: set(B),I: set(C),A3: fun(C,set(D))] :
      ( ~ aa(set(B),$o,finite_finite2(B),B2)
     => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,I)),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_Wellorder_ordLeq(C,B))
       => ( ! [X: C] :
              ( aa(set(C),$o,member(C,X),I)
             => aa(set(product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),A3,X))),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_Wellorder_ordLeq(D,B)) )
         => aa(set(product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A3),I)))),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_Wellorder_ordLeq(D,B)) ) ) ) ).

% card_of_UNION_ordLeq_infinite
tff(fact_4350_Card__order__iff__Restr__underS,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( order_well_order_on(B,field2(B,R2),R2)
     => ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
      <=> ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),field2(B,R2))
           => aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),product_Sigma(B,B,order_underS(B,R2,X3),aa(B,fun(B,set(B)),aTP_Lamp_afy(set(product_prod(B,B)),fun(B,fun(B,set(B))),R2),X3)))),bNF_Ca6860139660246222851ard_of(B,field2(B,R2)))),bNF_We4044943003108391690rdLess(B,B)) ) ) ) ).

% Card_order_iff_Restr_underS
tff(fact_4351_card__of__Plus__Times__aux,axiom,
    ! [C: $tType,B: $tType,A13: B,A23: B,A3: set(B),B2: set(C)] :
      ( ( ( A13 != A23 )
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,A13),aa(set(B),set(B),insert(B,A23),bot_bot(set(B))))),A3) )
     => ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(C,B2))),bNF_Wellorder_ordLeq(B,C))
       => aa(set(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),$o,member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A3,B2))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))))),bNF_Wellorder_ordLeq(sum_sum(B,C),product_prod(B,C))) ) ) ).

% card_of_Plus_Times_aux
tff(fact_4352_card__of__UNION__ordLeq__infinite__Field,axiom,
    ! [C: $tType,B: $tType,D: $tType,R2: set(product_prod(B,B)),I: set(C),A3: fun(C,set(D))] :
      ( ~ aa(set(B),$o,finite_finite2(B),field2(B,R2))
     => ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
       => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,I)),R2)),bNF_Wellorder_ordLeq(C,B))
         => ( ! [X: C] :
                ( aa(set(C),$o,member(C,X),I)
               => aa(set(product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),A3,X))),R2)),bNF_Wellorder_ordLeq(D,B)) )
           => aa(set(product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A3),I)))),R2)),bNF_Wellorder_ordLeq(D,B)) ) ) ) ) ).

% card_of_UNION_ordLeq_infinite_Field
tff(fact_4353_card__of__Times__ordLeq__infinite__Field,axiom,
    ! [B: $tType,D: $tType,C: $tType,R2: set(product_prod(B,B)),A3: set(C),B2: set(D)] :
      ( ~ aa(set(B),$o,finite_finite2(B),field2(B,R2))
     => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,A3)),R2)),bNF_Wellorder_ordLeq(C,B))
       => ( aa(set(product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,B2)),R2)),bNF_Wellorder_ordLeq(D,B))
         => ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
           => aa(set(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,D),product_Sigma(C,D,A3,aTP_Lamp_eq(set(D),fun(C,set(D)),B2)))),R2)),bNF_Wellorder_ordLeq(product_prod(C,D),B)) ) ) ) ) ).

% card_of_Times_ordLeq_infinite_Field
tff(fact_4354_card__of__def,axiom,
    ! [B: $tType,A3: set(B)] : ( bNF_Ca6860139660246222851ard_of(B,A3) = fChoice(set(product_prod(B,B)),bNF_Ca8970107618336181345der_on(B,A3)) ) ).

% card_of_def
tff(fact_4355_card__of__Times__Plus__distrib,axiom,
    ! [D: $tType,C: $tType,B: $tType,A3: set(B),B2: set(C),C2: set(D)] : aa(set(product_prod(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))))),$o,member(product_prod(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D))))),aa(set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))),product_prod(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D))))),aa(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),fun(set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))),product_prod(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))))),product_Pair(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D))))),bNF_Ca6860139660246222851ard_of(product_prod(B,sum_sum(C,D)),product_Sigma(B,sum_sum(C,D),A3,aa(set(D),fun(B,set(sum_sum(C,D))),aTP_Lamp_agl(set(C),fun(set(D),fun(B,set(sum_sum(C,D)))),B2),C2)))),bNF_Ca6860139660246222851ard_of(sum_sum(product_prod(B,C),product_prod(B,D)),sum_Plus(product_prod(B,C),product_prod(B,D),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)),product_Sigma(B,D,A3,aTP_Lamp_ly(set(D),fun(B,set(D)),C2)))))),bNF_Wellorder_ordIso(product_prod(B,sum_sum(C,D)),sum_sum(product_prod(B,C),product_prod(B,D)))) ).

% card_of_Times_Plus_distrib
tff(fact_4356_card__of__Plus__Times__bool,axiom,
    ! [B: $tType,A3: set(B)] : aa(set(product_prod(set(product_prod(sum_sum(B,B),sum_sum(B,B))),set(product_prod(product_prod(B,$o),product_prod(B,$o))))),$o,member(product_prod(set(product_prod(sum_sum(B,B),sum_sum(B,B))),set(product_prod(product_prod(B,$o),product_prod(B,$o)))),aa(set(product_prod(product_prod(B,$o),product_prod(B,$o))),product_prod(set(product_prod(sum_sum(B,B),sum_sum(B,B))),set(product_prod(product_prod(B,$o),product_prod(B,$o)))),aa(set(product_prod(sum_sum(B,B),sum_sum(B,B))),fun(set(product_prod(product_prod(B,$o),product_prod(B,$o))),product_prod(set(product_prod(sum_sum(B,B),sum_sum(B,B))),set(product_prod(product_prod(B,$o),product_prod(B,$o))))),product_Pair(set(product_prod(sum_sum(B,B),sum_sum(B,B))),set(product_prod(product_prod(B,$o),product_prod(B,$o)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,B),sum_Plus(B,B,A3,A3))),bNF_Ca6860139660246222851ard_of(product_prod(B,$o),product_Sigma(B,$o,A3,aTP_Lamp_agm(B,set($o)))))),bNF_Wellorder_ordIso(sum_sum(B,B),product_prod(B,$o))) ).

% card_of_Plus_Times_bool
tff(fact_4357_card__of__Plus__empty2,axiom,
    ! [C: $tType,B: $tType,A3: set(B)] : aa(set(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,bot_bot(set(C)),A3)))),bNF_Wellorder_ordIso(B,sum_sum(C,B))) ).

% card_of_Plus_empty2
tff(fact_4358_card__of__Plus__empty1,axiom,
    ! [C: $tType,B: $tType,A3: set(B)] : aa(set(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A3,bot_bot(set(C)))))),bNF_Wellorder_ordIso(B,sum_sum(B,C))) ).

% card_of_Plus_empty1
tff(fact_4359_Card__order__Times2,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,B)),A3: set(C)] :
      ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
     => ( ( A3 != bot_bot(set(C)) )
       => aa(set(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B))))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),R2),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,A3,aTP_Lamp_agn(set(product_prod(B,B)),fun(C,set(B)),R2))))),bNF_Wellorder_ordLeq(B,product_prod(C,B))) ) ) ).

% Card_order_Times2
tff(fact_4360_Card__order__Times1,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,B)),B2: set(C)] :
      ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
     => ( ( B2 != bot_bot(set(C)) )
       => aa(set(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C))))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),R2),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,field2(B,R2),aTP_Lamp_bq(set(C),fun(B,set(C)),B2))))),bNF_Wellorder_ordLeq(B,product_prod(B,C))) ) ) ).

% Card_order_Times1
tff(fact_4361_Card__order__Times__same__infinite,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
     => ( ~ aa(set(B),$o,finite_finite2(B),field2(B,R2))
       => aa(set(product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,B),product_prod(B,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(B,B),product_Sigma(B,B,field2(B,R2),aTP_Lamp_ey(set(product_prod(B,B)),fun(B,set(B)),R2)))),R2)),bNF_Wellorder_ordLeq(product_prod(B,B),B)) ) ) ).

% Card_order_Times_same_infinite
tff(fact_4362_card__of__Plus__Times,axiom,
    ! [C: $tType,B: $tType,A13: B,A23: B,A3: set(B),B12: C,B23: C,B2: set(C)] :
      ( ( ( A13 != A23 )
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,A13),aa(set(B),set(B),insert(B,A23),bot_bot(set(B))))),A3) )
     => ( ( ( B12 != B23 )
          & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(C),set(C),insert(C,B12),aa(set(C),set(C),insert(C,B23),bot_bot(set(C))))),B2) )
       => aa(set(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),$o,member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A3,B2))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))))),bNF_Wellorder_ordLeq(sum_sum(B,C),product_prod(B,C))) ) ) ).

% card_of_Plus_Times
tff(fact_4363_exists__minim__Card__order,axiom,
    ! [B: $tType,R: set(set(product_prod(B,B)))] :
      ( ( R != bot_bot(set(set(product_prod(B,B)))) )
     => ( ! [X: set(product_prod(B,B))] :
            ( aa(set(set(product_prod(B,B))),$o,member(set(product_prod(B,B)),X),R)
           => aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,X)),X) )
       => ? [X: set(product_prod(B,B))] :
            ( aa(set(set(product_prod(B,B))),$o,member(set(product_prod(B,B)),X),R)
            & ! [Xa3: set(product_prod(B,B))] :
                ( aa(set(set(product_prod(B,B))),$o,member(set(product_prod(B,B)),Xa3),R)
               => aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),X),Xa3)),bNF_Wellorder_ordLeq(B,B)) ) ) ) ) ).

% exists_minim_Card_order
tff(fact_4364_Card__order__empty,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
     => aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,bot_bot(set(C)))),R2)),bNF_Wellorder_ordLeq(C,B)) ) ).

% Card_order_empty
tff(fact_4365_Card__order__singl__ordLeq,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(B,B)),B3: C] :
      ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
     => ( ( field2(B,R2) != bot_bot(set(B)) )
       => aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,aa(set(C),set(C),insert(C,B3),bot_bot(set(C))))),R2)),bNF_Wellorder_ordLeq(C,B)) ) ) ).

% Card_order_singl_ordLeq
tff(fact_4366_card__of__empty1,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(B,B))] :
      ( ( order_well_order_on(B,field2(B,R2),R2)
        | aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2) )
     => aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,bot_bot(set(C)))),R2)),bNF_Wellorder_ordLeq(C,B)) ) ).

% card_of_empty1
tff(fact_4367_Card__order__Times__infinite,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(B,B)),P3: set(product_prod(C,C))] :
      ( ~ aa(set(B),$o,finite_finite2(B),field2(B,R2))
     => ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
       => ( ( field2(C,P3) != bot_bot(set(C)) )
         => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),P3),R2)),bNF_Wellorder_ordLeq(C,B))
           => ( aa(set(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,field2(B,R2),aTP_Lamp_ago(set(product_prod(C,C)),fun(B,set(C)),P3)))),R2)),bNF_Wellorder_ordIso(product_prod(B,C),B))
              & aa(set(product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,field2(C,P3),aTP_Lamp_agn(set(product_prod(B,B)),fun(C,set(B)),R2)))),R2)),bNF_Wellorder_ordIso(product_prod(C,B),B)) ) ) ) ) ) ).

% Card_order_Times_infinite
tff(fact_4368_card__of__Sigma__ordLeq__infinite__Field,axiom,
    ! [B: $tType,D: $tType,C: $tType,R2: set(product_prod(B,B)),I: set(C),A3: fun(C,set(D))] :
      ( ~ aa(set(B),$o,finite_finite2(B),field2(B,R2))
     => ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
       => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,I)),R2)),bNF_Wellorder_ordLeq(C,B))
         => ( ! [X: C] :
                ( aa(set(C),$o,member(C,X),I)
               => aa(set(product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),A3,X))),R2)),bNF_Wellorder_ordLeq(D,B)) )
           => aa(set(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,D),product_Sigma(C,D,I,A3))),R2)),bNF_Wellorder_ordLeq(product_prod(C,D),B)) ) ) ) ) ).

% card_of_Sigma_ordLeq_infinite_Field
tff(fact_4369_Plus__eq__empty__conv,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( ( sum_Plus(B,C,A3,B2) = bot_bot(set(sum_sum(B,C))) )
    <=> ( ( A3 = bot_bot(set(B)) )
        & ( B2 = bot_bot(set(C)) ) ) ) ).

% Plus_eq_empty_conv
tff(fact_4370_regularCard__UNION,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,B)),As8: fun(B,set(C)),B2: set(C)] :
      ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
     => ( bNF_Ca7133664381575040944arCard(B,R2)
       => ( bNF_Ca3754400796208372196lChain(B,set(C),R2,As8)
         => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),As8),field2(B,R2))))
           => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),R2)),bNF_We4044943003108391690rdLess(C,B))
             => ? [X: B] :
                  ( aa(set(B),$o,member(B,X),field2(B,R2))
                  & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(B,set(C),As8,X)) ) ) ) ) ) ) ).

% regularCard_UNION
tff(fact_4371_cardSuc__UNION,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,B)),As8: fun(set(B),set(C)),B2: set(C)] :
      ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
     => ( ~ aa(set(B),$o,finite_finite2(B),field2(B,R2))
       => ( bNF_Ca3754400796208372196lChain(set(B),set(C),bNF_Ca8387033319878233205ardSuc(B,R2),As8)
         => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(set(B)),set(set(C)),image2(set(B),set(C),As8),field2(set(B),bNF_Ca8387033319878233205ardSuc(B,R2)))))
           => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),R2)),bNF_Wellorder_ordLeq(C,B))
             => ? [X: set(B)] :
                  ( aa(set(set(B)),$o,member(set(B),X),field2(set(B),bNF_Ca8387033319878233205ardSuc(B,R2)))
                  & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(set(B),set(C),As8,X)) ) ) ) ) ) ) ).

% cardSuc_UNION
tff(fact_4372_UNION__Cinfinite__bound,axiom,
    ! [B: $tType,C: $tType,D: $tType,I: set(B),R2: set(product_prod(C,C)),A3: fun(B,set(D))] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,I)),R2)),bNF_Wellorder_ordLeq(B,C))
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),I)
           => aa(set(product_prod(set(product_prod(D,D)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(D,D)),fun(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C)))),product_Pair(set(product_prod(D,D)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(D,aa(B,set(D),A3,X))),R2)),bNF_Wellorder_ordLeq(D,C)) )
       => ( ( bNF_Ca4139267488887388095finite(C,R2)
            & aa(set(product_prod(C,C)),$o,bNF_Ca8970107618336181345der_on(C,field2(C,R2)),R2) )
         => aa(set(product_prod(set(product_prod(D,D)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(D,D)),fun(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C)))),product_Pair(set(product_prod(D,D)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(D,aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),A3),I)))),R2)),bNF_Wellorder_ordLeq(D,C)) ) ) ) ).

% UNION_Cinfinite_bound
tff(fact_4373_cardSuc__UNION__Cinfinite,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,B)),As8: fun(set(B),set(C)),B2: set(C)] :
      ( ( bNF_Ca4139267488887388095finite(B,R2)
        & aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2) )
     => ( bNF_Ca3754400796208372196lChain(set(B),set(C),bNF_Ca8387033319878233205ardSuc(B,R2),As8)
       => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(set(B)),set(set(C)),image2(set(B),set(C),As8),field2(set(B),bNF_Ca8387033319878233205ardSuc(B,R2)))))
         => ( aa(set(product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),R2)),bNF_Wellorder_ordLeq(C,B))
           => ? [X: set(B)] :
                ( aa(set(set(B)),$o,member(set(B),X),field2(set(B),bNF_Ca8387033319878233205ardSuc(B,R2)))
                & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(set(B),set(C),As8,X)) ) ) ) ) ) ).

% cardSuc_UNION_Cinfinite
tff(fact_4374_SIGMA__CSUM,axiom,
    ! [C: $tType,B: $tType,I: set(B),As8: fun(B,set(C))] : ( bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,I,As8)) = bNF_Cardinal_Csum(B,C,bNF_Ca6860139660246222851ard_of(B,I),aTP_Lamp_agp(fun(B,set(C)),fun(B,set(product_prod(C,C))),As8)) ) ).

% SIGMA_CSUM
tff(fact_4375_Csum__def,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,B)),Rs: fun(B,set(product_prod(C,C)))] : ( bNF_Cardinal_Csum(B,C,R2,Rs) = bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,field2(B,R2),aTP_Lamp_agq(fun(B,set(product_prod(C,C))),fun(B,set(C)),Rs))) ) ).

% Csum_def
tff(fact_4376_cexp__mono2_H,axiom,
    ! [C: $tType,D: $tType,B: $tType,P22: set(product_prod(B,B)),R23: set(product_prod(C,C)),Q: set(product_prod(D,D))] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P22),R23)),bNF_Wellorder_ordLeq(B,C))
     => ( aa(set(product_prod(D,D)),$o,bNF_Ca8970107618336181345der_on(D,field2(D,Q)),Q)
       => ( ( ( field2(B,P22) = bot_bot(set(B)) )
           => ( field2(C,R23) = bot_bot(set(C)) ) )
         => aa(set(product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D))))),$o,member(product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),aa(set(product_prod(fun(C,D),fun(C,D))),product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),aa(set(product_prod(fun(B,D),fun(B,D))),fun(set(product_prod(fun(C,D),fun(C,D))),product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D))))),product_Pair(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),bNF_Cardinal_cexp(D,B,Q,P22)),bNF_Cardinal_cexp(D,C,Q,R23))),bNF_Wellorder_ordLeq(fun(B,D),fun(C,D))) ) ) ) ).

% cexp_mono2'
tff(fact_4377_pred__on_Onot__maxchain__Some,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,fun(B,$o)),C2: set(B)] :
      ( aa(set(B),$o,pred_chain(B,A3,Pa),C2)
     => ( ~ pred_maxchain(B,A3,Pa,C2)
       => ( aa(set(B),$o,pred_chain(B,A3,Pa),fChoice(set(B),aa(set(B),fun(set(B),$o),aa(fun(B,fun(B,$o)),fun(set(B),fun(set(B),$o)),aTP_Lamp_agr(set(B),fun(fun(B,fun(B,$o)),fun(set(B),fun(set(B),$o))),A3),Pa),C2)))
          & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),C2),fChoice(set(B),aa(set(B),fun(set(B),$o),aa(fun(B,fun(B,$o)),fun(set(B),fun(set(B),$o)),aTP_Lamp_agr(set(B),fun(fun(B,fun(B,$o)),fun(set(B),fun(set(B),$o))),A3),Pa),C2))) ) ) ) ).

% pred_on.not_maxchain_Some
tff(fact_4378_subset_Onot__maxchain__Some,axiom,
    ! [B: $tType,A3: set(set(B)),C2: set(set(B))] :
      ( aa(set(set(B)),$o,pred_chain(set(B),A3,ord_less(set(B))),C2)
     => ( ~ pred_maxchain(set(B),A3,ord_less(set(B)),C2)
       => ( aa(set(set(B)),$o,pred_chain(set(B),A3,ord_less(set(B))),fChoice(set(set(B)),aa(set(set(B)),fun(set(set(B)),$o),aTP_Lamp_ags(set(set(B)),fun(set(set(B)),fun(set(set(B)),$o)),A3),C2)))
          & aa(set(set(B)),$o,aa(set(set(B)),fun(set(set(B)),$o),ord_less(set(set(B))),C2),fChoice(set(set(B)),aa(set(set(B)),fun(set(set(B)),$o),aTP_Lamp_ags(set(set(B)),fun(set(set(B)),fun(set(set(B)),$o)),A3),C2))) ) ) ) ).

% subset.not_maxchain_Some
tff(fact_4379_cexp__mono_H,axiom,
    ! [C: $tType,E: $tType,B: $tType,D: $tType,P1: set(product_prod(B,B)),R12: set(product_prod(C,C)),P22: set(product_prod(D,D)),R23: set(product_prod(E,E))] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R12)),bNF_Wellorder_ordLeq(B,C))
     => ( aa(set(product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),$o,member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),P22),R23)),bNF_Wellorder_ordLeq(D,E))
       => ( ( ( field2(D,P22) = bot_bot(set(D)) )
           => ( field2(E,R23) = bot_bot(set(E)) ) )
         => aa(set(product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C))))),$o,member(product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),aa(set(product_prod(fun(E,C),fun(E,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),aa(set(product_prod(fun(D,B),fun(D,B))),fun(set(product_prod(fun(E,C),fun(E,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C))))),product_Pair(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),bNF_Cardinal_cexp(B,D,P1,P22)),bNF_Cardinal_cexp(C,E,R12,R23))),bNF_Wellorder_ordLeq(fun(D,B),fun(E,C))) ) ) ) ).

% cexp_mono'
tff(fact_4380_card__of__Csum__Times_H,axiom,
    ! [B: $tType,D: $tType,C: $tType,R2: set(product_prod(B,B)),I: set(C),A3: fun(C,set(D))] :
      ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
     => ( ! [X: C] :
            ( aa(set(C),$o,member(C,X),I)
           => aa(set(product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),A3,X))),R2)),bNF_Wellorder_ordLeq(D,B)) )
       => aa(set(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(C,B),product_prod(C,B))))),$o,member(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Cardinal_Csum(C,D,bNF_Ca6860139660246222851ard_of(C,I),aTP_Lamp_agt(fun(C,set(D)),fun(C,set(product_prod(D,D))),A3))),bNF_Cardinal_cprod(C,B,bNF_Ca6860139660246222851ard_of(C,I),R2))),bNF_Wellorder_ordLeq(product_prod(C,D),product_prod(C,B))) ) ) ).

% card_of_Csum_Times'
tff(fact_4381_card__of__Csum__Times,axiom,
    ! [D: $tType,C: $tType,B: $tType,I: set(B),A3: fun(B,set(C)),B2: set(D)] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),I)
         => aa(set(product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),$o,member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A3,X))),bNF_Ca6860139660246222851ard_of(D,B2))),bNF_Wellorder_ordLeq(C,D)) )
     => aa(set(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D))))),$o,member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D))))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),bNF_Cardinal_Csum(B,C,bNF_Ca6860139660246222851ard_of(B,I),aTP_Lamp_agp(fun(B,set(C)),fun(B,set(product_prod(C,C))),A3))),bNF_Cardinal_cprod(B,D,bNF_Ca6860139660246222851ard_of(B,I),bNF_Ca6860139660246222851ard_of(D,B2)))),bNF_Wellorder_ordLeq(product_prod(B,C),product_prod(B,D))) ) ).

% card_of_Csum_Times
tff(fact_4382_czeroI,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2)
     => ( ( field2(B,R2) = bot_bot(set(B)) )
       => aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R2),bNF_Cardinal_czero(C))),bNF_Wellorder_ordIso(B,C)) ) ) ).

% czeroI
tff(fact_4383_Cnotzero__imp__not__empty,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( ( ~ aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R2),bNF_Cardinal_czero(B))),bNF_Wellorder_ordIso(B,B))
        & aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,field2(B,R2)),R2) )
     => ( field2(B,R2) != bot_bot(set(B)) ) ) ).

% Cnotzero_imp_not_empty
tff(fact_4384_czero__def,axiom,
    ! [B: $tType] : ( bNF_Cardinal_czero(B) = bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B))) ) ).

% czero_def
tff(fact_4385_cprod__def,axiom,
    ! [B: $tType,C: $tType,R12: set(product_prod(B,B)),R23: set(product_prod(C,C))] : ( bNF_Cardinal_cprod(B,C,R12,R23) = bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,field2(B,R12),aTP_Lamp_ago(set(product_prod(C,C)),fun(B,set(C)),R23))) ) ).

% cprod_def
tff(fact_4386_czeroE,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,B))] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R2),bNF_Cardinal_czero(C))),bNF_Wellorder_ordIso(B,C))
     => ( field2(B,R2) = bot_bot(set(B)) ) ) ).

% czeroE
tff(fact_4387_card__of__ordIso__czero__iff__empty,axiom,
    ! [C: $tType,B: $tType,A3: set(B)] :
      ( aa(set(product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),$o,member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A3)),bNF_Cardinal_czero(C))),bNF_Wellorder_ordIso(B,C))
    <=> ( A3 = bot_bot(set(B)) ) ) ).

% card_of_ordIso_czero_iff_empty
tff(fact_4388_subset_Osuc__def,axiom,
    ! [B: $tType,A3: set(set(B)),C2: set(set(B))] :
      ( pred_suc(set(B),A3,ord_less(set(B)),C2)
      = $ite(
          ( ~ aa(set(set(B)),$o,pred_chain(set(B),A3,ord_less(set(B))),C2)
          | pred_maxchain(set(B),A3,ord_less(set(B)),C2) ),
          C2,
          fChoice(set(set(B)),aa(set(set(B)),fun(set(set(B)),$o),aTP_Lamp_ags(set(set(B)),fun(set(set(B)),fun(set(set(B)),$o)),A3),C2)) ) ) ).

% subset.suc_def
tff(fact_4389_pred__on_Osuc__def,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,fun(B,$o)),C2: set(B)] :
      ( pred_suc(B,A3,Pa,C2)
      = $ite(
          ( ~ aa(set(B),$o,pred_chain(B,A3,Pa),C2)
          | pred_maxchain(B,A3,Pa,C2) ),
          C2,
          fChoice(set(B),aa(set(B),fun(set(B),$o),aa(fun(B,fun(B,$o)),fun(set(B),fun(set(B),$o)),aTP_Lamp_agr(set(B),fun(fun(B,fun(B,$o)),fun(set(B),fun(set(B),$o))),A3),Pa),C2)) ) ) ).

% pred_on.suc_def
tff(fact_4390_prod__set__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,X2: B,Y: C] : ( aa(product_prod(B,C),set(B),basic_fsts(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y)) = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) ).

% prod_set_simps(1)
tff(fact_4391_prod__set__simps_I2_J,axiom,
    ! [C: $tType,B: $tType,X2: C,Y: B] : ( basic_snds(C,B,aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X2),Y)) = aa(set(B),set(B),insert(B,Y),bot_bot(set(B))) ) ).

% prod_set_simps(2)
tff(fact_4392_prod__set__defs_I1_J,axiom,
    ! [C: $tType,B: $tType,X4: product_prod(B,C)] : ( aa(product_prod(B,C),set(B),basic_fsts(B,C),X4) = aa(set(B),set(B),insert(B,aa(product_prod(B,C),B,product_fst(B,C),X4)),bot_bot(set(B))) ) ).

% prod_set_defs(1)
tff(fact_4393_prod__set__defs_I2_J,axiom,
    ! [B: $tType,C: $tType,X4: product_prod(B,C)] : ( basic_snds(B,C,X4) = aa(set(C),set(C),insert(C,aa(product_prod(B,C),C,product_snd(B,C),X4)),bot_bot(set(C))) ) ).

% prod_set_defs(2)
tff(fact_4394_funpow__inj__finite,axiom,
    ! [B: $tType,P3: fun(B,B),X2: B] :
      ( inj_on(B,B,P3,top_top(set(B)))
     => ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_agu(fun(B,B),fun(B,fun(B,$o)),P3),X2)))
       => ~ ! [N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2)
             => ( aa(B,B,compow(fun(B,B),N2,P3),X2) != X2 ) ) ) ) ).

% funpow_inj_finite
tff(fact_4395_single__valuedp__single__valued__eq,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,C))] :
      ( single_valuedp(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),R2))
    <=> single_valued(B,C,R2) ) ).

% single_valuedp_single_valued_eq
tff(fact_4396_Code__Numeral_Osub__def,axiom,
    code_sub = aa(fun(num,fun(num,int)),fun(num,fun(num,code_integer)),map_fun(num,num,fun(num,int),fun(num,code_integer),id(num),map_fun(num,num,int,code_integer,id(num),code_integer_of_int)),aTP_Lamp_xx(num,fun(num,int))) ).

% Code_Numeral.sub_def
tff(fact_4397_set__encode__empty,axiom,
    nat_set_encode(bot_bot(set(nat))) = zero_zero(nat) ).

% set_encode_empty
tff(fact_4398_comp__fun__commute_Ocomp__fun__commute__funpow,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(C,C)),G: fun(B,nat)] :
      ( finite6289374366891150609ommute(B,C,F2)
     => finite6289374366891150609ommute(B,C,aa(fun(B,nat),fun(B,fun(C,C)),aTP_Lamp_agv(fun(B,fun(C,C)),fun(fun(B,nat),fun(B,fun(C,C))),F2),G)) ) ).

% comp_fun_commute.comp_fun_commute_funpow
tff(fact_4399_comp__fun__commute__on_Ocomp__fun__commute__on__funpow,axiom,
    ! [C: $tType,B: $tType,S: set(B),F2: fun(B,fun(C,C)),G: fun(B,nat)] :
      ( finite4664212375090638736ute_on(B,C,S,F2)
     => finite4664212375090638736ute_on(B,C,S,aa(fun(B,nat),fun(B,fun(C,C)),aTP_Lamp_agv(fun(B,fun(C,C)),fun(fun(B,nat),fun(B,fun(C,C))),F2),G)) ) ).

% comp_fun_commute_on.comp_fun_commute_on_funpow
tff(fact_4400_funpow__times__power,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [F2: fun(B,nat),X2: B] : ( compow(fun(B,B),aa(B,nat,F2,X2),aa(B,fun(B,B),times_times(B),X2)) = aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X2),aa(B,nat,F2,X2))) ) ) ).

% funpow_times_power
tff(fact_4401_relpowp__relpow__eq,axiom,
    ! [B: $tType,N: nat,R: set(product_prod(B,B)),X4: B,Xa3: B] :
      ( aa(B,$o,aa(B,fun(B,$o),compow(fun(B,fun(B,$o)),N,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R)),X4),Xa3)
    <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa3)),compow(set(product_prod(B,B)),N,R)) ) ).

% relpowp_relpow_eq
tff(fact_4402_Kleene__iter__lpfp,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [F2: fun(B,B),P3: B,K: nat] :
          ( order_mono(B,B,F2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,F2,P3)),P3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,compow(fun(B,B),K,F2),bot_bot(B))),P3) ) ) ) ).

% Kleene_iter_lpfp
tff(fact_4403_Kleene__iter__gpfp,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [F2: fun(B,B),P3: B,K: nat] :
          ( order_mono(B,B,F2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),P3),aa(B,B,F2,P3))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),P3),aa(B,B,compow(fun(B,B),K,F2),top_top(B))) ) ) ) ).

% Kleene_iter_gpfp
tff(fact_4404_single__valuedp__bot,axiom,
    ! [C: $tType,B: $tType] : single_valuedp(B,C,bot_bot(fun(B,fun(C,$o)))) ).

% single_valuedp_bot
tff(fact_4405_relpowp__bot,axiom,
    ! [B: $tType,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( compow(fun(B,fun(B,$o)),N,bot_bot(fun(B,fun(B,$o)))) = bot_bot(fun(B,fun(B,$o))) ) ) ).

% relpowp_bot
tff(fact_4406_single__valuedp__iff__Uniq,axiom,
    ! [C: $tType,B: $tType,R2: fun(B,fun(C,$o))] :
      ( single_valuedp(B,C,R2)
    <=> ! [X3: B] : uniq(C,aa(B,fun(C,$o),R2,X3)) ) ).

% single_valuedp_iff_Uniq
tff(fact_4407_of__nat__def,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat] : ( aa(nat,B,semiring_1_of_nat(B),N) = aa(B,B,compow(fun(B,B),N,aa(B,fun(B,B),plus_plus(B),one_one(B))),zero_zero(B)) ) ) ).

% of_nat_def
tff(fact_4408_numeral__add__unfold__funpow,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [K: num,A4: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),K)),A4) = aa(B,B,compow(fun(B,B),aa(num,nat,numeral_numeral(nat),K),aa(B,fun(B,B),plus_plus(B),one_one(B))),A4) ) ) ).

% numeral_add_unfold_funpow
tff(fact_4409_mono__funpow,axiom,
    ! [B: $tType] :
      ( ( lattice(B)
        & order_bot(B) )
     => ! [Qa: fun(B,B)] :
          ( order_mono(B,B,Qa)
         => order_mono(nat,B,aTP_Lamp_agw(fun(B,B),fun(nat,B),Qa)) ) ) ).

% mono_funpow
tff(fact_4410_funpow__decreasing,axiom,
    ! [B: $tType] :
      ( ( lattice(B)
        & order_bot(B) )
     => ! [M2: nat,N: nat,F2: fun(B,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( order_mono(B,B,F2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,compow(fun(B,B),M2,F2),bot_bot(B))),aa(B,B,compow(fun(B,B),N,F2),bot_bot(B))) ) ) ) ).

% funpow_decreasing
tff(fact_4411_funpow__increasing,axiom,
    ! [B: $tType] :
      ( ( lattice(B)
        & order_top(B) )
     => ! [M2: nat,N: nat,F2: fun(B,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
         => ( order_mono(B,B,F2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,compow(fun(B,B),N,F2),top_top(B))),aa(B,B,compow(fun(B,B),M2,F2),top_top(B))) ) ) ) ).

% funpow_increasing
tff(fact_4412_lfp__Kleene__iter,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(B,B),K: nat] :
          ( order_mono(B,B,F2)
         => ( ( aa(B,B,compow(fun(B,B),aa(nat,nat,suc,K),F2),bot_bot(B)) = aa(B,B,compow(fun(B,B),K,F2),bot_bot(B)) )
           => ( complete_lattice_lfp(B,F2) = aa(B,B,compow(fun(B,B),K,F2),bot_bot(B)) ) ) ) ) ).

% lfp_Kleene_iter
tff(fact_4413_gfp__Kleene__iter,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(B,B),K: nat] :
          ( order_mono(B,B,F2)
         => ( ( aa(B,B,compow(fun(B,B),aa(nat,nat,suc,K),F2),top_top(B)) = aa(B,B,compow(fun(B,B),K,F2),top_top(B)) )
           => ( complete_lattice_gfp(B,F2) = aa(B,B,compow(fun(B,B),K,F2),top_top(B)) ) ) ) ) ).

% gfp_Kleene_iter
tff(fact_4414_inj__on__funpow__least,axiom,
    ! [B: $tType,N: nat,F2: fun(B,B),S2: B] :
      ( ( aa(B,B,compow(fun(B,B),N,F2),S2) = S2 )
     => ( ! [M3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M3)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N)
             => ( aa(B,B,compow(fun(B,B),M3,F2),S2) != S2 ) ) )
       => inj_on(nat,B,aa(B,fun(nat,B),aTP_Lamp_agx(fun(B,B),fun(B,fun(nat,B)),F2),S2),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% inj_on_funpow_least
tff(fact_4415_numeral__unfold__funpow,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [K: num] : ( aa(num,B,numeral_numeral(B),K) = aa(B,B,compow(fun(B,B),aa(num,nat,numeral_numeral(nat),K),aa(B,fun(B,B),plus_plus(B),one_one(B))),zero_zero(B)) ) ) ).

% numeral_unfold_funpow
tff(fact_4416_antimono__funpow,axiom,
    ! [B: $tType] :
      ( ( lattice(B)
        & order_top(B) )
     => ! [Qa: fun(B,B)] :
          ( order_mono(B,B,Qa)
         => order_antimono(nat,B,aTP_Lamp_agy(fun(B,B),fun(nat,B),Qa)) ) ) ).

% antimono_funpow
tff(fact_4417_su__rel__fun__def,axiom,
    ! [C: $tType,B: $tType,F: set(product_prod(B,C)),F2: fun(B,C)] :
      ( su_rel_fun(B,C,F,F2)
    <=> ( ! [A12: B,B9: C,B14: C] :
            ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A12),B9)),F)
           => ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A12),B14)),F)
             => ( B9 = B14 ) ) )
        & ! [A12: B,P2: $o] :
            ( ! [B9: C] :
                ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A12),B9)),F)
               => (P2) )
           => (P2) )
        & ! [A12: B] : ( aa(B,C,F2,A12) = the(C,aa(B,fun(C,$o),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),F),A12)) ) ) ) ).

% su_rel_fun_def
tff(fact_4418_su__rel__fun_Ointro,axiom,
    ! [C: $tType,B: $tType,F: set(product_prod(B,C)),F2: fun(B,C)] :
      ( ! [A11: B,B8: C,B15: C] :
          ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A11),B8)),F)
         => ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A11),B15)),F)
           => ( B8 = B15 ) ) )
     => ( ! [A11: B,P: $o] :
            ( ! [B16: C] :
                ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A11),B16)),F)
               => (P) )
           => (P) )
       => ( ! [A11: B] : ( aa(B,C,F2,A11) = the(C,aa(B,fun(C,$o),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),F),A11)) )
         => su_rel_fun(B,C,F,F2) ) ) ) ).

% su_rel_fun.intro
tff(fact_4419_su__rel__fun_Of__def,axiom,
    ! [C: $tType,B: $tType,F: set(product_prod(B,C)),F2: fun(B,C),A3: B] :
      ( su_rel_fun(B,C,F,F2)
     => ( aa(B,C,F2,A3) = the(C,aa(B,fun(C,$o),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),F),A3)) ) ) ).

% su_rel_fun.f_def
tff(fact_4420_antimono__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [F2: fun(B,C)] :
          ( order_antimono(B,C,F2)
        <=> ! [X3: B,Y4: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),Y4)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,Y4)),aa(B,C,F2,X3)) ) ) ) ).

% antimono_def
tff(fact_4421_antimonoI,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [F2: fun(B,C)] :
          ( ! [X: B,Y2: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y2)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,Y2)),aa(B,C,F2,X)) )
         => order_antimono(B,C,F2) ) ) ).

% antimonoI
tff(fact_4422_antimonoE,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [F2: fun(B,C),X2: B,Y: B] :
          ( order_antimono(B,C,F2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,Y)),aa(B,C,F2,X2)) ) ) ) ).

% antimonoE
tff(fact_4423_antimonoD,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [F2: fun(B,C),X2: B,Y: B] :
          ( order_antimono(B,C,F2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y)
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,Y)),aa(B,C,F2,X2)) ) ) ) ).

% antimonoD
tff(fact_4424_min__of__antimono,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [F2: fun(B,C),X2: B,Y: B] :
          ( order_antimono(B,C,F2)
         => ( aa(C,C,aa(C,fun(C,C),ord_min(C),aa(B,C,F2,X2)),aa(B,C,F2,Y)) = aa(B,C,F2,aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y)) ) ) ) ).

% min_of_antimono
tff(fact_4425_max__of__antimono,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [F2: fun(B,C),X2: B,Y: B] :
          ( order_antimono(B,C,F2)
         => ( aa(C,C,aa(C,fun(C,C),ord_max(C),aa(B,C,F2,X2)),aa(B,C,F2,Y)) = aa(B,C,F2,aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y)) ) ) ) ).

% max_of_antimono
tff(fact_4426_aboveS__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A4: B] : ( order_aboveS(B,R2,A4) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_agz(set(product_prod(B,B)),fun(B,fun(B,$o)),R2),A4)) ) ).

% aboveS_def
tff(fact_4427_cardSuc__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( bNF_Ca8387033319878233205ardSuc(B,R2) = fChoice(set(product_prod(set(B),set(B))),bNF_Ca6246979054910435723ardSuc(B,R2)) ) ).

% cardSuc_def
tff(fact_4428_scomp__unfold,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,X4: fun(B,product_prod(C,D)),Xa3: fun(C,fun(D,E)),Xb3: B] : ( aa(B,E,product_scomp(B,C,D,E,X4,Xa3),Xb3) = aa(D,E,aa(C,fun(D,E),Xa3,aa(product_prod(C,D),C,product_fst(C,D),aa(B,product_prod(C,D),X4,Xb3))),aa(product_prod(C,D),D,product_snd(C,D),aa(B,product_prod(C,D),X4,Xb3))) ) ).

% scomp_unfold
tff(fact_4429_semilattice__order__set_Osubset__imp,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: set(B),B2: set(B)] :
      ( lattic4895041142388067077er_set(B,F2,Less_eq,Less)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
       => ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(set(B),B,lattic1715443433743089157tice_F(B,F2),B2)),aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3)) ) ) ) ) ).

% semilattice_order_set.subset_imp
tff(fact_4430_scomp__scomp,axiom,
    ! [B: $tType,F10: $tType,G6: $tType,C: $tType,E: $tType,D: $tType,F2: fun(B,product_prod(F10,G6)),G: fun(F10,fun(G6,product_prod(D,E))),H2: fun(D,fun(E,C))] : ( product_scomp(B,D,E,C,product_scomp(B,F10,G6,product_prod(D,E),F2,G),H2) = product_scomp(B,F10,G6,C,F2,aa(fun(D,fun(E,C)),fun(F10,fun(G6,C)),aTP_Lamp_aha(fun(F10,fun(G6,product_prod(D,E))),fun(fun(D,fun(E,C)),fun(F10,fun(G6,C))),G),H2)) ) ).

% scomp_scomp
tff(fact_4431_Inf__fin__def,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ( lattic7752659483105999362nf_fin(B) = lattic1715443433743089157tice_F(B,inf_inf(B)) ) ) ).

% Inf_fin_def
tff(fact_4432_semilattice__order__set_Obounded__iff,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: set(B),X2: B] :
      ( lattic4895041142388067077er_set(B,F2,Less_eq,Less)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( ( A3 != bot_bot(set(B)) )
         => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,X2),aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3))
          <=> ! [X3: B] :
                ( aa(set(B),$o,member(B,X3),A3)
               => aa(B,$o,aa(B,fun(B,$o),Less_eq,X2),X3) ) ) ) ) ) ).

% semilattice_order_set.bounded_iff
tff(fact_4433_semilattice__order__set_OboundedI,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: set(B),X2: B] :
      ( lattic4895041142388067077er_set(B,F2,Less_eq,Less)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( ( A3 != bot_bot(set(B)) )
         => ( ! [A5: B] :
                ( aa(set(B),$o,member(B,A5),A3)
               => aa(B,$o,aa(B,fun(B,$o),Less_eq,X2),A5) )
           => aa(B,$o,aa(B,fun(B,$o),Less_eq,X2),aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3)) ) ) ) ) ).

% semilattice_order_set.boundedI
tff(fact_4434_semilattice__order__set_OboundedE,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: set(B),X2: B] :
      ( lattic4895041142388067077er_set(B,F2,Less_eq,Less)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( ( A3 != bot_bot(set(B)) )
         => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,X2),aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3))
           => ! [A14: B] :
                ( aa(set(B),$o,member(B,A14),A3)
               => aa(B,$o,aa(B,fun(B,$o),Less_eq,X2),A14) ) ) ) ) ) ).

% semilattice_order_set.boundedE
tff(fact_4435_semilattice__set_Oeq__fold_H,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A3: set(B)] :
      ( lattic149705377957585745ce_set(B,F2)
     => ( aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3) = aa(option(B),B,the2(B),finite_fold(B,option(B),aTP_Lamp_ahb(fun(B,fun(B,B)),fun(B,fun(option(B),option(B))),F2),none(B),A3)) ) ) ).

% semilattice_set.eq_fold'
tff(fact_4436_semilattice__set_Oremove,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A3: set(B),X2: B] :
      ( lattic149705377957585745ce_set(B,F2)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( aa(set(B),$o,member(B,X2),A3)
         => ( aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3)
            = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),F2,X2),aa(set(B),B,lattic1715443433743089157tice_F(B,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))))) ) ) ) ) ).

% semilattice_set.remove
tff(fact_4437_semilattice__set_Oinsert__remove,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A3: set(B),X2: B] :
      ( lattic149705377957585745ce_set(B,F2)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( aa(set(B),B,lattic1715443433743089157tice_F(B,F2),aa(set(B),set(B),insert(B,X2),A3))
          = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = bot_bot(set(B)),X2,aa(B,B,aa(B,fun(B,B),F2,X2),aa(set(B),B,lattic1715443433743089157tice_F(B,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))))) ) ) ) ).

% semilattice_set.insert_remove
tff(fact_4438_semilattice__set_Ounion,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A3: set(B),B2: set(B)] :
      ( lattic149705377957585745ce_set(B,F2)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(B),$o,finite_finite2(B),B2)
           => ( ( B2 != bot_bot(set(B)) )
             => ( aa(set(B),B,lattic1715443433743089157tice_F(B,F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(B,B,aa(B,fun(B,B),F2,aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3)),aa(set(B),B,lattic1715443433743089157tice_F(B,F2),B2)) ) ) ) ) ) ) ).

% semilattice_set.union
tff(fact_4439_Inf__fin_Osemilattice__set__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => lattic149705377957585745ce_set(B,inf_inf(B)) ) ).

% Inf_fin.semilattice_set_axioms
tff(fact_4440_semilattice__set_Osingleton,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),X2: B] :
      ( lattic149705377957585745ce_set(B,F2)
     => ( aa(set(B),B,lattic1715443433743089157tice_F(B,F2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) = X2 ) ) ).

% semilattice_set.singleton
tff(fact_4441_semilattice__set_Ohom__commute,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),H2: fun(B,B),N3: set(B)] :
      ( lattic149705377957585745ce_set(B,F2)
     => ( ! [X: B,Y2: B] : ( aa(B,B,H2,aa(B,B,aa(B,fun(B,B),F2,X),Y2)) = aa(B,B,aa(B,fun(B,B),F2,aa(B,B,H2,X)),aa(B,B,H2,Y2)) )
       => ( aa(set(B),$o,finite_finite2(B),N3)
         => ( ( N3 != bot_bot(set(B)) )
           => ( aa(B,B,H2,aa(set(B),B,lattic1715443433743089157tice_F(B,F2),N3)) = aa(set(B),B,lattic1715443433743089157tice_F(B,F2),aa(set(B),set(B),image2(B,B,H2),N3)) ) ) ) ) ) ).

% semilattice_set.hom_commute
tff(fact_4442_semilattice__set_Osubset,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A3: set(B),B2: set(B)] :
      ( lattic149705377957585745ce_set(B,F2)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( ( B2 != bot_bot(set(B)) )
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A3)
           => ( aa(B,B,aa(B,fun(B,B),F2,aa(set(B),B,lattic1715443433743089157tice_F(B,F2),B2)),aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3)) = aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3) ) ) ) ) ) ).

% semilattice_set.subset
tff(fact_4443_semilattice__set_Oinsert__not__elem,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A3: set(B),X2: B] :
      ( lattic149705377957585745ce_set(B,F2)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( ~ aa(set(B),$o,member(B,X2),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic1715443433743089157tice_F(B,F2),aa(set(B),set(B),insert(B,X2),A3)) = aa(B,B,aa(B,fun(B,B),F2,X2),aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3)) ) ) ) ) ) ).

% semilattice_set.insert_not_elem
tff(fact_4444_semilattice__set_Oinsert,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A3: set(B),X2: B] :
      ( lattic149705377957585745ce_set(B,F2)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(B),B,lattic1715443433743089157tice_F(B,F2),aa(set(B),set(B),insert(B,X2),A3)) = aa(B,B,aa(B,fun(B,B),F2,X2),aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3)) ) ) ) ) ).

% semilattice_set.insert
tff(fact_4445_semilattice__set_Oclosed,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A3: set(B)] :
      ( lattic149705377957585745ce_set(B,F2)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( ( A3 != bot_bot(set(B)) )
         => ( ! [X: B,Y2: B] : aa(set(B),$o,member(B,aa(B,B,aa(B,fun(B,B),F2,X),Y2)),aa(set(B),set(B),insert(B,X),aa(set(B),set(B),insert(B,Y2),bot_bot(set(B)))))
           => aa(set(B),$o,member(B,aa(set(B),B,lattic1715443433743089157tice_F(B,F2),A3)),A3) ) ) ) ) ).

% semilattice_set.closed
tff(fact_4446_cr__int__def,axiom,
    ! [X4: product_prod(nat,nat)] : ( cr_int(X4) = aa(int,fun(int,$o),fequal(int),aa(product_prod(nat,nat),int,abs_Integ,X4)) ) ).

% cr_int_def
tff(fact_4447_antisymp__antisym__eq,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( antisymp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2))
    <=> antisym(B,R2) ) ).

% antisymp_antisym_eq
tff(fact_4448_mult__inj__if__coprime__nat,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,nat),A3: set(B),G: fun(C,nat),B2: set(C)] :
      ( inj_on(B,nat,F2,A3)
     => ( inj_on(C,nat,G,B2)
       => ( ! [A5: B,B4: C] :
              ( aa(set(B),$o,member(B,A5),A3)
             => ( aa(set(C),$o,member(C,B4),B2)
               => algebr8660921524188924756oprime(nat,aa(B,nat,F2,A5),aa(C,nat,G,B4)) ) )
         => inj_on(product_prod(B,C),nat,aa(fun(B,fun(C,nat)),fun(product_prod(B,C),nat),product_case_prod(B,C,nat),aa(fun(C,nat),fun(B,fun(C,nat)),aTP_Lamp_ahc(fun(B,nat),fun(fun(C,nat),fun(B,fun(C,nat))),F2),G)),product_Sigma(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2))) ) ) ) ).

% mult_inj_if_coprime_nat
tff(fact_4449_K__record__comp,axiom,
    ! [B: $tType,D: $tType,C: $tType,Ca: C,F2: fun(B,D),X4: B] : ( aa(B,C,aa(fun(B,D),fun(B,C),comp(D,C,B,aTP_Lamp_ahd(C,fun(D,C),Ca)),F2),X4) = Ca ) ).

% K_record_comp
tff(fact_4450_coprime__mult__right__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( algebr8660921524188924756oprime(B,Ca,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3))
        <=> ( algebr8660921524188924756oprime(B,Ca,A4)
            & algebr8660921524188924756oprime(B,Ca,B3) ) ) ) ).

% coprime_mult_right_iff
tff(fact_4451_coprime__mult__left__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( algebr8660921524188924756oprime(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3),Ca)
        <=> ( algebr8660921524188924756oprime(B,A4,Ca)
            & algebr8660921524188924756oprime(B,B3,Ca) ) ) ) ).

% coprime_mult_left_iff
tff(fact_4452_coprime__self,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B] :
          ( algebr8660921524188924756oprime(B,A4,A4)
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B)) ) ) ).

% coprime_self
tff(fact_4453_coprime__imp__gcd__eq__1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] :
          ( algebr8660921524188924756oprime(B,A4,B3)
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) = one_one(B) ) ) ) ).

% coprime_imp_gcd_eq_1
tff(fact_4454_coprime__0__right__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B] :
          ( algebr8660921524188924756oprime(B,A4,zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B)) ) ) ).

% coprime_0_right_iff
tff(fact_4455_coprime__0__left__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B] :
          ( algebr8660921524188924756oprime(B,zero_zero(B),A4)
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B)) ) ) ).

% coprime_0_left_iff
tff(fact_4456_coprime__mult__self__left__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( algebr8660921524188924756oprime(B,aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
        <=> ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),one_one(B))
            & algebr8660921524188924756oprime(B,A4,B3) ) ) ) ).

% coprime_mult_self_left_iff
tff(fact_4457_coprime__mult__self__right__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( algebr8660921524188924756oprime(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
        <=> ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),one_one(B))
            & algebr8660921524188924756oprime(B,A4,B3) ) ) ) ).

% coprime_mult_self_right_iff
tff(fact_4458_is__unit__gcd,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)),one_one(B))
        <=> algebr8660921524188924756oprime(B,A4,B3) ) ) ).

% is_unit_gcd
tff(fact_4459_prod__coprime__left,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_gcd(C)
     => ! [A3: set(B),F2: fun(B,C),A4: C] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),A3)
             => algebr8660921524188924756oprime(C,aa(B,C,F2,I3),A4) )
         => algebr8660921524188924756oprime(C,aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),A3),A4) ) ) ).

% prod_coprime_left
tff(fact_4460_prod__coprime__right,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_gcd(C)
     => ! [A3: set(B),A4: C,F2: fun(B,C)] :
          ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),A3)
             => algebr8660921524188924756oprime(C,A4,aa(B,C,F2,I3)) )
         => algebr8660921524188924756oprime(C,A4,aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),F2),A3)) ) ) ).

% prod_coprime_right
tff(fact_4461_coprime__commute,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B] :
          ( algebr8660921524188924756oprime(B,B3,A4)
        <=> algebr8660921524188924756oprime(B,A4,B3) ) ) ).

% coprime_commute
tff(fact_4462_coprime__divisors,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,Ca: B,B3: B,D3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),D3)
           => ( algebr8660921524188924756oprime(B,Ca,D3)
             => algebr8660921524188924756oprime(B,A4,B3) ) ) ) ) ).

% coprime_divisors
tff(fact_4463_coprime__1__left,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B] : algebr8660921524188924756oprime(B,one_one(B),A4) ) ).

% coprime_1_left
tff(fact_4464_coprime__1__right,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B] : algebr8660921524188924756oprime(B,A4,one_one(B)) ) ).

% coprime_1_right
tff(fact_4465_coprime__add__one__right,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B] : algebr8660921524188924756oprime(B,A4,aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B))) ) ).

% coprime_add_one_right
tff(fact_4466_coprime__add__one__left,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B] : algebr8660921524188924756oprime(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),one_one(B)),A4) ) ).

% coprime_add_one_left
tff(fact_4467_coprime__doff__one__right,axiom,
    ! [B: $tType] :
      ( ring_gcd(B)
     => ! [A4: B] : algebr8660921524188924756oprime(B,A4,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))) ) ).

% coprime_doff_one_right
tff(fact_4468_coprime__diff__one__left,axiom,
    ! [B: $tType] :
      ( ring_gcd(B)
     => ! [A4: B] : algebr8660921524188924756oprime(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B)),A4) ) ).

% coprime_diff_one_left
tff(fact_4469_coprime__dvd__mult__right__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( algebr8660921524188924756oprime(B,A4,Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ) ).

% coprime_dvd_mult_right_iff
tff(fact_4470_coprime__dvd__mult__left__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( algebr8660921524188924756oprime(B,A4,Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ) ).

% coprime_dvd_mult_left_iff
tff(fact_4471_divides__mult,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),Ca)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),Ca)
           => ( algebr8660921524188924756oprime(B,A4,B3)
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),Ca) ) ) ) ) ).

% divides_mult
tff(fact_4472_is__unit__right__imp__coprime,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => algebr8660921524188924756oprime(B,A4,B3) ) ) ).

% is_unit_right_imp_coprime
tff(fact_4473_is__unit__left__imp__coprime,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => algebr8660921524188924756oprime(B,A4,B3) ) ) ).

% is_unit_left_imp_coprime
tff(fact_4474_coprime__common__divisor,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( algebr8660921524188924756oprime(B,A4,B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),A4)
           => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),one_one(B)) ) ) ) ) ).

% coprime_common_divisor
tff(fact_4475_coprime__absorb__right,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Y: B,X2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Y),X2)
         => ( algebr8660921524188924756oprime(B,X2,Y)
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Y),one_one(B)) ) ) ) ).

% coprime_absorb_right
tff(fact_4476_coprime__imp__coprime,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ca: B,D3: B,A4: B,B3: B] :
          ( algebr8660921524188924756oprime(B,Ca,D3)
         => ( ! [E4: B] :
                ( ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),E4),one_one(B))
               => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),E4),A4)
                 => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),E4),B3)
                   => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),E4),Ca) ) ) )
           => ( ! [E4: B] :
                  ( ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),E4),one_one(B))
                 => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),E4),A4)
                   => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),E4),B3)
                     => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),E4),D3) ) ) )
             => algebr8660921524188924756oprime(B,A4,B3) ) ) ) ) ).

% coprime_imp_coprime
tff(fact_4477_coprime__absorb__left,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [X2: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X2),Y)
         => ( algebr8660921524188924756oprime(B,X2,Y)
          <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X2),one_one(B)) ) ) ) ).

% coprime_absorb_left
tff(fact_4478_not__coprimeI,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ca: B,A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),A4)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),B3)
           => ( ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Ca),one_one(B))
             => ~ algebr8660921524188924756oprime(B,A4,B3) ) ) ) ) ).

% not_coprimeI
tff(fact_4479_not__coprimeE,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( ~ algebr8660921524188924756oprime(B,A4,B3)
         => ~ ! [C3: B] :
                ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),C3),A4)
               => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),C3),B3)
                 => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),C3),one_one(B)) ) ) ) ) ).

% not_coprimeE
tff(fact_4480_coprime__def,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( algebr8660921524188924756oprime(B,A4,B3)
        <=> ! [C4: B] :
              ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),C4),A4)
             => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),C4),B3)
               => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),C4),one_one(B)) ) ) ) ) ).

% coprime_def
tff(fact_4481_coprimeI,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: B,B3: B] :
          ( ! [C3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),C3),A4)
             => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),C3),B3)
               => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),C3),one_one(B)) ) )
         => algebr8660921524188924756oprime(B,A4,B3) ) ) ).

% coprimeI
tff(fact_4482_mult__mod__cancel__left,axiom,
    ! [B: $tType] :
      ( ( euclid8851590272496341667cancel(B)
        & semiring_gcd(B) )
     => ! [N: B,A4: B,M2: B,B3: B] :
          ( ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),N),A4),M2) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),N),B3),M2) )
         => ( algebr8660921524188924756oprime(B,M2,N)
           => ( modulo_modulo(B,A4,M2) = modulo_modulo(B,B3,M2) ) ) ) ) ).

% mult_mod_cancel_left
tff(fact_4483_mult__mod__cancel__right,axiom,
    ! [B: $tType] :
      ( ( euclid8851590272496341667cancel(B)
        & semiring_gcd(B) )
     => ! [A4: B,N: B,M2: B,B3: B] :
          ( ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),N),M2) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),B3),N),M2) )
         => ( algebr8660921524188924756oprime(B,M2,N)
           => ( modulo_modulo(B,A4,M2) = modulo_modulo(B,B3,M2) ) ) ) ) ).

% mult_mod_cancel_right
tff(fact_4484_gcd__mult__right__right__cancel,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( algebr8660921524188924756oprime(B,A4,Ca)
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) ) ) ) ).

% gcd_mult_right_right_cancel
tff(fact_4485_gcd__mult__right__left__cancel,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,Ca: B,B3: B] :
          ( algebr8660921524188924756oprime(B,A4,Ca)
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) ) ) ) ).

% gcd_mult_right_left_cancel
tff(fact_4486_gcd__mult__left__right__cancel,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( algebr8660921524188924756oprime(B,B3,Ca)
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),B3) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) ) ) ) ).

% gcd_mult_left_right_cancel
tff(fact_4487_gcd__mult__left__left__cancel,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [B3: B,Ca: B,A4: B] :
          ( algebr8660921524188924756oprime(B,B3,Ca)
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),B3) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) ) ) ) ).

% gcd_mult_left_left_cancel
tff(fact_4488_gcd__eq__1__imp__coprime,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) = one_one(B) )
         => algebr8660921524188924756oprime(B,A4,B3) ) ) ).

% gcd_eq_1_imp_coprime
tff(fact_4489_coprime__iff__gcd__eq__1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] :
          ( algebr8660921524188924756oprime(B,A4,B3)
        <=> ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) = one_one(B) ) ) ) ).

% coprime_iff_gcd_eq_1
tff(fact_4490_antisym__bot,axiom,
    ! [B: $tType] : antisymp(B,bot_bot(fun(B,fun(B,$o)))) ).

% antisym_bot
tff(fact_4491_invertible__coprime,axiom,
    ! [B: $tType] :
      ( euclid8851590272496341667cancel(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3),Ca) = one_one(B) )
         => algebr8660921524188924756oprime(B,A4,Ca) ) ) ).

% invertible_coprime
tff(fact_4492_gcd__coprime__exists,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) != zero_zero(B) )
         => ? [A9: B,B11: B] :
              ( ( A4 = aa(B,B,aa(B,fun(B,B),times_times(B),A9),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)) )
              & ( B3 = aa(B,B,aa(B,fun(B,B),times_times(B),B11),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)) )
              & algebr8660921524188924756oprime(B,A9,B11) ) ) ) ).

% gcd_coprime_exists
tff(fact_4493_gcd__coprime,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,A7: B,B6: B] :
          ( ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) != zero_zero(B) )
         => ( ( A4 = aa(B,B,aa(B,fun(B,B),times_times(B),A7),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)) )
           => ( ( B3 = aa(B,B,aa(B,fun(B,B),times_times(B),B6),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)) )
             => algebr8660921524188924756oprime(B,A7,B6) ) ) ) ) ).

% gcd_coprime
tff(fact_4494_bind__singleton__conv__image,axiom,
    ! [B: $tType,C: $tType,A3: set(C),F2: fun(C,B)] : ( bind3(C,B,A3,aTP_Lamp_gz(fun(C,B),fun(C,set(B)),F2)) = aa(set(C),set(B),image2(C,B,F2),A3) ) ).

% bind_singleton_conv_image
tff(fact_4495_and_Osemilattice__neutr__axioms,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => semilattice_neutr(B,bit_se5824344872417868541ns_and(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% and.semilattice_neutr_axioms
tff(fact_4496_Func__empty,axiom,
    ! [C: $tType,B: $tType,B2: set(C)] : ( bNF_Wellorder_Func(B,C,bot_bot(set(B)),B2) = aa(set(fun(B,C)),set(fun(B,C)),insert(fun(B,C),aTP_Lamp_ahe(B,C)),bot_bot(set(fun(B,C)))) ) ).

% Func_empty
tff(fact_4497_Restr__natLeq2,axiom,
    ! [N: nat] : ( aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),inf_inf(set(product_prod(nat,nat))),bNF_Ca8665028551170535155natLeq),product_Sigma(nat,nat,order_underS(nat,bNF_Ca8665028551170535155natLeq,N),aTP_Lamp_ahf(nat,fun(nat,set(nat)),N))) = aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_tp(nat,fun(nat,fun(nat,$o)),N))) ) ).

% Restr_natLeq2
tff(fact_4498_empty__bind,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,set(B))] : ( bind3(C,B,bot_bot(set(C)),F2) = bot_bot(set(B)) ) ).

% empty_bind
tff(fact_4499_mod__h__bot__normalize,axiom,
    ! [B: $tType,H2: heap_ext(product_unit),Pa: assn] :
      ( syntax7388354845996824322omatch(B,heap_ext(product_unit),undefined(B),H2)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
      <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),undefined(heap_ext(product_unit))),bot_bot(set(nat)))) ) ) ).

% mod_h_bot_normalize
tff(fact_4500_Set_Obind__bind,axiom,
    ! [D: $tType,B: $tType,C: $tType,A3: set(D),B2: fun(D,set(C)),C2: fun(C,set(B))] : ( bind3(C,B,bind3(D,C,A3,B2),C2) = bind3(D,B,A3,aa(fun(C,set(B)),fun(D,set(B)),aTP_Lamp_ahg(fun(D,set(C)),fun(fun(C,set(B)),fun(D,set(B))),B2),C2)) ) ).

% Set.bind_bind
tff(fact_4501_natLeq__underS__less,axiom,
    ! [N: nat] : ( order_underS(nat,bNF_Ca8665028551170535155natLeq,N) = aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N)) ) ).

% natLeq_underS_less
tff(fact_4502_semilattice__neutr_Oaxioms_I2_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( semilattice_neutr(B,F2,Z2)
     => comm_monoid(B,F2,Z2) ) ).

% semilattice_neutr.axioms(2)
tff(fact_4503_bind__const,axiom,
    ! [C: $tType,B: $tType,A3: set(C),B2: set(B)] :
      ( bind3(C,B,A3,aTP_Lamp_bv(set(B),fun(C,set(B)),B2))
      = $ite(A3 = bot_bot(set(C)),bot_bot(set(B)),B2) ) ).

% bind_const
tff(fact_4504_nonempty__bind__const,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( bind3(B,C,A3,aTP_Lamp_bq(set(C),fun(B,set(C)),B2)) = B2 ) ) ).

% nonempty_bind_const
tff(fact_4505_semilattice__neutr__order_Oaxioms_I1_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semila1105856199041335345_order(B,F2,Z2,Less_eq,Less)
     => semilattice_neutr(B,F2,Z2) ) ).

% semilattice_neutr_order.axioms(1)
tff(fact_4506_option_Othe__def,axiom,
    ! [B: $tType,Option: option(B)] : ( aa(option(B),B,the2(B),Option) = case_option(B,B,undefined(B),aTP_Lamp_bk(B,B),Option) ) ).

% option.the_def
tff(fact_4507_sup__bot_Osemilattice__neutr__axioms,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => semilattice_neutr(B,sup_sup(B),bot_bot(B)) ) ).

% sup_bot.semilattice_neutr_axioms
tff(fact_4508_inf__top_Osemilattice__neutr__axioms,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => semilattice_neutr(B,inf_inf(B),top_top(B)) ) ).

% inf_top.semilattice_neutr_axioms
tff(fact_4509_curr__def,axiom,
    ! [B: $tType,D: $tType,C: $tType,A3: set(B),F2: fun(product_prod(B,C),D),X4: B] :
      ( aa(B,fun(C,D),aa(fun(product_prod(B,C),D),fun(B,fun(C,D)),bNF_Wellorder_curr(B,C,D,A3),F2),X4)
      = $ite(aa(set(B),$o,member(B,X4),A3),aa(B,fun(C,D),aTP_Lamp_dr(fun(product_prod(B,C),D),fun(B,fun(C,D)),F2),X4),undefined(fun(C,D))) ) ).

% curr_def
tff(fact_4510_natLeq__def,axiom,
    bNF_Ca8665028551170535155natLeq = aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),ord_less_eq(nat))) ).

% natLeq_def
tff(fact_4511_Set_Obind__def,axiom,
    ! [B: $tType,C: $tType,A3: set(C),F2: fun(C,set(B))] : ( bind3(C,B,A3,F2) = aa(fun(B,$o),set(B),collect(B),aa(fun(C,set(B)),fun(B,$o),aTP_Lamp_ahh(set(C),fun(fun(C,set(B)),fun(B,$o)),A3),F2)) ) ).

% Set.bind_def
tff(fact_4512_Func__def,axiom,
    ! [B: $tType,C: $tType,A3: set(B),B2: set(C)] : ( bNF_Wellorder_Func(B,C,A3,B2) = aa(fun(fun(B,C),$o),set(fun(B,C)),collect(fun(B,C)),aa(set(C),fun(fun(B,C),$o),aTP_Lamp_ahi(set(B),fun(set(C),fun(fun(B,C),$o)),A3),B2)) ) ).

% Func_def
tff(fact_4513_Restr__natLeq,axiom,
    ! [N: nat] : ( aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),inf_inf(set(product_prod(nat,nat))),bNF_Ca8665028551170535155natLeq),product_Sigma(nat,nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),N)),aTP_Lamp_ahj(nat,fun(nat,set(nat)),N))) = aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_tp(nat,fun(nat,fun(nat,$o)),N))) ) ).

% Restr_natLeq
tff(fact_4514_quotient__of__def,axiom,
    ! [X2: rat] : ( quotient_of(X2) = the(product_prod(int,int),aTP_Lamp_ahk(rat,fun(product_prod(int,int),$o),X2)) ) ).

% quotient_of_def
tff(fact_4515_power__int__add__1_H,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X2: B,M2: int] :
          ( ( ( X2 != zero_zero(B) )
            | ( M2 != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(B,X2,aa(int,int,aa(int,fun(int,int),plus_plus(int),M2),one_one(int))) = aa(B,B,aa(B,fun(B,B),times_times(B),X2),power_int(B,X2,M2)) ) ) ) ).

% power_int_add_1'
tff(fact_4516_power__int__add__1,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X2: B,M2: int] :
          ( ( ( X2 != zero_zero(B) )
            | ( M2 != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(B,X2,aa(int,int,aa(int,fun(int,int),plus_plus(int),M2),one_one(int))) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X2,M2)),X2) ) ) ) ).

% power_int_add_1
tff(fact_4517_power__int__minus__mult,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X2: B,N: int] :
          ( ( ( X2 != zero_zero(B) )
            | ( N != zero_zero(int) ) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X2,aa(int,int,aa(int,fun(int,int),minus_minus(int),N),one_one(int)))),X2) = power_int(B,X2,N) ) ) ) ).

% power_int_minus_mult
tff(fact_4518_power__int__1__left,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [N: int] : ( power_int(B,one_one(B),N) = one_one(B) ) ) ).

% power_int_1_left
tff(fact_4519_power__int__mult__distrib__numeral2,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X2: B,W2: num,M2: int] : ( power_int(B,aa(B,B,aa(B,fun(B,B),times_times(B),X2),aa(num,B,numeral_numeral(B),W2)),M2) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X2,M2)),power_int(B,aa(num,B,numeral_numeral(B),W2),M2)) ) ) ).

% power_int_mult_distrib_numeral2
tff(fact_4520_power__int__mult__distrib__numeral1,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [W2: num,Y: B,M2: int] : ( power_int(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Y),M2) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,aa(num,B,numeral_numeral(B),W2),M2)),power_int(B,Y,M2)) ) ) ).

% power_int_mult_distrib_numeral1
tff(fact_4521_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( inverse(B)
        & power(B) )
     => ! [X2: B] : ( power_int(B,X2,zero_zero(int)) = one_one(B) ) ) ).

% power_int_0_right
tff(fact_4522_power__int__minus__one__mult__self,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [M2: int] : ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),M2)),power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),M2)) = one_one(B) ) ) ).

% power_int_minus_one_mult_self
tff(fact_4523_power__int__minus__one__mult__self_H,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [M2: int,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),M2)),aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),M2)),B3)) = B3 ) ) ).

% power_int_minus_one_mult_self'
tff(fact_4524_power__int__add__numeral,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X2: B,M2: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X2,aa(num,int,numeral_numeral(int),M2))),power_int(B,X2,aa(num,int,numeral_numeral(int),N))) = power_int(B,X2,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M2),N))) ) ) ).

% power_int_add_numeral
tff(fact_4525_power__int__add__numeral2,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X2: B,M2: num,N: num,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X2,aa(num,int,numeral_numeral(int),M2))),aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X2,aa(num,int,numeral_numeral(int),N))),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X2,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M2),N)))),B3) ) ) ).

% power_int_add_numeral2
tff(fact_4526_power__int__commutes,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X2: B,N: int] : ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X2,N)),X2) = aa(B,B,aa(B,fun(B,B),times_times(B),X2),power_int(B,X2,N)) ) ) ).

% power_int_commutes
tff(fact_4527_power__int__mult__distrib,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X2: B,Y: B,M2: int] : ( power_int(B,aa(B,B,aa(B,fun(B,B),times_times(B),X2),Y),M2) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X2,M2)),power_int(B,Y,M2)) ) ) ).

% power_int_mult_distrib
tff(fact_4528_power__int__one__over,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X2: B,N: int] : ( power_int(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),X2),N) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),power_int(B,X2,N)) ) ) ).

% power_int_one_over
tff(fact_4529_power__int__0__left__If,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [M2: int] :
          ( power_int(B,zero_zero(B),M2)
          = $ite(M2 = zero_zero(int),one_one(B),zero_zero(B)) ) ) ).

% power_int_0_left_If
tff(fact_4530_power__int__increasing,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [N: int,N3: int,A4: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),N),N3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A4)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),power_int(B,A4,N)),power_int(B,A4,N3)) ) ) ) ).

% power_int_increasing
tff(fact_4531_power__int__strict__increasing,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [N: int,N3: int,A4: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),N),N3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),power_int(B,A4,N)),power_int(B,A4,N3)) ) ) ) ).

% power_int_strict_increasing
tff(fact_4532_power__int__minus__one__minus,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [N: int] : ( power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),aa(int,int,uminus_uminus(int),N)) = power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),N) ) ) ).

% power_int_minus_one_minus
tff(fact_4533_power__int__minus__one__diff__commute,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A4: int,B3: int] : ( power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),aa(int,int,aa(int,fun(int,int),minus_minus(int),A4),B3)) = power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),aa(int,int,aa(int,fun(int,int),minus_minus(int),B3),A4)) ) ) ).

% power_int_minus_one_diff_commute
tff(fact_4534_power__int__strict__decreasing,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [N: int,N3: int,A4: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),N),N3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A4)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A4),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),power_int(B,A4,N3)),power_int(B,A4,N)) ) ) ) ) ).

% power_int_strict_decreasing
tff(fact_4535_one__le__power__int,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X2: B,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),X2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),power_int(B,X2,N)) ) ) ) ).

% one_le_power_int
tff(fact_4536_one__less__power__int,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A4: B,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A4)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),N)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),power_int(B,A4,N)) ) ) ) ).

% one_less_power_int
tff(fact_4537_power__int__add,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X2: B,M2: int,N: int] :
          ( ( ( X2 != zero_zero(B) )
            | ( aa(int,int,aa(int,fun(int,int),plus_plus(int),M2),N) != zero_zero(int) ) )
         => ( power_int(B,X2,aa(int,int,aa(int,fun(int,int),plus_plus(int),M2),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X2,M2)),power_int(B,X2,N)) ) ) ) ).

% power_int_add
tff(fact_4538_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( division_ring(D)
        & one(B)
        & uminus(B) )
     => ! [X2: C,A4: D,N: int] :
          ( nO_MATCH(B,C,aa(B,B,uminus_uminus(B),one_one(B)),X2)
         => ( power_int(D,aa(D,D,uminus_uminus(D),A4),N) = aa(D,D,aa(D,fun(D,D),times_times(D),power_int(D,aa(D,D,uminus_uminus(D),one_one(D)),N)),power_int(D,A4,N)) ) ) ) ).

% power_int_minus_left_distrib
tff(fact_4539_power__int__le__one,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X2: B,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),power_int(B,X2,N)),one_one(B)) ) ) ) ) ).

% power_int_le_one
tff(fact_4540_power__int__decreasing,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [N: int,N3: int,A4: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),N),N3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A4)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),one_one(B))
             => ( ( ( A4 != zero_zero(B) )
                  | ( N3 != zero_zero(int) )
                  | ( N = zero_zero(int) ) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),power_int(B,A4,N3)),power_int(B,A4,N)) ) ) ) ) ) ).

% power_int_decreasing
tff(fact_4541_power__int__le__imp__le__exp,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X2: B,M2: int,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),X2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),power_int(B,X2,M2)),power_int(B,X2,N))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
             => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),M2),N) ) ) ) ) ).

% power_int_le_imp_le_exp
tff(fact_4542_Fract_Otransfer,axiom,
    aa(fun(int,fun(int,rat)),$o,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,rat)),$o),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,rat),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),rat,fequal(int),pcr_rat)),aTP_Lamp_acc(int,fun(int,product_prod(int,int)))),fract) ).

% Fract.transfer
tff(fact_4543_Fract__def,axiom,
    fract = aa(fun(int,fun(int,product_prod(int,int))),fun(int,fun(int,rat)),map_fun(int,int,fun(int,product_prod(int,int)),fun(int,rat),id(int),map_fun(int,int,product_prod(int,int),rat,id(int),abs_Rat)),aTP_Lamp_acc(int,fun(int,product_prod(int,int)))) ).

% Fract_def
tff(fact_4544_power__int__le__imp__less__exp,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X2: B,M2: int,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),X2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),power_int(B,X2,M2)),power_int(B,X2,N))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
             => aa(int,$o,aa(int,fun(int,$o),ord_less(int),M2),N) ) ) ) ) ).

% power_int_le_imp_less_exp
tff(fact_4545_fun_Opred__set,axiom,
    ! [B: $tType,C: $tType,Pa: fun(C,$o),X4: fun(B,C)] :
      ( aa(fun(B,C),$o,aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,aTP_Lamp_nh(B,$o)),Pa),X4)
    <=> ! [Xa2: C] :
          ( aa(set(C),$o,member(C,Xa2),aa(set(B),set(C),image2(B,C,X4),top_top(set(B))))
         => aa(C,$o,Pa,Xa2) ) ) ).

% fun.pred_set
tff(fact_4546_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => folding_insort_key(B,B,ord_less_eq(B),ord_less(B),top_top(set(B)),aTP_Lamp_eh(B,B)) ) ).

% sorted_list_of_set.folding_insort_key_axioms
tff(fact_4547_mset__set__Union,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),$o,finite_finite2(B),B2)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2) = bot_bot(set(B)) )
         => ( mset_set(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),mset_set(B,A3)),mset_set(B,B2)) ) ) ) ) ).

% mset_set_Union
tff(fact_4548_MOST__const,axiom,
    ! [B: $tType,Pa: $o] :
      ( eventually(B,aTP_Lamp_an($o,fun(B,$o),Pa),cofinite(B))
    <=> ( (Pa)
        | aa(set(B),$o,finite_finite2(B),top_top(set(B))) ) ) ).

% MOST_const
tff(fact_4549_mset__set_Oempty,axiom,
    ! [B: $tType] : ( mset_set(B,bot_bot(set(B))) = zero_zero(multiset(B)) ) ).

% mset_set.empty
tff(fact_4550_cofinite__bot,axiom,
    ! [B: $tType] :
      ( ( cofinite(B) = bot_bot(filter(B)) )
    <=> aa(set(B),$o,finite_finite2(B),top_top(set(B))) ) ).

% cofinite_bot
tff(fact_4551_MOST__eq_I2_J,axiom,
    ! [B: $tType,A4: B] :
      ( eventually(B,aa(B,fun(B,$o),fequal(B),A4),cofinite(B))
    <=> aa(set(B),$o,finite_finite2(B),top_top(set(B))) ) ).

% MOST_eq(2)
tff(fact_4552_MOST__eq_I1_J,axiom,
    ! [B: $tType,A4: B] :
      ( eventually(B,aTP_Lamp_ct(B,fun(B,$o),A4),cofinite(B))
    <=> aa(set(B),$o,finite_finite2(B),top_top(set(B))) ) ).

% MOST_eq(1)
tff(fact_4553_fun_Opred__True,axiom,
    ! [C: $tType,B: $tType,X4: fun(B,C)] : aa(fun(B,C),$o,aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,aTP_Lamp_nh(B,$o)),aTP_Lamp_ahl(C,$o)),X4) ).

% fun.pred_True
tff(fact_4554_MOST__neq_I2_J,axiom,
    ! [B: $tType,A4: B] : eventually(B,aa(B,fun(B,$o),aTP_Lamp_adk(B,fun(B,$o)),A4),cofinite(B)) ).

% MOST_neq(2)
tff(fact_4555_MOST__neq_I1_J,axiom,
    ! [B: $tType,A4: B] : eventually(B,aa(B,fun(B,$o),aTP_Lamp_rx(B,fun(B,$o)),A4),cofinite(B)) ).

% MOST_neq(1)
tff(fact_4556_MOST__eq__imp_I2_J,axiom,
    ! [B: $tType,A4: B,Pa: fun(B,$o)] : eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_ahm(B,fun(fun(B,$o),fun(B,$o)),A4),Pa),cofinite(B)) ).

% MOST_eq_imp(2)
tff(fact_4557_MOST__eq__imp_I1_J,axiom,
    ! [B: $tType,A4: B,Pa: fun(B,$o)] : eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_ahn(B,fun(fun(B,$o),fun(B,$o)),A4),Pa),cofinite(B)) ).

% MOST_eq_imp(1)
tff(fact_4558_MOST__I,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ! [X: B] : aa(B,$o,Pa,X)
     => eventually(B,Pa,cofinite(B)) ) ).

% MOST_I
tff(fact_4559_ALL__MOST,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ! [X_1: B] : aa(B,$o,Pa,X_1)
     => eventually(B,Pa,cofinite(B)) ) ).

% ALL_MOST
tff(fact_4560_MOST__mono,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( eventually(B,Pa,cofinite(B))
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
           => aa(B,$o,Qa,X) )
       => eventually(B,Qa,cofinite(B)) ) ) ).

% MOST_mono
tff(fact_4561_MOST__conjI,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( eventually(B,Pa,cofinite(B))
     => ( eventually(B,Qa,cofinite(B))
       => eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),cofinite(B)) ) ) ).

% MOST_conjI
tff(fact_4562_MOST__rev__mp,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( eventually(B,Pa,cofinite(B))
     => ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aw(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),cofinite(B))
       => eventually(B,Qa,cofinite(B)) ) ) ).

% MOST_rev_mp
tff(fact_4563_MOST__imp__iff,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( eventually(B,Pa,cofinite(B))
     => ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aw(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),cofinite(B))
      <=> eventually(B,Qa,cofinite(B)) ) ) ).

% MOST_imp_iff
tff(fact_4564_MOST__conj__distrib,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),cofinite(B))
    <=> ( eventually(B,Pa,cofinite(B))
        & eventually(B,Qa,cofinite(B)) ) ) ).

% MOST_conj_distrib
tff(fact_4565_pred__fun__def,axiom,
    ! [C: $tType,B: $tType,A3: fun(B,$o),B2: fun(C,$o),X4: fun(B,C)] :
      ( aa(fun(B,C),$o,aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,A3),B2),X4)
    <=> ! [Xa2: B] :
          ( aa(B,$o,A3,Xa2)
         => aa(C,$o,B2,aa(B,C,X4,Xa2)) ) ) ).

% pred_fun_def
tff(fact_4566_fun_Omap__cong__pred,axiom,
    ! [D: $tType,C: $tType,B: $tType,X2: fun(B,C),Ya2: fun(B,C),F2: fun(C,D),G: fun(C,D)] :
      ( ( X2 = Ya2 )
     => ( aa(fun(B,C),$o,aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,aTP_Lamp_nh(B,$o)),aa(fun(C,D),fun(C,$o),aTP_Lamp_aho(fun(C,D),fun(fun(C,D),fun(C,$o)),F2),G)),Ya2)
       => ( aa(fun(B,C),fun(B,D),comp(C,D,B,F2),X2) = aa(fun(B,C),fun(B,D),comp(C,D,B,G),Ya2) ) ) ) ).

% fun.map_cong_pred
tff(fact_4567_fun_Opred__mono,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),Paa: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(fun(B,$o),fun(fun(B,$o),$o),ord_less_eq(fun(B,$o)),Pa),Paa)
     => aa(fun(fun(C,B),$o),$o,aa(fun(fun(C,B),$o),fun(fun(fun(C,B),$o),$o),ord_less_eq(fun(fun(C,B),$o)),aa(fun(B,$o),fun(fun(C,B),$o),basic_pred_fun(C,B,aTP_Lamp_ahl(C,$o)),Pa)),aa(fun(B,$o),fun(fun(C,B),$o),basic_pred_fun(C,B,aTP_Lamp_ahl(C,$o)),Paa)) ) ).

% fun.pred_mono
tff(fact_4568_pred__fun__True__id,axiom,
    ! [B: $tType,C: $tType,D: $tType,P3: fun(C,$o),F2: fun(D,C)] :
      ( nO_MATCH(fun(B,B),fun(C,$o),id(B),P3)
     => ( aa(fun(D,C),$o,aa(fun(C,$o),fun(fun(D,C),$o),basic_pred_fun(D,C,aTP_Lamp_ahp(D,$o)),P3),F2)
      <=> aa(fun(D,$o),$o,aa(fun($o,$o),fun(fun(D,$o),$o),basic_pred_fun(D,$o,aTP_Lamp_ahp(D,$o)),id($o)),aa(fun(D,C),fun(D,$o),comp(C,$o,D,P3),F2)) ) ) ).

% pred_fun_True_id
tff(fact_4569_MOST__iff__finiteNeg,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( eventually(B,Pa,cofinite(B))
    <=> aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa))) ) ).

% MOST_iff_finiteNeg
tff(fact_4570_eventually__cofinite,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( eventually(B,Pa,cofinite(B))
    <=> aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa))) ) ).

% eventually_cofinite
tff(fact_4571_MOST__SucD,axiom,
    ! [Pa: fun(nat,$o)] :
      ( eventually(nat,aTP_Lamp_xd(fun(nat,$o),fun(nat,$o),Pa),cofinite(nat))
     => eventually(nat,Pa,cofinite(nat)) ) ).

% MOST_SucD
tff(fact_4572_MOST__SucI,axiom,
    ! [Pa: fun(nat,$o)] :
      ( eventually(nat,Pa,cofinite(nat))
     => eventually(nat,aTP_Lamp_xd(fun(nat,$o),fun(nat,$o),Pa),cofinite(nat)) ) ).

% MOST_SucI
tff(fact_4573_MOST__Suc__iff,axiom,
    ! [Pa: fun(nat,$o)] :
      ( eventually(nat,aTP_Lamp_xd(fun(nat,$o),fun(nat,$o),Pa),cofinite(nat))
    <=> eventually(nat,Pa,cofinite(nat)) ) ).

% MOST_Suc_iff
tff(fact_4574_MOST__nat,axiom,
    ! [Pa: fun(nat,$o)] :
      ( eventually(nat,Pa,cofinite(nat))
    <=> ? [M4: nat] :
        ! [N4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N4)
         => aa(nat,$o,Pa,N4) ) ) ).

% MOST_nat
tff(fact_4575_MOST__ge__nat,axiom,
    ! [M2: nat] : eventually(nat,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),cofinite(nat)) ).

% MOST_ge_nat
tff(fact_4576_MOST__nat__le,axiom,
    ! [Pa: fun(nat,$o)] :
      ( eventually(nat,Pa,cofinite(nat))
    <=> ? [M4: nat] :
        ! [N4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N4)
         => aa(nat,$o,Pa,N4) ) ) ).

% MOST_nat_le
tff(fact_4577_fun_Opred__cong,axiom,
    ! [C: $tType,B: $tType,X2: fun(B,C),Ya2: fun(B,C),Pa: fun(C,$o),Paa: fun(C,$o)] :
      ( ( X2 = Ya2 )
     => ( ! [Z3: C] :
            ( aa(set(C),$o,member(C,Z3),aa(set(B),set(C),image2(B,C,Ya2),top_top(set(B))))
           => ( aa(C,$o,Pa,Z3)
            <=> aa(C,$o,Paa,Z3) ) )
       => ( aa(fun(B,C),$o,aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,aTP_Lamp_nh(B,$o)),Pa),X2)
        <=> aa(fun(B,C),$o,aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,aTP_Lamp_nh(B,$o)),Paa),Ya2) ) ) ) ).

% fun.pred_cong
tff(fact_4578_fun_Opred__mono__strong,axiom,
    ! [C: $tType,B: $tType,Pa: fun(C,$o),X2: fun(B,C),Paa: fun(C,$o)] :
      ( aa(fun(B,C),$o,aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,aTP_Lamp_nh(B,$o)),Pa),X2)
     => ( ! [Z3: C] :
            ( aa(set(C),$o,member(C,Z3),aa(set(B),set(C),image2(B,C,X2),top_top(set(B))))
           => ( aa(C,$o,Pa,Z3)
             => aa(C,$o,Paa,Z3) ) )
       => aa(fun(B,C),$o,aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,aTP_Lamp_nh(B,$o)),Paa),X2) ) ) ).

% fun.pred_mono_strong
tff(fact_4579_cofinite__def,axiom,
    ! [B: $tType] : ( cofinite(B) = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),aTP_Lamp_ahq(fun(B,$o),$o)) ) ).

% cofinite_def
tff(fact_4580_fun_Opred__transfer,axiom,
    ! [B: $tType,C: $tType,D: $tType,R: fun(B,fun(C,$o))] : aa(fun(fun(C,$o),fun(fun(D,C),$o)),$o,aa(fun(fun(B,$o),fun(fun(D,B),$o)),fun(fun(fun(C,$o),fun(fun(D,C),$o)),$o),bNF_rel_fun(fun(B,$o),fun(C,$o),fun(fun(D,B),$o),fun(fun(D,C),$o),bNF_rel_fun(B,C,$o,$o,R,fequal($o)),bNF_rel_fun(fun(D,B),fun(D,C),$o,$o,bNF_rel_fun(D,D,B,C,fequal(D),R),fequal($o))),basic_pred_fun(D,B,aTP_Lamp_ahp(D,$o))),basic_pred_fun(D,C,aTP_Lamp_ahp(D,$o))) ).

% fun.pred_transfer
tff(fact_4581_mset__set__empty__iff,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ( mset_set(B,A3) = zero_zero(multiset(B)) )
    <=> ( ( A3 = bot_bot(set(B)) )
        | ~ aa(set(B),$o,finite_finite2(B),A3) ) ) ).

% mset_set_empty_iff
tff(fact_4582_fun_Opred__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,Qa: fun(C,$o),F2: fun(D,C),X2: fun(B,D)] :
      ( aa(fun(B,C),$o,aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,aTP_Lamp_nh(B,$o)),Qa),aa(fun(B,D),fun(B,C),comp(D,C,B,F2),X2))
    <=> aa(fun(B,D),$o,aa(fun(D,$o),fun(fun(B,D),$o),basic_pred_fun(B,D,aTP_Lamp_nh(B,$o)),aa(fun(D,C),fun(D,$o),comp(C,$o,D,Qa),F2)),X2) ) ).

% fun.pred_map
tff(fact_4583_MOST__finite__Ball__distrib,axiom,
    ! [B: $tType,C: $tType,A3: set(B),Pa: fun(B,fun(C,$o))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( eventually(C,aa(fun(B,fun(C,$o)),fun(C,$o),aTP_Lamp_ahr(set(B),fun(fun(B,fun(C,$o)),fun(C,$o)),A3),Pa),cofinite(C))
      <=> ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),A3)
           => eventually(C,aa(B,fun(C,$o),Pa,X3),cofinite(C)) ) ) ) ).

% MOST_finite_Ball_distrib
tff(fact_4584_MOST__inj,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),F2: fun(C,B)] :
      ( eventually(B,Pa,cofinite(B))
     => ( inj_on(C,B,F2,top_top(set(C)))
       => eventually(C,aa(fun(C,B),fun(C,$o),aTP_Lamp_nm(fun(B,$o),fun(fun(C,B),fun(C,$o)),Pa),F2),cofinite(C)) ) ) ).

% MOST_inj
tff(fact_4585_mset__set_Oinsert__remove,axiom,
    ! [B: $tType,A3: set(B),X2: B] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( mset_set(B,aa(set(B),set(B),insert(B,X2),A3)) = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X2),mset_set(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ).

% mset_set.insert_remove
tff(fact_4586_mset__set_Oremove,axiom,
    ! [B: $tType,A3: set(B),X2: B] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),$o,member(B,X2),A3)
       => ( mset_set(B,A3) = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X2),mset_set(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ).

% mset_set.remove
tff(fact_4587_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [B: $tType,C: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),S: set(C),F2: fun(C,B),X2: C,A3: set(C)] :
      ( folding_insort_key(B,C,Less_eq,Less,S,F2)
     => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(C),set(C),insert(C,X2),A3)),S)
       => ( aa(set(C),$o,finite_finite2(C),A3)
         => ( sorted8670434370408473282of_set(B,C,Less_eq,F2,aa(set(C),set(C),insert(C,X2),A3)) = insort_key(B,C,Less_eq,F2,X2,sorted8670434370408473282of_set(B,C,Less_eq,F2,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A3),aa(set(C),set(C),insert(C,X2),bot_bot(set(C)))))) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
tff(fact_4588_cr__integer__def,axiom,
    ! [X4: int,Xa3: code_integer] :
      ( code_cr_integer(X4,Xa3)
    <=> ( X4 = aa(code_integer,int,code_int_of_integer,Xa3) ) ) ).

% cr_integer_def
tff(fact_4589_sum__multiset__singleton,axiom,
    ! [B: $tType,A3: set(B)] : ( aa(set(B),multiset(B),aa(fun(B,multiset(B)),fun(set(B),multiset(B)),groups7311177749621191930dd_sum(B,multiset(B)),aTP_Lamp_ahs(B,multiset(B))),A3) = mset_set(B,A3) ) ).

% sum_multiset_singleton
tff(fact_4590_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [B: $tType,C: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),S: set(C),F2: fun(C,B),X2: C,A3: set(C)] :
      ( folding_insort_key(B,C,Less_eq,Less,S,F2)
     => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(C),set(C),insert(C,X2),A3)),S)
       => ( aa(set(C),$o,finite_finite2(C),A3)
         => ( sorted8670434370408473282of_set(B,C,Less_eq,F2,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A3),aa(set(C),set(C),insert(C,X2),bot_bot(set(C))))) = remove1(C,X2,sorted8670434370408473282of_set(B,C,Less_eq,F2,A3)) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
tff(fact_4591_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [B: $tType,C: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),S: set(C),F2: fun(C,B),A3: set(C)] :
      ( folding_insort_key(B,C,Less_eq,Less,S,F2)
     => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),A3),S)
       => ( aa(set(C),$o,finite_finite2(C),A3)
         => ( ( sorted8670434370408473282of_set(B,C,Less_eq,F2,A3) = nil(C) )
          <=> ( A3 = bot_bot(set(C)) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
tff(fact_4592_at__most__one__mset__mset__diff,axiom,
    ! [B: $tType,A4: B,M: multiset(B)] :
      ( ~ aa(set(B),$o,member(B,A4),aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),M),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A4),zero_zero(multiset(B))))))
     => ( aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),M),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A4),zero_zero(multiset(B))))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(multiset(B),set(B),set_mset(B),M)),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) ) ) ).

% at_most_one_mset_mset_diff
tff(fact_4593_set__mset__empty,axiom,
    ! [B: $tType] : ( aa(multiset(B),set(B),set_mset(B),zero_zero(multiset(B))) = bot_bot(set(B)) ) ).

% set_mset_empty
tff(fact_4594_set__mset__eq__empty__iff,axiom,
    ! [B: $tType,M: multiset(B)] :
      ( ( aa(multiset(B),set(B),set_mset(B),M) = bot_bot(set(B)) )
    <=> ( M = zero_zero(multiset(B)) ) ) ).

% set_mset_eq_empty_iff
tff(fact_4595_in__Inf__multiset__iff,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: B] :
      ( ( A3 != bot_bot(set(multiset(B))) )
     => ( aa(set(B),$o,member(B,X2),aa(multiset(B),set(B),set_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A3)))
      <=> ! [X3: multiset(B)] :
            ( aa(set(multiset(B)),$o,member(multiset(B),X3),A3)
           => aa(set(B),$o,member(B,X2),aa(multiset(B),set(B),set_mset(B),X3)) ) ) ) ).

% in_Inf_multiset_iff
tff(fact_4596_infinite__set__mset__mset__set,axiom,
    ! [B: $tType,A3: set(B)] :
      ( ~ aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(multiset(B),set(B),set_mset(B),mset_set(B,A3)) = bot_bot(set(B)) ) ) ).

% infinite_set_mset_mset_set
tff(fact_4597_set__mset__Inf,axiom,
    ! [B: $tType,A3: set(multiset(B))] :
      ( ( A3 != bot_bot(set(multiset(B))) )
     => ( aa(multiset(B),set(B),set_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A3)) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(multiset(B)),set(set(B)),image2(multiset(B),set(B),set_mset(B)),A3)) ) ) ).

% set_mset_Inf
tff(fact_4598_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [B: $tType,C: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),S: set(C),F2: fun(C,B)] :
      ( folding_insort_key(B,C,Less_eq,Less,S,F2)
     => ( sorted8670434370408473282of_set(B,C,Less_eq,F2,bot_bot(set(C))) = nil(C) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
tff(fact_4599_set__mset__single,axiom,
    ! [B: $tType,B3: B] : ( aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),B3),zero_zero(multiset(B)))) = aa(set(B),set(B),insert(B,B3),bot_bot(set(B))) ) ).

% set_mset_single
tff(fact_4600_mult1__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( mult1(B,R2) = aa(fun(product_prod(multiset(B),multiset(B)),$o),set(product_prod(multiset(B),multiset(B))),collect(product_prod(multiset(B),multiset(B))),aa(fun(multiset(B),fun(multiset(B),$o)),fun(product_prod(multiset(B),multiset(B)),$o),product_case_prod(multiset(B),multiset(B),$o),aTP_Lamp_aht(set(product_prod(B,B)),fun(multiset(B),fun(multiset(B),$o)),R2))) ) ).

% mult1_def
tff(fact_4601_sum__wcount__Int,axiom,
    ! [B: $tType,A3: set(B),F2: fun(B,nat),N3: multiset(B)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),wcount(B,F2,N3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(multiset(B),set(B),set_mset(B),N3))) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),wcount(B,F2,N3)),A3) ) ) ).

% sum_wcount_Int
tff(fact_4602_set__mset__replicate__mset__subset,axiom,
    ! [B: $tType,N: nat,X2: B] :
      ( aa(multiset(B),set(B),set_mset(B),replicate_mset(B,N,X2))
      = $ite(N = zero_zero(nat),bot_bot(set(B)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) ) ).

% set_mset_replicate_mset_subset
tff(fact_4603_mult1__lessE,axiom,
    ! [B: $tType,N3: multiset(B),M: multiset(B),R2: fun(B,fun(B,$o))] :
      ( aa(set(product_prod(multiset(B),multiset(B))),$o,member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),N3),M)),mult1(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2))))
     => ( asymp(B,R2)
       => ~ ! [A5: B,M0: multiset(B)] :
              ( ( M = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A5),M0) )
             => ! [K6: multiset(B)] :
                  ( ( N3 = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),M0),K6) )
                 => ( ~ aa(set(B),$o,member(B,A5),aa(multiset(B),set(B),set_mset(B),K6))
                   => ~ ! [B10: B] :
                          ( aa(set(B),$o,member(B,B10),aa(multiset(B),set(B),set_mset(B),K6))
                         => aa(B,$o,aa(B,fun(B,$o),R2,B10),A5) ) ) ) ) ) ) ).

% mult1_lessE
tff(fact_4604_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),list(B),linord4507533701916653071of_set(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))) = remove1(B,X2,aa(set(B),list(B),linord4507533701916653071of_set(B),A3)) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
tff(fact_4605_Pow__set_I1_J,axiom,
    ! [B: $tType] : ( pow(B,aa(list(B),set(B),set2(B),nil(B))) = aa(set(set(B)),set(set(B)),insert(set(B),bot_bot(set(B))),bot_bot(set(set(B)))) ) ).

% Pow_set(1)
tff(fact_4606_set__empty,axiom,
    ! [B: $tType,Xs: list(B)] :
      ( ( aa(list(B),set(B),set2(B),Xs) = bot_bot(set(B)) )
    <=> ( Xs = nil(B) ) ) ).

% set_empty
tff(fact_4607_set__empty2,axiom,
    ! [B: $tType,Xs: list(B)] :
      ( ( bot_bot(set(B)) = aa(list(B),set(B),set2(B),Xs) )
    <=> ( Xs = nil(B) ) ) ).

% set_empty2
tff(fact_4608_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( aa(set(B),list(B),linord4507533701916653071of_set(B),bot_bot(set(B))) = nil(B) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
tff(fact_4609_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( aa(set(B),list(B),linord4507533701916653071of_set(B),A3) = nil(B) )
          <=> ( A3 = bot_bot(set(B)) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
tff(fact_4610_empty__set,axiom,
    ! [B: $tType] : ( bot_bot(set(B)) = aa(list(B),set(B),set2(B),nil(B)) ) ).

% empty_set
tff(fact_4611_asymp__greater,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => asymp(B,aTP_Lamp_aaa(B,fun(B,$o))) ) ).

% asymp_greater
tff(fact_4612_card__lists__length__le,axiom,
    ! [B: $tType,A3: set(B),N: nat] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(list(B)),nat,finite_card(list(B)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(nat,fun(list(B),$o),aTP_Lamp_ahu(set(B),fun(nat,fun(list(B),$o)),A3),N))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(set(B),nat,finite_card(B),A3))),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% card_lists_length_le
tff(fact_4613_set__removeAll,axiom,
    ! [B: $tType,X2: B,Xs: list(B)] : ( aa(list(B),set(B),set2(B),aa(list(B),list(B),removeAll(B,X2),Xs)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) ) ).

% set_removeAll
tff(fact_4614_set__list__bind,axiom,
    ! [B: $tType,C: $tType,Xs: list(C),F2: fun(C,list(B))] : ( aa(list(B),set(B),set2(B),bind(C,B,Xs,F2)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_ahv(fun(C,list(B)),fun(C,set(B)),F2)),aa(list(C),set(C),set2(C),Xs))) ) ).

% set_list_bind
tff(fact_4615_finite__lists__length__eq,axiom,
    ! [B: $tType,A3: set(B),N: nat] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => aa(set(list(B)),$o,finite_finite2(list(B)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(nat,fun(list(B),$o),aTP_Lamp_ahw(set(B),fun(nat,fun(list(B),$o)),A3),N))) ) ).

% finite_lists_length_eq
tff(fact_4616_finite__lists__length__le,axiom,
    ! [B: $tType,A3: set(B),N: nat] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => aa(set(list(B)),$o,finite_finite2(list(B)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(nat,fun(list(B),$o),aTP_Lamp_ahu(set(B),fun(nat,fun(list(B),$o)),A3),N))) ) ).

% finite_lists_length_le
tff(fact_4617_card__lists__length__eq,axiom,
    ! [B: $tType,A3: set(B),N: nat] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(set(list(B)),nat,finite_card(list(B)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(nat,fun(list(B),$o),aTP_Lamp_ahw(set(B),fun(nat,fun(list(B),$o)),A3),N))) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(set(B),nat,finite_card(B),A3)),N) ) ) ).

% card_lists_length_eq
tff(fact_4618_card__lists__distinct__length__eq,axiom,
    ! [B: $tType,A3: set(B),K: nat] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(set(B),nat,finite_card(B),A3))
       => ( aa(set(list(B)),nat,finite_card(list(B)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(nat,fun(list(B),$o),aTP_Lamp_ahx(set(B),fun(nat,fun(list(B),$o)),A3),K))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_vw(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,finite_card(B),A3)),K)),one_one(nat)),aa(set(B),nat,finite_card(B),A3))) ) ) ) ).

% card_lists_distinct_length_eq
tff(fact_4619_card__lists__distinct__length__eq_H,axiom,
    ! [B: $tType,K: nat,A3: set(B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(set(B),nat,finite_card(B),A3))
     => ( aa(set(list(B)),nat,finite_card(list(B)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(set(B),fun(list(B),$o),aTP_Lamp_ahy(nat,fun(set(B),fun(list(B),$o)),K),A3))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_vw(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,finite_card(B),A3)),K)),one_one(nat)),aa(set(B),nat,finite_card(B),A3))) ) ) ).

% card_lists_distinct_length_eq'
tff(fact_4620_card__disjoint__shuffles,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
     => ( aa(set(list(B)),nat,finite_card(list(B)),shuffles(B,Xs,Ys)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(B),nat,size_size(list(B)),Xs)),aa(list(B),nat,size_size(list(B)),Ys))),aa(list(B),nat,size_size(list(B)),Xs)) ) ) ).

% card_disjoint_shuffles
tff(fact_4621_set__remove1__eq,axiom,
    ! [B: $tType,Xs: list(B),X2: B] :
      ( distinct(B,Xs)
     => ( aa(list(B),set(B),set2(B),remove1(B,X2,Xs)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) ) ) ).

% set_remove1_eq
tff(fact_4622_finite__lists__distinct__length__eq,axiom,
    ! [B: $tType,A3: set(B),N: nat] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => aa(set(list(B)),$o,finite_finite2(list(B)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(nat,fun(list(B),$o),aTP_Lamp_ahx(set(B),fun(nat,fun(list(B),$o)),A3),N))) ) ).

% finite_lists_distinct_length_eq
tff(fact_4623_shuffles_Osimps_I2_J,axiom,
    ! [B: $tType,Xs: list(B)] : ( shuffles(B,Xs,nil(B)) = aa(set(list(B)),set(list(B)),insert(list(B),Xs),bot_bot(set(list(B)))) ) ).

% shuffles.simps(2)
tff(fact_4624_shuffles_Osimps_I1_J,axiom,
    ! [B: $tType,Ys: list(B)] : ( shuffles(B,nil(B),Ys) = aa(set(list(B)),set(list(B)),insert(list(B),Ys),bot_bot(set(list(B)))) ) ).

% shuffles.simps(1)
tff(fact_4625_distinct__disjoint__shuffles,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Zs: list(B)] :
      ( distinct(B,Xs)
     => ( distinct(B,Ys)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
         => ( aa(set(list(B)),$o,member(list(B),Zs),shuffles(B,Xs,Ys))
           => distinct(B,Zs) ) ) ) ) ).

% distinct_disjoint_shuffles
tff(fact_4626_distinct__finite__set,axiom,
    ! [B: $tType,X2: set(B)] : aa(set(list(B)),$o,finite_finite2(list(B)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aTP_Lamp_ahz(set(B),fun(list(B),$o),X2))) ).

% distinct_finite_set
tff(fact_4627_distinct__finite__subset,axiom,
    ! [B: $tType,X2: set(B)] :
      ( aa(set(B),$o,finite_finite2(B),X2)
     => aa(set(list(B)),$o,finite_finite2(list(B)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aTP_Lamp_aia(set(B),fun(list(B),$o),X2))) ) ).

% distinct_finite_subset
tff(fact_4628_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),list(B),linord4507533701916653071of_set(B),aa(set(B),set(B),insert(B,X2),A3)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),X2),aa(set(B),list(B),linord4507533701916653071of_set(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
tff(fact_4629_set__map__filter,axiom,
    ! [B: $tType,C: $tType,G: fun(C,option(B)),Xs: list(C)] : ( aa(list(B),set(B),set2(B),map_filter(C,B,G,Xs)) = aa(fun(B,$o),set(B),collect(B),aa(list(C),fun(B,$o),aTP_Lamp_aib(fun(C,option(B)),fun(list(C),fun(B,$o)),G),Xs)) ) ).

% set_map_filter
tff(fact_4630_distinct__foldl__invar,axiom,
    ! [C: $tType,B: $tType,S: list(B),I: fun(set(B),fun(C,$o)),Sigma_0: C,F2: fun(C,fun(B,C))] :
      ( distinct(B,S)
     => ( aa(C,$o,aa(set(B),fun(C,$o),I,aa(list(B),set(B),set2(B),S)),Sigma_0)
       => ( ! [X: B,It: set(B),Sigma: C] :
              ( aa(set(B),$o,member(B,X),It)
             => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),It),aa(list(B),set(B),set2(B),S))
               => ( aa(C,$o,aa(set(B),fun(C,$o),I,It),Sigma)
                 => aa(C,$o,aa(set(B),fun(C,$o),I,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),It),aa(set(B),set(B),insert(B,X),bot_bot(set(B))))),aa(B,C,aa(C,fun(B,C),F2,Sigma),X)) ) ) )
         => aa(C,$o,aa(set(B),fun(C,$o),I,bot_bot(set(B))),foldl(C,B,F2,Sigma_0,S)) ) ) ) ).

% distinct_foldl_invar
tff(fact_4631_foldl__length,axiom,
    ! [B: $tType,L: list(B)] : ( foldl(nat,B,aTP_Lamp_aic(nat,fun(B,nat)),zero_zero(nat),L) = aa(list(B),nat,size_size(list(B)),L) ) ).

% foldl_length
tff(fact_4632_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ~ aa(set(B),$o,member(B,X2),A3)
           => ( aa(set(B),list(B),linord4507533701916653071of_set(B),aa(set(B),set(B),insert(B,X2),A3)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),X2),aa(set(B),list(B),linord4507533701916653071of_set(B),A3)) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
tff(fact_4633_insort__left__comm,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Y: B,Xs: list(B)] : ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),Y),Xs)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),Y),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),X2),Xs)) ) ) ).

% insort_left_comm
tff(fact_4634_comp__fun__commute__insort,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => finite6289374366891150609ommute(B,list(B),linorder_insort_key(B,B,aTP_Lamp_eh(B,B))) ) ).

% comp_fun_commute_insort
tff(fact_4635_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Y: B,X2: B] : ( aa(fun(list(B),list(B)),fun(list(B),list(B)),comp(list(B),list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),Y)),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),X2)) = aa(fun(list(B),list(B)),fun(list(B),list(B)),comp(list(B),list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),X2)),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),Y)) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
tff(fact_4636_sorted__list__of__set_Ofold__insort__key_Ofolding__on__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => finite_folding_on(B,list(B),top_top(set(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B))) ) ).

% sorted_list_of_set.fold_insort_key.folding_on_axioms
tff(fact_4637_comp__fun__commute_Ofoldl__f__commute,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(C,C)),A4: B,B3: C,Xs: list(B)] :
      ( finite6289374366891150609ommute(B,C,F2)
     => ( aa(C,C,aa(B,fun(C,C),F2,A4),foldl(C,B,aTP_Lamp_aid(fun(B,fun(C,C)),fun(C,fun(B,C)),F2),B3,Xs)) = foldl(C,B,aTP_Lamp_aid(fun(B,fun(C,C)),fun(C,fun(B,C)),F2),aa(C,C,aa(B,fun(C,C),F2,A4),B3),Xs) ) ) ).

% comp_fun_commute.foldl_f_commute
tff(fact_4638_fst__foldl,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(B,fun(D,B)),G: fun(B,fun(C,fun(D,C))),A4: B,B3: C,Xs: list(D)] : ( aa(product_prod(B,C),B,product_fst(B,C),foldl(product_prod(B,C),D,aa(fun(B,fun(C,fun(D,product_prod(B,C)))),fun(product_prod(B,C),fun(D,product_prod(B,C))),product_case_prod(B,C,fun(D,product_prod(B,C))),aa(fun(B,fun(C,fun(D,C))),fun(B,fun(C,fun(D,product_prod(B,C)))),aTP_Lamp_aie(fun(B,fun(D,B)),fun(fun(B,fun(C,fun(D,C))),fun(B,fun(C,fun(D,product_prod(B,C))))),F2),G)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B3),Xs)) = foldl(B,D,F2,A4,Xs) ) ).

% fst_foldl
tff(fact_4639_foldl__absorb1,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [X2: B,Zs: list(B)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),X2),foldl(B,B,times_times(B),one_one(B),Zs)) = foldl(B,B,times_times(B),X2,Zs) ) ) ).

% foldl_absorb1
tff(fact_4640_foldl__un__empty__eq,axiom,
    ! [B: $tType,I2: set(B),Ww: list(set(B))] : ( foldl(set(B),set(B),sup_sup(set(B)),I2,Ww) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),I2),foldl(set(B),set(B),sup_sup(set(B)),bot_bot(set(B)),Ww)) ) ).

% foldl_un_empty_eq
tff(fact_4641_sorted__list__of__set_Ofold__insort__key_Oeq__fold,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B)] : ( aa(set(B),list(B),linord4507533701916653071of_set(B),A3) = finite_fold(B,list(B),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),nil(B),A3) ) ) ).

% sorted_list_of_set.fold_insort_key.eq_fold
tff(fact_4642_foldl__set,axiom,
    ! [B: $tType,L: list(set(B))] : ( foldl(set(B),set(B),sup_sup(set(B)),bot_bot(set(B)),L) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_aif(list(set(B)),fun(set(B),$o),L))) ) ).

% foldl_set
tff(fact_4643_foldl__length__aux,axiom,
    ! [B: $tType,A4: nat,L: list(B)] : ( foldl(nat,B,aTP_Lamp_aic(nat,fun(B,nat)),A4,L) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),aa(list(B),nat,size_size(list(B)),L)) ) ).

% foldl_length_aux
tff(fact_4644_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B),X2: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),$o,member(B,X2),A3)
           => ( aa(set(B),list(B),linord4507533701916653071of_set(B),A3) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),X2),aa(set(B),list(B),linord4507533701916653071of_set(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
tff(fact_4645_listset_Osimps_I1_J,axiom,
    ! [B: $tType] : ( listset(B,nil(set(B))) = aa(set(list(B)),set(list(B)),insert(list(B),nil(B)),bot_bot(set(list(B)))) ) ).

% listset.simps(1)
tff(fact_4646_sorted__list__of__multiset__insert,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,M: multiset(B)] : ( linord6283353356039996273ltiset(B,aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X2),M)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),X2),linord6283353356039996273ltiset(B,M)) ) ) ).

% sorted_list_of_multiset_insert
tff(fact_4647_set__n__lists,axiom,
    ! [B: $tType,N: nat,Xs: list(B)] : ( aa(list(list(B)),set(list(B)),set2(list(B)),n_lists(B,N,Xs)) = aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(list(B),fun(list(B),$o),aTP_Lamp_aig(nat,fun(list(B),fun(list(B),$o)),N),Xs)) ) ).

% set_n_lists
tff(fact_4648_distinct__n__lists,axiom,
    ! [B: $tType,Xs: list(B),N: nat] :
      ( distinct(B,Xs)
     => distinct(list(B),n_lists(B,N,Xs)) ) ).

% distinct_n_lists
tff(fact_4649_length__n__lists,axiom,
    ! [B: $tType,N: nat,Xs: list(B)] : ( aa(list(list(B)),nat,size_size(list(list(B))),n_lists(B,N,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(list(B),nat,size_size(list(B)),Xs)),N) ) ).

% length_n_lists
tff(fact_4650_sorted__list__of__set__def,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( linord4507533701916653071of_set(B) = linord144544945434240204of_set(B,B,aTP_Lamp_eh(B,B)) ) ) ).

% sorted_list_of_set_def
tff(fact_4651_distinct__concat__iff,axiom,
    ! [B: $tType,Xs: list(list(B))] :
      ( distinct(B,concat(B,Xs))
    <=> ( distinct(list(B),aa(list(list(B)),list(list(B)),removeAll(list(B),nil(B)),Xs))
        & ! [Ys2: list(B)] :
            ( aa(set(list(B)),$o,member(list(B),Ys2),aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
           => distinct(B,Ys2) )
        & ! [Ys2: list(B),Zs2: list(B)] :
            ( ( aa(set(list(B)),$o,member(list(B),Ys2),aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
              & aa(set(list(B)),$o,member(list(B),Zs2),aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
              & ( Ys2 != Zs2 ) )
           => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Ys2)),aa(list(B),set(B),set2(B),Zs2)) = bot_bot(set(B)) ) ) ) ) ).

% distinct_concat_iff
tff(fact_4652_set__product,axiom,
    ! [B: $tType,C: $tType,Xs: list(B),Ys: list(C)] : ( aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),product(B,C,Xs,Ys)) = product_Sigma(B,C,aa(list(B),set(B),set2(B),Xs),aTP_Lamp_aih(list(C),fun(B,set(C)),Ys)) ) ).

% set_product
tff(fact_4653_set__concat,axiom,
    ! [B: $tType,Xs: list(list(B))] : ( aa(list(B),set(B),set2(B),concat(B,Xs)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(list(B)),set(set(B)),image2(list(B),set(B),set2(B)),aa(list(list(B)),set(list(B)),set2(list(B)),Xs))) ) ).

% set_concat
tff(fact_4654_distinct__concat,axiom,
    ! [B: $tType,Xs: list(list(B))] :
      ( distinct(list(B),Xs)
     => ( ! [Ys3: list(B)] :
            ( aa(set(list(B)),$o,member(list(B),Ys3),aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
           => distinct(B,Ys3) )
       => ( ! [Ys3: list(B),Zs3: list(B)] :
              ( aa(set(list(B)),$o,member(list(B),Ys3),aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
             => ( aa(set(list(B)),$o,member(list(B),Zs3),aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
               => ( ( Ys3 != Zs3 )
                 => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Ys3)),aa(list(B),set(B),set2(B),Zs3)) = bot_bot(set(B)) ) ) ) )
         => distinct(B,concat(B,Xs)) ) ) ) ).

% distinct_concat
tff(fact_4655_distinct__concat_H,axiom,
    ! [B: $tType,Xs: list(list(B))] :
      ( distinct(list(B),aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_aii(list(B),$o)),Xs))
     => ( ! [Ys3: list(B)] :
            ( aa(set(list(B)),$o,member(list(B),Ys3),aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
           => distinct(B,Ys3) )
       => ( ! [Ys3: list(B),Zs3: list(B)] :
              ( aa(set(list(B)),$o,member(list(B),Ys3),aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
             => ( aa(set(list(B)),$o,member(list(B),Zs3),aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
               => ( ( Ys3 != Zs3 )
                 => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Ys3)),aa(list(B),set(B),set2(B),Zs3)) = bot_bot(set(B)) ) ) ) )
         => distinct(B,concat(B,Xs)) ) ) ) ).

% distinct_concat'
tff(fact_4656_length__remdups__concat,axiom,
    ! [B: $tType,Xss: list(list(B))] : ( aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),remdups(B),concat(B,Xss))) = aa(set(B),nat,finite_card(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(list(B)),set(set(B)),image2(list(B),set(B),set2(B)),aa(list(list(B)),set(list(B)),set2(list(B)),Xss)))) ) ).

% length_remdups_concat
tff(fact_4657_sorted__list__of__set__nonempty,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( aa(set(B),list(B),linord4507533701916653071of_set(B),A3) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),aa(set(B),B,lattic643756798350308766er_Min(B),A3)),aa(set(B),list(B),linord4507533701916653071of_set(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,aa(set(B),B,lattic643756798350308766er_Min(B),A3)),bot_bot(set(B)))))) ) ) ) ) ).

% sorted_list_of_set_nonempty
tff(fact_4658_filter__filter,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o),Xs: list(B)] : ( aa(list(B),list(B),filter2(B,Pa),aa(list(B),list(B),filter2(B,Qa),Xs)) = aa(list(B),list(B),filter2(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aij(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa)),Xs) ) ).

% filter_filter
tff(fact_4659_set__filter,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B)] : ( aa(list(B),set(B),set2(B),aa(list(B),list(B),filter2(B,Pa),Xs)) = aa(fun(B,$o),set(B),collect(B),aa(list(B),fun(B,$o),aTP_Lamp_aik(fun(B,$o),fun(list(B),fun(B,$o)),Pa),Xs)) ) ).

% set_filter
tff(fact_4660_removeAll__filter__not__eq,axiom,
    ! [B: $tType,X2: B] : ( removeAll(B,X2) = filter2(B,aa(B,fun(B,$o),aTP_Lamp_adk(B,fun(B,$o)),X2)) ) ).

% removeAll_filter_not_eq
tff(fact_4661_partition__in__shuffles,axiom,
    ! [B: $tType,Xs: list(B),Pa: fun(B,$o)] : aa(set(list(B)),$o,member(list(B),Xs),shuffles(B,aa(list(B),list(B),filter2(B,Pa),Xs),aa(list(B),list(B),filter2(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa)),Xs))) ).

% partition_in_shuffles
tff(fact_4662_inj__split__Cons,axiom,
    ! [B: $tType,X5: set(product_prod(list(B),B))] : inj_on(product_prod(list(B),B),list(B),aa(fun(list(B),fun(B,list(B))),fun(product_prod(list(B),B),list(B)),product_case_prod(list(B),B,list(B)),aTP_Lamp_ail(list(B),fun(B,list(B)))),X5) ).

% inj_split_Cons
tff(fact_4663_map__filter__simps_I1_J,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,option(B)),X2: C,Xs: list(C)] : ( map_filter(C,B,F2,aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),X2),Xs)) = case_option(list(B),B,map_filter(C,B,F2,Xs),aa(list(C),fun(B,list(B)),aTP_Lamp_aim(fun(C,option(B)),fun(list(C),fun(B,list(B))),F2),Xs),aa(C,option(B),F2,X2)) ) ).

% map_filter_simps(1)
tff(fact_4664_sum__length__filter__compl,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B)] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),filter2(B,Pa),Xs))),aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),filter2(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa)),Xs))) = aa(list(B),nat,size_size(list(B)),Xs) ) ).

% sum_length_filter_compl
tff(fact_4665_inter__set__filter,axiom,
    ! [B: $tType,A3: set(B),Xs: list(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(list(B),set(B),set2(B),Xs)) = aa(list(B),set(B),set2(B),aa(list(B),list(B),filter2(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3)),Xs)) ) ).

% inter_set_filter
tff(fact_4666_concat__filter__neq__Nil,axiom,
    ! [B: $tType,Xs: list(list(B))] : ( concat(B,aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_aii(list(B),$o)),Xs)) = concat(B,Xs) ) ).

% concat_filter_neq_Nil
tff(fact_4667_ord_Olexordp_Omono,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o))] : order_mono(fun(list(B),fun(list(B),$o)),fun(list(B),fun(list(B),$o)),aTP_Lamp_ain(fun(B,fun(B,$o)),fun(fun(list(B),fun(list(B),$o)),fun(list(B),fun(list(B),$o))),Less)) ).

% ord.lexordp.mono
tff(fact_4668_inj__on__filter__key__eq,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),Y: B,Xs: list(B)] :
      ( inj_on(B,C,F2,aa(set(B),set(B),insert(B,Y),aa(list(B),set(B),set2(B),Xs)))
     => ( aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),aTP_Lamp_adm(fun(B,C),fun(B,fun(B,$o)),F2),Y)),Xs) = aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),fequal(B),Y)),Xs) ) ) ).

% inj_on_filter_key_eq
tff(fact_4669_lexordp_Omono,axiom,
    ! [B: $tType] :
      ( ord(B)
     => order_mono(fun(list(B),fun(list(B),$o)),fun(list(B),fun(list(B),$o)),aTP_Lamp_aio(fun(list(B),fun(list(B),$o)),fun(list(B),fun(list(B),$o)))) ) ).

% lexordp.mono
tff(fact_4670_set__minus__filter__out,axiom,
    ! [B: $tType,Xs: list(B),Y: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(set(B),set(B),insert(B,Y),bot_bot(set(B)))) = aa(list(B),set(B),set2(B),aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),aTP_Lamp_rx(B,fun(B,$o)),Y)),Xs)) ) ).

% set_minus_filter_out
tff(fact_4671_filter__shuffles__disjoint1_I2_J,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Zs: list(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
     => ( aa(set(list(B)),$o,member(list(B),Zs),shuffles(B,Xs,Ys))
       => ( aa(list(B),list(B),filter2(B,aTP_Lamp_aip(list(B),fun(B,$o),Xs)),Zs) = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
tff(fact_4672_filter__shuffles__disjoint1_I1_J,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Zs: list(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
     => ( aa(set(list(B)),$o,member(list(B),Zs),shuffles(B,Xs,Ys))
       => ( aa(list(B),list(B),filter2(B,aTP_Lamp_aiq(list(B),fun(B,$o),Xs)),Zs) = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
tff(fact_4673_filter__shuffles__disjoint2_I2_J,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Zs: list(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
     => ( aa(set(list(B)),$o,member(list(B),Zs),shuffles(B,Xs,Ys))
       => ( aa(list(B),list(B),filter2(B,aTP_Lamp_aip(list(B),fun(B,$o),Ys)),Zs) = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
tff(fact_4674_filter__shuffles__disjoint2_I1_J,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Zs: list(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
     => ( aa(set(list(B)),$o,member(list(B),Zs),shuffles(B,Xs,Ys))
       => ( aa(list(B),list(B),filter2(B,aTP_Lamp_aiq(list(B),fun(B,$o),Ys)),Zs) = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
tff(fact_4675_lists__length__Suc__eq,axiom,
    ! [B: $tType,A3: set(B),N: nat] : ( aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(nat,fun(list(B),$o),aTP_Lamp_air(set(B),fun(nat,fun(list(B),$o)),A3),N)) = aa(set(product_prod(list(B),B)),set(list(B)),image2(product_prod(list(B),B),list(B),aa(fun(list(B),fun(B,list(B))),fun(product_prod(list(B),B),list(B)),product_case_prod(list(B),B,list(B)),aTP_Lamp_ail(list(B),fun(B,list(B))))),product_Sigma(list(B),B,aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(nat,fun(list(B),$o),aTP_Lamp_ahw(set(B),fun(nat,fun(list(B),$o)),A3),N)),aTP_Lamp_ais(set(B),fun(list(B),set(B)),A3))) ) ).

% lists_length_Suc_eq
tff(fact_4676_distinct__length__filter,axiom,
    ! [B: $tType,Xs: list(B),Pa: fun(B,$o)] :
      ( distinct(B,Xs)
     => ( aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),filter2(B,Pa),Xs)) = aa(set(B),nat,finite_card(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(fun(B,$o),set(B),collect(B),Pa)),aa(list(B),set(B),set2(B),Xs))) ) ) ).

% distinct_length_filter
tff(fact_4677_shuffles_Oelims,axiom,
    ! [B: $tType,X2: list(B),Xa: list(B),Y: set(list(B))] :
      ( ( shuffles(B,X2,Xa) = Y )
     => ( ( ( X2 = nil(B) )
         => ( Y != aa(set(list(B)),set(list(B)),insert(list(B),Xa),bot_bot(set(list(B)))) ) )
       => ( ( ( Xa = nil(B) )
           => ( Y != aa(set(list(B)),set(list(B)),insert(list(B),X2),bot_bot(set(list(B)))) ) )
         => ~ ! [X: B,Xs2: list(B)] :
                ( ( X2 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2) )
               => ! [Y2: B,Ys3: list(B)] :
                    ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys3) )
                   => ( Y != aa(set(list(B)),set(list(B)),aa(set(list(B)),fun(set(list(B)),set(list(B))),sup_sup(set(list(B))),aa(set(list(B)),set(list(B)),image2(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X)),shuffles(B,Xs2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys3)))),aa(set(list(B)),set(list(B)),image2(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2)),shuffles(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2),Ys3))) ) ) ) ) ) ) ).

% shuffles.elims
tff(fact_4678_Pow__set_I2_J,axiom,
    ! [B: $tType,X2: B,Xs: list(B)] :
      ( pow(B,aa(list(B),set(B),set2(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)))
      = $let(
          a3: set(set(B)),
          a3 := pow(B,aa(list(B),set(B),set2(B),Xs)),
          aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),sup_sup(set(set(B))),a3),aa(set(set(B)),set(set(B)),image2(set(B),set(B),insert(B,X2)),a3)) ) ) ).

% Pow_set(2)
tff(fact_4679_set__Cons__sing__Nil,axiom,
    ! [B: $tType,A3: set(B)] : ( set_Cons(B,A3,aa(set(list(B)),set(list(B)),insert(list(B),nil(B)),bot_bot(set(list(B))))) = aa(set(B),set(list(B)),image2(B,list(B),aTP_Lamp_ait(B,list(B))),A3) ) ).

% set_Cons_sing_Nil
tff(fact_4680_transpose__aux__max,axiom,
    ! [B: $tType,C: $tType,Xs: list(B),Xss: list(list(C))] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,aa(list(B),nat,size_size(list(B)),Xs))),aa(nat,nat,foldr(list(C),nat,aTP_Lamp_aiu(list(C),fun(nat,nat)),Xss),zero_zero(nat))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(list(B),nat,size_size(list(B)),Xs)),aa(nat,nat,foldr(list(C),nat,aTP_Lamp_aiv(list(C),fun(nat,nat)),aa(list(list(C)),list(list(C)),filter2(list(C),aTP_Lamp_aiw(list(C),$o)),Xss)),zero_zero(nat)))) ) ).

% transpose_aux_max
tff(fact_4681_foldr__length,axiom,
    ! [B: $tType,L: list(B)] : ( aa(nat,nat,foldr(B,nat,aTP_Lamp_st(B,fun(nat,nat)),L),zero_zero(nat)) = aa(list(B),nat,size_size(list(B)),L) ) ).

% foldr_length
tff(fact_4682_foldr__filter,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,fun(B,B)),Pa: fun(C,$o),Xs: list(C)] : ( foldr(C,B,F2,aa(list(C),list(C),filter2(C,Pa),Xs)) = foldr(C,B,aa(fun(C,$o),fun(C,fun(B,B)),aTP_Lamp_aix(fun(C,fun(B,B)),fun(fun(C,$o),fun(C,fun(B,B))),F2),Pa),Xs) ) ).

% foldr_filter
tff(fact_4683_comp__fun__commute_Ofoldr__conv__foldl,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(C,C)),Xs: list(B),A4: C] :
      ( finite6289374366891150609ommute(B,C,F2)
     => ( aa(C,C,foldr(B,C,F2,Xs),A4) = foldl(C,B,aTP_Lamp_aid(fun(B,fun(C,C)),fun(C,fun(B,C)),F2),A4,Xs) ) ) ).

% comp_fun_commute.foldr_conv_foldl
tff(fact_4684_foldr__length__aux,axiom,
    ! [B: $tType,L: list(B),A4: nat] : ( aa(nat,nat,foldr(B,nat,aTP_Lamp_st(B,fun(nat,nat)),L),A4) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),aa(list(B),nat,size_size(list(B)),L)) ) ).

% foldr_length_aux
tff(fact_4685_set__Cons__def,axiom,
    ! [B: $tType,A3: set(B),XS: set(list(B))] : ( set_Cons(B,A3,XS) = aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(set(list(B)),fun(list(B),$o),aTP_Lamp_aiy(set(B),fun(set(list(B)),fun(list(B),$o)),A3),XS)) ) ).

% set_Cons_def
tff(fact_4686_transpose__max__length,axiom,
    ! [B: $tType,Xs: list(list(B))] : ( aa(nat,nat,foldr(list(B),nat,aTP_Lamp_aiz(list(B),fun(nat,nat)),transpose(B,Xs)),zero_zero(nat)) = aa(list(list(B)),nat,size_size(list(list(B))),aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_aii(list(B),$o)),Xs)) ) ).

% transpose_max_length
tff(fact_4687_listrel__Cons,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(C,B)),X2: C,Xs: list(C)] : ( aa(set(list(C)),set(list(B)),image(list(C),list(B),listrel(C,B,R2)),aa(set(list(C)),set(list(C)),insert(list(C),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),X2),Xs)),bot_bot(set(list(C))))) = set_Cons(B,aa(set(C),set(B),image(C,B,R2),aa(set(C),set(C),insert(C,X2),bot_bot(set(C)))),aa(set(list(C)),set(list(B)),image(list(C),list(B),listrel(C,B,R2)),aa(set(list(C)),set(list(C)),insert(list(C),Xs),bot_bot(set(list(C)))))) ) ).

% listrel_Cons
tff(fact_4688_arg__min__list_Oelims,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [X2: fun(B,C),Xa: list(B),Y: B] :
          ( ( arg_min_list(B,C,X2,Xa) = Y )
         => ( ! [X: B] :
                ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),nil(B)) )
               => ( Y != X ) )
           => ( ! [X: B,Y2: B,Zs3: list(B)] :
                  ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Zs3)) )
                 => ( Y
                   != $let(
                        m: B,
                        m := arg_min_list(B,C,X2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Zs3)),
                        $ite(aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,X2,X)),aa(B,C,X2,m)),X,m) ) ) )
             => ~ ( ( Xa = nil(B) )
                 => ( Y != undefined(B) ) ) ) ) ) ) ).

% arg_min_list.elims
tff(fact_4689_listrel__Nil,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(C,B))] : ( aa(set(list(C)),set(list(B)),image(list(C),list(B),listrel(C,B,R2)),aa(set(list(C)),set(list(C)),insert(list(C),nil(C)),bot_bot(set(list(C))))) = aa(set(list(B)),set(list(B)),insert(list(B),nil(B)),bot_bot(set(list(B)))) ) ).

% listrel_Nil
tff(fact_4690_filter__conv__foldr,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B)] : ( aa(list(B),list(B),filter2(B,Pa),Xs) = aa(list(B),list(B),foldr(B,list(B),aTP_Lamp_aja(fun(B,$o),fun(B,fun(list(B),list(B))),Pa),Xs),nil(B)) ) ).

% filter_conv_foldr
tff(fact_4691_arg__min__list_Osimps_I2_J,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [F2: fun(B,C),X2: B,Y: B,Zs: list(B)] :
          ( arg_min_list(B,C,F2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Zs)))
          = $let(
              m: B,
              m := arg_min_list(B,C,F2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Zs)),
              $ite(aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X2)),aa(B,C,F2,m)),X2,m) ) ) ) ).

% arg_min_list.simps(2)
tff(fact_4692_length__transpose,axiom,
    ! [B: $tType,Xs: list(list(B))] : ( aa(list(list(B)),nat,size_size(list(list(B))),transpose(B,Xs)) = aa(nat,nat,foldr(list(B),nat,aTP_Lamp_aiz(list(B),fun(nat,nat)),Xs),zero_zero(nat)) ) ).

% length_transpose
tff(fact_4693_horner__sum__foldr,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_semiring_0(B)
     => ! [F2: fun(C,B),A4: B,Xs: list(C)] : ( aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),F2),A4),Xs) = aa(B,B,foldr(C,B,aa(B,fun(C,fun(B,B)),aTP_Lamp_ajb(fun(C,B),fun(B,fun(C,fun(B,B))),F2),A4),Xs),zero_zero(B)) ) ) ).

% horner_sum_foldr
tff(fact_4694_horner__sum__simps_I2_J,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_0(B)
     => ! [F2: fun(C,B),A4: B,X2: C,Xs: list(C)] : ( aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),F2),A4),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),X2),Xs)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(C,B,F2,X2)),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),F2),A4),Xs))) ) ) ).

% horner_sum_simps(2)
tff(fact_4695_ord__class_Olexordp__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ( ord_lexordp(B) = complete_lattice_lfp(fun(list(B),fun(list(B),$o)),aTP_Lamp_aio(fun(list(B),fun(list(B),$o)),fun(list(B),fun(list(B),$o)))) ) ) ).

% ord_class.lexordp_def
tff(fact_4696_horner__sum__simps_I1_J,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_semiring_0(B)
     => ! [F2: fun(C,B),A4: B] : ( aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),F2),A4),nil(C)) = zero_zero(B) ) ) ).

% horner_sum_simps(1)
tff(fact_4697_ord_Olexordp__def,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o))] : ( lexordp2(B,Less) = complete_lattice_lfp(fun(list(B),fun(list(B),$o)),aTP_Lamp_ain(fun(B,fun(B,$o)),fun(fun(list(B),fun(list(B),$o)),fun(list(B),fun(list(B),$o))),Less)) ) ).

% ord.lexordp_def
tff(fact_4698_horner__sum__eq__sum__funpow,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_0(B)
     => ! [F2: fun(C,B),A4: B,Xs: list(C)] : ( aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),F2),A4),Xs) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(list(C),fun(nat,B),aa(B,fun(list(C),fun(nat,B)),aTP_Lamp_ajc(fun(C,B),fun(B,fun(list(C),fun(nat,B))),F2),A4),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(C),nat,size_size(list(C)),Xs))) ) ) ).

% horner_sum_eq_sum_funpow
tff(fact_4699_horner__sum__eq__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_1(B)
     => ! [F2: fun(C,B),A4: B,Xs: list(C)] : ( aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),F2),A4),Xs) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(list(C),fun(nat,B),aa(B,fun(list(C),fun(nat,B)),aTP_Lamp_ajd(fun(C,B),fun(B,fun(list(C),fun(nat,B))),F2),A4),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(C),nat,size_size(list(C)),Xs))) ) ) ).

% horner_sum_eq_sum
tff(fact_4700_ran__nth__set__encoding__conv,axiom,
    ! [B: $tType,L: list(B)] : ( ran(nat,B,aTP_Lamp_aje(list(B),fun(nat,option(B)),L)) = aa(list(B),set(B),set2(B),L) ) ).

% ran_nth_set_encoding_conv
tff(fact_4701_nth__Cons,axiom,
    ! [B: $tType,X2: B,Xs: list(B),N: nat] : ( aa(nat,B,nth(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)),N) = aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(B,fun(fun(nat,B),fun(nat,B)),case_nat(B),X2),nth(B,Xs)),N) ) ).

% nth_Cons
tff(fact_4702_set__conv__nth,axiom,
    ! [B: $tType,Xs: list(B)] : ( aa(list(B),set(B),set2(B),Xs) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_ajf(list(B),fun(B,$o),Xs)) ) ).

% set_conv_nth
tff(fact_4703_length__filter__conv__card,axiom,
    ! [B: $tType,P3: fun(B,$o),Xs: list(B)] : ( aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),filter2(B,P3),Xs)) = aa(set(nat),nat,finite_card(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(list(B),fun(nat,$o),aTP_Lamp_ajg(fun(B,$o),fun(list(B),fun(nat,$o)),P3),Xs))) ) ).

% length_filter_conv_card
tff(fact_4704_list__collect__set__alt,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,set(B)),L: list(C)] : ( list_collect_set(C,B,F2,L) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aa(list(C),fun(set(B),$o),aTP_Lamp_ajh(fun(C,set(B)),fun(list(C),fun(set(B),$o)),F2),L))) ) ).

% list_collect_set_alt
tff(fact_4705_set__update__distinct,axiom,
    ! [B: $tType,Xs: list(B),N: nat,X2: B] :
      ( distinct(B,Xs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(B),nat,size_size(list(B)),Xs))
       => ( aa(list(B),set(B),set2(B),list_update(B,Xs,N,X2)) = aa(set(B),set(B),insert(B,X2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(set(B),set(B),insert(B,aa(nat,B,nth(B,Xs),N)),bot_bot(set(B))))) ) ) ) ).

% set_update_distinct
tff(fact_4706_set__zip,axiom,
    ! [B: $tType,C: $tType,Xs: list(B),Ys: list(C)] : ( aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),zip(B,C,Xs,Ys)) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(list(C),fun(product_prod(B,C),$o),aTP_Lamp_aji(list(B),fun(list(C),fun(product_prod(B,C),$o)),Xs),Ys)) ) ).

% set_zip
tff(fact_4707_list__collect__set__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,set(B))] : ( list_collect_set(C,B,F2,nil(C)) = bot_bot(set(B)) ) ).

% list_collect_set_simps(1)
tff(fact_4708_list__update_Osimps_I2_J,axiom,
    ! [B: $tType,X2: B,Xs: list(B),I2: nat,V: B] : ( list_update(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs),I2,V) = aa(nat,list(B),aa(fun(nat,list(B)),fun(nat,list(B)),aa(list(B),fun(fun(nat,list(B)),fun(nat,list(B))),case_nat(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V),Xs)),aa(B,fun(nat,list(B)),aa(list(B),fun(B,fun(nat,list(B))),aTP_Lamp_ajj(B,fun(list(B),fun(B,fun(nat,list(B)))),X2),Xs),V)),I2) ) ).

% list_update.simps(2)
tff(fact_4709_set__zip__cart,axiom,
    ! [B: $tType,C: $tType,X2: product_prod(B,C),L: list(B),L3: list(C)] :
      ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),X2),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),zip(B,C,L,L3)))
     => aa(set(product_prod(B,C)),$o,member(product_prod(B,C),X2),product_Sigma(B,C,aa(list(B),set(B),set2(B),L),aTP_Lamp_aih(list(C),fun(B,set(C)),L3))) ) ).

% set_zip_cart
tff(fact_4710_concat__injective,axiom,
    ! [B: $tType,Xs: list(list(B)),Ys: list(list(B))] :
      ( ( concat(B,Xs) = concat(B,Ys) )
     => ( ( aa(list(list(B)),nat,size_size(list(list(B))),Xs) = aa(list(list(B)),nat,size_size(list(list(B))),Ys) )
       => ( ! [X: product_prod(list(B),list(B))] :
              ( aa(set(product_prod(list(B),list(B))),$o,member(product_prod(list(B),list(B)),X),aa(list(product_prod(list(B),list(B))),set(product_prod(list(B),list(B))),set2(product_prod(list(B),list(B))),zip(list(B),list(B),Xs,Ys)))
             => aa(product_prod(list(B),list(B)),$o,aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_ajk(list(B),fun(list(B),$o))),X) )
         => ( Xs = Ys ) ) ) ) ).

% concat_injective
tff(fact_4711_concat__eq__concat__iff,axiom,
    ! [B: $tType,Xs: list(list(B)),Ys: list(list(B))] :
      ( ! [X: product_prod(list(B),list(B))] :
          ( aa(set(product_prod(list(B),list(B))),$o,member(product_prod(list(B),list(B)),X),aa(list(product_prod(list(B),list(B))),set(product_prod(list(B),list(B))),set2(product_prod(list(B),list(B))),zip(list(B),list(B),Xs,Ys)))
         => aa(product_prod(list(B),list(B)),$o,aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_ajk(list(B),fun(list(B),$o))),X) )
     => ( ( aa(list(list(B)),nat,size_size(list(list(B))),Xs) = aa(list(list(B)),nat,size_size(list(list(B))),Ys) )
       => ( ( concat(B,Xs) = concat(B,Ys) )
        <=> ( Xs = Ys ) ) ) ) ).

% concat_eq_concat_iff
tff(fact_4712_foldl__snd__zip,axiom,
    ! [C: $tType,D: $tType,B: $tType,Ys: list(B),Xs: list(C),F2: fun(D,fun(B,D)),B3: D] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(B),nat,size_size(list(B)),Ys)),aa(list(C),nat,size_size(list(C)),Xs))
     => ( foldl(D,product_prod(C,B),aTP_Lamp_ajm(fun(D,fun(B,D)),fun(D,fun(product_prod(C,B),D)),F2),B3,zip(C,B,Xs,Ys)) = foldl(D,B,F2,B3,Ys) ) ) ).

% foldl_snd_zip
tff(fact_4713_foldr__snd__zip,axiom,
    ! [C: $tType,B: $tType,D: $tType,Ys: list(B),Xs: list(C),F2: fun(B,fun(D,D)),B3: D] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(B),nat,size_size(list(B)),Ys)),aa(list(C),nat,size_size(list(C)),Xs))
     => ( aa(D,D,foldr(product_prod(C,B),D,aa(fun(C,fun(B,fun(D,D))),fun(product_prod(C,B),fun(D,D)),product_case_prod(C,B,fun(D,D)),aTP_Lamp_ajn(fun(B,fun(D,D)),fun(C,fun(B,fun(D,D))),F2)),zip(C,B,Xs,Ys)),B3) = aa(D,D,foldr(B,D,F2,Ys),B3) ) ) ).

% foldr_snd_zip
tff(fact_4714_list__eq__iff__zip__eq,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B)] :
      ( ( Xs = Ys )
    <=> ( ( aa(list(B),nat,size_size(list(B)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
        & ! [X3: product_prod(B,B)] :
            ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),X3),aa(list(product_prod(B,B)),set(product_prod(B,B)),set2(product_prod(B,B)),zip(B,B,Xs,Ys)))
           => aa(product_prod(B,B),$o,aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),fequal(B)),X3) ) ) ) ).

% list_eq_iff_zip_eq
tff(fact_4715_list__collect__set__def,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,set(B)),L: list(C)] : ( list_collect_set(C,B,F2,L) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aa(list(C),fun(set(B),$o),aTP_Lamp_ajo(fun(C,set(B)),fun(list(C),fun(set(B),$o)),F2),L))) ) ).

% list_collect_set_def
tff(fact_4716_distinct__list__update,axiom,
    ! [B: $tType,Xs: list(B),A4: B,I2: nat] :
      ( distinct(B,Xs)
     => ( ~ aa(set(B),$o,member(B,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(set(B),set(B),insert(B,aa(nat,B,nth(B,Xs),I2)),bot_bot(set(B)))))
       => distinct(B,list_update(B,Xs,I2,A4)) ) ) ).

% distinct_list_update
tff(fact_4717_listrel__iff__zip,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Ys: list(C),R2: set(product_prod(B,C))] :
      ( aa(set(product_prod(list(B),list(C))),$o,member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xs),Ys)),listrel(B,C,R2))
    <=> ( ( aa(list(B),nat,size_size(list(B)),Xs) = aa(list(C),nat,size_size(list(C)),Ys) )
        & ! [X3: product_prod(B,C)] :
            ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),X3),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),zip(B,C,Xs,Ys)))
           => aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),R2)),X3) ) ) ) ).

% listrel_iff_zip
tff(fact_4718_set__nths,axiom,
    ! [B: $tType,Xs: list(B),I: set(nat)] : ( aa(list(B),set(B),set2(B),nths(B,Xs,I)) = aa(fun(B,$o),set(B),collect(B),aa(set(nat),fun(B,$o),aTP_Lamp_ajp(list(B),fun(set(nat),fun(B,$o)),Xs),I)) ) ).

% set_nths
tff(fact_4719_nth__transpose,axiom,
    ! [B: $tType,I2: nat,Xs: list(list(B))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(list(B)),nat,size_size(list(list(B))),transpose(B,Xs)))
     => ( aa(nat,list(B),nth(list(B),transpose(B,Xs)),I2) = aa(list(list(B)),list(B),map(list(B),B,aTP_Lamp_ajq(nat,fun(list(B),B),I2)),aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_ajr(nat,fun(list(B),$o),I2)),Xs)) ) ) ).

% nth_transpose
tff(fact_4720_sum__list__update,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [K: nat,Xs: list(B),X2: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(list(B),nat,size_size(list(B)),Xs))
         => ( aa(list(B),B,groups8242544230860333062m_list(B),list_update(B,Xs,K,X2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(list(B),B,groups8242544230860333062m_list(B),Xs)),X2)),aa(nat,B,nth(B,Xs),K)) ) ) ) ).

% sum_list_update
tff(fact_4721_map__ident,axiom,
    ! [B: $tType,X4: list(B)] : ( aa(list(B),list(B),map(B,B,aTP_Lamp_bk(B,B)),X4) = X4 ) ).

% map_ident
tff(fact_4722_sum__list_ONil,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => ( aa(list(B),B,groups8242544230860333062m_list(B),nil(B)) = zero_zero(B) ) ) ).

% sum_list.Nil
tff(fact_4723_sum__list_OCons,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => ! [X2: B,Xs: list(B)] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),aa(list(B),B,groups8242544230860333062m_list(B),Xs)) ) ) ).

% sum_list.Cons
tff(fact_4724_sum__list__eq__0__iff,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [Ns: list(B)] :
          ( ( aa(list(B),B,groups8242544230860333062m_list(B),Ns) = zero_zero(B) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),aa(list(B),set(B),set2(B),Ns))
             => ( X3 = zero_zero(B) ) ) ) ) ).

% sum_list_eq_0_iff
tff(fact_4725_nths__empty,axiom,
    ! [B: $tType,Xs: list(B)] : ( nths(B,Xs,bot_bot(set(nat))) = nil(B) ) ).

% nths_empty
tff(fact_4726_sum__list__0,axiom,
    ! [C: $tType,B: $tType] :
      ( monoid_add(B)
     => ! [Xs: list(C)] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,aTP_Lamp_ajs(C,B)),Xs)) = zero_zero(B) ) ) ).

% sum_list_0
tff(fact_4727_list__collect__set__map__simps_I1_J,axiom,
    ! [D: $tType,C: $tType,B: $tType,F2: fun(C,set(B)),X2: fun(D,C)] : ( list_collect_set(C,B,F2,aa(list(D),list(C),map(D,C,X2),nil(D))) = bot_bot(set(B)) ) ).

% list_collect_set_map_simps(1)
tff(fact_4728_concat__map__singleton,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),Xs: list(C)] : ( concat(B,aa(list(C),list(list(B)),map(C,list(B),aTP_Lamp_ajt(fun(C,B),fun(C,list(B)),F2)),Xs)) = aa(list(C),list(B),map(C,B,F2),Xs) ) ).

% concat_map_singleton
tff(fact_4729_map__zip__map,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,F2: fun(product_prod(C,D),B),G: fun(E,C),Xs: list(E),Ys: list(D)] : ( aa(list(product_prod(C,D)),list(B),map(product_prod(C,D),B,F2),zip(C,D,aa(list(E),list(C),map(E,C,G),Xs),Ys)) = aa(list(product_prod(E,D)),list(B),map(product_prod(E,D),B,aa(fun(E,fun(D,B)),fun(product_prod(E,D),B),product_case_prod(E,D,B),aa(fun(E,C),fun(E,fun(D,B)),aTP_Lamp_aju(fun(product_prod(C,D),B),fun(fun(E,C),fun(E,fun(D,B))),F2),G))),zip(E,D,Xs,Ys)) ) ).

% map_zip_map
tff(fact_4730_map__zip__map2,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,F2: fun(product_prod(C,D),B),Xs: list(C),G: fun(E,D),Ys: list(E)] : ( aa(list(product_prod(C,D)),list(B),map(product_prod(C,D),B,F2),zip(C,D,Xs,aa(list(E),list(D),map(E,D,G),Ys))) = aa(list(product_prod(C,E)),list(B),map(product_prod(C,E),B,aa(fun(C,fun(E,B)),fun(product_prod(C,E),B),product_case_prod(C,E,B),aa(fun(E,D),fun(C,fun(E,B)),aTP_Lamp_ajv(fun(product_prod(C,D),B),fun(fun(E,D),fun(C,fun(E,B))),F2),G))),zip(C,E,Xs,Ys)) ) ).

% map_zip_map2
tff(fact_4731_zip__map1,axiom,
    ! [B: $tType,D: $tType,C: $tType,F2: fun(D,B),Xs: list(D),Ys: list(C)] : ( zip(B,C,aa(list(D),list(B),map(D,B,F2),Xs),Ys) = aa(list(product_prod(D,C)),list(product_prod(B,C)),map(product_prod(D,C),product_prod(B,C),aa(fun(D,fun(C,product_prod(B,C))),fun(product_prod(D,C),product_prod(B,C)),product_case_prod(D,C,product_prod(B,C)),aTP_Lamp_ajw(fun(D,B),fun(D,fun(C,product_prod(B,C))),F2))),zip(D,C,Xs,Ys)) ) ).

% zip_map1
tff(fact_4732_zip__map2,axiom,
    ! [C: $tType,B: $tType,D: $tType,Xs: list(B),F2: fun(D,C),Ys: list(D)] : ( zip(B,C,Xs,aa(list(D),list(C),map(D,C,F2),Ys)) = aa(list(product_prod(B,D)),list(product_prod(B,C)),map(product_prod(B,D),product_prod(B,C),aa(fun(B,fun(D,product_prod(B,C))),fun(product_prod(B,D),product_prod(B,C)),product_case_prod(B,D,product_prod(B,C)),aTP_Lamp_ajx(fun(D,C),fun(B,fun(D,product_prod(B,C))),F2))),zip(B,D,Xs,Ys)) ) ).

% zip_map2
tff(fact_4733_map__prod__fun__zip,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,F2: fun(D,B),G: fun(E,C),Xs: list(D),Ys: list(E)] : ( aa(list(product_prod(D,E)),list(product_prod(B,C)),map(product_prod(D,E),product_prod(B,C),aa(fun(D,fun(E,product_prod(B,C))),fun(product_prod(D,E),product_prod(B,C)),product_case_prod(D,E,product_prod(B,C)),aa(fun(E,C),fun(D,fun(E,product_prod(B,C))),aTP_Lamp_ek(fun(D,B),fun(fun(E,C),fun(D,fun(E,product_prod(B,C)))),F2),G))),zip(D,E,Xs,Ys)) = zip(B,C,aa(list(D),list(B),map(D,B,F2),Xs),aa(list(E),list(C),map(E,C,G),Ys)) ) ).

% map_prod_fun_zip
tff(fact_4734_map2__map__map,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,H2: fun(C,fun(D,B)),F2: fun(E,C),Xs: list(E),G: fun(E,D)] : ( aa(list(product_prod(C,D)),list(B),map(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),H2)),zip(C,D,aa(list(E),list(C),map(E,C,F2),Xs),aa(list(E),list(D),map(E,D,G),Xs))) = aa(list(E),list(B),map(E,B,aa(fun(E,D),fun(E,B),aa(fun(E,C),fun(fun(E,D),fun(E,B)),aTP_Lamp_ajy(fun(C,fun(D,B)),fun(fun(E,C),fun(fun(E,D),fun(E,B))),H2),F2),G)),Xs) ) ).

% map2_map_map
tff(fact_4735_sum__list__map__filter,axiom,
    ! [C: $tType,B: $tType] :
      ( monoid_add(C)
     => ! [Xs: list(B),Pa: fun(B,$o),F2: fun(B,C)] :
          ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),aa(list(B),set(B),set2(B),Xs))
             => ( ~ aa(B,$o,Pa,X)
               => ( aa(B,C,F2,X) = zero_zero(C) ) ) )
         => ( aa(list(C),C,groups8242544230860333062m_list(C),aa(list(B),list(C),map(B,C,F2),aa(list(B),list(B),filter2(B,Pa),Xs))) = aa(list(C),C,groups8242544230860333062m_list(C),aa(list(B),list(C),map(B,C,F2),Xs)) ) ) ) ).

% sum_list_map_filter
tff(fact_4736_sum__list__map__filter_H,axiom,
    ! [B: $tType,C: $tType] :
      ( monoid_add(B)
     => ! [F2: fun(C,B),Pa: fun(C,$o),Xs: list(C)] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,F2),aa(list(C),list(C),filter2(C,Pa),Xs))) = aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,aa(fun(C,$o),fun(C,B),aTP_Lamp_ajz(fun(C,B),fun(fun(C,$o),fun(C,B)),F2),Pa)),Xs)) ) ) ).

% sum_list_map_filter'
tff(fact_4737_sum__list__strict__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( ( monoid_add(C)
        & strict9044650504122735259up_add(C) )
     => ! [Xs: list(B),F2: fun(B,C),G: fun(B,C)] :
          ( ( Xs != nil(B) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),aa(list(B),set(B),set2(B),Xs))
               => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,F2,X)),aa(B,C,G,X)) )
           => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(list(C),C,groups8242544230860333062m_list(C),aa(list(B),list(C),map(B,C,F2),Xs))),aa(list(C),C,groups8242544230860333062m_list(C),aa(list(B),list(C),map(B,C,G),Xs))) ) ) ) ).

% sum_list_strict_mono
tff(fact_4738_sum__list__map__remove1,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [X2: B,Xs: list(B),F2: fun(B,C)] :
          ( aa(set(B),$o,member(B,X2),aa(list(B),set(B),set2(B),Xs))
         => ( aa(list(C),C,groups8242544230860333062m_list(C),aa(list(B),list(C),map(B,C,F2),Xs)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,F2,X2)),aa(list(C),C,groups8242544230860333062m_list(C),aa(list(B),list(C),map(B,C,F2),remove1(B,X2,Xs)))) ) ) ) ).

% sum_list_map_remove1
tff(fact_4739_sum__list__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( ( monoid_add(C)
        & ordere6658533253407199908up_add(C) )
     => ! [Xs: list(B),F2: fun(B,C),G: fun(B,C)] :
          ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),aa(list(B),set(B),set2(B),Xs))
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F2,X)),aa(B,C,G,X)) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(list(C),C,groups8242544230860333062m_list(C),aa(list(B),list(C),map(B,C,F2),Xs))),aa(list(C),C,groups8242544230860333062m_list(C),aa(list(B),list(C),map(B,C,G),Xs))) ) ) ).

% sum_list_mono
tff(fact_4740_sum__list__distinct__conv__sum__set,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Xs: list(B),F2: fun(B,C)] :
          ( distinct(B,Xs)
         => ( aa(list(C),C,groups8242544230860333062m_list(C),aa(list(B),list(C),map(B,C,F2),Xs)) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),F2),aa(list(B),set(B),set2(B),Xs)) ) ) ) ).

% sum_list_distinct_conv_sum_set
tff(fact_4741_sum_Odistinct__set__conv__list,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Xs: list(B),G: fun(B,C)] :
          ( distinct(B,Xs)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(list(B),set(B),set2(B),Xs)) = aa(list(C),C,groups8242544230860333062m_list(C),aa(list(B),list(C),map(B,C,G),Xs)) ) ) ) ).

% sum.distinct_set_conv_list
tff(fact_4742_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [R2: B,Xs: list(C)] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,aTP_Lamp_rv(B,fun(C,B),R2)),Xs)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(list(C),nat,size_size(list(C)),Xs))),R2) ) ) ).

% sum_list_triv
tff(fact_4743_length__concat,axiom,
    ! [B: $tType,Xss: list(list(B))] : ( aa(list(B),nat,size_size(list(B)),concat(B,Xss)) = aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(list(B)),list(nat),map(list(B),nat,size_size(list(B))),Xss)) ) ).

% length_concat
tff(fact_4744_sum__list__abs,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [Xs: list(B)] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(list(B),B,groups8242544230860333062m_list(B),Xs))),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(B),list(B),map(B,B,abs_abs(B)),Xs))) ) ).

% sum_list_abs
tff(fact_4745_sum__list__const__mult,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Ca: B,F2: fun(C,B),Xs: list(C)] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ot(B,fun(fun(C,B),fun(C,B)),Ca),F2)),Xs)) = aa(B,B,aa(B,fun(B,B),times_times(B),Ca),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,F2),Xs))) ) ) ).

% sum_list_const_mult
tff(fact_4746_sum__list__mult__const,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_0(B)
     => ! [F2: fun(C,B),Ca: B,Xs: list(C)] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,aa(B,fun(C,B),aTP_Lamp_os(fun(C,B),fun(B,fun(C,B)),F2),Ca)),Xs)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,F2),Xs))),Ca) ) ) ).

% sum_list_mult_const
tff(fact_4747_list_Omap__ident,axiom,
    ! [B: $tType,T3: list(B)] : ( aa(list(B),list(B),map(B,B,aTP_Lamp_bk(B,B)),T3) = T3 ) ).

% list.map_ident
tff(fact_4748_sum__list__addf,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(B)
     => ! [F2: fun(C,B),G: fun(C,B),Xs: list(C)] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_op(fun(C,B),fun(fun(C,B),fun(C,B)),F2),G)),Xs)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,F2),Xs))),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,G),Xs))) ) ) ).

% sum_list_addf
tff(fact_4749_List_Omap_Oidentity,axiom,
    ! [B: $tType] : ( map(B,B,aTP_Lamp_bk(B,B)) = id(list(B)) ) ).

% List.map.identity
tff(fact_4750_sum__list__subtractf,axiom,
    ! [B: $tType,C: $tType] :
      ( ab_group_add(B)
     => ! [F2: fun(C,B),G: fun(C,B),Xs: list(C)] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ou(fun(C,B),fun(fun(C,B),fun(C,B)),F2),G)),Xs)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,F2),Xs))),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,G),Xs))) ) ) ).

% sum_list_subtractf
tff(fact_4751_uminus__sum__list__map,axiom,
    ! [B: $tType,C: $tType] :
      ( ab_group_add(B)
     => ! [F2: fun(C,B),Xs: list(C)] : ( aa(B,B,uminus_uminus(B),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,F2),Xs))) = aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,aa(fun(C,B),fun(C,B),comp(B,B,C,uminus_uminus(B)),F2)),Xs)) ) ) ).

% uminus_sum_list_map
tff(fact_4752_foldl__map,axiom,
    ! [B: $tType,C: $tType,D: $tType,G: fun(B,fun(C,B)),A4: B,F2: fun(D,C),Xs: list(D)] : ( foldl(B,C,G,A4,aa(list(D),list(C),map(D,C,F2),Xs)) = foldl(B,D,aa(fun(D,C),fun(B,fun(D,B)),aTP_Lamp_aka(fun(B,fun(C,B)),fun(fun(D,C),fun(B,fun(D,B))),G),F2),A4,Xs) ) ).

% foldl_map
tff(fact_4753_sum__code,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(C,B),Xs: list(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),aa(list(C),set(C),set2(C),Xs)) = aa(list(B),B,groups8242544230860333062m_list(B),aa(list(C),list(B),map(C,B,G),aa(list(C),list(C),remdups(C),Xs))) ) ) ).

% sum_code
tff(fact_4754_member__le__sum__list,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [X2: B,Xs: list(B)] :
          ( aa(set(B),$o,member(B,X2),aa(list(B),set(B),set2(B),Xs))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(list(B),B,groups8242544230860333062m_list(B),Xs)) ) ) ).

% member_le_sum_list
tff(fact_4755_Groups__List_Osum__list__nonneg,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [Xs: list(B)] :
          ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),aa(list(B),set(B),set2(B),Xs))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(list(B),B,groups8242544230860333062m_list(B),Xs)) ) ) ).

% Groups_List.sum_list_nonneg
tff(fact_4756_sum__list__nonneg__eq__0__iff,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [Xs: list(B)] :
          ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),aa(list(B),set(B),set2(B),Xs))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X) )
         => ( ( aa(list(B),B,groups8242544230860333062m_list(B),Xs) = zero_zero(B) )
          <=> ! [X3: B] :
                ( aa(set(B),$o,member(B,X3),aa(list(B),set(B),set2(B),Xs))
               => ( X3 = zero_zero(B) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
tff(fact_4757_sum__list__nonpos,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [Xs: list(B)] :
          ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),aa(list(B),set(B),set2(B),Xs))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),zero_zero(B)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(list(B),B,groups8242544230860333062m_list(B),Xs)),zero_zero(B)) ) ) ).

% sum_list_nonpos
tff(fact_4758_sum__list_Oeq__foldr,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => ! [Xs: list(B)] : ( aa(list(B),B,groups8242544230860333062m_list(B),Xs) = aa(B,B,foldr(B,B,plus_plus(B),Xs),zero_zero(B)) ) ) ).

% sum_list.eq_foldr
tff(fact_4759_nths__nths,axiom,
    ! [B: $tType,Xs: list(B),A3: set(nat),B2: set(nat)] : ( nths(B,nths(B,Xs,A3),B2) = nths(B,Xs,aa(fun(nat,$o),set(nat),collect(nat),aa(set(nat),fun(nat,$o),aTP_Lamp_akc(set(nat),fun(set(nat),fun(nat,$o)),A3),B2))) ) ).

% nths_nths
tff(fact_4760_distinct__sum__list__conv__Sum,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Xs: list(B)] :
          ( distinct(B,Xs)
         => ( aa(list(B),B,groups8242544230860333062m_list(B),Xs) = aa(set(B),B,aa(fun(B,B),fun(set(B),B),groups7311177749621191930dd_sum(B,B),aTP_Lamp_akd(B,B)),aa(list(B),set(B),set2(B),Xs)) ) ) ) ).

% distinct_sum_list_conv_Sum
tff(fact_4761_elem__le__sum__list,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [K: nat,Ns: list(B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(list(B),nat,size_size(list(B)),Ns))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,nth(B,Ns),K)),aa(list(B),B,groups8242544230860333062m_list(B),Ns)) ) ) ).

% elem_le_sum_list
tff(fact_4762_filter__in__nths,axiom,
    ! [B: $tType,Xs: list(B),S2: set(nat)] :
      ( distinct(B,Xs)
     => ( aa(list(B),list(B),filter2(B,aa(set(nat),fun(B,$o),aTP_Lamp_ake(list(B),fun(set(nat),fun(B,$o)),Xs),S2)),Xs) = nths(B,Xs,S2) ) ) ).

% filter_in_nths
tff(fact_4763_card__length__sum__list__rec,axiom,
    ! [M2: nat,N3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),M2)
     => ( aa(set(list(nat)),nat,finite_card(list(nat)),aa(fun(list(nat),$o),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),$o),aTP_Lamp_akf(nat,fun(nat,fun(list(nat),$o)),M2),N3))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(list(nat)),nat,finite_card(list(nat)),aa(fun(list(nat),$o),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),$o),aTP_Lamp_akg(nat,fun(nat,fun(list(nat),$o)),M2),N3)))),aa(set(list(nat)),nat,finite_card(list(nat)),aa(fun(list(nat),$o),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),$o),aTP_Lamp_akh(nat,fun(nat,fun(list(nat),$o)),M2),N3)))) ) ) ).

% card_length_sum_list_rec
tff(fact_4764_card__length__sum__list,axiom,
    ! [M2: nat,N3: nat] : ( aa(set(list(nat)),nat,finite_card(list(nat)),aa(fun(list(nat),$o),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),$o),aTP_Lamp_akf(nat,fun(nat,fun(list(nat),$o)),M2),N3))) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N3),M2)),one_one(nat))),N3) ) ).

% card_length_sum_list
tff(fact_4765_length__nths,axiom,
    ! [B: $tType,Xs: list(B),I: set(nat)] : ( aa(list(B),nat,size_size(list(B)),nths(B,Xs,I)) = aa(set(nat),nat,finite_card(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(set(nat),fun(nat,$o),aTP_Lamp_aki(list(B),fun(set(nat),fun(nat,$o)),Xs),I))) ) ).

% length_nths
tff(fact_4766_map__filter__map__filter,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),Pa: fun(C,$o),Xs: list(C)] : ( aa(list(C),list(B),map(C,B,F2),aa(list(C),list(C),filter2(C,Pa),Xs)) = map_filter(C,B,aa(fun(C,$o),fun(C,option(B)),aTP_Lamp_akj(fun(C,B),fun(fun(C,$o),fun(C,option(B))),F2),Pa),Xs) ) ).

% map_filter_map_filter
tff(fact_4767_filter__eq__nths,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B)] : ( aa(list(B),list(B),filter2(B,Pa),Xs) = nths(B,Xs,aa(fun(nat,$o),set(nat),collect(nat),aa(list(B),fun(nat,$o),aTP_Lamp_ajg(fun(B,$o),fun(list(B),fun(nat,$o)),Pa),Xs))) ) ).

% filter_eq_nths
tff(fact_4768_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Xs: list(B)] : ( aa(list(B),B,groups8242544230860333062m_list(B),Xs) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),nth(B,Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% sum_list_sum_nth
tff(fact_4769_map__filter__def,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,option(B)),Xs: list(C)] : ( map_filter(C,B,F2,Xs) = aa(list(C),list(B),map(C,B,aa(fun(C,option(B)),fun(C,B),comp(option(B),B,C,the2(B)),F2)),aa(list(C),list(C),filter2(C,aTP_Lamp_akk(fun(C,option(B)),fun(C,$o),F2)),Xs)) ) ).

% map_filter_def
tff(fact_4770_length__product__lists,axiom,
    ! [B: $tType,Xss: list(list(B))] : ( aa(list(list(B)),nat,size_size(list(list(B))),product_lists(B,Xss)) = aa(nat,nat,foldr(nat,nat,times_times(nat),aa(list(list(B)),list(nat),map(list(B),nat,size_size(list(B))),Xss)),one_one(nat)) ) ).

% length_product_lists
tff(fact_4771_part__def,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [F2: fun(B,C),Pivot: C,Xs: list(B)] : ( linorder_part(B,C,F2,Pivot,Xs) = aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),aa(list(B),list(B),filter2(B,aa(C,fun(B,$o),aTP_Lamp_akl(fun(B,C),fun(C,fun(B,$o)),F2),Pivot)),Xs)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),filter2(B,aa(C,fun(B,$o),aTP_Lamp_akm(fun(B,C),fun(C,fun(B,$o)),F2),Pivot)),Xs)),aa(list(B),list(B),filter2(B,aa(C,fun(B,$o),aTP_Lamp_akn(fun(B,C),fun(C,fun(B,$o)),F2),Pivot)),Xs))) ) ) ).

% part_def
tff(fact_4772_part__code_I2_J,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [F2: fun(B,C),Pivot: C,X2: B,Xs: list(B)] : ( linorder_part(B,C,F2,Pivot,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(product_prod(list(B),product_prod(list(B),list(B))),product_prod(list(B),product_prod(list(B),list(B))),aa(fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),fun(product_prod(list(B),product_prod(list(B),list(B))),product_prod(list(B),product_prod(list(B),list(B)))),product_case_prod(list(B),product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),aa(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),aa(C,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))))),aTP_Lamp_akp(fun(B,C),fun(C,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))))),F2),Pivot),X2)),linorder_part(B,C,F2,Pivot,Xs)) ) ) ).

% part_code(2)
tff(fact_4773_map__fst__mk__snd,axiom,
    ! [C: $tType,B: $tType,K: C,L: list(B)] : ( aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),aa(list(B),list(product_prod(B,C)),map(B,product_prod(B,C),aa(C,fun(B,product_prod(B,C)),aTP_Lamp_ej(C,fun(B,product_prod(B,C))),K)),L)) = L ) ).

% map_fst_mk_snd
tff(fact_4774_map__snd__mk__fst,axiom,
    ! [C: $tType,B: $tType,K: C,L: list(B)] : ( aa(list(product_prod(C,B)),list(B),map(product_prod(C,B),B,product_snd(C,B)),aa(list(B),list(product_prod(C,B)),map(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),K)),L)) = L ) ).

% map_snd_mk_fst
tff(fact_4775_nths__shift__lemma__Suc,axiom,
    ! [B: $tType,Pa: fun(nat,$o),Xs: list(B),Is: list(nat)] : ( aa(list(product_prod(B,nat)),list(B),map(product_prod(B,nat),B,product_fst(B,nat)),aa(list(product_prod(B,nat)),list(product_prod(B,nat)),filter2(product_prod(B,nat),aTP_Lamp_akq(fun(nat,$o),fun(product_prod(B,nat),$o),Pa)),zip(B,nat,Xs,Is))) = aa(list(product_prod(B,nat)),list(B),map(product_prod(B,nat),B,product_fst(B,nat)),aa(list(product_prod(B,nat)),list(product_prod(B,nat)),filter2(product_prod(B,nat),aTP_Lamp_akr(fun(nat,$o),fun(product_prod(B,nat),$o),Pa)),zip(B,nat,Xs,aa(list(nat),list(nat),map(nat,nat,suc),Is)))) ) ).

% nths_shift_lemma_Suc
tff(fact_4776_product__concat__map,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Ys: list(C)] : ( product(B,C,Xs,Ys) = concat(product_prod(B,C),aa(list(B),list(list(product_prod(B,C))),map(B,list(product_prod(B,C)),aTP_Lamp_aks(list(C),fun(B,list(product_prod(B,C))),Ys)),Xs)) ) ).

% product_concat_map
tff(fact_4777_product__lists_Osimps_I2_J,axiom,
    ! [B: $tType,Xs: list(B),Xss: list(list(B))] : ( product_lists(B,aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),Xs),Xss)) = concat(list(B),aa(list(B),list(list(list(B))),map(B,list(list(B)),aTP_Lamp_akt(list(list(B)),fun(B,list(list(B))),Xss)),Xs)) ) ).

% product_lists.simps(2)
tff(fact_4778_sum__list__filter__le__nat,axiom,
    ! [B: $tType,F2: fun(B,nat),Pa: fun(B,$o),Xs: list(B)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(B),list(nat),map(B,nat,F2),aa(list(B),list(B),filter2(B,Pa),Xs)))),aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(B),list(nat),map(B,nat,F2),Xs))) ).

% sum_list_filter_le_nat
tff(fact_4779_zip__same__conv__map,axiom,
    ! [B: $tType,Xs: list(B)] : ( zip(B,B,Xs,Xs) = aa(list(B),list(product_prod(B,B)),map(B,product_prod(B,B),aTP_Lamp_hn(B,product_prod(B,B))),Xs) ) ).

% zip_same_conv_map
tff(fact_4780_product__code,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Ys: list(C)] : ( product_product(B,C,aa(list(B),set(B),set2(B),Xs),aa(list(C),set(C),set2(C),Ys)) = aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),concat(product_prod(B,C),aa(list(B),list(list(product_prod(B,C))),map(B,list(product_prod(B,C)),aTP_Lamp_aks(list(C),fun(B,list(product_prod(B,C))),Ys)),Xs))) ) ).

% product_code
tff(fact_4781_sum__list__Suc,axiom,
    ! [B: $tType,F2: fun(B,nat),Xs: list(B)] : ( aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(B),list(nat),map(B,nat,aTP_Lamp_sw(fun(B,nat),fun(B,nat),F2)),Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(B),list(nat),map(B,nat,F2),Xs))),aa(list(B),nat,size_size(list(B)),Xs)) ) ).

% sum_list_Suc
tff(fact_4782_zip__left__commute,axiom,
    ! [C: $tType,B: $tType,D: $tType,Xs: list(B),Ys: list(C),Zs: list(D)] : ( zip(B,product_prod(C,D),Xs,zip(C,D,Ys,Zs)) = aa(list(product_prod(C,product_prod(B,D))),list(product_prod(B,product_prod(C,D))),map(product_prod(C,product_prod(B,D)),product_prod(B,product_prod(C,D)),aa(fun(C,fun(product_prod(B,D),product_prod(B,product_prod(C,D)))),fun(product_prod(C,product_prod(B,D)),product_prod(B,product_prod(C,D))),product_case_prod(C,product_prod(B,D),product_prod(B,product_prod(C,D))),aTP_Lamp_akv(C,fun(product_prod(B,D),product_prod(B,product_prod(C,D)))))),zip(C,product_prod(B,D),Ys,zip(B,D,Xs,Zs))) ) ).

% zip_left_commute
tff(fact_4783_zip__assoc,axiom,
    ! [C: $tType,B: $tType,D: $tType,Xs: list(B),Ys: list(C),Zs: list(D)] : ( zip(B,product_prod(C,D),Xs,zip(C,D,Ys,Zs)) = aa(list(product_prod(product_prod(B,C),D)),list(product_prod(B,product_prod(C,D))),map(product_prod(product_prod(B,C),D),product_prod(B,product_prod(C,D)),aa(fun(product_prod(B,C),fun(D,product_prod(B,product_prod(C,D)))),fun(product_prod(product_prod(B,C),D),product_prod(B,product_prod(C,D))),product_case_prod(product_prod(B,C),D,product_prod(B,product_prod(C,D))),aa(fun(B,fun(C,fun(D,product_prod(B,product_prod(C,D))))),fun(product_prod(B,C),fun(D,product_prod(B,product_prod(C,D)))),product_case_prod(B,C,fun(D,product_prod(B,product_prod(C,D)))),aTP_Lamp_akw(B,fun(C,fun(D,product_prod(B,product_prod(C,D)))))))),zip(product_prod(B,C),D,zip(B,C,Xs,Ys),Zs)) ) ).

% zip_assoc
tff(fact_4784_zip__commute,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Ys: list(C)] : ( zip(B,C,Xs,Ys) = aa(list(product_prod(C,B)),list(product_prod(B,C)),map(product_prod(C,B),product_prod(B,C),aa(fun(C,fun(B,product_prod(B,C))),fun(product_prod(C,B),product_prod(B,C)),product_case_prod(C,B,product_prod(B,C)),aTP_Lamp_ej(C,fun(B,product_prod(B,C))))),zip(C,B,Ys,Xs)) ) ).

% zip_commute
tff(fact_4785_n__lists_Osimps_I2_J,axiom,
    ! [B: $tType,N: nat,Xs: list(B)] : ( n_lists(B,aa(nat,nat,suc,N),Xs) = concat(list(B),aa(list(list(B)),list(list(list(B))),map(list(B),list(list(B)),aTP_Lamp_akx(list(B),fun(list(B),list(list(B))),Xs)),n_lists(B,N,Xs))) ) ).

% n_lists.simps(2)
tff(fact_4786_Id__on__set,axiom,
    ! [B: $tType,Xs: list(B)] : ( id_on(B,aa(list(B),set(B),set2(B),Xs)) = aa(list(product_prod(B,B)),set(product_prod(B,B)),set2(product_prod(B,B)),aa(list(B),list(product_prod(B,B)),map(B,product_prod(B,B),aTP_Lamp_hn(B,product_prod(B,B))),Xs)) ) ).

% Id_on_set
tff(fact_4787_set__relcomp,axiom,
    ! [C: $tType,D: $tType,B: $tType,Xys: list(product_prod(B,D)),Yzs: list(product_prod(D,C))] : ( relcomp(B,D,C,aa(list(product_prod(B,D)),set(product_prod(B,D)),set2(product_prod(B,D)),Xys),aa(list(product_prod(D,C)),set(product_prod(D,C)),set2(product_prod(D,C)),Yzs)) = aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),concat(product_prod(B,C),aa(list(product_prod(B,D)),list(list(product_prod(B,C))),map(product_prod(B,D),list(product_prod(B,C)),aTP_Lamp_akz(list(product_prod(D,C)),fun(product_prod(B,D),list(product_prod(B,C))),Yzs)),Xys))) ) ).

% set_relcomp
tff(fact_4788_sum__list__map__eq__sum__count2,axiom,
    ! [B: $tType,Xs: list(B),X5: set(B),F2: fun(B,nat)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Xs)),X5)
     => ( aa(set(B),$o,finite_finite2(B),X5)
       => ( aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(B),list(nat),map(B,nat,F2),Xs)) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(fun(B,nat),fun(B,nat),aTP_Lamp_ala(list(B),fun(fun(B,nat),fun(B,nat)),Xs),F2)),X5) ) ) ) ).

% sum_list_map_eq_sum_count2
tff(fact_4789_sum__list__map__eq__sum__count,axiom,
    ! [B: $tType,F2: fun(B,nat),Xs: list(B)] : ( aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(B),list(nat),map(B,nat,F2),Xs)) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(list(B),fun(B,nat),aTP_Lamp_alb(fun(B,nat),fun(list(B),fun(B,nat)),F2),Xs)),aa(list(B),set(B),set2(B),Xs)) ) ).

% sum_list_map_eq_sum_count
tff(fact_4790_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [F2: fun(nat,B),Ns: list(nat)] :
          ( ! [X: nat,Y2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),Y2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,F2,X)),aa(nat,B,F2,Y2)) )
         => ( sorted_wrt(nat,ord_less(nat),Ns)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),F2),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(nat),nat,size_size(list(nat)),Ns)))),aa(list(B),B,groups8242544230860333062m_list(B),aa(list(nat),list(B),map(nat,B,F2),Ns))) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
tff(fact_4791_sorted__wrt__map__linord,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(B)
     => ! [L: list(product_prod(B,C))] :
          ( sorted_wrt(product_prod(B,C),aTP_Lamp_alc(product_prod(B,C),fun(product_prod(B,C),$o)),L)
        <=> sorted_wrt(B,ord_less_eq(B),aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),L)) ) ) ).

% sorted_wrt_map_linord
tff(fact_4792_sorted__wrt__map,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(B,$o)),F2: fun(C,B),Xs: list(C)] :
      ( sorted_wrt(B,R,aa(list(C),list(B),map(C,B,F2),Xs))
    <=> sorted_wrt(C,aa(fun(C,B),fun(C,fun(C,$o)),aTP_Lamp_ald(fun(B,fun(B,$o)),fun(fun(C,B),fun(C,fun(C,$o))),R),F2),Xs) ) ).

% sorted_wrt_map
tff(fact_4793_sorted__wrt__true,axiom,
    ! [B: $tType,Xs: list(B)] : sorted_wrt(B,aTP_Lamp_ale(B,fun(B,$o)),Xs) ).

% sorted_wrt_true
tff(fact_4794_strict__sorted__equal__Uniq,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: set(B)] : uniq(list(B),aTP_Lamp_alf(set(B),fun(list(B),$o),A3)) ) ).

% strict_sorted_equal_Uniq
tff(fact_4795_sorted__map,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(B)
     => ! [F2: fun(C,B),Xs: list(C)] :
          ( sorted_wrt(B,ord_less_eq(B),aa(list(C),list(B),map(C,B,F2),Xs))
        <=> sorted_wrt(C,aTP_Lamp_alg(fun(C,B),fun(C,fun(C,$o)),F2),Xs) ) ) ).

% sorted_map
tff(fact_4796_sorted__same,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [G: fun(list(B),B),Xs: list(B)] : sorted_wrt(B,ord_less_eq(B),aa(list(B),list(B),filter2(B,aa(list(B),fun(B,$o),aTP_Lamp_alh(fun(list(B),B),fun(list(B),fun(B,$o)),G),Xs)),Xs)) ) ).

% sorted_same
tff(fact_4797_sorted__insort,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Xs: list(B)] :
          ( sorted_wrt(B,ord_less_eq(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),X2),Xs))
        <=> sorted_wrt(B,ord_less_eq(B),Xs) ) ) ).

% sorted_insort
tff(fact_4798_sorted__map__same,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(B)
     => ! [F2: fun(C,B),G: fun(list(C),B),Xs: list(C)] : sorted_wrt(B,ord_less_eq(B),aa(list(C),list(B),map(C,B,F2),aa(list(C),list(C),filter2(C,aa(list(C),fun(C,$o),aa(fun(list(C),B),fun(list(C),fun(C,$o)),aTP_Lamp_ali(fun(C,B),fun(fun(list(C),B),fun(list(C),fun(C,$o))),F2),G),Xs)),Xs))) ) ).

% sorted_map_same
tff(fact_4799_insort__remove1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: B,Xs: list(B)] :
          ( aa(set(B),$o,member(B,A4),aa(list(B),set(B),set2(B),Xs))
         => ( sorted_wrt(B,ord_less_eq(B),Xs)
           => ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),A4),remove1(B,A4,Xs)) = Xs ) ) ) ) ).

% insort_remove1
tff(fact_4800_nth__nth__transpose__sorted,axiom,
    ! [B: $tType,Xs: list(list(B)),I2: nat,J2: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,aa(list(list(B)),list(nat),map(list(B),nat,size_size(list(B))),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(list(B)),nat,size_size(list(list(B))),transpose(B,Xs)))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(list(B)),nat,size_size(list(list(B))),aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_ajr(nat,fun(list(B),$o),I2)),Xs)))
         => ( aa(nat,B,nth(B,aa(nat,list(B),nth(list(B),transpose(B,Xs)),I2)),J2) = aa(nat,B,nth(B,aa(nat,list(B),nth(list(B),Xs),J2)),I2) ) ) ) ) ).

% nth_nth_transpose_sorted
tff(fact_4801_transpose__column,axiom,
    ! [B: $tType,Xs: list(list(B)),I2: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,aa(list(list(B)),list(nat),map(list(B),nat,size_size(list(B))),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(list(B)),nat,size_size(list(list(B))),Xs))
       => ( aa(list(list(B)),list(B),map(list(B),B,aTP_Lamp_ajq(nat,fun(list(B),B),I2)),aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_ajr(nat,fun(list(B),$o),I2)),transpose(B,Xs))) = aa(nat,list(B),nth(list(B),Xs),I2) ) ) ) ).

% transpose_column
tff(fact_4802_transpose__column__length,axiom,
    ! [B: $tType,Xs: list(list(B)),I2: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,aa(list(list(B)),list(nat),map(list(B),nat,size_size(list(B))),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(list(B)),nat,size_size(list(list(B))),Xs))
       => ( aa(list(list(B)),nat,size_size(list(list(B))),aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_ajr(nat,fun(list(B),$o),I2)),transpose(B,Xs))) = aa(list(B),nat,size_size(list(B)),aa(nat,list(B),nth(list(B),Xs),I2)) ) ) ) ).

% transpose_column_length
tff(fact_4803_sum__list__rev,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Xs: list(B)] : ( aa(list(B),B,groups8242544230860333062m_list(B),rev(B,Xs)) = aa(list(B),B,groups8242544230860333062m_list(B),Xs) ) ) ).

% sum_list_rev
tff(fact_4804_sorted__wrt__rev__linord,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [L: list(B)] :
          ( sorted_wrt(B,aTP_Lamp_px(B,fun(B,$o)),L)
        <=> sorted_wrt(B,ord_less_eq(B),rev(B,L)) ) ) ).

% sorted_wrt_rev_linord
tff(fact_4805_sorted__wrt__map__rev__linord,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(B)
     => ! [L: list(product_prod(B,C))] :
          ( sorted_wrt(product_prod(B,C),aTP_Lamp_alj(product_prod(B,C),fun(product_prod(B,C),$o)),L)
        <=> sorted_wrt(B,ord_less_eq(B),rev(B,aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),L))) ) ) ).

% sorted_wrt_map_rev_linord
tff(fact_4806_sorted__wrt__rev,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o)),Xs: list(B)] :
      ( sorted_wrt(B,Pa,rev(B,Xs))
    <=> sorted_wrt(B,aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Pa),Xs) ) ).

% sorted_wrt_rev
tff(fact_4807_foldr__conv__foldl,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,fun(B,B)),Xs: list(C),A4: B] : ( aa(B,B,foldr(C,B,F2,Xs),A4) = foldl(B,C,aTP_Lamp_all(fun(C,fun(B,B)),fun(B,fun(C,B)),F2),A4,rev(C,Xs)) ) ).

% foldr_conv_foldl
tff(fact_4808_foldl__conv__foldr,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(C,B)),A4: B,Xs: list(C)] : ( foldl(B,C,F2,A4,Xs) = aa(B,B,foldr(C,B,aTP_Lamp_alm(fun(B,fun(C,B)),fun(C,fun(B,B)),F2),rev(C,Xs)),A4) ) ).

% foldl_conv_foldr
tff(fact_4809_remove__rev__alt__def,axiom,
    ! [B: $tType,X2: B,Xs: list(B)] : ( remove_rev(B,X2,Xs) = aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),aTP_Lamp_rx(B,fun(B,$o)),X2)),rev(B,Xs)) ) ).

% remove_rev_alt_def
tff(fact_4810_nths__def,axiom,
    ! [B: $tType,Xs: list(B),A3: set(nat)] : ( nths(B,Xs,A3) = aa(list(product_prod(B,nat)),list(B),map(product_prod(B,nat),B,product_fst(B,nat)),aa(list(product_prod(B,nat)),list(product_prod(B,nat)),filter2(product_prod(B,nat),aTP_Lamp_aln(set(nat),fun(product_prod(B,nat),$o),A3)),zip(B,nat,Xs,upt(zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))))) ) ).

% nths_def
tff(fact_4811_nths__shift__lemma,axiom,
    ! [B: $tType,A3: set(nat),Xs: list(B),I2: nat] : ( aa(list(product_prod(B,nat)),list(B),map(product_prod(B,nat),B,product_fst(B,nat)),aa(list(product_prod(B,nat)),list(product_prod(B,nat)),filter2(product_prod(B,nat),aTP_Lamp_aln(set(nat),fun(product_prod(B,nat),$o),A3)),zip(B,nat,Xs,upt(I2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),aa(list(B),nat,size_size(list(B)),Xs)))))) = aa(list(product_prod(B,nat)),list(B),map(product_prod(B,nat),B,product_fst(B,nat)),aa(list(product_prod(B,nat)),list(product_prod(B,nat)),filter2(product_prod(B,nat),aa(nat,fun(product_prod(B,nat),$o),aTP_Lamp_alo(set(nat),fun(nat,fun(product_prod(B,nat),$o)),A3),I2)),zip(B,nat,Xs,upt(zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))))) ) ).

% nths_shift_lemma
tff(fact_4812_sum__list__upt,axiom,
    ! [M2: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
     => ( aa(list(nat),nat,groups8242544230860333062m_list(nat),upt(M2,N)) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_vw(nat,nat)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% sum_list_upt
tff(fact_4813_map__add__upt_H,axiom,
    ! [Ofs: nat,A4: nat,B3: nat] : ( aa(list(nat),list(nat),map(nat,nat,aTP_Lamp_alp(nat,fun(nat,nat),Ofs)),upt(A4,B3)) = upt(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),Ofs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),B3),Ofs)) ) ).

% map_add_upt'
tff(fact_4814_upt__filter__extend,axiom,
    ! [U: nat,U3: nat,Pa: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),U),U3)
     => ( ! [I3: nat] :
            ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),U),I3)
              & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),U3) )
           => ~ aa(nat,$o,Pa,I3) )
       => ( aa(list(nat),list(nat),filter2(nat,Pa),upt(zero_zero(nat),U)) = aa(list(nat),list(nat),filter2(nat,Pa),upt(zero_zero(nat),U3)) ) ) ) ).

% upt_filter_extend
tff(fact_4815_interv__sum__list__conv__sum__set__nat,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [F2: fun(nat,B),M2: nat,N: nat] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(nat),list(B),map(nat,B,F2),upt(M2,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),F2),aa(list(nat),set(nat),set2(nat),upt(M2,N))) ) ) ).

% interv_sum_list_conv_sum_set_nat
tff(fact_4816_sum__set__upt__conv__sum__list__nat,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [F2: fun(nat,B),M2: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),F2),aa(list(nat),set(nat),set2(nat),upt(M2,N))) = aa(list(B),B,groups8242544230860333062m_list(B),aa(list(nat),list(B),map(nat,B,F2),upt(M2,N))) ) ) ).

% sum_set_upt_conv_sum_list_nat
tff(fact_4817_map__add__upt,axiom,
    ! [N: nat,M2: nat] : ( aa(list(nat),list(nat),map(nat,nat,aTP_Lamp_alp(nat,fun(nat,nat),N)),upt(zero_zero(nat),M2)) = upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),N)) ) ).

% map_add_upt
tff(fact_4818_map__upt__Suc,axiom,
    ! [B: $tType,F2: fun(nat,B),N: nat] : ( aa(list(nat),list(B),map(nat,B,F2),upt(zero_zero(nat),aa(nat,nat,suc,N))) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),aa(nat,B,F2,zero_zero(nat))),aa(list(nat),list(B),map(nat,B,aTP_Lamp_xh(fun(nat,B),fun(nat,B),F2)),upt(zero_zero(nat),N))) ) ).

% map_upt_Suc
tff(fact_4819_map__nth,axiom,
    ! [B: $tType,Xs: list(B)] : ( aa(list(nat),list(B),map(nat,B,nth(B,Xs)),upt(zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) = Xs ) ).

% map_nth
tff(fact_4820_map__decr__upt,axiom,
    ! [M2: nat,N: nat] : ( aa(list(nat),list(nat),map(nat,nat,aTP_Lamp_sv(nat,nat)),upt(aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = upt(M2,N) ) ).

% map_decr_upt
tff(fact_4821_transpose__rectangle,axiom,
    ! [B: $tType,Xs: list(list(B)),N: nat] :
      ( ( ( Xs = nil(list(B)) )
       => ( N = zero_zero(nat) ) )
     => ( ! [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(list(B)),nat,size_size(list(list(B))),Xs))
           => ( aa(list(B),nat,size_size(list(B)),aa(nat,list(B),nth(list(B),Xs),I3)) = N ) )
       => ( transpose(B,Xs) = aa(list(nat),list(list(B)),map(nat,list(B),aTP_Lamp_alr(list(list(B)),fun(nat,list(B)),Xs)),upt(zero_zero(nat),N)) ) ) ) ).

% transpose_rectangle
tff(fact_4822_transpose__transpose,axiom,
    ! [B: $tType,Xs: list(list(B))] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,aa(list(list(B)),list(nat),map(list(B),nat,size_size(list(B))),Xs)))
     => ( transpose(B,transpose(B,Xs)) = takeWhile(list(B),aTP_Lamp_aii(list(B),$o),Xs) ) ) ).

% transpose_transpose
tff(fact_4823_sorted__find__Min,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B),Pa: fun(B,$o)] :
          ( sorted_wrt(B,ord_less_eq(B),Xs)
         => ( ? [X4: B] :
                ( aa(set(B),$o,member(B,X4),aa(list(B),set(B),set2(B),Xs))
                & aa(B,$o,Pa,X4) )
           => ( find(B,Pa,Xs) = aa(B,option(B),some(B),aa(set(B),B,lattic643756798350308766er_Min(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_als(list(B),fun(fun(B,$o),fun(B,$o)),Xs),Pa)))) ) ) ) ) ).

% sorted_find_Min
tff(fact_4824_extract__Cons__code,axiom,
    ! [B: $tType,Pa: fun(B,$o),X2: B,Xs: list(B)] :
      ( extract(B,Pa,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs))
      = $ite(aa(B,$o,Pa,X2),aa(product_prod(list(B),product_prod(B,list(B))),option(product_prod(list(B),product_prod(B,list(B)))),some(product_prod(list(B),product_prod(B,list(B)))),aa(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B))),aa(list(B),fun(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B)))),product_Pair(list(B),product_prod(B,list(B))),nil(B)),aa(list(B),product_prod(B,list(B)),aa(B,fun(list(B),product_prod(B,list(B))),product_Pair(B,list(B)),X2),Xs))),case_option(option(product_prod(list(B),product_prod(B,list(B)))),product_prod(list(B),product_prod(B,list(B))),none(product_prod(list(B),product_prod(B,list(B)))),aa(fun(list(B),fun(product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B)))))),fun(product_prod(list(B),product_prod(B,list(B))),option(product_prod(list(B),product_prod(B,list(B))))),product_case_prod(list(B),product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B))))),aTP_Lamp_alu(B,fun(list(B),fun(product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B)))))),X2)),extract(B,Pa,Xs))) ) ).

% extract_Cons_code
tff(fact_4825_filter__equals__takeWhile__sorted__rev,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(B)
     => ! [F2: fun(C,B),Xs: list(C),T3: B] :
          ( sorted_wrt(B,ord_less_eq(B),rev(B,aa(list(C),list(B),map(C,B,F2),Xs)))
         => ( aa(list(C),list(C),filter2(C,aa(B,fun(C,$o),aTP_Lamp_alv(fun(C,B),fun(B,fun(C,$o)),F2),T3)),Xs) = takeWhile(C,aa(B,fun(C,$o),aTP_Lamp_alv(fun(C,B),fun(B,fun(C,$o)),F2),T3),Xs) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
tff(fact_4826_insort__key__remove1,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [A4: B,Xs: list(B),F2: fun(B,C)] :
          ( aa(set(B),$o,member(B,A4),aa(list(B),set(B),set2(B),Xs))
         => ( sorted_wrt(C,ord_less_eq(C),aa(list(B),list(C),map(B,C,F2),Xs))
           => ( ( aa(list(B),B,hd(B),aa(list(B),list(B),filter2(B,aa(fun(B,C),fun(B,$o),aTP_Lamp_alw(B,fun(fun(B,C),fun(B,$o)),A4),F2)),Xs)) = A4 )
             => ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,C,F2),A4),remove1(B,A4,Xs)) = Xs ) ) ) ) ) ).

% insort_key_remove1
tff(fact_4827_map__of__distinct__upd,axiom,
    ! [B: $tType,C: $tType,X2: B,Xs: list(product_prod(B,C)),Y: C] :
      ( ~ aa(set(B),$o,member(B,X2),aa(list(B),set(B),set2(B),aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xs)))
     => ( map_add(B,C,fun_upd(B,option(C),aTP_Lamp_abb(B,option(C)),X2,aa(C,option(C),some(C),Y)),map_of(B,C,Xs)) = fun_upd(B,option(C),map_of(B,C,Xs),X2,aa(C,option(C),some(C),Y)) ) ) ).

% map_of_distinct_upd
tff(fact_4828_empty__eq__map__of__iff,axiom,
    ! [C: $tType,B: $tType,Xys: list(product_prod(B,C))] :
      ( ( aTP_Lamp_abb(B,option(C)) = map_of(B,C,Xys) )
    <=> ( Xys = nil(product_prod(B,C)) ) ) ).

% empty_eq_map_of_iff
tff(fact_4829_hd__def,axiom,
    ! [B: $tType,List: list(B)] : ( aa(list(B),B,hd(B),List) = aa(list(B),B,case_list(B,B,undefined(B),aTP_Lamp_alx(B,fun(list(B),B))),List) ) ).

% hd_def
tff(fact_4830_list_Ocase__distrib,axiom,
    ! [C: $tType,B: $tType,D: $tType,H2: fun(C,B),F1: C,F22: fun(D,fun(list(D),C)),List: list(D)] : ( aa(C,B,H2,aa(list(D),C,case_list(C,D,F1,F22),List)) = aa(list(D),B,case_list(B,D,aa(C,B,H2,F1),aa(fun(D,fun(list(D),C)),fun(D,fun(list(D),B)),aTP_Lamp_aly(fun(C,B),fun(fun(D,fun(list(D),C)),fun(D,fun(list(D),B))),H2),F22)),List) ) ).

% list.case_distrib
tff(fact_4831_transpose__aux__filter__head,axiom,
    ! [B: $tType,Xss: list(list(B))] : ( concat(B,aa(list(list(B)),list(list(B)),map(list(B),list(B),case_list(list(B),B,nil(B),aTP_Lamp_alz(B,fun(list(B),list(B))))),Xss)) = aa(list(list(B)),list(B),map(list(B),B,hd(B)),aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_aii(list(B),$o)),Xss)) ) ).

% transpose_aux_filter_head
tff(fact_4832_map__add__map__of__foldr,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),Ps: list(product_prod(B,C))] : ( map_add(B,C,M2,map_of(B,C,Ps)) = aa(fun(B,option(C)),fun(B,option(C)),foldr(product_prod(B,C),fun(B,option(C)),aa(fun(B,fun(C,fun(fun(B,option(C)),fun(B,option(C))))),fun(product_prod(B,C),fun(fun(B,option(C)),fun(B,option(C)))),product_case_prod(B,C,fun(fun(B,option(C)),fun(B,option(C)))),aTP_Lamp_ama(B,fun(C,fun(fun(B,option(C)),fun(B,option(C)))))),Ps),M2) ) ).

% map_add_map_of_foldr
tff(fact_4833_map__of__concat,axiom,
    ! [C: $tType,B: $tType,Xss: list(list(product_prod(B,C)))] : ( map_of(B,C,concat(product_prod(B,C),Xss)) = aa(fun(B,option(C)),fun(B,option(C)),foldr(list(product_prod(B,C)),fun(B,option(C)),aTP_Lamp_amb(list(product_prod(B,C)),fun(fun(B,option(C)),fun(B,option(C)))),Xss),aTP_Lamp_abb(B,option(C))) ) ).

% map_of_concat
tff(fact_4834_map__of__map__keys,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),M2: fun(B,option(C))] :
      ( ( aa(list(B),set(B),set2(B),Xs) = dom(B,C,M2) )
     => ( map_of(B,C,aa(list(B),list(product_prod(B,C)),map(B,product_prod(B,C),aTP_Lamp_acu(fun(B,option(C)),fun(B,product_prod(B,C)),M2)),Xs)) = M2 ) ) ).

% map_of_map_keys
tff(fact_4835_map__of__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,F2: fun(D,C),Xs: list(product_prod(B,D))] : ( map_of(B,C,aa(list(product_prod(B,D)),list(product_prod(B,C)),map(product_prod(B,D),product_prod(B,C),aa(fun(B,fun(D,product_prod(B,C))),fun(product_prod(B,D),product_prod(B,C)),product_case_prod(B,D,product_prod(B,C)),aTP_Lamp_ajx(fun(D,C),fun(B,fun(D,product_prod(B,C))),F2))),Xs)) = aa(fun(B,option(D)),fun(B,option(C)),comp(option(D),option(C),B,map_option(D,C,F2)),map_of(B,D,Xs)) ) ).

% map_of_map
tff(fact_4836_transpose_Oelims,axiom,
    ! [B: $tType,X2: list(list(B)),Y: list(list(B))] :
      ( ( transpose(B,X2) = Y )
     => ( ( ( X2 = nil(list(B)) )
         => ( Y != nil(list(B)) ) )
       => ( ! [Xss2: list(list(B))] :
              ( ( X2 = aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),nil(B)),Xss2) )
             => ( Y != transpose(B,Xss2) ) )
         => ~ ! [X: B,Xs2: list(B),Xss2: list(list(B))] :
                ( ( X2 = aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2)),Xss2) )
               => ( Y != aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),concat(B,aa(list(list(B)),list(list(B)),map(list(B),list(B),case_list(list(B),B,nil(B),aTP_Lamp_alz(B,fun(list(B),list(B))))),Xss2)))),transpose(B,aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),Xs2),concat(list(B),aa(list(list(B)),list(list(list(B))),map(list(B),list(list(B)),case_list(list(list(B)),B,nil(list(B)),aTP_Lamp_amc(B,fun(list(B),list(list(B)))))),Xss2))))) ) ) ) ) ) ).

% transpose.elims
tff(fact_4837_transpose_Osimps_I3_J,axiom,
    ! [B: $tType,X2: B,Xs: list(B),Xss: list(list(B))] : ( transpose(B,aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)),Xss)) = aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),concat(B,aa(list(list(B)),list(list(B)),map(list(B),list(B),case_list(list(B),B,nil(B),aTP_Lamp_alz(B,fun(list(B),list(B))))),Xss)))),transpose(B,aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),Xs),concat(list(B),aa(list(list(B)),list(list(list(B))),map(list(B),list(list(B)),case_list(list(list(B)),B,nil(list(B)),aTP_Lamp_amc(B,fun(list(B),list(list(B)))))),Xss))))) ) ).

% transpose.simps(3)
tff(fact_4838_set__map__of__compr,axiom,
    ! [C: $tType,B: $tType,Xs: list(product_prod(B,C))] :
      ( distinct(B,aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xs))
     => ( aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),Xs) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_amd(list(product_prod(B,C)),fun(B,fun(C,$o)),Xs))) ) ) ).

% set_map_of_compr
tff(fact_4839_map__of__mapk__SomeI,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(B,C),T3: list(product_prod(B,D)),K: B,X2: D] :
      ( inj_on(B,C,F2,top_top(set(B)))
     => ( ( aa(B,option(D),map_of(B,D,T3),K) = aa(D,option(D),some(D),X2) )
       => ( aa(C,option(D),map_of(C,D,aa(list(product_prod(B,D)),list(product_prod(C,D)),map(product_prod(B,D),product_prod(C,D),aa(fun(B,fun(D,product_prod(C,D))),fun(product_prod(B,D),product_prod(C,D)),product_case_prod(B,D,product_prod(C,D)),aTP_Lamp_ame(fun(B,C),fun(B,fun(D,product_prod(C,D))),F2))),T3)),aa(B,C,F2,K)) = aa(D,option(D),some(D),X2) ) ) ) ).

% map_of_mapk_SomeI
tff(fact_4840_map__of__map__restrict,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),Ks: list(B)] : ( map_of(B,C,aa(list(B),list(product_prod(B,C)),map(B,product_prod(B,C),aTP_Lamp_dm(fun(B,C),fun(B,product_prod(B,C)),F2)),Ks)) = restrict_map(B,C,aa(fun(B,C),fun(B,option(C)),comp(C,option(C),B,some(C)),F2),aa(list(B),set(B),set2(B),Ks)) ) ).

% map_of_map_restrict
tff(fact_4841_min__list_Oelims,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [X2: list(B),Y: B] :
          ( ( min_list(B,X2) = Y )
         => ( ! [X: B,Xs2: list(B)] :
                ( ( X2 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2) )
               => ( Y != aa(list(B),B,case_list(B,B,X,aa(list(B),fun(B,fun(list(B),B)),aTP_Lamp_amf(B,fun(list(B),fun(B,fun(list(B),B))),X),Xs2)),Xs2) ) )
           => ~ ( ( X2 = nil(B) )
               => ( Y != undefined(B) ) ) ) ) ) ).

% min_list.elims
tff(fact_4842_transpose__aux__filter__tail,axiom,
    ! [B: $tType,Xss: list(list(B))] : ( concat(list(B),aa(list(list(B)),list(list(list(B))),map(list(B),list(list(B)),case_list(list(list(B)),B,nil(list(B)),aTP_Lamp_amc(B,fun(list(B),list(list(B)))))),Xss)) = aa(list(list(B)),list(list(B)),map(list(B),list(B),tl(B)),aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_aii(list(B),$o)),Xss)) ) ).

% transpose_aux_filter_tail
tff(fact_4843_transpose_Opelims,axiom,
    ! [B: $tType,X2: list(list(B)),Y: list(list(B))] :
      ( ( transpose(B,X2) = Y )
     => ( aa(list(list(B)),$o,accp(list(list(B)),transpose_rel(B)),X2)
       => ( ( ( X2 = nil(list(B)) )
           => ( ( Y = nil(list(B)) )
             => ~ aa(list(list(B)),$o,accp(list(list(B)),transpose_rel(B)),nil(list(B))) ) )
         => ( ! [Xss2: list(list(B))] :
                ( ( X2 = aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),nil(B)),Xss2) )
               => ( ( Y = transpose(B,Xss2) )
                 => ~ aa(list(list(B)),$o,accp(list(list(B)),transpose_rel(B)),aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),nil(B)),Xss2)) ) )
           => ~ ! [X: B,Xs2: list(B),Xss2: list(list(B))] :
                  ( ( X2 = aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2)),Xss2) )
                 => ( ( Y = aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),concat(B,aa(list(list(B)),list(list(B)),map(list(B),list(B),case_list(list(B),B,nil(B),aTP_Lamp_alz(B,fun(list(B),list(B))))),Xss2)))),transpose(B,aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),Xs2),concat(list(B),aa(list(list(B)),list(list(list(B))),map(list(B),list(list(B)),case_list(list(list(B)),B,nil(list(B)),aTP_Lamp_amc(B,fun(list(B),list(list(B)))))),Xss2))))) )
                   => ~ aa(list(list(B)),$o,accp(list(list(B)),transpose_rel(B)),aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2)),Xss2)) ) ) ) ) ) ) ).

% transpose.pelims
tff(fact_4844_list_Odisc__eq__case_I1_J,axiom,
    ! [B: $tType,List: list(B)] :
      ( ( List = nil(B) )
    <=> aa(list(B),$o,case_list($o,B,$true,aTP_Lamp_amg(B,fun(list(B),$o))),List) ) ).

% list.disc_eq_case(1)
tff(fact_4845_list_Odisc__eq__case_I2_J,axiom,
    ! [B: $tType,List: list(B)] :
      ( ( List != nil(B) )
    <=> aa(list(B),$o,case_list($o,B,$false,aTP_Lamp_amh(B,fun(list(B),$o))),List) ) ).

% list.disc_eq_case(2)
tff(fact_4846_tl__def,axiom,
    ! [B: $tType,List: list(B)] : ( aa(list(B),list(B),tl(B),List) = aa(list(B),list(B),case_list(list(B),B,nil(B),aTP_Lamp_ami(B,fun(list(B),list(B)))),List) ) ).

% tl_def
tff(fact_4847_transpose_Opinduct,axiom,
    ! [B: $tType,A0: list(list(B)),Pa: fun(list(list(B)),$o)] :
      ( aa(list(list(B)),$o,accp(list(list(B)),transpose_rel(B)),A0)
     => ( ( aa(list(list(B)),$o,accp(list(list(B)),transpose_rel(B)),nil(list(B)))
         => aa(list(list(B)),$o,Pa,nil(list(B))) )
       => ( ! [Xss2: list(list(B))] :
              ( aa(list(list(B)),$o,accp(list(list(B)),transpose_rel(B)),aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),nil(B)),Xss2))
             => ( aa(list(list(B)),$o,Pa,Xss2)
               => aa(list(list(B)),$o,Pa,aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),nil(B)),Xss2)) ) )
         => ( ! [X: B,Xs2: list(B),Xss2: list(list(B))] :
                ( aa(list(list(B)),$o,accp(list(list(B)),transpose_rel(B)),aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2)),Xss2))
               => ( aa(list(list(B)),$o,Pa,aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),Xs2),concat(list(B),aa(list(list(B)),list(list(list(B))),map(list(B),list(list(B)),case_list(list(list(B)),B,nil(list(B)),aTP_Lamp_amc(B,fun(list(B),list(list(B)))))),Xss2))))
                 => aa(list(list(B)),$o,Pa,aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2)),Xss2)) ) )
           => aa(list(list(B)),$o,Pa,A0) ) ) ) ) ).

% transpose.pinduct
tff(fact_4848_zip__Cons1,axiom,
    ! [B: $tType,C: $tType,X2: B,Xs: list(B),Ys: list(C)] : ( zip(B,C,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs),Ys) = aa(list(C),list(product_prod(B,C)),case_list(list(product_prod(B,C)),C,nil(product_prod(B,C)),aa(list(B),fun(C,fun(list(C),list(product_prod(B,C)))),aTP_Lamp_amj(B,fun(list(B),fun(C,fun(list(C),list(product_prod(B,C))))),X2),Xs)),Ys) ) ).

% zip_Cons1
tff(fact_4849_zip__Cons,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Y: C,Ys: list(C)] : ( zip(B,C,Xs,aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),Y),Ys)) = aa(list(B),list(product_prod(B,C)),case_list(list(product_prod(B,C)),B,nil(product_prod(B,C)),aa(list(C),fun(B,fun(list(B),list(product_prod(B,C)))),aTP_Lamp_amk(C,fun(list(C),fun(B,fun(list(B),list(product_prod(B,C))))),Y),Ys)),Xs) ) ).

% zip_Cons
tff(fact_4850_min__list_Osimps,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [X2: B,Xs: list(B)] : ( min_list(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(list(B),B,case_list(B,B,X2,aa(list(B),fun(B,fun(list(B),B)),aTP_Lamp_amf(B,fun(list(B),fun(B,fun(list(B),B))),X2),Xs)),Xs) ) ) ).

% min_list.simps
tff(fact_4851_transpose_Opsimps_I3_J,axiom,
    ! [B: $tType,X2: B,Xs: list(B),Xss: list(list(B))] :
      ( aa(list(list(B)),$o,accp(list(list(B)),transpose_rel(B)),aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)),Xss))
     => ( transpose(B,aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)),Xss)) = aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),concat(B,aa(list(list(B)),list(list(B)),map(list(B),list(B),case_list(list(B),B,nil(B),aTP_Lamp_alz(B,fun(list(B),list(B))))),Xss)))),transpose(B,aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),Xs),concat(list(B),aa(list(list(B)),list(list(list(B))),map(list(B),list(list(B)),case_list(list(list(B)),B,nil(list(B)),aTP_Lamp_amc(B,fun(list(B),list(list(B)))))),Xss))))) ) ) ).

% transpose.psimps(3)
tff(fact_4852_min__list_Opelims,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [X2: list(B),Y: B] :
          ( ( min_list(B,X2) = Y )
         => ( aa(list(B),$o,accp(list(B),min_list_rel(B)),X2)
           => ( ! [X: B,Xs2: list(B)] :
                  ( ( X2 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2) )
                 => ( ( Y = aa(list(B),B,case_list(B,B,X,aa(list(B),fun(B,fun(list(B),B)),aTP_Lamp_amf(B,fun(list(B),fun(B,fun(list(B),B))),X),Xs2)),Xs2) )
                   => ~ aa(list(B),$o,accp(list(B),min_list_rel(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2)) ) )
             => ~ ( ( X2 = nil(B) )
                 => ( ( Y = undefined(B) )
                   => ~ aa(list(B),$o,accp(list(B),min_list_rel(B)),nil(B)) ) ) ) ) ) ) ).

% min_list.pelims
tff(fact_4853_extract__def,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B)] : ( extract(B,Pa,Xs) = aa(list(B),option(product_prod(list(B),product_prod(B,list(B)))),case_list(option(product_prod(list(B),product_prod(B,list(B)))),B,none(product_prod(list(B),product_prod(B,list(B)))),aa(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B)))))),aTP_Lamp_aml(fun(B,$o),fun(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))))),Pa),Xs)),dropWhile(B,aa(fun(B,$o),fun(B,$o),comp($o,$o,B,fNot),Pa),Xs)) ) ).

% extract_def
tff(fact_4854_Bleast__code,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B),Pa: fun(B,$o)] : ( bleast(B,aa(list(B),set(B),set2(B),Xs),Pa) = aa(list(B),B,case_list(B,B,abort_Bleast(B,aa(list(B),set(B),set2(B),Xs),Pa),aTP_Lamp_amm(B,fun(list(B),B))),aa(list(B),list(B),filter2(B,Pa),aa(list(B),list(B),linorder_sort_key(B,B,aTP_Lamp_eh(B,B)),Xs))) ) ) ).

% Bleast_code
tff(fact_4855_sort__upt,axiom,
    ! [M2: nat,N: nat] : ( aa(list(nat),list(nat),linorder_sort_key(nat,nat,aTP_Lamp_vw(nat,nat)),upt(M2,N)) = upt(M2,N) ) ).

% sort_upt
tff(fact_4856_sort__key__stable,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [F2: fun(B,C),K: C,Xs: list(B)] : ( aa(list(B),list(B),filter2(B,aa(C,fun(B,$o),aTP_Lamp_akm(fun(B,C),fun(C,fun(B,$o)),F2),K)),aa(list(B),list(B),linorder_sort_key(B,C,F2),Xs)) = aa(list(B),list(B),filter2(B,aa(C,fun(B,$o),aTP_Lamp_akm(fun(B,C),fun(C,fun(B,$o)),F2),K)),Xs) ) ) ).

% sort_key_stable
tff(fact_4857_sort__key__const,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Ca: C,Xs: list(B)] : ( aa(list(B),list(B),linorder_sort_key(B,C,aTP_Lamp_zu(C,fun(B,C),Ca)),Xs) = Xs ) ) ).

% sort_key_const
tff(fact_4858_sorted__sort__id,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B)] :
          ( sorted_wrt(B,ord_less_eq(B),Xs)
         => ( aa(list(B),list(B),linorder_sort_key(B,B,aTP_Lamp_eh(B,B)),Xs) = Xs ) ) ) ).

% sorted_sort_id
tff(fact_4859_sorted__sort,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B)] : sorted_wrt(B,ord_less_eq(B),aa(list(B),list(B),linorder_sort_key(B,B,aTP_Lamp_eh(B,B)),Xs)) ) ).

% sorted_sort
tff(fact_4860_find__dropWhile,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B)] : ( find(B,Pa,Xs) = aa(list(B),option(B),case_list(option(B),B,none(B),aTP_Lamp_amn(B,fun(list(B),option(B)))),dropWhile(B,aa(fun(B,$o),fun(B,$o),comp($o,$o,B,fNot),Pa),Xs)) ) ).

% find_dropWhile
tff(fact_4861_sorted__list__of__set__sort__remdups,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B)] : ( aa(set(B),list(B),linord4507533701916653071of_set(B),aa(list(B),set(B),set2(B),Xs)) = aa(list(B),list(B),linorder_sort_key(B,B,aTP_Lamp_eh(B,B)),aa(list(B),list(B),remdups(B),Xs)) ) ) ).

% sorted_list_of_set_sort_remdups
tff(fact_4862_dropWhile__neq__rev,axiom,
    ! [B: $tType,Xs: list(B),X2: B] :
      ( distinct(B,Xs)
     => ( aa(set(B),$o,member(B,X2),aa(list(B),set(B),set2(B),Xs))
       => ( dropWhile(B,aa(B,fun(B,$o),aTP_Lamp_rx(B,fun(B,$o)),X2),rev(B,Xs)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),rev(B,takeWhile(B,aa(B,fun(B,$o),aTP_Lamp_rx(B,fun(B,$o)),X2),Xs))) ) ) ) ).

% dropWhile_neq_rev
tff(fact_4863_takeWhile__neq__rev,axiom,
    ! [B: $tType,Xs: list(B),X2: B] :
      ( distinct(B,Xs)
     => ( aa(set(B),$o,member(B,X2),aa(list(B),set(B),set2(B),Xs))
       => ( takeWhile(B,aa(B,fun(B,$o),aTP_Lamp_rx(B,fun(B,$o)),X2),rev(B,Xs)) = rev(B,aa(list(B),list(B),tl(B),dropWhile(B,aa(B,fun(B,$o),aTP_Lamp_rx(B,fun(B,$o)),X2),Xs))) ) ) ) ).

% takeWhile_neq_rev
tff(fact_4864_sort__key__by__quicksort__code,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [F2: fun(B,C),Xs: list(B)] : ( aa(list(B),list(B),linorder_sort_key(B,C,F2),Xs) = aa(list(B),list(B),case_list(list(B),B,nil(B),aa(list(B),fun(B,fun(list(B),list(B))),aTP_Lamp_ams(fun(B,C),fun(list(B),fun(B,fun(list(B),list(B)))),F2),Xs)),Xs) ) ) ).

% sort_key_by_quicksort_code
tff(fact_4865_remdup__sort__mergesort__remdups,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( aa(fun(list(B),list(B)),fun(list(B),list(B)),comp(list(B),list(B),list(B),remdups(B)),linorder_sort_key(B,B,aTP_Lamp_eh(B,B))) = mergesort_remdups(B) ) ) ).

% remdup_sort_mergesort_remdups
tff(fact_4866_sort__key__by__quicksort,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [F2: fun(B,C),Xs: list(B)] : ( aa(list(B),list(B),linorder_sort_key(B,C,F2),Xs) = append(B,aa(list(B),list(B),linorder_sort_key(B,C,F2),aa(list(B),list(B),filter2(B,aa(list(B),fun(B,$o),aTP_Lamp_amt(fun(B,C),fun(list(B),fun(B,$o)),F2),Xs)),Xs)),append(B,aa(list(B),list(B),filter2(B,aa(list(B),fun(B,$o),aTP_Lamp_amu(fun(B,C),fun(list(B),fun(B,$o)),F2),Xs)),Xs),aa(list(B),list(B),linorder_sort_key(B,C,F2),aa(list(B),list(B),filter2(B,aa(list(B),fun(B,$o),aTP_Lamp_amv(fun(B,C),fun(list(B),fun(B,$o)),F2),Xs)),Xs)))) ) ) ).

% sort_key_by_quicksort
tff(fact_4867_sum__list__append,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => ! [Xs: list(B),Ys: list(B)] : ( aa(list(B),B,groups8242544230860333062m_list(B),append(B,Xs,Ys)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(list(B),B,groups8242544230860333062m_list(B),Xs)),aa(list(B),B,groups8242544230860333062m_list(B),Ys)) ) ) ).

% sum_list_append
tff(fact_4868_distinct__append,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B)] :
      ( distinct(B,append(B,Xs,Ys))
    <=> ( distinct(B,Xs)
        & distinct(B,Ys)
        & ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) ) ) ) ).

% distinct_append
tff(fact_4869_tl__append,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B)] : ( aa(list(B),list(B),tl(B),append(B,Xs,Ys)) = aa(list(B),list(B),case_list(list(B),B,aa(list(B),list(B),tl(B),Ys),aTP_Lamp_amw(list(B),fun(B,fun(list(B),list(B))),Ys)),Xs) ) ).

% tl_append
tff(fact_4870_map__by__foldl,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),L: list(C)] : ( foldl(list(B),C,aTP_Lamp_amx(fun(C,B),fun(list(B),fun(C,list(B))),F2),nil(B),L) = aa(list(C),list(B),map(C,B,F2),L) ) ).

% map_by_foldl
tff(fact_4871_takeWhile__append,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B),Ys: list(B)] :
      ( takeWhile(B,Pa,append(B,Xs,Ys))
      = $ite(
          ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),aa(list(B),set(B),set2(B),Xs))
           => aa(B,$o,Pa,X3) ),
          append(B,Xs,takeWhile(B,Pa,Ys)),
          takeWhile(B,Pa,Xs) ) ) ).

% takeWhile_append
tff(fact_4872_dropWhile__append,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B),Ys: list(B)] :
      ( dropWhile(B,Pa,append(B,Xs,Ys))
      = $ite(
          ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),aa(list(B),set(B),set2(B),Xs))
           => aa(B,$o,Pa,X3) ),
          dropWhile(B,Pa,Ys),
          append(B,dropWhile(B,Pa,Xs),Ys) ) ) ).

% dropWhile_append
tff(fact_4873_nths__append,axiom,
    ! [B: $tType,L: list(B),L3: list(B),A3: set(nat)] : ( nths(B,append(B,L,L3),A3) = append(B,nths(B,L,A3),nths(B,L3,aa(fun(nat,$o),set(nat),collect(nat),aa(set(nat),fun(nat,$o),aTP_Lamp_amy(list(B),fun(set(nat),fun(nat,$o)),L),A3)))) ) ).

% nths_append
tff(fact_4874_horner__sum__append,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_1(B)
     => ! [F2: fun(C,B),A4: B,Xs: list(C),Ys: list(C)] : ( aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),F2),A4),append(C,Xs,Ys)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),F2),A4),Xs)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A4),aa(list(C),nat,size_size(list(C)),Xs))),aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),F2),A4),Ys))) ) ) ).

% horner_sum_append
tff(fact_4875_nths__Cons,axiom,
    ! [B: $tType,X2: B,L: list(B),A3: set(nat)] :
      ( nths(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),L),A3)
      = append(B,$ite(aa(set(nat),$o,member(nat,zero_zero(nat)),A3),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)),nil(B)),nths(B,L,aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_amz(set(nat),fun(nat,$o),A3)))) ) ).

% nths_Cons
tff(fact_4876_sorted__insort__is__snoc,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B),A4: B] :
          ( sorted_wrt(B,ord_less_eq(B),Xs)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),aa(list(B),set(B),set2(B),Xs))
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),A4) )
           => ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),A4),Xs) = append(B,Xs,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A4),nil(B))) ) ) ) ) ).

% sorted_insort_is_snoc
tff(fact_4877_filter__upt__last,axiom,
    ! [B: $tType,Pa: fun(B,$o),L: list(B),Js: list(nat),J2: nat,I2: nat] :
      ( ( aa(list(nat),list(nat),filter2(nat,aa(list(B),fun(nat,$o),aTP_Lamp_ana(fun(B,$o),fun(list(B),fun(nat,$o)),Pa),L)),upt(zero_zero(nat),aa(list(B),nat,size_size(list(B)),L))) = append(nat,Js,aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),J2),nil(nat))) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),I2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(B),nat,size_size(list(B)),L))
         => ~ aa(B,$o,Pa,aa(nat,B,nth(B,L),I2)) ) ) ) ).

% filter_upt_last
tff(fact_4878_sort__by__quicksort,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B)] : ( aa(list(B),list(B),linorder_sort_key(B,B,aTP_Lamp_eh(B,B)),Xs) = append(B,aa(list(B),list(B),linorder_sort_key(B,B,aTP_Lamp_eh(B,B)),aa(list(B),list(B),filter2(B,aTP_Lamp_anb(list(B),fun(B,$o),Xs)),Xs)),append(B,aa(list(B),list(B),filter2(B,aTP_Lamp_anc(list(B),fun(B,$o),Xs)),Xs),aa(list(B),list(B),linorder_sort_key(B,B,aTP_Lamp_eh(B,B)),aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),ord_less(B),aa(nat,B,nth(B,Xs),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(B),nat,size_size(list(B)),Xs)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),Xs)))) ) ) ).

% sort_by_quicksort
tff(fact_4879_lexn__conv,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),N: nat] : ( aa(nat,set(product_prod(list(B),list(B))),lexn(B,R2),N) = aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aa(nat,fun(list(B),fun(list(B),$o)),aTP_Lamp_and(set(product_prod(B,B)),fun(nat,fun(list(B),fun(list(B),$o))),R2),N))) ) ).

% lexn_conv
tff(fact_4880_lex__conv,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( lex(B,R2) = aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_ane(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),R2))) ) ).

% lex_conv
tff(fact_4881_subset__eq__mset__impl_Oelims,axiom,
    ! [B: $tType,X2: list(B),Xa: list(B),Y: option($o)] :
      ( ( subset_eq_mset_impl(B,X2,Xa) = Y )
     => ( ( ( X2 = nil(B) )
         => ( Y != aa($o,option($o),some($o),( Xa != nil(B) )) ) )
       => ~ ! [X: B,Xs2: list(B)] :
              ( ( X2 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2) )
             => ( Y != case_option(option($o),product_prod(list(B),product_prod(B,list(B))),none($o),aa(fun(list(B),fun(product_prod(B,list(B)),option($o))),fun(product_prod(list(B),product_prod(B,list(B))),option($o)),product_case_prod(list(B),product_prod(B,list(B)),option($o)),aTP_Lamp_ang(list(B),fun(list(B),fun(product_prod(B,list(B)),option($o))),Xs2)),extract(B,aa(B,fun(B,$o),fequal(B),X),Xa)) ) ) ) ) ).

% subset_eq_mset_impl.elims
tff(fact_4882_lex__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( lex(B,R2) = aa(set(set(product_prod(list(B),list(B)))),set(product_prod(list(B),list(B))),complete_Sup_Sup(set(product_prod(list(B),list(B)))),aa(set(nat),set(set(product_prod(list(B),list(B)))),image2(nat,set(product_prod(list(B),list(B))),lexn(B,R2)),top_top(set(nat)))) ) ).

% lex_def
tff(fact_4883_lexn_Osimps_I1_J,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( aa(nat,set(product_prod(list(B),list(B))),lexn(B,R2),zero_zero(nat)) = bot_bot(set(product_prod(list(B),list(B)))) ) ).

% lexn.simps(1)
tff(fact_4884_subset__eq__mset__impl_Osimps_I2_J,axiom,
    ! [B: $tType,X2: B,Xs: list(B),Ys: list(B)] : ( subset_eq_mset_impl(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs),Ys) = case_option(option($o),product_prod(list(B),product_prod(B,list(B))),none($o),aa(fun(list(B),fun(product_prod(B,list(B)),option($o))),fun(product_prod(list(B),product_prod(B,list(B))),option($o)),product_case_prod(list(B),product_prod(B,list(B)),option($o)),aTP_Lamp_ang(list(B),fun(list(B),fun(product_prod(B,list(B)),option($o))),Xs)),extract(B,aa(B,fun(B,$o),fequal(B),X2),Ys)) ) ).

% subset_eq_mset_impl.simps(2)
tff(fact_4885_subset__eq__mset__impl_Opelims,axiom,
    ! [B: $tType,X2: list(B),Xa: list(B),Y: option($o)] :
      ( ( subset_eq_mset_impl(B,X2,Xa) = Y )
     => ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),subset751672762298770561pl_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X2),Xa))
       => ( ( ( X2 = nil(B) )
           => ( ( Y = aa($o,option($o),some($o),( Xa != nil(B) )) )
             => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),subset751672762298770561pl_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Xa)) ) )
         => ~ ! [X: B,Xs2: list(B)] :
                ( ( X2 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2) )
               => ( ( Y = case_option(option($o),product_prod(list(B),product_prod(B,list(B))),none($o),aa(fun(list(B),fun(product_prod(B,list(B)),option($o))),fun(product_prod(list(B),product_prod(B,list(B))),option($o)),product_case_prod(list(B),product_prod(B,list(B)),option($o)),aTP_Lamp_ang(list(B),fun(list(B),fun(product_prod(B,list(B)),option($o))),Xs2)),extract(B,aa(B,fun(B,$o),fequal(B),X),Xa)) )
                 => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),subset751672762298770561pl_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2)),Xa)) ) ) ) ) ) ).

% subset_eq_mset_impl.pelims
tff(fact_4886_lenlex__conv,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( lenlex(B,R2) = aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_anh(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),R2))) ) ).

% lenlex_conv
tff(fact_4887_quicksort_Osimps_I2_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Xs: list(B)] : ( aa(list(B),list(B),linorder_quicksort(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = append(B,aa(list(B),list(B),linorder_quicksort(B),aa(list(B),list(B),filter2(B,aTP_Lamp_ani(B,fun(B,$o),X2)),Xs)),append(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)),aa(list(B),list(B),linorder_quicksort(B),aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),ord_less_eq(B),X2)),Xs)))) ) ) ).

% quicksort.simps(2)
tff(fact_4888_sort__quicksort,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( linorder_sort_key(B,B,aTP_Lamp_eh(B,B)) = linorder_quicksort(B) ) ) ).

% sort_quicksort
tff(fact_4889_quicksort_Oelims,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: list(B),Y: list(B)] :
          ( ( aa(list(B),list(B),linorder_quicksort(B),X2) = Y )
         => ( ( ( X2 = nil(B) )
             => ( Y != nil(B) ) )
           => ~ ! [X: B,Xs2: list(B)] :
                  ( ( X2 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2) )
                 => ( Y != append(B,aa(list(B),list(B),linorder_quicksort(B),aa(list(B),list(B),filter2(B,aTP_Lamp_ani(B,fun(B,$o),X)),Xs2)),append(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),nil(B)),aa(list(B),list(B),linorder_quicksort(B),aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),ord_less_eq(B),X)),Xs2)))) ) ) ) ) ) ).

% quicksort.elims
tff(fact_4890_quicksort_Opelims,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: list(B),Y: list(B)] :
          ( ( aa(list(B),list(B),linorder_quicksort(B),X2) = Y )
         => ( aa(list(B),$o,accp(list(B),linord6200660962353139674rt_rel(B)),X2)
           => ( ( ( X2 = nil(B) )
               => ( ( Y = nil(B) )
                 => ~ aa(list(B),$o,accp(list(B),linord6200660962353139674rt_rel(B)),nil(B)) ) )
             => ~ ! [X: B,Xs2: list(B)] :
                    ( ( X2 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2) )
                   => ( ( Y = append(B,aa(list(B),list(B),linorder_quicksort(B),aa(list(B),list(B),filter2(B,aTP_Lamp_ani(B,fun(B,$o),X)),Xs2)),append(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),nil(B)),aa(list(B),list(B),linorder_quicksort(B),aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),ord_less_eq(B),X)),Xs2)))) )
                     => ~ aa(list(B),$o,accp(list(B),linord6200660962353139674rt_rel(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2)) ) ) ) ) ) ) ).

% quicksort.pelims
tff(fact_4891_shuffles_Opelims,axiom,
    ! [B: $tType,X2: list(B),Xa: list(B),Y: set(list(B))] :
      ( ( shuffles(B,X2,Xa) = Y )
     => ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X2),Xa))
       => ( ( ( X2 = nil(B) )
           => ( ( Y = aa(set(list(B)),set(list(B)),insert(list(B),Xa),bot_bot(set(list(B)))) )
             => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Xa)) ) )
         => ( ( ( Xa = nil(B) )
             => ( ( Y = aa(set(list(B)),set(list(B)),insert(list(B),X2),bot_bot(set(list(B)))) )
               => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X2),nil(B))) ) )
           => ~ ! [X: B,Xs2: list(B)] :
                  ( ( X2 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2) )
                 => ! [Y2: B,Ys3: list(B)] :
                      ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys3) )
                     => ( ( Y = aa(set(list(B)),set(list(B)),aa(set(list(B)),fun(set(list(B)),set(list(B))),sup_sup(set(list(B))),aa(set(list(B)),set(list(B)),image2(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X)),shuffles(B,Xs2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys3)))),aa(set(list(B)),set(list(B)),image2(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2)),shuffles(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2),Ys3))) )
                       => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys3))) ) ) ) ) ) ) ) ).

% shuffles.pelims
tff(fact_4892_shuffles_Opsimps_I1_J,axiom,
    ! [B: $tType,Ys: list(B)] :
      ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Ys))
     => ( shuffles(B,nil(B),Ys) = aa(set(list(B)),set(list(B)),insert(list(B),Ys),bot_bot(set(list(B)))) ) ) ).

% shuffles.psimps(1)
tff(fact_4893_shuffles_Opsimps_I2_J,axiom,
    ! [B: $tType,Xs: list(B)] :
      ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),nil(B)))
     => ( shuffles(B,Xs,nil(B)) = aa(set(list(B)),set(list(B)),insert(list(B),Xs),bot_bot(set(list(B)))) ) ) ).

% shuffles.psimps(2)
tff(fact_4894_inv__image__partition,axiom,
    ! [B: $tType,Xs: list(B),Pa: fun(B,$o),Ys: list(B)] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),aa(list(B),set(B),set2(B),Xs))
         => aa(B,$o,Pa,X) )
     => ( ! [Y2: B] :
            ( aa(set(B),$o,member(B,Y2),aa(list(B),set(B),set2(B),Ys))
           => ~ aa(B,$o,Pa,Y2) )
       => ( aa(set(product_prod(list(B),list(B))),set(list(B)),aa(fun(list(B),product_prod(list(B),list(B))),fun(set(product_prod(list(B),list(B))),set(list(B))),vimage(list(B),product_prod(list(B),list(B))),partition(B,Pa)),aa(set(product_prod(list(B),list(B))),set(product_prod(list(B),list(B))),insert(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys)),bot_bot(set(product_prod(list(B),list(B)))))) = shuffles(B,Xs,Ys) ) ) ) ).

% inv_image_partition
tff(fact_4895_mergesort__remdups__def,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B)] : ( aa(list(B),list(B),mergesort_remdups(B),Xs) = merge_list(B,nil(list(B)),aa(list(B),list(list(B)),map(B,list(B),aTP_Lamp_anj(B,list(B))),Xs)) ) ) ).

% mergesort_remdups_def
tff(fact_4896_lexord__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( lexord(B,R2) = aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_ank(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),R2))) ) ).

% lexord_def
tff(fact_4897_partition_Osimps_I2_J,axiom,
    ! [B: $tType,Pa: fun(B,$o),X2: B,Xs: list(B)] : ( aa(list(B),product_prod(list(B),list(B)),partition(B,Pa),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(product_prod(list(B),list(B)),product_prod(list(B),list(B)),aa(fun(list(B),fun(list(B),product_prod(list(B),list(B)))),fun(product_prod(list(B),list(B)),product_prod(list(B),list(B))),product_case_prod(list(B),list(B),product_prod(list(B),list(B))),aa(B,fun(list(B),fun(list(B),product_prod(list(B),list(B)))),aTP_Lamp_anl(fun(B,$o),fun(B,fun(list(B),fun(list(B),product_prod(list(B),list(B))))),Pa),X2)),aa(list(B),product_prod(list(B),list(B)),partition(B,Pa),Xs)) ) ).

% partition.simps(2)
tff(fact_4898_lexordp__conv__lexord,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B),Ys: list(B)] :
          ( aa(list(B),$o,aa(list(B),fun(list(B),$o),ord_lexordp(B),Xs),Ys)
        <=> aa(set(product_prod(list(B),list(B))),$o,member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys)),lexord(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),ord_less(B))))) ) ) ).

% lexordp_conv_lexord
tff(fact_4899_List_Olexordp__def,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),Xs: list(B),Ys: list(B)] :
      ( lexordp(B,R2,Xs,Ys)
    <=> aa(set(product_prod(list(B),list(B))),$o,member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys)),lexord(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2)))) ) ).

% List.lexordp_def
tff(fact_4900_Succ__def,axiom,
    ! [B: $tType,Kl: set(list(B)),Kl2: list(B)] : ( bNF_Greatest_Succ(B,Kl,Kl2) = aa(fun(B,$o),set(B),collect(B),aa(list(B),fun(B,$o),aTP_Lamp_anm(set(list(B)),fun(list(B),fun(B,$o)),Kl),Kl2)) ) ).

% Succ_def
tff(fact_4901_listrel1__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( listrel1(B,R2) = aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_ann(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),R2))) ) ).

% listrel1_def
tff(fact_4902_listrel1p__def,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),Xs: list(B),Ys: list(B)] :
      ( listrel1p(B,R2,Xs,Ys)
    <=> aa(set(product_prod(list(B),list(B))),$o,member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys)),listrel1(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2)))) ) ).

% listrel1p_def
tff(fact_4903_slice__prepend,axiom,
    ! [B: $tType,I2: nat,K: nat,Xs: list(B),Ys: list(B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(list(B),nat,size_size(list(B)),Xs))
       => $let(
            p3: nat,
            p3 := aa(list(B),nat,size_size(list(B)),Ys),
            slice(B,I2,K,Xs) = slice(B,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),p3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),p3),append(B,Ys,Xs)) ) ) ) ).

% slice_prepend
tff(fact_4904_lexn_Osimps_I2_J,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),N: nat] : ( aa(nat,set(product_prod(list(B),list(B))),lexn(B,R2),aa(nat,nat,suc,N)) = aa(set(product_prod(list(B),list(B))),set(product_prod(list(B),list(B))),aa(set(product_prod(list(B),list(B))),fun(set(product_prod(list(B),list(B))),set(product_prod(list(B),list(B)))),inf_inf(set(product_prod(list(B),list(B)))),aa(set(product_prod(product_prod(B,list(B)),product_prod(B,list(B)))),set(product_prod(list(B),list(B))),image2(product_prod(product_prod(B,list(B)),product_prod(B,list(B))),product_prod(list(B),list(B)),product_map_prod(product_prod(B,list(B)),list(B),product_prod(B,list(B)),list(B),aa(fun(B,fun(list(B),list(B))),fun(product_prod(B,list(B)),list(B)),product_case_prod(B,list(B),list(B)),cons(B)),aa(fun(B,fun(list(B),list(B))),fun(product_prod(B,list(B)),list(B)),product_case_prod(B,list(B),list(B)),cons(B)))),lex_prod(B,list(B),R2,aa(nat,set(product_prod(list(B),list(B))),lexn(B,R2),N)))),aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_ano(nat,fun(list(B),fun(list(B),$o)),N)))) ) ).

% lexn.simps(2)
tff(fact_4905_map__prod__ident,axiom,
    ! [C: $tType,B: $tType,X4: product_prod(B,C)] : ( aa(product_prod(B,C),product_prod(B,C),product_map_prod(B,B,C,C,aTP_Lamp_bk(B,B),aTP_Lamp_hd(C,C)),X4) = X4 ) ).

% map_prod_ident
tff(fact_4906_case__prod__map__prod,axiom,
    ! [D: $tType,B: $tType,C: $tType,F10: $tType,E: $tType,H2: fun(C,fun(D,B)),F2: fun(E,C),G: fun(F10,D),X2: product_prod(E,F10)] : ( aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),H2),aa(product_prod(E,F10),product_prod(C,D),product_map_prod(E,C,F10,D,F2,G),X2)) = aa(product_prod(E,F10),B,aa(fun(E,fun(F10,B)),fun(product_prod(E,F10),B),product_case_prod(E,F10,B),aa(fun(F10,D),fun(E,fun(F10,B)),aa(fun(E,C),fun(fun(F10,D),fun(E,fun(F10,B))),aTP_Lamp_anp(fun(C,fun(D,B)),fun(fun(E,C),fun(fun(F10,D),fun(E,fun(F10,B)))),H2),F2),G)),X2) ) ).

% case_prod_map_prod
tff(fact_4907_prod_Omap__ident,axiom,
    ! [C: $tType,B: $tType,T3: product_prod(B,C)] : ( aa(product_prod(B,C),product_prod(B,C),product_map_prod(B,B,C,C,aTP_Lamp_bk(B,B),aTP_Lamp_hd(C,C)),T3) = T3 ) ).

% prod.map_ident
tff(fact_4908_map__prod_Oidentity,axiom,
    ! [C: $tType,B: $tType] : ( product_map_prod(B,B,C,C,aTP_Lamp_bk(B,B),aTP_Lamp_hd(C,C)) = id(product_prod(B,C)) ) ).

% map_prod.identity
tff(fact_4909_map__prod__def,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,F2: fun(B,D),G: fun(C,E)] : ( product_map_prod(B,D,C,E,F2,G) = aa(fun(B,fun(C,product_prod(D,E))),fun(product_prod(B,C),product_prod(D,E)),product_case_prod(B,C,product_prod(D,E)),aa(fun(C,E),fun(B,fun(C,product_prod(D,E))),aTP_Lamp_anq(fun(B,D),fun(fun(C,E),fun(B,fun(C,product_prod(D,E)))),F2),G)) ) ).

% map_prod_def
tff(fact_4910_case__prod__o__map__prod,axiom,
    ! [B: $tType,E: $tType,D: $tType,F10: $tType,C: $tType,F2: fun(E,fun(F10,D)),G1: fun(B,E),G22: fun(C,F10)] : ( aa(fun(product_prod(B,C),product_prod(E,F10)),fun(product_prod(B,C),D),comp(product_prod(E,F10),D,product_prod(B,C),aa(fun(E,fun(F10,D)),fun(product_prod(E,F10),D),product_case_prod(E,F10,D),F2)),product_map_prod(B,E,C,F10,G1,G22)) = aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),aa(fun(C,F10),fun(B,fun(C,D)),aa(fun(B,E),fun(fun(C,F10),fun(B,fun(C,D))),aTP_Lamp_anr(fun(E,fun(F10,D)),fun(fun(B,E),fun(fun(C,F10),fun(B,fun(C,D)))),F2),G1),G22)) ) ).

% case_prod_o_map_prod
tff(fact_4911_map__prod__surj__on,axiom,
    ! [E: $tType,C: $tType,B: $tType,D: $tType,F2: fun(C,B),A3: set(C),A10: set(B),G: fun(E,D),B2: set(E),B17: set(D)] :
      ( ( aa(set(C),set(B),image2(C,B,F2),A3) = A10 )
     => ( ( aa(set(E),set(D),image2(E,D,G),B2) = B17 )
       => ( aa(set(product_prod(C,E)),set(product_prod(B,D)),image2(product_prod(C,E),product_prod(B,D),product_map_prod(C,B,E,D,F2,G)),product_Sigma(C,E,A3,aTP_Lamp_ans(set(E),fun(C,set(E)),B2))) = product_Sigma(B,D,A10,aTP_Lamp_ly(set(D),fun(B,set(D)),B17)) ) ) ) ).

% map_prod_surj_on
tff(fact_4912_map__prod__inj__on,axiom,
    ! [E: $tType,C: $tType,B: $tType,D: $tType,F2: fun(B,C),A3: set(B),G: fun(D,E),B2: set(D)] :
      ( inj_on(B,C,F2,A3)
     => ( inj_on(D,E,G,B2)
       => inj_on(product_prod(B,D),product_prod(C,E),product_map_prod(B,C,D,E,F2,G),product_Sigma(B,D,A3,aTP_Lamp_ly(set(D),fun(B,set(D)),B2))) ) ) ).

% map_prod_inj_on
tff(fact_4913_sort__mergesort,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( linorder_sort_key(B,B,aTP_Lamp_eh(B,B)) = mergesort(B) ) ) ).

% sort_mergesort
tff(fact_4914_listrel__def,axiom,
    ! [C: $tType,B: $tType,X4: set(product_prod(B,C))] : ( listrel(B,C,X4) = aa(fun(product_prod(list(B),list(C)),$o),set(product_prod(list(B),list(C))),collect(product_prod(list(B),list(C))),aa(fun(list(B),fun(list(C),$o)),fun(product_prod(list(B),list(C)),$o),product_case_prod(list(B),list(C),$o),listrelp(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),X4)))) ) ).

% listrel_def
tff(fact_4915_size__list__conv__sum__list,axiom,
    ! [B: $tType,F2: fun(B,nat),Xs: list(B)] : ( size_list(B,F2,Xs) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),aa(list(B),list(nat),map(B,nat,F2),Xs))),aa(list(B),nat,size_size(list(B)),Xs)) ) ).

% size_list_conv_sum_list
tff(fact_4916_listrelp__listrel__eq,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,C)),X4: list(B),Xa3: list(C)] :
      ( aa(list(C),$o,aa(list(B),fun(list(C),$o),listrelp(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),R2)),X4),Xa3)
    <=> aa(set(product_prod(list(B),list(C))),$o,member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),X4),Xa3)),listrel(B,C,R2)) ) ).

% listrelp_listrel_eq
tff(fact_4917_list_Osize__gen_I2_J,axiom,
    ! [B: $tType,X2: fun(B,nat),X21: B,X222: list(B)] : ( size_list(B,X2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X21),X222)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(B,nat,X2,X21)),size_list(B,X2,X222))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% list.size_gen(2)
tff(fact_4918_map__snd__mk__snd,axiom,
    ! [C: $tType,B: $tType,K: B,L: list(C)] : ( aa(list(product_prod(C,B)),list(B),map(product_prod(C,B),B,product_snd(C,B)),aa(list(C),list(product_prod(C,B)),map(C,product_prod(C,B),aa(B,fun(C,product_prod(C,B)),aTP_Lamp_ei(B,fun(C,product_prod(C,B))),K)),L)) = replicate(B,aa(list(C),nat,size_size(list(C)),L),K) ) ).

% map_snd_mk_snd
tff(fact_4919_map__fst__mk__fst,axiom,
    ! [C: $tType,B: $tType,K: B,L: list(C)] : ( aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),aa(list(C),list(product_prod(B,C)),map(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K)),L)) = replicate(B,aa(list(C),nat,size_size(list(C)),L),K) ) ).

% map_fst_mk_fst
tff(fact_4920_lists__empty,axiom,
    ! [B: $tType] : ( lists(B,bot_bot(set(B))) = aa(set(list(B)),set(list(B)),insert(list(B),nil(B)),bot_bot(set(list(B)))) ) ).

% lists_empty
tff(fact_4921_lists__Int__eq,axiom,
    ! [B: $tType,A3: set(B),B2: set(B)] : ( lists(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) = aa(set(list(B)),set(list(B)),aa(set(list(B)),fun(set(list(B)),set(list(B))),inf_inf(set(list(B))),lists(B,A3)),lists(B,B2)) ) ).

% lists_Int_eq
tff(fact_4922_set__replicate,axiom,
    ! [B: $tType,N: nat,X2: B] :
      ( ( N != zero_zero(nat) )
     => ( aa(list(B),set(B),set2(B),replicate(B,N,X2)) = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) ) ).

% set_replicate
tff(fact_4923_lists__IntI,axiom,
    ! [B: $tType,L: list(B),A3: set(B),B2: set(B)] :
      ( aa(set(list(B)),$o,member(list(B),L),lists(B,A3))
     => ( aa(set(list(B)),$o,member(list(B),L),lists(B,B2))
       => aa(set(list(B)),$o,member(list(B),L),lists(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2))) ) ) ).

% lists_IntI
tff(fact_4924_map__replicate__const,axiom,
    ! [C: $tType,B: $tType,K: B,Lst: list(C)] : ( aa(list(C),list(B),map(C,B,aa(B,fun(C,B),aTP_Lamp_cy(B,fun(C,B)),K)),Lst) = replicate(B,aa(list(C),nat,size_size(list(C)),Lst),K) ) ).

% map_replicate_const
tff(fact_4925_replicate__length__filter,axiom,
    ! [B: $tType,X2: B,Xs: list(B)] : ( replicate(B,aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),fequal(B),X2)),Xs)),X2) = aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),fequal(B),X2)),Xs) ) ).

% replicate_length_filter
tff(fact_4926_lists__eq__set,axiom,
    ! [B: $tType,A3: set(B)] : ( lists(B,A3) = aa(fun(list(B),$o),set(list(B)),collect(list(B)),aTP_Lamp_ant(set(B),fun(list(B),$o),A3)) ) ).

% lists_eq_set
tff(fact_4927_sum__list__replicate,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat,Ca: B] : ( aa(list(B),B,groups8242544230860333062m_list(B),replicate(B,N,Ca)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),Ca) ) ) ).

% sum_list_replicate
tff(fact_4928_map__replicate__trivial,axiom,
    ! [B: $tType,X2: B,I2: nat] : ( aa(list(nat),list(B),map(nat,B,aTP_Lamp_anu(B,fun(nat,B),X2)),upt(zero_zero(nat),I2)) = replicate(B,I2,X2) ) ).

% map_replicate_trivial
tff(fact_4929_set__replicate__conv__if,axiom,
    ! [B: $tType,N: nat,X2: B] :
      ( aa(list(B),set(B),set2(B),replicate(B,N,X2))
      = $ite(N = zero_zero(nat),bot_bot(set(B)),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))) ) ).

% set_replicate_conv_if
tff(fact_4930_set__replicate__Suc,axiom,
    ! [B: $tType,N: nat,X2: B] : ( aa(list(B),set(B),set2(B),replicate(B,aa(nat,nat,suc,N),X2)) = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) ).

% set_replicate_Suc
tff(fact_4931_listrel__subset,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),A3: set(B)] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R2),product_Sigma(B,B,A3,aTP_Lamp_cr(set(B),fun(B,set(B)),A3)))
     => aa(set(product_prod(list(B),list(B))),$o,aa(set(product_prod(list(B),list(B))),fun(set(product_prod(list(B),list(B))),$o),ord_less_eq(set(product_prod(list(B),list(B)))),listrel(B,B,R2)),product_Sigma(list(B),list(B),lists(B,A3),aTP_Lamp_anv(set(B),fun(list(B),set(list(B))),A3))) ) ).

% listrel_subset
tff(fact_4932_lists__of__len__fin2,axiom,
    ! [B: $tType,Pa: set(B),N: nat] :
      ( aa(set(B),$o,finite_finite2(B),Pa)
     => aa(set(list(B)),$o,finite_finite2(list(B)),aa(set(list(B)),set(list(B)),aa(set(list(B)),fun(set(list(B)),set(list(B))),inf_inf(set(list(B))),lists(B,Pa)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aTP_Lamp_anw(nat,fun(list(B),$o),N)))) ) ).

% lists_of_len_fin2
tff(fact_4933_lists__of__len__fin1,axiom,
    ! [B: $tType,Pa: set(B),N: nat] :
      ( aa(set(B),$o,finite_finite2(B),Pa)
     => aa(set(list(B)),$o,finite_finite2(list(B)),aa(set(list(B)),set(list(B)),aa(set(list(B)),fun(set(list(B)),set(list(B))),inf_inf(set(list(B))),lists(B,Pa)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aTP_Lamp_anx(nat,fun(list(B),$o),N)))) ) ).

% lists_of_len_fin1
tff(fact_4934_map__zip2,axiom,
    ! [B: $tType,C: $tType,K: B,L: list(C)] : ( aa(list(C),list(product_prod(B,C)),map(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K)),L) = zip(B,C,replicate(B,aa(list(C),nat,size_size(list(C)),L),K),L) ) ).

% map_zip2
tff(fact_4935_map__zip1,axiom,
    ! [B: $tType,C: $tType,K: C,L: list(B)] : ( aa(list(B),list(product_prod(B,C)),map(B,product_prod(B,C),aa(C,fun(B,product_prod(B,C)),aTP_Lamp_ej(C,fun(B,product_prod(B,C))),K)),L) = zip(B,C,L,replicate(C,aa(list(B),nat,size_size(list(B)),L),K)) ) ).

% map_zip1
tff(fact_4936_enumerate__replicate__eq,axiom,
    ! [B: $tType,N: nat,M2: nat,A4: B] : ( enumerate(B,N,replicate(B,M2,A4)) = aa(list(nat),list(product_prod(nat,B)),map(nat,product_prod(nat,B),aTP_Lamp_any(B,fun(nat,product_prod(nat,B)),A4)),upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M2))) ) ).

% enumerate_replicate_eq
tff(fact_4937_prod_Oset__conv__list,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(C,B),Xs: list(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),G),aa(list(C),set(C),set2(C),Xs)) = aa(list(B),B,groups5270119922927024881d_list(B),aa(list(C),list(B),map(C,B,G),aa(list(C),list(C),remdups(C),Xs))) ) ) ).

% prod.set_conv_list
tff(fact_4938_INF__set__fold,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B),Xs: list(C)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,F2),aa(list(C),set(C),set2(C),Xs))) = aa(B,B,fold(C,B,aa(fun(C,B),fun(C,fun(B,B)),comp(B,fun(B,B),C,inf_inf(B)),F2),Xs),top_top(B)) ) ) ).

% INF_set_fold
tff(fact_4939_prod__list_Orev,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Xs: list(B)] : ( aa(list(B),B,groups5270119922927024881d_list(B),rev(B,Xs)) = aa(list(B),B,groups5270119922927024881d_list(B),Xs) ) ) ).

% prod_list.rev
tff(fact_4940_prod__list_OCons,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [X2: B,Xs: list(B)] : ( aa(list(B),B,groups5270119922927024881d_list(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(B,B,aa(B,fun(B,B),times_times(B),X2),aa(list(B),B,groups5270119922927024881d_list(B),Xs)) ) ) ).

% prod_list.Cons
tff(fact_4941_prod__list_ONil,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ( aa(list(B),B,groups5270119922927024881d_list(B),nil(B)) = one_one(B) ) ) ).

% prod_list.Nil
tff(fact_4942_prod__list_Oappend,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [Xs: list(B),Ys: list(B)] : ( aa(list(B),B,groups5270119922927024881d_list(B),append(B,Xs,Ys)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(list(B),B,groups5270119922927024881d_list(B),Xs)),aa(list(B),B,groups5270119922927024881d_list(B),Ys)) ) ) ).

% prod_list.append
tff(fact_4943_foldl__conv__fold,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(C,B)),S2: B,Xs: list(C)] : ( foldl(B,C,F2,S2,Xs) = aa(B,B,fold(C,B,aTP_Lamp_alm(fun(B,fun(C,B)),fun(C,fun(B,B)),F2),Xs),S2) ) ).

% foldl_conv_fold
tff(fact_4944_fold__filter,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,fun(B,B)),Pa: fun(C,$o),Xs: list(C)] : ( fold(C,B,F2,aa(list(C),list(C),filter2(C,Pa),Xs)) = fold(C,B,aa(fun(C,$o),fun(C,fun(B,B)),aTP_Lamp_aix(fun(C,fun(B,B)),fun(fun(C,$o),fun(C,fun(B,B))),F2),Pa),Xs) ) ).

% fold_filter
tff(fact_4945_prod__list__zero__iff,axiom,
    ! [B: $tType] :
      ( ( semiring_1(B)
        & semiri3467727345109120633visors(B) )
     => ! [Xs: list(B)] :
          ( ( aa(list(B),B,groups5270119922927024881d_list(B),Xs) = zero_zero(B) )
        <=> aa(set(B),$o,member(B,zero_zero(B)),aa(list(B),set(B),set2(B),Xs)) ) ) ).

% prod_list_zero_iff
tff(fact_4946_fold__plus__sum__list__rev,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => ! [Xs: list(B)] : ( fold(B,B,plus_plus(B),Xs) = aa(B,fun(B,B),plus_plus(B),aa(list(B),B,groups8242544230860333062m_list(B),rev(B,Xs))) ) ) ).

% fold_plus_sum_list_rev
tff(fact_4947_sort__conv__fold,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B)] : ( aa(list(B),list(B),linorder_sort_key(B,B,aTP_Lamp_eh(B,B)),Xs) = aa(list(B),list(B),fold(B,list(B),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),Xs),nil(B)) ) ) ).

% sort_conv_fold
tff(fact_4948_Sup__set__fold,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Xs: list(B)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(list(B),set(B),set2(B),Xs)) = aa(B,B,fold(B,B,sup_sup(B),Xs),bot_bot(B)) ) ) ).

% Sup_set_fold
tff(fact_4949_Inf__set__fold,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Xs: list(B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(list(B),set(B),set2(B),Xs)) = aa(B,B,fold(B,B,inf_inf(B),Xs),top_top(B)) ) ) ).

% Inf_set_fold
tff(fact_4950_Inf__fin_Oset__eq__fold,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X2: B,Xs: list(B)] : ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(list(B),set(B),set2(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs))) = aa(B,B,fold(B,B,inf_inf(B),Xs),X2) ) ) ).

% Inf_fin.set_eq_fold
tff(fact_4951_prod__list_Oeq__foldr,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [Xs: list(B)] : ( aa(list(B),B,groups5270119922927024881d_list(B),Xs) = aa(B,B,foldr(B,B,times_times(B),Xs),one_one(B)) ) ) ).

% prod_list.eq_foldr
tff(fact_4952_enumerate__map__upt,axiom,
    ! [B: $tType,N: nat,F2: fun(nat,B),M2: nat] : ( enumerate(B,N,aa(list(nat),list(B),map(nat,B,F2),upt(N,M2))) = aa(list(nat),list(product_prod(nat,B)),map(nat,product_prod(nat,B),aTP_Lamp_anz(fun(nat,B),fun(nat,product_prod(nat,B)),F2)),upt(N,M2)) ) ).

% enumerate_map_upt
tff(fact_4953_prod_Odistinct__set__conv__list,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [Xs: list(B),G: fun(B,C)] :
          ( distinct(B,Xs)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(list(B),set(B),set2(B),Xs)) = aa(list(C),C,groups5270119922927024881d_list(C),aa(list(B),list(C),map(B,C,G),Xs)) ) ) ) ).

% prod.distinct_set_conv_list
tff(fact_4954_SUP__set__fold,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F2: fun(C,B),Xs: list(C)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,F2),aa(list(C),set(C),set2(C),Xs))) = aa(B,B,fold(C,B,aa(fun(C,B),fun(C,fun(B,B)),comp(B,fun(B,B),C,sup_sup(B)),F2),Xs),bot_bot(B)) ) ) ).

% SUP_set_fold
tff(fact_4955_list_Oin__rel,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),A4: list(B),B3: list(C)] :
      ( aa(list(C),$o,aa(list(B),fun(list(C),$o),list_all2(B,C,R),A4),B3)
    <=> ? [Z5: list(product_prod(B,C))] :
          ( aa(set(list(product_prod(B,C))),$o,member(list(product_prod(B,C)),Z5),aa(fun(list(product_prod(B,C)),$o),set(list(product_prod(B,C))),collect(list(product_prod(B,C))),aTP_Lamp_aoa(fun(B,fun(C,$o)),fun(list(product_prod(B,C)),$o),R)))
          & ( aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Z5) = A4 )
          & ( aa(list(product_prod(B,C)),list(C),map(product_prod(B,C),C,product_snd(B,C)),Z5) = B3 ) ) ) ).

% list.in_rel
tff(fact_4956_properties__for__sort__key,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Ys: list(B),Xs: list(B),F2: fun(B,C)] :
          ( ( mset(B,Ys) = mset(B,Xs) )
         => ( ! [K2: B] :
                ( aa(set(B),$o,member(B,K2),aa(list(B),set(B),set2(B),Ys))
               => ( aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),aTP_Lamp_aob(fun(B,C),fun(B,fun(B,$o)),F2),K2)),Ys) = aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),aTP_Lamp_aob(fun(B,C),fun(B,fun(B,$o)),F2),K2)),Xs) ) )
           => ( sorted_wrt(C,ord_less_eq(C),aa(list(B),list(C),map(B,C,F2),Ys))
             => ( aa(list(B),list(B),linorder_sort_key(B,C,F2),Xs) = Ys ) ) ) ) ) ).

% properties_for_sort_key
tff(fact_4957_set__drop__conv,axiom,
    ! [B: $tType,N: nat,L: list(B)] : ( aa(list(B),set(B),set2(B),drop(B,N,L)) = aa(fun(B,$o),set(B),collect(B),aa(list(B),fun(B,$o),aTP_Lamp_aoc(nat,fun(list(B),fun(B,$o)),N),L)) ) ).

% set_drop_conv
tff(fact_4958_Multiset_Omset__insort,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Xs: list(B)] : ( mset(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),X2),Xs)) = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X2),mset(B,Xs)) ) ) ).

% Multiset.mset_insort
tff(fact_4959_sorted__list__of__multiset__mset,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B)] : ( linord6283353356039996273ltiset(B,mset(B,Xs)) = aa(list(B),list(B),linorder_sort_key(B,B,aTP_Lamp_eh(B,B)),Xs) ) ) ).

% sorted_list_of_multiset_mset
tff(fact_4960_list_Orel__map_I2_J,axiom,
    ! [B: $tType,C: $tType,D: $tType,Sa: fun(B,fun(C,$o)),X2: list(B),G: fun(D,C),Y: list(D)] :
      ( aa(list(C),$o,aa(list(B),fun(list(C),$o),list_all2(B,C,Sa),X2),aa(list(D),list(C),map(D,C,G),Y))
    <=> aa(list(D),$o,aa(list(B),fun(list(D),$o),list_all2(B,D,aa(fun(D,C),fun(B,fun(D,$o)),aTP_Lamp_aod(fun(B,fun(C,$o)),fun(fun(D,C),fun(B,fun(D,$o))),Sa),G)),X2),Y) ) ).

% list.rel_map(2)
tff(fact_4961_list_Orel__map_I1_J,axiom,
    ! [D: $tType,B: $tType,C: $tType,Sb: fun(B,fun(C,$o)),I2: fun(D,B),X2: list(D),Y: list(C)] :
      ( aa(list(C),$o,aa(list(B),fun(list(C),$o),list_all2(B,C,Sb),aa(list(D),list(B),map(D,B,I2),X2)),Y)
    <=> aa(list(C),$o,aa(list(D),fun(list(C),$o),list_all2(D,C,aa(fun(D,B),fun(D,fun(C,$o)),aTP_Lamp_aoe(fun(B,fun(C,$o)),fun(fun(D,B),fun(D,fun(C,$o))),Sb),I2)),X2),Y) ) ).

% list.rel_map(1)
tff(fact_4962_list__all2__map1,axiom,
    ! [D: $tType,B: $tType,C: $tType,Pa: fun(B,fun(C,$o)),F2: fun(D,B),As2: list(D),Bs: list(C)] :
      ( aa(list(C),$o,aa(list(B),fun(list(C),$o),list_all2(B,C,Pa),aa(list(D),list(B),map(D,B,F2),As2)),Bs)
    <=> aa(list(C),$o,aa(list(D),fun(list(C),$o),list_all2(D,C,aa(fun(D,B),fun(D,fun(C,$o)),aTP_Lamp_aoe(fun(B,fun(C,$o)),fun(fun(D,B),fun(D,fun(C,$o))),Pa),F2)),As2),Bs) ) ).

% list_all2_map1
tff(fact_4963_list__all2__map2,axiom,
    ! [B: $tType,C: $tType,D: $tType,Pa: fun(B,fun(C,$o)),As2: list(B),F2: fun(D,C),Bs: list(D)] :
      ( aa(list(C),$o,aa(list(B),fun(list(C),$o),list_all2(B,C,Pa),As2),aa(list(D),list(C),map(D,C,F2),Bs))
    <=> aa(list(D),$o,aa(list(B),fun(list(D),$o),list_all2(B,D,aa(fun(D,C),fun(B,fun(D,$o)),aTP_Lamp_aod(fun(B,fun(C,$o)),fun(fun(D,C),fun(B,fun(D,$o))),Pa),F2)),As2),Bs) ) ).

% list_all2_map2
tff(fact_4964_list_Odisc__transfer_I1_J,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o))] : aa(fun(list(C),$o),$o,aa(fun(list(B),$o),fun(fun(list(C),$o),$o),bNF_rel_fun(list(B),list(C),$o,$o,list_all2(B,C,R),fequal($o)),aTP_Lamp_aof(list(B),$o)),aTP_Lamp_aog(list(C),$o)) ).

% list.disc_transfer(1)
tff(fact_4965_list_Odisc__transfer_I2_J,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o))] : aa(fun(list(C),$o),$o,aa(fun(list(B),$o),fun(fun(list(C),$o),$o),bNF_rel_fun(list(B),list(C),$o,$o,list_all2(B,C,R),fequal($o)),aTP_Lamp_aii(list(B),$o)),aTP_Lamp_aiw(list(C),$o)) ).

% list.disc_transfer(2)
tff(fact_4966_mset__eq__finite,axiom,
    ! [B: $tType,Xs: list(B)] : aa(set(list(B)),$o,finite_finite2(list(B)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aTP_Lamp_aoh(list(B),fun(list(B),$o),Xs))) ).

% mset_eq_finite
tff(fact_4967_mset__eq__length__filter,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Z2: B] :
      ( ( mset(B,Xs) = mset(B,Ys) )
     => ( aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),fequal(B),Z2)),Xs)) = aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),fequal(B),Z2)),Ys)) ) ) ).

% mset_eq_length_filter
tff(fact_4968_drop__eq__nths,axiom,
    ! [B: $tType,N: nat,Xs: list(B)] : ( drop(B,N,Xs) = nths(B,Xs,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),ord_less_eq(nat),N))) ) ).

% drop_eq_nths
tff(fact_4969_drop__Cons,axiom,
    ! [B: $tType,N: nat,X2: B,Xs: list(B)] : ( drop(B,N,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(nat,list(B),aa(fun(nat,list(B)),fun(nat,list(B)),aa(list(B),fun(fun(nat,list(B)),fun(nat,list(B))),case_nat(list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)),aTP_Lamp_aoi(list(B),fun(nat,list(B)),Xs)),N) ) ).

% drop_Cons
tff(fact_4970_properties__for__sort,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ys: list(B),Xs: list(B)] :
          ( ( mset(B,Ys) = mset(B,Xs) )
         => ( sorted_wrt(B,ord_less_eq(B),Ys)
           => ( aa(list(B),list(B),linorder_sort_key(B,B,aTP_Lamp_eh(B,B)),Xs) = Ys ) ) ) ) ).

% properties_for_sort
tff(fact_4971_product__lists__set,axiom,
    ! [B: $tType,Xss: list(list(B))] : ( aa(list(list(B)),set(list(B)),set2(list(B)),product_lists(B,Xss)) = aa(fun(list(B),$o),set(list(B)),collect(list(B)),aTP_Lamp_aok(list(list(B)),fun(list(B),$o),Xss)) ) ).

% product_lists_set
tff(fact_4972_sum__list__transfer,axiom,
    ! [B: $tType,C: $tType] :
      ( ( monoid_add(C)
        & monoid_add(B) )
     => ! [A3: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),A3,zero_zero(B)),zero_zero(C))
         => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),A3,bNF_rel_fun(B,C,B,C,A3,A3)),plus_plus(B)),plus_plus(C))
           => aa(fun(list(C),C),$o,aa(fun(list(B),B),fun(fun(list(C),C),$o),bNF_rel_fun(list(B),list(C),B,C,list_all2(B,C,A3),A3),groups8242544230860333062m_list(B)),groups8242544230860333062m_list(C)) ) ) ) ).

% sum_list_transfer
tff(fact_4973_prod__list__transfer,axiom,
    ! [B: $tType,C: $tType] :
      ( ( monoid_mult(C)
        & monoid_mult(B) )
     => ! [A3: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),A3,one_one(B)),one_one(C))
         => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),A3,bNF_rel_fun(B,C,B,C,A3,A3)),times_times(B)),times_times(C))
           => aa(fun(list(C),C),$o,aa(fun(list(B),B),fun(fun(list(C),C),$o),bNF_rel_fun(list(B),list(C),B,C,list_all2(B,C,A3),A3),groups5270119922927024881d_list(B)),groups5270119922927024881d_list(C)) ) ) ) ).

% prod_list_transfer
tff(fact_4974_list__all2__iff,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o)),Xs: list(B),Ys: list(C)] :
      ( aa(list(C),$o,aa(list(B),fun(list(C),$o),list_all2(B,C,Pa),Xs),Ys)
    <=> ( ( aa(list(B),nat,size_size(list(B)),Xs) = aa(list(C),nat,size_size(list(C)),Ys) )
        & ! [X3: product_prod(B,C)] :
            ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),X3),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),zip(B,C,Xs,Ys)))
           => aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Pa),X3) ) ) ) ).

% list_all2_iff
tff(fact_4975_horner__sum__transfer,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType] :
      ( ( comm_semiring_0(C)
        & comm_semiring_0(B) )
     => ! [A3: fun(B,fun(C,$o)),B2: fun(D,fun(E,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),A3,zero_zero(B)),zero_zero(C))
         => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),A3,bNF_rel_fun(B,C,B,C,A3,A3)),plus_plus(B)),plus_plus(C))
           => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),A3,bNF_rel_fun(B,C,B,C,A3,A3)),times_times(B)),times_times(C))
             => aa(fun(fun(E,C),fun(C,fun(list(E),C))),$o,aa(fun(fun(D,B),fun(B,fun(list(D),B))),fun(fun(fun(E,C),fun(C,fun(list(E),C))),$o),bNF_rel_fun(fun(D,B),fun(E,C),fun(B,fun(list(D),B)),fun(C,fun(list(E),C)),bNF_rel_fun(D,E,B,C,B2,A3),bNF_rel_fun(B,C,fun(list(D),B),fun(list(E),C),A3,bNF_rel_fun(list(D),list(E),B,C,list_all2(D,E,B2),A3))),groups4207007520872428315er_sum(D,B)),groups4207007520872428315er_sum(E,C)) ) ) ) ) ).

% horner_sum_transfer
tff(fact_4976_image__mset__map__of,axiom,
    ! [C: $tType,B: $tType,Xs: list(product_prod(B,C))] :
      ( distinct(B,aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xs))
     => ( aa(multiset(B),multiset(C),image_mset(B,C,aTP_Lamp_aol(list(product_prod(B,C)),fun(B,C),Xs)),mset(B,aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xs))) = mset(C,aa(list(product_prod(B,C)),list(C),map(product_prod(B,C),C,product_snd(B,C)),Xs)) ) ) ).

% image_mset_map_of
tff(fact_4977_stable__sort__key__def,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Sk: fun(fun(B,C),fun(list(B),list(B)))] :
          ( linord3483353639454293061rt_key(B,C,Sk)
        <=> ! [F8: fun(B,C),Xs3: list(B),K5: C] : ( aa(list(B),list(B),filter2(B,aa(C,fun(B,$o),aTP_Lamp_akm(fun(B,C),fun(C,fun(B,$o)),F8),K5)),aa(list(B),list(B),aa(fun(B,C),fun(list(B),list(B)),Sk,F8),Xs3)) = aa(list(B),list(B),filter2(B,aa(C,fun(B,$o),aTP_Lamp_akm(fun(B,C),fun(C,fun(B,$o)),F8),K5)),Xs3) ) ) ) ).

% stable_sort_key_def
tff(fact_4978_map__rec,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),Xs: list(C)] : ( aa(list(C),list(B),map(C,B,F2),Xs) = aa(list(C),list(B),rec_list(list(B),C,nil(B),aTP_Lamp_aom(fun(C,B),fun(C,fun(list(C),fun(list(B),list(B)))),F2)),Xs) ) ).

% map_rec
tff(fact_4979_image__mset_Oidentity,axiom,
    ! [B: $tType] : ( image_mset(B,B,aTP_Lamp_bk(B,B)) = id(multiset(B)) ) ).

% image_mset.identity
tff(fact_4980_multiset_Omap__ident,axiom,
    ! [B: $tType,T3: multiset(B)] : ( aa(multiset(B),multiset(B),image_mset(B,B,aTP_Lamp_bk(B,B)),T3) = T3 ) ).

% multiset.map_ident
tff(fact_4981_image__mset__cong,axiom,
    ! [C: $tType,B: $tType,M: multiset(B),F2: fun(B,C),G: fun(B,C)] :
      ( ! [X: B] :
          ( aa(set(B),$o,member(B,X),aa(multiset(B),set(B),set_mset(B),M))
         => ( aa(B,C,F2,X) = aa(B,C,G,X) ) )
     => ( aa(multiset(B),multiset(C),image_mset(B,C,F2),M) = aa(multiset(B),multiset(C),image_mset(B,C,G),M) ) ) ).

% image_mset_cong
tff(fact_4982_image__mset__cong__pair,axiom,
    ! [D: $tType,C: $tType,B: $tType,M: multiset(product_prod(B,C)),F2: fun(B,fun(C,D)),G: fun(B,fun(C,D))] :
      ( ! [X: B,Y2: C] :
          ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y2)),aa(multiset(product_prod(B,C)),set(product_prod(B,C)),set_mset(product_prod(B,C)),M))
         => ( aa(C,D,aa(B,fun(C,D),F2,X),Y2) = aa(C,D,aa(B,fun(C,D),G,X),Y2) ) )
     => ( aa(multiset(product_prod(B,C)),multiset(D),image_mset(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),F2)),M) = aa(multiset(product_prod(B,C)),multiset(D),image_mset(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),G)),M) ) ) ).

% image_mset_cong_pair
tff(fact_4983_in__image__mset,axiom,
    ! [B: $tType,C: $tType,Y: B,F2: fun(C,B),M: multiset(C)] :
      ( aa(set(B),$o,member(B,Y),aa(multiset(B),set(B),set_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,F2),M)))
    <=> aa(set(B),$o,member(B,Y),aa(set(C),set(B),image2(C,B,F2),aa(multiset(C),set(C),set_mset(C),M))) ) ).

% in_image_mset
tff(fact_4984_rec__list__Cons__imp,axiom,
    ! [C: $tType,B: $tType,F2: fun(list(B),C),F1: C,F22: fun(B,fun(list(B),fun(C,C))),X2: B,Xs: list(B)] :
      ( ( F2 = rec_list(C,B,F1,F22) )
     => ( aa(list(B),C,F2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(C,C,aa(list(B),fun(C,C),aa(B,fun(list(B),fun(C,C)),F22,X2),Xs),aa(list(B),C,F2,Xs)) ) ) ).

% rec_list_Cons_imp
tff(fact_4985_rec__list__Nil__imp,axiom,
    ! [B: $tType,C: $tType,F2: fun(list(B),C),F1: C,F22: fun(B,fun(list(B),fun(C,C)))] :
      ( ( F2 = rec_list(C,B,F1,F22) )
     => ( aa(list(B),C,F2,nil(B)) = F1 ) ) ).

% rec_list_Nil_imp
tff(fact_4986_list_Orec__o__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,G: C,Ga: fun(D,fun(list(D),fun(C,C))),F2: fun(B,D)] : ( aa(fun(list(B),list(D)),fun(list(B),C),comp(list(D),C,list(B),rec_list(C,D,G,Ga)),map(B,D,F2)) = rec_list(C,B,G,aa(fun(B,D),fun(B,fun(list(B),fun(C,C))),aTP_Lamp_aon(fun(D,fun(list(D),fun(C,C))),fun(fun(B,D),fun(B,fun(list(B),fun(C,C)))),Ga),F2)) ) ).

% list.rec_o_map
tff(fact_4987_count__image__mset,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),A3: multiset(C),X2: B] : ( aa(B,nat,aa(multiset(B),fun(B,nat),count(B),aa(multiset(C),multiset(B),image_mset(C,B,F2),A3)),X2) = aa(set(C),nat,aa(fun(C,nat),fun(set(C),nat),groups7311177749621191930dd_sum(C,nat),aa(multiset(C),fun(C,nat),count(C),A3)),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),F2),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))),aa(multiset(C),set(C),set_mset(C),A3))) ) ).

% count_image_mset
tff(fact_4988_set__rec,axiom,
    ! [B: $tType,Xs: list(B)] : ( aa(list(B),set(B),set2(B),Xs) = aa(list(B),set(B),rec_list(set(B),B,bot_bot(set(B)),aTP_Lamp_aoo(B,fun(list(B),fun(set(B),set(B))))),Xs) ) ).

% set_rec
tff(fact_4989_prod_Oin__rel,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,R1: fun(B,fun(C,$o)),R22: fun(D,fun(E,$o)),A4: product_prod(B,D),B3: product_prod(C,E)] :
      ( aa(product_prod(C,E),$o,aa(product_prod(B,D),fun(product_prod(C,E),$o),basic_rel_prod(B,C,D,E,R1,R22),A4),B3)
    <=> ? [Z5: product_prod(product_prod(B,C),product_prod(D,E))] :
          ( aa(set(product_prod(product_prod(B,C),product_prod(D,E))),$o,member(product_prod(product_prod(B,C),product_prod(D,E)),Z5),aa(fun(product_prod(product_prod(B,C),product_prod(D,E)),$o),set(product_prod(product_prod(B,C),product_prod(D,E))),collect(product_prod(product_prod(B,C),product_prod(D,E))),aa(fun(D,fun(E,$o)),fun(product_prod(product_prod(B,C),product_prod(D,E)),$o),aTP_Lamp_aop(fun(B,fun(C,$o)),fun(fun(D,fun(E,$o)),fun(product_prod(product_prod(B,C),product_prod(D,E)),$o)),R1),R22)))
          & ( aa(product_prod(product_prod(B,C),product_prod(D,E)),product_prod(B,D),product_map_prod(product_prod(B,C),B,product_prod(D,E),D,product_fst(B,C),product_fst(D,E)),Z5) = A4 )
          & ( aa(product_prod(product_prod(B,C),product_prod(D,E)),product_prod(C,E),product_map_prod(product_prod(B,C),C,product_prod(D,E),E,product_snd(B,C),product_snd(D,E)),Z5) = B3 ) ) ) ).

% prod.in_rel
tff(fact_4990_prod_Orel__map_I1_J,axiom,
    ! [F10: $tType,G6: $tType,B: $tType,D: $tType,E: $tType,C: $tType,S1b: fun(B,fun(C,$o)),S2b: fun(D,fun(E,$o)),I1: fun(F10,B),I22: fun(G6,D),X2: product_prod(F10,G6),Y: product_prod(C,E)] :
      ( aa(product_prod(C,E),$o,aa(product_prod(B,D),fun(product_prod(C,E),$o),basic_rel_prod(B,C,D,E,S1b,S2b),aa(product_prod(F10,G6),product_prod(B,D),product_map_prod(F10,B,G6,D,I1,I22),X2)),Y)
    <=> aa(product_prod(C,E),$o,aa(product_prod(F10,G6),fun(product_prod(C,E),$o),basic_rel_prod(F10,C,G6,E,aa(fun(F10,B),fun(F10,fun(C,$o)),aTP_Lamp_aoq(fun(B,fun(C,$o)),fun(fun(F10,B),fun(F10,fun(C,$o))),S1b),I1),aa(fun(G6,D),fun(G6,fun(E,$o)),aTP_Lamp_aor(fun(D,fun(E,$o)),fun(fun(G6,D),fun(G6,fun(E,$o))),S2b),I22)),X2),Y) ) ).

% prod.rel_map(1)
tff(fact_4991_prod_Orel__map_I2_J,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType,G6: $tType,F10: $tType,S1a: fun(B,fun(C,$o)),S2a: fun(D,fun(E,$o)),X2: product_prod(B,D),G1: fun(F10,C),G22: fun(G6,E),Y: product_prod(F10,G6)] :
      ( aa(product_prod(C,E),$o,aa(product_prod(B,D),fun(product_prod(C,E),$o),basic_rel_prod(B,C,D,E,S1a,S2a),X2),aa(product_prod(F10,G6),product_prod(C,E),product_map_prod(F10,C,G6,E,G1,G22),Y))
    <=> aa(product_prod(F10,G6),$o,aa(product_prod(B,D),fun(product_prod(F10,G6),$o),basic_rel_prod(B,F10,D,G6,aa(fun(F10,C),fun(B,fun(F10,$o)),aTP_Lamp_aos(fun(B,fun(C,$o)),fun(fun(F10,C),fun(B,fun(F10,$o))),S1a),G1),aa(fun(G6,E),fun(D,fun(G6,$o)),aTP_Lamp_aot(fun(D,fun(E,$o)),fun(fun(G6,E),fun(D,fun(G6,$o))),S2a),G22)),X2),Y) ) ).

% prod.rel_map(2)
tff(fact_4992_rel__prod__conv,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,R1: fun(B,fun(D,$o)),R22: fun(C,fun(E,$o))] : ( basic_rel_prod(B,D,C,E,R1,R22) = aa(fun(B,fun(C,fun(product_prod(D,E),$o))),fun(product_prod(B,C),fun(product_prod(D,E),$o)),product_case_prod(B,C,fun(product_prod(D,E),$o)),aa(fun(C,fun(E,$o)),fun(B,fun(C,fun(product_prod(D,E),$o))),aTP_Lamp_aov(fun(B,fun(D,$o)),fun(fun(C,fun(E,$o)),fun(B,fun(C,fun(product_prod(D,E),$o)))),R1),R22)) ) ).

% rel_prod_conv
tff(fact_4993_int_Oid__abs__transfer,axiom,
    aa(fun(product_prod(nat,nat),int),$o,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(product_prod(nat,nat),int),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),int,basic_rel_prod(nat,nat,nat,nat,fequal(nat),fequal(nat)),pcr_int),aTP_Lamp_aow(product_prod(nat,nat),product_prod(nat,nat))),abs_Integ) ).

% int.id_abs_transfer
tff(fact_4994_count__sum,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,multiset(B)),A3: set(C),X2: B] : ( aa(B,nat,aa(multiset(B),fun(B,nat),count(B),aa(set(C),multiset(B),aa(fun(C,multiset(B)),fun(set(C),multiset(B)),groups7311177749621191930dd_sum(C,multiset(B)),F2),A3)),X2) = aa(set(C),nat,aa(fun(C,nat),fun(set(C),nat),groups7311177749621191930dd_sum(C,nat),aa(B,fun(C,nat),aTP_Lamp_aox(fun(C,multiset(B)),fun(B,fun(C,nat)),F2),X2)),A3) ) ).

% count_sum
tff(fact_4995_set__mset__def,axiom,
    ! [B: $tType,M: multiset(B)] : ( aa(multiset(B),set(B),set_mset(B),M) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_aoy(multiset(B),fun(B,$o),M)) ) ).

% set_mset_def
tff(fact_4996_set__mset__diff,axiom,
    ! [B: $tType,M: multiset(B),N3: multiset(B)] : ( aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),M),N3)) = aa(fun(B,$o),set(B),collect(B),aa(multiset(B),fun(B,$o),aTP_Lamp_aoz(multiset(B),fun(multiset(B),fun(B,$o)),M),N3)) ) ).

% set_mset_diff
tff(fact_4997_count__mset,axiom,
    ! [B: $tType,Xs: list(B),X2: B] : ( aa(B,nat,aa(multiset(B),fun(B,nat),count(B),mset(B,Xs)),X2) = aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),filter2(B,aa(B,fun(B,$o),fequal(B),X2)),Xs)) ) ).

% count_mset
tff(fact_4998_count__image__mset_H,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,B),X5: multiset(C),Y: B] : ( aa(B,nat,aa(multiset(B),fun(B,nat),count(B),aa(multiset(C),multiset(B),image_mset(C,B,F2),X5)),Y) = aa(set(C),nat,aa(fun(C,nat),fun(set(C),nat),groups7311177749621191930dd_sum(C,nat),aa(multiset(C),fun(C,nat),count(C),X5)),aa(fun(C,$o),set(C),collect(C),aa(B,fun(C,$o),aa(multiset(C),fun(B,fun(C,$o)),aTP_Lamp_apa(fun(C,B),fun(multiset(C),fun(B,fun(C,$o))),F2),X5),Y))) ) ).

% count_image_mset'
tff(fact_4999_count__induct,axiom,
    ! [B: $tType,Y: fun(B,nat),Pa: fun(fun(B,nat),$o)] :
      ( aa(set(fun(B,nat)),$o,member(fun(B,nat),Y),aa(fun(fun(B,nat),$o),set(fun(B,nat)),collect(fun(B,nat)),aTP_Lamp_apb(fun(B,nat),$o)))
     => ( ! [X: multiset(B)] : aa(fun(B,nat),$o,Pa,aa(multiset(B),fun(B,nat),count(B),X))
       => aa(fun(B,nat),$o,Pa,Y) ) ) ).

% count_induct
tff(fact_5000_count__cases,axiom,
    ! [B: $tType,Y: fun(B,nat)] :
      ( aa(set(fun(B,nat)),$o,member(fun(B,nat),Y),aa(fun(fun(B,nat),$o),set(fun(B,nat)),collect(fun(B,nat)),aTP_Lamp_apb(fun(B,nat),$o)))
     => ~ ! [X: multiset(B)] : ( Y != aa(multiset(B),fun(B,nat),count(B),X) ) ) ).

% count_cases
tff(fact_5001_count,axiom,
    ! [B: $tType,X2: multiset(B)] : aa(set(fun(B,nat)),$o,member(fun(B,nat),aa(multiset(B),fun(B,nat),count(B),X2)),aa(fun(fun(B,nat),$o),set(fun(B,nat)),collect(fun(B,nat)),aTP_Lamp_apb(fun(B,nat),$o))) ).

% count
tff(fact_5002_Inf__multiset_Orep__eq,axiom,
    ! [B: $tType,X2: set(multiset(B)),X4: B] :
      ( aa(B,nat,aa(multiset(B),fun(B,nat),count(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X2)),X4)
      = $ite(aa(set(multiset(B)),set(fun(B,nat)),image2(multiset(B),fun(B,nat),count(B)),X2) = bot_bot(set(fun(B,nat))),zero_zero(nat),aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(fun(B,nat)),set(nat),image2(fun(B,nat),nat,aTP_Lamp_apc(B,fun(fun(B,nat),nat),X4)),aa(set(multiset(B)),set(fun(B,nat)),image2(multiset(B),fun(B,nat),count(B)),X2)))) ) ).

% Inf_multiset.rep_eq
tff(fact_5003_count__Inf__multiset__nonempty,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: B] :
      ( ( A3 != bot_bot(set(multiset(B))) )
     => ( aa(B,nat,aa(multiset(B),fun(B,nat),count(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A3)),X2) = aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(multiset(B)),set(nat),image2(multiset(B),nat,aTP_Lamp_apd(B,fun(multiset(B),nat),X2)),A3)) ) ) ).

% count_Inf_multiset_nonempty
tff(fact_5004_size__multiset__eq,axiom,
    ! [B: $tType,F2: fun(B,nat),M: multiset(B)] : ( aa(multiset(B),nat,size_multiset(B,F2),M) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(multiset(B),fun(B,nat),aTP_Lamp_ape(fun(B,nat),fun(multiset(B),fun(B,nat)),F2),M)),aa(multiset(B),set(B),set_mset(B),M)) ) ).

% size_multiset_eq
tff(fact_5005_multiset_Oin__rel,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),A4: multiset(B),B3: multiset(C)] :
      ( aa(multiset(C),$o,aa(multiset(B),fun(multiset(C),$o),rel_mset(B,C,R),A4),B3)
    <=> ? [Z5: multiset(product_prod(B,C))] :
          ( aa(set(multiset(product_prod(B,C))),$o,member(multiset(product_prod(B,C)),Z5),aa(fun(multiset(product_prod(B,C)),$o),set(multiset(product_prod(B,C))),collect(multiset(product_prod(B,C))),aTP_Lamp_apf(fun(B,fun(C,$o)),fun(multiset(product_prod(B,C)),$o),R)))
          & ( aa(multiset(product_prod(B,C)),multiset(B),image_mset(product_prod(B,C),B,product_fst(B,C)),Z5) = A4 )
          & ( aa(multiset(product_prod(B,C)),multiset(C),image_mset(product_prod(B,C),C,product_snd(B,C)),Z5) = B3 ) ) ) ).

% multiset.in_rel
tff(fact_5006_fold__mset__def,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,fun(B,B)),S2: B,M: multiset(C)] : ( fold_mset(C,B,F2,S2,M) = finite_fold(C,B,aa(multiset(C),fun(C,fun(B,B)),aTP_Lamp_apg(fun(C,fun(B,B)),fun(multiset(C),fun(C,fun(B,B))),F2),M),S2,aa(multiset(C),set(C),set_mset(C),M)) ) ).

% fold_mset_def
tff(fact_5007_multiset_Orel__map_I2_J,axiom,
    ! [B: $tType,C: $tType,D: $tType,Sa: fun(B,fun(C,$o)),X2: multiset(B),G: fun(D,C),Y: multiset(D)] :
      ( aa(multiset(C),$o,aa(multiset(B),fun(multiset(C),$o),rel_mset(B,C,Sa),X2),aa(multiset(D),multiset(C),image_mset(D,C,G),Y))
    <=> aa(multiset(D),$o,aa(multiset(B),fun(multiset(D),$o),rel_mset(B,D,aa(fun(D,C),fun(B,fun(D,$o)),aTP_Lamp_aod(fun(B,fun(C,$o)),fun(fun(D,C),fun(B,fun(D,$o))),Sa),G)),X2),Y) ) ).

% multiset.rel_map(2)
tff(fact_5008_multiset_Orel__map_I1_J,axiom,
    ! [D: $tType,B: $tType,C: $tType,Sb: fun(B,fun(C,$o)),I2: fun(D,B),X2: multiset(D),Y: multiset(C)] :
      ( aa(multiset(C),$o,aa(multiset(B),fun(multiset(C),$o),rel_mset(B,C,Sb),aa(multiset(D),multiset(B),image_mset(D,B,I2),X2)),Y)
    <=> aa(multiset(C),$o,aa(multiset(D),fun(multiset(C),$o),rel_mset(D,C,aa(fun(D,B),fun(D,fun(C,$o)),aTP_Lamp_aoe(fun(B,fun(C,$o)),fun(fun(D,B),fun(D,fun(C,$o))),Sb),I2)),X2),Y) ) ).

% multiset.rel_map(1)
tff(fact_5009_sorted__list__of__multiset__def,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [M: multiset(B)] : ( linord6283353356039996273ltiset(B,M) = fold_mset(B,list(B),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),nil(B),M) ) ) ).

% sorted_list_of_multiset_def
tff(fact_5010_Inf__multiset__def,axiom,
    ! [B: $tType] : ( complete_Inf_Inf(multiset(B)) = aa(fun(set(fun(B,nat)),fun(B,nat)),fun(set(multiset(B)),multiset(B)),map_fun(set(multiset(B)),set(fun(B,nat)),fun(B,nat),multiset(B),image2(multiset(B),fun(B,nat),count(B)),abs_multiset(B)),aTP_Lamp_aph(set(fun(B,nat)),fun(B,nat))) ) ).

% Inf_multiset_def
tff(fact_5011_count__Abs__multiset,axiom,
    ! [B: $tType,F2: fun(B,nat)] :
      ( aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_tk(fun(B,nat),fun(B,$o),F2)))
     => ( aa(multiset(B),fun(B,nat),count(B),aa(fun(B,nat),multiset(B),abs_multiset(B),F2)) = F2 ) ) ).

% count_Abs_multiset
tff(fact_5012_sum__mset__delta_H,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_1(B)
     => ! [Y: C,Ca: B,A3: multiset(C)] : ( comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_api(C,fun(B,fun(C,B)),Y),Ca)),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),Ca),aa(nat,B,semiring_1_of_nat(B),aa(C,nat,aa(multiset(C),fun(C,nat),count(C),A3),Y))) ) ) ).

% sum_mset_delta'
tff(fact_5013_Union__image__single__mset,axiom,
    ! [B: $tType,M2: multiset(B)] : ( comm_m7189776963980413722m_mset(multiset(B),aa(multiset(B),multiset(multiset(B)),image_mset(B,multiset(B),aTP_Lamp_ahs(B,multiset(B))),M2)) = M2 ) ).

% Union_image_single_mset
tff(fact_5014_sum__mset_Oneutral__const,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: multiset(C)] : ( comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aTP_Lamp_ny(C,B)),A3)) = zero_zero(B) ) ) ).

% sum_mset.neutral_const
tff(fact_5015_set__mset__Union__mset,axiom,
    ! [B: $tType,MM: multiset(multiset(B))] : ( aa(multiset(B),set(B),set_mset(B),comm_m7189776963980413722m_mset(multiset(B),MM)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(multiset(B)),set(set(B)),image2(multiset(B),set(B),set_mset(B)),aa(multiset(multiset(B)),set(multiset(B)),set_mset(multiset(B)),MM))) ) ).

% set_mset_Union_mset
tff(fact_5016_sum__mset__replicate__mset,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat,A4: B] : ( comm_m7189776963980413722m_mset(B,replicate_mset(B,N,A4)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),A4) ) ) ).

% sum_mset_replicate_mset
tff(fact_5017_sum__mset_Oswap,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(C,fun(D,B)),B2: multiset(D),A3: multiset(C)] : ( comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(multiset(D),fun(C,B),aTP_Lamp_apj(fun(C,fun(D,B)),fun(multiset(D),fun(C,B)),G),B2)),A3)) = comm_m7189776963980413722m_mset(B,aa(multiset(D),multiset(B),image_mset(D,B,aa(multiset(C),fun(D,B),aTP_Lamp_apk(fun(C,fun(D,B)),fun(multiset(C),fun(D,B)),G),A3)),B2)) ) ) ).

% sum_mset.swap
tff(fact_5018_sum__mset_Odistrib,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(C,B),H2: fun(C,B),A3: multiset(C)] : ( comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_op(fun(C,B),fun(fun(C,B),fun(C,B)),G),H2)),A3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,G),A3))),comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,H2),A3))) ) ) ).

% sum_mset.distrib
tff(fact_5019_sum__mset__distrib__left,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Ca: B,F2: fun(C,B),M: multiset(C)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),Ca),comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,F2),M))) = comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ot(B,fun(fun(C,B),fun(C,B)),Ca),F2)),M)) ) ) ).

% sum_mset_distrib_left
tff(fact_5020_sum__mset__distrib__right,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [F2: fun(C,B),M: multiset(C),Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,F2),M))),Ca) = comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_os(fun(C,B),fun(B,fun(C,B)),F2),Ca)),M)) ) ) ).

% sum_mset_distrib_right
tff(fact_5021_sum__mset__product,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add(C)
        & times(C)
        & semiring_0(B) )
     => ! [F2: fun(C,B),A3: multiset(C),G: fun(D,B),B2: multiset(D)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,F2),A3))),comm_m7189776963980413722m_mset(B,aa(multiset(D),multiset(B),image_mset(D,B,G),B2))) = comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(multiset(D),fun(C,B),aa(fun(D,B),fun(multiset(D),fun(C,B)),aTP_Lamp_apm(fun(C,B),fun(fun(D,B),fun(multiset(D),fun(C,B))),F2),G),B2)),A3)) ) ) ).

% sum_mset_product
tff(fact_5022_zero__multiset__def,axiom,
    ! [B: $tType] : ( zero_zero(multiset(B)) = aa(fun(B,nat),multiset(B),abs_multiset(B),aTP_Lamp_apn(B,nat)) ) ).

% zero_multiset_def
tff(fact_5023_Abs__multiset__inject,axiom,
    ! [B: $tType,X2: fun(B,nat),Y: fun(B,nat)] :
      ( aa(set(fun(B,nat)),$o,member(fun(B,nat),X2),aa(fun(fun(B,nat),$o),set(fun(B,nat)),collect(fun(B,nat)),aTP_Lamp_apb(fun(B,nat),$o)))
     => ( aa(set(fun(B,nat)),$o,member(fun(B,nat),Y),aa(fun(fun(B,nat),$o),set(fun(B,nat)),collect(fun(B,nat)),aTP_Lamp_apb(fun(B,nat),$o)))
       => ( ( aa(fun(B,nat),multiset(B),abs_multiset(B),X2) = aa(fun(B,nat),multiset(B),abs_multiset(B),Y) )
        <=> ( X2 = Y ) ) ) ) ).

% Abs_multiset_inject
tff(fact_5024_Abs__multiset__induct,axiom,
    ! [B: $tType,Pa: fun(multiset(B),$o),X2: multiset(B)] :
      ( ! [Y2: fun(B,nat)] :
          ( aa(set(fun(B,nat)),$o,member(fun(B,nat),Y2),aa(fun(fun(B,nat),$o),set(fun(B,nat)),collect(fun(B,nat)),aTP_Lamp_apb(fun(B,nat),$o)))
         => aa(multiset(B),$o,Pa,aa(fun(B,nat),multiset(B),abs_multiset(B),Y2)) )
     => aa(multiset(B),$o,Pa,X2) ) ).

% Abs_multiset_induct
tff(fact_5025_Abs__multiset__cases,axiom,
    ! [B: $tType,X2: multiset(B)] :
      ~ ! [Y2: fun(B,nat)] :
          ( ( X2 = aa(fun(B,nat),multiset(B),abs_multiset(B),Y2) )
         => ~ aa(set(fun(B,nat)),$o,member(fun(B,nat),Y2),aa(fun(fun(B,nat),$o),set(fun(B,nat)),collect(fun(B,nat)),aTP_Lamp_apb(fun(B,nat),$o))) ) ).

% Abs_multiset_cases
tff(fact_5026_plus__multiset__def,axiom,
    ! [B: $tType] : ( plus_plus(multiset(B)) = aa(fun(fun(B,nat),fun(fun(B,nat),fun(B,nat))),fun(multiset(B),fun(multiset(B),multiset(B))),map_fun(multiset(B),fun(B,nat),fun(fun(B,nat),fun(B,nat)),fun(multiset(B),multiset(B)),count(B),map_fun(multiset(B),fun(B,nat),fun(B,nat),multiset(B),count(B),abs_multiset(B))),aTP_Lamp_apo(fun(B,nat),fun(fun(B,nat),fun(B,nat)))) ) ).

% plus_multiset_def
tff(fact_5027_minus__multiset__def,axiom,
    ! [B: $tType] : ( minus_minus(multiset(B)) = aa(fun(fun(B,nat),fun(fun(B,nat),fun(B,nat))),fun(multiset(B),fun(multiset(B),multiset(B))),map_fun(multiset(B),fun(B,nat),fun(fun(B,nat),fun(B,nat)),fun(multiset(B),multiset(B)),count(B),map_fun(multiset(B),fun(B,nat),fun(B,nat),multiset(B),count(B),abs_multiset(B))),aTP_Lamp_app(fun(B,nat),fun(fun(B,nat),fun(B,nat)))) ) ).

% minus_multiset_def
tff(fact_5028_type__definition__multiset,axiom,
    ! [B: $tType] : type_definition(multiset(B),fun(B,nat),count(B),abs_multiset(B),aa(fun(fun(B,nat),$o),set(fun(B,nat)),collect(fun(B,nat)),aTP_Lamp_apb(fun(B,nat),$o))) ).

% type_definition_multiset
tff(fact_5029_Abs__multiset__inverse,axiom,
    ! [B: $tType,Y: fun(B,nat)] :
      ( aa(set(fun(B,nat)),$o,member(fun(B,nat),Y),aa(fun(fun(B,nat),$o),set(fun(B,nat)),collect(fun(B,nat)),aTP_Lamp_apb(fun(B,nat),$o)))
     => ( aa(multiset(B),fun(B,nat),count(B),aa(fun(B,nat),multiset(B),abs_multiset(B),Y)) = Y ) ) ).

% Abs_multiset_inverse
tff(fact_5030_add__mset__def,axiom,
    ! [B: $tType] : ( add_mset(B) = aa(fun(B,fun(fun(B,nat),fun(B,nat))),fun(B,fun(multiset(B),multiset(B))),map_fun(B,B,fun(fun(B,nat),fun(B,nat)),fun(multiset(B),multiset(B)),id(B),map_fun(multiset(B),fun(B,nat),fun(B,nat),multiset(B),count(B),abs_multiset(B))),aTP_Lamp_apq(B,fun(fun(B,nat),fun(B,nat)))) ) ).

% add_mset_def
tff(fact_5031_sum__mset__delta,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_1(B)
     => ! [Y: C,Ca: B,A3: multiset(C)] : ( comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_apr(C,fun(B,fun(C,B)),Y),Ca)),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),Ca),aa(nat,B,semiring_1_of_nat(B),aa(C,nat,aa(multiset(C),fun(C,nat),count(C),A3),Y))) ) ) ).

% sum_mset_delta
tff(fact_5032_minus__multiset_Oabs__eq,axiom,
    ! [B: $tType,Xa: fun(B,nat),X2: fun(B,nat)] :
      ( aa(fun(B,nat),$o,aa(fun(B,nat),fun(fun(B,nat),$o),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),Xa),Xa)
     => ( aa(fun(B,nat),$o,aa(fun(B,nat),fun(fun(B,nat),$o),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),X2),X2)
       => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),aa(fun(B,nat),multiset(B),abs_multiset(B),Xa)),aa(fun(B,nat),multiset(B),abs_multiset(B),X2)) = aa(fun(B,nat),multiset(B),abs_multiset(B),aa(fun(B,nat),fun(B,nat),aa(fun(B,nat),fun(fun(B,nat),fun(B,nat)),aTP_Lamp_app(fun(B,nat),fun(fun(B,nat),fun(B,nat))),Xa),X2)) ) ) ) ).

% minus_multiset.abs_eq
tff(fact_5033_plus__multiset_Oabs__eq,axiom,
    ! [B: $tType,Xa: fun(B,nat),X2: fun(B,nat)] :
      ( aa(fun(B,nat),$o,aa(fun(B,nat),fun(fun(B,nat),$o),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),Xa),Xa)
     => ( aa(fun(B,nat),$o,aa(fun(B,nat),fun(fun(B,nat),$o),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),X2),X2)
       => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),aa(fun(B,nat),multiset(B),abs_multiset(B),Xa)),aa(fun(B,nat),multiset(B),abs_multiset(B),X2)) = aa(fun(B,nat),multiset(B),abs_multiset(B),aa(fun(B,nat),fun(B,nat),aa(fun(B,nat),fun(fun(B,nat),fun(B,nat)),aTP_Lamp_apo(fun(B,nat),fun(fun(B,nat),fun(B,nat))),Xa),X2)) ) ) ) ).

% plus_multiset.abs_eq
tff(fact_5034_add__mset_Oabs__eq,axiom,
    ! [B: $tType,X2: fun(B,nat),Xa: B] :
      ( aa(fun(B,nat),$o,aa(fun(B,nat),fun(fun(B,nat),$o),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),X2),X2)
     => ( aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),Xa),aa(fun(B,nat),multiset(B),abs_multiset(B),X2)) = aa(fun(B,nat),multiset(B),abs_multiset(B),aa(B,fun(B,nat),aTP_Lamp_aps(fun(B,nat),fun(B,fun(B,nat)),X2),Xa)) ) ) ).

% add_mset.abs_eq
tff(fact_5035_eq__onp__def,axiom,
    ! [B: $tType,R: fun(B,$o),X4: B,Xa3: B] :
      ( aa(B,$o,aa(B,fun(B,$o),bNF_eq_onp(B,R),X4),Xa3)
    <=> ( aa(B,$o,R,X4)
        & ( X4 = Xa3 ) ) ) ).

% eq_onp_def
tff(fact_5036_eq__onp__True,axiom,
    ! [B: $tType] : ( bNF_eq_onp(B,aTP_Lamp_nh(B,$o)) = fequal(B) ) ).

% eq_onp_True
tff(fact_5037_fun_Orel__eq__onp,axiom,
    ! [B: $tType,C: $tType,Pa: fun(C,$o)] : ( bNF_rel_fun(B,B,C,C,fequal(B),bNF_eq_onp(C,Pa)) = bNF_eq_onp(fun(B,C),aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,aTP_Lamp_nh(B,$o)),Pa)) ) ).

% fun.rel_eq_onp
tff(fact_5038_rel__fun__eq__eq__onp,axiom,
    ! [B: $tType,C: $tType,Pa: fun(C,$o)] : ( bNF_rel_fun(B,B,C,C,fequal(B),bNF_eq_onp(C,Pa)) = bNF_eq_onp(fun(B,C),aTP_Lamp_apt(fun(C,$o),fun(fun(B,C),$o),Pa)) ) ).

% rel_fun_eq_eq_onp
tff(fact_5039_fun_Opred__rel,axiom,
    ! [C: $tType,B: $tType,Pa: fun(C,$o),X2: fun(B,C)] :
      ( aa(fun(B,C),$o,aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,aTP_Lamp_nh(B,$o)),Pa),X2)
    <=> aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),bNF_rel_fun(B,B,C,C,fequal(B),bNF_eq_onp(C,Pa)),X2),X2) ) ).

% fun.pred_rel
tff(fact_5040_rel__fun__eq__onp__rel,axiom,
    ! [C: $tType,D: $tType,B: $tType,R: fun(B,$o),S: fun(C,fun(D,$o)),X4: fun(B,C),Xa3: fun(B,D)] :
      ( aa(fun(B,D),$o,aa(fun(B,C),fun(fun(B,D),$o),bNF_rel_fun(B,B,C,D,bNF_eq_onp(B,R),S),X4),Xa3)
    <=> ! [Xb2: B] :
          ( aa(B,$o,R,Xb2)
         => aa(D,$o,aa(C,fun(D,$o),S,aa(B,C,X4,Xb2)),aa(B,D,Xa3,Xb2)) ) ) ).

% rel_fun_eq_onp_rel
tff(fact_5041_filter__mset_Orsp,axiom,
    ! [B: $tType] : aa(fun(fun(B,$o),fun(fun(B,nat),fun(B,nat))),$o,aa(fun(fun(B,$o),fun(fun(B,nat),fun(B,nat))),fun(fun(fun(B,$o),fun(fun(B,nat),fun(B,nat))),$o),bNF_rel_fun(fun(B,$o),fun(B,$o),fun(fun(B,nat),fun(B,nat)),fun(fun(B,nat),fun(B,nat)),fequal(fun(B,$o)),bNF_rel_fun(fun(B,nat),fun(B,nat),fun(B,nat),fun(B,nat),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)))),aTP_Lamp_apu(fun(B,$o),fun(fun(B,nat),fun(B,nat)))),aTP_Lamp_apu(fun(B,$o),fun(fun(B,nat),fun(B,nat)))) ).

% filter_mset.rsp
tff(fact_5042_zero__multiset_Orsp,axiom,
    ! [B: $tType] : aa(fun(B,nat),$o,aa(fun(B,nat),fun(fun(B,nat),$o),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),aTP_Lamp_apn(B,nat)),aTP_Lamp_apn(B,nat)) ).

% zero_multiset.rsp
tff(fact_5043_add__mset_Orsp,axiom,
    ! [B: $tType] : aa(fun(B,fun(fun(B,nat),fun(B,nat))),$o,aa(fun(B,fun(fun(B,nat),fun(B,nat))),fun(fun(B,fun(fun(B,nat),fun(B,nat))),$o),bNF_rel_fun(B,B,fun(fun(B,nat),fun(B,nat)),fun(fun(B,nat),fun(B,nat)),fequal(B),bNF_rel_fun(fun(B,nat),fun(B,nat),fun(B,nat),fun(B,nat),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)))),aTP_Lamp_apq(B,fun(fun(B,nat),fun(B,nat)))),aTP_Lamp_apq(B,fun(fun(B,nat),fun(B,nat)))) ).

% add_mset.rsp
tff(fact_5044_plus__multiset_Orsp,axiom,
    ! [B: $tType] : aa(fun(fun(B,nat),fun(fun(B,nat),fun(B,nat))),$o,aa(fun(fun(B,nat),fun(fun(B,nat),fun(B,nat))),fun(fun(fun(B,nat),fun(fun(B,nat),fun(B,nat))),$o),bNF_rel_fun(fun(B,nat),fun(B,nat),fun(fun(B,nat),fun(B,nat)),fun(fun(B,nat),fun(B,nat)),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),bNF_rel_fun(fun(B,nat),fun(B,nat),fun(B,nat),fun(B,nat),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)))),aTP_Lamp_apo(fun(B,nat),fun(fun(B,nat),fun(B,nat)))),aTP_Lamp_apo(fun(B,nat),fun(fun(B,nat),fun(B,nat)))) ).

% plus_multiset.rsp
tff(fact_5045_minus__multiset_Orsp,axiom,
    ! [B: $tType] : aa(fun(fun(B,nat),fun(fun(B,nat),fun(B,nat))),$o,aa(fun(fun(B,nat),fun(fun(B,nat),fun(B,nat))),fun(fun(fun(B,nat),fun(fun(B,nat),fun(B,nat))),$o),bNF_rel_fun(fun(B,nat),fun(B,nat),fun(fun(B,nat),fun(B,nat)),fun(fun(B,nat),fun(B,nat)),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),bNF_rel_fun(fun(B,nat),fun(B,nat),fun(B,nat),fun(B,nat),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)))),aTP_Lamp_app(fun(B,nat),fun(fun(B,nat),fun(B,nat)))),aTP_Lamp_app(fun(B,nat),fun(fun(B,nat),fun(B,nat)))) ).

% minus_multiset.rsp
tff(fact_5046_repeat__mset_Orsp,axiom,
    ! [B: $tType] : aa(fun(nat,fun(fun(B,nat),fun(B,nat))),$o,aa(fun(nat,fun(fun(B,nat),fun(B,nat))),fun(fun(nat,fun(fun(B,nat),fun(B,nat))),$o),bNF_rel_fun(nat,nat,fun(fun(B,nat),fun(B,nat)),fun(fun(B,nat),fun(B,nat)),fequal(nat),bNF_rel_fun(fun(B,nat),fun(B,nat),fun(B,nat),fun(B,nat),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)))),aTP_Lamp_apv(nat,fun(fun(B,nat),fun(B,nat)))),aTP_Lamp_apv(nat,fun(fun(B,nat),fun(B,nat)))) ).

% repeat_mset.rsp
tff(fact_5047_Inf__multiset_Oabs__eq,axiom,
    ! [B: $tType,X2: set(fun(B,nat))] :
      ( aa(set(fun(B,nat)),$o,aa(set(fun(B,nat)),fun(set(fun(B,nat)),$o),bNF_rel_set(fun(B,nat),fun(B,nat),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o))),X2),X2)
     => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(fun(B,nat)),set(multiset(B)),image2(fun(B,nat),multiset(B),abs_multiset(B)),X2)) = aa(fun(B,nat),multiset(B),abs_multiset(B),aa(set(fun(B,nat)),fun(B,nat),aTP_Lamp_aph(set(fun(B,nat)),fun(B,nat)),X2)) ) ) ).

% Inf_multiset.abs_eq
tff(fact_5048_repeat__mset_Oabs__eq,axiom,
    ! [B: $tType,X2: fun(B,nat),Xa: nat] :
      ( aa(fun(B,nat),$o,aa(fun(B,nat),fun(fun(B,nat),$o),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),X2),X2)
     => ( aa(multiset(B),multiset(B),aa(nat,fun(multiset(B),multiset(B)),repeat_mset(B),Xa),aa(fun(B,nat),multiset(B),abs_multiset(B),X2)) = aa(fun(B,nat),multiset(B),abs_multiset(B),aa(nat,fun(B,nat),aTP_Lamp_apw(fun(B,nat),fun(nat,fun(B,nat)),X2),Xa)) ) ) ).

% repeat_mset.abs_eq
tff(fact_5049_Inf__multiset_Orsp,axiom,
    ! [B: $tType] : aa(fun(set(fun(B,nat)),fun(B,nat)),$o,aa(fun(set(fun(B,nat)),fun(B,nat)),fun(fun(set(fun(B,nat)),fun(B,nat)),$o),bNF_rel_fun(set(fun(B,nat)),set(fun(B,nat)),fun(B,nat),fun(B,nat),bNF_rel_set(fun(B,nat),fun(B,nat),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o))),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o))),aTP_Lamp_aph(set(fun(B,nat)),fun(B,nat))),aTP_Lamp_aph(set(fun(B,nat)),fun(B,nat))) ).

% Inf_multiset.rsp
tff(fact_5050_rel__set__def,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),X4: set(B),Xa3: set(C)] :
      ( aa(set(C),$o,aa(set(B),fun(set(C),$o),bNF_rel_set(B,C,R),X4),Xa3)
    <=> ( ! [Xb2: B] :
            ( aa(set(B),$o,member(B,Xb2),X4)
           => ? [Xc: C] :
                ( aa(set(C),$o,member(C,Xc),Xa3)
                & aa(C,$o,aa(B,fun(C,$o),R,Xb2),Xc) ) )
        & ! [Xb2: C] :
            ( aa(set(C),$o,member(C,Xb2),Xa3)
           => ? [Xc: B] :
                ( aa(set(B),$o,member(B,Xc),X4)
                & aa(C,$o,aa(B,fun(C,$o),R,Xc),Xb2) ) ) ) ) ).

% rel_set_def
tff(fact_5051_fun_Oset__transfer,axiom,
    ! [C: $tType,D: $tType,B: $tType,R: fun(C,fun(D,$o))] : aa(fun(fun(B,D),set(D)),$o,aa(fun(fun(B,C),set(C)),fun(fun(fun(B,D),set(D)),$o),bNF_rel_fun(fun(B,C),fun(B,D),set(C),set(D),bNF_rel_fun(B,B,C,D,fequal(B),R),bNF_rel_set(C,D,R)),aTP_Lamp_apx(fun(B,C),set(C))),aTP_Lamp_apy(fun(B,D),set(D))) ).

% fun.set_transfer
tff(fact_5052_repeat__mset__def,axiom,
    ! [B: $tType] : ( repeat_mset(B) = aa(fun(nat,fun(fun(B,nat),fun(B,nat))),fun(nat,fun(multiset(B),multiset(B))),map_fun(nat,nat,fun(fun(B,nat),fun(B,nat)),fun(multiset(B),multiset(B)),id(nat),map_fun(multiset(B),fun(B,nat),fun(B,nat),multiset(B),count(B),abs_multiset(B))),aTP_Lamp_apv(nat,fun(fun(B,nat),fun(B,nat)))) ) ).

% repeat_mset_def
tff(fact_5053_INF__parametric,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( complete_Inf(D)
     => ! [A3: fun(B,fun(C,$o))] : aa(fun(set(C),fun(fun(C,D),D)),$o,aa(fun(set(B),fun(fun(B,D),D)),fun(fun(set(C),fun(fun(C,D),D)),$o),bNF_rel_fun(set(B),set(C),fun(fun(B,D),D),fun(fun(C,D),D),bNF_rel_set(B,C,A3),bNF_rel_fun(fun(B,D),fun(C,D),D,D,bNF_rel_fun(B,C,D,D,A3,fequal(D)),fequal(D))),aTP_Lamp_apz(set(B),fun(fun(B,D),D))),aTP_Lamp_aqa(set(C),fun(fun(C,D),D))) ) ).

% INF_parametric
tff(fact_5054_SUP__parametric,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( complete_Sup(D)
     => ! [R: fun(B,fun(C,$o))] : aa(fun(set(C),fun(fun(C,D),D)),$o,aa(fun(set(B),fun(fun(B,D),D)),fun(fun(set(C),fun(fun(C,D),D)),$o),bNF_rel_fun(set(B),set(C),fun(fun(B,D),D),fun(fun(C,D),D),bNF_rel_set(B,C,R),bNF_rel_fun(fun(B,D),fun(C,D),D,D,bNF_rel_fun(B,C,D,D,R,fequal(D)),fequal(D))),aTP_Lamp_aqb(set(B),fun(fun(B,D),D))),aTP_Lamp_aqc(set(C),fun(fun(C,D),D))) ) ).

% SUP_parametric
tff(fact_5055_UNION__transfer,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,A3: fun(B,fun(C,$o)),B2: fun(D,fun(E,$o))] : aa(fun(set(C),fun(fun(C,set(E)),set(E))),$o,aa(fun(set(B),fun(fun(B,set(D)),set(D))),fun(fun(set(C),fun(fun(C,set(E)),set(E))),$o),bNF_rel_fun(set(B),set(C),fun(fun(B,set(D)),set(D)),fun(fun(C,set(E)),set(E)),bNF_rel_set(B,C,A3),bNF_rel_fun(fun(B,set(D)),fun(C,set(E)),set(D),set(E),bNF_rel_fun(B,C,set(D),set(E),A3,bNF_rel_set(D,E,B2)),bNF_rel_set(D,E,B2))),aTP_Lamp_aqd(set(B),fun(fun(B,set(D)),set(D)))),aTP_Lamp_aqe(set(C),fun(fun(C,set(E)),set(E)))) ).

% UNION_transfer
tff(fact_5056_empty__transfer,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o))] : aa(set(C),$o,aa(set(B),fun(set(C),$o),bNF_rel_set(B,C,A3),bot_bot(set(B))),bot_bot(set(C))) ).

% empty_transfer
tff(fact_5057_Union__transfer,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o))] : aa(fun(set(set(C)),set(C)),$o,aa(fun(set(set(B)),set(B)),fun(fun(set(set(C)),set(C)),$o),bNF_rel_fun(set(set(B)),set(set(C)),set(B),set(C),bNF_rel_set(set(B),set(C),bNF_rel_set(B,C,A3)),bNF_rel_set(B,C,A3)),complete_Sup_Sup(set(B))),complete_Sup_Sup(set(C))) ).

% Union_transfer
tff(fact_5058_set__relator__eq__onp,axiom,
    ! [B: $tType,Pa: fun(B,$o)] : ( bNF_rel_set(B,B,bNF_eq_onp(B,Pa)) = bNF_eq_onp(set(B),aTP_Lamp_aqf(fun(B,$o),fun(set(B),$o),Pa)) ) ).

% set_relator_eq_onp
tff(fact_5059_Inf__multiset_Otransfer,axiom,
    ! [B: $tType] : aa(fun(set(multiset(B)),multiset(B)),$o,aa(fun(set(fun(B,nat)),fun(B,nat)),fun(fun(set(multiset(B)),multiset(B)),$o),bNF_rel_fun(set(fun(B,nat)),set(multiset(B)),fun(B,nat),multiset(B),bNF_rel_set(fun(B,nat),multiset(B),pcr_multiset(B,B,fequal(B))),pcr_multiset(B,B,fequal(B))),aTP_Lamp_aph(set(fun(B,nat)),fun(B,nat))),complete_Inf_Inf(multiset(B))) ).

% Inf_multiset.transfer
tff(fact_5060_filter__mset_Oabs__eq,axiom,
    ! [B: $tType,X2: fun(B,nat),Xa: fun(B,$o)] :
      ( aa(fun(B,nat),$o,aa(fun(B,nat),fun(fun(B,nat),$o),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),X2),X2)
     => ( aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),Xa),aa(fun(B,nat),multiset(B),abs_multiset(B),X2)) = aa(fun(B,nat),multiset(B),abs_multiset(B),aa(fun(B,$o),fun(B,nat),aTP_Lamp_aqg(fun(B,nat),fun(fun(B,$o),fun(B,nat)),X2),Xa)) ) ) ).

% filter_mset.abs_eq
tff(fact_5061_filter__mset__def,axiom,
    ! [B: $tType] : ( filter_mset(B) = aa(fun(fun(B,$o),fun(fun(B,nat),fun(B,nat))),fun(fun(B,$o),fun(multiset(B),multiset(B))),map_fun(fun(B,$o),fun(B,$o),fun(fun(B,nat),fun(B,nat)),fun(multiset(B),multiset(B)),id(fun(B,$o)),map_fun(multiset(B),fun(B,nat),fun(B,nat),multiset(B),count(B),abs_multiset(B))),aTP_Lamp_apu(fun(B,$o),fun(fun(B,nat),fun(B,nat)))) ) ).

% filter_mset_def
tff(fact_5062_filter__mset__True,axiom,
    ! [B: $tType,M: multiset(B)] : ( aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),aTP_Lamp_nh(B,$o)),M) = M ) ).

% filter_mset_True
tff(fact_5063_filter__mset__False,axiom,
    ! [B: $tType,M: multiset(B)] : ( aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),aTP_Lamp_ao(B,$o)),M) = zero_zero(multiset(B)) ) ).

% filter_mset_False
tff(fact_5064_set__mset__filter,axiom,
    ! [B: $tType,Pa: fun(B,$o),M: multiset(B)] : ( aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),Pa),M)) = aa(fun(B,$o),set(B),collect(B),aa(multiset(B),fun(B,$o),aTP_Lamp_aqh(fun(B,$o),fun(multiset(B),fun(B,$o)),Pa),M)) ) ).

% set_mset_filter
tff(fact_5065_filter__mset__mset__set,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,$o)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),Pa),mset_set(B,A3)) = mset_set(B,aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),A3),Pa))) ) ) ).

% filter_mset_mset_set
tff(fact_5066_mset__filter,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B)] : ( mset(B,aa(list(B),list(B),filter2(B,Pa),Xs)) = aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),Pa),mset(B,Xs)) ) ).

% mset_filter
tff(fact_5067_filter__mset_Otransfer,axiom,
    ! [B: $tType] : aa(fun(fun(B,$o),fun(multiset(B),multiset(B))),$o,aa(fun(fun(B,$o),fun(fun(B,nat),fun(B,nat))),fun(fun(fun(B,$o),fun(multiset(B),multiset(B))),$o),bNF_rel_fun(fun(B,$o),fun(B,$o),fun(fun(B,nat),fun(B,nat)),fun(multiset(B),multiset(B)),fequal(fun(B,$o)),bNF_rel_fun(fun(B,nat),multiset(B),fun(B,nat),multiset(B),pcr_multiset(B,B,fequal(B)),pcr_multiset(B,B,fequal(B)))),aTP_Lamp_apu(fun(B,$o),fun(fun(B,nat),fun(B,nat)))),filter_mset(B)) ).

% filter_mset.transfer
tff(fact_5068_filter__filter__mset,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o),M: multiset(B)] : ( aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),Pa),aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),Qa),M)) = aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_aij(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa)),M) ) ).

% filter_filter_mset
tff(fact_5069_multiset__partition,axiom,
    ! [B: $tType,M: multiset(B),Pa: fun(B,$o)] : ( M = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),Pa),M)),aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa)),M)) ) ).

% multiset_partition
tff(fact_5070_image__mset__If,axiom,
    ! [B: $tType,C: $tType,Pa: fun(C,$o),F2: fun(C,B),G: fun(C,B),A3: multiset(C)] : ( aa(multiset(C),multiset(B),image_mset(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_ca(fun(C,$o),fun(fun(C,B),fun(fun(C,B),fun(C,B))),Pa),F2),G)),A3) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),aa(multiset(C),multiset(B),image_mset(C,B,F2),aa(multiset(C),multiset(C),aa(fun(C,$o),fun(multiset(C),multiset(C)),filter_mset(C),Pa),A3))),aa(multiset(C),multiset(B),image_mset(C,B,G),aa(multiset(C),multiset(C),aa(fun(C,$o),fun(multiset(C),multiset(C)),filter_mset(C),aTP_Lamp_cb(fun(C,$o),fun(C,$o),Pa)),A3))) ) ).

% image_mset_If
tff(fact_5071_filter__eq__replicate__mset,axiom,
    ! [B: $tType,X2: B,D2: multiset(B)] : ( aa(multiset(B),multiset(B),aa(fun(B,$o),fun(multiset(B),multiset(B)),filter_mset(B),aTP_Lamp_ct(B,fun(B,$o),X2)),D2) = replicate_mset(B,aa(B,nat,aa(multiset(B),fun(B,nat),count(B),D2),X2),X2) ) ).

% filter_eq_replicate_mset
tff(fact_5072_zero__multiset_Otransfer,axiom,
    ! [B: $tType] : aa(multiset(B),$o,aa(fun(B,nat),fun(multiset(B),$o),pcr_multiset(B,B,fequal(B)),aTP_Lamp_apn(B,nat)),zero_zero(multiset(B))) ).

% zero_multiset.transfer
tff(fact_5073_multiset_Orep__transfer,axiom,
    ! [B: $tType,C: $tType,T2: fun(B,fun(C,$o))] : aa(fun(multiset(C),fun(C,nat)),$o,aa(fun(fun(B,nat),fun(B,nat)),fun(fun(multiset(C),fun(C,nat)),$o),bNF_rel_fun(fun(B,nat),multiset(C),fun(B,nat),fun(C,nat),pcr_multiset(B,C,T2),bNF_rel_fun(B,C,nat,nat,T2,fequal(nat))),aTP_Lamp_aqi(fun(B,nat),fun(B,nat))),count(C)) ).

% multiset.rep_transfer
tff(fact_5074_add__mset_Otransfer,axiom,
    ! [B: $tType] : aa(fun(B,fun(multiset(B),multiset(B))),$o,aa(fun(B,fun(fun(B,nat),fun(B,nat))),fun(fun(B,fun(multiset(B),multiset(B))),$o),bNF_rel_fun(B,B,fun(fun(B,nat),fun(B,nat)),fun(multiset(B),multiset(B)),fequal(B),bNF_rel_fun(fun(B,nat),multiset(B),fun(B,nat),multiset(B),pcr_multiset(B,B,fequal(B)),pcr_multiset(B,B,fequal(B)))),aTP_Lamp_apq(B,fun(fun(B,nat),fun(B,nat)))),add_mset(B)) ).

% add_mset.transfer
tff(fact_5075_plus__multiset_Otransfer,axiom,
    ! [B: $tType] : aa(fun(multiset(B),fun(multiset(B),multiset(B))),$o,aa(fun(fun(B,nat),fun(fun(B,nat),fun(B,nat))),fun(fun(multiset(B),fun(multiset(B),multiset(B))),$o),bNF_rel_fun(fun(B,nat),multiset(B),fun(fun(B,nat),fun(B,nat)),fun(multiset(B),multiset(B)),pcr_multiset(B,B,fequal(B)),bNF_rel_fun(fun(B,nat),multiset(B),fun(B,nat),multiset(B),pcr_multiset(B,B,fequal(B)),pcr_multiset(B,B,fequal(B)))),aTP_Lamp_apo(fun(B,nat),fun(fun(B,nat),fun(B,nat)))),plus_plus(multiset(B))) ).

% plus_multiset.transfer
tff(fact_5076_minus__multiset_Otransfer,axiom,
    ! [B: $tType] : aa(fun(multiset(B),fun(multiset(B),multiset(B))),$o,aa(fun(fun(B,nat),fun(fun(B,nat),fun(B,nat))),fun(fun(multiset(B),fun(multiset(B),multiset(B))),$o),bNF_rel_fun(fun(B,nat),multiset(B),fun(fun(B,nat),fun(B,nat)),fun(multiset(B),multiset(B)),pcr_multiset(B,B,fequal(B)),bNF_rel_fun(fun(B,nat),multiset(B),fun(B,nat),multiset(B),pcr_multiset(B,B,fequal(B)),pcr_multiset(B,B,fequal(B)))),aTP_Lamp_app(fun(B,nat),fun(fun(B,nat),fun(B,nat)))),minus_minus(multiset(B))) ).

% minus_multiset.transfer
tff(fact_5077_repeat__mset_Otransfer,axiom,
    ! [B: $tType] : aa(fun(nat,fun(multiset(B),multiset(B))),$o,aa(fun(nat,fun(fun(B,nat),fun(B,nat))),fun(fun(nat,fun(multiset(B),multiset(B))),$o),bNF_rel_fun(nat,nat,fun(fun(B,nat),fun(B,nat)),fun(multiset(B),multiset(B)),fequal(nat),bNF_rel_fun(fun(B,nat),multiset(B),fun(B,nat),multiset(B),pcr_multiset(B,B,fequal(B)),pcr_multiset(B,B,fequal(B)))),aTP_Lamp_apv(nat,fun(fun(B,nat),fun(B,nat)))),repeat_mset(B)) ).

% repeat_mset.transfer
tff(fact_5078_minus__coset__filter,axiom,
    ! [B: $tType,A3: set(B),Xs: list(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),coset(B,Xs)) = aa(list(B),set(B),set2(B),aa(list(B),list(B),filter2(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3)),Xs)) ) ).

% minus_coset_filter
tff(fact_5079_multiset_Odomain,axiom,
    ! [B: $tType,C: $tType,T2: fun(B,fun(C,$o)),X4: fun(B,nat)] :
      ( aa(fun(B,nat),$o,aa(fun(fun(B,nat),fun(multiset(C),$o)),fun(fun(B,nat),$o),domainp(fun(B,nat),multiset(C)),pcr_multiset(B,C,T2)),X4)
    <=> ? [Y4: fun(C,nat)] :
          ( aa(fun(C,nat),$o,aa(fun(B,nat),fun(fun(C,nat),$o),bNF_rel_fun(B,C,nat,nat,T2,fequal(nat)),X4),Y4)
          & aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aTP_Lamp_aqj(fun(C,nat),fun(C,$o),Y4))) ) ) ).

% multiset.domain
tff(fact_5080_set__take__disj__set__drop__if__distinct,axiom,
    ! [B: $tType,Vs: list(B),I2: nat,J2: nat] :
      ( distinct(B,Vs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),take(B,I2,Vs))),aa(list(B),set(B),set2(B),drop(B,J2,Vs))) = bot_bot(set(B)) ) ) ) ).

% set_take_disj_set_drop_if_distinct
tff(fact_5081_fun_ODomainp__rel,axiom,
    ! [B: $tType,D: $tType,C: $tType,R: fun(C,fun(D,$o))] : ( aa(fun(fun(B,C),fun(fun(B,D),$o)),fun(fun(B,C),$o),domainp(fun(B,C),fun(B,D)),bNF_rel_fun(B,B,C,D,fequal(B),R)) = aa(fun(C,$o),fun(fun(B,C),$o),basic_pred_fun(B,C,aTP_Lamp_nh(B,$o)),aa(fun(C,fun(D,$o)),fun(C,$o),domainp(C,D),R)) ) ).

% fun.Domainp_rel
tff(fact_5082_filter__upt__take__conv,axiom,
    ! [B: $tType,Pa: fun(B,$o),M2: nat,L: list(B),N: nat] : ( aa(list(nat),list(nat),filter2(nat,aa(list(B),fun(nat,$o),aa(nat,fun(list(B),fun(nat,$o)),aTP_Lamp_aqk(fun(B,$o),fun(nat,fun(list(B),fun(nat,$o))),Pa),M2),L)),upt(N,M2)) = aa(list(nat),list(nat),filter2(nat,aa(list(B),fun(nat,$o),aTP_Lamp_ana(fun(B,$o),fun(list(B),fun(nat,$o)),Pa),L)),upt(N,M2)) ) ).

% filter_upt_take_conv
tff(fact_5083_take__Cons,axiom,
    ! [B: $tType,N: nat,X2: B,Xs: list(B)] : ( take(B,N,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(nat,list(B),aa(fun(nat,list(B)),fun(nat,list(B)),aa(list(B),fun(fun(nat,list(B)),fun(nat,list(B))),case_nat(list(B)),nil(B)),aa(list(B),fun(nat,list(B)),aTP_Lamp_aql(B,fun(list(B),fun(nat,list(B))),X2),Xs)),N) ) ).

% take_Cons
tff(fact_5084_union__coset__filter,axiom,
    ! [B: $tType,Xs: list(B),A3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),coset(B,Xs)),A3) = coset(B,aa(list(B),list(B),filter2(B,aTP_Lamp_at(set(B),fun(B,$o),A3)),Xs)) ) ).

% union_coset_filter
tff(fact_5085_inter__coset__fold,axiom,
    ! [B: $tType,A3: set(B),Xs: list(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),coset(B,Xs)) = aa(set(B),set(B),fold(B,set(B),remove(B),Xs),A3) ) ).

% inter_coset_fold
tff(fact_5086_multiset_Odomain__eq,axiom,
    ! [B: $tType,X4: fun(B,nat)] :
      ( aa(fun(B,nat),$o,aa(fun(fun(B,nat),fun(multiset(B),$o)),fun(fun(B,nat),$o),domainp(fun(B,nat),multiset(B)),pcr_multiset(B,B,fequal(B))),X4)
    <=> aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_tk(fun(B,nat),fun(B,$o),X4))) ) ).

% multiset.domain_eq
tff(fact_5087_zip__replicate2,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),N: nat,Y: C] : ( zip(B,C,Xs,replicate(C,N,Y)) = aa(list(B),list(product_prod(B,C)),map(B,product_prod(B,C),aa(C,fun(B,product_prod(B,C)),aTP_Lamp_ej(C,fun(B,product_prod(B,C))),Y)),take(B,N,Xs)) ) ).

% zip_replicate2
tff(fact_5088_multiset_Odomain__par,axiom,
    ! [C: $tType,B: $tType,T2: fun(B,fun(C,$o)),DT: fun(B,$o),DS: fun(nat,$o),P23: fun(fun(B,nat),$o)] :
      ( ( aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),T2) = DT )
     => ( ( aa(fun(nat,fun(nat,$o)),fun(nat,$o),domainp(nat,nat),fequal(nat)) = DS )
       => ( left_unique(B,C,T2)
         => ( aa(fun(fun(C,nat),$o),$o,aa(fun(fun(B,nat),$o),fun(fun(fun(C,nat),$o),$o),bNF_rel_fun(fun(B,nat),fun(C,nat),$o,$o,bNF_rel_fun(B,C,nat,nat,T2,fequal(nat)),fequal($o)),P23),aTP_Lamp_aqm(fun(C,nat),$o))
           => ( aa(fun(fun(B,nat),fun(multiset(C),$o)),fun(fun(B,nat),$o),domainp(fun(B,nat),multiset(C)),pcr_multiset(B,C,T2)) = aa(fun(fun(B,nat),$o),fun(fun(B,nat),$o),aa(fun(fun(B,nat),$o),fun(fun(fun(B,nat),$o),fun(fun(B,nat),$o)),inf_inf(fun(fun(B,nat),$o)),aa(fun(nat,$o),fun(fun(B,nat),$o),basic_pred_fun(B,nat,DT),DS)),P23) ) ) ) ) ) ).

% multiset.domain_par
tff(fact_5089_multiset_Odomain__par__left__total,axiom,
    ! [C: $tType,B: $tType,T2: fun(B,fun(C,$o)),P_a: fun(fun(B,nat),$o)] :
      ( left_total(fun(B,nat),fun(C,nat),bNF_rel_fun(B,C,nat,nat,T2,fequal(nat)))
     => ( aa(fun(fun(C,nat),$o),$o,aa(fun(fun(B,nat),$o),fun(fun(fun(C,nat),$o),$o),bNF_rel_fun(fun(B,nat),fun(C,nat),$o,$o,bNF_rel_fun(B,C,nat,nat,T2,fequal(nat)),fequal($o)),P_a),aTP_Lamp_aqm(fun(C,nat),$o))
       => ( aa(fun(fun(B,nat),fun(multiset(C),$o)),fun(fun(B,nat),$o),domainp(fun(B,nat),multiset(C)),pcr_multiset(B,C,T2)) = P_a ) ) ) ).

% multiset.domain_par_left_total
tff(fact_5090_prod__mset_Oremove,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [X2: B,A3: multiset(B)] :
          ( aa(set(B),$o,member(B,X2),aa(multiset(B),set(B),set_mset(B),A3))
         => ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),X2),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),A3),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X2),zero_zero(multiset(B)))))) ) ) ) ).

% prod_mset.remove
tff(fact_5091_prod__mset__empty,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),zero_zero(multiset(B))) = one_one(B) ) ) ).

% prod_mset_empty
tff(fact_5092_prod__mset_Oadd__mset,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [X2: B,N3: multiset(B)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X2),N3)) = aa(B,B,aa(B,fun(B,B),times_times(B),X2),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),N3)) ) ) ).

% prod_mset.add_mset
tff(fact_5093_prod__mset_Ounion,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M: multiset(B),N3: multiset(B)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),M),N3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),M)),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),N3)) ) ) ).

% prod_mset.union
tff(fact_5094_prod__mset__Un,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: multiset(B),B2: multiset(B)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),A3),B2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),A3)),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),B2)) ) ) ).

% prod_mset_Un
tff(fact_5095_prod__mset_Oneutral__const,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,aTP_Lamp_nz(C,B)),A3)) = one_one(B) ) ) ).

% prod_mset.neutral_const
tff(fact_5096_prod__mset_Oinsert,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(C,B),X2: C,A3: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,G),aa(multiset(C),multiset(C),aa(C,fun(multiset(C),multiset(C)),add_mset(C),X2),A3))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,G,X2)),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,G),A3))) ) ) ).

% prod_mset.insert
tff(fact_5097_prod__mset_Oswap,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(C,fun(D,B)),B2: multiset(D),A3: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,aa(multiset(D),fun(C,B),aTP_Lamp_aqn(fun(C,fun(D,B)),fun(multiset(D),fun(C,B)),G),B2)),A3)) = aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(D),multiset(B),image_mset(D,B,aa(multiset(C),fun(D,B),aTP_Lamp_aqo(fun(C,fun(D,B)),fun(multiset(C),fun(D,B)),G),A3)),B2)) ) ) ).

% prod_mset.swap
tff(fact_5098_typedef__left__unique,axiom,
    ! [B: $tType,C: $tType,Rep: fun(B,C),Abs: fun(C,B),A3: set(C),T2: fun(C,fun(B,$o))] :
      ( type_definition(B,C,Rep,Abs,A3)
     => ( ! [X: C,Xa4: B] :
            ( aa(B,$o,aa(C,fun(B,$o),T2,X),Xa4)
          <=> ( X = aa(B,C,Rep,Xa4) ) )
       => left_unique(C,B,T2) ) ) ).

% typedef_left_unique
tff(fact_5099_left__unique__iff,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o))] :
      ( left_unique(B,C,R)
    <=> ! [Z5: C] : uniq(B,aa(C,fun(B,$o),aTP_Lamp_gw(fun(B,fun(C,$o)),fun(C,fun(B,$o)),R),Z5)) ) ).

% left_unique_iff
tff(fact_5100_prod__mset_Oneutral,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: multiset(B)] :
          ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),aa(multiset(B),set(B),set_mset(B),A3))
             => ( X = one_one(B) ) )
         => ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),A3) = one_one(B) ) ) ) ).

% prod_mset.neutral
tff(fact_5101_prod__mset_Odistrib,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(C,B),H2: fun(C,B),A3: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ok(fun(C,B),fun(fun(C,B),fun(C,B)),G),H2)),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,G),A3))),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,H2),A3))) ) ) ).

% prod_mset.distrib
tff(fact_5102_rat_Odomain,axiom,
    ! [X4: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(fun(product_prod(int,int),fun(rat,$o)),fun(product_prod(int,int),$o),domainp(product_prod(int,int),rat),pcr_rat),X4)
    <=> ? [Y4: product_prod(int,int)] :
          ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),basic_rel_prod(int,int,int,int,fequal(int),fequal(int)),X4),Y4)
          & aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Y4),Y4) ) ) ).

% rat.domain
tff(fact_5103_is__unit__prod__mset__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: multiset(B)] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),A3)),one_one(B))
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),aa(multiset(B),set(B),set_mset(B),A3))
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X3),one_one(B)) ) ) ) ).

% is_unit_prod_mset_iff
tff(fact_5104_prod__mset_Oeq__fold,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M: multiset(B)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),M) = fold_mset(B,B,times_times(B),one_one(B),M) ) ) ).

% prod_mset.eq_fold
tff(fact_5105_prod__mset__delta_H,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Y: C,Ca: B,A3: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_aqp(C,fun(B,fun(C,B)),Y),Ca)),A3)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Ca),aa(C,nat,aa(multiset(C),fun(C,nat),count(C),A3),Y)) ) ) ).

% prod_mset_delta'
tff(fact_5106_prod__mset__delta,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Y: C,Ca: B,A3: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_aqq(C,fun(B,fun(C,B)),Y),Ca)),A3)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Ca),aa(C,nat,aa(multiset(C),fun(C,nat),count(C),A3),Y)) ) ) ).

% prod_mset_delta
tff(fact_5107_prod__mset__multiplicity,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M: multiset(B)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),M) = aa(set(B),B,aa(fun(B,B),fun(set(B),B),groups7121269368397514597t_prod(B,B),aTP_Lamp_aqr(multiset(B),fun(B,B),M)),aa(multiset(B),set(B),set_mset(B),M)) ) ) ).

% prod_mset_multiplicity
tff(fact_5108_composed__equiv__rel__eq__onp,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o)),Pa: fun(B,$o),P_a: fun(C,$o),P6: fun(B,$o)] :
      ( left_unique(B,C,R)
     => ( aa(fun(C,$o),$o,aa(fun(B,$o),fun(fun(C,$o),$o),bNF_rel_fun(B,C,$o,$o,R,fequal($o)),Pa),P_a)
       => ( ( aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),R) = P6 )
         => ( aa(fun(C,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(C,$o)),fun(fun(C,fun(B,$o)),fun(B,fun(B,$o))),relcompp(B,C,B),R),aa(fun(C,fun(B,$o)),fun(C,fun(B,$o)),aa(fun(C,fun(C,$o)),fun(fun(C,fun(B,$o)),fun(C,fun(B,$o))),relcompp(C,C,B),bNF_eq_onp(C,P_a)),conversep(B,C,R))) = bNF_eq_onp(B,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),P6),Pa)) ) ) ) ) ).

% composed_equiv_rel_eq_onp
tff(fact_5109_rat_Odomain__par,axiom,
    ! [DR1: fun(int,$o),DR2: fun(int,$o),P23: fun(product_prod(int,int),$o)] :
      ( ( aa(fun(int,fun(int,$o)),fun(int,$o),domainp(int,int),fequal(int)) = DR1 )
     => ( ( aa(fun(int,fun(int,$o)),fun(int,$o),domainp(int,int),fequal(int)) = DR2 )
       => ( aa(fun(product_prod(int,int),$o),$o,aa(fun(product_prod(int,int),$o),fun(fun(product_prod(int,int),$o),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),$o,$o,basic_rel_prod(int,int,int,int,fequal(int),fequal(int)),fequal($o)),P23),aTP_Lamp_aqs(product_prod(int,int),$o))
         => ( aa(fun(product_prod(int,int),fun(rat,$o)),fun(product_prod(int,int),$o),domainp(product_prod(int,int),rat),pcr_rat) = aa(fun(product_prod(int,int),$o),fun(product_prod(int,int),$o),aa(fun(product_prod(int,int),$o),fun(fun(product_prod(int,int),$o),fun(product_prod(int,int),$o)),inf_inf(fun(product_prod(int,int),$o)),basic_pred_prod(int,int,DR1,DR2)),P23) ) ) ) ) ).

% rat.domain_par
tff(fact_5110_wfP__SUP,axiom,
    ! [C: $tType,B: $tType,R2: fun(B,fun(C,fun(C,$o)))] :
      ( ! [I3: B] : wfP(C,aa(B,fun(C,fun(C,$o)),R2,I3))
     => ( ! [I3: B,J3: B] :
            ( ( aa(B,fun(C,fun(C,$o)),R2,I3) != aa(B,fun(C,fun(C,$o)),R2,J3) )
           => ( aa(fun(C,$o),fun(C,$o),aa(fun(C,$o),fun(fun(C,$o),fun(C,$o)),inf_inf(fun(C,$o)),aa(fun(C,fun(C,$o)),fun(C,$o),domainp(C,C),aa(B,fun(C,fun(C,$o)),R2,I3))),rangep(C,C,aa(B,fun(C,fun(C,$o)),R2,J3))) = bot_bot(fun(C,$o)) ) )
       => wfP(C,aa(set(fun(C,fun(C,$o))),fun(C,fun(C,$o)),complete_Sup_Sup(fun(C,fun(C,$o))),aa(set(B),set(fun(C,fun(C,$o))),image2(B,fun(C,fun(C,$o)),R2),top_top(set(B))))) ) ) ).

% wfP_SUP
tff(fact_5111_wfP__empty,axiom,
    ! [B: $tType] : wfP(B,aTP_Lamp_aqt(B,fun(B,$o))) ).

% wfP_empty
tff(fact_5112_relcompp__bot1,axiom,
    ! [D: $tType,C: $tType,B: $tType,R: fun(D,fun(C,$o))] : ( aa(fun(D,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(D,$o)),fun(fun(D,fun(C,$o)),fun(B,fun(C,$o))),relcompp(B,D,C),bot_bot(fun(B,fun(D,$o)))),R) = bot_bot(fun(B,fun(C,$o))) ) ).

% relcompp_bot1
tff(fact_5113_relcompp__bot2,axiom,
    ! [D: $tType,C: $tType,B: $tType,R: fun(B,fun(D,$o))] : ( aa(fun(D,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(D,$o)),fun(fun(D,fun(C,$o)),fun(B,fun(C,$o))),relcompp(B,D,C),R),bot_bot(fun(D,fun(C,$o)))) = bot_bot(fun(B,fun(C,$o))) ) ).

% relcompp_bot2
tff(fact_5114_prod_Opred__True,axiom,
    ! [C: $tType,B: $tType,X4: product_prod(B,C)] : aa(product_prod(B,C),$o,basic_pred_prod(B,C,aTP_Lamp_nh(B,$o),aTP_Lamp_ahl(C,$o)),X4) ).

% prod.pred_True
tff(fact_5115_OO__def,axiom,
    ! [B: $tType,D: $tType,C: $tType,R: fun(B,fun(D,$o)),S: fun(D,fun(C,$o)),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(D,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(D,$o)),fun(fun(D,fun(C,$o)),fun(B,fun(C,$o))),relcompp(B,D,C),R),S),X4),Xa3)
    <=> ? [Y4: D] :
          ( aa(D,$o,aa(B,fun(D,$o),R,X4),Y4)
          & aa(C,$o,aa(D,fun(C,$o),S,Y4),Xa3) ) ) ).

% OO_def
tff(fact_5116_prod_Omap__cong__pred,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,X2: product_prod(B,C),Ya2: product_prod(B,C),F1: fun(B,D),G1: fun(B,D),F22: fun(C,E),G22: fun(C,E)] :
      ( ( X2 = Ya2 )
     => ( aa(product_prod(B,C),$o,basic_pred_prod(B,C,aa(fun(B,D),fun(B,$o),aTP_Lamp_aqu(fun(B,D),fun(fun(B,D),fun(B,$o)),F1),G1),aa(fun(C,E),fun(C,$o),aTP_Lamp_aqv(fun(C,E),fun(fun(C,E),fun(C,$o)),F22),G22)),Ya2)
       => ( aa(product_prod(B,C),product_prod(D,E),product_map_prod(B,D,C,E,F1,F22),X2) = aa(product_prod(B,C),product_prod(D,E),product_map_prod(B,D,C,E,G1,G22),Ya2) ) ) ) ).

% prod.map_cong_pred
tff(fact_5117_relcompp__relcomp__eq,axiom,
    ! [B: $tType,C: $tType,D: $tType,R2: set(product_prod(B,D)),S2: set(product_prod(D,C)),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(D,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(D,$o)),fun(fun(D,fun(C,$o)),fun(B,fun(C,$o))),relcompp(B,D,C),aTP_Lamp_aqw(set(product_prod(B,D)),fun(B,fun(D,$o)),R2)),aTP_Lamp_aqx(set(product_prod(D,C)),fun(D,fun(C,$o)),S2)),X4),Xa3)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa3)),relcomp(B,D,C,R2,S2)) ) ).

% relcompp_relcomp_eq
tff(fact_5118_pcr__Domainp,axiom,
    ! [D: $tType,C: $tType,B: $tType,B2: fun(B,fun(C,$o)),Pa: fun(B,$o),A3: fun(D,fun(B,$o))] :
      ( ( aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),B2) = Pa )
     => ! [X4: D] :
          ( aa(D,$o,aa(fun(D,fun(C,$o)),fun(D,$o),domainp(D,C),aa(fun(B,fun(C,$o)),fun(D,fun(C,$o)),aa(fun(D,fun(B,$o)),fun(fun(B,fun(C,$o)),fun(D,fun(C,$o))),relcompp(D,B,C),A3),B2)),X4)
        <=> ? [Y4: B] :
              ( aa(B,$o,aa(D,fun(B,$o),A3,X4),Y4)
              & aa(B,$o,Pa,Y4) ) ) ) ).

% pcr_Domainp
tff(fact_5119_relcompp__SUP__distrib,axiom,
    ! [D: $tType,C: $tType,B: $tType,E: $tType,S2: fun(B,fun(D,$o)),R2: fun(E,fun(D,fun(C,$o))),I: set(E)] : ( aa(fun(D,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(D,$o)),fun(fun(D,fun(C,$o)),fun(B,fun(C,$o))),relcompp(B,D,C),S2),aa(set(fun(D,fun(C,$o))),fun(D,fun(C,$o)),complete_Sup_Sup(fun(D,fun(C,$o))),aa(set(E),set(fun(D,fun(C,$o))),image2(E,fun(D,fun(C,$o)),R2),I))) = aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Sup_Sup(fun(B,fun(C,$o))),aa(set(E),set(fun(B,fun(C,$o))),image2(E,fun(B,fun(C,$o)),aa(fun(E,fun(D,fun(C,$o))),fun(E,fun(B,fun(C,$o))),aTP_Lamp_aqy(fun(B,fun(D,$o)),fun(fun(E,fun(D,fun(C,$o))),fun(E,fun(B,fun(C,$o)))),S2),R2)),I)) ) ).

% relcompp_SUP_distrib
tff(fact_5120_relcompp__SUP__distrib2,axiom,
    ! [D: $tType,C: $tType,B: $tType,E: $tType,R2: fun(E,fun(B,fun(D,$o))),I: set(E),S2: fun(D,fun(C,$o))] : ( aa(fun(D,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(D,$o)),fun(fun(D,fun(C,$o)),fun(B,fun(C,$o))),relcompp(B,D,C),aa(set(fun(B,fun(D,$o))),fun(B,fun(D,$o)),complete_Sup_Sup(fun(B,fun(D,$o))),aa(set(E),set(fun(B,fun(D,$o))),image2(E,fun(B,fun(D,$o)),R2),I))),S2) = aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Sup_Sup(fun(B,fun(C,$o))),aa(set(E),set(fun(B,fun(C,$o))),image2(E,fun(B,fun(C,$o)),aa(fun(D,fun(C,$o)),fun(E,fun(B,fun(C,$o))),aTP_Lamp_aqz(fun(E,fun(B,fun(D,$o))),fun(fun(D,fun(C,$o)),fun(E,fun(B,fun(C,$o)))),R2),S2)),I)) ) ).

% relcompp_SUP_distrib2
tff(fact_5121_pcr__Domainp__par,axiom,
    ! [B: $tType,C: $tType,D: $tType,B2: fun(B,fun(C,$o)),P24: fun(B,$o),A3: fun(D,fun(B,$o)),P12: fun(D,$o),P23: fun(D,$o)] :
      ( ( aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),B2) = P24 )
     => ( ( aa(fun(D,fun(B,$o)),fun(D,$o),domainp(D,B),A3) = P12 )
       => ( aa(fun(B,$o),$o,aa(fun(D,$o),fun(fun(B,$o),$o),bNF_rel_fun(D,B,$o,$o,A3,fequal($o)),P23),P24)
         => ( aa(fun(D,fun(C,$o)),fun(D,$o),domainp(D,C),aa(fun(B,fun(C,$o)),fun(D,fun(C,$o)),aa(fun(D,fun(B,$o)),fun(fun(B,fun(C,$o)),fun(D,fun(C,$o))),relcompp(D,B,C),A3),B2)) = aa(fun(D,$o),fun(D,$o),aa(fun(D,$o),fun(fun(D,$o),fun(D,$o)),inf_inf(fun(D,$o)),P12),P23) ) ) ) ) ).

% pcr_Domainp_par
tff(fact_5122_relcomp__def,axiom,
    ! [B: $tType,D: $tType,C: $tType,X4: set(product_prod(B,C)),Xa3: set(product_prod(C,D))] : ( relcomp(B,C,D,X4,Xa3) = aa(fun(product_prod(B,D),$o),set(product_prod(B,D)),collect(product_prod(B,D)),aa(fun(B,fun(D,$o)),fun(product_prod(B,D),$o),product_case_prod(B,D,$o),aa(fun(C,fun(D,$o)),fun(B,fun(D,$o)),aa(fun(B,fun(C,$o)),fun(fun(C,fun(D,$o)),fun(B,fun(D,$o))),relcompp(B,C,D),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),X4)),aTP_Lamp_ara(set(product_prod(C,D)),fun(C,fun(D,$o)),Xa3)))) ) ).

% relcomp_def
tff(fact_5123_wfP__wf__eq,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( wfP(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2))
    <=> wf(B,R2) ) ).

% wfP_wf_eq
tff(fact_5124_wfP__def,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o))] :
      ( wfP(B,R2)
    <=> wf(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2))) ) ).

% wfP_def
tff(fact_5125_prod_Orel__compp__Grp,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,R1: fun(B,fun(D,$o)),R22: fun(C,fun(E,$o))] : ( basic_rel_prod(B,D,C,E,R1,R22) = aa(fun(product_prod(product_prod(B,D),product_prod(C,E)),fun(product_prod(D,E),$o)),fun(product_prod(B,C),fun(product_prod(D,E),$o)),aa(fun(product_prod(B,C),fun(product_prod(product_prod(B,D),product_prod(C,E)),$o)),fun(fun(product_prod(product_prod(B,D),product_prod(C,E)),fun(product_prod(D,E),$o)),fun(product_prod(B,C),fun(product_prod(D,E),$o))),relcompp(product_prod(B,C),product_prod(product_prod(B,D),product_prod(C,E)),product_prod(D,E)),conversep(product_prod(product_prod(B,D),product_prod(C,E)),product_prod(B,C),bNF_Grp(product_prod(product_prod(B,D),product_prod(C,E)),product_prod(B,C),aa(fun(product_prod(product_prod(B,D),product_prod(C,E)),$o),set(product_prod(product_prod(B,D),product_prod(C,E))),collect(product_prod(product_prod(B,D),product_prod(C,E))),aa(fun(C,fun(E,$o)),fun(product_prod(product_prod(B,D),product_prod(C,E)),$o),aTP_Lamp_arb(fun(B,fun(D,$o)),fun(fun(C,fun(E,$o)),fun(product_prod(product_prod(B,D),product_prod(C,E)),$o)),R1),R22)),product_map_prod(product_prod(B,D),B,product_prod(C,E),C,product_fst(B,D),product_fst(C,E))))),bNF_Grp(product_prod(product_prod(B,D),product_prod(C,E)),product_prod(D,E),aa(fun(product_prod(product_prod(B,D),product_prod(C,E)),$o),set(product_prod(product_prod(B,D),product_prod(C,E))),collect(product_prod(product_prod(B,D),product_prod(C,E))),aa(fun(C,fun(E,$o)),fun(product_prod(product_prod(B,D),product_prod(C,E)),$o),aTP_Lamp_arb(fun(B,fun(D,$o)),fun(fun(C,fun(E,$o)),fun(product_prod(product_prod(B,D),product_prod(C,E)),$o)),R1),R22)),product_map_prod(product_prod(B,D),D,product_prod(C,E),E,product_snd(B,D),product_snd(C,E)))) ) ).

% prod.rel_compp_Grp
tff(fact_5126_multiset_Orel__compp__Grp,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] : ( rel_mset(B,C,R) = aa(fun(multiset(product_prod(B,C)),fun(multiset(C),$o)),fun(multiset(B),fun(multiset(C),$o)),aa(fun(multiset(B),fun(multiset(product_prod(B,C)),$o)),fun(fun(multiset(product_prod(B,C)),fun(multiset(C),$o)),fun(multiset(B),fun(multiset(C),$o))),relcompp(multiset(B),multiset(product_prod(B,C)),multiset(C)),conversep(multiset(product_prod(B,C)),multiset(B),bNF_Grp(multiset(product_prod(B,C)),multiset(B),aa(fun(multiset(product_prod(B,C)),$o),set(multiset(product_prod(B,C))),collect(multiset(product_prod(B,C))),aTP_Lamp_apf(fun(B,fun(C,$o)),fun(multiset(product_prod(B,C)),$o),R)),image_mset(product_prod(B,C),B,product_fst(B,C))))),bNF_Grp(multiset(product_prod(B,C)),multiset(C),aa(fun(multiset(product_prod(B,C)),$o),set(multiset(product_prod(B,C))),collect(multiset(product_prod(B,C))),aTP_Lamp_apf(fun(B,fun(C,$o)),fun(multiset(product_prod(B,C)),$o),R)),image_mset(product_prod(B,C),C,product_snd(B,C)))) ) ).

% multiset.rel_compp_Grp
tff(fact_5127_fun_Orel__compp__Grp,axiom,
    ! [B: $tType,D: $tType,C: $tType,R: fun(C,fun(D,$o))] : ( bNF_rel_fun(B,B,C,D,fequal(B),R) = aa(fun(fun(B,product_prod(C,D)),fun(fun(B,D),$o)),fun(fun(B,C),fun(fun(B,D),$o)),aa(fun(fun(B,C),fun(fun(B,product_prod(C,D)),$o)),fun(fun(fun(B,product_prod(C,D)),fun(fun(B,D),$o)),fun(fun(B,C),fun(fun(B,D),$o))),relcompp(fun(B,C),fun(B,product_prod(C,D)),fun(B,D)),conversep(fun(B,product_prod(C,D)),fun(B,C),bNF_Grp(fun(B,product_prod(C,D)),fun(B,C),aa(fun(fun(B,product_prod(C,D)),$o),set(fun(B,product_prod(C,D))),collect(fun(B,product_prod(C,D))),aTP_Lamp_fc(fun(C,fun(D,$o)),fun(fun(B,product_prod(C,D)),$o),R)),comp(product_prod(C,D),C,B,product_fst(C,D))))),bNF_Grp(fun(B,product_prod(C,D)),fun(B,D),aa(fun(fun(B,product_prod(C,D)),$o),set(fun(B,product_prod(C,D))),collect(fun(B,product_prod(C,D))),aTP_Lamp_fc(fun(C,fun(D,$o)),fun(fun(B,product_prod(C,D)),$o),R)),comp(product_prod(C,D),D,B,product_snd(C,D)))) ) ).

% fun.rel_compp_Grp
tff(fact_5128_Grp__def,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,C),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),bNF_Grp(B,C,A3,F2),X4),Xa3)
    <=> ( ( Xa3 = aa(B,C,F2,X4) )
        & aa(set(B),$o,member(B,X4),A3) ) ) ).

% Grp_def
tff(fact_5129_list_Orel__Grp,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,C)] : ( list_all2(B,C,bNF_Grp(B,C,A3,F2)) = bNF_Grp(list(B),list(C),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aTP_Lamp_ant(set(B),fun(list(B),$o),A3)),map(B,C,F2)) ) ).

% list.rel_Grp
tff(fact_5130_multiset_Orel__Grp,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,C)] : ( rel_mset(B,C,bNF_Grp(B,C,A3,F2)) = bNF_Grp(multiset(B),multiset(C),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aTP_Lamp_arc(set(B),fun(multiset(B),$o),A3)),image_mset(B,C,F2)) ) ).

% multiset.rel_Grp
tff(fact_5131_fun_Orel__Grp,axiom,
    ! [B: $tType,D: $tType,C: $tType,A3: set(C),F2: fun(C,D)] : ( bNF_rel_fun(B,B,C,D,fequal(B),bNF_Grp(C,D,A3,F2)) = bNF_Grp(fun(B,C),fun(B,D),aa(fun(fun(B,C),$o),set(fun(B,C)),collect(fun(B,C)),aTP_Lamp_agg(set(C),fun(fun(B,C),$o),A3)),comp(C,D,B,F2)) ) ).

% fun.rel_Grp
tff(fact_5132_prod_Orel__Grp,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,A1: set(B),F1: fun(B,D),A22: set(C),F22: fun(C,E)] : ( basic_rel_prod(B,D,C,E,bNF_Grp(B,D,A1,F1),bNF_Grp(C,E,A22,F22)) = bNF_Grp(product_prod(B,C),product_prod(D,E),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(set(C),fun(product_prod(B,C),$o),aTP_Lamp_ard(set(B),fun(set(C),fun(product_prod(B,C),$o)),A1),A22)),product_map_prod(B,D,C,E,F1,F22)) ) ).

% prod.rel_Grp
tff(fact_5133_OO__Grp__alt,axiom,
    ! [B: $tType,D: $tType,C: $tType,A3: set(D),F2: fun(D,B),G: fun(D,C),X4: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(D,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(D,$o)),fun(fun(D,fun(C,$o)),fun(B,fun(C,$o))),relcompp(B,D,C),conversep(D,B,bNF_Grp(D,B,A3,F2))),bNF_Grp(D,C,A3,G)),X4),Xa3)
    <=> ? [Z5: D] :
          ( aa(set(D),$o,member(D,Z5),A3)
          & ( aa(D,B,F2,Z5) = X4 )
          & ( aa(D,C,G,Z5) = Xa3 ) ) ) ).

% OO_Grp_alt
tff(fact_5134_rat_Odomain__par__left__total,axiom,
    ! [P_a: fun(product_prod(int,int),$o)] :
      ( left_total(product_prod(int,int),product_prod(int,int),basic_rel_prod(int,int,int,int,fequal(int),fequal(int)))
     => ( aa(fun(product_prod(int,int),$o),$o,aa(fun(product_prod(int,int),$o),fun(fun(product_prod(int,int),$o),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),$o,$o,basic_rel_prod(int,int,int,int,fequal(int),fequal(int)),fequal($o)),P_a),aTP_Lamp_aqs(product_prod(int,int),$o))
       => ( aa(fun(product_prod(int,int),fun(rat,$o)),fun(product_prod(int,int),$o),domainp(product_prod(int,int),rat),pcr_rat) = P_a ) ) ) ).

% rat.domain_par_left_total
tff(fact_5135_list_Orel__compp__Grp,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] : ( list_all2(B,C,R) = aa(fun(list(product_prod(B,C)),fun(list(C),$o)),fun(list(B),fun(list(C),$o)),aa(fun(list(B),fun(list(product_prod(B,C)),$o)),fun(fun(list(product_prod(B,C)),fun(list(C),$o)),fun(list(B),fun(list(C),$o))),relcompp(list(B),list(product_prod(B,C)),list(C)),conversep(list(product_prod(B,C)),list(B),bNF_Grp(list(product_prod(B,C)),list(B),aa(fun(list(product_prod(B,C)),$o),set(list(product_prod(B,C))),collect(list(product_prod(B,C))),aTP_Lamp_aoa(fun(B,fun(C,$o)),fun(list(product_prod(B,C)),$o),R)),map(product_prod(B,C),B,product_fst(B,C))))),bNF_Grp(list(product_prod(B,C)),list(C),aa(fun(list(product_prod(B,C)),$o),set(list(product_prod(B,C))),collect(list(product_prod(B,C))),aTP_Lamp_aoa(fun(B,fun(C,$o)),fun(list(product_prod(B,C)),$o),R)),map(product_prod(B,C),C,product_snd(B,C)))) ) ).

% list.rel_compp_Grp
tff(fact_5136_right__total__relcompp__transfer,axiom,
    ! [B: $tType,F10: $tType,D: $tType,G6: $tType,C: $tType,E: $tType,B2: fun(B,fun(C,$o)),A3: fun(D,fun(E,$o)),C2: fun(F10,fun(G6,$o))] :
      ( right_total(B,C,B2)
     => aa(fun(fun(E,fun(C,$o)),fun(fun(C,fun(G6,$o)),fun(E,fun(G6,$o)))),$o,aa(fun(fun(D,fun(B,$o)),fun(fun(B,fun(F10,$o)),fun(D,fun(F10,$o)))),fun(fun(fun(E,fun(C,$o)),fun(fun(C,fun(G6,$o)),fun(E,fun(G6,$o)))),$o),bNF_rel_fun(fun(D,fun(B,$o)),fun(E,fun(C,$o)),fun(fun(B,fun(F10,$o)),fun(D,fun(F10,$o))),fun(fun(C,fun(G6,$o)),fun(E,fun(G6,$o))),bNF_rel_fun(D,E,fun(B,$o),fun(C,$o),A3,bNF_rel_fun(B,C,$o,$o,B2,fequal($o))),bNF_rel_fun(fun(B,fun(F10,$o)),fun(C,fun(G6,$o)),fun(D,fun(F10,$o)),fun(E,fun(G6,$o)),bNF_rel_fun(B,C,fun(F10,$o),fun(G6,$o),B2,bNF_rel_fun(F10,G6,$o,$o,C2,fequal($o))),bNF_rel_fun(D,E,fun(F10,$o),fun(G6,$o),A3,bNF_rel_fun(F10,G6,$o,$o,C2,fequal($o))))),aTP_Lamp_are(fun(B,fun(C,$o)),fun(fun(D,fun(B,$o)),fun(fun(B,fun(F10,$o)),fun(D,fun(F10,$o)))),B2)),relcompp(E,C,G6)) ) ).

% right_total_relcompp_transfer
tff(fact_5137_typedef__right__total,axiom,
    ! [B: $tType,C: $tType,Rep: fun(B,C),Abs: fun(C,B),A3: set(C),T2: fun(C,fun(B,$o))] :
      ( type_definition(B,C,Rep,Abs,A3)
     => ( ! [X: C,Xa4: B] :
            ( aa(B,$o,aa(C,fun(B,$o),T2,X),Xa4)
          <=> ( X = aa(B,C,Rep,Xa4) ) )
       => right_total(C,B,T2) ) ) ).

% typedef_right_total
tff(fact_5138_right__total__Collect__transfer,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o))] :
      ( right_total(B,C,A3)
     => aa(fun(fun(C,$o),set(C)),$o,aa(fun(fun(B,$o),set(B)),fun(fun(fun(C,$o),set(C)),$o),bNF_rel_fun(fun(B,$o),fun(C,$o),set(B),set(C),bNF_rel_fun(B,C,$o,$o,A3,fequal($o)),bNF_rel_set(B,C,A3)),aTP_Lamp_arg(fun(B,fun(C,$o)),fun(fun(B,$o),set(B)),A3)),collect(C)) ) ).

% right_total_Collect_transfer
tff(fact_5139_right__total__Domainp__transfer,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType,B2: fun(B,fun(C,$o)),A3: fun(D,fun(E,$o))] :
      ( right_total(B,C,B2)
     => aa(fun(fun(E,fun(C,$o)),fun(E,$o)),$o,aa(fun(fun(D,fun(B,$o)),fun(D,$o)),fun(fun(fun(E,fun(C,$o)),fun(E,$o)),$o),bNF_rel_fun(fun(D,fun(B,$o)),fun(E,fun(C,$o)),fun(D,$o),fun(E,$o),bNF_rel_fun(D,E,fun(B,$o),fun(C,$o),A3,bNF_rel_fun(B,C,$o,$o,B2,fequal($o))),bNF_rel_fun(D,E,$o,$o,A3,fequal($o))),aTP_Lamp_arh(fun(B,fun(C,$o)),fun(fun(D,fun(B,$o)),fun(D,$o)),B2)),domainp(E,C)) ) ).

% right_total_Domainp_transfer
tff(fact_5140_right__total__Inter__transfer,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o))] :
      ( bi_unique(B,C,A3)
     => ( right_total(B,C,A3)
       => aa(fun(set(set(C)),set(C)),$o,aa(fun(set(set(B)),set(B)),fun(fun(set(set(C)),set(C)),$o),bNF_rel_fun(set(set(B)),set(set(C)),set(B),set(C),bNF_rel_set(set(B),set(C),bNF_rel_set(B,C,A3)),bNF_rel_set(B,C,A3)),aTP_Lamp_ari(fun(B,fun(C,$o)),fun(set(set(B)),set(B)),A3)),complete_Inf_Inf(set(C))) ) ) ).

% right_total_Inter_transfer
tff(fact_5141_vimage__right__total__transfer,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,B2: fun(B,fun(C,$o)),A3: fun(D,fun(E,$o))] :
      ( bi_unique(B,C,B2)
     => ( right_total(D,E,A3)
       => aa(fun(fun(E,C),fun(set(C),set(E))),$o,aa(fun(fun(D,B),fun(set(B),set(D))),fun(fun(fun(E,C),fun(set(C),set(E))),$o),bNF_rel_fun(fun(D,B),fun(E,C),fun(set(B),set(D)),fun(set(C),set(E)),bNF_rel_fun(D,E,B,C,A3,B2),bNF_rel_fun(set(B),set(C),set(D),set(E),bNF_rel_set(B,C,B2),bNF_rel_set(D,E,A3))),aTP_Lamp_arj(fun(D,fun(E,$o)),fun(fun(D,B),fun(set(B),set(D))),A3)),vimage(E,C)) ) ) ).

% vimage_right_total_transfer
tff(fact_5142_right__total__fun__eq__transfer,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,A3: fun(B,fun(C,$o)),B2: fun(D,fun(E,$o))] :
      ( right_total(B,C,A3)
     => ( bi_unique(D,E,B2)
       => aa(fun(fun(C,E),fun(fun(C,E),$o)),$o,aa(fun(fun(B,D),fun(fun(B,D),$o)),fun(fun(fun(C,E),fun(fun(C,E),$o)),$o),bNF_rel_fun(fun(B,D),fun(C,E),fun(fun(B,D),$o),fun(fun(C,E),$o),bNF_rel_fun(B,C,D,E,A3,B2),bNF_rel_fun(fun(B,D),fun(C,E),$o,$o,bNF_rel_fun(B,C,D,E,A3,B2),fequal($o))),aTP_Lamp_ark(fun(B,fun(C,$o)),fun(fun(B,D),fun(fun(B,D),$o)),A3)),fequal(fun(C,E))) ) ) ).

% right_total_fun_eq_transfer
tff(fact_5143_typedef__bi__unique,axiom,
    ! [B: $tType,C: $tType,Rep: fun(B,C),Abs: fun(C,B),A3: set(C),T2: fun(C,fun(B,$o))] :
      ( type_definition(B,C,Rep,Abs,A3)
     => ( ! [X: C,Xa4: B] :
            ( aa(B,$o,aa(C,fun(B,$o),T2,X),Xa4)
          <=> ( X = aa(B,C,Rep,Xa4) ) )
       => bi_unique(C,B,T2) ) ) ).

% typedef_bi_unique
tff(fact_5144_bi__unique__iff,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] :
      ( bi_unique(B,C,R)
    <=> ( ! [Z5: C] : uniq(B,aa(C,fun(B,$o),aTP_Lamp_gw(fun(B,fun(C,$o)),fun(C,fun(B,$o)),R),Z5))
        & ! [Z5: B] : uniq(C,aa(B,fun(C,$o),R,Z5)) ) ) ).

% bi_unique_iff
tff(fact_5145_inter__transfer,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o))] :
      ( bi_unique(B,C,A3)
     => aa(fun(set(C),fun(set(C),set(C))),$o,aa(fun(set(B),fun(set(B),set(B))),fun(fun(set(C),fun(set(C),set(C))),$o),bNF_rel_fun(set(B),set(C),fun(set(B),set(B)),fun(set(C),set(C)),bNF_rel_set(B,C,A3),bNF_rel_fun(set(B),set(C),set(B),set(C),bNF_rel_set(B,C,A3),bNF_rel_set(B,C,A3))),inf_inf(set(B))),inf_inf(set(C))) ) ).

% inter_transfer
tff(fact_5146_right__total__Compl__transfer,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o))] :
      ( bi_unique(B,C,A3)
     => ( right_total(B,C,A3)
       => aa(fun(set(C),set(C)),$o,aa(fun(set(B),set(B)),fun(fun(set(C),set(C)),$o),bNF_rel_fun(set(B),set(C),set(B),set(C),bNF_rel_set(B,C,A3),bNF_rel_set(B,C,A3)),aTP_Lamp_arl(fun(B,fun(C,$o)),fun(set(B),set(B)),A3)),uminus_uminus(set(C))) ) ) ).

% right_total_Compl_transfer
tff(fact_5147_Inter__transfer,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o))] :
      ( bi_unique(B,C,A3)
     => ( bi_total(B,C,A3)
       => aa(fun(set(set(C)),set(C)),$o,aa(fun(set(set(B)),set(B)),fun(fun(set(set(C)),set(C)),$o),bNF_rel_fun(set(set(B)),set(set(C)),set(B),set(C),bNF_rel_set(set(B),set(C),bNF_rel_set(B,C,A3)),bNF_rel_set(B,C,A3)),complete_Inf_Inf(set(B))),complete_Inf_Inf(set(C))) ) ) ).

% Inter_transfer
tff(fact_5148_Abs__rat__cases,axiom,
    ! [X2: rat] :
      ~ ! [Y2: set(product_prod(int,int))] :
          ( ( X2 = aa(set(product_prod(int,int)),rat,abs_rat,Y2) )
         => ~ aa(set(set(product_prod(int,int))),$o,member(set(product_prod(int,int)),Y2),aa(fun(set(product_prod(int,int)),$o),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_arm(set(product_prod(int,int)),$o))) ) ).

% Abs_rat_cases
tff(fact_5149_Abs__rat__induct,axiom,
    ! [Pa: fun(rat,$o),X2: rat] :
      ( ! [Y2: set(product_prod(int,int))] :
          ( aa(set(set(product_prod(int,int))),$o,member(set(product_prod(int,int)),Y2),aa(fun(set(product_prod(int,int)),$o),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_arm(set(product_prod(int,int)),$o)))
         => aa(rat,$o,Pa,aa(set(product_prod(int,int)),rat,abs_rat,Y2)) )
     => aa(rat,$o,Pa,X2) ) ).

% Abs_rat_induct
tff(fact_5150_inf__filter__parametric,axiom,
    ! [B: $tType,C: $tType,A3: fun(B,fun(C,$o))] :
      ( bi_unique(B,C,A3)
     => ( bi_total(B,C,A3)
       => aa(fun(filter(C),fun(filter(C),filter(C))),$o,aa(fun(filter(B),fun(filter(B),filter(B))),fun(fun(filter(C),fun(filter(C),filter(C))),$o),bNF_rel_fun(filter(B),filter(C),fun(filter(B),filter(B)),fun(filter(C),filter(C)),rel_filter(B,C,A3),bNF_rel_fun(filter(B),filter(C),filter(B),filter(C),rel_filter(B,C,A3),rel_filter(B,C,A3))),inf_inf(filter(B))),inf_inf(filter(C))) ) ) ).

% inf_filter_parametric
tff(fact_5151_Abs__rat__inject,axiom,
    ! [X2: set(product_prod(int,int)),Y: set(product_prod(int,int))] :
      ( aa(set(set(product_prod(int,int))),$o,member(set(product_prod(int,int)),X2),aa(fun(set(product_prod(int,int)),$o),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_arm(set(product_prod(int,int)),$o)))
     => ( aa(set(set(product_prod(int,int))),$o,member(set(product_prod(int,int)),Y),aa(fun(set(product_prod(int,int)),$o),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_arm(set(product_prod(int,int)),$o)))
       => ( ( aa(set(product_prod(int,int)),rat,abs_rat,X2) = aa(set(product_prod(int,int)),rat,abs_rat,Y) )
        <=> ( X2 = Y ) ) ) ) ).

% Abs_rat_inject
tff(fact_5152_type__definition__rat,axiom,
    type_definition(rat,set(product_prod(int,int)),rep_rat,abs_rat,aa(fun(set(product_prod(int,int)),$o),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_arm(set(product_prod(int,int)),$o))) ).

% type_definition_rat
tff(fact_5153_Abs__rat__inverse,axiom,
    ! [Y: set(product_prod(int,int))] :
      ( aa(set(set(product_prod(int,int))),$o,member(set(product_prod(int,int)),Y),aa(fun(set(product_prod(int,int)),$o),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_arm(set(product_prod(int,int)),$o)))
     => ( aa(rat,set(product_prod(int,int)),rep_rat,aa(set(product_prod(int,int)),rat,abs_rat,Y)) = Y ) ) ).

% Abs_rat_inverse
tff(fact_5154_Rep__rat__induct,axiom,
    ! [Y: set(product_prod(int,int)),Pa: fun(set(product_prod(int,int)),$o)] :
      ( aa(set(set(product_prod(int,int))),$o,member(set(product_prod(int,int)),Y),aa(fun(set(product_prod(int,int)),$o),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_arm(set(product_prod(int,int)),$o)))
     => ( ! [X: rat] : aa(set(product_prod(int,int)),$o,Pa,aa(rat,set(product_prod(int,int)),rep_rat,X))
       => aa(set(product_prod(int,int)),$o,Pa,Y) ) ) ).

% Rep_rat_induct
tff(fact_5155_Rep__rat,axiom,
    ! [X2: rat] : aa(set(set(product_prod(int,int))),$o,member(set(product_prod(int,int)),aa(rat,set(product_prod(int,int)),rep_rat,X2)),aa(fun(set(product_prod(int,int)),$o),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_arm(set(product_prod(int,int)),$o))) ).

% Rep_rat
tff(fact_5156_Rep__rat__cases,axiom,
    ! [Y: set(product_prod(int,int))] :
      ( aa(set(set(product_prod(int,int))),$o,member(set(product_prod(int,int)),Y),aa(fun(set(product_prod(int,int)),$o),set(set(product_prod(int,int))),collect(set(product_prod(int,int))),aTP_Lamp_arm(set(product_prod(int,int)),$o)))
     => ~ ! [X: rat] : ( Y != aa(rat,set(product_prod(int,int)),rep_rat,X) ) ) ).

% Rep_rat_cases
tff(fact_5157_type__copy__vimage2p__Grp__Abs,axiom,
    ! [B: $tType,C: $tType,E: $tType,D: $tType,Rep: fun(B,C),Abs: fun(C,B),G: fun(D,E),Pa: fun(E,$o),H2: fun(E,B)] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( bNF_vimage2p(D,E,C,B,$o,G,Abs,bNF_Grp(E,B,aa(fun(E,$o),set(E),collect(E),Pa),H2)) = bNF_Grp(D,C,aa(fun(D,$o),set(D),collect(D),aa(fun(E,$o),fun(D,$o),aTP_Lamp_arn(fun(D,E),fun(fun(E,$o),fun(D,$o)),G),Pa)),aa(fun(D,E),fun(D,C),comp(E,C,D,aa(fun(E,B),fun(E,C),comp(B,C,E,Rep),H2)),G)) ) ) ).

% type_copy_vimage2p_Grp_Abs
tff(fact_5158_type__copy__vimage2p__Grp__Rep,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,Rep: fun(B,C),Abs: fun(C,B),F2: fun(D,E),Pa: fun(E,$o),H2: fun(E,C)] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( bNF_vimage2p(D,E,B,C,$o,F2,Rep,bNF_Grp(E,C,aa(fun(E,$o),set(E),collect(E),Pa),H2)) = bNF_Grp(D,B,aa(fun(D,$o),set(D),collect(D),aa(fun(E,$o),fun(D,$o),aTP_Lamp_arn(fun(D,E),fun(fun(E,$o),fun(D,$o)),F2),Pa)),aa(fun(D,E),fun(D,B),comp(E,B,D,aa(fun(E,C),fun(E,B),comp(C,B,E,Abs),H2)),F2)) ) ) ).

% type_copy_vimage2p_Grp_Rep
tff(fact_5159_sum__mset__constant,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Y: B,A3: multiset(C)] : ( comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aTP_Lamp_rv(B,fun(C,B),Y)),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(multiset(C),nat,size_size(multiset(C)),A3))),Y) ) ) ).

% sum_mset_constant
tff(fact_5160_prod__mset__constant,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ca: B,A3: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,aTP_Lamp_ru(B,fun(C,B),Ca)),A3)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Ca),aa(multiset(C),nat,size_size(multiset(C)),A3)) ) ) ).

% prod_mset_constant
tff(fact_5161_vimage2p__def,axiom,
    ! [B: $tType,E: $tType,D: $tType,F10: $tType,C: $tType,F2: fun(B,E),G: fun(C,F10),R: fun(E,fun(F10,D)),X4: B,Xa3: C] : ( aa(C,D,aa(B,fun(C,D),bNF_vimage2p(B,E,C,F10,D,F2,G,R),X4),Xa3) = aa(F10,D,aa(E,fun(F10,D),R,aa(B,E,F2,X4)),aa(C,F10,G,Xa3)) ) ).

% vimage2p_def
tff(fact_5162_size__eq__sum__mset,axiom,
    ! [B: $tType,M: multiset(B)] : ( aa(multiset(B),nat,size_size(multiset(B)),M) = comm_m7189776963980413722m_mset(nat,aa(multiset(B),multiset(nat),image_mset(B,nat,aTP_Lamp_rk(B,nat)),M)) ) ).

% size_eq_sum_mset
tff(fact_5163_image__mset__const__eq,axiom,
    ! [C: $tType,B: $tType,Ca: B,M: multiset(C)] : ( aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_cy(B,fun(C,B)),Ca)),M) = replicate_mset(B,aa(multiset(C),nat,size_size(multiset(C)),M),Ca) ) ).

% image_mset_const_eq
tff(fact_5164_size__multiset__overloaded__def,axiom,
    ! [B: $tType] : ( size_size(multiset(B)) = size_multiset(B,aTP_Lamp_apn(B,nat)) ) ).

% size_multiset_overloaded_def
tff(fact_5165_size__multiset__overloaded__eq,axiom,
    ! [B: $tType,X2: multiset(B)] : ( aa(multiset(B),nat,size_size(multiset(B)),X2) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(multiset(B),fun(B,nat),count(B),X2)),aa(multiset(B),set(B),set_mset(B),X2)) ) ).

% size_multiset_overloaded_eq
tff(fact_5166_tl__remdups__adj,axiom,
    ! [B: $tType,Ys: list(B)] :
      ( ( Ys != nil(B) )
     => ( aa(list(B),list(B),tl(B),remdups_adj(B,Ys)) = remdups_adj(B,dropWhile(B,aTP_Lamp_aro(list(B),fun(B,$o),Ys),aa(list(B),list(B),tl(B),Ys))) ) ) ).

% tl_remdups_adj
tff(fact_5167_map__upds__fold__map__upd,axiom,
    ! [B: $tType,C: $tType,M2: fun(B,option(C)),Ks: list(B),Vs: list(C)] : ( map_upds(B,C,M2,Ks,Vs) = foldl(fun(B,option(C)),product_prod(B,C),aTP_Lamp_arq(fun(B,option(C)),fun(product_prod(B,C),fun(B,option(C)))),M2,zip(B,C,Ks,Vs)) ) ).

% map_upds_fold_map_upd
tff(fact_5168_prod__list__def,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ( groups5270119922927024881d_list(B) = groups_monoid_F(B,times_times(B),one_one(B)) ) ) ).

% prod_list_def
tff(fact_5169_monoid__list_OF_Ocong,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] : ( groups_monoid_F(B,F2,Z2) = groups_monoid_F(B,F2,Z2) ) ).

% monoid_list.F.cong
tff(fact_5170_remdups__adj__Cons_H,axiom,
    ! [B: $tType,X2: B,Xs: list(B)] : ( remdups_adj(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),remdups_adj(B,dropWhile(B,aTP_Lamp_ct(B,fun(B,$o),X2),Xs))) ) ).

% remdups_adj_Cons'
tff(fact_5171_monoid__list_OCons,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,X2: B,Xs: list(B)] :
      ( groups_monoid_list(B,F2,Z2)
     => ( aa(list(B),B,groups_monoid_F(B,F2,Z2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(B,B,aa(B,fun(B,B),F2,X2),aa(list(B),B,groups_monoid_F(B,F2,Z2),Xs)) ) ) ).

% monoid_list.Cons
tff(fact_5172_monoid__list_ONil,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups_monoid_list(B,F2,Z2)
     => ( aa(list(B),B,groups_monoid_F(B,F2,Z2),nil(B)) = Z2 ) ) ).

% monoid_list.Nil
tff(fact_5173_monoid__list_Oappend,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Xs: list(B),Ys: list(B)] :
      ( groups_monoid_list(B,F2,Z2)
     => ( aa(list(B),B,groups_monoid_F(B,F2,Z2),append(B,Xs,Ys)) = aa(B,B,aa(B,fun(B,B),F2,aa(list(B),B,groups_monoid_F(B,F2,Z2),Xs)),aa(list(B),B,groups_monoid_F(B,F2,Z2),Ys)) ) ) ).

% monoid_list.append
tff(fact_5174_remdups__adj__Cons,axiom,
    ! [B: $tType,X2: B,Xs: list(B)] : ( remdups_adj(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(list(B),list(B),case_list(list(B),B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)),aTP_Lamp_arr(B,fun(B,fun(list(B),list(B))),X2)),remdups_adj(B,Xs)) ) ).

% remdups_adj_Cons
tff(fact_5175_comm__monoid__list_Orev,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Xs: list(B)] :
      ( groups1828464146339083142d_list(B,F2,Z2)
     => ( aa(list(B),B,groups_monoid_F(B,F2,Z2),rev(B,Xs)) = aa(list(B),B,groups_monoid_F(B,F2,Z2),Xs) ) ) ).

% comm_monoid_list.rev
tff(fact_5176_monoid__list_Oeq__foldr,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Xs: list(B)] :
      ( groups_monoid_list(B,F2,Z2)
     => ( aa(list(B),B,groups_monoid_F(B,F2,Z2),Xs) = aa(B,B,foldr(B,B,F2,Xs),Z2) ) ) ).

% monoid_list.eq_foldr
tff(fact_5177_sum__list__def,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => ( groups8242544230860333062m_list(B) = groups_monoid_F(B,plus_plus(B),zero_zero(B)) ) ) ).

% sum_list_def
tff(fact_5178_remdups__adj__append__dropWhile,axiom,
    ! [B: $tType,Xs: list(B),Y: B,Ys: list(B)] : ( remdups_adj(B,append(B,Xs,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys))) = append(B,remdups_adj(B,append(B,Xs,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),nil(B)))),remdups_adj(B,dropWhile(B,aTP_Lamp_ct(B,fun(B,$o),Y),Ys))) ) ).

% remdups_adj_append_dropWhile
tff(fact_5179_comm__monoid__list__set_Oset__conv__list,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(C,B),Xs: list(C)] :
      ( groups4802862169904069756st_set(B,F2,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(list(C),set(C),set2(C),Xs)) = aa(list(B),B,groups_monoid_F(B,F2,Z2),aa(list(C),list(B),map(C,B,G),aa(list(C),list(C),remdups(C),Xs))) ) ) ).

% comm_monoid_list_set.set_conv_list
tff(fact_5180_comm__monoid__list__set_Odistinct__set__conv__list,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,Xs: list(C),G: fun(C,B)] :
      ( groups4802862169904069756st_set(B,F2,Z2)
     => ( distinct(C,Xs)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(list(C),set(C),set2(C),Xs)) = aa(list(B),B,groups_monoid_F(B,F2,Z2),aa(list(C),list(B),map(C,B,G),Xs)) ) ) ) ).

% comm_monoid_list_set.distinct_set_conv_list
tff(fact_5181_remdups__adj__append_H_H,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B)] :
      ( ( Xs != nil(B) )
     => ( remdups_adj(B,append(B,Xs,Ys)) = append(B,remdups_adj(B,Xs),remdups_adj(B,dropWhile(B,aTP_Lamp_ars(list(B),fun(B,$o),Xs),Ys))) ) ) ).

% remdups_adj_append''
tff(fact_5182_comm__monoid__mult__class_Oprod__def,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ( groups7121269368397514597t_prod(B,C) = groups_comm_monoid_F(C,B,times_times(C),one_one(C)) ) ) ).

% comm_monoid_mult_class.prod_def
tff(fact_5183_comm__monoid__set_Otriangle__reindex,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,fun(nat,B)),N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(product_prod(nat,nat)),B,aa(fun(product_prod(nat,nat),B),fun(set(product_prod(nat,nat)),B),groups_comm_monoid_F(B,product_prod(nat,nat),F2,Z2),aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),G)),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_ur(nat,fun(nat,fun(nat,$o)),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(fun(nat,fun(nat,B)),fun(nat,B),aa(B,fun(fun(nat,fun(nat,B)),fun(nat,B)),aTP_Lamp_aru(fun(B,fun(B,B)),fun(B,fun(fun(nat,fun(nat,B)),fun(nat,B))),F2),Z2),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% comm_monoid_set.triangle_reindex
tff(fact_5184_comm__monoid__set_Ozero__middle,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,P3: nat,K: nat,G: fun(nat,B),H2: fun(nat,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),P3)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),P3)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aa(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),aTP_Lamp_arv(B,fun(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B)))),Z2),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),P3)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_arw(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),K),G),H2)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P3),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% comm_monoid_set.zero_middle
tff(fact_5185_comm__monoid__set_Otriangle__reindex__eq,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,fun(nat,B)),N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(product_prod(nat,nat)),B,aa(fun(product_prod(nat,nat),B),fun(set(product_prod(nat,nat)),B),groups_comm_monoid_F(B,product_prod(nat,nat),F2,Z2),aa(fun(nat,fun(nat,B)),fun(product_prod(nat,nat),B),product_case_prod(nat,nat,B),G)),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_rc(nat,fun(nat,fun(nat,$o)),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(fun(nat,fun(nat,B)),fun(nat,B),aa(B,fun(fun(nat,fun(nat,B)),fun(nat,B)),aTP_Lamp_aru(fun(B,fun(B,B)),fun(B,fun(fun(nat,fun(nat,B)),fun(nat,B))),F2),Z2),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% comm_monoid_set.triangle_reindex_eq
tff(fact_5186_comm__monoid__set_Oswap,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(C,fun(D,B)),B2: set(D),A3: set(C)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(set(D),fun(C,B),aa(fun(C,fun(D,B)),fun(set(D),fun(C,B)),aa(B,fun(fun(C,fun(D,B)),fun(set(D),fun(C,B))),aTP_Lamp_arx(fun(B,fun(B,B)),fun(B,fun(fun(C,fun(D,B)),fun(set(D),fun(C,B)))),F2),Z2),G),B2)),A3) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,F2,Z2),aa(set(C),fun(D,B),aa(fun(C,fun(D,B)),fun(set(C),fun(D,B)),aa(B,fun(fun(C,fun(D,B)),fun(set(C),fun(D,B))),aTP_Lamp_arz(fun(B,fun(B,B)),fun(B,fun(fun(C,fun(D,B)),fun(set(C),fun(D,B)))),F2),Z2),G),A3)),B2) ) ) ).

% comm_monoid_set.swap
tff(fact_5187_comm__monoid__set_Odistrib,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(C,B),H2: fun(C,B),A3: set(C)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_asa(fun(B,fun(B,B)),fun(fun(C,B),fun(fun(C,B),fun(C,B))),F2),G),H2)),A3) = aa(B,B,aa(B,fun(B,B),F2,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),A3)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),H2),A3)) ) ) ).

% comm_monoid_set.distrib
tff(fact_5188_comm__monoid__set_Oneutral__const,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(B,fun(C,B),aTP_Lamp_cy(B,fun(C,B)),Z2)),A3) = Z2 ) ) ).

% comm_monoid_set.neutral_const
tff(fact_5189_comm__monoid__set_Oempty,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),bot_bot(set(C))) = Z2 ) ) ).

% comm_monoid_set.empty
tff(fact_5190_comm__monoid__set_Ofinite__Collect__op,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,I: set(C),X2: fun(C,B),Y: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(fun(C,B),fun(C,$o),aa(set(C),fun(fun(C,B),fun(C,$o)),aTP_Lamp_asb(B,fun(set(C),fun(fun(C,B),fun(C,$o))),Z2),I),X2)))
       => ( aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(fun(C,B),fun(C,$o),aa(set(C),fun(fun(C,B),fun(C,$o)),aTP_Lamp_asb(B,fun(set(C),fun(fun(C,B),fun(C,$o))),Z2),I),Y)))
         => aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(fun(C,B),fun(C,$o),aa(fun(C,B),fun(fun(C,B),fun(C,$o)),aa(set(C),fun(fun(C,B),fun(fun(C,B),fun(C,$o))),aa(B,fun(set(C),fun(fun(C,B),fun(fun(C,B),fun(C,$o)))),aTP_Lamp_asc(fun(B,fun(B,B)),fun(B,fun(set(C),fun(fun(C,B),fun(fun(C,B),fun(C,$o))))),F2),Z2),I),X2),Y))) ) ) ) ).

% comm_monoid_set.finite_Collect_op
tff(fact_5191_comm__monoid__set__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups778175481326437816id_set(B,F2,Z2)
    <=> comm_monoid(B,F2,Z2) ) ).

% comm_monoid_set_def
tff(fact_5192_comm__monoid__set_Oaxioms,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => comm_monoid(B,F2,Z2) ) ).

% comm_monoid_set.axioms
tff(fact_5193_comm__monoid__set_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid(B,F2,Z2)
     => groups778175481326437816id_set(B,F2,Z2) ) ).

% comm_monoid_set.intro
tff(fact_5194_comm__monoid__list__set_Oaxioms_I2_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups4802862169904069756st_set(B,F2,Z2)
     => groups778175481326437816id_set(B,F2,Z2) ) ).

% comm_monoid_list_set.axioms(2)
tff(fact_5195_prod_Ocomm__monoid__set__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => groups778175481326437816id_set(B,times_times(B),one_one(B)) ) ).

% prod.comm_monoid_set_axioms
tff(fact_5196_comm__monoid__set_Odelta,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(B,B)),Z2: B,S: set(C),A4: C,B3: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),S)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(fun(C,B),fun(C,B),aa(C,fun(fun(C,B),fun(C,B)),aTP_Lamp_asd(B,fun(C,fun(fun(C,B),fun(C,B))),Z2),A4),B3)),S)
          = $ite(aa(set(C),$o,member(C,A4),S),aa(C,B,B3,A4),Z2) ) ) ) ).

% comm_monoid_set.delta
tff(fact_5197_comm__monoid__set_Odelta_H,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(B,B)),Z2: B,S: set(C),A4: C,B3: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),S)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(fun(C,B),fun(C,B),aa(C,fun(fun(C,B),fun(C,B)),aTP_Lamp_ase(B,fun(C,fun(fun(C,B),fun(C,B))),Z2),A4),B3)),S)
          = $ite(aa(set(C),$o,member(C,A4),S),aa(C,B,B3,A4),Z2) ) ) ) ).

% comm_monoid_set.delta'
tff(fact_5198_comm__monoid__set_Ointer__filter,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),G: fun(C,B),Pa: fun(C,$o)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(fun(C,$o),set(C),collect(C),aa(fun(C,$o),fun(C,$o),aTP_Lamp_asf(set(C),fun(fun(C,$o),fun(C,$o)),A3),Pa))) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(fun(C,$o),fun(C,B),aa(fun(C,B),fun(fun(C,$o),fun(C,B)),aTP_Lamp_asg(B,fun(fun(C,B),fun(fun(C,$o),fun(C,B))),Z2),G),Pa)),A3) ) ) ) ).

% comm_monoid_set.inter_filter
tff(fact_5199_comm__monoid__set_Oswap__restrict,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),B2: set(D),G: fun(C,fun(D,B)),R: fun(C,fun(D,$o))] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(D),$o,finite_finite2(D),B2)
         => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(fun(C,fun(D,$o)),fun(C,B),aa(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(C,B)),aa(set(D),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(C,B))),aa(B,fun(set(D),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(C,B)))),aTP_Lamp_asi(fun(B,fun(B,B)),fun(B,fun(set(D),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(C,B))))),F2),Z2),B2),G),R)),A3) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,F2,Z2),aa(fun(C,fun(D,$o)),fun(D,B),aa(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(D,B)),aa(set(C),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(D,B))),aa(B,fun(set(C),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(D,B)))),aTP_Lamp_ask(fun(B,fun(B,B)),fun(B,fun(set(C),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(D,B))))),F2),Z2),A3),G),R)),B2) ) ) ) ) ).

% comm_monoid_set.swap_restrict
tff(fact_5200_comm__monoid__set_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),M2: nat,N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aTP_Lamp_xh(fun(nat,B),fun(nat,B),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% comm_monoid_set.shift_bounds_cl_Suc_ivl
tff(fact_5201_comm__monoid__set_Oshift__bounds__Suc__ivl,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),M2: nat,N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aTP_Lamp_xh(fun(nat,B),fun(nat,B),G)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% comm_monoid_set.shift_bounds_Suc_ivl
tff(fact_5202_comm__monoid__set_Oshift__bounds__cl__nat__ivl,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),M2: nat,K: nat,N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(nat,fun(nat,B),aTP_Lamp_asl(fun(nat,B),fun(nat,fun(nat,B)),G),K)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% comm_monoid_set.shift_bounds_cl_nat_ivl
tff(fact_5203_comm__monoid__set_Oshift__bounds__nat__ivl,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),M2: nat,K: nat,N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M2),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(nat,fun(nat,B),aTP_Lamp_asl(fun(nat,B),fun(nat,fun(nat,B)),G),K)),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% comm_monoid_set.shift_bounds_nat_ivl
tff(fact_5204_comm__monoid__set_Oreindex__bij__betw,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(B,fun(B,B)),Z2: B,H2: fun(C,D),S: set(C),T2: set(D),G: fun(D,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( bij_betw(C,D,H2,S,T2)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(fun(D,B),fun(C,B),aTP_Lamp_asm(fun(C,D),fun(fun(D,B),fun(C,B)),H2),G)),S) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,F2,Z2),G),T2) ) ) ) ).

% comm_monoid_set.reindex_bij_betw
tff(fact_5205_comm__monoid__list__set__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups4802862169904069756st_set(B,F2,Z2)
    <=> ( groups1828464146339083142d_list(B,F2,Z2)
        & groups778175481326437816id_set(B,F2,Z2) ) ) ).

% comm_monoid_list_set_def
tff(fact_5206_comm__monoid__list__set_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( groups1828464146339083142d_list(B,F2,Z2)
     => ( groups778175481326437816id_set(B,F2,Z2)
       => groups4802862169904069756st_set(B,F2,Z2) ) ) ).

% comm_monoid_list_set.intro
tff(fact_5207_comm__monoid__set_Oimage__gen,axiom,
    ! [B: $tType,D: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,S: set(C),H2: fun(C,B),G: fun(C,D)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),S)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),H2),S) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,F2,Z2),aa(fun(C,D),fun(D,B),aa(fun(C,B),fun(fun(C,D),fun(D,B)),aa(set(C),fun(fun(C,B),fun(fun(C,D),fun(D,B))),aa(B,fun(set(C),fun(fun(C,B),fun(fun(C,D),fun(D,B)))),aTP_Lamp_aso(fun(B,fun(B,B)),fun(B,fun(set(C),fun(fun(C,B),fun(fun(C,D),fun(D,B))))),F2),Z2),S),H2),G)),aa(set(C),set(D),image2(C,D,G),S)) ) ) ) ).

% comm_monoid_set.image_gen
tff(fact_5208_comm__monoid__set_Ointer__restrict,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),G: fun(C,B),B2: set(C)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),B2)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(set(C),fun(C,B),aa(fun(C,B),fun(set(C),fun(C,B)),aTP_Lamp_asp(B,fun(fun(C,B),fun(set(C),fun(C,B))),Z2),G),B2)),A3) ) ) ) ).

% comm_monoid_set.inter_restrict
tff(fact_5209_comm__monoid__set_Osetdiff__irrelevant,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),G: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A3),aa(fun(C,$o),set(C),collect(C),aa(fun(C,B),fun(C,$o),aTP_Lamp_asq(B,fun(fun(C,B),fun(C,$o)),Z2),G)))) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),A3) ) ) ) ).

% comm_monoid_set.setdiff_irrelevant
tff(fact_5210_comm__monoid__set_OSuc__reindex__ivl,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,M2: nat,N: nat,G: fun(nat,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
       => ( aa(B,B,aa(B,fun(B,B),F2,aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,M2,N))),aa(nat,B,G,aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),F2,aa(nat,B,G,M2)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aTP_Lamp_xh(fun(nat,B),fun(nat,B),G)),set_or1337092689740270186AtMost(nat,M2,N))) ) ) ) ).

% comm_monoid_set.Suc_reindex_ivl
tff(fact_5211_comm__monoid__set_Oimage__eq,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(C,B),A3: set(C)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( inj_on(C,B,G,A3)
       => ( aa(set(B),B,aa(fun(B,B),fun(set(B),B),groups_comm_monoid_F(B,B,F2,Z2),aTP_Lamp_bk(B,B)),aa(set(C),set(B),image2(C,B,G),A3)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),A3) ) ) ) ).

% comm_monoid_set.image_eq
tff(fact_5212_comm__monoid__set_OatMost__Suc__shift,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),F2,aa(nat,B,G,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aTP_Lamp_xh(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_atMost(nat),N))) ) ) ).

% comm_monoid_set.atMost_Suc_shift
tff(fact_5213_comm__monoid__set_OatLeastAtMost__rev,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),N: nat,M2: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,N,M2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_asr(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),G),N),M2)),set_or1337092689740270186AtMost(nat,N,M2)) ) ) ).

% comm_monoid_set.atLeastAtMost_rev
tff(fact_5214_comm__monoid__set_OlessThan__Suc__shift,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),F2,aa(nat,B,G,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aTP_Lamp_xh(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% comm_monoid_set.lessThan_Suc_shift
tff(fact_5215_comm__monoid__set_Ocartesian__product,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(C,fun(D,B)),B2: set(D),A3: set(C)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(set(D),fun(C,B),aa(fun(C,fun(D,B)),fun(set(D),fun(C,B)),aa(B,fun(fun(C,fun(D,B)),fun(set(D),fun(C,B))),aTP_Lamp_arx(fun(B,fun(B,B)),fun(B,fun(fun(C,fun(D,B)),fun(set(D),fun(C,B)))),F2),Z2),G),B2)),A3) = aa(set(product_prod(C,D)),B,aa(fun(product_prod(C,D),B),fun(set(product_prod(C,D)),B),groups_comm_monoid_F(B,product_prod(C,D),F2,Z2),aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),G)),product_Sigma(C,D,A3,aTP_Lamp_eq(set(D),fun(C,set(D)),B2))) ) ) ).

% comm_monoid_set.cartesian_product
tff(fact_5216_comm__monoid__set_Onat__diff__reindex,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(nat,fun(nat,B),aTP_Lamp_ass(fun(nat,B),fun(nat,fun(nat,B)),G),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% comm_monoid_set.nat_diff_reindex
tff(fact_5217_comm__monoid__set_Ounion__inter,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),B2: set(C),G: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(C),$o,finite_finite2(C),B2)
         => ( aa(B,B,aa(B,fun(B,B),F2,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A3),B2))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),B2))) = aa(B,B,aa(B,fun(B,B),F2,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),A3)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),B2)) ) ) ) ) ).

% comm_monoid_set.union_inter
tff(fact_5218_comm__monoid__set_Ounion__inter__neutral,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),B2: set(C),G: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(C),$o,finite_finite2(C),B2)
         => ( ! [X: C] :
                ( aa(set(C),$o,member(C,X),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),B2))
               => ( aa(C,B,G,X) = Z2 ) )
           => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A3),B2)) = aa(B,B,aa(B,fun(B,B),F2,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),A3)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),B2)) ) ) ) ) ) ).

% comm_monoid_set.union_inter_neutral
tff(fact_5219_comm__monoid__set_OInt__Diff,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),G: fun(C,B),B2: set(C)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),A3) = aa(B,B,aa(B,fun(B,B),F2,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),B2))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A3),B2))) ) ) ) ).

% comm_monoid_set.Int_Diff
tff(fact_5220_comm__monoid__set_Omono__neutral__cong,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,T2: set(C),S: set(C),H2: fun(C,B),G: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),T2)
       => ( aa(set(C),$o,finite_finite2(C),S)
         => ( ! [I3: C] :
                ( aa(set(C),$o,member(C,I3),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T2),S))
               => ( aa(C,B,H2,I3) = Z2 ) )
           => ( ! [I3: C] :
                  ( aa(set(C),$o,member(C,I3),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),S),T2))
                 => ( aa(C,B,G,I3) = Z2 ) )
             => ( ! [X: C] :
                    ( aa(set(C),$o,member(C,X),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),S),T2))
                   => ( aa(C,B,G,X) = aa(C,B,H2,X) ) )
               => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),S) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),H2),T2) ) ) ) ) ) ) ) ).

% comm_monoid_set.mono_neutral_cong
tff(fact_5221_comm__monoid__set_Ogroup,axiom,
    ! [D: $tType,B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,S: set(C),T2: set(D),G: fun(C,D),H2: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),S)
       => ( aa(set(D),$o,finite_finite2(D),T2)
         => ( aa(set(D),$o,aa(set(D),fun(set(D),$o),ord_less_eq(set(D)),aa(set(C),set(D),image2(C,D,G),S)),T2)
           => ( aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,F2,Z2),aa(fun(C,B),fun(D,B),aa(fun(C,D),fun(fun(C,B),fun(D,B)),aa(set(C),fun(fun(C,D),fun(fun(C,B),fun(D,B))),aa(B,fun(set(C),fun(fun(C,D),fun(fun(C,B),fun(D,B)))),aTP_Lamp_ast(fun(B,fun(B,B)),fun(B,fun(set(C),fun(fun(C,D),fun(fun(C,B),fun(D,B))))),F2),Z2),S),G),H2)),T2) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),H2),S) ) ) ) ) ) ).

% comm_monoid_set.group
tff(fact_5222_comm__monoid__set_OatLeastLessThan__rev,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),N: nat,M2: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_asu(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),G),N),M2)),set_or7035219750837199246ssThan(nat,N,M2)) ) ) ).

% comm_monoid_set.atLeastLessThan_rev
tff(fact_5223_comm__monoid__set_OSigma,axiom,
    ! [B: $tType,D: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),B2: fun(C,set(D)),G: fun(C,fun(D,B))] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( ! [X: C] :
              ( aa(set(C),$o,member(C,X),A3)
             => aa(set(D),$o,finite_finite2(D),aa(C,set(D),B2,X)) )
         => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(fun(C,fun(D,B)),fun(C,B),aa(fun(C,set(D)),fun(fun(C,fun(D,B)),fun(C,B)),aa(B,fun(fun(C,set(D)),fun(fun(C,fun(D,B)),fun(C,B))),aTP_Lamp_asv(fun(B,fun(B,B)),fun(B,fun(fun(C,set(D)),fun(fun(C,fun(D,B)),fun(C,B)))),F2),Z2),B2),G)),A3) = aa(set(product_prod(C,D)),B,aa(fun(product_prod(C,D),B),fun(set(product_prod(C,D)),B),groups_comm_monoid_F(B,product_prod(C,D),F2,Z2),aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),G)),product_Sigma(C,D,A3,B2)) ) ) ) ) ).

% comm_monoid_set.Sigma
tff(fact_5224_comm__monoid__set_Onested__swap,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,A4: fun(nat,fun(nat,B)),N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(fun(nat,fun(nat,B)),fun(nat,B),aa(B,fun(fun(nat,fun(nat,B)),fun(nat,B)),aTP_Lamp_asw(fun(B,fun(B,B)),fun(B,fun(fun(nat,fun(nat,B)),fun(nat,B))),F2),Z2),A4)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(nat,fun(nat,B),aa(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),aa(B,fun(fun(nat,fun(nat,B)),fun(nat,fun(nat,B))),aTP_Lamp_asy(fun(B,fun(B,B)),fun(B,fun(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)))),F2),Z2),A4),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% comm_monoid_set.nested_swap
tff(fact_5225_comm__monoid__set_Oreindex__bij__betw__not__neutral,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(B,fun(B,B)),Z2: B,S3: set(C),T4: set(D),H2: fun(C,D),S: set(C),T2: set(D),G: fun(D,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),S3)
       => ( aa(set(D),$o,finite_finite2(D),T4)
         => ( bij_betw(C,D,H2,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),S),S3),aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),minus_minus(set(D)),T2),T4))
           => ( ! [A5: C] :
                  ( aa(set(C),$o,member(C,A5),S3)
                 => ( aa(D,B,G,aa(C,D,H2,A5)) = Z2 ) )
             => ( ! [B4: D] :
                    ( aa(set(D),$o,member(D,B4),T4)
                   => ( aa(D,B,G,B4) = Z2 ) )
               => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(fun(D,B),fun(C,B),aTP_Lamp_asm(fun(C,D),fun(fun(D,B),fun(C,B)),H2),G)),S) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,F2,Z2),G),T2) ) ) ) ) ) ) ) ).

% comm_monoid_set.reindex_bij_betw_not_neutral
tff(fact_5226_comm__monoid__set_OIf__cases,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),Pa: fun(C,$o),H2: fun(C,B),G: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_ca(fun(C,$o),fun(fun(C,B),fun(fun(C,B),fun(C,B))),Pa),H2),G)),A3) = aa(B,B,aa(B,fun(B,B),F2,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),H2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),aa(fun(C,$o),set(C),collect(C),Pa)))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),aa(set(C),set(C),uminus_uminus(set(C)),aa(fun(C,$o),set(C),collect(C),Pa))))) ) ) ) ).

% comm_monoid_set.If_cases
tff(fact_5227_comm__monoid__set_OatLeast1__atMost__eq,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aTP_Lamp_xh(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% comm_monoid_set.atLeast1_atMost_eq
tff(fact_5228_comm__monoid__set_OatMost__shift,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(B,B,aa(B,fun(B,B),F2,aa(nat,B,G,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aTP_Lamp_xh(fun(nat,B),fun(nat,B),G)),aa(nat,set(nat),set_ord_lessThan(nat),N))) ) ) ).

% comm_monoid_set.atMost_shift
tff(fact_5229_comm__monoid__set_Onat__group,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),K: nat,N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(nat,fun(nat,B),aa(fun(nat,B),fun(nat,fun(nat,B)),aa(B,fun(fun(nat,B),fun(nat,fun(nat,B))),aTP_Lamp_asz(fun(B,fun(B,B)),fun(B,fun(fun(nat,B),fun(nat,fun(nat,B)))),F2),Z2),G),K)),aa(nat,set(nat),set_ord_lessThan(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))) ) ) ).

% comm_monoid_set.nat_group
tff(fact_5230_comm__monoid__set_Onested__swap_H,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,A4: fun(nat,fun(nat,B)),N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(fun(nat,fun(nat,B)),fun(nat,B),aa(B,fun(fun(nat,fun(nat,B)),fun(nat,B)),aTP_Lamp_ata(fun(B,fun(B,B)),fun(B,fun(fun(nat,fun(nat,B)),fun(nat,B))),F2),Z2),A4)),aa(nat,set(nat),set_ord_atMost(nat),N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(nat,fun(nat,B),aa(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),aa(B,fun(fun(nat,fun(nat,B)),fun(nat,fun(nat,B))),aTP_Lamp_asy(fun(B,fun(B,B)),fun(B,fun(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)))),F2),Z2),A4),N)),aa(nat,set(nat),set_ord_lessThan(nat),N)) ) ) ).

% comm_monoid_set.nested_swap'
tff(fact_5231_comm__monoid__set_Oinsert__remove,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),G: fun(C,B),X2: C] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),insert(C,X2),A3)) = aa(B,B,aa(B,fun(B,B),F2,aa(C,B,G,X2)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A3),aa(set(C),set(C),insert(C,X2),bot_bot(set(C)))))) ) ) ) ).

% comm_monoid_set.insert_remove
tff(fact_5232_comm__monoid__set_Oremove,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),X2: C,G: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(C),$o,member(C,X2),A3)
         => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),A3) = aa(B,B,aa(B,fun(B,B),F2,aa(C,B,G,X2)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A3),aa(set(C),set(C),insert(C,X2),bot_bot(set(C)))))) ) ) ) ) ).

% comm_monoid_set.remove
tff(fact_5233_comm__monoid__set_Ounion__disjoint,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),B2: set(C),G: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(C),$o,finite_finite2(C),B2)
         => ( ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),B2) = bot_bot(set(C)) )
           => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A3),B2)) = aa(B,B,aa(B,fun(B,B),F2,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),A3)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),B2)) ) ) ) ) ) ).

% comm_monoid_set.union_disjoint
tff(fact_5234_comm__monoid__set_Ounion__diff2,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(C),B2: set(C),G: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),A3)
       => ( aa(set(C),$o,finite_finite2(C),B2)
         => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A3),B2)) = aa(B,B,aa(B,fun(B,B),F2,aa(B,B,aa(B,fun(B,B),F2,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A3),B2))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),B2),A3)))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A3),B2))) ) ) ) ) ).

% comm_monoid_set.union_diff2
tff(fact_5235_comm__monoid__set_Odelta__remove,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,S: set(C),A4: C,B3: fun(C,B),Ca: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),S)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_atb(C,fun(fun(C,B),fun(fun(C,B),fun(C,B))),A4),B3),Ca)),S)
          = $ite(aa(set(C),$o,member(C,A4),S),aa(B,B,aa(B,fun(B,B),F2,aa(C,B,B3,A4)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),Ca),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),S),aa(set(C),set(C),insert(C,A4),bot_bot(set(C)))))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),Ca),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),S),aa(set(C),set(C),insert(C,A4),bot_bot(set(C)))))) ) ) ) ).

% comm_monoid_set.delta_remove
tff(fact_5236_comm__monoid__set_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),N: nat,M2: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or7035219750837199246ssThan(nat,N,M2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_asr(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),G),N),M2)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M2)) ) ) ).

% comm_monoid_set.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_5237_comm__monoid__set_OatLeast__atMost__pred__shift,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),M2: nat,N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(fun(nat,nat),fun(nat,B),comp(nat,B,nat,G),aTP_Lamp_sv(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% comm_monoid_set.atLeast_atMost_pred_shift
tff(fact_5238_comm__monoid__set_OatLeast__lessThan__pred__shift,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),M2: nat,N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(fun(nat,nat),fun(nat,B),comp(nat,B,nat,G),aTP_Lamp_sv(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M2),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or7035219750837199246ssThan(nat,M2,N)) ) ) ).

% comm_monoid_set.atLeast_lessThan_pred_shift
tff(fact_5239_comm__monoid__set_Oin__pairs,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),M2: nat,N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(fun(nat,B),fun(nat,B),aTP_Lamp_atc(fun(B,fun(B,B)),fun(fun(nat,B),fun(nat,B)),F2),G)),set_or1337092689740270186AtMost(nat,M2,N)) ) ) ).

% comm_monoid_set.in_pairs
tff(fact_5240_comm__monoid__set_OUNION__disjoint,axiom,
    ! [D: $tType,B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,I: set(C),A3: fun(C,set(D)),G: fun(D,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),I)
       => ( ! [X: C] :
              ( aa(set(C),$o,member(C,X),I)
             => aa(set(D),$o,finite_finite2(D),aa(C,set(D),A3,X)) )
         => ( ! [X: C] :
                ( aa(set(C),$o,member(C,X),I)
               => ! [Xa4: C] :
                    ( aa(set(C),$o,member(C,Xa4),I)
                   => ( ( X != Xa4 )
                     => ( aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),inf_inf(set(D)),aa(C,set(D),A3,X)),aa(C,set(D),A3,Xa4)) = bot_bot(set(D)) ) ) ) )
           => ( aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,F2,Z2),G),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A3),I))) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),aa(fun(D,B),fun(C,B),aa(fun(C,set(D)),fun(fun(D,B),fun(C,B)),aa(B,fun(fun(C,set(D)),fun(fun(D,B),fun(C,B))),aTP_Lamp_atd(fun(B,fun(B,B)),fun(B,fun(fun(C,set(D)),fun(fun(D,B),fun(C,B)))),F2),Z2),A3),G)),I) ) ) ) ) ) ).

% comm_monoid_set.UNION_disjoint
tff(fact_5241_comm__monoid__set_Oin__pairs__0,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(nat,B),N: nat] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,F2,Z2),aa(fun(nat,B),fun(nat,B),aTP_Lamp_atc(fun(B,fun(B,B)),fun(fun(nat,B),fun(nat,B)),F2),G)),aa(nat,set(nat),set_ord_atMost(nat),N)) ) ) ).

% comm_monoid_set.in_pairs_0
tff(fact_5242_comm__monoid__set_OUnion__disjoint,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,C2: set(set(C)),G: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( ! [X: set(C)] :
            ( aa(set(set(C)),$o,member(set(C),X),C2)
           => aa(set(C),$o,finite_finite2(C),X) )
       => ( ! [X: set(C)] :
              ( aa(set(set(C)),$o,member(set(C),X),C2)
             => ! [Xa4: set(C)] :
                  ( aa(set(set(C)),$o,member(set(C),Xa4),C2)
                 => ( ( X != Xa4 )
                   => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),X),Xa4) = bot_bot(set(C)) ) ) ) )
         => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),G),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),C2)) = aa(set(set(C)),B,aa(fun(C,B),fun(set(set(C)),B),aa(fun(fun(C,B),fun(set(C),B)),fun(fun(C,B),fun(set(set(C)),B)),comp(fun(set(C),B),fun(set(set(C)),B),fun(C,B),groups_comm_monoid_F(B,set(C),F2,Z2)),groups_comm_monoid_F(B,C,F2,Z2)),G),C2) ) ) ) ) ).

% comm_monoid_set.Union_disjoint
tff(fact_5243_insort__insert__insort,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Xs: list(B)] :
          ( ~ aa(set(B),$o,member(B,X2),aa(list(B),set(B),set2(B),Xs))
         => ( linord329482645794927042rt_key(B,B,aTP_Lamp_eh(B,B),X2,Xs) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_eh(B,B)),X2),Xs) ) ) ) ).

% insort_insert_insort
tff(fact_5244_Quotient__multiset,axiom,
    ! [B: $tType] : quotient(fun(B,nat),multiset(B),bNF_eq_onp(fun(B,nat),aTP_Lamp_apb(fun(B,nat),$o)),abs_multiset(B),count(B),cr_multiset(B)) ).

% Quotient_multiset
tff(fact_5245_sorted__insort__insert,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B),X2: B] :
          ( sorted_wrt(B,ord_less_eq(B),Xs)
         => sorted_wrt(B,ord_less_eq(B),linord329482645794927042rt_key(B,B,aTP_Lamp_eh(B,B),X2,Xs)) ) ) ).

% sorted_insort_insert
tff(fact_5246_QuotientI,axiom,
    ! [B: $tType,C: $tType,Abs: fun(C,B),Rep: fun(B,C),R: fun(C,fun(C,$o)),T2: fun(C,fun(B,$o))] :
      ( ! [A5: B] : ( aa(C,B,Abs,aa(B,C,Rep,A5)) = A5 )
     => ( ! [A5: B] : aa(C,$o,aa(C,fun(C,$o),R,aa(B,C,Rep,A5)),aa(B,C,Rep,A5))
       => ( ! [R3: C,S6: C] :
              ( aa(C,$o,aa(C,fun(C,$o),R,R3),S6)
            <=> ( aa(C,$o,aa(C,fun(C,$o),R,R3),R3)
                & aa(C,$o,aa(C,fun(C,$o),R,S6),S6)
                & ( aa(C,B,Abs,R3) = aa(C,B,Abs,S6) ) ) )
         => ( ! [X: C,Xa4: B] :
                ( aa(B,$o,aa(C,fun(B,$o),T2,X),Xa4)
              <=> ( aa(C,$o,aa(C,fun(C,$o),R,X),X)
                  & ( aa(C,B,Abs,X) = Xa4 ) ) )
           => quotient(C,B,R,Abs,Rep,T2) ) ) ) ) ).

% QuotientI
tff(fact_5247_Quotient__def,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(B,$o)),Abs: fun(B,C),Rep: fun(C,B),T2: fun(B,fun(C,$o))] :
      ( quotient(B,C,R,Abs,Rep,T2)
    <=> ( ! [A6: C] : ( aa(B,C,Abs,aa(C,B,Rep,A6)) = A6 )
        & ! [A6: C] : aa(B,$o,aa(B,fun(B,$o),R,aa(C,B,Rep,A6)),aa(C,B,Rep,A6))
        & ! [R6: B,S7: B] :
            ( aa(B,$o,aa(B,fun(B,$o),R,R6),S7)
          <=> ( aa(B,$o,aa(B,fun(B,$o),R,R6),R6)
              & aa(B,$o,aa(B,fun(B,$o),R,S7),S7)
              & ( aa(B,C,Abs,R6) = aa(B,C,Abs,S7) ) ) )
        & ! [X3: B,Xa2: C] :
            ( aa(C,$o,aa(B,fun(C,$o),T2,X3),Xa2)
          <=> ( aa(B,$o,aa(B,fun(B,$o),R,X3),X3)
              & ( aa(B,C,Abs,X3) = Xa2 ) ) ) ) ) ).

% Quotient_def
tff(fact_5248_Quotient__cr__rel,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(B,$o)),Abs: fun(B,C),Rep: fun(C,B),T2: fun(B,fun(C,$o))] :
      ( quotient(B,C,R,Abs,Rep,T2)
     => ! [X4: B,Xa3: C] :
          ( aa(C,$o,aa(B,fun(C,$o),T2,X4),Xa3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),R,X4),X4)
            & ( aa(B,C,Abs,X4) = Xa3 ) ) ) ) ).

% Quotient_cr_rel
tff(fact_5249_UNIV__typedef__to__Quotient,axiom,
    ! [B: $tType,C: $tType,Rep: fun(B,C),Abs: fun(C,B),T2: fun(C,fun(B,$o))] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( ! [X: C,Xa4: B] :
            ( aa(B,$o,aa(C,fun(B,$o),T2,X),Xa4)
          <=> ( X = aa(B,C,Rep,Xa4) ) )
       => quotient(C,B,fequal(C),Abs,Rep,T2) ) ) ).

% UNIV_typedef_to_Quotient
tff(fact_5250_open__typedef__to__Quotient,axiom,
    ! [B: $tType,C: $tType,Rep: fun(B,C),Abs: fun(C,B),Pa: fun(C,$o),T2: fun(C,fun(B,$o))] :
      ( type_definition(B,C,Rep,Abs,aa(fun(C,$o),set(C),collect(C),Pa))
     => ( ! [X: C,Xa4: B] :
            ( aa(B,$o,aa(C,fun(B,$o),T2,X),Xa4)
          <=> ( X = aa(B,C,Rep,Xa4) ) )
       => quotient(C,B,bNF_eq_onp(C,Pa),Abs,Rep,T2) ) ) ).

% open_typedef_to_Quotient
tff(fact_5251_typedef__to__Quotient,axiom,
    ! [B: $tType,C: $tType,Rep: fun(B,C),Abs: fun(C,B),S: set(C),T2: fun(C,fun(B,$o))] :
      ( type_definition(B,C,Rep,Abs,S)
     => ( ! [X: C,Xa4: B] :
            ( aa(B,$o,aa(C,fun(B,$o),T2,X),Xa4)
          <=> ( X = aa(B,C,Rep,Xa4) ) )
       => quotient(C,B,bNF_eq_onp(C,aTP_Lamp_nw(set(C),fun(C,$o),S)),Abs,Rep,T2) ) ) ).

% typedef_to_Quotient
tff(fact_5252_insort__insert__triv,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Xs: list(B)] :
          ( aa(set(B),$o,member(B,X2),aa(list(B),set(B),set2(B),Xs))
         => ( linord329482645794927042rt_key(B,B,aTP_Lamp_eh(B,B),X2,Xs) = Xs ) ) ) ).

% insort_insert_triv
tff(fact_5253_cr__multiset__def,axiom,
    ! [B: $tType,X4: fun(B,nat),Xa3: multiset(B)] :
      ( aa(multiset(B),$o,aa(fun(B,nat),fun(multiset(B),$o),cr_multiset(B),X4),Xa3)
    <=> ( X4 = aa(multiset(B),fun(B,nat),count(B),Xa3) ) ) ).

% cr_multiset_def
tff(fact_5254_set__insort__insert,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X2: B,Xs: list(B)] : ( aa(list(B),set(B),set2(B),linord329482645794927042rt_key(B,B,aTP_Lamp_eh(B,B),X2,Xs)) = aa(set(B),set(B),insert(B,X2),aa(list(B),set(B),set2(B),Xs)) ) ) ).

% set_insort_insert
tff(fact_5255_Quotient__eq__onp__typedef,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),Abs: fun(B,C),Rep: fun(C,B),Cr: fun(B,fun(C,$o))] :
      ( quotient(B,C,bNF_eq_onp(B,Pa),Abs,Rep,Cr)
     => type_definition(C,B,Rep,Abs,aa(fun(B,$o),set(B),collect(B),Pa)) ) ).

% Quotient_eq_onp_typedef
tff(fact_5256_Quotient__crel__typedef,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),Abs: fun(B,C),Rep: fun(C,B),T2: fun(B,fun(C,$o))] :
      ( quotient(B,C,bNF_eq_onp(B,Pa),Abs,Rep,T2)
     => ! [X4: B,Xa3: C] :
          ( aa(C,$o,aa(B,fun(C,$o),T2,X4),Xa3)
        <=> ( X4 = aa(C,B,Rep,Xa3) ) ) ) ).

% Quotient_crel_typedef
tff(fact_5257_Quotient__crel__typecopy,axiom,
    ! [B: $tType,C: $tType,Abs: fun(B,C),Rep: fun(C,B),T2: fun(B,fun(C,$o))] :
      ( quotient(B,C,fequal(B),Abs,Rep,T2)
     => ! [X4: B,Xa3: C] :
          ( aa(C,$o,aa(B,fun(C,$o),T2,X4),Xa3)
        <=> ( X4 = aa(C,B,Rep,Xa3) ) ) ) ).

% Quotient_crel_typecopy
tff(fact_5258_subseqs_Osimps_I2_J,axiom,
    ! [B: $tType,X2: B,Xs: list(B)] :
      ( subseqs(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs))
      = $let(
          xss: list(list(B)),
          xss := subseqs(B,Xs),
          append(list(B),aa(list(list(B)),list(list(B)),map(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2)),xss),xss) ) ) ).

% subseqs.simps(2)
tff(fact_5259_sort__quicksort__by__rel,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( linorder_sort_key(B,B,aTP_Lamp_eh(B,B)) = quicksort_by_rel(B,ord_less_eq(B),nil(B)) ) ) ).

% sort_quicksort_by_rel
tff(fact_5260_Powp__Pow__eq,axiom,
    ! [B: $tType,A3: set(B),X4: set(B)] :
      ( powp(B,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),A3),X4)
    <=> aa(set(set(B)),$o,member(set(B),X4),pow(B,A3)) ) ).

% Powp_Pow_eq
tff(fact_5261_Powp__def,axiom,
    ! [B: $tType,A3: fun(B,$o),X4: set(B)] :
      ( powp(B,A3,X4)
    <=> ! [Xa2: B] :
          ( aa(set(B),$o,member(B,Xa2),X4)
         => aa(B,$o,A3,Xa2) ) ) ).

% Powp_def
tff(fact_5262_quicksort__by__rel_Oelims,axiom,
    ! [B: $tType,X2: fun(B,fun(B,$o)),Xa: list(B),Xb: list(B),Y: list(B)] :
      ( ( aa(list(B),list(B),quicksort_by_rel(B,X2,Xa),Xb) = Y )
     => ( ( ( Xb = nil(B) )
         => ( Y != Xa ) )
       => ~ ! [X: B,Xs2: list(B)] :
              ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2) )
             => ( Y != aa(product_prod(list(B),list(B)),list(B),aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aa(B,fun(list(B),fun(list(B),list(B))),aa(list(B),fun(B,fun(list(B),fun(list(B),list(B)))),aTP_Lamp_ate(fun(B,fun(B,$o)),fun(list(B),fun(B,fun(list(B),fun(list(B),list(B))))),X2),Xa),X)),partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),X2),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs2)) ) ) ) ) ).

% quicksort_by_rel.elims
tff(fact_5263_quicksort__by__rel_Osimps_I2_J,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),Sl: list(B),X2: B,Xs: list(B)] : ( aa(list(B),list(B),quicksort_by_rel(B,R,Sl),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(product_prod(list(B),list(B)),list(B),aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aa(B,fun(list(B),fun(list(B),list(B))),aa(list(B),fun(B,fun(list(B),fun(list(B),list(B)))),aTP_Lamp_ate(fun(B,fun(B,$o)),fun(list(B),fun(B,fun(list(B),fun(list(B),list(B))))),R),Sl),X2)),partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),R),X2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs)) ) ).

% quicksort_by_rel.simps(2)
tff(fact_5264_quicksort__by__rel_Opsimps_I2_J,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),Sl: list(B),X2: B,Xs: list(B)] :
      ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Sl),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs))))
     => ( aa(list(B),list(B),quicksort_by_rel(B,R,Sl),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs)) = aa(product_prod(list(B),list(B)),list(B),aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aa(B,fun(list(B),fun(list(B),list(B))),aa(list(B),fun(B,fun(list(B),fun(list(B),list(B)))),aTP_Lamp_ate(fun(B,fun(B,$o)),fun(list(B),fun(B,fun(list(B),fun(list(B),list(B))))),R),Sl),X2)),partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),R),X2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs)) ) ) ).

% quicksort_by_rel.psimps(2)
tff(fact_5265_quicksort__by__rel_Opelims,axiom,
    ! [B: $tType,X2: fun(B,fun(B,$o)),Xa: list(B),Xb: list(B),Y: list(B)] :
      ( ( aa(list(B),list(B),quicksort_by_rel(B,X2,Xa),Xb) = Y )
     => ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),X2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xa),Xb)))
       => ( ( ( Xb = nil(B) )
           => ( ( Y = Xa )
             => ~ aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),X2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xa),nil(B)))) ) )
         => ~ ! [X: B,Xs2: list(B)] :
                ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2) )
               => ( ( Y = aa(product_prod(list(B),list(B)),list(B),aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aa(B,fun(list(B),fun(list(B),list(B))),aa(list(B),fun(B,fun(list(B),fun(list(B),list(B)))),aTP_Lamp_ate(fun(B,fun(B,$o)),fun(list(B),fun(B,fun(list(B),fun(list(B),list(B))))),X2),Xa),X)),partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),X2),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs2)) )
                 => ~ aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),X2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xa),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2)))) ) ) ) ) ) ).

% quicksort_by_rel.pelims
tff(fact_5266_quicksort__by__rel_Opinduct,axiom,
    ! [B: $tType,A0: fun(B,fun(B,$o)),A13: list(B),A23: list(B),Pa: fun(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)))] :
      ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),A0),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),A13),A23)))
     => ( ! [R7: fun(B,fun(B,$o)),Sl2: list(B)] :
            ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R7),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Sl2),nil(B))))
           => aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)),Pa,R7),Sl2),nil(B)) )
       => ( ! [R7: fun(B,fun(B,$o)),Sl2: list(B),X: B,Xs2: list(B)] :
              ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R7),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Sl2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2))))
             => ( ! [Xa3: product_prod(list(B),list(B)),Xb3: list(B),Y5: list(B)] :
                    ( ( Xa3 = partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),R7),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs2) )
                   => ( ( aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xb3),Y5) = Xa3 )
                     => aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)),Pa,R7),Sl2),Y5) ) )
               => ( ! [Xa3: product_prod(list(B),list(B)),Xb3: list(B),Y5: list(B)] :
                      ( ( Xa3 = partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),R7),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs2) )
                     => ( ( aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xb3),Y5) = Xa3 )
                       => aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)),Pa,R7),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),aa(list(B),list(B),quicksort_by_rel(B,R7,Sl2),Y5))),Xb3) ) )
                 => aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)),Pa,R7),Sl2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs2)) ) ) )
         => aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)),Pa,A0),A13),A23) ) ) ) ).

% quicksort_by_rel.pinduct
tff(fact_5267_arg__min__list_Opelims,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [X2: fun(B,C),Xa: list(B),Y: B] :
          ( ( arg_min_list(B,C,X2,Xa) = Y )
         => ( aa(product_prod(fun(B,C),list(B)),$o,accp(product_prod(fun(B,C),list(B)),arg_min_list_rel(B,C)),aa(list(B),product_prod(fun(B,C),list(B)),aa(fun(B,C),fun(list(B),product_prod(fun(B,C),list(B))),product_Pair(fun(B,C),list(B)),X2),Xa))
           => ( ! [X: B] :
                  ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),nil(B)) )
                 => ( ( Y = X )
                   => ~ aa(product_prod(fun(B,C),list(B)),$o,accp(product_prod(fun(B,C),list(B)),arg_min_list_rel(B,C)),aa(list(B),product_prod(fun(B,C),list(B)),aa(fun(B,C),fun(list(B),product_prod(fun(B,C),list(B))),product_Pair(fun(B,C),list(B)),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),nil(B)))) ) )
             => ( ! [X: B,Y2: B,Zs3: list(B)] :
                    ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Zs3)) )
                   => ( ( Y
                        = $let(
                            m: B,
                            m := arg_min_list(B,C,X2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Zs3)),
                            $ite(aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,X2,X)),aa(B,C,X2,m)),X,m) ) )
                     => ~ aa(product_prod(fun(B,C),list(B)),$o,accp(product_prod(fun(B,C),list(B)),arg_min_list_rel(B,C)),aa(list(B),product_prod(fun(B,C),list(B)),aa(fun(B,C),fun(list(B),product_prod(fun(B,C),list(B))),product_Pair(fun(B,C),list(B)),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Zs3)))) ) )
               => ~ ( ( Xa = nil(B) )
                   => ( ( Y = undefined(B) )
                     => ~ aa(product_prod(fun(B,C),list(B)),$o,accp(product_prod(fun(B,C),list(B)),arg_min_list_rel(B,C)),aa(list(B),product_prod(fun(B,C),list(B)),aa(fun(B,C),fun(list(B),product_prod(fun(B,C),list(B))),product_Pair(fun(B,C),list(B)),X2),nil(B))) ) ) ) ) ) ) ) ).

% arg_min_list.pelims
tff(fact_5268_product__swap,axiom,
    ! [B: $tType,C: $tType,A3: set(C),B2: set(B)] : ( aa(set(product_prod(C,B)),set(product_prod(B,C)),image2(product_prod(C,B),product_prod(B,C),product_swap(C,B)),product_Sigma(C,B,A3,aTP_Lamp_bv(set(B),fun(C,set(B)),B2))) = product_Sigma(B,C,B2,aTP_Lamp_bq(set(C),fun(B,set(C)),A3)) ) ).

% product_swap
tff(fact_5269_MOST__INFM,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ~ aa(set(B),$o,finite_finite2(B),top_top(set(B)))
     => ( eventually(B,Pa,cofinite(B))
       => frequently(B,Pa,cofinite(B)) ) ) ).

% MOST_INFM
tff(fact_5270_frequently__const,axiom,
    ! [B: $tType,F: filter(B),Pa: $o] :
      ( ( F != bot_bot(filter(B)) )
     => ( frequently(B,aTP_Lamp_an($o,fun(B,$o),Pa),F)
      <=> (Pa) ) ) ).

% frequently_const
tff(fact_5271_case__swap,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(D,fun(C,B)),P3: product_prod(D,C)] : ( aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),aTP_Lamp_atf(fun(D,fun(C,B)),fun(C,fun(D,B)),F2)),aa(product_prod(D,C),product_prod(C,D),product_swap(D,C),P3)) = aa(product_prod(D,C),B,aa(fun(D,fun(C,B)),fun(product_prod(D,C),B),product_case_prod(D,C,B),F2),P3) ) ).

% case_swap
tff(fact_5272_not__INFM,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ~ frequently(B,Pa,cofinite(B))
    <=> eventually(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa),cofinite(B)) ) ).

% not_INFM
tff(fact_5273_not__MOST,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ~ eventually(B,Pa,cofinite(B))
    <=> frequently(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa),cofinite(B)) ) ).

% not_MOST
tff(fact_5274_INFM__const,axiom,
    ! [B: $tType,Pa: $o] :
      ( frequently(B,aTP_Lamp_an($o,fun(B,$o),Pa),cofinite(B))
    <=> ( (Pa)
        & ~ aa(set(B),$o,finite_finite2(B),top_top(set(B))) ) ) ).

% INFM_const
tff(fact_5275_INFM__neq_I1_J,axiom,
    ! [B: $tType,A4: B] :
      ( frequently(B,aa(B,fun(B,$o),aTP_Lamp_rx(B,fun(B,$o)),A4),cofinite(B))
    <=> ~ aa(set(B),$o,finite_finite2(B),top_top(set(B))) ) ).

% INFM_neq(1)
tff(fact_5276_INFM__neq_I2_J,axiom,
    ! [B: $tType,A4: B] :
      ( frequently(B,aa(B,fun(B,$o),aTP_Lamp_adk(B,fun(B,$o)),A4),cofinite(B))
    <=> ~ aa(set(B),$o,finite_finite2(B),top_top(set(B))) ) ).

% INFM_neq(2)
tff(fact_5277_frequently__const__iff,axiom,
    ! [B: $tType,Pa: $o,F: filter(B)] :
      ( frequently(B,aTP_Lamp_an($o,fun(B,$o),Pa),F)
    <=> ( (Pa)
        & ( F != bot_bot(filter(B)) ) ) ) ).

% frequently_const_iff
tff(fact_5278_frequently__all,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o)),F: filter(B)] :
      ( frequently(B,aTP_Lamp_afj(fun(B,fun(C,$o)),fun(B,$o),Pa),F)
    <=> ! [Y7: fun(B,C)] : frequently(B,aa(fun(B,C),fun(B,$o),aTP_Lamp_nl(fun(B,fun(C,$o)),fun(fun(B,C),fun(B,$o)),Pa),Y7),F) ) ).

% frequently_all
tff(fact_5279_not__frequently__False,axiom,
    ! [B: $tType,F: filter(B)] : ~ frequently(B,aTP_Lamp_ao(B,$o),F) ).

% not_frequently_False
tff(fact_5280_frequently__disj__iff,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o),F: filter(B)] :
      ( frequently(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_au(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F)
    <=> ( frequently(B,Pa,F)
        | frequently(B,Qa,F) ) ) ).

% frequently_disj_iff
tff(fact_5281_frequently__elim1,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),Qa: fun(B,$o)] :
      ( frequently(B,Pa,F)
     => ( ! [I3: B] :
            ( aa(B,$o,Pa,I3)
           => aa(B,$o,Qa,I3) )
       => frequently(B,Qa,F) ) ) ).

% frequently_elim1
tff(fact_5282_frequently__disj,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),Qa: fun(B,$o)] :
      ( frequently(B,Pa,F)
     => ( frequently(B,Qa,F)
       => frequently(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_au(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F) ) ) ).

% frequently_disj
tff(fact_5283_frequently__ex,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B)] :
      ( frequently(B,Pa,F)
     => ? [X_1: B] : aa(B,$o,Pa,X_1) ) ).

% frequently_ex
tff(fact_5284_eventually__frequently__const__simps_I1_J,axiom,
    ! [B: $tType,Pa: fun(B,$o),C2: $o,F: filter(B)] :
      ( frequently(B,aa($o,fun(B,$o),aTP_Lamp_atg(fun(B,$o),fun($o,fun(B,$o)),Pa),C2),F)
    <=> ( frequently(B,Pa,F)
        & (C2) ) ) ).

% eventually_frequently_const_simps(1)
tff(fact_5285_eventually__frequently__const__simps_I2_J,axiom,
    ! [B: $tType,C2: $o,Pa: fun(B,$o),F: filter(B)] :
      ( frequently(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_ath($o,fun(fun(B,$o),fun(B,$o)),C2),Pa),F)
    <=> ( (C2)
        & frequently(B,Pa,F) ) ) ).

% eventually_frequently_const_simps(2)
tff(fact_5286_eventually__frequently__const__simps_I5_J,axiom,
    ! [B: $tType,Pa: fun(B,$o),C2: $o,F: filter(B)] :
      ( eventually(B,aa($o,fun(B,$o),aTP_Lamp_ati(fun(B,$o),fun($o,fun(B,$o)),Pa),C2),F)
    <=> ( frequently(B,Pa,F)
       => (C2) ) ) ).

% eventually_frequently_const_simps(5)
tff(fact_5287_frequently__mp,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o),F: filter(B)] :
      ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aw(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F)
     => ( frequently(B,Pa,F)
       => frequently(B,Qa,F) ) ) ).

% frequently_mp
tff(fact_5288_frequently__def,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B)] :
      ( frequently(B,Pa,F)
    <=> ~ eventually(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa),F) ) ).

% frequently_def
tff(fact_5289_not__eventually,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B)] :
      ( ~ eventually(B,Pa,F)
    <=> frequently(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa),F) ) ).

% not_eventually
tff(fact_5290_not__frequently,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B)] :
      ( ~ frequently(B,Pa,F)
    <=> eventually(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa),F) ) ).

% not_frequently
tff(fact_5291_frequently__rev__mp,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),Qa: fun(B,$o)] :
      ( frequently(B,Pa,F)
     => ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aw(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F)
       => frequently(B,Qa,F) ) ) ).

% frequently_rev_mp
tff(fact_5292_frequently__imp__iff,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o),F: filter(B)] :
      ( frequently(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aw(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F)
    <=> ( eventually(B,Pa,F)
       => frequently(B,Qa,F) ) ) ).

% frequently_imp_iff
tff(fact_5293_INFM__disj__distrib,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( frequently(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_au(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),cofinite(B))
    <=> ( frequently(B,Pa,cofinite(B))
        | frequently(B,Qa,cofinite(B)) ) ) ).

% INFM_disj_distrib
tff(fact_5294_INFM__mono,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( frequently(B,Pa,cofinite(B))
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
           => aa(B,$o,Qa,X) )
       => frequently(B,Qa,cofinite(B)) ) ) ).

% INFM_mono
tff(fact_5295_INFM__EX,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( frequently(B,Pa,cofinite(B))
     => ? [X_1: B] : aa(B,$o,Pa,X_1) ) ).

% INFM_EX
tff(fact_5296_INFM__E,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( frequently(B,Pa,cofinite(B))
     => ~ ! [X: B] : ~ aa(B,$o,Pa,X) ) ).

% INFM_E
tff(fact_5297_not__INFM__eq_I1_J,axiom,
    ! [B: $tType,A4: B] : ~ frequently(B,aTP_Lamp_ct(B,fun(B,$o),A4),cofinite(B)) ).

% not_INFM_eq(1)
tff(fact_5298_not__INFM__eq_I2_J,axiom,
    ! [B: $tType,A4: B] : ~ frequently(B,aa(B,fun(B,$o),fequal(B),A4),cofinite(B)) ).

% not_INFM_eq(2)
tff(fact_5299_eventually__frequently,axiom,
    ! [B: $tType,F: filter(B),Pa: fun(B,$o)] :
      ( ( F != bot_bot(filter(B)) )
     => ( eventually(B,Pa,F)
       => frequently(B,Pa,F) ) ) ).

% eventually_frequently
tff(fact_5300_frequently__bex__finite__distrib,axiom,
    ! [B: $tType,C: $tType,A3: set(B),Pa: fun(C,fun(B,$o)),F: filter(C)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( frequently(C,aa(fun(C,fun(B,$o)),fun(C,$o),aTP_Lamp_aeo(set(B),fun(fun(C,fun(B,$o)),fun(C,$o)),A3),Pa),F)
      <=> ? [X3: B] :
            ( aa(set(B),$o,member(B,X3),A3)
            & frequently(C,aa(B,fun(C,$o),aTP_Lamp_km(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Pa),X3),F) ) ) ) ).

% frequently_bex_finite_distrib
tff(fact_5301_frequently__bex__finite,axiom,
    ! [B: $tType,C: $tType,A3: set(B),Pa: fun(C,fun(B,$o)),F: filter(C)] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( frequently(C,aa(fun(C,fun(B,$o)),fun(C,$o),aTP_Lamp_aeo(set(B),fun(fun(C,fun(B,$o)),fun(C,$o)),A3),Pa),F)
       => ? [X: B] :
            ( aa(set(B),$o,member(B,X),A3)
            & frequently(C,aa(B,fun(C,$o),aTP_Lamp_km(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Pa),X),F) ) ) ) ).

% frequently_bex_finite
tff(fact_5302_frequently__cofinite,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( frequently(B,Pa,cofinite(B))
    <=> ~ aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Pa)) ) ).

% frequently_cofinite
tff(fact_5303_INFM__iff__infinite,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( frequently(B,Pa,cofinite(B))
    <=> ~ aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),Pa)) ) ).

% INFM_iff_infinite
tff(fact_5304_INFM__conjI,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( frequently(B,Pa,cofinite(B))
     => ( eventually(B,Qa,cofinite(B))
       => frequently(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),cofinite(B)) ) ) ).

% INFM_conjI
tff(fact_5305_Alm__all__def,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( eventually(B,Pa,cofinite(B))
    <=> ~ frequently(B,aTP_Lamp_as(fun(B,$o),fun(B,$o),Pa),cofinite(B)) ) ).

% Alm_all_def
tff(fact_5306_INFM__imp__distrib,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( frequently(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aw(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),cofinite(B))
    <=> ( eventually(B,Pa,cofinite(B))
       => frequently(B,Qa,cofinite(B)) ) ) ).

% INFM_imp_distrib
tff(fact_5307_eventually__frequentlyE,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),Qa: fun(B,$o)] :
      ( eventually(B,Pa,F)
     => ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_atj(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F)
       => ( ( F != bot_bot(filter(B)) )
         => frequently(B,Qa,F) ) ) ) ).

% eventually_frequentlyE
tff(fact_5308_INFM__nat,axiom,
    ! [Pa: fun(nat,$o)] :
      ( frequently(nat,Pa,cofinite(nat))
    <=> ! [M4: nat] :
        ? [N4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N4)
          & aa(nat,$o,Pa,N4) ) ) ).

% INFM_nat
tff(fact_5309_INFM__nat__le,axiom,
    ! [Pa: fun(nat,$o)] :
      ( frequently(nat,Pa,cofinite(nat))
    <=> ! [M4: nat] :
        ? [N4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N4)
          & aa(nat,$o,Pa,N4) ) ) ).

% INFM_nat_le
tff(fact_5310_INFM__inj,axiom,
    ! [B: $tType,C: $tType,Pa: fun(C,$o),F2: fun(B,C)] :
      ( frequently(B,aa(fun(B,C),fun(B,$o),aTP_Lamp_atk(fun(C,$o),fun(fun(B,C),fun(B,$o)),Pa),F2),cofinite(B))
     => ( inj_on(B,C,F2,top_top(set(B)))
       => frequently(C,Pa,cofinite(C)) ) ) ).

% INFM_inj
tff(fact_5311_INFM__finite__Bex__distrib,axiom,
    ! [B: $tType,C: $tType,A3: set(B),Pa: fun(B,fun(C,$o))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( frequently(C,aa(fun(B,fun(C,$o)),fun(C,$o),aTP_Lamp_atl(set(B),fun(fun(B,fun(C,$o)),fun(C,$o)),A3),Pa),cofinite(C))
      <=> ? [X3: B] :
            ( aa(set(B),$o,member(B,X3),A3)
            & frequently(C,aa(B,fun(C,$o),Pa,X3),cofinite(C)) ) ) ) ).

% INFM_finite_Bex_distrib
tff(fact_5312_INFM__nat__inductI,axiom,
    ! [Pa: fun(nat,$o),Qa: fun(nat,$o)] :
      ( aa(nat,$o,Pa,zero_zero(nat))
     => ( ! [I3: nat] :
            ( aa(nat,$o,Pa,I3)
           => ? [J4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J4)
                & aa(nat,$o,Pa,J4)
                & aa(nat,$o,Qa,J4) ) )
       => frequently(nat,Qa,cofinite(nat)) ) ) ).

% INFM_nat_inductI
tff(fact_5313_Sup__multiset__def,axiom,
    ! [B: $tType,A3: set(multiset(B))] :
      ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A3)
      = $ite(
          ( ( A3 != bot_bot(set(multiset(B))) )
          & condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3) ),
          aa(fun(B,nat),multiset(B),abs_multiset(B),aTP_Lamp_atm(set(multiset(B)),fun(B,nat),A3)),
          zero_zero(multiset(B)) ) ) ).

% Sup_multiset_def
tff(fact_5314_irreflp__irrefl__eq,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( irreflp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R))
    <=> irrefl(B,R) ) ).

% irreflp_irrefl_eq
tff(fact_5315_comm__monoid__set_OG__def,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(B,B)),Z2: B,P3: fun(C,B),I: set(C)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),P3),I)
        = $ite(aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aa(fun(C,B),fun(set(C),fun(C,$o)),aTP_Lamp_atn(B,fun(fun(C,B),fun(set(C),fun(C,$o))),Z2),P3),I))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,F2,Z2),P3),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aa(fun(C,B),fun(set(C),fun(C,$o)),aTP_Lamp_atn(B,fun(fun(C,B),fun(set(C),fun(C,$o))),Z2),P3),I))),Z2) ) ) ).

% comm_monoid_set.G_def
tff(fact_5316_subset__mset_Obdd__above__empty,axiom,
    ! [B: $tType] : condit8047198070973881523_above(multiset(B),subseteq_mset(B),bot_bot(set(multiset(B)))) ).

% subset_mset.bdd_above_empty
tff(fact_5317_subset__mset_Obdd__above__UN,axiom,
    ! [C: $tType,B: $tType,I: set(B),A3: fun(B,set(multiset(C)))] :
      ( aa(set(B),$o,finite_finite2(B),I)
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(set(multiset(C))),set(multiset(C)),complete_Sup_Sup(set(multiset(C))),aa(set(B),set(set(multiset(C))),image2(B,set(multiset(C)),A3),I)))
      <=> ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),I)
           => condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(B,set(multiset(C)),A3,X3)) ) ) ) ).

% subset_mset.bdd_above_UN
tff(fact_5318_bdd__above__multiset__imp__bdd__above__count,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: B] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3)
     => condit941137186595557371_above(nat,aa(set(multiset(B)),set(nat),image2(multiset(B),nat,aTP_Lamp_apd(B,fun(multiset(B),nat),X2)),A3)) ) ).

% bdd_above_multiset_imp_bdd_above_count
tff(fact_5319_subset__mset_OcSUP__le__iff,axiom,
    ! [B: $tType,C: $tType,A3: set(B),F2: fun(B,multiset(C)),U: multiset(C)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))
       => ( aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))),U)
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),F2,X3)),U) ) ) ) ) ).

% subset_mset.cSUP_le_iff
tff(fact_5320_subset__mset_OcSUP__mono,axiom,
    ! [B: $tType,C: $tType,D: $tType,A3: set(B),G: fun(D,multiset(C)),B2: set(D),F2: fun(B,multiset(C))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(D),set(multiset(C)),image2(D,multiset(C),G),B2))
       => ( ! [N2: B] :
              ( aa(set(B),$o,member(B,N2),A3)
             => ? [X4: D] :
                  ( aa(set(D),$o,member(D,X4),B2)
                  & aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),F2,N2)),aa(D,multiset(C),G,X4)) ) )
         => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(D),set(multiset(C)),image2(D,multiset(C),G),B2))) ) ) ) ).

% subset_mset.cSUP_mono
tff(fact_5321_subset__mset_OLeast__def,axiom,
    ! [B: $tType,Pa: fun(multiset(B),$o)] : ( aa(fun(multiset(B),$o),multiset(B),least(multiset(B),subseteq_mset(B)),Pa) = the(multiset(B),aTP_Lamp_ato(fun(multiset(B),$o),fun(multiset(B),$o),Pa)) ) ).

% subset_mset.Least_def
tff(fact_5322_subset__mset_OcSup__subset__mono,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( ( A3 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),B2)
       => ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),A3),B2)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A3)),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),B2)) ) ) ) ).

% subset_mset.cSup_subset_mono
tff(fact_5323_subset__mset_Ofinite__has__maximal,axiom,
    ! [B: $tType,A3: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ? [X: multiset(B)] :
            ( aa(set(multiset(B)),$o,member(multiset(B),X),A3)
            & ! [Xa3: multiset(B)] :
                ( aa(set(multiset(B)),$o,member(multiset(B),Xa3),A3)
               => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X),Xa3)
                 => ( X = Xa3 ) ) ) ) ) ) ).

% subset_mset.finite_has_maximal
tff(fact_5324_subset__mset_Ofinite__has__minimal,axiom,
    ! [B: $tType,A3: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ? [X: multiset(B)] :
            ( aa(set(multiset(B)),$o,member(multiset(B),X),A3)
            & ! [Xa3: multiset(B)] :
                ( aa(set(multiset(B)),$o,member(multiset(B),Xa3),A3)
               => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Xa3),X)
                 => ( X = Xa3 ) ) ) ) ) ) ).

% subset_mset.finite_has_minimal
tff(fact_5325_subset__mset_OcSup__le__iff,axiom,
    ! [B: $tType,S: set(multiset(B)),A4: multiset(B)] :
      ( ( S != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),S)
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),S)),A4)
        <=> ! [X3: multiset(B)] :
              ( aa(set(multiset(B)),$o,member(multiset(B),X3),S)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X3),A4) ) ) ) ) ).

% subset_mset.cSup_le_iff
tff(fact_5326_subset__mset_OcSup__mono,axiom,
    ! [B: $tType,B2: set(multiset(B)),A3: set(multiset(B))] :
      ( ( B2 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3)
       => ( ! [B4: multiset(B)] :
              ( aa(set(multiset(B)),$o,member(multiset(B),B4),B2)
             => ? [X4: multiset(B)] :
                  ( aa(set(multiset(B)),$o,member(multiset(B),X4),A3)
                  & aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),B4),X4) ) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),B2)),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A3)) ) ) ) ).

% subset_mset.cSup_mono
tff(fact_5327_subset__mset_OcSup__cInf,axiom,
    ! [B: $tType,S: set(multiset(B))] :
      ( ( S != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),S)
       => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),S) = aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aTP_Lamp_atp(set(multiset(B)),fun(multiset(B),$o),S))) ) ) ) ).

% subset_mset.cSup_cInf
tff(fact_5328_subset__mset_Obdd__above__Int1,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3)
     => condit8047198070973881523_above(multiset(B),subseteq_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A3),B2)) ) ).

% subset_mset.bdd_above_Int1
tff(fact_5329_subset__mset_Obdd__above__Int2,axiom,
    ! [B: $tType,B2: set(multiset(B)),A3: set(multiset(B))] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),B2)
     => condit8047198070973881523_above(multiset(B),subseteq_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A3),B2)) ) ).

% subset_mset.bdd_above_Int2
tff(fact_5330_comm__monoid__set_Onon__neutral_H,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(C,B),I: set(C)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),G),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aa(fun(C,B),fun(set(C),fun(C,$o)),aTP_Lamp_atn(B,fun(fun(C,B),fun(set(C),fun(C,$o))),Z2),G),I))) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),G),I) ) ) ).

% comm_monoid_set.non_neutral'
tff(fact_5331_subset__mset_OcSUP__subset__mono,axiom,
    ! [C: $tType,B: $tType,A3: set(B),G: fun(B,multiset(C)),B2: set(B),F2: fun(B,multiset(C))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),G),B2))
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),F2,X)),aa(B,multiset(C),G,X)) )
           => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),G),B2))) ) ) ) ) ).

% subset_mset.cSUP_subset_mono
tff(fact_5332_subset__mset_OcInf__eq__non__empty,axiom,
    ! [B: $tType,X5: set(multiset(B)),A4: multiset(B)] :
      ( ( X5 != bot_bot(set(multiset(B))) )
     => ( ! [X: multiset(B)] :
            ( aa(set(multiset(B)),$o,member(multiset(B),X),X5)
           => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A4),X) )
       => ( ! [Y2: multiset(B)] :
              ( ! [X4: multiset(B)] :
                  ( aa(set(multiset(B)),$o,member(multiset(B),X4),X5)
                 => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Y2),X4) )
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Y2),A4) )
         => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X5) = A4 ) ) ) ) ).

% subset_mset.cInf_eq_non_empty
tff(fact_5333_subset__mset_OcInf__greatest,axiom,
    ! [B: $tType,X5: set(multiset(B)),Z2: multiset(B)] :
      ( ( X5 != bot_bot(set(multiset(B))) )
     => ( ! [X: multiset(B)] :
            ( aa(set(multiset(B)),$o,member(multiset(B),X),X5)
           => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Z2),X) )
       => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Z2),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X5)) ) ) ).

% subset_mset.cInf_greatest
tff(fact_5334_subset__mset_OcSup__eq__non__empty,axiom,
    ! [B: $tType,X5: set(multiset(B)),A4: multiset(B)] :
      ( ( X5 != bot_bot(set(multiset(B))) )
     => ( ! [X: multiset(B)] :
            ( aa(set(multiset(B)),$o,member(multiset(B),X),X5)
           => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X),A4) )
       => ( ! [Y2: multiset(B)] :
              ( ! [X4: multiset(B)] :
                  ( aa(set(multiset(B)),$o,member(multiset(B),X4),X5)
                 => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X4),Y2) )
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A4),Y2) )
         => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),X5) = A4 ) ) ) ) ).

% subset_mset.cSup_eq_non_empty
tff(fact_5335_subset__mset_OcSup__least,axiom,
    ! [B: $tType,X5: set(multiset(B)),Z2: multiset(B)] :
      ( ( X5 != bot_bot(set(multiset(B))) )
     => ( ! [X: multiset(B)] :
            ( aa(set(multiset(B)),$o,member(multiset(B),X),X5)
           => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X),Z2) )
       => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),X5)),Z2) ) ) ).

% subset_mset.cSup_least
tff(fact_5336_irreflp__greater,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => irreflp(B,aTP_Lamp_aaa(B,fun(B,$o))) ) ).

% irreflp_greater
tff(fact_5337_set__mset__Sup,axiom,
    ! [B: $tType,A3: set(multiset(B))] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3)
     => ( aa(multiset(B),set(B),set_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A3)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(multiset(B)),set(set(B)),image2(multiset(B),set(B),set_mset(B)),A3)) ) ) ).

% set_mset_Sup
tff(fact_5338_comm__monoid__set_Oempty_H,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(B,B)),Z2: B,P3: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),P3),bot_bot(set(C))) = Z2 ) ) ).

% comm_monoid_set.empty'
tff(fact_5339_comm__monoid__set_Odistrib__triv_H,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,I: set(C),G: fun(C,B),H2: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),I)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_asa(fun(B,fun(B,B)),fun(fun(C,B),fun(fun(C,B),fun(C,B))),F2),G),H2)),I) = aa(B,B,aa(B,fun(B,B),F2,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),G),I)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),H2),I)) ) ) ) ).

% comm_monoid_set.distrib_triv'
tff(fact_5340_comm__monoid__set_Odistrib_H,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,I: set(C),G: fun(C,B),H2: fun(C,B)] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(fun(C,B),fun(C,$o),aa(set(C),fun(fun(C,B),fun(C,$o)),aTP_Lamp_asb(B,fun(set(C),fun(fun(C,B),fun(C,$o))),Z2),I),G)))
       => ( aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(fun(C,B),fun(C,$o),aa(set(C),fun(fun(C,B),fun(C,$o)),aTP_Lamp_asb(B,fun(set(C),fun(fun(C,B),fun(C,$o))),Z2),I),H2)))
         => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_asa(fun(B,fun(B,B)),fun(fun(C,B),fun(fun(C,B),fun(C,B))),F2),G),H2)),I) = aa(B,B,aa(B,fun(B,B),F2,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),G),I)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),H2),I)) ) ) ) ) ).

% comm_monoid_set.distrib'
tff(fact_5341_count__Sup__multiset__nonempty,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: B] :
      ( ( A3 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3)
       => ( aa(B,nat,aa(multiset(B),fun(B,nat),count(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A3)),X2) = aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(B)),set(nat),image2(multiset(B),nat,aTP_Lamp_apd(B,fun(multiset(B),nat),X2)),A3)) ) ) ) ).

% count_Sup_multiset_nonempty
tff(fact_5342_subset__mset_OcINF__greatest,axiom,
    ! [C: $tType,B: $tType,A3: set(B),M2: multiset(C),F2: fun(B,multiset(C))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),A3)
           => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),M2),aa(B,multiset(C),F2,X)) )
       => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),M2),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))) ) ) ).

% subset_mset.cINF_greatest
tff(fact_5343_subset__mset_OcSUP__least,axiom,
    ! [B: $tType,C: $tType,A3: set(B),F2: fun(B,multiset(C)),M: multiset(C)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( ! [X: B] :
            ( aa(set(B),$o,member(B,X),A3)
           => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),F2,X)),M) )
       => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))),M) ) ) ).

% subset_mset.cSUP_least
tff(fact_5344_prod_H__def,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ( groups1962203154675924110t_prod(B,C) = groups_comm_monoid_G(C,B,times_times(C),one_one(C)) ) ) ).

% prod'_def
tff(fact_5345_bdd__above__multiset__imp__finite__support,axiom,
    ! [B: $tType,A3: set(multiset(B))] :
      ( ( A3 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3)
       => aa(set(B),$o,finite_finite2(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(multiset(B)),set(set(B)),image2(multiset(B),set(B),aTP_Lamp_atq(multiset(B),set(B))),A3))) ) ) ).

% bdd_above_multiset_imp_finite_support
tff(fact_5346_Sup__multiset__in__multiset,axiom,
    ! [B: $tType,A3: set(multiset(B))] :
      ( ( A3 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3)
       => aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_atr(set(multiset(B)),fun(B,$o),A3))) ) ) ).

% Sup_multiset_in_multiset
tff(fact_5347_comm__monoid__set_Oinsert_H,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,I: set(C),P3: fun(C,B),I2: C] :
      ( groups778175481326437816id_set(B,F2,Z2)
     => ( aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aa(fun(C,B),fun(C,$o),aa(set(C),fun(fun(C,B),fun(C,$o)),aTP_Lamp_asb(B,fun(set(C),fun(fun(C,B),fun(C,$o))),Z2),I),P3)))
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),P3),aa(set(C),set(C),insert(C,I2),I))
          = $ite(aa(set(C),$o,member(C,I2),I),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),P3),I),aa(B,B,aa(B,fun(B,B),F2,aa(C,B,P3,I2)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,F2,Z2),P3),I))) ) ) ) ).

% comm_monoid_set.insert'
tff(fact_5348_subset__mset_Omono__cSUP,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [F2: fun(multiset(B),C),A3: fun(D,multiset(B)),I: set(D)] :
          ( aa(fun(multiset(B),C),$o,mono(multiset(B),C,subseteq_mset(B)),F2)
         => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),aa(set(D),set(multiset(B)),image2(D,multiset(B),A3),I))
           => ( ( I != bot_bot(set(D)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(D),set(C),image2(D,C,aa(fun(D,multiset(B)),fun(D,C),aTP_Lamp_ats(fun(multiset(B),C),fun(fun(D,multiset(B)),fun(D,C)),F2),A3)),I))),aa(multiset(B),C,F2,aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(D),set(multiset(B)),image2(D,multiset(B),A3),I)))) ) ) ) ) ).

% subset_mset.mono_cSUP
tff(fact_5349_subset__mset_Omono__cSup,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [F2: fun(multiset(B),C),A3: set(multiset(B))] :
          ( aa(fun(multiset(B),C),$o,mono(multiset(B),C,subseteq_mset(B)),F2)
         => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3)
           => ( ( A3 != bot_bot(set(multiset(B))) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(multiset(B)),set(C),image2(multiset(B),C,F2),A3))),aa(multiset(B),C,F2,aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A3))) ) ) ) ) ).

% subset_mset.mono_cSup
tff(fact_5350_subset__mset_Osum__nonneg__leq__bound,axiom,
    ! [B: $tType,C: $tType,S2: set(B),F2: fun(B,multiset(C)),B2: multiset(C),I2: B] :
      ( aa(set(B),$o,finite_finite2(B),S2)
     => ( ! [I3: B] :
            ( aa(set(B),$o,member(B,I3),S2)
           => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),zero_zero(multiset(C))),aa(B,multiset(C),F2,I3)) )
       => ( ( groups3894954378712506084id_sum(multiset(C),B,plus_plus(multiset(C)),zero_zero(multiset(C)),F2,S2) = B2 )
         => ( aa(set(B),$o,member(B,I2),S2)
           => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),F2,I2)),B2) ) ) ) ) ).

% subset_mset.sum_nonneg_leq_bound
tff(fact_5351_order_Omono_Ocong,axiom,
    ! [C: $tType,B: $tType] :
      ( order(C)
     => ! [Less_eq: fun(B,fun(B,$o))] : ( mono(B,C,Less_eq) = mono(B,C,Less_eq) ) ) ).

% order.mono.cong
tff(fact_5352_subset__mset_Osum__mono,axiom,
    ! [C: $tType,B: $tType,K4: set(B),F2: fun(B,multiset(C)),G: fun(B,multiset(C))] :
      ( ! [I3: B] :
          ( aa(set(B),$o,member(B,I3),K4)
         => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),F2,I3)),aa(B,multiset(C),G,I3)) )
     => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),groups3894954378712506084id_sum(multiset(C),B,plus_plus(multiset(C)),zero_zero(multiset(C)),F2,K4)),groups3894954378712506084id_sum(multiset(C),B,plus_plus(multiset(C)),zero_zero(multiset(C)),G,K4)) ) ).

% subset_mset.sum_mono
tff(fact_5353_subset__mset_Osum__nonneg__0,axiom,
    ! [B: $tType,C: $tType,S2: set(B),F2: fun(B,multiset(C)),I2: B] :
      ( aa(set(B),$o,finite_finite2(B),S2)
     => ( ! [I3: B] :
            ( aa(set(B),$o,member(B,I3),S2)
           => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),zero_zero(multiset(C))),aa(B,multiset(C),F2,I3)) )
       => ( ( groups3894954378712506084id_sum(multiset(C),B,plus_plus(multiset(C)),zero_zero(multiset(C)),F2,S2) = zero_zero(multiset(C)) )
         => ( aa(set(B),$o,member(B,I2),S2)
           => ( aa(B,multiset(C),F2,I2) = zero_zero(multiset(C)) ) ) ) ) ) ).

% subset_mset.sum_nonneg_0
tff(fact_5354_subset__mset_OGreatest__def,axiom,
    ! [B: $tType,Pa: fun(multiset(B),$o)] : ( aa(fun(multiset(B),$o),multiset(B),greatest(multiset(B),subseteq_mset(B)),Pa) = the(multiset(B),aTP_Lamp_att(fun(multiset(B),$o),fun(multiset(B),$o),Pa)) ) ).

% subset_mset.Greatest_def
tff(fact_5355_subset__mset_Omono__cINF,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [F2: fun(multiset(B),C),A3: fun(D,multiset(B)),I: set(D)] :
          ( aa(fun(multiset(B),C),$o,mono(multiset(B),C,subseteq_mset(B)),F2)
         => ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),aa(set(D),set(multiset(B)),image2(D,multiset(B),A3),I))
           => ( ( I != bot_bot(set(D)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(multiset(B),C,F2,aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(D),set(multiset(B)),image2(D,multiset(B),A3),I)))),aa(set(C),C,complete_Inf_Inf(C),aa(set(D),set(C),image2(D,C,aa(fun(D,multiset(B)),fun(D,C),aTP_Lamp_ats(fun(multiset(B),C),fun(fun(D,multiset(B)),fun(D,C)),F2),A3)),I))) ) ) ) ) ).

% subset_mset.mono_cINF
tff(fact_5356_subset__mset_Omono__cInf,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [F2: fun(multiset(B),C),A3: set(multiset(B))] :
          ( aa(fun(multiset(B),C),$o,mono(multiset(B),C,subseteq_mset(B)),F2)
         => ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),A3)
           => ( ( A3 != bot_bot(set(multiset(B))) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(multiset(B),C,F2,aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A3))),aa(set(C),C,complete_Inf_Inf(C),aa(set(multiset(B)),set(C),image2(multiset(B),C,F2),A3))) ) ) ) ) ).

% subset_mset.mono_cInf
tff(fact_5357_subset__mset_Obdd__below__empty,axiom,
    ! [B: $tType] : aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),bot_bot(set(multiset(B)))) ).

% subset_mset.bdd_below_empty
tff(fact_5358_subset__mset_Obdd__below__UN,axiom,
    ! [C: $tType,B: $tType,I: set(B),A3: fun(B,set(multiset(C)))] :
      ( aa(set(B),$o,finite_finite2(B),I)
     => ( aa(set(multiset(C)),$o,condit8119078960628432327_below(multiset(C),subseteq_mset(C)),aa(set(set(multiset(C))),set(multiset(C)),complete_Sup_Sup(set(multiset(C))),aa(set(B),set(set(multiset(C))),image2(B,set(multiset(C)),A3),I)))
      <=> ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),I)
           => aa(set(multiset(C)),$o,condit8119078960628432327_below(multiset(C),subseteq_mset(C)),aa(B,set(multiset(C)),A3,X3)) ) ) ) ).

% subset_mset.bdd_below_UN
tff(fact_5359_order_OGreatest_Ocong,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o))] : ( greatest(B,Less_eq) = greatest(B,Less_eq) ) ).

% order.Greatest.cong
tff(fact_5360_subset__mset_Obdd__below__Int2,axiom,
    ! [B: $tType,B2: set(multiset(B)),A3: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),B2)
     => aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A3),B2)) ) ).

% subset_mset.bdd_below_Int2
tff(fact_5361_subset__mset_Obdd__below__Int1,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),A3)
     => aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A3),B2)) ) ).

% subset_mset.bdd_below_Int1
tff(fact_5362_subset__mset_Ole__cInf__iff,axiom,
    ! [B: $tType,S: set(multiset(B)),A4: multiset(B)] :
      ( ( S != bot_bot(set(multiset(B))) )
     => ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),S)
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A4),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),S))
        <=> ! [X3: multiset(B)] :
              ( aa(set(multiset(B)),$o,member(multiset(B),X3),S)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A4),X3) ) ) ) ) ).

% subset_mset.le_cInf_iff
tff(fact_5363_subset__mset_OcInf__mono,axiom,
    ! [B: $tType,B2: set(multiset(B)),A3: set(multiset(B))] :
      ( ( B2 != bot_bot(set(multiset(B))) )
     => ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),A3)
       => ( ! [B4: multiset(B)] :
              ( aa(set(multiset(B)),$o,member(multiset(B),B4),B2)
             => ? [X4: multiset(B)] :
                  ( aa(set(multiset(B)),$o,member(multiset(B),X4),A3)
                  & aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X4),B4) ) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A3)),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),B2)) ) ) ) ).

% subset_mset.cInf_mono
tff(fact_5364_subset__mset_OcINF__mono,axiom,
    ! [D: $tType,C: $tType,B: $tType,B2: set(B),F2: fun(D,multiset(C)),A3: set(D),G: fun(B,multiset(C))] :
      ( ( B2 != bot_bot(set(B)) )
     => ( aa(set(multiset(C)),$o,condit8119078960628432327_below(multiset(C),subseteq_mset(C)),aa(set(D),set(multiset(C)),image2(D,multiset(C),F2),A3))
       => ( ! [M3: B] :
              ( aa(set(B),$o,member(B,M3),B2)
             => ? [X4: D] :
                  ( aa(set(D),$o,member(D,X4),A3)
                  & aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(D,multiset(C),F2,X4)),aa(B,multiset(C),G,M3)) ) )
         => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(D),set(multiset(C)),image2(D,multiset(C),F2),A3))),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),G),B2))) ) ) ) ).

% subset_mset.cINF_mono
tff(fact_5365_subset__mset_Ole__cINF__iff,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(C)),U: multiset(C)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( aa(set(multiset(C)),$o,condit8119078960628432327_below(multiset(C),subseteq_mset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))
       => ( aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),U),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3)))
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),U),aa(B,multiset(C),F2,X3)) ) ) ) ) ).

% subset_mset.le_cINF_iff
tff(fact_5366_subset__mset_OcInf__superset__mono,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( ( A3 != bot_bot(set(multiset(B))) )
     => ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),B2)
       => ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),A3),B2)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),B2)),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A3)) ) ) ) ).

% subset_mset.cInf_superset_mono
tff(fact_5367_subset__mset_OcINF__superset__mono,axiom,
    ! [C: $tType,B: $tType,A3: set(B),G: fun(B,multiset(C)),B2: set(B),F2: fun(B,multiset(C))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( aa(set(multiset(C)),$o,condit8119078960628432327_below(multiset(C),subseteq_mset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),G),B2))
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B2)
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),B2)
               => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),G,X)),aa(B,multiset(C),F2,X)) )
           => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),G),B2))),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))) ) ) ) ) ).

% subset_mset.cINF_superset_mono
tff(fact_5368_subset__mset_OcInf__le__cSup,axiom,
    ! [B: $tType,A3: set(multiset(B))] :
      ( ( A3 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3)
       => ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),A3)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A3)),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A3)) ) ) ) ).

% subset_mset.cInf_le_cSup
tff(fact_5369_subset__mset_OcInf__cSup,axiom,
    ! [B: $tType,S: set(multiset(B))] :
      ( ( S != bot_bot(set(multiset(B))) )
     => ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),S)
       => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),S) = aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aTP_Lamp_atu(set(multiset(B)),fun(multiset(B),$o),S))) ) ) ) ).

% subset_mset.cInf_cSup
tff(fact_5370_subset__mset_OcINF__union,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(C)),B2: set(B)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( aa(set(multiset(C)),$o,condit8119078960628432327_below(multiset(C),subseteq_mset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))
       => ( ( B2 != bot_bot(set(B)) )
         => ( aa(set(multiset(C)),$o,condit8119078960628432327_below(multiset(C),subseteq_mset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),B2))
           => ( aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),inter_mset(C),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),B2))) ) ) ) ) ) ).

% subset_mset.cINF_union
tff(fact_5371_subset__mset_OcINF__insert,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(C)),A4: B] :
      ( ( A3 != bot_bot(set(B)) )
     => ( aa(set(multiset(C)),$o,condit8119078960628432327_below(multiset(C),subseteq_mset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))
       => ( aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),aa(set(B),set(B),insert(B,A4),A3))) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),inter_mset(C),aa(B,multiset(C),F2,A4)),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))) ) ) ) ).

% subset_mset.cINF_insert
tff(fact_5372_subset__mset_OcSUP__union,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(C)),B2: set(B)] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))
       => ( ( B2 != bot_bot(set(B)) )
         => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),B2))
           => ( aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B2))) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),union_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),B2))) ) ) ) ) ) ).

% subset_mset.cSUP_union
tff(fact_5373_set__mset__inter,axiom,
    ! [B: $tType,A3: multiset(B),B2: multiset(B)] : ( aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(multiset(B),set(B),set_mset(B),A3)),aa(multiset(B),set(B),set_mset(B),B2)) ) ).

% set_mset_inter
tff(fact_5374_subset__mset_Obdd__above__image__sup,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,multiset(B)),G: fun(C,multiset(B)),A3: set(C)] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),aa(set(C),set(multiset(B)),image2(C,multiset(B),aa(fun(C,multiset(B)),fun(C,multiset(B)),aTP_Lamp_atv(fun(C,multiset(B)),fun(fun(C,multiset(B)),fun(C,multiset(B))),F2),G)),A3))
    <=> ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),aa(set(C),set(multiset(B)),image2(C,multiset(B),F2),A3))
        & condit8047198070973881523_above(multiset(B),subseteq_mset(B),aa(set(C),set(multiset(B)),image2(C,multiset(B),G),A3)) ) ) ).

% subset_mset.bdd_above_image_sup
tff(fact_5375_subset__mset_Obdd__below__image__inf,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,multiset(B)),G: fun(C,multiset(B)),A3: set(C)] :
      ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),aa(set(C),set(multiset(B)),image2(C,multiset(B),aa(fun(C,multiset(B)),fun(C,multiset(B)),aTP_Lamp_atw(fun(C,multiset(B)),fun(fun(C,multiset(B)),fun(C,multiset(B))),F2),G)),A3))
    <=> ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),aa(set(C),set(multiset(B)),image2(C,multiset(B),F2),A3))
        & aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),aa(set(C),set(multiset(B)),image2(C,multiset(B),G),A3)) ) ) ).

% subset_mset.bdd_below_image_inf
tff(fact_5376_prod__mset_Ounion__disjoint,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: multiset(B),B2: multiset(B),G: fun(B,C)] :
          ( ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A3),B2) = zero_zero(multiset(B)) )
         => ( aa(multiset(C),C,comm_m9189036328036947845d_mset(C),aa(multiset(B),multiset(C),image_mset(B,C,G),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),A3),B2))) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(multiset(C),C,comm_m9189036328036947845d_mset(C),aa(multiset(B),multiset(C),image_mset(B,C,G),A3))),aa(multiset(C),C,comm_m9189036328036947845d_mset(C),aa(multiset(B),multiset(C),image_mset(B,C,G),B2))) ) ) ) ).

% prod_mset.union_disjoint
tff(fact_5377_subset__mset_Omono__inf,axiom,
    ! [C: $tType,B: $tType] :
      ( semilattice_inf(C)
     => ! [F2: fun(multiset(B),C),A3: multiset(B),B2: multiset(B)] :
          ( aa(fun(multiset(B),C),$o,mono(multiset(B),C,subseteq_mset(B)),F2)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(multiset(B),C,F2,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A3),B2))),aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(multiset(B),C,F2,A3)),aa(multiset(B),C,F2,B2))) ) ) ).

% subset_mset.mono_inf
tff(fact_5378_subset__mset_OcSup__union__distrib,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( ( A3 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3)
       => ( ( B2 != bot_bot(set(multiset(B))) )
         => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),B2)
           => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),sup_sup(set(multiset(B))),A3),B2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A3)),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),B2)) ) ) ) ) ) ).

% subset_mset.cSup_union_distrib
tff(fact_5379_subset__mset_OcInf__union__distrib,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( ( A3 != bot_bot(set(multiset(B))) )
     => ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),A3)
       => ( ( B2 != bot_bot(set(multiset(B))) )
         => ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),B2)
           => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),sup_sup(set(multiset(B))),A3),B2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A3)),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),B2)) ) ) ) ) ) ).

% subset_mset.cInf_union_distrib
tff(fact_5380_subset__mset_OcSup__insert__If,axiom,
    ! [B: $tType,X5: set(multiset(B)),A4: multiset(B)] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),X5)
     => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),A4),X5))
        = $ite(X5 = bot_bot(set(multiset(B))),A4,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),A4),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),X5))) ) ) ).

% subset_mset.cSup_insert_If
tff(fact_5381_subset__mset_OcSup__insert,axiom,
    ! [B: $tType,X5: set(multiset(B)),A4: multiset(B)] :
      ( ( X5 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),X5)
       => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),A4),X5)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),A4),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),X5)) ) ) ) ).

% subset_mset.cSup_insert
tff(fact_5382_subset__mset_OcInf__insert,axiom,
    ! [B: $tType,X5: set(multiset(B)),A4: multiset(B)] :
      ( ( X5 != bot_bot(set(multiset(B))) )
     => ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),X5)
       => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),A4),X5)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A4),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X5)) ) ) ) ).

% subset_mset.cInf_insert
tff(fact_5383_subset__mset_OcInf__insert__If,axiom,
    ! [B: $tType,X5: set(multiset(B)),A4: multiset(B)] :
      ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),X5)
     => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),A4),X5))
        = $ite(X5 = bot_bot(set(multiset(B))),A4,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A4),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X5))) ) ) ).

% subset_mset.cInf_insert_If
tff(fact_5384_subset__mset_OcSup__inter__less__eq,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A3)
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),B2)
       => ( ( aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A3),B2) != bot_bot(set(multiset(B))) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A3),B2))),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A3)),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),B2))) ) ) ) ).

% subset_mset.cSup_inter_less_eq
tff(fact_5385_subset__mset_Oless__eq__cInf__inter,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),A3)
     => ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),B2)
       => ( ( aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A3),B2) != bot_bot(set(multiset(B))) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A3)),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),B2))),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A3),B2))) ) ) ) ).

% subset_mset.less_eq_cInf_inter
tff(fact_5386_subset__mset_OSUP__sup__distrib,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(C)),G: fun(B,multiset(C))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))
       => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),G),A3))
         => ( aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),union_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),G),A3))) = aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),aa(fun(B,multiset(C)),fun(B,multiset(C)),aTP_Lamp_atx(fun(B,multiset(C)),fun(fun(B,multiset(C)),fun(B,multiset(C))),F2),G)),A3)) ) ) ) ) ).

% subset_mset.SUP_sup_distrib
tff(fact_5387_subset__mset_OcINF__inf__distrib,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(C)),G: fun(B,multiset(C))] :
      ( ( A3 != bot_bot(set(B)) )
     => ( aa(set(multiset(C)),$o,condit8119078960628432327_below(multiset(C),subseteq_mset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))
       => ( aa(set(multiset(C)),$o,condit8119078960628432327_below(multiset(C),subseteq_mset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),G),A3))
         => ( aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),inter_mset(C),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),G),A3))) = aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),aa(fun(B,multiset(C)),fun(B,multiset(C)),aTP_Lamp_aty(fun(B,multiset(C)),fun(fun(B,multiset(C)),fun(B,multiset(C))),F2),G)),A3)) ) ) ) ) ).

% subset_mset.cINF_inf_distrib
tff(fact_5388_subset__mset_OcSUP__insert,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(C)),A4: B] :
      ( ( A3 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))
       => ( aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),aa(set(B),set(B),insert(B,A4),A3))) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),union_mset(C),aa(B,multiset(C),F2,A4)),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),F2),A3))) ) ) ) ).

% subset_mset.cSUP_insert
tff(fact_5389_multp__code__def,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o)),N3: multiset(B),M: multiset(B)] :
      ( multp_code(B,Pa,N3,M)
    <=> $let(
          z: multiset(B),
          z := aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),M),N3),
          $let(
            x: multiset(B),
            x := aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),M),z),
            ( ( x != zero_zero(multiset(B)) )
            & ! [X3: B] :
                ( aa(set(B),$o,member(B,X3),aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),N3),z)))
               => ? [Y4: B] :
                    ( aa(set(B),$o,member(B,Y4),aa(multiset(B),set(B),set_mset(B),x))
                    & aa(B,$o,aa(B,fun(B,$o),Pa,X3),Y4) ) ) ) ) ) ) ).

% multp_code_def
tff(fact_5390_multeqp__code__def,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o)),N3: multiset(B),M: multiset(B)] :
      ( multeqp_code(B,Pa,N3,M)
    <=> $let(
          z: multiset(B),
          z := aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),M),N3),
          ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),N3),z)))
           => ? [Y4: B] :
                ( aa(set(B),$o,member(B,Y4),aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),M),z)))
                & aa(B,$o,aa(B,fun(B,$o),Pa,X3),Y4) ) ) ) ) ).

% multeqp_code_def
tff(fact_5391_subset__mset_Oinf__Sup1__distrib,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X2),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)) = lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_atz(set(multiset(B)),fun(multiset(B),fun(multiset(B),$o)),A3),X2))) ) ) ) ).

% subset_mset.inf_Sup1_distrib
tff(fact_5392_subset__mset_OSup__fin_Osingleton,axiom,
    ! [B: $tType,X2: multiset(B)] : ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B))))) = X2 ) ).

% subset_mset.Sup_fin.singleton
tff(fact_5393_subset__mset_OSup__fin_Oinsert,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),A3)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X2),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)) ) ) ) ).

% subset_mset.Sup_fin.insert
tff(fact_5394_subset__mset_OSup__fin_Oeq__fold_H,axiom,
    ! [B: $tType,A3: set(multiset(B))] : ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3) = aa(option(multiset(B)),multiset(B),the2(multiset(B)),finite_fold(multiset(B),option(multiset(B)),aTP_Lamp_aua(multiset(B),fun(option(multiset(B)),option(multiset(B)))),none(multiset(B)),A3)) ) ).

% subset_mset.Sup_fin.eq_fold'
tff(fact_5395_subset__mset_OSup__fin_Ounion,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),B2)
         => ( ( B2 != bot_bot(set(multiset(B))) )
           => ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),sup_sup(set(multiset(B))),A3),B2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)),lattic4630905495605216202up_fin(multiset(B),union_mset(B),B2)) ) ) ) ) ) ).

% subset_mset.Sup_fin.union
tff(fact_5396_subset__mset_OSup__fin_Ohom__commute,axiom,
    ! [B: $tType,H2: fun(multiset(B),multiset(B)),N3: set(multiset(B))] :
      ( ! [X: multiset(B),Y2: multiset(B)] : ( aa(multiset(B),multiset(B),H2,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X),Y2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),aa(multiset(B),multiset(B),H2,X)),aa(multiset(B),multiset(B),H2,Y2)) )
     => ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),N3)
       => ( ( N3 != bot_bot(set(multiset(B))) )
         => ( aa(multiset(B),multiset(B),H2,lattic4630905495605216202up_fin(multiset(B),union_mset(B),N3)) = lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),image2(multiset(B),multiset(B),H2),N3)) ) ) ) ) ).

% subset_mset.Sup_fin.hom_commute
tff(fact_5397_subset__mset_OSup__fin_Obounded__iff,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)),X2)
        <=> ! [X3: multiset(B)] :
              ( aa(set(multiset(B)),$o,member(multiset(B),X3),A3)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X3),X2) ) ) ) ) ).

% subset_mset.Sup_fin.bounded_iff
tff(fact_5398_subset__mset_OSup__fin_OboundedI,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( ! [A5: multiset(B)] :
              ( aa(set(multiset(B)),$o,member(multiset(B),A5),A3)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A5),X2) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)),X2) ) ) ) ).

% subset_mset.Sup_fin.boundedI
tff(fact_5399_subset__mset_OSup__fin_OboundedE,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)),X2)
         => ! [A14: multiset(B)] :
              ( aa(set(multiset(B)),$o,member(multiset(B),A14),A3)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A14),X2) ) ) ) ) ).

% subset_mset.Sup_fin.boundedE
tff(fact_5400_subset__mset_OcSup__eq__Sup__fin,axiom,
    ! [B: $tType,X5: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),X5)
     => ( ( X5 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),X5) = lattic4630905495605216202up_fin(multiset(B),union_mset(B),X5) ) ) ) ).

% subset_mset.cSup_eq_Sup_fin
tff(fact_5401_subset__mset_OSup__fin_Oinsert__not__elem,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ~ aa(set(multiset(B)),$o,member(multiset(B),X2),A3)
       => ( ( A3 != bot_bot(set(multiset(B))) )
         => ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),A3)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X2),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)) ) ) ) ) ).

% subset_mset.Sup_fin.insert_not_elem
tff(fact_5402_subset__mset_OSup__fin_Oclosed,axiom,
    ! [B: $tType,A3: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( ! [X: multiset(B),Y2: multiset(B)] : aa(set(multiset(B)),$o,member(multiset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X),Y2)),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),Y2),bot_bot(set(multiset(B))))))
         => aa(set(multiset(B)),$o,member(multiset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)),A3) ) ) ) ).

% subset_mset.Sup_fin.closed
tff(fact_5403_subset__mset_OSup__fin_Oinsert__remove,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),A3))
        = $ite(aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A3),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B))))) = bot_bot(set(multiset(B))),X2,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X2),lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A3),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B)))))))) ) ) ).

% subset_mset.Sup_fin.insert_remove
tff(fact_5404_subset__mset_OSup__fin_Oremove,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( aa(set(multiset(B)),$o,member(multiset(B),X2),A3)
       => ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)
          = $ite(aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A3),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B))))) = bot_bot(set(multiset(B))),X2,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X2),lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A3),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B)))))))) ) ) ) ).

% subset_mset.Sup_fin.remove
tff(fact_5405_subset__mset_OSup__fin_Osubset,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( B2 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),B2),A3)
         => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),B2)),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)) = lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3) ) ) ) ) ).

% subset_mset.Sup_fin.subset
tff(fact_5406_subset__mset_OSup__fin_Osubset__imp,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),A3),B2)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),B2)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)),lattic4630905495605216202up_fin(multiset(B),union_mset(B),B2)) ) ) ) ).

% subset_mset.Sup_fin.subset_imp
tff(fact_5407_subset__mset_Oinf__Sup2__distrib,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),B2)
         => ( ( B2 != bot_bot(set(multiset(B))) )
           => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)),lattic4630905495605216202up_fin(multiset(B),union_mset(B),B2)) = lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(set(multiset(B)),fun(multiset(B),$o),aTP_Lamp_aub(set(multiset(B)),fun(set(multiset(B)),fun(multiset(B),$o)),A3),B2))) ) ) ) ) ) ).

% subset_mset.inf_Sup2_distrib
tff(fact_5408_subset__mset_OInf__fin__le__Sup__fin,axiom,
    ! [B: $tType,A3: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3)),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A3)) ) ) ).

% subset_mset.Inf_fin_le_Sup_fin
tff(fact_5409_subset__mset_Osup__Inf2__distrib,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),B2)
         => ( ( B2 != bot_bot(set(multiset(B))) )
           => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3)),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),B2)) = lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(set(multiset(B)),fun(multiset(B),$o),aTP_Lamp_auc(set(multiset(B)),fun(set(multiset(B)),fun(multiset(B),$o)),A3),B2))) ) ) ) ) ) ).

% subset_mset.sup_Inf2_distrib
tff(fact_5410_subset__mset_Osup__Inf1__distrib,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X2),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3)) = lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_aud(set(multiset(B)),fun(multiset(B),fun(multiset(B),$o)),A3),X2))) ) ) ) ).

% subset_mset.sup_Inf1_distrib
tff(fact_5411_subset__mset_OInf__fin_Osingleton,axiom,
    ! [B: $tType,X2: multiset(B)] : ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B))))) = X2 ) ).

% subset_mset.Inf_fin.singleton
tff(fact_5412_subset__mset_OInf__fin_Oinsert,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),A3)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X2),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3)) ) ) ) ).

% subset_mset.Inf_fin.insert
tff(fact_5413_subset__mset_OInf__fin_Oeq__fold_H,axiom,
    ! [B: $tType,A3: set(multiset(B))] : ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3) = aa(option(multiset(B)),multiset(B),the2(multiset(B)),finite_fold(multiset(B),option(multiset(B)),aTP_Lamp_aue(multiset(B),fun(option(multiset(B)),option(multiset(B)))),none(multiset(B)),A3)) ) ).

% subset_mset.Inf_fin.eq_fold'
tff(fact_5414_subset__mset_OInf__fin_Ohom__commute,axiom,
    ! [B: $tType,H2: fun(multiset(B),multiset(B)),N3: set(multiset(B))] :
      ( ! [X: multiset(B),Y2: multiset(B)] : ( aa(multiset(B),multiset(B),H2,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X),Y2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),aa(multiset(B),multiset(B),H2,X)),aa(multiset(B),multiset(B),H2,Y2)) )
     => ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),N3)
       => ( ( N3 != bot_bot(set(multiset(B))) )
         => ( aa(multiset(B),multiset(B),H2,lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),N3)) = lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),image2(multiset(B),multiset(B),H2),N3)) ) ) ) ) ).

% subset_mset.Inf_fin.hom_commute
tff(fact_5415_subset__mset_OInf__fin_OboundedE,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X2),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3))
         => ! [A14: multiset(B)] :
              ( aa(set(multiset(B)),$o,member(multiset(B),A14),A3)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X2),A14) ) ) ) ) ).

% subset_mset.Inf_fin.boundedE
tff(fact_5416_subset__mset_OInf__fin_OboundedI,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( ! [A5: multiset(B)] :
              ( aa(set(multiset(B)),$o,member(multiset(B),A5),A3)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X2),A5) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X2),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3)) ) ) ) ).

% subset_mset.Inf_fin.boundedI
tff(fact_5417_subset__mset_OInf__fin_Obounded__iff,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X2),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3))
        <=> ! [X3: multiset(B)] :
              ( aa(set(multiset(B)),$o,member(multiset(B),X3),A3)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X2),X3) ) ) ) ) ).

% subset_mset.Inf_fin.bounded_iff
tff(fact_5418_subset__mset_OcInf__eq__Inf__fin,axiom,
    ! [B: $tType,X5: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),X5)
     => ( ( X5 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X5) = lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),X5) ) ) ) ).

% subset_mset.cInf_eq_Inf_fin
tff(fact_5419_subset__mset_OInf__fin_Oremove,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( aa(set(multiset(B)),$o,member(multiset(B),X2),A3)
       => ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3)
          = $ite(aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A3),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B))))) = bot_bot(set(multiset(B))),X2,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X2),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A3),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B)))))))) ) ) ) ).

% subset_mset.Inf_fin.remove
tff(fact_5420_subset__mset_OInf__fin_Oinsert__remove,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),A3))
        = $ite(aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A3),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B))))) = bot_bot(set(multiset(B))),X2,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X2),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A3),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B)))))))) ) ) ).

% subset_mset.Inf_fin.insert_remove
tff(fact_5421_subset__mset_OInf__fin_Oclosed,axiom,
    ! [B: $tType,A3: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( ! [X: multiset(B),Y2: multiset(B)] : aa(set(multiset(B)),$o,member(multiset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X),Y2)),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),Y2),bot_bot(set(multiset(B))))))
         => aa(set(multiset(B)),$o,member(multiset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3)),A3) ) ) ) ).

% subset_mset.Inf_fin.closed
tff(fact_5422_subset__mset_OInf__fin_Oinsert__not__elem,axiom,
    ! [B: $tType,A3: set(multiset(B)),X2: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ~ aa(set(multiset(B)),$o,member(multiset(B),X2),A3)
       => ( ( A3 != bot_bot(set(multiset(B))) )
         => ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),A3)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X2),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3)) ) ) ) ) ).

% subset_mset.Inf_fin.insert_not_elem
tff(fact_5423_subset__mset_OInf__fin_Osubset,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( B2 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),B2),A3)
         => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),B2)),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3)) = lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3) ) ) ) ) ).

% subset_mset.Inf_fin.subset
tff(fact_5424_subset__mset_OInf__fin_Ounion,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),A3)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),B2)
         => ( ( B2 != bot_bot(set(multiset(B))) )
           => ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),sup_sup(set(multiset(B))),A3),B2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3)),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),B2)) ) ) ) ) ) ).

% subset_mset.Inf_fin.union
tff(fact_5425_subset__mset_OInf__fin_Osubset__imp,axiom,
    ! [B: $tType,A3: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),A3),B2)
     => ( ( A3 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite2(multiset(B)),B2)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),B2)),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A3)) ) ) ) ).

% subset_mset.Inf_fin.subset_imp
tff(fact_5426_subset__mset_Osum__pos,axiom,
    ! [C: $tType,B: $tType,I: set(B),F2: fun(B,multiset(C))] :
      ( aa(set(B),$o,finite_finite2(B),I)
     => ( ( I != bot_bot(set(B)) )
       => ( ! [I3: B] :
              ( aa(set(B),$o,member(B,I3),I)
             => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subset_mset(C),zero_zero(multiset(C))),aa(B,multiset(C),F2,I3)) )
         => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subset_mset(C),zero_zero(multiset(C))),groups3894954378712506084id_sum(multiset(C),B,plus_plus(multiset(C)),zero_zero(multiset(C)),F2,I)) ) ) ) ).

% subset_mset.sum_pos
tff(fact_5427_subset__mset_Osum__strict__mono,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,multiset(C)),G: fun(B,multiset(C))] :
      ( aa(set(B),$o,finite_finite2(B),A3)
     => ( ( A3 != bot_bot(set(B)) )
       => ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),A3)
             => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subset_mset(C),aa(B,multiset(C),F2,X)),aa(B,multiset(C),G,X)) )
         => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subset_mset(C),groups3894954378712506084id_sum(multiset(C),B,plus_plus(multiset(C)),zero_zero(multiset(C)),F2,A3)),groups3894954378712506084id_sum(multiset(C),B,plus_plus(multiset(C)),zero_zero(multiset(C)),G,A3)) ) ) ) ).

% subset_mset.sum_strict_mono
tff(fact_5428_subset__mset_OatLeastAtMost__singleton,axiom,
    ! [B: $tType,A4: multiset(B)] : ( set_atLeastAtMost(multiset(B),subseteq_mset(B),A4,A4) = aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),A4),bot_bot(set(multiset(B)))) ) ).

% subset_mset.atLeastAtMost_singleton
tff(fact_5429_subset__mset_OatLeastatMost__empty__iff,axiom,
    ! [B: $tType,A4: multiset(B),B3: multiset(B)] :
      ( ( set_atLeastAtMost(multiset(B),subseteq_mset(B),A4,B3) = bot_bot(set(multiset(B))) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A4),B3) ) ).

% subset_mset.atLeastatMost_empty_iff
tff(fact_5430_subset__mset_OatLeastatMost__empty__iff2,axiom,
    ! [B: $tType,A4: multiset(B),B3: multiset(B)] :
      ( ( bot_bot(set(multiset(B))) = set_atLeastAtMost(multiset(B),subseteq_mset(B),A4,B3) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A4),B3) ) ).

% subset_mset.atLeastatMost_empty_iff2
tff(fact_5431_subset__mset_OatLeastatMost__empty,axiom,
    ! [B: $tType,B3: multiset(B),A4: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),B3),A4)
     => ( set_atLeastAtMost(multiset(B),subseteq_mset(B),A4,B3) = bot_bot(set(multiset(B))) ) ) ).

% subset_mset.atLeastatMost_empty
tff(fact_5432_subset__mset_OatLeastAtMost__singleton__iff,axiom,
    ! [B: $tType,A4: multiset(B),B3: multiset(B),Ca: multiset(B)] :
      ( ( set_atLeastAtMost(multiset(B),subseteq_mset(B),A4,B3) = aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),Ca),bot_bot(set(multiset(B)))) )
    <=> ( ( A4 = B3 )
        & ( B3 = Ca ) ) ) ).

% subset_mset.atLeastAtMost_singleton_iff
tff(fact_5433_subset__mset_Oasymp__greater,axiom,
    ! [B: $tType] : asymp(multiset(B),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o))) ).

% subset_mset.asymp_greater
tff(fact_5434_subset__mset_Oirreflp__greater,axiom,
    ! [B: $tType] : irreflp(multiset(B),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o))) ).

% subset_mset.irreflp_greater
tff(fact_5435_subset__mset_Olexordp_Omono,axiom,
    ! [B: $tType] : order_mono(fun(list(multiset(B)),fun(list(multiset(B)),$o)),fun(list(multiset(B)),fun(list(multiset(B)),$o)),aTP_Lamp_aug(fun(list(multiset(B)),fun(list(multiset(B)),$o)),fun(list(multiset(B)),fun(list(multiset(B)),$o)))) ).

% subset_mset.lexordp.mono
tff(fact_5436_subset__mset_Olexordp__def,axiom,
    ! [B: $tType] : ( lexordp2(multiset(B),subset_mset(B)) = complete_lattice_lfp(fun(list(multiset(B)),fun(list(multiset(B)),$o)),aTP_Lamp_aug(fun(list(multiset(B)),fun(list(multiset(B)),$o)),fun(list(multiset(B)),fun(list(multiset(B)),$o)))) ) ).

% subset_mset.lexordp_def
tff(fact_5437_subset__mset_Oordering__top__axioms,axiom,
    ! [B: $tType] : ordering_top(multiset(B),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o)),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o)),zero_zero(multiset(B))) ).

% subset_mset.ordering_top_axioms
tff(fact_5438_subset__mset_OSup__fin_Osemilattice__order__set__axioms,axiom,
    ! [B: $tType] : lattic4895041142388067077er_set(multiset(B),union_mset(B),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o)),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o))) ).

% subset_mset.Sup_fin.semilattice_order_set_axioms
tff(fact_5439_wf__subset__mset__rel,axiom,
    ! [B: $tType] : wf(multiset(B),aa(fun(product_prod(multiset(B),multiset(B)),$o),set(product_prod(multiset(B),multiset(B))),collect(product_prod(multiset(B),multiset(B))),aa(fun(multiset(B),fun(multiset(B),$o)),fun(product_prod(multiset(B),multiset(B)),$o),product_case_prod(multiset(B),multiset(B),$o),subset_mset(B)))) ).

% wf_subset_mset_rel
tff(fact_5440_subset__mset_Osemilattice__neutr__order__axioms,axiom,
    ! [B: $tType] : semila1105856199041335345_order(multiset(B),union_mset(B),zero_zero(multiset(B)),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o)),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o))) ).

% subset_mset.semilattice_neutr_order_axioms
tff(fact_5441_subset__mset_OatLeastAtMost__singleton_H,axiom,
    ! [B: $tType,A4: multiset(B),B3: multiset(B)] :
      ( ( A4 = B3 )
     => ( set_atLeastAtMost(multiset(B),subseteq_mset(B),A4,B3) = aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),A4),bot_bot(set(multiset(B)))) ) ) ).

% subset_mset.atLeastAtMost_singleton'
tff(fact_5442_subset__mset_OcSUP__lessD,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,multiset(B)),A3: set(C),Y: multiset(B),I2: C] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),aa(set(C),set(multiset(B)),image2(C,multiset(B),F2),A3))
     => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(C),set(multiset(B)),image2(C,multiset(B),F2),A3))),Y)
       => ( aa(set(C),$o,member(C,I2),A3)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),aa(C,multiset(B),F2,I2)),Y) ) ) ) ).

% subset_mset.cSUP_lessD
tff(fact_5443_subset__mset_Oless__cINF__D,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,multiset(B)),A3: set(C),Y: multiset(B),I2: C] :
      ( aa(set(multiset(B)),$o,condit8119078960628432327_below(multiset(B),subseteq_mset(B)),aa(set(C),set(multiset(B)),image2(C,multiset(B),F2),A3))
     => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),Y),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(C),set(multiset(B)),image2(C,multiset(B),F2),A3)))
       => ( aa(set(C),$o,member(C,I2),A3)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),Y),aa(C,multiset(B),F2,I2)) ) ) ) ).

% subset_mset.less_cINF_D
tff(fact_5444_subset__mset_OgreaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [B: $tType,A4: multiset(B),B3: multiset(B)] : ( set_gr3752724095348155675AtMost(multiset(B),subseteq_mset(B),subset_mset(B),A4,B3) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),set_atLeastAtMost(multiset(B),subseteq_mset(B),A4,B3)),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),A4),bot_bot(set(multiset(B))))) ) ).

% subset_mset.greaterThanAtMost_eq_atLeastAtMost_diff
tff(fact_5445_subset__mset_OatLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [B: $tType,A4: multiset(B),B3: multiset(B)] : ( set_atLeastLessThan(multiset(B),subseteq_mset(B),subset_mset(B),A4,B3) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),set_atLeastAtMost(multiset(B),subseteq_mset(B),A4,B3)),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),B3),bot_bot(set(multiset(B))))) ) ).

% subset_mset.atLeastLessThan_eq_atLeastAtMost_diff
tff(fact_5446_subset__mset_OgreaterThanLessThan__empty,axiom,
    ! [B: $tType,L: multiset(B),K: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),L),K)
     => ( set_gr287244882034783167ssThan(multiset(B),subset_mset(B),K,L) = bot_bot(set(multiset(B))) ) ) ).

% subset_mset.greaterThanLessThan_empty
tff(fact_5447_subset__mset_OatLeastLessThan__empty,axiom,
    ! [B: $tType,B3: multiset(B),A4: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),B3),A4)
     => ( set_atLeastLessThan(multiset(B),subseteq_mset(B),subset_mset(B),A4,B3) = bot_bot(set(multiset(B))) ) ) ).

% subset_mset.atLeastLessThan_empty
tff(fact_5448_subset__mset_OatLeastLessThan__empty__iff,axiom,
    ! [B: $tType,A4: multiset(B),B3: multiset(B)] :
      ( ( set_atLeastLessThan(multiset(B),subseteq_mset(B),subset_mset(B),A4,B3) = bot_bot(set(multiset(B))) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),A4),B3) ) ).

% subset_mset.atLeastLessThan_empty_iff
tff(fact_5449_subset__mset_OatLeastLessThan__empty__iff2,axiom,
    ! [B: $tType,A4: multiset(B),B3: multiset(B)] :
      ( ( bot_bot(set(multiset(B))) = set_atLeastLessThan(multiset(B),subseteq_mset(B),subset_mset(B),A4,B3) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),A4),B3) ) ).

% subset_mset.atLeastLessThan_empty_iff2
tff(fact_5450_subset__mset_OgreaterThanAtMost__empty,axiom,
    ! [B: $tType,L: multiset(B),K: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),L),K)
     => ( set_gr3752724095348155675AtMost(multiset(B),subseteq_mset(B),subset_mset(B),K,L) = bot_bot(set(multiset(B))) ) ) ).

% subset_mset.greaterThanAtMost_empty
tff(fact_5451_subset__mset_OgreaterThanAtMost__empty__iff,axiom,
    ! [B: $tType,K: multiset(B),L: multiset(B)] :
      ( ( set_gr3752724095348155675AtMost(multiset(B),subseteq_mset(B),subset_mset(B),K,L) = bot_bot(set(multiset(B))) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),K),L) ) ).

% subset_mset.greaterThanAtMost_empty_iff
tff(fact_5452_subset__mset_OgreaterThanAtMost__empty__iff2,axiom,
    ! [B: $tType,K: multiset(B),L: multiset(B)] :
      ( ( bot_bot(set(multiset(B))) = set_gr3752724095348155675AtMost(multiset(B),subseteq_mset(B),subset_mset(B),K,L) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),K),L) ) ).

% subset_mset.greaterThanAtMost_empty_iff2
tff(fact_5453_subset__mset_OIio__Int__singleton,axiom,
    ! [B: $tType,K: multiset(B),X2: multiset(B)] :
      ( aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_lessThan(multiset(B),subset_mset(B),K)),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B)))))
      = $ite(aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),X2),K),aa(set(multiset(B)),set(multiset(B)),insert(multiset(B),X2),bot_bot(set(multiset(B)))),bot_bot(set(multiset(B)))) ) ).

% subset_mset.Iio_Int_singleton
tff(fact_5454_equivp__equiv,axiom,
    ! [B: $tType,A3: set(product_prod(B,B))] :
      ( equiv_equiv(B,top_top(set(B)),A3)
    <=> equiv_equivp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),A3)) ) ).

% equivp_equiv
tff(fact_5455_asymp__asym__eq,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( asymp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R))
    <=> asym(B,R) ) ).

% asymp_asym_eq
tff(fact_5456_ord_OlessThan__def,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o)),U: B] : ( set_lessThan(B,Less,U) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Less),U)) ) ).

% ord.lessThan_def
tff(fact_5457_Quotient__crel__quotient,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(B,$o)),Abs: fun(B,C),Rep: fun(C,B),T2: fun(B,fun(C,$o))] :
      ( quotient(B,C,R,Abs,Rep,T2)
     => ( equiv_equivp(B,R)
       => ! [X4: B] : ( aa(B,fun(C,$o),T2,X4) = aa(C,fun(C,$o),fequal(C),aa(B,C,Abs,X4)) ) ) ) ).

% Quotient_crel_quotient
tff(fact_5458_subset__mset_OlessThan__def,axiom,
    ! [B: $tType,U: multiset(B)] : ( set_lessThan(multiset(B),subset_mset(B),U) = aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o)),U)) ) ).

% subset_mset.lessThan_def
tff(fact_5459_subset__mset_OatLeastLessThan__def,axiom,
    ! [B: $tType,L: multiset(B),U: multiset(B)] : ( set_atLeastLessThan(multiset(B),subseteq_mset(B),subset_mset(B),L,U) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_atLeast(multiset(B),subseteq_mset(B),L)),set_lessThan(multiset(B),subset_mset(B),U)) ) ).

% subset_mset.atLeastLessThan_def
tff(fact_5460_subset__mset_OgreaterThanLessThan__eq,axiom,
    ! [B: $tType,A4: multiset(B),B3: multiset(B)] : ( set_gr287244882034783167ssThan(multiset(B),subset_mset(B),A4,B3) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_greaterThan(multiset(B),subset_mset(B),A4)),set_lessThan(multiset(B),subset_mset(B),B3)) ) ).

% subset_mset.greaterThanLessThan_eq
tff(fact_5461_subset__mset_OgreaterThanLessThan__def,axiom,
    ! [B: $tType,L: multiset(B),U: multiset(B)] : ( set_gr287244882034783167ssThan(multiset(B),subset_mset(B),L,U) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_greaterThan(multiset(B),subset_mset(B),L)),set_lessThan(multiset(B),subset_mset(B),U)) ) ).

% subset_mset.greaterThanLessThan_def
tff(fact_5462_ord_OgreaterThan__def,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o)),L: B] : ( set_greaterThan(B,Less,L) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),Less,L)) ) ).

% ord.greaterThan_def
tff(fact_5463_ord_OatLeast__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),L: B] : ( set_atLeast(B,Less_eq,L) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),Less_eq,L)) ) ).

% ord.atLeast_def
tff(fact_5464_subset__mset_OatLeast__def,axiom,
    ! [B: $tType,L: multiset(B)] : ( set_atLeast(multiset(B),subseteq_mset(B),L) = aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),L)) ) ).

% subset_mset.atLeast_def
tff(fact_5465_subset__mset_OgreaterThan__def,axiom,
    ! [B: $tType,L: multiset(B)] : ( set_greaterThan(multiset(B),subset_mset(B),L) = aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(multiset(B),fun(multiset(B),$o),subset_mset(B),L)) ) ).

% subset_mset.greaterThan_def
tff(fact_5466_subset__mset_Onot__empty__eq__Ici__eq__empty,axiom,
    ! [B: $tType,L: multiset(B)] : ( bot_bot(set(multiset(B))) != set_atLeast(multiset(B),subseteq_mset(B),L) ) ).

% subset_mset.not_empty_eq_Ici_eq_empty
tff(fact_5467_ord_OgreaterThanLessThan__eq,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o)),A4: B,B3: B] : ( set_gr287244882034783167ssThan(B,Less,A4,B3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_greaterThan(B,Less,A4)),set_lessThan(B,Less,B3)) ) ).

% ord.greaterThanLessThan_eq
tff(fact_5468_ord_OgreaterThanLessThan__def,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o)),L: B,U: B] : ( set_gr287244882034783167ssThan(B,Less,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_greaterThan(B,Less,L)),set_lessThan(B,Less,U)) ) ).

% ord.greaterThanLessThan_def
tff(fact_5469_ord_OatLeastLessThan__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),L: B,U: B] : ( set_atLeastLessThan(B,Less_eq,Less,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_atLeast(B,Less_eq,L)),set_lessThan(B,Less,U)) ) ).

% ord.atLeastLessThan_def
tff(fact_5470_subset__mset_OgreaterThanAtMost__def,axiom,
    ! [B: $tType,L: multiset(B),U: multiset(B)] : ( set_gr3752724095348155675AtMost(multiset(B),subseteq_mset(B),subset_mset(B),L,U) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_greaterThan(multiset(B),subset_mset(B),L)),set_atMost(multiset(B),subseteq_mset(B),U)) ) ).

% subset_mset.greaterThanAtMost_def
tff(fact_5471_ord_OgreaterThanAtMost__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),L: B,U: B] : ( set_gr3752724095348155675AtMost(B,Less_eq,Less,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_greaterThan(B,Less,L)),set_atMost(B,Less_eq,U)) ) ).

% ord.greaterThanAtMost_def
tff(fact_5472_ord_OatLeastAtMost__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),L: B,U: B] : ( set_atLeastAtMost(B,Less_eq,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_atLeast(B,Less_eq,L)),set_atMost(B,Less_eq,U)) ) ).

% ord.atLeastAtMost_def
tff(fact_5473_ord_OatMost__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),U: B] : ( set_atMost(B,Less_eq,U) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Less_eq),U)) ) ).

% ord.atMost_def
tff(fact_5474_subset__mset_OatMost__def,axiom,
    ! [B: $tType,U: multiset(B)] : ( set_atMost(multiset(B),subseteq_mset(B),U) = aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o)),U)) ) ).

% subset_mset.atMost_def
tff(fact_5475_subset__mset_Onot__empty__eq__Iic__eq__empty,axiom,
    ! [B: $tType,H2: multiset(B)] : ( bot_bot(set(multiset(B))) != set_atMost(multiset(B),subseteq_mset(B),H2) ) ).

% subset_mset.not_empty_eq_Iic_eq_empty
tff(fact_5476_subset__mset_OatLeastAtMost__def,axiom,
    ! [B: $tType,L: multiset(B),U: multiset(B)] : ( set_atLeastAtMost(multiset(B),subseteq_mset(B),L,U) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_atLeast(multiset(B),subseteq_mset(B),L)),set_atMost(multiset(B),subseteq_mset(B),U)) ) ).

% subset_mset.atLeastAtMost_def
tff(fact_5477_Shift__def,axiom,
    ! [B: $tType,Kl: set(list(B)),K: B] : ( bNF_Greatest_Shift(B,Kl,K) = aa(fun(list(B),$o),set(list(B)),collect(list(B)),aa(B,fun(list(B),$o),aTP_Lamp_aui(set(list(B)),fun(B,fun(list(B),$o)),Kl),K)) ) ).

% Shift_def
tff(fact_5478_drop__bit__of__1,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ( bit_se4197421643247451524op_bit(B,N,one_one(B)) = aa($o,B,zero_neq_one_of_bool(B),( N = zero_zero(nat) )) ) ) ).

% drop_bit_of_1
tff(fact_5479_bit__double__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A4: B,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A4)),N)
        <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,A4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))
            & ( N != zero_zero(nat) )
            & bit_se6407376104438227557le_bit(B,type2(B),N) ) ) ) ).

% bit_double_iff
tff(fact_5480_bit__minus__1__iff,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,uminus_uminus(B),one_one(B))),N)
        <=> bit_se6407376104438227557le_bit(B,type2(B),N) ) ) ).

% bit_minus_1_iff
tff(fact_5481_bit__minus__iff,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A4: B,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,uminus_uminus(B),A4)),N)
        <=> ( bit_se6407376104438227557le_bit(B,type2(B),N)
            & ~ aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),one_one(B))),N) ) ) ) ).

% bit_minus_iff
tff(fact_5482_drop__bit__exp__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [M2: nat,N: nat] :
          ( bit_se4197421643247451524op_bit(B,M2,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N))
          = aa(B,B,
              aa(B,fun(B,B),times_times(B),
                aa($o,B,zero_neq_one_of_bool(B),
                  aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N)
                & bit_se6407376104438227557le_bit(B,type2(B),N))),
              aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M2))) ) ) ).

% drop_bit_exp_eq
tff(fact_5483_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),bit_se4730199178511100633sh_bit(B,N,one_one(B))) = bit_se4197421643247451524op_bit(B,N,A4) ) ) ).

% div_push_bit_of_1_eq_drop_bit
tff(fact_5484_bit__iff__and__drop__bit__eq__1,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A4: B,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,A4),N)
        <=> ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),bit_se4197421643247451524op_bit(B,N,A4)),one_one(B)) = one_one(B) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
tff(fact_5485_bit__mask__sub__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [M2: nat,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M2)),one_one(B))),N)
        <=> ( bit_se6407376104438227557le_bit(B,type2(B),N)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M2) ) ) ) ).

% bit_mask_sub_iff
tff(fact_5486_old_Orec__unit__def,axiom,
    ! [B: $tType,X4: B,Xa3: product_unit] : ( product_rec_unit(B,X4,Xa3) = the(B,product_rec_set_unit(B,X4,Xa3)) ) ).

% old.rec_unit_def
tff(fact_5487_Gcd__Lcm,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(B)] : ( gcd_Gcd(B,A3) = gcd_Lcm(B,aa(fun(B,$o),set(B),collect(B),aTP_Lamp_auj(set(B),fun(B,$o),A3))) ) ) ).

% Gcd_Lcm
tff(fact_5488_Lcm__Gcd,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(B)] : ( gcd_Lcm(B,A3) = gcd_Gcd(B,aa(fun(B,$o),set(B),collect(B),aTP_Lamp_auk(set(B),fun(B,$o),A3))) ) ) ).

% Lcm_Gcd
tff(fact_5489_Lcm__abs__eq,axiom,
    ! [K4: set(int)] : ( gcd_Lcm(int,aa(set(int),set(int),image2(int,int,abs_abs(int)),K4)) = gcd_Lcm(int,K4) ) ).

% Lcm_abs_eq
tff(fact_5490_Lcm__int__eq,axiom,
    ! [N3: set(nat)] : ( gcd_Lcm(int,aa(set(nat),set(int),image2(nat,int,semiring_1_of_nat(int)),N3)) = aa(nat,int,semiring_1_of_nat(int),gcd_Lcm(nat,N3)) ) ).

% Lcm_int_eq
tff(fact_5491_Lcm__empty,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ( gcd_Lcm(B,bot_bot(set(B))) = one_one(B) ) ) ).

% Lcm_empty
tff(fact_5492_Lcm__1__iff,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(B)] :
          ( ( gcd_Lcm(B,A3) = one_one(B) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X3),one_one(B)) ) ) ) ).

% Lcm_1_iff
tff(fact_5493_Lcm__nat__abs__eq,axiom,
    ! [K4: set(int)] : ( gcd_Lcm(nat,aa(set(int),set(nat),image2(int,nat,aTP_Lamp_zt(int,nat)),K4)) = aa(int,nat,nat2,gcd_Lcm(int,K4)) ) ).

% Lcm_nat_abs_eq
tff(fact_5494_Lcm__nat__empty,axiom,
    gcd_Lcm(nat,bot_bot(set(nat))) = one_one(nat) ).

% Lcm_nat_empty
tff(fact_5495_Lcm__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_Gcd(C)
     => ! [A3: set(B),F2: fun(B,C),G: fun(B,C)] :
          ( ! [X: B] :
              ( aa(set(B),$o,member(B,X),A3)
             => aa(C,$o,aa(C,fun(C,$o),dvd_dvd(C),aa(B,C,F2,X)),aa(B,C,G,X)) )
         => aa(C,$o,aa(C,fun(C,$o),dvd_dvd(C),gcd_Lcm(C,aa(set(B),set(C),image2(B,C,F2),A3))),gcd_Lcm(C,aa(set(B),set(C),image2(B,C,G),A3))) ) ) ).

% Lcm_mono
tff(fact_5496_Gcd__nat__def,axiom,
    ! [M: set(nat)] : ( gcd_Gcd(nat,M) = gcd_Lcm(nat,aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_aul(set(nat),fun(nat,$o),M))) ) ).

% Gcd_nat_def
tff(fact_5497_Lcm__int__def,axiom,
    ! [K4: set(int)] : ( gcd_Lcm(int,K4) = aa(nat,int,semiring_1_of_nat(int),gcd_Lcm(nat,aa(set(int),set(nat),image2(int,nat,aa(fun(int,int),fun(int,nat),comp(int,nat,int,nat2),abs_abs(int))),K4))) ) ).

% Lcm_int_def
tff(fact_5498_Lcm__no__units,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(B)] : ( gcd_Lcm(B,A3) = gcd_Lcm(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_aum(B,$o)))) ) ) ).

% Lcm_no_units
tff(fact_5499_Lcm__coprime_H,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(B)] :
          ( ( aa(set(B),nat,finite_card(B),A3) != zero_zero(nat) )
         => ( ! [A5: B,B4: B] :
                ( aa(set(B),$o,member(B,A5),A3)
               => ( aa(set(B),$o,member(B,B4),A3)
                 => ( ( A5 != B4 )
                   => algebr8660921524188924756oprime(B,A5,B4) ) ) )
           => ( gcd_Lcm(B,A3) = aa(B,B,normal6383669964737779283malize(B),aa(set(B),B,aa(fun(B,B),fun(set(B),B),groups7121269368397514597t_prod(B,B),aTP_Lamp_aun(B,B)),A3)) ) ) ) ) ).

% Lcm_coprime'
tff(fact_5500_Lcm__coprime,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(B)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( ( A3 != bot_bot(set(B)) )
           => ( ! [A5: B,B4: B] :
                  ( aa(set(B),$o,member(B,A5),A3)
                 => ( aa(set(B),$o,member(B,B4),A3)
                   => ( ( A5 != B4 )
                     => algebr8660921524188924756oprime(B,A5,B4) ) ) )
             => ( gcd_Lcm(B,A3) = aa(B,B,normal6383669964737779283malize(B),aa(set(B),B,aa(fun(B,B),fun(set(B),B),groups7121269368397514597t_prod(B,B),aTP_Lamp_aun(B,B)),A3)) ) ) ) ) ) ).

% Lcm_coprime
tff(fact_5501_Lcm__eq__Max__nat,axiom,
    ! [M: set(nat)] :
      ( aa(set(nat),$o,finite_finite2(nat),M)
     => ( ( M != bot_bot(set(nat)) )
       => ( ~ aa(set(nat),$o,member(nat,zero_zero(nat)),M)
         => ( ! [M3: nat,N2: nat] :
                ( aa(set(nat),$o,member(nat,M3),M)
               => ( aa(set(nat),$o,member(nat,N2),M)
                 => aa(set(nat),$o,member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M3),N2)),M) ) )
           => ( gcd_Lcm(nat,M) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),M) ) ) ) ) ) ).

% Lcm_eq_Max_nat
tff(fact_5502_normalize__idem,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] : ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,normal6383669964737779283malize(B),A4)) = aa(B,B,normal6383669964737779283malize(B),A4) ) ) ).

% normalize_idem
tff(fact_5503_normalize__eq__0__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A4) = zero_zero(B) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% normalize_eq_0_iff
tff(fact_5504_normalize__0,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ( aa(B,B,normal6383669964737779283malize(B),zero_zero(B)) = zero_zero(B) ) ) ).

% normalize_0
tff(fact_5505_normalize__mult__normalize__left,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] : ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A4)),B3)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ) ).

% normalize_mult_normalize_left
tff(fact_5506_normalize__mult__normalize__right,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] : ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,normal6383669964737779283malize(B),B3))) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ) ).

% normalize_mult_normalize_right
tff(fact_5507_normalize__1,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ( aa(B,B,normal6383669964737779283malize(B),one_one(B)) = one_one(B) ) ) ).

% normalize_1
tff(fact_5508_gcd_Onormalize__bottom,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ( aa(B,B,normal6383669964737779283malize(B),one_one(B)) = one_one(B) ) ) ).

% gcd.normalize_bottom
tff(fact_5509_normalize__dvd__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(B,B,normal6383669964737779283malize(B),A4)),B3)
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ).

% normalize_dvd_iff
tff(fact_5510_dvd__normalize__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),aa(B,B,normal6383669964737779283malize(B),B3))
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ).

% dvd_normalize_iff
tff(fact_5511_coprime__normalize__right__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( algebr8660921524188924756oprime(B,A4,aa(B,B,normal6383669964737779283malize(B),B3))
        <=> algebr8660921524188924756oprime(B,A4,B3) ) ) ).

% coprime_normalize_right_iff
tff(fact_5512_coprime__normalize__left__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( algebr8660921524188924756oprime(B,aa(B,B,normal6383669964737779283malize(B),A4),B3)
        <=> algebr8660921524188924756oprime(B,A4,B3) ) ) ).

% coprime_normalize_left_iff
tff(fact_5513_lcm__eq__1__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3) = one_one(B) )
        <=> ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
            & aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B)) ) ) ) ).

% lcm_eq_1_iff
tff(fact_5514_lcm_Otop__left__normalize,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),one_one(B)),A4) = aa(B,B,normal6383669964737779283malize(B),A4) ) ) ).

% lcm.top_left_normalize
tff(fact_5515_lcm_Otop__right__normalize,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),one_one(B)) = aa(B,B,normal6383669964737779283malize(B),A4) ) ) ).

% lcm.top_right_normalize
tff(fact_5516_normalize__mult__unit__left,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,normal6383669964737779283malize(B),B3) ) ) ) ).

% normalize_mult_unit_left
tff(fact_5517_normalize__mult__unit__right,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B))
         => ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,normal6383669964737779283malize(B),A4) ) ) ) ).

% normalize_mult_unit_right
tff(fact_5518_gcd__mult__lcm,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A4)),aa(B,B,normal6383669964737779283malize(B),B3)) ) ) ).

% gcd_mult_lcm
tff(fact_5519_lcm__mult__gcd,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3)),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A4)),aa(B,B,normal6383669964737779283malize(B),B3)) ) ) ).

% lcm_mult_gcd
tff(fact_5520_Lcm__2,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: B,B3: B] : ( gcd_Lcm(B,aa(set(B),set(B),insert(B,A4),aa(set(B),set(B),insert(B,B3),bot_bot(set(B))))) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3) ) ) ).

% Lcm_2
tff(fact_5521_Lcm__singleton,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: B] : ( gcd_Lcm(B,aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) = aa(B,B,normal6383669964737779283malize(B),A4) ) ) ).

% Lcm_singleton
tff(fact_5522_Gcd__singleton,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: B] : ( gcd_Gcd(B,aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))) = aa(B,B,normal6383669964737779283malize(B),A4) ) ) ).

% Gcd_singleton
tff(fact_5523_coprime__crossproduct,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,D3: B,B3: B,Ca: B] :
          ( algebr8660921524188924756oprime(B,A4,D3)
         => ( algebr8660921524188924756oprime(B,B3,Ca)
           => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A4)),aa(B,B,normal6383669964737779283malize(B),Ca)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),B3)),aa(B,B,normal6383669964737779283malize(B),D3)) )
            <=> ( ( aa(B,B,normal6383669964737779283malize(B),A4) = aa(B,B,normal6383669964737779283malize(B),B3) )
                & ( aa(B,B,normal6383669964737779283malize(B),Ca) = aa(B,B,normal6383669964737779283malize(B),D3) ) ) ) ) ) ) ).

% coprime_crossproduct
tff(fact_5524_dvd__normalize__div,axiom,
    ! [B: $tType] :
      ( normal6328177297339901930cative(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
         => ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,normal6383669964737779283malize(B),A4)),aa(B,B,normal6383669964737779283malize(B),B3)) ) ) ) ).

% dvd_normalize_div
tff(fact_5525_associated__unit,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A4) = aa(B,B,normal6383669964737779283malize(B),B3) )
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),one_one(B)) ) ) ) ).

% associated_unit
tff(fact_5526_normalize__1__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A4) = one_one(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B)) ) ) ).

% normalize_1_iff
tff(fact_5527_is__unit__normalize,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,normal6383669964737779283malize(B),A4) = one_one(B) ) ) ) ).

% is_unit_normalize
tff(fact_5528_normalize__idem__imp__is__unit__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A4) = A4 )
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
          <=> ( A4 = one_one(B) ) ) ) ) ).

% normalize_idem_imp_is_unit_iff
tff(fact_5529_gcd__lcm,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => ( ( B3 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3))) ) ) ) ) ).

% gcd_lcm
tff(fact_5530_associated__iff__dvd,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A4) = aa(B,B,normal6383669964737779283malize(B),B3) )
        <=> ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
            & aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4) ) ) ) ).

% associated_iff_dvd
tff(fact_5531_associated__eqI,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
           => ( ( aa(B,B,normal6383669964737779283malize(B),A4) = A4 )
             => ( ( aa(B,B,normal6383669964737779283malize(B),B3) = B3 )
               => ( A4 = B3 ) ) ) ) ) ) ).

% associated_eqI
tff(fact_5532_associatedD2,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A4) = aa(B,B,normal6383669964737779283malize(B),B3) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4) ) ) ).

% associatedD2
tff(fact_5533_associatedD1,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A4) = aa(B,B,normal6383669964737779283malize(B),B3) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3) ) ) ).

% associatedD1
tff(fact_5534_associatedI,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),B3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
           => ( aa(B,B,normal6383669964737779283malize(B),A4) = aa(B,B,normal6383669964737779283malize(B),B3) ) ) ) ) ).

% associatedI
tff(fact_5535_normalize__mult,axiom,
    ! [B: $tType] :
      ( normal6328177297339901930cative(B)
     => ! [A4: B,B3: B] : ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A4)),aa(B,B,normal6383669964737779283malize(B),B3)) ) ) ).

% normalize_mult
tff(fact_5536_lcm__mult__left,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [Ca: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3))) ) ) ).

% lcm_mult_left
tff(fact_5537_lcm__mult__right,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,Ca: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),B3),A4)),Ca)) ) ) ).

% lcm_mult_right
tff(fact_5538_lcm__mult__distrib_H,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [Ca: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),Ca)),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) ) ) ).

% lcm_mult_distrib'
tff(fact_5539_lcm__gcd__prod,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3)),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ) ).

% lcm_gcd_prod
tff(fact_5540_lcm__gcd,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3))) ) ) ).

% lcm_gcd
tff(fact_5541_Lcm__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => bounde6485984586167503788ce_set(B,gcd_lcm(B),one_one(B),zero_zero(B),normal6383669964737779283malize(B)) ) ).

% Lcm_fin.bounded_quasi_semilattice_set_axioms
tff(fact_5542_lcm__coprime,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] :
          ( algebr8660921524188924756oprime(B,A4,B3)
         => ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) ) ) ) ).

% lcm_coprime
tff(fact_5543_gcd__mult__left,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [Ca: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3))) ) ) ).

% gcd_mult_left
tff(fact_5544_gcd__mult__right,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,Ca: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),B3),A4)),Ca)) ) ) ).

% gcd_mult_right
tff(fact_5545_gcd__mult__distrib_H,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [Ca: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),Ca)),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3)) ) ) ).

% gcd_mult_distrib'
tff(fact_5546_Lcm__in__lcm__closed__set__nat,axiom,
    ! [M: set(nat)] :
      ( aa(set(nat),$o,finite_finite2(nat),M)
     => ( ( M != bot_bot(set(nat)) )
       => ( ! [M3: nat,N2: nat] :
              ( aa(set(nat),$o,member(nat,M3),M)
             => ( aa(set(nat),$o,member(nat,N2),M)
               => aa(set(nat),$o,member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M3),N2)),M) ) )
         => aa(set(nat),$o,member(nat,gcd_Lcm(nat,M)),M) ) ) ) ).

% Lcm_in_lcm_closed_set_nat
tff(fact_5547_lcm__mult__unit1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4)),Ca) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),B3),Ca) ) ) ) ).

% lcm_mult_unit1
tff(fact_5548_lcm__mult__unit2,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),B3),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),B3),Ca) ) ) ) ).

% lcm_mult_unit2
tff(fact_5549_lcm__div__unit2,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),B3),aa(B,B,aa(B,fun(B,B),divide_divide(B),Ca),A4)) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),B3),Ca) ) ) ) ).

% lcm_div_unit2
tff(fact_5550_lcm__div__unit1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B,Ca: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),B3),A4)),Ca) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),B3),Ca) ) ) ) ).

% lcm_div_unit1
tff(fact_5551_Gcd__mult,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [Ca: B,A3: set(B)] : ( gcd_Gcd(B,aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),Ca)),A3)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),gcd_Gcd(B,A3))) ) ) ).

% Gcd_mult
tff(fact_5552_Lcm__mult,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(B),Ca: B] :
          ( ( A3 != bot_bot(set(B)) )
         => ( gcd_Lcm(B,aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),Ca)),A3)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),gcd_Lcm(B,A3))) ) ) ) ).

% Lcm_mult
tff(fact_5553_Gcd__fin__mult,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(B),B3: B] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(B),B,semiring_gcd_Gcd_fin(B),aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),B3)),A3)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(set(B),B,semiring_gcd_Gcd_fin(B),A3))) ) ) ) ).

% Gcd_fin_mult
tff(fact_5554_Lcm__set__eq__fold,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [Xs: list(B)] : ( gcd_Lcm(B,aa(list(B),set(B),set2(B),Xs)) = aa(B,B,fold(B,B,gcd_lcm(B),Xs),one_one(B)) ) ) ).

% Lcm_set_eq_fold
tff(fact_5555_Gcd__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => bounde6485984586167503788ce_set(B,gcd_gcd(B),zero_zero(B),one_one(B),normal6383669964737779283malize(B)) ) ).

% Gcd_fin.bounded_quasi_semilattice_set_axioms
tff(fact_5556_Lcm__fin_Oeq__fold,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(B)] :
          ( aa(set(B),B,semiring_gcd_Lcm_fin(B),A3)
          = $ite(aa(set(B),$o,finite_finite2(B),A3),finite_fold(B,B,gcd_lcm(B),one_one(B),A3),zero_zero(B)) ) ) ).

% Lcm_fin.eq_fold
tff(fact_5557_lcm_Obounded__quasi__semilattice__axioms,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => bounde8507323023520639062attice(B,gcd_lcm(B),one_one(B),zero_zero(B),normal6383669964737779283malize(B)) ) ).

% lcm.bounded_quasi_semilattice_axioms
tff(fact_5558_gcd_Obounded__quasi__semilattice__axioms,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => bounde8507323023520639062attice(B,gcd_gcd(B),zero_zero(B),one_one(B),normal6383669964737779283malize(B)) ) ).

% gcd.bounded_quasi_semilattice_axioms
tff(fact_5559_Lcm__fin_Oempty,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ( aa(set(B),B,semiring_gcd_Lcm_fin(B),bot_bot(set(B))) = one_one(B) ) ) ).

% Lcm_fin.empty
tff(fact_5560_is__unit__Lcm__fin__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(B)] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(set(B),B,semiring_gcd_Lcm_fin(B),A3)),one_one(B))
        <=> ( aa(set(B),B,semiring_gcd_Lcm_fin(B),A3) = one_one(B) ) ) ) ).

% is_unit_Lcm_fin_iff
tff(fact_5561_Lcm__fin__1__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(B)] :
          ( ( aa(set(B),B,semiring_gcd_Lcm_fin(B),A3) = one_one(B) )
        <=> ( ! [X3: B] :
                ( aa(set(B),$o,member(B,X3),A3)
               => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X3),one_one(B)) )
            & aa(set(B),$o,finite_finite2(B),A3) ) ) ) ).

% Lcm_fin_1_iff
tff(fact_5562_Lcm__fin__mult,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(B),B3: B] :
          ( ( A3 != bot_bot(set(B)) )
         => ( aa(set(B),B,semiring_gcd_Lcm_fin(B),aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),B3)),A3)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(set(B),B,semiring_gcd_Lcm_fin(B),A3))) ) ) ) ).

% Lcm_fin_mult
tff(fact_5563_Lcm__fin_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,A3: set(B)] : ( aa(set(B),B,semiring_gcd_Lcm_fin(B),aa(set(B),set(B),insert(B,A4),A3)) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),aa(set(B),B,semiring_gcd_Lcm_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) ) ).

% Lcm_fin.insert_remove
tff(fact_5564_Lcm__fin_Oremove,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,A3: set(B)] :
          ( aa(set(B),$o,member(B,A4),A3)
         => ( aa(set(B),B,semiring_gcd_Lcm_fin(B),A3) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),aa(set(B),B,semiring_gcd_Lcm_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,A4),bot_bot(set(B)))))) ) ) ) ).

% Lcm_fin.remove
tff(fact_5565_Lcm__fin_Oset__eq__fold,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [Xs: list(B)] : ( aa(set(B),B,semiring_gcd_Lcm_fin(B),aa(list(B),set(B),set2(B),Xs)) = aa(B,B,fold(B,B,gcd_lcm(B),Xs),one_one(B)) ) ) ).

% Lcm_fin.set_eq_fold
tff(fact_5566_Lcm__fin__def,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ( semiring_gcd_Lcm_fin(B) = bounde2362111253966948842tice_F(B,gcd_lcm(B),one_one(B),zero_zero(B)) ) ) ).

% Lcm_fin_def
tff(fact_5567_combine__options__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),X2: option(B),Y: option(B)] : ( combine_options(B,F2,X2,Y) = case_option(option(B),B,Y,aa(option(B),fun(B,option(B)),aTP_Lamp_aup(fun(B,fun(B,B)),fun(option(B),fun(B,option(B))),F2),Y),X2) ) ).

% combine_options_def
tff(fact_5568_inv__image__def,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(C,C)),F2: fun(B,C)] : ( inv_image(C,B,R2,F2) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(fun(B,C),fun(B,fun(B,$o)),aTP_Lamp_auq(set(product_prod(C,C)),fun(fun(B,C),fun(B,fun(B,$o))),R2),F2))) ) ).

% inv_image_def
tff(fact_5569_normalize__div,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,normal6383669964737779283malize(B),A4)),A4) = aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),unit_f5069060285200089521factor(B,A4)) ) ) ).

% normalize_div
tff(fact_5570_unit__factor__idem,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] : ( unit_f5069060285200089521factor(B,unit_f5069060285200089521factor(B,A4)) = unit_f5069060285200089521factor(B,A4) ) ) ).

% unit_factor_idem
tff(fact_5571_unit__factor__eq__0__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] :
          ( ( unit_f5069060285200089521factor(B,A4) = zero_zero(B) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% unit_factor_eq_0_iff
tff(fact_5572_unit__factor__0,axiom,
    ! [B: $tType] :
      ( semido2269285787275462019factor(B)
     => ( unit_f5069060285200089521factor(B,zero_zero(B)) = zero_zero(B) ) ) ).

% unit_factor_0
tff(fact_5573_unit__factor__1,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ( unit_f5069060285200089521factor(B,one_one(B)) = one_one(B) ) ) ).

% unit_factor_1
tff(fact_5574_normalize__mult__unit__factor,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A4)),unit_f5069060285200089521factor(B,A4)) = A4 ) ) ).

% normalize_mult_unit_factor
tff(fact_5575_unit__factor__mult__normalize,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),unit_f5069060285200089521factor(B,A4)),aa(B,B,normal6383669964737779283malize(B),A4)) = A4 ) ) ).

% unit_factor_mult_normalize
tff(fact_5576_div__unit__factor,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),unit_f5069060285200089521factor(B,A4)) = aa(B,B,normal6383669964737779283malize(B),A4) ) ) ).

% div_unit_factor
tff(fact_5577_div__normalize,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] : ( aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),aa(B,B,normal6383669964737779283malize(B),A4)) = unit_f5069060285200089521factor(B,A4) ) ) ).

% div_normalize
tff(fact_5578_inv__unit__factor__eq__0__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] :
          ( ( aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),unit_f5069060285200089521factor(B,A4)) = zero_zero(B) )
        <=> ( A4 = zero_zero(B) ) ) ) ).

% inv_unit_factor_eq_0_iff
tff(fact_5579_unit__factor__mult__unit__left,axiom,
    ! [B: $tType] :
      ( semido2269285787275462019factor(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( unit_f5069060285200089521factor(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),A4),unit_f5069060285200089521factor(B,B3)) ) ) ) ).

% unit_factor_mult_unit_left
tff(fact_5580_unit__factor__mult__unit__right,axiom,
    ! [B: $tType] :
      ( semido2269285787275462019factor(B)
     => ! [A4: B,B3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( unit_f5069060285200089521factor(B,aa(B,B,aa(B,fun(B,B),times_times(B),B3),A4)) = aa(B,B,aa(B,fun(B,B),times_times(B),unit_f5069060285200089521factor(B,B3)),A4) ) ) ) ).

% unit_factor_mult_unit_right
tff(fact_5581_mult__one__div__unit__factor,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),aa(B,B,aa(B,fun(B,B),divide_divide(B),one_one(B)),unit_f5069060285200089521factor(B,B3))) = aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),unit_f5069060285200089521factor(B,B3)) ) ) ).

% mult_one_div_unit_factor
tff(fact_5582_unit__factor__lcm,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] :
          ( unit_f5069060285200089521factor(B,aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3))
          = $ite(
              ( ( A4 = zero_zero(B) )
              | ( B3 = zero_zero(B) ) ),
              zero_zero(B),
              one_one(B) ) ) ) ).

% unit_factor_lcm
tff(fact_5583_unit__factor__normalize,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] :
          ( ( A4 != zero_zero(B) )
         => ( unit_f5069060285200089521factor(B,aa(B,B,normal6383669964737779283malize(B),A4)) = one_one(B) ) ) ) ).

% unit_factor_normalize
tff(fact_5584_normalize__unit__factor,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] :
          ( ( A4 != zero_zero(B) )
         => ( aa(B,B,normal6383669964737779283malize(B),unit_f5069060285200089521factor(B,A4)) = one_one(B) ) ) ) ).

% normalize_unit_factor
tff(fact_5585_unit__factor__self,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] : aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),unit_f5069060285200089521factor(B,A4)),A4) ) ).

% unit_factor_self
tff(fact_5586_unit__factor__mult,axiom,
    ! [B: $tType] :
      ( normal6328177297339901930cative(B)
     => ! [A4: B,B3: B] : ( unit_f5069060285200089521factor(B,aa(B,B,aa(B,fun(B,B),times_times(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),unit_f5069060285200089521factor(B,A4)),unit_f5069060285200089521factor(B,B3)) ) ) ).

% unit_factor_mult
tff(fact_5587_normalize__unit__factor__eqI,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A4) = aa(B,B,normal6383669964737779283malize(B),B3) )
         => ( ( unit_f5069060285200089521factor(B,A4) = unit_f5069060285200089521factor(B,B3) )
           => ( A4 = B3 ) ) ) ) ).

% normalize_unit_factor_eqI
tff(fact_5588_unit__factor__dvd,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B,B3: B] :
          ( ( A4 != zero_zero(B) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),unit_f5069060285200089521factor(B,A4)),B3) ) ) ).

% unit_factor_dvd
tff(fact_5589_is__unit__unit__factor,axiom,
    ! [B: $tType] :
      ( semido2269285787275462019factor(B)
     => ! [A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),A4),one_one(B))
         => ( unit_f5069060285200089521factor(B,A4) = A4 ) ) ) ).

% is_unit_unit_factor
tff(fact_5590_dvd__unit__factor__div,axiom,
    ! [B: $tType] :
      ( normal6328177297339901930cative(B)
     => ! [B3: B,A4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B3),A4)
         => ( unit_f5069060285200089521factor(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),unit_f5069060285200089521factor(B,A4)),unit_f5069060285200089521factor(B,B3)) ) ) ) ).

% dvd_unit_factor_div
tff(fact_5591_gcd__mult__distrib,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [K: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),K),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),K),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),K),B3))),unit_f5069060285200089521factor(B,K)) ) ) ).

% gcd_mult_distrib
tff(fact_5592_mult__gcd__right,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))),unit_f5069060285200089521factor(B,Ca)) ) ) ).

% mult_gcd_right
tff(fact_5593_mult__gcd__left,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [Ca: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),Ca),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),unit_f5069060285200089521factor(B,Ca)),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))) ) ) ).

% mult_gcd_left
tff(fact_5594_mult__lcm__left,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [Ca: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),Ca),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),unit_f5069060285200089521factor(B,Ca)),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),Ca),B3))) ) ) ).

% mult_lcm_left
tff(fact_5595_mult__lcm__right,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [A4: B,B3: B,Ca: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3)),Ca) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),A4),Ca)),aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca))),unit_f5069060285200089521factor(B,Ca)) ) ) ).

% mult_lcm_right
tff(fact_5596_lcm__mult__distrib,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [K: B,A4: B,B3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),K),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A4),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),K),A4)),aa(B,B,aa(B,fun(B,B),times_times(B),K),B3))),unit_f5069060285200089521factor(B,K)) ) ) ).

% lcm_mult_distrib
tff(fact_5597_unit__factor__is__unit,axiom,
    ! [B: $tType] :
      ( semido2269285787275462019factor(B)
     => ! [A4: B] :
          ( ( A4 != zero_zero(B) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),unit_f5069060285200089521factor(B,A4)),one_one(B)) ) ) ).

% unit_factor_is_unit
tff(fact_5598_unit__factor__gcd,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: B,B3: B] :
          ( unit_f5069060285200089521factor(B,aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A4),B3))
          = $ite(
              ( ( A4 = zero_zero(B) )
              & ( B3 = zero_zero(B) ) ),
              zero_zero(B),
              one_one(B) ) ) ) ).

% unit_factor_gcd
tff(fact_5599_coprime__crossproduct_H,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [B3: B,D3: B,A4: B,Ca: B] :
          ( ( B3 != zero_zero(B) )
         => ( ( unit_f5069060285200089521factor(B,B3) = unit_f5069060285200089521factor(B,D3) )
           => ( algebr8660921524188924756oprime(B,A4,B3)
             => ( algebr8660921524188924756oprime(B,Ca,D3)
               => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A4),D3) = aa(B,B,aa(B,fun(B,B),times_times(B),B3),Ca) )
                <=> ( ( A4 = Ca )
                    & ( B3 = D3 ) ) ) ) ) ) ) ) ).

% coprime_crossproduct'
tff(fact_5600_unit__factor__Lcm,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(B)] :
          ( unit_f5069060285200089521factor(B,gcd_Lcm(B,A3))
          = $ite(gcd_Lcm(B,A3) = zero_zero(B),zero_zero(B),one_one(B)) ) ) ).

% unit_factor_Lcm
tff(fact_5601_unit__factor__Gcd,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(B)] :
          ( unit_f5069060285200089521factor(B,gcd_Gcd(B,A3))
          = $ite(gcd_Gcd(B,A3) = zero_zero(B),zero_zero(B),one_one(B)) ) ) ).

% unit_factor_Gcd
tff(fact_5602_normalize__idem__imp__unit__factor__eq,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A4: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A4) = A4 )
         => ( unit_f5069060285200089521factor(B,A4) = aa($o,B,zero_neq_one_of_bool(B),( A4 != zero_zero(B) )) ) ) ) ).

% normalize_idem_imp_unit_factor_eq
tff(fact_5603_rp__inv__image__def,axiom,
    ! [C: $tType,B: $tType] : ( fun_rp_inv_image(B,C) = aa(fun(set(product_prod(B,B)),fun(set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))))),fun(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C))))),product_case_prod(set(product_prod(B,B)),set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C))))),aTP_Lamp_aur(set(product_prod(B,B)),fun(set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C))))))) ) ).

% rp_inv_image_def
tff(fact_5604_lenlex__def,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : ( lenlex(B,R2) = inv_image(product_prod(nat,list(B)),list(B),lex_prod(nat,list(B),less_than,lex(B,R2)),aTP_Lamp_aus(list(B),product_prod(nat,list(B)))) ) ).

% lenlex_def
tff(fact_5605_mlex__prod__def,axiom,
    ! [B: $tType,F2: fun(B,nat),R: set(product_prod(B,B))] : ( mlex_prod(B,F2,R) = inv_image(product_prod(nat,B),B,lex_prod(nat,B,less_than,R),aTP_Lamp_aut(fun(B,nat),fun(B,product_prod(nat,B)),F2)) ) ).

% mlex_prod_def
tff(fact_5606_measures__def,axiom,
    ! [B: $tType,Fs: list(fun(B,nat))] : ( measures(B,Fs) = inv_image(list(nat),B,lex(nat,less_than),aTP_Lamp_auu(list(fun(B,nat)),fun(B,list(nat)),Fs)) ) ).

% measures_def
tff(fact_5607_old_Orec__sum__def,axiom,
    ! [C: $tType,D: $tType,B: $tType,X4: fun(B,C),Xa3: fun(D,C),Xb3: sum_sum(B,D)] : ( sum_rec_sum(B,C,D,X4,Xa3,Xb3) = the(C,sum_rec_set_sum(B,C,D,X4,Xa3,Xb3)) ) ).

% old.rec_sum_def
tff(fact_5608_takeWhile__not__last,axiom,
    ! [B: $tType,Xs: list(B)] :
      ( distinct(B,Xs)
     => ( takeWhile(B,aTP_Lamp_auv(list(B),fun(B,$o),Xs),Xs) = butlast(B,Xs) ) ) ).

% takeWhile_not_last
tff(fact_5609_uncurry__def,axiom,
    ! [D: $tType,C: $tType,B: $tType,F2: fun(B,fun(C,D))] : ( uncurry(B,C,D,F2) = aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),F2) ) ).

% uncurry_def
tff(fact_5610_img__ord__def,axiom,
    ! [C: $tType,D: $tType,B: $tType,F2: fun(B,D),Ord: fun(D,fun(D,C)),X4: B,Xa3: B] : ( partial_img_ord(B,D,C,F2,Ord,X4,Xa3) = aa(D,C,aa(D,fun(D,C),Ord,aa(B,D,F2,X4)),aa(B,D,F2,Xa3)) ) ).

% img_ord_def
tff(fact_5611_mk__less__def,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),X4: B,Xa3: B] :
      ( partial_mk_less(B,R,X4,Xa3)
    <=> ( aa(B,$o,aa(B,fun(B,$o),R,X4),Xa3)
        & ~ aa(B,$o,aa(B,fun(B,$o),R,Xa3),X4) ) ) ).

% mk_less_def
tff(fact_5612_ID_Oin__rel,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),A4: B,B3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),bNF_id_bnf(fun(B,fun(C,$o)),R),A4),B3)
    <=> ? [Z5: product_prod(B,C)] :
          ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),Z5),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aTP_Lamp_auw(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),R)))
          & ( aa(product_prod(B,C),B,bNF_id_bnf(fun(product_prod(B,C),B),product_fst(B,C)),Z5) = A4 )
          & ( aa(product_prod(B,C),C,bNF_id_bnf(fun(product_prod(B,C),C),product_snd(B,C)),Z5) = B3 ) ) ) ).

% ID.in_rel
tff(fact_5613_is__num_Ocases,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [A4: B] :
          ( neg_numeral_is_num(B,A4)
         => ( ( A4 != one_one(B) )
           => ( ! [X: B] :
                  ( ( A4 = aa(B,B,uminus_uminus(B),X) )
                 => ~ neg_numeral_is_num(B,X) )
             => ~ ! [X: B,Y2: B] :
                    ( ( A4 = aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y2) )
                   => ( neg_numeral_is_num(B,X)
                     => ~ neg_numeral_is_num(B,Y2) ) ) ) ) ) ) ).

% is_num.cases
tff(fact_5614_pred__on_Osuc__Union__closed__empty,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,fun(B,$o))] : aa(set(set(B)),$o,member(set(B),bot_bot(set(B))),pred_s596693808085603175closed(B,A3,Pa)) ).

% pred_on.suc_Union_closed_empty
tff(fact_5615_ID_Omap__cong__pred,axiom,
    ! [C: $tType,B: $tType,X2: B,Ya2: B,F2: fun(B,C),G: fun(B,C)] :
      ( ( X2 = Ya2 )
     => ( aa(B,$o,bNF_id_bnf(fun(B,$o),aa(fun(B,C),fun(B,$o),aTP_Lamp_np(fun(B,C),fun(fun(B,C),fun(B,$o)),F2),G)),Ya2)
       => ( aa(B,C,bNF_id_bnf(fun(B,C),F2),X2) = aa(B,C,bNF_id_bnf(fun(B,C),G),Ya2) ) ) ) ).

% ID.map_cong_pred
tff(fact_5616_is__num__normalize_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => neg_numeral_is_num(B,one_one(B)) ) ).

% is_num_normalize(4)
tff(fact_5617_pred__on_Osuc__Union__closed__def,axiom,
    ! [B: $tType,A3: set(B),Pa: fun(B,fun(B,$o))] : ( pred_s596693808085603175closed(B,A3,Pa) = aa(fun(set(B),$o),set(set(B)),collect(set(B)),pred_s7749564232668923593losedp(B,A3,Pa)) ) ).

% pred_on.suc_Union_closed_def
tff(fact_5618_subset_Osuc__Union__closed__empty,axiom,
    ! [B: $tType,A3: set(set(B))] : aa(set(set(set(B))),$o,member(set(set(B)),bot_bot(set(set(B)))),pred_s596693808085603175closed(set(B),A3,ord_less(set(B)))) ).

% subset.suc_Union_closed_empty
tff(fact_5619_ID_Orel__cong,axiom,
    ! [B: $tType,C: $tType,X2: B,Ya2: B,Y: C,Xa: C,R: fun(B,fun(C,$o)),Ra2: fun(B,fun(C,$o))] :
      ( ( X2 = Ya2 )
     => ( ( Y = Xa )
       => ( ! [Z3: B,Yb: C] :
              ( aa(set(B),$o,member(B,Z3),aa(set(B),set(B),insert(B,Ya2),bot_bot(set(B))))
             => ( aa(set(C),$o,member(C,Yb),aa(set(C),set(C),insert(C,Xa),bot_bot(set(C))))
               => ( aa(C,$o,aa(B,fun(C,$o),R,Z3),Yb)
                <=> aa(C,$o,aa(B,fun(C,$o),Ra2,Z3),Yb) ) ) )
         => ( aa(C,$o,aa(B,fun(C,$o),bNF_id_bnf(fun(B,fun(C,$o)),R),X2),Y)
          <=> aa(C,$o,aa(B,fun(C,$o),bNF_id_bnf(fun(B,fun(C,$o)),Ra2),Ya2),Xa) ) ) ) ) ).

% ID.rel_cong
tff(fact_5620_ID_Orel__mono__strong,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),X2: B,Y: C,Ra2: fun(B,fun(C,$o))] :
      ( aa(C,$o,aa(B,fun(C,$o),bNF_id_bnf(fun(B,fun(C,$o)),R),X2),Y)
     => ( ! [Z3: B,Yb: C] :
            ( aa(set(B),$o,member(B,Z3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))
           => ( aa(set(C),$o,member(C,Yb),aa(set(C),set(C),insert(C,Y),bot_bot(set(C))))
             => ( aa(C,$o,aa(B,fun(C,$o),R,Z3),Yb)
               => aa(C,$o,aa(B,fun(C,$o),Ra2,Z3),Yb) ) ) )
       => aa(C,$o,aa(B,fun(C,$o),bNF_id_bnf(fun(B,fun(C,$o)),Ra2),X2),Y) ) ) ).

% ID.rel_mono_strong
tff(fact_5621_ID_Orel__refl__strong,axiom,
    ! [B: $tType,X2: B,Ra2: fun(B,fun(B,$o))] :
      ( ! [Z3: B] :
          ( aa(set(B),$o,member(B,Z3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))
         => aa(B,$o,aa(B,fun(B,$o),Ra2,Z3),Z3) )
     => aa(B,$o,aa(B,fun(B,$o),bNF_id_bnf(fun(B,fun(B,$o)),Ra2),X2),X2) ) ).

% ID.rel_refl_strong
tff(fact_5622_subset_Osuc__Union__closed__def,axiom,
    ! [B: $tType,A3: set(set(B))] : ( pred_s596693808085603175closed(set(B),A3,ord_less(set(B))) = aa(fun(set(set(B)),$o),set(set(set(B))),collect(set(set(B))),pred_s7749564232668923593losedp(set(B),A3,ord_less(set(B)))) ) ).

% subset.suc_Union_closed_def
tff(fact_5623_is__num_Osimps,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [A4: B] :
          ( neg_numeral_is_num(B,A4)
        <=> ( ( A4 = one_one(B) )
            | ? [X3: B] :
                ( ( A4 = aa(B,B,uminus_uminus(B),X3) )
                & neg_numeral_is_num(B,X3) )
            | ? [X3: B,Y4: B] :
                ( ( A4 = aa(B,B,aa(B,fun(B,B),plus_plus(B),X3),Y4) )
                & neg_numeral_is_num(B,X3)
                & neg_numeral_is_num(B,Y4) ) ) ) ) ).

% is_num.simps
tff(fact_5624_acyclicP__converse,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o))] :
      ( transitive_acyclic(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),conversep(B,B,R2))))
    <=> transitive_acyclic(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2))) ) ).

% acyclicP_converse
tff(fact_5625_typedef__to__part__equivp,axiom,
    ! [B: $tType,C: $tType,Rep: fun(B,C),Abs: fun(C,B),S: set(C)] :
      ( type_definition(B,C,Rep,Abs,S)
     => equiv_part_equivp(C,bNF_eq_onp(C,aTP_Lamp_nw(set(C),fun(C,$o),S))) ) ).

% typedef_to_part_equivp
tff(fact_5626_open__typedef__to__part__equivp,axiom,
    ! [B: $tType,C: $tType,Rep: fun(B,C),Abs: fun(C,B),Pa: fun(C,$o)] :
      ( type_definition(B,C,Rep,Abs,aa(fun(C,$o),set(C),collect(C),Pa))
     => equiv_part_equivp(C,bNF_eq_onp(C,Pa)) ) ).

% open_typedef_to_part_equivp
tff(fact_5627_acyclic__empty,axiom,
    ! [B: $tType] : transitive_acyclic(B,bot_bot(set(product_prod(B,B)))) ).

% acyclic_empty
tff(fact_5628_ID_Opred__True,axiom,
    ! [B: $tType,X4: B] : aa(B,$o,bNF_id_bnf(fun(B,$o),aTP_Lamp_nh(B,$o)),X4) ).

% ID.pred_True
tff(fact_5629_part__equivp__typedef,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o))] :
      ( equiv_part_equivp(B,R)
     => ? [D4: set(B)] : aa(set(set(B)),$o,member(set(B),D4),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_aux(fun(B,fun(B,$o)),fun(set(B),$o),R))) ) ).

% part_equivp_typedef
tff(fact_5630_ID_Opred__mono__strong,axiom,
    ! [B: $tType,Pa: fun(B,$o),X2: B,Paa: fun(B,$o)] :
      ( aa(B,$o,bNF_id_bnf(fun(B,$o),Pa),X2)
     => ( ! [Z3: B] :
            ( aa(set(B),$o,member(B,Z3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))
           => ( aa(B,$o,Pa,Z3)
             => aa(B,$o,Paa,Z3) ) )
       => aa(B,$o,bNF_id_bnf(fun(B,$o),Paa),X2) ) ) ).

% ID.pred_mono_strong
tff(fact_5631_ID_Opred__cong,axiom,
    ! [B: $tType,X2: B,Ya2: B,Pa: fun(B,$o),Paa: fun(B,$o)] :
      ( ( X2 = Ya2 )
     => ( ! [Z3: B] :
            ( aa(set(B),$o,member(B,Z3),aa(set(B),set(B),insert(B,Ya2),bot_bot(set(B))))
           => ( aa(B,$o,Pa,Z3)
            <=> aa(B,$o,Paa,Z3) ) )
       => ( aa(B,$o,bNF_id_bnf(fun(B,$o),Pa),X2)
        <=> aa(B,$o,bNF_id_bnf(fun(B,$o),Paa),Ya2) ) ) ) ).

% ID.pred_cong
tff(fact_5632_wfP__acyclicP,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o))] :
      ( wfP(B,R2)
     => transitive_acyclic(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2))) ) ).

% wfP_acyclicP
tff(fact_5633_ID_Opred__set,axiom,
    ! [B: $tType,Pa: fun(B,$o),X4: B] :
      ( aa(B,$o,bNF_id_bnf(fun(B,$o),Pa),X4)
    <=> ! [Xa2: B] :
          ( aa(set(B),$o,member(B,Xa2),aa(set(B),set(B),insert(B,X4),bot_bot(set(B))))
         => aa(B,$o,Pa,Xa2) ) ) ).

% ID.pred_set
tff(fact_5634_old_Orec__prod__def,axiom,
    ! [D: $tType,C: $tType,B: $tType,X4: fun(B,fun(C,D)),Xa3: product_prod(B,C)] : ( product_rec_prod(B,C,D,X4,Xa3) = the(D,product_rec_set_prod(B,C,D,X4,Xa3)) ) ).

% old.rec_prod_def
tff(fact_5635_snds__def,axiom,
    ! [C: $tType,B: $tType,X4: product_prod(B,C)] : ( basic_snds(B,C,X4) = aa(fun(C,$o),set(C),collect(C),basic_sndsp(B,C,X4)) ) ).

% snds_def
tff(fact_5636_nat__of__num__code_I3_J,axiom,
    ! [N: num] :
      ( nat_of_num(aa(num,num,bit1,N))
      = $let(
          m: nat,
          m := nat_of_num(N),
          aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),m),m)) ) ) ).

% nat_of_num_code(3)
tff(fact_5637_nat__of__num__code_I2_J,axiom,
    ! [N: num] :
      ( nat_of_num(aa(num,num,bit0,N))
      = $let(
          m: nat,
          m := nat_of_num(N),
          aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),m),m) ) ) ).

% nat_of_num_code(2)
tff(fact_5638_fsts__def,axiom,
    ! [C: $tType,B: $tType,X4: product_prod(B,C)] : ( aa(product_prod(B,C),set(B),basic_fsts(B,C),X4) = aa(fun(B,$o),set(B),collect(B),basic_fstsp(B,C,X4)) ) ).

% fsts_def
tff(fact_5639_inv__on__def,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),A3: set(B),X2: C] : ( inv_on(B,C,F2,A3,X2) = fChoice(B,aa(C,fun(B,$o),aa(set(B),fun(C,fun(B,$o)),aTP_Lamp_eo(fun(B,C),fun(set(B),fun(C,fun(B,$o))),F2),A3),X2)) ) ).

% inv_on_def
tff(fact_5640_pick__middlep__def,axiom,
    ! [C: $tType,B: $tType,D: $tType,Pa: fun(C,fun(B,$o)),Qa: fun(B,fun(D,$o)),A4: C,Ca: D] : ( bNF_pick_middlep(C,B,D,Pa,Qa,A4,Ca) = fChoice(B,aa(D,fun(B,$o),aa(C,fun(D,fun(B,$o)),aa(fun(B,fun(D,$o)),fun(C,fun(D,fun(B,$o))),aTP_Lamp_auy(fun(C,fun(B,$o)),fun(fun(B,fun(D,$o)),fun(C,fun(D,fun(B,$o)))),Pa),Qa),A4),Ca)) ) ).

% pick_middlep_def
tff(fact_5641_subset__mset_Osemilattice__order__axioms,axiom,
    ! [B: $tType] : semilattice_order(multiset(B),union_mset(B),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o)),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o))) ).

% subset_mset.semilattice_order_axioms
tff(fact_5642_max_Osemilattice__order__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semilattice_order(B,ord_max(B),aTP_Lamp_px(B,fun(B,$o)),aTP_Lamp_acf(B,fun(B,$o))) ) ).

% max.semilattice_order_axioms
tff(fact_5643_prod__mset__def,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ( comm_m9189036328036947845d_mset(B) = comm_monoid_F(B,times_times(B),one_one(B)) ) ) ).

% prod_mset_def
tff(fact_5644_semilattice__order_Omono,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,Ca: B,B3: B,D3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),Ca)
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B3),D3)
         => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),aa(B,B,aa(B,fun(B,B),F2,Ca),D3)) ) ) ) ).

% semilattice_order.mono
tff(fact_5645_semilattice__order_OorderE,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
       => ( A4 = aa(B,B,aa(B,fun(B,B),F2,A4),B3) ) ) ) ).

% semilattice_order.orderE
tff(fact_5646_semilattice__order_OorderI,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( ( A4 = aa(B,B,aa(B,fun(B,B),F2,A4),B3) )
       => aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3) ) ) ).

% semilattice_order.orderI
tff(fact_5647_semilattice__order_Oabsorb1,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
       => ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = A4 ) ) ) ).

% semilattice_order.absorb1
tff(fact_5648_semilattice__order_Oabsorb2,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),B3: B,A4: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B3),A4)
       => ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = B3 ) ) ) ).

% semilattice_order.absorb2
tff(fact_5649_semilattice__order_Oabsorb3,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A4),B3)
       => ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = A4 ) ) ) ).

% semilattice_order.absorb3
tff(fact_5650_semilattice__order_Oabsorb4,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),B3: B,A4: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,B3),A4)
       => ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = B3 ) ) ) ).

% semilattice_order.absorb4
tff(fact_5651_semilattice__order_OboundedE,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B,Ca: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),aa(B,B,aa(B,fun(B,B),F2,B3),Ca))
       => ~ ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
           => ~ aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),Ca) ) ) ) ).

% semilattice_order.boundedE
tff(fact_5652_semilattice__order_OboundedI,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B,Ca: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),Ca)
         => aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),aa(B,B,aa(B,fun(B,B),F2,B3),Ca)) ) ) ) ).

% semilattice_order.boundedI
tff(fact_5653_semilattice__order_Oorder__iff,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
      <=> ( A4 = aa(B,B,aa(B,fun(B,B),F2,A4),B3) ) ) ) ).

% semilattice_order.order_iff
tff(fact_5654_semilattice__order_Ocobounded1,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),A4) ) ).

% semilattice_order.cobounded1
tff(fact_5655_semilattice__order_Ocobounded2,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),B3) ) ).

% semilattice_order.cobounded2
tff(fact_5656_semilattice__order_Oabsorb__iff1,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
      <=> ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = A4 ) ) ) ).

% semilattice_order.absorb_iff1
tff(fact_5657_semilattice__order_Oabsorb__iff2,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),B3: B,A4: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B3),A4)
      <=> ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = B3 ) ) ) ).

% semilattice_order.absorb_iff2
tff(fact_5658_semilattice__order_Obounded__iff,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B,Ca: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),aa(B,B,aa(B,fun(B,B),F2,B3),Ca))
      <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
          & aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),Ca) ) ) ) ).

% semilattice_order.bounded_iff
tff(fact_5659_semilattice__order_OcoboundedI1,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,Ca: B,B3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),Ca)
       => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),Ca) ) ) ).

% semilattice_order.coboundedI1
tff(fact_5660_semilattice__order_OcoboundedI2,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),B3: B,Ca: B,A4: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B3),Ca)
       => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),Ca) ) ) ).

% semilattice_order.coboundedI2
tff(fact_5661_semilattice__order_Ostrict__boundedE,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B,Ca: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A4),aa(B,B,aa(B,fun(B,B),F2,B3),Ca))
       => ~ ( aa(B,$o,aa(B,fun(B,$o),Less,A4),B3)
           => ~ aa(B,$o,aa(B,fun(B,$o),Less,A4),Ca) ) ) ) ).

% semilattice_order.strict_boundedE
tff(fact_5662_semilattice__order_Ostrict__order__iff,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A4),B3)
      <=> ( ( A4 = aa(B,B,aa(B,fun(B,B),F2,A4),B3) )
          & ( A4 != B3 ) ) ) ) ).

% semilattice_order.strict_order_iff
tff(fact_5663_semilattice__order_Ostrict__coboundedI1,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,Ca: B,B3: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A4),Ca)
       => aa(B,$o,aa(B,fun(B,$o),Less,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),Ca) ) ) ).

% semilattice_order.strict_coboundedI1
tff(fact_5664_semilattice__order_Ostrict__coboundedI2,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),B3: B,Ca: B,A4: B] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,B3),Ca)
       => aa(B,$o,aa(B,fun(B,$o),Less,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),Ca) ) ) ).

% semilattice_order.strict_coboundedI2
tff(fact_5665_semilattice__neutr__order_Oaxioms_I2_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semila1105856199041335345_order(B,F2,Z2,Less_eq,Less)
     => semilattice_order(B,F2,Less_eq,Less) ) ).

% semilattice_neutr_order.axioms(2)
tff(fact_5666_gcd__nat_Osemilattice__order__axioms,axiom,
    semilattice_order(nat,gcd_gcd(nat),dvd_dvd(nat),aTP_Lamp_abk(nat,fun(nat,$o))) ).

% gcd_nat.semilattice_order_axioms
tff(fact_5667_semilattice__neutr__order_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semilattice_neutr(B,F2,Z2)
     => ( semilattice_order(B,F2,Less_eq,Less)
       => semila1105856199041335345_order(B,F2,Z2,Less_eq,Less) ) ) ).

% semilattice_neutr_order.intro
tff(fact_5668_semilattice__neutr__order__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semila1105856199041335345_order(B,F2,Z2,Less_eq,Less)
    <=> ( semilattice_neutr(B,F2,Z2)
        & semilattice_order(B,F2,Less_eq,Less) ) ) ).

% semilattice_neutr_order_def
tff(fact_5669_inf_Osemilattice__order__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => semilattice_order(B,inf_inf(B),ord_less_eq(B),ord_less(B)) ) ).

% inf.semilattice_order_axioms
tff(fact_5670_min_Osemilattice__order__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semilattice_order(B,ord_min(B),ord_less_eq(B),ord_less(B)) ) ).

% min.semilattice_order_axioms
tff(fact_5671_sup_Osemilattice__order__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => semilattice_order(B,sup_sup(B),aTP_Lamp_acg(B,fun(B,$o)),aTP_Lamp_ach(B,fun(B,$o))) ) ).

% sup.semilattice_order_axioms
tff(fact_5672_comm__monoid__mset_Oneutral__const,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: multiset(C)] :
      ( comm_monoid_mset(B,F2,Z2)
     => ( aa(multiset(B),B,comm_monoid_F(B,F2,Z2),aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_cy(B,fun(C,B)),Z2)),A3)) = Z2 ) ) ).

% comm_monoid_mset.neutral_const
tff(fact_5673_comm__monoid__mset_Odistrib,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(C,B),H2: fun(C,B),A3: multiset(C)] :
      ( comm_monoid_mset(B,F2,Z2)
     => ( aa(multiset(B),B,comm_monoid_F(B,F2,Z2),aa(multiset(C),multiset(B),image_mset(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_asa(fun(B,fun(B,B)),fun(fun(C,B),fun(fun(C,B),fun(C,B))),F2),G),H2)),A3)) = aa(B,B,aa(B,fun(B,B),F2,aa(multiset(B),B,comm_monoid_F(B,F2,Z2),aa(multiset(C),multiset(B),image_mset(C,B,G),A3))),aa(multiset(B),B,comm_monoid_F(B,F2,Z2),aa(multiset(C),multiset(B),image_mset(C,B,H2),A3))) ) ) ).

% comm_monoid_mset.distrib
tff(fact_5674_comm__monoid__mset_Oswap,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(B,fun(B,B)),Z2: B,G: fun(C,fun(D,B)),B2: multiset(D),A3: multiset(C)] :
      ( comm_monoid_mset(B,F2,Z2)
     => ( aa(multiset(B),B,comm_monoid_F(B,F2,Z2),aa(multiset(C),multiset(B),image_mset(C,B,aa(multiset(D),fun(C,B),aa(fun(C,fun(D,B)),fun(multiset(D),fun(C,B)),aa(B,fun(fun(C,fun(D,B)),fun(multiset(D),fun(C,B))),aTP_Lamp_auz(fun(B,fun(B,B)),fun(B,fun(fun(C,fun(D,B)),fun(multiset(D),fun(C,B)))),F2),Z2),G),B2)),A3)) = aa(multiset(B),B,comm_monoid_F(B,F2,Z2),aa(multiset(D),multiset(B),image_mset(D,B,aa(multiset(C),fun(D,B),aa(fun(C,fun(D,B)),fun(multiset(C),fun(D,B)),aa(B,fun(fun(C,fun(D,B)),fun(multiset(C),fun(D,B))),aTP_Lamp_ava(fun(B,fun(B,B)),fun(B,fun(fun(C,fun(D,B)),fun(multiset(C),fun(D,B)))),F2),Z2),G),A3)),B2)) ) ) ).

% comm_monoid_mset.swap
tff(fact_5675_comm__monoid__mset__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid_mset(B,F2,Z2)
    <=> comm_monoid(B,F2,Z2) ) ).

% comm_monoid_mset_def
tff(fact_5676_comm__monoid__mset_Oaxioms,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid_mset(B,F2,Z2)
     => comm_monoid(B,F2,Z2) ) ).

% comm_monoid_mset.axioms
tff(fact_5677_comm__monoid__mset_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid(B,F2,Z2)
     => comm_monoid_mset(B,F2,Z2) ) ).

% comm_monoid_mset.intro
tff(fact_5678_prod__mset_Ocomm__monoid__mset__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => comm_monoid_mset(B,times_times(B),one_one(B)) ) ).

% prod_mset.comm_monoid_mset_axioms
tff(fact_5679_bdd__below__primitive__def,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ( condit1013018076250108175_below(B) = condit16957441358409770ng_bdd(B,aTP_Lamp_avb(B,fun(B,$o))) ) ) ).

% bdd_below_primitive_def
tff(fact_5680_option_Osimps_I15_J,axiom,
    ! [B: $tType,X24: B] : ( set_option(B,aa(B,option(B),some(B),X24)) = aa(set(B),set(B),insert(B,X24),bot_bot(set(B))) ) ).

% option.simps(15)
tff(fact_5681_those_Osimps_I2_J,axiom,
    ! [B: $tType,X2: option(B),Xs: list(option(B))] : ( those(B,aa(list(option(B)),list(option(B)),aa(option(B),fun(list(option(B)),list(option(B))),cons(option(B)),X2),Xs)) = case_option(option(list(B)),B,none(list(B)),aTP_Lamp_avc(list(option(B)),fun(B,option(list(B))),Xs),X2) ) ).

% those.simps(2)
tff(fact_5682_set__empty__eq,axiom,
    ! [B: $tType,Xo: option(B)] :
      ( ( set_option(B,Xo) = bot_bot(set(B)) )
    <=> ( Xo = none(B) ) ) ).

% set_empty_eq
tff(fact_5683_option_Osimps_I14_J,axiom,
    ! [B: $tType] : ( set_option(B,none(B)) = bot_bot(set(B)) ) ).

% option.simps(14)
tff(fact_5684_subset__mset_Obdd__below__primitive__def,axiom,
    ! [B: $tType] : ( condit8119078960628432327_below(multiset(B),subseteq_mset(B)) = condit16957441358409770ng_bdd(multiset(B),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o))) ) ).

% subset_mset.bdd_below_primitive_def
tff(fact_5685_option_Orel__Grp,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,C)] : ( rel_option(B,C,bNF_Grp(B,C,A3,F2)) = bNF_Grp(option(B),option(C),aa(fun(option(B),$o),set(option(B)),collect(option(B)),aTP_Lamp_avd(set(B),fun(option(B),$o),A3)),map_option(B,C,F2)) ) ).

% option.rel_Grp
tff(fact_5686_option_Oin__rel,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),A4: option(B),B3: option(C)] :
      ( aa(option(C),$o,aa(option(B),fun(option(C),$o),rel_option(B,C,R),A4),B3)
    <=> ? [Z5: option(product_prod(B,C))] :
          ( aa(set(option(product_prod(B,C))),$o,member(option(product_prod(B,C)),Z5),aa(fun(option(product_prod(B,C)),$o),set(option(product_prod(B,C))),collect(option(product_prod(B,C))),aTP_Lamp_ave(fun(B,fun(C,$o)),fun(option(product_prod(B,C)),$o),R)))
          & ( aa(option(product_prod(B,C)),option(B),map_option(product_prod(B,C),B,product_fst(B,C)),Z5) = A4 )
          & ( aa(option(product_prod(B,C)),option(C),map_option(product_prod(B,C),C,product_snd(B,C)),Z5) = B3 ) ) ) ).

% option.in_rel
tff(fact_5687_option_Orel__compp__Grp,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] : ( rel_option(B,C,R) = aa(fun(option(product_prod(B,C)),fun(option(C),$o)),fun(option(B),fun(option(C),$o)),aa(fun(option(B),fun(option(product_prod(B,C)),$o)),fun(fun(option(product_prod(B,C)),fun(option(C),$o)),fun(option(B),fun(option(C),$o))),relcompp(option(B),option(product_prod(B,C)),option(C)),conversep(option(product_prod(B,C)),option(B),bNF_Grp(option(product_prod(B,C)),option(B),aa(fun(option(product_prod(B,C)),$o),set(option(product_prod(B,C))),collect(option(product_prod(B,C))),aTP_Lamp_ave(fun(B,fun(C,$o)),fun(option(product_prod(B,C)),$o),R)),map_option(product_prod(B,C),B,product_fst(B,C))))),bNF_Grp(option(product_prod(B,C)),option(C),aa(fun(option(product_prod(B,C)),$o),set(option(product_prod(B,C))),collect(option(product_prod(B,C))),aTP_Lamp_ave(fun(B,fun(C,$o)),fun(option(product_prod(B,C)),$o),R)),map_option(product_prod(B,C),C,product_snd(B,C)))) ) ).

% option.rel_compp_Grp
tff(fact_5688_rel__option__iff,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),X2: option(B),Y: option(C)] :
      ( aa(option(C),$o,aa(option(B),fun(option(C),$o),rel_option(B,C,R),X2),Y)
    <=> aa(product_prod(option(B),option(C)),$o,aa(fun(option(B),fun(option(C),$o)),fun(product_prod(option(B),option(C)),$o),product_case_prod(option(B),option(C),$o),aTP_Lamp_avh(fun(B,fun(C,$o)),fun(option(B),fun(option(C),$o)),R)),aa(option(C),product_prod(option(B),option(C)),aa(option(B),fun(option(C),product_prod(option(B),option(C))),product_Pair(option(B),option(C)),X2),Y)) ) ).

% rel_option_iff
tff(fact_5689_option_Orel__map_I2_J,axiom,
    ! [B: $tType,C: $tType,D: $tType,Sa: fun(B,fun(C,$o)),X2: option(B),G: fun(D,C),Y: option(D)] :
      ( aa(option(C),$o,aa(option(B),fun(option(C),$o),rel_option(B,C,Sa),X2),aa(option(D),option(C),map_option(D,C,G),Y))
    <=> aa(option(D),$o,aa(option(B),fun(option(D),$o),rel_option(B,D,aa(fun(D,C),fun(B,fun(D,$o)),aTP_Lamp_aod(fun(B,fun(C,$o)),fun(fun(D,C),fun(B,fun(D,$o))),Sa),G)),X2),Y) ) ).

% option.rel_map(2)
tff(fact_5690_option_Orel__map_I1_J,axiom,
    ! [D: $tType,B: $tType,C: $tType,Sb: fun(B,fun(C,$o)),I2: fun(D,B),X2: option(D),Y: option(C)] :
      ( aa(option(C),$o,aa(option(B),fun(option(C),$o),rel_option(B,C,Sb),aa(option(D),option(B),map_option(D,B,I2),X2)),Y)
    <=> aa(option(C),$o,aa(option(D),fun(option(C),$o),rel_option(D,C,aa(fun(D,B),fun(D,fun(C,$o)),aTP_Lamp_aoe(fun(B,fun(C,$o)),fun(fun(D,B),fun(D,fun(C,$o))),Sb),I2)),X2),Y) ) ).

% option.rel_map(1)
tff(fact_5691_option_Odisc__transfer_I2_J,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o))] : aa(fun(option(C),$o),$o,aa(fun(option(B),$o),fun(fun(option(C),$o),$o),bNF_rel_fun(option(B),option(C),$o,$o,rel_option(B,C,R),fequal($o)),aTP_Lamp_avi(option(B),$o)),aTP_Lamp_avj(option(C),$o)) ).

% option.disc_transfer(2)
tff(fact_5692_option_Odisc__transfer_I1_J,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o))] : aa(fun(option(C),$o),$o,aa(fun(option(B),$o),fun(fun(option(C),$o),$o),bNF_rel_fun(option(B),option(C),$o,$o,rel_option(B,C,R),fequal($o)),aTP_Lamp_avk(option(B),$o)),aTP_Lamp_avl(option(C),$o)) ).

% option.disc_transfer(1)
tff(fact_5693_rel__option__inf,axiom,
    ! [C: $tType,B: $tType,A3: fun(B,fun(C,$o)),B2: fun(B,fun(C,$o))] : ( aa(fun(option(B),fun(option(C),$o)),fun(option(B),fun(option(C),$o)),aa(fun(option(B),fun(option(C),$o)),fun(fun(option(B),fun(option(C),$o)),fun(option(B),fun(option(C),$o))),inf_inf(fun(option(B),fun(option(C),$o))),rel_option(B,C,A3)),rel_option(B,C,B2)) = rel_option(B,C,aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),A3),B2)) ) ).

% rel_option_inf
tff(fact_5694_preordering__bdd_OInt1,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: set(B),B2: set(B)] :
      ( condit622319405099724424ng_bdd(B,Less_eq,Less)
     => ( aa(set(B),$o,condit16957441358409770ng_bdd(B,Less_eq),A3)
       => aa(set(B),$o,condit16957441358409770ng_bdd(B,Less_eq),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ) ).

% preordering_bdd.Int1
tff(fact_5695_preordering__bdd_OInt2,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),B2: set(B),A3: set(B)] :
      ( condit622319405099724424ng_bdd(B,Less_eq,Less)
     => ( aa(set(B),$o,condit16957441358409770ng_bdd(B,Less_eq),B2)
       => aa(set(B),$o,condit16957441358409770ng_bdd(B,Less_eq),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B2)) ) ) ).

% preordering_bdd.Int2
tff(fact_5696_numeral__sqr,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [K: num] : ( aa(num,B,numeral_numeral(B),sqr(K)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),K)),aa(num,B,numeral_numeral(B),K)) ) ) ).

% numeral_sqr
tff(fact_5697_subset__mset_Obdd__below_Opreordering__bdd__axioms,axiom,
    ! [B: $tType] : condit622319405099724424ng_bdd(multiset(B),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o)),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o))) ).

% subset_mset.bdd_below.preordering_bdd_axioms
tff(fact_5698_preordering__bdd_Oempty,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( condit622319405099724424ng_bdd(B,Less_eq,Less)
     => aa(set(B),$o,condit16957441358409770ng_bdd(B,Less_eq),bot_bot(set(B))) ) ).

% preordering_bdd.empty
tff(fact_5699_bdd__below_Opreordering__bdd__axioms,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => condit622319405099724424ng_bdd(B,aTP_Lamp_avb(B,fun(B,$o)),aTP_Lamp_aaa(B,fun(B,$o))) ) ).

% bdd_below.preordering_bdd_axioms
tff(fact_5700_in__range_Osimps,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
    <=> ! [X3: nat] :
          ( aa(set(nat),$o,member(nat,X3),As2)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),lim(product_unit,H2)) ) ) ).

% in_range.simps
tff(fact_5701_in__range_Oelims_I1_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X2)
      <=> (Y) )
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ( (Y)
            <=> ~ ! [X3: nat] :
                    ( aa(set(nat),$o,member(nat,X3),As)
                   => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),lim(product_unit,H4)) ) ) ) ) ).

% in_range.elims(1)
tff(fact_5702_in__range_Oelims_I2_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X2)
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ~ ! [X4: nat] :
                  ( aa(set(nat),$o,member(nat,X4),As)
                 => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X4),lim(product_unit,H4)) ) ) ) ).

% in_range.elims(2)
tff(fact_5703_in__range_Oelims_I3_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X2)
     => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
            ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
           => ! [X: nat] :
                ( aa(set(nat),$o,member(nat,X),As)
               => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),lim(product_unit,H4)) ) ) ) ).

% in_range.elims(3)
tff(fact_5704_new__addrs__def,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat),H5: heap_ext(product_unit)] : ( hoare_new_addrs(H2,As2,H5) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),aa(fun(nat,$o),set(nat),collect(nat),aa(heap_ext(product_unit),fun(nat,$o),aTP_Lamp_avm(heap_ext(product_unit),fun(heap_ext(product_unit),fun(nat,$o)),H2),H5))) ) ).

% new_addrs_def
tff(fact_5705_hoare__tripleE,axiom,
    ! [B: $tType,Pa: assn,Ca: heap_Time_Heap(B),Qa: fun(B,assn),H2: heap_ext(product_unit),As2: set(nat)] :
      ( hoare_hoare_triple(B,Pa,Ca,Qa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
       => ~ ! [R3: B,H3: heap_ext(product_unit)] :
              ( ? [T6: nat] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(B,Ca),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H3),T6))) )
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Qa,R3)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),hoare_new_addrs(H2,As2,H3)))
               => ( relH(aa(fun(nat,$o),set(nat),collect(nat),aa(set(nat),fun(nat,$o),aTP_Lamp_avn(heap_ext(product_unit),fun(set(nat),fun(nat,$o)),H2),As2)),H2,H3)
                 => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),lim(product_unit,H2)),lim(product_unit,H3)) ) ) ) ) ) ).

% hoare_tripleE
tff(fact_5706_hoare__tripleI,axiom,
    ! [B: $tType,Pa: assn,Ca: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( ! [H4: heap_ext(product_unit),As: set(nat)] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
         => ? [R8: B,H6: heap_ext(product_unit),T7: nat] :
              ( ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(B,Ca),H4) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R8),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H6),T7))) )
              & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Qa,R8)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H6),hoare_new_addrs(H4,As,H6)))
              & relH(aa(fun(nat,$o),set(nat),collect(nat),aa(set(nat),fun(nat,$o),aTP_Lamp_avn(heap_ext(product_unit),fun(set(nat),fun(nat,$o)),H4),As)),H4,H6)
              & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),lim(product_unit,H4)),lim(product_unit,H6)) ) )
     => hoare_hoare_triple(B,Pa,Ca,Qa) ) ).

% hoare_tripleI
tff(fact_5707_new__addr__refl,axiom,
    ! [H2: heap_ext(product_unit),As2: set(nat)] : ( hoare_new_addrs(H2,As2,H2) = As2 ) ).

% new_addr_refl
tff(fact_5708_hoare__triple__def,axiom,
    ! [B: $tType,Pa: assn,Ca: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( hoare_hoare_triple(B,Pa,Ca,Qa)
    <=> ! [H: heap_ext(product_unit),As7: set(nat)] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As7))
         => ? [R6: B,H7: heap_ext(product_unit)] :
              ( ? [T8: nat] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(B,Ca),H) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R6),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H7),T8))) )
              & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Qa,R6)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),hoare_new_addrs(H,As7,H7)))
              & relH(aa(fun(nat,$o),set(nat),collect(nat),aa(set(nat),fun(nat,$o),aTP_Lamp_avn(heap_ext(product_unit),fun(set(nat),fun(nat,$o)),H),As7)),H,H7)
              & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),lim(product_unit,H)),lim(product_unit,H7)) ) ) ) ).

% hoare_triple_def
tff(fact_5709_execute__ureturn,axiom,
    ! [B: $tType,X2: B] : ( heap_Time_execute(B,heap_Time_ureturn(B,X2)) = aa(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),comp(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit),some(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_avo(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),X2)) ) ).

% execute_ureturn
tff(fact_5710_execute__return,axiom,
    ! [B: $tType,X2: B] : ( heap_Time_execute(B,aa(B,heap_Time_Heap(B),heap_Time_return(B),X2)) = aa(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),comp(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit),some(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_avp(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),X2)) ) ).

% execute_return
tff(fact_5711_hoare__triple__effect,axiom,
    ! [B: $tType,Pa: assn,Ca: heap_Time_Heap(B),Qa: fun(B,assn),H2: heap_ext(product_unit),As2: set(nat)] :
      ( hoare_hoare_triple(B,Pa,Ca,Qa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
       => ? [H3: heap_ext(product_unit),R3: B,T6: nat] :
            ( heap_Time_effect(B,Ca,H2,H3,R3,T6)
            & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Qa,R3)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),hoare_new_addrs(H2,As2,H3))) ) ) ) ).

% hoare_triple_effect
tff(fact_5712_effect__LetI,axiom,
    ! [C: $tType,B: $tType,X2: B,T3: B,F2: fun(B,heap_Time_Heap(C)),H2: heap_ext(product_unit),H5: heap_ext(product_unit),R2: C,N: nat] :
      ( ( X2 = T3 )
     => ( heap_Time_effect(C,aa(B,heap_Time_Heap(C),F2,X2),H2,H5,R2,N)
       => heap_Time_effect(C,aa(B,heap_Time_Heap(C),F2,T3),H2,H5,R2,N) ) ) ).

% effect_LetI
tff(fact_5713_ureturn__def,axiom,
    ! [B: $tType,X2: B] : ( heap_Time_ureturn(B,X2) = heap_Time_heap(B,aTP_Lamp_avo(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),X2)) ) ).

% ureturn_def
tff(fact_5714_return__def,axiom,
    ! [B: $tType,X2: B] : ( aa(B,heap_Time_Heap(B),heap_Time_return(B),X2) = heap_Time_heap(B,aTP_Lamp_avp(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),X2)) ) ).

% return_def
tff(fact_5715_sngr__assn__raw_Oelims_I3_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X2,Xa),Xb)
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ( ( ref_get(B,H4,X2) = Xa )
                  & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(B,X2)),bot_bot(set(nat))) )
                  & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_ref(B,X2)),lim(product_unit,H4)) ) ) ) ) ).

% sngr_assn_raw.elims(3)
tff(fact_5716_relH__ref,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit),R2: ref(B)] :
          ( relH(As2,H2,H5)
         => ( aa(set(nat),$o,member(nat,addr_of_ref(B,R2)),As2)
           => ( ref_get(B,H2,R2) = ref_get(B,H5,R2) ) ) ) ) ).

% relH_ref
tff(fact_5717_sngr__assn__raw_Osimps,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R2: ref(B),X2: B,H2: heap_ext(product_unit),As2: set(nat)] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,R2,X2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
        <=> ( ( ref_get(B,H2,R2) = X2 )
            & ( As2 = aa(set(nat),set(nat),insert(nat,addr_of_ref(B,R2)),bot_bot(set(nat))) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_ref(B,R2)),lim(product_unit,H2)) ) ) ) ).

% sngr_assn_raw.simps
tff(fact_5718_sngr__assn__raw_Oelims_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
          ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X2,Xa),Xb)
          <=> (Y) )
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ( (Y)
                <=> ~ ( ( ref_get(B,H4,X2) = Xa )
                      & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(B,X2)),bot_bot(set(nat))) )
                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_ref(B,X2)),lim(product_unit,H4)) ) ) ) ) ) ).

% sngr_assn_raw.elims(1)
tff(fact_5719_sngr__assn__raw_Oelims_I2_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X2,Xa),Xb)
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ~ ( ( ref_get(B,H4,X2) = Xa )
                    & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(B,X2)),bot_bot(set(nat))) )
                    & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_ref(B,X2)),lim(product_unit,H4)) ) ) ) ) ).

% sngr_assn_raw.elims(2)
tff(fact_5720_sngr__assn__raw_Opelims_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
          ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X2,Xa),Xb)
          <=> (Y) )
         => ( aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( ( (Y)
                    <=> ( ( ref_get(B,H4,X2) = Xa )
                        & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(B,X2)),bot_bot(set(nat))) )
                        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_ref(B,X2)),lim(product_unit,H4)) ) )
                   => ~ aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))) ) ) ) ) ) ).

% sngr_assn_raw.pelims(1)
tff(fact_5721_sngr__assn__raw_Opelims_I2_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X2,Xa),Xb)
         => ( aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))
                   => ~ ( ( ref_get(B,H4,X2) = Xa )
                        & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(B,X2)),bot_bot(set(nat))) )
                        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_ref(B,X2)),lim(product_unit,H4)) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(2)
tff(fact_5722_sngr__assn__raw_Opelims_I3_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X2,Xa),Xb)
         => ( aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))
                   => ( ( ref_get(B,H4,X2) = Xa )
                      & ( As = aa(set(nat),set(nat),insert(nat,addr_of_ref(B,X2)),bot_bot(set(nat))) )
                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_ref(B,X2)),lim(product_unit,H4)) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(3)
tff(fact_5723_relH__set__ref,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R2: ref(B),As2: set(nat),H2: heap_ext(product_unit),X2: B] :
          ( ~ aa(set(nat),$o,member(nat,addr_of_ref(B,R2)),As2)
         => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
           => relH(As2,H2,aa(heap_ext(product_unit),heap_ext(product_unit),ref_set(B,R2,X2),H2)) ) ) ) ).

% relH_set_ref
tff(fact_5724_snga__assn__raw_Oelims_I3_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X2,Xa),Xb)
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ( ( array_get(B,H4,X2) = Xa )
                  & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(B,X2)),bot_bot(set(nat))) )
                  & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X2)),lim(product_unit,H4)) ) ) ) ) ).

% snga_assn_raw.elims(3)
tff(fact_5725_snga__assn__raw_Oelims_I2_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X2,Xa),Xb)
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ~ ( ( array_get(B,H4,X2) = Xa )
                    & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(B,X2)),bot_bot(set(nat))) )
                    & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X2)),lim(product_unit,H4)) ) ) ) ) ).

% snga_assn_raw.elims(2)
tff(fact_5726_relH__array,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit),R2: array(B)] :
          ( relH(As2,H2,H5)
         => ( aa(set(nat),$o,member(nat,addr_of_array(B,R2)),As2)
           => ( array_get(B,H2,R2) = array_get(B,H5,R2) ) ) ) ) ).

% relH_array
tff(fact_5727_snga__assn__raw_Osimps,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R2: array(B),X2: list(B),H2: heap_ext(product_unit),As2: set(nat)] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,R2,X2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
        <=> ( ( array_get(B,H2,R2) = X2 )
            & ( As2 = aa(set(nat),set(nat),insert(nat,addr_of_array(B,R2)),bot_bot(set(nat))) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,R2)),lim(product_unit,H2)) ) ) ) ).

% snga_assn_raw.simps
tff(fact_5728_snga__assn__raw_Oelims_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
          ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X2,Xa),Xb)
          <=> (Y) )
         => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
               => ( (Y)
                <=> ~ ( ( array_get(B,H4,X2) = Xa )
                      & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(B,X2)),bot_bot(set(nat))) )
                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X2)),lim(product_unit,H4)) ) ) ) ) ) ).

% snga_assn_raw.elims(1)
tff(fact_5729_snga__assn__raw_Opelims_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
          ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X2,Xa),Xb)
          <=> (Y) )
         => ( aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( ( (Y)
                    <=> ( ( array_get(B,H4,X2) = Xa )
                        & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(B,X2)),bot_bot(set(nat))) )
                        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X2)),lim(product_unit,H4)) ) )
                   => ~ aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))) ) ) ) ) ) ).

% snga_assn_raw.pelims(1)
tff(fact_5730_snga__assn__raw_Opelims_I2_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X2,Xa),Xb)
         => ( aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))
                   => ~ ( ( array_get(B,H4,X2) = Xa )
                        & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(B,X2)),bot_bot(set(nat))) )
                        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X2)),lim(product_unit,H4)) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(2)
tff(fact_5731_snga__assn__raw_Opelims_I3_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X2,Xa),Xb)
         => ( aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
                 => ( aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))))
                   => ( ( array_get(B,H4,X2) = Xa )
                      & ( As = aa(set(nat),set(nat),insert(nat,addr_of_array(B,X2)),bot_bot(set(nat))) )
                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X2)),lim(product_unit,H4)) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(3)
tff(fact_5732_relH__set__array,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R2: array(B),As2: set(nat),H2: heap_ext(product_unit),X2: list(B)] :
          ( ~ aa(set(nat),$o,member(nat,addr_of_array(B,R2)),As2)
         => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
           => relH(As2,H2,aa(heap_ext(product_unit),heap_ext(product_unit),array_set(B,R2,X2),H2)) ) ) ) ).

% relH_set_array
tff(fact_5733_execute__make,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [N: nat,F2: fun(nat,B),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),heap_Time_execute(array(B),array_make(B,N,F2)),H2) = aa(product_prod(array(B),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avq(nat,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),N)),array_alloc(B,aa(list(nat),list(B),map(nat,B,F2),upt(zero_zero(nat),N)),H2))) ) ) ).

% execute_make
tff(fact_5734_Array__Time_Omake__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [N: nat,F2: fun(nat,B)] : ( array_make(B,N,F2) = heap_Time_heap(array(B),aa(fun(nat,B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avr(nat,fun(fun(nat,B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),N),F2)) ) ) ).

% Array_Time.make_def
tff(fact_5735_execute__of__list,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Xs: list(B),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),heap_Time_execute(array(B),array_of_list(B,Xs)),H2) = aa(product_prod(array(B),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avs(list(B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Xs)),array_alloc(B,Xs,H2))) ) ) ).

% execute_of_list
tff(fact_5736_execute__new,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [N: nat,X2: B,H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),heap_Time_execute(array(B),array_new(B,N,X2)),H2) = aa(product_prod(array(B),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avq(nat,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),N)),array_alloc(B,replicate(B,N,X2),H2))) ) ) ).

% execute_new
tff(fact_5737_of__list__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Xs: list(B)] : ( array_of_list(B,Xs) = heap_Time_heap(array(B),aTP_Lamp_avt(list(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),Xs)) ) ) ).

% of_list_def
tff(fact_5738_array__make,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [N: nat,X2: B] : ( array_new(B,N,X2) = array_make(B,N,aTP_Lamp_avu(B,fun(nat,B),X2)) ) ) ).

% array_make
tff(fact_5739_array__of__list__make,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Xs: list(B)] : ( array_of_list(B,Xs) = array_make(B,aa(list(B),nat,size_size(list(B)),Xs),nth(B,Xs)) ) ) ).

% array_of_list_make
tff(fact_5740_new__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [N: nat,X2: B] : ( array_new(B,N,X2) = heap_Time_heap(array(B),aa(B,fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avv(nat,fun(B,fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),N),X2)) ) ) ).

% new_def
tff(fact_5741_Array__Time_Oalloc__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Xs: list(B),H2: heap_ext(product_unit)] :
          ( array_alloc(B,Xs,H2)
          = $let(
              l: nat,
              l := lim(product_unit,H2),
              $let(
                r: array(B),
                r := array2(B,l),
                aa(heap_ext(product_unit),product_prod(array(B),heap_ext(product_unit)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),heap_ext(product_unit))),product_Pair(array(B),heap_ext(product_unit)),r),aa(heap_ext(product_unit),heap_ext(product_unit),array_set(B,r,Xs),lim_update(product_unit,aTP_Lamp_avw(nat,fun(nat,nat),l),H2))) ) ) ) ) ).

% Array_Time.alloc_def
tff(fact_5742_freeze__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A4: array(B)] : ( array_freeze(B,A4) = heap_Time_heap(list(B),aTP_Lamp_avx(array(B),fun(heap_ext(product_unit),product_prod(list(B),product_prod(heap_ext(product_unit),nat))),A4)) ) ) ).

% freeze_def
tff(fact_5743_trancl__def,axiom,
    ! [B: $tType,X4: set(product_prod(B,B))] : ( transitive_trancl(B,X4) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),transitive_tranclp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),X4)))) ) ).

% trancl_def
tff(fact_5744_less__nat__rel,axiom,
    ord_less(nat) = transitive_tranclp(nat,aTP_Lamp_ww(nat,fun(nat,$o))) ).

% less_nat_rel
tff(fact_5745_tranclp__trancl__eq,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),X4: B,Xa3: B] :
      ( aa(B,$o,aa(B,fun(B,$o),transitive_tranclp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2)),X4),Xa3)
    <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa3)),transitive_trancl(B,R2)) ) ).

% tranclp_trancl_eq
tff(fact_5746_tranclp__def,axiom,
    ! [B: $tType,X4: fun(B,fun(B,$o))] : ( transitive_tranclp(B,X4) = complete_lattice_lfp(fun(B,fun(B,$o)),aTP_Lamp_kv(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),X4)) ) ).

% tranclp_def
tff(fact_5747_Nitpick_Otranclp__unfold,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( aa(B,$o,aa(B,fun(B,$o),transitive_tranclp(B,R2),A4),B3)
    <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A4),B3)),transitive_trancl(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2)))) ) ).

% Nitpick.tranclp_unfold
tff(fact_5748_Array__Time_Onth__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A4: array(B),I2: nat] : ( array_nth(B,A4,I2) = heap_Time_guard(B,aa(nat,fun(heap_ext(product_unit),$o),aTP_Lamp_avy(array(B),fun(nat,fun(heap_ext(product_unit),$o)),A4),I2),aa(nat,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avz(array(B),fun(nat,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))),A4),I2)) ) ) ).

% Array_Time.nth_def
tff(fact_5749_swap__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I2: nat,X2: B,A4: array(B)] : ( array_swap(B,I2,X2,A4) = heap_Time_guard(B,aa(array(B),fun(heap_ext(product_unit),$o),aTP_Lamp_awa(nat,fun(array(B),fun(heap_ext(product_unit),$o)),I2),A4),aa(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(B,fun(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awb(nat,fun(B,fun(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))))),I2),X2),A4)) ) ) ).

% swap_def
tff(fact_5750_map__entry__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I2: nat,F2: fun(B,B),A4: array(B)] : ( array_map_entry(B,I2,F2,A4) = heap_Time_guard(array(B),aa(array(B),fun(heap_ext(product_unit),$o),aTP_Lamp_awa(nat,fun(array(B),fun(heap_ext(product_unit),$o)),I2),A4),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(fun(B,B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awc(nat,fun(fun(B,B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))))),I2),F2),A4)) ) ) ).

% map_entry_def
tff(fact_5751_upd__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I2: nat,X2: B,A4: array(B)] : ( array_upd(B,I2,X2,A4) = heap_Time_guard(array(B),aa(array(B),fun(heap_ext(product_unit),$o),aTP_Lamp_awa(nat,fun(array(B),fun(heap_ext(product_unit),$o)),I2),A4),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(B,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awd(nat,fun(B,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))))),I2),X2),A4)) ) ) ).

% upd_def
tff(fact_5752_reflp__refl__eq,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( reflp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2))
    <=> refl_on(B,top_top(set(B)),R2) ) ).

% reflp_refl_eq
tff(fact_5753_reflp__inf,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),S2: fun(B,fun(B,$o))] :
      ( reflp(B,R2)
     => ( reflp(B,S2)
       => reflp(B,aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),inf_inf(fun(B,fun(B,$o))),R2),S2)) ) ) ).

% reflp_inf
tff(fact_5754_Quotient__id__abs__transfer,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(B,$o)),Abs: fun(B,C),Rep: fun(C,B),T2: fun(B,fun(C,$o))] :
      ( quotient(B,C,R,Abs,Rep,T2)
     => ( reflp(B,R)
       => aa(fun(B,C),$o,aa(fun(B,B),fun(fun(B,C),$o),bNF_rel_fun(B,B,B,C,fequal(B),T2),aTP_Lamp_bk(B,B)),Abs) ) ) ).

% Quotient_id_abs_transfer
tff(fact_5755_sub_Otransfer,axiom,
    aa(fun(num,fun(num,code_integer)),$o,aa(fun(num,fun(num,int)),fun(fun(num,fun(num,code_integer)),$o),bNF_rel_fun(num,num,fun(num,int),fun(num,code_integer),fequal(num),bNF_rel_fun(num,num,int,code_integer,fequal(num),code_pcr_integer)),aTP_Lamp_xx(num,fun(num,int))),code_sub) ).

% sub.transfer
tff(fact_5756_image2p__def,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,F2: fun(D,B),G: fun(E,C),R: fun(D,fun(E,$o)),X4: B,Xa3: C] :
      ( bNF_Greatest_image2p(D,B,E,C,F2,G,R,X4,Xa3)
    <=> ? [X8: D,Y8: E] :
          ( aa(E,$o,aa(D,fun(E,$o),R,X8),Y8)
          & ( aa(D,B,F2,X8) = X4 )
          & ( aa(E,C,G,Y8) = Xa3 ) ) ) ).

% image2p_def
tff(fact_5757_rtranclp__imp__Sup__relpowp,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o)),X2: B,Y: B] :
      ( aa(B,$o,aa(B,fun(B,$o),transitive_rtranclp(B,Pa),X2),Y)
     => aa(B,$o,aa(B,fun(B,$o),aa(set(fun(B,fun(B,$o))),fun(B,fun(B,$o)),complete_Sup_Sup(fun(B,fun(B,$o))),aa(set(nat),set(fun(B,fun(B,$o))),image2(nat,fun(B,fun(B,$o)),aTP_Lamp_awe(fun(B,fun(B,$o)),fun(nat,fun(B,fun(B,$o))),Pa)),top_top(set(nat)))),X2),Y) ) ).

% rtranclp_imp_Sup_relpowp
tff(fact_5758_rtranclp__r__diff__Id,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o))] : ( transitive_rtranclp(B,aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),inf_inf(fun(B,fun(B,$o))),R2),aTP_Lamp_adk(B,fun(B,$o)))) = transitive_rtranclp(B,R2) ) ).

% rtranclp_r_diff_Id
tff(fact_5759_integer_Oid__abs__transfer,axiom,
    aa(fun(int,code_integer),$o,aa(fun(int,int),fun(fun(int,code_integer),$o),bNF_rel_fun(int,int,int,code_integer,fequal(int),code_pcr_integer),aTP_Lamp_rw(int,int)),code_integer_of_int) ).

% integer.id_abs_transfer
tff(fact_5760_integer_Orep__transfer,axiom,
    aa(fun(code_integer,int),$o,aa(fun(int,int),fun(fun(code_integer,int),$o),bNF_rel_fun(int,code_integer,int,int,code_pcr_integer,fequal(int)),aTP_Lamp_rw(int,int)),code_int_of_integer) ).

% integer.rep_transfer
tff(fact_5761_Transitive__Closure_Ortranclp__rtrancl__eq,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),X4: B,Xa3: B] :
      ( aa(B,$o,aa(B,fun(B,$o),transitive_rtranclp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2)),X4),Xa3)
    <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa3)),transitive_rtrancl(B,R2)) ) ).

% Transitive_Closure.rtranclp_rtrancl_eq
tff(fact_5762_dup_Otransfer,axiom,
    aa(fun(code_integer,code_integer),$o,aa(fun(int,int),fun(fun(code_integer,code_integer),$o),bNF_rel_fun(int,code_integer,int,code_integer,code_pcr_integer,code_pcr_integer),aTP_Lamp_yl(int,int)),code_dup) ).

% dup.transfer
tff(fact_5763_rtranclp__def,axiom,
    ! [B: $tType,X4: fun(B,fun(B,$o))] : ( transitive_rtranclp(B,X4) = complete_lattice_lfp(fun(B,fun(B,$o)),aTP_Lamp_ku(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),X4)) ) ).

% rtranclp_def
tff(fact_5764_rtrancl__def,axiom,
    ! [B: $tType,X4: set(product_prod(B,B))] : ( transitive_rtrancl(B,X4) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),transitive_rtranclp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),X4)))) ) ).

% rtrancl_def
tff(fact_5765_Enum_Ortranclp__rtrancl__eq,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),X2: B,Y: B] :
      ( aa(B,$o,aa(B,fun(B,$o),transitive_rtranclp(B,R2),X2),Y)
    <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y)),transitive_rtrancl(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2)))) ) ).

% Enum.rtranclp_rtrancl_eq
tff(fact_5766_rtranclp__is__Sup__relpowp,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o))] : ( transitive_rtranclp(B,Pa) = aa(set(fun(B,fun(B,$o))),fun(B,fun(B,$o)),complete_Sup_Sup(fun(B,fun(B,$o))),aa(set(nat),set(fun(B,fun(B,$o))),image2(nat,fun(B,fun(B,$o)),aTP_Lamp_awe(fun(B,fun(B,$o)),fun(nat,fun(B,fun(B,$o))),Pa)),top_top(set(nat)))) ) ).

% rtranclp_is_Sup_relpowp
tff(fact_5767_old_Orec__bool__def,axiom,
    ! [B: $tType,X4: B,Xa3: B,Xb3: $o] : ( product_rec_bool(B,X4,Xa3,Xb3) = the(B,product_rec_set_bool(B,X4,Xa3,Xb3)) ) ).

% old.rec_bool_def
tff(fact_5768_Ref__Time_Oalloc__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X2: B,H2: heap_ext(product_unit)] :
          ( ref_alloc(B,X2,H2)
          = $let(
              l: nat,
              l := lim(product_unit,H2),
              $let(
                r: ref(B),
                r := ref2(B,l),
                aa(heap_ext(product_unit),product_prod(ref(B),heap_ext(product_unit)),aa(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),heap_ext(product_unit))),product_Pair(ref(B),heap_ext(product_unit)),r),aa(heap_ext(product_unit),heap_ext(product_unit),ref_set(B,r,X2),lim_update(product_unit,aTP_Lamp_avw(nat,fun(nat,nat),l),H2))) ) ) ) ) ).

% Ref_Time.alloc_def
tff(fact_5769_sum__encode__def,axiom,
    ! [X2: sum_sum(nat,nat)] : ( nat_sum_encode(X2) = aa(sum_sum(nat,nat),nat,sum_case_sum(nat,nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aTP_Lamp_awf(nat,nat)),X2) ) ).

% sum_encode_def
tff(fact_5770_case__sum__KK,axiom,
    ! [B: $tType,C: $tType,D: $tType,A4: D,X4: sum_sum(B,C)] : ( aa(sum_sum(B,C),D,sum_case_sum(B,D,C,aTP_Lamp_awg(D,fun(B,D),A4),aTP_Lamp_awh(D,fun(C,D),A4)),X4) = A4 ) ).

% case_sum_KK
tff(fact_5771_disjE__realizer,axiom,
    ! [D: $tType,C: $tType,B: $tType,Pa: fun(B,$o),Qa: fun(C,$o),X2: sum_sum(B,C),R: fun(D,$o),F2: fun(B,D),G: fun(C,D)] :
      ( aa(sum_sum(B,C),$o,sum_case_sum(B,$o,C,Pa,Qa),X2)
     => ( ! [P5: B] :
            ( aa(B,$o,Pa,P5)
           => aa(D,$o,R,aa(B,D,F2,P5)) )
       => ( ! [Q5: C] :
              ( aa(C,$o,Qa,Q5)
             => aa(D,$o,R,aa(C,D,G,Q5)) )
         => aa(D,$o,R,aa(sum_sum(B,C),D,sum_case_sum(B,D,C,F2,G),X2)) ) ) ) ).

% disjE_realizer
tff(fact_5772_sum_Ocase__distrib,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,H2: fun(C,B),F1: fun(D,C),F22: fun(E,C),Sum: sum_sum(D,E)] : ( aa(C,B,H2,aa(sum_sum(D,E),C,sum_case_sum(D,C,E,F1,F22),Sum)) = aa(sum_sum(D,E),B,sum_case_sum(D,B,E,aa(fun(D,C),fun(D,B),aTP_Lamp_cc(fun(C,B),fun(fun(D,C),fun(D,B)),H2),F1),aa(fun(E,C),fun(E,B),aTP_Lamp_awi(fun(C,B),fun(fun(E,C),fun(E,B)),H2),F22)),Sum) ) ).

% sum.case_distrib
tff(fact_5773_execute__ref,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [V: B,H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),heap_Time_execute(ref(B),ref_ref(B,V)),H2) = aa(product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),option(product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),some(product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),aa(product_prod(ref(B),heap_ext(product_unit)),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),aa(fun(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(ref(B),heap_ext(product_unit)),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(ref(B),heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_awj(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))))),ref_alloc(B,V,H2))) ) ) ).

% execute_ref
tff(fact_5774_ref__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [V: B] : ( ref_ref(B,V) = heap_Time_heap(ref(B),aTP_Lamp_awk(B,fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),V)) ) ) ).

% ref_def
tff(fact_5775_projr__def,axiom,
    ! [B: $tType,C: $tType,Sum: sum_sum(C,B)] : ( sum_projr(C,B,Sum) = aa(sum_sum(C,B),B,sum_case_sum(C,B,B,aTP_Lamp_awl(C,B),aTP_Lamp_bk(B,B)),Sum) ) ).

% projr_def
tff(fact_5776_projl__def,axiom,
    ! [C: $tType,B: $tType,Sum: sum_sum(B,C)] : ( sum_projl(B,C,Sum) = aa(sum_sum(B,C),B,sum_case_sum(B,B,C,aTP_Lamp_bk(B,B),aTP_Lamp_awl(C,B)),Sum) ) ).

% projl_def
tff(fact_5777_laz__weak__Pb,axiom,
    ! [B: $tType,C: $tType,Pa: fun(C,$o),A3: list(B),B2: list(C)] :
      ( list_all_zip(B,C,aTP_Lamp_qv(fun(C,$o),fun(B,fun(C,$o)),Pa),A3,B2)
    <=> ( ( aa(list(B),nat,size_size(list(B)),A3) = aa(list(C),nat,size_size(list(C)),B2) )
        & ! [X3: C] :
            ( aa(set(C),$o,member(C,X3),aa(list(C),set(C),set2(C),B2))
           => aa(C,$o,Pa,X3) ) ) ) ).

% laz_weak_Pb
tff(fact_5778_laz__weak__Pa,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),A3: list(B),B2: list(C)] :
      ( list_all_zip(B,C,aTP_Lamp_awm(fun(B,$o),fun(B,fun(C,$o)),Pa),A3,B2)
    <=> ( ( aa(list(B),nat,size_size(list(B)),A3) = aa(list(C),nat,size_size(list(C)),B2) )
        & ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),aa(list(B),set(B),set2(B),A3))
           => aa(B,$o,Pa,X3) ) ) ) ).

% laz_weak_Pa
tff(fact_5779_laz__conj,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,fun(C,$o)),Qa: fun(B,fun(C,$o)),A4: list(B),B3: list(C)] :
      ( list_all_zip(B,C,aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aTP_Lamp_awn(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),Pa),Qa),A4,B3)
    <=> ( list_all_zip(B,C,Pa,A4,B3)
        & list_all_zip(B,C,Qa,A4,B3) ) ) ).

% laz_conj
tff(fact_5780_laz__swap__ex,axiom,
    ! [C: $tType,B: $tType,D: $tType,Pa: fun(B,fun(C,fun(D,$o))),A3: list(B),B2: list(C)] :
      ( list_all_zip(B,C,aTP_Lamp_awo(fun(B,fun(C,fun(D,$o))),fun(B,fun(C,$o)),Pa),A3,B2)
     => ~ ! [C5: list(D)] :
            ( list_all_zip(B,D,aTP_Lamp_awp(fun(B,fun(C,fun(D,$o))),fun(B,fun(D,$o)),Pa),A3,C5)
           => ~ list_all_zip(C,D,aTP_Lamp_awq(fun(B,fun(C,fun(D,$o))),fun(C,fun(D,$o)),Pa),B2,C5) ) ) ).

% laz_swap_ex
tff(fact_5781_list__all__zip__map1,axiom,
    ! [D: $tType,B: $tType,C: $tType,Pa: fun(B,fun(C,$o)),F2: fun(D,B),As2: list(D),Bs: list(C)] :
      ( list_all_zip(B,C,Pa,aa(list(D),list(B),map(D,B,F2),As2),Bs)
    <=> list_all_zip(D,C,aa(fun(D,B),fun(D,fun(C,$o)),aTP_Lamp_aoe(fun(B,fun(C,$o)),fun(fun(D,B),fun(D,fun(C,$o))),Pa),F2),As2,Bs) ) ).

% list_all_zip_map1
tff(fact_5782_list__all__zip__map2,axiom,
    ! [B: $tType,C: $tType,D: $tType,Pa: fun(B,fun(C,$o)),As2: list(B),F2: fun(D,C),Bs: list(D)] :
      ( list_all_zip(B,C,Pa,As2,aa(list(D),list(C),map(D,C,F2),Bs))
    <=> list_all_zip(B,D,aa(fun(D,C),fun(B,fun(D,$o)),aTP_Lamp_aod(fun(B,fun(C,$o)),fun(fun(D,C),fun(B,fun(D,$o))),Pa),F2),As2,Bs) ) ).

% list_all_zip_map2
tff(fact_5783_option_Orec__o__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,G: C,Ga: fun(D,C),F2: fun(B,D)] : ( aa(fun(option(B),option(D)),fun(option(B),C),comp(option(D),C,option(B),rec_option(C,D,G,Ga)),map_option(B,D,F2)) = rec_option(C,B,G,aa(fun(B,D),fun(B,C),aTP_Lamp_awr(fun(D,C),fun(fun(B,D),fun(B,C)),Ga),F2)) ) ).

% option.rec_o_map
tff(fact_5784_tap__def,axiom,
    ! [B: $tType,F2: fun(heap_ext(product_unit),B)] : ( heap_Time_tap(B,F2) = heap_Time_Heap2(B,aTP_Lamp_aws(fun(heap_ext(product_unit),B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),F2)) ) ).

% tap_def
tff(fact_5785_ordering__top_Oaxioms_I2_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ordering_top_axioms(B,Less_eq,Top) ) ).

% ordering_top.axioms(2)
tff(fact_5786_ordering__top__axioms__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Top: B] :
      ( ordering_top_axioms(B,Less_eq,Top)
    <=> ! [A6: B] : aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),Top) ) ).

% ordering_top_axioms_def
tff(fact_5787_ordering__top__axioms_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Top: B] :
      ( ! [A5: B] : aa(B,$o,aa(B,fun(B,$o),Less_eq,A5),Top)
     => ordering_top_axioms(B,Less_eq,Top) ) ).

% ordering_top_axioms.intro
tff(fact_5788_guard__def,axiom,
    ! [B: $tType,Pa: fun(heap_ext(product_unit),$o),F2: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))] : ( heap_Time_guard(B,Pa,F2) = heap_Time_Heap2(B,aa(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awt(fun(heap_ext(product_unit),$o),fun(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Pa),F2)) ) ).

% guard_def
tff(fact_5789_lookup__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R2: ref(B)] : ( ref_lookup(B,R2) = heap_Time_tap(B,aTP_Lamp_awu(ref(B),fun(heap_ext(product_unit),B),R2)) ) ) ).

% lookup_def
tff(fact_5790_ordering__top_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B] :
      ( ordering(B,Less_eq,Less)
     => ( ordering_top_axioms(B,Less_eq,Top)
       => ordering_top(B,Less_eq,Less,Top) ) ) ).

% ordering_top.intro
tff(fact_5791_ordering__top__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B] :
      ( ordering_top(B,Less_eq,Less,Top)
    <=> ( ordering(B,Less_eq,Less)
        & ordering_top_axioms(B,Less_eq,Top) ) ) ).

% ordering_top_def
tff(fact_5792_ordering__top_Oaxioms_I1_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ordering(B,Less_eq,Less) ) ).

% ordering_top.axioms(1)
tff(fact_5793_ordering_Oeq__iff,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( ordering(B,Less_eq,Less)
     => ( ( A4 = B3 )
      <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
          & aa(B,$o,aa(B,fun(B,$o),Less_eq,B3),A4) ) ) ) ).

% ordering.eq_iff
tff(fact_5794_ordering_Oantisym,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( ordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B3),A4)
         => ( A4 = B3 ) ) ) ) ).

% ordering.antisym
tff(fact_5795_ordering_Oorder__iff__strict,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( ordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
      <=> ( aa(B,$o,aa(B,fun(B,$o),Less,A4),B3)
          | ( A4 = B3 ) ) ) ) ).

% ordering.order_iff_strict
tff(fact_5796_ordering_Ostrict__iff__order,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( ordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A4),B3)
      <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
          & ( A4 != B3 ) ) ) ) ).

% ordering.strict_iff_order
tff(fact_5797_ordering_Ostrict__implies__not__eq,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( ordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A4),B3)
       => ( A4 != B3 ) ) ) ).

% ordering.strict_implies_not_eq
tff(fact_5798_ordering_Onot__eq__order__implies__strict,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( ordering(B,Less_eq,Less)
     => ( ( A4 != B3 )
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
         => aa(B,$o,aa(B,fun(B,$o),Less,A4),B3) ) ) ) ).

% ordering.not_eq_order_implies_strict
tff(fact_5799_ordering__strictI,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ! [A5: B,B4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A5),B4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),Less,A5),B4)
            | ( A5 = B4 ) ) )
     => ( ! [A5: B,B4: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less,A5),B4)
           => ~ aa(B,$o,aa(B,fun(B,$o),Less,B4),A5) )
       => ( ! [A5: B] : ~ aa(B,$o,aa(B,fun(B,$o),Less,A5),A5)
         => ( ! [A5: B,B4: B,C3: B] :
                ( aa(B,$o,aa(B,fun(B,$o),Less,A5),B4)
               => ( aa(B,$o,aa(B,fun(B,$o),Less,B4),C3)
                 => aa(B,$o,aa(B,fun(B,$o),Less,A5),C3) ) )
           => ordering(B,Less_eq,Less) ) ) ) ) ).

% ordering_strictI
tff(fact_5800_ordering__dualI,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ordering(B,aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Less_eq),aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Less))
     => ordering(B,Less_eq,Less) ) ).

% ordering_dualI
tff(fact_5801_gcd__nat_Oordering__axioms,axiom,
    ordering(nat,dvd_dvd(nat),aTP_Lamp_abk(nat,fun(nat,$o))) ).

% gcd_nat.ordering_axioms
tff(fact_5802_order_Oordering__axioms,axiom,
    ! [B: $tType] :
      ( order(B)
     => ordering(B,ord_less_eq(B),ord_less(B)) ) ).

% order.ordering_axioms
tff(fact_5803_dual__order_Oordering__axioms,axiom,
    ! [B: $tType] :
      ( order(B)
     => ordering(B,aTP_Lamp_awv(B,fun(B,$o)),aTP_Lamp_aww(B,fun(B,$o))) ) ).

% dual_order.ordering_axioms
tff(fact_5804_subset__mset_Odual__order_Oordering__axioms,axiom,
    ! [B: $tType] : ordering(multiset(B),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o)),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o))) ).

% subset_mset.dual_order.ordering_axioms
tff(fact_5805_raise__def,axiom,
    ! [B: $tType,S2: list(char)] : ( heap_Time_raise(B,S2) = heap_Time_Heap2(B,aTP_Lamp_awx(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))) ) ).

% raise_def
tff(fact_5806_Heap__lub__empty,axiom,
    ! [B: $tType] : ( aa(set(heap_Time_Heap(B)),heap_Time_Heap(B),heap_Time_Heap_lub(B),bot_bot(set(heap_Time_Heap(B)))) = heap_Time_Heap2(B,aTP_Lamp_awx(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))) ) ).

% Heap_lub_empty
tff(fact_5807_len__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A4: array(B)] : ( array_len(B,A4) = heap_Time_tap(nat,aTP_Lamp_awy(array(B),fun(heap_ext(product_unit),nat),A4)) ) ) ).

% len_def
tff(fact_5808_len_H__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1(B)
        & heap(C) )
     => ! [A4: array(C)] : ( array_len2(C,B,A4) = heap_Time_bind(nat,B,array_len(C,A4),aTP_Lamp_awz(nat,heap_Time_Heap(B))) ) ) ).

% len'_def
tff(fact_5809_Heap_Oset,axiom,
    ! [B: $tType,X2: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] : ( heap_Time_set_Heap(B,heap_Time_Heap2(B,X2)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),set(set(B)),image2(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(B),aTP_Lamp_axa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(B))),aa(set(heap_ext(product_unit)),set(option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),image2(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),X2),top_top(set(heap_ext(product_unit)))))) ) ).

% Heap.set
tff(fact_5810_Range__Int__subset,axiom,
    ! [B: $tType,C: $tType,A3: set(product_prod(C,B)),B2: set(product_prod(C,B))] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(product_prod(C,B)),set(B),range2(C,B),aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),set(product_prod(C,B))),inf_inf(set(product_prod(C,B))),A3),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(product_prod(C,B)),set(B),range2(C,B),A3)),aa(set(product_prod(C,B)),set(B),range2(C,B),B2))) ).

% Range_Int_subset
tff(fact_5811_Heap__Time__Monad_Obind__bind,axiom,
    ! [D: $tType,B: $tType,C: $tType,F2: heap_Time_Heap(D),G: fun(D,heap_Time_Heap(C)),K: fun(C,heap_Time_Heap(B))] : ( heap_Time_bind(C,B,heap_Time_bind(D,C,F2,G),K) = heap_Time_bind(D,B,F2,aa(fun(C,heap_Time_Heap(B)),fun(D,heap_Time_Heap(B)),aTP_Lamp_axb(fun(D,heap_Time_Heap(C)),fun(fun(C,heap_Time_Heap(B)),fun(D,heap_Time_Heap(B))),G),K)) ) ).

% Heap_Time_Monad.bind_bind
tff(fact_5812_Range__empty,axiom,
    ! [C: $tType,B: $tType] : ( aa(set(product_prod(C,B)),set(B),range2(C,B),bot_bot(set(product_prod(C,B)))) = bot_bot(set(B)) ) ).

% Range_empty
tff(fact_5813_Range__Collect__case__prod,axiom,
    ! [B: $tType,C: $tType,Pa: fun(C,fun(B,$o))] : ( aa(set(product_prod(C,B)),set(B),range2(C,B),aa(fun(product_prod(C,B),$o),set(product_prod(C,B)),collect(product_prod(C,B)),aa(fun(C,fun(B,$o)),fun(product_prod(C,B),$o),product_case_prod(C,B,$o),Pa))) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_axc(fun(C,fun(B,$o)),fun(B,$o),Pa)) ) ).

% Range_Collect_case_prod
tff(fact_5814_distrib__if__bind,axiom,
    ! [B: $tType,C: $tType,B3: $o,Ca: heap_Time_Heap(C),D3: heap_Time_Heap(C),F2: fun(C,heap_Time_Heap(B))] :
      ( heap_Time_bind(C,B,$ite((B3),Ca,D3),F2)
      = $ite((B3),heap_Time_bind(C,B,Ca,F2),heap_Time_bind(C,B,D3,F2)) ) ).

% distrib_if_bind
tff(fact_5815_Range__empty__iff,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(C,B))] :
      ( ( aa(set(product_prod(C,B)),set(B),range2(C,B),R2) = bot_bot(set(B)) )
    <=> ( R2 = bot_bot(set(product_prod(C,B))) ) ) ).

% Range_empty_iff
tff(fact_5816_Range__Union,axiom,
    ! [B: $tType,C: $tType,S: set(set(product_prod(C,B)))] : ( aa(set(product_prod(C,B)),set(B),range2(C,B),aa(set(set(product_prod(C,B))),set(product_prod(C,B)),complete_Sup_Sup(set(product_prod(C,B))),S)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(product_prod(C,B))),set(set(B)),image2(set(product_prod(C,B)),set(B),range2(C,B)),S)) ) ).

% Range_Union
tff(fact_5817_Range__def,axiom,
    ! [C: $tType,B: $tType,X4: set(product_prod(B,C))] : ( aa(set(product_prod(B,C)),set(C),range2(B,C),X4) = aa(fun(C,$o),set(C),collect(C),rangep(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),X4))) ) ).

% Range_def
tff(fact_5818_Rangep__Range__eq,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(C,B)),X4: B] :
      ( aa(B,$o,rangep(C,B,aTP_Lamp_jo(set(product_prod(C,B)),fun(C,fun(B,$o)),R2)),X4)
    <=> aa(set(B),$o,member(B,X4),aa(set(product_prod(C,B)),set(B),range2(C,B),R2)) ) ).

% Rangep_Range_eq
tff(fact_5819_lookup__chain,axiom,
    ! [C: $tType,B: $tType] :
      ( heap(C)
     => ! [R2: ref(C),F2: heap_Time_Heap(B)] : ( heap_Time_bind(C,B,ref_lookup(C,R2),aTP_Lamp_axd(heap_Time_Heap(B),fun(C,heap_Time_Heap(B)),F2)) = heap_Time_bind(product_unit,B,heap_Time_wait(one_one(nat)),aTP_Lamp_axe(heap_Time_Heap(B),fun(product_unit,heap_Time_Heap(B)),F2)) ) ) ).

% lookup_chain
tff(fact_5820_bind__return,axiom,
    ! [B: $tType,F2: heap_Time_Heap(B)] : ( heap_Time_bind(B,B,F2,heap_Time_return(B)) = heap_Time_bind(product_unit,B,heap_Time_wait(one_one(nat)),aTP_Lamp_axe(heap_Time_Heap(B),fun(product_unit,heap_Time_Heap(B)),F2)) ) ).

% bind_return
tff(fact_5821_return__bind,axiom,
    ! [B: $tType,C: $tType,X2: C,F2: fun(C,heap_Time_Heap(B))] : ( heap_Time_bind(C,B,aa(C,heap_Time_Heap(C),heap_Time_return(C),X2),F2) = heap_Time_bind(product_unit,B,heap_Time_wait(one_one(nat)),aa(fun(C,heap_Time_Heap(B)),fun(product_unit,heap_Time_Heap(B)),aTP_Lamp_axf(C,fun(fun(C,heap_Time_Heap(B)),fun(product_unit,heap_Time_Heap(B))),X2),F2)) ) ).

% return_bind
tff(fact_5822_upd__ureturn,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I2: nat,X2: B,A4: array(B)] : ( heap_Time_bind(array(B),array(B),array_upd(B,I2,X2,A4),aTP_Lamp_axg(array(B),fun(array(B),heap_Time_Heap(array(B))),A4)) = array_upd(B,I2,X2,A4) ) ) ).

% upd_ureturn
tff(fact_5823_bind__lift,axiom,
    ! [B: $tType,C: $tType,F2: heap_Time_Heap(C),G: fun(C,B)] : ( heap_Time_bind(C,B,F2,heap_Time_lift(C,B,G)) = heap_Time_bind(C,B,F2,aTP_Lamp_axh(fun(C,B),fun(C,heap_Time_Heap(B)),G)) ) ).

% bind_lift
tff(fact_5824_Heap__Time__Monad_Obind__def,axiom,
    ! [B: $tType,C: $tType,F2: heap_Time_Heap(C),G: fun(C,heap_Time_Heap(B))] : ( heap_Time_bind(C,B,F2,G) = heap_Time_Heap2(B,aa(fun(C,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_axk(heap_Time_Heap(C),fun(fun(C,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),F2),G)) ) ).

% Heap_Time_Monad.bind_def
tff(fact_5825_wf__UN,axiom,
    ! [C: $tType,B: $tType,I: set(B),R2: fun(B,set(product_prod(C,C)))] :
      ( ! [I3: B] :
          ( aa(set(B),$o,member(B,I3),I)
         => wf(C,aa(B,set(product_prod(C,C)),R2,I3)) )
     => ( ! [I3: B,J3: B] :
            ( aa(set(B),$o,member(B,I3),I)
           => ( aa(set(B),$o,member(B,J3),I)
             => ( ( aa(B,set(product_prod(C,C)),R2,I3) != aa(B,set(product_prod(C,C)),R2,J3) )
               => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(product_prod(C,C)),set(C),domain(C,C),aa(B,set(product_prod(C,C)),R2,I3))),aa(set(product_prod(C,C)),set(C),range2(C,C),aa(B,set(product_prod(C,C)),R2,J3))) = bot_bot(set(C)) ) ) ) )
       => wf(C,aa(set(set(product_prod(C,C))),set(product_prod(C,C)),complete_Sup_Sup(set(product_prod(C,C))),aa(set(B),set(set(product_prod(C,C))),image2(B,set(product_prod(C,C)),R2),I))) ) ) ).

% wf_UN
tff(fact_5826_Domain__empty,axiom,
    ! [C: $tType,B: $tType] : ( aa(set(product_prod(B,C)),set(B),domain(B,C),bot_bot(set(product_prod(B,C)))) = bot_bot(set(B)) ) ).

% Domain_empty
tff(fact_5827_Domain__Collect__case__prod,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o))] : ( aa(set(product_prod(B,C)),set(B),domain(B,C),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Pa))) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_gv(fun(B,fun(C,$o)),fun(B,$o),Pa)) ) ).

% Domain_Collect_case_prod
tff(fact_5828_dom__ran__disj__comp,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(product_prod(B,B)),set(B),domain(B,B),R)),aa(set(product_prod(B,B)),set(B),range2(B,B),R)) = bot_bot(set(B)) )
     => ( relcomp(B,B,B,R,R) = bot_bot(set(product_prod(B,B))) ) ) ).

% dom_ran_disj_comp
tff(fact_5829_Domain__empty__iff,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,C))] :
      ( ( aa(set(product_prod(B,C)),set(B),domain(B,C),R2) = bot_bot(set(B)) )
    <=> ( R2 = bot_bot(set(product_prod(B,C))) ) ) ).

% Domain_empty_iff
tff(fact_5830_Domain__unfold,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,C))] : ( aa(set(product_prod(B,C)),set(B),domain(B,C),R2) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_axl(set(product_prod(B,C)),fun(B,$o),R2)) ) ).

% Domain_unfold
tff(fact_5831_Domainp__Domain__eq,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(B,C)),X4: B] :
      ( aa(B,$o,aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),R2)),X4)
    <=> aa(set(B),$o,member(B,X4),aa(set(product_prod(B,C)),set(B),domain(B,C),R2)) ) ).

% Domainp_Domain_eq
tff(fact_5832_Domain__def,axiom,
    ! [C: $tType,B: $tType,X4: set(product_prod(B,C))] : ( aa(set(product_prod(B,C)),set(B),domain(B,C),X4) = aa(fun(B,$o),set(B),collect(B),aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),X4))) ) ).

% Domain_def
tff(fact_5833_Domain__Int__subset,axiom,
    ! [C: $tType,B: $tType,A3: set(product_prod(B,C)),B2: set(product_prod(B,C))] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(product_prod(B,C)),set(B),domain(B,C),aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),A3),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(product_prod(B,C)),set(B),domain(B,C),A3)),aa(set(product_prod(B,C)),set(B),domain(B,C),B2))) ).

% Domain_Int_subset
tff(fact_5834_wf__no__path,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(product_prod(B,B)),set(B),domain(B,B),R)),aa(set(product_prod(B,B)),set(B),range2(B,B),R)) = bot_bot(set(B)) )
     => wf(B,R) ) ).

% wf_no_path
tff(fact_5835_wf__min,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( wf(B,R)
     => ( ( R != bot_bot(set(product_prod(B,B))) )
       => ~ ! [M3: B] : ~ aa(set(B),$o,member(B,M3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(product_prod(B,B)),set(B),domain(B,B),R)),aa(set(product_prod(B,B)),set(B),range2(B,B),R))) ) ) ).

% wf_min
tff(fact_5836_Domain__Union,axiom,
    ! [C: $tType,B: $tType,S: set(set(product_prod(B,C)))] : ( aa(set(product_prod(B,C)),set(B),domain(B,C),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),S)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(product_prod(B,C))),set(set(B)),image2(set(product_prod(B,C)),set(B),domain(B,C)),S)) ) ).

% Domain_Union
tff(fact_5837_wf__Un,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),S2: set(product_prod(B,B))] :
      ( wf(B,R2)
     => ( wf(B,S2)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(product_prod(B,B)),set(B),domain(B,B),R2)),aa(set(product_prod(B,B)),set(B),range2(B,B),S2)) = bot_bot(set(B)) )
         => wf(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),R2),S2)) ) ) ) ).

% wf_Un
tff(fact_5838_wf__Union,axiom,
    ! [B: $tType,R: set(set(product_prod(B,B)))] :
      ( ! [X: set(product_prod(B,B))] :
          ( aa(set(set(product_prod(B,B))),$o,member(set(product_prod(B,B)),X),R)
         => wf(B,X) )
     => ( ! [X: set(product_prod(B,B))] :
            ( aa(set(set(product_prod(B,B))),$o,member(set(product_prod(B,B)),X),R)
           => ! [Xa4: set(product_prod(B,B))] :
                ( aa(set(set(product_prod(B,B))),$o,member(set(product_prod(B,B)),Xa4),R)
               => ( ( X != Xa4 )
                 => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(product_prod(B,B)),set(B),domain(B,B),X)),aa(set(product_prod(B,B)),set(B),range2(B,B),Xa4)) = bot_bot(set(B)) ) ) ) )
       => wf(B,aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),R)) ) ) ).

% wf_Union
tff(fact_5839_wf__max,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( wf(B,converse(B,B,R))
     => ( ( R != bot_bot(set(product_prod(B,B))) )
       => ~ ! [M3: B] : ~ aa(set(B),$o,member(B,M3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(product_prod(B,B)),set(B),range2(B,B),R)),aa(set(product_prod(B,B)),set(B),domain(B,B),R))) ) ) ).

% wf_max
tff(fact_5840_execute__bind__case,axiom,
    ! [B: $tType,C: $tType,F2: heap_Time_Heap(C),G: fun(C,heap_Time_Heap(B)),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(B,heap_Time_bind(C,B,F2,G)),H2) = case_option(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(C,product_prod(heap_ext(product_unit),nat)),none(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(C,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),product_case_prod(C,product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_axj(fun(C,heap_Time_Heap(B)),fun(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),G)),aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(C,F2),H2)) ) ).

% execute_bind_case
tff(fact_5841_change__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [F2: fun(B,B),R2: ref(B)] : ( ref_change(B,F2,R2) = heap_Time_bind(B,B,ref_lookup(B,R2),aa(ref(B),fun(B,heap_Time_Heap(B)),aTP_Lamp_axn(fun(B,B),fun(ref(B),fun(B,heap_Time_Heap(B))),F2),R2)) ) ) ).

% change_def
tff(fact_5842_wait__def,axiom,
    ! [N: nat] : ( heap_Time_wait(N) = heap_Time_Heap2(product_unit,aTP_Lamp_axo(nat,fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),N)) ) ).

% wait_def
tff(fact_5843_rec__natural__def,axiom,
    ! [B: $tType,X4: B,Xa3: fun(code_natural,fun(B,B)),Xb3: code_natural] : ( aa(code_natural,B,code_rec_natural(B,X4,Xa3),Xb3) = the(B,code_rec_set_natural(B,X4,Xa3,Xb3)) ) ).

% rec_natural_def
tff(fact_5844_unit__abs__eta__conv,axiom,
    ! [B: $tType,F2: fun(product_unit,B)] : ( aTP_Lamp_axp(fun(product_unit,B),fun(product_unit,B),F2) = F2 ) ).

% unit_abs_eta_conv
tff(fact_5845_UNIV__unit,axiom,
    top_top(set(product_unit)) = aa(set(product_unit),set(product_unit),insert(product_unit,product_Unity),bot_bot(set(product_unit))) ).

% UNIV_unit
tff(fact_5846_inf__unit__def,axiom,
    ! [Uu: product_unit,Uv: product_unit] : ( aa(product_unit,product_unit,aa(product_unit,fun(product_unit,product_unit),inf_inf(product_unit),Uu),Uv) = product_Unity ) ).

% inf_unit_def
tff(fact_5847_bot__unit__def,axiom,
    bot_bot(product_unit) = product_Unity ).

% bot_unit_def
tff(fact_5848_Ref__Time_Oupdate__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R2: ref(B),V: B] : ( ref_update(B,R2,V) = heap_Time_heap(product_unit,aa(B,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_axq(ref(B),fun(B,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),R2),V)) ) ) ).

% Ref_Time.update_def
tff(fact_5849_upd_H__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A4: array(B),I2: code_integer,X2: B] : ( array_upd2(B,A4,I2,X2) = heap_Time_bind(array(B),product_unit,array_upd(B,code_nat_of_integer(I2),X2,A4),aTP_Lamp_axr(array(B),heap_Time_Heap(product_unit))) ) ) ).

% upd'_def
tff(fact_5850_case__natural__def,axiom,
    ! [B: $tType,X4: B,Xa3: fun(code_natural,B)] : ( code_case_natural(B,X4,Xa3) = code_rec_natural(B,X4,aTP_Lamp_axs(fun(code_natural,B),fun(code_natural,fun(B,B)),Xa3)) ) ).

% case_natural_def
tff(fact_5851_cone__def,axiom,
    bNF_Cardinal_cone = bNF_Ca6860139660246222851ard_of(product_unit,aa(set(product_unit),set(product_unit),insert(product_unit,product_Unity),bot_bot(set(product_unit)))) ).

% cone_def
tff(fact_5852_next_Osimps,axiom,
    ! [V: code_natural,W2: code_natural] :
      ( aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),V),W2))
      = $let(
          v: code_natural,
          v := minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,V,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),divide_divide(code_natural),V),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,one2)))))))))))))))),
          $let(
            w2: code_natural,
            w2 := minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,W2,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),divide_divide(code_natural),W2),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,one2)))))))))))))),
            aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),v,aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),w2),one_one(code_natural)))),one_one(code_natural))),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),v),w2)) ) ) ) ).

% next.simps
tff(fact_5853_Abs__int__cases,axiom,
    ! [X2: int] :
      ~ ! [Y2: set(product_prod(nat,nat))] :
          ( ( X2 = aa(set(product_prod(nat,nat)),int,abs_int,Y2) )
         => ~ aa(set(set(product_prod(nat,nat))),$o,member(set(product_prod(nat,nat)),Y2),aa(fun(set(product_prod(nat,nat)),$o),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axt(set(product_prod(nat,nat)),$o))) ) ).

% Abs_int_cases
tff(fact_5854_Abs__int__inject,axiom,
    ! [X2: set(product_prod(nat,nat)),Y: set(product_prod(nat,nat))] :
      ( aa(set(set(product_prod(nat,nat))),$o,member(set(product_prod(nat,nat)),X2),aa(fun(set(product_prod(nat,nat)),$o),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axt(set(product_prod(nat,nat)),$o)))
     => ( aa(set(set(product_prod(nat,nat))),$o,member(set(product_prod(nat,nat)),Y),aa(fun(set(product_prod(nat,nat)),$o),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axt(set(product_prod(nat,nat)),$o)))
       => ( ( aa(set(product_prod(nat,nat)),int,abs_int,X2) = aa(set(product_prod(nat,nat)),int,abs_int,Y) )
        <=> ( X2 = Y ) ) ) ) ).

% Abs_int_inject
tff(fact_5855_Abs__int__induct,axiom,
    ! [Pa: fun(int,$o),X2: int] :
      ( ! [Y2: set(product_prod(nat,nat))] :
          ( aa(set(set(product_prod(nat,nat))),$o,member(set(product_prod(nat,nat)),Y2),aa(fun(set(product_prod(nat,nat)),$o),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axt(set(product_prod(nat,nat)),$o)))
         => aa(int,$o,Pa,aa(set(product_prod(nat,nat)),int,abs_int,Y2)) )
     => aa(int,$o,Pa,X2) ) ).

% Abs_int_induct
tff(fact_5856_split__seed__def,axiom,
    ! [S2: product_prod(code_natural,code_natural)] : ( split_seed(S2) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_case_prod(code_natural,code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aTP_Lamp_axv(product_prod(code_natural,code_natural),fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),S2)),S2) ) ).

% split_seed_def
tff(fact_5857_Random_Orange__def,axiom,
    ! [K: code_natural] : ( range(K) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),iterate(code_natural,product_prod(code_natural,code_natural),log(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),K),aTP_Lamp_axx(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),one_one(code_natural)),aTP_Lamp_axy(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),K)) ) ).

% Random.range_def
tff(fact_5858_Abs__int__inverse,axiom,
    ! [Y: set(product_prod(nat,nat))] :
      ( aa(set(set(product_prod(nat,nat))),$o,member(set(product_prod(nat,nat)),Y),aa(fun(set(product_prod(nat,nat)),$o),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axt(set(product_prod(nat,nat)),$o)))
     => ( aa(int,set(product_prod(nat,nat)),rep_int,aa(set(product_prod(nat,nat)),int,abs_int,Y)) = Y ) ) ).

% Abs_int_inverse
tff(fact_5859_Rep__int,axiom,
    ! [X2: int] : aa(set(set(product_prod(nat,nat))),$o,member(set(product_prod(nat,nat)),aa(int,set(product_prod(nat,nat)),rep_int,X2)),aa(fun(set(product_prod(nat,nat)),$o),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axt(set(product_prod(nat,nat)),$o))) ).

% Rep_int
tff(fact_5860_Rep__int__cases,axiom,
    ! [Y: set(product_prod(nat,nat))] :
      ( aa(set(set(product_prod(nat,nat))),$o,member(set(product_prod(nat,nat)),Y),aa(fun(set(product_prod(nat,nat)),$o),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axt(set(product_prod(nat,nat)),$o)))
     => ~ ! [X: int] : ( Y != aa(int,set(product_prod(nat,nat)),rep_int,X) ) ) ).

% Rep_int_cases
tff(fact_5861_Rep__int__induct,axiom,
    ! [Y: set(product_prod(nat,nat)),Pa: fun(set(product_prod(nat,nat)),$o)] :
      ( aa(set(set(product_prod(nat,nat))),$o,member(set(product_prod(nat,nat)),Y),aa(fun(set(product_prod(nat,nat)),$o),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axt(set(product_prod(nat,nat)),$o)))
     => ( ! [X: int] : aa(set(product_prod(nat,nat)),$o,Pa,aa(int,set(product_prod(nat,nat)),rep_int,X))
       => aa(set(product_prod(nat,nat)),$o,Pa,Y) ) ) ).

% Rep_int_induct
tff(fact_5862_type__definition__int,axiom,
    type_definition(int,set(product_prod(nat,nat)),rep_int,abs_int,aa(fun(set(product_prod(nat,nat)),$o),set(set(product_prod(nat,nat))),collect(set(product_prod(nat,nat))),aTP_Lamp_axt(set(product_prod(nat,nat)),$o))) ).

% type_definition_int
tff(fact_5863_select__weight__def,axiom,
    ! [B: $tType,Xs: list(product_prod(code_natural,B))] : ( select_weight(B,Xs) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)),range(aa(list(code_natural),code_natural,groups8242544230860333062m_list(code_natural),aa(list(product_prod(code_natural,B)),list(code_natural),map(product_prod(code_natural,B),code_natural,product_fst(code_natural,B)),Xs))),aTP_Lamp_axz(list(product_prod(code_natural,B)),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)))),Xs)) ) ).

% select_weight_def
tff(fact_5864_pick__drop__zero,axiom,
    ! [B: $tType,Xs: list(product_prod(code_natural,B))] : ( pick(B,aa(list(product_prod(code_natural,B)),list(product_prod(code_natural,B)),filter2(product_prod(code_natural,B),aa(fun(code_natural,fun(B,$o)),fun(product_prod(code_natural,B),$o),product_case_prod(code_natural,B,$o),aTP_Lamp_aya(code_natural,fun(B,$o)))),Xs)) = pick(B,Xs) ) ).

% pick_drop_zero
tff(fact_5865_select__weight__drop__zero,axiom,
    ! [B: $tType,Xs: list(product_prod(code_natural,B))] : ( select_weight(B,aa(list(product_prod(code_natural,B)),list(product_prod(code_natural,B)),filter2(product_prod(code_natural,B),aa(fun(code_natural,fun(B,$o)),fun(product_prod(code_natural,B),$o),product_case_prod(code_natural,B,$o),aTP_Lamp_aya(code_natural,fun(B,$o)))),Xs)) = select_weight(B,Xs) ) ).

% select_weight_drop_zero
tff(fact_5866_comm__monoid__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid(B,F2,Z2)
    <=> ( abel_semigroup(B,F2)
        & comm_monoid_axioms(B,F2,Z2) ) ) ).

% comm_monoid_def
tff(fact_5867_comm__monoid_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( abel_semigroup(B,F2)
     => ( comm_monoid_axioms(B,F2,Z2)
       => comm_monoid(B,F2,Z2) ) ) ).

% comm_monoid.intro
tff(fact_5868_ordering_Oaxioms_I2_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ordering(B,Less_eq,Less)
     => ordering_axioms(B,Less_eq,Less) ) ).

% ordering.axioms(2)
tff(fact_5869_mult_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => abel_semigroup(B,times_times(B)) ) ).

% mult.abel_semigroup_axioms
tff(fact_5870_add_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => abel_semigroup(B,plus_plus(B)) ) ).

% add.abel_semigroup_axioms
tff(fact_5871_sup_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => abel_semigroup(B,sup_sup(B)) ) ).

% sup.abel_semigroup_axioms
tff(fact_5872_comm__monoid_Oaxioms_I1_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid(B,F2,Z2)
     => abel_semigroup(B,F2) ) ).

% comm_monoid.axioms(1)
tff(fact_5873_min_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => abel_semigroup(B,ord_min(B)) ) ).

% min.abel_semigroup_axioms
tff(fact_5874_max_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => abel_semigroup(B,ord_max(B)) ) ).

% max.abel_semigroup_axioms
tff(fact_5875_ordering__axioms_Ointro,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o)),Less_eq: fun(B,fun(B,$o))] :
      ( ! [A5: B,B4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less,A5),B4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A5),B4)
            & ( A5 != B4 ) ) )
     => ( ! [A5: B,B4: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A5),B4)
           => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B4),A5)
             => ( A5 = B4 ) ) )
       => ordering_axioms(B,Less_eq,Less) ) ) ).

% ordering_axioms.intro
tff(fact_5876_ordering__axioms__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ordering_axioms(B,Less_eq,Less)
    <=> ( ! [A6: B,B5: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less,A6),B5)
          <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),B5)
              & ( A6 != B5 ) ) )
        & ! [A6: B,B5: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),B5)
           => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B5),A6)
             => ( A6 = B5 ) ) ) ) ) ).

% ordering_axioms_def
tff(fact_5877_abel__semigroup_Ocommute,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A4: B,B3: B] :
      ( abel_semigroup(B,F2)
     => ( aa(B,B,aa(B,fun(B,B),F2,A4),B3) = aa(B,B,aa(B,fun(B,B),F2,B3),A4) ) ) ).

% abel_semigroup.commute
tff(fact_5878_abel__semigroup_Oleft__commute,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),B3: B,A4: B,Ca: B] :
      ( abel_semigroup(B,F2)
     => ( aa(B,B,aa(B,fun(B,B),F2,B3),aa(B,B,aa(B,fun(B,B),F2,A4),Ca)) = aa(B,B,aa(B,fun(B,B),F2,A4),aa(B,B,aa(B,fun(B,B),F2,B3),Ca)) ) ) ).

% abel_semigroup.left_commute
tff(fact_5879_abstract__boolean__algebra_Oaxioms_I1_J,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => abel_semigroup(B,Conj) ) ).

% abstract_boolean_algebra.axioms(1)
tff(fact_5880_abstract__boolean__algebra_Oaxioms_I2_J,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => abel_semigroup(B,Disj) ) ).

% abstract_boolean_algebra.axioms(2)
tff(fact_5881_abel__semigroup_Oaxioms_I1_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( abel_semigroup(B,F2)
     => semigroup(B,F2) ) ).

% abel_semigroup.axioms(1)
tff(fact_5882_inf_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => abel_semigroup(B,inf_inf(B)) ) ).

% inf.abel_semigroup_axioms
tff(fact_5883_abel__semigroup__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( abel_semigroup(B,F2)
    <=> ( semigroup(B,F2)
        & abel_s757365448890700780axioms(B,F2) ) ) ).

% abel_semigroup_def
tff(fact_5884_abel__semigroup_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( semigroup(B,F2)
     => ( abel_s757365448890700780axioms(B,F2)
       => abel_semigroup(B,F2) ) ) ).

% abel_semigroup.intro
tff(fact_5885_abstract__boolean__algebra__def,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
    <=> ( abel_semigroup(B,Conj)
        & abel_semigroup(B,Disj)
        & boolea6902313364301356556axioms(B,Conj,Disj,Compl,Zero,One) ) ) ).

% abstract_boolean_algebra_def
tff(fact_5886_abel__semigroup__axioms__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( abel_s757365448890700780axioms(B,F2)
    <=> ! [A6: B,B5: B] : ( aa(B,B,aa(B,fun(B,B),F2,A6),B5) = aa(B,B,aa(B,fun(B,B),F2,B5),A6) ) ) ).

% abel_semigroup_axioms_def
tff(fact_5887_abel__semigroup__axioms_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( ! [A5: B,B4: B] : ( aa(B,B,aa(B,fun(B,B),F2,A5),B4) = aa(B,B,aa(B,fun(B,B),F2,B4),A5) )
     => abel_s757365448890700780axioms(B,F2) ) ).

% abel_semigroup_axioms.intro
tff(fact_5888_abstract__boolean__algebra__axioms__def,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea6902313364301356556axioms(B,Conj,Disj,Compl,Zero,One)
    <=> ( ! [X3: B,Y4: B,Z5: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X3),aa(B,B,aa(B,fun(B,B),Disj,Y4),Z5)) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X3),Y4)),aa(B,B,aa(B,fun(B,B),Conj,X3),Z5)) )
        & ! [X3: B,Y4: B,Z5: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X3),aa(B,B,aa(B,fun(B,B),Conj,Y4),Z5)) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,X3),Y4)),aa(B,B,aa(B,fun(B,B),Disj,X3),Z5)) )
        & ! [X3: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X3),One) = X3 )
        & ! [X3: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X3),Zero) = X3 )
        & ! [X3: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X3),aa(B,B,Compl,X3)) = Zero )
        & ! [X3: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X3),aa(B,B,Compl,X3)) = One ) ) ) ).

% abstract_boolean_algebra_axioms_def
tff(fact_5889_abstract__boolean__algebra__axioms_Ointro,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),One: B,Zero: B,Compl: fun(B,B)] :
      ( ! [X: B,Y2: B,Z3: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X),aa(B,B,aa(B,fun(B,B),Disj,Y2),Z3)) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X),Y2)),aa(B,B,aa(B,fun(B,B),Conj,X),Z3)) )
     => ( ! [X: B,Y2: B,Z3: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X),aa(B,B,aa(B,fun(B,B),Conj,Y2),Z3)) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,X),Y2)),aa(B,B,aa(B,fun(B,B),Disj,X),Z3)) )
       => ( ! [X: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X),One) = X )
         => ( ! [X: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X),Zero) = X )
           => ( ! [X: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X),aa(B,B,Compl,X)) = Zero )
             => ( ! [X: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X),aa(B,B,Compl,X)) = One )
               => boolea6902313364301356556axioms(B,Conj,Disj,Compl,Zero,One) ) ) ) ) ) ) ).

% abstract_boolean_algebra_axioms.intro
tff(fact_5890_abel__semigroup_Oaxioms_I2_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( abel_semigroup(B,F2)
     => abel_s757365448890700780axioms(B,F2) ) ).

% abel_semigroup.axioms(2)
tff(fact_5891_abstract__boolean__algebra_Oaxioms_I3_J,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => boolea6902313364301356556axioms(B,Conj,Disj,Compl,Zero,One) ) ).

% abstract_boolean_algebra.axioms(3)
tff(fact_5892_abstract__boolean__algebra_Ointro,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( abel_semigroup(B,Conj)
     => ( abel_semigroup(B,Disj)
       => ( boolea6902313364301356556axioms(B,Conj,Disj,Compl,Zero,One)
         => boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One) ) ) ) ).

% abstract_boolean_algebra.intro
tff(fact_5893_ordering__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ordering(B,Less_eq,Less)
    <=> ( partial_preordering(B,Less_eq)
        & ordering_axioms(B,Less_eq,Less) ) ) ).

% ordering_def
tff(fact_5894_ordering_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( partial_preordering(B,Less_eq)
     => ( ordering_axioms(B,Less_eq,Less)
       => ordering(B,Less_eq,Less) ) ) ).

% ordering.intro
tff(fact_5895_sort__mergesort__by__rel,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( linorder_sort_key(B,B,aTP_Lamp_eh(B,B)) = mergesort_by_rel(B,ord_less_eq(B)) ) ) ).

% sort_mergesort_by_rel
tff(fact_5896_partial__preordering_Orefl,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),A4: B] :
      ( partial_preordering(B,Less_eq)
     => aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),A4) ) ).

% partial_preordering.refl
tff(fact_5897_partial__preordering_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o))] :
      ( ! [A5: B] : aa(B,$o,aa(B,fun(B,$o),Less_eq,A5),A5)
     => ( ! [A5: B,B4: B,C3: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A5),B4)
           => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B4),C3)
             => aa(B,$o,aa(B,fun(B,$o),Less_eq,A5),C3) ) )
       => partial_preordering(B,Less_eq) ) ) ).

% partial_preordering.intro
tff(fact_5898_partial__preordering_Otrans,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),A4: B,B3: B,Ca: B] :
      ( partial_preordering(B,Less_eq)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B3),Ca)
         => aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),Ca) ) ) ) ).

% partial_preordering.trans
tff(fact_5899_partial__preordering__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o))] :
      ( partial_preordering(B,Less_eq)
    <=> ( ! [A6: B] : aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),A6)
        & ! [A6: B,B5: B,C4: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),B5)
           => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B5),C4)
             => aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),C4) ) ) ) ) ).

% partial_preordering_def
tff(fact_5900_order_Opartial__preordering__axioms,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => partial_preordering(B,ord_less_eq(B)) ) ).

% order.partial_preordering_axioms
tff(fact_5901_ordering_Oaxioms_I1_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ordering(B,Less_eq,Less)
     => partial_preordering(B,Less_eq) ) ).

% ordering.axioms(1)
tff(fact_5902_subset__mset_Odual__order_Opartial__preordering__axioms,axiom,
    ! [B: $tType] : partial_preordering(multiset(B),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o))) ).

% subset_mset.dual_order.partial_preordering_axioms
tff(fact_5903_dual__order_Opartial__preordering__axioms,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => partial_preordering(B,aTP_Lamp_avb(B,fun(B,$o))) ) ).

% dual_order.partial_preordering_axioms
tff(fact_5904_mergesort__by__rel__simps_I3_J,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),X13: B,X24: B,Xs: list(B)] : ( aa(list(B),list(B),mergesort_by_rel(B,R),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X13),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X24),Xs))) = aa(product_prod(list(B),list(B)),list(B),aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aTP_Lamp_ayb(fun(B,fun(B,$o)),fun(list(B),fun(list(B),list(B))),R)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X13),nil(B))),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X24),nil(B))),Xs)) ) ).

% mergesort_by_rel_simps(3)
tff(fact_5905_semilattice__neutr_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( semilattice(B,F2)
     => ( comm_monoid(B,F2,Z2)
       => semilattice_neutr(B,F2,Z2) ) ) ).

% semilattice_neutr.intro
tff(fact_5906_semilattice__neutr__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( semilattice_neutr(B,F2,Z2)
    <=> ( semilattice(B,F2)
        & comm_monoid(B,F2,Z2) ) ) ).

% semilattice_neutr_def
tff(fact_5907_semilattice__map2,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( semilattice(B,F2)
     => semilattice(list(B),aTP_Lamp_ayc(fun(B,fun(B,B)),fun(list(B),fun(list(B),list(B))),F2)) ) ).

% semilattice_map2
tff(fact_5908_semilattice_Oaxioms_I1_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( semilattice(B,F2)
     => abel_semigroup(B,F2) ) ).

% semilattice.axioms(1)
tff(fact_5909_inf_Osemilattice__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => semilattice(B,inf_inf(B)) ) ).

% inf.semilattice_axioms
tff(fact_5910_semilattice__neutr_Oaxioms_I1_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( semilattice_neutr(B,F2,Z2)
     => semilattice(B,F2) ) ).

% semilattice_neutr.axioms(1)
tff(fact_5911_max_Osemilattice__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semilattice(B,ord_max(B)) ) ).

% max.semilattice_axioms
tff(fact_5912_min_Osemilattice__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semilattice(B,ord_min(B)) ) ).

% min.semilattice_axioms
tff(fact_5913_semilattice_Oright__idem,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A4: B,B3: B] :
      ( semilattice(B,F2)
     => ( aa(B,B,aa(B,fun(B,B),F2,aa(B,B,aa(B,fun(B,B),F2,A4),B3)),B3) = aa(B,B,aa(B,fun(B,B),F2,A4),B3) ) ) ).

% semilattice.right_idem
tff(fact_5914_semilattice_Oleft__idem,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A4: B,B3: B] :
      ( semilattice(B,F2)
     => ( aa(B,B,aa(B,fun(B,B),F2,A4),aa(B,B,aa(B,fun(B,B),F2,A4),B3)) = aa(B,B,aa(B,fun(B,B),F2,A4),B3) ) ) ).

% semilattice.left_idem
tff(fact_5915_semilattice_Oidem,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),A4: B] :
      ( semilattice(B,F2)
     => ( aa(B,B,aa(B,fun(B,B),F2,A4),A4) = A4 ) ) ).

% semilattice.idem
tff(fact_5916_sup_Osemilattice__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => semilattice(B,sup_sup(B)) ) ).

% sup.semilattice_axioms
tff(fact_5917_semilattice__order_Oaxioms_I1_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => semilattice(B,F2) ) ).

% semilattice_order.axioms(1)
tff(fact_5918_semilattice_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( abel_semigroup(B,F2)
     => ( semilattice_axioms(B,F2)
       => semilattice(B,F2) ) ) ).

% semilattice.intro
tff(fact_5919_semilattice__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( semilattice(B,F2)
    <=> ( abel_semigroup(B,F2)
        & semilattice_axioms(B,F2) ) ) ).

% semilattice_def
tff(fact_5920_semilattice__order__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semilattice_order(B,F2,Less_eq,Less)
    <=> ( semilattice(B,F2)
        & semila6385135966242565138axioms(B,F2,Less_eq,Less) ) ) ).

% semilattice_order_def
tff(fact_5921_semilattice__axioms_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( ! [A5: B] : ( aa(B,B,aa(B,fun(B,B),F2,A5),A5) = A5 )
     => semilattice_axioms(B,F2) ) ).

% semilattice_axioms.intro
tff(fact_5922_semilattice__order__axioms_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),F2: fun(B,fun(B,B)),Less: fun(B,fun(B,$o))] :
      ( ! [A5: B,B4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A5),B4)
        <=> ( A5 = aa(B,B,aa(B,fun(B,B),F2,A5),B4) ) )
     => ( ! [A5: B,B4: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less,A5),B4)
          <=> ( ( A5 = aa(B,B,aa(B,fun(B,B),F2,A5),B4) )
              & ( A5 != B4 ) ) )
       => semila6385135966242565138axioms(B,F2,Less_eq,Less) ) ) ).

% semilattice_order_axioms.intro
tff(fact_5923_semilattice__axioms__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( semilattice_axioms(B,F2)
    <=> ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),F2,A6),A6) = A6 ) ) ).

% semilattice_axioms_def
tff(fact_5924_semilattice__order__axioms__def,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semila6385135966242565138axioms(B,F2,Less_eq,Less)
    <=> ( ! [A6: B,B5: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),B5)
          <=> ( A6 = aa(B,B,aa(B,fun(B,B),F2,A6),B5) ) )
        & ! [A6: B,B5: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less,A6),B5)
          <=> ( ( A6 = aa(B,B,aa(B,fun(B,B),F2,A6),B5) )
              & ( A6 != B5 ) ) ) ) ) ).

% semilattice_order_axioms_def
tff(fact_5925_semilattice__order_Oaxioms_I2_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semilattice_order(B,F2,Less_eq,Less)
     => semila6385135966242565138axioms(B,F2,Less_eq,Less) ) ).

% semilattice_order.axioms(2)
tff(fact_5926_semilattice_Oaxioms_I2_J,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B))] :
      ( semilattice(B,F2)
     => semilattice_axioms(B,F2) ) ).

% semilattice.axioms(2)
tff(fact_5927_semilattice__order_Ointro,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semilattice(B,F2)
     => ( semila6385135966242565138axioms(B,F2,Less_eq,Less)
       => semilattice_order(B,F2,Less_eq,Less) ) ) ).

% semilattice_order.intro
tff(fact_5928_subset__mset_Odual__order_Opreordering__axioms,axiom,
    ! [B: $tType] : preordering(multiset(B),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o)),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o))) ).

% subset_mset.dual_order.preordering_axioms
tff(fact_5929_list__decode_Oelims,axiom,
    ! [X2: nat,Y: list(nat)] :
      ( ( nat_list_decode(X2) = Y )
     => ( ( ( X2 = zero_zero(nat) )
         => ( Y != nil(nat) ) )
       => ~ ! [N2: nat] :
              ( ( X2 = aa(nat,nat,suc,N2) )
             => ( Y != aa(product_prod(nat,nat),list(nat),aa(fun(nat,fun(nat,list(nat))),fun(product_prod(nat,nat),list(nat)),product_case_prod(nat,nat,list(nat)),aTP_Lamp_ayd(nat,fun(nat,list(nat)))),nat_prod_decode(N2)) ) ) ) ) ).

% list_decode.elims
tff(fact_5930_dual__order_Opreordering__axioms,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => preordering(B,aTP_Lamp_avb(B,fun(B,$o)),aTP_Lamp_aaa(B,fun(B,$o))) ) ).

% dual_order.preordering_axioms
tff(fact_5931_preordering__dualI,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( preordering(B,aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Less_eq),aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Less))
     => preordering(B,Less_eq,Less) ) ).

% preordering_dualI
tff(fact_5932_preordering__strictI,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ! [A5: B,B4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A5),B4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),Less,A5),B4)
            | ( A5 = B4 ) ) )
     => ( ! [A5: B,B4: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less,A5),B4)
           => ~ aa(B,$o,aa(B,fun(B,$o),Less,B4),A5) )
       => ( ! [A5: B] : ~ aa(B,$o,aa(B,fun(B,$o),Less,A5),A5)
         => ( ! [A5: B,B4: B,C3: B] :
                ( aa(B,$o,aa(B,fun(B,$o),Less,A5),B4)
               => ( aa(B,$o,aa(B,fun(B,$o),Less,B4),C3)
                 => aa(B,$o,aa(B,fun(B,$o),Less,A5),C3) ) )
           => preordering(B,Less_eq,Less) ) ) ) ) ).

% preordering_strictI
tff(fact_5933_preordering_Ostrict__implies__order,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A4),B3)
       => aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3) ) ) ).

% preordering.strict_implies_order
tff(fact_5934_preordering_Ostrict__iff__not,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A4),B3)
      <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
          & ~ aa(B,$o,aa(B,fun(B,$o),Less_eq,B3),A4) ) ) ) ).

% preordering.strict_iff_not
tff(fact_5935_preordering_Ostrict__trans2,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B,Ca: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A4),B3)
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B3),Ca)
         => aa(B,$o,aa(B,fun(B,$o),Less,A4),Ca) ) ) ) ).

% preordering.strict_trans2
tff(fact_5936_preordering_Ostrict__trans1,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B,Ca: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A4),B3)
       => ( aa(B,$o,aa(B,fun(B,$o),Less,B3),Ca)
         => aa(B,$o,aa(B,fun(B,$o),Less,A4),Ca) ) ) ) ).

% preordering.strict_trans1
tff(fact_5937_preordering_Ostrict__trans,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B,Ca: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A4),B3)
       => ( aa(B,$o,aa(B,fun(B,$o),Less,B3),Ca)
         => aa(B,$o,aa(B,fun(B,$o),Less,A4),Ca) ) ) ) ).

% preordering.strict_trans
tff(fact_5938_preordering_Oirrefl,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B] :
      ( preordering(B,Less_eq,Less)
     => ~ aa(B,$o,aa(B,fun(B,$o),Less,A4),A4) ) ).

% preordering.irrefl
tff(fact_5939_preordering_Oasym,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: B,B3: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A4),B3)
       => ~ aa(B,$o,aa(B,fun(B,$o),Less,B3),A4) ) ) ).

% preordering.asym
tff(fact_5940_gcd__nat_Opreordering__axioms,axiom,
    preordering(nat,dvd_dvd(nat),aTP_Lamp_abk(nat,fun(nat,$o))) ).

% gcd_nat.preordering_axioms
tff(fact_5941_list__decode_Osimps_I2_J,axiom,
    ! [N: nat] : ( nat_list_decode(aa(nat,nat,suc,N)) = aa(product_prod(nat,nat),list(nat),aa(fun(nat,fun(nat,list(nat))),fun(product_prod(nat,nat),list(nat)),product_case_prod(nat,nat,list(nat)),aTP_Lamp_ayd(nat,fun(nat,list(nat)))),nat_prod_decode(N)) ) ).

% list_decode.simps(2)
tff(fact_5942_preordering_Oaxioms_I1_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( preordering(B,Less_eq,Less)
     => partial_preordering(B,Less_eq) ) ).

% preordering.axioms(1)
tff(fact_5943_order_Opreordering__axioms,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => preordering(B,ord_less_eq(B),ord_less(B)) ) ).

% order.preordering_axioms
tff(fact_5944_preordering__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( preordering(B,Less_eq,Less)
    <=> ( partial_preordering(B,Less_eq)
        & preordering_axioms(B,Less_eq,Less) ) ) ).

% preordering_def
tff(fact_5945_preordering_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( partial_preordering(B,Less_eq)
     => ( preordering_axioms(B,Less_eq,Less)
       => preordering(B,Less_eq,Less) ) ) ).

% preordering.intro
tff(fact_5946_list__decode_Opelims,axiom,
    ! [X2: nat,Y: list(nat)] :
      ( ( nat_list_decode(X2) = Y )
     => ( aa(nat,$o,accp(nat,nat_list_decode_rel),X2)
       => ( ( ( X2 = zero_zero(nat) )
           => ( ( Y = nil(nat) )
             => ~ aa(nat,$o,accp(nat,nat_list_decode_rel),zero_zero(nat)) ) )
         => ~ ! [N2: nat] :
                ( ( X2 = aa(nat,nat,suc,N2) )
               => ( ( Y = aa(product_prod(nat,nat),list(nat),aa(fun(nat,fun(nat,list(nat))),fun(product_prod(nat,nat),list(nat)),product_case_prod(nat,nat,list(nat)),aTP_Lamp_ayd(nat,fun(nat,list(nat)))),nat_prod_decode(N2)) )
                 => ~ aa(nat,$o,accp(nat,nat_list_decode_rel),aa(nat,nat,suc,N2)) ) ) ) ) ) ).

% list_decode.pelims
tff(fact_5947_preordering__axioms_Ointro,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o)),Less_eq: fun(B,fun(B,$o))] :
      ( ! [A5: B,B4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less,A5),B4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A5),B4)
            & ~ aa(B,$o,aa(B,fun(B,$o),Less_eq,B4),A5) ) )
     => preordering_axioms(B,Less_eq,Less) ) ).

% preordering_axioms.intro
tff(fact_5948_preordering__axioms__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( preordering_axioms(B,Less_eq,Less)
    <=> ! [A6: B,B5: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less,A6),B5)
        <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),B5)
            & ~ aa(B,$o,aa(B,fun(B,$o),Less_eq,B5),A6) ) ) ) ).

% preordering_axioms_def
tff(fact_5949_preordering_Oaxioms_I2_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( preordering(B,Less_eq,Less)
     => preordering_axioms(B,Less_eq,Less) ) ).

% preordering.axioms(2)
tff(fact_5950_list__decode_Opsimps_I2_J,axiom,
    ! [N: nat] :
      ( aa(nat,$o,accp(nat,nat_list_decode_rel),aa(nat,nat,suc,N))
     => ( nat_list_decode(aa(nat,nat,suc,N)) = aa(product_prod(nat,nat),list(nat),aa(fun(nat,fun(nat,list(nat))),fun(product_prod(nat,nat),list(nat)),product_case_prod(nat,nat,list(nat)),aTP_Lamp_ayd(nat,fun(nat,list(nat)))),nat_prod_decode(N)) ) ) ).

% list_decode.psimps(2)
tff(fact_5951_admissible__disj,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [Pa: fun(B,$o),Qa: fun(B,$o)] :
          ( comple1908693960933563346ssible(B,complete_Sup_Sup(B),ord_less_eq(B),Pa)
         => ( comple1908693960933563346ssible(B,complete_Sup_Sup(B),ord_less_eq(B),Qa)
           => comple1908693960933563346ssible(B,complete_Sup_Sup(B),ord_less_eq(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_aye(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa)) ) ) ) ).

% admissible_disj
tff(fact_5952_ndepth__Push__Node__aux,axiom,
    ! [B: $tType,I2: nat,F2: fun(nat,sum_sum(B,nat)),K: nat] :
      ( ( aa(nat,sum_sum(B,nat),aa(fun(nat,sum_sum(B,nat)),fun(nat,sum_sum(B,nat)),aa(sum_sum(B,nat),fun(fun(nat,sum_sum(B,nat)),fun(nat,sum_sum(B,nat))),case_nat(sum_sum(B,nat)),aa(nat,sum_sum(B,nat),sum_Inr(nat,B),aa(nat,nat,suc,I2))),F2),K) = aa(nat,sum_sum(B,nat),sum_Inr(nat,B),zero_zero(nat)) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,ord_Least(nat,aTP_Lamp_ayf(fun(nat,sum_sum(B,nat)),fun(nat,$o),F2)))),K) ) ).

% ndepth_Push_Node_aux
tff(fact_5953_bij__image__Collect__eq,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),Pa: fun(B,$o)] :
      ( bij_betw(B,C,F2,top_top(set(B)),top_top(set(C)))
     => ( aa(set(B),set(C),image2(B,C,F2),aa(fun(B,$o),set(B),collect(B),Pa)) = aa(fun(C,$o),set(C),collect(C),aa(fun(B,$o),fun(C,$o),aTP_Lamp_ayg(fun(B,C),fun(fun(B,$o),fun(C,$o)),F2),Pa)) ) ) ).

% bij_image_Collect_eq
tff(fact_5954_inv__identity,axiom,
    ! [B: $tType,X4: B] : ( hilbert_inv_into(B,B,top_top(set(B)),aTP_Lamp_bk(B,B),X4) = X4 ) ).

% inv_identity
tff(fact_5955_inv__into__def,axiom,
    ! [C: $tType,B: $tType,A3: set(C),F2: fun(C,B),X4: B] : ( hilbert_inv_into(C,B,A3,F2,X4) = fChoice(C,aa(B,fun(C,$o),aa(fun(C,B),fun(B,fun(C,$o)),aTP_Lamp_kf(set(C),fun(fun(C,B),fun(B,fun(C,$o))),A3),F2),X4)) ) ).

% inv_into_def
tff(fact_5956_inv__into__def2,axiom,
    ! [B: $tType,C: $tType,A3: set(B),F2: fun(B,C),X2: C] : ( hilbert_inv_into(B,C,A3,F2,X2) = fChoice(B,aa(C,fun(B,$o),aa(fun(B,C),fun(C,fun(B,$o)),aTP_Lamp_pm(set(B),fun(fun(B,C),fun(C,fun(B,$o))),A3),F2),X2)) ) ).

% inv_into_def2
tff(fact_5957_admissible__True,axiom,
    ! [B: $tType,Lub: fun(set(B),B),Ord: fun(B,fun(B,$o))] : comple1908693960933563346ssible(B,Lub,Ord,aTP_Lamp_nh(B,$o)) ).

% admissible_True
tff(fact_5958_admissible__conj,axiom,
    ! [B: $tType,Lub: fun(set(B),B),Ord: fun(B,fun(B,$o)),Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( comple1908693960933563346ssible(B,Lub,Ord,Pa)
     => ( comple1908693960933563346ssible(B,Lub,Ord,Qa)
       => comple1908693960933563346ssible(B,Lub,Ord,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa)) ) ) ).

% admissible_conj
tff(fact_5959_admissible__const,axiom,
    ! [B: $tType,Lub: fun(set(B),B),Ord: fun(B,fun(B,$o)),T3: $o] : comple1908693960933563346ssible(B,Lub,Ord,aTP_Lamp_an($o,fun(B,$o),T3)) ).

% admissible_const
tff(fact_5960_admissible__ball,axiom,
    ! [B: $tType,C: $tType,A3: set(B),Lub: fun(set(C),C),Ord: fun(C,fun(C,$o)),Pa: fun(C,fun(B,$o))] :
      ( ! [Y2: B] :
          ( aa(set(B),$o,member(B,Y2),A3)
         => comple1908693960933563346ssible(C,Lub,Ord,aa(B,fun(C,$o),aTP_Lamp_km(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Pa),Y2)) )
     => comple1908693960933563346ssible(C,Lub,Ord,aa(fun(C,fun(B,$o)),fun(C,$o),aTP_Lamp_adf(set(B),fun(fun(C,fun(B,$o)),fun(C,$o)),A3),Pa)) ) ).

% admissible_ball
tff(fact_5961_admissible__all,axiom,
    ! [B: $tType,C: $tType,Lub: fun(set(C),C),Ord: fun(C,fun(C,$o)),Pa: fun(C,fun(B,$o))] :
      ( ! [Y2: B] : comple1908693960933563346ssible(C,Lub,Ord,aa(B,fun(C,$o),aTP_Lamp_km(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Pa),Y2))
     => comple1908693960933563346ssible(C,Lub,Ord,aTP_Lamp_ayh(fun(C,fun(B,$o)),fun(C,$o),Pa)) ) ).

% admissible_all
tff(fact_5962_inv__def,axiom,
    ! [C: $tType,B: $tType,F2: fun(C,B),X4: B] : ( hilbert_inv_into(C,B,top_top(set(C)),F2,X4) = fChoice(C,aa(B,fun(C,$o),aTP_Lamp_ayi(fun(C,B),fun(B,fun(C,$o)),F2),X4)) ) ).

% inv_def
tff(fact_5963_ccpo_Oadmissible__def,axiom,
    ! [B: $tType,Lub: fun(set(B),B),Ord: fun(B,fun(B,$o)),Pa: fun(B,$o)] :
      ( comple1908693960933563346ssible(B,Lub,Ord,Pa)
    <=> ! [A12: set(B)] :
          ( comple1602240252501008431_chain(B,Ord,A12)
         => ( ( A12 != bot_bot(set(B)) )
           => ( ! [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A12)
                 => aa(B,$o,Pa,X3) )
             => aa(B,$o,Pa,aa(set(B),B,Lub,A12)) ) ) ) ) ).

% ccpo.admissible_def
tff(fact_5964_ccpo_OadmissibleI,axiom,
    ! [B: $tType,Ord: fun(B,fun(B,$o)),Pa: fun(B,$o),Lub: fun(set(B),B)] :
      ( ! [A11: set(B)] :
          ( comple1602240252501008431_chain(B,Ord,A11)
         => ( ( A11 != bot_bot(set(B)) )
           => ( ! [X4: B] :
                  ( aa(set(B),$o,member(B,X4),A11)
                 => aa(B,$o,Pa,X4) )
             => aa(B,$o,Pa,aa(set(B),B,Lub,A11)) ) ) )
     => comple1908693960933563346ssible(B,Lub,Ord,Pa) ) ).

% ccpo.admissibleI
tff(fact_5965_ccpo_OadmissibleD,axiom,
    ! [B: $tType,Lub: fun(set(B),B),Ord: fun(B,fun(B,$o)),Pa: fun(B,$o),A3: set(B)] :
      ( comple1908693960933563346ssible(B,Lub,Ord,Pa)
     => ( comple1602240252501008431_chain(B,Ord,A3)
       => ( ( A3 != bot_bot(set(B)) )
         => ( ! [X: B] :
                ( aa(set(B),$o,member(B,X),A3)
               => aa(B,$o,Pa,X) )
           => aa(B,$o,Pa,aa(set(B),B,Lub,A3)) ) ) ) ) ).

% ccpo.admissibleD
tff(fact_5966_Node__def,axiom,
    ! [C: $tType,B: $tType] : ( old_Node(B,C) = aa(fun(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),$o),set(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat))),collect(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat))),aTP_Lamp_ayj(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),$o)) ) ).

% Node_def
tff(fact_5967_Union__plus,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(sum_sum(C,D),set(B)),A3: set(C),B2: set(D)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(sum_sum(C,D)),set(set(B)),image2(sum_sum(C,D),set(B),F2),sum_Plus(C,D,A3,B2))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_ayk(fun(sum_sum(C,D),set(B)),fun(C,set(B)),F2)),A3))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aTP_Lamp_ayl(fun(sum_sum(C,D),set(B)),fun(D,set(B)),F2)),B2))) ) ).

% Union_plus
tff(fact_5968_Union__sum,axiom,
    ! [C: $tType,B: $tType,D: $tType,F2: fun(sum_sum(C,D),set(B))] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(sum_sum(C,D)),set(set(B)),image2(sum_sum(C,D),set(B),F2),top_top(set(sum_sum(C,D))))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_ayk(fun(sum_sum(C,D),set(B)),fun(C,set(B)),F2)),top_top(set(C))))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aTP_Lamp_ayl(fun(sum_sum(C,D),set(B)),fun(D,set(B)),F2)),top_top(set(D))))) ) ).

% Union_sum
tff(fact_5969_surjective__sum,axiom,
    ! [D: $tType,C: $tType,B: $tType,F2: fun(sum_sum(B,C),D)] : ( sum_case_sum(B,D,C,aTP_Lamp_aym(fun(sum_sum(B,C),D),fun(B,D),F2),aTP_Lamp_ayn(fun(sum_sum(B,C),D),fun(C,D),F2)) = F2 ) ).

% surjective_sum
tff(fact_5970_Node__K0__I,axiom,
    ! [C: $tType,B: $tType,A4: sum_sum(C,nat)] : aa(set(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat))),$o,member(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),aa(sum_sum(C,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),aa(fun(nat,sum_sum(B,nat)),fun(sum_sum(C,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat))),product_Pair(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),aTP_Lamp_ayo(nat,sum_sum(B,nat))),A4)),old_Node(B,C)) ).

% Node_K0_I
tff(fact_5971_prod_OPlus,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_mult(D)
     => ! [A3: set(B),B2: set(C),G: fun(sum_sum(B,C),D)] :
          ( aa(set(B),$o,finite_finite2(B),A3)
         => ( aa(set(C),$o,finite_finite2(C),B2)
           => ( aa(set(sum_sum(B,C)),D,aa(fun(sum_sum(B,C),D),fun(set(sum_sum(B,C)),D),groups7121269368397514597t_prod(sum_sum(B,C),D),G),sum_Plus(B,C,A3,B2)) = aa(D,D,aa(D,fun(D,D),times_times(D),aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(B,sum_sum(B,C)),fun(B,D),comp(sum_sum(B,C),D,B,G),sum_Inl(B,C))),A3)),aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),aa(fun(C,sum_sum(B,C)),fun(C,D),comp(sum_sum(B,C),D,C,G),sum_Inr(C,B))),B2)) ) ) ) ) ).

% prod.Plus
tff(fact_5972_card__order__csum__cone__cexp__def,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(B,B)),A1: set(C)] :
      ( aa(set(product_prod(B,B)),$o,bNF_Ca8970107618336181345der_on(B,top_top(set(B))),R2)
     => ( bNF_Cardinal_cexp(sum_sum(C,product_unit),B,bNF_Cardinal_csum(C,product_unit,bNF_Ca6860139660246222851ard_of(C,A1),bNF_Cardinal_cone),R2) = bNF_Ca6860139660246222851ard_of(fun(B,sum_sum(C,product_unit)),bNF_Wellorder_Func(B,sum_sum(C,product_unit),top_top(set(B)),aa(set(sum_sum(C,product_unit)),set(sum_sum(C,product_unit)),aa(set(sum_sum(C,product_unit)),fun(set(sum_sum(C,product_unit)),set(sum_sum(C,product_unit))),sup_sup(set(sum_sum(C,product_unit))),aa(set(C),set(sum_sum(C,product_unit)),image2(C,sum_sum(C,product_unit),sum_Inl(C,product_unit)),A1)),aa(set(sum_sum(C,product_unit)),set(sum_sum(C,product_unit)),insert(sum_sum(C,product_unit),aa(product_unit,sum_sum(C,product_unit),sum_Inr(product_unit,C),product_Unity)),bot_bot(set(sum_sum(C,product_unit))))))) ) ) ).

% card_order_csum_cone_cexp_def
tff(fact_5973_sum__set__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,X2: B] : ( aa(sum_sum(B,C),set(B),basic_setl(B,C),aa(B,sum_sum(B,C),sum_Inl(B,C),X2)) = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) ).

% sum_set_simps(1)
tff(fact_5974_sum__set__simps_I2_J,axiom,
    ! [C: $tType,B: $tType,X2: C] : ( aa(sum_sum(B,C),set(B),basic_setl(B,C),aa(C,sum_sum(B,C),sum_Inr(C,B),X2)) = bot_bot(set(B)) ) ).

% sum_set_simps(2)
tff(fact_5975_sum__set__defs_I1_J,axiom,
    ! [B: $tType,C: $tType] : ( basic_setl(B,C) = sum_case_sum(B,set(B),C,aTP_Lamp_dj(B,set(B)),aTP_Lamp_gj(C,set(B))) ) ).

% sum_set_defs(1)
tff(fact_5976_sum__set__simps_I4_J,axiom,
    ! [C: $tType,B: $tType,X2: B] : ( aa(sum_sum(C,B),set(B),basic_setr(C,B),aa(B,sum_sum(C,B),sum_Inr(B,C),X2)) = aa(set(B),set(B),insert(B,X2),bot_bot(set(B))) ) ).

% sum_set_simps(4)
tff(fact_5977_Push__def,axiom,
    ! [B: $tType] : ( old_Push(B) = case_nat(sum_sum(B,nat)) ) ).

% Push_def
tff(fact_5978_sum__set__simps_I3_J,axiom,
    ! [C: $tType,B: $tType,X2: C] : ( aa(sum_sum(C,B),set(B),basic_setr(C,B),aa(C,sum_sum(C,B),sum_Inl(C,B),X2)) = bot_bot(set(B)) ) ).

% sum_set_simps(3)
tff(fact_5979_sum__set__defs_I2_J,axiom,
    ! [B: $tType,C: $tType] : ( basic_setr(B,C) = sum_case_sum(B,set(C),C,aTP_Lamp_bs(B,set(C)),aTP_Lamp_ayp(C,set(C))) ) ).

% sum_set_defs(2)
tff(fact_5980_ndepth__def,axiom,
    ! [C: $tType,B: $tType,N: old_node(B,C)] : ( old_ndepth(B,C,N) = aa(product_prod(fun(nat,sum_sum(C,nat)),sum_sum(B,nat)),nat,aa(fun(fun(nat,sum_sum(C,nat)),fun(sum_sum(B,nat),nat)),fun(product_prod(fun(nat,sum_sum(C,nat)),sum_sum(B,nat)),nat),product_case_prod(fun(nat,sum_sum(C,nat)),sum_sum(B,nat),nat),aTP_Lamp_ayr(fun(nat,sum_sum(C,nat)),fun(sum_sum(B,nat),nat))),old_Rep_Node(B,C,N)) ) ).

% ndepth_def
tff(fact_5981_ndepth__K0,axiom,
    ! [B: $tType,C: $tType,X2: sum_sum(B,nat)] : ( old_ndepth(B,C,old_Abs_Node(C,B,aa(sum_sum(B,nat),product_prod(fun(nat,sum_sum(C,nat)),sum_sum(B,nat)),aa(fun(nat,sum_sum(C,nat)),fun(sum_sum(B,nat),product_prod(fun(nat,sum_sum(C,nat)),sum_sum(B,nat))),product_Pair(fun(nat,sum_sum(C,nat)),sum_sum(B,nat)),aTP_Lamp_ays(nat,sum_sum(C,nat))),X2))) = zero_zero(nat) ) ).

% ndepth_K0
tff(fact_5982_Atom__def,axiom,
    ! [C: $tType,B: $tType,X4: sum_sum(B,nat)] : ( old_Atom(B,C,X4) = aa(set(old_node(B,C)),set(old_node(B,C)),insert(old_node(B,C),old_Abs_Node(C,B,aa(sum_sum(B,nat),product_prod(fun(nat,sum_sum(C,nat)),sum_sum(B,nat)),aa(fun(nat,sum_sum(C,nat)),fun(sum_sum(B,nat),product_prod(fun(nat,sum_sum(C,nat)),sum_sum(B,nat))),product_Pair(fun(nat,sum_sum(C,nat)),sum_sum(B,nat)),aTP_Lamp_ays(nat,sum_sum(C,nat))),X4))),bot_bot(set(old_node(B,C)))) ) ).

% Atom_def
tff(fact_5983_Push__Node__def,axiom,
    ! [B: $tType,C: $tType,X4: sum_sum(B,nat),Xa3: old_node(C,B)] : ( aa(old_node(C,B),old_node(C,B),old_Push_Node(B,C,X4),Xa3) = old_Abs_Node(B,C,aa(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),product_apfst(fun(nat,sum_sum(B,nat)),fun(nat,sum_sum(B,nat)),sum_sum(C,nat),aa(sum_sum(B,nat),fun(fun(nat,sum_sum(B,nat)),fun(nat,sum_sum(B,nat))),old_Push(B),X4)),old_Rep_Node(C,B,Xa3))) ) ).

% Push_Node_def
tff(fact_5984_Lim__def,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,set(old_node(B,C)))] : ( old_Lim(C,B,F2) = aa(set(set(old_node(B,C))),set(old_node(B,C)),complete_Sup_Sup(set(old_node(B,C))),aa(fun(set(old_node(B,C)),$o),set(set(old_node(B,C))),collect(set(old_node(B,C))),aTP_Lamp_ayt(fun(C,set(old_node(B,C))),fun(set(old_node(B,C)),$o),F2))) ) ).

% Lim_def
tff(fact_5985_ntrunc__0,axiom,
    ! [C: $tType,B: $tType,M: set(old_node(B,C))] : ( old_ntrunc(B,C,zero_zero(nat),M) = bot_bot(set(old_node(B,C))) ) ).

% ntrunc_0
tff(fact_5986_ntrunc__UN1,axiom,
    ! [B: $tType,C: $tType,D: $tType,K: nat,F2: fun(D,set(old_node(B,C)))] : ( old_ntrunc(B,C,K,aa(set(set(old_node(B,C))),set(old_node(B,C)),complete_Sup_Sup(set(old_node(B,C))),aa(set(D),set(set(old_node(B,C))),image2(D,set(old_node(B,C)),F2),top_top(set(D))))) = aa(set(set(old_node(B,C))),set(old_node(B,C)),complete_Sup_Sup(set(old_node(B,C))),aa(set(D),set(set(old_node(B,C))),image2(D,set(old_node(B,C)),aa(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C))),aTP_Lamp_ayu(nat,fun(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C)))),K),F2)),top_top(set(D)))) ) ).

% ntrunc_UN1
tff(fact_5987_ntrunc__def,axiom,
    ! [C: $tType,B: $tType,K: nat,N3: set(old_node(B,C))] : ( old_ntrunc(B,C,K,N3) = aa(fun(old_node(B,C),$o),set(old_node(B,C)),collect(old_node(B,C)),aa(set(old_node(B,C)),fun(old_node(B,C),$o),aTP_Lamp_ayv(nat,fun(set(old_node(B,C)),fun(old_node(B,C),$o)),K),N3)) ) ).

% ntrunc_def
tff(fact_5988_ntrunc__one__In1,axiom,
    ! [C: $tType,B: $tType,M: set(old_node(B,C))] : ( old_ntrunc(B,C,aa(nat,nat,suc,zero_zero(nat)),old_In1(B,C,M)) = bot_bot(set(old_node(B,C))) ) ).

% ntrunc_one_In1
tff(fact_5989_ntrunc__one__In0,axiom,
    ! [C: $tType,B: $tType,M: set(old_node(B,C))] : ( old_ntrunc(B,C,aa(nat,nat,suc,zero_zero(nat)),old_In0(B,C,M)) = bot_bot(set(old_node(B,C))) ) ).

% ntrunc_one_In0
tff(fact_5990_In1__UN1,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(D,set(old_node(B,C)))] : ( old_In1(B,C,aa(set(set(old_node(B,C))),set(old_node(B,C)),complete_Sup_Sup(set(old_node(B,C))),aa(set(D),set(set(old_node(B,C))),image2(D,set(old_node(B,C)),F2),top_top(set(D))))) = aa(set(set(old_node(B,C))),set(old_node(B,C)),complete_Sup_Sup(set(old_node(B,C))),aa(set(D),set(set(old_node(B,C))),image2(D,set(old_node(B,C)),aTP_Lamp_ayw(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C))),F2)),top_top(set(D)))) ) ).

% In1_UN1
tff(fact_5991_In0__UN1,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(D,set(old_node(B,C)))] : ( old_In0(B,C,aa(set(set(old_node(B,C))),set(old_node(B,C)),complete_Sup_Sup(set(old_node(B,C))),aa(set(D),set(set(old_node(B,C))),image2(D,set(old_node(B,C)),F2),top_top(set(D))))) = aa(set(set(old_node(B,C))),set(old_node(B,C)),complete_Sup_Sup(set(old_node(B,C))),aa(set(D),set(set(old_node(B,C))),image2(D,set(old_node(B,C)),aTP_Lamp_ayx(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C))),F2)),top_top(set(D)))) ) ).

% In0_UN1
tff(fact_5992_Case__def,axiom,
    ! [B: $tType,D: $tType,C: $tType,Ca: fun(set(old_node(C,D)),B),D3: fun(set(old_node(C,D)),B),M: set(old_node(C,D))] : ( old_Case(C,D,B,Ca,D3,M) = the(B,aa(set(old_node(C,D)),fun(B,$o),aa(fun(set(old_node(C,D)),B),fun(set(old_node(C,D)),fun(B,$o)),aTP_Lamp_ayy(fun(set(old_node(C,D)),B),fun(fun(set(old_node(C,D)),B),fun(set(old_node(C,D)),fun(B,$o))),Ca),D3),M)) ) ).

% Case_def
tff(fact_5993_dsum__def,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),S2: set(product_prod(set(old_node(B,C)),set(old_node(B,C))))] : ( old_dsum(B,C,R2,S2) = aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),sup_sup(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),complete_Sup_Sup(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),image2(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),fun(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),product_case_prod(set(old_node(B,C)),set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_ayz(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))))),R2))),aa(set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),complete_Sup_Sup(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),image2(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),fun(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),product_case_prod(set(old_node(B,C)),set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_aza(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))))),S2))) ) ).

% dsum_def
tff(fact_5994_dprod__def,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),S2: set(product_prod(set(old_node(B,C)),set(old_node(B,C))))] : ( old_dprod(B,C,R2,S2) = aa(set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),complete_Sup_Sup(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),image2(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),fun(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),product_case_prod(set(old_node(B,C)),set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_azc(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),S2))),R2)) ) ).

% dprod_def
tff(fact_5995_Scons__UN1__y,axiom,
    ! [B: $tType,C: $tType,D: $tType,M: set(old_node(B,C)),F2: fun(D,set(old_node(B,C)))] : ( old_Scons(B,C,M,aa(set(set(old_node(B,C))),set(old_node(B,C)),complete_Sup_Sup(set(old_node(B,C))),aa(set(D),set(set(old_node(B,C))),image2(D,set(old_node(B,C)),F2),top_top(set(D))))) = aa(set(set(old_node(B,C))),set(old_node(B,C)),complete_Sup_Sup(set(old_node(B,C))),aa(set(D),set(set(old_node(B,C))),image2(D,set(old_node(B,C)),aa(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C))),aTP_Lamp_azd(set(old_node(B,C)),fun(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C)))),M),F2)),top_top(set(D)))) ) ).

% Scons_UN1_y
tff(fact_5996_Scons__UN1__x,axiom,
    ! [B: $tType,C: $tType,D: $tType,F2: fun(D,set(old_node(B,C))),M: set(old_node(B,C))] : ( old_Scons(B,C,aa(set(set(old_node(B,C))),set(old_node(B,C)),complete_Sup_Sup(set(old_node(B,C))),aa(set(D),set(set(old_node(B,C))),image2(D,set(old_node(B,C)),F2),top_top(set(D)))),M) = aa(set(set(old_node(B,C))),set(old_node(B,C)),complete_Sup_Sup(set(old_node(B,C))),aa(set(D),set(set(old_node(B,C))),image2(D,set(old_node(B,C)),aa(set(old_node(B,C)),fun(D,set(old_node(B,C))),aTP_Lamp_aze(fun(D,set(old_node(B,C))),fun(set(old_node(B,C)),fun(D,set(old_node(B,C)))),F2),M)),top_top(set(D)))) ) ).

% Scons_UN1_x
tff(fact_5997_Split__def,axiom,
    ! [B: $tType,D: $tType,C: $tType,Ca: fun(set(old_node(C,D)),fun(set(old_node(C,D)),B)),M: set(old_node(C,D))] : ( aa(set(old_node(C,D)),B,old_Split(C,D,B,Ca),M) = the(B,aa(set(old_node(C,D)),fun(B,$o),aTP_Lamp_azf(fun(set(old_node(C,D)),fun(set(old_node(C,D)),B)),fun(set(old_node(C,D)),fun(B,$o)),Ca),M)) ) ).

% Split_def
tff(fact_5998_setr__def,axiom,
    ! [C: $tType,B: $tType,X4: sum_sum(B,C)] : ( aa(sum_sum(B,C),set(C),basic_setr(B,C),X4) = aa(fun(C,$o),set(C),collect(C),basic_setrp(B,C,X4)) ) ).

% setr_def
tff(fact_5999_setl__def,axiom,
    ! [C: $tType,B: $tType,X4: sum_sum(B,C)] : ( aa(sum_sum(B,C),set(B),basic_setl(B,C),X4) = aa(fun(B,$o),set(B),collect(B),basic_setlp(B,C,X4)) ) ).

% setl_def
tff(fact_6000_dsum__subset__Sigma,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),A3: set(set(old_node(B,C))),B2: set(set(old_node(B,C))),S2: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),C2: set(set(old_node(B,C))),D2: set(set(old_node(B,C)))] :
      ( aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o,aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o),ord_less_eq(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),R2),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),A3,aTP_Lamp_azg(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),B2)))
     => ( aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o,aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o),ord_less_eq(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),S2),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),C2,aTP_Lamp_azg(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),D2)))
       => aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o,aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o),ord_less_eq(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),old_dsum(B,C,R2,S2)),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),old_usum(B,C,A3,C2),aa(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),aTP_Lamp_azh(set(set(old_node(B,C))),fun(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C))))),B2),D2))) ) ) ).

% dsum_subset_Sigma
tff(fact_6001_dsum__Sigma,axiom,
    ! [C: $tType,B: $tType,A3: set(set(old_node(B,C))),B2: set(set(old_node(B,C))),C2: set(set(old_node(B,C))),D2: set(set(old_node(B,C)))] : aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o,aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o),ord_less_eq(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),old_dsum(B,C,product_Sigma(set(old_node(B,C)),set(old_node(B,C)),A3,aTP_Lamp_azg(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),B2)),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),C2,aTP_Lamp_azg(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),D2)))),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),old_usum(B,C,A3,C2),aa(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),aTP_Lamp_azh(set(set(old_node(B,C))),fun(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C))))),B2),D2))) ).

% dsum_Sigma
tff(fact_6002_dprod__Sigma,axiom,
    ! [C: $tType,B: $tType,A3: set(set(old_node(B,C))),B2: set(set(old_node(B,C))),C2: set(set(old_node(B,C))),D2: set(set(old_node(B,C)))] : aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o,aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o),ord_less_eq(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),old_dprod(B,C,product_Sigma(set(old_node(B,C)),set(old_node(B,C)),A3,aTP_Lamp_azg(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),B2)),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),C2,aTP_Lamp_azg(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),D2)))),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),old_uprod(B,C,A3,C2),aa(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),aTP_Lamp_azi(set(set(old_node(B,C))),fun(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C))))),B2),D2))) ).

% dprod_Sigma
tff(fact_6003_dprod__subset__Sigma,axiom,
    ! [C: $tType,B: $tType,R2: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),A3: set(set(old_node(B,C))),B2: set(set(old_node(B,C))),S2: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),C2: set(set(old_node(B,C))),D2: set(set(old_node(B,C)))] :
      ( aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o,aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o),ord_less_eq(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),R2),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),A3,aTP_Lamp_azg(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),B2)))
     => ( aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o,aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o),ord_less_eq(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),S2),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),C2,aTP_Lamp_azg(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),D2)))
       => aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o,aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o),ord_less_eq(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),old_dprod(B,C,R2,S2)),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),old_uprod(B,C,A3,C2),aa(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),aTP_Lamp_azi(set(set(old_node(B,C))),fun(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C))))),B2),D2))) ) ) ).

% dprod_subset_Sigma
tff(fact_6004_uprod__def,axiom,
    ! [C: $tType,B: $tType,A3: set(set(old_node(B,C))),B2: set(set(old_node(B,C)))] : ( old_uprod(B,C,A3,B2) = aa(set(set(set(old_node(B,C)))),set(set(old_node(B,C))),complete_Sup_Sup(set(set(old_node(B,C)))),aa(set(set(old_node(B,C))),set(set(set(old_node(B,C)))),image2(set(old_node(B,C)),set(set(old_node(B,C))),aTP_Lamp_azk(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),B2)),A3)) ) ).

% uprod_def
tff(fact_6005_dprod__subset__Sigma2,axiom,
    ! [C: $tType,B: $tType,A3: set(set(old_node(B,C))),B2: fun(set(old_node(B,C)),set(set(old_node(B,C)))),C2: set(set(old_node(B,C))),D2: fun(set(old_node(B,C)),set(set(old_node(B,C))))] : aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o,aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),$o),ord_less_eq(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),old_dprod(B,C,product_Sigma(set(old_node(B,C)),set(old_node(B,C)),A3,B2),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),C2,D2))),product_Sigma(set(old_node(B,C)),set(old_node(B,C)),old_uprod(B,C,A3,C2),old_Split(B,C,set(set(old_node(B,C))),aa(fun(set(old_node(B,C)),set(set(old_node(B,C)))),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(set(old_node(B,C))))),aTP_Lamp_azl(fun(set(old_node(B,C)),set(set(old_node(B,C)))),fun(fun(set(old_node(B,C)),set(set(old_node(B,C)))),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(set(old_node(B,C)))))),B2),D2)))) ).

% dprod_subset_Sigma2
tff(fact_6006_relH__def,axiom,
    ! [As2: set(nat),H2: heap_ext(product_unit),H5: heap_ext(product_unit)] :
      ( relH(As2,H2,H5)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As2))
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2))
        & ! [T8: typerep,X3: nat] :
            ( aa(set(nat),$o,member(nat,X3),As2)
           => ( ( refs(product_unit,H2,T8,X3) = refs(product_unit,H5,T8,X3) )
              & ( arrays(product_unit,H2,T8,X3) = arrays(product_unit,H5,T8,X3) ) ) ) ) ) ).

% relH_def
tff(fact_6007_int__decode__def,axiom,
    ! [N: nat] : ( nat_int_decode(N) = aa(sum_sum(nat,nat),int,sum_case_sum(nat,int,nat,semiring_1_of_nat(int),aTP_Lamp_azm(nat,int)),nat_sum_decode(N)) ) ).

% int_decode_def
tff(fact_6008_nat__to__rat__surj__def,axiom,
    ! [N: nat] : ( nat_to_rat_surj(N) = aa(product_prod(nat,nat),rat,aa(fun(nat,fun(nat,rat)),fun(product_prod(nat,nat),rat),product_case_prod(nat,nat,rat),aTP_Lamp_azn(nat,fun(nat,rat))),nat_prod_decode(N)) ) ).

% nat_to_rat_surj_def
tff(fact_6009_accp__eq__acc,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),X4: B] :
      ( aa(B,$o,accp(B,R2),X4)
    <=> aa(set(B),$o,member(B,X4),acc(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2)))) ) ).

% accp_eq_acc
tff(fact_6010_acc__def,axiom,
    ! [B: $tType,X4: set(product_prod(B,B))] : ( acc(B,X4) = aa(fun(B,$o),set(B),collect(B),accp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),X4))) ) ).

% acc_def
tff(fact_6011_accp__acc__eq,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),X4: B] :
      ( aa(B,$o,accp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2)),X4)
    <=> aa(set(B),$o,member(B,X4),acc(B,R2)) ) ).

% accp_acc_eq
tff(fact_6012_in__range_Opelims_I1_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X2)
      <=> (Y) )
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X2)
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( ( (Y)
                <=> ! [X3: nat] :
                      ( aa(set(nat),$o,member(nat,X3),As)
                     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),lim(product_unit,H4)) ) )
               => ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)) ) ) ) ) ).

% in_range.pelims(1)
tff(fact_6013_in__range_Opelims_I2_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X2)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X2)
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
               => ~ ! [X4: nat] :
                      ( aa(set(nat),$o,member(nat,X4),As)
                     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X4),lim(product_unit,H4)) ) ) ) ) ) ).

% in_range.pelims(2)
tff(fact_6014_in__range_Opelims_I3_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X2)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X2)
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
               => ! [X: nat] :
                    ( aa(set(nat),$o,member(nat,X),As)
                   => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),lim(product_unit,H4)) ) ) ) ) ) ).

% in_range.pelims(3)
tff(fact_6015_one__assn__raw_Opelims_I3_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X2)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X2)
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
               => ( As = bot_bot(set(nat)) ) ) ) ) ) ).

% one_assn_raw.pelims(3)
tff(fact_6016_one__assn__raw_Opelims_I2_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X2)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X2)
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
               => ( As != bot_bot(set(nat)) ) ) ) ) ) ).

% one_assn_raw.pelims(2)
tff(fact_6017_one__assn__raw_Opelims_I1_J,axiom,
    ! [X2: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X2)
      <=> (Y) )
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X2)
       => ~ ! [H4: heap_ext(product_unit),As: set(nat)] :
              ( ( X2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As) )
             => ( ( (Y)
                <=> ( As = bot_bot(set(nat)) ) )
               => ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)) ) ) ) ) ).

% one_assn_raw.pelims(1)
tff(fact_6018_to__nat__def,axiom,
    ! [B: $tType] :
      ( countable(B)
     => ( to_nat(B) = fChoice(fun(B,nat),aTP_Lamp_azo(fun(B,nat),$o)) ) ) ).

% to_nat_def
tff(fact_6019_fixp__induct,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [Pa: fun(B,$o),F2: fun(B,B)] :
          ( comple1908693960933563346ssible(B,complete_Sup_Sup(B),ord_less_eq(B),Pa)
         => ( comple7038119648293358887notone(B,B,ord_less_eq(B),ord_less_eq(B),F2)
           => ( aa(B,$o,Pa,aa(set(B),B,complete_Sup_Sup(B),bot_bot(set(B))))
             => ( ! [X: B] :
                    ( aa(B,$o,Pa,X)
                   => aa(B,$o,Pa,aa(B,B,F2,X)) )
               => aa(B,$o,Pa,comple115746919287870866o_fixp(B,F2)) ) ) ) ) ) ).

% fixp_induct
tff(fact_6020_let__mono,axiom,
    ! [C: $tType,D: $tType,B: $tType,Orda: fun(C,fun(C,$o)),Ordb: fun(D,fun(D,$o)),B3: fun(C,fun(B,D)),T3: B] :
      ( ! [X: B] : comple7038119648293358887notone(C,D,Orda,Ordb,aa(B,fun(C,D),aTP_Lamp_azp(fun(C,fun(B,D)),fun(B,fun(C,D)),B3),X))
     => comple7038119648293358887notone(C,D,Orda,Ordb,aa(B,fun(C,D),aTP_Lamp_azp(fun(C,fun(B,D)),fun(B,fun(C,D)),B3),T3)) ) ).

% let_mono
tff(fact_6021_if__mono,axiom,
    ! [B: $tType,C: $tType,Orda: fun(B,fun(B,$o)),Ordb: fun(C,fun(C,$o)),F: fun(B,C),G3: fun(B,C),Ca: $o] :
      ( comple7038119648293358887notone(B,C,Orda,Ordb,F)
     => ( comple7038119648293358887notone(B,C,Orda,Ordb,G3)
       => comple7038119648293358887notone(B,C,Orda,Ordb,aa($o,fun(B,C),aa(fun(B,C),fun($o,fun(B,C)),aTP_Lamp_azq(fun(B,C),fun(fun(B,C),fun($o,fun(B,C))),F),G3),Ca)) ) ) ).

% if_mono
tff(fact_6022_Array__Time_Oset__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A4: array(B),X2: list(B)] : ( array_set(B,A4,X2) = arrays_update(product_unit,aa(list(B),fun(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat)))),aTP_Lamp_azr(array(B),fun(list(B),fun(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat))))),A4),X2)) ) ) ).

% Array_Time.set_def
tff(fact_6023_Ref__Time_Oset__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R2: ref(B),X2: B] : ( ref_set(B,R2,X2) = refs_update(product_unit,aa(B,fun(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat))),aTP_Lamp_azs(ref(B),fun(B,fun(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat)))),R2),X2)) ) ) ).

% Ref_Time.set_def
tff(fact_6024_tailrec_Oconst__mono,axiom,
    ! [B: $tType,C: $tType,Ord: fun(B,fun(B,$o)),Ca: C] : comple7038119648293358887notone(B,C,Ord,partial_flat_ord(C,undefined(C)),aTP_Lamp_bm(C,fun(B,C),Ca)) ).

% tailrec.const_mono
tff(fact_6025_dir__image__def,axiom,
    ! [B: $tType,C: $tType,R2: set(product_prod(C,C)),F2: fun(C,B)] : ( bNF_We2720479622203943262_image(C,B,R2,F2) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(C,B),fun(product_prod(B,B),$o),aTP_Lamp_bx(set(product_prod(C,C)),fun(fun(C,B),fun(product_prod(B,B),$o)),R2),F2)) ) ).

% dir_image_def
tff(fact_6026_option_Oconst__mono,axiom,
    ! [B: $tType,C: $tType,Ord: fun(B,fun(B,$o)),Ca: option(C)] : comple7038119648293358887notone(B,option(C),Ord,partial_flat_ord(option(C),none(C)),aTP_Lamp_azt(option(C),fun(B,option(C)),Ca)) ).

% option.const_mono
tff(fact_6027_heap__step__admissible,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType,F10: $tType,Pa: fun(F10,fun(B,fun(D,fun(C,fun(E,$o))))),X2: F10] : comple1908693960933563346ssible(fun(B,option(product_prod(C,product_prod(D,E)))),partial_fun_lub(option(product_prod(C,product_prod(D,E))),option(product_prod(C,product_prod(D,E))),B,partial_flat_lub(option(product_prod(C,product_prod(D,E))),none(product_prod(C,product_prod(D,E))))),partial_fun_ord(option(product_prod(C,product_prod(D,E))),option(product_prod(C,product_prod(D,E))),B,partial_flat_ord(option(product_prod(C,product_prod(D,E))),none(product_prod(C,product_prod(D,E))))),aa(F10,fun(fun(B,option(product_prod(C,product_prod(D,E)))),$o),aTP_Lamp_azu(fun(F10,fun(B,fun(D,fun(C,fun(E,$o))))),fun(F10,fun(fun(B,option(product_prod(C,product_prod(D,E)))),$o)),Pa),X2)) ).

% heap_step_admissible
tff(fact_6028_map__mmupd__empty,axiom,
    ! [C: $tType,B: $tType,M2: fun(B,option(C)),V: C] : ( map_mmupd(B,C,M2,bot_bot(set(B)),V) = M2 ) ).

% map_mmupd_empty
tff(fact_6029_option__admissible,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o))] : comple1908693960933563346ssible(fun(B,option(C)),partial_fun_lub(option(C),option(C),B,partial_flat_lub(option(C),none(C))),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),aTP_Lamp_azv(fun(B,fun(C,$o)),fun(fun(B,option(C)),$o),Pa)) ).

% option_admissible
tff(fact_6030_call__mono,axiom,
    ! [C: $tType,B: $tType,Ord: fun(C,fun(C,$o)),T3: B] : comple7038119648293358887notone(fun(B,C),C,partial_fun_ord(C,C,B,Ord),Ord,aTP_Lamp_azw(B,fun(fun(B,C),C),T3)) ).

% call_mono
tff(fact_6031_fun__lub__def,axiom,
    ! [C: $tType,D: $tType,B: $tType,L4: fun(set(D),C),A3: set(fun(B,D)),X4: B] : ( aa(B,C,aa(set(fun(B,D)),fun(B,C),partial_fun_lub(D,C,B,L4),A3),X4) = aa(set(D),C,L4,aa(fun(D,$o),set(D),collect(D),aa(B,fun(D,$o),aTP_Lamp_azx(set(fun(B,D)),fun(B,fun(D,$o)),A3),X4))) ) ).

% fun_lub_def
tff(fact_6032_chain__fun,axiom,
    ! [C: $tType,B: $tType,Ord: fun(C,fun(C,$o)),A3: set(fun(B,C)),A4: B] :
      ( comple1602240252501008431_chain(fun(B,C),partial_fun_ord(C,C,B,Ord),A3)
     => comple1602240252501008431_chain(C,Ord,aa(fun(C,$o),set(C),collect(C),aa(B,fun(C,$o),aTP_Lamp_azy(set(fun(B,C)),fun(B,fun(C,$o)),A3),A4))) ) ).

% chain_fun
tff(fact_6033_tailrec__admissible,axiom,
    ! [C: $tType,B: $tType,Ca: C,Pa: fun(B,fun(C,$o))] : comple1908693960933563346ssible(fun(B,C),partial_fun_lub(C,C,B,partial_flat_lub(C,Ca)),partial_fun_ord(C,C,B,partial_flat_ord(C,Ca)),aa(fun(B,fun(C,$o)),fun(fun(B,C),$o),aTP_Lamp_azz(C,fun(fun(B,fun(C,$o)),fun(fun(B,C),$o)),Ca),Pa)) ).

% tailrec_admissible
tff(fact_6034_tailrec_Ofixp__induct__uc,axiom,
    ! [B: $tType,C: $tType,D: $tType,U2: fun(D,fun(B,C)),F: fun(D,D),C2: fun(fun(B,C),D),F2: D,Pa: fun(fun(B,C),$o)] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,C),C,partial_fun_ord(C,C,B,partial_flat_ord(C,undefined(C))),partial_flat_ord(C,undefined(C)),aa(B,fun(fun(B,C),C),aa(fun(fun(B,C),D),fun(B,fun(fun(B,C),C)),aa(fun(D,D),fun(fun(fun(B,C),D),fun(B,fun(fun(B,C),C))),aTP_Lamp_baa(fun(D,fun(B,C)),fun(fun(D,D),fun(fun(fun(B,C),D),fun(B,fun(fun(B,C),C)))),U2),F),C2),X))
     => ( ( F2 = aa(fun(B,C),D,C2,comple187402453842119260l_fixp(fun(B,C),partial_fun_lub(C,C,B,partial_flat_lub(C,undefined(C))),partial_fun_ord(C,C,B,partial_flat_ord(C,undefined(C))),aa(fun(fun(B,C),D),fun(fun(B,C),fun(B,C)),aa(fun(D,D),fun(fun(fun(B,C),D),fun(fun(B,C),fun(B,C))),aTP_Lamp_bab(fun(D,fun(B,C)),fun(fun(D,D),fun(fun(fun(B,C),D),fun(fun(B,C),fun(B,C)))),U2),F),C2))) )
       => ( ! [F9: fun(B,C)] : ( aa(D,fun(B,C),U2,aa(fun(B,C),D,C2,F9)) = F9 )
         => ( comple1908693960933563346ssible(fun(B,C),partial_fun_lub(C,C,B,partial_flat_lub(C,undefined(C))),partial_fun_ord(C,C,B,partial_flat_ord(C,undefined(C))),Pa)
           => ( aa(fun(B,C),$o,Pa,aTP_Lamp_ahe(B,C))
             => ( ! [F9: D] :
                    ( aa(fun(B,C),$o,Pa,aa(D,fun(B,C),U2,F9))
                   => aa(fun(B,C),$o,Pa,aa(D,fun(B,C),U2,aa(D,D,F,F9))) )
               => aa(fun(B,C),$o,Pa,aa(D,fun(B,C),U2,F2)) ) ) ) ) ) ) ).

% tailrec.fixp_induct_uc
tff(fact_6035_option_Ofixp__induct__uc,axiom,
    ! [B: $tType,C: $tType,D: $tType,U2: fun(D,fun(B,option(C))),F: fun(D,D),C2: fun(fun(B,option(C)),D),F2: D,Pa: fun(fun(B,option(C)),$o)] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,option(C)),option(C),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),partial_flat_ord(option(C),none(C)),aa(B,fun(fun(B,option(C)),option(C)),aa(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C))),aa(fun(D,D),fun(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C)))),aTP_Lamp_bac(fun(D,fun(B,option(C))),fun(fun(D,D),fun(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C))))),U2),F),C2),X))
     => ( ( F2 = aa(fun(B,option(C)),D,C2,comple187402453842119260l_fixp(fun(B,option(C)),partial_fun_lub(option(C),option(C),B,partial_flat_lub(option(C),none(C))),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),aa(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C))),aa(fun(D,D),fun(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C)))),aTP_Lamp_bad(fun(D,fun(B,option(C))),fun(fun(D,D),fun(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C))))),U2),F),C2))) )
       => ( ! [F9: fun(B,option(C))] : ( aa(D,fun(B,option(C)),U2,aa(fun(B,option(C)),D,C2,F9)) = F9 )
         => ( comple1908693960933563346ssible(fun(B,option(C)),partial_fun_lub(option(C),option(C),B,partial_flat_lub(option(C),none(C))),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),Pa)
           => ( aa(fun(B,option(C)),$o,Pa,aTP_Lamp_abb(B,option(C)))
             => ( ! [F9: D] :
                    ( aa(fun(B,option(C)),$o,Pa,aa(D,fun(B,option(C)),U2,F9))
                   => aa(fun(B,option(C)),$o,Pa,aa(D,fun(B,option(C)),U2,aa(D,D,F,F9))) )
               => aa(fun(B,option(C)),$o,Pa,aa(D,fun(B,option(C)),U2,F2)) ) ) ) ) ) ) ).

% option.fixp_induct_uc
tff(fact_6036_fixp__induct__tailrec,axiom,
    ! [D: $tType,B: $tType,C: $tType,Ca: C,U2: fun(D,fun(B,C)),F: fun(D,D),C2: fun(fun(B,C),D),F2: D,Pa: fun(B,fun(C,$o)),X2: B,Y: C] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,C),C,partial_fun_ord(C,C,B,partial_flat_ord(C,Ca)),partial_flat_ord(C,Ca),aa(B,fun(fun(B,C),C),aa(fun(fun(B,C),D),fun(B,fun(fun(B,C),C)),aa(fun(D,D),fun(fun(fun(B,C),D),fun(B,fun(fun(B,C),C))),aTP_Lamp_baa(fun(D,fun(B,C)),fun(fun(D,D),fun(fun(fun(B,C),D),fun(B,fun(fun(B,C),C)))),U2),F),C2),X))
     => ( ( F2 = aa(fun(B,C),D,C2,comple187402453842119260l_fixp(fun(B,C),partial_fun_lub(C,C,B,partial_flat_lub(C,Ca)),partial_fun_ord(C,C,B,partial_flat_ord(C,Ca)),aa(fun(fun(B,C),D),fun(fun(B,C),fun(B,C)),aa(fun(D,D),fun(fun(fun(B,C),D),fun(fun(B,C),fun(B,C))),aTP_Lamp_bab(fun(D,fun(B,C)),fun(fun(D,D),fun(fun(fun(B,C),D),fun(fun(B,C),fun(B,C)))),U2),F),C2))) )
       => ( ! [F9: fun(B,C)] : ( aa(D,fun(B,C),U2,aa(fun(B,C),D,C2,F9)) = F9 )
         => ( ! [F9: D,X: B,Y2: C] :
                ( ! [Xa3: B,Ya: C] :
                    ( ( aa(B,C,aa(D,fun(B,C),U2,F9),Xa3) = Ya )
                   => ( ( Ya != Ca )
                     => aa(C,$o,aa(B,fun(C,$o),Pa,Xa3),Ya) ) )
               => ( ( aa(B,C,aa(D,fun(B,C),U2,aa(D,D,F,F9)),X) = Y2 )
                 => ( ( Y2 != Ca )
                   => aa(C,$o,aa(B,fun(C,$o),Pa,X),Y2) ) ) )
           => ( ( aa(B,C,aa(D,fun(B,C),U2,F2),X2) = Y )
             => ( ( Y != Ca )
               => aa(C,$o,aa(B,fun(C,$o),Pa,X2),Y) ) ) ) ) ) ) ).

% fixp_induct_tailrec
tff(fact_6037_option_Omono__body__fixp,axiom,
    ! [C: $tType,B: $tType,F: fun(fun(B,option(C)),fun(B,option(C)))] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,option(C)),option(C),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),partial_flat_ord(option(C),none(C)),aa(B,fun(fun(B,option(C)),option(C)),aTP_Lamp_bae(fun(fun(B,option(C)),fun(B,option(C))),fun(B,fun(fun(B,option(C)),option(C))),F),X))
     => ( comple187402453842119260l_fixp(fun(B,option(C)),partial_fun_lub(option(C),option(C),B,partial_flat_lub(option(C),none(C))),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),F) = aa(fun(B,option(C)),fun(B,option(C)),F,comple187402453842119260l_fixp(fun(B,option(C)),partial_fun_lub(option(C),option(C),B,partial_flat_lub(option(C),none(C))),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),F)) ) ) ).

% option.mono_body_fixp
tff(fact_6038_option_Ofixp__rule__uc,axiom,
    ! [B: $tType,C: $tType,D: $tType,U2: fun(D,fun(B,option(C))),F: fun(D,D),C2: fun(fun(B,option(C)),D),F2: D] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,option(C)),option(C),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),partial_flat_ord(option(C),none(C)),aa(B,fun(fun(B,option(C)),option(C)),aa(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C))),aa(fun(D,D),fun(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C)))),aTP_Lamp_bac(fun(D,fun(B,option(C))),fun(fun(D,D),fun(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C))))),U2),F),C2),X))
     => ( ( F2 = aa(fun(B,option(C)),D,C2,comple187402453842119260l_fixp(fun(B,option(C)),partial_fun_lub(option(C),option(C),B,partial_flat_lub(option(C),none(C))),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),aa(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C))),aa(fun(D,D),fun(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C)))),aTP_Lamp_bad(fun(D,fun(B,option(C))),fun(fun(D,D),fun(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C))))),U2),F),C2))) )
       => ( ! [F9: D] : ( aa(fun(B,option(C)),D,C2,aa(D,fun(B,option(C)),U2,F9)) = F9 )
         => ( F2 = aa(D,D,F,F2) ) ) ) ) ).

% option.fixp_rule_uc
tff(fact_6039_tailrec_Omono__body__fixp,axiom,
    ! [C: $tType,B: $tType,F: fun(fun(B,C),fun(B,C))] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,C),C,partial_fun_ord(C,C,B,partial_flat_ord(C,undefined(C))),partial_flat_ord(C,undefined(C)),aa(B,fun(fun(B,C),C),aTP_Lamp_baf(fun(fun(B,C),fun(B,C)),fun(B,fun(fun(B,C),C)),F),X))
     => ( comple187402453842119260l_fixp(fun(B,C),partial_fun_lub(C,C,B,partial_flat_lub(C,undefined(C))),partial_fun_ord(C,C,B,partial_flat_ord(C,undefined(C))),F) = aa(fun(B,C),fun(B,C),F,comple187402453842119260l_fixp(fun(B,C),partial_fun_lub(C,C,B,partial_flat_lub(C,undefined(C))),partial_fun_ord(C,C,B,partial_flat_ord(C,undefined(C))),F)) ) ) ).

% tailrec.mono_body_fixp
tff(fact_6040_tailrec_Ofixp__rule__uc,axiom,
    ! [B: $tType,C: $tType,D: $tType,U2: fun(D,fun(B,C)),F: fun(D,D),C2: fun(fun(B,C),D),F2: D] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,C),C,partial_fun_ord(C,C,B,partial_flat_ord(C,undefined(C))),partial_flat_ord(C,undefined(C)),aa(B,fun(fun(B,C),C),aa(fun(fun(B,C),D),fun(B,fun(fun(B,C),C)),aa(fun(D,D),fun(fun(fun(B,C),D),fun(B,fun(fun(B,C),C))),aTP_Lamp_baa(fun(D,fun(B,C)),fun(fun(D,D),fun(fun(fun(B,C),D),fun(B,fun(fun(B,C),C)))),U2),F),C2),X))
     => ( ( F2 = aa(fun(B,C),D,C2,comple187402453842119260l_fixp(fun(B,C),partial_fun_lub(C,C,B,partial_flat_lub(C,undefined(C))),partial_fun_ord(C,C,B,partial_flat_ord(C,undefined(C))),aa(fun(fun(B,C),D),fun(fun(B,C),fun(B,C)),aa(fun(D,D),fun(fun(fun(B,C),D),fun(fun(B,C),fun(B,C))),aTP_Lamp_bab(fun(D,fun(B,C)),fun(fun(D,D),fun(fun(fun(B,C),D),fun(fun(B,C),fun(B,C)))),U2),F),C2))) )
       => ( ! [F9: D] : ( aa(fun(B,C),D,C2,aa(D,fun(B,C),U2,F9)) = F9 )
         => ( F2 = aa(D,D,F,F2) ) ) ) ) ).

% tailrec.fixp_rule_uc
tff(fact_6041_fixp__induct__option,axiom,
    ! [D: $tType,B: $tType,C: $tType,U2: fun(D,fun(B,option(C))),F: fun(D,D),C2: fun(fun(B,option(C)),D),F2: D,Pa: fun(B,fun(C,$o)),X2: B,Y: C] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,option(C)),option(C),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),partial_flat_ord(option(C),none(C)),aa(B,fun(fun(B,option(C)),option(C)),aa(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C))),aa(fun(D,D),fun(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C)))),aTP_Lamp_bac(fun(D,fun(B,option(C))),fun(fun(D,D),fun(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C))))),U2),F),C2),X))
     => ( ( F2 = aa(fun(B,option(C)),D,C2,comple187402453842119260l_fixp(fun(B,option(C)),partial_fun_lub(option(C),option(C),B,partial_flat_lub(option(C),none(C))),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),aa(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C))),aa(fun(D,D),fun(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C)))),aTP_Lamp_bad(fun(D,fun(B,option(C))),fun(fun(D,D),fun(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C))))),U2),F),C2))) )
       => ( ! [F9: fun(B,option(C))] : ( aa(D,fun(B,option(C)),U2,aa(fun(B,option(C)),D,C2,F9)) = F9 )
         => ( ! [F9: D,X: B,Y2: C] :
                ( ! [Xa3: B,Ya: C] :
                    ( ( aa(B,option(C),aa(D,fun(B,option(C)),U2,F9),Xa3) = aa(C,option(C),some(C),Ya) )
                   => aa(C,$o,aa(B,fun(C,$o),Pa,Xa3),Ya) )
               => ( ( aa(B,option(C),aa(D,fun(B,option(C)),U2,aa(D,D,F,F9)),X) = aa(C,option(C),some(C),Y2) )
                 => aa(C,$o,aa(B,fun(C,$o),Pa,X),Y2) ) )
           => ( ( aa(B,option(C),aa(D,fun(B,option(C)),U2,F2),X2) = aa(C,option(C),some(C),Y) )
             => aa(C,$o,aa(B,fun(C,$o),Pa,X2),Y) ) ) ) ) ) ).

% fixp_induct_option
tff(fact_6042_partial__function__definitions_Ofixp__induct__uc,axiom,
    ! [C: $tType,B: $tType,D: $tType,Leq: fun(B,fun(B,$o)),Lub: fun(set(B),B),U2: fun(D,fun(C,B)),F: fun(D,D),C2: fun(fun(C,B),D),F2: D,Pa: fun(fun(C,B),$o)] :
      ( partia7178651479351089652itions(B,Leq,Lub)
     => ( ! [X: C] : comple7038119648293358887notone(fun(C,B),B,partial_fun_ord(B,B,C,Leq),Leq,aa(C,fun(fun(C,B),B),aa(fun(fun(C,B),D),fun(C,fun(fun(C,B),B)),aa(fun(D,D),fun(fun(fun(C,B),D),fun(C,fun(fun(C,B),B))),aTP_Lamp_bag(fun(D,fun(C,B)),fun(fun(D,D),fun(fun(fun(C,B),D),fun(C,fun(fun(C,B),B)))),U2),F),C2),X))
       => ( ( F2 = aa(fun(C,B),D,C2,comple187402453842119260l_fixp(fun(C,B),partial_fun_lub(B,B,C,Lub),partial_fun_ord(B,B,C,Leq),aa(fun(fun(C,B),D),fun(fun(C,B),fun(C,B)),aa(fun(D,D),fun(fun(fun(C,B),D),fun(fun(C,B),fun(C,B))),aTP_Lamp_bah(fun(D,fun(C,B)),fun(fun(D,D),fun(fun(fun(C,B),D),fun(fun(C,B),fun(C,B)))),U2),F),C2))) )
         => ( ! [F9: fun(C,B)] : ( aa(D,fun(C,B),U2,aa(fun(C,B),D,C2,F9)) = F9 )
           => ( comple1908693960933563346ssible(fun(C,B),partial_fun_lub(B,B,C,Lub),partial_fun_ord(B,B,C,Leq),Pa)
             => ( aa(fun(C,B),$o,Pa,aTP_Lamp_bai(fun(set(B),B),fun(C,B),Lub))
               => ( ! [F9: D] :
                      ( aa(fun(C,B),$o,Pa,aa(D,fun(C,B),U2,F9))
                     => aa(fun(C,B),$o,Pa,aa(D,fun(C,B),U2,aa(D,D,F,F9))) )
                 => aa(fun(C,B),$o,Pa,aa(D,fun(C,B),U2,F2)) ) ) ) ) ) ) ) ).

% partial_function_definitions.fixp_induct_uc
tff(fact_6043_admissible__fun,axiom,
    ! [B: $tType,C: $tType,Le: fun(B,fun(B,$o)),Lub: fun(set(B),B),Qa: fun(C,fun(B,$o))] :
      ( partia7178651479351089652itions(B,Le,Lub)
     => ( ! [X: C] : comple1908693960933563346ssible(B,Lub,Le,aa(C,fun(B,$o),Qa,X))
       => comple1908693960933563346ssible(fun(C,B),partial_fun_lub(B,B,C,Lub),partial_fun_ord(B,B,C,Le),aTP_Lamp_baj(fun(C,fun(B,$o)),fun(fun(C,B),$o),Qa)) ) ) ).

% admissible_fun
tff(fact_6044_partial__function__definitions_Oconst__mono,axiom,
    ! [C: $tType,B: $tType,Leq: fun(B,fun(B,$o)),Lub: fun(set(B),B),Ord: fun(C,fun(C,$o)),Ca: B] :
      ( partia7178651479351089652itions(B,Leq,Lub)
     => comple7038119648293358887notone(C,B,Ord,Leq,aa(B,fun(C,B),aTP_Lamp_cy(B,fun(C,B)),Ca)) ) ).

% partial_function_definitions.const_mono
tff(fact_6045_partial__function__definitions_Ofixp__rule__uc,axiom,
    ! [C: $tType,B: $tType,D: $tType,Leq: fun(B,fun(B,$o)),Lub: fun(set(B),B),U2: fun(D,fun(C,B)),F: fun(D,D),C2: fun(fun(C,B),D),F2: D] :
      ( partia7178651479351089652itions(B,Leq,Lub)
     => ( ! [X: C] : comple7038119648293358887notone(fun(C,B),B,partial_fun_ord(B,B,C,Leq),Leq,aa(C,fun(fun(C,B),B),aa(fun(fun(C,B),D),fun(C,fun(fun(C,B),B)),aa(fun(D,D),fun(fun(fun(C,B),D),fun(C,fun(fun(C,B),B))),aTP_Lamp_bag(fun(D,fun(C,B)),fun(fun(D,D),fun(fun(fun(C,B),D),fun(C,fun(fun(C,B),B)))),U2),F),C2),X))
       => ( ( F2 = aa(fun(C,B),D,C2,comple187402453842119260l_fixp(fun(C,B),partial_fun_lub(B,B,C,Lub),partial_fun_ord(B,B,C,Leq),aa(fun(fun(C,B),D),fun(fun(C,B),fun(C,B)),aa(fun(D,D),fun(fun(fun(C,B),D),fun(fun(C,B),fun(C,B))),aTP_Lamp_bah(fun(D,fun(C,B)),fun(fun(D,D),fun(fun(fun(C,B),D),fun(fun(C,B),fun(C,B)))),U2),F),C2))) )
         => ( ! [F9: D] : ( aa(fun(C,B),D,C2,aa(D,fun(C,B),U2,F9)) = F9 )
           => ( F2 = aa(D,D,F,F2) ) ) ) ) ) ).

% partial_function_definitions.fixp_rule_uc
tff(fact_6046_partial__function__definitions_Omono__body__fixp,axiom,
    ! [B: $tType,C: $tType,Leq: fun(B,fun(B,$o)),Lub: fun(set(B),B),F: fun(fun(C,B),fun(C,B))] :
      ( partia7178651479351089652itions(B,Leq,Lub)
     => ( ! [X: C] : comple7038119648293358887notone(fun(C,B),B,partial_fun_ord(B,B,C,Leq),Leq,aa(C,fun(fun(C,B),B),aTP_Lamp_bak(fun(fun(C,B),fun(C,B)),fun(C,fun(fun(C,B),B)),F),X))
       => ( comple187402453842119260l_fixp(fun(C,B),partial_fun_lub(B,B,C,Lub),partial_fun_ord(B,B,C,Leq),F) = aa(fun(C,B),fun(C,B),F,comple187402453842119260l_fixp(fun(C,B),partial_fun_lub(B,B,C,Lub),partial_fun_ord(B,B,C,Leq),F)) ) ) ) ).

% partial_function_definitions.mono_body_fixp
tff(fact_6047_Partial__Function_Obind__mono,axiom,
    ! [E: $tType,C: $tType,B: $tType,D: $tType,B2: fun(fun(B,option(C)),option(D)),C2: fun(D,fun(fun(B,option(C)),option(E)))] :
      ( comple7038119648293358887notone(fun(B,option(C)),option(D),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),partial_flat_ord(option(D),none(D)),B2)
     => ( ! [Y2: D] : comple7038119648293358887notone(fun(B,option(C)),option(E),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),partial_flat_ord(option(E),none(E)),aa(D,fun(fun(B,option(C)),option(E)),C2,Y2))
       => comple7038119648293358887notone(fun(B,option(C)),option(E),partial_fun_ord(option(C),option(C),B,partial_flat_ord(option(C),none(C))),partial_flat_ord(option(E),none(E)),aa(fun(D,fun(fun(B,option(C)),option(E))),fun(fun(B,option(C)),option(E)),aTP_Lamp_bam(fun(fun(B,option(C)),option(D)),fun(fun(D,fun(fun(B,option(C)),option(E))),fun(fun(B,option(C)),option(E))),B2),C2)) ) ) ).

% Partial_Function.bind_mono
tff(fact_6048_heap_Ofixp__induct__uc,axiom,
    ! [B: $tType,C: $tType,D: $tType,U2: fun(D,fun(B,heap_Time_Heap(C))),F: fun(D,D),C2: fun(fun(B,heap_Time_Heap(C)),D),F2: D,Pa: fun(fun(B,heap_Time_Heap(C)),$o)] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)))),aTP_Lamp_ban(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))))),U2),F),C2),X))
     => ( ( F2 = aa(fun(B,heap_Time_Heap(C)),D,C2,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)))),aTP_Lamp_bao(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))))),U2),F),C2))) )
       => ( ! [F9: fun(B,heap_Time_Heap(C))] : ( aa(D,fun(B,heap_Time_Heap(C)),U2,aa(fun(B,heap_Time_Heap(C)),D,C2,F9)) = F9 )
         => ( comple1908693960933563346ssible(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),Pa)
           => ( aa(fun(B,heap_Time_Heap(C)),$o,Pa,aTP_Lamp_baq(B,heap_Time_Heap(C)))
             => ( ! [F9: D] :
                    ( aa(fun(B,heap_Time_Heap(C)),$o,Pa,aa(D,fun(B,heap_Time_Heap(C)),U2,F9))
                   => aa(fun(B,heap_Time_Heap(C)),$o,Pa,aa(D,fun(B,heap_Time_Heap(C)),U2,aa(D,D,F,F9))) )
               => aa(fun(B,heap_Time_Heap(C)),$o,Pa,aa(D,fun(B,heap_Time_Heap(C)),U2,F2)) ) ) ) ) ) ) ).

% heap.fixp_induct_uc
tff(fact_6049_bind__assoc,axiom,
    ! [D: $tType,B: $tType,C: $tType,X2: option(D),F2: fun(D,option(C)),G: fun(C,option(B))] : ( bind2(C,B,bind2(D,C,X2,F2),G) = bind2(D,B,X2,aa(fun(C,option(B)),fun(D,option(B)),aTP_Lamp_bar(fun(D,option(C)),fun(fun(C,option(B)),fun(D,option(B))),F2),G)) ) ).

% bind_assoc
tff(fact_6050_bind__rzero,axiom,
    ! [C: $tType,B: $tType,X2: option(C)] : ( bind2(C,B,X2,aTP_Lamp_acp(C,option(B))) = none(B) ) ).

% bind_rzero
tff(fact_6051_heap_Oconst__mono,axiom,
    ! [B: $tType,C: $tType,Ord: fun(B,fun(B,$o)),Ca: heap_Time_Heap(C)] : comple7038119648293358887notone(B,heap_Time_Heap(C),Ord,heap_Time_Heap_ord(C),aTP_Lamp_bas(heap_Time_Heap(C),fun(B,heap_Time_Heap(C)),Ca)) ).

% heap.const_mono
tff(fact_6052_heap_Omono__body__fixp,axiom,
    ! [C: $tType,B: $tType,F: fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)))] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aTP_Lamp_bat(fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),F),X))
     => ( comple187402453842119260l_fixp(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),F) = aa(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)),F,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),F)) ) ) ).

% heap.mono_body_fixp
tff(fact_6053_heap_Ofixp__rule__uc,axiom,
    ! [B: $tType,C: $tType,D: $tType,U2: fun(D,fun(B,heap_Time_Heap(C))),F: fun(D,D),C2: fun(fun(B,heap_Time_Heap(C)),D),F2: D] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)))),aTP_Lamp_ban(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))))),U2),F),C2),X))
     => ( ( F2 = aa(fun(B,heap_Time_Heap(C)),D,C2,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)))),aTP_Lamp_bao(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))))),U2),F),C2))) )
       => ( ! [F9: D] : ( aa(fun(B,heap_Time_Heap(C)),D,C2,aa(D,fun(B,heap_Time_Heap(C)),U2,F9)) = F9 )
         => ( F2 = aa(D,D,F,F2) ) ) ) ) ).

% heap.fixp_rule_uc
tff(fact_6054_Heap__Time__Monad_Obind__mono,axiom,
    ! [E: $tType,C: $tType,B: $tType,D: $tType,B2: fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D)),C2: fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E)))] :
      ( comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(D),B2)
     => ( ! [Y2: D] : comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(E),aa(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E)),C2,Y2))
       => comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(E),aa(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E)),aTP_Lamp_bav(fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D)),fun(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),B2),C2)) ) ) ).

% Heap_Time_Monad.bind_mono
tff(fact_6055_fixp__induct__heap,axiom,
    ! [D: $tType,C: $tType,B: $tType,U2: fun(D,fun(B,heap_Time_Heap(C))),F: fun(D,D),C2: fun(fun(B,heap_Time_Heap(C)),D),F2: D,Pa: fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))))),X2: B,H2: heap_ext(product_unit),H5: heap_ext(product_unit),R2: C,N: nat] :
      ( ! [X: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)))),aTP_Lamp_ban(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))))),U2),F),C2),X))
     => ( ( F2 = aa(fun(B,heap_Time_Heap(C)),D,C2,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)))),aTP_Lamp_bao(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))))),U2),F),C2))) )
       => ( ! [F9: fun(B,heap_Time_Heap(C))] : ( aa(D,fun(B,heap_Time_Heap(C)),U2,aa(fun(B,heap_Time_Heap(C)),D,C2,F9)) = F9 )
         => ( ! [F9: D,X: B,H4: heap_ext(product_unit),H3: heap_ext(product_unit),R3: C,N2: nat] :
                ( ! [Xa3: B,Ha: heap_ext(product_unit),H_a: heap_ext(product_unit),Ra3: C,Na: nat] :
                    ( heap_Time_effect(C,aa(B,heap_Time_Heap(C),aa(D,fun(B,heap_Time_Heap(C)),U2,F9),Xa3),Ha,H_a,Ra3,Na)
                   => aa(nat,$o,aa(C,fun(nat,$o),aa(heap_ext(product_unit),fun(C,fun(nat,$o)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o)))),Pa,Xa3),Ha),H_a),Ra3),Na) )
               => ( heap_Time_effect(C,aa(B,heap_Time_Heap(C),aa(D,fun(B,heap_Time_Heap(C)),U2,aa(D,D,F,F9)),X),H4,H3,R3,N2)
                 => aa(nat,$o,aa(C,fun(nat,$o),aa(heap_ext(product_unit),fun(C,fun(nat,$o)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o)))),Pa,X),H4),H3),R3),N2) ) )
           => ( heap_Time_effect(C,aa(B,heap_Time_Heap(C),aa(D,fun(B,heap_Time_Heap(C)),U2,F2),X2),H2,H5,R2,N)
             => aa(nat,$o,aa(C,fun(nat,$o),aa(heap_ext(product_unit),fun(C,fun(nat,$o)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o)))),Pa,X2),H2),H5),R2),N) ) ) ) ) ) ).

% fixp_induct_heap
tff(fact_6056_admissible__heap,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o)))))] : comple1908693960933563346ssible(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),aTP_Lamp_baw(fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))))),fun(fun(B,heap_Time_Heap(C)),$o),Pa)) ).

% admissible_heap
tff(fact_6057_sum__set__upto__conv__sum__list__int,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [F2: fun(int,B),I2: int,J2: int] : ( aa(set(int),B,aa(fun(int,B),fun(set(int),B),groups7311177749621191930dd_sum(int,B),F2),aa(list(int),set(int),set2(int),upto(I2,J2))) = aa(list(B),B,groups8242544230860333062m_list(B),aa(list(int),list(B),map(int,B,F2),upto(I2,J2))) ) ) ).

% sum_set_upto_conv_sum_list_int
tff(fact_6058_interv__sum__list__conv__sum__set__int,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [F2: fun(int,B),K: int,L: int] : ( aa(list(B),B,groups8242544230860333062m_list(B),aa(list(int),list(B),map(int,B,F2),upto(K,L))) = aa(set(int),B,aa(fun(int,B),fun(set(int),B),groups7311177749621191930dd_sum(int,B),F2),aa(list(int),set(int),set2(int),upto(K,L))) ) ) ).

% interv_sum_list_conv_sum_set_int
tff(fact_6059_sort__upto,axiom,
    ! [I2: int,J2: int] : ( aa(list(int),list(int),linorder_sort_key(int,int,aTP_Lamp_rw(int,int)),upto(I2,J2)) = upto(I2,J2) ) ).

% sort_upto
tff(fact_6060_card_Ofolding__axioms,axiom,
    ! [B: $tType] : finite_folding(B,nat,aTP_Lamp_st(B,fun(nat,nat))) ).

% card.folding_axioms
tff(fact_6061_sum_Odisc__eq__case_I1_J,axiom,
    ! [C: $tType,B: $tType,Sum: sum_sum(B,C)] :
      ( sum_isl(B,C,Sum)
    <=> aa(sum_sum(B,C),$o,sum_case_sum(B,$o,C,aTP_Lamp_nh(B,$o),aTP_Lamp_avf(C,$o)),Sum) ) ).

% sum.disc_eq_case(1)
tff(fact_6062_sum_Odisc__eq__case_I2_J,axiom,
    ! [C: $tType,B: $tType,Sum: sum_sum(B,C)] :
      ( ~ sum_isl(B,C,Sum)
    <=> aa(sum_sum(B,C),$o,sum_case_sum(B,$o,C,aTP_Lamp_ao(B,$o),aTP_Lamp_ahl(C,$o)),Sum) ) ).

% sum.disc_eq_case(2)
tff(fact_6063_scomp__fcomp,axiom,
    ! [B: $tType,E: $tType,F10: $tType,C: $tType,D: $tType,F2: fun(B,product_prod(E,F10)),G: fun(E,fun(F10,D)),H2: fun(D,C)] : ( fcomp(B,D,C,product_scomp(B,E,F10,D,F2,G),H2) = product_scomp(B,E,F10,C,F2,aa(fun(D,C),fun(E,fun(F10,C)),aTP_Lamp_bax(fun(E,fun(F10,D)),fun(fun(D,C),fun(E,fun(F10,C))),G),H2)) ) ).

% scomp_fcomp
tff(fact_6064_bot__in__iterates,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [F2: fun(B,B)] : aa(set(B),$o,member(B,aa(set(B),B,complete_Sup_Sup(B),bot_bot(set(B)))),comple6359979572994053840erates(B,F2)) ) ).

% bot_in_iterates
tff(fact_6065_iterates__def,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [X4: fun(B,B)] : ( comple6359979572994053840erates(B,X4) = aa(fun(B,$o),set(B),collect(B),comple7512665784863727008ratesp(B,X4)) ) ) ).

% iterates_def
tff(fact_6066_sym__Int__converse,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] : sym(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),converse(B,B,R2))) ).

% sym_Int_converse
tff(fact_6067_Heap_Oempty__def,axiom,
    empty = heap_ext2(product_unit,aTP_Lamp_bay(typerep,fun(nat,list(nat))),aTP_Lamp_baz(typerep,fun(nat,nat)),zero_zero(nat),product_Unity) ).

% Heap.empty_def
tff(fact_6068_sym__Int,axiom,
    ! [B: $tType,R2: set(product_prod(B,B)),S2: set(product_prod(B,B))] :
      ( sym(B,R2)
     => ( sym(B,S2)
       => sym(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R2),S2)) ) ) ).

% sym_Int
tff(fact_6069_array_Oset,axiom,
    ! [B: $tType,X2: nat] : ( set_array(B,array2(B,X2)) = bot_bot(set(B)) ) ).

% array.set
tff(fact_6070_ref_Oset,axiom,
    ! [B: $tType,X2: nat] : ( set_ref(B,ref2(B,X2)) = bot_bot(set(B)) ) ).

% ref.set
tff(fact_6071_Quotient3__to__Quotient__equivp,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(B,$o)),Abs: fun(B,C),Rep: fun(C,B),T2: fun(B,fun(C,$o))] :
      ( quotient3(B,C,R,Abs,Rep)
     => ( ! [X: B] : ( aa(B,fun(C,$o),T2,X) = aa(C,fun(C,$o),fequal(C),aa(B,C,Abs,X)) )
       => ( equiv_equivp(B,R)
         => quotient(B,C,R,Abs,Rep,T2) ) ) ) ).

% Quotient3_to_Quotient_equivp
tff(fact_6072_quot__type_Osome__collect,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(B,$o)),Abs: fun(set(B),C),Rep: fun(C,set(B)),R2: B] :
      ( quot_type(B,C,R,Abs,Rep)
     => ( aa(B,$o,aa(B,fun(B,$o),R,R2),R2)
       => ( aa(B,fun(B,$o),R,fChoice(B,aa(B,fun(B,$o),aTP_Lamp_bba(fun(B,fun(B,$o)),fun(B,fun(B,$o)),R),R2))) = aa(B,fun(B,$o),R,R2) ) ) ) ).

% quot_type.some_collect
tff(fact_6073_lambda__prs1,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,R1: fun(B,fun(B,$o)),Abs1: fun(B,C),Rep1: fun(C,B),R22: fun(D,fun(D,$o)),Abs2: fun(D,E),Rep2: fun(E,D),F2: fun(C,E)] :
      ( quotient3(B,C,R1,Abs1,Rep1)
     => ( quotient3(D,E,R22,Abs2,Rep2)
       => ( aa(fun(B,D),fun(C,E),map_fun(C,B,D,E,Rep1,Abs2),aa(fun(C,E),fun(B,D),map_fun(B,C,E,D,Abs1,Rep2),F2)) = F2 ) ) ) ).

% lambda_prs1
tff(fact_6074_lambda__prs,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,R1: fun(B,fun(B,$o)),Abs1: fun(B,C),Rep1: fun(C,B),R22: fun(D,fun(D,$o)),Abs2: fun(D,E),Rep2: fun(E,D),F2: fun(C,E)] :
      ( quotient3(B,C,R1,Abs1,Rep1)
     => ( quotient3(D,E,R22,Abs2,Rep2)
       => ( aa(fun(B,D),fun(C,E),map_fun(C,B,D,E,Rep1,Abs2),aa(fun(C,E),fun(B,D),aa(fun(E,D),fun(fun(C,E),fun(B,D)),aTP_Lamp_bbb(fun(B,C),fun(fun(E,D),fun(fun(C,E),fun(B,D))),Abs1),Rep2),F2)) = F2 ) ) ) ).

% lambda_prs
tff(fact_6075_Quotient3__to__Quotient,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(B,$o)),Abs: fun(B,C),Rep: fun(C,B),T2: fun(B,fun(C,$o))] :
      ( quotient3(B,C,R,Abs,Rep)
     => ( ! [X: B,Xa4: C] :
            ( aa(C,$o,aa(B,fun(C,$o),T2,X),Xa4)
          <=> ( aa(B,$o,aa(B,fun(B,$o),R,X),X)
              & ( aa(B,C,Abs,X) = Xa4 ) ) )
       => quotient(B,C,R,Abs,Rep,T2) ) ) ).

% Quotient3_to_Quotient
tff(fact_6076_quot__type_Orep__def,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(B,$o)),Abs: fun(set(B),C),Rep: fun(C,set(B)),A4: C] :
      ( quot_type(B,C,R,Abs,Rep)
     => ( quot_rep(C,B,Rep,A4) = fChoice(B,aa(C,fun(B,$o),aTP_Lamp_hm(fun(C,set(B)),fun(C,fun(B,$o)),Rep),A4)) ) ) ).

% quot_type.rep_def
tff(fact_6077_toCard__def,axiom,
    ! [B: $tType,C: $tType,A3: set(B),R2: set(product_prod(C,C))] : ( bNF_Greatest_toCard(B,C,A3,R2) = fChoice(fun(B,C),bNF_Gr1419584066657907630d_pred(B,C,A3,R2)) ) ).

% toCard_def
tff(fact_6078_fromCard__def,axiom,
    ! [B: $tType,C: $tType,A3: set(B),R2: set(product_prod(C,C)),K: C] : ( bNF_Gr5436034075474128252omCard(B,C,A3,R2,K) = fChoice(B,aa(C,fun(B,$o),aa(set(product_prod(C,C)),fun(C,fun(B,$o)),aTP_Lamp_bbc(set(B),fun(set(product_prod(C,C)),fun(C,fun(B,$o))),A3),R2),K)) ) ).

% fromCard_def
tff(fact_6079_symp__sym__eq,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( symp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2))
    <=> sym(B,R2) ) ).

% symp_sym_eq
tff(fact_6080_symp__inf,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),S2: fun(B,fun(B,$o))] :
      ( symp(B,R2)
     => ( symp(B,S2)
       => symp(B,aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),inf_inf(fun(B,fun(B,$o))),R2),S2)) ) ) ).

% symp_inf
tff(fact_6081_select__def,axiom,
    ! [B: $tType,Xs: list(B)] : ( select(B,Xs) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)),range(code_natural_of_nat(aa(list(B),nat,size_size(list(B)),Xs))),aTP_Lamp_bbd(list(B),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)))),Xs)) ) ).

% select_def
tff(fact_6082_subset__mset_Oarg__max__def,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,multiset(C)),Pa: fun(B,$o)] : ( lattices_arg_max(multiset(C),B,subset_mset(C),F2,Pa) = fChoice(B,lattices_is_arg_max(multiset(C),B,subset_mset(C),F2,Pa)) ) ).

% subset_mset.arg_max_def
tff(fact_6083_ord_Oarg__max__def,axiom,
    ! [C: $tType,B: $tType,Less: fun(C,fun(C,$o)),F2: fun(B,C),Pa: fun(B,$o)] : ( lattices_arg_max(C,B,Less,F2,Pa) = fChoice(B,lattices_is_arg_max(C,B,Less,F2,Pa)) ) ).

% ord.arg_max_def
tff(fact_6084_subset__mset_Oarg__max__on__def,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,multiset(C)),S: set(B)] : ( lattices_arg_max_on(multiset(C),B,subset_mset(C),F2,S) = lattices_arg_max(multiset(C),B,subset_mset(C),F2,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),S)) ) ).

% subset_mset.arg_max_on_def
tff(fact_6085_ord_Oarg__max__on__def,axiom,
    ! [C: $tType,B: $tType,Less: fun(C,fun(C,$o)),F2: fun(B,C),S: set(B)] : ( lattices_arg_max_on(C,B,Less,F2,S) = lattices_arg_max(C,B,Less,F2,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),S)) ) ).

% ord.arg_max_on_def
tff(fact_6086_cr__natural__def,axiom,
    ! [X4: nat,Xa3: code_natural] :
      ( code_cr_natural(X4,Xa3)
    <=> ( X4 = code_nat_of_natural(Xa3) ) ) ).

% cr_natural_def
tff(fact_6087_subset__mset_Oarg__min__def,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,multiset(C)),Pa: fun(B,$o)] : ( lattices_arg_min(multiset(C),B,subset_mset(C),F2,Pa) = fChoice(B,lattices_is_arg_min(multiset(C),B,subset_mset(C),F2,Pa)) ) ).

% subset_mset.arg_min_def
tff(fact_6088_ord_Oarg__min__def,axiom,
    ! [C: $tType,B: $tType,Less: fun(C,fun(C,$o)),F2: fun(B,C),Pa: fun(B,$o)] : ( lattices_arg_min(C,B,Less,F2,Pa) = fChoice(B,lattices_is_arg_min(C,B,Less,F2,Pa)) ) ).

% ord.arg_min_def
tff(fact_6089_subset__mset_Oarg__min__on__def,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,multiset(C)),S: set(B)] : ( lattices_arg_min_on(multiset(C),B,subset_mset(C),F2,S) = lattices_arg_min(multiset(C),B,subset_mset(C),F2,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),S)) ) ).

% subset_mset.arg_min_on_def
tff(fact_6090_ord_Oarg__min__on__def,axiom,
    ! [C: $tType,B: $tType,Less: fun(C,fun(C,$o)),F2: fun(B,C),S: set(B)] : ( lattices_arg_min_on(C,B,Less,F2,S) = lattices_arg_min(C,B,Less,F2,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),S)) ) ).

% ord.arg_min_on_def
tff(fact_6091_Nitpick_OEx1__unfold,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ? [X3: B] :
          ( aa(B,$o,Pa,X3)
          & ! [Y4: B] :
              ( aa(B,$o,Pa,Y4)
             => ( Y4 = X3 ) ) )
    <=> ? [X3: B] : ( aa(fun(B,$o),set(B),collect(B),Pa) = aa(set(B),set(B),insert(B,X3),bot_bot(set(B))) ) ) ).

% Nitpick.Ex1_unfold
tff(fact_6092_transp__trans,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o))] :
      ( transp(B,R2)
    <=> trans(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2))) ) ).

% transp_trans
tff(fact_6093_transp__ge,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => transp(B,aTP_Lamp_avb(B,fun(B,$o))) ) ).

% transp_ge
tff(fact_6094_transp__inf,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),S2: fun(B,fun(B,$o))] :
      ( transp(B,R2)
     => ( transp(B,S2)
       => transp(B,aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),inf_inf(fun(B,fun(B,$o))),R2),S2)) ) ) ).

% transp_inf
tff(fact_6095_transp__empty,axiom,
    ! [B: $tType] : transp(B,aTP_Lamp_aqt(B,fun(B,$o))) ).

% transp_empty
tff(fact_6096_transp__singleton,axiom,
    ! [B: $tType,A4: B] : transp(B,aTP_Lamp_bbe(B,fun(B,fun(B,$o)),A4)) ).

% transp_singleton
tff(fact_6097_subset__mset_Otransp__ge,axiom,
    ! [B: $tType] : transp(multiset(B),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o))) ).

% subset_mset.transp_ge
tff(fact_6098_subset__mset_Otransp__gr,axiom,
    ! [B: $tType] : transp(multiset(B),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o))) ).

% subset_mset.transp_gr
tff(fact_6099_transp__gr,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => transp(B,aTP_Lamp_aaa(B,fun(B,$o))) ) ).

% transp_gr
tff(fact_6100_transp__trans__eq,axiom,
    ! [B: $tType,R2: set(product_prod(B,B))] :
      ( transp(B,aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),R2))
    <=> trans(B,R2) ) ).

% transp_trans_eq
tff(fact_6101_irreflp__multp,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o))] :
      ( transp(B,R2)
     => ( irreflp(B,R2)
       => irreflp(multiset(B),multp(B,R2)) ) ) ).

% irreflp_multp
tff(fact_6102_multp__cancel__max,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),X5: multiset(B),Y3: multiset(B)] :
      ( transp(B,R2)
     => ( irreflp(B,R2)
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),multp(B,R2),X5),Y3)
        <=> aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),multp(B,R2),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),X5),Y3)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),Y3),X5)) ) ) ) ).

% multp_cancel_max
tff(fact_6103_multp__cancel__add__mset,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),Uu: B,X5: multiset(B),Y3: multiset(B)] :
      ( transp(B,R2)
     => ( irreflp(B,R2)
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),multp(B,R2),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),Uu),X5)),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),Uu),Y3))
        <=> aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),multp(B,R2),X5),Y3) ) ) ) ).

% multp_cancel_add_mset
tff(fact_6104_multp__cancel,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),X5: multiset(B),Z4: multiset(B),Y3: multiset(B)] :
      ( transp(B,R2)
     => ( irreflp(B,R2)
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),multp(B,R2),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),X5),Z4)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),Y3),Z4))
        <=> aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),multp(B,R2),X5),Y3) ) ) ) ).

% multp_cancel
tff(fact_6105_multp__def,axiom,
    ! [B: $tType,R2: fun(B,fun(B,$o)),M: multiset(B),N3: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),multp(B,R2),M),N3)
    <=> aa(set(product_prod(multiset(B),multiset(B))),$o,member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),M),N3)),mult(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R2)))) ) ).

% multp_def
tff(fact_6106_THE__default__def,axiom,
    ! [B: $tType,D3: B,Pa: fun(B,$o)] :
      ( fun_THE_default(B,D3,Pa)
      = $ite(
          ? [X3: B] :
            ( aa(B,$o,Pa,X3)
            & ! [Y4: B] :
                ( aa(B,$o,Pa,Y4)
               => ( Y4 = X3 ) ) ),
          the(B,Pa),
          D3 ) ) ).

% THE_default_def
tff(fact_6107_fundef__ex1__uniqueness,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),D3: fun(B,C),G3: fun(B,fun(C,$o)),X2: B,H2: fun(B,C)] :
      ( ! [X: B] : ( aa(B,C,F2,X) = fun_THE_default(C,aa(B,C,D3,X),aa(B,fun(C,$o),G3,X)) )
     => ( ? [X4: C] :
            ( aa(C,$o,aa(B,fun(C,$o),G3,X2),X4)
            & ! [Y2: C] :
                ( aa(C,$o,aa(B,fun(C,$o),G3,X2),Y2)
               => ( Y2 = X4 ) ) )
       => ( aa(C,$o,aa(B,fun(C,$o),G3,X2),aa(B,C,H2,X2))
         => ( aa(B,C,H2,X2) = aa(B,C,F2,X2) ) ) ) ) ).

% fundef_ex1_uniqueness
tff(fact_6108_fundef__ex1__existence,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),D3: fun(B,C),G3: fun(B,fun(C,$o)),X2: B] :
      ( ! [X: B] : ( aa(B,C,F2,X) = fun_THE_default(C,aa(B,C,D3,X),aa(B,fun(C,$o),G3,X)) )
     => ( ? [X4: C] :
            ( aa(C,$o,aa(B,fun(C,$o),G3,X2),X4)
            & ! [Y2: C] :
                ( aa(C,$o,aa(B,fun(C,$o),G3,X2),Y2)
               => ( Y2 = X4 ) ) )
       => aa(C,$o,aa(B,fun(C,$o),G3,X2),aa(B,C,F2,X2)) ) ) ).

% fundef_ex1_existence
tff(fact_6109_fundef__default__value,axiom,
    ! [C: $tType,B: $tType,F2: fun(B,C),D3: fun(B,C),G3: fun(B,fun(C,$o)),D2: fun(B,$o),X2: B] :
      ( ! [X: B] : ( aa(B,C,F2,X) = fun_THE_default(C,aa(B,C,D3,X),aa(B,fun(C,$o),G3,X)) )
     => ( ! [X: B,Y2: C] :
            ( aa(C,$o,aa(B,fun(C,$o),G3,X),Y2)
           => aa(B,$o,D2,X) )
       => ( ~ aa(B,$o,D2,X2)
         => ( aa(B,C,F2,X2) = aa(B,C,D3,X2) ) ) ) ) ).

% fundef_default_value
tff(fact_6110_fundef__ex1__iff,axiom,
    ! [B: $tType,C: $tType,F2: fun(B,C),D3: fun(B,C),G3: fun(B,fun(C,$o)),X2: B,Y: C] :
      ( ! [X: B] : ( aa(B,C,F2,X) = fun_THE_default(C,aa(B,C,D3,X),aa(B,fun(C,$o),G3,X)) )
     => ( ? [X4: C] :
            ( aa(C,$o,aa(B,fun(C,$o),G3,X2),X4)
            & ! [Y2: C] :
                ( aa(C,$o,aa(B,fun(C,$o),G3,X2),Y2)
               => ( Y2 = X4 ) ) )
       => ( aa(C,$o,aa(B,fun(C,$o),G3,X2),Y)
        <=> ( aa(B,C,F2,X2) = Y ) ) ) ) ).

% fundef_ex1_iff
tff(fact_6111_curry__def,axiom,
    ! [D: $tType,B: $tType,C: $tType,X4: fun(product_prod(B,C),D),Xa3: B,Xb3: C] : ( product_curry(B,C,D,X4,Xa3,Xb3) = aa(product_prod(B,C),D,X4,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Xa3),Xb3)) ) ).

% curry_def
tff(fact_6112_prod__encode__def,axiom,
    nat_prod_encode = aa(fun(nat,fun(nat,nat)),fun(product_prod(nat,nat),nat),product_case_prod(nat,nat,nat),aTP_Lamp_bbf(nat,fun(nat,nat))) ).

% prod_encode_def
tff(fact_6113_curry__K,axiom,
    ! [C: $tType,B: $tType,D: $tType,Ca: D,X4: B,Xa3: C] : ( product_curry(B,C,D,aTP_Lamp_bbg(D,fun(product_prod(B,C),D),Ca),X4,Xa3) = Ca ) ).

% curry_K
tff(fact_6114_successively__altdef,axiom,
    ! [B: $tType,X4: fun(B,fun(B,$o))] : ( successively(B,X4) = rec_list($o,B,$true,aTP_Lamp_bbi(fun(B,fun(B,$o)),fun(B,fun(list(B),fun($o,$o))),X4)) ) ).

% successively_altdef
tff(fact_6115_semilattice__neutr__set_Oremove,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(B),X2: B] :
      ( lattic5652469242046573047tr_set(B,F2,Z2)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( aa(set(B),$o,member(B,X2),A3)
         => ( lattic5214292709420241887eutr_F(B,F2,Z2,A3) = aa(B,B,aa(B,fun(B,B),F2,X2),lattic5214292709420241887eutr_F(B,F2,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ).

% semilattice_neutr_set.remove
tff(fact_6116_successively__rev,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o)),Xs: list(B)] :
      ( aa(list(B),$o,successively(B,Pa),rev(B,Xs))
    <=> aa(list(B),$o,successively(B,aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Pa)),Xs) ) ).

% successively_rev
tff(fact_6117_semilattice__neutr__set_Oclosed,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(B)] :
      ( lattic5652469242046573047tr_set(B,F2,Z2)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( ( A3 != bot_bot(set(B)) )
         => ( ! [X: B,Y2: B] : aa(set(B),$o,member(B,aa(B,B,aa(B,fun(B,B),F2,X),Y2)),aa(set(B),set(B),insert(B,X),aa(set(B),set(B),insert(B,Y2),bot_bot(set(B)))))
           => aa(set(B),$o,member(B,lattic5214292709420241887eutr_F(B,F2,Z2,A3)),A3) ) ) ) ) ).

% semilattice_neutr_set.closed
tff(fact_6118_semilattice__neutr__set_Oempty,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B] :
      ( lattic5652469242046573047tr_set(B,F2,Z2)
     => ( lattic5214292709420241887eutr_F(B,F2,Z2,bot_bot(set(B))) = Z2 ) ) ).

% semilattice_neutr_set.empty
tff(fact_6119_successively__map,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,fun(B,$o)),F2: fun(C,B),Xs: list(C)] :
      ( aa(list(B),$o,successively(B,Pa),aa(list(C),list(B),map(C,B,F2),Xs))
    <=> aa(list(C),$o,successively(C,aa(fun(C,B),fun(C,fun(C,$o)),aTP_Lamp_ald(fun(B,fun(B,$o)),fun(fun(C,B),fun(C,fun(C,$o))),Pa),F2)),Xs) ) ).

% successively_map
tff(fact_6120_semilattice__neutr__set_Oinsert__remove,axiom,
    ! [B: $tType,F2: fun(B,fun(B,B)),Z2: B,A3: set(B),X2: B] :
      ( lattic5652469242046573047tr_set(B,F2,Z2)
     => ( aa(set(B),$o,finite_finite2(B),A3)
       => ( lattic5214292709420241887eutr_F(B,F2,Z2,aa(set(B),set(B),insert(B,X2),A3)) = aa(B,B,aa(B,fun(B,B),F2,X2),lattic5214292709420241887eutr_F(B,F2,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ).

% semilattice_neutr_set.insert_remove
tff(fact_6121_inv__imagep__def,axiom,
    ! [C: $tType,B: $tType,R2: fun(C,fun(C,$o)),F2: fun(B,C),X4: B,Xa3: B] :
      ( inv_imagep(C,B,R2,F2,X4,Xa3)
    <=> aa(C,$o,aa(C,fun(C,$o),R2,aa(B,C,F2,X4)),aa(B,C,F2,Xa3)) ) ).

% inv_imagep_def
tff(fact_6122_is__filter__map__filter__on,axiom,
    ! [B: $tType,C: $tType,F2: fun(C,B),X5: set(C),F: filter(C)] :
      ( aa(fun(fun(B,$o),$o),$o,is_filter(B),aa(filter(C),fun(fun(B,$o),$o),aa(set(C),fun(filter(C),fun(fun(B,$o),$o)),aTP_Lamp_bbk(fun(C,B),fun(set(C),fun(filter(C),fun(fun(B,$o),$o))),F2),X5),F))
    <=> eventually(C,aTP_Lamp_nw(set(C),fun(C,$o),X5),F) ) ).

% is_filter_map_filter_on
tff(fact_6123_is__filter_OTrue,axiom,
    ! [B: $tType,F: fun(fun(B,$o),$o)] :
      ( aa(fun(fun(B,$o),$o),$o,is_filter(B),F)
     => aa(fun(B,$o),$o,F,aTP_Lamp_nh(B,$o)) ) ).

% is_filter.True
tff(fact_6124_is__filter_Oconj,axiom,
    ! [B: $tType,F: fun(fun(B,$o),$o),Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( aa(fun(fun(B,$o),$o),$o,is_filter(B),F)
     => ( aa(fun(B,$o),$o,F,Pa)
       => ( aa(fun(B,$o),$o,F,Qa)
         => aa(fun(B,$o),$o,F,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa)) ) ) ) ).

% is_filter.conj
tff(fact_6125_is__filter_Omono,axiom,
    ! [B: $tType,F: fun(fun(B,$o),$o),Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( aa(fun(fun(B,$o),$o),$o,is_filter(B),F)
     => ( ! [X: B] :
            ( aa(B,$o,Pa,X)
           => aa(B,$o,Qa,X) )
       => ( aa(fun(B,$o),$o,F,Pa)
         => aa(fun(B,$o),$o,F,Qa) ) ) ) ).

% is_filter.mono
tff(fact_6126_is__filter_Ointro,axiom,
    ! [B: $tType,F: fun(fun(B,$o),$o)] :
      ( aa(fun(B,$o),$o,F,aTP_Lamp_nh(B,$o))
     => ( ! [P: fun(B,$o)] :
            ( aa(fun(B,$o),$o,F,P)
           => ! [Q2: fun(B,$o)] :
                ( aa(fun(B,$o),$o,F,Q2)
               => aa(fun(B,$o),$o,F,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),P),Q2)) ) )
       => ( ! [P: fun(B,$o),Q2: fun(B,$o)] :
              ( ! [X4: B] :
                  ( aa(B,$o,P,X4)
                 => aa(B,$o,Q2,X4) )
             => ( aa(fun(B,$o),$o,F,P)
               => aa(fun(B,$o),$o,F,Q2) ) )
         => aa(fun(fun(B,$o),$o),$o,is_filter(B),F) ) ) ) ).

% is_filter.intro
tff(fact_6127_is__filter__def,axiom,
    ! [B: $tType,F: fun(fun(B,$o),$o)] :
      ( aa(fun(fun(B,$o),$o),$o,is_filter(B),F)
    <=> ( aa(fun(B,$o),$o,F,aTP_Lamp_nh(B,$o))
        & ! [P2: fun(B,$o)] :
            ( aa(fun(B,$o),$o,F,P2)
           => ! [Q4: fun(B,$o)] :
                ( aa(fun(B,$o),$o,F,Q4)
               => aa(fun(B,$o),$o,F,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),P2),Q4)) ) )
        & ! [P2: fun(B,$o),Q4: fun(B,$o)] :
            ( ! [X3: B] :
                ( aa(B,$o,P2,X3)
               => aa(B,$o,Q4,X3) )
           => ( aa(fun(B,$o),$o,F,P2)
             => aa(fun(B,$o),$o,F,Q4) ) ) ) ) ).

% is_filter_def
tff(fact_6128_Abs__filter__cases,axiom,
    ! [B: $tType,X2: filter(B)] :
      ~ ! [Y2: fun(fun(B,$o),$o)] :
          ( ( X2 = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),Y2) )
         => ~ aa(set(fun(fun(B,$o),$o)),$o,member(fun(fun(B,$o),$o),Y2),aa(fun(fun(fun(B,$o),$o),$o),set(fun(fun(B,$o),$o)),collect(fun(fun(B,$o),$o)),is_filter(B))) ) ).

% Abs_filter_cases
tff(fact_6129_Abs__filter__induct,axiom,
    ! [B: $tType,Pa: fun(filter(B),$o),X2: filter(B)] :
      ( ! [Y2: fun(fun(B,$o),$o)] :
          ( aa(set(fun(fun(B,$o),$o)),$o,member(fun(fun(B,$o),$o),Y2),aa(fun(fun(fun(B,$o),$o),$o),set(fun(fun(B,$o),$o)),collect(fun(fun(B,$o),$o)),is_filter(B)))
         => aa(filter(B),$o,Pa,aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),Y2)) )
     => aa(filter(B),$o,Pa,X2) ) ).

% Abs_filter_induct
tff(fact_6130_Abs__filter__inject,axiom,
    ! [B: $tType,X2: fun(fun(B,$o),$o),Y: fun(fun(B,$o),$o)] :
      ( aa(set(fun(fun(B,$o),$o)),$o,member(fun(fun(B,$o),$o),X2),aa(fun(fun(fun(B,$o),$o),$o),set(fun(fun(B,$o),$o)),collect(fun(fun(B,$o),$o)),is_filter(B)))
     => ( aa(set(fun(fun(B,$o),$o)),$o,member(fun(fun(B,$o),$o),Y),aa(fun(fun(fun(B,$o),$o),$o),set(fun(fun(B,$o),$o)),collect(fun(fun(B,$o),$o)),is_filter(B)))
       => ( ( aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),X2) = aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),Y) )
        <=> ( X2 = Y ) ) ) ) ).

% Abs_filter_inject
tff(fact_6131_type__definition__filter,axiom,
    ! [B: $tType] : type_definition(filter(B),fun(fun(B,$o),$o),rep_filter(B),abs_filter(B),aa(fun(fun(fun(B,$o),$o),$o),set(fun(fun(B,$o),$o)),collect(fun(fun(B,$o),$o)),is_filter(B))) ).

% type_definition_filter
tff(fact_6132_Abs__filter__inverse,axiom,
    ! [B: $tType,Y: fun(fun(B,$o),$o)] :
      ( aa(set(fun(fun(B,$o),$o)),$o,member(fun(fun(B,$o),$o),Y),aa(fun(fun(fun(B,$o),$o),$o),set(fun(fun(B,$o),$o)),collect(fun(fun(B,$o),$o)),is_filter(B)))
     => ( aa(filter(B),fun(fun(B,$o),$o),rep_filter(B),aa(fun(fun(B,$o),$o),filter(B),abs_filter(B),Y)) = Y ) ) ).

% Abs_filter_inverse
tff(fact_6133_Rep__filter,axiom,
    ! [B: $tType,X2: filter(B)] : aa(set(fun(fun(B,$o),$o)),$o,member(fun(fun(B,$o),$o),aa(filter(B),fun(fun(B,$o),$o),rep_filter(B),X2)),aa(fun(fun(fun(B,$o),$o),$o),set(fun(fun(B,$o),$o)),collect(fun(fun(B,$o),$o)),is_filter(B))) ).

% Rep_filter
tff(fact_6134_Rep__filter__cases,axiom,
    ! [B: $tType,Y: fun(fun(B,$o),$o)] :
      ( aa(set(fun(fun(B,$o),$o)),$o,member(fun(fun(B,$o),$o),Y),aa(fun(fun(fun(B,$o),$o),$o),set(fun(fun(B,$o),$o)),collect(fun(fun(B,$o),$o)),is_filter(B)))
     => ~ ! [X: filter(B)] : ( Y != aa(filter(B),fun(fun(B,$o),$o),rep_filter(B),X) ) ) ).

% Rep_filter_cases
tff(fact_6135_Rep__filter__induct,axiom,
    ! [B: $tType,Y: fun(fun(B,$o),$o),Pa: fun(fun(fun(B,$o),$o),$o)] :
      ( aa(set(fun(fun(B,$o),$o)),$o,member(fun(fun(B,$o),$o),Y),aa(fun(fun(fun(B,$o),$o),$o),set(fun(fun(B,$o),$o)),collect(fun(fun(B,$o),$o)),is_filter(B)))
     => ( ! [X: filter(B)] : aa(fun(fun(B,$o),$o),$o,Pa,aa(filter(B),fun(fun(B,$o),$o),rep_filter(B),X))
       => aa(fun(fun(B,$o),$o),$o,Pa,Y) ) ) ).

% Rep_filter_induct
tff(fact_6136_ref_Orel__compp__Grp,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] : ( rel_ref(B,C,R) = aa(fun(ref(product_prod(B,C)),fun(ref(C),$o)),fun(ref(B),fun(ref(C),$o)),aa(fun(ref(B),fun(ref(product_prod(B,C)),$o)),fun(fun(ref(product_prod(B,C)),fun(ref(C),$o)),fun(ref(B),fun(ref(C),$o))),relcompp(ref(B),ref(product_prod(B,C)),ref(C)),conversep(ref(product_prod(B,C)),ref(B),bNF_Grp(ref(product_prod(B,C)),ref(B),aa(fun(ref(product_prod(B,C)),$o),set(ref(product_prod(B,C))),collect(ref(product_prod(B,C))),aTP_Lamp_bbl(fun(B,fun(C,$o)),fun(ref(product_prod(B,C)),$o),R)),map_ref(product_prod(B,C),B,product_fst(B,C))))),bNF_Grp(ref(product_prod(B,C)),ref(C),aa(fun(ref(product_prod(B,C)),$o),set(ref(product_prod(B,C))),collect(ref(product_prod(B,C))),aTP_Lamp_bbl(fun(B,fun(C,$o)),fun(ref(product_prod(B,C)),$o),R)),map_ref(product_prod(B,C),C,product_snd(B,C)))) ) ).

% ref.rel_compp_Grp
tff(fact_6137_array_Orel__compp__Grp,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] : ( rel_array(B,C,R) = aa(fun(array(product_prod(B,C)),fun(array(C),$o)),fun(array(B),fun(array(C),$o)),aa(fun(array(B),fun(array(product_prod(B,C)),$o)),fun(fun(array(product_prod(B,C)),fun(array(C),$o)),fun(array(B),fun(array(C),$o))),relcompp(array(B),array(product_prod(B,C)),array(C)),conversep(array(product_prod(B,C)),array(B),bNF_Grp(array(product_prod(B,C)),array(B),aa(fun(array(product_prod(B,C)),$o),set(array(product_prod(B,C))),collect(array(product_prod(B,C))),aTP_Lamp_bbm(fun(B,fun(C,$o)),fun(array(product_prod(B,C)),$o),R)),map_array(product_prod(B,C),B,product_fst(B,C))))),bNF_Grp(array(product_prod(B,C)),array(C),aa(fun(array(product_prod(B,C)),$o),set(array(product_prod(B,C))),collect(array(product_prod(B,C))),aTP_Lamp_bbm(fun(B,fun(C,$o)),fun(array(product_prod(B,C)),$o),R)),map_array(product_prod(B,C),C,product_snd(B,C)))) ) ).

% array.rel_compp_Grp
tff(fact_6138_ref_Orel__map_I2_J,axiom,
    ! [B: $tType,C: $tType,D: $tType,Sa: fun(B,fun(C,$o)),X2: ref(B),G: fun(D,C),Y: ref(D)] :
      ( aa(ref(C),$o,aa(ref(B),fun(ref(C),$o),rel_ref(B,C,Sa),X2),aa(ref(D),ref(C),map_ref(D,C,G),Y))
    <=> aa(ref(D),$o,aa(ref(B),fun(ref(D),$o),rel_ref(B,D,aa(fun(D,C),fun(B,fun(D,$o)),aTP_Lamp_aod(fun(B,fun(C,$o)),fun(fun(D,C),fun(B,fun(D,$o))),Sa),G)),X2),Y) ) ).

% ref.rel_map(2)
tff(fact_6139_ref_Orel__map_I1_J,axiom,
    ! [D: $tType,B: $tType,C: $tType,Sb: fun(B,fun(C,$o)),I2: fun(D,B),X2: ref(D),Y: ref(C)] :
      ( aa(ref(C),$o,aa(ref(B),fun(ref(C),$o),rel_ref(B,C,Sb),aa(ref(D),ref(B),map_ref(D,B,I2),X2)),Y)
    <=> aa(ref(C),$o,aa(ref(D),fun(ref(C),$o),rel_ref(D,C,aa(fun(D,B),fun(D,fun(C,$o)),aTP_Lamp_aoe(fun(B,fun(C,$o)),fun(fun(D,B),fun(D,fun(C,$o))),Sb),I2)),X2),Y) ) ).

% ref.rel_map(1)
tff(fact_6140_array_Orel__map_I2_J,axiom,
    ! [B: $tType,C: $tType,D: $tType,Sa: fun(B,fun(C,$o)),X2: array(B),G: fun(D,C),Y: array(D)] :
      ( aa(array(C),$o,aa(array(B),fun(array(C),$o),rel_array(B,C,Sa),X2),aa(array(D),array(C),map_array(D,C,G),Y))
    <=> aa(array(D),$o,aa(array(B),fun(array(D),$o),rel_array(B,D,aa(fun(D,C),fun(B,fun(D,$o)),aTP_Lamp_aod(fun(B,fun(C,$o)),fun(fun(D,C),fun(B,fun(D,$o))),Sa),G)),X2),Y) ) ).

% array.rel_map(2)
tff(fact_6141_array_Orel__map_I1_J,axiom,
    ! [D: $tType,B: $tType,C: $tType,Sb: fun(B,fun(C,$o)),I2: fun(D,B),X2: array(D),Y: array(C)] :
      ( aa(array(C),$o,aa(array(B),fun(array(C),$o),rel_array(B,C,Sb),aa(array(D),array(B),map_array(D,B,I2),X2)),Y)
    <=> aa(array(C),$o,aa(array(D),fun(array(C),$o),rel_array(D,C,aa(fun(D,B),fun(D,fun(C,$o)),aTP_Lamp_aoe(fun(B,fun(C,$o)),fun(fun(D,B),fun(D,fun(C,$o))),Sb),I2)),X2),Y) ) ).

% array.rel_map(1)
tff(fact_6142_ref_Omap__ident,axiom,
    ! [B: $tType,T3: ref(B)] : ( aa(ref(B),ref(B),map_ref(B,B,aTP_Lamp_bk(B,B)),T3) = T3 ) ).

% ref.map_ident
tff(fact_6143_array_Omap__ident,axiom,
    ! [B: $tType,T3: array(B)] : ( aa(array(B),array(B),map_array(B,B,aTP_Lamp_bk(B,B)),T3) = T3 ) ).

% array.map_ident
tff(fact_6144_ref_Orel__Grp,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,C)] : ( rel_ref(B,C,bNF_Grp(B,C,A3,F2)) = bNF_Grp(ref(B),ref(C),aa(fun(ref(B),$o),set(ref(B)),collect(ref(B)),aTP_Lamp_bbn(set(B),fun(ref(B),$o),A3)),map_ref(B,C,F2)) ) ).

% ref.rel_Grp
tff(fact_6145_array_Orel__Grp,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,C)] : ( rel_array(B,C,bNF_Grp(B,C,A3,F2)) = bNF_Grp(array(B),array(C),aa(fun(array(B),$o),set(array(B)),collect(array(B)),aTP_Lamp_bbo(set(B),fun(array(B),$o),A3)),map_array(B,C,F2)) ) ).

% array.rel_Grp
tff(fact_6146_ref_Oin__rel,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),A4: ref(B),B3: ref(C)] :
      ( aa(ref(C),$o,aa(ref(B),fun(ref(C),$o),rel_ref(B,C,R),A4),B3)
    <=> ? [Z5: ref(product_prod(B,C))] :
          ( aa(set(ref(product_prod(B,C))),$o,member(ref(product_prod(B,C)),Z5),aa(fun(ref(product_prod(B,C)),$o),set(ref(product_prod(B,C))),collect(ref(product_prod(B,C))),aTP_Lamp_bbl(fun(B,fun(C,$o)),fun(ref(product_prod(B,C)),$o),R)))
          & ( aa(ref(product_prod(B,C)),ref(B),map_ref(product_prod(B,C),B,product_fst(B,C)),Z5) = A4 )
          & ( aa(ref(product_prod(B,C)),ref(C),map_ref(product_prod(B,C),C,product_snd(B,C)),Z5) = B3 ) ) ) ).

% ref.in_rel
tff(fact_6147_array_Oin__rel,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),A4: array(B),B3: array(C)] :
      ( aa(array(C),$o,aa(array(B),fun(array(C),$o),rel_array(B,C,R),A4),B3)
    <=> ? [Z5: array(product_prod(B,C))] :
          ( aa(set(array(product_prod(B,C))),$o,member(array(product_prod(B,C)),Z5),aa(fun(array(product_prod(B,C)),$o),set(array(product_prod(B,C))),collect(array(product_prod(B,C))),aTP_Lamp_bbm(fun(B,fun(C,$o)),fun(array(product_prod(B,C)),$o),R)))
          & ( aa(array(product_prod(B,C)),array(B),map_array(product_prod(B,C),B,product_fst(B,C)),Z5) = A4 )
          & ( aa(array(product_prod(B,C)),array(C),map_array(product_prod(B,C),C,product_snd(B,C)),Z5) = B3 ) ) ) ).

% array.in_rel
tff(fact_6148_array_Orec__o__map,axiom,
    ! [D: $tType,B: $tType,C: $tType,G: fun(nat,C),F2: fun(B,D)] : ( aa(fun(array(B),array(D)),fun(array(B),C),comp(array(D),C,array(B),rec_array(C,D,G)),map_array(B,D,F2)) = rec_array(C,B,G) ) ).

% array.rec_o_map
tff(fact_6149_ref_Orec__o__map,axiom,
    ! [D: $tType,B: $tType,C: $tType,G: fun(nat,C),F2: fun(B,D)] : ( aa(fun(ref(B),ref(D)),fun(ref(B),C),comp(ref(D),C,ref(B),rec_ref(C,D,G)),map_ref(B,D,F2)) = rec_ref(C,B,G) ) ).

% ref.rec_o_map
tff(fact_6150_array_Omap__cong__pred,axiom,
    ! [C: $tType,B: $tType,X2: array(B),Ya2: array(B),F2: fun(B,C),G: fun(B,C)] :
      ( ( X2 = Ya2 )
     => ( pred_array(B,aa(fun(B,C),fun(B,$o),aTP_Lamp_np(fun(B,C),fun(fun(B,C),fun(B,$o)),F2),G),Ya2)
       => ( aa(array(B),array(C),map_array(B,C,F2),X2) = aa(array(B),array(C),map_array(B,C,G),Ya2) ) ) ) ).

% array.map_cong_pred
tff(fact_6151_ref_Omap__cong__pred,axiom,
    ! [C: $tType,B: $tType,X2: ref(B),Ya2: ref(B),F2: fun(B,C),G: fun(B,C)] :
      ( ( X2 = Ya2 )
     => ( pred_ref(B,aa(fun(B,C),fun(B,$o),aTP_Lamp_np(fun(B,C),fun(fun(B,C),fun(B,$o)),F2),G),Ya2)
       => ( aa(ref(B),ref(C),map_ref(B,C,F2),X2) = aa(ref(B),ref(C),map_ref(B,C,G),Ya2) ) ) ) ).

% ref.map_cong_pred
tff(fact_6152_ref_Opred__True,axiom,
    ! [B: $tType,X4: ref(B)] : pred_ref(B,aTP_Lamp_nh(B,$o),X4) ).

% ref.pred_True
tff(fact_6153_array_Opred__True,axiom,
    ! [B: $tType,X4: array(B)] : pred_array(B,aTP_Lamp_nh(B,$o),X4) ).

% array.pred_True
tff(fact_6154_Heap_Oin__rel,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),A4: heap_Time_Heap(B),B3: heap_Time_Heap(C)] :
      ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),heap_Time_rel_Heap(B,C,R),A4),B3)
    <=> ? [Z5: heap_Time_Heap(product_prod(B,C))] :
          ( aa(set(heap_Time_Heap(product_prod(B,C))),$o,member(heap_Time_Heap(product_prod(B,C)),Z5),aa(fun(heap_Time_Heap(product_prod(B,C)),$o),set(heap_Time_Heap(product_prod(B,C))),collect(heap_Time_Heap(product_prod(B,C))),aTP_Lamp_bbp(fun(B,fun(C,$o)),fun(heap_Time_Heap(product_prod(B,C)),$o),R)))
          & ( aa(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(B),heap_Time_map_Heap(product_prod(B,C),B,product_fst(B,C)),Z5) = A4 )
          & ( aa(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(C),heap_Time_map_Heap(product_prod(B,C),C,product_snd(B,C)),Z5) = B3 ) ) ) ).

% Heap.in_rel
tff(fact_6155_Heap_Orel__compp__Grp,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] : ( heap_Time_rel_Heap(B,C,R) = aa(fun(heap_Time_Heap(product_prod(B,C)),fun(heap_Time_Heap(C),$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),aa(fun(heap_Time_Heap(B),fun(heap_Time_Heap(product_prod(B,C)),$o)),fun(fun(heap_Time_Heap(product_prod(B,C)),fun(heap_Time_Heap(C),$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o))),relcompp(heap_Time_Heap(B),heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(C)),conversep(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(B),bNF_Grp(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(B),aa(fun(heap_Time_Heap(product_prod(B,C)),$o),set(heap_Time_Heap(product_prod(B,C))),collect(heap_Time_Heap(product_prod(B,C))),aTP_Lamp_bbp(fun(B,fun(C,$o)),fun(heap_Time_Heap(product_prod(B,C)),$o),R)),heap_Time_map_Heap(product_prod(B,C),B,product_fst(B,C))))),bNF_Grp(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(C),aa(fun(heap_Time_Heap(product_prod(B,C)),$o),set(heap_Time_Heap(product_prod(B,C))),collect(heap_Time_Heap(product_prod(B,C))),aTP_Lamp_bbp(fun(B,fun(C,$o)),fun(heap_Time_Heap(product_prod(B,C)),$o),R)),heap_Time_map_Heap(product_prod(B,C),C,product_snd(B,C)))) ) ).

% Heap.rel_compp_Grp
tff(fact_6156_Heap_Orel__map_I1_J,axiom,
    ! [D: $tType,B: $tType,C: $tType,Sb: fun(B,fun(C,$o)),I2: fun(D,B),X2: heap_Time_Heap(D),Y: heap_Time_Heap(C)] :
      ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),heap_Time_rel_Heap(B,C,Sb),aa(heap_Time_Heap(D),heap_Time_Heap(B),heap_Time_map_Heap(D,B,I2),X2)),Y)
    <=> aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(D),fun(heap_Time_Heap(C),$o),heap_Time_rel_Heap(D,C,aa(fun(D,B),fun(D,fun(C,$o)),aTP_Lamp_aoe(fun(B,fun(C,$o)),fun(fun(D,B),fun(D,fun(C,$o))),Sb),I2)),X2),Y) ) ).

% Heap.rel_map(1)
tff(fact_6157_Heap_Orel__map_I2_J,axiom,
    ! [B: $tType,C: $tType,D: $tType,Sa: fun(B,fun(C,$o)),X2: heap_Time_Heap(B),G: fun(D,C),Y: heap_Time_Heap(D)] :
      ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),heap_Time_rel_Heap(B,C,Sa),X2),aa(heap_Time_Heap(D),heap_Time_Heap(C),heap_Time_map_Heap(D,C,G),Y))
    <=> aa(heap_Time_Heap(D),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(D),$o),heap_Time_rel_Heap(B,D,aa(fun(D,C),fun(B,fun(D,$o)),aTP_Lamp_aod(fun(B,fun(C,$o)),fun(fun(D,C),fun(B,fun(D,$o))),Sa),G)),X2),Y) ) ).

% Heap.rel_map(2)
tff(fact_6158_Heap_Omap__ident,axiom,
    ! [B: $tType,T3: heap_Time_Heap(B)] : ( aa(heap_Time_Heap(B),heap_Time_Heap(B),heap_Time_map_Heap(B,B,aTP_Lamp_bk(B,B)),T3) = T3 ) ).

% Heap.map_ident
tff(fact_6159_Heap_Orel__Grp,axiom,
    ! [C: $tType,B: $tType,A3: set(B),F2: fun(B,C)] : ( heap_Time_rel_Heap(B,C,bNF_Grp(B,C,A3,F2)) = bNF_Grp(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(heap_Time_Heap(B),$o),set(heap_Time_Heap(B)),collect(heap_Time_Heap(B)),aTP_Lamp_bbq(set(B),fun(heap_Time_Heap(B),$o),A3)),heap_Time_map_Heap(B,C,F2)) ) ).

% Heap.rel_Grp
tff(fact_6160_Heap_Orec__o__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,G: fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),F2: fun(B,D)] : ( aa(fun(heap_Time_Heap(B),heap_Time_Heap(D)),fun(heap_Time_Heap(B),C),comp(heap_Time_Heap(D),C,heap_Time_Heap(B),heap_Time_rec_Heap(D,C,G)),heap_Time_map_Heap(B,D,F2)) = heap_Time_rec_Heap(B,C,aa(fun(B,D),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),aTP_Lamp_bbr(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(B,D),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C)),G),F2)) ) ).

% Heap.rec_o_map
tff(fact_6161_Heap_Omap__cong__pred,axiom,
    ! [C: $tType,B: $tType,X2: heap_Time_Heap(B),Ya2: heap_Time_Heap(B),F2: fun(B,C),G: fun(B,C)] :
      ( ( X2 = Ya2 )
     => ( heap_Time_pred_Heap(B,aa(fun(B,C),fun(B,$o),aTP_Lamp_np(fun(B,C),fun(fun(B,C),fun(B,$o)),F2),G),Ya2)
       => ( aa(heap_Time_Heap(B),heap_Time_Heap(C),heap_Time_map_Heap(B,C,F2),X2) = aa(heap_Time_Heap(B),heap_Time_Heap(C),heap_Time_map_Heap(B,C,G),Ya2) ) ) ) ).

% Heap.map_cong_pred
tff(fact_6162_Heap_Opred__True,axiom,
    ! [B: $tType,X4: heap_Time_Heap(B)] : heap_Time_pred_Heap(B,aTP_Lamp_nh(B,$o),X4) ).

% Heap.pred_True
tff(fact_6163_Heap_Opred__inject,axiom,
    ! [B: $tType,Pa: fun(B,$o),A4: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] :
      ( heap_Time_pred_Heap(B,Pa,heap_Time_Heap2(B,A4))
    <=> aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),$o,aa(fun(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),$o),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),$o),basic_pred_fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_bbs(heap_ext(product_unit),$o)),pred_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),basic_pred_prod(B,product_prod(heap_ext(product_unit),nat),Pa,top_top(fun(product_prod(heap_ext(product_unit),nat),$o))))),A4) ) ).

% Heap.pred_inject
tff(fact_6164_option_Omap__cong__pred,axiom,
    ! [C: $tType,B: $tType,X2: option(B),Ya2: option(B),F2: fun(B,C),G: fun(B,C)] :
      ( ( X2 = Ya2 )
     => ( aa(option(B),$o,pred_option(B,aa(fun(B,C),fun(B,$o),aTP_Lamp_np(fun(B,C),fun(fun(B,C),fun(B,$o)),F2),G)),Ya2)
       => ( aa(option(B),option(C),map_option(B,C,F2),X2) = aa(option(B),option(C),map_option(B,C,G),Ya2) ) ) ) ).

% option.map_cong_pred
tff(fact_6165_option_Opred__True,axiom,
    ! [B: $tType,X4: option(B)] : aa(option(B),$o,pred_option(B,aTP_Lamp_nh(B,$o)),X4) ).

% option.pred_True
tff(fact_6166_ATP_Olambda__1,axiom,
    ! [Uu: product_prod(int,int)] :
      ( aa(product_prod(int,int),product_prod(int,int),aTP_Lamp_abn(product_prod(int,int),product_prod(int,int)),Uu)
      = $ite(aa(product_prod(int,int),int,product_fst(int,int),Uu) = zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_fst(int,int),Uu))) ) ).

% ATP.lambda_1
tff(fact_6167_ATP_Olambda__2,axiom,
    ! [B: $tType,Uu: set(set(B))] : ( aa(set(set(B)),int,aTP_Lamp_sz(set(set(B)),int),Uu) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(set(B)),nat,finite_card(set(B)),Uu)),one_one(nat)))),aa(nat,int,semiring_1_of_nat(int),aa(set(B),nat,finite_card(B),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),Uu)))) ) ).

% ATP.lambda_2
tff(fact_6168_ATP_Olambda__3,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,set(product_prod(B,B)),aTP_Lamp_he(B,set(product_prod(B,B))),Uu) = aa(set(product_prod(B,B)),set(product_prod(B,B)),insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),Uu)),bot_bot(set(product_prod(B,B)))) ) ).

% ATP.lambda_3
tff(fact_6169_ATP_Olambda__4,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Uu: B] :
          ( aa(B,$o,aTP_Lamp_aee(B,$o),Uu)
        <=> ( aa(set(B),$o,member(B,Uu),ring_1_Ints(B))
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Uu) ) ) ) ).

% ATP.lambda_4
tff(fact_6170_ATP_Olambda__5,axiom,
    ! [Uu: a] : ( aa(a,assn,aTP_Lamp_a(a,assn),Uu) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),q(Uu)),top_top(assn)) ) ).

% ATP.lambda_5
tff(fact_6171_ATP_Olambda__6,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: product_prod(int,int)] : ( aa(product_prod(int,int),B,aTP_Lamp_abs(product_prod(int,int),B),Uu) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(int,B,ring_1_of_int(B),aa(product_prod(int,int),int,product_fst(int,int),Uu))),aa(int,B,ring_1_of_int(B),aa(product_prod(int,int),int,product_snd(int,int),Uu))) ) ) ).

% ATP.lambda_6
tff(fact_6172_ATP_Olambda__7,axiom,
    ! [Uu: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aTP_Lamp_abp(product_prod(int,int),product_prod(int,int)),Uu) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),aa(product_prod(int,int),int,product_fst(int,int),Uu))),aa(product_prod(int,int),int,product_snd(int,int),Uu)) ) ).

% ATP.lambda_7
tff(fact_6173_ATP_Olambda__8,axiom,
    ! [Uu: nat] : ( aa(nat,int,aTP_Lamp_azm(nat,int),Uu) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),Uu))),one_one(int)) ) ).

% ATP.lambda_8
tff(fact_6174_ATP_Olambda__9,axiom,
    ! [B: $tType,Uu: product_prod(B,B)] :
      ( aa(product_prod(B,B),$o,aTP_Lamp_io(product_prod(B,B),$o),Uu)
    <=> ( aa(product_prod(B,B),B,product_fst(B,B),Uu) = aa(product_prod(B,B),B,product_snd(B,B),Uu) ) ) ).

% ATP.lambda_9
tff(fact_6175_ATP_Olambda__10,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),product_prod(nat,list(B)),aTP_Lamp_aus(list(B),product_prod(nat,list(B))),Uu) = aa(list(B),product_prod(nat,list(B)),aa(nat,fun(list(B),product_prod(nat,list(B))),product_Pair(nat,list(B)),aa(list(B),nat,size_size(list(B)),Uu)),Uu) ) ).

% ATP.lambda_10
tff(fact_6176_ATP_Olambda__11,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [Uu: nat] :
          ( aa(nat,$o,aTP_Lamp_zr(nat,$o),Uu)
        <=> ( aa(nat,B,semiring_1_of_nat(B),Uu) = zero_zero(B) ) ) ) ).

% ATP.lambda_11
tff(fact_6177_ATP_Olambda__12,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_sv(nat,nat),Uu) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),aa(nat,nat,suc,zero_zero(nat))) ) ).

% ATP.lambda_12
tff(fact_6178_ATP_Olambda__13,axiom,
    ! [Uu: int] : ( aa(int,int,aTP_Lamp_yl(int,int),Uu) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uu),Uu) ) ).

% ATP.lambda_13
tff(fact_6179_ATP_Olambda__14,axiom,
    ! [C: $tType,Uu: C] : ( aa(C,product_prod(C,C),aTP_Lamp_ho(C,product_prod(C,C)),Uu) = aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),Uu),Uu) ) ).

% ATP.lambda_14
tff(fact_6180_ATP_Olambda__15,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,product_prod(B,B),aTP_Lamp_hn(B,product_prod(B,B)),Uu) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),Uu) ) ).

% ATP.lambda_15
tff(fact_6181_ATP_Olambda__16,axiom,
    ! [Uu: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aTP_Lamp_aqs(product_prod(int,int),$o),Uu)
    <=> aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Uu),Uu) ) ).

% ATP.lambda_16
tff(fact_6182_ATP_Olambda__17,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_sp(B,B),Uu) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),one_one(B)) ) ) ).

% ATP.lambda_17
tff(fact_6183_ATP_Olambda__18,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [Uu: B] :
          ( aa(B,$o,aTP_Lamp_aum(B,$o),Uu)
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Uu),one_one(B)) ) ) ).

% ATP.lambda_18
tff(fact_6184_ATP_Olambda__19,axiom,
    ! [Uu: nat] : ( aa(nat,product_prod(nat,nat),aTP_Lamp_wi(nat,product_prod(nat,nat)),Uu) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Uu),zero_zero(nat)) ) ).

% ATP.lambda_19
tff(fact_6185_ATP_Olambda__20,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,multiset(B),aTP_Lamp_ahs(B,multiset(B)),Uu) = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),Uu),zero_zero(multiset(B))) ) ).

% ATP.lambda_20
tff(fact_6186_ATP_Olambda__21,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B] : ( aa(B,list(B),aTP_Lamp_anj(B,list(B)),Uu) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uu),nil(B)) ) ) ).

% ATP.lambda_21
tff(fact_6187_ATP_Olambda__22,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,list(B),aTP_Lamp_ait(B,list(B)),Uu) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uu),nil(B)) ) ).

% ATP.lambda_22
tff(fact_6188_ATP_Olambda__23,axiom,
    ! [C: $tType,Uu: C] : ( aa(C,set(C),aTP_Lamp_ayp(C,set(C)),Uu) = aa(set(C),set(C),insert(C,Uu),bot_bot(set(C))) ) ).

% ATP.lambda_23
tff(fact_6189_ATP_Olambda__24,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,set(B),aTP_Lamp_dj(B,set(B)),Uu) = aa(set(B),set(B),insert(B,Uu),bot_bot(set(B))) ) ).

% ATP.lambda_24
tff(fact_6190_ATP_Olambda__25,axiom,
    ! [B: $tType] :
      ( countable(B)
     => ! [Uu: fun(B,nat)] :
          ( aa(fun(B,nat),$o,aTP_Lamp_azo(fun(B,nat),$o),Uu)
        <=> inj_on(B,nat,Uu,top_top(set(B))) ) ) ).

% ATP.lambda_25
tff(fact_6191_ATP_Olambda__26,axiom,
    ! [D: $tType,B: $tType,Uu: fun(B,D)] : ( aa(fun(B,D),set(D),aTP_Lamp_apy(fun(B,D),set(D)),Uu) = aa(set(B),set(D),image2(B,D,Uu),top_top(set(B))) ) ).

% ATP.lambda_26
tff(fact_6192_ATP_Olambda__27,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C)] : ( aa(fun(B,C),set(C),aTP_Lamp_apx(fun(B,C),set(C)),Uu) = aa(set(B),set(C),image2(B,C,Uu),top_top(set(B))) ) ).

% ATP.lambda_27
tff(fact_6193_ATP_Olambda__28,axiom,
    ! [C: $tType,Uu: option(C)] :
      ( aa(option(C),$o,aTP_Lamp_avl(option(C),$o),Uu)
    <=> ( Uu = none(C) ) ) ).

% ATP.lambda_28
tff(fact_6194_ATP_Olambda__29,axiom,
    ! [B: $tType,Uu: option(B)] :
      ( aa(option(B),$o,aTP_Lamp_avk(option(B),$o),Uu)
    <=> ( Uu = none(B) ) ) ).

% ATP.lambda_29
tff(fact_6195_ATP_Olambda__30,axiom,
    ! [C: $tType,Uu: list(C)] :
      ( aa(list(C),$o,aTP_Lamp_aog(list(C),$o),Uu)
    <=> ( Uu = nil(C) ) ) ).

% ATP.lambda_30
tff(fact_6196_ATP_Olambda__31,axiom,
    ! [B: $tType,Uu: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_aof(list(B),$o),Uu)
    <=> ( Uu = nil(B) ) ) ).

% ATP.lambda_31
tff(fact_6197_ATP_Olambda__32,axiom,
    ! [Uu: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aTP_Lamp_abr(product_prod(int,int),$o),Uu)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uu))) ) ).

% ATP.lambda_32
tff(fact_6198_ATP_Olambda__33,axiom,
    ! [Uu: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_axx(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,aTP_Lamp_axw(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu)) ) ).

% ATP.lambda_33
tff(fact_6199_ATP_Olambda__34,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_awf(nat,nat),Uu) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uu)) ) ).

% ATP.lambda_34
tff(fact_6200_ATP_Olambda__35,axiom,
    ! [C: $tType,Uu: list(C)] : ( aa(list(C),fun(nat,nat),aTP_Lamp_aiv(list(C),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(C),nat,size_size(list(C)),Uu)),aa(nat,nat,suc,zero_zero(nat)))) ) ).

% ATP.lambda_35
tff(fact_6201_ATP_Olambda__36,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,fun(set(product_prod(B,B)),set(product_prod(B,B))),aTP_Lamp_ls(B,fun(set(product_prod(B,B)),set(product_prod(B,B)))),Uu) = insert(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),Uu)) ) ).

% ATP.lambda_36
tff(fact_6202_ATP_Olambda__37,axiom,
    ! [C: $tType,Uu: option(C)] :
      ( aa(option(C),$o,aTP_Lamp_avj(option(C),$o),Uu)
    <=> ( Uu != none(C) ) ) ).

% ATP.lambda_37
tff(fact_6203_ATP_Olambda__38,axiom,
    ! [B: $tType,Uu: option(B)] :
      ( aa(option(B),$o,aTP_Lamp_avi(option(B),$o),Uu)
    <=> ( Uu != none(B) ) ) ).

% ATP.lambda_38
tff(fact_6204_ATP_Olambda__39,axiom,
    ! [C: $tType,Uu: list(C)] :
      ( aa(list(C),$o,aTP_Lamp_aiw(list(C),$o),Uu)
    <=> ( Uu != nil(C) ) ) ).

% ATP.lambda_39
tff(fact_6205_ATP_Olambda__40,axiom,
    ! [B: $tType,Uu: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_aii(list(B),$o),Uu)
    <=> ( Uu != nil(B) ) ) ).

% ATP.lambda_40
tff(fact_6206_ATP_Olambda__41,axiom,
    ! [B: $tType,Uu: option(product_prod(B,product_prod(heap_ext(product_unit),nat)))] : ( aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(B),aTP_Lamp_axa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(B)),Uu) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(set(B)),image2(product_prod(B,product_prod(heap_ext(product_unit),nat)),set(B),basic_fsts(B,product_prod(heap_ext(product_unit),nat))),set_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),Uu))) ) ).

% ATP.lambda_41
tff(fact_6207_ATP_Olambda__42,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,option(C))] : ( aa(fun(B,option(C)),fun(product_prod(B,C),fun(B,option(C))),aTP_Lamp_arq(fun(B,option(C)),fun(product_prod(B,C),fun(B,option(C)))),Uu) = aa(fun(B,fun(C,fun(B,option(C)))),fun(product_prod(B,C),fun(B,option(C))),product_case_prod(B,C,fun(B,option(C))),aTP_Lamp_arp(fun(B,option(C)),fun(B,fun(C,fun(B,option(C)))),Uu)) ) ).

% ATP.lambda_42
tff(fact_6208_ATP_Olambda__43,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: C] : ( aa(C,fun(product_prod(B,D),product_prod(B,product_prod(C,D))),aTP_Lamp_akv(C,fun(product_prod(B,D),product_prod(B,product_prod(C,D)))),Uu) = aa(fun(B,fun(D,product_prod(B,product_prod(C,D)))),fun(product_prod(B,D),product_prod(B,product_prod(C,D))),product_case_prod(B,D,product_prod(B,product_prod(C,D))),aTP_Lamp_aku(C,fun(B,fun(D,product_prod(B,product_prod(C,D)))),Uu)) ) ).

% ATP.lambda_43
tff(fact_6209_ATP_Olambda__44,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: B] : ( aa(B,fun(product_prod(C,D),product_prod(product_prod(B,C),D)),aTP_Lamp_ql(B,fun(product_prod(C,D),product_prod(product_prod(B,C),D))),Uu) = aa(fun(C,fun(D,product_prod(product_prod(B,C),D))),fun(product_prod(C,D),product_prod(product_prod(B,C),D)),product_case_prod(C,D,product_prod(product_prod(B,C),D)),aTP_Lamp_qk(B,fun(C,fun(D,product_prod(product_prod(B,C),D))),Uu)) ) ).

% ATP.lambda_44
tff(fact_6210_ATP_Olambda__45,axiom,
    ! [B: $tType,Uu: multiset(B)] : ( aa(multiset(B),set(B),aTP_Lamp_atq(multiset(B),set(B)),Uu) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_aoy(multiset(B),fun(B,$o),Uu)) ) ).

% ATP.lambda_45
tff(fact_6211_ATP_Olambda__46,axiom,
    ! [Uu: nat] : ( aa(nat,set(nat),aTP_Lamp_zq(nat,set(nat)),Uu) = aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_yz(nat,fun(nat,$o),Uu)) ) ).

% ATP.lambda_46
tff(fact_6212_ATP_Olambda__47,axiom,
    ! [C: $tType,Uu: fun(C,nat)] :
      ( aa(fun(C,nat),$o,aTP_Lamp_aqm(fun(C,nat),$o),Uu)
    <=> aa(set(C),$o,finite_finite2(C),aa(fun(C,$o),set(C),collect(C),aTP_Lamp_aqj(fun(C,nat),fun(C,$o),Uu))) ) ).

% ATP.lambda_47
tff(fact_6213_ATP_Olambda__48,axiom,
    ! [B: $tType,Uu: fun(B,nat)] :
      ( aa(fun(B,nat),$o,aTP_Lamp_apb(fun(B,nat),$o),Uu)
    <=> aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_tk(fun(B,nat),fun(B,$o),Uu))) ) ).

% ATP.lambda_48
tff(fact_6214_ATP_Olambda__49,axiom,
    ! [B: $tType,Uu: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aTP_Lamp_ahq(fun(B,$o),$o),Uu)
    <=> aa(set(B),$o,finite_finite2(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_as(fun(B,$o),fun(B,$o),Uu))) ) ).

% ATP.lambda_49
tff(fact_6215_ATP_Olambda__50,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C)] : ( aa(fun(B,C),set(product_prod(B,C)),aTP_Lamp_es(fun(B,C),set(product_prod(B,C))),Uu) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_er(fun(B,C),fun(B,fun(C,$o)),Uu))) ) ).

% ATP.lambda_50
tff(fact_6216_ATP_Olambda__51,axiom,
    ! [C: $tType,Uu: list(C)] : ( aa(list(C),fun(nat,nat),aTP_Lamp_aiu(list(C),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(C),nat,size_size(list(C)),Uu)) ) ).

% ATP.lambda_51
tff(fact_6217_ATP_Olambda__52,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),fun(nat,nat),aTP_Lamp_aiz(list(B),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(B),nat,size_size(list(B)),Uu)) ) ).

% ATP.lambda_52
tff(fact_6218_ATP_Olambda__53,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [Uu: nat] : ( aa(nat,heap_Time_Heap(B),aTP_Lamp_awz(nat,heap_Time_Heap(B)),Uu) = heap_Time_ureturn(B,aa(nat,B,semiring_1_of_nat(B),Uu)) ) ) ).

% ATP.lambda_53
tff(fact_6219_ATP_Olambda__54,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_aai(num,option(num)),Uu) = aa(num,option(num),some(num),aa(num,num,bit1,Uu)) ) ).

% ATP.lambda_54
tff(fact_6220_ATP_Olambda__55,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_aaz(num,option(num)),Uu) = aa(num,option(num),some(num),aa(num,num,bit0,Uu)) ) ).

% ATP.lambda_55
tff(fact_6221_ATP_Olambda__56,axiom,
    ! [Uu: int] : ( aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aah(int,fun(int,product_prod(int,int))),Uu) = aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),Uu)) ) ).

% ATP.lambda_56
tff(fact_6222_ATP_Olambda__57,axiom,
    ! [Uu: int] : ( aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aaj(int,fun(int,product_prod(int,int))),Uu) = aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,abs_abs(int),Uu)) ) ).

% ATP.lambda_57
tff(fact_6223_ATP_Olambda__58,axiom,
    ! [Uu: nat] : ( aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_ty(nat,fun(nat,product_prod(nat,nat))),Uu) = aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_58
tff(fact_6224_ATP_Olambda__59,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B] : ( aa(B,filter(B),aTP_Lamp_xw(B,filter(B)),Uu) = principal(B,aa(B,set(B),set_ord_atLeast(B),Uu)) ) ) ).

% ATP.lambda_59
tff(fact_6225_ATP_Olambda__60,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Uu: B] : ( aa(B,filter(B),aTP_Lamp_xt(B,filter(B)),Uu) = principal(B,aa(B,set(B),set_ord_atLeast(B),Uu)) ) ) ).

% ATP.lambda_60
tff(fact_6226_ATP_Olambda__61,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B] : ( aa(B,filter(B),aTP_Lamp_qg(B,filter(B)),Uu) = principal(B,aa(B,set(B),set_ord_atMost(B),Uu)) ) ) ).

% ATP.lambda_61
tff(fact_6227_ATP_Olambda__62,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Uu: B] : ( aa(B,filter(B),aTP_Lamp_qc(B,filter(B)),Uu) = principal(B,aa(B,set(B),set_ord_atMost(B),Uu)) ) ) ).

% ATP.lambda_62
tff(fact_6228_ATP_Olambda__63,axiom,
    ! [Uu: int] : ( aa(int,nat,aTP_Lamp_zt(int,nat),Uu) = aa(int,nat,nat2,aa(int,int,abs_abs(int),Uu)) ) ).

% ATP.lambda_63
tff(fact_6229_ATP_Olambda__64,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Uu: B] :
          ( aa(B,$o,aTP_Lamp_acy(B,$o),Uu)
        <=> ? [N4: int] :
              ( ( Uu = aa(int,B,ring_1_of_int(B),N4) )
              & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N4) ) ) ) ).

% ATP.lambda_64
tff(fact_6230_ATP_Olambda__65,axiom,
    ! [Uu: set(product_prod(int,int))] :
      ( aa(set(product_prod(int,int)),$o,aTP_Lamp_arm(set(product_prod(int,int)),$o),Uu)
    <=> ? [X3: product_prod(int,int)] :
          ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X3),X3)
          & ( Uu = aa(fun(product_prod(int,int),$o),set(product_prod(int,int)),collect(product_prod(int,int)),aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X3)) ) ) ) ).

% ATP.lambda_65
tff(fact_6231_ATP_Olambda__66,axiom,
    ! [Uu: set(product_prod(nat,nat))] :
      ( aa(set(product_prod(nat,nat)),$o,aTP_Lamp_axt(set(product_prod(nat,nat)),$o),Uu)
    <=> ? [X3: product_prod(nat,nat)] :
          ( aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,X3),X3)
          & ( Uu = aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,X3)) ) ) ) ).

% ATP.lambda_66
tff(fact_6232_ATP_Olambda__67,axiom,
    ! [B: $tType,Uu: product_prod(B,B)] :
      ( aa(product_prod(B,B),$o,aTP_Lamp_in(product_prod(B,B),$o),Uu)
    <=> ? [X3: B] : ( Uu = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),X3) ) ) ).

% ATP.lambda_67
tff(fact_6233_ATP_Olambda__68,axiom,
    ! [B: $tType,C: $tType,Uu: product_prod(product_prod($o,B),product_prod($o,C))] :
      ( aa(product_prod(product_prod($o,B),product_prod($o,C)),$o,aTP_Lamp_bc(product_prod(product_prod($o,B),product_prod($o,C)),$o),Uu)
    <=> ? [X3: B,Y4: C] : ( Uu = aa(product_prod($o,C),product_prod(product_prod($o,B),product_prod($o,C)),aa(product_prod($o,B),fun(product_prod($o,C),product_prod(product_prod($o,B),product_prod($o,C))),product_Pair(product_prod($o,B),product_prod($o,C)),aa(B,product_prod($o,B),aa($o,fun(B,product_prod($o,B)),product_Pair($o,B),$true),X3)),aa(C,product_prod($o,C),aa($o,fun(C,product_prod($o,C)),product_Pair($o,C),$false),Y4)) ) ) ).

% ATP.lambda_68
tff(fact_6234_ATP_Olambda__69,axiom,
    ! [C: $tType,B: $tType,Uu: product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat))] :
      ( aa(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),$o,aTP_Lamp_ayj(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),$o),Uu)
    <=> ? [F8: fun(nat,sum_sum(B,nat)),X3: sum_sum(C,nat),K5: nat] :
          ( ( Uu = aa(sum_sum(C,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),aa(fun(nat,sum_sum(B,nat)),fun(sum_sum(C,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat))),product_Pair(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),F8),X3) )
          & ( aa(nat,sum_sum(B,nat),F8,K5) = aa(nat,sum_sum(B,nat),sum_Inr(nat,B),zero_zero(nat)) ) ) ) ).

% ATP.lambda_69
tff(fact_6235_ATP_Olambda__70,axiom,
    ! [B: $tType,C: $tType,Uu: B] : ( aa(B,heap_Time_Heap(C),aTP_Lamp_baq(B,heap_Time_Heap(C)),Uu) = heap_Time_Heap2(C,aTP_Lamp_bap(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))))) ) ).

% ATP.lambda_70
tff(fact_6236_ATP_Olambda__71,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B)] : ( aa(array(B),heap_Time_Heap(product_unit),aTP_Lamp_axr(array(B),heap_Time_Heap(product_unit)),Uu) = heap_Time_ureturn(product_unit,product_Unity) ) ) ).

% ATP.lambda_71
tff(fact_6237_ATP_Olambda__72,axiom,
    ! [C: $tType,Uu: nat] : ( aa(nat,sum_sum(C,nat),aTP_Lamp_ays(nat,sum_sum(C,nat)),Uu) = aa(nat,sum_sum(C,nat),sum_Inr(nat,C),zero_zero(nat)) ) ).

% ATP.lambda_72
tff(fact_6238_ATP_Olambda__73,axiom,
    ! [B: $tType,Uu: nat] : ( aa(nat,sum_sum(B,nat),aTP_Lamp_ayo(nat,sum_sum(B,nat)),Uu) = aa(nat,sum_sum(B,nat),sum_Inr(nat,B),zero_zero(nat)) ) ).

% ATP.lambda_73
tff(fact_6239_ATP_Olambda__74,axiom,
    ! [Uu: num,Uua: nat] : ( aa(nat,option(num),aTP_Lamp_abh(num,fun(nat,option(num)),Uu),Uua) = case_num(option(num),aa(num,option(num),some(num),one2),aTP_Lamp_abf(nat,fun(num,option(num)),Uua),aTP_Lamp_abg(nat,fun(num,option(num)),Uua),Uu) ) ).

% ATP.lambda_74
tff(fact_6240_ATP_Olambda__75,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Uu: nat,Uua: nat] :
          ( aa(nat,B,aTP_Lamp_ys(nat,fun(nat,B),Uu),Uua)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,binomial(Uu),Uua)),zero_zero(B)) ) ) ).

% ATP.lambda_75
tff(fact_6241_ATP_Olambda__76,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: product_prod(B,D),Uua: product_prod(D,C)] :
      ( aa(product_prod(D,C),list(product_prod(B,C)),aTP_Lamp_aky(product_prod(B,D),fun(product_prod(D,C),list(product_prod(B,C))),Uu),Uua)
      = $ite(aa(product_prod(B,D),D,product_snd(B,D),Uu) = aa(product_prod(D,C),D,product_fst(D,C),Uua),aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(product_prod(B,D),B,product_fst(B,D),Uu)),aa(product_prod(D,C),C,product_snd(D,C),Uua))),nil(product_prod(B,C))),nil(product_prod(B,C))) ) ).

% ATP.lambda_76
tff(fact_6242_ATP_Olambda__77,axiom,
    ! [B: $tType,Uu: list(B),Uua: nat] :
      ( aa(nat,option(B),aTP_Lamp_aje(list(B),fun(nat,option(B)),Uu),Uua)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uua),aa(list(B),nat,size_size(list(B)),Uu)),aa(B,option(B),some(B),aa(nat,B,nth(B,Uu),Uua)),none(B)) ) ).

% ATP.lambda_77
tff(fact_6243_ATP_Olambda__78,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aba(int,fun(int,product_prod(int,int))),Uu),Uua)
      = $ite(Uu = zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),Uu)),Uua)),aa(int,int,abs_abs(int),Uu))) ) ).

% ATP.lambda_78
tff(fact_6244_ATP_Olambda__79,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_acc(int,fun(int,product_prod(int,int))),Uu),Uua)
      = $ite(Uua = zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Uu),Uua)) ) ).

% ATP.lambda_79
tff(fact_6245_ATP_Olambda__80,axiom,
    ! [B: $tType,Uu: set(fun(B,nat)),Uua: B] :
      ( aa(B,nat,aa(set(fun(B,nat)),fun(B,nat),aTP_Lamp_aph(set(fun(B,nat)),fun(B,nat)),Uu),Uua)
      = $ite(Uu = bot_bot(set(fun(B,nat))),zero_zero(nat),aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(fun(B,nat)),set(nat),image2(fun(B,nat),nat,aTP_Lamp_apc(B,fun(fun(B,nat),nat),Uua)),Uu))) ) ).

% ATP.lambda_80
tff(fact_6246_ATP_Olambda__81,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Uu: nat,Uua: nat] :
          ( aa(nat,B,aTP_Lamp_yr(nat,fun(nat,B),Uu),Uua)
          = $ite(~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,binomial(Uu),Uua)),zero_zero(B)) ) ) ).

% ATP.lambda_81
tff(fact_6247_ATP_Olambda__82,axiom,
    ! [B: $tType] :
      ( ( lattice(B)
        & order_top(B) )
     => ! [Uu: fun(B,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_agy(fun(B,B),fun(nat,B),Uu),Uua) = aa(B,B,compow(fun(B,B),Uua,Uu),top_top(B)) ) ) ).

% ATP.lambda_82
tff(fact_6248_ATP_Olambda__83,axiom,
    ! [B: $tType] :
      ( ( lattice(B)
        & order_bot(B) )
     => ! [Uu: fun(B,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_agw(fun(B,B),fun(nat,B),Uu),Uua) = aa(B,B,compow(fun(B,B),Uua,Uu),bot_bot(B)) ) ) ).

% ATP.lambda_83
tff(fact_6249_ATP_Olambda__84,axiom,
    ! [B: $tType,Uu: list(list(B)),Uua: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_aok(list(list(B)),fun(list(B),$o),Uu),Uua)
    <=> aa(list(list(B)),$o,aa(list(B),fun(list(list(B)),$o),list_all2(B,list(B),aTP_Lamp_aoj(B,fun(list(B),$o))),Uua),Uu) ) ).

% ATP.lambda_84
tff(fact_6250_ATP_Olambda__85,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [Uu: option(B),Uua: B] : ( aa(B,option(B),aTP_Lamp_abe(option(B),fun(B,option(B)),Uu),Uua) = case_option(option(B),B,none(B),aTP_Lamp_abd(B,fun(B,option(B)),Uua),Uu) ) ) ).

% ATP.lambda_85
tff(fact_6251_ATP_Olambda__86,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Uu: option(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_aab(option(B),fun(B,$o),Uu),Uua)
        <=> case_option($o,B,$true,aa(B,fun(B,$o),aTP_Lamp_aaa(B,fun(B,$o)),Uua),Uu) ) ) ).

% ATP.lambda_86
tff(fact_6252_ATP_Olambda__87,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aa(nat,fun(num,option(num)),aTP_Lamp_abi(nat,fun(num,option(num))),Uu),Uua) = aa(nat,option(num),aa(fun(nat,option(num)),fun(nat,option(num)),aa(option(num),fun(fun(nat,option(num)),fun(nat,option(num))),case_nat(option(num)),none(num)),aTP_Lamp_abh(num,fun(nat,option(num)),Uua)),Uu) ) ).

% ATP.lambda_87
tff(fact_6253_ATP_Olambda__88,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Uu: option(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_aac(option(B),fun(B,$o),Uu),Uua)
        <=> case_option($o,B,$false,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_88
tff(fact_6254_ATP_Olambda__89,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_abf(nat,fun(num,option(num)),Uu),Uua) = case_option(option(num),num,none(num),aTP_Lamp_aaz(num,option(num)),bit_take_bit_num(Uu,Uua)) ) ).

% ATP.lambda_89
tff(fact_6255_ATP_Olambda__90,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aTP_Lamp_ev(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),Uu),Uua)
    <=> aa(C,$o,aa(B,fun(C,$o),Uu,aa(product_prod(B,C),B,product_fst(B,C),Uua)),aa(product_prod(B,C),C,product_snd(B,C),Uua)) ) ).

% ATP.lambda_90
tff(fact_6256_ATP_Olambda__91,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(B,fun(B,B)),Uua: B] : ( aa(B,B,aTP_Lamp_mj(fun(B,fun(B,B)),fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),Uu,Uua),Uua) ) ) ).

% ATP.lambda_91
tff(fact_6257_ATP_Olambda__92,axiom,
    ! [B: $tType,Uu: list(list(B)),Uua: nat] : ( aa(nat,list(B),aTP_Lamp_alr(list(list(B)),fun(nat,list(B)),Uu),Uua) = aa(list(nat),list(B),map(nat,B,aa(nat,fun(nat,B),aTP_Lamp_alq(list(list(B)),fun(nat,fun(nat,B)),Uu),Uua)),upt(zero_zero(nat),aa(list(list(B)),nat,size_size(list(list(B))),Uu))) ) ).

% ATP.lambda_92
tff(fact_6258_ATP_Olambda__93,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat] : ( aa(nat,B,aTP_Lamp_rg(fun(nat,fun(nat,B)),fun(nat,B),Uu),Uua) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_rf(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uua)),aa(nat,set(nat),set_ord_atMost(nat),Uua)) ) ) ).

% ATP.lambda_93
tff(fact_6259_ATP_Olambda__94,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat] : ( aa(nat,B,aTP_Lamp_re(fun(nat,fun(nat,B)),fun(nat,B),Uu),Uua) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_rd(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uua)),aa(nat,set(nat),set_ord_atMost(nat),Uua)) ) ) ).

% ATP.lambda_94
tff(fact_6260_ATP_Olambda__95,axiom,
    ! [Uu: product_prod(int,int),Uua: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aa(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),aTP_Lamp_abm(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),Uu),Uua) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uua)),aa(product_prod(int,int),int,product_snd(int,int),Uu)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))) ) ).

% ATP.lambda_95
tff(fact_6261_ATP_Olambda__96,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,B,aTP_Lamp_un(nat,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),Uua)),aa(nat,B,semiring_1_of_nat(B),Uua))),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_96
tff(fact_6262_ATP_Olambda__97,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,B,aTP_Lamp_yh(nat,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(nat,B,gbinomial(B,aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua))),Uua)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Uua)) ) ) ).

% ATP.lambda_97
tff(fact_6263_ATP_Olambda__98,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,int,aa(code_integer,fun(code_integer,int),aTP_Lamp_zj(code_integer,fun(code_integer,int)),Uu),Uua)
      = $let(
          l2: int,
          l2 := aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(code_integer,int,code_int_of_integer,Uu)),
          $ite(Uua = zero_zero(code_integer),l2,aa(int,int,aa(int,fun(int,int),plus_plus(int),l2),one_one(int))) ) ) ).

% ATP.lambda_98
tff(fact_6264_ATP_Olambda__99,axiom,
    ! [Uu: product_prod(int,int),Uua: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aa(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),aTP_Lamp_abq(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),Uu),Uua) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_fst(int,int),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))) ) ).

% ATP.lambda_99
tff(fact_6265_ATP_Olambda__100,axiom,
    ! [C: $tType,B: $tType,Uu: set(old_node(B,C)),Uua: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_aza(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),Uu),Uua) = aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),insert(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_In1(B,C,Uu)),old_In1(B,C,Uua))),bot_bot(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))) ) ).

% ATP.lambda_100
tff(fact_6266_ATP_Olambda__101,axiom,
    ! [C: $tType,B: $tType,Uu: set(old_node(B,C)),Uua: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_ayz(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),Uu),Uua) = aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),insert(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_In0(B,C,Uu)),old_In0(B,C,Uua))),bot_bot(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))) ) ).

% ATP.lambda_101
tff(fact_6267_ATP_Olambda__102,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(C,C))] :
      ( aa(set(product_prod(C,C)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o),aTP_Lamp_afw(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o)),Uu),Uua)
    <=> ( order_well_order_on(B,field2(B,Uu),Uu)
        & order_well_order_on(C,field2(C,Uua),Uua)
        & ? [X_12: fun(B,C)] : bNF_Wellorder_embedS(B,C,Uu,Uua,X_12) ) ) ).

% ATP.lambda_102
tff(fact_6268_ATP_Olambda__103,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(C,C))] :
      ( aa(set(product_prod(C,C)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o),aTP_Lamp_agb(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o)),Uu),Uua)
    <=> ( order_well_order_on(B,field2(B,Uu),Uu)
        & order_well_order_on(C,field2(C,Uua),Uua)
        & ? [X_12: fun(B,C)] : aa(fun(B,C),$o,bNF_Wellorder_embed(B,C,Uu,Uua),X_12) ) ) ).

% ATP.lambda_103
tff(fact_6269_ATP_Olambda__104,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(C,C))] :
      ( aa(set(product_prod(C,C)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o),aTP_Lamp_afz(set(product_prod(B,B)),fun(set(product_prod(C,C)),$o)),Uu),Uua)
    <=> ( order_well_order_on(B,field2(B,Uu),Uu)
        & order_well_order_on(C,field2(C,Uua),Uua)
        & ? [X_12: fun(B,C)] : bNF_Wellorder_iso(B,C,Uu,Uua,X_12) ) ) ).

% ATP.lambda_104
tff(fact_6270_ATP_Olambda__105,axiom,
    ! [Uu: rat,Uua: int] :
      ( aa(int,$o,aTP_Lamp_ya(rat,fun(int,$o),Uu),Uua)
    <=> ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(int,rat,ring_1_of_int(rat),Uua)),Uu)
        & aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),Uu),aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),one_one(int)))) ) ) ).

% ATP.lambda_105
tff(fact_6271_ATP_Olambda__106,axiom,
    ! [B: $tType,Uu: set(B),Uua: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_aia(set(B),fun(list(B),$o),Uu),Uua)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Uua)),Uu)
        & distinct(B,Uua) ) ) ).

% ATP.lambda_106
tff(fact_6272_ATP_Olambda__107,axiom,
    ! [B: $tType,Uu: set(B),Uua: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_ahz(set(B),fun(list(B),$o),Uu),Uua)
    <=> ( ( aa(list(B),set(B),set2(B),Uua) = Uu )
        & distinct(B,Uua) ) ) ).

% ATP.lambda_107
tff(fact_6273_ATP_Olambda__108,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,B,aTP_Lamp_tz(nat,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),Uua)),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_108
tff(fact_6274_ATP_Olambda__109,axiom,
    ! [Uu: rat,Uua: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aTP_Lamp_ahk(rat,fun(product_prod(int,int),$o),Uu),Uua)
    <=> ( ( Uu = aa(int,rat,aa(int,fun(int,rat),fract,aa(product_prod(int,int),int,product_fst(int,int),Uua)),aa(product_prod(int,int),int,product_snd(int,int),Uua)) )
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),Uua))
        & algebr8660921524188924756oprime(int,aa(product_prod(int,int),int,product_fst(int,int),Uua),aa(product_prod(int,int),int,product_snd(int,int),Uua)) ) ) ).

% ATP.lambda_109
tff(fact_6275_ATP_Olambda__110,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B] : ( aa(B,set(set(B)),aTP_Lamp_jr(set(product_prod(B,B)),fun(B,set(set(B))),Uu),Uua) = aa(set(set(B)),set(set(B)),insert(set(B),aa(set(B),set(B),image(B,B,Uu),aa(set(B),set(B),insert(B,Uua),bot_bot(set(B))))),bot_bot(set(set(B)))) ) ).

% ATP.lambda_110
tff(fact_6276_ATP_Olambda__111,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_vf(B,fun(nat,B),Uu),Uua) = aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(nat,B,semiring_1_of_nat(B),Uua))),Uua) ) ) ).

% ATP.lambda_111
tff(fact_6277_ATP_Olambda__112,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_ym(B,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,Uu),Uua)),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),Uu),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(nat,B,semiring_1_of_nat(B),Uua))) ) ) ).

% ATP.lambda_112
tff(fact_6278_ATP_Olambda__113,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_vm(B,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,Uu),Uua)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),Uua)) ) ) ).

% ATP.lambda_113
tff(fact_6279_ATP_Olambda__114,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(list(B),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_avx(array(B),fun(heap_ext(product_unit),product_prod(list(B),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(list(B),product_prod(heap_ext(product_unit),nat)),aa(list(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(list(B),product_prod(heap_ext(product_unit),nat))),product_Pair(list(B),product_prod(heap_ext(product_unit),nat)),array_get(B,Uua,Uu)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),array_length(B,Uua,Uu)))) ) ) ).

% ATP.lambda_114
tff(fact_6280_ATP_Olambda__115,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_abk(nat,fun(nat,$o)),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uu),Uua)
        & ( Uu != Uua ) ) ) ).

% ATP.lambda_115
tff(fact_6281_ATP_Olambda__116,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: set(set(B))] :
      ( aa(set(set(B)),$o,aTP_Lamp_ta(set(set(B)),fun(set(set(B)),$o),Uu),Uua)
    <=> ( aa(set(set(B)),$o,aa(set(set(B)),fun(set(set(B)),$o),ord_less_eq(set(set(B))),Uua),Uu)
        & ( Uua != bot_bot(set(set(B))) ) ) ) ).

% ATP.lambda_116
tff(fact_6282_ATP_Olambda__117,axiom,
    ! [B: $tType,Uu: set(option(B)),Uua: option(B)] :
      ( aa(option(B),$o,aTP_Lamp_abo(set(option(B)),fun(option(B),$o),Uu),Uua)
    <=> ( aa(set(option(B)),$o,member(option(B),Uua),Uu)
        & ( Uua != none(B) ) ) ) ).

% ATP.lambda_117
tff(fact_6283_ATP_Olambda__118,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ye(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(nat,nat,binomial(Uu),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% ATP.lambda_118
tff(fact_6284_ATP_Olambda__119,axiom,
    ! [Uu: set(int),Uua: int] :
      ( aa(int,$o,aTP_Lamp_adu(set(int),fun(int,$o),Uu),Uua)
    <=> ( aa(set(int),$o,member(int,Uua),Uu)
        & ! [X3: int] :
            ( aa(set(int),$o,member(int,X3),Uu)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X3),Uua) ) ) ) ).

% ATP.lambda_119
tff(fact_6285_ATP_Olambda__120,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_adv(set(set(B)),fun(set(B),$o),Uu),Uua)
    <=> ( aa(set(set(B)),$o,member(set(B),Uua),Uu)
        & ! [X3: set(B)] :
            ( aa(set(set(B)),$o,member(set(B),X3),Uu)
           => ~ aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),Uua),X3) ) ) ) ).

% ATP.lambda_120
tff(fact_6286_ATP_Olambda__121,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),aTP_Lamp_afr(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o)),Uu),Uua)
    <=> ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),Uu),Uua)
        & ! [A6: B,B5: B,C4: B] :
            ( ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A6),B5)),Uua)
              & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B5),C4)),Uu) )
           => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A6),B5)),Uu) ) ) ) ).

% ATP.lambda_121
tff(fact_6287_ATP_Olambda__122,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: set(set(B))] :
      ( aa(set(set(B)),$o,aTP_Lamp_ju(set(set(B)),fun(set(set(B)),$o),Uu),Uua)
    <=> ( aa(set(set(B)),$o,aa(set(set(B)),fun(set(set(B)),$o),ord_less_eq(set(set(B))),Uua),Uu)
        & chain_subset(B,Uua) ) ) ).

% ATP.lambda_122
tff(fact_6288_ATP_Olambda__123,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_lp(set(B),fun(set(B),$o),Uu),Uua)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),Uua),Uu)
        & aa(set(B),$o,finite_finite2(B),Uua) ) ) ).

% ATP.lambda_123
tff(fact_6289_ATP_Olambda__124,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),aTP_Lamp_vr(set(B),fun(set(B),$o)),Uu),Uua)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),Uu),Uua)
        & aa(set(B),$o,finite_finite2(B),Uua) ) ) ).

% ATP.lambda_124
tff(fact_6290_ATP_Olambda__125,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_xz(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uu),Uua)),Uua) ) ).

% ATP.lambda_125
tff(fact_6291_ATP_Olambda__126,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_uf(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uu) ) ).

% ATP.lambda_126
tff(fact_6292_ATP_Olambda__127,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ue(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uua) ) ).

% ATP.lambda_127
tff(fact_6293_ATP_Olambda__128,axiom,
    ! [C: $tType,B: $tType,Uu: set(old_node(B,C)),Uua: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(set(old_node(B,C))),aTP_Lamp_azj(set(old_node(B,C)),fun(set(old_node(B,C)),set(set(old_node(B,C)))),Uu),Uua) = aa(set(set(old_node(B,C))),set(set(old_node(B,C))),insert(set(old_node(B,C)),old_Scons(B,C,Uu,Uua)),bot_bot(set(set(old_node(B,C))))) ) ).

% ATP.lambda_128
tff(fact_6294_ATP_Olambda__129,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: B] : ( aa(B,set(product_prod(C,B)),aTP_Lamp_lh(C,fun(B,set(product_prod(C,B))),Uu),Uua) = aa(set(product_prod(C,B)),set(product_prod(C,B)),insert(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uu),Uua)),bot_bot(set(product_prod(C,B)))) ) ).

% ATP.lambda_129
tff(fact_6295_ATP_Olambda__130,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C] : ( aa(C,set(product_prod(B,C)),aTP_Lamp_hb(B,fun(C,set(product_prod(B,C))),Uu),Uua) = aa(set(product_prod(B,C)),set(product_prod(B,C)),insert(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),Uua)),bot_bot(set(product_prod(B,C)))) ) ).

% ATP.lambda_130
tff(fact_6296_ATP_Olambda__131,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aTP_Lamp_yf(B,fun(B,$o),Uu),Uua)
        <=> ( aa(set(B),$o,member(B,Uua),ring_1_Ints(B))
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),Uua)),Uu) ) ) ) ).

% ATP.lambda_131
tff(fact_6297_ATP_Olambda__132,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aTP_Lamp_auw(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),Uu),Uua)
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),aa(set(product_prod(B,C)),set(product_prod(B,C)),insert(product_prod(B,C),Uua),bot_bot(set(product_prod(B,C))))),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Uu))) ) ).

% ATP.lambda_132
tff(fact_6298_ATP_Olambda__133,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(C,fun(D,$o)),Uua: fun(B,product_prod(C,D))] :
      ( aa(fun(B,product_prod(C,D)),$o,aTP_Lamp_fc(fun(C,fun(D,$o)),fun(fun(B,product_prod(C,D)),$o),Uu),Uua)
    <=> aa(set(product_prod(C,D)),$o,aa(set(product_prod(C,D)),fun(set(product_prod(C,D)),$o),ord_less_eq(set(product_prod(C,D))),aa(set(B),set(product_prod(C,D)),image2(B,product_prod(C,D),Uua),top_top(set(B)))),aa(fun(product_prod(C,D),$o),set(product_prod(C,D)),collect(product_prod(C,D)),aa(fun(C,fun(D,$o)),fun(product_prod(C,D),$o),product_case_prod(C,D,$o),Uu))) ) ).

% ATP.lambda_133
tff(fact_6299_ATP_Olambda__134,axiom,
    ! [B: $tType,Uu: fun(set(B),$o),Uua: set(B)] :
      ( aa(set(B),$o,aa(fun(set(B),$o),fun(set(B),$o),aTP_Lamp_lc(fun(set(B),$o),fun(set(B),$o)),Uu),Uua)
    <=> ( ( Uua = bot_bot(set(B)) )
        | ? [A12: set(B),A6: B] :
            ( ( Uua = aa(set(B),set(B),insert(B,A6),A12) )
            & aa(set(B),$o,Uu,A12) ) ) ) ).

% ATP.lambda_134
tff(fact_6300_ATP_Olambda__135,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: fun(B,C)] :
      ( aa(fun(B,C),$o,aTP_Lamp_agg(set(C),fun(fun(B,C),$o),Uu),Uua)
    <=> aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,Uua),top_top(set(B)))),Uu) ) ).

% ATP.lambda_135
tff(fact_6301_ATP_Olambda__136,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B] : ( aa(B,set(set(B)),aTP_Lamp_js(set(product_prod(B,B)),fun(B,set(set(B))),Uu),Uua) = equiv_quotient(B,aa(set(B),set(B),insert(B,Uua),bot_bot(set(B))),Uu) ) ).

% ATP.lambda_136
tff(fact_6302_ATP_Olambda__137,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: set(B),Uua: list(B)] :
          ( aa(list(B),$o,aTP_Lamp_alf(set(B),fun(list(B),$o),Uu),Uua)
        <=> ( sorted_wrt(B,ord_less(B),Uua)
            & ( aa(list(B),set(B),set2(B),Uua) = Uu ) ) ) ) ).

% ATP.lambda_137
tff(fact_6303_ATP_Olambda__138,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_uu(set(product_prod(B,B)),fun(nat,$o),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),aa(set(product_prod(B,B)),nat,finite_card(product_prod(B,B)),Uu)) ) ) ).

% ATP.lambda_138
tff(fact_6304_ATP_Olambda__139,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_vq(nat,fun(nat,$o),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),aa(nat,nat,suc,Uu)) ) ) ).

% ATP.lambda_139
tff(fact_6305_ATP_Olambda__140,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(D,product_prod(B,C)),Uua: B] : ( aa(B,set(C),aTP_Lamp_en(fun(D,product_prod(B,C)),fun(B,set(C)),Uu),Uua) = aa(set(D),set(C),image2(D,C,aa(fun(D,product_prod(B,C)),fun(D,C),comp(product_prod(B,C),C,D,product_snd(B,C)),Uu)),top_top(set(D))) ) ).

% ATP.lambda_140
tff(fact_6306_ATP_Olambda__141,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_yd(fun(nat,B),fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))),aa(nat,B,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))) ) ) ).

% ATP.lambda_141
tff(fact_6307_ATP_Olambda__142,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_yc(fun(nat,B),fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))),aa(nat,B,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))) ) ) ).

% ATP.lambda_142
tff(fact_6308_ATP_Olambda__143,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_su(fun(nat,B),fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,Uu,aa(nat,nat,suc,Uua))),aa(nat,B,Uu,Uua)) ) ) ).

% ATP.lambda_143
tff(fact_6309_ATP_Olambda__144,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat] : ( aa(nat,B,aTP_Lamp_wg(fun(nat,fun(nat,B)),fun(nat,B),Uu),Uua) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),Uu,Uua)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_144
tff(fact_6310_ATP_Olambda__145,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat] : ( aa(nat,B,aTP_Lamp_we(fun(nat,fun(nat,B)),fun(nat,B),Uu),Uua) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),Uu,Uua)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_145
tff(fact_6311_ATP_Olambda__146,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_ro(fun(nat,B),fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uu,Uua)),aa(nat,B,aa(B,fun(nat,B),power_power(B),zero_zero(B)),Uua)) ) ) ).

% ATP.lambda_146
tff(fact_6312_ATP_Olambda__147,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_sy(fun(nat,B),fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,Uu,Uua)),aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_147
tff(fact_6313_ATP_Olambda__148,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_si(fun(nat,B),fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,Uu,Uua)),aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_148
tff(fact_6314_ATP_Olambda__149,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_sx(fun(nat,B),fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,Uu,Uua)),aa(nat,B,Uu,aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_149
tff(fact_6315_ATP_Olambda__150,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [Uu: fun(B,$o),Uua: B] :
          ( aa(B,$o,aTP_Lamp_afl(fun(B,$o),fun(B,$o),Uu),Uua)
        <=> ( aa(B,$o,Uu,Uua)
            & ! [Y4: B] :
                ( aa(B,$o,Uu,Y4)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Y4) ) ) ) ) ).

% ATP.lambda_150
tff(fact_6316_ATP_Olambda__151,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Uu: fun(B,$o),Uua: B] :
          ( aa(B,$o,aTP_Lamp_afo(fun(B,$o),fun(B,$o),Uu),Uua)
        <=> ( aa(B,$o,Uu,Uua)
            & ! [Y4: B] :
                ( aa(B,$o,Uu,Y4)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y4),Uua) ) ) ) ) ).

% ATP.lambda_151
tff(fact_6317_ATP_Olambda__152,axiom,
    ! [B: $tType,Uu: fun(multiset(B),$o),Uua: multiset(B)] :
      ( aa(multiset(B),$o,aTP_Lamp_ato(fun(multiset(B),$o),fun(multiset(B),$o),Uu),Uua)
    <=> ( aa(multiset(B),$o,Uu,Uua)
        & ! [Y4: multiset(B)] :
            ( aa(multiset(B),$o,Uu,Y4)
           => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Uua),Y4) ) ) ) ).

% ATP.lambda_152
tff(fact_6318_ATP_Olambda__153,axiom,
    ! [B: $tType,Uu: fun(multiset(B),$o),Uua: multiset(B)] :
      ( aa(multiset(B),$o,aTP_Lamp_att(fun(multiset(B),$o),fun(multiset(B),$o),Uu),Uua)
    <=> ( aa(multiset(B),$o,Uu,Uua)
        & ! [Y4: multiset(B)] :
            ( aa(multiset(B),$o,Uu,Y4)
           => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Y4),Uua) ) ) ) ).

% ATP.lambda_153
tff(fact_6319_ATP_Olambda__154,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat] : ( aa(nat,B,aTP_Lamp_vc(fun(nat,fun(nat,B)),fun(nat,B),Uu),Uua) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),Uu,Uua)),aa(nat,set(nat),set_ord_lessThan(nat),Uua)) ) ) ).

% ATP.lambda_154
tff(fact_6320_ATP_Olambda__155,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat] : ( aa(nat,B,aTP_Lamp_uz(fun(nat,fun(nat,B)),fun(nat,B),Uu),Uua) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),Uu,Uua)),aa(nat,set(nat),set_ord_lessThan(nat),Uua)) ) ) ).

% ATP.lambda_155
tff(fact_6321_ATP_Olambda__156,axiom,
    ! [C: $tType,Uu: fun(nat,sum_sum(C,nat)),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_ayq(fun(nat,sum_sum(C,nat)),fun(nat,$o),Uu),Uua)
    <=> ( aa(nat,sum_sum(C,nat),Uu,Uua) = aa(nat,sum_sum(C,nat),sum_Inr(nat,C),zero_zero(nat)) ) ) ).

% ATP.lambda_156
tff(fact_6322_ATP_Olambda__157,axiom,
    ! [B: $tType,Uu: fun(nat,sum_sum(B,nat)),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_ayf(fun(nat,sum_sum(B,nat)),fun(nat,$o),Uu),Uua)
    <=> ( aa(nat,sum_sum(B,nat),Uu,Uua) = aa(nat,sum_sum(B,nat),sum_Inr(nat,B),zero_zero(nat)) ) ) ).

% ATP.lambda_157
tff(fact_6323_ATP_Olambda__158,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(B,B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_mp(fun(B,B),fun(B,$o),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,Uu,Uua)),Uua) ) ) ).

% ATP.lambda_158
tff(fact_6324_ATP_Olambda__159,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B] : ( aa(B,product_prod(nat,B),aTP_Lamp_aut(fun(B,nat),fun(B,product_prod(nat,B)),Uu),Uua) = aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),aa(B,nat,Uu,Uua)),Uua) ) ).

% ATP.lambda_159
tff(fact_6325_ATP_Olambda__160,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: B] : ( aa(B,product_prod(C,B),aTP_Lamp_dn(fun(B,C),fun(B,product_prod(C,B)),Uu),Uua) = aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),aa(B,C,Uu,Uua)),Uua) ) ).

% ATP.lambda_160
tff(fact_6326_ATP_Olambda__161,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,B),Uua: C] : ( aa(C,list(B),aTP_Lamp_ajt(fun(C,B),fun(C,list(B)),Uu),Uua) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),aa(C,B,Uu,Uua)),nil(B)) ) ).

% ATP.lambda_161
tff(fact_6327_ATP_Olambda__162,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,B),Uua: C] : ( aa(C,set(B),aTP_Lamp_gz(fun(C,B),fun(C,set(B)),Uu),Uua) = aa(set(B),set(B),insert(B,aa(C,B,Uu,Uua)),bot_bot(set(B))) ) ).

% ATP.lambda_162
tff(fact_6328_ATP_Olambda__163,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(B,C),Uua: B] :
          ( aa(B,$o,aTP_Lamp_ps(fun(B,C),fun(B,$o),Uu),Uua)
        <=> ( aa(B,C,Uu,Uua) = zero_zero(C) ) ) ) ).

% ATP.lambda_163
tff(fact_6329_ATP_Olambda__164,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(B,C),Uua: B] :
          ( aa(B,$o,aTP_Lamp_pp(fun(B,C),fun(B,$o),Uu),Uua)
        <=> ( aa(B,C,Uu,Uua) = one_one(C) ) ) ) ).

% ATP.lambda_164
tff(fact_6330_ATP_Olambda__165,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: list(B),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_avt(list(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avs(list(B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(B,Uu,Uua)) ) ) ).

% ATP.lambda_165
tff(fact_6331_ATP_Olambda__166,axiom,
    ! [B: $tType,Uu: list(fun(B,nat)),Uua: B] : ( aa(B,list(nat),aTP_Lamp_auu(list(fun(B,nat)),fun(B,list(nat)),Uu),Uua) = aa(list(fun(B,nat)),list(nat),map(fun(B,nat),nat,aTP_Lamp_apc(B,fun(fun(B,nat),nat),Uua)),Uu) ) ).

% ATP.lambda_166
tff(fact_6332_ATP_Olambda__167,axiom,
    ! [B: $tType,Uu: list(B),Uua: list(B)] : ( aa(list(B),list(list(B)),aTP_Lamp_akx(list(B),fun(list(B),list(list(B))),Uu),Uua) = aa(list(B),list(list(B)),map(B,list(B),aa(list(B),fun(B,list(B)),aTP_Lamp_ail(list(B),fun(B,list(B))),Uua)),Uu) ) ).

% ATP.lambda_167
tff(fact_6333_ATP_Olambda__168,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_bbf(nat,fun(nat,nat)),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua))),Uu) ) ).

% ATP.lambda_168
tff(fact_6334_ATP_Olambda__169,axiom,
    ! [Uu: num,Uua: num] : ( aa(num,int,aTP_Lamp_zz(num,fun(num,int),Uu),Uua) = bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),Uu),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),Uu))),aa(num,int,numeral_numeral(int),Uua))) ) ).

% ATP.lambda_169
tff(fact_6335_ATP_Olambda__170,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_mu(set(B),fun(set(B),$o),Uu),Uua)
    <=> ( aa(set(B),$o,finite_finite2(B),Uua)
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),Uua),Uu) ) ) ).

% ATP.lambda_170
tff(fact_6336_ATP_Olambda__171,axiom,
    ! [Uu: assn,Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aTP_Lamp_aj(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uu),Uua)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,Uua)
        & ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Uu),Uua) ) ) ).

% ATP.lambda_171
tff(fact_6337_ATP_Olambda__172,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aTP_Lamp_bg(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uu),Uua)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,Uua)
        & ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,Uu,Uua) ) ) ).

% ATP.lambda_172
tff(fact_6338_ATP_Olambda__173,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: heap_Time_Heap(product_prod(B,C))] :
      ( aa(heap_Time_Heap(product_prod(B,C)),$o,aTP_Lamp_bbp(fun(B,fun(C,$o)),fun(heap_Time_Heap(product_prod(B,C)),$o),Uu),Uua)
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),heap_Time_set_Heap(product_prod(B,C),Uua)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Uu))) ) ).

% ATP.lambda_173
tff(fact_6339_ATP_Olambda__174,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: option(product_prod(B,C))] :
      ( aa(option(product_prod(B,C)),$o,aTP_Lamp_ave(fun(B,fun(C,$o)),fun(option(product_prod(B,C)),$o),Uu),Uua)
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),set_option(product_prod(B,C),Uua)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Uu))) ) ).

% ATP.lambda_174
tff(fact_6340_ATP_Olambda__175,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: array(product_prod(B,C))] :
      ( aa(array(product_prod(B,C)),$o,aTP_Lamp_bbm(fun(B,fun(C,$o)),fun(array(product_prod(B,C)),$o),Uu),Uua)
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),set_array(product_prod(B,C),Uua)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Uu))) ) ).

% ATP.lambda_175
tff(fact_6341_ATP_Olambda__176,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: multiset(product_prod(B,C))] :
      ( aa(multiset(product_prod(B,C)),$o,aTP_Lamp_apf(fun(B,fun(C,$o)),fun(multiset(product_prod(B,C)),$o),Uu),Uua)
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),aa(multiset(product_prod(B,C)),set(product_prod(B,C)),set_mset(product_prod(B,C)),Uua)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Uu))) ) ).

% ATP.lambda_176
tff(fact_6342_ATP_Olambda__177,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: ref(product_prod(B,C))] :
      ( aa(ref(product_prod(B,C)),$o,aTP_Lamp_bbl(fun(B,fun(C,$o)),fun(ref(product_prod(B,C)),$o),Uu),Uua)
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),set_ref(product_prod(B,C),Uua)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Uu))) ) ).

% ATP.lambda_177
tff(fact_6343_ATP_Olambda__178,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: list(product_prod(B,C))] :
      ( aa(list(product_prod(B,C)),$o,aTP_Lamp_aoa(fun(B,fun(C,$o)),fun(list(product_prod(B,C)),$o),Uu),Uua)
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),Uua)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Uu))) ) ).

% ATP.lambda_178
tff(fact_6344_ATP_Olambda__179,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: set(set(B))] : ( aa(set(set(B)),set(B),aTP_Lamp_ari(fun(B,fun(C,$o)),fun(set(set(B)),set(B)),Uu),Uua) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),Uua)),aa(fun(B,$o),set(B),collect(B),aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),Uu))) ) ).

% ATP.lambda_179
tff(fact_6345_ATP_Olambda__180,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: set(B)] : ( aa(set(B),set(B),aTP_Lamp_arl(fun(B,fun(C,$o)),fun(set(B),set(B)),Uu),Uua) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),uminus_uminus(set(B)),Uua)),aa(fun(B,$o),set(B),collect(B),aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),Uu))) ) ).

% ATP.lambda_180
tff(fact_6346_ATP_Olambda__181,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(B)
     => ! [Uu: product_prod(B,C),Uua: product_prod(B,C)] :
          ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),aTP_Lamp_alc(product_prod(B,C),fun(product_prod(B,C),$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(product_prod(B,C),B,product_fst(B,C),Uu)),aa(product_prod(B,C),B,product_fst(B,C),Uua)) ) ) ).

% ATP.lambda_181
tff(fact_6347_ATP_Olambda__182,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(B)
     => ! [Uu: product_prod(B,C),Uua: product_prod(B,C)] :
          ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),aTP_Lamp_alj(product_prod(B,C),fun(product_prod(B,C),$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(product_prod(B,C),B,product_fst(B,C),Uua)),aa(product_prod(B,C),B,product_fst(B,C),Uu)) ) ) ).

% ATP.lambda_182
tff(fact_6348_ATP_Olambda__183,axiom,
    ! [B: $tType,Uu: list(option(B)),Uua: B] : ( aa(B,option(list(B)),aTP_Lamp_avc(list(option(B)),fun(B,option(list(B))),Uu),Uua) = aa(option(list(B)),option(list(B)),map_option(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uua)),those(B,Uu)) ) ).

% ATP.lambda_183
tff(fact_6349_ATP_Olambda__184,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_wy(nat,fun(nat,B)),Uu),Uua) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,semiring_1_of_nat(B),Uu)),aa(nat,B,semiring_1_of_nat(B),Uua)) ) ) ).

% ATP.lambda_184
tff(fact_6350_ATP_Olambda__185,axiom,
    ! [Uu: num,Uua: num] : ( aa(num,int,aa(num,fun(num,int),aTP_Lamp_xx(num,fun(num,int)),Uu),Uua) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Uu)),aa(num,int,numeral_numeral(int),Uua)) ) ).

% ATP.lambda_185
tff(fact_6351_ATP_Olambda__186,axiom,
    ! [B: $tType,Uu: list(list(B)),Uua: B] : ( aa(B,list(list(B)),aTP_Lamp_akt(list(list(B)),fun(B,list(list(B))),Uu),Uua) = aa(list(list(B)),list(list(B)),map(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uua)),product_lists(B,Uu)) ) ).

% ATP.lambda_186
tff(fact_6352_ATP_Olambda__187,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,rat,aa(nat,fun(nat,rat),aTP_Lamp_azn(nat,fun(nat,rat)),Uu),Uua) = aa(int,rat,aa(int,fun(int,rat),fract,nat_int_decode(Uu)),nat_int_decode(Uua)) ) ).

% ATP.lambda_187
tff(fact_6353_ATP_Olambda__188,axiom,
    ! [B: $tType,Uu: list(B),Uua: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_ajk(list(B),fun(list(B),$o)),Uu),Uua)
    <=> ( aa(list(B),nat,size_size(list(B)),Uu) = aa(list(B),nat,size_size(list(B)),Uua) ) ) ).

% ATP.lambda_188
tff(fact_6354_ATP_Olambda__189,axiom,
    ! [B: $tType,Uu: list(B),Uua: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_aoh(list(B),fun(list(B),$o),Uu),Uua)
    <=> ( mset(B,Uua) = mset(B,Uu) ) ) ).

% ATP.lambda_189
tff(fact_6355_ATP_Olambda__190,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,num,aa(code_integer,fun(code_integer,num),aTP_Lamp_zf(code_integer,fun(code_integer,num)),Uu),Uua)
      = $let(
          l2: num,
          l2 := code_num_of_integer(Uu),
          $let(
            l3: num,
            l3 := aa(num,num,aa(num,fun(num,num),plus_plus(num),l2),l2),
            $ite(Uua = zero_zero(code_integer),l3,aa(num,num,aa(num,fun(num,num),plus_plus(num),l3),one2)) ) ) ) ).

% ATP.lambda_190
tff(fact_6356_ATP_Olambda__191,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,nat,aa(code_integer,fun(code_integer,nat),aTP_Lamp_zg(code_integer,fun(code_integer,nat)),Uu),Uua)
      = $let(
          l2: nat,
          l2 := code_nat_of_integer(Uu),
          $let(
            l3: nat,
            l3 := aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),l2),l2),
            $ite(Uua = zero_zero(code_integer),l3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),l3),one_one(nat))) ) ) ) ).

% ATP.lambda_191
tff(fact_6357_ATP_Olambda__192,axiom,
    ! [B: $tType,Uu: set(B),Uua: heap_Time_Heap(B)] :
      ( aa(heap_Time_Heap(B),$o,aTP_Lamp_bbq(set(B),fun(heap_Time_Heap(B),$o),Uu),Uua)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),heap_Time_set_Heap(B,Uua)),Uu) ) ).

% ATP.lambda_192
tff(fact_6358_ATP_Olambda__193,axiom,
    ! [B: $tType,Uu: set(B),Uua: option(B)] :
      ( aa(option(B),$o,aTP_Lamp_avd(set(B),fun(option(B),$o),Uu),Uua)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),set_option(B,Uua)),Uu) ) ).

% ATP.lambda_193
tff(fact_6359_ATP_Olambda__194,axiom,
    ! [B: $tType,Uu: set(B),Uua: array(B)] :
      ( aa(array(B),$o,aTP_Lamp_bbo(set(B),fun(array(B),$o),Uu),Uua)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),set_array(B,Uua)),Uu) ) ).

% ATP.lambda_194
tff(fact_6360_ATP_Olambda__195,axiom,
    ! [B: $tType,Uu: set(B),Uua: multiset(B)] :
      ( aa(multiset(B),$o,aTP_Lamp_arc(set(B),fun(multiset(B),$o),Uu),Uua)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(multiset(B),set(B),set_mset(B),Uua)),Uu) ) ).

% ATP.lambda_195
tff(fact_6361_ATP_Olambda__196,axiom,
    ! [B: $tType,Uu: set(B),Uua: ref(B)] :
      ( aa(ref(B),$o,aTP_Lamp_bbn(set(B),fun(ref(B),$o),Uu),Uua)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),set_ref(B,Uua)),Uu) ) ).

% ATP.lambda_196
tff(fact_6362_ATP_Olambda__197,axiom,
    ! [B: $tType,Uu: set(B),Uua: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_ant(set(B),fun(list(B),$o),Uu),Uua)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Uua)),Uu) ) ).

% ATP.lambda_197
tff(fact_6363_ATP_Olambda__198,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,B,aTP_Lamp_vo(nat,fun(nat,B),Uu),Uua) = aa(nat,B,gbinomial(B,aa(nat,B,semiring_1_of_nat(B),Uua)),Uu) ) ) ).

% ATP.lambda_198
tff(fact_6364_ATP_Olambda__199,axiom,
    ! [B: $tType,C: $tType,Uu: list(C),Uua: B] : ( aa(B,list(product_prod(B,C)),aTP_Lamp_aks(list(C),fun(B,list(product_prod(B,C))),Uu),Uua) = aa(list(C),list(product_prod(B,C)),map(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua)),Uu) ) ).

% ATP.lambda_199
tff(fact_6365_ATP_Olambda__200,axiom,
    ! [B: $tType,Uu: set(nat),Uua: product_prod(B,nat)] :
      ( aa(product_prod(B,nat),$o,aTP_Lamp_aln(set(nat),fun(product_prod(B,nat),$o),Uu),Uua)
    <=> aa(set(nat),$o,member(nat,aa(product_prod(B,nat),nat,product_snd(B,nat),Uua)),Uu) ) ).

% ATP.lambda_200
tff(fact_6366_ATP_Olambda__201,axiom,
    ! [Uu: set(nat),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_amz(set(nat),fun(nat,$o),Uu),Uua)
    <=> aa(set(nat),$o,member(nat,aa(nat,nat,suc,Uua)),Uu) ) ).

% ATP.lambda_201
tff(fact_6367_ATP_Olambda__202,axiom,
    ! [B: $tType,Uu: nat,Uua: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_anx(nat,fun(list(B),$o),Uu),Uua)
    <=> ( aa(list(B),nat,size_size(list(B)),Uua) = Uu ) ) ).

% ATP.lambda_202
tff(fact_6368_ATP_Olambda__203,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(B,B))] : ( aa(set(product_prod(B,B)),set(set(product_prod(B,B))),aTP_Lamp_afx(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(set(product_prod(B,B)))),Uu),Uua) = aa(set(set(product_prod(B,B))),set(set(product_prod(B,B))),image(set(product_prod(B,B)),set(product_prod(B,B)),converse(set(product_prod(B,B)),set(product_prod(B,B)),bNF_We4044943003108391690rdLess(B,B))),aa(set(set(product_prod(B,B))),set(set(product_prod(B,B))),insert(set(product_prod(B,B)),Uu),bot_bot(set(set(product_prod(B,B)))))) ) ).

% ATP.lambda_203
tff(fact_6369_ATP_Olambda__204,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [Uu: B,Uua: B] : ( aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),aTP_Lamp_ze(B,fun(B,product_prod(B,B))),Uu),Uua) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Uua)),one_one(B))) ) ) ).

% ATP.lambda_204
tff(fact_6370_ATP_Olambda__205,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [Uu: B,Uua: B] : ( aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),aTP_Lamp_za(B,fun(B,product_prod(B,B))),Uu),Uua) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Uua)) ) ) ).

% ATP.lambda_205
tff(fact_6371_ATP_Olambda__206,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_xy(B,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(nat,B,semiring_1_of_nat(B),Uua)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_206
tff(fact_6372_ATP_Olambda__207,axiom,
    ! [B: $tType,Uu: B,Uua: set(set(B))] : ( aa(set(set(B)),set(set(B)),aa(B,fun(set(set(B)),set(set(B))),aTP_Lamp_kj(B,fun(set(set(B)),set(set(B)))),Uu),Uua) = aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),sup_sup(set(set(B))),Uua),aa(set(set(B)),set(set(B)),image2(set(B),set(B),insert(B,Uu)),Uua)) ) ).

% ATP.lambda_207
tff(fact_6373_ATP_Olambda__208,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: list(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_anb(list(B),fun(B,$o),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),aa(nat,B,nth(B,Uu),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(B),nat,size_size(list(B)),Uu)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% ATP.lambda_208
tff(fact_6374_ATP_Olambda__209,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: list(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_anc(list(B),fun(B,$o),Uu),Uua)
        <=> ( Uua = aa(nat,B,nth(B,Uu),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(B),nat,size_size(list(B)),Uu)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ) ).

% ATP.lambda_209
tff(fact_6375_ATP_Olambda__210,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_yj(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(nat,nat,binomial(Uu),Uua)) ) ).

% ATP.lambda_210
tff(fact_6376_ATP_Olambda__211,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: multiset(B),Uua: B] : ( aa(B,B,aTP_Lamp_aqr(multiset(B),fun(B,B),Uu),Uua) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Uua),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),Uu),Uua)) ) ) ).

% ATP.lambda_211
tff(fact_6377_ATP_Olambda__212,axiom,
    ! [B: $tType,Uu: B,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),aTP_Lamp_avo(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),zero_zero(nat))) ) ).

% ATP.lambda_212
tff(fact_6378_ATP_Olambda__213,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: ref(B),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),aa(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_awj(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),aa(ref(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),product_Pair(ref(B),product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat))) ) ) ).

% ATP.lambda_213
tff(fact_6379_ATP_Olambda__214,axiom,
    ! [B: $tType,Uu: B,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),aTP_Lamp_avp(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat))) ) ).

% ATP.lambda_214
tff(fact_6380_ATP_Olambda__215,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,B)),Uua: C] : ( aa(C,set(B),aTP_Lamp_jp(set(product_prod(C,B)),fun(C,set(B)),Uu),Uua) = aa(set(C),set(B),image(C,B,Uu),aa(set(C),set(C),insert(C,Uua),bot_bot(set(C)))) ) ).

% ATP.lambda_215
tff(fact_6381_ATP_Olambda__216,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,C),Uua: C] : ( aa(C,set(B),aTP_Lamp_ha(fun(B,C),fun(C,set(B)),Uu),Uua) = aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Uu),aa(set(C),set(C),insert(C,Uua),bot_bot(set(C)))) ) ).

% ATP.lambda_216
tff(fact_6382_ATP_Olambda__217,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_ew(set(B),fun(B,$o),Uu),Uua)
    <=> ( Uu = aa(set(B),set(B),insert(B,Uua),bot_bot(set(B))) ) ) ).

% ATP.lambda_217
tff(fact_6383_ATP_Olambda__218,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(B,B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_nr(fun(B,B),fun(B,$o),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),aa(B,B,Uu,Uua)) ) ) ).

% ATP.lambda_218
tff(fact_6384_ATP_Olambda__219,axiom,
    ! [B: $tType,Uu: fun(nat,B),Uua: nat] : ( aa(nat,product_prod(nat,B),aTP_Lamp_anz(fun(nat,B),fun(nat,product_prod(nat,B)),Uu),Uua) = aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),Uua),aa(nat,B,Uu,Uua)) ) ).

% ATP.lambda_219
tff(fact_6385_ATP_Olambda__220,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: B] : ( aa(B,product_prod(B,C),aTP_Lamp_dm(fun(B,C),fun(B,product_prod(B,C)),Uu),Uua) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),aa(B,C,Uu,Uua)) ) ).

% ATP.lambda_220
tff(fact_6386_ATP_Olambda__221,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_zp(B,fun(nat,B),Uu),Uua) = bit_se4730199178511100633sh_bit(B,Uua,aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,bit_se5641148757651400278ts_bit(B,Uu),Uua))) ) ) ).

% ATP.lambda_221
tff(fact_6387_ATP_Olambda__222,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,option(C)),Uua: B] : ( aa(B,product_prod(B,C),aTP_Lamp_acu(fun(B,option(C)),fun(B,product_prod(B,C)),Uu),Uua) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),aa(option(C),C,the2(C),aa(B,option(C),Uu,Uua))) ) ).

% ATP.lambda_222
tff(fact_6388_ATP_Olambda__223,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aa(int,fun(int,int),aTP_Lamp_zk(int,fun(int,int)),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uu),aa($o,int,zero_neq_one_of_bool(int),( Uua != zero_zero(int) ))) ) ).

% ATP.lambda_223
tff(fact_6389_ATP_Olambda__224,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_vi(set(product_prod(B,B)),fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),aa(set(product_prod(B,B)),nat,finite_card(product_prod(B,B)),Uu)) ) ).

% ATP.lambda_224
tff(fact_6390_ATP_Olambda__225,axiom,
    ! [B: $tType,Uu: nat,Uua: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_ajr(nat,fun(list(B),$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uu),aa(list(B),nat,size_size(list(B)),Uua)) ) ).

% ATP.lambda_225
tff(fact_6391_ATP_Olambda__226,axiom,
    ! [B: $tType] :
      ( ( semiring_char_0(B)
        & semidom_divide(B) )
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_vv(B,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),minus_minus(B),Uu),aa(nat,B,semiring_1_of_nat(B),Uua)) ) ) ).

% ATP.lambda_226
tff(fact_6392_ATP_Olambda__227,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_vx(B,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),minus_minus(B),Uu),aa(nat,B,semiring_1_of_nat(B),Uua)) ) ) ).

% ATP.lambda_227
tff(fact_6393_ATP_Olambda__228,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_vk(B,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(nat,B,semiring_1_of_nat(B),Uua)) ) ) ).

% ATP.lambda_228
tff(fact_6394_ATP_Olambda__229,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,list(nat),aa(nat,fun(nat,list(nat)),aTP_Lamp_ayd(nat,fun(nat,list(nat))),Uu),Uua) = aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),Uu),nat_list_decode(Uua)) ) ).

% ATP.lambda_229
tff(fact_6395_ATP_Olambda__230,axiom,
    ! [C: $tType,B: $tType,Uu: list(product_prod(B,C)),Uua: fun(B,option(C))] : ( aa(fun(B,option(C)),fun(B,option(C)),aa(list(product_prod(B,C)),fun(fun(B,option(C)),fun(B,option(C))),aTP_Lamp_amb(list(product_prod(B,C)),fun(fun(B,option(C)),fun(B,option(C)))),Uu),Uua) = map_add(B,C,Uua,map_of(B,C,Uu)) ) ).

% ATP.lambda_230
tff(fact_6396_ATP_Olambda__231,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] :
      ( aa(list(B),$o,aa(B,fun(list(B),$o),aTP_Lamp_aoj(B,fun(list(B),$o)),Uu),Uua)
    <=> aa(set(B),$o,member(B,Uu),aa(list(B),set(B),set2(B),Uua)) ) ).

% ATP.lambda_231
tff(fact_6397_ATP_Olambda__232,axiom,
    ! [B: $tType,Uu: list(set(B)),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_aif(list(set(B)),fun(set(B),$o),Uu),Uua)
    <=> aa(set(set(B)),$o,member(set(B),Uua),aa(list(set(B)),set(set(B)),set2(set(B)),Uu)) ) ).

% ATP.lambda_232
tff(fact_6398_ATP_Olambda__233,axiom,
    ! [B: $tType,Uu: list(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_aiq(list(B),fun(B,$o),Uu),Uua)
    <=> aa(set(B),$o,member(B,Uua),aa(list(B),set(B),set2(B),Uu)) ) ).

% ATP.lambda_233
tff(fact_6399_ATP_Olambda__234,axiom,
    ! [B: $tType,Uu: nat,Uua: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_anw(nat,fun(list(B),$o),Uu),Uua)
    <=> ( Uu = aa(list(B),nat,size_size(list(B)),Uua) ) ) ).

% ATP.lambda_234
tff(fact_6400_ATP_Olambda__235,axiom,
    ! [B: $tType,Uu: list(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_aro(list(B),fun(B,$o),Uu),Uua)
    <=> ( Uua = aa(list(B),B,hd(B),Uu) ) ) ).

% ATP.lambda_235
tff(fact_6401_ATP_Olambda__236,axiom,
    ! [B: $tType,Uu: list(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_ars(list(B),fun(B,$o),Uu),Uua)
    <=> ( Uua = last(B,Uu) ) ) ).

% ATP.lambda_236
tff(fact_6402_ATP_Olambda__237,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ww(nat,fun(nat,$o)),Uu),Uua)
    <=> ( Uua = aa(nat,nat,suc,Uu) ) ) ).

% ATP.lambda_237
tff(fact_6403_ATP_Olambda__238,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_ka(set(B),fun(set(B),$o),Uu),Uua)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),Uua),Uu) ) ).

% ATP.lambda_238
tff(fact_6404_ATP_Olambda__239,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ra(nat,fun(nat,$o)),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),Uu) ) ).

% ATP.lambda_239
tff(fact_6405_ATP_Olambda__240,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_wu(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_240
tff(fact_6406_ATP_Olambda__241,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_acg(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_241
tff(fact_6407_ATP_Olambda__242,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_acd(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_242
tff(fact_6408_ATP_Olambda__243,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_avb(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_243
tff(fact_6409_ATP_Olambda__244,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_px(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_244
tff(fact_6410_ATP_Olambda__245,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_awv(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_245
tff(fact_6411_ATP_Olambda__246,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aTP_Lamp_rh(B,fun(B,$o),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_246
tff(fact_6412_ATP_Olambda__247,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_zd(nat,fun(nat,nat),Uu),Uua) = modulo_modulo(nat,Uua,Uu) ) ).

% ATP.lambda_247
tff(fact_6413_ATP_Olambda__248,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_ti(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),divide_divide(B),Uua),Uu) ) ) ).

% ATP.lambda_248
tff(fact_6414_ATP_Olambda__249,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_qi(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),divide_divide(B),Uua),Uu) ) ) ).

% ATP.lambda_249
tff(fact_6415_ATP_Olambda__250,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uua),Uu) ) ).

% ATP.lambda_250
tff(fact_6416_ATP_Olambda__251,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_wv(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_251
tff(fact_6417_ATP_Olambda__252,axiom,
    ! [B: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aTP_Lamp_tq(B,fun(B,$o),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_252
tff(fact_6418_ATP_Olambda__253,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_ach(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_253
tff(fact_6419_ATP_Olambda__254,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_ace(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_254
tff(fact_6420_ATP_Olambda__255,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_aaa(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_255
tff(fact_6421_ATP_Olambda__256,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_acf(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_256
tff(fact_6422_ATP_Olambda__257,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_aww(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_257
tff(fact_6423_ATP_Olambda__258,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aTP_Lamp_uv(B,fun(B,$o),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_258
tff(fact_6424_ATP_Olambda__259,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_tw(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),Uu) ) ) ).

% ATP.lambda_259
tff(fact_6425_ATP_Olambda__260,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ri(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uu) ) ).

% ATP.lambda_260
tff(fact_6426_ATP_Olambda__261,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_rt(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),minus_minus(B),Uua),Uu) ) ) ).

% ATP.lambda_261
tff(fact_6427_ATP_Olambda__262,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_cl(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),minus_minus(B),Uua),Uu) ) ) ).

% ATP.lambda_262
tff(fact_6428_ATP_Olambda__263,axiom,
    ! [B: $tType,Uu: B,Uua: multiset(B)] : ( aa(multiset(B),nat,aTP_Lamp_apd(B,fun(multiset(B),nat),Uu),Uua) = aa(B,nat,aa(multiset(B),fun(B,nat),count(B),Uua),Uu) ) ).

% ATP.lambda_263
tff(fact_6429_ATP_Olambda__264,axiom,
    ! [B: $tType,Uu: multiset(B),Uua: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_auh(multiset(B),fun(multiset(B),$o)),Uu),Uua)
    <=> aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Uua),Uu) ) ).

% ATP.lambda_264
tff(fact_6430_ATP_Olambda__265,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_ih(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Uua),Uu) ) ) ).

% ATP.lambda_265
tff(fact_6431_ATP_Olambda__266,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B)] : ( aa(set(B),set(B),aTP_Lamp_gs(set(B),fun(set(B),set(B)),Uu),Uua) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),Uua),Uu) ) ).

% ATP.lambda_266
tff(fact_6432_ATP_Olambda__267,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_ge(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Uua),Uu) ) ) ).

% ATP.lambda_267
tff(fact_6433_ATP_Olambda__268,axiom,
    ! [Uu: code_integer,Uua: code_integer] : ( aa(code_integer,code_integer,aTP_Lamp_yt(code_integer,fun(code_integer,code_integer),Uu),Uua) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),Uua),Uu) ) ).

% ATP.lambda_268
tff(fact_6434_ATP_Olambda__269,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_alp(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uu) ) ).

% ATP.lambda_269
tff(fact_6435_ATP_Olambda__270,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aTP_Lamp_wx(int,fun(int,int),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),Uu) ) ).

% ATP.lambda_270
tff(fact_6436_ATP_Olambda__271,axiom,
    ! [B: $tType] :
      ( cancel_semigroup_add(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_do(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uua),Uu) ) ) ).

% ATP.lambda_271
tff(fact_6437_ATP_Olambda__272,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_rs(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uua),Uu) ) ) ).

% ATP.lambda_272
tff(fact_6438_ATP_Olambda__273,axiom,
    ! [B: $tType,Uu: multiset(B),Uua: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_auf(multiset(B),fun(multiset(B),$o)),Uu),Uua)
    <=> aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),Uua),Uu) ) ).

% ATP.lambda_273
tff(fact_6439_ATP_Olambda__274,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: B,Uua: ref(B)] : ( aa(ref(B),assn,aa(B,fun(ref(B),assn),aTP_Lamp_al(B,fun(ref(B),assn)),Uu),Uua) = sngr_assn(B,Uua,Uu) ) ) ).

% ATP.lambda_274
tff(fact_6440_ATP_Olambda__275,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: list(B),Uua: array(B)] : ( aa(array(B),assn,aa(list(B),fun(array(B),assn),aTP_Lamp_am(list(B),fun(array(B),assn)),Uu),Uua) = snga_assn(B,Uua,Uu) ) ) ).

% ATP.lambda_275
tff(fact_6441_ATP_Olambda__276,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_yz(nat,fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uua),Uu) ) ).

% ATP.lambda_276
tff(fact_6442_ATP_Olambda__277,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,$o,aTP_Lamp_zc(int,fun(int,$o),Uu),Uua)
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uua),Uu) ) ).

% ATP.lambda_277
tff(fact_6443_ATP_Olambda__278,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aTP_Lamp_yu(B,fun(B,$o),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Uua),Uu) ) ) ).

% ATP.lambda_278
tff(fact_6444_ATP_Olambda__279,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: set(B)] : ( aa(set(B),set(product_prod(B,C)),aTP_Lamp_fm(fun(B,set(C)),fun(set(B),set(product_prod(B,C))),Uu),Uua) = product_Sigma(B,C,Uua,Uu) ) ).

% ATP.lambda_279
tff(fact_6445_ATP_Olambda__280,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_wl(nat,fun(nat,product_prod(nat,nat))),Uu),Uua) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Uua),Uu) ) ).

% ATP.lambda_280
tff(fact_6446_ATP_Olambda__281,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: B] : ( aa(B,product_prod(B,C),aa(C,fun(B,product_prod(B,C)),aTP_Lamp_ej(C,fun(B,product_prod(B,C))),Uu),Uua) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uu) ) ).

% ATP.lambda_281
tff(fact_6447_ATP_Olambda__282,axiom,
    ! [B: $tType,Uu: B,Uua: nat] : ( aa(nat,product_prod(nat,B),aTP_Lamp_any(B,fun(nat,product_prod(nat,B)),Uu),Uua) = aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),Uua),Uu) ) ).

% ATP.lambda_282
tff(fact_6448_ATP_Olambda__283,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C] : ( aa(C,product_prod(C,B),aa(B,fun(C,product_prod(C,B)),aTP_Lamp_ei(B,fun(C,product_prod(C,B))),Uu),Uua) = aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uua),Uu) ) ).

% ATP.lambda_283
tff(fact_6449_ATP_Olambda__284,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ud(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(Uua),Uu) ) ).

% ATP.lambda_284
tff(fact_6450_ATP_Olambda__285,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),nat,aTP_Lamp_awy(array(B),fun(heap_ext(product_unit),nat),Uu),Uua) = array_length(B,Uua,Uu) ) ) ).

% ATP.lambda_285
tff(fact_6451_ATP_Olambda__286,axiom,
    ! [B: $tType,Uu: list(B),Uua: B] : ( aa(B,list(B),aa(list(B),fun(B,list(B)),aTP_Lamp_ail(list(B),fun(B,list(B))),Uu),Uua) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uua),Uu) ) ).

% ATP.lambda_286
tff(fact_6452_ATP_Olambda__287,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: ref(B),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),B,aTP_Lamp_awu(ref(B),fun(heap_ext(product_unit),B),Uu),Uua) = ref_get(B,Uua,Uu) ) ) ).

% ATP.lambda_287
tff(fact_6453_ATP_Olambda__288,axiom,
    ! [Uu: set(nat),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_xp(set(nat),fun(nat,$o),Uu),Uua)
    <=> aa(set(nat),$o,member(nat,Uua),Uu) ) ).

% ATP.lambda_288
tff(fact_6454_ATP_Olambda__289,axiom,
    ! [C: $tType,Uu: set(C),Uua: C] :
      ( aa(C,$o,aTP_Lamp_nw(set(C),fun(C,$o),Uu),Uua)
    <=> aa(set(C),$o,member(C,Uua),Uu) ) ).

% ATP.lambda_289
tff(fact_6455_ATP_Olambda__290,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Uu: set(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_xn(set(B),fun(B,$o),Uu),Uua)
        <=> aa(set(B),$o,member(B,Uua),Uu) ) ) ).

% ATP.lambda_290
tff(fact_6456_ATP_Olambda__291,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Uu: set(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_xr(set(B),fun(B,$o),Uu),Uua)
        <=> aa(set(B),$o,member(B,Uua),Uu) ) ) ).

% ATP.lambda_291
tff(fact_6457_ATP_Olambda__292,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_ad(set(B),fun(B,$o)),Uu),Uua)
    <=> aa(set(B),$o,member(B,Uua),Uu) ) ).

% ATP.lambda_292
tff(fact_6458_ATP_Olambda__293,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: nat] : ( aa(nat,set(product_prod(B,B)),aTP_Lamp_ut(set(product_prod(B,B)),fun(nat,set(product_prod(B,B))),Uu),Uua) = compow(set(product_prod(B,B)),Uua,Uu) ) ).

% ATP.lambda_293
tff(fact_6459_ATP_Olambda__294,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: nat] : ( aa(nat,fun(B,fun(B,$o)),aTP_Lamp_awe(fun(B,fun(B,$o)),fun(nat,fun(B,fun(B,$o))),Uu),Uua) = compow(fun(B,fun(B,$o)),Uua,Uu) ) ).

% ATP.lambda_294
tff(fact_6460_ATP_Olambda__295,axiom,
    ! [B: $tType,Uu: list(B),Uua: nat] : ( aa(nat,list(B),aTP_Lamp_aoi(list(B),fun(nat,list(B)),Uu),Uua) = drop(B,Uua,Uu) ) ).

% ATP.lambda_295
tff(fact_6461_ATP_Olambda__296,axiom,
    ! [B: $tType,Uu: nat,Uua: list(B)] : ( aa(list(B),B,aTP_Lamp_ajq(nat,fun(list(B),B),Uu),Uua) = aa(nat,B,nth(B,Uua),Uu) ) ).

% ATP.lambda_296
tff(fact_6462_ATP_Olambda__297,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(B,D),Uua: fun(D,set(C))] : ( aa(fun(D,set(C)),fun(B,set(C)),aTP_Lamp_ji(fun(B,D),fun(fun(D,set(C)),fun(B,set(C))),Uu),Uua) = aa(fun(B,D),fun(B,set(C)),comp(D,set(C),B,Uua),Uu) ) ).

% ATP.lambda_297
tff(fact_6463_ATP_Olambda__298,axiom,
    ! [B: $tType,Uu: B,Uua: B] :
      ( aa(B,$o,aTP_Lamp_ct(B,fun(B,$o),Uu),Uua)
    <=> ( Uua = Uu ) ) ).

% ATP.lambda_298
tff(fact_6464_ATP_Olambda__299,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_avw(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),one_one(nat)) ) ).

% ATP.lambda_299
tff(fact_6465_ATP_Olambda__300,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] : ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),aTP_Lamp_alz(B,fun(list(B),list(B))),Uu),Uua) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uu),nil(B)) ) ).

% ATP.lambda_300
tff(fact_6466_ATP_Olambda__301,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] : ( aa(list(B),list(list(B)),aa(B,fun(list(B),list(list(B))),aTP_Lamp_amc(B,fun(list(B),list(list(B)))),Uu),Uua) = aa(list(list(B)),list(list(B)),aa(list(B),fun(list(list(B)),list(list(B))),cons(list(B)),Uua),nil(list(B))) ) ).

% ATP.lambda_301
tff(fact_6467_ATP_Olambda__302,axiom,
    ! [B: $tType,Uu: B,Uua: B] : ( aa(B,set(B),aTP_Lamp_fa(B,fun(B,set(B)),Uu),Uua) = aa(set(B),set(B),insert(B,Uu),bot_bot(set(B))) ) ).

% ATP.lambda_302
tff(fact_6468_ATP_Olambda__303,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: B,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_awk(B,fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(ref(B),heap_ext(product_unit)),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),aa(fun(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(ref(B),heap_ext(product_unit)),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(ref(B),heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_awj(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))))),ref_alloc(B,Uu,Uua)) ) ) ).

% ATP.lambda_303
tff(fact_6469_ATP_Olambda__304,axiom,
    ! [B: $tType,Uu: multiset(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_aoy(multiset(B),fun(B,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),Uu),Uua)) ) ).

% ATP.lambda_304
tff(fact_6470_ATP_Olambda__305,axiom,
    ! [C: $tType,Uu: fun(C,nat),Uua: C] :
      ( aa(C,$o,aTP_Lamp_aqj(fun(C,nat),fun(C,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(C,nat,Uu,Uua)) ) ).

% ATP.lambda_305
tff(fact_6471_ATP_Olambda__306,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B] :
      ( aa(B,$o,aTP_Lamp_tk(fun(B,nat),fun(B,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(B,nat,Uu,Uua)) ) ).

% ATP.lambda_306
tff(fact_6472_ATP_Olambda__307,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_atr(set(multiset(B)),fun(B,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(B)),set(nat),image2(multiset(B),nat,aTP_Lamp_apd(B,fun(multiset(B),nat),Uua)),Uu))) ) ).

% ATP.lambda_307
tff(fact_6473_ATP_Olambda__308,axiom,
    ! [B: $tType,Uu: code_natural,Uua: B] :
      ( aa(B,$o,aa(code_natural,fun(B,$o),aTP_Lamp_aya(code_natural,fun(B,$o)),Uu),Uua)
    <=> aa(code_natural,$o,aa(code_natural,fun(code_natural,$o),ord_less(code_natural),zero_zero(code_natural)),Uu) ) ).

% ATP.lambda_308
tff(fact_6474_ATP_Olambda__309,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_ahf(nat,fun(nat,set(nat)),Uu),Uua) = order_underS(nat,bNF_Ca8665028551170535155natLeq,Uu) ) ).

% ATP.lambda_309
tff(fact_6475_ATP_Olambda__310,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: B] : ( aa(B,set(C),aTP_Lamp_dy(set(product_prod(B,C)),fun(B,set(C)),Uu),Uua) = aa(set(product_prod(B,C)),set(C),image2(product_prod(B,C),C,product_snd(B,C)),Uu) ) ).

% ATP.lambda_310
tff(fact_6476_ATP_Olambda__311,axiom,
    ! [B: $tType,Uu: fun(nat,$o),Uua: product_prod(B,nat)] :
      ( aa(product_prod(B,nat),$o,aTP_Lamp_akq(fun(nat,$o),fun(product_prod(B,nat),$o),Uu),Uua)
    <=> aa(nat,$o,Uu,aa(nat,nat,suc,aa(product_prod(B,nat),nat,product_snd(B,nat),Uua))) ) ).

% ATP.lambda_311
tff(fact_6477_ATP_Olambda__312,axiom,
    ! [B: $tType,Uu: fun(nat,$o),Uua: product_prod(B,nat)] :
      ( aa(product_prod(B,nat),$o,aTP_Lamp_akr(fun(nat,$o),fun(product_prod(B,nat),$o),Uu),Uua)
    <=> aa(nat,$o,Uu,aa(product_prod(B,nat),nat,product_snd(B,nat),Uua)) ) ).

% ATP.lambda_312
tff(fact_6478_ATP_Olambda__313,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(C,D),Uua: product_prod(B,C)] : ( aa(product_prod(B,C),D,aTP_Lamp_du(fun(C,D),fun(product_prod(B,C),D),Uu),Uua) = aa(C,D,Uu,aa(product_prod(B,C),C,product_snd(B,C),Uua)) ) ).

% ATP.lambda_313
tff(fact_6479_ATP_Olambda__314,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(B,D),Uua: product_prod(B,C)] : ( aa(product_prod(B,C),D,aTP_Lamp_dc(fun(B,D),fun(product_prod(B,C),D),Uu),Uua) = aa(B,D,Uu,aa(product_prod(B,C),B,product_fst(B,C),Uua)) ) ).

% ATP.lambda_314
tff(fact_6480_ATP_Olambda__315,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(sum_sum(C,D),set(B)),Uua: D] : ( aa(D,set(B),aTP_Lamp_ayl(fun(sum_sum(C,D),set(B)),fun(D,set(B)),Uu),Uua) = aa(sum_sum(C,D),set(B),Uu,aa(D,sum_sum(C,D),sum_Inr(D,C),Uua)) ) ).

% ATP.lambda_315
tff(fact_6481_ATP_Olambda__316,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(sum_sum(B,C),D),Uua: C] : ( aa(C,D,aTP_Lamp_ayn(fun(sum_sum(B,C),D),fun(C,D),Uu),Uua) = aa(sum_sum(B,C),D,Uu,aa(C,sum_sum(B,C),sum_Inr(C,B),Uua)) ) ).

% ATP.lambda_316
tff(fact_6482_ATP_Olambda__317,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(sum_sum(C,D),set(B)),Uua: C] : ( aa(C,set(B),aTP_Lamp_ayk(fun(sum_sum(C,D),set(B)),fun(C,set(B)),Uu),Uua) = aa(sum_sum(C,D),set(B),Uu,aa(C,sum_sum(C,D),sum_Inl(C,D),Uua)) ) ).

% ATP.lambda_317
tff(fact_6483_ATP_Olambda__318,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(sum_sum(B,C),D),Uua: B] : ( aa(B,D,aTP_Lamp_aym(fun(sum_sum(B,C),D),fun(B,D),Uu),Uua) = aa(sum_sum(B,C),D,Uu,aa(B,sum_sum(B,C),sum_Inl(B,C),Uua)) ) ).

% ATP.lambda_318
tff(fact_6484_ATP_Olambda__319,axiom,
    ! [Uu: fun(nat,$o),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_xd(fun(nat,$o),fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,Uu,aa(nat,nat,suc,Uua)) ) ).

% ATP.lambda_319
tff(fact_6485_ATP_Olambda__320,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_ss(fun(nat,B),fun(nat,B),Uu),Uua) = aa(nat,B,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_320
tff(fact_6486_ATP_Olambda__321,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_sr(fun(nat,B),fun(nat,B),Uu),Uua) = aa(nat,B,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_321
tff(fact_6487_ATP_Olambda__322,axiom,
    ! [B: $tType,Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_xh(fun(nat,B),fun(nat,B),Uu),Uua) = aa(nat,B,Uu,aa(nat,nat,suc,Uua)) ) ).

% ATP.lambda_322
tff(fact_6488_ATP_Olambda__323,axiom,
    ! [B: $tType,D: $tType,Uu: D,Uua: fun(D,set(set(B)))] : ( aa(fun(D,set(set(B))),set(set(B)),aTP_Lamp_agc(D,fun(fun(D,set(set(B))),set(set(B))),Uu),Uua) = aa(D,set(set(B)),Uua,Uu) ) ).

% ATP.lambda_323
tff(fact_6489_ATP_Olambda__324,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: fun(C,set(B))] : ( aa(fun(C,set(B)),set(B),aTP_Lamp_jh(C,fun(fun(C,set(B)),set(B)),Uu),Uua) = aa(C,set(B),Uua,Uu) ) ).

% ATP.lambda_324
tff(fact_6490_ATP_Olambda__325,axiom,
    ! [B: $tType,C: $tType] :
      ( complete_Sup(B)
     => ! [Uu: C,Uua: fun(C,B)] : ( aa(fun(C,B),B,aTP_Lamp_fd(C,fun(fun(C,B),B),Uu),Uua) = aa(C,B,Uua,Uu) ) ) ).

% ATP.lambda_325
tff(fact_6491_ATP_Olambda__326,axiom,
    ! [B: $tType,C: $tType] :
      ( complete_Inf(B)
     => ! [Uu: C,Uua: fun(C,B)] : ( aa(fun(C,B),B,aTP_Lamp_hw(C,fun(fun(C,B),B),Uu),Uua) = aa(C,B,Uua,Uu) ) ) ).

% ATP.lambda_326
tff(fact_6492_ATP_Olambda__327,axiom,
    ! [B: $tType,Uu: B,Uua: fun(B,nat)] : ( aa(fun(B,nat),nat,aTP_Lamp_apc(B,fun(fun(B,nat),nat),Uu),Uua) = aa(B,nat,Uua,Uu) ) ).

% ATP.lambda_327
tff(fact_6493_ATP_Olambda__328,axiom,
    ! [C: $tType,B: $tType] :
      ( complete_Sup(C)
     => ! [Uu: B,Uua: fun(B,C)] : ( aa(fun(B,C),C,aTP_Lamp_fl(B,fun(fun(B,C),C),Uu),Uua) = aa(B,C,Uua,Uu) ) ) ).

% ATP.lambda_328
tff(fact_6494_ATP_Olambda__329,axiom,
    ! [C: $tType,B: $tType] :
      ( complete_Inf(C)
     => ! [Uu: B,Uua: fun(B,C)] : ( aa(fun(B,C),C,aTP_Lamp_ia(B,fun(fun(B,C),C),Uu),Uua) = aa(B,C,Uua,Uu) ) ) ).

% ATP.lambda_329
tff(fact_6495_ATP_Olambda__330,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: fun(B,C)] : ( aa(fun(B,C),C,aTP_Lamp_azw(B,fun(fun(B,C),C),Uu),Uua) = aa(B,C,Uua,Uu) ) ).

% ATP.lambda_330
tff(fact_6496_ATP_Olambda__331,axiom,
    ! [C: $tType,B: $tType,Uu: fun(set(B),B),Uua: C] : ( aa(C,B,aTP_Lamp_bai(fun(set(B),B),fun(C,B),Uu),Uua) = aa(set(B),B,Uu,bot_bot(set(B))) ) ).

% ATP.lambda_331
tff(fact_6497_ATP_Olambda__332,axiom,
    ! [B: $tType,Uu: fun(product_unit,B),Uua: product_unit] : ( aa(product_unit,B,aTP_Lamp_axp(fun(product_unit,B),fun(product_unit,B),Uu),Uua) = aa(product_unit,B,Uu,product_Unity) ) ).

% ATP.lambda_332
tff(fact_6498_ATP_Olambda__333,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B,Uua: option(B)] : ( aa(option(B),option(B),aa(B,fun(option(B),option(B)),aTP_Lamp_abw(B,fun(option(B),option(B))),Uu),Uua) = aa(B,option(B),some(B),case_option(B,B,Uu,aa(B,fun(B,B),ord_min(B),Uu),Uua)) ) ) ).

% ATP.lambda_333
tff(fact_6499_ATP_Olambda__334,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B,Uua: option(B)] : ( aa(option(B),option(B),aa(B,fun(option(B),option(B)),aTP_Lamp_abz(B,fun(option(B),option(B))),Uu),Uua) = aa(B,option(B),some(B),case_option(B,B,Uu,aa(B,fun(B,B),ord_max(B),Uu),Uua)) ) ) ).

% ATP.lambda_334
tff(fact_6500_ATP_Olambda__335,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Uu: B,Uua: option(B)] : ( aa(option(B),option(B),aa(B,fun(option(B),option(B)),aTP_Lamp_aby(B,fun(option(B),option(B))),Uu),Uua) = aa(B,option(B),some(B),case_option(B,B,Uu,aa(B,fun(B,B),sup_sup(B),Uu),Uua)) ) ) ).

% ATP.lambda_335
tff(fact_6501_ATP_Olambda__336,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Uu: B,Uua: option(B)] : ( aa(option(B),option(B),aa(B,fun(option(B),option(B)),aTP_Lamp_abx(B,fun(option(B),option(B))),Uu),Uua) = aa(B,option(B),some(B),case_option(B,B,Uu,aa(B,fun(B,B),inf_inf(B),Uu),Uua)) ) ) ).

% ATP.lambda_336
tff(fact_6502_ATP_Olambda__337,axiom,
    ! [B: $tType,Uu: multiset(B),Uua: option(multiset(B))] : ( aa(option(multiset(B)),option(multiset(B)),aa(multiset(B),fun(option(multiset(B)),option(multiset(B))),aTP_Lamp_aua(multiset(B),fun(option(multiset(B)),option(multiset(B)))),Uu),Uua) = aa(multiset(B),option(multiset(B)),some(multiset(B)),case_option(multiset(B),multiset(B),Uu,aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),Uu),Uua)) ) ).

% ATP.lambda_337
tff(fact_6503_ATP_Olambda__338,axiom,
    ! [B: $tType,Uu: multiset(B),Uua: option(multiset(B))] : ( aa(option(multiset(B)),option(multiset(B)),aa(multiset(B),fun(option(multiset(B)),option(multiset(B))),aTP_Lamp_aue(multiset(B),fun(option(multiset(B)),option(multiset(B)))),Uu),Uua) = aa(multiset(B),option(multiset(B)),some(multiset(B)),case_option(multiset(B),multiset(B),Uu,aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),Uu),Uua)) ) ).

% ATP.lambda_338
tff(fact_6504_ATP_Olambda__339,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_abg(nat,fun(num,option(num)),Uu),Uua) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(Uu,Uua))) ) ).

% ATP.lambda_339
tff(fact_6505_ATP_Olambda__340,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,heap_Time_Heap(B)),Uua: C] : ( aa(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_axj(fun(C,heap_Time_Heap(B)),fun(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua) = aa(fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),product_case_prod(heap_ext(product_unit),nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(C,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_axi(fun(C,heap_Time_Heap(B)),fun(C,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua)) ) ).

% ATP.lambda_340
tff(fact_6506_ATP_Olambda__341,axiom,
    ! [B: $tType,Uu: list(B),Uua: list(B)] : ( aa(list(B),fun(product_prod(B,list(B)),option($o)),aTP_Lamp_ang(list(B),fun(list(B),fun(product_prod(B,list(B)),option($o))),Uu),Uua) = aa(fun(B,fun(list(B),option($o))),fun(product_prod(B,list(B)),option($o)),product_case_prod(B,list(B),option($o)),aa(list(B),fun(B,fun(list(B),option($o))),aTP_Lamp_anf(list(B),fun(list(B),fun(B,fun(list(B),option($o)))),Uu),Uua)) ) ).

% ATP.lambda_341
tff(fact_6507_ATP_Olambda__342,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: list(B)] : ( aa(list(B),fun(product_prod(list(B),list(B)),list(B)),aTP_Lamp_amp(fun(B,C),fun(list(B),fun(product_prod(list(B),list(B)),list(B))),Uu),Uua) = aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aa(list(B),fun(list(B),fun(list(B),list(B))),aTP_Lamp_amo(fun(B,C),fun(list(B),fun(list(B),fun(list(B),list(B)))),Uu),Uua)) ) ) ).

% ATP.lambda_342
tff(fact_6508_ATP_Olambda__343,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] : ( aa(list(B),fun(product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B))))),aTP_Lamp_alu(B,fun(list(B),fun(product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B)))))),Uu),Uua) = aa(fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B)))))),fun(product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B))))),product_case_prod(B,list(B),option(product_prod(list(B),product_prod(B,list(B))))),aa(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B)))))),aTP_Lamp_alt(B,fun(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))))),Uu),Uua)) ) ).

% ATP.lambda_343
tff(fact_6509_ATP_Olambda__344,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(D,fun(B,D)),Uua: D] : ( aa(D,fun(product_prod(C,B),D),aTP_Lamp_ajm(fun(D,fun(B,D)),fun(D,fun(product_prod(C,B),D)),Uu),Uua) = aa(fun(C,fun(B,D)),fun(product_prod(C,B),D),product_case_prod(C,B,D),aa(D,fun(C,fun(B,D)),aTP_Lamp_ajl(fun(D,fun(B,D)),fun(D,fun(C,fun(B,D))),Uu),Uua)) ) ).

% ATP.lambda_344
tff(fact_6510_ATP_Olambda__345,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),$o),aa(nat,fun(nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_xa(nat,fun(nat,fun(product_prod(nat,nat),$o))),Uu),Uua) = aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_wz(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua)) ) ).

% ATP.lambda_345
tff(fact_6511_ATP_Olambda__346,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wt(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_ws(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_346
tff(fact_6512_ATP_Olambda__347,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wr(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_wq(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_347
tff(fact_6513_ATP_Olambda__348,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),$o),aa(nat,fun(nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wp(nat,fun(nat,fun(product_prod(nat,nat),$o))),Uu),Uua) = aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_wo(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua)) ) ).

% ATP.lambda_348
tff(fact_6514_ATP_Olambda__349,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),$o),aa(nat,fun(nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_wn(nat,fun(nat,fun(product_prod(nat,nat),$o))),Uu),Uua) = aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_wm(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua)) ) ).

% ATP.lambda_349
tff(fact_6515_ATP_Olambda__350,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_wb(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_wa(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_350
tff(fact_6516_ATP_Olambda__351,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(B,$o)] : ( aa(fun(B,$o),set(B),aTP_Lamp_arg(fun(B,fun(C,$o)),fun(fun(B,$o),set(B)),Uu),Uua) = aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_arf(fun(B,fun(C,$o)),fun(fun(B,$o),fun(B,$o)),Uu),Uua)) ) ).

% ATP.lambda_351
tff(fact_6517_ATP_Olambda__352,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,$o)),Uua: C] : ( aa(C,set(B),aTP_Lamp_gx(fun(B,fun(C,$o)),fun(C,set(B)),Uu),Uua) = aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aTP_Lamp_gw(fun(B,fun(C,$o)),fun(C,fun(B,$o)),Uu),Uua)) ) ).

% ATP.lambda_352
tff(fact_6518_ATP_Olambda__353,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(D,fun(C,B)),Uua: fun(C,D)] : ( aa(fun(C,D),B,aTP_Lamp_iy(fun(D,fun(C,B)),fun(fun(C,D),B),Uu),Uua) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(C,D),fun(C,B),aTP_Lamp_ix(fun(D,fun(C,B)),fun(fun(C,D),fun(C,B)),Uu),Uua)),top_top(set(C)))) ) ) ).

% ATP.lambda_353
tff(fact_6519_ATP_Olambda__354,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(D,fun(C,B)),Uua: C] : ( aa(C,B,aTP_Lamp_iz(fun(D,fun(C,B)),fun(C,B),Uu),Uua) = aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,aa(C,fun(D,B),aTP_Lamp_iv(fun(D,fun(C,B)),fun(C,fun(D,B)),Uu),Uua)),top_top(set(D)))) ) ) ).

% ATP.lambda_354
tff(fact_6520_ATP_Olambda__355,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(D,fun(C,B)),Uua: fun(C,D)] : ( aa(fun(C,D),B,aTP_Lamp_ja(fun(D,fun(C,B)),fun(fun(C,D),B),Uu),Uua) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(C,D),fun(C,B),aTP_Lamp_ix(fun(D,fun(C,B)),fun(fun(C,D),fun(C,B)),Uu),Uua)),top_top(set(C)))) ) ) ).

% ATP.lambda_355
tff(fact_6521_ATP_Olambda__356,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(D,fun(C,B)),Uua: C] : ( aa(C,B,aTP_Lamp_iw(fun(D,fun(C,B)),fun(C,B),Uu),Uua) = aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,aa(C,fun(D,B),aTP_Lamp_iv(fun(D,fun(C,B)),fun(C,fun(D,B)),Uu),Uua)),top_top(set(D)))) ) ) ).

% ATP.lambda_356
tff(fact_6522_ATP_Olambda__357,axiom,
    ! [B: $tType,Uu: fun(heap_ext(product_unit),B),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_aws(fun(heap_ext(product_unit),B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),B,Uu,Uua)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat)))) ) ).

% ATP.lambda_357
tff(fact_6523_ATP_Olambda__358,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,option(B)),Uua: C] :
      ( aa(C,$o,aTP_Lamp_akk(fun(C,option(B)),fun(C,$o),Uu),Uua)
    <=> ( aa(C,option(B),Uu,Uua) != none(B) ) ) ).

% ATP.lambda_358
tff(fact_6524_ATP_Olambda__359,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,option(C)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_acl(fun(B,option(C)),fun(B,$o),Uu),Uua)
    <=> ( aa(B,option(C),Uu,Uua) != none(C) ) ) ).

% ATP.lambda_359
tff(fact_6525_ATP_Olambda__360,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: B] : ( aa(B,set(product_prod(B,C)),aTP_Lamp_hc(fun(B,set(C)),fun(B,set(product_prod(B,C))),Uu),Uua) = aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(C),set(set(product_prod(B,C))),image2(C,set(product_prod(B,C)),aTP_Lamp_hb(B,fun(C,set(product_prod(B,C))),Uua)),aa(B,set(C),Uu,Uua))) ) ).

% ATP.lambda_360
tff(fact_6526_ATP_Olambda__361,axiom,
    ! [C: $tType,B: $tType,Uu: set(set(old_node(B,C))),Uua: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(set(old_node(B,C))),aTP_Lamp_azk(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),Uu),Uua) = aa(set(set(set(old_node(B,C)))),set(set(old_node(B,C))),complete_Sup_Sup(set(set(old_node(B,C)))),aa(set(set(old_node(B,C))),set(set(set(old_node(B,C)))),image2(set(old_node(B,C)),set(set(old_node(B,C))),aTP_Lamp_azj(set(old_node(B,C)),fun(set(old_node(B,C)),set(set(old_node(B,C)))),Uua)),Uu)) ) ).

% ATP.lambda_361
tff(fact_6527_ATP_Olambda__362,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: B] : ( aa(B,nat,aTP_Lamp_atm(set(multiset(B)),fun(B,nat),Uu),Uua) = aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(B)),set(nat),image2(multiset(B),nat,aTP_Lamp_apd(B,fun(multiset(B),nat),Uua)),Uu)) ) ).

% ATP.lambda_362
tff(fact_6528_ATP_Olambda__363,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: list(product_prod(D,C)),Uua: product_prod(B,D)] : ( aa(product_prod(B,D),list(product_prod(B,C)),aTP_Lamp_akz(list(product_prod(D,C)),fun(product_prod(B,D),list(product_prod(B,C))),Uu),Uua) = concat(product_prod(B,C),aa(list(product_prod(D,C)),list(list(product_prod(B,C))),map(product_prod(D,C),list(product_prod(B,C)),aTP_Lamp_aky(product_prod(B,D),fun(product_prod(D,C),list(product_prod(B,C))),Uua)),Uu)) ) ).

% ATP.lambda_363
tff(fact_6529_ATP_Olambda__364,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_zs(nat,fun(nat,$o),Uu),Uua)
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uu),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))) ) ).

% ATP.lambda_364
tff(fact_6530_ATP_Olambda__365,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_hl(set(set(B)),fun(B,$o),Uu),Uua)
    <=> aa(set($o),$o,complete_Sup_Sup($o),aa(set(set(B)),set($o),image2(set(B),$o,member(B,Uua)),Uu)) ) ).

% ATP.lambda_365
tff(fact_6531_ATP_Olambda__366,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_jg(set(set(B)),fun(B,$o),Uu),Uua)
    <=> aa(set($o),$o,complete_Inf_Inf($o),aa(set(set(B)),set($o),image2(set(B),$o,member(B,Uua)),Uu)) ) ).

% ATP.lambda_366
tff(fact_6532_ATP_Olambda__367,axiom,
    ! [Uu: code_natural,Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_axw(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),Uua),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),Uu),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2)))))))))))))))))))))))))))))))))) ) ).

% ATP.lambda_367
tff(fact_6533_ATP_Olambda__368,axiom,
    ! [B: $tType,Uu: fun(nat,set(B)),Uua: nat] : ( aa(nat,set(B),aTP_Lamp_wk(fun(nat,set(B)),fun(nat,set(B)),Uu),Uua) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(nat),set(set(B)),image2(nat,set(B),Uu),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua))) ) ).

% ATP.lambda_368
tff(fact_6534_ATP_Olambda__369,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,fun(B,B),aTP_Lamp_vs(B,fun(nat,fun(B,B)),Uu),Uua) = aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Uu),aa(nat,B,semiring_1_of_nat(B),Uua))) ) ) ).

% ATP.lambda_369
tff(fact_6535_ATP_Olambda__370,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,fun(B,B),aTP_Lamp_us(B,fun(nat,fun(B,B)),Uu),Uua) = aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(nat,B,semiring_1_of_nat(B),Uua))) ) ) ).

% ATP.lambda_370
tff(fact_6536_ATP_Olambda__371,axiom,
    ! [B: $tType,Uu: list(B),Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural))),aTP_Lamp_bbd(list(B),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(B,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural))),product_Pair(B,product_prod(code_natural,code_natural)),aa(nat,B,nth(B,Uu),code_nat_of_natural(Uua))) ) ).

% ATP.lambda_371
tff(fact_6537_ATP_Olambda__372,axiom,
    ! [B: $tType,Uu: list(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_aip(list(B),fun(B,$o),Uu),Uua)
    <=> ~ aa(set(B),$o,member(B,Uua),aa(list(B),set(B),set2(B),Uu)) ) ).

% ATP.lambda_372
tff(fact_6538_ATP_Olambda__373,axiom,
    ! [B: $tType,Uu: list(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_auv(list(B),fun(B,$o),Uu),Uua)
    <=> ( Uua != last(B,Uu) ) ) ).

% ATP.lambda_373
tff(fact_6539_ATP_Olambda__374,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: set(C)] : ( aa(set(C),set(B),aTP_Lamp_gt(fun(C,set(B)),fun(set(C),set(B)),Uu),Uua) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),Uu),Uua)) ) ).

% ATP.lambda_374
tff(fact_6540_ATP_Olambda__375,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: set(C)] : ( aa(set(C),B,aTP_Lamp_aea(fun(C,B),fun(set(C),B),Uu),Uua) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Uu),Uua)) ) ) ).

% ATP.lambda_375
tff(fact_6541_ATP_Olambda__376,axiom,
    ! [E: $tType,C: $tType,Uu: set(C),Uua: fun(C,set(E))] : ( aa(fun(C,set(E)),set(E),aa(set(C),fun(fun(C,set(E)),set(E)),aTP_Lamp_aqe(set(C),fun(fun(C,set(E)),set(E))),Uu),Uua) = aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(C),set(set(E)),image2(C,set(E),Uua),Uu)) ) ).

% ATP.lambda_376
tff(fact_6542_ATP_Olambda__377,axiom,
    ! [D: $tType,C: $tType] :
      ( complete_Sup(D)
     => ! [Uu: set(C),Uua: fun(C,D)] : ( aa(fun(C,D),D,aa(set(C),fun(fun(C,D),D),aTP_Lamp_aqc(set(C),fun(fun(C,D),D)),Uu),Uua) = aa(set(D),D,complete_Sup_Sup(D),aa(set(C),set(D),image2(C,D,Uua),Uu)) ) ) ).

% ATP.lambda_377
tff(fact_6543_ATP_Olambda__378,axiom,
    ! [B: $tType,Uu: set(B),Uua: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(set(B),fun(fun(B,$o),$o),aTP_Lamp_aeq(set(B),fun(fun(B,$o),$o)),Uu),Uua)
    <=> aa(set($o),$o,complete_Sup_Sup($o),aa(set(B),set($o),image2(B,$o,Uua),Uu)) ) ).

% ATP.lambda_378
tff(fact_6544_ATP_Olambda__379,axiom,
    ! [D: $tType,B: $tType,Uu: set(B),Uua: fun(B,set(D))] : ( aa(fun(B,set(D)),set(D),aa(set(B),fun(fun(B,set(D)),set(D)),aTP_Lamp_aqd(set(B),fun(fun(B,set(D)),set(D))),Uu),Uua) = aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),Uua),Uu)) ) ).

% ATP.lambda_379
tff(fact_6545_ATP_Olambda__380,axiom,
    ! [D: $tType,B: $tType] :
      ( complete_Sup(D)
     => ! [Uu: set(B),Uua: fun(B,D)] : ( aa(fun(B,D),D,aa(set(B),fun(fun(B,D),D),aTP_Lamp_aqb(set(B),fun(fun(B,D),D)),Uu),Uua) = aa(set(D),D,complete_Sup_Sup(D),aa(set(B),set(D),image2(B,D,Uua),Uu)) ) ) ).

% ATP.lambda_380
tff(fact_6546_ATP_Olambda__381,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: set(C)] : ( aa(set(C),set(B),aTP_Lamp_is(fun(C,set(B)),fun(set(C),set(B)),Uu),Uua) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),Uu),Uua)) ) ).

% ATP.lambda_381
tff(fact_6547_ATP_Olambda__382,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: set(C)] : ( aa(set(C),B,aTP_Lamp_aeb(fun(C,B),fun(set(C),B),Uu),Uua) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Uu),Uua)) ) ) ).

% ATP.lambda_382
tff(fact_6548_ATP_Olambda__383,axiom,
    ! [D: $tType,C: $tType] :
      ( complete_Inf(D)
     => ! [Uu: set(C),Uua: fun(C,D)] : ( aa(fun(C,D),D,aa(set(C),fun(fun(C,D),D),aTP_Lamp_aqa(set(C),fun(fun(C,D),D)),Uu),Uua) = aa(set(D),D,complete_Inf_Inf(D),aa(set(C),set(D),image2(C,D,Uua),Uu)) ) ) ).

% ATP.lambda_383
tff(fact_6549_ATP_Olambda__384,axiom,
    ! [B: $tType,Uu: set(B),Uua: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(set(B),fun(fun(B,$o),$o),aTP_Lamp_adb(set(B),fun(fun(B,$o),$o)),Uu),Uua)
    <=> aa(set($o),$o,complete_Inf_Inf($o),aa(set(B),set($o),image2(B,$o,Uua),Uu)) ) ).

% ATP.lambda_384
tff(fact_6550_ATP_Olambda__385,axiom,
    ! [D: $tType,B: $tType] :
      ( complete_Inf(D)
     => ! [Uu: set(B),Uua: fun(B,D)] : ( aa(fun(B,D),D,aa(set(B),fun(fun(B,D),D),aTP_Lamp_apz(set(B),fun(fun(B,D),D)),Uu),Uua) = aa(set(D),D,complete_Inf_Inf(D),aa(set(B),set(D),image2(B,D,Uua),Uu)) ) ) ).

% ATP.lambda_385
tff(fact_6551_ATP_Olambda__386,axiom,
    ! [B: $tType] :
      ( sup(B)
     => ! [Uu: B,Uua: B] : ( aa(B,option(B),aTP_Lamp_aad(B,fun(B,option(B)),Uu),Uua) = aa(B,option(B),some(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Uu),Uua)) ) ) ).

% ATP.lambda_386
tff(fact_6552_ATP_Olambda__387,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [Uu: B,Uua: B] : ( aa(B,option(B),aTP_Lamp_abd(B,fun(B,option(B)),Uu),Uua) = aa(B,option(B),some(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),Uu),Uua)) ) ) ).

% ATP.lambda_387
tff(fact_6553_ATP_Olambda__388,axiom,
    ! [Uu: code_natural,Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_axy(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),modulo_modulo(code_natural,Uua,Uu)) ) ).

% ATP.lambda_388
tff(fact_6554_ATP_Olambda__389,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: B,Uua: C] : ( aa(C,fun(D,product_prod(product_prod(B,C),D)),aTP_Lamp_qk(B,fun(C,fun(D,product_prod(product_prod(B,C),D))),Uu),Uua) = aa(product_prod(B,C),fun(D,product_prod(product_prod(B,C),D)),product_Pair(product_prod(B,C),D),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),Uua)) ) ).

% ATP.lambda_389
tff(fact_6555_ATP_Olambda__390,axiom,
    ! [B: $tType,Uu: list(product_prod(code_natural,B)),Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural))),aTP_Lamp_axz(list(product_prod(code_natural,B)),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(B,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural))),product_Pair(B,product_prod(code_natural,code_natural)),aa(code_natural,B,pick(B,Uu),Uua)) ) ).

% ATP.lambda_390
tff(fact_6556_ATP_Olambda__391,axiom,
    ! [C: $tType,B: $tType,Uu: list(product_prod(B,C)),Uua: B] : ( aa(B,C,aTP_Lamp_aol(list(product_prod(B,C)),fun(B,C),Uu),Uua) = aa(option(C),C,the2(C),aa(B,option(C),map_of(B,C,Uu),Uua)) ) ).

% ATP.lambda_391
tff(fact_6557_ATP_Olambda__392,axiom,
    ! [C: $tType,B: $tType,Uu: C,Uua: B] : ( aa(B,fun(set(product_prod(C,B)),set(product_prod(C,B))),aTP_Lamp_li(C,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),Uu),Uua) = insert(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uu),Uua)) ) ).

% ATP.lambda_392
tff(fact_6558_ATP_Olambda__393,axiom,
    ! [B: $tType,C: $tType,Uu: B,Uua: C] : ( aa(C,fun(set(product_prod(B,C)),set(product_prod(B,C))),aTP_Lamp_lq(B,fun(C,fun(set(product_prod(B,C)),set(product_prod(B,C)))),Uu),Uua) = insert(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),Uua)) ) ).

% ATP.lambda_393
tff(fact_6559_ATP_Olambda__394,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_zx(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uu),Uua)) ) ).

% ATP.lambda_394
tff(fact_6560_ATP_Olambda__395,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_zy(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uua),Uu)) ) ).

% ATP.lambda_395
tff(fact_6561_ATP_Olambda__396,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_aca(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uu),Uua)) ) ).

% ATP.lambda_396
tff(fact_6562_ATP_Olambda__397,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_acb(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uua),Uu)) ) ).

% ATP.lambda_397
tff(fact_6563_ATP_Olambda__398,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aTP_Lamp_ani(B,fun(B,$o),Uu),Uua)
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uu),Uua) ) ) ).

% ATP.lambda_398
tff(fact_6564_ATP_Olambda__399,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_at(set(B),fun(B,$o),Uu),Uua)
    <=> ~ aa(set(B),$o,member(B,Uua),Uu) ) ).

% ATP.lambda_399
tff(fact_6565_ATP_Olambda__400,axiom,
    ! [B: $tType,Uu: B,Uua: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_adk(B,fun(B,$o)),Uu),Uua)
    <=> ( Uu != Uua ) ) ).

% ATP.lambda_400
tff(fact_6566_ATP_Olambda__401,axiom,
    ! [B: $tType] :
      ( ( linorder(B)
        & no_top(B) )
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aTP_Lamp_xi(B,fun(B,$o),Uu),Uua)
        <=> ( Uua != Uu ) ) ) ).

% ATP.lambda_401
tff(fact_6567_ATP_Olambda__402,axiom,
    ! [B: $tType] :
      ( ( linorder(B)
        & no_bot(B) )
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aTP_Lamp_pk(B,fun(B,$o),Uu),Uua)
        <=> ( Uua != Uu ) ) ) ).

% ATP.lambda_402
tff(fact_6568_ATP_Olambda__403,axiom,
    ! [B: $tType,Uu: B,Uua: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_rx(B,fun(B,$o)),Uu),Uua)
    <=> ( Uua != Uu ) ) ).

% ATP.lambda_403
tff(fact_6569_ATP_Olambda__404,axiom,
    ! [B: $tType,Uu: B,Uua: B] : ( aa(B,set(B),aTP_Lamp_ea(B,fun(B,set(B)),Uu),Uua) = aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert(B,Uu),bot_bot(set(B)))) ) ).

% ATP.lambda_404
tff(fact_6570_ATP_Olambda__405,axiom,
    ! [Uu: nat,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_axo(nat,fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),some(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(product_unit,fun(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),product_Pair(product_unit,product_prod(heap_ext(product_unit),nat)),product_Unity),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),Uu))) ) ).

% ATP.lambda_405
tff(fact_6571_ATP_Olambda__406,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(B,fun(B,B)),Uua: B] : ( aa(B,B,aTP_Lamp_mi(fun(B,fun(B,B)),fun(B,B),Uu),Uua) = complete_lattice_lfp(B,aa(B,fun(B,B),Uu,Uua)) ) ) ).

% ATP.lambda_406
tff(fact_6572_ATP_Olambda__407,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(B,fun(B,B)),Uua: B] : ( aa(B,B,aTP_Lamp_no(fun(B,fun(B,B)),fun(B,B),Uu),Uua) = complete_lattice_gfp(B,aa(B,fun(B,B),Uu,Uua)) ) ) ).

% ATP.lambda_407
tff(fact_6573_ATP_Olambda__408,axiom,
    ! [D: $tType,C: $tType,Uu: fun(C,set(D)),Uua: C] : ( aa(C,set(product_prod(D,D)),aTP_Lamp_agt(fun(C,set(D)),fun(C,set(product_prod(D,D))),Uu),Uua) = bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),Uu,Uua)) ) ).

% ATP.lambda_408
tff(fact_6574_ATP_Olambda__409,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: B] : ( aa(B,set(product_prod(C,C)),aTP_Lamp_agp(fun(B,set(C)),fun(B,set(product_prod(C,C))),Uu),Uua) = bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),Uu,Uua)) ) ).

% ATP.lambda_409
tff(fact_6575_ATP_Olambda__410,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [Uu: fun(B,$o),Uua: B] : ( aa(B,C,aTP_Lamp_xc(fun(B,$o),fun(B,C),Uu),Uua) = aa($o,C,zero_neq_one_of_bool(C),aa(B,$o,Uu,Uua)) ) ) ).

% ATP.lambda_410
tff(fact_6576_ATP_Olambda__411,axiom,
    ! [B: $tType,C: $tType] :
      ( field_char_0(B)
     => ! [Uu: fun(C,rat),Uua: C] : ( aa(C,B,aTP_Lamp_abu(fun(C,rat),fun(C,B),Uu),Uua) = aa(rat,B,field_char_0_of_rat(B),aa(C,rat,Uu,Uua)) ) ) ).

% ATP.lambda_411
tff(fact_6577_ATP_Olambda__412,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: fun(C,nat),Uua: C] : ( aa(C,B,aTP_Lamp_so(fun(C,nat),fun(C,B),Uu),Uua) = aa(nat,B,semiring_1_of_nat(B),aa(C,nat,Uu,Uua)) ) ) ).

% ATP.lambda_412
tff(fact_6578_ATP_Olambda__413,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_1(B)
     => ! [Uu: fun(C,nat),Uua: C] : ( aa(C,B,aTP_Lamp_sn(fun(C,nat),fun(C,B),Uu),Uua) = aa(nat,B,semiring_1_of_nat(B),aa(C,nat,Uu,Uua)) ) ) ).

% ATP.lambda_413
tff(fact_6579_ATP_Olambda__414,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B] : ( aa(B,int,aTP_Lamp_sq(fun(B,nat),fun(B,int),Uu),Uua) = aa(nat,int,semiring_1_of_nat(int),aa(B,nat,Uu,Uua)) ) ).

% ATP.lambda_414
tff(fact_6580_ATP_Olambda__415,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: C] : ( aa(C,set(B),aTP_Lamp_hz(fun(C,set(B)),fun(C,set(B)),Uu),Uua) = aa(set(B),set(B),uminus_uminus(set(B)),aa(C,set(B),Uu,Uua)) ) ).

% ATP.lambda_415
tff(fact_6581_ATP_Olambda__416,axiom,
    ! [B: $tType,C: $tType] :
      ( comple489889107523837845lgebra(B)
     => ! [Uu: fun(C,B),Uua: C] : ( aa(C,B,aTP_Lamp_ir(fun(C,B),fun(C,B),Uu),Uua) = aa(B,B,uminus_uminus(B),aa(C,B,Uu,Uua)) ) ) ).

% ATP.lambda_416
tff(fact_6582_ATP_Olambda__417,axiom,
    ! [B: $tType,C: $tType] :
      ( ab_group_add(B)
     => ! [Uu: fun(C,B),Uua: C] : ( aa(C,B,aTP_Lamp_oy(fun(C,B),fun(C,B),Uu),Uua) = aa(B,B,uminus_uminus(B),aa(C,B,Uu,Uua)) ) ) ).

% ATP.lambda_417
tff(fact_6583_ATP_Olambda__418,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(product_prod(C,C))),Uua: B] : ( aa(B,set(product_prod(C,C)),aTP_Lamp_je(fun(B,set(product_prod(C,C))),fun(B,set(product_prod(C,C))),Uu),Uua) = transitive_trancl(C,aa(B,set(product_prod(C,C)),Uu,Uua)) ) ).

% ATP.lambda_418
tff(fact_6584_ATP_Olambda__419,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,fun(B,B),aTP_Lamp_tf(fun(nat,B),fun(nat,fun(B,B)),Uu),Uua) = aa(B,fun(B,B),times_times(B),aa(nat,B,Uu,Uua)) ) ) ).

% ATP.lambda_419
tff(fact_6585_ATP_Olambda__420,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_ring_1(B)
     => ! [Uu: fun(C,int),Uua: C] : ( aa(C,B,aTP_Lamp_xu(fun(C,int),fun(C,B),Uu),Uua) = aa(int,B,ring_1_of_int(B),aa(C,int,Uu,Uua)) ) ) ).

% ATP.lambda_420
tff(fact_6586_ATP_Olambda__421,axiom,
    ! [B: $tType,C: $tType] :
      ( ring_1(B)
     => ! [Uu: fun(C,int),Uua: C] : ( aa(C,B,aTP_Lamp_xv(fun(C,int),fun(C,B),Uu),Uua) = aa(int,B,ring_1_of_int(B),aa(C,int,Uu,Uua)) ) ) ).

% ATP.lambda_421
tff(fact_6587_ATP_Olambda__422,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: C] : ( aa(C,heap_Time_Heap(B),aTP_Lamp_axh(fun(C,B),fun(C,heap_Time_Heap(B)),Uu),Uua) = aa(B,heap_Time_Heap(B),heap_Time_return(B),aa(C,B,Uu,Uua)) ) ).

% ATP.lambda_422
tff(fact_6588_ATP_Olambda__423,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,fun(B,B),aTP_Lamp_tx(fun(nat,B),fun(nat,fun(B,B)),Uu),Uua) = aa(B,fun(B,B),plus_plus(B),aa(nat,B,Uu,Uua)) ) ) ).

% ATP.lambda_423
tff(fact_6589_ATP_Olambda__424,axiom,
    ! [B: $tType,C: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [Uu: fun(C,B),Uua: C] : ( aa(C,B,aTP_Lamp_qh(fun(C,B),fun(C,B),Uu),Uua) = aa(B,B,abs_abs(B),aa(C,B,Uu,Uua)) ) ) ).

% ATP.lambda_424
tff(fact_6590_ATP_Olambda__425,axiom,
    ! [B: $tType,C: $tType] :
      ( linordered_field(B)
     => ! [Uu: fun(C,B),Uua: C] : ( aa(C,B,aTP_Lamp_qm(fun(C,B),fun(C,B),Uu),Uua) = aa(B,B,abs_abs(B),aa(C,B,Uu,Uua)) ) ) ).

% ATP.lambda_425
tff(fact_6591_ATP_Olambda__426,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(C,B),Uua: C] : ( aa(C,option(B),aTP_Lamp_aaf(fun(C,B),fun(C,option(B)),Uu),Uua) = aa(B,option(B),some(B),aa(C,B,Uu,Uua)) ) ) ).

% ATP.lambda_426
tff(fact_6592_ATP_Olambda__427,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: C] : ( aa(C,option(B),aTP_Lamp_abv(fun(C,B),fun(C,option(B)),Uu),Uua) = aa(B,option(B),some(B),aa(C,B,Uu,Uua)) ) ).

% ATP.lambda_427
tff(fact_6593_ATP_Olambda__428,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [Uu: fun(B,C),Uua: B] : ( aa(B,option(C),aTP_Lamp_aag(fun(B,C),fun(B,option(C)),Uu),Uua) = aa(C,option(C),some(C),aa(B,C,Uu,Uua)) ) ) ).

% ATP.lambda_428
tff(fact_6594_ATP_Olambda__429,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: B] : ( aa(B,option(C),aTP_Lamp_acj(fun(B,C),fun(B,option(C)),Uu),Uua) = aa(C,option(C),some(C),aa(B,C,Uu,Uua)) ) ).

% ATP.lambda_429
tff(fact_6595_ATP_Olambda__430,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(D,set(product_prod(C,B))),Uua: D] : ( aa(D,set(product_prod(B,C)),aTP_Lamp_mo(fun(D,set(product_prod(C,B))),fun(D,set(product_prod(B,C))),Uu),Uua) = converse(C,B,aa(D,set(product_prod(C,B)),Uu,Uua)) ) ).

% ATP.lambda_430
tff(fact_6596_ATP_Olambda__431,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(D,B),Uua: D] : ( aa(D,fun(C,product_prod(B,C)),aTP_Lamp_ajw(fun(D,B),fun(D,fun(C,product_prod(B,C))),Uu),Uua) = aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Uu,Uua)) ) ).

% ATP.lambda_431
tff(fact_6597_ATP_Olambda__432,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(B,C),Uua: B] : ( aa(B,fun(D,product_prod(C,D)),aTP_Lamp_ame(fun(B,C),fun(B,fun(D,product_prod(C,D))),Uu),Uua) = aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(B,C,Uu,Uua)) ) ).

% ATP.lambda_432
tff(fact_6598_ATP_Olambda__433,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(D,set(old_node(B,C))),Uua: D] : ( aa(D,set(old_node(B,C)),aTP_Lamp_ayw(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C))),Uu),Uua) = old_In1(B,C,aa(D,set(old_node(B,C)),Uu,Uua)) ) ).

% ATP.lambda_433
tff(fact_6599_ATP_Olambda__434,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(D,set(old_node(B,C))),Uua: D] : ( aa(D,set(old_node(B,C)),aTP_Lamp_ayx(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C))),Uu),Uua) = old_In0(B,C,aa(D,set(old_node(B,C)),Uu,Uua)) ) ).

% ATP.lambda_434
tff(fact_6600_ATP_Olambda__435,axiom,
    ! [D: $tType,E: $tType,Uu: fun(E,set(D)),Uua: E] : ( aa(E,filter(D),aTP_Lamp_mw(fun(E,set(D)),fun(E,filter(D)),Uu),Uua) = principal(D,aa(E,set(D),Uu,Uua)) ) ).

% ATP.lambda_435
tff(fact_6601_ATP_Olambda__436,axiom,
    ! [E: $tType,D: $tType,Uu: fun(D,set(E)),Uua: D] : ( aa(D,filter(E),aTP_Lamp_na(fun(D,set(E)),fun(D,filter(E)),Uu),Uua) = principal(E,aa(D,set(E),Uu,Uua)) ) ).

% ATP.lambda_436
tff(fact_6602_ATP_Olambda__437,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: C] : ( aa(C,filter(B),aTP_Lamp_mg(fun(C,set(B)),fun(C,filter(B)),Uu),Uua) = principal(B,aa(C,set(B),Uu,Uua)) ) ).

% ATP.lambda_437
tff(fact_6603_ATP_Olambda__438,axiom,
    ! [F10: $tType,B: $tType,Uu: fun(B,set(F10)),Uua: B] : ( aa(B,filter(F10),aTP_Lamp_mz(fun(B,set(F10)),fun(B,filter(F10)),Uu),Uua) = principal(F10,aa(B,set(F10),Uu,Uua)) ) ).

% ATP.lambda_438
tff(fact_6604_ATP_Olambda__439,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: B] : ( aa(B,filter(C),aTP_Lamp_mf(fun(B,set(C)),fun(B,filter(C)),Uu),Uua) = principal(C,aa(B,set(C),Uu,Uua)) ) ).

% ATP.lambda_439
tff(fact_6605_ATP_Olambda__440,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: B] : ( aa(B,nat,aTP_Lamp_rj(fun(B,set(C)),fun(B,nat),Uu),Uua) = aa(set(C),nat,finite_card(C),aa(B,set(C),Uu,Uua)) ) ).

% ATP.lambda_440
tff(fact_6606_ATP_Olambda__441,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(product_prod(C,C))),Uua: B] : ( aa(B,set(C),aTP_Lamp_agq(fun(B,set(product_prod(C,C))),fun(B,set(C)),Uu),Uua) = field2(C,aa(B,set(product_prod(C,C)),Uu,Uua)) ) ).

% ATP.lambda_441
tff(fact_6607_ATP_Olambda__442,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,list(B)),Uua: C] : ( aa(C,set(B),aTP_Lamp_ahv(fun(C,list(B)),fun(C,set(B)),Uu),Uua) = aa(list(B),set(B),set2(B),aa(C,list(B),Uu,Uua)) ) ).

% ATP.lambda_442
tff(fact_6608_ATP_Olambda__443,axiom,
    ! [B: $tType,Uu: fun(set(B),fun(B,$o)),Uua: set(B)] : ( aa(set(B),set(B),aTP_Lamp_ns(fun(set(B),fun(B,$o)),fun(set(B),set(B)),Uu),Uua) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),Uu,Uua)) ) ).

% ATP.lambda_443
tff(fact_6609_ATP_Olambda__444,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: B] : ( aa(B,set(C),aTP_Lamp_dq(fun(B,fun(C,$o)),fun(B,set(C)),Uu),Uua) = aa(fun(C,$o),set(C),collect(C),aa(B,fun(C,$o),Uu,Uua)) ) ).

% ATP.lambda_444
tff(fact_6610_ATP_Olambda__445,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: B] : ( aa(B,fun(set(C),set(C)),aTP_Lamp_lo(fun(B,C),fun(B,fun(set(C),set(C))),Uu),Uua) = insert(C,aa(B,C,Uu,Uua)) ) ).

% ATP.lambda_445
tff(fact_6611_ATP_Olambda__446,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: C] : ( aa(C,set(set(B)),aTP_Lamp_jt(fun(C,set(B)),fun(C,set(set(B))),Uu),Uua) = pow(B,aa(C,set(B),Uu,Uua)) ) ).

% ATP.lambda_446
tff(fact_6612_ATP_Olambda__447,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B] : ( aa(B,nat,aTP_Lamp_sw(fun(B,nat),fun(B,nat),Uu),Uua) = aa(nat,nat,suc,aa(B,nat,Uu,Uua)) ) ).

% ATP.lambda_447
tff(fact_6613_ATP_Olambda__448,axiom,
    ! [C: $tType,Uu: fun(C,$o),Uua: C] :
      ( aa(C,$o,aTP_Lamp_cb(fun(C,$o),fun(C,$o),Uu),Uua)
    <=> ~ aa(C,$o,Uu,Uua) ) ).

% ATP.lambda_448
tff(fact_6614_ATP_Olambda__449,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: B] :
      ( aa(B,$o,aTP_Lamp_as(fun(B,$o),fun(B,$o),Uu),Uua)
    <=> ~ aa(B,$o,Uu,Uua) ) ).

% ATP.lambda_449
tff(fact_6615_ATP_Olambda__450,axiom,
    ! [C: $tType,B: $tType] :
      ( finite_finite(B)
     => ! [Uu: fun(C,fun(B,$o)),Uua: C] :
          ( aa(C,$o,aTP_Lamp_afh(fun(C,fun(B,$o)),fun(C,$o),Uu),Uua)
        <=> ! [X_12: B] : aa(B,$o,aa(C,fun(B,$o),Uu,Uua),X_12) ) ) ).

% ATP.lambda_450
tff(fact_6616_ATP_Olambda__451,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,fun(B,$o)),Uua: C] :
      ( aa(C,$o,aTP_Lamp_ayh(fun(C,fun(B,$o)),fun(C,$o),Uu),Uua)
    <=> ! [X_12: B] : aa(B,$o,aa(C,fun(B,$o),Uu,Uua),X_12) ) ).

% ATP.lambda_451
tff(fact_6617_ATP_Olambda__452,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,$o)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_afj(fun(B,fun(C,$o)),fun(B,$o),Uu),Uua)
    <=> ! [X_12: C] : aa(C,$o,aa(B,fun(C,$o),Uu,Uua),X_12) ) ).

% ATP.lambda_452
tff(fact_6618_ATP_Olambda__453,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,$o)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_gv(fun(B,fun(C,$o)),fun(B,$o),Uu),Uua)
    <=> ? [X_12: C] : aa(C,$o,aa(B,fun(C,$o),Uu,Uua),X_12) ) ).

% ATP.lambda_453
tff(fact_6619_ATP_Olambda__454,axiom,
    ! [B: $tType,C: $tType,Uu: fun(nat,sum_sum(C,nat)),Uua: sum_sum(B,nat)] : ( aa(sum_sum(B,nat),nat,aa(fun(nat,sum_sum(C,nat)),fun(sum_sum(B,nat),nat),aTP_Lamp_ayr(fun(nat,sum_sum(C,nat)),fun(sum_sum(B,nat),nat)),Uu),Uua) = ord_Least(nat,aTP_Lamp_ayq(fun(nat,sum_sum(C,nat)),fun(nat,$o),Uu)) ) ).

% ATP.lambda_454
tff(fact_6620_ATP_Olambda__455,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_ahj(nat,fun(nat,set(nat)),Uu),Uua) = aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_th(nat,fun(nat,$o)),Uu)) ) ).

% ATP.lambda_455
tff(fact_6621_ATP_Olambda__456,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B)] : ( aa(set(B),filter(set(B)),aTP_Lamp_mt(set(B),fun(set(B),filter(set(B))),Uu),Uua) = principal(set(B),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aa(set(B),fun(set(B),$o),aTP_Lamp_ms(set(B),fun(set(B),fun(set(B),$o)),Uu),Uua))) ) ).

% ATP.lambda_456
tff(fact_6622_ATP_Olambda__457,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,$o),Uua: fun(C,$o)] : ( aa(fun(C,$o),filter(product_prod(B,C)),aa(fun(B,$o),fun(fun(C,$o),filter(product_prod(B,C))),aTP_Lamp_qq(fun(B,$o),fun(fun(C,$o),filter(product_prod(B,C)))),Uu),Uua) = principal(product_prod(B,C),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(fun(C,$o),fun(B,fun(C,$o)),aTP_Lamp_cv(fun(B,$o),fun(fun(C,$o),fun(B,fun(C,$o))),Uu),Uua)))) ) ).

% ATP.lambda_457
tff(fact_6623_ATP_Olambda__458,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,fun(B,$o)),Uua: fun(C,B)] :
      ( aa(fun(C,B),$o,aTP_Lamp_baj(fun(C,fun(B,$o)),fun(fun(C,B),$o),Uu),Uua)
    <=> ! [X3: C] : aa(B,$o,aa(C,fun(B,$o),Uu,X3),aa(C,B,Uua,X3)) ) ).

% ATP.lambda_458
tff(fact_6624_ATP_Olambda__459,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,fun(B,$o)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_axc(fun(C,fun(B,$o)),fun(B,$o),Uu),Uua)
    <=> ? [X3: C] : aa(B,$o,aa(C,fun(B,$o),Uu,X3),Uua) ) ).

% ATP.lambda_459
tff(fact_6625_ATP_Olambda__460,axiom,
    ! [B: $tType,Uu: fun(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aTP_Lamp_bf(fun(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uu),Uua)
    <=> ? [X3: B] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uu,X3),Uua) ) ).

% ATP.lambda_460
tff(fact_6626_ATP_Olambda__461,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,$o)),Uua: C] :
      ( aa(C,$o,aTP_Lamp_adl(fun(B,fun(C,$o)),fun(C,$o),Uu),Uua)
    <=> ? [A6: B] : aa(C,$o,aa(B,fun(C,$o),Uu,A6),Uua) ) ).

% ATP.lambda_461
tff(fact_6627_ATP_Olambda__462,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_aux(fun(B,fun(B,$o)),fun(set(B),$o),Uu),Uua)
    <=> ? [X3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Uu,X3),X3)
          & ( Uua = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),Uu,X3)) ) ) ) ).

% ATP.lambda_462
tff(fact_6628_ATP_Olambda__463,axiom,
    ! [B: $tType,Uu: list(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_ajf(list(B),fun(B,$o),Uu),Uua)
    <=> ? [I5: nat] :
          ( ( Uua = aa(nat,B,nth(B,Uu),I5) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I5),aa(list(B),nat,size_size(list(B)),Uu)) ) ) ).

% ATP.lambda_463
tff(fact_6629_ATP_Olambda__464,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: set(set(option(B))),Uua: set(option(B))] :
          ( aa(set(option(B)),$o,aTP_Lamp_aed(set(set(option(B))),fun(set(option(B)),$o),Uu),Uua)
        <=> ? [F8: fun(set(option(B)),option(B))] :
              ( ( Uua = aa(set(set(option(B))),set(option(B)),image2(set(option(B)),option(B),F8),Uu) )
              & ! [X3: set(option(B))] :
                  ( aa(set(set(option(B))),$o,member(set(option(B)),X3),Uu)
                 => aa(set(option(B)),$o,member(option(B),aa(set(option(B)),option(B),F8,X3)),X3) ) ) ) ) ).

% ATP.lambda_464
tff(fact_6630_ATP_Olambda__465,axiom,
    ! [C: $tType,Uu: set(set(C)),Uua: set(C)] :
      ( aa(set(C),$o,aTP_Lamp_aec(set(set(C)),fun(set(C),$o),Uu),Uua)
    <=> ? [F8: fun(set(C),C)] :
          ( ( Uua = aa(set(set(C)),set(C),image2(set(C),C,F8),Uu) )
          & ! [X3: set(C)] :
              ( aa(set(set(C)),$o,member(set(C),X3),Uu)
             => aa(set(C),$o,member(C,aa(set(C),C,F8,X3)),X3) ) ) ) ).

% ATP.lambda_465
tff(fact_6631_ATP_Olambda__466,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: set(set(B)),Uua: set(B)] :
          ( aa(set(B),$o,aTP_Lamp_adw(set(set(B)),fun(set(B),$o),Uu),Uua)
        <=> ? [F8: fun(set(B),B)] :
              ( ( Uua = aa(set(set(B)),set(B),image2(set(B),B,F8),Uu) )
              & ! [X3: set(B)] :
                  ( aa(set(set(B)),$o,member(set(B),X3),Uu)
                 => aa(set(B),$o,member(B,aa(set(B),B,F8,X3)),X3) ) ) ) ) ).

% ATP.lambda_466
tff(fact_6632_ATP_Olambda__467,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: set(set(B)),Uua: set(B)] :
          ( aa(set(B),$o,aTP_Lamp_ady(set(set(B)),fun(set(B),$o),Uu),Uua)
        <=> ? [F8: fun(set(B),B)] :
              ( ( Uua = aa(set(set(B)),set(B),image2(set(B),B,F8),Uu) )
              & ! [X3: set(B)] :
                  ( aa(set(set(B)),$o,member(set(B),X3),Uu)
                 => aa(set(B),$o,member(B,aa(set(B),B,F8,X3)),X3) ) ) ) ) ).

% ATP.lambda_467
tff(fact_6633_ATP_Olambda__468,axiom,
    ! [B: $tType] :
      ( finite8700451911770168679attice(B)
     => ! [Uu: set(set(B)),Uua: set(B)] :
          ( aa(set(B),$o,aTP_Lamp_adz(set(set(B)),fun(set(B),$o),Uu),Uua)
        <=> ? [F8: fun(set(B),B)] :
              ( ( Uua = aa(set(set(B)),set(B),image2(set(B),B,F8),Uu) )
              & ! [X3: set(B)] :
                  ( aa(set(set(B)),$o,member(set(B),X3),Uu)
                 => aa(set(B),$o,member(B,aa(set(B),B,F8,X3)),X3) ) ) ) ) ).

% ATP.lambda_468
tff(fact_6634_ATP_Olambda__469,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_kb(set(B),fun(set(B),$o),Uu),Uua)
    <=> ? [B9: set(B)] :
          ( ( Uua = aa(set(B),set(B),uminus_uminus(set(B)),B9) )
          & aa(set(set(B)),$o,member(set(B),Uu),pow(B,B9)) ) ) ).

% ATP.lambda_469
tff(fact_6635_ATP_Olambda__470,axiom,
    ! [B: $tType,Uu: set(filter(B)),Uua: filter(B)] :
      ( aa(filter(B),$o,aTP_Lamp_adx(set(filter(B)),fun(filter(B),$o),Uu),Uua)
    <=> ! [X3: filter(B)] :
          ( aa(set(filter(B)),$o,member(filter(B),X3),Uu)
         => aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),Uua),X3) ) ) ).

% ATP.lambda_470
tff(fact_6636_ATP_Olambda__471,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: set(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_aef(set(B),fun(B,$o),Uu),Uua)
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),Uu)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),X3) ) ) ) ).

% ATP.lambda_471
tff(fact_6637_ATP_Olambda__472,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: set(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_adq(set(B),fun(B,$o),Uu),Uua)
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),Uu)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),X3) ) ) ) ).

% ATP.lambda_472
tff(fact_6638_ATP_Olambda__473,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: set(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_acz(set(B),fun(B,$o),Uu),Uua)
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),Uu)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),Uua) ) ) ) ).

% ATP.lambda_473
tff(fact_6639_ATP_Olambda__474,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: set(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_adp(set(B),fun(B,$o),Uu),Uua)
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),Uu)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),Uua) ) ) ) ).

% ATP.lambda_474
tff(fact_6640_ATP_Olambda__475,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: multiset(B)] :
      ( aa(multiset(B),$o,aTP_Lamp_atu(set(multiset(B)),fun(multiset(B),$o),Uu),Uua)
    <=> ! [X3: multiset(B)] :
          ( aa(set(multiset(B)),$o,member(multiset(B),X3),Uu)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Uua),X3) ) ) ).

% ATP.lambda_475
tff(fact_6641_ATP_Olambda__476,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: multiset(B)] :
      ( aa(multiset(B),$o,aTP_Lamp_atp(set(multiset(B)),fun(multiset(B),$o),Uu),Uua)
    <=> ! [X3: multiset(B)] :
          ( aa(set(multiset(B)),$o,member(multiset(B),X3),Uu)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X3),Uua) ) ) ).

% ATP.lambda_476
tff(fact_6642_ATP_Olambda__477,axiom,
    ! [Uu: set(nat),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_aul(set(nat),fun(nat,$o),Uu),Uua)
    <=> ! [X3: nat] :
          ( aa(set(nat),$o,member(nat,X3),Uu)
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uua),X3) ) ) ).

% ATP.lambda_477
tff(fact_6643_ATP_Olambda__478,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [Uu: set(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_auj(set(B),fun(B,$o),Uu),Uua)
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),Uu)
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Uua),X3) ) ) ) ).

% ATP.lambda_478
tff(fact_6644_ATP_Olambda__479,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [Uu: set(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_auk(set(B),fun(B,$o),Uu),Uua)
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),Uu)
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),X3),Uua) ) ) ) ).

% ATP.lambda_479
tff(fact_6645_ATP_Olambda__480,axiom,
    ! [B: $tType,Uu: set(filter(B)),Uua: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aTP_Lamp_ael(set(filter(B)),fun(fun(B,$o),$o),Uu),Uua)
    <=> ! [X3: filter(B)] :
          ( aa(set(filter(B)),$o,member(filter(B),X3),Uu)
         => eventually(B,Uua,X3) ) ) ).

% ATP.lambda_480
tff(fact_6646_ATP_Olambda__481,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_add(set(set(B)),fun(B,$o),Uu),Uua)
    <=> ! [X3: set(B)] :
          ( aa(set(set(B)),$o,member(set(B),X3),Uu)
         => aa(set(B),$o,member(B,Uua),X3) ) ) ).

% ATP.lambda_481
tff(fact_6647_ATP_Olambda__482,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_aes(set(set(B)),fun(B,$o),Uu),Uua)
    <=> ? [X3: set(B)] :
          ( aa(set(set(B)),$o,member(set(B),X3),Uu)
          & aa(set(B),$o,member(B,Uua),X3) ) ) ).

% ATP.lambda_482
tff(fact_6648_ATP_Olambda__483,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: fun(B,$o),Uua: B] :
          ( aa(B,$o,aTP_Lamp_afk(fun(B,$o),fun(B,$o),Uu),Uua)
        <=> ! [Y4: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Y4)
             => aa(B,$o,Uu,Y4) ) ) ) ).

% ATP.lambda_483
tff(fact_6649_ATP_Olambda__484,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_aqf(fun(B,$o),fun(set(B),$o),Uu),Uua)
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),Uua)
         => aa(B,$o,Uu,X3) ) ) ).

% ATP.lambda_484
tff(fact_6650_ATP_Olambda__485,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_agj(set(product_prod(B,B)),fun(set(B),$o),Uu),Uua)
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),Uua)
         => ! [Xa2: B] :
              ( aa(set(B),$o,member(B,Xa2),Uua)
             => ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa2)),Uu)
                | aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa2),X3)),Uu) ) ) ) ) ).

% ATP.lambda_485
tff(fact_6651_ATP_Olambda__486,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_axl(set(product_prod(B,C)),fun(B,$o),Uu),Uua)
    <=> ? [Y4: C] : aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Y4)),Uu) ) ).

% ATP.lambda_486
tff(fact_6652_ATP_Olambda__487,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,option(B)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_acr(fun(C,option(B)),fun(B,$o),Uu),Uua)
    <=> ? [A6: C] : ( aa(C,option(B),Uu,A6) = aa(B,option(B),some(B),Uua) ) ) ).

% ATP.lambda_487
tff(fact_6653_ATP_Olambda__488,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aTP_Lamp_ak(fun(B,assn),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uu),Uua)
    <=> ? [X3: B] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Uu,X3)),Uua) ) ).

% ATP.lambda_488
tff(fact_6654_ATP_Olambda__489,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(old_node(B,C))),Uua: set(old_node(B,C))] :
      ( aa(set(old_node(B,C)),$o,aTP_Lamp_ayt(fun(C,set(old_node(B,C))),fun(set(old_node(B,C)),$o),Uu),Uua)
    <=> ? [X3: C] : ( Uua = aa(set(old_node(B,C)),set(old_node(B,C)),image2(old_node(B,C),old_node(B,C),old_Push_Node(C,B,aa(C,sum_sum(C,nat),sum_Inl(C,nat),X3))),aa(C,set(old_node(B,C)),Uu,X3)) ) ) ).

% ATP.lambda_489
tff(fact_6655_ATP_Olambda__490,axiom,
    ! [B: $tType,C: $tType,Uu: B,Uua: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aTP_Lamp_aap(B,fun(product_prod(B,C),$o),Uu),Uua)
    <=> ? [V4: C] : ( Uua = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),V4) ) ) ).

% ATP.lambda_490
tff(fact_6656_ATP_Olambda__491,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_ck(fun(C,B),fun(B,$o),Uu),Uua)
    <=> ? [X3: C] : ( Uua = aa(C,B,Uu,X3) ) ) ).

% ATP.lambda_491
tff(fact_6657_ATP_Olambda__492,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,$o),Uua: fun(B,C)] :
      ( aa(fun(B,C),$o,aTP_Lamp_apt(fun(C,$o),fun(fun(B,C),$o),Uu),Uua)
    <=> ! [X3: B] : aa(C,$o,Uu,aa(B,C,Uua,X3)) ) ).

% ATP.lambda_492
tff(fact_6658_ATP_Olambda__493,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(B,option(C))] :
      ( aa(fun(B,option(C)),$o,aTP_Lamp_azv(fun(B,fun(C,$o)),fun(fun(B,option(C)),$o),Uu),Uua)
    <=> ! [X3: B,Y4: C] :
          ( ( aa(B,option(C),Uua,X3) = aa(C,option(C),some(C),Y4) )
         => aa(C,$o,aa(B,fun(C,$o),Uu,X3),Y4) ) ) ).

% ATP.lambda_493
tff(fact_6659_ATP_Olambda__494,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: product_prod(product_prod($o,B),product_prod($o,C))] :
      ( aa(product_prod(product_prod($o,B),product_prod($o,C)),$o,aTP_Lamp_bb(set(product_prod(B,C)),fun(product_prod(product_prod($o,B),product_prod($o,C)),$o),Uu),Uua)
    <=> ? [X3: B,Y4: C] :
          ( ( Uua = aa(product_prod($o,C),product_prod(product_prod($o,B),product_prod($o,C)),aa(product_prod($o,B),fun(product_prod($o,C),product_prod(product_prod($o,B),product_prod($o,C))),product_Pair(product_prod($o,B),product_prod($o,C)),aa(B,product_prod($o,B),aa($o,fun(B,product_prod($o,B)),product_Pair($o,B),$false),X3)),aa(C,product_prod($o,C),aa($o,fun(C,product_prod($o,C)),product_Pair($o,C),$false),Y4)) )
          & aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Y4)),Uu) ) ) ).

% ATP.lambda_494
tff(fact_6660_ATP_Olambda__495,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,option(C)),Uua: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aTP_Lamp_acv(fun(B,option(C)),fun(product_prod(B,C),$o),Uu),Uua)
    <=> ? [A6: B,B5: C] :
          ( ( Uua = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A6),B5) )
          & ( aa(B,option(C),Uu,A6) = aa(C,option(C),some(C),B5) ) ) ) ).

% ATP.lambda_495
tff(fact_6661_ATP_Olambda__496,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: product_prod(set(B),set(B))] :
      ( aa(product_prod(set(B),set(B)),$o,aTP_Lamp_aem(set(product_prod(B,B)),fun(product_prod(set(B),set(B)),$o),Uu),Uua)
    <=> ? [X7: set(B),Y7: set(B)] :
          ( ( Uua = aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),X7),Y7) )
          & ( X7 != bot_bot(set(B)) )
          & ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),Y7)
             => ? [Xa2: B] :
                  ( aa(set(B),$o,member(B,Xa2),X7)
                  & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa2),X3)),Uu) ) ) ) ) ).

% ATP.lambda_496
tff(fact_6662_ATP_Olambda__497,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))))),Uua: fun(B,heap_Time_Heap(C))] :
      ( aa(fun(B,heap_Time_Heap(C)),$o,aTP_Lamp_baw(fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))))),fun(fun(B,heap_Time_Heap(C)),$o),Uu),Uua)
    <=> ! [X3: B,H: heap_ext(product_unit),H7: heap_ext(product_unit),R6: C,N4: nat] :
          ( heap_Time_effect(C,aa(B,heap_Time_Heap(C),Uua,X3),H,H7,R6,N4)
         => aa(nat,$o,aa(C,fun(nat,$o),aa(heap_ext(product_unit),fun(C,fun(nat,$o)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o)))),Uu,X3),H),H7),R6),N4) ) ) ).

% ATP.lambda_497
tff(fact_6663_ATP_Olambda__498,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: B] : ( aa(B,set(C),aTP_Lamp_br(set(C),fun(B,set(C)),Uu),Uua) = aa(set(C),set(C),uminus_uminus(set(C)),Uu) ) ).

% ATP.lambda_498
tff(fact_6664_ATP_Olambda__499,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] : ( aa(B,set(B),aTP_Lamp_bi(set(B),fun(B,set(B)),Uu),Uua) = aa(set(B),set(B),uminus_uminus(set(B)),Uu) ) ).

% ATP.lambda_499
tff(fact_6665_ATP_Olambda__500,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B),Uua: array(B)] : ( aa(array(B),heap_Time_Heap(array(B)),aTP_Lamp_axg(array(B),fun(array(B),heap_Time_Heap(array(B))),Uu),Uua) = heap_Time_ureturn(array(B),Uu) ) ) ).

% ATP.lambda_500
tff(fact_6666_ATP_Olambda__501,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: B,Uua: product_unit] : ( aa(product_unit,heap_Time_Heap(B),aTP_Lamp_axm(B,fun(product_unit,heap_Time_Heap(B)),Uu),Uua) = aa(B,heap_Time_Heap(B),heap_Time_return(B),Uu) ) ) ).

% ATP.lambda_501
tff(fact_6667_ATP_Olambda__502,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] : ( aa(list(B),option(B),aa(B,fun(list(B),option(B)),aTP_Lamp_amn(B,fun(list(B),option(B))),Uu),Uua) = aa(B,option(B),some(B),Uu) ) ).

% ATP.lambda_502
tff(fact_6668_ATP_Olambda__503,axiom,
    ! [D: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: D] : ( aa(D,set(C),aTP_Lamp_agi(set(product_prod(C,C)),fun(D,set(C)),Uu),Uua) = field2(C,Uu) ) ).

% ATP.lambda_503
tff(fact_6669_ATP_Olambda__504,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: B] : ( aa(B,set(C),aTP_Lamp_ago(set(product_prod(C,C)),fun(B,set(C)),Uu),Uua) = field2(C,Uu) ) ).

% ATP.lambda_504
tff(fact_6670_ATP_Olambda__505,axiom,
    ! [D: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: D] : ( aa(D,set(B),aTP_Lamp_agh(set(product_prod(B,B)),fun(D,set(B)),Uu),Uua) = field2(B,Uu) ) ).

% ATP.lambda_505
tff(fact_6671_ATP_Olambda__506,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: C] : ( aa(C,set(B),aTP_Lamp_agn(set(product_prod(B,B)),fun(C,set(B)),Uu),Uua) = field2(B,Uu) ) ).

% ATP.lambda_506
tff(fact_6672_ATP_Olambda__507,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B] : ( aa(B,set(B),aTP_Lamp_ey(set(product_prod(B,B)),fun(B,set(B)),Uu),Uua) = field2(B,Uu) ) ).

% ATP.lambda_507
tff(fact_6673_ATP_Olambda__508,axiom,
    ! [B: $tType,C: $tType,Uu: list(C),Uua: B] : ( aa(B,set(C),aTP_Lamp_aih(list(C),fun(B,set(C)),Uu),Uua) = aa(list(C),set(C),set2(C),Uu) ) ).

% ATP.lambda_508
tff(fact_6674_ATP_Olambda__509,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,$o),Uua: B] : ( aa(B,set(C),aTP_Lamp_cw(fun(C,$o),fun(B,set(C)),Uu),Uua) = aa(fun(C,$o),set(C),collect(C),Uu) ) ).

% ATP.lambda_509
tff(fact_6675_ATP_Olambda__510,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] : ( aa(list(B),fun(set(B),set(B)),aa(B,fun(list(B),fun(set(B),set(B))),aTP_Lamp_aoo(B,fun(list(B),fun(set(B),set(B)))),Uu),Uua) = insert(B,Uu) ) ).

% ATP.lambda_510
tff(fact_6676_ATP_Olambda__511,axiom,
    ! [B: $tType,Uu: set(B),Uua: list(B)] : ( aa(list(B),set(list(B)),aTP_Lamp_anv(set(B),fun(list(B),set(list(B))),Uu),Uua) = lists(B,Uu) ) ).

% ATP.lambda_511
tff(fact_6677_ATP_Olambda__512,axiom,
    ! [B: $tType,Uu: nat,Uua: B] : ( aa(B,nat,aa(nat,fun(B,nat),aTP_Lamp_aic(nat,fun(B,nat)),Uu),Uua) = aa(nat,nat,suc,Uu) ) ).

% ATP.lambda_512
tff(fact_6678_ATP_Olambda__513,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: option(B),Uub: option(C)] :
      ( aa(option(C),$o,aa(option(B),fun(option(C),$o),aTP_Lamp_avh(fun(B,fun(C,$o)),fun(option(B),fun(option(C),$o)),Uu),Uua),Uub)
    <=> case_option($o,B,case_option($o,C,$true,aTP_Lamp_avf(C,$o),Uub),aa(option(C),fun(B,$o),aTP_Lamp_avg(fun(B,fun(C,$o)),fun(option(C),fun(B,$o)),Uu),Uub),Uua) ) ).

% ATP.lambda_513
tff(fact_6679_ATP_Olambda__514,axiom,
    ! [Uu: num,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_yq(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),aa(num,code_integer,numeral_numeral(code_integer),Uu)),Uub),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uub),aa(num,code_integer,numeral_numeral(code_integer),Uu))),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_514
tff(fact_6680_ATP_Olambda__515,axiom,
    ! [Uu: num,Uua: nat,Uub: nat] :
      ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_yo(num,fun(nat,fun(nat,product_prod(nat,nat))),Uu),Uua),Uub)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Uu)),Uub),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),Uu))),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_515
tff(fact_6681_ATP_Olambda__516,axiom,
    ! [Uu: num,Uua: int,Uub: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_yp(num,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),Uu)),Uub),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),Uub),aa(num,int,numeral_numeral(int),Uu))),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_516
tff(fact_6682_ATP_Olambda__517,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [Uu: num,Uua: B,Uub: B] :
          ( aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),aTP_Lamp_yn(num,fun(B,fun(B,product_prod(B,B))),Uu),Uua),Uub)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),Uu)),Uub),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Uua)),one_one(B))),aa(B,B,aa(B,fun(B,B),minus_minus(B),Uub),aa(num,B,numeral_numeral(B),Uu))),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Uua)),Uub)) ) ) ).

% ATP.lambda_517
tff(fact_6683_ATP_Olambda__518,axiom,
    ! [B: $tType,Uu: B,Uua: B,Uub: list(B)] :
      ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),aTP_Lamp_arr(B,fun(B,fun(list(B),list(B))),Uu),Uua),Uub)
      = $ite(Uu = Uua,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uua),Uub),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uu),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uua),Uub))) ) ).

% ATP.lambda_518
tff(fact_6684_ATP_Olambda__519,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(B,C),Uua: set(B),Uub: B] :
          ( aa(B,C,aa(set(B),fun(B,C),aTP_Lamp_pr(fun(B,C),fun(set(B),fun(B,C)),Uu),Uua),Uub)
          = $ite(aa(set(B),$o,member(B,Uub),Uua),aa(B,C,Uu,Uub),zero_zero(C)) ) ) ).

% ATP.lambda_519
tff(fact_6685_ATP_Olambda__520,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(B,C),Uua: set(B),Uub: B] :
          ( aa(B,C,aa(set(B),fun(B,C),aTP_Lamp_po(fun(B,C),fun(set(B),fun(B,C)),Uu),Uua),Uub)
          = $ite(aa(set(B),$o,member(B,Uub),Uua),aa(B,C,Uu,Uub),one_one(C)) ) ) ).

% ATP.lambda_520
tff(fact_6686_ATP_Olambda__521,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_ob(B,fun(fun(B,C),fun(B,C)),Uu),Uua),Uub)
          = $ite(Uu = Uub,aa(B,C,Uua,Uub),zero_zero(C)) ) ) ).

% ATP.lambda_521
tff(fact_6687_ATP_Olambda__522,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_od(B,fun(fun(B,C),fun(B,C)),Uu),Uua),Uub)
          = $ite(Uu = Uub,aa(B,C,Uua,Uub),one_one(C)) ) ) ).

% ATP.lambda_522
tff(fact_6688_ATP_Olambda__523,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_oa(B,fun(fun(B,C),fun(B,C)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(B,C,Uua,Uub),zero_zero(C)) ) ) ).

% ATP.lambda_523
tff(fact_6689_ATP_Olambda__524,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_oc(B,fun(fun(B,C),fun(B,C)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(B,C,Uua,Uub),one_one(C)) ) ) ).

% ATP.lambda_524
tff(fact_6690_ATP_Olambda__525,axiom,
    ! [B: $tType,Uu: B,Uua: fun(B,nat),Uub: B] :
      ( aa(B,nat,aa(fun(B,nat),fun(B,nat),aa(B,fun(fun(B,nat),fun(B,nat)),aTP_Lamp_apq(B,fun(fun(B,nat),fun(B,nat))),Uu),Uua),Uub)
      = $ite(Uub = Uu,aa(nat,nat,suc,aa(B,nat,Uua,Uub)),aa(B,nat,Uua,Uub)) ) ).

% ATP.lambda_525
tff(fact_6691_ATP_Olambda__526,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B,Uub: B] :
      ( aa(B,nat,aa(B,fun(B,nat),aTP_Lamp_aps(fun(B,nat),fun(B,fun(B,nat)),Uu),Uua),Uub)
      = $ite(Uub = Uua,aa(nat,nat,suc,aa(B,nat,Uu,Uub)),aa(B,nat,Uu,Uub)) ) ).

% ATP.lambda_526
tff(fact_6692_ATP_Olambda__527,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Uu: C,Uua: B,Uub: C] :
          ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_api(C,fun(B,fun(C,B)),Uu),Uua),Uub)
          = $ite(Uu = Uub,Uua,zero_zero(B)) ) ) ).

% ATP.lambda_527
tff(fact_6693_ATP_Olambda__528,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: C,Uua: B,Uub: C] :
          ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_aqp(C,fun(B,fun(C,B)),Uu),Uua),Uub)
          = $ite(Uu = Uub,Uua,one_one(B)) ) ) ).

% ATP.lambda_528
tff(fact_6694_ATP_Olambda__529,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Uu: C,Uua: B,Uub: C] :
          ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_apr(C,fun(B,fun(C,B)),Uu),Uua),Uub)
          = $ite(Uub = Uu,Uua,zero_zero(B)) ) ) ).

% ATP.lambda_529
tff(fact_6695_ATP_Olambda__530,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: C,Uua: B,Uub: C] :
          ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_aqq(C,fun(B,fun(C,B)),Uu),Uua),Uub)
          = $ite(Uub = Uu,Uua,one_one(B)) ) ) ).

% ATP.lambda_530
tff(fact_6696_ATP_Olambda__531,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zi(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_531
tff(fact_6697_ATP_Olambda__532,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zm(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,abs_abs(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_532
tff(fact_6698_ATP_Olambda__533,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_zh(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uu),Uub))) ) ).

% ATP.lambda_533
tff(fact_6699_ATP_Olambda__534,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: B,Uub: list(B)] :
      ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),aTP_Lamp_aja(fun(B,$o),fun(B,fun(list(B),list(B))),Uu),Uua),Uub)
      = $ite(aa(B,$o,Uu,Uua),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uua),Uub),Uub) ) ).

% ATP.lambda_534
tff(fact_6700_ATP_Olambda__535,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: B,Uub: set(B)] :
      ( aa(set(B),set(B),aa(B,fun(set(B),set(B)),aTP_Lamp_ky(fun(B,$o),fun(B,fun(set(B),set(B))),Uu),Uua),Uub)
      = $ite(aa(B,$o,Uu,Uua),aa(set(B),set(B),insert(B,Uua),Uub),Uub) ) ).

% ATP.lambda_535
tff(fact_6701_ATP_Olambda__536,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: fun(B,nat),Uub: B] :
      ( aa(B,nat,aa(fun(B,nat),fun(B,nat),aa(fun(B,$o),fun(fun(B,nat),fun(B,nat)),aTP_Lamp_apu(fun(B,$o),fun(fun(B,nat),fun(B,nat))),Uu),Uua),Uub)
      = $ite(aa(B,$o,Uu,Uub),aa(B,nat,Uua,Uub),zero_zero(nat)) ) ).

% ATP.lambda_536
tff(fact_6702_ATP_Olambda__537,axiom,
    ! [C: $tType,B: $tType] :
      ( monoid_add(B)
     => ! [Uu: fun(C,B),Uua: fun(C,$o),Uub: C] :
          ( aa(C,B,aa(fun(C,$o),fun(C,B),aTP_Lamp_ajz(fun(C,B),fun(fun(C,$o),fun(C,B)),Uu),Uua),Uub)
          = $ite(aa(C,$o,Uua,Uub),aa(C,B,Uu,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_537
tff(fact_6703_ATP_Olambda__538,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: fun(B,$o),Uub: B] :
      ( aa(B,nat,aa(fun(B,$o),fun(B,nat),aTP_Lamp_aqg(fun(B,nat),fun(fun(B,$o),fun(B,nat)),Uu),Uua),Uub)
      = $ite(aa(B,$o,Uua,Uub),aa(B,nat,Uu,Uub),zero_zero(nat)) ) ).

% ATP.lambda_538
tff(fact_6704_ATP_Olambda__539,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(B,C),Uua: fun(B,$o),Uub: B] :
          ( aa(B,C,aa(fun(B,$o),fun(B,C),aTP_Lamp_pg(fun(B,C),fun(fun(B,$o),fun(B,C)),Uu),Uua),Uub)
          = $ite(aa(B,$o,Uua,Uub),aa(B,C,Uu,Uub),zero_zero(C)) ) ) ).

% ATP.lambda_539
tff(fact_6705_ATP_Olambda__540,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(B,C),Uua: fun(B,$o),Uub: B] :
          ( aa(B,C,aa(fun(B,$o),fun(B,C),aTP_Lamp_pd(fun(B,C),fun(fun(B,$o),fun(B,C)),Uu),Uua),Uub)
          = $ite(aa(B,$o,Uua,Uub),aa(B,C,Uu,Uub),one_one(C)) ) ) ).

% ATP.lambda_540
tff(fact_6706_ATP_Olambda__541,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,fun(B,B)),Uua: fun(C,$o),Uub: C] :
      ( aa(C,fun(B,B),aa(fun(C,$o),fun(C,fun(B,B)),aTP_Lamp_aix(fun(C,fun(B,B)),fun(fun(C,$o),fun(C,fun(B,B))),Uu),Uua),Uub)
      = $ite(aa(C,$o,Uua,Uub),aa(C,fun(B,B),Uu,Uub),id(B)) ) ).

% ATP.lambda_541
tff(fact_6707_ATP_Olambda__542,axiom,
    ! [B: $tType,Uu: fun(heap_ext(product_unit),$o),Uua: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),Uub: heap_ext(product_unit)] :
      ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awt(fun(heap_ext(product_unit),$o),fun(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub)
      = $ite(aa(heap_ext(product_unit),$o,Uu,Uub),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Uua,Uub)),none(product_prod(B,product_prod(heap_ext(product_unit),nat)))) ) ).

% ATP.lambda_542
tff(fact_6708_ATP_Olambda__543,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,B),Uua: fun(C,$o),Uub: C] :
      ( aa(C,option(B),aa(fun(C,$o),fun(C,option(B)),aTP_Lamp_akj(fun(C,B),fun(fun(C,$o),fun(C,option(B))),Uu),Uua),Uub)
      = $ite(aa(C,$o,Uua,Uub),aa(B,option(B),some(B),aa(C,B,Uu,Uub)),none(B)) ) ).

% ATP.lambda_543
tff(fact_6709_ATP_Olambda__544,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: B,Uub: set(product_prod(B,C))] : ( aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(B,fun(set(product_prod(B,C)),set(product_prod(B,C))),aTP_Lamp_lr(set(C),fun(B,fun(set(product_prod(B,C)),set(product_prod(B,C)))),Uu),Uua),Uub) = finite_fold(C,set(product_prod(B,C)),aTP_Lamp_lq(B,fun(C,fun(set(product_prod(B,C)),set(product_prod(B,C)))),Uua),Uub,Uu) ) ).

% ATP.lambda_544
tff(fact_6710_ATP_Olambda__545,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: C,Uub: set(product_prod(C,B))] : ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(C,fun(set(product_prod(C,B)),set(product_prod(C,B))),aTP_Lamp_lm(set(B),fun(C,fun(set(product_prod(C,B)),set(product_prod(C,B)))),Uu),Uua),Uub) = finite_fold(B,set(product_prod(C,B)),aTP_Lamp_li(C,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),Uua),Uub,Uu) ) ).

% ATP.lambda_545
tff(fact_6711_ATP_Olambda__546,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,B)),Uua: option(B),Uub: B] : ( aa(B,option(B),aa(option(B),fun(B,option(B)),aTP_Lamp_aup(fun(B,fun(B,B)),fun(option(B),fun(B,option(B))),Uu),Uua),Uub) = case_option(option(B),B,aa(B,option(B),some(B),Uub),aa(B,fun(B,option(B)),aTP_Lamp_auo(fun(B,fun(B,B)),fun(B,fun(B,option(B))),Uu),Uub),Uua) ) ).

% ATP.lambda_546
tff(fact_6712_ATP_Olambda__547,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: list(B),Uub: list(B)] : ( aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),aTP_Lamp_ayb(fun(B,fun(B,$o)),fun(list(B),fun(list(B),list(B))),Uu),Uua),Uub) = merges9089515139780605204_merge(B,Uu,aa(list(B),list(B),mergesort_by_rel(B,Uu),Uua),aa(list(B),list(B),mergesort_by_rel(B,Uu),Uub)) ) ).

% ATP.lambda_547
tff(fact_6713_ATP_Olambda__548,axiom,
    ! [B: $tType] :
      ( sup(B)
     => ! [Uu: option(B),Uua: option(B),Uub: B] : ( aa(B,option(B),aa(option(B),fun(B,option(B)),aTP_Lamp_aae(option(B),fun(option(B),fun(B,option(B))),Uu),Uua),Uub) = case_option(option(B),B,Uu,aTP_Lamp_aad(B,fun(B,option(B)),Uub),Uua) ) ) ).

% ATP.lambda_548
tff(fact_6714_ATP_Olambda__549,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B),Uua: list(B),Uub: fun(typerep,fun(nat,list(nat)))] : ( aa(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat))),aa(list(B),fun(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat)))),aTP_Lamp_azr(array(B),fun(list(B),fun(fun(typerep,fun(nat,list(nat))),fun(typerep,fun(nat,list(nat))))),Uu),Uua),Uub) = fun_upd(typerep,fun(nat,list(nat)),Uub,typerep_typerep(B,type2(B)),fun_upd(nat,list(nat),aa(typerep,fun(nat,list(nat)),Uub,typerep_typerep(B,type2(B))),addr_of_array(B,Uu),aa(list(B),list(nat),map(B,nat,to_nat(B)),Uua))) ) ) ).

% ATP.lambda_549
tff(fact_6715_ATP_Olambda__550,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: ref(B),Uua: B,Uub: fun(typerep,fun(nat,nat))] : ( aa(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat)),aa(B,fun(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat))),aTP_Lamp_azs(ref(B),fun(B,fun(fun(typerep,fun(nat,nat)),fun(typerep,fun(nat,nat)))),Uu),Uua),Uub) = fun_upd(typerep,fun(nat,nat),Uub,typerep_typerep(B,type2(B)),fun_upd(nat,nat,aa(typerep,fun(nat,nat),Uub,typerep_typerep(B,type2(B))),addr_of_ref(B,Uu),aa(B,nat,to_nat(B),Uua))) ) ) ).

% ATP.lambda_550
tff(fact_6716_ATP_Olambda__551,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,option(C)),Uua: B,Uub: C] : ( aa(C,fun(B,option(C)),aa(B,fun(C,fun(B,option(C))),aTP_Lamp_arp(fun(B,option(C)),fun(B,fun(C,fun(B,option(C)))),Uu),Uua),Uub) = fun_upd(B,option(C),Uu,Uua,aa(C,option(C),some(C),Uub)) ) ).

% ATP.lambda_551
tff(fact_6717_ATP_Olambda__552,axiom,
    ! [B: $tType,C: $tType,Uu: B,Uua: C,Uub: fun(B,option(C))] : ( aa(fun(B,option(C)),fun(B,option(C)),aa(C,fun(fun(B,option(C)),fun(B,option(C))),aa(B,fun(C,fun(fun(B,option(C)),fun(B,option(C)))),aTP_Lamp_ama(B,fun(C,fun(fun(B,option(C)),fun(B,option(C))))),Uu),Uua),Uub) = fun_upd(B,option(C),Uub,Uu,aa(C,option(C),some(C),Uua)) ) ).

% ATP.lambda_552
tff(fact_6718_ATP_Olambda__553,axiom,
    ! [B: $tType,Uu: fun(B,B),Uua: B,Uub: nat] : ( aa(nat,B,aa(B,fun(nat,B),aTP_Lamp_agx(fun(B,B),fun(B,fun(nat,B)),Uu),Uua),Uub) = aa(B,B,compow(fun(B,B),Uub,Uu),Uua) ) ).

% ATP.lambda_553
tff(fact_6719_ATP_Olambda__554,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B),Uub: $o] :
      ( aa($o,set(B),aa(set(B),fun($o,set(B)),aTP_Lamp_fy(set(B),fun(set(B),fun($o,set(B))),Uu),Uua),Uub)
      = $ite((Uub),Uu,Uua) ) ).

% ATP.lambda_554
tff(fact_6720_ATP_Olambda__555,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,$o)),Uua: option(C),Uub: B] :
      ( aa(B,$o,aa(option(C),fun(B,$o),aTP_Lamp_avg(fun(B,fun(C,$o)),fun(option(C),fun(B,$o)),Uu),Uua),Uub)
    <=> case_option($o,C,$false,aa(B,fun(C,$o),Uu,Uub),Uua) ) ).

% ATP.lambda_555
tff(fact_6721_ATP_Olambda__556,axiom,
    ! [B: $tType,C: $tType,Uu: heap_Time_Heap(C),Uua: fun(C,heap_Time_Heap(B)),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(C,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_axk(heap_Time_Heap(C),fun(fun(C,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub) = case_option(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(C,product_prod(heap_ext(product_unit),nat)),none(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(C,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),product_case_prod(C,product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_axj(fun(C,heap_Time_Heap(B)),fun(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uua)),aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(C,Uu),Uub)) ) ).

% ATP.lambda_556
tff(fact_6722_ATP_Olambda__557,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,B)),Uua: fun(nat,B),Uub: nat] : ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aTP_Lamp_atc(fun(B,fun(B,B)),fun(fun(nat,B),fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),Uu,aa(nat,B,Uua,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub))),aa(nat,B,Uua,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub)))) ) ).

% ATP.lambda_557
tff(fact_6723_ATP_Olambda__558,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,Uu: fun(E,fun(C,D)),Uua: fun(B,E),Uub: product_prod(B,C)] : ( aa(product_prod(B,C),D,aa(fun(B,E),fun(product_prod(B,C),D),aTP_Lamp_dk(fun(E,fun(C,D)),fun(fun(B,E),fun(product_prod(B,C),D)),Uu),Uua),Uub) = aa(C,D,aa(E,fun(C,D),Uu,aa(B,E,Uua,aa(product_prod(B,C),B,product_fst(B,C),Uub))),aa(product_prod(B,C),C,product_snd(B,C),Uub)) ) ).

% ATP.lambda_558
tff(fact_6724_ATP_Olambda__559,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(D,fun(C,B)),Uua: fun(C,D),Uub: C] : ( aa(C,B,aa(fun(C,D),fun(C,B),aTP_Lamp_ix(fun(D,fun(C,B)),fun(fun(C,D),fun(C,B)),Uu),Uua),Uub) = aa(C,B,aa(D,fun(C,B),Uu,aa(C,D,Uua,Uub)),Uub) ) ) ).

% ATP.lambda_559
tff(fact_6725_ATP_Olambda__560,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_rf(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,aa(nat,fun(nat,B),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_560
tff(fact_6726_ATP_Olambda__561,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_rd(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,aa(nat,fun(nat,B),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_561
tff(fact_6727_ATP_Olambda__562,axiom,
    ! [B: $tType,Uu: fun(nat,fun(nat,B)),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_art(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,aa(nat,fun(nat,B),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ).

% ATP.lambda_562
tff(fact_6728_ATP_Olambda__563,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(B,C),Uub: B] :
      ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_nl(fun(B,fun(C,$o)),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(C,$o,aa(B,fun(C,$o),Uu,Uub),aa(B,C,Uua,Uub)) ) ).

% ATP.lambda_563
tff(fact_6729_ATP_Olambda__564,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_vd(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,aa(nat,fun(nat,B),Uu,Uub),Uua) ) ) ).

% ATP.lambda_564
tff(fact_6730_ATP_Olambda__565,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_va(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,aa(nat,fun(nat,B),Uu,Uub),Uua) ) ) ).

% ATP.lambda_565
tff(fact_6731_ATP_Olambda__566,axiom,
    ! [B: $tType,Uu: fun(nat,fun(nat,B)),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_asx(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,aa(nat,fun(nat,B),Uu,Uub),Uua) ) ).

% ATP.lambda_566
tff(fact_6732_ATP_Olambda__567,axiom,
    ! [B: $tType,C: $tType,Uu: fun(fun(C,B),fun(C,B)),Uua: C,Uub: fun(C,B)] : ( aa(fun(C,B),B,aa(C,fun(fun(C,B),B),aTP_Lamp_bak(fun(fun(C,B),fun(C,B)),fun(C,fun(fun(C,B),B)),Uu),Uua),Uub) = aa(C,B,aa(fun(C,B),fun(C,B),Uu,Uub),Uua) ) ).

% ATP.lambda_567
tff(fact_6733_ATP_Olambda__568,axiom,
    ! [C: $tType,B: $tType,Uu: fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),Uua: B,Uub: fun(B,heap_Time_Heap(C))] : ( aa(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aTP_Lamp_bat(fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),Uu),Uua),Uub) = aa(B,heap_Time_Heap(C),aa(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)),Uu,Uub),Uua) ) ).

% ATP.lambda_568
tff(fact_6734_ATP_Olambda__569,axiom,
    ! [C: $tType,B: $tType,Uu: fun(fun(B,option(C)),fun(B,option(C))),Uua: B,Uub: fun(B,option(C))] : ( aa(fun(B,option(C)),option(C),aa(B,fun(fun(B,option(C)),option(C)),aTP_Lamp_bae(fun(fun(B,option(C)),fun(B,option(C))),fun(B,fun(fun(B,option(C)),option(C))),Uu),Uua),Uub) = aa(B,option(C),aa(fun(B,option(C)),fun(B,option(C)),Uu,Uub),Uua) ) ).

% ATP.lambda_569
tff(fact_6735_ATP_Olambda__570,axiom,
    ! [C: $tType,B: $tType,Uu: fun(fun(B,C),fun(B,C)),Uua: B,Uub: fun(B,C)] : ( aa(fun(B,C),C,aa(B,fun(fun(B,C),C),aTP_Lamp_baf(fun(fun(B,C),fun(B,C)),fun(B,fun(fun(B,C),C)),Uu),Uua),Uub) = aa(B,C,aa(fun(B,C),fun(B,C),Uu,Uub),Uua) ) ).

% ATP.lambda_570
tff(fact_6736_ATP_Olambda__571,axiom,
    ! [D: $tType,E: $tType,C: $tType,B: $tType,Uu: fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),Uua: fun(B,heap_Time_Heap(C)),Uub: D] : ( aa(D,heap_Time_Heap(E),aa(fun(B,heap_Time_Heap(C)),fun(D,heap_Time_Heap(E)),aTP_Lamp_bau(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),fun(D,heap_Time_Heap(E))),Uu),Uua),Uub) = aa(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E),aa(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E)),Uu,Uub),Uua) ) ).

% ATP.lambda_571
tff(fact_6737_ATP_Olambda__572,axiom,
    ! [D: $tType,E: $tType,C: $tType,B: $tType,Uu: fun(D,fun(fun(B,option(C)),option(E))),Uua: fun(B,option(C)),Uub: D] : ( aa(D,option(E),aa(fun(B,option(C)),fun(D,option(E)),aTP_Lamp_bal(fun(D,fun(fun(B,option(C)),option(E))),fun(fun(B,option(C)),fun(D,option(E))),Uu),Uua),Uub) = aa(fun(B,option(C)),option(E),aa(D,fun(fun(B,option(C)),option(E)),Uu,Uub),Uua) ) ).

% ATP.lambda_572
tff(fact_6738_ATP_Olambda__573,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(D,fun(C,B)),Uua: C,Uub: D] : ( aa(D,B,aa(C,fun(D,B),aTP_Lamp_iv(fun(D,fun(C,B)),fun(C,fun(D,B)),Uu),Uua),Uub) = aa(C,B,aa(D,fun(C,B),Uu,Uub),Uua) ) ) ).

% ATP.lambda_573
tff(fact_6739_ATP_Olambda__574,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( complete_Sup(B)
     => ! [Uu: fun(D,fun(C,B)),Uua: C,Uub: D] : ( aa(D,B,aa(C,fun(D,B),aTP_Lamp_fe(fun(D,fun(C,B)),fun(C,fun(D,B)),Uu),Uua),Uub) = aa(C,B,aa(D,fun(C,B),Uu,Uub),Uua) ) ) ).

% ATP.lambda_574
tff(fact_6740_ATP_Olambda__575,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( complete_Inf(B)
     => ! [Uu: fun(D,fun(C,B)),Uua: C,Uub: D] : ( aa(D,B,aa(C,fun(D,B),aTP_Lamp_hy(fun(D,fun(C,B)),fun(C,fun(D,B)),Uu),Uua),Uub) = aa(C,B,aa(D,fun(C,B),Uu,Uub),Uua) ) ) ).

% ATP.lambda_575
tff(fact_6741_ATP_Olambda__576,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(D,fun(C,B)),Uua: C,Uub: D] : ( aa(D,B,aa(C,fun(D,B),aTP_Lamp_atf(fun(D,fun(C,B)),fun(C,fun(D,B)),Uu),Uua),Uub) = aa(C,B,aa(D,fun(C,B),Uu,Uub),Uua) ) ).

% ATP.lambda_576
tff(fact_6742_ATP_Olambda__577,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: D,Uub: C] : ( aa(C,B,aa(D,fun(C,B),aTP_Lamp_fu(fun(C,fun(D,B)),fun(D,fun(C,B)),Uu),Uua),Uub) = aa(D,B,aa(C,fun(D,B),Uu,Uub),Uua) ) ) ).

% ATP.lambda_577
tff(fact_6743_ATP_Olambda__578,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: D,Uub: C] : ( aa(C,B,aa(D,fun(C,B),aTP_Lamp_oi(fun(C,fun(D,B)),fun(D,fun(C,B)),Uu),Uua),Uub) = aa(D,B,aa(C,fun(D,B),Uu,Uub),Uua) ) ) ).

% ATP.lambda_578
tff(fact_6744_ATP_Olambda__579,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: D,Uub: C] : ( aa(C,B,aa(D,fun(C,B),aTP_Lamp_of(fun(C,fun(D,B)),fun(D,fun(C,B)),Uu),Uua),Uub) = aa(D,B,aa(C,fun(D,B),Uu,Uub),Uua) ) ) ).

% ATP.lambda_579
tff(fact_6745_ATP_Olambda__580,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(C,fun(D,B)),Uua: D,Uub: C] : ( aa(C,B,aa(D,fun(C,B),aTP_Lamp_ary(fun(C,fun(D,B)),fun(D,fun(C,B)),Uu),Uua),Uub) = aa(D,B,aa(C,fun(D,B),Uu,Uub),Uua) ) ).

% ATP.lambda_580
tff(fact_6746_ATP_Olambda__581,axiom,
    ! [C: $tType,B: $tType] :
      ( finite_finite(B)
     => ! [Uu: fun(C,fun(B,$o)),Uua: B,Uub: C] :
          ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_afg(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(C,fun(B,$o),Uu,Uub),Uua) ) ) ).

% ATP.lambda_581
tff(fact_6747_ATP_Olambda__582,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,fun(B,$o)),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_km(fun(C,fun(B,$o)),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,aa(C,fun(B,$o),Uu,Uub),Uua) ) ).

% ATP.lambda_582
tff(fact_6748_ATP_Olambda__583,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(C,fun(B,D)),Uua: B,Uub: C] : ( aa(C,D,aa(B,fun(C,D),aTP_Lamp_azp(fun(C,fun(B,D)),fun(B,fun(C,D)),Uu),Uua),Uub) = aa(B,D,aa(C,fun(B,D),Uu,Uub),Uua) ) ).

% ATP.lambda_583
tff(fact_6749_ATP_Olambda__584,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,fun(B,B)),Uua: B,Uub: C] : ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_all(fun(C,fun(B,B)),fun(B,fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(C,fun(B,B),Uu,Uub),Uua) ) ).

% ATP.lambda_584
tff(fact_6750_ATP_Olambda__585,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,$o)),Uua: C,Uub: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_gw(fun(B,fun(C,$o)),fun(C,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(C,$o,aa(B,fun(C,$o),Uu,Uub),Uua) ) ).

% ATP.lambda_585
tff(fact_6751_ATP_Olambda__586,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_mult(D)
     => ! [Uu: fun(B,fun(C,D)),Uua: C,Uub: B] : ( aa(B,D,aa(C,fun(B,D),aTP_Lamp_on(fun(B,fun(C,D)),fun(C,fun(B,D)),Uu),Uua),Uub) = aa(C,D,aa(B,fun(C,D),Uu,Uub),Uua) ) ) ).

% ATP.lambda_586
tff(fact_6752_ATP_Olambda__587,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_add(D)
     => ! [Uu: fun(B,fun(C,D)),Uua: C,Uub: B] : ( aa(B,D,aa(C,fun(B,D),aTP_Lamp_ow(fun(B,fun(C,D)),fun(C,fun(B,D)),Uu),Uua),Uub) = aa(C,D,aa(B,fun(C,D),Uu,Uub),Uua) ) ) ).

% ATP.lambda_587
tff(fact_6753_ATP_Olambda__588,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,C)),Uua: C,Uub: B] : ( aa(B,C,aa(C,fun(B,C),aTP_Lamp_aid(fun(B,fun(C,C)),fun(C,fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(B,fun(C,C),Uu,Uub),Uua) ) ).

% ATP.lambda_588
tff(fact_6754_ATP_Olambda__589,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,B)),Uua: C,Uub: B] : ( aa(B,B,aa(C,fun(B,B),aTP_Lamp_alm(fun(B,fun(C,B)),fun(C,fun(B,B)),Uu),Uua),Uub) = aa(C,B,aa(B,fun(C,B),Uu,Uub),Uua) ) ).

% ATP.lambda_589
tff(fact_6755_ATP_Olambda__590,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_alk(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,aa(B,fun(B,$o),Uu,Uub),Uua) ) ).

% ATP.lambda_590
tff(fact_6756_ATP_Olambda__591,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,$o),aa(code_integer,fun(code_integer,product_prod(code_integer,$o)),aTP_Lamp_zl(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),Uu),Uua),Uub)
      = aa($o,product_prod(code_integer,$o),
          aa(code_integer,fun($o,product_prod(code_integer,$o)),product_Pair(code_integer,$o),$ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),Uu),Uua,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),Uub))),
          ( Uub = one_one(code_integer) )) ) ).

% ATP.lambda_591
tff(fact_6757_ATP_Olambda__592,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: set(set(B)),Uub: set(set(B))] :
      ( aa(set(set(B)),$o,aa(set(set(B)),fun(set(set(B)),$o),aTP_Lamp_ags(set(set(B)),fun(set(set(B)),fun(set(set(B)),$o)),Uu),Uua),Uub)
    <=> ( aa(set(set(B)),$o,pred_chain(set(B),Uu,ord_less(set(B))),Uub)
        & aa(set(set(B)),$o,aa(set(set(B)),fun(set(set(B)),$o),ord_less(set(set(B))),Uua),Uub) ) ) ).

% ATP.lambda_592
tff(fact_6758_ATP_Olambda__593,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_eu(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,aa(B,fun(B,$o),Uu,Uua),Uub)
        | ( Uua = Uub ) ) ) ).

% ATP.lambda_593
tff(fact_6759_ATP_Olambda__594,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_ve(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(nat,fun(nat,B),aTP_Lamp_vd(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uub)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_594
tff(fact_6760_ATP_Olambda__595,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,fun(nat,B)),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_vb(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_va(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uu),Uub)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_595
tff(fact_6761_ATP_Olambda__596,axiom,
    ! [Uu: product_prod(code_natural,code_natural),Uua: code_natural,Uub: code_natural] : ( aa(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aTP_Lamp_axv(product_prod(code_natural,code_natural),fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),Uu),Uua),Uub) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_case_prod(code_natural,code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aa(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),aTP_Lamp_axu(code_natural,fun(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))))),Uua),Uub)),aa(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(code_natural,code_natural),product_snd(code_natural,product_prod(code_natural,code_natural)),aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,Uu))) ) ).

% ATP.lambda_596
tff(fact_6762_ATP_Olambda__597,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aay(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aax(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_597
tff(fact_6763_ATP_Olambda__598,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aaw(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aav(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_598
tff(fact_6764_ATP_Olambda__599,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aat(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aas(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_599
tff(fact_6765_ATP_Olambda__600,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aar(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aaq(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_600
tff(fact_6766_ATP_Olambda__601,axiom,
    ! [Uu: rat,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_aan(rat,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> aa(product_prod(int,int),$o,aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aa(int,fun(int,fun(int,$o)),aTP_Lamp_aam(int,fun(int,fun(int,fun(int,$o))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_601
tff(fact_6767_ATP_Olambda__602,axiom,
    ! [Uu: rat,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_aal(rat,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> aa(product_prod(int,int),$o,aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aa(int,fun(int,fun(int,$o)),aTP_Lamp_aak(int,fun(int,fun(int,fun(int,$o))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_602
tff(fact_6768_ATP_Olambda__603,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: set(C),Uub: D] : ( aa(D,B,aa(set(C),fun(D,B),aTP_Lamp_oj(fun(C,fun(D,B)),fun(set(C),fun(D,B)),Uu),Uua),Uub) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aa(D,fun(C,B),aTP_Lamp_oi(fun(C,fun(D,B)),fun(D,fun(C,B)),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_603
tff(fact_6769_ATP_Olambda__604,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: set(C),Uub: D] : ( aa(D,B,aa(set(C),fun(D,B),aTP_Lamp_og(fun(C,fun(D,B)),fun(set(C),fun(D,B)),Uu),Uua),Uub) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(D,fun(C,B),aTP_Lamp_of(fun(C,fun(D,B)),fun(D,fun(C,B)),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_604
tff(fact_6770_ATP_Olambda__605,axiom,
    ! [E: $tType,F10: $tType,B: $tType,D: $tType,C: $tType,Uu: fun(C,fun(D,fun(E,fun(F10,set(B))))),Uua: product_prod(C,D),Uub: product_prod(E,F10)] : ( aa(product_prod(E,F10),set(B),aa(product_prod(C,D),fun(product_prod(E,F10),set(B)),aTP_Lamp_hr(fun(C,fun(D,fun(E,fun(F10,set(B))))),fun(product_prod(C,D),fun(product_prod(E,F10),set(B))),Uu),Uua),Uub) = aa(product_prod(C,D),set(B),aa(fun(C,fun(D,set(B))),fun(product_prod(C,D),set(B)),product_case_prod(C,D,set(B)),aa(product_prod(E,F10),fun(C,fun(D,set(B))),aTP_Lamp_hq(fun(C,fun(D,fun(E,fun(F10,set(B))))),fun(product_prod(E,F10),fun(C,fun(D,set(B)))),Uu),Uub)),Uua) ) ).

% ATP.lambda_605
tff(fact_6771_ATP_Olambda__606,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: filter(C),Uub: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(filter(C),fun(fun(B,$o),$o),aTP_Lamp_afb(fun(C,B),fun(filter(C),fun(fun(B,$o),$o)),Uu),Uua),Uub)
    <=> eventually(C,aa(fun(B,$o),fun(C,$o),aTP_Lamp_afa(fun(C,B),fun(fun(B,$o),fun(C,$o)),Uu),Uub),Uua) ) ).

% ATP.lambda_606
tff(fact_6772_ATP_Olambda__607,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B),Uua: nat,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(nat,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avz(array(B),fun(nat,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),aa(nat,B,nth(B,array_get(B,Uub,Uu)),Uua)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),one_one(nat))) ) ) ).

% ATP.lambda_607
tff(fact_6773_ATP_Olambda__608,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Uu: fun(nat,B),Uua: fun(nat,B),Uub: nat] : ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aTP_Lamp_rn(fun(nat,B),fun(fun(nat,B),fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uu,Uub)),aa(nat,B,aa(B,fun(nat,B),power_power(B),zero_zero(B)),Uub))),aa(nat,B,Uua,Uub)) ) ) ).

% ATP.lambda_608
tff(fact_6774_ATP_Olambda__609,axiom,
    ! [B: $tType,Uu: fun(set(B),set(B)),Uua: set(B),Uub: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),aTP_Lamp_nf(fun(set(B),set(B)),fun(set(B),fun(set(B),set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),Uu,Uub)),Uua)),complete_lattice_gfp(set(B),Uu)) ) ).

% ATP.lambda_609
tff(fact_6775_ATP_Olambda__610,axiom,
    ! [B: $tType,Uu: set(B),Uua: fun(set(B),set(B)),Uub: set(B)] : ( aa(set(B),set(B),aa(fun(set(B),set(B)),fun(set(B),set(B)),aTP_Lamp_nd(set(B),fun(fun(set(B),set(B)),fun(set(B),set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),Uua,Uub)),Uu)),complete_lattice_gfp(set(B),Uua)) ) ).

% ATP.lambda_610
tff(fact_6776_ATP_Olambda__611,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_akg(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),one_one(nat)) )
        & ( aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_611
tff(fact_6777_ATP_Olambda__612,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Uu: fun(B,fun(D,$o)),Uua: fun(C,fun(E,$o)),Uub: product_prod(product_prod(B,D),product_prod(C,E))] :
      ( aa(product_prod(product_prod(B,D),product_prod(C,E)),$o,aa(fun(C,fun(E,$o)),fun(product_prod(product_prod(B,D),product_prod(C,E)),$o),aTP_Lamp_arb(fun(B,fun(D,$o)),fun(fun(C,fun(E,$o)),fun(product_prod(product_prod(B,D),product_prod(C,E)),$o)),Uu),Uua),Uub)
    <=> ( aa(set(product_prod(B,D)),$o,aa(set(product_prod(B,D)),fun(set(product_prod(B,D)),$o),ord_less_eq(set(product_prod(B,D))),aa(product_prod(product_prod(B,D),product_prod(C,E)),set(product_prod(B,D)),basic_fsts(product_prod(B,D),product_prod(C,E)),Uub)),aa(fun(product_prod(B,D),$o),set(product_prod(B,D)),collect(product_prod(B,D)),aa(fun(B,fun(D,$o)),fun(product_prod(B,D),$o),product_case_prod(B,D,$o),Uu)))
        & aa(set(product_prod(C,E)),$o,aa(set(product_prod(C,E)),fun(set(product_prod(C,E)),$o),ord_less_eq(set(product_prod(C,E))),basic_snds(product_prod(B,D),product_prod(C,E),Uub)),aa(fun(product_prod(C,E),$o),set(product_prod(C,E)),collect(product_prod(C,E)),aa(fun(C,fun(E,$o)),fun(product_prod(C,E),$o),product_case_prod(C,E,$o),Uua))) ) ) ).

% ATP.lambda_612
tff(fact_6778_ATP_Olambda__613,axiom,
    ! [B: $tType,C: $tType,E: $tType,D: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(D,fun(E,$o)),Uub: product_prod(product_prod(B,C),product_prod(D,E))] :
      ( aa(product_prod(product_prod(B,C),product_prod(D,E)),$o,aa(fun(D,fun(E,$o)),fun(product_prod(product_prod(B,C),product_prod(D,E)),$o),aTP_Lamp_aop(fun(B,fun(C,$o)),fun(fun(D,fun(E,$o)),fun(product_prod(product_prod(B,C),product_prod(D,E)),$o)),Uu),Uua),Uub)
    <=> ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),aa(product_prod(product_prod(B,C),product_prod(D,E)),set(product_prod(B,C)),basic_fsts(product_prod(B,C),product_prod(D,E)),Uub)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Uu)))
        & aa(set(product_prod(D,E)),$o,aa(set(product_prod(D,E)),fun(set(product_prod(D,E)),$o),ord_less_eq(set(product_prod(D,E))),basic_snds(product_prod(B,C),product_prod(D,E),Uub)),aa(fun(product_prod(D,E),$o),set(product_prod(D,E)),collect(product_prod(D,E)),aa(fun(D,fun(E,$o)),fun(product_prod(D,E),$o),product_case_prod(D,E,$o),Uua))) ) ) ).

% ATP.lambda_613
tff(fact_6779_ATP_Olambda__614,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: list(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_anh(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(B),nat,size_size(list(B)),Uua)),aa(list(B),nat,size_size(list(B)),Uub))
        | ( ( aa(list(B),nat,size_size(list(B)),Uua) = aa(list(B),nat,size_size(list(B)),Uub) )
          & aa(set(product_prod(list(B),list(B))),$o,member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Uua),Uub)),lex(B,Uu)) ) ) ) ).

% ATP.lambda_614
tff(fact_6780_ATP_Olambda__615,axiom,
    ! [B: $tType,Uu: nat,Uua: list(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_ano(nat,fun(list(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(B),nat,size_size(list(B)),Uua) = aa(nat,nat,suc,Uu) )
        & ( aa(list(B),nat,size_size(list(B)),Uub) = aa(nat,nat,suc,Uu) ) ) ) ).

% ATP.lambda_615
tff(fact_6781_ATP_Olambda__616,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: list(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_ane(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(B),nat,size_size(list(B)),Uua) = aa(list(B),nat,size_size(list(B)),Uub) )
        & ? [Xys2: list(B),X3: B,Y4: B,Xs4: list(B),Ys4: list(B)] :
            ( ( Uua = append(B,Xys2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X3),Xs4)) )
            & ( Uub = append(B,Xys2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y4),Ys4)) )
            & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Y4)),Uu) ) ) ) ).

% ATP.lambda_616
tff(fact_6782_ATP_Olambda__617,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_akh(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub)),one_one(nat)) = Uua ) ) ) ).

% ATP.lambda_617
tff(fact_6783_ATP_Olambda__618,axiom,
    ! [B: $tType,Uu: nat,Uua: set(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(set(B),fun(list(B),$o),aTP_Lamp_ahy(nat,fun(set(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(B),nat,size_size(list(B)),Uub) = Uu )
        & distinct(B,Uub)
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Uub)),Uua) ) ) ).

% ATP.lambda_618
tff(fact_6784_ATP_Olambda__619,axiom,
    ! [B: $tType,Uu: set(B),Uua: nat,Uub: list(B)] :
      ( aa(list(B),$o,aa(nat,fun(list(B),$o),aTP_Lamp_ahx(set(B),fun(nat,fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(B),nat,size_size(list(B)),Uub) = Uua )
        & distinct(B,Uub)
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Uub)),Uu) ) ) ).

% ATP.lambda_619
tff(fact_6785_ATP_Olambda__620,axiom,
    ! [B: $tType,Uu: set(B),Uua: nat,Uub: list(B)] :
      ( aa(list(B),$o,aa(nat,fun(list(B),$o),aTP_Lamp_air(set(B),fun(nat,fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Uub)),Uu)
        & ( aa(list(B),nat,size_size(list(B)),Uub) = aa(nat,nat,suc,Uua) ) ) ) ).

% ATP.lambda_620
tff(fact_6786_ATP_Olambda__621,axiom,
    ! [B: $tType,Uu: nat,Uua: list(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_aig(nat,fun(list(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(B),nat,size_size(list(B)),Uub) = Uu )
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Uub)),aa(list(B),set(B),set2(B),Uua)) ) ) ).

% ATP.lambda_621
tff(fact_6787_ATP_Olambda__622,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: set(C),Uub: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(set(C),fun(product_prod(B,C),$o),aTP_Lamp_ard(set(B),fun(set(C),fun(product_prod(B,C),$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(product_prod(B,C),set(B),basic_fsts(B,C),Uub)),Uu)
        & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),basic_snds(B,C,Uub)),Uua) ) ) ).

% ATP.lambda_622
tff(fact_6788_ATP_Olambda__623,axiom,
    ! [B: $tType,Uu: set(B),Uua: nat,Uub: list(B)] :
      ( aa(list(B),$o,aa(nat,fun(list(B),$o),aTP_Lamp_ahu(set(B),fun(nat,fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Uub)),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(B),nat,size_size(list(B)),Uub)),Uua) ) ) ).

% ATP.lambda_623
tff(fact_6789_ATP_Olambda__624,axiom,
    ! [B: $tType,Uu: set(B),Uua: nat,Uub: list(B)] :
      ( aa(list(B),$o,aa(nat,fun(list(B),$o),aTP_Lamp_ahw(set(B),fun(nat,fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Uub)),Uu)
        & ( aa(list(B),nat,size_size(list(B)),Uub) = Uua ) ) ) ).

% ATP.lambda_624
tff(fact_6790_ATP_Olambda__625,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_akf(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_625
tff(fact_6791_ATP_Olambda__626,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: set(C),Uub: fun(B,option(C))] :
      ( aa(fun(B,option(C)),$o,aa(set(C),fun(fun(B,option(C)),$o),aTP_Lamp_act(set(B),fun(set(C),fun(fun(B,option(C)),$o)),Uu),Uua),Uub)
    <=> ( ( dom(B,C,Uub) = Uu )
        & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),ran(B,C,Uub)),Uua) ) ) ).

% ATP.lambda_626
tff(fact_6792_ATP_Olambda__627,axiom,
    ! [Uu: heap_ext(product_unit),Uua: heap_ext(product_unit),Uub: nat] :
      ( aa(nat,$o,aa(heap_ext(product_unit),fun(nat,$o),aTP_Lamp_avm(heap_ext(product_unit),fun(heap_ext(product_unit),fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),lim(product_unit,Uu)),Uub)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),lim(product_unit,Uua)) ) ) ).

% ATP.lambda_627
tff(fact_6793_ATP_Olambda__628,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_tm(set(nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(set(nat),$o,member(nat,aa(nat,nat,suc,Uub)),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),Uua) ) ) ).

% ATP.lambda_628
tff(fact_6794_ATP_Olambda__629,axiom,
    ! [B: $tType,Uu: set(nat),Uua: nat,Uub: product_prod(B,nat)] :
      ( aa(product_prod(B,nat),$o,aa(nat,fun(product_prod(B,nat),$o),aTP_Lamp_alo(set(nat),fun(nat,fun(product_prod(B,nat),$o)),Uu),Uua),Uub)
    <=> aa(set(nat),$o,member(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(product_prod(B,nat),nat,product_snd(B,nat),Uub)),Uua)),Uu) ) ).

% ATP.lambda_629
tff(fact_6795_ATP_Olambda__630,axiom,
    ! [B: $tType,Uu: set(list(B)),Uua: list(B),Uub: B] :
      ( aa(B,$o,aa(list(B),fun(B,$o),aTP_Lamp_anm(set(list(B)),fun(list(B),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(list(B)),$o,member(list(B),append(B,Uua,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),nil(B)))),Uu) ) ).

% ATP.lambda_630
tff(fact_6796_ATP_Olambda__631,axiom,
    ! [Uu: nat,Uua: nat,Uub: set(nat)] :
      ( aa(set(nat),$o,aa(nat,fun(set(nat),$o),aTP_Lamp_wc(nat,fun(nat,fun(set(nat),$o)),Uu),Uua),Uub)
    <=> ( aa(set(set(nat)),$o,member(set(nat),Uub),pow(nat,set_or7035219750837199246ssThan(nat,zero_zero(nat),Uu)))
        & ( aa(set(nat),nat,finite_card(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_631
tff(fact_6797_ATP_Olambda__632,axiom,
    ! [B: $tType,Uu: list(B),Uua: set(nat),Uub: nat] :
      ( aa(nat,$o,aa(set(nat),fun(nat,$o),aTP_Lamp_aki(list(B),fun(set(nat),fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),aa(list(B),nat,size_size(list(B)),Uu))
        & aa(set(nat),$o,member(nat,Uub),Uua) ) ) ).

% ATP.lambda_632
tff(fact_6798_ATP_Olambda__633,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: list(B),Uub: nat] :
      ( aa(nat,$o,aa(list(B),fun(nat,$o),aTP_Lamp_ajg(fun(B,$o),fun(list(B),fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),aa(list(B),nat,size_size(list(B)),Uua))
        & aa(B,$o,Uu,aa(nat,B,nth(B,Uua),Uub)) ) ) ).

% ATP.lambda_633
tff(fact_6799_ATP_Olambda__634,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: multiset(B),Uub: B] :
      ( aa(B,$o,aa(multiset(B),fun(B,$o),aTP_Lamp_aqh(fun(B,$o),fun(multiset(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),aa(multiset(B),set(B),set_mset(B),Uua))
        & aa(B,$o,Uu,Uub) ) ) ).

% ATP.lambda_634
tff(fact_6800_ATP_Olambda__635,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: list(B),Uua: fun(B,$o),Uub: B] :
          ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_als(list(B),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(set(B),$o,member(B,Uub),aa(list(B),set(B),set2(B),Uu))
            & aa(B,$o,Uua,Uub) ) ) ) ).

% ATP.lambda_635
tff(fact_6801_ATP_Olambda__636,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: list(B),Uub: B] :
      ( aa(B,$o,aa(list(B),fun(B,$o),aTP_Lamp_aik(fun(B,$o),fun(list(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),aa(list(B),set(B),set2(B),Uua))
        & aa(B,$o,Uu,Uub) ) ) ).

% ATP.lambda_636
tff(fact_6802_ATP_Olambda__637,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,option(C)),Uua: B,Uub: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(B,fun(product_prod(B,C),$o),aTP_Lamp_acw(fun(B,option(C)),fun(B,fun(product_prod(B,C),$o)),Uu),Uua),Uub)
    <=> ( aa(set(product_prod(B,C)),$o,member(product_prod(B,C),Uub),graph(B,C,Uu))
        & ( aa(product_prod(B,C),B,product_fst(B,C),Uub) != Uua ) ) ) ).

% ATP.lambda_637
tff(fact_6803_ATP_Olambda__638,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_vz(B,fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Uu),aa(nat,B,semiring_1_of_nat(B),Uub))),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_638
tff(fact_6804_ATP_Olambda__639,axiom,
    ! [Uu: heap_ext(product_unit),Uua: set(nat),Uub: nat] :
      ( aa(nat,$o,aa(set(nat),fun(nat,$o),aTP_Lamp_avn(heap_ext(product_unit),fun(set(nat),fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),lim(product_unit,Uu))
        & ~ aa(set(nat),$o,member(nat,Uub),Uua) ) ) ).

% ATP.lambda_639
tff(fact_6805_ATP_Olambda__640,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_aeg(set(product_prod(B,B)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),field2(B,Uu))
        & ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),Uua)
           => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),X3)),Uu) ) ) ) ).

% ATP.lambda_640
tff(fact_6806_ATP_Olambda__641,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_aei(set(product_prod(B,B)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),field2(B,Uu))
        & ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),Uua)
           => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Uub)),Uu) ) ) ) ).

% ATP.lambda_641
tff(fact_6807_ATP_Olambda__642,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_aeh(set(product_prod(B,B)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),field2(B,Uu))
        & ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),Uua)
           => ( ( Uub != X3 )
              & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),X3)),Uu) ) ) ) ) ).

% ATP.lambda_642
tff(fact_6808_ATP_Olambda__643,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_aen(set(product_prod(B,B)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),field2(B,Uu))
        & ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),Uua)
           => ( ( Uub != X3 )
              & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Uub)),Uu) ) ) ) ) ).

% ATP.lambda_643
tff(fact_6809_ATP_Olambda__644,axiom,
    ! [B: $tType,Uu: list(B),Uua: set(nat),Uub: nat] :
      ( aa(nat,$o,aa(set(nat),fun(nat,$o),aTP_Lamp_amy(list(B),fun(set(nat),fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(set(nat),$o,member(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),aa(list(B),nat,size_size(list(B)),Uu))),Uua) ) ).

% ATP.lambda_644
tff(fact_6810_ATP_Olambda__645,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_tp(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uua),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),Uub) ) ) ).

% ATP.lambda_645
tff(fact_6811_ATP_Olambda__646,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Uu: set(B),Uua: nat,Uub: B] :
          ( aa(B,$o,aa(nat,fun(B,$o),aTP_Lamp_xm(set(B),fun(nat,fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(set(B),$o,member(B,Uub),Uu)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),infini527867602293511546merate(B,Uu,Uua)),Uub) ) ) ) ).

% ATP.lambda_646
tff(fact_6812_ATP_Olambda__647,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_acx(set(B),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(set(B),$o,member(B,Uub),Uu)
            & ( aa(B,C,Uua,Uub) = aa(set(C),C,lattic643756798350308766er_Min(C),aa(set(B),set(C),image2(B,C,Uua),Uu)) ) ) ) ) ).

% ATP.lambda_647
tff(fact_6813_ATP_Olambda__648,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),aTP_Lamp_afn(set(product_prod(B,B)),fun(set(B),fun(set(B),$o)),Uu),Uua),Uub)
    <=> ( order_ofilter(B,Uu,Uua)
        & ( Uua != field2(B,Uu) )
        & order_ofilter(B,Uu,Uub)
        & ( Uub != field2(B,Uu) )
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),Uua),Uub) ) ) ).

% ATP.lambda_648
tff(fact_6814_ATP_Olambda__649,axiom,
    ! [Uu: set(nat),Uua: set(nat),Uub: nat] :
      ( aa(nat,$o,aa(set(nat),fun(nat,$o),aTP_Lamp_akc(set(nat),fun(set(nat),fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(set(nat),$o,member(nat,Uub),Uu)
        & aa(set(nat),$o,member(nat,aa(set(nat),nat,finite_card(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_akb(set(nat),fun(nat,fun(nat,$o)),Uu),Uub)))),Uua) ) ) ).

% ATP.lambda_649
tff(fact_6815_ATP_Olambda__650,axiom,
    ! [B: $tType,Uu: set(B),Uua: nat,Uub: set(B)] :
      ( aa(set(B),$o,aa(nat,fun(set(B),$o),aTP_Lamp_ul(set(B),fun(nat,fun(set(B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),Uub),Uu)
        & ( aa(set(B),nat,finite_card(B),Uub) = Uua ) ) ) ).

% ATP.lambda_650
tff(fact_6816_ATP_Olambda__651,axiom,
    ! [B: $tType,C: $tType,Uu: nat,Uua: set(old_node(B,C)),Uub: old_node(B,C)] :
      ( aa(old_node(B,C),$o,aa(set(old_node(B,C)),fun(old_node(B,C),$o),aTP_Lamp_ayv(nat,fun(set(old_node(B,C)),fun(old_node(B,C),$o)),Uu),Uua),Uub)
    <=> ( aa(set(old_node(B,C)),$o,member(old_node(B,C),Uub),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),old_ndepth(B,C,Uub)),Uu) ) ) ).

% ATP.lambda_651
tff(fact_6817_ATP_Olambda__652,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_tn(set(nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(set(nat),$o,member(nat,Uub),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_652
tff(fact_6818_ATP_Olambda__653,axiom,
    ! [B: $tType,Uu: multiset(B),Uua: multiset(B),Uub: B] :
      ( aa(B,$o,aa(multiset(B),fun(B,$o),aTP_Lamp_aoz(multiset(B),fun(multiset(B),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),Uua),Uub)),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),Uu),Uub)) ) ).

% ATP.lambda_653
tff(fact_6819_ATP_Olambda__654,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(B,B)),Uub: fun(C,B)] : ( aa(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C))))),aTP_Lamp_aur(set(product_prod(B,B)),fun(set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))))),Uu),Uua),Uub) = aa(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),fun(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))),product_Pair(set(product_prod(C,C)),set(product_prod(C,C))),inv_image(B,C,Uu,Uub)),inv_image(B,C,Uua,Uub)) ) ).

% ATP.lambda_654
tff(fact_6820_ATP_Olambda__655,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_ui(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub)) ) ).

% ATP.lambda_655
tff(fact_6821_ATP_Olambda__656,axiom,
    ! [Uu: assn,Uua: assn,Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_ba(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Uu),Uua),Uub)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Uu),Uub)
        | aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Uua),Uub) ) ) ).

% ATP.lambda_656
tff(fact_6822_ATP_Olambda__657,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_av(set(B),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),Uu)
        | aa(set(B),$o,member(B,Uub),Uua) ) ) ).

% ATP.lambda_657
tff(fact_6823_ATP_Olambda__658,axiom,
    ! [B: $tType,Uu: B,Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_de(B,fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uub = Uu )
        | aa(set(B),$o,member(B,Uub),Uua) ) ) ).

% ATP.lambda_658
tff(fact_6824_ATP_Olambda__659,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_vt(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uua)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uua),Uub) ) ) ).

% ATP.lambda_659
tff(fact_6825_ATP_Olambda__660,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_tg(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uub),Uua) ) ) ).

% ATP.lambda_660
tff(fact_6826_ATP_Olambda__661,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_vu(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uua),Uub) ) ) ).

% ATP.lambda_661
tff(fact_6827_ATP_Olambda__662,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_ub(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uub),Uua) ) ) ).

% ATP.lambda_662
tff(fact_6828_ATP_Olambda__663,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_uc(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uub),Uua) ) ) ).

% ATP.lambda_663
tff(fact_6829_ATP_Olambda__664,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_ua(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uub),Uua) ) ) ).

% ATP.lambda_664
tff(fact_6830_ATP_Olambda__665,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B),Uub: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),aTP_Lamp_uh(set(B),fun(set(B),fun(set(B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),Uua),Uub)
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),Uub),Uu) ) ) ).

% ATP.lambda_665
tff(fact_6831_ATP_Olambda__666,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B),Uub: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),aTP_Lamp_ug(set(B),fun(set(B),fun(set(B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),Uub),Uua)
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),Uua),Uu) ) ) ).

% ATP.lambda_666
tff(fact_6832_ATP_Olambda__667,axiom,
    ! [Uu: assn,Uua: assn,Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_ah(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Uu),Uua),Uub)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Uu),Uub)
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Uua),Uub) ) ) ).

% ATP.lambda_667
tff(fact_6833_ATP_Olambda__668,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_abl(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uub),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uub),Uu) ) ) ).

% ATP.lambda_668
tff(fact_6834_ATP_Olambda__669,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_abc(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uub),Uua)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uub),Uu) ) ) ).

% ATP.lambda_669
tff(fact_6835_ATP_Olambda__670,axiom,
    ! [B: $tType,Uu: filter(B),Uua: filter(B),Uub: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(filter(B),fun(fun(B,$o),$o),aTP_Lamp_aet(filter(B),fun(filter(B),fun(fun(B,$o),$o)),Uu),Uua),Uub)
    <=> ( eventually(B,Uub,Uu)
        & eventually(B,Uub,Uua) ) ) ).

% ATP.lambda_670
tff(fact_6836_ATP_Olambda__671,axiom,
    ! [B: $tType,Uu: set(B),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_adt(set(B),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uua),Uu)
        & aa(set(B),$o,member(B,Uub),Uu) ) ) ).

% ATP.lambda_671
tff(fact_6837_ATP_Olambda__672,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_akb(set(nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(set(nat),$o,member(nat,Uub),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),Uua) ) ) ).

% ATP.lambda_672
tff(fact_6838_ATP_Olambda__673,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: B,Uub: set(B)] :
      ( aa(set(B),$o,aa(B,fun(set(B),$o),aTP_Lamp_sa(set(set(B)),fun(B,fun(set(B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(set(B)),$o,member(set(B),Uub),Uu)
        & aa(set(B),$o,member(B,Uua),Uub) ) ) ).

% ATP.lambda_673
tff(fact_6839_ATP_Olambda__674,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_ar(set(B),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),Uu)
        & aa(set(B),$o,member(B,Uub),Uua) ) ) ).

% ATP.lambda_674
tff(fact_6840_ATP_Olambda__675,axiom,
    ! [B: $tType,Uu: B,Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_bbe(B,fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uua = Uu )
        & ( Uub = Uu ) ) ) ).

% ATP.lambda_675
tff(fact_6841_ATP_Olambda__676,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B),Uub: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),aTP_Lamp_kn(set(B),fun(set(B),fun(set(B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uub),Uu) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uua),Uu) ) ) ).

% ATP.lambda_676
tff(fact_6842_ATP_Olambda__677,axiom,
    ! [B: $tType,Uu: list(B),Uua: fun(B,nat),Uub: B] : ( aa(B,nat,aa(fun(B,nat),fun(B,nat),aTP_Lamp_ala(list(B),fun(fun(B,nat),fun(B,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),count_list(B,Uu,Uub)),aa(B,nat,Uua,Uub)) ) ).

% ATP.lambda_677
tff(fact_6843_ATP_Olambda__678,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: list(B),Uub: B] : ( aa(B,nat,aa(list(B),fun(B,nat),aTP_Lamp_alb(fun(B,nat),fun(list(B),fun(B,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),count_list(B,Uua,Uub)),aa(B,nat,Uu,Uub)) ) ).

% ATP.lambda_678
tff(fact_6844_ATP_Olambda__679,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_nq(fun(B,$o),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),Uua)
       => aa(B,$o,Uu,Uub) ) ) ).

% ATP.lambda_679
tff(fact_6845_ATP_Olambda__680,axiom,
    ! [B: $tType,Uu: B,Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_ahm(B,fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uu = Uub )
       => aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_680
tff(fact_6846_ATP_Olambda__681,axiom,
    ! [B: $tType,Uu: B,Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_ahn(B,fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uub = Uu )
       => aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_681
tff(fact_6847_ATP_Olambda__682,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,fun(B,B)),Uua: multiset(C),Uub: C] : ( aa(C,fun(B,B),aa(multiset(C),fun(C,fun(B,B)),aTP_Lamp_apg(fun(C,fun(B,B)),fun(multiset(C),fun(C,fun(B,B))),Uu),Uua),Uub) = compow(fun(B,B),aa(C,nat,aa(multiset(C),fun(C,nat),count(C),Uua),Uub),aa(C,fun(B,B),Uu,Uub)) ) ).

% ATP.lambda_682
tff(fact_6848_ATP_Olambda__683,axiom,
    ! [C: $tType,Uu: set(C),Uua: fun(C,$o),Uub: C] :
      ( aa(C,$o,aa(fun(C,$o),fun(C,$o),aTP_Lamp_asf(set(C),fun(fun(C,$o),fun(C,$o)),Uu),Uua),Uub)
    <=> ( aa(set(C),$o,member(C,Uub),Uu)
        & aa(C,$o,Uua,Uub) ) ) ).

% ATP.lambda_683
tff(fact_6849_ATP_Olambda__684,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [Uu: set(B),Uua: fun(B,$o),Uub: B] :
          ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_xs(set(B),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(set(B),$o,member(B,Uub),Uu)
            & aa(B,$o,Uua,Uub) ) ) ) ).

% ATP.lambda_684
tff(fact_6850_ATP_Olambda__685,axiom,
    ! [B: $tType,Uu: set(B),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_dh(set(B),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),Uu)
        & aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_685
tff(fact_6851_ATP_Olambda__686,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_lw(fun(B,$o),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),Uua)
        & aa(B,$o,Uu,Uub) ) ) ).

% ATP.lambda_686
tff(fact_6852_ATP_Olambda__687,axiom,
    ! [B: $tType,Uu: B,Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_dt(B,fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uu = Uub )
        & aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_687
tff(fact_6853_ATP_Olambda__688,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_dx(fun(B,$o),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uua = Uub )
        & aa(B,$o,Uu,Uua) ) ) ).

% ATP.lambda_688
tff(fact_6854_ATP_Olambda__689,axiom,
    ! [B: $tType,Uu: B,Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_ds(B,fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uub = Uu )
        & aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_689
tff(fact_6855_ATP_Olambda__690,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(B,set(C)),Uub: B] :
      ( aa(B,$o,aa(fun(B,set(C)),fun(B,$o),aTP_Lamp_eb(set(B),fun(fun(B,set(C)),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),Uu)
        & ( aa(B,set(C),Uua,Uub) != bot_bot(set(C)) ) ) ) ).

% ATP.lambda_690
tff(fact_6856_ATP_Olambda__691,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_lf(set(B),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(set(B),$o,member(B,Uub),Uu)
            & ( aa(B,C,Uua,Uub) != zero_zero(C) ) ) ) ) ).

% ATP.lambda_691
tff(fact_6857_ATP_Olambda__692,axiom,
    ! [B: $tType,C: $tType] :
      ( ab_group_add(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_lu(set(B),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(set(B),$o,member(B,Uub),Uu)
            & ( aa(B,C,Uua,Uub) != zero_zero(C) ) ) ) ) ).

% ATP.lambda_692
tff(fact_6858_ATP_Olambda__693,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_ld(set(B),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(set(B),$o,member(B,Uub),Uu)
            & ( aa(B,C,Uua,Uub) != one_one(C) ) ) ) ) ).

% ATP.lambda_693
tff(fact_6859_ATP_Olambda__694,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(C,B),Uua: set(C),Uub: C] :
          ( aa(C,$o,aa(set(C),fun(C,$o),aTP_Lamp_lx(fun(C,B),fun(set(C),fun(C,$o)),Uu),Uua),Uub)
        <=> ( aa(set(C),$o,member(C,Uub),Uua)
            & ( aa(C,B,Uu,Uub) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_694
tff(fact_6860_ATP_Olambda__695,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(C,B),Uua: set(C),Uub: C] :
          ( aa(C,$o,aa(set(C),fun(C,$o),aTP_Lamp_mk(fun(C,B),fun(set(C),fun(C,$o)),Uu),Uua),Uub)
        <=> ( aa(set(C),$o,member(C,Uub),Uua)
            & ( aa(C,B,Uu,Uub) != one_one(B) ) ) ) ) ).

% ATP.lambda_695
tff(fact_6861_ATP_Olambda__696,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_parity(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_yv(set(B),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(set(B),$o,member(B,Uub),Uu)
            & ~ aa(C,$o,aa(C,fun(C,$o),dvd_dvd(C),aa(num,C,numeral_numeral(C),aa(num,num,bit0,one2))),aa(B,C,Uua,Uub)) ) ) ) ).

% ATP.lambda_696
tff(fact_6862_ATP_Olambda__697,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_cf(set(B),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,member(B,Uub),Uu)
        & ~ aa(set(B),$o,member(B,Uub),Uua) ) ) ).

% ATP.lambda_697
tff(fact_6863_ATP_Olambda__698,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: multiset(B),Uub: B] : ( aa(B,nat,aa(multiset(B),fun(B,nat),aTP_Lamp_ape(fun(B,nat),fun(multiset(B),fun(B,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),Uua),Uub)),aa(nat,nat,suc,aa(B,nat,Uu,Uub))) ) ).

% ATP.lambda_698
tff(fact_6864_ATP_Olambda__699,axiom,
    ! [B: $tType,E: $tType,D: $tType,Uu: fun(D,fun(E,$o)),Uua: fun(D,B),Uub: set(B)] : ( aa(set(B),set(D),aa(fun(D,B),fun(set(B),set(D)),aTP_Lamp_arj(fun(D,fun(E,$o)),fun(fun(D,B),fun(set(B),set(D))),Uu),Uua),Uub) = aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),inf_inf(set(D)),aa(set(B),set(D),aa(fun(D,B),fun(set(B),set(D)),vimage(D,B),Uua),Uub)),aa(fun(D,$o),set(D),collect(D),aa(fun(D,fun(E,$o)),fun(D,$o),domainp(D,E),Uu))) ) ).

% ATP.lambda_699
tff(fact_6865_ATP_Olambda__700,axiom,
    ! [B: $tType,C: $tType,Uu: list(product_prod(B,C)),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_amd(list(product_prod(B,C)),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> ( aa(B,option(C),map_of(B,C,Uu),Uua) = aa(C,option(C),some(C),Uub) ) ) ).

% ATP.lambda_700
tff(fact_6866_ATP_Olambda__701,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_zw(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uu) ) ).

% ATP.lambda_701
tff(fact_6867_ATP_Olambda__702,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_rc(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu) ) ).

% ATP.lambda_702
tff(fact_6868_ATP_Olambda__703,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ur(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu) ) ).

% ATP.lambda_703
tff(fact_6869_ATP_Olambda__704,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Uu: B,Uua: B,Uub: B] : ( aa(B,B,aa(B,fun(B,B),aTP_Lamp_rr(B,fun(B,fun(B,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),Uub),Uu)),Uua) ) ) ).

% ATP.lambda_704
tff(fact_6870_ATP_Olambda__705,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Uu: B,Uua: B,Uub: B] : ( aa(B,B,aa(B,fun(B,B),aTP_Lamp_sl(B,fun(B,fun(B,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_705
tff(fact_6871_ATP_Olambda__706,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Uu: B,Uua: B,Uub: B] : ( aa(B,B,aa(B,fun(B,B),aTP_Lamp_sm(B,fun(B,fun(B,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),Uub),Uu)),Uua) ) ) ).

% ATP.lambda_706
tff(fact_6872_ATP_Olambda__707,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Uu: B,Uua: B,Uub: B] : ( aa(B,B,aa(B,fun(B,B),aTP_Lamp_sk(B,fun(B,fun(B,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_707
tff(fact_6873_ATP_Olambda__708,axiom,
    ! [C: $tType,D: $tType,Uu: set(product_prod(D,C)),Uua: D,Uub: C] :
      ( aa(C,$o,aa(D,fun(C,$o),aTP_Lamp_aqx(set(product_prod(D,C)),fun(D,fun(C,$o)),Uu),Uua),Uub)
    <=> aa(set(product_prod(D,C)),$o,member(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),Uua),Uub)),Uu) ) ).

% ATP.lambda_708
tff(fact_6874_ATP_Olambda__709,axiom,
    ! [D: $tType,C: $tType,Uu: set(product_prod(C,D)),Uua: C,Uub: D] :
      ( aa(D,$o,aa(C,fun(D,$o),aTP_Lamp_ara(set(product_prod(C,D)),fun(C,fun(D,$o)),Uu),Uua),Uub)
    <=> aa(set(product_prod(C,D)),$o,member(product_prod(C,D),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),Uua),Uub)),Uu) ) ).

% ATP.lambda_709
tff(fact_6875_ATP_Olambda__710,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,B)),Uua: C,Uub: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_jo(set(product_prod(C,B)),fun(C,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(product_prod(C,B)),$o,member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uua),Uub)),Uu) ) ).

% ATP.lambda_710
tff(fact_6876_ATP_Olambda__711,axiom,
    ! [D: $tType,B: $tType,Uu: set(product_prod(B,D)),Uua: B,Uub: D] :
      ( aa(D,$o,aa(B,fun(D,$o),aTP_Lamp_aqw(set(product_prod(B,D)),fun(B,fun(D,$o)),Uu),Uua),Uub)
    <=> aa(set(product_prod(B,D)),$o,member(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),Uua),Uub)),Uu) ) ).

% ATP.lambda_711
tff(fact_6877_ATP_Olambda__712,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_ap(set(product_prod(B,C)),fun(B,fun(C,$o))),Uu),Uua),Uub)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uub)),Uu) ) ).

% ATP.lambda_712
tff(fact_6878_ATP_Olambda__713,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_it(set(product_prod(B,B)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uub)),Uu) ) ).

% ATP.lambda_713
tff(fact_6879_ATP_Olambda__714,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,B)),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_mn(set(product_prod(C,B)),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> aa(set(product_prod(C,B)),$o,member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uub),Uua)),Uu) ) ).

% ATP.lambda_714
tff(fact_6880_ATP_Olambda__715,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_mv(set(product_prod(B,B)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uua)),Uu) ) ).

% ATP.lambda_715
tff(fact_6881_ATP_Olambda__716,axiom,
    ! [B: $tType,Uu: set(list(B)),Uua: B,Uub: list(B)] :
      ( aa(list(B),$o,aa(B,fun(list(B),$o),aTP_Lamp_aui(set(list(B)),fun(B,fun(list(B),$o)),Uu),Uua),Uub)
    <=> aa(set(list(B)),$o,member(list(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uua),Uub)),Uu) ) ).

% ATP.lambda_716
tff(fact_6882_ATP_Olambda__717,axiom,
    ! [B: $tType,Uu: list(list(B)),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_alq(list(list(B)),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,nth(B,aa(nat,list(B),nth(list(B),Uu),Uub)),Uua) ) ).

% ATP.lambda_717
tff(fact_6883_ATP_Olambda__718,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Uu: B,Uua: B,Uub: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_yb(B,fun(B,fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(set(B),$o,member(B,Uub),ring_1_Ints(B))
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uu),Uub)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uub),Uua) ) ) ) ).

% ATP.lambda_718
tff(fact_6884_ATP_Olambda__719,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: list(B),Uub: B] :
          ( aa(B,$o,aa(list(B),fun(B,$o),aTP_Lamp_amv(fun(B,C),fun(list(B),fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Uu,aa(nat,B,nth(B,Uua),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(B),nat,size_size(list(B)),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_719
tff(fact_6885_ATP_Olambda__720,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: fun(C,B),Uub: B] :
      ( aa(B,$o,aa(fun(C,B),fun(B,$o),aTP_Lamp_pl(fun(B,C),fun(fun(C,B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(C,B,Uua,aa(B,C,Uu,Uub)) = Uub ) ) ).

% ATP.lambda_720
tff(fact_6886_ATP_Olambda__721,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,$o),Uua: fun(C,$o),Uub: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(fun(C,$o),fun(product_prod(B,C),$o),aTP_Lamp_qs(fun(B,$o),fun(fun(C,$o),fun(product_prod(B,C),$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uu,aa(product_prod(B,C),B,product_fst(B,C),Uub))
        & aa(C,$o,Uua,aa(product_prod(B,C),C,product_snd(B,C),Uub)) ) ) ).

% ATP.lambda_721
tff(fact_6887_ATP_Olambda__722,axiom,
    ! [D: $tType,E: $tType,C: $tType,B: $tType,Uu: fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D)),Uua: fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),Uub: fun(B,heap_Time_Heap(C))] : ( aa(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E),aa(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E)),aTP_Lamp_bav(fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D)),fun(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),Uu),Uua),Uub) = heap_Time_bind(D,E,aa(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D),Uu,Uub),aa(fun(B,heap_Time_Heap(C)),fun(D,heap_Time_Heap(E)),aTP_Lamp_bau(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),fun(D,heap_Time_Heap(E))),Uua),Uub)) ) ).

% ATP.lambda_722
tff(fact_6888_ATP_Olambda__723,axiom,
    ! [D: $tType,E: $tType,C: $tType,B: $tType,Uu: fun(fun(B,option(C)),option(D)),Uua: fun(D,fun(fun(B,option(C)),option(E))),Uub: fun(B,option(C))] : ( aa(fun(B,option(C)),option(E),aa(fun(D,fun(fun(B,option(C)),option(E))),fun(fun(B,option(C)),option(E)),aTP_Lamp_bam(fun(fun(B,option(C)),option(D)),fun(fun(D,fun(fun(B,option(C)),option(E))),fun(fun(B,option(C)),option(E))),Uu),Uua),Uub) = bind2(D,E,aa(fun(B,option(C)),option(D),Uu,Uub),aa(fun(B,option(C)),fun(D,option(E)),aTP_Lamp_bal(fun(D,fun(fun(B,option(C)),option(E))),fun(fun(B,option(C)),fun(D,option(E))),Uua),Uub)) ) ).

% ATP.lambda_723
tff(fact_6889_ATP_Olambda__724,axiom,
    ! [Uu: fun(nat,$o),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_tj(fun(nat,$o),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,Uu,Uub)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),Uua) ) ) ).

% ATP.lambda_724
tff(fact_6890_ATP_Olambda__725,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_arf(fun(B,fun(C,$o)),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uua,Uub)
        & aa(B,$o,aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),Uu),Uub) ) ) ).

% ATP.lambda_725
tff(fact_6891_ATP_Olambda__726,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: list(B),Uub: B] :
          ( aa(B,$o,aa(list(B),fun(B,$o),aTP_Lamp_amt(fun(B,C),fun(list(B),fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Uu,Uub)),aa(B,C,Uu,aa(nat,B,nth(B,Uua),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(B),nat,size_size(list(B)),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% ATP.lambda_726
tff(fact_6892_ATP_Olambda__727,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: list(B),Uub: B] :
          ( aa(B,$o,aa(list(B),fun(B,$o),aTP_Lamp_amu(fun(B,C),fun(list(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(B,C,Uu,Uub) = aa(B,C,Uu,aa(nat,B,nth(B,Uua),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(B),nat,size_size(list(B)),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ).

% ATP.lambda_727
tff(fact_6893_ATP_Olambda__728,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(B,fun(C,D)),Uub: B] : ( aa(B,D,aa(fun(B,fun(C,D)),fun(B,D),aTP_Lamp_pb(fun(B,set(C)),fun(fun(B,fun(C,D)),fun(B,D)),Uu),Uua),Uub) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),aa(B,fun(C,D),Uua,Uub)),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_728
tff(fact_6894_ATP_Olambda__729,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(B,fun(C,D)),Uub: B] : ( aa(B,D,aa(fun(B,fun(C,D)),fun(B,D),aTP_Lamp_pc(fun(B,set(C)),fun(fun(B,fun(C,D)),fun(B,D)),Uu),Uua),Uub) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),aa(B,fun(C,D),Uua,Uub)),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_729
tff(fact_6895_ATP_Olambda__730,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(B)
     => ! [Uu: fun(C,B),Uua: C,Uub: C] :
          ( aa(C,$o,aa(C,fun(C,$o),aTP_Lamp_alg(fun(C,B),fun(C,fun(C,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(C,B,Uu,Uua)),aa(C,B,Uu,Uub)) ) ) ).

% ATP.lambda_730
tff(fact_6896_ATP_Olambda__731,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: fun(B,C),Uub: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_xk(fun(B,C),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Uu,Uub)),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_731
tff(fact_6897_ATP_Olambda__732,axiom,
    ! [B: $tType,C: $tType] :
      ( field(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_qo(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_732
tff(fact_6898_ATP_Olambda__733,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(B,fun(D,C)),Uua: fun(B,option(D)),Uub: B] : ( aa(B,option(C),aa(fun(B,option(D)),fun(B,option(C)),aTP_Lamp_ack(fun(B,fun(D,C)),fun(fun(B,option(D)),fun(B,option(C))),Uu),Uua),Uub) = aa(option(D),option(C),map_option(D,C,aa(B,fun(D,C),Uu,Uub)),aa(B,option(D),Uua,Uub)) ) ).

% ATP.lambda_733
tff(fact_6899_ATP_Olambda__734,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ok(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_734
tff(fact_6900_ATP_Olambda__735,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(B,C),Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_mq(fun(B,C),fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Uu,Uub)),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_735
tff(fact_6901_ATP_Olambda__736,axiom,
    ! [C: $tType,B: $tType] :
      ( linordered_idom(C)
     => ! [Uu: fun(B,C),Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_qf(fun(B,C),fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Uua,Uub)),aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_736
tff(fact_6902_ATP_Olambda__737,axiom,
    ! [B: $tType,C: $tType] :
      ( ab_group_add(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ou(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_737
tff(fact_6903_ATP_Olambda__738,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: fun(B,set(C)),Uub: B] : ( aa(B,set(C),aa(fun(B,set(C)),fun(B,set(C)),aTP_Lamp_cg(fun(B,set(C)),fun(fun(B,set(C)),fun(B,set(C))),Uu),Uua),Uub) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),aa(B,set(C),Uu,Uub)),aa(B,set(C),Uua,Uub)) ) ).

% ATP.lambda_738
tff(fact_6904_ATP_Olambda__739,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: fun(B,nat),Uub: B] : ( aa(B,nat,aa(fun(B,nat),fun(B,nat),aa(fun(B,nat),fun(fun(B,nat),fun(B,nat)),aTP_Lamp_app(fun(B,nat),fun(fun(B,nat),fun(B,nat))),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(B,nat,Uu,Uub)),aa(B,nat,Uua,Uub)) ) ).

% ATP.lambda_739
tff(fact_6905_ATP_Olambda__740,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [Uu: fun(B,nat),Uua: fun(B,nat),Uub: B] : ( aa(B,nat,aa(fun(B,nat),fun(B,nat),aTP_Lamp_uy(fun(B,nat),fun(fun(B,nat),fun(B,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(B,nat,Uua,Uub)),aa(B,nat,Uu,Uub)) ) ) ).

% ATP.lambda_740
tff(fact_6906_ATP_Olambda__741,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: fun(B,nat),Uub: B] : ( aa(B,nat,aa(fun(B,nat),fun(B,nat),aTP_Lamp_qj(fun(B,nat),fun(fun(B,nat),fun(B,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(B,nat,Uua,Uub)),aa(B,nat,Uu,Uub)) ) ).

% ATP.lambda_741
tff(fact_6907_ATP_Olambda__742,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_gp(fun(C,set(B)),fun(fun(C,set(B)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(C,set(B),Uu,Uub)),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_742
tff(fact_6908_ATP_Olambda__743,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_gg(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_743
tff(fact_6909_ATP_Olambda__744,axiom,
    ! [B: $tType,C: $tType] :
      ( lattice(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_jz(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_744
tff(fact_6910_ATP_Olambda__745,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: fun(B,assn),Uub: B] : ( aa(B,assn,aa(fun(B,assn),fun(B,assn),aTP_Lamp_ay(fun(B,assn),fun(fun(B,assn),fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(B,assn,Uu,Uub)),aa(B,assn,Uua,Uub)) ) ).

% ATP.lambda_745
tff(fact_6911_ATP_Olambda__746,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: fun(B,set(C)),Uub: B] : ( aa(B,set(C),aa(fun(B,set(C)),fun(B,set(C)),aTP_Lamp_bt(fun(B,set(C)),fun(fun(B,set(C)),fun(B,set(C))),Uu),Uua),Uub) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),aa(B,set(C),Uu,Uub)),aa(B,set(C),Uua,Uub)) ) ).

% ATP.lambda_746
tff(fact_6912_ATP_Olambda__747,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Uu: fun(B,C),Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_kd(fun(B,C),fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(B,C,Uu,Uub)),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_747
tff(fact_6913_ATP_Olambda__748,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_ij(fun(C,set(B)),fun(fun(C,set(B)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(C,set(B),Uu,Uub)),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_748
tff(fact_6914_ATP_Olambda__749,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_id(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_749
tff(fact_6915_ATP_Olambda__750,axiom,
    ! [B: $tType,C: $tType] :
      ( lattice(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_jy(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_750
tff(fact_6916_ATP_Olambda__751,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: fun(B,set(C)),Uub: B] : ( aa(B,set(C),aa(fun(B,set(C)),fun(B,set(C)),aTP_Lamp_bu(fun(B,set(C)),fun(fun(B,set(C)),fun(B,set(C))),Uu),Uua),Uub) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),Uu,Uub)),aa(B,set(C),Uua,Uub)) ) ).

% ATP.lambda_751
tff(fact_6917_ATP_Olambda__752,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Uu: fun(B,C),Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_kc(fun(B,C),fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,Uu,Uub)),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_752
tff(fact_6918_ATP_Olambda__753,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_op(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_753
tff(fact_6919_ATP_Olambda__754,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: fun(B,nat),Uub: B] : ( aa(B,nat,aa(fun(B,nat),fun(B,nat),aa(fun(B,nat),fun(fun(B,nat),fun(B,nat)),aTP_Lamp_apo(fun(B,nat),fun(fun(B,nat),fun(B,nat))),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(B,nat,Uu,Uub)),aa(B,nat,Uua,Uub)) ) ).

% ATP.lambda_754
tff(fact_6920_ATP_Olambda__755,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(B,C),Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_mb(fun(B,C),fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,Uu,Uub)),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_755
tff(fact_6921_ATP_Olambda__756,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,multiset(B)),Uua: fun(C,multiset(B)),Uub: C] : ( aa(C,multiset(B),aa(fun(C,multiset(B)),fun(C,multiset(B)),aTP_Lamp_atv(fun(C,multiset(B)),fun(fun(C,multiset(B)),fun(C,multiset(B))),Uu),Uua),Uub) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),aa(C,multiset(B),Uu,Uub)),aa(C,multiset(B),Uua,Uub)) ) ).

% ATP.lambda_756
tff(fact_6922_ATP_Olambda__757,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,multiset(C)),Uua: fun(B,multiset(C)),Uub: B] : ( aa(B,multiset(C),aa(fun(B,multiset(C)),fun(B,multiset(C)),aTP_Lamp_atx(fun(B,multiset(C)),fun(fun(B,multiset(C)),fun(B,multiset(C))),Uu),Uua),Uub) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),union_mset(C),aa(B,multiset(C),Uu,Uub)),aa(B,multiset(C),Uua,Uub)) ) ).

% ATP.lambda_757
tff(fact_6923_ATP_Olambda__758,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,multiset(B)),Uua: fun(C,multiset(B)),Uub: C] : ( aa(C,multiset(B),aa(fun(C,multiset(B)),fun(C,multiset(B)),aTP_Lamp_atw(fun(C,multiset(B)),fun(fun(C,multiset(B)),fun(C,multiset(B))),Uu),Uua),Uub) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),aa(C,multiset(B),Uu,Uub)),aa(C,multiset(B),Uua,Uub)) ) ).

% ATP.lambda_758
tff(fact_6924_ATP_Olambda__759,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,multiset(C)),Uua: fun(B,multiset(C)),Uub: B] : ( aa(B,multiset(C),aa(fun(B,multiset(C)),fun(B,multiset(C)),aTP_Lamp_aty(fun(B,multiset(C)),fun(fun(B,multiset(C)),fun(B,multiset(C))),Uu),Uua),Uub) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),inter_mset(C),aa(B,multiset(C),Uu,Uub)),aa(B,multiset(C),Uua,Uub)) ) ).

% ATP.lambda_759
tff(fact_6925_ATP_Olambda__760,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(D,B),Uua: fun(D,C),Uub: D] : ( aa(D,product_prod(B,C),aa(fun(D,C),fun(D,product_prod(B,C)),aTP_Lamp_co(fun(D,B),fun(fun(D,C),fun(D,product_prod(B,C))),Uu),Uua),Uub) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Uu,Uub)),aa(D,C,Uua,Uub)) ) ).

% ATP.lambda_760
tff(fact_6926_ATP_Olambda__761,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(B,C),Uua: fun(B,D),Uub: B] : ( aa(B,product_prod(C,D),aa(fun(B,D),fun(B,product_prod(C,D)),aTP_Lamp_qp(fun(B,C),fun(fun(B,D),fun(B,product_prod(C,D))),Uu),Uua),Uub) = aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(B,C,Uu,Uub)),aa(B,D,Uua,Uub)) ) ).

% ATP.lambda_761
tff(fact_6927_ATP_Olambda__762,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aw(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uu,Uub)
       => aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_762
tff(fact_6928_ATP_Olambda__763,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_rm(fun(B,set(C)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(C),$o,aa(set(C),fun(set(C),$o),disjnt(C),aa(B,set(C),Uu,Uua)),aa(B,set(C),Uu,Uub)) ) ).

% ATP.lambda_763
tff(fact_6929_ATP_Olambda__764,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,C)),Uua: fun(B,nat),Uub: B] : ( aa(B,fun(C,C),aa(fun(B,nat),fun(B,fun(C,C)),aTP_Lamp_agv(fun(B,fun(C,C)),fun(fun(B,nat),fun(B,fun(C,C))),Uu),Uua),Uub) = compow(fun(C,C),aa(B,nat,Uua,Uub),aa(B,fun(C,C),Uu,Uub)) ) ).

% ATP.lambda_764
tff(fact_6930_ATP_Olambda__765,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uua: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_bd(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Uu),Uua),Uub)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Uu,Uub)
        | aa(product_prod(heap_ext(product_unit),set(nat)),$o,Uua,Uub) ) ) ).

% ATP.lambda_765
tff(fact_6931_ATP_Olambda__766,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [Uu: fun(B,$o),Uua: fun(B,$o),Uub: B] :
          ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aye(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(B,$o,Uu,Uub)
            | aa(B,$o,Uua,Uub) ) ) ) ).

% ATP.lambda_766
tff(fact_6932_ATP_Olambda__767,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_au(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uu,Uub)
        | aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_767
tff(fact_6933_ATP_Olambda__768,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uua: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_be(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Uu),Uua),Uub)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Uu,Uub)
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Uua,Uub) ) ) ).

% ATP.lambda_768
tff(fact_6934_ATP_Olambda__769,axiom,
    ! [C: $tType,Uu: fun(C,$o),Uua: fun(C,$o),Uub: C] :
      ( aa(C,$o,aa(fun(C,$o),fun(C,$o),aTP_Lamp_aej(fun(C,$o),fun(fun(C,$o),fun(C,$o)),Uu),Uua),Uub)
    <=> ( aa(C,$o,Uu,Uub)
        & aa(C,$o,Uua,Uub) ) ) ).

% ATP.lambda_769
tff(fact_6935_ATP_Olambda__770,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aq(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uu,Uub)
        & aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_770
tff(fact_6936_ATP_Olambda__771,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aij(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uua,Uub)
        & aa(B,$o,Uu,Uub) ) ) ).

% ATP.lambda_771
tff(fact_6937_ATP_Olambda__772,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: B,Uub: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_aob(fun(B,C),fun(B,fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(B,C,Uu,Uua) = aa(B,C,Uu,Uub) ) ) ) ).

% ATP.lambda_772
tff(fact_6938_ATP_Olambda__773,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_adm(fun(B,C),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,C,Uu,Uua) = aa(B,C,Uu,Uub) ) ) ).

% ATP.lambda_773
tff(fact_6939_ATP_Olambda__774,axiom,
    ! [E: $tType,C: $tType,Uu: fun(C,E),Uua: fun(C,E),Uub: C] :
      ( aa(C,$o,aa(fun(C,E),fun(C,$o),aTP_Lamp_aqv(fun(C,E),fun(fun(C,E),fun(C,$o)),Uu),Uua),Uub)
    <=> ( aa(C,E,Uu,Uub) = aa(C,E,Uua,Uub) ) ) ).

% ATP.lambda_774
tff(fact_6940_ATP_Olambda__775,axiom,
    ! [D: $tType,C: $tType,Uu: fun(C,D),Uua: fun(C,D),Uub: C] :
      ( aa(C,$o,aa(fun(C,D),fun(C,$o),aTP_Lamp_aho(fun(C,D),fun(fun(C,D),fun(C,$o)),Uu),Uua),Uub)
    <=> ( aa(C,D,Uu,Uub) = aa(C,D,Uua,Uub) ) ) ).

% ATP.lambda_775
tff(fact_6941_ATP_Olambda__776,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: fun(C,B),Uub: C] :
      ( aa(C,$o,aa(fun(C,B),fun(C,$o),aTP_Lamp_nn(fun(C,B),fun(fun(C,B),fun(C,$o)),Uu),Uua),Uub)
    <=> ( aa(C,B,Uu,Uub) = aa(C,B,Uua,Uub) ) ) ).

% ATP.lambda_776
tff(fact_6942_ATP_Olambda__777,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_ng(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uu,Uub)
      <=> aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_777
tff(fact_6943_ATP_Olambda__778,axiom,
    ! [D: $tType,B: $tType,Uu: fun(B,D),Uua: fun(B,D),Uub: B] :
      ( aa(B,$o,aa(fun(B,D),fun(B,$o),aTP_Lamp_aqu(fun(B,D),fun(fun(B,D),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,D,Uu,Uub) = aa(B,D,Uua,Uub) ) ) ).

% ATP.lambda_778
tff(fact_6944_ATP_Olambda__779,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: fun(B,C),Uub: B] :
      ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_np(fun(B,C),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,C,Uu,Uub) = aa(B,C,Uua,Uub) ) ) ).

% ATP.lambda_779
tff(fact_6945_ATP_Olambda__780,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_alw(B,fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(B,C,Uua,Uu) = aa(B,C,Uua,Uub) ) ) ) ).

% ATP.lambda_780
tff(fact_6946_ATP_Olambda__781,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [Uu: fun(B,C),Uua: fun(B,$o),Uub: B] : ( aa(B,C,aa(fun(B,$o),fun(B,C),aTP_Lamp_xf(fun(B,C),fun(fun(B,$o),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Uu,Uub)),aa($o,C,zero_neq_one_of_bool(C),aa(B,$o,Uua,Uub))) ) ) ).

% ATP.lambda_781
tff(fact_6947_ATP_Olambda__782,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_afp(fun(B,fun(B,$o)),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uua,Uub)
        & ! [Y4: B] :
            ( aa(B,$o,Uua,Y4)
           => aa(B,$o,aa(B,fun(B,$o),Uu,Uub),Y4) ) ) ) ).

% ATP.lambda_782
tff(fact_6948_ATP_Olambda__783,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: fun(B,assn),Uub: B] : ( aa(B,assn,aa(fun(B,assn),fun(B,assn),aTP_Lamp_ax(fun(B,assn),fun(fun(B,assn),fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(B,assn,Uu,Uub)),ex_assn(B,Uua)) ) ).

% ATP.lambda_783
tff(fact_6949_ATP_Olambda__784,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,option(C)),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_aau(fun(B,option(C)),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> ( aa(B,option(C),Uu,Uua) = aa(C,option(C),some(C),Uub) ) ) ).

% ATP.lambda_784
tff(fact_6950_ATP_Olambda__785,axiom,
    ! [Uu: fun(b,b),Uua: ref(b),Uub: b] :
      ( aa(b,heap_Time_Heap(b),aa(ref(b),fun(b,heap_Time_Heap(b)),aTP_Lamp_axn(fun(b,b),fun(ref(b),fun(b,heap_Time_Heap(b))),Uu),Uua),Uub)
      = $let(
          y: b,
          y := aa(b,b,Uu,Uub),
          heap_Time_bind(product_unit,b,ref_update(b,Uua,y),aTP_Lamp_axm(b,fun(product_unit,heap_Time_Heap(b)),y)) ) ) ).

% ATP.lambda_785
tff(fact_6951_ATP_Olambda__786,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: set(D),Uub: C] : ( aa(C,B,aa(set(D),fun(C,B),aTP_Lamp_oh(fun(C,fun(D,B)),fun(set(D),fun(C,B)),Uu),Uua),Uub) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups7121269368397514597t_prod(D,B),aa(C,fun(D,B),Uu,Uub)),Uua) ) ) ).

% ATP.lambda_786
tff(fact_6952_ATP_Olambda__787,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: set(D),Uub: C] : ( aa(C,B,aa(set(D),fun(C,B),aTP_Lamp_oe(fun(C,fun(D,B)),fun(set(D),fun(C,B)),Uu),Uua),Uub) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups7311177749621191930dd_sum(D,B),aa(C,fun(D,B),Uu,Uub)),Uua) ) ) ).

% ATP.lambda_787
tff(fact_6953_ATP_Olambda__788,axiom,
    ! [Uu: fun(nat,nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_rb(fun(nat,nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,Uu,Uub)),Uua) ) ).

% ATP.lambda_788
tff(fact_6954_ATP_Olambda__789,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,set(B)),Uua: set(B),Uub: C] :
      ( aa(C,$o,aa(set(B),fun(C,$o),aTP_Lamp_hg(fun(C,set(B)),fun(set(B),fun(C,$o)),Uu),Uua),Uub)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(C,set(B),Uu,Uub)),Uua) ) ).

% ATP.lambda_789
tff(fact_6955_ATP_Olambda__790,axiom,
    ! [B: $tType,C: $tType] :
      ( unboun7993243217541854897norder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_tv(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_790
tff(fact_6956_ATP_Olambda__791,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_nx(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_791
tff(fact_6957_ATP_Olambda__792,axiom,
    ! [C: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: C] : ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_zb(fun(C,B),fun(B,fun(C,B)),Uu),Uua),Uub) = modulo_modulo(B,aa(C,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_792
tff(fact_6958_ATP_Olambda__793,axiom,
    ! [C: $tType,B: $tType] :
      ( field(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: C] : ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_qn(fun(C,B),fun(B,fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(C,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_793
tff(fact_6959_ATP_Olambda__794,axiom,
    ! [B: $tType,C: $tType] :
      ( euclid4440199948858584721cancel(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] : ( aa(B,C,aa(C,fun(B,C),aTP_Lamp_yw(fun(B,C),fun(C,fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),divide_divide(C),aa(B,C,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_794
tff(fact_6960_ATP_Olambda__795,axiom,
    ! [B: $tType,C: $tType] :
      ( ( dense_linorder(C)
        & no_bot(C) )
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_tu(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_795
tff(fact_6961_ATP_Olambda__796,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_akl(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_796
tff(fact_6962_ATP_Olambda__797,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: C] : ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_os(fun(C,B),fun(B,fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_797
tff(fact_6963_ATP_Olambda__798,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: assn,Uub: B] : ( aa(B,assn,aa(assn,fun(B,assn),aTP_Lamp_aa(fun(B,assn),fun(assn,fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_798
tff(fact_6964_ATP_Olambda__799,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,set(B)),Uua: set(B),Uub: C] : ( aa(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_gq(fun(C,set(B)),fun(set(B),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(C,set(B),Uu,Uub)),Uua) ) ).

% ATP.lambda_799
tff(fact_6965_ATP_Olambda__800,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: fun(C,B),Uua: nat,Uub: C] : ( aa(C,B,aa(nat,fun(C,B),aTP_Lamp_ry(fun(C,B),fun(nat,fun(C,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(C,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_800
tff(fact_6966_ATP_Olambda__801,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,multiset(B)),Uua: B,Uub: C] : ( aa(C,nat,aa(B,fun(C,nat),aTP_Lamp_aox(fun(C,multiset(B)),fun(B,fun(C,nat)),Uu),Uua),Uub) = aa(B,nat,aa(multiset(B),fun(B,nat),count(B),aa(C,multiset(B),Uu,Uub)),Uua) ) ).

% ATP.lambda_801
tff(fact_6967_ATP_Olambda__802,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,set(B)),Uua: set(B),Uub: C] : ( aa(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_fk(fun(C,set(B)),fun(set(B),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(C,set(B),Uu,Uub)),Uua) ) ).

% ATP.lambda_802
tff(fact_6968_ATP_Olambda__803,axiom,
    ! [C: $tType,B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: C] : ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_ii(fun(C,B),fun(B,fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_803
tff(fact_6969_ATP_Olambda__804,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: assn,Uub: B] : ( aa(B,assn,aa(assn,fun(B,assn),aTP_Lamp_az(fun(B,assn),fun(assn,fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(B,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_804
tff(fact_6970_ATP_Olambda__805,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,set(B)),Uua: set(B),Uub: C] : ( aa(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_go(fun(C,set(B)),fun(set(B),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(C,set(B),Uu,Uub)),Uua) ) ).

% ATP.lambda_805
tff(fact_6971_ATP_Olambda__806,axiom,
    ! [C: $tType,B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: C] : ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_gf(fun(C,B),fun(B,fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_806
tff(fact_6972_ATP_Olambda__807,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: assn,Uub: B] : ( aa(B,assn,aa(assn,fun(B,assn),aTP_Lamp_ai(fun(B,assn),fun(assn,fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(B,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_807
tff(fact_6973_ATP_Olambda__808,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] : ( aa(B,C,aa(C,fun(B,C),aTP_Lamp_iq(fun(B,C),fun(C,fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_808
tff(fact_6974_ATP_Olambda__809,axiom,
    ! [B: $tType,C: $tType] :
      ( linord4140545234300271783up_add(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] : ( aa(B,C,aa(C,fun(B,C),aTP_Lamp_zv(fun(B,C),fun(C,fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_809
tff(fact_6975_ATP_Olambda__810,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(D,heap_Time_Heap(C)),Uua: fun(C,heap_Time_Heap(B)),Uub: D] : ( aa(D,heap_Time_Heap(B),aa(fun(C,heap_Time_Heap(B)),fun(D,heap_Time_Heap(B)),aTP_Lamp_axb(fun(D,heap_Time_Heap(C)),fun(fun(C,heap_Time_Heap(B)),fun(D,heap_Time_Heap(B))),Uu),Uua),Uub) = heap_Time_bind(C,B,aa(D,heap_Time_Heap(C),Uu,Uub),Uua) ) ).

% ATP.lambda_810
tff(fact_6976_ATP_Olambda__811,axiom,
    ! [F10: $tType,G6: $tType,C: $tType,E: $tType,D: $tType,Uu: fun(F10,fun(G6,product_prod(D,E))),Uua: fun(D,fun(E,C)),Uub: F10] : ( aa(F10,fun(G6,C),aa(fun(D,fun(E,C)),fun(F10,fun(G6,C)),aTP_Lamp_aha(fun(F10,fun(G6,product_prod(D,E))),fun(fun(D,fun(E,C)),fun(F10,fun(G6,C))),Uu),Uua),Uub) = product_scomp(G6,D,E,C,aa(F10,fun(G6,product_prod(D,E)),Uu,Uub),Uua) ) ).

% ATP.lambda_811
tff(fact_6977_ATP_Olambda__812,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(D,set(old_node(B,C))),Uua: set(old_node(B,C)),Uub: D] : ( aa(D,set(old_node(B,C)),aa(set(old_node(B,C)),fun(D,set(old_node(B,C))),aTP_Lamp_aze(fun(D,set(old_node(B,C))),fun(set(old_node(B,C)),fun(D,set(old_node(B,C)))),Uu),Uua),Uub) = old_Scons(B,C,aa(D,set(old_node(B,C)),Uu,Uub),Uua) ) ).

% ATP.lambda_812
tff(fact_6978_ATP_Olambda__813,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(B,filter(C)),Uua: filter(D),Uub: B] : ( aa(B,filter(product_prod(C,D)),aa(filter(D),fun(B,filter(product_prod(C,D))),aTP_Lamp_qx(fun(B,filter(C)),fun(filter(D),fun(B,filter(product_prod(C,D)))),Uu),Uua),Uub) = prod_filter(C,D,aa(B,filter(C),Uu,Uub),Uua) ) ).

% ATP.lambda_813
tff(fact_6979_ATP_Olambda__814,axiom,
    ! [E: $tType,B: $tType,C: $tType,D: $tType,Uu: fun(E,fun(B,fun(D,$o))),Uua: fun(D,fun(C,$o)),Uub: E] : ( aa(E,fun(B,fun(C,$o)),aa(fun(D,fun(C,$o)),fun(E,fun(B,fun(C,$o))),aTP_Lamp_aqz(fun(E,fun(B,fun(D,$o))),fun(fun(D,fun(C,$o)),fun(E,fun(B,fun(C,$o)))),Uu),Uua),Uub) = aa(fun(D,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(D,$o)),fun(fun(D,fun(C,$o)),fun(B,fun(C,$o))),relcompp(B,D,C),aa(E,fun(B,fun(D,$o)),Uu,Uub)),Uua) ) ).

% ATP.lambda_814
tff(fact_6980_ATP_Olambda__815,axiom,
    ! [E: $tType,B: $tType,C: $tType,D: $tType,Uu: fun(E,set(product_prod(B,D))),Uua: set(product_prod(D,C)),Uub: E] : ( aa(E,set(product_prod(B,C)),aa(set(product_prod(D,C)),fun(E,set(product_prod(B,C))),aTP_Lamp_ma(fun(E,set(product_prod(B,D))),fun(set(product_prod(D,C)),fun(E,set(product_prod(B,C)))),Uu),Uua),Uub) = relcomp(B,D,C,aa(E,set(product_prod(B,D)),Uu,Uub),Uua) ) ).

% ATP.lambda_815
tff(fact_6981_ATP_Olambda__816,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(D,set(product_prod(C,B))),Uua: set(C),Uub: D] : ( aa(D,set(B),aa(set(C),fun(D,set(B)),aTP_Lamp_jq(fun(D,set(product_prod(C,B))),fun(set(C),fun(D,set(B))),Uu),Uua),Uub) = aa(set(C),set(B),image(C,B,aa(D,set(product_prod(C,B)),Uu,Uub)),Uua) ) ).

% ATP.lambda_816
tff(fact_6982_ATP_Olambda__817,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(D,option(C)),Uua: fun(C,option(B)),Uub: D] : ( aa(D,option(B),aa(fun(C,option(B)),fun(D,option(B)),aTP_Lamp_bar(fun(D,option(C)),fun(fun(C,option(B)),fun(D,option(B))),Uu),Uua),Uub) = bind2(C,B,aa(D,option(C),Uu,Uub),Uua) ) ).

% ATP.lambda_817
tff(fact_6983_ATP_Olambda__818,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: $o,Uub: B] :
      ( aa(B,$o,aa($o,fun(B,$o),aTP_Lamp_ati(fun(B,$o),fun($o,fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uu,Uub)
       => (Uua) ) ) ).

% ATP.lambda_818
tff(fact_6984_ATP_Olambda__819,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,C),Uua: set(C),Uub: B] :
      ( aa(B,$o,aa(set(C),fun(B,$o),aTP_Lamp_bn(fun(B,C),fun(set(C),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(C),$o,member(C,aa(B,C,Uu,Uub)),Uua) ) ).

% ATP.lambda_819
tff(fact_6985_ATP_Olambda__820,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: fun(C,B),Uub: C] :
      ( aa(C,$o,aa(fun(C,B),fun(C,$o),aTP_Lamp_la(set(B),fun(fun(C,B),fun(C,$o)),Uu),Uua),Uub)
    <=> aa(set(B),$o,member(B,aa(C,B,Uua,Uub)),Uu) ) ).

% ATP.lambda_820
tff(fact_6986_ATP_Olambda__821,axiom,
    ! [E: $tType,F10: $tType,C: $tType,D: $tType,Uu: fun(E,fun(F10,D)),Uua: fun(D,C),Uub: E] : ( aa(E,fun(F10,C),aa(fun(D,C),fun(E,fun(F10,C)),aTP_Lamp_bax(fun(E,fun(F10,D)),fun(fun(D,C),fun(E,fun(F10,C))),Uu),Uua),Uub) = fcomp(F10,D,C,aa(E,fun(F10,D),Uu,Uub),Uua) ) ).

% ATP.lambda_821
tff(fact_6987_ATP_Olambda__822,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(D,set(C)),Uua: fun(C,set(B)),Uub: D] : ( aa(D,set(B),aa(fun(C,set(B)),fun(D,set(B)),aTP_Lamp_ahg(fun(D,set(C)),fun(fun(C,set(B)),fun(D,set(B))),Uu),Uua),Uub) = bind3(C,B,aa(D,set(C),Uu,Uub),Uua) ) ).

% ATP.lambda_822
tff(fact_6988_ATP_Olambda__823,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: $o,Uub: B] :
      ( aa(B,$o,aa($o,fun(B,$o),aTP_Lamp_ni(fun(B,$o),fun($o,fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uu,Uub)
        | (Uua) ) ) ).

% ATP.lambda_823
tff(fact_6989_ATP_Olambda__824,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: $o,Uub: B] :
      ( aa(B,$o,aa($o,fun(B,$o),aTP_Lamp_atg(fun(B,$o),fun($o,fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uu,Uub)
        & (Uua) ) ) ).

% ATP.lambda_824
tff(fact_6990_ATP_Olambda__825,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,B),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_ayi(fun(C,B),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> ( aa(C,B,Uu,Uub) = Uua ) ) ).

% ATP.lambda_825
tff(fact_6991_ATP_Olambda__826,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_akm(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(B,C,Uu,Uub) = Uua ) ) ) ).

% ATP.lambda_826
tff(fact_6992_ATP_Olambda__827,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,C),Uua: C,Uub: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_ep(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,C,Uu,Uub) = Uua ) ) ).

% ATP.lambda_827
tff(fact_6993_ATP_Olambda__828,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: fun(C,B),Uub: C] :
      ( aa(C,$o,aa(fun(C,B),fun(C,$o),aTP_Lamp_asq(B,fun(fun(C,B),fun(C,$o)),Uu),Uua),Uub)
    <=> ( aa(C,B,Uua,Uub) = Uu ) ) ).

% ATP.lambda_828
tff(fact_6994_ATP_Olambda__829,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: fun(nat,B),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(nat,B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avr(nat,fun(fun(nat,B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avq(nat,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(B,aa(list(nat),list(B),map(nat,B,Uua),upt(zero_zero(nat),Uu)),Uub)) ) ) ).

% ATP.lambda_829
tff(fact_6995_ATP_Olambda__830,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: B,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(B,fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avv(nat,fun(B,fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avq(nat,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(B,replicate(B,Uu,Uua),Uub)) ) ) ).

% ATP.lambda_830
tff(fact_6996_ATP_Olambda__831,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_agz(set(product_prod(B,B)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uub != Uua )
        & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uub)),Uu) ) ) ).

% ATP.lambda_831
tff(fact_6997_ATP_Olambda__832,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_aga(set(product_prod(B,B)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uub != Uua )
        & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uua)),Uu) ) ) ).

% ATP.lambda_832
tff(fact_6998_ATP_Olambda__833,axiom,
    ! [B: $tType,Uu: B,Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_df(B,fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uub != Uu )
       => aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_833
tff(fact_6999_ATP_Olambda__834,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_vy(nat,fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub))) ) ) ).

% ATP.lambda_834
tff(fact_7000_ATP_Olambda__835,axiom,
    ! [B: $tType,Uu: B,Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_adg(B,fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uua != Uu )
        & ( Uub != Uu ) ) ) ).

% ATP.lambda_835
tff(fact_7001_ATP_Olambda__836,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [Uu: fun(B,$o),Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_xg(fun(B,$o),fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),times_times(C),aa($o,C,zero_neq_one_of_bool(C),aa(B,$o,Uu,Uub))),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_836
tff(fact_7002_ATP_Olambda__837,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_atj(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( ~ aa(B,$o,Uu,Uub)
        | aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_837
tff(fact_7003_ATP_Olambda__838,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [Uu: fun(B,B),Uua: fun(B,$o),Uub: B] :
          ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_aek(fun(B,B),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
        <=> ( ? [X3: B] :
                ( ( Uub = aa(B,B,Uu,X3) )
                & aa(B,$o,Uua,X3) )
            | ? [M6: set(B)] :
                ( ( Uub = aa(set(B),B,complete_Sup_Sup(B),M6) )
                & comple1602240252501008431_chain(B,ord_less_eq(B),M6)
                & ! [X3: B] :
                    ( aa(set(B),$o,member(B,X3),M6)
                   => aa(B,$o,Uua,X3) ) ) ) ) ) ).

% ATP.lambda_838
tff(fact_7004_ATP_Olambda__839,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: set(C),Uub: fun(B,C)] :
      ( aa(fun(B,C),$o,aa(set(C),fun(fun(B,C),$o),aTP_Lamp_ahi(set(B),fun(set(C),fun(fun(B,C),$o)),Uu),Uua),Uub)
    <=> ( ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),Uu)
           => aa(set(C),$o,member(C,aa(B,C,Uub,X3)),Uua) )
        & ! [A6: B] :
            ( ~ aa(set(B),$o,member(B,A6),Uu)
           => ( aa(B,C,Uub,A6) = undefined(C) ) ) ) ) ).

% ATP.lambda_839
tff(fact_7005_ATP_Olambda__840,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [Uu: fun(list(B),fun(list(B),$o)),Uua: list(B),Uub: list(B)] :
          ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(list(B),fun(list(B),$o)),fun(list(B),fun(list(B),$o)),aTP_Lamp_aio(fun(list(B),fun(list(B),$o)),fun(list(B),fun(list(B),$o))),Uu),Uua),Uub)
        <=> ( ? [Y4: B,Ys2: list(B)] :
                ( ( Uua = nil(B) )
                & ( Uub = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y4),Ys2) ) )
            | ? [X3: B,Y4: B,Xs3: list(B),Ys2: list(B)] :
                ( ( Uua = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X3),Xs3) )
                & ( Uub = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y4),Ys2) )
                & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),Y4) )
            | ? [X3: B,Y4: B,Xs3: list(B),Ys2: list(B)] :
                ( ( Uua = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X3),Xs3) )
                & ( Uub = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y4),Ys2) )
                & ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),Y4)
                & ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y4),X3)
                & aa(list(B),$o,aa(list(B),fun(list(B),$o),Uu,Xs3),Ys2) ) ) ) ) ).

% ATP.lambda_840
tff(fact_7006_ATP_Olambda__841,axiom,
    ! [B: $tType,Uu: fun(list(multiset(B)),fun(list(multiset(B)),$o)),Uua: list(multiset(B)),Uub: list(multiset(B))] :
      ( aa(list(multiset(B)),$o,aa(list(multiset(B)),fun(list(multiset(B)),$o),aa(fun(list(multiset(B)),fun(list(multiset(B)),$o)),fun(list(multiset(B)),fun(list(multiset(B)),$o)),aTP_Lamp_aug(fun(list(multiset(B)),fun(list(multiset(B)),$o)),fun(list(multiset(B)),fun(list(multiset(B)),$o))),Uu),Uua),Uub)
    <=> ( ? [Y4: multiset(B),Ys2: list(multiset(B))] :
            ( ( Uua = nil(multiset(B)) )
            & ( Uub = aa(list(multiset(B)),list(multiset(B)),aa(multiset(B),fun(list(multiset(B)),list(multiset(B))),cons(multiset(B)),Y4),Ys2) ) )
        | ? [X3: multiset(B),Y4: multiset(B),Xs3: list(multiset(B)),Ys2: list(multiset(B))] :
            ( ( Uua = aa(list(multiset(B)),list(multiset(B)),aa(multiset(B),fun(list(multiset(B)),list(multiset(B))),cons(multiset(B)),X3),Xs3) )
            & ( Uub = aa(list(multiset(B)),list(multiset(B)),aa(multiset(B),fun(list(multiset(B)),list(multiset(B))),cons(multiset(B)),Y4),Ys2) )
            & aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),X3),Y4) )
        | ? [X3: multiset(B),Y4: multiset(B),Xs3: list(multiset(B)),Ys2: list(multiset(B))] :
            ( ( Uua = aa(list(multiset(B)),list(multiset(B)),aa(multiset(B),fun(list(multiset(B)),list(multiset(B))),cons(multiset(B)),X3),Xs3) )
            & ( Uub = aa(list(multiset(B)),list(multiset(B)),aa(multiset(B),fun(list(multiset(B)),list(multiset(B))),cons(multiset(B)),Y4),Ys2) )
            & ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),X3),Y4)
            & ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),Y4),X3)
            & aa(list(multiset(B)),$o,aa(list(multiset(B)),fun(list(multiset(B)),$o),Uu,Xs3),Ys2) ) ) ) ).

% ATP.lambda_841
tff(fact_7007_ATP_Olambda__842,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B),Uub: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),aTP_Lamp_ms(set(B),fun(set(B),fun(set(B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,finite_finite2(B),Uub)
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),Uua),Uub)
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),Uub),Uu) ) ) ).

% ATP.lambda_842
tff(fact_7008_ATP_Olambda__843,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),aTP_Lamp_aff(set(product_prod(B,B)),fun(set(B),fun(set(B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,finite_finite2(B),Uua)
        & aa(set(B),$o,finite_finite2(B),Uub)
        & ( Uub != bot_bot(set(B)) )
        & ! [X3: B] :
            ( aa(set(B),$o,member(B,X3),Uua)
           => ? [Xa2: B] :
                ( aa(set(B),$o,member(B,Xa2),Uub)
                & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa2)),Uu) ) ) ) ) ).

% ATP.lambda_843
tff(fact_7009_ATP_Olambda__844,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,B)),Uua: list(B),Uub: list(B)] : ( aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),aTP_Lamp_ayc(fun(B,fun(B,B)),fun(list(B),fun(list(B),list(B))),Uu),Uua),Uub) = aa(list(product_prod(B,B)),list(B),map(product_prod(B,B),B,aa(fun(B,fun(B,B)),fun(product_prod(B,B),B),product_case_prod(B,B,B),Uu)),zip(B,B,Uua,Uub)) ) ).

% ATP.lambda_844
tff(fact_7010_ATP_Olambda__845,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] : ( aa(B,set(B),aa(B,fun(B,set(B)),aTP_Lamp_mr(set(product_prod(B,B)),fun(B,fun(B,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),image(B,B,converse(B,B,Uu)),aa(set(B),set(B),insert(B,Uua),bot_bot(set(B)))) ) ).

% ATP.lambda_845
tff(fact_7011_ATP_Olambda__846,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: list(B),Uub: B] : ( aa(B,fun(list(B),list(B)),aa(list(B),fun(B,fun(list(B),list(B))),aTP_Lamp_ams(fun(B,C),fun(list(B),fun(B,fun(list(B),list(B)))),Uu),Uua),Uub) = case_list(list(B),B,Uua,aa(B,fun(B,fun(list(B),list(B))),aa(list(B),fun(B,fun(B,fun(list(B),list(B)))),aTP_Lamp_amr(fun(B,C),fun(list(B),fun(B,fun(B,fun(list(B),list(B))))),Uu),Uua),Uub)) ) ) ).

% ATP.lambda_846
tff(fact_7012_ATP_Olambda__847,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,B),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_wj(fun(nat,B),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_847
tff(fact_7013_ATP_Olambda__848,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,B),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_wh(fun(nat,B),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_848
tff(fact_7014_ATP_Olambda__849,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,B),Uua: list(B),Uub: C] : ( aa(C,list(B),aa(list(B),fun(C,list(B)),aTP_Lamp_amx(fun(C,B),fun(list(B),fun(C,list(B))),Uu),Uua),Uub) = append(B,Uua,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),aa(C,B,Uu,Uub)),nil(B))) ) ).

% ATP.lambda_849
tff(fact_7015_ATP_Olambda__850,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [Uu: B,Uua: B,Uub: nat] : ( aa(nat,B,aa(B,fun(nat,B),aTP_Lamp_yk(B,fun(B,fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),Uub)),Uua)) ) ) ).

% ATP.lambda_850
tff(fact_7016_ATP_Olambda__851,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: B,Uua: B,Uub: nat] : ( aa(nat,B,aa(B,fun(nat,B),aTP_Lamp_yg(B,fun(B,fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),Uub)),Uua)) ) ) ).

% ATP.lambda_851
tff(fact_7017_ATP_Olambda__852,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: array(B),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avq(nat,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_Pair(array(B),product_prod(heap_ext(product_unit),nat)),Uua),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),one_one(nat)))) ) ) ).

% ATP.lambda_852
tff(fact_7018_ATP_Olambda__853,axiom,
    ! [B: $tType,Uu: B,Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_fb(B,fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(B),$o,member(B,Uub),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uua),aa(set(B),set(B),insert(B,Uu),bot_bot(set(B))))) ) ).

% ATP.lambda_853
tff(fact_7019_ATP_Olambda__854,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: list(B),Uua: array(B),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_avs(list(B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_Pair(array(B),product_prod(heap_ext(product_unit),nat)),Uua),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),aa(list(B),nat,size_size(list(B)),Uu)))) ) ) ).

% ATP.lambda_854
tff(fact_7020_ATP_Olambda__855,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [Uu: B,Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_vj(B,fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_855
tff(fact_7021_ATP_Olambda__856,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,option(C)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_acn(fun(B,option(C)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(B),$o,member(B,Uub),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uua),dom(B,C,Uu))) ) ).

% ATP.lambda_856
tff(fact_7022_ATP_Olambda__857,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,option(C)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_aco(fun(B,option(C)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(B),$o,member(B,Uub),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),Uua),dom(B,C,Uu))) ) ).

% ATP.lambda_857
tff(fact_7023_ATP_Olambda__858,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: array(B),Uub: heap_ext(product_unit)] :
          ( aa(heap_ext(product_unit),$o,aa(array(B),fun(heap_ext(product_unit),$o),aTP_Lamp_awa(nat,fun(array(B),fun(heap_ext(product_unit),$o)),Uu),Uua),Uub)
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uu),array_length(B,Uub,Uua)) ) ) ).

% ATP.lambda_858
tff(fact_7024_ATP_Olambda__859,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B),Uua: nat,Uub: heap_ext(product_unit)] :
          ( aa(heap_ext(product_unit),$o,aa(nat,fun(heap_ext(product_unit),$o),aTP_Lamp_avy(array(B),fun(nat,fun(heap_ext(product_unit),$o)),Uu),Uua),Uub)
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uua),array_length(B,Uub,Uu)) ) ) ).

% ATP.lambda_859
tff(fact_7025_ATP_Olambda__860,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [Uu: B,Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_sg(B,fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_860
tff(fact_7026_ATP_Olambda__861,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_yi(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)) ) ).

% ATP.lambda_861
tff(fact_7027_ATP_Olambda__862,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: B,Uua: C,Uub: D] : ( aa(D,product_prod(B,product_prod(C,D)),aa(C,fun(D,product_prod(B,product_prod(C,D))),aa(B,fun(C,fun(D,product_prod(B,product_prod(C,D)))),aTP_Lamp_akw(B,fun(C,fun(D,product_prod(B,product_prod(C,D))))),Uu),Uua),Uub) = aa(product_prod(C,D),product_prod(B,product_prod(C,D)),aa(B,fun(product_prod(C,D),product_prod(B,product_prod(C,D))),product_Pair(B,product_prod(C,D)),Uu),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),Uua),Uub)) ) ).

% ATP.lambda_862
tff(fact_7028_ATP_Olambda__863,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: C,Uua: B,Uub: D] : ( aa(D,product_prod(B,product_prod(C,D)),aa(B,fun(D,product_prod(B,product_prod(C,D))),aTP_Lamp_aku(C,fun(B,fun(D,product_prod(B,product_prod(C,D)))),Uu),Uua),Uub) = aa(product_prod(C,D),product_prod(B,product_prod(C,D)),aa(B,fun(product_prod(C,D),product_prod(B,product_prod(C,D))),product_Pair(B,product_prod(C,D)),Uua),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),Uu),Uub)) ) ).

% ATP.lambda_863
tff(fact_7029_ATP_Olambda__864,axiom,
    ! [B: $tType,Uu: B,Uua: list(B),Uub: nat] : ( aa(nat,list(B),aa(list(B),fun(nat,list(B)),aTP_Lamp_aql(B,fun(list(B),fun(nat,list(B))),Uu),Uua),Uub) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uu),take(B,Uub,Uua)) ) ).

% ATP.lambda_864
tff(fact_7030_ATP_Olambda__865,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,option(B)),Uua: list(C),Uub: B] : ( aa(B,list(B),aa(list(C),fun(B,list(B)),aTP_Lamp_aim(fun(C,option(B)),fun(list(C),fun(B,list(B))),Uu),Uua),Uub) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),map_filter(C,B,Uu,Uua)) ) ).

% ATP.lambda_865
tff(fact_7031_ATP_Olambda__866,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [Uu: fun(B,C),Uua: set(B),Uub: C] :
          ( aa(C,$o,aa(set(B),fun(C,$o),aTP_Lamp_xq(fun(B,C),fun(set(B),fun(C,$o)),Uu),Uua),Uub)
        <=> aa(set(C),$o,member(C,Uub),aa(set(B),set(C),image2(B,C,Uu),Uua)) ) ) ).

% ATP.lambda_866
tff(fact_7032_ATP_Olambda__867,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_qa(fun(B,set(C)),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),Uua),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_867
tff(fact_7033_ATP_Olambda__868,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_qb(fun(B,set(C)),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),Uua),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_868
tff(fact_7034_ATP_Olambda__869,axiom,
    ! [C: $tType,B: $tType] :
      ( unboun7993243217541854897norder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_xb(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),Uua),aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_869
tff(fact_7035_ATP_Olambda__870,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_xj(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),Uua),aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_870
tff(fact_7036_ATP_Olambda__871,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: C] :
          ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_alv(fun(C,B),fun(B,fun(C,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),aa(C,B,Uu,Uub)) ) ) ).

% ATP.lambda_871
tff(fact_7037_ATP_Olambda__872,axiom,
    ! [C: $tType,B: $tType] :
      ( unboun7993243217541854897norder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_xl(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less(C),Uua),aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_872
tff(fact_7038_ATP_Olambda__873,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_akn(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less(C),Uua),aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_873
tff(fact_7039_ATP_Olambda__874,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(D,B),Uua: fun(C,option(D)),Uub: C] : ( aa(C,option(B),aa(fun(C,option(D)),fun(C,option(B)),aTP_Lamp_acs(fun(D,B),fun(fun(C,option(D)),fun(C,option(B))),Uu),Uua),Uub) = aa(option(D),option(B),map_option(D,B,Uu),aa(C,option(D),Uua,Uub)) ) ).

% ATP.lambda_874
tff(fact_7040_ATP_Olambda__875,axiom,
    ! [B: $tType,Uu: nat,Uua: fun(B,nat),Uub: B] : ( aa(B,nat,aa(fun(B,nat),fun(B,nat),aa(nat,fun(fun(B,nat),fun(B,nat)),aTP_Lamp_apv(nat,fun(fun(B,nat),fun(B,nat))),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),aa(B,nat,Uua,Uub)) ) ).

% ATP.lambda_875
tff(fact_7041_ATP_Olambda__876,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Uu: B,Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ot(B,fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uu),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_876
tff(fact_7042_ATP_Olambda__877,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: nat,Uub: B] : ( aa(B,nat,aa(nat,fun(B,nat),aTP_Lamp_apw(fun(B,nat),fun(nat,fun(B,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(B,nat,Uu,Uub)) ) ).

% ATP.lambda_877
tff(fact_7043_ATP_Olambda__878,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_hu(set(B),fun(fun(C,set(B)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_878
tff(fact_7044_ATP_Olambda__879,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: B,Uua: fun(C,nat),Uub: C] : ( aa(C,B,aa(fun(C,nat),fun(C,B),aTP_Lamp_sd(B,fun(fun(C,nat),fun(C,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Uu),aa(C,nat,Uua,Uub)) ) ) ).

% ATP.lambda_879
tff(fact_7045_ATP_Olambda__880,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_fj(set(B),fun(fun(C,set(B)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_880
tff(fact_7046_ATP_Olambda__881,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: B,Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ig(B,fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Uu),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_881
tff(fact_7047_ATP_Olambda__882,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_gn(set(B),fun(fun(C,set(B)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_882
tff(fact_7048_ATP_Olambda__883,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [Uu: C,Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_ip(C,fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),inf_inf(C),Uu),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_883
tff(fact_7049_ATP_Olambda__884,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: B,Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_gd(B,fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Uu),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_884
tff(fact_7050_ATP_Olambda__885,axiom,
    ! [C: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_yx(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),dvd_dvd(C),Uua),aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_885
tff(fact_7051_ATP_Olambda__886,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: nat,Uua: fun(D,set(old_node(B,C))),Uub: D] : ( aa(D,set(old_node(B,C)),aa(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C))),aTP_Lamp_ayu(nat,fun(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C)))),Uu),Uua),Uub) = old_ntrunc(B,C,Uu,aa(D,set(old_node(B,C)),Uua,Uub)) ) ).

% ATP.lambda_886
tff(fact_7052_ATP_Olambda__887,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: set(old_node(B,C)),Uua: fun(D,set(old_node(B,C))),Uub: D] : ( aa(D,set(old_node(B,C)),aa(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C))),aTP_Lamp_azd(set(old_node(B,C)),fun(fun(D,set(old_node(B,C))),fun(D,set(old_node(B,C)))),Uu),Uua),Uub) = old_Scons(B,C,Uu,aa(D,set(old_node(B,C)),Uua,Uub)) ) ).

% ATP.lambda_887
tff(fact_7053_ATP_Olambda__888,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: filter(C),Uua: fun(B,filter(D)),Uub: B] : ( aa(B,filter(product_prod(C,D)),aa(fun(B,filter(D)),fun(B,filter(product_prod(C,D))),aTP_Lamp_qw(filter(C),fun(fun(B,filter(D)),fun(B,filter(product_prod(C,D)))),Uu),Uua),Uub) = prod_filter(C,D,Uu,aa(B,filter(D),Uua,Uub)) ) ).

% ATP.lambda_888
tff(fact_7054_ATP_Olambda__889,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(B,D),Uua: fun(C,filter(D)),Uub: C] : ( aa(C,filter(B),aa(fun(C,filter(D)),fun(C,filter(B)),aTP_Lamp_afu(fun(B,D),fun(fun(C,filter(D)),fun(C,filter(B))),Uu),Uua),Uub) = filtercomap(B,D,Uu,aa(C,filter(D),Uua,Uub)) ) ).

% ATP.lambda_889
tff(fact_7055_ATP_Olambda__890,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(B,C),Uua: fun(D,filter(C)),Uub: D] : ( aa(D,filter(B),aa(fun(D,filter(C)),fun(D,filter(B)),aTP_Lamp_aft(fun(B,C),fun(fun(D,filter(C)),fun(D,filter(B))),Uu),Uua),Uub) = filtercomap(B,C,Uu,aa(D,filter(C),Uua,Uub)) ) ).

% ATP.lambda_890
tff(fact_7056_ATP_Olambda__891,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType,Uu: fun(B,fun(D,$o)),Uua: fun(E,fun(D,fun(C,$o))),Uub: E] : ( aa(E,fun(B,fun(C,$o)),aa(fun(E,fun(D,fun(C,$o))),fun(E,fun(B,fun(C,$o))),aTP_Lamp_aqy(fun(B,fun(D,$o)),fun(fun(E,fun(D,fun(C,$o))),fun(E,fun(B,fun(C,$o)))),Uu),Uua),Uub) = aa(fun(D,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(D,$o)),fun(fun(D,fun(C,$o)),fun(B,fun(C,$o))),relcompp(B,D,C),Uu),aa(E,fun(D,fun(C,$o)),Uua,Uub)) ) ).

% ATP.lambda_891
tff(fact_7057_ATP_Olambda__892,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(D,C),Uua: B,Uub: D] : ( aa(D,product_prod(B,C),aa(B,fun(D,product_prod(B,C)),aTP_Lamp_ajx(fun(D,C),fun(B,fun(D,product_prod(B,C))),Uu),Uua),Uub) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),aa(D,C,Uu,Uub)) ) ).

% ATP.lambda_892
tff(fact_7058_ATP_Olambda__893,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType,Uu: set(product_prod(B,D)),Uua: fun(E,set(product_prod(D,C))),Uub: E] : ( aa(E,set(product_prod(B,C)),aa(fun(E,set(product_prod(D,C))),fun(E,set(product_prod(B,C))),aTP_Lamp_lz(set(product_prod(B,D)),fun(fun(E,set(product_prod(D,C))),fun(E,set(product_prod(B,C)))),Uu),Uua),Uub) = relcomp(B,D,C,Uu,aa(E,set(product_prod(D,C)),Uua,Uub)) ) ).

% ATP.lambda_893
tff(fact_7059_ATP_Olambda__894,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(C,B),Uua: fun(D,filter(C)),Uub: D] : ( aa(D,filter(B),aa(fun(D,filter(C)),fun(D,filter(B)),aTP_Lamp_pt(fun(C,B),fun(fun(D,filter(C)),fun(D,filter(B))),Uu),Uua),Uub) = filtermap(C,B,Uu,aa(D,filter(C),Uua,Uub)) ) ).

% ATP.lambda_894
tff(fact_7060_ATP_Olambda__895,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: set(product_prod(C,B)),Uua: fun(D,set(C)),Uub: D] : ( aa(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_jn(set(product_prod(C,B)),fun(fun(D,set(C)),fun(D,set(B))),Uu),Uua),Uub) = aa(set(C),set(B),image(C,B,Uu),aa(D,set(C),Uua,Uub)) ) ).

% ATP.lambda_895
tff(fact_7061_ATP_Olambda__896,axiom,
    ! [B: $tType,Uu: $o,Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_nk($o,fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( (Uu)
       => aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_896
tff(fact_7062_ATP_Olambda__897,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(B,C),Uua: fun(D,set(C)),Uub: D] : ( aa(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_gr(fun(B,C),fun(fun(D,set(C)),fun(D,set(B))),Uu),Uua),Uub) = aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Uu),aa(D,set(C),Uua,Uub)) ) ).

% ATP.lambda_897
tff(fact_7063_ATP_Olambda__898,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: C,Uub: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_hm(fun(C,set(B)),fun(C,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(B),$o,member(B,Uub),aa(C,set(B),Uu,Uua)) ) ).

% ATP.lambda_898
tff(fact_7064_ATP_Olambda__899,axiom,
    ! [C: $tType,B: $tType,Uu: C,Uua: fun(B,set(C)),Uub: B] : ( aa(B,set(C),aa(fun(B,set(C)),fun(B,set(C)),aTP_Lamp_gk(C,fun(fun(B,set(C)),fun(B,set(C))),Uu),Uua),Uub) = aa(set(C),set(C),insert(C,Uu),aa(B,set(C),Uua,Uub)) ) ).

% ATP.lambda_899
tff(fact_7065_ATP_Olambda__900,axiom,
    ! [B: $tType,C: $tType,Uu: B,Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_fi(B,fun(fun(C,set(B)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),insert(B,Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_900
tff(fact_7066_ATP_Olambda__901,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(C,B),Uua: fun(D,set(C)),Uub: D] : ( aa(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_gi(fun(C,B),fun(fun(D,set(C)),fun(D,set(B))),Uu),Uua),Uub) = aa(set(C),set(B),image2(C,B,Uu),aa(D,set(C),Uua,Uub)) ) ).

% ATP.lambda_901
tff(fact_7067_ATP_Olambda__902,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,C),Uua: fun(D,set(B)),Uub: D] : ( aa(D,set(C),aa(fun(D,set(B)),fun(D,set(C)),aTP_Lamp_iu(fun(B,C),fun(fun(D,set(B)),fun(D,set(C))),Uu),Uua),Uub) = aa(set(B),set(C),image2(B,C,Uu),aa(D,set(B),Uua,Uub)) ) ).

% ATP.lambda_902
tff(fact_7068_ATP_Olambda__903,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( condit1219197933456340205attice(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,D),Uub: B] : ( aa(B,set(D),aa(fun(C,D),fun(B,set(D)),aTP_Lamp_jv(fun(B,set(C)),fun(fun(C,D),fun(B,set(D))),Uu),Uua),Uub) = aa(set(C),set(D),image2(C,D,Uua),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_903
tff(fact_7069_ATP_Olambda__904,axiom,
    ! [B: $tType,Uu: $o,Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_nj($o,fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( (Uu)
        | aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_904
tff(fact_7070_ATP_Olambda__905,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: B,Uub: $o] :
      ( aa($o,$o,aa(B,fun($o,$o),aTP_Lamp_aez(fun(B,$o),fun(B,fun($o,$o)),Uu),Uua),Uub)
    <=> ( (Uub)
        | aa(B,$o,Uu,Uua) ) ) ).

% ATP.lambda_905
tff(fact_7071_ATP_Olambda__906,axiom,
    ! [B: $tType,Uu: $o,Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_ath($o,fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( (Uu)
        & aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_906
tff(fact_7072_ATP_Olambda__907,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: B,Uub: $o] :
      ( aa($o,$o,aa(B,fun($o,$o),aTP_Lamp_adc(fun(B,$o),fun(B,fun($o,$o)),Uu),Uua),Uub)
    <=> ( (Uub)
        & aa(B,$o,Uu,Uua) ) ) ).

% ATP.lambda_907
tff(fact_7073_ATP_Olambda__908,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: fun(list(B),B),Uua: list(B),Uub: B] :
          ( aa(B,$o,aa(list(B),fun(B,$o),aTP_Lamp_alh(fun(list(B),B),fun(list(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ( Uub = aa(list(B),B,Uu,Uua) ) ) ) ).

% ATP.lambda_908
tff(fact_7074_ATP_Olambda__909,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_er(fun(B,C),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> ( Uub = aa(B,C,Uu,Uua) ) ) ).

% ATP.lambda_909
tff(fact_7075_ATP_Olambda__910,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: B,Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_vl(B,fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_910
tff(fact_7076_ATP_Olambda__911,axiom,
    ! [B: $tType,Uu: list(B),Uua: set(nat),Uub: B] :
      ( aa(B,$o,aa(set(nat),fun(B,$o),aTP_Lamp_ake(list(B),fun(set(nat),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(B),$o,member(B,Uub),aa(list(B),set(B),set2(B),nths(B,Uu,Uua))) ) ).

% ATP.lambda_911
tff(fact_7077_ATP_Olambda__912,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_bba(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(B),$o,member(B,Uub),aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),Uu,Uua))) ) ).

% ATP.lambda_912
tff(fact_7078_ATP_Olambda__913,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: fun(C,B),Uub: B] : ( aa(B,set(B),aa(fun(C,B),fun(B,set(B)),aTP_Lamp_afv(set(product_prod(C,C)),fun(fun(C,B),fun(B,set(B))),Uu),Uua),Uub) = aa(set(C),set(B),image2(C,B,Uua),field2(C,Uu)) ) ).

% ATP.lambda_913
tff(fact_7079_ATP_Olambda__914,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: set(B),Uua: set(D),Uub: fun(B,C)] : ( aa(fun(B,C),set(fun(B,D)),aa(set(D),fun(fun(B,C),set(fun(B,D))),aTP_Lamp_agd(set(B),fun(set(D),fun(fun(B,C),set(fun(B,D)))),Uu),Uua),Uub) = bNF_Wellorder_Func(B,D,Uu,Uua) ) ).

% ATP.lambda_914
tff(fact_7080_ATP_Olambda__915,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B),Uub: B] : ( aa(B,set(B),aa(set(B),fun(B,set(B)),aTP_Lamp_ee(set(B),fun(set(B),fun(B,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uu),Uua) ) ).

% ATP.lambda_915
tff(fact_7081_ATP_Olambda__916,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: set(C),Uub: B] : ( aa(B,set(C),aa(set(C),fun(B,set(C)),aTP_Lamp_bw(set(C),fun(set(C),fun(B,set(C))),Uu),Uua),Uub) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),Uu),Uua) ) ).

% ATP.lambda_916
tff(fact_7082_ATP_Olambda__917,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] : ( aa(B,set(B),aa(B,fun(B,set(B)),aTP_Lamp_afy(set(product_prod(B,B)),fun(B,fun(B,set(B))),Uu),Uua),Uub) = order_underS(B,Uu,Uua) ) ).

% ATP.lambda_917
tff(fact_7083_ATP_Olambda__918,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] : ( aa(B,set(B),aa(B,fun(B,set(B)),aTP_Lamp_jb(set(product_prod(B,B)),fun(B,fun(B,set(B))),Uu),Uua),Uub) = order_above(B,Uu,Uua) ) ).

% ATP.lambda_918
tff(fact_7084_ATP_Olambda__919,axiom,
    ! [C: $tType,B: $tType,Uu: set(set(old_node(B,C))),Uua: set(set(old_node(B,C))),Uub: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(set(old_node(B,C))),aa(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),aTP_Lamp_azi(set(set(old_node(B,C))),fun(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C))))),Uu),Uua),Uub) = old_uprod(B,C,Uu,Uua) ) ).

% ATP.lambda_919
tff(fact_7085_ATP_Olambda__920,axiom,
    ! [C: $tType,B: $tType,Uu: set(set(old_node(B,C))),Uua: set(set(old_node(B,C))),Uub: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(set(old_node(B,C))),aa(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),aTP_Lamp_azh(set(set(old_node(B,C))),fun(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C))))),Uu),Uua),Uub) = old_usum(B,C,Uu,Uua) ) ).

% ATP.lambda_920
tff(fact_7086_ATP_Olambda__921,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: set(C),Uua: set(D),Uub: B] : ( aa(B,set(sum_sum(C,D)),aa(set(D),fun(B,set(sum_sum(C,D))),aTP_Lamp_agl(set(C),fun(set(D),fun(B,set(sum_sum(C,D)))),Uu),Uua),Uub) = sum_Plus(C,D,Uu,Uua) ) ).

% ATP.lambda_921
tff(fact_7087_ATP_Olambda__922,axiom,
    ! [B: $tType,Uu: list(B),Uua: B,Uub: list(B)] : ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),aTP_Lamp_amw(list(B),fun(B,fun(list(B),list(B))),Uu),Uua),Uub) = append(B,Uub,Uu) ) ).

% ATP.lambda_922
tff(fact_7088_ATP_Olambda__923,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: set(C),Uub: B] : ( aa(B,set(C),aa(set(C),fun(B,set(C)),aTP_Lamp_cz(C,fun(set(C),fun(B,set(C))),Uu),Uua),Uub) = aa(set(C),set(C),insert(C,Uu),Uua) ) ).

% ATP.lambda_923
tff(fact_7089_ATP_Olambda__924,axiom,
    ! [B: $tType,C: $tType,E: $tType,Uu: fun(E,C),Uua: set(E),Uub: B] : ( aa(B,set(C),aa(set(E),fun(B,set(C)),aTP_Lamp_em(fun(E,C),fun(set(E),fun(B,set(C))),Uu),Uua),Uub) = aa(set(E),set(C),image2(E,C,Uu),Uua) ) ).

% ATP.lambda_924
tff(fact_7090_ATP_Olambda__925,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: set(C),Uub: B] : ( aa(B,set(B),aa(set(C),fun(B,set(B)),aTP_Lamp_cn(fun(C,B),fun(set(C),fun(B,set(B))),Uu),Uua),Uub) = aa(set(C),set(B),image2(C,B,Uu),Uua) ) ).

% ATP.lambda_925
tff(fact_7091_ATP_Olambda__926,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_ts(fun(B,nat),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),$ite(Uub = Uua,aa(nat,nat,suc,aa(B,nat,Uu,Uub)),aa(B,nat,Uu,Uub))) ) ).

% ATP.lambda_926
tff(fact_7092_ATP_Olambda__927,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_tl(fun(B,nat),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),$ite(aa(B,$o,Uua,Uub),aa(B,nat,Uu,Uub),zero_zero(nat))) ) ).

% ATP.lambda_927
tff(fact_7093_ATP_Olambda__928,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: ref(B),Uua: B,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(B,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_axq(ref(B),fun(B,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(product_unit,fun(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),product_Pair(product_unit,product_prod(heap_ext(product_unit),nat)),product_Unity),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),aa(heap_ext(product_unit),heap_ext(product_unit),ref_set(B,Uu,Uua),Uub)),one_one(nat))) ) ) ).

% ATP.lambda_928
tff(fact_7094_ATP_Olambda__929,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: fun(B,nat),Uub: B] :
      ( aa(B,$o,aa(fun(B,nat),fun(B,$o),aTP_Lamp_tt(fun(B,nat),fun(fun(B,nat),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(B,nat,Uu,Uub)),aa(B,nat,Uua,Uub))) ) ).

% ATP.lambda_929
tff(fact_7095_ATP_Olambda__930,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,C),Uua: fun(B,$o),Uub: C] :
      ( aa(C,$o,aa(fun(B,$o),fun(C,$o),aTP_Lamp_ayg(fun(B,C),fun(fun(B,$o),fun(C,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,Uua,hilbert_inv_into(B,C,top_top(set(B)),Uu,Uub)) ) ).

% ATP.lambda_930
tff(fact_7096_ATP_Olambda__931,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),Uua: fun(B,D),Uub: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] : ( aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C,aa(fun(B,D),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),aTP_Lamp_bbr(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(B,D),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C)),Uu),Uua),Uub) = aa(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C,Uu,aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),comp(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(D,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit),map_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(D,product_prod(heap_ext(product_unit),nat)),product_map_prod(B,D,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),Uua,id(product_prod(heap_ext(product_unit),nat))))),Uub)) ) ).

% ATP.lambda_931
tff(fact_7097_ATP_Olambda__932,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,B),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_ux(fun(nat,B),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_932
tff(fact_7098_ATP_Olambda__933,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,B),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_uw(fun(nat,B),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_933
tff(fact_7099_ATP_Olambda__934,axiom,
    ! [B: $tType,Uu: fun(nat,B),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_ass(fun(nat,B),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ).

% ATP.lambda_934
tff(fact_7100_ATP_Olambda__935,axiom,
    ! [Uu: fun(nat,$o),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_xe(fun(nat,$o),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_935
tff(fact_7101_ATP_Olambda__936,axiom,
    ! [B: $tType,Uu: fun(nat,set(B)),Uua: nat,Uub: nat] : ( aa(nat,set(B),aa(nat,fun(nat,set(B)),aTP_Lamp_sh(fun(nat,set(B)),fun(nat,fun(nat,set(B))),Uu),Uua),Uub) = aa(nat,set(B),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_936
tff(fact_7102_ATP_Olambda__937,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,B),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_sc(fun(nat,B),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_937
tff(fact_7103_ATP_Olambda__938,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,B),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_sb(fun(nat,B),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_938
tff(fact_7104_ATP_Olambda__939,axiom,
    ! [B: $tType,Uu: fun(nat,B),Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_asl(fun(nat,B),fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_939
tff(fact_7105_ATP_Olambda__940,axiom,
    ! [B: $tType,C: $tType,Uu: fun(product_prod(B,C),$o),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_adj(fun(product_prod(B,C),$o),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> aa(product_prod(B,C),$o,Uu,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uub)) ) ).

% ATP.lambda_940
tff(fact_7106_ATP_Olambda__941,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(product_prod(B,C),D),Uua: B,Uub: C] : ( aa(C,D,aa(B,fun(C,D),aTP_Lamp_dr(fun(product_prod(B,C),D),fun(B,fun(C,D)),Uu),Uua),Uub) = aa(product_prod(B,C),D,Uu,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uub)) ) ).

% ATP.lambda_941
tff(fact_7107_ATP_Olambda__942,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: list(B),Uub: nat] :
      ( aa(nat,$o,aa(list(B),fun(nat,$o),aTP_Lamp_ana(fun(B,$o),fun(list(B),fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,Uu,aa(nat,B,nth(B,Uua),Uub)) ) ).

% ATP.lambda_942
tff(fact_7108_ATP_Olambda__943,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Uu: fun(multiset(B),C),Uua: fun(D,multiset(B)),Uub: D] : ( aa(D,C,aa(fun(D,multiset(B)),fun(D,C),aTP_Lamp_ats(fun(multiset(B),C),fun(fun(D,multiset(B)),fun(D,C)),Uu),Uua),Uub) = aa(multiset(B),C,Uu,aa(D,multiset(B),Uua,Uub)) ) ) ).

% ATP.lambda_943
tff(fact_7109_ATP_Olambda__944,axiom,
    ! [C: $tType,D: $tType,E: $tType,B: $tType,Uu: fun(E,fun(C,D)),Uua: fun(B,E),Uub: B] : ( aa(B,fun(C,D),aa(fun(B,E),fun(B,fun(C,D)),aTP_Lamp_dl(fun(E,fun(C,D)),fun(fun(B,E),fun(B,fun(C,D))),Uu),Uua),Uub) = aa(E,fun(C,D),Uu,aa(B,E,Uua,Uub)) ) ).

% ATP.lambda_944
tff(fact_7110_ATP_Olambda__945,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(D,set(B)),Uua: fun(C,D),Uub: C] : ( aa(C,set(B),aa(fun(C,D),fun(C,set(B)),aTP_Lamp_gh(fun(D,set(B)),fun(fun(C,D),fun(C,set(B))),Uu),Uua),Uub) = aa(D,set(B),Uu,aa(C,D,Uua,Uub)) ) ).

% ATP.lambda_945
tff(fact_7111_ATP_Olambda__946,axiom,
    ! [E: $tType,D: $tType,G6: $tType,Uu: fun(D,fun(E,$o)),Uua: fun(G6,D),Uub: G6] : ( aa(G6,fun(E,$o),aa(fun(G6,D),fun(G6,fun(E,$o)),aTP_Lamp_aor(fun(D,fun(E,$o)),fun(fun(G6,D),fun(G6,fun(E,$o))),Uu),Uua),Uub) = aa(D,fun(E,$o),Uu,aa(G6,D,Uua,Uub)) ) ).

% ATP.lambda_946
tff(fact_7112_ATP_Olambda__947,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(D,C),Uua: fun(B,D),Uub: B] : ( aa(B,C,aa(fun(B,D),fun(B,C),aTP_Lamp_awr(fun(D,C),fun(fun(B,D),fun(B,C)),Uu),Uua),Uub) = aa(D,C,Uu,aa(B,D,Uua,Uub)) ) ).

% ATP.lambda_947
tff(fact_7113_ATP_Olambda__948,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(D,B),Uua: fun(C,D),Uub: C] : ( aa(C,B,aa(fun(C,D),fun(C,B),aTP_Lamp_cj(fun(D,B),fun(fun(C,D),fun(C,B)),Uu),Uua),Uub) = aa(D,B,Uu,aa(C,D,Uua,Uub)) ) ).

% ATP.lambda_948
tff(fact_7114_ATP_Olambda__949,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,$o),Uua: fun(B,C),Uub: B] :
      ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_atk(fun(C,$o),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(C,$o,Uu,aa(B,C,Uua,Uub)) ) ).

% ATP.lambda_949
tff(fact_7115_ATP_Olambda__950,axiom,
    ! [D: $tType,C: $tType,E: $tType,Uu: fun(C,fun(D,$o)),Uua: fun(E,C),Uub: E] : ( aa(E,fun(D,$o),aa(fun(E,C),fun(E,fun(D,$o)),aTP_Lamp_fo(fun(C,fun(D,$o)),fun(fun(E,C),fun(E,fun(D,$o))),Uu),Uua),Uub) = aa(C,fun(D,$o),Uu,aa(E,C,Uua,Uub)) ) ).

% ATP.lambda_950
tff(fact_7116_ATP_Olambda__951,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: fun(num,C),Uub: num] : ( aa(num,B,aa(fun(num,C),fun(num,B),aTP_Lamp_abj(fun(C,B),fun(fun(num,C),fun(num,B)),Uu),Uua),Uub) = aa(C,B,Uu,aa(num,C,Uua,Uub)) ) ).

% ATP.lambda_951
tff(fact_7117_ATP_Olambda__952,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: fun(nat,C),Uub: nat] : ( aa(nat,B,aa(fun(nat,C),fun(nat,B),aTP_Lamp_zn(fun(C,B),fun(fun(nat,C),fun(nat,B)),Uu),Uua),Uub) = aa(C,B,Uu,aa(nat,C,Uua,Uub)) ) ).

% ATP.lambda_952
tff(fact_7118_ATP_Olambda__953,axiom,
    ! [B: $tType,C: $tType,E: $tType,Uu: fun(C,B),Uua: fun(E,C),Uub: E] : ( aa(E,B,aa(fun(E,C),fun(E,B),aTP_Lamp_awi(fun(C,B),fun(fun(E,C),fun(E,B)),Uu),Uua),Uub) = aa(C,B,Uu,aa(E,C,Uua,Uub)) ) ).

% ATP.lambda_953
tff(fact_7119_ATP_Olambda__954,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(C,B),Uua: fun(D,C),Uub: D] : ( aa(D,B,aa(fun(D,C),fun(D,B),aTP_Lamp_cc(fun(C,B),fun(fun(D,C),fun(D,B)),Uu),Uua),Uub) = aa(C,B,Uu,aa(D,C,Uua,Uub)) ) ).

% ATP.lambda_954
tff(fact_7120_ATP_Olambda__955,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(C) )
     => ! [Uu: fun(B,C),Uua: fun(D,B),Uub: D] : ( aa(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_kk(fun(B,C),fun(fun(D,B),fun(D,C)),Uu),Uua),Uub) = aa(B,C,Uu,aa(D,B,Uua,Uub)) ) ) ).

% ATP.lambda_955
tff(fact_7121_ATP_Olambda__956,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(C) )
     => ! [Uu: fun(B,C),Uua: fun(D,B),Uub: D] : ( aa(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_lb(fun(B,C),fun(fun(D,B),fun(D,C)),Uu),Uua),Uub) = aa(B,C,Uu,aa(D,B,Uua,Uub)) ) ) ).

% ATP.lambda_956
tff(fact_7122_ATP_Olambda__957,axiom,
    ! [B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(C)
        & comple6319245703460814977attice(B) )
     => ! [Uu: fun(B,C),Uua: fun(C,B),Uub: C] : ( aa(C,C,aa(fun(C,B),fun(C,C),aTP_Lamp_mm(fun(B,C),fun(fun(C,B),fun(C,C)),Uu),Uua),Uub) = aa(B,C,Uu,aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_957
tff(fact_7123_ATP_Olambda__958,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,$o),Uua: fun(C,B),Uub: C] :
      ( aa(C,$o,aa(fun(C,B),fun(C,$o),aTP_Lamp_nm(fun(B,$o),fun(fun(C,B),fun(C,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,Uu,aa(C,B,Uua,Uub)) ) ).

% ATP.lambda_958
tff(fact_7124_ATP_Olambda__959,axiom,
    ! [C: $tType,B: $tType,F10: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(F10,B),Uub: F10] : ( aa(F10,fun(C,$o),aa(fun(F10,B),fun(F10,fun(C,$o)),aTP_Lamp_aoq(fun(B,fun(C,$o)),fun(fun(F10,B),fun(F10,fun(C,$o))),Uu),Uua),Uub) = aa(B,fun(C,$o),Uu,aa(F10,B,Uua,Uub)) ) ).

% ATP.lambda_959
tff(fact_7125_ATP_Olambda__960,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(D,B),Uub: D] : ( aa(D,fun(C,$o),aa(fun(D,B),fun(D,fun(C,$o)),aTP_Lamp_aoe(fun(B,fun(C,$o)),fun(fun(D,B),fun(D,fun(C,$o))),Uu),Uua),Uub) = aa(B,fun(C,$o),Uu,aa(D,B,Uua,Uub)) ) ).

% ATP.lambda_960
tff(fact_7126_ATP_Olambda__961,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,C),Uua: fun(D,B),Uub: D] : ( aa(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_mx(fun(B,C),fun(fun(D,B),fun(D,C)),Uu),Uua),Uub) = aa(B,C,Uu,aa(D,B,Uua,Uub)) ) ).

% ATP.lambda_961
tff(fact_7127_ATP_Olambda__962,axiom,
    ! [E: $tType,D: $tType,Uu: fun(D,E),Uua: fun(E,$o),Uub: D] :
      ( aa(D,$o,aa(fun(E,$o),fun(D,$o),aTP_Lamp_arn(fun(D,E),fun(fun(E,$o),fun(D,$o)),Uu),Uua),Uub)
    <=> aa(E,$o,Uua,aa(D,E,Uu,Uub)) ) ).

% ATP.lambda_962
tff(fact_7128_ATP_Olambda__963,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(C,D),Uua: fun(D,B),Uub: C] : ( aa(C,B,aa(fun(D,B),fun(C,B),aTP_Lamp_asm(fun(C,D),fun(fun(D,B),fun(C,B)),Uu),Uua),Uub) = aa(D,B,Uua,aa(C,D,Uu,Uub)) ) ).

% ATP.lambda_963
tff(fact_7129_ATP_Olambda__964,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: fun(B,$o),Uub: C] :
      ( aa(C,$o,aa(fun(B,$o),fun(C,$o),aTP_Lamp_afa(fun(C,B),fun(fun(B,$o),fun(C,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,Uua,aa(C,B,Uu,Uub)) ) ).

% ATP.lambda_964
tff(fact_7130_ATP_Olambda__965,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(C,B),Uua: fun(B,D),Uub: C] : ( aa(C,D,aa(fun(B,D),fun(C,D),aTP_Lamp_kz(fun(C,B),fun(fun(B,D),fun(C,D)),Uu),Uua),Uub) = aa(B,D,Uua,aa(C,B,Uu,Uub)) ) ).

% ATP.lambda_965
tff(fact_7131_ATP_Olambda__966,axiom,
    ! [C: $tType,B: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(C) )
     => ! [Uu: fun(B,C),Uua: fun(C,B),Uub: B] : ( aa(B,B,aa(fun(C,B),fun(B,B),aTP_Lamp_ml(fun(B,C),fun(fun(C,B),fun(B,B)),Uu),Uua),Uub) = aa(C,B,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_966
tff(fact_7132_ATP_Olambda__967,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: fun(C,$o),Uub: B] :
      ( aa(B,$o,aa(fun(C,$o),fun(B,$o),aTP_Lamp_bl(fun(B,C),fun(fun(C,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(C,$o,Uua,aa(B,C,Uu,Uub)) ) ).

% ATP.lambda_967
tff(fact_7133_ATP_Olambda__968,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [Uu: fun(B,C),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_oz(fun(B,C),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(C,D,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_968
tff(fact_7134_ATP_Olambda__969,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(D)
     => ! [Uu: fun(B,C),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_pa(fun(B,C),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(C,D,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_969
tff(fact_7135_ATP_Olambda__970,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( semiring_1(D)
     => ! [Uu: fun(B,C),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_rp(fun(B,C),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(C,D,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_970
tff(fact_7136_ATP_Olambda__971,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(B,C),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_afs(fun(B,C),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(C,D,Uua,aa(B,C,Uu,Uub)) ) ).

% ATP.lambda_971
tff(fact_7137_ATP_Olambda__972,axiom,
    ! [B: $tType,Uu: fun(code_natural,B),Uua: code_natural,Uub: B] : ( aa(B,B,aa(code_natural,fun(B,B),aTP_Lamp_axs(fun(code_natural,B),fun(code_natural,fun(B,B)),Uu),Uua),Uub) = aa(code_natural,B,Uu,Uua) ) ).

% ATP.lambda_972
tff(fact_7138_ATP_Olambda__973,axiom,
    ! [B: $tType,C: $tType,E: $tType,Uu: fun(E,set(C)),Uua: E,Uub: B] : ( aa(B,set(C),aa(E,fun(B,set(C)),aTP_Lamp_fq(fun(E,set(C)),fun(E,fun(B,set(C))),Uu),Uua),Uub) = aa(E,set(C),Uu,Uua) ) ).

% ATP.lambda_973
tff(fact_7139_ATP_Olambda__974,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(D,fun(B,D)),Uua: D,Uub: C] : ( aa(C,fun(B,D),aa(D,fun(C,fun(B,D)),aTP_Lamp_ajl(fun(D,fun(B,D)),fun(D,fun(C,fun(B,D))),Uu),Uua),Uub) = aa(D,fun(B,D),Uu,Uua) ) ).

% ATP.lambda_974
tff(fact_7140_ATP_Olambda__975,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,$o),Uua: C,Uub: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_qu(fun(C,$o),fun(C,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(C,$o,Uu,Uua) ) ).

% ATP.lambda_975
tff(fact_7141_ATP_Olambda__976,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,$o),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_awm(fun(B,$o),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,Uu,Uua) ) ).

% ATP.lambda_976
tff(fact_7142_ATP_Olambda__977,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(B,D),Uua: B,Uub: C] : ( aa(C,D,aa(B,fun(C,D),aTP_Lamp_dd(fun(B,D),fun(B,fun(C,D)),Uu),Uua),Uub) = aa(B,D,Uu,Uua) ) ).

% ATP.lambda_977
tff(fact_7143_ATP_Olambda__978,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(B,C),Uua: B,Uub: D] : ( aa(D,C,aa(B,fun(D,C),aTP_Lamp_di(fun(B,C),fun(B,fun(D,C)),Uu),Uua),Uub) = aa(B,C,Uu,Uua) ) ).

% ATP.lambda_978
tff(fact_7144_ATP_Olambda__979,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: fun(C,heap_Time_Heap(B)),Uub: product_unit] : ( aa(product_unit,heap_Time_Heap(B),aa(fun(C,heap_Time_Heap(B)),fun(product_unit,heap_Time_Heap(B)),aTP_Lamp_axf(C,fun(fun(C,heap_Time_Heap(B)),fun(product_unit,heap_Time_Heap(B))),Uu),Uua),Uub) = aa(C,heap_Time_Heap(B),Uua,Uu) ) ).

% ATP.lambda_979
tff(fact_7145_ATP_Olambda__980,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] : ( aa(B,fun(product_prod(B,B),$o),aa(B,fun(B,fun(product_prod(B,B),$o)),aTP_Lamp_jd(set(product_prod(B,B)),fun(B,fun(B,fun(product_prod(B,B),$o))),Uu),Uua),Uub) = aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(B,fun(B,fun(B,$o)),aa(B,fun(B,fun(B,fun(B,$o))),aTP_Lamp_jc(set(product_prod(B,B)),fun(B,fun(B,fun(B,fun(B,$o)))),Uu),Uua),Uub)) ) ).

% ATP.lambda_980
tff(fact_7146_ATP_Olambda__981,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: option(B)] : ( aa(option(B),option(B),aa(B,fun(option(B),option(B)),aTP_Lamp_ahb(fun(B,fun(B,B)),fun(B,fun(option(B),option(B))),Uu),Uua),Uub) = aa(B,option(B),some(B),case_option(B,B,Uua,aa(B,fun(B,B),Uu,Uua),Uub)) ) ).

% ATP.lambda_981
tff(fact_7147_ATP_Olambda__982,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: B] : ( aa(B,option(B),aa(B,fun(B,option(B)),aTP_Lamp_auo(fun(B,fun(B,B)),fun(B,fun(B,option(B))),Uu),Uua),Uub) = aa(B,option(B),some(B),aa(B,B,aa(B,fun(B,B),Uu,Uua),Uub)) ) ).

% ATP.lambda_982
tff(fact_7148_ATP_Olambda__983,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,fun(C,fun(D,$o))),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_awo(fun(B,fun(C,fun(D,$o))),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> ? [X_12: D] : aa(D,$o,aa(C,fun(D,$o),aa(B,fun(C,fun(D,$o)),Uu,Uua),Uub),X_12) ) ).

% ATP.lambda_983
tff(fact_7149_ATP_Olambda__984,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: multiset(C),Uub: D] : ( aa(D,B,aa(multiset(C),fun(D,B),aTP_Lamp_aqo(fun(C,fun(D,B)),fun(multiset(C),fun(D,B)),Uu),Uua),Uub) = aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,aa(D,fun(C,B),aTP_Lamp_oi(fun(C,fun(D,B)),fun(D,fun(C,B)),Uu),Uub)),Uua)) ) ) ).

% ATP.lambda_984
tff(fact_7150_ATP_Olambda__985,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: multiset(C),Uub: D] : ( aa(D,B,aa(multiset(C),fun(D,B),aTP_Lamp_apk(fun(C,fun(D,B)),fun(multiset(C),fun(D,B)),Uu),Uua),Uub) = comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(D,fun(C,B),aTP_Lamp_of(fun(C,fun(D,B)),fun(D,fun(C,B)),Uu),Uub)),Uua)) ) ) ).

% ATP.lambda_985
tff(fact_7151_ATP_Olambda__986,axiom,
    ! [C: $tType,D: $tType,B: $tType,F10: $tType,E: $tType,Uu: fun(C,fun(D,fun(E,fun(F10,set(B))))),Uua: set(product_prod(E,F10)),Uub: product_prod(C,D)] : ( aa(product_prod(C,D),set(B),aa(set(product_prod(E,F10)),fun(product_prod(C,D),set(B)),aTP_Lamp_hs(fun(C,fun(D,fun(E,fun(F10,set(B))))),fun(set(product_prod(E,F10)),fun(product_prod(C,D),set(B))),Uu),Uua),Uub) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(product_prod(E,F10)),set(set(B)),image2(product_prod(E,F10),set(B),aa(product_prod(C,D),fun(product_prod(E,F10),set(B)),aTP_Lamp_hr(fun(C,fun(D,fun(E,fun(F10,set(B))))),fun(product_prod(C,D),fun(product_prod(E,F10),set(B))),Uu),Uub)),Uua)) ) ).

% ATP.lambda_986
tff(fact_7152_ATP_Olambda__987,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: set(C),Uub: D] : ( aa(D,B,aa(set(C),fun(D,B),aTP_Lamp_fv(fun(C,fun(D,B)),fun(set(C),fun(D,B)),Uu),Uua),Uub) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(D,fun(C,B),aTP_Lamp_fu(fun(C,fun(D,B)),fun(D,fun(C,B)),Uu),Uub)),Uua)) ) ) ).

% ATP.lambda_987
tff(fact_7153_ATP_Olambda__988,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: set(C),Uub: D] : ( aa(D,B,aa(set(C),fun(D,B),aTP_Lamp_ic(fun(C,fun(D,B)),fun(set(C),fun(D,B)),Uu),Uua),Uub) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(D,fun(C,B),aTP_Lamp_fu(fun(C,fun(D,B)),fun(D,fun(C,B)),Uu),Uub)),Uua)) ) ) ).

% ATP.lambda_988
tff(fact_7154_ATP_Olambda__989,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: multiset(D),Uub: C] : ( aa(C,B,aa(multiset(D),fun(C,B),aTP_Lamp_aqn(fun(C,fun(D,B)),fun(multiset(D),fun(C,B)),Uu),Uua),Uub) = aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(D),multiset(B),image_mset(D,B,aa(C,fun(D,B),Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_989
tff(fact_7155_ATP_Olambda__990,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: multiset(D),Uub: C] : ( aa(C,B,aa(multiset(D),fun(C,B),aTP_Lamp_apj(fun(C,fun(D,B)),fun(multiset(D),fun(C,B)),Uu),Uua),Uub) = comm_m7189776963980413722m_mset(B,aa(multiset(D),multiset(B),image_mset(D,B,aa(C,fun(D,B),Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_990
tff(fact_7156_ATP_Olambda__991,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: set(D),Uub: C] : ( aa(C,B,aa(set(D),fun(C,B),aTP_Lamp_ft(fun(C,fun(D,B)),fun(set(D),fun(C,B)),Uu),Uua),Uub) = aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,aa(C,fun(D,B),Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_991
tff(fact_7157_ATP_Olambda__992,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(B,fun(C,set(D))),Uua: set(C),Uub: B] : ( aa(B,set(D),aa(set(C),fun(B,set(D)),aTP_Lamp_ki(fun(B,fun(C,set(D))),fun(set(C),fun(B,set(D))),Uu),Uua),Uub) = aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),aa(B,fun(C,set(D)),Uu,Uub)),Uua)) ) ).

% ATP.lambda_992
tff(fact_7158_ATP_Olambda__993,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(C,fun(D,B)),Uua: set(D),Uub: C] : ( aa(C,B,aa(set(D),fun(C,B),aTP_Lamp_ib(fun(C,fun(D,B)),fun(set(D),fun(C,B)),Uu),Uua),Uub) = aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,aa(C,fun(D,B),Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_993
tff(fact_7159_ATP_Olambda__994,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,C),Uua: C,Uub: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_kw(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,C,Uu,Uub) != Uua ) ) ).

% ATP.lambda_994
tff(fact_7160_ATP_Olambda__995,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: fun(B,C),Uub: B] :
      ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_kx(C,fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,C,Uua,Uub) != Uu ) ) ).

% ATP.lambda_995
tff(fact_7161_ATP_Olambda__996,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),Uua: set(old_node(B,C)),Uub: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_azc(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),Uu),Uua),Uub) = aa(set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),complete_Sup_Sup(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),image2(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),fun(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),product_case_prod(set(old_node(B,C)),set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),aTP_Lamp_azb(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))))),Uua),Uub))),Uu)) ) ).

% ATP.lambda_996
tff(fact_7162_ATP_Olambda__997,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(D,set(B)),Uua: fun(C,set(D)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(D)),fun(C,set(B)),aTP_Lamp_fz(fun(D,set(B)),fun(fun(C,set(D)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),Uu),aa(C,set(D),Uua,Uub))) ) ).

% ATP.lambda_997
tff(fact_7163_ATP_Olambda__998,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(C,set(B)),Uua: fun(D,set(C)),Uub: D] : ( aa(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_ga(fun(C,set(B)),fun(fun(D,set(C)),fun(D,set(B))),Uu),Uua),Uub) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),Uu),aa(D,set(C),Uua,Uub))) ) ).

% ATP.lambda_998
tff(fact_7164_ATP_Olambda__999,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(C,B),Uua: fun(D,set(C)),Uub: D] : ( aa(D,B,aa(fun(D,set(C)),fun(D,B),aTP_Lamp_fp(fun(C,B),fun(fun(D,set(C)),fun(D,B)),Uu),Uua),Uub) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Uu),aa(D,set(C),Uua,Uub))) ) ) ).

% ATP.lambda_999
tff(fact_7165_ATP_Olambda__1000,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( condit1219197933456340205attice(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_jw(fun(B,set(C)),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(set(D),D,complete_Sup_Sup(D),aa(set(C),set(D),image2(C,D,Uua),aa(B,set(C),Uu,Uub))) ) ) ).

% ATP.lambda_1000
tff(fact_7166_ATP_Olambda__1001,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(D,set(B)),Uua: fun(C,set(D)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(D)),fun(C,set(B)),aTP_Lamp_im(fun(D,set(B)),fun(fun(C,set(D)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(D),set(set(B)),image2(D,set(B),Uu),aa(C,set(D),Uua,Uub))) ) ).

% ATP.lambda_1001
tff(fact_7167_ATP_Olambda__1002,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( condit1219197933456340205attice(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_jx(fun(B,set(C)),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(set(D),D,complete_Inf_Inf(D),aa(set(C),set(D),image2(C,D,Uua),aa(B,set(C),Uu,Uub))) ) ) ).

% ATP.lambda_1002
tff(fact_7168_ATP_Olambda__1003,axiom,
    ! [C: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_yy(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> ~ aa(C,$o,aa(C,fun(C,$o),dvd_dvd(C),Uua),aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_1003
tff(fact_7169_ATP_Olambda__1004,axiom,
    ! [B: $tType,C: $tType,E: $tType,Uu: fun(E,set(C)),Uua: set(E),Uub: B] : ( aa(B,set(C),aa(set(E),fun(B,set(C)),aTP_Lamp_fs(fun(E,set(C)),fun(set(E),fun(B,set(C))),Uu),Uua),Uub) = aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(E),set(set(C)),image2(E,set(C),Uu),Uua)) ) ).

% ATP.lambda_1004
tff(fact_7170_ATP_Olambda__1005,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: C,Uub: list(C)] : ( aa(list(C),fun(list(B),list(B)),aa(C,fun(list(C),fun(list(B),list(B))),aTP_Lamp_aom(fun(C,B),fun(C,fun(list(C),fun(list(B),list(B)))),Uu),Uua),Uub) = aa(B,fun(list(B),list(B)),cons(B),aa(C,B,Uu,Uua)) ) ).

% ATP.lambda_1005
tff(fact_7171_ATP_Olambda__1006,axiom,
    ! [C: $tType,B: $tType,Uu: set(C),Uua: fun(B,fun(C,$o)),Uub: B] : ( aa(B,nat,aa(fun(B,fun(C,$o)),fun(B,nat),aTP_Lamp_rl(set(C),fun(fun(B,fun(C,$o)),fun(B,nat)),Uu),Uua),Uub) = aa(set(C),nat,finite_card(C),aa(fun(C,$o),set(C),collect(C),aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aTP_Lamp_ol(set(C),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),Uu),Uua),Uub))) ) ).

% ATP.lambda_1006
tff(fact_7172_ATP_Olambda__1007,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,fun(C,fun(D,$o))),Uua: B,Uub: D] :
      ( aa(D,$o,aa(B,fun(D,$o),aTP_Lamp_awp(fun(B,fun(C,fun(D,$o))),fun(B,fun(D,$o)),Uu),Uua),Uub)
    <=> ? [B5: C] : aa(D,$o,aa(C,fun(D,$o),aa(B,fun(C,fun(D,$o)),Uu,Uua),B5),Uub) ) ).

% ATP.lambda_1007
tff(fact_7173_ATP_Olambda__1008,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,fun(C,fun(D,$o))),Uua: C,Uub: D] :
      ( aa(D,$o,aa(C,fun(D,$o),aTP_Lamp_awq(fun(B,fun(C,fun(D,$o))),fun(C,fun(D,$o)),Uu),Uua),Uub)
    <=> ? [A6: B] : aa(D,$o,aa(C,fun(D,$o),aa(B,fun(C,fun(D,$o)),Uu,A6),Uua),Uub) ) ).

% ATP.lambda_1008
tff(fact_7174_ATP_Olambda__1009,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,fun(C,D)),Uua: set(D),Uub: B] :
      ( aa(B,$o,aa(set(D),fun(B,$o),aTP_Lamp_ed(fun(B,fun(C,D)),fun(set(D),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [B5: C] : aa(set(D),$o,member(D,aa(C,D,aa(B,fun(C,D),Uu,Uub),B5)),Uua) ) ).

% ATP.lambda_1009
tff(fact_7175_ATP_Olambda__1010,axiom,
    ! [B: $tType,C: $tType,Uu: list(B),Uua: list(C),Uub: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(list(C),fun(product_prod(B,C),$o),aTP_Lamp_aji(list(B),fun(list(C),fun(product_prod(B,C),$o)),Uu),Uua),Uub)
    <=> ? [I5: nat] :
          ( ( Uub = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(nat,B,nth(B,Uu),I5)),aa(nat,C,nth(C,Uua),I5)) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I5),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(B),nat,size_size(list(B)),Uu)),aa(list(C),nat,size_size(list(C)),Uua))) ) ) ).

% ATP.lambda_1010
tff(fact_7176_ATP_Olambda__1011,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: fun(B,C),Uub: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(fun(B,C),fun(product_prod(B,C),$o),aTP_Lamp_ex(set(B),fun(fun(B,C),fun(product_prod(B,C),$o)),Uu),Uua),Uub)
    <=> ? [A6: B] :
          ( ( Uub = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A6),aa(B,C,Uua,A6)) )
          & aa(set(B),$o,member(B,A6),Uu) ) ) ).

% ATP.lambda_1011
tff(fact_7177_ATP_Olambda__1012,axiom,
    ! [B: $tType,Uu: list(B),Uua: set(nat),Uub: B] :
      ( aa(B,$o,aa(set(nat),fun(B,$o),aTP_Lamp_ajp(list(B),fun(set(nat),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [I5: nat] :
          ( ( Uub = aa(nat,B,nth(B,Uu),I5) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I5),aa(list(B),nat,size_size(list(B)),Uu))
          & aa(set(nat),$o,member(nat,I5),Uua) ) ) ).

% ATP.lambda_1012
tff(fact_7178_ATP_Olambda__1013,axiom,
    ! [B: $tType,Uu: nat,Uua: list(B),Uub: B] :
      ( aa(B,$o,aa(list(B),fun(B,$o),aTP_Lamp_aoc(nat,fun(list(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [I5: nat] :
          ( ( Uub = aa(nat,B,nth(B,Uua),I5) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uu),I5)
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I5),aa(list(B),nat,size_size(list(B)),Uua)) ) ) ).

% ATP.lambda_1013
tff(fact_7179_ATP_Olambda__1014,axiom,
    ! [C: $tType,B: $tType,Uu: set(C),Uua: fun(C,set(B)),Uub: B] :
      ( aa(B,$o,aa(fun(C,set(B)),fun(B,$o),aTP_Lamp_ahh(set(C),fun(fun(C,set(B)),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: set(B)] :
          ( aa(set(set(B)),$o,member(set(B),X3),aa(set(C),set(set(B)),image2(C,set(B),Uua),Uu))
          & aa(set(B),$o,member(B,Uub),X3) ) ) ).

% ATP.lambda_1014
tff(fact_7180_ATP_Olambda__1015,axiom,
    ! [B: $tType,Uu: set(set(product_prod(B,B))),Uua: set(product_prod(B,B)),Uub: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),aTP_Lamp_agk(set(set(product_prod(B,B))),fun(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o)),Uu),Uua),Uub)
    <=> ? [R6: set(product_prod(B,B))] :
          ( ( Uub = aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R6),Uua) )
          & aa(set(set(product_prod(B,B))),$o,member(set(product_prod(B,B)),R6),Uu) ) ) ).

% ATP.lambda_1015
tff(fact_7181_ATP_Olambda__1016,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Uu: set(B),Uua: B,Uub: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_nv(set(B),fun(B,fun(B,$o)),Uu),Uua),Uub)
        <=> ? [A6: B] :
              ( ( Uub = aa(B,B,aa(B,fun(B,B),sup_sup(B),Uua),A6) )
              & aa(set(B),$o,member(B,A6),Uu) ) ) ) ).

% ATP.lambda_1016
tff(fact_7182_ATP_Olambda__1017,axiom,
    ! [B: $tType] :
      ( finite8700451911770168679attice(B)
     => ! [Uu: B,Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_hh(B,fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ? [B5: B] :
              ( ( Uub = aa(B,B,aa(B,fun(B,B),inf_inf(B),Uu),B5) )
              & aa(set(B),$o,member(B,B5),Uua) ) ) ) ).

% ATP.lambda_1017
tff(fact_7183_ATP_Olambda__1018,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Uu: set(B),Uua: B,Uub: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_nb(set(B),fun(B,fun(B,$o)),Uu),Uua),Uub)
        <=> ? [A6: B] :
              ( ( Uub = aa(B,B,aa(B,fun(B,B),inf_inf(B),Uua),A6) )
              & aa(set(B),$o,member(B,A6),Uu) ) ) ) ).

% ATP.lambda_1018
tff(fact_7184_ATP_Olambda__1019,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: multiset(B),Uub: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_aud(set(multiset(B)),fun(multiset(B),fun(multiset(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: multiset(B)] :
          ( ( Uub = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),Uua),A6) )
          & aa(set(multiset(B)),$o,member(multiset(B),A6),Uu) ) ) ).

% ATP.lambda_1019
tff(fact_7185_ATP_Olambda__1020,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: multiset(B),Uub: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_atz(set(multiset(B)),fun(multiset(B),fun(multiset(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: multiset(B)] :
          ( ( Uub = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),Uua),A6) )
          & aa(set(multiset(B)),$o,member(multiset(B),A6),Uu) ) ) ).

% ATP.lambda_1020
tff(fact_7186_ATP_Olambda__1021,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: list(C),Uub: set(B)] :
      ( aa(set(B),$o,aa(list(C),fun(set(B),$o),aTP_Lamp_ajh(fun(C,set(B)),fun(list(C),fun(set(B),$o)),Uu),Uua),Uub)
    <=> ? [I5: nat] :
          ( ( Uub = aa(C,set(B),Uu,aa(nat,C,nth(C,Uua),I5)) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I5),aa(list(C),nat,size_size(list(C)),Uua)) ) ) ).

% ATP.lambda_1021
tff(fact_7187_ATP_Olambda__1022,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: list(C),Uub: set(B)] :
      ( aa(set(B),$o,aa(list(C),fun(set(B),$o),aTP_Lamp_ajo(fun(C,set(B)),fun(list(C),fun(set(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: C] :
          ( ( Uub = aa(C,set(B),Uu,A6) )
          & aa(set(C),$o,member(C,A6),aa(list(C),set(C),set2(C),Uua)) ) ) ).

% ATP.lambda_1022
tff(fact_7188_ATP_Olambda__1023,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: set(C),Uub: B] :
      ( aa(B,$o,aa(set(C),fun(B,$o),aTP_Lamp_ch(fun(C,B),fun(set(C),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: C] :
          ( ( Uub = aa(C,B,Uu,X3) )
          & aa(set(C),$o,member(C,X3),Uua) ) ) ).

% ATP.lambda_1023
tff(fact_7189_ATP_Olambda__1024,axiom,
    ! [C: $tType,D: $tType,Uu: fun(C,set(D)),Uua: fun(D,$o),Uub: C] :
      ( aa(C,$o,aa(fun(D,$o),fun(C,$o),aTP_Lamp_ade(fun(C,set(D)),fun(fun(D,$o),fun(C,$o)),Uu),Uua),Uub)
    <=> ! [X3: D] :
          ( aa(set(D),$o,member(D,X3),aa(C,set(D),Uu,Uub))
         => aa(D,$o,Uua,X3) ) ) ).

% ATP.lambda_1024
tff(fact_7190_ATP_Olambda__1025,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: fun(C,$o),Uub: set(B)] :
      ( aa(set(B),$o,aa(fun(C,$o),fun(set(B),$o),aTP_Lamp_fw(fun(C,set(B)),fun(fun(C,$o),fun(set(B),$o)),Uu),Uua),Uub)
    <=> ? [X3: C] :
          ( ( Uub = aa(C,set(B),Uu,X3) )
          & aa(C,$o,Uua,X3) ) ) ).

% ATP.lambda_1025
tff(fact_7191_ATP_Olambda__1026,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: fun(C,$o),Uub: B] :
      ( aa(B,$o,aa(fun(C,$o),fun(B,$o),aTP_Lamp_ci(fun(C,B),fun(fun(C,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: C] :
          ( ( Uub = aa(C,B,Uu,X3) )
          & aa(C,$o,Uua,X3) ) ) ).

% ATP.lambda_1026
tff(fact_7192_ATP_Olambda__1027,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,$o),Uua: fun(B,C),Uub: C] :
      ( aa(C,$o,aa(fun(B,C),fun(C,$o),aTP_Lamp_ks(fun(B,$o),fun(fun(B,C),fun(C,$o)),Uu),Uua),Uub)
    <=> ? [X3: B] :
          ( ( Uub = aa(B,C,Uua,X3) )
          & aa(B,$o,Uu,X3) ) ) ).

% ATP.lambda_1027
tff(fact_7193_ATP_Olambda__1028,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(D,fun(B,$o)),Uub: D] :
      ( aa(D,$o,aa(fun(D,fun(B,$o)),fun(D,$o),aTP_Lamp_arh(fun(B,fun(C,$o)),fun(fun(D,fun(B,$o)),fun(D,$o)),Uu),Uua),Uub)
    <=> ? [X3: B] :
          ( aa(set(B),$o,member(B,X3),aa(fun(B,$o),set(B),collect(B),aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),Uu)))
          & aa(B,$o,aa(D,fun(B,$o),Uua,Uub),X3) ) ) ).

% ATP.lambda_1028
tff(fact_7194_ATP_Olambda__1029,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(B,D),Uub: fun(B,D)] :
      ( aa(fun(B,D),$o,aa(fun(B,D),fun(fun(B,D),$o),aTP_Lamp_ark(fun(B,fun(C,$o)),fun(fun(B,D),fun(fun(B,D),$o)),Uu),Uua),Uub)
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),aa(fun(B,$o),set(B),collect(B),aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),Uu)))
         => ( aa(B,D,Uua,X3) = aa(B,D,Uub,X3) ) ) ) ).

% ATP.lambda_1029
tff(fact_7195_ATP_Olambda__1030,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,option(B)),Uua: list(C),Uub: B] :
      ( aa(B,$o,aa(list(C),fun(B,$o),aTP_Lamp_aib(fun(C,option(B)),fun(list(C),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: C] :
          ( aa(set(C),$o,member(C,X3),aa(list(C),set(C),set2(C),Uua))
          & ( aa(C,option(B),Uu,X3) = aa(B,option(B),some(B),Uub) ) ) ) ).

% ATP.lambda_1030
tff(fact_7196_ATP_Olambda__1031,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: fun(B,fun(C,$o)),Uub: B] :
      ( aa(B,$o,aa(fun(B,fun(C,$o)),fun(B,$o),aTP_Lamp_adh(set(C),fun(fun(B,fun(C,$o)),fun(B,$o)),Uu),Uua),Uub)
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),Uu)
         => aa(C,$o,aa(B,fun(C,$o),Uua,Uub),X3) ) ) ).

% ATP.lambda_1031
tff(fact_7197_ATP_Olambda__1032,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: fun(C,fun(B,$o)),Uub: C] :
      ( aa(C,$o,aa(fun(C,fun(B,$o)),fun(C,$o),aTP_Lamp_adf(set(B),fun(fun(C,fun(B,$o)),fun(C,$o)),Uu),Uua),Uub)
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),Uu)
         => aa(B,$o,aa(C,fun(B,$o),Uua,Uub),X3) ) ) ).

% ATP.lambda_1032
tff(fact_7198_ATP_Olambda__1033,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(B,fun(C,$o)),Uub: C] :
      ( aa(C,$o,aa(fun(B,fun(C,$o)),fun(C,$o),aTP_Lamp_ahr(set(B),fun(fun(B,fun(C,$o)),fun(C,$o)),Uu),Uua),Uub)
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),Uu)
         => aa(C,$o,aa(B,fun(C,$o),Uua,X3),Uub) ) ) ).

% ATP.lambda_1033
tff(fact_7199_ATP_Olambda__1034,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: fun(B,fun(C,$o)),Uub: B] :
      ( aa(B,$o,aa(fun(B,fun(C,$o)),fun(B,$o),aTP_Lamp_aew(set(C),fun(fun(B,fun(C,$o)),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: C] :
          ( aa(set(C),$o,member(C,X3),Uu)
          & aa(C,$o,aa(B,fun(C,$o),Uua,Uub),X3) ) ) ).

% ATP.lambda_1034
tff(fact_7200_ATP_Olambda__1035,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: fun(C,fun(B,$o)),Uub: C] :
      ( aa(C,$o,aa(fun(C,fun(B,$o)),fun(C,$o),aTP_Lamp_aeo(set(B),fun(fun(C,fun(B,$o)),fun(C,$o)),Uu),Uua),Uub)
    <=> ? [X3: B] :
          ( aa(set(B),$o,member(B,X3),Uu)
          & aa(B,$o,aa(C,fun(B,$o),Uua,Uub),X3) ) ) ).

% ATP.lambda_1035
tff(fact_7201_ATP_Olambda__1036,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(B,fun(C,$o)),Uub: C] :
      ( aa(C,$o,aa(fun(B,fun(C,$o)),fun(C,$o),aTP_Lamp_atl(set(B),fun(fun(B,fun(C,$o)),fun(C,$o)),Uu),Uua),Uub)
    <=> ? [X3: B] :
          ( aa(set(B),$o,member(B,X3),Uu)
          & aa(C,$o,aa(B,fun(C,$o),Uua,X3),Uub) ) ) ).

% ATP.lambda_1036
tff(fact_7202_ATP_Olambda__1037,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,fun(B,$o)),Uua: set(C),Uub: B] :
      ( aa(B,$o,aa(set(C),fun(B,$o),aTP_Lamp_aep(fun(C,fun(B,$o)),fun(set(C),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: C] :
          ( aa(set(C),$o,member(C,X3),Uua)
          & aa(B,$o,aa(C,fun(B,$o),Uu,X3),Uub) ) ) ).

% ATP.lambda_1037
tff(fact_7203_ATP_Olambda__1038,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_ads(set(product_prod(B,B)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ! [X3: product_prod(B,B)] :
          ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),X3),Uu)
         => aa(product_prod(B,B),$o,aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(B,fun(B,fun(B,$o)),aa(B,fun(B,fun(B,fun(B,$o))),aTP_Lamp_adr(set(product_prod(B,B)),fun(B,fun(B,fun(B,fun(B,$o)))),Uu),Uua),Uub)),X3) ) ) ).

% ATP.lambda_1038
tff(fact_7204_ATP_Olambda__1039,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(B,fun(C,D)),Uua: set(D),Uub: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(set(D),fun(product_prod(B,C),$o),aTP_Lamp_ec(fun(B,fun(C,D)),fun(set(D),fun(product_prod(B,C),$o)),Uu),Uua),Uub)
    <=> ? [P4: product_prod(B,C)] :
          ( ( Uub = P4 )
          & aa(set(D),$o,member(D,aa(C,D,aa(B,fun(C,D),Uu,aa(product_prod(B,C),B,product_fst(B,C),P4)),aa(product_prod(B,C),C,product_snd(B,C),P4))),Uua) ) ) ).

% ATP.lambda_1039
tff(fact_7205_ATP_Olambda__1040,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,B)),Uua: set(C),Uub: B] :
      ( aa(B,$o,aa(set(C),fun(B,$o),aTP_Lamp_aev(set(product_prod(C,B)),fun(set(C),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: C] :
          ( aa(set(C),$o,member(C,X3),Uua)
          & aa(set(product_prod(C,B)),$o,member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X3),Uub)),Uu) ) ) ).

% ATP.lambda_1040
tff(fact_7206_ATP_Olambda__1041,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_aey(fun(B,C),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: B] :
          ( aa(set(B),$o,member(B,X3),Uua)
          & ( aa(B,C,Uu,X3) = aa(B,C,Uu,Uub) ) ) ) ).

% ATP.lambda_1041
tff(fact_7207_ATP_Olambda__1042,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,option(B)),Uua: set(C),Uub: B] :
      ( aa(B,$o,aa(set(C),fun(B,$o),aTP_Lamp_afe(fun(C,option(B)),fun(set(C),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: C] :
          ( aa(set(C),$o,member(C,X3),Uua)
          & ( aa(C,option(B),Uu,X3) = aa(B,option(B),some(B),Uub) ) ) ) ).

% ATP.lambda_1042
tff(fact_7208_ATP_Olambda__1043,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: set(C),Uub: B] :
      ( aa(B,$o,aa(set(C),fun(B,$o),aTP_Lamp_adi(fun(C,set(B)),fun(set(C),fun(B,$o)),Uu),Uua),Uub)
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),Uua)
         => aa(set(B),$o,member(B,Uub),aa(C,set(B),Uu,X3)) ) ) ).

% ATP.lambda_1043
tff(fact_7209_ATP_Olambda__1044,axiom,
    ! [D: $tType,B: $tType,Uu: set(fun(B,D)),Uua: B,Uub: D] :
      ( aa(D,$o,aa(B,fun(D,$o),aTP_Lamp_azx(set(fun(B,D)),fun(B,fun(D,$o)),Uu),Uua),Uub)
    <=> ? [X3: fun(B,D)] :
          ( aa(set(fun(B,D)),$o,member(fun(B,D),X3),Uu)
          & ( Uub = aa(B,D,X3,Uua) ) ) ) ).

% ATP.lambda_1044
tff(fact_7210_ATP_Olambda__1045,axiom,
    ! [C: $tType,B: $tType,Uu: set(fun(B,C)),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_azy(set(fun(B,C)),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> ? [X3: fun(B,C)] :
          ( aa(set(fun(B,C)),$o,member(fun(B,C),X3),Uu)
          & ( Uub = aa(B,C,X3,Uua) ) ) ) ).

% ATP.lambda_1045
tff(fact_7211_ATP_Olambda__1046,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: set(C),Uub: B] :
      ( aa(B,$o,aa(set(C),fun(B,$o),aTP_Lamp_aex(fun(C,set(B)),fun(set(C),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: C] :
          ( aa(set(C),$o,member(C,X3),Uua)
          & aa(set(B),$o,member(B,Uub),aa(C,set(B),Uu,X3)) ) ) ).

% ATP.lambda_1046
tff(fact_7212_ATP_Olambda__1047,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: set(C),Uub: B] :
      ( aa(B,$o,aa(set(C),fun(B,$o),aTP_Lamp_aer(fun(C,B),fun(set(C),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: C] :
          ( aa(set(C),$o,member(C,X3),Uua)
          & ( Uub = aa(C,B,Uu,X3) ) ) ) ).

% ATP.lambda_1047
tff(fact_7213_ATP_Olambda__1048,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: filter(C),Uub: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(filter(C),fun(fun(B,$o),$o),aTP_Lamp_afq(fun(B,C),fun(filter(C),fun(fun(B,$o),$o)),Uu),Uua),Uub)
    <=> ? [Q4: fun(C,$o)] :
          ( eventually(C,Q4,Uua)
          & ! [X3: B] :
              ( aa(C,$o,Q4,aa(B,C,Uu,X3))
             => aa(B,$o,Uub,X3) ) ) ) ).

% ATP.lambda_1048
tff(fact_7214_ATP_Olambda__1049,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,$o),Uua: fun(C,fun(B,$o)),Uub: C] :
      ( aa(C,$o,aa(fun(C,fun(B,$o)),fun(C,$o),aTP_Lamp_kl(fun(B,$o),fun(fun(C,fun(B,$o)),fun(C,$o)),Uu),Uua),Uub)
    <=> ? [Y4: B] :
          ( aa(B,$o,Uu,Y4)
          & aa(B,$o,aa(C,fun(B,$o),Uua,Uub),Y4) ) ) ).

% ATP.lambda_1049
tff(fact_7215_ATP_Olambda__1050,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: fun(C,$o),Uub: B] :
      ( aa(B,$o,aa(fun(C,$o),fun(B,$o),aTP_Lamp_fx(fun(C,set(B)),fun(fun(C,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: C] :
          ( aa(C,$o,Uua,X3)
          & aa(set(B),$o,member(B,Uub),aa(C,set(B),Uu,X3)) ) ) ).

% ATP.lambda_1050
tff(fact_7216_ATP_Olambda__1051,axiom,
    ! [C: $tType,B: $tType,Uu: C,Uua: fun(B,fun(C,$o)),Uub: fun(B,C)] :
      ( aa(fun(B,C),$o,aa(fun(B,fun(C,$o)),fun(fun(B,C),$o),aTP_Lamp_azz(C,fun(fun(B,fun(C,$o)),fun(fun(B,C),$o)),Uu),Uua),Uub)
    <=> ! [X3: B] :
          ( ( aa(B,C,Uub,X3) != Uu )
         => aa(C,$o,aa(B,fun(C,$o),Uua,X3),aa(B,C,Uub,X3)) ) ) ).

% ATP.lambda_1051
tff(fact_7217_ATP_Olambda__1052,axiom,
    ! [B: $tType,Uu: fun(B,B),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_agu(fun(B,B),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ? [N4: nat] : ( Uub = aa(B,B,compow(fun(B,B),N4,Uu),Uua) ) ) ).

% ATP.lambda_1052
tff(fact_7218_ATP_Olambda__1053,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: fun(C,fun(C,$o)),Uub: product_prod(B,B)] :
      ( aa(product_prod(B,B),$o,aa(fun(C,fun(C,$o)),fun(product_prod(B,B),$o),aTP_Lamp_cq(fun(C,B),fun(fun(C,fun(C,$o)),fun(product_prod(B,B),$o)),Uu),Uua),Uub)
    <=> ? [A6: C,B5: C] :
          ( ( Uub = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(C,B,Uu,A6)),aa(C,B,Uu,B5)) )
          & aa(C,$o,aa(C,fun(C,$o),Uua,A6),B5) ) ) ).

% ATP.lambda_1053
tff(fact_7219_ATP_Olambda__1054,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: fun(C,B),Uub: product_prod(B,B)] :
      ( aa(product_prod(B,B),$o,aa(fun(C,B),fun(product_prod(B,B),$o),aTP_Lamp_bx(set(product_prod(C,C)),fun(fun(C,B),fun(product_prod(B,B),$o)),Uu),Uua),Uub)
    <=> ? [A17: C,A25: C] :
          ( ( Uub = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(C,B,Uua,A17)),aa(C,B,Uua,A25)) )
          & aa(set(product_prod(C,C)),$o,member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),A17),A25)),Uu) ) ) ).

% ATP.lambda_1054
tff(fact_7220_ATP_Olambda__1055,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: list(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_ank(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: B,V3: list(B)] :
          ( ( Uub = append(B,Uua,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A6),V3)) )
          | ? [U4: list(B),Aa2: B,B5: B,Va: list(B),W3: list(B)] :
              ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Aa2),B5)),Uu)
              & ( Uua = append(B,U4,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Aa2),Va)) )
              & ( Uub = append(B,U4,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),W3)) ) ) ) ) ).

% ATP.lambda_1055
tff(fact_7221_ATP_Olambda__1056,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Uu: set(B),Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_nu(set(B),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ? [A6: B,B5: B] :
              ( ( Uub = aa(B,B,aa(B,fun(B,B),sup_sup(B),A6),B5) )
              & aa(set(B),$o,member(B,A6),Uu)
              & aa(set(B),$o,member(B,B5),Uua) ) ) ) ).

% ATP.lambda_1056
tff(fact_7222_ATP_Olambda__1057,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Uu: set(B),Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_nc(set(B),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ? [A6: B,B5: B] :
              ( ( Uub = aa(B,B,aa(B,fun(B,B),inf_inf(B),A6),B5) )
              & aa(set(B),$o,member(B,A6),Uu)
              & aa(set(B),$o,member(B,B5),Uua) ) ) ) ).

% ATP.lambda_1057
tff(fact_7223_ATP_Olambda__1058,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: set(multiset(B)),Uub: multiset(B)] :
      ( aa(multiset(B),$o,aa(set(multiset(B)),fun(multiset(B),$o),aTP_Lamp_auc(set(multiset(B)),fun(set(multiset(B)),fun(multiset(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: multiset(B),B5: multiset(B)] :
          ( ( Uub = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),A6),B5) )
          & aa(set(multiset(B)),$o,member(multiset(B),A6),Uu)
          & aa(set(multiset(B)),$o,member(multiset(B),B5),Uua) ) ) ).

% ATP.lambda_1058
tff(fact_7224_ATP_Olambda__1059,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: set(multiset(B)),Uub: multiset(B)] :
      ( aa(multiset(B),$o,aa(set(multiset(B)),fun(multiset(B),$o),aTP_Lamp_aub(set(multiset(B)),fun(set(multiset(B)),fun(multiset(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: multiset(B),B5: multiset(B)] :
          ( ( Uub = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A6),B5) )
          & aa(set(multiset(B)),$o,member(multiset(B),A6),Uu)
          & aa(set(multiset(B)),$o,member(multiset(B),B5),Uua) ) ) ).

% ATP.lambda_1059
tff(fact_7225_ATP_Olambda__1060,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(list(B)),Uub: list(B)] :
      ( aa(list(B),$o,aa(set(list(B)),fun(list(B),$o),aTP_Lamp_aiy(set(B),fun(set(list(B)),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ? [X3: B,Xs3: list(B)] :
          ( ( Uub = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X3),Xs3) )
          & aa(set(B),$o,member(B,X3),Uu)
          & aa(set(list(B)),$o,member(list(B),Xs3),Uua) ) ) ).

% ATP.lambda_1060
tff(fact_7226_ATP_Olambda__1061,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(set(old_node(C,D)),fun(set(old_node(C,D)),B)),Uua: set(old_node(C,D)),Uub: B] :
      ( aa(B,$o,aa(set(old_node(C,D)),fun(B,$o),aTP_Lamp_azf(fun(set(old_node(C,D)),fun(set(old_node(C,D)),B)),fun(set(old_node(C,D)),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: set(old_node(C,D)),Y4: set(old_node(C,D))] :
          ( ( Uua = old_Scons(C,D,X3,Y4) )
          & ( Uub = aa(set(old_node(C,D)),B,aa(set(old_node(C,D)),fun(set(old_node(C,D)),B),Uu,X3),Y4) ) ) ) ).

% ATP.lambda_1061
tff(fact_7227_ATP_Olambda__1062,axiom,
    ! [B: $tType,Uu: filter(B),Uua: filter(B),Uub: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(filter(B),fun(fun(B,$o),$o),aTP_Lamp_afm(filter(B),fun(filter(B),fun(fun(B,$o),$o)),Uu),Uua),Uub)
    <=> ? [Q4: fun(B,$o),R5: fun(B,$o)] :
          ( eventually(B,Q4,Uu)
          & eventually(B,R5,Uua)
          & ! [X3: B] :
              ( ( aa(B,$o,Q4,X3)
                & aa(B,$o,R5,X3) )
             => aa(B,$o,Uub,X3) ) ) ) ).

% ATP.lambda_1062
tff(fact_7228_ATP_Olambda__1063,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: multiset(B),Uub: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_aht(set(product_prod(B,B)),fun(multiset(B),fun(multiset(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: B,M02: multiset(B),K7: multiset(B)] :
          ( ( Uub = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A6),M02) )
          & ( Uua = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),M02),K7) )
          & ! [B5: B] :
              ( aa(set(B),$o,member(B,B5),aa(multiset(B),set(B),set_mset(B),K7))
             => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B5),A6)),Uu) ) ) ) ).

% ATP.lambda_1063
tff(fact_7229_ATP_Olambda__1064,axiom,
    ! [C: $tType,B: $tType,F10: $tType,D: $tType,E: $tType,Uu: fun(F10,fun(B,fun(D,fun(C,fun(E,$o))))),Uua: F10,Uub: fun(B,option(product_prod(C,product_prod(D,E))))] :
      ( aa(fun(B,option(product_prod(C,product_prod(D,E)))),$o,aa(F10,fun(fun(B,option(product_prod(C,product_prod(D,E)))),$o),aTP_Lamp_azu(fun(F10,fun(B,fun(D,fun(C,fun(E,$o))))),fun(F10,fun(fun(B,option(product_prod(C,product_prod(D,E)))),$o)),Uu),Uua),Uub)
    <=> ! [H: B,H7: D,R6: C,N4: E] :
          ( ( aa(B,option(product_prod(C,product_prod(D,E))),Uub,H) = aa(product_prod(C,product_prod(D,E)),option(product_prod(C,product_prod(D,E))),some(product_prod(C,product_prod(D,E))),aa(product_prod(D,E),product_prod(C,product_prod(D,E)),aa(C,fun(product_prod(D,E),product_prod(C,product_prod(D,E))),product_Pair(C,product_prod(D,E)),R6),aa(E,product_prod(D,E),aa(D,fun(E,product_prod(D,E)),product_Pair(D,E),H7),N4))) )
         => aa(E,$o,aa(C,fun(E,$o),aa(D,fun(C,fun(E,$o)),aa(B,fun(D,fun(C,fun(E,$o))),aa(F10,fun(B,fun(D,fun(C,fun(E,$o)))),Uu,Uua),H),H7),R6),N4) ) ) ).

% ATP.lambda_1064
tff(fact_7230_ATP_Olambda__1065,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: list(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_ann(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ? [Us: list(B),Z5: B,Z9: B,Vs2: list(B)] :
          ( ( Uua = append(B,Us,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Z5),Vs2)) )
          & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z5),Z9)),Uu)
          & ( Uub = append(B,Us,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Z9),Vs2)) ) ) ) ).

% ATP.lambda_1065
tff(fact_7231_ATP_Olambda__1066,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(nat,fun(nat,B)),Uuc: nat] : ( aa(nat,B,aa(fun(nat,fun(nat,B)),fun(nat,B),aa(B,fun(fun(nat,fun(nat,B)),fun(nat,B)),aTP_Lamp_aru(fun(B,fun(B,B)),fun(B,fun(fun(nat,fun(nat,B)),fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Uu,Uua),aa(nat,fun(nat,B),aTP_Lamp_art(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uub),Uuc)),aa(nat,set(nat),set_ord_atMost(nat),Uuc)) ) ).

% ATP.lambda_1066
tff(fact_7232_ATP_Olambda__1067,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(nat,fun(nat,B)),Uuc: nat] : ( aa(nat,B,aa(fun(nat,fun(nat,B)),fun(nat,B),aa(B,fun(fun(nat,fun(nat,B)),fun(nat,B)),aTP_Lamp_asw(fun(B,fun(B,B)),fun(B,fun(fun(nat,fun(nat,B)),fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Uu,Uua),aa(nat,fun(nat,B),Uub,Uuc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uuc)) ) ).

% ATP.lambda_1067
tff(fact_7233_ATP_Olambda__1068,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(nat,fun(nat,B)),Uuc: nat] : ( aa(nat,B,aa(fun(nat,fun(nat,B)),fun(nat,B),aa(B,fun(fun(nat,fun(nat,B)),fun(nat,B)),aTP_Lamp_ata(fun(B,fun(B,B)),fun(B,fun(fun(nat,fun(nat,B)),fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Uu,Uua),aa(nat,fun(nat,B),Uub,Uuc)),aa(nat,set(nat),set_ord_lessThan(nat),Uuc)) ) ).

% ATP.lambda_1068
tff(fact_7234_ATP_Olambda__1069,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,Uu: fun(C,fun(D,fun(E,B))),Uua: E,Uub: C,Uuc: D] : ( aa(D,B,aa(C,fun(D,B),aa(E,fun(C,fun(D,B)),aTP_Lamp_db(fun(C,fun(D,fun(E,B))),fun(E,fun(C,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(E,B,aa(D,fun(E,B),aa(C,fun(D,fun(E,B)),Uu,Uub),Uuc),Uua) ) ).

% ATP.lambda_1069
tff(fact_7235_ATP_Olambda__1070,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: product_prod(D,B),Uua: B,Uub: C,Uuc: set(product_prod(D,C))] :
      ( aa(set(product_prod(D,C)),set(product_prod(D,C)),aa(C,fun(set(product_prod(D,C)),set(product_prod(D,C))),aa(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aTP_Lamp_lv(product_prod(D,B),fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),Uu),Uua),Uub),Uuc)
      = $ite(aa(product_prod(D,B),B,product_snd(D,B),Uu) = Uua,aa(set(product_prod(D,C)),set(product_prod(D,C)),insert(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),aa(product_prod(D,B),D,product_fst(D,B),Uu)),Uub)),Uuc),Uuc) ) ).

% ATP.lambda_1070
tff(fact_7236_ATP_Olambda__1071,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: set(B),Uub: B,Uuc: C] :
      ( aa(C,B,aa(B,fun(C,B),aa(set(B),fun(B,fun(C,B)),aTP_Lamp_ke(fun(B,C),fun(set(B),fun(B,fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(aa(set(C),$o,member(C,Uuc),aa(set(B),set(C),image2(B,C,Uu),Uua)),the_inv_into(B,C,Uua,Uu,Uuc),Uub) ) ).

% ATP.lambda_1071
tff(fact_7237_ATP_Olambda__1072,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: fun(B,C),Uub: B,Uuc: C] :
      ( aa(C,B,aa(B,fun(C,B),aa(fun(B,C),fun(B,fun(C,B)),aTP_Lamp_qt(set(B),fun(fun(B,C),fun(B,fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(aa(set(C),$o,member(C,Uuc),aa(set(B),set(C),image2(B,C,Uua),Uu)),the_inv_into(B,C,Uu,Uua,Uuc),Uub) ) ).

% ATP.lambda_1072
tff(fact_7238_ATP_Olambda__1073,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: B,Uub: C,Uuc: set(C)] :
      ( aa(set(C),set(C),aa(C,fun(set(C),set(C)),aa(B,fun(C,fun(set(C),set(C))),aTP_Lamp_ln(set(B),fun(B,fun(C,fun(set(C),set(C)))),Uu),Uua),Uub),Uuc)
      = $ite(aa(set(B),$o,member(B,Uua),Uu),aa(set(C),set(C),insert(C,Uub),Uuc),Uuc) ) ).

% ATP.lambda_1073
tff(fact_7239_ATP_Olambda__1074,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: nat,Uua: fun(nat,B),Uub: fun(nat,B),Uuc: nat] :
          ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_td(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),Uu),Uua),Uub),Uuc)
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),
              aa(nat,B,Uua,Uuc),
              $ite(Uuc = Uu,zero_zero(B),aa(nat,B,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ).

% ATP.lambda_1074
tff(fact_7240_ATP_Olambda__1075,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: nat,Uua: fun(nat,B),Uub: fun(nat,B),Uuc: nat] :
          ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_tb(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),Uu),Uua),Uub),Uuc)
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),
              aa(nat,B,Uua,Uuc),
              $ite(Uuc = Uu,one_one(B),aa(nat,B,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ).

% ATP.lambda_1075
tff(fact_7241_ATP_Olambda__1076,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: nat,Uua: fun(nat,B),Uub: fun(nat,B),Uuc: nat] :
          ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_tc(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),aa(nat,B,Uua,Uuc),aa(nat,B,Uub,Uuc)) ) ) ).

% ATP.lambda_1076
tff(fact_7242_ATP_Olambda__1077,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: nat,Uua: fun(nat,B),Uub: fun(nat,B),Uuc: nat] :
          ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_te(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),aa(nat,B,Uua,Uuc),aa(nat,B,Uub,Uuc)) ) ) ).

% ATP.lambda_1077
tff(fact_7243_ATP_Olambda__1078,axiom,
    ! [B: $tType,Uu: nat,Uua: fun(nat,B),Uub: fun(nat,B),Uuc: nat] :
      ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_arw(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),Uu),Uua),Uub),Uuc)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),aa(nat,B,Uua,Uuc),aa(nat,B,Uub,Uuc)) ) ).

% ATP.lambda_1078
tff(fact_7244_ATP_Olambda__1079,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: set(B),Uub: fun(B,C),Uuc: B] :
      ( aa(B,C,aa(fun(B,C),fun(B,C),aa(set(B),fun(fun(B,C),fun(B,C)),aTP_Lamp_ef(fun(B,C),fun(set(B),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
      = $ite(aa(set(B),$o,member(B,Uuc),Uua),aa(B,C,Uu,Uuc),aa(B,C,Uub,Uuc)) ) ).

% ATP.lambda_1079
tff(fact_7245_ATP_Olambda__1080,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: fun(C,B),Uub: fun(C,B),Uuc: C] :
      ( aa(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_atb(C,fun(fun(C,B),fun(fun(C,B),fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(Uuc = Uu,aa(C,B,Uua,Uuc),aa(C,B,Uub,Uuc)) ) ).

% ATP.lambda_1080
tff(fact_7246_ATP_Olambda__1081,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: fun(B,C),Uuc: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_py(B,fun(fun(B,C),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(B,C,Uua,Uuc),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_1081
tff(fact_7247_ATP_Olambda__1082,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: fun(B,C),Uuc: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_pz(B,fun(fun(B,C),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(B,C,Uua,Uuc),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_1082
tff(fact_7248_ATP_Olambda__1083,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: fun(C,B),Uub: set(C),Uuc: C] :
      ( aa(C,B,aa(set(C),fun(C,B),aa(fun(C,B),fun(set(C),fun(C,B)),aTP_Lamp_asp(B,fun(fun(C,B),fun(set(C),fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(aa(set(C),$o,member(C,Uuc),Uub),aa(C,B,Uua,Uuc),Uu) ) ).

% ATP.lambda_1083
tff(fact_7249_ATP_Olambda__1084,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C,Uub: fun(C,B),Uuc: C] :
      ( aa(C,B,aa(fun(C,B),fun(C,B),aa(C,fun(fun(C,B),fun(C,B)),aTP_Lamp_ase(B,fun(C,fun(fun(C,B),fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(Uua = Uuc,aa(C,B,Uub,Uuc),Uu) ) ).

% ATP.lambda_1084
tff(fact_7250_ATP_Olambda__1085,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: C,Uuc: B] :
          ( aa(B,C,aa(C,fun(B,C),aa(fun(B,C),fun(C,fun(B,C)),aTP_Lamp_sj(B,fun(fun(B,C),fun(C,fun(B,C))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(B,C,Uua,Uuc),Uub) ) ) ).

% ATP.lambda_1085
tff(fact_7251_ATP_Olambda__1086,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C,Uub: fun(C,B),Uuc: C] :
      ( aa(C,B,aa(fun(C,B),fun(C,B),aa(C,fun(fun(C,B),fun(C,B)),aTP_Lamp_asd(B,fun(C,fun(fun(C,B),fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(Uuc = Uua,aa(C,B,Uub,Uuc),Uu) ) ).

% ATP.lambda_1086
tff(fact_7252_ATP_Olambda__1087,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C,Uub: fun(B,option(C)),Uuc: B] :
      ( aa(B,option(C),aa(fun(B,option(C)),fun(B,option(C)),aa(C,fun(fun(B,option(C)),fun(B,option(C))),aTP_Lamp_aci(B,fun(C,fun(fun(B,option(C)),fun(B,option(C)))),Uu),Uua),Uub),Uuc)
      = $ite(Uuc = Uu,aa(C,option(C),some(C),Uua),aa(B,option(C),Uub,Uuc)) ) ).

% ATP.lambda_1087
tff(fact_7253_ATP_Olambda__1088,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,option(B)),Uua: C,Uub: B,Uuc: C] :
      ( aa(C,option(B),aa(B,fun(C,option(B)),aa(C,fun(B,fun(C,option(B))),aTP_Lamp_acq(fun(C,option(B)),fun(C,fun(B,fun(C,option(B)))),Uu),Uua),Uub),Uuc)
      = $ite(Uuc = Uua,aa(B,option(B),some(B),Uub),aa(C,option(B),Uu,Uuc)) ) ).

% ATP.lambda_1088
tff(fact_7254_ATP_Olambda__1089,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: C,Uub: C,Uuc: B] :
      ( aa(B,C,aa(C,fun(B,C),aa(C,fun(C,fun(B,C)),aTP_Lamp_bh(set(B),fun(C,fun(C,fun(B,C))),Uu),Uua),Uub),Uuc)
      = $ite(aa(set(B),$o,member(B,Uuc),Uu),Uua,Uub) ) ).

% ATP.lambda_1089
tff(fact_7255_ATP_Olambda__1090,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: B,Uub: list(B),Uuc: list(B)] :
      ( aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),aa(B,fun(list(B),fun(list(B),product_prod(list(B),list(B)))),aTP_Lamp_anl(fun(B,$o),fun(B,fun(list(B),fun(list(B),product_prod(list(B),list(B))))),Uu),Uua),Uub),Uuc)
      = $ite(aa(B,$o,Uu,Uua),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uua),Uub)),Uuc),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Uub),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uua),Uuc))) ) ).

% ATP.lambda_1090
tff(fact_7256_ATP_Olambda__1091,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,$o),Uua: fun(C,B),Uub: fun(C,B),Uuc: C] :
      ( aa(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_ca(fun(C,$o),fun(fun(C,B),fun(fun(C,B),fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(aa(C,$o,Uu,Uuc),aa(C,B,Uua,Uuc),aa(C,B,Uub,Uuc)) ) ).

% ATP.lambda_1091
tff(fact_7257_ATP_Olambda__1092,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,$o),Uua: fun(B,option(C)),Uub: fun(B,option(C)),Uuc: B] :
      ( aa(B,option(C),aa(fun(B,option(C)),fun(B,option(C)),aa(fun(B,option(C)),fun(fun(B,option(C)),fun(B,option(C))),aTP_Lamp_acm(fun(B,$o),fun(fun(B,option(C)),fun(fun(B,option(C)),fun(B,option(C)))),Uu),Uua),Uub),Uuc)
      = $ite(aa(B,$o,Uu,Uuc),aa(B,option(C),Uua,Uuc),aa(B,option(C),Uub,Uuc)) ) ).

% ATP.lambda_1092
tff(fact_7258_ATP_Olambda__1093,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(B,$o),Uua: fun(B,C),Uub: fun(B,C),Uuc: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_pv(fun(B,$o),fun(fun(B,C),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
          = $ite(aa(B,$o,Uu,Uuc),aa(B,C,Uua,Uuc),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_1093
tff(fact_7259_ATP_Olambda__1094,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(B,$o),Uua: fun(B,C),Uub: fun(B,C),Uuc: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_pw(fun(B,$o),fun(fun(B,C),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
          = $ite(aa(B,$o,Uu,Uuc),aa(B,C,Uua,Uuc),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_1094
tff(fact_7260_ATP_Olambda__1095,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: fun(B,$o),Uub: fun(B,C),Uuc: B] :
      ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,$o),fun(fun(B,C),fun(B,C)),aTP_Lamp_my(fun(B,C),fun(fun(B,$o),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
      = $ite(aa(B,$o,Uua,Uuc),aa(B,C,Uu,Uuc),aa(B,C,Uub,Uuc)) ) ).

% ATP.lambda_1095
tff(fact_7261_ATP_Olambda__1096,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: fun(C,B),Uub: fun(C,$o),Uuc: C] :
      ( aa(C,B,aa(fun(C,$o),fun(C,B),aa(fun(C,B),fun(fun(C,$o),fun(C,B)),aTP_Lamp_asg(B,fun(fun(C,B),fun(fun(C,$o),fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(aa(C,$o,Uub,Uuc),aa(C,B,Uua,Uuc),Uu) ) ).

% ATP.lambda_1096
tff(fact_7262_ATP_Olambda__1097,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: set(product_prod(C,D)),Uua: B,Uub: C,Uuc: set(product_prod(B,D))] : ( aa(set(product_prod(B,D)),set(product_prod(B,D)),aa(C,fun(set(product_prod(B,D)),set(product_prod(B,D))),aa(B,fun(C,fun(set(product_prod(B,D)),set(product_prod(B,D)))),aTP_Lamp_me(set(product_prod(C,D)),fun(B,fun(C,fun(set(product_prod(B,D)),set(product_prod(B,D))))),Uu),Uua),Uub),Uuc) = finite_fold(product_prod(C,D),set(product_prod(B,D)),aa(fun(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D))))),fun(product_prod(C,D),fun(set(product_prod(B,D)),set(product_prod(B,D)))),product_case_prod(C,D,fun(set(product_prod(B,D)),set(product_prod(B,D)))),aa(C,fun(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D))))),aTP_Lamp_md(B,fun(C,fun(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D)))))),Uua),Uub)),Uuc,Uu) ) ).

% ATP.lambda_1097
tff(fact_7263_ATP_Olambda__1098,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: D,Uub: B,Uuc: set(product_prod(D,C))] : ( aa(set(product_prod(D,C)),set(product_prod(D,C)),aa(B,fun(set(product_prod(D,C)),set(product_prod(D,C))),aa(D,fun(B,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aTP_Lamp_ll(set(product_prod(B,C)),fun(D,fun(B,fun(set(product_prod(D,C)),set(product_prod(D,C))))),Uu),Uua),Uub),Uuc) = finite_fold(product_prod(B,C),set(product_prod(D,C)),aa(fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),fun(product_prod(B,C),fun(set(product_prod(D,C)),set(product_prod(D,C)))),product_case_prod(B,C,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aa(B,fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),aTP_Lamp_lk(D,fun(B,fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C)))))),Uua),Uub)),Uuc,Uu) ) ).

% ATP.lambda_1098
tff(fact_7264_ATP_Olambda__1099,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: fun(B,C),Uub: $o,Uuc: B] :
      ( aa(B,C,aa($o,fun(B,C),aa(fun(B,C),fun($o,fun(B,C)),aTP_Lamp_azq(fun(B,C),fun(fun(B,C),fun($o,fun(B,C))),Uu),Uua),Uub),Uuc)
      = $ite((Uub),aa(B,C,Uu,Uuc),aa(B,C,Uua,Uuc)) ) ).

% ATP.lambda_1099
tff(fact_7265_ATP_Olambda__1100,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_0(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: list(C),Uuc: nat] : ( aa(nat,B,aa(list(C),fun(nat,B),aa(B,fun(list(C),fun(nat,B)),aTP_Lamp_ajc(fun(C,B),fun(B,fun(list(C),fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,compow(fun(B,B),Uuc,aa(B,fun(B,B),times_times(B),Uua)),aa(C,B,Uu,aa(nat,C,nth(C,Uub),Uuc))) ) ) ).

% ATP.lambda_1100
tff(fact_7266_ATP_Olambda__1101,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: B,Uub: list(B),Uuc: $o] :
      ( aa($o,$o,aa(list(B),fun($o,$o),aa(B,fun(list(B),fun($o,$o)),aTP_Lamp_bbi(fun(B,fun(B,$o)),fun(B,fun(list(B),fun($o,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(list(B),$o,case_list($o,B,$true,aa($o,fun(B,fun(list(B),$o)),aa(B,fun($o,fun(B,fun(list(B),$o))),aTP_Lamp_bbh(fun(B,fun(B,$o)),fun(B,fun($o,fun(B,fun(list(B),$o)))),Uu),Uua),Uuc)),Uub) ) ).

% ATP.lambda_1101
tff(fact_7267_ATP_Olambda__1102,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(D,fun(list(D),fun(C,C))),Uua: fun(B,D),Uub: B,Uuc: list(B)] : ( aa(list(B),fun(C,C),aa(B,fun(list(B),fun(C,C)),aa(fun(B,D),fun(B,fun(list(B),fun(C,C))),aTP_Lamp_aon(fun(D,fun(list(D),fun(C,C))),fun(fun(B,D),fun(B,fun(list(B),fun(C,C)))),Uu),Uua),Uub),Uuc) = aa(list(D),fun(C,C),aa(D,fun(list(D),fun(C,C)),Uu,aa(B,D,Uua,Uub)),aa(list(B),list(D),map(B,D,Uua),Uuc)) ) ).

% ATP.lambda_1102
tff(fact_7268_ATP_Olambda__1103,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(B,$o)),Uua: fun(C,B),Uub: C,Uuc: C] :
      ( aa(C,$o,aa(C,fun(C,$o),aa(fun(C,B),fun(C,fun(C,$o)),aTP_Lamp_ald(fun(B,fun(B,$o)),fun(fun(C,B),fun(C,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(B,$o,aa(B,fun(B,$o),Uu,aa(C,B,Uua,Uub)),aa(C,B,Uua,Uuc)) ) ).

% ATP.lambda_1103
tff(fact_7269_ATP_Olambda__1104,axiom,
    ! [C: $tType,B: $tType,D: $tType,E: $tType,Uu: fun(C,fun(D,B)),Uua: fun(E,C),Uub: fun(E,D),Uuc: E] : ( aa(E,B,aa(fun(E,D),fun(E,B),aa(fun(E,C),fun(fun(E,D),fun(E,B)),aTP_Lamp_ajy(fun(C,fun(D,B)),fun(fun(E,C),fun(fun(E,D),fun(E,B))),Uu),Uua),Uub),Uuc) = aa(D,B,aa(C,fun(D,B),Uu,aa(E,C,Uua,Uuc)),aa(E,D,Uub,Uuc)) ) ).

% ATP.lambda_1104
tff(fact_7270_ATP_Olambda__1105,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(B,B)),Uua: fun(C,B),Uub: fun(C,B),Uuc: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_asa(fun(B,fun(B,B)),fun(fun(C,B),fun(fun(C,B),fun(C,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),Uu,aa(C,B,Uua,Uuc)),aa(C,B,Uub,Uuc)) ) ).

% ATP.lambda_1105
tff(fact_7271_ATP_Olambda__1106,axiom,
    ! [D: $tType,E: $tType,G6: $tType,Uu: fun(D,fun(E,$o)),Uua: fun(G6,E),Uub: D,Uuc: G6] :
      ( aa(G6,$o,aa(D,fun(G6,$o),aa(fun(G6,E),fun(D,fun(G6,$o)),aTP_Lamp_aot(fun(D,fun(E,$o)),fun(fun(G6,E),fun(D,fun(G6,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(E,$o,aa(D,fun(E,$o),Uu,Uub),aa(G6,E,Uua,Uuc)) ) ).

% ATP.lambda_1106
tff(fact_7272_ATP_Olambda__1107,axiom,
    ! [C: $tType,D: $tType,E: $tType,Uu: fun(C,fun(D,$o)),Uua: fun(E,D),Uub: C,Uuc: E] :
      ( aa(E,$o,aa(C,fun(E,$o),aa(fun(E,D),fun(C,fun(E,$o)),aTP_Lamp_fn(fun(C,fun(D,$o)),fun(fun(E,D),fun(C,fun(E,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(D,$o,aa(C,fun(D,$o),Uu,Uub),aa(E,D,Uua,Uuc)) ) ).

% ATP.lambda_1107
tff(fact_7273_ATP_Olambda__1108,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType] :
      ( ( order(D)
        & order(B) )
     => ! [Uu: fun(B,fun(C,D)),Uua: fun(E,C),Uub: B,Uuc: E] : ( aa(E,D,aa(B,fun(E,D),aa(fun(E,C),fun(B,fun(E,D)),aTP_Lamp_lj(fun(B,fun(C,D)),fun(fun(E,C),fun(B,fun(E,D))),Uu),Uua),Uub),Uuc) = aa(C,D,aa(B,fun(C,D),Uu,Uub),aa(E,C,Uua,Uuc)) ) ) ).

% ATP.lambda_1108
tff(fact_7274_ATP_Olambda__1109,axiom,
    ! [B: $tType,C: $tType,F10: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(F10,C),Uub: B,Uuc: F10] :
      ( aa(F10,$o,aa(B,fun(F10,$o),aa(fun(F10,C),fun(B,fun(F10,$o)),aTP_Lamp_aos(fun(B,fun(C,$o)),fun(fun(F10,C),fun(B,fun(F10,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(C,$o,aa(B,fun(C,$o),Uu,Uub),aa(F10,C,Uua,Uuc)) ) ).

% ATP.lambda_1109
tff(fact_7275_ATP_Olambda__1110,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(D,C),Uub: B,Uuc: D] :
      ( aa(D,$o,aa(B,fun(D,$o),aa(fun(D,C),fun(B,fun(D,$o)),aTP_Lamp_aod(fun(B,fun(C,$o)),fun(fun(D,C),fun(B,fun(D,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(C,$o,aa(B,fun(C,$o),Uu,Uub),aa(D,C,Uua,Uuc)) ) ).

% ATP.lambda_1110
tff(fact_7276_ATP_Olambda__1111,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(B,fun(C,B)),Uua: fun(D,C),Uub: B,Uuc: D] : ( aa(D,B,aa(B,fun(D,B),aa(fun(D,C),fun(B,fun(D,B)),aTP_Lamp_aka(fun(B,fun(C,B)),fun(fun(D,C),fun(B,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(C,B,aa(B,fun(C,B),Uu,Uub),aa(D,C,Uua,Uuc)) ) ).

% ATP.lambda_1111
tff(fact_7277_ATP_Olambda__1112,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: set(D),Uuc: C] : ( aa(C,B,aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_or(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),Uu),Uua),Uub),Uuc) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups7311177749621191930dd_sum(D,B),aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_oq(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uuc)),Uub) ) ) ).

% ATP.lambda_1112
tff(fact_7278_ATP_Olambda__1113,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: set(C),Uub: filter(C),Uuc: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(filter(C),fun(fun(B,$o),$o),aa(set(C),fun(filter(C),fun(fun(B,$o),$o)),aTP_Lamp_bbk(fun(C,B),fun(set(C),fun(filter(C),fun(fun(B,$o),$o))),Uu),Uua),Uub),Uuc)
    <=> eventually(C,aa(fun(B,$o),fun(C,$o),aa(set(C),fun(fun(B,$o),fun(C,$o)),aTP_Lamp_bbj(fun(C,B),fun(set(C),fun(fun(B,$o),fun(C,$o))),Uu),Uua),Uuc),Uub) ) ).

% ATP.lambda_1113
tff(fact_7279_ATP_Olambda__1114,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: fun(C,B),Uub: filter(C),Uuc: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(filter(C),fun(fun(B,$o),$o),aa(fun(C,B),fun(filter(C),fun(fun(B,$o),$o)),aTP_Lamp_afd(set(C),fun(fun(C,B),fun(filter(C),fun(fun(B,$o),$o))),Uu),Uua),Uub),Uuc)
    <=> eventually(C,aa(fun(B,$o),fun(C,$o),aa(fun(C,B),fun(fun(B,$o),fun(C,$o)),aTP_Lamp_afc(set(C),fun(fun(C,B),fun(fun(B,$o),fun(C,$o))),Uu),Uua),Uuc),Uub) ) ).

% ATP.lambda_1114
tff(fact_7280_ATP_Olambda__1115,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: list(B),Uub: B,Uuc: B] :
          ( aa(B,fun(list(B),list(B)),aa(B,fun(B,fun(list(B),list(B))),aa(list(B),fun(B,fun(B,fun(list(B),list(B)))),aTP_Lamp_amr(fun(B,C),fun(list(B),fun(B,fun(B,fun(list(B),list(B))))),Uu),Uua),Uub),Uuc)
          = case_list(list(B),B,$ite(aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Uu,Uub)),aa(B,C,Uu,Uuc)),Uua,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uuc),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),nil(B)))),aa(list(B),fun(B,fun(list(B),list(B))),aTP_Lamp_amq(fun(B,C),fun(list(B),fun(B,fun(list(B),list(B)))),Uu),Uua)) ) ) ).

% ATP.lambda_1115
tff(fact_7281_ATP_Olambda__1116,axiom,
    ! [B: $tType,Uu: set(B),Uua: fun(B,fun(B,$o)),Uub: set(B),Uuc: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),aa(fun(B,fun(B,$o)),fun(set(B),fun(set(B),$o)),aTP_Lamp_agr(set(B),fun(fun(B,fun(B,$o)),fun(set(B),fun(set(B),$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,pred_chain(B,Uu,Uua),Uuc)
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),Uub),Uuc) ) ) ).

% ATP.lambda_1116
tff(fact_7282_ATP_Olambda__1117,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(B,fun(C,$o)),Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aTP_Lamp_awn(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(C,$o,aa(B,fun(C,$o),Uu,Uub),Uuc)
        & aa(C,$o,aa(B,fun(C,$o),Uua,Uub),Uuc) ) ) ).

% ATP.lambda_1117
tff(fact_7283_ATP_Olambda__1118,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,assn)),Uua: $o,Uub: B,Uuc: C] : ( aa(C,assn,aa(B,fun(C,assn),aa($o,fun(B,fun(C,assn)),aTP_Lamp_ab(fun(B,fun(C,assn)),fun($o,fun(B,fun(C,assn))),Uu),Uua),Uub),Uuc) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),Uu,Uub),Uuc)),pure_assn(Uua)) ) ).

% ATP.lambda_1118
tff(fact_7284_ATP_Olambda__1119,axiom,
    ! [D: $tType,B: $tType,C: $tType,F10: $tType,E: $tType,Uu: fun(C,fun(D,fun(E,fun(F10,set(B))))),Uua: product_prod(E,F10),Uub: C,Uuc: D] : ( aa(D,set(B),aa(C,fun(D,set(B)),aa(product_prod(E,F10),fun(C,fun(D,set(B))),aTP_Lamp_hq(fun(C,fun(D,fun(E,fun(F10,set(B))))),fun(product_prod(E,F10),fun(C,fun(D,set(B)))),Uu),Uua),Uub),Uuc) = aa(product_prod(E,F10),set(B),aa(fun(E,fun(F10,set(B))),fun(product_prod(E,F10),set(B)),product_case_prod(E,F10,set(B)),aa(D,fun(E,fun(F10,set(B))),aa(C,fun(D,fun(E,fun(F10,set(B)))),Uu,Uub),Uuc)),Uua) ) ).

% ATP.lambda_1119
tff(fact_7285_ATP_Olambda__1120,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comm_monoid_mult(D)
     => ! [Uu: set(B),Uua: fun(B,fun(C,D)),Uub: fun(B,fun(C,$o)),Uuc: C] : ( aa(C,D,aa(fun(B,fun(C,$o)),fun(C,D),aa(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(C,D)),aTP_Lamp_oo(set(B),fun(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(C,D))),Uu),Uua),Uub),Uuc) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(C,fun(B,D),aTP_Lamp_on(fun(B,fun(C,D)),fun(C,fun(B,D)),Uua),Uuc)),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aa(fun(B,fun(C,$o)),fun(C,fun(B,$o)),aTP_Lamp_ko(set(B),fun(fun(B,fun(C,$o)),fun(C,fun(B,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1120
tff(fact_7286_ATP_Olambda__1121,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comm_monoid_add(D)
     => ! [Uu: set(B),Uua: fun(B,fun(C,D)),Uub: fun(B,fun(C,$o)),Uuc: C] : ( aa(C,D,aa(fun(B,fun(C,$o)),fun(C,D),aa(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(C,D)),aTP_Lamp_ox(set(B),fun(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(C,D))),Uu),Uua),Uub),Uuc) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(C,fun(B,D),aTP_Lamp_ow(fun(B,fun(C,D)),fun(C,fun(B,D)),Uua),Uuc)),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aa(fun(B,fun(C,$o)),fun(C,fun(B,$o)),aTP_Lamp_ko(set(B),fun(fun(B,fun(C,$o)),fun(C,fun(B,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1121
tff(fact_7287_ATP_Olambda__1122,axiom,
    ! [Uu: code_natural,Uua: code_natural,Uub: code_natural,Uuc: code_natural] : ( aa(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aa(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),aTP_Lamp_axu(code_natural,fun(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))))),Uu),Uua),Uub),Uuc) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_Pair(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),inc_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),Uu)),Uuc)),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),Uub),inc_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),Uua))) ) ).

% ATP.lambda_1122
tff(fact_7288_ATP_Olambda__1123,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: set(B),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(set(B),fun(B,fun(B,$o)),aTP_Lamp_jf(fun(B,fun(B,$o)),fun(set(B),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uuc)),product_Sigma(B,B,Uua,aTP_Lamp_cr(set(B),fun(B,set(B)),Uua)))
        & aa(B,$o,aa(B,fun(B,$o),Uu,Uub),Uuc) ) ) ).

% ATP.lambda_1123
tff(fact_7289_ATP_Olambda__1124,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_wa(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uub))) ) ).

% ATP.lambda_1124
tff(fact_7290_ATP_Olambda__1125,axiom,
    ! [C: $tType,B: $tType,Uu: set(old_node(B,C)),Uua: set(old_node(B,C)),Uub: set(old_node(B,C)),Uuc: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),aTP_Lamp_azb(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))))),Uu),Uua),Uub),Uuc) = aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),insert(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_Scons(B,C,Uu,Uub)),old_Scons(B,C,Uua,Uuc))),bot_bot(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))) ) ).

% ATP.lambda_1125
tff(fact_7291_ATP_Olambda__1126,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: B,Uub: array(B),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(B,fun(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awb(nat,fun(B,fun(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),aa(nat,B,nth(B,array_get(B,Uuc,Uub)),Uu)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(B,Uub,Uu,Uua,Uuc)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_1126
tff(fact_7292_ATP_Olambda__1127,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(set(B),fun(B,fun(B,$o)),aTP_Lamp_dz(set(product_prod(B,B)),fun(set(B),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uuc)),Uu)
        & ~ aa(set(B),$o,member(B,Uub),Uua)
        & ~ aa(set(B),$o,member(B,Uuc),Uua) ) ) ).

% ATP.lambda_1127
tff(fact_7293_ATP_Olambda__1128,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: set(product_prod(B,B)),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aTP_Lamp_uo(fun(B,nat),fun(set(product_prod(B,B)),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,Uu,Uub)),aa(B,nat,Uu,Uuc))
        | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(B,nat,Uu,Uub)),aa(B,nat,Uu,Uuc))
          & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uuc)),Uua) ) ) ) ).

% ATP.lambda_1128
tff(fact_7294_ATP_Olambda__1129,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: fun(B,C),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(fun(B,C),fun(B,fun(B,$o)),aTP_Lamp_auq(set(product_prod(C,C)),fun(fun(B,C),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(set(product_prod(C,C)),$o,member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),aa(B,C,Uua,Uub)),aa(B,C,Uua,Uuc))),Uu) ) ).

% ATP.lambda_1129
tff(fact_7295_ATP_Olambda__1130,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,option(C)),Uua: fun(product_prod(B,C),$o),Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(product_prod(B,C),$o),fun(B,fun(C,$o)),aTP_Lamp_aao(fun(B,option(C)),fun(fun(product_prod(B,C),$o),fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( aa(B,option(C),Uu,Uub) = aa(C,option(C),some(C),Uuc) )
        & aa(product_prod(B,C),$o,Uua,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uub),Uuc)) ) ) ).

% ATP.lambda_1130
tff(fact_7296_ATP_Olambda__1131,axiom,
    ! [B: $tType,C: $tType] :
      ( order(B)
     => ! [Uu: fun(B,set(C)),Uua: set(C),Uub: set(C),Uuc: B] : ( aa(B,set(C),aa(set(C),fun(B,set(C)),aa(set(C),fun(set(C),fun(B,set(C))),aTP_Lamp_lt(fun(B,set(C)),fun(set(C),fun(set(C),fun(B,set(C)))),Uu),Uua),Uub),Uuc) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),aa(B,set(C),Uu,Uuc)),Uua)),Uub) ) ) ).

% ATP.lambda_1131
tff(fact_7297_ATP_Olambda__1132,axiom,
    ! [B: $tType,Uu: set(B),Uua: fun(set(B),set(B)),Uub: set(B),Uuc: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),aa(fun(set(B),set(B)),fun(set(B),fun(set(B),set(B))),aTP_Lamp_ne(set(B),fun(fun(set(B),set(B)),fun(set(B),fun(set(B),set(B)))),Uu),Uua),Uub),Uuc) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),Uua,Uuc)),Uub)),Uu) ) ).

% ATP.lambda_1132
tff(fact_7298_ATP_Olambda__1133,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Uu: B,Uua: B,Uub: nat,Uuc: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(B,fun(nat,fun(nat,B)),aTP_Lamp_vn(B,fun(B,fun(nat,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,binomial(Uub),Uuc))),comm_s3205402744901411588hammer(B,Uu,Uuc))),comm_s3205402744901411588hammer(B,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_1133
tff(fact_7299_ATP_Olambda__1134,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_uk(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,semiring_1_of_nat(nat),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uu),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_1134
tff(fact_7300_ATP_Olambda__1135,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: B,Uua: B,Uub: nat,Uuc: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(B,fun(nat,fun(nat,B)),aTP_Lamp_um(B,fun(B,fun(nat,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uu),Uuc))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_1135
tff(fact_7301_ATP_Olambda__1136,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: nat,Uub: list(B),Uuc: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(nat,fun(list(B),fun(list(B),$o)),aTP_Lamp_and(set(product_prod(B,B)),fun(nat,fun(list(B),fun(list(B),$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( aa(list(B),nat,size_size(list(B)),Uub) = Uua )
        & ( aa(list(B),nat,size_size(list(B)),Uuc) = Uua )
        & ? [Xys2: list(B),X3: B,Y4: B,Xs4: list(B),Ys4: list(B)] :
            ( ( Uub = append(B,Xys2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X3),Xs4)) )
            & ( Uuc = append(B,Xys2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y4),Ys4)) )
            & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Y4)),Uu) ) ) ) ).

% ATP.lambda_1136
tff(fact_7302_ATP_Olambda__1137,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [Uu: B,Uua: nat,Uub: B,Uuc: nat] : ( aa(nat,B,aa(B,fun(nat,B),aa(nat,fun(B,fun(nat,B)),aTP_Lamp_vg(B,fun(nat,fun(B,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uuc)))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uu),Uuc)) ) ) ).

% ATP.lambda_1137
tff(fact_7303_ATP_Olambda__1138,axiom,
    ! [B: $tType,Uu: $o,Uua: B,Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(B,fun(B,fun(B,$o)),aTP_Lamp_ez($o,fun(B,fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( (Uu)
         => ( Uuc = Uua ) )
        & ( ~ (Uu)
         => ( Uuc = Uub ) ) ) ) ).

% ATP.lambda_1138
tff(fact_7304_ATP_Olambda__1139,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,B),Uua: set(C),Uub: fun(B,$o),Uuc: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(set(C),fun(fun(B,$o),fun(B,$o)),aTP_Lamp_cd(fun(C,B),fun(set(C),fun(fun(B,$o),fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),aa(set(C),set(B),image2(C,B,Uu),Uua))
        & aa(B,$o,Uub,Uuc) ) ) ).

% ATP.lambda_1139
tff(fact_7305_ATP_Olambda__1140,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: multiset(C),Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(multiset(C),fun(B,fun(C,$o)),aTP_Lamp_apa(fun(C,B),fun(multiset(C),fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(C),$o,member(C,Uuc),aa(multiset(C),set(C),set_mset(C),Uua))
        & ( Uub = aa(C,B,Uu,Uuc) ) ) ) ).

% ATP.lambda_1140
tff(fact_7306_ATP_Olambda__1141,axiom,
    ! [C: $tType,D: $tType,Uu: set(D),Uua: fun(C,fun(D,$o)),Uub: C,Uuc: D] :
      ( aa(D,$o,aa(C,fun(D,$o),aa(fun(C,fun(D,$o)),fun(C,fun(D,$o)),aTP_Lamp_ash(set(D),fun(fun(C,fun(D,$o)),fun(C,fun(D,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(D),$o,member(D,Uuc),Uu)
        & aa(D,$o,aa(C,fun(D,$o),Uua,Uub),Uuc) ) ) ).

% ATP.lambda_1141
tff(fact_7307_ATP_Olambda__1142,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: fun(B,fun(C,$o)),Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aTP_Lamp_ol(set(C),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(C),$o,member(C,Uuc),Uu)
        & aa(C,$o,aa(B,fun(C,$o),Uua,Uub),Uuc) ) ) ).

% ATP.lambda_1142
tff(fact_7308_ATP_Olambda__1143,axiom,
    ! [C: $tType,D: $tType,Uu: set(C),Uua: fun(C,fun(D,$o)),Uub: D,Uuc: C] :
      ( aa(C,$o,aa(D,fun(C,$o),aa(fun(C,fun(D,$o)),fun(D,fun(C,$o)),aTP_Lamp_asj(set(C),fun(fun(C,fun(D,$o)),fun(D,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(C),$o,member(C,Uuc),Uu)
        & aa(D,$o,aa(C,fun(D,$o),Uua,Uuc),Uub) ) ) ).

% ATP.lambda_1143
tff(fact_7309_ATP_Olambda__1144,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(B,fun(C,$o)),Uub: C,Uuc: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aa(fun(B,fun(C,$o)),fun(C,fun(B,$o)),aTP_Lamp_ko(set(B),fun(fun(B,fun(C,$o)),fun(C,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),Uu)
        & aa(C,$o,aa(B,fun(C,$o),Uua,Uuc),Uub) ) ) ).

% ATP.lambda_1144
tff(fact_7310_ATP_Olambda__1145,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: set(product_prod(C,C)),Uub: C,Uuc: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aa(set(product_prod(C,C)),fun(C,fun(B,$o)),aTP_Lamp_bbc(set(B),fun(set(product_prod(C,C)),fun(C,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),Uu)
        & ( aa(B,C,bNF_Greatest_toCard(B,C,Uu,Uua),Uuc) = Uub ) ) ) ).

% ATP.lambda_1145
tff(fact_7311_ATP_Olambda__1146,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: fun(B,C),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(fun(B,C),fun(B,fun(B,$o)),aTP_Lamp_kq(set(B),fun(fun(B,C),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),Uu)
        & ( aa(B,C,Uua,Uuc) = aa(B,C,Uua,Uub) ) ) ) ).

% ATP.lambda_1146
tff(fact_7312_ATP_Olambda__1147,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: set(B),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(set(B),fun(B,fun(B,$o)),aTP_Lamp_kg(fun(B,C),fun(set(B),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),Uua)
        & ( aa(B,C,Uu,Uub) = aa(B,C,Uu,Uuc) ) ) ) ).

% ATP.lambda_1147
tff(fact_7313_ATP_Olambda__1148,axiom,
    ! [C: $tType,D: $tType,Uu: set(C),Uua: fun(C,D),Uub: D,Uuc: C] :
      ( aa(C,$o,aa(D,fun(C,$o),aa(fun(C,D),fun(D,fun(C,$o)),aTP_Lamp_asn(set(C),fun(fun(C,D),fun(D,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(C),$o,member(C,Uuc),Uu)
        & ( aa(C,D,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_1148
tff(fact_7314_ATP_Olambda__1149,axiom,
    ! [C: $tType,B: $tType,Uu: set(C),Uua: fun(C,B),Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(C,B),fun(B,fun(C,$o)),aTP_Lamp_kf(set(C),fun(fun(C,B),fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(C),$o,member(C,Uuc),Uu)
        & ( aa(C,B,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_1149
tff(fact_7315_ATP_Olambda__1150,axiom,
    ! [B: $tType,D: $tType,Uu: set(B),Uua: fun(B,D),Uub: D,Uuc: B] :
      ( aa(B,$o,aa(D,fun(B,$o),aa(fun(B,D),fun(D,fun(B,$o)),aTP_Lamp_pe(set(B),fun(fun(B,D),fun(D,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),Uu)
        & ( aa(B,D,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_1150
tff(fact_7316_ATP_Olambda__1151,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(B,C),Uub: C,Uuc: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aa(fun(B,C),fun(C,fun(B,$o)),aTP_Lamp_pm(set(B),fun(fun(B,C),fun(C,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),Uu)
        & ( aa(B,C,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_1151
tff(fact_7317_ATP_Olambda__1152,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,C),Uua: set(B),Uub: C,Uuc: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aa(set(B),fun(C,fun(B,$o)),aTP_Lamp_eo(fun(B,C),fun(set(B),fun(C,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),Uua)
        & ( aa(B,C,Uu,Uuc) = Uub ) ) ) ).

% ATP.lambda_1152
tff(fact_7318_ATP_Olambda__1153,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: fun(C,B),Uub: set(C),Uuc: C] :
      ( aa(C,$o,aa(set(C),fun(C,$o),aa(fun(C,B),fun(set(C),fun(C,$o)),aTP_Lamp_kt(set(B),fun(fun(C,B),fun(set(C),fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(C),$o,member(C,Uuc),Uub)
        & aa(set(B),$o,member(B,aa(C,B,Uua,Uuc)),Uu) ) ) ).

% ATP.lambda_1153
tff(fact_7319_ATP_Olambda__1154,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [Uu: B,Uua: nat,Uub: B,Uuc: nat] : ( aa(nat,B,aa(B,fun(nat,B),aa(nat,fun(B,fun(nat,B)),aTP_Lamp_vh(B,fun(nat,fun(B,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uu),Uuc)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uuc))) ) ) ).

% ATP.lambda_1154
tff(fact_7320_ATP_Olambda__1155,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_uj(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(Uu),Uuc)),aa(nat,nat,binomial(Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_1155
tff(fact_7321_ATP_Olambda__1156,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: list(B),Uub: list(B),Uuc: list(B)] : ( aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),aa(list(B),fun(list(B),fun(list(B),list(B))),aTP_Lamp_amo(fun(B,C),fun(list(B),fun(list(B),fun(list(B),list(B)))),Uu),Uua),Uub),Uuc) = append(B,aa(list(B),list(B),linorder_sort_key(B,C,Uu),Uua),append(B,Uub,aa(list(B),list(B),linorder_sort_key(B,C,Uu),Uuc))) ) ) ).

% ATP.lambda_1156
tff(fact_7322_ATP_Olambda__1157,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aa(int,fun(int,fun(int,$o)),aTP_Lamp_aam(int,fun(int,fun(int,fun(int,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub)) ) ).

% ATP.lambda_1157
tff(fact_7323_ATP_Olambda__1158,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_wo(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_1158
tff(fact_7324_ATP_Olambda__1159,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aa(int,fun(int,fun(int,$o)),aTP_Lamp_aak(int,fun(int,fun(int,fun(int,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub)) ) ).

% ATP.lambda_1159
tff(fact_7325_ATP_Olambda__1160,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_wm(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_1160
tff(fact_7326_ATP_Olambda__1161,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_wq(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)) ) ).

% ATP.lambda_1161
tff(fact_7327_ATP_Olambda__1162,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_ws(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ).

% ATP.lambda_1162
tff(fact_7328_ATP_Olambda__1163,axiom,
    ! [B: $tType,C: $tType,Uu: B,Uua: list(B),Uub: C,Uuc: list(C)] : ( aa(list(C),list(product_prod(B,C)),aa(C,fun(list(C),list(product_prod(B,C))),aa(list(B),fun(C,fun(list(C),list(product_prod(B,C)))),aTP_Lamp_amj(B,fun(list(B),fun(C,fun(list(C),list(product_prod(B,C))))),Uu),Uua),Uub),Uuc) = aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),Uub)),zip(B,C,Uua,Uuc)) ) ).

% ATP.lambda_1163
tff(fact_7329_ATP_Olambda__1164,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: list(C),Uub: B,Uuc: list(B)] : ( aa(list(B),list(product_prod(B,C)),aa(B,fun(list(B),list(product_prod(B,C))),aa(list(C),fun(B,fun(list(B),list(product_prod(B,C)))),aTP_Lamp_amk(C,fun(list(C),fun(B,fun(list(B),list(product_prod(B,C))))),Uu),Uua),Uub),Uuc) = aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uub),Uu)),zip(B,C,Uuc,Uua)) ) ).

% ATP.lambda_1164
tff(fact_7330_ATP_Olambda__1165,axiom,
    ! [B: $tType,C: $tType,Uu: filter(B),Uua: filter(C),Uub: fun(B,$o),Uuc: fun(C,$o)] :
      ( aa(fun(C,$o),$o,aa(fun(B,$o),fun(fun(C,$o),$o),aa(filter(C),fun(fun(B,$o),fun(fun(C,$o),$o)),aTP_Lamp_qr(filter(B),fun(filter(C),fun(fun(B,$o),fun(fun(C,$o),$o))),Uu),Uua),Uub),Uuc)
    <=> ( eventually(B,Uub,Uu)
        & eventually(C,Uuc,Uua) ) ) ).

% ATP.lambda_1165
tff(fact_7331_ATP_Olambda__1166,axiom,
    ! [B: $tType,C: $tType,Uu: B,Uua: C,Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(C,fun(B,fun(C,$o)),aTP_Lamp_et(B,fun(C,fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( Uu = Uub )
        & ( Uua = Uuc ) ) ) ).

% ATP.lambda_1166
tff(fact_7332_ATP_Olambda__1167,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_wz(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua) ) ) ).

% ATP.lambda_1167
tff(fact_7333_ATP_Olambda__1168,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: set(C),Uub: fun(B,$o),Uuc: C] :
      ( aa(C,$o,aa(fun(B,$o),fun(C,$o),aa(set(C),fun(fun(B,$o),fun(C,$o)),aTP_Lamp_ce(fun(C,B),fun(set(C),fun(fun(B,$o),fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(C),$o,member(C,Uuc),Uua)
        & aa(B,$o,Uub,aa(C,B,Uu,Uuc)) ) ) ).

% ATP.lambda_1168
tff(fact_7334_ATP_Olambda__1169,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(D,set(product_prod(B,C))),Uua: D,Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(D,fun(B,fun(C,$o)),aTP_Lamp_hk(fun(D,set(product_prod(B,C))),fun(D,fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(set(product_prod(B,C)),$o,member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uub),Uuc)),aa(D,set(product_prod(B,C)),Uu,Uua)) ) ).

% ATP.lambda_1169
tff(fact_7335_ATP_Olambda__1170,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(B,C),Uuc: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aa(fun(B,C),fun(fun(B,C),fun(B,$o)),aTP_Lamp_le(set(B),fun(fun(B,C),fun(fun(B,C),fun(B,$o))),Uu),Uua),Uub),Uuc)
        <=> ( aa(set(B),$o,member(B,Uuc),Uu)
            & ( aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Uua,Uuc)),aa(B,C,Uub,Uuc)) != one_one(C) ) ) ) ) ).

% ATP.lambda_1170
tff(fact_7336_ATP_Olambda__1171,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(B,C),Uuc: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aa(fun(B,C),fun(fun(B,C),fun(B,$o)),aTP_Lamp_lg(set(B),fun(fun(B,C),fun(fun(B,C),fun(B,$o))),Uu),Uua),Uub),Uuc)
        <=> ( aa(set(B),$o,member(B,Uuc),Uu)
            & ( aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,Uua,Uuc)),aa(B,C,Uub,Uuc)) != zero_zero(C) ) ) ) ) ).

% ATP.lambda_1171
tff(fact_7337_ATP_Olambda__1172,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: set(C),Uub: fun(C,B),Uuc: C] :
      ( aa(C,$o,aa(fun(C,B),fun(C,$o),aa(set(C),fun(fun(C,B),fun(C,$o)),aTP_Lamp_asb(B,fun(set(C),fun(fun(C,B),fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(C),$o,member(C,Uuc),Uua)
        & ( aa(C,B,Uub,Uuc) != Uu ) ) ) ).

% ATP.lambda_1172
tff(fact_7338_ATP_Olambda__1173,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: fun(C,B),Uub: set(C),Uuc: C] :
      ( aa(C,$o,aa(set(C),fun(C,$o),aa(fun(C,B),fun(set(C),fun(C,$o)),aTP_Lamp_atn(B,fun(fun(C,B),fun(set(C),fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(C),$o,member(C,Uuc),Uub)
        & ( aa(C,B,Uua,Uuc) != Uu ) ) ) ).

% ATP.lambda_1173
tff(fact_7339_ATP_Olambda__1174,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: list(C),Uuc: nat] : ( aa(nat,B,aa(list(C),fun(nat,B),aa(B,fun(list(C),fun(nat,B)),aTP_Lamp_ajd(fun(C,B),fun(B,fun(list(C),fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,Uu,aa(nat,C,nth(C,Uub),Uuc))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uua),Uuc)) ) ) ).

% ATP.lambda_1174
tff(fact_7340_ATP_Olambda__1175,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: fun(C,$o),Uub: fun(B,C),Uuc: B] :
      ( aa(B,$o,aa(fun(B,C),fun(B,$o),aa(fun(C,$o),fun(fun(B,C),fun(B,$o)),aTP_Lamp_pu(set(B),fun(fun(C,$o),fun(fun(B,C),fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(C,$o,Uua,aa(B,C,Uub,Uuc))
        & aa(set(B),$o,member(B,Uuc),Uu) ) ) ).

% ATP.lambda_1175
tff(fact_7341_ATP_Olambda__1176,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: set(C),Uub: fun(B,$o),Uuc: C] :
      ( aa(C,$o,aa(fun(B,$o),fun(C,$o),aa(set(C),fun(fun(B,$o),fun(C,$o)),aTP_Lamp_bbj(fun(C,B),fun(set(C),fun(fun(B,$o),fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(B,$o,Uub,aa(C,B,Uu,Uuc))
        & aa(set(C),$o,member(C,Uuc),Uua) ) ) ).

% ATP.lambda_1176
tff(fact_7342_ATP_Olambda__1177,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: fun(C,B),Uub: fun(B,$o),Uuc: C] :
      ( aa(C,$o,aa(fun(B,$o),fun(C,$o),aa(fun(C,B),fun(fun(B,$o),fun(C,$o)),aTP_Lamp_afc(set(C),fun(fun(C,B),fun(fun(B,$o),fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(B,$o,Uub,aa(C,B,Uua,Uuc))
        & aa(set(C),$o,member(C,Uuc),Uu) ) ) ).

% ATP.lambda_1177
tff(fact_7343_ATP_Olambda__1178,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,$o),Uua: fun(B,fun(C,$o)),Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aTP_Lamp_dp(fun(B,$o),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(B,$o,Uu,Uub)
        & aa(C,$o,aa(B,fun(C,$o),Uua,Uub),Uuc) ) ) ).

% ATP.lambda_1178
tff(fact_7344_ATP_Olambda__1179,axiom,
    ! [D: $tType,C: $tType,B: $tType,E: $tType,Uu: fun(D,set(B)),Uua: fun(E,set(C)),Uub: D,Uuc: E] : ( aa(E,set(product_prod(B,C)),aa(D,fun(E,set(product_prod(B,C))),aa(fun(E,set(C)),fun(D,fun(E,set(product_prod(B,C)))),aTP_Lamp_fr(fun(D,set(B)),fun(fun(E,set(C)),fun(D,fun(E,set(product_prod(B,C))))),Uu),Uua),Uub),Uuc) = product_Sigma(B,C,aa(D,set(B),Uu,Uub),aa(E,fun(B,set(C)),aTP_Lamp_fq(fun(E,set(C)),fun(E,fun(B,set(C))),Uua),Uuc)) ) ).

% ATP.lambda_1179
tff(fact_7345_ATP_Olambda__1180,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: fun(B,B),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(fun(B,B),fun(B,fun(B,$o)),aTP_Lamp_to(fun(B,$o),fun(fun(B,B),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(B,$o,Uu,Uuc)
        & ( Uub = aa(B,B,Uua,Uuc) ) ) ) ).

% ATP.lambda_1180
tff(fact_7346_ATP_Olambda__1181,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_semiring_0(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: C,Uuc: B] : ( aa(B,B,aa(C,fun(B,B),aa(B,fun(C,fun(B,B)),aTP_Lamp_ajb(fun(C,B),fun(B,fun(C,fun(B,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(C,B,Uu,Uub)),aa(B,B,aa(B,fun(B,B),times_times(B),Uua),Uuc)) ) ) ).

% ATP.lambda_1181
tff(fact_7347_ATP_Olambda__1182,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( semiring_0(B)
        & comm_monoid_add(C)
        & times(C) )
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: C,Uuc: D] : ( aa(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_apl(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,Uu,Uub)),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_1182
tff(fact_7348_ATP_Olambda__1183,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: C,Uuc: D] : ( aa(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_oq(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,Uu,Uub)),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_1183
tff(fact_7349_ATP_Olambda__1184,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,nat),Uua: fun(C,nat),Uub: B,Uuc: C] : ( aa(C,nat,aa(B,fun(C,nat),aa(fun(C,nat),fun(B,fun(C,nat)),aTP_Lamp_ahc(fun(B,nat),fun(fun(C,nat),fun(B,fun(C,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(B,nat,Uu,Uub)),aa(C,nat,Uua,Uuc)) ) ).

% ATP.lambda_1184
tff(fact_7350_ATP_Olambda__1185,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( semiring_0(D)
     => ! [Uu: fun(B,D),Uua: fun(C,D),Uub: B,Uuc: C] : ( aa(C,D,aa(B,fun(C,D),aa(fun(C,D),fun(B,fun(C,D)),aTP_Lamp_qd(fun(B,D),fun(fun(C,D),fun(B,fun(C,D))),Uu),Uua),Uub),Uuc) = aa(D,D,aa(D,fun(D,D),times_times(D),aa(B,D,Uu,Uub)),aa(C,D,Uua,Uuc)) ) ) ).

% ATP.lambda_1185
tff(fact_7351_ATP_Olambda__1186,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(C,set(B)),Uua: fun(D,set(B)),Uub: C,Uuc: D] : ( aa(D,set(B),aa(C,fun(D,set(B)),aa(fun(D,set(B)),fun(C,fun(D,set(B))),aTP_Lamp_ik(fun(C,set(B)),fun(fun(D,set(B)),fun(C,fun(D,set(B)))),Uu),Uua),Uub),Uuc) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(C,set(B),Uu,Uub)),aa(D,set(B),Uua,Uuc)) ) ).

% ATP.lambda_1186
tff(fact_7352_ATP_Olambda__1187,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: C,Uuc: D] : ( aa(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_ie(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,Uu,Uub)),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_1187
tff(fact_7353_ATP_Olambda__1188,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(C,set(B)),Uua: fun(D,set(B)),Uub: C,Uuc: D] : ( aa(D,set(B),aa(C,fun(D,set(B)),aa(fun(D,set(B)),fun(C,fun(D,set(B))),aTP_Lamp_gl(fun(C,set(B)),fun(fun(D,set(B)),fun(C,fun(D,set(B)))),Uu),Uua),Uub),Uuc) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(C,set(B),Uu,Uub)),aa(D,set(B),Uua,Uuc)) ) ).

% ATP.lambda_1188
tff(fact_7354_ATP_Olambda__1189,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: C,Uuc: D] : ( aa(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_gb(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,Uu,Uub)),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_1189
tff(fact_7355_ATP_Olambda__1190,axiom,
    ! [C: $tType,B: $tType,Uu: fun(set(old_node(B,C)),set(set(old_node(B,C)))),Uua: fun(set(old_node(B,C)),set(set(old_node(B,C)))),Uub: set(old_node(B,C)),Uuc: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),set(set(old_node(B,C)))),aa(fun(set(old_node(B,C)),set(set(old_node(B,C)))),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(set(old_node(B,C))))),aTP_Lamp_azl(fun(set(old_node(B,C)),set(set(old_node(B,C)))),fun(fun(set(old_node(B,C)),set(set(old_node(B,C)))),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(set(old_node(B,C)))))),Uu),Uua),Uub),Uuc) = old_uprod(B,C,aa(set(old_node(B,C)),set(set(old_node(B,C))),Uu,Uub),aa(set(old_node(B,C)),set(set(old_node(B,C))),Uua,Uuc)) ) ).

% ATP.lambda_1190
tff(fact_7356_ATP_Olambda__1191,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Uu: fun(B,filter(D)),Uua: fun(C,filter(E)),Uub: B,Uuc: C] : ( aa(C,filter(product_prod(D,E)),aa(B,fun(C,filter(product_prod(D,E))),aa(fun(C,filter(E)),fun(B,fun(C,filter(product_prod(D,E)))),aTP_Lamp_qy(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,fun(C,filter(product_prod(D,E))))),Uu),Uua),Uub),Uuc) = prod_filter(D,E,aa(B,filter(D),Uu,Uub),aa(C,filter(E),Uua,Uuc)) ) ).

% ATP.lambda_1191
tff(fact_7357_ATP_Olambda__1192,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,Uu: fun(D,B),Uua: fun(E,C),Uub: D,Uuc: E] : ( aa(E,product_prod(B,C),aa(D,fun(E,product_prod(B,C)),aa(fun(E,C),fun(D,fun(E,product_prod(B,C))),aTP_Lamp_ek(fun(D,B),fun(fun(E,C),fun(D,fun(E,product_prod(B,C)))),Uu),Uua),Uub),Uuc) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Uu,Uub)),aa(E,C,Uua,Uuc)) ) ).

% ATP.lambda_1192
tff(fact_7358_ATP_Olambda__1193,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Uu: fun(B,D),Uua: fun(C,E),Uub: B,Uuc: C] : ( aa(C,product_prod(D,E),aa(B,fun(C,product_prod(D,E)),aa(fun(C,E),fun(B,fun(C,product_prod(D,E))),aTP_Lamp_anq(fun(B,D),fun(fun(C,E),fun(B,fun(C,product_prod(D,E)))),Uu),Uua),Uub),Uuc) = aa(E,product_prod(D,E),aa(D,fun(E,product_prod(D,E)),product_Pair(D,E),aa(B,D,Uu,Uub)),aa(C,E,Uua,Uuc)) ) ).

% ATP.lambda_1193
tff(fact_7359_ATP_Olambda__1194,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,$o),Uua: fun(C,$o),Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(C,$o),fun(B,fun(C,$o)),aTP_Lamp_cv(fun(B,$o),fun(fun(C,$o),fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(B,$o,Uu,Uub)
        & aa(C,$o,Uua,Uuc) ) ) ).

% ATP.lambda_1194
tff(fact_7360_ATP_Olambda__1195,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(B)
     => ! [Uu: fun(C,B),Uua: fun(list(C),B),Uub: list(C),Uuc: C] :
          ( aa(C,$o,aa(list(C),fun(C,$o),aa(fun(list(C),B),fun(list(C),fun(C,$o)),aTP_Lamp_ali(fun(C,B),fun(fun(list(C),B),fun(list(C),fun(C,$o))),Uu),Uua),Uub),Uuc)
        <=> ( aa(C,B,Uu,Uuc) = aa(list(C),B,Uua,Uub) ) ) ) ).

% ATP.lambda_1195
tff(fact_7361_ATP_Olambda__1196,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [Uu: set(C),Uua: fun(B,fun(C,D)),Uub: fun(B,fun(C,$o)),Uuc: B] : ( aa(B,D,aa(fun(B,fun(C,$o)),fun(B,D),aa(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(B,D)),aTP_Lamp_om(set(C),fun(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(B,D))),Uu),Uua),Uub),Uuc) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),aa(B,fun(C,D),Uua,Uuc)),aa(fun(C,$o),set(C),collect(C),aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aTP_Lamp_ol(set(C),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1196
tff(fact_7362_ATP_Olambda__1197,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(D)
     => ! [Uu: set(C),Uua: fun(B,fun(C,D)),Uub: fun(B,fun(C,$o)),Uuc: B] : ( aa(B,D,aa(fun(B,fun(C,$o)),fun(B,D),aa(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(B,D)),aTP_Lamp_ov(set(C),fun(fun(B,fun(C,D)),fun(fun(B,fun(C,$o)),fun(B,D))),Uu),Uua),Uub),Uuc) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),aa(B,fun(C,D),Uua,Uuc)),aa(fun(C,$o),set(C),collect(C),aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aTP_Lamp_ol(set(C),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1197
tff(fact_7363_ATP_Olambda__1198,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: list(B),Uub: B,Uuc: list(B)] : ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),aa(list(B),fun(B,fun(list(B),list(B))),aTP_Lamp_amq(fun(B,C),fun(list(B),fun(B,fun(list(B),list(B)))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(B),product_prod(list(B),list(B))),list(B),aa(fun(list(B),fun(product_prod(list(B),list(B)),list(B))),fun(product_prod(list(B),product_prod(list(B),list(B))),list(B)),product_case_prod(list(B),product_prod(list(B),list(B)),list(B)),aTP_Lamp_amp(fun(B,C),fun(list(B),fun(product_prod(list(B),list(B)),list(B))),Uu)),linorder_part(B,C,Uu,aa(B,C,Uu,aa(nat,B,nth(B,Uua),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(list(B),nat,size_size(list(B)),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),Uua)) ) ) ).

% ATP.lambda_1198
tff(fact_7364_ATP_Olambda__1199,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(B,$o)),Uua: fun(C,B),Uub: C,Uuc: C] :
      ( aa(C,$o,aa(C,fun(C,$o),aa(fun(C,B),fun(C,fun(C,$o)),aTP_Lamp_rz(fun(B,fun(B,$o)),fun(fun(C,B),fun(C,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( aa(C,B,Uua,Uub) != aa(C,B,Uua,Uuc) )
       => aa(B,$o,aa(B,fun(B,$o),Uu,aa(C,B,Uua,Uub)),aa(C,B,Uua,Uuc)) ) ) ).

% ATP.lambda_1199
tff(fact_7365_ATP_Olambda__1200,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,set(C)),Uua: set(C),Uub: set(C),Uuc: B] :
      ( aa(B,$o,aa(set(C),fun(B,$o),aa(set(C),fun(set(C),fun(B,$o)),aTP_Lamp_nt(fun(B,set(C)),fun(set(C),fun(set(C),fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(C),$o,finite_finite2(C),aa(B,set(C),Uu,Uuc))
        & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),Uub),aa(B,set(C),Uu,Uuc))
        & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),Uu,Uuc)),Uua) ) ) ).

% ATP.lambda_1200
tff(fact_7366_ATP_Olambda__1201,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( semiring_1(D)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(C,D),Uuc: C] : ( aa(C,D,aa(fun(C,D),fun(C,D),aa(fun(B,C),fun(fun(C,D),fun(C,D)),aTP_Lamp_rq(set(B),fun(fun(B,C),fun(fun(C,D),fun(C,D))),Uu),Uua),Uub),Uuc) = aa(D,D,aa(D,fun(D,D),times_times(D),aa(nat,D,semiring_1_of_nat(D),aa(set(B),nat,finite_card(B),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aa(fun(B,C),fun(C,fun(B,$o)),aTP_Lamp_pm(set(B),fun(fun(B,C),fun(C,fun(B,$o))),Uu),Uua),Uuc))))),aa(C,D,Uub,Uuc)) ) ) ).

% ATP.lambda_1201
tff(fact_7367_ATP_Olambda__1202,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(set(old_node(C,D)),B),Uua: fun(set(old_node(C,D)),B),Uub: set(old_node(C,D)),Uuc: B] :
      ( aa(B,$o,aa(set(old_node(C,D)),fun(B,$o),aa(fun(set(old_node(C,D)),B),fun(set(old_node(C,D)),fun(B,$o)),aTP_Lamp_ayy(fun(set(old_node(C,D)),B),fun(fun(set(old_node(C,D)),B),fun(set(old_node(C,D)),fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ? [X3: set(old_node(C,D))] :
            ( ( Uub = old_In0(C,D,X3) )
            & ( Uuc = aa(set(old_node(C,D)),B,Uu,X3) ) )
        | ? [Y4: set(old_node(C,D))] :
            ( ( Uub = old_In1(C,D,Y4) )
            & ( Uuc = aa(set(old_node(C,D)),B,Uua,Y4) ) ) ) ) ).

% ATP.lambda_1202
tff(fact_7368_ATP_Olambda__1203,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: fun(B,fun(B,$o)),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aTP_Lamp_ku(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ? [A6: B] :
            ( ( Uub = A6 )
            & ( Uuc = A6 ) )
        | ? [A6: B,B5: B,C4: B] :
            ( ( Uub = A6 )
            & ( Uuc = C4 )
            & aa(B,$o,aa(B,fun(B,$o),Uua,A6),B5)
            & aa(B,$o,aa(B,fun(B,$o),Uu,B5),C4) ) ) ) ).

% ATP.lambda_1203
tff(fact_7369_ATP_Olambda__1204,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: fun(B,fun(B,$o)),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aTP_Lamp_kv(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ? [A6: B,B5: B] :
            ( ( Uub = A6 )
            & ( Uuc = B5 )
            & aa(B,$o,aa(B,fun(B,$o),Uu,A6),B5) )
        | ? [A6: B,B5: B,C4: B] :
            ( ( Uub = A6 )
            & ( Uuc = C4 )
            & aa(B,$o,aa(B,fun(B,$o),Uua,A6),B5)
            & aa(B,$o,aa(B,fun(B,$o),Uu,B5),C4) ) ) ) ).

% ATP.lambda_1204
tff(fact_7370_ATP_Olambda__1205,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: fun(list(B),fun(list(B),$o)),Uub: list(B),Uuc: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(list(B),fun(list(B),$o)),fun(list(B),fun(list(B),$o)),aTP_Lamp_ain(fun(B,fun(B,$o)),fun(fun(list(B),fun(list(B),$o)),fun(list(B),fun(list(B),$o))),Uu),Uua),Uub),Uuc)
    <=> ( ? [Y4: B,Ys2: list(B)] :
            ( ( Uub = nil(B) )
            & ( Uuc = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y4),Ys2) ) )
        | ? [X3: B,Y4: B,Xs3: list(B),Ys2: list(B)] :
            ( ( Uub = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X3),Xs3) )
            & ( Uuc = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y4),Ys2) )
            & aa(B,$o,aa(B,fun(B,$o),Uu,X3),Y4) )
        | ? [X3: B,Y4: B,Xs3: list(B),Ys2: list(B)] :
            ( ( Uub = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X3),Xs3) )
            & ( Uuc = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y4),Ys2) )
            & ~ aa(B,$o,aa(B,fun(B,$o),Uu,X3),Y4)
            & ~ aa(B,$o,aa(B,fun(B,$o),Uu,Y4),X3)
            & aa(list(B),$o,aa(list(B),fun(list(B),$o),Uua,Xs3),Ys2) ) ) ) ).

% ATP.lambda_1205
tff(fact_7371_ATP_Olambda__1206,axiom,
    ! [B: $tType,C: $tType,Uu: $o,Uua: fun(B,fun(C,assn)),Uub: B,Uuc: C] : ( aa(C,assn,aa(B,fun(C,assn),aa(fun(B,fun(C,assn)),fun(B,fun(C,assn)),aTP_Lamp_ac($o,fun(fun(B,fun(C,assn)),fun(B,fun(C,assn))),Uu),Uua),Uub),Uuc) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),pure_assn(Uu)),aa(C,assn,aa(B,fun(C,assn),Uua,Uub),Uuc)) ) ).

% ATP.lambda_1206
tff(fact_7372_ATP_Olambda__1207,axiom,
    ! [B: $tType,Uu: B,Uua: list(B),Uub: B,Uuc: nat] : ( aa(nat,list(B),aa(B,fun(nat,list(B)),aa(list(B),fun(B,fun(nat,list(B))),aTP_Lamp_ajj(B,fun(list(B),fun(B,fun(nat,list(B)))),Uu),Uua),Uub),Uuc) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uu),list_update(B,Uua,Uuc,Uub)) ) ).

% ATP.lambda_1207
tff(fact_7373_ATP_Olambda__1208,axiom,
    ! [B: $tType,C: $tType,Uu: $o,Uua: fun(B,fun(C,$o)),Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aTP_Lamp_cs($o,fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( (Uu)
        & aa(C,$o,aa(B,fun(C,$o),Uua,Uub),Uuc) ) ) ).

% ATP.lambda_1208
tff(fact_7374_ATP_Olambda__1209,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: fun(B,B),Uub: array(B),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(fun(B,B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awc(nat,fun(fun(B,B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_Pair(array(B),product_prod(heap_ext(product_unit),nat)),Uub),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(B,Uub,Uu,aa(B,B,Uua,aa(nat,B,nth(B,array_get(B,Uuc,Uub)),Uu)),Uuc)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_1209
tff(fact_7375_ATP_Olambda__1210,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: B,Uub: array(B),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(B,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_awd(nat,fun(B,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_Pair(array(B),product_prod(heap_ext(product_unit),nat)),Uub),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(B,Uub,Uu,Uua,Uuc)),one_one(nat))) ) ) ).

% ATP.lambda_1210
tff(fact_7376_ATP_Olambda__1211,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(D,B),Uua: fun(D,C),Uub: set(D),Uuc: B] : ( aa(B,set(C),aa(set(D),fun(B,set(C)),aa(fun(D,C),fun(set(D),fun(B,set(C))),aTP_Lamp_cp(fun(D,B),fun(fun(D,C),fun(set(D),fun(B,set(C)))),Uu),Uua),Uub),Uuc) = aa(set(D),set(C),image2(D,C,Uua),aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),inf_inf(set(D)),aa(set(B),set(D),aa(fun(D,B),fun(set(B),set(D)),vimage(D,B),Uu),aa(set(B),set(B),insert(B,Uuc),bot_bot(set(B))))),Uub)) ) ).

% ATP.lambda_1211
tff(fact_7377_ATP_Olambda__1212,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,heap_Time_Heap(B)),Uua: C,Uub: heap_ext(product_unit),Uuc: nat] : ( aa(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(C,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_axi(fun(C,heap_Time_Heap(B)),fun(C,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua),Uub),Uuc) = heap_Time_timeFrame(B,Uuc,aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_Time_execute(B,aa(C,heap_Time_Heap(B),Uu,Uua)),Uub)) ) ).

% ATP.lambda_1212
tff(fact_7378_ATP_Olambda__1213,axiom,
    ! [B: $tType,Uu: list(B),Uua: list(B),Uub: B,Uuc: list(B)] : ( aa(list(B),option($o),aa(B,fun(list(B),option($o)),aa(list(B),fun(B,fun(list(B),option($o))),aTP_Lamp_anf(list(B),fun(list(B),fun(B,fun(list(B),option($o)))),Uu),Uua),Uub),Uuc) = subset_eq_mset_impl(B,Uu,append(B,Uua,Uuc)) ) ).

% ATP.lambda_1213
tff(fact_7379_ATP_Olambda__1214,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(B,D),Uuc: D] : ( aa(D,C,aa(fun(B,D),fun(D,C),aa(fun(B,C),fun(fun(B,D),fun(D,C)),aTP_Lamp_pf(set(B),fun(fun(B,C),fun(fun(B,D),fun(D,C))),Uu),Uua),Uub),Uuc) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Uua),aa(fun(B,$o),set(B),collect(B),aa(D,fun(B,$o),aa(fun(B,D),fun(D,fun(B,$o)),aTP_Lamp_pe(set(B),fun(fun(B,D),fun(D,fun(B,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1214
tff(fact_7380_ATP_Olambda__1215,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comm_monoid_mult(D)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(B,D),Uuc: C] : ( aa(C,D,aa(fun(B,D),fun(C,D),aa(fun(B,C),fun(fun(B,D),fun(C,D)),aTP_Lamp_pn(set(B),fun(fun(B,C),fun(fun(B,D),fun(C,D))),Uu),Uua),Uub),Uuc) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),Uub),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aa(fun(B,C),fun(C,fun(B,$o)),aTP_Lamp_pm(set(B),fun(fun(B,C),fun(C,fun(B,$o))),Uu),Uua),Uuc))) ) ) ).

% ATP.lambda_1215
tff(fact_7381_ATP_Olambda__1216,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(B,D),Uuc: D] : ( aa(D,C,aa(fun(B,D),fun(D,C),aa(fun(B,C),fun(fun(B,D),fun(D,C)),aTP_Lamp_ph(set(B),fun(fun(B,C),fun(fun(B,D),fun(D,C))),Uu),Uua),Uub),Uuc) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Uua),aa(fun(B,$o),set(B),collect(B),aa(D,fun(B,$o),aa(fun(B,D),fun(D,fun(B,$o)),aTP_Lamp_pe(set(B),fun(fun(B,D),fun(D,fun(B,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1216
tff(fact_7382_ATP_Olambda__1217,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comm_monoid_add(D)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(B,D),Uuc: C] : ( aa(C,D,aa(fun(B,D),fun(C,D),aa(fun(B,C),fun(fun(B,D),fun(C,D)),aTP_Lamp_pq(set(B),fun(fun(B,C),fun(fun(B,D),fun(C,D))),Uu),Uua),Uub),Uuc) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),Uub),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aa(fun(B,C),fun(C,fun(B,$o)),aTP_Lamp_pm(set(B),fun(fun(B,C),fun(C,fun(B,$o))),Uu),Uua),Uuc))) ) ) ).

% ATP.lambda_1217
tff(fact_7383_ATP_Olambda__1218,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [Uu: B,Uua: list(B),Uub: B,Uuc: list(B)] : ( aa(list(B),B,aa(B,fun(list(B),B),aa(list(B),fun(B,fun(list(B),B)),aTP_Lamp_amf(B,fun(list(B),fun(B,fun(list(B),B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),ord_min(B),Uu),min_list(B,Uua)) ) ) ).

% ATP.lambda_1218
tff(fact_7384_ATP_Olambda__1219,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(C,B),Uua: fun(D,fun(list(D),C)),Uub: D,Uuc: list(D)] : ( aa(list(D),B,aa(D,fun(list(D),B),aa(fun(D,fun(list(D),C)),fun(D,fun(list(D),B)),aTP_Lamp_aly(fun(C,B),fun(fun(D,fun(list(D),C)),fun(D,fun(list(D),B))),Uu),Uua),Uub),Uuc) = aa(C,B,Uu,aa(list(D),C,aa(D,fun(list(D),C),Uua,Uub),Uuc)) ) ).

% ATP.lambda_1219
tff(fact_7385_ATP_Olambda__1220,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType,Uu: fun(C,B),Uua: fun(D,fun(E,C)),Uub: D,Uuc: E] : ( aa(E,B,aa(D,fun(E,B),aa(fun(D,fun(E,C)),fun(D,fun(E,B)),aTP_Lamp_dg(fun(C,B),fun(fun(D,fun(E,C)),fun(D,fun(E,B))),Uu),Uua),Uub),Uuc) = aa(C,B,Uu,aa(E,C,aa(D,fun(E,C),Uua,Uub),Uuc)) ) ).

% ATP.lambda_1220
tff(fact_7386_ATP_Olambda__1221,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,B),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_wf(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_1221
tff(fact_7387_ATP_Olambda__1222,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,B),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_wd(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_1222
tff(fact_7388_ATP_Olambda__1223,axiom,
    ! [B: $tType,Uu: fun(nat,B),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_asu(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ).

% ATP.lambda_1223
tff(fact_7389_ATP_Olambda__1224,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,B),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_sf(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_1224
tff(fact_7390_ATP_Olambda__1225,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(nat,B),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_se(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_1225
tff(fact_7391_ATP_Olambda__1226,axiom,
    ! [B: $tType,Uu: fun(nat,B),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(nat,fun(nat,fun(nat,B)),aTP_Lamp_asr(fun(nat,B),fun(nat,fun(nat,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ).

% ATP.lambda_1226
tff(fact_7392_ATP_Olambda__1227,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: nat,Uub: list(B),Uuc: nat] :
      ( aa(nat,$o,aa(list(B),fun(nat,$o),aa(nat,fun(list(B),fun(nat,$o)),aTP_Lamp_aqk(fun(B,$o),fun(nat,fun(list(B),fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(B,$o,Uu,aa(nat,B,nth(B,take(B,Uua,Uub)),Uuc)) ) ).

% ATP.lambda_1227
tff(fact_7393_ATP_Olambda__1228,axiom,
    ! [B: $tType,E: $tType,C: $tType,D: $tType,Uu: fun(product_prod(C,D),B),Uua: fun(E,C),Uub: E,Uuc: D] : ( aa(D,B,aa(E,fun(D,B),aa(fun(E,C),fun(E,fun(D,B)),aTP_Lamp_aju(fun(product_prod(C,D),B),fun(fun(E,C),fun(E,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(product_prod(C,D),B,Uu,aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(E,C,Uua,Uub)),Uuc)) ) ).

% ATP.lambda_1228
tff(fact_7394_ATP_Olambda__1229,axiom,
    ! [B: $tType,C: $tType,D: $tType,E: $tType,Uu: fun(product_prod(C,D),B),Uua: fun(E,D),Uub: C,Uuc: E] : ( aa(E,B,aa(C,fun(E,B),aa(fun(E,D),fun(C,fun(E,B)),aTP_Lamp_ajv(fun(product_prod(C,D),B),fun(fun(E,D),fun(C,fun(E,B))),Uu),Uua),Uub),Uuc) = aa(product_prod(C,D),B,Uu,aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),Uub),aa(E,D,Uua,Uuc))) ) ).

% ATP.lambda_1229
tff(fact_7395_ATP_Olambda__1230,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(D,fun(C,B)),Uua: fun(D,D),Uub: fun(fun(C,B),D),Uuc: fun(C,B)] : ( aa(fun(C,B),fun(C,B),aa(fun(fun(C,B),D),fun(fun(C,B),fun(C,B)),aa(fun(D,D),fun(fun(fun(C,B),D),fun(fun(C,B),fun(C,B))),aTP_Lamp_bah(fun(D,fun(C,B)),fun(fun(D,D),fun(fun(fun(C,B),D),fun(fun(C,B),fun(C,B)))),Uu),Uua),Uub),Uuc) = aa(D,fun(C,B),Uu,aa(D,D,Uua,aa(fun(C,B),D,Uub,Uuc))) ) ).

% ATP.lambda_1230
tff(fact_7396_ATP_Olambda__1231,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(D,fun(B,heap_Time_Heap(C))),Uua: fun(D,D),Uub: fun(fun(B,heap_Time_Heap(C)),D),Uuc: fun(B,heap_Time_Heap(C))] : ( aa(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)))),aTP_Lamp_bao(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))))),Uu),Uua),Uub),Uuc) = aa(D,fun(B,heap_Time_Heap(C)),Uu,aa(D,D,Uua,aa(fun(B,heap_Time_Heap(C)),D,Uub,Uuc))) ) ).

% ATP.lambda_1231
tff(fact_7397_ATP_Olambda__1232,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(D,fun(B,option(C))),Uua: fun(D,D),Uub: fun(fun(B,option(C)),D),Uuc: fun(B,option(C))] : ( aa(fun(B,option(C)),fun(B,option(C)),aa(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C))),aa(fun(D,D),fun(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C)))),aTP_Lamp_bad(fun(D,fun(B,option(C))),fun(fun(D,D),fun(fun(fun(B,option(C)),D),fun(fun(B,option(C)),fun(B,option(C))))),Uu),Uua),Uub),Uuc) = aa(D,fun(B,option(C)),Uu,aa(D,D,Uua,aa(fun(B,option(C)),D,Uub,Uuc))) ) ).

% ATP.lambda_1232
tff(fact_7398_ATP_Olambda__1233,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(D,fun(B,C)),Uua: fun(D,D),Uub: fun(fun(B,C),D),Uuc: fun(B,C)] : ( aa(fun(B,C),fun(B,C),aa(fun(fun(B,C),D),fun(fun(B,C),fun(B,C)),aa(fun(D,D),fun(fun(fun(B,C),D),fun(fun(B,C),fun(B,C))),aTP_Lamp_bab(fun(D,fun(B,C)),fun(fun(D,D),fun(fun(fun(B,C),D),fun(fun(B,C),fun(B,C)))),Uu),Uua),Uub),Uuc) = aa(D,fun(B,C),Uu,aa(D,D,Uua,aa(fun(B,C),D,Uub,Uuc))) ) ).

% ATP.lambda_1233
tff(fact_7399_ATP_Olambda__1234,axiom,
    ! [D: $tType,E: $tType,C: $tType,B: $tType,Uu: fun(B,C),Uua: fun(E,D),Uub: fun(C,E),Uuc: B] : ( aa(B,D,aa(fun(C,E),fun(B,D),aa(fun(E,D),fun(fun(C,E),fun(B,D)),aTP_Lamp_bbb(fun(B,C),fun(fun(E,D),fun(fun(C,E),fun(B,D))),Uu),Uua),Uub),Uuc) = aa(E,D,Uua,aa(C,E,Uub,aa(B,C,Uu,Uuc))) ) ).

% ATP.lambda_1234
tff(fact_7400_ATP_Olambda__1235,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Uu: fun(B,fun(D,$o)),Uua: fun(C,fun(E,$o)),Uub: B,Uuc: C] : ( aa(C,fun(product_prod(D,E),$o),aa(B,fun(C,fun(product_prod(D,E),$o)),aa(fun(C,fun(E,$o)),fun(B,fun(C,fun(product_prod(D,E),$o))),aTP_Lamp_aov(fun(B,fun(D,$o)),fun(fun(C,fun(E,$o)),fun(B,fun(C,fun(product_prod(D,E),$o)))),Uu),Uua),Uub),Uuc) = aa(fun(D,fun(E,$o)),fun(product_prod(D,E),$o),product_case_prod(D,E,$o),aa(C,fun(D,fun(E,$o)),aa(B,fun(C,fun(D,fun(E,$o))),aa(fun(C,fun(E,$o)),fun(B,fun(C,fun(D,fun(E,$o)))),aTP_Lamp_aou(fun(B,fun(D,$o)),fun(fun(C,fun(E,$o)),fun(B,fun(C,fun(D,fun(E,$o))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_1235
tff(fact_7401_ATP_Olambda__1236,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B,Uuc: list(B)] : ( aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),aa(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),aa(C,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))))),aTP_Lamp_akp(fun(B,C),fun(C,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))))),Uu),Uua),Uub),Uuc) = aa(fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_case_prod(list(B),list(B),product_prod(list(B),product_prod(list(B),list(B)))),aa(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))),aa(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))),aa(C,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))))),aTP_Lamp_ako(fun(B,C),fun(C,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))))),Uu),Uua),Uub),Uuc)) ) ) ).

% ATP.lambda_1236
tff(fact_7402_ATP_Olambda__1237,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(C,C)),Uub: B,Uuc: C] : ( aa(C,fun(product_prod(B,C),$o),aa(B,fun(C,fun(product_prod(B,C),$o)),aa(set(product_prod(C,C)),fun(B,fun(C,fun(product_prod(B,C),$o))),aTP_Lamp_jm(set(product_prod(B,B)),fun(set(product_prod(C,C)),fun(B,fun(C,fun(product_prod(B,C),$o)))),Uu),Uua),Uub),Uuc) = aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(C,fun(B,fun(C,$o)),aa(B,fun(C,fun(B,fun(C,$o))),aa(set(product_prod(C,C)),fun(B,fun(C,fun(B,fun(C,$o)))),aTP_Lamp_jl(set(product_prod(B,B)),fun(set(product_prod(C,C)),fun(B,fun(C,fun(B,fun(C,$o))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_1237
tff(fact_7403_ATP_Olambda__1238,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,$o),Uua: fun(B,set(product_prod(C,C))),Uub: B,Uuc: C] : ( aa(C,fun(product_prod(B,C),$o),aa(B,fun(C,fun(product_prod(B,C),$o)),aa(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(product_prod(B,C),$o))),aTP_Lamp_jk(fun(B,$o),fun(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(product_prod(B,C),$o)))),Uu),Uua),Uub),Uuc) = aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(C,fun(B,fun(C,$o)),aa(B,fun(C,fun(B,fun(C,$o))),aa(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(B,fun(C,$o)))),aTP_Lamp_jj(fun(B,$o),fun(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(B,fun(C,$o))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_1238
tff(fact_7404_ATP_Olambda__1239,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( semiring_0(B)
        & comm_monoid_add(C)
        & times(C) )
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: multiset(D),Uuc: C] : ( aa(C,B,aa(multiset(D),fun(C,B),aa(fun(D,B),fun(multiset(D),fun(C,B)),aTP_Lamp_apm(fun(C,B),fun(fun(D,B),fun(multiset(D),fun(C,B))),Uu),Uua),Uub),Uuc) = comm_m7189776963980413722m_mset(B,aa(multiset(D),multiset(B),image_mset(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_apl(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_1239
tff(fact_7405_ATP_Olambda__1240,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(C,set(B)),Uua: fun(D,set(B)),Uub: set(D),Uuc: C] : ( aa(C,set(B),aa(set(D),fun(C,set(B)),aa(fun(D,set(B)),fun(set(D),fun(C,set(B))),aTP_Lamp_gm(fun(C,set(B)),fun(fun(D,set(B)),fun(set(D),fun(C,set(B)))),Uu),Uua),Uub),Uuc) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(C,fun(D,set(B)),aa(fun(D,set(B)),fun(C,fun(D,set(B))),aTP_Lamp_gl(fun(C,set(B)),fun(fun(D,set(B)),fun(C,fun(D,set(B)))),Uu),Uua),Uuc)),Uub)) ) ).

% ATP.lambda_1240
tff(fact_7406_ATP_Olambda__1241,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: set(D),Uuc: C] : ( aa(C,B,aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_gc(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),Uu),Uua),Uub),Uuc) = aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_gb(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_1241
tff(fact_7407_ATP_Olambda__1242,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Uu: set(C),Uua: fun(B,filter(D)),Uub: fun(C,filter(E)),Uuc: B] : ( aa(B,filter(product_prod(D,E)),aa(fun(C,filter(E)),fun(B,filter(product_prod(D,E))),aa(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,filter(product_prod(D,E)))),aTP_Lamp_qz(set(C),fun(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,filter(product_prod(D,E))))),Uu),Uua),Uub),Uuc) = aa(set(filter(product_prod(D,E))),filter(product_prod(D,E)),complete_Inf_Inf(filter(product_prod(D,E))),aa(set(C),set(filter(product_prod(D,E))),image2(C,filter(product_prod(D,E)),aa(B,fun(C,filter(product_prod(D,E))),aa(fun(C,filter(E)),fun(B,fun(C,filter(product_prod(D,E)))),aTP_Lamp_qy(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,fun(C,filter(product_prod(D,E))))),Uua),Uub),Uuc)),Uu)) ) ).

% ATP.lambda_1242
tff(fact_7408_ATP_Olambda__1243,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(C,set(B)),Uua: fun(D,set(B)),Uub: set(D),Uuc: C] : ( aa(C,set(B),aa(set(D),fun(C,set(B)),aa(fun(D,set(B)),fun(set(D),fun(C,set(B))),aTP_Lamp_il(fun(C,set(B)),fun(fun(D,set(B)),fun(set(D),fun(C,set(B)))),Uu),Uua),Uub),Uuc) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(C,fun(D,set(B)),aa(fun(D,set(B)),fun(C,fun(D,set(B))),aTP_Lamp_ik(fun(C,set(B)),fun(fun(D,set(B)),fun(C,fun(D,set(B)))),Uu),Uua),Uuc)),Uub)) ) ).

% ATP.lambda_1243
tff(fact_7409_ATP_Olambda__1244,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: set(D),Uuc: C] : ( aa(C,B,aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_if(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),Uu),Uua),Uub),Uuc) = aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_ie(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_1244
tff(fact_7410_ATP_Olambda__1245,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aaq(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_1245
tff(fact_7411_ATP_Olambda__1246,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aas(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_1246
tff(fact_7412_ATP_Olambda__1247,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: list(B),Uub: B,Uuc: list(B)] : ( aa(list(B),option(product_prod(list(B),product_prod(B,list(B)))),aa(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))),aa(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B)))))),aTP_Lamp_aml(fun(B,$o),fun(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(B),product_prod(B,list(B))),option(product_prod(list(B),product_prod(B,list(B)))),some(product_prod(list(B),product_prod(B,list(B)))),aa(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B))),aa(list(B),fun(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B)))),product_Pair(list(B),product_prod(B,list(B))),takeWhile(B,aa(fun(B,$o),fun(B,$o),comp($o,$o,B,fNot),Uu),Uua)),aa(list(B),product_prod(B,list(B)),aa(B,fun(list(B),product_prod(B,list(B))),product_Pair(B,list(B)),Uub),Uuc))) ) ).

% ATP.lambda_1247
tff(fact_7413_ATP_Olambda__1248,axiom,
    ! [B: $tType,Uu: B,Uua: list(B),Uub: B,Uuc: list(B)] : ( aa(list(B),option(product_prod(list(B),product_prod(B,list(B)))),aa(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))),aa(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B)))))),aTP_Lamp_alt(B,fun(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(B),product_prod(B,list(B))),option(product_prod(list(B),product_prod(B,list(B)))),some(product_prod(list(B),product_prod(B,list(B)))),aa(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B))),aa(list(B),fun(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B)))),product_Pair(list(B),product_prod(B,list(B))),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uu),Uua)),aa(list(B),product_prod(B,list(B)),aa(B,fun(list(B),product_prod(B,list(B))),product_Pair(B,list(B)),Uub),Uuc))) ) ).

% ATP.lambda_1248
tff(fact_7414_ATP_Olambda__1249,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aax(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uub)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_1249
tff(fact_7415_ATP_Olambda__1250,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_aav(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub))) ) ).

% ATP.lambda_1250
tff(fact_7416_ATP_Olambda__1251,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: fun(B,fun(C,set(D))),Uub: C,Uuc: B] : ( aa(B,set(D),aa(C,fun(B,set(D)),aa(fun(B,fun(C,set(D))),fun(C,fun(B,set(D))),aTP_Lamp_kh(set(product_prod(C,C)),fun(fun(B,fun(C,set(D))),fun(C,fun(B,set(D)))),Uu),Uua),Uub),Uuc) = aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),aa(B,fun(C,set(D)),Uua,Uuc)),aa(set(C),set(C),image(C,C,Uu),aa(set(C),set(C),insert(C,Uub),bot_bot(set(C)))))) ) ).

% ATP.lambda_1251
tff(fact_7417_ATP_Olambda__1252,axiom,
    ! [D: $tType,B: $tType,C: $tType,F10: $tType,E: $tType,Uu: fun(C,fun(D,fun(E,fun(F10,set(B))))),Uua: set(product_prod(E,F10)),Uub: C,Uuc: D] : ( aa(D,set(B),aa(C,fun(D,set(B)),aa(set(product_prod(E,F10)),fun(C,fun(D,set(B))),aTP_Lamp_hp(fun(C,fun(D,fun(E,fun(F10,set(B))))),fun(set(product_prod(E,F10)),fun(C,fun(D,set(B)))),Uu),Uua),Uub),Uuc) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(product_prod(E,F10)),set(set(B)),image2(product_prod(E,F10),set(B),aa(fun(E,fun(F10,set(B))),fun(product_prod(E,F10),set(B)),product_case_prod(E,F10,set(B)),aa(D,fun(E,fun(F10,set(B))),aa(C,fun(D,fun(E,fun(F10,set(B)))),Uu,Uub),Uuc))),Uua)) ) ).

% ATP.lambda_1252
tff(fact_7418_ATP_Olambda__1253,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: set(C),Uub: C,Uuc: fun(B,C)] :
      ( aa(fun(B,C),$o,aa(C,fun(fun(B,C),$o),aa(set(C),fun(C,fun(fun(B,C),$o)),aTP_Lamp_afi(set(B),fun(set(C),fun(C,fun(fun(B,C),$o))),Uu),Uua),Uub),Uuc)
    <=> ! [X3: B] :
          ( ( aa(set(B),$o,member(B,X3),Uu)
           => aa(set(C),$o,member(C,aa(B,C,Uuc,X3)),Uua) )
          & ( ~ aa(set(B),$o,member(B,X3),Uu)
           => ( aa(B,C,Uuc,X3) = Uub ) ) ) ) ).

% ATP.lambda_1253
tff(fact_7419_ATP_Olambda__1254,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: set(product_prod(B,D)),Uua: set(product_prod(D,C)),Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(product_prod(D,C)),fun(B,fun(C,$o)),aTP_Lamp_mc(set(product_prod(B,D)),fun(set(product_prod(D,C)),fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ? [Y4: D] :
          ( aa(set(product_prod(B,D)),$o,member(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),Uub),Y4)),Uu)
          & aa(set(product_prod(D,C)),$o,member(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),Y4),Uuc)),Uua) ) ) ).

% ATP.lambda_1254
tff(fact_7420_ATP_Olambda__1255,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: set(D),Uua: fun(D,B),Uub: fun(D,C),Uuc: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(fun(D,C),fun(product_prod(B,C),$o),aa(fun(D,B),fun(fun(D,C),fun(product_prod(B,C),$o)),aTP_Lamp_bj(set(D),fun(fun(D,B),fun(fun(D,C),fun(product_prod(B,C),$o))),Uu),Uua),Uub),Uuc)
    <=> ? [A6: D] :
          ( ( Uuc = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Uua,A6)),aa(D,C,Uub,A6)) )
          & aa(set(D),$o,member(D,A6),Uu) ) ) ).

% ATP.lambda_1255
tff(fact_7421_ATP_Olambda__1256,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: C,Uub: set(C),Uuc: B] :
      ( aa(B,$o,aa(set(C),fun(B,$o),aa(C,fun(set(C),fun(B,$o)),aTP_Lamp_cu(fun(C,B),fun(C,fun(set(C),fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ? [L5: C] :
          ( ( Uuc = aa(C,B,Uu,L5) )
          & ( ( L5 = Uua )
            | aa(set(C),$o,member(C,L5),Uub) ) ) ) ).

% ATP.lambda_1256
tff(fact_7422_ATP_Olambda__1257,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(B)
     => ! [Uu: B,Uua: B,Uub: fun(B,C),Uuc: C] :
          ( aa(C,$o,aa(fun(B,C),fun(C,$o),aa(B,fun(fun(B,C),fun(C,$o)),aTP_Lamp_tr(B,fun(B,fun(fun(B,C),fun(C,$o))),Uu),Uua),Uub),Uuc)
        <=> ? [I5: B] :
              ( ( Uuc = aa(B,C,Uub,I5) )
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uu),I5)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),I5),Uua) ) ) ) ).

% ATP.lambda_1257
tff(fact_7423_ATP_Olambda__1258,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: fun(B,fun(C,D)),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(fun(B,fun(C,D)),fun(B,fun(B,$o)),aTP_Lamp_ado(set(product_prod(C,C)),fun(fun(B,fun(C,D)),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ! [X3: product_prod(C,C)] :
          ( aa(set(product_prod(C,C)),$o,member(product_prod(C,C),X3),Uu)
         => aa(product_prod(C,C),$o,aa(fun(C,fun(C,$o)),fun(product_prod(C,C),$o),product_case_prod(C,C,$o),aa(B,fun(C,fun(C,$o)),aa(B,fun(B,fun(C,fun(C,$o))),aTP_Lamp_adn(fun(B,fun(C,D)),fun(B,fun(B,fun(C,fun(C,$o)))),Uua),Uub),Uuc)),X3) ) ) ).

% ATP.lambda_1258
tff(fact_7424_ATP_Olambda__1259,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(B,$o),Uua: fun(C,$o),Uub: fun(B,fun(C,D)),Uuc: D] :
      ( aa(D,$o,aa(fun(B,fun(C,D)),fun(D,$o),aa(fun(C,$o),fun(fun(B,fun(C,D)),fun(D,$o)),aTP_Lamp_kr(fun(B,$o),fun(fun(C,$o),fun(fun(B,fun(C,D)),fun(D,$o))),Uu),Uua),Uub),Uuc)
    <=> ? [X3: B,Y4: C] :
          ( ( Uuc = aa(C,D,aa(B,fun(C,D),Uub,X3),Y4) )
          & aa(B,$o,Uu,X3)
          & aa(C,$o,Uua,Y4) ) ) ).

% ATP.lambda_1259
tff(fact_7425_ATP_Olambda__1260,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: set(product_prod(C,C)),Uub: fun(B,C),Uuc: product_prod(B,B)] :
      ( aa(product_prod(B,B),$o,aa(fun(B,C),fun(product_prod(B,B),$o),aa(set(product_prod(C,C)),fun(fun(B,C),fun(product_prod(B,B),$o)),aTP_Lamp_by(set(B),fun(set(product_prod(C,C)),fun(fun(B,C),fun(product_prod(B,B),$o))),Uu),Uua),Uub),Uuc)
    <=> ? [A17: B,A25: B] :
          ( ( Uuc = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A17),A25) )
          & aa(set(B),$o,member(B,A17),Uu)
          & aa(set(B),$o,member(B,A25),Uu)
          & aa(set(product_prod(C,C)),$o,member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),aa(B,C,Uub,A17)),aa(B,C,Uub,A25))),Uua) ) ) ).

% ATP.lambda_1260
tff(fact_7426_ATP_Olambda__1261,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(nat,fun(nat,B)),Uuc: nat,Uud: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),aa(B,fun(fun(nat,fun(nat,B)),fun(nat,fun(nat,B))),aTP_Lamp_asy(fun(B,fun(B,B)),fun(B,fun(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Uu,Uua),aa(nat,fun(nat,B),aTP_Lamp_asx(fun(nat,fun(nat,B)),fun(nat,fun(nat,B)),Uub),Uud)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uud),Uuc)) ) ).

% ATP.lambda_1261
tff(fact_7427_ATP_Olambda__1262,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(C,fun(D,B)),Uuc: set(C),Uud: D] : ( aa(D,B,aa(set(C),fun(D,B),aa(fun(C,fun(D,B)),fun(set(C),fun(D,B)),aa(B,fun(fun(C,fun(D,B)),fun(set(C),fun(D,B))),aTP_Lamp_arz(fun(B,fun(B,B)),fun(B,fun(fun(C,fun(D,B)),fun(set(C),fun(D,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Uu,Uua),aa(D,fun(C,B),aTP_Lamp_ary(fun(C,fun(D,B)),fun(D,fun(C,B)),Uub),Uud)),Uuc) ) ).

% ATP.lambda_1262
tff(fact_7428_ATP_Olambda__1263,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(C,set(D)),Uuc: fun(C,fun(D,B)),Uud: C] : ( aa(C,B,aa(fun(C,fun(D,B)),fun(C,B),aa(fun(C,set(D)),fun(fun(C,fun(D,B)),fun(C,B)),aa(B,fun(fun(C,set(D)),fun(fun(C,fun(D,B)),fun(C,B))),aTP_Lamp_asv(fun(B,fun(B,B)),fun(B,fun(fun(C,set(D)),fun(fun(C,fun(D,B)),fun(C,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,Uu,Uua),aa(C,fun(D,B),Uuc,Uud)),aa(C,set(D),Uub,Uud)) ) ).

% ATP.lambda_1263
tff(fact_7429_ATP_Olambda__1264,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(C,fun(D,B)),Uuc: set(D),Uud: C] : ( aa(C,B,aa(set(D),fun(C,B),aa(fun(C,fun(D,B)),fun(set(D),fun(C,B)),aa(B,fun(fun(C,fun(D,B)),fun(set(D),fun(C,B))),aTP_Lamp_arx(fun(B,fun(B,B)),fun(B,fun(fun(C,fun(D,B)),fun(set(D),fun(C,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,Uu,Uua),aa(C,fun(D,B),Uub,Uud)),Uuc) ) ).

% ATP.lambda_1264
tff(fact_7430_ATP_Olambda__1265,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(nat,B),Uuc: nat,Uud: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(fun(nat,B),fun(nat,fun(nat,B)),aa(B,fun(fun(nat,B),fun(nat,fun(nat,B))),aTP_Lamp_asz(fun(B,fun(B,B)),fun(B,fun(fun(nat,B),fun(nat,fun(nat,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Uu,Uua),Uub),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uud),Uuc),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uud),Uuc)),Uuc))) ) ).

% ATP.lambda_1265
tff(fact_7431_ATP_Olambda__1266,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(C,set(D)),Uuc: fun(D,B),Uud: C] : ( aa(C,B,aa(fun(D,B),fun(C,B),aa(fun(C,set(D)),fun(fun(D,B),fun(C,B)),aa(B,fun(fun(C,set(D)),fun(fun(D,B),fun(C,B))),aTP_Lamp_atd(fun(B,fun(B,B)),fun(B,fun(fun(C,set(D)),fun(fun(D,B),fun(C,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,Uu,Uua),Uuc),aa(C,set(D),Uub,Uud)) ) ).

% ATP.lambda_1266
tff(fact_7432_ATP_Olambda__1267,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: D,Uua: B,Uub: B,Uuc: C,Uud: set(product_prod(D,C))] :
      ( aa(set(product_prod(D,C)),set(product_prod(D,C)),aa(C,fun(set(product_prod(D,C)),set(product_prod(D,C))),aa(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aa(B,fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),aTP_Lamp_lk(D,fun(B,fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C)))))),Uu),Uua),Uub),Uuc),Uud)
      = $ite(Uua = Uub,aa(set(product_prod(D,C)),set(product_prod(D,C)),insert(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),Uu),Uuc)),Uud),Uud) ) ).

% ATP.lambda_1267
tff(fact_7433_ATP_Olambda__1268,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: B,Uua: C,Uub: C,Uuc: D,Uud: set(product_prod(B,D))] :
      ( aa(set(product_prod(B,D)),set(product_prod(B,D)),aa(D,fun(set(product_prod(B,D)),set(product_prod(B,D))),aa(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D)))),aa(C,fun(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D))))),aTP_Lamp_md(B,fun(C,fun(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D)))))),Uu),Uua),Uub),Uuc),Uud)
      = $ite(Uua = Uub,aa(set(product_prod(B,D)),set(product_prod(B,D)),insert(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),Uu),Uuc)),Uud),Uud) ) ).

% ATP.lambda_1268
tff(fact_7434_ATP_Olambda__1269,axiom,
    ! [B: $tType,Uu: B,Uua: nat,Uub: fun(nat,B),Uuc: fun(nat,B),Uud: nat] :
      ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aa(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),aTP_Lamp_arv(B,fun(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B)))),Uu),Uua),Uub),Uuc),Uud)
      = $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uud),Uua),
          aa(nat,B,Uub,Uud),
          $ite(Uud = Uua,Uu,aa(nat,B,Uuc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uud),aa(nat,nat,suc,zero_zero(nat))))) ) ) ).

% ATP.lambda_1269
tff(fact_7435_ATP_Olambda__1270,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: list(B),Uub: B,Uuc: list(B),Uud: list(B)] : ( aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),aa(B,fun(list(B),fun(list(B),list(B))),aa(list(B),fun(B,fun(list(B),fun(list(B),list(B)))),aTP_Lamp_ate(fun(B,fun(B,$o)),fun(list(B),fun(B,fun(list(B),fun(list(B),list(B))))),Uu),Uua),Uub),Uuc),Uud) = aa(list(B),list(B),quicksort_by_rel(B,Uu,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),aa(list(B),list(B),quicksort_by_rel(B,Uu,Uua),Uud))),Uuc) ) ).

% ATP.lambda_1270
tff(fact_7436_ATP_Olambda__1271,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(C,fun(D,B)),Uuc: multiset(C),Uud: D] : ( aa(D,B,aa(multiset(C),fun(D,B),aa(fun(C,fun(D,B)),fun(multiset(C),fun(D,B)),aa(B,fun(fun(C,fun(D,B)),fun(multiset(C),fun(D,B))),aTP_Lamp_ava(fun(B,fun(B,B)),fun(B,fun(fun(C,fun(D,B)),fun(multiset(C),fun(D,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(multiset(B),B,comm_monoid_F(B,Uu,Uua),aa(multiset(C),multiset(B),image_mset(C,B,aa(D,fun(C,B),aTP_Lamp_ary(fun(C,fun(D,B)),fun(D,fun(C,B)),Uub),Uud)),Uuc)) ) ).

% ATP.lambda_1271
tff(fact_7437_ATP_Olambda__1272,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(C,fun(D,B)),Uuc: multiset(D),Uud: C] : ( aa(C,B,aa(multiset(D),fun(C,B),aa(fun(C,fun(D,B)),fun(multiset(D),fun(C,B)),aa(B,fun(fun(C,fun(D,B)),fun(multiset(D),fun(C,B))),aTP_Lamp_auz(fun(B,fun(B,B)),fun(B,fun(fun(C,fun(D,B)),fun(multiset(D),fun(C,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(multiset(B),B,comm_monoid_F(B,Uu,Uua),aa(multiset(D),multiset(B),image_mset(D,B,aa(C,fun(D,B),Uub,Uud)),Uuc)) ) ).

% ATP.lambda_1272
tff(fact_7438_ATP_Olambda__1273,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(D,fun(C,B)),Uua: fun(D,D),Uub: fun(fun(C,B),D),Uuc: C,Uud: fun(C,B)] : ( aa(fun(C,B),B,aa(C,fun(fun(C,B),B),aa(fun(fun(C,B),D),fun(C,fun(fun(C,B),B)),aa(fun(D,D),fun(fun(fun(C,B),D),fun(C,fun(fun(C,B),B))),aTP_Lamp_bag(fun(D,fun(C,B)),fun(fun(D,D),fun(fun(fun(C,B),D),fun(C,fun(fun(C,B),B)))),Uu),Uua),Uub),Uuc),Uud) = aa(C,B,aa(D,fun(C,B),Uu,aa(D,D,Uua,aa(fun(C,B),D,Uub,Uud))),Uuc) ) ).

% ATP.lambda_1273
tff(fact_7439_ATP_Olambda__1274,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(D,fun(B,heap_Time_Heap(C))),Uua: fun(D,D),Uub: fun(fun(B,heap_Time_Heap(C)),D),Uuc: B,Uud: fun(B,heap_Time_Heap(C))] : ( aa(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)))),aTP_Lamp_ban(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))))),Uu),Uua),Uub),Uuc),Uud) = aa(B,heap_Time_Heap(C),aa(D,fun(B,heap_Time_Heap(C)),Uu,aa(D,D,Uua,aa(fun(B,heap_Time_Heap(C)),D,Uub,Uud))),Uuc) ) ).

% ATP.lambda_1274
tff(fact_7440_ATP_Olambda__1275,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(D,fun(B,option(C))),Uua: fun(D,D),Uub: fun(fun(B,option(C)),D),Uuc: B,Uud: fun(B,option(C))] : ( aa(fun(B,option(C)),option(C),aa(B,fun(fun(B,option(C)),option(C)),aa(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C))),aa(fun(D,D),fun(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C)))),aTP_Lamp_bac(fun(D,fun(B,option(C))),fun(fun(D,D),fun(fun(fun(B,option(C)),D),fun(B,fun(fun(B,option(C)),option(C))))),Uu),Uua),Uub),Uuc),Uud) = aa(B,option(C),aa(D,fun(B,option(C)),Uu,aa(D,D,Uua,aa(fun(B,option(C)),D,Uub,Uud))),Uuc) ) ).

% ATP.lambda_1275
tff(fact_7441_ATP_Olambda__1276,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(D,fun(B,C)),Uua: fun(D,D),Uub: fun(fun(B,C),D),Uuc: B,Uud: fun(B,C)] : ( aa(fun(B,C),C,aa(B,fun(fun(B,C),C),aa(fun(fun(B,C),D),fun(B,fun(fun(B,C),C)),aa(fun(D,D),fun(fun(fun(B,C),D),fun(B,fun(fun(B,C),C))),aTP_Lamp_baa(fun(D,fun(B,C)),fun(fun(D,D),fun(fun(fun(B,C),D),fun(B,fun(fun(B,C),C)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,C,aa(D,fun(B,C),Uu,aa(D,D,Uua,aa(fun(B,C),D,Uub,Uud))),Uuc) ) ).

% ATP.lambda_1276
tff(fact_7442_ATP_Olambda__1277,axiom,
    ! [B: $tType,E: $tType,D: $tType,F10: $tType,C: $tType,Uu: fun(E,fun(F10,D)),Uua: fun(B,E),Uub: fun(C,F10),Uuc: B,Uud: C] : ( aa(C,D,aa(B,fun(C,D),aa(fun(C,F10),fun(B,fun(C,D)),aa(fun(B,E),fun(fun(C,F10),fun(B,fun(C,D))),aTP_Lamp_anr(fun(E,fun(F10,D)),fun(fun(B,E),fun(fun(C,F10),fun(B,fun(C,D)))),Uu),Uua),Uub),Uuc),Uud) = aa(F10,D,aa(E,fun(F10,D),Uu,aa(B,E,Uua,Uuc)),aa(C,F10,Uub,Uud)) ) ).

% ATP.lambda_1277
tff(fact_7443_ATP_Olambda__1278,axiom,
    ! [E: $tType,C: $tType,B: $tType,D: $tType,F10: $tType,Uu: fun(C,fun(D,B)),Uua: fun(E,C),Uub: fun(F10,D),Uuc: E,Uud: F10] : ( aa(F10,B,aa(E,fun(F10,B),aa(fun(F10,D),fun(E,fun(F10,B)),aa(fun(E,C),fun(fun(F10,D),fun(E,fun(F10,B))),aTP_Lamp_anp(fun(C,fun(D,B)),fun(fun(E,C),fun(fun(F10,D),fun(E,fun(F10,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(D,B,aa(C,fun(D,B),Uu,aa(E,C,Uua,Uuc)),aa(F10,D,Uub,Uud)) ) ).

% ATP.lambda_1278
tff(fact_7444_ATP_Olambda__1279,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,fun(D,B)),Uua: fun(B,fun(C,fun(D,C))),Uub: B,Uuc: C,Uud: D] : ( aa(D,product_prod(B,C),aa(C,fun(D,product_prod(B,C)),aa(B,fun(C,fun(D,product_prod(B,C))),aa(fun(B,fun(C,fun(D,C))),fun(B,fun(C,fun(D,product_prod(B,C)))),aTP_Lamp_aie(fun(B,fun(D,B)),fun(fun(B,fun(C,fun(D,C))),fun(B,fun(C,fun(D,product_prod(B,C))))),Uu),Uua),Uub),Uuc),Uud) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,aa(B,fun(D,B),Uu,Uub),Uud)),aa(D,C,aa(C,fun(D,C),aa(B,fun(C,fun(D,C)),Uua,Uub),Uuc),Uud)) ) ).

% ATP.lambda_1279
tff(fact_7445_ATP_Olambda__1280,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(C,fun(B,$o)),Uua: fun(B,fun(D,$o)),Uub: C,Uuc: D,Uud: B] :
      ( aa(B,$o,aa(D,fun(B,$o),aa(C,fun(D,fun(B,$o)),aa(fun(B,fun(D,$o)),fun(C,fun(D,fun(B,$o))),aTP_Lamp_auy(fun(C,fun(B,$o)),fun(fun(B,fun(D,$o)),fun(C,fun(D,fun(B,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( aa(B,$o,aa(C,fun(B,$o),Uu,Uub),Uud)
        & aa(D,$o,aa(B,fun(D,$o),Uua,Uud),Uuc) ) ) ).

% ATP.lambda_1280
tff(fact_7446_ATP_Olambda__1281,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(B,fun(C,D)),Uua: B,Uub: B,Uuc: C,Uud: C] :
      ( aa(C,$o,aa(C,fun(C,$o),aa(B,fun(C,fun(C,$o)),aa(B,fun(B,fun(C,fun(C,$o))),aTP_Lamp_adn(fun(B,fun(C,D)),fun(B,fun(B,fun(C,fun(C,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( aa(C,D,aa(B,fun(C,D),Uu,Uua),Uuc) = aa(C,D,aa(B,fun(C,D),Uu,Uub),Uud) ) ) ).

% ATP.lambda_1281
tff(fact_7447_ATP_Olambda__1282,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: B,Uub: $o,Uuc: B,Uud: list(B)] :
      ( aa(list(B),$o,aa(B,fun(list(B),$o),aa($o,fun(B,fun(list(B),$o)),aa(B,fun($o,fun(B,fun(list(B),$o))),aTP_Lamp_bbh(fun(B,fun(B,$o)),fun(B,fun($o,fun(B,fun(list(B),$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( aa(B,$o,aa(B,fun(B,$o),Uu,Uua),Uuc)
        & (Uub) ) ) ).

% ATP.lambda_1282
tff(fact_7448_ATP_Olambda__1283,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: nat,Uua: B,Uub: B,Uuc: B,Uud: nat] : ( aa(nat,B,aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_uq(nat,fun(B,fun(B,fun(B,fun(nat,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),Uud)),Uua)),one_one(B))),Uud)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uub),Uud))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_1283
tff(fact_7449_ATP_Olambda__1284,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: nat,Uua: B,Uub: B,Uuc: B,Uud: nat] : ( aa(nat,B,aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_up(nat,fun(B,fun(B,fun(B,fun(nat,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),Uu)),Uua)),Uud)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uub),Uud))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uuc),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_1284
tff(fact_7450_ATP_Olambda__1285,axiom,
    ! [B: $tType,Uu: B,Uua: B,Uub: set(product_prod(B,B)),Uuc: B,Uud: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aa(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o))),aTP_Lamp_gy(B,fun(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uuc),Uu)),transitive_trancl(B,Uub))
          | ( Uuc = Uu ) )
        & ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uud)),transitive_trancl(B,Uub))
          | ( Uud = Uua ) ) ) ) ).

% ATP.lambda_1285
tff(fact_7451_ATP_Olambda__1286,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: nat,Uua: B,Uub: B,Uuc: B,Uud: nat] : ( aa(nat,B,aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_vp(nat,fun(B,fun(B,fun(B,fun(nat,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,aa(B,B,uminus_uminus(B),Uua)),Uud)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),Uub)),Uud))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_1286
tff(fact_7452_ATP_Olambda__1287,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B,Uuc: B,Uud: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(B,fun(B,fun(B,$o)),aa(B,fun(B,fun(B,fun(B,$o))),aTP_Lamp_jc(set(product_prod(B,B)),fun(B,fun(B,fun(B,fun(B,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,Uua),aa(set(B),set(B),insert(B,Uub),aa(set(B),set(B),insert(B,Uuc),aa(set(B),set(B),insert(B,Uud),bot_bot(set(B))))))),field2(B,Uu))
        & ( ( ( Uua = Uuc )
            & ( Uub = Uud ) )
          | aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),bNF_We1388413361240627857o_max2(B,Uu,Uua,Uub)),bNF_We1388413361240627857o_max2(B,Uu,Uuc,Uud))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),Uu),id2(B)))
          | ( ( bNF_We1388413361240627857o_max2(B,Uu,Uua,Uub) = bNF_We1388413361240627857o_max2(B,Uu,Uuc,Uud) )
            & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uuc)),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),Uu),id2(B))) )
          | ( ( bNF_We1388413361240627857o_max2(B,Uu,Uua,Uub) = bNF_We1388413361240627857o_max2(B,Uu,Uuc,Uud) )
            & ( Uua = Uuc )
            & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uud)),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),Uu),id2(B))) ) ) ) ) ).

% ATP.lambda_1287
tff(fact_7453_ATP_Olambda__1288,axiom,
    ! [B: $tType,Uu: B,Uua: B,Uub: set(product_prod(B,B)),Uuc: B,Uud: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aa(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o))),aTP_Lamp_eg(B,fun(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uuc),Uu)),transitive_rtrancl(B,Uub))
        & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uud)),transitive_rtrancl(B,Uub)) ) ) ).

% ATP.lambda_1288
tff(fact_7454_ATP_Olambda__1289,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B,Uuc: B,Uud: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(B,fun(B,fun(B,$o)),aa(B,fun(B,fun(B,fun(B,$o))),aTP_Lamp_adr(set(product_prod(B,B)),fun(B,fun(B,fun(B,fun(B,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( ( Uub = Uuc )
       => aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uud)),Uu) ) ) ).

% ATP.lambda_1289
tff(fact_7455_ATP_Olambda__1290,axiom,
    ! [D: $tType,C: $tType,B: $tType,F10: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(D,fun(B,$o)),Uub: fun(B,fun(F10,$o)),Uuc: D,Uud: F10] :
      ( aa(F10,$o,aa(D,fun(F10,$o),aa(fun(B,fun(F10,$o)),fun(D,fun(F10,$o)),aa(fun(D,fun(B,$o)),fun(fun(B,fun(F10,$o)),fun(D,fun(F10,$o))),aTP_Lamp_are(fun(B,fun(C,$o)),fun(fun(D,fun(B,$o)),fun(fun(B,fun(F10,$o)),fun(D,fun(F10,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ? [X3: B] :
          ( aa(set(B),$o,member(B,X3),aa(fun(B,$o),set(B),collect(B),aa(fun(B,fun(C,$o)),fun(B,$o),domainp(B,C),Uu)))
          & aa(B,$o,aa(D,fun(B,$o),Uua,Uuc),X3)
          & aa(F10,$o,aa(B,fun(F10,$o),Uub,X3),Uud) ) ) ).

% ATP.lambda_1290
tff(fact_7456_ATP_Olambda__1291,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( semiring_0(D)
     => ! [Uu: fun(B,D),Uua: fun(C,D),Uub: set(B),Uuc: set(C),Uud: D] :
          ( aa(D,$o,aa(set(C),fun(D,$o),aa(set(B),fun(set(C),fun(D,$o)),aa(fun(C,D),fun(set(B),fun(set(C),fun(D,$o))),aTP_Lamp_qe(fun(B,D),fun(fun(C,D),fun(set(B),fun(set(C),fun(D,$o)))),Uu),Uua),Uub),Uuc),Uud)
        <=> ? [A6: B,B5: C] :
              ( ( Uud = aa(D,D,aa(D,fun(D,D),times_times(D),aa(B,D,Uu,A6)),aa(C,D,Uua,B5)) )
              & aa(set(B),$o,member(B,A6),Uub)
              & aa(set(C),$o,member(C,B5),Uuc) ) ) ) ).

% ATP.lambda_1291
tff(fact_7457_ATP_Olambda__1292,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: set(C),Uuc: fun(C,fun(D,B)),Uud: fun(C,fun(D,$o)),Uue: D] : ( aa(D,B,aa(fun(C,fun(D,$o)),fun(D,B),aa(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(D,B)),aa(set(C),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(D,B))),aa(B,fun(set(C),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(D,B)))),aTP_Lamp_ask(fun(B,fun(B,B)),fun(B,fun(set(C),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(D,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Uu,Uua),aa(D,fun(C,B),aTP_Lamp_ary(fun(C,fun(D,B)),fun(D,fun(C,B)),Uuc),Uue)),aa(fun(C,$o),set(C),collect(C),aa(D,fun(C,$o),aa(fun(C,fun(D,$o)),fun(D,fun(C,$o)),aTP_Lamp_asj(set(C),fun(fun(C,fun(D,$o)),fun(D,fun(C,$o))),Uub),Uud),Uue))) ) ).

% ATP.lambda_1292
tff(fact_7458_ATP_Olambda__1293,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: set(D),Uuc: fun(C,fun(D,B)),Uud: fun(C,fun(D,$o)),Uue: C] : ( aa(C,B,aa(fun(C,fun(D,$o)),fun(C,B),aa(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(C,B)),aa(set(D),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(C,B))),aa(B,fun(set(D),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(C,B)))),aTP_Lamp_asi(fun(B,fun(B,B)),fun(B,fun(set(D),fun(fun(C,fun(D,B)),fun(fun(C,fun(D,$o)),fun(C,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,Uu,Uua),aa(C,fun(D,B),Uuc,Uue)),aa(fun(D,$o),set(D),collect(D),aa(C,fun(D,$o),aa(fun(C,fun(D,$o)),fun(C,fun(D,$o)),aTP_Lamp_ash(set(D),fun(fun(C,fun(D,$o)),fun(C,fun(D,$o))),Uub),Uud),Uue))) ) ).

% ATP.lambda_1293
tff(fact_7459_ATP_Olambda__1294,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: set(C),Uuc: fun(C,B),Uud: fun(C,D),Uue: D] : ( aa(D,B,aa(fun(C,D),fun(D,B),aa(fun(C,B),fun(fun(C,D),fun(D,B)),aa(set(C),fun(fun(C,B),fun(fun(C,D),fun(D,B))),aa(B,fun(set(C),fun(fun(C,B),fun(fun(C,D),fun(D,B)))),aTP_Lamp_aso(fun(B,fun(B,B)),fun(B,fun(set(C),fun(fun(C,B),fun(fun(C,D),fun(D,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Uu,Uua),Uuc),aa(fun(C,$o),set(C),collect(C),aa(D,fun(C,$o),aa(fun(C,D),fun(D,fun(C,$o)),aTP_Lamp_asn(set(C),fun(fun(C,D),fun(D,fun(C,$o))),Uub),Uud),Uue))) ) ).

% ATP.lambda_1294
tff(fact_7460_ATP_Olambda__1295,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: set(C),Uuc: fun(C,D),Uud: fun(C,B),Uue: D] : ( aa(D,B,aa(fun(C,B),fun(D,B),aa(fun(C,D),fun(fun(C,B),fun(D,B)),aa(set(C),fun(fun(C,D),fun(fun(C,B),fun(D,B))),aa(B,fun(set(C),fun(fun(C,D),fun(fun(C,B),fun(D,B)))),aTP_Lamp_ast(fun(B,fun(B,B)),fun(B,fun(set(C),fun(fun(C,D),fun(fun(C,B),fun(D,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Uu,Uua),Uud),aa(fun(C,$o),set(C),collect(C),aa(D,fun(C,$o),aa(fun(C,D),fun(D,fun(C,$o)),aTP_Lamp_asn(set(C),fun(fun(C,D),fun(D,fun(C,$o))),Uub),Uuc),Uue))) ) ).

% ATP.lambda_1295
tff(fact_7461_ATP_Olambda__1296,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,Uu: fun(B,fun(D,$o)),Uua: fun(C,fun(E,$o)),Uub: B,Uuc: C,Uud: D,Uue: E] :
      ( aa(E,$o,aa(D,fun(E,$o),aa(C,fun(D,fun(E,$o)),aa(B,fun(C,fun(D,fun(E,$o))),aa(fun(C,fun(E,$o)),fun(B,fun(C,fun(D,fun(E,$o)))),aTP_Lamp_aou(fun(B,fun(D,$o)),fun(fun(C,fun(E,$o)),fun(B,fun(C,fun(D,fun(E,$o))))),Uu),Uua),Uub),Uuc),Uud),Uue)
    <=> ( aa(D,$o,aa(B,fun(D,$o),Uu,Uub),Uud)
        & aa(E,$o,aa(C,fun(E,$o),Uua,Uuc),Uue) ) ) ).

% ATP.lambda_1296
tff(fact_7462_ATP_Olambda__1297,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(C,C)),Uub: B,Uuc: C,Uud: B,Uue: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(C,fun(B,fun(C,$o)),aa(B,fun(C,fun(B,fun(C,$o))),aa(set(product_prod(C,C)),fun(B,fun(C,fun(B,fun(C,$o)))),aTP_Lamp_jl(set(product_prod(B,B)),fun(set(product_prod(C,C)),fun(B,fun(C,fun(B,fun(C,$o))))),Uu),Uua),Uub),Uuc),Uud),Uue)
    <=> ( aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uud)),Uu)
        | ( ( Uub = Uud )
          & aa(set(product_prod(C,C)),$o,member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),Uuc),Uue)),Uua) ) ) ) ).

% ATP.lambda_1297
tff(fact_7463_ATP_Olambda__1298,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,$o),Uua: fun(B,set(product_prod(C,C))),Uub: B,Uuc: C,Uud: B,Uue: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(C,fun(B,fun(C,$o)),aa(B,fun(C,fun(B,fun(C,$o))),aa(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(B,fun(C,$o)))),aTP_Lamp_jj(fun(B,$o),fun(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(B,fun(C,$o))))),Uu),Uua),Uub),Uuc),Uud),Uue)
    <=> ( ( Uub = Uud )
        & aa(B,$o,Uu,Uud)
        & aa(set(product_prod(C,C)),$o,member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),Uuc),Uue)),aa(B,set(product_prod(C,C)),Uua,Uud)) ) ) ).

% ATP.lambda_1298
tff(fact_7464_ATP_Olambda__1299,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: set(C),Uuc: fun(C,B),Uud: fun(C,B),Uue: C] :
      ( aa(C,$o,aa(fun(C,B),fun(C,$o),aa(fun(C,B),fun(fun(C,B),fun(C,$o)),aa(set(C),fun(fun(C,B),fun(fun(C,B),fun(C,$o))),aa(B,fun(set(C),fun(fun(C,B),fun(fun(C,B),fun(C,$o)))),aTP_Lamp_asc(fun(B,fun(B,B)),fun(B,fun(set(C),fun(fun(C,B),fun(fun(C,B),fun(C,$o))))),Uu),Uua),Uub),Uuc),Uud),Uue)
    <=> ( aa(set(C),$o,member(C,Uue),Uub)
        & ( aa(B,B,aa(B,fun(B,B),Uu,aa(C,B,Uuc,Uue)),aa(C,B,Uud,Uue)) != Uua ) ) ) ).

% ATP.lambda_1299
tff(fact_7465_ATP_Olambda__1300,axiom,
    ! [Uu: fun(b,c),Uua: c,Uub: b,Uuc: list(b),Uud: list(b),Uue: list(b)] :
      ( aa(list(b),product_prod(list(b),product_prod(list(b),list(b))),aa(list(b),fun(list(b),product_prod(list(b),product_prod(list(b),list(b)))),aa(list(b),fun(list(b),fun(list(b),product_prod(list(b),product_prod(list(b),list(b))))),aa(b,fun(list(b),fun(list(b),fun(list(b),product_prod(list(b),product_prod(list(b),list(b)))))),aa(c,fun(b,fun(list(b),fun(list(b),fun(list(b),product_prod(list(b),product_prod(list(b),list(b))))))),aTP_Lamp_ako(fun(b,c),fun(c,fun(b,fun(list(b),fun(list(b),fun(list(b),product_prod(list(b),product_prod(list(b),list(b)))))))),Uu),Uua),Uub),Uuc),Uud),Uue)
      = $let(
          x2: c,
          x2 := aa(b,c,Uu,Uub),
          $ite(
            aa(c,$o,aa(c,fun(c,$o),ord_less(c),x2),Uua),
            aa(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b))),aa(list(b),fun(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b)))),product_Pair(list(b),product_prod(list(b),list(b))),aa(list(b),list(b),aa(b,fun(list(b),list(b)),cons(b),Uub),Uuc)),aa(list(b),product_prod(list(b),list(b)),aa(list(b),fun(list(b),product_prod(list(b),list(b))),product_Pair(list(b),list(b)),Uud),Uue)),
            $ite(aa(c,$o,aa(c,fun(c,$o),ord_less(c),Uua),x2),aa(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b))),aa(list(b),fun(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b)))),product_Pair(list(b),product_prod(list(b),list(b))),Uuc),aa(list(b),product_prod(list(b),list(b)),aa(list(b),fun(list(b),product_prod(list(b),list(b))),product_Pair(list(b),list(b)),Uud),aa(list(b),list(b),aa(b,fun(list(b),list(b)),cons(b),Uub),Uue))),aa(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b))),aa(list(b),fun(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b)))),product_Pair(list(b),product_prod(list(b),list(b))),Uuc),aa(list(b),product_prod(list(b),list(b)),aa(list(b),fun(list(b),product_prod(list(b),list(b))),product_Pair(list(b),list(b)),aa(list(b),list(b),aa(b,fun(list(b),list(b)),cons(b),Uub),Uud)),Uue))) ) ) ) ).

% ATP.lambda_1300
tff(fact_7466_ATP_Olambda__1301,axiom,
    ! [C: $tType,B: $tType,Uu: $o,Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_cx($o,fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> (Uu) ) ).

% ATP.lambda_1301
tff(fact_7467_ATP_Olambda__1302,axiom,
    ! [B: $tType,C: $tType,Uu: heap_Time_Heap(C),Uua: B] : ( aa(B,heap_Time_Heap(C),aTP_Lamp_bas(heap_Time_Heap(C),fun(B,heap_Time_Heap(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_1302
tff(fact_7468_ATP_Olambda__1303,axiom,
    ! [B: $tType,Uu: heap_Time_Heap(B),Uua: product_unit] : ( aa(product_unit,heap_Time_Heap(B),aTP_Lamp_axe(heap_Time_Heap(B),fun(product_unit,heap_Time_Heap(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1303
tff(fact_7469_ATP_Olambda__1304,axiom,
    ! [C: $tType,B: $tType] :
      ( heap(C)
     => ! [Uu: heap_Time_Heap(B),Uua: C] : ( aa(C,heap_Time_Heap(B),aTP_Lamp_axd(heap_Time_Heap(B),fun(C,heap_Time_Heap(B)),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1304
tff(fact_7470_ATP_Olambda__1305,axiom,
    ! [B: $tType,C: $tType,Uu: multiset(C),Uua: B] : ( aa(B,multiset(C),aTP_Lamp_ht(multiset(C),fun(B,multiset(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_1305
tff(fact_7471_ATP_Olambda__1306,axiom,
    ! [B: $tType,Uu: assn,Uua: B] : ( aa(B,assn,aTP_Lamp_ae(assn,fun(B,assn),Uu),Uua) = Uu ) ).

% ATP.lambda_1306
tff(fact_7472_ATP_Olambda__1307,axiom,
    ! [B: $tType,C: $tType,Uu: option(C),Uua: B] : ( aa(B,option(C),aTP_Lamp_azt(option(C),fun(B,option(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_1307
tff(fact_7473_ATP_Olambda__1308,axiom,
    ! [B: $tType,Uu: $o,Uua: B] :
      ( aa(B,$o,aTP_Lamp_an($o,fun(B,$o),Uu),Uua)
    <=> (Uu) ) ).

% ATP.lambda_1308
tff(fact_7474_ATP_Olambda__1309,axiom,
    ! [C: $tType,B: $tType,Uu: set(set(old_node(B,C))),Uua: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(set(old_node(B,C))),aTP_Lamp_azg(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),Uu),Uua) = Uu ) ).

% ATP.lambda_1309
tff(fact_7475_ATP_Olambda__1310,axiom,
    ! [D: $tType,E: $tType,Uu: set(E),Uua: D] : ( aa(D,set(E),aTP_Lamp_el(set(E),fun(D,set(E)),Uu),Uua) = Uu ) ).

% ATP.lambda_1310
tff(fact_7476_ATP_Olambda__1311,axiom,
    ! [C: $tType,E: $tType,Uu: set(E),Uua: C] : ( aa(C,set(E),aTP_Lamp_ans(set(E),fun(C,set(E)),Uu),Uua) = Uu ) ).

% ATP.lambda_1311
tff(fact_7477_ATP_Olambda__1312,axiom,
    ! [C: $tType,D: $tType,Uu: set(D),Uua: C] : ( aa(C,set(D),aTP_Lamp_eq(set(D),fun(C,set(D)),Uu),Uua) = Uu ) ).

% ATP.lambda_1312
tff(fact_7478_ATP_Olambda__1313,axiom,
    ! [B: $tType,D: $tType,Uu: set(D),Uua: B] : ( aa(B,set(D),aTP_Lamp_ly(set(D),fun(B,set(D)),Uu),Uua) = Uu ) ).

% ATP.lambda_1313
tff(fact_7479_ATP_Olambda__1314,axiom,
    ! [D: $tType,C: $tType,Uu: set(C),Uua: D] : ( aa(D,set(C),aTP_Lamp_agf(set(C),fun(D,set(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_1314
tff(fact_7480_ATP_Olambda__1315,axiom,
    ! [C: $tType,Uu: set(C),Uua: C] : ( aa(C,set(C),aTP_Lamp_cm(set(C),fun(C,set(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_1315
tff(fact_7481_ATP_Olambda__1316,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: B] : ( aa(B,set(C),aTP_Lamp_bq(set(C),fun(B,set(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_1316
tff(fact_7482_ATP_Olambda__1317,axiom,
    ! [B: $tType,Uu: set(B),Uua: list(B)] : ( aa(list(B),set(B),aTP_Lamp_ais(set(B),fun(list(B),set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1317
tff(fact_7483_ATP_Olambda__1318,axiom,
    ! [D: $tType,B: $tType,Uu: set(B),Uua: D] : ( aa(D,set(B),aTP_Lamp_age(set(B),fun(D,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1318
tff(fact_7484_ATP_Olambda__1319,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: C] : ( aa(C,set(B),aTP_Lamp_bv(set(B),fun(C,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1319
tff(fact_7485_ATP_Olambda__1320,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] : ( aa(B,set(B),aTP_Lamp_cr(set(B),fun(B,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1320
tff(fact_7486_ATP_Olambda__1321,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,$o),Uua: B] : ( aa(B,fun(C,$o),aTP_Lamp_qv(fun(C,$o),fun(B,fun(C,$o)),Uu),Uua) = Uu ) ).

% ATP.lambda_1321
tff(fact_7487_ATP_Olambda__1322,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(C,D),Uua: B] : ( aa(B,fun(C,D),aTP_Lamp_dv(fun(C,D),fun(B,fun(C,D)),Uu),Uua) = Uu ) ).

% ATP.lambda_1322
tff(fact_7488_ATP_Olambda__1323,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,C),Uua: B] : ( aa(B,fun(C,C),aTP_Lamp_kp(fun(C,C),fun(B,fun(C,C)),Uu),Uua) = Uu ) ).

% ATP.lambda_1323
tff(fact_7489_ATP_Olambda__1324,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(B,fun(D,D)),Uua: C] : ( aa(C,fun(B,fun(D,D)),aTP_Lamp_ajn(fun(B,fun(D,D)),fun(C,fun(B,fun(D,D))),Uu),Uua) = Uu ) ).

% ATP.lambda_1324
tff(fact_7490_ATP_Olambda__1325,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: D,Uua: product_prod(B,C)] : ( aa(product_prod(B,C),D,aTP_Lamp_bbg(D,fun(product_prod(B,C),D),Uu),Uua) = Uu ) ).

% ATP.lambda_1325
tff(fact_7491_ATP_Olambda__1326,axiom,
    ! [C: $tType,D: $tType,Uu: D,Uua: C] : ( aa(C,D,aTP_Lamp_awh(D,fun(C,D),Uu),Uua) = Uu ) ).

% ATP.lambda_1326
tff(fact_7492_ATP_Olambda__1327,axiom,
    ! [B: $tType,D: $tType,Uu: D,Uua: B] : ( aa(B,D,aTP_Lamp_awg(D,fun(B,D),Uu),Uua) = Uu ) ).

% ATP.lambda_1327
tff(fact_7493_ATP_Olambda__1328,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Uu: C,Uua: B] : ( aa(B,C,aTP_Lamp_hf(C,fun(B,C),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1328
tff(fact_7494_ATP_Olambda__1329,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [Uu: C,Uua: B] : ( aa(B,C,aTP_Lamp_fh(C,fun(B,C),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1329
tff(fact_7495_ATP_Olambda__1330,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(C)
     => ! [Uu: C,Uua: B] : ( aa(B,C,aTP_Lamp_zu(C,fun(B,C),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1330
tff(fact_7496_ATP_Olambda__1331,axiom,
    ! [D: $tType,C: $tType,Uu: C,Uua: D] : ( aa(D,C,aTP_Lamp_ahd(C,fun(D,C),Uu),Uua) = Uu ) ).

% ATP.lambda_1331
tff(fact_7497_ATP_Olambda__1332,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: B] : ( aa(B,C,aTP_Lamp_bm(C,fun(B,C),Uu),Uua) = Uu ) ).

% ATP.lambda_1332
tff(fact_7498_ATP_Olambda__1333,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: B,Uua: C] : ( aa(C,B,aTP_Lamp_gu(B,fun(C,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1333
tff(fact_7499_ATP_Olambda__1334,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_mh(B,fun(B,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1334
tff(fact_7500_ATP_Olambda__1335,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: B,Uua: C] : ( aa(C,B,aTP_Lamp_ru(B,fun(C,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1335
tff(fact_7501_ATP_Olambda__1336,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B,Uua: list(B)] : ( aa(list(B),B,aa(B,fun(list(B),B),aTP_Lamp_amm(B,fun(list(B),B)),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1336
tff(fact_7502_ATP_Olambda__1337,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Uu: B,Uua: C] : ( aa(C,B,aTP_Lamp_rv(B,fun(C,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1337
tff(fact_7503_ATP_Olambda__1338,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_avu(B,fun(nat,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1338
tff(fact_7504_ATP_Olambda__1339,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] : ( aa(list(B),B,aa(B,fun(list(B),B),aTP_Lamp_alx(B,fun(list(B),B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1339
tff(fact_7505_ATP_Olambda__1340,axiom,
    ! [B: $tType,Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_anu(B,fun(nat,B),Uu),Uua) = Uu ) ).

% ATP.lambda_1340
tff(fact_7506_ATP_Olambda__1341,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C] : ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_cy(B,fun(C,B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1341
tff(fact_7507_ATP_Olambda__1342,axiom,
    ! [C: $tType,B: $tType,Uu: C,Uua: B] : ( aa(B,B,aa(C,fun(B,B),aTP_Lamp_dw(C,fun(B,B)),Uu),Uua) = Uua ) ).

% ATP.lambda_1342
tff(fact_7508_ATP_Olambda__1343,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] : ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),aTP_Lamp_ami(B,fun(list(B),list(B))),Uu),Uua) = Uua ) ).

% ATP.lambda_1343
tff(fact_7509_ATP_Olambda__1344,axiom,
    ! [Uu: typerep,Uua: nat] : ( aa(nat,nat,aa(typerep,fun(nat,nat),aTP_Lamp_baz(typerep,fun(nat,nat)),Uu),Uua) = zero_zero(nat) ) ).

% ATP.lambda_1344
tff(fact_7510_ATP_Olambda__1345,axiom,
    ! [Uu: typerep,Uua: nat] : ( aa(nat,list(nat),aa(typerep,fun(nat,list(nat)),aTP_Lamp_bay(typerep,fun(nat,list(nat))),Uu),Uua) = nil(nat) ) ).

% ATP.lambda_1345
tff(fact_7511_ATP_Olambda__1346,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] :
      ( aa(list(B),$o,aa(B,fun(list(B),$o),aTP_Lamp_amg(B,fun(list(B),$o)),Uu),Uua)
    <=> $false ) ).

% ATP.lambda_1346
tff(fact_7512_ATP_Olambda__1347,axiom,
    ! [B: $tType,Uu: B,Uua: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_aqt(B,fun(B,$o)),Uu),Uua)
    <=> $false ) ).

% ATP.lambda_1347
tff(fact_7513_ATP_Olambda__1348,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] :
      ( aa(list(B),$o,aa(B,fun(list(B),$o),aTP_Lamp_amh(B,fun(list(B),$o)),Uu),Uua)
    <=> $true ) ).

% ATP.lambda_1348
tff(fact_7514_ATP_Olambda__1349,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_da(B,fun(C,$o)),Uu),Uua)
    <=> $true ) ).

% ATP.lambda_1349
tff(fact_7515_ATP_Olambda__1350,axiom,
    ! [B: $tType,Uu: B,Uua: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_ale(B,fun(B,$o)),Uu),Uua)
    <=> $true ) ).

% ATP.lambda_1350
tff(fact_7516_ATP_Olambda__1351,axiom,
    ! [Uu: product_prod(nat,nat)] : ( aa(product_prod(nat,nat),product_prod(nat,nat),aTP_Lamp_aow(product_prod(nat,nat),product_prod(nat,nat)),Uu) = Uu ) ).

% ATP.lambda_1351
tff(fact_7517_ATP_Olambda__1352,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_vw(nat,nat),Uu) = Uu ) ).

% ATP.lambda_1352
tff(fact_7518_ATP_Olambda__1353,axiom,
    ! [Uu: int] : ( aa(int,int,aTP_Lamp_rw(int,int),Uu) = Uu ) ).

% ATP.lambda_1353
tff(fact_7519_ATP_Olambda__1354,axiom,
    ! [B: $tType,Uu: fun(B,nat)] : ( aa(fun(B,nat),fun(B,nat),aTP_Lamp_aqi(fun(B,nat),fun(B,nat)),Uu) = Uu ) ).

% ATP.lambda_1354
tff(fact_7520_ATP_Olambda__1355,axiom,
    ! [C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: C] : ( aa(C,C,aTP_Lamp_pi(C,C),Uu) = Uu ) ) ).

% ATP.lambda_1355
tff(fact_7521_ATP_Olambda__1356,axiom,
    ! [C: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: C] : ( aa(C,C,aTP_Lamp_pj(C,C),Uu) = Uu ) ) ).

% ATP.lambda_1356
tff(fact_7522_ATP_Olambda__1357,axiom,
    ! [C: $tType,Uu: C] : ( aa(C,C,aTP_Lamp_hd(C,C),Uu) = Uu ) ).

% ATP.lambda_1357
tff(fact_7523_ATP_Olambda__1358,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_akd(B,B),Uu) = Uu ) ) ).

% ATP.lambda_1358
tff(fact_7524_ATP_Olambda__1359,axiom,
    ! [B: $tType] :
      ( complete_Sup(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_ff(B,B),Uu) = Uu ) ) ).

% ATP.lambda_1359
tff(fact_7525_ATP_Olambda__1360,axiom,
    ! [B: $tType] :
      ( complete_Inf(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_hv(B,B),Uu) = Uu ) ) ).

% ATP.lambda_1360
tff(fact_7526_ATP_Olambda__1361,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_eh(B,B),Uu) = Uu ) ) ).

% ATP.lambda_1361
tff(fact_7527_ATP_Olambda__1362,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_af(B,B),Uu) = Uu ) ) ).

% ATP.lambda_1362
tff(fact_7528_ATP_Olambda__1363,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_aun(B,B),Uu) = Uu ) ) ).

% ATP.lambda_1363
tff(fact_7529_ATP_Olambda__1364,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,B,aTP_Lamp_bk(B,B),Uu) = Uu ) ).

% ATP.lambda_1364
tff(fact_7530_ATP_Olambda__1365,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: C] : ( aa(C,B,aTP_Lamp_hx(C,B),Uu) = top_top(B) ) ) ).

% ATP.lambda_1365
tff(fact_7531_ATP_Olambda__1366,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,set($o),aTP_Lamp_agm(B,set($o)),Uu) = top_top(set($o)) ) ).

% ATP.lambda_1366
tff(fact_7532_ATP_Olambda__1367,axiom,
    ! [B: $tType,C: $tType,Uu: B] : ( aa(B,set(C),aTP_Lamp_bp(B,set(C)),Uu) = top_top(set(C)) ) ).

% ATP.lambda_1367
tff(fact_7533_ATP_Olambda__1368,axiom,
    ! [D: $tType,C: $tType,Uu: D] : ( aa(D,set(C),aTP_Lamp_hi(D,set(C)),Uu) = bot_bot(set(C)) ) ).

% ATP.lambda_1368
tff(fact_7534_ATP_Olambda__1369,axiom,
    ! [C: $tType,B: $tType,Uu: C] : ( aa(C,set(B),aTP_Lamp_gj(C,set(B)),Uu) = bot_bot(set(B)) ) ).

% ATP.lambda_1369
tff(fact_7535_ATP_Olambda__1370,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: C] : ( aa(C,B,aTP_Lamp_fg(C,B),Uu) = bot_bot(B) ) ) ).

% ATP.lambda_1370
tff(fact_7536_ATP_Olambda__1371,axiom,
    ! [B: $tType,E: $tType,Uu: B] : ( aa(B,set(E),aTP_Lamp_hj(B,set(E)),Uu) = bot_bot(set(E)) ) ).

% ATP.lambda_1371
tff(fact_7537_ATP_Olambda__1372,axiom,
    ! [B: $tType,C: $tType,Uu: B] : ( aa(B,set(C),aTP_Lamp_bs(B,set(C)),Uu) = bot_bot(set(C)) ) ).

% ATP.lambda_1372
tff(fact_7538_ATP_Olambda__1373,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: C] : ( aa(C,B,aTP_Lamp_ny(C,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_1373
tff(fact_7539_ATP_Olambda__1374,axiom,
    ! [C: $tType,B: $tType] :
      ( monoid_add(B)
     => ! [Uu: C] : ( aa(C,B,aTP_Lamp_ajs(C,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_1374
tff(fact_7540_ATP_Olambda__1375,axiom,
    ! [B: $tType] :
      ( mult_zero(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_bo(B,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_1375
tff(fact_7541_ATP_Olambda__1376,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,nat,aTP_Lamp_apn(B,nat),Uu) = zero_zero(nat) ) ).

% ATP.lambda_1376
tff(fact_7542_ATP_Olambda__1377,axiom,
    ! [B: $tType,C: $tType] :
      ( zero(C)
     => ! [Uu: B] : ( aa(B,C,aTP_Lamp_bz(B,C),Uu) = zero_zero(C) ) ) ).

% ATP.lambda_1377
tff(fact_7543_ATP_Olambda__1378,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: C] : ( aa(C,B,aTP_Lamp_nz(C,B),Uu) = one_one(B) ) ) ).

% ATP.lambda_1378
tff(fact_7544_ATP_Olambda__1379,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,nat,aTP_Lamp_rk(B,nat),Uu) = one_one(nat) ) ).

% ATP.lambda_1379
tff(fact_7545_ATP_Olambda__1380,axiom,
    ! [C: $tType,Uu: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_bap(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),Uu) = none(product_prod(C,product_prod(heap_ext(product_unit),nat))) ) ).

% ATP.lambda_1380
tff(fact_7546_ATP_Olambda__1381,axiom,
    ! [B: $tType,Uu: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_awx(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),Uu) = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) ) ).

% ATP.lambda_1381
tff(fact_7547_ATP_Olambda__1382,axiom,
    ! [D: $tType,C: $tType,Uu: D] : ( aa(D,option(C),aTP_Lamp_ada(D,option(C)),Uu) = none(C) ) ).

% ATP.lambda_1382
tff(fact_7548_ATP_Olambda__1383,axiom,
    ! [C: $tType,B: $tType,Uu: C] : ( aa(C,option(B),aTP_Lamp_acp(C,option(B)),Uu) = none(B) ) ).

% ATP.lambda_1383
tff(fact_7549_ATP_Olambda__1384,axiom,
    ! [B: $tType,D: $tType,Uu: B] : ( aa(B,option(D),aTP_Lamp_abt(B,option(D)),Uu) = none(D) ) ).

% ATP.lambda_1384
tff(fact_7550_ATP_Olambda__1385,axiom,
    ! [B: $tType,C: $tType,Uu: B] : ( aa(B,option(C),aTP_Lamp_abb(B,option(C)),Uu) = none(C) ) ).

% ATP.lambda_1385
tff(fact_7551_ATP_Olambda__1386,axiom,
    ! [C: $tType,B: $tType,Uu: C] : ( aa(C,B,aTP_Lamp_awl(C,B),Uu) = undefined(B) ) ).

% ATP.lambda_1386
tff(fact_7552_ATP_Olambda__1387,axiom,
    ! [B: $tType,C: $tType,Uu: B] : ( aa(B,C,aTP_Lamp_ahe(B,C),Uu) = undefined(C) ) ).

% ATP.lambda_1387
tff(fact_7553_ATP_Olambda__1388,axiom,
    ! [Uu: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aTP_Lamp_ag(product_prod(heap_ext(product_unit),set(nat)),$o),Uu)
    <=> $false ) ).

% ATP.lambda_1388
tff(fact_7554_ATP_Olambda__1389,axiom,
    ! [Uu: nat] :
      ( aa(nat,$o,aTP_Lamp_xo(nat,$o),Uu)
    <=> $false ) ).

% ATP.lambda_1389
tff(fact_7555_ATP_Olambda__1390,axiom,
    ! [C: $tType,Uu: C] :
      ( aa(C,$o,aTP_Lamp_avf(C,$o),Uu)
    <=> $false ) ).

% ATP.lambda_1390
tff(fact_7556_ATP_Olambda__1391,axiom,
    ! [B: $tType,Uu: B] :
      ( aa(B,$o,aTP_Lamp_ao(B,$o),Uu)
    <=> $false ) ).

% ATP.lambda_1391
tff(fact_7557_ATP_Olambda__1392,axiom,
    ! [Uu: heap_ext(product_unit)] :
      ( aa(heap_ext(product_unit),$o,aTP_Lamp_bbs(heap_ext(product_unit),$o),Uu)
    <=> $true ) ).

% ATP.lambda_1392
tff(fact_7558_ATP_Olambda__1393,axiom,
    ! [Uu: nat] :
      ( aa(nat,$o,aTP_Lamp_zo(nat,$o),Uu)
    <=> $true ) ).

% ATP.lambda_1393
tff(fact_7559_ATP_Olambda__1394,axiom,
    ! [B: $tType,Uu: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aTP_Lamp_aeu(fun(B,$o),$o),Uu)
    <=> $true ) ).

% ATP.lambda_1394
tff(fact_7560_ATP_Olambda__1395,axiom,
    ! [D: $tType,Uu: D] :
      ( aa(D,$o,aTP_Lamp_ahp(D,$o),Uu)
    <=> $true ) ).

% ATP.lambda_1395
tff(fact_7561_ATP_Olambda__1396,axiom,
    ! [C: $tType,Uu: C] :
      ( aa(C,$o,aTP_Lamp_ahl(C,$o),Uu)
    <=> $true ) ).

% ATP.lambda_1396
tff(fact_7562_ATP_Olambda__1397,axiom,
    ! [B: $tType,Uu: B] :
      ( aa(B,$o,aTP_Lamp_nh(B,$o),Uu)
    <=> $true ) ).

% ATP.lambda_1397
tff(fact_7563_ATP_Olambda__1398,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,fun(nat,nat),aTP_Lamp_st(B,fun(nat,nat)),Uu) = suc ) ).

% ATP.lambda_1398

% Type constructors (712)
tff(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => condit1219197933456340205attice(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( comple592849572758109894attice(A19)
     => comple592849572758109894attice(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__boolean__algebra,axiom,
    ! [A18: $tType,A19: $tType] :
      ( comple489889107523837845lgebra(A19)
     => comple489889107523837845lgebra(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bounded_lattice(A19)
     => bounde4967611905675639751up_bot(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bounded_lattice(A19)
     => bounde4346867609351753570nf_top(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => comple6319245703460814977attice(fun(A18,A19)) ) ).

tff(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A18: $tType,A19: $tType] :
      ( boolea8198339166811842893lgebra(A19)
     => boolea8198339166811842893lgebra(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice__top,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bounded_lattice(A19)
     => bounded_lattice_top(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice__bot,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bounded_lattice(A19)
     => bounded_lattice_bot(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Partial__Order_Occpo,axiom,
    ! [A18: $tType,A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => comple9053668089753744459l_ccpo(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A18: $tType,A19: $tType] :
      ( semilattice_sup(A19)
     => semilattice_sup(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A18: $tType,A19: $tType] :
      ( semilattice_inf(A19)
     => semilattice_inf(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( distrib_lattice(A19)
     => distrib_lattice(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bounded_lattice(A19)
     => bounded_lattice(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Lattices_OSup,axiom,
    ! [A18: $tType,A19: $tType] :
      ( complete_Sup(A19)
     => complete_Sup(fun(A18,A19)) ) ).

tff(tcon_fun___Complete__Lattices_OInf,axiom,
    ! [A18: $tType,A19: $tType] :
      ( complete_Inf(A19)
     => complete_Inf(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A18: $tType,A19: $tType] :
      ( order_top(A19)
     => order_top(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A18: $tType,A19: $tType] :
      ( order_bot(A19)
     => order_bot(fun(A18,A19)) ) ).

tff(tcon_fun___Countable_Ocountable,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( finite_finite(A18)
        & countable(A19) )
     => countable(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Opreorder,axiom,
    ! [A18: $tType,A19: $tType] :
      ( preorder(A19)
     => preorder(fun(A18,A19)) ) ).

tff(tcon_fun___Finite__Set_Ofinite,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( finite_finite(A18)
        & finite_finite(A19) )
     => finite_finite(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Olattice,axiom,
    ! [A18: $tType,A19: $tType] :
      ( lattice(A19)
     => lattice(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Oorder,axiom,
    ! [A18: $tType,A19: $tType] :
      ( order(A19)
     => order(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Otop,axiom,
    ! [A18: $tType,A19: $tType] :
      ( top(A19)
     => top(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Oord,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ord(A19)
     => ord(fun(A18,A19)) ) ).

tff(tcon_fun___Orderings_Obot,axiom,
    ! [A18: $tType,A19: $tType] :
      ( bot(A19)
     => bot(fun(A18,A19)) ) ).

tff(tcon_fun___Groups_Ouminus,axiom,
    ! [A18: $tType,A19: $tType] :
      ( uminus(A19)
     => uminus(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Osup,axiom,
    ! [A18: $tType,A19: $tType] :
      ( semilattice_sup(A19)
     => sup(fun(A18,A19)) ) ).

tff(tcon_fun___Lattices_Oinf,axiom,
    ! [A18: $tType,A19: $tType] :
      ( semilattice_inf(A19)
     => inf(fun(A18,A19)) ) ).

tff(tcon_fun___Groups_Ominus,axiom,
    ! [A18: $tType,A19: $tType] :
      ( minus(A19)
     => minus(fun(A18,A19)) ) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder(int) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_1,axiom,
    condit1219197933456340205attice(int) ).

tff(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations(int) ).

tff(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel(int) ).

tff(tcon_Int_Oint___Rings_Onormalization__semidom__multiplicative,axiom,
    normal6328177297339901930cative(int) ).

tff(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add(int) ).

tff(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide__unit__factor,axiom,
    semido2269285787275462019factor(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize(int) ).

tff(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add(int) ).

tff(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits(int) ).

tff(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring(int) ).

tff(tcon_Int_Oint___Rings_Onormalization__semidom,axiom,
    normal8620421768224518004emidom(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__sup_2,axiom,
    semilattice_sup(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__inf_3,axiom,
    semilattice_inf(int) ).

tff(tcon_Int_Oint___Lattices_Odistrib__lattice_4,axiom,
    distrib_lattice(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult(int) ).

tff(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs(int) ).

tff(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult(int) ).

tff(tcon_Int_Oint___Complete__Lattices_OSup_5,axiom,
    complete_Sup(int) ).

tff(tcon_Int_Oint___Complete__Lattices_OInf_6,axiom,
    complete_Inf(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide(int) ).

tff(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring(int) ).

tff(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0(int) ).

tff(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add(int) ).

tff(tcon_Int_Oint___Countable_Ocountable_7,axiom,
    countable(int) ).

tff(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn(int) ).

tff(tcon_Int_Oint___Orderings_Opreorder_8,axiom,
    preorder(int) ).

tff(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult(int) ).

tff(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0(int) ).

tff(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top(int) ).

tff(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot(int) ).

tff(tcon_Int_Oint___Lattices_Olattice_9,axiom,
    lattice(int) ).

tff(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd(int) ).

tff(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring(int) ).

tff(tcon_Int_Oint___Orderings_Oorder_10,axiom,
    order(int) ).

tff(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral(int) ).

tff(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0(int) ).

tff(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring(int) ).

tff(tcon_Int_Oint___Orderings_Oord_11,axiom,
    ord(int) ).

tff(tcon_Int_Oint___Groups_Ouminus_12,axiom,
    uminus(int) ).

tff(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1(int) ).

tff(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if(int) ).

tff(tcon_Int_Oint___Lattices_Osup_13,axiom,
    sup(int) ).

tff(tcon_Int_Oint___Lattices_Oinf_14,axiom,
    inf(int) ).

tff(tcon_Int_Oint___Groups_Otimes,axiom,
    times(int) ).

tff(tcon_Int_Oint___Groups_Ominus_15,axiom,
    minus(int) ).

tff(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd(int) ).

tff(tcon_Int_Oint___Power_Opower,axiom,
    power(int) ).

tff(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral(int) ).

tff(tcon_Int_Oint___Groups_Ozero,axiom,
    zero(int) ).

tff(tcon_Int_Oint___Rings_Oring,axiom,
    ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom,axiom,
    idom(int) ).

tff(tcon_Int_Oint___Groups_Oone,axiom,
    one(int) ).

tff(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd(int) ).

tff(tcon_Int_Oint___Heap_Oheap,axiom,
    heap(int) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_16,axiom,
    condit6923001295902523014norder(nat) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_17,axiom,
    condit1219197933456340205attice(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_18,axiom,
    bit_un5681908812861735899ations(nat) ).

tff(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_19,axiom,
    semiri1453513574482234551roduct(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_20,axiom,
    euclid5411537665997757685th_nat(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_21,axiom,
    ordere1937475149494474687imp_le(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_22,axiom,
    euclid3128863361964157862miring(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_23,axiom,
    euclid4440199948858584721cancel(nat) ).

tff(tcon_Nat_Onat___Rings_Onormalization__semidom__multiplicative_24,axiom,
    normal6328177297339901930cative(nat) ).

tff(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_25,axiom,
    unique1627219031080169319umeral(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_26,axiom,
    semiri6575147826004484403cancel(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_27,axiom,
    strict9044650504122735259up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_28,axiom,
    ordere580206878836729694up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_29,axiom,
    ordere2412721322843649153imp_le(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_30,axiom,
    bit_se359711467146920520ations(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_31,axiom,
    linord2810124833399127020strict(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_32,axiom,
    strict7427464778891057005id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_33,axiom,
    ordere8940638589300402666id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_34,axiom,
    euclid3725896446679973847miring(nat) ).

tff(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_35,axiom,
    linord4140545234300271783up_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_36,axiom,
    linord181362715937106298miring(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide__unit__factor_37,axiom,
    semido2269285787275462019factor(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_38,axiom,
    linord8928482502909563296strict(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_39,axiom,
    semiri3467727345109120633visors(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_40,axiom,
    ordere6658533253407199908up_add(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_41,axiom,
    semiri6843258321239162965malize(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_42,axiom,
    ordere6911136660526730532id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_43,axiom,
    cancel2418104881723323429up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_44,axiom,
    cancel1802427076303600483id_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_45,axiom,
    comm_s4317794764714335236cancel(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_46,axiom,
    bit_semiring_bits(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__comm__semiring_47,axiom,
    ordere2520102378445227354miring(nat) ).

tff(tcon_Nat_Onat___Rings_Onormalization__semidom_48,axiom,
    normal8620421768224518004emidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_49,axiom,
    cancel_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring_50,axiom,
    linordered_semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring__0_51,axiom,
    ordered_semiring_0(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semidom_52,axiom,
    linordered_semidom(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__sup_53,axiom,
    semilattice_sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__inf_54,axiom,
    semilattice_inf(nat) ).

tff(tcon_Nat_Onat___Lattices_Odistrib__lattice_55,axiom,
    distrib_lattice(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__mult_56,axiom,
    ab_semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Oalgebraic__semidom_57,axiom,
    algebraic_semidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_58,axiom,
    comm_monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__add_59,axiom,
    ab_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring_60,axiom,
    ordered_semiring(nat) ).

tff(tcon_Nat_Onat___Parity_Osemiring__parity_61,axiom,
    semiring_parity(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__add_62,axiom,
    comm_monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__modulo_63,axiom,
    semiring_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1_64,axiom,
    comm_semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__0_65,axiom,
    comm_semiring_0(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__mult_66,axiom,
    semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Complete__Lattices_OSup_67,axiom,
    complete_Sup(nat) ).

tff(tcon_Nat_Onat___Complete__Lattices_OInf_68,axiom,
    complete_Inf(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__modulo_69,axiom,
    semidom_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide_70,axiom,
    semidom_divide(nat) ).

tff(tcon_Nat_Onat___Num_Osemiring__numeral_71,axiom,
    semiring_numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__add_72,axiom,
    semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__less__one_73,axiom,
    zero_less_one(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring_74,axiom,
    comm_semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder__bot_75,axiom,
    order_bot(nat) ).

tff(tcon_Nat_Onat___Nat_Osemiring__char__0_76,axiom,
    semiring_char_0(nat) ).

tff(tcon_Nat_Onat___Countable_Ocountable_77,axiom,
    countable(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__neq__one_78,axiom,
    zero_neq_one(nat) ).

tff(tcon_Nat_Onat___Orderings_Opreorder_79,axiom,
    preorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Olinorder_80,axiom,
    linorder(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__mult_81,axiom,
    monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__add_82,axiom,
    monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1_83,axiom,
    semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__0_84,axiom,
    semiring_0(nat) ).

tff(tcon_Nat_Onat___Orderings_Ono__top_85,axiom,
    no_top(nat) ).

tff(tcon_Nat_Onat___Lattices_Olattice_86,axiom,
    lattice(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd_87,axiom,
    semiring_gcd(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__Gcd_88,axiom,
    semiring_Gcd(nat) ).

tff(tcon_Nat_Onat___Rings_Omult__zero_89,axiom,
    mult_zero(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder_90,axiom,
    order(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring_91,axiom,
    semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Oord_92,axiom,
    ord(nat) ).

tff(tcon_Nat_Onat___Orderings_Obot_93,axiom,
    bot(nat) ).

tff(tcon_Nat_Onat___Lattices_Osup_94,axiom,
    sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Oinf_95,axiom,
    inf(nat) ).

tff(tcon_Nat_Onat___Groups_Otimes_96,axiom,
    times(nat) ).

tff(tcon_Nat_Onat___Groups_Ominus_97,axiom,
    minus(nat) ).

tff(tcon_Nat_Onat___Power_Opower_98,axiom,
    power(nat) ).

tff(tcon_Nat_Onat___Num_Onumeral_99,axiom,
    numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Ozero_100,axiom,
    zero(nat) ).

tff(tcon_Nat_Onat___Groups_Oone_101,axiom,
    one(nat) ).

tff(tcon_Nat_Onat___Rings_Odvd_102,axiom,
    dvd(nat) ).

tff(tcon_Nat_Onat___Heap_Oheap_103,axiom,
    heap(nat) ).

tff(tcon_Num_Onum___Orderings_Opreorder_104,axiom,
    preorder(num) ).

tff(tcon_Num_Onum___Orderings_Olinorder_105,axiom,
    linorder(num) ).

tff(tcon_Num_Onum___Orderings_Oorder_106,axiom,
    order(num) ).

tff(tcon_Num_Onum___Orderings_Oord_107,axiom,
    ord(num) ).

tff(tcon_Num_Onum___Groups_Otimes_108,axiom,
    times(num) ).

tff(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_109,axiom,
    semiri1453513574482234551roduct(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_110,axiom,
    ordere1937475149494474687imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_111,axiom,
    semiri6575147826004484403cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_112,axiom,
    strict9044650504122735259up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_113,axiom,
    ordere580206878836729694up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_114,axiom,
    ordere2412721322843649153imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_115,axiom,
    linord2810124833399127020strict(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_116,axiom,
    strict7427464778891057005id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_117,axiom,
    ordere8940638589300402666id_add(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_118,axiom,
    linord715952674999750819strict(rat) ).

tff(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_119,axiom,
    linord4140545234300271783up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_120,axiom,
    linord181362715937106298miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_121,axiom,
    linord8928482502909563296strict(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_122,axiom,
    semiri3467727345109120633visors(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_123,axiom,
    ordere6658533253407199908up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_124,axiom,
    ordere166539214618696060dd_abs(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_125,axiom,
    ordere6911136660526730532id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_126,axiom,
    linord5086331880401160121up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_127,axiom,
    cancel2418104881723323429up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_128,axiom,
    ring_15535105094025558882visors(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_129,axiom,
    cancel1802427076303600483id_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring__strict_130,axiom,
    linord4710134922213307826strict(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_131,axiom,
    comm_s4317794764714335236cancel(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__comm__semiring_132,axiom,
    ordere2520102378445227354miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1_133,axiom,
    linord6961819062388156250ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add_134,axiom,
    ordered_ab_group_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_135,axiom,
    cancel_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring_136,axiom,
    linordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring__0_137,axiom,
    ordered_semiring_0(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semidom_138,axiom,
    linordered_semidom(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__sup_139,axiom,
    semilattice_sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__inf_140,axiom,
    semilattice_inf(rat) ).

tff(tcon_Rat_Orat___Lattices_Odistrib__lattice_141,axiom,
    distrib_lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__mult_142,axiom,
    ab_semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_143,axiom,
    comm_monoid_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__add_144,axiom,
    ab_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring_145,axiom,
    ordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring__abs_146,axiom,
    ordered_ring_abs(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__add_147,axiom,
    comm_monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring_148,axiom,
    linordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__idom_149,axiom,
    linordered_idom(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1_150,axiom,
    comm_semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__0_151,axiom,
    comm_semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__mult_152,axiom,
    semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom__divide_153,axiom,
    semidom_divide(rat) ).

tff(tcon_Rat_Orat___Num_Osemiring__numeral_154,axiom,
    semiring_numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__add_155,axiom,
    semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__less__one_156,axiom,
    zero_less_one(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring_157,axiom,
    comm_semiring(rat) ).

tff(tcon_Rat_Orat___Nat_Osemiring__char__0_158,axiom,
    semiring_char_0(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__group__add_159,axiom,
    ab_group_add(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0(rat) ).

tff(tcon_Rat_Orat___Countable_Ocountable_160,axiom,
    countable(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__neq__one_161,axiom,
    zero_neq_one(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring_162,axiom,
    ordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__abs__sgn_163,axiom,
    idom_abs_sgn(rat) ).

tff(tcon_Rat_Orat___Orderings_Opreorder_164,axiom,
    preorder(rat) ).

tff(tcon_Rat_Orat___Orderings_Olinorder_165,axiom,
    linorder(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__mult_166,axiom,
    monoid_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__divide_167,axiom,
    idom_divide(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring__1_168,axiom,
    comm_ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__add_169,axiom,
    monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1_170,axiom,
    semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__0_171,axiom,
    semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__top_172,axiom,
    no_top(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__bot_173,axiom,
    no_bot(rat) ).

tff(tcon_Rat_Orat___Lattices_Olattice_174,axiom,
    lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Ogroup__add_175,axiom,
    group_add(rat) ).

tff(tcon_Rat_Orat___Rings_Omult__zero_176,axiom,
    mult_zero(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring_177,axiom,
    comm_ring(rat) ).

tff(tcon_Rat_Orat___Orderings_Oorder_178,axiom,
    order(rat) ).

tff(tcon_Rat_Orat___Num_Oneg__numeral_179,axiom,
    neg_numeral(rat) ).

tff(tcon_Rat_Orat___Nat_Oring__char__0_180,axiom,
    ring_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring_181,axiom,
    semiring(rat) ).

tff(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse(rat) ).

tff(tcon_Rat_Orat___Orderings_Oord_182,axiom,
    ord(rat) ).

tff(tcon_Rat_Orat___Groups_Ouminus_183,axiom,
    uminus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1_184,axiom,
    ring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Oabs__if_185,axiom,
    abs_if(rat) ).

tff(tcon_Rat_Orat___Lattices_Osup_186,axiom,
    sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Oinf_187,axiom,
    inf(rat) ).

tff(tcon_Rat_Orat___Groups_Otimes_188,axiom,
    times(rat) ).

tff(tcon_Rat_Orat___Groups_Ominus_189,axiom,
    minus(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield,axiom,
    field(rat) ).

tff(tcon_Rat_Orat___Power_Opower_190,axiom,
    power(rat) ).

tff(tcon_Rat_Orat___Num_Onumeral_191,axiom,
    numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Ozero_192,axiom,
    zero(rat) ).

tff(tcon_Rat_Orat___Rings_Oring_193,axiom,
    ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom_194,axiom,
    idom(rat) ).

tff(tcon_Rat_Orat___Groups_Oone_195,axiom,
    one(rat) ).

tff(tcon_Rat_Orat___Rings_Odvd_196,axiom,
    dvd(rat) ).

tff(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_197,axiom,
    ! [A18: $tType] : condit1219197933456340205attice(set(A18)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_198,axiom,
    ! [A18: $tType] : comple592849572758109894attice(set(A18)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__boolean__algebra_199,axiom,
    ! [A18: $tType] : comple489889107523837845lgebra(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_200,axiom,
    ! [A18: $tType] : bounde4967611905675639751up_bot(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_201,axiom,
    ! [A18: $tType] : bounde4346867609351753570nf_top(set(A18)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_202,axiom,
    ! [A18: $tType] : comple6319245703460814977attice(set(A18)) ).

tff(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_203,axiom,
    ! [A18: $tType] : boolea8198339166811842893lgebra(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice__top_204,axiom,
    ! [A18: $tType] : bounded_lattice_top(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice__bot_205,axiom,
    ! [A18: $tType] : bounded_lattice_bot(set(A18)) ).

tff(tcon_Set_Oset___Complete__Partial__Order_Occpo_206,axiom,
    ! [A18: $tType] : comple9053668089753744459l_ccpo(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__sup_207,axiom,
    ! [A18: $tType] : semilattice_sup(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__inf_208,axiom,
    ! [A18: $tType] : semilattice_inf(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Odistrib__lattice_209,axiom,
    ! [A18: $tType] : distrib_lattice(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice_210,axiom,
    ! [A18: $tType] : bounded_lattice(set(A18)) ).

tff(tcon_Set_Oset___Complete__Lattices_OSup_211,axiom,
    ! [A18: $tType] : complete_Sup(set(A18)) ).

tff(tcon_Set_Oset___Complete__Lattices_OInf_212,axiom,
    ! [A18: $tType] : complete_Inf(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Oorder__top_213,axiom,
    ! [A18: $tType] : order_top(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Oorder__bot_214,axiom,
    ! [A18: $tType] : order_bot(set(A18)) ).

tff(tcon_Set_Oset___Countable_Ocountable_215,axiom,
    ! [A18: $tType] :
      ( finite_finite(A18)
     => countable(set(A18)) ) ).

tff(tcon_Set_Oset___Orderings_Opreorder_216,axiom,
    ! [A18: $tType] : preorder(set(A18)) ).

tff(tcon_Set_Oset___Finite__Set_Ofinite_217,axiom,
    ! [A18: $tType] :
      ( finite_finite(A18)
     => finite_finite(set(A18)) ) ).

tff(tcon_Set_Oset___Lattices_Olattice_218,axiom,
    ! [A18: $tType] : lattice(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Oorder_219,axiom,
    ! [A18: $tType] : order(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Otop_220,axiom,
    ! [A18: $tType] : top(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Oord_221,axiom,
    ! [A18: $tType] : ord(set(A18)) ).

tff(tcon_Set_Oset___Orderings_Obot_222,axiom,
    ! [A18: $tType] : bot(set(A18)) ).

tff(tcon_Set_Oset___Groups_Ouminus_223,axiom,
    ! [A18: $tType] : uminus(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Osup_224,axiom,
    ! [A18: $tType] : sup(set(A18)) ).

tff(tcon_Set_Oset___Lattices_Oinf_225,axiom,
    ! [A18: $tType] : inf(set(A18)) ).

tff(tcon_Set_Oset___Groups_Ominus_226,axiom,
    ! [A18: $tType] : minus(set(A18)) ).

tff(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_227,axiom,
    condit1219197933456340205attice($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_228,axiom,
    comple592849572758109894attice($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__boolean__algebra_229,axiom,
    comple489889107523837845lgebra($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_230,axiom,
    bounde4967611905675639751up_bot($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_231,axiom,
    bounde4346867609351753570nf_top($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_232,axiom,
    comple6319245703460814977attice($o) ).

tff(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_233,axiom,
    boolea8198339166811842893lgebra($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice__top_234,axiom,
    bounded_lattice_top($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_235,axiom,
    bounded_lattice_bot($o) ).

tff(tcon_HOL_Obool___Complete__Partial__Order_Occpo_236,axiom,
    comple9053668089753744459l_ccpo($o) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__sup_237,axiom,
    semilattice_sup($o) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__inf_238,axiom,
    semilattice_inf($o) ).

tff(tcon_HOL_Obool___Lattices_Odistrib__lattice_239,axiom,
    distrib_lattice($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice_240,axiom,
    bounded_lattice($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_OSup_241,axiom,
    complete_Sup($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_OInf_242,axiom,
    complete_Inf($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder__top_243,axiom,
    order_top($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder__bot_244,axiom,
    order_bot($o) ).

tff(tcon_HOL_Obool___Countable_Ocountable_245,axiom,
    countable($o) ).

tff(tcon_HOL_Obool___Orderings_Opreorder_246,axiom,
    preorder($o) ).

tff(tcon_HOL_Obool___Orderings_Olinorder_247,axiom,
    linorder($o) ).

tff(tcon_HOL_Obool___Finite__Set_Ofinite_248,axiom,
    finite_finite($o) ).

tff(tcon_HOL_Obool___Lattices_Olattice_249,axiom,
    lattice($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder_250,axiom,
    order($o) ).

tff(tcon_HOL_Obool___Orderings_Otop_251,axiom,
    top($o) ).

tff(tcon_HOL_Obool___Orderings_Oord_252,axiom,
    ord($o) ).

tff(tcon_HOL_Obool___Orderings_Obot_253,axiom,
    bot($o) ).

tff(tcon_HOL_Obool___Groups_Ouminus_254,axiom,
    uminus($o) ).

tff(tcon_HOL_Obool___Lattices_Osup_255,axiom,
    sup($o) ).

tff(tcon_HOL_Obool___Lattices_Oinf_256,axiom,
    inf($o) ).

tff(tcon_HOL_Obool___Groups_Ominus_257,axiom,
    minus($o) ).

tff(tcon_HOL_Obool___Heap_Oheap_258,axiom,
    heap($o) ).

tff(tcon_Heap_Oref___Countable_Ocountable_259,axiom,
    ! [A18: $tType] : countable(ref(A18)) ).

tff(tcon_Heap_Oref___Heap_Oheap_260,axiom,
    ! [A18: $tType] : heap(ref(A18)) ).

tff(tcon_List_Olist___Countable_Ocountable_261,axiom,
    ! [A18: $tType] :
      ( countable(A18)
     => countable(list(A18)) ) ).

tff(tcon_List_Olist___Heap_Oheap_262,axiom,
    ! [A18: $tType] :
      ( heap(A18)
     => heap(list(A18)) ) ).

tff(tcon_Heap_Oarray___Countable_Ocountable_263,axiom,
    ! [A18: $tType] : countable(array(A18)) ).

tff(tcon_Heap_Oarray___Heap_Oheap_264,axiom,
    ! [A18: $tType] : heap(array(A18)) ).

tff(tcon_Sum__Type_Osum___Countable_Ocountable_265,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( countable(A18)
        & countable(A19) )
     => countable(sum_sum(A18,A19)) ) ).

tff(tcon_Sum__Type_Osum___Finite__Set_Ofinite_266,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( finite_finite(A18)
        & finite_finite(A19) )
     => finite_finite(sum_sum(A18,A19)) ) ).

tff(tcon_Sum__Type_Osum___Heap_Oheap_267,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( heap(A18)
        & heap(A19) )
     => heap(sum_sum(A18,A19)) ) ).

tff(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_268,axiom,
    ! [A18: $tType] : condit1219197933456340205attice(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_269,axiom,
    ! [A18: $tType] : bounde4967611905675639751up_bot(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_270,axiom,
    ! [A18: $tType] : bounde4346867609351753570nf_top(filter(A18)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_271,axiom,
    ! [A18: $tType] : comple6319245703460814977attice(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice__top_272,axiom,
    ! [A18: $tType] : bounded_lattice_top(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice__bot_273,axiom,
    ! [A18: $tType] : bounded_lattice_bot(filter(A18)) ).

tff(tcon_Filter_Ofilter___Complete__Partial__Order_Occpo_274,axiom,
    ! [A18: $tType] : comple9053668089753744459l_ccpo(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_275,axiom,
    ! [A18: $tType] : semilattice_sup(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_276,axiom,
    ! [A18: $tType] : semilattice_inf(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Odistrib__lattice_277,axiom,
    ! [A18: $tType] : distrib_lattice(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice_278,axiom,
    ! [A18: $tType] : bounded_lattice(filter(A18)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_OSup_279,axiom,
    ! [A18: $tType] : complete_Sup(filter(A18)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_OInf_280,axiom,
    ! [A18: $tType] : complete_Inf(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__top_281,axiom,
    ! [A18: $tType] : order_top(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__bot_282,axiom,
    ! [A18: $tType] : order_bot(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Opreorder_283,axiom,
    ! [A18: $tType] : preorder(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Olattice_284,axiom,
    ! [A18: $tType] : lattice(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder_285,axiom,
    ! [A18: $tType] : order(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Otop_286,axiom,
    ! [A18: $tType] : top(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Oord_287,axiom,
    ! [A18: $tType] : ord(filter(A18)) ).

tff(tcon_Filter_Ofilter___Orderings_Obot_288,axiom,
    ! [A18: $tType] : bot(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Osup_289,axiom,
    ! [A18: $tType] : sup(filter(A18)) ).

tff(tcon_Filter_Ofilter___Lattices_Oinf_290,axiom,
    ! [A18: $tType] : inf(filter(A18)) ).

tff(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_291,axiom,
    ! [A18: $tType] :
      ( comple5582772986160207858norder(A18)
     => condit6923001295902523014norder(option(A18)) ) ).

tff(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_292,axiom,
    ! [A18: $tType] :
      ( comple6319245703460814977attice(A18)
     => condit1219197933456340205attice(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__distrib__lattice_293,axiom,
    ! [A18: $tType] :
      ( comple592849572758109894attice(A18)
     => comple592849572758109894attice(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__semilattice__sup__bot_294,axiom,
    ! [A18: $tType] :
      ( lattice(A18)
     => bounde4967611905675639751up_bot(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__semilattice__inf__top_295,axiom,
    ! [A18: $tType] :
      ( bounded_lattice_top(A18)
     => bounde4346867609351753570nf_top(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__linorder,axiom,
    ! [A18: $tType] :
      ( comple5582772986160207858norder(A18)
     => comple5582772986160207858norder(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__lattice_296,axiom,
    ! [A18: $tType] :
      ( comple6319245703460814977attice(A18)
     => comple6319245703460814977attice(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice__top_297,axiom,
    ! [A18: $tType] :
      ( bounded_lattice_top(A18)
     => bounded_lattice_top(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice__bot_298,axiom,
    ! [A18: $tType] :
      ( lattice(A18)
     => bounded_lattice_bot(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Partial__Order_Occpo_299,axiom,
    ! [A18: $tType] :
      ( comple6319245703460814977attice(A18)
     => comple9053668089753744459l_ccpo(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Osemilattice__sup_300,axiom,
    ! [A18: $tType] :
      ( semilattice_sup(A18)
     => semilattice_sup(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Osemilattice__inf_301,axiom,
    ! [A18: $tType] :
      ( semilattice_inf(A18)
     => semilattice_inf(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Odistrib__lattice_302,axiom,
    ! [A18: $tType] :
      ( distrib_lattice(A18)
     => distrib_lattice(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice_303,axiom,
    ! [A18: $tType] :
      ( bounded_lattice_top(A18)
     => bounded_lattice(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_OSup_304,axiom,
    ! [A18: $tType] :
      ( comple6319245703460814977attice(A18)
     => complete_Sup(option(A18)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_OInf_305,axiom,
    ! [A18: $tType] :
      ( comple6319245703460814977attice(A18)
     => complete_Inf(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Owellorder_306,axiom,
    ! [A18: $tType] :
      ( wellorder(A18)
     => wellorder(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder__top_307,axiom,
    ! [A18: $tType] :
      ( order_top(A18)
     => order_top(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder__bot_308,axiom,
    ! [A18: $tType] :
      ( order(A18)
     => order_bot(option(A18)) ) ).

tff(tcon_Option_Ooption___Countable_Ocountable_309,axiom,
    ! [A18: $tType] :
      ( countable(A18)
     => countable(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Opreorder_310,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => preorder(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Olinorder_311,axiom,
    ! [A18: $tType] :
      ( linorder(A18)
     => linorder(option(A18)) ) ).

tff(tcon_Option_Ooption___Finite__Set_Ofinite_312,axiom,
    ! [A18: $tType] :
      ( finite_finite(A18)
     => finite_finite(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Olattice_313,axiom,
    ! [A18: $tType] :
      ( lattice(A18)
     => lattice(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder_314,axiom,
    ! [A18: $tType] :
      ( order(A18)
     => order(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Otop_315,axiom,
    ! [A18: $tType] :
      ( order_top(A18)
     => top(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Oord_316,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => ord(option(A18)) ) ).

tff(tcon_Option_Ooption___Orderings_Obot_317,axiom,
    ! [A18: $tType] :
      ( order(A18)
     => bot(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Osup_318,axiom,
    ! [A18: $tType] :
      ( sup(A18)
     => sup(option(A18)) ) ).

tff(tcon_Option_Ooption___Lattices_Oinf_319,axiom,
    ! [A18: $tType] :
      ( inf(A18)
     => inf(option(A18)) ) ).

tff(tcon_Option_Ooption___Heap_Oheap_320,axiom,
    ! [A18: $tType] :
      ( heap(A18)
     => heap(option(A18)) ) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__sup__bot_321,axiom,
    bounde4967611905675639751up_bot(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__inf__top_322,axiom,
    bounde4346867609351753570nf_top(assn) ).

tff(tcon_Assertions_Oassn___Boolean__Algebras_Oboolean__algebra_323,axiom,
    boolea8198339166811842893lgebra(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice__top_324,axiom,
    bounded_lattice_top(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice__bot_325,axiom,
    bounded_lattice_bot(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osemilattice__sup_326,axiom,
    semilattice_sup(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osemilattice__inf_327,axiom,
    semilattice_inf(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Odistrib__lattice_328,axiom,
    distrib_lattice(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice_329,axiom,
    bounded_lattice(assn) ).

tff(tcon_Assertions_Oassn___Groups_Oab__semigroup__mult_330,axiom,
    ab_semigroup_mult(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ocomm__monoid__mult_331,axiom,
    comm_monoid_mult(assn) ).

tff(tcon_Assertions_Oassn___Groups_Osemigroup__mult_332,axiom,
    semigroup_mult(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder__top_333,axiom,
    order_top(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder__bot_334,axiom,
    order_bot(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Opreorder_335,axiom,
    preorder(assn) ).

tff(tcon_Assertions_Oassn___Groups_Omonoid__mult_336,axiom,
    monoid_mult(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Olattice_337,axiom,
    lattice(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder_338,axiom,
    order(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Otop_339,axiom,
    top(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oord_340,axiom,
    ord(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Obot_341,axiom,
    bot(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ouminus_342,axiom,
    uminus(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osup_343,axiom,
    sup(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Oinf_344,axiom,
    inf(assn) ).

tff(tcon_Assertions_Oassn___Groups_Otimes_345,axiom,
    times(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ominus_346,axiom,
    minus(assn) ).

tff(tcon_Assertions_Oassn___Power_Opower_347,axiom,
    power(assn) ).

tff(tcon_Assertions_Oassn___Groups_Oone_348,axiom,
    one(assn) ).

tff(tcon_Assertions_Oassn___Rings_Odvd_349,axiom,
    dvd(assn) ).

tff(tcon_Typerep_Otyperep___Countable_Ocountable_350,axiom,
    countable(typerep) ).

tff(tcon_Typerep_Otyperep___Heap_Oheap_351,axiom,
    heap(typerep) ).

tff(tcon_Multiset_Omultiset___Groups_Oordered__ab__semigroup__add_352,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => ordere6658533253407199908up_add(multiset(A18)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__ab__semigroup__add_353,axiom,
    ! [A18: $tType] : cancel2418104881723323429up_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__comm__monoid__add_354,axiom,
    ! [A18: $tType] : cancel1802427076303600483id_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__semigroup__add_355,axiom,
    ! [A18: $tType] : cancel_semigroup_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__diff_356,axiom,
    ! [A18: $tType] : comm_monoid_diff(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Oab__semigroup__add_357,axiom,
    ! [A18: $tType] : ab_semigroup_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__add_358,axiom,
    ! [A18: $tType] : comm_monoid_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Complete__Lattices_OSup_359,axiom,
    ! [A18: $tType] : complete_Sup(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Complete__Lattices_OInf_360,axiom,
    ! [A18: $tType] : complete_Inf(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Osemigroup__add_361,axiom,
    ! [A18: $tType] : semigroup_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Orderings_Opreorder_362,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => preorder(multiset(A18)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Omonoid__add_363,axiom,
    ! [A18: $tType] : monoid_add(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Orderings_Oorder_364,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => order(multiset(A18)) ) ).

tff(tcon_Multiset_Omultiset___Orderings_Oord_365,axiom,
    ! [A18: $tType] :
      ( preorder(A18)
     => ord(multiset(A18)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Ominus_366,axiom,
    ! [A18: $tType] : minus(multiset(A18)) ).

tff(tcon_Multiset_Omultiset___Groups_Ozero_367,axiom,
    ! [A18: $tType] : zero(multiset(A18)) ).

tff(tcon_Product__Type_Oprod___Countable_Ocountable_368,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( countable(A18)
        & countable(A19) )
     => countable(product_prod(A18,A19)) ) ).

tff(tcon_Product__Type_Oprod___Finite__Set_Ofinite_369,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( finite_finite(A18)
        & finite_finite(A19) )
     => finite_finite(product_prod(A18,A19)) ) ).

tff(tcon_Product__Type_Oprod___Heap_Oheap_370,axiom,
    ! [A18: $tType,A19: $tType] :
      ( ( heap(A18)
        & heap(A19) )
     => heap(product_prod(A18,A19)) ) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_371,axiom,
    condit6923001295902523014norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_372,axiom,
    condit1219197933456340205attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_373,axiom,
    comple592849572758109894attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__boolean__algebra_374,axiom,
    comple489889107523837845lgebra(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_375,axiom,
    bounde4967611905675639751up_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_376,axiom,
    bounde4346867609351753570nf_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_377,axiom,
    comple5582772986160207858norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_378,axiom,
    comple6319245703460814977attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_379,axiom,
    boolea8198339166811842893lgebra(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__top_380,axiom,
    bounded_lattice_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__bot_381,axiom,
    bounded_lattice_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Partial__Order_Occpo_382,axiom,
    comple9053668089753744459l_ccpo(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_383,axiom,
    semilattice_sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_384,axiom,
    semilattice_inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Odistrib__lattice_385,axiom,
    distrib_lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice_386,axiom,
    bounded_lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_OSup_387,axiom,
    complete_Sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_OInf_388,axiom,
    complete_Inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Owellorder_389,axiom,
    wellorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__top_390,axiom,
    order_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__bot_391,axiom,
    order_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Countable_Ocountable_392,axiom,
    countable(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Opreorder_393,axiom,
    preorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Olinorder_394,axiom,
    linorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Finite__Set_Ofinite_395,axiom,
    finite_finite(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Olattice_396,axiom,
    lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder_397,axiom,
    order(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Otop_398,axiom,
    top(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oord_399,axiom,
    ord(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Obot_400,axiom,
    bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ouminus_401,axiom,
    uminus(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osup_402,axiom,
    sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Oinf_403,axiom,
    inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ominus_404,axiom,
    minus(product_unit) ).

tff(tcon_Product__Type_Ounit___Heap_Oheap_405,axiom,
    heap(product_unit) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_406,axiom,
    bit_un5681908812861735899ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_407,axiom,
    semiri1453513574482234551roduct(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_408,axiom,
    euclid5411537665997757685th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_409,axiom,
    euclid8789492081693882211th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_410,axiom,
    ordere1937475149494474687imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_411,axiom,
    euclid3128863361964157862miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_412,axiom,
    euclid4440199948858584721cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_413,axiom,
    unique1627219031080169319umeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_414,axiom,
    euclid8851590272496341667cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_415,axiom,
    semiri6575147826004484403cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_416,axiom,
    strict9044650504122735259up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_417,axiom,
    ordere580206878836729694up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_418,axiom,
    ordere2412721322843649153imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_419,axiom,
    bit_se359711467146920520ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_420,axiom,
    linord2810124833399127020strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_421,axiom,
    strict7427464778891057005id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_422,axiom,
    ordere8940638589300402666id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_423,axiom,
    euclid3725896446679973847miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_424,axiom,
    linord715952674999750819strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_425,axiom,
    linord4140545234300271783up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_426,axiom,
    bit_ri3973907225187159222ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_427,axiom,
    linord181362715937106298miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_428,axiom,
    linord8928482502909563296strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_429,axiom,
    semiri3467727345109120633visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_430,axiom,
    ordere6658533253407199908up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_431,axiom,
    ordere166539214618696060dd_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_432,axiom,
    ordere6911136660526730532id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_433,axiom,
    linord5086331880401160121up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_434,axiom,
    cancel2418104881723323429up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_435,axiom,
    ring_15535105094025558882visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_436,axiom,
    cancel1802427076303600483id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_437,axiom,
    linord4710134922213307826strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_438,axiom,
    comm_s4317794764714335236cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_439,axiom,
    bit_semiring_bits(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_440,axiom,
    ordere2520102378445227354miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_441,axiom,
    linord6961819062388156250ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_442,axiom,
    ordered_ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_443,axiom,
    cancel_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_444,axiom,
    linordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_445,axiom,
    ordered_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_446,axiom,
    linordered_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_447,axiom,
    ab_semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_448,axiom,
    algebraic_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_449,axiom,
    comm_monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_450,axiom,
    ab_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_451,axiom,
    ordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_452,axiom,
    ordered_ring_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_453,axiom,
    semiring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_454,axiom,
    comm_monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_455,axiom,
    semiring_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_456,axiom,
    linordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_457,axiom,
    linordered_idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_458,axiom,
    comm_semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_459,axiom,
    comm_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_460,axiom,
    semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_461,axiom,
    semidom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_462,axiom,
    semidom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_463,axiom,
    semiring_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_464,axiom,
    semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_465,axiom,
    zero_less_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_466,axiom,
    comm_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_467,axiom,
    semiring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_468,axiom,
    ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_469,axiom,
    zero_neq_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_470,axiom,
    ordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_471,axiom,
    idom_abs_sgn(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_472,axiom,
    preorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_473,axiom,
    linorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_474,axiom,
    monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_475,axiom,
    idom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_476,axiom,
    idom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_477,axiom,
    comm_ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_478,axiom,
    monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_479,axiom,
    semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_480,axiom,
    semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_481,axiom,
    group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_482,axiom,
    mult_zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_483,axiom,
    comm_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oorder_484,axiom,
    order(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_485,axiom,
    neg_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_486,axiom,
    ring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring_487,axiom,
    semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oord_488,axiom,
    ord(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ouminus_489,axiom,
    uminus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1_490,axiom,
    ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_491,axiom,
    abs_if(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Otimes_492,axiom,
    times(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ominus_493,axiom,
    minus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Power_Opower_494,axiom,
    power(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Onumeral_495,axiom,
    numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ozero_496,axiom,
    zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring_497,axiom,
    ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom_498,axiom,
    idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oone_499,axiom,
    one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Odvd_500,axiom,
    dvd(code_integer) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_501,axiom,
    bit_un5681908812861735899ations(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring__with__nat_502,axiom,
    euclid5411537665997757685th_nat(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__monoid__add__imp__le_503,axiom,
    ordere1937475149494474687imp_le(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring_504,axiom,
    euclid3128863361964157862miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring__cancel_505,axiom,
    euclid4440199948858584721cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors__cancel_506,axiom,
    semiri6575147826004484403cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__ab__semigroup__add_507,axiom,
    strict9044650504122735259up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__ab__semigroup__add_508,axiom,
    ordere580206878836729694up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add__imp__le_509,axiom,
    ordere2412721322843649153imp_le(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bit__operations_510,axiom,
    bit_se359711467146920520ations(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__comm__semiring__strict_511,axiom,
    linord2810124833399127020strict(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__comm__monoid__add_512,axiom,
    strict7427464778891057005id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__comm__monoid__add_513,axiom,
    ordere8940638589300402666id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring_514,axiom,
    euclid3725896446679973847miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Olinordered__ab__semigroup__add_515,axiom,
    linord4140545234300271783up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__nonzero__semiring_516,axiom,
    linord181362715937106298miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring__strict_517,axiom,
    linord8928482502909563296strict(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors_518,axiom,
    semiri3467727345109120633visors(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_519,axiom,
    ordere6658533253407199908up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__comm__monoid__add_520,axiom,
    ordere6911136660526730532id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__ab__semigroup__add_521,axiom,
    cancel2418104881723323429up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_522,axiom,
    cancel1802427076303600483id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1__cancel_523,axiom,
    comm_s4317794764714335236cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bits_524,axiom,
    bit_semiring_bits(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__comm__semiring_525,axiom,
    ordere2520102378445227354miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_526,axiom,
    cancel_semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring_527,axiom,
    linordered_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring__0_528,axiom,
    ordered_semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semidom_529,axiom,
    linordered_semidom(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__mult_530,axiom,
    ab_semigroup_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oalgebraic__semidom_531,axiom,
    algebraic_semidom(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__mult_532,axiom,
    comm_monoid_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__diff_533,axiom,
    comm_monoid_diff(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_534,axiom,
    ab_semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring_535,axiom,
    ordered_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Parity_Osemiring__parity_536,axiom,
    semiring_parity(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_537,axiom,
    comm_monoid_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__modulo_538,axiom,
    semiring_modulo(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_539,axiom,
    comm_semiring_1(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__0_540,axiom,
    comm_semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Osemigroup__mult_541,axiom,
    semigroup_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemidom__modulo_542,axiom,
    semidom_modulo(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemidom__divide_543,axiom,
    semidom_divide(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Num_Osemiring__numeral_544,axiom,
    semiring_numeral(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_545,axiom,
    semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ozero__less__one_546,axiom,
    zero_less_one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring_547,axiom,
    comm_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Nat_Osemiring__char__0_548,axiom,
    semiring_char_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ozero__neq__one_549,axiom,
    zero_neq_one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Opreorder_550,axiom,
    preorder(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Olinorder_551,axiom,
    linorder(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Omonoid__mult_552,axiom,
    monoid_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_553,axiom,
    monoid_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__1_554,axiom,
    semiring_1(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__0_555,axiom,
    semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Omult__zero_556,axiom,
    mult_zero(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Oorder_557,axiom,
    order(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring_558,axiom,
    semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Oord_559,axiom,
    ord(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Otimes_560,axiom,
    times(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ominus_561,axiom,
    minus(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Power_Opower_562,axiom,
    power(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Num_Onumeral_563,axiom,
    numeral(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ozero_564,axiom,
    zero(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oone_565,axiom,
    one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Odvd_566,axiom,
    dvd(code_natural) ).

% Helper facts (6)
tff(help_fAll_1_1_U,axiom,
    ! [A: $tType,P7: fun(A,$o),X2: A] :
      ( ~ aa(fun(A,$o),$o,fAll(A),P7)
      | aa(A,$o,P7,X2) ) ).

tff(help_fNot_2_1_U,axiom,
    ! [P7: $o] :
      ( (P7)
      | aa($o,$o,fNot,P7) ) ).

tff(help_fNot_1_1_U,axiom,
    ! [P7: $o] :
      ( ~ aa($o,$o,fNot,P7)
      | ~ (P7) ) ).

tff(help_fequal_2_1_T,axiom,
    ! [A: $tType,X2: A,Y: A] :
      ( ( X2 != Y )
      | aa(A,$o,aa(A,fun(A,$o),fequal(A),X2),Y) ) ).

tff(help_fequal_1_1_T,axiom,
    ! [A: $tType,X2: A,Y: A] :
      ( ~ aa(A,$o,aa(A,fun(A,$o),fequal(A),X2),Y)
      | ( X2 = Y ) ) ).

tff(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P7: fun(A,$o)] :
      ( aa(A,$o,P7,fChoice(A,P7))
      = ( ? [X7: A] : aa(A,$o,P7,X7) ) ) ).

% Free types (2)
tff(tfree_0,hypothesis,
    heap(b) ).

tff(tfree_1,hypothesis,
    linorder(c) ).

% Conjectures (4)
tff(conj_0,hypothesis,
    entails(p,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),p2),top_top(assn))) ).

tff(conj_1,hypothesis,
    ! [X4: a] : entails(q(X4),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),q2(X4)),top_top(assn))) ).

tff(conj_2,hypothesis,
    hoare_hoare_triple(a,p2,c2,aTP_Lamp_a(a,assn)) ).

tff(conj_3,conjecture,
    entails(p,p_0_ATP) ).

%------------------------------------------------------------------------------
